// AUTOGENERATED FILE. DO NOT MODIFY.

#include <stdlib.h>
#include <stdint.h>

#include "unpack16.h"



static void unpack_1_16bit_signed_0off(const uint8_t * input, double * output, void *closure) {
	// Unpack 1 values into output
	// Values are 16-bit signed
	// Skip 0 bits, read 16 bits of data.
	// Input must be at least 2 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 0 to 15
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)input[1] << 16);
	output[0] = (double)(value >> 16);
}

static void unpack_1_16bit_unsigned_0off(const uint8_t * input, double * output, void *closure) {
	// Unpack 1 values into output
	// Values are 16-bit unsigned
	// Skip 0 bits, read 16 bits of data.
	// Input must be at least 2 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 0 to 15
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)input[1] << 16);
	output[0] = (double)(value >> 16);
}

static void unpack_1_16bit_signed_1off(const uint8_t * input, double * output, void *closure) {
	// Unpack 1 values into output
	// Values are 16-bit signed
	// Skip 1 bits, read 16 bits of data.
	// Input must be at least 3 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 1 to 16
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)input[1] << 17) |
			((uint32_t)(input[2] & 0x80) << 9);
	output[0] = (double)(value >> 16);
}

static void unpack_1_16bit_unsigned_1off(const uint8_t * input, double * output, void *closure) {
	// Unpack 1 values into output
	// Values are 16-bit unsigned
	// Skip 1 bits, read 16 bits of data.
	// Input must be at least 3 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 1 to 16
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)input[1] << 17) |
			((uint32_t)(input[2] & 0x80) << 9);
	output[0] = (double)(value >> 16);
}

static void unpack_1_16bit_signed_2off(const uint8_t * input, double * output, void *closure) {
	// Unpack 1 values into output
	// Values are 16-bit signed
	// Skip 2 bits, read 16 bits of data.
	// Input must be at least 3 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 2 to 17
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)input[1] << 18) |
			((uint32_t)(input[2] & 0xc0) << 10);
	output[0] = (double)(value >> 16);
}

static void unpack_1_16bit_unsigned_2off(const uint8_t * input, double * output, void *closure) {
	// Unpack 1 values into output
	// Values are 16-bit unsigned
	// Skip 2 bits, read 16 bits of data.
	// Input must be at least 3 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 2 to 17
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)input[1] << 18) |
			((uint32_t)(input[2] & 0xc0) << 10);
	output[0] = (double)(value >> 16);
}

static void unpack_1_16bit_signed_3off(const uint8_t * input, double * output, void *closure) {
	// Unpack 1 values into output
	// Values are 16-bit signed
	// Skip 3 bits, read 16 bits of data.
	// Input must be at least 3 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 3 to 18
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)input[1] << 19) |
			((uint32_t)(input[2] & 0xe0) << 11);
	output[0] = (double)(value >> 16);
}

static void unpack_1_16bit_unsigned_3off(const uint8_t * input, double * output, void *closure) {
	// Unpack 1 values into output
	// Values are 16-bit unsigned
	// Skip 3 bits, read 16 bits of data.
	// Input must be at least 3 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 3 to 18
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)input[1] << 19) |
			((uint32_t)(input[2] & 0xe0) << 11);
	output[0] = (double)(value >> 16);
}

static void unpack_1_16bit_signed_4off(const uint8_t * input, double * output, void *closure) {
	// Unpack 1 values into output
	// Values are 16-bit signed
	// Skip 4 bits, read 16 bits of data.
	// Input must be at least 3 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 4 to 19
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20) |
			((uint32_t)(input[2] & 0xf0) << 12);
	output[0] = (double)(value >> 16);
}

static void unpack_1_16bit_unsigned_4off(const uint8_t * input, double * output, void *closure) {
	// Unpack 1 values into output
	// Values are 16-bit unsigned
	// Skip 4 bits, read 16 bits of data.
	// Input must be at least 3 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 4 to 19
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20) |
			((uint32_t)(input[2] & 0xf0) << 12);
	output[0] = (double)(value >> 16);
}

static void unpack_1_16bit_signed_5off(const uint8_t * input, double * output, void *closure) {
	// Unpack 1 values into output
	// Values are 16-bit signed
	// Skip 5 bits, read 16 bits of data.
	// Input must be at least 3 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 5 to 20
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)(input[2] & 0xf8) << 13);
	output[0] = (double)(value >> 16);
}

static void unpack_1_16bit_unsigned_5off(const uint8_t * input, double * output, void *closure) {
	// Unpack 1 values into output
	// Values are 16-bit unsigned
	// Skip 5 bits, read 16 bits of data.
	// Input must be at least 3 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 5 to 20
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)(input[2] & 0xf8) << 13);
	output[0] = (double)(value >> 16);
}

static void unpack_1_16bit_signed_6off(const uint8_t * input, double * output, void *closure) {
	// Unpack 1 values into output
	// Values are 16-bit signed
	// Skip 6 bits, read 16 bits of data.
	// Input must be at least 3 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 6 to 21
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)(input[2] & 0xfc) << 14);
	output[0] = (double)(value >> 16);
}

static void unpack_1_16bit_unsigned_6off(const uint8_t * input, double * output, void *closure) {
	// Unpack 1 values into output
	// Values are 16-bit unsigned
	// Skip 6 bits, read 16 bits of data.
	// Input must be at least 3 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 6 to 21
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)(input[2] & 0xfc) << 14);
	output[0] = (double)(value >> 16);
}

static void unpack_1_16bit_signed_7off(const uint8_t * input, double * output, void *closure) {
	// Unpack 1 values into output
	// Values are 16-bit signed
	// Skip 7 bits, read 16 bits of data.
	// Input must be at least 3 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 7 to 22
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)(input[2] & 0xfe) << 15);
	output[0] = (double)(value >> 16);
}

static void unpack_1_16bit_unsigned_7off(const uint8_t * input, double * output, void *closure) {
	// Unpack 1 values into output
	// Values are 16-bit unsigned
	// Skip 7 bits, read 16 bits of data.
	// Input must be at least 3 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 7 to 22
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)(input[2] & 0xfe) << 15);
	output[0] = (double)(value >> 16);
}

static void unpack_2_16bit_signed_0off(const uint8_t * input, double * output, void *closure) {
	// Unpack 2 values into output
	// Values are 16-bit signed
	// Skip 0 bits, read 32 bits of data.
	// Input must be at least 4 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 0 to 15
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)input[1] << 16);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 16 to 31
	value = ((uint32_t)input[2] << 24) |
			((uint32_t)input[3] << 16);
	output[1] = (double)(value >> 16);
}

static void unpack_2_16bit_unsigned_0off(const uint8_t * input, double * output, void *closure) {
	// Unpack 2 values into output
	// Values are 16-bit unsigned
	// Skip 0 bits, read 32 bits of data.
	// Input must be at least 4 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 0 to 15
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)input[1] << 16);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 16 to 31
	value = ((uint32_t)input[2] << 24) |
			((uint32_t)input[3] << 16);
	output[1] = (double)(value >> 16);
}

static void unpack_2_16bit_signed_1off(const uint8_t * input, double * output, void *closure) {
	// Unpack 2 values into output
	// Values are 16-bit signed
	// Skip 1 bits, read 32 bits of data.
	// Input must be at least 5 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 1 to 16
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)input[1] << 17) |
			((uint32_t)(input[2] & 0x80) << 9);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 17 to 32
	value = ((uint32_t)(input[2] & 0x7f) << 25) |
			((uint32_t)input[3] << 17) |
			((uint32_t)(input[4] & 0x80) << 9);
	output[1] = (double)(value >> 16);
}

static void unpack_2_16bit_unsigned_1off(const uint8_t * input, double * output, void *closure) {
	// Unpack 2 values into output
	// Values are 16-bit unsigned
	// Skip 1 bits, read 32 bits of data.
	// Input must be at least 5 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 1 to 16
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)input[1] << 17) |
			((uint32_t)(input[2] & 0x80) << 9);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 17 to 32
	value = ((uint32_t)(input[2] & 0x7f) << 25) |
			((uint32_t)input[3] << 17) |
			((uint32_t)(input[4] & 0x80) << 9);
	output[1] = (double)(value >> 16);
}

static void unpack_2_16bit_signed_2off(const uint8_t * input, double * output, void *closure) {
	// Unpack 2 values into output
	// Values are 16-bit signed
	// Skip 2 bits, read 32 bits of data.
	// Input must be at least 5 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 2 to 17
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)input[1] << 18) |
			((uint32_t)(input[2] & 0xc0) << 10);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 18 to 33
	value = ((uint32_t)(input[2] & 0x3f) << 26) |
			((uint32_t)input[3] << 18) |
			((uint32_t)(input[4] & 0xc0) << 10);
	output[1] = (double)(value >> 16);
}

static void unpack_2_16bit_unsigned_2off(const uint8_t * input, double * output, void *closure) {
	// Unpack 2 values into output
	// Values are 16-bit unsigned
	// Skip 2 bits, read 32 bits of data.
	// Input must be at least 5 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 2 to 17
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)input[1] << 18) |
			((uint32_t)(input[2] & 0xc0) << 10);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 18 to 33
	value = ((uint32_t)(input[2] & 0x3f) << 26) |
			((uint32_t)input[3] << 18) |
			((uint32_t)(input[4] & 0xc0) << 10);
	output[1] = (double)(value >> 16);
}

static void unpack_2_16bit_signed_3off(const uint8_t * input, double * output, void *closure) {
	// Unpack 2 values into output
	// Values are 16-bit signed
	// Skip 3 bits, read 32 bits of data.
	// Input must be at least 5 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 3 to 18
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)input[1] << 19) |
			((uint32_t)(input[2] & 0xe0) << 11);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 19 to 34
	value = ((uint32_t)(input[2] & 0x1f) << 27) |
			((uint32_t)input[3] << 19) |
			((uint32_t)(input[4] & 0xe0) << 11);
	output[1] = (double)(value >> 16);
}

static void unpack_2_16bit_unsigned_3off(const uint8_t * input, double * output, void *closure) {
	// Unpack 2 values into output
	// Values are 16-bit unsigned
	// Skip 3 bits, read 32 bits of data.
	// Input must be at least 5 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 3 to 18
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)input[1] << 19) |
			((uint32_t)(input[2] & 0xe0) << 11);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 19 to 34
	value = ((uint32_t)(input[2] & 0x1f) << 27) |
			((uint32_t)input[3] << 19) |
			((uint32_t)(input[4] & 0xe0) << 11);
	output[1] = (double)(value >> 16);
}

static void unpack_2_16bit_signed_4off(const uint8_t * input, double * output, void *closure) {
	// Unpack 2 values into output
	// Values are 16-bit signed
	// Skip 4 bits, read 32 bits of data.
	// Input must be at least 5 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 4 to 19
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20) |
			((uint32_t)(input[2] & 0xf0) << 12);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 20 to 35
	value = ((uint32_t)(input[2] & 0x0f) << 28) |
			((uint32_t)input[3] << 20) |
			((uint32_t)(input[4] & 0xf0) << 12);
	output[1] = (double)(value >> 16);
}

static void unpack_2_16bit_unsigned_4off(const uint8_t * input, double * output, void *closure) {
	// Unpack 2 values into output
	// Values are 16-bit unsigned
	// Skip 4 bits, read 32 bits of data.
	// Input must be at least 5 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 4 to 19
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20) |
			((uint32_t)(input[2] & 0xf0) << 12);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 20 to 35
	value = ((uint32_t)(input[2] & 0x0f) << 28) |
			((uint32_t)input[3] << 20) |
			((uint32_t)(input[4] & 0xf0) << 12);
	output[1] = (double)(value >> 16);
}

static void unpack_2_16bit_signed_5off(const uint8_t * input, double * output, void *closure) {
	// Unpack 2 values into output
	// Values are 16-bit signed
	// Skip 5 bits, read 32 bits of data.
	// Input must be at least 5 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 5 to 20
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)(input[2] & 0xf8) << 13);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 21 to 36
	value = ((uint32_t)(input[2] & 0x07) << 29) |
			((uint32_t)input[3] << 21) |
			((uint32_t)(input[4] & 0xf8) << 13);
	output[1] = (double)(value >> 16);
}

static void unpack_2_16bit_unsigned_5off(const uint8_t * input, double * output, void *closure) {
	// Unpack 2 values into output
	// Values are 16-bit unsigned
	// Skip 5 bits, read 32 bits of data.
	// Input must be at least 5 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 5 to 20
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)(input[2] & 0xf8) << 13);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 21 to 36
	value = ((uint32_t)(input[2] & 0x07) << 29) |
			((uint32_t)input[3] << 21) |
			((uint32_t)(input[4] & 0xf8) << 13);
	output[1] = (double)(value >> 16);
}

static void unpack_2_16bit_signed_6off(const uint8_t * input, double * output, void *closure) {
	// Unpack 2 values into output
	// Values are 16-bit signed
	// Skip 6 bits, read 32 bits of data.
	// Input must be at least 5 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 6 to 21
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)(input[2] & 0xfc) << 14);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 22 to 37
	value = ((uint32_t)(input[2] & 0x03) << 30) |
			((uint32_t)input[3] << 22) |
			((uint32_t)(input[4] & 0xfc) << 14);
	output[1] = (double)(value >> 16);
}

static void unpack_2_16bit_unsigned_6off(const uint8_t * input, double * output, void *closure) {
	// Unpack 2 values into output
	// Values are 16-bit unsigned
	// Skip 6 bits, read 32 bits of data.
	// Input must be at least 5 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 6 to 21
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)(input[2] & 0xfc) << 14);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 22 to 37
	value = ((uint32_t)(input[2] & 0x03) << 30) |
			((uint32_t)input[3] << 22) |
			((uint32_t)(input[4] & 0xfc) << 14);
	output[1] = (double)(value >> 16);
}

static void unpack_2_16bit_signed_7off(const uint8_t * input, double * output, void *closure) {
	// Unpack 2 values into output
	// Values are 16-bit signed
	// Skip 7 bits, read 32 bits of data.
	// Input must be at least 5 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 7 to 22
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)(input[2] & 0xfe) << 15);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 23 to 38
	value = ((uint32_t)(input[2] & 0x01) << 31) |
			((uint32_t)input[3] << 23) |
			((uint32_t)(input[4] & 0xfe) << 15);
	output[1] = (double)(value >> 16);
}

static void unpack_2_16bit_unsigned_7off(const uint8_t * input, double * output, void *closure) {
	// Unpack 2 values into output
	// Values are 16-bit unsigned
	// Skip 7 bits, read 32 bits of data.
	// Input must be at least 5 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 7 to 22
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)(input[2] & 0xfe) << 15);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 23 to 38
	value = ((uint32_t)(input[2] & 0x01) << 31) |
			((uint32_t)input[3] << 23) |
			((uint32_t)(input[4] & 0xfe) << 15);
	output[1] = (double)(value >> 16);
}

static void unpack_3_16bit_signed_0off(const uint8_t * input, double * output, void *closure) {
	// Unpack 3 values into output
	// Values are 16-bit signed
	// Skip 0 bits, read 48 bits of data.
	// Input must be at least 6 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 0 to 15
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)input[1] << 16);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 16 to 31
	value = ((uint32_t)input[2] << 24) |
			((uint32_t)input[3] << 16);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 32 to 47
	value = ((uint32_t)input[4] << 24) |
			((uint32_t)input[5] << 16);
	output[2] = (double)(value >> 16);
}

static void unpack_3_16bit_unsigned_0off(const uint8_t * input, double * output, void *closure) {
	// Unpack 3 values into output
	// Values are 16-bit unsigned
	// Skip 0 bits, read 48 bits of data.
	// Input must be at least 6 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 0 to 15
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)input[1] << 16);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 16 to 31
	value = ((uint32_t)input[2] << 24) |
			((uint32_t)input[3] << 16);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 32 to 47
	value = ((uint32_t)input[4] << 24) |
			((uint32_t)input[5] << 16);
	output[2] = (double)(value >> 16);
}

static void unpack_3_16bit_signed_1off(const uint8_t * input, double * output, void *closure) {
	// Unpack 3 values into output
	// Values are 16-bit signed
	// Skip 1 bits, read 48 bits of data.
	// Input must be at least 7 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 1 to 16
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)input[1] << 17) |
			((uint32_t)(input[2] & 0x80) << 9);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 17 to 32
	value = ((uint32_t)(input[2] & 0x7f) << 25) |
			((uint32_t)input[3] << 17) |
			((uint32_t)(input[4] & 0x80) << 9);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 33 to 48
	value = ((uint32_t)(input[4] & 0x7f) << 25) |
			((uint32_t)input[5] << 17) |
			((uint32_t)(input[6] & 0x80) << 9);
	output[2] = (double)(value >> 16);
}

static void unpack_3_16bit_unsigned_1off(const uint8_t * input, double * output, void *closure) {
	// Unpack 3 values into output
	// Values are 16-bit unsigned
	// Skip 1 bits, read 48 bits of data.
	// Input must be at least 7 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 1 to 16
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)input[1] << 17) |
			((uint32_t)(input[2] & 0x80) << 9);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 17 to 32
	value = ((uint32_t)(input[2] & 0x7f) << 25) |
			((uint32_t)input[3] << 17) |
			((uint32_t)(input[4] & 0x80) << 9);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 33 to 48
	value = ((uint32_t)(input[4] & 0x7f) << 25) |
			((uint32_t)input[5] << 17) |
			((uint32_t)(input[6] & 0x80) << 9);
	output[2] = (double)(value >> 16);
}

static void unpack_3_16bit_signed_2off(const uint8_t * input, double * output, void *closure) {
	// Unpack 3 values into output
	// Values are 16-bit signed
	// Skip 2 bits, read 48 bits of data.
	// Input must be at least 7 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 2 to 17
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)input[1] << 18) |
			((uint32_t)(input[2] & 0xc0) << 10);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 18 to 33
	value = ((uint32_t)(input[2] & 0x3f) << 26) |
			((uint32_t)input[3] << 18) |
			((uint32_t)(input[4] & 0xc0) << 10);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 34 to 49
	value = ((uint32_t)(input[4] & 0x3f) << 26) |
			((uint32_t)input[5] << 18) |
			((uint32_t)(input[6] & 0xc0) << 10);
	output[2] = (double)(value >> 16);
}

static void unpack_3_16bit_unsigned_2off(const uint8_t * input, double * output, void *closure) {
	// Unpack 3 values into output
	// Values are 16-bit unsigned
	// Skip 2 bits, read 48 bits of data.
	// Input must be at least 7 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 2 to 17
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)input[1] << 18) |
			((uint32_t)(input[2] & 0xc0) << 10);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 18 to 33
	value = ((uint32_t)(input[2] & 0x3f) << 26) |
			((uint32_t)input[3] << 18) |
			((uint32_t)(input[4] & 0xc0) << 10);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 34 to 49
	value = ((uint32_t)(input[4] & 0x3f) << 26) |
			((uint32_t)input[5] << 18) |
			((uint32_t)(input[6] & 0xc0) << 10);
	output[2] = (double)(value >> 16);
}

static void unpack_3_16bit_signed_3off(const uint8_t * input, double * output, void *closure) {
	// Unpack 3 values into output
	// Values are 16-bit signed
	// Skip 3 bits, read 48 bits of data.
	// Input must be at least 7 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 3 to 18
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)input[1] << 19) |
			((uint32_t)(input[2] & 0xe0) << 11);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 19 to 34
	value = ((uint32_t)(input[2] & 0x1f) << 27) |
			((uint32_t)input[3] << 19) |
			((uint32_t)(input[4] & 0xe0) << 11);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 35 to 50
	value = ((uint32_t)(input[4] & 0x1f) << 27) |
			((uint32_t)input[5] << 19) |
			((uint32_t)(input[6] & 0xe0) << 11);
	output[2] = (double)(value >> 16);
}

static void unpack_3_16bit_unsigned_3off(const uint8_t * input, double * output, void *closure) {
	// Unpack 3 values into output
	// Values are 16-bit unsigned
	// Skip 3 bits, read 48 bits of data.
	// Input must be at least 7 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 3 to 18
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)input[1] << 19) |
			((uint32_t)(input[2] & 0xe0) << 11);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 19 to 34
	value = ((uint32_t)(input[2] & 0x1f) << 27) |
			((uint32_t)input[3] << 19) |
			((uint32_t)(input[4] & 0xe0) << 11);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 35 to 50
	value = ((uint32_t)(input[4] & 0x1f) << 27) |
			((uint32_t)input[5] << 19) |
			((uint32_t)(input[6] & 0xe0) << 11);
	output[2] = (double)(value >> 16);
}

static void unpack_3_16bit_signed_4off(const uint8_t * input, double * output, void *closure) {
	// Unpack 3 values into output
	// Values are 16-bit signed
	// Skip 4 bits, read 48 bits of data.
	// Input must be at least 7 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 4 to 19
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20) |
			((uint32_t)(input[2] & 0xf0) << 12);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 20 to 35
	value = ((uint32_t)(input[2] & 0x0f) << 28) |
			((uint32_t)input[3] << 20) |
			((uint32_t)(input[4] & 0xf0) << 12);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 36 to 51
	value = ((uint32_t)(input[4] & 0x0f) << 28) |
			((uint32_t)input[5] << 20) |
			((uint32_t)(input[6] & 0xf0) << 12);
	output[2] = (double)(value >> 16);
}

static void unpack_3_16bit_unsigned_4off(const uint8_t * input, double * output, void *closure) {
	// Unpack 3 values into output
	// Values are 16-bit unsigned
	// Skip 4 bits, read 48 bits of data.
	// Input must be at least 7 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 4 to 19
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20) |
			((uint32_t)(input[2] & 0xf0) << 12);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 20 to 35
	value = ((uint32_t)(input[2] & 0x0f) << 28) |
			((uint32_t)input[3] << 20) |
			((uint32_t)(input[4] & 0xf0) << 12);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 36 to 51
	value = ((uint32_t)(input[4] & 0x0f) << 28) |
			((uint32_t)input[5] << 20) |
			((uint32_t)(input[6] & 0xf0) << 12);
	output[2] = (double)(value >> 16);
}

static void unpack_3_16bit_signed_5off(const uint8_t * input, double * output, void *closure) {
	// Unpack 3 values into output
	// Values are 16-bit signed
	// Skip 5 bits, read 48 bits of data.
	// Input must be at least 7 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 5 to 20
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)(input[2] & 0xf8) << 13);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 21 to 36
	value = ((uint32_t)(input[2] & 0x07) << 29) |
			((uint32_t)input[3] << 21) |
			((uint32_t)(input[4] & 0xf8) << 13);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 37 to 52
	value = ((uint32_t)(input[4] & 0x07) << 29) |
			((uint32_t)input[5] << 21) |
			((uint32_t)(input[6] & 0xf8) << 13);
	output[2] = (double)(value >> 16);
}

static void unpack_3_16bit_unsigned_5off(const uint8_t * input, double * output, void *closure) {
	// Unpack 3 values into output
	// Values are 16-bit unsigned
	// Skip 5 bits, read 48 bits of data.
	// Input must be at least 7 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 5 to 20
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)(input[2] & 0xf8) << 13);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 21 to 36
	value = ((uint32_t)(input[2] & 0x07) << 29) |
			((uint32_t)input[3] << 21) |
			((uint32_t)(input[4] & 0xf8) << 13);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 37 to 52
	value = ((uint32_t)(input[4] & 0x07) << 29) |
			((uint32_t)input[5] << 21) |
			((uint32_t)(input[6] & 0xf8) << 13);
	output[2] = (double)(value >> 16);
}

static void unpack_3_16bit_signed_6off(const uint8_t * input, double * output, void *closure) {
	// Unpack 3 values into output
	// Values are 16-bit signed
	// Skip 6 bits, read 48 bits of data.
	// Input must be at least 7 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 6 to 21
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)(input[2] & 0xfc) << 14);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 22 to 37
	value = ((uint32_t)(input[2] & 0x03) << 30) |
			((uint32_t)input[3] << 22) |
			((uint32_t)(input[4] & 0xfc) << 14);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 38 to 53
	value = ((uint32_t)(input[4] & 0x03) << 30) |
			((uint32_t)input[5] << 22) |
			((uint32_t)(input[6] & 0xfc) << 14);
	output[2] = (double)(value >> 16);
}

static void unpack_3_16bit_unsigned_6off(const uint8_t * input, double * output, void *closure) {
	// Unpack 3 values into output
	// Values are 16-bit unsigned
	// Skip 6 bits, read 48 bits of data.
	// Input must be at least 7 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 6 to 21
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)(input[2] & 0xfc) << 14);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 22 to 37
	value = ((uint32_t)(input[2] & 0x03) << 30) |
			((uint32_t)input[3] << 22) |
			((uint32_t)(input[4] & 0xfc) << 14);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 38 to 53
	value = ((uint32_t)(input[4] & 0x03) << 30) |
			((uint32_t)input[5] << 22) |
			((uint32_t)(input[6] & 0xfc) << 14);
	output[2] = (double)(value >> 16);
}

static void unpack_3_16bit_signed_7off(const uint8_t * input, double * output, void *closure) {
	// Unpack 3 values into output
	// Values are 16-bit signed
	// Skip 7 bits, read 48 bits of data.
	// Input must be at least 7 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 7 to 22
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)(input[2] & 0xfe) << 15);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 23 to 38
	value = ((uint32_t)(input[2] & 0x01) << 31) |
			((uint32_t)input[3] << 23) |
			((uint32_t)(input[4] & 0xfe) << 15);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 39 to 54
	value = ((uint32_t)(input[4] & 0x01) << 31) |
			((uint32_t)input[5] << 23) |
			((uint32_t)(input[6] & 0xfe) << 15);
	output[2] = (double)(value >> 16);
}

static void unpack_3_16bit_unsigned_7off(const uint8_t * input, double * output, void *closure) {
	// Unpack 3 values into output
	// Values are 16-bit unsigned
	// Skip 7 bits, read 48 bits of data.
	// Input must be at least 7 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 7 to 22
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)(input[2] & 0xfe) << 15);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 23 to 38
	value = ((uint32_t)(input[2] & 0x01) << 31) |
			((uint32_t)input[3] << 23) |
			((uint32_t)(input[4] & 0xfe) << 15);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 39 to 54
	value = ((uint32_t)(input[4] & 0x01) << 31) |
			((uint32_t)input[5] << 23) |
			((uint32_t)(input[6] & 0xfe) << 15);
	output[2] = (double)(value >> 16);
}

static void unpack_4_16bit_signed_0off(const uint8_t * input, double * output, void *closure) {
	// Unpack 4 values into output
	// Values are 16-bit signed
	// Skip 0 bits, read 64 bits of data.
	// Input must be at least 8 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 0 to 15
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)input[1] << 16);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 16 to 31
	value = ((uint32_t)input[2] << 24) |
			((uint32_t)input[3] << 16);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 32 to 47
	value = ((uint32_t)input[4] << 24) |
			((uint32_t)input[5] << 16);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 48 to 63
	value = ((uint32_t)input[6] << 24) |
			((uint32_t)input[7] << 16);
	output[3] = (double)(value >> 16);
}

static void unpack_4_16bit_unsigned_0off(const uint8_t * input, double * output, void *closure) {
	// Unpack 4 values into output
	// Values are 16-bit unsigned
	// Skip 0 bits, read 64 bits of data.
	// Input must be at least 8 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 0 to 15
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)input[1] << 16);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 16 to 31
	value = ((uint32_t)input[2] << 24) |
			((uint32_t)input[3] << 16);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 32 to 47
	value = ((uint32_t)input[4] << 24) |
			((uint32_t)input[5] << 16);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 48 to 63
	value = ((uint32_t)input[6] << 24) |
			((uint32_t)input[7] << 16);
	output[3] = (double)(value >> 16);
}

static void unpack_4_16bit_signed_1off(const uint8_t * input, double * output, void *closure) {
	// Unpack 4 values into output
	// Values are 16-bit signed
	// Skip 1 bits, read 64 bits of data.
	// Input must be at least 9 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 1 to 16
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)input[1] << 17) |
			((uint32_t)(input[2] & 0x80) << 9);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 17 to 32
	value = ((uint32_t)(input[2] & 0x7f) << 25) |
			((uint32_t)input[3] << 17) |
			((uint32_t)(input[4] & 0x80) << 9);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 33 to 48
	value = ((uint32_t)(input[4] & 0x7f) << 25) |
			((uint32_t)input[5] << 17) |
			((uint32_t)(input[6] & 0x80) << 9);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 49 to 64
	value = ((uint32_t)(input[6] & 0x7f) << 25) |
			((uint32_t)input[7] << 17) |
			((uint32_t)(input[8] & 0x80) << 9);
	output[3] = (double)(value >> 16);
}

static void unpack_4_16bit_unsigned_1off(const uint8_t * input, double * output, void *closure) {
	// Unpack 4 values into output
	// Values are 16-bit unsigned
	// Skip 1 bits, read 64 bits of data.
	// Input must be at least 9 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 1 to 16
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)input[1] << 17) |
			((uint32_t)(input[2] & 0x80) << 9);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 17 to 32
	value = ((uint32_t)(input[2] & 0x7f) << 25) |
			((uint32_t)input[3] << 17) |
			((uint32_t)(input[4] & 0x80) << 9);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 33 to 48
	value = ((uint32_t)(input[4] & 0x7f) << 25) |
			((uint32_t)input[5] << 17) |
			((uint32_t)(input[6] & 0x80) << 9);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 49 to 64
	value = ((uint32_t)(input[6] & 0x7f) << 25) |
			((uint32_t)input[7] << 17) |
			((uint32_t)(input[8] & 0x80) << 9);
	output[3] = (double)(value >> 16);
}

static void unpack_4_16bit_signed_2off(const uint8_t * input, double * output, void *closure) {
	// Unpack 4 values into output
	// Values are 16-bit signed
	// Skip 2 bits, read 64 bits of data.
	// Input must be at least 9 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 2 to 17
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)input[1] << 18) |
			((uint32_t)(input[2] & 0xc0) << 10);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 18 to 33
	value = ((uint32_t)(input[2] & 0x3f) << 26) |
			((uint32_t)input[3] << 18) |
			((uint32_t)(input[4] & 0xc0) << 10);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 34 to 49
	value = ((uint32_t)(input[4] & 0x3f) << 26) |
			((uint32_t)input[5] << 18) |
			((uint32_t)(input[6] & 0xc0) << 10);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 50 to 65
	value = ((uint32_t)(input[6] & 0x3f) << 26) |
			((uint32_t)input[7] << 18) |
			((uint32_t)(input[8] & 0xc0) << 10);
	output[3] = (double)(value >> 16);
}

static void unpack_4_16bit_unsigned_2off(const uint8_t * input, double * output, void *closure) {
	// Unpack 4 values into output
	// Values are 16-bit unsigned
	// Skip 2 bits, read 64 bits of data.
	// Input must be at least 9 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 2 to 17
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)input[1] << 18) |
			((uint32_t)(input[2] & 0xc0) << 10);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 18 to 33
	value = ((uint32_t)(input[2] & 0x3f) << 26) |
			((uint32_t)input[3] << 18) |
			((uint32_t)(input[4] & 0xc0) << 10);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 34 to 49
	value = ((uint32_t)(input[4] & 0x3f) << 26) |
			((uint32_t)input[5] << 18) |
			((uint32_t)(input[6] & 0xc0) << 10);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 50 to 65
	value = ((uint32_t)(input[6] & 0x3f) << 26) |
			((uint32_t)input[7] << 18) |
			((uint32_t)(input[8] & 0xc0) << 10);
	output[3] = (double)(value >> 16);
}

static void unpack_4_16bit_signed_3off(const uint8_t * input, double * output, void *closure) {
	// Unpack 4 values into output
	// Values are 16-bit signed
	// Skip 3 bits, read 64 bits of data.
	// Input must be at least 9 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 3 to 18
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)input[1] << 19) |
			((uint32_t)(input[2] & 0xe0) << 11);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 19 to 34
	value = ((uint32_t)(input[2] & 0x1f) << 27) |
			((uint32_t)input[3] << 19) |
			((uint32_t)(input[4] & 0xe0) << 11);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 35 to 50
	value = ((uint32_t)(input[4] & 0x1f) << 27) |
			((uint32_t)input[5] << 19) |
			((uint32_t)(input[6] & 0xe0) << 11);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 51 to 66
	value = ((uint32_t)(input[6] & 0x1f) << 27) |
			((uint32_t)input[7] << 19) |
			((uint32_t)(input[8] & 0xe0) << 11);
	output[3] = (double)(value >> 16);
}

static void unpack_4_16bit_unsigned_3off(const uint8_t * input, double * output, void *closure) {
	// Unpack 4 values into output
	// Values are 16-bit unsigned
	// Skip 3 bits, read 64 bits of data.
	// Input must be at least 9 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 3 to 18
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)input[1] << 19) |
			((uint32_t)(input[2] & 0xe0) << 11);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 19 to 34
	value = ((uint32_t)(input[2] & 0x1f) << 27) |
			((uint32_t)input[3] << 19) |
			((uint32_t)(input[4] & 0xe0) << 11);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 35 to 50
	value = ((uint32_t)(input[4] & 0x1f) << 27) |
			((uint32_t)input[5] << 19) |
			((uint32_t)(input[6] & 0xe0) << 11);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 51 to 66
	value = ((uint32_t)(input[6] & 0x1f) << 27) |
			((uint32_t)input[7] << 19) |
			((uint32_t)(input[8] & 0xe0) << 11);
	output[3] = (double)(value >> 16);
}

static void unpack_4_16bit_signed_4off(const uint8_t * input, double * output, void *closure) {
	// Unpack 4 values into output
	// Values are 16-bit signed
	// Skip 4 bits, read 64 bits of data.
	// Input must be at least 9 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 4 to 19
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20) |
			((uint32_t)(input[2] & 0xf0) << 12);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 20 to 35
	value = ((uint32_t)(input[2] & 0x0f) << 28) |
			((uint32_t)input[3] << 20) |
			((uint32_t)(input[4] & 0xf0) << 12);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 36 to 51
	value = ((uint32_t)(input[4] & 0x0f) << 28) |
			((uint32_t)input[5] << 20) |
			((uint32_t)(input[6] & 0xf0) << 12);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 52 to 67
	value = ((uint32_t)(input[6] & 0x0f) << 28) |
			((uint32_t)input[7] << 20) |
			((uint32_t)(input[8] & 0xf0) << 12);
	output[3] = (double)(value >> 16);
}

static void unpack_4_16bit_unsigned_4off(const uint8_t * input, double * output, void *closure) {
	// Unpack 4 values into output
	// Values are 16-bit unsigned
	// Skip 4 bits, read 64 bits of data.
	// Input must be at least 9 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 4 to 19
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20) |
			((uint32_t)(input[2] & 0xf0) << 12);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 20 to 35
	value = ((uint32_t)(input[2] & 0x0f) << 28) |
			((uint32_t)input[3] << 20) |
			((uint32_t)(input[4] & 0xf0) << 12);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 36 to 51
	value = ((uint32_t)(input[4] & 0x0f) << 28) |
			((uint32_t)input[5] << 20) |
			((uint32_t)(input[6] & 0xf0) << 12);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 52 to 67
	value = ((uint32_t)(input[6] & 0x0f) << 28) |
			((uint32_t)input[7] << 20) |
			((uint32_t)(input[8] & 0xf0) << 12);
	output[3] = (double)(value >> 16);
}

static void unpack_4_16bit_signed_5off(const uint8_t * input, double * output, void *closure) {
	// Unpack 4 values into output
	// Values are 16-bit signed
	// Skip 5 bits, read 64 bits of data.
	// Input must be at least 9 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 5 to 20
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)(input[2] & 0xf8) << 13);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 21 to 36
	value = ((uint32_t)(input[2] & 0x07) << 29) |
			((uint32_t)input[3] << 21) |
			((uint32_t)(input[4] & 0xf8) << 13);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 37 to 52
	value = ((uint32_t)(input[4] & 0x07) << 29) |
			((uint32_t)input[5] << 21) |
			((uint32_t)(input[6] & 0xf8) << 13);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 53 to 68
	value = ((uint32_t)(input[6] & 0x07) << 29) |
			((uint32_t)input[7] << 21) |
			((uint32_t)(input[8] & 0xf8) << 13);
	output[3] = (double)(value >> 16);
}

static void unpack_4_16bit_unsigned_5off(const uint8_t * input, double * output, void *closure) {
	// Unpack 4 values into output
	// Values are 16-bit unsigned
	// Skip 5 bits, read 64 bits of data.
	// Input must be at least 9 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 5 to 20
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)(input[2] & 0xf8) << 13);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 21 to 36
	value = ((uint32_t)(input[2] & 0x07) << 29) |
			((uint32_t)input[3] << 21) |
			((uint32_t)(input[4] & 0xf8) << 13);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 37 to 52
	value = ((uint32_t)(input[4] & 0x07) << 29) |
			((uint32_t)input[5] << 21) |
			((uint32_t)(input[6] & 0xf8) << 13);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 53 to 68
	value = ((uint32_t)(input[6] & 0x07) << 29) |
			((uint32_t)input[7] << 21) |
			((uint32_t)(input[8] & 0xf8) << 13);
	output[3] = (double)(value >> 16);
}

static void unpack_4_16bit_signed_6off(const uint8_t * input, double * output, void *closure) {
	// Unpack 4 values into output
	// Values are 16-bit signed
	// Skip 6 bits, read 64 bits of data.
	// Input must be at least 9 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 6 to 21
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)(input[2] & 0xfc) << 14);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 22 to 37
	value = ((uint32_t)(input[2] & 0x03) << 30) |
			((uint32_t)input[3] << 22) |
			((uint32_t)(input[4] & 0xfc) << 14);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 38 to 53
	value = ((uint32_t)(input[4] & 0x03) << 30) |
			((uint32_t)input[5] << 22) |
			((uint32_t)(input[6] & 0xfc) << 14);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 54 to 69
	value = ((uint32_t)(input[6] & 0x03) << 30) |
			((uint32_t)input[7] << 22) |
			((uint32_t)(input[8] & 0xfc) << 14);
	output[3] = (double)(value >> 16);
}

static void unpack_4_16bit_unsigned_6off(const uint8_t * input, double * output, void *closure) {
	// Unpack 4 values into output
	// Values are 16-bit unsigned
	// Skip 6 bits, read 64 bits of data.
	// Input must be at least 9 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 6 to 21
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)(input[2] & 0xfc) << 14);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 22 to 37
	value = ((uint32_t)(input[2] & 0x03) << 30) |
			((uint32_t)input[3] << 22) |
			((uint32_t)(input[4] & 0xfc) << 14);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 38 to 53
	value = ((uint32_t)(input[4] & 0x03) << 30) |
			((uint32_t)input[5] << 22) |
			((uint32_t)(input[6] & 0xfc) << 14);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 54 to 69
	value = ((uint32_t)(input[6] & 0x03) << 30) |
			((uint32_t)input[7] << 22) |
			((uint32_t)(input[8] & 0xfc) << 14);
	output[3] = (double)(value >> 16);
}

static void unpack_4_16bit_signed_7off(const uint8_t * input, double * output, void *closure) {
	// Unpack 4 values into output
	// Values are 16-bit signed
	// Skip 7 bits, read 64 bits of data.
	// Input must be at least 9 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 7 to 22
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)(input[2] & 0xfe) << 15);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 23 to 38
	value = ((uint32_t)(input[2] & 0x01) << 31) |
			((uint32_t)input[3] << 23) |
			((uint32_t)(input[4] & 0xfe) << 15);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 39 to 54
	value = ((uint32_t)(input[4] & 0x01) << 31) |
			((uint32_t)input[5] << 23) |
			((uint32_t)(input[6] & 0xfe) << 15);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 55 to 70
	value = ((uint32_t)(input[6] & 0x01) << 31) |
			((uint32_t)input[7] << 23) |
			((uint32_t)(input[8] & 0xfe) << 15);
	output[3] = (double)(value >> 16);
}

static void unpack_4_16bit_unsigned_7off(const uint8_t * input, double * output, void *closure) {
	// Unpack 4 values into output
	// Values are 16-bit unsigned
	// Skip 7 bits, read 64 bits of data.
	// Input must be at least 9 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 7 to 22
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)(input[2] & 0xfe) << 15);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 23 to 38
	value = ((uint32_t)(input[2] & 0x01) << 31) |
			((uint32_t)input[3] << 23) |
			((uint32_t)(input[4] & 0xfe) << 15);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 39 to 54
	value = ((uint32_t)(input[4] & 0x01) << 31) |
			((uint32_t)input[5] << 23) |
			((uint32_t)(input[6] & 0xfe) << 15);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 55 to 70
	value = ((uint32_t)(input[6] & 0x01) << 31) |
			((uint32_t)input[7] << 23) |
			((uint32_t)(input[8] & 0xfe) << 15);
	output[3] = (double)(value >> 16);
}

static void unpack_5_16bit_signed_0off(const uint8_t * input, double * output, void *closure) {
	// Unpack 5 values into output
	// Values are 16-bit signed
	// Skip 0 bits, read 80 bits of data.
	// Input must be at least 10 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 0 to 15
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)input[1] << 16);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 16 to 31
	value = ((uint32_t)input[2] << 24) |
			((uint32_t)input[3] << 16);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 32 to 47
	value = ((uint32_t)input[4] << 24) |
			((uint32_t)input[5] << 16);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 48 to 63
	value = ((uint32_t)input[6] << 24) |
			((uint32_t)input[7] << 16);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 64 to 79
	value = ((uint32_t)input[8] << 24) |
			((uint32_t)input[9] << 16);
	output[4] = (double)(value >> 16);
}

static void unpack_5_16bit_unsigned_0off(const uint8_t * input, double * output, void *closure) {
	// Unpack 5 values into output
	// Values are 16-bit unsigned
	// Skip 0 bits, read 80 bits of data.
	// Input must be at least 10 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 0 to 15
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)input[1] << 16);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 16 to 31
	value = ((uint32_t)input[2] << 24) |
			((uint32_t)input[3] << 16);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 32 to 47
	value = ((uint32_t)input[4] << 24) |
			((uint32_t)input[5] << 16);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 48 to 63
	value = ((uint32_t)input[6] << 24) |
			((uint32_t)input[7] << 16);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 64 to 79
	value = ((uint32_t)input[8] << 24) |
			((uint32_t)input[9] << 16);
	output[4] = (double)(value >> 16);
}

static void unpack_5_16bit_signed_1off(const uint8_t * input, double * output, void *closure) {
	// Unpack 5 values into output
	// Values are 16-bit signed
	// Skip 1 bits, read 80 bits of data.
	// Input must be at least 11 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 1 to 16
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)input[1] << 17) |
			((uint32_t)(input[2] & 0x80) << 9);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 17 to 32
	value = ((uint32_t)(input[2] & 0x7f) << 25) |
			((uint32_t)input[3] << 17) |
			((uint32_t)(input[4] & 0x80) << 9);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 33 to 48
	value = ((uint32_t)(input[4] & 0x7f) << 25) |
			((uint32_t)input[5] << 17) |
			((uint32_t)(input[6] & 0x80) << 9);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 49 to 64
	value = ((uint32_t)(input[6] & 0x7f) << 25) |
			((uint32_t)input[7] << 17) |
			((uint32_t)(input[8] & 0x80) << 9);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 65 to 80
	value = ((uint32_t)(input[8] & 0x7f) << 25) |
			((uint32_t)input[9] << 17) |
			((uint32_t)(input[10] & 0x80) << 9);
	output[4] = (double)(value >> 16);
}

static void unpack_5_16bit_unsigned_1off(const uint8_t * input, double * output, void *closure) {
	// Unpack 5 values into output
	// Values are 16-bit unsigned
	// Skip 1 bits, read 80 bits of data.
	// Input must be at least 11 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 1 to 16
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)input[1] << 17) |
			((uint32_t)(input[2] & 0x80) << 9);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 17 to 32
	value = ((uint32_t)(input[2] & 0x7f) << 25) |
			((uint32_t)input[3] << 17) |
			((uint32_t)(input[4] & 0x80) << 9);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 33 to 48
	value = ((uint32_t)(input[4] & 0x7f) << 25) |
			((uint32_t)input[5] << 17) |
			((uint32_t)(input[6] & 0x80) << 9);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 49 to 64
	value = ((uint32_t)(input[6] & 0x7f) << 25) |
			((uint32_t)input[7] << 17) |
			((uint32_t)(input[8] & 0x80) << 9);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 65 to 80
	value = ((uint32_t)(input[8] & 0x7f) << 25) |
			((uint32_t)input[9] << 17) |
			((uint32_t)(input[10] & 0x80) << 9);
	output[4] = (double)(value >> 16);
}

static void unpack_5_16bit_signed_2off(const uint8_t * input, double * output, void *closure) {
	// Unpack 5 values into output
	// Values are 16-bit signed
	// Skip 2 bits, read 80 bits of data.
	// Input must be at least 11 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 2 to 17
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)input[1] << 18) |
			((uint32_t)(input[2] & 0xc0) << 10);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 18 to 33
	value = ((uint32_t)(input[2] & 0x3f) << 26) |
			((uint32_t)input[3] << 18) |
			((uint32_t)(input[4] & 0xc0) << 10);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 34 to 49
	value = ((uint32_t)(input[4] & 0x3f) << 26) |
			((uint32_t)input[5] << 18) |
			((uint32_t)(input[6] & 0xc0) << 10);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 50 to 65
	value = ((uint32_t)(input[6] & 0x3f) << 26) |
			((uint32_t)input[7] << 18) |
			((uint32_t)(input[8] & 0xc0) << 10);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 66 to 81
	value = ((uint32_t)(input[8] & 0x3f) << 26) |
			((uint32_t)input[9] << 18) |
			((uint32_t)(input[10] & 0xc0) << 10);
	output[4] = (double)(value >> 16);
}

static void unpack_5_16bit_unsigned_2off(const uint8_t * input, double * output, void *closure) {
	// Unpack 5 values into output
	// Values are 16-bit unsigned
	// Skip 2 bits, read 80 bits of data.
	// Input must be at least 11 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 2 to 17
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)input[1] << 18) |
			((uint32_t)(input[2] & 0xc0) << 10);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 18 to 33
	value = ((uint32_t)(input[2] & 0x3f) << 26) |
			((uint32_t)input[3] << 18) |
			((uint32_t)(input[4] & 0xc0) << 10);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 34 to 49
	value = ((uint32_t)(input[4] & 0x3f) << 26) |
			((uint32_t)input[5] << 18) |
			((uint32_t)(input[6] & 0xc0) << 10);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 50 to 65
	value = ((uint32_t)(input[6] & 0x3f) << 26) |
			((uint32_t)input[7] << 18) |
			((uint32_t)(input[8] & 0xc0) << 10);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 66 to 81
	value = ((uint32_t)(input[8] & 0x3f) << 26) |
			((uint32_t)input[9] << 18) |
			((uint32_t)(input[10] & 0xc0) << 10);
	output[4] = (double)(value >> 16);
}

static void unpack_5_16bit_signed_3off(const uint8_t * input, double * output, void *closure) {
	// Unpack 5 values into output
	// Values are 16-bit signed
	// Skip 3 bits, read 80 bits of data.
	// Input must be at least 11 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 3 to 18
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)input[1] << 19) |
			((uint32_t)(input[2] & 0xe0) << 11);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 19 to 34
	value = ((uint32_t)(input[2] & 0x1f) << 27) |
			((uint32_t)input[3] << 19) |
			((uint32_t)(input[4] & 0xe0) << 11);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 35 to 50
	value = ((uint32_t)(input[4] & 0x1f) << 27) |
			((uint32_t)input[5] << 19) |
			((uint32_t)(input[6] & 0xe0) << 11);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 51 to 66
	value = ((uint32_t)(input[6] & 0x1f) << 27) |
			((uint32_t)input[7] << 19) |
			((uint32_t)(input[8] & 0xe0) << 11);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 67 to 82
	value = ((uint32_t)(input[8] & 0x1f) << 27) |
			((uint32_t)input[9] << 19) |
			((uint32_t)(input[10] & 0xe0) << 11);
	output[4] = (double)(value >> 16);
}

static void unpack_5_16bit_unsigned_3off(const uint8_t * input, double * output, void *closure) {
	// Unpack 5 values into output
	// Values are 16-bit unsigned
	// Skip 3 bits, read 80 bits of data.
	// Input must be at least 11 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 3 to 18
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)input[1] << 19) |
			((uint32_t)(input[2] & 0xe0) << 11);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 19 to 34
	value = ((uint32_t)(input[2] & 0x1f) << 27) |
			((uint32_t)input[3] << 19) |
			((uint32_t)(input[4] & 0xe0) << 11);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 35 to 50
	value = ((uint32_t)(input[4] & 0x1f) << 27) |
			((uint32_t)input[5] << 19) |
			((uint32_t)(input[6] & 0xe0) << 11);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 51 to 66
	value = ((uint32_t)(input[6] & 0x1f) << 27) |
			((uint32_t)input[7] << 19) |
			((uint32_t)(input[8] & 0xe0) << 11);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 67 to 82
	value = ((uint32_t)(input[8] & 0x1f) << 27) |
			((uint32_t)input[9] << 19) |
			((uint32_t)(input[10] & 0xe0) << 11);
	output[4] = (double)(value >> 16);
}

static void unpack_5_16bit_signed_4off(const uint8_t * input, double * output, void *closure) {
	// Unpack 5 values into output
	// Values are 16-bit signed
	// Skip 4 bits, read 80 bits of data.
	// Input must be at least 11 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 4 to 19
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20) |
			((uint32_t)(input[2] & 0xf0) << 12);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 20 to 35
	value = ((uint32_t)(input[2] & 0x0f) << 28) |
			((uint32_t)input[3] << 20) |
			((uint32_t)(input[4] & 0xf0) << 12);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 36 to 51
	value = ((uint32_t)(input[4] & 0x0f) << 28) |
			((uint32_t)input[5] << 20) |
			((uint32_t)(input[6] & 0xf0) << 12);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 52 to 67
	value = ((uint32_t)(input[6] & 0x0f) << 28) |
			((uint32_t)input[7] << 20) |
			((uint32_t)(input[8] & 0xf0) << 12);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 68 to 83
	value = ((uint32_t)(input[8] & 0x0f) << 28) |
			((uint32_t)input[9] << 20) |
			((uint32_t)(input[10] & 0xf0) << 12);
	output[4] = (double)(value >> 16);
}

static void unpack_5_16bit_unsigned_4off(const uint8_t * input, double * output, void *closure) {
	// Unpack 5 values into output
	// Values are 16-bit unsigned
	// Skip 4 bits, read 80 bits of data.
	// Input must be at least 11 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 4 to 19
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20) |
			((uint32_t)(input[2] & 0xf0) << 12);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 20 to 35
	value = ((uint32_t)(input[2] & 0x0f) << 28) |
			((uint32_t)input[3] << 20) |
			((uint32_t)(input[4] & 0xf0) << 12);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 36 to 51
	value = ((uint32_t)(input[4] & 0x0f) << 28) |
			((uint32_t)input[5] << 20) |
			((uint32_t)(input[6] & 0xf0) << 12);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 52 to 67
	value = ((uint32_t)(input[6] & 0x0f) << 28) |
			((uint32_t)input[7] << 20) |
			((uint32_t)(input[8] & 0xf0) << 12);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 68 to 83
	value = ((uint32_t)(input[8] & 0x0f) << 28) |
			((uint32_t)input[9] << 20) |
			((uint32_t)(input[10] & 0xf0) << 12);
	output[4] = (double)(value >> 16);
}

static void unpack_5_16bit_signed_5off(const uint8_t * input, double * output, void *closure) {
	// Unpack 5 values into output
	// Values are 16-bit signed
	// Skip 5 bits, read 80 bits of data.
	// Input must be at least 11 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 5 to 20
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)(input[2] & 0xf8) << 13);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 21 to 36
	value = ((uint32_t)(input[2] & 0x07) << 29) |
			((uint32_t)input[3] << 21) |
			((uint32_t)(input[4] & 0xf8) << 13);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 37 to 52
	value = ((uint32_t)(input[4] & 0x07) << 29) |
			((uint32_t)input[5] << 21) |
			((uint32_t)(input[6] & 0xf8) << 13);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 53 to 68
	value = ((uint32_t)(input[6] & 0x07) << 29) |
			((uint32_t)input[7] << 21) |
			((uint32_t)(input[8] & 0xf8) << 13);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 69 to 84
	value = ((uint32_t)(input[8] & 0x07) << 29) |
			((uint32_t)input[9] << 21) |
			((uint32_t)(input[10] & 0xf8) << 13);
	output[4] = (double)(value >> 16);
}

static void unpack_5_16bit_unsigned_5off(const uint8_t * input, double * output, void *closure) {
	// Unpack 5 values into output
	// Values are 16-bit unsigned
	// Skip 5 bits, read 80 bits of data.
	// Input must be at least 11 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 5 to 20
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)(input[2] & 0xf8) << 13);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 21 to 36
	value = ((uint32_t)(input[2] & 0x07) << 29) |
			((uint32_t)input[3] << 21) |
			((uint32_t)(input[4] & 0xf8) << 13);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 37 to 52
	value = ((uint32_t)(input[4] & 0x07) << 29) |
			((uint32_t)input[5] << 21) |
			((uint32_t)(input[6] & 0xf8) << 13);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 53 to 68
	value = ((uint32_t)(input[6] & 0x07) << 29) |
			((uint32_t)input[7] << 21) |
			((uint32_t)(input[8] & 0xf8) << 13);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 69 to 84
	value = ((uint32_t)(input[8] & 0x07) << 29) |
			((uint32_t)input[9] << 21) |
			((uint32_t)(input[10] & 0xf8) << 13);
	output[4] = (double)(value >> 16);
}

static void unpack_5_16bit_signed_6off(const uint8_t * input, double * output, void *closure) {
	// Unpack 5 values into output
	// Values are 16-bit signed
	// Skip 6 bits, read 80 bits of data.
	// Input must be at least 11 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 6 to 21
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)(input[2] & 0xfc) << 14);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 22 to 37
	value = ((uint32_t)(input[2] & 0x03) << 30) |
			((uint32_t)input[3] << 22) |
			((uint32_t)(input[4] & 0xfc) << 14);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 38 to 53
	value = ((uint32_t)(input[4] & 0x03) << 30) |
			((uint32_t)input[5] << 22) |
			((uint32_t)(input[6] & 0xfc) << 14);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 54 to 69
	value = ((uint32_t)(input[6] & 0x03) << 30) |
			((uint32_t)input[7] << 22) |
			((uint32_t)(input[8] & 0xfc) << 14);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 70 to 85
	value = ((uint32_t)(input[8] & 0x03) << 30) |
			((uint32_t)input[9] << 22) |
			((uint32_t)(input[10] & 0xfc) << 14);
	output[4] = (double)(value >> 16);
}

static void unpack_5_16bit_unsigned_6off(const uint8_t * input, double * output, void *closure) {
	// Unpack 5 values into output
	// Values are 16-bit unsigned
	// Skip 6 bits, read 80 bits of data.
	// Input must be at least 11 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 6 to 21
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)(input[2] & 0xfc) << 14);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 22 to 37
	value = ((uint32_t)(input[2] & 0x03) << 30) |
			((uint32_t)input[3] << 22) |
			((uint32_t)(input[4] & 0xfc) << 14);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 38 to 53
	value = ((uint32_t)(input[4] & 0x03) << 30) |
			((uint32_t)input[5] << 22) |
			((uint32_t)(input[6] & 0xfc) << 14);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 54 to 69
	value = ((uint32_t)(input[6] & 0x03) << 30) |
			((uint32_t)input[7] << 22) |
			((uint32_t)(input[8] & 0xfc) << 14);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 70 to 85
	value = ((uint32_t)(input[8] & 0x03) << 30) |
			((uint32_t)input[9] << 22) |
			((uint32_t)(input[10] & 0xfc) << 14);
	output[4] = (double)(value >> 16);
}

static void unpack_5_16bit_signed_7off(const uint8_t * input, double * output, void *closure) {
	// Unpack 5 values into output
	// Values are 16-bit signed
	// Skip 7 bits, read 80 bits of data.
	// Input must be at least 11 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 7 to 22
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)(input[2] & 0xfe) << 15);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 23 to 38
	value = ((uint32_t)(input[2] & 0x01) << 31) |
			((uint32_t)input[3] << 23) |
			((uint32_t)(input[4] & 0xfe) << 15);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 39 to 54
	value = ((uint32_t)(input[4] & 0x01) << 31) |
			((uint32_t)input[5] << 23) |
			((uint32_t)(input[6] & 0xfe) << 15);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 55 to 70
	value = ((uint32_t)(input[6] & 0x01) << 31) |
			((uint32_t)input[7] << 23) |
			((uint32_t)(input[8] & 0xfe) << 15);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 71 to 86
	value = ((uint32_t)(input[8] & 0x01) << 31) |
			((uint32_t)input[9] << 23) |
			((uint32_t)(input[10] & 0xfe) << 15);
	output[4] = (double)(value >> 16);
}

static void unpack_5_16bit_unsigned_7off(const uint8_t * input, double * output, void *closure) {
	// Unpack 5 values into output
	// Values are 16-bit unsigned
	// Skip 7 bits, read 80 bits of data.
	// Input must be at least 11 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 7 to 22
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)(input[2] & 0xfe) << 15);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 23 to 38
	value = ((uint32_t)(input[2] & 0x01) << 31) |
			((uint32_t)input[3] << 23) |
			((uint32_t)(input[4] & 0xfe) << 15);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 39 to 54
	value = ((uint32_t)(input[4] & 0x01) << 31) |
			((uint32_t)input[5] << 23) |
			((uint32_t)(input[6] & 0xfe) << 15);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 55 to 70
	value = ((uint32_t)(input[6] & 0x01) << 31) |
			((uint32_t)input[7] << 23) |
			((uint32_t)(input[8] & 0xfe) << 15);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 71 to 86
	value = ((uint32_t)(input[8] & 0x01) << 31) |
			((uint32_t)input[9] << 23) |
			((uint32_t)(input[10] & 0xfe) << 15);
	output[4] = (double)(value >> 16);
}

static void unpack_6_16bit_signed_0off(const uint8_t * input, double * output, void *closure) {
	// Unpack 6 values into output
	// Values are 16-bit signed
	// Skip 0 bits, read 96 bits of data.
	// Input must be at least 12 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 0 to 15
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)input[1] << 16);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 16 to 31
	value = ((uint32_t)input[2] << 24) |
			((uint32_t)input[3] << 16);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 32 to 47
	value = ((uint32_t)input[4] << 24) |
			((uint32_t)input[5] << 16);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 48 to 63
	value = ((uint32_t)input[6] << 24) |
			((uint32_t)input[7] << 16);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 64 to 79
	value = ((uint32_t)input[8] << 24) |
			((uint32_t)input[9] << 16);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 80 to 95
	value = ((uint32_t)input[10] << 24) |
			((uint32_t)input[11] << 16);
	output[5] = (double)(value >> 16);
}

static void unpack_6_16bit_unsigned_0off(const uint8_t * input, double * output, void *closure) {
	// Unpack 6 values into output
	// Values are 16-bit unsigned
	// Skip 0 bits, read 96 bits of data.
	// Input must be at least 12 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 0 to 15
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)input[1] << 16);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 16 to 31
	value = ((uint32_t)input[2] << 24) |
			((uint32_t)input[3] << 16);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 32 to 47
	value = ((uint32_t)input[4] << 24) |
			((uint32_t)input[5] << 16);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 48 to 63
	value = ((uint32_t)input[6] << 24) |
			((uint32_t)input[7] << 16);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 64 to 79
	value = ((uint32_t)input[8] << 24) |
			((uint32_t)input[9] << 16);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 80 to 95
	value = ((uint32_t)input[10] << 24) |
			((uint32_t)input[11] << 16);
	output[5] = (double)(value >> 16);
}

static void unpack_6_16bit_signed_1off(const uint8_t * input, double * output, void *closure) {
	// Unpack 6 values into output
	// Values are 16-bit signed
	// Skip 1 bits, read 96 bits of data.
	// Input must be at least 13 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 1 to 16
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)input[1] << 17) |
			((uint32_t)(input[2] & 0x80) << 9);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 17 to 32
	value = ((uint32_t)(input[2] & 0x7f) << 25) |
			((uint32_t)input[3] << 17) |
			((uint32_t)(input[4] & 0x80) << 9);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 33 to 48
	value = ((uint32_t)(input[4] & 0x7f) << 25) |
			((uint32_t)input[5] << 17) |
			((uint32_t)(input[6] & 0x80) << 9);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 49 to 64
	value = ((uint32_t)(input[6] & 0x7f) << 25) |
			((uint32_t)input[7] << 17) |
			((uint32_t)(input[8] & 0x80) << 9);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 65 to 80
	value = ((uint32_t)(input[8] & 0x7f) << 25) |
			((uint32_t)input[9] << 17) |
			((uint32_t)(input[10] & 0x80) << 9);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 81 to 96
	value = ((uint32_t)(input[10] & 0x7f) << 25) |
			((uint32_t)input[11] << 17) |
			((uint32_t)(input[12] & 0x80) << 9);
	output[5] = (double)(value >> 16);
}

static void unpack_6_16bit_unsigned_1off(const uint8_t * input, double * output, void *closure) {
	// Unpack 6 values into output
	// Values are 16-bit unsigned
	// Skip 1 bits, read 96 bits of data.
	// Input must be at least 13 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 1 to 16
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)input[1] << 17) |
			((uint32_t)(input[2] & 0x80) << 9);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 17 to 32
	value = ((uint32_t)(input[2] & 0x7f) << 25) |
			((uint32_t)input[3] << 17) |
			((uint32_t)(input[4] & 0x80) << 9);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 33 to 48
	value = ((uint32_t)(input[4] & 0x7f) << 25) |
			((uint32_t)input[5] << 17) |
			((uint32_t)(input[6] & 0x80) << 9);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 49 to 64
	value = ((uint32_t)(input[6] & 0x7f) << 25) |
			((uint32_t)input[7] << 17) |
			((uint32_t)(input[8] & 0x80) << 9);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 65 to 80
	value = ((uint32_t)(input[8] & 0x7f) << 25) |
			((uint32_t)input[9] << 17) |
			((uint32_t)(input[10] & 0x80) << 9);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 81 to 96
	value = ((uint32_t)(input[10] & 0x7f) << 25) |
			((uint32_t)input[11] << 17) |
			((uint32_t)(input[12] & 0x80) << 9);
	output[5] = (double)(value >> 16);
}

static void unpack_6_16bit_signed_2off(const uint8_t * input, double * output, void *closure) {
	// Unpack 6 values into output
	// Values are 16-bit signed
	// Skip 2 bits, read 96 bits of data.
	// Input must be at least 13 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 2 to 17
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)input[1] << 18) |
			((uint32_t)(input[2] & 0xc0) << 10);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 18 to 33
	value = ((uint32_t)(input[2] & 0x3f) << 26) |
			((uint32_t)input[3] << 18) |
			((uint32_t)(input[4] & 0xc0) << 10);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 34 to 49
	value = ((uint32_t)(input[4] & 0x3f) << 26) |
			((uint32_t)input[5] << 18) |
			((uint32_t)(input[6] & 0xc0) << 10);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 50 to 65
	value = ((uint32_t)(input[6] & 0x3f) << 26) |
			((uint32_t)input[7] << 18) |
			((uint32_t)(input[8] & 0xc0) << 10);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 66 to 81
	value = ((uint32_t)(input[8] & 0x3f) << 26) |
			((uint32_t)input[9] << 18) |
			((uint32_t)(input[10] & 0xc0) << 10);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 82 to 97
	value = ((uint32_t)(input[10] & 0x3f) << 26) |
			((uint32_t)input[11] << 18) |
			((uint32_t)(input[12] & 0xc0) << 10);
	output[5] = (double)(value >> 16);
}

static void unpack_6_16bit_unsigned_2off(const uint8_t * input, double * output, void *closure) {
	// Unpack 6 values into output
	// Values are 16-bit unsigned
	// Skip 2 bits, read 96 bits of data.
	// Input must be at least 13 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 2 to 17
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)input[1] << 18) |
			((uint32_t)(input[2] & 0xc0) << 10);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 18 to 33
	value = ((uint32_t)(input[2] & 0x3f) << 26) |
			((uint32_t)input[3] << 18) |
			((uint32_t)(input[4] & 0xc0) << 10);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 34 to 49
	value = ((uint32_t)(input[4] & 0x3f) << 26) |
			((uint32_t)input[5] << 18) |
			((uint32_t)(input[6] & 0xc0) << 10);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 50 to 65
	value = ((uint32_t)(input[6] & 0x3f) << 26) |
			((uint32_t)input[7] << 18) |
			((uint32_t)(input[8] & 0xc0) << 10);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 66 to 81
	value = ((uint32_t)(input[8] & 0x3f) << 26) |
			((uint32_t)input[9] << 18) |
			((uint32_t)(input[10] & 0xc0) << 10);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 82 to 97
	value = ((uint32_t)(input[10] & 0x3f) << 26) |
			((uint32_t)input[11] << 18) |
			((uint32_t)(input[12] & 0xc0) << 10);
	output[5] = (double)(value >> 16);
}

static void unpack_6_16bit_signed_3off(const uint8_t * input, double * output, void *closure) {
	// Unpack 6 values into output
	// Values are 16-bit signed
	// Skip 3 bits, read 96 bits of data.
	// Input must be at least 13 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 3 to 18
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)input[1] << 19) |
			((uint32_t)(input[2] & 0xe0) << 11);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 19 to 34
	value = ((uint32_t)(input[2] & 0x1f) << 27) |
			((uint32_t)input[3] << 19) |
			((uint32_t)(input[4] & 0xe0) << 11);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 35 to 50
	value = ((uint32_t)(input[4] & 0x1f) << 27) |
			((uint32_t)input[5] << 19) |
			((uint32_t)(input[6] & 0xe0) << 11);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 51 to 66
	value = ((uint32_t)(input[6] & 0x1f) << 27) |
			((uint32_t)input[7] << 19) |
			((uint32_t)(input[8] & 0xe0) << 11);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 67 to 82
	value = ((uint32_t)(input[8] & 0x1f) << 27) |
			((uint32_t)input[9] << 19) |
			((uint32_t)(input[10] & 0xe0) << 11);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 83 to 98
	value = ((uint32_t)(input[10] & 0x1f) << 27) |
			((uint32_t)input[11] << 19) |
			((uint32_t)(input[12] & 0xe0) << 11);
	output[5] = (double)(value >> 16);
}

static void unpack_6_16bit_unsigned_3off(const uint8_t * input, double * output, void *closure) {
	// Unpack 6 values into output
	// Values are 16-bit unsigned
	// Skip 3 bits, read 96 bits of data.
	// Input must be at least 13 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 3 to 18
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)input[1] << 19) |
			((uint32_t)(input[2] & 0xe0) << 11);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 19 to 34
	value = ((uint32_t)(input[2] & 0x1f) << 27) |
			((uint32_t)input[3] << 19) |
			((uint32_t)(input[4] & 0xe0) << 11);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 35 to 50
	value = ((uint32_t)(input[4] & 0x1f) << 27) |
			((uint32_t)input[5] << 19) |
			((uint32_t)(input[6] & 0xe0) << 11);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 51 to 66
	value = ((uint32_t)(input[6] & 0x1f) << 27) |
			((uint32_t)input[7] << 19) |
			((uint32_t)(input[8] & 0xe0) << 11);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 67 to 82
	value = ((uint32_t)(input[8] & 0x1f) << 27) |
			((uint32_t)input[9] << 19) |
			((uint32_t)(input[10] & 0xe0) << 11);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 83 to 98
	value = ((uint32_t)(input[10] & 0x1f) << 27) |
			((uint32_t)input[11] << 19) |
			((uint32_t)(input[12] & 0xe0) << 11);
	output[5] = (double)(value >> 16);
}

static void unpack_6_16bit_signed_4off(const uint8_t * input, double * output, void *closure) {
	// Unpack 6 values into output
	// Values are 16-bit signed
	// Skip 4 bits, read 96 bits of data.
	// Input must be at least 13 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 4 to 19
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20) |
			((uint32_t)(input[2] & 0xf0) << 12);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 20 to 35
	value = ((uint32_t)(input[2] & 0x0f) << 28) |
			((uint32_t)input[3] << 20) |
			((uint32_t)(input[4] & 0xf0) << 12);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 36 to 51
	value = ((uint32_t)(input[4] & 0x0f) << 28) |
			((uint32_t)input[5] << 20) |
			((uint32_t)(input[6] & 0xf0) << 12);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 52 to 67
	value = ((uint32_t)(input[6] & 0x0f) << 28) |
			((uint32_t)input[7] << 20) |
			((uint32_t)(input[8] & 0xf0) << 12);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 68 to 83
	value = ((uint32_t)(input[8] & 0x0f) << 28) |
			((uint32_t)input[9] << 20) |
			((uint32_t)(input[10] & 0xf0) << 12);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 84 to 99
	value = ((uint32_t)(input[10] & 0x0f) << 28) |
			((uint32_t)input[11] << 20) |
			((uint32_t)(input[12] & 0xf0) << 12);
	output[5] = (double)(value >> 16);
}

static void unpack_6_16bit_unsigned_4off(const uint8_t * input, double * output, void *closure) {
	// Unpack 6 values into output
	// Values are 16-bit unsigned
	// Skip 4 bits, read 96 bits of data.
	// Input must be at least 13 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 4 to 19
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20) |
			((uint32_t)(input[2] & 0xf0) << 12);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 20 to 35
	value = ((uint32_t)(input[2] & 0x0f) << 28) |
			((uint32_t)input[3] << 20) |
			((uint32_t)(input[4] & 0xf0) << 12);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 36 to 51
	value = ((uint32_t)(input[4] & 0x0f) << 28) |
			((uint32_t)input[5] << 20) |
			((uint32_t)(input[6] & 0xf0) << 12);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 52 to 67
	value = ((uint32_t)(input[6] & 0x0f) << 28) |
			((uint32_t)input[7] << 20) |
			((uint32_t)(input[8] & 0xf0) << 12);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 68 to 83
	value = ((uint32_t)(input[8] & 0x0f) << 28) |
			((uint32_t)input[9] << 20) |
			((uint32_t)(input[10] & 0xf0) << 12);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 84 to 99
	value = ((uint32_t)(input[10] & 0x0f) << 28) |
			((uint32_t)input[11] << 20) |
			((uint32_t)(input[12] & 0xf0) << 12);
	output[5] = (double)(value >> 16);
}

static void unpack_6_16bit_signed_5off(const uint8_t * input, double * output, void *closure) {
	// Unpack 6 values into output
	// Values are 16-bit signed
	// Skip 5 bits, read 96 bits of data.
	// Input must be at least 13 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 5 to 20
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)(input[2] & 0xf8) << 13);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 21 to 36
	value = ((uint32_t)(input[2] & 0x07) << 29) |
			((uint32_t)input[3] << 21) |
			((uint32_t)(input[4] & 0xf8) << 13);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 37 to 52
	value = ((uint32_t)(input[4] & 0x07) << 29) |
			((uint32_t)input[5] << 21) |
			((uint32_t)(input[6] & 0xf8) << 13);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 53 to 68
	value = ((uint32_t)(input[6] & 0x07) << 29) |
			((uint32_t)input[7] << 21) |
			((uint32_t)(input[8] & 0xf8) << 13);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 69 to 84
	value = ((uint32_t)(input[8] & 0x07) << 29) |
			((uint32_t)input[9] << 21) |
			((uint32_t)(input[10] & 0xf8) << 13);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 85 to 100
	value = ((uint32_t)(input[10] & 0x07) << 29) |
			((uint32_t)input[11] << 21) |
			((uint32_t)(input[12] & 0xf8) << 13);
	output[5] = (double)(value >> 16);
}

static void unpack_6_16bit_unsigned_5off(const uint8_t * input, double * output, void *closure) {
	// Unpack 6 values into output
	// Values are 16-bit unsigned
	// Skip 5 bits, read 96 bits of data.
	// Input must be at least 13 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 5 to 20
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)(input[2] & 0xf8) << 13);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 21 to 36
	value = ((uint32_t)(input[2] & 0x07) << 29) |
			((uint32_t)input[3] << 21) |
			((uint32_t)(input[4] & 0xf8) << 13);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 37 to 52
	value = ((uint32_t)(input[4] & 0x07) << 29) |
			((uint32_t)input[5] << 21) |
			((uint32_t)(input[6] & 0xf8) << 13);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 53 to 68
	value = ((uint32_t)(input[6] & 0x07) << 29) |
			((uint32_t)input[7] << 21) |
			((uint32_t)(input[8] & 0xf8) << 13);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 69 to 84
	value = ((uint32_t)(input[8] & 0x07) << 29) |
			((uint32_t)input[9] << 21) |
			((uint32_t)(input[10] & 0xf8) << 13);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 85 to 100
	value = ((uint32_t)(input[10] & 0x07) << 29) |
			((uint32_t)input[11] << 21) |
			((uint32_t)(input[12] & 0xf8) << 13);
	output[5] = (double)(value >> 16);
}

static void unpack_6_16bit_signed_6off(const uint8_t * input, double * output, void *closure) {
	// Unpack 6 values into output
	// Values are 16-bit signed
	// Skip 6 bits, read 96 bits of data.
	// Input must be at least 13 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 6 to 21
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)(input[2] & 0xfc) << 14);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 22 to 37
	value = ((uint32_t)(input[2] & 0x03) << 30) |
			((uint32_t)input[3] << 22) |
			((uint32_t)(input[4] & 0xfc) << 14);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 38 to 53
	value = ((uint32_t)(input[4] & 0x03) << 30) |
			((uint32_t)input[5] << 22) |
			((uint32_t)(input[6] & 0xfc) << 14);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 54 to 69
	value = ((uint32_t)(input[6] & 0x03) << 30) |
			((uint32_t)input[7] << 22) |
			((uint32_t)(input[8] & 0xfc) << 14);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 70 to 85
	value = ((uint32_t)(input[8] & 0x03) << 30) |
			((uint32_t)input[9] << 22) |
			((uint32_t)(input[10] & 0xfc) << 14);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 86 to 101
	value = ((uint32_t)(input[10] & 0x03) << 30) |
			((uint32_t)input[11] << 22) |
			((uint32_t)(input[12] & 0xfc) << 14);
	output[5] = (double)(value >> 16);
}

static void unpack_6_16bit_unsigned_6off(const uint8_t * input, double * output, void *closure) {
	// Unpack 6 values into output
	// Values are 16-bit unsigned
	// Skip 6 bits, read 96 bits of data.
	// Input must be at least 13 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 6 to 21
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)(input[2] & 0xfc) << 14);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 22 to 37
	value = ((uint32_t)(input[2] & 0x03) << 30) |
			((uint32_t)input[3] << 22) |
			((uint32_t)(input[4] & 0xfc) << 14);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 38 to 53
	value = ((uint32_t)(input[4] & 0x03) << 30) |
			((uint32_t)input[5] << 22) |
			((uint32_t)(input[6] & 0xfc) << 14);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 54 to 69
	value = ((uint32_t)(input[6] & 0x03) << 30) |
			((uint32_t)input[7] << 22) |
			((uint32_t)(input[8] & 0xfc) << 14);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 70 to 85
	value = ((uint32_t)(input[8] & 0x03) << 30) |
			((uint32_t)input[9] << 22) |
			((uint32_t)(input[10] & 0xfc) << 14);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 86 to 101
	value = ((uint32_t)(input[10] & 0x03) << 30) |
			((uint32_t)input[11] << 22) |
			((uint32_t)(input[12] & 0xfc) << 14);
	output[5] = (double)(value >> 16);
}

static void unpack_6_16bit_signed_7off(const uint8_t * input, double * output, void *closure) {
	// Unpack 6 values into output
	// Values are 16-bit signed
	// Skip 7 bits, read 96 bits of data.
	// Input must be at least 13 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 7 to 22
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)(input[2] & 0xfe) << 15);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 23 to 38
	value = ((uint32_t)(input[2] & 0x01) << 31) |
			((uint32_t)input[3] << 23) |
			((uint32_t)(input[4] & 0xfe) << 15);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 39 to 54
	value = ((uint32_t)(input[4] & 0x01) << 31) |
			((uint32_t)input[5] << 23) |
			((uint32_t)(input[6] & 0xfe) << 15);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 55 to 70
	value = ((uint32_t)(input[6] & 0x01) << 31) |
			((uint32_t)input[7] << 23) |
			((uint32_t)(input[8] & 0xfe) << 15);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 71 to 86
	value = ((uint32_t)(input[8] & 0x01) << 31) |
			((uint32_t)input[9] << 23) |
			((uint32_t)(input[10] & 0xfe) << 15);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 87 to 102
	value = ((uint32_t)(input[10] & 0x01) << 31) |
			((uint32_t)input[11] << 23) |
			((uint32_t)(input[12] & 0xfe) << 15);
	output[5] = (double)(value >> 16);
}

static void unpack_6_16bit_unsigned_7off(const uint8_t * input, double * output, void *closure) {
	// Unpack 6 values into output
	// Values are 16-bit unsigned
	// Skip 7 bits, read 96 bits of data.
	// Input must be at least 13 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 7 to 22
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)(input[2] & 0xfe) << 15);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 23 to 38
	value = ((uint32_t)(input[2] & 0x01) << 31) |
			((uint32_t)input[3] << 23) |
			((uint32_t)(input[4] & 0xfe) << 15);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 39 to 54
	value = ((uint32_t)(input[4] & 0x01) << 31) |
			((uint32_t)input[5] << 23) |
			((uint32_t)(input[6] & 0xfe) << 15);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 55 to 70
	value = ((uint32_t)(input[6] & 0x01) << 31) |
			((uint32_t)input[7] << 23) |
			((uint32_t)(input[8] & 0xfe) << 15);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 71 to 86
	value = ((uint32_t)(input[8] & 0x01) << 31) |
			((uint32_t)input[9] << 23) |
			((uint32_t)(input[10] & 0xfe) << 15);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 87 to 102
	value = ((uint32_t)(input[10] & 0x01) << 31) |
			((uint32_t)input[11] << 23) |
			((uint32_t)(input[12] & 0xfe) << 15);
	output[5] = (double)(value >> 16);
}

static void unpack_7_16bit_signed_0off(const uint8_t * input, double * output, void *closure) {
	// Unpack 7 values into output
	// Values are 16-bit signed
	// Skip 0 bits, read 112 bits of data.
	// Input must be at least 14 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 0 to 15
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)input[1] << 16);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 16 to 31
	value = ((uint32_t)input[2] << 24) |
			((uint32_t)input[3] << 16);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 32 to 47
	value = ((uint32_t)input[4] << 24) |
			((uint32_t)input[5] << 16);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 48 to 63
	value = ((uint32_t)input[6] << 24) |
			((uint32_t)input[7] << 16);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 64 to 79
	value = ((uint32_t)input[8] << 24) |
			((uint32_t)input[9] << 16);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 80 to 95
	value = ((uint32_t)input[10] << 24) |
			((uint32_t)input[11] << 16);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 96 to 111
	value = ((uint32_t)input[12] << 24) |
			((uint32_t)input[13] << 16);
	output[6] = (double)(value >> 16);
}

static void unpack_7_16bit_unsigned_0off(const uint8_t * input, double * output, void *closure) {
	// Unpack 7 values into output
	// Values are 16-bit unsigned
	// Skip 0 bits, read 112 bits of data.
	// Input must be at least 14 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 0 to 15
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)input[1] << 16);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 16 to 31
	value = ((uint32_t)input[2] << 24) |
			((uint32_t)input[3] << 16);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 32 to 47
	value = ((uint32_t)input[4] << 24) |
			((uint32_t)input[5] << 16);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 48 to 63
	value = ((uint32_t)input[6] << 24) |
			((uint32_t)input[7] << 16);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 64 to 79
	value = ((uint32_t)input[8] << 24) |
			((uint32_t)input[9] << 16);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 80 to 95
	value = ((uint32_t)input[10] << 24) |
			((uint32_t)input[11] << 16);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 96 to 111
	value = ((uint32_t)input[12] << 24) |
			((uint32_t)input[13] << 16);
	output[6] = (double)(value >> 16);
}

static void unpack_7_16bit_signed_1off(const uint8_t * input, double * output, void *closure) {
	// Unpack 7 values into output
	// Values are 16-bit signed
	// Skip 1 bits, read 112 bits of data.
	// Input must be at least 15 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 1 to 16
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)input[1] << 17) |
			((uint32_t)(input[2] & 0x80) << 9);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 17 to 32
	value = ((uint32_t)(input[2] & 0x7f) << 25) |
			((uint32_t)input[3] << 17) |
			((uint32_t)(input[4] & 0x80) << 9);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 33 to 48
	value = ((uint32_t)(input[4] & 0x7f) << 25) |
			((uint32_t)input[5] << 17) |
			((uint32_t)(input[6] & 0x80) << 9);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 49 to 64
	value = ((uint32_t)(input[6] & 0x7f) << 25) |
			((uint32_t)input[7] << 17) |
			((uint32_t)(input[8] & 0x80) << 9);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 65 to 80
	value = ((uint32_t)(input[8] & 0x7f) << 25) |
			((uint32_t)input[9] << 17) |
			((uint32_t)(input[10] & 0x80) << 9);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 81 to 96
	value = ((uint32_t)(input[10] & 0x7f) << 25) |
			((uint32_t)input[11] << 17) |
			((uint32_t)(input[12] & 0x80) << 9);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 97 to 112
	value = ((uint32_t)(input[12] & 0x7f) << 25) |
			((uint32_t)input[13] << 17) |
			((uint32_t)(input[14] & 0x80) << 9);
	output[6] = (double)(value >> 16);
}

static void unpack_7_16bit_unsigned_1off(const uint8_t * input, double * output, void *closure) {
	// Unpack 7 values into output
	// Values are 16-bit unsigned
	// Skip 1 bits, read 112 bits of data.
	// Input must be at least 15 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 1 to 16
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)input[1] << 17) |
			((uint32_t)(input[2] & 0x80) << 9);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 17 to 32
	value = ((uint32_t)(input[2] & 0x7f) << 25) |
			((uint32_t)input[3] << 17) |
			((uint32_t)(input[4] & 0x80) << 9);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 33 to 48
	value = ((uint32_t)(input[4] & 0x7f) << 25) |
			((uint32_t)input[5] << 17) |
			((uint32_t)(input[6] & 0x80) << 9);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 49 to 64
	value = ((uint32_t)(input[6] & 0x7f) << 25) |
			((uint32_t)input[7] << 17) |
			((uint32_t)(input[8] & 0x80) << 9);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 65 to 80
	value = ((uint32_t)(input[8] & 0x7f) << 25) |
			((uint32_t)input[9] << 17) |
			((uint32_t)(input[10] & 0x80) << 9);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 81 to 96
	value = ((uint32_t)(input[10] & 0x7f) << 25) |
			((uint32_t)input[11] << 17) |
			((uint32_t)(input[12] & 0x80) << 9);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 97 to 112
	value = ((uint32_t)(input[12] & 0x7f) << 25) |
			((uint32_t)input[13] << 17) |
			((uint32_t)(input[14] & 0x80) << 9);
	output[6] = (double)(value >> 16);
}

static void unpack_7_16bit_signed_2off(const uint8_t * input, double * output, void *closure) {
	// Unpack 7 values into output
	// Values are 16-bit signed
	// Skip 2 bits, read 112 bits of data.
	// Input must be at least 15 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 2 to 17
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)input[1] << 18) |
			((uint32_t)(input[2] & 0xc0) << 10);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 18 to 33
	value = ((uint32_t)(input[2] & 0x3f) << 26) |
			((uint32_t)input[3] << 18) |
			((uint32_t)(input[4] & 0xc0) << 10);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 34 to 49
	value = ((uint32_t)(input[4] & 0x3f) << 26) |
			((uint32_t)input[5] << 18) |
			((uint32_t)(input[6] & 0xc0) << 10);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 50 to 65
	value = ((uint32_t)(input[6] & 0x3f) << 26) |
			((uint32_t)input[7] << 18) |
			((uint32_t)(input[8] & 0xc0) << 10);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 66 to 81
	value = ((uint32_t)(input[8] & 0x3f) << 26) |
			((uint32_t)input[9] << 18) |
			((uint32_t)(input[10] & 0xc0) << 10);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 82 to 97
	value = ((uint32_t)(input[10] & 0x3f) << 26) |
			((uint32_t)input[11] << 18) |
			((uint32_t)(input[12] & 0xc0) << 10);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 98 to 113
	value = ((uint32_t)(input[12] & 0x3f) << 26) |
			((uint32_t)input[13] << 18) |
			((uint32_t)(input[14] & 0xc0) << 10);
	output[6] = (double)(value >> 16);
}

static void unpack_7_16bit_unsigned_2off(const uint8_t * input, double * output, void *closure) {
	// Unpack 7 values into output
	// Values are 16-bit unsigned
	// Skip 2 bits, read 112 bits of data.
	// Input must be at least 15 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 2 to 17
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)input[1] << 18) |
			((uint32_t)(input[2] & 0xc0) << 10);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 18 to 33
	value = ((uint32_t)(input[2] & 0x3f) << 26) |
			((uint32_t)input[3] << 18) |
			((uint32_t)(input[4] & 0xc0) << 10);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 34 to 49
	value = ((uint32_t)(input[4] & 0x3f) << 26) |
			((uint32_t)input[5] << 18) |
			((uint32_t)(input[6] & 0xc0) << 10);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 50 to 65
	value = ((uint32_t)(input[6] & 0x3f) << 26) |
			((uint32_t)input[7] << 18) |
			((uint32_t)(input[8] & 0xc0) << 10);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 66 to 81
	value = ((uint32_t)(input[8] & 0x3f) << 26) |
			((uint32_t)input[9] << 18) |
			((uint32_t)(input[10] & 0xc0) << 10);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 82 to 97
	value = ((uint32_t)(input[10] & 0x3f) << 26) |
			((uint32_t)input[11] << 18) |
			((uint32_t)(input[12] & 0xc0) << 10);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 98 to 113
	value = ((uint32_t)(input[12] & 0x3f) << 26) |
			((uint32_t)input[13] << 18) |
			((uint32_t)(input[14] & 0xc0) << 10);
	output[6] = (double)(value >> 16);
}

static void unpack_7_16bit_signed_3off(const uint8_t * input, double * output, void *closure) {
	// Unpack 7 values into output
	// Values are 16-bit signed
	// Skip 3 bits, read 112 bits of data.
	// Input must be at least 15 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 3 to 18
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)input[1] << 19) |
			((uint32_t)(input[2] & 0xe0) << 11);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 19 to 34
	value = ((uint32_t)(input[2] & 0x1f) << 27) |
			((uint32_t)input[3] << 19) |
			((uint32_t)(input[4] & 0xe0) << 11);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 35 to 50
	value = ((uint32_t)(input[4] & 0x1f) << 27) |
			((uint32_t)input[5] << 19) |
			((uint32_t)(input[6] & 0xe0) << 11);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 51 to 66
	value = ((uint32_t)(input[6] & 0x1f) << 27) |
			((uint32_t)input[7] << 19) |
			((uint32_t)(input[8] & 0xe0) << 11);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 67 to 82
	value = ((uint32_t)(input[8] & 0x1f) << 27) |
			((uint32_t)input[9] << 19) |
			((uint32_t)(input[10] & 0xe0) << 11);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 83 to 98
	value = ((uint32_t)(input[10] & 0x1f) << 27) |
			((uint32_t)input[11] << 19) |
			((uint32_t)(input[12] & 0xe0) << 11);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 99 to 114
	value = ((uint32_t)(input[12] & 0x1f) << 27) |
			((uint32_t)input[13] << 19) |
			((uint32_t)(input[14] & 0xe0) << 11);
	output[6] = (double)(value >> 16);
}

static void unpack_7_16bit_unsigned_3off(const uint8_t * input, double * output, void *closure) {
	// Unpack 7 values into output
	// Values are 16-bit unsigned
	// Skip 3 bits, read 112 bits of data.
	// Input must be at least 15 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 3 to 18
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)input[1] << 19) |
			((uint32_t)(input[2] & 0xe0) << 11);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 19 to 34
	value = ((uint32_t)(input[2] & 0x1f) << 27) |
			((uint32_t)input[3] << 19) |
			((uint32_t)(input[4] & 0xe0) << 11);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 35 to 50
	value = ((uint32_t)(input[4] & 0x1f) << 27) |
			((uint32_t)input[5] << 19) |
			((uint32_t)(input[6] & 0xe0) << 11);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 51 to 66
	value = ((uint32_t)(input[6] & 0x1f) << 27) |
			((uint32_t)input[7] << 19) |
			((uint32_t)(input[8] & 0xe0) << 11);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 67 to 82
	value = ((uint32_t)(input[8] & 0x1f) << 27) |
			((uint32_t)input[9] << 19) |
			((uint32_t)(input[10] & 0xe0) << 11);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 83 to 98
	value = ((uint32_t)(input[10] & 0x1f) << 27) |
			((uint32_t)input[11] << 19) |
			((uint32_t)(input[12] & 0xe0) << 11);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 99 to 114
	value = ((uint32_t)(input[12] & 0x1f) << 27) |
			((uint32_t)input[13] << 19) |
			((uint32_t)(input[14] & 0xe0) << 11);
	output[6] = (double)(value >> 16);
}

static void unpack_7_16bit_signed_4off(const uint8_t * input, double * output, void *closure) {
	// Unpack 7 values into output
	// Values are 16-bit signed
	// Skip 4 bits, read 112 bits of data.
	// Input must be at least 15 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 4 to 19
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20) |
			((uint32_t)(input[2] & 0xf0) << 12);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 20 to 35
	value = ((uint32_t)(input[2] & 0x0f) << 28) |
			((uint32_t)input[3] << 20) |
			((uint32_t)(input[4] & 0xf0) << 12);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 36 to 51
	value = ((uint32_t)(input[4] & 0x0f) << 28) |
			((uint32_t)input[5] << 20) |
			((uint32_t)(input[6] & 0xf0) << 12);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 52 to 67
	value = ((uint32_t)(input[6] & 0x0f) << 28) |
			((uint32_t)input[7] << 20) |
			((uint32_t)(input[8] & 0xf0) << 12);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 68 to 83
	value = ((uint32_t)(input[8] & 0x0f) << 28) |
			((uint32_t)input[9] << 20) |
			((uint32_t)(input[10] & 0xf0) << 12);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 84 to 99
	value = ((uint32_t)(input[10] & 0x0f) << 28) |
			((uint32_t)input[11] << 20) |
			((uint32_t)(input[12] & 0xf0) << 12);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 100 to 115
	value = ((uint32_t)(input[12] & 0x0f) << 28) |
			((uint32_t)input[13] << 20) |
			((uint32_t)(input[14] & 0xf0) << 12);
	output[6] = (double)(value >> 16);
}

static void unpack_7_16bit_unsigned_4off(const uint8_t * input, double * output, void *closure) {
	// Unpack 7 values into output
	// Values are 16-bit unsigned
	// Skip 4 bits, read 112 bits of data.
	// Input must be at least 15 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 4 to 19
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20) |
			((uint32_t)(input[2] & 0xf0) << 12);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 20 to 35
	value = ((uint32_t)(input[2] & 0x0f) << 28) |
			((uint32_t)input[3] << 20) |
			((uint32_t)(input[4] & 0xf0) << 12);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 36 to 51
	value = ((uint32_t)(input[4] & 0x0f) << 28) |
			((uint32_t)input[5] << 20) |
			((uint32_t)(input[6] & 0xf0) << 12);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 52 to 67
	value = ((uint32_t)(input[6] & 0x0f) << 28) |
			((uint32_t)input[7] << 20) |
			((uint32_t)(input[8] & 0xf0) << 12);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 68 to 83
	value = ((uint32_t)(input[8] & 0x0f) << 28) |
			((uint32_t)input[9] << 20) |
			((uint32_t)(input[10] & 0xf0) << 12);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 84 to 99
	value = ((uint32_t)(input[10] & 0x0f) << 28) |
			((uint32_t)input[11] << 20) |
			((uint32_t)(input[12] & 0xf0) << 12);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 100 to 115
	value = ((uint32_t)(input[12] & 0x0f) << 28) |
			((uint32_t)input[13] << 20) |
			((uint32_t)(input[14] & 0xf0) << 12);
	output[6] = (double)(value >> 16);
}

static void unpack_7_16bit_signed_5off(const uint8_t * input, double * output, void *closure) {
	// Unpack 7 values into output
	// Values are 16-bit signed
	// Skip 5 bits, read 112 bits of data.
	// Input must be at least 15 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 5 to 20
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)(input[2] & 0xf8) << 13);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 21 to 36
	value = ((uint32_t)(input[2] & 0x07) << 29) |
			((uint32_t)input[3] << 21) |
			((uint32_t)(input[4] & 0xf8) << 13);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 37 to 52
	value = ((uint32_t)(input[4] & 0x07) << 29) |
			((uint32_t)input[5] << 21) |
			((uint32_t)(input[6] & 0xf8) << 13);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 53 to 68
	value = ((uint32_t)(input[6] & 0x07) << 29) |
			((uint32_t)input[7] << 21) |
			((uint32_t)(input[8] & 0xf8) << 13);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 69 to 84
	value = ((uint32_t)(input[8] & 0x07) << 29) |
			((uint32_t)input[9] << 21) |
			((uint32_t)(input[10] & 0xf8) << 13);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 85 to 100
	value = ((uint32_t)(input[10] & 0x07) << 29) |
			((uint32_t)input[11] << 21) |
			((uint32_t)(input[12] & 0xf8) << 13);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 101 to 116
	value = ((uint32_t)(input[12] & 0x07) << 29) |
			((uint32_t)input[13] << 21) |
			((uint32_t)(input[14] & 0xf8) << 13);
	output[6] = (double)(value >> 16);
}

static void unpack_7_16bit_unsigned_5off(const uint8_t * input, double * output, void *closure) {
	// Unpack 7 values into output
	// Values are 16-bit unsigned
	// Skip 5 bits, read 112 bits of data.
	// Input must be at least 15 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 5 to 20
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)(input[2] & 0xf8) << 13);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 21 to 36
	value = ((uint32_t)(input[2] & 0x07) << 29) |
			((uint32_t)input[3] << 21) |
			((uint32_t)(input[4] & 0xf8) << 13);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 37 to 52
	value = ((uint32_t)(input[4] & 0x07) << 29) |
			((uint32_t)input[5] << 21) |
			((uint32_t)(input[6] & 0xf8) << 13);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 53 to 68
	value = ((uint32_t)(input[6] & 0x07) << 29) |
			((uint32_t)input[7] << 21) |
			((uint32_t)(input[8] & 0xf8) << 13);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 69 to 84
	value = ((uint32_t)(input[8] & 0x07) << 29) |
			((uint32_t)input[9] << 21) |
			((uint32_t)(input[10] & 0xf8) << 13);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 85 to 100
	value = ((uint32_t)(input[10] & 0x07) << 29) |
			((uint32_t)input[11] << 21) |
			((uint32_t)(input[12] & 0xf8) << 13);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 101 to 116
	value = ((uint32_t)(input[12] & 0x07) << 29) |
			((uint32_t)input[13] << 21) |
			((uint32_t)(input[14] & 0xf8) << 13);
	output[6] = (double)(value >> 16);
}

static void unpack_7_16bit_signed_6off(const uint8_t * input, double * output, void *closure) {
	// Unpack 7 values into output
	// Values are 16-bit signed
	// Skip 6 bits, read 112 bits of data.
	// Input must be at least 15 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 6 to 21
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)(input[2] & 0xfc) << 14);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 22 to 37
	value = ((uint32_t)(input[2] & 0x03) << 30) |
			((uint32_t)input[3] << 22) |
			((uint32_t)(input[4] & 0xfc) << 14);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 38 to 53
	value = ((uint32_t)(input[4] & 0x03) << 30) |
			((uint32_t)input[5] << 22) |
			((uint32_t)(input[6] & 0xfc) << 14);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 54 to 69
	value = ((uint32_t)(input[6] & 0x03) << 30) |
			((uint32_t)input[7] << 22) |
			((uint32_t)(input[8] & 0xfc) << 14);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 70 to 85
	value = ((uint32_t)(input[8] & 0x03) << 30) |
			((uint32_t)input[9] << 22) |
			((uint32_t)(input[10] & 0xfc) << 14);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 86 to 101
	value = ((uint32_t)(input[10] & 0x03) << 30) |
			((uint32_t)input[11] << 22) |
			((uint32_t)(input[12] & 0xfc) << 14);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 102 to 117
	value = ((uint32_t)(input[12] & 0x03) << 30) |
			((uint32_t)input[13] << 22) |
			((uint32_t)(input[14] & 0xfc) << 14);
	output[6] = (double)(value >> 16);
}

static void unpack_7_16bit_unsigned_6off(const uint8_t * input, double * output, void *closure) {
	// Unpack 7 values into output
	// Values are 16-bit unsigned
	// Skip 6 bits, read 112 bits of data.
	// Input must be at least 15 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 6 to 21
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)(input[2] & 0xfc) << 14);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 22 to 37
	value = ((uint32_t)(input[2] & 0x03) << 30) |
			((uint32_t)input[3] << 22) |
			((uint32_t)(input[4] & 0xfc) << 14);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 38 to 53
	value = ((uint32_t)(input[4] & 0x03) << 30) |
			((uint32_t)input[5] << 22) |
			((uint32_t)(input[6] & 0xfc) << 14);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 54 to 69
	value = ((uint32_t)(input[6] & 0x03) << 30) |
			((uint32_t)input[7] << 22) |
			((uint32_t)(input[8] & 0xfc) << 14);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 70 to 85
	value = ((uint32_t)(input[8] & 0x03) << 30) |
			((uint32_t)input[9] << 22) |
			((uint32_t)(input[10] & 0xfc) << 14);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 86 to 101
	value = ((uint32_t)(input[10] & 0x03) << 30) |
			((uint32_t)input[11] << 22) |
			((uint32_t)(input[12] & 0xfc) << 14);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 102 to 117
	value = ((uint32_t)(input[12] & 0x03) << 30) |
			((uint32_t)input[13] << 22) |
			((uint32_t)(input[14] & 0xfc) << 14);
	output[6] = (double)(value >> 16);
}

static void unpack_7_16bit_signed_7off(const uint8_t * input, double * output, void *closure) {
	// Unpack 7 values into output
	// Values are 16-bit signed
	// Skip 7 bits, read 112 bits of data.
	// Input must be at least 15 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 7 to 22
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)(input[2] & 0xfe) << 15);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 23 to 38
	value = ((uint32_t)(input[2] & 0x01) << 31) |
			((uint32_t)input[3] << 23) |
			((uint32_t)(input[4] & 0xfe) << 15);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 39 to 54
	value = ((uint32_t)(input[4] & 0x01) << 31) |
			((uint32_t)input[5] << 23) |
			((uint32_t)(input[6] & 0xfe) << 15);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 55 to 70
	value = ((uint32_t)(input[6] & 0x01) << 31) |
			((uint32_t)input[7] << 23) |
			((uint32_t)(input[8] & 0xfe) << 15);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 71 to 86
	value = ((uint32_t)(input[8] & 0x01) << 31) |
			((uint32_t)input[9] << 23) |
			((uint32_t)(input[10] & 0xfe) << 15);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 87 to 102
	value = ((uint32_t)(input[10] & 0x01) << 31) |
			((uint32_t)input[11] << 23) |
			((uint32_t)(input[12] & 0xfe) << 15);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 103 to 118
	value = ((uint32_t)(input[12] & 0x01) << 31) |
			((uint32_t)input[13] << 23) |
			((uint32_t)(input[14] & 0xfe) << 15);
	output[6] = (double)(value >> 16);
}

static void unpack_7_16bit_unsigned_7off(const uint8_t * input, double * output, void *closure) {
	// Unpack 7 values into output
	// Values are 16-bit unsigned
	// Skip 7 bits, read 112 bits of data.
	// Input must be at least 15 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 7 to 22
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)(input[2] & 0xfe) << 15);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 23 to 38
	value = ((uint32_t)(input[2] & 0x01) << 31) |
			((uint32_t)input[3] << 23) |
			((uint32_t)(input[4] & 0xfe) << 15);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 39 to 54
	value = ((uint32_t)(input[4] & 0x01) << 31) |
			((uint32_t)input[5] << 23) |
			((uint32_t)(input[6] & 0xfe) << 15);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 55 to 70
	value = ((uint32_t)(input[6] & 0x01) << 31) |
			((uint32_t)input[7] << 23) |
			((uint32_t)(input[8] & 0xfe) << 15);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 71 to 86
	value = ((uint32_t)(input[8] & 0x01) << 31) |
			((uint32_t)input[9] << 23) |
			((uint32_t)(input[10] & 0xfe) << 15);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 87 to 102
	value = ((uint32_t)(input[10] & 0x01) << 31) |
			((uint32_t)input[11] << 23) |
			((uint32_t)(input[12] & 0xfe) << 15);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 103 to 118
	value = ((uint32_t)(input[12] & 0x01) << 31) |
			((uint32_t)input[13] << 23) |
			((uint32_t)(input[14] & 0xfe) << 15);
	output[6] = (double)(value >> 16);
}

static void unpack_8_16bit_signed_0off(const uint8_t * input, double * output, void *closure) {
	// Unpack 8 values into output
	// Values are 16-bit signed
	// Skip 0 bits, read 128 bits of data.
	// Input must be at least 16 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 0 to 15
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)input[1] << 16);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 16 to 31
	value = ((uint32_t)input[2] << 24) |
			((uint32_t)input[3] << 16);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 32 to 47
	value = ((uint32_t)input[4] << 24) |
			((uint32_t)input[5] << 16);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 48 to 63
	value = ((uint32_t)input[6] << 24) |
			((uint32_t)input[7] << 16);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 64 to 79
	value = ((uint32_t)input[8] << 24) |
			((uint32_t)input[9] << 16);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 80 to 95
	value = ((uint32_t)input[10] << 24) |
			((uint32_t)input[11] << 16);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 96 to 111
	value = ((uint32_t)input[12] << 24) |
			((uint32_t)input[13] << 16);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 112 to 127
	value = ((uint32_t)input[14] << 24) |
			((uint32_t)input[15] << 16);
	output[7] = (double)(value >> 16);
}

static void unpack_8_16bit_unsigned_0off(const uint8_t * input, double * output, void *closure) {
	// Unpack 8 values into output
	// Values are 16-bit unsigned
	// Skip 0 bits, read 128 bits of data.
	// Input must be at least 16 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 0 to 15
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)input[1] << 16);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 16 to 31
	value = ((uint32_t)input[2] << 24) |
			((uint32_t)input[3] << 16);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 32 to 47
	value = ((uint32_t)input[4] << 24) |
			((uint32_t)input[5] << 16);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 48 to 63
	value = ((uint32_t)input[6] << 24) |
			((uint32_t)input[7] << 16);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 64 to 79
	value = ((uint32_t)input[8] << 24) |
			((uint32_t)input[9] << 16);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 80 to 95
	value = ((uint32_t)input[10] << 24) |
			((uint32_t)input[11] << 16);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 96 to 111
	value = ((uint32_t)input[12] << 24) |
			((uint32_t)input[13] << 16);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 112 to 127
	value = ((uint32_t)input[14] << 24) |
			((uint32_t)input[15] << 16);
	output[7] = (double)(value >> 16);
}

static void unpack_8_16bit_signed_1off(const uint8_t * input, double * output, void *closure) {
	// Unpack 8 values into output
	// Values are 16-bit signed
	// Skip 1 bits, read 128 bits of data.
	// Input must be at least 17 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 1 to 16
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)input[1] << 17) |
			((uint32_t)(input[2] & 0x80) << 9);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 17 to 32
	value = ((uint32_t)(input[2] & 0x7f) << 25) |
			((uint32_t)input[3] << 17) |
			((uint32_t)(input[4] & 0x80) << 9);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 33 to 48
	value = ((uint32_t)(input[4] & 0x7f) << 25) |
			((uint32_t)input[5] << 17) |
			((uint32_t)(input[6] & 0x80) << 9);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 49 to 64
	value = ((uint32_t)(input[6] & 0x7f) << 25) |
			((uint32_t)input[7] << 17) |
			((uint32_t)(input[8] & 0x80) << 9);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 65 to 80
	value = ((uint32_t)(input[8] & 0x7f) << 25) |
			((uint32_t)input[9] << 17) |
			((uint32_t)(input[10] & 0x80) << 9);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 81 to 96
	value = ((uint32_t)(input[10] & 0x7f) << 25) |
			((uint32_t)input[11] << 17) |
			((uint32_t)(input[12] & 0x80) << 9);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 97 to 112
	value = ((uint32_t)(input[12] & 0x7f) << 25) |
			((uint32_t)input[13] << 17) |
			((uint32_t)(input[14] & 0x80) << 9);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 113 to 128
	value = ((uint32_t)(input[14] & 0x7f) << 25) |
			((uint32_t)input[15] << 17) |
			((uint32_t)(input[16] & 0x80) << 9);
	output[7] = (double)(value >> 16);
}

static void unpack_8_16bit_unsigned_1off(const uint8_t * input, double * output, void *closure) {
	// Unpack 8 values into output
	// Values are 16-bit unsigned
	// Skip 1 bits, read 128 bits of data.
	// Input must be at least 17 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 1 to 16
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)input[1] << 17) |
			((uint32_t)(input[2] & 0x80) << 9);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 17 to 32
	value = ((uint32_t)(input[2] & 0x7f) << 25) |
			((uint32_t)input[3] << 17) |
			((uint32_t)(input[4] & 0x80) << 9);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 33 to 48
	value = ((uint32_t)(input[4] & 0x7f) << 25) |
			((uint32_t)input[5] << 17) |
			((uint32_t)(input[6] & 0x80) << 9);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 49 to 64
	value = ((uint32_t)(input[6] & 0x7f) << 25) |
			((uint32_t)input[7] << 17) |
			((uint32_t)(input[8] & 0x80) << 9);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 65 to 80
	value = ((uint32_t)(input[8] & 0x7f) << 25) |
			((uint32_t)input[9] << 17) |
			((uint32_t)(input[10] & 0x80) << 9);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 81 to 96
	value = ((uint32_t)(input[10] & 0x7f) << 25) |
			((uint32_t)input[11] << 17) |
			((uint32_t)(input[12] & 0x80) << 9);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 97 to 112
	value = ((uint32_t)(input[12] & 0x7f) << 25) |
			((uint32_t)input[13] << 17) |
			((uint32_t)(input[14] & 0x80) << 9);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 113 to 128
	value = ((uint32_t)(input[14] & 0x7f) << 25) |
			((uint32_t)input[15] << 17) |
			((uint32_t)(input[16] & 0x80) << 9);
	output[7] = (double)(value >> 16);
}

static void unpack_8_16bit_signed_2off(const uint8_t * input, double * output, void *closure) {
	// Unpack 8 values into output
	// Values are 16-bit signed
	// Skip 2 bits, read 128 bits of data.
	// Input must be at least 17 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 2 to 17
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)input[1] << 18) |
			((uint32_t)(input[2] & 0xc0) << 10);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 18 to 33
	value = ((uint32_t)(input[2] & 0x3f) << 26) |
			((uint32_t)input[3] << 18) |
			((uint32_t)(input[4] & 0xc0) << 10);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 34 to 49
	value = ((uint32_t)(input[4] & 0x3f) << 26) |
			((uint32_t)input[5] << 18) |
			((uint32_t)(input[6] & 0xc0) << 10);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 50 to 65
	value = ((uint32_t)(input[6] & 0x3f) << 26) |
			((uint32_t)input[7] << 18) |
			((uint32_t)(input[8] & 0xc0) << 10);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 66 to 81
	value = ((uint32_t)(input[8] & 0x3f) << 26) |
			((uint32_t)input[9] << 18) |
			((uint32_t)(input[10] & 0xc0) << 10);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 82 to 97
	value = ((uint32_t)(input[10] & 0x3f) << 26) |
			((uint32_t)input[11] << 18) |
			((uint32_t)(input[12] & 0xc0) << 10);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 98 to 113
	value = ((uint32_t)(input[12] & 0x3f) << 26) |
			((uint32_t)input[13] << 18) |
			((uint32_t)(input[14] & 0xc0) << 10);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 114 to 129
	value = ((uint32_t)(input[14] & 0x3f) << 26) |
			((uint32_t)input[15] << 18) |
			((uint32_t)(input[16] & 0xc0) << 10);
	output[7] = (double)(value >> 16);
}

static void unpack_8_16bit_unsigned_2off(const uint8_t * input, double * output, void *closure) {
	// Unpack 8 values into output
	// Values are 16-bit unsigned
	// Skip 2 bits, read 128 bits of data.
	// Input must be at least 17 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 2 to 17
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)input[1] << 18) |
			((uint32_t)(input[2] & 0xc0) << 10);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 18 to 33
	value = ((uint32_t)(input[2] & 0x3f) << 26) |
			((uint32_t)input[3] << 18) |
			((uint32_t)(input[4] & 0xc0) << 10);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 34 to 49
	value = ((uint32_t)(input[4] & 0x3f) << 26) |
			((uint32_t)input[5] << 18) |
			((uint32_t)(input[6] & 0xc0) << 10);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 50 to 65
	value = ((uint32_t)(input[6] & 0x3f) << 26) |
			((uint32_t)input[7] << 18) |
			((uint32_t)(input[8] & 0xc0) << 10);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 66 to 81
	value = ((uint32_t)(input[8] & 0x3f) << 26) |
			((uint32_t)input[9] << 18) |
			((uint32_t)(input[10] & 0xc0) << 10);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 82 to 97
	value = ((uint32_t)(input[10] & 0x3f) << 26) |
			((uint32_t)input[11] << 18) |
			((uint32_t)(input[12] & 0xc0) << 10);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 98 to 113
	value = ((uint32_t)(input[12] & 0x3f) << 26) |
			((uint32_t)input[13] << 18) |
			((uint32_t)(input[14] & 0xc0) << 10);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 114 to 129
	value = ((uint32_t)(input[14] & 0x3f) << 26) |
			((uint32_t)input[15] << 18) |
			((uint32_t)(input[16] & 0xc0) << 10);
	output[7] = (double)(value >> 16);
}

static void unpack_8_16bit_signed_3off(const uint8_t * input, double * output, void *closure) {
	// Unpack 8 values into output
	// Values are 16-bit signed
	// Skip 3 bits, read 128 bits of data.
	// Input must be at least 17 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 3 to 18
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)input[1] << 19) |
			((uint32_t)(input[2] & 0xe0) << 11);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 19 to 34
	value = ((uint32_t)(input[2] & 0x1f) << 27) |
			((uint32_t)input[3] << 19) |
			((uint32_t)(input[4] & 0xe0) << 11);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 35 to 50
	value = ((uint32_t)(input[4] & 0x1f) << 27) |
			((uint32_t)input[5] << 19) |
			((uint32_t)(input[6] & 0xe0) << 11);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 51 to 66
	value = ((uint32_t)(input[6] & 0x1f) << 27) |
			((uint32_t)input[7] << 19) |
			((uint32_t)(input[8] & 0xe0) << 11);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 67 to 82
	value = ((uint32_t)(input[8] & 0x1f) << 27) |
			((uint32_t)input[9] << 19) |
			((uint32_t)(input[10] & 0xe0) << 11);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 83 to 98
	value = ((uint32_t)(input[10] & 0x1f) << 27) |
			((uint32_t)input[11] << 19) |
			((uint32_t)(input[12] & 0xe0) << 11);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 99 to 114
	value = ((uint32_t)(input[12] & 0x1f) << 27) |
			((uint32_t)input[13] << 19) |
			((uint32_t)(input[14] & 0xe0) << 11);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 115 to 130
	value = ((uint32_t)(input[14] & 0x1f) << 27) |
			((uint32_t)input[15] << 19) |
			((uint32_t)(input[16] & 0xe0) << 11);
	output[7] = (double)(value >> 16);
}

static void unpack_8_16bit_unsigned_3off(const uint8_t * input, double * output, void *closure) {
	// Unpack 8 values into output
	// Values are 16-bit unsigned
	// Skip 3 bits, read 128 bits of data.
	// Input must be at least 17 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 3 to 18
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)input[1] << 19) |
			((uint32_t)(input[2] & 0xe0) << 11);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 19 to 34
	value = ((uint32_t)(input[2] & 0x1f) << 27) |
			((uint32_t)input[3] << 19) |
			((uint32_t)(input[4] & 0xe0) << 11);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 35 to 50
	value = ((uint32_t)(input[4] & 0x1f) << 27) |
			((uint32_t)input[5] << 19) |
			((uint32_t)(input[6] & 0xe0) << 11);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 51 to 66
	value = ((uint32_t)(input[6] & 0x1f) << 27) |
			((uint32_t)input[7] << 19) |
			((uint32_t)(input[8] & 0xe0) << 11);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 67 to 82
	value = ((uint32_t)(input[8] & 0x1f) << 27) |
			((uint32_t)input[9] << 19) |
			((uint32_t)(input[10] & 0xe0) << 11);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 83 to 98
	value = ((uint32_t)(input[10] & 0x1f) << 27) |
			((uint32_t)input[11] << 19) |
			((uint32_t)(input[12] & 0xe0) << 11);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 99 to 114
	value = ((uint32_t)(input[12] & 0x1f) << 27) |
			((uint32_t)input[13] << 19) |
			((uint32_t)(input[14] & 0xe0) << 11);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 115 to 130
	value = ((uint32_t)(input[14] & 0x1f) << 27) |
			((uint32_t)input[15] << 19) |
			((uint32_t)(input[16] & 0xe0) << 11);
	output[7] = (double)(value >> 16);
}

static void unpack_8_16bit_signed_4off(const uint8_t * input, double * output, void *closure) {
	// Unpack 8 values into output
	// Values are 16-bit signed
	// Skip 4 bits, read 128 bits of data.
	// Input must be at least 17 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 4 to 19
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20) |
			((uint32_t)(input[2] & 0xf0) << 12);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 20 to 35
	value = ((uint32_t)(input[2] & 0x0f) << 28) |
			((uint32_t)input[3] << 20) |
			((uint32_t)(input[4] & 0xf0) << 12);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 36 to 51
	value = ((uint32_t)(input[4] & 0x0f) << 28) |
			((uint32_t)input[5] << 20) |
			((uint32_t)(input[6] & 0xf0) << 12);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 52 to 67
	value = ((uint32_t)(input[6] & 0x0f) << 28) |
			((uint32_t)input[7] << 20) |
			((uint32_t)(input[8] & 0xf0) << 12);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 68 to 83
	value = ((uint32_t)(input[8] & 0x0f) << 28) |
			((uint32_t)input[9] << 20) |
			((uint32_t)(input[10] & 0xf0) << 12);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 84 to 99
	value = ((uint32_t)(input[10] & 0x0f) << 28) |
			((uint32_t)input[11] << 20) |
			((uint32_t)(input[12] & 0xf0) << 12);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 100 to 115
	value = ((uint32_t)(input[12] & 0x0f) << 28) |
			((uint32_t)input[13] << 20) |
			((uint32_t)(input[14] & 0xf0) << 12);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 116 to 131
	value = ((uint32_t)(input[14] & 0x0f) << 28) |
			((uint32_t)input[15] << 20) |
			((uint32_t)(input[16] & 0xf0) << 12);
	output[7] = (double)(value >> 16);
}

static void unpack_8_16bit_unsigned_4off(const uint8_t * input, double * output, void *closure) {
	// Unpack 8 values into output
	// Values are 16-bit unsigned
	// Skip 4 bits, read 128 bits of data.
	// Input must be at least 17 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 4 to 19
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20) |
			((uint32_t)(input[2] & 0xf0) << 12);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 20 to 35
	value = ((uint32_t)(input[2] & 0x0f) << 28) |
			((uint32_t)input[3] << 20) |
			((uint32_t)(input[4] & 0xf0) << 12);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 36 to 51
	value = ((uint32_t)(input[4] & 0x0f) << 28) |
			((uint32_t)input[5] << 20) |
			((uint32_t)(input[6] & 0xf0) << 12);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 52 to 67
	value = ((uint32_t)(input[6] & 0x0f) << 28) |
			((uint32_t)input[7] << 20) |
			((uint32_t)(input[8] & 0xf0) << 12);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 68 to 83
	value = ((uint32_t)(input[8] & 0x0f) << 28) |
			((uint32_t)input[9] << 20) |
			((uint32_t)(input[10] & 0xf0) << 12);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 84 to 99
	value = ((uint32_t)(input[10] & 0x0f) << 28) |
			((uint32_t)input[11] << 20) |
			((uint32_t)(input[12] & 0xf0) << 12);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 100 to 115
	value = ((uint32_t)(input[12] & 0x0f) << 28) |
			((uint32_t)input[13] << 20) |
			((uint32_t)(input[14] & 0xf0) << 12);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 116 to 131
	value = ((uint32_t)(input[14] & 0x0f) << 28) |
			((uint32_t)input[15] << 20) |
			((uint32_t)(input[16] & 0xf0) << 12);
	output[7] = (double)(value >> 16);
}

static void unpack_8_16bit_signed_5off(const uint8_t * input, double * output, void *closure) {
	// Unpack 8 values into output
	// Values are 16-bit signed
	// Skip 5 bits, read 128 bits of data.
	// Input must be at least 17 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 5 to 20
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)(input[2] & 0xf8) << 13);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 21 to 36
	value = ((uint32_t)(input[2] & 0x07) << 29) |
			((uint32_t)input[3] << 21) |
			((uint32_t)(input[4] & 0xf8) << 13);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 37 to 52
	value = ((uint32_t)(input[4] & 0x07) << 29) |
			((uint32_t)input[5] << 21) |
			((uint32_t)(input[6] & 0xf8) << 13);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 53 to 68
	value = ((uint32_t)(input[6] & 0x07) << 29) |
			((uint32_t)input[7] << 21) |
			((uint32_t)(input[8] & 0xf8) << 13);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 69 to 84
	value = ((uint32_t)(input[8] & 0x07) << 29) |
			((uint32_t)input[9] << 21) |
			((uint32_t)(input[10] & 0xf8) << 13);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 85 to 100
	value = ((uint32_t)(input[10] & 0x07) << 29) |
			((uint32_t)input[11] << 21) |
			((uint32_t)(input[12] & 0xf8) << 13);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 101 to 116
	value = ((uint32_t)(input[12] & 0x07) << 29) |
			((uint32_t)input[13] << 21) |
			((uint32_t)(input[14] & 0xf8) << 13);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 117 to 132
	value = ((uint32_t)(input[14] & 0x07) << 29) |
			((uint32_t)input[15] << 21) |
			((uint32_t)(input[16] & 0xf8) << 13);
	output[7] = (double)(value >> 16);
}

static void unpack_8_16bit_unsigned_5off(const uint8_t * input, double * output, void *closure) {
	// Unpack 8 values into output
	// Values are 16-bit unsigned
	// Skip 5 bits, read 128 bits of data.
	// Input must be at least 17 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 5 to 20
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)(input[2] & 0xf8) << 13);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 21 to 36
	value = ((uint32_t)(input[2] & 0x07) << 29) |
			((uint32_t)input[3] << 21) |
			((uint32_t)(input[4] & 0xf8) << 13);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 37 to 52
	value = ((uint32_t)(input[4] & 0x07) << 29) |
			((uint32_t)input[5] << 21) |
			((uint32_t)(input[6] & 0xf8) << 13);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 53 to 68
	value = ((uint32_t)(input[6] & 0x07) << 29) |
			((uint32_t)input[7] << 21) |
			((uint32_t)(input[8] & 0xf8) << 13);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 69 to 84
	value = ((uint32_t)(input[8] & 0x07) << 29) |
			((uint32_t)input[9] << 21) |
			((uint32_t)(input[10] & 0xf8) << 13);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 85 to 100
	value = ((uint32_t)(input[10] & 0x07) << 29) |
			((uint32_t)input[11] << 21) |
			((uint32_t)(input[12] & 0xf8) << 13);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 101 to 116
	value = ((uint32_t)(input[12] & 0x07) << 29) |
			((uint32_t)input[13] << 21) |
			((uint32_t)(input[14] & 0xf8) << 13);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 117 to 132
	value = ((uint32_t)(input[14] & 0x07) << 29) |
			((uint32_t)input[15] << 21) |
			((uint32_t)(input[16] & 0xf8) << 13);
	output[7] = (double)(value >> 16);
}

static void unpack_8_16bit_signed_6off(const uint8_t * input, double * output, void *closure) {
	// Unpack 8 values into output
	// Values are 16-bit signed
	// Skip 6 bits, read 128 bits of data.
	// Input must be at least 17 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 6 to 21
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)(input[2] & 0xfc) << 14);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 22 to 37
	value = ((uint32_t)(input[2] & 0x03) << 30) |
			((uint32_t)input[3] << 22) |
			((uint32_t)(input[4] & 0xfc) << 14);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 38 to 53
	value = ((uint32_t)(input[4] & 0x03) << 30) |
			((uint32_t)input[5] << 22) |
			((uint32_t)(input[6] & 0xfc) << 14);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 54 to 69
	value = ((uint32_t)(input[6] & 0x03) << 30) |
			((uint32_t)input[7] << 22) |
			((uint32_t)(input[8] & 0xfc) << 14);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 70 to 85
	value = ((uint32_t)(input[8] & 0x03) << 30) |
			((uint32_t)input[9] << 22) |
			((uint32_t)(input[10] & 0xfc) << 14);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 86 to 101
	value = ((uint32_t)(input[10] & 0x03) << 30) |
			((uint32_t)input[11] << 22) |
			((uint32_t)(input[12] & 0xfc) << 14);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 102 to 117
	value = ((uint32_t)(input[12] & 0x03) << 30) |
			((uint32_t)input[13] << 22) |
			((uint32_t)(input[14] & 0xfc) << 14);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 118 to 133
	value = ((uint32_t)(input[14] & 0x03) << 30) |
			((uint32_t)input[15] << 22) |
			((uint32_t)(input[16] & 0xfc) << 14);
	output[7] = (double)(value >> 16);
}

static void unpack_8_16bit_unsigned_6off(const uint8_t * input, double * output, void *closure) {
	// Unpack 8 values into output
	// Values are 16-bit unsigned
	// Skip 6 bits, read 128 bits of data.
	// Input must be at least 17 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 6 to 21
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)(input[2] & 0xfc) << 14);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 22 to 37
	value = ((uint32_t)(input[2] & 0x03) << 30) |
			((uint32_t)input[3] << 22) |
			((uint32_t)(input[4] & 0xfc) << 14);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 38 to 53
	value = ((uint32_t)(input[4] & 0x03) << 30) |
			((uint32_t)input[5] << 22) |
			((uint32_t)(input[6] & 0xfc) << 14);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 54 to 69
	value = ((uint32_t)(input[6] & 0x03) << 30) |
			((uint32_t)input[7] << 22) |
			((uint32_t)(input[8] & 0xfc) << 14);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 70 to 85
	value = ((uint32_t)(input[8] & 0x03) << 30) |
			((uint32_t)input[9] << 22) |
			((uint32_t)(input[10] & 0xfc) << 14);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 86 to 101
	value = ((uint32_t)(input[10] & 0x03) << 30) |
			((uint32_t)input[11] << 22) |
			((uint32_t)(input[12] & 0xfc) << 14);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 102 to 117
	value = ((uint32_t)(input[12] & 0x03) << 30) |
			((uint32_t)input[13] << 22) |
			((uint32_t)(input[14] & 0xfc) << 14);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 118 to 133
	value = ((uint32_t)(input[14] & 0x03) << 30) |
			((uint32_t)input[15] << 22) |
			((uint32_t)(input[16] & 0xfc) << 14);
	output[7] = (double)(value >> 16);
}

static void unpack_8_16bit_signed_7off(const uint8_t * input, double * output, void *closure) {
	// Unpack 8 values into output
	// Values are 16-bit signed
	// Skip 7 bits, read 128 bits of data.
	// Input must be at least 17 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 7 to 22
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)(input[2] & 0xfe) << 15);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 23 to 38
	value = ((uint32_t)(input[2] & 0x01) << 31) |
			((uint32_t)input[3] << 23) |
			((uint32_t)(input[4] & 0xfe) << 15);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 39 to 54
	value = ((uint32_t)(input[4] & 0x01) << 31) |
			((uint32_t)input[5] << 23) |
			((uint32_t)(input[6] & 0xfe) << 15);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 55 to 70
	value = ((uint32_t)(input[6] & 0x01) << 31) |
			((uint32_t)input[7] << 23) |
			((uint32_t)(input[8] & 0xfe) << 15);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 71 to 86
	value = ((uint32_t)(input[8] & 0x01) << 31) |
			((uint32_t)input[9] << 23) |
			((uint32_t)(input[10] & 0xfe) << 15);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 87 to 102
	value = ((uint32_t)(input[10] & 0x01) << 31) |
			((uint32_t)input[11] << 23) |
			((uint32_t)(input[12] & 0xfe) << 15);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 103 to 118
	value = ((uint32_t)(input[12] & 0x01) << 31) |
			((uint32_t)input[13] << 23) |
			((uint32_t)(input[14] & 0xfe) << 15);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 119 to 134
	value = ((uint32_t)(input[14] & 0x01) << 31) |
			((uint32_t)input[15] << 23) |
			((uint32_t)(input[16] & 0xfe) << 15);
	output[7] = (double)(value >> 16);
}

static void unpack_8_16bit_unsigned_7off(const uint8_t * input, double * output, void *closure) {
	// Unpack 8 values into output
	// Values are 16-bit unsigned
	// Skip 7 bits, read 128 bits of data.
	// Input must be at least 17 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 7 to 22
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)(input[2] & 0xfe) << 15);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 23 to 38
	value = ((uint32_t)(input[2] & 0x01) << 31) |
			((uint32_t)input[3] << 23) |
			((uint32_t)(input[4] & 0xfe) << 15);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 39 to 54
	value = ((uint32_t)(input[4] & 0x01) << 31) |
			((uint32_t)input[5] << 23) |
			((uint32_t)(input[6] & 0xfe) << 15);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 55 to 70
	value = ((uint32_t)(input[6] & 0x01) << 31) |
			((uint32_t)input[7] << 23) |
			((uint32_t)(input[8] & 0xfe) << 15);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 71 to 86
	value = ((uint32_t)(input[8] & 0x01) << 31) |
			((uint32_t)input[9] << 23) |
			((uint32_t)(input[10] & 0xfe) << 15);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 87 to 102
	value = ((uint32_t)(input[10] & 0x01) << 31) |
			((uint32_t)input[11] << 23) |
			((uint32_t)(input[12] & 0xfe) << 15);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 103 to 118
	value = ((uint32_t)(input[12] & 0x01) << 31) |
			((uint32_t)input[13] << 23) |
			((uint32_t)(input[14] & 0xfe) << 15);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 119 to 134
	value = ((uint32_t)(input[14] & 0x01) << 31) |
			((uint32_t)input[15] << 23) |
			((uint32_t)(input[16] & 0xfe) << 15);
	output[7] = (double)(value >> 16);
}

static void unpack_9_16bit_signed_0off(const uint8_t * input, double * output, void *closure) {
	// Unpack 9 values into output
	// Values are 16-bit signed
	// Skip 0 bits, read 144 bits of data.
	// Input must be at least 18 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 0 to 15
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)input[1] << 16);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 16 to 31
	value = ((uint32_t)input[2] << 24) |
			((uint32_t)input[3] << 16);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 32 to 47
	value = ((uint32_t)input[4] << 24) |
			((uint32_t)input[5] << 16);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 48 to 63
	value = ((uint32_t)input[6] << 24) |
			((uint32_t)input[7] << 16);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 64 to 79
	value = ((uint32_t)input[8] << 24) |
			((uint32_t)input[9] << 16);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 80 to 95
	value = ((uint32_t)input[10] << 24) |
			((uint32_t)input[11] << 16);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 96 to 111
	value = ((uint32_t)input[12] << 24) |
			((uint32_t)input[13] << 16);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 112 to 127
	value = ((uint32_t)input[14] << 24) |
			((uint32_t)input[15] << 16);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 128 to 143
	value = ((uint32_t)input[16] << 24) |
			((uint32_t)input[17] << 16);
	output[8] = (double)(value >> 16);
}

static void unpack_9_16bit_unsigned_0off(const uint8_t * input, double * output, void *closure) {
	// Unpack 9 values into output
	// Values are 16-bit unsigned
	// Skip 0 bits, read 144 bits of data.
	// Input must be at least 18 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 0 to 15
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)input[1] << 16);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 16 to 31
	value = ((uint32_t)input[2] << 24) |
			((uint32_t)input[3] << 16);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 32 to 47
	value = ((uint32_t)input[4] << 24) |
			((uint32_t)input[5] << 16);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 48 to 63
	value = ((uint32_t)input[6] << 24) |
			((uint32_t)input[7] << 16);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 64 to 79
	value = ((uint32_t)input[8] << 24) |
			((uint32_t)input[9] << 16);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 80 to 95
	value = ((uint32_t)input[10] << 24) |
			((uint32_t)input[11] << 16);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 96 to 111
	value = ((uint32_t)input[12] << 24) |
			((uint32_t)input[13] << 16);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 112 to 127
	value = ((uint32_t)input[14] << 24) |
			((uint32_t)input[15] << 16);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 128 to 143
	value = ((uint32_t)input[16] << 24) |
			((uint32_t)input[17] << 16);
	output[8] = (double)(value >> 16);
}

static void unpack_9_16bit_signed_1off(const uint8_t * input, double * output, void *closure) {
	// Unpack 9 values into output
	// Values are 16-bit signed
	// Skip 1 bits, read 144 bits of data.
	// Input must be at least 19 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 1 to 16
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)input[1] << 17) |
			((uint32_t)(input[2] & 0x80) << 9);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 17 to 32
	value = ((uint32_t)(input[2] & 0x7f) << 25) |
			((uint32_t)input[3] << 17) |
			((uint32_t)(input[4] & 0x80) << 9);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 33 to 48
	value = ((uint32_t)(input[4] & 0x7f) << 25) |
			((uint32_t)input[5] << 17) |
			((uint32_t)(input[6] & 0x80) << 9);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 49 to 64
	value = ((uint32_t)(input[6] & 0x7f) << 25) |
			((uint32_t)input[7] << 17) |
			((uint32_t)(input[8] & 0x80) << 9);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 65 to 80
	value = ((uint32_t)(input[8] & 0x7f) << 25) |
			((uint32_t)input[9] << 17) |
			((uint32_t)(input[10] & 0x80) << 9);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 81 to 96
	value = ((uint32_t)(input[10] & 0x7f) << 25) |
			((uint32_t)input[11] << 17) |
			((uint32_t)(input[12] & 0x80) << 9);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 97 to 112
	value = ((uint32_t)(input[12] & 0x7f) << 25) |
			((uint32_t)input[13] << 17) |
			((uint32_t)(input[14] & 0x80) << 9);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 113 to 128
	value = ((uint32_t)(input[14] & 0x7f) << 25) |
			((uint32_t)input[15] << 17) |
			((uint32_t)(input[16] & 0x80) << 9);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 129 to 144
	value = ((uint32_t)(input[16] & 0x7f) << 25) |
			((uint32_t)input[17] << 17) |
			((uint32_t)(input[18] & 0x80) << 9);
	output[8] = (double)(value >> 16);
}

static void unpack_9_16bit_unsigned_1off(const uint8_t * input, double * output, void *closure) {
	// Unpack 9 values into output
	// Values are 16-bit unsigned
	// Skip 1 bits, read 144 bits of data.
	// Input must be at least 19 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 1 to 16
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)input[1] << 17) |
			((uint32_t)(input[2] & 0x80) << 9);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 17 to 32
	value = ((uint32_t)(input[2] & 0x7f) << 25) |
			((uint32_t)input[3] << 17) |
			((uint32_t)(input[4] & 0x80) << 9);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 33 to 48
	value = ((uint32_t)(input[4] & 0x7f) << 25) |
			((uint32_t)input[5] << 17) |
			((uint32_t)(input[6] & 0x80) << 9);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 49 to 64
	value = ((uint32_t)(input[6] & 0x7f) << 25) |
			((uint32_t)input[7] << 17) |
			((uint32_t)(input[8] & 0x80) << 9);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 65 to 80
	value = ((uint32_t)(input[8] & 0x7f) << 25) |
			((uint32_t)input[9] << 17) |
			((uint32_t)(input[10] & 0x80) << 9);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 81 to 96
	value = ((uint32_t)(input[10] & 0x7f) << 25) |
			((uint32_t)input[11] << 17) |
			((uint32_t)(input[12] & 0x80) << 9);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 97 to 112
	value = ((uint32_t)(input[12] & 0x7f) << 25) |
			((uint32_t)input[13] << 17) |
			((uint32_t)(input[14] & 0x80) << 9);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 113 to 128
	value = ((uint32_t)(input[14] & 0x7f) << 25) |
			((uint32_t)input[15] << 17) |
			((uint32_t)(input[16] & 0x80) << 9);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 129 to 144
	value = ((uint32_t)(input[16] & 0x7f) << 25) |
			((uint32_t)input[17] << 17) |
			((uint32_t)(input[18] & 0x80) << 9);
	output[8] = (double)(value >> 16);
}

static void unpack_9_16bit_signed_2off(const uint8_t * input, double * output, void *closure) {
	// Unpack 9 values into output
	// Values are 16-bit signed
	// Skip 2 bits, read 144 bits of data.
	// Input must be at least 19 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 2 to 17
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)input[1] << 18) |
			((uint32_t)(input[2] & 0xc0) << 10);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 18 to 33
	value = ((uint32_t)(input[2] & 0x3f) << 26) |
			((uint32_t)input[3] << 18) |
			((uint32_t)(input[4] & 0xc0) << 10);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 34 to 49
	value = ((uint32_t)(input[4] & 0x3f) << 26) |
			((uint32_t)input[5] << 18) |
			((uint32_t)(input[6] & 0xc0) << 10);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 50 to 65
	value = ((uint32_t)(input[6] & 0x3f) << 26) |
			((uint32_t)input[7] << 18) |
			((uint32_t)(input[8] & 0xc0) << 10);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 66 to 81
	value = ((uint32_t)(input[8] & 0x3f) << 26) |
			((uint32_t)input[9] << 18) |
			((uint32_t)(input[10] & 0xc0) << 10);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 82 to 97
	value = ((uint32_t)(input[10] & 0x3f) << 26) |
			((uint32_t)input[11] << 18) |
			((uint32_t)(input[12] & 0xc0) << 10);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 98 to 113
	value = ((uint32_t)(input[12] & 0x3f) << 26) |
			((uint32_t)input[13] << 18) |
			((uint32_t)(input[14] & 0xc0) << 10);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 114 to 129
	value = ((uint32_t)(input[14] & 0x3f) << 26) |
			((uint32_t)input[15] << 18) |
			((uint32_t)(input[16] & 0xc0) << 10);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 130 to 145
	value = ((uint32_t)(input[16] & 0x3f) << 26) |
			((uint32_t)input[17] << 18) |
			((uint32_t)(input[18] & 0xc0) << 10);
	output[8] = (double)(value >> 16);
}

static void unpack_9_16bit_unsigned_2off(const uint8_t * input, double * output, void *closure) {
	// Unpack 9 values into output
	// Values are 16-bit unsigned
	// Skip 2 bits, read 144 bits of data.
	// Input must be at least 19 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 2 to 17
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)input[1] << 18) |
			((uint32_t)(input[2] & 0xc0) << 10);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 18 to 33
	value = ((uint32_t)(input[2] & 0x3f) << 26) |
			((uint32_t)input[3] << 18) |
			((uint32_t)(input[4] & 0xc0) << 10);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 34 to 49
	value = ((uint32_t)(input[4] & 0x3f) << 26) |
			((uint32_t)input[5] << 18) |
			((uint32_t)(input[6] & 0xc0) << 10);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 50 to 65
	value = ((uint32_t)(input[6] & 0x3f) << 26) |
			((uint32_t)input[7] << 18) |
			((uint32_t)(input[8] & 0xc0) << 10);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 66 to 81
	value = ((uint32_t)(input[8] & 0x3f) << 26) |
			((uint32_t)input[9] << 18) |
			((uint32_t)(input[10] & 0xc0) << 10);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 82 to 97
	value = ((uint32_t)(input[10] & 0x3f) << 26) |
			((uint32_t)input[11] << 18) |
			((uint32_t)(input[12] & 0xc0) << 10);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 98 to 113
	value = ((uint32_t)(input[12] & 0x3f) << 26) |
			((uint32_t)input[13] << 18) |
			((uint32_t)(input[14] & 0xc0) << 10);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 114 to 129
	value = ((uint32_t)(input[14] & 0x3f) << 26) |
			((uint32_t)input[15] << 18) |
			((uint32_t)(input[16] & 0xc0) << 10);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 130 to 145
	value = ((uint32_t)(input[16] & 0x3f) << 26) |
			((uint32_t)input[17] << 18) |
			((uint32_t)(input[18] & 0xc0) << 10);
	output[8] = (double)(value >> 16);
}

static void unpack_9_16bit_signed_3off(const uint8_t * input, double * output, void *closure) {
	// Unpack 9 values into output
	// Values are 16-bit signed
	// Skip 3 bits, read 144 bits of data.
	// Input must be at least 19 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 3 to 18
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)input[1] << 19) |
			((uint32_t)(input[2] & 0xe0) << 11);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 19 to 34
	value = ((uint32_t)(input[2] & 0x1f) << 27) |
			((uint32_t)input[3] << 19) |
			((uint32_t)(input[4] & 0xe0) << 11);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 35 to 50
	value = ((uint32_t)(input[4] & 0x1f) << 27) |
			((uint32_t)input[5] << 19) |
			((uint32_t)(input[6] & 0xe0) << 11);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 51 to 66
	value = ((uint32_t)(input[6] & 0x1f) << 27) |
			((uint32_t)input[7] << 19) |
			((uint32_t)(input[8] & 0xe0) << 11);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 67 to 82
	value = ((uint32_t)(input[8] & 0x1f) << 27) |
			((uint32_t)input[9] << 19) |
			((uint32_t)(input[10] & 0xe0) << 11);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 83 to 98
	value = ((uint32_t)(input[10] & 0x1f) << 27) |
			((uint32_t)input[11] << 19) |
			((uint32_t)(input[12] & 0xe0) << 11);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 99 to 114
	value = ((uint32_t)(input[12] & 0x1f) << 27) |
			((uint32_t)input[13] << 19) |
			((uint32_t)(input[14] & 0xe0) << 11);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 115 to 130
	value = ((uint32_t)(input[14] & 0x1f) << 27) |
			((uint32_t)input[15] << 19) |
			((uint32_t)(input[16] & 0xe0) << 11);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 131 to 146
	value = ((uint32_t)(input[16] & 0x1f) << 27) |
			((uint32_t)input[17] << 19) |
			((uint32_t)(input[18] & 0xe0) << 11);
	output[8] = (double)(value >> 16);
}

static void unpack_9_16bit_unsigned_3off(const uint8_t * input, double * output, void *closure) {
	// Unpack 9 values into output
	// Values are 16-bit unsigned
	// Skip 3 bits, read 144 bits of data.
	// Input must be at least 19 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 3 to 18
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)input[1] << 19) |
			((uint32_t)(input[2] & 0xe0) << 11);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 19 to 34
	value = ((uint32_t)(input[2] & 0x1f) << 27) |
			((uint32_t)input[3] << 19) |
			((uint32_t)(input[4] & 0xe0) << 11);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 35 to 50
	value = ((uint32_t)(input[4] & 0x1f) << 27) |
			((uint32_t)input[5] << 19) |
			((uint32_t)(input[6] & 0xe0) << 11);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 51 to 66
	value = ((uint32_t)(input[6] & 0x1f) << 27) |
			((uint32_t)input[7] << 19) |
			((uint32_t)(input[8] & 0xe0) << 11);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 67 to 82
	value = ((uint32_t)(input[8] & 0x1f) << 27) |
			((uint32_t)input[9] << 19) |
			((uint32_t)(input[10] & 0xe0) << 11);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 83 to 98
	value = ((uint32_t)(input[10] & 0x1f) << 27) |
			((uint32_t)input[11] << 19) |
			((uint32_t)(input[12] & 0xe0) << 11);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 99 to 114
	value = ((uint32_t)(input[12] & 0x1f) << 27) |
			((uint32_t)input[13] << 19) |
			((uint32_t)(input[14] & 0xe0) << 11);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 115 to 130
	value = ((uint32_t)(input[14] & 0x1f) << 27) |
			((uint32_t)input[15] << 19) |
			((uint32_t)(input[16] & 0xe0) << 11);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 131 to 146
	value = ((uint32_t)(input[16] & 0x1f) << 27) |
			((uint32_t)input[17] << 19) |
			((uint32_t)(input[18] & 0xe0) << 11);
	output[8] = (double)(value >> 16);
}

static void unpack_9_16bit_signed_4off(const uint8_t * input, double * output, void *closure) {
	// Unpack 9 values into output
	// Values are 16-bit signed
	// Skip 4 bits, read 144 bits of data.
	// Input must be at least 19 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 4 to 19
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20) |
			((uint32_t)(input[2] & 0xf0) << 12);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 20 to 35
	value = ((uint32_t)(input[2] & 0x0f) << 28) |
			((uint32_t)input[3] << 20) |
			((uint32_t)(input[4] & 0xf0) << 12);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 36 to 51
	value = ((uint32_t)(input[4] & 0x0f) << 28) |
			((uint32_t)input[5] << 20) |
			((uint32_t)(input[6] & 0xf0) << 12);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 52 to 67
	value = ((uint32_t)(input[6] & 0x0f) << 28) |
			((uint32_t)input[7] << 20) |
			((uint32_t)(input[8] & 0xf0) << 12);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 68 to 83
	value = ((uint32_t)(input[8] & 0x0f) << 28) |
			((uint32_t)input[9] << 20) |
			((uint32_t)(input[10] & 0xf0) << 12);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 84 to 99
	value = ((uint32_t)(input[10] & 0x0f) << 28) |
			((uint32_t)input[11] << 20) |
			((uint32_t)(input[12] & 0xf0) << 12);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 100 to 115
	value = ((uint32_t)(input[12] & 0x0f) << 28) |
			((uint32_t)input[13] << 20) |
			((uint32_t)(input[14] & 0xf0) << 12);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 116 to 131
	value = ((uint32_t)(input[14] & 0x0f) << 28) |
			((uint32_t)input[15] << 20) |
			((uint32_t)(input[16] & 0xf0) << 12);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 132 to 147
	value = ((uint32_t)(input[16] & 0x0f) << 28) |
			((uint32_t)input[17] << 20) |
			((uint32_t)(input[18] & 0xf0) << 12);
	output[8] = (double)(value >> 16);
}

static void unpack_9_16bit_unsigned_4off(const uint8_t * input, double * output, void *closure) {
	// Unpack 9 values into output
	// Values are 16-bit unsigned
	// Skip 4 bits, read 144 bits of data.
	// Input must be at least 19 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 4 to 19
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20) |
			((uint32_t)(input[2] & 0xf0) << 12);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 20 to 35
	value = ((uint32_t)(input[2] & 0x0f) << 28) |
			((uint32_t)input[3] << 20) |
			((uint32_t)(input[4] & 0xf0) << 12);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 36 to 51
	value = ((uint32_t)(input[4] & 0x0f) << 28) |
			((uint32_t)input[5] << 20) |
			((uint32_t)(input[6] & 0xf0) << 12);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 52 to 67
	value = ((uint32_t)(input[6] & 0x0f) << 28) |
			((uint32_t)input[7] << 20) |
			((uint32_t)(input[8] & 0xf0) << 12);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 68 to 83
	value = ((uint32_t)(input[8] & 0x0f) << 28) |
			((uint32_t)input[9] << 20) |
			((uint32_t)(input[10] & 0xf0) << 12);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 84 to 99
	value = ((uint32_t)(input[10] & 0x0f) << 28) |
			((uint32_t)input[11] << 20) |
			((uint32_t)(input[12] & 0xf0) << 12);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 100 to 115
	value = ((uint32_t)(input[12] & 0x0f) << 28) |
			((uint32_t)input[13] << 20) |
			((uint32_t)(input[14] & 0xf0) << 12);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 116 to 131
	value = ((uint32_t)(input[14] & 0x0f) << 28) |
			((uint32_t)input[15] << 20) |
			((uint32_t)(input[16] & 0xf0) << 12);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 132 to 147
	value = ((uint32_t)(input[16] & 0x0f) << 28) |
			((uint32_t)input[17] << 20) |
			((uint32_t)(input[18] & 0xf0) << 12);
	output[8] = (double)(value >> 16);
}

static void unpack_9_16bit_signed_5off(const uint8_t * input, double * output, void *closure) {
	// Unpack 9 values into output
	// Values are 16-bit signed
	// Skip 5 bits, read 144 bits of data.
	// Input must be at least 19 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 5 to 20
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)(input[2] & 0xf8) << 13);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 21 to 36
	value = ((uint32_t)(input[2] & 0x07) << 29) |
			((uint32_t)input[3] << 21) |
			((uint32_t)(input[4] & 0xf8) << 13);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 37 to 52
	value = ((uint32_t)(input[4] & 0x07) << 29) |
			((uint32_t)input[5] << 21) |
			((uint32_t)(input[6] & 0xf8) << 13);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 53 to 68
	value = ((uint32_t)(input[6] & 0x07) << 29) |
			((uint32_t)input[7] << 21) |
			((uint32_t)(input[8] & 0xf8) << 13);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 69 to 84
	value = ((uint32_t)(input[8] & 0x07) << 29) |
			((uint32_t)input[9] << 21) |
			((uint32_t)(input[10] & 0xf8) << 13);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 85 to 100
	value = ((uint32_t)(input[10] & 0x07) << 29) |
			((uint32_t)input[11] << 21) |
			((uint32_t)(input[12] & 0xf8) << 13);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 101 to 116
	value = ((uint32_t)(input[12] & 0x07) << 29) |
			((uint32_t)input[13] << 21) |
			((uint32_t)(input[14] & 0xf8) << 13);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 117 to 132
	value = ((uint32_t)(input[14] & 0x07) << 29) |
			((uint32_t)input[15] << 21) |
			((uint32_t)(input[16] & 0xf8) << 13);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 133 to 148
	value = ((uint32_t)(input[16] & 0x07) << 29) |
			((uint32_t)input[17] << 21) |
			((uint32_t)(input[18] & 0xf8) << 13);
	output[8] = (double)(value >> 16);
}

static void unpack_9_16bit_unsigned_5off(const uint8_t * input, double * output, void *closure) {
	// Unpack 9 values into output
	// Values are 16-bit unsigned
	// Skip 5 bits, read 144 bits of data.
	// Input must be at least 19 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 5 to 20
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)(input[2] & 0xf8) << 13);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 21 to 36
	value = ((uint32_t)(input[2] & 0x07) << 29) |
			((uint32_t)input[3] << 21) |
			((uint32_t)(input[4] & 0xf8) << 13);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 37 to 52
	value = ((uint32_t)(input[4] & 0x07) << 29) |
			((uint32_t)input[5] << 21) |
			((uint32_t)(input[6] & 0xf8) << 13);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 53 to 68
	value = ((uint32_t)(input[6] & 0x07) << 29) |
			((uint32_t)input[7] << 21) |
			((uint32_t)(input[8] & 0xf8) << 13);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 69 to 84
	value = ((uint32_t)(input[8] & 0x07) << 29) |
			((uint32_t)input[9] << 21) |
			((uint32_t)(input[10] & 0xf8) << 13);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 85 to 100
	value = ((uint32_t)(input[10] & 0x07) << 29) |
			((uint32_t)input[11] << 21) |
			((uint32_t)(input[12] & 0xf8) << 13);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 101 to 116
	value = ((uint32_t)(input[12] & 0x07) << 29) |
			((uint32_t)input[13] << 21) |
			((uint32_t)(input[14] & 0xf8) << 13);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 117 to 132
	value = ((uint32_t)(input[14] & 0x07) << 29) |
			((uint32_t)input[15] << 21) |
			((uint32_t)(input[16] & 0xf8) << 13);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 133 to 148
	value = ((uint32_t)(input[16] & 0x07) << 29) |
			((uint32_t)input[17] << 21) |
			((uint32_t)(input[18] & 0xf8) << 13);
	output[8] = (double)(value >> 16);
}

static void unpack_9_16bit_signed_6off(const uint8_t * input, double * output, void *closure) {
	// Unpack 9 values into output
	// Values are 16-bit signed
	// Skip 6 bits, read 144 bits of data.
	// Input must be at least 19 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 6 to 21
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)(input[2] & 0xfc) << 14);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 22 to 37
	value = ((uint32_t)(input[2] & 0x03) << 30) |
			((uint32_t)input[3] << 22) |
			((uint32_t)(input[4] & 0xfc) << 14);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 38 to 53
	value = ((uint32_t)(input[4] & 0x03) << 30) |
			((uint32_t)input[5] << 22) |
			((uint32_t)(input[6] & 0xfc) << 14);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 54 to 69
	value = ((uint32_t)(input[6] & 0x03) << 30) |
			((uint32_t)input[7] << 22) |
			((uint32_t)(input[8] & 0xfc) << 14);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 70 to 85
	value = ((uint32_t)(input[8] & 0x03) << 30) |
			((uint32_t)input[9] << 22) |
			((uint32_t)(input[10] & 0xfc) << 14);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 86 to 101
	value = ((uint32_t)(input[10] & 0x03) << 30) |
			((uint32_t)input[11] << 22) |
			((uint32_t)(input[12] & 0xfc) << 14);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 102 to 117
	value = ((uint32_t)(input[12] & 0x03) << 30) |
			((uint32_t)input[13] << 22) |
			((uint32_t)(input[14] & 0xfc) << 14);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 118 to 133
	value = ((uint32_t)(input[14] & 0x03) << 30) |
			((uint32_t)input[15] << 22) |
			((uint32_t)(input[16] & 0xfc) << 14);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 134 to 149
	value = ((uint32_t)(input[16] & 0x03) << 30) |
			((uint32_t)input[17] << 22) |
			((uint32_t)(input[18] & 0xfc) << 14);
	output[8] = (double)(value >> 16);
}

static void unpack_9_16bit_unsigned_6off(const uint8_t * input, double * output, void *closure) {
	// Unpack 9 values into output
	// Values are 16-bit unsigned
	// Skip 6 bits, read 144 bits of data.
	// Input must be at least 19 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 6 to 21
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)(input[2] & 0xfc) << 14);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 22 to 37
	value = ((uint32_t)(input[2] & 0x03) << 30) |
			((uint32_t)input[3] << 22) |
			((uint32_t)(input[4] & 0xfc) << 14);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 38 to 53
	value = ((uint32_t)(input[4] & 0x03) << 30) |
			((uint32_t)input[5] << 22) |
			((uint32_t)(input[6] & 0xfc) << 14);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 54 to 69
	value = ((uint32_t)(input[6] & 0x03) << 30) |
			((uint32_t)input[7] << 22) |
			((uint32_t)(input[8] & 0xfc) << 14);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 70 to 85
	value = ((uint32_t)(input[8] & 0x03) << 30) |
			((uint32_t)input[9] << 22) |
			((uint32_t)(input[10] & 0xfc) << 14);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 86 to 101
	value = ((uint32_t)(input[10] & 0x03) << 30) |
			((uint32_t)input[11] << 22) |
			((uint32_t)(input[12] & 0xfc) << 14);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 102 to 117
	value = ((uint32_t)(input[12] & 0x03) << 30) |
			((uint32_t)input[13] << 22) |
			((uint32_t)(input[14] & 0xfc) << 14);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 118 to 133
	value = ((uint32_t)(input[14] & 0x03) << 30) |
			((uint32_t)input[15] << 22) |
			((uint32_t)(input[16] & 0xfc) << 14);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 134 to 149
	value = ((uint32_t)(input[16] & 0x03) << 30) |
			((uint32_t)input[17] << 22) |
			((uint32_t)(input[18] & 0xfc) << 14);
	output[8] = (double)(value >> 16);
}

static void unpack_9_16bit_signed_7off(const uint8_t * input, double * output, void *closure) {
	// Unpack 9 values into output
	// Values are 16-bit signed
	// Skip 7 bits, read 144 bits of data.
	// Input must be at least 19 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 7 to 22
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)(input[2] & 0xfe) << 15);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 23 to 38
	value = ((uint32_t)(input[2] & 0x01) << 31) |
			((uint32_t)input[3] << 23) |
			((uint32_t)(input[4] & 0xfe) << 15);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 39 to 54
	value = ((uint32_t)(input[4] & 0x01) << 31) |
			((uint32_t)input[5] << 23) |
			((uint32_t)(input[6] & 0xfe) << 15);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 55 to 70
	value = ((uint32_t)(input[6] & 0x01) << 31) |
			((uint32_t)input[7] << 23) |
			((uint32_t)(input[8] & 0xfe) << 15);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 71 to 86
	value = ((uint32_t)(input[8] & 0x01) << 31) |
			((uint32_t)input[9] << 23) |
			((uint32_t)(input[10] & 0xfe) << 15);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 87 to 102
	value = ((uint32_t)(input[10] & 0x01) << 31) |
			((uint32_t)input[11] << 23) |
			((uint32_t)(input[12] & 0xfe) << 15);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 103 to 118
	value = ((uint32_t)(input[12] & 0x01) << 31) |
			((uint32_t)input[13] << 23) |
			((uint32_t)(input[14] & 0xfe) << 15);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 119 to 134
	value = ((uint32_t)(input[14] & 0x01) << 31) |
			((uint32_t)input[15] << 23) |
			((uint32_t)(input[16] & 0xfe) << 15);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 135 to 150
	value = ((uint32_t)(input[16] & 0x01) << 31) |
			((uint32_t)input[17] << 23) |
			((uint32_t)(input[18] & 0xfe) << 15);
	output[8] = (double)(value >> 16);
}

static void unpack_9_16bit_unsigned_7off(const uint8_t * input, double * output, void *closure) {
	// Unpack 9 values into output
	// Values are 16-bit unsigned
	// Skip 7 bits, read 144 bits of data.
	// Input must be at least 19 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 7 to 22
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)(input[2] & 0xfe) << 15);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 23 to 38
	value = ((uint32_t)(input[2] & 0x01) << 31) |
			((uint32_t)input[3] << 23) |
			((uint32_t)(input[4] & 0xfe) << 15);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 39 to 54
	value = ((uint32_t)(input[4] & 0x01) << 31) |
			((uint32_t)input[5] << 23) |
			((uint32_t)(input[6] & 0xfe) << 15);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 55 to 70
	value = ((uint32_t)(input[6] & 0x01) << 31) |
			((uint32_t)input[7] << 23) |
			((uint32_t)(input[8] & 0xfe) << 15);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 71 to 86
	value = ((uint32_t)(input[8] & 0x01) << 31) |
			((uint32_t)input[9] << 23) |
			((uint32_t)(input[10] & 0xfe) << 15);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 87 to 102
	value = ((uint32_t)(input[10] & 0x01) << 31) |
			((uint32_t)input[11] << 23) |
			((uint32_t)(input[12] & 0xfe) << 15);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 103 to 118
	value = ((uint32_t)(input[12] & 0x01) << 31) |
			((uint32_t)input[13] << 23) |
			((uint32_t)(input[14] & 0xfe) << 15);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 119 to 134
	value = ((uint32_t)(input[14] & 0x01) << 31) |
			((uint32_t)input[15] << 23) |
			((uint32_t)(input[16] & 0xfe) << 15);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 135 to 150
	value = ((uint32_t)(input[16] & 0x01) << 31) |
			((uint32_t)input[17] << 23) |
			((uint32_t)(input[18] & 0xfe) << 15);
	output[8] = (double)(value >> 16);
}

static void unpack_10_16bit_signed_0off(const uint8_t * input, double * output, void *closure) {
	// Unpack 10 values into output
	// Values are 16-bit signed
	// Skip 0 bits, read 160 bits of data.
	// Input must be at least 20 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 0 to 15
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)input[1] << 16);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 16 to 31
	value = ((uint32_t)input[2] << 24) |
			((uint32_t)input[3] << 16);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 32 to 47
	value = ((uint32_t)input[4] << 24) |
			((uint32_t)input[5] << 16);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 48 to 63
	value = ((uint32_t)input[6] << 24) |
			((uint32_t)input[7] << 16);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 64 to 79
	value = ((uint32_t)input[8] << 24) |
			((uint32_t)input[9] << 16);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 80 to 95
	value = ((uint32_t)input[10] << 24) |
			((uint32_t)input[11] << 16);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 96 to 111
	value = ((uint32_t)input[12] << 24) |
			((uint32_t)input[13] << 16);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 112 to 127
	value = ((uint32_t)input[14] << 24) |
			((uint32_t)input[15] << 16);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 128 to 143
	value = ((uint32_t)input[16] << 24) |
			((uint32_t)input[17] << 16);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 144 to 159
	value = ((uint32_t)input[18] << 24) |
			((uint32_t)input[19] << 16);
	output[9] = (double)(value >> 16);
}

static void unpack_10_16bit_unsigned_0off(const uint8_t * input, double * output, void *closure) {
	// Unpack 10 values into output
	// Values are 16-bit unsigned
	// Skip 0 bits, read 160 bits of data.
	// Input must be at least 20 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 0 to 15
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)input[1] << 16);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 16 to 31
	value = ((uint32_t)input[2] << 24) |
			((uint32_t)input[3] << 16);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 32 to 47
	value = ((uint32_t)input[4] << 24) |
			((uint32_t)input[5] << 16);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 48 to 63
	value = ((uint32_t)input[6] << 24) |
			((uint32_t)input[7] << 16);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 64 to 79
	value = ((uint32_t)input[8] << 24) |
			((uint32_t)input[9] << 16);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 80 to 95
	value = ((uint32_t)input[10] << 24) |
			((uint32_t)input[11] << 16);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 96 to 111
	value = ((uint32_t)input[12] << 24) |
			((uint32_t)input[13] << 16);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 112 to 127
	value = ((uint32_t)input[14] << 24) |
			((uint32_t)input[15] << 16);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 128 to 143
	value = ((uint32_t)input[16] << 24) |
			((uint32_t)input[17] << 16);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 144 to 159
	value = ((uint32_t)input[18] << 24) |
			((uint32_t)input[19] << 16);
	output[9] = (double)(value >> 16);
}

static void unpack_10_16bit_signed_1off(const uint8_t * input, double * output, void *closure) {
	// Unpack 10 values into output
	// Values are 16-bit signed
	// Skip 1 bits, read 160 bits of data.
	// Input must be at least 21 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 1 to 16
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)input[1] << 17) |
			((uint32_t)(input[2] & 0x80) << 9);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 17 to 32
	value = ((uint32_t)(input[2] & 0x7f) << 25) |
			((uint32_t)input[3] << 17) |
			((uint32_t)(input[4] & 0x80) << 9);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 33 to 48
	value = ((uint32_t)(input[4] & 0x7f) << 25) |
			((uint32_t)input[5] << 17) |
			((uint32_t)(input[6] & 0x80) << 9);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 49 to 64
	value = ((uint32_t)(input[6] & 0x7f) << 25) |
			((uint32_t)input[7] << 17) |
			((uint32_t)(input[8] & 0x80) << 9);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 65 to 80
	value = ((uint32_t)(input[8] & 0x7f) << 25) |
			((uint32_t)input[9] << 17) |
			((uint32_t)(input[10] & 0x80) << 9);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 81 to 96
	value = ((uint32_t)(input[10] & 0x7f) << 25) |
			((uint32_t)input[11] << 17) |
			((uint32_t)(input[12] & 0x80) << 9);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 97 to 112
	value = ((uint32_t)(input[12] & 0x7f) << 25) |
			((uint32_t)input[13] << 17) |
			((uint32_t)(input[14] & 0x80) << 9);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 113 to 128
	value = ((uint32_t)(input[14] & 0x7f) << 25) |
			((uint32_t)input[15] << 17) |
			((uint32_t)(input[16] & 0x80) << 9);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 129 to 144
	value = ((uint32_t)(input[16] & 0x7f) << 25) |
			((uint32_t)input[17] << 17) |
			((uint32_t)(input[18] & 0x80) << 9);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 145 to 160
	value = ((uint32_t)(input[18] & 0x7f) << 25) |
			((uint32_t)input[19] << 17) |
			((uint32_t)(input[20] & 0x80) << 9);
	output[9] = (double)(value >> 16);
}

static void unpack_10_16bit_unsigned_1off(const uint8_t * input, double * output, void *closure) {
	// Unpack 10 values into output
	// Values are 16-bit unsigned
	// Skip 1 bits, read 160 bits of data.
	// Input must be at least 21 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 1 to 16
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)input[1] << 17) |
			((uint32_t)(input[2] & 0x80) << 9);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 17 to 32
	value = ((uint32_t)(input[2] & 0x7f) << 25) |
			((uint32_t)input[3] << 17) |
			((uint32_t)(input[4] & 0x80) << 9);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 33 to 48
	value = ((uint32_t)(input[4] & 0x7f) << 25) |
			((uint32_t)input[5] << 17) |
			((uint32_t)(input[6] & 0x80) << 9);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 49 to 64
	value = ((uint32_t)(input[6] & 0x7f) << 25) |
			((uint32_t)input[7] << 17) |
			((uint32_t)(input[8] & 0x80) << 9);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 65 to 80
	value = ((uint32_t)(input[8] & 0x7f) << 25) |
			((uint32_t)input[9] << 17) |
			((uint32_t)(input[10] & 0x80) << 9);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 81 to 96
	value = ((uint32_t)(input[10] & 0x7f) << 25) |
			((uint32_t)input[11] << 17) |
			((uint32_t)(input[12] & 0x80) << 9);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 97 to 112
	value = ((uint32_t)(input[12] & 0x7f) << 25) |
			((uint32_t)input[13] << 17) |
			((uint32_t)(input[14] & 0x80) << 9);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 113 to 128
	value = ((uint32_t)(input[14] & 0x7f) << 25) |
			((uint32_t)input[15] << 17) |
			((uint32_t)(input[16] & 0x80) << 9);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 129 to 144
	value = ((uint32_t)(input[16] & 0x7f) << 25) |
			((uint32_t)input[17] << 17) |
			((uint32_t)(input[18] & 0x80) << 9);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 145 to 160
	value = ((uint32_t)(input[18] & 0x7f) << 25) |
			((uint32_t)input[19] << 17) |
			((uint32_t)(input[20] & 0x80) << 9);
	output[9] = (double)(value >> 16);
}

static void unpack_10_16bit_signed_2off(const uint8_t * input, double * output, void *closure) {
	// Unpack 10 values into output
	// Values are 16-bit signed
	// Skip 2 bits, read 160 bits of data.
	// Input must be at least 21 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 2 to 17
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)input[1] << 18) |
			((uint32_t)(input[2] & 0xc0) << 10);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 18 to 33
	value = ((uint32_t)(input[2] & 0x3f) << 26) |
			((uint32_t)input[3] << 18) |
			((uint32_t)(input[4] & 0xc0) << 10);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 34 to 49
	value = ((uint32_t)(input[4] & 0x3f) << 26) |
			((uint32_t)input[5] << 18) |
			((uint32_t)(input[6] & 0xc0) << 10);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 50 to 65
	value = ((uint32_t)(input[6] & 0x3f) << 26) |
			((uint32_t)input[7] << 18) |
			((uint32_t)(input[8] & 0xc0) << 10);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 66 to 81
	value = ((uint32_t)(input[8] & 0x3f) << 26) |
			((uint32_t)input[9] << 18) |
			((uint32_t)(input[10] & 0xc0) << 10);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 82 to 97
	value = ((uint32_t)(input[10] & 0x3f) << 26) |
			((uint32_t)input[11] << 18) |
			((uint32_t)(input[12] & 0xc0) << 10);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 98 to 113
	value = ((uint32_t)(input[12] & 0x3f) << 26) |
			((uint32_t)input[13] << 18) |
			((uint32_t)(input[14] & 0xc0) << 10);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 114 to 129
	value = ((uint32_t)(input[14] & 0x3f) << 26) |
			((uint32_t)input[15] << 18) |
			((uint32_t)(input[16] & 0xc0) << 10);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 130 to 145
	value = ((uint32_t)(input[16] & 0x3f) << 26) |
			((uint32_t)input[17] << 18) |
			((uint32_t)(input[18] & 0xc0) << 10);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 146 to 161
	value = ((uint32_t)(input[18] & 0x3f) << 26) |
			((uint32_t)input[19] << 18) |
			((uint32_t)(input[20] & 0xc0) << 10);
	output[9] = (double)(value >> 16);
}

static void unpack_10_16bit_unsigned_2off(const uint8_t * input, double * output, void *closure) {
	// Unpack 10 values into output
	// Values are 16-bit unsigned
	// Skip 2 bits, read 160 bits of data.
	// Input must be at least 21 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 2 to 17
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)input[1] << 18) |
			((uint32_t)(input[2] & 0xc0) << 10);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 18 to 33
	value = ((uint32_t)(input[2] & 0x3f) << 26) |
			((uint32_t)input[3] << 18) |
			((uint32_t)(input[4] & 0xc0) << 10);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 34 to 49
	value = ((uint32_t)(input[4] & 0x3f) << 26) |
			((uint32_t)input[5] << 18) |
			((uint32_t)(input[6] & 0xc0) << 10);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 50 to 65
	value = ((uint32_t)(input[6] & 0x3f) << 26) |
			((uint32_t)input[7] << 18) |
			((uint32_t)(input[8] & 0xc0) << 10);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 66 to 81
	value = ((uint32_t)(input[8] & 0x3f) << 26) |
			((uint32_t)input[9] << 18) |
			((uint32_t)(input[10] & 0xc0) << 10);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 82 to 97
	value = ((uint32_t)(input[10] & 0x3f) << 26) |
			((uint32_t)input[11] << 18) |
			((uint32_t)(input[12] & 0xc0) << 10);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 98 to 113
	value = ((uint32_t)(input[12] & 0x3f) << 26) |
			((uint32_t)input[13] << 18) |
			((uint32_t)(input[14] & 0xc0) << 10);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 114 to 129
	value = ((uint32_t)(input[14] & 0x3f) << 26) |
			((uint32_t)input[15] << 18) |
			((uint32_t)(input[16] & 0xc0) << 10);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 130 to 145
	value = ((uint32_t)(input[16] & 0x3f) << 26) |
			((uint32_t)input[17] << 18) |
			((uint32_t)(input[18] & 0xc0) << 10);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 146 to 161
	value = ((uint32_t)(input[18] & 0x3f) << 26) |
			((uint32_t)input[19] << 18) |
			((uint32_t)(input[20] & 0xc0) << 10);
	output[9] = (double)(value >> 16);
}

static void unpack_10_16bit_signed_3off(const uint8_t * input, double * output, void *closure) {
	// Unpack 10 values into output
	// Values are 16-bit signed
	// Skip 3 bits, read 160 bits of data.
	// Input must be at least 21 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 3 to 18
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)input[1] << 19) |
			((uint32_t)(input[2] & 0xe0) << 11);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 19 to 34
	value = ((uint32_t)(input[2] & 0x1f) << 27) |
			((uint32_t)input[3] << 19) |
			((uint32_t)(input[4] & 0xe0) << 11);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 35 to 50
	value = ((uint32_t)(input[4] & 0x1f) << 27) |
			((uint32_t)input[5] << 19) |
			((uint32_t)(input[6] & 0xe0) << 11);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 51 to 66
	value = ((uint32_t)(input[6] & 0x1f) << 27) |
			((uint32_t)input[7] << 19) |
			((uint32_t)(input[8] & 0xe0) << 11);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 67 to 82
	value = ((uint32_t)(input[8] & 0x1f) << 27) |
			((uint32_t)input[9] << 19) |
			((uint32_t)(input[10] & 0xe0) << 11);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 83 to 98
	value = ((uint32_t)(input[10] & 0x1f) << 27) |
			((uint32_t)input[11] << 19) |
			((uint32_t)(input[12] & 0xe0) << 11);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 99 to 114
	value = ((uint32_t)(input[12] & 0x1f) << 27) |
			((uint32_t)input[13] << 19) |
			((uint32_t)(input[14] & 0xe0) << 11);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 115 to 130
	value = ((uint32_t)(input[14] & 0x1f) << 27) |
			((uint32_t)input[15] << 19) |
			((uint32_t)(input[16] & 0xe0) << 11);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 131 to 146
	value = ((uint32_t)(input[16] & 0x1f) << 27) |
			((uint32_t)input[17] << 19) |
			((uint32_t)(input[18] & 0xe0) << 11);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 147 to 162
	value = ((uint32_t)(input[18] & 0x1f) << 27) |
			((uint32_t)input[19] << 19) |
			((uint32_t)(input[20] & 0xe0) << 11);
	output[9] = (double)(value >> 16);
}

static void unpack_10_16bit_unsigned_3off(const uint8_t * input, double * output, void *closure) {
	// Unpack 10 values into output
	// Values are 16-bit unsigned
	// Skip 3 bits, read 160 bits of data.
	// Input must be at least 21 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 3 to 18
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)input[1] << 19) |
			((uint32_t)(input[2] & 0xe0) << 11);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 19 to 34
	value = ((uint32_t)(input[2] & 0x1f) << 27) |
			((uint32_t)input[3] << 19) |
			((uint32_t)(input[4] & 0xe0) << 11);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 35 to 50
	value = ((uint32_t)(input[4] & 0x1f) << 27) |
			((uint32_t)input[5] << 19) |
			((uint32_t)(input[6] & 0xe0) << 11);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 51 to 66
	value = ((uint32_t)(input[6] & 0x1f) << 27) |
			((uint32_t)input[7] << 19) |
			((uint32_t)(input[8] & 0xe0) << 11);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 67 to 82
	value = ((uint32_t)(input[8] & 0x1f) << 27) |
			((uint32_t)input[9] << 19) |
			((uint32_t)(input[10] & 0xe0) << 11);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 83 to 98
	value = ((uint32_t)(input[10] & 0x1f) << 27) |
			((uint32_t)input[11] << 19) |
			((uint32_t)(input[12] & 0xe0) << 11);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 99 to 114
	value = ((uint32_t)(input[12] & 0x1f) << 27) |
			((uint32_t)input[13] << 19) |
			((uint32_t)(input[14] & 0xe0) << 11);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 115 to 130
	value = ((uint32_t)(input[14] & 0x1f) << 27) |
			((uint32_t)input[15] << 19) |
			((uint32_t)(input[16] & 0xe0) << 11);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 131 to 146
	value = ((uint32_t)(input[16] & 0x1f) << 27) |
			((uint32_t)input[17] << 19) |
			((uint32_t)(input[18] & 0xe0) << 11);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 147 to 162
	value = ((uint32_t)(input[18] & 0x1f) << 27) |
			((uint32_t)input[19] << 19) |
			((uint32_t)(input[20] & 0xe0) << 11);
	output[9] = (double)(value >> 16);
}

static void unpack_10_16bit_signed_4off(const uint8_t * input, double * output, void *closure) {
	// Unpack 10 values into output
	// Values are 16-bit signed
	// Skip 4 bits, read 160 bits of data.
	// Input must be at least 21 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 4 to 19
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20) |
			((uint32_t)(input[2] & 0xf0) << 12);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 20 to 35
	value = ((uint32_t)(input[2] & 0x0f) << 28) |
			((uint32_t)input[3] << 20) |
			((uint32_t)(input[4] & 0xf0) << 12);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 36 to 51
	value = ((uint32_t)(input[4] & 0x0f) << 28) |
			((uint32_t)input[5] << 20) |
			((uint32_t)(input[6] & 0xf0) << 12);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 52 to 67
	value = ((uint32_t)(input[6] & 0x0f) << 28) |
			((uint32_t)input[7] << 20) |
			((uint32_t)(input[8] & 0xf0) << 12);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 68 to 83
	value = ((uint32_t)(input[8] & 0x0f) << 28) |
			((uint32_t)input[9] << 20) |
			((uint32_t)(input[10] & 0xf0) << 12);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 84 to 99
	value = ((uint32_t)(input[10] & 0x0f) << 28) |
			((uint32_t)input[11] << 20) |
			((uint32_t)(input[12] & 0xf0) << 12);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 100 to 115
	value = ((uint32_t)(input[12] & 0x0f) << 28) |
			((uint32_t)input[13] << 20) |
			((uint32_t)(input[14] & 0xf0) << 12);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 116 to 131
	value = ((uint32_t)(input[14] & 0x0f) << 28) |
			((uint32_t)input[15] << 20) |
			((uint32_t)(input[16] & 0xf0) << 12);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 132 to 147
	value = ((uint32_t)(input[16] & 0x0f) << 28) |
			((uint32_t)input[17] << 20) |
			((uint32_t)(input[18] & 0xf0) << 12);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 148 to 163
	value = ((uint32_t)(input[18] & 0x0f) << 28) |
			((uint32_t)input[19] << 20) |
			((uint32_t)(input[20] & 0xf0) << 12);
	output[9] = (double)(value >> 16);
}

static void unpack_10_16bit_unsigned_4off(const uint8_t * input, double * output, void *closure) {
	// Unpack 10 values into output
	// Values are 16-bit unsigned
	// Skip 4 bits, read 160 bits of data.
	// Input must be at least 21 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 4 to 19
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20) |
			((uint32_t)(input[2] & 0xf0) << 12);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 20 to 35
	value = ((uint32_t)(input[2] & 0x0f) << 28) |
			((uint32_t)input[3] << 20) |
			((uint32_t)(input[4] & 0xf0) << 12);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 36 to 51
	value = ((uint32_t)(input[4] & 0x0f) << 28) |
			((uint32_t)input[5] << 20) |
			((uint32_t)(input[6] & 0xf0) << 12);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 52 to 67
	value = ((uint32_t)(input[6] & 0x0f) << 28) |
			((uint32_t)input[7] << 20) |
			((uint32_t)(input[8] & 0xf0) << 12);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 68 to 83
	value = ((uint32_t)(input[8] & 0x0f) << 28) |
			((uint32_t)input[9] << 20) |
			((uint32_t)(input[10] & 0xf0) << 12);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 84 to 99
	value = ((uint32_t)(input[10] & 0x0f) << 28) |
			((uint32_t)input[11] << 20) |
			((uint32_t)(input[12] & 0xf0) << 12);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 100 to 115
	value = ((uint32_t)(input[12] & 0x0f) << 28) |
			((uint32_t)input[13] << 20) |
			((uint32_t)(input[14] & 0xf0) << 12);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 116 to 131
	value = ((uint32_t)(input[14] & 0x0f) << 28) |
			((uint32_t)input[15] << 20) |
			((uint32_t)(input[16] & 0xf0) << 12);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 132 to 147
	value = ((uint32_t)(input[16] & 0x0f) << 28) |
			((uint32_t)input[17] << 20) |
			((uint32_t)(input[18] & 0xf0) << 12);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 148 to 163
	value = ((uint32_t)(input[18] & 0x0f) << 28) |
			((uint32_t)input[19] << 20) |
			((uint32_t)(input[20] & 0xf0) << 12);
	output[9] = (double)(value >> 16);
}

static void unpack_10_16bit_signed_5off(const uint8_t * input, double * output, void *closure) {
	// Unpack 10 values into output
	// Values are 16-bit signed
	// Skip 5 bits, read 160 bits of data.
	// Input must be at least 21 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 5 to 20
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)(input[2] & 0xf8) << 13);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 21 to 36
	value = ((uint32_t)(input[2] & 0x07) << 29) |
			((uint32_t)input[3] << 21) |
			((uint32_t)(input[4] & 0xf8) << 13);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 37 to 52
	value = ((uint32_t)(input[4] & 0x07) << 29) |
			((uint32_t)input[5] << 21) |
			((uint32_t)(input[6] & 0xf8) << 13);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 53 to 68
	value = ((uint32_t)(input[6] & 0x07) << 29) |
			((uint32_t)input[7] << 21) |
			((uint32_t)(input[8] & 0xf8) << 13);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 69 to 84
	value = ((uint32_t)(input[8] & 0x07) << 29) |
			((uint32_t)input[9] << 21) |
			((uint32_t)(input[10] & 0xf8) << 13);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 85 to 100
	value = ((uint32_t)(input[10] & 0x07) << 29) |
			((uint32_t)input[11] << 21) |
			((uint32_t)(input[12] & 0xf8) << 13);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 101 to 116
	value = ((uint32_t)(input[12] & 0x07) << 29) |
			((uint32_t)input[13] << 21) |
			((uint32_t)(input[14] & 0xf8) << 13);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 117 to 132
	value = ((uint32_t)(input[14] & 0x07) << 29) |
			((uint32_t)input[15] << 21) |
			((uint32_t)(input[16] & 0xf8) << 13);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 133 to 148
	value = ((uint32_t)(input[16] & 0x07) << 29) |
			((uint32_t)input[17] << 21) |
			((uint32_t)(input[18] & 0xf8) << 13);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 149 to 164
	value = ((uint32_t)(input[18] & 0x07) << 29) |
			((uint32_t)input[19] << 21) |
			((uint32_t)(input[20] & 0xf8) << 13);
	output[9] = (double)(value >> 16);
}

static void unpack_10_16bit_unsigned_5off(const uint8_t * input, double * output, void *closure) {
	// Unpack 10 values into output
	// Values are 16-bit unsigned
	// Skip 5 bits, read 160 bits of data.
	// Input must be at least 21 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 5 to 20
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)(input[2] & 0xf8) << 13);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 21 to 36
	value = ((uint32_t)(input[2] & 0x07) << 29) |
			((uint32_t)input[3] << 21) |
			((uint32_t)(input[4] & 0xf8) << 13);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 37 to 52
	value = ((uint32_t)(input[4] & 0x07) << 29) |
			((uint32_t)input[5] << 21) |
			((uint32_t)(input[6] & 0xf8) << 13);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 53 to 68
	value = ((uint32_t)(input[6] & 0x07) << 29) |
			((uint32_t)input[7] << 21) |
			((uint32_t)(input[8] & 0xf8) << 13);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 69 to 84
	value = ((uint32_t)(input[8] & 0x07) << 29) |
			((uint32_t)input[9] << 21) |
			((uint32_t)(input[10] & 0xf8) << 13);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 85 to 100
	value = ((uint32_t)(input[10] & 0x07) << 29) |
			((uint32_t)input[11] << 21) |
			((uint32_t)(input[12] & 0xf8) << 13);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 101 to 116
	value = ((uint32_t)(input[12] & 0x07) << 29) |
			((uint32_t)input[13] << 21) |
			((uint32_t)(input[14] & 0xf8) << 13);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 117 to 132
	value = ((uint32_t)(input[14] & 0x07) << 29) |
			((uint32_t)input[15] << 21) |
			((uint32_t)(input[16] & 0xf8) << 13);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 133 to 148
	value = ((uint32_t)(input[16] & 0x07) << 29) |
			((uint32_t)input[17] << 21) |
			((uint32_t)(input[18] & 0xf8) << 13);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 149 to 164
	value = ((uint32_t)(input[18] & 0x07) << 29) |
			((uint32_t)input[19] << 21) |
			((uint32_t)(input[20] & 0xf8) << 13);
	output[9] = (double)(value >> 16);
}

static void unpack_10_16bit_signed_6off(const uint8_t * input, double * output, void *closure) {
	// Unpack 10 values into output
	// Values are 16-bit signed
	// Skip 6 bits, read 160 bits of data.
	// Input must be at least 21 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 6 to 21
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)(input[2] & 0xfc) << 14);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 22 to 37
	value = ((uint32_t)(input[2] & 0x03) << 30) |
			((uint32_t)input[3] << 22) |
			((uint32_t)(input[4] & 0xfc) << 14);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 38 to 53
	value = ((uint32_t)(input[4] & 0x03) << 30) |
			((uint32_t)input[5] << 22) |
			((uint32_t)(input[6] & 0xfc) << 14);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 54 to 69
	value = ((uint32_t)(input[6] & 0x03) << 30) |
			((uint32_t)input[7] << 22) |
			((uint32_t)(input[8] & 0xfc) << 14);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 70 to 85
	value = ((uint32_t)(input[8] & 0x03) << 30) |
			((uint32_t)input[9] << 22) |
			((uint32_t)(input[10] & 0xfc) << 14);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 86 to 101
	value = ((uint32_t)(input[10] & 0x03) << 30) |
			((uint32_t)input[11] << 22) |
			((uint32_t)(input[12] & 0xfc) << 14);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 102 to 117
	value = ((uint32_t)(input[12] & 0x03) << 30) |
			((uint32_t)input[13] << 22) |
			((uint32_t)(input[14] & 0xfc) << 14);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 118 to 133
	value = ((uint32_t)(input[14] & 0x03) << 30) |
			((uint32_t)input[15] << 22) |
			((uint32_t)(input[16] & 0xfc) << 14);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 134 to 149
	value = ((uint32_t)(input[16] & 0x03) << 30) |
			((uint32_t)input[17] << 22) |
			((uint32_t)(input[18] & 0xfc) << 14);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 150 to 165
	value = ((uint32_t)(input[18] & 0x03) << 30) |
			((uint32_t)input[19] << 22) |
			((uint32_t)(input[20] & 0xfc) << 14);
	output[9] = (double)(value >> 16);
}

static void unpack_10_16bit_unsigned_6off(const uint8_t * input, double * output, void *closure) {
	// Unpack 10 values into output
	// Values are 16-bit unsigned
	// Skip 6 bits, read 160 bits of data.
	// Input must be at least 21 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 6 to 21
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)(input[2] & 0xfc) << 14);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 22 to 37
	value = ((uint32_t)(input[2] & 0x03) << 30) |
			((uint32_t)input[3] << 22) |
			((uint32_t)(input[4] & 0xfc) << 14);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 38 to 53
	value = ((uint32_t)(input[4] & 0x03) << 30) |
			((uint32_t)input[5] << 22) |
			((uint32_t)(input[6] & 0xfc) << 14);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 54 to 69
	value = ((uint32_t)(input[6] & 0x03) << 30) |
			((uint32_t)input[7] << 22) |
			((uint32_t)(input[8] & 0xfc) << 14);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 70 to 85
	value = ((uint32_t)(input[8] & 0x03) << 30) |
			((uint32_t)input[9] << 22) |
			((uint32_t)(input[10] & 0xfc) << 14);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 86 to 101
	value = ((uint32_t)(input[10] & 0x03) << 30) |
			((uint32_t)input[11] << 22) |
			((uint32_t)(input[12] & 0xfc) << 14);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 102 to 117
	value = ((uint32_t)(input[12] & 0x03) << 30) |
			((uint32_t)input[13] << 22) |
			((uint32_t)(input[14] & 0xfc) << 14);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 118 to 133
	value = ((uint32_t)(input[14] & 0x03) << 30) |
			((uint32_t)input[15] << 22) |
			((uint32_t)(input[16] & 0xfc) << 14);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 134 to 149
	value = ((uint32_t)(input[16] & 0x03) << 30) |
			((uint32_t)input[17] << 22) |
			((uint32_t)(input[18] & 0xfc) << 14);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 150 to 165
	value = ((uint32_t)(input[18] & 0x03) << 30) |
			((uint32_t)input[19] << 22) |
			((uint32_t)(input[20] & 0xfc) << 14);
	output[9] = (double)(value >> 16);
}

static void unpack_10_16bit_signed_7off(const uint8_t * input, double * output, void *closure) {
	// Unpack 10 values into output
	// Values are 16-bit signed
	// Skip 7 bits, read 160 bits of data.
	// Input must be at least 21 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 7 to 22
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)(input[2] & 0xfe) << 15);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 23 to 38
	value = ((uint32_t)(input[2] & 0x01) << 31) |
			((uint32_t)input[3] << 23) |
			((uint32_t)(input[4] & 0xfe) << 15);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 39 to 54
	value = ((uint32_t)(input[4] & 0x01) << 31) |
			((uint32_t)input[5] << 23) |
			((uint32_t)(input[6] & 0xfe) << 15);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 55 to 70
	value = ((uint32_t)(input[6] & 0x01) << 31) |
			((uint32_t)input[7] << 23) |
			((uint32_t)(input[8] & 0xfe) << 15);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 71 to 86
	value = ((uint32_t)(input[8] & 0x01) << 31) |
			((uint32_t)input[9] << 23) |
			((uint32_t)(input[10] & 0xfe) << 15);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 87 to 102
	value = ((uint32_t)(input[10] & 0x01) << 31) |
			((uint32_t)input[11] << 23) |
			((uint32_t)(input[12] & 0xfe) << 15);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 103 to 118
	value = ((uint32_t)(input[12] & 0x01) << 31) |
			((uint32_t)input[13] << 23) |
			((uint32_t)(input[14] & 0xfe) << 15);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 119 to 134
	value = ((uint32_t)(input[14] & 0x01) << 31) |
			((uint32_t)input[15] << 23) |
			((uint32_t)(input[16] & 0xfe) << 15);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 135 to 150
	value = ((uint32_t)(input[16] & 0x01) << 31) |
			((uint32_t)input[17] << 23) |
			((uint32_t)(input[18] & 0xfe) << 15);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 151 to 166
	value = ((uint32_t)(input[18] & 0x01) << 31) |
			((uint32_t)input[19] << 23) |
			((uint32_t)(input[20] & 0xfe) << 15);
	output[9] = (double)(value >> 16);
}

static void unpack_10_16bit_unsigned_7off(const uint8_t * input, double * output, void *closure) {
	// Unpack 10 values into output
	// Values are 16-bit unsigned
	// Skip 7 bits, read 160 bits of data.
	// Input must be at least 21 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 7 to 22
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)(input[2] & 0xfe) << 15);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 23 to 38
	value = ((uint32_t)(input[2] & 0x01) << 31) |
			((uint32_t)input[3] << 23) |
			((uint32_t)(input[4] & 0xfe) << 15);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 39 to 54
	value = ((uint32_t)(input[4] & 0x01) << 31) |
			((uint32_t)input[5] << 23) |
			((uint32_t)(input[6] & 0xfe) << 15);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 55 to 70
	value = ((uint32_t)(input[6] & 0x01) << 31) |
			((uint32_t)input[7] << 23) |
			((uint32_t)(input[8] & 0xfe) << 15);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 71 to 86
	value = ((uint32_t)(input[8] & 0x01) << 31) |
			((uint32_t)input[9] << 23) |
			((uint32_t)(input[10] & 0xfe) << 15);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 87 to 102
	value = ((uint32_t)(input[10] & 0x01) << 31) |
			((uint32_t)input[11] << 23) |
			((uint32_t)(input[12] & 0xfe) << 15);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 103 to 118
	value = ((uint32_t)(input[12] & 0x01) << 31) |
			((uint32_t)input[13] << 23) |
			((uint32_t)(input[14] & 0xfe) << 15);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 119 to 134
	value = ((uint32_t)(input[14] & 0x01) << 31) |
			((uint32_t)input[15] << 23) |
			((uint32_t)(input[16] & 0xfe) << 15);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 135 to 150
	value = ((uint32_t)(input[16] & 0x01) << 31) |
			((uint32_t)input[17] << 23) |
			((uint32_t)(input[18] & 0xfe) << 15);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 151 to 166
	value = ((uint32_t)(input[18] & 0x01) << 31) |
			((uint32_t)input[19] << 23) |
			((uint32_t)(input[20] & 0xfe) << 15);
	output[9] = (double)(value >> 16);
}

static void unpack_11_16bit_signed_0off(const uint8_t * input, double * output, void *closure) {
	// Unpack 11 values into output
	// Values are 16-bit signed
	// Skip 0 bits, read 176 bits of data.
	// Input must be at least 22 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 0 to 15
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)input[1] << 16);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 16 to 31
	value = ((uint32_t)input[2] << 24) |
			((uint32_t)input[3] << 16);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 32 to 47
	value = ((uint32_t)input[4] << 24) |
			((uint32_t)input[5] << 16);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 48 to 63
	value = ((uint32_t)input[6] << 24) |
			((uint32_t)input[7] << 16);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 64 to 79
	value = ((uint32_t)input[8] << 24) |
			((uint32_t)input[9] << 16);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 80 to 95
	value = ((uint32_t)input[10] << 24) |
			((uint32_t)input[11] << 16);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 96 to 111
	value = ((uint32_t)input[12] << 24) |
			((uint32_t)input[13] << 16);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 112 to 127
	value = ((uint32_t)input[14] << 24) |
			((uint32_t)input[15] << 16);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 128 to 143
	value = ((uint32_t)input[16] << 24) |
			((uint32_t)input[17] << 16);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 144 to 159
	value = ((uint32_t)input[18] << 24) |
			((uint32_t)input[19] << 16);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 160 to 175
	value = ((uint32_t)input[20] << 24) |
			((uint32_t)input[21] << 16);
	output[10] = (double)(value >> 16);
}

static void unpack_11_16bit_unsigned_0off(const uint8_t * input, double * output, void *closure) {
	// Unpack 11 values into output
	// Values are 16-bit unsigned
	// Skip 0 bits, read 176 bits of data.
	// Input must be at least 22 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 0 to 15
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)input[1] << 16);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 16 to 31
	value = ((uint32_t)input[2] << 24) |
			((uint32_t)input[3] << 16);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 32 to 47
	value = ((uint32_t)input[4] << 24) |
			((uint32_t)input[5] << 16);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 48 to 63
	value = ((uint32_t)input[6] << 24) |
			((uint32_t)input[7] << 16);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 64 to 79
	value = ((uint32_t)input[8] << 24) |
			((uint32_t)input[9] << 16);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 80 to 95
	value = ((uint32_t)input[10] << 24) |
			((uint32_t)input[11] << 16);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 96 to 111
	value = ((uint32_t)input[12] << 24) |
			((uint32_t)input[13] << 16);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 112 to 127
	value = ((uint32_t)input[14] << 24) |
			((uint32_t)input[15] << 16);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 128 to 143
	value = ((uint32_t)input[16] << 24) |
			((uint32_t)input[17] << 16);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 144 to 159
	value = ((uint32_t)input[18] << 24) |
			((uint32_t)input[19] << 16);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 160 to 175
	value = ((uint32_t)input[20] << 24) |
			((uint32_t)input[21] << 16);
	output[10] = (double)(value >> 16);
}

static void unpack_11_16bit_signed_1off(const uint8_t * input, double * output, void *closure) {
	// Unpack 11 values into output
	// Values are 16-bit signed
	// Skip 1 bits, read 176 bits of data.
	// Input must be at least 23 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 1 to 16
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)input[1] << 17) |
			((uint32_t)(input[2] & 0x80) << 9);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 17 to 32
	value = ((uint32_t)(input[2] & 0x7f) << 25) |
			((uint32_t)input[3] << 17) |
			((uint32_t)(input[4] & 0x80) << 9);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 33 to 48
	value = ((uint32_t)(input[4] & 0x7f) << 25) |
			((uint32_t)input[5] << 17) |
			((uint32_t)(input[6] & 0x80) << 9);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 49 to 64
	value = ((uint32_t)(input[6] & 0x7f) << 25) |
			((uint32_t)input[7] << 17) |
			((uint32_t)(input[8] & 0x80) << 9);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 65 to 80
	value = ((uint32_t)(input[8] & 0x7f) << 25) |
			((uint32_t)input[9] << 17) |
			((uint32_t)(input[10] & 0x80) << 9);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 81 to 96
	value = ((uint32_t)(input[10] & 0x7f) << 25) |
			((uint32_t)input[11] << 17) |
			((uint32_t)(input[12] & 0x80) << 9);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 97 to 112
	value = ((uint32_t)(input[12] & 0x7f) << 25) |
			((uint32_t)input[13] << 17) |
			((uint32_t)(input[14] & 0x80) << 9);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 113 to 128
	value = ((uint32_t)(input[14] & 0x7f) << 25) |
			((uint32_t)input[15] << 17) |
			((uint32_t)(input[16] & 0x80) << 9);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 129 to 144
	value = ((uint32_t)(input[16] & 0x7f) << 25) |
			((uint32_t)input[17] << 17) |
			((uint32_t)(input[18] & 0x80) << 9);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 145 to 160
	value = ((uint32_t)(input[18] & 0x7f) << 25) |
			((uint32_t)input[19] << 17) |
			((uint32_t)(input[20] & 0x80) << 9);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 161 to 176
	value = ((uint32_t)(input[20] & 0x7f) << 25) |
			((uint32_t)input[21] << 17) |
			((uint32_t)(input[22] & 0x80) << 9);
	output[10] = (double)(value >> 16);
}

static void unpack_11_16bit_unsigned_1off(const uint8_t * input, double * output, void *closure) {
	// Unpack 11 values into output
	// Values are 16-bit unsigned
	// Skip 1 bits, read 176 bits of data.
	// Input must be at least 23 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 1 to 16
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)input[1] << 17) |
			((uint32_t)(input[2] & 0x80) << 9);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 17 to 32
	value = ((uint32_t)(input[2] & 0x7f) << 25) |
			((uint32_t)input[3] << 17) |
			((uint32_t)(input[4] & 0x80) << 9);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 33 to 48
	value = ((uint32_t)(input[4] & 0x7f) << 25) |
			((uint32_t)input[5] << 17) |
			((uint32_t)(input[6] & 0x80) << 9);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 49 to 64
	value = ((uint32_t)(input[6] & 0x7f) << 25) |
			((uint32_t)input[7] << 17) |
			((uint32_t)(input[8] & 0x80) << 9);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 65 to 80
	value = ((uint32_t)(input[8] & 0x7f) << 25) |
			((uint32_t)input[9] << 17) |
			((uint32_t)(input[10] & 0x80) << 9);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 81 to 96
	value = ((uint32_t)(input[10] & 0x7f) << 25) |
			((uint32_t)input[11] << 17) |
			((uint32_t)(input[12] & 0x80) << 9);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 97 to 112
	value = ((uint32_t)(input[12] & 0x7f) << 25) |
			((uint32_t)input[13] << 17) |
			((uint32_t)(input[14] & 0x80) << 9);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 113 to 128
	value = ((uint32_t)(input[14] & 0x7f) << 25) |
			((uint32_t)input[15] << 17) |
			((uint32_t)(input[16] & 0x80) << 9);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 129 to 144
	value = ((uint32_t)(input[16] & 0x7f) << 25) |
			((uint32_t)input[17] << 17) |
			((uint32_t)(input[18] & 0x80) << 9);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 145 to 160
	value = ((uint32_t)(input[18] & 0x7f) << 25) |
			((uint32_t)input[19] << 17) |
			((uint32_t)(input[20] & 0x80) << 9);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 161 to 176
	value = ((uint32_t)(input[20] & 0x7f) << 25) |
			((uint32_t)input[21] << 17) |
			((uint32_t)(input[22] & 0x80) << 9);
	output[10] = (double)(value >> 16);
}

static void unpack_11_16bit_signed_2off(const uint8_t * input, double * output, void *closure) {
	// Unpack 11 values into output
	// Values are 16-bit signed
	// Skip 2 bits, read 176 bits of data.
	// Input must be at least 23 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 2 to 17
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)input[1] << 18) |
			((uint32_t)(input[2] & 0xc0) << 10);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 18 to 33
	value = ((uint32_t)(input[2] & 0x3f) << 26) |
			((uint32_t)input[3] << 18) |
			((uint32_t)(input[4] & 0xc0) << 10);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 34 to 49
	value = ((uint32_t)(input[4] & 0x3f) << 26) |
			((uint32_t)input[5] << 18) |
			((uint32_t)(input[6] & 0xc0) << 10);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 50 to 65
	value = ((uint32_t)(input[6] & 0x3f) << 26) |
			((uint32_t)input[7] << 18) |
			((uint32_t)(input[8] & 0xc0) << 10);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 66 to 81
	value = ((uint32_t)(input[8] & 0x3f) << 26) |
			((uint32_t)input[9] << 18) |
			((uint32_t)(input[10] & 0xc0) << 10);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 82 to 97
	value = ((uint32_t)(input[10] & 0x3f) << 26) |
			((uint32_t)input[11] << 18) |
			((uint32_t)(input[12] & 0xc0) << 10);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 98 to 113
	value = ((uint32_t)(input[12] & 0x3f) << 26) |
			((uint32_t)input[13] << 18) |
			((uint32_t)(input[14] & 0xc0) << 10);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 114 to 129
	value = ((uint32_t)(input[14] & 0x3f) << 26) |
			((uint32_t)input[15] << 18) |
			((uint32_t)(input[16] & 0xc0) << 10);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 130 to 145
	value = ((uint32_t)(input[16] & 0x3f) << 26) |
			((uint32_t)input[17] << 18) |
			((uint32_t)(input[18] & 0xc0) << 10);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 146 to 161
	value = ((uint32_t)(input[18] & 0x3f) << 26) |
			((uint32_t)input[19] << 18) |
			((uint32_t)(input[20] & 0xc0) << 10);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 162 to 177
	value = ((uint32_t)(input[20] & 0x3f) << 26) |
			((uint32_t)input[21] << 18) |
			((uint32_t)(input[22] & 0xc0) << 10);
	output[10] = (double)(value >> 16);
}

static void unpack_11_16bit_unsigned_2off(const uint8_t * input, double * output, void *closure) {
	// Unpack 11 values into output
	// Values are 16-bit unsigned
	// Skip 2 bits, read 176 bits of data.
	// Input must be at least 23 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 2 to 17
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)input[1] << 18) |
			((uint32_t)(input[2] & 0xc0) << 10);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 18 to 33
	value = ((uint32_t)(input[2] & 0x3f) << 26) |
			((uint32_t)input[3] << 18) |
			((uint32_t)(input[4] & 0xc0) << 10);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 34 to 49
	value = ((uint32_t)(input[4] & 0x3f) << 26) |
			((uint32_t)input[5] << 18) |
			((uint32_t)(input[6] & 0xc0) << 10);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 50 to 65
	value = ((uint32_t)(input[6] & 0x3f) << 26) |
			((uint32_t)input[7] << 18) |
			((uint32_t)(input[8] & 0xc0) << 10);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 66 to 81
	value = ((uint32_t)(input[8] & 0x3f) << 26) |
			((uint32_t)input[9] << 18) |
			((uint32_t)(input[10] & 0xc0) << 10);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 82 to 97
	value = ((uint32_t)(input[10] & 0x3f) << 26) |
			((uint32_t)input[11] << 18) |
			((uint32_t)(input[12] & 0xc0) << 10);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 98 to 113
	value = ((uint32_t)(input[12] & 0x3f) << 26) |
			((uint32_t)input[13] << 18) |
			((uint32_t)(input[14] & 0xc0) << 10);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 114 to 129
	value = ((uint32_t)(input[14] & 0x3f) << 26) |
			((uint32_t)input[15] << 18) |
			((uint32_t)(input[16] & 0xc0) << 10);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 130 to 145
	value = ((uint32_t)(input[16] & 0x3f) << 26) |
			((uint32_t)input[17] << 18) |
			((uint32_t)(input[18] & 0xc0) << 10);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 146 to 161
	value = ((uint32_t)(input[18] & 0x3f) << 26) |
			((uint32_t)input[19] << 18) |
			((uint32_t)(input[20] & 0xc0) << 10);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 162 to 177
	value = ((uint32_t)(input[20] & 0x3f) << 26) |
			((uint32_t)input[21] << 18) |
			((uint32_t)(input[22] & 0xc0) << 10);
	output[10] = (double)(value >> 16);
}

static void unpack_11_16bit_signed_3off(const uint8_t * input, double * output, void *closure) {
	// Unpack 11 values into output
	// Values are 16-bit signed
	// Skip 3 bits, read 176 bits of data.
	// Input must be at least 23 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 3 to 18
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)input[1] << 19) |
			((uint32_t)(input[2] & 0xe0) << 11);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 19 to 34
	value = ((uint32_t)(input[2] & 0x1f) << 27) |
			((uint32_t)input[3] << 19) |
			((uint32_t)(input[4] & 0xe0) << 11);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 35 to 50
	value = ((uint32_t)(input[4] & 0x1f) << 27) |
			((uint32_t)input[5] << 19) |
			((uint32_t)(input[6] & 0xe0) << 11);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 51 to 66
	value = ((uint32_t)(input[6] & 0x1f) << 27) |
			((uint32_t)input[7] << 19) |
			((uint32_t)(input[8] & 0xe0) << 11);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 67 to 82
	value = ((uint32_t)(input[8] & 0x1f) << 27) |
			((uint32_t)input[9] << 19) |
			((uint32_t)(input[10] & 0xe0) << 11);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 83 to 98
	value = ((uint32_t)(input[10] & 0x1f) << 27) |
			((uint32_t)input[11] << 19) |
			((uint32_t)(input[12] & 0xe0) << 11);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 99 to 114
	value = ((uint32_t)(input[12] & 0x1f) << 27) |
			((uint32_t)input[13] << 19) |
			((uint32_t)(input[14] & 0xe0) << 11);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 115 to 130
	value = ((uint32_t)(input[14] & 0x1f) << 27) |
			((uint32_t)input[15] << 19) |
			((uint32_t)(input[16] & 0xe0) << 11);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 131 to 146
	value = ((uint32_t)(input[16] & 0x1f) << 27) |
			((uint32_t)input[17] << 19) |
			((uint32_t)(input[18] & 0xe0) << 11);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 147 to 162
	value = ((uint32_t)(input[18] & 0x1f) << 27) |
			((uint32_t)input[19] << 19) |
			((uint32_t)(input[20] & 0xe0) << 11);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 163 to 178
	value = ((uint32_t)(input[20] & 0x1f) << 27) |
			((uint32_t)input[21] << 19) |
			((uint32_t)(input[22] & 0xe0) << 11);
	output[10] = (double)(value >> 16);
}

static void unpack_11_16bit_unsigned_3off(const uint8_t * input, double * output, void *closure) {
	// Unpack 11 values into output
	// Values are 16-bit unsigned
	// Skip 3 bits, read 176 bits of data.
	// Input must be at least 23 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 3 to 18
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)input[1] << 19) |
			((uint32_t)(input[2] & 0xe0) << 11);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 19 to 34
	value = ((uint32_t)(input[2] & 0x1f) << 27) |
			((uint32_t)input[3] << 19) |
			((uint32_t)(input[4] & 0xe0) << 11);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 35 to 50
	value = ((uint32_t)(input[4] & 0x1f) << 27) |
			((uint32_t)input[5] << 19) |
			((uint32_t)(input[6] & 0xe0) << 11);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 51 to 66
	value = ((uint32_t)(input[6] & 0x1f) << 27) |
			((uint32_t)input[7] << 19) |
			((uint32_t)(input[8] & 0xe0) << 11);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 67 to 82
	value = ((uint32_t)(input[8] & 0x1f) << 27) |
			((uint32_t)input[9] << 19) |
			((uint32_t)(input[10] & 0xe0) << 11);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 83 to 98
	value = ((uint32_t)(input[10] & 0x1f) << 27) |
			((uint32_t)input[11] << 19) |
			((uint32_t)(input[12] & 0xe0) << 11);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 99 to 114
	value = ((uint32_t)(input[12] & 0x1f) << 27) |
			((uint32_t)input[13] << 19) |
			((uint32_t)(input[14] & 0xe0) << 11);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 115 to 130
	value = ((uint32_t)(input[14] & 0x1f) << 27) |
			((uint32_t)input[15] << 19) |
			((uint32_t)(input[16] & 0xe0) << 11);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 131 to 146
	value = ((uint32_t)(input[16] & 0x1f) << 27) |
			((uint32_t)input[17] << 19) |
			((uint32_t)(input[18] & 0xe0) << 11);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 147 to 162
	value = ((uint32_t)(input[18] & 0x1f) << 27) |
			((uint32_t)input[19] << 19) |
			((uint32_t)(input[20] & 0xe0) << 11);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 163 to 178
	value = ((uint32_t)(input[20] & 0x1f) << 27) |
			((uint32_t)input[21] << 19) |
			((uint32_t)(input[22] & 0xe0) << 11);
	output[10] = (double)(value >> 16);
}

static void unpack_11_16bit_signed_4off(const uint8_t * input, double * output, void *closure) {
	// Unpack 11 values into output
	// Values are 16-bit signed
	// Skip 4 bits, read 176 bits of data.
	// Input must be at least 23 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 4 to 19
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20) |
			((uint32_t)(input[2] & 0xf0) << 12);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 20 to 35
	value = ((uint32_t)(input[2] & 0x0f) << 28) |
			((uint32_t)input[3] << 20) |
			((uint32_t)(input[4] & 0xf0) << 12);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 36 to 51
	value = ((uint32_t)(input[4] & 0x0f) << 28) |
			((uint32_t)input[5] << 20) |
			((uint32_t)(input[6] & 0xf0) << 12);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 52 to 67
	value = ((uint32_t)(input[6] & 0x0f) << 28) |
			((uint32_t)input[7] << 20) |
			((uint32_t)(input[8] & 0xf0) << 12);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 68 to 83
	value = ((uint32_t)(input[8] & 0x0f) << 28) |
			((uint32_t)input[9] << 20) |
			((uint32_t)(input[10] & 0xf0) << 12);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 84 to 99
	value = ((uint32_t)(input[10] & 0x0f) << 28) |
			((uint32_t)input[11] << 20) |
			((uint32_t)(input[12] & 0xf0) << 12);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 100 to 115
	value = ((uint32_t)(input[12] & 0x0f) << 28) |
			((uint32_t)input[13] << 20) |
			((uint32_t)(input[14] & 0xf0) << 12);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 116 to 131
	value = ((uint32_t)(input[14] & 0x0f) << 28) |
			((uint32_t)input[15] << 20) |
			((uint32_t)(input[16] & 0xf0) << 12);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 132 to 147
	value = ((uint32_t)(input[16] & 0x0f) << 28) |
			((uint32_t)input[17] << 20) |
			((uint32_t)(input[18] & 0xf0) << 12);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 148 to 163
	value = ((uint32_t)(input[18] & 0x0f) << 28) |
			((uint32_t)input[19] << 20) |
			((uint32_t)(input[20] & 0xf0) << 12);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 164 to 179
	value = ((uint32_t)(input[20] & 0x0f) << 28) |
			((uint32_t)input[21] << 20) |
			((uint32_t)(input[22] & 0xf0) << 12);
	output[10] = (double)(value >> 16);
}

static void unpack_11_16bit_unsigned_4off(const uint8_t * input, double * output, void *closure) {
	// Unpack 11 values into output
	// Values are 16-bit unsigned
	// Skip 4 bits, read 176 bits of data.
	// Input must be at least 23 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 4 to 19
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20) |
			((uint32_t)(input[2] & 0xf0) << 12);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 20 to 35
	value = ((uint32_t)(input[2] & 0x0f) << 28) |
			((uint32_t)input[3] << 20) |
			((uint32_t)(input[4] & 0xf0) << 12);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 36 to 51
	value = ((uint32_t)(input[4] & 0x0f) << 28) |
			((uint32_t)input[5] << 20) |
			((uint32_t)(input[6] & 0xf0) << 12);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 52 to 67
	value = ((uint32_t)(input[6] & 0x0f) << 28) |
			((uint32_t)input[7] << 20) |
			((uint32_t)(input[8] & 0xf0) << 12);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 68 to 83
	value = ((uint32_t)(input[8] & 0x0f) << 28) |
			((uint32_t)input[9] << 20) |
			((uint32_t)(input[10] & 0xf0) << 12);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 84 to 99
	value = ((uint32_t)(input[10] & 0x0f) << 28) |
			((uint32_t)input[11] << 20) |
			((uint32_t)(input[12] & 0xf0) << 12);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 100 to 115
	value = ((uint32_t)(input[12] & 0x0f) << 28) |
			((uint32_t)input[13] << 20) |
			((uint32_t)(input[14] & 0xf0) << 12);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 116 to 131
	value = ((uint32_t)(input[14] & 0x0f) << 28) |
			((uint32_t)input[15] << 20) |
			((uint32_t)(input[16] & 0xf0) << 12);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 132 to 147
	value = ((uint32_t)(input[16] & 0x0f) << 28) |
			((uint32_t)input[17] << 20) |
			((uint32_t)(input[18] & 0xf0) << 12);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 148 to 163
	value = ((uint32_t)(input[18] & 0x0f) << 28) |
			((uint32_t)input[19] << 20) |
			((uint32_t)(input[20] & 0xf0) << 12);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 164 to 179
	value = ((uint32_t)(input[20] & 0x0f) << 28) |
			((uint32_t)input[21] << 20) |
			((uint32_t)(input[22] & 0xf0) << 12);
	output[10] = (double)(value >> 16);
}

static void unpack_11_16bit_signed_5off(const uint8_t * input, double * output, void *closure) {
	// Unpack 11 values into output
	// Values are 16-bit signed
	// Skip 5 bits, read 176 bits of data.
	// Input must be at least 23 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 5 to 20
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)(input[2] & 0xf8) << 13);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 21 to 36
	value = ((uint32_t)(input[2] & 0x07) << 29) |
			((uint32_t)input[3] << 21) |
			((uint32_t)(input[4] & 0xf8) << 13);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 37 to 52
	value = ((uint32_t)(input[4] & 0x07) << 29) |
			((uint32_t)input[5] << 21) |
			((uint32_t)(input[6] & 0xf8) << 13);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 53 to 68
	value = ((uint32_t)(input[6] & 0x07) << 29) |
			((uint32_t)input[7] << 21) |
			((uint32_t)(input[8] & 0xf8) << 13);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 69 to 84
	value = ((uint32_t)(input[8] & 0x07) << 29) |
			((uint32_t)input[9] << 21) |
			((uint32_t)(input[10] & 0xf8) << 13);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 85 to 100
	value = ((uint32_t)(input[10] & 0x07) << 29) |
			((uint32_t)input[11] << 21) |
			((uint32_t)(input[12] & 0xf8) << 13);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 101 to 116
	value = ((uint32_t)(input[12] & 0x07) << 29) |
			((uint32_t)input[13] << 21) |
			((uint32_t)(input[14] & 0xf8) << 13);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 117 to 132
	value = ((uint32_t)(input[14] & 0x07) << 29) |
			((uint32_t)input[15] << 21) |
			((uint32_t)(input[16] & 0xf8) << 13);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 133 to 148
	value = ((uint32_t)(input[16] & 0x07) << 29) |
			((uint32_t)input[17] << 21) |
			((uint32_t)(input[18] & 0xf8) << 13);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 149 to 164
	value = ((uint32_t)(input[18] & 0x07) << 29) |
			((uint32_t)input[19] << 21) |
			((uint32_t)(input[20] & 0xf8) << 13);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 165 to 180
	value = ((uint32_t)(input[20] & 0x07) << 29) |
			((uint32_t)input[21] << 21) |
			((uint32_t)(input[22] & 0xf8) << 13);
	output[10] = (double)(value >> 16);
}

static void unpack_11_16bit_unsigned_5off(const uint8_t * input, double * output, void *closure) {
	// Unpack 11 values into output
	// Values are 16-bit unsigned
	// Skip 5 bits, read 176 bits of data.
	// Input must be at least 23 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 5 to 20
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)(input[2] & 0xf8) << 13);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 21 to 36
	value = ((uint32_t)(input[2] & 0x07) << 29) |
			((uint32_t)input[3] << 21) |
			((uint32_t)(input[4] & 0xf8) << 13);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 37 to 52
	value = ((uint32_t)(input[4] & 0x07) << 29) |
			((uint32_t)input[5] << 21) |
			((uint32_t)(input[6] & 0xf8) << 13);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 53 to 68
	value = ((uint32_t)(input[6] & 0x07) << 29) |
			((uint32_t)input[7] << 21) |
			((uint32_t)(input[8] & 0xf8) << 13);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 69 to 84
	value = ((uint32_t)(input[8] & 0x07) << 29) |
			((uint32_t)input[9] << 21) |
			((uint32_t)(input[10] & 0xf8) << 13);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 85 to 100
	value = ((uint32_t)(input[10] & 0x07) << 29) |
			((uint32_t)input[11] << 21) |
			((uint32_t)(input[12] & 0xf8) << 13);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 101 to 116
	value = ((uint32_t)(input[12] & 0x07) << 29) |
			((uint32_t)input[13] << 21) |
			((uint32_t)(input[14] & 0xf8) << 13);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 117 to 132
	value = ((uint32_t)(input[14] & 0x07) << 29) |
			((uint32_t)input[15] << 21) |
			((uint32_t)(input[16] & 0xf8) << 13);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 133 to 148
	value = ((uint32_t)(input[16] & 0x07) << 29) |
			((uint32_t)input[17] << 21) |
			((uint32_t)(input[18] & 0xf8) << 13);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 149 to 164
	value = ((uint32_t)(input[18] & 0x07) << 29) |
			((uint32_t)input[19] << 21) |
			((uint32_t)(input[20] & 0xf8) << 13);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 165 to 180
	value = ((uint32_t)(input[20] & 0x07) << 29) |
			((uint32_t)input[21] << 21) |
			((uint32_t)(input[22] & 0xf8) << 13);
	output[10] = (double)(value >> 16);
}

static void unpack_11_16bit_signed_6off(const uint8_t * input, double * output, void *closure) {
	// Unpack 11 values into output
	// Values are 16-bit signed
	// Skip 6 bits, read 176 bits of data.
	// Input must be at least 23 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 6 to 21
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)(input[2] & 0xfc) << 14);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 22 to 37
	value = ((uint32_t)(input[2] & 0x03) << 30) |
			((uint32_t)input[3] << 22) |
			((uint32_t)(input[4] & 0xfc) << 14);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 38 to 53
	value = ((uint32_t)(input[4] & 0x03) << 30) |
			((uint32_t)input[5] << 22) |
			((uint32_t)(input[6] & 0xfc) << 14);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 54 to 69
	value = ((uint32_t)(input[6] & 0x03) << 30) |
			((uint32_t)input[7] << 22) |
			((uint32_t)(input[8] & 0xfc) << 14);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 70 to 85
	value = ((uint32_t)(input[8] & 0x03) << 30) |
			((uint32_t)input[9] << 22) |
			((uint32_t)(input[10] & 0xfc) << 14);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 86 to 101
	value = ((uint32_t)(input[10] & 0x03) << 30) |
			((uint32_t)input[11] << 22) |
			((uint32_t)(input[12] & 0xfc) << 14);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 102 to 117
	value = ((uint32_t)(input[12] & 0x03) << 30) |
			((uint32_t)input[13] << 22) |
			((uint32_t)(input[14] & 0xfc) << 14);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 118 to 133
	value = ((uint32_t)(input[14] & 0x03) << 30) |
			((uint32_t)input[15] << 22) |
			((uint32_t)(input[16] & 0xfc) << 14);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 134 to 149
	value = ((uint32_t)(input[16] & 0x03) << 30) |
			((uint32_t)input[17] << 22) |
			((uint32_t)(input[18] & 0xfc) << 14);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 150 to 165
	value = ((uint32_t)(input[18] & 0x03) << 30) |
			((uint32_t)input[19] << 22) |
			((uint32_t)(input[20] & 0xfc) << 14);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 166 to 181
	value = ((uint32_t)(input[20] & 0x03) << 30) |
			((uint32_t)input[21] << 22) |
			((uint32_t)(input[22] & 0xfc) << 14);
	output[10] = (double)(value >> 16);
}

static void unpack_11_16bit_unsigned_6off(const uint8_t * input, double * output, void *closure) {
	// Unpack 11 values into output
	// Values are 16-bit unsigned
	// Skip 6 bits, read 176 bits of data.
	// Input must be at least 23 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 6 to 21
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)(input[2] & 0xfc) << 14);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 22 to 37
	value = ((uint32_t)(input[2] & 0x03) << 30) |
			((uint32_t)input[3] << 22) |
			((uint32_t)(input[4] & 0xfc) << 14);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 38 to 53
	value = ((uint32_t)(input[4] & 0x03) << 30) |
			((uint32_t)input[5] << 22) |
			((uint32_t)(input[6] & 0xfc) << 14);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 54 to 69
	value = ((uint32_t)(input[6] & 0x03) << 30) |
			((uint32_t)input[7] << 22) |
			((uint32_t)(input[8] & 0xfc) << 14);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 70 to 85
	value = ((uint32_t)(input[8] & 0x03) << 30) |
			((uint32_t)input[9] << 22) |
			((uint32_t)(input[10] & 0xfc) << 14);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 86 to 101
	value = ((uint32_t)(input[10] & 0x03) << 30) |
			((uint32_t)input[11] << 22) |
			((uint32_t)(input[12] & 0xfc) << 14);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 102 to 117
	value = ((uint32_t)(input[12] & 0x03) << 30) |
			((uint32_t)input[13] << 22) |
			((uint32_t)(input[14] & 0xfc) << 14);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 118 to 133
	value = ((uint32_t)(input[14] & 0x03) << 30) |
			((uint32_t)input[15] << 22) |
			((uint32_t)(input[16] & 0xfc) << 14);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 134 to 149
	value = ((uint32_t)(input[16] & 0x03) << 30) |
			((uint32_t)input[17] << 22) |
			((uint32_t)(input[18] & 0xfc) << 14);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 150 to 165
	value = ((uint32_t)(input[18] & 0x03) << 30) |
			((uint32_t)input[19] << 22) |
			((uint32_t)(input[20] & 0xfc) << 14);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 166 to 181
	value = ((uint32_t)(input[20] & 0x03) << 30) |
			((uint32_t)input[21] << 22) |
			((uint32_t)(input[22] & 0xfc) << 14);
	output[10] = (double)(value >> 16);
}

static void unpack_11_16bit_signed_7off(const uint8_t * input, double * output, void *closure) {
	// Unpack 11 values into output
	// Values are 16-bit signed
	// Skip 7 bits, read 176 bits of data.
	// Input must be at least 23 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 7 to 22
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)(input[2] & 0xfe) << 15);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 23 to 38
	value = ((uint32_t)(input[2] & 0x01) << 31) |
			((uint32_t)input[3] << 23) |
			((uint32_t)(input[4] & 0xfe) << 15);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 39 to 54
	value = ((uint32_t)(input[4] & 0x01) << 31) |
			((uint32_t)input[5] << 23) |
			((uint32_t)(input[6] & 0xfe) << 15);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 55 to 70
	value = ((uint32_t)(input[6] & 0x01) << 31) |
			((uint32_t)input[7] << 23) |
			((uint32_t)(input[8] & 0xfe) << 15);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 71 to 86
	value = ((uint32_t)(input[8] & 0x01) << 31) |
			((uint32_t)input[9] << 23) |
			((uint32_t)(input[10] & 0xfe) << 15);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 87 to 102
	value = ((uint32_t)(input[10] & 0x01) << 31) |
			((uint32_t)input[11] << 23) |
			((uint32_t)(input[12] & 0xfe) << 15);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 103 to 118
	value = ((uint32_t)(input[12] & 0x01) << 31) |
			((uint32_t)input[13] << 23) |
			((uint32_t)(input[14] & 0xfe) << 15);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 119 to 134
	value = ((uint32_t)(input[14] & 0x01) << 31) |
			((uint32_t)input[15] << 23) |
			((uint32_t)(input[16] & 0xfe) << 15);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 135 to 150
	value = ((uint32_t)(input[16] & 0x01) << 31) |
			((uint32_t)input[17] << 23) |
			((uint32_t)(input[18] & 0xfe) << 15);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 151 to 166
	value = ((uint32_t)(input[18] & 0x01) << 31) |
			((uint32_t)input[19] << 23) |
			((uint32_t)(input[20] & 0xfe) << 15);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 167 to 182
	value = ((uint32_t)(input[20] & 0x01) << 31) |
			((uint32_t)input[21] << 23) |
			((uint32_t)(input[22] & 0xfe) << 15);
	output[10] = (double)(value >> 16);
}

static void unpack_11_16bit_unsigned_7off(const uint8_t * input, double * output, void *closure) {
	// Unpack 11 values into output
	// Values are 16-bit unsigned
	// Skip 7 bits, read 176 bits of data.
	// Input must be at least 23 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 7 to 22
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)(input[2] & 0xfe) << 15);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 23 to 38
	value = ((uint32_t)(input[2] & 0x01) << 31) |
			((uint32_t)input[3] << 23) |
			((uint32_t)(input[4] & 0xfe) << 15);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 39 to 54
	value = ((uint32_t)(input[4] & 0x01) << 31) |
			((uint32_t)input[5] << 23) |
			((uint32_t)(input[6] & 0xfe) << 15);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 55 to 70
	value = ((uint32_t)(input[6] & 0x01) << 31) |
			((uint32_t)input[7] << 23) |
			((uint32_t)(input[8] & 0xfe) << 15);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 71 to 86
	value = ((uint32_t)(input[8] & 0x01) << 31) |
			((uint32_t)input[9] << 23) |
			((uint32_t)(input[10] & 0xfe) << 15);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 87 to 102
	value = ((uint32_t)(input[10] & 0x01) << 31) |
			((uint32_t)input[11] << 23) |
			((uint32_t)(input[12] & 0xfe) << 15);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 103 to 118
	value = ((uint32_t)(input[12] & 0x01) << 31) |
			((uint32_t)input[13] << 23) |
			((uint32_t)(input[14] & 0xfe) << 15);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 119 to 134
	value = ((uint32_t)(input[14] & 0x01) << 31) |
			((uint32_t)input[15] << 23) |
			((uint32_t)(input[16] & 0xfe) << 15);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 135 to 150
	value = ((uint32_t)(input[16] & 0x01) << 31) |
			((uint32_t)input[17] << 23) |
			((uint32_t)(input[18] & 0xfe) << 15);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 151 to 166
	value = ((uint32_t)(input[18] & 0x01) << 31) |
			((uint32_t)input[19] << 23) |
			((uint32_t)(input[20] & 0xfe) << 15);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 167 to 182
	value = ((uint32_t)(input[20] & 0x01) << 31) |
			((uint32_t)input[21] << 23) |
			((uint32_t)(input[22] & 0xfe) << 15);
	output[10] = (double)(value >> 16);
}

static void unpack_12_16bit_signed_0off(const uint8_t * input, double * output, void *closure) {
	// Unpack 12 values into output
	// Values are 16-bit signed
	// Skip 0 bits, read 192 bits of data.
	// Input must be at least 24 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 0 to 15
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)input[1] << 16);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 16 to 31
	value = ((uint32_t)input[2] << 24) |
			((uint32_t)input[3] << 16);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 32 to 47
	value = ((uint32_t)input[4] << 24) |
			((uint32_t)input[5] << 16);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 48 to 63
	value = ((uint32_t)input[6] << 24) |
			((uint32_t)input[7] << 16);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 64 to 79
	value = ((uint32_t)input[8] << 24) |
			((uint32_t)input[9] << 16);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 80 to 95
	value = ((uint32_t)input[10] << 24) |
			((uint32_t)input[11] << 16);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 96 to 111
	value = ((uint32_t)input[12] << 24) |
			((uint32_t)input[13] << 16);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 112 to 127
	value = ((uint32_t)input[14] << 24) |
			((uint32_t)input[15] << 16);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 128 to 143
	value = ((uint32_t)input[16] << 24) |
			((uint32_t)input[17] << 16);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 144 to 159
	value = ((uint32_t)input[18] << 24) |
			((uint32_t)input[19] << 16);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 160 to 175
	value = ((uint32_t)input[20] << 24) |
			((uint32_t)input[21] << 16);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 176 to 191
	value = ((uint32_t)input[22] << 24) |
			((uint32_t)input[23] << 16);
	output[11] = (double)(value >> 16);
}

static void unpack_12_16bit_unsigned_0off(const uint8_t * input, double * output, void *closure) {
	// Unpack 12 values into output
	// Values are 16-bit unsigned
	// Skip 0 bits, read 192 bits of data.
	// Input must be at least 24 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 0 to 15
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)input[1] << 16);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 16 to 31
	value = ((uint32_t)input[2] << 24) |
			((uint32_t)input[3] << 16);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 32 to 47
	value = ((uint32_t)input[4] << 24) |
			((uint32_t)input[5] << 16);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 48 to 63
	value = ((uint32_t)input[6] << 24) |
			((uint32_t)input[7] << 16);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 64 to 79
	value = ((uint32_t)input[8] << 24) |
			((uint32_t)input[9] << 16);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 80 to 95
	value = ((uint32_t)input[10] << 24) |
			((uint32_t)input[11] << 16);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 96 to 111
	value = ((uint32_t)input[12] << 24) |
			((uint32_t)input[13] << 16);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 112 to 127
	value = ((uint32_t)input[14] << 24) |
			((uint32_t)input[15] << 16);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 128 to 143
	value = ((uint32_t)input[16] << 24) |
			((uint32_t)input[17] << 16);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 144 to 159
	value = ((uint32_t)input[18] << 24) |
			((uint32_t)input[19] << 16);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 160 to 175
	value = ((uint32_t)input[20] << 24) |
			((uint32_t)input[21] << 16);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 176 to 191
	value = ((uint32_t)input[22] << 24) |
			((uint32_t)input[23] << 16);
	output[11] = (double)(value >> 16);
}

static void unpack_12_16bit_signed_1off(const uint8_t * input, double * output, void *closure) {
	// Unpack 12 values into output
	// Values are 16-bit signed
	// Skip 1 bits, read 192 bits of data.
	// Input must be at least 25 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 1 to 16
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)input[1] << 17) |
			((uint32_t)(input[2] & 0x80) << 9);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 17 to 32
	value = ((uint32_t)(input[2] & 0x7f) << 25) |
			((uint32_t)input[3] << 17) |
			((uint32_t)(input[4] & 0x80) << 9);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 33 to 48
	value = ((uint32_t)(input[4] & 0x7f) << 25) |
			((uint32_t)input[5] << 17) |
			((uint32_t)(input[6] & 0x80) << 9);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 49 to 64
	value = ((uint32_t)(input[6] & 0x7f) << 25) |
			((uint32_t)input[7] << 17) |
			((uint32_t)(input[8] & 0x80) << 9);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 65 to 80
	value = ((uint32_t)(input[8] & 0x7f) << 25) |
			((uint32_t)input[9] << 17) |
			((uint32_t)(input[10] & 0x80) << 9);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 81 to 96
	value = ((uint32_t)(input[10] & 0x7f) << 25) |
			((uint32_t)input[11] << 17) |
			((uint32_t)(input[12] & 0x80) << 9);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 97 to 112
	value = ((uint32_t)(input[12] & 0x7f) << 25) |
			((uint32_t)input[13] << 17) |
			((uint32_t)(input[14] & 0x80) << 9);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 113 to 128
	value = ((uint32_t)(input[14] & 0x7f) << 25) |
			((uint32_t)input[15] << 17) |
			((uint32_t)(input[16] & 0x80) << 9);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 129 to 144
	value = ((uint32_t)(input[16] & 0x7f) << 25) |
			((uint32_t)input[17] << 17) |
			((uint32_t)(input[18] & 0x80) << 9);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 145 to 160
	value = ((uint32_t)(input[18] & 0x7f) << 25) |
			((uint32_t)input[19] << 17) |
			((uint32_t)(input[20] & 0x80) << 9);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 161 to 176
	value = ((uint32_t)(input[20] & 0x7f) << 25) |
			((uint32_t)input[21] << 17) |
			((uint32_t)(input[22] & 0x80) << 9);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 177 to 192
	value = ((uint32_t)(input[22] & 0x7f) << 25) |
			((uint32_t)input[23] << 17) |
			((uint32_t)(input[24] & 0x80) << 9);
	output[11] = (double)(value >> 16);
}

static void unpack_12_16bit_unsigned_1off(const uint8_t * input, double * output, void *closure) {
	// Unpack 12 values into output
	// Values are 16-bit unsigned
	// Skip 1 bits, read 192 bits of data.
	// Input must be at least 25 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 1 to 16
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)input[1] << 17) |
			((uint32_t)(input[2] & 0x80) << 9);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 17 to 32
	value = ((uint32_t)(input[2] & 0x7f) << 25) |
			((uint32_t)input[3] << 17) |
			((uint32_t)(input[4] & 0x80) << 9);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 33 to 48
	value = ((uint32_t)(input[4] & 0x7f) << 25) |
			((uint32_t)input[5] << 17) |
			((uint32_t)(input[6] & 0x80) << 9);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 49 to 64
	value = ((uint32_t)(input[6] & 0x7f) << 25) |
			((uint32_t)input[7] << 17) |
			((uint32_t)(input[8] & 0x80) << 9);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 65 to 80
	value = ((uint32_t)(input[8] & 0x7f) << 25) |
			((uint32_t)input[9] << 17) |
			((uint32_t)(input[10] & 0x80) << 9);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 81 to 96
	value = ((uint32_t)(input[10] & 0x7f) << 25) |
			((uint32_t)input[11] << 17) |
			((uint32_t)(input[12] & 0x80) << 9);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 97 to 112
	value = ((uint32_t)(input[12] & 0x7f) << 25) |
			((uint32_t)input[13] << 17) |
			((uint32_t)(input[14] & 0x80) << 9);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 113 to 128
	value = ((uint32_t)(input[14] & 0x7f) << 25) |
			((uint32_t)input[15] << 17) |
			((uint32_t)(input[16] & 0x80) << 9);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 129 to 144
	value = ((uint32_t)(input[16] & 0x7f) << 25) |
			((uint32_t)input[17] << 17) |
			((uint32_t)(input[18] & 0x80) << 9);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 145 to 160
	value = ((uint32_t)(input[18] & 0x7f) << 25) |
			((uint32_t)input[19] << 17) |
			((uint32_t)(input[20] & 0x80) << 9);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 161 to 176
	value = ((uint32_t)(input[20] & 0x7f) << 25) |
			((uint32_t)input[21] << 17) |
			((uint32_t)(input[22] & 0x80) << 9);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 177 to 192
	value = ((uint32_t)(input[22] & 0x7f) << 25) |
			((uint32_t)input[23] << 17) |
			((uint32_t)(input[24] & 0x80) << 9);
	output[11] = (double)(value >> 16);
}

static void unpack_12_16bit_signed_2off(const uint8_t * input, double * output, void *closure) {
	// Unpack 12 values into output
	// Values are 16-bit signed
	// Skip 2 bits, read 192 bits of data.
	// Input must be at least 25 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 2 to 17
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)input[1] << 18) |
			((uint32_t)(input[2] & 0xc0) << 10);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 18 to 33
	value = ((uint32_t)(input[2] & 0x3f) << 26) |
			((uint32_t)input[3] << 18) |
			((uint32_t)(input[4] & 0xc0) << 10);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 34 to 49
	value = ((uint32_t)(input[4] & 0x3f) << 26) |
			((uint32_t)input[5] << 18) |
			((uint32_t)(input[6] & 0xc0) << 10);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 50 to 65
	value = ((uint32_t)(input[6] & 0x3f) << 26) |
			((uint32_t)input[7] << 18) |
			((uint32_t)(input[8] & 0xc0) << 10);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 66 to 81
	value = ((uint32_t)(input[8] & 0x3f) << 26) |
			((uint32_t)input[9] << 18) |
			((uint32_t)(input[10] & 0xc0) << 10);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 82 to 97
	value = ((uint32_t)(input[10] & 0x3f) << 26) |
			((uint32_t)input[11] << 18) |
			((uint32_t)(input[12] & 0xc0) << 10);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 98 to 113
	value = ((uint32_t)(input[12] & 0x3f) << 26) |
			((uint32_t)input[13] << 18) |
			((uint32_t)(input[14] & 0xc0) << 10);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 114 to 129
	value = ((uint32_t)(input[14] & 0x3f) << 26) |
			((uint32_t)input[15] << 18) |
			((uint32_t)(input[16] & 0xc0) << 10);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 130 to 145
	value = ((uint32_t)(input[16] & 0x3f) << 26) |
			((uint32_t)input[17] << 18) |
			((uint32_t)(input[18] & 0xc0) << 10);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 146 to 161
	value = ((uint32_t)(input[18] & 0x3f) << 26) |
			((uint32_t)input[19] << 18) |
			((uint32_t)(input[20] & 0xc0) << 10);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 162 to 177
	value = ((uint32_t)(input[20] & 0x3f) << 26) |
			((uint32_t)input[21] << 18) |
			((uint32_t)(input[22] & 0xc0) << 10);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 178 to 193
	value = ((uint32_t)(input[22] & 0x3f) << 26) |
			((uint32_t)input[23] << 18) |
			((uint32_t)(input[24] & 0xc0) << 10);
	output[11] = (double)(value >> 16);
}

static void unpack_12_16bit_unsigned_2off(const uint8_t * input, double * output, void *closure) {
	// Unpack 12 values into output
	// Values are 16-bit unsigned
	// Skip 2 bits, read 192 bits of data.
	// Input must be at least 25 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 2 to 17
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)input[1] << 18) |
			((uint32_t)(input[2] & 0xc0) << 10);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 18 to 33
	value = ((uint32_t)(input[2] & 0x3f) << 26) |
			((uint32_t)input[3] << 18) |
			((uint32_t)(input[4] & 0xc0) << 10);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 34 to 49
	value = ((uint32_t)(input[4] & 0x3f) << 26) |
			((uint32_t)input[5] << 18) |
			((uint32_t)(input[6] & 0xc0) << 10);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 50 to 65
	value = ((uint32_t)(input[6] & 0x3f) << 26) |
			((uint32_t)input[7] << 18) |
			((uint32_t)(input[8] & 0xc0) << 10);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 66 to 81
	value = ((uint32_t)(input[8] & 0x3f) << 26) |
			((uint32_t)input[9] << 18) |
			((uint32_t)(input[10] & 0xc0) << 10);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 82 to 97
	value = ((uint32_t)(input[10] & 0x3f) << 26) |
			((uint32_t)input[11] << 18) |
			((uint32_t)(input[12] & 0xc0) << 10);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 98 to 113
	value = ((uint32_t)(input[12] & 0x3f) << 26) |
			((uint32_t)input[13] << 18) |
			((uint32_t)(input[14] & 0xc0) << 10);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 114 to 129
	value = ((uint32_t)(input[14] & 0x3f) << 26) |
			((uint32_t)input[15] << 18) |
			((uint32_t)(input[16] & 0xc0) << 10);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 130 to 145
	value = ((uint32_t)(input[16] & 0x3f) << 26) |
			((uint32_t)input[17] << 18) |
			((uint32_t)(input[18] & 0xc0) << 10);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 146 to 161
	value = ((uint32_t)(input[18] & 0x3f) << 26) |
			((uint32_t)input[19] << 18) |
			((uint32_t)(input[20] & 0xc0) << 10);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 162 to 177
	value = ((uint32_t)(input[20] & 0x3f) << 26) |
			((uint32_t)input[21] << 18) |
			((uint32_t)(input[22] & 0xc0) << 10);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 178 to 193
	value = ((uint32_t)(input[22] & 0x3f) << 26) |
			((uint32_t)input[23] << 18) |
			((uint32_t)(input[24] & 0xc0) << 10);
	output[11] = (double)(value >> 16);
}

static void unpack_12_16bit_signed_3off(const uint8_t * input, double * output, void *closure) {
	// Unpack 12 values into output
	// Values are 16-bit signed
	// Skip 3 bits, read 192 bits of data.
	// Input must be at least 25 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 3 to 18
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)input[1] << 19) |
			((uint32_t)(input[2] & 0xe0) << 11);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 19 to 34
	value = ((uint32_t)(input[2] & 0x1f) << 27) |
			((uint32_t)input[3] << 19) |
			((uint32_t)(input[4] & 0xe0) << 11);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 35 to 50
	value = ((uint32_t)(input[4] & 0x1f) << 27) |
			((uint32_t)input[5] << 19) |
			((uint32_t)(input[6] & 0xe0) << 11);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 51 to 66
	value = ((uint32_t)(input[6] & 0x1f) << 27) |
			((uint32_t)input[7] << 19) |
			((uint32_t)(input[8] & 0xe0) << 11);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 67 to 82
	value = ((uint32_t)(input[8] & 0x1f) << 27) |
			((uint32_t)input[9] << 19) |
			((uint32_t)(input[10] & 0xe0) << 11);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 83 to 98
	value = ((uint32_t)(input[10] & 0x1f) << 27) |
			((uint32_t)input[11] << 19) |
			((uint32_t)(input[12] & 0xe0) << 11);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 99 to 114
	value = ((uint32_t)(input[12] & 0x1f) << 27) |
			((uint32_t)input[13] << 19) |
			((uint32_t)(input[14] & 0xe0) << 11);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 115 to 130
	value = ((uint32_t)(input[14] & 0x1f) << 27) |
			((uint32_t)input[15] << 19) |
			((uint32_t)(input[16] & 0xe0) << 11);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 131 to 146
	value = ((uint32_t)(input[16] & 0x1f) << 27) |
			((uint32_t)input[17] << 19) |
			((uint32_t)(input[18] & 0xe0) << 11);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 147 to 162
	value = ((uint32_t)(input[18] & 0x1f) << 27) |
			((uint32_t)input[19] << 19) |
			((uint32_t)(input[20] & 0xe0) << 11);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 163 to 178
	value = ((uint32_t)(input[20] & 0x1f) << 27) |
			((uint32_t)input[21] << 19) |
			((uint32_t)(input[22] & 0xe0) << 11);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 179 to 194
	value = ((uint32_t)(input[22] & 0x1f) << 27) |
			((uint32_t)input[23] << 19) |
			((uint32_t)(input[24] & 0xe0) << 11);
	output[11] = (double)(value >> 16);
}

static void unpack_12_16bit_unsigned_3off(const uint8_t * input, double * output, void *closure) {
	// Unpack 12 values into output
	// Values are 16-bit unsigned
	// Skip 3 bits, read 192 bits of data.
	// Input must be at least 25 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 3 to 18
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)input[1] << 19) |
			((uint32_t)(input[2] & 0xe0) << 11);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 19 to 34
	value = ((uint32_t)(input[2] & 0x1f) << 27) |
			((uint32_t)input[3] << 19) |
			((uint32_t)(input[4] & 0xe0) << 11);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 35 to 50
	value = ((uint32_t)(input[4] & 0x1f) << 27) |
			((uint32_t)input[5] << 19) |
			((uint32_t)(input[6] & 0xe0) << 11);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 51 to 66
	value = ((uint32_t)(input[6] & 0x1f) << 27) |
			((uint32_t)input[7] << 19) |
			((uint32_t)(input[8] & 0xe0) << 11);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 67 to 82
	value = ((uint32_t)(input[8] & 0x1f) << 27) |
			((uint32_t)input[9] << 19) |
			((uint32_t)(input[10] & 0xe0) << 11);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 83 to 98
	value = ((uint32_t)(input[10] & 0x1f) << 27) |
			((uint32_t)input[11] << 19) |
			((uint32_t)(input[12] & 0xe0) << 11);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 99 to 114
	value = ((uint32_t)(input[12] & 0x1f) << 27) |
			((uint32_t)input[13] << 19) |
			((uint32_t)(input[14] & 0xe0) << 11);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 115 to 130
	value = ((uint32_t)(input[14] & 0x1f) << 27) |
			((uint32_t)input[15] << 19) |
			((uint32_t)(input[16] & 0xe0) << 11);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 131 to 146
	value = ((uint32_t)(input[16] & 0x1f) << 27) |
			((uint32_t)input[17] << 19) |
			((uint32_t)(input[18] & 0xe0) << 11);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 147 to 162
	value = ((uint32_t)(input[18] & 0x1f) << 27) |
			((uint32_t)input[19] << 19) |
			((uint32_t)(input[20] & 0xe0) << 11);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 163 to 178
	value = ((uint32_t)(input[20] & 0x1f) << 27) |
			((uint32_t)input[21] << 19) |
			((uint32_t)(input[22] & 0xe0) << 11);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 179 to 194
	value = ((uint32_t)(input[22] & 0x1f) << 27) |
			((uint32_t)input[23] << 19) |
			((uint32_t)(input[24] & 0xe0) << 11);
	output[11] = (double)(value >> 16);
}

static void unpack_12_16bit_signed_4off(const uint8_t * input, double * output, void *closure) {
	// Unpack 12 values into output
	// Values are 16-bit signed
	// Skip 4 bits, read 192 bits of data.
	// Input must be at least 25 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 4 to 19
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20) |
			((uint32_t)(input[2] & 0xf0) << 12);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 20 to 35
	value = ((uint32_t)(input[2] & 0x0f) << 28) |
			((uint32_t)input[3] << 20) |
			((uint32_t)(input[4] & 0xf0) << 12);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 36 to 51
	value = ((uint32_t)(input[4] & 0x0f) << 28) |
			((uint32_t)input[5] << 20) |
			((uint32_t)(input[6] & 0xf0) << 12);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 52 to 67
	value = ((uint32_t)(input[6] & 0x0f) << 28) |
			((uint32_t)input[7] << 20) |
			((uint32_t)(input[8] & 0xf0) << 12);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 68 to 83
	value = ((uint32_t)(input[8] & 0x0f) << 28) |
			((uint32_t)input[9] << 20) |
			((uint32_t)(input[10] & 0xf0) << 12);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 84 to 99
	value = ((uint32_t)(input[10] & 0x0f) << 28) |
			((uint32_t)input[11] << 20) |
			((uint32_t)(input[12] & 0xf0) << 12);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 100 to 115
	value = ((uint32_t)(input[12] & 0x0f) << 28) |
			((uint32_t)input[13] << 20) |
			((uint32_t)(input[14] & 0xf0) << 12);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 116 to 131
	value = ((uint32_t)(input[14] & 0x0f) << 28) |
			((uint32_t)input[15] << 20) |
			((uint32_t)(input[16] & 0xf0) << 12);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 132 to 147
	value = ((uint32_t)(input[16] & 0x0f) << 28) |
			((uint32_t)input[17] << 20) |
			((uint32_t)(input[18] & 0xf0) << 12);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 148 to 163
	value = ((uint32_t)(input[18] & 0x0f) << 28) |
			((uint32_t)input[19] << 20) |
			((uint32_t)(input[20] & 0xf0) << 12);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 164 to 179
	value = ((uint32_t)(input[20] & 0x0f) << 28) |
			((uint32_t)input[21] << 20) |
			((uint32_t)(input[22] & 0xf0) << 12);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 180 to 195
	value = ((uint32_t)(input[22] & 0x0f) << 28) |
			((uint32_t)input[23] << 20) |
			((uint32_t)(input[24] & 0xf0) << 12);
	output[11] = (double)(value >> 16);
}

static void unpack_12_16bit_unsigned_4off(const uint8_t * input, double * output, void *closure) {
	// Unpack 12 values into output
	// Values are 16-bit unsigned
	// Skip 4 bits, read 192 bits of data.
	// Input must be at least 25 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 4 to 19
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20) |
			((uint32_t)(input[2] & 0xf0) << 12);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 20 to 35
	value = ((uint32_t)(input[2] & 0x0f) << 28) |
			((uint32_t)input[3] << 20) |
			((uint32_t)(input[4] & 0xf0) << 12);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 36 to 51
	value = ((uint32_t)(input[4] & 0x0f) << 28) |
			((uint32_t)input[5] << 20) |
			((uint32_t)(input[6] & 0xf0) << 12);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 52 to 67
	value = ((uint32_t)(input[6] & 0x0f) << 28) |
			((uint32_t)input[7] << 20) |
			((uint32_t)(input[8] & 0xf0) << 12);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 68 to 83
	value = ((uint32_t)(input[8] & 0x0f) << 28) |
			((uint32_t)input[9] << 20) |
			((uint32_t)(input[10] & 0xf0) << 12);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 84 to 99
	value = ((uint32_t)(input[10] & 0x0f) << 28) |
			((uint32_t)input[11] << 20) |
			((uint32_t)(input[12] & 0xf0) << 12);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 100 to 115
	value = ((uint32_t)(input[12] & 0x0f) << 28) |
			((uint32_t)input[13] << 20) |
			((uint32_t)(input[14] & 0xf0) << 12);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 116 to 131
	value = ((uint32_t)(input[14] & 0x0f) << 28) |
			((uint32_t)input[15] << 20) |
			((uint32_t)(input[16] & 0xf0) << 12);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 132 to 147
	value = ((uint32_t)(input[16] & 0x0f) << 28) |
			((uint32_t)input[17] << 20) |
			((uint32_t)(input[18] & 0xf0) << 12);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 148 to 163
	value = ((uint32_t)(input[18] & 0x0f) << 28) |
			((uint32_t)input[19] << 20) |
			((uint32_t)(input[20] & 0xf0) << 12);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 164 to 179
	value = ((uint32_t)(input[20] & 0x0f) << 28) |
			((uint32_t)input[21] << 20) |
			((uint32_t)(input[22] & 0xf0) << 12);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 180 to 195
	value = ((uint32_t)(input[22] & 0x0f) << 28) |
			((uint32_t)input[23] << 20) |
			((uint32_t)(input[24] & 0xf0) << 12);
	output[11] = (double)(value >> 16);
}

static void unpack_12_16bit_signed_5off(const uint8_t * input, double * output, void *closure) {
	// Unpack 12 values into output
	// Values are 16-bit signed
	// Skip 5 bits, read 192 bits of data.
	// Input must be at least 25 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 5 to 20
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)(input[2] & 0xf8) << 13);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 21 to 36
	value = ((uint32_t)(input[2] & 0x07) << 29) |
			((uint32_t)input[3] << 21) |
			((uint32_t)(input[4] & 0xf8) << 13);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 37 to 52
	value = ((uint32_t)(input[4] & 0x07) << 29) |
			((uint32_t)input[5] << 21) |
			((uint32_t)(input[6] & 0xf8) << 13);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 53 to 68
	value = ((uint32_t)(input[6] & 0x07) << 29) |
			((uint32_t)input[7] << 21) |
			((uint32_t)(input[8] & 0xf8) << 13);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 69 to 84
	value = ((uint32_t)(input[8] & 0x07) << 29) |
			((uint32_t)input[9] << 21) |
			((uint32_t)(input[10] & 0xf8) << 13);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 85 to 100
	value = ((uint32_t)(input[10] & 0x07) << 29) |
			((uint32_t)input[11] << 21) |
			((uint32_t)(input[12] & 0xf8) << 13);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 101 to 116
	value = ((uint32_t)(input[12] & 0x07) << 29) |
			((uint32_t)input[13] << 21) |
			((uint32_t)(input[14] & 0xf8) << 13);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 117 to 132
	value = ((uint32_t)(input[14] & 0x07) << 29) |
			((uint32_t)input[15] << 21) |
			((uint32_t)(input[16] & 0xf8) << 13);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 133 to 148
	value = ((uint32_t)(input[16] & 0x07) << 29) |
			((uint32_t)input[17] << 21) |
			((uint32_t)(input[18] & 0xf8) << 13);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 149 to 164
	value = ((uint32_t)(input[18] & 0x07) << 29) |
			((uint32_t)input[19] << 21) |
			((uint32_t)(input[20] & 0xf8) << 13);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 165 to 180
	value = ((uint32_t)(input[20] & 0x07) << 29) |
			((uint32_t)input[21] << 21) |
			((uint32_t)(input[22] & 0xf8) << 13);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 181 to 196
	value = ((uint32_t)(input[22] & 0x07) << 29) |
			((uint32_t)input[23] << 21) |
			((uint32_t)(input[24] & 0xf8) << 13);
	output[11] = (double)(value >> 16);
}

static void unpack_12_16bit_unsigned_5off(const uint8_t * input, double * output, void *closure) {
	// Unpack 12 values into output
	// Values are 16-bit unsigned
	// Skip 5 bits, read 192 bits of data.
	// Input must be at least 25 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 5 to 20
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)(input[2] & 0xf8) << 13);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 21 to 36
	value = ((uint32_t)(input[2] & 0x07) << 29) |
			((uint32_t)input[3] << 21) |
			((uint32_t)(input[4] & 0xf8) << 13);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 37 to 52
	value = ((uint32_t)(input[4] & 0x07) << 29) |
			((uint32_t)input[5] << 21) |
			((uint32_t)(input[6] & 0xf8) << 13);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 53 to 68
	value = ((uint32_t)(input[6] & 0x07) << 29) |
			((uint32_t)input[7] << 21) |
			((uint32_t)(input[8] & 0xf8) << 13);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 69 to 84
	value = ((uint32_t)(input[8] & 0x07) << 29) |
			((uint32_t)input[9] << 21) |
			((uint32_t)(input[10] & 0xf8) << 13);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 85 to 100
	value = ((uint32_t)(input[10] & 0x07) << 29) |
			((uint32_t)input[11] << 21) |
			((uint32_t)(input[12] & 0xf8) << 13);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 101 to 116
	value = ((uint32_t)(input[12] & 0x07) << 29) |
			((uint32_t)input[13] << 21) |
			((uint32_t)(input[14] & 0xf8) << 13);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 117 to 132
	value = ((uint32_t)(input[14] & 0x07) << 29) |
			((uint32_t)input[15] << 21) |
			((uint32_t)(input[16] & 0xf8) << 13);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 133 to 148
	value = ((uint32_t)(input[16] & 0x07) << 29) |
			((uint32_t)input[17] << 21) |
			((uint32_t)(input[18] & 0xf8) << 13);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 149 to 164
	value = ((uint32_t)(input[18] & 0x07) << 29) |
			((uint32_t)input[19] << 21) |
			((uint32_t)(input[20] & 0xf8) << 13);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 165 to 180
	value = ((uint32_t)(input[20] & 0x07) << 29) |
			((uint32_t)input[21] << 21) |
			((uint32_t)(input[22] & 0xf8) << 13);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 181 to 196
	value = ((uint32_t)(input[22] & 0x07) << 29) |
			((uint32_t)input[23] << 21) |
			((uint32_t)(input[24] & 0xf8) << 13);
	output[11] = (double)(value >> 16);
}

static void unpack_12_16bit_signed_6off(const uint8_t * input, double * output, void *closure) {
	// Unpack 12 values into output
	// Values are 16-bit signed
	// Skip 6 bits, read 192 bits of data.
	// Input must be at least 25 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 6 to 21
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)(input[2] & 0xfc) << 14);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 22 to 37
	value = ((uint32_t)(input[2] & 0x03) << 30) |
			((uint32_t)input[3] << 22) |
			((uint32_t)(input[4] & 0xfc) << 14);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 38 to 53
	value = ((uint32_t)(input[4] & 0x03) << 30) |
			((uint32_t)input[5] << 22) |
			((uint32_t)(input[6] & 0xfc) << 14);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 54 to 69
	value = ((uint32_t)(input[6] & 0x03) << 30) |
			((uint32_t)input[7] << 22) |
			((uint32_t)(input[8] & 0xfc) << 14);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 70 to 85
	value = ((uint32_t)(input[8] & 0x03) << 30) |
			((uint32_t)input[9] << 22) |
			((uint32_t)(input[10] & 0xfc) << 14);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 86 to 101
	value = ((uint32_t)(input[10] & 0x03) << 30) |
			((uint32_t)input[11] << 22) |
			((uint32_t)(input[12] & 0xfc) << 14);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 102 to 117
	value = ((uint32_t)(input[12] & 0x03) << 30) |
			((uint32_t)input[13] << 22) |
			((uint32_t)(input[14] & 0xfc) << 14);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 118 to 133
	value = ((uint32_t)(input[14] & 0x03) << 30) |
			((uint32_t)input[15] << 22) |
			((uint32_t)(input[16] & 0xfc) << 14);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 134 to 149
	value = ((uint32_t)(input[16] & 0x03) << 30) |
			((uint32_t)input[17] << 22) |
			((uint32_t)(input[18] & 0xfc) << 14);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 150 to 165
	value = ((uint32_t)(input[18] & 0x03) << 30) |
			((uint32_t)input[19] << 22) |
			((uint32_t)(input[20] & 0xfc) << 14);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 166 to 181
	value = ((uint32_t)(input[20] & 0x03) << 30) |
			((uint32_t)input[21] << 22) |
			((uint32_t)(input[22] & 0xfc) << 14);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 182 to 197
	value = ((uint32_t)(input[22] & 0x03) << 30) |
			((uint32_t)input[23] << 22) |
			((uint32_t)(input[24] & 0xfc) << 14);
	output[11] = (double)(value >> 16);
}

static void unpack_12_16bit_unsigned_6off(const uint8_t * input, double * output, void *closure) {
	// Unpack 12 values into output
	// Values are 16-bit unsigned
	// Skip 6 bits, read 192 bits of data.
	// Input must be at least 25 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 6 to 21
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)(input[2] & 0xfc) << 14);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 22 to 37
	value = ((uint32_t)(input[2] & 0x03) << 30) |
			((uint32_t)input[3] << 22) |
			((uint32_t)(input[4] & 0xfc) << 14);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 38 to 53
	value = ((uint32_t)(input[4] & 0x03) << 30) |
			((uint32_t)input[5] << 22) |
			((uint32_t)(input[6] & 0xfc) << 14);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 54 to 69
	value = ((uint32_t)(input[6] & 0x03) << 30) |
			((uint32_t)input[7] << 22) |
			((uint32_t)(input[8] & 0xfc) << 14);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 70 to 85
	value = ((uint32_t)(input[8] & 0x03) << 30) |
			((uint32_t)input[9] << 22) |
			((uint32_t)(input[10] & 0xfc) << 14);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 86 to 101
	value = ((uint32_t)(input[10] & 0x03) << 30) |
			((uint32_t)input[11] << 22) |
			((uint32_t)(input[12] & 0xfc) << 14);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 102 to 117
	value = ((uint32_t)(input[12] & 0x03) << 30) |
			((uint32_t)input[13] << 22) |
			((uint32_t)(input[14] & 0xfc) << 14);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 118 to 133
	value = ((uint32_t)(input[14] & 0x03) << 30) |
			((uint32_t)input[15] << 22) |
			((uint32_t)(input[16] & 0xfc) << 14);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 134 to 149
	value = ((uint32_t)(input[16] & 0x03) << 30) |
			((uint32_t)input[17] << 22) |
			((uint32_t)(input[18] & 0xfc) << 14);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 150 to 165
	value = ((uint32_t)(input[18] & 0x03) << 30) |
			((uint32_t)input[19] << 22) |
			((uint32_t)(input[20] & 0xfc) << 14);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 166 to 181
	value = ((uint32_t)(input[20] & 0x03) << 30) |
			((uint32_t)input[21] << 22) |
			((uint32_t)(input[22] & 0xfc) << 14);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 182 to 197
	value = ((uint32_t)(input[22] & 0x03) << 30) |
			((uint32_t)input[23] << 22) |
			((uint32_t)(input[24] & 0xfc) << 14);
	output[11] = (double)(value >> 16);
}

static void unpack_12_16bit_signed_7off(const uint8_t * input, double * output, void *closure) {
	// Unpack 12 values into output
	// Values are 16-bit signed
	// Skip 7 bits, read 192 bits of data.
	// Input must be at least 25 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 7 to 22
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)(input[2] & 0xfe) << 15);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 23 to 38
	value = ((uint32_t)(input[2] & 0x01) << 31) |
			((uint32_t)input[3] << 23) |
			((uint32_t)(input[4] & 0xfe) << 15);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 39 to 54
	value = ((uint32_t)(input[4] & 0x01) << 31) |
			((uint32_t)input[5] << 23) |
			((uint32_t)(input[6] & 0xfe) << 15);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 55 to 70
	value = ((uint32_t)(input[6] & 0x01) << 31) |
			((uint32_t)input[7] << 23) |
			((uint32_t)(input[8] & 0xfe) << 15);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 71 to 86
	value = ((uint32_t)(input[8] & 0x01) << 31) |
			((uint32_t)input[9] << 23) |
			((uint32_t)(input[10] & 0xfe) << 15);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 87 to 102
	value = ((uint32_t)(input[10] & 0x01) << 31) |
			((uint32_t)input[11] << 23) |
			((uint32_t)(input[12] & 0xfe) << 15);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 103 to 118
	value = ((uint32_t)(input[12] & 0x01) << 31) |
			((uint32_t)input[13] << 23) |
			((uint32_t)(input[14] & 0xfe) << 15);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 119 to 134
	value = ((uint32_t)(input[14] & 0x01) << 31) |
			((uint32_t)input[15] << 23) |
			((uint32_t)(input[16] & 0xfe) << 15);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 135 to 150
	value = ((uint32_t)(input[16] & 0x01) << 31) |
			((uint32_t)input[17] << 23) |
			((uint32_t)(input[18] & 0xfe) << 15);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 151 to 166
	value = ((uint32_t)(input[18] & 0x01) << 31) |
			((uint32_t)input[19] << 23) |
			((uint32_t)(input[20] & 0xfe) << 15);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 167 to 182
	value = ((uint32_t)(input[20] & 0x01) << 31) |
			((uint32_t)input[21] << 23) |
			((uint32_t)(input[22] & 0xfe) << 15);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 183 to 198
	value = ((uint32_t)(input[22] & 0x01) << 31) |
			((uint32_t)input[23] << 23) |
			((uint32_t)(input[24] & 0xfe) << 15);
	output[11] = (double)(value >> 16);
}

static void unpack_12_16bit_unsigned_7off(const uint8_t * input, double * output, void *closure) {
	// Unpack 12 values into output
	// Values are 16-bit unsigned
	// Skip 7 bits, read 192 bits of data.
	// Input must be at least 25 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 7 to 22
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)(input[2] & 0xfe) << 15);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 23 to 38
	value = ((uint32_t)(input[2] & 0x01) << 31) |
			((uint32_t)input[3] << 23) |
			((uint32_t)(input[4] & 0xfe) << 15);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 39 to 54
	value = ((uint32_t)(input[4] & 0x01) << 31) |
			((uint32_t)input[5] << 23) |
			((uint32_t)(input[6] & 0xfe) << 15);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 55 to 70
	value = ((uint32_t)(input[6] & 0x01) << 31) |
			((uint32_t)input[7] << 23) |
			((uint32_t)(input[8] & 0xfe) << 15);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 71 to 86
	value = ((uint32_t)(input[8] & 0x01) << 31) |
			((uint32_t)input[9] << 23) |
			((uint32_t)(input[10] & 0xfe) << 15);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 87 to 102
	value = ((uint32_t)(input[10] & 0x01) << 31) |
			((uint32_t)input[11] << 23) |
			((uint32_t)(input[12] & 0xfe) << 15);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 103 to 118
	value = ((uint32_t)(input[12] & 0x01) << 31) |
			((uint32_t)input[13] << 23) |
			((uint32_t)(input[14] & 0xfe) << 15);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 119 to 134
	value = ((uint32_t)(input[14] & 0x01) << 31) |
			((uint32_t)input[15] << 23) |
			((uint32_t)(input[16] & 0xfe) << 15);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 135 to 150
	value = ((uint32_t)(input[16] & 0x01) << 31) |
			((uint32_t)input[17] << 23) |
			((uint32_t)(input[18] & 0xfe) << 15);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 151 to 166
	value = ((uint32_t)(input[18] & 0x01) << 31) |
			((uint32_t)input[19] << 23) |
			((uint32_t)(input[20] & 0xfe) << 15);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 167 to 182
	value = ((uint32_t)(input[20] & 0x01) << 31) |
			((uint32_t)input[21] << 23) |
			((uint32_t)(input[22] & 0xfe) << 15);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 183 to 198
	value = ((uint32_t)(input[22] & 0x01) << 31) |
			((uint32_t)input[23] << 23) |
			((uint32_t)(input[24] & 0xfe) << 15);
	output[11] = (double)(value >> 16);
}

static void unpack_13_16bit_signed_0off(const uint8_t * input, double * output, void *closure) {
	// Unpack 13 values into output
	// Values are 16-bit signed
	// Skip 0 bits, read 208 bits of data.
	// Input must be at least 26 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 0 to 15
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)input[1] << 16);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 16 to 31
	value = ((uint32_t)input[2] << 24) |
			((uint32_t)input[3] << 16);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 32 to 47
	value = ((uint32_t)input[4] << 24) |
			((uint32_t)input[5] << 16);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 48 to 63
	value = ((uint32_t)input[6] << 24) |
			((uint32_t)input[7] << 16);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 64 to 79
	value = ((uint32_t)input[8] << 24) |
			((uint32_t)input[9] << 16);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 80 to 95
	value = ((uint32_t)input[10] << 24) |
			((uint32_t)input[11] << 16);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 96 to 111
	value = ((uint32_t)input[12] << 24) |
			((uint32_t)input[13] << 16);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 112 to 127
	value = ((uint32_t)input[14] << 24) |
			((uint32_t)input[15] << 16);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 128 to 143
	value = ((uint32_t)input[16] << 24) |
			((uint32_t)input[17] << 16);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 144 to 159
	value = ((uint32_t)input[18] << 24) |
			((uint32_t)input[19] << 16);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 160 to 175
	value = ((uint32_t)input[20] << 24) |
			((uint32_t)input[21] << 16);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 176 to 191
	value = ((uint32_t)input[22] << 24) |
			((uint32_t)input[23] << 16);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 192 to 207
	value = ((uint32_t)input[24] << 24) |
			((uint32_t)input[25] << 16);
	output[12] = (double)(value >> 16);
}

static void unpack_13_16bit_unsigned_0off(const uint8_t * input, double * output, void *closure) {
	// Unpack 13 values into output
	// Values are 16-bit unsigned
	// Skip 0 bits, read 208 bits of data.
	// Input must be at least 26 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 0 to 15
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)input[1] << 16);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 16 to 31
	value = ((uint32_t)input[2] << 24) |
			((uint32_t)input[3] << 16);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 32 to 47
	value = ((uint32_t)input[4] << 24) |
			((uint32_t)input[5] << 16);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 48 to 63
	value = ((uint32_t)input[6] << 24) |
			((uint32_t)input[7] << 16);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 64 to 79
	value = ((uint32_t)input[8] << 24) |
			((uint32_t)input[9] << 16);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 80 to 95
	value = ((uint32_t)input[10] << 24) |
			((uint32_t)input[11] << 16);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 96 to 111
	value = ((uint32_t)input[12] << 24) |
			((uint32_t)input[13] << 16);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 112 to 127
	value = ((uint32_t)input[14] << 24) |
			((uint32_t)input[15] << 16);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 128 to 143
	value = ((uint32_t)input[16] << 24) |
			((uint32_t)input[17] << 16);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 144 to 159
	value = ((uint32_t)input[18] << 24) |
			((uint32_t)input[19] << 16);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 160 to 175
	value = ((uint32_t)input[20] << 24) |
			((uint32_t)input[21] << 16);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 176 to 191
	value = ((uint32_t)input[22] << 24) |
			((uint32_t)input[23] << 16);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 192 to 207
	value = ((uint32_t)input[24] << 24) |
			((uint32_t)input[25] << 16);
	output[12] = (double)(value >> 16);
}

static void unpack_13_16bit_signed_1off(const uint8_t * input, double * output, void *closure) {
	// Unpack 13 values into output
	// Values are 16-bit signed
	// Skip 1 bits, read 208 bits of data.
	// Input must be at least 27 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 1 to 16
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)input[1] << 17) |
			((uint32_t)(input[2] & 0x80) << 9);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 17 to 32
	value = ((uint32_t)(input[2] & 0x7f) << 25) |
			((uint32_t)input[3] << 17) |
			((uint32_t)(input[4] & 0x80) << 9);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 33 to 48
	value = ((uint32_t)(input[4] & 0x7f) << 25) |
			((uint32_t)input[5] << 17) |
			((uint32_t)(input[6] & 0x80) << 9);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 49 to 64
	value = ((uint32_t)(input[6] & 0x7f) << 25) |
			((uint32_t)input[7] << 17) |
			((uint32_t)(input[8] & 0x80) << 9);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 65 to 80
	value = ((uint32_t)(input[8] & 0x7f) << 25) |
			((uint32_t)input[9] << 17) |
			((uint32_t)(input[10] & 0x80) << 9);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 81 to 96
	value = ((uint32_t)(input[10] & 0x7f) << 25) |
			((uint32_t)input[11] << 17) |
			((uint32_t)(input[12] & 0x80) << 9);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 97 to 112
	value = ((uint32_t)(input[12] & 0x7f) << 25) |
			((uint32_t)input[13] << 17) |
			((uint32_t)(input[14] & 0x80) << 9);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 113 to 128
	value = ((uint32_t)(input[14] & 0x7f) << 25) |
			((uint32_t)input[15] << 17) |
			((uint32_t)(input[16] & 0x80) << 9);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 129 to 144
	value = ((uint32_t)(input[16] & 0x7f) << 25) |
			((uint32_t)input[17] << 17) |
			((uint32_t)(input[18] & 0x80) << 9);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 145 to 160
	value = ((uint32_t)(input[18] & 0x7f) << 25) |
			((uint32_t)input[19] << 17) |
			((uint32_t)(input[20] & 0x80) << 9);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 161 to 176
	value = ((uint32_t)(input[20] & 0x7f) << 25) |
			((uint32_t)input[21] << 17) |
			((uint32_t)(input[22] & 0x80) << 9);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 177 to 192
	value = ((uint32_t)(input[22] & 0x7f) << 25) |
			((uint32_t)input[23] << 17) |
			((uint32_t)(input[24] & 0x80) << 9);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 193 to 208
	value = ((uint32_t)(input[24] & 0x7f) << 25) |
			((uint32_t)input[25] << 17) |
			((uint32_t)(input[26] & 0x80) << 9);
	output[12] = (double)(value >> 16);
}

static void unpack_13_16bit_unsigned_1off(const uint8_t * input, double * output, void *closure) {
	// Unpack 13 values into output
	// Values are 16-bit unsigned
	// Skip 1 bits, read 208 bits of data.
	// Input must be at least 27 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 1 to 16
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)input[1] << 17) |
			((uint32_t)(input[2] & 0x80) << 9);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 17 to 32
	value = ((uint32_t)(input[2] & 0x7f) << 25) |
			((uint32_t)input[3] << 17) |
			((uint32_t)(input[4] & 0x80) << 9);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 33 to 48
	value = ((uint32_t)(input[4] & 0x7f) << 25) |
			((uint32_t)input[5] << 17) |
			((uint32_t)(input[6] & 0x80) << 9);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 49 to 64
	value = ((uint32_t)(input[6] & 0x7f) << 25) |
			((uint32_t)input[7] << 17) |
			((uint32_t)(input[8] & 0x80) << 9);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 65 to 80
	value = ((uint32_t)(input[8] & 0x7f) << 25) |
			((uint32_t)input[9] << 17) |
			((uint32_t)(input[10] & 0x80) << 9);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 81 to 96
	value = ((uint32_t)(input[10] & 0x7f) << 25) |
			((uint32_t)input[11] << 17) |
			((uint32_t)(input[12] & 0x80) << 9);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 97 to 112
	value = ((uint32_t)(input[12] & 0x7f) << 25) |
			((uint32_t)input[13] << 17) |
			((uint32_t)(input[14] & 0x80) << 9);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 113 to 128
	value = ((uint32_t)(input[14] & 0x7f) << 25) |
			((uint32_t)input[15] << 17) |
			((uint32_t)(input[16] & 0x80) << 9);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 129 to 144
	value = ((uint32_t)(input[16] & 0x7f) << 25) |
			((uint32_t)input[17] << 17) |
			((uint32_t)(input[18] & 0x80) << 9);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 145 to 160
	value = ((uint32_t)(input[18] & 0x7f) << 25) |
			((uint32_t)input[19] << 17) |
			((uint32_t)(input[20] & 0x80) << 9);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 161 to 176
	value = ((uint32_t)(input[20] & 0x7f) << 25) |
			((uint32_t)input[21] << 17) |
			((uint32_t)(input[22] & 0x80) << 9);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 177 to 192
	value = ((uint32_t)(input[22] & 0x7f) << 25) |
			((uint32_t)input[23] << 17) |
			((uint32_t)(input[24] & 0x80) << 9);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 193 to 208
	value = ((uint32_t)(input[24] & 0x7f) << 25) |
			((uint32_t)input[25] << 17) |
			((uint32_t)(input[26] & 0x80) << 9);
	output[12] = (double)(value >> 16);
}

static void unpack_13_16bit_signed_2off(const uint8_t * input, double * output, void *closure) {
	// Unpack 13 values into output
	// Values are 16-bit signed
	// Skip 2 bits, read 208 bits of data.
	// Input must be at least 27 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 2 to 17
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)input[1] << 18) |
			((uint32_t)(input[2] & 0xc0) << 10);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 18 to 33
	value = ((uint32_t)(input[2] & 0x3f) << 26) |
			((uint32_t)input[3] << 18) |
			((uint32_t)(input[4] & 0xc0) << 10);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 34 to 49
	value = ((uint32_t)(input[4] & 0x3f) << 26) |
			((uint32_t)input[5] << 18) |
			((uint32_t)(input[6] & 0xc0) << 10);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 50 to 65
	value = ((uint32_t)(input[6] & 0x3f) << 26) |
			((uint32_t)input[7] << 18) |
			((uint32_t)(input[8] & 0xc0) << 10);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 66 to 81
	value = ((uint32_t)(input[8] & 0x3f) << 26) |
			((uint32_t)input[9] << 18) |
			((uint32_t)(input[10] & 0xc0) << 10);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 82 to 97
	value = ((uint32_t)(input[10] & 0x3f) << 26) |
			((uint32_t)input[11] << 18) |
			((uint32_t)(input[12] & 0xc0) << 10);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 98 to 113
	value = ((uint32_t)(input[12] & 0x3f) << 26) |
			((uint32_t)input[13] << 18) |
			((uint32_t)(input[14] & 0xc0) << 10);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 114 to 129
	value = ((uint32_t)(input[14] & 0x3f) << 26) |
			((uint32_t)input[15] << 18) |
			((uint32_t)(input[16] & 0xc0) << 10);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 130 to 145
	value = ((uint32_t)(input[16] & 0x3f) << 26) |
			((uint32_t)input[17] << 18) |
			((uint32_t)(input[18] & 0xc0) << 10);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 146 to 161
	value = ((uint32_t)(input[18] & 0x3f) << 26) |
			((uint32_t)input[19] << 18) |
			((uint32_t)(input[20] & 0xc0) << 10);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 162 to 177
	value = ((uint32_t)(input[20] & 0x3f) << 26) |
			((uint32_t)input[21] << 18) |
			((uint32_t)(input[22] & 0xc0) << 10);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 178 to 193
	value = ((uint32_t)(input[22] & 0x3f) << 26) |
			((uint32_t)input[23] << 18) |
			((uint32_t)(input[24] & 0xc0) << 10);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 194 to 209
	value = ((uint32_t)(input[24] & 0x3f) << 26) |
			((uint32_t)input[25] << 18) |
			((uint32_t)(input[26] & 0xc0) << 10);
	output[12] = (double)(value >> 16);
}

static void unpack_13_16bit_unsigned_2off(const uint8_t * input, double * output, void *closure) {
	// Unpack 13 values into output
	// Values are 16-bit unsigned
	// Skip 2 bits, read 208 bits of data.
	// Input must be at least 27 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 2 to 17
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)input[1] << 18) |
			((uint32_t)(input[2] & 0xc0) << 10);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 18 to 33
	value = ((uint32_t)(input[2] & 0x3f) << 26) |
			((uint32_t)input[3] << 18) |
			((uint32_t)(input[4] & 0xc0) << 10);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 34 to 49
	value = ((uint32_t)(input[4] & 0x3f) << 26) |
			((uint32_t)input[5] << 18) |
			((uint32_t)(input[6] & 0xc0) << 10);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 50 to 65
	value = ((uint32_t)(input[6] & 0x3f) << 26) |
			((uint32_t)input[7] << 18) |
			((uint32_t)(input[8] & 0xc0) << 10);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 66 to 81
	value = ((uint32_t)(input[8] & 0x3f) << 26) |
			((uint32_t)input[9] << 18) |
			((uint32_t)(input[10] & 0xc0) << 10);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 82 to 97
	value = ((uint32_t)(input[10] & 0x3f) << 26) |
			((uint32_t)input[11] << 18) |
			((uint32_t)(input[12] & 0xc0) << 10);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 98 to 113
	value = ((uint32_t)(input[12] & 0x3f) << 26) |
			((uint32_t)input[13] << 18) |
			((uint32_t)(input[14] & 0xc0) << 10);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 114 to 129
	value = ((uint32_t)(input[14] & 0x3f) << 26) |
			((uint32_t)input[15] << 18) |
			((uint32_t)(input[16] & 0xc0) << 10);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 130 to 145
	value = ((uint32_t)(input[16] & 0x3f) << 26) |
			((uint32_t)input[17] << 18) |
			((uint32_t)(input[18] & 0xc0) << 10);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 146 to 161
	value = ((uint32_t)(input[18] & 0x3f) << 26) |
			((uint32_t)input[19] << 18) |
			((uint32_t)(input[20] & 0xc0) << 10);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 162 to 177
	value = ((uint32_t)(input[20] & 0x3f) << 26) |
			((uint32_t)input[21] << 18) |
			((uint32_t)(input[22] & 0xc0) << 10);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 178 to 193
	value = ((uint32_t)(input[22] & 0x3f) << 26) |
			((uint32_t)input[23] << 18) |
			((uint32_t)(input[24] & 0xc0) << 10);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 194 to 209
	value = ((uint32_t)(input[24] & 0x3f) << 26) |
			((uint32_t)input[25] << 18) |
			((uint32_t)(input[26] & 0xc0) << 10);
	output[12] = (double)(value >> 16);
}

static void unpack_13_16bit_signed_3off(const uint8_t * input, double * output, void *closure) {
	// Unpack 13 values into output
	// Values are 16-bit signed
	// Skip 3 bits, read 208 bits of data.
	// Input must be at least 27 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 3 to 18
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)input[1] << 19) |
			((uint32_t)(input[2] & 0xe0) << 11);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 19 to 34
	value = ((uint32_t)(input[2] & 0x1f) << 27) |
			((uint32_t)input[3] << 19) |
			((uint32_t)(input[4] & 0xe0) << 11);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 35 to 50
	value = ((uint32_t)(input[4] & 0x1f) << 27) |
			((uint32_t)input[5] << 19) |
			((uint32_t)(input[6] & 0xe0) << 11);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 51 to 66
	value = ((uint32_t)(input[6] & 0x1f) << 27) |
			((uint32_t)input[7] << 19) |
			((uint32_t)(input[8] & 0xe0) << 11);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 67 to 82
	value = ((uint32_t)(input[8] & 0x1f) << 27) |
			((uint32_t)input[9] << 19) |
			((uint32_t)(input[10] & 0xe0) << 11);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 83 to 98
	value = ((uint32_t)(input[10] & 0x1f) << 27) |
			((uint32_t)input[11] << 19) |
			((uint32_t)(input[12] & 0xe0) << 11);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 99 to 114
	value = ((uint32_t)(input[12] & 0x1f) << 27) |
			((uint32_t)input[13] << 19) |
			((uint32_t)(input[14] & 0xe0) << 11);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 115 to 130
	value = ((uint32_t)(input[14] & 0x1f) << 27) |
			((uint32_t)input[15] << 19) |
			((uint32_t)(input[16] & 0xe0) << 11);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 131 to 146
	value = ((uint32_t)(input[16] & 0x1f) << 27) |
			((uint32_t)input[17] << 19) |
			((uint32_t)(input[18] & 0xe0) << 11);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 147 to 162
	value = ((uint32_t)(input[18] & 0x1f) << 27) |
			((uint32_t)input[19] << 19) |
			((uint32_t)(input[20] & 0xe0) << 11);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 163 to 178
	value = ((uint32_t)(input[20] & 0x1f) << 27) |
			((uint32_t)input[21] << 19) |
			((uint32_t)(input[22] & 0xe0) << 11);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 179 to 194
	value = ((uint32_t)(input[22] & 0x1f) << 27) |
			((uint32_t)input[23] << 19) |
			((uint32_t)(input[24] & 0xe0) << 11);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 195 to 210
	value = ((uint32_t)(input[24] & 0x1f) << 27) |
			((uint32_t)input[25] << 19) |
			((uint32_t)(input[26] & 0xe0) << 11);
	output[12] = (double)(value >> 16);
}

static void unpack_13_16bit_unsigned_3off(const uint8_t * input, double * output, void *closure) {
	// Unpack 13 values into output
	// Values are 16-bit unsigned
	// Skip 3 bits, read 208 bits of data.
	// Input must be at least 27 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 3 to 18
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)input[1] << 19) |
			((uint32_t)(input[2] & 0xe0) << 11);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 19 to 34
	value = ((uint32_t)(input[2] & 0x1f) << 27) |
			((uint32_t)input[3] << 19) |
			((uint32_t)(input[4] & 0xe0) << 11);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 35 to 50
	value = ((uint32_t)(input[4] & 0x1f) << 27) |
			((uint32_t)input[5] << 19) |
			((uint32_t)(input[6] & 0xe0) << 11);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 51 to 66
	value = ((uint32_t)(input[6] & 0x1f) << 27) |
			((uint32_t)input[7] << 19) |
			((uint32_t)(input[8] & 0xe0) << 11);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 67 to 82
	value = ((uint32_t)(input[8] & 0x1f) << 27) |
			((uint32_t)input[9] << 19) |
			((uint32_t)(input[10] & 0xe0) << 11);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 83 to 98
	value = ((uint32_t)(input[10] & 0x1f) << 27) |
			((uint32_t)input[11] << 19) |
			((uint32_t)(input[12] & 0xe0) << 11);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 99 to 114
	value = ((uint32_t)(input[12] & 0x1f) << 27) |
			((uint32_t)input[13] << 19) |
			((uint32_t)(input[14] & 0xe0) << 11);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 115 to 130
	value = ((uint32_t)(input[14] & 0x1f) << 27) |
			((uint32_t)input[15] << 19) |
			((uint32_t)(input[16] & 0xe0) << 11);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 131 to 146
	value = ((uint32_t)(input[16] & 0x1f) << 27) |
			((uint32_t)input[17] << 19) |
			((uint32_t)(input[18] & 0xe0) << 11);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 147 to 162
	value = ((uint32_t)(input[18] & 0x1f) << 27) |
			((uint32_t)input[19] << 19) |
			((uint32_t)(input[20] & 0xe0) << 11);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 163 to 178
	value = ((uint32_t)(input[20] & 0x1f) << 27) |
			((uint32_t)input[21] << 19) |
			((uint32_t)(input[22] & 0xe0) << 11);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 179 to 194
	value = ((uint32_t)(input[22] & 0x1f) << 27) |
			((uint32_t)input[23] << 19) |
			((uint32_t)(input[24] & 0xe0) << 11);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 195 to 210
	value = ((uint32_t)(input[24] & 0x1f) << 27) |
			((uint32_t)input[25] << 19) |
			((uint32_t)(input[26] & 0xe0) << 11);
	output[12] = (double)(value >> 16);
}

static void unpack_13_16bit_signed_4off(const uint8_t * input, double * output, void *closure) {
	// Unpack 13 values into output
	// Values are 16-bit signed
	// Skip 4 bits, read 208 bits of data.
	// Input must be at least 27 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 4 to 19
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20) |
			((uint32_t)(input[2] & 0xf0) << 12);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 20 to 35
	value = ((uint32_t)(input[2] & 0x0f) << 28) |
			((uint32_t)input[3] << 20) |
			((uint32_t)(input[4] & 0xf0) << 12);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 36 to 51
	value = ((uint32_t)(input[4] & 0x0f) << 28) |
			((uint32_t)input[5] << 20) |
			((uint32_t)(input[6] & 0xf0) << 12);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 52 to 67
	value = ((uint32_t)(input[6] & 0x0f) << 28) |
			((uint32_t)input[7] << 20) |
			((uint32_t)(input[8] & 0xf0) << 12);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 68 to 83
	value = ((uint32_t)(input[8] & 0x0f) << 28) |
			((uint32_t)input[9] << 20) |
			((uint32_t)(input[10] & 0xf0) << 12);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 84 to 99
	value = ((uint32_t)(input[10] & 0x0f) << 28) |
			((uint32_t)input[11] << 20) |
			((uint32_t)(input[12] & 0xf0) << 12);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 100 to 115
	value = ((uint32_t)(input[12] & 0x0f) << 28) |
			((uint32_t)input[13] << 20) |
			((uint32_t)(input[14] & 0xf0) << 12);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 116 to 131
	value = ((uint32_t)(input[14] & 0x0f) << 28) |
			((uint32_t)input[15] << 20) |
			((uint32_t)(input[16] & 0xf0) << 12);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 132 to 147
	value = ((uint32_t)(input[16] & 0x0f) << 28) |
			((uint32_t)input[17] << 20) |
			((uint32_t)(input[18] & 0xf0) << 12);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 148 to 163
	value = ((uint32_t)(input[18] & 0x0f) << 28) |
			((uint32_t)input[19] << 20) |
			((uint32_t)(input[20] & 0xf0) << 12);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 164 to 179
	value = ((uint32_t)(input[20] & 0x0f) << 28) |
			((uint32_t)input[21] << 20) |
			((uint32_t)(input[22] & 0xf0) << 12);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 180 to 195
	value = ((uint32_t)(input[22] & 0x0f) << 28) |
			((uint32_t)input[23] << 20) |
			((uint32_t)(input[24] & 0xf0) << 12);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 196 to 211
	value = ((uint32_t)(input[24] & 0x0f) << 28) |
			((uint32_t)input[25] << 20) |
			((uint32_t)(input[26] & 0xf0) << 12);
	output[12] = (double)(value >> 16);
}

static void unpack_13_16bit_unsigned_4off(const uint8_t * input, double * output, void *closure) {
	// Unpack 13 values into output
	// Values are 16-bit unsigned
	// Skip 4 bits, read 208 bits of data.
	// Input must be at least 27 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 4 to 19
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20) |
			((uint32_t)(input[2] & 0xf0) << 12);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 20 to 35
	value = ((uint32_t)(input[2] & 0x0f) << 28) |
			((uint32_t)input[3] << 20) |
			((uint32_t)(input[4] & 0xf0) << 12);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 36 to 51
	value = ((uint32_t)(input[4] & 0x0f) << 28) |
			((uint32_t)input[5] << 20) |
			((uint32_t)(input[6] & 0xf0) << 12);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 52 to 67
	value = ((uint32_t)(input[6] & 0x0f) << 28) |
			((uint32_t)input[7] << 20) |
			((uint32_t)(input[8] & 0xf0) << 12);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 68 to 83
	value = ((uint32_t)(input[8] & 0x0f) << 28) |
			((uint32_t)input[9] << 20) |
			((uint32_t)(input[10] & 0xf0) << 12);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 84 to 99
	value = ((uint32_t)(input[10] & 0x0f) << 28) |
			((uint32_t)input[11] << 20) |
			((uint32_t)(input[12] & 0xf0) << 12);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 100 to 115
	value = ((uint32_t)(input[12] & 0x0f) << 28) |
			((uint32_t)input[13] << 20) |
			((uint32_t)(input[14] & 0xf0) << 12);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 116 to 131
	value = ((uint32_t)(input[14] & 0x0f) << 28) |
			((uint32_t)input[15] << 20) |
			((uint32_t)(input[16] & 0xf0) << 12);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 132 to 147
	value = ((uint32_t)(input[16] & 0x0f) << 28) |
			((uint32_t)input[17] << 20) |
			((uint32_t)(input[18] & 0xf0) << 12);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 148 to 163
	value = ((uint32_t)(input[18] & 0x0f) << 28) |
			((uint32_t)input[19] << 20) |
			((uint32_t)(input[20] & 0xf0) << 12);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 164 to 179
	value = ((uint32_t)(input[20] & 0x0f) << 28) |
			((uint32_t)input[21] << 20) |
			((uint32_t)(input[22] & 0xf0) << 12);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 180 to 195
	value = ((uint32_t)(input[22] & 0x0f) << 28) |
			((uint32_t)input[23] << 20) |
			((uint32_t)(input[24] & 0xf0) << 12);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 196 to 211
	value = ((uint32_t)(input[24] & 0x0f) << 28) |
			((uint32_t)input[25] << 20) |
			((uint32_t)(input[26] & 0xf0) << 12);
	output[12] = (double)(value >> 16);
}

static void unpack_13_16bit_signed_5off(const uint8_t * input, double * output, void *closure) {
	// Unpack 13 values into output
	// Values are 16-bit signed
	// Skip 5 bits, read 208 bits of data.
	// Input must be at least 27 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 5 to 20
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)(input[2] & 0xf8) << 13);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 21 to 36
	value = ((uint32_t)(input[2] & 0x07) << 29) |
			((uint32_t)input[3] << 21) |
			((uint32_t)(input[4] & 0xf8) << 13);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 37 to 52
	value = ((uint32_t)(input[4] & 0x07) << 29) |
			((uint32_t)input[5] << 21) |
			((uint32_t)(input[6] & 0xf8) << 13);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 53 to 68
	value = ((uint32_t)(input[6] & 0x07) << 29) |
			((uint32_t)input[7] << 21) |
			((uint32_t)(input[8] & 0xf8) << 13);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 69 to 84
	value = ((uint32_t)(input[8] & 0x07) << 29) |
			((uint32_t)input[9] << 21) |
			((uint32_t)(input[10] & 0xf8) << 13);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 85 to 100
	value = ((uint32_t)(input[10] & 0x07) << 29) |
			((uint32_t)input[11] << 21) |
			((uint32_t)(input[12] & 0xf8) << 13);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 101 to 116
	value = ((uint32_t)(input[12] & 0x07) << 29) |
			((uint32_t)input[13] << 21) |
			((uint32_t)(input[14] & 0xf8) << 13);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 117 to 132
	value = ((uint32_t)(input[14] & 0x07) << 29) |
			((uint32_t)input[15] << 21) |
			((uint32_t)(input[16] & 0xf8) << 13);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 133 to 148
	value = ((uint32_t)(input[16] & 0x07) << 29) |
			((uint32_t)input[17] << 21) |
			((uint32_t)(input[18] & 0xf8) << 13);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 149 to 164
	value = ((uint32_t)(input[18] & 0x07) << 29) |
			((uint32_t)input[19] << 21) |
			((uint32_t)(input[20] & 0xf8) << 13);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 165 to 180
	value = ((uint32_t)(input[20] & 0x07) << 29) |
			((uint32_t)input[21] << 21) |
			((uint32_t)(input[22] & 0xf8) << 13);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 181 to 196
	value = ((uint32_t)(input[22] & 0x07) << 29) |
			((uint32_t)input[23] << 21) |
			((uint32_t)(input[24] & 0xf8) << 13);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 197 to 212
	value = ((uint32_t)(input[24] & 0x07) << 29) |
			((uint32_t)input[25] << 21) |
			((uint32_t)(input[26] & 0xf8) << 13);
	output[12] = (double)(value >> 16);
}

static void unpack_13_16bit_unsigned_5off(const uint8_t * input, double * output, void *closure) {
	// Unpack 13 values into output
	// Values are 16-bit unsigned
	// Skip 5 bits, read 208 bits of data.
	// Input must be at least 27 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 5 to 20
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)(input[2] & 0xf8) << 13);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 21 to 36
	value = ((uint32_t)(input[2] & 0x07) << 29) |
			((uint32_t)input[3] << 21) |
			((uint32_t)(input[4] & 0xf8) << 13);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 37 to 52
	value = ((uint32_t)(input[4] & 0x07) << 29) |
			((uint32_t)input[5] << 21) |
			((uint32_t)(input[6] & 0xf8) << 13);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 53 to 68
	value = ((uint32_t)(input[6] & 0x07) << 29) |
			((uint32_t)input[7] << 21) |
			((uint32_t)(input[8] & 0xf8) << 13);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 69 to 84
	value = ((uint32_t)(input[8] & 0x07) << 29) |
			((uint32_t)input[9] << 21) |
			((uint32_t)(input[10] & 0xf8) << 13);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 85 to 100
	value = ((uint32_t)(input[10] & 0x07) << 29) |
			((uint32_t)input[11] << 21) |
			((uint32_t)(input[12] & 0xf8) << 13);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 101 to 116
	value = ((uint32_t)(input[12] & 0x07) << 29) |
			((uint32_t)input[13] << 21) |
			((uint32_t)(input[14] & 0xf8) << 13);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 117 to 132
	value = ((uint32_t)(input[14] & 0x07) << 29) |
			((uint32_t)input[15] << 21) |
			((uint32_t)(input[16] & 0xf8) << 13);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 133 to 148
	value = ((uint32_t)(input[16] & 0x07) << 29) |
			((uint32_t)input[17] << 21) |
			((uint32_t)(input[18] & 0xf8) << 13);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 149 to 164
	value = ((uint32_t)(input[18] & 0x07) << 29) |
			((uint32_t)input[19] << 21) |
			((uint32_t)(input[20] & 0xf8) << 13);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 165 to 180
	value = ((uint32_t)(input[20] & 0x07) << 29) |
			((uint32_t)input[21] << 21) |
			((uint32_t)(input[22] & 0xf8) << 13);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 181 to 196
	value = ((uint32_t)(input[22] & 0x07) << 29) |
			((uint32_t)input[23] << 21) |
			((uint32_t)(input[24] & 0xf8) << 13);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 197 to 212
	value = ((uint32_t)(input[24] & 0x07) << 29) |
			((uint32_t)input[25] << 21) |
			((uint32_t)(input[26] & 0xf8) << 13);
	output[12] = (double)(value >> 16);
}

static void unpack_13_16bit_signed_6off(const uint8_t * input, double * output, void *closure) {
	// Unpack 13 values into output
	// Values are 16-bit signed
	// Skip 6 bits, read 208 bits of data.
	// Input must be at least 27 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 6 to 21
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)(input[2] & 0xfc) << 14);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 22 to 37
	value = ((uint32_t)(input[2] & 0x03) << 30) |
			((uint32_t)input[3] << 22) |
			((uint32_t)(input[4] & 0xfc) << 14);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 38 to 53
	value = ((uint32_t)(input[4] & 0x03) << 30) |
			((uint32_t)input[5] << 22) |
			((uint32_t)(input[6] & 0xfc) << 14);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 54 to 69
	value = ((uint32_t)(input[6] & 0x03) << 30) |
			((uint32_t)input[7] << 22) |
			((uint32_t)(input[8] & 0xfc) << 14);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 70 to 85
	value = ((uint32_t)(input[8] & 0x03) << 30) |
			((uint32_t)input[9] << 22) |
			((uint32_t)(input[10] & 0xfc) << 14);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 86 to 101
	value = ((uint32_t)(input[10] & 0x03) << 30) |
			((uint32_t)input[11] << 22) |
			((uint32_t)(input[12] & 0xfc) << 14);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 102 to 117
	value = ((uint32_t)(input[12] & 0x03) << 30) |
			((uint32_t)input[13] << 22) |
			((uint32_t)(input[14] & 0xfc) << 14);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 118 to 133
	value = ((uint32_t)(input[14] & 0x03) << 30) |
			((uint32_t)input[15] << 22) |
			((uint32_t)(input[16] & 0xfc) << 14);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 134 to 149
	value = ((uint32_t)(input[16] & 0x03) << 30) |
			((uint32_t)input[17] << 22) |
			((uint32_t)(input[18] & 0xfc) << 14);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 150 to 165
	value = ((uint32_t)(input[18] & 0x03) << 30) |
			((uint32_t)input[19] << 22) |
			((uint32_t)(input[20] & 0xfc) << 14);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 166 to 181
	value = ((uint32_t)(input[20] & 0x03) << 30) |
			((uint32_t)input[21] << 22) |
			((uint32_t)(input[22] & 0xfc) << 14);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 182 to 197
	value = ((uint32_t)(input[22] & 0x03) << 30) |
			((uint32_t)input[23] << 22) |
			((uint32_t)(input[24] & 0xfc) << 14);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 198 to 213
	value = ((uint32_t)(input[24] & 0x03) << 30) |
			((uint32_t)input[25] << 22) |
			((uint32_t)(input[26] & 0xfc) << 14);
	output[12] = (double)(value >> 16);
}

static void unpack_13_16bit_unsigned_6off(const uint8_t * input, double * output, void *closure) {
	// Unpack 13 values into output
	// Values are 16-bit unsigned
	// Skip 6 bits, read 208 bits of data.
	// Input must be at least 27 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 6 to 21
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)(input[2] & 0xfc) << 14);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 22 to 37
	value = ((uint32_t)(input[2] & 0x03) << 30) |
			((uint32_t)input[3] << 22) |
			((uint32_t)(input[4] & 0xfc) << 14);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 38 to 53
	value = ((uint32_t)(input[4] & 0x03) << 30) |
			((uint32_t)input[5] << 22) |
			((uint32_t)(input[6] & 0xfc) << 14);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 54 to 69
	value = ((uint32_t)(input[6] & 0x03) << 30) |
			((uint32_t)input[7] << 22) |
			((uint32_t)(input[8] & 0xfc) << 14);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 70 to 85
	value = ((uint32_t)(input[8] & 0x03) << 30) |
			((uint32_t)input[9] << 22) |
			((uint32_t)(input[10] & 0xfc) << 14);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 86 to 101
	value = ((uint32_t)(input[10] & 0x03) << 30) |
			((uint32_t)input[11] << 22) |
			((uint32_t)(input[12] & 0xfc) << 14);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 102 to 117
	value = ((uint32_t)(input[12] & 0x03) << 30) |
			((uint32_t)input[13] << 22) |
			((uint32_t)(input[14] & 0xfc) << 14);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 118 to 133
	value = ((uint32_t)(input[14] & 0x03) << 30) |
			((uint32_t)input[15] << 22) |
			((uint32_t)(input[16] & 0xfc) << 14);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 134 to 149
	value = ((uint32_t)(input[16] & 0x03) << 30) |
			((uint32_t)input[17] << 22) |
			((uint32_t)(input[18] & 0xfc) << 14);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 150 to 165
	value = ((uint32_t)(input[18] & 0x03) << 30) |
			((uint32_t)input[19] << 22) |
			((uint32_t)(input[20] & 0xfc) << 14);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 166 to 181
	value = ((uint32_t)(input[20] & 0x03) << 30) |
			((uint32_t)input[21] << 22) |
			((uint32_t)(input[22] & 0xfc) << 14);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 182 to 197
	value = ((uint32_t)(input[22] & 0x03) << 30) |
			((uint32_t)input[23] << 22) |
			((uint32_t)(input[24] & 0xfc) << 14);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 198 to 213
	value = ((uint32_t)(input[24] & 0x03) << 30) |
			((uint32_t)input[25] << 22) |
			((uint32_t)(input[26] & 0xfc) << 14);
	output[12] = (double)(value >> 16);
}

static void unpack_13_16bit_signed_7off(const uint8_t * input, double * output, void *closure) {
	// Unpack 13 values into output
	// Values are 16-bit signed
	// Skip 7 bits, read 208 bits of data.
	// Input must be at least 27 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 7 to 22
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)(input[2] & 0xfe) << 15);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 23 to 38
	value = ((uint32_t)(input[2] & 0x01) << 31) |
			((uint32_t)input[3] << 23) |
			((uint32_t)(input[4] & 0xfe) << 15);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 39 to 54
	value = ((uint32_t)(input[4] & 0x01) << 31) |
			((uint32_t)input[5] << 23) |
			((uint32_t)(input[6] & 0xfe) << 15);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 55 to 70
	value = ((uint32_t)(input[6] & 0x01) << 31) |
			((uint32_t)input[7] << 23) |
			((uint32_t)(input[8] & 0xfe) << 15);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 71 to 86
	value = ((uint32_t)(input[8] & 0x01) << 31) |
			((uint32_t)input[9] << 23) |
			((uint32_t)(input[10] & 0xfe) << 15);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 87 to 102
	value = ((uint32_t)(input[10] & 0x01) << 31) |
			((uint32_t)input[11] << 23) |
			((uint32_t)(input[12] & 0xfe) << 15);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 103 to 118
	value = ((uint32_t)(input[12] & 0x01) << 31) |
			((uint32_t)input[13] << 23) |
			((uint32_t)(input[14] & 0xfe) << 15);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 119 to 134
	value = ((uint32_t)(input[14] & 0x01) << 31) |
			((uint32_t)input[15] << 23) |
			((uint32_t)(input[16] & 0xfe) << 15);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 135 to 150
	value = ((uint32_t)(input[16] & 0x01) << 31) |
			((uint32_t)input[17] << 23) |
			((uint32_t)(input[18] & 0xfe) << 15);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 151 to 166
	value = ((uint32_t)(input[18] & 0x01) << 31) |
			((uint32_t)input[19] << 23) |
			((uint32_t)(input[20] & 0xfe) << 15);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 167 to 182
	value = ((uint32_t)(input[20] & 0x01) << 31) |
			((uint32_t)input[21] << 23) |
			((uint32_t)(input[22] & 0xfe) << 15);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 183 to 198
	value = ((uint32_t)(input[22] & 0x01) << 31) |
			((uint32_t)input[23] << 23) |
			((uint32_t)(input[24] & 0xfe) << 15);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 199 to 214
	value = ((uint32_t)(input[24] & 0x01) << 31) |
			((uint32_t)input[25] << 23) |
			((uint32_t)(input[26] & 0xfe) << 15);
	output[12] = (double)(value >> 16);
}

static void unpack_13_16bit_unsigned_7off(const uint8_t * input, double * output, void *closure) {
	// Unpack 13 values into output
	// Values are 16-bit unsigned
	// Skip 7 bits, read 208 bits of data.
	// Input must be at least 27 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 7 to 22
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)(input[2] & 0xfe) << 15);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 23 to 38
	value = ((uint32_t)(input[2] & 0x01) << 31) |
			((uint32_t)input[3] << 23) |
			((uint32_t)(input[4] & 0xfe) << 15);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 39 to 54
	value = ((uint32_t)(input[4] & 0x01) << 31) |
			((uint32_t)input[5] << 23) |
			((uint32_t)(input[6] & 0xfe) << 15);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 55 to 70
	value = ((uint32_t)(input[6] & 0x01) << 31) |
			((uint32_t)input[7] << 23) |
			((uint32_t)(input[8] & 0xfe) << 15);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 71 to 86
	value = ((uint32_t)(input[8] & 0x01) << 31) |
			((uint32_t)input[9] << 23) |
			((uint32_t)(input[10] & 0xfe) << 15);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 87 to 102
	value = ((uint32_t)(input[10] & 0x01) << 31) |
			((uint32_t)input[11] << 23) |
			((uint32_t)(input[12] & 0xfe) << 15);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 103 to 118
	value = ((uint32_t)(input[12] & 0x01) << 31) |
			((uint32_t)input[13] << 23) |
			((uint32_t)(input[14] & 0xfe) << 15);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 119 to 134
	value = ((uint32_t)(input[14] & 0x01) << 31) |
			((uint32_t)input[15] << 23) |
			((uint32_t)(input[16] & 0xfe) << 15);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 135 to 150
	value = ((uint32_t)(input[16] & 0x01) << 31) |
			((uint32_t)input[17] << 23) |
			((uint32_t)(input[18] & 0xfe) << 15);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 151 to 166
	value = ((uint32_t)(input[18] & 0x01) << 31) |
			((uint32_t)input[19] << 23) |
			((uint32_t)(input[20] & 0xfe) << 15);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 167 to 182
	value = ((uint32_t)(input[20] & 0x01) << 31) |
			((uint32_t)input[21] << 23) |
			((uint32_t)(input[22] & 0xfe) << 15);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 183 to 198
	value = ((uint32_t)(input[22] & 0x01) << 31) |
			((uint32_t)input[23] << 23) |
			((uint32_t)(input[24] & 0xfe) << 15);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 199 to 214
	value = ((uint32_t)(input[24] & 0x01) << 31) |
			((uint32_t)input[25] << 23) |
			((uint32_t)(input[26] & 0xfe) << 15);
	output[12] = (double)(value >> 16);
}

static void unpack_14_16bit_signed_0off(const uint8_t * input, double * output, void *closure) {
	// Unpack 14 values into output
	// Values are 16-bit signed
	// Skip 0 bits, read 224 bits of data.
	// Input must be at least 28 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 0 to 15
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)input[1] << 16);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 16 to 31
	value = ((uint32_t)input[2] << 24) |
			((uint32_t)input[3] << 16);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 32 to 47
	value = ((uint32_t)input[4] << 24) |
			((uint32_t)input[5] << 16);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 48 to 63
	value = ((uint32_t)input[6] << 24) |
			((uint32_t)input[7] << 16);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 64 to 79
	value = ((uint32_t)input[8] << 24) |
			((uint32_t)input[9] << 16);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 80 to 95
	value = ((uint32_t)input[10] << 24) |
			((uint32_t)input[11] << 16);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 96 to 111
	value = ((uint32_t)input[12] << 24) |
			((uint32_t)input[13] << 16);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 112 to 127
	value = ((uint32_t)input[14] << 24) |
			((uint32_t)input[15] << 16);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 128 to 143
	value = ((uint32_t)input[16] << 24) |
			((uint32_t)input[17] << 16);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 144 to 159
	value = ((uint32_t)input[18] << 24) |
			((uint32_t)input[19] << 16);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 160 to 175
	value = ((uint32_t)input[20] << 24) |
			((uint32_t)input[21] << 16);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 176 to 191
	value = ((uint32_t)input[22] << 24) |
			((uint32_t)input[23] << 16);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 192 to 207
	value = ((uint32_t)input[24] << 24) |
			((uint32_t)input[25] << 16);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 208 to 223
	value = ((uint32_t)input[26] << 24) |
			((uint32_t)input[27] << 16);
	output[13] = (double)(value >> 16);
}

static void unpack_14_16bit_unsigned_0off(const uint8_t * input, double * output, void *closure) {
	// Unpack 14 values into output
	// Values are 16-bit unsigned
	// Skip 0 bits, read 224 bits of data.
	// Input must be at least 28 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 0 to 15
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)input[1] << 16);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 16 to 31
	value = ((uint32_t)input[2] << 24) |
			((uint32_t)input[3] << 16);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 32 to 47
	value = ((uint32_t)input[4] << 24) |
			((uint32_t)input[5] << 16);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 48 to 63
	value = ((uint32_t)input[6] << 24) |
			((uint32_t)input[7] << 16);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 64 to 79
	value = ((uint32_t)input[8] << 24) |
			((uint32_t)input[9] << 16);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 80 to 95
	value = ((uint32_t)input[10] << 24) |
			((uint32_t)input[11] << 16);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 96 to 111
	value = ((uint32_t)input[12] << 24) |
			((uint32_t)input[13] << 16);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 112 to 127
	value = ((uint32_t)input[14] << 24) |
			((uint32_t)input[15] << 16);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 128 to 143
	value = ((uint32_t)input[16] << 24) |
			((uint32_t)input[17] << 16);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 144 to 159
	value = ((uint32_t)input[18] << 24) |
			((uint32_t)input[19] << 16);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 160 to 175
	value = ((uint32_t)input[20] << 24) |
			((uint32_t)input[21] << 16);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 176 to 191
	value = ((uint32_t)input[22] << 24) |
			((uint32_t)input[23] << 16);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 192 to 207
	value = ((uint32_t)input[24] << 24) |
			((uint32_t)input[25] << 16);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 208 to 223
	value = ((uint32_t)input[26] << 24) |
			((uint32_t)input[27] << 16);
	output[13] = (double)(value >> 16);
}

static void unpack_14_16bit_signed_1off(const uint8_t * input, double * output, void *closure) {
	// Unpack 14 values into output
	// Values are 16-bit signed
	// Skip 1 bits, read 224 bits of data.
	// Input must be at least 29 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 1 to 16
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)input[1] << 17) |
			((uint32_t)(input[2] & 0x80) << 9);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 17 to 32
	value = ((uint32_t)(input[2] & 0x7f) << 25) |
			((uint32_t)input[3] << 17) |
			((uint32_t)(input[4] & 0x80) << 9);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 33 to 48
	value = ((uint32_t)(input[4] & 0x7f) << 25) |
			((uint32_t)input[5] << 17) |
			((uint32_t)(input[6] & 0x80) << 9);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 49 to 64
	value = ((uint32_t)(input[6] & 0x7f) << 25) |
			((uint32_t)input[7] << 17) |
			((uint32_t)(input[8] & 0x80) << 9);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 65 to 80
	value = ((uint32_t)(input[8] & 0x7f) << 25) |
			((uint32_t)input[9] << 17) |
			((uint32_t)(input[10] & 0x80) << 9);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 81 to 96
	value = ((uint32_t)(input[10] & 0x7f) << 25) |
			((uint32_t)input[11] << 17) |
			((uint32_t)(input[12] & 0x80) << 9);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 97 to 112
	value = ((uint32_t)(input[12] & 0x7f) << 25) |
			((uint32_t)input[13] << 17) |
			((uint32_t)(input[14] & 0x80) << 9);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 113 to 128
	value = ((uint32_t)(input[14] & 0x7f) << 25) |
			((uint32_t)input[15] << 17) |
			((uint32_t)(input[16] & 0x80) << 9);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 129 to 144
	value = ((uint32_t)(input[16] & 0x7f) << 25) |
			((uint32_t)input[17] << 17) |
			((uint32_t)(input[18] & 0x80) << 9);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 145 to 160
	value = ((uint32_t)(input[18] & 0x7f) << 25) |
			((uint32_t)input[19] << 17) |
			((uint32_t)(input[20] & 0x80) << 9);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 161 to 176
	value = ((uint32_t)(input[20] & 0x7f) << 25) |
			((uint32_t)input[21] << 17) |
			((uint32_t)(input[22] & 0x80) << 9);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 177 to 192
	value = ((uint32_t)(input[22] & 0x7f) << 25) |
			((uint32_t)input[23] << 17) |
			((uint32_t)(input[24] & 0x80) << 9);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 193 to 208
	value = ((uint32_t)(input[24] & 0x7f) << 25) |
			((uint32_t)input[25] << 17) |
			((uint32_t)(input[26] & 0x80) << 9);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 209 to 224
	value = ((uint32_t)(input[26] & 0x7f) << 25) |
			((uint32_t)input[27] << 17) |
			((uint32_t)(input[28] & 0x80) << 9);
	output[13] = (double)(value >> 16);
}

static void unpack_14_16bit_unsigned_1off(const uint8_t * input, double * output, void *closure) {
	// Unpack 14 values into output
	// Values are 16-bit unsigned
	// Skip 1 bits, read 224 bits of data.
	// Input must be at least 29 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 1 to 16
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)input[1] << 17) |
			((uint32_t)(input[2] & 0x80) << 9);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 17 to 32
	value = ((uint32_t)(input[2] & 0x7f) << 25) |
			((uint32_t)input[3] << 17) |
			((uint32_t)(input[4] & 0x80) << 9);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 33 to 48
	value = ((uint32_t)(input[4] & 0x7f) << 25) |
			((uint32_t)input[5] << 17) |
			((uint32_t)(input[6] & 0x80) << 9);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 49 to 64
	value = ((uint32_t)(input[6] & 0x7f) << 25) |
			((uint32_t)input[7] << 17) |
			((uint32_t)(input[8] & 0x80) << 9);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 65 to 80
	value = ((uint32_t)(input[8] & 0x7f) << 25) |
			((uint32_t)input[9] << 17) |
			((uint32_t)(input[10] & 0x80) << 9);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 81 to 96
	value = ((uint32_t)(input[10] & 0x7f) << 25) |
			((uint32_t)input[11] << 17) |
			((uint32_t)(input[12] & 0x80) << 9);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 97 to 112
	value = ((uint32_t)(input[12] & 0x7f) << 25) |
			((uint32_t)input[13] << 17) |
			((uint32_t)(input[14] & 0x80) << 9);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 113 to 128
	value = ((uint32_t)(input[14] & 0x7f) << 25) |
			((uint32_t)input[15] << 17) |
			((uint32_t)(input[16] & 0x80) << 9);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 129 to 144
	value = ((uint32_t)(input[16] & 0x7f) << 25) |
			((uint32_t)input[17] << 17) |
			((uint32_t)(input[18] & 0x80) << 9);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 145 to 160
	value = ((uint32_t)(input[18] & 0x7f) << 25) |
			((uint32_t)input[19] << 17) |
			((uint32_t)(input[20] & 0x80) << 9);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 161 to 176
	value = ((uint32_t)(input[20] & 0x7f) << 25) |
			((uint32_t)input[21] << 17) |
			((uint32_t)(input[22] & 0x80) << 9);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 177 to 192
	value = ((uint32_t)(input[22] & 0x7f) << 25) |
			((uint32_t)input[23] << 17) |
			((uint32_t)(input[24] & 0x80) << 9);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 193 to 208
	value = ((uint32_t)(input[24] & 0x7f) << 25) |
			((uint32_t)input[25] << 17) |
			((uint32_t)(input[26] & 0x80) << 9);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 209 to 224
	value = ((uint32_t)(input[26] & 0x7f) << 25) |
			((uint32_t)input[27] << 17) |
			((uint32_t)(input[28] & 0x80) << 9);
	output[13] = (double)(value >> 16);
}

static void unpack_14_16bit_signed_2off(const uint8_t * input, double * output, void *closure) {
	// Unpack 14 values into output
	// Values are 16-bit signed
	// Skip 2 bits, read 224 bits of data.
	// Input must be at least 29 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 2 to 17
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)input[1] << 18) |
			((uint32_t)(input[2] & 0xc0) << 10);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 18 to 33
	value = ((uint32_t)(input[2] & 0x3f) << 26) |
			((uint32_t)input[3] << 18) |
			((uint32_t)(input[4] & 0xc0) << 10);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 34 to 49
	value = ((uint32_t)(input[4] & 0x3f) << 26) |
			((uint32_t)input[5] << 18) |
			((uint32_t)(input[6] & 0xc0) << 10);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 50 to 65
	value = ((uint32_t)(input[6] & 0x3f) << 26) |
			((uint32_t)input[7] << 18) |
			((uint32_t)(input[8] & 0xc0) << 10);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 66 to 81
	value = ((uint32_t)(input[8] & 0x3f) << 26) |
			((uint32_t)input[9] << 18) |
			((uint32_t)(input[10] & 0xc0) << 10);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 82 to 97
	value = ((uint32_t)(input[10] & 0x3f) << 26) |
			((uint32_t)input[11] << 18) |
			((uint32_t)(input[12] & 0xc0) << 10);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 98 to 113
	value = ((uint32_t)(input[12] & 0x3f) << 26) |
			((uint32_t)input[13] << 18) |
			((uint32_t)(input[14] & 0xc0) << 10);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 114 to 129
	value = ((uint32_t)(input[14] & 0x3f) << 26) |
			((uint32_t)input[15] << 18) |
			((uint32_t)(input[16] & 0xc0) << 10);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 130 to 145
	value = ((uint32_t)(input[16] & 0x3f) << 26) |
			((uint32_t)input[17] << 18) |
			((uint32_t)(input[18] & 0xc0) << 10);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 146 to 161
	value = ((uint32_t)(input[18] & 0x3f) << 26) |
			((uint32_t)input[19] << 18) |
			((uint32_t)(input[20] & 0xc0) << 10);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 162 to 177
	value = ((uint32_t)(input[20] & 0x3f) << 26) |
			((uint32_t)input[21] << 18) |
			((uint32_t)(input[22] & 0xc0) << 10);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 178 to 193
	value = ((uint32_t)(input[22] & 0x3f) << 26) |
			((uint32_t)input[23] << 18) |
			((uint32_t)(input[24] & 0xc0) << 10);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 194 to 209
	value = ((uint32_t)(input[24] & 0x3f) << 26) |
			((uint32_t)input[25] << 18) |
			((uint32_t)(input[26] & 0xc0) << 10);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 210 to 225
	value = ((uint32_t)(input[26] & 0x3f) << 26) |
			((uint32_t)input[27] << 18) |
			((uint32_t)(input[28] & 0xc0) << 10);
	output[13] = (double)(value >> 16);
}

static void unpack_14_16bit_unsigned_2off(const uint8_t * input, double * output, void *closure) {
	// Unpack 14 values into output
	// Values are 16-bit unsigned
	// Skip 2 bits, read 224 bits of data.
	// Input must be at least 29 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 2 to 17
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)input[1] << 18) |
			((uint32_t)(input[2] & 0xc0) << 10);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 18 to 33
	value = ((uint32_t)(input[2] & 0x3f) << 26) |
			((uint32_t)input[3] << 18) |
			((uint32_t)(input[4] & 0xc0) << 10);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 34 to 49
	value = ((uint32_t)(input[4] & 0x3f) << 26) |
			((uint32_t)input[5] << 18) |
			((uint32_t)(input[6] & 0xc0) << 10);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 50 to 65
	value = ((uint32_t)(input[6] & 0x3f) << 26) |
			((uint32_t)input[7] << 18) |
			((uint32_t)(input[8] & 0xc0) << 10);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 66 to 81
	value = ((uint32_t)(input[8] & 0x3f) << 26) |
			((uint32_t)input[9] << 18) |
			((uint32_t)(input[10] & 0xc0) << 10);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 82 to 97
	value = ((uint32_t)(input[10] & 0x3f) << 26) |
			((uint32_t)input[11] << 18) |
			((uint32_t)(input[12] & 0xc0) << 10);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 98 to 113
	value = ((uint32_t)(input[12] & 0x3f) << 26) |
			((uint32_t)input[13] << 18) |
			((uint32_t)(input[14] & 0xc0) << 10);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 114 to 129
	value = ((uint32_t)(input[14] & 0x3f) << 26) |
			((uint32_t)input[15] << 18) |
			((uint32_t)(input[16] & 0xc0) << 10);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 130 to 145
	value = ((uint32_t)(input[16] & 0x3f) << 26) |
			((uint32_t)input[17] << 18) |
			((uint32_t)(input[18] & 0xc0) << 10);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 146 to 161
	value = ((uint32_t)(input[18] & 0x3f) << 26) |
			((uint32_t)input[19] << 18) |
			((uint32_t)(input[20] & 0xc0) << 10);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 162 to 177
	value = ((uint32_t)(input[20] & 0x3f) << 26) |
			((uint32_t)input[21] << 18) |
			((uint32_t)(input[22] & 0xc0) << 10);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 178 to 193
	value = ((uint32_t)(input[22] & 0x3f) << 26) |
			((uint32_t)input[23] << 18) |
			((uint32_t)(input[24] & 0xc0) << 10);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 194 to 209
	value = ((uint32_t)(input[24] & 0x3f) << 26) |
			((uint32_t)input[25] << 18) |
			((uint32_t)(input[26] & 0xc0) << 10);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 210 to 225
	value = ((uint32_t)(input[26] & 0x3f) << 26) |
			((uint32_t)input[27] << 18) |
			((uint32_t)(input[28] & 0xc0) << 10);
	output[13] = (double)(value >> 16);
}

static void unpack_14_16bit_signed_3off(const uint8_t * input, double * output, void *closure) {
	// Unpack 14 values into output
	// Values are 16-bit signed
	// Skip 3 bits, read 224 bits of data.
	// Input must be at least 29 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 3 to 18
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)input[1] << 19) |
			((uint32_t)(input[2] & 0xe0) << 11);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 19 to 34
	value = ((uint32_t)(input[2] & 0x1f) << 27) |
			((uint32_t)input[3] << 19) |
			((uint32_t)(input[4] & 0xe0) << 11);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 35 to 50
	value = ((uint32_t)(input[4] & 0x1f) << 27) |
			((uint32_t)input[5] << 19) |
			((uint32_t)(input[6] & 0xe0) << 11);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 51 to 66
	value = ((uint32_t)(input[6] & 0x1f) << 27) |
			((uint32_t)input[7] << 19) |
			((uint32_t)(input[8] & 0xe0) << 11);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 67 to 82
	value = ((uint32_t)(input[8] & 0x1f) << 27) |
			((uint32_t)input[9] << 19) |
			((uint32_t)(input[10] & 0xe0) << 11);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 83 to 98
	value = ((uint32_t)(input[10] & 0x1f) << 27) |
			((uint32_t)input[11] << 19) |
			((uint32_t)(input[12] & 0xe0) << 11);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 99 to 114
	value = ((uint32_t)(input[12] & 0x1f) << 27) |
			((uint32_t)input[13] << 19) |
			((uint32_t)(input[14] & 0xe0) << 11);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 115 to 130
	value = ((uint32_t)(input[14] & 0x1f) << 27) |
			((uint32_t)input[15] << 19) |
			((uint32_t)(input[16] & 0xe0) << 11);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 131 to 146
	value = ((uint32_t)(input[16] & 0x1f) << 27) |
			((uint32_t)input[17] << 19) |
			((uint32_t)(input[18] & 0xe0) << 11);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 147 to 162
	value = ((uint32_t)(input[18] & 0x1f) << 27) |
			((uint32_t)input[19] << 19) |
			((uint32_t)(input[20] & 0xe0) << 11);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 163 to 178
	value = ((uint32_t)(input[20] & 0x1f) << 27) |
			((uint32_t)input[21] << 19) |
			((uint32_t)(input[22] & 0xe0) << 11);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 179 to 194
	value = ((uint32_t)(input[22] & 0x1f) << 27) |
			((uint32_t)input[23] << 19) |
			((uint32_t)(input[24] & 0xe0) << 11);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 195 to 210
	value = ((uint32_t)(input[24] & 0x1f) << 27) |
			((uint32_t)input[25] << 19) |
			((uint32_t)(input[26] & 0xe0) << 11);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 211 to 226
	value = ((uint32_t)(input[26] & 0x1f) << 27) |
			((uint32_t)input[27] << 19) |
			((uint32_t)(input[28] & 0xe0) << 11);
	output[13] = (double)(value >> 16);
}

static void unpack_14_16bit_unsigned_3off(const uint8_t * input, double * output, void *closure) {
	// Unpack 14 values into output
	// Values are 16-bit unsigned
	// Skip 3 bits, read 224 bits of data.
	// Input must be at least 29 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 3 to 18
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)input[1] << 19) |
			((uint32_t)(input[2] & 0xe0) << 11);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 19 to 34
	value = ((uint32_t)(input[2] & 0x1f) << 27) |
			((uint32_t)input[3] << 19) |
			((uint32_t)(input[4] & 0xe0) << 11);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 35 to 50
	value = ((uint32_t)(input[4] & 0x1f) << 27) |
			((uint32_t)input[5] << 19) |
			((uint32_t)(input[6] & 0xe0) << 11);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 51 to 66
	value = ((uint32_t)(input[6] & 0x1f) << 27) |
			((uint32_t)input[7] << 19) |
			((uint32_t)(input[8] & 0xe0) << 11);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 67 to 82
	value = ((uint32_t)(input[8] & 0x1f) << 27) |
			((uint32_t)input[9] << 19) |
			((uint32_t)(input[10] & 0xe0) << 11);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 83 to 98
	value = ((uint32_t)(input[10] & 0x1f) << 27) |
			((uint32_t)input[11] << 19) |
			((uint32_t)(input[12] & 0xe0) << 11);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 99 to 114
	value = ((uint32_t)(input[12] & 0x1f) << 27) |
			((uint32_t)input[13] << 19) |
			((uint32_t)(input[14] & 0xe0) << 11);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 115 to 130
	value = ((uint32_t)(input[14] & 0x1f) << 27) |
			((uint32_t)input[15] << 19) |
			((uint32_t)(input[16] & 0xe0) << 11);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 131 to 146
	value = ((uint32_t)(input[16] & 0x1f) << 27) |
			((uint32_t)input[17] << 19) |
			((uint32_t)(input[18] & 0xe0) << 11);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 147 to 162
	value = ((uint32_t)(input[18] & 0x1f) << 27) |
			((uint32_t)input[19] << 19) |
			((uint32_t)(input[20] & 0xe0) << 11);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 163 to 178
	value = ((uint32_t)(input[20] & 0x1f) << 27) |
			((uint32_t)input[21] << 19) |
			((uint32_t)(input[22] & 0xe0) << 11);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 179 to 194
	value = ((uint32_t)(input[22] & 0x1f) << 27) |
			((uint32_t)input[23] << 19) |
			((uint32_t)(input[24] & 0xe0) << 11);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 195 to 210
	value = ((uint32_t)(input[24] & 0x1f) << 27) |
			((uint32_t)input[25] << 19) |
			((uint32_t)(input[26] & 0xe0) << 11);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 211 to 226
	value = ((uint32_t)(input[26] & 0x1f) << 27) |
			((uint32_t)input[27] << 19) |
			((uint32_t)(input[28] & 0xe0) << 11);
	output[13] = (double)(value >> 16);
}

static void unpack_14_16bit_signed_4off(const uint8_t * input, double * output, void *closure) {
	// Unpack 14 values into output
	// Values are 16-bit signed
	// Skip 4 bits, read 224 bits of data.
	// Input must be at least 29 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 4 to 19
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20) |
			((uint32_t)(input[2] & 0xf0) << 12);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 20 to 35
	value = ((uint32_t)(input[2] & 0x0f) << 28) |
			((uint32_t)input[3] << 20) |
			((uint32_t)(input[4] & 0xf0) << 12);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 36 to 51
	value = ((uint32_t)(input[4] & 0x0f) << 28) |
			((uint32_t)input[5] << 20) |
			((uint32_t)(input[6] & 0xf0) << 12);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 52 to 67
	value = ((uint32_t)(input[6] & 0x0f) << 28) |
			((uint32_t)input[7] << 20) |
			((uint32_t)(input[8] & 0xf0) << 12);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 68 to 83
	value = ((uint32_t)(input[8] & 0x0f) << 28) |
			((uint32_t)input[9] << 20) |
			((uint32_t)(input[10] & 0xf0) << 12);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 84 to 99
	value = ((uint32_t)(input[10] & 0x0f) << 28) |
			((uint32_t)input[11] << 20) |
			((uint32_t)(input[12] & 0xf0) << 12);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 100 to 115
	value = ((uint32_t)(input[12] & 0x0f) << 28) |
			((uint32_t)input[13] << 20) |
			((uint32_t)(input[14] & 0xf0) << 12);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 116 to 131
	value = ((uint32_t)(input[14] & 0x0f) << 28) |
			((uint32_t)input[15] << 20) |
			((uint32_t)(input[16] & 0xf0) << 12);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 132 to 147
	value = ((uint32_t)(input[16] & 0x0f) << 28) |
			((uint32_t)input[17] << 20) |
			((uint32_t)(input[18] & 0xf0) << 12);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 148 to 163
	value = ((uint32_t)(input[18] & 0x0f) << 28) |
			((uint32_t)input[19] << 20) |
			((uint32_t)(input[20] & 0xf0) << 12);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 164 to 179
	value = ((uint32_t)(input[20] & 0x0f) << 28) |
			((uint32_t)input[21] << 20) |
			((uint32_t)(input[22] & 0xf0) << 12);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 180 to 195
	value = ((uint32_t)(input[22] & 0x0f) << 28) |
			((uint32_t)input[23] << 20) |
			((uint32_t)(input[24] & 0xf0) << 12);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 196 to 211
	value = ((uint32_t)(input[24] & 0x0f) << 28) |
			((uint32_t)input[25] << 20) |
			((uint32_t)(input[26] & 0xf0) << 12);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 212 to 227
	value = ((uint32_t)(input[26] & 0x0f) << 28) |
			((uint32_t)input[27] << 20) |
			((uint32_t)(input[28] & 0xf0) << 12);
	output[13] = (double)(value >> 16);
}

static void unpack_14_16bit_unsigned_4off(const uint8_t * input, double * output, void *closure) {
	// Unpack 14 values into output
	// Values are 16-bit unsigned
	// Skip 4 bits, read 224 bits of data.
	// Input must be at least 29 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 4 to 19
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20) |
			((uint32_t)(input[2] & 0xf0) << 12);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 20 to 35
	value = ((uint32_t)(input[2] & 0x0f) << 28) |
			((uint32_t)input[3] << 20) |
			((uint32_t)(input[4] & 0xf0) << 12);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 36 to 51
	value = ((uint32_t)(input[4] & 0x0f) << 28) |
			((uint32_t)input[5] << 20) |
			((uint32_t)(input[6] & 0xf0) << 12);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 52 to 67
	value = ((uint32_t)(input[6] & 0x0f) << 28) |
			((uint32_t)input[7] << 20) |
			((uint32_t)(input[8] & 0xf0) << 12);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 68 to 83
	value = ((uint32_t)(input[8] & 0x0f) << 28) |
			((uint32_t)input[9] << 20) |
			((uint32_t)(input[10] & 0xf0) << 12);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 84 to 99
	value = ((uint32_t)(input[10] & 0x0f) << 28) |
			((uint32_t)input[11] << 20) |
			((uint32_t)(input[12] & 0xf0) << 12);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 100 to 115
	value = ((uint32_t)(input[12] & 0x0f) << 28) |
			((uint32_t)input[13] << 20) |
			((uint32_t)(input[14] & 0xf0) << 12);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 116 to 131
	value = ((uint32_t)(input[14] & 0x0f) << 28) |
			((uint32_t)input[15] << 20) |
			((uint32_t)(input[16] & 0xf0) << 12);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 132 to 147
	value = ((uint32_t)(input[16] & 0x0f) << 28) |
			((uint32_t)input[17] << 20) |
			((uint32_t)(input[18] & 0xf0) << 12);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 148 to 163
	value = ((uint32_t)(input[18] & 0x0f) << 28) |
			((uint32_t)input[19] << 20) |
			((uint32_t)(input[20] & 0xf0) << 12);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 164 to 179
	value = ((uint32_t)(input[20] & 0x0f) << 28) |
			((uint32_t)input[21] << 20) |
			((uint32_t)(input[22] & 0xf0) << 12);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 180 to 195
	value = ((uint32_t)(input[22] & 0x0f) << 28) |
			((uint32_t)input[23] << 20) |
			((uint32_t)(input[24] & 0xf0) << 12);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 196 to 211
	value = ((uint32_t)(input[24] & 0x0f) << 28) |
			((uint32_t)input[25] << 20) |
			((uint32_t)(input[26] & 0xf0) << 12);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 212 to 227
	value = ((uint32_t)(input[26] & 0x0f) << 28) |
			((uint32_t)input[27] << 20) |
			((uint32_t)(input[28] & 0xf0) << 12);
	output[13] = (double)(value >> 16);
}

static void unpack_14_16bit_signed_5off(const uint8_t * input, double * output, void *closure) {
	// Unpack 14 values into output
	// Values are 16-bit signed
	// Skip 5 bits, read 224 bits of data.
	// Input must be at least 29 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 5 to 20
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)(input[2] & 0xf8) << 13);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 21 to 36
	value = ((uint32_t)(input[2] & 0x07) << 29) |
			((uint32_t)input[3] << 21) |
			((uint32_t)(input[4] & 0xf8) << 13);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 37 to 52
	value = ((uint32_t)(input[4] & 0x07) << 29) |
			((uint32_t)input[5] << 21) |
			((uint32_t)(input[6] & 0xf8) << 13);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 53 to 68
	value = ((uint32_t)(input[6] & 0x07) << 29) |
			((uint32_t)input[7] << 21) |
			((uint32_t)(input[8] & 0xf8) << 13);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 69 to 84
	value = ((uint32_t)(input[8] & 0x07) << 29) |
			((uint32_t)input[9] << 21) |
			((uint32_t)(input[10] & 0xf8) << 13);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 85 to 100
	value = ((uint32_t)(input[10] & 0x07) << 29) |
			((uint32_t)input[11] << 21) |
			((uint32_t)(input[12] & 0xf8) << 13);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 101 to 116
	value = ((uint32_t)(input[12] & 0x07) << 29) |
			((uint32_t)input[13] << 21) |
			((uint32_t)(input[14] & 0xf8) << 13);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 117 to 132
	value = ((uint32_t)(input[14] & 0x07) << 29) |
			((uint32_t)input[15] << 21) |
			((uint32_t)(input[16] & 0xf8) << 13);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 133 to 148
	value = ((uint32_t)(input[16] & 0x07) << 29) |
			((uint32_t)input[17] << 21) |
			((uint32_t)(input[18] & 0xf8) << 13);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 149 to 164
	value = ((uint32_t)(input[18] & 0x07) << 29) |
			((uint32_t)input[19] << 21) |
			((uint32_t)(input[20] & 0xf8) << 13);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 165 to 180
	value = ((uint32_t)(input[20] & 0x07) << 29) |
			((uint32_t)input[21] << 21) |
			((uint32_t)(input[22] & 0xf8) << 13);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 181 to 196
	value = ((uint32_t)(input[22] & 0x07) << 29) |
			((uint32_t)input[23] << 21) |
			((uint32_t)(input[24] & 0xf8) << 13);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 197 to 212
	value = ((uint32_t)(input[24] & 0x07) << 29) |
			((uint32_t)input[25] << 21) |
			((uint32_t)(input[26] & 0xf8) << 13);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 213 to 228
	value = ((uint32_t)(input[26] & 0x07) << 29) |
			((uint32_t)input[27] << 21) |
			((uint32_t)(input[28] & 0xf8) << 13);
	output[13] = (double)(value >> 16);
}

static void unpack_14_16bit_unsigned_5off(const uint8_t * input, double * output, void *closure) {
	// Unpack 14 values into output
	// Values are 16-bit unsigned
	// Skip 5 bits, read 224 bits of data.
	// Input must be at least 29 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 5 to 20
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)(input[2] & 0xf8) << 13);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 21 to 36
	value = ((uint32_t)(input[2] & 0x07) << 29) |
			((uint32_t)input[3] << 21) |
			((uint32_t)(input[4] & 0xf8) << 13);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 37 to 52
	value = ((uint32_t)(input[4] & 0x07) << 29) |
			((uint32_t)input[5] << 21) |
			((uint32_t)(input[6] & 0xf8) << 13);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 53 to 68
	value = ((uint32_t)(input[6] & 0x07) << 29) |
			((uint32_t)input[7] << 21) |
			((uint32_t)(input[8] & 0xf8) << 13);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 69 to 84
	value = ((uint32_t)(input[8] & 0x07) << 29) |
			((uint32_t)input[9] << 21) |
			((uint32_t)(input[10] & 0xf8) << 13);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 85 to 100
	value = ((uint32_t)(input[10] & 0x07) << 29) |
			((uint32_t)input[11] << 21) |
			((uint32_t)(input[12] & 0xf8) << 13);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 101 to 116
	value = ((uint32_t)(input[12] & 0x07) << 29) |
			((uint32_t)input[13] << 21) |
			((uint32_t)(input[14] & 0xf8) << 13);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 117 to 132
	value = ((uint32_t)(input[14] & 0x07) << 29) |
			((uint32_t)input[15] << 21) |
			((uint32_t)(input[16] & 0xf8) << 13);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 133 to 148
	value = ((uint32_t)(input[16] & 0x07) << 29) |
			((uint32_t)input[17] << 21) |
			((uint32_t)(input[18] & 0xf8) << 13);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 149 to 164
	value = ((uint32_t)(input[18] & 0x07) << 29) |
			((uint32_t)input[19] << 21) |
			((uint32_t)(input[20] & 0xf8) << 13);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 165 to 180
	value = ((uint32_t)(input[20] & 0x07) << 29) |
			((uint32_t)input[21] << 21) |
			((uint32_t)(input[22] & 0xf8) << 13);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 181 to 196
	value = ((uint32_t)(input[22] & 0x07) << 29) |
			((uint32_t)input[23] << 21) |
			((uint32_t)(input[24] & 0xf8) << 13);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 197 to 212
	value = ((uint32_t)(input[24] & 0x07) << 29) |
			((uint32_t)input[25] << 21) |
			((uint32_t)(input[26] & 0xf8) << 13);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 213 to 228
	value = ((uint32_t)(input[26] & 0x07) << 29) |
			((uint32_t)input[27] << 21) |
			((uint32_t)(input[28] & 0xf8) << 13);
	output[13] = (double)(value >> 16);
}

static void unpack_14_16bit_signed_6off(const uint8_t * input, double * output, void *closure) {
	// Unpack 14 values into output
	// Values are 16-bit signed
	// Skip 6 bits, read 224 bits of data.
	// Input must be at least 29 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 6 to 21
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)(input[2] & 0xfc) << 14);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 22 to 37
	value = ((uint32_t)(input[2] & 0x03) << 30) |
			((uint32_t)input[3] << 22) |
			((uint32_t)(input[4] & 0xfc) << 14);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 38 to 53
	value = ((uint32_t)(input[4] & 0x03) << 30) |
			((uint32_t)input[5] << 22) |
			((uint32_t)(input[6] & 0xfc) << 14);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 54 to 69
	value = ((uint32_t)(input[6] & 0x03) << 30) |
			((uint32_t)input[7] << 22) |
			((uint32_t)(input[8] & 0xfc) << 14);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 70 to 85
	value = ((uint32_t)(input[8] & 0x03) << 30) |
			((uint32_t)input[9] << 22) |
			((uint32_t)(input[10] & 0xfc) << 14);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 86 to 101
	value = ((uint32_t)(input[10] & 0x03) << 30) |
			((uint32_t)input[11] << 22) |
			((uint32_t)(input[12] & 0xfc) << 14);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 102 to 117
	value = ((uint32_t)(input[12] & 0x03) << 30) |
			((uint32_t)input[13] << 22) |
			((uint32_t)(input[14] & 0xfc) << 14);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 118 to 133
	value = ((uint32_t)(input[14] & 0x03) << 30) |
			((uint32_t)input[15] << 22) |
			((uint32_t)(input[16] & 0xfc) << 14);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 134 to 149
	value = ((uint32_t)(input[16] & 0x03) << 30) |
			((uint32_t)input[17] << 22) |
			((uint32_t)(input[18] & 0xfc) << 14);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 150 to 165
	value = ((uint32_t)(input[18] & 0x03) << 30) |
			((uint32_t)input[19] << 22) |
			((uint32_t)(input[20] & 0xfc) << 14);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 166 to 181
	value = ((uint32_t)(input[20] & 0x03) << 30) |
			((uint32_t)input[21] << 22) |
			((uint32_t)(input[22] & 0xfc) << 14);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 182 to 197
	value = ((uint32_t)(input[22] & 0x03) << 30) |
			((uint32_t)input[23] << 22) |
			((uint32_t)(input[24] & 0xfc) << 14);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 198 to 213
	value = ((uint32_t)(input[24] & 0x03) << 30) |
			((uint32_t)input[25] << 22) |
			((uint32_t)(input[26] & 0xfc) << 14);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 214 to 229
	value = ((uint32_t)(input[26] & 0x03) << 30) |
			((uint32_t)input[27] << 22) |
			((uint32_t)(input[28] & 0xfc) << 14);
	output[13] = (double)(value >> 16);
}

static void unpack_14_16bit_unsigned_6off(const uint8_t * input, double * output, void *closure) {
	// Unpack 14 values into output
	// Values are 16-bit unsigned
	// Skip 6 bits, read 224 bits of data.
	// Input must be at least 29 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 6 to 21
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)(input[2] & 0xfc) << 14);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 22 to 37
	value = ((uint32_t)(input[2] & 0x03) << 30) |
			((uint32_t)input[3] << 22) |
			((uint32_t)(input[4] & 0xfc) << 14);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 38 to 53
	value = ((uint32_t)(input[4] & 0x03) << 30) |
			((uint32_t)input[5] << 22) |
			((uint32_t)(input[6] & 0xfc) << 14);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 54 to 69
	value = ((uint32_t)(input[6] & 0x03) << 30) |
			((uint32_t)input[7] << 22) |
			((uint32_t)(input[8] & 0xfc) << 14);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 70 to 85
	value = ((uint32_t)(input[8] & 0x03) << 30) |
			((uint32_t)input[9] << 22) |
			((uint32_t)(input[10] & 0xfc) << 14);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 86 to 101
	value = ((uint32_t)(input[10] & 0x03) << 30) |
			((uint32_t)input[11] << 22) |
			((uint32_t)(input[12] & 0xfc) << 14);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 102 to 117
	value = ((uint32_t)(input[12] & 0x03) << 30) |
			((uint32_t)input[13] << 22) |
			((uint32_t)(input[14] & 0xfc) << 14);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 118 to 133
	value = ((uint32_t)(input[14] & 0x03) << 30) |
			((uint32_t)input[15] << 22) |
			((uint32_t)(input[16] & 0xfc) << 14);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 134 to 149
	value = ((uint32_t)(input[16] & 0x03) << 30) |
			((uint32_t)input[17] << 22) |
			((uint32_t)(input[18] & 0xfc) << 14);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 150 to 165
	value = ((uint32_t)(input[18] & 0x03) << 30) |
			((uint32_t)input[19] << 22) |
			((uint32_t)(input[20] & 0xfc) << 14);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 166 to 181
	value = ((uint32_t)(input[20] & 0x03) << 30) |
			((uint32_t)input[21] << 22) |
			((uint32_t)(input[22] & 0xfc) << 14);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 182 to 197
	value = ((uint32_t)(input[22] & 0x03) << 30) |
			((uint32_t)input[23] << 22) |
			((uint32_t)(input[24] & 0xfc) << 14);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 198 to 213
	value = ((uint32_t)(input[24] & 0x03) << 30) |
			((uint32_t)input[25] << 22) |
			((uint32_t)(input[26] & 0xfc) << 14);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 214 to 229
	value = ((uint32_t)(input[26] & 0x03) << 30) |
			((uint32_t)input[27] << 22) |
			((uint32_t)(input[28] & 0xfc) << 14);
	output[13] = (double)(value >> 16);
}

static void unpack_14_16bit_signed_7off(const uint8_t * input, double * output, void *closure) {
	// Unpack 14 values into output
	// Values are 16-bit signed
	// Skip 7 bits, read 224 bits of data.
	// Input must be at least 29 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 7 to 22
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)(input[2] & 0xfe) << 15);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 23 to 38
	value = ((uint32_t)(input[2] & 0x01) << 31) |
			((uint32_t)input[3] << 23) |
			((uint32_t)(input[4] & 0xfe) << 15);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 39 to 54
	value = ((uint32_t)(input[4] & 0x01) << 31) |
			((uint32_t)input[5] << 23) |
			((uint32_t)(input[6] & 0xfe) << 15);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 55 to 70
	value = ((uint32_t)(input[6] & 0x01) << 31) |
			((uint32_t)input[7] << 23) |
			((uint32_t)(input[8] & 0xfe) << 15);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 71 to 86
	value = ((uint32_t)(input[8] & 0x01) << 31) |
			((uint32_t)input[9] << 23) |
			((uint32_t)(input[10] & 0xfe) << 15);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 87 to 102
	value = ((uint32_t)(input[10] & 0x01) << 31) |
			((uint32_t)input[11] << 23) |
			((uint32_t)(input[12] & 0xfe) << 15);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 103 to 118
	value = ((uint32_t)(input[12] & 0x01) << 31) |
			((uint32_t)input[13] << 23) |
			((uint32_t)(input[14] & 0xfe) << 15);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 119 to 134
	value = ((uint32_t)(input[14] & 0x01) << 31) |
			((uint32_t)input[15] << 23) |
			((uint32_t)(input[16] & 0xfe) << 15);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 135 to 150
	value = ((uint32_t)(input[16] & 0x01) << 31) |
			((uint32_t)input[17] << 23) |
			((uint32_t)(input[18] & 0xfe) << 15);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 151 to 166
	value = ((uint32_t)(input[18] & 0x01) << 31) |
			((uint32_t)input[19] << 23) |
			((uint32_t)(input[20] & 0xfe) << 15);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 167 to 182
	value = ((uint32_t)(input[20] & 0x01) << 31) |
			((uint32_t)input[21] << 23) |
			((uint32_t)(input[22] & 0xfe) << 15);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 183 to 198
	value = ((uint32_t)(input[22] & 0x01) << 31) |
			((uint32_t)input[23] << 23) |
			((uint32_t)(input[24] & 0xfe) << 15);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 199 to 214
	value = ((uint32_t)(input[24] & 0x01) << 31) |
			((uint32_t)input[25] << 23) |
			((uint32_t)(input[26] & 0xfe) << 15);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 215 to 230
	value = ((uint32_t)(input[26] & 0x01) << 31) |
			((uint32_t)input[27] << 23) |
			((uint32_t)(input[28] & 0xfe) << 15);
	output[13] = (double)(value >> 16);
}

static void unpack_14_16bit_unsigned_7off(const uint8_t * input, double * output, void *closure) {
	// Unpack 14 values into output
	// Values are 16-bit unsigned
	// Skip 7 bits, read 224 bits of data.
	// Input must be at least 29 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 7 to 22
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)(input[2] & 0xfe) << 15);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 23 to 38
	value = ((uint32_t)(input[2] & 0x01) << 31) |
			((uint32_t)input[3] << 23) |
			((uint32_t)(input[4] & 0xfe) << 15);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 39 to 54
	value = ((uint32_t)(input[4] & 0x01) << 31) |
			((uint32_t)input[5] << 23) |
			((uint32_t)(input[6] & 0xfe) << 15);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 55 to 70
	value = ((uint32_t)(input[6] & 0x01) << 31) |
			((uint32_t)input[7] << 23) |
			((uint32_t)(input[8] & 0xfe) << 15);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 71 to 86
	value = ((uint32_t)(input[8] & 0x01) << 31) |
			((uint32_t)input[9] << 23) |
			((uint32_t)(input[10] & 0xfe) << 15);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 87 to 102
	value = ((uint32_t)(input[10] & 0x01) << 31) |
			((uint32_t)input[11] << 23) |
			((uint32_t)(input[12] & 0xfe) << 15);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 103 to 118
	value = ((uint32_t)(input[12] & 0x01) << 31) |
			((uint32_t)input[13] << 23) |
			((uint32_t)(input[14] & 0xfe) << 15);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 119 to 134
	value = ((uint32_t)(input[14] & 0x01) << 31) |
			((uint32_t)input[15] << 23) |
			((uint32_t)(input[16] & 0xfe) << 15);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 135 to 150
	value = ((uint32_t)(input[16] & 0x01) << 31) |
			((uint32_t)input[17] << 23) |
			((uint32_t)(input[18] & 0xfe) << 15);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 151 to 166
	value = ((uint32_t)(input[18] & 0x01) << 31) |
			((uint32_t)input[19] << 23) |
			((uint32_t)(input[20] & 0xfe) << 15);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 167 to 182
	value = ((uint32_t)(input[20] & 0x01) << 31) |
			((uint32_t)input[21] << 23) |
			((uint32_t)(input[22] & 0xfe) << 15);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 183 to 198
	value = ((uint32_t)(input[22] & 0x01) << 31) |
			((uint32_t)input[23] << 23) |
			((uint32_t)(input[24] & 0xfe) << 15);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 199 to 214
	value = ((uint32_t)(input[24] & 0x01) << 31) |
			((uint32_t)input[25] << 23) |
			((uint32_t)(input[26] & 0xfe) << 15);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 215 to 230
	value = ((uint32_t)(input[26] & 0x01) << 31) |
			((uint32_t)input[27] << 23) |
			((uint32_t)(input[28] & 0xfe) << 15);
	output[13] = (double)(value >> 16);
}

static void unpack_15_16bit_signed_0off(const uint8_t * input, double * output, void *closure) {
	// Unpack 15 values into output
	// Values are 16-bit signed
	// Skip 0 bits, read 240 bits of data.
	// Input must be at least 30 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 0 to 15
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)input[1] << 16);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 16 to 31
	value = ((uint32_t)input[2] << 24) |
			((uint32_t)input[3] << 16);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 32 to 47
	value = ((uint32_t)input[4] << 24) |
			((uint32_t)input[5] << 16);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 48 to 63
	value = ((uint32_t)input[6] << 24) |
			((uint32_t)input[7] << 16);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 64 to 79
	value = ((uint32_t)input[8] << 24) |
			((uint32_t)input[9] << 16);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 80 to 95
	value = ((uint32_t)input[10] << 24) |
			((uint32_t)input[11] << 16);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 96 to 111
	value = ((uint32_t)input[12] << 24) |
			((uint32_t)input[13] << 16);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 112 to 127
	value = ((uint32_t)input[14] << 24) |
			((uint32_t)input[15] << 16);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 128 to 143
	value = ((uint32_t)input[16] << 24) |
			((uint32_t)input[17] << 16);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 144 to 159
	value = ((uint32_t)input[18] << 24) |
			((uint32_t)input[19] << 16);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 160 to 175
	value = ((uint32_t)input[20] << 24) |
			((uint32_t)input[21] << 16);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 176 to 191
	value = ((uint32_t)input[22] << 24) |
			((uint32_t)input[23] << 16);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 192 to 207
	value = ((uint32_t)input[24] << 24) |
			((uint32_t)input[25] << 16);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 208 to 223
	value = ((uint32_t)input[26] << 24) |
			((uint32_t)input[27] << 16);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 224 to 239
	value = ((uint32_t)input[28] << 24) |
			((uint32_t)input[29] << 16);
	output[14] = (double)(value >> 16);
}

static void unpack_15_16bit_unsigned_0off(const uint8_t * input, double * output, void *closure) {
	// Unpack 15 values into output
	// Values are 16-bit unsigned
	// Skip 0 bits, read 240 bits of data.
	// Input must be at least 30 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 0 to 15
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)input[1] << 16);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 16 to 31
	value = ((uint32_t)input[2] << 24) |
			((uint32_t)input[3] << 16);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 32 to 47
	value = ((uint32_t)input[4] << 24) |
			((uint32_t)input[5] << 16);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 48 to 63
	value = ((uint32_t)input[6] << 24) |
			((uint32_t)input[7] << 16);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 64 to 79
	value = ((uint32_t)input[8] << 24) |
			((uint32_t)input[9] << 16);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 80 to 95
	value = ((uint32_t)input[10] << 24) |
			((uint32_t)input[11] << 16);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 96 to 111
	value = ((uint32_t)input[12] << 24) |
			((uint32_t)input[13] << 16);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 112 to 127
	value = ((uint32_t)input[14] << 24) |
			((uint32_t)input[15] << 16);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 128 to 143
	value = ((uint32_t)input[16] << 24) |
			((uint32_t)input[17] << 16);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 144 to 159
	value = ((uint32_t)input[18] << 24) |
			((uint32_t)input[19] << 16);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 160 to 175
	value = ((uint32_t)input[20] << 24) |
			((uint32_t)input[21] << 16);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 176 to 191
	value = ((uint32_t)input[22] << 24) |
			((uint32_t)input[23] << 16);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 192 to 207
	value = ((uint32_t)input[24] << 24) |
			((uint32_t)input[25] << 16);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 208 to 223
	value = ((uint32_t)input[26] << 24) |
			((uint32_t)input[27] << 16);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 224 to 239
	value = ((uint32_t)input[28] << 24) |
			((uint32_t)input[29] << 16);
	output[14] = (double)(value >> 16);
}

static void unpack_15_16bit_signed_1off(const uint8_t * input, double * output, void *closure) {
	// Unpack 15 values into output
	// Values are 16-bit signed
	// Skip 1 bits, read 240 bits of data.
	// Input must be at least 31 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 1 to 16
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)input[1] << 17) |
			((uint32_t)(input[2] & 0x80) << 9);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 17 to 32
	value = ((uint32_t)(input[2] & 0x7f) << 25) |
			((uint32_t)input[3] << 17) |
			((uint32_t)(input[4] & 0x80) << 9);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 33 to 48
	value = ((uint32_t)(input[4] & 0x7f) << 25) |
			((uint32_t)input[5] << 17) |
			((uint32_t)(input[6] & 0x80) << 9);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 49 to 64
	value = ((uint32_t)(input[6] & 0x7f) << 25) |
			((uint32_t)input[7] << 17) |
			((uint32_t)(input[8] & 0x80) << 9);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 65 to 80
	value = ((uint32_t)(input[8] & 0x7f) << 25) |
			((uint32_t)input[9] << 17) |
			((uint32_t)(input[10] & 0x80) << 9);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 81 to 96
	value = ((uint32_t)(input[10] & 0x7f) << 25) |
			((uint32_t)input[11] << 17) |
			((uint32_t)(input[12] & 0x80) << 9);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 97 to 112
	value = ((uint32_t)(input[12] & 0x7f) << 25) |
			((uint32_t)input[13] << 17) |
			((uint32_t)(input[14] & 0x80) << 9);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 113 to 128
	value = ((uint32_t)(input[14] & 0x7f) << 25) |
			((uint32_t)input[15] << 17) |
			((uint32_t)(input[16] & 0x80) << 9);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 129 to 144
	value = ((uint32_t)(input[16] & 0x7f) << 25) |
			((uint32_t)input[17] << 17) |
			((uint32_t)(input[18] & 0x80) << 9);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 145 to 160
	value = ((uint32_t)(input[18] & 0x7f) << 25) |
			((uint32_t)input[19] << 17) |
			((uint32_t)(input[20] & 0x80) << 9);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 161 to 176
	value = ((uint32_t)(input[20] & 0x7f) << 25) |
			((uint32_t)input[21] << 17) |
			((uint32_t)(input[22] & 0x80) << 9);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 177 to 192
	value = ((uint32_t)(input[22] & 0x7f) << 25) |
			((uint32_t)input[23] << 17) |
			((uint32_t)(input[24] & 0x80) << 9);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 193 to 208
	value = ((uint32_t)(input[24] & 0x7f) << 25) |
			((uint32_t)input[25] << 17) |
			((uint32_t)(input[26] & 0x80) << 9);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 209 to 224
	value = ((uint32_t)(input[26] & 0x7f) << 25) |
			((uint32_t)input[27] << 17) |
			((uint32_t)(input[28] & 0x80) << 9);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 225 to 240
	value = ((uint32_t)(input[28] & 0x7f) << 25) |
			((uint32_t)input[29] << 17) |
			((uint32_t)(input[30] & 0x80) << 9);
	output[14] = (double)(value >> 16);
}

static void unpack_15_16bit_unsigned_1off(const uint8_t * input, double * output, void *closure) {
	// Unpack 15 values into output
	// Values are 16-bit unsigned
	// Skip 1 bits, read 240 bits of data.
	// Input must be at least 31 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 1 to 16
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)input[1] << 17) |
			((uint32_t)(input[2] & 0x80) << 9);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 17 to 32
	value = ((uint32_t)(input[2] & 0x7f) << 25) |
			((uint32_t)input[3] << 17) |
			((uint32_t)(input[4] & 0x80) << 9);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 33 to 48
	value = ((uint32_t)(input[4] & 0x7f) << 25) |
			((uint32_t)input[5] << 17) |
			((uint32_t)(input[6] & 0x80) << 9);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 49 to 64
	value = ((uint32_t)(input[6] & 0x7f) << 25) |
			((uint32_t)input[7] << 17) |
			((uint32_t)(input[8] & 0x80) << 9);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 65 to 80
	value = ((uint32_t)(input[8] & 0x7f) << 25) |
			((uint32_t)input[9] << 17) |
			((uint32_t)(input[10] & 0x80) << 9);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 81 to 96
	value = ((uint32_t)(input[10] & 0x7f) << 25) |
			((uint32_t)input[11] << 17) |
			((uint32_t)(input[12] & 0x80) << 9);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 97 to 112
	value = ((uint32_t)(input[12] & 0x7f) << 25) |
			((uint32_t)input[13] << 17) |
			((uint32_t)(input[14] & 0x80) << 9);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 113 to 128
	value = ((uint32_t)(input[14] & 0x7f) << 25) |
			((uint32_t)input[15] << 17) |
			((uint32_t)(input[16] & 0x80) << 9);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 129 to 144
	value = ((uint32_t)(input[16] & 0x7f) << 25) |
			((uint32_t)input[17] << 17) |
			((uint32_t)(input[18] & 0x80) << 9);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 145 to 160
	value = ((uint32_t)(input[18] & 0x7f) << 25) |
			((uint32_t)input[19] << 17) |
			((uint32_t)(input[20] & 0x80) << 9);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 161 to 176
	value = ((uint32_t)(input[20] & 0x7f) << 25) |
			((uint32_t)input[21] << 17) |
			((uint32_t)(input[22] & 0x80) << 9);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 177 to 192
	value = ((uint32_t)(input[22] & 0x7f) << 25) |
			((uint32_t)input[23] << 17) |
			((uint32_t)(input[24] & 0x80) << 9);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 193 to 208
	value = ((uint32_t)(input[24] & 0x7f) << 25) |
			((uint32_t)input[25] << 17) |
			((uint32_t)(input[26] & 0x80) << 9);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 209 to 224
	value = ((uint32_t)(input[26] & 0x7f) << 25) |
			((uint32_t)input[27] << 17) |
			((uint32_t)(input[28] & 0x80) << 9);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 225 to 240
	value = ((uint32_t)(input[28] & 0x7f) << 25) |
			((uint32_t)input[29] << 17) |
			((uint32_t)(input[30] & 0x80) << 9);
	output[14] = (double)(value >> 16);
}

static void unpack_15_16bit_signed_2off(const uint8_t * input, double * output, void *closure) {
	// Unpack 15 values into output
	// Values are 16-bit signed
	// Skip 2 bits, read 240 bits of data.
	// Input must be at least 31 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 2 to 17
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)input[1] << 18) |
			((uint32_t)(input[2] & 0xc0) << 10);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 18 to 33
	value = ((uint32_t)(input[2] & 0x3f) << 26) |
			((uint32_t)input[3] << 18) |
			((uint32_t)(input[4] & 0xc0) << 10);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 34 to 49
	value = ((uint32_t)(input[4] & 0x3f) << 26) |
			((uint32_t)input[5] << 18) |
			((uint32_t)(input[6] & 0xc0) << 10);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 50 to 65
	value = ((uint32_t)(input[6] & 0x3f) << 26) |
			((uint32_t)input[7] << 18) |
			((uint32_t)(input[8] & 0xc0) << 10);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 66 to 81
	value = ((uint32_t)(input[8] & 0x3f) << 26) |
			((uint32_t)input[9] << 18) |
			((uint32_t)(input[10] & 0xc0) << 10);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 82 to 97
	value = ((uint32_t)(input[10] & 0x3f) << 26) |
			((uint32_t)input[11] << 18) |
			((uint32_t)(input[12] & 0xc0) << 10);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 98 to 113
	value = ((uint32_t)(input[12] & 0x3f) << 26) |
			((uint32_t)input[13] << 18) |
			((uint32_t)(input[14] & 0xc0) << 10);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 114 to 129
	value = ((uint32_t)(input[14] & 0x3f) << 26) |
			((uint32_t)input[15] << 18) |
			((uint32_t)(input[16] & 0xc0) << 10);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 130 to 145
	value = ((uint32_t)(input[16] & 0x3f) << 26) |
			((uint32_t)input[17] << 18) |
			((uint32_t)(input[18] & 0xc0) << 10);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 146 to 161
	value = ((uint32_t)(input[18] & 0x3f) << 26) |
			((uint32_t)input[19] << 18) |
			((uint32_t)(input[20] & 0xc0) << 10);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 162 to 177
	value = ((uint32_t)(input[20] & 0x3f) << 26) |
			((uint32_t)input[21] << 18) |
			((uint32_t)(input[22] & 0xc0) << 10);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 178 to 193
	value = ((uint32_t)(input[22] & 0x3f) << 26) |
			((uint32_t)input[23] << 18) |
			((uint32_t)(input[24] & 0xc0) << 10);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 194 to 209
	value = ((uint32_t)(input[24] & 0x3f) << 26) |
			((uint32_t)input[25] << 18) |
			((uint32_t)(input[26] & 0xc0) << 10);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 210 to 225
	value = ((uint32_t)(input[26] & 0x3f) << 26) |
			((uint32_t)input[27] << 18) |
			((uint32_t)(input[28] & 0xc0) << 10);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 226 to 241
	value = ((uint32_t)(input[28] & 0x3f) << 26) |
			((uint32_t)input[29] << 18) |
			((uint32_t)(input[30] & 0xc0) << 10);
	output[14] = (double)(value >> 16);
}

static void unpack_15_16bit_unsigned_2off(const uint8_t * input, double * output, void *closure) {
	// Unpack 15 values into output
	// Values are 16-bit unsigned
	// Skip 2 bits, read 240 bits of data.
	// Input must be at least 31 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 2 to 17
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)input[1] << 18) |
			((uint32_t)(input[2] & 0xc0) << 10);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 18 to 33
	value = ((uint32_t)(input[2] & 0x3f) << 26) |
			((uint32_t)input[3] << 18) |
			((uint32_t)(input[4] & 0xc0) << 10);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 34 to 49
	value = ((uint32_t)(input[4] & 0x3f) << 26) |
			((uint32_t)input[5] << 18) |
			((uint32_t)(input[6] & 0xc0) << 10);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 50 to 65
	value = ((uint32_t)(input[6] & 0x3f) << 26) |
			((uint32_t)input[7] << 18) |
			((uint32_t)(input[8] & 0xc0) << 10);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 66 to 81
	value = ((uint32_t)(input[8] & 0x3f) << 26) |
			((uint32_t)input[9] << 18) |
			((uint32_t)(input[10] & 0xc0) << 10);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 82 to 97
	value = ((uint32_t)(input[10] & 0x3f) << 26) |
			((uint32_t)input[11] << 18) |
			((uint32_t)(input[12] & 0xc0) << 10);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 98 to 113
	value = ((uint32_t)(input[12] & 0x3f) << 26) |
			((uint32_t)input[13] << 18) |
			((uint32_t)(input[14] & 0xc0) << 10);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 114 to 129
	value = ((uint32_t)(input[14] & 0x3f) << 26) |
			((uint32_t)input[15] << 18) |
			((uint32_t)(input[16] & 0xc0) << 10);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 130 to 145
	value = ((uint32_t)(input[16] & 0x3f) << 26) |
			((uint32_t)input[17] << 18) |
			((uint32_t)(input[18] & 0xc0) << 10);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 146 to 161
	value = ((uint32_t)(input[18] & 0x3f) << 26) |
			((uint32_t)input[19] << 18) |
			((uint32_t)(input[20] & 0xc0) << 10);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 162 to 177
	value = ((uint32_t)(input[20] & 0x3f) << 26) |
			((uint32_t)input[21] << 18) |
			((uint32_t)(input[22] & 0xc0) << 10);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 178 to 193
	value = ((uint32_t)(input[22] & 0x3f) << 26) |
			((uint32_t)input[23] << 18) |
			((uint32_t)(input[24] & 0xc0) << 10);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 194 to 209
	value = ((uint32_t)(input[24] & 0x3f) << 26) |
			((uint32_t)input[25] << 18) |
			((uint32_t)(input[26] & 0xc0) << 10);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 210 to 225
	value = ((uint32_t)(input[26] & 0x3f) << 26) |
			((uint32_t)input[27] << 18) |
			((uint32_t)(input[28] & 0xc0) << 10);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 226 to 241
	value = ((uint32_t)(input[28] & 0x3f) << 26) |
			((uint32_t)input[29] << 18) |
			((uint32_t)(input[30] & 0xc0) << 10);
	output[14] = (double)(value >> 16);
}

static void unpack_15_16bit_signed_3off(const uint8_t * input, double * output, void *closure) {
	// Unpack 15 values into output
	// Values are 16-bit signed
	// Skip 3 bits, read 240 bits of data.
	// Input must be at least 31 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 3 to 18
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)input[1] << 19) |
			((uint32_t)(input[2] & 0xe0) << 11);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 19 to 34
	value = ((uint32_t)(input[2] & 0x1f) << 27) |
			((uint32_t)input[3] << 19) |
			((uint32_t)(input[4] & 0xe0) << 11);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 35 to 50
	value = ((uint32_t)(input[4] & 0x1f) << 27) |
			((uint32_t)input[5] << 19) |
			((uint32_t)(input[6] & 0xe0) << 11);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 51 to 66
	value = ((uint32_t)(input[6] & 0x1f) << 27) |
			((uint32_t)input[7] << 19) |
			((uint32_t)(input[8] & 0xe0) << 11);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 67 to 82
	value = ((uint32_t)(input[8] & 0x1f) << 27) |
			((uint32_t)input[9] << 19) |
			((uint32_t)(input[10] & 0xe0) << 11);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 83 to 98
	value = ((uint32_t)(input[10] & 0x1f) << 27) |
			((uint32_t)input[11] << 19) |
			((uint32_t)(input[12] & 0xe0) << 11);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 99 to 114
	value = ((uint32_t)(input[12] & 0x1f) << 27) |
			((uint32_t)input[13] << 19) |
			((uint32_t)(input[14] & 0xe0) << 11);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 115 to 130
	value = ((uint32_t)(input[14] & 0x1f) << 27) |
			((uint32_t)input[15] << 19) |
			((uint32_t)(input[16] & 0xe0) << 11);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 131 to 146
	value = ((uint32_t)(input[16] & 0x1f) << 27) |
			((uint32_t)input[17] << 19) |
			((uint32_t)(input[18] & 0xe0) << 11);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 147 to 162
	value = ((uint32_t)(input[18] & 0x1f) << 27) |
			((uint32_t)input[19] << 19) |
			((uint32_t)(input[20] & 0xe0) << 11);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 163 to 178
	value = ((uint32_t)(input[20] & 0x1f) << 27) |
			((uint32_t)input[21] << 19) |
			((uint32_t)(input[22] & 0xe0) << 11);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 179 to 194
	value = ((uint32_t)(input[22] & 0x1f) << 27) |
			((uint32_t)input[23] << 19) |
			((uint32_t)(input[24] & 0xe0) << 11);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 195 to 210
	value = ((uint32_t)(input[24] & 0x1f) << 27) |
			((uint32_t)input[25] << 19) |
			((uint32_t)(input[26] & 0xe0) << 11);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 211 to 226
	value = ((uint32_t)(input[26] & 0x1f) << 27) |
			((uint32_t)input[27] << 19) |
			((uint32_t)(input[28] & 0xe0) << 11);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 227 to 242
	value = ((uint32_t)(input[28] & 0x1f) << 27) |
			((uint32_t)input[29] << 19) |
			((uint32_t)(input[30] & 0xe0) << 11);
	output[14] = (double)(value >> 16);
}

static void unpack_15_16bit_unsigned_3off(const uint8_t * input, double * output, void *closure) {
	// Unpack 15 values into output
	// Values are 16-bit unsigned
	// Skip 3 bits, read 240 bits of data.
	// Input must be at least 31 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 3 to 18
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)input[1] << 19) |
			((uint32_t)(input[2] & 0xe0) << 11);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 19 to 34
	value = ((uint32_t)(input[2] & 0x1f) << 27) |
			((uint32_t)input[3] << 19) |
			((uint32_t)(input[4] & 0xe0) << 11);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 35 to 50
	value = ((uint32_t)(input[4] & 0x1f) << 27) |
			((uint32_t)input[5] << 19) |
			((uint32_t)(input[6] & 0xe0) << 11);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 51 to 66
	value = ((uint32_t)(input[6] & 0x1f) << 27) |
			((uint32_t)input[7] << 19) |
			((uint32_t)(input[8] & 0xe0) << 11);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 67 to 82
	value = ((uint32_t)(input[8] & 0x1f) << 27) |
			((uint32_t)input[9] << 19) |
			((uint32_t)(input[10] & 0xe0) << 11);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 83 to 98
	value = ((uint32_t)(input[10] & 0x1f) << 27) |
			((uint32_t)input[11] << 19) |
			((uint32_t)(input[12] & 0xe0) << 11);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 99 to 114
	value = ((uint32_t)(input[12] & 0x1f) << 27) |
			((uint32_t)input[13] << 19) |
			((uint32_t)(input[14] & 0xe0) << 11);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 115 to 130
	value = ((uint32_t)(input[14] & 0x1f) << 27) |
			((uint32_t)input[15] << 19) |
			((uint32_t)(input[16] & 0xe0) << 11);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 131 to 146
	value = ((uint32_t)(input[16] & 0x1f) << 27) |
			((uint32_t)input[17] << 19) |
			((uint32_t)(input[18] & 0xe0) << 11);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 147 to 162
	value = ((uint32_t)(input[18] & 0x1f) << 27) |
			((uint32_t)input[19] << 19) |
			((uint32_t)(input[20] & 0xe0) << 11);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 163 to 178
	value = ((uint32_t)(input[20] & 0x1f) << 27) |
			((uint32_t)input[21] << 19) |
			((uint32_t)(input[22] & 0xe0) << 11);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 179 to 194
	value = ((uint32_t)(input[22] & 0x1f) << 27) |
			((uint32_t)input[23] << 19) |
			((uint32_t)(input[24] & 0xe0) << 11);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 195 to 210
	value = ((uint32_t)(input[24] & 0x1f) << 27) |
			((uint32_t)input[25] << 19) |
			((uint32_t)(input[26] & 0xe0) << 11);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 211 to 226
	value = ((uint32_t)(input[26] & 0x1f) << 27) |
			((uint32_t)input[27] << 19) |
			((uint32_t)(input[28] & 0xe0) << 11);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 227 to 242
	value = ((uint32_t)(input[28] & 0x1f) << 27) |
			((uint32_t)input[29] << 19) |
			((uint32_t)(input[30] & 0xe0) << 11);
	output[14] = (double)(value >> 16);
}

static void unpack_15_16bit_signed_4off(const uint8_t * input, double * output, void *closure) {
	// Unpack 15 values into output
	// Values are 16-bit signed
	// Skip 4 bits, read 240 bits of data.
	// Input must be at least 31 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 4 to 19
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20) |
			((uint32_t)(input[2] & 0xf0) << 12);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 20 to 35
	value = ((uint32_t)(input[2] & 0x0f) << 28) |
			((uint32_t)input[3] << 20) |
			((uint32_t)(input[4] & 0xf0) << 12);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 36 to 51
	value = ((uint32_t)(input[4] & 0x0f) << 28) |
			((uint32_t)input[5] << 20) |
			((uint32_t)(input[6] & 0xf0) << 12);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 52 to 67
	value = ((uint32_t)(input[6] & 0x0f) << 28) |
			((uint32_t)input[7] << 20) |
			((uint32_t)(input[8] & 0xf0) << 12);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 68 to 83
	value = ((uint32_t)(input[8] & 0x0f) << 28) |
			((uint32_t)input[9] << 20) |
			((uint32_t)(input[10] & 0xf0) << 12);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 84 to 99
	value = ((uint32_t)(input[10] & 0x0f) << 28) |
			((uint32_t)input[11] << 20) |
			((uint32_t)(input[12] & 0xf0) << 12);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 100 to 115
	value = ((uint32_t)(input[12] & 0x0f) << 28) |
			((uint32_t)input[13] << 20) |
			((uint32_t)(input[14] & 0xf0) << 12);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 116 to 131
	value = ((uint32_t)(input[14] & 0x0f) << 28) |
			((uint32_t)input[15] << 20) |
			((uint32_t)(input[16] & 0xf0) << 12);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 132 to 147
	value = ((uint32_t)(input[16] & 0x0f) << 28) |
			((uint32_t)input[17] << 20) |
			((uint32_t)(input[18] & 0xf0) << 12);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 148 to 163
	value = ((uint32_t)(input[18] & 0x0f) << 28) |
			((uint32_t)input[19] << 20) |
			((uint32_t)(input[20] & 0xf0) << 12);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 164 to 179
	value = ((uint32_t)(input[20] & 0x0f) << 28) |
			((uint32_t)input[21] << 20) |
			((uint32_t)(input[22] & 0xf0) << 12);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 180 to 195
	value = ((uint32_t)(input[22] & 0x0f) << 28) |
			((uint32_t)input[23] << 20) |
			((uint32_t)(input[24] & 0xf0) << 12);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 196 to 211
	value = ((uint32_t)(input[24] & 0x0f) << 28) |
			((uint32_t)input[25] << 20) |
			((uint32_t)(input[26] & 0xf0) << 12);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 212 to 227
	value = ((uint32_t)(input[26] & 0x0f) << 28) |
			((uint32_t)input[27] << 20) |
			((uint32_t)(input[28] & 0xf0) << 12);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 228 to 243
	value = ((uint32_t)(input[28] & 0x0f) << 28) |
			((uint32_t)input[29] << 20) |
			((uint32_t)(input[30] & 0xf0) << 12);
	output[14] = (double)(value >> 16);
}

static void unpack_15_16bit_unsigned_4off(const uint8_t * input, double * output, void *closure) {
	// Unpack 15 values into output
	// Values are 16-bit unsigned
	// Skip 4 bits, read 240 bits of data.
	// Input must be at least 31 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 4 to 19
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20) |
			((uint32_t)(input[2] & 0xf0) << 12);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 20 to 35
	value = ((uint32_t)(input[2] & 0x0f) << 28) |
			((uint32_t)input[3] << 20) |
			((uint32_t)(input[4] & 0xf0) << 12);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 36 to 51
	value = ((uint32_t)(input[4] & 0x0f) << 28) |
			((uint32_t)input[5] << 20) |
			((uint32_t)(input[6] & 0xf0) << 12);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 52 to 67
	value = ((uint32_t)(input[6] & 0x0f) << 28) |
			((uint32_t)input[7] << 20) |
			((uint32_t)(input[8] & 0xf0) << 12);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 68 to 83
	value = ((uint32_t)(input[8] & 0x0f) << 28) |
			((uint32_t)input[9] << 20) |
			((uint32_t)(input[10] & 0xf0) << 12);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 84 to 99
	value = ((uint32_t)(input[10] & 0x0f) << 28) |
			((uint32_t)input[11] << 20) |
			((uint32_t)(input[12] & 0xf0) << 12);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 100 to 115
	value = ((uint32_t)(input[12] & 0x0f) << 28) |
			((uint32_t)input[13] << 20) |
			((uint32_t)(input[14] & 0xf0) << 12);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 116 to 131
	value = ((uint32_t)(input[14] & 0x0f) << 28) |
			((uint32_t)input[15] << 20) |
			((uint32_t)(input[16] & 0xf0) << 12);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 132 to 147
	value = ((uint32_t)(input[16] & 0x0f) << 28) |
			((uint32_t)input[17] << 20) |
			((uint32_t)(input[18] & 0xf0) << 12);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 148 to 163
	value = ((uint32_t)(input[18] & 0x0f) << 28) |
			((uint32_t)input[19] << 20) |
			((uint32_t)(input[20] & 0xf0) << 12);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 164 to 179
	value = ((uint32_t)(input[20] & 0x0f) << 28) |
			((uint32_t)input[21] << 20) |
			((uint32_t)(input[22] & 0xf0) << 12);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 180 to 195
	value = ((uint32_t)(input[22] & 0x0f) << 28) |
			((uint32_t)input[23] << 20) |
			((uint32_t)(input[24] & 0xf0) << 12);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 196 to 211
	value = ((uint32_t)(input[24] & 0x0f) << 28) |
			((uint32_t)input[25] << 20) |
			((uint32_t)(input[26] & 0xf0) << 12);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 212 to 227
	value = ((uint32_t)(input[26] & 0x0f) << 28) |
			((uint32_t)input[27] << 20) |
			((uint32_t)(input[28] & 0xf0) << 12);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 228 to 243
	value = ((uint32_t)(input[28] & 0x0f) << 28) |
			((uint32_t)input[29] << 20) |
			((uint32_t)(input[30] & 0xf0) << 12);
	output[14] = (double)(value >> 16);
}

static void unpack_15_16bit_signed_5off(const uint8_t * input, double * output, void *closure) {
	// Unpack 15 values into output
	// Values are 16-bit signed
	// Skip 5 bits, read 240 bits of data.
	// Input must be at least 31 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 5 to 20
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)(input[2] & 0xf8) << 13);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 21 to 36
	value = ((uint32_t)(input[2] & 0x07) << 29) |
			((uint32_t)input[3] << 21) |
			((uint32_t)(input[4] & 0xf8) << 13);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 37 to 52
	value = ((uint32_t)(input[4] & 0x07) << 29) |
			((uint32_t)input[5] << 21) |
			((uint32_t)(input[6] & 0xf8) << 13);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 53 to 68
	value = ((uint32_t)(input[6] & 0x07) << 29) |
			((uint32_t)input[7] << 21) |
			((uint32_t)(input[8] & 0xf8) << 13);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 69 to 84
	value = ((uint32_t)(input[8] & 0x07) << 29) |
			((uint32_t)input[9] << 21) |
			((uint32_t)(input[10] & 0xf8) << 13);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 85 to 100
	value = ((uint32_t)(input[10] & 0x07) << 29) |
			((uint32_t)input[11] << 21) |
			((uint32_t)(input[12] & 0xf8) << 13);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 101 to 116
	value = ((uint32_t)(input[12] & 0x07) << 29) |
			((uint32_t)input[13] << 21) |
			((uint32_t)(input[14] & 0xf8) << 13);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 117 to 132
	value = ((uint32_t)(input[14] & 0x07) << 29) |
			((uint32_t)input[15] << 21) |
			((uint32_t)(input[16] & 0xf8) << 13);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 133 to 148
	value = ((uint32_t)(input[16] & 0x07) << 29) |
			((uint32_t)input[17] << 21) |
			((uint32_t)(input[18] & 0xf8) << 13);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 149 to 164
	value = ((uint32_t)(input[18] & 0x07) << 29) |
			((uint32_t)input[19] << 21) |
			((uint32_t)(input[20] & 0xf8) << 13);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 165 to 180
	value = ((uint32_t)(input[20] & 0x07) << 29) |
			((uint32_t)input[21] << 21) |
			((uint32_t)(input[22] & 0xf8) << 13);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 181 to 196
	value = ((uint32_t)(input[22] & 0x07) << 29) |
			((uint32_t)input[23] << 21) |
			((uint32_t)(input[24] & 0xf8) << 13);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 197 to 212
	value = ((uint32_t)(input[24] & 0x07) << 29) |
			((uint32_t)input[25] << 21) |
			((uint32_t)(input[26] & 0xf8) << 13);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 213 to 228
	value = ((uint32_t)(input[26] & 0x07) << 29) |
			((uint32_t)input[27] << 21) |
			((uint32_t)(input[28] & 0xf8) << 13);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 229 to 244
	value = ((uint32_t)(input[28] & 0x07) << 29) |
			((uint32_t)input[29] << 21) |
			((uint32_t)(input[30] & 0xf8) << 13);
	output[14] = (double)(value >> 16);
}

static void unpack_15_16bit_unsigned_5off(const uint8_t * input, double * output, void *closure) {
	// Unpack 15 values into output
	// Values are 16-bit unsigned
	// Skip 5 bits, read 240 bits of data.
	// Input must be at least 31 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 5 to 20
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)(input[2] & 0xf8) << 13);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 21 to 36
	value = ((uint32_t)(input[2] & 0x07) << 29) |
			((uint32_t)input[3] << 21) |
			((uint32_t)(input[4] & 0xf8) << 13);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 37 to 52
	value = ((uint32_t)(input[4] & 0x07) << 29) |
			((uint32_t)input[5] << 21) |
			((uint32_t)(input[6] & 0xf8) << 13);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 53 to 68
	value = ((uint32_t)(input[6] & 0x07) << 29) |
			((uint32_t)input[7] << 21) |
			((uint32_t)(input[8] & 0xf8) << 13);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 69 to 84
	value = ((uint32_t)(input[8] & 0x07) << 29) |
			((uint32_t)input[9] << 21) |
			((uint32_t)(input[10] & 0xf8) << 13);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 85 to 100
	value = ((uint32_t)(input[10] & 0x07) << 29) |
			((uint32_t)input[11] << 21) |
			((uint32_t)(input[12] & 0xf8) << 13);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 101 to 116
	value = ((uint32_t)(input[12] & 0x07) << 29) |
			((uint32_t)input[13] << 21) |
			((uint32_t)(input[14] & 0xf8) << 13);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 117 to 132
	value = ((uint32_t)(input[14] & 0x07) << 29) |
			((uint32_t)input[15] << 21) |
			((uint32_t)(input[16] & 0xf8) << 13);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 133 to 148
	value = ((uint32_t)(input[16] & 0x07) << 29) |
			((uint32_t)input[17] << 21) |
			((uint32_t)(input[18] & 0xf8) << 13);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 149 to 164
	value = ((uint32_t)(input[18] & 0x07) << 29) |
			((uint32_t)input[19] << 21) |
			((uint32_t)(input[20] & 0xf8) << 13);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 165 to 180
	value = ((uint32_t)(input[20] & 0x07) << 29) |
			((uint32_t)input[21] << 21) |
			((uint32_t)(input[22] & 0xf8) << 13);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 181 to 196
	value = ((uint32_t)(input[22] & 0x07) << 29) |
			((uint32_t)input[23] << 21) |
			((uint32_t)(input[24] & 0xf8) << 13);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 197 to 212
	value = ((uint32_t)(input[24] & 0x07) << 29) |
			((uint32_t)input[25] << 21) |
			((uint32_t)(input[26] & 0xf8) << 13);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 213 to 228
	value = ((uint32_t)(input[26] & 0x07) << 29) |
			((uint32_t)input[27] << 21) |
			((uint32_t)(input[28] & 0xf8) << 13);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 229 to 244
	value = ((uint32_t)(input[28] & 0x07) << 29) |
			((uint32_t)input[29] << 21) |
			((uint32_t)(input[30] & 0xf8) << 13);
	output[14] = (double)(value >> 16);
}

static void unpack_15_16bit_signed_6off(const uint8_t * input, double * output, void *closure) {
	// Unpack 15 values into output
	// Values are 16-bit signed
	// Skip 6 bits, read 240 bits of data.
	// Input must be at least 31 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 6 to 21
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)(input[2] & 0xfc) << 14);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 22 to 37
	value = ((uint32_t)(input[2] & 0x03) << 30) |
			((uint32_t)input[3] << 22) |
			((uint32_t)(input[4] & 0xfc) << 14);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 38 to 53
	value = ((uint32_t)(input[4] & 0x03) << 30) |
			((uint32_t)input[5] << 22) |
			((uint32_t)(input[6] & 0xfc) << 14);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 54 to 69
	value = ((uint32_t)(input[6] & 0x03) << 30) |
			((uint32_t)input[7] << 22) |
			((uint32_t)(input[8] & 0xfc) << 14);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 70 to 85
	value = ((uint32_t)(input[8] & 0x03) << 30) |
			((uint32_t)input[9] << 22) |
			((uint32_t)(input[10] & 0xfc) << 14);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 86 to 101
	value = ((uint32_t)(input[10] & 0x03) << 30) |
			((uint32_t)input[11] << 22) |
			((uint32_t)(input[12] & 0xfc) << 14);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 102 to 117
	value = ((uint32_t)(input[12] & 0x03) << 30) |
			((uint32_t)input[13] << 22) |
			((uint32_t)(input[14] & 0xfc) << 14);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 118 to 133
	value = ((uint32_t)(input[14] & 0x03) << 30) |
			((uint32_t)input[15] << 22) |
			((uint32_t)(input[16] & 0xfc) << 14);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 134 to 149
	value = ((uint32_t)(input[16] & 0x03) << 30) |
			((uint32_t)input[17] << 22) |
			((uint32_t)(input[18] & 0xfc) << 14);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 150 to 165
	value = ((uint32_t)(input[18] & 0x03) << 30) |
			((uint32_t)input[19] << 22) |
			((uint32_t)(input[20] & 0xfc) << 14);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 166 to 181
	value = ((uint32_t)(input[20] & 0x03) << 30) |
			((uint32_t)input[21] << 22) |
			((uint32_t)(input[22] & 0xfc) << 14);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 182 to 197
	value = ((uint32_t)(input[22] & 0x03) << 30) |
			((uint32_t)input[23] << 22) |
			((uint32_t)(input[24] & 0xfc) << 14);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 198 to 213
	value = ((uint32_t)(input[24] & 0x03) << 30) |
			((uint32_t)input[25] << 22) |
			((uint32_t)(input[26] & 0xfc) << 14);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 214 to 229
	value = ((uint32_t)(input[26] & 0x03) << 30) |
			((uint32_t)input[27] << 22) |
			((uint32_t)(input[28] & 0xfc) << 14);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 230 to 245
	value = ((uint32_t)(input[28] & 0x03) << 30) |
			((uint32_t)input[29] << 22) |
			((uint32_t)(input[30] & 0xfc) << 14);
	output[14] = (double)(value >> 16);
}

static void unpack_15_16bit_unsigned_6off(const uint8_t * input, double * output, void *closure) {
	// Unpack 15 values into output
	// Values are 16-bit unsigned
	// Skip 6 bits, read 240 bits of data.
	// Input must be at least 31 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 6 to 21
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)(input[2] & 0xfc) << 14);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 22 to 37
	value = ((uint32_t)(input[2] & 0x03) << 30) |
			((uint32_t)input[3] << 22) |
			((uint32_t)(input[4] & 0xfc) << 14);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 38 to 53
	value = ((uint32_t)(input[4] & 0x03) << 30) |
			((uint32_t)input[5] << 22) |
			((uint32_t)(input[6] & 0xfc) << 14);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 54 to 69
	value = ((uint32_t)(input[6] & 0x03) << 30) |
			((uint32_t)input[7] << 22) |
			((uint32_t)(input[8] & 0xfc) << 14);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 70 to 85
	value = ((uint32_t)(input[8] & 0x03) << 30) |
			((uint32_t)input[9] << 22) |
			((uint32_t)(input[10] & 0xfc) << 14);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 86 to 101
	value = ((uint32_t)(input[10] & 0x03) << 30) |
			((uint32_t)input[11] << 22) |
			((uint32_t)(input[12] & 0xfc) << 14);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 102 to 117
	value = ((uint32_t)(input[12] & 0x03) << 30) |
			((uint32_t)input[13] << 22) |
			((uint32_t)(input[14] & 0xfc) << 14);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 118 to 133
	value = ((uint32_t)(input[14] & 0x03) << 30) |
			((uint32_t)input[15] << 22) |
			((uint32_t)(input[16] & 0xfc) << 14);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 134 to 149
	value = ((uint32_t)(input[16] & 0x03) << 30) |
			((uint32_t)input[17] << 22) |
			((uint32_t)(input[18] & 0xfc) << 14);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 150 to 165
	value = ((uint32_t)(input[18] & 0x03) << 30) |
			((uint32_t)input[19] << 22) |
			((uint32_t)(input[20] & 0xfc) << 14);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 166 to 181
	value = ((uint32_t)(input[20] & 0x03) << 30) |
			((uint32_t)input[21] << 22) |
			((uint32_t)(input[22] & 0xfc) << 14);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 182 to 197
	value = ((uint32_t)(input[22] & 0x03) << 30) |
			((uint32_t)input[23] << 22) |
			((uint32_t)(input[24] & 0xfc) << 14);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 198 to 213
	value = ((uint32_t)(input[24] & 0x03) << 30) |
			((uint32_t)input[25] << 22) |
			((uint32_t)(input[26] & 0xfc) << 14);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 214 to 229
	value = ((uint32_t)(input[26] & 0x03) << 30) |
			((uint32_t)input[27] << 22) |
			((uint32_t)(input[28] & 0xfc) << 14);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 230 to 245
	value = ((uint32_t)(input[28] & 0x03) << 30) |
			((uint32_t)input[29] << 22) |
			((uint32_t)(input[30] & 0xfc) << 14);
	output[14] = (double)(value >> 16);
}

static void unpack_15_16bit_signed_7off(const uint8_t * input, double * output, void *closure) {
	// Unpack 15 values into output
	// Values are 16-bit signed
	// Skip 7 bits, read 240 bits of data.
	// Input must be at least 31 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 7 to 22
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)(input[2] & 0xfe) << 15);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 23 to 38
	value = ((uint32_t)(input[2] & 0x01) << 31) |
			((uint32_t)input[3] << 23) |
			((uint32_t)(input[4] & 0xfe) << 15);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 39 to 54
	value = ((uint32_t)(input[4] & 0x01) << 31) |
			((uint32_t)input[5] << 23) |
			((uint32_t)(input[6] & 0xfe) << 15);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 55 to 70
	value = ((uint32_t)(input[6] & 0x01) << 31) |
			((uint32_t)input[7] << 23) |
			((uint32_t)(input[8] & 0xfe) << 15);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 71 to 86
	value = ((uint32_t)(input[8] & 0x01) << 31) |
			((uint32_t)input[9] << 23) |
			((uint32_t)(input[10] & 0xfe) << 15);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 87 to 102
	value = ((uint32_t)(input[10] & 0x01) << 31) |
			((uint32_t)input[11] << 23) |
			((uint32_t)(input[12] & 0xfe) << 15);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 103 to 118
	value = ((uint32_t)(input[12] & 0x01) << 31) |
			((uint32_t)input[13] << 23) |
			((uint32_t)(input[14] & 0xfe) << 15);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 119 to 134
	value = ((uint32_t)(input[14] & 0x01) << 31) |
			((uint32_t)input[15] << 23) |
			((uint32_t)(input[16] & 0xfe) << 15);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 135 to 150
	value = ((uint32_t)(input[16] & 0x01) << 31) |
			((uint32_t)input[17] << 23) |
			((uint32_t)(input[18] & 0xfe) << 15);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 151 to 166
	value = ((uint32_t)(input[18] & 0x01) << 31) |
			((uint32_t)input[19] << 23) |
			((uint32_t)(input[20] & 0xfe) << 15);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 167 to 182
	value = ((uint32_t)(input[20] & 0x01) << 31) |
			((uint32_t)input[21] << 23) |
			((uint32_t)(input[22] & 0xfe) << 15);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 183 to 198
	value = ((uint32_t)(input[22] & 0x01) << 31) |
			((uint32_t)input[23] << 23) |
			((uint32_t)(input[24] & 0xfe) << 15);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 199 to 214
	value = ((uint32_t)(input[24] & 0x01) << 31) |
			((uint32_t)input[25] << 23) |
			((uint32_t)(input[26] & 0xfe) << 15);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 215 to 230
	value = ((uint32_t)(input[26] & 0x01) << 31) |
			((uint32_t)input[27] << 23) |
			((uint32_t)(input[28] & 0xfe) << 15);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 231 to 246
	value = ((uint32_t)(input[28] & 0x01) << 31) |
			((uint32_t)input[29] << 23) |
			((uint32_t)(input[30] & 0xfe) << 15);
	output[14] = (double)(value >> 16);
}

static void unpack_15_16bit_unsigned_7off(const uint8_t * input, double * output, void *closure) {
	// Unpack 15 values into output
	// Values are 16-bit unsigned
	// Skip 7 bits, read 240 bits of data.
	// Input must be at least 31 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 7 to 22
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)(input[2] & 0xfe) << 15);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 23 to 38
	value = ((uint32_t)(input[2] & 0x01) << 31) |
			((uint32_t)input[3] << 23) |
			((uint32_t)(input[4] & 0xfe) << 15);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 39 to 54
	value = ((uint32_t)(input[4] & 0x01) << 31) |
			((uint32_t)input[5] << 23) |
			((uint32_t)(input[6] & 0xfe) << 15);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 55 to 70
	value = ((uint32_t)(input[6] & 0x01) << 31) |
			((uint32_t)input[7] << 23) |
			((uint32_t)(input[8] & 0xfe) << 15);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 71 to 86
	value = ((uint32_t)(input[8] & 0x01) << 31) |
			((uint32_t)input[9] << 23) |
			((uint32_t)(input[10] & 0xfe) << 15);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 87 to 102
	value = ((uint32_t)(input[10] & 0x01) << 31) |
			((uint32_t)input[11] << 23) |
			((uint32_t)(input[12] & 0xfe) << 15);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 103 to 118
	value = ((uint32_t)(input[12] & 0x01) << 31) |
			((uint32_t)input[13] << 23) |
			((uint32_t)(input[14] & 0xfe) << 15);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 119 to 134
	value = ((uint32_t)(input[14] & 0x01) << 31) |
			((uint32_t)input[15] << 23) |
			((uint32_t)(input[16] & 0xfe) << 15);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 135 to 150
	value = ((uint32_t)(input[16] & 0x01) << 31) |
			((uint32_t)input[17] << 23) |
			((uint32_t)(input[18] & 0xfe) << 15);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 151 to 166
	value = ((uint32_t)(input[18] & 0x01) << 31) |
			((uint32_t)input[19] << 23) |
			((uint32_t)(input[20] & 0xfe) << 15);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 167 to 182
	value = ((uint32_t)(input[20] & 0x01) << 31) |
			((uint32_t)input[21] << 23) |
			((uint32_t)(input[22] & 0xfe) << 15);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 183 to 198
	value = ((uint32_t)(input[22] & 0x01) << 31) |
			((uint32_t)input[23] << 23) |
			((uint32_t)(input[24] & 0xfe) << 15);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 199 to 214
	value = ((uint32_t)(input[24] & 0x01) << 31) |
			((uint32_t)input[25] << 23) |
			((uint32_t)(input[26] & 0xfe) << 15);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 215 to 230
	value = ((uint32_t)(input[26] & 0x01) << 31) |
			((uint32_t)input[27] << 23) |
			((uint32_t)(input[28] & 0xfe) << 15);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 231 to 246
	value = ((uint32_t)(input[28] & 0x01) << 31) |
			((uint32_t)input[29] << 23) |
			((uint32_t)(input[30] & 0xfe) << 15);
	output[14] = (double)(value >> 16);
}

static void unpack_16_16bit_signed_0off(const uint8_t * input, double * output, void *closure) {
	// Unpack 16 values into output
	// Values are 16-bit signed
	// Skip 0 bits, read 256 bits of data.
	// Input must be at least 32 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 0 to 15
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)input[1] << 16);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 16 to 31
	value = ((uint32_t)input[2] << 24) |
			((uint32_t)input[3] << 16);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 32 to 47
	value = ((uint32_t)input[4] << 24) |
			((uint32_t)input[5] << 16);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 48 to 63
	value = ((uint32_t)input[6] << 24) |
			((uint32_t)input[7] << 16);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 64 to 79
	value = ((uint32_t)input[8] << 24) |
			((uint32_t)input[9] << 16);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 80 to 95
	value = ((uint32_t)input[10] << 24) |
			((uint32_t)input[11] << 16);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 96 to 111
	value = ((uint32_t)input[12] << 24) |
			((uint32_t)input[13] << 16);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 112 to 127
	value = ((uint32_t)input[14] << 24) |
			((uint32_t)input[15] << 16);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 128 to 143
	value = ((uint32_t)input[16] << 24) |
			((uint32_t)input[17] << 16);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 144 to 159
	value = ((uint32_t)input[18] << 24) |
			((uint32_t)input[19] << 16);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 160 to 175
	value = ((uint32_t)input[20] << 24) |
			((uint32_t)input[21] << 16);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 176 to 191
	value = ((uint32_t)input[22] << 24) |
			((uint32_t)input[23] << 16);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 192 to 207
	value = ((uint32_t)input[24] << 24) |
			((uint32_t)input[25] << 16);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 208 to 223
	value = ((uint32_t)input[26] << 24) |
			((uint32_t)input[27] << 16);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 224 to 239
	value = ((uint32_t)input[28] << 24) |
			((uint32_t)input[29] << 16);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 240 to 255
	value = ((uint32_t)input[30] << 24) |
			((uint32_t)input[31] << 16);
	output[15] = (double)(value >> 16);
}

static void unpack_16_16bit_unsigned_0off(const uint8_t * input, double * output, void *closure) {
	// Unpack 16 values into output
	// Values are 16-bit unsigned
	// Skip 0 bits, read 256 bits of data.
	// Input must be at least 32 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 0 to 15
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)input[1] << 16);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 16 to 31
	value = ((uint32_t)input[2] << 24) |
			((uint32_t)input[3] << 16);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 32 to 47
	value = ((uint32_t)input[4] << 24) |
			((uint32_t)input[5] << 16);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 48 to 63
	value = ((uint32_t)input[6] << 24) |
			((uint32_t)input[7] << 16);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 64 to 79
	value = ((uint32_t)input[8] << 24) |
			((uint32_t)input[9] << 16);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 80 to 95
	value = ((uint32_t)input[10] << 24) |
			((uint32_t)input[11] << 16);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 96 to 111
	value = ((uint32_t)input[12] << 24) |
			((uint32_t)input[13] << 16);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 112 to 127
	value = ((uint32_t)input[14] << 24) |
			((uint32_t)input[15] << 16);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 128 to 143
	value = ((uint32_t)input[16] << 24) |
			((uint32_t)input[17] << 16);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 144 to 159
	value = ((uint32_t)input[18] << 24) |
			((uint32_t)input[19] << 16);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 160 to 175
	value = ((uint32_t)input[20] << 24) |
			((uint32_t)input[21] << 16);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 176 to 191
	value = ((uint32_t)input[22] << 24) |
			((uint32_t)input[23] << 16);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 192 to 207
	value = ((uint32_t)input[24] << 24) |
			((uint32_t)input[25] << 16);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 208 to 223
	value = ((uint32_t)input[26] << 24) |
			((uint32_t)input[27] << 16);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 224 to 239
	value = ((uint32_t)input[28] << 24) |
			((uint32_t)input[29] << 16);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 240 to 255
	value = ((uint32_t)input[30] << 24) |
			((uint32_t)input[31] << 16);
	output[15] = (double)(value >> 16);
}

static void unpack_16_16bit_signed_1off(const uint8_t * input, double * output, void *closure) {
	// Unpack 16 values into output
	// Values are 16-bit signed
	// Skip 1 bits, read 256 bits of data.
	// Input must be at least 33 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 1 to 16
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)input[1] << 17) |
			((uint32_t)(input[2] & 0x80) << 9);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 17 to 32
	value = ((uint32_t)(input[2] & 0x7f) << 25) |
			((uint32_t)input[3] << 17) |
			((uint32_t)(input[4] & 0x80) << 9);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 33 to 48
	value = ((uint32_t)(input[4] & 0x7f) << 25) |
			((uint32_t)input[5] << 17) |
			((uint32_t)(input[6] & 0x80) << 9);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 49 to 64
	value = ((uint32_t)(input[6] & 0x7f) << 25) |
			((uint32_t)input[7] << 17) |
			((uint32_t)(input[8] & 0x80) << 9);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 65 to 80
	value = ((uint32_t)(input[8] & 0x7f) << 25) |
			((uint32_t)input[9] << 17) |
			((uint32_t)(input[10] & 0x80) << 9);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 81 to 96
	value = ((uint32_t)(input[10] & 0x7f) << 25) |
			((uint32_t)input[11] << 17) |
			((uint32_t)(input[12] & 0x80) << 9);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 97 to 112
	value = ((uint32_t)(input[12] & 0x7f) << 25) |
			((uint32_t)input[13] << 17) |
			((uint32_t)(input[14] & 0x80) << 9);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 113 to 128
	value = ((uint32_t)(input[14] & 0x7f) << 25) |
			((uint32_t)input[15] << 17) |
			((uint32_t)(input[16] & 0x80) << 9);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 129 to 144
	value = ((uint32_t)(input[16] & 0x7f) << 25) |
			((uint32_t)input[17] << 17) |
			((uint32_t)(input[18] & 0x80) << 9);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 145 to 160
	value = ((uint32_t)(input[18] & 0x7f) << 25) |
			((uint32_t)input[19] << 17) |
			((uint32_t)(input[20] & 0x80) << 9);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 161 to 176
	value = ((uint32_t)(input[20] & 0x7f) << 25) |
			((uint32_t)input[21] << 17) |
			((uint32_t)(input[22] & 0x80) << 9);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 177 to 192
	value = ((uint32_t)(input[22] & 0x7f) << 25) |
			((uint32_t)input[23] << 17) |
			((uint32_t)(input[24] & 0x80) << 9);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 193 to 208
	value = ((uint32_t)(input[24] & 0x7f) << 25) |
			((uint32_t)input[25] << 17) |
			((uint32_t)(input[26] & 0x80) << 9);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 209 to 224
	value = ((uint32_t)(input[26] & 0x7f) << 25) |
			((uint32_t)input[27] << 17) |
			((uint32_t)(input[28] & 0x80) << 9);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 225 to 240
	value = ((uint32_t)(input[28] & 0x7f) << 25) |
			((uint32_t)input[29] << 17) |
			((uint32_t)(input[30] & 0x80) << 9);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 241 to 256
	value = ((uint32_t)(input[30] & 0x7f) << 25) |
			((uint32_t)input[31] << 17) |
			((uint32_t)(input[32] & 0x80) << 9);
	output[15] = (double)(value >> 16);
}

static void unpack_16_16bit_unsigned_1off(const uint8_t * input, double * output, void *closure) {
	// Unpack 16 values into output
	// Values are 16-bit unsigned
	// Skip 1 bits, read 256 bits of data.
	// Input must be at least 33 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 1 to 16
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)input[1] << 17) |
			((uint32_t)(input[2] & 0x80) << 9);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 17 to 32
	value = ((uint32_t)(input[2] & 0x7f) << 25) |
			((uint32_t)input[3] << 17) |
			((uint32_t)(input[4] & 0x80) << 9);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 33 to 48
	value = ((uint32_t)(input[4] & 0x7f) << 25) |
			((uint32_t)input[5] << 17) |
			((uint32_t)(input[6] & 0x80) << 9);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 49 to 64
	value = ((uint32_t)(input[6] & 0x7f) << 25) |
			((uint32_t)input[7] << 17) |
			((uint32_t)(input[8] & 0x80) << 9);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 65 to 80
	value = ((uint32_t)(input[8] & 0x7f) << 25) |
			((uint32_t)input[9] << 17) |
			((uint32_t)(input[10] & 0x80) << 9);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 81 to 96
	value = ((uint32_t)(input[10] & 0x7f) << 25) |
			((uint32_t)input[11] << 17) |
			((uint32_t)(input[12] & 0x80) << 9);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 97 to 112
	value = ((uint32_t)(input[12] & 0x7f) << 25) |
			((uint32_t)input[13] << 17) |
			((uint32_t)(input[14] & 0x80) << 9);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 113 to 128
	value = ((uint32_t)(input[14] & 0x7f) << 25) |
			((uint32_t)input[15] << 17) |
			((uint32_t)(input[16] & 0x80) << 9);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 129 to 144
	value = ((uint32_t)(input[16] & 0x7f) << 25) |
			((uint32_t)input[17] << 17) |
			((uint32_t)(input[18] & 0x80) << 9);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 145 to 160
	value = ((uint32_t)(input[18] & 0x7f) << 25) |
			((uint32_t)input[19] << 17) |
			((uint32_t)(input[20] & 0x80) << 9);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 161 to 176
	value = ((uint32_t)(input[20] & 0x7f) << 25) |
			((uint32_t)input[21] << 17) |
			((uint32_t)(input[22] & 0x80) << 9);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 177 to 192
	value = ((uint32_t)(input[22] & 0x7f) << 25) |
			((uint32_t)input[23] << 17) |
			((uint32_t)(input[24] & 0x80) << 9);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 193 to 208
	value = ((uint32_t)(input[24] & 0x7f) << 25) |
			((uint32_t)input[25] << 17) |
			((uint32_t)(input[26] & 0x80) << 9);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 209 to 224
	value = ((uint32_t)(input[26] & 0x7f) << 25) |
			((uint32_t)input[27] << 17) |
			((uint32_t)(input[28] & 0x80) << 9);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 225 to 240
	value = ((uint32_t)(input[28] & 0x7f) << 25) |
			((uint32_t)input[29] << 17) |
			((uint32_t)(input[30] & 0x80) << 9);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 241 to 256
	value = ((uint32_t)(input[30] & 0x7f) << 25) |
			((uint32_t)input[31] << 17) |
			((uint32_t)(input[32] & 0x80) << 9);
	output[15] = (double)(value >> 16);
}

static void unpack_16_16bit_signed_2off(const uint8_t * input, double * output, void *closure) {
	// Unpack 16 values into output
	// Values are 16-bit signed
	// Skip 2 bits, read 256 bits of data.
	// Input must be at least 33 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 2 to 17
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)input[1] << 18) |
			((uint32_t)(input[2] & 0xc0) << 10);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 18 to 33
	value = ((uint32_t)(input[2] & 0x3f) << 26) |
			((uint32_t)input[3] << 18) |
			((uint32_t)(input[4] & 0xc0) << 10);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 34 to 49
	value = ((uint32_t)(input[4] & 0x3f) << 26) |
			((uint32_t)input[5] << 18) |
			((uint32_t)(input[6] & 0xc0) << 10);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 50 to 65
	value = ((uint32_t)(input[6] & 0x3f) << 26) |
			((uint32_t)input[7] << 18) |
			((uint32_t)(input[8] & 0xc0) << 10);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 66 to 81
	value = ((uint32_t)(input[8] & 0x3f) << 26) |
			((uint32_t)input[9] << 18) |
			((uint32_t)(input[10] & 0xc0) << 10);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 82 to 97
	value = ((uint32_t)(input[10] & 0x3f) << 26) |
			((uint32_t)input[11] << 18) |
			((uint32_t)(input[12] & 0xc0) << 10);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 98 to 113
	value = ((uint32_t)(input[12] & 0x3f) << 26) |
			((uint32_t)input[13] << 18) |
			((uint32_t)(input[14] & 0xc0) << 10);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 114 to 129
	value = ((uint32_t)(input[14] & 0x3f) << 26) |
			((uint32_t)input[15] << 18) |
			((uint32_t)(input[16] & 0xc0) << 10);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 130 to 145
	value = ((uint32_t)(input[16] & 0x3f) << 26) |
			((uint32_t)input[17] << 18) |
			((uint32_t)(input[18] & 0xc0) << 10);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 146 to 161
	value = ((uint32_t)(input[18] & 0x3f) << 26) |
			((uint32_t)input[19] << 18) |
			((uint32_t)(input[20] & 0xc0) << 10);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 162 to 177
	value = ((uint32_t)(input[20] & 0x3f) << 26) |
			((uint32_t)input[21] << 18) |
			((uint32_t)(input[22] & 0xc0) << 10);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 178 to 193
	value = ((uint32_t)(input[22] & 0x3f) << 26) |
			((uint32_t)input[23] << 18) |
			((uint32_t)(input[24] & 0xc0) << 10);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 194 to 209
	value = ((uint32_t)(input[24] & 0x3f) << 26) |
			((uint32_t)input[25] << 18) |
			((uint32_t)(input[26] & 0xc0) << 10);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 210 to 225
	value = ((uint32_t)(input[26] & 0x3f) << 26) |
			((uint32_t)input[27] << 18) |
			((uint32_t)(input[28] & 0xc0) << 10);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 226 to 241
	value = ((uint32_t)(input[28] & 0x3f) << 26) |
			((uint32_t)input[29] << 18) |
			((uint32_t)(input[30] & 0xc0) << 10);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 242 to 257
	value = ((uint32_t)(input[30] & 0x3f) << 26) |
			((uint32_t)input[31] << 18) |
			((uint32_t)(input[32] & 0xc0) << 10);
	output[15] = (double)(value >> 16);
}

static void unpack_16_16bit_unsigned_2off(const uint8_t * input, double * output, void *closure) {
	// Unpack 16 values into output
	// Values are 16-bit unsigned
	// Skip 2 bits, read 256 bits of data.
	// Input must be at least 33 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 2 to 17
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)input[1] << 18) |
			((uint32_t)(input[2] & 0xc0) << 10);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 18 to 33
	value = ((uint32_t)(input[2] & 0x3f) << 26) |
			((uint32_t)input[3] << 18) |
			((uint32_t)(input[4] & 0xc0) << 10);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 34 to 49
	value = ((uint32_t)(input[4] & 0x3f) << 26) |
			((uint32_t)input[5] << 18) |
			((uint32_t)(input[6] & 0xc0) << 10);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 50 to 65
	value = ((uint32_t)(input[6] & 0x3f) << 26) |
			((uint32_t)input[7] << 18) |
			((uint32_t)(input[8] & 0xc0) << 10);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 66 to 81
	value = ((uint32_t)(input[8] & 0x3f) << 26) |
			((uint32_t)input[9] << 18) |
			((uint32_t)(input[10] & 0xc0) << 10);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 82 to 97
	value = ((uint32_t)(input[10] & 0x3f) << 26) |
			((uint32_t)input[11] << 18) |
			((uint32_t)(input[12] & 0xc0) << 10);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 98 to 113
	value = ((uint32_t)(input[12] & 0x3f) << 26) |
			((uint32_t)input[13] << 18) |
			((uint32_t)(input[14] & 0xc0) << 10);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 114 to 129
	value = ((uint32_t)(input[14] & 0x3f) << 26) |
			((uint32_t)input[15] << 18) |
			((uint32_t)(input[16] & 0xc0) << 10);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 130 to 145
	value = ((uint32_t)(input[16] & 0x3f) << 26) |
			((uint32_t)input[17] << 18) |
			((uint32_t)(input[18] & 0xc0) << 10);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 146 to 161
	value = ((uint32_t)(input[18] & 0x3f) << 26) |
			((uint32_t)input[19] << 18) |
			((uint32_t)(input[20] & 0xc0) << 10);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 162 to 177
	value = ((uint32_t)(input[20] & 0x3f) << 26) |
			((uint32_t)input[21] << 18) |
			((uint32_t)(input[22] & 0xc0) << 10);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 178 to 193
	value = ((uint32_t)(input[22] & 0x3f) << 26) |
			((uint32_t)input[23] << 18) |
			((uint32_t)(input[24] & 0xc0) << 10);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 194 to 209
	value = ((uint32_t)(input[24] & 0x3f) << 26) |
			((uint32_t)input[25] << 18) |
			((uint32_t)(input[26] & 0xc0) << 10);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 210 to 225
	value = ((uint32_t)(input[26] & 0x3f) << 26) |
			((uint32_t)input[27] << 18) |
			((uint32_t)(input[28] & 0xc0) << 10);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 226 to 241
	value = ((uint32_t)(input[28] & 0x3f) << 26) |
			((uint32_t)input[29] << 18) |
			((uint32_t)(input[30] & 0xc0) << 10);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 242 to 257
	value = ((uint32_t)(input[30] & 0x3f) << 26) |
			((uint32_t)input[31] << 18) |
			((uint32_t)(input[32] & 0xc0) << 10);
	output[15] = (double)(value >> 16);
}

static void unpack_16_16bit_signed_3off(const uint8_t * input, double * output, void *closure) {
	// Unpack 16 values into output
	// Values are 16-bit signed
	// Skip 3 bits, read 256 bits of data.
	// Input must be at least 33 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 3 to 18
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)input[1] << 19) |
			((uint32_t)(input[2] & 0xe0) << 11);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 19 to 34
	value = ((uint32_t)(input[2] & 0x1f) << 27) |
			((uint32_t)input[3] << 19) |
			((uint32_t)(input[4] & 0xe0) << 11);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 35 to 50
	value = ((uint32_t)(input[4] & 0x1f) << 27) |
			((uint32_t)input[5] << 19) |
			((uint32_t)(input[6] & 0xe0) << 11);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 51 to 66
	value = ((uint32_t)(input[6] & 0x1f) << 27) |
			((uint32_t)input[7] << 19) |
			((uint32_t)(input[8] & 0xe0) << 11);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 67 to 82
	value = ((uint32_t)(input[8] & 0x1f) << 27) |
			((uint32_t)input[9] << 19) |
			((uint32_t)(input[10] & 0xe0) << 11);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 83 to 98
	value = ((uint32_t)(input[10] & 0x1f) << 27) |
			((uint32_t)input[11] << 19) |
			((uint32_t)(input[12] & 0xe0) << 11);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 99 to 114
	value = ((uint32_t)(input[12] & 0x1f) << 27) |
			((uint32_t)input[13] << 19) |
			((uint32_t)(input[14] & 0xe0) << 11);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 115 to 130
	value = ((uint32_t)(input[14] & 0x1f) << 27) |
			((uint32_t)input[15] << 19) |
			((uint32_t)(input[16] & 0xe0) << 11);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 131 to 146
	value = ((uint32_t)(input[16] & 0x1f) << 27) |
			((uint32_t)input[17] << 19) |
			((uint32_t)(input[18] & 0xe0) << 11);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 147 to 162
	value = ((uint32_t)(input[18] & 0x1f) << 27) |
			((uint32_t)input[19] << 19) |
			((uint32_t)(input[20] & 0xe0) << 11);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 163 to 178
	value = ((uint32_t)(input[20] & 0x1f) << 27) |
			((uint32_t)input[21] << 19) |
			((uint32_t)(input[22] & 0xe0) << 11);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 179 to 194
	value = ((uint32_t)(input[22] & 0x1f) << 27) |
			((uint32_t)input[23] << 19) |
			((uint32_t)(input[24] & 0xe0) << 11);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 195 to 210
	value = ((uint32_t)(input[24] & 0x1f) << 27) |
			((uint32_t)input[25] << 19) |
			((uint32_t)(input[26] & 0xe0) << 11);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 211 to 226
	value = ((uint32_t)(input[26] & 0x1f) << 27) |
			((uint32_t)input[27] << 19) |
			((uint32_t)(input[28] & 0xe0) << 11);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 227 to 242
	value = ((uint32_t)(input[28] & 0x1f) << 27) |
			((uint32_t)input[29] << 19) |
			((uint32_t)(input[30] & 0xe0) << 11);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 243 to 258
	value = ((uint32_t)(input[30] & 0x1f) << 27) |
			((uint32_t)input[31] << 19) |
			((uint32_t)(input[32] & 0xe0) << 11);
	output[15] = (double)(value >> 16);
}

static void unpack_16_16bit_unsigned_3off(const uint8_t * input, double * output, void *closure) {
	// Unpack 16 values into output
	// Values are 16-bit unsigned
	// Skip 3 bits, read 256 bits of data.
	// Input must be at least 33 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 3 to 18
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)input[1] << 19) |
			((uint32_t)(input[2] & 0xe0) << 11);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 19 to 34
	value = ((uint32_t)(input[2] & 0x1f) << 27) |
			((uint32_t)input[3] << 19) |
			((uint32_t)(input[4] & 0xe0) << 11);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 35 to 50
	value = ((uint32_t)(input[4] & 0x1f) << 27) |
			((uint32_t)input[5] << 19) |
			((uint32_t)(input[6] & 0xe0) << 11);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 51 to 66
	value = ((uint32_t)(input[6] & 0x1f) << 27) |
			((uint32_t)input[7] << 19) |
			((uint32_t)(input[8] & 0xe0) << 11);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 67 to 82
	value = ((uint32_t)(input[8] & 0x1f) << 27) |
			((uint32_t)input[9] << 19) |
			((uint32_t)(input[10] & 0xe0) << 11);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 83 to 98
	value = ((uint32_t)(input[10] & 0x1f) << 27) |
			((uint32_t)input[11] << 19) |
			((uint32_t)(input[12] & 0xe0) << 11);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 99 to 114
	value = ((uint32_t)(input[12] & 0x1f) << 27) |
			((uint32_t)input[13] << 19) |
			((uint32_t)(input[14] & 0xe0) << 11);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 115 to 130
	value = ((uint32_t)(input[14] & 0x1f) << 27) |
			((uint32_t)input[15] << 19) |
			((uint32_t)(input[16] & 0xe0) << 11);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 131 to 146
	value = ((uint32_t)(input[16] & 0x1f) << 27) |
			((uint32_t)input[17] << 19) |
			((uint32_t)(input[18] & 0xe0) << 11);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 147 to 162
	value = ((uint32_t)(input[18] & 0x1f) << 27) |
			((uint32_t)input[19] << 19) |
			((uint32_t)(input[20] & 0xe0) << 11);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 163 to 178
	value = ((uint32_t)(input[20] & 0x1f) << 27) |
			((uint32_t)input[21] << 19) |
			((uint32_t)(input[22] & 0xe0) << 11);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 179 to 194
	value = ((uint32_t)(input[22] & 0x1f) << 27) |
			((uint32_t)input[23] << 19) |
			((uint32_t)(input[24] & 0xe0) << 11);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 195 to 210
	value = ((uint32_t)(input[24] & 0x1f) << 27) |
			((uint32_t)input[25] << 19) |
			((uint32_t)(input[26] & 0xe0) << 11);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 211 to 226
	value = ((uint32_t)(input[26] & 0x1f) << 27) |
			((uint32_t)input[27] << 19) |
			((uint32_t)(input[28] & 0xe0) << 11);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 227 to 242
	value = ((uint32_t)(input[28] & 0x1f) << 27) |
			((uint32_t)input[29] << 19) |
			((uint32_t)(input[30] & 0xe0) << 11);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 243 to 258
	value = ((uint32_t)(input[30] & 0x1f) << 27) |
			((uint32_t)input[31] << 19) |
			((uint32_t)(input[32] & 0xe0) << 11);
	output[15] = (double)(value >> 16);
}

static void unpack_16_16bit_signed_4off(const uint8_t * input, double * output, void *closure) {
	// Unpack 16 values into output
	// Values are 16-bit signed
	// Skip 4 bits, read 256 bits of data.
	// Input must be at least 33 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 4 to 19
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20) |
			((uint32_t)(input[2] & 0xf0) << 12);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 20 to 35
	value = ((uint32_t)(input[2] & 0x0f) << 28) |
			((uint32_t)input[3] << 20) |
			((uint32_t)(input[4] & 0xf0) << 12);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 36 to 51
	value = ((uint32_t)(input[4] & 0x0f) << 28) |
			((uint32_t)input[5] << 20) |
			((uint32_t)(input[6] & 0xf0) << 12);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 52 to 67
	value = ((uint32_t)(input[6] & 0x0f) << 28) |
			((uint32_t)input[7] << 20) |
			((uint32_t)(input[8] & 0xf0) << 12);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 68 to 83
	value = ((uint32_t)(input[8] & 0x0f) << 28) |
			((uint32_t)input[9] << 20) |
			((uint32_t)(input[10] & 0xf0) << 12);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 84 to 99
	value = ((uint32_t)(input[10] & 0x0f) << 28) |
			((uint32_t)input[11] << 20) |
			((uint32_t)(input[12] & 0xf0) << 12);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 100 to 115
	value = ((uint32_t)(input[12] & 0x0f) << 28) |
			((uint32_t)input[13] << 20) |
			((uint32_t)(input[14] & 0xf0) << 12);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 116 to 131
	value = ((uint32_t)(input[14] & 0x0f) << 28) |
			((uint32_t)input[15] << 20) |
			((uint32_t)(input[16] & 0xf0) << 12);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 132 to 147
	value = ((uint32_t)(input[16] & 0x0f) << 28) |
			((uint32_t)input[17] << 20) |
			((uint32_t)(input[18] & 0xf0) << 12);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 148 to 163
	value = ((uint32_t)(input[18] & 0x0f) << 28) |
			((uint32_t)input[19] << 20) |
			((uint32_t)(input[20] & 0xf0) << 12);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 164 to 179
	value = ((uint32_t)(input[20] & 0x0f) << 28) |
			((uint32_t)input[21] << 20) |
			((uint32_t)(input[22] & 0xf0) << 12);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 180 to 195
	value = ((uint32_t)(input[22] & 0x0f) << 28) |
			((uint32_t)input[23] << 20) |
			((uint32_t)(input[24] & 0xf0) << 12);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 196 to 211
	value = ((uint32_t)(input[24] & 0x0f) << 28) |
			((uint32_t)input[25] << 20) |
			((uint32_t)(input[26] & 0xf0) << 12);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 212 to 227
	value = ((uint32_t)(input[26] & 0x0f) << 28) |
			((uint32_t)input[27] << 20) |
			((uint32_t)(input[28] & 0xf0) << 12);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 228 to 243
	value = ((uint32_t)(input[28] & 0x0f) << 28) |
			((uint32_t)input[29] << 20) |
			((uint32_t)(input[30] & 0xf0) << 12);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 244 to 259
	value = ((uint32_t)(input[30] & 0x0f) << 28) |
			((uint32_t)input[31] << 20) |
			((uint32_t)(input[32] & 0xf0) << 12);
	output[15] = (double)(value >> 16);
}

static void unpack_16_16bit_unsigned_4off(const uint8_t * input, double * output, void *closure) {
	// Unpack 16 values into output
	// Values are 16-bit unsigned
	// Skip 4 bits, read 256 bits of data.
	// Input must be at least 33 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 4 to 19
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20) |
			((uint32_t)(input[2] & 0xf0) << 12);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 20 to 35
	value = ((uint32_t)(input[2] & 0x0f) << 28) |
			((uint32_t)input[3] << 20) |
			((uint32_t)(input[4] & 0xf0) << 12);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 36 to 51
	value = ((uint32_t)(input[4] & 0x0f) << 28) |
			((uint32_t)input[5] << 20) |
			((uint32_t)(input[6] & 0xf0) << 12);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 52 to 67
	value = ((uint32_t)(input[6] & 0x0f) << 28) |
			((uint32_t)input[7] << 20) |
			((uint32_t)(input[8] & 0xf0) << 12);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 68 to 83
	value = ((uint32_t)(input[8] & 0x0f) << 28) |
			((uint32_t)input[9] << 20) |
			((uint32_t)(input[10] & 0xf0) << 12);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 84 to 99
	value = ((uint32_t)(input[10] & 0x0f) << 28) |
			((uint32_t)input[11] << 20) |
			((uint32_t)(input[12] & 0xf0) << 12);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 100 to 115
	value = ((uint32_t)(input[12] & 0x0f) << 28) |
			((uint32_t)input[13] << 20) |
			((uint32_t)(input[14] & 0xf0) << 12);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 116 to 131
	value = ((uint32_t)(input[14] & 0x0f) << 28) |
			((uint32_t)input[15] << 20) |
			((uint32_t)(input[16] & 0xf0) << 12);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 132 to 147
	value = ((uint32_t)(input[16] & 0x0f) << 28) |
			((uint32_t)input[17] << 20) |
			((uint32_t)(input[18] & 0xf0) << 12);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 148 to 163
	value = ((uint32_t)(input[18] & 0x0f) << 28) |
			((uint32_t)input[19] << 20) |
			((uint32_t)(input[20] & 0xf0) << 12);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 164 to 179
	value = ((uint32_t)(input[20] & 0x0f) << 28) |
			((uint32_t)input[21] << 20) |
			((uint32_t)(input[22] & 0xf0) << 12);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 180 to 195
	value = ((uint32_t)(input[22] & 0x0f) << 28) |
			((uint32_t)input[23] << 20) |
			((uint32_t)(input[24] & 0xf0) << 12);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 196 to 211
	value = ((uint32_t)(input[24] & 0x0f) << 28) |
			((uint32_t)input[25] << 20) |
			((uint32_t)(input[26] & 0xf0) << 12);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 212 to 227
	value = ((uint32_t)(input[26] & 0x0f) << 28) |
			((uint32_t)input[27] << 20) |
			((uint32_t)(input[28] & 0xf0) << 12);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 228 to 243
	value = ((uint32_t)(input[28] & 0x0f) << 28) |
			((uint32_t)input[29] << 20) |
			((uint32_t)(input[30] & 0xf0) << 12);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 244 to 259
	value = ((uint32_t)(input[30] & 0x0f) << 28) |
			((uint32_t)input[31] << 20) |
			((uint32_t)(input[32] & 0xf0) << 12);
	output[15] = (double)(value >> 16);
}

static void unpack_16_16bit_signed_5off(const uint8_t * input, double * output, void *closure) {
	// Unpack 16 values into output
	// Values are 16-bit signed
	// Skip 5 bits, read 256 bits of data.
	// Input must be at least 33 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 5 to 20
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)(input[2] & 0xf8) << 13);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 21 to 36
	value = ((uint32_t)(input[2] & 0x07) << 29) |
			((uint32_t)input[3] << 21) |
			((uint32_t)(input[4] & 0xf8) << 13);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 37 to 52
	value = ((uint32_t)(input[4] & 0x07) << 29) |
			((uint32_t)input[5] << 21) |
			((uint32_t)(input[6] & 0xf8) << 13);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 53 to 68
	value = ((uint32_t)(input[6] & 0x07) << 29) |
			((uint32_t)input[7] << 21) |
			((uint32_t)(input[8] & 0xf8) << 13);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 69 to 84
	value = ((uint32_t)(input[8] & 0x07) << 29) |
			((uint32_t)input[9] << 21) |
			((uint32_t)(input[10] & 0xf8) << 13);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 85 to 100
	value = ((uint32_t)(input[10] & 0x07) << 29) |
			((uint32_t)input[11] << 21) |
			((uint32_t)(input[12] & 0xf8) << 13);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 101 to 116
	value = ((uint32_t)(input[12] & 0x07) << 29) |
			((uint32_t)input[13] << 21) |
			((uint32_t)(input[14] & 0xf8) << 13);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 117 to 132
	value = ((uint32_t)(input[14] & 0x07) << 29) |
			((uint32_t)input[15] << 21) |
			((uint32_t)(input[16] & 0xf8) << 13);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 133 to 148
	value = ((uint32_t)(input[16] & 0x07) << 29) |
			((uint32_t)input[17] << 21) |
			((uint32_t)(input[18] & 0xf8) << 13);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 149 to 164
	value = ((uint32_t)(input[18] & 0x07) << 29) |
			((uint32_t)input[19] << 21) |
			((uint32_t)(input[20] & 0xf8) << 13);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 165 to 180
	value = ((uint32_t)(input[20] & 0x07) << 29) |
			((uint32_t)input[21] << 21) |
			((uint32_t)(input[22] & 0xf8) << 13);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 181 to 196
	value = ((uint32_t)(input[22] & 0x07) << 29) |
			((uint32_t)input[23] << 21) |
			((uint32_t)(input[24] & 0xf8) << 13);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 197 to 212
	value = ((uint32_t)(input[24] & 0x07) << 29) |
			((uint32_t)input[25] << 21) |
			((uint32_t)(input[26] & 0xf8) << 13);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 213 to 228
	value = ((uint32_t)(input[26] & 0x07) << 29) |
			((uint32_t)input[27] << 21) |
			((uint32_t)(input[28] & 0xf8) << 13);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 229 to 244
	value = ((uint32_t)(input[28] & 0x07) << 29) |
			((uint32_t)input[29] << 21) |
			((uint32_t)(input[30] & 0xf8) << 13);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 245 to 260
	value = ((uint32_t)(input[30] & 0x07) << 29) |
			((uint32_t)input[31] << 21) |
			((uint32_t)(input[32] & 0xf8) << 13);
	output[15] = (double)(value >> 16);
}

static void unpack_16_16bit_unsigned_5off(const uint8_t * input, double * output, void *closure) {
	// Unpack 16 values into output
	// Values are 16-bit unsigned
	// Skip 5 bits, read 256 bits of data.
	// Input must be at least 33 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 5 to 20
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)(input[2] & 0xf8) << 13);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 21 to 36
	value = ((uint32_t)(input[2] & 0x07) << 29) |
			((uint32_t)input[3] << 21) |
			((uint32_t)(input[4] & 0xf8) << 13);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 37 to 52
	value = ((uint32_t)(input[4] & 0x07) << 29) |
			((uint32_t)input[5] << 21) |
			((uint32_t)(input[6] & 0xf8) << 13);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 53 to 68
	value = ((uint32_t)(input[6] & 0x07) << 29) |
			((uint32_t)input[7] << 21) |
			((uint32_t)(input[8] & 0xf8) << 13);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 69 to 84
	value = ((uint32_t)(input[8] & 0x07) << 29) |
			((uint32_t)input[9] << 21) |
			((uint32_t)(input[10] & 0xf8) << 13);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 85 to 100
	value = ((uint32_t)(input[10] & 0x07) << 29) |
			((uint32_t)input[11] << 21) |
			((uint32_t)(input[12] & 0xf8) << 13);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 101 to 116
	value = ((uint32_t)(input[12] & 0x07) << 29) |
			((uint32_t)input[13] << 21) |
			((uint32_t)(input[14] & 0xf8) << 13);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 117 to 132
	value = ((uint32_t)(input[14] & 0x07) << 29) |
			((uint32_t)input[15] << 21) |
			((uint32_t)(input[16] & 0xf8) << 13);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 133 to 148
	value = ((uint32_t)(input[16] & 0x07) << 29) |
			((uint32_t)input[17] << 21) |
			((uint32_t)(input[18] & 0xf8) << 13);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 149 to 164
	value = ((uint32_t)(input[18] & 0x07) << 29) |
			((uint32_t)input[19] << 21) |
			((uint32_t)(input[20] & 0xf8) << 13);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 165 to 180
	value = ((uint32_t)(input[20] & 0x07) << 29) |
			((uint32_t)input[21] << 21) |
			((uint32_t)(input[22] & 0xf8) << 13);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 181 to 196
	value = ((uint32_t)(input[22] & 0x07) << 29) |
			((uint32_t)input[23] << 21) |
			((uint32_t)(input[24] & 0xf8) << 13);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 197 to 212
	value = ((uint32_t)(input[24] & 0x07) << 29) |
			((uint32_t)input[25] << 21) |
			((uint32_t)(input[26] & 0xf8) << 13);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 213 to 228
	value = ((uint32_t)(input[26] & 0x07) << 29) |
			((uint32_t)input[27] << 21) |
			((uint32_t)(input[28] & 0xf8) << 13);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 229 to 244
	value = ((uint32_t)(input[28] & 0x07) << 29) |
			((uint32_t)input[29] << 21) |
			((uint32_t)(input[30] & 0xf8) << 13);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 245 to 260
	value = ((uint32_t)(input[30] & 0x07) << 29) |
			((uint32_t)input[31] << 21) |
			((uint32_t)(input[32] & 0xf8) << 13);
	output[15] = (double)(value >> 16);
}

static void unpack_16_16bit_signed_6off(const uint8_t * input, double * output, void *closure) {
	// Unpack 16 values into output
	// Values are 16-bit signed
	// Skip 6 bits, read 256 bits of data.
	// Input must be at least 33 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 6 to 21
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)(input[2] & 0xfc) << 14);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 22 to 37
	value = ((uint32_t)(input[2] & 0x03) << 30) |
			((uint32_t)input[3] << 22) |
			((uint32_t)(input[4] & 0xfc) << 14);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 38 to 53
	value = ((uint32_t)(input[4] & 0x03) << 30) |
			((uint32_t)input[5] << 22) |
			((uint32_t)(input[6] & 0xfc) << 14);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 54 to 69
	value = ((uint32_t)(input[6] & 0x03) << 30) |
			((uint32_t)input[7] << 22) |
			((uint32_t)(input[8] & 0xfc) << 14);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 70 to 85
	value = ((uint32_t)(input[8] & 0x03) << 30) |
			((uint32_t)input[9] << 22) |
			((uint32_t)(input[10] & 0xfc) << 14);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 86 to 101
	value = ((uint32_t)(input[10] & 0x03) << 30) |
			((uint32_t)input[11] << 22) |
			((uint32_t)(input[12] & 0xfc) << 14);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 102 to 117
	value = ((uint32_t)(input[12] & 0x03) << 30) |
			((uint32_t)input[13] << 22) |
			((uint32_t)(input[14] & 0xfc) << 14);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 118 to 133
	value = ((uint32_t)(input[14] & 0x03) << 30) |
			((uint32_t)input[15] << 22) |
			((uint32_t)(input[16] & 0xfc) << 14);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 134 to 149
	value = ((uint32_t)(input[16] & 0x03) << 30) |
			((uint32_t)input[17] << 22) |
			((uint32_t)(input[18] & 0xfc) << 14);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 150 to 165
	value = ((uint32_t)(input[18] & 0x03) << 30) |
			((uint32_t)input[19] << 22) |
			((uint32_t)(input[20] & 0xfc) << 14);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 166 to 181
	value = ((uint32_t)(input[20] & 0x03) << 30) |
			((uint32_t)input[21] << 22) |
			((uint32_t)(input[22] & 0xfc) << 14);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 182 to 197
	value = ((uint32_t)(input[22] & 0x03) << 30) |
			((uint32_t)input[23] << 22) |
			((uint32_t)(input[24] & 0xfc) << 14);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 198 to 213
	value = ((uint32_t)(input[24] & 0x03) << 30) |
			((uint32_t)input[25] << 22) |
			((uint32_t)(input[26] & 0xfc) << 14);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 214 to 229
	value = ((uint32_t)(input[26] & 0x03) << 30) |
			((uint32_t)input[27] << 22) |
			((uint32_t)(input[28] & 0xfc) << 14);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 230 to 245
	value = ((uint32_t)(input[28] & 0x03) << 30) |
			((uint32_t)input[29] << 22) |
			((uint32_t)(input[30] & 0xfc) << 14);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 246 to 261
	value = ((uint32_t)(input[30] & 0x03) << 30) |
			((uint32_t)input[31] << 22) |
			((uint32_t)(input[32] & 0xfc) << 14);
	output[15] = (double)(value >> 16);
}

static void unpack_16_16bit_unsigned_6off(const uint8_t * input, double * output, void *closure) {
	// Unpack 16 values into output
	// Values are 16-bit unsigned
	// Skip 6 bits, read 256 bits of data.
	// Input must be at least 33 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 6 to 21
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)(input[2] & 0xfc) << 14);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 22 to 37
	value = ((uint32_t)(input[2] & 0x03) << 30) |
			((uint32_t)input[3] << 22) |
			((uint32_t)(input[4] & 0xfc) << 14);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 38 to 53
	value = ((uint32_t)(input[4] & 0x03) << 30) |
			((uint32_t)input[5] << 22) |
			((uint32_t)(input[6] & 0xfc) << 14);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 54 to 69
	value = ((uint32_t)(input[6] & 0x03) << 30) |
			((uint32_t)input[7] << 22) |
			((uint32_t)(input[8] & 0xfc) << 14);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 70 to 85
	value = ((uint32_t)(input[8] & 0x03) << 30) |
			((uint32_t)input[9] << 22) |
			((uint32_t)(input[10] & 0xfc) << 14);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 86 to 101
	value = ((uint32_t)(input[10] & 0x03) << 30) |
			((uint32_t)input[11] << 22) |
			((uint32_t)(input[12] & 0xfc) << 14);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 102 to 117
	value = ((uint32_t)(input[12] & 0x03) << 30) |
			((uint32_t)input[13] << 22) |
			((uint32_t)(input[14] & 0xfc) << 14);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 118 to 133
	value = ((uint32_t)(input[14] & 0x03) << 30) |
			((uint32_t)input[15] << 22) |
			((uint32_t)(input[16] & 0xfc) << 14);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 134 to 149
	value = ((uint32_t)(input[16] & 0x03) << 30) |
			((uint32_t)input[17] << 22) |
			((uint32_t)(input[18] & 0xfc) << 14);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 150 to 165
	value = ((uint32_t)(input[18] & 0x03) << 30) |
			((uint32_t)input[19] << 22) |
			((uint32_t)(input[20] & 0xfc) << 14);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 166 to 181
	value = ((uint32_t)(input[20] & 0x03) << 30) |
			((uint32_t)input[21] << 22) |
			((uint32_t)(input[22] & 0xfc) << 14);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 182 to 197
	value = ((uint32_t)(input[22] & 0x03) << 30) |
			((uint32_t)input[23] << 22) |
			((uint32_t)(input[24] & 0xfc) << 14);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 198 to 213
	value = ((uint32_t)(input[24] & 0x03) << 30) |
			((uint32_t)input[25] << 22) |
			((uint32_t)(input[26] & 0xfc) << 14);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 214 to 229
	value = ((uint32_t)(input[26] & 0x03) << 30) |
			((uint32_t)input[27] << 22) |
			((uint32_t)(input[28] & 0xfc) << 14);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 230 to 245
	value = ((uint32_t)(input[28] & 0x03) << 30) |
			((uint32_t)input[29] << 22) |
			((uint32_t)(input[30] & 0xfc) << 14);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 246 to 261
	value = ((uint32_t)(input[30] & 0x03) << 30) |
			((uint32_t)input[31] << 22) |
			((uint32_t)(input[32] & 0xfc) << 14);
	output[15] = (double)(value >> 16);
}

static void unpack_16_16bit_signed_7off(const uint8_t * input, double * output, void *closure) {
	// Unpack 16 values into output
	// Values are 16-bit signed
	// Skip 7 bits, read 256 bits of data.
	// Input must be at least 33 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 7 to 22
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)(input[2] & 0xfe) << 15);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 23 to 38
	value = ((uint32_t)(input[2] & 0x01) << 31) |
			((uint32_t)input[3] << 23) |
			((uint32_t)(input[4] & 0xfe) << 15);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 39 to 54
	value = ((uint32_t)(input[4] & 0x01) << 31) |
			((uint32_t)input[5] << 23) |
			((uint32_t)(input[6] & 0xfe) << 15);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 55 to 70
	value = ((uint32_t)(input[6] & 0x01) << 31) |
			((uint32_t)input[7] << 23) |
			((uint32_t)(input[8] & 0xfe) << 15);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 71 to 86
	value = ((uint32_t)(input[8] & 0x01) << 31) |
			((uint32_t)input[9] << 23) |
			((uint32_t)(input[10] & 0xfe) << 15);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 87 to 102
	value = ((uint32_t)(input[10] & 0x01) << 31) |
			((uint32_t)input[11] << 23) |
			((uint32_t)(input[12] & 0xfe) << 15);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 103 to 118
	value = ((uint32_t)(input[12] & 0x01) << 31) |
			((uint32_t)input[13] << 23) |
			((uint32_t)(input[14] & 0xfe) << 15);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 119 to 134
	value = ((uint32_t)(input[14] & 0x01) << 31) |
			((uint32_t)input[15] << 23) |
			((uint32_t)(input[16] & 0xfe) << 15);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 135 to 150
	value = ((uint32_t)(input[16] & 0x01) << 31) |
			((uint32_t)input[17] << 23) |
			((uint32_t)(input[18] & 0xfe) << 15);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 151 to 166
	value = ((uint32_t)(input[18] & 0x01) << 31) |
			((uint32_t)input[19] << 23) |
			((uint32_t)(input[20] & 0xfe) << 15);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 167 to 182
	value = ((uint32_t)(input[20] & 0x01) << 31) |
			((uint32_t)input[21] << 23) |
			((uint32_t)(input[22] & 0xfe) << 15);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 183 to 198
	value = ((uint32_t)(input[22] & 0x01) << 31) |
			((uint32_t)input[23] << 23) |
			((uint32_t)(input[24] & 0xfe) << 15);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 199 to 214
	value = ((uint32_t)(input[24] & 0x01) << 31) |
			((uint32_t)input[25] << 23) |
			((uint32_t)(input[26] & 0xfe) << 15);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 215 to 230
	value = ((uint32_t)(input[26] & 0x01) << 31) |
			((uint32_t)input[27] << 23) |
			((uint32_t)(input[28] & 0xfe) << 15);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 231 to 246
	value = ((uint32_t)(input[28] & 0x01) << 31) |
			((uint32_t)input[29] << 23) |
			((uint32_t)(input[30] & 0xfe) << 15);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 247 to 262
	value = ((uint32_t)(input[30] & 0x01) << 31) |
			((uint32_t)input[31] << 23) |
			((uint32_t)(input[32] & 0xfe) << 15);
	output[15] = (double)(value >> 16);
}

static void unpack_16_16bit_unsigned_7off(const uint8_t * input, double * output, void *closure) {
	// Unpack 16 values into output
	// Values are 16-bit unsigned
	// Skip 7 bits, read 256 bits of data.
	// Input must be at least 33 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 7 to 22
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)(input[2] & 0xfe) << 15);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 23 to 38
	value = ((uint32_t)(input[2] & 0x01) << 31) |
			((uint32_t)input[3] << 23) |
			((uint32_t)(input[4] & 0xfe) << 15);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 39 to 54
	value = ((uint32_t)(input[4] & 0x01) << 31) |
			((uint32_t)input[5] << 23) |
			((uint32_t)(input[6] & 0xfe) << 15);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 55 to 70
	value = ((uint32_t)(input[6] & 0x01) << 31) |
			((uint32_t)input[7] << 23) |
			((uint32_t)(input[8] & 0xfe) << 15);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 71 to 86
	value = ((uint32_t)(input[8] & 0x01) << 31) |
			((uint32_t)input[9] << 23) |
			((uint32_t)(input[10] & 0xfe) << 15);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 87 to 102
	value = ((uint32_t)(input[10] & 0x01) << 31) |
			((uint32_t)input[11] << 23) |
			((uint32_t)(input[12] & 0xfe) << 15);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 103 to 118
	value = ((uint32_t)(input[12] & 0x01) << 31) |
			((uint32_t)input[13] << 23) |
			((uint32_t)(input[14] & 0xfe) << 15);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 119 to 134
	value = ((uint32_t)(input[14] & 0x01) << 31) |
			((uint32_t)input[15] << 23) |
			((uint32_t)(input[16] & 0xfe) << 15);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 135 to 150
	value = ((uint32_t)(input[16] & 0x01) << 31) |
			((uint32_t)input[17] << 23) |
			((uint32_t)(input[18] & 0xfe) << 15);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 151 to 166
	value = ((uint32_t)(input[18] & 0x01) << 31) |
			((uint32_t)input[19] << 23) |
			((uint32_t)(input[20] & 0xfe) << 15);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 167 to 182
	value = ((uint32_t)(input[20] & 0x01) << 31) |
			((uint32_t)input[21] << 23) |
			((uint32_t)(input[22] & 0xfe) << 15);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 183 to 198
	value = ((uint32_t)(input[22] & 0x01) << 31) |
			((uint32_t)input[23] << 23) |
			((uint32_t)(input[24] & 0xfe) << 15);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 199 to 214
	value = ((uint32_t)(input[24] & 0x01) << 31) |
			((uint32_t)input[25] << 23) |
			((uint32_t)(input[26] & 0xfe) << 15);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 215 to 230
	value = ((uint32_t)(input[26] & 0x01) << 31) |
			((uint32_t)input[27] << 23) |
			((uint32_t)(input[28] & 0xfe) << 15);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 231 to 246
	value = ((uint32_t)(input[28] & 0x01) << 31) |
			((uint32_t)input[29] << 23) |
			((uint32_t)(input[30] & 0xfe) << 15);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 247 to 262
	value = ((uint32_t)(input[30] & 0x01) << 31) |
			((uint32_t)input[31] << 23) |
			((uint32_t)(input[32] & 0xfe) << 15);
	output[15] = (double)(value >> 16);
}

static void unpack_17_16bit_signed_0off(const uint8_t * input, double * output, void *closure) {
	// Unpack 17 values into output
	// Values are 16-bit signed
	// Skip 0 bits, read 272 bits of data.
	// Input must be at least 34 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 0 to 15
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)input[1] << 16);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 16 to 31
	value = ((uint32_t)input[2] << 24) |
			((uint32_t)input[3] << 16);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 32 to 47
	value = ((uint32_t)input[4] << 24) |
			((uint32_t)input[5] << 16);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 48 to 63
	value = ((uint32_t)input[6] << 24) |
			((uint32_t)input[7] << 16);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 64 to 79
	value = ((uint32_t)input[8] << 24) |
			((uint32_t)input[9] << 16);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 80 to 95
	value = ((uint32_t)input[10] << 24) |
			((uint32_t)input[11] << 16);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 96 to 111
	value = ((uint32_t)input[12] << 24) |
			((uint32_t)input[13] << 16);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 112 to 127
	value = ((uint32_t)input[14] << 24) |
			((uint32_t)input[15] << 16);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 128 to 143
	value = ((uint32_t)input[16] << 24) |
			((uint32_t)input[17] << 16);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 144 to 159
	value = ((uint32_t)input[18] << 24) |
			((uint32_t)input[19] << 16);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 160 to 175
	value = ((uint32_t)input[20] << 24) |
			((uint32_t)input[21] << 16);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 176 to 191
	value = ((uint32_t)input[22] << 24) |
			((uint32_t)input[23] << 16);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 192 to 207
	value = ((uint32_t)input[24] << 24) |
			((uint32_t)input[25] << 16);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 208 to 223
	value = ((uint32_t)input[26] << 24) |
			((uint32_t)input[27] << 16);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 224 to 239
	value = ((uint32_t)input[28] << 24) |
			((uint32_t)input[29] << 16);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 240 to 255
	value = ((uint32_t)input[30] << 24) |
			((uint32_t)input[31] << 16);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 256 to 271
	value = ((uint32_t)input[32] << 24) |
			((uint32_t)input[33] << 16);
	output[16] = (double)(value >> 16);
}

static void unpack_17_16bit_unsigned_0off(const uint8_t * input, double * output, void *closure) {
	// Unpack 17 values into output
	// Values are 16-bit unsigned
	// Skip 0 bits, read 272 bits of data.
	// Input must be at least 34 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 0 to 15
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)input[1] << 16);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 16 to 31
	value = ((uint32_t)input[2] << 24) |
			((uint32_t)input[3] << 16);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 32 to 47
	value = ((uint32_t)input[4] << 24) |
			((uint32_t)input[5] << 16);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 48 to 63
	value = ((uint32_t)input[6] << 24) |
			((uint32_t)input[7] << 16);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 64 to 79
	value = ((uint32_t)input[8] << 24) |
			((uint32_t)input[9] << 16);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 80 to 95
	value = ((uint32_t)input[10] << 24) |
			((uint32_t)input[11] << 16);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 96 to 111
	value = ((uint32_t)input[12] << 24) |
			((uint32_t)input[13] << 16);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 112 to 127
	value = ((uint32_t)input[14] << 24) |
			((uint32_t)input[15] << 16);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 128 to 143
	value = ((uint32_t)input[16] << 24) |
			((uint32_t)input[17] << 16);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 144 to 159
	value = ((uint32_t)input[18] << 24) |
			((uint32_t)input[19] << 16);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 160 to 175
	value = ((uint32_t)input[20] << 24) |
			((uint32_t)input[21] << 16);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 176 to 191
	value = ((uint32_t)input[22] << 24) |
			((uint32_t)input[23] << 16);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 192 to 207
	value = ((uint32_t)input[24] << 24) |
			((uint32_t)input[25] << 16);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 208 to 223
	value = ((uint32_t)input[26] << 24) |
			((uint32_t)input[27] << 16);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 224 to 239
	value = ((uint32_t)input[28] << 24) |
			((uint32_t)input[29] << 16);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 240 to 255
	value = ((uint32_t)input[30] << 24) |
			((uint32_t)input[31] << 16);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 256 to 271
	value = ((uint32_t)input[32] << 24) |
			((uint32_t)input[33] << 16);
	output[16] = (double)(value >> 16);
}

static void unpack_17_16bit_signed_1off(const uint8_t * input, double * output, void *closure) {
	// Unpack 17 values into output
	// Values are 16-bit signed
	// Skip 1 bits, read 272 bits of data.
	// Input must be at least 35 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 1 to 16
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)input[1] << 17) |
			((uint32_t)(input[2] & 0x80) << 9);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 17 to 32
	value = ((uint32_t)(input[2] & 0x7f) << 25) |
			((uint32_t)input[3] << 17) |
			((uint32_t)(input[4] & 0x80) << 9);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 33 to 48
	value = ((uint32_t)(input[4] & 0x7f) << 25) |
			((uint32_t)input[5] << 17) |
			((uint32_t)(input[6] & 0x80) << 9);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 49 to 64
	value = ((uint32_t)(input[6] & 0x7f) << 25) |
			((uint32_t)input[7] << 17) |
			((uint32_t)(input[8] & 0x80) << 9);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 65 to 80
	value = ((uint32_t)(input[8] & 0x7f) << 25) |
			((uint32_t)input[9] << 17) |
			((uint32_t)(input[10] & 0x80) << 9);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 81 to 96
	value = ((uint32_t)(input[10] & 0x7f) << 25) |
			((uint32_t)input[11] << 17) |
			((uint32_t)(input[12] & 0x80) << 9);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 97 to 112
	value = ((uint32_t)(input[12] & 0x7f) << 25) |
			((uint32_t)input[13] << 17) |
			((uint32_t)(input[14] & 0x80) << 9);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 113 to 128
	value = ((uint32_t)(input[14] & 0x7f) << 25) |
			((uint32_t)input[15] << 17) |
			((uint32_t)(input[16] & 0x80) << 9);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 129 to 144
	value = ((uint32_t)(input[16] & 0x7f) << 25) |
			((uint32_t)input[17] << 17) |
			((uint32_t)(input[18] & 0x80) << 9);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 145 to 160
	value = ((uint32_t)(input[18] & 0x7f) << 25) |
			((uint32_t)input[19] << 17) |
			((uint32_t)(input[20] & 0x80) << 9);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 161 to 176
	value = ((uint32_t)(input[20] & 0x7f) << 25) |
			((uint32_t)input[21] << 17) |
			((uint32_t)(input[22] & 0x80) << 9);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 177 to 192
	value = ((uint32_t)(input[22] & 0x7f) << 25) |
			((uint32_t)input[23] << 17) |
			((uint32_t)(input[24] & 0x80) << 9);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 193 to 208
	value = ((uint32_t)(input[24] & 0x7f) << 25) |
			((uint32_t)input[25] << 17) |
			((uint32_t)(input[26] & 0x80) << 9);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 209 to 224
	value = ((uint32_t)(input[26] & 0x7f) << 25) |
			((uint32_t)input[27] << 17) |
			((uint32_t)(input[28] & 0x80) << 9);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 225 to 240
	value = ((uint32_t)(input[28] & 0x7f) << 25) |
			((uint32_t)input[29] << 17) |
			((uint32_t)(input[30] & 0x80) << 9);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 241 to 256
	value = ((uint32_t)(input[30] & 0x7f) << 25) |
			((uint32_t)input[31] << 17) |
			((uint32_t)(input[32] & 0x80) << 9);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 257 to 272
	value = ((uint32_t)(input[32] & 0x7f) << 25) |
			((uint32_t)input[33] << 17) |
			((uint32_t)(input[34] & 0x80) << 9);
	output[16] = (double)(value >> 16);
}

static void unpack_17_16bit_unsigned_1off(const uint8_t * input, double * output, void *closure) {
	// Unpack 17 values into output
	// Values are 16-bit unsigned
	// Skip 1 bits, read 272 bits of data.
	// Input must be at least 35 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 1 to 16
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)input[1] << 17) |
			((uint32_t)(input[2] & 0x80) << 9);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 17 to 32
	value = ((uint32_t)(input[2] & 0x7f) << 25) |
			((uint32_t)input[3] << 17) |
			((uint32_t)(input[4] & 0x80) << 9);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 33 to 48
	value = ((uint32_t)(input[4] & 0x7f) << 25) |
			((uint32_t)input[5] << 17) |
			((uint32_t)(input[6] & 0x80) << 9);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 49 to 64
	value = ((uint32_t)(input[6] & 0x7f) << 25) |
			((uint32_t)input[7] << 17) |
			((uint32_t)(input[8] & 0x80) << 9);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 65 to 80
	value = ((uint32_t)(input[8] & 0x7f) << 25) |
			((uint32_t)input[9] << 17) |
			((uint32_t)(input[10] & 0x80) << 9);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 81 to 96
	value = ((uint32_t)(input[10] & 0x7f) << 25) |
			((uint32_t)input[11] << 17) |
			((uint32_t)(input[12] & 0x80) << 9);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 97 to 112
	value = ((uint32_t)(input[12] & 0x7f) << 25) |
			((uint32_t)input[13] << 17) |
			((uint32_t)(input[14] & 0x80) << 9);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 113 to 128
	value = ((uint32_t)(input[14] & 0x7f) << 25) |
			((uint32_t)input[15] << 17) |
			((uint32_t)(input[16] & 0x80) << 9);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 129 to 144
	value = ((uint32_t)(input[16] & 0x7f) << 25) |
			((uint32_t)input[17] << 17) |
			((uint32_t)(input[18] & 0x80) << 9);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 145 to 160
	value = ((uint32_t)(input[18] & 0x7f) << 25) |
			((uint32_t)input[19] << 17) |
			((uint32_t)(input[20] & 0x80) << 9);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 161 to 176
	value = ((uint32_t)(input[20] & 0x7f) << 25) |
			((uint32_t)input[21] << 17) |
			((uint32_t)(input[22] & 0x80) << 9);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 177 to 192
	value = ((uint32_t)(input[22] & 0x7f) << 25) |
			((uint32_t)input[23] << 17) |
			((uint32_t)(input[24] & 0x80) << 9);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 193 to 208
	value = ((uint32_t)(input[24] & 0x7f) << 25) |
			((uint32_t)input[25] << 17) |
			((uint32_t)(input[26] & 0x80) << 9);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 209 to 224
	value = ((uint32_t)(input[26] & 0x7f) << 25) |
			((uint32_t)input[27] << 17) |
			((uint32_t)(input[28] & 0x80) << 9);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 225 to 240
	value = ((uint32_t)(input[28] & 0x7f) << 25) |
			((uint32_t)input[29] << 17) |
			((uint32_t)(input[30] & 0x80) << 9);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 241 to 256
	value = ((uint32_t)(input[30] & 0x7f) << 25) |
			((uint32_t)input[31] << 17) |
			((uint32_t)(input[32] & 0x80) << 9);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 257 to 272
	value = ((uint32_t)(input[32] & 0x7f) << 25) |
			((uint32_t)input[33] << 17) |
			((uint32_t)(input[34] & 0x80) << 9);
	output[16] = (double)(value >> 16);
}

static void unpack_17_16bit_signed_2off(const uint8_t * input, double * output, void *closure) {
	// Unpack 17 values into output
	// Values are 16-bit signed
	// Skip 2 bits, read 272 bits of data.
	// Input must be at least 35 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 2 to 17
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)input[1] << 18) |
			((uint32_t)(input[2] & 0xc0) << 10);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 18 to 33
	value = ((uint32_t)(input[2] & 0x3f) << 26) |
			((uint32_t)input[3] << 18) |
			((uint32_t)(input[4] & 0xc0) << 10);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 34 to 49
	value = ((uint32_t)(input[4] & 0x3f) << 26) |
			((uint32_t)input[5] << 18) |
			((uint32_t)(input[6] & 0xc0) << 10);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 50 to 65
	value = ((uint32_t)(input[6] & 0x3f) << 26) |
			((uint32_t)input[7] << 18) |
			((uint32_t)(input[8] & 0xc0) << 10);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 66 to 81
	value = ((uint32_t)(input[8] & 0x3f) << 26) |
			((uint32_t)input[9] << 18) |
			((uint32_t)(input[10] & 0xc0) << 10);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 82 to 97
	value = ((uint32_t)(input[10] & 0x3f) << 26) |
			((uint32_t)input[11] << 18) |
			((uint32_t)(input[12] & 0xc0) << 10);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 98 to 113
	value = ((uint32_t)(input[12] & 0x3f) << 26) |
			((uint32_t)input[13] << 18) |
			((uint32_t)(input[14] & 0xc0) << 10);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 114 to 129
	value = ((uint32_t)(input[14] & 0x3f) << 26) |
			((uint32_t)input[15] << 18) |
			((uint32_t)(input[16] & 0xc0) << 10);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 130 to 145
	value = ((uint32_t)(input[16] & 0x3f) << 26) |
			((uint32_t)input[17] << 18) |
			((uint32_t)(input[18] & 0xc0) << 10);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 146 to 161
	value = ((uint32_t)(input[18] & 0x3f) << 26) |
			((uint32_t)input[19] << 18) |
			((uint32_t)(input[20] & 0xc0) << 10);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 162 to 177
	value = ((uint32_t)(input[20] & 0x3f) << 26) |
			((uint32_t)input[21] << 18) |
			((uint32_t)(input[22] & 0xc0) << 10);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 178 to 193
	value = ((uint32_t)(input[22] & 0x3f) << 26) |
			((uint32_t)input[23] << 18) |
			((uint32_t)(input[24] & 0xc0) << 10);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 194 to 209
	value = ((uint32_t)(input[24] & 0x3f) << 26) |
			((uint32_t)input[25] << 18) |
			((uint32_t)(input[26] & 0xc0) << 10);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 210 to 225
	value = ((uint32_t)(input[26] & 0x3f) << 26) |
			((uint32_t)input[27] << 18) |
			((uint32_t)(input[28] & 0xc0) << 10);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 226 to 241
	value = ((uint32_t)(input[28] & 0x3f) << 26) |
			((uint32_t)input[29] << 18) |
			((uint32_t)(input[30] & 0xc0) << 10);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 242 to 257
	value = ((uint32_t)(input[30] & 0x3f) << 26) |
			((uint32_t)input[31] << 18) |
			((uint32_t)(input[32] & 0xc0) << 10);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 258 to 273
	value = ((uint32_t)(input[32] & 0x3f) << 26) |
			((uint32_t)input[33] << 18) |
			((uint32_t)(input[34] & 0xc0) << 10);
	output[16] = (double)(value >> 16);
}

static void unpack_17_16bit_unsigned_2off(const uint8_t * input, double * output, void *closure) {
	// Unpack 17 values into output
	// Values are 16-bit unsigned
	// Skip 2 bits, read 272 bits of data.
	// Input must be at least 35 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 2 to 17
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)input[1] << 18) |
			((uint32_t)(input[2] & 0xc0) << 10);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 18 to 33
	value = ((uint32_t)(input[2] & 0x3f) << 26) |
			((uint32_t)input[3] << 18) |
			((uint32_t)(input[4] & 0xc0) << 10);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 34 to 49
	value = ((uint32_t)(input[4] & 0x3f) << 26) |
			((uint32_t)input[5] << 18) |
			((uint32_t)(input[6] & 0xc0) << 10);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 50 to 65
	value = ((uint32_t)(input[6] & 0x3f) << 26) |
			((uint32_t)input[7] << 18) |
			((uint32_t)(input[8] & 0xc0) << 10);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 66 to 81
	value = ((uint32_t)(input[8] & 0x3f) << 26) |
			((uint32_t)input[9] << 18) |
			((uint32_t)(input[10] & 0xc0) << 10);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 82 to 97
	value = ((uint32_t)(input[10] & 0x3f) << 26) |
			((uint32_t)input[11] << 18) |
			((uint32_t)(input[12] & 0xc0) << 10);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 98 to 113
	value = ((uint32_t)(input[12] & 0x3f) << 26) |
			((uint32_t)input[13] << 18) |
			((uint32_t)(input[14] & 0xc0) << 10);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 114 to 129
	value = ((uint32_t)(input[14] & 0x3f) << 26) |
			((uint32_t)input[15] << 18) |
			((uint32_t)(input[16] & 0xc0) << 10);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 130 to 145
	value = ((uint32_t)(input[16] & 0x3f) << 26) |
			((uint32_t)input[17] << 18) |
			((uint32_t)(input[18] & 0xc0) << 10);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 146 to 161
	value = ((uint32_t)(input[18] & 0x3f) << 26) |
			((uint32_t)input[19] << 18) |
			((uint32_t)(input[20] & 0xc0) << 10);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 162 to 177
	value = ((uint32_t)(input[20] & 0x3f) << 26) |
			((uint32_t)input[21] << 18) |
			((uint32_t)(input[22] & 0xc0) << 10);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 178 to 193
	value = ((uint32_t)(input[22] & 0x3f) << 26) |
			((uint32_t)input[23] << 18) |
			((uint32_t)(input[24] & 0xc0) << 10);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 194 to 209
	value = ((uint32_t)(input[24] & 0x3f) << 26) |
			((uint32_t)input[25] << 18) |
			((uint32_t)(input[26] & 0xc0) << 10);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 210 to 225
	value = ((uint32_t)(input[26] & 0x3f) << 26) |
			((uint32_t)input[27] << 18) |
			((uint32_t)(input[28] & 0xc0) << 10);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 226 to 241
	value = ((uint32_t)(input[28] & 0x3f) << 26) |
			((uint32_t)input[29] << 18) |
			((uint32_t)(input[30] & 0xc0) << 10);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 242 to 257
	value = ((uint32_t)(input[30] & 0x3f) << 26) |
			((uint32_t)input[31] << 18) |
			((uint32_t)(input[32] & 0xc0) << 10);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 258 to 273
	value = ((uint32_t)(input[32] & 0x3f) << 26) |
			((uint32_t)input[33] << 18) |
			((uint32_t)(input[34] & 0xc0) << 10);
	output[16] = (double)(value >> 16);
}

static void unpack_17_16bit_signed_3off(const uint8_t * input, double * output, void *closure) {
	// Unpack 17 values into output
	// Values are 16-bit signed
	// Skip 3 bits, read 272 bits of data.
	// Input must be at least 35 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 3 to 18
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)input[1] << 19) |
			((uint32_t)(input[2] & 0xe0) << 11);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 19 to 34
	value = ((uint32_t)(input[2] & 0x1f) << 27) |
			((uint32_t)input[3] << 19) |
			((uint32_t)(input[4] & 0xe0) << 11);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 35 to 50
	value = ((uint32_t)(input[4] & 0x1f) << 27) |
			((uint32_t)input[5] << 19) |
			((uint32_t)(input[6] & 0xe0) << 11);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 51 to 66
	value = ((uint32_t)(input[6] & 0x1f) << 27) |
			((uint32_t)input[7] << 19) |
			((uint32_t)(input[8] & 0xe0) << 11);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 67 to 82
	value = ((uint32_t)(input[8] & 0x1f) << 27) |
			((uint32_t)input[9] << 19) |
			((uint32_t)(input[10] & 0xe0) << 11);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 83 to 98
	value = ((uint32_t)(input[10] & 0x1f) << 27) |
			((uint32_t)input[11] << 19) |
			((uint32_t)(input[12] & 0xe0) << 11);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 99 to 114
	value = ((uint32_t)(input[12] & 0x1f) << 27) |
			((uint32_t)input[13] << 19) |
			((uint32_t)(input[14] & 0xe0) << 11);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 115 to 130
	value = ((uint32_t)(input[14] & 0x1f) << 27) |
			((uint32_t)input[15] << 19) |
			((uint32_t)(input[16] & 0xe0) << 11);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 131 to 146
	value = ((uint32_t)(input[16] & 0x1f) << 27) |
			((uint32_t)input[17] << 19) |
			((uint32_t)(input[18] & 0xe0) << 11);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 147 to 162
	value = ((uint32_t)(input[18] & 0x1f) << 27) |
			((uint32_t)input[19] << 19) |
			((uint32_t)(input[20] & 0xe0) << 11);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 163 to 178
	value = ((uint32_t)(input[20] & 0x1f) << 27) |
			((uint32_t)input[21] << 19) |
			((uint32_t)(input[22] & 0xe0) << 11);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 179 to 194
	value = ((uint32_t)(input[22] & 0x1f) << 27) |
			((uint32_t)input[23] << 19) |
			((uint32_t)(input[24] & 0xe0) << 11);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 195 to 210
	value = ((uint32_t)(input[24] & 0x1f) << 27) |
			((uint32_t)input[25] << 19) |
			((uint32_t)(input[26] & 0xe0) << 11);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 211 to 226
	value = ((uint32_t)(input[26] & 0x1f) << 27) |
			((uint32_t)input[27] << 19) |
			((uint32_t)(input[28] & 0xe0) << 11);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 227 to 242
	value = ((uint32_t)(input[28] & 0x1f) << 27) |
			((uint32_t)input[29] << 19) |
			((uint32_t)(input[30] & 0xe0) << 11);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 243 to 258
	value = ((uint32_t)(input[30] & 0x1f) << 27) |
			((uint32_t)input[31] << 19) |
			((uint32_t)(input[32] & 0xe0) << 11);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 259 to 274
	value = ((uint32_t)(input[32] & 0x1f) << 27) |
			((uint32_t)input[33] << 19) |
			((uint32_t)(input[34] & 0xe0) << 11);
	output[16] = (double)(value >> 16);
}

static void unpack_17_16bit_unsigned_3off(const uint8_t * input, double * output, void *closure) {
	// Unpack 17 values into output
	// Values are 16-bit unsigned
	// Skip 3 bits, read 272 bits of data.
	// Input must be at least 35 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 3 to 18
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)input[1] << 19) |
			((uint32_t)(input[2] & 0xe0) << 11);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 19 to 34
	value = ((uint32_t)(input[2] & 0x1f) << 27) |
			((uint32_t)input[3] << 19) |
			((uint32_t)(input[4] & 0xe0) << 11);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 35 to 50
	value = ((uint32_t)(input[4] & 0x1f) << 27) |
			((uint32_t)input[5] << 19) |
			((uint32_t)(input[6] & 0xe0) << 11);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 51 to 66
	value = ((uint32_t)(input[6] & 0x1f) << 27) |
			((uint32_t)input[7] << 19) |
			((uint32_t)(input[8] & 0xe0) << 11);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 67 to 82
	value = ((uint32_t)(input[8] & 0x1f) << 27) |
			((uint32_t)input[9] << 19) |
			((uint32_t)(input[10] & 0xe0) << 11);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 83 to 98
	value = ((uint32_t)(input[10] & 0x1f) << 27) |
			((uint32_t)input[11] << 19) |
			((uint32_t)(input[12] & 0xe0) << 11);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 99 to 114
	value = ((uint32_t)(input[12] & 0x1f) << 27) |
			((uint32_t)input[13] << 19) |
			((uint32_t)(input[14] & 0xe0) << 11);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 115 to 130
	value = ((uint32_t)(input[14] & 0x1f) << 27) |
			((uint32_t)input[15] << 19) |
			((uint32_t)(input[16] & 0xe0) << 11);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 131 to 146
	value = ((uint32_t)(input[16] & 0x1f) << 27) |
			((uint32_t)input[17] << 19) |
			((uint32_t)(input[18] & 0xe0) << 11);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 147 to 162
	value = ((uint32_t)(input[18] & 0x1f) << 27) |
			((uint32_t)input[19] << 19) |
			((uint32_t)(input[20] & 0xe0) << 11);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 163 to 178
	value = ((uint32_t)(input[20] & 0x1f) << 27) |
			((uint32_t)input[21] << 19) |
			((uint32_t)(input[22] & 0xe0) << 11);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 179 to 194
	value = ((uint32_t)(input[22] & 0x1f) << 27) |
			((uint32_t)input[23] << 19) |
			((uint32_t)(input[24] & 0xe0) << 11);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 195 to 210
	value = ((uint32_t)(input[24] & 0x1f) << 27) |
			((uint32_t)input[25] << 19) |
			((uint32_t)(input[26] & 0xe0) << 11);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 211 to 226
	value = ((uint32_t)(input[26] & 0x1f) << 27) |
			((uint32_t)input[27] << 19) |
			((uint32_t)(input[28] & 0xe0) << 11);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 227 to 242
	value = ((uint32_t)(input[28] & 0x1f) << 27) |
			((uint32_t)input[29] << 19) |
			((uint32_t)(input[30] & 0xe0) << 11);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 243 to 258
	value = ((uint32_t)(input[30] & 0x1f) << 27) |
			((uint32_t)input[31] << 19) |
			((uint32_t)(input[32] & 0xe0) << 11);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 259 to 274
	value = ((uint32_t)(input[32] & 0x1f) << 27) |
			((uint32_t)input[33] << 19) |
			((uint32_t)(input[34] & 0xe0) << 11);
	output[16] = (double)(value >> 16);
}

static void unpack_17_16bit_signed_4off(const uint8_t * input, double * output, void *closure) {
	// Unpack 17 values into output
	// Values are 16-bit signed
	// Skip 4 bits, read 272 bits of data.
	// Input must be at least 35 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 4 to 19
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20) |
			((uint32_t)(input[2] & 0xf0) << 12);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 20 to 35
	value = ((uint32_t)(input[2] & 0x0f) << 28) |
			((uint32_t)input[3] << 20) |
			((uint32_t)(input[4] & 0xf0) << 12);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 36 to 51
	value = ((uint32_t)(input[4] & 0x0f) << 28) |
			((uint32_t)input[5] << 20) |
			((uint32_t)(input[6] & 0xf0) << 12);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 52 to 67
	value = ((uint32_t)(input[6] & 0x0f) << 28) |
			((uint32_t)input[7] << 20) |
			((uint32_t)(input[8] & 0xf0) << 12);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 68 to 83
	value = ((uint32_t)(input[8] & 0x0f) << 28) |
			((uint32_t)input[9] << 20) |
			((uint32_t)(input[10] & 0xf0) << 12);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 84 to 99
	value = ((uint32_t)(input[10] & 0x0f) << 28) |
			((uint32_t)input[11] << 20) |
			((uint32_t)(input[12] & 0xf0) << 12);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 100 to 115
	value = ((uint32_t)(input[12] & 0x0f) << 28) |
			((uint32_t)input[13] << 20) |
			((uint32_t)(input[14] & 0xf0) << 12);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 116 to 131
	value = ((uint32_t)(input[14] & 0x0f) << 28) |
			((uint32_t)input[15] << 20) |
			((uint32_t)(input[16] & 0xf0) << 12);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 132 to 147
	value = ((uint32_t)(input[16] & 0x0f) << 28) |
			((uint32_t)input[17] << 20) |
			((uint32_t)(input[18] & 0xf0) << 12);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 148 to 163
	value = ((uint32_t)(input[18] & 0x0f) << 28) |
			((uint32_t)input[19] << 20) |
			((uint32_t)(input[20] & 0xf0) << 12);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 164 to 179
	value = ((uint32_t)(input[20] & 0x0f) << 28) |
			((uint32_t)input[21] << 20) |
			((uint32_t)(input[22] & 0xf0) << 12);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 180 to 195
	value = ((uint32_t)(input[22] & 0x0f) << 28) |
			((uint32_t)input[23] << 20) |
			((uint32_t)(input[24] & 0xf0) << 12);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 196 to 211
	value = ((uint32_t)(input[24] & 0x0f) << 28) |
			((uint32_t)input[25] << 20) |
			((uint32_t)(input[26] & 0xf0) << 12);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 212 to 227
	value = ((uint32_t)(input[26] & 0x0f) << 28) |
			((uint32_t)input[27] << 20) |
			((uint32_t)(input[28] & 0xf0) << 12);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 228 to 243
	value = ((uint32_t)(input[28] & 0x0f) << 28) |
			((uint32_t)input[29] << 20) |
			((uint32_t)(input[30] & 0xf0) << 12);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 244 to 259
	value = ((uint32_t)(input[30] & 0x0f) << 28) |
			((uint32_t)input[31] << 20) |
			((uint32_t)(input[32] & 0xf0) << 12);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 260 to 275
	value = ((uint32_t)(input[32] & 0x0f) << 28) |
			((uint32_t)input[33] << 20) |
			((uint32_t)(input[34] & 0xf0) << 12);
	output[16] = (double)(value >> 16);
}

static void unpack_17_16bit_unsigned_4off(const uint8_t * input, double * output, void *closure) {
	// Unpack 17 values into output
	// Values are 16-bit unsigned
	// Skip 4 bits, read 272 bits of data.
	// Input must be at least 35 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 4 to 19
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20) |
			((uint32_t)(input[2] & 0xf0) << 12);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 20 to 35
	value = ((uint32_t)(input[2] & 0x0f) << 28) |
			((uint32_t)input[3] << 20) |
			((uint32_t)(input[4] & 0xf0) << 12);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 36 to 51
	value = ((uint32_t)(input[4] & 0x0f) << 28) |
			((uint32_t)input[5] << 20) |
			((uint32_t)(input[6] & 0xf0) << 12);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 52 to 67
	value = ((uint32_t)(input[6] & 0x0f) << 28) |
			((uint32_t)input[7] << 20) |
			((uint32_t)(input[8] & 0xf0) << 12);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 68 to 83
	value = ((uint32_t)(input[8] & 0x0f) << 28) |
			((uint32_t)input[9] << 20) |
			((uint32_t)(input[10] & 0xf0) << 12);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 84 to 99
	value = ((uint32_t)(input[10] & 0x0f) << 28) |
			((uint32_t)input[11] << 20) |
			((uint32_t)(input[12] & 0xf0) << 12);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 100 to 115
	value = ((uint32_t)(input[12] & 0x0f) << 28) |
			((uint32_t)input[13] << 20) |
			((uint32_t)(input[14] & 0xf0) << 12);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 116 to 131
	value = ((uint32_t)(input[14] & 0x0f) << 28) |
			((uint32_t)input[15] << 20) |
			((uint32_t)(input[16] & 0xf0) << 12);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 132 to 147
	value = ((uint32_t)(input[16] & 0x0f) << 28) |
			((uint32_t)input[17] << 20) |
			((uint32_t)(input[18] & 0xf0) << 12);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 148 to 163
	value = ((uint32_t)(input[18] & 0x0f) << 28) |
			((uint32_t)input[19] << 20) |
			((uint32_t)(input[20] & 0xf0) << 12);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 164 to 179
	value = ((uint32_t)(input[20] & 0x0f) << 28) |
			((uint32_t)input[21] << 20) |
			((uint32_t)(input[22] & 0xf0) << 12);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 180 to 195
	value = ((uint32_t)(input[22] & 0x0f) << 28) |
			((uint32_t)input[23] << 20) |
			((uint32_t)(input[24] & 0xf0) << 12);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 196 to 211
	value = ((uint32_t)(input[24] & 0x0f) << 28) |
			((uint32_t)input[25] << 20) |
			((uint32_t)(input[26] & 0xf0) << 12);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 212 to 227
	value = ((uint32_t)(input[26] & 0x0f) << 28) |
			((uint32_t)input[27] << 20) |
			((uint32_t)(input[28] & 0xf0) << 12);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 228 to 243
	value = ((uint32_t)(input[28] & 0x0f) << 28) |
			((uint32_t)input[29] << 20) |
			((uint32_t)(input[30] & 0xf0) << 12);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 244 to 259
	value = ((uint32_t)(input[30] & 0x0f) << 28) |
			((uint32_t)input[31] << 20) |
			((uint32_t)(input[32] & 0xf0) << 12);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 260 to 275
	value = ((uint32_t)(input[32] & 0x0f) << 28) |
			((uint32_t)input[33] << 20) |
			((uint32_t)(input[34] & 0xf0) << 12);
	output[16] = (double)(value >> 16);
}

static void unpack_17_16bit_signed_5off(const uint8_t * input, double * output, void *closure) {
	// Unpack 17 values into output
	// Values are 16-bit signed
	// Skip 5 bits, read 272 bits of data.
	// Input must be at least 35 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 5 to 20
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)(input[2] & 0xf8) << 13);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 21 to 36
	value = ((uint32_t)(input[2] & 0x07) << 29) |
			((uint32_t)input[3] << 21) |
			((uint32_t)(input[4] & 0xf8) << 13);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 37 to 52
	value = ((uint32_t)(input[4] & 0x07) << 29) |
			((uint32_t)input[5] << 21) |
			((uint32_t)(input[6] & 0xf8) << 13);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 53 to 68
	value = ((uint32_t)(input[6] & 0x07) << 29) |
			((uint32_t)input[7] << 21) |
			((uint32_t)(input[8] & 0xf8) << 13);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 69 to 84
	value = ((uint32_t)(input[8] & 0x07) << 29) |
			((uint32_t)input[9] << 21) |
			((uint32_t)(input[10] & 0xf8) << 13);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 85 to 100
	value = ((uint32_t)(input[10] & 0x07) << 29) |
			((uint32_t)input[11] << 21) |
			((uint32_t)(input[12] & 0xf8) << 13);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 101 to 116
	value = ((uint32_t)(input[12] & 0x07) << 29) |
			((uint32_t)input[13] << 21) |
			((uint32_t)(input[14] & 0xf8) << 13);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 117 to 132
	value = ((uint32_t)(input[14] & 0x07) << 29) |
			((uint32_t)input[15] << 21) |
			((uint32_t)(input[16] & 0xf8) << 13);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 133 to 148
	value = ((uint32_t)(input[16] & 0x07) << 29) |
			((uint32_t)input[17] << 21) |
			((uint32_t)(input[18] & 0xf8) << 13);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 149 to 164
	value = ((uint32_t)(input[18] & 0x07) << 29) |
			((uint32_t)input[19] << 21) |
			((uint32_t)(input[20] & 0xf8) << 13);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 165 to 180
	value = ((uint32_t)(input[20] & 0x07) << 29) |
			((uint32_t)input[21] << 21) |
			((uint32_t)(input[22] & 0xf8) << 13);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 181 to 196
	value = ((uint32_t)(input[22] & 0x07) << 29) |
			((uint32_t)input[23] << 21) |
			((uint32_t)(input[24] & 0xf8) << 13);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 197 to 212
	value = ((uint32_t)(input[24] & 0x07) << 29) |
			((uint32_t)input[25] << 21) |
			((uint32_t)(input[26] & 0xf8) << 13);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 213 to 228
	value = ((uint32_t)(input[26] & 0x07) << 29) |
			((uint32_t)input[27] << 21) |
			((uint32_t)(input[28] & 0xf8) << 13);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 229 to 244
	value = ((uint32_t)(input[28] & 0x07) << 29) |
			((uint32_t)input[29] << 21) |
			((uint32_t)(input[30] & 0xf8) << 13);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 245 to 260
	value = ((uint32_t)(input[30] & 0x07) << 29) |
			((uint32_t)input[31] << 21) |
			((uint32_t)(input[32] & 0xf8) << 13);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 261 to 276
	value = ((uint32_t)(input[32] & 0x07) << 29) |
			((uint32_t)input[33] << 21) |
			((uint32_t)(input[34] & 0xf8) << 13);
	output[16] = (double)(value >> 16);
}

static void unpack_17_16bit_unsigned_5off(const uint8_t * input, double * output, void *closure) {
	// Unpack 17 values into output
	// Values are 16-bit unsigned
	// Skip 5 bits, read 272 bits of data.
	// Input must be at least 35 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 5 to 20
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)(input[2] & 0xf8) << 13);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 21 to 36
	value = ((uint32_t)(input[2] & 0x07) << 29) |
			((uint32_t)input[3] << 21) |
			((uint32_t)(input[4] & 0xf8) << 13);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 37 to 52
	value = ((uint32_t)(input[4] & 0x07) << 29) |
			((uint32_t)input[5] << 21) |
			((uint32_t)(input[6] & 0xf8) << 13);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 53 to 68
	value = ((uint32_t)(input[6] & 0x07) << 29) |
			((uint32_t)input[7] << 21) |
			((uint32_t)(input[8] & 0xf8) << 13);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 69 to 84
	value = ((uint32_t)(input[8] & 0x07) << 29) |
			((uint32_t)input[9] << 21) |
			((uint32_t)(input[10] & 0xf8) << 13);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 85 to 100
	value = ((uint32_t)(input[10] & 0x07) << 29) |
			((uint32_t)input[11] << 21) |
			((uint32_t)(input[12] & 0xf8) << 13);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 101 to 116
	value = ((uint32_t)(input[12] & 0x07) << 29) |
			((uint32_t)input[13] << 21) |
			((uint32_t)(input[14] & 0xf8) << 13);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 117 to 132
	value = ((uint32_t)(input[14] & 0x07) << 29) |
			((uint32_t)input[15] << 21) |
			((uint32_t)(input[16] & 0xf8) << 13);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 133 to 148
	value = ((uint32_t)(input[16] & 0x07) << 29) |
			((uint32_t)input[17] << 21) |
			((uint32_t)(input[18] & 0xf8) << 13);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 149 to 164
	value = ((uint32_t)(input[18] & 0x07) << 29) |
			((uint32_t)input[19] << 21) |
			((uint32_t)(input[20] & 0xf8) << 13);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 165 to 180
	value = ((uint32_t)(input[20] & 0x07) << 29) |
			((uint32_t)input[21] << 21) |
			((uint32_t)(input[22] & 0xf8) << 13);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 181 to 196
	value = ((uint32_t)(input[22] & 0x07) << 29) |
			((uint32_t)input[23] << 21) |
			((uint32_t)(input[24] & 0xf8) << 13);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 197 to 212
	value = ((uint32_t)(input[24] & 0x07) << 29) |
			((uint32_t)input[25] << 21) |
			((uint32_t)(input[26] & 0xf8) << 13);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 213 to 228
	value = ((uint32_t)(input[26] & 0x07) << 29) |
			((uint32_t)input[27] << 21) |
			((uint32_t)(input[28] & 0xf8) << 13);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 229 to 244
	value = ((uint32_t)(input[28] & 0x07) << 29) |
			((uint32_t)input[29] << 21) |
			((uint32_t)(input[30] & 0xf8) << 13);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 245 to 260
	value = ((uint32_t)(input[30] & 0x07) << 29) |
			((uint32_t)input[31] << 21) |
			((uint32_t)(input[32] & 0xf8) << 13);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 261 to 276
	value = ((uint32_t)(input[32] & 0x07) << 29) |
			((uint32_t)input[33] << 21) |
			((uint32_t)(input[34] & 0xf8) << 13);
	output[16] = (double)(value >> 16);
}

static void unpack_17_16bit_signed_6off(const uint8_t * input, double * output, void *closure) {
	// Unpack 17 values into output
	// Values are 16-bit signed
	// Skip 6 bits, read 272 bits of data.
	// Input must be at least 35 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 6 to 21
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)(input[2] & 0xfc) << 14);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 22 to 37
	value = ((uint32_t)(input[2] & 0x03) << 30) |
			((uint32_t)input[3] << 22) |
			((uint32_t)(input[4] & 0xfc) << 14);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 38 to 53
	value = ((uint32_t)(input[4] & 0x03) << 30) |
			((uint32_t)input[5] << 22) |
			((uint32_t)(input[6] & 0xfc) << 14);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 54 to 69
	value = ((uint32_t)(input[6] & 0x03) << 30) |
			((uint32_t)input[7] << 22) |
			((uint32_t)(input[8] & 0xfc) << 14);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 70 to 85
	value = ((uint32_t)(input[8] & 0x03) << 30) |
			((uint32_t)input[9] << 22) |
			((uint32_t)(input[10] & 0xfc) << 14);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 86 to 101
	value = ((uint32_t)(input[10] & 0x03) << 30) |
			((uint32_t)input[11] << 22) |
			((uint32_t)(input[12] & 0xfc) << 14);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 102 to 117
	value = ((uint32_t)(input[12] & 0x03) << 30) |
			((uint32_t)input[13] << 22) |
			((uint32_t)(input[14] & 0xfc) << 14);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 118 to 133
	value = ((uint32_t)(input[14] & 0x03) << 30) |
			((uint32_t)input[15] << 22) |
			((uint32_t)(input[16] & 0xfc) << 14);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 134 to 149
	value = ((uint32_t)(input[16] & 0x03) << 30) |
			((uint32_t)input[17] << 22) |
			((uint32_t)(input[18] & 0xfc) << 14);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 150 to 165
	value = ((uint32_t)(input[18] & 0x03) << 30) |
			((uint32_t)input[19] << 22) |
			((uint32_t)(input[20] & 0xfc) << 14);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 166 to 181
	value = ((uint32_t)(input[20] & 0x03) << 30) |
			((uint32_t)input[21] << 22) |
			((uint32_t)(input[22] & 0xfc) << 14);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 182 to 197
	value = ((uint32_t)(input[22] & 0x03) << 30) |
			((uint32_t)input[23] << 22) |
			((uint32_t)(input[24] & 0xfc) << 14);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 198 to 213
	value = ((uint32_t)(input[24] & 0x03) << 30) |
			((uint32_t)input[25] << 22) |
			((uint32_t)(input[26] & 0xfc) << 14);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 214 to 229
	value = ((uint32_t)(input[26] & 0x03) << 30) |
			((uint32_t)input[27] << 22) |
			((uint32_t)(input[28] & 0xfc) << 14);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 230 to 245
	value = ((uint32_t)(input[28] & 0x03) << 30) |
			((uint32_t)input[29] << 22) |
			((uint32_t)(input[30] & 0xfc) << 14);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 246 to 261
	value = ((uint32_t)(input[30] & 0x03) << 30) |
			((uint32_t)input[31] << 22) |
			((uint32_t)(input[32] & 0xfc) << 14);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 262 to 277
	value = ((uint32_t)(input[32] & 0x03) << 30) |
			((uint32_t)input[33] << 22) |
			((uint32_t)(input[34] & 0xfc) << 14);
	output[16] = (double)(value >> 16);
}

static void unpack_17_16bit_unsigned_6off(const uint8_t * input, double * output, void *closure) {
	// Unpack 17 values into output
	// Values are 16-bit unsigned
	// Skip 6 bits, read 272 bits of data.
	// Input must be at least 35 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 6 to 21
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)(input[2] & 0xfc) << 14);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 22 to 37
	value = ((uint32_t)(input[2] & 0x03) << 30) |
			((uint32_t)input[3] << 22) |
			((uint32_t)(input[4] & 0xfc) << 14);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 38 to 53
	value = ((uint32_t)(input[4] & 0x03) << 30) |
			((uint32_t)input[5] << 22) |
			((uint32_t)(input[6] & 0xfc) << 14);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 54 to 69
	value = ((uint32_t)(input[6] & 0x03) << 30) |
			((uint32_t)input[7] << 22) |
			((uint32_t)(input[8] & 0xfc) << 14);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 70 to 85
	value = ((uint32_t)(input[8] & 0x03) << 30) |
			((uint32_t)input[9] << 22) |
			((uint32_t)(input[10] & 0xfc) << 14);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 86 to 101
	value = ((uint32_t)(input[10] & 0x03) << 30) |
			((uint32_t)input[11] << 22) |
			((uint32_t)(input[12] & 0xfc) << 14);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 102 to 117
	value = ((uint32_t)(input[12] & 0x03) << 30) |
			((uint32_t)input[13] << 22) |
			((uint32_t)(input[14] & 0xfc) << 14);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 118 to 133
	value = ((uint32_t)(input[14] & 0x03) << 30) |
			((uint32_t)input[15] << 22) |
			((uint32_t)(input[16] & 0xfc) << 14);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 134 to 149
	value = ((uint32_t)(input[16] & 0x03) << 30) |
			((uint32_t)input[17] << 22) |
			((uint32_t)(input[18] & 0xfc) << 14);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 150 to 165
	value = ((uint32_t)(input[18] & 0x03) << 30) |
			((uint32_t)input[19] << 22) |
			((uint32_t)(input[20] & 0xfc) << 14);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 166 to 181
	value = ((uint32_t)(input[20] & 0x03) << 30) |
			((uint32_t)input[21] << 22) |
			((uint32_t)(input[22] & 0xfc) << 14);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 182 to 197
	value = ((uint32_t)(input[22] & 0x03) << 30) |
			((uint32_t)input[23] << 22) |
			((uint32_t)(input[24] & 0xfc) << 14);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 198 to 213
	value = ((uint32_t)(input[24] & 0x03) << 30) |
			((uint32_t)input[25] << 22) |
			((uint32_t)(input[26] & 0xfc) << 14);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 214 to 229
	value = ((uint32_t)(input[26] & 0x03) << 30) |
			((uint32_t)input[27] << 22) |
			((uint32_t)(input[28] & 0xfc) << 14);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 230 to 245
	value = ((uint32_t)(input[28] & 0x03) << 30) |
			((uint32_t)input[29] << 22) |
			((uint32_t)(input[30] & 0xfc) << 14);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 246 to 261
	value = ((uint32_t)(input[30] & 0x03) << 30) |
			((uint32_t)input[31] << 22) |
			((uint32_t)(input[32] & 0xfc) << 14);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 262 to 277
	value = ((uint32_t)(input[32] & 0x03) << 30) |
			((uint32_t)input[33] << 22) |
			((uint32_t)(input[34] & 0xfc) << 14);
	output[16] = (double)(value >> 16);
}

static void unpack_17_16bit_signed_7off(const uint8_t * input, double * output, void *closure) {
	// Unpack 17 values into output
	// Values are 16-bit signed
	// Skip 7 bits, read 272 bits of data.
	// Input must be at least 35 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 7 to 22
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)(input[2] & 0xfe) << 15);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 23 to 38
	value = ((uint32_t)(input[2] & 0x01) << 31) |
			((uint32_t)input[3] << 23) |
			((uint32_t)(input[4] & 0xfe) << 15);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 39 to 54
	value = ((uint32_t)(input[4] & 0x01) << 31) |
			((uint32_t)input[5] << 23) |
			((uint32_t)(input[6] & 0xfe) << 15);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 55 to 70
	value = ((uint32_t)(input[6] & 0x01) << 31) |
			((uint32_t)input[7] << 23) |
			((uint32_t)(input[8] & 0xfe) << 15);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 71 to 86
	value = ((uint32_t)(input[8] & 0x01) << 31) |
			((uint32_t)input[9] << 23) |
			((uint32_t)(input[10] & 0xfe) << 15);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 87 to 102
	value = ((uint32_t)(input[10] & 0x01) << 31) |
			((uint32_t)input[11] << 23) |
			((uint32_t)(input[12] & 0xfe) << 15);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 103 to 118
	value = ((uint32_t)(input[12] & 0x01) << 31) |
			((uint32_t)input[13] << 23) |
			((uint32_t)(input[14] & 0xfe) << 15);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 119 to 134
	value = ((uint32_t)(input[14] & 0x01) << 31) |
			((uint32_t)input[15] << 23) |
			((uint32_t)(input[16] & 0xfe) << 15);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 135 to 150
	value = ((uint32_t)(input[16] & 0x01) << 31) |
			((uint32_t)input[17] << 23) |
			((uint32_t)(input[18] & 0xfe) << 15);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 151 to 166
	value = ((uint32_t)(input[18] & 0x01) << 31) |
			((uint32_t)input[19] << 23) |
			((uint32_t)(input[20] & 0xfe) << 15);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 167 to 182
	value = ((uint32_t)(input[20] & 0x01) << 31) |
			((uint32_t)input[21] << 23) |
			((uint32_t)(input[22] & 0xfe) << 15);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 183 to 198
	value = ((uint32_t)(input[22] & 0x01) << 31) |
			((uint32_t)input[23] << 23) |
			((uint32_t)(input[24] & 0xfe) << 15);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 199 to 214
	value = ((uint32_t)(input[24] & 0x01) << 31) |
			((uint32_t)input[25] << 23) |
			((uint32_t)(input[26] & 0xfe) << 15);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 215 to 230
	value = ((uint32_t)(input[26] & 0x01) << 31) |
			((uint32_t)input[27] << 23) |
			((uint32_t)(input[28] & 0xfe) << 15);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 231 to 246
	value = ((uint32_t)(input[28] & 0x01) << 31) |
			((uint32_t)input[29] << 23) |
			((uint32_t)(input[30] & 0xfe) << 15);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 247 to 262
	value = ((uint32_t)(input[30] & 0x01) << 31) |
			((uint32_t)input[31] << 23) |
			((uint32_t)(input[32] & 0xfe) << 15);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 263 to 278
	value = ((uint32_t)(input[32] & 0x01) << 31) |
			((uint32_t)input[33] << 23) |
			((uint32_t)(input[34] & 0xfe) << 15);
	output[16] = (double)(value >> 16);
}

static void unpack_17_16bit_unsigned_7off(const uint8_t * input, double * output, void *closure) {
	// Unpack 17 values into output
	// Values are 16-bit unsigned
	// Skip 7 bits, read 272 bits of data.
	// Input must be at least 35 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 7 to 22
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)(input[2] & 0xfe) << 15);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 23 to 38
	value = ((uint32_t)(input[2] & 0x01) << 31) |
			((uint32_t)input[3] << 23) |
			((uint32_t)(input[4] & 0xfe) << 15);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 39 to 54
	value = ((uint32_t)(input[4] & 0x01) << 31) |
			((uint32_t)input[5] << 23) |
			((uint32_t)(input[6] & 0xfe) << 15);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 55 to 70
	value = ((uint32_t)(input[6] & 0x01) << 31) |
			((uint32_t)input[7] << 23) |
			((uint32_t)(input[8] & 0xfe) << 15);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 71 to 86
	value = ((uint32_t)(input[8] & 0x01) << 31) |
			((uint32_t)input[9] << 23) |
			((uint32_t)(input[10] & 0xfe) << 15);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 87 to 102
	value = ((uint32_t)(input[10] & 0x01) << 31) |
			((uint32_t)input[11] << 23) |
			((uint32_t)(input[12] & 0xfe) << 15);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 103 to 118
	value = ((uint32_t)(input[12] & 0x01) << 31) |
			((uint32_t)input[13] << 23) |
			((uint32_t)(input[14] & 0xfe) << 15);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 119 to 134
	value = ((uint32_t)(input[14] & 0x01) << 31) |
			((uint32_t)input[15] << 23) |
			((uint32_t)(input[16] & 0xfe) << 15);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 135 to 150
	value = ((uint32_t)(input[16] & 0x01) << 31) |
			((uint32_t)input[17] << 23) |
			((uint32_t)(input[18] & 0xfe) << 15);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 151 to 166
	value = ((uint32_t)(input[18] & 0x01) << 31) |
			((uint32_t)input[19] << 23) |
			((uint32_t)(input[20] & 0xfe) << 15);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 167 to 182
	value = ((uint32_t)(input[20] & 0x01) << 31) |
			((uint32_t)input[21] << 23) |
			((uint32_t)(input[22] & 0xfe) << 15);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 183 to 198
	value = ((uint32_t)(input[22] & 0x01) << 31) |
			((uint32_t)input[23] << 23) |
			((uint32_t)(input[24] & 0xfe) << 15);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 199 to 214
	value = ((uint32_t)(input[24] & 0x01) << 31) |
			((uint32_t)input[25] << 23) |
			((uint32_t)(input[26] & 0xfe) << 15);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 215 to 230
	value = ((uint32_t)(input[26] & 0x01) << 31) |
			((uint32_t)input[27] << 23) |
			((uint32_t)(input[28] & 0xfe) << 15);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 231 to 246
	value = ((uint32_t)(input[28] & 0x01) << 31) |
			((uint32_t)input[29] << 23) |
			((uint32_t)(input[30] & 0xfe) << 15);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 247 to 262
	value = ((uint32_t)(input[30] & 0x01) << 31) |
			((uint32_t)input[31] << 23) |
			((uint32_t)(input[32] & 0xfe) << 15);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 263 to 278
	value = ((uint32_t)(input[32] & 0x01) << 31) |
			((uint32_t)input[33] << 23) |
			((uint32_t)(input[34] & 0xfe) << 15);
	output[16] = (double)(value >> 16);
}

static void unpack_18_16bit_signed_0off(const uint8_t * input, double * output, void *closure) {
	// Unpack 18 values into output
	// Values are 16-bit signed
	// Skip 0 bits, read 288 bits of data.
	// Input must be at least 36 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 0 to 15
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)input[1] << 16);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 16 to 31
	value = ((uint32_t)input[2] << 24) |
			((uint32_t)input[3] << 16);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 32 to 47
	value = ((uint32_t)input[4] << 24) |
			((uint32_t)input[5] << 16);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 48 to 63
	value = ((uint32_t)input[6] << 24) |
			((uint32_t)input[7] << 16);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 64 to 79
	value = ((uint32_t)input[8] << 24) |
			((uint32_t)input[9] << 16);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 80 to 95
	value = ((uint32_t)input[10] << 24) |
			((uint32_t)input[11] << 16);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 96 to 111
	value = ((uint32_t)input[12] << 24) |
			((uint32_t)input[13] << 16);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 112 to 127
	value = ((uint32_t)input[14] << 24) |
			((uint32_t)input[15] << 16);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 128 to 143
	value = ((uint32_t)input[16] << 24) |
			((uint32_t)input[17] << 16);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 144 to 159
	value = ((uint32_t)input[18] << 24) |
			((uint32_t)input[19] << 16);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 160 to 175
	value = ((uint32_t)input[20] << 24) |
			((uint32_t)input[21] << 16);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 176 to 191
	value = ((uint32_t)input[22] << 24) |
			((uint32_t)input[23] << 16);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 192 to 207
	value = ((uint32_t)input[24] << 24) |
			((uint32_t)input[25] << 16);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 208 to 223
	value = ((uint32_t)input[26] << 24) |
			((uint32_t)input[27] << 16);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 224 to 239
	value = ((uint32_t)input[28] << 24) |
			((uint32_t)input[29] << 16);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 240 to 255
	value = ((uint32_t)input[30] << 24) |
			((uint32_t)input[31] << 16);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 256 to 271
	value = ((uint32_t)input[32] << 24) |
			((uint32_t)input[33] << 16);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 272 to 287
	value = ((uint32_t)input[34] << 24) |
			((uint32_t)input[35] << 16);
	output[17] = (double)(value >> 16);
}

static void unpack_18_16bit_unsigned_0off(const uint8_t * input, double * output, void *closure) {
	// Unpack 18 values into output
	// Values are 16-bit unsigned
	// Skip 0 bits, read 288 bits of data.
	// Input must be at least 36 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 0 to 15
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)input[1] << 16);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 16 to 31
	value = ((uint32_t)input[2] << 24) |
			((uint32_t)input[3] << 16);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 32 to 47
	value = ((uint32_t)input[4] << 24) |
			((uint32_t)input[5] << 16);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 48 to 63
	value = ((uint32_t)input[6] << 24) |
			((uint32_t)input[7] << 16);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 64 to 79
	value = ((uint32_t)input[8] << 24) |
			((uint32_t)input[9] << 16);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 80 to 95
	value = ((uint32_t)input[10] << 24) |
			((uint32_t)input[11] << 16);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 96 to 111
	value = ((uint32_t)input[12] << 24) |
			((uint32_t)input[13] << 16);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 112 to 127
	value = ((uint32_t)input[14] << 24) |
			((uint32_t)input[15] << 16);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 128 to 143
	value = ((uint32_t)input[16] << 24) |
			((uint32_t)input[17] << 16);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 144 to 159
	value = ((uint32_t)input[18] << 24) |
			((uint32_t)input[19] << 16);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 160 to 175
	value = ((uint32_t)input[20] << 24) |
			((uint32_t)input[21] << 16);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 176 to 191
	value = ((uint32_t)input[22] << 24) |
			((uint32_t)input[23] << 16);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 192 to 207
	value = ((uint32_t)input[24] << 24) |
			((uint32_t)input[25] << 16);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 208 to 223
	value = ((uint32_t)input[26] << 24) |
			((uint32_t)input[27] << 16);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 224 to 239
	value = ((uint32_t)input[28] << 24) |
			((uint32_t)input[29] << 16);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 240 to 255
	value = ((uint32_t)input[30] << 24) |
			((uint32_t)input[31] << 16);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 256 to 271
	value = ((uint32_t)input[32] << 24) |
			((uint32_t)input[33] << 16);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 272 to 287
	value = ((uint32_t)input[34] << 24) |
			((uint32_t)input[35] << 16);
	output[17] = (double)(value >> 16);
}

static void unpack_18_16bit_signed_1off(const uint8_t * input, double * output, void *closure) {
	// Unpack 18 values into output
	// Values are 16-bit signed
	// Skip 1 bits, read 288 bits of data.
	// Input must be at least 37 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 1 to 16
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)input[1] << 17) |
			((uint32_t)(input[2] & 0x80) << 9);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 17 to 32
	value = ((uint32_t)(input[2] & 0x7f) << 25) |
			((uint32_t)input[3] << 17) |
			((uint32_t)(input[4] & 0x80) << 9);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 33 to 48
	value = ((uint32_t)(input[4] & 0x7f) << 25) |
			((uint32_t)input[5] << 17) |
			((uint32_t)(input[6] & 0x80) << 9);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 49 to 64
	value = ((uint32_t)(input[6] & 0x7f) << 25) |
			((uint32_t)input[7] << 17) |
			((uint32_t)(input[8] & 0x80) << 9);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 65 to 80
	value = ((uint32_t)(input[8] & 0x7f) << 25) |
			((uint32_t)input[9] << 17) |
			((uint32_t)(input[10] & 0x80) << 9);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 81 to 96
	value = ((uint32_t)(input[10] & 0x7f) << 25) |
			((uint32_t)input[11] << 17) |
			((uint32_t)(input[12] & 0x80) << 9);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 97 to 112
	value = ((uint32_t)(input[12] & 0x7f) << 25) |
			((uint32_t)input[13] << 17) |
			((uint32_t)(input[14] & 0x80) << 9);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 113 to 128
	value = ((uint32_t)(input[14] & 0x7f) << 25) |
			((uint32_t)input[15] << 17) |
			((uint32_t)(input[16] & 0x80) << 9);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 129 to 144
	value = ((uint32_t)(input[16] & 0x7f) << 25) |
			((uint32_t)input[17] << 17) |
			((uint32_t)(input[18] & 0x80) << 9);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 145 to 160
	value = ((uint32_t)(input[18] & 0x7f) << 25) |
			((uint32_t)input[19] << 17) |
			((uint32_t)(input[20] & 0x80) << 9);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 161 to 176
	value = ((uint32_t)(input[20] & 0x7f) << 25) |
			((uint32_t)input[21] << 17) |
			((uint32_t)(input[22] & 0x80) << 9);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 177 to 192
	value = ((uint32_t)(input[22] & 0x7f) << 25) |
			((uint32_t)input[23] << 17) |
			((uint32_t)(input[24] & 0x80) << 9);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 193 to 208
	value = ((uint32_t)(input[24] & 0x7f) << 25) |
			((uint32_t)input[25] << 17) |
			((uint32_t)(input[26] & 0x80) << 9);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 209 to 224
	value = ((uint32_t)(input[26] & 0x7f) << 25) |
			((uint32_t)input[27] << 17) |
			((uint32_t)(input[28] & 0x80) << 9);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 225 to 240
	value = ((uint32_t)(input[28] & 0x7f) << 25) |
			((uint32_t)input[29] << 17) |
			((uint32_t)(input[30] & 0x80) << 9);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 241 to 256
	value = ((uint32_t)(input[30] & 0x7f) << 25) |
			((uint32_t)input[31] << 17) |
			((uint32_t)(input[32] & 0x80) << 9);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 257 to 272
	value = ((uint32_t)(input[32] & 0x7f) << 25) |
			((uint32_t)input[33] << 17) |
			((uint32_t)(input[34] & 0x80) << 9);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 273 to 288
	value = ((uint32_t)(input[34] & 0x7f) << 25) |
			((uint32_t)input[35] << 17) |
			((uint32_t)(input[36] & 0x80) << 9);
	output[17] = (double)(value >> 16);
}

static void unpack_18_16bit_unsigned_1off(const uint8_t * input, double * output, void *closure) {
	// Unpack 18 values into output
	// Values are 16-bit unsigned
	// Skip 1 bits, read 288 bits of data.
	// Input must be at least 37 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 1 to 16
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)input[1] << 17) |
			((uint32_t)(input[2] & 0x80) << 9);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 17 to 32
	value = ((uint32_t)(input[2] & 0x7f) << 25) |
			((uint32_t)input[3] << 17) |
			((uint32_t)(input[4] & 0x80) << 9);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 33 to 48
	value = ((uint32_t)(input[4] & 0x7f) << 25) |
			((uint32_t)input[5] << 17) |
			((uint32_t)(input[6] & 0x80) << 9);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 49 to 64
	value = ((uint32_t)(input[6] & 0x7f) << 25) |
			((uint32_t)input[7] << 17) |
			((uint32_t)(input[8] & 0x80) << 9);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 65 to 80
	value = ((uint32_t)(input[8] & 0x7f) << 25) |
			((uint32_t)input[9] << 17) |
			((uint32_t)(input[10] & 0x80) << 9);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 81 to 96
	value = ((uint32_t)(input[10] & 0x7f) << 25) |
			((uint32_t)input[11] << 17) |
			((uint32_t)(input[12] & 0x80) << 9);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 97 to 112
	value = ((uint32_t)(input[12] & 0x7f) << 25) |
			((uint32_t)input[13] << 17) |
			((uint32_t)(input[14] & 0x80) << 9);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 113 to 128
	value = ((uint32_t)(input[14] & 0x7f) << 25) |
			((uint32_t)input[15] << 17) |
			((uint32_t)(input[16] & 0x80) << 9);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 129 to 144
	value = ((uint32_t)(input[16] & 0x7f) << 25) |
			((uint32_t)input[17] << 17) |
			((uint32_t)(input[18] & 0x80) << 9);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 145 to 160
	value = ((uint32_t)(input[18] & 0x7f) << 25) |
			((uint32_t)input[19] << 17) |
			((uint32_t)(input[20] & 0x80) << 9);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 161 to 176
	value = ((uint32_t)(input[20] & 0x7f) << 25) |
			((uint32_t)input[21] << 17) |
			((uint32_t)(input[22] & 0x80) << 9);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 177 to 192
	value = ((uint32_t)(input[22] & 0x7f) << 25) |
			((uint32_t)input[23] << 17) |
			((uint32_t)(input[24] & 0x80) << 9);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 193 to 208
	value = ((uint32_t)(input[24] & 0x7f) << 25) |
			((uint32_t)input[25] << 17) |
			((uint32_t)(input[26] & 0x80) << 9);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 209 to 224
	value = ((uint32_t)(input[26] & 0x7f) << 25) |
			((uint32_t)input[27] << 17) |
			((uint32_t)(input[28] & 0x80) << 9);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 225 to 240
	value = ((uint32_t)(input[28] & 0x7f) << 25) |
			((uint32_t)input[29] << 17) |
			((uint32_t)(input[30] & 0x80) << 9);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 241 to 256
	value = ((uint32_t)(input[30] & 0x7f) << 25) |
			((uint32_t)input[31] << 17) |
			((uint32_t)(input[32] & 0x80) << 9);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 257 to 272
	value = ((uint32_t)(input[32] & 0x7f) << 25) |
			((uint32_t)input[33] << 17) |
			((uint32_t)(input[34] & 0x80) << 9);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 273 to 288
	value = ((uint32_t)(input[34] & 0x7f) << 25) |
			((uint32_t)input[35] << 17) |
			((uint32_t)(input[36] & 0x80) << 9);
	output[17] = (double)(value >> 16);
}

static void unpack_18_16bit_signed_2off(const uint8_t * input, double * output, void *closure) {
	// Unpack 18 values into output
	// Values are 16-bit signed
	// Skip 2 bits, read 288 bits of data.
	// Input must be at least 37 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 2 to 17
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)input[1] << 18) |
			((uint32_t)(input[2] & 0xc0) << 10);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 18 to 33
	value = ((uint32_t)(input[2] & 0x3f) << 26) |
			((uint32_t)input[3] << 18) |
			((uint32_t)(input[4] & 0xc0) << 10);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 34 to 49
	value = ((uint32_t)(input[4] & 0x3f) << 26) |
			((uint32_t)input[5] << 18) |
			((uint32_t)(input[6] & 0xc0) << 10);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 50 to 65
	value = ((uint32_t)(input[6] & 0x3f) << 26) |
			((uint32_t)input[7] << 18) |
			((uint32_t)(input[8] & 0xc0) << 10);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 66 to 81
	value = ((uint32_t)(input[8] & 0x3f) << 26) |
			((uint32_t)input[9] << 18) |
			((uint32_t)(input[10] & 0xc0) << 10);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 82 to 97
	value = ((uint32_t)(input[10] & 0x3f) << 26) |
			((uint32_t)input[11] << 18) |
			((uint32_t)(input[12] & 0xc0) << 10);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 98 to 113
	value = ((uint32_t)(input[12] & 0x3f) << 26) |
			((uint32_t)input[13] << 18) |
			((uint32_t)(input[14] & 0xc0) << 10);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 114 to 129
	value = ((uint32_t)(input[14] & 0x3f) << 26) |
			((uint32_t)input[15] << 18) |
			((uint32_t)(input[16] & 0xc0) << 10);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 130 to 145
	value = ((uint32_t)(input[16] & 0x3f) << 26) |
			((uint32_t)input[17] << 18) |
			((uint32_t)(input[18] & 0xc0) << 10);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 146 to 161
	value = ((uint32_t)(input[18] & 0x3f) << 26) |
			((uint32_t)input[19] << 18) |
			((uint32_t)(input[20] & 0xc0) << 10);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 162 to 177
	value = ((uint32_t)(input[20] & 0x3f) << 26) |
			((uint32_t)input[21] << 18) |
			((uint32_t)(input[22] & 0xc0) << 10);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 178 to 193
	value = ((uint32_t)(input[22] & 0x3f) << 26) |
			((uint32_t)input[23] << 18) |
			((uint32_t)(input[24] & 0xc0) << 10);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 194 to 209
	value = ((uint32_t)(input[24] & 0x3f) << 26) |
			((uint32_t)input[25] << 18) |
			((uint32_t)(input[26] & 0xc0) << 10);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 210 to 225
	value = ((uint32_t)(input[26] & 0x3f) << 26) |
			((uint32_t)input[27] << 18) |
			((uint32_t)(input[28] & 0xc0) << 10);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 226 to 241
	value = ((uint32_t)(input[28] & 0x3f) << 26) |
			((uint32_t)input[29] << 18) |
			((uint32_t)(input[30] & 0xc0) << 10);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 242 to 257
	value = ((uint32_t)(input[30] & 0x3f) << 26) |
			((uint32_t)input[31] << 18) |
			((uint32_t)(input[32] & 0xc0) << 10);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 258 to 273
	value = ((uint32_t)(input[32] & 0x3f) << 26) |
			((uint32_t)input[33] << 18) |
			((uint32_t)(input[34] & 0xc0) << 10);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 274 to 289
	value = ((uint32_t)(input[34] & 0x3f) << 26) |
			((uint32_t)input[35] << 18) |
			((uint32_t)(input[36] & 0xc0) << 10);
	output[17] = (double)(value >> 16);
}

static void unpack_18_16bit_unsigned_2off(const uint8_t * input, double * output, void *closure) {
	// Unpack 18 values into output
	// Values are 16-bit unsigned
	// Skip 2 bits, read 288 bits of data.
	// Input must be at least 37 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 2 to 17
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)input[1] << 18) |
			((uint32_t)(input[2] & 0xc0) << 10);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 18 to 33
	value = ((uint32_t)(input[2] & 0x3f) << 26) |
			((uint32_t)input[3] << 18) |
			((uint32_t)(input[4] & 0xc0) << 10);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 34 to 49
	value = ((uint32_t)(input[4] & 0x3f) << 26) |
			((uint32_t)input[5] << 18) |
			((uint32_t)(input[6] & 0xc0) << 10);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 50 to 65
	value = ((uint32_t)(input[6] & 0x3f) << 26) |
			((uint32_t)input[7] << 18) |
			((uint32_t)(input[8] & 0xc0) << 10);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 66 to 81
	value = ((uint32_t)(input[8] & 0x3f) << 26) |
			((uint32_t)input[9] << 18) |
			((uint32_t)(input[10] & 0xc0) << 10);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 82 to 97
	value = ((uint32_t)(input[10] & 0x3f) << 26) |
			((uint32_t)input[11] << 18) |
			((uint32_t)(input[12] & 0xc0) << 10);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 98 to 113
	value = ((uint32_t)(input[12] & 0x3f) << 26) |
			((uint32_t)input[13] << 18) |
			((uint32_t)(input[14] & 0xc0) << 10);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 114 to 129
	value = ((uint32_t)(input[14] & 0x3f) << 26) |
			((uint32_t)input[15] << 18) |
			((uint32_t)(input[16] & 0xc0) << 10);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 130 to 145
	value = ((uint32_t)(input[16] & 0x3f) << 26) |
			((uint32_t)input[17] << 18) |
			((uint32_t)(input[18] & 0xc0) << 10);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 146 to 161
	value = ((uint32_t)(input[18] & 0x3f) << 26) |
			((uint32_t)input[19] << 18) |
			((uint32_t)(input[20] & 0xc0) << 10);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 162 to 177
	value = ((uint32_t)(input[20] & 0x3f) << 26) |
			((uint32_t)input[21] << 18) |
			((uint32_t)(input[22] & 0xc0) << 10);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 178 to 193
	value = ((uint32_t)(input[22] & 0x3f) << 26) |
			((uint32_t)input[23] << 18) |
			((uint32_t)(input[24] & 0xc0) << 10);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 194 to 209
	value = ((uint32_t)(input[24] & 0x3f) << 26) |
			((uint32_t)input[25] << 18) |
			((uint32_t)(input[26] & 0xc0) << 10);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 210 to 225
	value = ((uint32_t)(input[26] & 0x3f) << 26) |
			((uint32_t)input[27] << 18) |
			((uint32_t)(input[28] & 0xc0) << 10);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 226 to 241
	value = ((uint32_t)(input[28] & 0x3f) << 26) |
			((uint32_t)input[29] << 18) |
			((uint32_t)(input[30] & 0xc0) << 10);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 242 to 257
	value = ((uint32_t)(input[30] & 0x3f) << 26) |
			((uint32_t)input[31] << 18) |
			((uint32_t)(input[32] & 0xc0) << 10);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 258 to 273
	value = ((uint32_t)(input[32] & 0x3f) << 26) |
			((uint32_t)input[33] << 18) |
			((uint32_t)(input[34] & 0xc0) << 10);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 274 to 289
	value = ((uint32_t)(input[34] & 0x3f) << 26) |
			((uint32_t)input[35] << 18) |
			((uint32_t)(input[36] & 0xc0) << 10);
	output[17] = (double)(value >> 16);
}

static void unpack_18_16bit_signed_3off(const uint8_t * input, double * output, void *closure) {
	// Unpack 18 values into output
	// Values are 16-bit signed
	// Skip 3 bits, read 288 bits of data.
	// Input must be at least 37 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 3 to 18
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)input[1] << 19) |
			((uint32_t)(input[2] & 0xe0) << 11);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 19 to 34
	value = ((uint32_t)(input[2] & 0x1f) << 27) |
			((uint32_t)input[3] << 19) |
			((uint32_t)(input[4] & 0xe0) << 11);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 35 to 50
	value = ((uint32_t)(input[4] & 0x1f) << 27) |
			((uint32_t)input[5] << 19) |
			((uint32_t)(input[6] & 0xe0) << 11);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 51 to 66
	value = ((uint32_t)(input[6] & 0x1f) << 27) |
			((uint32_t)input[7] << 19) |
			((uint32_t)(input[8] & 0xe0) << 11);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 67 to 82
	value = ((uint32_t)(input[8] & 0x1f) << 27) |
			((uint32_t)input[9] << 19) |
			((uint32_t)(input[10] & 0xe0) << 11);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 83 to 98
	value = ((uint32_t)(input[10] & 0x1f) << 27) |
			((uint32_t)input[11] << 19) |
			((uint32_t)(input[12] & 0xe0) << 11);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 99 to 114
	value = ((uint32_t)(input[12] & 0x1f) << 27) |
			((uint32_t)input[13] << 19) |
			((uint32_t)(input[14] & 0xe0) << 11);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 115 to 130
	value = ((uint32_t)(input[14] & 0x1f) << 27) |
			((uint32_t)input[15] << 19) |
			((uint32_t)(input[16] & 0xe0) << 11);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 131 to 146
	value = ((uint32_t)(input[16] & 0x1f) << 27) |
			((uint32_t)input[17] << 19) |
			((uint32_t)(input[18] & 0xe0) << 11);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 147 to 162
	value = ((uint32_t)(input[18] & 0x1f) << 27) |
			((uint32_t)input[19] << 19) |
			((uint32_t)(input[20] & 0xe0) << 11);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 163 to 178
	value = ((uint32_t)(input[20] & 0x1f) << 27) |
			((uint32_t)input[21] << 19) |
			((uint32_t)(input[22] & 0xe0) << 11);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 179 to 194
	value = ((uint32_t)(input[22] & 0x1f) << 27) |
			((uint32_t)input[23] << 19) |
			((uint32_t)(input[24] & 0xe0) << 11);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 195 to 210
	value = ((uint32_t)(input[24] & 0x1f) << 27) |
			((uint32_t)input[25] << 19) |
			((uint32_t)(input[26] & 0xe0) << 11);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 211 to 226
	value = ((uint32_t)(input[26] & 0x1f) << 27) |
			((uint32_t)input[27] << 19) |
			((uint32_t)(input[28] & 0xe0) << 11);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 227 to 242
	value = ((uint32_t)(input[28] & 0x1f) << 27) |
			((uint32_t)input[29] << 19) |
			((uint32_t)(input[30] & 0xe0) << 11);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 243 to 258
	value = ((uint32_t)(input[30] & 0x1f) << 27) |
			((uint32_t)input[31] << 19) |
			((uint32_t)(input[32] & 0xe0) << 11);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 259 to 274
	value = ((uint32_t)(input[32] & 0x1f) << 27) |
			((uint32_t)input[33] << 19) |
			((uint32_t)(input[34] & 0xe0) << 11);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 275 to 290
	value = ((uint32_t)(input[34] & 0x1f) << 27) |
			((uint32_t)input[35] << 19) |
			((uint32_t)(input[36] & 0xe0) << 11);
	output[17] = (double)(value >> 16);
}

static void unpack_18_16bit_unsigned_3off(const uint8_t * input, double * output, void *closure) {
	// Unpack 18 values into output
	// Values are 16-bit unsigned
	// Skip 3 bits, read 288 bits of data.
	// Input must be at least 37 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 3 to 18
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)input[1] << 19) |
			((uint32_t)(input[2] & 0xe0) << 11);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 19 to 34
	value = ((uint32_t)(input[2] & 0x1f) << 27) |
			((uint32_t)input[3] << 19) |
			((uint32_t)(input[4] & 0xe0) << 11);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 35 to 50
	value = ((uint32_t)(input[4] & 0x1f) << 27) |
			((uint32_t)input[5] << 19) |
			((uint32_t)(input[6] & 0xe0) << 11);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 51 to 66
	value = ((uint32_t)(input[6] & 0x1f) << 27) |
			((uint32_t)input[7] << 19) |
			((uint32_t)(input[8] & 0xe0) << 11);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 67 to 82
	value = ((uint32_t)(input[8] & 0x1f) << 27) |
			((uint32_t)input[9] << 19) |
			((uint32_t)(input[10] & 0xe0) << 11);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 83 to 98
	value = ((uint32_t)(input[10] & 0x1f) << 27) |
			((uint32_t)input[11] << 19) |
			((uint32_t)(input[12] & 0xe0) << 11);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 99 to 114
	value = ((uint32_t)(input[12] & 0x1f) << 27) |
			((uint32_t)input[13] << 19) |
			((uint32_t)(input[14] & 0xe0) << 11);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 115 to 130
	value = ((uint32_t)(input[14] & 0x1f) << 27) |
			((uint32_t)input[15] << 19) |
			((uint32_t)(input[16] & 0xe0) << 11);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 131 to 146
	value = ((uint32_t)(input[16] & 0x1f) << 27) |
			((uint32_t)input[17] << 19) |
			((uint32_t)(input[18] & 0xe0) << 11);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 147 to 162
	value = ((uint32_t)(input[18] & 0x1f) << 27) |
			((uint32_t)input[19] << 19) |
			((uint32_t)(input[20] & 0xe0) << 11);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 163 to 178
	value = ((uint32_t)(input[20] & 0x1f) << 27) |
			((uint32_t)input[21] << 19) |
			((uint32_t)(input[22] & 0xe0) << 11);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 179 to 194
	value = ((uint32_t)(input[22] & 0x1f) << 27) |
			((uint32_t)input[23] << 19) |
			((uint32_t)(input[24] & 0xe0) << 11);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 195 to 210
	value = ((uint32_t)(input[24] & 0x1f) << 27) |
			((uint32_t)input[25] << 19) |
			((uint32_t)(input[26] & 0xe0) << 11);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 211 to 226
	value = ((uint32_t)(input[26] & 0x1f) << 27) |
			((uint32_t)input[27] << 19) |
			((uint32_t)(input[28] & 0xe0) << 11);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 227 to 242
	value = ((uint32_t)(input[28] & 0x1f) << 27) |
			((uint32_t)input[29] << 19) |
			((uint32_t)(input[30] & 0xe0) << 11);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 243 to 258
	value = ((uint32_t)(input[30] & 0x1f) << 27) |
			((uint32_t)input[31] << 19) |
			((uint32_t)(input[32] & 0xe0) << 11);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 259 to 274
	value = ((uint32_t)(input[32] & 0x1f) << 27) |
			((uint32_t)input[33] << 19) |
			((uint32_t)(input[34] & 0xe0) << 11);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 275 to 290
	value = ((uint32_t)(input[34] & 0x1f) << 27) |
			((uint32_t)input[35] << 19) |
			((uint32_t)(input[36] & 0xe0) << 11);
	output[17] = (double)(value >> 16);
}

static void unpack_18_16bit_signed_4off(const uint8_t * input, double * output, void *closure) {
	// Unpack 18 values into output
	// Values are 16-bit signed
	// Skip 4 bits, read 288 bits of data.
	// Input must be at least 37 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 4 to 19
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20) |
			((uint32_t)(input[2] & 0xf0) << 12);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 20 to 35
	value = ((uint32_t)(input[2] & 0x0f) << 28) |
			((uint32_t)input[3] << 20) |
			((uint32_t)(input[4] & 0xf0) << 12);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 36 to 51
	value = ((uint32_t)(input[4] & 0x0f) << 28) |
			((uint32_t)input[5] << 20) |
			((uint32_t)(input[6] & 0xf0) << 12);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 52 to 67
	value = ((uint32_t)(input[6] & 0x0f) << 28) |
			((uint32_t)input[7] << 20) |
			((uint32_t)(input[8] & 0xf0) << 12);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 68 to 83
	value = ((uint32_t)(input[8] & 0x0f) << 28) |
			((uint32_t)input[9] << 20) |
			((uint32_t)(input[10] & 0xf0) << 12);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 84 to 99
	value = ((uint32_t)(input[10] & 0x0f) << 28) |
			((uint32_t)input[11] << 20) |
			((uint32_t)(input[12] & 0xf0) << 12);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 100 to 115
	value = ((uint32_t)(input[12] & 0x0f) << 28) |
			((uint32_t)input[13] << 20) |
			((uint32_t)(input[14] & 0xf0) << 12);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 116 to 131
	value = ((uint32_t)(input[14] & 0x0f) << 28) |
			((uint32_t)input[15] << 20) |
			((uint32_t)(input[16] & 0xf0) << 12);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 132 to 147
	value = ((uint32_t)(input[16] & 0x0f) << 28) |
			((uint32_t)input[17] << 20) |
			((uint32_t)(input[18] & 0xf0) << 12);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 148 to 163
	value = ((uint32_t)(input[18] & 0x0f) << 28) |
			((uint32_t)input[19] << 20) |
			((uint32_t)(input[20] & 0xf0) << 12);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 164 to 179
	value = ((uint32_t)(input[20] & 0x0f) << 28) |
			((uint32_t)input[21] << 20) |
			((uint32_t)(input[22] & 0xf0) << 12);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 180 to 195
	value = ((uint32_t)(input[22] & 0x0f) << 28) |
			((uint32_t)input[23] << 20) |
			((uint32_t)(input[24] & 0xf0) << 12);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 196 to 211
	value = ((uint32_t)(input[24] & 0x0f) << 28) |
			((uint32_t)input[25] << 20) |
			((uint32_t)(input[26] & 0xf0) << 12);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 212 to 227
	value = ((uint32_t)(input[26] & 0x0f) << 28) |
			((uint32_t)input[27] << 20) |
			((uint32_t)(input[28] & 0xf0) << 12);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 228 to 243
	value = ((uint32_t)(input[28] & 0x0f) << 28) |
			((uint32_t)input[29] << 20) |
			((uint32_t)(input[30] & 0xf0) << 12);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 244 to 259
	value = ((uint32_t)(input[30] & 0x0f) << 28) |
			((uint32_t)input[31] << 20) |
			((uint32_t)(input[32] & 0xf0) << 12);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 260 to 275
	value = ((uint32_t)(input[32] & 0x0f) << 28) |
			((uint32_t)input[33] << 20) |
			((uint32_t)(input[34] & 0xf0) << 12);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 276 to 291
	value = ((uint32_t)(input[34] & 0x0f) << 28) |
			((uint32_t)input[35] << 20) |
			((uint32_t)(input[36] & 0xf0) << 12);
	output[17] = (double)(value >> 16);
}

static void unpack_18_16bit_unsigned_4off(const uint8_t * input, double * output, void *closure) {
	// Unpack 18 values into output
	// Values are 16-bit unsigned
	// Skip 4 bits, read 288 bits of data.
	// Input must be at least 37 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 4 to 19
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20) |
			((uint32_t)(input[2] & 0xf0) << 12);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 20 to 35
	value = ((uint32_t)(input[2] & 0x0f) << 28) |
			((uint32_t)input[3] << 20) |
			((uint32_t)(input[4] & 0xf0) << 12);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 36 to 51
	value = ((uint32_t)(input[4] & 0x0f) << 28) |
			((uint32_t)input[5] << 20) |
			((uint32_t)(input[6] & 0xf0) << 12);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 52 to 67
	value = ((uint32_t)(input[6] & 0x0f) << 28) |
			((uint32_t)input[7] << 20) |
			((uint32_t)(input[8] & 0xf0) << 12);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 68 to 83
	value = ((uint32_t)(input[8] & 0x0f) << 28) |
			((uint32_t)input[9] << 20) |
			((uint32_t)(input[10] & 0xf0) << 12);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 84 to 99
	value = ((uint32_t)(input[10] & 0x0f) << 28) |
			((uint32_t)input[11] << 20) |
			((uint32_t)(input[12] & 0xf0) << 12);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 100 to 115
	value = ((uint32_t)(input[12] & 0x0f) << 28) |
			((uint32_t)input[13] << 20) |
			((uint32_t)(input[14] & 0xf0) << 12);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 116 to 131
	value = ((uint32_t)(input[14] & 0x0f) << 28) |
			((uint32_t)input[15] << 20) |
			((uint32_t)(input[16] & 0xf0) << 12);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 132 to 147
	value = ((uint32_t)(input[16] & 0x0f) << 28) |
			((uint32_t)input[17] << 20) |
			((uint32_t)(input[18] & 0xf0) << 12);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 148 to 163
	value = ((uint32_t)(input[18] & 0x0f) << 28) |
			((uint32_t)input[19] << 20) |
			((uint32_t)(input[20] & 0xf0) << 12);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 164 to 179
	value = ((uint32_t)(input[20] & 0x0f) << 28) |
			((uint32_t)input[21] << 20) |
			((uint32_t)(input[22] & 0xf0) << 12);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 180 to 195
	value = ((uint32_t)(input[22] & 0x0f) << 28) |
			((uint32_t)input[23] << 20) |
			((uint32_t)(input[24] & 0xf0) << 12);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 196 to 211
	value = ((uint32_t)(input[24] & 0x0f) << 28) |
			((uint32_t)input[25] << 20) |
			((uint32_t)(input[26] & 0xf0) << 12);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 212 to 227
	value = ((uint32_t)(input[26] & 0x0f) << 28) |
			((uint32_t)input[27] << 20) |
			((uint32_t)(input[28] & 0xf0) << 12);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 228 to 243
	value = ((uint32_t)(input[28] & 0x0f) << 28) |
			((uint32_t)input[29] << 20) |
			((uint32_t)(input[30] & 0xf0) << 12);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 244 to 259
	value = ((uint32_t)(input[30] & 0x0f) << 28) |
			((uint32_t)input[31] << 20) |
			((uint32_t)(input[32] & 0xf0) << 12);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 260 to 275
	value = ((uint32_t)(input[32] & 0x0f) << 28) |
			((uint32_t)input[33] << 20) |
			((uint32_t)(input[34] & 0xf0) << 12);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 276 to 291
	value = ((uint32_t)(input[34] & 0x0f) << 28) |
			((uint32_t)input[35] << 20) |
			((uint32_t)(input[36] & 0xf0) << 12);
	output[17] = (double)(value >> 16);
}

static void unpack_18_16bit_signed_5off(const uint8_t * input, double * output, void *closure) {
	// Unpack 18 values into output
	// Values are 16-bit signed
	// Skip 5 bits, read 288 bits of data.
	// Input must be at least 37 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 5 to 20
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)(input[2] & 0xf8) << 13);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 21 to 36
	value = ((uint32_t)(input[2] & 0x07) << 29) |
			((uint32_t)input[3] << 21) |
			((uint32_t)(input[4] & 0xf8) << 13);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 37 to 52
	value = ((uint32_t)(input[4] & 0x07) << 29) |
			((uint32_t)input[5] << 21) |
			((uint32_t)(input[6] & 0xf8) << 13);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 53 to 68
	value = ((uint32_t)(input[6] & 0x07) << 29) |
			((uint32_t)input[7] << 21) |
			((uint32_t)(input[8] & 0xf8) << 13);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 69 to 84
	value = ((uint32_t)(input[8] & 0x07) << 29) |
			((uint32_t)input[9] << 21) |
			((uint32_t)(input[10] & 0xf8) << 13);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 85 to 100
	value = ((uint32_t)(input[10] & 0x07) << 29) |
			((uint32_t)input[11] << 21) |
			((uint32_t)(input[12] & 0xf8) << 13);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 101 to 116
	value = ((uint32_t)(input[12] & 0x07) << 29) |
			((uint32_t)input[13] << 21) |
			((uint32_t)(input[14] & 0xf8) << 13);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 117 to 132
	value = ((uint32_t)(input[14] & 0x07) << 29) |
			((uint32_t)input[15] << 21) |
			((uint32_t)(input[16] & 0xf8) << 13);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 133 to 148
	value = ((uint32_t)(input[16] & 0x07) << 29) |
			((uint32_t)input[17] << 21) |
			((uint32_t)(input[18] & 0xf8) << 13);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 149 to 164
	value = ((uint32_t)(input[18] & 0x07) << 29) |
			((uint32_t)input[19] << 21) |
			((uint32_t)(input[20] & 0xf8) << 13);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 165 to 180
	value = ((uint32_t)(input[20] & 0x07) << 29) |
			((uint32_t)input[21] << 21) |
			((uint32_t)(input[22] & 0xf8) << 13);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 181 to 196
	value = ((uint32_t)(input[22] & 0x07) << 29) |
			((uint32_t)input[23] << 21) |
			((uint32_t)(input[24] & 0xf8) << 13);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 197 to 212
	value = ((uint32_t)(input[24] & 0x07) << 29) |
			((uint32_t)input[25] << 21) |
			((uint32_t)(input[26] & 0xf8) << 13);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 213 to 228
	value = ((uint32_t)(input[26] & 0x07) << 29) |
			((uint32_t)input[27] << 21) |
			((uint32_t)(input[28] & 0xf8) << 13);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 229 to 244
	value = ((uint32_t)(input[28] & 0x07) << 29) |
			((uint32_t)input[29] << 21) |
			((uint32_t)(input[30] & 0xf8) << 13);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 245 to 260
	value = ((uint32_t)(input[30] & 0x07) << 29) |
			((uint32_t)input[31] << 21) |
			((uint32_t)(input[32] & 0xf8) << 13);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 261 to 276
	value = ((uint32_t)(input[32] & 0x07) << 29) |
			((uint32_t)input[33] << 21) |
			((uint32_t)(input[34] & 0xf8) << 13);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 277 to 292
	value = ((uint32_t)(input[34] & 0x07) << 29) |
			((uint32_t)input[35] << 21) |
			((uint32_t)(input[36] & 0xf8) << 13);
	output[17] = (double)(value >> 16);
}

static void unpack_18_16bit_unsigned_5off(const uint8_t * input, double * output, void *closure) {
	// Unpack 18 values into output
	// Values are 16-bit unsigned
	// Skip 5 bits, read 288 bits of data.
	// Input must be at least 37 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 5 to 20
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)(input[2] & 0xf8) << 13);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 21 to 36
	value = ((uint32_t)(input[2] & 0x07) << 29) |
			((uint32_t)input[3] << 21) |
			((uint32_t)(input[4] & 0xf8) << 13);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 37 to 52
	value = ((uint32_t)(input[4] & 0x07) << 29) |
			((uint32_t)input[5] << 21) |
			((uint32_t)(input[6] & 0xf8) << 13);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 53 to 68
	value = ((uint32_t)(input[6] & 0x07) << 29) |
			((uint32_t)input[7] << 21) |
			((uint32_t)(input[8] & 0xf8) << 13);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 69 to 84
	value = ((uint32_t)(input[8] & 0x07) << 29) |
			((uint32_t)input[9] << 21) |
			((uint32_t)(input[10] & 0xf8) << 13);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 85 to 100
	value = ((uint32_t)(input[10] & 0x07) << 29) |
			((uint32_t)input[11] << 21) |
			((uint32_t)(input[12] & 0xf8) << 13);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 101 to 116
	value = ((uint32_t)(input[12] & 0x07) << 29) |
			((uint32_t)input[13] << 21) |
			((uint32_t)(input[14] & 0xf8) << 13);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 117 to 132
	value = ((uint32_t)(input[14] & 0x07) << 29) |
			((uint32_t)input[15] << 21) |
			((uint32_t)(input[16] & 0xf8) << 13);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 133 to 148
	value = ((uint32_t)(input[16] & 0x07) << 29) |
			((uint32_t)input[17] << 21) |
			((uint32_t)(input[18] & 0xf8) << 13);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 149 to 164
	value = ((uint32_t)(input[18] & 0x07) << 29) |
			((uint32_t)input[19] << 21) |
			((uint32_t)(input[20] & 0xf8) << 13);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 165 to 180
	value = ((uint32_t)(input[20] & 0x07) << 29) |
			((uint32_t)input[21] << 21) |
			((uint32_t)(input[22] & 0xf8) << 13);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 181 to 196
	value = ((uint32_t)(input[22] & 0x07) << 29) |
			((uint32_t)input[23] << 21) |
			((uint32_t)(input[24] & 0xf8) << 13);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 197 to 212
	value = ((uint32_t)(input[24] & 0x07) << 29) |
			((uint32_t)input[25] << 21) |
			((uint32_t)(input[26] & 0xf8) << 13);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 213 to 228
	value = ((uint32_t)(input[26] & 0x07) << 29) |
			((uint32_t)input[27] << 21) |
			((uint32_t)(input[28] & 0xf8) << 13);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 229 to 244
	value = ((uint32_t)(input[28] & 0x07) << 29) |
			((uint32_t)input[29] << 21) |
			((uint32_t)(input[30] & 0xf8) << 13);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 245 to 260
	value = ((uint32_t)(input[30] & 0x07) << 29) |
			((uint32_t)input[31] << 21) |
			((uint32_t)(input[32] & 0xf8) << 13);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 261 to 276
	value = ((uint32_t)(input[32] & 0x07) << 29) |
			((uint32_t)input[33] << 21) |
			((uint32_t)(input[34] & 0xf8) << 13);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 277 to 292
	value = ((uint32_t)(input[34] & 0x07) << 29) |
			((uint32_t)input[35] << 21) |
			((uint32_t)(input[36] & 0xf8) << 13);
	output[17] = (double)(value >> 16);
}

static void unpack_18_16bit_signed_6off(const uint8_t * input, double * output, void *closure) {
	// Unpack 18 values into output
	// Values are 16-bit signed
	// Skip 6 bits, read 288 bits of data.
	// Input must be at least 37 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 6 to 21
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)(input[2] & 0xfc) << 14);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 22 to 37
	value = ((uint32_t)(input[2] & 0x03) << 30) |
			((uint32_t)input[3] << 22) |
			((uint32_t)(input[4] & 0xfc) << 14);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 38 to 53
	value = ((uint32_t)(input[4] & 0x03) << 30) |
			((uint32_t)input[5] << 22) |
			((uint32_t)(input[6] & 0xfc) << 14);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 54 to 69
	value = ((uint32_t)(input[6] & 0x03) << 30) |
			((uint32_t)input[7] << 22) |
			((uint32_t)(input[8] & 0xfc) << 14);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 70 to 85
	value = ((uint32_t)(input[8] & 0x03) << 30) |
			((uint32_t)input[9] << 22) |
			((uint32_t)(input[10] & 0xfc) << 14);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 86 to 101
	value = ((uint32_t)(input[10] & 0x03) << 30) |
			((uint32_t)input[11] << 22) |
			((uint32_t)(input[12] & 0xfc) << 14);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 102 to 117
	value = ((uint32_t)(input[12] & 0x03) << 30) |
			((uint32_t)input[13] << 22) |
			((uint32_t)(input[14] & 0xfc) << 14);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 118 to 133
	value = ((uint32_t)(input[14] & 0x03) << 30) |
			((uint32_t)input[15] << 22) |
			((uint32_t)(input[16] & 0xfc) << 14);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 134 to 149
	value = ((uint32_t)(input[16] & 0x03) << 30) |
			((uint32_t)input[17] << 22) |
			((uint32_t)(input[18] & 0xfc) << 14);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 150 to 165
	value = ((uint32_t)(input[18] & 0x03) << 30) |
			((uint32_t)input[19] << 22) |
			((uint32_t)(input[20] & 0xfc) << 14);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 166 to 181
	value = ((uint32_t)(input[20] & 0x03) << 30) |
			((uint32_t)input[21] << 22) |
			((uint32_t)(input[22] & 0xfc) << 14);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 182 to 197
	value = ((uint32_t)(input[22] & 0x03) << 30) |
			((uint32_t)input[23] << 22) |
			((uint32_t)(input[24] & 0xfc) << 14);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 198 to 213
	value = ((uint32_t)(input[24] & 0x03) << 30) |
			((uint32_t)input[25] << 22) |
			((uint32_t)(input[26] & 0xfc) << 14);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 214 to 229
	value = ((uint32_t)(input[26] & 0x03) << 30) |
			((uint32_t)input[27] << 22) |
			((uint32_t)(input[28] & 0xfc) << 14);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 230 to 245
	value = ((uint32_t)(input[28] & 0x03) << 30) |
			((uint32_t)input[29] << 22) |
			((uint32_t)(input[30] & 0xfc) << 14);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 246 to 261
	value = ((uint32_t)(input[30] & 0x03) << 30) |
			((uint32_t)input[31] << 22) |
			((uint32_t)(input[32] & 0xfc) << 14);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 262 to 277
	value = ((uint32_t)(input[32] & 0x03) << 30) |
			((uint32_t)input[33] << 22) |
			((uint32_t)(input[34] & 0xfc) << 14);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 278 to 293
	value = ((uint32_t)(input[34] & 0x03) << 30) |
			((uint32_t)input[35] << 22) |
			((uint32_t)(input[36] & 0xfc) << 14);
	output[17] = (double)(value >> 16);
}

static void unpack_18_16bit_unsigned_6off(const uint8_t * input, double * output, void *closure) {
	// Unpack 18 values into output
	// Values are 16-bit unsigned
	// Skip 6 bits, read 288 bits of data.
	// Input must be at least 37 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 6 to 21
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)(input[2] & 0xfc) << 14);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 22 to 37
	value = ((uint32_t)(input[2] & 0x03) << 30) |
			((uint32_t)input[3] << 22) |
			((uint32_t)(input[4] & 0xfc) << 14);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 38 to 53
	value = ((uint32_t)(input[4] & 0x03) << 30) |
			((uint32_t)input[5] << 22) |
			((uint32_t)(input[6] & 0xfc) << 14);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 54 to 69
	value = ((uint32_t)(input[6] & 0x03) << 30) |
			((uint32_t)input[7] << 22) |
			((uint32_t)(input[8] & 0xfc) << 14);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 70 to 85
	value = ((uint32_t)(input[8] & 0x03) << 30) |
			((uint32_t)input[9] << 22) |
			((uint32_t)(input[10] & 0xfc) << 14);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 86 to 101
	value = ((uint32_t)(input[10] & 0x03) << 30) |
			((uint32_t)input[11] << 22) |
			((uint32_t)(input[12] & 0xfc) << 14);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 102 to 117
	value = ((uint32_t)(input[12] & 0x03) << 30) |
			((uint32_t)input[13] << 22) |
			((uint32_t)(input[14] & 0xfc) << 14);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 118 to 133
	value = ((uint32_t)(input[14] & 0x03) << 30) |
			((uint32_t)input[15] << 22) |
			((uint32_t)(input[16] & 0xfc) << 14);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 134 to 149
	value = ((uint32_t)(input[16] & 0x03) << 30) |
			((uint32_t)input[17] << 22) |
			((uint32_t)(input[18] & 0xfc) << 14);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 150 to 165
	value = ((uint32_t)(input[18] & 0x03) << 30) |
			((uint32_t)input[19] << 22) |
			((uint32_t)(input[20] & 0xfc) << 14);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 166 to 181
	value = ((uint32_t)(input[20] & 0x03) << 30) |
			((uint32_t)input[21] << 22) |
			((uint32_t)(input[22] & 0xfc) << 14);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 182 to 197
	value = ((uint32_t)(input[22] & 0x03) << 30) |
			((uint32_t)input[23] << 22) |
			((uint32_t)(input[24] & 0xfc) << 14);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 198 to 213
	value = ((uint32_t)(input[24] & 0x03) << 30) |
			((uint32_t)input[25] << 22) |
			((uint32_t)(input[26] & 0xfc) << 14);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 214 to 229
	value = ((uint32_t)(input[26] & 0x03) << 30) |
			((uint32_t)input[27] << 22) |
			((uint32_t)(input[28] & 0xfc) << 14);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 230 to 245
	value = ((uint32_t)(input[28] & 0x03) << 30) |
			((uint32_t)input[29] << 22) |
			((uint32_t)(input[30] & 0xfc) << 14);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 246 to 261
	value = ((uint32_t)(input[30] & 0x03) << 30) |
			((uint32_t)input[31] << 22) |
			((uint32_t)(input[32] & 0xfc) << 14);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 262 to 277
	value = ((uint32_t)(input[32] & 0x03) << 30) |
			((uint32_t)input[33] << 22) |
			((uint32_t)(input[34] & 0xfc) << 14);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 278 to 293
	value = ((uint32_t)(input[34] & 0x03) << 30) |
			((uint32_t)input[35] << 22) |
			((uint32_t)(input[36] & 0xfc) << 14);
	output[17] = (double)(value >> 16);
}

static void unpack_18_16bit_signed_7off(const uint8_t * input, double * output, void *closure) {
	// Unpack 18 values into output
	// Values are 16-bit signed
	// Skip 7 bits, read 288 bits of data.
	// Input must be at least 37 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 7 to 22
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)(input[2] & 0xfe) << 15);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 23 to 38
	value = ((uint32_t)(input[2] & 0x01) << 31) |
			((uint32_t)input[3] << 23) |
			((uint32_t)(input[4] & 0xfe) << 15);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 39 to 54
	value = ((uint32_t)(input[4] & 0x01) << 31) |
			((uint32_t)input[5] << 23) |
			((uint32_t)(input[6] & 0xfe) << 15);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 55 to 70
	value = ((uint32_t)(input[6] & 0x01) << 31) |
			((uint32_t)input[7] << 23) |
			((uint32_t)(input[8] & 0xfe) << 15);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 71 to 86
	value = ((uint32_t)(input[8] & 0x01) << 31) |
			((uint32_t)input[9] << 23) |
			((uint32_t)(input[10] & 0xfe) << 15);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 87 to 102
	value = ((uint32_t)(input[10] & 0x01) << 31) |
			((uint32_t)input[11] << 23) |
			((uint32_t)(input[12] & 0xfe) << 15);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 103 to 118
	value = ((uint32_t)(input[12] & 0x01) << 31) |
			((uint32_t)input[13] << 23) |
			((uint32_t)(input[14] & 0xfe) << 15);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 119 to 134
	value = ((uint32_t)(input[14] & 0x01) << 31) |
			((uint32_t)input[15] << 23) |
			((uint32_t)(input[16] & 0xfe) << 15);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 135 to 150
	value = ((uint32_t)(input[16] & 0x01) << 31) |
			((uint32_t)input[17] << 23) |
			((uint32_t)(input[18] & 0xfe) << 15);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 151 to 166
	value = ((uint32_t)(input[18] & 0x01) << 31) |
			((uint32_t)input[19] << 23) |
			((uint32_t)(input[20] & 0xfe) << 15);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 167 to 182
	value = ((uint32_t)(input[20] & 0x01) << 31) |
			((uint32_t)input[21] << 23) |
			((uint32_t)(input[22] & 0xfe) << 15);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 183 to 198
	value = ((uint32_t)(input[22] & 0x01) << 31) |
			((uint32_t)input[23] << 23) |
			((uint32_t)(input[24] & 0xfe) << 15);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 199 to 214
	value = ((uint32_t)(input[24] & 0x01) << 31) |
			((uint32_t)input[25] << 23) |
			((uint32_t)(input[26] & 0xfe) << 15);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 215 to 230
	value = ((uint32_t)(input[26] & 0x01) << 31) |
			((uint32_t)input[27] << 23) |
			((uint32_t)(input[28] & 0xfe) << 15);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 231 to 246
	value = ((uint32_t)(input[28] & 0x01) << 31) |
			((uint32_t)input[29] << 23) |
			((uint32_t)(input[30] & 0xfe) << 15);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 247 to 262
	value = ((uint32_t)(input[30] & 0x01) << 31) |
			((uint32_t)input[31] << 23) |
			((uint32_t)(input[32] & 0xfe) << 15);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 263 to 278
	value = ((uint32_t)(input[32] & 0x01) << 31) |
			((uint32_t)input[33] << 23) |
			((uint32_t)(input[34] & 0xfe) << 15);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 279 to 294
	value = ((uint32_t)(input[34] & 0x01) << 31) |
			((uint32_t)input[35] << 23) |
			((uint32_t)(input[36] & 0xfe) << 15);
	output[17] = (double)(value >> 16);
}

static void unpack_18_16bit_unsigned_7off(const uint8_t * input, double * output, void *closure) {
	// Unpack 18 values into output
	// Values are 16-bit unsigned
	// Skip 7 bits, read 288 bits of data.
	// Input must be at least 37 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 7 to 22
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)(input[2] & 0xfe) << 15);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 23 to 38
	value = ((uint32_t)(input[2] & 0x01) << 31) |
			((uint32_t)input[3] << 23) |
			((uint32_t)(input[4] & 0xfe) << 15);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 39 to 54
	value = ((uint32_t)(input[4] & 0x01) << 31) |
			((uint32_t)input[5] << 23) |
			((uint32_t)(input[6] & 0xfe) << 15);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 55 to 70
	value = ((uint32_t)(input[6] & 0x01) << 31) |
			((uint32_t)input[7] << 23) |
			((uint32_t)(input[8] & 0xfe) << 15);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 71 to 86
	value = ((uint32_t)(input[8] & 0x01) << 31) |
			((uint32_t)input[9] << 23) |
			((uint32_t)(input[10] & 0xfe) << 15);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 87 to 102
	value = ((uint32_t)(input[10] & 0x01) << 31) |
			((uint32_t)input[11] << 23) |
			((uint32_t)(input[12] & 0xfe) << 15);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 103 to 118
	value = ((uint32_t)(input[12] & 0x01) << 31) |
			((uint32_t)input[13] << 23) |
			((uint32_t)(input[14] & 0xfe) << 15);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 119 to 134
	value = ((uint32_t)(input[14] & 0x01) << 31) |
			((uint32_t)input[15] << 23) |
			((uint32_t)(input[16] & 0xfe) << 15);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 135 to 150
	value = ((uint32_t)(input[16] & 0x01) << 31) |
			((uint32_t)input[17] << 23) |
			((uint32_t)(input[18] & 0xfe) << 15);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 151 to 166
	value = ((uint32_t)(input[18] & 0x01) << 31) |
			((uint32_t)input[19] << 23) |
			((uint32_t)(input[20] & 0xfe) << 15);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 167 to 182
	value = ((uint32_t)(input[20] & 0x01) << 31) |
			((uint32_t)input[21] << 23) |
			((uint32_t)(input[22] & 0xfe) << 15);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 183 to 198
	value = ((uint32_t)(input[22] & 0x01) << 31) |
			((uint32_t)input[23] << 23) |
			((uint32_t)(input[24] & 0xfe) << 15);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 199 to 214
	value = ((uint32_t)(input[24] & 0x01) << 31) |
			((uint32_t)input[25] << 23) |
			((uint32_t)(input[26] & 0xfe) << 15);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 215 to 230
	value = ((uint32_t)(input[26] & 0x01) << 31) |
			((uint32_t)input[27] << 23) |
			((uint32_t)(input[28] & 0xfe) << 15);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 231 to 246
	value = ((uint32_t)(input[28] & 0x01) << 31) |
			((uint32_t)input[29] << 23) |
			((uint32_t)(input[30] & 0xfe) << 15);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 247 to 262
	value = ((uint32_t)(input[30] & 0x01) << 31) |
			((uint32_t)input[31] << 23) |
			((uint32_t)(input[32] & 0xfe) << 15);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 263 to 278
	value = ((uint32_t)(input[32] & 0x01) << 31) |
			((uint32_t)input[33] << 23) |
			((uint32_t)(input[34] & 0xfe) << 15);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 279 to 294
	value = ((uint32_t)(input[34] & 0x01) << 31) |
			((uint32_t)input[35] << 23) |
			((uint32_t)(input[36] & 0xfe) << 15);
	output[17] = (double)(value >> 16);
}

static void unpack_19_16bit_signed_0off(const uint8_t * input, double * output, void *closure) {
	// Unpack 19 values into output
	// Values are 16-bit signed
	// Skip 0 bits, read 304 bits of data.
	// Input must be at least 38 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 0 to 15
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)input[1] << 16);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 16 to 31
	value = ((uint32_t)input[2] << 24) |
			((uint32_t)input[3] << 16);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 32 to 47
	value = ((uint32_t)input[4] << 24) |
			((uint32_t)input[5] << 16);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 48 to 63
	value = ((uint32_t)input[6] << 24) |
			((uint32_t)input[7] << 16);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 64 to 79
	value = ((uint32_t)input[8] << 24) |
			((uint32_t)input[9] << 16);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 80 to 95
	value = ((uint32_t)input[10] << 24) |
			((uint32_t)input[11] << 16);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 96 to 111
	value = ((uint32_t)input[12] << 24) |
			((uint32_t)input[13] << 16);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 112 to 127
	value = ((uint32_t)input[14] << 24) |
			((uint32_t)input[15] << 16);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 128 to 143
	value = ((uint32_t)input[16] << 24) |
			((uint32_t)input[17] << 16);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 144 to 159
	value = ((uint32_t)input[18] << 24) |
			((uint32_t)input[19] << 16);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 160 to 175
	value = ((uint32_t)input[20] << 24) |
			((uint32_t)input[21] << 16);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 176 to 191
	value = ((uint32_t)input[22] << 24) |
			((uint32_t)input[23] << 16);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 192 to 207
	value = ((uint32_t)input[24] << 24) |
			((uint32_t)input[25] << 16);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 208 to 223
	value = ((uint32_t)input[26] << 24) |
			((uint32_t)input[27] << 16);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 224 to 239
	value = ((uint32_t)input[28] << 24) |
			((uint32_t)input[29] << 16);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 240 to 255
	value = ((uint32_t)input[30] << 24) |
			((uint32_t)input[31] << 16);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 256 to 271
	value = ((uint32_t)input[32] << 24) |
			((uint32_t)input[33] << 16);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 272 to 287
	value = ((uint32_t)input[34] << 24) |
			((uint32_t)input[35] << 16);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 288 to 303
	value = ((uint32_t)input[36] << 24) |
			((uint32_t)input[37] << 16);
	output[18] = (double)(value >> 16);
}

static void unpack_19_16bit_unsigned_0off(const uint8_t * input, double * output, void *closure) {
	// Unpack 19 values into output
	// Values are 16-bit unsigned
	// Skip 0 bits, read 304 bits of data.
	// Input must be at least 38 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 0 to 15
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)input[1] << 16);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 16 to 31
	value = ((uint32_t)input[2] << 24) |
			((uint32_t)input[3] << 16);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 32 to 47
	value = ((uint32_t)input[4] << 24) |
			((uint32_t)input[5] << 16);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 48 to 63
	value = ((uint32_t)input[6] << 24) |
			((uint32_t)input[7] << 16);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 64 to 79
	value = ((uint32_t)input[8] << 24) |
			((uint32_t)input[9] << 16);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 80 to 95
	value = ((uint32_t)input[10] << 24) |
			((uint32_t)input[11] << 16);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 96 to 111
	value = ((uint32_t)input[12] << 24) |
			((uint32_t)input[13] << 16);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 112 to 127
	value = ((uint32_t)input[14] << 24) |
			((uint32_t)input[15] << 16);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 128 to 143
	value = ((uint32_t)input[16] << 24) |
			((uint32_t)input[17] << 16);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 144 to 159
	value = ((uint32_t)input[18] << 24) |
			((uint32_t)input[19] << 16);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 160 to 175
	value = ((uint32_t)input[20] << 24) |
			((uint32_t)input[21] << 16);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 176 to 191
	value = ((uint32_t)input[22] << 24) |
			((uint32_t)input[23] << 16);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 192 to 207
	value = ((uint32_t)input[24] << 24) |
			((uint32_t)input[25] << 16);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 208 to 223
	value = ((uint32_t)input[26] << 24) |
			((uint32_t)input[27] << 16);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 224 to 239
	value = ((uint32_t)input[28] << 24) |
			((uint32_t)input[29] << 16);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 240 to 255
	value = ((uint32_t)input[30] << 24) |
			((uint32_t)input[31] << 16);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 256 to 271
	value = ((uint32_t)input[32] << 24) |
			((uint32_t)input[33] << 16);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 272 to 287
	value = ((uint32_t)input[34] << 24) |
			((uint32_t)input[35] << 16);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 288 to 303
	value = ((uint32_t)input[36] << 24) |
			((uint32_t)input[37] << 16);
	output[18] = (double)(value >> 16);
}

static void unpack_19_16bit_signed_1off(const uint8_t * input, double * output, void *closure) {
	// Unpack 19 values into output
	// Values are 16-bit signed
	// Skip 1 bits, read 304 bits of data.
	// Input must be at least 39 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 1 to 16
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)input[1] << 17) |
			((uint32_t)(input[2] & 0x80) << 9);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 17 to 32
	value = ((uint32_t)(input[2] & 0x7f) << 25) |
			((uint32_t)input[3] << 17) |
			((uint32_t)(input[4] & 0x80) << 9);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 33 to 48
	value = ((uint32_t)(input[4] & 0x7f) << 25) |
			((uint32_t)input[5] << 17) |
			((uint32_t)(input[6] & 0x80) << 9);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 49 to 64
	value = ((uint32_t)(input[6] & 0x7f) << 25) |
			((uint32_t)input[7] << 17) |
			((uint32_t)(input[8] & 0x80) << 9);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 65 to 80
	value = ((uint32_t)(input[8] & 0x7f) << 25) |
			((uint32_t)input[9] << 17) |
			((uint32_t)(input[10] & 0x80) << 9);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 81 to 96
	value = ((uint32_t)(input[10] & 0x7f) << 25) |
			((uint32_t)input[11] << 17) |
			((uint32_t)(input[12] & 0x80) << 9);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 97 to 112
	value = ((uint32_t)(input[12] & 0x7f) << 25) |
			((uint32_t)input[13] << 17) |
			((uint32_t)(input[14] & 0x80) << 9);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 113 to 128
	value = ((uint32_t)(input[14] & 0x7f) << 25) |
			((uint32_t)input[15] << 17) |
			((uint32_t)(input[16] & 0x80) << 9);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 129 to 144
	value = ((uint32_t)(input[16] & 0x7f) << 25) |
			((uint32_t)input[17] << 17) |
			((uint32_t)(input[18] & 0x80) << 9);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 145 to 160
	value = ((uint32_t)(input[18] & 0x7f) << 25) |
			((uint32_t)input[19] << 17) |
			((uint32_t)(input[20] & 0x80) << 9);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 161 to 176
	value = ((uint32_t)(input[20] & 0x7f) << 25) |
			((uint32_t)input[21] << 17) |
			((uint32_t)(input[22] & 0x80) << 9);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 177 to 192
	value = ((uint32_t)(input[22] & 0x7f) << 25) |
			((uint32_t)input[23] << 17) |
			((uint32_t)(input[24] & 0x80) << 9);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 193 to 208
	value = ((uint32_t)(input[24] & 0x7f) << 25) |
			((uint32_t)input[25] << 17) |
			((uint32_t)(input[26] & 0x80) << 9);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 209 to 224
	value = ((uint32_t)(input[26] & 0x7f) << 25) |
			((uint32_t)input[27] << 17) |
			((uint32_t)(input[28] & 0x80) << 9);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 225 to 240
	value = ((uint32_t)(input[28] & 0x7f) << 25) |
			((uint32_t)input[29] << 17) |
			((uint32_t)(input[30] & 0x80) << 9);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 241 to 256
	value = ((uint32_t)(input[30] & 0x7f) << 25) |
			((uint32_t)input[31] << 17) |
			((uint32_t)(input[32] & 0x80) << 9);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 257 to 272
	value = ((uint32_t)(input[32] & 0x7f) << 25) |
			((uint32_t)input[33] << 17) |
			((uint32_t)(input[34] & 0x80) << 9);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 273 to 288
	value = ((uint32_t)(input[34] & 0x7f) << 25) |
			((uint32_t)input[35] << 17) |
			((uint32_t)(input[36] & 0x80) << 9);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 289 to 304
	value = ((uint32_t)(input[36] & 0x7f) << 25) |
			((uint32_t)input[37] << 17) |
			((uint32_t)(input[38] & 0x80) << 9);
	output[18] = (double)(value >> 16);
}

static void unpack_19_16bit_unsigned_1off(const uint8_t * input, double * output, void *closure) {
	// Unpack 19 values into output
	// Values are 16-bit unsigned
	// Skip 1 bits, read 304 bits of data.
	// Input must be at least 39 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 1 to 16
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)input[1] << 17) |
			((uint32_t)(input[2] & 0x80) << 9);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 17 to 32
	value = ((uint32_t)(input[2] & 0x7f) << 25) |
			((uint32_t)input[3] << 17) |
			((uint32_t)(input[4] & 0x80) << 9);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 33 to 48
	value = ((uint32_t)(input[4] & 0x7f) << 25) |
			((uint32_t)input[5] << 17) |
			((uint32_t)(input[6] & 0x80) << 9);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 49 to 64
	value = ((uint32_t)(input[6] & 0x7f) << 25) |
			((uint32_t)input[7] << 17) |
			((uint32_t)(input[8] & 0x80) << 9);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 65 to 80
	value = ((uint32_t)(input[8] & 0x7f) << 25) |
			((uint32_t)input[9] << 17) |
			((uint32_t)(input[10] & 0x80) << 9);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 81 to 96
	value = ((uint32_t)(input[10] & 0x7f) << 25) |
			((uint32_t)input[11] << 17) |
			((uint32_t)(input[12] & 0x80) << 9);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 97 to 112
	value = ((uint32_t)(input[12] & 0x7f) << 25) |
			((uint32_t)input[13] << 17) |
			((uint32_t)(input[14] & 0x80) << 9);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 113 to 128
	value = ((uint32_t)(input[14] & 0x7f) << 25) |
			((uint32_t)input[15] << 17) |
			((uint32_t)(input[16] & 0x80) << 9);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 129 to 144
	value = ((uint32_t)(input[16] & 0x7f) << 25) |
			((uint32_t)input[17] << 17) |
			((uint32_t)(input[18] & 0x80) << 9);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 145 to 160
	value = ((uint32_t)(input[18] & 0x7f) << 25) |
			((uint32_t)input[19] << 17) |
			((uint32_t)(input[20] & 0x80) << 9);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 161 to 176
	value = ((uint32_t)(input[20] & 0x7f) << 25) |
			((uint32_t)input[21] << 17) |
			((uint32_t)(input[22] & 0x80) << 9);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 177 to 192
	value = ((uint32_t)(input[22] & 0x7f) << 25) |
			((uint32_t)input[23] << 17) |
			((uint32_t)(input[24] & 0x80) << 9);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 193 to 208
	value = ((uint32_t)(input[24] & 0x7f) << 25) |
			((uint32_t)input[25] << 17) |
			((uint32_t)(input[26] & 0x80) << 9);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 209 to 224
	value = ((uint32_t)(input[26] & 0x7f) << 25) |
			((uint32_t)input[27] << 17) |
			((uint32_t)(input[28] & 0x80) << 9);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 225 to 240
	value = ((uint32_t)(input[28] & 0x7f) << 25) |
			((uint32_t)input[29] << 17) |
			((uint32_t)(input[30] & 0x80) << 9);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 241 to 256
	value = ((uint32_t)(input[30] & 0x7f) << 25) |
			((uint32_t)input[31] << 17) |
			((uint32_t)(input[32] & 0x80) << 9);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 257 to 272
	value = ((uint32_t)(input[32] & 0x7f) << 25) |
			((uint32_t)input[33] << 17) |
			((uint32_t)(input[34] & 0x80) << 9);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 273 to 288
	value = ((uint32_t)(input[34] & 0x7f) << 25) |
			((uint32_t)input[35] << 17) |
			((uint32_t)(input[36] & 0x80) << 9);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 289 to 304
	value = ((uint32_t)(input[36] & 0x7f) << 25) |
			((uint32_t)input[37] << 17) |
			((uint32_t)(input[38] & 0x80) << 9);
	output[18] = (double)(value >> 16);
}

static void unpack_19_16bit_signed_2off(const uint8_t * input, double * output, void *closure) {
	// Unpack 19 values into output
	// Values are 16-bit signed
	// Skip 2 bits, read 304 bits of data.
	// Input must be at least 39 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 2 to 17
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)input[1] << 18) |
			((uint32_t)(input[2] & 0xc0) << 10);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 18 to 33
	value = ((uint32_t)(input[2] & 0x3f) << 26) |
			((uint32_t)input[3] << 18) |
			((uint32_t)(input[4] & 0xc0) << 10);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 34 to 49
	value = ((uint32_t)(input[4] & 0x3f) << 26) |
			((uint32_t)input[5] << 18) |
			((uint32_t)(input[6] & 0xc0) << 10);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 50 to 65
	value = ((uint32_t)(input[6] & 0x3f) << 26) |
			((uint32_t)input[7] << 18) |
			((uint32_t)(input[8] & 0xc0) << 10);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 66 to 81
	value = ((uint32_t)(input[8] & 0x3f) << 26) |
			((uint32_t)input[9] << 18) |
			((uint32_t)(input[10] & 0xc0) << 10);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 82 to 97
	value = ((uint32_t)(input[10] & 0x3f) << 26) |
			((uint32_t)input[11] << 18) |
			((uint32_t)(input[12] & 0xc0) << 10);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 98 to 113
	value = ((uint32_t)(input[12] & 0x3f) << 26) |
			((uint32_t)input[13] << 18) |
			((uint32_t)(input[14] & 0xc0) << 10);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 114 to 129
	value = ((uint32_t)(input[14] & 0x3f) << 26) |
			((uint32_t)input[15] << 18) |
			((uint32_t)(input[16] & 0xc0) << 10);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 130 to 145
	value = ((uint32_t)(input[16] & 0x3f) << 26) |
			((uint32_t)input[17] << 18) |
			((uint32_t)(input[18] & 0xc0) << 10);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 146 to 161
	value = ((uint32_t)(input[18] & 0x3f) << 26) |
			((uint32_t)input[19] << 18) |
			((uint32_t)(input[20] & 0xc0) << 10);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 162 to 177
	value = ((uint32_t)(input[20] & 0x3f) << 26) |
			((uint32_t)input[21] << 18) |
			((uint32_t)(input[22] & 0xc0) << 10);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 178 to 193
	value = ((uint32_t)(input[22] & 0x3f) << 26) |
			((uint32_t)input[23] << 18) |
			((uint32_t)(input[24] & 0xc0) << 10);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 194 to 209
	value = ((uint32_t)(input[24] & 0x3f) << 26) |
			((uint32_t)input[25] << 18) |
			((uint32_t)(input[26] & 0xc0) << 10);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 210 to 225
	value = ((uint32_t)(input[26] & 0x3f) << 26) |
			((uint32_t)input[27] << 18) |
			((uint32_t)(input[28] & 0xc0) << 10);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 226 to 241
	value = ((uint32_t)(input[28] & 0x3f) << 26) |
			((uint32_t)input[29] << 18) |
			((uint32_t)(input[30] & 0xc0) << 10);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 242 to 257
	value = ((uint32_t)(input[30] & 0x3f) << 26) |
			((uint32_t)input[31] << 18) |
			((uint32_t)(input[32] & 0xc0) << 10);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 258 to 273
	value = ((uint32_t)(input[32] & 0x3f) << 26) |
			((uint32_t)input[33] << 18) |
			((uint32_t)(input[34] & 0xc0) << 10);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 274 to 289
	value = ((uint32_t)(input[34] & 0x3f) << 26) |
			((uint32_t)input[35] << 18) |
			((uint32_t)(input[36] & 0xc0) << 10);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 290 to 305
	value = ((uint32_t)(input[36] & 0x3f) << 26) |
			((uint32_t)input[37] << 18) |
			((uint32_t)(input[38] & 0xc0) << 10);
	output[18] = (double)(value >> 16);
}

static void unpack_19_16bit_unsigned_2off(const uint8_t * input, double * output, void *closure) {
	// Unpack 19 values into output
	// Values are 16-bit unsigned
	// Skip 2 bits, read 304 bits of data.
	// Input must be at least 39 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 2 to 17
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)input[1] << 18) |
			((uint32_t)(input[2] & 0xc0) << 10);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 18 to 33
	value = ((uint32_t)(input[2] & 0x3f) << 26) |
			((uint32_t)input[3] << 18) |
			((uint32_t)(input[4] & 0xc0) << 10);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 34 to 49
	value = ((uint32_t)(input[4] & 0x3f) << 26) |
			((uint32_t)input[5] << 18) |
			((uint32_t)(input[6] & 0xc0) << 10);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 50 to 65
	value = ((uint32_t)(input[6] & 0x3f) << 26) |
			((uint32_t)input[7] << 18) |
			((uint32_t)(input[8] & 0xc0) << 10);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 66 to 81
	value = ((uint32_t)(input[8] & 0x3f) << 26) |
			((uint32_t)input[9] << 18) |
			((uint32_t)(input[10] & 0xc0) << 10);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 82 to 97
	value = ((uint32_t)(input[10] & 0x3f) << 26) |
			((uint32_t)input[11] << 18) |
			((uint32_t)(input[12] & 0xc0) << 10);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 98 to 113
	value = ((uint32_t)(input[12] & 0x3f) << 26) |
			((uint32_t)input[13] << 18) |
			((uint32_t)(input[14] & 0xc0) << 10);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 114 to 129
	value = ((uint32_t)(input[14] & 0x3f) << 26) |
			((uint32_t)input[15] << 18) |
			((uint32_t)(input[16] & 0xc0) << 10);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 130 to 145
	value = ((uint32_t)(input[16] & 0x3f) << 26) |
			((uint32_t)input[17] << 18) |
			((uint32_t)(input[18] & 0xc0) << 10);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 146 to 161
	value = ((uint32_t)(input[18] & 0x3f) << 26) |
			((uint32_t)input[19] << 18) |
			((uint32_t)(input[20] & 0xc0) << 10);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 162 to 177
	value = ((uint32_t)(input[20] & 0x3f) << 26) |
			((uint32_t)input[21] << 18) |
			((uint32_t)(input[22] & 0xc0) << 10);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 178 to 193
	value = ((uint32_t)(input[22] & 0x3f) << 26) |
			((uint32_t)input[23] << 18) |
			((uint32_t)(input[24] & 0xc0) << 10);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 194 to 209
	value = ((uint32_t)(input[24] & 0x3f) << 26) |
			((uint32_t)input[25] << 18) |
			((uint32_t)(input[26] & 0xc0) << 10);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 210 to 225
	value = ((uint32_t)(input[26] & 0x3f) << 26) |
			((uint32_t)input[27] << 18) |
			((uint32_t)(input[28] & 0xc0) << 10);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 226 to 241
	value = ((uint32_t)(input[28] & 0x3f) << 26) |
			((uint32_t)input[29] << 18) |
			((uint32_t)(input[30] & 0xc0) << 10);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 242 to 257
	value = ((uint32_t)(input[30] & 0x3f) << 26) |
			((uint32_t)input[31] << 18) |
			((uint32_t)(input[32] & 0xc0) << 10);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 258 to 273
	value = ((uint32_t)(input[32] & 0x3f) << 26) |
			((uint32_t)input[33] << 18) |
			((uint32_t)(input[34] & 0xc0) << 10);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 274 to 289
	value = ((uint32_t)(input[34] & 0x3f) << 26) |
			((uint32_t)input[35] << 18) |
			((uint32_t)(input[36] & 0xc0) << 10);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 290 to 305
	value = ((uint32_t)(input[36] & 0x3f) << 26) |
			((uint32_t)input[37] << 18) |
			((uint32_t)(input[38] & 0xc0) << 10);
	output[18] = (double)(value >> 16);
}

static void unpack_19_16bit_signed_3off(const uint8_t * input, double * output, void *closure) {
	// Unpack 19 values into output
	// Values are 16-bit signed
	// Skip 3 bits, read 304 bits of data.
	// Input must be at least 39 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 3 to 18
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)input[1] << 19) |
			((uint32_t)(input[2] & 0xe0) << 11);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 19 to 34
	value = ((uint32_t)(input[2] & 0x1f) << 27) |
			((uint32_t)input[3] << 19) |
			((uint32_t)(input[4] & 0xe0) << 11);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 35 to 50
	value = ((uint32_t)(input[4] & 0x1f) << 27) |
			((uint32_t)input[5] << 19) |
			((uint32_t)(input[6] & 0xe0) << 11);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 51 to 66
	value = ((uint32_t)(input[6] & 0x1f) << 27) |
			((uint32_t)input[7] << 19) |
			((uint32_t)(input[8] & 0xe0) << 11);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 67 to 82
	value = ((uint32_t)(input[8] & 0x1f) << 27) |
			((uint32_t)input[9] << 19) |
			((uint32_t)(input[10] & 0xe0) << 11);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 83 to 98
	value = ((uint32_t)(input[10] & 0x1f) << 27) |
			((uint32_t)input[11] << 19) |
			((uint32_t)(input[12] & 0xe0) << 11);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 99 to 114
	value = ((uint32_t)(input[12] & 0x1f) << 27) |
			((uint32_t)input[13] << 19) |
			((uint32_t)(input[14] & 0xe0) << 11);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 115 to 130
	value = ((uint32_t)(input[14] & 0x1f) << 27) |
			((uint32_t)input[15] << 19) |
			((uint32_t)(input[16] & 0xe0) << 11);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 131 to 146
	value = ((uint32_t)(input[16] & 0x1f) << 27) |
			((uint32_t)input[17] << 19) |
			((uint32_t)(input[18] & 0xe0) << 11);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 147 to 162
	value = ((uint32_t)(input[18] & 0x1f) << 27) |
			((uint32_t)input[19] << 19) |
			((uint32_t)(input[20] & 0xe0) << 11);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 163 to 178
	value = ((uint32_t)(input[20] & 0x1f) << 27) |
			((uint32_t)input[21] << 19) |
			((uint32_t)(input[22] & 0xe0) << 11);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 179 to 194
	value = ((uint32_t)(input[22] & 0x1f) << 27) |
			((uint32_t)input[23] << 19) |
			((uint32_t)(input[24] & 0xe0) << 11);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 195 to 210
	value = ((uint32_t)(input[24] & 0x1f) << 27) |
			((uint32_t)input[25] << 19) |
			((uint32_t)(input[26] & 0xe0) << 11);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 211 to 226
	value = ((uint32_t)(input[26] & 0x1f) << 27) |
			((uint32_t)input[27] << 19) |
			((uint32_t)(input[28] & 0xe0) << 11);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 227 to 242
	value = ((uint32_t)(input[28] & 0x1f) << 27) |
			((uint32_t)input[29] << 19) |
			((uint32_t)(input[30] & 0xe0) << 11);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 243 to 258
	value = ((uint32_t)(input[30] & 0x1f) << 27) |
			((uint32_t)input[31] << 19) |
			((uint32_t)(input[32] & 0xe0) << 11);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 259 to 274
	value = ((uint32_t)(input[32] & 0x1f) << 27) |
			((uint32_t)input[33] << 19) |
			((uint32_t)(input[34] & 0xe0) << 11);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 275 to 290
	value = ((uint32_t)(input[34] & 0x1f) << 27) |
			((uint32_t)input[35] << 19) |
			((uint32_t)(input[36] & 0xe0) << 11);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 291 to 306
	value = ((uint32_t)(input[36] & 0x1f) << 27) |
			((uint32_t)input[37] << 19) |
			((uint32_t)(input[38] & 0xe0) << 11);
	output[18] = (double)(value >> 16);
}

static void unpack_19_16bit_unsigned_3off(const uint8_t * input, double * output, void *closure) {
	// Unpack 19 values into output
	// Values are 16-bit unsigned
	// Skip 3 bits, read 304 bits of data.
	// Input must be at least 39 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 3 to 18
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)input[1] << 19) |
			((uint32_t)(input[2] & 0xe0) << 11);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 19 to 34
	value = ((uint32_t)(input[2] & 0x1f) << 27) |
			((uint32_t)input[3] << 19) |
			((uint32_t)(input[4] & 0xe0) << 11);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 35 to 50
	value = ((uint32_t)(input[4] & 0x1f) << 27) |
			((uint32_t)input[5] << 19) |
			((uint32_t)(input[6] & 0xe0) << 11);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 51 to 66
	value = ((uint32_t)(input[6] & 0x1f) << 27) |
			((uint32_t)input[7] << 19) |
			((uint32_t)(input[8] & 0xe0) << 11);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 67 to 82
	value = ((uint32_t)(input[8] & 0x1f) << 27) |
			((uint32_t)input[9] << 19) |
			((uint32_t)(input[10] & 0xe0) << 11);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 83 to 98
	value = ((uint32_t)(input[10] & 0x1f) << 27) |
			((uint32_t)input[11] << 19) |
			((uint32_t)(input[12] & 0xe0) << 11);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 99 to 114
	value = ((uint32_t)(input[12] & 0x1f) << 27) |
			((uint32_t)input[13] << 19) |
			((uint32_t)(input[14] & 0xe0) << 11);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 115 to 130
	value = ((uint32_t)(input[14] & 0x1f) << 27) |
			((uint32_t)input[15] << 19) |
			((uint32_t)(input[16] & 0xe0) << 11);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 131 to 146
	value = ((uint32_t)(input[16] & 0x1f) << 27) |
			((uint32_t)input[17] << 19) |
			((uint32_t)(input[18] & 0xe0) << 11);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 147 to 162
	value = ((uint32_t)(input[18] & 0x1f) << 27) |
			((uint32_t)input[19] << 19) |
			((uint32_t)(input[20] & 0xe0) << 11);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 163 to 178
	value = ((uint32_t)(input[20] & 0x1f) << 27) |
			((uint32_t)input[21] << 19) |
			((uint32_t)(input[22] & 0xe0) << 11);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 179 to 194
	value = ((uint32_t)(input[22] & 0x1f) << 27) |
			((uint32_t)input[23] << 19) |
			((uint32_t)(input[24] & 0xe0) << 11);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 195 to 210
	value = ((uint32_t)(input[24] & 0x1f) << 27) |
			((uint32_t)input[25] << 19) |
			((uint32_t)(input[26] & 0xe0) << 11);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 211 to 226
	value = ((uint32_t)(input[26] & 0x1f) << 27) |
			((uint32_t)input[27] << 19) |
			((uint32_t)(input[28] & 0xe0) << 11);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 227 to 242
	value = ((uint32_t)(input[28] & 0x1f) << 27) |
			((uint32_t)input[29] << 19) |
			((uint32_t)(input[30] & 0xe0) << 11);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 243 to 258
	value = ((uint32_t)(input[30] & 0x1f) << 27) |
			((uint32_t)input[31] << 19) |
			((uint32_t)(input[32] & 0xe0) << 11);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 259 to 274
	value = ((uint32_t)(input[32] & 0x1f) << 27) |
			((uint32_t)input[33] << 19) |
			((uint32_t)(input[34] & 0xe0) << 11);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 275 to 290
	value = ((uint32_t)(input[34] & 0x1f) << 27) |
			((uint32_t)input[35] << 19) |
			((uint32_t)(input[36] & 0xe0) << 11);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 291 to 306
	value = ((uint32_t)(input[36] & 0x1f) << 27) |
			((uint32_t)input[37] << 19) |
			((uint32_t)(input[38] & 0xe0) << 11);
	output[18] = (double)(value >> 16);
}

static void unpack_19_16bit_signed_4off(const uint8_t * input, double * output, void *closure) {
	// Unpack 19 values into output
	// Values are 16-bit signed
	// Skip 4 bits, read 304 bits of data.
	// Input must be at least 39 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 4 to 19
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20) |
			((uint32_t)(input[2] & 0xf0) << 12);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 20 to 35
	value = ((uint32_t)(input[2] & 0x0f) << 28) |
			((uint32_t)input[3] << 20) |
			((uint32_t)(input[4] & 0xf0) << 12);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 36 to 51
	value = ((uint32_t)(input[4] & 0x0f) << 28) |
			((uint32_t)input[5] << 20) |
			((uint32_t)(input[6] & 0xf0) << 12);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 52 to 67
	value = ((uint32_t)(input[6] & 0x0f) << 28) |
			((uint32_t)input[7] << 20) |
			((uint32_t)(input[8] & 0xf0) << 12);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 68 to 83
	value = ((uint32_t)(input[8] & 0x0f) << 28) |
			((uint32_t)input[9] << 20) |
			((uint32_t)(input[10] & 0xf0) << 12);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 84 to 99
	value = ((uint32_t)(input[10] & 0x0f) << 28) |
			((uint32_t)input[11] << 20) |
			((uint32_t)(input[12] & 0xf0) << 12);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 100 to 115
	value = ((uint32_t)(input[12] & 0x0f) << 28) |
			((uint32_t)input[13] << 20) |
			((uint32_t)(input[14] & 0xf0) << 12);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 116 to 131
	value = ((uint32_t)(input[14] & 0x0f) << 28) |
			((uint32_t)input[15] << 20) |
			((uint32_t)(input[16] & 0xf0) << 12);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 132 to 147
	value = ((uint32_t)(input[16] & 0x0f) << 28) |
			((uint32_t)input[17] << 20) |
			((uint32_t)(input[18] & 0xf0) << 12);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 148 to 163
	value = ((uint32_t)(input[18] & 0x0f) << 28) |
			((uint32_t)input[19] << 20) |
			((uint32_t)(input[20] & 0xf0) << 12);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 164 to 179
	value = ((uint32_t)(input[20] & 0x0f) << 28) |
			((uint32_t)input[21] << 20) |
			((uint32_t)(input[22] & 0xf0) << 12);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 180 to 195
	value = ((uint32_t)(input[22] & 0x0f) << 28) |
			((uint32_t)input[23] << 20) |
			((uint32_t)(input[24] & 0xf0) << 12);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 196 to 211
	value = ((uint32_t)(input[24] & 0x0f) << 28) |
			((uint32_t)input[25] << 20) |
			((uint32_t)(input[26] & 0xf0) << 12);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 212 to 227
	value = ((uint32_t)(input[26] & 0x0f) << 28) |
			((uint32_t)input[27] << 20) |
			((uint32_t)(input[28] & 0xf0) << 12);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 228 to 243
	value = ((uint32_t)(input[28] & 0x0f) << 28) |
			((uint32_t)input[29] << 20) |
			((uint32_t)(input[30] & 0xf0) << 12);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 244 to 259
	value = ((uint32_t)(input[30] & 0x0f) << 28) |
			((uint32_t)input[31] << 20) |
			((uint32_t)(input[32] & 0xf0) << 12);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 260 to 275
	value = ((uint32_t)(input[32] & 0x0f) << 28) |
			((uint32_t)input[33] << 20) |
			((uint32_t)(input[34] & 0xf0) << 12);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 276 to 291
	value = ((uint32_t)(input[34] & 0x0f) << 28) |
			((uint32_t)input[35] << 20) |
			((uint32_t)(input[36] & 0xf0) << 12);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 292 to 307
	value = ((uint32_t)(input[36] & 0x0f) << 28) |
			((uint32_t)input[37] << 20) |
			((uint32_t)(input[38] & 0xf0) << 12);
	output[18] = (double)(value >> 16);
}

static void unpack_19_16bit_unsigned_4off(const uint8_t * input, double * output, void *closure) {
	// Unpack 19 values into output
	// Values are 16-bit unsigned
	// Skip 4 bits, read 304 bits of data.
	// Input must be at least 39 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 4 to 19
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20) |
			((uint32_t)(input[2] & 0xf0) << 12);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 20 to 35
	value = ((uint32_t)(input[2] & 0x0f) << 28) |
			((uint32_t)input[3] << 20) |
			((uint32_t)(input[4] & 0xf0) << 12);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 36 to 51
	value = ((uint32_t)(input[4] & 0x0f) << 28) |
			((uint32_t)input[5] << 20) |
			((uint32_t)(input[6] & 0xf0) << 12);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 52 to 67
	value = ((uint32_t)(input[6] & 0x0f) << 28) |
			((uint32_t)input[7] << 20) |
			((uint32_t)(input[8] & 0xf0) << 12);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 68 to 83
	value = ((uint32_t)(input[8] & 0x0f) << 28) |
			((uint32_t)input[9] << 20) |
			((uint32_t)(input[10] & 0xf0) << 12);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 84 to 99
	value = ((uint32_t)(input[10] & 0x0f) << 28) |
			((uint32_t)input[11] << 20) |
			((uint32_t)(input[12] & 0xf0) << 12);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 100 to 115
	value = ((uint32_t)(input[12] & 0x0f) << 28) |
			((uint32_t)input[13] << 20) |
			((uint32_t)(input[14] & 0xf0) << 12);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 116 to 131
	value = ((uint32_t)(input[14] & 0x0f) << 28) |
			((uint32_t)input[15] << 20) |
			((uint32_t)(input[16] & 0xf0) << 12);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 132 to 147
	value = ((uint32_t)(input[16] & 0x0f) << 28) |
			((uint32_t)input[17] << 20) |
			((uint32_t)(input[18] & 0xf0) << 12);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 148 to 163
	value = ((uint32_t)(input[18] & 0x0f) << 28) |
			((uint32_t)input[19] << 20) |
			((uint32_t)(input[20] & 0xf0) << 12);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 164 to 179
	value = ((uint32_t)(input[20] & 0x0f) << 28) |
			((uint32_t)input[21] << 20) |
			((uint32_t)(input[22] & 0xf0) << 12);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 180 to 195
	value = ((uint32_t)(input[22] & 0x0f) << 28) |
			((uint32_t)input[23] << 20) |
			((uint32_t)(input[24] & 0xf0) << 12);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 196 to 211
	value = ((uint32_t)(input[24] & 0x0f) << 28) |
			((uint32_t)input[25] << 20) |
			((uint32_t)(input[26] & 0xf0) << 12);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 212 to 227
	value = ((uint32_t)(input[26] & 0x0f) << 28) |
			((uint32_t)input[27] << 20) |
			((uint32_t)(input[28] & 0xf0) << 12);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 228 to 243
	value = ((uint32_t)(input[28] & 0x0f) << 28) |
			((uint32_t)input[29] << 20) |
			((uint32_t)(input[30] & 0xf0) << 12);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 244 to 259
	value = ((uint32_t)(input[30] & 0x0f) << 28) |
			((uint32_t)input[31] << 20) |
			((uint32_t)(input[32] & 0xf0) << 12);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 260 to 275
	value = ((uint32_t)(input[32] & 0x0f) << 28) |
			((uint32_t)input[33] << 20) |
			((uint32_t)(input[34] & 0xf0) << 12);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 276 to 291
	value = ((uint32_t)(input[34] & 0x0f) << 28) |
			((uint32_t)input[35] << 20) |
			((uint32_t)(input[36] & 0xf0) << 12);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 292 to 307
	value = ((uint32_t)(input[36] & 0x0f) << 28) |
			((uint32_t)input[37] << 20) |
			((uint32_t)(input[38] & 0xf0) << 12);
	output[18] = (double)(value >> 16);
}

static void unpack_19_16bit_signed_5off(const uint8_t * input, double * output, void *closure) {
	// Unpack 19 values into output
	// Values are 16-bit signed
	// Skip 5 bits, read 304 bits of data.
	// Input must be at least 39 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 5 to 20
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)(input[2] & 0xf8) << 13);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 21 to 36
	value = ((uint32_t)(input[2] & 0x07) << 29) |
			((uint32_t)input[3] << 21) |
			((uint32_t)(input[4] & 0xf8) << 13);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 37 to 52
	value = ((uint32_t)(input[4] & 0x07) << 29) |
			((uint32_t)input[5] << 21) |
			((uint32_t)(input[6] & 0xf8) << 13);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 53 to 68
	value = ((uint32_t)(input[6] & 0x07) << 29) |
			((uint32_t)input[7] << 21) |
			((uint32_t)(input[8] & 0xf8) << 13);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 69 to 84
	value = ((uint32_t)(input[8] & 0x07) << 29) |
			((uint32_t)input[9] << 21) |
			((uint32_t)(input[10] & 0xf8) << 13);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 85 to 100
	value = ((uint32_t)(input[10] & 0x07) << 29) |
			((uint32_t)input[11] << 21) |
			((uint32_t)(input[12] & 0xf8) << 13);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 101 to 116
	value = ((uint32_t)(input[12] & 0x07) << 29) |
			((uint32_t)input[13] << 21) |
			((uint32_t)(input[14] & 0xf8) << 13);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 117 to 132
	value = ((uint32_t)(input[14] & 0x07) << 29) |
			((uint32_t)input[15] << 21) |
			((uint32_t)(input[16] & 0xf8) << 13);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 133 to 148
	value = ((uint32_t)(input[16] & 0x07) << 29) |
			((uint32_t)input[17] << 21) |
			((uint32_t)(input[18] & 0xf8) << 13);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 149 to 164
	value = ((uint32_t)(input[18] & 0x07) << 29) |
			((uint32_t)input[19] << 21) |
			((uint32_t)(input[20] & 0xf8) << 13);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 165 to 180
	value = ((uint32_t)(input[20] & 0x07) << 29) |
			((uint32_t)input[21] << 21) |
			((uint32_t)(input[22] & 0xf8) << 13);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 181 to 196
	value = ((uint32_t)(input[22] & 0x07) << 29) |
			((uint32_t)input[23] << 21) |
			((uint32_t)(input[24] & 0xf8) << 13);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 197 to 212
	value = ((uint32_t)(input[24] & 0x07) << 29) |
			((uint32_t)input[25] << 21) |
			((uint32_t)(input[26] & 0xf8) << 13);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 213 to 228
	value = ((uint32_t)(input[26] & 0x07) << 29) |
			((uint32_t)input[27] << 21) |
			((uint32_t)(input[28] & 0xf8) << 13);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 229 to 244
	value = ((uint32_t)(input[28] & 0x07) << 29) |
			((uint32_t)input[29] << 21) |
			((uint32_t)(input[30] & 0xf8) << 13);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 245 to 260
	value = ((uint32_t)(input[30] & 0x07) << 29) |
			((uint32_t)input[31] << 21) |
			((uint32_t)(input[32] & 0xf8) << 13);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 261 to 276
	value = ((uint32_t)(input[32] & 0x07) << 29) |
			((uint32_t)input[33] << 21) |
			((uint32_t)(input[34] & 0xf8) << 13);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 277 to 292
	value = ((uint32_t)(input[34] & 0x07) << 29) |
			((uint32_t)input[35] << 21) |
			((uint32_t)(input[36] & 0xf8) << 13);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 293 to 308
	value = ((uint32_t)(input[36] & 0x07) << 29) |
			((uint32_t)input[37] << 21) |
			((uint32_t)(input[38] & 0xf8) << 13);
	output[18] = (double)(value >> 16);
}

static void unpack_19_16bit_unsigned_5off(const uint8_t * input, double * output, void *closure) {
	// Unpack 19 values into output
	// Values are 16-bit unsigned
	// Skip 5 bits, read 304 bits of data.
	// Input must be at least 39 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 5 to 20
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)(input[2] & 0xf8) << 13);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 21 to 36
	value = ((uint32_t)(input[2] & 0x07) << 29) |
			((uint32_t)input[3] << 21) |
			((uint32_t)(input[4] & 0xf8) << 13);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 37 to 52
	value = ((uint32_t)(input[4] & 0x07) << 29) |
			((uint32_t)input[5] << 21) |
			((uint32_t)(input[6] & 0xf8) << 13);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 53 to 68
	value = ((uint32_t)(input[6] & 0x07) << 29) |
			((uint32_t)input[7] << 21) |
			((uint32_t)(input[8] & 0xf8) << 13);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 69 to 84
	value = ((uint32_t)(input[8] & 0x07) << 29) |
			((uint32_t)input[9] << 21) |
			((uint32_t)(input[10] & 0xf8) << 13);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 85 to 100
	value = ((uint32_t)(input[10] & 0x07) << 29) |
			((uint32_t)input[11] << 21) |
			((uint32_t)(input[12] & 0xf8) << 13);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 101 to 116
	value = ((uint32_t)(input[12] & 0x07) << 29) |
			((uint32_t)input[13] << 21) |
			((uint32_t)(input[14] & 0xf8) << 13);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 117 to 132
	value = ((uint32_t)(input[14] & 0x07) << 29) |
			((uint32_t)input[15] << 21) |
			((uint32_t)(input[16] & 0xf8) << 13);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 133 to 148
	value = ((uint32_t)(input[16] & 0x07) << 29) |
			((uint32_t)input[17] << 21) |
			((uint32_t)(input[18] & 0xf8) << 13);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 149 to 164
	value = ((uint32_t)(input[18] & 0x07) << 29) |
			((uint32_t)input[19] << 21) |
			((uint32_t)(input[20] & 0xf8) << 13);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 165 to 180
	value = ((uint32_t)(input[20] & 0x07) << 29) |
			((uint32_t)input[21] << 21) |
			((uint32_t)(input[22] & 0xf8) << 13);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 181 to 196
	value = ((uint32_t)(input[22] & 0x07) << 29) |
			((uint32_t)input[23] << 21) |
			((uint32_t)(input[24] & 0xf8) << 13);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 197 to 212
	value = ((uint32_t)(input[24] & 0x07) << 29) |
			((uint32_t)input[25] << 21) |
			((uint32_t)(input[26] & 0xf8) << 13);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 213 to 228
	value = ((uint32_t)(input[26] & 0x07) << 29) |
			((uint32_t)input[27] << 21) |
			((uint32_t)(input[28] & 0xf8) << 13);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 229 to 244
	value = ((uint32_t)(input[28] & 0x07) << 29) |
			((uint32_t)input[29] << 21) |
			((uint32_t)(input[30] & 0xf8) << 13);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 245 to 260
	value = ((uint32_t)(input[30] & 0x07) << 29) |
			((uint32_t)input[31] << 21) |
			((uint32_t)(input[32] & 0xf8) << 13);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 261 to 276
	value = ((uint32_t)(input[32] & 0x07) << 29) |
			((uint32_t)input[33] << 21) |
			((uint32_t)(input[34] & 0xf8) << 13);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 277 to 292
	value = ((uint32_t)(input[34] & 0x07) << 29) |
			((uint32_t)input[35] << 21) |
			((uint32_t)(input[36] & 0xf8) << 13);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 293 to 308
	value = ((uint32_t)(input[36] & 0x07) << 29) |
			((uint32_t)input[37] << 21) |
			((uint32_t)(input[38] & 0xf8) << 13);
	output[18] = (double)(value >> 16);
}

static void unpack_19_16bit_signed_6off(const uint8_t * input, double * output, void *closure) {
	// Unpack 19 values into output
	// Values are 16-bit signed
	// Skip 6 bits, read 304 bits of data.
	// Input must be at least 39 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 6 to 21
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)(input[2] & 0xfc) << 14);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 22 to 37
	value = ((uint32_t)(input[2] & 0x03) << 30) |
			((uint32_t)input[3] << 22) |
			((uint32_t)(input[4] & 0xfc) << 14);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 38 to 53
	value = ((uint32_t)(input[4] & 0x03) << 30) |
			((uint32_t)input[5] << 22) |
			((uint32_t)(input[6] & 0xfc) << 14);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 54 to 69
	value = ((uint32_t)(input[6] & 0x03) << 30) |
			((uint32_t)input[7] << 22) |
			((uint32_t)(input[8] & 0xfc) << 14);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 70 to 85
	value = ((uint32_t)(input[8] & 0x03) << 30) |
			((uint32_t)input[9] << 22) |
			((uint32_t)(input[10] & 0xfc) << 14);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 86 to 101
	value = ((uint32_t)(input[10] & 0x03) << 30) |
			((uint32_t)input[11] << 22) |
			((uint32_t)(input[12] & 0xfc) << 14);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 102 to 117
	value = ((uint32_t)(input[12] & 0x03) << 30) |
			((uint32_t)input[13] << 22) |
			((uint32_t)(input[14] & 0xfc) << 14);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 118 to 133
	value = ((uint32_t)(input[14] & 0x03) << 30) |
			((uint32_t)input[15] << 22) |
			((uint32_t)(input[16] & 0xfc) << 14);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 134 to 149
	value = ((uint32_t)(input[16] & 0x03) << 30) |
			((uint32_t)input[17] << 22) |
			((uint32_t)(input[18] & 0xfc) << 14);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 150 to 165
	value = ((uint32_t)(input[18] & 0x03) << 30) |
			((uint32_t)input[19] << 22) |
			((uint32_t)(input[20] & 0xfc) << 14);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 166 to 181
	value = ((uint32_t)(input[20] & 0x03) << 30) |
			((uint32_t)input[21] << 22) |
			((uint32_t)(input[22] & 0xfc) << 14);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 182 to 197
	value = ((uint32_t)(input[22] & 0x03) << 30) |
			((uint32_t)input[23] << 22) |
			((uint32_t)(input[24] & 0xfc) << 14);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 198 to 213
	value = ((uint32_t)(input[24] & 0x03) << 30) |
			((uint32_t)input[25] << 22) |
			((uint32_t)(input[26] & 0xfc) << 14);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 214 to 229
	value = ((uint32_t)(input[26] & 0x03) << 30) |
			((uint32_t)input[27] << 22) |
			((uint32_t)(input[28] & 0xfc) << 14);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 230 to 245
	value = ((uint32_t)(input[28] & 0x03) << 30) |
			((uint32_t)input[29] << 22) |
			((uint32_t)(input[30] & 0xfc) << 14);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 246 to 261
	value = ((uint32_t)(input[30] & 0x03) << 30) |
			((uint32_t)input[31] << 22) |
			((uint32_t)(input[32] & 0xfc) << 14);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 262 to 277
	value = ((uint32_t)(input[32] & 0x03) << 30) |
			((uint32_t)input[33] << 22) |
			((uint32_t)(input[34] & 0xfc) << 14);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 278 to 293
	value = ((uint32_t)(input[34] & 0x03) << 30) |
			((uint32_t)input[35] << 22) |
			((uint32_t)(input[36] & 0xfc) << 14);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 294 to 309
	value = ((uint32_t)(input[36] & 0x03) << 30) |
			((uint32_t)input[37] << 22) |
			((uint32_t)(input[38] & 0xfc) << 14);
	output[18] = (double)(value >> 16);
}

static void unpack_19_16bit_unsigned_6off(const uint8_t * input, double * output, void *closure) {
	// Unpack 19 values into output
	// Values are 16-bit unsigned
	// Skip 6 bits, read 304 bits of data.
	// Input must be at least 39 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 6 to 21
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)(input[2] & 0xfc) << 14);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 22 to 37
	value = ((uint32_t)(input[2] & 0x03) << 30) |
			((uint32_t)input[3] << 22) |
			((uint32_t)(input[4] & 0xfc) << 14);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 38 to 53
	value = ((uint32_t)(input[4] & 0x03) << 30) |
			((uint32_t)input[5] << 22) |
			((uint32_t)(input[6] & 0xfc) << 14);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 54 to 69
	value = ((uint32_t)(input[6] & 0x03) << 30) |
			((uint32_t)input[7] << 22) |
			((uint32_t)(input[8] & 0xfc) << 14);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 70 to 85
	value = ((uint32_t)(input[8] & 0x03) << 30) |
			((uint32_t)input[9] << 22) |
			((uint32_t)(input[10] & 0xfc) << 14);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 86 to 101
	value = ((uint32_t)(input[10] & 0x03) << 30) |
			((uint32_t)input[11] << 22) |
			((uint32_t)(input[12] & 0xfc) << 14);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 102 to 117
	value = ((uint32_t)(input[12] & 0x03) << 30) |
			((uint32_t)input[13] << 22) |
			((uint32_t)(input[14] & 0xfc) << 14);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 118 to 133
	value = ((uint32_t)(input[14] & 0x03) << 30) |
			((uint32_t)input[15] << 22) |
			((uint32_t)(input[16] & 0xfc) << 14);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 134 to 149
	value = ((uint32_t)(input[16] & 0x03) << 30) |
			((uint32_t)input[17] << 22) |
			((uint32_t)(input[18] & 0xfc) << 14);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 150 to 165
	value = ((uint32_t)(input[18] & 0x03) << 30) |
			((uint32_t)input[19] << 22) |
			((uint32_t)(input[20] & 0xfc) << 14);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 166 to 181
	value = ((uint32_t)(input[20] & 0x03) << 30) |
			((uint32_t)input[21] << 22) |
			((uint32_t)(input[22] & 0xfc) << 14);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 182 to 197
	value = ((uint32_t)(input[22] & 0x03) << 30) |
			((uint32_t)input[23] << 22) |
			((uint32_t)(input[24] & 0xfc) << 14);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 198 to 213
	value = ((uint32_t)(input[24] & 0x03) << 30) |
			((uint32_t)input[25] << 22) |
			((uint32_t)(input[26] & 0xfc) << 14);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 214 to 229
	value = ((uint32_t)(input[26] & 0x03) << 30) |
			((uint32_t)input[27] << 22) |
			((uint32_t)(input[28] & 0xfc) << 14);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 230 to 245
	value = ((uint32_t)(input[28] & 0x03) << 30) |
			((uint32_t)input[29] << 22) |
			((uint32_t)(input[30] & 0xfc) << 14);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 246 to 261
	value = ((uint32_t)(input[30] & 0x03) << 30) |
			((uint32_t)input[31] << 22) |
			((uint32_t)(input[32] & 0xfc) << 14);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 262 to 277
	value = ((uint32_t)(input[32] & 0x03) << 30) |
			((uint32_t)input[33] << 22) |
			((uint32_t)(input[34] & 0xfc) << 14);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 278 to 293
	value = ((uint32_t)(input[34] & 0x03) << 30) |
			((uint32_t)input[35] << 22) |
			((uint32_t)(input[36] & 0xfc) << 14);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 294 to 309
	value = ((uint32_t)(input[36] & 0x03) << 30) |
			((uint32_t)input[37] << 22) |
			((uint32_t)(input[38] & 0xfc) << 14);
	output[18] = (double)(value >> 16);
}

static void unpack_19_16bit_signed_7off(const uint8_t * input, double * output, void *closure) {
	// Unpack 19 values into output
	// Values are 16-bit signed
	// Skip 7 bits, read 304 bits of data.
	// Input must be at least 39 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 7 to 22
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)(input[2] & 0xfe) << 15);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 23 to 38
	value = ((uint32_t)(input[2] & 0x01) << 31) |
			((uint32_t)input[3] << 23) |
			((uint32_t)(input[4] & 0xfe) << 15);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 39 to 54
	value = ((uint32_t)(input[4] & 0x01) << 31) |
			((uint32_t)input[5] << 23) |
			((uint32_t)(input[6] & 0xfe) << 15);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 55 to 70
	value = ((uint32_t)(input[6] & 0x01) << 31) |
			((uint32_t)input[7] << 23) |
			((uint32_t)(input[8] & 0xfe) << 15);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 71 to 86
	value = ((uint32_t)(input[8] & 0x01) << 31) |
			((uint32_t)input[9] << 23) |
			((uint32_t)(input[10] & 0xfe) << 15);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 87 to 102
	value = ((uint32_t)(input[10] & 0x01) << 31) |
			((uint32_t)input[11] << 23) |
			((uint32_t)(input[12] & 0xfe) << 15);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 103 to 118
	value = ((uint32_t)(input[12] & 0x01) << 31) |
			((uint32_t)input[13] << 23) |
			((uint32_t)(input[14] & 0xfe) << 15);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 119 to 134
	value = ((uint32_t)(input[14] & 0x01) << 31) |
			((uint32_t)input[15] << 23) |
			((uint32_t)(input[16] & 0xfe) << 15);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 135 to 150
	value = ((uint32_t)(input[16] & 0x01) << 31) |
			((uint32_t)input[17] << 23) |
			((uint32_t)(input[18] & 0xfe) << 15);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 151 to 166
	value = ((uint32_t)(input[18] & 0x01) << 31) |
			((uint32_t)input[19] << 23) |
			((uint32_t)(input[20] & 0xfe) << 15);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 167 to 182
	value = ((uint32_t)(input[20] & 0x01) << 31) |
			((uint32_t)input[21] << 23) |
			((uint32_t)(input[22] & 0xfe) << 15);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 183 to 198
	value = ((uint32_t)(input[22] & 0x01) << 31) |
			((uint32_t)input[23] << 23) |
			((uint32_t)(input[24] & 0xfe) << 15);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 199 to 214
	value = ((uint32_t)(input[24] & 0x01) << 31) |
			((uint32_t)input[25] << 23) |
			((uint32_t)(input[26] & 0xfe) << 15);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 215 to 230
	value = ((uint32_t)(input[26] & 0x01) << 31) |
			((uint32_t)input[27] << 23) |
			((uint32_t)(input[28] & 0xfe) << 15);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 231 to 246
	value = ((uint32_t)(input[28] & 0x01) << 31) |
			((uint32_t)input[29] << 23) |
			((uint32_t)(input[30] & 0xfe) << 15);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 247 to 262
	value = ((uint32_t)(input[30] & 0x01) << 31) |
			((uint32_t)input[31] << 23) |
			((uint32_t)(input[32] & 0xfe) << 15);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 263 to 278
	value = ((uint32_t)(input[32] & 0x01) << 31) |
			((uint32_t)input[33] << 23) |
			((uint32_t)(input[34] & 0xfe) << 15);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 279 to 294
	value = ((uint32_t)(input[34] & 0x01) << 31) |
			((uint32_t)input[35] << 23) |
			((uint32_t)(input[36] & 0xfe) << 15);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 295 to 310
	value = ((uint32_t)(input[36] & 0x01) << 31) |
			((uint32_t)input[37] << 23) |
			((uint32_t)(input[38] & 0xfe) << 15);
	output[18] = (double)(value >> 16);
}

static void unpack_19_16bit_unsigned_7off(const uint8_t * input, double * output, void *closure) {
	// Unpack 19 values into output
	// Values are 16-bit unsigned
	// Skip 7 bits, read 304 bits of data.
	// Input must be at least 39 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 7 to 22
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)(input[2] & 0xfe) << 15);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 23 to 38
	value = ((uint32_t)(input[2] & 0x01) << 31) |
			((uint32_t)input[3] << 23) |
			((uint32_t)(input[4] & 0xfe) << 15);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 39 to 54
	value = ((uint32_t)(input[4] & 0x01) << 31) |
			((uint32_t)input[5] << 23) |
			((uint32_t)(input[6] & 0xfe) << 15);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 55 to 70
	value = ((uint32_t)(input[6] & 0x01) << 31) |
			((uint32_t)input[7] << 23) |
			((uint32_t)(input[8] & 0xfe) << 15);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 71 to 86
	value = ((uint32_t)(input[8] & 0x01) << 31) |
			((uint32_t)input[9] << 23) |
			((uint32_t)(input[10] & 0xfe) << 15);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 87 to 102
	value = ((uint32_t)(input[10] & 0x01) << 31) |
			((uint32_t)input[11] << 23) |
			((uint32_t)(input[12] & 0xfe) << 15);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 103 to 118
	value = ((uint32_t)(input[12] & 0x01) << 31) |
			((uint32_t)input[13] << 23) |
			((uint32_t)(input[14] & 0xfe) << 15);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 119 to 134
	value = ((uint32_t)(input[14] & 0x01) << 31) |
			((uint32_t)input[15] << 23) |
			((uint32_t)(input[16] & 0xfe) << 15);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 135 to 150
	value = ((uint32_t)(input[16] & 0x01) << 31) |
			((uint32_t)input[17] << 23) |
			((uint32_t)(input[18] & 0xfe) << 15);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 151 to 166
	value = ((uint32_t)(input[18] & 0x01) << 31) |
			((uint32_t)input[19] << 23) |
			((uint32_t)(input[20] & 0xfe) << 15);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 167 to 182
	value = ((uint32_t)(input[20] & 0x01) << 31) |
			((uint32_t)input[21] << 23) |
			((uint32_t)(input[22] & 0xfe) << 15);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 183 to 198
	value = ((uint32_t)(input[22] & 0x01) << 31) |
			((uint32_t)input[23] << 23) |
			((uint32_t)(input[24] & 0xfe) << 15);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 199 to 214
	value = ((uint32_t)(input[24] & 0x01) << 31) |
			((uint32_t)input[25] << 23) |
			((uint32_t)(input[26] & 0xfe) << 15);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 215 to 230
	value = ((uint32_t)(input[26] & 0x01) << 31) |
			((uint32_t)input[27] << 23) |
			((uint32_t)(input[28] & 0xfe) << 15);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 231 to 246
	value = ((uint32_t)(input[28] & 0x01) << 31) |
			((uint32_t)input[29] << 23) |
			((uint32_t)(input[30] & 0xfe) << 15);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 247 to 262
	value = ((uint32_t)(input[30] & 0x01) << 31) |
			((uint32_t)input[31] << 23) |
			((uint32_t)(input[32] & 0xfe) << 15);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 263 to 278
	value = ((uint32_t)(input[32] & 0x01) << 31) |
			((uint32_t)input[33] << 23) |
			((uint32_t)(input[34] & 0xfe) << 15);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 279 to 294
	value = ((uint32_t)(input[34] & 0x01) << 31) |
			((uint32_t)input[35] << 23) |
			((uint32_t)(input[36] & 0xfe) << 15);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 295 to 310
	value = ((uint32_t)(input[36] & 0x01) << 31) |
			((uint32_t)input[37] << 23) |
			((uint32_t)(input[38] & 0xfe) << 15);
	output[18] = (double)(value >> 16);
}

static void unpack_20_16bit_signed_0off(const uint8_t * input, double * output, void *closure) {
	// Unpack 20 values into output
	// Values are 16-bit signed
	// Skip 0 bits, read 320 bits of data.
	// Input must be at least 40 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 0 to 15
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)input[1] << 16);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 16 to 31
	value = ((uint32_t)input[2] << 24) |
			((uint32_t)input[3] << 16);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 32 to 47
	value = ((uint32_t)input[4] << 24) |
			((uint32_t)input[5] << 16);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 48 to 63
	value = ((uint32_t)input[6] << 24) |
			((uint32_t)input[7] << 16);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 64 to 79
	value = ((uint32_t)input[8] << 24) |
			((uint32_t)input[9] << 16);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 80 to 95
	value = ((uint32_t)input[10] << 24) |
			((uint32_t)input[11] << 16);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 96 to 111
	value = ((uint32_t)input[12] << 24) |
			((uint32_t)input[13] << 16);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 112 to 127
	value = ((uint32_t)input[14] << 24) |
			((uint32_t)input[15] << 16);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 128 to 143
	value = ((uint32_t)input[16] << 24) |
			((uint32_t)input[17] << 16);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 144 to 159
	value = ((uint32_t)input[18] << 24) |
			((uint32_t)input[19] << 16);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 160 to 175
	value = ((uint32_t)input[20] << 24) |
			((uint32_t)input[21] << 16);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 176 to 191
	value = ((uint32_t)input[22] << 24) |
			((uint32_t)input[23] << 16);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 192 to 207
	value = ((uint32_t)input[24] << 24) |
			((uint32_t)input[25] << 16);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 208 to 223
	value = ((uint32_t)input[26] << 24) |
			((uint32_t)input[27] << 16);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 224 to 239
	value = ((uint32_t)input[28] << 24) |
			((uint32_t)input[29] << 16);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 240 to 255
	value = ((uint32_t)input[30] << 24) |
			((uint32_t)input[31] << 16);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 256 to 271
	value = ((uint32_t)input[32] << 24) |
			((uint32_t)input[33] << 16);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 272 to 287
	value = ((uint32_t)input[34] << 24) |
			((uint32_t)input[35] << 16);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 288 to 303
	value = ((uint32_t)input[36] << 24) |
			((uint32_t)input[37] << 16);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 304 to 319
	value = ((uint32_t)input[38] << 24) |
			((uint32_t)input[39] << 16);
	output[19] = (double)(value >> 16);
}

static void unpack_20_16bit_unsigned_0off(const uint8_t * input, double * output, void *closure) {
	// Unpack 20 values into output
	// Values are 16-bit unsigned
	// Skip 0 bits, read 320 bits of data.
	// Input must be at least 40 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 0 to 15
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)input[1] << 16);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 16 to 31
	value = ((uint32_t)input[2] << 24) |
			((uint32_t)input[3] << 16);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 32 to 47
	value = ((uint32_t)input[4] << 24) |
			((uint32_t)input[5] << 16);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 48 to 63
	value = ((uint32_t)input[6] << 24) |
			((uint32_t)input[7] << 16);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 64 to 79
	value = ((uint32_t)input[8] << 24) |
			((uint32_t)input[9] << 16);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 80 to 95
	value = ((uint32_t)input[10] << 24) |
			((uint32_t)input[11] << 16);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 96 to 111
	value = ((uint32_t)input[12] << 24) |
			((uint32_t)input[13] << 16);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 112 to 127
	value = ((uint32_t)input[14] << 24) |
			((uint32_t)input[15] << 16);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 128 to 143
	value = ((uint32_t)input[16] << 24) |
			((uint32_t)input[17] << 16);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 144 to 159
	value = ((uint32_t)input[18] << 24) |
			((uint32_t)input[19] << 16);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 160 to 175
	value = ((uint32_t)input[20] << 24) |
			((uint32_t)input[21] << 16);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 176 to 191
	value = ((uint32_t)input[22] << 24) |
			((uint32_t)input[23] << 16);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 192 to 207
	value = ((uint32_t)input[24] << 24) |
			((uint32_t)input[25] << 16);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 208 to 223
	value = ((uint32_t)input[26] << 24) |
			((uint32_t)input[27] << 16);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 224 to 239
	value = ((uint32_t)input[28] << 24) |
			((uint32_t)input[29] << 16);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 240 to 255
	value = ((uint32_t)input[30] << 24) |
			((uint32_t)input[31] << 16);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 256 to 271
	value = ((uint32_t)input[32] << 24) |
			((uint32_t)input[33] << 16);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 272 to 287
	value = ((uint32_t)input[34] << 24) |
			((uint32_t)input[35] << 16);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 288 to 303
	value = ((uint32_t)input[36] << 24) |
			((uint32_t)input[37] << 16);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 304 to 319
	value = ((uint32_t)input[38] << 24) |
			((uint32_t)input[39] << 16);
	output[19] = (double)(value >> 16);
}

static void unpack_20_16bit_signed_1off(const uint8_t * input, double * output, void *closure) {
	// Unpack 20 values into output
	// Values are 16-bit signed
	// Skip 1 bits, read 320 bits of data.
	// Input must be at least 41 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 1 to 16
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)input[1] << 17) |
			((uint32_t)(input[2] & 0x80) << 9);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 17 to 32
	value = ((uint32_t)(input[2] & 0x7f) << 25) |
			((uint32_t)input[3] << 17) |
			((uint32_t)(input[4] & 0x80) << 9);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 33 to 48
	value = ((uint32_t)(input[4] & 0x7f) << 25) |
			((uint32_t)input[5] << 17) |
			((uint32_t)(input[6] & 0x80) << 9);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 49 to 64
	value = ((uint32_t)(input[6] & 0x7f) << 25) |
			((uint32_t)input[7] << 17) |
			((uint32_t)(input[8] & 0x80) << 9);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 65 to 80
	value = ((uint32_t)(input[8] & 0x7f) << 25) |
			((uint32_t)input[9] << 17) |
			((uint32_t)(input[10] & 0x80) << 9);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 81 to 96
	value = ((uint32_t)(input[10] & 0x7f) << 25) |
			((uint32_t)input[11] << 17) |
			((uint32_t)(input[12] & 0x80) << 9);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 97 to 112
	value = ((uint32_t)(input[12] & 0x7f) << 25) |
			((uint32_t)input[13] << 17) |
			((uint32_t)(input[14] & 0x80) << 9);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 113 to 128
	value = ((uint32_t)(input[14] & 0x7f) << 25) |
			((uint32_t)input[15] << 17) |
			((uint32_t)(input[16] & 0x80) << 9);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 129 to 144
	value = ((uint32_t)(input[16] & 0x7f) << 25) |
			((uint32_t)input[17] << 17) |
			((uint32_t)(input[18] & 0x80) << 9);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 145 to 160
	value = ((uint32_t)(input[18] & 0x7f) << 25) |
			((uint32_t)input[19] << 17) |
			((uint32_t)(input[20] & 0x80) << 9);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 161 to 176
	value = ((uint32_t)(input[20] & 0x7f) << 25) |
			((uint32_t)input[21] << 17) |
			((uint32_t)(input[22] & 0x80) << 9);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 177 to 192
	value = ((uint32_t)(input[22] & 0x7f) << 25) |
			((uint32_t)input[23] << 17) |
			((uint32_t)(input[24] & 0x80) << 9);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 193 to 208
	value = ((uint32_t)(input[24] & 0x7f) << 25) |
			((uint32_t)input[25] << 17) |
			((uint32_t)(input[26] & 0x80) << 9);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 209 to 224
	value = ((uint32_t)(input[26] & 0x7f) << 25) |
			((uint32_t)input[27] << 17) |
			((uint32_t)(input[28] & 0x80) << 9);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 225 to 240
	value = ((uint32_t)(input[28] & 0x7f) << 25) |
			((uint32_t)input[29] << 17) |
			((uint32_t)(input[30] & 0x80) << 9);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 241 to 256
	value = ((uint32_t)(input[30] & 0x7f) << 25) |
			((uint32_t)input[31] << 17) |
			((uint32_t)(input[32] & 0x80) << 9);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 257 to 272
	value = ((uint32_t)(input[32] & 0x7f) << 25) |
			((uint32_t)input[33] << 17) |
			((uint32_t)(input[34] & 0x80) << 9);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 273 to 288
	value = ((uint32_t)(input[34] & 0x7f) << 25) |
			((uint32_t)input[35] << 17) |
			((uint32_t)(input[36] & 0x80) << 9);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 289 to 304
	value = ((uint32_t)(input[36] & 0x7f) << 25) |
			((uint32_t)input[37] << 17) |
			((uint32_t)(input[38] & 0x80) << 9);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 305 to 320
	value = ((uint32_t)(input[38] & 0x7f) << 25) |
			((uint32_t)input[39] << 17) |
			((uint32_t)(input[40] & 0x80) << 9);
	output[19] = (double)(value >> 16);
}

static void unpack_20_16bit_unsigned_1off(const uint8_t * input, double * output, void *closure) {
	// Unpack 20 values into output
	// Values are 16-bit unsigned
	// Skip 1 bits, read 320 bits of data.
	// Input must be at least 41 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 1 to 16
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)input[1] << 17) |
			((uint32_t)(input[2] & 0x80) << 9);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 17 to 32
	value = ((uint32_t)(input[2] & 0x7f) << 25) |
			((uint32_t)input[3] << 17) |
			((uint32_t)(input[4] & 0x80) << 9);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 33 to 48
	value = ((uint32_t)(input[4] & 0x7f) << 25) |
			((uint32_t)input[5] << 17) |
			((uint32_t)(input[6] & 0x80) << 9);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 49 to 64
	value = ((uint32_t)(input[6] & 0x7f) << 25) |
			((uint32_t)input[7] << 17) |
			((uint32_t)(input[8] & 0x80) << 9);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 65 to 80
	value = ((uint32_t)(input[8] & 0x7f) << 25) |
			((uint32_t)input[9] << 17) |
			((uint32_t)(input[10] & 0x80) << 9);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 81 to 96
	value = ((uint32_t)(input[10] & 0x7f) << 25) |
			((uint32_t)input[11] << 17) |
			((uint32_t)(input[12] & 0x80) << 9);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 97 to 112
	value = ((uint32_t)(input[12] & 0x7f) << 25) |
			((uint32_t)input[13] << 17) |
			((uint32_t)(input[14] & 0x80) << 9);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 113 to 128
	value = ((uint32_t)(input[14] & 0x7f) << 25) |
			((uint32_t)input[15] << 17) |
			((uint32_t)(input[16] & 0x80) << 9);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 129 to 144
	value = ((uint32_t)(input[16] & 0x7f) << 25) |
			((uint32_t)input[17] << 17) |
			((uint32_t)(input[18] & 0x80) << 9);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 145 to 160
	value = ((uint32_t)(input[18] & 0x7f) << 25) |
			((uint32_t)input[19] << 17) |
			((uint32_t)(input[20] & 0x80) << 9);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 161 to 176
	value = ((uint32_t)(input[20] & 0x7f) << 25) |
			((uint32_t)input[21] << 17) |
			((uint32_t)(input[22] & 0x80) << 9);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 177 to 192
	value = ((uint32_t)(input[22] & 0x7f) << 25) |
			((uint32_t)input[23] << 17) |
			((uint32_t)(input[24] & 0x80) << 9);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 193 to 208
	value = ((uint32_t)(input[24] & 0x7f) << 25) |
			((uint32_t)input[25] << 17) |
			((uint32_t)(input[26] & 0x80) << 9);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 209 to 224
	value = ((uint32_t)(input[26] & 0x7f) << 25) |
			((uint32_t)input[27] << 17) |
			((uint32_t)(input[28] & 0x80) << 9);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 225 to 240
	value = ((uint32_t)(input[28] & 0x7f) << 25) |
			((uint32_t)input[29] << 17) |
			((uint32_t)(input[30] & 0x80) << 9);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 241 to 256
	value = ((uint32_t)(input[30] & 0x7f) << 25) |
			((uint32_t)input[31] << 17) |
			((uint32_t)(input[32] & 0x80) << 9);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 257 to 272
	value = ((uint32_t)(input[32] & 0x7f) << 25) |
			((uint32_t)input[33] << 17) |
			((uint32_t)(input[34] & 0x80) << 9);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 273 to 288
	value = ((uint32_t)(input[34] & 0x7f) << 25) |
			((uint32_t)input[35] << 17) |
			((uint32_t)(input[36] & 0x80) << 9);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 289 to 304
	value = ((uint32_t)(input[36] & 0x7f) << 25) |
			((uint32_t)input[37] << 17) |
			((uint32_t)(input[38] & 0x80) << 9);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 305 to 320
	value = ((uint32_t)(input[38] & 0x7f) << 25) |
			((uint32_t)input[39] << 17) |
			((uint32_t)(input[40] & 0x80) << 9);
	output[19] = (double)(value >> 16);
}

static void unpack_20_16bit_signed_2off(const uint8_t * input, double * output, void *closure) {
	// Unpack 20 values into output
	// Values are 16-bit signed
	// Skip 2 bits, read 320 bits of data.
	// Input must be at least 41 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 2 to 17
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)input[1] << 18) |
			((uint32_t)(input[2] & 0xc0) << 10);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 18 to 33
	value = ((uint32_t)(input[2] & 0x3f) << 26) |
			((uint32_t)input[3] << 18) |
			((uint32_t)(input[4] & 0xc0) << 10);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 34 to 49
	value = ((uint32_t)(input[4] & 0x3f) << 26) |
			((uint32_t)input[5] << 18) |
			((uint32_t)(input[6] & 0xc0) << 10);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 50 to 65
	value = ((uint32_t)(input[6] & 0x3f) << 26) |
			((uint32_t)input[7] << 18) |
			((uint32_t)(input[8] & 0xc0) << 10);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 66 to 81
	value = ((uint32_t)(input[8] & 0x3f) << 26) |
			((uint32_t)input[9] << 18) |
			((uint32_t)(input[10] & 0xc0) << 10);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 82 to 97
	value = ((uint32_t)(input[10] & 0x3f) << 26) |
			((uint32_t)input[11] << 18) |
			((uint32_t)(input[12] & 0xc0) << 10);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 98 to 113
	value = ((uint32_t)(input[12] & 0x3f) << 26) |
			((uint32_t)input[13] << 18) |
			((uint32_t)(input[14] & 0xc0) << 10);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 114 to 129
	value = ((uint32_t)(input[14] & 0x3f) << 26) |
			((uint32_t)input[15] << 18) |
			((uint32_t)(input[16] & 0xc0) << 10);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 130 to 145
	value = ((uint32_t)(input[16] & 0x3f) << 26) |
			((uint32_t)input[17] << 18) |
			((uint32_t)(input[18] & 0xc0) << 10);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 146 to 161
	value = ((uint32_t)(input[18] & 0x3f) << 26) |
			((uint32_t)input[19] << 18) |
			((uint32_t)(input[20] & 0xc0) << 10);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 162 to 177
	value = ((uint32_t)(input[20] & 0x3f) << 26) |
			((uint32_t)input[21] << 18) |
			((uint32_t)(input[22] & 0xc0) << 10);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 178 to 193
	value = ((uint32_t)(input[22] & 0x3f) << 26) |
			((uint32_t)input[23] << 18) |
			((uint32_t)(input[24] & 0xc0) << 10);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 194 to 209
	value = ((uint32_t)(input[24] & 0x3f) << 26) |
			((uint32_t)input[25] << 18) |
			((uint32_t)(input[26] & 0xc0) << 10);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 210 to 225
	value = ((uint32_t)(input[26] & 0x3f) << 26) |
			((uint32_t)input[27] << 18) |
			((uint32_t)(input[28] & 0xc0) << 10);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 226 to 241
	value = ((uint32_t)(input[28] & 0x3f) << 26) |
			((uint32_t)input[29] << 18) |
			((uint32_t)(input[30] & 0xc0) << 10);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 242 to 257
	value = ((uint32_t)(input[30] & 0x3f) << 26) |
			((uint32_t)input[31] << 18) |
			((uint32_t)(input[32] & 0xc0) << 10);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 258 to 273
	value = ((uint32_t)(input[32] & 0x3f) << 26) |
			((uint32_t)input[33] << 18) |
			((uint32_t)(input[34] & 0xc0) << 10);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 274 to 289
	value = ((uint32_t)(input[34] & 0x3f) << 26) |
			((uint32_t)input[35] << 18) |
			((uint32_t)(input[36] & 0xc0) << 10);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 290 to 305
	value = ((uint32_t)(input[36] & 0x3f) << 26) |
			((uint32_t)input[37] << 18) |
			((uint32_t)(input[38] & 0xc0) << 10);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 306 to 321
	value = ((uint32_t)(input[38] & 0x3f) << 26) |
			((uint32_t)input[39] << 18) |
			((uint32_t)(input[40] & 0xc0) << 10);
	output[19] = (double)(value >> 16);
}

static void unpack_20_16bit_unsigned_2off(const uint8_t * input, double * output, void *closure) {
	// Unpack 20 values into output
	// Values are 16-bit unsigned
	// Skip 2 bits, read 320 bits of data.
	// Input must be at least 41 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 2 to 17
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)input[1] << 18) |
			((uint32_t)(input[2] & 0xc0) << 10);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 18 to 33
	value = ((uint32_t)(input[2] & 0x3f) << 26) |
			((uint32_t)input[3] << 18) |
			((uint32_t)(input[4] & 0xc0) << 10);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 34 to 49
	value = ((uint32_t)(input[4] & 0x3f) << 26) |
			((uint32_t)input[5] << 18) |
			((uint32_t)(input[6] & 0xc0) << 10);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 50 to 65
	value = ((uint32_t)(input[6] & 0x3f) << 26) |
			((uint32_t)input[7] << 18) |
			((uint32_t)(input[8] & 0xc0) << 10);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 66 to 81
	value = ((uint32_t)(input[8] & 0x3f) << 26) |
			((uint32_t)input[9] << 18) |
			((uint32_t)(input[10] & 0xc0) << 10);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 82 to 97
	value = ((uint32_t)(input[10] & 0x3f) << 26) |
			((uint32_t)input[11] << 18) |
			((uint32_t)(input[12] & 0xc0) << 10);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 98 to 113
	value = ((uint32_t)(input[12] & 0x3f) << 26) |
			((uint32_t)input[13] << 18) |
			((uint32_t)(input[14] & 0xc0) << 10);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 114 to 129
	value = ((uint32_t)(input[14] & 0x3f) << 26) |
			((uint32_t)input[15] << 18) |
			((uint32_t)(input[16] & 0xc0) << 10);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 130 to 145
	value = ((uint32_t)(input[16] & 0x3f) << 26) |
			((uint32_t)input[17] << 18) |
			((uint32_t)(input[18] & 0xc0) << 10);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 146 to 161
	value = ((uint32_t)(input[18] & 0x3f) << 26) |
			((uint32_t)input[19] << 18) |
			((uint32_t)(input[20] & 0xc0) << 10);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 162 to 177
	value = ((uint32_t)(input[20] & 0x3f) << 26) |
			((uint32_t)input[21] << 18) |
			((uint32_t)(input[22] & 0xc0) << 10);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 178 to 193
	value = ((uint32_t)(input[22] & 0x3f) << 26) |
			((uint32_t)input[23] << 18) |
			((uint32_t)(input[24] & 0xc0) << 10);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 194 to 209
	value = ((uint32_t)(input[24] & 0x3f) << 26) |
			((uint32_t)input[25] << 18) |
			((uint32_t)(input[26] & 0xc0) << 10);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 210 to 225
	value = ((uint32_t)(input[26] & 0x3f) << 26) |
			((uint32_t)input[27] << 18) |
			((uint32_t)(input[28] & 0xc0) << 10);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 226 to 241
	value = ((uint32_t)(input[28] & 0x3f) << 26) |
			((uint32_t)input[29] << 18) |
			((uint32_t)(input[30] & 0xc0) << 10);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 242 to 257
	value = ((uint32_t)(input[30] & 0x3f) << 26) |
			((uint32_t)input[31] << 18) |
			((uint32_t)(input[32] & 0xc0) << 10);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 258 to 273
	value = ((uint32_t)(input[32] & 0x3f) << 26) |
			((uint32_t)input[33] << 18) |
			((uint32_t)(input[34] & 0xc0) << 10);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 274 to 289
	value = ((uint32_t)(input[34] & 0x3f) << 26) |
			((uint32_t)input[35] << 18) |
			((uint32_t)(input[36] & 0xc0) << 10);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 290 to 305
	value = ((uint32_t)(input[36] & 0x3f) << 26) |
			((uint32_t)input[37] << 18) |
			((uint32_t)(input[38] & 0xc0) << 10);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 306 to 321
	value = ((uint32_t)(input[38] & 0x3f) << 26) |
			((uint32_t)input[39] << 18) |
			((uint32_t)(input[40] & 0xc0) << 10);
	output[19] = (double)(value >> 16);
}

static void unpack_20_16bit_signed_3off(const uint8_t * input, double * output, void *closure) {
	// Unpack 20 values into output
	// Values are 16-bit signed
	// Skip 3 bits, read 320 bits of data.
	// Input must be at least 41 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 3 to 18
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)input[1] << 19) |
			((uint32_t)(input[2] & 0xe0) << 11);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 19 to 34
	value = ((uint32_t)(input[2] & 0x1f) << 27) |
			((uint32_t)input[3] << 19) |
			((uint32_t)(input[4] & 0xe0) << 11);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 35 to 50
	value = ((uint32_t)(input[4] & 0x1f) << 27) |
			((uint32_t)input[5] << 19) |
			((uint32_t)(input[6] & 0xe0) << 11);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 51 to 66
	value = ((uint32_t)(input[6] & 0x1f) << 27) |
			((uint32_t)input[7] << 19) |
			((uint32_t)(input[8] & 0xe0) << 11);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 67 to 82
	value = ((uint32_t)(input[8] & 0x1f) << 27) |
			((uint32_t)input[9] << 19) |
			((uint32_t)(input[10] & 0xe0) << 11);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 83 to 98
	value = ((uint32_t)(input[10] & 0x1f) << 27) |
			((uint32_t)input[11] << 19) |
			((uint32_t)(input[12] & 0xe0) << 11);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 99 to 114
	value = ((uint32_t)(input[12] & 0x1f) << 27) |
			((uint32_t)input[13] << 19) |
			((uint32_t)(input[14] & 0xe0) << 11);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 115 to 130
	value = ((uint32_t)(input[14] & 0x1f) << 27) |
			((uint32_t)input[15] << 19) |
			((uint32_t)(input[16] & 0xe0) << 11);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 131 to 146
	value = ((uint32_t)(input[16] & 0x1f) << 27) |
			((uint32_t)input[17] << 19) |
			((uint32_t)(input[18] & 0xe0) << 11);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 147 to 162
	value = ((uint32_t)(input[18] & 0x1f) << 27) |
			((uint32_t)input[19] << 19) |
			((uint32_t)(input[20] & 0xe0) << 11);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 163 to 178
	value = ((uint32_t)(input[20] & 0x1f) << 27) |
			((uint32_t)input[21] << 19) |
			((uint32_t)(input[22] & 0xe0) << 11);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 179 to 194
	value = ((uint32_t)(input[22] & 0x1f) << 27) |
			((uint32_t)input[23] << 19) |
			((uint32_t)(input[24] & 0xe0) << 11);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 195 to 210
	value = ((uint32_t)(input[24] & 0x1f) << 27) |
			((uint32_t)input[25] << 19) |
			((uint32_t)(input[26] & 0xe0) << 11);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 211 to 226
	value = ((uint32_t)(input[26] & 0x1f) << 27) |
			((uint32_t)input[27] << 19) |
			((uint32_t)(input[28] & 0xe0) << 11);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 227 to 242
	value = ((uint32_t)(input[28] & 0x1f) << 27) |
			((uint32_t)input[29] << 19) |
			((uint32_t)(input[30] & 0xe0) << 11);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 243 to 258
	value = ((uint32_t)(input[30] & 0x1f) << 27) |
			((uint32_t)input[31] << 19) |
			((uint32_t)(input[32] & 0xe0) << 11);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 259 to 274
	value = ((uint32_t)(input[32] & 0x1f) << 27) |
			((uint32_t)input[33] << 19) |
			((uint32_t)(input[34] & 0xe0) << 11);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 275 to 290
	value = ((uint32_t)(input[34] & 0x1f) << 27) |
			((uint32_t)input[35] << 19) |
			((uint32_t)(input[36] & 0xe0) << 11);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 291 to 306
	value = ((uint32_t)(input[36] & 0x1f) << 27) |
			((uint32_t)input[37] << 19) |
			((uint32_t)(input[38] & 0xe0) << 11);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 307 to 322
	value = ((uint32_t)(input[38] & 0x1f) << 27) |
			((uint32_t)input[39] << 19) |
			((uint32_t)(input[40] & 0xe0) << 11);
	output[19] = (double)(value >> 16);
}

static void unpack_20_16bit_unsigned_3off(const uint8_t * input, double * output, void *closure) {
	// Unpack 20 values into output
	// Values are 16-bit unsigned
	// Skip 3 bits, read 320 bits of data.
	// Input must be at least 41 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 3 to 18
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)input[1] << 19) |
			((uint32_t)(input[2] & 0xe0) << 11);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 19 to 34
	value = ((uint32_t)(input[2] & 0x1f) << 27) |
			((uint32_t)input[3] << 19) |
			((uint32_t)(input[4] & 0xe0) << 11);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 35 to 50
	value = ((uint32_t)(input[4] & 0x1f) << 27) |
			((uint32_t)input[5] << 19) |
			((uint32_t)(input[6] & 0xe0) << 11);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 51 to 66
	value = ((uint32_t)(input[6] & 0x1f) << 27) |
			((uint32_t)input[7] << 19) |
			((uint32_t)(input[8] & 0xe0) << 11);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 67 to 82
	value = ((uint32_t)(input[8] & 0x1f) << 27) |
			((uint32_t)input[9] << 19) |
			((uint32_t)(input[10] & 0xe0) << 11);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 83 to 98
	value = ((uint32_t)(input[10] & 0x1f) << 27) |
			((uint32_t)input[11] << 19) |
			((uint32_t)(input[12] & 0xe0) << 11);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 99 to 114
	value = ((uint32_t)(input[12] & 0x1f) << 27) |
			((uint32_t)input[13] << 19) |
			((uint32_t)(input[14] & 0xe0) << 11);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 115 to 130
	value = ((uint32_t)(input[14] & 0x1f) << 27) |
			((uint32_t)input[15] << 19) |
			((uint32_t)(input[16] & 0xe0) << 11);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 131 to 146
	value = ((uint32_t)(input[16] & 0x1f) << 27) |
			((uint32_t)input[17] << 19) |
			((uint32_t)(input[18] & 0xe0) << 11);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 147 to 162
	value = ((uint32_t)(input[18] & 0x1f) << 27) |
			((uint32_t)input[19] << 19) |
			((uint32_t)(input[20] & 0xe0) << 11);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 163 to 178
	value = ((uint32_t)(input[20] & 0x1f) << 27) |
			((uint32_t)input[21] << 19) |
			((uint32_t)(input[22] & 0xe0) << 11);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 179 to 194
	value = ((uint32_t)(input[22] & 0x1f) << 27) |
			((uint32_t)input[23] << 19) |
			((uint32_t)(input[24] & 0xe0) << 11);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 195 to 210
	value = ((uint32_t)(input[24] & 0x1f) << 27) |
			((uint32_t)input[25] << 19) |
			((uint32_t)(input[26] & 0xe0) << 11);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 211 to 226
	value = ((uint32_t)(input[26] & 0x1f) << 27) |
			((uint32_t)input[27] << 19) |
			((uint32_t)(input[28] & 0xe0) << 11);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 227 to 242
	value = ((uint32_t)(input[28] & 0x1f) << 27) |
			((uint32_t)input[29] << 19) |
			((uint32_t)(input[30] & 0xe0) << 11);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 243 to 258
	value = ((uint32_t)(input[30] & 0x1f) << 27) |
			((uint32_t)input[31] << 19) |
			((uint32_t)(input[32] & 0xe0) << 11);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 259 to 274
	value = ((uint32_t)(input[32] & 0x1f) << 27) |
			((uint32_t)input[33] << 19) |
			((uint32_t)(input[34] & 0xe0) << 11);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 275 to 290
	value = ((uint32_t)(input[34] & 0x1f) << 27) |
			((uint32_t)input[35] << 19) |
			((uint32_t)(input[36] & 0xe0) << 11);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 291 to 306
	value = ((uint32_t)(input[36] & 0x1f) << 27) |
			((uint32_t)input[37] << 19) |
			((uint32_t)(input[38] & 0xe0) << 11);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 307 to 322
	value = ((uint32_t)(input[38] & 0x1f) << 27) |
			((uint32_t)input[39] << 19) |
			((uint32_t)(input[40] & 0xe0) << 11);
	output[19] = (double)(value >> 16);
}

static void unpack_20_16bit_signed_4off(const uint8_t * input, double * output, void *closure) {
	// Unpack 20 values into output
	// Values are 16-bit signed
	// Skip 4 bits, read 320 bits of data.
	// Input must be at least 41 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 4 to 19
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20) |
			((uint32_t)(input[2] & 0xf0) << 12);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 20 to 35
	value = ((uint32_t)(input[2] & 0x0f) << 28) |
			((uint32_t)input[3] << 20) |
			((uint32_t)(input[4] & 0xf0) << 12);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 36 to 51
	value = ((uint32_t)(input[4] & 0x0f) << 28) |
			((uint32_t)input[5] << 20) |
			((uint32_t)(input[6] & 0xf0) << 12);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 52 to 67
	value = ((uint32_t)(input[6] & 0x0f) << 28) |
			((uint32_t)input[7] << 20) |
			((uint32_t)(input[8] & 0xf0) << 12);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 68 to 83
	value = ((uint32_t)(input[8] & 0x0f) << 28) |
			((uint32_t)input[9] << 20) |
			((uint32_t)(input[10] & 0xf0) << 12);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 84 to 99
	value = ((uint32_t)(input[10] & 0x0f) << 28) |
			((uint32_t)input[11] << 20) |
			((uint32_t)(input[12] & 0xf0) << 12);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 100 to 115
	value = ((uint32_t)(input[12] & 0x0f) << 28) |
			((uint32_t)input[13] << 20) |
			((uint32_t)(input[14] & 0xf0) << 12);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 116 to 131
	value = ((uint32_t)(input[14] & 0x0f) << 28) |
			((uint32_t)input[15] << 20) |
			((uint32_t)(input[16] & 0xf0) << 12);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 132 to 147
	value = ((uint32_t)(input[16] & 0x0f) << 28) |
			((uint32_t)input[17] << 20) |
			((uint32_t)(input[18] & 0xf0) << 12);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 148 to 163
	value = ((uint32_t)(input[18] & 0x0f) << 28) |
			((uint32_t)input[19] << 20) |
			((uint32_t)(input[20] & 0xf0) << 12);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 164 to 179
	value = ((uint32_t)(input[20] & 0x0f) << 28) |
			((uint32_t)input[21] << 20) |
			((uint32_t)(input[22] & 0xf0) << 12);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 180 to 195
	value = ((uint32_t)(input[22] & 0x0f) << 28) |
			((uint32_t)input[23] << 20) |
			((uint32_t)(input[24] & 0xf0) << 12);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 196 to 211
	value = ((uint32_t)(input[24] & 0x0f) << 28) |
			((uint32_t)input[25] << 20) |
			((uint32_t)(input[26] & 0xf0) << 12);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 212 to 227
	value = ((uint32_t)(input[26] & 0x0f) << 28) |
			((uint32_t)input[27] << 20) |
			((uint32_t)(input[28] & 0xf0) << 12);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 228 to 243
	value = ((uint32_t)(input[28] & 0x0f) << 28) |
			((uint32_t)input[29] << 20) |
			((uint32_t)(input[30] & 0xf0) << 12);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 244 to 259
	value = ((uint32_t)(input[30] & 0x0f) << 28) |
			((uint32_t)input[31] << 20) |
			((uint32_t)(input[32] & 0xf0) << 12);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 260 to 275
	value = ((uint32_t)(input[32] & 0x0f) << 28) |
			((uint32_t)input[33] << 20) |
			((uint32_t)(input[34] & 0xf0) << 12);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 276 to 291
	value = ((uint32_t)(input[34] & 0x0f) << 28) |
			((uint32_t)input[35] << 20) |
			((uint32_t)(input[36] & 0xf0) << 12);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 292 to 307
	value = ((uint32_t)(input[36] & 0x0f) << 28) |
			((uint32_t)input[37] << 20) |
			((uint32_t)(input[38] & 0xf0) << 12);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 308 to 323
	value = ((uint32_t)(input[38] & 0x0f) << 28) |
			((uint32_t)input[39] << 20) |
			((uint32_t)(input[40] & 0xf0) << 12);
	output[19] = (double)(value >> 16);
}

static void unpack_20_16bit_unsigned_4off(const uint8_t * input, double * output, void *closure) {
	// Unpack 20 values into output
	// Values are 16-bit unsigned
	// Skip 4 bits, read 320 bits of data.
	// Input must be at least 41 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 4 to 19
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20) |
			((uint32_t)(input[2] & 0xf0) << 12);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 20 to 35
	value = ((uint32_t)(input[2] & 0x0f) << 28) |
			((uint32_t)input[3] << 20) |
			((uint32_t)(input[4] & 0xf0) << 12);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 36 to 51
	value = ((uint32_t)(input[4] & 0x0f) << 28) |
			((uint32_t)input[5] << 20) |
			((uint32_t)(input[6] & 0xf0) << 12);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 52 to 67
	value = ((uint32_t)(input[6] & 0x0f) << 28) |
			((uint32_t)input[7] << 20) |
			((uint32_t)(input[8] & 0xf0) << 12);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 68 to 83
	value = ((uint32_t)(input[8] & 0x0f) << 28) |
			((uint32_t)input[9] << 20) |
			((uint32_t)(input[10] & 0xf0) << 12);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 84 to 99
	value = ((uint32_t)(input[10] & 0x0f) << 28) |
			((uint32_t)input[11] << 20) |
			((uint32_t)(input[12] & 0xf0) << 12);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 100 to 115
	value = ((uint32_t)(input[12] & 0x0f) << 28) |
			((uint32_t)input[13] << 20) |
			((uint32_t)(input[14] & 0xf0) << 12);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 116 to 131
	value = ((uint32_t)(input[14] & 0x0f) << 28) |
			((uint32_t)input[15] << 20) |
			((uint32_t)(input[16] & 0xf0) << 12);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 132 to 147
	value = ((uint32_t)(input[16] & 0x0f) << 28) |
			((uint32_t)input[17] << 20) |
			((uint32_t)(input[18] & 0xf0) << 12);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 148 to 163
	value = ((uint32_t)(input[18] & 0x0f) << 28) |
			((uint32_t)input[19] << 20) |
			((uint32_t)(input[20] & 0xf0) << 12);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 164 to 179
	value = ((uint32_t)(input[20] & 0x0f) << 28) |
			((uint32_t)input[21] << 20) |
			((uint32_t)(input[22] & 0xf0) << 12);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 180 to 195
	value = ((uint32_t)(input[22] & 0x0f) << 28) |
			((uint32_t)input[23] << 20) |
			((uint32_t)(input[24] & 0xf0) << 12);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 196 to 211
	value = ((uint32_t)(input[24] & 0x0f) << 28) |
			((uint32_t)input[25] << 20) |
			((uint32_t)(input[26] & 0xf0) << 12);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 212 to 227
	value = ((uint32_t)(input[26] & 0x0f) << 28) |
			((uint32_t)input[27] << 20) |
			((uint32_t)(input[28] & 0xf0) << 12);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 228 to 243
	value = ((uint32_t)(input[28] & 0x0f) << 28) |
			((uint32_t)input[29] << 20) |
			((uint32_t)(input[30] & 0xf0) << 12);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 244 to 259
	value = ((uint32_t)(input[30] & 0x0f) << 28) |
			((uint32_t)input[31] << 20) |
			((uint32_t)(input[32] & 0xf0) << 12);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 260 to 275
	value = ((uint32_t)(input[32] & 0x0f) << 28) |
			((uint32_t)input[33] << 20) |
			((uint32_t)(input[34] & 0xf0) << 12);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 276 to 291
	value = ((uint32_t)(input[34] & 0x0f) << 28) |
			((uint32_t)input[35] << 20) |
			((uint32_t)(input[36] & 0xf0) << 12);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 292 to 307
	value = ((uint32_t)(input[36] & 0x0f) << 28) |
			((uint32_t)input[37] << 20) |
			((uint32_t)(input[38] & 0xf0) << 12);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 308 to 323
	value = ((uint32_t)(input[38] & 0x0f) << 28) |
			((uint32_t)input[39] << 20) |
			((uint32_t)(input[40] & 0xf0) << 12);
	output[19] = (double)(value >> 16);
}

static void unpack_20_16bit_signed_5off(const uint8_t * input, double * output, void *closure) {
	// Unpack 20 values into output
	// Values are 16-bit signed
	// Skip 5 bits, read 320 bits of data.
	// Input must be at least 41 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 5 to 20
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)(input[2] & 0xf8) << 13);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 21 to 36
	value = ((uint32_t)(input[2] & 0x07) << 29) |
			((uint32_t)input[3] << 21) |
			((uint32_t)(input[4] & 0xf8) << 13);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 37 to 52
	value = ((uint32_t)(input[4] & 0x07) << 29) |
			((uint32_t)input[5] << 21) |
			((uint32_t)(input[6] & 0xf8) << 13);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 53 to 68
	value = ((uint32_t)(input[6] & 0x07) << 29) |
			((uint32_t)input[7] << 21) |
			((uint32_t)(input[8] & 0xf8) << 13);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 69 to 84
	value = ((uint32_t)(input[8] & 0x07) << 29) |
			((uint32_t)input[9] << 21) |
			((uint32_t)(input[10] & 0xf8) << 13);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 85 to 100
	value = ((uint32_t)(input[10] & 0x07) << 29) |
			((uint32_t)input[11] << 21) |
			((uint32_t)(input[12] & 0xf8) << 13);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 101 to 116
	value = ((uint32_t)(input[12] & 0x07) << 29) |
			((uint32_t)input[13] << 21) |
			((uint32_t)(input[14] & 0xf8) << 13);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 117 to 132
	value = ((uint32_t)(input[14] & 0x07) << 29) |
			((uint32_t)input[15] << 21) |
			((uint32_t)(input[16] & 0xf8) << 13);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 133 to 148
	value = ((uint32_t)(input[16] & 0x07) << 29) |
			((uint32_t)input[17] << 21) |
			((uint32_t)(input[18] & 0xf8) << 13);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 149 to 164
	value = ((uint32_t)(input[18] & 0x07) << 29) |
			((uint32_t)input[19] << 21) |
			((uint32_t)(input[20] & 0xf8) << 13);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 165 to 180
	value = ((uint32_t)(input[20] & 0x07) << 29) |
			((uint32_t)input[21] << 21) |
			((uint32_t)(input[22] & 0xf8) << 13);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 181 to 196
	value = ((uint32_t)(input[22] & 0x07) << 29) |
			((uint32_t)input[23] << 21) |
			((uint32_t)(input[24] & 0xf8) << 13);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 197 to 212
	value = ((uint32_t)(input[24] & 0x07) << 29) |
			((uint32_t)input[25] << 21) |
			((uint32_t)(input[26] & 0xf8) << 13);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 213 to 228
	value = ((uint32_t)(input[26] & 0x07) << 29) |
			((uint32_t)input[27] << 21) |
			((uint32_t)(input[28] & 0xf8) << 13);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 229 to 244
	value = ((uint32_t)(input[28] & 0x07) << 29) |
			((uint32_t)input[29] << 21) |
			((uint32_t)(input[30] & 0xf8) << 13);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 245 to 260
	value = ((uint32_t)(input[30] & 0x07) << 29) |
			((uint32_t)input[31] << 21) |
			((uint32_t)(input[32] & 0xf8) << 13);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 261 to 276
	value = ((uint32_t)(input[32] & 0x07) << 29) |
			((uint32_t)input[33] << 21) |
			((uint32_t)(input[34] & 0xf8) << 13);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 277 to 292
	value = ((uint32_t)(input[34] & 0x07) << 29) |
			((uint32_t)input[35] << 21) |
			((uint32_t)(input[36] & 0xf8) << 13);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 293 to 308
	value = ((uint32_t)(input[36] & 0x07) << 29) |
			((uint32_t)input[37] << 21) |
			((uint32_t)(input[38] & 0xf8) << 13);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 309 to 324
	value = ((uint32_t)(input[38] & 0x07) << 29) |
			((uint32_t)input[39] << 21) |
			((uint32_t)(input[40] & 0xf8) << 13);
	output[19] = (double)(value >> 16);
}

static void unpack_20_16bit_unsigned_5off(const uint8_t * input, double * output, void *closure) {
	// Unpack 20 values into output
	// Values are 16-bit unsigned
	// Skip 5 bits, read 320 bits of data.
	// Input must be at least 41 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 5 to 20
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)(input[2] & 0xf8) << 13);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 21 to 36
	value = ((uint32_t)(input[2] & 0x07) << 29) |
			((uint32_t)input[3] << 21) |
			((uint32_t)(input[4] & 0xf8) << 13);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 37 to 52
	value = ((uint32_t)(input[4] & 0x07) << 29) |
			((uint32_t)input[5] << 21) |
			((uint32_t)(input[6] & 0xf8) << 13);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 53 to 68
	value = ((uint32_t)(input[6] & 0x07) << 29) |
			((uint32_t)input[7] << 21) |
			((uint32_t)(input[8] & 0xf8) << 13);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 69 to 84
	value = ((uint32_t)(input[8] & 0x07) << 29) |
			((uint32_t)input[9] << 21) |
			((uint32_t)(input[10] & 0xf8) << 13);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 85 to 100
	value = ((uint32_t)(input[10] & 0x07) << 29) |
			((uint32_t)input[11] << 21) |
			((uint32_t)(input[12] & 0xf8) << 13);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 101 to 116
	value = ((uint32_t)(input[12] & 0x07) << 29) |
			((uint32_t)input[13] << 21) |
			((uint32_t)(input[14] & 0xf8) << 13);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 117 to 132
	value = ((uint32_t)(input[14] & 0x07) << 29) |
			((uint32_t)input[15] << 21) |
			((uint32_t)(input[16] & 0xf8) << 13);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 133 to 148
	value = ((uint32_t)(input[16] & 0x07) << 29) |
			((uint32_t)input[17] << 21) |
			((uint32_t)(input[18] & 0xf8) << 13);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 149 to 164
	value = ((uint32_t)(input[18] & 0x07) << 29) |
			((uint32_t)input[19] << 21) |
			((uint32_t)(input[20] & 0xf8) << 13);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 165 to 180
	value = ((uint32_t)(input[20] & 0x07) << 29) |
			((uint32_t)input[21] << 21) |
			((uint32_t)(input[22] & 0xf8) << 13);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 181 to 196
	value = ((uint32_t)(input[22] & 0x07) << 29) |
			((uint32_t)input[23] << 21) |
			((uint32_t)(input[24] & 0xf8) << 13);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 197 to 212
	value = ((uint32_t)(input[24] & 0x07) << 29) |
			((uint32_t)input[25] << 21) |
			((uint32_t)(input[26] & 0xf8) << 13);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 213 to 228
	value = ((uint32_t)(input[26] & 0x07) << 29) |
			((uint32_t)input[27] << 21) |
			((uint32_t)(input[28] & 0xf8) << 13);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 229 to 244
	value = ((uint32_t)(input[28] & 0x07) << 29) |
			((uint32_t)input[29] << 21) |
			((uint32_t)(input[30] & 0xf8) << 13);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 245 to 260
	value = ((uint32_t)(input[30] & 0x07) << 29) |
			((uint32_t)input[31] << 21) |
			((uint32_t)(input[32] & 0xf8) << 13);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 261 to 276
	value = ((uint32_t)(input[32] & 0x07) << 29) |
			((uint32_t)input[33] << 21) |
			((uint32_t)(input[34] & 0xf8) << 13);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 277 to 292
	value = ((uint32_t)(input[34] & 0x07) << 29) |
			((uint32_t)input[35] << 21) |
			((uint32_t)(input[36] & 0xf8) << 13);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 293 to 308
	value = ((uint32_t)(input[36] & 0x07) << 29) |
			((uint32_t)input[37] << 21) |
			((uint32_t)(input[38] & 0xf8) << 13);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 309 to 324
	value = ((uint32_t)(input[38] & 0x07) << 29) |
			((uint32_t)input[39] << 21) |
			((uint32_t)(input[40] & 0xf8) << 13);
	output[19] = (double)(value >> 16);
}

static void unpack_20_16bit_signed_6off(const uint8_t * input, double * output, void *closure) {
	// Unpack 20 values into output
	// Values are 16-bit signed
	// Skip 6 bits, read 320 bits of data.
	// Input must be at least 41 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 6 to 21
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)(input[2] & 0xfc) << 14);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 22 to 37
	value = ((uint32_t)(input[2] & 0x03) << 30) |
			((uint32_t)input[3] << 22) |
			((uint32_t)(input[4] & 0xfc) << 14);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 38 to 53
	value = ((uint32_t)(input[4] & 0x03) << 30) |
			((uint32_t)input[5] << 22) |
			((uint32_t)(input[6] & 0xfc) << 14);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 54 to 69
	value = ((uint32_t)(input[6] & 0x03) << 30) |
			((uint32_t)input[7] << 22) |
			((uint32_t)(input[8] & 0xfc) << 14);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 70 to 85
	value = ((uint32_t)(input[8] & 0x03) << 30) |
			((uint32_t)input[9] << 22) |
			((uint32_t)(input[10] & 0xfc) << 14);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 86 to 101
	value = ((uint32_t)(input[10] & 0x03) << 30) |
			((uint32_t)input[11] << 22) |
			((uint32_t)(input[12] & 0xfc) << 14);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 102 to 117
	value = ((uint32_t)(input[12] & 0x03) << 30) |
			((uint32_t)input[13] << 22) |
			((uint32_t)(input[14] & 0xfc) << 14);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 118 to 133
	value = ((uint32_t)(input[14] & 0x03) << 30) |
			((uint32_t)input[15] << 22) |
			((uint32_t)(input[16] & 0xfc) << 14);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 134 to 149
	value = ((uint32_t)(input[16] & 0x03) << 30) |
			((uint32_t)input[17] << 22) |
			((uint32_t)(input[18] & 0xfc) << 14);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 150 to 165
	value = ((uint32_t)(input[18] & 0x03) << 30) |
			((uint32_t)input[19] << 22) |
			((uint32_t)(input[20] & 0xfc) << 14);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 166 to 181
	value = ((uint32_t)(input[20] & 0x03) << 30) |
			((uint32_t)input[21] << 22) |
			((uint32_t)(input[22] & 0xfc) << 14);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 182 to 197
	value = ((uint32_t)(input[22] & 0x03) << 30) |
			((uint32_t)input[23] << 22) |
			((uint32_t)(input[24] & 0xfc) << 14);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 198 to 213
	value = ((uint32_t)(input[24] & 0x03) << 30) |
			((uint32_t)input[25] << 22) |
			((uint32_t)(input[26] & 0xfc) << 14);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 214 to 229
	value = ((uint32_t)(input[26] & 0x03) << 30) |
			((uint32_t)input[27] << 22) |
			((uint32_t)(input[28] & 0xfc) << 14);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 230 to 245
	value = ((uint32_t)(input[28] & 0x03) << 30) |
			((uint32_t)input[29] << 22) |
			((uint32_t)(input[30] & 0xfc) << 14);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 246 to 261
	value = ((uint32_t)(input[30] & 0x03) << 30) |
			((uint32_t)input[31] << 22) |
			((uint32_t)(input[32] & 0xfc) << 14);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 262 to 277
	value = ((uint32_t)(input[32] & 0x03) << 30) |
			((uint32_t)input[33] << 22) |
			((uint32_t)(input[34] & 0xfc) << 14);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 278 to 293
	value = ((uint32_t)(input[34] & 0x03) << 30) |
			((uint32_t)input[35] << 22) |
			((uint32_t)(input[36] & 0xfc) << 14);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 294 to 309
	value = ((uint32_t)(input[36] & 0x03) << 30) |
			((uint32_t)input[37] << 22) |
			((uint32_t)(input[38] & 0xfc) << 14);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 310 to 325
	value = ((uint32_t)(input[38] & 0x03) << 30) |
			((uint32_t)input[39] << 22) |
			((uint32_t)(input[40] & 0xfc) << 14);
	output[19] = (double)(value >> 16);
}

static void unpack_20_16bit_unsigned_6off(const uint8_t * input, double * output, void *closure) {
	// Unpack 20 values into output
	// Values are 16-bit unsigned
	// Skip 6 bits, read 320 bits of data.
	// Input must be at least 41 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 6 to 21
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)(input[2] & 0xfc) << 14);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 22 to 37
	value = ((uint32_t)(input[2] & 0x03) << 30) |
			((uint32_t)input[3] << 22) |
			((uint32_t)(input[4] & 0xfc) << 14);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 38 to 53
	value = ((uint32_t)(input[4] & 0x03) << 30) |
			((uint32_t)input[5] << 22) |
			((uint32_t)(input[6] & 0xfc) << 14);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 54 to 69
	value = ((uint32_t)(input[6] & 0x03) << 30) |
			((uint32_t)input[7] << 22) |
			((uint32_t)(input[8] & 0xfc) << 14);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 70 to 85
	value = ((uint32_t)(input[8] & 0x03) << 30) |
			((uint32_t)input[9] << 22) |
			((uint32_t)(input[10] & 0xfc) << 14);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 86 to 101
	value = ((uint32_t)(input[10] & 0x03) << 30) |
			((uint32_t)input[11] << 22) |
			((uint32_t)(input[12] & 0xfc) << 14);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 102 to 117
	value = ((uint32_t)(input[12] & 0x03) << 30) |
			((uint32_t)input[13] << 22) |
			((uint32_t)(input[14] & 0xfc) << 14);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 118 to 133
	value = ((uint32_t)(input[14] & 0x03) << 30) |
			((uint32_t)input[15] << 22) |
			((uint32_t)(input[16] & 0xfc) << 14);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 134 to 149
	value = ((uint32_t)(input[16] & 0x03) << 30) |
			((uint32_t)input[17] << 22) |
			((uint32_t)(input[18] & 0xfc) << 14);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 150 to 165
	value = ((uint32_t)(input[18] & 0x03) << 30) |
			((uint32_t)input[19] << 22) |
			((uint32_t)(input[20] & 0xfc) << 14);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 166 to 181
	value = ((uint32_t)(input[20] & 0x03) << 30) |
			((uint32_t)input[21] << 22) |
			((uint32_t)(input[22] & 0xfc) << 14);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 182 to 197
	value = ((uint32_t)(input[22] & 0x03) << 30) |
			((uint32_t)input[23] << 22) |
			((uint32_t)(input[24] & 0xfc) << 14);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 198 to 213
	value = ((uint32_t)(input[24] & 0x03) << 30) |
			((uint32_t)input[25] << 22) |
			((uint32_t)(input[26] & 0xfc) << 14);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 214 to 229
	value = ((uint32_t)(input[26] & 0x03) << 30) |
			((uint32_t)input[27] << 22) |
			((uint32_t)(input[28] & 0xfc) << 14);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 230 to 245
	value = ((uint32_t)(input[28] & 0x03) << 30) |
			((uint32_t)input[29] << 22) |
			((uint32_t)(input[30] & 0xfc) << 14);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 246 to 261
	value = ((uint32_t)(input[30] & 0x03) << 30) |
			((uint32_t)input[31] << 22) |
			((uint32_t)(input[32] & 0xfc) << 14);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 262 to 277
	value = ((uint32_t)(input[32] & 0x03) << 30) |
			((uint32_t)input[33] << 22) |
			((uint32_t)(input[34] & 0xfc) << 14);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 278 to 293
	value = ((uint32_t)(input[34] & 0x03) << 30) |
			((uint32_t)input[35] << 22) |
			((uint32_t)(input[36] & 0xfc) << 14);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 294 to 309
	value = ((uint32_t)(input[36] & 0x03) << 30) |
			((uint32_t)input[37] << 22) |
			((uint32_t)(input[38] & 0xfc) << 14);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 310 to 325
	value = ((uint32_t)(input[38] & 0x03) << 30) |
			((uint32_t)input[39] << 22) |
			((uint32_t)(input[40] & 0xfc) << 14);
	output[19] = (double)(value >> 16);
}

static void unpack_20_16bit_signed_7off(const uint8_t * input, double * output, void *closure) {
	// Unpack 20 values into output
	// Values are 16-bit signed
	// Skip 7 bits, read 320 bits of data.
	// Input must be at least 41 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 7 to 22
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)(input[2] & 0xfe) << 15);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 23 to 38
	value = ((uint32_t)(input[2] & 0x01) << 31) |
			((uint32_t)input[3] << 23) |
			((uint32_t)(input[4] & 0xfe) << 15);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 39 to 54
	value = ((uint32_t)(input[4] & 0x01) << 31) |
			((uint32_t)input[5] << 23) |
			((uint32_t)(input[6] & 0xfe) << 15);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 55 to 70
	value = ((uint32_t)(input[6] & 0x01) << 31) |
			((uint32_t)input[7] << 23) |
			((uint32_t)(input[8] & 0xfe) << 15);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 71 to 86
	value = ((uint32_t)(input[8] & 0x01) << 31) |
			((uint32_t)input[9] << 23) |
			((uint32_t)(input[10] & 0xfe) << 15);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 87 to 102
	value = ((uint32_t)(input[10] & 0x01) << 31) |
			((uint32_t)input[11] << 23) |
			((uint32_t)(input[12] & 0xfe) << 15);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 103 to 118
	value = ((uint32_t)(input[12] & 0x01) << 31) |
			((uint32_t)input[13] << 23) |
			((uint32_t)(input[14] & 0xfe) << 15);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 119 to 134
	value = ((uint32_t)(input[14] & 0x01) << 31) |
			((uint32_t)input[15] << 23) |
			((uint32_t)(input[16] & 0xfe) << 15);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 135 to 150
	value = ((uint32_t)(input[16] & 0x01) << 31) |
			((uint32_t)input[17] << 23) |
			((uint32_t)(input[18] & 0xfe) << 15);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 151 to 166
	value = ((uint32_t)(input[18] & 0x01) << 31) |
			((uint32_t)input[19] << 23) |
			((uint32_t)(input[20] & 0xfe) << 15);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 167 to 182
	value = ((uint32_t)(input[20] & 0x01) << 31) |
			((uint32_t)input[21] << 23) |
			((uint32_t)(input[22] & 0xfe) << 15);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 183 to 198
	value = ((uint32_t)(input[22] & 0x01) << 31) |
			((uint32_t)input[23] << 23) |
			((uint32_t)(input[24] & 0xfe) << 15);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 199 to 214
	value = ((uint32_t)(input[24] & 0x01) << 31) |
			((uint32_t)input[25] << 23) |
			((uint32_t)(input[26] & 0xfe) << 15);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 215 to 230
	value = ((uint32_t)(input[26] & 0x01) << 31) |
			((uint32_t)input[27] << 23) |
			((uint32_t)(input[28] & 0xfe) << 15);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 231 to 246
	value = ((uint32_t)(input[28] & 0x01) << 31) |
			((uint32_t)input[29] << 23) |
			((uint32_t)(input[30] & 0xfe) << 15);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 247 to 262
	value = ((uint32_t)(input[30] & 0x01) << 31) |
			((uint32_t)input[31] << 23) |
			((uint32_t)(input[32] & 0xfe) << 15);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 263 to 278
	value = ((uint32_t)(input[32] & 0x01) << 31) |
			((uint32_t)input[33] << 23) |
			((uint32_t)(input[34] & 0xfe) << 15);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 279 to 294
	value = ((uint32_t)(input[34] & 0x01) << 31) |
			((uint32_t)input[35] << 23) |
			((uint32_t)(input[36] & 0xfe) << 15);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 295 to 310
	value = ((uint32_t)(input[36] & 0x01) << 31) |
			((uint32_t)input[37] << 23) |
			((uint32_t)(input[38] & 0xfe) << 15);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 311 to 326
	value = ((uint32_t)(input[38] & 0x01) << 31) |
			((uint32_t)input[39] << 23) |
			((uint32_t)(input[40] & 0xfe) << 15);
	output[19] = (double)(value >> 16);
}

static void unpack_20_16bit_unsigned_7off(const uint8_t * input, double * output, void *closure) {
	// Unpack 20 values into output
	// Values are 16-bit unsigned
	// Skip 7 bits, read 320 bits of data.
	// Input must be at least 41 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 7 to 22
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)(input[2] & 0xfe) << 15);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 23 to 38
	value = ((uint32_t)(input[2] & 0x01) << 31) |
			((uint32_t)input[3] << 23) |
			((uint32_t)(input[4] & 0xfe) << 15);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 39 to 54
	value = ((uint32_t)(input[4] & 0x01) << 31) |
			((uint32_t)input[5] << 23) |
			((uint32_t)(input[6] & 0xfe) << 15);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 55 to 70
	value = ((uint32_t)(input[6] & 0x01) << 31) |
			((uint32_t)input[7] << 23) |
			((uint32_t)(input[8] & 0xfe) << 15);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 71 to 86
	value = ((uint32_t)(input[8] & 0x01) << 31) |
			((uint32_t)input[9] << 23) |
			((uint32_t)(input[10] & 0xfe) << 15);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 87 to 102
	value = ((uint32_t)(input[10] & 0x01) << 31) |
			((uint32_t)input[11] << 23) |
			((uint32_t)(input[12] & 0xfe) << 15);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 103 to 118
	value = ((uint32_t)(input[12] & 0x01) << 31) |
			((uint32_t)input[13] << 23) |
			((uint32_t)(input[14] & 0xfe) << 15);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 119 to 134
	value = ((uint32_t)(input[14] & 0x01) << 31) |
			((uint32_t)input[15] << 23) |
			((uint32_t)(input[16] & 0xfe) << 15);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 135 to 150
	value = ((uint32_t)(input[16] & 0x01) << 31) |
			((uint32_t)input[17] << 23) |
			((uint32_t)(input[18] & 0xfe) << 15);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 151 to 166
	value = ((uint32_t)(input[18] & 0x01) << 31) |
			((uint32_t)input[19] << 23) |
			((uint32_t)(input[20] & 0xfe) << 15);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 167 to 182
	value = ((uint32_t)(input[20] & 0x01) << 31) |
			((uint32_t)input[21] << 23) |
			((uint32_t)(input[22] & 0xfe) << 15);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 183 to 198
	value = ((uint32_t)(input[22] & 0x01) << 31) |
			((uint32_t)input[23] << 23) |
			((uint32_t)(input[24] & 0xfe) << 15);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 199 to 214
	value = ((uint32_t)(input[24] & 0x01) << 31) |
			((uint32_t)input[25] << 23) |
			((uint32_t)(input[26] & 0xfe) << 15);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 215 to 230
	value = ((uint32_t)(input[26] & 0x01) << 31) |
			((uint32_t)input[27] << 23) |
			((uint32_t)(input[28] & 0xfe) << 15);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 231 to 246
	value = ((uint32_t)(input[28] & 0x01) << 31) |
			((uint32_t)input[29] << 23) |
			((uint32_t)(input[30] & 0xfe) << 15);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 247 to 262
	value = ((uint32_t)(input[30] & 0x01) << 31) |
			((uint32_t)input[31] << 23) |
			((uint32_t)(input[32] & 0xfe) << 15);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 263 to 278
	value = ((uint32_t)(input[32] & 0x01) << 31) |
			((uint32_t)input[33] << 23) |
			((uint32_t)(input[34] & 0xfe) << 15);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 279 to 294
	value = ((uint32_t)(input[34] & 0x01) << 31) |
			((uint32_t)input[35] << 23) |
			((uint32_t)(input[36] & 0xfe) << 15);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 295 to 310
	value = ((uint32_t)(input[36] & 0x01) << 31) |
			((uint32_t)input[37] << 23) |
			((uint32_t)(input[38] & 0xfe) << 15);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 311 to 326
	value = ((uint32_t)(input[38] & 0x01) << 31) |
			((uint32_t)input[39] << 23) |
			((uint32_t)(input[40] & 0xfe) << 15);
	output[19] = (double)(value >> 16);
}

static void unpack_21_16bit_signed_0off(const uint8_t * input, double * output, void *closure) {
	// Unpack 21 values into output
	// Values are 16-bit signed
	// Skip 0 bits, read 336 bits of data.
	// Input must be at least 42 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 0 to 15
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)input[1] << 16);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 16 to 31
	value = ((uint32_t)input[2] << 24) |
			((uint32_t)input[3] << 16);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 32 to 47
	value = ((uint32_t)input[4] << 24) |
			((uint32_t)input[5] << 16);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 48 to 63
	value = ((uint32_t)input[6] << 24) |
			((uint32_t)input[7] << 16);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 64 to 79
	value = ((uint32_t)input[8] << 24) |
			((uint32_t)input[9] << 16);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 80 to 95
	value = ((uint32_t)input[10] << 24) |
			((uint32_t)input[11] << 16);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 96 to 111
	value = ((uint32_t)input[12] << 24) |
			((uint32_t)input[13] << 16);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 112 to 127
	value = ((uint32_t)input[14] << 24) |
			((uint32_t)input[15] << 16);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 128 to 143
	value = ((uint32_t)input[16] << 24) |
			((uint32_t)input[17] << 16);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 144 to 159
	value = ((uint32_t)input[18] << 24) |
			((uint32_t)input[19] << 16);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 160 to 175
	value = ((uint32_t)input[20] << 24) |
			((uint32_t)input[21] << 16);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 176 to 191
	value = ((uint32_t)input[22] << 24) |
			((uint32_t)input[23] << 16);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 192 to 207
	value = ((uint32_t)input[24] << 24) |
			((uint32_t)input[25] << 16);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 208 to 223
	value = ((uint32_t)input[26] << 24) |
			((uint32_t)input[27] << 16);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 224 to 239
	value = ((uint32_t)input[28] << 24) |
			((uint32_t)input[29] << 16);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 240 to 255
	value = ((uint32_t)input[30] << 24) |
			((uint32_t)input[31] << 16);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 256 to 271
	value = ((uint32_t)input[32] << 24) |
			((uint32_t)input[33] << 16);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 272 to 287
	value = ((uint32_t)input[34] << 24) |
			((uint32_t)input[35] << 16);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 288 to 303
	value = ((uint32_t)input[36] << 24) |
			((uint32_t)input[37] << 16);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 304 to 319
	value = ((uint32_t)input[38] << 24) |
			((uint32_t)input[39] << 16);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 320 to 335
	value = ((uint32_t)input[40] << 24) |
			((uint32_t)input[41] << 16);
	output[20] = (double)(value >> 16);
}

static void unpack_21_16bit_unsigned_0off(const uint8_t * input, double * output, void *closure) {
	// Unpack 21 values into output
	// Values are 16-bit unsigned
	// Skip 0 bits, read 336 bits of data.
	// Input must be at least 42 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 0 to 15
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)input[1] << 16);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 16 to 31
	value = ((uint32_t)input[2] << 24) |
			((uint32_t)input[3] << 16);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 32 to 47
	value = ((uint32_t)input[4] << 24) |
			((uint32_t)input[5] << 16);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 48 to 63
	value = ((uint32_t)input[6] << 24) |
			((uint32_t)input[7] << 16);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 64 to 79
	value = ((uint32_t)input[8] << 24) |
			((uint32_t)input[9] << 16);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 80 to 95
	value = ((uint32_t)input[10] << 24) |
			((uint32_t)input[11] << 16);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 96 to 111
	value = ((uint32_t)input[12] << 24) |
			((uint32_t)input[13] << 16);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 112 to 127
	value = ((uint32_t)input[14] << 24) |
			((uint32_t)input[15] << 16);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 128 to 143
	value = ((uint32_t)input[16] << 24) |
			((uint32_t)input[17] << 16);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 144 to 159
	value = ((uint32_t)input[18] << 24) |
			((uint32_t)input[19] << 16);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 160 to 175
	value = ((uint32_t)input[20] << 24) |
			((uint32_t)input[21] << 16);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 176 to 191
	value = ((uint32_t)input[22] << 24) |
			((uint32_t)input[23] << 16);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 192 to 207
	value = ((uint32_t)input[24] << 24) |
			((uint32_t)input[25] << 16);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 208 to 223
	value = ((uint32_t)input[26] << 24) |
			((uint32_t)input[27] << 16);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 224 to 239
	value = ((uint32_t)input[28] << 24) |
			((uint32_t)input[29] << 16);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 240 to 255
	value = ((uint32_t)input[30] << 24) |
			((uint32_t)input[31] << 16);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 256 to 271
	value = ((uint32_t)input[32] << 24) |
			((uint32_t)input[33] << 16);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 272 to 287
	value = ((uint32_t)input[34] << 24) |
			((uint32_t)input[35] << 16);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 288 to 303
	value = ((uint32_t)input[36] << 24) |
			((uint32_t)input[37] << 16);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 304 to 319
	value = ((uint32_t)input[38] << 24) |
			((uint32_t)input[39] << 16);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 320 to 335
	value = ((uint32_t)input[40] << 24) |
			((uint32_t)input[41] << 16);
	output[20] = (double)(value >> 16);
}

static void unpack_21_16bit_signed_1off(const uint8_t * input, double * output, void *closure) {
	// Unpack 21 values into output
	// Values are 16-bit signed
	// Skip 1 bits, read 336 bits of data.
	// Input must be at least 43 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 1 to 16
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)input[1] << 17) |
			((uint32_t)(input[2] & 0x80) << 9);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 17 to 32
	value = ((uint32_t)(input[2] & 0x7f) << 25) |
			((uint32_t)input[3] << 17) |
			((uint32_t)(input[4] & 0x80) << 9);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 33 to 48
	value = ((uint32_t)(input[4] & 0x7f) << 25) |
			((uint32_t)input[5] << 17) |
			((uint32_t)(input[6] & 0x80) << 9);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 49 to 64
	value = ((uint32_t)(input[6] & 0x7f) << 25) |
			((uint32_t)input[7] << 17) |
			((uint32_t)(input[8] & 0x80) << 9);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 65 to 80
	value = ((uint32_t)(input[8] & 0x7f) << 25) |
			((uint32_t)input[9] << 17) |
			((uint32_t)(input[10] & 0x80) << 9);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 81 to 96
	value = ((uint32_t)(input[10] & 0x7f) << 25) |
			((uint32_t)input[11] << 17) |
			((uint32_t)(input[12] & 0x80) << 9);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 97 to 112
	value = ((uint32_t)(input[12] & 0x7f) << 25) |
			((uint32_t)input[13] << 17) |
			((uint32_t)(input[14] & 0x80) << 9);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 113 to 128
	value = ((uint32_t)(input[14] & 0x7f) << 25) |
			((uint32_t)input[15] << 17) |
			((uint32_t)(input[16] & 0x80) << 9);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 129 to 144
	value = ((uint32_t)(input[16] & 0x7f) << 25) |
			((uint32_t)input[17] << 17) |
			((uint32_t)(input[18] & 0x80) << 9);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 145 to 160
	value = ((uint32_t)(input[18] & 0x7f) << 25) |
			((uint32_t)input[19] << 17) |
			((uint32_t)(input[20] & 0x80) << 9);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 161 to 176
	value = ((uint32_t)(input[20] & 0x7f) << 25) |
			((uint32_t)input[21] << 17) |
			((uint32_t)(input[22] & 0x80) << 9);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 177 to 192
	value = ((uint32_t)(input[22] & 0x7f) << 25) |
			((uint32_t)input[23] << 17) |
			((uint32_t)(input[24] & 0x80) << 9);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 193 to 208
	value = ((uint32_t)(input[24] & 0x7f) << 25) |
			((uint32_t)input[25] << 17) |
			((uint32_t)(input[26] & 0x80) << 9);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 209 to 224
	value = ((uint32_t)(input[26] & 0x7f) << 25) |
			((uint32_t)input[27] << 17) |
			((uint32_t)(input[28] & 0x80) << 9);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 225 to 240
	value = ((uint32_t)(input[28] & 0x7f) << 25) |
			((uint32_t)input[29] << 17) |
			((uint32_t)(input[30] & 0x80) << 9);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 241 to 256
	value = ((uint32_t)(input[30] & 0x7f) << 25) |
			((uint32_t)input[31] << 17) |
			((uint32_t)(input[32] & 0x80) << 9);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 257 to 272
	value = ((uint32_t)(input[32] & 0x7f) << 25) |
			((uint32_t)input[33] << 17) |
			((uint32_t)(input[34] & 0x80) << 9);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 273 to 288
	value = ((uint32_t)(input[34] & 0x7f) << 25) |
			((uint32_t)input[35] << 17) |
			((uint32_t)(input[36] & 0x80) << 9);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 289 to 304
	value = ((uint32_t)(input[36] & 0x7f) << 25) |
			((uint32_t)input[37] << 17) |
			((uint32_t)(input[38] & 0x80) << 9);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 305 to 320
	value = ((uint32_t)(input[38] & 0x7f) << 25) |
			((uint32_t)input[39] << 17) |
			((uint32_t)(input[40] & 0x80) << 9);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 321 to 336
	value = ((uint32_t)(input[40] & 0x7f) << 25) |
			((uint32_t)input[41] << 17) |
			((uint32_t)(input[42] & 0x80) << 9);
	output[20] = (double)(value >> 16);
}

static void unpack_21_16bit_unsigned_1off(const uint8_t * input, double * output, void *closure) {
	// Unpack 21 values into output
	// Values are 16-bit unsigned
	// Skip 1 bits, read 336 bits of data.
	// Input must be at least 43 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 1 to 16
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)input[1] << 17) |
			((uint32_t)(input[2] & 0x80) << 9);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 17 to 32
	value = ((uint32_t)(input[2] & 0x7f) << 25) |
			((uint32_t)input[3] << 17) |
			((uint32_t)(input[4] & 0x80) << 9);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 33 to 48
	value = ((uint32_t)(input[4] & 0x7f) << 25) |
			((uint32_t)input[5] << 17) |
			((uint32_t)(input[6] & 0x80) << 9);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 49 to 64
	value = ((uint32_t)(input[6] & 0x7f) << 25) |
			((uint32_t)input[7] << 17) |
			((uint32_t)(input[8] & 0x80) << 9);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 65 to 80
	value = ((uint32_t)(input[8] & 0x7f) << 25) |
			((uint32_t)input[9] << 17) |
			((uint32_t)(input[10] & 0x80) << 9);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 81 to 96
	value = ((uint32_t)(input[10] & 0x7f) << 25) |
			((uint32_t)input[11] << 17) |
			((uint32_t)(input[12] & 0x80) << 9);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 97 to 112
	value = ((uint32_t)(input[12] & 0x7f) << 25) |
			((uint32_t)input[13] << 17) |
			((uint32_t)(input[14] & 0x80) << 9);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 113 to 128
	value = ((uint32_t)(input[14] & 0x7f) << 25) |
			((uint32_t)input[15] << 17) |
			((uint32_t)(input[16] & 0x80) << 9);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 129 to 144
	value = ((uint32_t)(input[16] & 0x7f) << 25) |
			((uint32_t)input[17] << 17) |
			((uint32_t)(input[18] & 0x80) << 9);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 145 to 160
	value = ((uint32_t)(input[18] & 0x7f) << 25) |
			((uint32_t)input[19] << 17) |
			((uint32_t)(input[20] & 0x80) << 9);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 161 to 176
	value = ((uint32_t)(input[20] & 0x7f) << 25) |
			((uint32_t)input[21] << 17) |
			((uint32_t)(input[22] & 0x80) << 9);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 177 to 192
	value = ((uint32_t)(input[22] & 0x7f) << 25) |
			((uint32_t)input[23] << 17) |
			((uint32_t)(input[24] & 0x80) << 9);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 193 to 208
	value = ((uint32_t)(input[24] & 0x7f) << 25) |
			((uint32_t)input[25] << 17) |
			((uint32_t)(input[26] & 0x80) << 9);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 209 to 224
	value = ((uint32_t)(input[26] & 0x7f) << 25) |
			((uint32_t)input[27] << 17) |
			((uint32_t)(input[28] & 0x80) << 9);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 225 to 240
	value = ((uint32_t)(input[28] & 0x7f) << 25) |
			((uint32_t)input[29] << 17) |
			((uint32_t)(input[30] & 0x80) << 9);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 241 to 256
	value = ((uint32_t)(input[30] & 0x7f) << 25) |
			((uint32_t)input[31] << 17) |
			((uint32_t)(input[32] & 0x80) << 9);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 257 to 272
	value = ((uint32_t)(input[32] & 0x7f) << 25) |
			((uint32_t)input[33] << 17) |
			((uint32_t)(input[34] & 0x80) << 9);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 273 to 288
	value = ((uint32_t)(input[34] & 0x7f) << 25) |
			((uint32_t)input[35] << 17) |
			((uint32_t)(input[36] & 0x80) << 9);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 289 to 304
	value = ((uint32_t)(input[36] & 0x7f) << 25) |
			((uint32_t)input[37] << 17) |
			((uint32_t)(input[38] & 0x80) << 9);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 305 to 320
	value = ((uint32_t)(input[38] & 0x7f) << 25) |
			((uint32_t)input[39] << 17) |
			((uint32_t)(input[40] & 0x80) << 9);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 321 to 336
	value = ((uint32_t)(input[40] & 0x7f) << 25) |
			((uint32_t)input[41] << 17) |
			((uint32_t)(input[42] & 0x80) << 9);
	output[20] = (double)(value >> 16);
}

static void unpack_21_16bit_signed_2off(const uint8_t * input, double * output, void *closure) {
	// Unpack 21 values into output
	// Values are 16-bit signed
	// Skip 2 bits, read 336 bits of data.
	// Input must be at least 43 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 2 to 17
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)input[1] << 18) |
			((uint32_t)(input[2] & 0xc0) << 10);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 18 to 33
	value = ((uint32_t)(input[2] & 0x3f) << 26) |
			((uint32_t)input[3] << 18) |
			((uint32_t)(input[4] & 0xc0) << 10);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 34 to 49
	value = ((uint32_t)(input[4] & 0x3f) << 26) |
			((uint32_t)input[5] << 18) |
			((uint32_t)(input[6] & 0xc0) << 10);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 50 to 65
	value = ((uint32_t)(input[6] & 0x3f) << 26) |
			((uint32_t)input[7] << 18) |
			((uint32_t)(input[8] & 0xc0) << 10);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 66 to 81
	value = ((uint32_t)(input[8] & 0x3f) << 26) |
			((uint32_t)input[9] << 18) |
			((uint32_t)(input[10] & 0xc0) << 10);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 82 to 97
	value = ((uint32_t)(input[10] & 0x3f) << 26) |
			((uint32_t)input[11] << 18) |
			((uint32_t)(input[12] & 0xc0) << 10);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 98 to 113
	value = ((uint32_t)(input[12] & 0x3f) << 26) |
			((uint32_t)input[13] << 18) |
			((uint32_t)(input[14] & 0xc0) << 10);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 114 to 129
	value = ((uint32_t)(input[14] & 0x3f) << 26) |
			((uint32_t)input[15] << 18) |
			((uint32_t)(input[16] & 0xc0) << 10);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 130 to 145
	value = ((uint32_t)(input[16] & 0x3f) << 26) |
			((uint32_t)input[17] << 18) |
			((uint32_t)(input[18] & 0xc0) << 10);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 146 to 161
	value = ((uint32_t)(input[18] & 0x3f) << 26) |
			((uint32_t)input[19] << 18) |
			((uint32_t)(input[20] & 0xc0) << 10);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 162 to 177
	value = ((uint32_t)(input[20] & 0x3f) << 26) |
			((uint32_t)input[21] << 18) |
			((uint32_t)(input[22] & 0xc0) << 10);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 178 to 193
	value = ((uint32_t)(input[22] & 0x3f) << 26) |
			((uint32_t)input[23] << 18) |
			((uint32_t)(input[24] & 0xc0) << 10);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 194 to 209
	value = ((uint32_t)(input[24] & 0x3f) << 26) |
			((uint32_t)input[25] << 18) |
			((uint32_t)(input[26] & 0xc0) << 10);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 210 to 225
	value = ((uint32_t)(input[26] & 0x3f) << 26) |
			((uint32_t)input[27] << 18) |
			((uint32_t)(input[28] & 0xc0) << 10);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 226 to 241
	value = ((uint32_t)(input[28] & 0x3f) << 26) |
			((uint32_t)input[29] << 18) |
			((uint32_t)(input[30] & 0xc0) << 10);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 242 to 257
	value = ((uint32_t)(input[30] & 0x3f) << 26) |
			((uint32_t)input[31] << 18) |
			((uint32_t)(input[32] & 0xc0) << 10);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 258 to 273
	value = ((uint32_t)(input[32] & 0x3f) << 26) |
			((uint32_t)input[33] << 18) |
			((uint32_t)(input[34] & 0xc0) << 10);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 274 to 289
	value = ((uint32_t)(input[34] & 0x3f) << 26) |
			((uint32_t)input[35] << 18) |
			((uint32_t)(input[36] & 0xc0) << 10);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 290 to 305
	value = ((uint32_t)(input[36] & 0x3f) << 26) |
			((uint32_t)input[37] << 18) |
			((uint32_t)(input[38] & 0xc0) << 10);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 306 to 321
	value = ((uint32_t)(input[38] & 0x3f) << 26) |
			((uint32_t)input[39] << 18) |
			((uint32_t)(input[40] & 0xc0) << 10);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 322 to 337
	value = ((uint32_t)(input[40] & 0x3f) << 26) |
			((uint32_t)input[41] << 18) |
			((uint32_t)(input[42] & 0xc0) << 10);
	output[20] = (double)(value >> 16);
}

static void unpack_21_16bit_unsigned_2off(const uint8_t * input, double * output, void *closure) {
	// Unpack 21 values into output
	// Values are 16-bit unsigned
	// Skip 2 bits, read 336 bits of data.
	// Input must be at least 43 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 2 to 17
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)input[1] << 18) |
			((uint32_t)(input[2] & 0xc0) << 10);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 18 to 33
	value = ((uint32_t)(input[2] & 0x3f) << 26) |
			((uint32_t)input[3] << 18) |
			((uint32_t)(input[4] & 0xc0) << 10);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 34 to 49
	value = ((uint32_t)(input[4] & 0x3f) << 26) |
			((uint32_t)input[5] << 18) |
			((uint32_t)(input[6] & 0xc0) << 10);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 50 to 65
	value = ((uint32_t)(input[6] & 0x3f) << 26) |
			((uint32_t)input[7] << 18) |
			((uint32_t)(input[8] & 0xc0) << 10);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 66 to 81
	value = ((uint32_t)(input[8] & 0x3f) << 26) |
			((uint32_t)input[9] << 18) |
			((uint32_t)(input[10] & 0xc0) << 10);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 82 to 97
	value = ((uint32_t)(input[10] & 0x3f) << 26) |
			((uint32_t)input[11] << 18) |
			((uint32_t)(input[12] & 0xc0) << 10);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 98 to 113
	value = ((uint32_t)(input[12] & 0x3f) << 26) |
			((uint32_t)input[13] << 18) |
			((uint32_t)(input[14] & 0xc0) << 10);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 114 to 129
	value = ((uint32_t)(input[14] & 0x3f) << 26) |
			((uint32_t)input[15] << 18) |
			((uint32_t)(input[16] & 0xc0) << 10);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 130 to 145
	value = ((uint32_t)(input[16] & 0x3f) << 26) |
			((uint32_t)input[17] << 18) |
			((uint32_t)(input[18] & 0xc0) << 10);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 146 to 161
	value = ((uint32_t)(input[18] & 0x3f) << 26) |
			((uint32_t)input[19] << 18) |
			((uint32_t)(input[20] & 0xc0) << 10);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 162 to 177
	value = ((uint32_t)(input[20] & 0x3f) << 26) |
			((uint32_t)input[21] << 18) |
			((uint32_t)(input[22] & 0xc0) << 10);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 178 to 193
	value = ((uint32_t)(input[22] & 0x3f) << 26) |
			((uint32_t)input[23] << 18) |
			((uint32_t)(input[24] & 0xc0) << 10);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 194 to 209
	value = ((uint32_t)(input[24] & 0x3f) << 26) |
			((uint32_t)input[25] << 18) |
			((uint32_t)(input[26] & 0xc0) << 10);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 210 to 225
	value = ((uint32_t)(input[26] & 0x3f) << 26) |
			((uint32_t)input[27] << 18) |
			((uint32_t)(input[28] & 0xc0) << 10);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 226 to 241
	value = ((uint32_t)(input[28] & 0x3f) << 26) |
			((uint32_t)input[29] << 18) |
			((uint32_t)(input[30] & 0xc0) << 10);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 242 to 257
	value = ((uint32_t)(input[30] & 0x3f) << 26) |
			((uint32_t)input[31] << 18) |
			((uint32_t)(input[32] & 0xc0) << 10);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 258 to 273
	value = ((uint32_t)(input[32] & 0x3f) << 26) |
			((uint32_t)input[33] << 18) |
			((uint32_t)(input[34] & 0xc0) << 10);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 274 to 289
	value = ((uint32_t)(input[34] & 0x3f) << 26) |
			((uint32_t)input[35] << 18) |
			((uint32_t)(input[36] & 0xc0) << 10);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 290 to 305
	value = ((uint32_t)(input[36] & 0x3f) << 26) |
			((uint32_t)input[37] << 18) |
			((uint32_t)(input[38] & 0xc0) << 10);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 306 to 321
	value = ((uint32_t)(input[38] & 0x3f) << 26) |
			((uint32_t)input[39] << 18) |
			((uint32_t)(input[40] & 0xc0) << 10);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 322 to 337
	value = ((uint32_t)(input[40] & 0x3f) << 26) |
			((uint32_t)input[41] << 18) |
			((uint32_t)(input[42] & 0xc0) << 10);
	output[20] = (double)(value >> 16);
}

static void unpack_21_16bit_signed_3off(const uint8_t * input, double * output, void *closure) {
	// Unpack 21 values into output
	// Values are 16-bit signed
	// Skip 3 bits, read 336 bits of data.
	// Input must be at least 43 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 3 to 18
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)input[1] << 19) |
			((uint32_t)(input[2] & 0xe0) << 11);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 19 to 34
	value = ((uint32_t)(input[2] & 0x1f) << 27) |
			((uint32_t)input[3] << 19) |
			((uint32_t)(input[4] & 0xe0) << 11);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 35 to 50
	value = ((uint32_t)(input[4] & 0x1f) << 27) |
			((uint32_t)input[5] << 19) |
			((uint32_t)(input[6] & 0xe0) << 11);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 51 to 66
	value = ((uint32_t)(input[6] & 0x1f) << 27) |
			((uint32_t)input[7] << 19) |
			((uint32_t)(input[8] & 0xe0) << 11);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 67 to 82
	value = ((uint32_t)(input[8] & 0x1f) << 27) |
			((uint32_t)input[9] << 19) |
			((uint32_t)(input[10] & 0xe0) << 11);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 83 to 98
	value = ((uint32_t)(input[10] & 0x1f) << 27) |
			((uint32_t)input[11] << 19) |
			((uint32_t)(input[12] & 0xe0) << 11);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 99 to 114
	value = ((uint32_t)(input[12] & 0x1f) << 27) |
			((uint32_t)input[13] << 19) |
			((uint32_t)(input[14] & 0xe0) << 11);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 115 to 130
	value = ((uint32_t)(input[14] & 0x1f) << 27) |
			((uint32_t)input[15] << 19) |
			((uint32_t)(input[16] & 0xe0) << 11);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 131 to 146
	value = ((uint32_t)(input[16] & 0x1f) << 27) |
			((uint32_t)input[17] << 19) |
			((uint32_t)(input[18] & 0xe0) << 11);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 147 to 162
	value = ((uint32_t)(input[18] & 0x1f) << 27) |
			((uint32_t)input[19] << 19) |
			((uint32_t)(input[20] & 0xe0) << 11);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 163 to 178
	value = ((uint32_t)(input[20] & 0x1f) << 27) |
			((uint32_t)input[21] << 19) |
			((uint32_t)(input[22] & 0xe0) << 11);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 179 to 194
	value = ((uint32_t)(input[22] & 0x1f) << 27) |
			((uint32_t)input[23] << 19) |
			((uint32_t)(input[24] & 0xe0) << 11);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 195 to 210
	value = ((uint32_t)(input[24] & 0x1f) << 27) |
			((uint32_t)input[25] << 19) |
			((uint32_t)(input[26] & 0xe0) << 11);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 211 to 226
	value = ((uint32_t)(input[26] & 0x1f) << 27) |
			((uint32_t)input[27] << 19) |
			((uint32_t)(input[28] & 0xe0) << 11);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 227 to 242
	value = ((uint32_t)(input[28] & 0x1f) << 27) |
			((uint32_t)input[29] << 19) |
			((uint32_t)(input[30] & 0xe0) << 11);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 243 to 258
	value = ((uint32_t)(input[30] & 0x1f) << 27) |
			((uint32_t)input[31] << 19) |
			((uint32_t)(input[32] & 0xe0) << 11);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 259 to 274
	value = ((uint32_t)(input[32] & 0x1f) << 27) |
			((uint32_t)input[33] << 19) |
			((uint32_t)(input[34] & 0xe0) << 11);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 275 to 290
	value = ((uint32_t)(input[34] & 0x1f) << 27) |
			((uint32_t)input[35] << 19) |
			((uint32_t)(input[36] & 0xe0) << 11);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 291 to 306
	value = ((uint32_t)(input[36] & 0x1f) << 27) |
			((uint32_t)input[37] << 19) |
			((uint32_t)(input[38] & 0xe0) << 11);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 307 to 322
	value = ((uint32_t)(input[38] & 0x1f) << 27) |
			((uint32_t)input[39] << 19) |
			((uint32_t)(input[40] & 0xe0) << 11);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 323 to 338
	value = ((uint32_t)(input[40] & 0x1f) << 27) |
			((uint32_t)input[41] << 19) |
			((uint32_t)(input[42] & 0xe0) << 11);
	output[20] = (double)(value >> 16);
}

static void unpack_21_16bit_unsigned_3off(const uint8_t * input, double * output, void *closure) {
	// Unpack 21 values into output
	// Values are 16-bit unsigned
	// Skip 3 bits, read 336 bits of data.
	// Input must be at least 43 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 3 to 18
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)input[1] << 19) |
			((uint32_t)(input[2] & 0xe0) << 11);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 19 to 34
	value = ((uint32_t)(input[2] & 0x1f) << 27) |
			((uint32_t)input[3] << 19) |
			((uint32_t)(input[4] & 0xe0) << 11);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 35 to 50
	value = ((uint32_t)(input[4] & 0x1f) << 27) |
			((uint32_t)input[5] << 19) |
			((uint32_t)(input[6] & 0xe0) << 11);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 51 to 66
	value = ((uint32_t)(input[6] & 0x1f) << 27) |
			((uint32_t)input[7] << 19) |
			((uint32_t)(input[8] & 0xe0) << 11);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 67 to 82
	value = ((uint32_t)(input[8] & 0x1f) << 27) |
			((uint32_t)input[9] << 19) |
			((uint32_t)(input[10] & 0xe0) << 11);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 83 to 98
	value = ((uint32_t)(input[10] & 0x1f) << 27) |
			((uint32_t)input[11] << 19) |
			((uint32_t)(input[12] & 0xe0) << 11);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 99 to 114
	value = ((uint32_t)(input[12] & 0x1f) << 27) |
			((uint32_t)input[13] << 19) |
			((uint32_t)(input[14] & 0xe0) << 11);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 115 to 130
	value = ((uint32_t)(input[14] & 0x1f) << 27) |
			((uint32_t)input[15] << 19) |
			((uint32_t)(input[16] & 0xe0) << 11);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 131 to 146
	value = ((uint32_t)(input[16] & 0x1f) << 27) |
			((uint32_t)input[17] << 19) |
			((uint32_t)(input[18] & 0xe0) << 11);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 147 to 162
	value = ((uint32_t)(input[18] & 0x1f) << 27) |
			((uint32_t)input[19] << 19) |
			((uint32_t)(input[20] & 0xe0) << 11);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 163 to 178
	value = ((uint32_t)(input[20] & 0x1f) << 27) |
			((uint32_t)input[21] << 19) |
			((uint32_t)(input[22] & 0xe0) << 11);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 179 to 194
	value = ((uint32_t)(input[22] & 0x1f) << 27) |
			((uint32_t)input[23] << 19) |
			((uint32_t)(input[24] & 0xe0) << 11);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 195 to 210
	value = ((uint32_t)(input[24] & 0x1f) << 27) |
			((uint32_t)input[25] << 19) |
			((uint32_t)(input[26] & 0xe0) << 11);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 211 to 226
	value = ((uint32_t)(input[26] & 0x1f) << 27) |
			((uint32_t)input[27] << 19) |
			((uint32_t)(input[28] & 0xe0) << 11);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 227 to 242
	value = ((uint32_t)(input[28] & 0x1f) << 27) |
			((uint32_t)input[29] << 19) |
			((uint32_t)(input[30] & 0xe0) << 11);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 243 to 258
	value = ((uint32_t)(input[30] & 0x1f) << 27) |
			((uint32_t)input[31] << 19) |
			((uint32_t)(input[32] & 0xe0) << 11);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 259 to 274
	value = ((uint32_t)(input[32] & 0x1f) << 27) |
			((uint32_t)input[33] << 19) |
			((uint32_t)(input[34] & 0xe0) << 11);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 275 to 290
	value = ((uint32_t)(input[34] & 0x1f) << 27) |
			((uint32_t)input[35] << 19) |
			((uint32_t)(input[36] & 0xe0) << 11);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 291 to 306
	value = ((uint32_t)(input[36] & 0x1f) << 27) |
			((uint32_t)input[37] << 19) |
			((uint32_t)(input[38] & 0xe0) << 11);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 307 to 322
	value = ((uint32_t)(input[38] & 0x1f) << 27) |
			((uint32_t)input[39] << 19) |
			((uint32_t)(input[40] & 0xe0) << 11);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 323 to 338
	value = ((uint32_t)(input[40] & 0x1f) << 27) |
			((uint32_t)input[41] << 19) |
			((uint32_t)(input[42] & 0xe0) << 11);
	output[20] = (double)(value >> 16);
}

static void unpack_21_16bit_signed_4off(const uint8_t * input, double * output, void *closure) {
	// Unpack 21 values into output
	// Values are 16-bit signed
	// Skip 4 bits, read 336 bits of data.
	// Input must be at least 43 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 4 to 19
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20) |
			((uint32_t)(input[2] & 0xf0) << 12);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 20 to 35
	value = ((uint32_t)(input[2] & 0x0f) << 28) |
			((uint32_t)input[3] << 20) |
			((uint32_t)(input[4] & 0xf0) << 12);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 36 to 51
	value = ((uint32_t)(input[4] & 0x0f) << 28) |
			((uint32_t)input[5] << 20) |
			((uint32_t)(input[6] & 0xf0) << 12);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 52 to 67
	value = ((uint32_t)(input[6] & 0x0f) << 28) |
			((uint32_t)input[7] << 20) |
			((uint32_t)(input[8] & 0xf0) << 12);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 68 to 83
	value = ((uint32_t)(input[8] & 0x0f) << 28) |
			((uint32_t)input[9] << 20) |
			((uint32_t)(input[10] & 0xf0) << 12);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 84 to 99
	value = ((uint32_t)(input[10] & 0x0f) << 28) |
			((uint32_t)input[11] << 20) |
			((uint32_t)(input[12] & 0xf0) << 12);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 100 to 115
	value = ((uint32_t)(input[12] & 0x0f) << 28) |
			((uint32_t)input[13] << 20) |
			((uint32_t)(input[14] & 0xf0) << 12);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 116 to 131
	value = ((uint32_t)(input[14] & 0x0f) << 28) |
			((uint32_t)input[15] << 20) |
			((uint32_t)(input[16] & 0xf0) << 12);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 132 to 147
	value = ((uint32_t)(input[16] & 0x0f) << 28) |
			((uint32_t)input[17] << 20) |
			((uint32_t)(input[18] & 0xf0) << 12);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 148 to 163
	value = ((uint32_t)(input[18] & 0x0f) << 28) |
			((uint32_t)input[19] << 20) |
			((uint32_t)(input[20] & 0xf0) << 12);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 164 to 179
	value = ((uint32_t)(input[20] & 0x0f) << 28) |
			((uint32_t)input[21] << 20) |
			((uint32_t)(input[22] & 0xf0) << 12);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 180 to 195
	value = ((uint32_t)(input[22] & 0x0f) << 28) |
			((uint32_t)input[23] << 20) |
			((uint32_t)(input[24] & 0xf0) << 12);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 196 to 211
	value = ((uint32_t)(input[24] & 0x0f) << 28) |
			((uint32_t)input[25] << 20) |
			((uint32_t)(input[26] & 0xf0) << 12);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 212 to 227
	value = ((uint32_t)(input[26] & 0x0f) << 28) |
			((uint32_t)input[27] << 20) |
			((uint32_t)(input[28] & 0xf0) << 12);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 228 to 243
	value = ((uint32_t)(input[28] & 0x0f) << 28) |
			((uint32_t)input[29] << 20) |
			((uint32_t)(input[30] & 0xf0) << 12);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 244 to 259
	value = ((uint32_t)(input[30] & 0x0f) << 28) |
			((uint32_t)input[31] << 20) |
			((uint32_t)(input[32] & 0xf0) << 12);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 260 to 275
	value = ((uint32_t)(input[32] & 0x0f) << 28) |
			((uint32_t)input[33] << 20) |
			((uint32_t)(input[34] & 0xf0) << 12);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 276 to 291
	value = ((uint32_t)(input[34] & 0x0f) << 28) |
			((uint32_t)input[35] << 20) |
			((uint32_t)(input[36] & 0xf0) << 12);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 292 to 307
	value = ((uint32_t)(input[36] & 0x0f) << 28) |
			((uint32_t)input[37] << 20) |
			((uint32_t)(input[38] & 0xf0) << 12);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 308 to 323
	value = ((uint32_t)(input[38] & 0x0f) << 28) |
			((uint32_t)input[39] << 20) |
			((uint32_t)(input[40] & 0xf0) << 12);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 324 to 339
	value = ((uint32_t)(input[40] & 0x0f) << 28) |
			((uint32_t)input[41] << 20) |
			((uint32_t)(input[42] & 0xf0) << 12);
	output[20] = (double)(value >> 16);
}

static void unpack_21_16bit_unsigned_4off(const uint8_t * input, double * output, void *closure) {
	// Unpack 21 values into output
	// Values are 16-bit unsigned
	// Skip 4 bits, read 336 bits of data.
	// Input must be at least 43 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 4 to 19
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20) |
			((uint32_t)(input[2] & 0xf0) << 12);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 20 to 35
	value = ((uint32_t)(input[2] & 0x0f) << 28) |
			((uint32_t)input[3] << 20) |
			((uint32_t)(input[4] & 0xf0) << 12);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 36 to 51
	value = ((uint32_t)(input[4] & 0x0f) << 28) |
			((uint32_t)input[5] << 20) |
			((uint32_t)(input[6] & 0xf0) << 12);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 52 to 67
	value = ((uint32_t)(input[6] & 0x0f) << 28) |
			((uint32_t)input[7] << 20) |
			((uint32_t)(input[8] & 0xf0) << 12);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 68 to 83
	value = ((uint32_t)(input[8] & 0x0f) << 28) |
			((uint32_t)input[9] << 20) |
			((uint32_t)(input[10] & 0xf0) << 12);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 84 to 99
	value = ((uint32_t)(input[10] & 0x0f) << 28) |
			((uint32_t)input[11] << 20) |
			((uint32_t)(input[12] & 0xf0) << 12);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 100 to 115
	value = ((uint32_t)(input[12] & 0x0f) << 28) |
			((uint32_t)input[13] << 20) |
			((uint32_t)(input[14] & 0xf0) << 12);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 116 to 131
	value = ((uint32_t)(input[14] & 0x0f) << 28) |
			((uint32_t)input[15] << 20) |
			((uint32_t)(input[16] & 0xf0) << 12);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 132 to 147
	value = ((uint32_t)(input[16] & 0x0f) << 28) |
			((uint32_t)input[17] << 20) |
			((uint32_t)(input[18] & 0xf0) << 12);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 148 to 163
	value = ((uint32_t)(input[18] & 0x0f) << 28) |
			((uint32_t)input[19] << 20) |
			((uint32_t)(input[20] & 0xf0) << 12);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 164 to 179
	value = ((uint32_t)(input[20] & 0x0f) << 28) |
			((uint32_t)input[21] << 20) |
			((uint32_t)(input[22] & 0xf0) << 12);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 180 to 195
	value = ((uint32_t)(input[22] & 0x0f) << 28) |
			((uint32_t)input[23] << 20) |
			((uint32_t)(input[24] & 0xf0) << 12);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 196 to 211
	value = ((uint32_t)(input[24] & 0x0f) << 28) |
			((uint32_t)input[25] << 20) |
			((uint32_t)(input[26] & 0xf0) << 12);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 212 to 227
	value = ((uint32_t)(input[26] & 0x0f) << 28) |
			((uint32_t)input[27] << 20) |
			((uint32_t)(input[28] & 0xf0) << 12);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 228 to 243
	value = ((uint32_t)(input[28] & 0x0f) << 28) |
			((uint32_t)input[29] << 20) |
			((uint32_t)(input[30] & 0xf0) << 12);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 244 to 259
	value = ((uint32_t)(input[30] & 0x0f) << 28) |
			((uint32_t)input[31] << 20) |
			((uint32_t)(input[32] & 0xf0) << 12);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 260 to 275
	value = ((uint32_t)(input[32] & 0x0f) << 28) |
			((uint32_t)input[33] << 20) |
			((uint32_t)(input[34] & 0xf0) << 12);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 276 to 291
	value = ((uint32_t)(input[34] & 0x0f) << 28) |
			((uint32_t)input[35] << 20) |
			((uint32_t)(input[36] & 0xf0) << 12);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 292 to 307
	value = ((uint32_t)(input[36] & 0x0f) << 28) |
			((uint32_t)input[37] << 20) |
			((uint32_t)(input[38] & 0xf0) << 12);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 308 to 323
	value = ((uint32_t)(input[38] & 0x0f) << 28) |
			((uint32_t)input[39] << 20) |
			((uint32_t)(input[40] & 0xf0) << 12);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 324 to 339
	value = ((uint32_t)(input[40] & 0x0f) << 28) |
			((uint32_t)input[41] << 20) |
			((uint32_t)(input[42] & 0xf0) << 12);
	output[20] = (double)(value >> 16);
}

static void unpack_21_16bit_signed_5off(const uint8_t * input, double * output, void *closure) {
	// Unpack 21 values into output
	// Values are 16-bit signed
	// Skip 5 bits, read 336 bits of data.
	// Input must be at least 43 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 5 to 20
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)(input[2] & 0xf8) << 13);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 21 to 36
	value = ((uint32_t)(input[2] & 0x07) << 29) |
			((uint32_t)input[3] << 21) |
			((uint32_t)(input[4] & 0xf8) << 13);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 37 to 52
	value = ((uint32_t)(input[4] & 0x07) << 29) |
			((uint32_t)input[5] << 21) |
			((uint32_t)(input[6] & 0xf8) << 13);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 53 to 68
	value = ((uint32_t)(input[6] & 0x07) << 29) |
			((uint32_t)input[7] << 21) |
			((uint32_t)(input[8] & 0xf8) << 13);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 69 to 84
	value = ((uint32_t)(input[8] & 0x07) << 29) |
			((uint32_t)input[9] << 21) |
			((uint32_t)(input[10] & 0xf8) << 13);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 85 to 100
	value = ((uint32_t)(input[10] & 0x07) << 29) |
			((uint32_t)input[11] << 21) |
			((uint32_t)(input[12] & 0xf8) << 13);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 101 to 116
	value = ((uint32_t)(input[12] & 0x07) << 29) |
			((uint32_t)input[13] << 21) |
			((uint32_t)(input[14] & 0xf8) << 13);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 117 to 132
	value = ((uint32_t)(input[14] & 0x07) << 29) |
			((uint32_t)input[15] << 21) |
			((uint32_t)(input[16] & 0xf8) << 13);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 133 to 148
	value = ((uint32_t)(input[16] & 0x07) << 29) |
			((uint32_t)input[17] << 21) |
			((uint32_t)(input[18] & 0xf8) << 13);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 149 to 164
	value = ((uint32_t)(input[18] & 0x07) << 29) |
			((uint32_t)input[19] << 21) |
			((uint32_t)(input[20] & 0xf8) << 13);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 165 to 180
	value = ((uint32_t)(input[20] & 0x07) << 29) |
			((uint32_t)input[21] << 21) |
			((uint32_t)(input[22] & 0xf8) << 13);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 181 to 196
	value = ((uint32_t)(input[22] & 0x07) << 29) |
			((uint32_t)input[23] << 21) |
			((uint32_t)(input[24] & 0xf8) << 13);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 197 to 212
	value = ((uint32_t)(input[24] & 0x07) << 29) |
			((uint32_t)input[25] << 21) |
			((uint32_t)(input[26] & 0xf8) << 13);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 213 to 228
	value = ((uint32_t)(input[26] & 0x07) << 29) |
			((uint32_t)input[27] << 21) |
			((uint32_t)(input[28] & 0xf8) << 13);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 229 to 244
	value = ((uint32_t)(input[28] & 0x07) << 29) |
			((uint32_t)input[29] << 21) |
			((uint32_t)(input[30] & 0xf8) << 13);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 245 to 260
	value = ((uint32_t)(input[30] & 0x07) << 29) |
			((uint32_t)input[31] << 21) |
			((uint32_t)(input[32] & 0xf8) << 13);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 261 to 276
	value = ((uint32_t)(input[32] & 0x07) << 29) |
			((uint32_t)input[33] << 21) |
			((uint32_t)(input[34] & 0xf8) << 13);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 277 to 292
	value = ((uint32_t)(input[34] & 0x07) << 29) |
			((uint32_t)input[35] << 21) |
			((uint32_t)(input[36] & 0xf8) << 13);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 293 to 308
	value = ((uint32_t)(input[36] & 0x07) << 29) |
			((uint32_t)input[37] << 21) |
			((uint32_t)(input[38] & 0xf8) << 13);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 309 to 324
	value = ((uint32_t)(input[38] & 0x07) << 29) |
			((uint32_t)input[39] << 21) |
			((uint32_t)(input[40] & 0xf8) << 13);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 325 to 340
	value = ((uint32_t)(input[40] & 0x07) << 29) |
			((uint32_t)input[41] << 21) |
			((uint32_t)(input[42] & 0xf8) << 13);
	output[20] = (double)(value >> 16);
}

static void unpack_21_16bit_unsigned_5off(const uint8_t * input, double * output, void *closure) {
	// Unpack 21 values into output
	// Values are 16-bit unsigned
	// Skip 5 bits, read 336 bits of data.
	// Input must be at least 43 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 5 to 20
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)(input[2] & 0xf8) << 13);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 21 to 36
	value = ((uint32_t)(input[2] & 0x07) << 29) |
			((uint32_t)input[3] << 21) |
			((uint32_t)(input[4] & 0xf8) << 13);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 37 to 52
	value = ((uint32_t)(input[4] & 0x07) << 29) |
			((uint32_t)input[5] << 21) |
			((uint32_t)(input[6] & 0xf8) << 13);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 53 to 68
	value = ((uint32_t)(input[6] & 0x07) << 29) |
			((uint32_t)input[7] << 21) |
			((uint32_t)(input[8] & 0xf8) << 13);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 69 to 84
	value = ((uint32_t)(input[8] & 0x07) << 29) |
			((uint32_t)input[9] << 21) |
			((uint32_t)(input[10] & 0xf8) << 13);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 85 to 100
	value = ((uint32_t)(input[10] & 0x07) << 29) |
			((uint32_t)input[11] << 21) |
			((uint32_t)(input[12] & 0xf8) << 13);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 101 to 116
	value = ((uint32_t)(input[12] & 0x07) << 29) |
			((uint32_t)input[13] << 21) |
			((uint32_t)(input[14] & 0xf8) << 13);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 117 to 132
	value = ((uint32_t)(input[14] & 0x07) << 29) |
			((uint32_t)input[15] << 21) |
			((uint32_t)(input[16] & 0xf8) << 13);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 133 to 148
	value = ((uint32_t)(input[16] & 0x07) << 29) |
			((uint32_t)input[17] << 21) |
			((uint32_t)(input[18] & 0xf8) << 13);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 149 to 164
	value = ((uint32_t)(input[18] & 0x07) << 29) |
			((uint32_t)input[19] << 21) |
			((uint32_t)(input[20] & 0xf8) << 13);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 165 to 180
	value = ((uint32_t)(input[20] & 0x07) << 29) |
			((uint32_t)input[21] << 21) |
			((uint32_t)(input[22] & 0xf8) << 13);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 181 to 196
	value = ((uint32_t)(input[22] & 0x07) << 29) |
			((uint32_t)input[23] << 21) |
			((uint32_t)(input[24] & 0xf8) << 13);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 197 to 212
	value = ((uint32_t)(input[24] & 0x07) << 29) |
			((uint32_t)input[25] << 21) |
			((uint32_t)(input[26] & 0xf8) << 13);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 213 to 228
	value = ((uint32_t)(input[26] & 0x07) << 29) |
			((uint32_t)input[27] << 21) |
			((uint32_t)(input[28] & 0xf8) << 13);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 229 to 244
	value = ((uint32_t)(input[28] & 0x07) << 29) |
			((uint32_t)input[29] << 21) |
			((uint32_t)(input[30] & 0xf8) << 13);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 245 to 260
	value = ((uint32_t)(input[30] & 0x07) << 29) |
			((uint32_t)input[31] << 21) |
			((uint32_t)(input[32] & 0xf8) << 13);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 261 to 276
	value = ((uint32_t)(input[32] & 0x07) << 29) |
			((uint32_t)input[33] << 21) |
			((uint32_t)(input[34] & 0xf8) << 13);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 277 to 292
	value = ((uint32_t)(input[34] & 0x07) << 29) |
			((uint32_t)input[35] << 21) |
			((uint32_t)(input[36] & 0xf8) << 13);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 293 to 308
	value = ((uint32_t)(input[36] & 0x07) << 29) |
			((uint32_t)input[37] << 21) |
			((uint32_t)(input[38] & 0xf8) << 13);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 309 to 324
	value = ((uint32_t)(input[38] & 0x07) << 29) |
			((uint32_t)input[39] << 21) |
			((uint32_t)(input[40] & 0xf8) << 13);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 325 to 340
	value = ((uint32_t)(input[40] & 0x07) << 29) |
			((uint32_t)input[41] << 21) |
			((uint32_t)(input[42] & 0xf8) << 13);
	output[20] = (double)(value >> 16);
}

static void unpack_21_16bit_signed_6off(const uint8_t * input, double * output, void *closure) {
	// Unpack 21 values into output
	// Values are 16-bit signed
	// Skip 6 bits, read 336 bits of data.
	// Input must be at least 43 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 6 to 21
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)(input[2] & 0xfc) << 14);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 22 to 37
	value = ((uint32_t)(input[2] & 0x03) << 30) |
			((uint32_t)input[3] << 22) |
			((uint32_t)(input[4] & 0xfc) << 14);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 38 to 53
	value = ((uint32_t)(input[4] & 0x03) << 30) |
			((uint32_t)input[5] << 22) |
			((uint32_t)(input[6] & 0xfc) << 14);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 54 to 69
	value = ((uint32_t)(input[6] & 0x03) << 30) |
			((uint32_t)input[7] << 22) |
			((uint32_t)(input[8] & 0xfc) << 14);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 70 to 85
	value = ((uint32_t)(input[8] & 0x03) << 30) |
			((uint32_t)input[9] << 22) |
			((uint32_t)(input[10] & 0xfc) << 14);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 86 to 101
	value = ((uint32_t)(input[10] & 0x03) << 30) |
			((uint32_t)input[11] << 22) |
			((uint32_t)(input[12] & 0xfc) << 14);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 102 to 117
	value = ((uint32_t)(input[12] & 0x03) << 30) |
			((uint32_t)input[13] << 22) |
			((uint32_t)(input[14] & 0xfc) << 14);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 118 to 133
	value = ((uint32_t)(input[14] & 0x03) << 30) |
			((uint32_t)input[15] << 22) |
			((uint32_t)(input[16] & 0xfc) << 14);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 134 to 149
	value = ((uint32_t)(input[16] & 0x03) << 30) |
			((uint32_t)input[17] << 22) |
			((uint32_t)(input[18] & 0xfc) << 14);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 150 to 165
	value = ((uint32_t)(input[18] & 0x03) << 30) |
			((uint32_t)input[19] << 22) |
			((uint32_t)(input[20] & 0xfc) << 14);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 166 to 181
	value = ((uint32_t)(input[20] & 0x03) << 30) |
			((uint32_t)input[21] << 22) |
			((uint32_t)(input[22] & 0xfc) << 14);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 182 to 197
	value = ((uint32_t)(input[22] & 0x03) << 30) |
			((uint32_t)input[23] << 22) |
			((uint32_t)(input[24] & 0xfc) << 14);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 198 to 213
	value = ((uint32_t)(input[24] & 0x03) << 30) |
			((uint32_t)input[25] << 22) |
			((uint32_t)(input[26] & 0xfc) << 14);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 214 to 229
	value = ((uint32_t)(input[26] & 0x03) << 30) |
			((uint32_t)input[27] << 22) |
			((uint32_t)(input[28] & 0xfc) << 14);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 230 to 245
	value = ((uint32_t)(input[28] & 0x03) << 30) |
			((uint32_t)input[29] << 22) |
			((uint32_t)(input[30] & 0xfc) << 14);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 246 to 261
	value = ((uint32_t)(input[30] & 0x03) << 30) |
			((uint32_t)input[31] << 22) |
			((uint32_t)(input[32] & 0xfc) << 14);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 262 to 277
	value = ((uint32_t)(input[32] & 0x03) << 30) |
			((uint32_t)input[33] << 22) |
			((uint32_t)(input[34] & 0xfc) << 14);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 278 to 293
	value = ((uint32_t)(input[34] & 0x03) << 30) |
			((uint32_t)input[35] << 22) |
			((uint32_t)(input[36] & 0xfc) << 14);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 294 to 309
	value = ((uint32_t)(input[36] & 0x03) << 30) |
			((uint32_t)input[37] << 22) |
			((uint32_t)(input[38] & 0xfc) << 14);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 310 to 325
	value = ((uint32_t)(input[38] & 0x03) << 30) |
			((uint32_t)input[39] << 22) |
			((uint32_t)(input[40] & 0xfc) << 14);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 326 to 341
	value = ((uint32_t)(input[40] & 0x03) << 30) |
			((uint32_t)input[41] << 22) |
			((uint32_t)(input[42] & 0xfc) << 14);
	output[20] = (double)(value >> 16);
}

static void unpack_21_16bit_unsigned_6off(const uint8_t * input, double * output, void *closure) {
	// Unpack 21 values into output
	// Values are 16-bit unsigned
	// Skip 6 bits, read 336 bits of data.
	// Input must be at least 43 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 6 to 21
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)(input[2] & 0xfc) << 14);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 22 to 37
	value = ((uint32_t)(input[2] & 0x03) << 30) |
			((uint32_t)input[3] << 22) |
			((uint32_t)(input[4] & 0xfc) << 14);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 38 to 53
	value = ((uint32_t)(input[4] & 0x03) << 30) |
			((uint32_t)input[5] << 22) |
			((uint32_t)(input[6] & 0xfc) << 14);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 54 to 69
	value = ((uint32_t)(input[6] & 0x03) << 30) |
			((uint32_t)input[7] << 22) |
			((uint32_t)(input[8] & 0xfc) << 14);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 70 to 85
	value = ((uint32_t)(input[8] & 0x03) << 30) |
			((uint32_t)input[9] << 22) |
			((uint32_t)(input[10] & 0xfc) << 14);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 86 to 101
	value = ((uint32_t)(input[10] & 0x03) << 30) |
			((uint32_t)input[11] << 22) |
			((uint32_t)(input[12] & 0xfc) << 14);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 102 to 117
	value = ((uint32_t)(input[12] & 0x03) << 30) |
			((uint32_t)input[13] << 22) |
			((uint32_t)(input[14] & 0xfc) << 14);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 118 to 133
	value = ((uint32_t)(input[14] & 0x03) << 30) |
			((uint32_t)input[15] << 22) |
			((uint32_t)(input[16] & 0xfc) << 14);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 134 to 149
	value = ((uint32_t)(input[16] & 0x03) << 30) |
			((uint32_t)input[17] << 22) |
			((uint32_t)(input[18] & 0xfc) << 14);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 150 to 165
	value = ((uint32_t)(input[18] & 0x03) << 30) |
			((uint32_t)input[19] << 22) |
			((uint32_t)(input[20] & 0xfc) << 14);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 166 to 181
	value = ((uint32_t)(input[20] & 0x03) << 30) |
			((uint32_t)input[21] << 22) |
			((uint32_t)(input[22] & 0xfc) << 14);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 182 to 197
	value = ((uint32_t)(input[22] & 0x03) << 30) |
			((uint32_t)input[23] << 22) |
			((uint32_t)(input[24] & 0xfc) << 14);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 198 to 213
	value = ((uint32_t)(input[24] & 0x03) << 30) |
			((uint32_t)input[25] << 22) |
			((uint32_t)(input[26] & 0xfc) << 14);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 214 to 229
	value = ((uint32_t)(input[26] & 0x03) << 30) |
			((uint32_t)input[27] << 22) |
			((uint32_t)(input[28] & 0xfc) << 14);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 230 to 245
	value = ((uint32_t)(input[28] & 0x03) << 30) |
			((uint32_t)input[29] << 22) |
			((uint32_t)(input[30] & 0xfc) << 14);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 246 to 261
	value = ((uint32_t)(input[30] & 0x03) << 30) |
			((uint32_t)input[31] << 22) |
			((uint32_t)(input[32] & 0xfc) << 14);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 262 to 277
	value = ((uint32_t)(input[32] & 0x03) << 30) |
			((uint32_t)input[33] << 22) |
			((uint32_t)(input[34] & 0xfc) << 14);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 278 to 293
	value = ((uint32_t)(input[34] & 0x03) << 30) |
			((uint32_t)input[35] << 22) |
			((uint32_t)(input[36] & 0xfc) << 14);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 294 to 309
	value = ((uint32_t)(input[36] & 0x03) << 30) |
			((uint32_t)input[37] << 22) |
			((uint32_t)(input[38] & 0xfc) << 14);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 310 to 325
	value = ((uint32_t)(input[38] & 0x03) << 30) |
			((uint32_t)input[39] << 22) |
			((uint32_t)(input[40] & 0xfc) << 14);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 326 to 341
	value = ((uint32_t)(input[40] & 0x03) << 30) |
			((uint32_t)input[41] << 22) |
			((uint32_t)(input[42] & 0xfc) << 14);
	output[20] = (double)(value >> 16);
}

static void unpack_21_16bit_signed_7off(const uint8_t * input, double * output, void *closure) {
	// Unpack 21 values into output
	// Values are 16-bit signed
	// Skip 7 bits, read 336 bits of data.
	// Input must be at least 43 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 7 to 22
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)(input[2] & 0xfe) << 15);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 23 to 38
	value = ((uint32_t)(input[2] & 0x01) << 31) |
			((uint32_t)input[3] << 23) |
			((uint32_t)(input[4] & 0xfe) << 15);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 39 to 54
	value = ((uint32_t)(input[4] & 0x01) << 31) |
			((uint32_t)input[5] << 23) |
			((uint32_t)(input[6] & 0xfe) << 15);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 55 to 70
	value = ((uint32_t)(input[6] & 0x01) << 31) |
			((uint32_t)input[7] << 23) |
			((uint32_t)(input[8] & 0xfe) << 15);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 71 to 86
	value = ((uint32_t)(input[8] & 0x01) << 31) |
			((uint32_t)input[9] << 23) |
			((uint32_t)(input[10] & 0xfe) << 15);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 87 to 102
	value = ((uint32_t)(input[10] & 0x01) << 31) |
			((uint32_t)input[11] << 23) |
			((uint32_t)(input[12] & 0xfe) << 15);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 103 to 118
	value = ((uint32_t)(input[12] & 0x01) << 31) |
			((uint32_t)input[13] << 23) |
			((uint32_t)(input[14] & 0xfe) << 15);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 119 to 134
	value = ((uint32_t)(input[14] & 0x01) << 31) |
			((uint32_t)input[15] << 23) |
			((uint32_t)(input[16] & 0xfe) << 15);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 135 to 150
	value = ((uint32_t)(input[16] & 0x01) << 31) |
			((uint32_t)input[17] << 23) |
			((uint32_t)(input[18] & 0xfe) << 15);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 151 to 166
	value = ((uint32_t)(input[18] & 0x01) << 31) |
			((uint32_t)input[19] << 23) |
			((uint32_t)(input[20] & 0xfe) << 15);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 167 to 182
	value = ((uint32_t)(input[20] & 0x01) << 31) |
			((uint32_t)input[21] << 23) |
			((uint32_t)(input[22] & 0xfe) << 15);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 183 to 198
	value = ((uint32_t)(input[22] & 0x01) << 31) |
			((uint32_t)input[23] << 23) |
			((uint32_t)(input[24] & 0xfe) << 15);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 199 to 214
	value = ((uint32_t)(input[24] & 0x01) << 31) |
			((uint32_t)input[25] << 23) |
			((uint32_t)(input[26] & 0xfe) << 15);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 215 to 230
	value = ((uint32_t)(input[26] & 0x01) << 31) |
			((uint32_t)input[27] << 23) |
			((uint32_t)(input[28] & 0xfe) << 15);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 231 to 246
	value = ((uint32_t)(input[28] & 0x01) << 31) |
			((uint32_t)input[29] << 23) |
			((uint32_t)(input[30] & 0xfe) << 15);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 247 to 262
	value = ((uint32_t)(input[30] & 0x01) << 31) |
			((uint32_t)input[31] << 23) |
			((uint32_t)(input[32] & 0xfe) << 15);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 263 to 278
	value = ((uint32_t)(input[32] & 0x01) << 31) |
			((uint32_t)input[33] << 23) |
			((uint32_t)(input[34] & 0xfe) << 15);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 279 to 294
	value = ((uint32_t)(input[34] & 0x01) << 31) |
			((uint32_t)input[35] << 23) |
			((uint32_t)(input[36] & 0xfe) << 15);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 295 to 310
	value = ((uint32_t)(input[36] & 0x01) << 31) |
			((uint32_t)input[37] << 23) |
			((uint32_t)(input[38] & 0xfe) << 15);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 311 to 326
	value = ((uint32_t)(input[38] & 0x01) << 31) |
			((uint32_t)input[39] << 23) |
			((uint32_t)(input[40] & 0xfe) << 15);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 327 to 342
	value = ((uint32_t)(input[40] & 0x01) << 31) |
			((uint32_t)input[41] << 23) |
			((uint32_t)(input[42] & 0xfe) << 15);
	output[20] = (double)(value >> 16);
}

static void unpack_21_16bit_unsigned_7off(const uint8_t * input, double * output, void *closure) {
	// Unpack 21 values into output
	// Values are 16-bit unsigned
	// Skip 7 bits, read 336 bits of data.
	// Input must be at least 43 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 7 to 22
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)(input[2] & 0xfe) << 15);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 23 to 38
	value = ((uint32_t)(input[2] & 0x01) << 31) |
			((uint32_t)input[3] << 23) |
			((uint32_t)(input[4] & 0xfe) << 15);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 39 to 54
	value = ((uint32_t)(input[4] & 0x01) << 31) |
			((uint32_t)input[5] << 23) |
			((uint32_t)(input[6] & 0xfe) << 15);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 55 to 70
	value = ((uint32_t)(input[6] & 0x01) << 31) |
			((uint32_t)input[7] << 23) |
			((uint32_t)(input[8] & 0xfe) << 15);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 71 to 86
	value = ((uint32_t)(input[8] & 0x01) << 31) |
			((uint32_t)input[9] << 23) |
			((uint32_t)(input[10] & 0xfe) << 15);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 87 to 102
	value = ((uint32_t)(input[10] & 0x01) << 31) |
			((uint32_t)input[11] << 23) |
			((uint32_t)(input[12] & 0xfe) << 15);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 103 to 118
	value = ((uint32_t)(input[12] & 0x01) << 31) |
			((uint32_t)input[13] << 23) |
			((uint32_t)(input[14] & 0xfe) << 15);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 119 to 134
	value = ((uint32_t)(input[14] & 0x01) << 31) |
			((uint32_t)input[15] << 23) |
			((uint32_t)(input[16] & 0xfe) << 15);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 135 to 150
	value = ((uint32_t)(input[16] & 0x01) << 31) |
			((uint32_t)input[17] << 23) |
			((uint32_t)(input[18] & 0xfe) << 15);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 151 to 166
	value = ((uint32_t)(input[18] & 0x01) << 31) |
			((uint32_t)input[19] << 23) |
			((uint32_t)(input[20] & 0xfe) << 15);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 167 to 182
	value = ((uint32_t)(input[20] & 0x01) << 31) |
			((uint32_t)input[21] << 23) |
			((uint32_t)(input[22] & 0xfe) << 15);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 183 to 198
	value = ((uint32_t)(input[22] & 0x01) << 31) |
			((uint32_t)input[23] << 23) |
			((uint32_t)(input[24] & 0xfe) << 15);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 199 to 214
	value = ((uint32_t)(input[24] & 0x01) << 31) |
			((uint32_t)input[25] << 23) |
			((uint32_t)(input[26] & 0xfe) << 15);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 215 to 230
	value = ((uint32_t)(input[26] & 0x01) << 31) |
			((uint32_t)input[27] << 23) |
			((uint32_t)(input[28] & 0xfe) << 15);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 231 to 246
	value = ((uint32_t)(input[28] & 0x01) << 31) |
			((uint32_t)input[29] << 23) |
			((uint32_t)(input[30] & 0xfe) << 15);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 247 to 262
	value = ((uint32_t)(input[30] & 0x01) << 31) |
			((uint32_t)input[31] << 23) |
			((uint32_t)(input[32] & 0xfe) << 15);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 263 to 278
	value = ((uint32_t)(input[32] & 0x01) << 31) |
			((uint32_t)input[33] << 23) |
			((uint32_t)(input[34] & 0xfe) << 15);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 279 to 294
	value = ((uint32_t)(input[34] & 0x01) << 31) |
			((uint32_t)input[35] << 23) |
			((uint32_t)(input[36] & 0xfe) << 15);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 295 to 310
	value = ((uint32_t)(input[36] & 0x01) << 31) |
			((uint32_t)input[37] << 23) |
			((uint32_t)(input[38] & 0xfe) << 15);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 311 to 326
	value = ((uint32_t)(input[38] & 0x01) << 31) |
			((uint32_t)input[39] << 23) |
			((uint32_t)(input[40] & 0xfe) << 15);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 327 to 342
	value = ((uint32_t)(input[40] & 0x01) << 31) |
			((uint32_t)input[41] << 23) |
			((uint32_t)(input[42] & 0xfe) << 15);
	output[20] = (double)(value >> 16);
}

static void unpack_22_16bit_signed_0off(const uint8_t * input, double * output, void *closure) {
	// Unpack 22 values into output
	// Values are 16-bit signed
	// Skip 0 bits, read 352 bits of data.
	// Input must be at least 44 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 0 to 15
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)input[1] << 16);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 16 to 31
	value = ((uint32_t)input[2] << 24) |
			((uint32_t)input[3] << 16);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 32 to 47
	value = ((uint32_t)input[4] << 24) |
			((uint32_t)input[5] << 16);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 48 to 63
	value = ((uint32_t)input[6] << 24) |
			((uint32_t)input[7] << 16);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 64 to 79
	value = ((uint32_t)input[8] << 24) |
			((uint32_t)input[9] << 16);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 80 to 95
	value = ((uint32_t)input[10] << 24) |
			((uint32_t)input[11] << 16);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 96 to 111
	value = ((uint32_t)input[12] << 24) |
			((uint32_t)input[13] << 16);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 112 to 127
	value = ((uint32_t)input[14] << 24) |
			((uint32_t)input[15] << 16);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 128 to 143
	value = ((uint32_t)input[16] << 24) |
			((uint32_t)input[17] << 16);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 144 to 159
	value = ((uint32_t)input[18] << 24) |
			((uint32_t)input[19] << 16);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 160 to 175
	value = ((uint32_t)input[20] << 24) |
			((uint32_t)input[21] << 16);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 176 to 191
	value = ((uint32_t)input[22] << 24) |
			((uint32_t)input[23] << 16);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 192 to 207
	value = ((uint32_t)input[24] << 24) |
			((uint32_t)input[25] << 16);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 208 to 223
	value = ((uint32_t)input[26] << 24) |
			((uint32_t)input[27] << 16);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 224 to 239
	value = ((uint32_t)input[28] << 24) |
			((uint32_t)input[29] << 16);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 240 to 255
	value = ((uint32_t)input[30] << 24) |
			((uint32_t)input[31] << 16);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 256 to 271
	value = ((uint32_t)input[32] << 24) |
			((uint32_t)input[33] << 16);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 272 to 287
	value = ((uint32_t)input[34] << 24) |
			((uint32_t)input[35] << 16);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 288 to 303
	value = ((uint32_t)input[36] << 24) |
			((uint32_t)input[37] << 16);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 304 to 319
	value = ((uint32_t)input[38] << 24) |
			((uint32_t)input[39] << 16);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 320 to 335
	value = ((uint32_t)input[40] << 24) |
			((uint32_t)input[41] << 16);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 336 to 351
	value = ((uint32_t)input[42] << 24) |
			((uint32_t)input[43] << 16);
	output[21] = (double)(value >> 16);
}

static void unpack_22_16bit_unsigned_0off(const uint8_t * input, double * output, void *closure) {
	// Unpack 22 values into output
	// Values are 16-bit unsigned
	// Skip 0 bits, read 352 bits of data.
	// Input must be at least 44 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 0 to 15
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)input[1] << 16);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 16 to 31
	value = ((uint32_t)input[2] << 24) |
			((uint32_t)input[3] << 16);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 32 to 47
	value = ((uint32_t)input[4] << 24) |
			((uint32_t)input[5] << 16);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 48 to 63
	value = ((uint32_t)input[6] << 24) |
			((uint32_t)input[7] << 16);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 64 to 79
	value = ((uint32_t)input[8] << 24) |
			((uint32_t)input[9] << 16);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 80 to 95
	value = ((uint32_t)input[10] << 24) |
			((uint32_t)input[11] << 16);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 96 to 111
	value = ((uint32_t)input[12] << 24) |
			((uint32_t)input[13] << 16);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 112 to 127
	value = ((uint32_t)input[14] << 24) |
			((uint32_t)input[15] << 16);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 128 to 143
	value = ((uint32_t)input[16] << 24) |
			((uint32_t)input[17] << 16);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 144 to 159
	value = ((uint32_t)input[18] << 24) |
			((uint32_t)input[19] << 16);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 160 to 175
	value = ((uint32_t)input[20] << 24) |
			((uint32_t)input[21] << 16);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 176 to 191
	value = ((uint32_t)input[22] << 24) |
			((uint32_t)input[23] << 16);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 192 to 207
	value = ((uint32_t)input[24] << 24) |
			((uint32_t)input[25] << 16);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 208 to 223
	value = ((uint32_t)input[26] << 24) |
			((uint32_t)input[27] << 16);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 224 to 239
	value = ((uint32_t)input[28] << 24) |
			((uint32_t)input[29] << 16);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 240 to 255
	value = ((uint32_t)input[30] << 24) |
			((uint32_t)input[31] << 16);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 256 to 271
	value = ((uint32_t)input[32] << 24) |
			((uint32_t)input[33] << 16);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 272 to 287
	value = ((uint32_t)input[34] << 24) |
			((uint32_t)input[35] << 16);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 288 to 303
	value = ((uint32_t)input[36] << 24) |
			((uint32_t)input[37] << 16);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 304 to 319
	value = ((uint32_t)input[38] << 24) |
			((uint32_t)input[39] << 16);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 320 to 335
	value = ((uint32_t)input[40] << 24) |
			((uint32_t)input[41] << 16);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 336 to 351
	value = ((uint32_t)input[42] << 24) |
			((uint32_t)input[43] << 16);
	output[21] = (double)(value >> 16);
}

static void unpack_22_16bit_signed_1off(const uint8_t * input, double * output, void *closure) {
	// Unpack 22 values into output
	// Values are 16-bit signed
	// Skip 1 bits, read 352 bits of data.
	// Input must be at least 45 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 1 to 16
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)input[1] << 17) |
			((uint32_t)(input[2] & 0x80) << 9);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 17 to 32
	value = ((uint32_t)(input[2] & 0x7f) << 25) |
			((uint32_t)input[3] << 17) |
			((uint32_t)(input[4] & 0x80) << 9);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 33 to 48
	value = ((uint32_t)(input[4] & 0x7f) << 25) |
			((uint32_t)input[5] << 17) |
			((uint32_t)(input[6] & 0x80) << 9);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 49 to 64
	value = ((uint32_t)(input[6] & 0x7f) << 25) |
			((uint32_t)input[7] << 17) |
			((uint32_t)(input[8] & 0x80) << 9);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 65 to 80
	value = ((uint32_t)(input[8] & 0x7f) << 25) |
			((uint32_t)input[9] << 17) |
			((uint32_t)(input[10] & 0x80) << 9);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 81 to 96
	value = ((uint32_t)(input[10] & 0x7f) << 25) |
			((uint32_t)input[11] << 17) |
			((uint32_t)(input[12] & 0x80) << 9);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 97 to 112
	value = ((uint32_t)(input[12] & 0x7f) << 25) |
			((uint32_t)input[13] << 17) |
			((uint32_t)(input[14] & 0x80) << 9);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 113 to 128
	value = ((uint32_t)(input[14] & 0x7f) << 25) |
			((uint32_t)input[15] << 17) |
			((uint32_t)(input[16] & 0x80) << 9);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 129 to 144
	value = ((uint32_t)(input[16] & 0x7f) << 25) |
			((uint32_t)input[17] << 17) |
			((uint32_t)(input[18] & 0x80) << 9);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 145 to 160
	value = ((uint32_t)(input[18] & 0x7f) << 25) |
			((uint32_t)input[19] << 17) |
			((uint32_t)(input[20] & 0x80) << 9);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 161 to 176
	value = ((uint32_t)(input[20] & 0x7f) << 25) |
			((uint32_t)input[21] << 17) |
			((uint32_t)(input[22] & 0x80) << 9);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 177 to 192
	value = ((uint32_t)(input[22] & 0x7f) << 25) |
			((uint32_t)input[23] << 17) |
			((uint32_t)(input[24] & 0x80) << 9);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 193 to 208
	value = ((uint32_t)(input[24] & 0x7f) << 25) |
			((uint32_t)input[25] << 17) |
			((uint32_t)(input[26] & 0x80) << 9);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 209 to 224
	value = ((uint32_t)(input[26] & 0x7f) << 25) |
			((uint32_t)input[27] << 17) |
			((uint32_t)(input[28] & 0x80) << 9);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 225 to 240
	value = ((uint32_t)(input[28] & 0x7f) << 25) |
			((uint32_t)input[29] << 17) |
			((uint32_t)(input[30] & 0x80) << 9);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 241 to 256
	value = ((uint32_t)(input[30] & 0x7f) << 25) |
			((uint32_t)input[31] << 17) |
			((uint32_t)(input[32] & 0x80) << 9);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 257 to 272
	value = ((uint32_t)(input[32] & 0x7f) << 25) |
			((uint32_t)input[33] << 17) |
			((uint32_t)(input[34] & 0x80) << 9);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 273 to 288
	value = ((uint32_t)(input[34] & 0x7f) << 25) |
			((uint32_t)input[35] << 17) |
			((uint32_t)(input[36] & 0x80) << 9);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 289 to 304
	value = ((uint32_t)(input[36] & 0x7f) << 25) |
			((uint32_t)input[37] << 17) |
			((uint32_t)(input[38] & 0x80) << 9);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 305 to 320
	value = ((uint32_t)(input[38] & 0x7f) << 25) |
			((uint32_t)input[39] << 17) |
			((uint32_t)(input[40] & 0x80) << 9);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 321 to 336
	value = ((uint32_t)(input[40] & 0x7f) << 25) |
			((uint32_t)input[41] << 17) |
			((uint32_t)(input[42] & 0x80) << 9);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 337 to 352
	value = ((uint32_t)(input[42] & 0x7f) << 25) |
			((uint32_t)input[43] << 17) |
			((uint32_t)(input[44] & 0x80) << 9);
	output[21] = (double)(value >> 16);
}

static void unpack_22_16bit_unsigned_1off(const uint8_t * input, double * output, void *closure) {
	// Unpack 22 values into output
	// Values are 16-bit unsigned
	// Skip 1 bits, read 352 bits of data.
	// Input must be at least 45 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 1 to 16
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)input[1] << 17) |
			((uint32_t)(input[2] & 0x80) << 9);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 17 to 32
	value = ((uint32_t)(input[2] & 0x7f) << 25) |
			((uint32_t)input[3] << 17) |
			((uint32_t)(input[4] & 0x80) << 9);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 33 to 48
	value = ((uint32_t)(input[4] & 0x7f) << 25) |
			((uint32_t)input[5] << 17) |
			((uint32_t)(input[6] & 0x80) << 9);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 49 to 64
	value = ((uint32_t)(input[6] & 0x7f) << 25) |
			((uint32_t)input[7] << 17) |
			((uint32_t)(input[8] & 0x80) << 9);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 65 to 80
	value = ((uint32_t)(input[8] & 0x7f) << 25) |
			((uint32_t)input[9] << 17) |
			((uint32_t)(input[10] & 0x80) << 9);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 81 to 96
	value = ((uint32_t)(input[10] & 0x7f) << 25) |
			((uint32_t)input[11] << 17) |
			((uint32_t)(input[12] & 0x80) << 9);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 97 to 112
	value = ((uint32_t)(input[12] & 0x7f) << 25) |
			((uint32_t)input[13] << 17) |
			((uint32_t)(input[14] & 0x80) << 9);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 113 to 128
	value = ((uint32_t)(input[14] & 0x7f) << 25) |
			((uint32_t)input[15] << 17) |
			((uint32_t)(input[16] & 0x80) << 9);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 129 to 144
	value = ((uint32_t)(input[16] & 0x7f) << 25) |
			((uint32_t)input[17] << 17) |
			((uint32_t)(input[18] & 0x80) << 9);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 145 to 160
	value = ((uint32_t)(input[18] & 0x7f) << 25) |
			((uint32_t)input[19] << 17) |
			((uint32_t)(input[20] & 0x80) << 9);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 161 to 176
	value = ((uint32_t)(input[20] & 0x7f) << 25) |
			((uint32_t)input[21] << 17) |
			((uint32_t)(input[22] & 0x80) << 9);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 177 to 192
	value = ((uint32_t)(input[22] & 0x7f) << 25) |
			((uint32_t)input[23] << 17) |
			((uint32_t)(input[24] & 0x80) << 9);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 193 to 208
	value = ((uint32_t)(input[24] & 0x7f) << 25) |
			((uint32_t)input[25] << 17) |
			((uint32_t)(input[26] & 0x80) << 9);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 209 to 224
	value = ((uint32_t)(input[26] & 0x7f) << 25) |
			((uint32_t)input[27] << 17) |
			((uint32_t)(input[28] & 0x80) << 9);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 225 to 240
	value = ((uint32_t)(input[28] & 0x7f) << 25) |
			((uint32_t)input[29] << 17) |
			((uint32_t)(input[30] & 0x80) << 9);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 241 to 256
	value = ((uint32_t)(input[30] & 0x7f) << 25) |
			((uint32_t)input[31] << 17) |
			((uint32_t)(input[32] & 0x80) << 9);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 257 to 272
	value = ((uint32_t)(input[32] & 0x7f) << 25) |
			((uint32_t)input[33] << 17) |
			((uint32_t)(input[34] & 0x80) << 9);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 273 to 288
	value = ((uint32_t)(input[34] & 0x7f) << 25) |
			((uint32_t)input[35] << 17) |
			((uint32_t)(input[36] & 0x80) << 9);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 289 to 304
	value = ((uint32_t)(input[36] & 0x7f) << 25) |
			((uint32_t)input[37] << 17) |
			((uint32_t)(input[38] & 0x80) << 9);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 305 to 320
	value = ((uint32_t)(input[38] & 0x7f) << 25) |
			((uint32_t)input[39] << 17) |
			((uint32_t)(input[40] & 0x80) << 9);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 321 to 336
	value = ((uint32_t)(input[40] & 0x7f) << 25) |
			((uint32_t)input[41] << 17) |
			((uint32_t)(input[42] & 0x80) << 9);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 337 to 352
	value = ((uint32_t)(input[42] & 0x7f) << 25) |
			((uint32_t)input[43] << 17) |
			((uint32_t)(input[44] & 0x80) << 9);
	output[21] = (double)(value >> 16);
}

static void unpack_22_16bit_signed_2off(const uint8_t * input, double * output, void *closure) {
	// Unpack 22 values into output
	// Values are 16-bit signed
	// Skip 2 bits, read 352 bits of data.
	// Input must be at least 45 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 2 to 17
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)input[1] << 18) |
			((uint32_t)(input[2] & 0xc0) << 10);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 18 to 33
	value = ((uint32_t)(input[2] & 0x3f) << 26) |
			((uint32_t)input[3] << 18) |
			((uint32_t)(input[4] & 0xc0) << 10);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 34 to 49
	value = ((uint32_t)(input[4] & 0x3f) << 26) |
			((uint32_t)input[5] << 18) |
			((uint32_t)(input[6] & 0xc0) << 10);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 50 to 65
	value = ((uint32_t)(input[6] & 0x3f) << 26) |
			((uint32_t)input[7] << 18) |
			((uint32_t)(input[8] & 0xc0) << 10);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 66 to 81
	value = ((uint32_t)(input[8] & 0x3f) << 26) |
			((uint32_t)input[9] << 18) |
			((uint32_t)(input[10] & 0xc0) << 10);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 82 to 97
	value = ((uint32_t)(input[10] & 0x3f) << 26) |
			((uint32_t)input[11] << 18) |
			((uint32_t)(input[12] & 0xc0) << 10);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 98 to 113
	value = ((uint32_t)(input[12] & 0x3f) << 26) |
			((uint32_t)input[13] << 18) |
			((uint32_t)(input[14] & 0xc0) << 10);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 114 to 129
	value = ((uint32_t)(input[14] & 0x3f) << 26) |
			((uint32_t)input[15] << 18) |
			((uint32_t)(input[16] & 0xc0) << 10);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 130 to 145
	value = ((uint32_t)(input[16] & 0x3f) << 26) |
			((uint32_t)input[17] << 18) |
			((uint32_t)(input[18] & 0xc0) << 10);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 146 to 161
	value = ((uint32_t)(input[18] & 0x3f) << 26) |
			((uint32_t)input[19] << 18) |
			((uint32_t)(input[20] & 0xc0) << 10);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 162 to 177
	value = ((uint32_t)(input[20] & 0x3f) << 26) |
			((uint32_t)input[21] << 18) |
			((uint32_t)(input[22] & 0xc0) << 10);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 178 to 193
	value = ((uint32_t)(input[22] & 0x3f) << 26) |
			((uint32_t)input[23] << 18) |
			((uint32_t)(input[24] & 0xc0) << 10);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 194 to 209
	value = ((uint32_t)(input[24] & 0x3f) << 26) |
			((uint32_t)input[25] << 18) |
			((uint32_t)(input[26] & 0xc0) << 10);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 210 to 225
	value = ((uint32_t)(input[26] & 0x3f) << 26) |
			((uint32_t)input[27] << 18) |
			((uint32_t)(input[28] & 0xc0) << 10);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 226 to 241
	value = ((uint32_t)(input[28] & 0x3f) << 26) |
			((uint32_t)input[29] << 18) |
			((uint32_t)(input[30] & 0xc0) << 10);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 242 to 257
	value = ((uint32_t)(input[30] & 0x3f) << 26) |
			((uint32_t)input[31] << 18) |
			((uint32_t)(input[32] & 0xc0) << 10);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 258 to 273
	value = ((uint32_t)(input[32] & 0x3f) << 26) |
			((uint32_t)input[33] << 18) |
			((uint32_t)(input[34] & 0xc0) << 10);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 274 to 289
	value = ((uint32_t)(input[34] & 0x3f) << 26) |
			((uint32_t)input[35] << 18) |
			((uint32_t)(input[36] & 0xc0) << 10);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 290 to 305
	value = ((uint32_t)(input[36] & 0x3f) << 26) |
			((uint32_t)input[37] << 18) |
			((uint32_t)(input[38] & 0xc0) << 10);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 306 to 321
	value = ((uint32_t)(input[38] & 0x3f) << 26) |
			((uint32_t)input[39] << 18) |
			((uint32_t)(input[40] & 0xc0) << 10);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 322 to 337
	value = ((uint32_t)(input[40] & 0x3f) << 26) |
			((uint32_t)input[41] << 18) |
			((uint32_t)(input[42] & 0xc0) << 10);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 338 to 353
	value = ((uint32_t)(input[42] & 0x3f) << 26) |
			((uint32_t)input[43] << 18) |
			((uint32_t)(input[44] & 0xc0) << 10);
	output[21] = (double)(value >> 16);
}

static void unpack_22_16bit_unsigned_2off(const uint8_t * input, double * output, void *closure) {
	// Unpack 22 values into output
	// Values are 16-bit unsigned
	// Skip 2 bits, read 352 bits of data.
	// Input must be at least 45 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 2 to 17
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)input[1] << 18) |
			((uint32_t)(input[2] & 0xc0) << 10);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 18 to 33
	value = ((uint32_t)(input[2] & 0x3f) << 26) |
			((uint32_t)input[3] << 18) |
			((uint32_t)(input[4] & 0xc0) << 10);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 34 to 49
	value = ((uint32_t)(input[4] & 0x3f) << 26) |
			((uint32_t)input[5] << 18) |
			((uint32_t)(input[6] & 0xc0) << 10);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 50 to 65
	value = ((uint32_t)(input[6] & 0x3f) << 26) |
			((uint32_t)input[7] << 18) |
			((uint32_t)(input[8] & 0xc0) << 10);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 66 to 81
	value = ((uint32_t)(input[8] & 0x3f) << 26) |
			((uint32_t)input[9] << 18) |
			((uint32_t)(input[10] & 0xc0) << 10);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 82 to 97
	value = ((uint32_t)(input[10] & 0x3f) << 26) |
			((uint32_t)input[11] << 18) |
			((uint32_t)(input[12] & 0xc0) << 10);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 98 to 113
	value = ((uint32_t)(input[12] & 0x3f) << 26) |
			((uint32_t)input[13] << 18) |
			((uint32_t)(input[14] & 0xc0) << 10);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 114 to 129
	value = ((uint32_t)(input[14] & 0x3f) << 26) |
			((uint32_t)input[15] << 18) |
			((uint32_t)(input[16] & 0xc0) << 10);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 130 to 145
	value = ((uint32_t)(input[16] & 0x3f) << 26) |
			((uint32_t)input[17] << 18) |
			((uint32_t)(input[18] & 0xc0) << 10);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 146 to 161
	value = ((uint32_t)(input[18] & 0x3f) << 26) |
			((uint32_t)input[19] << 18) |
			((uint32_t)(input[20] & 0xc0) << 10);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 162 to 177
	value = ((uint32_t)(input[20] & 0x3f) << 26) |
			((uint32_t)input[21] << 18) |
			((uint32_t)(input[22] & 0xc0) << 10);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 178 to 193
	value = ((uint32_t)(input[22] & 0x3f) << 26) |
			((uint32_t)input[23] << 18) |
			((uint32_t)(input[24] & 0xc0) << 10);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 194 to 209
	value = ((uint32_t)(input[24] & 0x3f) << 26) |
			((uint32_t)input[25] << 18) |
			((uint32_t)(input[26] & 0xc0) << 10);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 210 to 225
	value = ((uint32_t)(input[26] & 0x3f) << 26) |
			((uint32_t)input[27] << 18) |
			((uint32_t)(input[28] & 0xc0) << 10);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 226 to 241
	value = ((uint32_t)(input[28] & 0x3f) << 26) |
			((uint32_t)input[29] << 18) |
			((uint32_t)(input[30] & 0xc0) << 10);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 242 to 257
	value = ((uint32_t)(input[30] & 0x3f) << 26) |
			((uint32_t)input[31] << 18) |
			((uint32_t)(input[32] & 0xc0) << 10);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 258 to 273
	value = ((uint32_t)(input[32] & 0x3f) << 26) |
			((uint32_t)input[33] << 18) |
			((uint32_t)(input[34] & 0xc0) << 10);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 274 to 289
	value = ((uint32_t)(input[34] & 0x3f) << 26) |
			((uint32_t)input[35] << 18) |
			((uint32_t)(input[36] & 0xc0) << 10);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 290 to 305
	value = ((uint32_t)(input[36] & 0x3f) << 26) |
			((uint32_t)input[37] << 18) |
			((uint32_t)(input[38] & 0xc0) << 10);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 306 to 321
	value = ((uint32_t)(input[38] & 0x3f) << 26) |
			((uint32_t)input[39] << 18) |
			((uint32_t)(input[40] & 0xc0) << 10);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 322 to 337
	value = ((uint32_t)(input[40] & 0x3f) << 26) |
			((uint32_t)input[41] << 18) |
			((uint32_t)(input[42] & 0xc0) << 10);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 338 to 353
	value = ((uint32_t)(input[42] & 0x3f) << 26) |
			((uint32_t)input[43] << 18) |
			((uint32_t)(input[44] & 0xc0) << 10);
	output[21] = (double)(value >> 16);
}

static void unpack_22_16bit_signed_3off(const uint8_t * input, double * output, void *closure) {
	// Unpack 22 values into output
	// Values are 16-bit signed
	// Skip 3 bits, read 352 bits of data.
	// Input must be at least 45 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 3 to 18
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)input[1] << 19) |
			((uint32_t)(input[2] & 0xe0) << 11);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 19 to 34
	value = ((uint32_t)(input[2] & 0x1f) << 27) |
			((uint32_t)input[3] << 19) |
			((uint32_t)(input[4] & 0xe0) << 11);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 35 to 50
	value = ((uint32_t)(input[4] & 0x1f) << 27) |
			((uint32_t)input[5] << 19) |
			((uint32_t)(input[6] & 0xe0) << 11);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 51 to 66
	value = ((uint32_t)(input[6] & 0x1f) << 27) |
			((uint32_t)input[7] << 19) |
			((uint32_t)(input[8] & 0xe0) << 11);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 67 to 82
	value = ((uint32_t)(input[8] & 0x1f) << 27) |
			((uint32_t)input[9] << 19) |
			((uint32_t)(input[10] & 0xe0) << 11);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 83 to 98
	value = ((uint32_t)(input[10] & 0x1f) << 27) |
			((uint32_t)input[11] << 19) |
			((uint32_t)(input[12] & 0xe0) << 11);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 99 to 114
	value = ((uint32_t)(input[12] & 0x1f) << 27) |
			((uint32_t)input[13] << 19) |
			((uint32_t)(input[14] & 0xe0) << 11);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 115 to 130
	value = ((uint32_t)(input[14] & 0x1f) << 27) |
			((uint32_t)input[15] << 19) |
			((uint32_t)(input[16] & 0xe0) << 11);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 131 to 146
	value = ((uint32_t)(input[16] & 0x1f) << 27) |
			((uint32_t)input[17] << 19) |
			((uint32_t)(input[18] & 0xe0) << 11);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 147 to 162
	value = ((uint32_t)(input[18] & 0x1f) << 27) |
			((uint32_t)input[19] << 19) |
			((uint32_t)(input[20] & 0xe0) << 11);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 163 to 178
	value = ((uint32_t)(input[20] & 0x1f) << 27) |
			((uint32_t)input[21] << 19) |
			((uint32_t)(input[22] & 0xe0) << 11);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 179 to 194
	value = ((uint32_t)(input[22] & 0x1f) << 27) |
			((uint32_t)input[23] << 19) |
			((uint32_t)(input[24] & 0xe0) << 11);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 195 to 210
	value = ((uint32_t)(input[24] & 0x1f) << 27) |
			((uint32_t)input[25] << 19) |
			((uint32_t)(input[26] & 0xe0) << 11);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 211 to 226
	value = ((uint32_t)(input[26] & 0x1f) << 27) |
			((uint32_t)input[27] << 19) |
			((uint32_t)(input[28] & 0xe0) << 11);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 227 to 242
	value = ((uint32_t)(input[28] & 0x1f) << 27) |
			((uint32_t)input[29] << 19) |
			((uint32_t)(input[30] & 0xe0) << 11);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 243 to 258
	value = ((uint32_t)(input[30] & 0x1f) << 27) |
			((uint32_t)input[31] << 19) |
			((uint32_t)(input[32] & 0xe0) << 11);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 259 to 274
	value = ((uint32_t)(input[32] & 0x1f) << 27) |
			((uint32_t)input[33] << 19) |
			((uint32_t)(input[34] & 0xe0) << 11);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 275 to 290
	value = ((uint32_t)(input[34] & 0x1f) << 27) |
			((uint32_t)input[35] << 19) |
			((uint32_t)(input[36] & 0xe0) << 11);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 291 to 306
	value = ((uint32_t)(input[36] & 0x1f) << 27) |
			((uint32_t)input[37] << 19) |
			((uint32_t)(input[38] & 0xe0) << 11);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 307 to 322
	value = ((uint32_t)(input[38] & 0x1f) << 27) |
			((uint32_t)input[39] << 19) |
			((uint32_t)(input[40] & 0xe0) << 11);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 323 to 338
	value = ((uint32_t)(input[40] & 0x1f) << 27) |
			((uint32_t)input[41] << 19) |
			((uint32_t)(input[42] & 0xe0) << 11);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 339 to 354
	value = ((uint32_t)(input[42] & 0x1f) << 27) |
			((uint32_t)input[43] << 19) |
			((uint32_t)(input[44] & 0xe0) << 11);
	output[21] = (double)(value >> 16);
}

static void unpack_22_16bit_unsigned_3off(const uint8_t * input, double * output, void *closure) {
	// Unpack 22 values into output
	// Values are 16-bit unsigned
	// Skip 3 bits, read 352 bits of data.
	// Input must be at least 45 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 3 to 18
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)input[1] << 19) |
			((uint32_t)(input[2] & 0xe0) << 11);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 19 to 34
	value = ((uint32_t)(input[2] & 0x1f) << 27) |
			((uint32_t)input[3] << 19) |
			((uint32_t)(input[4] & 0xe0) << 11);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 35 to 50
	value = ((uint32_t)(input[4] & 0x1f) << 27) |
			((uint32_t)input[5] << 19) |
			((uint32_t)(input[6] & 0xe0) << 11);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 51 to 66
	value = ((uint32_t)(input[6] & 0x1f) << 27) |
			((uint32_t)input[7] << 19) |
			((uint32_t)(input[8] & 0xe0) << 11);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 67 to 82
	value = ((uint32_t)(input[8] & 0x1f) << 27) |
			((uint32_t)input[9] << 19) |
			((uint32_t)(input[10] & 0xe0) << 11);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 83 to 98
	value = ((uint32_t)(input[10] & 0x1f) << 27) |
			((uint32_t)input[11] << 19) |
			((uint32_t)(input[12] & 0xe0) << 11);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 99 to 114
	value = ((uint32_t)(input[12] & 0x1f) << 27) |
			((uint32_t)input[13] << 19) |
			((uint32_t)(input[14] & 0xe0) << 11);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 115 to 130
	value = ((uint32_t)(input[14] & 0x1f) << 27) |
			((uint32_t)input[15] << 19) |
			((uint32_t)(input[16] & 0xe0) << 11);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 131 to 146
	value = ((uint32_t)(input[16] & 0x1f) << 27) |
			((uint32_t)input[17] << 19) |
			((uint32_t)(input[18] & 0xe0) << 11);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 147 to 162
	value = ((uint32_t)(input[18] & 0x1f) << 27) |
			((uint32_t)input[19] << 19) |
			((uint32_t)(input[20] & 0xe0) << 11);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 163 to 178
	value = ((uint32_t)(input[20] & 0x1f) << 27) |
			((uint32_t)input[21] << 19) |
			((uint32_t)(input[22] & 0xe0) << 11);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 179 to 194
	value = ((uint32_t)(input[22] & 0x1f) << 27) |
			((uint32_t)input[23] << 19) |
			((uint32_t)(input[24] & 0xe0) << 11);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 195 to 210
	value = ((uint32_t)(input[24] & 0x1f) << 27) |
			((uint32_t)input[25] << 19) |
			((uint32_t)(input[26] & 0xe0) << 11);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 211 to 226
	value = ((uint32_t)(input[26] & 0x1f) << 27) |
			((uint32_t)input[27] << 19) |
			((uint32_t)(input[28] & 0xe0) << 11);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 227 to 242
	value = ((uint32_t)(input[28] & 0x1f) << 27) |
			((uint32_t)input[29] << 19) |
			((uint32_t)(input[30] & 0xe0) << 11);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 243 to 258
	value = ((uint32_t)(input[30] & 0x1f) << 27) |
			((uint32_t)input[31] << 19) |
			((uint32_t)(input[32] & 0xe0) << 11);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 259 to 274
	value = ((uint32_t)(input[32] & 0x1f) << 27) |
			((uint32_t)input[33] << 19) |
			((uint32_t)(input[34] & 0xe0) << 11);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 275 to 290
	value = ((uint32_t)(input[34] & 0x1f) << 27) |
			((uint32_t)input[35] << 19) |
			((uint32_t)(input[36] & 0xe0) << 11);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 291 to 306
	value = ((uint32_t)(input[36] & 0x1f) << 27) |
			((uint32_t)input[37] << 19) |
			((uint32_t)(input[38] & 0xe0) << 11);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 307 to 322
	value = ((uint32_t)(input[38] & 0x1f) << 27) |
			((uint32_t)input[39] << 19) |
			((uint32_t)(input[40] & 0xe0) << 11);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 323 to 338
	value = ((uint32_t)(input[40] & 0x1f) << 27) |
			((uint32_t)input[41] << 19) |
			((uint32_t)(input[42] & 0xe0) << 11);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 339 to 354
	value = ((uint32_t)(input[42] & 0x1f) << 27) |
			((uint32_t)input[43] << 19) |
			((uint32_t)(input[44] & 0xe0) << 11);
	output[21] = (double)(value >> 16);
}

static void unpack_22_16bit_signed_4off(const uint8_t * input, double * output, void *closure) {
	// Unpack 22 values into output
	// Values are 16-bit signed
	// Skip 4 bits, read 352 bits of data.
	// Input must be at least 45 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 4 to 19
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20) |
			((uint32_t)(input[2] & 0xf0) << 12);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 20 to 35
	value = ((uint32_t)(input[2] & 0x0f) << 28) |
			((uint32_t)input[3] << 20) |
			((uint32_t)(input[4] & 0xf0) << 12);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 36 to 51
	value = ((uint32_t)(input[4] & 0x0f) << 28) |
			((uint32_t)input[5] << 20) |
			((uint32_t)(input[6] & 0xf0) << 12);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 52 to 67
	value = ((uint32_t)(input[6] & 0x0f) << 28) |
			((uint32_t)input[7] << 20) |
			((uint32_t)(input[8] & 0xf0) << 12);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 68 to 83
	value = ((uint32_t)(input[8] & 0x0f) << 28) |
			((uint32_t)input[9] << 20) |
			((uint32_t)(input[10] & 0xf0) << 12);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 84 to 99
	value = ((uint32_t)(input[10] & 0x0f) << 28) |
			((uint32_t)input[11] << 20) |
			((uint32_t)(input[12] & 0xf0) << 12);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 100 to 115
	value = ((uint32_t)(input[12] & 0x0f) << 28) |
			((uint32_t)input[13] << 20) |
			((uint32_t)(input[14] & 0xf0) << 12);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 116 to 131
	value = ((uint32_t)(input[14] & 0x0f) << 28) |
			((uint32_t)input[15] << 20) |
			((uint32_t)(input[16] & 0xf0) << 12);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 132 to 147
	value = ((uint32_t)(input[16] & 0x0f) << 28) |
			((uint32_t)input[17] << 20) |
			((uint32_t)(input[18] & 0xf0) << 12);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 148 to 163
	value = ((uint32_t)(input[18] & 0x0f) << 28) |
			((uint32_t)input[19] << 20) |
			((uint32_t)(input[20] & 0xf0) << 12);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 164 to 179
	value = ((uint32_t)(input[20] & 0x0f) << 28) |
			((uint32_t)input[21] << 20) |
			((uint32_t)(input[22] & 0xf0) << 12);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 180 to 195
	value = ((uint32_t)(input[22] & 0x0f) << 28) |
			((uint32_t)input[23] << 20) |
			((uint32_t)(input[24] & 0xf0) << 12);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 196 to 211
	value = ((uint32_t)(input[24] & 0x0f) << 28) |
			((uint32_t)input[25] << 20) |
			((uint32_t)(input[26] & 0xf0) << 12);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 212 to 227
	value = ((uint32_t)(input[26] & 0x0f) << 28) |
			((uint32_t)input[27] << 20) |
			((uint32_t)(input[28] & 0xf0) << 12);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 228 to 243
	value = ((uint32_t)(input[28] & 0x0f) << 28) |
			((uint32_t)input[29] << 20) |
			((uint32_t)(input[30] & 0xf0) << 12);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 244 to 259
	value = ((uint32_t)(input[30] & 0x0f) << 28) |
			((uint32_t)input[31] << 20) |
			((uint32_t)(input[32] & 0xf0) << 12);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 260 to 275
	value = ((uint32_t)(input[32] & 0x0f) << 28) |
			((uint32_t)input[33] << 20) |
			((uint32_t)(input[34] & 0xf0) << 12);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 276 to 291
	value = ((uint32_t)(input[34] & 0x0f) << 28) |
			((uint32_t)input[35] << 20) |
			((uint32_t)(input[36] & 0xf0) << 12);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 292 to 307
	value = ((uint32_t)(input[36] & 0x0f) << 28) |
			((uint32_t)input[37] << 20) |
			((uint32_t)(input[38] & 0xf0) << 12);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 308 to 323
	value = ((uint32_t)(input[38] & 0x0f) << 28) |
			((uint32_t)input[39] << 20) |
			((uint32_t)(input[40] & 0xf0) << 12);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 324 to 339
	value = ((uint32_t)(input[40] & 0x0f) << 28) |
			((uint32_t)input[41] << 20) |
			((uint32_t)(input[42] & 0xf0) << 12);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 340 to 355
	value = ((uint32_t)(input[42] & 0x0f) << 28) |
			((uint32_t)input[43] << 20) |
			((uint32_t)(input[44] & 0xf0) << 12);
	output[21] = (double)(value >> 16);
}

static void unpack_22_16bit_unsigned_4off(const uint8_t * input, double * output, void *closure) {
	// Unpack 22 values into output
	// Values are 16-bit unsigned
	// Skip 4 bits, read 352 bits of data.
	// Input must be at least 45 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 4 to 19
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20) |
			((uint32_t)(input[2] & 0xf0) << 12);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 20 to 35
	value = ((uint32_t)(input[2] & 0x0f) << 28) |
			((uint32_t)input[3] << 20) |
			((uint32_t)(input[4] & 0xf0) << 12);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 36 to 51
	value = ((uint32_t)(input[4] & 0x0f) << 28) |
			((uint32_t)input[5] << 20) |
			((uint32_t)(input[6] & 0xf0) << 12);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 52 to 67
	value = ((uint32_t)(input[6] & 0x0f) << 28) |
			((uint32_t)input[7] << 20) |
			((uint32_t)(input[8] & 0xf0) << 12);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 68 to 83
	value = ((uint32_t)(input[8] & 0x0f) << 28) |
			((uint32_t)input[9] << 20) |
			((uint32_t)(input[10] & 0xf0) << 12);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 84 to 99
	value = ((uint32_t)(input[10] & 0x0f) << 28) |
			((uint32_t)input[11] << 20) |
			((uint32_t)(input[12] & 0xf0) << 12);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 100 to 115
	value = ((uint32_t)(input[12] & 0x0f) << 28) |
			((uint32_t)input[13] << 20) |
			((uint32_t)(input[14] & 0xf0) << 12);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 116 to 131
	value = ((uint32_t)(input[14] & 0x0f) << 28) |
			((uint32_t)input[15] << 20) |
			((uint32_t)(input[16] & 0xf0) << 12);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 132 to 147
	value = ((uint32_t)(input[16] & 0x0f) << 28) |
			((uint32_t)input[17] << 20) |
			((uint32_t)(input[18] & 0xf0) << 12);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 148 to 163
	value = ((uint32_t)(input[18] & 0x0f) << 28) |
			((uint32_t)input[19] << 20) |
			((uint32_t)(input[20] & 0xf0) << 12);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 164 to 179
	value = ((uint32_t)(input[20] & 0x0f) << 28) |
			((uint32_t)input[21] << 20) |
			((uint32_t)(input[22] & 0xf0) << 12);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 180 to 195
	value = ((uint32_t)(input[22] & 0x0f) << 28) |
			((uint32_t)input[23] << 20) |
			((uint32_t)(input[24] & 0xf0) << 12);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 196 to 211
	value = ((uint32_t)(input[24] & 0x0f) << 28) |
			((uint32_t)input[25] << 20) |
			((uint32_t)(input[26] & 0xf0) << 12);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 212 to 227
	value = ((uint32_t)(input[26] & 0x0f) << 28) |
			((uint32_t)input[27] << 20) |
			((uint32_t)(input[28] & 0xf0) << 12);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 228 to 243
	value = ((uint32_t)(input[28] & 0x0f) << 28) |
			((uint32_t)input[29] << 20) |
			((uint32_t)(input[30] & 0xf0) << 12);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 244 to 259
	value = ((uint32_t)(input[30] & 0x0f) << 28) |
			((uint32_t)input[31] << 20) |
			((uint32_t)(input[32] & 0xf0) << 12);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 260 to 275
	value = ((uint32_t)(input[32] & 0x0f) << 28) |
			((uint32_t)input[33] << 20) |
			((uint32_t)(input[34] & 0xf0) << 12);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 276 to 291
	value = ((uint32_t)(input[34] & 0x0f) << 28) |
			((uint32_t)input[35] << 20) |
			((uint32_t)(input[36] & 0xf0) << 12);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 292 to 307
	value = ((uint32_t)(input[36] & 0x0f) << 28) |
			((uint32_t)input[37] << 20) |
			((uint32_t)(input[38] & 0xf0) << 12);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 308 to 323
	value = ((uint32_t)(input[38] & 0x0f) << 28) |
			((uint32_t)input[39] << 20) |
			((uint32_t)(input[40] & 0xf0) << 12);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 324 to 339
	value = ((uint32_t)(input[40] & 0x0f) << 28) |
			((uint32_t)input[41] << 20) |
			((uint32_t)(input[42] & 0xf0) << 12);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 340 to 355
	value = ((uint32_t)(input[42] & 0x0f) << 28) |
			((uint32_t)input[43] << 20) |
			((uint32_t)(input[44] & 0xf0) << 12);
	output[21] = (double)(value >> 16);
}

static void unpack_22_16bit_signed_5off(const uint8_t * input, double * output, void *closure) {
	// Unpack 22 values into output
	// Values are 16-bit signed
	// Skip 5 bits, read 352 bits of data.
	// Input must be at least 45 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 5 to 20
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)(input[2] & 0xf8) << 13);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 21 to 36
	value = ((uint32_t)(input[2] & 0x07) << 29) |
			((uint32_t)input[3] << 21) |
			((uint32_t)(input[4] & 0xf8) << 13);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 37 to 52
	value = ((uint32_t)(input[4] & 0x07) << 29) |
			((uint32_t)input[5] << 21) |
			((uint32_t)(input[6] & 0xf8) << 13);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 53 to 68
	value = ((uint32_t)(input[6] & 0x07) << 29) |
			((uint32_t)input[7] << 21) |
			((uint32_t)(input[8] & 0xf8) << 13);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 69 to 84
	value = ((uint32_t)(input[8] & 0x07) << 29) |
			((uint32_t)input[9] << 21) |
			((uint32_t)(input[10] & 0xf8) << 13);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 85 to 100
	value = ((uint32_t)(input[10] & 0x07) << 29) |
			((uint32_t)input[11] << 21) |
			((uint32_t)(input[12] & 0xf8) << 13);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 101 to 116
	value = ((uint32_t)(input[12] & 0x07) << 29) |
			((uint32_t)input[13] << 21) |
			((uint32_t)(input[14] & 0xf8) << 13);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 117 to 132
	value = ((uint32_t)(input[14] & 0x07) << 29) |
			((uint32_t)input[15] << 21) |
			((uint32_t)(input[16] & 0xf8) << 13);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 133 to 148
	value = ((uint32_t)(input[16] & 0x07) << 29) |
			((uint32_t)input[17] << 21) |
			((uint32_t)(input[18] & 0xf8) << 13);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 149 to 164
	value = ((uint32_t)(input[18] & 0x07) << 29) |
			((uint32_t)input[19] << 21) |
			((uint32_t)(input[20] & 0xf8) << 13);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 165 to 180
	value = ((uint32_t)(input[20] & 0x07) << 29) |
			((uint32_t)input[21] << 21) |
			((uint32_t)(input[22] & 0xf8) << 13);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 181 to 196
	value = ((uint32_t)(input[22] & 0x07) << 29) |
			((uint32_t)input[23] << 21) |
			((uint32_t)(input[24] & 0xf8) << 13);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 197 to 212
	value = ((uint32_t)(input[24] & 0x07) << 29) |
			((uint32_t)input[25] << 21) |
			((uint32_t)(input[26] & 0xf8) << 13);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 213 to 228
	value = ((uint32_t)(input[26] & 0x07) << 29) |
			((uint32_t)input[27] << 21) |
			((uint32_t)(input[28] & 0xf8) << 13);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 229 to 244
	value = ((uint32_t)(input[28] & 0x07) << 29) |
			((uint32_t)input[29] << 21) |
			((uint32_t)(input[30] & 0xf8) << 13);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 245 to 260
	value = ((uint32_t)(input[30] & 0x07) << 29) |
			((uint32_t)input[31] << 21) |
			((uint32_t)(input[32] & 0xf8) << 13);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 261 to 276
	value = ((uint32_t)(input[32] & 0x07) << 29) |
			((uint32_t)input[33] << 21) |
			((uint32_t)(input[34] & 0xf8) << 13);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 277 to 292
	value = ((uint32_t)(input[34] & 0x07) << 29) |
			((uint32_t)input[35] << 21) |
			((uint32_t)(input[36] & 0xf8) << 13);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 293 to 308
	value = ((uint32_t)(input[36] & 0x07) << 29) |
			((uint32_t)input[37] << 21) |
			((uint32_t)(input[38] & 0xf8) << 13);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 309 to 324
	value = ((uint32_t)(input[38] & 0x07) << 29) |
			((uint32_t)input[39] << 21) |
			((uint32_t)(input[40] & 0xf8) << 13);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 325 to 340
	value = ((uint32_t)(input[40] & 0x07) << 29) |
			((uint32_t)input[41] << 21) |
			((uint32_t)(input[42] & 0xf8) << 13);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 341 to 356
	value = ((uint32_t)(input[42] & 0x07) << 29) |
			((uint32_t)input[43] << 21) |
			((uint32_t)(input[44] & 0xf8) << 13);
	output[21] = (double)(value >> 16);
}

static void unpack_22_16bit_unsigned_5off(const uint8_t * input, double * output, void *closure) {
	// Unpack 22 values into output
	// Values are 16-bit unsigned
	// Skip 5 bits, read 352 bits of data.
	// Input must be at least 45 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 5 to 20
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)(input[2] & 0xf8) << 13);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 21 to 36
	value = ((uint32_t)(input[2] & 0x07) << 29) |
			((uint32_t)input[3] << 21) |
			((uint32_t)(input[4] & 0xf8) << 13);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 37 to 52
	value = ((uint32_t)(input[4] & 0x07) << 29) |
			((uint32_t)input[5] << 21) |
			((uint32_t)(input[6] & 0xf8) << 13);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 53 to 68
	value = ((uint32_t)(input[6] & 0x07) << 29) |
			((uint32_t)input[7] << 21) |
			((uint32_t)(input[8] & 0xf8) << 13);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 69 to 84
	value = ((uint32_t)(input[8] & 0x07) << 29) |
			((uint32_t)input[9] << 21) |
			((uint32_t)(input[10] & 0xf8) << 13);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 85 to 100
	value = ((uint32_t)(input[10] & 0x07) << 29) |
			((uint32_t)input[11] << 21) |
			((uint32_t)(input[12] & 0xf8) << 13);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 101 to 116
	value = ((uint32_t)(input[12] & 0x07) << 29) |
			((uint32_t)input[13] << 21) |
			((uint32_t)(input[14] & 0xf8) << 13);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 117 to 132
	value = ((uint32_t)(input[14] & 0x07) << 29) |
			((uint32_t)input[15] << 21) |
			((uint32_t)(input[16] & 0xf8) << 13);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 133 to 148
	value = ((uint32_t)(input[16] & 0x07) << 29) |
			((uint32_t)input[17] << 21) |
			((uint32_t)(input[18] & 0xf8) << 13);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 149 to 164
	value = ((uint32_t)(input[18] & 0x07) << 29) |
			((uint32_t)input[19] << 21) |
			((uint32_t)(input[20] & 0xf8) << 13);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 165 to 180
	value = ((uint32_t)(input[20] & 0x07) << 29) |
			((uint32_t)input[21] << 21) |
			((uint32_t)(input[22] & 0xf8) << 13);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 181 to 196
	value = ((uint32_t)(input[22] & 0x07) << 29) |
			((uint32_t)input[23] << 21) |
			((uint32_t)(input[24] & 0xf8) << 13);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 197 to 212
	value = ((uint32_t)(input[24] & 0x07) << 29) |
			((uint32_t)input[25] << 21) |
			((uint32_t)(input[26] & 0xf8) << 13);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 213 to 228
	value = ((uint32_t)(input[26] & 0x07) << 29) |
			((uint32_t)input[27] << 21) |
			((uint32_t)(input[28] & 0xf8) << 13);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 229 to 244
	value = ((uint32_t)(input[28] & 0x07) << 29) |
			((uint32_t)input[29] << 21) |
			((uint32_t)(input[30] & 0xf8) << 13);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 245 to 260
	value = ((uint32_t)(input[30] & 0x07) << 29) |
			((uint32_t)input[31] << 21) |
			((uint32_t)(input[32] & 0xf8) << 13);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 261 to 276
	value = ((uint32_t)(input[32] & 0x07) << 29) |
			((uint32_t)input[33] << 21) |
			((uint32_t)(input[34] & 0xf8) << 13);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 277 to 292
	value = ((uint32_t)(input[34] & 0x07) << 29) |
			((uint32_t)input[35] << 21) |
			((uint32_t)(input[36] & 0xf8) << 13);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 293 to 308
	value = ((uint32_t)(input[36] & 0x07) << 29) |
			((uint32_t)input[37] << 21) |
			((uint32_t)(input[38] & 0xf8) << 13);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 309 to 324
	value = ((uint32_t)(input[38] & 0x07) << 29) |
			((uint32_t)input[39] << 21) |
			((uint32_t)(input[40] & 0xf8) << 13);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 325 to 340
	value = ((uint32_t)(input[40] & 0x07) << 29) |
			((uint32_t)input[41] << 21) |
			((uint32_t)(input[42] & 0xf8) << 13);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 341 to 356
	value = ((uint32_t)(input[42] & 0x07) << 29) |
			((uint32_t)input[43] << 21) |
			((uint32_t)(input[44] & 0xf8) << 13);
	output[21] = (double)(value >> 16);
}

static void unpack_22_16bit_signed_6off(const uint8_t * input, double * output, void *closure) {
	// Unpack 22 values into output
	// Values are 16-bit signed
	// Skip 6 bits, read 352 bits of data.
	// Input must be at least 45 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 6 to 21
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)(input[2] & 0xfc) << 14);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 22 to 37
	value = ((uint32_t)(input[2] & 0x03) << 30) |
			((uint32_t)input[3] << 22) |
			((uint32_t)(input[4] & 0xfc) << 14);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 38 to 53
	value = ((uint32_t)(input[4] & 0x03) << 30) |
			((uint32_t)input[5] << 22) |
			((uint32_t)(input[6] & 0xfc) << 14);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 54 to 69
	value = ((uint32_t)(input[6] & 0x03) << 30) |
			((uint32_t)input[7] << 22) |
			((uint32_t)(input[8] & 0xfc) << 14);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 70 to 85
	value = ((uint32_t)(input[8] & 0x03) << 30) |
			((uint32_t)input[9] << 22) |
			((uint32_t)(input[10] & 0xfc) << 14);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 86 to 101
	value = ((uint32_t)(input[10] & 0x03) << 30) |
			((uint32_t)input[11] << 22) |
			((uint32_t)(input[12] & 0xfc) << 14);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 102 to 117
	value = ((uint32_t)(input[12] & 0x03) << 30) |
			((uint32_t)input[13] << 22) |
			((uint32_t)(input[14] & 0xfc) << 14);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 118 to 133
	value = ((uint32_t)(input[14] & 0x03) << 30) |
			((uint32_t)input[15] << 22) |
			((uint32_t)(input[16] & 0xfc) << 14);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 134 to 149
	value = ((uint32_t)(input[16] & 0x03) << 30) |
			((uint32_t)input[17] << 22) |
			((uint32_t)(input[18] & 0xfc) << 14);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 150 to 165
	value = ((uint32_t)(input[18] & 0x03) << 30) |
			((uint32_t)input[19] << 22) |
			((uint32_t)(input[20] & 0xfc) << 14);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 166 to 181
	value = ((uint32_t)(input[20] & 0x03) << 30) |
			((uint32_t)input[21] << 22) |
			((uint32_t)(input[22] & 0xfc) << 14);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 182 to 197
	value = ((uint32_t)(input[22] & 0x03) << 30) |
			((uint32_t)input[23] << 22) |
			((uint32_t)(input[24] & 0xfc) << 14);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 198 to 213
	value = ((uint32_t)(input[24] & 0x03) << 30) |
			((uint32_t)input[25] << 22) |
			((uint32_t)(input[26] & 0xfc) << 14);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 214 to 229
	value = ((uint32_t)(input[26] & 0x03) << 30) |
			((uint32_t)input[27] << 22) |
			((uint32_t)(input[28] & 0xfc) << 14);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 230 to 245
	value = ((uint32_t)(input[28] & 0x03) << 30) |
			((uint32_t)input[29] << 22) |
			((uint32_t)(input[30] & 0xfc) << 14);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 246 to 261
	value = ((uint32_t)(input[30] & 0x03) << 30) |
			((uint32_t)input[31] << 22) |
			((uint32_t)(input[32] & 0xfc) << 14);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 262 to 277
	value = ((uint32_t)(input[32] & 0x03) << 30) |
			((uint32_t)input[33] << 22) |
			((uint32_t)(input[34] & 0xfc) << 14);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 278 to 293
	value = ((uint32_t)(input[34] & 0x03) << 30) |
			((uint32_t)input[35] << 22) |
			((uint32_t)(input[36] & 0xfc) << 14);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 294 to 309
	value = ((uint32_t)(input[36] & 0x03) << 30) |
			((uint32_t)input[37] << 22) |
			((uint32_t)(input[38] & 0xfc) << 14);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 310 to 325
	value = ((uint32_t)(input[38] & 0x03) << 30) |
			((uint32_t)input[39] << 22) |
			((uint32_t)(input[40] & 0xfc) << 14);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 326 to 341
	value = ((uint32_t)(input[40] & 0x03) << 30) |
			((uint32_t)input[41] << 22) |
			((uint32_t)(input[42] & 0xfc) << 14);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 342 to 357
	value = ((uint32_t)(input[42] & 0x03) << 30) |
			((uint32_t)input[43] << 22) |
			((uint32_t)(input[44] & 0xfc) << 14);
	output[21] = (double)(value >> 16);
}

static void unpack_22_16bit_unsigned_6off(const uint8_t * input, double * output, void *closure) {
	// Unpack 22 values into output
	// Values are 16-bit unsigned
	// Skip 6 bits, read 352 bits of data.
	// Input must be at least 45 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 6 to 21
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)(input[2] & 0xfc) << 14);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 22 to 37
	value = ((uint32_t)(input[2] & 0x03) << 30) |
			((uint32_t)input[3] << 22) |
			((uint32_t)(input[4] & 0xfc) << 14);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 38 to 53
	value = ((uint32_t)(input[4] & 0x03) << 30) |
			((uint32_t)input[5] << 22) |
			((uint32_t)(input[6] & 0xfc) << 14);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 54 to 69
	value = ((uint32_t)(input[6] & 0x03) << 30) |
			((uint32_t)input[7] << 22) |
			((uint32_t)(input[8] & 0xfc) << 14);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 70 to 85
	value = ((uint32_t)(input[8] & 0x03) << 30) |
			((uint32_t)input[9] << 22) |
			((uint32_t)(input[10] & 0xfc) << 14);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 86 to 101
	value = ((uint32_t)(input[10] & 0x03) << 30) |
			((uint32_t)input[11] << 22) |
			((uint32_t)(input[12] & 0xfc) << 14);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 102 to 117
	value = ((uint32_t)(input[12] & 0x03) << 30) |
			((uint32_t)input[13] << 22) |
			((uint32_t)(input[14] & 0xfc) << 14);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 118 to 133
	value = ((uint32_t)(input[14] & 0x03) << 30) |
			((uint32_t)input[15] << 22) |
			((uint32_t)(input[16] & 0xfc) << 14);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 134 to 149
	value = ((uint32_t)(input[16] & 0x03) << 30) |
			((uint32_t)input[17] << 22) |
			((uint32_t)(input[18] & 0xfc) << 14);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 150 to 165
	value = ((uint32_t)(input[18] & 0x03) << 30) |
			((uint32_t)input[19] << 22) |
			((uint32_t)(input[20] & 0xfc) << 14);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 166 to 181
	value = ((uint32_t)(input[20] & 0x03) << 30) |
			((uint32_t)input[21] << 22) |
			((uint32_t)(input[22] & 0xfc) << 14);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 182 to 197
	value = ((uint32_t)(input[22] & 0x03) << 30) |
			((uint32_t)input[23] << 22) |
			((uint32_t)(input[24] & 0xfc) << 14);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 198 to 213
	value = ((uint32_t)(input[24] & 0x03) << 30) |
			((uint32_t)input[25] << 22) |
			((uint32_t)(input[26] & 0xfc) << 14);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 214 to 229
	value = ((uint32_t)(input[26] & 0x03) << 30) |
			((uint32_t)input[27] << 22) |
			((uint32_t)(input[28] & 0xfc) << 14);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 230 to 245
	value = ((uint32_t)(input[28] & 0x03) << 30) |
			((uint32_t)input[29] << 22) |
			((uint32_t)(input[30] & 0xfc) << 14);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 246 to 261
	value = ((uint32_t)(input[30] & 0x03) << 30) |
			((uint32_t)input[31] << 22) |
			((uint32_t)(input[32] & 0xfc) << 14);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 262 to 277
	value = ((uint32_t)(input[32] & 0x03) << 30) |
			((uint32_t)input[33] << 22) |
			((uint32_t)(input[34] & 0xfc) << 14);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 278 to 293
	value = ((uint32_t)(input[34] & 0x03) << 30) |
			((uint32_t)input[35] << 22) |
			((uint32_t)(input[36] & 0xfc) << 14);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 294 to 309
	value = ((uint32_t)(input[36] & 0x03) << 30) |
			((uint32_t)input[37] << 22) |
			((uint32_t)(input[38] & 0xfc) << 14);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 310 to 325
	value = ((uint32_t)(input[38] & 0x03) << 30) |
			((uint32_t)input[39] << 22) |
			((uint32_t)(input[40] & 0xfc) << 14);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 326 to 341
	value = ((uint32_t)(input[40] & 0x03) << 30) |
			((uint32_t)input[41] << 22) |
			((uint32_t)(input[42] & 0xfc) << 14);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 342 to 357
	value = ((uint32_t)(input[42] & 0x03) << 30) |
			((uint32_t)input[43] << 22) |
			((uint32_t)(input[44] & 0xfc) << 14);
	output[21] = (double)(value >> 16);
}

static void unpack_22_16bit_signed_7off(const uint8_t * input, double * output, void *closure) {
	// Unpack 22 values into output
	// Values are 16-bit signed
	// Skip 7 bits, read 352 bits of data.
	// Input must be at least 45 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 7 to 22
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)(input[2] & 0xfe) << 15);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 23 to 38
	value = ((uint32_t)(input[2] & 0x01) << 31) |
			((uint32_t)input[3] << 23) |
			((uint32_t)(input[4] & 0xfe) << 15);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 39 to 54
	value = ((uint32_t)(input[4] & 0x01) << 31) |
			((uint32_t)input[5] << 23) |
			((uint32_t)(input[6] & 0xfe) << 15);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 55 to 70
	value = ((uint32_t)(input[6] & 0x01) << 31) |
			((uint32_t)input[7] << 23) |
			((uint32_t)(input[8] & 0xfe) << 15);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 71 to 86
	value = ((uint32_t)(input[8] & 0x01) << 31) |
			((uint32_t)input[9] << 23) |
			((uint32_t)(input[10] & 0xfe) << 15);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 87 to 102
	value = ((uint32_t)(input[10] & 0x01) << 31) |
			((uint32_t)input[11] << 23) |
			((uint32_t)(input[12] & 0xfe) << 15);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 103 to 118
	value = ((uint32_t)(input[12] & 0x01) << 31) |
			((uint32_t)input[13] << 23) |
			((uint32_t)(input[14] & 0xfe) << 15);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 119 to 134
	value = ((uint32_t)(input[14] & 0x01) << 31) |
			((uint32_t)input[15] << 23) |
			((uint32_t)(input[16] & 0xfe) << 15);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 135 to 150
	value = ((uint32_t)(input[16] & 0x01) << 31) |
			((uint32_t)input[17] << 23) |
			((uint32_t)(input[18] & 0xfe) << 15);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 151 to 166
	value = ((uint32_t)(input[18] & 0x01) << 31) |
			((uint32_t)input[19] << 23) |
			((uint32_t)(input[20] & 0xfe) << 15);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 167 to 182
	value = ((uint32_t)(input[20] & 0x01) << 31) |
			((uint32_t)input[21] << 23) |
			((uint32_t)(input[22] & 0xfe) << 15);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 183 to 198
	value = ((uint32_t)(input[22] & 0x01) << 31) |
			((uint32_t)input[23] << 23) |
			((uint32_t)(input[24] & 0xfe) << 15);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 199 to 214
	value = ((uint32_t)(input[24] & 0x01) << 31) |
			((uint32_t)input[25] << 23) |
			((uint32_t)(input[26] & 0xfe) << 15);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 215 to 230
	value = ((uint32_t)(input[26] & 0x01) << 31) |
			((uint32_t)input[27] << 23) |
			((uint32_t)(input[28] & 0xfe) << 15);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 231 to 246
	value = ((uint32_t)(input[28] & 0x01) << 31) |
			((uint32_t)input[29] << 23) |
			((uint32_t)(input[30] & 0xfe) << 15);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 247 to 262
	value = ((uint32_t)(input[30] & 0x01) << 31) |
			((uint32_t)input[31] << 23) |
			((uint32_t)(input[32] & 0xfe) << 15);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 263 to 278
	value = ((uint32_t)(input[32] & 0x01) << 31) |
			((uint32_t)input[33] << 23) |
			((uint32_t)(input[34] & 0xfe) << 15);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 279 to 294
	value = ((uint32_t)(input[34] & 0x01) << 31) |
			((uint32_t)input[35] << 23) |
			((uint32_t)(input[36] & 0xfe) << 15);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 295 to 310
	value = ((uint32_t)(input[36] & 0x01) << 31) |
			((uint32_t)input[37] << 23) |
			((uint32_t)(input[38] & 0xfe) << 15);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 311 to 326
	value = ((uint32_t)(input[38] & 0x01) << 31) |
			((uint32_t)input[39] << 23) |
			((uint32_t)(input[40] & 0xfe) << 15);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 327 to 342
	value = ((uint32_t)(input[40] & 0x01) << 31) |
			((uint32_t)input[41] << 23) |
			((uint32_t)(input[42] & 0xfe) << 15);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 343 to 358
	value = ((uint32_t)(input[42] & 0x01) << 31) |
			((uint32_t)input[43] << 23) |
			((uint32_t)(input[44] & 0xfe) << 15);
	output[21] = (double)(value >> 16);
}

static void unpack_22_16bit_unsigned_7off(const uint8_t * input, double * output, void *closure) {
	// Unpack 22 values into output
	// Values are 16-bit unsigned
	// Skip 7 bits, read 352 bits of data.
	// Input must be at least 45 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 7 to 22
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)(input[2] & 0xfe) << 15);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 23 to 38
	value = ((uint32_t)(input[2] & 0x01) << 31) |
			((uint32_t)input[3] << 23) |
			((uint32_t)(input[4] & 0xfe) << 15);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 39 to 54
	value = ((uint32_t)(input[4] & 0x01) << 31) |
			((uint32_t)input[5] << 23) |
			((uint32_t)(input[6] & 0xfe) << 15);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 55 to 70
	value = ((uint32_t)(input[6] & 0x01) << 31) |
			((uint32_t)input[7] << 23) |
			((uint32_t)(input[8] & 0xfe) << 15);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 71 to 86
	value = ((uint32_t)(input[8] & 0x01) << 31) |
			((uint32_t)input[9] << 23) |
			((uint32_t)(input[10] & 0xfe) << 15);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 87 to 102
	value = ((uint32_t)(input[10] & 0x01) << 31) |
			((uint32_t)input[11] << 23) |
			((uint32_t)(input[12] & 0xfe) << 15);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 103 to 118
	value = ((uint32_t)(input[12] & 0x01) << 31) |
			((uint32_t)input[13] << 23) |
			((uint32_t)(input[14] & 0xfe) << 15);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 119 to 134
	value = ((uint32_t)(input[14] & 0x01) << 31) |
			((uint32_t)input[15] << 23) |
			((uint32_t)(input[16] & 0xfe) << 15);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 135 to 150
	value = ((uint32_t)(input[16] & 0x01) << 31) |
			((uint32_t)input[17] << 23) |
			((uint32_t)(input[18] & 0xfe) << 15);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 151 to 166
	value = ((uint32_t)(input[18] & 0x01) << 31) |
			((uint32_t)input[19] << 23) |
			((uint32_t)(input[20] & 0xfe) << 15);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 167 to 182
	value = ((uint32_t)(input[20] & 0x01) << 31) |
			((uint32_t)input[21] << 23) |
			((uint32_t)(input[22] & 0xfe) << 15);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 183 to 198
	value = ((uint32_t)(input[22] & 0x01) << 31) |
			((uint32_t)input[23] << 23) |
			((uint32_t)(input[24] & 0xfe) << 15);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 199 to 214
	value = ((uint32_t)(input[24] & 0x01) << 31) |
			((uint32_t)input[25] << 23) |
			((uint32_t)(input[26] & 0xfe) << 15);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 215 to 230
	value = ((uint32_t)(input[26] & 0x01) << 31) |
			((uint32_t)input[27] << 23) |
			((uint32_t)(input[28] & 0xfe) << 15);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 231 to 246
	value = ((uint32_t)(input[28] & 0x01) << 31) |
			((uint32_t)input[29] << 23) |
			((uint32_t)(input[30] & 0xfe) << 15);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 247 to 262
	value = ((uint32_t)(input[30] & 0x01) << 31) |
			((uint32_t)input[31] << 23) |
			((uint32_t)(input[32] & 0xfe) << 15);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 263 to 278
	value = ((uint32_t)(input[32] & 0x01) << 31) |
			((uint32_t)input[33] << 23) |
			((uint32_t)(input[34] & 0xfe) << 15);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 279 to 294
	value = ((uint32_t)(input[34] & 0x01) << 31) |
			((uint32_t)input[35] << 23) |
			((uint32_t)(input[36] & 0xfe) << 15);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 295 to 310
	value = ((uint32_t)(input[36] & 0x01) << 31) |
			((uint32_t)input[37] << 23) |
			((uint32_t)(input[38] & 0xfe) << 15);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 311 to 326
	value = ((uint32_t)(input[38] & 0x01) << 31) |
			((uint32_t)input[39] << 23) |
			((uint32_t)(input[40] & 0xfe) << 15);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 327 to 342
	value = ((uint32_t)(input[40] & 0x01) << 31) |
			((uint32_t)input[41] << 23) |
			((uint32_t)(input[42] & 0xfe) << 15);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 343 to 358
	value = ((uint32_t)(input[42] & 0x01) << 31) |
			((uint32_t)input[43] << 23) |
			((uint32_t)(input[44] & 0xfe) << 15);
	output[21] = (double)(value >> 16);
}

static void unpack_23_16bit_signed_0off(const uint8_t * input, double * output, void *closure) {
	// Unpack 23 values into output
	// Values are 16-bit signed
	// Skip 0 bits, read 368 bits of data.
	// Input must be at least 46 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 0 to 15
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)input[1] << 16);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 16 to 31
	value = ((uint32_t)input[2] << 24) |
			((uint32_t)input[3] << 16);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 32 to 47
	value = ((uint32_t)input[4] << 24) |
			((uint32_t)input[5] << 16);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 48 to 63
	value = ((uint32_t)input[6] << 24) |
			((uint32_t)input[7] << 16);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 64 to 79
	value = ((uint32_t)input[8] << 24) |
			((uint32_t)input[9] << 16);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 80 to 95
	value = ((uint32_t)input[10] << 24) |
			((uint32_t)input[11] << 16);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 96 to 111
	value = ((uint32_t)input[12] << 24) |
			((uint32_t)input[13] << 16);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 112 to 127
	value = ((uint32_t)input[14] << 24) |
			((uint32_t)input[15] << 16);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 128 to 143
	value = ((uint32_t)input[16] << 24) |
			((uint32_t)input[17] << 16);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 144 to 159
	value = ((uint32_t)input[18] << 24) |
			((uint32_t)input[19] << 16);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 160 to 175
	value = ((uint32_t)input[20] << 24) |
			((uint32_t)input[21] << 16);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 176 to 191
	value = ((uint32_t)input[22] << 24) |
			((uint32_t)input[23] << 16);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 192 to 207
	value = ((uint32_t)input[24] << 24) |
			((uint32_t)input[25] << 16);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 208 to 223
	value = ((uint32_t)input[26] << 24) |
			((uint32_t)input[27] << 16);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 224 to 239
	value = ((uint32_t)input[28] << 24) |
			((uint32_t)input[29] << 16);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 240 to 255
	value = ((uint32_t)input[30] << 24) |
			((uint32_t)input[31] << 16);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 256 to 271
	value = ((uint32_t)input[32] << 24) |
			((uint32_t)input[33] << 16);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 272 to 287
	value = ((uint32_t)input[34] << 24) |
			((uint32_t)input[35] << 16);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 288 to 303
	value = ((uint32_t)input[36] << 24) |
			((uint32_t)input[37] << 16);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 304 to 319
	value = ((uint32_t)input[38] << 24) |
			((uint32_t)input[39] << 16);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 320 to 335
	value = ((uint32_t)input[40] << 24) |
			((uint32_t)input[41] << 16);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 336 to 351
	value = ((uint32_t)input[42] << 24) |
			((uint32_t)input[43] << 16);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 352 to 367
	value = ((uint32_t)input[44] << 24) |
			((uint32_t)input[45] << 16);
	output[22] = (double)(value >> 16);
}

static void unpack_23_16bit_unsigned_0off(const uint8_t * input, double * output, void *closure) {
	// Unpack 23 values into output
	// Values are 16-bit unsigned
	// Skip 0 bits, read 368 bits of data.
	// Input must be at least 46 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 0 to 15
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)input[1] << 16);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 16 to 31
	value = ((uint32_t)input[2] << 24) |
			((uint32_t)input[3] << 16);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 32 to 47
	value = ((uint32_t)input[4] << 24) |
			((uint32_t)input[5] << 16);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 48 to 63
	value = ((uint32_t)input[6] << 24) |
			((uint32_t)input[7] << 16);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 64 to 79
	value = ((uint32_t)input[8] << 24) |
			((uint32_t)input[9] << 16);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 80 to 95
	value = ((uint32_t)input[10] << 24) |
			((uint32_t)input[11] << 16);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 96 to 111
	value = ((uint32_t)input[12] << 24) |
			((uint32_t)input[13] << 16);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 112 to 127
	value = ((uint32_t)input[14] << 24) |
			((uint32_t)input[15] << 16);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 128 to 143
	value = ((uint32_t)input[16] << 24) |
			((uint32_t)input[17] << 16);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 144 to 159
	value = ((uint32_t)input[18] << 24) |
			((uint32_t)input[19] << 16);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 160 to 175
	value = ((uint32_t)input[20] << 24) |
			((uint32_t)input[21] << 16);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 176 to 191
	value = ((uint32_t)input[22] << 24) |
			((uint32_t)input[23] << 16);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 192 to 207
	value = ((uint32_t)input[24] << 24) |
			((uint32_t)input[25] << 16);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 208 to 223
	value = ((uint32_t)input[26] << 24) |
			((uint32_t)input[27] << 16);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 224 to 239
	value = ((uint32_t)input[28] << 24) |
			((uint32_t)input[29] << 16);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 240 to 255
	value = ((uint32_t)input[30] << 24) |
			((uint32_t)input[31] << 16);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 256 to 271
	value = ((uint32_t)input[32] << 24) |
			((uint32_t)input[33] << 16);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 272 to 287
	value = ((uint32_t)input[34] << 24) |
			((uint32_t)input[35] << 16);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 288 to 303
	value = ((uint32_t)input[36] << 24) |
			((uint32_t)input[37] << 16);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 304 to 319
	value = ((uint32_t)input[38] << 24) |
			((uint32_t)input[39] << 16);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 320 to 335
	value = ((uint32_t)input[40] << 24) |
			((uint32_t)input[41] << 16);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 336 to 351
	value = ((uint32_t)input[42] << 24) |
			((uint32_t)input[43] << 16);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 352 to 367
	value = ((uint32_t)input[44] << 24) |
			((uint32_t)input[45] << 16);
	output[22] = (double)(value >> 16);
}

static void unpack_23_16bit_signed_1off(const uint8_t * input, double * output, void *closure) {
	// Unpack 23 values into output
	// Values are 16-bit signed
	// Skip 1 bits, read 368 bits of data.
	// Input must be at least 47 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 1 to 16
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)input[1] << 17) |
			((uint32_t)(input[2] & 0x80) << 9);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 17 to 32
	value = ((uint32_t)(input[2] & 0x7f) << 25) |
			((uint32_t)input[3] << 17) |
			((uint32_t)(input[4] & 0x80) << 9);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 33 to 48
	value = ((uint32_t)(input[4] & 0x7f) << 25) |
			((uint32_t)input[5] << 17) |
			((uint32_t)(input[6] & 0x80) << 9);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 49 to 64
	value = ((uint32_t)(input[6] & 0x7f) << 25) |
			((uint32_t)input[7] << 17) |
			((uint32_t)(input[8] & 0x80) << 9);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 65 to 80
	value = ((uint32_t)(input[8] & 0x7f) << 25) |
			((uint32_t)input[9] << 17) |
			((uint32_t)(input[10] & 0x80) << 9);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 81 to 96
	value = ((uint32_t)(input[10] & 0x7f) << 25) |
			((uint32_t)input[11] << 17) |
			((uint32_t)(input[12] & 0x80) << 9);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 97 to 112
	value = ((uint32_t)(input[12] & 0x7f) << 25) |
			((uint32_t)input[13] << 17) |
			((uint32_t)(input[14] & 0x80) << 9);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 113 to 128
	value = ((uint32_t)(input[14] & 0x7f) << 25) |
			((uint32_t)input[15] << 17) |
			((uint32_t)(input[16] & 0x80) << 9);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 129 to 144
	value = ((uint32_t)(input[16] & 0x7f) << 25) |
			((uint32_t)input[17] << 17) |
			((uint32_t)(input[18] & 0x80) << 9);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 145 to 160
	value = ((uint32_t)(input[18] & 0x7f) << 25) |
			((uint32_t)input[19] << 17) |
			((uint32_t)(input[20] & 0x80) << 9);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 161 to 176
	value = ((uint32_t)(input[20] & 0x7f) << 25) |
			((uint32_t)input[21] << 17) |
			((uint32_t)(input[22] & 0x80) << 9);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 177 to 192
	value = ((uint32_t)(input[22] & 0x7f) << 25) |
			((uint32_t)input[23] << 17) |
			((uint32_t)(input[24] & 0x80) << 9);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 193 to 208
	value = ((uint32_t)(input[24] & 0x7f) << 25) |
			((uint32_t)input[25] << 17) |
			((uint32_t)(input[26] & 0x80) << 9);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 209 to 224
	value = ((uint32_t)(input[26] & 0x7f) << 25) |
			((uint32_t)input[27] << 17) |
			((uint32_t)(input[28] & 0x80) << 9);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 225 to 240
	value = ((uint32_t)(input[28] & 0x7f) << 25) |
			((uint32_t)input[29] << 17) |
			((uint32_t)(input[30] & 0x80) << 9);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 241 to 256
	value = ((uint32_t)(input[30] & 0x7f) << 25) |
			((uint32_t)input[31] << 17) |
			((uint32_t)(input[32] & 0x80) << 9);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 257 to 272
	value = ((uint32_t)(input[32] & 0x7f) << 25) |
			((uint32_t)input[33] << 17) |
			((uint32_t)(input[34] & 0x80) << 9);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 273 to 288
	value = ((uint32_t)(input[34] & 0x7f) << 25) |
			((uint32_t)input[35] << 17) |
			((uint32_t)(input[36] & 0x80) << 9);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 289 to 304
	value = ((uint32_t)(input[36] & 0x7f) << 25) |
			((uint32_t)input[37] << 17) |
			((uint32_t)(input[38] & 0x80) << 9);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 305 to 320
	value = ((uint32_t)(input[38] & 0x7f) << 25) |
			((uint32_t)input[39] << 17) |
			((uint32_t)(input[40] & 0x80) << 9);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 321 to 336
	value = ((uint32_t)(input[40] & 0x7f) << 25) |
			((uint32_t)input[41] << 17) |
			((uint32_t)(input[42] & 0x80) << 9);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 337 to 352
	value = ((uint32_t)(input[42] & 0x7f) << 25) |
			((uint32_t)input[43] << 17) |
			((uint32_t)(input[44] & 0x80) << 9);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 353 to 368
	value = ((uint32_t)(input[44] & 0x7f) << 25) |
			((uint32_t)input[45] << 17) |
			((uint32_t)(input[46] & 0x80) << 9);
	output[22] = (double)(value >> 16);
}

static void unpack_23_16bit_unsigned_1off(const uint8_t * input, double * output, void *closure) {
	// Unpack 23 values into output
	// Values are 16-bit unsigned
	// Skip 1 bits, read 368 bits of data.
	// Input must be at least 47 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 1 to 16
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)input[1] << 17) |
			((uint32_t)(input[2] & 0x80) << 9);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 17 to 32
	value = ((uint32_t)(input[2] & 0x7f) << 25) |
			((uint32_t)input[3] << 17) |
			((uint32_t)(input[4] & 0x80) << 9);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 33 to 48
	value = ((uint32_t)(input[4] & 0x7f) << 25) |
			((uint32_t)input[5] << 17) |
			((uint32_t)(input[6] & 0x80) << 9);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 49 to 64
	value = ((uint32_t)(input[6] & 0x7f) << 25) |
			((uint32_t)input[7] << 17) |
			((uint32_t)(input[8] & 0x80) << 9);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 65 to 80
	value = ((uint32_t)(input[8] & 0x7f) << 25) |
			((uint32_t)input[9] << 17) |
			((uint32_t)(input[10] & 0x80) << 9);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 81 to 96
	value = ((uint32_t)(input[10] & 0x7f) << 25) |
			((uint32_t)input[11] << 17) |
			((uint32_t)(input[12] & 0x80) << 9);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 97 to 112
	value = ((uint32_t)(input[12] & 0x7f) << 25) |
			((uint32_t)input[13] << 17) |
			((uint32_t)(input[14] & 0x80) << 9);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 113 to 128
	value = ((uint32_t)(input[14] & 0x7f) << 25) |
			((uint32_t)input[15] << 17) |
			((uint32_t)(input[16] & 0x80) << 9);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 129 to 144
	value = ((uint32_t)(input[16] & 0x7f) << 25) |
			((uint32_t)input[17] << 17) |
			((uint32_t)(input[18] & 0x80) << 9);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 145 to 160
	value = ((uint32_t)(input[18] & 0x7f) << 25) |
			((uint32_t)input[19] << 17) |
			((uint32_t)(input[20] & 0x80) << 9);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 161 to 176
	value = ((uint32_t)(input[20] & 0x7f) << 25) |
			((uint32_t)input[21] << 17) |
			((uint32_t)(input[22] & 0x80) << 9);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 177 to 192
	value = ((uint32_t)(input[22] & 0x7f) << 25) |
			((uint32_t)input[23] << 17) |
			((uint32_t)(input[24] & 0x80) << 9);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 193 to 208
	value = ((uint32_t)(input[24] & 0x7f) << 25) |
			((uint32_t)input[25] << 17) |
			((uint32_t)(input[26] & 0x80) << 9);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 209 to 224
	value = ((uint32_t)(input[26] & 0x7f) << 25) |
			((uint32_t)input[27] << 17) |
			((uint32_t)(input[28] & 0x80) << 9);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 225 to 240
	value = ((uint32_t)(input[28] & 0x7f) << 25) |
			((uint32_t)input[29] << 17) |
			((uint32_t)(input[30] & 0x80) << 9);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 241 to 256
	value = ((uint32_t)(input[30] & 0x7f) << 25) |
			((uint32_t)input[31] << 17) |
			((uint32_t)(input[32] & 0x80) << 9);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 257 to 272
	value = ((uint32_t)(input[32] & 0x7f) << 25) |
			((uint32_t)input[33] << 17) |
			((uint32_t)(input[34] & 0x80) << 9);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 273 to 288
	value = ((uint32_t)(input[34] & 0x7f) << 25) |
			((uint32_t)input[35] << 17) |
			((uint32_t)(input[36] & 0x80) << 9);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 289 to 304
	value = ((uint32_t)(input[36] & 0x7f) << 25) |
			((uint32_t)input[37] << 17) |
			((uint32_t)(input[38] & 0x80) << 9);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 305 to 320
	value = ((uint32_t)(input[38] & 0x7f) << 25) |
			((uint32_t)input[39] << 17) |
			((uint32_t)(input[40] & 0x80) << 9);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 321 to 336
	value = ((uint32_t)(input[40] & 0x7f) << 25) |
			((uint32_t)input[41] << 17) |
			((uint32_t)(input[42] & 0x80) << 9);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 337 to 352
	value = ((uint32_t)(input[42] & 0x7f) << 25) |
			((uint32_t)input[43] << 17) |
			((uint32_t)(input[44] & 0x80) << 9);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 353 to 368
	value = ((uint32_t)(input[44] & 0x7f) << 25) |
			((uint32_t)input[45] << 17) |
			((uint32_t)(input[46] & 0x80) << 9);
	output[22] = (double)(value >> 16);
}

static void unpack_23_16bit_signed_2off(const uint8_t * input, double * output, void *closure) {
	// Unpack 23 values into output
	// Values are 16-bit signed
	// Skip 2 bits, read 368 bits of data.
	// Input must be at least 47 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 2 to 17
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)input[1] << 18) |
			((uint32_t)(input[2] & 0xc0) << 10);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 18 to 33
	value = ((uint32_t)(input[2] & 0x3f) << 26) |
			((uint32_t)input[3] << 18) |
			((uint32_t)(input[4] & 0xc0) << 10);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 34 to 49
	value = ((uint32_t)(input[4] & 0x3f) << 26) |
			((uint32_t)input[5] << 18) |
			((uint32_t)(input[6] & 0xc0) << 10);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 50 to 65
	value = ((uint32_t)(input[6] & 0x3f) << 26) |
			((uint32_t)input[7] << 18) |
			((uint32_t)(input[8] & 0xc0) << 10);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 66 to 81
	value = ((uint32_t)(input[8] & 0x3f) << 26) |
			((uint32_t)input[9] << 18) |
			((uint32_t)(input[10] & 0xc0) << 10);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 82 to 97
	value = ((uint32_t)(input[10] & 0x3f) << 26) |
			((uint32_t)input[11] << 18) |
			((uint32_t)(input[12] & 0xc0) << 10);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 98 to 113
	value = ((uint32_t)(input[12] & 0x3f) << 26) |
			((uint32_t)input[13] << 18) |
			((uint32_t)(input[14] & 0xc0) << 10);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 114 to 129
	value = ((uint32_t)(input[14] & 0x3f) << 26) |
			((uint32_t)input[15] << 18) |
			((uint32_t)(input[16] & 0xc0) << 10);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 130 to 145
	value = ((uint32_t)(input[16] & 0x3f) << 26) |
			((uint32_t)input[17] << 18) |
			((uint32_t)(input[18] & 0xc0) << 10);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 146 to 161
	value = ((uint32_t)(input[18] & 0x3f) << 26) |
			((uint32_t)input[19] << 18) |
			((uint32_t)(input[20] & 0xc0) << 10);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 162 to 177
	value = ((uint32_t)(input[20] & 0x3f) << 26) |
			((uint32_t)input[21] << 18) |
			((uint32_t)(input[22] & 0xc0) << 10);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 178 to 193
	value = ((uint32_t)(input[22] & 0x3f) << 26) |
			((uint32_t)input[23] << 18) |
			((uint32_t)(input[24] & 0xc0) << 10);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 194 to 209
	value = ((uint32_t)(input[24] & 0x3f) << 26) |
			((uint32_t)input[25] << 18) |
			((uint32_t)(input[26] & 0xc0) << 10);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 210 to 225
	value = ((uint32_t)(input[26] & 0x3f) << 26) |
			((uint32_t)input[27] << 18) |
			((uint32_t)(input[28] & 0xc0) << 10);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 226 to 241
	value = ((uint32_t)(input[28] & 0x3f) << 26) |
			((uint32_t)input[29] << 18) |
			((uint32_t)(input[30] & 0xc0) << 10);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 242 to 257
	value = ((uint32_t)(input[30] & 0x3f) << 26) |
			((uint32_t)input[31] << 18) |
			((uint32_t)(input[32] & 0xc0) << 10);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 258 to 273
	value = ((uint32_t)(input[32] & 0x3f) << 26) |
			((uint32_t)input[33] << 18) |
			((uint32_t)(input[34] & 0xc0) << 10);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 274 to 289
	value = ((uint32_t)(input[34] & 0x3f) << 26) |
			((uint32_t)input[35] << 18) |
			((uint32_t)(input[36] & 0xc0) << 10);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 290 to 305
	value = ((uint32_t)(input[36] & 0x3f) << 26) |
			((uint32_t)input[37] << 18) |
			((uint32_t)(input[38] & 0xc0) << 10);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 306 to 321
	value = ((uint32_t)(input[38] & 0x3f) << 26) |
			((uint32_t)input[39] << 18) |
			((uint32_t)(input[40] & 0xc0) << 10);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 322 to 337
	value = ((uint32_t)(input[40] & 0x3f) << 26) |
			((uint32_t)input[41] << 18) |
			((uint32_t)(input[42] & 0xc0) << 10);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 338 to 353
	value = ((uint32_t)(input[42] & 0x3f) << 26) |
			((uint32_t)input[43] << 18) |
			((uint32_t)(input[44] & 0xc0) << 10);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 354 to 369
	value = ((uint32_t)(input[44] & 0x3f) << 26) |
			((uint32_t)input[45] << 18) |
			((uint32_t)(input[46] & 0xc0) << 10);
	output[22] = (double)(value >> 16);
}

static void unpack_23_16bit_unsigned_2off(const uint8_t * input, double * output, void *closure) {
	// Unpack 23 values into output
	// Values are 16-bit unsigned
	// Skip 2 bits, read 368 bits of data.
	// Input must be at least 47 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 2 to 17
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)input[1] << 18) |
			((uint32_t)(input[2] & 0xc0) << 10);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 18 to 33
	value = ((uint32_t)(input[2] & 0x3f) << 26) |
			((uint32_t)input[3] << 18) |
			((uint32_t)(input[4] & 0xc0) << 10);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 34 to 49
	value = ((uint32_t)(input[4] & 0x3f) << 26) |
			((uint32_t)input[5] << 18) |
			((uint32_t)(input[6] & 0xc0) << 10);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 50 to 65
	value = ((uint32_t)(input[6] & 0x3f) << 26) |
			((uint32_t)input[7] << 18) |
			((uint32_t)(input[8] & 0xc0) << 10);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 66 to 81
	value = ((uint32_t)(input[8] & 0x3f) << 26) |
			((uint32_t)input[9] << 18) |
			((uint32_t)(input[10] & 0xc0) << 10);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 82 to 97
	value = ((uint32_t)(input[10] & 0x3f) << 26) |
			((uint32_t)input[11] << 18) |
			((uint32_t)(input[12] & 0xc0) << 10);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 98 to 113
	value = ((uint32_t)(input[12] & 0x3f) << 26) |
			((uint32_t)input[13] << 18) |
			((uint32_t)(input[14] & 0xc0) << 10);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 114 to 129
	value = ((uint32_t)(input[14] & 0x3f) << 26) |
			((uint32_t)input[15] << 18) |
			((uint32_t)(input[16] & 0xc0) << 10);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 130 to 145
	value = ((uint32_t)(input[16] & 0x3f) << 26) |
			((uint32_t)input[17] << 18) |
			((uint32_t)(input[18] & 0xc0) << 10);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 146 to 161
	value = ((uint32_t)(input[18] & 0x3f) << 26) |
			((uint32_t)input[19] << 18) |
			((uint32_t)(input[20] & 0xc0) << 10);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 162 to 177
	value = ((uint32_t)(input[20] & 0x3f) << 26) |
			((uint32_t)input[21] << 18) |
			((uint32_t)(input[22] & 0xc0) << 10);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 178 to 193
	value = ((uint32_t)(input[22] & 0x3f) << 26) |
			((uint32_t)input[23] << 18) |
			((uint32_t)(input[24] & 0xc0) << 10);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 194 to 209
	value = ((uint32_t)(input[24] & 0x3f) << 26) |
			((uint32_t)input[25] << 18) |
			((uint32_t)(input[26] & 0xc0) << 10);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 210 to 225
	value = ((uint32_t)(input[26] & 0x3f) << 26) |
			((uint32_t)input[27] << 18) |
			((uint32_t)(input[28] & 0xc0) << 10);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 226 to 241
	value = ((uint32_t)(input[28] & 0x3f) << 26) |
			((uint32_t)input[29] << 18) |
			((uint32_t)(input[30] & 0xc0) << 10);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 242 to 257
	value = ((uint32_t)(input[30] & 0x3f) << 26) |
			((uint32_t)input[31] << 18) |
			((uint32_t)(input[32] & 0xc0) << 10);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 258 to 273
	value = ((uint32_t)(input[32] & 0x3f) << 26) |
			((uint32_t)input[33] << 18) |
			((uint32_t)(input[34] & 0xc0) << 10);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 274 to 289
	value = ((uint32_t)(input[34] & 0x3f) << 26) |
			((uint32_t)input[35] << 18) |
			((uint32_t)(input[36] & 0xc0) << 10);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 290 to 305
	value = ((uint32_t)(input[36] & 0x3f) << 26) |
			((uint32_t)input[37] << 18) |
			((uint32_t)(input[38] & 0xc0) << 10);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 306 to 321
	value = ((uint32_t)(input[38] & 0x3f) << 26) |
			((uint32_t)input[39] << 18) |
			((uint32_t)(input[40] & 0xc0) << 10);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 322 to 337
	value = ((uint32_t)(input[40] & 0x3f) << 26) |
			((uint32_t)input[41] << 18) |
			((uint32_t)(input[42] & 0xc0) << 10);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 338 to 353
	value = ((uint32_t)(input[42] & 0x3f) << 26) |
			((uint32_t)input[43] << 18) |
			((uint32_t)(input[44] & 0xc0) << 10);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 354 to 369
	value = ((uint32_t)(input[44] & 0x3f) << 26) |
			((uint32_t)input[45] << 18) |
			((uint32_t)(input[46] & 0xc0) << 10);
	output[22] = (double)(value >> 16);
}

static void unpack_23_16bit_signed_3off(const uint8_t * input, double * output, void *closure) {
	// Unpack 23 values into output
	// Values are 16-bit signed
	// Skip 3 bits, read 368 bits of data.
	// Input must be at least 47 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 3 to 18
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)input[1] << 19) |
			((uint32_t)(input[2] & 0xe0) << 11);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 19 to 34
	value = ((uint32_t)(input[2] & 0x1f) << 27) |
			((uint32_t)input[3] << 19) |
			((uint32_t)(input[4] & 0xe0) << 11);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 35 to 50
	value = ((uint32_t)(input[4] & 0x1f) << 27) |
			((uint32_t)input[5] << 19) |
			((uint32_t)(input[6] & 0xe0) << 11);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 51 to 66
	value = ((uint32_t)(input[6] & 0x1f) << 27) |
			((uint32_t)input[7] << 19) |
			((uint32_t)(input[8] & 0xe0) << 11);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 67 to 82
	value = ((uint32_t)(input[8] & 0x1f) << 27) |
			((uint32_t)input[9] << 19) |
			((uint32_t)(input[10] & 0xe0) << 11);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 83 to 98
	value = ((uint32_t)(input[10] & 0x1f) << 27) |
			((uint32_t)input[11] << 19) |
			((uint32_t)(input[12] & 0xe0) << 11);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 99 to 114
	value = ((uint32_t)(input[12] & 0x1f) << 27) |
			((uint32_t)input[13] << 19) |
			((uint32_t)(input[14] & 0xe0) << 11);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 115 to 130
	value = ((uint32_t)(input[14] & 0x1f) << 27) |
			((uint32_t)input[15] << 19) |
			((uint32_t)(input[16] & 0xe0) << 11);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 131 to 146
	value = ((uint32_t)(input[16] & 0x1f) << 27) |
			((uint32_t)input[17] << 19) |
			((uint32_t)(input[18] & 0xe0) << 11);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 147 to 162
	value = ((uint32_t)(input[18] & 0x1f) << 27) |
			((uint32_t)input[19] << 19) |
			((uint32_t)(input[20] & 0xe0) << 11);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 163 to 178
	value = ((uint32_t)(input[20] & 0x1f) << 27) |
			((uint32_t)input[21] << 19) |
			((uint32_t)(input[22] & 0xe0) << 11);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 179 to 194
	value = ((uint32_t)(input[22] & 0x1f) << 27) |
			((uint32_t)input[23] << 19) |
			((uint32_t)(input[24] & 0xe0) << 11);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 195 to 210
	value = ((uint32_t)(input[24] & 0x1f) << 27) |
			((uint32_t)input[25] << 19) |
			((uint32_t)(input[26] & 0xe0) << 11);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 211 to 226
	value = ((uint32_t)(input[26] & 0x1f) << 27) |
			((uint32_t)input[27] << 19) |
			((uint32_t)(input[28] & 0xe0) << 11);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 227 to 242
	value = ((uint32_t)(input[28] & 0x1f) << 27) |
			((uint32_t)input[29] << 19) |
			((uint32_t)(input[30] & 0xe0) << 11);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 243 to 258
	value = ((uint32_t)(input[30] & 0x1f) << 27) |
			((uint32_t)input[31] << 19) |
			((uint32_t)(input[32] & 0xe0) << 11);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 259 to 274
	value = ((uint32_t)(input[32] & 0x1f) << 27) |
			((uint32_t)input[33] << 19) |
			((uint32_t)(input[34] & 0xe0) << 11);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 275 to 290
	value = ((uint32_t)(input[34] & 0x1f) << 27) |
			((uint32_t)input[35] << 19) |
			((uint32_t)(input[36] & 0xe0) << 11);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 291 to 306
	value = ((uint32_t)(input[36] & 0x1f) << 27) |
			((uint32_t)input[37] << 19) |
			((uint32_t)(input[38] & 0xe0) << 11);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 307 to 322
	value = ((uint32_t)(input[38] & 0x1f) << 27) |
			((uint32_t)input[39] << 19) |
			((uint32_t)(input[40] & 0xe0) << 11);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 323 to 338
	value = ((uint32_t)(input[40] & 0x1f) << 27) |
			((uint32_t)input[41] << 19) |
			((uint32_t)(input[42] & 0xe0) << 11);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 339 to 354
	value = ((uint32_t)(input[42] & 0x1f) << 27) |
			((uint32_t)input[43] << 19) |
			((uint32_t)(input[44] & 0xe0) << 11);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 355 to 370
	value = ((uint32_t)(input[44] & 0x1f) << 27) |
			((uint32_t)input[45] << 19) |
			((uint32_t)(input[46] & 0xe0) << 11);
	output[22] = (double)(value >> 16);
}

static void unpack_23_16bit_unsigned_3off(const uint8_t * input, double * output, void *closure) {
	// Unpack 23 values into output
	// Values are 16-bit unsigned
	// Skip 3 bits, read 368 bits of data.
	// Input must be at least 47 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 3 to 18
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)input[1] << 19) |
			((uint32_t)(input[2] & 0xe0) << 11);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 19 to 34
	value = ((uint32_t)(input[2] & 0x1f) << 27) |
			((uint32_t)input[3] << 19) |
			((uint32_t)(input[4] & 0xe0) << 11);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 35 to 50
	value = ((uint32_t)(input[4] & 0x1f) << 27) |
			((uint32_t)input[5] << 19) |
			((uint32_t)(input[6] & 0xe0) << 11);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 51 to 66
	value = ((uint32_t)(input[6] & 0x1f) << 27) |
			((uint32_t)input[7] << 19) |
			((uint32_t)(input[8] & 0xe0) << 11);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 67 to 82
	value = ((uint32_t)(input[8] & 0x1f) << 27) |
			((uint32_t)input[9] << 19) |
			((uint32_t)(input[10] & 0xe0) << 11);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 83 to 98
	value = ((uint32_t)(input[10] & 0x1f) << 27) |
			((uint32_t)input[11] << 19) |
			((uint32_t)(input[12] & 0xe0) << 11);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 99 to 114
	value = ((uint32_t)(input[12] & 0x1f) << 27) |
			((uint32_t)input[13] << 19) |
			((uint32_t)(input[14] & 0xe0) << 11);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 115 to 130
	value = ((uint32_t)(input[14] & 0x1f) << 27) |
			((uint32_t)input[15] << 19) |
			((uint32_t)(input[16] & 0xe0) << 11);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 131 to 146
	value = ((uint32_t)(input[16] & 0x1f) << 27) |
			((uint32_t)input[17] << 19) |
			((uint32_t)(input[18] & 0xe0) << 11);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 147 to 162
	value = ((uint32_t)(input[18] & 0x1f) << 27) |
			((uint32_t)input[19] << 19) |
			((uint32_t)(input[20] & 0xe0) << 11);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 163 to 178
	value = ((uint32_t)(input[20] & 0x1f) << 27) |
			((uint32_t)input[21] << 19) |
			((uint32_t)(input[22] & 0xe0) << 11);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 179 to 194
	value = ((uint32_t)(input[22] & 0x1f) << 27) |
			((uint32_t)input[23] << 19) |
			((uint32_t)(input[24] & 0xe0) << 11);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 195 to 210
	value = ((uint32_t)(input[24] & 0x1f) << 27) |
			((uint32_t)input[25] << 19) |
			((uint32_t)(input[26] & 0xe0) << 11);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 211 to 226
	value = ((uint32_t)(input[26] & 0x1f) << 27) |
			((uint32_t)input[27] << 19) |
			((uint32_t)(input[28] & 0xe0) << 11);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 227 to 242
	value = ((uint32_t)(input[28] & 0x1f) << 27) |
			((uint32_t)input[29] << 19) |
			((uint32_t)(input[30] & 0xe0) << 11);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 243 to 258
	value = ((uint32_t)(input[30] & 0x1f) << 27) |
			((uint32_t)input[31] << 19) |
			((uint32_t)(input[32] & 0xe0) << 11);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 259 to 274
	value = ((uint32_t)(input[32] & 0x1f) << 27) |
			((uint32_t)input[33] << 19) |
			((uint32_t)(input[34] & 0xe0) << 11);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 275 to 290
	value = ((uint32_t)(input[34] & 0x1f) << 27) |
			((uint32_t)input[35] << 19) |
			((uint32_t)(input[36] & 0xe0) << 11);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 291 to 306
	value = ((uint32_t)(input[36] & 0x1f) << 27) |
			((uint32_t)input[37] << 19) |
			((uint32_t)(input[38] & 0xe0) << 11);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 307 to 322
	value = ((uint32_t)(input[38] & 0x1f) << 27) |
			((uint32_t)input[39] << 19) |
			((uint32_t)(input[40] & 0xe0) << 11);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 323 to 338
	value = ((uint32_t)(input[40] & 0x1f) << 27) |
			((uint32_t)input[41] << 19) |
			((uint32_t)(input[42] & 0xe0) << 11);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 339 to 354
	value = ((uint32_t)(input[42] & 0x1f) << 27) |
			((uint32_t)input[43] << 19) |
			((uint32_t)(input[44] & 0xe0) << 11);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 355 to 370
	value = ((uint32_t)(input[44] & 0x1f) << 27) |
			((uint32_t)input[45] << 19) |
			((uint32_t)(input[46] & 0xe0) << 11);
	output[22] = (double)(value >> 16);
}

static void unpack_23_16bit_signed_4off(const uint8_t * input, double * output, void *closure) {
	// Unpack 23 values into output
	// Values are 16-bit signed
	// Skip 4 bits, read 368 bits of data.
	// Input must be at least 47 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 4 to 19
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20) |
			((uint32_t)(input[2] & 0xf0) << 12);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 20 to 35
	value = ((uint32_t)(input[2] & 0x0f) << 28) |
			((uint32_t)input[3] << 20) |
			((uint32_t)(input[4] & 0xf0) << 12);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 36 to 51
	value = ((uint32_t)(input[4] & 0x0f) << 28) |
			((uint32_t)input[5] << 20) |
			((uint32_t)(input[6] & 0xf0) << 12);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 52 to 67
	value = ((uint32_t)(input[6] & 0x0f) << 28) |
			((uint32_t)input[7] << 20) |
			((uint32_t)(input[8] & 0xf0) << 12);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 68 to 83
	value = ((uint32_t)(input[8] & 0x0f) << 28) |
			((uint32_t)input[9] << 20) |
			((uint32_t)(input[10] & 0xf0) << 12);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 84 to 99
	value = ((uint32_t)(input[10] & 0x0f) << 28) |
			((uint32_t)input[11] << 20) |
			((uint32_t)(input[12] & 0xf0) << 12);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 100 to 115
	value = ((uint32_t)(input[12] & 0x0f) << 28) |
			((uint32_t)input[13] << 20) |
			((uint32_t)(input[14] & 0xf0) << 12);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 116 to 131
	value = ((uint32_t)(input[14] & 0x0f) << 28) |
			((uint32_t)input[15] << 20) |
			((uint32_t)(input[16] & 0xf0) << 12);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 132 to 147
	value = ((uint32_t)(input[16] & 0x0f) << 28) |
			((uint32_t)input[17] << 20) |
			((uint32_t)(input[18] & 0xf0) << 12);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 148 to 163
	value = ((uint32_t)(input[18] & 0x0f) << 28) |
			((uint32_t)input[19] << 20) |
			((uint32_t)(input[20] & 0xf0) << 12);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 164 to 179
	value = ((uint32_t)(input[20] & 0x0f) << 28) |
			((uint32_t)input[21] << 20) |
			((uint32_t)(input[22] & 0xf0) << 12);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 180 to 195
	value = ((uint32_t)(input[22] & 0x0f) << 28) |
			((uint32_t)input[23] << 20) |
			((uint32_t)(input[24] & 0xf0) << 12);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 196 to 211
	value = ((uint32_t)(input[24] & 0x0f) << 28) |
			((uint32_t)input[25] << 20) |
			((uint32_t)(input[26] & 0xf0) << 12);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 212 to 227
	value = ((uint32_t)(input[26] & 0x0f) << 28) |
			((uint32_t)input[27] << 20) |
			((uint32_t)(input[28] & 0xf0) << 12);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 228 to 243
	value = ((uint32_t)(input[28] & 0x0f) << 28) |
			((uint32_t)input[29] << 20) |
			((uint32_t)(input[30] & 0xf0) << 12);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 244 to 259
	value = ((uint32_t)(input[30] & 0x0f) << 28) |
			((uint32_t)input[31] << 20) |
			((uint32_t)(input[32] & 0xf0) << 12);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 260 to 275
	value = ((uint32_t)(input[32] & 0x0f) << 28) |
			((uint32_t)input[33] << 20) |
			((uint32_t)(input[34] & 0xf0) << 12);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 276 to 291
	value = ((uint32_t)(input[34] & 0x0f) << 28) |
			((uint32_t)input[35] << 20) |
			((uint32_t)(input[36] & 0xf0) << 12);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 292 to 307
	value = ((uint32_t)(input[36] & 0x0f) << 28) |
			((uint32_t)input[37] << 20) |
			((uint32_t)(input[38] & 0xf0) << 12);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 308 to 323
	value = ((uint32_t)(input[38] & 0x0f) << 28) |
			((uint32_t)input[39] << 20) |
			((uint32_t)(input[40] & 0xf0) << 12);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 324 to 339
	value = ((uint32_t)(input[40] & 0x0f) << 28) |
			((uint32_t)input[41] << 20) |
			((uint32_t)(input[42] & 0xf0) << 12);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 340 to 355
	value = ((uint32_t)(input[42] & 0x0f) << 28) |
			((uint32_t)input[43] << 20) |
			((uint32_t)(input[44] & 0xf0) << 12);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 356 to 371
	value = ((uint32_t)(input[44] & 0x0f) << 28) |
			((uint32_t)input[45] << 20) |
			((uint32_t)(input[46] & 0xf0) << 12);
	output[22] = (double)(value >> 16);
}

static void unpack_23_16bit_unsigned_4off(const uint8_t * input, double * output, void *closure) {
	// Unpack 23 values into output
	// Values are 16-bit unsigned
	// Skip 4 bits, read 368 bits of data.
	// Input must be at least 47 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 4 to 19
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20) |
			((uint32_t)(input[2] & 0xf0) << 12);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 20 to 35
	value = ((uint32_t)(input[2] & 0x0f) << 28) |
			((uint32_t)input[3] << 20) |
			((uint32_t)(input[4] & 0xf0) << 12);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 36 to 51
	value = ((uint32_t)(input[4] & 0x0f) << 28) |
			((uint32_t)input[5] << 20) |
			((uint32_t)(input[6] & 0xf0) << 12);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 52 to 67
	value = ((uint32_t)(input[6] & 0x0f) << 28) |
			((uint32_t)input[7] << 20) |
			((uint32_t)(input[8] & 0xf0) << 12);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 68 to 83
	value = ((uint32_t)(input[8] & 0x0f) << 28) |
			((uint32_t)input[9] << 20) |
			((uint32_t)(input[10] & 0xf0) << 12);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 84 to 99
	value = ((uint32_t)(input[10] & 0x0f) << 28) |
			((uint32_t)input[11] << 20) |
			((uint32_t)(input[12] & 0xf0) << 12);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 100 to 115
	value = ((uint32_t)(input[12] & 0x0f) << 28) |
			((uint32_t)input[13] << 20) |
			((uint32_t)(input[14] & 0xf0) << 12);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 116 to 131
	value = ((uint32_t)(input[14] & 0x0f) << 28) |
			((uint32_t)input[15] << 20) |
			((uint32_t)(input[16] & 0xf0) << 12);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 132 to 147
	value = ((uint32_t)(input[16] & 0x0f) << 28) |
			((uint32_t)input[17] << 20) |
			((uint32_t)(input[18] & 0xf0) << 12);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 148 to 163
	value = ((uint32_t)(input[18] & 0x0f) << 28) |
			((uint32_t)input[19] << 20) |
			((uint32_t)(input[20] & 0xf0) << 12);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 164 to 179
	value = ((uint32_t)(input[20] & 0x0f) << 28) |
			((uint32_t)input[21] << 20) |
			((uint32_t)(input[22] & 0xf0) << 12);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 180 to 195
	value = ((uint32_t)(input[22] & 0x0f) << 28) |
			((uint32_t)input[23] << 20) |
			((uint32_t)(input[24] & 0xf0) << 12);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 196 to 211
	value = ((uint32_t)(input[24] & 0x0f) << 28) |
			((uint32_t)input[25] << 20) |
			((uint32_t)(input[26] & 0xf0) << 12);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 212 to 227
	value = ((uint32_t)(input[26] & 0x0f) << 28) |
			((uint32_t)input[27] << 20) |
			((uint32_t)(input[28] & 0xf0) << 12);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 228 to 243
	value = ((uint32_t)(input[28] & 0x0f) << 28) |
			((uint32_t)input[29] << 20) |
			((uint32_t)(input[30] & 0xf0) << 12);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 244 to 259
	value = ((uint32_t)(input[30] & 0x0f) << 28) |
			((uint32_t)input[31] << 20) |
			((uint32_t)(input[32] & 0xf0) << 12);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 260 to 275
	value = ((uint32_t)(input[32] & 0x0f) << 28) |
			((uint32_t)input[33] << 20) |
			((uint32_t)(input[34] & 0xf0) << 12);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 276 to 291
	value = ((uint32_t)(input[34] & 0x0f) << 28) |
			((uint32_t)input[35] << 20) |
			((uint32_t)(input[36] & 0xf0) << 12);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 292 to 307
	value = ((uint32_t)(input[36] & 0x0f) << 28) |
			((uint32_t)input[37] << 20) |
			((uint32_t)(input[38] & 0xf0) << 12);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 308 to 323
	value = ((uint32_t)(input[38] & 0x0f) << 28) |
			((uint32_t)input[39] << 20) |
			((uint32_t)(input[40] & 0xf0) << 12);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 324 to 339
	value = ((uint32_t)(input[40] & 0x0f) << 28) |
			((uint32_t)input[41] << 20) |
			((uint32_t)(input[42] & 0xf0) << 12);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 340 to 355
	value = ((uint32_t)(input[42] & 0x0f) << 28) |
			((uint32_t)input[43] << 20) |
			((uint32_t)(input[44] & 0xf0) << 12);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 356 to 371
	value = ((uint32_t)(input[44] & 0x0f) << 28) |
			((uint32_t)input[45] << 20) |
			((uint32_t)(input[46] & 0xf0) << 12);
	output[22] = (double)(value >> 16);
}

static void unpack_23_16bit_signed_5off(const uint8_t * input, double * output, void *closure) {
	// Unpack 23 values into output
	// Values are 16-bit signed
	// Skip 5 bits, read 368 bits of data.
	// Input must be at least 47 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 5 to 20
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)(input[2] & 0xf8) << 13);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 21 to 36
	value = ((uint32_t)(input[2] & 0x07) << 29) |
			((uint32_t)input[3] << 21) |
			((uint32_t)(input[4] & 0xf8) << 13);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 37 to 52
	value = ((uint32_t)(input[4] & 0x07) << 29) |
			((uint32_t)input[5] << 21) |
			((uint32_t)(input[6] & 0xf8) << 13);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 53 to 68
	value = ((uint32_t)(input[6] & 0x07) << 29) |
			((uint32_t)input[7] << 21) |
			((uint32_t)(input[8] & 0xf8) << 13);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 69 to 84
	value = ((uint32_t)(input[8] & 0x07) << 29) |
			((uint32_t)input[9] << 21) |
			((uint32_t)(input[10] & 0xf8) << 13);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 85 to 100
	value = ((uint32_t)(input[10] & 0x07) << 29) |
			((uint32_t)input[11] << 21) |
			((uint32_t)(input[12] & 0xf8) << 13);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 101 to 116
	value = ((uint32_t)(input[12] & 0x07) << 29) |
			((uint32_t)input[13] << 21) |
			((uint32_t)(input[14] & 0xf8) << 13);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 117 to 132
	value = ((uint32_t)(input[14] & 0x07) << 29) |
			((uint32_t)input[15] << 21) |
			((uint32_t)(input[16] & 0xf8) << 13);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 133 to 148
	value = ((uint32_t)(input[16] & 0x07) << 29) |
			((uint32_t)input[17] << 21) |
			((uint32_t)(input[18] & 0xf8) << 13);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 149 to 164
	value = ((uint32_t)(input[18] & 0x07) << 29) |
			((uint32_t)input[19] << 21) |
			((uint32_t)(input[20] & 0xf8) << 13);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 165 to 180
	value = ((uint32_t)(input[20] & 0x07) << 29) |
			((uint32_t)input[21] << 21) |
			((uint32_t)(input[22] & 0xf8) << 13);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 181 to 196
	value = ((uint32_t)(input[22] & 0x07) << 29) |
			((uint32_t)input[23] << 21) |
			((uint32_t)(input[24] & 0xf8) << 13);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 197 to 212
	value = ((uint32_t)(input[24] & 0x07) << 29) |
			((uint32_t)input[25] << 21) |
			((uint32_t)(input[26] & 0xf8) << 13);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 213 to 228
	value = ((uint32_t)(input[26] & 0x07) << 29) |
			((uint32_t)input[27] << 21) |
			((uint32_t)(input[28] & 0xf8) << 13);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 229 to 244
	value = ((uint32_t)(input[28] & 0x07) << 29) |
			((uint32_t)input[29] << 21) |
			((uint32_t)(input[30] & 0xf8) << 13);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 245 to 260
	value = ((uint32_t)(input[30] & 0x07) << 29) |
			((uint32_t)input[31] << 21) |
			((uint32_t)(input[32] & 0xf8) << 13);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 261 to 276
	value = ((uint32_t)(input[32] & 0x07) << 29) |
			((uint32_t)input[33] << 21) |
			((uint32_t)(input[34] & 0xf8) << 13);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 277 to 292
	value = ((uint32_t)(input[34] & 0x07) << 29) |
			((uint32_t)input[35] << 21) |
			((uint32_t)(input[36] & 0xf8) << 13);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 293 to 308
	value = ((uint32_t)(input[36] & 0x07) << 29) |
			((uint32_t)input[37] << 21) |
			((uint32_t)(input[38] & 0xf8) << 13);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 309 to 324
	value = ((uint32_t)(input[38] & 0x07) << 29) |
			((uint32_t)input[39] << 21) |
			((uint32_t)(input[40] & 0xf8) << 13);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 325 to 340
	value = ((uint32_t)(input[40] & 0x07) << 29) |
			((uint32_t)input[41] << 21) |
			((uint32_t)(input[42] & 0xf8) << 13);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 341 to 356
	value = ((uint32_t)(input[42] & 0x07) << 29) |
			((uint32_t)input[43] << 21) |
			((uint32_t)(input[44] & 0xf8) << 13);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 357 to 372
	value = ((uint32_t)(input[44] & 0x07) << 29) |
			((uint32_t)input[45] << 21) |
			((uint32_t)(input[46] & 0xf8) << 13);
	output[22] = (double)(value >> 16);
}

static void unpack_23_16bit_unsigned_5off(const uint8_t * input, double * output, void *closure) {
	// Unpack 23 values into output
	// Values are 16-bit unsigned
	// Skip 5 bits, read 368 bits of data.
	// Input must be at least 47 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 5 to 20
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)(input[2] & 0xf8) << 13);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 21 to 36
	value = ((uint32_t)(input[2] & 0x07) << 29) |
			((uint32_t)input[3] << 21) |
			((uint32_t)(input[4] & 0xf8) << 13);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 37 to 52
	value = ((uint32_t)(input[4] & 0x07) << 29) |
			((uint32_t)input[5] << 21) |
			((uint32_t)(input[6] & 0xf8) << 13);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 53 to 68
	value = ((uint32_t)(input[6] & 0x07) << 29) |
			((uint32_t)input[7] << 21) |
			((uint32_t)(input[8] & 0xf8) << 13);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 69 to 84
	value = ((uint32_t)(input[8] & 0x07) << 29) |
			((uint32_t)input[9] << 21) |
			((uint32_t)(input[10] & 0xf8) << 13);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 85 to 100
	value = ((uint32_t)(input[10] & 0x07) << 29) |
			((uint32_t)input[11] << 21) |
			((uint32_t)(input[12] & 0xf8) << 13);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 101 to 116
	value = ((uint32_t)(input[12] & 0x07) << 29) |
			((uint32_t)input[13] << 21) |
			((uint32_t)(input[14] & 0xf8) << 13);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 117 to 132
	value = ((uint32_t)(input[14] & 0x07) << 29) |
			((uint32_t)input[15] << 21) |
			((uint32_t)(input[16] & 0xf8) << 13);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 133 to 148
	value = ((uint32_t)(input[16] & 0x07) << 29) |
			((uint32_t)input[17] << 21) |
			((uint32_t)(input[18] & 0xf8) << 13);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 149 to 164
	value = ((uint32_t)(input[18] & 0x07) << 29) |
			((uint32_t)input[19] << 21) |
			((uint32_t)(input[20] & 0xf8) << 13);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 165 to 180
	value = ((uint32_t)(input[20] & 0x07) << 29) |
			((uint32_t)input[21] << 21) |
			((uint32_t)(input[22] & 0xf8) << 13);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 181 to 196
	value = ((uint32_t)(input[22] & 0x07) << 29) |
			((uint32_t)input[23] << 21) |
			((uint32_t)(input[24] & 0xf8) << 13);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 197 to 212
	value = ((uint32_t)(input[24] & 0x07) << 29) |
			((uint32_t)input[25] << 21) |
			((uint32_t)(input[26] & 0xf8) << 13);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 213 to 228
	value = ((uint32_t)(input[26] & 0x07) << 29) |
			((uint32_t)input[27] << 21) |
			((uint32_t)(input[28] & 0xf8) << 13);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 229 to 244
	value = ((uint32_t)(input[28] & 0x07) << 29) |
			((uint32_t)input[29] << 21) |
			((uint32_t)(input[30] & 0xf8) << 13);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 245 to 260
	value = ((uint32_t)(input[30] & 0x07) << 29) |
			((uint32_t)input[31] << 21) |
			((uint32_t)(input[32] & 0xf8) << 13);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 261 to 276
	value = ((uint32_t)(input[32] & 0x07) << 29) |
			((uint32_t)input[33] << 21) |
			((uint32_t)(input[34] & 0xf8) << 13);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 277 to 292
	value = ((uint32_t)(input[34] & 0x07) << 29) |
			((uint32_t)input[35] << 21) |
			((uint32_t)(input[36] & 0xf8) << 13);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 293 to 308
	value = ((uint32_t)(input[36] & 0x07) << 29) |
			((uint32_t)input[37] << 21) |
			((uint32_t)(input[38] & 0xf8) << 13);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 309 to 324
	value = ((uint32_t)(input[38] & 0x07) << 29) |
			((uint32_t)input[39] << 21) |
			((uint32_t)(input[40] & 0xf8) << 13);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 325 to 340
	value = ((uint32_t)(input[40] & 0x07) << 29) |
			((uint32_t)input[41] << 21) |
			((uint32_t)(input[42] & 0xf8) << 13);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 341 to 356
	value = ((uint32_t)(input[42] & 0x07) << 29) |
			((uint32_t)input[43] << 21) |
			((uint32_t)(input[44] & 0xf8) << 13);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 357 to 372
	value = ((uint32_t)(input[44] & 0x07) << 29) |
			((uint32_t)input[45] << 21) |
			((uint32_t)(input[46] & 0xf8) << 13);
	output[22] = (double)(value >> 16);
}

static void unpack_23_16bit_signed_6off(const uint8_t * input, double * output, void *closure) {
	// Unpack 23 values into output
	// Values are 16-bit signed
	// Skip 6 bits, read 368 bits of data.
	// Input must be at least 47 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 6 to 21
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)(input[2] & 0xfc) << 14);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 22 to 37
	value = ((uint32_t)(input[2] & 0x03) << 30) |
			((uint32_t)input[3] << 22) |
			((uint32_t)(input[4] & 0xfc) << 14);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 38 to 53
	value = ((uint32_t)(input[4] & 0x03) << 30) |
			((uint32_t)input[5] << 22) |
			((uint32_t)(input[6] & 0xfc) << 14);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 54 to 69
	value = ((uint32_t)(input[6] & 0x03) << 30) |
			((uint32_t)input[7] << 22) |
			((uint32_t)(input[8] & 0xfc) << 14);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 70 to 85
	value = ((uint32_t)(input[8] & 0x03) << 30) |
			((uint32_t)input[9] << 22) |
			((uint32_t)(input[10] & 0xfc) << 14);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 86 to 101
	value = ((uint32_t)(input[10] & 0x03) << 30) |
			((uint32_t)input[11] << 22) |
			((uint32_t)(input[12] & 0xfc) << 14);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 102 to 117
	value = ((uint32_t)(input[12] & 0x03) << 30) |
			((uint32_t)input[13] << 22) |
			((uint32_t)(input[14] & 0xfc) << 14);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 118 to 133
	value = ((uint32_t)(input[14] & 0x03) << 30) |
			((uint32_t)input[15] << 22) |
			((uint32_t)(input[16] & 0xfc) << 14);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 134 to 149
	value = ((uint32_t)(input[16] & 0x03) << 30) |
			((uint32_t)input[17] << 22) |
			((uint32_t)(input[18] & 0xfc) << 14);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 150 to 165
	value = ((uint32_t)(input[18] & 0x03) << 30) |
			((uint32_t)input[19] << 22) |
			((uint32_t)(input[20] & 0xfc) << 14);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 166 to 181
	value = ((uint32_t)(input[20] & 0x03) << 30) |
			((uint32_t)input[21] << 22) |
			((uint32_t)(input[22] & 0xfc) << 14);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 182 to 197
	value = ((uint32_t)(input[22] & 0x03) << 30) |
			((uint32_t)input[23] << 22) |
			((uint32_t)(input[24] & 0xfc) << 14);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 198 to 213
	value = ((uint32_t)(input[24] & 0x03) << 30) |
			((uint32_t)input[25] << 22) |
			((uint32_t)(input[26] & 0xfc) << 14);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 214 to 229
	value = ((uint32_t)(input[26] & 0x03) << 30) |
			((uint32_t)input[27] << 22) |
			((uint32_t)(input[28] & 0xfc) << 14);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 230 to 245
	value = ((uint32_t)(input[28] & 0x03) << 30) |
			((uint32_t)input[29] << 22) |
			((uint32_t)(input[30] & 0xfc) << 14);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 246 to 261
	value = ((uint32_t)(input[30] & 0x03) << 30) |
			((uint32_t)input[31] << 22) |
			((uint32_t)(input[32] & 0xfc) << 14);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 262 to 277
	value = ((uint32_t)(input[32] & 0x03) << 30) |
			((uint32_t)input[33] << 22) |
			((uint32_t)(input[34] & 0xfc) << 14);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 278 to 293
	value = ((uint32_t)(input[34] & 0x03) << 30) |
			((uint32_t)input[35] << 22) |
			((uint32_t)(input[36] & 0xfc) << 14);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 294 to 309
	value = ((uint32_t)(input[36] & 0x03) << 30) |
			((uint32_t)input[37] << 22) |
			((uint32_t)(input[38] & 0xfc) << 14);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 310 to 325
	value = ((uint32_t)(input[38] & 0x03) << 30) |
			((uint32_t)input[39] << 22) |
			((uint32_t)(input[40] & 0xfc) << 14);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 326 to 341
	value = ((uint32_t)(input[40] & 0x03) << 30) |
			((uint32_t)input[41] << 22) |
			((uint32_t)(input[42] & 0xfc) << 14);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 342 to 357
	value = ((uint32_t)(input[42] & 0x03) << 30) |
			((uint32_t)input[43] << 22) |
			((uint32_t)(input[44] & 0xfc) << 14);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 358 to 373
	value = ((uint32_t)(input[44] & 0x03) << 30) |
			((uint32_t)input[45] << 22) |
			((uint32_t)(input[46] & 0xfc) << 14);
	output[22] = (double)(value >> 16);
}

static void unpack_23_16bit_unsigned_6off(const uint8_t * input, double * output, void *closure) {
	// Unpack 23 values into output
	// Values are 16-bit unsigned
	// Skip 6 bits, read 368 bits of data.
	// Input must be at least 47 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 6 to 21
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)(input[2] & 0xfc) << 14);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 22 to 37
	value = ((uint32_t)(input[2] & 0x03) << 30) |
			((uint32_t)input[3] << 22) |
			((uint32_t)(input[4] & 0xfc) << 14);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 38 to 53
	value = ((uint32_t)(input[4] & 0x03) << 30) |
			((uint32_t)input[5] << 22) |
			((uint32_t)(input[6] & 0xfc) << 14);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 54 to 69
	value = ((uint32_t)(input[6] & 0x03) << 30) |
			((uint32_t)input[7] << 22) |
			((uint32_t)(input[8] & 0xfc) << 14);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 70 to 85
	value = ((uint32_t)(input[8] & 0x03) << 30) |
			((uint32_t)input[9] << 22) |
			((uint32_t)(input[10] & 0xfc) << 14);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 86 to 101
	value = ((uint32_t)(input[10] & 0x03) << 30) |
			((uint32_t)input[11] << 22) |
			((uint32_t)(input[12] & 0xfc) << 14);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 102 to 117
	value = ((uint32_t)(input[12] & 0x03) << 30) |
			((uint32_t)input[13] << 22) |
			((uint32_t)(input[14] & 0xfc) << 14);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 118 to 133
	value = ((uint32_t)(input[14] & 0x03) << 30) |
			((uint32_t)input[15] << 22) |
			((uint32_t)(input[16] & 0xfc) << 14);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 134 to 149
	value = ((uint32_t)(input[16] & 0x03) << 30) |
			((uint32_t)input[17] << 22) |
			((uint32_t)(input[18] & 0xfc) << 14);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 150 to 165
	value = ((uint32_t)(input[18] & 0x03) << 30) |
			((uint32_t)input[19] << 22) |
			((uint32_t)(input[20] & 0xfc) << 14);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 166 to 181
	value = ((uint32_t)(input[20] & 0x03) << 30) |
			((uint32_t)input[21] << 22) |
			((uint32_t)(input[22] & 0xfc) << 14);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 182 to 197
	value = ((uint32_t)(input[22] & 0x03) << 30) |
			((uint32_t)input[23] << 22) |
			((uint32_t)(input[24] & 0xfc) << 14);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 198 to 213
	value = ((uint32_t)(input[24] & 0x03) << 30) |
			((uint32_t)input[25] << 22) |
			((uint32_t)(input[26] & 0xfc) << 14);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 214 to 229
	value = ((uint32_t)(input[26] & 0x03) << 30) |
			((uint32_t)input[27] << 22) |
			((uint32_t)(input[28] & 0xfc) << 14);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 230 to 245
	value = ((uint32_t)(input[28] & 0x03) << 30) |
			((uint32_t)input[29] << 22) |
			((uint32_t)(input[30] & 0xfc) << 14);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 246 to 261
	value = ((uint32_t)(input[30] & 0x03) << 30) |
			((uint32_t)input[31] << 22) |
			((uint32_t)(input[32] & 0xfc) << 14);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 262 to 277
	value = ((uint32_t)(input[32] & 0x03) << 30) |
			((uint32_t)input[33] << 22) |
			((uint32_t)(input[34] & 0xfc) << 14);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 278 to 293
	value = ((uint32_t)(input[34] & 0x03) << 30) |
			((uint32_t)input[35] << 22) |
			((uint32_t)(input[36] & 0xfc) << 14);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 294 to 309
	value = ((uint32_t)(input[36] & 0x03) << 30) |
			((uint32_t)input[37] << 22) |
			((uint32_t)(input[38] & 0xfc) << 14);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 310 to 325
	value = ((uint32_t)(input[38] & 0x03) << 30) |
			((uint32_t)input[39] << 22) |
			((uint32_t)(input[40] & 0xfc) << 14);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 326 to 341
	value = ((uint32_t)(input[40] & 0x03) << 30) |
			((uint32_t)input[41] << 22) |
			((uint32_t)(input[42] & 0xfc) << 14);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 342 to 357
	value = ((uint32_t)(input[42] & 0x03) << 30) |
			((uint32_t)input[43] << 22) |
			((uint32_t)(input[44] & 0xfc) << 14);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 358 to 373
	value = ((uint32_t)(input[44] & 0x03) << 30) |
			((uint32_t)input[45] << 22) |
			((uint32_t)(input[46] & 0xfc) << 14);
	output[22] = (double)(value >> 16);
}

static void unpack_23_16bit_signed_7off(const uint8_t * input, double * output, void *closure) {
	// Unpack 23 values into output
	// Values are 16-bit signed
	// Skip 7 bits, read 368 bits of data.
	// Input must be at least 47 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 7 to 22
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)(input[2] & 0xfe) << 15);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 23 to 38
	value = ((uint32_t)(input[2] & 0x01) << 31) |
			((uint32_t)input[3] << 23) |
			((uint32_t)(input[4] & 0xfe) << 15);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 39 to 54
	value = ((uint32_t)(input[4] & 0x01) << 31) |
			((uint32_t)input[5] << 23) |
			((uint32_t)(input[6] & 0xfe) << 15);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 55 to 70
	value = ((uint32_t)(input[6] & 0x01) << 31) |
			((uint32_t)input[7] << 23) |
			((uint32_t)(input[8] & 0xfe) << 15);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 71 to 86
	value = ((uint32_t)(input[8] & 0x01) << 31) |
			((uint32_t)input[9] << 23) |
			((uint32_t)(input[10] & 0xfe) << 15);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 87 to 102
	value = ((uint32_t)(input[10] & 0x01) << 31) |
			((uint32_t)input[11] << 23) |
			((uint32_t)(input[12] & 0xfe) << 15);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 103 to 118
	value = ((uint32_t)(input[12] & 0x01) << 31) |
			((uint32_t)input[13] << 23) |
			((uint32_t)(input[14] & 0xfe) << 15);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 119 to 134
	value = ((uint32_t)(input[14] & 0x01) << 31) |
			((uint32_t)input[15] << 23) |
			((uint32_t)(input[16] & 0xfe) << 15);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 135 to 150
	value = ((uint32_t)(input[16] & 0x01) << 31) |
			((uint32_t)input[17] << 23) |
			((uint32_t)(input[18] & 0xfe) << 15);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 151 to 166
	value = ((uint32_t)(input[18] & 0x01) << 31) |
			((uint32_t)input[19] << 23) |
			((uint32_t)(input[20] & 0xfe) << 15);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 167 to 182
	value = ((uint32_t)(input[20] & 0x01) << 31) |
			((uint32_t)input[21] << 23) |
			((uint32_t)(input[22] & 0xfe) << 15);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 183 to 198
	value = ((uint32_t)(input[22] & 0x01) << 31) |
			((uint32_t)input[23] << 23) |
			((uint32_t)(input[24] & 0xfe) << 15);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 199 to 214
	value = ((uint32_t)(input[24] & 0x01) << 31) |
			((uint32_t)input[25] << 23) |
			((uint32_t)(input[26] & 0xfe) << 15);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 215 to 230
	value = ((uint32_t)(input[26] & 0x01) << 31) |
			((uint32_t)input[27] << 23) |
			((uint32_t)(input[28] & 0xfe) << 15);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 231 to 246
	value = ((uint32_t)(input[28] & 0x01) << 31) |
			((uint32_t)input[29] << 23) |
			((uint32_t)(input[30] & 0xfe) << 15);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 247 to 262
	value = ((uint32_t)(input[30] & 0x01) << 31) |
			((uint32_t)input[31] << 23) |
			((uint32_t)(input[32] & 0xfe) << 15);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 263 to 278
	value = ((uint32_t)(input[32] & 0x01) << 31) |
			((uint32_t)input[33] << 23) |
			((uint32_t)(input[34] & 0xfe) << 15);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 279 to 294
	value = ((uint32_t)(input[34] & 0x01) << 31) |
			((uint32_t)input[35] << 23) |
			((uint32_t)(input[36] & 0xfe) << 15);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 295 to 310
	value = ((uint32_t)(input[36] & 0x01) << 31) |
			((uint32_t)input[37] << 23) |
			((uint32_t)(input[38] & 0xfe) << 15);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 311 to 326
	value = ((uint32_t)(input[38] & 0x01) << 31) |
			((uint32_t)input[39] << 23) |
			((uint32_t)(input[40] & 0xfe) << 15);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 327 to 342
	value = ((uint32_t)(input[40] & 0x01) << 31) |
			((uint32_t)input[41] << 23) |
			((uint32_t)(input[42] & 0xfe) << 15);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 343 to 358
	value = ((uint32_t)(input[42] & 0x01) << 31) |
			((uint32_t)input[43] << 23) |
			((uint32_t)(input[44] & 0xfe) << 15);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 359 to 374
	value = ((uint32_t)(input[44] & 0x01) << 31) |
			((uint32_t)input[45] << 23) |
			((uint32_t)(input[46] & 0xfe) << 15);
	output[22] = (double)(value >> 16);
}

static void unpack_23_16bit_unsigned_7off(const uint8_t * input, double * output, void *closure) {
	// Unpack 23 values into output
	// Values are 16-bit unsigned
	// Skip 7 bits, read 368 bits of data.
	// Input must be at least 47 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 7 to 22
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)(input[2] & 0xfe) << 15);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 23 to 38
	value = ((uint32_t)(input[2] & 0x01) << 31) |
			((uint32_t)input[3] << 23) |
			((uint32_t)(input[4] & 0xfe) << 15);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 39 to 54
	value = ((uint32_t)(input[4] & 0x01) << 31) |
			((uint32_t)input[5] << 23) |
			((uint32_t)(input[6] & 0xfe) << 15);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 55 to 70
	value = ((uint32_t)(input[6] & 0x01) << 31) |
			((uint32_t)input[7] << 23) |
			((uint32_t)(input[8] & 0xfe) << 15);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 71 to 86
	value = ((uint32_t)(input[8] & 0x01) << 31) |
			((uint32_t)input[9] << 23) |
			((uint32_t)(input[10] & 0xfe) << 15);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 87 to 102
	value = ((uint32_t)(input[10] & 0x01) << 31) |
			((uint32_t)input[11] << 23) |
			((uint32_t)(input[12] & 0xfe) << 15);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 103 to 118
	value = ((uint32_t)(input[12] & 0x01) << 31) |
			((uint32_t)input[13] << 23) |
			((uint32_t)(input[14] & 0xfe) << 15);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 119 to 134
	value = ((uint32_t)(input[14] & 0x01) << 31) |
			((uint32_t)input[15] << 23) |
			((uint32_t)(input[16] & 0xfe) << 15);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 135 to 150
	value = ((uint32_t)(input[16] & 0x01) << 31) |
			((uint32_t)input[17] << 23) |
			((uint32_t)(input[18] & 0xfe) << 15);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 151 to 166
	value = ((uint32_t)(input[18] & 0x01) << 31) |
			((uint32_t)input[19] << 23) |
			((uint32_t)(input[20] & 0xfe) << 15);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 167 to 182
	value = ((uint32_t)(input[20] & 0x01) << 31) |
			((uint32_t)input[21] << 23) |
			((uint32_t)(input[22] & 0xfe) << 15);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 183 to 198
	value = ((uint32_t)(input[22] & 0x01) << 31) |
			((uint32_t)input[23] << 23) |
			((uint32_t)(input[24] & 0xfe) << 15);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 199 to 214
	value = ((uint32_t)(input[24] & 0x01) << 31) |
			((uint32_t)input[25] << 23) |
			((uint32_t)(input[26] & 0xfe) << 15);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 215 to 230
	value = ((uint32_t)(input[26] & 0x01) << 31) |
			((uint32_t)input[27] << 23) |
			((uint32_t)(input[28] & 0xfe) << 15);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 231 to 246
	value = ((uint32_t)(input[28] & 0x01) << 31) |
			((uint32_t)input[29] << 23) |
			((uint32_t)(input[30] & 0xfe) << 15);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 247 to 262
	value = ((uint32_t)(input[30] & 0x01) << 31) |
			((uint32_t)input[31] << 23) |
			((uint32_t)(input[32] & 0xfe) << 15);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 263 to 278
	value = ((uint32_t)(input[32] & 0x01) << 31) |
			((uint32_t)input[33] << 23) |
			((uint32_t)(input[34] & 0xfe) << 15);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 279 to 294
	value = ((uint32_t)(input[34] & 0x01) << 31) |
			((uint32_t)input[35] << 23) |
			((uint32_t)(input[36] & 0xfe) << 15);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 295 to 310
	value = ((uint32_t)(input[36] & 0x01) << 31) |
			((uint32_t)input[37] << 23) |
			((uint32_t)(input[38] & 0xfe) << 15);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 311 to 326
	value = ((uint32_t)(input[38] & 0x01) << 31) |
			((uint32_t)input[39] << 23) |
			((uint32_t)(input[40] & 0xfe) << 15);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 327 to 342
	value = ((uint32_t)(input[40] & 0x01) << 31) |
			((uint32_t)input[41] << 23) |
			((uint32_t)(input[42] & 0xfe) << 15);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 343 to 358
	value = ((uint32_t)(input[42] & 0x01) << 31) |
			((uint32_t)input[43] << 23) |
			((uint32_t)(input[44] & 0xfe) << 15);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 359 to 374
	value = ((uint32_t)(input[44] & 0x01) << 31) |
			((uint32_t)input[45] << 23) |
			((uint32_t)(input[46] & 0xfe) << 15);
	output[22] = (double)(value >> 16);
}

static void unpack_24_16bit_signed_0off(const uint8_t * input, double * output, void *closure) {
	// Unpack 24 values into output
	// Values are 16-bit signed
	// Skip 0 bits, read 384 bits of data.
	// Input must be at least 48 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 0 to 15
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)input[1] << 16);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 16 to 31
	value = ((uint32_t)input[2] << 24) |
			((uint32_t)input[3] << 16);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 32 to 47
	value = ((uint32_t)input[4] << 24) |
			((uint32_t)input[5] << 16);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 48 to 63
	value = ((uint32_t)input[6] << 24) |
			((uint32_t)input[7] << 16);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 64 to 79
	value = ((uint32_t)input[8] << 24) |
			((uint32_t)input[9] << 16);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 80 to 95
	value = ((uint32_t)input[10] << 24) |
			((uint32_t)input[11] << 16);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 96 to 111
	value = ((uint32_t)input[12] << 24) |
			((uint32_t)input[13] << 16);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 112 to 127
	value = ((uint32_t)input[14] << 24) |
			((uint32_t)input[15] << 16);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 128 to 143
	value = ((uint32_t)input[16] << 24) |
			((uint32_t)input[17] << 16);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 144 to 159
	value = ((uint32_t)input[18] << 24) |
			((uint32_t)input[19] << 16);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 160 to 175
	value = ((uint32_t)input[20] << 24) |
			((uint32_t)input[21] << 16);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 176 to 191
	value = ((uint32_t)input[22] << 24) |
			((uint32_t)input[23] << 16);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 192 to 207
	value = ((uint32_t)input[24] << 24) |
			((uint32_t)input[25] << 16);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 208 to 223
	value = ((uint32_t)input[26] << 24) |
			((uint32_t)input[27] << 16);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 224 to 239
	value = ((uint32_t)input[28] << 24) |
			((uint32_t)input[29] << 16);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 240 to 255
	value = ((uint32_t)input[30] << 24) |
			((uint32_t)input[31] << 16);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 256 to 271
	value = ((uint32_t)input[32] << 24) |
			((uint32_t)input[33] << 16);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 272 to 287
	value = ((uint32_t)input[34] << 24) |
			((uint32_t)input[35] << 16);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 288 to 303
	value = ((uint32_t)input[36] << 24) |
			((uint32_t)input[37] << 16);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 304 to 319
	value = ((uint32_t)input[38] << 24) |
			((uint32_t)input[39] << 16);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 320 to 335
	value = ((uint32_t)input[40] << 24) |
			((uint32_t)input[41] << 16);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 336 to 351
	value = ((uint32_t)input[42] << 24) |
			((uint32_t)input[43] << 16);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 352 to 367
	value = ((uint32_t)input[44] << 24) |
			((uint32_t)input[45] << 16);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 368 to 383
	value = ((uint32_t)input[46] << 24) |
			((uint32_t)input[47] << 16);
	output[23] = (double)(value >> 16);
}

static void unpack_24_16bit_unsigned_0off(const uint8_t * input, double * output, void *closure) {
	// Unpack 24 values into output
	// Values are 16-bit unsigned
	// Skip 0 bits, read 384 bits of data.
	// Input must be at least 48 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 0 to 15
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)input[1] << 16);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 16 to 31
	value = ((uint32_t)input[2] << 24) |
			((uint32_t)input[3] << 16);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 32 to 47
	value = ((uint32_t)input[4] << 24) |
			((uint32_t)input[5] << 16);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 48 to 63
	value = ((uint32_t)input[6] << 24) |
			((uint32_t)input[7] << 16);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 64 to 79
	value = ((uint32_t)input[8] << 24) |
			((uint32_t)input[9] << 16);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 80 to 95
	value = ((uint32_t)input[10] << 24) |
			((uint32_t)input[11] << 16);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 96 to 111
	value = ((uint32_t)input[12] << 24) |
			((uint32_t)input[13] << 16);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 112 to 127
	value = ((uint32_t)input[14] << 24) |
			((uint32_t)input[15] << 16);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 128 to 143
	value = ((uint32_t)input[16] << 24) |
			((uint32_t)input[17] << 16);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 144 to 159
	value = ((uint32_t)input[18] << 24) |
			((uint32_t)input[19] << 16);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 160 to 175
	value = ((uint32_t)input[20] << 24) |
			((uint32_t)input[21] << 16);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 176 to 191
	value = ((uint32_t)input[22] << 24) |
			((uint32_t)input[23] << 16);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 192 to 207
	value = ((uint32_t)input[24] << 24) |
			((uint32_t)input[25] << 16);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 208 to 223
	value = ((uint32_t)input[26] << 24) |
			((uint32_t)input[27] << 16);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 224 to 239
	value = ((uint32_t)input[28] << 24) |
			((uint32_t)input[29] << 16);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 240 to 255
	value = ((uint32_t)input[30] << 24) |
			((uint32_t)input[31] << 16);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 256 to 271
	value = ((uint32_t)input[32] << 24) |
			((uint32_t)input[33] << 16);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 272 to 287
	value = ((uint32_t)input[34] << 24) |
			((uint32_t)input[35] << 16);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 288 to 303
	value = ((uint32_t)input[36] << 24) |
			((uint32_t)input[37] << 16);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 304 to 319
	value = ((uint32_t)input[38] << 24) |
			((uint32_t)input[39] << 16);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 320 to 335
	value = ((uint32_t)input[40] << 24) |
			((uint32_t)input[41] << 16);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 336 to 351
	value = ((uint32_t)input[42] << 24) |
			((uint32_t)input[43] << 16);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 352 to 367
	value = ((uint32_t)input[44] << 24) |
			((uint32_t)input[45] << 16);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 368 to 383
	value = ((uint32_t)input[46] << 24) |
			((uint32_t)input[47] << 16);
	output[23] = (double)(value >> 16);
}

static void unpack_24_16bit_signed_1off(const uint8_t * input, double * output, void *closure) {
	// Unpack 24 values into output
	// Values are 16-bit signed
	// Skip 1 bits, read 384 bits of data.
	// Input must be at least 49 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 1 to 16
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)input[1] << 17) |
			((uint32_t)(input[2] & 0x80) << 9);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 17 to 32
	value = ((uint32_t)(input[2] & 0x7f) << 25) |
			((uint32_t)input[3] << 17) |
			((uint32_t)(input[4] & 0x80) << 9);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 33 to 48
	value = ((uint32_t)(input[4] & 0x7f) << 25) |
			((uint32_t)input[5] << 17) |
			((uint32_t)(input[6] & 0x80) << 9);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 49 to 64
	value = ((uint32_t)(input[6] & 0x7f) << 25) |
			((uint32_t)input[7] << 17) |
			((uint32_t)(input[8] & 0x80) << 9);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 65 to 80
	value = ((uint32_t)(input[8] & 0x7f) << 25) |
			((uint32_t)input[9] << 17) |
			((uint32_t)(input[10] & 0x80) << 9);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 81 to 96
	value = ((uint32_t)(input[10] & 0x7f) << 25) |
			((uint32_t)input[11] << 17) |
			((uint32_t)(input[12] & 0x80) << 9);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 97 to 112
	value = ((uint32_t)(input[12] & 0x7f) << 25) |
			((uint32_t)input[13] << 17) |
			((uint32_t)(input[14] & 0x80) << 9);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 113 to 128
	value = ((uint32_t)(input[14] & 0x7f) << 25) |
			((uint32_t)input[15] << 17) |
			((uint32_t)(input[16] & 0x80) << 9);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 129 to 144
	value = ((uint32_t)(input[16] & 0x7f) << 25) |
			((uint32_t)input[17] << 17) |
			((uint32_t)(input[18] & 0x80) << 9);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 145 to 160
	value = ((uint32_t)(input[18] & 0x7f) << 25) |
			((uint32_t)input[19] << 17) |
			((uint32_t)(input[20] & 0x80) << 9);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 161 to 176
	value = ((uint32_t)(input[20] & 0x7f) << 25) |
			((uint32_t)input[21] << 17) |
			((uint32_t)(input[22] & 0x80) << 9);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 177 to 192
	value = ((uint32_t)(input[22] & 0x7f) << 25) |
			((uint32_t)input[23] << 17) |
			((uint32_t)(input[24] & 0x80) << 9);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 193 to 208
	value = ((uint32_t)(input[24] & 0x7f) << 25) |
			((uint32_t)input[25] << 17) |
			((uint32_t)(input[26] & 0x80) << 9);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 209 to 224
	value = ((uint32_t)(input[26] & 0x7f) << 25) |
			((uint32_t)input[27] << 17) |
			((uint32_t)(input[28] & 0x80) << 9);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 225 to 240
	value = ((uint32_t)(input[28] & 0x7f) << 25) |
			((uint32_t)input[29] << 17) |
			((uint32_t)(input[30] & 0x80) << 9);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 241 to 256
	value = ((uint32_t)(input[30] & 0x7f) << 25) |
			((uint32_t)input[31] << 17) |
			((uint32_t)(input[32] & 0x80) << 9);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 257 to 272
	value = ((uint32_t)(input[32] & 0x7f) << 25) |
			((uint32_t)input[33] << 17) |
			((uint32_t)(input[34] & 0x80) << 9);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 273 to 288
	value = ((uint32_t)(input[34] & 0x7f) << 25) |
			((uint32_t)input[35] << 17) |
			((uint32_t)(input[36] & 0x80) << 9);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 289 to 304
	value = ((uint32_t)(input[36] & 0x7f) << 25) |
			((uint32_t)input[37] << 17) |
			((uint32_t)(input[38] & 0x80) << 9);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 305 to 320
	value = ((uint32_t)(input[38] & 0x7f) << 25) |
			((uint32_t)input[39] << 17) |
			((uint32_t)(input[40] & 0x80) << 9);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 321 to 336
	value = ((uint32_t)(input[40] & 0x7f) << 25) |
			((uint32_t)input[41] << 17) |
			((uint32_t)(input[42] & 0x80) << 9);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 337 to 352
	value = ((uint32_t)(input[42] & 0x7f) << 25) |
			((uint32_t)input[43] << 17) |
			((uint32_t)(input[44] & 0x80) << 9);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 353 to 368
	value = ((uint32_t)(input[44] & 0x7f) << 25) |
			((uint32_t)input[45] << 17) |
			((uint32_t)(input[46] & 0x80) << 9);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 369 to 384
	value = ((uint32_t)(input[46] & 0x7f) << 25) |
			((uint32_t)input[47] << 17) |
			((uint32_t)(input[48] & 0x80) << 9);
	output[23] = (double)(value >> 16);
}

static void unpack_24_16bit_unsigned_1off(const uint8_t * input, double * output, void *closure) {
	// Unpack 24 values into output
	// Values are 16-bit unsigned
	// Skip 1 bits, read 384 bits of data.
	// Input must be at least 49 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 1 to 16
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)input[1] << 17) |
			((uint32_t)(input[2] & 0x80) << 9);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 17 to 32
	value = ((uint32_t)(input[2] & 0x7f) << 25) |
			((uint32_t)input[3] << 17) |
			((uint32_t)(input[4] & 0x80) << 9);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 33 to 48
	value = ((uint32_t)(input[4] & 0x7f) << 25) |
			((uint32_t)input[5] << 17) |
			((uint32_t)(input[6] & 0x80) << 9);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 49 to 64
	value = ((uint32_t)(input[6] & 0x7f) << 25) |
			((uint32_t)input[7] << 17) |
			((uint32_t)(input[8] & 0x80) << 9);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 65 to 80
	value = ((uint32_t)(input[8] & 0x7f) << 25) |
			((uint32_t)input[9] << 17) |
			((uint32_t)(input[10] & 0x80) << 9);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 81 to 96
	value = ((uint32_t)(input[10] & 0x7f) << 25) |
			((uint32_t)input[11] << 17) |
			((uint32_t)(input[12] & 0x80) << 9);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 97 to 112
	value = ((uint32_t)(input[12] & 0x7f) << 25) |
			((uint32_t)input[13] << 17) |
			((uint32_t)(input[14] & 0x80) << 9);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 113 to 128
	value = ((uint32_t)(input[14] & 0x7f) << 25) |
			((uint32_t)input[15] << 17) |
			((uint32_t)(input[16] & 0x80) << 9);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 129 to 144
	value = ((uint32_t)(input[16] & 0x7f) << 25) |
			((uint32_t)input[17] << 17) |
			((uint32_t)(input[18] & 0x80) << 9);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 145 to 160
	value = ((uint32_t)(input[18] & 0x7f) << 25) |
			((uint32_t)input[19] << 17) |
			((uint32_t)(input[20] & 0x80) << 9);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 161 to 176
	value = ((uint32_t)(input[20] & 0x7f) << 25) |
			((uint32_t)input[21] << 17) |
			((uint32_t)(input[22] & 0x80) << 9);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 177 to 192
	value = ((uint32_t)(input[22] & 0x7f) << 25) |
			((uint32_t)input[23] << 17) |
			((uint32_t)(input[24] & 0x80) << 9);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 193 to 208
	value = ((uint32_t)(input[24] & 0x7f) << 25) |
			((uint32_t)input[25] << 17) |
			((uint32_t)(input[26] & 0x80) << 9);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 209 to 224
	value = ((uint32_t)(input[26] & 0x7f) << 25) |
			((uint32_t)input[27] << 17) |
			((uint32_t)(input[28] & 0x80) << 9);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 225 to 240
	value = ((uint32_t)(input[28] & 0x7f) << 25) |
			((uint32_t)input[29] << 17) |
			((uint32_t)(input[30] & 0x80) << 9);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 241 to 256
	value = ((uint32_t)(input[30] & 0x7f) << 25) |
			((uint32_t)input[31] << 17) |
			((uint32_t)(input[32] & 0x80) << 9);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 257 to 272
	value = ((uint32_t)(input[32] & 0x7f) << 25) |
			((uint32_t)input[33] << 17) |
			((uint32_t)(input[34] & 0x80) << 9);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 273 to 288
	value = ((uint32_t)(input[34] & 0x7f) << 25) |
			((uint32_t)input[35] << 17) |
			((uint32_t)(input[36] & 0x80) << 9);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 289 to 304
	value = ((uint32_t)(input[36] & 0x7f) << 25) |
			((uint32_t)input[37] << 17) |
			((uint32_t)(input[38] & 0x80) << 9);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 305 to 320
	value = ((uint32_t)(input[38] & 0x7f) << 25) |
			((uint32_t)input[39] << 17) |
			((uint32_t)(input[40] & 0x80) << 9);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 321 to 336
	value = ((uint32_t)(input[40] & 0x7f) << 25) |
			((uint32_t)input[41] << 17) |
			((uint32_t)(input[42] & 0x80) << 9);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 337 to 352
	value = ((uint32_t)(input[42] & 0x7f) << 25) |
			((uint32_t)input[43] << 17) |
			((uint32_t)(input[44] & 0x80) << 9);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 353 to 368
	value = ((uint32_t)(input[44] & 0x7f) << 25) |
			((uint32_t)input[45] << 17) |
			((uint32_t)(input[46] & 0x80) << 9);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 369 to 384
	value = ((uint32_t)(input[46] & 0x7f) << 25) |
			((uint32_t)input[47] << 17) |
			((uint32_t)(input[48] & 0x80) << 9);
	output[23] = (double)(value >> 16);
}

static void unpack_24_16bit_signed_2off(const uint8_t * input, double * output, void *closure) {
	// Unpack 24 values into output
	// Values are 16-bit signed
	// Skip 2 bits, read 384 bits of data.
	// Input must be at least 49 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 2 to 17
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)input[1] << 18) |
			((uint32_t)(input[2] & 0xc0) << 10);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 18 to 33
	value = ((uint32_t)(input[2] & 0x3f) << 26) |
			((uint32_t)input[3] << 18) |
			((uint32_t)(input[4] & 0xc0) << 10);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 34 to 49
	value = ((uint32_t)(input[4] & 0x3f) << 26) |
			((uint32_t)input[5] << 18) |
			((uint32_t)(input[6] & 0xc0) << 10);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 50 to 65
	value = ((uint32_t)(input[6] & 0x3f) << 26) |
			((uint32_t)input[7] << 18) |
			((uint32_t)(input[8] & 0xc0) << 10);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 66 to 81
	value = ((uint32_t)(input[8] & 0x3f) << 26) |
			((uint32_t)input[9] << 18) |
			((uint32_t)(input[10] & 0xc0) << 10);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 82 to 97
	value = ((uint32_t)(input[10] & 0x3f) << 26) |
			((uint32_t)input[11] << 18) |
			((uint32_t)(input[12] & 0xc0) << 10);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 98 to 113
	value = ((uint32_t)(input[12] & 0x3f) << 26) |
			((uint32_t)input[13] << 18) |
			((uint32_t)(input[14] & 0xc0) << 10);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 114 to 129
	value = ((uint32_t)(input[14] & 0x3f) << 26) |
			((uint32_t)input[15] << 18) |
			((uint32_t)(input[16] & 0xc0) << 10);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 130 to 145
	value = ((uint32_t)(input[16] & 0x3f) << 26) |
			((uint32_t)input[17] << 18) |
			((uint32_t)(input[18] & 0xc0) << 10);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 146 to 161
	value = ((uint32_t)(input[18] & 0x3f) << 26) |
			((uint32_t)input[19] << 18) |
			((uint32_t)(input[20] & 0xc0) << 10);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 162 to 177
	value = ((uint32_t)(input[20] & 0x3f) << 26) |
			((uint32_t)input[21] << 18) |
			((uint32_t)(input[22] & 0xc0) << 10);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 178 to 193
	value = ((uint32_t)(input[22] & 0x3f) << 26) |
			((uint32_t)input[23] << 18) |
			((uint32_t)(input[24] & 0xc0) << 10);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 194 to 209
	value = ((uint32_t)(input[24] & 0x3f) << 26) |
			((uint32_t)input[25] << 18) |
			((uint32_t)(input[26] & 0xc0) << 10);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 210 to 225
	value = ((uint32_t)(input[26] & 0x3f) << 26) |
			((uint32_t)input[27] << 18) |
			((uint32_t)(input[28] & 0xc0) << 10);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 226 to 241
	value = ((uint32_t)(input[28] & 0x3f) << 26) |
			((uint32_t)input[29] << 18) |
			((uint32_t)(input[30] & 0xc0) << 10);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 242 to 257
	value = ((uint32_t)(input[30] & 0x3f) << 26) |
			((uint32_t)input[31] << 18) |
			((uint32_t)(input[32] & 0xc0) << 10);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 258 to 273
	value = ((uint32_t)(input[32] & 0x3f) << 26) |
			((uint32_t)input[33] << 18) |
			((uint32_t)(input[34] & 0xc0) << 10);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 274 to 289
	value = ((uint32_t)(input[34] & 0x3f) << 26) |
			((uint32_t)input[35] << 18) |
			((uint32_t)(input[36] & 0xc0) << 10);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 290 to 305
	value = ((uint32_t)(input[36] & 0x3f) << 26) |
			((uint32_t)input[37] << 18) |
			((uint32_t)(input[38] & 0xc0) << 10);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 306 to 321
	value = ((uint32_t)(input[38] & 0x3f) << 26) |
			((uint32_t)input[39] << 18) |
			((uint32_t)(input[40] & 0xc0) << 10);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 322 to 337
	value = ((uint32_t)(input[40] & 0x3f) << 26) |
			((uint32_t)input[41] << 18) |
			((uint32_t)(input[42] & 0xc0) << 10);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 338 to 353
	value = ((uint32_t)(input[42] & 0x3f) << 26) |
			((uint32_t)input[43] << 18) |
			((uint32_t)(input[44] & 0xc0) << 10);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 354 to 369
	value = ((uint32_t)(input[44] & 0x3f) << 26) |
			((uint32_t)input[45] << 18) |
			((uint32_t)(input[46] & 0xc0) << 10);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 370 to 385
	value = ((uint32_t)(input[46] & 0x3f) << 26) |
			((uint32_t)input[47] << 18) |
			((uint32_t)(input[48] & 0xc0) << 10);
	output[23] = (double)(value >> 16);
}

static void unpack_24_16bit_unsigned_2off(const uint8_t * input, double * output, void *closure) {
	// Unpack 24 values into output
	// Values are 16-bit unsigned
	// Skip 2 bits, read 384 bits of data.
	// Input must be at least 49 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 2 to 17
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)input[1] << 18) |
			((uint32_t)(input[2] & 0xc0) << 10);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 18 to 33
	value = ((uint32_t)(input[2] & 0x3f) << 26) |
			((uint32_t)input[3] << 18) |
			((uint32_t)(input[4] & 0xc0) << 10);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 34 to 49
	value = ((uint32_t)(input[4] & 0x3f) << 26) |
			((uint32_t)input[5] << 18) |
			((uint32_t)(input[6] & 0xc0) << 10);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 50 to 65
	value = ((uint32_t)(input[6] & 0x3f) << 26) |
			((uint32_t)input[7] << 18) |
			((uint32_t)(input[8] & 0xc0) << 10);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 66 to 81
	value = ((uint32_t)(input[8] & 0x3f) << 26) |
			((uint32_t)input[9] << 18) |
			((uint32_t)(input[10] & 0xc0) << 10);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 82 to 97
	value = ((uint32_t)(input[10] & 0x3f) << 26) |
			((uint32_t)input[11] << 18) |
			((uint32_t)(input[12] & 0xc0) << 10);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 98 to 113
	value = ((uint32_t)(input[12] & 0x3f) << 26) |
			((uint32_t)input[13] << 18) |
			((uint32_t)(input[14] & 0xc0) << 10);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 114 to 129
	value = ((uint32_t)(input[14] & 0x3f) << 26) |
			((uint32_t)input[15] << 18) |
			((uint32_t)(input[16] & 0xc0) << 10);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 130 to 145
	value = ((uint32_t)(input[16] & 0x3f) << 26) |
			((uint32_t)input[17] << 18) |
			((uint32_t)(input[18] & 0xc0) << 10);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 146 to 161
	value = ((uint32_t)(input[18] & 0x3f) << 26) |
			((uint32_t)input[19] << 18) |
			((uint32_t)(input[20] & 0xc0) << 10);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 162 to 177
	value = ((uint32_t)(input[20] & 0x3f) << 26) |
			((uint32_t)input[21] << 18) |
			((uint32_t)(input[22] & 0xc0) << 10);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 178 to 193
	value = ((uint32_t)(input[22] & 0x3f) << 26) |
			((uint32_t)input[23] << 18) |
			((uint32_t)(input[24] & 0xc0) << 10);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 194 to 209
	value = ((uint32_t)(input[24] & 0x3f) << 26) |
			((uint32_t)input[25] << 18) |
			((uint32_t)(input[26] & 0xc0) << 10);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 210 to 225
	value = ((uint32_t)(input[26] & 0x3f) << 26) |
			((uint32_t)input[27] << 18) |
			((uint32_t)(input[28] & 0xc0) << 10);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 226 to 241
	value = ((uint32_t)(input[28] & 0x3f) << 26) |
			((uint32_t)input[29] << 18) |
			((uint32_t)(input[30] & 0xc0) << 10);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 242 to 257
	value = ((uint32_t)(input[30] & 0x3f) << 26) |
			((uint32_t)input[31] << 18) |
			((uint32_t)(input[32] & 0xc0) << 10);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 258 to 273
	value = ((uint32_t)(input[32] & 0x3f) << 26) |
			((uint32_t)input[33] << 18) |
			((uint32_t)(input[34] & 0xc0) << 10);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 274 to 289
	value = ((uint32_t)(input[34] & 0x3f) << 26) |
			((uint32_t)input[35] << 18) |
			((uint32_t)(input[36] & 0xc0) << 10);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 290 to 305
	value = ((uint32_t)(input[36] & 0x3f) << 26) |
			((uint32_t)input[37] << 18) |
			((uint32_t)(input[38] & 0xc0) << 10);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 306 to 321
	value = ((uint32_t)(input[38] & 0x3f) << 26) |
			((uint32_t)input[39] << 18) |
			((uint32_t)(input[40] & 0xc0) << 10);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 322 to 337
	value = ((uint32_t)(input[40] & 0x3f) << 26) |
			((uint32_t)input[41] << 18) |
			((uint32_t)(input[42] & 0xc0) << 10);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 338 to 353
	value = ((uint32_t)(input[42] & 0x3f) << 26) |
			((uint32_t)input[43] << 18) |
			((uint32_t)(input[44] & 0xc0) << 10);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 354 to 369
	value = ((uint32_t)(input[44] & 0x3f) << 26) |
			((uint32_t)input[45] << 18) |
			((uint32_t)(input[46] & 0xc0) << 10);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 370 to 385
	value = ((uint32_t)(input[46] & 0x3f) << 26) |
			((uint32_t)input[47] << 18) |
			((uint32_t)(input[48] & 0xc0) << 10);
	output[23] = (double)(value >> 16);
}

static void unpack_24_16bit_signed_3off(const uint8_t * input, double * output, void *closure) {
	// Unpack 24 values into output
	// Values are 16-bit signed
	// Skip 3 bits, read 384 bits of data.
	// Input must be at least 49 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 3 to 18
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)input[1] << 19) |
			((uint32_t)(input[2] & 0xe0) << 11);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 19 to 34
	value = ((uint32_t)(input[2] & 0x1f) << 27) |
			((uint32_t)input[3] << 19) |
			((uint32_t)(input[4] & 0xe0) << 11);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 35 to 50
	value = ((uint32_t)(input[4] & 0x1f) << 27) |
			((uint32_t)input[5] << 19) |
			((uint32_t)(input[6] & 0xe0) << 11);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 51 to 66
	value = ((uint32_t)(input[6] & 0x1f) << 27) |
			((uint32_t)input[7] << 19) |
			((uint32_t)(input[8] & 0xe0) << 11);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 67 to 82
	value = ((uint32_t)(input[8] & 0x1f) << 27) |
			((uint32_t)input[9] << 19) |
			((uint32_t)(input[10] & 0xe0) << 11);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 83 to 98
	value = ((uint32_t)(input[10] & 0x1f) << 27) |
			((uint32_t)input[11] << 19) |
			((uint32_t)(input[12] & 0xe0) << 11);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 99 to 114
	value = ((uint32_t)(input[12] & 0x1f) << 27) |
			((uint32_t)input[13] << 19) |
			((uint32_t)(input[14] & 0xe0) << 11);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 115 to 130
	value = ((uint32_t)(input[14] & 0x1f) << 27) |
			((uint32_t)input[15] << 19) |
			((uint32_t)(input[16] & 0xe0) << 11);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 131 to 146
	value = ((uint32_t)(input[16] & 0x1f) << 27) |
			((uint32_t)input[17] << 19) |
			((uint32_t)(input[18] & 0xe0) << 11);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 147 to 162
	value = ((uint32_t)(input[18] & 0x1f) << 27) |
			((uint32_t)input[19] << 19) |
			((uint32_t)(input[20] & 0xe0) << 11);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 163 to 178
	value = ((uint32_t)(input[20] & 0x1f) << 27) |
			((uint32_t)input[21] << 19) |
			((uint32_t)(input[22] & 0xe0) << 11);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 179 to 194
	value = ((uint32_t)(input[22] & 0x1f) << 27) |
			((uint32_t)input[23] << 19) |
			((uint32_t)(input[24] & 0xe0) << 11);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 195 to 210
	value = ((uint32_t)(input[24] & 0x1f) << 27) |
			((uint32_t)input[25] << 19) |
			((uint32_t)(input[26] & 0xe0) << 11);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 211 to 226
	value = ((uint32_t)(input[26] & 0x1f) << 27) |
			((uint32_t)input[27] << 19) |
			((uint32_t)(input[28] & 0xe0) << 11);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 227 to 242
	value = ((uint32_t)(input[28] & 0x1f) << 27) |
			((uint32_t)input[29] << 19) |
			((uint32_t)(input[30] & 0xe0) << 11);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 243 to 258
	value = ((uint32_t)(input[30] & 0x1f) << 27) |
			((uint32_t)input[31] << 19) |
			((uint32_t)(input[32] & 0xe0) << 11);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 259 to 274
	value = ((uint32_t)(input[32] & 0x1f) << 27) |
			((uint32_t)input[33] << 19) |
			((uint32_t)(input[34] & 0xe0) << 11);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 275 to 290
	value = ((uint32_t)(input[34] & 0x1f) << 27) |
			((uint32_t)input[35] << 19) |
			((uint32_t)(input[36] & 0xe0) << 11);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 291 to 306
	value = ((uint32_t)(input[36] & 0x1f) << 27) |
			((uint32_t)input[37] << 19) |
			((uint32_t)(input[38] & 0xe0) << 11);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 307 to 322
	value = ((uint32_t)(input[38] & 0x1f) << 27) |
			((uint32_t)input[39] << 19) |
			((uint32_t)(input[40] & 0xe0) << 11);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 323 to 338
	value = ((uint32_t)(input[40] & 0x1f) << 27) |
			((uint32_t)input[41] << 19) |
			((uint32_t)(input[42] & 0xe0) << 11);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 339 to 354
	value = ((uint32_t)(input[42] & 0x1f) << 27) |
			((uint32_t)input[43] << 19) |
			((uint32_t)(input[44] & 0xe0) << 11);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 355 to 370
	value = ((uint32_t)(input[44] & 0x1f) << 27) |
			((uint32_t)input[45] << 19) |
			((uint32_t)(input[46] & 0xe0) << 11);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 371 to 386
	value = ((uint32_t)(input[46] & 0x1f) << 27) |
			((uint32_t)input[47] << 19) |
			((uint32_t)(input[48] & 0xe0) << 11);
	output[23] = (double)(value >> 16);
}

static void unpack_24_16bit_unsigned_3off(const uint8_t * input, double * output, void *closure) {
	// Unpack 24 values into output
	// Values are 16-bit unsigned
	// Skip 3 bits, read 384 bits of data.
	// Input must be at least 49 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 3 to 18
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)input[1] << 19) |
			((uint32_t)(input[2] & 0xe0) << 11);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 19 to 34
	value = ((uint32_t)(input[2] & 0x1f) << 27) |
			((uint32_t)input[3] << 19) |
			((uint32_t)(input[4] & 0xe0) << 11);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 35 to 50
	value = ((uint32_t)(input[4] & 0x1f) << 27) |
			((uint32_t)input[5] << 19) |
			((uint32_t)(input[6] & 0xe0) << 11);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 51 to 66
	value = ((uint32_t)(input[6] & 0x1f) << 27) |
			((uint32_t)input[7] << 19) |
			((uint32_t)(input[8] & 0xe0) << 11);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 67 to 82
	value = ((uint32_t)(input[8] & 0x1f) << 27) |
			((uint32_t)input[9] << 19) |
			((uint32_t)(input[10] & 0xe0) << 11);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 83 to 98
	value = ((uint32_t)(input[10] & 0x1f) << 27) |
			((uint32_t)input[11] << 19) |
			((uint32_t)(input[12] & 0xe0) << 11);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 99 to 114
	value = ((uint32_t)(input[12] & 0x1f) << 27) |
			((uint32_t)input[13] << 19) |
			((uint32_t)(input[14] & 0xe0) << 11);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 115 to 130
	value = ((uint32_t)(input[14] & 0x1f) << 27) |
			((uint32_t)input[15] << 19) |
			((uint32_t)(input[16] & 0xe0) << 11);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 131 to 146
	value = ((uint32_t)(input[16] & 0x1f) << 27) |
			((uint32_t)input[17] << 19) |
			((uint32_t)(input[18] & 0xe0) << 11);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 147 to 162
	value = ((uint32_t)(input[18] & 0x1f) << 27) |
			((uint32_t)input[19] << 19) |
			((uint32_t)(input[20] & 0xe0) << 11);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 163 to 178
	value = ((uint32_t)(input[20] & 0x1f) << 27) |
			((uint32_t)input[21] << 19) |
			((uint32_t)(input[22] & 0xe0) << 11);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 179 to 194
	value = ((uint32_t)(input[22] & 0x1f) << 27) |
			((uint32_t)input[23] << 19) |
			((uint32_t)(input[24] & 0xe0) << 11);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 195 to 210
	value = ((uint32_t)(input[24] & 0x1f) << 27) |
			((uint32_t)input[25] << 19) |
			((uint32_t)(input[26] & 0xe0) << 11);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 211 to 226
	value = ((uint32_t)(input[26] & 0x1f) << 27) |
			((uint32_t)input[27] << 19) |
			((uint32_t)(input[28] & 0xe0) << 11);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 227 to 242
	value = ((uint32_t)(input[28] & 0x1f) << 27) |
			((uint32_t)input[29] << 19) |
			((uint32_t)(input[30] & 0xe0) << 11);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 243 to 258
	value = ((uint32_t)(input[30] & 0x1f) << 27) |
			((uint32_t)input[31] << 19) |
			((uint32_t)(input[32] & 0xe0) << 11);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 259 to 274
	value = ((uint32_t)(input[32] & 0x1f) << 27) |
			((uint32_t)input[33] << 19) |
			((uint32_t)(input[34] & 0xe0) << 11);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 275 to 290
	value = ((uint32_t)(input[34] & 0x1f) << 27) |
			((uint32_t)input[35] << 19) |
			((uint32_t)(input[36] & 0xe0) << 11);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 291 to 306
	value = ((uint32_t)(input[36] & 0x1f) << 27) |
			((uint32_t)input[37] << 19) |
			((uint32_t)(input[38] & 0xe0) << 11);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 307 to 322
	value = ((uint32_t)(input[38] & 0x1f) << 27) |
			((uint32_t)input[39] << 19) |
			((uint32_t)(input[40] & 0xe0) << 11);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 323 to 338
	value = ((uint32_t)(input[40] & 0x1f) << 27) |
			((uint32_t)input[41] << 19) |
			((uint32_t)(input[42] & 0xe0) << 11);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 339 to 354
	value = ((uint32_t)(input[42] & 0x1f) << 27) |
			((uint32_t)input[43] << 19) |
			((uint32_t)(input[44] & 0xe0) << 11);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 355 to 370
	value = ((uint32_t)(input[44] & 0x1f) << 27) |
			((uint32_t)input[45] << 19) |
			((uint32_t)(input[46] & 0xe0) << 11);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 371 to 386
	value = ((uint32_t)(input[46] & 0x1f) << 27) |
			((uint32_t)input[47] << 19) |
			((uint32_t)(input[48] & 0xe0) << 11);
	output[23] = (double)(value >> 16);
}

static void unpack_24_16bit_signed_4off(const uint8_t * input, double * output, void *closure) {
	// Unpack 24 values into output
	// Values are 16-bit signed
	// Skip 4 bits, read 384 bits of data.
	// Input must be at least 49 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 4 to 19
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20) |
			((uint32_t)(input[2] & 0xf0) << 12);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 20 to 35
	value = ((uint32_t)(input[2] & 0x0f) << 28) |
			((uint32_t)input[3] << 20) |
			((uint32_t)(input[4] & 0xf0) << 12);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 36 to 51
	value = ((uint32_t)(input[4] & 0x0f) << 28) |
			((uint32_t)input[5] << 20) |
			((uint32_t)(input[6] & 0xf0) << 12);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 52 to 67
	value = ((uint32_t)(input[6] & 0x0f) << 28) |
			((uint32_t)input[7] << 20) |
			((uint32_t)(input[8] & 0xf0) << 12);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 68 to 83
	value = ((uint32_t)(input[8] & 0x0f) << 28) |
			((uint32_t)input[9] << 20) |
			((uint32_t)(input[10] & 0xf0) << 12);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 84 to 99
	value = ((uint32_t)(input[10] & 0x0f) << 28) |
			((uint32_t)input[11] << 20) |
			((uint32_t)(input[12] & 0xf0) << 12);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 100 to 115
	value = ((uint32_t)(input[12] & 0x0f) << 28) |
			((uint32_t)input[13] << 20) |
			((uint32_t)(input[14] & 0xf0) << 12);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 116 to 131
	value = ((uint32_t)(input[14] & 0x0f) << 28) |
			((uint32_t)input[15] << 20) |
			((uint32_t)(input[16] & 0xf0) << 12);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 132 to 147
	value = ((uint32_t)(input[16] & 0x0f) << 28) |
			((uint32_t)input[17] << 20) |
			((uint32_t)(input[18] & 0xf0) << 12);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 148 to 163
	value = ((uint32_t)(input[18] & 0x0f) << 28) |
			((uint32_t)input[19] << 20) |
			((uint32_t)(input[20] & 0xf0) << 12);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 164 to 179
	value = ((uint32_t)(input[20] & 0x0f) << 28) |
			((uint32_t)input[21] << 20) |
			((uint32_t)(input[22] & 0xf0) << 12);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 180 to 195
	value = ((uint32_t)(input[22] & 0x0f) << 28) |
			((uint32_t)input[23] << 20) |
			((uint32_t)(input[24] & 0xf0) << 12);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 196 to 211
	value = ((uint32_t)(input[24] & 0x0f) << 28) |
			((uint32_t)input[25] << 20) |
			((uint32_t)(input[26] & 0xf0) << 12);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 212 to 227
	value = ((uint32_t)(input[26] & 0x0f) << 28) |
			((uint32_t)input[27] << 20) |
			((uint32_t)(input[28] & 0xf0) << 12);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 228 to 243
	value = ((uint32_t)(input[28] & 0x0f) << 28) |
			((uint32_t)input[29] << 20) |
			((uint32_t)(input[30] & 0xf0) << 12);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 244 to 259
	value = ((uint32_t)(input[30] & 0x0f) << 28) |
			((uint32_t)input[31] << 20) |
			((uint32_t)(input[32] & 0xf0) << 12);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 260 to 275
	value = ((uint32_t)(input[32] & 0x0f) << 28) |
			((uint32_t)input[33] << 20) |
			((uint32_t)(input[34] & 0xf0) << 12);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 276 to 291
	value = ((uint32_t)(input[34] & 0x0f) << 28) |
			((uint32_t)input[35] << 20) |
			((uint32_t)(input[36] & 0xf0) << 12);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 292 to 307
	value = ((uint32_t)(input[36] & 0x0f) << 28) |
			((uint32_t)input[37] << 20) |
			((uint32_t)(input[38] & 0xf0) << 12);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 308 to 323
	value = ((uint32_t)(input[38] & 0x0f) << 28) |
			((uint32_t)input[39] << 20) |
			((uint32_t)(input[40] & 0xf0) << 12);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 324 to 339
	value = ((uint32_t)(input[40] & 0x0f) << 28) |
			((uint32_t)input[41] << 20) |
			((uint32_t)(input[42] & 0xf0) << 12);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 340 to 355
	value = ((uint32_t)(input[42] & 0x0f) << 28) |
			((uint32_t)input[43] << 20) |
			((uint32_t)(input[44] & 0xf0) << 12);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 356 to 371
	value = ((uint32_t)(input[44] & 0x0f) << 28) |
			((uint32_t)input[45] << 20) |
			((uint32_t)(input[46] & 0xf0) << 12);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 372 to 387
	value = ((uint32_t)(input[46] & 0x0f) << 28) |
			((uint32_t)input[47] << 20) |
			((uint32_t)(input[48] & 0xf0) << 12);
	output[23] = (double)(value >> 16);
}

static void unpack_24_16bit_unsigned_4off(const uint8_t * input, double * output, void *closure) {
	// Unpack 24 values into output
	// Values are 16-bit unsigned
	// Skip 4 bits, read 384 bits of data.
	// Input must be at least 49 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 4 to 19
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20) |
			((uint32_t)(input[2] & 0xf0) << 12);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 20 to 35
	value = ((uint32_t)(input[2] & 0x0f) << 28) |
			((uint32_t)input[3] << 20) |
			((uint32_t)(input[4] & 0xf0) << 12);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 36 to 51
	value = ((uint32_t)(input[4] & 0x0f) << 28) |
			((uint32_t)input[5] << 20) |
			((uint32_t)(input[6] & 0xf0) << 12);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 52 to 67
	value = ((uint32_t)(input[6] & 0x0f) << 28) |
			((uint32_t)input[7] << 20) |
			((uint32_t)(input[8] & 0xf0) << 12);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 68 to 83
	value = ((uint32_t)(input[8] & 0x0f) << 28) |
			((uint32_t)input[9] << 20) |
			((uint32_t)(input[10] & 0xf0) << 12);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 84 to 99
	value = ((uint32_t)(input[10] & 0x0f) << 28) |
			((uint32_t)input[11] << 20) |
			((uint32_t)(input[12] & 0xf0) << 12);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 100 to 115
	value = ((uint32_t)(input[12] & 0x0f) << 28) |
			((uint32_t)input[13] << 20) |
			((uint32_t)(input[14] & 0xf0) << 12);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 116 to 131
	value = ((uint32_t)(input[14] & 0x0f) << 28) |
			((uint32_t)input[15] << 20) |
			((uint32_t)(input[16] & 0xf0) << 12);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 132 to 147
	value = ((uint32_t)(input[16] & 0x0f) << 28) |
			((uint32_t)input[17] << 20) |
			((uint32_t)(input[18] & 0xf0) << 12);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 148 to 163
	value = ((uint32_t)(input[18] & 0x0f) << 28) |
			((uint32_t)input[19] << 20) |
			((uint32_t)(input[20] & 0xf0) << 12);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 164 to 179
	value = ((uint32_t)(input[20] & 0x0f) << 28) |
			((uint32_t)input[21] << 20) |
			((uint32_t)(input[22] & 0xf0) << 12);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 180 to 195
	value = ((uint32_t)(input[22] & 0x0f) << 28) |
			((uint32_t)input[23] << 20) |
			((uint32_t)(input[24] & 0xf0) << 12);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 196 to 211
	value = ((uint32_t)(input[24] & 0x0f) << 28) |
			((uint32_t)input[25] << 20) |
			((uint32_t)(input[26] & 0xf0) << 12);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 212 to 227
	value = ((uint32_t)(input[26] & 0x0f) << 28) |
			((uint32_t)input[27] << 20) |
			((uint32_t)(input[28] & 0xf0) << 12);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 228 to 243
	value = ((uint32_t)(input[28] & 0x0f) << 28) |
			((uint32_t)input[29] << 20) |
			((uint32_t)(input[30] & 0xf0) << 12);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 244 to 259
	value = ((uint32_t)(input[30] & 0x0f) << 28) |
			((uint32_t)input[31] << 20) |
			((uint32_t)(input[32] & 0xf0) << 12);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 260 to 275
	value = ((uint32_t)(input[32] & 0x0f) << 28) |
			((uint32_t)input[33] << 20) |
			((uint32_t)(input[34] & 0xf0) << 12);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 276 to 291
	value = ((uint32_t)(input[34] & 0x0f) << 28) |
			((uint32_t)input[35] << 20) |
			((uint32_t)(input[36] & 0xf0) << 12);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 292 to 307
	value = ((uint32_t)(input[36] & 0x0f) << 28) |
			((uint32_t)input[37] << 20) |
			((uint32_t)(input[38] & 0xf0) << 12);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 308 to 323
	value = ((uint32_t)(input[38] & 0x0f) << 28) |
			((uint32_t)input[39] << 20) |
			((uint32_t)(input[40] & 0xf0) << 12);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 324 to 339
	value = ((uint32_t)(input[40] & 0x0f) << 28) |
			((uint32_t)input[41] << 20) |
			((uint32_t)(input[42] & 0xf0) << 12);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 340 to 355
	value = ((uint32_t)(input[42] & 0x0f) << 28) |
			((uint32_t)input[43] << 20) |
			((uint32_t)(input[44] & 0xf0) << 12);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 356 to 371
	value = ((uint32_t)(input[44] & 0x0f) << 28) |
			((uint32_t)input[45] << 20) |
			((uint32_t)(input[46] & 0xf0) << 12);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 372 to 387
	value = ((uint32_t)(input[46] & 0x0f) << 28) |
			((uint32_t)input[47] << 20) |
			((uint32_t)(input[48] & 0xf0) << 12);
	output[23] = (double)(value >> 16);
}

static void unpack_24_16bit_signed_5off(const uint8_t * input, double * output, void *closure) {
	// Unpack 24 values into output
	// Values are 16-bit signed
	// Skip 5 bits, read 384 bits of data.
	// Input must be at least 49 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 5 to 20
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)(input[2] & 0xf8) << 13);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 21 to 36
	value = ((uint32_t)(input[2] & 0x07) << 29) |
			((uint32_t)input[3] << 21) |
			((uint32_t)(input[4] & 0xf8) << 13);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 37 to 52
	value = ((uint32_t)(input[4] & 0x07) << 29) |
			((uint32_t)input[5] << 21) |
			((uint32_t)(input[6] & 0xf8) << 13);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 53 to 68
	value = ((uint32_t)(input[6] & 0x07) << 29) |
			((uint32_t)input[7] << 21) |
			((uint32_t)(input[8] & 0xf8) << 13);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 69 to 84
	value = ((uint32_t)(input[8] & 0x07) << 29) |
			((uint32_t)input[9] << 21) |
			((uint32_t)(input[10] & 0xf8) << 13);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 85 to 100
	value = ((uint32_t)(input[10] & 0x07) << 29) |
			((uint32_t)input[11] << 21) |
			((uint32_t)(input[12] & 0xf8) << 13);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 101 to 116
	value = ((uint32_t)(input[12] & 0x07) << 29) |
			((uint32_t)input[13] << 21) |
			((uint32_t)(input[14] & 0xf8) << 13);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 117 to 132
	value = ((uint32_t)(input[14] & 0x07) << 29) |
			((uint32_t)input[15] << 21) |
			((uint32_t)(input[16] & 0xf8) << 13);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 133 to 148
	value = ((uint32_t)(input[16] & 0x07) << 29) |
			((uint32_t)input[17] << 21) |
			((uint32_t)(input[18] & 0xf8) << 13);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 149 to 164
	value = ((uint32_t)(input[18] & 0x07) << 29) |
			((uint32_t)input[19] << 21) |
			((uint32_t)(input[20] & 0xf8) << 13);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 165 to 180
	value = ((uint32_t)(input[20] & 0x07) << 29) |
			((uint32_t)input[21] << 21) |
			((uint32_t)(input[22] & 0xf8) << 13);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 181 to 196
	value = ((uint32_t)(input[22] & 0x07) << 29) |
			((uint32_t)input[23] << 21) |
			((uint32_t)(input[24] & 0xf8) << 13);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 197 to 212
	value = ((uint32_t)(input[24] & 0x07) << 29) |
			((uint32_t)input[25] << 21) |
			((uint32_t)(input[26] & 0xf8) << 13);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 213 to 228
	value = ((uint32_t)(input[26] & 0x07) << 29) |
			((uint32_t)input[27] << 21) |
			((uint32_t)(input[28] & 0xf8) << 13);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 229 to 244
	value = ((uint32_t)(input[28] & 0x07) << 29) |
			((uint32_t)input[29] << 21) |
			((uint32_t)(input[30] & 0xf8) << 13);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 245 to 260
	value = ((uint32_t)(input[30] & 0x07) << 29) |
			((uint32_t)input[31] << 21) |
			((uint32_t)(input[32] & 0xf8) << 13);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 261 to 276
	value = ((uint32_t)(input[32] & 0x07) << 29) |
			((uint32_t)input[33] << 21) |
			((uint32_t)(input[34] & 0xf8) << 13);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 277 to 292
	value = ((uint32_t)(input[34] & 0x07) << 29) |
			((uint32_t)input[35] << 21) |
			((uint32_t)(input[36] & 0xf8) << 13);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 293 to 308
	value = ((uint32_t)(input[36] & 0x07) << 29) |
			((uint32_t)input[37] << 21) |
			((uint32_t)(input[38] & 0xf8) << 13);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 309 to 324
	value = ((uint32_t)(input[38] & 0x07) << 29) |
			((uint32_t)input[39] << 21) |
			((uint32_t)(input[40] & 0xf8) << 13);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 325 to 340
	value = ((uint32_t)(input[40] & 0x07) << 29) |
			((uint32_t)input[41] << 21) |
			((uint32_t)(input[42] & 0xf8) << 13);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 341 to 356
	value = ((uint32_t)(input[42] & 0x07) << 29) |
			((uint32_t)input[43] << 21) |
			((uint32_t)(input[44] & 0xf8) << 13);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 357 to 372
	value = ((uint32_t)(input[44] & 0x07) << 29) |
			((uint32_t)input[45] << 21) |
			((uint32_t)(input[46] & 0xf8) << 13);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 373 to 388
	value = ((uint32_t)(input[46] & 0x07) << 29) |
			((uint32_t)input[47] << 21) |
			((uint32_t)(input[48] & 0xf8) << 13);
	output[23] = (double)(value >> 16);
}

static void unpack_24_16bit_unsigned_5off(const uint8_t * input, double * output, void *closure) {
	// Unpack 24 values into output
	// Values are 16-bit unsigned
	// Skip 5 bits, read 384 bits of data.
	// Input must be at least 49 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 5 to 20
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)(input[2] & 0xf8) << 13);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 21 to 36
	value = ((uint32_t)(input[2] & 0x07) << 29) |
			((uint32_t)input[3] << 21) |
			((uint32_t)(input[4] & 0xf8) << 13);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 37 to 52
	value = ((uint32_t)(input[4] & 0x07) << 29) |
			((uint32_t)input[5] << 21) |
			((uint32_t)(input[6] & 0xf8) << 13);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 53 to 68
	value = ((uint32_t)(input[6] & 0x07) << 29) |
			((uint32_t)input[7] << 21) |
			((uint32_t)(input[8] & 0xf8) << 13);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 69 to 84
	value = ((uint32_t)(input[8] & 0x07) << 29) |
			((uint32_t)input[9] << 21) |
			((uint32_t)(input[10] & 0xf8) << 13);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 85 to 100
	value = ((uint32_t)(input[10] & 0x07) << 29) |
			((uint32_t)input[11] << 21) |
			((uint32_t)(input[12] & 0xf8) << 13);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 101 to 116
	value = ((uint32_t)(input[12] & 0x07) << 29) |
			((uint32_t)input[13] << 21) |
			((uint32_t)(input[14] & 0xf8) << 13);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 117 to 132
	value = ((uint32_t)(input[14] & 0x07) << 29) |
			((uint32_t)input[15] << 21) |
			((uint32_t)(input[16] & 0xf8) << 13);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 133 to 148
	value = ((uint32_t)(input[16] & 0x07) << 29) |
			((uint32_t)input[17] << 21) |
			((uint32_t)(input[18] & 0xf8) << 13);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 149 to 164
	value = ((uint32_t)(input[18] & 0x07) << 29) |
			((uint32_t)input[19] << 21) |
			((uint32_t)(input[20] & 0xf8) << 13);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 165 to 180
	value = ((uint32_t)(input[20] & 0x07) << 29) |
			((uint32_t)input[21] << 21) |
			((uint32_t)(input[22] & 0xf8) << 13);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 181 to 196
	value = ((uint32_t)(input[22] & 0x07) << 29) |
			((uint32_t)input[23] << 21) |
			((uint32_t)(input[24] & 0xf8) << 13);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 197 to 212
	value = ((uint32_t)(input[24] & 0x07) << 29) |
			((uint32_t)input[25] << 21) |
			((uint32_t)(input[26] & 0xf8) << 13);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 213 to 228
	value = ((uint32_t)(input[26] & 0x07) << 29) |
			((uint32_t)input[27] << 21) |
			((uint32_t)(input[28] & 0xf8) << 13);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 229 to 244
	value = ((uint32_t)(input[28] & 0x07) << 29) |
			((uint32_t)input[29] << 21) |
			((uint32_t)(input[30] & 0xf8) << 13);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 245 to 260
	value = ((uint32_t)(input[30] & 0x07) << 29) |
			((uint32_t)input[31] << 21) |
			((uint32_t)(input[32] & 0xf8) << 13);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 261 to 276
	value = ((uint32_t)(input[32] & 0x07) << 29) |
			((uint32_t)input[33] << 21) |
			((uint32_t)(input[34] & 0xf8) << 13);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 277 to 292
	value = ((uint32_t)(input[34] & 0x07) << 29) |
			((uint32_t)input[35] << 21) |
			((uint32_t)(input[36] & 0xf8) << 13);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 293 to 308
	value = ((uint32_t)(input[36] & 0x07) << 29) |
			((uint32_t)input[37] << 21) |
			((uint32_t)(input[38] & 0xf8) << 13);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 309 to 324
	value = ((uint32_t)(input[38] & 0x07) << 29) |
			((uint32_t)input[39] << 21) |
			((uint32_t)(input[40] & 0xf8) << 13);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 325 to 340
	value = ((uint32_t)(input[40] & 0x07) << 29) |
			((uint32_t)input[41] << 21) |
			((uint32_t)(input[42] & 0xf8) << 13);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 341 to 356
	value = ((uint32_t)(input[42] & 0x07) << 29) |
			((uint32_t)input[43] << 21) |
			((uint32_t)(input[44] & 0xf8) << 13);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 357 to 372
	value = ((uint32_t)(input[44] & 0x07) << 29) |
			((uint32_t)input[45] << 21) |
			((uint32_t)(input[46] & 0xf8) << 13);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 373 to 388
	value = ((uint32_t)(input[46] & 0x07) << 29) |
			((uint32_t)input[47] << 21) |
			((uint32_t)(input[48] & 0xf8) << 13);
	output[23] = (double)(value >> 16);
}

static void unpack_24_16bit_signed_6off(const uint8_t * input, double * output, void *closure) {
	// Unpack 24 values into output
	// Values are 16-bit signed
	// Skip 6 bits, read 384 bits of data.
	// Input must be at least 49 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 6 to 21
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)(input[2] & 0xfc) << 14);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 22 to 37
	value = ((uint32_t)(input[2] & 0x03) << 30) |
			((uint32_t)input[3] << 22) |
			((uint32_t)(input[4] & 0xfc) << 14);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 38 to 53
	value = ((uint32_t)(input[4] & 0x03) << 30) |
			((uint32_t)input[5] << 22) |
			((uint32_t)(input[6] & 0xfc) << 14);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 54 to 69
	value = ((uint32_t)(input[6] & 0x03) << 30) |
			((uint32_t)input[7] << 22) |
			((uint32_t)(input[8] & 0xfc) << 14);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 70 to 85
	value = ((uint32_t)(input[8] & 0x03) << 30) |
			((uint32_t)input[9] << 22) |
			((uint32_t)(input[10] & 0xfc) << 14);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 86 to 101
	value = ((uint32_t)(input[10] & 0x03) << 30) |
			((uint32_t)input[11] << 22) |
			((uint32_t)(input[12] & 0xfc) << 14);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 102 to 117
	value = ((uint32_t)(input[12] & 0x03) << 30) |
			((uint32_t)input[13] << 22) |
			((uint32_t)(input[14] & 0xfc) << 14);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 118 to 133
	value = ((uint32_t)(input[14] & 0x03) << 30) |
			((uint32_t)input[15] << 22) |
			((uint32_t)(input[16] & 0xfc) << 14);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 134 to 149
	value = ((uint32_t)(input[16] & 0x03) << 30) |
			((uint32_t)input[17] << 22) |
			((uint32_t)(input[18] & 0xfc) << 14);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 150 to 165
	value = ((uint32_t)(input[18] & 0x03) << 30) |
			((uint32_t)input[19] << 22) |
			((uint32_t)(input[20] & 0xfc) << 14);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 166 to 181
	value = ((uint32_t)(input[20] & 0x03) << 30) |
			((uint32_t)input[21] << 22) |
			((uint32_t)(input[22] & 0xfc) << 14);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 182 to 197
	value = ((uint32_t)(input[22] & 0x03) << 30) |
			((uint32_t)input[23] << 22) |
			((uint32_t)(input[24] & 0xfc) << 14);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 198 to 213
	value = ((uint32_t)(input[24] & 0x03) << 30) |
			((uint32_t)input[25] << 22) |
			((uint32_t)(input[26] & 0xfc) << 14);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 214 to 229
	value = ((uint32_t)(input[26] & 0x03) << 30) |
			((uint32_t)input[27] << 22) |
			((uint32_t)(input[28] & 0xfc) << 14);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 230 to 245
	value = ((uint32_t)(input[28] & 0x03) << 30) |
			((uint32_t)input[29] << 22) |
			((uint32_t)(input[30] & 0xfc) << 14);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 246 to 261
	value = ((uint32_t)(input[30] & 0x03) << 30) |
			((uint32_t)input[31] << 22) |
			((uint32_t)(input[32] & 0xfc) << 14);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 262 to 277
	value = ((uint32_t)(input[32] & 0x03) << 30) |
			((uint32_t)input[33] << 22) |
			((uint32_t)(input[34] & 0xfc) << 14);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 278 to 293
	value = ((uint32_t)(input[34] & 0x03) << 30) |
			((uint32_t)input[35] << 22) |
			((uint32_t)(input[36] & 0xfc) << 14);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 294 to 309
	value = ((uint32_t)(input[36] & 0x03) << 30) |
			((uint32_t)input[37] << 22) |
			((uint32_t)(input[38] & 0xfc) << 14);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 310 to 325
	value = ((uint32_t)(input[38] & 0x03) << 30) |
			((uint32_t)input[39] << 22) |
			((uint32_t)(input[40] & 0xfc) << 14);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 326 to 341
	value = ((uint32_t)(input[40] & 0x03) << 30) |
			((uint32_t)input[41] << 22) |
			((uint32_t)(input[42] & 0xfc) << 14);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 342 to 357
	value = ((uint32_t)(input[42] & 0x03) << 30) |
			((uint32_t)input[43] << 22) |
			((uint32_t)(input[44] & 0xfc) << 14);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 358 to 373
	value = ((uint32_t)(input[44] & 0x03) << 30) |
			((uint32_t)input[45] << 22) |
			((uint32_t)(input[46] & 0xfc) << 14);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 374 to 389
	value = ((uint32_t)(input[46] & 0x03) << 30) |
			((uint32_t)input[47] << 22) |
			((uint32_t)(input[48] & 0xfc) << 14);
	output[23] = (double)(value >> 16);
}

static void unpack_24_16bit_unsigned_6off(const uint8_t * input, double * output, void *closure) {
	// Unpack 24 values into output
	// Values are 16-bit unsigned
	// Skip 6 bits, read 384 bits of data.
	// Input must be at least 49 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 6 to 21
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)(input[2] & 0xfc) << 14);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 22 to 37
	value = ((uint32_t)(input[2] & 0x03) << 30) |
			((uint32_t)input[3] << 22) |
			((uint32_t)(input[4] & 0xfc) << 14);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 38 to 53
	value = ((uint32_t)(input[4] & 0x03) << 30) |
			((uint32_t)input[5] << 22) |
			((uint32_t)(input[6] & 0xfc) << 14);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 54 to 69
	value = ((uint32_t)(input[6] & 0x03) << 30) |
			((uint32_t)input[7] << 22) |
			((uint32_t)(input[8] & 0xfc) << 14);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 70 to 85
	value = ((uint32_t)(input[8] & 0x03) << 30) |
			((uint32_t)input[9] << 22) |
			((uint32_t)(input[10] & 0xfc) << 14);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 86 to 101
	value = ((uint32_t)(input[10] & 0x03) << 30) |
			((uint32_t)input[11] << 22) |
			((uint32_t)(input[12] & 0xfc) << 14);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 102 to 117
	value = ((uint32_t)(input[12] & 0x03) << 30) |
			((uint32_t)input[13] << 22) |
			((uint32_t)(input[14] & 0xfc) << 14);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 118 to 133
	value = ((uint32_t)(input[14] & 0x03) << 30) |
			((uint32_t)input[15] << 22) |
			((uint32_t)(input[16] & 0xfc) << 14);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 134 to 149
	value = ((uint32_t)(input[16] & 0x03) << 30) |
			((uint32_t)input[17] << 22) |
			((uint32_t)(input[18] & 0xfc) << 14);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 150 to 165
	value = ((uint32_t)(input[18] & 0x03) << 30) |
			((uint32_t)input[19] << 22) |
			((uint32_t)(input[20] & 0xfc) << 14);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 166 to 181
	value = ((uint32_t)(input[20] & 0x03) << 30) |
			((uint32_t)input[21] << 22) |
			((uint32_t)(input[22] & 0xfc) << 14);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 182 to 197
	value = ((uint32_t)(input[22] & 0x03) << 30) |
			((uint32_t)input[23] << 22) |
			((uint32_t)(input[24] & 0xfc) << 14);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 198 to 213
	value = ((uint32_t)(input[24] & 0x03) << 30) |
			((uint32_t)input[25] << 22) |
			((uint32_t)(input[26] & 0xfc) << 14);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 214 to 229
	value = ((uint32_t)(input[26] & 0x03) << 30) |
			((uint32_t)input[27] << 22) |
			((uint32_t)(input[28] & 0xfc) << 14);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 230 to 245
	value = ((uint32_t)(input[28] & 0x03) << 30) |
			((uint32_t)input[29] << 22) |
			((uint32_t)(input[30] & 0xfc) << 14);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 246 to 261
	value = ((uint32_t)(input[30] & 0x03) << 30) |
			((uint32_t)input[31] << 22) |
			((uint32_t)(input[32] & 0xfc) << 14);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 262 to 277
	value = ((uint32_t)(input[32] & 0x03) << 30) |
			((uint32_t)input[33] << 22) |
			((uint32_t)(input[34] & 0xfc) << 14);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 278 to 293
	value = ((uint32_t)(input[34] & 0x03) << 30) |
			((uint32_t)input[35] << 22) |
			((uint32_t)(input[36] & 0xfc) << 14);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 294 to 309
	value = ((uint32_t)(input[36] & 0x03) << 30) |
			((uint32_t)input[37] << 22) |
			((uint32_t)(input[38] & 0xfc) << 14);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 310 to 325
	value = ((uint32_t)(input[38] & 0x03) << 30) |
			((uint32_t)input[39] << 22) |
			((uint32_t)(input[40] & 0xfc) << 14);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 326 to 341
	value = ((uint32_t)(input[40] & 0x03) << 30) |
			((uint32_t)input[41] << 22) |
			((uint32_t)(input[42] & 0xfc) << 14);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 342 to 357
	value = ((uint32_t)(input[42] & 0x03) << 30) |
			((uint32_t)input[43] << 22) |
			((uint32_t)(input[44] & 0xfc) << 14);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 358 to 373
	value = ((uint32_t)(input[44] & 0x03) << 30) |
			((uint32_t)input[45] << 22) |
			((uint32_t)(input[46] & 0xfc) << 14);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 374 to 389
	value = ((uint32_t)(input[46] & 0x03) << 30) |
			((uint32_t)input[47] << 22) |
			((uint32_t)(input[48] & 0xfc) << 14);
	output[23] = (double)(value >> 16);
}

static void unpack_24_16bit_signed_7off(const uint8_t * input, double * output, void *closure) {
	// Unpack 24 values into output
	// Values are 16-bit signed
	// Skip 7 bits, read 384 bits of data.
	// Input must be at least 49 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 7 to 22
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)(input[2] & 0xfe) << 15);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 23 to 38
	value = ((uint32_t)(input[2] & 0x01) << 31) |
			((uint32_t)input[3] << 23) |
			((uint32_t)(input[4] & 0xfe) << 15);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 39 to 54
	value = ((uint32_t)(input[4] & 0x01) << 31) |
			((uint32_t)input[5] << 23) |
			((uint32_t)(input[6] & 0xfe) << 15);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 55 to 70
	value = ((uint32_t)(input[6] & 0x01) << 31) |
			((uint32_t)input[7] << 23) |
			((uint32_t)(input[8] & 0xfe) << 15);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 71 to 86
	value = ((uint32_t)(input[8] & 0x01) << 31) |
			((uint32_t)input[9] << 23) |
			((uint32_t)(input[10] & 0xfe) << 15);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 87 to 102
	value = ((uint32_t)(input[10] & 0x01) << 31) |
			((uint32_t)input[11] << 23) |
			((uint32_t)(input[12] & 0xfe) << 15);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 103 to 118
	value = ((uint32_t)(input[12] & 0x01) << 31) |
			((uint32_t)input[13] << 23) |
			((uint32_t)(input[14] & 0xfe) << 15);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 119 to 134
	value = ((uint32_t)(input[14] & 0x01) << 31) |
			((uint32_t)input[15] << 23) |
			((uint32_t)(input[16] & 0xfe) << 15);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 135 to 150
	value = ((uint32_t)(input[16] & 0x01) << 31) |
			((uint32_t)input[17] << 23) |
			((uint32_t)(input[18] & 0xfe) << 15);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 151 to 166
	value = ((uint32_t)(input[18] & 0x01) << 31) |
			((uint32_t)input[19] << 23) |
			((uint32_t)(input[20] & 0xfe) << 15);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 167 to 182
	value = ((uint32_t)(input[20] & 0x01) << 31) |
			((uint32_t)input[21] << 23) |
			((uint32_t)(input[22] & 0xfe) << 15);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 183 to 198
	value = ((uint32_t)(input[22] & 0x01) << 31) |
			((uint32_t)input[23] << 23) |
			((uint32_t)(input[24] & 0xfe) << 15);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 199 to 214
	value = ((uint32_t)(input[24] & 0x01) << 31) |
			((uint32_t)input[25] << 23) |
			((uint32_t)(input[26] & 0xfe) << 15);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 215 to 230
	value = ((uint32_t)(input[26] & 0x01) << 31) |
			((uint32_t)input[27] << 23) |
			((uint32_t)(input[28] & 0xfe) << 15);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 231 to 246
	value = ((uint32_t)(input[28] & 0x01) << 31) |
			((uint32_t)input[29] << 23) |
			((uint32_t)(input[30] & 0xfe) << 15);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 247 to 262
	value = ((uint32_t)(input[30] & 0x01) << 31) |
			((uint32_t)input[31] << 23) |
			((uint32_t)(input[32] & 0xfe) << 15);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 263 to 278
	value = ((uint32_t)(input[32] & 0x01) << 31) |
			((uint32_t)input[33] << 23) |
			((uint32_t)(input[34] & 0xfe) << 15);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 279 to 294
	value = ((uint32_t)(input[34] & 0x01) << 31) |
			((uint32_t)input[35] << 23) |
			((uint32_t)(input[36] & 0xfe) << 15);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 295 to 310
	value = ((uint32_t)(input[36] & 0x01) << 31) |
			((uint32_t)input[37] << 23) |
			((uint32_t)(input[38] & 0xfe) << 15);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 311 to 326
	value = ((uint32_t)(input[38] & 0x01) << 31) |
			((uint32_t)input[39] << 23) |
			((uint32_t)(input[40] & 0xfe) << 15);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 327 to 342
	value = ((uint32_t)(input[40] & 0x01) << 31) |
			((uint32_t)input[41] << 23) |
			((uint32_t)(input[42] & 0xfe) << 15);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 343 to 358
	value = ((uint32_t)(input[42] & 0x01) << 31) |
			((uint32_t)input[43] << 23) |
			((uint32_t)(input[44] & 0xfe) << 15);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 359 to 374
	value = ((uint32_t)(input[44] & 0x01) << 31) |
			((uint32_t)input[45] << 23) |
			((uint32_t)(input[46] & 0xfe) << 15);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 375 to 390
	value = ((uint32_t)(input[46] & 0x01) << 31) |
			((uint32_t)input[47] << 23) |
			((uint32_t)(input[48] & 0xfe) << 15);
	output[23] = (double)(value >> 16);
}

static void unpack_24_16bit_unsigned_7off(const uint8_t * input, double * output, void *closure) {
	// Unpack 24 values into output
	// Values are 16-bit unsigned
	// Skip 7 bits, read 384 bits of data.
	// Input must be at least 49 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 7 to 22
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)(input[2] & 0xfe) << 15);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 23 to 38
	value = ((uint32_t)(input[2] & 0x01) << 31) |
			((uint32_t)input[3] << 23) |
			((uint32_t)(input[4] & 0xfe) << 15);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 39 to 54
	value = ((uint32_t)(input[4] & 0x01) << 31) |
			((uint32_t)input[5] << 23) |
			((uint32_t)(input[6] & 0xfe) << 15);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 55 to 70
	value = ((uint32_t)(input[6] & 0x01) << 31) |
			((uint32_t)input[7] << 23) |
			((uint32_t)(input[8] & 0xfe) << 15);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 71 to 86
	value = ((uint32_t)(input[8] & 0x01) << 31) |
			((uint32_t)input[9] << 23) |
			((uint32_t)(input[10] & 0xfe) << 15);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 87 to 102
	value = ((uint32_t)(input[10] & 0x01) << 31) |
			((uint32_t)input[11] << 23) |
			((uint32_t)(input[12] & 0xfe) << 15);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 103 to 118
	value = ((uint32_t)(input[12] & 0x01) << 31) |
			((uint32_t)input[13] << 23) |
			((uint32_t)(input[14] & 0xfe) << 15);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 119 to 134
	value = ((uint32_t)(input[14] & 0x01) << 31) |
			((uint32_t)input[15] << 23) |
			((uint32_t)(input[16] & 0xfe) << 15);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 135 to 150
	value = ((uint32_t)(input[16] & 0x01) << 31) |
			((uint32_t)input[17] << 23) |
			((uint32_t)(input[18] & 0xfe) << 15);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 151 to 166
	value = ((uint32_t)(input[18] & 0x01) << 31) |
			((uint32_t)input[19] << 23) |
			((uint32_t)(input[20] & 0xfe) << 15);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 167 to 182
	value = ((uint32_t)(input[20] & 0x01) << 31) |
			((uint32_t)input[21] << 23) |
			((uint32_t)(input[22] & 0xfe) << 15);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 183 to 198
	value = ((uint32_t)(input[22] & 0x01) << 31) |
			((uint32_t)input[23] << 23) |
			((uint32_t)(input[24] & 0xfe) << 15);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 199 to 214
	value = ((uint32_t)(input[24] & 0x01) << 31) |
			((uint32_t)input[25] << 23) |
			((uint32_t)(input[26] & 0xfe) << 15);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 215 to 230
	value = ((uint32_t)(input[26] & 0x01) << 31) |
			((uint32_t)input[27] << 23) |
			((uint32_t)(input[28] & 0xfe) << 15);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 231 to 246
	value = ((uint32_t)(input[28] & 0x01) << 31) |
			((uint32_t)input[29] << 23) |
			((uint32_t)(input[30] & 0xfe) << 15);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 247 to 262
	value = ((uint32_t)(input[30] & 0x01) << 31) |
			((uint32_t)input[31] << 23) |
			((uint32_t)(input[32] & 0xfe) << 15);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 263 to 278
	value = ((uint32_t)(input[32] & 0x01) << 31) |
			((uint32_t)input[33] << 23) |
			((uint32_t)(input[34] & 0xfe) << 15);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 279 to 294
	value = ((uint32_t)(input[34] & 0x01) << 31) |
			((uint32_t)input[35] << 23) |
			((uint32_t)(input[36] & 0xfe) << 15);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 295 to 310
	value = ((uint32_t)(input[36] & 0x01) << 31) |
			((uint32_t)input[37] << 23) |
			((uint32_t)(input[38] & 0xfe) << 15);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 311 to 326
	value = ((uint32_t)(input[38] & 0x01) << 31) |
			((uint32_t)input[39] << 23) |
			((uint32_t)(input[40] & 0xfe) << 15);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 327 to 342
	value = ((uint32_t)(input[40] & 0x01) << 31) |
			((uint32_t)input[41] << 23) |
			((uint32_t)(input[42] & 0xfe) << 15);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 343 to 358
	value = ((uint32_t)(input[42] & 0x01) << 31) |
			((uint32_t)input[43] << 23) |
			((uint32_t)(input[44] & 0xfe) << 15);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 359 to 374
	value = ((uint32_t)(input[44] & 0x01) << 31) |
			((uint32_t)input[45] << 23) |
			((uint32_t)(input[46] & 0xfe) << 15);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 375 to 390
	value = ((uint32_t)(input[46] & 0x01) << 31) |
			((uint32_t)input[47] << 23) |
			((uint32_t)(input[48] & 0xfe) << 15);
	output[23] = (double)(value >> 16);
}

static void unpack_25_16bit_signed_0off(const uint8_t * input, double * output, void *closure) {
	// Unpack 25 values into output
	// Values are 16-bit signed
	// Skip 0 bits, read 400 bits of data.
	// Input must be at least 50 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 0 to 15
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)input[1] << 16);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 16 to 31
	value = ((uint32_t)input[2] << 24) |
			((uint32_t)input[3] << 16);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 32 to 47
	value = ((uint32_t)input[4] << 24) |
			((uint32_t)input[5] << 16);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 48 to 63
	value = ((uint32_t)input[6] << 24) |
			((uint32_t)input[7] << 16);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 64 to 79
	value = ((uint32_t)input[8] << 24) |
			((uint32_t)input[9] << 16);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 80 to 95
	value = ((uint32_t)input[10] << 24) |
			((uint32_t)input[11] << 16);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 96 to 111
	value = ((uint32_t)input[12] << 24) |
			((uint32_t)input[13] << 16);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 112 to 127
	value = ((uint32_t)input[14] << 24) |
			((uint32_t)input[15] << 16);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 128 to 143
	value = ((uint32_t)input[16] << 24) |
			((uint32_t)input[17] << 16);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 144 to 159
	value = ((uint32_t)input[18] << 24) |
			((uint32_t)input[19] << 16);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 160 to 175
	value = ((uint32_t)input[20] << 24) |
			((uint32_t)input[21] << 16);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 176 to 191
	value = ((uint32_t)input[22] << 24) |
			((uint32_t)input[23] << 16);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 192 to 207
	value = ((uint32_t)input[24] << 24) |
			((uint32_t)input[25] << 16);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 208 to 223
	value = ((uint32_t)input[26] << 24) |
			((uint32_t)input[27] << 16);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 224 to 239
	value = ((uint32_t)input[28] << 24) |
			((uint32_t)input[29] << 16);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 240 to 255
	value = ((uint32_t)input[30] << 24) |
			((uint32_t)input[31] << 16);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 256 to 271
	value = ((uint32_t)input[32] << 24) |
			((uint32_t)input[33] << 16);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 272 to 287
	value = ((uint32_t)input[34] << 24) |
			((uint32_t)input[35] << 16);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 288 to 303
	value = ((uint32_t)input[36] << 24) |
			((uint32_t)input[37] << 16);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 304 to 319
	value = ((uint32_t)input[38] << 24) |
			((uint32_t)input[39] << 16);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 320 to 335
	value = ((uint32_t)input[40] << 24) |
			((uint32_t)input[41] << 16);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 336 to 351
	value = ((uint32_t)input[42] << 24) |
			((uint32_t)input[43] << 16);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 352 to 367
	value = ((uint32_t)input[44] << 24) |
			((uint32_t)input[45] << 16);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 368 to 383
	value = ((uint32_t)input[46] << 24) |
			((uint32_t)input[47] << 16);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 384 to 399
	value = ((uint32_t)input[48] << 24) |
			((uint32_t)input[49] << 16);
	output[24] = (double)(value >> 16);
}

static void unpack_25_16bit_unsigned_0off(const uint8_t * input, double * output, void *closure) {
	// Unpack 25 values into output
	// Values are 16-bit unsigned
	// Skip 0 bits, read 400 bits of data.
	// Input must be at least 50 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 0 to 15
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)input[1] << 16);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 16 to 31
	value = ((uint32_t)input[2] << 24) |
			((uint32_t)input[3] << 16);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 32 to 47
	value = ((uint32_t)input[4] << 24) |
			((uint32_t)input[5] << 16);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 48 to 63
	value = ((uint32_t)input[6] << 24) |
			((uint32_t)input[7] << 16);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 64 to 79
	value = ((uint32_t)input[8] << 24) |
			((uint32_t)input[9] << 16);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 80 to 95
	value = ((uint32_t)input[10] << 24) |
			((uint32_t)input[11] << 16);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 96 to 111
	value = ((uint32_t)input[12] << 24) |
			((uint32_t)input[13] << 16);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 112 to 127
	value = ((uint32_t)input[14] << 24) |
			((uint32_t)input[15] << 16);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 128 to 143
	value = ((uint32_t)input[16] << 24) |
			((uint32_t)input[17] << 16);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 144 to 159
	value = ((uint32_t)input[18] << 24) |
			((uint32_t)input[19] << 16);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 160 to 175
	value = ((uint32_t)input[20] << 24) |
			((uint32_t)input[21] << 16);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 176 to 191
	value = ((uint32_t)input[22] << 24) |
			((uint32_t)input[23] << 16);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 192 to 207
	value = ((uint32_t)input[24] << 24) |
			((uint32_t)input[25] << 16);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 208 to 223
	value = ((uint32_t)input[26] << 24) |
			((uint32_t)input[27] << 16);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 224 to 239
	value = ((uint32_t)input[28] << 24) |
			((uint32_t)input[29] << 16);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 240 to 255
	value = ((uint32_t)input[30] << 24) |
			((uint32_t)input[31] << 16);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 256 to 271
	value = ((uint32_t)input[32] << 24) |
			((uint32_t)input[33] << 16);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 272 to 287
	value = ((uint32_t)input[34] << 24) |
			((uint32_t)input[35] << 16);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 288 to 303
	value = ((uint32_t)input[36] << 24) |
			((uint32_t)input[37] << 16);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 304 to 319
	value = ((uint32_t)input[38] << 24) |
			((uint32_t)input[39] << 16);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 320 to 335
	value = ((uint32_t)input[40] << 24) |
			((uint32_t)input[41] << 16);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 336 to 351
	value = ((uint32_t)input[42] << 24) |
			((uint32_t)input[43] << 16);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 352 to 367
	value = ((uint32_t)input[44] << 24) |
			((uint32_t)input[45] << 16);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 368 to 383
	value = ((uint32_t)input[46] << 24) |
			((uint32_t)input[47] << 16);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 384 to 399
	value = ((uint32_t)input[48] << 24) |
			((uint32_t)input[49] << 16);
	output[24] = (double)(value >> 16);
}

static void unpack_25_16bit_signed_1off(const uint8_t * input, double * output, void *closure) {
	// Unpack 25 values into output
	// Values are 16-bit signed
	// Skip 1 bits, read 400 bits of data.
	// Input must be at least 51 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 1 to 16
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)input[1] << 17) |
			((uint32_t)(input[2] & 0x80) << 9);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 17 to 32
	value = ((uint32_t)(input[2] & 0x7f) << 25) |
			((uint32_t)input[3] << 17) |
			((uint32_t)(input[4] & 0x80) << 9);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 33 to 48
	value = ((uint32_t)(input[4] & 0x7f) << 25) |
			((uint32_t)input[5] << 17) |
			((uint32_t)(input[6] & 0x80) << 9);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 49 to 64
	value = ((uint32_t)(input[6] & 0x7f) << 25) |
			((uint32_t)input[7] << 17) |
			((uint32_t)(input[8] & 0x80) << 9);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 65 to 80
	value = ((uint32_t)(input[8] & 0x7f) << 25) |
			((uint32_t)input[9] << 17) |
			((uint32_t)(input[10] & 0x80) << 9);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 81 to 96
	value = ((uint32_t)(input[10] & 0x7f) << 25) |
			((uint32_t)input[11] << 17) |
			((uint32_t)(input[12] & 0x80) << 9);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 97 to 112
	value = ((uint32_t)(input[12] & 0x7f) << 25) |
			((uint32_t)input[13] << 17) |
			((uint32_t)(input[14] & 0x80) << 9);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 113 to 128
	value = ((uint32_t)(input[14] & 0x7f) << 25) |
			((uint32_t)input[15] << 17) |
			((uint32_t)(input[16] & 0x80) << 9);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 129 to 144
	value = ((uint32_t)(input[16] & 0x7f) << 25) |
			((uint32_t)input[17] << 17) |
			((uint32_t)(input[18] & 0x80) << 9);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 145 to 160
	value = ((uint32_t)(input[18] & 0x7f) << 25) |
			((uint32_t)input[19] << 17) |
			((uint32_t)(input[20] & 0x80) << 9);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 161 to 176
	value = ((uint32_t)(input[20] & 0x7f) << 25) |
			((uint32_t)input[21] << 17) |
			((uint32_t)(input[22] & 0x80) << 9);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 177 to 192
	value = ((uint32_t)(input[22] & 0x7f) << 25) |
			((uint32_t)input[23] << 17) |
			((uint32_t)(input[24] & 0x80) << 9);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 193 to 208
	value = ((uint32_t)(input[24] & 0x7f) << 25) |
			((uint32_t)input[25] << 17) |
			((uint32_t)(input[26] & 0x80) << 9);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 209 to 224
	value = ((uint32_t)(input[26] & 0x7f) << 25) |
			((uint32_t)input[27] << 17) |
			((uint32_t)(input[28] & 0x80) << 9);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 225 to 240
	value = ((uint32_t)(input[28] & 0x7f) << 25) |
			((uint32_t)input[29] << 17) |
			((uint32_t)(input[30] & 0x80) << 9);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 241 to 256
	value = ((uint32_t)(input[30] & 0x7f) << 25) |
			((uint32_t)input[31] << 17) |
			((uint32_t)(input[32] & 0x80) << 9);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 257 to 272
	value = ((uint32_t)(input[32] & 0x7f) << 25) |
			((uint32_t)input[33] << 17) |
			((uint32_t)(input[34] & 0x80) << 9);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 273 to 288
	value = ((uint32_t)(input[34] & 0x7f) << 25) |
			((uint32_t)input[35] << 17) |
			((uint32_t)(input[36] & 0x80) << 9);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 289 to 304
	value = ((uint32_t)(input[36] & 0x7f) << 25) |
			((uint32_t)input[37] << 17) |
			((uint32_t)(input[38] & 0x80) << 9);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 305 to 320
	value = ((uint32_t)(input[38] & 0x7f) << 25) |
			((uint32_t)input[39] << 17) |
			((uint32_t)(input[40] & 0x80) << 9);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 321 to 336
	value = ((uint32_t)(input[40] & 0x7f) << 25) |
			((uint32_t)input[41] << 17) |
			((uint32_t)(input[42] & 0x80) << 9);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 337 to 352
	value = ((uint32_t)(input[42] & 0x7f) << 25) |
			((uint32_t)input[43] << 17) |
			((uint32_t)(input[44] & 0x80) << 9);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 353 to 368
	value = ((uint32_t)(input[44] & 0x7f) << 25) |
			((uint32_t)input[45] << 17) |
			((uint32_t)(input[46] & 0x80) << 9);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 369 to 384
	value = ((uint32_t)(input[46] & 0x7f) << 25) |
			((uint32_t)input[47] << 17) |
			((uint32_t)(input[48] & 0x80) << 9);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 385 to 400
	value = ((uint32_t)(input[48] & 0x7f) << 25) |
			((uint32_t)input[49] << 17) |
			((uint32_t)(input[50] & 0x80) << 9);
	output[24] = (double)(value >> 16);
}

static void unpack_25_16bit_unsigned_1off(const uint8_t * input, double * output, void *closure) {
	// Unpack 25 values into output
	// Values are 16-bit unsigned
	// Skip 1 bits, read 400 bits of data.
	// Input must be at least 51 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 1 to 16
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)input[1] << 17) |
			((uint32_t)(input[2] & 0x80) << 9);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 17 to 32
	value = ((uint32_t)(input[2] & 0x7f) << 25) |
			((uint32_t)input[3] << 17) |
			((uint32_t)(input[4] & 0x80) << 9);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 33 to 48
	value = ((uint32_t)(input[4] & 0x7f) << 25) |
			((uint32_t)input[5] << 17) |
			((uint32_t)(input[6] & 0x80) << 9);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 49 to 64
	value = ((uint32_t)(input[6] & 0x7f) << 25) |
			((uint32_t)input[7] << 17) |
			((uint32_t)(input[8] & 0x80) << 9);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 65 to 80
	value = ((uint32_t)(input[8] & 0x7f) << 25) |
			((uint32_t)input[9] << 17) |
			((uint32_t)(input[10] & 0x80) << 9);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 81 to 96
	value = ((uint32_t)(input[10] & 0x7f) << 25) |
			((uint32_t)input[11] << 17) |
			((uint32_t)(input[12] & 0x80) << 9);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 97 to 112
	value = ((uint32_t)(input[12] & 0x7f) << 25) |
			((uint32_t)input[13] << 17) |
			((uint32_t)(input[14] & 0x80) << 9);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 113 to 128
	value = ((uint32_t)(input[14] & 0x7f) << 25) |
			((uint32_t)input[15] << 17) |
			((uint32_t)(input[16] & 0x80) << 9);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 129 to 144
	value = ((uint32_t)(input[16] & 0x7f) << 25) |
			((uint32_t)input[17] << 17) |
			((uint32_t)(input[18] & 0x80) << 9);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 145 to 160
	value = ((uint32_t)(input[18] & 0x7f) << 25) |
			((uint32_t)input[19] << 17) |
			((uint32_t)(input[20] & 0x80) << 9);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 161 to 176
	value = ((uint32_t)(input[20] & 0x7f) << 25) |
			((uint32_t)input[21] << 17) |
			((uint32_t)(input[22] & 0x80) << 9);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 177 to 192
	value = ((uint32_t)(input[22] & 0x7f) << 25) |
			((uint32_t)input[23] << 17) |
			((uint32_t)(input[24] & 0x80) << 9);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 193 to 208
	value = ((uint32_t)(input[24] & 0x7f) << 25) |
			((uint32_t)input[25] << 17) |
			((uint32_t)(input[26] & 0x80) << 9);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 209 to 224
	value = ((uint32_t)(input[26] & 0x7f) << 25) |
			((uint32_t)input[27] << 17) |
			((uint32_t)(input[28] & 0x80) << 9);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 225 to 240
	value = ((uint32_t)(input[28] & 0x7f) << 25) |
			((uint32_t)input[29] << 17) |
			((uint32_t)(input[30] & 0x80) << 9);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 241 to 256
	value = ((uint32_t)(input[30] & 0x7f) << 25) |
			((uint32_t)input[31] << 17) |
			((uint32_t)(input[32] & 0x80) << 9);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 257 to 272
	value = ((uint32_t)(input[32] & 0x7f) << 25) |
			((uint32_t)input[33] << 17) |
			((uint32_t)(input[34] & 0x80) << 9);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 273 to 288
	value = ((uint32_t)(input[34] & 0x7f) << 25) |
			((uint32_t)input[35] << 17) |
			((uint32_t)(input[36] & 0x80) << 9);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 289 to 304
	value = ((uint32_t)(input[36] & 0x7f) << 25) |
			((uint32_t)input[37] << 17) |
			((uint32_t)(input[38] & 0x80) << 9);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 305 to 320
	value = ((uint32_t)(input[38] & 0x7f) << 25) |
			((uint32_t)input[39] << 17) |
			((uint32_t)(input[40] & 0x80) << 9);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 321 to 336
	value = ((uint32_t)(input[40] & 0x7f) << 25) |
			((uint32_t)input[41] << 17) |
			((uint32_t)(input[42] & 0x80) << 9);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 337 to 352
	value = ((uint32_t)(input[42] & 0x7f) << 25) |
			((uint32_t)input[43] << 17) |
			((uint32_t)(input[44] & 0x80) << 9);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 353 to 368
	value = ((uint32_t)(input[44] & 0x7f) << 25) |
			((uint32_t)input[45] << 17) |
			((uint32_t)(input[46] & 0x80) << 9);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 369 to 384
	value = ((uint32_t)(input[46] & 0x7f) << 25) |
			((uint32_t)input[47] << 17) |
			((uint32_t)(input[48] & 0x80) << 9);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 385 to 400
	value = ((uint32_t)(input[48] & 0x7f) << 25) |
			((uint32_t)input[49] << 17) |
			((uint32_t)(input[50] & 0x80) << 9);
	output[24] = (double)(value >> 16);
}

static void unpack_25_16bit_signed_2off(const uint8_t * input, double * output, void *closure) {
	// Unpack 25 values into output
	// Values are 16-bit signed
	// Skip 2 bits, read 400 bits of data.
	// Input must be at least 51 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 2 to 17
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)input[1] << 18) |
			((uint32_t)(input[2] & 0xc0) << 10);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 18 to 33
	value = ((uint32_t)(input[2] & 0x3f) << 26) |
			((uint32_t)input[3] << 18) |
			((uint32_t)(input[4] & 0xc0) << 10);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 34 to 49
	value = ((uint32_t)(input[4] & 0x3f) << 26) |
			((uint32_t)input[5] << 18) |
			((uint32_t)(input[6] & 0xc0) << 10);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 50 to 65
	value = ((uint32_t)(input[6] & 0x3f) << 26) |
			((uint32_t)input[7] << 18) |
			((uint32_t)(input[8] & 0xc0) << 10);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 66 to 81
	value = ((uint32_t)(input[8] & 0x3f) << 26) |
			((uint32_t)input[9] << 18) |
			((uint32_t)(input[10] & 0xc0) << 10);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 82 to 97
	value = ((uint32_t)(input[10] & 0x3f) << 26) |
			((uint32_t)input[11] << 18) |
			((uint32_t)(input[12] & 0xc0) << 10);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 98 to 113
	value = ((uint32_t)(input[12] & 0x3f) << 26) |
			((uint32_t)input[13] << 18) |
			((uint32_t)(input[14] & 0xc0) << 10);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 114 to 129
	value = ((uint32_t)(input[14] & 0x3f) << 26) |
			((uint32_t)input[15] << 18) |
			((uint32_t)(input[16] & 0xc0) << 10);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 130 to 145
	value = ((uint32_t)(input[16] & 0x3f) << 26) |
			((uint32_t)input[17] << 18) |
			((uint32_t)(input[18] & 0xc0) << 10);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 146 to 161
	value = ((uint32_t)(input[18] & 0x3f) << 26) |
			((uint32_t)input[19] << 18) |
			((uint32_t)(input[20] & 0xc0) << 10);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 162 to 177
	value = ((uint32_t)(input[20] & 0x3f) << 26) |
			((uint32_t)input[21] << 18) |
			((uint32_t)(input[22] & 0xc0) << 10);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 178 to 193
	value = ((uint32_t)(input[22] & 0x3f) << 26) |
			((uint32_t)input[23] << 18) |
			((uint32_t)(input[24] & 0xc0) << 10);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 194 to 209
	value = ((uint32_t)(input[24] & 0x3f) << 26) |
			((uint32_t)input[25] << 18) |
			((uint32_t)(input[26] & 0xc0) << 10);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 210 to 225
	value = ((uint32_t)(input[26] & 0x3f) << 26) |
			((uint32_t)input[27] << 18) |
			((uint32_t)(input[28] & 0xc0) << 10);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 226 to 241
	value = ((uint32_t)(input[28] & 0x3f) << 26) |
			((uint32_t)input[29] << 18) |
			((uint32_t)(input[30] & 0xc0) << 10);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 242 to 257
	value = ((uint32_t)(input[30] & 0x3f) << 26) |
			((uint32_t)input[31] << 18) |
			((uint32_t)(input[32] & 0xc0) << 10);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 258 to 273
	value = ((uint32_t)(input[32] & 0x3f) << 26) |
			((uint32_t)input[33] << 18) |
			((uint32_t)(input[34] & 0xc0) << 10);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 274 to 289
	value = ((uint32_t)(input[34] & 0x3f) << 26) |
			((uint32_t)input[35] << 18) |
			((uint32_t)(input[36] & 0xc0) << 10);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 290 to 305
	value = ((uint32_t)(input[36] & 0x3f) << 26) |
			((uint32_t)input[37] << 18) |
			((uint32_t)(input[38] & 0xc0) << 10);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 306 to 321
	value = ((uint32_t)(input[38] & 0x3f) << 26) |
			((uint32_t)input[39] << 18) |
			((uint32_t)(input[40] & 0xc0) << 10);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 322 to 337
	value = ((uint32_t)(input[40] & 0x3f) << 26) |
			((uint32_t)input[41] << 18) |
			((uint32_t)(input[42] & 0xc0) << 10);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 338 to 353
	value = ((uint32_t)(input[42] & 0x3f) << 26) |
			((uint32_t)input[43] << 18) |
			((uint32_t)(input[44] & 0xc0) << 10);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 354 to 369
	value = ((uint32_t)(input[44] & 0x3f) << 26) |
			((uint32_t)input[45] << 18) |
			((uint32_t)(input[46] & 0xc0) << 10);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 370 to 385
	value = ((uint32_t)(input[46] & 0x3f) << 26) |
			((uint32_t)input[47] << 18) |
			((uint32_t)(input[48] & 0xc0) << 10);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 386 to 401
	value = ((uint32_t)(input[48] & 0x3f) << 26) |
			((uint32_t)input[49] << 18) |
			((uint32_t)(input[50] & 0xc0) << 10);
	output[24] = (double)(value >> 16);
}

static void unpack_25_16bit_unsigned_2off(const uint8_t * input, double * output, void *closure) {
	// Unpack 25 values into output
	// Values are 16-bit unsigned
	// Skip 2 bits, read 400 bits of data.
	// Input must be at least 51 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 2 to 17
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)input[1] << 18) |
			((uint32_t)(input[2] & 0xc0) << 10);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 18 to 33
	value = ((uint32_t)(input[2] & 0x3f) << 26) |
			((uint32_t)input[3] << 18) |
			((uint32_t)(input[4] & 0xc0) << 10);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 34 to 49
	value = ((uint32_t)(input[4] & 0x3f) << 26) |
			((uint32_t)input[5] << 18) |
			((uint32_t)(input[6] & 0xc0) << 10);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 50 to 65
	value = ((uint32_t)(input[6] & 0x3f) << 26) |
			((uint32_t)input[7] << 18) |
			((uint32_t)(input[8] & 0xc0) << 10);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 66 to 81
	value = ((uint32_t)(input[8] & 0x3f) << 26) |
			((uint32_t)input[9] << 18) |
			((uint32_t)(input[10] & 0xc0) << 10);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 82 to 97
	value = ((uint32_t)(input[10] & 0x3f) << 26) |
			((uint32_t)input[11] << 18) |
			((uint32_t)(input[12] & 0xc0) << 10);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 98 to 113
	value = ((uint32_t)(input[12] & 0x3f) << 26) |
			((uint32_t)input[13] << 18) |
			((uint32_t)(input[14] & 0xc0) << 10);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 114 to 129
	value = ((uint32_t)(input[14] & 0x3f) << 26) |
			((uint32_t)input[15] << 18) |
			((uint32_t)(input[16] & 0xc0) << 10);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 130 to 145
	value = ((uint32_t)(input[16] & 0x3f) << 26) |
			((uint32_t)input[17] << 18) |
			((uint32_t)(input[18] & 0xc0) << 10);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 146 to 161
	value = ((uint32_t)(input[18] & 0x3f) << 26) |
			((uint32_t)input[19] << 18) |
			((uint32_t)(input[20] & 0xc0) << 10);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 162 to 177
	value = ((uint32_t)(input[20] & 0x3f) << 26) |
			((uint32_t)input[21] << 18) |
			((uint32_t)(input[22] & 0xc0) << 10);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 178 to 193
	value = ((uint32_t)(input[22] & 0x3f) << 26) |
			((uint32_t)input[23] << 18) |
			((uint32_t)(input[24] & 0xc0) << 10);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 194 to 209
	value = ((uint32_t)(input[24] & 0x3f) << 26) |
			((uint32_t)input[25] << 18) |
			((uint32_t)(input[26] & 0xc0) << 10);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 210 to 225
	value = ((uint32_t)(input[26] & 0x3f) << 26) |
			((uint32_t)input[27] << 18) |
			((uint32_t)(input[28] & 0xc0) << 10);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 226 to 241
	value = ((uint32_t)(input[28] & 0x3f) << 26) |
			((uint32_t)input[29] << 18) |
			((uint32_t)(input[30] & 0xc0) << 10);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 242 to 257
	value = ((uint32_t)(input[30] & 0x3f) << 26) |
			((uint32_t)input[31] << 18) |
			((uint32_t)(input[32] & 0xc0) << 10);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 258 to 273
	value = ((uint32_t)(input[32] & 0x3f) << 26) |
			((uint32_t)input[33] << 18) |
			((uint32_t)(input[34] & 0xc0) << 10);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 274 to 289
	value = ((uint32_t)(input[34] & 0x3f) << 26) |
			((uint32_t)input[35] << 18) |
			((uint32_t)(input[36] & 0xc0) << 10);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 290 to 305
	value = ((uint32_t)(input[36] & 0x3f) << 26) |
			((uint32_t)input[37] << 18) |
			((uint32_t)(input[38] & 0xc0) << 10);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 306 to 321
	value = ((uint32_t)(input[38] & 0x3f) << 26) |
			((uint32_t)input[39] << 18) |
			((uint32_t)(input[40] & 0xc0) << 10);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 322 to 337
	value = ((uint32_t)(input[40] & 0x3f) << 26) |
			((uint32_t)input[41] << 18) |
			((uint32_t)(input[42] & 0xc0) << 10);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 338 to 353
	value = ((uint32_t)(input[42] & 0x3f) << 26) |
			((uint32_t)input[43] << 18) |
			((uint32_t)(input[44] & 0xc0) << 10);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 354 to 369
	value = ((uint32_t)(input[44] & 0x3f) << 26) |
			((uint32_t)input[45] << 18) |
			((uint32_t)(input[46] & 0xc0) << 10);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 370 to 385
	value = ((uint32_t)(input[46] & 0x3f) << 26) |
			((uint32_t)input[47] << 18) |
			((uint32_t)(input[48] & 0xc0) << 10);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 386 to 401
	value = ((uint32_t)(input[48] & 0x3f) << 26) |
			((uint32_t)input[49] << 18) |
			((uint32_t)(input[50] & 0xc0) << 10);
	output[24] = (double)(value >> 16);
}

static void unpack_25_16bit_signed_3off(const uint8_t * input, double * output, void *closure) {
	// Unpack 25 values into output
	// Values are 16-bit signed
	// Skip 3 bits, read 400 bits of data.
	// Input must be at least 51 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 3 to 18
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)input[1] << 19) |
			((uint32_t)(input[2] & 0xe0) << 11);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 19 to 34
	value = ((uint32_t)(input[2] & 0x1f) << 27) |
			((uint32_t)input[3] << 19) |
			((uint32_t)(input[4] & 0xe0) << 11);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 35 to 50
	value = ((uint32_t)(input[4] & 0x1f) << 27) |
			((uint32_t)input[5] << 19) |
			((uint32_t)(input[6] & 0xe0) << 11);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 51 to 66
	value = ((uint32_t)(input[6] & 0x1f) << 27) |
			((uint32_t)input[7] << 19) |
			((uint32_t)(input[8] & 0xe0) << 11);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 67 to 82
	value = ((uint32_t)(input[8] & 0x1f) << 27) |
			((uint32_t)input[9] << 19) |
			((uint32_t)(input[10] & 0xe0) << 11);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 83 to 98
	value = ((uint32_t)(input[10] & 0x1f) << 27) |
			((uint32_t)input[11] << 19) |
			((uint32_t)(input[12] & 0xe0) << 11);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 99 to 114
	value = ((uint32_t)(input[12] & 0x1f) << 27) |
			((uint32_t)input[13] << 19) |
			((uint32_t)(input[14] & 0xe0) << 11);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 115 to 130
	value = ((uint32_t)(input[14] & 0x1f) << 27) |
			((uint32_t)input[15] << 19) |
			((uint32_t)(input[16] & 0xe0) << 11);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 131 to 146
	value = ((uint32_t)(input[16] & 0x1f) << 27) |
			((uint32_t)input[17] << 19) |
			((uint32_t)(input[18] & 0xe0) << 11);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 147 to 162
	value = ((uint32_t)(input[18] & 0x1f) << 27) |
			((uint32_t)input[19] << 19) |
			((uint32_t)(input[20] & 0xe0) << 11);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 163 to 178
	value = ((uint32_t)(input[20] & 0x1f) << 27) |
			((uint32_t)input[21] << 19) |
			((uint32_t)(input[22] & 0xe0) << 11);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 179 to 194
	value = ((uint32_t)(input[22] & 0x1f) << 27) |
			((uint32_t)input[23] << 19) |
			((uint32_t)(input[24] & 0xe0) << 11);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 195 to 210
	value = ((uint32_t)(input[24] & 0x1f) << 27) |
			((uint32_t)input[25] << 19) |
			((uint32_t)(input[26] & 0xe0) << 11);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 211 to 226
	value = ((uint32_t)(input[26] & 0x1f) << 27) |
			((uint32_t)input[27] << 19) |
			((uint32_t)(input[28] & 0xe0) << 11);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 227 to 242
	value = ((uint32_t)(input[28] & 0x1f) << 27) |
			((uint32_t)input[29] << 19) |
			((uint32_t)(input[30] & 0xe0) << 11);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 243 to 258
	value = ((uint32_t)(input[30] & 0x1f) << 27) |
			((uint32_t)input[31] << 19) |
			((uint32_t)(input[32] & 0xe0) << 11);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 259 to 274
	value = ((uint32_t)(input[32] & 0x1f) << 27) |
			((uint32_t)input[33] << 19) |
			((uint32_t)(input[34] & 0xe0) << 11);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 275 to 290
	value = ((uint32_t)(input[34] & 0x1f) << 27) |
			((uint32_t)input[35] << 19) |
			((uint32_t)(input[36] & 0xe0) << 11);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 291 to 306
	value = ((uint32_t)(input[36] & 0x1f) << 27) |
			((uint32_t)input[37] << 19) |
			((uint32_t)(input[38] & 0xe0) << 11);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 307 to 322
	value = ((uint32_t)(input[38] & 0x1f) << 27) |
			((uint32_t)input[39] << 19) |
			((uint32_t)(input[40] & 0xe0) << 11);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 323 to 338
	value = ((uint32_t)(input[40] & 0x1f) << 27) |
			((uint32_t)input[41] << 19) |
			((uint32_t)(input[42] & 0xe0) << 11);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 339 to 354
	value = ((uint32_t)(input[42] & 0x1f) << 27) |
			((uint32_t)input[43] << 19) |
			((uint32_t)(input[44] & 0xe0) << 11);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 355 to 370
	value = ((uint32_t)(input[44] & 0x1f) << 27) |
			((uint32_t)input[45] << 19) |
			((uint32_t)(input[46] & 0xe0) << 11);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 371 to 386
	value = ((uint32_t)(input[46] & 0x1f) << 27) |
			((uint32_t)input[47] << 19) |
			((uint32_t)(input[48] & 0xe0) << 11);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 387 to 402
	value = ((uint32_t)(input[48] & 0x1f) << 27) |
			((uint32_t)input[49] << 19) |
			((uint32_t)(input[50] & 0xe0) << 11);
	output[24] = (double)(value >> 16);
}

static void unpack_25_16bit_unsigned_3off(const uint8_t * input, double * output, void *closure) {
	// Unpack 25 values into output
	// Values are 16-bit unsigned
	// Skip 3 bits, read 400 bits of data.
	// Input must be at least 51 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 3 to 18
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)input[1] << 19) |
			((uint32_t)(input[2] & 0xe0) << 11);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 19 to 34
	value = ((uint32_t)(input[2] & 0x1f) << 27) |
			((uint32_t)input[3] << 19) |
			((uint32_t)(input[4] & 0xe0) << 11);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 35 to 50
	value = ((uint32_t)(input[4] & 0x1f) << 27) |
			((uint32_t)input[5] << 19) |
			((uint32_t)(input[6] & 0xe0) << 11);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 51 to 66
	value = ((uint32_t)(input[6] & 0x1f) << 27) |
			((uint32_t)input[7] << 19) |
			((uint32_t)(input[8] & 0xe0) << 11);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 67 to 82
	value = ((uint32_t)(input[8] & 0x1f) << 27) |
			((uint32_t)input[9] << 19) |
			((uint32_t)(input[10] & 0xe0) << 11);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 83 to 98
	value = ((uint32_t)(input[10] & 0x1f) << 27) |
			((uint32_t)input[11] << 19) |
			((uint32_t)(input[12] & 0xe0) << 11);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 99 to 114
	value = ((uint32_t)(input[12] & 0x1f) << 27) |
			((uint32_t)input[13] << 19) |
			((uint32_t)(input[14] & 0xe0) << 11);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 115 to 130
	value = ((uint32_t)(input[14] & 0x1f) << 27) |
			((uint32_t)input[15] << 19) |
			((uint32_t)(input[16] & 0xe0) << 11);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 131 to 146
	value = ((uint32_t)(input[16] & 0x1f) << 27) |
			((uint32_t)input[17] << 19) |
			((uint32_t)(input[18] & 0xe0) << 11);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 147 to 162
	value = ((uint32_t)(input[18] & 0x1f) << 27) |
			((uint32_t)input[19] << 19) |
			((uint32_t)(input[20] & 0xe0) << 11);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 163 to 178
	value = ((uint32_t)(input[20] & 0x1f) << 27) |
			((uint32_t)input[21] << 19) |
			((uint32_t)(input[22] & 0xe0) << 11);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 179 to 194
	value = ((uint32_t)(input[22] & 0x1f) << 27) |
			((uint32_t)input[23] << 19) |
			((uint32_t)(input[24] & 0xe0) << 11);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 195 to 210
	value = ((uint32_t)(input[24] & 0x1f) << 27) |
			((uint32_t)input[25] << 19) |
			((uint32_t)(input[26] & 0xe0) << 11);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 211 to 226
	value = ((uint32_t)(input[26] & 0x1f) << 27) |
			((uint32_t)input[27] << 19) |
			((uint32_t)(input[28] & 0xe0) << 11);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 227 to 242
	value = ((uint32_t)(input[28] & 0x1f) << 27) |
			((uint32_t)input[29] << 19) |
			((uint32_t)(input[30] & 0xe0) << 11);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 243 to 258
	value = ((uint32_t)(input[30] & 0x1f) << 27) |
			((uint32_t)input[31] << 19) |
			((uint32_t)(input[32] & 0xe0) << 11);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 259 to 274
	value = ((uint32_t)(input[32] & 0x1f) << 27) |
			((uint32_t)input[33] << 19) |
			((uint32_t)(input[34] & 0xe0) << 11);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 275 to 290
	value = ((uint32_t)(input[34] & 0x1f) << 27) |
			((uint32_t)input[35] << 19) |
			((uint32_t)(input[36] & 0xe0) << 11);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 291 to 306
	value = ((uint32_t)(input[36] & 0x1f) << 27) |
			((uint32_t)input[37] << 19) |
			((uint32_t)(input[38] & 0xe0) << 11);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 307 to 322
	value = ((uint32_t)(input[38] & 0x1f) << 27) |
			((uint32_t)input[39] << 19) |
			((uint32_t)(input[40] & 0xe0) << 11);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 323 to 338
	value = ((uint32_t)(input[40] & 0x1f) << 27) |
			((uint32_t)input[41] << 19) |
			((uint32_t)(input[42] & 0xe0) << 11);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 339 to 354
	value = ((uint32_t)(input[42] & 0x1f) << 27) |
			((uint32_t)input[43] << 19) |
			((uint32_t)(input[44] & 0xe0) << 11);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 355 to 370
	value = ((uint32_t)(input[44] & 0x1f) << 27) |
			((uint32_t)input[45] << 19) |
			((uint32_t)(input[46] & 0xe0) << 11);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 371 to 386
	value = ((uint32_t)(input[46] & 0x1f) << 27) |
			((uint32_t)input[47] << 19) |
			((uint32_t)(input[48] & 0xe0) << 11);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 387 to 402
	value = ((uint32_t)(input[48] & 0x1f) << 27) |
			((uint32_t)input[49] << 19) |
			((uint32_t)(input[50] & 0xe0) << 11);
	output[24] = (double)(value >> 16);
}

static void unpack_25_16bit_signed_4off(const uint8_t * input, double * output, void *closure) {
	// Unpack 25 values into output
	// Values are 16-bit signed
	// Skip 4 bits, read 400 bits of data.
	// Input must be at least 51 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 4 to 19
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20) |
			((uint32_t)(input[2] & 0xf0) << 12);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 20 to 35
	value = ((uint32_t)(input[2] & 0x0f) << 28) |
			((uint32_t)input[3] << 20) |
			((uint32_t)(input[4] & 0xf0) << 12);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 36 to 51
	value = ((uint32_t)(input[4] & 0x0f) << 28) |
			((uint32_t)input[5] << 20) |
			((uint32_t)(input[6] & 0xf0) << 12);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 52 to 67
	value = ((uint32_t)(input[6] & 0x0f) << 28) |
			((uint32_t)input[7] << 20) |
			((uint32_t)(input[8] & 0xf0) << 12);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 68 to 83
	value = ((uint32_t)(input[8] & 0x0f) << 28) |
			((uint32_t)input[9] << 20) |
			((uint32_t)(input[10] & 0xf0) << 12);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 84 to 99
	value = ((uint32_t)(input[10] & 0x0f) << 28) |
			((uint32_t)input[11] << 20) |
			((uint32_t)(input[12] & 0xf0) << 12);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 100 to 115
	value = ((uint32_t)(input[12] & 0x0f) << 28) |
			((uint32_t)input[13] << 20) |
			((uint32_t)(input[14] & 0xf0) << 12);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 116 to 131
	value = ((uint32_t)(input[14] & 0x0f) << 28) |
			((uint32_t)input[15] << 20) |
			((uint32_t)(input[16] & 0xf0) << 12);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 132 to 147
	value = ((uint32_t)(input[16] & 0x0f) << 28) |
			((uint32_t)input[17] << 20) |
			((uint32_t)(input[18] & 0xf0) << 12);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 148 to 163
	value = ((uint32_t)(input[18] & 0x0f) << 28) |
			((uint32_t)input[19] << 20) |
			((uint32_t)(input[20] & 0xf0) << 12);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 164 to 179
	value = ((uint32_t)(input[20] & 0x0f) << 28) |
			((uint32_t)input[21] << 20) |
			((uint32_t)(input[22] & 0xf0) << 12);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 180 to 195
	value = ((uint32_t)(input[22] & 0x0f) << 28) |
			((uint32_t)input[23] << 20) |
			((uint32_t)(input[24] & 0xf0) << 12);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 196 to 211
	value = ((uint32_t)(input[24] & 0x0f) << 28) |
			((uint32_t)input[25] << 20) |
			((uint32_t)(input[26] & 0xf0) << 12);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 212 to 227
	value = ((uint32_t)(input[26] & 0x0f) << 28) |
			((uint32_t)input[27] << 20) |
			((uint32_t)(input[28] & 0xf0) << 12);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 228 to 243
	value = ((uint32_t)(input[28] & 0x0f) << 28) |
			((uint32_t)input[29] << 20) |
			((uint32_t)(input[30] & 0xf0) << 12);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 244 to 259
	value = ((uint32_t)(input[30] & 0x0f) << 28) |
			((uint32_t)input[31] << 20) |
			((uint32_t)(input[32] & 0xf0) << 12);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 260 to 275
	value = ((uint32_t)(input[32] & 0x0f) << 28) |
			((uint32_t)input[33] << 20) |
			((uint32_t)(input[34] & 0xf0) << 12);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 276 to 291
	value = ((uint32_t)(input[34] & 0x0f) << 28) |
			((uint32_t)input[35] << 20) |
			((uint32_t)(input[36] & 0xf0) << 12);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 292 to 307
	value = ((uint32_t)(input[36] & 0x0f) << 28) |
			((uint32_t)input[37] << 20) |
			((uint32_t)(input[38] & 0xf0) << 12);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 308 to 323
	value = ((uint32_t)(input[38] & 0x0f) << 28) |
			((uint32_t)input[39] << 20) |
			((uint32_t)(input[40] & 0xf0) << 12);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 324 to 339
	value = ((uint32_t)(input[40] & 0x0f) << 28) |
			((uint32_t)input[41] << 20) |
			((uint32_t)(input[42] & 0xf0) << 12);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 340 to 355
	value = ((uint32_t)(input[42] & 0x0f) << 28) |
			((uint32_t)input[43] << 20) |
			((uint32_t)(input[44] & 0xf0) << 12);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 356 to 371
	value = ((uint32_t)(input[44] & 0x0f) << 28) |
			((uint32_t)input[45] << 20) |
			((uint32_t)(input[46] & 0xf0) << 12);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 372 to 387
	value = ((uint32_t)(input[46] & 0x0f) << 28) |
			((uint32_t)input[47] << 20) |
			((uint32_t)(input[48] & 0xf0) << 12);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 388 to 403
	value = ((uint32_t)(input[48] & 0x0f) << 28) |
			((uint32_t)input[49] << 20) |
			((uint32_t)(input[50] & 0xf0) << 12);
	output[24] = (double)(value >> 16);
}

static void unpack_25_16bit_unsigned_4off(const uint8_t * input, double * output, void *closure) {
	// Unpack 25 values into output
	// Values are 16-bit unsigned
	// Skip 4 bits, read 400 bits of data.
	// Input must be at least 51 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 4 to 19
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20) |
			((uint32_t)(input[2] & 0xf0) << 12);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 20 to 35
	value = ((uint32_t)(input[2] & 0x0f) << 28) |
			((uint32_t)input[3] << 20) |
			((uint32_t)(input[4] & 0xf0) << 12);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 36 to 51
	value = ((uint32_t)(input[4] & 0x0f) << 28) |
			((uint32_t)input[5] << 20) |
			((uint32_t)(input[6] & 0xf0) << 12);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 52 to 67
	value = ((uint32_t)(input[6] & 0x0f) << 28) |
			((uint32_t)input[7] << 20) |
			((uint32_t)(input[8] & 0xf0) << 12);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 68 to 83
	value = ((uint32_t)(input[8] & 0x0f) << 28) |
			((uint32_t)input[9] << 20) |
			((uint32_t)(input[10] & 0xf0) << 12);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 84 to 99
	value = ((uint32_t)(input[10] & 0x0f) << 28) |
			((uint32_t)input[11] << 20) |
			((uint32_t)(input[12] & 0xf0) << 12);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 100 to 115
	value = ((uint32_t)(input[12] & 0x0f) << 28) |
			((uint32_t)input[13] << 20) |
			((uint32_t)(input[14] & 0xf0) << 12);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 116 to 131
	value = ((uint32_t)(input[14] & 0x0f) << 28) |
			((uint32_t)input[15] << 20) |
			((uint32_t)(input[16] & 0xf0) << 12);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 132 to 147
	value = ((uint32_t)(input[16] & 0x0f) << 28) |
			((uint32_t)input[17] << 20) |
			((uint32_t)(input[18] & 0xf0) << 12);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 148 to 163
	value = ((uint32_t)(input[18] & 0x0f) << 28) |
			((uint32_t)input[19] << 20) |
			((uint32_t)(input[20] & 0xf0) << 12);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 164 to 179
	value = ((uint32_t)(input[20] & 0x0f) << 28) |
			((uint32_t)input[21] << 20) |
			((uint32_t)(input[22] & 0xf0) << 12);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 180 to 195
	value = ((uint32_t)(input[22] & 0x0f) << 28) |
			((uint32_t)input[23] << 20) |
			((uint32_t)(input[24] & 0xf0) << 12);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 196 to 211
	value = ((uint32_t)(input[24] & 0x0f) << 28) |
			((uint32_t)input[25] << 20) |
			((uint32_t)(input[26] & 0xf0) << 12);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 212 to 227
	value = ((uint32_t)(input[26] & 0x0f) << 28) |
			((uint32_t)input[27] << 20) |
			((uint32_t)(input[28] & 0xf0) << 12);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 228 to 243
	value = ((uint32_t)(input[28] & 0x0f) << 28) |
			((uint32_t)input[29] << 20) |
			((uint32_t)(input[30] & 0xf0) << 12);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 244 to 259
	value = ((uint32_t)(input[30] & 0x0f) << 28) |
			((uint32_t)input[31] << 20) |
			((uint32_t)(input[32] & 0xf0) << 12);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 260 to 275
	value = ((uint32_t)(input[32] & 0x0f) << 28) |
			((uint32_t)input[33] << 20) |
			((uint32_t)(input[34] & 0xf0) << 12);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 276 to 291
	value = ((uint32_t)(input[34] & 0x0f) << 28) |
			((uint32_t)input[35] << 20) |
			((uint32_t)(input[36] & 0xf0) << 12);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 292 to 307
	value = ((uint32_t)(input[36] & 0x0f) << 28) |
			((uint32_t)input[37] << 20) |
			((uint32_t)(input[38] & 0xf0) << 12);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 308 to 323
	value = ((uint32_t)(input[38] & 0x0f) << 28) |
			((uint32_t)input[39] << 20) |
			((uint32_t)(input[40] & 0xf0) << 12);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 324 to 339
	value = ((uint32_t)(input[40] & 0x0f) << 28) |
			((uint32_t)input[41] << 20) |
			((uint32_t)(input[42] & 0xf0) << 12);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 340 to 355
	value = ((uint32_t)(input[42] & 0x0f) << 28) |
			((uint32_t)input[43] << 20) |
			((uint32_t)(input[44] & 0xf0) << 12);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 356 to 371
	value = ((uint32_t)(input[44] & 0x0f) << 28) |
			((uint32_t)input[45] << 20) |
			((uint32_t)(input[46] & 0xf0) << 12);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 372 to 387
	value = ((uint32_t)(input[46] & 0x0f) << 28) |
			((uint32_t)input[47] << 20) |
			((uint32_t)(input[48] & 0xf0) << 12);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 388 to 403
	value = ((uint32_t)(input[48] & 0x0f) << 28) |
			((uint32_t)input[49] << 20) |
			((uint32_t)(input[50] & 0xf0) << 12);
	output[24] = (double)(value >> 16);
}

static void unpack_25_16bit_signed_5off(const uint8_t * input, double * output, void *closure) {
	// Unpack 25 values into output
	// Values are 16-bit signed
	// Skip 5 bits, read 400 bits of data.
	// Input must be at least 51 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 5 to 20
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)(input[2] & 0xf8) << 13);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 21 to 36
	value = ((uint32_t)(input[2] & 0x07) << 29) |
			((uint32_t)input[3] << 21) |
			((uint32_t)(input[4] & 0xf8) << 13);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 37 to 52
	value = ((uint32_t)(input[4] & 0x07) << 29) |
			((uint32_t)input[5] << 21) |
			((uint32_t)(input[6] & 0xf8) << 13);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 53 to 68
	value = ((uint32_t)(input[6] & 0x07) << 29) |
			((uint32_t)input[7] << 21) |
			((uint32_t)(input[8] & 0xf8) << 13);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 69 to 84
	value = ((uint32_t)(input[8] & 0x07) << 29) |
			((uint32_t)input[9] << 21) |
			((uint32_t)(input[10] & 0xf8) << 13);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 85 to 100
	value = ((uint32_t)(input[10] & 0x07) << 29) |
			((uint32_t)input[11] << 21) |
			((uint32_t)(input[12] & 0xf8) << 13);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 101 to 116
	value = ((uint32_t)(input[12] & 0x07) << 29) |
			((uint32_t)input[13] << 21) |
			((uint32_t)(input[14] & 0xf8) << 13);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 117 to 132
	value = ((uint32_t)(input[14] & 0x07) << 29) |
			((uint32_t)input[15] << 21) |
			((uint32_t)(input[16] & 0xf8) << 13);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 133 to 148
	value = ((uint32_t)(input[16] & 0x07) << 29) |
			((uint32_t)input[17] << 21) |
			((uint32_t)(input[18] & 0xf8) << 13);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 149 to 164
	value = ((uint32_t)(input[18] & 0x07) << 29) |
			((uint32_t)input[19] << 21) |
			((uint32_t)(input[20] & 0xf8) << 13);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 165 to 180
	value = ((uint32_t)(input[20] & 0x07) << 29) |
			((uint32_t)input[21] << 21) |
			((uint32_t)(input[22] & 0xf8) << 13);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 181 to 196
	value = ((uint32_t)(input[22] & 0x07) << 29) |
			((uint32_t)input[23] << 21) |
			((uint32_t)(input[24] & 0xf8) << 13);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 197 to 212
	value = ((uint32_t)(input[24] & 0x07) << 29) |
			((uint32_t)input[25] << 21) |
			((uint32_t)(input[26] & 0xf8) << 13);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 213 to 228
	value = ((uint32_t)(input[26] & 0x07) << 29) |
			((uint32_t)input[27] << 21) |
			((uint32_t)(input[28] & 0xf8) << 13);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 229 to 244
	value = ((uint32_t)(input[28] & 0x07) << 29) |
			((uint32_t)input[29] << 21) |
			((uint32_t)(input[30] & 0xf8) << 13);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 245 to 260
	value = ((uint32_t)(input[30] & 0x07) << 29) |
			((uint32_t)input[31] << 21) |
			((uint32_t)(input[32] & 0xf8) << 13);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 261 to 276
	value = ((uint32_t)(input[32] & 0x07) << 29) |
			((uint32_t)input[33] << 21) |
			((uint32_t)(input[34] & 0xf8) << 13);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 277 to 292
	value = ((uint32_t)(input[34] & 0x07) << 29) |
			((uint32_t)input[35] << 21) |
			((uint32_t)(input[36] & 0xf8) << 13);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 293 to 308
	value = ((uint32_t)(input[36] & 0x07) << 29) |
			((uint32_t)input[37] << 21) |
			((uint32_t)(input[38] & 0xf8) << 13);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 309 to 324
	value = ((uint32_t)(input[38] & 0x07) << 29) |
			((uint32_t)input[39] << 21) |
			((uint32_t)(input[40] & 0xf8) << 13);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 325 to 340
	value = ((uint32_t)(input[40] & 0x07) << 29) |
			((uint32_t)input[41] << 21) |
			((uint32_t)(input[42] & 0xf8) << 13);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 341 to 356
	value = ((uint32_t)(input[42] & 0x07) << 29) |
			((uint32_t)input[43] << 21) |
			((uint32_t)(input[44] & 0xf8) << 13);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 357 to 372
	value = ((uint32_t)(input[44] & 0x07) << 29) |
			((uint32_t)input[45] << 21) |
			((uint32_t)(input[46] & 0xf8) << 13);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 373 to 388
	value = ((uint32_t)(input[46] & 0x07) << 29) |
			((uint32_t)input[47] << 21) |
			((uint32_t)(input[48] & 0xf8) << 13);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 389 to 404
	value = ((uint32_t)(input[48] & 0x07) << 29) |
			((uint32_t)input[49] << 21) |
			((uint32_t)(input[50] & 0xf8) << 13);
	output[24] = (double)(value >> 16);
}

static void unpack_25_16bit_unsigned_5off(const uint8_t * input, double * output, void *closure) {
	// Unpack 25 values into output
	// Values are 16-bit unsigned
	// Skip 5 bits, read 400 bits of data.
	// Input must be at least 51 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 5 to 20
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)(input[2] & 0xf8) << 13);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 21 to 36
	value = ((uint32_t)(input[2] & 0x07) << 29) |
			((uint32_t)input[3] << 21) |
			((uint32_t)(input[4] & 0xf8) << 13);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 37 to 52
	value = ((uint32_t)(input[4] & 0x07) << 29) |
			((uint32_t)input[5] << 21) |
			((uint32_t)(input[6] & 0xf8) << 13);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 53 to 68
	value = ((uint32_t)(input[6] & 0x07) << 29) |
			((uint32_t)input[7] << 21) |
			((uint32_t)(input[8] & 0xf8) << 13);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 69 to 84
	value = ((uint32_t)(input[8] & 0x07) << 29) |
			((uint32_t)input[9] << 21) |
			((uint32_t)(input[10] & 0xf8) << 13);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 85 to 100
	value = ((uint32_t)(input[10] & 0x07) << 29) |
			((uint32_t)input[11] << 21) |
			((uint32_t)(input[12] & 0xf8) << 13);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 101 to 116
	value = ((uint32_t)(input[12] & 0x07) << 29) |
			((uint32_t)input[13] << 21) |
			((uint32_t)(input[14] & 0xf8) << 13);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 117 to 132
	value = ((uint32_t)(input[14] & 0x07) << 29) |
			((uint32_t)input[15] << 21) |
			((uint32_t)(input[16] & 0xf8) << 13);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 133 to 148
	value = ((uint32_t)(input[16] & 0x07) << 29) |
			((uint32_t)input[17] << 21) |
			((uint32_t)(input[18] & 0xf8) << 13);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 149 to 164
	value = ((uint32_t)(input[18] & 0x07) << 29) |
			((uint32_t)input[19] << 21) |
			((uint32_t)(input[20] & 0xf8) << 13);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 165 to 180
	value = ((uint32_t)(input[20] & 0x07) << 29) |
			((uint32_t)input[21] << 21) |
			((uint32_t)(input[22] & 0xf8) << 13);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 181 to 196
	value = ((uint32_t)(input[22] & 0x07) << 29) |
			((uint32_t)input[23] << 21) |
			((uint32_t)(input[24] & 0xf8) << 13);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 197 to 212
	value = ((uint32_t)(input[24] & 0x07) << 29) |
			((uint32_t)input[25] << 21) |
			((uint32_t)(input[26] & 0xf8) << 13);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 213 to 228
	value = ((uint32_t)(input[26] & 0x07) << 29) |
			((uint32_t)input[27] << 21) |
			((uint32_t)(input[28] & 0xf8) << 13);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 229 to 244
	value = ((uint32_t)(input[28] & 0x07) << 29) |
			((uint32_t)input[29] << 21) |
			((uint32_t)(input[30] & 0xf8) << 13);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 245 to 260
	value = ((uint32_t)(input[30] & 0x07) << 29) |
			((uint32_t)input[31] << 21) |
			((uint32_t)(input[32] & 0xf8) << 13);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 261 to 276
	value = ((uint32_t)(input[32] & 0x07) << 29) |
			((uint32_t)input[33] << 21) |
			((uint32_t)(input[34] & 0xf8) << 13);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 277 to 292
	value = ((uint32_t)(input[34] & 0x07) << 29) |
			((uint32_t)input[35] << 21) |
			((uint32_t)(input[36] & 0xf8) << 13);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 293 to 308
	value = ((uint32_t)(input[36] & 0x07) << 29) |
			((uint32_t)input[37] << 21) |
			((uint32_t)(input[38] & 0xf8) << 13);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 309 to 324
	value = ((uint32_t)(input[38] & 0x07) << 29) |
			((uint32_t)input[39] << 21) |
			((uint32_t)(input[40] & 0xf8) << 13);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 325 to 340
	value = ((uint32_t)(input[40] & 0x07) << 29) |
			((uint32_t)input[41] << 21) |
			((uint32_t)(input[42] & 0xf8) << 13);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 341 to 356
	value = ((uint32_t)(input[42] & 0x07) << 29) |
			((uint32_t)input[43] << 21) |
			((uint32_t)(input[44] & 0xf8) << 13);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 357 to 372
	value = ((uint32_t)(input[44] & 0x07) << 29) |
			((uint32_t)input[45] << 21) |
			((uint32_t)(input[46] & 0xf8) << 13);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 373 to 388
	value = ((uint32_t)(input[46] & 0x07) << 29) |
			((uint32_t)input[47] << 21) |
			((uint32_t)(input[48] & 0xf8) << 13);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 389 to 404
	value = ((uint32_t)(input[48] & 0x07) << 29) |
			((uint32_t)input[49] << 21) |
			((uint32_t)(input[50] & 0xf8) << 13);
	output[24] = (double)(value >> 16);
}

static void unpack_25_16bit_signed_6off(const uint8_t * input, double * output, void *closure) {
	// Unpack 25 values into output
	// Values are 16-bit signed
	// Skip 6 bits, read 400 bits of data.
	// Input must be at least 51 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 6 to 21
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)(input[2] & 0xfc) << 14);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 22 to 37
	value = ((uint32_t)(input[2] & 0x03) << 30) |
			((uint32_t)input[3] << 22) |
			((uint32_t)(input[4] & 0xfc) << 14);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 38 to 53
	value = ((uint32_t)(input[4] & 0x03) << 30) |
			((uint32_t)input[5] << 22) |
			((uint32_t)(input[6] & 0xfc) << 14);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 54 to 69
	value = ((uint32_t)(input[6] & 0x03) << 30) |
			((uint32_t)input[7] << 22) |
			((uint32_t)(input[8] & 0xfc) << 14);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 70 to 85
	value = ((uint32_t)(input[8] & 0x03) << 30) |
			((uint32_t)input[9] << 22) |
			((uint32_t)(input[10] & 0xfc) << 14);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 86 to 101
	value = ((uint32_t)(input[10] & 0x03) << 30) |
			((uint32_t)input[11] << 22) |
			((uint32_t)(input[12] & 0xfc) << 14);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 102 to 117
	value = ((uint32_t)(input[12] & 0x03) << 30) |
			((uint32_t)input[13] << 22) |
			((uint32_t)(input[14] & 0xfc) << 14);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 118 to 133
	value = ((uint32_t)(input[14] & 0x03) << 30) |
			((uint32_t)input[15] << 22) |
			((uint32_t)(input[16] & 0xfc) << 14);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 134 to 149
	value = ((uint32_t)(input[16] & 0x03) << 30) |
			((uint32_t)input[17] << 22) |
			((uint32_t)(input[18] & 0xfc) << 14);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 150 to 165
	value = ((uint32_t)(input[18] & 0x03) << 30) |
			((uint32_t)input[19] << 22) |
			((uint32_t)(input[20] & 0xfc) << 14);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 166 to 181
	value = ((uint32_t)(input[20] & 0x03) << 30) |
			((uint32_t)input[21] << 22) |
			((uint32_t)(input[22] & 0xfc) << 14);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 182 to 197
	value = ((uint32_t)(input[22] & 0x03) << 30) |
			((uint32_t)input[23] << 22) |
			((uint32_t)(input[24] & 0xfc) << 14);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 198 to 213
	value = ((uint32_t)(input[24] & 0x03) << 30) |
			((uint32_t)input[25] << 22) |
			((uint32_t)(input[26] & 0xfc) << 14);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 214 to 229
	value = ((uint32_t)(input[26] & 0x03) << 30) |
			((uint32_t)input[27] << 22) |
			((uint32_t)(input[28] & 0xfc) << 14);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 230 to 245
	value = ((uint32_t)(input[28] & 0x03) << 30) |
			((uint32_t)input[29] << 22) |
			((uint32_t)(input[30] & 0xfc) << 14);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 246 to 261
	value = ((uint32_t)(input[30] & 0x03) << 30) |
			((uint32_t)input[31] << 22) |
			((uint32_t)(input[32] & 0xfc) << 14);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 262 to 277
	value = ((uint32_t)(input[32] & 0x03) << 30) |
			((uint32_t)input[33] << 22) |
			((uint32_t)(input[34] & 0xfc) << 14);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 278 to 293
	value = ((uint32_t)(input[34] & 0x03) << 30) |
			((uint32_t)input[35] << 22) |
			((uint32_t)(input[36] & 0xfc) << 14);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 294 to 309
	value = ((uint32_t)(input[36] & 0x03) << 30) |
			((uint32_t)input[37] << 22) |
			((uint32_t)(input[38] & 0xfc) << 14);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 310 to 325
	value = ((uint32_t)(input[38] & 0x03) << 30) |
			((uint32_t)input[39] << 22) |
			((uint32_t)(input[40] & 0xfc) << 14);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 326 to 341
	value = ((uint32_t)(input[40] & 0x03) << 30) |
			((uint32_t)input[41] << 22) |
			((uint32_t)(input[42] & 0xfc) << 14);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 342 to 357
	value = ((uint32_t)(input[42] & 0x03) << 30) |
			((uint32_t)input[43] << 22) |
			((uint32_t)(input[44] & 0xfc) << 14);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 358 to 373
	value = ((uint32_t)(input[44] & 0x03) << 30) |
			((uint32_t)input[45] << 22) |
			((uint32_t)(input[46] & 0xfc) << 14);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 374 to 389
	value = ((uint32_t)(input[46] & 0x03) << 30) |
			((uint32_t)input[47] << 22) |
			((uint32_t)(input[48] & 0xfc) << 14);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 390 to 405
	value = ((uint32_t)(input[48] & 0x03) << 30) |
			((uint32_t)input[49] << 22) |
			((uint32_t)(input[50] & 0xfc) << 14);
	output[24] = (double)(value >> 16);
}

static void unpack_25_16bit_unsigned_6off(const uint8_t * input, double * output, void *closure) {
	// Unpack 25 values into output
	// Values are 16-bit unsigned
	// Skip 6 bits, read 400 bits of data.
	// Input must be at least 51 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 6 to 21
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)(input[2] & 0xfc) << 14);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 22 to 37
	value = ((uint32_t)(input[2] & 0x03) << 30) |
			((uint32_t)input[3] << 22) |
			((uint32_t)(input[4] & 0xfc) << 14);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 38 to 53
	value = ((uint32_t)(input[4] & 0x03) << 30) |
			((uint32_t)input[5] << 22) |
			((uint32_t)(input[6] & 0xfc) << 14);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 54 to 69
	value = ((uint32_t)(input[6] & 0x03) << 30) |
			((uint32_t)input[7] << 22) |
			((uint32_t)(input[8] & 0xfc) << 14);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 70 to 85
	value = ((uint32_t)(input[8] & 0x03) << 30) |
			((uint32_t)input[9] << 22) |
			((uint32_t)(input[10] & 0xfc) << 14);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 86 to 101
	value = ((uint32_t)(input[10] & 0x03) << 30) |
			((uint32_t)input[11] << 22) |
			((uint32_t)(input[12] & 0xfc) << 14);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 102 to 117
	value = ((uint32_t)(input[12] & 0x03) << 30) |
			((uint32_t)input[13] << 22) |
			((uint32_t)(input[14] & 0xfc) << 14);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 118 to 133
	value = ((uint32_t)(input[14] & 0x03) << 30) |
			((uint32_t)input[15] << 22) |
			((uint32_t)(input[16] & 0xfc) << 14);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 134 to 149
	value = ((uint32_t)(input[16] & 0x03) << 30) |
			((uint32_t)input[17] << 22) |
			((uint32_t)(input[18] & 0xfc) << 14);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 150 to 165
	value = ((uint32_t)(input[18] & 0x03) << 30) |
			((uint32_t)input[19] << 22) |
			((uint32_t)(input[20] & 0xfc) << 14);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 166 to 181
	value = ((uint32_t)(input[20] & 0x03) << 30) |
			((uint32_t)input[21] << 22) |
			((uint32_t)(input[22] & 0xfc) << 14);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 182 to 197
	value = ((uint32_t)(input[22] & 0x03) << 30) |
			((uint32_t)input[23] << 22) |
			((uint32_t)(input[24] & 0xfc) << 14);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 198 to 213
	value = ((uint32_t)(input[24] & 0x03) << 30) |
			((uint32_t)input[25] << 22) |
			((uint32_t)(input[26] & 0xfc) << 14);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 214 to 229
	value = ((uint32_t)(input[26] & 0x03) << 30) |
			((uint32_t)input[27] << 22) |
			((uint32_t)(input[28] & 0xfc) << 14);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 230 to 245
	value = ((uint32_t)(input[28] & 0x03) << 30) |
			((uint32_t)input[29] << 22) |
			((uint32_t)(input[30] & 0xfc) << 14);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 246 to 261
	value = ((uint32_t)(input[30] & 0x03) << 30) |
			((uint32_t)input[31] << 22) |
			((uint32_t)(input[32] & 0xfc) << 14);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 262 to 277
	value = ((uint32_t)(input[32] & 0x03) << 30) |
			((uint32_t)input[33] << 22) |
			((uint32_t)(input[34] & 0xfc) << 14);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 278 to 293
	value = ((uint32_t)(input[34] & 0x03) << 30) |
			((uint32_t)input[35] << 22) |
			((uint32_t)(input[36] & 0xfc) << 14);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 294 to 309
	value = ((uint32_t)(input[36] & 0x03) << 30) |
			((uint32_t)input[37] << 22) |
			((uint32_t)(input[38] & 0xfc) << 14);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 310 to 325
	value = ((uint32_t)(input[38] & 0x03) << 30) |
			((uint32_t)input[39] << 22) |
			((uint32_t)(input[40] & 0xfc) << 14);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 326 to 341
	value = ((uint32_t)(input[40] & 0x03) << 30) |
			((uint32_t)input[41] << 22) |
			((uint32_t)(input[42] & 0xfc) << 14);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 342 to 357
	value = ((uint32_t)(input[42] & 0x03) << 30) |
			((uint32_t)input[43] << 22) |
			((uint32_t)(input[44] & 0xfc) << 14);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 358 to 373
	value = ((uint32_t)(input[44] & 0x03) << 30) |
			((uint32_t)input[45] << 22) |
			((uint32_t)(input[46] & 0xfc) << 14);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 374 to 389
	value = ((uint32_t)(input[46] & 0x03) << 30) |
			((uint32_t)input[47] << 22) |
			((uint32_t)(input[48] & 0xfc) << 14);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 390 to 405
	value = ((uint32_t)(input[48] & 0x03) << 30) |
			((uint32_t)input[49] << 22) |
			((uint32_t)(input[50] & 0xfc) << 14);
	output[24] = (double)(value >> 16);
}

static void unpack_25_16bit_signed_7off(const uint8_t * input, double * output, void *closure) {
	// Unpack 25 values into output
	// Values are 16-bit signed
	// Skip 7 bits, read 400 bits of data.
	// Input must be at least 51 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 7 to 22
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)(input[2] & 0xfe) << 15);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 23 to 38
	value = ((uint32_t)(input[2] & 0x01) << 31) |
			((uint32_t)input[3] << 23) |
			((uint32_t)(input[4] & 0xfe) << 15);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 39 to 54
	value = ((uint32_t)(input[4] & 0x01) << 31) |
			((uint32_t)input[5] << 23) |
			((uint32_t)(input[6] & 0xfe) << 15);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 55 to 70
	value = ((uint32_t)(input[6] & 0x01) << 31) |
			((uint32_t)input[7] << 23) |
			((uint32_t)(input[8] & 0xfe) << 15);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 71 to 86
	value = ((uint32_t)(input[8] & 0x01) << 31) |
			((uint32_t)input[9] << 23) |
			((uint32_t)(input[10] & 0xfe) << 15);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 87 to 102
	value = ((uint32_t)(input[10] & 0x01) << 31) |
			((uint32_t)input[11] << 23) |
			((uint32_t)(input[12] & 0xfe) << 15);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 103 to 118
	value = ((uint32_t)(input[12] & 0x01) << 31) |
			((uint32_t)input[13] << 23) |
			((uint32_t)(input[14] & 0xfe) << 15);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 119 to 134
	value = ((uint32_t)(input[14] & 0x01) << 31) |
			((uint32_t)input[15] << 23) |
			((uint32_t)(input[16] & 0xfe) << 15);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 135 to 150
	value = ((uint32_t)(input[16] & 0x01) << 31) |
			((uint32_t)input[17] << 23) |
			((uint32_t)(input[18] & 0xfe) << 15);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 151 to 166
	value = ((uint32_t)(input[18] & 0x01) << 31) |
			((uint32_t)input[19] << 23) |
			((uint32_t)(input[20] & 0xfe) << 15);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 167 to 182
	value = ((uint32_t)(input[20] & 0x01) << 31) |
			((uint32_t)input[21] << 23) |
			((uint32_t)(input[22] & 0xfe) << 15);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 183 to 198
	value = ((uint32_t)(input[22] & 0x01) << 31) |
			((uint32_t)input[23] << 23) |
			((uint32_t)(input[24] & 0xfe) << 15);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 199 to 214
	value = ((uint32_t)(input[24] & 0x01) << 31) |
			((uint32_t)input[25] << 23) |
			((uint32_t)(input[26] & 0xfe) << 15);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 215 to 230
	value = ((uint32_t)(input[26] & 0x01) << 31) |
			((uint32_t)input[27] << 23) |
			((uint32_t)(input[28] & 0xfe) << 15);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 231 to 246
	value = ((uint32_t)(input[28] & 0x01) << 31) |
			((uint32_t)input[29] << 23) |
			((uint32_t)(input[30] & 0xfe) << 15);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 247 to 262
	value = ((uint32_t)(input[30] & 0x01) << 31) |
			((uint32_t)input[31] << 23) |
			((uint32_t)(input[32] & 0xfe) << 15);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 263 to 278
	value = ((uint32_t)(input[32] & 0x01) << 31) |
			((uint32_t)input[33] << 23) |
			((uint32_t)(input[34] & 0xfe) << 15);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 279 to 294
	value = ((uint32_t)(input[34] & 0x01) << 31) |
			((uint32_t)input[35] << 23) |
			((uint32_t)(input[36] & 0xfe) << 15);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 295 to 310
	value = ((uint32_t)(input[36] & 0x01) << 31) |
			((uint32_t)input[37] << 23) |
			((uint32_t)(input[38] & 0xfe) << 15);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 311 to 326
	value = ((uint32_t)(input[38] & 0x01) << 31) |
			((uint32_t)input[39] << 23) |
			((uint32_t)(input[40] & 0xfe) << 15);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 327 to 342
	value = ((uint32_t)(input[40] & 0x01) << 31) |
			((uint32_t)input[41] << 23) |
			((uint32_t)(input[42] & 0xfe) << 15);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 343 to 358
	value = ((uint32_t)(input[42] & 0x01) << 31) |
			((uint32_t)input[43] << 23) |
			((uint32_t)(input[44] & 0xfe) << 15);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 359 to 374
	value = ((uint32_t)(input[44] & 0x01) << 31) |
			((uint32_t)input[45] << 23) |
			((uint32_t)(input[46] & 0xfe) << 15);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 375 to 390
	value = ((uint32_t)(input[46] & 0x01) << 31) |
			((uint32_t)input[47] << 23) |
			((uint32_t)(input[48] & 0xfe) << 15);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 391 to 406
	value = ((uint32_t)(input[48] & 0x01) << 31) |
			((uint32_t)input[49] << 23) |
			((uint32_t)(input[50] & 0xfe) << 15);
	output[24] = (double)(value >> 16);
}

static void unpack_25_16bit_unsigned_7off(const uint8_t * input, double * output, void *closure) {
	// Unpack 25 values into output
	// Values are 16-bit unsigned
	// Skip 7 bits, read 400 bits of data.
	// Input must be at least 51 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 7 to 22
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)(input[2] & 0xfe) << 15);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 23 to 38
	value = ((uint32_t)(input[2] & 0x01) << 31) |
			((uint32_t)input[3] << 23) |
			((uint32_t)(input[4] & 0xfe) << 15);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 39 to 54
	value = ((uint32_t)(input[4] & 0x01) << 31) |
			((uint32_t)input[5] << 23) |
			((uint32_t)(input[6] & 0xfe) << 15);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 55 to 70
	value = ((uint32_t)(input[6] & 0x01) << 31) |
			((uint32_t)input[7] << 23) |
			((uint32_t)(input[8] & 0xfe) << 15);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 71 to 86
	value = ((uint32_t)(input[8] & 0x01) << 31) |
			((uint32_t)input[9] << 23) |
			((uint32_t)(input[10] & 0xfe) << 15);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 87 to 102
	value = ((uint32_t)(input[10] & 0x01) << 31) |
			((uint32_t)input[11] << 23) |
			((uint32_t)(input[12] & 0xfe) << 15);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 103 to 118
	value = ((uint32_t)(input[12] & 0x01) << 31) |
			((uint32_t)input[13] << 23) |
			((uint32_t)(input[14] & 0xfe) << 15);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 119 to 134
	value = ((uint32_t)(input[14] & 0x01) << 31) |
			((uint32_t)input[15] << 23) |
			((uint32_t)(input[16] & 0xfe) << 15);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 135 to 150
	value = ((uint32_t)(input[16] & 0x01) << 31) |
			((uint32_t)input[17] << 23) |
			((uint32_t)(input[18] & 0xfe) << 15);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 151 to 166
	value = ((uint32_t)(input[18] & 0x01) << 31) |
			((uint32_t)input[19] << 23) |
			((uint32_t)(input[20] & 0xfe) << 15);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 167 to 182
	value = ((uint32_t)(input[20] & 0x01) << 31) |
			((uint32_t)input[21] << 23) |
			((uint32_t)(input[22] & 0xfe) << 15);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 183 to 198
	value = ((uint32_t)(input[22] & 0x01) << 31) |
			((uint32_t)input[23] << 23) |
			((uint32_t)(input[24] & 0xfe) << 15);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 199 to 214
	value = ((uint32_t)(input[24] & 0x01) << 31) |
			((uint32_t)input[25] << 23) |
			((uint32_t)(input[26] & 0xfe) << 15);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 215 to 230
	value = ((uint32_t)(input[26] & 0x01) << 31) |
			((uint32_t)input[27] << 23) |
			((uint32_t)(input[28] & 0xfe) << 15);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 231 to 246
	value = ((uint32_t)(input[28] & 0x01) << 31) |
			((uint32_t)input[29] << 23) |
			((uint32_t)(input[30] & 0xfe) << 15);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 247 to 262
	value = ((uint32_t)(input[30] & 0x01) << 31) |
			((uint32_t)input[31] << 23) |
			((uint32_t)(input[32] & 0xfe) << 15);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 263 to 278
	value = ((uint32_t)(input[32] & 0x01) << 31) |
			((uint32_t)input[33] << 23) |
			((uint32_t)(input[34] & 0xfe) << 15);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 279 to 294
	value = ((uint32_t)(input[34] & 0x01) << 31) |
			((uint32_t)input[35] << 23) |
			((uint32_t)(input[36] & 0xfe) << 15);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 295 to 310
	value = ((uint32_t)(input[36] & 0x01) << 31) |
			((uint32_t)input[37] << 23) |
			((uint32_t)(input[38] & 0xfe) << 15);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 311 to 326
	value = ((uint32_t)(input[38] & 0x01) << 31) |
			((uint32_t)input[39] << 23) |
			((uint32_t)(input[40] & 0xfe) << 15);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 327 to 342
	value = ((uint32_t)(input[40] & 0x01) << 31) |
			((uint32_t)input[41] << 23) |
			((uint32_t)(input[42] & 0xfe) << 15);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 343 to 358
	value = ((uint32_t)(input[42] & 0x01) << 31) |
			((uint32_t)input[43] << 23) |
			((uint32_t)(input[44] & 0xfe) << 15);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 359 to 374
	value = ((uint32_t)(input[44] & 0x01) << 31) |
			((uint32_t)input[45] << 23) |
			((uint32_t)(input[46] & 0xfe) << 15);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 375 to 390
	value = ((uint32_t)(input[46] & 0x01) << 31) |
			((uint32_t)input[47] << 23) |
			((uint32_t)(input[48] & 0xfe) << 15);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 391 to 406
	value = ((uint32_t)(input[48] & 0x01) << 31) |
			((uint32_t)input[49] << 23) |
			((uint32_t)(input[50] & 0xfe) << 15);
	output[24] = (double)(value >> 16);
}

static void unpack_26_16bit_signed_0off(const uint8_t * input, double * output, void *closure) {
	// Unpack 26 values into output
	// Values are 16-bit signed
	// Skip 0 bits, read 416 bits of data.
	// Input must be at least 52 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 0 to 15
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)input[1] << 16);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 16 to 31
	value = ((uint32_t)input[2] << 24) |
			((uint32_t)input[3] << 16);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 32 to 47
	value = ((uint32_t)input[4] << 24) |
			((uint32_t)input[5] << 16);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 48 to 63
	value = ((uint32_t)input[6] << 24) |
			((uint32_t)input[7] << 16);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 64 to 79
	value = ((uint32_t)input[8] << 24) |
			((uint32_t)input[9] << 16);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 80 to 95
	value = ((uint32_t)input[10] << 24) |
			((uint32_t)input[11] << 16);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 96 to 111
	value = ((uint32_t)input[12] << 24) |
			((uint32_t)input[13] << 16);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 112 to 127
	value = ((uint32_t)input[14] << 24) |
			((uint32_t)input[15] << 16);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 128 to 143
	value = ((uint32_t)input[16] << 24) |
			((uint32_t)input[17] << 16);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 144 to 159
	value = ((uint32_t)input[18] << 24) |
			((uint32_t)input[19] << 16);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 160 to 175
	value = ((uint32_t)input[20] << 24) |
			((uint32_t)input[21] << 16);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 176 to 191
	value = ((uint32_t)input[22] << 24) |
			((uint32_t)input[23] << 16);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 192 to 207
	value = ((uint32_t)input[24] << 24) |
			((uint32_t)input[25] << 16);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 208 to 223
	value = ((uint32_t)input[26] << 24) |
			((uint32_t)input[27] << 16);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 224 to 239
	value = ((uint32_t)input[28] << 24) |
			((uint32_t)input[29] << 16);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 240 to 255
	value = ((uint32_t)input[30] << 24) |
			((uint32_t)input[31] << 16);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 256 to 271
	value = ((uint32_t)input[32] << 24) |
			((uint32_t)input[33] << 16);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 272 to 287
	value = ((uint32_t)input[34] << 24) |
			((uint32_t)input[35] << 16);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 288 to 303
	value = ((uint32_t)input[36] << 24) |
			((uint32_t)input[37] << 16);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 304 to 319
	value = ((uint32_t)input[38] << 24) |
			((uint32_t)input[39] << 16);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 320 to 335
	value = ((uint32_t)input[40] << 24) |
			((uint32_t)input[41] << 16);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 336 to 351
	value = ((uint32_t)input[42] << 24) |
			((uint32_t)input[43] << 16);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 352 to 367
	value = ((uint32_t)input[44] << 24) |
			((uint32_t)input[45] << 16);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 368 to 383
	value = ((uint32_t)input[46] << 24) |
			((uint32_t)input[47] << 16);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 384 to 399
	value = ((uint32_t)input[48] << 24) |
			((uint32_t)input[49] << 16);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 400 to 415
	value = ((uint32_t)input[50] << 24) |
			((uint32_t)input[51] << 16);
	output[25] = (double)(value >> 16);
}

static void unpack_26_16bit_unsigned_0off(const uint8_t * input, double * output, void *closure) {
	// Unpack 26 values into output
	// Values are 16-bit unsigned
	// Skip 0 bits, read 416 bits of data.
	// Input must be at least 52 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 0 to 15
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)input[1] << 16);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 16 to 31
	value = ((uint32_t)input[2] << 24) |
			((uint32_t)input[3] << 16);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 32 to 47
	value = ((uint32_t)input[4] << 24) |
			((uint32_t)input[5] << 16);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 48 to 63
	value = ((uint32_t)input[6] << 24) |
			((uint32_t)input[7] << 16);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 64 to 79
	value = ((uint32_t)input[8] << 24) |
			((uint32_t)input[9] << 16);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 80 to 95
	value = ((uint32_t)input[10] << 24) |
			((uint32_t)input[11] << 16);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 96 to 111
	value = ((uint32_t)input[12] << 24) |
			((uint32_t)input[13] << 16);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 112 to 127
	value = ((uint32_t)input[14] << 24) |
			((uint32_t)input[15] << 16);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 128 to 143
	value = ((uint32_t)input[16] << 24) |
			((uint32_t)input[17] << 16);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 144 to 159
	value = ((uint32_t)input[18] << 24) |
			((uint32_t)input[19] << 16);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 160 to 175
	value = ((uint32_t)input[20] << 24) |
			((uint32_t)input[21] << 16);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 176 to 191
	value = ((uint32_t)input[22] << 24) |
			((uint32_t)input[23] << 16);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 192 to 207
	value = ((uint32_t)input[24] << 24) |
			((uint32_t)input[25] << 16);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 208 to 223
	value = ((uint32_t)input[26] << 24) |
			((uint32_t)input[27] << 16);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 224 to 239
	value = ((uint32_t)input[28] << 24) |
			((uint32_t)input[29] << 16);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 240 to 255
	value = ((uint32_t)input[30] << 24) |
			((uint32_t)input[31] << 16);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 256 to 271
	value = ((uint32_t)input[32] << 24) |
			((uint32_t)input[33] << 16);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 272 to 287
	value = ((uint32_t)input[34] << 24) |
			((uint32_t)input[35] << 16);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 288 to 303
	value = ((uint32_t)input[36] << 24) |
			((uint32_t)input[37] << 16);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 304 to 319
	value = ((uint32_t)input[38] << 24) |
			((uint32_t)input[39] << 16);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 320 to 335
	value = ((uint32_t)input[40] << 24) |
			((uint32_t)input[41] << 16);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 336 to 351
	value = ((uint32_t)input[42] << 24) |
			((uint32_t)input[43] << 16);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 352 to 367
	value = ((uint32_t)input[44] << 24) |
			((uint32_t)input[45] << 16);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 368 to 383
	value = ((uint32_t)input[46] << 24) |
			((uint32_t)input[47] << 16);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 384 to 399
	value = ((uint32_t)input[48] << 24) |
			((uint32_t)input[49] << 16);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 400 to 415
	value = ((uint32_t)input[50] << 24) |
			((uint32_t)input[51] << 16);
	output[25] = (double)(value >> 16);
}

static void unpack_26_16bit_signed_1off(const uint8_t * input, double * output, void *closure) {
	// Unpack 26 values into output
	// Values are 16-bit signed
	// Skip 1 bits, read 416 bits of data.
	// Input must be at least 53 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 1 to 16
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)input[1] << 17) |
			((uint32_t)(input[2] & 0x80) << 9);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 17 to 32
	value = ((uint32_t)(input[2] & 0x7f) << 25) |
			((uint32_t)input[3] << 17) |
			((uint32_t)(input[4] & 0x80) << 9);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 33 to 48
	value = ((uint32_t)(input[4] & 0x7f) << 25) |
			((uint32_t)input[5] << 17) |
			((uint32_t)(input[6] & 0x80) << 9);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 49 to 64
	value = ((uint32_t)(input[6] & 0x7f) << 25) |
			((uint32_t)input[7] << 17) |
			((uint32_t)(input[8] & 0x80) << 9);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 65 to 80
	value = ((uint32_t)(input[8] & 0x7f) << 25) |
			((uint32_t)input[9] << 17) |
			((uint32_t)(input[10] & 0x80) << 9);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 81 to 96
	value = ((uint32_t)(input[10] & 0x7f) << 25) |
			((uint32_t)input[11] << 17) |
			((uint32_t)(input[12] & 0x80) << 9);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 97 to 112
	value = ((uint32_t)(input[12] & 0x7f) << 25) |
			((uint32_t)input[13] << 17) |
			((uint32_t)(input[14] & 0x80) << 9);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 113 to 128
	value = ((uint32_t)(input[14] & 0x7f) << 25) |
			((uint32_t)input[15] << 17) |
			((uint32_t)(input[16] & 0x80) << 9);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 129 to 144
	value = ((uint32_t)(input[16] & 0x7f) << 25) |
			((uint32_t)input[17] << 17) |
			((uint32_t)(input[18] & 0x80) << 9);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 145 to 160
	value = ((uint32_t)(input[18] & 0x7f) << 25) |
			((uint32_t)input[19] << 17) |
			((uint32_t)(input[20] & 0x80) << 9);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 161 to 176
	value = ((uint32_t)(input[20] & 0x7f) << 25) |
			((uint32_t)input[21] << 17) |
			((uint32_t)(input[22] & 0x80) << 9);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 177 to 192
	value = ((uint32_t)(input[22] & 0x7f) << 25) |
			((uint32_t)input[23] << 17) |
			((uint32_t)(input[24] & 0x80) << 9);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 193 to 208
	value = ((uint32_t)(input[24] & 0x7f) << 25) |
			((uint32_t)input[25] << 17) |
			((uint32_t)(input[26] & 0x80) << 9);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 209 to 224
	value = ((uint32_t)(input[26] & 0x7f) << 25) |
			((uint32_t)input[27] << 17) |
			((uint32_t)(input[28] & 0x80) << 9);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 225 to 240
	value = ((uint32_t)(input[28] & 0x7f) << 25) |
			((uint32_t)input[29] << 17) |
			((uint32_t)(input[30] & 0x80) << 9);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 241 to 256
	value = ((uint32_t)(input[30] & 0x7f) << 25) |
			((uint32_t)input[31] << 17) |
			((uint32_t)(input[32] & 0x80) << 9);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 257 to 272
	value = ((uint32_t)(input[32] & 0x7f) << 25) |
			((uint32_t)input[33] << 17) |
			((uint32_t)(input[34] & 0x80) << 9);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 273 to 288
	value = ((uint32_t)(input[34] & 0x7f) << 25) |
			((uint32_t)input[35] << 17) |
			((uint32_t)(input[36] & 0x80) << 9);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 289 to 304
	value = ((uint32_t)(input[36] & 0x7f) << 25) |
			((uint32_t)input[37] << 17) |
			((uint32_t)(input[38] & 0x80) << 9);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 305 to 320
	value = ((uint32_t)(input[38] & 0x7f) << 25) |
			((uint32_t)input[39] << 17) |
			((uint32_t)(input[40] & 0x80) << 9);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 321 to 336
	value = ((uint32_t)(input[40] & 0x7f) << 25) |
			((uint32_t)input[41] << 17) |
			((uint32_t)(input[42] & 0x80) << 9);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 337 to 352
	value = ((uint32_t)(input[42] & 0x7f) << 25) |
			((uint32_t)input[43] << 17) |
			((uint32_t)(input[44] & 0x80) << 9);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 353 to 368
	value = ((uint32_t)(input[44] & 0x7f) << 25) |
			((uint32_t)input[45] << 17) |
			((uint32_t)(input[46] & 0x80) << 9);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 369 to 384
	value = ((uint32_t)(input[46] & 0x7f) << 25) |
			((uint32_t)input[47] << 17) |
			((uint32_t)(input[48] & 0x80) << 9);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 385 to 400
	value = ((uint32_t)(input[48] & 0x7f) << 25) |
			((uint32_t)input[49] << 17) |
			((uint32_t)(input[50] & 0x80) << 9);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 401 to 416
	value = ((uint32_t)(input[50] & 0x7f) << 25) |
			((uint32_t)input[51] << 17) |
			((uint32_t)(input[52] & 0x80) << 9);
	output[25] = (double)(value >> 16);
}

static void unpack_26_16bit_unsigned_1off(const uint8_t * input, double * output, void *closure) {
	// Unpack 26 values into output
	// Values are 16-bit unsigned
	// Skip 1 bits, read 416 bits of data.
	// Input must be at least 53 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 1 to 16
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)input[1] << 17) |
			((uint32_t)(input[2] & 0x80) << 9);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 17 to 32
	value = ((uint32_t)(input[2] & 0x7f) << 25) |
			((uint32_t)input[3] << 17) |
			((uint32_t)(input[4] & 0x80) << 9);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 33 to 48
	value = ((uint32_t)(input[4] & 0x7f) << 25) |
			((uint32_t)input[5] << 17) |
			((uint32_t)(input[6] & 0x80) << 9);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 49 to 64
	value = ((uint32_t)(input[6] & 0x7f) << 25) |
			((uint32_t)input[7] << 17) |
			((uint32_t)(input[8] & 0x80) << 9);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 65 to 80
	value = ((uint32_t)(input[8] & 0x7f) << 25) |
			((uint32_t)input[9] << 17) |
			((uint32_t)(input[10] & 0x80) << 9);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 81 to 96
	value = ((uint32_t)(input[10] & 0x7f) << 25) |
			((uint32_t)input[11] << 17) |
			((uint32_t)(input[12] & 0x80) << 9);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 97 to 112
	value = ((uint32_t)(input[12] & 0x7f) << 25) |
			((uint32_t)input[13] << 17) |
			((uint32_t)(input[14] & 0x80) << 9);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 113 to 128
	value = ((uint32_t)(input[14] & 0x7f) << 25) |
			((uint32_t)input[15] << 17) |
			((uint32_t)(input[16] & 0x80) << 9);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 129 to 144
	value = ((uint32_t)(input[16] & 0x7f) << 25) |
			((uint32_t)input[17] << 17) |
			((uint32_t)(input[18] & 0x80) << 9);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 145 to 160
	value = ((uint32_t)(input[18] & 0x7f) << 25) |
			((uint32_t)input[19] << 17) |
			((uint32_t)(input[20] & 0x80) << 9);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 161 to 176
	value = ((uint32_t)(input[20] & 0x7f) << 25) |
			((uint32_t)input[21] << 17) |
			((uint32_t)(input[22] & 0x80) << 9);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 177 to 192
	value = ((uint32_t)(input[22] & 0x7f) << 25) |
			((uint32_t)input[23] << 17) |
			((uint32_t)(input[24] & 0x80) << 9);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 193 to 208
	value = ((uint32_t)(input[24] & 0x7f) << 25) |
			((uint32_t)input[25] << 17) |
			((uint32_t)(input[26] & 0x80) << 9);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 209 to 224
	value = ((uint32_t)(input[26] & 0x7f) << 25) |
			((uint32_t)input[27] << 17) |
			((uint32_t)(input[28] & 0x80) << 9);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 225 to 240
	value = ((uint32_t)(input[28] & 0x7f) << 25) |
			((uint32_t)input[29] << 17) |
			((uint32_t)(input[30] & 0x80) << 9);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 241 to 256
	value = ((uint32_t)(input[30] & 0x7f) << 25) |
			((uint32_t)input[31] << 17) |
			((uint32_t)(input[32] & 0x80) << 9);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 257 to 272
	value = ((uint32_t)(input[32] & 0x7f) << 25) |
			((uint32_t)input[33] << 17) |
			((uint32_t)(input[34] & 0x80) << 9);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 273 to 288
	value = ((uint32_t)(input[34] & 0x7f) << 25) |
			((uint32_t)input[35] << 17) |
			((uint32_t)(input[36] & 0x80) << 9);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 289 to 304
	value = ((uint32_t)(input[36] & 0x7f) << 25) |
			((uint32_t)input[37] << 17) |
			((uint32_t)(input[38] & 0x80) << 9);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 305 to 320
	value = ((uint32_t)(input[38] & 0x7f) << 25) |
			((uint32_t)input[39] << 17) |
			((uint32_t)(input[40] & 0x80) << 9);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 321 to 336
	value = ((uint32_t)(input[40] & 0x7f) << 25) |
			((uint32_t)input[41] << 17) |
			((uint32_t)(input[42] & 0x80) << 9);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 337 to 352
	value = ((uint32_t)(input[42] & 0x7f) << 25) |
			((uint32_t)input[43] << 17) |
			((uint32_t)(input[44] & 0x80) << 9);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 353 to 368
	value = ((uint32_t)(input[44] & 0x7f) << 25) |
			((uint32_t)input[45] << 17) |
			((uint32_t)(input[46] & 0x80) << 9);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 369 to 384
	value = ((uint32_t)(input[46] & 0x7f) << 25) |
			((uint32_t)input[47] << 17) |
			((uint32_t)(input[48] & 0x80) << 9);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 385 to 400
	value = ((uint32_t)(input[48] & 0x7f) << 25) |
			((uint32_t)input[49] << 17) |
			((uint32_t)(input[50] & 0x80) << 9);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 401 to 416
	value = ((uint32_t)(input[50] & 0x7f) << 25) |
			((uint32_t)input[51] << 17) |
			((uint32_t)(input[52] & 0x80) << 9);
	output[25] = (double)(value >> 16);
}

static void unpack_26_16bit_signed_2off(const uint8_t * input, double * output, void *closure) {
	// Unpack 26 values into output
	// Values are 16-bit signed
	// Skip 2 bits, read 416 bits of data.
	// Input must be at least 53 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 2 to 17
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)input[1] << 18) |
			((uint32_t)(input[2] & 0xc0) << 10);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 18 to 33
	value = ((uint32_t)(input[2] & 0x3f) << 26) |
			((uint32_t)input[3] << 18) |
			((uint32_t)(input[4] & 0xc0) << 10);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 34 to 49
	value = ((uint32_t)(input[4] & 0x3f) << 26) |
			((uint32_t)input[5] << 18) |
			((uint32_t)(input[6] & 0xc0) << 10);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 50 to 65
	value = ((uint32_t)(input[6] & 0x3f) << 26) |
			((uint32_t)input[7] << 18) |
			((uint32_t)(input[8] & 0xc0) << 10);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 66 to 81
	value = ((uint32_t)(input[8] & 0x3f) << 26) |
			((uint32_t)input[9] << 18) |
			((uint32_t)(input[10] & 0xc0) << 10);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 82 to 97
	value = ((uint32_t)(input[10] & 0x3f) << 26) |
			((uint32_t)input[11] << 18) |
			((uint32_t)(input[12] & 0xc0) << 10);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 98 to 113
	value = ((uint32_t)(input[12] & 0x3f) << 26) |
			((uint32_t)input[13] << 18) |
			((uint32_t)(input[14] & 0xc0) << 10);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 114 to 129
	value = ((uint32_t)(input[14] & 0x3f) << 26) |
			((uint32_t)input[15] << 18) |
			((uint32_t)(input[16] & 0xc0) << 10);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 130 to 145
	value = ((uint32_t)(input[16] & 0x3f) << 26) |
			((uint32_t)input[17] << 18) |
			((uint32_t)(input[18] & 0xc0) << 10);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 146 to 161
	value = ((uint32_t)(input[18] & 0x3f) << 26) |
			((uint32_t)input[19] << 18) |
			((uint32_t)(input[20] & 0xc0) << 10);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 162 to 177
	value = ((uint32_t)(input[20] & 0x3f) << 26) |
			((uint32_t)input[21] << 18) |
			((uint32_t)(input[22] & 0xc0) << 10);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 178 to 193
	value = ((uint32_t)(input[22] & 0x3f) << 26) |
			((uint32_t)input[23] << 18) |
			((uint32_t)(input[24] & 0xc0) << 10);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 194 to 209
	value = ((uint32_t)(input[24] & 0x3f) << 26) |
			((uint32_t)input[25] << 18) |
			((uint32_t)(input[26] & 0xc0) << 10);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 210 to 225
	value = ((uint32_t)(input[26] & 0x3f) << 26) |
			((uint32_t)input[27] << 18) |
			((uint32_t)(input[28] & 0xc0) << 10);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 226 to 241
	value = ((uint32_t)(input[28] & 0x3f) << 26) |
			((uint32_t)input[29] << 18) |
			((uint32_t)(input[30] & 0xc0) << 10);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 242 to 257
	value = ((uint32_t)(input[30] & 0x3f) << 26) |
			((uint32_t)input[31] << 18) |
			((uint32_t)(input[32] & 0xc0) << 10);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 258 to 273
	value = ((uint32_t)(input[32] & 0x3f) << 26) |
			((uint32_t)input[33] << 18) |
			((uint32_t)(input[34] & 0xc0) << 10);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 274 to 289
	value = ((uint32_t)(input[34] & 0x3f) << 26) |
			((uint32_t)input[35] << 18) |
			((uint32_t)(input[36] & 0xc0) << 10);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 290 to 305
	value = ((uint32_t)(input[36] & 0x3f) << 26) |
			((uint32_t)input[37] << 18) |
			((uint32_t)(input[38] & 0xc0) << 10);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 306 to 321
	value = ((uint32_t)(input[38] & 0x3f) << 26) |
			((uint32_t)input[39] << 18) |
			((uint32_t)(input[40] & 0xc0) << 10);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 322 to 337
	value = ((uint32_t)(input[40] & 0x3f) << 26) |
			((uint32_t)input[41] << 18) |
			((uint32_t)(input[42] & 0xc0) << 10);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 338 to 353
	value = ((uint32_t)(input[42] & 0x3f) << 26) |
			((uint32_t)input[43] << 18) |
			((uint32_t)(input[44] & 0xc0) << 10);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 354 to 369
	value = ((uint32_t)(input[44] & 0x3f) << 26) |
			((uint32_t)input[45] << 18) |
			((uint32_t)(input[46] & 0xc0) << 10);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 370 to 385
	value = ((uint32_t)(input[46] & 0x3f) << 26) |
			((uint32_t)input[47] << 18) |
			((uint32_t)(input[48] & 0xc0) << 10);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 386 to 401
	value = ((uint32_t)(input[48] & 0x3f) << 26) |
			((uint32_t)input[49] << 18) |
			((uint32_t)(input[50] & 0xc0) << 10);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 402 to 417
	value = ((uint32_t)(input[50] & 0x3f) << 26) |
			((uint32_t)input[51] << 18) |
			((uint32_t)(input[52] & 0xc0) << 10);
	output[25] = (double)(value >> 16);
}

static void unpack_26_16bit_unsigned_2off(const uint8_t * input, double * output, void *closure) {
	// Unpack 26 values into output
	// Values are 16-bit unsigned
	// Skip 2 bits, read 416 bits of data.
	// Input must be at least 53 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 2 to 17
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)input[1] << 18) |
			((uint32_t)(input[2] & 0xc0) << 10);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 18 to 33
	value = ((uint32_t)(input[2] & 0x3f) << 26) |
			((uint32_t)input[3] << 18) |
			((uint32_t)(input[4] & 0xc0) << 10);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 34 to 49
	value = ((uint32_t)(input[4] & 0x3f) << 26) |
			((uint32_t)input[5] << 18) |
			((uint32_t)(input[6] & 0xc0) << 10);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 50 to 65
	value = ((uint32_t)(input[6] & 0x3f) << 26) |
			((uint32_t)input[7] << 18) |
			((uint32_t)(input[8] & 0xc0) << 10);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 66 to 81
	value = ((uint32_t)(input[8] & 0x3f) << 26) |
			((uint32_t)input[9] << 18) |
			((uint32_t)(input[10] & 0xc0) << 10);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 82 to 97
	value = ((uint32_t)(input[10] & 0x3f) << 26) |
			((uint32_t)input[11] << 18) |
			((uint32_t)(input[12] & 0xc0) << 10);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 98 to 113
	value = ((uint32_t)(input[12] & 0x3f) << 26) |
			((uint32_t)input[13] << 18) |
			((uint32_t)(input[14] & 0xc0) << 10);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 114 to 129
	value = ((uint32_t)(input[14] & 0x3f) << 26) |
			((uint32_t)input[15] << 18) |
			((uint32_t)(input[16] & 0xc0) << 10);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 130 to 145
	value = ((uint32_t)(input[16] & 0x3f) << 26) |
			((uint32_t)input[17] << 18) |
			((uint32_t)(input[18] & 0xc0) << 10);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 146 to 161
	value = ((uint32_t)(input[18] & 0x3f) << 26) |
			((uint32_t)input[19] << 18) |
			((uint32_t)(input[20] & 0xc0) << 10);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 162 to 177
	value = ((uint32_t)(input[20] & 0x3f) << 26) |
			((uint32_t)input[21] << 18) |
			((uint32_t)(input[22] & 0xc0) << 10);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 178 to 193
	value = ((uint32_t)(input[22] & 0x3f) << 26) |
			((uint32_t)input[23] << 18) |
			((uint32_t)(input[24] & 0xc0) << 10);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 194 to 209
	value = ((uint32_t)(input[24] & 0x3f) << 26) |
			((uint32_t)input[25] << 18) |
			((uint32_t)(input[26] & 0xc0) << 10);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 210 to 225
	value = ((uint32_t)(input[26] & 0x3f) << 26) |
			((uint32_t)input[27] << 18) |
			((uint32_t)(input[28] & 0xc0) << 10);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 226 to 241
	value = ((uint32_t)(input[28] & 0x3f) << 26) |
			((uint32_t)input[29] << 18) |
			((uint32_t)(input[30] & 0xc0) << 10);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 242 to 257
	value = ((uint32_t)(input[30] & 0x3f) << 26) |
			((uint32_t)input[31] << 18) |
			((uint32_t)(input[32] & 0xc0) << 10);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 258 to 273
	value = ((uint32_t)(input[32] & 0x3f) << 26) |
			((uint32_t)input[33] << 18) |
			((uint32_t)(input[34] & 0xc0) << 10);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 274 to 289
	value = ((uint32_t)(input[34] & 0x3f) << 26) |
			((uint32_t)input[35] << 18) |
			((uint32_t)(input[36] & 0xc0) << 10);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 290 to 305
	value = ((uint32_t)(input[36] & 0x3f) << 26) |
			((uint32_t)input[37] << 18) |
			((uint32_t)(input[38] & 0xc0) << 10);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 306 to 321
	value = ((uint32_t)(input[38] & 0x3f) << 26) |
			((uint32_t)input[39] << 18) |
			((uint32_t)(input[40] & 0xc0) << 10);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 322 to 337
	value = ((uint32_t)(input[40] & 0x3f) << 26) |
			((uint32_t)input[41] << 18) |
			((uint32_t)(input[42] & 0xc0) << 10);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 338 to 353
	value = ((uint32_t)(input[42] & 0x3f) << 26) |
			((uint32_t)input[43] << 18) |
			((uint32_t)(input[44] & 0xc0) << 10);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 354 to 369
	value = ((uint32_t)(input[44] & 0x3f) << 26) |
			((uint32_t)input[45] << 18) |
			((uint32_t)(input[46] & 0xc0) << 10);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 370 to 385
	value = ((uint32_t)(input[46] & 0x3f) << 26) |
			((uint32_t)input[47] << 18) |
			((uint32_t)(input[48] & 0xc0) << 10);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 386 to 401
	value = ((uint32_t)(input[48] & 0x3f) << 26) |
			((uint32_t)input[49] << 18) |
			((uint32_t)(input[50] & 0xc0) << 10);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 402 to 417
	value = ((uint32_t)(input[50] & 0x3f) << 26) |
			((uint32_t)input[51] << 18) |
			((uint32_t)(input[52] & 0xc0) << 10);
	output[25] = (double)(value >> 16);
}

static void unpack_26_16bit_signed_3off(const uint8_t * input, double * output, void *closure) {
	// Unpack 26 values into output
	// Values are 16-bit signed
	// Skip 3 bits, read 416 bits of data.
	// Input must be at least 53 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 3 to 18
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)input[1] << 19) |
			((uint32_t)(input[2] & 0xe0) << 11);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 19 to 34
	value = ((uint32_t)(input[2] & 0x1f) << 27) |
			((uint32_t)input[3] << 19) |
			((uint32_t)(input[4] & 0xe0) << 11);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 35 to 50
	value = ((uint32_t)(input[4] & 0x1f) << 27) |
			((uint32_t)input[5] << 19) |
			((uint32_t)(input[6] & 0xe0) << 11);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 51 to 66
	value = ((uint32_t)(input[6] & 0x1f) << 27) |
			((uint32_t)input[7] << 19) |
			((uint32_t)(input[8] & 0xe0) << 11);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 67 to 82
	value = ((uint32_t)(input[8] & 0x1f) << 27) |
			((uint32_t)input[9] << 19) |
			((uint32_t)(input[10] & 0xe0) << 11);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 83 to 98
	value = ((uint32_t)(input[10] & 0x1f) << 27) |
			((uint32_t)input[11] << 19) |
			((uint32_t)(input[12] & 0xe0) << 11);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 99 to 114
	value = ((uint32_t)(input[12] & 0x1f) << 27) |
			((uint32_t)input[13] << 19) |
			((uint32_t)(input[14] & 0xe0) << 11);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 115 to 130
	value = ((uint32_t)(input[14] & 0x1f) << 27) |
			((uint32_t)input[15] << 19) |
			((uint32_t)(input[16] & 0xe0) << 11);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 131 to 146
	value = ((uint32_t)(input[16] & 0x1f) << 27) |
			((uint32_t)input[17] << 19) |
			((uint32_t)(input[18] & 0xe0) << 11);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 147 to 162
	value = ((uint32_t)(input[18] & 0x1f) << 27) |
			((uint32_t)input[19] << 19) |
			((uint32_t)(input[20] & 0xe0) << 11);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 163 to 178
	value = ((uint32_t)(input[20] & 0x1f) << 27) |
			((uint32_t)input[21] << 19) |
			((uint32_t)(input[22] & 0xe0) << 11);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 179 to 194
	value = ((uint32_t)(input[22] & 0x1f) << 27) |
			((uint32_t)input[23] << 19) |
			((uint32_t)(input[24] & 0xe0) << 11);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 195 to 210
	value = ((uint32_t)(input[24] & 0x1f) << 27) |
			((uint32_t)input[25] << 19) |
			((uint32_t)(input[26] & 0xe0) << 11);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 211 to 226
	value = ((uint32_t)(input[26] & 0x1f) << 27) |
			((uint32_t)input[27] << 19) |
			((uint32_t)(input[28] & 0xe0) << 11);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 227 to 242
	value = ((uint32_t)(input[28] & 0x1f) << 27) |
			((uint32_t)input[29] << 19) |
			((uint32_t)(input[30] & 0xe0) << 11);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 243 to 258
	value = ((uint32_t)(input[30] & 0x1f) << 27) |
			((uint32_t)input[31] << 19) |
			((uint32_t)(input[32] & 0xe0) << 11);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 259 to 274
	value = ((uint32_t)(input[32] & 0x1f) << 27) |
			((uint32_t)input[33] << 19) |
			((uint32_t)(input[34] & 0xe0) << 11);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 275 to 290
	value = ((uint32_t)(input[34] & 0x1f) << 27) |
			((uint32_t)input[35] << 19) |
			((uint32_t)(input[36] & 0xe0) << 11);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 291 to 306
	value = ((uint32_t)(input[36] & 0x1f) << 27) |
			((uint32_t)input[37] << 19) |
			((uint32_t)(input[38] & 0xe0) << 11);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 307 to 322
	value = ((uint32_t)(input[38] & 0x1f) << 27) |
			((uint32_t)input[39] << 19) |
			((uint32_t)(input[40] & 0xe0) << 11);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 323 to 338
	value = ((uint32_t)(input[40] & 0x1f) << 27) |
			((uint32_t)input[41] << 19) |
			((uint32_t)(input[42] & 0xe0) << 11);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 339 to 354
	value = ((uint32_t)(input[42] & 0x1f) << 27) |
			((uint32_t)input[43] << 19) |
			((uint32_t)(input[44] & 0xe0) << 11);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 355 to 370
	value = ((uint32_t)(input[44] & 0x1f) << 27) |
			((uint32_t)input[45] << 19) |
			((uint32_t)(input[46] & 0xe0) << 11);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 371 to 386
	value = ((uint32_t)(input[46] & 0x1f) << 27) |
			((uint32_t)input[47] << 19) |
			((uint32_t)(input[48] & 0xe0) << 11);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 387 to 402
	value = ((uint32_t)(input[48] & 0x1f) << 27) |
			((uint32_t)input[49] << 19) |
			((uint32_t)(input[50] & 0xe0) << 11);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 403 to 418
	value = ((uint32_t)(input[50] & 0x1f) << 27) |
			((uint32_t)input[51] << 19) |
			((uint32_t)(input[52] & 0xe0) << 11);
	output[25] = (double)(value >> 16);
}

static void unpack_26_16bit_unsigned_3off(const uint8_t * input, double * output, void *closure) {
	// Unpack 26 values into output
	// Values are 16-bit unsigned
	// Skip 3 bits, read 416 bits of data.
	// Input must be at least 53 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 3 to 18
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)input[1] << 19) |
			((uint32_t)(input[2] & 0xe0) << 11);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 19 to 34
	value = ((uint32_t)(input[2] & 0x1f) << 27) |
			((uint32_t)input[3] << 19) |
			((uint32_t)(input[4] & 0xe0) << 11);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 35 to 50
	value = ((uint32_t)(input[4] & 0x1f) << 27) |
			((uint32_t)input[5] << 19) |
			((uint32_t)(input[6] & 0xe0) << 11);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 51 to 66
	value = ((uint32_t)(input[6] & 0x1f) << 27) |
			((uint32_t)input[7] << 19) |
			((uint32_t)(input[8] & 0xe0) << 11);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 67 to 82
	value = ((uint32_t)(input[8] & 0x1f) << 27) |
			((uint32_t)input[9] << 19) |
			((uint32_t)(input[10] & 0xe0) << 11);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 83 to 98
	value = ((uint32_t)(input[10] & 0x1f) << 27) |
			((uint32_t)input[11] << 19) |
			((uint32_t)(input[12] & 0xe0) << 11);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 99 to 114
	value = ((uint32_t)(input[12] & 0x1f) << 27) |
			((uint32_t)input[13] << 19) |
			((uint32_t)(input[14] & 0xe0) << 11);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 115 to 130
	value = ((uint32_t)(input[14] & 0x1f) << 27) |
			((uint32_t)input[15] << 19) |
			((uint32_t)(input[16] & 0xe0) << 11);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 131 to 146
	value = ((uint32_t)(input[16] & 0x1f) << 27) |
			((uint32_t)input[17] << 19) |
			((uint32_t)(input[18] & 0xe0) << 11);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 147 to 162
	value = ((uint32_t)(input[18] & 0x1f) << 27) |
			((uint32_t)input[19] << 19) |
			((uint32_t)(input[20] & 0xe0) << 11);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 163 to 178
	value = ((uint32_t)(input[20] & 0x1f) << 27) |
			((uint32_t)input[21] << 19) |
			((uint32_t)(input[22] & 0xe0) << 11);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 179 to 194
	value = ((uint32_t)(input[22] & 0x1f) << 27) |
			((uint32_t)input[23] << 19) |
			((uint32_t)(input[24] & 0xe0) << 11);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 195 to 210
	value = ((uint32_t)(input[24] & 0x1f) << 27) |
			((uint32_t)input[25] << 19) |
			((uint32_t)(input[26] & 0xe0) << 11);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 211 to 226
	value = ((uint32_t)(input[26] & 0x1f) << 27) |
			((uint32_t)input[27] << 19) |
			((uint32_t)(input[28] & 0xe0) << 11);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 227 to 242
	value = ((uint32_t)(input[28] & 0x1f) << 27) |
			((uint32_t)input[29] << 19) |
			((uint32_t)(input[30] & 0xe0) << 11);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 243 to 258
	value = ((uint32_t)(input[30] & 0x1f) << 27) |
			((uint32_t)input[31] << 19) |
			((uint32_t)(input[32] & 0xe0) << 11);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 259 to 274
	value = ((uint32_t)(input[32] & 0x1f) << 27) |
			((uint32_t)input[33] << 19) |
			((uint32_t)(input[34] & 0xe0) << 11);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 275 to 290
	value = ((uint32_t)(input[34] & 0x1f) << 27) |
			((uint32_t)input[35] << 19) |
			((uint32_t)(input[36] & 0xe0) << 11);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 291 to 306
	value = ((uint32_t)(input[36] & 0x1f) << 27) |
			((uint32_t)input[37] << 19) |
			((uint32_t)(input[38] & 0xe0) << 11);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 307 to 322
	value = ((uint32_t)(input[38] & 0x1f) << 27) |
			((uint32_t)input[39] << 19) |
			((uint32_t)(input[40] & 0xe0) << 11);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 323 to 338
	value = ((uint32_t)(input[40] & 0x1f) << 27) |
			((uint32_t)input[41] << 19) |
			((uint32_t)(input[42] & 0xe0) << 11);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 339 to 354
	value = ((uint32_t)(input[42] & 0x1f) << 27) |
			((uint32_t)input[43] << 19) |
			((uint32_t)(input[44] & 0xe0) << 11);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 355 to 370
	value = ((uint32_t)(input[44] & 0x1f) << 27) |
			((uint32_t)input[45] << 19) |
			((uint32_t)(input[46] & 0xe0) << 11);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 371 to 386
	value = ((uint32_t)(input[46] & 0x1f) << 27) |
			((uint32_t)input[47] << 19) |
			((uint32_t)(input[48] & 0xe0) << 11);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 387 to 402
	value = ((uint32_t)(input[48] & 0x1f) << 27) |
			((uint32_t)input[49] << 19) |
			((uint32_t)(input[50] & 0xe0) << 11);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 403 to 418
	value = ((uint32_t)(input[50] & 0x1f) << 27) |
			((uint32_t)input[51] << 19) |
			((uint32_t)(input[52] & 0xe0) << 11);
	output[25] = (double)(value >> 16);
}

static void unpack_26_16bit_signed_4off(const uint8_t * input, double * output, void *closure) {
	// Unpack 26 values into output
	// Values are 16-bit signed
	// Skip 4 bits, read 416 bits of data.
	// Input must be at least 53 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 4 to 19
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20) |
			((uint32_t)(input[2] & 0xf0) << 12);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 20 to 35
	value = ((uint32_t)(input[2] & 0x0f) << 28) |
			((uint32_t)input[3] << 20) |
			((uint32_t)(input[4] & 0xf0) << 12);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 36 to 51
	value = ((uint32_t)(input[4] & 0x0f) << 28) |
			((uint32_t)input[5] << 20) |
			((uint32_t)(input[6] & 0xf0) << 12);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 52 to 67
	value = ((uint32_t)(input[6] & 0x0f) << 28) |
			((uint32_t)input[7] << 20) |
			((uint32_t)(input[8] & 0xf0) << 12);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 68 to 83
	value = ((uint32_t)(input[8] & 0x0f) << 28) |
			((uint32_t)input[9] << 20) |
			((uint32_t)(input[10] & 0xf0) << 12);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 84 to 99
	value = ((uint32_t)(input[10] & 0x0f) << 28) |
			((uint32_t)input[11] << 20) |
			((uint32_t)(input[12] & 0xf0) << 12);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 100 to 115
	value = ((uint32_t)(input[12] & 0x0f) << 28) |
			((uint32_t)input[13] << 20) |
			((uint32_t)(input[14] & 0xf0) << 12);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 116 to 131
	value = ((uint32_t)(input[14] & 0x0f) << 28) |
			((uint32_t)input[15] << 20) |
			((uint32_t)(input[16] & 0xf0) << 12);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 132 to 147
	value = ((uint32_t)(input[16] & 0x0f) << 28) |
			((uint32_t)input[17] << 20) |
			((uint32_t)(input[18] & 0xf0) << 12);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 148 to 163
	value = ((uint32_t)(input[18] & 0x0f) << 28) |
			((uint32_t)input[19] << 20) |
			((uint32_t)(input[20] & 0xf0) << 12);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 164 to 179
	value = ((uint32_t)(input[20] & 0x0f) << 28) |
			((uint32_t)input[21] << 20) |
			((uint32_t)(input[22] & 0xf0) << 12);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 180 to 195
	value = ((uint32_t)(input[22] & 0x0f) << 28) |
			((uint32_t)input[23] << 20) |
			((uint32_t)(input[24] & 0xf0) << 12);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 196 to 211
	value = ((uint32_t)(input[24] & 0x0f) << 28) |
			((uint32_t)input[25] << 20) |
			((uint32_t)(input[26] & 0xf0) << 12);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 212 to 227
	value = ((uint32_t)(input[26] & 0x0f) << 28) |
			((uint32_t)input[27] << 20) |
			((uint32_t)(input[28] & 0xf0) << 12);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 228 to 243
	value = ((uint32_t)(input[28] & 0x0f) << 28) |
			((uint32_t)input[29] << 20) |
			((uint32_t)(input[30] & 0xf0) << 12);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 244 to 259
	value = ((uint32_t)(input[30] & 0x0f) << 28) |
			((uint32_t)input[31] << 20) |
			((uint32_t)(input[32] & 0xf0) << 12);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 260 to 275
	value = ((uint32_t)(input[32] & 0x0f) << 28) |
			((uint32_t)input[33] << 20) |
			((uint32_t)(input[34] & 0xf0) << 12);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 276 to 291
	value = ((uint32_t)(input[34] & 0x0f) << 28) |
			((uint32_t)input[35] << 20) |
			((uint32_t)(input[36] & 0xf0) << 12);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 292 to 307
	value = ((uint32_t)(input[36] & 0x0f) << 28) |
			((uint32_t)input[37] << 20) |
			((uint32_t)(input[38] & 0xf0) << 12);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 308 to 323
	value = ((uint32_t)(input[38] & 0x0f) << 28) |
			((uint32_t)input[39] << 20) |
			((uint32_t)(input[40] & 0xf0) << 12);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 324 to 339
	value = ((uint32_t)(input[40] & 0x0f) << 28) |
			((uint32_t)input[41] << 20) |
			((uint32_t)(input[42] & 0xf0) << 12);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 340 to 355
	value = ((uint32_t)(input[42] & 0x0f) << 28) |
			((uint32_t)input[43] << 20) |
			((uint32_t)(input[44] & 0xf0) << 12);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 356 to 371
	value = ((uint32_t)(input[44] & 0x0f) << 28) |
			((uint32_t)input[45] << 20) |
			((uint32_t)(input[46] & 0xf0) << 12);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 372 to 387
	value = ((uint32_t)(input[46] & 0x0f) << 28) |
			((uint32_t)input[47] << 20) |
			((uint32_t)(input[48] & 0xf0) << 12);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 388 to 403
	value = ((uint32_t)(input[48] & 0x0f) << 28) |
			((uint32_t)input[49] << 20) |
			((uint32_t)(input[50] & 0xf0) << 12);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 404 to 419
	value = ((uint32_t)(input[50] & 0x0f) << 28) |
			((uint32_t)input[51] << 20) |
			((uint32_t)(input[52] & 0xf0) << 12);
	output[25] = (double)(value >> 16);
}

static void unpack_26_16bit_unsigned_4off(const uint8_t * input, double * output, void *closure) {
	// Unpack 26 values into output
	// Values are 16-bit unsigned
	// Skip 4 bits, read 416 bits of data.
	// Input must be at least 53 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 4 to 19
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20) |
			((uint32_t)(input[2] & 0xf0) << 12);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 20 to 35
	value = ((uint32_t)(input[2] & 0x0f) << 28) |
			((uint32_t)input[3] << 20) |
			((uint32_t)(input[4] & 0xf0) << 12);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 36 to 51
	value = ((uint32_t)(input[4] & 0x0f) << 28) |
			((uint32_t)input[5] << 20) |
			((uint32_t)(input[6] & 0xf0) << 12);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 52 to 67
	value = ((uint32_t)(input[6] & 0x0f) << 28) |
			((uint32_t)input[7] << 20) |
			((uint32_t)(input[8] & 0xf0) << 12);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 68 to 83
	value = ((uint32_t)(input[8] & 0x0f) << 28) |
			((uint32_t)input[9] << 20) |
			((uint32_t)(input[10] & 0xf0) << 12);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 84 to 99
	value = ((uint32_t)(input[10] & 0x0f) << 28) |
			((uint32_t)input[11] << 20) |
			((uint32_t)(input[12] & 0xf0) << 12);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 100 to 115
	value = ((uint32_t)(input[12] & 0x0f) << 28) |
			((uint32_t)input[13] << 20) |
			((uint32_t)(input[14] & 0xf0) << 12);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 116 to 131
	value = ((uint32_t)(input[14] & 0x0f) << 28) |
			((uint32_t)input[15] << 20) |
			((uint32_t)(input[16] & 0xf0) << 12);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 132 to 147
	value = ((uint32_t)(input[16] & 0x0f) << 28) |
			((uint32_t)input[17] << 20) |
			((uint32_t)(input[18] & 0xf0) << 12);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 148 to 163
	value = ((uint32_t)(input[18] & 0x0f) << 28) |
			((uint32_t)input[19] << 20) |
			((uint32_t)(input[20] & 0xf0) << 12);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 164 to 179
	value = ((uint32_t)(input[20] & 0x0f) << 28) |
			((uint32_t)input[21] << 20) |
			((uint32_t)(input[22] & 0xf0) << 12);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 180 to 195
	value = ((uint32_t)(input[22] & 0x0f) << 28) |
			((uint32_t)input[23] << 20) |
			((uint32_t)(input[24] & 0xf0) << 12);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 196 to 211
	value = ((uint32_t)(input[24] & 0x0f) << 28) |
			((uint32_t)input[25] << 20) |
			((uint32_t)(input[26] & 0xf0) << 12);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 212 to 227
	value = ((uint32_t)(input[26] & 0x0f) << 28) |
			((uint32_t)input[27] << 20) |
			((uint32_t)(input[28] & 0xf0) << 12);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 228 to 243
	value = ((uint32_t)(input[28] & 0x0f) << 28) |
			((uint32_t)input[29] << 20) |
			((uint32_t)(input[30] & 0xf0) << 12);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 244 to 259
	value = ((uint32_t)(input[30] & 0x0f) << 28) |
			((uint32_t)input[31] << 20) |
			((uint32_t)(input[32] & 0xf0) << 12);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 260 to 275
	value = ((uint32_t)(input[32] & 0x0f) << 28) |
			((uint32_t)input[33] << 20) |
			((uint32_t)(input[34] & 0xf0) << 12);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 276 to 291
	value = ((uint32_t)(input[34] & 0x0f) << 28) |
			((uint32_t)input[35] << 20) |
			((uint32_t)(input[36] & 0xf0) << 12);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 292 to 307
	value = ((uint32_t)(input[36] & 0x0f) << 28) |
			((uint32_t)input[37] << 20) |
			((uint32_t)(input[38] & 0xf0) << 12);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 308 to 323
	value = ((uint32_t)(input[38] & 0x0f) << 28) |
			((uint32_t)input[39] << 20) |
			((uint32_t)(input[40] & 0xf0) << 12);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 324 to 339
	value = ((uint32_t)(input[40] & 0x0f) << 28) |
			((uint32_t)input[41] << 20) |
			((uint32_t)(input[42] & 0xf0) << 12);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 340 to 355
	value = ((uint32_t)(input[42] & 0x0f) << 28) |
			((uint32_t)input[43] << 20) |
			((uint32_t)(input[44] & 0xf0) << 12);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 356 to 371
	value = ((uint32_t)(input[44] & 0x0f) << 28) |
			((uint32_t)input[45] << 20) |
			((uint32_t)(input[46] & 0xf0) << 12);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 372 to 387
	value = ((uint32_t)(input[46] & 0x0f) << 28) |
			((uint32_t)input[47] << 20) |
			((uint32_t)(input[48] & 0xf0) << 12);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 388 to 403
	value = ((uint32_t)(input[48] & 0x0f) << 28) |
			((uint32_t)input[49] << 20) |
			((uint32_t)(input[50] & 0xf0) << 12);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 404 to 419
	value = ((uint32_t)(input[50] & 0x0f) << 28) |
			((uint32_t)input[51] << 20) |
			((uint32_t)(input[52] & 0xf0) << 12);
	output[25] = (double)(value >> 16);
}

static void unpack_26_16bit_signed_5off(const uint8_t * input, double * output, void *closure) {
	// Unpack 26 values into output
	// Values are 16-bit signed
	// Skip 5 bits, read 416 bits of data.
	// Input must be at least 53 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 5 to 20
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)(input[2] & 0xf8) << 13);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 21 to 36
	value = ((uint32_t)(input[2] & 0x07) << 29) |
			((uint32_t)input[3] << 21) |
			((uint32_t)(input[4] & 0xf8) << 13);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 37 to 52
	value = ((uint32_t)(input[4] & 0x07) << 29) |
			((uint32_t)input[5] << 21) |
			((uint32_t)(input[6] & 0xf8) << 13);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 53 to 68
	value = ((uint32_t)(input[6] & 0x07) << 29) |
			((uint32_t)input[7] << 21) |
			((uint32_t)(input[8] & 0xf8) << 13);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 69 to 84
	value = ((uint32_t)(input[8] & 0x07) << 29) |
			((uint32_t)input[9] << 21) |
			((uint32_t)(input[10] & 0xf8) << 13);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 85 to 100
	value = ((uint32_t)(input[10] & 0x07) << 29) |
			((uint32_t)input[11] << 21) |
			((uint32_t)(input[12] & 0xf8) << 13);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 101 to 116
	value = ((uint32_t)(input[12] & 0x07) << 29) |
			((uint32_t)input[13] << 21) |
			((uint32_t)(input[14] & 0xf8) << 13);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 117 to 132
	value = ((uint32_t)(input[14] & 0x07) << 29) |
			((uint32_t)input[15] << 21) |
			((uint32_t)(input[16] & 0xf8) << 13);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 133 to 148
	value = ((uint32_t)(input[16] & 0x07) << 29) |
			((uint32_t)input[17] << 21) |
			((uint32_t)(input[18] & 0xf8) << 13);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 149 to 164
	value = ((uint32_t)(input[18] & 0x07) << 29) |
			((uint32_t)input[19] << 21) |
			((uint32_t)(input[20] & 0xf8) << 13);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 165 to 180
	value = ((uint32_t)(input[20] & 0x07) << 29) |
			((uint32_t)input[21] << 21) |
			((uint32_t)(input[22] & 0xf8) << 13);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 181 to 196
	value = ((uint32_t)(input[22] & 0x07) << 29) |
			((uint32_t)input[23] << 21) |
			((uint32_t)(input[24] & 0xf8) << 13);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 197 to 212
	value = ((uint32_t)(input[24] & 0x07) << 29) |
			((uint32_t)input[25] << 21) |
			((uint32_t)(input[26] & 0xf8) << 13);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 213 to 228
	value = ((uint32_t)(input[26] & 0x07) << 29) |
			((uint32_t)input[27] << 21) |
			((uint32_t)(input[28] & 0xf8) << 13);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 229 to 244
	value = ((uint32_t)(input[28] & 0x07) << 29) |
			((uint32_t)input[29] << 21) |
			((uint32_t)(input[30] & 0xf8) << 13);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 245 to 260
	value = ((uint32_t)(input[30] & 0x07) << 29) |
			((uint32_t)input[31] << 21) |
			((uint32_t)(input[32] & 0xf8) << 13);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 261 to 276
	value = ((uint32_t)(input[32] & 0x07) << 29) |
			((uint32_t)input[33] << 21) |
			((uint32_t)(input[34] & 0xf8) << 13);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 277 to 292
	value = ((uint32_t)(input[34] & 0x07) << 29) |
			((uint32_t)input[35] << 21) |
			((uint32_t)(input[36] & 0xf8) << 13);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 293 to 308
	value = ((uint32_t)(input[36] & 0x07) << 29) |
			((uint32_t)input[37] << 21) |
			((uint32_t)(input[38] & 0xf8) << 13);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 309 to 324
	value = ((uint32_t)(input[38] & 0x07) << 29) |
			((uint32_t)input[39] << 21) |
			((uint32_t)(input[40] & 0xf8) << 13);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 325 to 340
	value = ((uint32_t)(input[40] & 0x07) << 29) |
			((uint32_t)input[41] << 21) |
			((uint32_t)(input[42] & 0xf8) << 13);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 341 to 356
	value = ((uint32_t)(input[42] & 0x07) << 29) |
			((uint32_t)input[43] << 21) |
			((uint32_t)(input[44] & 0xf8) << 13);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 357 to 372
	value = ((uint32_t)(input[44] & 0x07) << 29) |
			((uint32_t)input[45] << 21) |
			((uint32_t)(input[46] & 0xf8) << 13);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 373 to 388
	value = ((uint32_t)(input[46] & 0x07) << 29) |
			((uint32_t)input[47] << 21) |
			((uint32_t)(input[48] & 0xf8) << 13);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 389 to 404
	value = ((uint32_t)(input[48] & 0x07) << 29) |
			((uint32_t)input[49] << 21) |
			((uint32_t)(input[50] & 0xf8) << 13);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 405 to 420
	value = ((uint32_t)(input[50] & 0x07) << 29) |
			((uint32_t)input[51] << 21) |
			((uint32_t)(input[52] & 0xf8) << 13);
	output[25] = (double)(value >> 16);
}

static void unpack_26_16bit_unsigned_5off(const uint8_t * input, double * output, void *closure) {
	// Unpack 26 values into output
	// Values are 16-bit unsigned
	// Skip 5 bits, read 416 bits of data.
	// Input must be at least 53 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 5 to 20
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)(input[2] & 0xf8) << 13);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 21 to 36
	value = ((uint32_t)(input[2] & 0x07) << 29) |
			((uint32_t)input[3] << 21) |
			((uint32_t)(input[4] & 0xf8) << 13);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 37 to 52
	value = ((uint32_t)(input[4] & 0x07) << 29) |
			((uint32_t)input[5] << 21) |
			((uint32_t)(input[6] & 0xf8) << 13);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 53 to 68
	value = ((uint32_t)(input[6] & 0x07) << 29) |
			((uint32_t)input[7] << 21) |
			((uint32_t)(input[8] & 0xf8) << 13);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 69 to 84
	value = ((uint32_t)(input[8] & 0x07) << 29) |
			((uint32_t)input[9] << 21) |
			((uint32_t)(input[10] & 0xf8) << 13);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 85 to 100
	value = ((uint32_t)(input[10] & 0x07) << 29) |
			((uint32_t)input[11] << 21) |
			((uint32_t)(input[12] & 0xf8) << 13);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 101 to 116
	value = ((uint32_t)(input[12] & 0x07) << 29) |
			((uint32_t)input[13] << 21) |
			((uint32_t)(input[14] & 0xf8) << 13);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 117 to 132
	value = ((uint32_t)(input[14] & 0x07) << 29) |
			((uint32_t)input[15] << 21) |
			((uint32_t)(input[16] & 0xf8) << 13);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 133 to 148
	value = ((uint32_t)(input[16] & 0x07) << 29) |
			((uint32_t)input[17] << 21) |
			((uint32_t)(input[18] & 0xf8) << 13);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 149 to 164
	value = ((uint32_t)(input[18] & 0x07) << 29) |
			((uint32_t)input[19] << 21) |
			((uint32_t)(input[20] & 0xf8) << 13);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 165 to 180
	value = ((uint32_t)(input[20] & 0x07) << 29) |
			((uint32_t)input[21] << 21) |
			((uint32_t)(input[22] & 0xf8) << 13);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 181 to 196
	value = ((uint32_t)(input[22] & 0x07) << 29) |
			((uint32_t)input[23] << 21) |
			((uint32_t)(input[24] & 0xf8) << 13);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 197 to 212
	value = ((uint32_t)(input[24] & 0x07) << 29) |
			((uint32_t)input[25] << 21) |
			((uint32_t)(input[26] & 0xf8) << 13);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 213 to 228
	value = ((uint32_t)(input[26] & 0x07) << 29) |
			((uint32_t)input[27] << 21) |
			((uint32_t)(input[28] & 0xf8) << 13);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 229 to 244
	value = ((uint32_t)(input[28] & 0x07) << 29) |
			((uint32_t)input[29] << 21) |
			((uint32_t)(input[30] & 0xf8) << 13);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 245 to 260
	value = ((uint32_t)(input[30] & 0x07) << 29) |
			((uint32_t)input[31] << 21) |
			((uint32_t)(input[32] & 0xf8) << 13);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 261 to 276
	value = ((uint32_t)(input[32] & 0x07) << 29) |
			((uint32_t)input[33] << 21) |
			((uint32_t)(input[34] & 0xf8) << 13);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 277 to 292
	value = ((uint32_t)(input[34] & 0x07) << 29) |
			((uint32_t)input[35] << 21) |
			((uint32_t)(input[36] & 0xf8) << 13);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 293 to 308
	value = ((uint32_t)(input[36] & 0x07) << 29) |
			((uint32_t)input[37] << 21) |
			((uint32_t)(input[38] & 0xf8) << 13);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 309 to 324
	value = ((uint32_t)(input[38] & 0x07) << 29) |
			((uint32_t)input[39] << 21) |
			((uint32_t)(input[40] & 0xf8) << 13);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 325 to 340
	value = ((uint32_t)(input[40] & 0x07) << 29) |
			((uint32_t)input[41] << 21) |
			((uint32_t)(input[42] & 0xf8) << 13);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 341 to 356
	value = ((uint32_t)(input[42] & 0x07) << 29) |
			((uint32_t)input[43] << 21) |
			((uint32_t)(input[44] & 0xf8) << 13);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 357 to 372
	value = ((uint32_t)(input[44] & 0x07) << 29) |
			((uint32_t)input[45] << 21) |
			((uint32_t)(input[46] & 0xf8) << 13);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 373 to 388
	value = ((uint32_t)(input[46] & 0x07) << 29) |
			((uint32_t)input[47] << 21) |
			((uint32_t)(input[48] & 0xf8) << 13);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 389 to 404
	value = ((uint32_t)(input[48] & 0x07) << 29) |
			((uint32_t)input[49] << 21) |
			((uint32_t)(input[50] & 0xf8) << 13);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 405 to 420
	value = ((uint32_t)(input[50] & 0x07) << 29) |
			((uint32_t)input[51] << 21) |
			((uint32_t)(input[52] & 0xf8) << 13);
	output[25] = (double)(value >> 16);
}

static void unpack_26_16bit_signed_6off(const uint8_t * input, double * output, void *closure) {
	// Unpack 26 values into output
	// Values are 16-bit signed
	// Skip 6 bits, read 416 bits of data.
	// Input must be at least 53 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 6 to 21
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)(input[2] & 0xfc) << 14);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 22 to 37
	value = ((uint32_t)(input[2] & 0x03) << 30) |
			((uint32_t)input[3] << 22) |
			((uint32_t)(input[4] & 0xfc) << 14);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 38 to 53
	value = ((uint32_t)(input[4] & 0x03) << 30) |
			((uint32_t)input[5] << 22) |
			((uint32_t)(input[6] & 0xfc) << 14);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 54 to 69
	value = ((uint32_t)(input[6] & 0x03) << 30) |
			((uint32_t)input[7] << 22) |
			((uint32_t)(input[8] & 0xfc) << 14);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 70 to 85
	value = ((uint32_t)(input[8] & 0x03) << 30) |
			((uint32_t)input[9] << 22) |
			((uint32_t)(input[10] & 0xfc) << 14);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 86 to 101
	value = ((uint32_t)(input[10] & 0x03) << 30) |
			((uint32_t)input[11] << 22) |
			((uint32_t)(input[12] & 0xfc) << 14);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 102 to 117
	value = ((uint32_t)(input[12] & 0x03) << 30) |
			((uint32_t)input[13] << 22) |
			((uint32_t)(input[14] & 0xfc) << 14);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 118 to 133
	value = ((uint32_t)(input[14] & 0x03) << 30) |
			((uint32_t)input[15] << 22) |
			((uint32_t)(input[16] & 0xfc) << 14);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 134 to 149
	value = ((uint32_t)(input[16] & 0x03) << 30) |
			((uint32_t)input[17] << 22) |
			((uint32_t)(input[18] & 0xfc) << 14);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 150 to 165
	value = ((uint32_t)(input[18] & 0x03) << 30) |
			((uint32_t)input[19] << 22) |
			((uint32_t)(input[20] & 0xfc) << 14);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 166 to 181
	value = ((uint32_t)(input[20] & 0x03) << 30) |
			((uint32_t)input[21] << 22) |
			((uint32_t)(input[22] & 0xfc) << 14);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 182 to 197
	value = ((uint32_t)(input[22] & 0x03) << 30) |
			((uint32_t)input[23] << 22) |
			((uint32_t)(input[24] & 0xfc) << 14);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 198 to 213
	value = ((uint32_t)(input[24] & 0x03) << 30) |
			((uint32_t)input[25] << 22) |
			((uint32_t)(input[26] & 0xfc) << 14);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 214 to 229
	value = ((uint32_t)(input[26] & 0x03) << 30) |
			((uint32_t)input[27] << 22) |
			((uint32_t)(input[28] & 0xfc) << 14);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 230 to 245
	value = ((uint32_t)(input[28] & 0x03) << 30) |
			((uint32_t)input[29] << 22) |
			((uint32_t)(input[30] & 0xfc) << 14);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 246 to 261
	value = ((uint32_t)(input[30] & 0x03) << 30) |
			((uint32_t)input[31] << 22) |
			((uint32_t)(input[32] & 0xfc) << 14);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 262 to 277
	value = ((uint32_t)(input[32] & 0x03) << 30) |
			((uint32_t)input[33] << 22) |
			((uint32_t)(input[34] & 0xfc) << 14);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 278 to 293
	value = ((uint32_t)(input[34] & 0x03) << 30) |
			((uint32_t)input[35] << 22) |
			((uint32_t)(input[36] & 0xfc) << 14);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 294 to 309
	value = ((uint32_t)(input[36] & 0x03) << 30) |
			((uint32_t)input[37] << 22) |
			((uint32_t)(input[38] & 0xfc) << 14);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 310 to 325
	value = ((uint32_t)(input[38] & 0x03) << 30) |
			((uint32_t)input[39] << 22) |
			((uint32_t)(input[40] & 0xfc) << 14);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 326 to 341
	value = ((uint32_t)(input[40] & 0x03) << 30) |
			((uint32_t)input[41] << 22) |
			((uint32_t)(input[42] & 0xfc) << 14);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 342 to 357
	value = ((uint32_t)(input[42] & 0x03) << 30) |
			((uint32_t)input[43] << 22) |
			((uint32_t)(input[44] & 0xfc) << 14);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 358 to 373
	value = ((uint32_t)(input[44] & 0x03) << 30) |
			((uint32_t)input[45] << 22) |
			((uint32_t)(input[46] & 0xfc) << 14);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 374 to 389
	value = ((uint32_t)(input[46] & 0x03) << 30) |
			((uint32_t)input[47] << 22) |
			((uint32_t)(input[48] & 0xfc) << 14);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 390 to 405
	value = ((uint32_t)(input[48] & 0x03) << 30) |
			((uint32_t)input[49] << 22) |
			((uint32_t)(input[50] & 0xfc) << 14);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 406 to 421
	value = ((uint32_t)(input[50] & 0x03) << 30) |
			((uint32_t)input[51] << 22) |
			((uint32_t)(input[52] & 0xfc) << 14);
	output[25] = (double)(value >> 16);
}

static void unpack_26_16bit_unsigned_6off(const uint8_t * input, double * output, void *closure) {
	// Unpack 26 values into output
	// Values are 16-bit unsigned
	// Skip 6 bits, read 416 bits of data.
	// Input must be at least 53 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 6 to 21
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)(input[2] & 0xfc) << 14);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 22 to 37
	value = ((uint32_t)(input[2] & 0x03) << 30) |
			((uint32_t)input[3] << 22) |
			((uint32_t)(input[4] & 0xfc) << 14);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 38 to 53
	value = ((uint32_t)(input[4] & 0x03) << 30) |
			((uint32_t)input[5] << 22) |
			((uint32_t)(input[6] & 0xfc) << 14);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 54 to 69
	value = ((uint32_t)(input[6] & 0x03) << 30) |
			((uint32_t)input[7] << 22) |
			((uint32_t)(input[8] & 0xfc) << 14);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 70 to 85
	value = ((uint32_t)(input[8] & 0x03) << 30) |
			((uint32_t)input[9] << 22) |
			((uint32_t)(input[10] & 0xfc) << 14);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 86 to 101
	value = ((uint32_t)(input[10] & 0x03) << 30) |
			((uint32_t)input[11] << 22) |
			((uint32_t)(input[12] & 0xfc) << 14);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 102 to 117
	value = ((uint32_t)(input[12] & 0x03) << 30) |
			((uint32_t)input[13] << 22) |
			((uint32_t)(input[14] & 0xfc) << 14);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 118 to 133
	value = ((uint32_t)(input[14] & 0x03) << 30) |
			((uint32_t)input[15] << 22) |
			((uint32_t)(input[16] & 0xfc) << 14);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 134 to 149
	value = ((uint32_t)(input[16] & 0x03) << 30) |
			((uint32_t)input[17] << 22) |
			((uint32_t)(input[18] & 0xfc) << 14);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 150 to 165
	value = ((uint32_t)(input[18] & 0x03) << 30) |
			((uint32_t)input[19] << 22) |
			((uint32_t)(input[20] & 0xfc) << 14);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 166 to 181
	value = ((uint32_t)(input[20] & 0x03) << 30) |
			((uint32_t)input[21] << 22) |
			((uint32_t)(input[22] & 0xfc) << 14);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 182 to 197
	value = ((uint32_t)(input[22] & 0x03) << 30) |
			((uint32_t)input[23] << 22) |
			((uint32_t)(input[24] & 0xfc) << 14);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 198 to 213
	value = ((uint32_t)(input[24] & 0x03) << 30) |
			((uint32_t)input[25] << 22) |
			((uint32_t)(input[26] & 0xfc) << 14);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 214 to 229
	value = ((uint32_t)(input[26] & 0x03) << 30) |
			((uint32_t)input[27] << 22) |
			((uint32_t)(input[28] & 0xfc) << 14);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 230 to 245
	value = ((uint32_t)(input[28] & 0x03) << 30) |
			((uint32_t)input[29] << 22) |
			((uint32_t)(input[30] & 0xfc) << 14);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 246 to 261
	value = ((uint32_t)(input[30] & 0x03) << 30) |
			((uint32_t)input[31] << 22) |
			((uint32_t)(input[32] & 0xfc) << 14);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 262 to 277
	value = ((uint32_t)(input[32] & 0x03) << 30) |
			((uint32_t)input[33] << 22) |
			((uint32_t)(input[34] & 0xfc) << 14);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 278 to 293
	value = ((uint32_t)(input[34] & 0x03) << 30) |
			((uint32_t)input[35] << 22) |
			((uint32_t)(input[36] & 0xfc) << 14);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 294 to 309
	value = ((uint32_t)(input[36] & 0x03) << 30) |
			((uint32_t)input[37] << 22) |
			((uint32_t)(input[38] & 0xfc) << 14);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 310 to 325
	value = ((uint32_t)(input[38] & 0x03) << 30) |
			((uint32_t)input[39] << 22) |
			((uint32_t)(input[40] & 0xfc) << 14);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 326 to 341
	value = ((uint32_t)(input[40] & 0x03) << 30) |
			((uint32_t)input[41] << 22) |
			((uint32_t)(input[42] & 0xfc) << 14);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 342 to 357
	value = ((uint32_t)(input[42] & 0x03) << 30) |
			((uint32_t)input[43] << 22) |
			((uint32_t)(input[44] & 0xfc) << 14);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 358 to 373
	value = ((uint32_t)(input[44] & 0x03) << 30) |
			((uint32_t)input[45] << 22) |
			((uint32_t)(input[46] & 0xfc) << 14);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 374 to 389
	value = ((uint32_t)(input[46] & 0x03) << 30) |
			((uint32_t)input[47] << 22) |
			((uint32_t)(input[48] & 0xfc) << 14);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 390 to 405
	value = ((uint32_t)(input[48] & 0x03) << 30) |
			((uint32_t)input[49] << 22) |
			((uint32_t)(input[50] & 0xfc) << 14);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 406 to 421
	value = ((uint32_t)(input[50] & 0x03) << 30) |
			((uint32_t)input[51] << 22) |
			((uint32_t)(input[52] & 0xfc) << 14);
	output[25] = (double)(value >> 16);
}

static void unpack_26_16bit_signed_7off(const uint8_t * input, double * output, void *closure) {
	// Unpack 26 values into output
	// Values are 16-bit signed
	// Skip 7 bits, read 416 bits of data.
	// Input must be at least 53 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 7 to 22
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)(input[2] & 0xfe) << 15);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 23 to 38
	value = ((uint32_t)(input[2] & 0x01) << 31) |
			((uint32_t)input[3] << 23) |
			((uint32_t)(input[4] & 0xfe) << 15);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 39 to 54
	value = ((uint32_t)(input[4] & 0x01) << 31) |
			((uint32_t)input[5] << 23) |
			((uint32_t)(input[6] & 0xfe) << 15);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 55 to 70
	value = ((uint32_t)(input[6] & 0x01) << 31) |
			((uint32_t)input[7] << 23) |
			((uint32_t)(input[8] & 0xfe) << 15);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 71 to 86
	value = ((uint32_t)(input[8] & 0x01) << 31) |
			((uint32_t)input[9] << 23) |
			((uint32_t)(input[10] & 0xfe) << 15);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 87 to 102
	value = ((uint32_t)(input[10] & 0x01) << 31) |
			((uint32_t)input[11] << 23) |
			((uint32_t)(input[12] & 0xfe) << 15);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 103 to 118
	value = ((uint32_t)(input[12] & 0x01) << 31) |
			((uint32_t)input[13] << 23) |
			((uint32_t)(input[14] & 0xfe) << 15);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 119 to 134
	value = ((uint32_t)(input[14] & 0x01) << 31) |
			((uint32_t)input[15] << 23) |
			((uint32_t)(input[16] & 0xfe) << 15);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 135 to 150
	value = ((uint32_t)(input[16] & 0x01) << 31) |
			((uint32_t)input[17] << 23) |
			((uint32_t)(input[18] & 0xfe) << 15);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 151 to 166
	value = ((uint32_t)(input[18] & 0x01) << 31) |
			((uint32_t)input[19] << 23) |
			((uint32_t)(input[20] & 0xfe) << 15);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 167 to 182
	value = ((uint32_t)(input[20] & 0x01) << 31) |
			((uint32_t)input[21] << 23) |
			((uint32_t)(input[22] & 0xfe) << 15);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 183 to 198
	value = ((uint32_t)(input[22] & 0x01) << 31) |
			((uint32_t)input[23] << 23) |
			((uint32_t)(input[24] & 0xfe) << 15);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 199 to 214
	value = ((uint32_t)(input[24] & 0x01) << 31) |
			((uint32_t)input[25] << 23) |
			((uint32_t)(input[26] & 0xfe) << 15);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 215 to 230
	value = ((uint32_t)(input[26] & 0x01) << 31) |
			((uint32_t)input[27] << 23) |
			((uint32_t)(input[28] & 0xfe) << 15);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 231 to 246
	value = ((uint32_t)(input[28] & 0x01) << 31) |
			((uint32_t)input[29] << 23) |
			((uint32_t)(input[30] & 0xfe) << 15);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 247 to 262
	value = ((uint32_t)(input[30] & 0x01) << 31) |
			((uint32_t)input[31] << 23) |
			((uint32_t)(input[32] & 0xfe) << 15);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 263 to 278
	value = ((uint32_t)(input[32] & 0x01) << 31) |
			((uint32_t)input[33] << 23) |
			((uint32_t)(input[34] & 0xfe) << 15);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 279 to 294
	value = ((uint32_t)(input[34] & 0x01) << 31) |
			((uint32_t)input[35] << 23) |
			((uint32_t)(input[36] & 0xfe) << 15);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 295 to 310
	value = ((uint32_t)(input[36] & 0x01) << 31) |
			((uint32_t)input[37] << 23) |
			((uint32_t)(input[38] & 0xfe) << 15);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 311 to 326
	value = ((uint32_t)(input[38] & 0x01) << 31) |
			((uint32_t)input[39] << 23) |
			((uint32_t)(input[40] & 0xfe) << 15);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 327 to 342
	value = ((uint32_t)(input[40] & 0x01) << 31) |
			((uint32_t)input[41] << 23) |
			((uint32_t)(input[42] & 0xfe) << 15);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 343 to 358
	value = ((uint32_t)(input[42] & 0x01) << 31) |
			((uint32_t)input[43] << 23) |
			((uint32_t)(input[44] & 0xfe) << 15);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 359 to 374
	value = ((uint32_t)(input[44] & 0x01) << 31) |
			((uint32_t)input[45] << 23) |
			((uint32_t)(input[46] & 0xfe) << 15);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 375 to 390
	value = ((uint32_t)(input[46] & 0x01) << 31) |
			((uint32_t)input[47] << 23) |
			((uint32_t)(input[48] & 0xfe) << 15);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 391 to 406
	value = ((uint32_t)(input[48] & 0x01) << 31) |
			((uint32_t)input[49] << 23) |
			((uint32_t)(input[50] & 0xfe) << 15);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 407 to 422
	value = ((uint32_t)(input[50] & 0x01) << 31) |
			((uint32_t)input[51] << 23) |
			((uint32_t)(input[52] & 0xfe) << 15);
	output[25] = (double)(value >> 16);
}

static void unpack_26_16bit_unsigned_7off(const uint8_t * input, double * output, void *closure) {
	// Unpack 26 values into output
	// Values are 16-bit unsigned
	// Skip 7 bits, read 416 bits of data.
	// Input must be at least 53 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 7 to 22
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)(input[2] & 0xfe) << 15);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 23 to 38
	value = ((uint32_t)(input[2] & 0x01) << 31) |
			((uint32_t)input[3] << 23) |
			((uint32_t)(input[4] & 0xfe) << 15);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 39 to 54
	value = ((uint32_t)(input[4] & 0x01) << 31) |
			((uint32_t)input[5] << 23) |
			((uint32_t)(input[6] & 0xfe) << 15);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 55 to 70
	value = ((uint32_t)(input[6] & 0x01) << 31) |
			((uint32_t)input[7] << 23) |
			((uint32_t)(input[8] & 0xfe) << 15);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 71 to 86
	value = ((uint32_t)(input[8] & 0x01) << 31) |
			((uint32_t)input[9] << 23) |
			((uint32_t)(input[10] & 0xfe) << 15);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 87 to 102
	value = ((uint32_t)(input[10] & 0x01) << 31) |
			((uint32_t)input[11] << 23) |
			((uint32_t)(input[12] & 0xfe) << 15);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 103 to 118
	value = ((uint32_t)(input[12] & 0x01) << 31) |
			((uint32_t)input[13] << 23) |
			((uint32_t)(input[14] & 0xfe) << 15);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 119 to 134
	value = ((uint32_t)(input[14] & 0x01) << 31) |
			((uint32_t)input[15] << 23) |
			((uint32_t)(input[16] & 0xfe) << 15);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 135 to 150
	value = ((uint32_t)(input[16] & 0x01) << 31) |
			((uint32_t)input[17] << 23) |
			((uint32_t)(input[18] & 0xfe) << 15);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 151 to 166
	value = ((uint32_t)(input[18] & 0x01) << 31) |
			((uint32_t)input[19] << 23) |
			((uint32_t)(input[20] & 0xfe) << 15);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 167 to 182
	value = ((uint32_t)(input[20] & 0x01) << 31) |
			((uint32_t)input[21] << 23) |
			((uint32_t)(input[22] & 0xfe) << 15);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 183 to 198
	value = ((uint32_t)(input[22] & 0x01) << 31) |
			((uint32_t)input[23] << 23) |
			((uint32_t)(input[24] & 0xfe) << 15);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 199 to 214
	value = ((uint32_t)(input[24] & 0x01) << 31) |
			((uint32_t)input[25] << 23) |
			((uint32_t)(input[26] & 0xfe) << 15);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 215 to 230
	value = ((uint32_t)(input[26] & 0x01) << 31) |
			((uint32_t)input[27] << 23) |
			((uint32_t)(input[28] & 0xfe) << 15);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 231 to 246
	value = ((uint32_t)(input[28] & 0x01) << 31) |
			((uint32_t)input[29] << 23) |
			((uint32_t)(input[30] & 0xfe) << 15);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 247 to 262
	value = ((uint32_t)(input[30] & 0x01) << 31) |
			((uint32_t)input[31] << 23) |
			((uint32_t)(input[32] & 0xfe) << 15);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 263 to 278
	value = ((uint32_t)(input[32] & 0x01) << 31) |
			((uint32_t)input[33] << 23) |
			((uint32_t)(input[34] & 0xfe) << 15);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 279 to 294
	value = ((uint32_t)(input[34] & 0x01) << 31) |
			((uint32_t)input[35] << 23) |
			((uint32_t)(input[36] & 0xfe) << 15);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 295 to 310
	value = ((uint32_t)(input[36] & 0x01) << 31) |
			((uint32_t)input[37] << 23) |
			((uint32_t)(input[38] & 0xfe) << 15);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 311 to 326
	value = ((uint32_t)(input[38] & 0x01) << 31) |
			((uint32_t)input[39] << 23) |
			((uint32_t)(input[40] & 0xfe) << 15);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 327 to 342
	value = ((uint32_t)(input[40] & 0x01) << 31) |
			((uint32_t)input[41] << 23) |
			((uint32_t)(input[42] & 0xfe) << 15);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 343 to 358
	value = ((uint32_t)(input[42] & 0x01) << 31) |
			((uint32_t)input[43] << 23) |
			((uint32_t)(input[44] & 0xfe) << 15);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 359 to 374
	value = ((uint32_t)(input[44] & 0x01) << 31) |
			((uint32_t)input[45] << 23) |
			((uint32_t)(input[46] & 0xfe) << 15);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 375 to 390
	value = ((uint32_t)(input[46] & 0x01) << 31) |
			((uint32_t)input[47] << 23) |
			((uint32_t)(input[48] & 0xfe) << 15);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 391 to 406
	value = ((uint32_t)(input[48] & 0x01) << 31) |
			((uint32_t)input[49] << 23) |
			((uint32_t)(input[50] & 0xfe) << 15);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 407 to 422
	value = ((uint32_t)(input[50] & 0x01) << 31) |
			((uint32_t)input[51] << 23) |
			((uint32_t)(input[52] & 0xfe) << 15);
	output[25] = (double)(value >> 16);
}

static void unpack_27_16bit_signed_0off(const uint8_t * input, double * output, void *closure) {
	// Unpack 27 values into output
	// Values are 16-bit signed
	// Skip 0 bits, read 432 bits of data.
	// Input must be at least 54 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 0 to 15
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)input[1] << 16);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 16 to 31
	value = ((uint32_t)input[2] << 24) |
			((uint32_t)input[3] << 16);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 32 to 47
	value = ((uint32_t)input[4] << 24) |
			((uint32_t)input[5] << 16);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 48 to 63
	value = ((uint32_t)input[6] << 24) |
			((uint32_t)input[7] << 16);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 64 to 79
	value = ((uint32_t)input[8] << 24) |
			((uint32_t)input[9] << 16);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 80 to 95
	value = ((uint32_t)input[10] << 24) |
			((uint32_t)input[11] << 16);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 96 to 111
	value = ((uint32_t)input[12] << 24) |
			((uint32_t)input[13] << 16);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 112 to 127
	value = ((uint32_t)input[14] << 24) |
			((uint32_t)input[15] << 16);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 128 to 143
	value = ((uint32_t)input[16] << 24) |
			((uint32_t)input[17] << 16);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 144 to 159
	value = ((uint32_t)input[18] << 24) |
			((uint32_t)input[19] << 16);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 160 to 175
	value = ((uint32_t)input[20] << 24) |
			((uint32_t)input[21] << 16);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 176 to 191
	value = ((uint32_t)input[22] << 24) |
			((uint32_t)input[23] << 16);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 192 to 207
	value = ((uint32_t)input[24] << 24) |
			((uint32_t)input[25] << 16);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 208 to 223
	value = ((uint32_t)input[26] << 24) |
			((uint32_t)input[27] << 16);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 224 to 239
	value = ((uint32_t)input[28] << 24) |
			((uint32_t)input[29] << 16);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 240 to 255
	value = ((uint32_t)input[30] << 24) |
			((uint32_t)input[31] << 16);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 256 to 271
	value = ((uint32_t)input[32] << 24) |
			((uint32_t)input[33] << 16);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 272 to 287
	value = ((uint32_t)input[34] << 24) |
			((uint32_t)input[35] << 16);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 288 to 303
	value = ((uint32_t)input[36] << 24) |
			((uint32_t)input[37] << 16);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 304 to 319
	value = ((uint32_t)input[38] << 24) |
			((uint32_t)input[39] << 16);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 320 to 335
	value = ((uint32_t)input[40] << 24) |
			((uint32_t)input[41] << 16);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 336 to 351
	value = ((uint32_t)input[42] << 24) |
			((uint32_t)input[43] << 16);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 352 to 367
	value = ((uint32_t)input[44] << 24) |
			((uint32_t)input[45] << 16);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 368 to 383
	value = ((uint32_t)input[46] << 24) |
			((uint32_t)input[47] << 16);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 384 to 399
	value = ((uint32_t)input[48] << 24) |
			((uint32_t)input[49] << 16);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 400 to 415
	value = ((uint32_t)input[50] << 24) |
			((uint32_t)input[51] << 16);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 416 to 431
	value = ((uint32_t)input[52] << 24) |
			((uint32_t)input[53] << 16);
	output[26] = (double)(value >> 16);
}

static void unpack_27_16bit_unsigned_0off(const uint8_t * input, double * output, void *closure) {
	// Unpack 27 values into output
	// Values are 16-bit unsigned
	// Skip 0 bits, read 432 bits of data.
	// Input must be at least 54 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 0 to 15
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)input[1] << 16);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 16 to 31
	value = ((uint32_t)input[2] << 24) |
			((uint32_t)input[3] << 16);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 32 to 47
	value = ((uint32_t)input[4] << 24) |
			((uint32_t)input[5] << 16);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 48 to 63
	value = ((uint32_t)input[6] << 24) |
			((uint32_t)input[7] << 16);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 64 to 79
	value = ((uint32_t)input[8] << 24) |
			((uint32_t)input[9] << 16);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 80 to 95
	value = ((uint32_t)input[10] << 24) |
			((uint32_t)input[11] << 16);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 96 to 111
	value = ((uint32_t)input[12] << 24) |
			((uint32_t)input[13] << 16);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 112 to 127
	value = ((uint32_t)input[14] << 24) |
			((uint32_t)input[15] << 16);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 128 to 143
	value = ((uint32_t)input[16] << 24) |
			((uint32_t)input[17] << 16);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 144 to 159
	value = ((uint32_t)input[18] << 24) |
			((uint32_t)input[19] << 16);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 160 to 175
	value = ((uint32_t)input[20] << 24) |
			((uint32_t)input[21] << 16);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 176 to 191
	value = ((uint32_t)input[22] << 24) |
			((uint32_t)input[23] << 16);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 192 to 207
	value = ((uint32_t)input[24] << 24) |
			((uint32_t)input[25] << 16);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 208 to 223
	value = ((uint32_t)input[26] << 24) |
			((uint32_t)input[27] << 16);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 224 to 239
	value = ((uint32_t)input[28] << 24) |
			((uint32_t)input[29] << 16);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 240 to 255
	value = ((uint32_t)input[30] << 24) |
			((uint32_t)input[31] << 16);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 256 to 271
	value = ((uint32_t)input[32] << 24) |
			((uint32_t)input[33] << 16);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 272 to 287
	value = ((uint32_t)input[34] << 24) |
			((uint32_t)input[35] << 16);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 288 to 303
	value = ((uint32_t)input[36] << 24) |
			((uint32_t)input[37] << 16);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 304 to 319
	value = ((uint32_t)input[38] << 24) |
			((uint32_t)input[39] << 16);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 320 to 335
	value = ((uint32_t)input[40] << 24) |
			((uint32_t)input[41] << 16);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 336 to 351
	value = ((uint32_t)input[42] << 24) |
			((uint32_t)input[43] << 16);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 352 to 367
	value = ((uint32_t)input[44] << 24) |
			((uint32_t)input[45] << 16);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 368 to 383
	value = ((uint32_t)input[46] << 24) |
			((uint32_t)input[47] << 16);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 384 to 399
	value = ((uint32_t)input[48] << 24) |
			((uint32_t)input[49] << 16);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 400 to 415
	value = ((uint32_t)input[50] << 24) |
			((uint32_t)input[51] << 16);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 416 to 431
	value = ((uint32_t)input[52] << 24) |
			((uint32_t)input[53] << 16);
	output[26] = (double)(value >> 16);
}

static void unpack_27_16bit_signed_1off(const uint8_t * input, double * output, void *closure) {
	// Unpack 27 values into output
	// Values are 16-bit signed
	// Skip 1 bits, read 432 bits of data.
	// Input must be at least 55 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 1 to 16
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)input[1] << 17) |
			((uint32_t)(input[2] & 0x80) << 9);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 17 to 32
	value = ((uint32_t)(input[2] & 0x7f) << 25) |
			((uint32_t)input[3] << 17) |
			((uint32_t)(input[4] & 0x80) << 9);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 33 to 48
	value = ((uint32_t)(input[4] & 0x7f) << 25) |
			((uint32_t)input[5] << 17) |
			((uint32_t)(input[6] & 0x80) << 9);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 49 to 64
	value = ((uint32_t)(input[6] & 0x7f) << 25) |
			((uint32_t)input[7] << 17) |
			((uint32_t)(input[8] & 0x80) << 9);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 65 to 80
	value = ((uint32_t)(input[8] & 0x7f) << 25) |
			((uint32_t)input[9] << 17) |
			((uint32_t)(input[10] & 0x80) << 9);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 81 to 96
	value = ((uint32_t)(input[10] & 0x7f) << 25) |
			((uint32_t)input[11] << 17) |
			((uint32_t)(input[12] & 0x80) << 9);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 97 to 112
	value = ((uint32_t)(input[12] & 0x7f) << 25) |
			((uint32_t)input[13] << 17) |
			((uint32_t)(input[14] & 0x80) << 9);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 113 to 128
	value = ((uint32_t)(input[14] & 0x7f) << 25) |
			((uint32_t)input[15] << 17) |
			((uint32_t)(input[16] & 0x80) << 9);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 129 to 144
	value = ((uint32_t)(input[16] & 0x7f) << 25) |
			((uint32_t)input[17] << 17) |
			((uint32_t)(input[18] & 0x80) << 9);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 145 to 160
	value = ((uint32_t)(input[18] & 0x7f) << 25) |
			((uint32_t)input[19] << 17) |
			((uint32_t)(input[20] & 0x80) << 9);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 161 to 176
	value = ((uint32_t)(input[20] & 0x7f) << 25) |
			((uint32_t)input[21] << 17) |
			((uint32_t)(input[22] & 0x80) << 9);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 177 to 192
	value = ((uint32_t)(input[22] & 0x7f) << 25) |
			((uint32_t)input[23] << 17) |
			((uint32_t)(input[24] & 0x80) << 9);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 193 to 208
	value = ((uint32_t)(input[24] & 0x7f) << 25) |
			((uint32_t)input[25] << 17) |
			((uint32_t)(input[26] & 0x80) << 9);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 209 to 224
	value = ((uint32_t)(input[26] & 0x7f) << 25) |
			((uint32_t)input[27] << 17) |
			((uint32_t)(input[28] & 0x80) << 9);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 225 to 240
	value = ((uint32_t)(input[28] & 0x7f) << 25) |
			((uint32_t)input[29] << 17) |
			((uint32_t)(input[30] & 0x80) << 9);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 241 to 256
	value = ((uint32_t)(input[30] & 0x7f) << 25) |
			((uint32_t)input[31] << 17) |
			((uint32_t)(input[32] & 0x80) << 9);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 257 to 272
	value = ((uint32_t)(input[32] & 0x7f) << 25) |
			((uint32_t)input[33] << 17) |
			((uint32_t)(input[34] & 0x80) << 9);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 273 to 288
	value = ((uint32_t)(input[34] & 0x7f) << 25) |
			((uint32_t)input[35] << 17) |
			((uint32_t)(input[36] & 0x80) << 9);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 289 to 304
	value = ((uint32_t)(input[36] & 0x7f) << 25) |
			((uint32_t)input[37] << 17) |
			((uint32_t)(input[38] & 0x80) << 9);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 305 to 320
	value = ((uint32_t)(input[38] & 0x7f) << 25) |
			((uint32_t)input[39] << 17) |
			((uint32_t)(input[40] & 0x80) << 9);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 321 to 336
	value = ((uint32_t)(input[40] & 0x7f) << 25) |
			((uint32_t)input[41] << 17) |
			((uint32_t)(input[42] & 0x80) << 9);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 337 to 352
	value = ((uint32_t)(input[42] & 0x7f) << 25) |
			((uint32_t)input[43] << 17) |
			((uint32_t)(input[44] & 0x80) << 9);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 353 to 368
	value = ((uint32_t)(input[44] & 0x7f) << 25) |
			((uint32_t)input[45] << 17) |
			((uint32_t)(input[46] & 0x80) << 9);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 369 to 384
	value = ((uint32_t)(input[46] & 0x7f) << 25) |
			((uint32_t)input[47] << 17) |
			((uint32_t)(input[48] & 0x80) << 9);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 385 to 400
	value = ((uint32_t)(input[48] & 0x7f) << 25) |
			((uint32_t)input[49] << 17) |
			((uint32_t)(input[50] & 0x80) << 9);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 401 to 416
	value = ((uint32_t)(input[50] & 0x7f) << 25) |
			((uint32_t)input[51] << 17) |
			((uint32_t)(input[52] & 0x80) << 9);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 417 to 432
	value = ((uint32_t)(input[52] & 0x7f) << 25) |
			((uint32_t)input[53] << 17) |
			((uint32_t)(input[54] & 0x80) << 9);
	output[26] = (double)(value >> 16);
}

static void unpack_27_16bit_unsigned_1off(const uint8_t * input, double * output, void *closure) {
	// Unpack 27 values into output
	// Values are 16-bit unsigned
	// Skip 1 bits, read 432 bits of data.
	// Input must be at least 55 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 1 to 16
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)input[1] << 17) |
			((uint32_t)(input[2] & 0x80) << 9);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 17 to 32
	value = ((uint32_t)(input[2] & 0x7f) << 25) |
			((uint32_t)input[3] << 17) |
			((uint32_t)(input[4] & 0x80) << 9);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 33 to 48
	value = ((uint32_t)(input[4] & 0x7f) << 25) |
			((uint32_t)input[5] << 17) |
			((uint32_t)(input[6] & 0x80) << 9);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 49 to 64
	value = ((uint32_t)(input[6] & 0x7f) << 25) |
			((uint32_t)input[7] << 17) |
			((uint32_t)(input[8] & 0x80) << 9);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 65 to 80
	value = ((uint32_t)(input[8] & 0x7f) << 25) |
			((uint32_t)input[9] << 17) |
			((uint32_t)(input[10] & 0x80) << 9);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 81 to 96
	value = ((uint32_t)(input[10] & 0x7f) << 25) |
			((uint32_t)input[11] << 17) |
			((uint32_t)(input[12] & 0x80) << 9);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 97 to 112
	value = ((uint32_t)(input[12] & 0x7f) << 25) |
			((uint32_t)input[13] << 17) |
			((uint32_t)(input[14] & 0x80) << 9);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 113 to 128
	value = ((uint32_t)(input[14] & 0x7f) << 25) |
			((uint32_t)input[15] << 17) |
			((uint32_t)(input[16] & 0x80) << 9);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 129 to 144
	value = ((uint32_t)(input[16] & 0x7f) << 25) |
			((uint32_t)input[17] << 17) |
			((uint32_t)(input[18] & 0x80) << 9);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 145 to 160
	value = ((uint32_t)(input[18] & 0x7f) << 25) |
			((uint32_t)input[19] << 17) |
			((uint32_t)(input[20] & 0x80) << 9);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 161 to 176
	value = ((uint32_t)(input[20] & 0x7f) << 25) |
			((uint32_t)input[21] << 17) |
			((uint32_t)(input[22] & 0x80) << 9);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 177 to 192
	value = ((uint32_t)(input[22] & 0x7f) << 25) |
			((uint32_t)input[23] << 17) |
			((uint32_t)(input[24] & 0x80) << 9);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 193 to 208
	value = ((uint32_t)(input[24] & 0x7f) << 25) |
			((uint32_t)input[25] << 17) |
			((uint32_t)(input[26] & 0x80) << 9);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 209 to 224
	value = ((uint32_t)(input[26] & 0x7f) << 25) |
			((uint32_t)input[27] << 17) |
			((uint32_t)(input[28] & 0x80) << 9);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 225 to 240
	value = ((uint32_t)(input[28] & 0x7f) << 25) |
			((uint32_t)input[29] << 17) |
			((uint32_t)(input[30] & 0x80) << 9);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 241 to 256
	value = ((uint32_t)(input[30] & 0x7f) << 25) |
			((uint32_t)input[31] << 17) |
			((uint32_t)(input[32] & 0x80) << 9);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 257 to 272
	value = ((uint32_t)(input[32] & 0x7f) << 25) |
			((uint32_t)input[33] << 17) |
			((uint32_t)(input[34] & 0x80) << 9);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 273 to 288
	value = ((uint32_t)(input[34] & 0x7f) << 25) |
			((uint32_t)input[35] << 17) |
			((uint32_t)(input[36] & 0x80) << 9);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 289 to 304
	value = ((uint32_t)(input[36] & 0x7f) << 25) |
			((uint32_t)input[37] << 17) |
			((uint32_t)(input[38] & 0x80) << 9);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 305 to 320
	value = ((uint32_t)(input[38] & 0x7f) << 25) |
			((uint32_t)input[39] << 17) |
			((uint32_t)(input[40] & 0x80) << 9);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 321 to 336
	value = ((uint32_t)(input[40] & 0x7f) << 25) |
			((uint32_t)input[41] << 17) |
			((uint32_t)(input[42] & 0x80) << 9);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 337 to 352
	value = ((uint32_t)(input[42] & 0x7f) << 25) |
			((uint32_t)input[43] << 17) |
			((uint32_t)(input[44] & 0x80) << 9);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 353 to 368
	value = ((uint32_t)(input[44] & 0x7f) << 25) |
			((uint32_t)input[45] << 17) |
			((uint32_t)(input[46] & 0x80) << 9);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 369 to 384
	value = ((uint32_t)(input[46] & 0x7f) << 25) |
			((uint32_t)input[47] << 17) |
			((uint32_t)(input[48] & 0x80) << 9);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 385 to 400
	value = ((uint32_t)(input[48] & 0x7f) << 25) |
			((uint32_t)input[49] << 17) |
			((uint32_t)(input[50] & 0x80) << 9);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 401 to 416
	value = ((uint32_t)(input[50] & 0x7f) << 25) |
			((uint32_t)input[51] << 17) |
			((uint32_t)(input[52] & 0x80) << 9);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 417 to 432
	value = ((uint32_t)(input[52] & 0x7f) << 25) |
			((uint32_t)input[53] << 17) |
			((uint32_t)(input[54] & 0x80) << 9);
	output[26] = (double)(value >> 16);
}

static void unpack_27_16bit_signed_2off(const uint8_t * input, double * output, void *closure) {
	// Unpack 27 values into output
	// Values are 16-bit signed
	// Skip 2 bits, read 432 bits of data.
	// Input must be at least 55 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 2 to 17
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)input[1] << 18) |
			((uint32_t)(input[2] & 0xc0) << 10);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 18 to 33
	value = ((uint32_t)(input[2] & 0x3f) << 26) |
			((uint32_t)input[3] << 18) |
			((uint32_t)(input[4] & 0xc0) << 10);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 34 to 49
	value = ((uint32_t)(input[4] & 0x3f) << 26) |
			((uint32_t)input[5] << 18) |
			((uint32_t)(input[6] & 0xc0) << 10);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 50 to 65
	value = ((uint32_t)(input[6] & 0x3f) << 26) |
			((uint32_t)input[7] << 18) |
			((uint32_t)(input[8] & 0xc0) << 10);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 66 to 81
	value = ((uint32_t)(input[8] & 0x3f) << 26) |
			((uint32_t)input[9] << 18) |
			((uint32_t)(input[10] & 0xc0) << 10);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 82 to 97
	value = ((uint32_t)(input[10] & 0x3f) << 26) |
			((uint32_t)input[11] << 18) |
			((uint32_t)(input[12] & 0xc0) << 10);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 98 to 113
	value = ((uint32_t)(input[12] & 0x3f) << 26) |
			((uint32_t)input[13] << 18) |
			((uint32_t)(input[14] & 0xc0) << 10);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 114 to 129
	value = ((uint32_t)(input[14] & 0x3f) << 26) |
			((uint32_t)input[15] << 18) |
			((uint32_t)(input[16] & 0xc0) << 10);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 130 to 145
	value = ((uint32_t)(input[16] & 0x3f) << 26) |
			((uint32_t)input[17] << 18) |
			((uint32_t)(input[18] & 0xc0) << 10);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 146 to 161
	value = ((uint32_t)(input[18] & 0x3f) << 26) |
			((uint32_t)input[19] << 18) |
			((uint32_t)(input[20] & 0xc0) << 10);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 162 to 177
	value = ((uint32_t)(input[20] & 0x3f) << 26) |
			((uint32_t)input[21] << 18) |
			((uint32_t)(input[22] & 0xc0) << 10);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 178 to 193
	value = ((uint32_t)(input[22] & 0x3f) << 26) |
			((uint32_t)input[23] << 18) |
			((uint32_t)(input[24] & 0xc0) << 10);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 194 to 209
	value = ((uint32_t)(input[24] & 0x3f) << 26) |
			((uint32_t)input[25] << 18) |
			((uint32_t)(input[26] & 0xc0) << 10);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 210 to 225
	value = ((uint32_t)(input[26] & 0x3f) << 26) |
			((uint32_t)input[27] << 18) |
			((uint32_t)(input[28] & 0xc0) << 10);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 226 to 241
	value = ((uint32_t)(input[28] & 0x3f) << 26) |
			((uint32_t)input[29] << 18) |
			((uint32_t)(input[30] & 0xc0) << 10);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 242 to 257
	value = ((uint32_t)(input[30] & 0x3f) << 26) |
			((uint32_t)input[31] << 18) |
			((uint32_t)(input[32] & 0xc0) << 10);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 258 to 273
	value = ((uint32_t)(input[32] & 0x3f) << 26) |
			((uint32_t)input[33] << 18) |
			((uint32_t)(input[34] & 0xc0) << 10);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 274 to 289
	value = ((uint32_t)(input[34] & 0x3f) << 26) |
			((uint32_t)input[35] << 18) |
			((uint32_t)(input[36] & 0xc0) << 10);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 290 to 305
	value = ((uint32_t)(input[36] & 0x3f) << 26) |
			((uint32_t)input[37] << 18) |
			((uint32_t)(input[38] & 0xc0) << 10);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 306 to 321
	value = ((uint32_t)(input[38] & 0x3f) << 26) |
			((uint32_t)input[39] << 18) |
			((uint32_t)(input[40] & 0xc0) << 10);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 322 to 337
	value = ((uint32_t)(input[40] & 0x3f) << 26) |
			((uint32_t)input[41] << 18) |
			((uint32_t)(input[42] & 0xc0) << 10);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 338 to 353
	value = ((uint32_t)(input[42] & 0x3f) << 26) |
			((uint32_t)input[43] << 18) |
			((uint32_t)(input[44] & 0xc0) << 10);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 354 to 369
	value = ((uint32_t)(input[44] & 0x3f) << 26) |
			((uint32_t)input[45] << 18) |
			((uint32_t)(input[46] & 0xc0) << 10);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 370 to 385
	value = ((uint32_t)(input[46] & 0x3f) << 26) |
			((uint32_t)input[47] << 18) |
			((uint32_t)(input[48] & 0xc0) << 10);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 386 to 401
	value = ((uint32_t)(input[48] & 0x3f) << 26) |
			((uint32_t)input[49] << 18) |
			((uint32_t)(input[50] & 0xc0) << 10);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 402 to 417
	value = ((uint32_t)(input[50] & 0x3f) << 26) |
			((uint32_t)input[51] << 18) |
			((uint32_t)(input[52] & 0xc0) << 10);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 418 to 433
	value = ((uint32_t)(input[52] & 0x3f) << 26) |
			((uint32_t)input[53] << 18) |
			((uint32_t)(input[54] & 0xc0) << 10);
	output[26] = (double)(value >> 16);
}

static void unpack_27_16bit_unsigned_2off(const uint8_t * input, double * output, void *closure) {
	// Unpack 27 values into output
	// Values are 16-bit unsigned
	// Skip 2 bits, read 432 bits of data.
	// Input must be at least 55 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 2 to 17
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)input[1] << 18) |
			((uint32_t)(input[2] & 0xc0) << 10);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 18 to 33
	value = ((uint32_t)(input[2] & 0x3f) << 26) |
			((uint32_t)input[3] << 18) |
			((uint32_t)(input[4] & 0xc0) << 10);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 34 to 49
	value = ((uint32_t)(input[4] & 0x3f) << 26) |
			((uint32_t)input[5] << 18) |
			((uint32_t)(input[6] & 0xc0) << 10);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 50 to 65
	value = ((uint32_t)(input[6] & 0x3f) << 26) |
			((uint32_t)input[7] << 18) |
			((uint32_t)(input[8] & 0xc0) << 10);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 66 to 81
	value = ((uint32_t)(input[8] & 0x3f) << 26) |
			((uint32_t)input[9] << 18) |
			((uint32_t)(input[10] & 0xc0) << 10);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 82 to 97
	value = ((uint32_t)(input[10] & 0x3f) << 26) |
			((uint32_t)input[11] << 18) |
			((uint32_t)(input[12] & 0xc0) << 10);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 98 to 113
	value = ((uint32_t)(input[12] & 0x3f) << 26) |
			((uint32_t)input[13] << 18) |
			((uint32_t)(input[14] & 0xc0) << 10);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 114 to 129
	value = ((uint32_t)(input[14] & 0x3f) << 26) |
			((uint32_t)input[15] << 18) |
			((uint32_t)(input[16] & 0xc0) << 10);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 130 to 145
	value = ((uint32_t)(input[16] & 0x3f) << 26) |
			((uint32_t)input[17] << 18) |
			((uint32_t)(input[18] & 0xc0) << 10);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 146 to 161
	value = ((uint32_t)(input[18] & 0x3f) << 26) |
			((uint32_t)input[19] << 18) |
			((uint32_t)(input[20] & 0xc0) << 10);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 162 to 177
	value = ((uint32_t)(input[20] & 0x3f) << 26) |
			((uint32_t)input[21] << 18) |
			((uint32_t)(input[22] & 0xc0) << 10);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 178 to 193
	value = ((uint32_t)(input[22] & 0x3f) << 26) |
			((uint32_t)input[23] << 18) |
			((uint32_t)(input[24] & 0xc0) << 10);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 194 to 209
	value = ((uint32_t)(input[24] & 0x3f) << 26) |
			((uint32_t)input[25] << 18) |
			((uint32_t)(input[26] & 0xc0) << 10);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 210 to 225
	value = ((uint32_t)(input[26] & 0x3f) << 26) |
			((uint32_t)input[27] << 18) |
			((uint32_t)(input[28] & 0xc0) << 10);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 226 to 241
	value = ((uint32_t)(input[28] & 0x3f) << 26) |
			((uint32_t)input[29] << 18) |
			((uint32_t)(input[30] & 0xc0) << 10);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 242 to 257
	value = ((uint32_t)(input[30] & 0x3f) << 26) |
			((uint32_t)input[31] << 18) |
			((uint32_t)(input[32] & 0xc0) << 10);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 258 to 273
	value = ((uint32_t)(input[32] & 0x3f) << 26) |
			((uint32_t)input[33] << 18) |
			((uint32_t)(input[34] & 0xc0) << 10);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 274 to 289
	value = ((uint32_t)(input[34] & 0x3f) << 26) |
			((uint32_t)input[35] << 18) |
			((uint32_t)(input[36] & 0xc0) << 10);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 290 to 305
	value = ((uint32_t)(input[36] & 0x3f) << 26) |
			((uint32_t)input[37] << 18) |
			((uint32_t)(input[38] & 0xc0) << 10);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 306 to 321
	value = ((uint32_t)(input[38] & 0x3f) << 26) |
			((uint32_t)input[39] << 18) |
			((uint32_t)(input[40] & 0xc0) << 10);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 322 to 337
	value = ((uint32_t)(input[40] & 0x3f) << 26) |
			((uint32_t)input[41] << 18) |
			((uint32_t)(input[42] & 0xc0) << 10);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 338 to 353
	value = ((uint32_t)(input[42] & 0x3f) << 26) |
			((uint32_t)input[43] << 18) |
			((uint32_t)(input[44] & 0xc0) << 10);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 354 to 369
	value = ((uint32_t)(input[44] & 0x3f) << 26) |
			((uint32_t)input[45] << 18) |
			((uint32_t)(input[46] & 0xc0) << 10);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 370 to 385
	value = ((uint32_t)(input[46] & 0x3f) << 26) |
			((uint32_t)input[47] << 18) |
			((uint32_t)(input[48] & 0xc0) << 10);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 386 to 401
	value = ((uint32_t)(input[48] & 0x3f) << 26) |
			((uint32_t)input[49] << 18) |
			((uint32_t)(input[50] & 0xc0) << 10);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 402 to 417
	value = ((uint32_t)(input[50] & 0x3f) << 26) |
			((uint32_t)input[51] << 18) |
			((uint32_t)(input[52] & 0xc0) << 10);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 418 to 433
	value = ((uint32_t)(input[52] & 0x3f) << 26) |
			((uint32_t)input[53] << 18) |
			((uint32_t)(input[54] & 0xc0) << 10);
	output[26] = (double)(value >> 16);
}

static void unpack_27_16bit_signed_3off(const uint8_t * input, double * output, void *closure) {
	// Unpack 27 values into output
	// Values are 16-bit signed
	// Skip 3 bits, read 432 bits of data.
	// Input must be at least 55 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 3 to 18
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)input[1] << 19) |
			((uint32_t)(input[2] & 0xe0) << 11);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 19 to 34
	value = ((uint32_t)(input[2] & 0x1f) << 27) |
			((uint32_t)input[3] << 19) |
			((uint32_t)(input[4] & 0xe0) << 11);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 35 to 50
	value = ((uint32_t)(input[4] & 0x1f) << 27) |
			((uint32_t)input[5] << 19) |
			((uint32_t)(input[6] & 0xe0) << 11);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 51 to 66
	value = ((uint32_t)(input[6] & 0x1f) << 27) |
			((uint32_t)input[7] << 19) |
			((uint32_t)(input[8] & 0xe0) << 11);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 67 to 82
	value = ((uint32_t)(input[8] & 0x1f) << 27) |
			((uint32_t)input[9] << 19) |
			((uint32_t)(input[10] & 0xe0) << 11);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 83 to 98
	value = ((uint32_t)(input[10] & 0x1f) << 27) |
			((uint32_t)input[11] << 19) |
			((uint32_t)(input[12] & 0xe0) << 11);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 99 to 114
	value = ((uint32_t)(input[12] & 0x1f) << 27) |
			((uint32_t)input[13] << 19) |
			((uint32_t)(input[14] & 0xe0) << 11);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 115 to 130
	value = ((uint32_t)(input[14] & 0x1f) << 27) |
			((uint32_t)input[15] << 19) |
			((uint32_t)(input[16] & 0xe0) << 11);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 131 to 146
	value = ((uint32_t)(input[16] & 0x1f) << 27) |
			((uint32_t)input[17] << 19) |
			((uint32_t)(input[18] & 0xe0) << 11);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 147 to 162
	value = ((uint32_t)(input[18] & 0x1f) << 27) |
			((uint32_t)input[19] << 19) |
			((uint32_t)(input[20] & 0xe0) << 11);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 163 to 178
	value = ((uint32_t)(input[20] & 0x1f) << 27) |
			((uint32_t)input[21] << 19) |
			((uint32_t)(input[22] & 0xe0) << 11);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 179 to 194
	value = ((uint32_t)(input[22] & 0x1f) << 27) |
			((uint32_t)input[23] << 19) |
			((uint32_t)(input[24] & 0xe0) << 11);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 195 to 210
	value = ((uint32_t)(input[24] & 0x1f) << 27) |
			((uint32_t)input[25] << 19) |
			((uint32_t)(input[26] & 0xe0) << 11);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 211 to 226
	value = ((uint32_t)(input[26] & 0x1f) << 27) |
			((uint32_t)input[27] << 19) |
			((uint32_t)(input[28] & 0xe0) << 11);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 227 to 242
	value = ((uint32_t)(input[28] & 0x1f) << 27) |
			((uint32_t)input[29] << 19) |
			((uint32_t)(input[30] & 0xe0) << 11);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 243 to 258
	value = ((uint32_t)(input[30] & 0x1f) << 27) |
			((uint32_t)input[31] << 19) |
			((uint32_t)(input[32] & 0xe0) << 11);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 259 to 274
	value = ((uint32_t)(input[32] & 0x1f) << 27) |
			((uint32_t)input[33] << 19) |
			((uint32_t)(input[34] & 0xe0) << 11);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 275 to 290
	value = ((uint32_t)(input[34] & 0x1f) << 27) |
			((uint32_t)input[35] << 19) |
			((uint32_t)(input[36] & 0xe0) << 11);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 291 to 306
	value = ((uint32_t)(input[36] & 0x1f) << 27) |
			((uint32_t)input[37] << 19) |
			((uint32_t)(input[38] & 0xe0) << 11);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 307 to 322
	value = ((uint32_t)(input[38] & 0x1f) << 27) |
			((uint32_t)input[39] << 19) |
			((uint32_t)(input[40] & 0xe0) << 11);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 323 to 338
	value = ((uint32_t)(input[40] & 0x1f) << 27) |
			((uint32_t)input[41] << 19) |
			((uint32_t)(input[42] & 0xe0) << 11);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 339 to 354
	value = ((uint32_t)(input[42] & 0x1f) << 27) |
			((uint32_t)input[43] << 19) |
			((uint32_t)(input[44] & 0xe0) << 11);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 355 to 370
	value = ((uint32_t)(input[44] & 0x1f) << 27) |
			((uint32_t)input[45] << 19) |
			((uint32_t)(input[46] & 0xe0) << 11);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 371 to 386
	value = ((uint32_t)(input[46] & 0x1f) << 27) |
			((uint32_t)input[47] << 19) |
			((uint32_t)(input[48] & 0xe0) << 11);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 387 to 402
	value = ((uint32_t)(input[48] & 0x1f) << 27) |
			((uint32_t)input[49] << 19) |
			((uint32_t)(input[50] & 0xe0) << 11);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 403 to 418
	value = ((uint32_t)(input[50] & 0x1f) << 27) |
			((uint32_t)input[51] << 19) |
			((uint32_t)(input[52] & 0xe0) << 11);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 419 to 434
	value = ((uint32_t)(input[52] & 0x1f) << 27) |
			((uint32_t)input[53] << 19) |
			((uint32_t)(input[54] & 0xe0) << 11);
	output[26] = (double)(value >> 16);
}

static void unpack_27_16bit_unsigned_3off(const uint8_t * input, double * output, void *closure) {
	// Unpack 27 values into output
	// Values are 16-bit unsigned
	// Skip 3 bits, read 432 bits of data.
	// Input must be at least 55 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 3 to 18
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)input[1] << 19) |
			((uint32_t)(input[2] & 0xe0) << 11);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 19 to 34
	value = ((uint32_t)(input[2] & 0x1f) << 27) |
			((uint32_t)input[3] << 19) |
			((uint32_t)(input[4] & 0xe0) << 11);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 35 to 50
	value = ((uint32_t)(input[4] & 0x1f) << 27) |
			((uint32_t)input[5] << 19) |
			((uint32_t)(input[6] & 0xe0) << 11);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 51 to 66
	value = ((uint32_t)(input[6] & 0x1f) << 27) |
			((uint32_t)input[7] << 19) |
			((uint32_t)(input[8] & 0xe0) << 11);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 67 to 82
	value = ((uint32_t)(input[8] & 0x1f) << 27) |
			((uint32_t)input[9] << 19) |
			((uint32_t)(input[10] & 0xe0) << 11);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 83 to 98
	value = ((uint32_t)(input[10] & 0x1f) << 27) |
			((uint32_t)input[11] << 19) |
			((uint32_t)(input[12] & 0xe0) << 11);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 99 to 114
	value = ((uint32_t)(input[12] & 0x1f) << 27) |
			((uint32_t)input[13] << 19) |
			((uint32_t)(input[14] & 0xe0) << 11);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 115 to 130
	value = ((uint32_t)(input[14] & 0x1f) << 27) |
			((uint32_t)input[15] << 19) |
			((uint32_t)(input[16] & 0xe0) << 11);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 131 to 146
	value = ((uint32_t)(input[16] & 0x1f) << 27) |
			((uint32_t)input[17] << 19) |
			((uint32_t)(input[18] & 0xe0) << 11);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 147 to 162
	value = ((uint32_t)(input[18] & 0x1f) << 27) |
			((uint32_t)input[19] << 19) |
			((uint32_t)(input[20] & 0xe0) << 11);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 163 to 178
	value = ((uint32_t)(input[20] & 0x1f) << 27) |
			((uint32_t)input[21] << 19) |
			((uint32_t)(input[22] & 0xe0) << 11);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 179 to 194
	value = ((uint32_t)(input[22] & 0x1f) << 27) |
			((uint32_t)input[23] << 19) |
			((uint32_t)(input[24] & 0xe0) << 11);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 195 to 210
	value = ((uint32_t)(input[24] & 0x1f) << 27) |
			((uint32_t)input[25] << 19) |
			((uint32_t)(input[26] & 0xe0) << 11);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 211 to 226
	value = ((uint32_t)(input[26] & 0x1f) << 27) |
			((uint32_t)input[27] << 19) |
			((uint32_t)(input[28] & 0xe0) << 11);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 227 to 242
	value = ((uint32_t)(input[28] & 0x1f) << 27) |
			((uint32_t)input[29] << 19) |
			((uint32_t)(input[30] & 0xe0) << 11);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 243 to 258
	value = ((uint32_t)(input[30] & 0x1f) << 27) |
			((uint32_t)input[31] << 19) |
			((uint32_t)(input[32] & 0xe0) << 11);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 259 to 274
	value = ((uint32_t)(input[32] & 0x1f) << 27) |
			((uint32_t)input[33] << 19) |
			((uint32_t)(input[34] & 0xe0) << 11);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 275 to 290
	value = ((uint32_t)(input[34] & 0x1f) << 27) |
			((uint32_t)input[35] << 19) |
			((uint32_t)(input[36] & 0xe0) << 11);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 291 to 306
	value = ((uint32_t)(input[36] & 0x1f) << 27) |
			((uint32_t)input[37] << 19) |
			((uint32_t)(input[38] & 0xe0) << 11);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 307 to 322
	value = ((uint32_t)(input[38] & 0x1f) << 27) |
			((uint32_t)input[39] << 19) |
			((uint32_t)(input[40] & 0xe0) << 11);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 323 to 338
	value = ((uint32_t)(input[40] & 0x1f) << 27) |
			((uint32_t)input[41] << 19) |
			((uint32_t)(input[42] & 0xe0) << 11);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 339 to 354
	value = ((uint32_t)(input[42] & 0x1f) << 27) |
			((uint32_t)input[43] << 19) |
			((uint32_t)(input[44] & 0xe0) << 11);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 355 to 370
	value = ((uint32_t)(input[44] & 0x1f) << 27) |
			((uint32_t)input[45] << 19) |
			((uint32_t)(input[46] & 0xe0) << 11);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 371 to 386
	value = ((uint32_t)(input[46] & 0x1f) << 27) |
			((uint32_t)input[47] << 19) |
			((uint32_t)(input[48] & 0xe0) << 11);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 387 to 402
	value = ((uint32_t)(input[48] & 0x1f) << 27) |
			((uint32_t)input[49] << 19) |
			((uint32_t)(input[50] & 0xe0) << 11);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 403 to 418
	value = ((uint32_t)(input[50] & 0x1f) << 27) |
			((uint32_t)input[51] << 19) |
			((uint32_t)(input[52] & 0xe0) << 11);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 419 to 434
	value = ((uint32_t)(input[52] & 0x1f) << 27) |
			((uint32_t)input[53] << 19) |
			((uint32_t)(input[54] & 0xe0) << 11);
	output[26] = (double)(value >> 16);
}

static void unpack_27_16bit_signed_4off(const uint8_t * input, double * output, void *closure) {
	// Unpack 27 values into output
	// Values are 16-bit signed
	// Skip 4 bits, read 432 bits of data.
	// Input must be at least 55 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 4 to 19
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20) |
			((uint32_t)(input[2] & 0xf0) << 12);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 20 to 35
	value = ((uint32_t)(input[2] & 0x0f) << 28) |
			((uint32_t)input[3] << 20) |
			((uint32_t)(input[4] & 0xf0) << 12);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 36 to 51
	value = ((uint32_t)(input[4] & 0x0f) << 28) |
			((uint32_t)input[5] << 20) |
			((uint32_t)(input[6] & 0xf0) << 12);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 52 to 67
	value = ((uint32_t)(input[6] & 0x0f) << 28) |
			((uint32_t)input[7] << 20) |
			((uint32_t)(input[8] & 0xf0) << 12);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 68 to 83
	value = ((uint32_t)(input[8] & 0x0f) << 28) |
			((uint32_t)input[9] << 20) |
			((uint32_t)(input[10] & 0xf0) << 12);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 84 to 99
	value = ((uint32_t)(input[10] & 0x0f) << 28) |
			((uint32_t)input[11] << 20) |
			((uint32_t)(input[12] & 0xf0) << 12);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 100 to 115
	value = ((uint32_t)(input[12] & 0x0f) << 28) |
			((uint32_t)input[13] << 20) |
			((uint32_t)(input[14] & 0xf0) << 12);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 116 to 131
	value = ((uint32_t)(input[14] & 0x0f) << 28) |
			((uint32_t)input[15] << 20) |
			((uint32_t)(input[16] & 0xf0) << 12);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 132 to 147
	value = ((uint32_t)(input[16] & 0x0f) << 28) |
			((uint32_t)input[17] << 20) |
			((uint32_t)(input[18] & 0xf0) << 12);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 148 to 163
	value = ((uint32_t)(input[18] & 0x0f) << 28) |
			((uint32_t)input[19] << 20) |
			((uint32_t)(input[20] & 0xf0) << 12);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 164 to 179
	value = ((uint32_t)(input[20] & 0x0f) << 28) |
			((uint32_t)input[21] << 20) |
			((uint32_t)(input[22] & 0xf0) << 12);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 180 to 195
	value = ((uint32_t)(input[22] & 0x0f) << 28) |
			((uint32_t)input[23] << 20) |
			((uint32_t)(input[24] & 0xf0) << 12);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 196 to 211
	value = ((uint32_t)(input[24] & 0x0f) << 28) |
			((uint32_t)input[25] << 20) |
			((uint32_t)(input[26] & 0xf0) << 12);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 212 to 227
	value = ((uint32_t)(input[26] & 0x0f) << 28) |
			((uint32_t)input[27] << 20) |
			((uint32_t)(input[28] & 0xf0) << 12);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 228 to 243
	value = ((uint32_t)(input[28] & 0x0f) << 28) |
			((uint32_t)input[29] << 20) |
			((uint32_t)(input[30] & 0xf0) << 12);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 244 to 259
	value = ((uint32_t)(input[30] & 0x0f) << 28) |
			((uint32_t)input[31] << 20) |
			((uint32_t)(input[32] & 0xf0) << 12);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 260 to 275
	value = ((uint32_t)(input[32] & 0x0f) << 28) |
			((uint32_t)input[33] << 20) |
			((uint32_t)(input[34] & 0xf0) << 12);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 276 to 291
	value = ((uint32_t)(input[34] & 0x0f) << 28) |
			((uint32_t)input[35] << 20) |
			((uint32_t)(input[36] & 0xf0) << 12);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 292 to 307
	value = ((uint32_t)(input[36] & 0x0f) << 28) |
			((uint32_t)input[37] << 20) |
			((uint32_t)(input[38] & 0xf0) << 12);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 308 to 323
	value = ((uint32_t)(input[38] & 0x0f) << 28) |
			((uint32_t)input[39] << 20) |
			((uint32_t)(input[40] & 0xf0) << 12);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 324 to 339
	value = ((uint32_t)(input[40] & 0x0f) << 28) |
			((uint32_t)input[41] << 20) |
			((uint32_t)(input[42] & 0xf0) << 12);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 340 to 355
	value = ((uint32_t)(input[42] & 0x0f) << 28) |
			((uint32_t)input[43] << 20) |
			((uint32_t)(input[44] & 0xf0) << 12);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 356 to 371
	value = ((uint32_t)(input[44] & 0x0f) << 28) |
			((uint32_t)input[45] << 20) |
			((uint32_t)(input[46] & 0xf0) << 12);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 372 to 387
	value = ((uint32_t)(input[46] & 0x0f) << 28) |
			((uint32_t)input[47] << 20) |
			((uint32_t)(input[48] & 0xf0) << 12);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 388 to 403
	value = ((uint32_t)(input[48] & 0x0f) << 28) |
			((uint32_t)input[49] << 20) |
			((uint32_t)(input[50] & 0xf0) << 12);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 404 to 419
	value = ((uint32_t)(input[50] & 0x0f) << 28) |
			((uint32_t)input[51] << 20) |
			((uint32_t)(input[52] & 0xf0) << 12);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 420 to 435
	value = ((uint32_t)(input[52] & 0x0f) << 28) |
			((uint32_t)input[53] << 20) |
			((uint32_t)(input[54] & 0xf0) << 12);
	output[26] = (double)(value >> 16);
}

static void unpack_27_16bit_unsigned_4off(const uint8_t * input, double * output, void *closure) {
	// Unpack 27 values into output
	// Values are 16-bit unsigned
	// Skip 4 bits, read 432 bits of data.
	// Input must be at least 55 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 4 to 19
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20) |
			((uint32_t)(input[2] & 0xf0) << 12);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 20 to 35
	value = ((uint32_t)(input[2] & 0x0f) << 28) |
			((uint32_t)input[3] << 20) |
			((uint32_t)(input[4] & 0xf0) << 12);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 36 to 51
	value = ((uint32_t)(input[4] & 0x0f) << 28) |
			((uint32_t)input[5] << 20) |
			((uint32_t)(input[6] & 0xf0) << 12);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 52 to 67
	value = ((uint32_t)(input[6] & 0x0f) << 28) |
			((uint32_t)input[7] << 20) |
			((uint32_t)(input[8] & 0xf0) << 12);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 68 to 83
	value = ((uint32_t)(input[8] & 0x0f) << 28) |
			((uint32_t)input[9] << 20) |
			((uint32_t)(input[10] & 0xf0) << 12);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 84 to 99
	value = ((uint32_t)(input[10] & 0x0f) << 28) |
			((uint32_t)input[11] << 20) |
			((uint32_t)(input[12] & 0xf0) << 12);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 100 to 115
	value = ((uint32_t)(input[12] & 0x0f) << 28) |
			((uint32_t)input[13] << 20) |
			((uint32_t)(input[14] & 0xf0) << 12);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 116 to 131
	value = ((uint32_t)(input[14] & 0x0f) << 28) |
			((uint32_t)input[15] << 20) |
			((uint32_t)(input[16] & 0xf0) << 12);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 132 to 147
	value = ((uint32_t)(input[16] & 0x0f) << 28) |
			((uint32_t)input[17] << 20) |
			((uint32_t)(input[18] & 0xf0) << 12);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 148 to 163
	value = ((uint32_t)(input[18] & 0x0f) << 28) |
			((uint32_t)input[19] << 20) |
			((uint32_t)(input[20] & 0xf0) << 12);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 164 to 179
	value = ((uint32_t)(input[20] & 0x0f) << 28) |
			((uint32_t)input[21] << 20) |
			((uint32_t)(input[22] & 0xf0) << 12);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 180 to 195
	value = ((uint32_t)(input[22] & 0x0f) << 28) |
			((uint32_t)input[23] << 20) |
			((uint32_t)(input[24] & 0xf0) << 12);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 196 to 211
	value = ((uint32_t)(input[24] & 0x0f) << 28) |
			((uint32_t)input[25] << 20) |
			((uint32_t)(input[26] & 0xf0) << 12);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 212 to 227
	value = ((uint32_t)(input[26] & 0x0f) << 28) |
			((uint32_t)input[27] << 20) |
			((uint32_t)(input[28] & 0xf0) << 12);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 228 to 243
	value = ((uint32_t)(input[28] & 0x0f) << 28) |
			((uint32_t)input[29] << 20) |
			((uint32_t)(input[30] & 0xf0) << 12);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 244 to 259
	value = ((uint32_t)(input[30] & 0x0f) << 28) |
			((uint32_t)input[31] << 20) |
			((uint32_t)(input[32] & 0xf0) << 12);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 260 to 275
	value = ((uint32_t)(input[32] & 0x0f) << 28) |
			((uint32_t)input[33] << 20) |
			((uint32_t)(input[34] & 0xf0) << 12);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 276 to 291
	value = ((uint32_t)(input[34] & 0x0f) << 28) |
			((uint32_t)input[35] << 20) |
			((uint32_t)(input[36] & 0xf0) << 12);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 292 to 307
	value = ((uint32_t)(input[36] & 0x0f) << 28) |
			((uint32_t)input[37] << 20) |
			((uint32_t)(input[38] & 0xf0) << 12);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 308 to 323
	value = ((uint32_t)(input[38] & 0x0f) << 28) |
			((uint32_t)input[39] << 20) |
			((uint32_t)(input[40] & 0xf0) << 12);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 324 to 339
	value = ((uint32_t)(input[40] & 0x0f) << 28) |
			((uint32_t)input[41] << 20) |
			((uint32_t)(input[42] & 0xf0) << 12);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 340 to 355
	value = ((uint32_t)(input[42] & 0x0f) << 28) |
			((uint32_t)input[43] << 20) |
			((uint32_t)(input[44] & 0xf0) << 12);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 356 to 371
	value = ((uint32_t)(input[44] & 0x0f) << 28) |
			((uint32_t)input[45] << 20) |
			((uint32_t)(input[46] & 0xf0) << 12);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 372 to 387
	value = ((uint32_t)(input[46] & 0x0f) << 28) |
			((uint32_t)input[47] << 20) |
			((uint32_t)(input[48] & 0xf0) << 12);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 388 to 403
	value = ((uint32_t)(input[48] & 0x0f) << 28) |
			((uint32_t)input[49] << 20) |
			((uint32_t)(input[50] & 0xf0) << 12);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 404 to 419
	value = ((uint32_t)(input[50] & 0x0f) << 28) |
			((uint32_t)input[51] << 20) |
			((uint32_t)(input[52] & 0xf0) << 12);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 420 to 435
	value = ((uint32_t)(input[52] & 0x0f) << 28) |
			((uint32_t)input[53] << 20) |
			((uint32_t)(input[54] & 0xf0) << 12);
	output[26] = (double)(value >> 16);
}

static void unpack_27_16bit_signed_5off(const uint8_t * input, double * output, void *closure) {
	// Unpack 27 values into output
	// Values are 16-bit signed
	// Skip 5 bits, read 432 bits of data.
	// Input must be at least 55 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 5 to 20
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)(input[2] & 0xf8) << 13);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 21 to 36
	value = ((uint32_t)(input[2] & 0x07) << 29) |
			((uint32_t)input[3] << 21) |
			((uint32_t)(input[4] & 0xf8) << 13);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 37 to 52
	value = ((uint32_t)(input[4] & 0x07) << 29) |
			((uint32_t)input[5] << 21) |
			((uint32_t)(input[6] & 0xf8) << 13);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 53 to 68
	value = ((uint32_t)(input[6] & 0x07) << 29) |
			((uint32_t)input[7] << 21) |
			((uint32_t)(input[8] & 0xf8) << 13);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 69 to 84
	value = ((uint32_t)(input[8] & 0x07) << 29) |
			((uint32_t)input[9] << 21) |
			((uint32_t)(input[10] & 0xf8) << 13);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 85 to 100
	value = ((uint32_t)(input[10] & 0x07) << 29) |
			((uint32_t)input[11] << 21) |
			((uint32_t)(input[12] & 0xf8) << 13);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 101 to 116
	value = ((uint32_t)(input[12] & 0x07) << 29) |
			((uint32_t)input[13] << 21) |
			((uint32_t)(input[14] & 0xf8) << 13);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 117 to 132
	value = ((uint32_t)(input[14] & 0x07) << 29) |
			((uint32_t)input[15] << 21) |
			((uint32_t)(input[16] & 0xf8) << 13);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 133 to 148
	value = ((uint32_t)(input[16] & 0x07) << 29) |
			((uint32_t)input[17] << 21) |
			((uint32_t)(input[18] & 0xf8) << 13);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 149 to 164
	value = ((uint32_t)(input[18] & 0x07) << 29) |
			((uint32_t)input[19] << 21) |
			((uint32_t)(input[20] & 0xf8) << 13);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 165 to 180
	value = ((uint32_t)(input[20] & 0x07) << 29) |
			((uint32_t)input[21] << 21) |
			((uint32_t)(input[22] & 0xf8) << 13);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 181 to 196
	value = ((uint32_t)(input[22] & 0x07) << 29) |
			((uint32_t)input[23] << 21) |
			((uint32_t)(input[24] & 0xf8) << 13);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 197 to 212
	value = ((uint32_t)(input[24] & 0x07) << 29) |
			((uint32_t)input[25] << 21) |
			((uint32_t)(input[26] & 0xf8) << 13);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 213 to 228
	value = ((uint32_t)(input[26] & 0x07) << 29) |
			((uint32_t)input[27] << 21) |
			((uint32_t)(input[28] & 0xf8) << 13);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 229 to 244
	value = ((uint32_t)(input[28] & 0x07) << 29) |
			((uint32_t)input[29] << 21) |
			((uint32_t)(input[30] & 0xf8) << 13);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 245 to 260
	value = ((uint32_t)(input[30] & 0x07) << 29) |
			((uint32_t)input[31] << 21) |
			((uint32_t)(input[32] & 0xf8) << 13);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 261 to 276
	value = ((uint32_t)(input[32] & 0x07) << 29) |
			((uint32_t)input[33] << 21) |
			((uint32_t)(input[34] & 0xf8) << 13);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 277 to 292
	value = ((uint32_t)(input[34] & 0x07) << 29) |
			((uint32_t)input[35] << 21) |
			((uint32_t)(input[36] & 0xf8) << 13);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 293 to 308
	value = ((uint32_t)(input[36] & 0x07) << 29) |
			((uint32_t)input[37] << 21) |
			((uint32_t)(input[38] & 0xf8) << 13);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 309 to 324
	value = ((uint32_t)(input[38] & 0x07) << 29) |
			((uint32_t)input[39] << 21) |
			((uint32_t)(input[40] & 0xf8) << 13);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 325 to 340
	value = ((uint32_t)(input[40] & 0x07) << 29) |
			((uint32_t)input[41] << 21) |
			((uint32_t)(input[42] & 0xf8) << 13);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 341 to 356
	value = ((uint32_t)(input[42] & 0x07) << 29) |
			((uint32_t)input[43] << 21) |
			((uint32_t)(input[44] & 0xf8) << 13);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 357 to 372
	value = ((uint32_t)(input[44] & 0x07) << 29) |
			((uint32_t)input[45] << 21) |
			((uint32_t)(input[46] & 0xf8) << 13);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 373 to 388
	value = ((uint32_t)(input[46] & 0x07) << 29) |
			((uint32_t)input[47] << 21) |
			((uint32_t)(input[48] & 0xf8) << 13);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 389 to 404
	value = ((uint32_t)(input[48] & 0x07) << 29) |
			((uint32_t)input[49] << 21) |
			((uint32_t)(input[50] & 0xf8) << 13);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 405 to 420
	value = ((uint32_t)(input[50] & 0x07) << 29) |
			((uint32_t)input[51] << 21) |
			((uint32_t)(input[52] & 0xf8) << 13);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 421 to 436
	value = ((uint32_t)(input[52] & 0x07) << 29) |
			((uint32_t)input[53] << 21) |
			((uint32_t)(input[54] & 0xf8) << 13);
	output[26] = (double)(value >> 16);
}

static void unpack_27_16bit_unsigned_5off(const uint8_t * input, double * output, void *closure) {
	// Unpack 27 values into output
	// Values are 16-bit unsigned
	// Skip 5 bits, read 432 bits of data.
	// Input must be at least 55 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 5 to 20
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)(input[2] & 0xf8) << 13);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 21 to 36
	value = ((uint32_t)(input[2] & 0x07) << 29) |
			((uint32_t)input[3] << 21) |
			((uint32_t)(input[4] & 0xf8) << 13);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 37 to 52
	value = ((uint32_t)(input[4] & 0x07) << 29) |
			((uint32_t)input[5] << 21) |
			((uint32_t)(input[6] & 0xf8) << 13);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 53 to 68
	value = ((uint32_t)(input[6] & 0x07) << 29) |
			((uint32_t)input[7] << 21) |
			((uint32_t)(input[8] & 0xf8) << 13);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 69 to 84
	value = ((uint32_t)(input[8] & 0x07) << 29) |
			((uint32_t)input[9] << 21) |
			((uint32_t)(input[10] & 0xf8) << 13);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 85 to 100
	value = ((uint32_t)(input[10] & 0x07) << 29) |
			((uint32_t)input[11] << 21) |
			((uint32_t)(input[12] & 0xf8) << 13);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 101 to 116
	value = ((uint32_t)(input[12] & 0x07) << 29) |
			((uint32_t)input[13] << 21) |
			((uint32_t)(input[14] & 0xf8) << 13);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 117 to 132
	value = ((uint32_t)(input[14] & 0x07) << 29) |
			((uint32_t)input[15] << 21) |
			((uint32_t)(input[16] & 0xf8) << 13);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 133 to 148
	value = ((uint32_t)(input[16] & 0x07) << 29) |
			((uint32_t)input[17] << 21) |
			((uint32_t)(input[18] & 0xf8) << 13);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 149 to 164
	value = ((uint32_t)(input[18] & 0x07) << 29) |
			((uint32_t)input[19] << 21) |
			((uint32_t)(input[20] & 0xf8) << 13);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 165 to 180
	value = ((uint32_t)(input[20] & 0x07) << 29) |
			((uint32_t)input[21] << 21) |
			((uint32_t)(input[22] & 0xf8) << 13);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 181 to 196
	value = ((uint32_t)(input[22] & 0x07) << 29) |
			((uint32_t)input[23] << 21) |
			((uint32_t)(input[24] & 0xf8) << 13);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 197 to 212
	value = ((uint32_t)(input[24] & 0x07) << 29) |
			((uint32_t)input[25] << 21) |
			((uint32_t)(input[26] & 0xf8) << 13);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 213 to 228
	value = ((uint32_t)(input[26] & 0x07) << 29) |
			((uint32_t)input[27] << 21) |
			((uint32_t)(input[28] & 0xf8) << 13);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 229 to 244
	value = ((uint32_t)(input[28] & 0x07) << 29) |
			((uint32_t)input[29] << 21) |
			((uint32_t)(input[30] & 0xf8) << 13);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 245 to 260
	value = ((uint32_t)(input[30] & 0x07) << 29) |
			((uint32_t)input[31] << 21) |
			((uint32_t)(input[32] & 0xf8) << 13);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 261 to 276
	value = ((uint32_t)(input[32] & 0x07) << 29) |
			((uint32_t)input[33] << 21) |
			((uint32_t)(input[34] & 0xf8) << 13);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 277 to 292
	value = ((uint32_t)(input[34] & 0x07) << 29) |
			((uint32_t)input[35] << 21) |
			((uint32_t)(input[36] & 0xf8) << 13);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 293 to 308
	value = ((uint32_t)(input[36] & 0x07) << 29) |
			((uint32_t)input[37] << 21) |
			((uint32_t)(input[38] & 0xf8) << 13);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 309 to 324
	value = ((uint32_t)(input[38] & 0x07) << 29) |
			((uint32_t)input[39] << 21) |
			((uint32_t)(input[40] & 0xf8) << 13);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 325 to 340
	value = ((uint32_t)(input[40] & 0x07) << 29) |
			((uint32_t)input[41] << 21) |
			((uint32_t)(input[42] & 0xf8) << 13);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 341 to 356
	value = ((uint32_t)(input[42] & 0x07) << 29) |
			((uint32_t)input[43] << 21) |
			((uint32_t)(input[44] & 0xf8) << 13);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 357 to 372
	value = ((uint32_t)(input[44] & 0x07) << 29) |
			((uint32_t)input[45] << 21) |
			((uint32_t)(input[46] & 0xf8) << 13);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 373 to 388
	value = ((uint32_t)(input[46] & 0x07) << 29) |
			((uint32_t)input[47] << 21) |
			((uint32_t)(input[48] & 0xf8) << 13);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 389 to 404
	value = ((uint32_t)(input[48] & 0x07) << 29) |
			((uint32_t)input[49] << 21) |
			((uint32_t)(input[50] & 0xf8) << 13);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 405 to 420
	value = ((uint32_t)(input[50] & 0x07) << 29) |
			((uint32_t)input[51] << 21) |
			((uint32_t)(input[52] & 0xf8) << 13);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 421 to 436
	value = ((uint32_t)(input[52] & 0x07) << 29) |
			((uint32_t)input[53] << 21) |
			((uint32_t)(input[54] & 0xf8) << 13);
	output[26] = (double)(value >> 16);
}

static void unpack_27_16bit_signed_6off(const uint8_t * input, double * output, void *closure) {
	// Unpack 27 values into output
	// Values are 16-bit signed
	// Skip 6 bits, read 432 bits of data.
	// Input must be at least 55 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 6 to 21
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)(input[2] & 0xfc) << 14);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 22 to 37
	value = ((uint32_t)(input[2] & 0x03) << 30) |
			((uint32_t)input[3] << 22) |
			((uint32_t)(input[4] & 0xfc) << 14);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 38 to 53
	value = ((uint32_t)(input[4] & 0x03) << 30) |
			((uint32_t)input[5] << 22) |
			((uint32_t)(input[6] & 0xfc) << 14);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 54 to 69
	value = ((uint32_t)(input[6] & 0x03) << 30) |
			((uint32_t)input[7] << 22) |
			((uint32_t)(input[8] & 0xfc) << 14);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 70 to 85
	value = ((uint32_t)(input[8] & 0x03) << 30) |
			((uint32_t)input[9] << 22) |
			((uint32_t)(input[10] & 0xfc) << 14);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 86 to 101
	value = ((uint32_t)(input[10] & 0x03) << 30) |
			((uint32_t)input[11] << 22) |
			((uint32_t)(input[12] & 0xfc) << 14);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 102 to 117
	value = ((uint32_t)(input[12] & 0x03) << 30) |
			((uint32_t)input[13] << 22) |
			((uint32_t)(input[14] & 0xfc) << 14);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 118 to 133
	value = ((uint32_t)(input[14] & 0x03) << 30) |
			((uint32_t)input[15] << 22) |
			((uint32_t)(input[16] & 0xfc) << 14);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 134 to 149
	value = ((uint32_t)(input[16] & 0x03) << 30) |
			((uint32_t)input[17] << 22) |
			((uint32_t)(input[18] & 0xfc) << 14);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 150 to 165
	value = ((uint32_t)(input[18] & 0x03) << 30) |
			((uint32_t)input[19] << 22) |
			((uint32_t)(input[20] & 0xfc) << 14);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 166 to 181
	value = ((uint32_t)(input[20] & 0x03) << 30) |
			((uint32_t)input[21] << 22) |
			((uint32_t)(input[22] & 0xfc) << 14);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 182 to 197
	value = ((uint32_t)(input[22] & 0x03) << 30) |
			((uint32_t)input[23] << 22) |
			((uint32_t)(input[24] & 0xfc) << 14);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 198 to 213
	value = ((uint32_t)(input[24] & 0x03) << 30) |
			((uint32_t)input[25] << 22) |
			((uint32_t)(input[26] & 0xfc) << 14);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 214 to 229
	value = ((uint32_t)(input[26] & 0x03) << 30) |
			((uint32_t)input[27] << 22) |
			((uint32_t)(input[28] & 0xfc) << 14);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 230 to 245
	value = ((uint32_t)(input[28] & 0x03) << 30) |
			((uint32_t)input[29] << 22) |
			((uint32_t)(input[30] & 0xfc) << 14);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 246 to 261
	value = ((uint32_t)(input[30] & 0x03) << 30) |
			((uint32_t)input[31] << 22) |
			((uint32_t)(input[32] & 0xfc) << 14);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 262 to 277
	value = ((uint32_t)(input[32] & 0x03) << 30) |
			((uint32_t)input[33] << 22) |
			((uint32_t)(input[34] & 0xfc) << 14);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 278 to 293
	value = ((uint32_t)(input[34] & 0x03) << 30) |
			((uint32_t)input[35] << 22) |
			((uint32_t)(input[36] & 0xfc) << 14);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 294 to 309
	value = ((uint32_t)(input[36] & 0x03) << 30) |
			((uint32_t)input[37] << 22) |
			((uint32_t)(input[38] & 0xfc) << 14);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 310 to 325
	value = ((uint32_t)(input[38] & 0x03) << 30) |
			((uint32_t)input[39] << 22) |
			((uint32_t)(input[40] & 0xfc) << 14);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 326 to 341
	value = ((uint32_t)(input[40] & 0x03) << 30) |
			((uint32_t)input[41] << 22) |
			((uint32_t)(input[42] & 0xfc) << 14);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 342 to 357
	value = ((uint32_t)(input[42] & 0x03) << 30) |
			((uint32_t)input[43] << 22) |
			((uint32_t)(input[44] & 0xfc) << 14);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 358 to 373
	value = ((uint32_t)(input[44] & 0x03) << 30) |
			((uint32_t)input[45] << 22) |
			((uint32_t)(input[46] & 0xfc) << 14);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 374 to 389
	value = ((uint32_t)(input[46] & 0x03) << 30) |
			((uint32_t)input[47] << 22) |
			((uint32_t)(input[48] & 0xfc) << 14);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 390 to 405
	value = ((uint32_t)(input[48] & 0x03) << 30) |
			((uint32_t)input[49] << 22) |
			((uint32_t)(input[50] & 0xfc) << 14);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 406 to 421
	value = ((uint32_t)(input[50] & 0x03) << 30) |
			((uint32_t)input[51] << 22) |
			((uint32_t)(input[52] & 0xfc) << 14);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 422 to 437
	value = ((uint32_t)(input[52] & 0x03) << 30) |
			((uint32_t)input[53] << 22) |
			((uint32_t)(input[54] & 0xfc) << 14);
	output[26] = (double)(value >> 16);
}

static void unpack_27_16bit_unsigned_6off(const uint8_t * input, double * output, void *closure) {
	// Unpack 27 values into output
	// Values are 16-bit unsigned
	// Skip 6 bits, read 432 bits of data.
	// Input must be at least 55 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 6 to 21
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)(input[2] & 0xfc) << 14);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 22 to 37
	value = ((uint32_t)(input[2] & 0x03) << 30) |
			((uint32_t)input[3] << 22) |
			((uint32_t)(input[4] & 0xfc) << 14);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 38 to 53
	value = ((uint32_t)(input[4] & 0x03) << 30) |
			((uint32_t)input[5] << 22) |
			((uint32_t)(input[6] & 0xfc) << 14);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 54 to 69
	value = ((uint32_t)(input[6] & 0x03) << 30) |
			((uint32_t)input[7] << 22) |
			((uint32_t)(input[8] & 0xfc) << 14);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 70 to 85
	value = ((uint32_t)(input[8] & 0x03) << 30) |
			((uint32_t)input[9] << 22) |
			((uint32_t)(input[10] & 0xfc) << 14);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 86 to 101
	value = ((uint32_t)(input[10] & 0x03) << 30) |
			((uint32_t)input[11] << 22) |
			((uint32_t)(input[12] & 0xfc) << 14);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 102 to 117
	value = ((uint32_t)(input[12] & 0x03) << 30) |
			((uint32_t)input[13] << 22) |
			((uint32_t)(input[14] & 0xfc) << 14);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 118 to 133
	value = ((uint32_t)(input[14] & 0x03) << 30) |
			((uint32_t)input[15] << 22) |
			((uint32_t)(input[16] & 0xfc) << 14);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 134 to 149
	value = ((uint32_t)(input[16] & 0x03) << 30) |
			((uint32_t)input[17] << 22) |
			((uint32_t)(input[18] & 0xfc) << 14);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 150 to 165
	value = ((uint32_t)(input[18] & 0x03) << 30) |
			((uint32_t)input[19] << 22) |
			((uint32_t)(input[20] & 0xfc) << 14);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 166 to 181
	value = ((uint32_t)(input[20] & 0x03) << 30) |
			((uint32_t)input[21] << 22) |
			((uint32_t)(input[22] & 0xfc) << 14);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 182 to 197
	value = ((uint32_t)(input[22] & 0x03) << 30) |
			((uint32_t)input[23] << 22) |
			((uint32_t)(input[24] & 0xfc) << 14);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 198 to 213
	value = ((uint32_t)(input[24] & 0x03) << 30) |
			((uint32_t)input[25] << 22) |
			((uint32_t)(input[26] & 0xfc) << 14);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 214 to 229
	value = ((uint32_t)(input[26] & 0x03) << 30) |
			((uint32_t)input[27] << 22) |
			((uint32_t)(input[28] & 0xfc) << 14);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 230 to 245
	value = ((uint32_t)(input[28] & 0x03) << 30) |
			((uint32_t)input[29] << 22) |
			((uint32_t)(input[30] & 0xfc) << 14);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 246 to 261
	value = ((uint32_t)(input[30] & 0x03) << 30) |
			((uint32_t)input[31] << 22) |
			((uint32_t)(input[32] & 0xfc) << 14);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 262 to 277
	value = ((uint32_t)(input[32] & 0x03) << 30) |
			((uint32_t)input[33] << 22) |
			((uint32_t)(input[34] & 0xfc) << 14);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 278 to 293
	value = ((uint32_t)(input[34] & 0x03) << 30) |
			((uint32_t)input[35] << 22) |
			((uint32_t)(input[36] & 0xfc) << 14);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 294 to 309
	value = ((uint32_t)(input[36] & 0x03) << 30) |
			((uint32_t)input[37] << 22) |
			((uint32_t)(input[38] & 0xfc) << 14);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 310 to 325
	value = ((uint32_t)(input[38] & 0x03) << 30) |
			((uint32_t)input[39] << 22) |
			((uint32_t)(input[40] & 0xfc) << 14);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 326 to 341
	value = ((uint32_t)(input[40] & 0x03) << 30) |
			((uint32_t)input[41] << 22) |
			((uint32_t)(input[42] & 0xfc) << 14);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 342 to 357
	value = ((uint32_t)(input[42] & 0x03) << 30) |
			((uint32_t)input[43] << 22) |
			((uint32_t)(input[44] & 0xfc) << 14);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 358 to 373
	value = ((uint32_t)(input[44] & 0x03) << 30) |
			((uint32_t)input[45] << 22) |
			((uint32_t)(input[46] & 0xfc) << 14);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 374 to 389
	value = ((uint32_t)(input[46] & 0x03) << 30) |
			((uint32_t)input[47] << 22) |
			((uint32_t)(input[48] & 0xfc) << 14);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 390 to 405
	value = ((uint32_t)(input[48] & 0x03) << 30) |
			((uint32_t)input[49] << 22) |
			((uint32_t)(input[50] & 0xfc) << 14);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 406 to 421
	value = ((uint32_t)(input[50] & 0x03) << 30) |
			((uint32_t)input[51] << 22) |
			((uint32_t)(input[52] & 0xfc) << 14);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 422 to 437
	value = ((uint32_t)(input[52] & 0x03) << 30) |
			((uint32_t)input[53] << 22) |
			((uint32_t)(input[54] & 0xfc) << 14);
	output[26] = (double)(value >> 16);
}

static void unpack_27_16bit_signed_7off(const uint8_t * input, double * output, void *closure) {
	// Unpack 27 values into output
	// Values are 16-bit signed
	// Skip 7 bits, read 432 bits of data.
	// Input must be at least 55 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 7 to 22
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)(input[2] & 0xfe) << 15);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 23 to 38
	value = ((uint32_t)(input[2] & 0x01) << 31) |
			((uint32_t)input[3] << 23) |
			((uint32_t)(input[4] & 0xfe) << 15);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 39 to 54
	value = ((uint32_t)(input[4] & 0x01) << 31) |
			((uint32_t)input[5] << 23) |
			((uint32_t)(input[6] & 0xfe) << 15);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 55 to 70
	value = ((uint32_t)(input[6] & 0x01) << 31) |
			((uint32_t)input[7] << 23) |
			((uint32_t)(input[8] & 0xfe) << 15);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 71 to 86
	value = ((uint32_t)(input[8] & 0x01) << 31) |
			((uint32_t)input[9] << 23) |
			((uint32_t)(input[10] & 0xfe) << 15);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 87 to 102
	value = ((uint32_t)(input[10] & 0x01) << 31) |
			((uint32_t)input[11] << 23) |
			((uint32_t)(input[12] & 0xfe) << 15);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 103 to 118
	value = ((uint32_t)(input[12] & 0x01) << 31) |
			((uint32_t)input[13] << 23) |
			((uint32_t)(input[14] & 0xfe) << 15);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 119 to 134
	value = ((uint32_t)(input[14] & 0x01) << 31) |
			((uint32_t)input[15] << 23) |
			((uint32_t)(input[16] & 0xfe) << 15);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 135 to 150
	value = ((uint32_t)(input[16] & 0x01) << 31) |
			((uint32_t)input[17] << 23) |
			((uint32_t)(input[18] & 0xfe) << 15);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 151 to 166
	value = ((uint32_t)(input[18] & 0x01) << 31) |
			((uint32_t)input[19] << 23) |
			((uint32_t)(input[20] & 0xfe) << 15);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 167 to 182
	value = ((uint32_t)(input[20] & 0x01) << 31) |
			((uint32_t)input[21] << 23) |
			((uint32_t)(input[22] & 0xfe) << 15);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 183 to 198
	value = ((uint32_t)(input[22] & 0x01) << 31) |
			((uint32_t)input[23] << 23) |
			((uint32_t)(input[24] & 0xfe) << 15);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 199 to 214
	value = ((uint32_t)(input[24] & 0x01) << 31) |
			((uint32_t)input[25] << 23) |
			((uint32_t)(input[26] & 0xfe) << 15);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 215 to 230
	value = ((uint32_t)(input[26] & 0x01) << 31) |
			((uint32_t)input[27] << 23) |
			((uint32_t)(input[28] & 0xfe) << 15);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 231 to 246
	value = ((uint32_t)(input[28] & 0x01) << 31) |
			((uint32_t)input[29] << 23) |
			((uint32_t)(input[30] & 0xfe) << 15);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 247 to 262
	value = ((uint32_t)(input[30] & 0x01) << 31) |
			((uint32_t)input[31] << 23) |
			((uint32_t)(input[32] & 0xfe) << 15);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 263 to 278
	value = ((uint32_t)(input[32] & 0x01) << 31) |
			((uint32_t)input[33] << 23) |
			((uint32_t)(input[34] & 0xfe) << 15);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 279 to 294
	value = ((uint32_t)(input[34] & 0x01) << 31) |
			((uint32_t)input[35] << 23) |
			((uint32_t)(input[36] & 0xfe) << 15);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 295 to 310
	value = ((uint32_t)(input[36] & 0x01) << 31) |
			((uint32_t)input[37] << 23) |
			((uint32_t)(input[38] & 0xfe) << 15);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 311 to 326
	value = ((uint32_t)(input[38] & 0x01) << 31) |
			((uint32_t)input[39] << 23) |
			((uint32_t)(input[40] & 0xfe) << 15);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 327 to 342
	value = ((uint32_t)(input[40] & 0x01) << 31) |
			((uint32_t)input[41] << 23) |
			((uint32_t)(input[42] & 0xfe) << 15);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 343 to 358
	value = ((uint32_t)(input[42] & 0x01) << 31) |
			((uint32_t)input[43] << 23) |
			((uint32_t)(input[44] & 0xfe) << 15);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 359 to 374
	value = ((uint32_t)(input[44] & 0x01) << 31) |
			((uint32_t)input[45] << 23) |
			((uint32_t)(input[46] & 0xfe) << 15);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 375 to 390
	value = ((uint32_t)(input[46] & 0x01) << 31) |
			((uint32_t)input[47] << 23) |
			((uint32_t)(input[48] & 0xfe) << 15);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 391 to 406
	value = ((uint32_t)(input[48] & 0x01) << 31) |
			((uint32_t)input[49] << 23) |
			((uint32_t)(input[50] & 0xfe) << 15);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 407 to 422
	value = ((uint32_t)(input[50] & 0x01) << 31) |
			((uint32_t)input[51] << 23) |
			((uint32_t)(input[52] & 0xfe) << 15);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 423 to 438
	value = ((uint32_t)(input[52] & 0x01) << 31) |
			((uint32_t)input[53] << 23) |
			((uint32_t)(input[54] & 0xfe) << 15);
	output[26] = (double)(value >> 16);
}

static void unpack_27_16bit_unsigned_7off(const uint8_t * input, double * output, void *closure) {
	// Unpack 27 values into output
	// Values are 16-bit unsigned
	// Skip 7 bits, read 432 bits of data.
	// Input must be at least 55 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 7 to 22
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)(input[2] & 0xfe) << 15);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 23 to 38
	value = ((uint32_t)(input[2] & 0x01) << 31) |
			((uint32_t)input[3] << 23) |
			((uint32_t)(input[4] & 0xfe) << 15);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 39 to 54
	value = ((uint32_t)(input[4] & 0x01) << 31) |
			((uint32_t)input[5] << 23) |
			((uint32_t)(input[6] & 0xfe) << 15);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 55 to 70
	value = ((uint32_t)(input[6] & 0x01) << 31) |
			((uint32_t)input[7] << 23) |
			((uint32_t)(input[8] & 0xfe) << 15);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 71 to 86
	value = ((uint32_t)(input[8] & 0x01) << 31) |
			((uint32_t)input[9] << 23) |
			((uint32_t)(input[10] & 0xfe) << 15);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 87 to 102
	value = ((uint32_t)(input[10] & 0x01) << 31) |
			((uint32_t)input[11] << 23) |
			((uint32_t)(input[12] & 0xfe) << 15);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 103 to 118
	value = ((uint32_t)(input[12] & 0x01) << 31) |
			((uint32_t)input[13] << 23) |
			((uint32_t)(input[14] & 0xfe) << 15);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 119 to 134
	value = ((uint32_t)(input[14] & 0x01) << 31) |
			((uint32_t)input[15] << 23) |
			((uint32_t)(input[16] & 0xfe) << 15);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 135 to 150
	value = ((uint32_t)(input[16] & 0x01) << 31) |
			((uint32_t)input[17] << 23) |
			((uint32_t)(input[18] & 0xfe) << 15);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 151 to 166
	value = ((uint32_t)(input[18] & 0x01) << 31) |
			((uint32_t)input[19] << 23) |
			((uint32_t)(input[20] & 0xfe) << 15);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 167 to 182
	value = ((uint32_t)(input[20] & 0x01) << 31) |
			((uint32_t)input[21] << 23) |
			((uint32_t)(input[22] & 0xfe) << 15);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 183 to 198
	value = ((uint32_t)(input[22] & 0x01) << 31) |
			((uint32_t)input[23] << 23) |
			((uint32_t)(input[24] & 0xfe) << 15);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 199 to 214
	value = ((uint32_t)(input[24] & 0x01) << 31) |
			((uint32_t)input[25] << 23) |
			((uint32_t)(input[26] & 0xfe) << 15);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 215 to 230
	value = ((uint32_t)(input[26] & 0x01) << 31) |
			((uint32_t)input[27] << 23) |
			((uint32_t)(input[28] & 0xfe) << 15);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 231 to 246
	value = ((uint32_t)(input[28] & 0x01) << 31) |
			((uint32_t)input[29] << 23) |
			((uint32_t)(input[30] & 0xfe) << 15);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 247 to 262
	value = ((uint32_t)(input[30] & 0x01) << 31) |
			((uint32_t)input[31] << 23) |
			((uint32_t)(input[32] & 0xfe) << 15);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 263 to 278
	value = ((uint32_t)(input[32] & 0x01) << 31) |
			((uint32_t)input[33] << 23) |
			((uint32_t)(input[34] & 0xfe) << 15);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 279 to 294
	value = ((uint32_t)(input[34] & 0x01) << 31) |
			((uint32_t)input[35] << 23) |
			((uint32_t)(input[36] & 0xfe) << 15);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 295 to 310
	value = ((uint32_t)(input[36] & 0x01) << 31) |
			((uint32_t)input[37] << 23) |
			((uint32_t)(input[38] & 0xfe) << 15);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 311 to 326
	value = ((uint32_t)(input[38] & 0x01) << 31) |
			((uint32_t)input[39] << 23) |
			((uint32_t)(input[40] & 0xfe) << 15);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 327 to 342
	value = ((uint32_t)(input[40] & 0x01) << 31) |
			((uint32_t)input[41] << 23) |
			((uint32_t)(input[42] & 0xfe) << 15);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 343 to 358
	value = ((uint32_t)(input[42] & 0x01) << 31) |
			((uint32_t)input[43] << 23) |
			((uint32_t)(input[44] & 0xfe) << 15);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 359 to 374
	value = ((uint32_t)(input[44] & 0x01) << 31) |
			((uint32_t)input[45] << 23) |
			((uint32_t)(input[46] & 0xfe) << 15);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 375 to 390
	value = ((uint32_t)(input[46] & 0x01) << 31) |
			((uint32_t)input[47] << 23) |
			((uint32_t)(input[48] & 0xfe) << 15);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 391 to 406
	value = ((uint32_t)(input[48] & 0x01) << 31) |
			((uint32_t)input[49] << 23) |
			((uint32_t)(input[50] & 0xfe) << 15);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 407 to 422
	value = ((uint32_t)(input[50] & 0x01) << 31) |
			((uint32_t)input[51] << 23) |
			((uint32_t)(input[52] & 0xfe) << 15);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 423 to 438
	value = ((uint32_t)(input[52] & 0x01) << 31) |
			((uint32_t)input[53] << 23) |
			((uint32_t)(input[54] & 0xfe) << 15);
	output[26] = (double)(value >> 16);
}

static void unpack_28_16bit_signed_0off(const uint8_t * input, double * output, void *closure) {
	// Unpack 28 values into output
	// Values are 16-bit signed
	// Skip 0 bits, read 448 bits of data.
	// Input must be at least 56 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 0 to 15
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)input[1] << 16);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 16 to 31
	value = ((uint32_t)input[2] << 24) |
			((uint32_t)input[3] << 16);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 32 to 47
	value = ((uint32_t)input[4] << 24) |
			((uint32_t)input[5] << 16);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 48 to 63
	value = ((uint32_t)input[6] << 24) |
			((uint32_t)input[7] << 16);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 64 to 79
	value = ((uint32_t)input[8] << 24) |
			((uint32_t)input[9] << 16);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 80 to 95
	value = ((uint32_t)input[10] << 24) |
			((uint32_t)input[11] << 16);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 96 to 111
	value = ((uint32_t)input[12] << 24) |
			((uint32_t)input[13] << 16);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 112 to 127
	value = ((uint32_t)input[14] << 24) |
			((uint32_t)input[15] << 16);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 128 to 143
	value = ((uint32_t)input[16] << 24) |
			((uint32_t)input[17] << 16);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 144 to 159
	value = ((uint32_t)input[18] << 24) |
			((uint32_t)input[19] << 16);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 160 to 175
	value = ((uint32_t)input[20] << 24) |
			((uint32_t)input[21] << 16);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 176 to 191
	value = ((uint32_t)input[22] << 24) |
			((uint32_t)input[23] << 16);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 192 to 207
	value = ((uint32_t)input[24] << 24) |
			((uint32_t)input[25] << 16);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 208 to 223
	value = ((uint32_t)input[26] << 24) |
			((uint32_t)input[27] << 16);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 224 to 239
	value = ((uint32_t)input[28] << 24) |
			((uint32_t)input[29] << 16);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 240 to 255
	value = ((uint32_t)input[30] << 24) |
			((uint32_t)input[31] << 16);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 256 to 271
	value = ((uint32_t)input[32] << 24) |
			((uint32_t)input[33] << 16);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 272 to 287
	value = ((uint32_t)input[34] << 24) |
			((uint32_t)input[35] << 16);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 288 to 303
	value = ((uint32_t)input[36] << 24) |
			((uint32_t)input[37] << 16);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 304 to 319
	value = ((uint32_t)input[38] << 24) |
			((uint32_t)input[39] << 16);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 320 to 335
	value = ((uint32_t)input[40] << 24) |
			((uint32_t)input[41] << 16);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 336 to 351
	value = ((uint32_t)input[42] << 24) |
			((uint32_t)input[43] << 16);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 352 to 367
	value = ((uint32_t)input[44] << 24) |
			((uint32_t)input[45] << 16);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 368 to 383
	value = ((uint32_t)input[46] << 24) |
			((uint32_t)input[47] << 16);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 384 to 399
	value = ((uint32_t)input[48] << 24) |
			((uint32_t)input[49] << 16);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 400 to 415
	value = ((uint32_t)input[50] << 24) |
			((uint32_t)input[51] << 16);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 416 to 431
	value = ((uint32_t)input[52] << 24) |
			((uint32_t)input[53] << 16);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 432 to 447
	value = ((uint32_t)input[54] << 24) |
			((uint32_t)input[55] << 16);
	output[27] = (double)(value >> 16);
}

static void unpack_28_16bit_unsigned_0off(const uint8_t * input, double * output, void *closure) {
	// Unpack 28 values into output
	// Values are 16-bit unsigned
	// Skip 0 bits, read 448 bits of data.
	// Input must be at least 56 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 0 to 15
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)input[1] << 16);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 16 to 31
	value = ((uint32_t)input[2] << 24) |
			((uint32_t)input[3] << 16);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 32 to 47
	value = ((uint32_t)input[4] << 24) |
			((uint32_t)input[5] << 16);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 48 to 63
	value = ((uint32_t)input[6] << 24) |
			((uint32_t)input[7] << 16);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 64 to 79
	value = ((uint32_t)input[8] << 24) |
			((uint32_t)input[9] << 16);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 80 to 95
	value = ((uint32_t)input[10] << 24) |
			((uint32_t)input[11] << 16);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 96 to 111
	value = ((uint32_t)input[12] << 24) |
			((uint32_t)input[13] << 16);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 112 to 127
	value = ((uint32_t)input[14] << 24) |
			((uint32_t)input[15] << 16);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 128 to 143
	value = ((uint32_t)input[16] << 24) |
			((uint32_t)input[17] << 16);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 144 to 159
	value = ((uint32_t)input[18] << 24) |
			((uint32_t)input[19] << 16);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 160 to 175
	value = ((uint32_t)input[20] << 24) |
			((uint32_t)input[21] << 16);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 176 to 191
	value = ((uint32_t)input[22] << 24) |
			((uint32_t)input[23] << 16);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 192 to 207
	value = ((uint32_t)input[24] << 24) |
			((uint32_t)input[25] << 16);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 208 to 223
	value = ((uint32_t)input[26] << 24) |
			((uint32_t)input[27] << 16);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 224 to 239
	value = ((uint32_t)input[28] << 24) |
			((uint32_t)input[29] << 16);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 240 to 255
	value = ((uint32_t)input[30] << 24) |
			((uint32_t)input[31] << 16);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 256 to 271
	value = ((uint32_t)input[32] << 24) |
			((uint32_t)input[33] << 16);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 272 to 287
	value = ((uint32_t)input[34] << 24) |
			((uint32_t)input[35] << 16);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 288 to 303
	value = ((uint32_t)input[36] << 24) |
			((uint32_t)input[37] << 16);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 304 to 319
	value = ((uint32_t)input[38] << 24) |
			((uint32_t)input[39] << 16);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 320 to 335
	value = ((uint32_t)input[40] << 24) |
			((uint32_t)input[41] << 16);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 336 to 351
	value = ((uint32_t)input[42] << 24) |
			((uint32_t)input[43] << 16);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 352 to 367
	value = ((uint32_t)input[44] << 24) |
			((uint32_t)input[45] << 16);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 368 to 383
	value = ((uint32_t)input[46] << 24) |
			((uint32_t)input[47] << 16);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 384 to 399
	value = ((uint32_t)input[48] << 24) |
			((uint32_t)input[49] << 16);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 400 to 415
	value = ((uint32_t)input[50] << 24) |
			((uint32_t)input[51] << 16);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 416 to 431
	value = ((uint32_t)input[52] << 24) |
			((uint32_t)input[53] << 16);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 432 to 447
	value = ((uint32_t)input[54] << 24) |
			((uint32_t)input[55] << 16);
	output[27] = (double)(value >> 16);
}

static void unpack_28_16bit_signed_1off(const uint8_t * input, double * output, void *closure) {
	// Unpack 28 values into output
	// Values are 16-bit signed
	// Skip 1 bits, read 448 bits of data.
	// Input must be at least 57 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 1 to 16
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)input[1] << 17) |
			((uint32_t)(input[2] & 0x80) << 9);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 17 to 32
	value = ((uint32_t)(input[2] & 0x7f) << 25) |
			((uint32_t)input[3] << 17) |
			((uint32_t)(input[4] & 0x80) << 9);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 33 to 48
	value = ((uint32_t)(input[4] & 0x7f) << 25) |
			((uint32_t)input[5] << 17) |
			((uint32_t)(input[6] & 0x80) << 9);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 49 to 64
	value = ((uint32_t)(input[6] & 0x7f) << 25) |
			((uint32_t)input[7] << 17) |
			((uint32_t)(input[8] & 0x80) << 9);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 65 to 80
	value = ((uint32_t)(input[8] & 0x7f) << 25) |
			((uint32_t)input[9] << 17) |
			((uint32_t)(input[10] & 0x80) << 9);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 81 to 96
	value = ((uint32_t)(input[10] & 0x7f) << 25) |
			((uint32_t)input[11] << 17) |
			((uint32_t)(input[12] & 0x80) << 9);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 97 to 112
	value = ((uint32_t)(input[12] & 0x7f) << 25) |
			((uint32_t)input[13] << 17) |
			((uint32_t)(input[14] & 0x80) << 9);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 113 to 128
	value = ((uint32_t)(input[14] & 0x7f) << 25) |
			((uint32_t)input[15] << 17) |
			((uint32_t)(input[16] & 0x80) << 9);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 129 to 144
	value = ((uint32_t)(input[16] & 0x7f) << 25) |
			((uint32_t)input[17] << 17) |
			((uint32_t)(input[18] & 0x80) << 9);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 145 to 160
	value = ((uint32_t)(input[18] & 0x7f) << 25) |
			((uint32_t)input[19] << 17) |
			((uint32_t)(input[20] & 0x80) << 9);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 161 to 176
	value = ((uint32_t)(input[20] & 0x7f) << 25) |
			((uint32_t)input[21] << 17) |
			((uint32_t)(input[22] & 0x80) << 9);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 177 to 192
	value = ((uint32_t)(input[22] & 0x7f) << 25) |
			((uint32_t)input[23] << 17) |
			((uint32_t)(input[24] & 0x80) << 9);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 193 to 208
	value = ((uint32_t)(input[24] & 0x7f) << 25) |
			((uint32_t)input[25] << 17) |
			((uint32_t)(input[26] & 0x80) << 9);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 209 to 224
	value = ((uint32_t)(input[26] & 0x7f) << 25) |
			((uint32_t)input[27] << 17) |
			((uint32_t)(input[28] & 0x80) << 9);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 225 to 240
	value = ((uint32_t)(input[28] & 0x7f) << 25) |
			((uint32_t)input[29] << 17) |
			((uint32_t)(input[30] & 0x80) << 9);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 241 to 256
	value = ((uint32_t)(input[30] & 0x7f) << 25) |
			((uint32_t)input[31] << 17) |
			((uint32_t)(input[32] & 0x80) << 9);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 257 to 272
	value = ((uint32_t)(input[32] & 0x7f) << 25) |
			((uint32_t)input[33] << 17) |
			((uint32_t)(input[34] & 0x80) << 9);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 273 to 288
	value = ((uint32_t)(input[34] & 0x7f) << 25) |
			((uint32_t)input[35] << 17) |
			((uint32_t)(input[36] & 0x80) << 9);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 289 to 304
	value = ((uint32_t)(input[36] & 0x7f) << 25) |
			((uint32_t)input[37] << 17) |
			((uint32_t)(input[38] & 0x80) << 9);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 305 to 320
	value = ((uint32_t)(input[38] & 0x7f) << 25) |
			((uint32_t)input[39] << 17) |
			((uint32_t)(input[40] & 0x80) << 9);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 321 to 336
	value = ((uint32_t)(input[40] & 0x7f) << 25) |
			((uint32_t)input[41] << 17) |
			((uint32_t)(input[42] & 0x80) << 9);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 337 to 352
	value = ((uint32_t)(input[42] & 0x7f) << 25) |
			((uint32_t)input[43] << 17) |
			((uint32_t)(input[44] & 0x80) << 9);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 353 to 368
	value = ((uint32_t)(input[44] & 0x7f) << 25) |
			((uint32_t)input[45] << 17) |
			((uint32_t)(input[46] & 0x80) << 9);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 369 to 384
	value = ((uint32_t)(input[46] & 0x7f) << 25) |
			((uint32_t)input[47] << 17) |
			((uint32_t)(input[48] & 0x80) << 9);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 385 to 400
	value = ((uint32_t)(input[48] & 0x7f) << 25) |
			((uint32_t)input[49] << 17) |
			((uint32_t)(input[50] & 0x80) << 9);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 401 to 416
	value = ((uint32_t)(input[50] & 0x7f) << 25) |
			((uint32_t)input[51] << 17) |
			((uint32_t)(input[52] & 0x80) << 9);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 417 to 432
	value = ((uint32_t)(input[52] & 0x7f) << 25) |
			((uint32_t)input[53] << 17) |
			((uint32_t)(input[54] & 0x80) << 9);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 433 to 448
	value = ((uint32_t)(input[54] & 0x7f) << 25) |
			((uint32_t)input[55] << 17) |
			((uint32_t)(input[56] & 0x80) << 9);
	output[27] = (double)(value >> 16);
}

static void unpack_28_16bit_unsigned_1off(const uint8_t * input, double * output, void *closure) {
	// Unpack 28 values into output
	// Values are 16-bit unsigned
	// Skip 1 bits, read 448 bits of data.
	// Input must be at least 57 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 1 to 16
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)input[1] << 17) |
			((uint32_t)(input[2] & 0x80) << 9);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 17 to 32
	value = ((uint32_t)(input[2] & 0x7f) << 25) |
			((uint32_t)input[3] << 17) |
			((uint32_t)(input[4] & 0x80) << 9);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 33 to 48
	value = ((uint32_t)(input[4] & 0x7f) << 25) |
			((uint32_t)input[5] << 17) |
			((uint32_t)(input[6] & 0x80) << 9);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 49 to 64
	value = ((uint32_t)(input[6] & 0x7f) << 25) |
			((uint32_t)input[7] << 17) |
			((uint32_t)(input[8] & 0x80) << 9);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 65 to 80
	value = ((uint32_t)(input[8] & 0x7f) << 25) |
			((uint32_t)input[9] << 17) |
			((uint32_t)(input[10] & 0x80) << 9);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 81 to 96
	value = ((uint32_t)(input[10] & 0x7f) << 25) |
			((uint32_t)input[11] << 17) |
			((uint32_t)(input[12] & 0x80) << 9);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 97 to 112
	value = ((uint32_t)(input[12] & 0x7f) << 25) |
			((uint32_t)input[13] << 17) |
			((uint32_t)(input[14] & 0x80) << 9);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 113 to 128
	value = ((uint32_t)(input[14] & 0x7f) << 25) |
			((uint32_t)input[15] << 17) |
			((uint32_t)(input[16] & 0x80) << 9);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 129 to 144
	value = ((uint32_t)(input[16] & 0x7f) << 25) |
			((uint32_t)input[17] << 17) |
			((uint32_t)(input[18] & 0x80) << 9);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 145 to 160
	value = ((uint32_t)(input[18] & 0x7f) << 25) |
			((uint32_t)input[19] << 17) |
			((uint32_t)(input[20] & 0x80) << 9);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 161 to 176
	value = ((uint32_t)(input[20] & 0x7f) << 25) |
			((uint32_t)input[21] << 17) |
			((uint32_t)(input[22] & 0x80) << 9);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 177 to 192
	value = ((uint32_t)(input[22] & 0x7f) << 25) |
			((uint32_t)input[23] << 17) |
			((uint32_t)(input[24] & 0x80) << 9);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 193 to 208
	value = ((uint32_t)(input[24] & 0x7f) << 25) |
			((uint32_t)input[25] << 17) |
			((uint32_t)(input[26] & 0x80) << 9);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 209 to 224
	value = ((uint32_t)(input[26] & 0x7f) << 25) |
			((uint32_t)input[27] << 17) |
			((uint32_t)(input[28] & 0x80) << 9);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 225 to 240
	value = ((uint32_t)(input[28] & 0x7f) << 25) |
			((uint32_t)input[29] << 17) |
			((uint32_t)(input[30] & 0x80) << 9);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 241 to 256
	value = ((uint32_t)(input[30] & 0x7f) << 25) |
			((uint32_t)input[31] << 17) |
			((uint32_t)(input[32] & 0x80) << 9);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 257 to 272
	value = ((uint32_t)(input[32] & 0x7f) << 25) |
			((uint32_t)input[33] << 17) |
			((uint32_t)(input[34] & 0x80) << 9);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 273 to 288
	value = ((uint32_t)(input[34] & 0x7f) << 25) |
			((uint32_t)input[35] << 17) |
			((uint32_t)(input[36] & 0x80) << 9);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 289 to 304
	value = ((uint32_t)(input[36] & 0x7f) << 25) |
			((uint32_t)input[37] << 17) |
			((uint32_t)(input[38] & 0x80) << 9);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 305 to 320
	value = ((uint32_t)(input[38] & 0x7f) << 25) |
			((uint32_t)input[39] << 17) |
			((uint32_t)(input[40] & 0x80) << 9);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 321 to 336
	value = ((uint32_t)(input[40] & 0x7f) << 25) |
			((uint32_t)input[41] << 17) |
			((uint32_t)(input[42] & 0x80) << 9);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 337 to 352
	value = ((uint32_t)(input[42] & 0x7f) << 25) |
			((uint32_t)input[43] << 17) |
			((uint32_t)(input[44] & 0x80) << 9);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 353 to 368
	value = ((uint32_t)(input[44] & 0x7f) << 25) |
			((uint32_t)input[45] << 17) |
			((uint32_t)(input[46] & 0x80) << 9);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 369 to 384
	value = ((uint32_t)(input[46] & 0x7f) << 25) |
			((uint32_t)input[47] << 17) |
			((uint32_t)(input[48] & 0x80) << 9);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 385 to 400
	value = ((uint32_t)(input[48] & 0x7f) << 25) |
			((uint32_t)input[49] << 17) |
			((uint32_t)(input[50] & 0x80) << 9);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 401 to 416
	value = ((uint32_t)(input[50] & 0x7f) << 25) |
			((uint32_t)input[51] << 17) |
			((uint32_t)(input[52] & 0x80) << 9);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 417 to 432
	value = ((uint32_t)(input[52] & 0x7f) << 25) |
			((uint32_t)input[53] << 17) |
			((uint32_t)(input[54] & 0x80) << 9);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 433 to 448
	value = ((uint32_t)(input[54] & 0x7f) << 25) |
			((uint32_t)input[55] << 17) |
			((uint32_t)(input[56] & 0x80) << 9);
	output[27] = (double)(value >> 16);
}

static void unpack_28_16bit_signed_2off(const uint8_t * input, double * output, void *closure) {
	// Unpack 28 values into output
	// Values are 16-bit signed
	// Skip 2 bits, read 448 bits of data.
	// Input must be at least 57 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 2 to 17
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)input[1] << 18) |
			((uint32_t)(input[2] & 0xc0) << 10);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 18 to 33
	value = ((uint32_t)(input[2] & 0x3f) << 26) |
			((uint32_t)input[3] << 18) |
			((uint32_t)(input[4] & 0xc0) << 10);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 34 to 49
	value = ((uint32_t)(input[4] & 0x3f) << 26) |
			((uint32_t)input[5] << 18) |
			((uint32_t)(input[6] & 0xc0) << 10);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 50 to 65
	value = ((uint32_t)(input[6] & 0x3f) << 26) |
			((uint32_t)input[7] << 18) |
			((uint32_t)(input[8] & 0xc0) << 10);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 66 to 81
	value = ((uint32_t)(input[8] & 0x3f) << 26) |
			((uint32_t)input[9] << 18) |
			((uint32_t)(input[10] & 0xc0) << 10);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 82 to 97
	value = ((uint32_t)(input[10] & 0x3f) << 26) |
			((uint32_t)input[11] << 18) |
			((uint32_t)(input[12] & 0xc0) << 10);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 98 to 113
	value = ((uint32_t)(input[12] & 0x3f) << 26) |
			((uint32_t)input[13] << 18) |
			((uint32_t)(input[14] & 0xc0) << 10);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 114 to 129
	value = ((uint32_t)(input[14] & 0x3f) << 26) |
			((uint32_t)input[15] << 18) |
			((uint32_t)(input[16] & 0xc0) << 10);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 130 to 145
	value = ((uint32_t)(input[16] & 0x3f) << 26) |
			((uint32_t)input[17] << 18) |
			((uint32_t)(input[18] & 0xc0) << 10);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 146 to 161
	value = ((uint32_t)(input[18] & 0x3f) << 26) |
			((uint32_t)input[19] << 18) |
			((uint32_t)(input[20] & 0xc0) << 10);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 162 to 177
	value = ((uint32_t)(input[20] & 0x3f) << 26) |
			((uint32_t)input[21] << 18) |
			((uint32_t)(input[22] & 0xc0) << 10);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 178 to 193
	value = ((uint32_t)(input[22] & 0x3f) << 26) |
			((uint32_t)input[23] << 18) |
			((uint32_t)(input[24] & 0xc0) << 10);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 194 to 209
	value = ((uint32_t)(input[24] & 0x3f) << 26) |
			((uint32_t)input[25] << 18) |
			((uint32_t)(input[26] & 0xc0) << 10);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 210 to 225
	value = ((uint32_t)(input[26] & 0x3f) << 26) |
			((uint32_t)input[27] << 18) |
			((uint32_t)(input[28] & 0xc0) << 10);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 226 to 241
	value = ((uint32_t)(input[28] & 0x3f) << 26) |
			((uint32_t)input[29] << 18) |
			((uint32_t)(input[30] & 0xc0) << 10);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 242 to 257
	value = ((uint32_t)(input[30] & 0x3f) << 26) |
			((uint32_t)input[31] << 18) |
			((uint32_t)(input[32] & 0xc0) << 10);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 258 to 273
	value = ((uint32_t)(input[32] & 0x3f) << 26) |
			((uint32_t)input[33] << 18) |
			((uint32_t)(input[34] & 0xc0) << 10);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 274 to 289
	value = ((uint32_t)(input[34] & 0x3f) << 26) |
			((uint32_t)input[35] << 18) |
			((uint32_t)(input[36] & 0xc0) << 10);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 290 to 305
	value = ((uint32_t)(input[36] & 0x3f) << 26) |
			((uint32_t)input[37] << 18) |
			((uint32_t)(input[38] & 0xc0) << 10);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 306 to 321
	value = ((uint32_t)(input[38] & 0x3f) << 26) |
			((uint32_t)input[39] << 18) |
			((uint32_t)(input[40] & 0xc0) << 10);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 322 to 337
	value = ((uint32_t)(input[40] & 0x3f) << 26) |
			((uint32_t)input[41] << 18) |
			((uint32_t)(input[42] & 0xc0) << 10);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 338 to 353
	value = ((uint32_t)(input[42] & 0x3f) << 26) |
			((uint32_t)input[43] << 18) |
			((uint32_t)(input[44] & 0xc0) << 10);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 354 to 369
	value = ((uint32_t)(input[44] & 0x3f) << 26) |
			((uint32_t)input[45] << 18) |
			((uint32_t)(input[46] & 0xc0) << 10);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 370 to 385
	value = ((uint32_t)(input[46] & 0x3f) << 26) |
			((uint32_t)input[47] << 18) |
			((uint32_t)(input[48] & 0xc0) << 10);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 386 to 401
	value = ((uint32_t)(input[48] & 0x3f) << 26) |
			((uint32_t)input[49] << 18) |
			((uint32_t)(input[50] & 0xc0) << 10);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 402 to 417
	value = ((uint32_t)(input[50] & 0x3f) << 26) |
			((uint32_t)input[51] << 18) |
			((uint32_t)(input[52] & 0xc0) << 10);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 418 to 433
	value = ((uint32_t)(input[52] & 0x3f) << 26) |
			((uint32_t)input[53] << 18) |
			((uint32_t)(input[54] & 0xc0) << 10);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 434 to 449
	value = ((uint32_t)(input[54] & 0x3f) << 26) |
			((uint32_t)input[55] << 18) |
			((uint32_t)(input[56] & 0xc0) << 10);
	output[27] = (double)(value >> 16);
}

static void unpack_28_16bit_unsigned_2off(const uint8_t * input, double * output, void *closure) {
	// Unpack 28 values into output
	// Values are 16-bit unsigned
	// Skip 2 bits, read 448 bits of data.
	// Input must be at least 57 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 2 to 17
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)input[1] << 18) |
			((uint32_t)(input[2] & 0xc0) << 10);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 18 to 33
	value = ((uint32_t)(input[2] & 0x3f) << 26) |
			((uint32_t)input[3] << 18) |
			((uint32_t)(input[4] & 0xc0) << 10);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 34 to 49
	value = ((uint32_t)(input[4] & 0x3f) << 26) |
			((uint32_t)input[5] << 18) |
			((uint32_t)(input[6] & 0xc0) << 10);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 50 to 65
	value = ((uint32_t)(input[6] & 0x3f) << 26) |
			((uint32_t)input[7] << 18) |
			((uint32_t)(input[8] & 0xc0) << 10);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 66 to 81
	value = ((uint32_t)(input[8] & 0x3f) << 26) |
			((uint32_t)input[9] << 18) |
			((uint32_t)(input[10] & 0xc0) << 10);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 82 to 97
	value = ((uint32_t)(input[10] & 0x3f) << 26) |
			((uint32_t)input[11] << 18) |
			((uint32_t)(input[12] & 0xc0) << 10);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 98 to 113
	value = ((uint32_t)(input[12] & 0x3f) << 26) |
			((uint32_t)input[13] << 18) |
			((uint32_t)(input[14] & 0xc0) << 10);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 114 to 129
	value = ((uint32_t)(input[14] & 0x3f) << 26) |
			((uint32_t)input[15] << 18) |
			((uint32_t)(input[16] & 0xc0) << 10);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 130 to 145
	value = ((uint32_t)(input[16] & 0x3f) << 26) |
			((uint32_t)input[17] << 18) |
			((uint32_t)(input[18] & 0xc0) << 10);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 146 to 161
	value = ((uint32_t)(input[18] & 0x3f) << 26) |
			((uint32_t)input[19] << 18) |
			((uint32_t)(input[20] & 0xc0) << 10);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 162 to 177
	value = ((uint32_t)(input[20] & 0x3f) << 26) |
			((uint32_t)input[21] << 18) |
			((uint32_t)(input[22] & 0xc0) << 10);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 178 to 193
	value = ((uint32_t)(input[22] & 0x3f) << 26) |
			((uint32_t)input[23] << 18) |
			((uint32_t)(input[24] & 0xc0) << 10);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 194 to 209
	value = ((uint32_t)(input[24] & 0x3f) << 26) |
			((uint32_t)input[25] << 18) |
			((uint32_t)(input[26] & 0xc0) << 10);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 210 to 225
	value = ((uint32_t)(input[26] & 0x3f) << 26) |
			((uint32_t)input[27] << 18) |
			((uint32_t)(input[28] & 0xc0) << 10);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 226 to 241
	value = ((uint32_t)(input[28] & 0x3f) << 26) |
			((uint32_t)input[29] << 18) |
			((uint32_t)(input[30] & 0xc0) << 10);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 242 to 257
	value = ((uint32_t)(input[30] & 0x3f) << 26) |
			((uint32_t)input[31] << 18) |
			((uint32_t)(input[32] & 0xc0) << 10);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 258 to 273
	value = ((uint32_t)(input[32] & 0x3f) << 26) |
			((uint32_t)input[33] << 18) |
			((uint32_t)(input[34] & 0xc0) << 10);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 274 to 289
	value = ((uint32_t)(input[34] & 0x3f) << 26) |
			((uint32_t)input[35] << 18) |
			((uint32_t)(input[36] & 0xc0) << 10);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 290 to 305
	value = ((uint32_t)(input[36] & 0x3f) << 26) |
			((uint32_t)input[37] << 18) |
			((uint32_t)(input[38] & 0xc0) << 10);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 306 to 321
	value = ((uint32_t)(input[38] & 0x3f) << 26) |
			((uint32_t)input[39] << 18) |
			((uint32_t)(input[40] & 0xc0) << 10);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 322 to 337
	value = ((uint32_t)(input[40] & 0x3f) << 26) |
			((uint32_t)input[41] << 18) |
			((uint32_t)(input[42] & 0xc0) << 10);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 338 to 353
	value = ((uint32_t)(input[42] & 0x3f) << 26) |
			((uint32_t)input[43] << 18) |
			((uint32_t)(input[44] & 0xc0) << 10);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 354 to 369
	value = ((uint32_t)(input[44] & 0x3f) << 26) |
			((uint32_t)input[45] << 18) |
			((uint32_t)(input[46] & 0xc0) << 10);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 370 to 385
	value = ((uint32_t)(input[46] & 0x3f) << 26) |
			((uint32_t)input[47] << 18) |
			((uint32_t)(input[48] & 0xc0) << 10);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 386 to 401
	value = ((uint32_t)(input[48] & 0x3f) << 26) |
			((uint32_t)input[49] << 18) |
			((uint32_t)(input[50] & 0xc0) << 10);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 402 to 417
	value = ((uint32_t)(input[50] & 0x3f) << 26) |
			((uint32_t)input[51] << 18) |
			((uint32_t)(input[52] & 0xc0) << 10);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 418 to 433
	value = ((uint32_t)(input[52] & 0x3f) << 26) |
			((uint32_t)input[53] << 18) |
			((uint32_t)(input[54] & 0xc0) << 10);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 434 to 449
	value = ((uint32_t)(input[54] & 0x3f) << 26) |
			((uint32_t)input[55] << 18) |
			((uint32_t)(input[56] & 0xc0) << 10);
	output[27] = (double)(value >> 16);
}

static void unpack_28_16bit_signed_3off(const uint8_t * input, double * output, void *closure) {
	// Unpack 28 values into output
	// Values are 16-bit signed
	// Skip 3 bits, read 448 bits of data.
	// Input must be at least 57 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 3 to 18
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)input[1] << 19) |
			((uint32_t)(input[2] & 0xe0) << 11);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 19 to 34
	value = ((uint32_t)(input[2] & 0x1f) << 27) |
			((uint32_t)input[3] << 19) |
			((uint32_t)(input[4] & 0xe0) << 11);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 35 to 50
	value = ((uint32_t)(input[4] & 0x1f) << 27) |
			((uint32_t)input[5] << 19) |
			((uint32_t)(input[6] & 0xe0) << 11);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 51 to 66
	value = ((uint32_t)(input[6] & 0x1f) << 27) |
			((uint32_t)input[7] << 19) |
			((uint32_t)(input[8] & 0xe0) << 11);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 67 to 82
	value = ((uint32_t)(input[8] & 0x1f) << 27) |
			((uint32_t)input[9] << 19) |
			((uint32_t)(input[10] & 0xe0) << 11);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 83 to 98
	value = ((uint32_t)(input[10] & 0x1f) << 27) |
			((uint32_t)input[11] << 19) |
			((uint32_t)(input[12] & 0xe0) << 11);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 99 to 114
	value = ((uint32_t)(input[12] & 0x1f) << 27) |
			((uint32_t)input[13] << 19) |
			((uint32_t)(input[14] & 0xe0) << 11);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 115 to 130
	value = ((uint32_t)(input[14] & 0x1f) << 27) |
			((uint32_t)input[15] << 19) |
			((uint32_t)(input[16] & 0xe0) << 11);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 131 to 146
	value = ((uint32_t)(input[16] & 0x1f) << 27) |
			((uint32_t)input[17] << 19) |
			((uint32_t)(input[18] & 0xe0) << 11);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 147 to 162
	value = ((uint32_t)(input[18] & 0x1f) << 27) |
			((uint32_t)input[19] << 19) |
			((uint32_t)(input[20] & 0xe0) << 11);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 163 to 178
	value = ((uint32_t)(input[20] & 0x1f) << 27) |
			((uint32_t)input[21] << 19) |
			((uint32_t)(input[22] & 0xe0) << 11);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 179 to 194
	value = ((uint32_t)(input[22] & 0x1f) << 27) |
			((uint32_t)input[23] << 19) |
			((uint32_t)(input[24] & 0xe0) << 11);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 195 to 210
	value = ((uint32_t)(input[24] & 0x1f) << 27) |
			((uint32_t)input[25] << 19) |
			((uint32_t)(input[26] & 0xe0) << 11);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 211 to 226
	value = ((uint32_t)(input[26] & 0x1f) << 27) |
			((uint32_t)input[27] << 19) |
			((uint32_t)(input[28] & 0xe0) << 11);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 227 to 242
	value = ((uint32_t)(input[28] & 0x1f) << 27) |
			((uint32_t)input[29] << 19) |
			((uint32_t)(input[30] & 0xe0) << 11);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 243 to 258
	value = ((uint32_t)(input[30] & 0x1f) << 27) |
			((uint32_t)input[31] << 19) |
			((uint32_t)(input[32] & 0xe0) << 11);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 259 to 274
	value = ((uint32_t)(input[32] & 0x1f) << 27) |
			((uint32_t)input[33] << 19) |
			((uint32_t)(input[34] & 0xe0) << 11);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 275 to 290
	value = ((uint32_t)(input[34] & 0x1f) << 27) |
			((uint32_t)input[35] << 19) |
			((uint32_t)(input[36] & 0xe0) << 11);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 291 to 306
	value = ((uint32_t)(input[36] & 0x1f) << 27) |
			((uint32_t)input[37] << 19) |
			((uint32_t)(input[38] & 0xe0) << 11);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 307 to 322
	value = ((uint32_t)(input[38] & 0x1f) << 27) |
			((uint32_t)input[39] << 19) |
			((uint32_t)(input[40] & 0xe0) << 11);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 323 to 338
	value = ((uint32_t)(input[40] & 0x1f) << 27) |
			((uint32_t)input[41] << 19) |
			((uint32_t)(input[42] & 0xe0) << 11);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 339 to 354
	value = ((uint32_t)(input[42] & 0x1f) << 27) |
			((uint32_t)input[43] << 19) |
			((uint32_t)(input[44] & 0xe0) << 11);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 355 to 370
	value = ((uint32_t)(input[44] & 0x1f) << 27) |
			((uint32_t)input[45] << 19) |
			((uint32_t)(input[46] & 0xe0) << 11);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 371 to 386
	value = ((uint32_t)(input[46] & 0x1f) << 27) |
			((uint32_t)input[47] << 19) |
			((uint32_t)(input[48] & 0xe0) << 11);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 387 to 402
	value = ((uint32_t)(input[48] & 0x1f) << 27) |
			((uint32_t)input[49] << 19) |
			((uint32_t)(input[50] & 0xe0) << 11);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 403 to 418
	value = ((uint32_t)(input[50] & 0x1f) << 27) |
			((uint32_t)input[51] << 19) |
			((uint32_t)(input[52] & 0xe0) << 11);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 419 to 434
	value = ((uint32_t)(input[52] & 0x1f) << 27) |
			((uint32_t)input[53] << 19) |
			((uint32_t)(input[54] & 0xe0) << 11);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 435 to 450
	value = ((uint32_t)(input[54] & 0x1f) << 27) |
			((uint32_t)input[55] << 19) |
			((uint32_t)(input[56] & 0xe0) << 11);
	output[27] = (double)(value >> 16);
}

static void unpack_28_16bit_unsigned_3off(const uint8_t * input, double * output, void *closure) {
	// Unpack 28 values into output
	// Values are 16-bit unsigned
	// Skip 3 bits, read 448 bits of data.
	// Input must be at least 57 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 3 to 18
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)input[1] << 19) |
			((uint32_t)(input[2] & 0xe0) << 11);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 19 to 34
	value = ((uint32_t)(input[2] & 0x1f) << 27) |
			((uint32_t)input[3] << 19) |
			((uint32_t)(input[4] & 0xe0) << 11);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 35 to 50
	value = ((uint32_t)(input[4] & 0x1f) << 27) |
			((uint32_t)input[5] << 19) |
			((uint32_t)(input[6] & 0xe0) << 11);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 51 to 66
	value = ((uint32_t)(input[6] & 0x1f) << 27) |
			((uint32_t)input[7] << 19) |
			((uint32_t)(input[8] & 0xe0) << 11);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 67 to 82
	value = ((uint32_t)(input[8] & 0x1f) << 27) |
			((uint32_t)input[9] << 19) |
			((uint32_t)(input[10] & 0xe0) << 11);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 83 to 98
	value = ((uint32_t)(input[10] & 0x1f) << 27) |
			((uint32_t)input[11] << 19) |
			((uint32_t)(input[12] & 0xe0) << 11);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 99 to 114
	value = ((uint32_t)(input[12] & 0x1f) << 27) |
			((uint32_t)input[13] << 19) |
			((uint32_t)(input[14] & 0xe0) << 11);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 115 to 130
	value = ((uint32_t)(input[14] & 0x1f) << 27) |
			((uint32_t)input[15] << 19) |
			((uint32_t)(input[16] & 0xe0) << 11);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 131 to 146
	value = ((uint32_t)(input[16] & 0x1f) << 27) |
			((uint32_t)input[17] << 19) |
			((uint32_t)(input[18] & 0xe0) << 11);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 147 to 162
	value = ((uint32_t)(input[18] & 0x1f) << 27) |
			((uint32_t)input[19] << 19) |
			((uint32_t)(input[20] & 0xe0) << 11);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 163 to 178
	value = ((uint32_t)(input[20] & 0x1f) << 27) |
			((uint32_t)input[21] << 19) |
			((uint32_t)(input[22] & 0xe0) << 11);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 179 to 194
	value = ((uint32_t)(input[22] & 0x1f) << 27) |
			((uint32_t)input[23] << 19) |
			((uint32_t)(input[24] & 0xe0) << 11);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 195 to 210
	value = ((uint32_t)(input[24] & 0x1f) << 27) |
			((uint32_t)input[25] << 19) |
			((uint32_t)(input[26] & 0xe0) << 11);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 211 to 226
	value = ((uint32_t)(input[26] & 0x1f) << 27) |
			((uint32_t)input[27] << 19) |
			((uint32_t)(input[28] & 0xe0) << 11);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 227 to 242
	value = ((uint32_t)(input[28] & 0x1f) << 27) |
			((uint32_t)input[29] << 19) |
			((uint32_t)(input[30] & 0xe0) << 11);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 243 to 258
	value = ((uint32_t)(input[30] & 0x1f) << 27) |
			((uint32_t)input[31] << 19) |
			((uint32_t)(input[32] & 0xe0) << 11);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 259 to 274
	value = ((uint32_t)(input[32] & 0x1f) << 27) |
			((uint32_t)input[33] << 19) |
			((uint32_t)(input[34] & 0xe0) << 11);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 275 to 290
	value = ((uint32_t)(input[34] & 0x1f) << 27) |
			((uint32_t)input[35] << 19) |
			((uint32_t)(input[36] & 0xe0) << 11);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 291 to 306
	value = ((uint32_t)(input[36] & 0x1f) << 27) |
			((uint32_t)input[37] << 19) |
			((uint32_t)(input[38] & 0xe0) << 11);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 307 to 322
	value = ((uint32_t)(input[38] & 0x1f) << 27) |
			((uint32_t)input[39] << 19) |
			((uint32_t)(input[40] & 0xe0) << 11);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 323 to 338
	value = ((uint32_t)(input[40] & 0x1f) << 27) |
			((uint32_t)input[41] << 19) |
			((uint32_t)(input[42] & 0xe0) << 11);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 339 to 354
	value = ((uint32_t)(input[42] & 0x1f) << 27) |
			((uint32_t)input[43] << 19) |
			((uint32_t)(input[44] & 0xe0) << 11);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 355 to 370
	value = ((uint32_t)(input[44] & 0x1f) << 27) |
			((uint32_t)input[45] << 19) |
			((uint32_t)(input[46] & 0xe0) << 11);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 371 to 386
	value = ((uint32_t)(input[46] & 0x1f) << 27) |
			((uint32_t)input[47] << 19) |
			((uint32_t)(input[48] & 0xe0) << 11);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 387 to 402
	value = ((uint32_t)(input[48] & 0x1f) << 27) |
			((uint32_t)input[49] << 19) |
			((uint32_t)(input[50] & 0xe0) << 11);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 403 to 418
	value = ((uint32_t)(input[50] & 0x1f) << 27) |
			((uint32_t)input[51] << 19) |
			((uint32_t)(input[52] & 0xe0) << 11);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 419 to 434
	value = ((uint32_t)(input[52] & 0x1f) << 27) |
			((uint32_t)input[53] << 19) |
			((uint32_t)(input[54] & 0xe0) << 11);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 435 to 450
	value = ((uint32_t)(input[54] & 0x1f) << 27) |
			((uint32_t)input[55] << 19) |
			((uint32_t)(input[56] & 0xe0) << 11);
	output[27] = (double)(value >> 16);
}

static void unpack_28_16bit_signed_4off(const uint8_t * input, double * output, void *closure) {
	// Unpack 28 values into output
	// Values are 16-bit signed
	// Skip 4 bits, read 448 bits of data.
	// Input must be at least 57 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 4 to 19
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20) |
			((uint32_t)(input[2] & 0xf0) << 12);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 20 to 35
	value = ((uint32_t)(input[2] & 0x0f) << 28) |
			((uint32_t)input[3] << 20) |
			((uint32_t)(input[4] & 0xf0) << 12);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 36 to 51
	value = ((uint32_t)(input[4] & 0x0f) << 28) |
			((uint32_t)input[5] << 20) |
			((uint32_t)(input[6] & 0xf0) << 12);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 52 to 67
	value = ((uint32_t)(input[6] & 0x0f) << 28) |
			((uint32_t)input[7] << 20) |
			((uint32_t)(input[8] & 0xf0) << 12);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 68 to 83
	value = ((uint32_t)(input[8] & 0x0f) << 28) |
			((uint32_t)input[9] << 20) |
			((uint32_t)(input[10] & 0xf0) << 12);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 84 to 99
	value = ((uint32_t)(input[10] & 0x0f) << 28) |
			((uint32_t)input[11] << 20) |
			((uint32_t)(input[12] & 0xf0) << 12);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 100 to 115
	value = ((uint32_t)(input[12] & 0x0f) << 28) |
			((uint32_t)input[13] << 20) |
			((uint32_t)(input[14] & 0xf0) << 12);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 116 to 131
	value = ((uint32_t)(input[14] & 0x0f) << 28) |
			((uint32_t)input[15] << 20) |
			((uint32_t)(input[16] & 0xf0) << 12);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 132 to 147
	value = ((uint32_t)(input[16] & 0x0f) << 28) |
			((uint32_t)input[17] << 20) |
			((uint32_t)(input[18] & 0xf0) << 12);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 148 to 163
	value = ((uint32_t)(input[18] & 0x0f) << 28) |
			((uint32_t)input[19] << 20) |
			((uint32_t)(input[20] & 0xf0) << 12);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 164 to 179
	value = ((uint32_t)(input[20] & 0x0f) << 28) |
			((uint32_t)input[21] << 20) |
			((uint32_t)(input[22] & 0xf0) << 12);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 180 to 195
	value = ((uint32_t)(input[22] & 0x0f) << 28) |
			((uint32_t)input[23] << 20) |
			((uint32_t)(input[24] & 0xf0) << 12);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 196 to 211
	value = ((uint32_t)(input[24] & 0x0f) << 28) |
			((uint32_t)input[25] << 20) |
			((uint32_t)(input[26] & 0xf0) << 12);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 212 to 227
	value = ((uint32_t)(input[26] & 0x0f) << 28) |
			((uint32_t)input[27] << 20) |
			((uint32_t)(input[28] & 0xf0) << 12);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 228 to 243
	value = ((uint32_t)(input[28] & 0x0f) << 28) |
			((uint32_t)input[29] << 20) |
			((uint32_t)(input[30] & 0xf0) << 12);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 244 to 259
	value = ((uint32_t)(input[30] & 0x0f) << 28) |
			((uint32_t)input[31] << 20) |
			((uint32_t)(input[32] & 0xf0) << 12);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 260 to 275
	value = ((uint32_t)(input[32] & 0x0f) << 28) |
			((uint32_t)input[33] << 20) |
			((uint32_t)(input[34] & 0xf0) << 12);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 276 to 291
	value = ((uint32_t)(input[34] & 0x0f) << 28) |
			((uint32_t)input[35] << 20) |
			((uint32_t)(input[36] & 0xf0) << 12);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 292 to 307
	value = ((uint32_t)(input[36] & 0x0f) << 28) |
			((uint32_t)input[37] << 20) |
			((uint32_t)(input[38] & 0xf0) << 12);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 308 to 323
	value = ((uint32_t)(input[38] & 0x0f) << 28) |
			((uint32_t)input[39] << 20) |
			((uint32_t)(input[40] & 0xf0) << 12);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 324 to 339
	value = ((uint32_t)(input[40] & 0x0f) << 28) |
			((uint32_t)input[41] << 20) |
			((uint32_t)(input[42] & 0xf0) << 12);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 340 to 355
	value = ((uint32_t)(input[42] & 0x0f) << 28) |
			((uint32_t)input[43] << 20) |
			((uint32_t)(input[44] & 0xf0) << 12);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 356 to 371
	value = ((uint32_t)(input[44] & 0x0f) << 28) |
			((uint32_t)input[45] << 20) |
			((uint32_t)(input[46] & 0xf0) << 12);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 372 to 387
	value = ((uint32_t)(input[46] & 0x0f) << 28) |
			((uint32_t)input[47] << 20) |
			((uint32_t)(input[48] & 0xf0) << 12);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 388 to 403
	value = ((uint32_t)(input[48] & 0x0f) << 28) |
			((uint32_t)input[49] << 20) |
			((uint32_t)(input[50] & 0xf0) << 12);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 404 to 419
	value = ((uint32_t)(input[50] & 0x0f) << 28) |
			((uint32_t)input[51] << 20) |
			((uint32_t)(input[52] & 0xf0) << 12);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 420 to 435
	value = ((uint32_t)(input[52] & 0x0f) << 28) |
			((uint32_t)input[53] << 20) |
			((uint32_t)(input[54] & 0xf0) << 12);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 436 to 451
	value = ((uint32_t)(input[54] & 0x0f) << 28) |
			((uint32_t)input[55] << 20) |
			((uint32_t)(input[56] & 0xf0) << 12);
	output[27] = (double)(value >> 16);
}

static void unpack_28_16bit_unsigned_4off(const uint8_t * input, double * output, void *closure) {
	// Unpack 28 values into output
	// Values are 16-bit unsigned
	// Skip 4 bits, read 448 bits of data.
	// Input must be at least 57 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 4 to 19
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20) |
			((uint32_t)(input[2] & 0xf0) << 12);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 20 to 35
	value = ((uint32_t)(input[2] & 0x0f) << 28) |
			((uint32_t)input[3] << 20) |
			((uint32_t)(input[4] & 0xf0) << 12);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 36 to 51
	value = ((uint32_t)(input[4] & 0x0f) << 28) |
			((uint32_t)input[5] << 20) |
			((uint32_t)(input[6] & 0xf0) << 12);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 52 to 67
	value = ((uint32_t)(input[6] & 0x0f) << 28) |
			((uint32_t)input[7] << 20) |
			((uint32_t)(input[8] & 0xf0) << 12);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 68 to 83
	value = ((uint32_t)(input[8] & 0x0f) << 28) |
			((uint32_t)input[9] << 20) |
			((uint32_t)(input[10] & 0xf0) << 12);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 84 to 99
	value = ((uint32_t)(input[10] & 0x0f) << 28) |
			((uint32_t)input[11] << 20) |
			((uint32_t)(input[12] & 0xf0) << 12);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 100 to 115
	value = ((uint32_t)(input[12] & 0x0f) << 28) |
			((uint32_t)input[13] << 20) |
			((uint32_t)(input[14] & 0xf0) << 12);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 116 to 131
	value = ((uint32_t)(input[14] & 0x0f) << 28) |
			((uint32_t)input[15] << 20) |
			((uint32_t)(input[16] & 0xf0) << 12);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 132 to 147
	value = ((uint32_t)(input[16] & 0x0f) << 28) |
			((uint32_t)input[17] << 20) |
			((uint32_t)(input[18] & 0xf0) << 12);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 148 to 163
	value = ((uint32_t)(input[18] & 0x0f) << 28) |
			((uint32_t)input[19] << 20) |
			((uint32_t)(input[20] & 0xf0) << 12);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 164 to 179
	value = ((uint32_t)(input[20] & 0x0f) << 28) |
			((uint32_t)input[21] << 20) |
			((uint32_t)(input[22] & 0xf0) << 12);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 180 to 195
	value = ((uint32_t)(input[22] & 0x0f) << 28) |
			((uint32_t)input[23] << 20) |
			((uint32_t)(input[24] & 0xf0) << 12);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 196 to 211
	value = ((uint32_t)(input[24] & 0x0f) << 28) |
			((uint32_t)input[25] << 20) |
			((uint32_t)(input[26] & 0xf0) << 12);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 212 to 227
	value = ((uint32_t)(input[26] & 0x0f) << 28) |
			((uint32_t)input[27] << 20) |
			((uint32_t)(input[28] & 0xf0) << 12);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 228 to 243
	value = ((uint32_t)(input[28] & 0x0f) << 28) |
			((uint32_t)input[29] << 20) |
			((uint32_t)(input[30] & 0xf0) << 12);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 244 to 259
	value = ((uint32_t)(input[30] & 0x0f) << 28) |
			((uint32_t)input[31] << 20) |
			((uint32_t)(input[32] & 0xf0) << 12);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 260 to 275
	value = ((uint32_t)(input[32] & 0x0f) << 28) |
			((uint32_t)input[33] << 20) |
			((uint32_t)(input[34] & 0xf0) << 12);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 276 to 291
	value = ((uint32_t)(input[34] & 0x0f) << 28) |
			((uint32_t)input[35] << 20) |
			((uint32_t)(input[36] & 0xf0) << 12);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 292 to 307
	value = ((uint32_t)(input[36] & 0x0f) << 28) |
			((uint32_t)input[37] << 20) |
			((uint32_t)(input[38] & 0xf0) << 12);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 308 to 323
	value = ((uint32_t)(input[38] & 0x0f) << 28) |
			((uint32_t)input[39] << 20) |
			((uint32_t)(input[40] & 0xf0) << 12);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 324 to 339
	value = ((uint32_t)(input[40] & 0x0f) << 28) |
			((uint32_t)input[41] << 20) |
			((uint32_t)(input[42] & 0xf0) << 12);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 340 to 355
	value = ((uint32_t)(input[42] & 0x0f) << 28) |
			((uint32_t)input[43] << 20) |
			((uint32_t)(input[44] & 0xf0) << 12);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 356 to 371
	value = ((uint32_t)(input[44] & 0x0f) << 28) |
			((uint32_t)input[45] << 20) |
			((uint32_t)(input[46] & 0xf0) << 12);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 372 to 387
	value = ((uint32_t)(input[46] & 0x0f) << 28) |
			((uint32_t)input[47] << 20) |
			((uint32_t)(input[48] & 0xf0) << 12);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 388 to 403
	value = ((uint32_t)(input[48] & 0x0f) << 28) |
			((uint32_t)input[49] << 20) |
			((uint32_t)(input[50] & 0xf0) << 12);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 404 to 419
	value = ((uint32_t)(input[50] & 0x0f) << 28) |
			((uint32_t)input[51] << 20) |
			((uint32_t)(input[52] & 0xf0) << 12);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 420 to 435
	value = ((uint32_t)(input[52] & 0x0f) << 28) |
			((uint32_t)input[53] << 20) |
			((uint32_t)(input[54] & 0xf0) << 12);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 436 to 451
	value = ((uint32_t)(input[54] & 0x0f) << 28) |
			((uint32_t)input[55] << 20) |
			((uint32_t)(input[56] & 0xf0) << 12);
	output[27] = (double)(value >> 16);
}

static void unpack_28_16bit_signed_5off(const uint8_t * input, double * output, void *closure) {
	// Unpack 28 values into output
	// Values are 16-bit signed
	// Skip 5 bits, read 448 bits of data.
	// Input must be at least 57 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 5 to 20
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)(input[2] & 0xf8) << 13);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 21 to 36
	value = ((uint32_t)(input[2] & 0x07) << 29) |
			((uint32_t)input[3] << 21) |
			((uint32_t)(input[4] & 0xf8) << 13);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 37 to 52
	value = ((uint32_t)(input[4] & 0x07) << 29) |
			((uint32_t)input[5] << 21) |
			((uint32_t)(input[6] & 0xf8) << 13);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 53 to 68
	value = ((uint32_t)(input[6] & 0x07) << 29) |
			((uint32_t)input[7] << 21) |
			((uint32_t)(input[8] & 0xf8) << 13);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 69 to 84
	value = ((uint32_t)(input[8] & 0x07) << 29) |
			((uint32_t)input[9] << 21) |
			((uint32_t)(input[10] & 0xf8) << 13);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 85 to 100
	value = ((uint32_t)(input[10] & 0x07) << 29) |
			((uint32_t)input[11] << 21) |
			((uint32_t)(input[12] & 0xf8) << 13);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 101 to 116
	value = ((uint32_t)(input[12] & 0x07) << 29) |
			((uint32_t)input[13] << 21) |
			((uint32_t)(input[14] & 0xf8) << 13);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 117 to 132
	value = ((uint32_t)(input[14] & 0x07) << 29) |
			((uint32_t)input[15] << 21) |
			((uint32_t)(input[16] & 0xf8) << 13);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 133 to 148
	value = ((uint32_t)(input[16] & 0x07) << 29) |
			((uint32_t)input[17] << 21) |
			((uint32_t)(input[18] & 0xf8) << 13);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 149 to 164
	value = ((uint32_t)(input[18] & 0x07) << 29) |
			((uint32_t)input[19] << 21) |
			((uint32_t)(input[20] & 0xf8) << 13);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 165 to 180
	value = ((uint32_t)(input[20] & 0x07) << 29) |
			((uint32_t)input[21] << 21) |
			((uint32_t)(input[22] & 0xf8) << 13);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 181 to 196
	value = ((uint32_t)(input[22] & 0x07) << 29) |
			((uint32_t)input[23] << 21) |
			((uint32_t)(input[24] & 0xf8) << 13);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 197 to 212
	value = ((uint32_t)(input[24] & 0x07) << 29) |
			((uint32_t)input[25] << 21) |
			((uint32_t)(input[26] & 0xf8) << 13);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 213 to 228
	value = ((uint32_t)(input[26] & 0x07) << 29) |
			((uint32_t)input[27] << 21) |
			((uint32_t)(input[28] & 0xf8) << 13);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 229 to 244
	value = ((uint32_t)(input[28] & 0x07) << 29) |
			((uint32_t)input[29] << 21) |
			((uint32_t)(input[30] & 0xf8) << 13);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 245 to 260
	value = ((uint32_t)(input[30] & 0x07) << 29) |
			((uint32_t)input[31] << 21) |
			((uint32_t)(input[32] & 0xf8) << 13);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 261 to 276
	value = ((uint32_t)(input[32] & 0x07) << 29) |
			((uint32_t)input[33] << 21) |
			((uint32_t)(input[34] & 0xf8) << 13);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 277 to 292
	value = ((uint32_t)(input[34] & 0x07) << 29) |
			((uint32_t)input[35] << 21) |
			((uint32_t)(input[36] & 0xf8) << 13);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 293 to 308
	value = ((uint32_t)(input[36] & 0x07) << 29) |
			((uint32_t)input[37] << 21) |
			((uint32_t)(input[38] & 0xf8) << 13);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 309 to 324
	value = ((uint32_t)(input[38] & 0x07) << 29) |
			((uint32_t)input[39] << 21) |
			((uint32_t)(input[40] & 0xf8) << 13);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 325 to 340
	value = ((uint32_t)(input[40] & 0x07) << 29) |
			((uint32_t)input[41] << 21) |
			((uint32_t)(input[42] & 0xf8) << 13);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 341 to 356
	value = ((uint32_t)(input[42] & 0x07) << 29) |
			((uint32_t)input[43] << 21) |
			((uint32_t)(input[44] & 0xf8) << 13);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 357 to 372
	value = ((uint32_t)(input[44] & 0x07) << 29) |
			((uint32_t)input[45] << 21) |
			((uint32_t)(input[46] & 0xf8) << 13);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 373 to 388
	value = ((uint32_t)(input[46] & 0x07) << 29) |
			((uint32_t)input[47] << 21) |
			((uint32_t)(input[48] & 0xf8) << 13);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 389 to 404
	value = ((uint32_t)(input[48] & 0x07) << 29) |
			((uint32_t)input[49] << 21) |
			((uint32_t)(input[50] & 0xf8) << 13);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 405 to 420
	value = ((uint32_t)(input[50] & 0x07) << 29) |
			((uint32_t)input[51] << 21) |
			((uint32_t)(input[52] & 0xf8) << 13);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 421 to 436
	value = ((uint32_t)(input[52] & 0x07) << 29) |
			((uint32_t)input[53] << 21) |
			((uint32_t)(input[54] & 0xf8) << 13);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 437 to 452
	value = ((uint32_t)(input[54] & 0x07) << 29) |
			((uint32_t)input[55] << 21) |
			((uint32_t)(input[56] & 0xf8) << 13);
	output[27] = (double)(value >> 16);
}

static void unpack_28_16bit_unsigned_5off(const uint8_t * input, double * output, void *closure) {
	// Unpack 28 values into output
	// Values are 16-bit unsigned
	// Skip 5 bits, read 448 bits of data.
	// Input must be at least 57 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 5 to 20
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)(input[2] & 0xf8) << 13);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 21 to 36
	value = ((uint32_t)(input[2] & 0x07) << 29) |
			((uint32_t)input[3] << 21) |
			((uint32_t)(input[4] & 0xf8) << 13);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 37 to 52
	value = ((uint32_t)(input[4] & 0x07) << 29) |
			((uint32_t)input[5] << 21) |
			((uint32_t)(input[6] & 0xf8) << 13);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 53 to 68
	value = ((uint32_t)(input[6] & 0x07) << 29) |
			((uint32_t)input[7] << 21) |
			((uint32_t)(input[8] & 0xf8) << 13);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 69 to 84
	value = ((uint32_t)(input[8] & 0x07) << 29) |
			((uint32_t)input[9] << 21) |
			((uint32_t)(input[10] & 0xf8) << 13);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 85 to 100
	value = ((uint32_t)(input[10] & 0x07) << 29) |
			((uint32_t)input[11] << 21) |
			((uint32_t)(input[12] & 0xf8) << 13);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 101 to 116
	value = ((uint32_t)(input[12] & 0x07) << 29) |
			((uint32_t)input[13] << 21) |
			((uint32_t)(input[14] & 0xf8) << 13);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 117 to 132
	value = ((uint32_t)(input[14] & 0x07) << 29) |
			((uint32_t)input[15] << 21) |
			((uint32_t)(input[16] & 0xf8) << 13);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 133 to 148
	value = ((uint32_t)(input[16] & 0x07) << 29) |
			((uint32_t)input[17] << 21) |
			((uint32_t)(input[18] & 0xf8) << 13);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 149 to 164
	value = ((uint32_t)(input[18] & 0x07) << 29) |
			((uint32_t)input[19] << 21) |
			((uint32_t)(input[20] & 0xf8) << 13);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 165 to 180
	value = ((uint32_t)(input[20] & 0x07) << 29) |
			((uint32_t)input[21] << 21) |
			((uint32_t)(input[22] & 0xf8) << 13);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 181 to 196
	value = ((uint32_t)(input[22] & 0x07) << 29) |
			((uint32_t)input[23] << 21) |
			((uint32_t)(input[24] & 0xf8) << 13);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 197 to 212
	value = ((uint32_t)(input[24] & 0x07) << 29) |
			((uint32_t)input[25] << 21) |
			((uint32_t)(input[26] & 0xf8) << 13);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 213 to 228
	value = ((uint32_t)(input[26] & 0x07) << 29) |
			((uint32_t)input[27] << 21) |
			((uint32_t)(input[28] & 0xf8) << 13);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 229 to 244
	value = ((uint32_t)(input[28] & 0x07) << 29) |
			((uint32_t)input[29] << 21) |
			((uint32_t)(input[30] & 0xf8) << 13);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 245 to 260
	value = ((uint32_t)(input[30] & 0x07) << 29) |
			((uint32_t)input[31] << 21) |
			((uint32_t)(input[32] & 0xf8) << 13);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 261 to 276
	value = ((uint32_t)(input[32] & 0x07) << 29) |
			((uint32_t)input[33] << 21) |
			((uint32_t)(input[34] & 0xf8) << 13);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 277 to 292
	value = ((uint32_t)(input[34] & 0x07) << 29) |
			((uint32_t)input[35] << 21) |
			((uint32_t)(input[36] & 0xf8) << 13);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 293 to 308
	value = ((uint32_t)(input[36] & 0x07) << 29) |
			((uint32_t)input[37] << 21) |
			((uint32_t)(input[38] & 0xf8) << 13);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 309 to 324
	value = ((uint32_t)(input[38] & 0x07) << 29) |
			((uint32_t)input[39] << 21) |
			((uint32_t)(input[40] & 0xf8) << 13);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 325 to 340
	value = ((uint32_t)(input[40] & 0x07) << 29) |
			((uint32_t)input[41] << 21) |
			((uint32_t)(input[42] & 0xf8) << 13);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 341 to 356
	value = ((uint32_t)(input[42] & 0x07) << 29) |
			((uint32_t)input[43] << 21) |
			((uint32_t)(input[44] & 0xf8) << 13);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 357 to 372
	value = ((uint32_t)(input[44] & 0x07) << 29) |
			((uint32_t)input[45] << 21) |
			((uint32_t)(input[46] & 0xf8) << 13);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 373 to 388
	value = ((uint32_t)(input[46] & 0x07) << 29) |
			((uint32_t)input[47] << 21) |
			((uint32_t)(input[48] & 0xf8) << 13);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 389 to 404
	value = ((uint32_t)(input[48] & 0x07) << 29) |
			((uint32_t)input[49] << 21) |
			((uint32_t)(input[50] & 0xf8) << 13);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 405 to 420
	value = ((uint32_t)(input[50] & 0x07) << 29) |
			((uint32_t)input[51] << 21) |
			((uint32_t)(input[52] & 0xf8) << 13);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 421 to 436
	value = ((uint32_t)(input[52] & 0x07) << 29) |
			((uint32_t)input[53] << 21) |
			((uint32_t)(input[54] & 0xf8) << 13);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 437 to 452
	value = ((uint32_t)(input[54] & 0x07) << 29) |
			((uint32_t)input[55] << 21) |
			((uint32_t)(input[56] & 0xf8) << 13);
	output[27] = (double)(value >> 16);
}

static void unpack_28_16bit_signed_6off(const uint8_t * input, double * output, void *closure) {
	// Unpack 28 values into output
	// Values are 16-bit signed
	// Skip 6 bits, read 448 bits of data.
	// Input must be at least 57 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 6 to 21
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)(input[2] & 0xfc) << 14);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 22 to 37
	value = ((uint32_t)(input[2] & 0x03) << 30) |
			((uint32_t)input[3] << 22) |
			((uint32_t)(input[4] & 0xfc) << 14);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 38 to 53
	value = ((uint32_t)(input[4] & 0x03) << 30) |
			((uint32_t)input[5] << 22) |
			((uint32_t)(input[6] & 0xfc) << 14);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 54 to 69
	value = ((uint32_t)(input[6] & 0x03) << 30) |
			((uint32_t)input[7] << 22) |
			((uint32_t)(input[8] & 0xfc) << 14);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 70 to 85
	value = ((uint32_t)(input[8] & 0x03) << 30) |
			((uint32_t)input[9] << 22) |
			((uint32_t)(input[10] & 0xfc) << 14);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 86 to 101
	value = ((uint32_t)(input[10] & 0x03) << 30) |
			((uint32_t)input[11] << 22) |
			((uint32_t)(input[12] & 0xfc) << 14);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 102 to 117
	value = ((uint32_t)(input[12] & 0x03) << 30) |
			((uint32_t)input[13] << 22) |
			((uint32_t)(input[14] & 0xfc) << 14);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 118 to 133
	value = ((uint32_t)(input[14] & 0x03) << 30) |
			((uint32_t)input[15] << 22) |
			((uint32_t)(input[16] & 0xfc) << 14);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 134 to 149
	value = ((uint32_t)(input[16] & 0x03) << 30) |
			((uint32_t)input[17] << 22) |
			((uint32_t)(input[18] & 0xfc) << 14);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 150 to 165
	value = ((uint32_t)(input[18] & 0x03) << 30) |
			((uint32_t)input[19] << 22) |
			((uint32_t)(input[20] & 0xfc) << 14);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 166 to 181
	value = ((uint32_t)(input[20] & 0x03) << 30) |
			((uint32_t)input[21] << 22) |
			((uint32_t)(input[22] & 0xfc) << 14);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 182 to 197
	value = ((uint32_t)(input[22] & 0x03) << 30) |
			((uint32_t)input[23] << 22) |
			((uint32_t)(input[24] & 0xfc) << 14);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 198 to 213
	value = ((uint32_t)(input[24] & 0x03) << 30) |
			((uint32_t)input[25] << 22) |
			((uint32_t)(input[26] & 0xfc) << 14);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 214 to 229
	value = ((uint32_t)(input[26] & 0x03) << 30) |
			((uint32_t)input[27] << 22) |
			((uint32_t)(input[28] & 0xfc) << 14);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 230 to 245
	value = ((uint32_t)(input[28] & 0x03) << 30) |
			((uint32_t)input[29] << 22) |
			((uint32_t)(input[30] & 0xfc) << 14);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 246 to 261
	value = ((uint32_t)(input[30] & 0x03) << 30) |
			((uint32_t)input[31] << 22) |
			((uint32_t)(input[32] & 0xfc) << 14);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 262 to 277
	value = ((uint32_t)(input[32] & 0x03) << 30) |
			((uint32_t)input[33] << 22) |
			((uint32_t)(input[34] & 0xfc) << 14);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 278 to 293
	value = ((uint32_t)(input[34] & 0x03) << 30) |
			((uint32_t)input[35] << 22) |
			((uint32_t)(input[36] & 0xfc) << 14);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 294 to 309
	value = ((uint32_t)(input[36] & 0x03) << 30) |
			((uint32_t)input[37] << 22) |
			((uint32_t)(input[38] & 0xfc) << 14);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 310 to 325
	value = ((uint32_t)(input[38] & 0x03) << 30) |
			((uint32_t)input[39] << 22) |
			((uint32_t)(input[40] & 0xfc) << 14);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 326 to 341
	value = ((uint32_t)(input[40] & 0x03) << 30) |
			((uint32_t)input[41] << 22) |
			((uint32_t)(input[42] & 0xfc) << 14);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 342 to 357
	value = ((uint32_t)(input[42] & 0x03) << 30) |
			((uint32_t)input[43] << 22) |
			((uint32_t)(input[44] & 0xfc) << 14);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 358 to 373
	value = ((uint32_t)(input[44] & 0x03) << 30) |
			((uint32_t)input[45] << 22) |
			((uint32_t)(input[46] & 0xfc) << 14);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 374 to 389
	value = ((uint32_t)(input[46] & 0x03) << 30) |
			((uint32_t)input[47] << 22) |
			((uint32_t)(input[48] & 0xfc) << 14);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 390 to 405
	value = ((uint32_t)(input[48] & 0x03) << 30) |
			((uint32_t)input[49] << 22) |
			((uint32_t)(input[50] & 0xfc) << 14);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 406 to 421
	value = ((uint32_t)(input[50] & 0x03) << 30) |
			((uint32_t)input[51] << 22) |
			((uint32_t)(input[52] & 0xfc) << 14);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 422 to 437
	value = ((uint32_t)(input[52] & 0x03) << 30) |
			((uint32_t)input[53] << 22) |
			((uint32_t)(input[54] & 0xfc) << 14);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 438 to 453
	value = ((uint32_t)(input[54] & 0x03) << 30) |
			((uint32_t)input[55] << 22) |
			((uint32_t)(input[56] & 0xfc) << 14);
	output[27] = (double)(value >> 16);
}

static void unpack_28_16bit_unsigned_6off(const uint8_t * input, double * output, void *closure) {
	// Unpack 28 values into output
	// Values are 16-bit unsigned
	// Skip 6 bits, read 448 bits of data.
	// Input must be at least 57 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 6 to 21
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)(input[2] & 0xfc) << 14);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 22 to 37
	value = ((uint32_t)(input[2] & 0x03) << 30) |
			((uint32_t)input[3] << 22) |
			((uint32_t)(input[4] & 0xfc) << 14);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 38 to 53
	value = ((uint32_t)(input[4] & 0x03) << 30) |
			((uint32_t)input[5] << 22) |
			((uint32_t)(input[6] & 0xfc) << 14);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 54 to 69
	value = ((uint32_t)(input[6] & 0x03) << 30) |
			((uint32_t)input[7] << 22) |
			((uint32_t)(input[8] & 0xfc) << 14);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 70 to 85
	value = ((uint32_t)(input[8] & 0x03) << 30) |
			((uint32_t)input[9] << 22) |
			((uint32_t)(input[10] & 0xfc) << 14);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 86 to 101
	value = ((uint32_t)(input[10] & 0x03) << 30) |
			((uint32_t)input[11] << 22) |
			((uint32_t)(input[12] & 0xfc) << 14);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 102 to 117
	value = ((uint32_t)(input[12] & 0x03) << 30) |
			((uint32_t)input[13] << 22) |
			((uint32_t)(input[14] & 0xfc) << 14);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 118 to 133
	value = ((uint32_t)(input[14] & 0x03) << 30) |
			((uint32_t)input[15] << 22) |
			((uint32_t)(input[16] & 0xfc) << 14);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 134 to 149
	value = ((uint32_t)(input[16] & 0x03) << 30) |
			((uint32_t)input[17] << 22) |
			((uint32_t)(input[18] & 0xfc) << 14);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 150 to 165
	value = ((uint32_t)(input[18] & 0x03) << 30) |
			((uint32_t)input[19] << 22) |
			((uint32_t)(input[20] & 0xfc) << 14);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 166 to 181
	value = ((uint32_t)(input[20] & 0x03) << 30) |
			((uint32_t)input[21] << 22) |
			((uint32_t)(input[22] & 0xfc) << 14);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 182 to 197
	value = ((uint32_t)(input[22] & 0x03) << 30) |
			((uint32_t)input[23] << 22) |
			((uint32_t)(input[24] & 0xfc) << 14);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 198 to 213
	value = ((uint32_t)(input[24] & 0x03) << 30) |
			((uint32_t)input[25] << 22) |
			((uint32_t)(input[26] & 0xfc) << 14);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 214 to 229
	value = ((uint32_t)(input[26] & 0x03) << 30) |
			((uint32_t)input[27] << 22) |
			((uint32_t)(input[28] & 0xfc) << 14);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 230 to 245
	value = ((uint32_t)(input[28] & 0x03) << 30) |
			((uint32_t)input[29] << 22) |
			((uint32_t)(input[30] & 0xfc) << 14);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 246 to 261
	value = ((uint32_t)(input[30] & 0x03) << 30) |
			((uint32_t)input[31] << 22) |
			((uint32_t)(input[32] & 0xfc) << 14);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 262 to 277
	value = ((uint32_t)(input[32] & 0x03) << 30) |
			((uint32_t)input[33] << 22) |
			((uint32_t)(input[34] & 0xfc) << 14);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 278 to 293
	value = ((uint32_t)(input[34] & 0x03) << 30) |
			((uint32_t)input[35] << 22) |
			((uint32_t)(input[36] & 0xfc) << 14);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 294 to 309
	value = ((uint32_t)(input[36] & 0x03) << 30) |
			((uint32_t)input[37] << 22) |
			((uint32_t)(input[38] & 0xfc) << 14);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 310 to 325
	value = ((uint32_t)(input[38] & 0x03) << 30) |
			((uint32_t)input[39] << 22) |
			((uint32_t)(input[40] & 0xfc) << 14);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 326 to 341
	value = ((uint32_t)(input[40] & 0x03) << 30) |
			((uint32_t)input[41] << 22) |
			((uint32_t)(input[42] & 0xfc) << 14);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 342 to 357
	value = ((uint32_t)(input[42] & 0x03) << 30) |
			((uint32_t)input[43] << 22) |
			((uint32_t)(input[44] & 0xfc) << 14);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 358 to 373
	value = ((uint32_t)(input[44] & 0x03) << 30) |
			((uint32_t)input[45] << 22) |
			((uint32_t)(input[46] & 0xfc) << 14);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 374 to 389
	value = ((uint32_t)(input[46] & 0x03) << 30) |
			((uint32_t)input[47] << 22) |
			((uint32_t)(input[48] & 0xfc) << 14);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 390 to 405
	value = ((uint32_t)(input[48] & 0x03) << 30) |
			((uint32_t)input[49] << 22) |
			((uint32_t)(input[50] & 0xfc) << 14);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 406 to 421
	value = ((uint32_t)(input[50] & 0x03) << 30) |
			((uint32_t)input[51] << 22) |
			((uint32_t)(input[52] & 0xfc) << 14);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 422 to 437
	value = ((uint32_t)(input[52] & 0x03) << 30) |
			((uint32_t)input[53] << 22) |
			((uint32_t)(input[54] & 0xfc) << 14);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 438 to 453
	value = ((uint32_t)(input[54] & 0x03) << 30) |
			((uint32_t)input[55] << 22) |
			((uint32_t)(input[56] & 0xfc) << 14);
	output[27] = (double)(value >> 16);
}

static void unpack_28_16bit_signed_7off(const uint8_t * input, double * output, void *closure) {
	// Unpack 28 values into output
	// Values are 16-bit signed
	// Skip 7 bits, read 448 bits of data.
	// Input must be at least 57 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 7 to 22
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)(input[2] & 0xfe) << 15);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 23 to 38
	value = ((uint32_t)(input[2] & 0x01) << 31) |
			((uint32_t)input[3] << 23) |
			((uint32_t)(input[4] & 0xfe) << 15);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 39 to 54
	value = ((uint32_t)(input[4] & 0x01) << 31) |
			((uint32_t)input[5] << 23) |
			((uint32_t)(input[6] & 0xfe) << 15);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 55 to 70
	value = ((uint32_t)(input[6] & 0x01) << 31) |
			((uint32_t)input[7] << 23) |
			((uint32_t)(input[8] & 0xfe) << 15);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 71 to 86
	value = ((uint32_t)(input[8] & 0x01) << 31) |
			((uint32_t)input[9] << 23) |
			((uint32_t)(input[10] & 0xfe) << 15);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 87 to 102
	value = ((uint32_t)(input[10] & 0x01) << 31) |
			((uint32_t)input[11] << 23) |
			((uint32_t)(input[12] & 0xfe) << 15);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 103 to 118
	value = ((uint32_t)(input[12] & 0x01) << 31) |
			((uint32_t)input[13] << 23) |
			((uint32_t)(input[14] & 0xfe) << 15);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 119 to 134
	value = ((uint32_t)(input[14] & 0x01) << 31) |
			((uint32_t)input[15] << 23) |
			((uint32_t)(input[16] & 0xfe) << 15);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 135 to 150
	value = ((uint32_t)(input[16] & 0x01) << 31) |
			((uint32_t)input[17] << 23) |
			((uint32_t)(input[18] & 0xfe) << 15);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 151 to 166
	value = ((uint32_t)(input[18] & 0x01) << 31) |
			((uint32_t)input[19] << 23) |
			((uint32_t)(input[20] & 0xfe) << 15);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 167 to 182
	value = ((uint32_t)(input[20] & 0x01) << 31) |
			((uint32_t)input[21] << 23) |
			((uint32_t)(input[22] & 0xfe) << 15);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 183 to 198
	value = ((uint32_t)(input[22] & 0x01) << 31) |
			((uint32_t)input[23] << 23) |
			((uint32_t)(input[24] & 0xfe) << 15);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 199 to 214
	value = ((uint32_t)(input[24] & 0x01) << 31) |
			((uint32_t)input[25] << 23) |
			((uint32_t)(input[26] & 0xfe) << 15);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 215 to 230
	value = ((uint32_t)(input[26] & 0x01) << 31) |
			((uint32_t)input[27] << 23) |
			((uint32_t)(input[28] & 0xfe) << 15);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 231 to 246
	value = ((uint32_t)(input[28] & 0x01) << 31) |
			((uint32_t)input[29] << 23) |
			((uint32_t)(input[30] & 0xfe) << 15);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 247 to 262
	value = ((uint32_t)(input[30] & 0x01) << 31) |
			((uint32_t)input[31] << 23) |
			((uint32_t)(input[32] & 0xfe) << 15);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 263 to 278
	value = ((uint32_t)(input[32] & 0x01) << 31) |
			((uint32_t)input[33] << 23) |
			((uint32_t)(input[34] & 0xfe) << 15);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 279 to 294
	value = ((uint32_t)(input[34] & 0x01) << 31) |
			((uint32_t)input[35] << 23) |
			((uint32_t)(input[36] & 0xfe) << 15);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 295 to 310
	value = ((uint32_t)(input[36] & 0x01) << 31) |
			((uint32_t)input[37] << 23) |
			((uint32_t)(input[38] & 0xfe) << 15);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 311 to 326
	value = ((uint32_t)(input[38] & 0x01) << 31) |
			((uint32_t)input[39] << 23) |
			((uint32_t)(input[40] & 0xfe) << 15);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 327 to 342
	value = ((uint32_t)(input[40] & 0x01) << 31) |
			((uint32_t)input[41] << 23) |
			((uint32_t)(input[42] & 0xfe) << 15);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 343 to 358
	value = ((uint32_t)(input[42] & 0x01) << 31) |
			((uint32_t)input[43] << 23) |
			((uint32_t)(input[44] & 0xfe) << 15);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 359 to 374
	value = ((uint32_t)(input[44] & 0x01) << 31) |
			((uint32_t)input[45] << 23) |
			((uint32_t)(input[46] & 0xfe) << 15);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 375 to 390
	value = ((uint32_t)(input[46] & 0x01) << 31) |
			((uint32_t)input[47] << 23) |
			((uint32_t)(input[48] & 0xfe) << 15);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 391 to 406
	value = ((uint32_t)(input[48] & 0x01) << 31) |
			((uint32_t)input[49] << 23) |
			((uint32_t)(input[50] & 0xfe) << 15);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 407 to 422
	value = ((uint32_t)(input[50] & 0x01) << 31) |
			((uint32_t)input[51] << 23) |
			((uint32_t)(input[52] & 0xfe) << 15);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 423 to 438
	value = ((uint32_t)(input[52] & 0x01) << 31) |
			((uint32_t)input[53] << 23) |
			((uint32_t)(input[54] & 0xfe) << 15);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 439 to 454
	value = ((uint32_t)(input[54] & 0x01) << 31) |
			((uint32_t)input[55] << 23) |
			((uint32_t)(input[56] & 0xfe) << 15);
	output[27] = (double)(value >> 16);
}

static void unpack_28_16bit_unsigned_7off(const uint8_t * input, double * output, void *closure) {
	// Unpack 28 values into output
	// Values are 16-bit unsigned
	// Skip 7 bits, read 448 bits of data.
	// Input must be at least 57 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 7 to 22
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)(input[2] & 0xfe) << 15);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 23 to 38
	value = ((uint32_t)(input[2] & 0x01) << 31) |
			((uint32_t)input[3] << 23) |
			((uint32_t)(input[4] & 0xfe) << 15);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 39 to 54
	value = ((uint32_t)(input[4] & 0x01) << 31) |
			((uint32_t)input[5] << 23) |
			((uint32_t)(input[6] & 0xfe) << 15);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 55 to 70
	value = ((uint32_t)(input[6] & 0x01) << 31) |
			((uint32_t)input[7] << 23) |
			((uint32_t)(input[8] & 0xfe) << 15);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 71 to 86
	value = ((uint32_t)(input[8] & 0x01) << 31) |
			((uint32_t)input[9] << 23) |
			((uint32_t)(input[10] & 0xfe) << 15);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 87 to 102
	value = ((uint32_t)(input[10] & 0x01) << 31) |
			((uint32_t)input[11] << 23) |
			((uint32_t)(input[12] & 0xfe) << 15);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 103 to 118
	value = ((uint32_t)(input[12] & 0x01) << 31) |
			((uint32_t)input[13] << 23) |
			((uint32_t)(input[14] & 0xfe) << 15);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 119 to 134
	value = ((uint32_t)(input[14] & 0x01) << 31) |
			((uint32_t)input[15] << 23) |
			((uint32_t)(input[16] & 0xfe) << 15);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 135 to 150
	value = ((uint32_t)(input[16] & 0x01) << 31) |
			((uint32_t)input[17] << 23) |
			((uint32_t)(input[18] & 0xfe) << 15);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 151 to 166
	value = ((uint32_t)(input[18] & 0x01) << 31) |
			((uint32_t)input[19] << 23) |
			((uint32_t)(input[20] & 0xfe) << 15);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 167 to 182
	value = ((uint32_t)(input[20] & 0x01) << 31) |
			((uint32_t)input[21] << 23) |
			((uint32_t)(input[22] & 0xfe) << 15);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 183 to 198
	value = ((uint32_t)(input[22] & 0x01) << 31) |
			((uint32_t)input[23] << 23) |
			((uint32_t)(input[24] & 0xfe) << 15);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 199 to 214
	value = ((uint32_t)(input[24] & 0x01) << 31) |
			((uint32_t)input[25] << 23) |
			((uint32_t)(input[26] & 0xfe) << 15);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 215 to 230
	value = ((uint32_t)(input[26] & 0x01) << 31) |
			((uint32_t)input[27] << 23) |
			((uint32_t)(input[28] & 0xfe) << 15);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 231 to 246
	value = ((uint32_t)(input[28] & 0x01) << 31) |
			((uint32_t)input[29] << 23) |
			((uint32_t)(input[30] & 0xfe) << 15);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 247 to 262
	value = ((uint32_t)(input[30] & 0x01) << 31) |
			((uint32_t)input[31] << 23) |
			((uint32_t)(input[32] & 0xfe) << 15);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 263 to 278
	value = ((uint32_t)(input[32] & 0x01) << 31) |
			((uint32_t)input[33] << 23) |
			((uint32_t)(input[34] & 0xfe) << 15);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 279 to 294
	value = ((uint32_t)(input[34] & 0x01) << 31) |
			((uint32_t)input[35] << 23) |
			((uint32_t)(input[36] & 0xfe) << 15);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 295 to 310
	value = ((uint32_t)(input[36] & 0x01) << 31) |
			((uint32_t)input[37] << 23) |
			((uint32_t)(input[38] & 0xfe) << 15);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 311 to 326
	value = ((uint32_t)(input[38] & 0x01) << 31) |
			((uint32_t)input[39] << 23) |
			((uint32_t)(input[40] & 0xfe) << 15);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 327 to 342
	value = ((uint32_t)(input[40] & 0x01) << 31) |
			((uint32_t)input[41] << 23) |
			((uint32_t)(input[42] & 0xfe) << 15);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 343 to 358
	value = ((uint32_t)(input[42] & 0x01) << 31) |
			((uint32_t)input[43] << 23) |
			((uint32_t)(input[44] & 0xfe) << 15);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 359 to 374
	value = ((uint32_t)(input[44] & 0x01) << 31) |
			((uint32_t)input[45] << 23) |
			((uint32_t)(input[46] & 0xfe) << 15);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 375 to 390
	value = ((uint32_t)(input[46] & 0x01) << 31) |
			((uint32_t)input[47] << 23) |
			((uint32_t)(input[48] & 0xfe) << 15);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 391 to 406
	value = ((uint32_t)(input[48] & 0x01) << 31) |
			((uint32_t)input[49] << 23) |
			((uint32_t)(input[50] & 0xfe) << 15);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 407 to 422
	value = ((uint32_t)(input[50] & 0x01) << 31) |
			((uint32_t)input[51] << 23) |
			((uint32_t)(input[52] & 0xfe) << 15);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 423 to 438
	value = ((uint32_t)(input[52] & 0x01) << 31) |
			((uint32_t)input[53] << 23) |
			((uint32_t)(input[54] & 0xfe) << 15);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 439 to 454
	value = ((uint32_t)(input[54] & 0x01) << 31) |
			((uint32_t)input[55] << 23) |
			((uint32_t)(input[56] & 0xfe) << 15);
	output[27] = (double)(value >> 16);
}

static void unpack_29_16bit_signed_0off(const uint8_t * input, double * output, void *closure) {
	// Unpack 29 values into output
	// Values are 16-bit signed
	// Skip 0 bits, read 464 bits of data.
	// Input must be at least 58 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 0 to 15
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)input[1] << 16);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 16 to 31
	value = ((uint32_t)input[2] << 24) |
			((uint32_t)input[3] << 16);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 32 to 47
	value = ((uint32_t)input[4] << 24) |
			((uint32_t)input[5] << 16);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 48 to 63
	value = ((uint32_t)input[6] << 24) |
			((uint32_t)input[7] << 16);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 64 to 79
	value = ((uint32_t)input[8] << 24) |
			((uint32_t)input[9] << 16);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 80 to 95
	value = ((uint32_t)input[10] << 24) |
			((uint32_t)input[11] << 16);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 96 to 111
	value = ((uint32_t)input[12] << 24) |
			((uint32_t)input[13] << 16);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 112 to 127
	value = ((uint32_t)input[14] << 24) |
			((uint32_t)input[15] << 16);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 128 to 143
	value = ((uint32_t)input[16] << 24) |
			((uint32_t)input[17] << 16);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 144 to 159
	value = ((uint32_t)input[18] << 24) |
			((uint32_t)input[19] << 16);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 160 to 175
	value = ((uint32_t)input[20] << 24) |
			((uint32_t)input[21] << 16);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 176 to 191
	value = ((uint32_t)input[22] << 24) |
			((uint32_t)input[23] << 16);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 192 to 207
	value = ((uint32_t)input[24] << 24) |
			((uint32_t)input[25] << 16);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 208 to 223
	value = ((uint32_t)input[26] << 24) |
			((uint32_t)input[27] << 16);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 224 to 239
	value = ((uint32_t)input[28] << 24) |
			((uint32_t)input[29] << 16);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 240 to 255
	value = ((uint32_t)input[30] << 24) |
			((uint32_t)input[31] << 16);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 256 to 271
	value = ((uint32_t)input[32] << 24) |
			((uint32_t)input[33] << 16);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 272 to 287
	value = ((uint32_t)input[34] << 24) |
			((uint32_t)input[35] << 16);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 288 to 303
	value = ((uint32_t)input[36] << 24) |
			((uint32_t)input[37] << 16);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 304 to 319
	value = ((uint32_t)input[38] << 24) |
			((uint32_t)input[39] << 16);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 320 to 335
	value = ((uint32_t)input[40] << 24) |
			((uint32_t)input[41] << 16);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 336 to 351
	value = ((uint32_t)input[42] << 24) |
			((uint32_t)input[43] << 16);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 352 to 367
	value = ((uint32_t)input[44] << 24) |
			((uint32_t)input[45] << 16);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 368 to 383
	value = ((uint32_t)input[46] << 24) |
			((uint32_t)input[47] << 16);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 384 to 399
	value = ((uint32_t)input[48] << 24) |
			((uint32_t)input[49] << 16);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 400 to 415
	value = ((uint32_t)input[50] << 24) |
			((uint32_t)input[51] << 16);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 416 to 431
	value = ((uint32_t)input[52] << 24) |
			((uint32_t)input[53] << 16);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 432 to 447
	value = ((uint32_t)input[54] << 24) |
			((uint32_t)input[55] << 16);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 448 to 463
	value = ((uint32_t)input[56] << 24) |
			((uint32_t)input[57] << 16);
	output[28] = (double)(value >> 16);
}

static void unpack_29_16bit_unsigned_0off(const uint8_t * input, double * output, void *closure) {
	// Unpack 29 values into output
	// Values are 16-bit unsigned
	// Skip 0 bits, read 464 bits of data.
	// Input must be at least 58 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 0 to 15
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)input[1] << 16);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 16 to 31
	value = ((uint32_t)input[2] << 24) |
			((uint32_t)input[3] << 16);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 32 to 47
	value = ((uint32_t)input[4] << 24) |
			((uint32_t)input[5] << 16);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 48 to 63
	value = ((uint32_t)input[6] << 24) |
			((uint32_t)input[7] << 16);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 64 to 79
	value = ((uint32_t)input[8] << 24) |
			((uint32_t)input[9] << 16);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 80 to 95
	value = ((uint32_t)input[10] << 24) |
			((uint32_t)input[11] << 16);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 96 to 111
	value = ((uint32_t)input[12] << 24) |
			((uint32_t)input[13] << 16);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 112 to 127
	value = ((uint32_t)input[14] << 24) |
			((uint32_t)input[15] << 16);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 128 to 143
	value = ((uint32_t)input[16] << 24) |
			((uint32_t)input[17] << 16);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 144 to 159
	value = ((uint32_t)input[18] << 24) |
			((uint32_t)input[19] << 16);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 160 to 175
	value = ((uint32_t)input[20] << 24) |
			((uint32_t)input[21] << 16);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 176 to 191
	value = ((uint32_t)input[22] << 24) |
			((uint32_t)input[23] << 16);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 192 to 207
	value = ((uint32_t)input[24] << 24) |
			((uint32_t)input[25] << 16);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 208 to 223
	value = ((uint32_t)input[26] << 24) |
			((uint32_t)input[27] << 16);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 224 to 239
	value = ((uint32_t)input[28] << 24) |
			((uint32_t)input[29] << 16);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 240 to 255
	value = ((uint32_t)input[30] << 24) |
			((uint32_t)input[31] << 16);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 256 to 271
	value = ((uint32_t)input[32] << 24) |
			((uint32_t)input[33] << 16);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 272 to 287
	value = ((uint32_t)input[34] << 24) |
			((uint32_t)input[35] << 16);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 288 to 303
	value = ((uint32_t)input[36] << 24) |
			((uint32_t)input[37] << 16);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 304 to 319
	value = ((uint32_t)input[38] << 24) |
			((uint32_t)input[39] << 16);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 320 to 335
	value = ((uint32_t)input[40] << 24) |
			((uint32_t)input[41] << 16);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 336 to 351
	value = ((uint32_t)input[42] << 24) |
			((uint32_t)input[43] << 16);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 352 to 367
	value = ((uint32_t)input[44] << 24) |
			((uint32_t)input[45] << 16);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 368 to 383
	value = ((uint32_t)input[46] << 24) |
			((uint32_t)input[47] << 16);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 384 to 399
	value = ((uint32_t)input[48] << 24) |
			((uint32_t)input[49] << 16);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 400 to 415
	value = ((uint32_t)input[50] << 24) |
			((uint32_t)input[51] << 16);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 416 to 431
	value = ((uint32_t)input[52] << 24) |
			((uint32_t)input[53] << 16);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 432 to 447
	value = ((uint32_t)input[54] << 24) |
			((uint32_t)input[55] << 16);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 448 to 463
	value = ((uint32_t)input[56] << 24) |
			((uint32_t)input[57] << 16);
	output[28] = (double)(value >> 16);
}

static void unpack_29_16bit_signed_1off(const uint8_t * input, double * output, void *closure) {
	// Unpack 29 values into output
	// Values are 16-bit signed
	// Skip 1 bits, read 464 bits of data.
	// Input must be at least 59 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 1 to 16
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)input[1] << 17) |
			((uint32_t)(input[2] & 0x80) << 9);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 17 to 32
	value = ((uint32_t)(input[2] & 0x7f) << 25) |
			((uint32_t)input[3] << 17) |
			((uint32_t)(input[4] & 0x80) << 9);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 33 to 48
	value = ((uint32_t)(input[4] & 0x7f) << 25) |
			((uint32_t)input[5] << 17) |
			((uint32_t)(input[6] & 0x80) << 9);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 49 to 64
	value = ((uint32_t)(input[6] & 0x7f) << 25) |
			((uint32_t)input[7] << 17) |
			((uint32_t)(input[8] & 0x80) << 9);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 65 to 80
	value = ((uint32_t)(input[8] & 0x7f) << 25) |
			((uint32_t)input[9] << 17) |
			((uint32_t)(input[10] & 0x80) << 9);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 81 to 96
	value = ((uint32_t)(input[10] & 0x7f) << 25) |
			((uint32_t)input[11] << 17) |
			((uint32_t)(input[12] & 0x80) << 9);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 97 to 112
	value = ((uint32_t)(input[12] & 0x7f) << 25) |
			((uint32_t)input[13] << 17) |
			((uint32_t)(input[14] & 0x80) << 9);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 113 to 128
	value = ((uint32_t)(input[14] & 0x7f) << 25) |
			((uint32_t)input[15] << 17) |
			((uint32_t)(input[16] & 0x80) << 9);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 129 to 144
	value = ((uint32_t)(input[16] & 0x7f) << 25) |
			((uint32_t)input[17] << 17) |
			((uint32_t)(input[18] & 0x80) << 9);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 145 to 160
	value = ((uint32_t)(input[18] & 0x7f) << 25) |
			((uint32_t)input[19] << 17) |
			((uint32_t)(input[20] & 0x80) << 9);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 161 to 176
	value = ((uint32_t)(input[20] & 0x7f) << 25) |
			((uint32_t)input[21] << 17) |
			((uint32_t)(input[22] & 0x80) << 9);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 177 to 192
	value = ((uint32_t)(input[22] & 0x7f) << 25) |
			((uint32_t)input[23] << 17) |
			((uint32_t)(input[24] & 0x80) << 9);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 193 to 208
	value = ((uint32_t)(input[24] & 0x7f) << 25) |
			((uint32_t)input[25] << 17) |
			((uint32_t)(input[26] & 0x80) << 9);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 209 to 224
	value = ((uint32_t)(input[26] & 0x7f) << 25) |
			((uint32_t)input[27] << 17) |
			((uint32_t)(input[28] & 0x80) << 9);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 225 to 240
	value = ((uint32_t)(input[28] & 0x7f) << 25) |
			((uint32_t)input[29] << 17) |
			((uint32_t)(input[30] & 0x80) << 9);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 241 to 256
	value = ((uint32_t)(input[30] & 0x7f) << 25) |
			((uint32_t)input[31] << 17) |
			((uint32_t)(input[32] & 0x80) << 9);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 257 to 272
	value = ((uint32_t)(input[32] & 0x7f) << 25) |
			((uint32_t)input[33] << 17) |
			((uint32_t)(input[34] & 0x80) << 9);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 273 to 288
	value = ((uint32_t)(input[34] & 0x7f) << 25) |
			((uint32_t)input[35] << 17) |
			((uint32_t)(input[36] & 0x80) << 9);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 289 to 304
	value = ((uint32_t)(input[36] & 0x7f) << 25) |
			((uint32_t)input[37] << 17) |
			((uint32_t)(input[38] & 0x80) << 9);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 305 to 320
	value = ((uint32_t)(input[38] & 0x7f) << 25) |
			((uint32_t)input[39] << 17) |
			((uint32_t)(input[40] & 0x80) << 9);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 321 to 336
	value = ((uint32_t)(input[40] & 0x7f) << 25) |
			((uint32_t)input[41] << 17) |
			((uint32_t)(input[42] & 0x80) << 9);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 337 to 352
	value = ((uint32_t)(input[42] & 0x7f) << 25) |
			((uint32_t)input[43] << 17) |
			((uint32_t)(input[44] & 0x80) << 9);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 353 to 368
	value = ((uint32_t)(input[44] & 0x7f) << 25) |
			((uint32_t)input[45] << 17) |
			((uint32_t)(input[46] & 0x80) << 9);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 369 to 384
	value = ((uint32_t)(input[46] & 0x7f) << 25) |
			((uint32_t)input[47] << 17) |
			((uint32_t)(input[48] & 0x80) << 9);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 385 to 400
	value = ((uint32_t)(input[48] & 0x7f) << 25) |
			((uint32_t)input[49] << 17) |
			((uint32_t)(input[50] & 0x80) << 9);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 401 to 416
	value = ((uint32_t)(input[50] & 0x7f) << 25) |
			((uint32_t)input[51] << 17) |
			((uint32_t)(input[52] & 0x80) << 9);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 417 to 432
	value = ((uint32_t)(input[52] & 0x7f) << 25) |
			((uint32_t)input[53] << 17) |
			((uint32_t)(input[54] & 0x80) << 9);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 433 to 448
	value = ((uint32_t)(input[54] & 0x7f) << 25) |
			((uint32_t)input[55] << 17) |
			((uint32_t)(input[56] & 0x80) << 9);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 449 to 464
	value = ((uint32_t)(input[56] & 0x7f) << 25) |
			((uint32_t)input[57] << 17) |
			((uint32_t)(input[58] & 0x80) << 9);
	output[28] = (double)(value >> 16);
}

static void unpack_29_16bit_unsigned_1off(const uint8_t * input, double * output, void *closure) {
	// Unpack 29 values into output
	// Values are 16-bit unsigned
	// Skip 1 bits, read 464 bits of data.
	// Input must be at least 59 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 1 to 16
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)input[1] << 17) |
			((uint32_t)(input[2] & 0x80) << 9);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 17 to 32
	value = ((uint32_t)(input[2] & 0x7f) << 25) |
			((uint32_t)input[3] << 17) |
			((uint32_t)(input[4] & 0x80) << 9);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 33 to 48
	value = ((uint32_t)(input[4] & 0x7f) << 25) |
			((uint32_t)input[5] << 17) |
			((uint32_t)(input[6] & 0x80) << 9);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 49 to 64
	value = ((uint32_t)(input[6] & 0x7f) << 25) |
			((uint32_t)input[7] << 17) |
			((uint32_t)(input[8] & 0x80) << 9);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 65 to 80
	value = ((uint32_t)(input[8] & 0x7f) << 25) |
			((uint32_t)input[9] << 17) |
			((uint32_t)(input[10] & 0x80) << 9);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 81 to 96
	value = ((uint32_t)(input[10] & 0x7f) << 25) |
			((uint32_t)input[11] << 17) |
			((uint32_t)(input[12] & 0x80) << 9);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 97 to 112
	value = ((uint32_t)(input[12] & 0x7f) << 25) |
			((uint32_t)input[13] << 17) |
			((uint32_t)(input[14] & 0x80) << 9);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 113 to 128
	value = ((uint32_t)(input[14] & 0x7f) << 25) |
			((uint32_t)input[15] << 17) |
			((uint32_t)(input[16] & 0x80) << 9);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 129 to 144
	value = ((uint32_t)(input[16] & 0x7f) << 25) |
			((uint32_t)input[17] << 17) |
			((uint32_t)(input[18] & 0x80) << 9);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 145 to 160
	value = ((uint32_t)(input[18] & 0x7f) << 25) |
			((uint32_t)input[19] << 17) |
			((uint32_t)(input[20] & 0x80) << 9);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 161 to 176
	value = ((uint32_t)(input[20] & 0x7f) << 25) |
			((uint32_t)input[21] << 17) |
			((uint32_t)(input[22] & 0x80) << 9);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 177 to 192
	value = ((uint32_t)(input[22] & 0x7f) << 25) |
			((uint32_t)input[23] << 17) |
			((uint32_t)(input[24] & 0x80) << 9);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 193 to 208
	value = ((uint32_t)(input[24] & 0x7f) << 25) |
			((uint32_t)input[25] << 17) |
			((uint32_t)(input[26] & 0x80) << 9);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 209 to 224
	value = ((uint32_t)(input[26] & 0x7f) << 25) |
			((uint32_t)input[27] << 17) |
			((uint32_t)(input[28] & 0x80) << 9);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 225 to 240
	value = ((uint32_t)(input[28] & 0x7f) << 25) |
			((uint32_t)input[29] << 17) |
			((uint32_t)(input[30] & 0x80) << 9);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 241 to 256
	value = ((uint32_t)(input[30] & 0x7f) << 25) |
			((uint32_t)input[31] << 17) |
			((uint32_t)(input[32] & 0x80) << 9);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 257 to 272
	value = ((uint32_t)(input[32] & 0x7f) << 25) |
			((uint32_t)input[33] << 17) |
			((uint32_t)(input[34] & 0x80) << 9);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 273 to 288
	value = ((uint32_t)(input[34] & 0x7f) << 25) |
			((uint32_t)input[35] << 17) |
			((uint32_t)(input[36] & 0x80) << 9);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 289 to 304
	value = ((uint32_t)(input[36] & 0x7f) << 25) |
			((uint32_t)input[37] << 17) |
			((uint32_t)(input[38] & 0x80) << 9);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 305 to 320
	value = ((uint32_t)(input[38] & 0x7f) << 25) |
			((uint32_t)input[39] << 17) |
			((uint32_t)(input[40] & 0x80) << 9);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 321 to 336
	value = ((uint32_t)(input[40] & 0x7f) << 25) |
			((uint32_t)input[41] << 17) |
			((uint32_t)(input[42] & 0x80) << 9);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 337 to 352
	value = ((uint32_t)(input[42] & 0x7f) << 25) |
			((uint32_t)input[43] << 17) |
			((uint32_t)(input[44] & 0x80) << 9);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 353 to 368
	value = ((uint32_t)(input[44] & 0x7f) << 25) |
			((uint32_t)input[45] << 17) |
			((uint32_t)(input[46] & 0x80) << 9);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 369 to 384
	value = ((uint32_t)(input[46] & 0x7f) << 25) |
			((uint32_t)input[47] << 17) |
			((uint32_t)(input[48] & 0x80) << 9);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 385 to 400
	value = ((uint32_t)(input[48] & 0x7f) << 25) |
			((uint32_t)input[49] << 17) |
			((uint32_t)(input[50] & 0x80) << 9);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 401 to 416
	value = ((uint32_t)(input[50] & 0x7f) << 25) |
			((uint32_t)input[51] << 17) |
			((uint32_t)(input[52] & 0x80) << 9);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 417 to 432
	value = ((uint32_t)(input[52] & 0x7f) << 25) |
			((uint32_t)input[53] << 17) |
			((uint32_t)(input[54] & 0x80) << 9);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 433 to 448
	value = ((uint32_t)(input[54] & 0x7f) << 25) |
			((uint32_t)input[55] << 17) |
			((uint32_t)(input[56] & 0x80) << 9);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 449 to 464
	value = ((uint32_t)(input[56] & 0x7f) << 25) |
			((uint32_t)input[57] << 17) |
			((uint32_t)(input[58] & 0x80) << 9);
	output[28] = (double)(value >> 16);
}

static void unpack_29_16bit_signed_2off(const uint8_t * input, double * output, void *closure) {
	// Unpack 29 values into output
	// Values are 16-bit signed
	// Skip 2 bits, read 464 bits of data.
	// Input must be at least 59 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 2 to 17
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)input[1] << 18) |
			((uint32_t)(input[2] & 0xc0) << 10);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 18 to 33
	value = ((uint32_t)(input[2] & 0x3f) << 26) |
			((uint32_t)input[3] << 18) |
			((uint32_t)(input[4] & 0xc0) << 10);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 34 to 49
	value = ((uint32_t)(input[4] & 0x3f) << 26) |
			((uint32_t)input[5] << 18) |
			((uint32_t)(input[6] & 0xc0) << 10);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 50 to 65
	value = ((uint32_t)(input[6] & 0x3f) << 26) |
			((uint32_t)input[7] << 18) |
			((uint32_t)(input[8] & 0xc0) << 10);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 66 to 81
	value = ((uint32_t)(input[8] & 0x3f) << 26) |
			((uint32_t)input[9] << 18) |
			((uint32_t)(input[10] & 0xc0) << 10);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 82 to 97
	value = ((uint32_t)(input[10] & 0x3f) << 26) |
			((uint32_t)input[11] << 18) |
			((uint32_t)(input[12] & 0xc0) << 10);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 98 to 113
	value = ((uint32_t)(input[12] & 0x3f) << 26) |
			((uint32_t)input[13] << 18) |
			((uint32_t)(input[14] & 0xc0) << 10);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 114 to 129
	value = ((uint32_t)(input[14] & 0x3f) << 26) |
			((uint32_t)input[15] << 18) |
			((uint32_t)(input[16] & 0xc0) << 10);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 130 to 145
	value = ((uint32_t)(input[16] & 0x3f) << 26) |
			((uint32_t)input[17] << 18) |
			((uint32_t)(input[18] & 0xc0) << 10);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 146 to 161
	value = ((uint32_t)(input[18] & 0x3f) << 26) |
			((uint32_t)input[19] << 18) |
			((uint32_t)(input[20] & 0xc0) << 10);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 162 to 177
	value = ((uint32_t)(input[20] & 0x3f) << 26) |
			((uint32_t)input[21] << 18) |
			((uint32_t)(input[22] & 0xc0) << 10);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 178 to 193
	value = ((uint32_t)(input[22] & 0x3f) << 26) |
			((uint32_t)input[23] << 18) |
			((uint32_t)(input[24] & 0xc0) << 10);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 194 to 209
	value = ((uint32_t)(input[24] & 0x3f) << 26) |
			((uint32_t)input[25] << 18) |
			((uint32_t)(input[26] & 0xc0) << 10);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 210 to 225
	value = ((uint32_t)(input[26] & 0x3f) << 26) |
			((uint32_t)input[27] << 18) |
			((uint32_t)(input[28] & 0xc0) << 10);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 226 to 241
	value = ((uint32_t)(input[28] & 0x3f) << 26) |
			((uint32_t)input[29] << 18) |
			((uint32_t)(input[30] & 0xc0) << 10);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 242 to 257
	value = ((uint32_t)(input[30] & 0x3f) << 26) |
			((uint32_t)input[31] << 18) |
			((uint32_t)(input[32] & 0xc0) << 10);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 258 to 273
	value = ((uint32_t)(input[32] & 0x3f) << 26) |
			((uint32_t)input[33] << 18) |
			((uint32_t)(input[34] & 0xc0) << 10);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 274 to 289
	value = ((uint32_t)(input[34] & 0x3f) << 26) |
			((uint32_t)input[35] << 18) |
			((uint32_t)(input[36] & 0xc0) << 10);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 290 to 305
	value = ((uint32_t)(input[36] & 0x3f) << 26) |
			((uint32_t)input[37] << 18) |
			((uint32_t)(input[38] & 0xc0) << 10);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 306 to 321
	value = ((uint32_t)(input[38] & 0x3f) << 26) |
			((uint32_t)input[39] << 18) |
			((uint32_t)(input[40] & 0xc0) << 10);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 322 to 337
	value = ((uint32_t)(input[40] & 0x3f) << 26) |
			((uint32_t)input[41] << 18) |
			((uint32_t)(input[42] & 0xc0) << 10);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 338 to 353
	value = ((uint32_t)(input[42] & 0x3f) << 26) |
			((uint32_t)input[43] << 18) |
			((uint32_t)(input[44] & 0xc0) << 10);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 354 to 369
	value = ((uint32_t)(input[44] & 0x3f) << 26) |
			((uint32_t)input[45] << 18) |
			((uint32_t)(input[46] & 0xc0) << 10);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 370 to 385
	value = ((uint32_t)(input[46] & 0x3f) << 26) |
			((uint32_t)input[47] << 18) |
			((uint32_t)(input[48] & 0xc0) << 10);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 386 to 401
	value = ((uint32_t)(input[48] & 0x3f) << 26) |
			((uint32_t)input[49] << 18) |
			((uint32_t)(input[50] & 0xc0) << 10);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 402 to 417
	value = ((uint32_t)(input[50] & 0x3f) << 26) |
			((uint32_t)input[51] << 18) |
			((uint32_t)(input[52] & 0xc0) << 10);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 418 to 433
	value = ((uint32_t)(input[52] & 0x3f) << 26) |
			((uint32_t)input[53] << 18) |
			((uint32_t)(input[54] & 0xc0) << 10);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 434 to 449
	value = ((uint32_t)(input[54] & 0x3f) << 26) |
			((uint32_t)input[55] << 18) |
			((uint32_t)(input[56] & 0xc0) << 10);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 450 to 465
	value = ((uint32_t)(input[56] & 0x3f) << 26) |
			((uint32_t)input[57] << 18) |
			((uint32_t)(input[58] & 0xc0) << 10);
	output[28] = (double)(value >> 16);
}

static void unpack_29_16bit_unsigned_2off(const uint8_t * input, double * output, void *closure) {
	// Unpack 29 values into output
	// Values are 16-bit unsigned
	// Skip 2 bits, read 464 bits of data.
	// Input must be at least 59 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 2 to 17
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)input[1] << 18) |
			((uint32_t)(input[2] & 0xc0) << 10);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 18 to 33
	value = ((uint32_t)(input[2] & 0x3f) << 26) |
			((uint32_t)input[3] << 18) |
			((uint32_t)(input[4] & 0xc0) << 10);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 34 to 49
	value = ((uint32_t)(input[4] & 0x3f) << 26) |
			((uint32_t)input[5] << 18) |
			((uint32_t)(input[6] & 0xc0) << 10);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 50 to 65
	value = ((uint32_t)(input[6] & 0x3f) << 26) |
			((uint32_t)input[7] << 18) |
			((uint32_t)(input[8] & 0xc0) << 10);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 66 to 81
	value = ((uint32_t)(input[8] & 0x3f) << 26) |
			((uint32_t)input[9] << 18) |
			((uint32_t)(input[10] & 0xc0) << 10);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 82 to 97
	value = ((uint32_t)(input[10] & 0x3f) << 26) |
			((uint32_t)input[11] << 18) |
			((uint32_t)(input[12] & 0xc0) << 10);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 98 to 113
	value = ((uint32_t)(input[12] & 0x3f) << 26) |
			((uint32_t)input[13] << 18) |
			((uint32_t)(input[14] & 0xc0) << 10);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 114 to 129
	value = ((uint32_t)(input[14] & 0x3f) << 26) |
			((uint32_t)input[15] << 18) |
			((uint32_t)(input[16] & 0xc0) << 10);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 130 to 145
	value = ((uint32_t)(input[16] & 0x3f) << 26) |
			((uint32_t)input[17] << 18) |
			((uint32_t)(input[18] & 0xc0) << 10);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 146 to 161
	value = ((uint32_t)(input[18] & 0x3f) << 26) |
			((uint32_t)input[19] << 18) |
			((uint32_t)(input[20] & 0xc0) << 10);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 162 to 177
	value = ((uint32_t)(input[20] & 0x3f) << 26) |
			((uint32_t)input[21] << 18) |
			((uint32_t)(input[22] & 0xc0) << 10);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 178 to 193
	value = ((uint32_t)(input[22] & 0x3f) << 26) |
			((uint32_t)input[23] << 18) |
			((uint32_t)(input[24] & 0xc0) << 10);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 194 to 209
	value = ((uint32_t)(input[24] & 0x3f) << 26) |
			((uint32_t)input[25] << 18) |
			((uint32_t)(input[26] & 0xc0) << 10);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 210 to 225
	value = ((uint32_t)(input[26] & 0x3f) << 26) |
			((uint32_t)input[27] << 18) |
			((uint32_t)(input[28] & 0xc0) << 10);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 226 to 241
	value = ((uint32_t)(input[28] & 0x3f) << 26) |
			((uint32_t)input[29] << 18) |
			((uint32_t)(input[30] & 0xc0) << 10);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 242 to 257
	value = ((uint32_t)(input[30] & 0x3f) << 26) |
			((uint32_t)input[31] << 18) |
			((uint32_t)(input[32] & 0xc0) << 10);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 258 to 273
	value = ((uint32_t)(input[32] & 0x3f) << 26) |
			((uint32_t)input[33] << 18) |
			((uint32_t)(input[34] & 0xc0) << 10);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 274 to 289
	value = ((uint32_t)(input[34] & 0x3f) << 26) |
			((uint32_t)input[35] << 18) |
			((uint32_t)(input[36] & 0xc0) << 10);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 290 to 305
	value = ((uint32_t)(input[36] & 0x3f) << 26) |
			((uint32_t)input[37] << 18) |
			((uint32_t)(input[38] & 0xc0) << 10);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 306 to 321
	value = ((uint32_t)(input[38] & 0x3f) << 26) |
			((uint32_t)input[39] << 18) |
			((uint32_t)(input[40] & 0xc0) << 10);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 322 to 337
	value = ((uint32_t)(input[40] & 0x3f) << 26) |
			((uint32_t)input[41] << 18) |
			((uint32_t)(input[42] & 0xc0) << 10);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 338 to 353
	value = ((uint32_t)(input[42] & 0x3f) << 26) |
			((uint32_t)input[43] << 18) |
			((uint32_t)(input[44] & 0xc0) << 10);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 354 to 369
	value = ((uint32_t)(input[44] & 0x3f) << 26) |
			((uint32_t)input[45] << 18) |
			((uint32_t)(input[46] & 0xc0) << 10);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 370 to 385
	value = ((uint32_t)(input[46] & 0x3f) << 26) |
			((uint32_t)input[47] << 18) |
			((uint32_t)(input[48] & 0xc0) << 10);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 386 to 401
	value = ((uint32_t)(input[48] & 0x3f) << 26) |
			((uint32_t)input[49] << 18) |
			((uint32_t)(input[50] & 0xc0) << 10);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 402 to 417
	value = ((uint32_t)(input[50] & 0x3f) << 26) |
			((uint32_t)input[51] << 18) |
			((uint32_t)(input[52] & 0xc0) << 10);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 418 to 433
	value = ((uint32_t)(input[52] & 0x3f) << 26) |
			((uint32_t)input[53] << 18) |
			((uint32_t)(input[54] & 0xc0) << 10);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 434 to 449
	value = ((uint32_t)(input[54] & 0x3f) << 26) |
			((uint32_t)input[55] << 18) |
			((uint32_t)(input[56] & 0xc0) << 10);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 450 to 465
	value = ((uint32_t)(input[56] & 0x3f) << 26) |
			((uint32_t)input[57] << 18) |
			((uint32_t)(input[58] & 0xc0) << 10);
	output[28] = (double)(value >> 16);
}

static void unpack_29_16bit_signed_3off(const uint8_t * input, double * output, void *closure) {
	// Unpack 29 values into output
	// Values are 16-bit signed
	// Skip 3 bits, read 464 bits of data.
	// Input must be at least 59 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 3 to 18
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)input[1] << 19) |
			((uint32_t)(input[2] & 0xe0) << 11);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 19 to 34
	value = ((uint32_t)(input[2] & 0x1f) << 27) |
			((uint32_t)input[3] << 19) |
			((uint32_t)(input[4] & 0xe0) << 11);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 35 to 50
	value = ((uint32_t)(input[4] & 0x1f) << 27) |
			((uint32_t)input[5] << 19) |
			((uint32_t)(input[6] & 0xe0) << 11);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 51 to 66
	value = ((uint32_t)(input[6] & 0x1f) << 27) |
			((uint32_t)input[7] << 19) |
			((uint32_t)(input[8] & 0xe0) << 11);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 67 to 82
	value = ((uint32_t)(input[8] & 0x1f) << 27) |
			((uint32_t)input[9] << 19) |
			((uint32_t)(input[10] & 0xe0) << 11);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 83 to 98
	value = ((uint32_t)(input[10] & 0x1f) << 27) |
			((uint32_t)input[11] << 19) |
			((uint32_t)(input[12] & 0xe0) << 11);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 99 to 114
	value = ((uint32_t)(input[12] & 0x1f) << 27) |
			((uint32_t)input[13] << 19) |
			((uint32_t)(input[14] & 0xe0) << 11);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 115 to 130
	value = ((uint32_t)(input[14] & 0x1f) << 27) |
			((uint32_t)input[15] << 19) |
			((uint32_t)(input[16] & 0xe0) << 11);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 131 to 146
	value = ((uint32_t)(input[16] & 0x1f) << 27) |
			((uint32_t)input[17] << 19) |
			((uint32_t)(input[18] & 0xe0) << 11);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 147 to 162
	value = ((uint32_t)(input[18] & 0x1f) << 27) |
			((uint32_t)input[19] << 19) |
			((uint32_t)(input[20] & 0xe0) << 11);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 163 to 178
	value = ((uint32_t)(input[20] & 0x1f) << 27) |
			((uint32_t)input[21] << 19) |
			((uint32_t)(input[22] & 0xe0) << 11);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 179 to 194
	value = ((uint32_t)(input[22] & 0x1f) << 27) |
			((uint32_t)input[23] << 19) |
			((uint32_t)(input[24] & 0xe0) << 11);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 195 to 210
	value = ((uint32_t)(input[24] & 0x1f) << 27) |
			((uint32_t)input[25] << 19) |
			((uint32_t)(input[26] & 0xe0) << 11);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 211 to 226
	value = ((uint32_t)(input[26] & 0x1f) << 27) |
			((uint32_t)input[27] << 19) |
			((uint32_t)(input[28] & 0xe0) << 11);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 227 to 242
	value = ((uint32_t)(input[28] & 0x1f) << 27) |
			((uint32_t)input[29] << 19) |
			((uint32_t)(input[30] & 0xe0) << 11);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 243 to 258
	value = ((uint32_t)(input[30] & 0x1f) << 27) |
			((uint32_t)input[31] << 19) |
			((uint32_t)(input[32] & 0xe0) << 11);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 259 to 274
	value = ((uint32_t)(input[32] & 0x1f) << 27) |
			((uint32_t)input[33] << 19) |
			((uint32_t)(input[34] & 0xe0) << 11);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 275 to 290
	value = ((uint32_t)(input[34] & 0x1f) << 27) |
			((uint32_t)input[35] << 19) |
			((uint32_t)(input[36] & 0xe0) << 11);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 291 to 306
	value = ((uint32_t)(input[36] & 0x1f) << 27) |
			((uint32_t)input[37] << 19) |
			((uint32_t)(input[38] & 0xe0) << 11);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 307 to 322
	value = ((uint32_t)(input[38] & 0x1f) << 27) |
			((uint32_t)input[39] << 19) |
			((uint32_t)(input[40] & 0xe0) << 11);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 323 to 338
	value = ((uint32_t)(input[40] & 0x1f) << 27) |
			((uint32_t)input[41] << 19) |
			((uint32_t)(input[42] & 0xe0) << 11);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 339 to 354
	value = ((uint32_t)(input[42] & 0x1f) << 27) |
			((uint32_t)input[43] << 19) |
			((uint32_t)(input[44] & 0xe0) << 11);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 355 to 370
	value = ((uint32_t)(input[44] & 0x1f) << 27) |
			((uint32_t)input[45] << 19) |
			((uint32_t)(input[46] & 0xe0) << 11);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 371 to 386
	value = ((uint32_t)(input[46] & 0x1f) << 27) |
			((uint32_t)input[47] << 19) |
			((uint32_t)(input[48] & 0xe0) << 11);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 387 to 402
	value = ((uint32_t)(input[48] & 0x1f) << 27) |
			((uint32_t)input[49] << 19) |
			((uint32_t)(input[50] & 0xe0) << 11);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 403 to 418
	value = ((uint32_t)(input[50] & 0x1f) << 27) |
			((uint32_t)input[51] << 19) |
			((uint32_t)(input[52] & 0xe0) << 11);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 419 to 434
	value = ((uint32_t)(input[52] & 0x1f) << 27) |
			((uint32_t)input[53] << 19) |
			((uint32_t)(input[54] & 0xe0) << 11);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 435 to 450
	value = ((uint32_t)(input[54] & 0x1f) << 27) |
			((uint32_t)input[55] << 19) |
			((uint32_t)(input[56] & 0xe0) << 11);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 451 to 466
	value = ((uint32_t)(input[56] & 0x1f) << 27) |
			((uint32_t)input[57] << 19) |
			((uint32_t)(input[58] & 0xe0) << 11);
	output[28] = (double)(value >> 16);
}

static void unpack_29_16bit_unsigned_3off(const uint8_t * input, double * output, void *closure) {
	// Unpack 29 values into output
	// Values are 16-bit unsigned
	// Skip 3 bits, read 464 bits of data.
	// Input must be at least 59 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 3 to 18
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)input[1] << 19) |
			((uint32_t)(input[2] & 0xe0) << 11);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 19 to 34
	value = ((uint32_t)(input[2] & 0x1f) << 27) |
			((uint32_t)input[3] << 19) |
			((uint32_t)(input[4] & 0xe0) << 11);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 35 to 50
	value = ((uint32_t)(input[4] & 0x1f) << 27) |
			((uint32_t)input[5] << 19) |
			((uint32_t)(input[6] & 0xe0) << 11);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 51 to 66
	value = ((uint32_t)(input[6] & 0x1f) << 27) |
			((uint32_t)input[7] << 19) |
			((uint32_t)(input[8] & 0xe0) << 11);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 67 to 82
	value = ((uint32_t)(input[8] & 0x1f) << 27) |
			((uint32_t)input[9] << 19) |
			((uint32_t)(input[10] & 0xe0) << 11);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 83 to 98
	value = ((uint32_t)(input[10] & 0x1f) << 27) |
			((uint32_t)input[11] << 19) |
			((uint32_t)(input[12] & 0xe0) << 11);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 99 to 114
	value = ((uint32_t)(input[12] & 0x1f) << 27) |
			((uint32_t)input[13] << 19) |
			((uint32_t)(input[14] & 0xe0) << 11);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 115 to 130
	value = ((uint32_t)(input[14] & 0x1f) << 27) |
			((uint32_t)input[15] << 19) |
			((uint32_t)(input[16] & 0xe0) << 11);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 131 to 146
	value = ((uint32_t)(input[16] & 0x1f) << 27) |
			((uint32_t)input[17] << 19) |
			((uint32_t)(input[18] & 0xe0) << 11);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 147 to 162
	value = ((uint32_t)(input[18] & 0x1f) << 27) |
			((uint32_t)input[19] << 19) |
			((uint32_t)(input[20] & 0xe0) << 11);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 163 to 178
	value = ((uint32_t)(input[20] & 0x1f) << 27) |
			((uint32_t)input[21] << 19) |
			((uint32_t)(input[22] & 0xe0) << 11);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 179 to 194
	value = ((uint32_t)(input[22] & 0x1f) << 27) |
			((uint32_t)input[23] << 19) |
			((uint32_t)(input[24] & 0xe0) << 11);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 195 to 210
	value = ((uint32_t)(input[24] & 0x1f) << 27) |
			((uint32_t)input[25] << 19) |
			((uint32_t)(input[26] & 0xe0) << 11);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 211 to 226
	value = ((uint32_t)(input[26] & 0x1f) << 27) |
			((uint32_t)input[27] << 19) |
			((uint32_t)(input[28] & 0xe0) << 11);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 227 to 242
	value = ((uint32_t)(input[28] & 0x1f) << 27) |
			((uint32_t)input[29] << 19) |
			((uint32_t)(input[30] & 0xe0) << 11);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 243 to 258
	value = ((uint32_t)(input[30] & 0x1f) << 27) |
			((uint32_t)input[31] << 19) |
			((uint32_t)(input[32] & 0xe0) << 11);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 259 to 274
	value = ((uint32_t)(input[32] & 0x1f) << 27) |
			((uint32_t)input[33] << 19) |
			((uint32_t)(input[34] & 0xe0) << 11);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 275 to 290
	value = ((uint32_t)(input[34] & 0x1f) << 27) |
			((uint32_t)input[35] << 19) |
			((uint32_t)(input[36] & 0xe0) << 11);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 291 to 306
	value = ((uint32_t)(input[36] & 0x1f) << 27) |
			((uint32_t)input[37] << 19) |
			((uint32_t)(input[38] & 0xe0) << 11);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 307 to 322
	value = ((uint32_t)(input[38] & 0x1f) << 27) |
			((uint32_t)input[39] << 19) |
			((uint32_t)(input[40] & 0xe0) << 11);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 323 to 338
	value = ((uint32_t)(input[40] & 0x1f) << 27) |
			((uint32_t)input[41] << 19) |
			((uint32_t)(input[42] & 0xe0) << 11);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 339 to 354
	value = ((uint32_t)(input[42] & 0x1f) << 27) |
			((uint32_t)input[43] << 19) |
			((uint32_t)(input[44] & 0xe0) << 11);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 355 to 370
	value = ((uint32_t)(input[44] & 0x1f) << 27) |
			((uint32_t)input[45] << 19) |
			((uint32_t)(input[46] & 0xe0) << 11);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 371 to 386
	value = ((uint32_t)(input[46] & 0x1f) << 27) |
			((uint32_t)input[47] << 19) |
			((uint32_t)(input[48] & 0xe0) << 11);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 387 to 402
	value = ((uint32_t)(input[48] & 0x1f) << 27) |
			((uint32_t)input[49] << 19) |
			((uint32_t)(input[50] & 0xe0) << 11);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 403 to 418
	value = ((uint32_t)(input[50] & 0x1f) << 27) |
			((uint32_t)input[51] << 19) |
			((uint32_t)(input[52] & 0xe0) << 11);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 419 to 434
	value = ((uint32_t)(input[52] & 0x1f) << 27) |
			((uint32_t)input[53] << 19) |
			((uint32_t)(input[54] & 0xe0) << 11);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 435 to 450
	value = ((uint32_t)(input[54] & 0x1f) << 27) |
			((uint32_t)input[55] << 19) |
			((uint32_t)(input[56] & 0xe0) << 11);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 451 to 466
	value = ((uint32_t)(input[56] & 0x1f) << 27) |
			((uint32_t)input[57] << 19) |
			((uint32_t)(input[58] & 0xe0) << 11);
	output[28] = (double)(value >> 16);
}

static void unpack_29_16bit_signed_4off(const uint8_t * input, double * output, void *closure) {
	// Unpack 29 values into output
	// Values are 16-bit signed
	// Skip 4 bits, read 464 bits of data.
	// Input must be at least 59 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 4 to 19
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20) |
			((uint32_t)(input[2] & 0xf0) << 12);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 20 to 35
	value = ((uint32_t)(input[2] & 0x0f) << 28) |
			((uint32_t)input[3] << 20) |
			((uint32_t)(input[4] & 0xf0) << 12);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 36 to 51
	value = ((uint32_t)(input[4] & 0x0f) << 28) |
			((uint32_t)input[5] << 20) |
			((uint32_t)(input[6] & 0xf0) << 12);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 52 to 67
	value = ((uint32_t)(input[6] & 0x0f) << 28) |
			((uint32_t)input[7] << 20) |
			((uint32_t)(input[8] & 0xf0) << 12);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 68 to 83
	value = ((uint32_t)(input[8] & 0x0f) << 28) |
			((uint32_t)input[9] << 20) |
			((uint32_t)(input[10] & 0xf0) << 12);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 84 to 99
	value = ((uint32_t)(input[10] & 0x0f) << 28) |
			((uint32_t)input[11] << 20) |
			((uint32_t)(input[12] & 0xf0) << 12);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 100 to 115
	value = ((uint32_t)(input[12] & 0x0f) << 28) |
			((uint32_t)input[13] << 20) |
			((uint32_t)(input[14] & 0xf0) << 12);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 116 to 131
	value = ((uint32_t)(input[14] & 0x0f) << 28) |
			((uint32_t)input[15] << 20) |
			((uint32_t)(input[16] & 0xf0) << 12);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 132 to 147
	value = ((uint32_t)(input[16] & 0x0f) << 28) |
			((uint32_t)input[17] << 20) |
			((uint32_t)(input[18] & 0xf0) << 12);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 148 to 163
	value = ((uint32_t)(input[18] & 0x0f) << 28) |
			((uint32_t)input[19] << 20) |
			((uint32_t)(input[20] & 0xf0) << 12);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 164 to 179
	value = ((uint32_t)(input[20] & 0x0f) << 28) |
			((uint32_t)input[21] << 20) |
			((uint32_t)(input[22] & 0xf0) << 12);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 180 to 195
	value = ((uint32_t)(input[22] & 0x0f) << 28) |
			((uint32_t)input[23] << 20) |
			((uint32_t)(input[24] & 0xf0) << 12);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 196 to 211
	value = ((uint32_t)(input[24] & 0x0f) << 28) |
			((uint32_t)input[25] << 20) |
			((uint32_t)(input[26] & 0xf0) << 12);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 212 to 227
	value = ((uint32_t)(input[26] & 0x0f) << 28) |
			((uint32_t)input[27] << 20) |
			((uint32_t)(input[28] & 0xf0) << 12);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 228 to 243
	value = ((uint32_t)(input[28] & 0x0f) << 28) |
			((uint32_t)input[29] << 20) |
			((uint32_t)(input[30] & 0xf0) << 12);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 244 to 259
	value = ((uint32_t)(input[30] & 0x0f) << 28) |
			((uint32_t)input[31] << 20) |
			((uint32_t)(input[32] & 0xf0) << 12);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 260 to 275
	value = ((uint32_t)(input[32] & 0x0f) << 28) |
			((uint32_t)input[33] << 20) |
			((uint32_t)(input[34] & 0xf0) << 12);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 276 to 291
	value = ((uint32_t)(input[34] & 0x0f) << 28) |
			((uint32_t)input[35] << 20) |
			((uint32_t)(input[36] & 0xf0) << 12);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 292 to 307
	value = ((uint32_t)(input[36] & 0x0f) << 28) |
			((uint32_t)input[37] << 20) |
			((uint32_t)(input[38] & 0xf0) << 12);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 308 to 323
	value = ((uint32_t)(input[38] & 0x0f) << 28) |
			((uint32_t)input[39] << 20) |
			((uint32_t)(input[40] & 0xf0) << 12);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 324 to 339
	value = ((uint32_t)(input[40] & 0x0f) << 28) |
			((uint32_t)input[41] << 20) |
			((uint32_t)(input[42] & 0xf0) << 12);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 340 to 355
	value = ((uint32_t)(input[42] & 0x0f) << 28) |
			((uint32_t)input[43] << 20) |
			((uint32_t)(input[44] & 0xf0) << 12);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 356 to 371
	value = ((uint32_t)(input[44] & 0x0f) << 28) |
			((uint32_t)input[45] << 20) |
			((uint32_t)(input[46] & 0xf0) << 12);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 372 to 387
	value = ((uint32_t)(input[46] & 0x0f) << 28) |
			((uint32_t)input[47] << 20) |
			((uint32_t)(input[48] & 0xf0) << 12);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 388 to 403
	value = ((uint32_t)(input[48] & 0x0f) << 28) |
			((uint32_t)input[49] << 20) |
			((uint32_t)(input[50] & 0xf0) << 12);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 404 to 419
	value = ((uint32_t)(input[50] & 0x0f) << 28) |
			((uint32_t)input[51] << 20) |
			((uint32_t)(input[52] & 0xf0) << 12);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 420 to 435
	value = ((uint32_t)(input[52] & 0x0f) << 28) |
			((uint32_t)input[53] << 20) |
			((uint32_t)(input[54] & 0xf0) << 12);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 436 to 451
	value = ((uint32_t)(input[54] & 0x0f) << 28) |
			((uint32_t)input[55] << 20) |
			((uint32_t)(input[56] & 0xf0) << 12);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 452 to 467
	value = ((uint32_t)(input[56] & 0x0f) << 28) |
			((uint32_t)input[57] << 20) |
			((uint32_t)(input[58] & 0xf0) << 12);
	output[28] = (double)(value >> 16);
}

static void unpack_29_16bit_unsigned_4off(const uint8_t * input, double * output, void *closure) {
	// Unpack 29 values into output
	// Values are 16-bit unsigned
	// Skip 4 bits, read 464 bits of data.
	// Input must be at least 59 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 4 to 19
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20) |
			((uint32_t)(input[2] & 0xf0) << 12);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 20 to 35
	value = ((uint32_t)(input[2] & 0x0f) << 28) |
			((uint32_t)input[3] << 20) |
			((uint32_t)(input[4] & 0xf0) << 12);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 36 to 51
	value = ((uint32_t)(input[4] & 0x0f) << 28) |
			((uint32_t)input[5] << 20) |
			((uint32_t)(input[6] & 0xf0) << 12);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 52 to 67
	value = ((uint32_t)(input[6] & 0x0f) << 28) |
			((uint32_t)input[7] << 20) |
			((uint32_t)(input[8] & 0xf0) << 12);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 68 to 83
	value = ((uint32_t)(input[8] & 0x0f) << 28) |
			((uint32_t)input[9] << 20) |
			((uint32_t)(input[10] & 0xf0) << 12);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 84 to 99
	value = ((uint32_t)(input[10] & 0x0f) << 28) |
			((uint32_t)input[11] << 20) |
			((uint32_t)(input[12] & 0xf0) << 12);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 100 to 115
	value = ((uint32_t)(input[12] & 0x0f) << 28) |
			((uint32_t)input[13] << 20) |
			((uint32_t)(input[14] & 0xf0) << 12);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 116 to 131
	value = ((uint32_t)(input[14] & 0x0f) << 28) |
			((uint32_t)input[15] << 20) |
			((uint32_t)(input[16] & 0xf0) << 12);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 132 to 147
	value = ((uint32_t)(input[16] & 0x0f) << 28) |
			((uint32_t)input[17] << 20) |
			((uint32_t)(input[18] & 0xf0) << 12);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 148 to 163
	value = ((uint32_t)(input[18] & 0x0f) << 28) |
			((uint32_t)input[19] << 20) |
			((uint32_t)(input[20] & 0xf0) << 12);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 164 to 179
	value = ((uint32_t)(input[20] & 0x0f) << 28) |
			((uint32_t)input[21] << 20) |
			((uint32_t)(input[22] & 0xf0) << 12);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 180 to 195
	value = ((uint32_t)(input[22] & 0x0f) << 28) |
			((uint32_t)input[23] << 20) |
			((uint32_t)(input[24] & 0xf0) << 12);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 196 to 211
	value = ((uint32_t)(input[24] & 0x0f) << 28) |
			((uint32_t)input[25] << 20) |
			((uint32_t)(input[26] & 0xf0) << 12);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 212 to 227
	value = ((uint32_t)(input[26] & 0x0f) << 28) |
			((uint32_t)input[27] << 20) |
			((uint32_t)(input[28] & 0xf0) << 12);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 228 to 243
	value = ((uint32_t)(input[28] & 0x0f) << 28) |
			((uint32_t)input[29] << 20) |
			((uint32_t)(input[30] & 0xf0) << 12);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 244 to 259
	value = ((uint32_t)(input[30] & 0x0f) << 28) |
			((uint32_t)input[31] << 20) |
			((uint32_t)(input[32] & 0xf0) << 12);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 260 to 275
	value = ((uint32_t)(input[32] & 0x0f) << 28) |
			((uint32_t)input[33] << 20) |
			((uint32_t)(input[34] & 0xf0) << 12);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 276 to 291
	value = ((uint32_t)(input[34] & 0x0f) << 28) |
			((uint32_t)input[35] << 20) |
			((uint32_t)(input[36] & 0xf0) << 12);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 292 to 307
	value = ((uint32_t)(input[36] & 0x0f) << 28) |
			((uint32_t)input[37] << 20) |
			((uint32_t)(input[38] & 0xf0) << 12);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 308 to 323
	value = ((uint32_t)(input[38] & 0x0f) << 28) |
			((uint32_t)input[39] << 20) |
			((uint32_t)(input[40] & 0xf0) << 12);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 324 to 339
	value = ((uint32_t)(input[40] & 0x0f) << 28) |
			((uint32_t)input[41] << 20) |
			((uint32_t)(input[42] & 0xf0) << 12);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 340 to 355
	value = ((uint32_t)(input[42] & 0x0f) << 28) |
			((uint32_t)input[43] << 20) |
			((uint32_t)(input[44] & 0xf0) << 12);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 356 to 371
	value = ((uint32_t)(input[44] & 0x0f) << 28) |
			((uint32_t)input[45] << 20) |
			((uint32_t)(input[46] & 0xf0) << 12);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 372 to 387
	value = ((uint32_t)(input[46] & 0x0f) << 28) |
			((uint32_t)input[47] << 20) |
			((uint32_t)(input[48] & 0xf0) << 12);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 388 to 403
	value = ((uint32_t)(input[48] & 0x0f) << 28) |
			((uint32_t)input[49] << 20) |
			((uint32_t)(input[50] & 0xf0) << 12);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 404 to 419
	value = ((uint32_t)(input[50] & 0x0f) << 28) |
			((uint32_t)input[51] << 20) |
			((uint32_t)(input[52] & 0xf0) << 12);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 420 to 435
	value = ((uint32_t)(input[52] & 0x0f) << 28) |
			((uint32_t)input[53] << 20) |
			((uint32_t)(input[54] & 0xf0) << 12);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 436 to 451
	value = ((uint32_t)(input[54] & 0x0f) << 28) |
			((uint32_t)input[55] << 20) |
			((uint32_t)(input[56] & 0xf0) << 12);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 452 to 467
	value = ((uint32_t)(input[56] & 0x0f) << 28) |
			((uint32_t)input[57] << 20) |
			((uint32_t)(input[58] & 0xf0) << 12);
	output[28] = (double)(value >> 16);
}

static void unpack_29_16bit_signed_5off(const uint8_t * input, double * output, void *closure) {
	// Unpack 29 values into output
	// Values are 16-bit signed
	// Skip 5 bits, read 464 bits of data.
	// Input must be at least 59 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 5 to 20
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)(input[2] & 0xf8) << 13);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 21 to 36
	value = ((uint32_t)(input[2] & 0x07) << 29) |
			((uint32_t)input[3] << 21) |
			((uint32_t)(input[4] & 0xf8) << 13);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 37 to 52
	value = ((uint32_t)(input[4] & 0x07) << 29) |
			((uint32_t)input[5] << 21) |
			((uint32_t)(input[6] & 0xf8) << 13);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 53 to 68
	value = ((uint32_t)(input[6] & 0x07) << 29) |
			((uint32_t)input[7] << 21) |
			((uint32_t)(input[8] & 0xf8) << 13);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 69 to 84
	value = ((uint32_t)(input[8] & 0x07) << 29) |
			((uint32_t)input[9] << 21) |
			((uint32_t)(input[10] & 0xf8) << 13);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 85 to 100
	value = ((uint32_t)(input[10] & 0x07) << 29) |
			((uint32_t)input[11] << 21) |
			((uint32_t)(input[12] & 0xf8) << 13);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 101 to 116
	value = ((uint32_t)(input[12] & 0x07) << 29) |
			((uint32_t)input[13] << 21) |
			((uint32_t)(input[14] & 0xf8) << 13);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 117 to 132
	value = ((uint32_t)(input[14] & 0x07) << 29) |
			((uint32_t)input[15] << 21) |
			((uint32_t)(input[16] & 0xf8) << 13);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 133 to 148
	value = ((uint32_t)(input[16] & 0x07) << 29) |
			((uint32_t)input[17] << 21) |
			((uint32_t)(input[18] & 0xf8) << 13);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 149 to 164
	value = ((uint32_t)(input[18] & 0x07) << 29) |
			((uint32_t)input[19] << 21) |
			((uint32_t)(input[20] & 0xf8) << 13);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 165 to 180
	value = ((uint32_t)(input[20] & 0x07) << 29) |
			((uint32_t)input[21] << 21) |
			((uint32_t)(input[22] & 0xf8) << 13);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 181 to 196
	value = ((uint32_t)(input[22] & 0x07) << 29) |
			((uint32_t)input[23] << 21) |
			((uint32_t)(input[24] & 0xf8) << 13);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 197 to 212
	value = ((uint32_t)(input[24] & 0x07) << 29) |
			((uint32_t)input[25] << 21) |
			((uint32_t)(input[26] & 0xf8) << 13);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 213 to 228
	value = ((uint32_t)(input[26] & 0x07) << 29) |
			((uint32_t)input[27] << 21) |
			((uint32_t)(input[28] & 0xf8) << 13);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 229 to 244
	value = ((uint32_t)(input[28] & 0x07) << 29) |
			((uint32_t)input[29] << 21) |
			((uint32_t)(input[30] & 0xf8) << 13);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 245 to 260
	value = ((uint32_t)(input[30] & 0x07) << 29) |
			((uint32_t)input[31] << 21) |
			((uint32_t)(input[32] & 0xf8) << 13);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 261 to 276
	value = ((uint32_t)(input[32] & 0x07) << 29) |
			((uint32_t)input[33] << 21) |
			((uint32_t)(input[34] & 0xf8) << 13);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 277 to 292
	value = ((uint32_t)(input[34] & 0x07) << 29) |
			((uint32_t)input[35] << 21) |
			((uint32_t)(input[36] & 0xf8) << 13);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 293 to 308
	value = ((uint32_t)(input[36] & 0x07) << 29) |
			((uint32_t)input[37] << 21) |
			((uint32_t)(input[38] & 0xf8) << 13);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 309 to 324
	value = ((uint32_t)(input[38] & 0x07) << 29) |
			((uint32_t)input[39] << 21) |
			((uint32_t)(input[40] & 0xf8) << 13);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 325 to 340
	value = ((uint32_t)(input[40] & 0x07) << 29) |
			((uint32_t)input[41] << 21) |
			((uint32_t)(input[42] & 0xf8) << 13);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 341 to 356
	value = ((uint32_t)(input[42] & 0x07) << 29) |
			((uint32_t)input[43] << 21) |
			((uint32_t)(input[44] & 0xf8) << 13);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 357 to 372
	value = ((uint32_t)(input[44] & 0x07) << 29) |
			((uint32_t)input[45] << 21) |
			((uint32_t)(input[46] & 0xf8) << 13);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 373 to 388
	value = ((uint32_t)(input[46] & 0x07) << 29) |
			((uint32_t)input[47] << 21) |
			((uint32_t)(input[48] & 0xf8) << 13);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 389 to 404
	value = ((uint32_t)(input[48] & 0x07) << 29) |
			((uint32_t)input[49] << 21) |
			((uint32_t)(input[50] & 0xf8) << 13);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 405 to 420
	value = ((uint32_t)(input[50] & 0x07) << 29) |
			((uint32_t)input[51] << 21) |
			((uint32_t)(input[52] & 0xf8) << 13);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 421 to 436
	value = ((uint32_t)(input[52] & 0x07) << 29) |
			((uint32_t)input[53] << 21) |
			((uint32_t)(input[54] & 0xf8) << 13);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 437 to 452
	value = ((uint32_t)(input[54] & 0x07) << 29) |
			((uint32_t)input[55] << 21) |
			((uint32_t)(input[56] & 0xf8) << 13);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 453 to 468
	value = ((uint32_t)(input[56] & 0x07) << 29) |
			((uint32_t)input[57] << 21) |
			((uint32_t)(input[58] & 0xf8) << 13);
	output[28] = (double)(value >> 16);
}

static void unpack_29_16bit_unsigned_5off(const uint8_t * input, double * output, void *closure) {
	// Unpack 29 values into output
	// Values are 16-bit unsigned
	// Skip 5 bits, read 464 bits of data.
	// Input must be at least 59 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 5 to 20
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)(input[2] & 0xf8) << 13);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 21 to 36
	value = ((uint32_t)(input[2] & 0x07) << 29) |
			((uint32_t)input[3] << 21) |
			((uint32_t)(input[4] & 0xf8) << 13);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 37 to 52
	value = ((uint32_t)(input[4] & 0x07) << 29) |
			((uint32_t)input[5] << 21) |
			((uint32_t)(input[6] & 0xf8) << 13);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 53 to 68
	value = ((uint32_t)(input[6] & 0x07) << 29) |
			((uint32_t)input[7] << 21) |
			((uint32_t)(input[8] & 0xf8) << 13);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 69 to 84
	value = ((uint32_t)(input[8] & 0x07) << 29) |
			((uint32_t)input[9] << 21) |
			((uint32_t)(input[10] & 0xf8) << 13);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 85 to 100
	value = ((uint32_t)(input[10] & 0x07) << 29) |
			((uint32_t)input[11] << 21) |
			((uint32_t)(input[12] & 0xf8) << 13);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 101 to 116
	value = ((uint32_t)(input[12] & 0x07) << 29) |
			((uint32_t)input[13] << 21) |
			((uint32_t)(input[14] & 0xf8) << 13);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 117 to 132
	value = ((uint32_t)(input[14] & 0x07) << 29) |
			((uint32_t)input[15] << 21) |
			((uint32_t)(input[16] & 0xf8) << 13);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 133 to 148
	value = ((uint32_t)(input[16] & 0x07) << 29) |
			((uint32_t)input[17] << 21) |
			((uint32_t)(input[18] & 0xf8) << 13);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 149 to 164
	value = ((uint32_t)(input[18] & 0x07) << 29) |
			((uint32_t)input[19] << 21) |
			((uint32_t)(input[20] & 0xf8) << 13);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 165 to 180
	value = ((uint32_t)(input[20] & 0x07) << 29) |
			((uint32_t)input[21] << 21) |
			((uint32_t)(input[22] & 0xf8) << 13);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 181 to 196
	value = ((uint32_t)(input[22] & 0x07) << 29) |
			((uint32_t)input[23] << 21) |
			((uint32_t)(input[24] & 0xf8) << 13);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 197 to 212
	value = ((uint32_t)(input[24] & 0x07) << 29) |
			((uint32_t)input[25] << 21) |
			((uint32_t)(input[26] & 0xf8) << 13);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 213 to 228
	value = ((uint32_t)(input[26] & 0x07) << 29) |
			((uint32_t)input[27] << 21) |
			((uint32_t)(input[28] & 0xf8) << 13);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 229 to 244
	value = ((uint32_t)(input[28] & 0x07) << 29) |
			((uint32_t)input[29] << 21) |
			((uint32_t)(input[30] & 0xf8) << 13);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 245 to 260
	value = ((uint32_t)(input[30] & 0x07) << 29) |
			((uint32_t)input[31] << 21) |
			((uint32_t)(input[32] & 0xf8) << 13);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 261 to 276
	value = ((uint32_t)(input[32] & 0x07) << 29) |
			((uint32_t)input[33] << 21) |
			((uint32_t)(input[34] & 0xf8) << 13);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 277 to 292
	value = ((uint32_t)(input[34] & 0x07) << 29) |
			((uint32_t)input[35] << 21) |
			((uint32_t)(input[36] & 0xf8) << 13);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 293 to 308
	value = ((uint32_t)(input[36] & 0x07) << 29) |
			((uint32_t)input[37] << 21) |
			((uint32_t)(input[38] & 0xf8) << 13);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 309 to 324
	value = ((uint32_t)(input[38] & 0x07) << 29) |
			((uint32_t)input[39] << 21) |
			((uint32_t)(input[40] & 0xf8) << 13);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 325 to 340
	value = ((uint32_t)(input[40] & 0x07) << 29) |
			((uint32_t)input[41] << 21) |
			((uint32_t)(input[42] & 0xf8) << 13);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 341 to 356
	value = ((uint32_t)(input[42] & 0x07) << 29) |
			((uint32_t)input[43] << 21) |
			((uint32_t)(input[44] & 0xf8) << 13);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 357 to 372
	value = ((uint32_t)(input[44] & 0x07) << 29) |
			((uint32_t)input[45] << 21) |
			((uint32_t)(input[46] & 0xf8) << 13);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 373 to 388
	value = ((uint32_t)(input[46] & 0x07) << 29) |
			((uint32_t)input[47] << 21) |
			((uint32_t)(input[48] & 0xf8) << 13);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 389 to 404
	value = ((uint32_t)(input[48] & 0x07) << 29) |
			((uint32_t)input[49] << 21) |
			((uint32_t)(input[50] & 0xf8) << 13);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 405 to 420
	value = ((uint32_t)(input[50] & 0x07) << 29) |
			((uint32_t)input[51] << 21) |
			((uint32_t)(input[52] & 0xf8) << 13);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 421 to 436
	value = ((uint32_t)(input[52] & 0x07) << 29) |
			((uint32_t)input[53] << 21) |
			((uint32_t)(input[54] & 0xf8) << 13);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 437 to 452
	value = ((uint32_t)(input[54] & 0x07) << 29) |
			((uint32_t)input[55] << 21) |
			((uint32_t)(input[56] & 0xf8) << 13);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 453 to 468
	value = ((uint32_t)(input[56] & 0x07) << 29) |
			((uint32_t)input[57] << 21) |
			((uint32_t)(input[58] & 0xf8) << 13);
	output[28] = (double)(value >> 16);
}

static void unpack_29_16bit_signed_6off(const uint8_t * input, double * output, void *closure) {
	// Unpack 29 values into output
	// Values are 16-bit signed
	// Skip 6 bits, read 464 bits of data.
	// Input must be at least 59 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 6 to 21
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)(input[2] & 0xfc) << 14);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 22 to 37
	value = ((uint32_t)(input[2] & 0x03) << 30) |
			((uint32_t)input[3] << 22) |
			((uint32_t)(input[4] & 0xfc) << 14);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 38 to 53
	value = ((uint32_t)(input[4] & 0x03) << 30) |
			((uint32_t)input[5] << 22) |
			((uint32_t)(input[6] & 0xfc) << 14);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 54 to 69
	value = ((uint32_t)(input[6] & 0x03) << 30) |
			((uint32_t)input[7] << 22) |
			((uint32_t)(input[8] & 0xfc) << 14);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 70 to 85
	value = ((uint32_t)(input[8] & 0x03) << 30) |
			((uint32_t)input[9] << 22) |
			((uint32_t)(input[10] & 0xfc) << 14);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 86 to 101
	value = ((uint32_t)(input[10] & 0x03) << 30) |
			((uint32_t)input[11] << 22) |
			((uint32_t)(input[12] & 0xfc) << 14);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 102 to 117
	value = ((uint32_t)(input[12] & 0x03) << 30) |
			((uint32_t)input[13] << 22) |
			((uint32_t)(input[14] & 0xfc) << 14);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 118 to 133
	value = ((uint32_t)(input[14] & 0x03) << 30) |
			((uint32_t)input[15] << 22) |
			((uint32_t)(input[16] & 0xfc) << 14);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 134 to 149
	value = ((uint32_t)(input[16] & 0x03) << 30) |
			((uint32_t)input[17] << 22) |
			((uint32_t)(input[18] & 0xfc) << 14);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 150 to 165
	value = ((uint32_t)(input[18] & 0x03) << 30) |
			((uint32_t)input[19] << 22) |
			((uint32_t)(input[20] & 0xfc) << 14);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 166 to 181
	value = ((uint32_t)(input[20] & 0x03) << 30) |
			((uint32_t)input[21] << 22) |
			((uint32_t)(input[22] & 0xfc) << 14);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 182 to 197
	value = ((uint32_t)(input[22] & 0x03) << 30) |
			((uint32_t)input[23] << 22) |
			((uint32_t)(input[24] & 0xfc) << 14);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 198 to 213
	value = ((uint32_t)(input[24] & 0x03) << 30) |
			((uint32_t)input[25] << 22) |
			((uint32_t)(input[26] & 0xfc) << 14);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 214 to 229
	value = ((uint32_t)(input[26] & 0x03) << 30) |
			((uint32_t)input[27] << 22) |
			((uint32_t)(input[28] & 0xfc) << 14);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 230 to 245
	value = ((uint32_t)(input[28] & 0x03) << 30) |
			((uint32_t)input[29] << 22) |
			((uint32_t)(input[30] & 0xfc) << 14);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 246 to 261
	value = ((uint32_t)(input[30] & 0x03) << 30) |
			((uint32_t)input[31] << 22) |
			((uint32_t)(input[32] & 0xfc) << 14);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 262 to 277
	value = ((uint32_t)(input[32] & 0x03) << 30) |
			((uint32_t)input[33] << 22) |
			((uint32_t)(input[34] & 0xfc) << 14);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 278 to 293
	value = ((uint32_t)(input[34] & 0x03) << 30) |
			((uint32_t)input[35] << 22) |
			((uint32_t)(input[36] & 0xfc) << 14);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 294 to 309
	value = ((uint32_t)(input[36] & 0x03) << 30) |
			((uint32_t)input[37] << 22) |
			((uint32_t)(input[38] & 0xfc) << 14);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 310 to 325
	value = ((uint32_t)(input[38] & 0x03) << 30) |
			((uint32_t)input[39] << 22) |
			((uint32_t)(input[40] & 0xfc) << 14);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 326 to 341
	value = ((uint32_t)(input[40] & 0x03) << 30) |
			((uint32_t)input[41] << 22) |
			((uint32_t)(input[42] & 0xfc) << 14);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 342 to 357
	value = ((uint32_t)(input[42] & 0x03) << 30) |
			((uint32_t)input[43] << 22) |
			((uint32_t)(input[44] & 0xfc) << 14);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 358 to 373
	value = ((uint32_t)(input[44] & 0x03) << 30) |
			((uint32_t)input[45] << 22) |
			((uint32_t)(input[46] & 0xfc) << 14);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 374 to 389
	value = ((uint32_t)(input[46] & 0x03) << 30) |
			((uint32_t)input[47] << 22) |
			((uint32_t)(input[48] & 0xfc) << 14);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 390 to 405
	value = ((uint32_t)(input[48] & 0x03) << 30) |
			((uint32_t)input[49] << 22) |
			((uint32_t)(input[50] & 0xfc) << 14);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 406 to 421
	value = ((uint32_t)(input[50] & 0x03) << 30) |
			((uint32_t)input[51] << 22) |
			((uint32_t)(input[52] & 0xfc) << 14);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 422 to 437
	value = ((uint32_t)(input[52] & 0x03) << 30) |
			((uint32_t)input[53] << 22) |
			((uint32_t)(input[54] & 0xfc) << 14);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 438 to 453
	value = ((uint32_t)(input[54] & 0x03) << 30) |
			((uint32_t)input[55] << 22) |
			((uint32_t)(input[56] & 0xfc) << 14);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 454 to 469
	value = ((uint32_t)(input[56] & 0x03) << 30) |
			((uint32_t)input[57] << 22) |
			((uint32_t)(input[58] & 0xfc) << 14);
	output[28] = (double)(value >> 16);
}

static void unpack_29_16bit_unsigned_6off(const uint8_t * input, double * output, void *closure) {
	// Unpack 29 values into output
	// Values are 16-bit unsigned
	// Skip 6 bits, read 464 bits of data.
	// Input must be at least 59 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 6 to 21
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)(input[2] & 0xfc) << 14);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 22 to 37
	value = ((uint32_t)(input[2] & 0x03) << 30) |
			((uint32_t)input[3] << 22) |
			((uint32_t)(input[4] & 0xfc) << 14);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 38 to 53
	value = ((uint32_t)(input[4] & 0x03) << 30) |
			((uint32_t)input[5] << 22) |
			((uint32_t)(input[6] & 0xfc) << 14);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 54 to 69
	value = ((uint32_t)(input[6] & 0x03) << 30) |
			((uint32_t)input[7] << 22) |
			((uint32_t)(input[8] & 0xfc) << 14);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 70 to 85
	value = ((uint32_t)(input[8] & 0x03) << 30) |
			((uint32_t)input[9] << 22) |
			((uint32_t)(input[10] & 0xfc) << 14);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 86 to 101
	value = ((uint32_t)(input[10] & 0x03) << 30) |
			((uint32_t)input[11] << 22) |
			((uint32_t)(input[12] & 0xfc) << 14);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 102 to 117
	value = ((uint32_t)(input[12] & 0x03) << 30) |
			((uint32_t)input[13] << 22) |
			((uint32_t)(input[14] & 0xfc) << 14);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 118 to 133
	value = ((uint32_t)(input[14] & 0x03) << 30) |
			((uint32_t)input[15] << 22) |
			((uint32_t)(input[16] & 0xfc) << 14);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 134 to 149
	value = ((uint32_t)(input[16] & 0x03) << 30) |
			((uint32_t)input[17] << 22) |
			((uint32_t)(input[18] & 0xfc) << 14);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 150 to 165
	value = ((uint32_t)(input[18] & 0x03) << 30) |
			((uint32_t)input[19] << 22) |
			((uint32_t)(input[20] & 0xfc) << 14);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 166 to 181
	value = ((uint32_t)(input[20] & 0x03) << 30) |
			((uint32_t)input[21] << 22) |
			((uint32_t)(input[22] & 0xfc) << 14);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 182 to 197
	value = ((uint32_t)(input[22] & 0x03) << 30) |
			((uint32_t)input[23] << 22) |
			((uint32_t)(input[24] & 0xfc) << 14);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 198 to 213
	value = ((uint32_t)(input[24] & 0x03) << 30) |
			((uint32_t)input[25] << 22) |
			((uint32_t)(input[26] & 0xfc) << 14);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 214 to 229
	value = ((uint32_t)(input[26] & 0x03) << 30) |
			((uint32_t)input[27] << 22) |
			((uint32_t)(input[28] & 0xfc) << 14);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 230 to 245
	value = ((uint32_t)(input[28] & 0x03) << 30) |
			((uint32_t)input[29] << 22) |
			((uint32_t)(input[30] & 0xfc) << 14);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 246 to 261
	value = ((uint32_t)(input[30] & 0x03) << 30) |
			((uint32_t)input[31] << 22) |
			((uint32_t)(input[32] & 0xfc) << 14);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 262 to 277
	value = ((uint32_t)(input[32] & 0x03) << 30) |
			((uint32_t)input[33] << 22) |
			((uint32_t)(input[34] & 0xfc) << 14);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 278 to 293
	value = ((uint32_t)(input[34] & 0x03) << 30) |
			((uint32_t)input[35] << 22) |
			((uint32_t)(input[36] & 0xfc) << 14);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 294 to 309
	value = ((uint32_t)(input[36] & 0x03) << 30) |
			((uint32_t)input[37] << 22) |
			((uint32_t)(input[38] & 0xfc) << 14);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 310 to 325
	value = ((uint32_t)(input[38] & 0x03) << 30) |
			((uint32_t)input[39] << 22) |
			((uint32_t)(input[40] & 0xfc) << 14);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 326 to 341
	value = ((uint32_t)(input[40] & 0x03) << 30) |
			((uint32_t)input[41] << 22) |
			((uint32_t)(input[42] & 0xfc) << 14);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 342 to 357
	value = ((uint32_t)(input[42] & 0x03) << 30) |
			((uint32_t)input[43] << 22) |
			((uint32_t)(input[44] & 0xfc) << 14);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 358 to 373
	value = ((uint32_t)(input[44] & 0x03) << 30) |
			((uint32_t)input[45] << 22) |
			((uint32_t)(input[46] & 0xfc) << 14);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 374 to 389
	value = ((uint32_t)(input[46] & 0x03) << 30) |
			((uint32_t)input[47] << 22) |
			((uint32_t)(input[48] & 0xfc) << 14);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 390 to 405
	value = ((uint32_t)(input[48] & 0x03) << 30) |
			((uint32_t)input[49] << 22) |
			((uint32_t)(input[50] & 0xfc) << 14);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 406 to 421
	value = ((uint32_t)(input[50] & 0x03) << 30) |
			((uint32_t)input[51] << 22) |
			((uint32_t)(input[52] & 0xfc) << 14);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 422 to 437
	value = ((uint32_t)(input[52] & 0x03) << 30) |
			((uint32_t)input[53] << 22) |
			((uint32_t)(input[54] & 0xfc) << 14);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 438 to 453
	value = ((uint32_t)(input[54] & 0x03) << 30) |
			((uint32_t)input[55] << 22) |
			((uint32_t)(input[56] & 0xfc) << 14);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 454 to 469
	value = ((uint32_t)(input[56] & 0x03) << 30) |
			((uint32_t)input[57] << 22) |
			((uint32_t)(input[58] & 0xfc) << 14);
	output[28] = (double)(value >> 16);
}

static void unpack_29_16bit_signed_7off(const uint8_t * input, double * output, void *closure) {
	// Unpack 29 values into output
	// Values are 16-bit signed
	// Skip 7 bits, read 464 bits of data.
	// Input must be at least 59 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 7 to 22
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)(input[2] & 0xfe) << 15);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 23 to 38
	value = ((uint32_t)(input[2] & 0x01) << 31) |
			((uint32_t)input[3] << 23) |
			((uint32_t)(input[4] & 0xfe) << 15);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 39 to 54
	value = ((uint32_t)(input[4] & 0x01) << 31) |
			((uint32_t)input[5] << 23) |
			((uint32_t)(input[6] & 0xfe) << 15);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 55 to 70
	value = ((uint32_t)(input[6] & 0x01) << 31) |
			((uint32_t)input[7] << 23) |
			((uint32_t)(input[8] & 0xfe) << 15);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 71 to 86
	value = ((uint32_t)(input[8] & 0x01) << 31) |
			((uint32_t)input[9] << 23) |
			((uint32_t)(input[10] & 0xfe) << 15);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 87 to 102
	value = ((uint32_t)(input[10] & 0x01) << 31) |
			((uint32_t)input[11] << 23) |
			((uint32_t)(input[12] & 0xfe) << 15);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 103 to 118
	value = ((uint32_t)(input[12] & 0x01) << 31) |
			((uint32_t)input[13] << 23) |
			((uint32_t)(input[14] & 0xfe) << 15);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 119 to 134
	value = ((uint32_t)(input[14] & 0x01) << 31) |
			((uint32_t)input[15] << 23) |
			((uint32_t)(input[16] & 0xfe) << 15);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 135 to 150
	value = ((uint32_t)(input[16] & 0x01) << 31) |
			((uint32_t)input[17] << 23) |
			((uint32_t)(input[18] & 0xfe) << 15);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 151 to 166
	value = ((uint32_t)(input[18] & 0x01) << 31) |
			((uint32_t)input[19] << 23) |
			((uint32_t)(input[20] & 0xfe) << 15);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 167 to 182
	value = ((uint32_t)(input[20] & 0x01) << 31) |
			((uint32_t)input[21] << 23) |
			((uint32_t)(input[22] & 0xfe) << 15);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 183 to 198
	value = ((uint32_t)(input[22] & 0x01) << 31) |
			((uint32_t)input[23] << 23) |
			((uint32_t)(input[24] & 0xfe) << 15);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 199 to 214
	value = ((uint32_t)(input[24] & 0x01) << 31) |
			((uint32_t)input[25] << 23) |
			((uint32_t)(input[26] & 0xfe) << 15);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 215 to 230
	value = ((uint32_t)(input[26] & 0x01) << 31) |
			((uint32_t)input[27] << 23) |
			((uint32_t)(input[28] & 0xfe) << 15);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 231 to 246
	value = ((uint32_t)(input[28] & 0x01) << 31) |
			((uint32_t)input[29] << 23) |
			((uint32_t)(input[30] & 0xfe) << 15);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 247 to 262
	value = ((uint32_t)(input[30] & 0x01) << 31) |
			((uint32_t)input[31] << 23) |
			((uint32_t)(input[32] & 0xfe) << 15);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 263 to 278
	value = ((uint32_t)(input[32] & 0x01) << 31) |
			((uint32_t)input[33] << 23) |
			((uint32_t)(input[34] & 0xfe) << 15);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 279 to 294
	value = ((uint32_t)(input[34] & 0x01) << 31) |
			((uint32_t)input[35] << 23) |
			((uint32_t)(input[36] & 0xfe) << 15);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 295 to 310
	value = ((uint32_t)(input[36] & 0x01) << 31) |
			((uint32_t)input[37] << 23) |
			((uint32_t)(input[38] & 0xfe) << 15);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 311 to 326
	value = ((uint32_t)(input[38] & 0x01) << 31) |
			((uint32_t)input[39] << 23) |
			((uint32_t)(input[40] & 0xfe) << 15);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 327 to 342
	value = ((uint32_t)(input[40] & 0x01) << 31) |
			((uint32_t)input[41] << 23) |
			((uint32_t)(input[42] & 0xfe) << 15);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 343 to 358
	value = ((uint32_t)(input[42] & 0x01) << 31) |
			((uint32_t)input[43] << 23) |
			((uint32_t)(input[44] & 0xfe) << 15);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 359 to 374
	value = ((uint32_t)(input[44] & 0x01) << 31) |
			((uint32_t)input[45] << 23) |
			((uint32_t)(input[46] & 0xfe) << 15);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 375 to 390
	value = ((uint32_t)(input[46] & 0x01) << 31) |
			((uint32_t)input[47] << 23) |
			((uint32_t)(input[48] & 0xfe) << 15);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 391 to 406
	value = ((uint32_t)(input[48] & 0x01) << 31) |
			((uint32_t)input[49] << 23) |
			((uint32_t)(input[50] & 0xfe) << 15);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 407 to 422
	value = ((uint32_t)(input[50] & 0x01) << 31) |
			((uint32_t)input[51] << 23) |
			((uint32_t)(input[52] & 0xfe) << 15);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 423 to 438
	value = ((uint32_t)(input[52] & 0x01) << 31) |
			((uint32_t)input[53] << 23) |
			((uint32_t)(input[54] & 0xfe) << 15);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 439 to 454
	value = ((uint32_t)(input[54] & 0x01) << 31) |
			((uint32_t)input[55] << 23) |
			((uint32_t)(input[56] & 0xfe) << 15);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 455 to 470
	value = ((uint32_t)(input[56] & 0x01) << 31) |
			((uint32_t)input[57] << 23) |
			((uint32_t)(input[58] & 0xfe) << 15);
	output[28] = (double)(value >> 16);
}

static void unpack_29_16bit_unsigned_7off(const uint8_t * input, double * output, void *closure) {
	// Unpack 29 values into output
	// Values are 16-bit unsigned
	// Skip 7 bits, read 464 bits of data.
	// Input must be at least 59 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 7 to 22
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)(input[2] & 0xfe) << 15);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 23 to 38
	value = ((uint32_t)(input[2] & 0x01) << 31) |
			((uint32_t)input[3] << 23) |
			((uint32_t)(input[4] & 0xfe) << 15);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 39 to 54
	value = ((uint32_t)(input[4] & 0x01) << 31) |
			((uint32_t)input[5] << 23) |
			((uint32_t)(input[6] & 0xfe) << 15);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 55 to 70
	value = ((uint32_t)(input[6] & 0x01) << 31) |
			((uint32_t)input[7] << 23) |
			((uint32_t)(input[8] & 0xfe) << 15);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 71 to 86
	value = ((uint32_t)(input[8] & 0x01) << 31) |
			((uint32_t)input[9] << 23) |
			((uint32_t)(input[10] & 0xfe) << 15);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 87 to 102
	value = ((uint32_t)(input[10] & 0x01) << 31) |
			((uint32_t)input[11] << 23) |
			((uint32_t)(input[12] & 0xfe) << 15);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 103 to 118
	value = ((uint32_t)(input[12] & 0x01) << 31) |
			((uint32_t)input[13] << 23) |
			((uint32_t)(input[14] & 0xfe) << 15);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 119 to 134
	value = ((uint32_t)(input[14] & 0x01) << 31) |
			((uint32_t)input[15] << 23) |
			((uint32_t)(input[16] & 0xfe) << 15);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 135 to 150
	value = ((uint32_t)(input[16] & 0x01) << 31) |
			((uint32_t)input[17] << 23) |
			((uint32_t)(input[18] & 0xfe) << 15);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 151 to 166
	value = ((uint32_t)(input[18] & 0x01) << 31) |
			((uint32_t)input[19] << 23) |
			((uint32_t)(input[20] & 0xfe) << 15);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 167 to 182
	value = ((uint32_t)(input[20] & 0x01) << 31) |
			((uint32_t)input[21] << 23) |
			((uint32_t)(input[22] & 0xfe) << 15);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 183 to 198
	value = ((uint32_t)(input[22] & 0x01) << 31) |
			((uint32_t)input[23] << 23) |
			((uint32_t)(input[24] & 0xfe) << 15);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 199 to 214
	value = ((uint32_t)(input[24] & 0x01) << 31) |
			((uint32_t)input[25] << 23) |
			((uint32_t)(input[26] & 0xfe) << 15);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 215 to 230
	value = ((uint32_t)(input[26] & 0x01) << 31) |
			((uint32_t)input[27] << 23) |
			((uint32_t)(input[28] & 0xfe) << 15);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 231 to 246
	value = ((uint32_t)(input[28] & 0x01) << 31) |
			((uint32_t)input[29] << 23) |
			((uint32_t)(input[30] & 0xfe) << 15);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 247 to 262
	value = ((uint32_t)(input[30] & 0x01) << 31) |
			((uint32_t)input[31] << 23) |
			((uint32_t)(input[32] & 0xfe) << 15);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 263 to 278
	value = ((uint32_t)(input[32] & 0x01) << 31) |
			((uint32_t)input[33] << 23) |
			((uint32_t)(input[34] & 0xfe) << 15);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 279 to 294
	value = ((uint32_t)(input[34] & 0x01) << 31) |
			((uint32_t)input[35] << 23) |
			((uint32_t)(input[36] & 0xfe) << 15);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 295 to 310
	value = ((uint32_t)(input[36] & 0x01) << 31) |
			((uint32_t)input[37] << 23) |
			((uint32_t)(input[38] & 0xfe) << 15);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 311 to 326
	value = ((uint32_t)(input[38] & 0x01) << 31) |
			((uint32_t)input[39] << 23) |
			((uint32_t)(input[40] & 0xfe) << 15);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 327 to 342
	value = ((uint32_t)(input[40] & 0x01) << 31) |
			((uint32_t)input[41] << 23) |
			((uint32_t)(input[42] & 0xfe) << 15);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 343 to 358
	value = ((uint32_t)(input[42] & 0x01) << 31) |
			((uint32_t)input[43] << 23) |
			((uint32_t)(input[44] & 0xfe) << 15);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 359 to 374
	value = ((uint32_t)(input[44] & 0x01) << 31) |
			((uint32_t)input[45] << 23) |
			((uint32_t)(input[46] & 0xfe) << 15);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 375 to 390
	value = ((uint32_t)(input[46] & 0x01) << 31) |
			((uint32_t)input[47] << 23) |
			((uint32_t)(input[48] & 0xfe) << 15);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 391 to 406
	value = ((uint32_t)(input[48] & 0x01) << 31) |
			((uint32_t)input[49] << 23) |
			((uint32_t)(input[50] & 0xfe) << 15);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 407 to 422
	value = ((uint32_t)(input[50] & 0x01) << 31) |
			((uint32_t)input[51] << 23) |
			((uint32_t)(input[52] & 0xfe) << 15);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 423 to 438
	value = ((uint32_t)(input[52] & 0x01) << 31) |
			((uint32_t)input[53] << 23) |
			((uint32_t)(input[54] & 0xfe) << 15);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 439 to 454
	value = ((uint32_t)(input[54] & 0x01) << 31) |
			((uint32_t)input[55] << 23) |
			((uint32_t)(input[56] & 0xfe) << 15);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 455 to 470
	value = ((uint32_t)(input[56] & 0x01) << 31) |
			((uint32_t)input[57] << 23) |
			((uint32_t)(input[58] & 0xfe) << 15);
	output[28] = (double)(value >> 16);
}

static void unpack_30_16bit_signed_0off(const uint8_t * input, double * output, void *closure) {
	// Unpack 30 values into output
	// Values are 16-bit signed
	// Skip 0 bits, read 480 bits of data.
	// Input must be at least 60 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 0 to 15
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)input[1] << 16);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 16 to 31
	value = ((uint32_t)input[2] << 24) |
			((uint32_t)input[3] << 16);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 32 to 47
	value = ((uint32_t)input[4] << 24) |
			((uint32_t)input[5] << 16);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 48 to 63
	value = ((uint32_t)input[6] << 24) |
			((uint32_t)input[7] << 16);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 64 to 79
	value = ((uint32_t)input[8] << 24) |
			((uint32_t)input[9] << 16);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 80 to 95
	value = ((uint32_t)input[10] << 24) |
			((uint32_t)input[11] << 16);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 96 to 111
	value = ((uint32_t)input[12] << 24) |
			((uint32_t)input[13] << 16);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 112 to 127
	value = ((uint32_t)input[14] << 24) |
			((uint32_t)input[15] << 16);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 128 to 143
	value = ((uint32_t)input[16] << 24) |
			((uint32_t)input[17] << 16);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 144 to 159
	value = ((uint32_t)input[18] << 24) |
			((uint32_t)input[19] << 16);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 160 to 175
	value = ((uint32_t)input[20] << 24) |
			((uint32_t)input[21] << 16);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 176 to 191
	value = ((uint32_t)input[22] << 24) |
			((uint32_t)input[23] << 16);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 192 to 207
	value = ((uint32_t)input[24] << 24) |
			((uint32_t)input[25] << 16);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 208 to 223
	value = ((uint32_t)input[26] << 24) |
			((uint32_t)input[27] << 16);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 224 to 239
	value = ((uint32_t)input[28] << 24) |
			((uint32_t)input[29] << 16);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 240 to 255
	value = ((uint32_t)input[30] << 24) |
			((uint32_t)input[31] << 16);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 256 to 271
	value = ((uint32_t)input[32] << 24) |
			((uint32_t)input[33] << 16);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 272 to 287
	value = ((uint32_t)input[34] << 24) |
			((uint32_t)input[35] << 16);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 288 to 303
	value = ((uint32_t)input[36] << 24) |
			((uint32_t)input[37] << 16);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 304 to 319
	value = ((uint32_t)input[38] << 24) |
			((uint32_t)input[39] << 16);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 320 to 335
	value = ((uint32_t)input[40] << 24) |
			((uint32_t)input[41] << 16);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 336 to 351
	value = ((uint32_t)input[42] << 24) |
			((uint32_t)input[43] << 16);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 352 to 367
	value = ((uint32_t)input[44] << 24) |
			((uint32_t)input[45] << 16);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 368 to 383
	value = ((uint32_t)input[46] << 24) |
			((uint32_t)input[47] << 16);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 384 to 399
	value = ((uint32_t)input[48] << 24) |
			((uint32_t)input[49] << 16);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 400 to 415
	value = ((uint32_t)input[50] << 24) |
			((uint32_t)input[51] << 16);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 416 to 431
	value = ((uint32_t)input[52] << 24) |
			((uint32_t)input[53] << 16);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 432 to 447
	value = ((uint32_t)input[54] << 24) |
			((uint32_t)input[55] << 16);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 448 to 463
	value = ((uint32_t)input[56] << 24) |
			((uint32_t)input[57] << 16);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 464 to 479
	value = ((uint32_t)input[58] << 24) |
			((uint32_t)input[59] << 16);
	output[29] = (double)(value >> 16);
}

static void unpack_30_16bit_unsigned_0off(const uint8_t * input, double * output, void *closure) {
	// Unpack 30 values into output
	// Values are 16-bit unsigned
	// Skip 0 bits, read 480 bits of data.
	// Input must be at least 60 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 0 to 15
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)input[1] << 16);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 16 to 31
	value = ((uint32_t)input[2] << 24) |
			((uint32_t)input[3] << 16);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 32 to 47
	value = ((uint32_t)input[4] << 24) |
			((uint32_t)input[5] << 16);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 48 to 63
	value = ((uint32_t)input[6] << 24) |
			((uint32_t)input[7] << 16);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 64 to 79
	value = ((uint32_t)input[8] << 24) |
			((uint32_t)input[9] << 16);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 80 to 95
	value = ((uint32_t)input[10] << 24) |
			((uint32_t)input[11] << 16);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 96 to 111
	value = ((uint32_t)input[12] << 24) |
			((uint32_t)input[13] << 16);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 112 to 127
	value = ((uint32_t)input[14] << 24) |
			((uint32_t)input[15] << 16);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 128 to 143
	value = ((uint32_t)input[16] << 24) |
			((uint32_t)input[17] << 16);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 144 to 159
	value = ((uint32_t)input[18] << 24) |
			((uint32_t)input[19] << 16);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 160 to 175
	value = ((uint32_t)input[20] << 24) |
			((uint32_t)input[21] << 16);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 176 to 191
	value = ((uint32_t)input[22] << 24) |
			((uint32_t)input[23] << 16);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 192 to 207
	value = ((uint32_t)input[24] << 24) |
			((uint32_t)input[25] << 16);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 208 to 223
	value = ((uint32_t)input[26] << 24) |
			((uint32_t)input[27] << 16);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 224 to 239
	value = ((uint32_t)input[28] << 24) |
			((uint32_t)input[29] << 16);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 240 to 255
	value = ((uint32_t)input[30] << 24) |
			((uint32_t)input[31] << 16);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 256 to 271
	value = ((uint32_t)input[32] << 24) |
			((uint32_t)input[33] << 16);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 272 to 287
	value = ((uint32_t)input[34] << 24) |
			((uint32_t)input[35] << 16);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 288 to 303
	value = ((uint32_t)input[36] << 24) |
			((uint32_t)input[37] << 16);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 304 to 319
	value = ((uint32_t)input[38] << 24) |
			((uint32_t)input[39] << 16);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 320 to 335
	value = ((uint32_t)input[40] << 24) |
			((uint32_t)input[41] << 16);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 336 to 351
	value = ((uint32_t)input[42] << 24) |
			((uint32_t)input[43] << 16);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 352 to 367
	value = ((uint32_t)input[44] << 24) |
			((uint32_t)input[45] << 16);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 368 to 383
	value = ((uint32_t)input[46] << 24) |
			((uint32_t)input[47] << 16);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 384 to 399
	value = ((uint32_t)input[48] << 24) |
			((uint32_t)input[49] << 16);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 400 to 415
	value = ((uint32_t)input[50] << 24) |
			((uint32_t)input[51] << 16);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 416 to 431
	value = ((uint32_t)input[52] << 24) |
			((uint32_t)input[53] << 16);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 432 to 447
	value = ((uint32_t)input[54] << 24) |
			((uint32_t)input[55] << 16);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 448 to 463
	value = ((uint32_t)input[56] << 24) |
			((uint32_t)input[57] << 16);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 464 to 479
	value = ((uint32_t)input[58] << 24) |
			((uint32_t)input[59] << 16);
	output[29] = (double)(value >> 16);
}

static void unpack_30_16bit_signed_1off(const uint8_t * input, double * output, void *closure) {
	// Unpack 30 values into output
	// Values are 16-bit signed
	// Skip 1 bits, read 480 bits of data.
	// Input must be at least 61 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 1 to 16
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)input[1] << 17) |
			((uint32_t)(input[2] & 0x80) << 9);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 17 to 32
	value = ((uint32_t)(input[2] & 0x7f) << 25) |
			((uint32_t)input[3] << 17) |
			((uint32_t)(input[4] & 0x80) << 9);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 33 to 48
	value = ((uint32_t)(input[4] & 0x7f) << 25) |
			((uint32_t)input[5] << 17) |
			((uint32_t)(input[6] & 0x80) << 9);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 49 to 64
	value = ((uint32_t)(input[6] & 0x7f) << 25) |
			((uint32_t)input[7] << 17) |
			((uint32_t)(input[8] & 0x80) << 9);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 65 to 80
	value = ((uint32_t)(input[8] & 0x7f) << 25) |
			((uint32_t)input[9] << 17) |
			((uint32_t)(input[10] & 0x80) << 9);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 81 to 96
	value = ((uint32_t)(input[10] & 0x7f) << 25) |
			((uint32_t)input[11] << 17) |
			((uint32_t)(input[12] & 0x80) << 9);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 97 to 112
	value = ((uint32_t)(input[12] & 0x7f) << 25) |
			((uint32_t)input[13] << 17) |
			((uint32_t)(input[14] & 0x80) << 9);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 113 to 128
	value = ((uint32_t)(input[14] & 0x7f) << 25) |
			((uint32_t)input[15] << 17) |
			((uint32_t)(input[16] & 0x80) << 9);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 129 to 144
	value = ((uint32_t)(input[16] & 0x7f) << 25) |
			((uint32_t)input[17] << 17) |
			((uint32_t)(input[18] & 0x80) << 9);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 145 to 160
	value = ((uint32_t)(input[18] & 0x7f) << 25) |
			((uint32_t)input[19] << 17) |
			((uint32_t)(input[20] & 0x80) << 9);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 161 to 176
	value = ((uint32_t)(input[20] & 0x7f) << 25) |
			((uint32_t)input[21] << 17) |
			((uint32_t)(input[22] & 0x80) << 9);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 177 to 192
	value = ((uint32_t)(input[22] & 0x7f) << 25) |
			((uint32_t)input[23] << 17) |
			((uint32_t)(input[24] & 0x80) << 9);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 193 to 208
	value = ((uint32_t)(input[24] & 0x7f) << 25) |
			((uint32_t)input[25] << 17) |
			((uint32_t)(input[26] & 0x80) << 9);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 209 to 224
	value = ((uint32_t)(input[26] & 0x7f) << 25) |
			((uint32_t)input[27] << 17) |
			((uint32_t)(input[28] & 0x80) << 9);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 225 to 240
	value = ((uint32_t)(input[28] & 0x7f) << 25) |
			((uint32_t)input[29] << 17) |
			((uint32_t)(input[30] & 0x80) << 9);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 241 to 256
	value = ((uint32_t)(input[30] & 0x7f) << 25) |
			((uint32_t)input[31] << 17) |
			((uint32_t)(input[32] & 0x80) << 9);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 257 to 272
	value = ((uint32_t)(input[32] & 0x7f) << 25) |
			((uint32_t)input[33] << 17) |
			((uint32_t)(input[34] & 0x80) << 9);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 273 to 288
	value = ((uint32_t)(input[34] & 0x7f) << 25) |
			((uint32_t)input[35] << 17) |
			((uint32_t)(input[36] & 0x80) << 9);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 289 to 304
	value = ((uint32_t)(input[36] & 0x7f) << 25) |
			((uint32_t)input[37] << 17) |
			((uint32_t)(input[38] & 0x80) << 9);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 305 to 320
	value = ((uint32_t)(input[38] & 0x7f) << 25) |
			((uint32_t)input[39] << 17) |
			((uint32_t)(input[40] & 0x80) << 9);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 321 to 336
	value = ((uint32_t)(input[40] & 0x7f) << 25) |
			((uint32_t)input[41] << 17) |
			((uint32_t)(input[42] & 0x80) << 9);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 337 to 352
	value = ((uint32_t)(input[42] & 0x7f) << 25) |
			((uint32_t)input[43] << 17) |
			((uint32_t)(input[44] & 0x80) << 9);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 353 to 368
	value = ((uint32_t)(input[44] & 0x7f) << 25) |
			((uint32_t)input[45] << 17) |
			((uint32_t)(input[46] & 0x80) << 9);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 369 to 384
	value = ((uint32_t)(input[46] & 0x7f) << 25) |
			((uint32_t)input[47] << 17) |
			((uint32_t)(input[48] & 0x80) << 9);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 385 to 400
	value = ((uint32_t)(input[48] & 0x7f) << 25) |
			((uint32_t)input[49] << 17) |
			((uint32_t)(input[50] & 0x80) << 9);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 401 to 416
	value = ((uint32_t)(input[50] & 0x7f) << 25) |
			((uint32_t)input[51] << 17) |
			((uint32_t)(input[52] & 0x80) << 9);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 417 to 432
	value = ((uint32_t)(input[52] & 0x7f) << 25) |
			((uint32_t)input[53] << 17) |
			((uint32_t)(input[54] & 0x80) << 9);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 433 to 448
	value = ((uint32_t)(input[54] & 0x7f) << 25) |
			((uint32_t)input[55] << 17) |
			((uint32_t)(input[56] & 0x80) << 9);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 449 to 464
	value = ((uint32_t)(input[56] & 0x7f) << 25) |
			((uint32_t)input[57] << 17) |
			((uint32_t)(input[58] & 0x80) << 9);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 465 to 480
	value = ((uint32_t)(input[58] & 0x7f) << 25) |
			((uint32_t)input[59] << 17) |
			((uint32_t)(input[60] & 0x80) << 9);
	output[29] = (double)(value >> 16);
}

static void unpack_30_16bit_unsigned_1off(const uint8_t * input, double * output, void *closure) {
	// Unpack 30 values into output
	// Values are 16-bit unsigned
	// Skip 1 bits, read 480 bits of data.
	// Input must be at least 61 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 1 to 16
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)input[1] << 17) |
			((uint32_t)(input[2] & 0x80) << 9);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 17 to 32
	value = ((uint32_t)(input[2] & 0x7f) << 25) |
			((uint32_t)input[3] << 17) |
			((uint32_t)(input[4] & 0x80) << 9);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 33 to 48
	value = ((uint32_t)(input[4] & 0x7f) << 25) |
			((uint32_t)input[5] << 17) |
			((uint32_t)(input[6] & 0x80) << 9);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 49 to 64
	value = ((uint32_t)(input[6] & 0x7f) << 25) |
			((uint32_t)input[7] << 17) |
			((uint32_t)(input[8] & 0x80) << 9);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 65 to 80
	value = ((uint32_t)(input[8] & 0x7f) << 25) |
			((uint32_t)input[9] << 17) |
			((uint32_t)(input[10] & 0x80) << 9);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 81 to 96
	value = ((uint32_t)(input[10] & 0x7f) << 25) |
			((uint32_t)input[11] << 17) |
			((uint32_t)(input[12] & 0x80) << 9);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 97 to 112
	value = ((uint32_t)(input[12] & 0x7f) << 25) |
			((uint32_t)input[13] << 17) |
			((uint32_t)(input[14] & 0x80) << 9);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 113 to 128
	value = ((uint32_t)(input[14] & 0x7f) << 25) |
			((uint32_t)input[15] << 17) |
			((uint32_t)(input[16] & 0x80) << 9);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 129 to 144
	value = ((uint32_t)(input[16] & 0x7f) << 25) |
			((uint32_t)input[17] << 17) |
			((uint32_t)(input[18] & 0x80) << 9);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 145 to 160
	value = ((uint32_t)(input[18] & 0x7f) << 25) |
			((uint32_t)input[19] << 17) |
			((uint32_t)(input[20] & 0x80) << 9);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 161 to 176
	value = ((uint32_t)(input[20] & 0x7f) << 25) |
			((uint32_t)input[21] << 17) |
			((uint32_t)(input[22] & 0x80) << 9);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 177 to 192
	value = ((uint32_t)(input[22] & 0x7f) << 25) |
			((uint32_t)input[23] << 17) |
			((uint32_t)(input[24] & 0x80) << 9);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 193 to 208
	value = ((uint32_t)(input[24] & 0x7f) << 25) |
			((uint32_t)input[25] << 17) |
			((uint32_t)(input[26] & 0x80) << 9);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 209 to 224
	value = ((uint32_t)(input[26] & 0x7f) << 25) |
			((uint32_t)input[27] << 17) |
			((uint32_t)(input[28] & 0x80) << 9);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 225 to 240
	value = ((uint32_t)(input[28] & 0x7f) << 25) |
			((uint32_t)input[29] << 17) |
			((uint32_t)(input[30] & 0x80) << 9);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 241 to 256
	value = ((uint32_t)(input[30] & 0x7f) << 25) |
			((uint32_t)input[31] << 17) |
			((uint32_t)(input[32] & 0x80) << 9);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 257 to 272
	value = ((uint32_t)(input[32] & 0x7f) << 25) |
			((uint32_t)input[33] << 17) |
			((uint32_t)(input[34] & 0x80) << 9);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 273 to 288
	value = ((uint32_t)(input[34] & 0x7f) << 25) |
			((uint32_t)input[35] << 17) |
			((uint32_t)(input[36] & 0x80) << 9);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 289 to 304
	value = ((uint32_t)(input[36] & 0x7f) << 25) |
			((uint32_t)input[37] << 17) |
			((uint32_t)(input[38] & 0x80) << 9);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 305 to 320
	value = ((uint32_t)(input[38] & 0x7f) << 25) |
			((uint32_t)input[39] << 17) |
			((uint32_t)(input[40] & 0x80) << 9);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 321 to 336
	value = ((uint32_t)(input[40] & 0x7f) << 25) |
			((uint32_t)input[41] << 17) |
			((uint32_t)(input[42] & 0x80) << 9);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 337 to 352
	value = ((uint32_t)(input[42] & 0x7f) << 25) |
			((uint32_t)input[43] << 17) |
			((uint32_t)(input[44] & 0x80) << 9);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 353 to 368
	value = ((uint32_t)(input[44] & 0x7f) << 25) |
			((uint32_t)input[45] << 17) |
			((uint32_t)(input[46] & 0x80) << 9);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 369 to 384
	value = ((uint32_t)(input[46] & 0x7f) << 25) |
			((uint32_t)input[47] << 17) |
			((uint32_t)(input[48] & 0x80) << 9);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 385 to 400
	value = ((uint32_t)(input[48] & 0x7f) << 25) |
			((uint32_t)input[49] << 17) |
			((uint32_t)(input[50] & 0x80) << 9);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 401 to 416
	value = ((uint32_t)(input[50] & 0x7f) << 25) |
			((uint32_t)input[51] << 17) |
			((uint32_t)(input[52] & 0x80) << 9);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 417 to 432
	value = ((uint32_t)(input[52] & 0x7f) << 25) |
			((uint32_t)input[53] << 17) |
			((uint32_t)(input[54] & 0x80) << 9);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 433 to 448
	value = ((uint32_t)(input[54] & 0x7f) << 25) |
			((uint32_t)input[55] << 17) |
			((uint32_t)(input[56] & 0x80) << 9);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 449 to 464
	value = ((uint32_t)(input[56] & 0x7f) << 25) |
			((uint32_t)input[57] << 17) |
			((uint32_t)(input[58] & 0x80) << 9);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 465 to 480
	value = ((uint32_t)(input[58] & 0x7f) << 25) |
			((uint32_t)input[59] << 17) |
			((uint32_t)(input[60] & 0x80) << 9);
	output[29] = (double)(value >> 16);
}

static void unpack_30_16bit_signed_2off(const uint8_t * input, double * output, void *closure) {
	// Unpack 30 values into output
	// Values are 16-bit signed
	// Skip 2 bits, read 480 bits of data.
	// Input must be at least 61 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 2 to 17
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)input[1] << 18) |
			((uint32_t)(input[2] & 0xc0) << 10);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 18 to 33
	value = ((uint32_t)(input[2] & 0x3f) << 26) |
			((uint32_t)input[3] << 18) |
			((uint32_t)(input[4] & 0xc0) << 10);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 34 to 49
	value = ((uint32_t)(input[4] & 0x3f) << 26) |
			((uint32_t)input[5] << 18) |
			((uint32_t)(input[6] & 0xc0) << 10);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 50 to 65
	value = ((uint32_t)(input[6] & 0x3f) << 26) |
			((uint32_t)input[7] << 18) |
			((uint32_t)(input[8] & 0xc0) << 10);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 66 to 81
	value = ((uint32_t)(input[8] & 0x3f) << 26) |
			((uint32_t)input[9] << 18) |
			((uint32_t)(input[10] & 0xc0) << 10);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 82 to 97
	value = ((uint32_t)(input[10] & 0x3f) << 26) |
			((uint32_t)input[11] << 18) |
			((uint32_t)(input[12] & 0xc0) << 10);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 98 to 113
	value = ((uint32_t)(input[12] & 0x3f) << 26) |
			((uint32_t)input[13] << 18) |
			((uint32_t)(input[14] & 0xc0) << 10);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 114 to 129
	value = ((uint32_t)(input[14] & 0x3f) << 26) |
			((uint32_t)input[15] << 18) |
			((uint32_t)(input[16] & 0xc0) << 10);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 130 to 145
	value = ((uint32_t)(input[16] & 0x3f) << 26) |
			((uint32_t)input[17] << 18) |
			((uint32_t)(input[18] & 0xc0) << 10);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 146 to 161
	value = ((uint32_t)(input[18] & 0x3f) << 26) |
			((uint32_t)input[19] << 18) |
			((uint32_t)(input[20] & 0xc0) << 10);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 162 to 177
	value = ((uint32_t)(input[20] & 0x3f) << 26) |
			((uint32_t)input[21] << 18) |
			((uint32_t)(input[22] & 0xc0) << 10);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 178 to 193
	value = ((uint32_t)(input[22] & 0x3f) << 26) |
			((uint32_t)input[23] << 18) |
			((uint32_t)(input[24] & 0xc0) << 10);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 194 to 209
	value = ((uint32_t)(input[24] & 0x3f) << 26) |
			((uint32_t)input[25] << 18) |
			((uint32_t)(input[26] & 0xc0) << 10);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 210 to 225
	value = ((uint32_t)(input[26] & 0x3f) << 26) |
			((uint32_t)input[27] << 18) |
			((uint32_t)(input[28] & 0xc0) << 10);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 226 to 241
	value = ((uint32_t)(input[28] & 0x3f) << 26) |
			((uint32_t)input[29] << 18) |
			((uint32_t)(input[30] & 0xc0) << 10);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 242 to 257
	value = ((uint32_t)(input[30] & 0x3f) << 26) |
			((uint32_t)input[31] << 18) |
			((uint32_t)(input[32] & 0xc0) << 10);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 258 to 273
	value = ((uint32_t)(input[32] & 0x3f) << 26) |
			((uint32_t)input[33] << 18) |
			((uint32_t)(input[34] & 0xc0) << 10);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 274 to 289
	value = ((uint32_t)(input[34] & 0x3f) << 26) |
			((uint32_t)input[35] << 18) |
			((uint32_t)(input[36] & 0xc0) << 10);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 290 to 305
	value = ((uint32_t)(input[36] & 0x3f) << 26) |
			((uint32_t)input[37] << 18) |
			((uint32_t)(input[38] & 0xc0) << 10);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 306 to 321
	value = ((uint32_t)(input[38] & 0x3f) << 26) |
			((uint32_t)input[39] << 18) |
			((uint32_t)(input[40] & 0xc0) << 10);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 322 to 337
	value = ((uint32_t)(input[40] & 0x3f) << 26) |
			((uint32_t)input[41] << 18) |
			((uint32_t)(input[42] & 0xc0) << 10);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 338 to 353
	value = ((uint32_t)(input[42] & 0x3f) << 26) |
			((uint32_t)input[43] << 18) |
			((uint32_t)(input[44] & 0xc0) << 10);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 354 to 369
	value = ((uint32_t)(input[44] & 0x3f) << 26) |
			((uint32_t)input[45] << 18) |
			((uint32_t)(input[46] & 0xc0) << 10);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 370 to 385
	value = ((uint32_t)(input[46] & 0x3f) << 26) |
			((uint32_t)input[47] << 18) |
			((uint32_t)(input[48] & 0xc0) << 10);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 386 to 401
	value = ((uint32_t)(input[48] & 0x3f) << 26) |
			((uint32_t)input[49] << 18) |
			((uint32_t)(input[50] & 0xc0) << 10);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 402 to 417
	value = ((uint32_t)(input[50] & 0x3f) << 26) |
			((uint32_t)input[51] << 18) |
			((uint32_t)(input[52] & 0xc0) << 10);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 418 to 433
	value = ((uint32_t)(input[52] & 0x3f) << 26) |
			((uint32_t)input[53] << 18) |
			((uint32_t)(input[54] & 0xc0) << 10);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 434 to 449
	value = ((uint32_t)(input[54] & 0x3f) << 26) |
			((uint32_t)input[55] << 18) |
			((uint32_t)(input[56] & 0xc0) << 10);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 450 to 465
	value = ((uint32_t)(input[56] & 0x3f) << 26) |
			((uint32_t)input[57] << 18) |
			((uint32_t)(input[58] & 0xc0) << 10);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 466 to 481
	value = ((uint32_t)(input[58] & 0x3f) << 26) |
			((uint32_t)input[59] << 18) |
			((uint32_t)(input[60] & 0xc0) << 10);
	output[29] = (double)(value >> 16);
}

static void unpack_30_16bit_unsigned_2off(const uint8_t * input, double * output, void *closure) {
	// Unpack 30 values into output
	// Values are 16-bit unsigned
	// Skip 2 bits, read 480 bits of data.
	// Input must be at least 61 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 2 to 17
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)input[1] << 18) |
			((uint32_t)(input[2] & 0xc0) << 10);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 18 to 33
	value = ((uint32_t)(input[2] & 0x3f) << 26) |
			((uint32_t)input[3] << 18) |
			((uint32_t)(input[4] & 0xc0) << 10);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 34 to 49
	value = ((uint32_t)(input[4] & 0x3f) << 26) |
			((uint32_t)input[5] << 18) |
			((uint32_t)(input[6] & 0xc0) << 10);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 50 to 65
	value = ((uint32_t)(input[6] & 0x3f) << 26) |
			((uint32_t)input[7] << 18) |
			((uint32_t)(input[8] & 0xc0) << 10);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 66 to 81
	value = ((uint32_t)(input[8] & 0x3f) << 26) |
			((uint32_t)input[9] << 18) |
			((uint32_t)(input[10] & 0xc0) << 10);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 82 to 97
	value = ((uint32_t)(input[10] & 0x3f) << 26) |
			((uint32_t)input[11] << 18) |
			((uint32_t)(input[12] & 0xc0) << 10);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 98 to 113
	value = ((uint32_t)(input[12] & 0x3f) << 26) |
			((uint32_t)input[13] << 18) |
			((uint32_t)(input[14] & 0xc0) << 10);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 114 to 129
	value = ((uint32_t)(input[14] & 0x3f) << 26) |
			((uint32_t)input[15] << 18) |
			((uint32_t)(input[16] & 0xc0) << 10);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 130 to 145
	value = ((uint32_t)(input[16] & 0x3f) << 26) |
			((uint32_t)input[17] << 18) |
			((uint32_t)(input[18] & 0xc0) << 10);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 146 to 161
	value = ((uint32_t)(input[18] & 0x3f) << 26) |
			((uint32_t)input[19] << 18) |
			((uint32_t)(input[20] & 0xc0) << 10);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 162 to 177
	value = ((uint32_t)(input[20] & 0x3f) << 26) |
			((uint32_t)input[21] << 18) |
			((uint32_t)(input[22] & 0xc0) << 10);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 178 to 193
	value = ((uint32_t)(input[22] & 0x3f) << 26) |
			((uint32_t)input[23] << 18) |
			((uint32_t)(input[24] & 0xc0) << 10);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 194 to 209
	value = ((uint32_t)(input[24] & 0x3f) << 26) |
			((uint32_t)input[25] << 18) |
			((uint32_t)(input[26] & 0xc0) << 10);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 210 to 225
	value = ((uint32_t)(input[26] & 0x3f) << 26) |
			((uint32_t)input[27] << 18) |
			((uint32_t)(input[28] & 0xc0) << 10);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 226 to 241
	value = ((uint32_t)(input[28] & 0x3f) << 26) |
			((uint32_t)input[29] << 18) |
			((uint32_t)(input[30] & 0xc0) << 10);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 242 to 257
	value = ((uint32_t)(input[30] & 0x3f) << 26) |
			((uint32_t)input[31] << 18) |
			((uint32_t)(input[32] & 0xc0) << 10);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 258 to 273
	value = ((uint32_t)(input[32] & 0x3f) << 26) |
			((uint32_t)input[33] << 18) |
			((uint32_t)(input[34] & 0xc0) << 10);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 274 to 289
	value = ((uint32_t)(input[34] & 0x3f) << 26) |
			((uint32_t)input[35] << 18) |
			((uint32_t)(input[36] & 0xc0) << 10);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 290 to 305
	value = ((uint32_t)(input[36] & 0x3f) << 26) |
			((uint32_t)input[37] << 18) |
			((uint32_t)(input[38] & 0xc0) << 10);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 306 to 321
	value = ((uint32_t)(input[38] & 0x3f) << 26) |
			((uint32_t)input[39] << 18) |
			((uint32_t)(input[40] & 0xc0) << 10);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 322 to 337
	value = ((uint32_t)(input[40] & 0x3f) << 26) |
			((uint32_t)input[41] << 18) |
			((uint32_t)(input[42] & 0xc0) << 10);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 338 to 353
	value = ((uint32_t)(input[42] & 0x3f) << 26) |
			((uint32_t)input[43] << 18) |
			((uint32_t)(input[44] & 0xc0) << 10);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 354 to 369
	value = ((uint32_t)(input[44] & 0x3f) << 26) |
			((uint32_t)input[45] << 18) |
			((uint32_t)(input[46] & 0xc0) << 10);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 370 to 385
	value = ((uint32_t)(input[46] & 0x3f) << 26) |
			((uint32_t)input[47] << 18) |
			((uint32_t)(input[48] & 0xc0) << 10);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 386 to 401
	value = ((uint32_t)(input[48] & 0x3f) << 26) |
			((uint32_t)input[49] << 18) |
			((uint32_t)(input[50] & 0xc0) << 10);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 402 to 417
	value = ((uint32_t)(input[50] & 0x3f) << 26) |
			((uint32_t)input[51] << 18) |
			((uint32_t)(input[52] & 0xc0) << 10);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 418 to 433
	value = ((uint32_t)(input[52] & 0x3f) << 26) |
			((uint32_t)input[53] << 18) |
			((uint32_t)(input[54] & 0xc0) << 10);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 434 to 449
	value = ((uint32_t)(input[54] & 0x3f) << 26) |
			((uint32_t)input[55] << 18) |
			((uint32_t)(input[56] & 0xc0) << 10);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 450 to 465
	value = ((uint32_t)(input[56] & 0x3f) << 26) |
			((uint32_t)input[57] << 18) |
			((uint32_t)(input[58] & 0xc0) << 10);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 466 to 481
	value = ((uint32_t)(input[58] & 0x3f) << 26) |
			((uint32_t)input[59] << 18) |
			((uint32_t)(input[60] & 0xc0) << 10);
	output[29] = (double)(value >> 16);
}

static void unpack_30_16bit_signed_3off(const uint8_t * input, double * output, void *closure) {
	// Unpack 30 values into output
	// Values are 16-bit signed
	// Skip 3 bits, read 480 bits of data.
	// Input must be at least 61 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 3 to 18
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)input[1] << 19) |
			((uint32_t)(input[2] & 0xe0) << 11);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 19 to 34
	value = ((uint32_t)(input[2] & 0x1f) << 27) |
			((uint32_t)input[3] << 19) |
			((uint32_t)(input[4] & 0xe0) << 11);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 35 to 50
	value = ((uint32_t)(input[4] & 0x1f) << 27) |
			((uint32_t)input[5] << 19) |
			((uint32_t)(input[6] & 0xe0) << 11);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 51 to 66
	value = ((uint32_t)(input[6] & 0x1f) << 27) |
			((uint32_t)input[7] << 19) |
			((uint32_t)(input[8] & 0xe0) << 11);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 67 to 82
	value = ((uint32_t)(input[8] & 0x1f) << 27) |
			((uint32_t)input[9] << 19) |
			((uint32_t)(input[10] & 0xe0) << 11);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 83 to 98
	value = ((uint32_t)(input[10] & 0x1f) << 27) |
			((uint32_t)input[11] << 19) |
			((uint32_t)(input[12] & 0xe0) << 11);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 99 to 114
	value = ((uint32_t)(input[12] & 0x1f) << 27) |
			((uint32_t)input[13] << 19) |
			((uint32_t)(input[14] & 0xe0) << 11);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 115 to 130
	value = ((uint32_t)(input[14] & 0x1f) << 27) |
			((uint32_t)input[15] << 19) |
			((uint32_t)(input[16] & 0xe0) << 11);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 131 to 146
	value = ((uint32_t)(input[16] & 0x1f) << 27) |
			((uint32_t)input[17] << 19) |
			((uint32_t)(input[18] & 0xe0) << 11);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 147 to 162
	value = ((uint32_t)(input[18] & 0x1f) << 27) |
			((uint32_t)input[19] << 19) |
			((uint32_t)(input[20] & 0xe0) << 11);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 163 to 178
	value = ((uint32_t)(input[20] & 0x1f) << 27) |
			((uint32_t)input[21] << 19) |
			((uint32_t)(input[22] & 0xe0) << 11);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 179 to 194
	value = ((uint32_t)(input[22] & 0x1f) << 27) |
			((uint32_t)input[23] << 19) |
			((uint32_t)(input[24] & 0xe0) << 11);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 195 to 210
	value = ((uint32_t)(input[24] & 0x1f) << 27) |
			((uint32_t)input[25] << 19) |
			((uint32_t)(input[26] & 0xe0) << 11);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 211 to 226
	value = ((uint32_t)(input[26] & 0x1f) << 27) |
			((uint32_t)input[27] << 19) |
			((uint32_t)(input[28] & 0xe0) << 11);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 227 to 242
	value = ((uint32_t)(input[28] & 0x1f) << 27) |
			((uint32_t)input[29] << 19) |
			((uint32_t)(input[30] & 0xe0) << 11);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 243 to 258
	value = ((uint32_t)(input[30] & 0x1f) << 27) |
			((uint32_t)input[31] << 19) |
			((uint32_t)(input[32] & 0xe0) << 11);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 259 to 274
	value = ((uint32_t)(input[32] & 0x1f) << 27) |
			((uint32_t)input[33] << 19) |
			((uint32_t)(input[34] & 0xe0) << 11);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 275 to 290
	value = ((uint32_t)(input[34] & 0x1f) << 27) |
			((uint32_t)input[35] << 19) |
			((uint32_t)(input[36] & 0xe0) << 11);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 291 to 306
	value = ((uint32_t)(input[36] & 0x1f) << 27) |
			((uint32_t)input[37] << 19) |
			((uint32_t)(input[38] & 0xe0) << 11);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 307 to 322
	value = ((uint32_t)(input[38] & 0x1f) << 27) |
			((uint32_t)input[39] << 19) |
			((uint32_t)(input[40] & 0xe0) << 11);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 323 to 338
	value = ((uint32_t)(input[40] & 0x1f) << 27) |
			((uint32_t)input[41] << 19) |
			((uint32_t)(input[42] & 0xe0) << 11);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 339 to 354
	value = ((uint32_t)(input[42] & 0x1f) << 27) |
			((uint32_t)input[43] << 19) |
			((uint32_t)(input[44] & 0xe0) << 11);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 355 to 370
	value = ((uint32_t)(input[44] & 0x1f) << 27) |
			((uint32_t)input[45] << 19) |
			((uint32_t)(input[46] & 0xe0) << 11);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 371 to 386
	value = ((uint32_t)(input[46] & 0x1f) << 27) |
			((uint32_t)input[47] << 19) |
			((uint32_t)(input[48] & 0xe0) << 11);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 387 to 402
	value = ((uint32_t)(input[48] & 0x1f) << 27) |
			((uint32_t)input[49] << 19) |
			((uint32_t)(input[50] & 0xe0) << 11);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 403 to 418
	value = ((uint32_t)(input[50] & 0x1f) << 27) |
			((uint32_t)input[51] << 19) |
			((uint32_t)(input[52] & 0xe0) << 11);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 419 to 434
	value = ((uint32_t)(input[52] & 0x1f) << 27) |
			((uint32_t)input[53] << 19) |
			((uint32_t)(input[54] & 0xe0) << 11);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 435 to 450
	value = ((uint32_t)(input[54] & 0x1f) << 27) |
			((uint32_t)input[55] << 19) |
			((uint32_t)(input[56] & 0xe0) << 11);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 451 to 466
	value = ((uint32_t)(input[56] & 0x1f) << 27) |
			((uint32_t)input[57] << 19) |
			((uint32_t)(input[58] & 0xe0) << 11);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 467 to 482
	value = ((uint32_t)(input[58] & 0x1f) << 27) |
			((uint32_t)input[59] << 19) |
			((uint32_t)(input[60] & 0xe0) << 11);
	output[29] = (double)(value >> 16);
}

static void unpack_30_16bit_unsigned_3off(const uint8_t * input, double * output, void *closure) {
	// Unpack 30 values into output
	// Values are 16-bit unsigned
	// Skip 3 bits, read 480 bits of data.
	// Input must be at least 61 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 3 to 18
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)input[1] << 19) |
			((uint32_t)(input[2] & 0xe0) << 11);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 19 to 34
	value = ((uint32_t)(input[2] & 0x1f) << 27) |
			((uint32_t)input[3] << 19) |
			((uint32_t)(input[4] & 0xe0) << 11);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 35 to 50
	value = ((uint32_t)(input[4] & 0x1f) << 27) |
			((uint32_t)input[5] << 19) |
			((uint32_t)(input[6] & 0xe0) << 11);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 51 to 66
	value = ((uint32_t)(input[6] & 0x1f) << 27) |
			((uint32_t)input[7] << 19) |
			((uint32_t)(input[8] & 0xe0) << 11);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 67 to 82
	value = ((uint32_t)(input[8] & 0x1f) << 27) |
			((uint32_t)input[9] << 19) |
			((uint32_t)(input[10] & 0xe0) << 11);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 83 to 98
	value = ((uint32_t)(input[10] & 0x1f) << 27) |
			((uint32_t)input[11] << 19) |
			((uint32_t)(input[12] & 0xe0) << 11);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 99 to 114
	value = ((uint32_t)(input[12] & 0x1f) << 27) |
			((uint32_t)input[13] << 19) |
			((uint32_t)(input[14] & 0xe0) << 11);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 115 to 130
	value = ((uint32_t)(input[14] & 0x1f) << 27) |
			((uint32_t)input[15] << 19) |
			((uint32_t)(input[16] & 0xe0) << 11);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 131 to 146
	value = ((uint32_t)(input[16] & 0x1f) << 27) |
			((uint32_t)input[17] << 19) |
			((uint32_t)(input[18] & 0xe0) << 11);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 147 to 162
	value = ((uint32_t)(input[18] & 0x1f) << 27) |
			((uint32_t)input[19] << 19) |
			((uint32_t)(input[20] & 0xe0) << 11);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 163 to 178
	value = ((uint32_t)(input[20] & 0x1f) << 27) |
			((uint32_t)input[21] << 19) |
			((uint32_t)(input[22] & 0xe0) << 11);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 179 to 194
	value = ((uint32_t)(input[22] & 0x1f) << 27) |
			((uint32_t)input[23] << 19) |
			((uint32_t)(input[24] & 0xe0) << 11);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 195 to 210
	value = ((uint32_t)(input[24] & 0x1f) << 27) |
			((uint32_t)input[25] << 19) |
			((uint32_t)(input[26] & 0xe0) << 11);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 211 to 226
	value = ((uint32_t)(input[26] & 0x1f) << 27) |
			((uint32_t)input[27] << 19) |
			((uint32_t)(input[28] & 0xe0) << 11);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 227 to 242
	value = ((uint32_t)(input[28] & 0x1f) << 27) |
			((uint32_t)input[29] << 19) |
			((uint32_t)(input[30] & 0xe0) << 11);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 243 to 258
	value = ((uint32_t)(input[30] & 0x1f) << 27) |
			((uint32_t)input[31] << 19) |
			((uint32_t)(input[32] & 0xe0) << 11);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 259 to 274
	value = ((uint32_t)(input[32] & 0x1f) << 27) |
			((uint32_t)input[33] << 19) |
			((uint32_t)(input[34] & 0xe0) << 11);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 275 to 290
	value = ((uint32_t)(input[34] & 0x1f) << 27) |
			((uint32_t)input[35] << 19) |
			((uint32_t)(input[36] & 0xe0) << 11);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 291 to 306
	value = ((uint32_t)(input[36] & 0x1f) << 27) |
			((uint32_t)input[37] << 19) |
			((uint32_t)(input[38] & 0xe0) << 11);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 307 to 322
	value = ((uint32_t)(input[38] & 0x1f) << 27) |
			((uint32_t)input[39] << 19) |
			((uint32_t)(input[40] & 0xe0) << 11);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 323 to 338
	value = ((uint32_t)(input[40] & 0x1f) << 27) |
			((uint32_t)input[41] << 19) |
			((uint32_t)(input[42] & 0xe0) << 11);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 339 to 354
	value = ((uint32_t)(input[42] & 0x1f) << 27) |
			((uint32_t)input[43] << 19) |
			((uint32_t)(input[44] & 0xe0) << 11);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 355 to 370
	value = ((uint32_t)(input[44] & 0x1f) << 27) |
			((uint32_t)input[45] << 19) |
			((uint32_t)(input[46] & 0xe0) << 11);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 371 to 386
	value = ((uint32_t)(input[46] & 0x1f) << 27) |
			((uint32_t)input[47] << 19) |
			((uint32_t)(input[48] & 0xe0) << 11);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 387 to 402
	value = ((uint32_t)(input[48] & 0x1f) << 27) |
			((uint32_t)input[49] << 19) |
			((uint32_t)(input[50] & 0xe0) << 11);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 403 to 418
	value = ((uint32_t)(input[50] & 0x1f) << 27) |
			((uint32_t)input[51] << 19) |
			((uint32_t)(input[52] & 0xe0) << 11);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 419 to 434
	value = ((uint32_t)(input[52] & 0x1f) << 27) |
			((uint32_t)input[53] << 19) |
			((uint32_t)(input[54] & 0xe0) << 11);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 435 to 450
	value = ((uint32_t)(input[54] & 0x1f) << 27) |
			((uint32_t)input[55] << 19) |
			((uint32_t)(input[56] & 0xe0) << 11);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 451 to 466
	value = ((uint32_t)(input[56] & 0x1f) << 27) |
			((uint32_t)input[57] << 19) |
			((uint32_t)(input[58] & 0xe0) << 11);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 467 to 482
	value = ((uint32_t)(input[58] & 0x1f) << 27) |
			((uint32_t)input[59] << 19) |
			((uint32_t)(input[60] & 0xe0) << 11);
	output[29] = (double)(value >> 16);
}

static void unpack_30_16bit_signed_4off(const uint8_t * input, double * output, void *closure) {
	// Unpack 30 values into output
	// Values are 16-bit signed
	// Skip 4 bits, read 480 bits of data.
	// Input must be at least 61 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 4 to 19
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20) |
			((uint32_t)(input[2] & 0xf0) << 12);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 20 to 35
	value = ((uint32_t)(input[2] & 0x0f) << 28) |
			((uint32_t)input[3] << 20) |
			((uint32_t)(input[4] & 0xf0) << 12);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 36 to 51
	value = ((uint32_t)(input[4] & 0x0f) << 28) |
			((uint32_t)input[5] << 20) |
			((uint32_t)(input[6] & 0xf0) << 12);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 52 to 67
	value = ((uint32_t)(input[6] & 0x0f) << 28) |
			((uint32_t)input[7] << 20) |
			((uint32_t)(input[8] & 0xf0) << 12);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 68 to 83
	value = ((uint32_t)(input[8] & 0x0f) << 28) |
			((uint32_t)input[9] << 20) |
			((uint32_t)(input[10] & 0xf0) << 12);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 84 to 99
	value = ((uint32_t)(input[10] & 0x0f) << 28) |
			((uint32_t)input[11] << 20) |
			((uint32_t)(input[12] & 0xf0) << 12);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 100 to 115
	value = ((uint32_t)(input[12] & 0x0f) << 28) |
			((uint32_t)input[13] << 20) |
			((uint32_t)(input[14] & 0xf0) << 12);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 116 to 131
	value = ((uint32_t)(input[14] & 0x0f) << 28) |
			((uint32_t)input[15] << 20) |
			((uint32_t)(input[16] & 0xf0) << 12);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 132 to 147
	value = ((uint32_t)(input[16] & 0x0f) << 28) |
			((uint32_t)input[17] << 20) |
			((uint32_t)(input[18] & 0xf0) << 12);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 148 to 163
	value = ((uint32_t)(input[18] & 0x0f) << 28) |
			((uint32_t)input[19] << 20) |
			((uint32_t)(input[20] & 0xf0) << 12);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 164 to 179
	value = ((uint32_t)(input[20] & 0x0f) << 28) |
			((uint32_t)input[21] << 20) |
			((uint32_t)(input[22] & 0xf0) << 12);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 180 to 195
	value = ((uint32_t)(input[22] & 0x0f) << 28) |
			((uint32_t)input[23] << 20) |
			((uint32_t)(input[24] & 0xf0) << 12);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 196 to 211
	value = ((uint32_t)(input[24] & 0x0f) << 28) |
			((uint32_t)input[25] << 20) |
			((uint32_t)(input[26] & 0xf0) << 12);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 212 to 227
	value = ((uint32_t)(input[26] & 0x0f) << 28) |
			((uint32_t)input[27] << 20) |
			((uint32_t)(input[28] & 0xf0) << 12);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 228 to 243
	value = ((uint32_t)(input[28] & 0x0f) << 28) |
			((uint32_t)input[29] << 20) |
			((uint32_t)(input[30] & 0xf0) << 12);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 244 to 259
	value = ((uint32_t)(input[30] & 0x0f) << 28) |
			((uint32_t)input[31] << 20) |
			((uint32_t)(input[32] & 0xf0) << 12);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 260 to 275
	value = ((uint32_t)(input[32] & 0x0f) << 28) |
			((uint32_t)input[33] << 20) |
			((uint32_t)(input[34] & 0xf0) << 12);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 276 to 291
	value = ((uint32_t)(input[34] & 0x0f) << 28) |
			((uint32_t)input[35] << 20) |
			((uint32_t)(input[36] & 0xf0) << 12);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 292 to 307
	value = ((uint32_t)(input[36] & 0x0f) << 28) |
			((uint32_t)input[37] << 20) |
			((uint32_t)(input[38] & 0xf0) << 12);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 308 to 323
	value = ((uint32_t)(input[38] & 0x0f) << 28) |
			((uint32_t)input[39] << 20) |
			((uint32_t)(input[40] & 0xf0) << 12);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 324 to 339
	value = ((uint32_t)(input[40] & 0x0f) << 28) |
			((uint32_t)input[41] << 20) |
			((uint32_t)(input[42] & 0xf0) << 12);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 340 to 355
	value = ((uint32_t)(input[42] & 0x0f) << 28) |
			((uint32_t)input[43] << 20) |
			((uint32_t)(input[44] & 0xf0) << 12);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 356 to 371
	value = ((uint32_t)(input[44] & 0x0f) << 28) |
			((uint32_t)input[45] << 20) |
			((uint32_t)(input[46] & 0xf0) << 12);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 372 to 387
	value = ((uint32_t)(input[46] & 0x0f) << 28) |
			((uint32_t)input[47] << 20) |
			((uint32_t)(input[48] & 0xf0) << 12);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 388 to 403
	value = ((uint32_t)(input[48] & 0x0f) << 28) |
			((uint32_t)input[49] << 20) |
			((uint32_t)(input[50] & 0xf0) << 12);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 404 to 419
	value = ((uint32_t)(input[50] & 0x0f) << 28) |
			((uint32_t)input[51] << 20) |
			((uint32_t)(input[52] & 0xf0) << 12);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 420 to 435
	value = ((uint32_t)(input[52] & 0x0f) << 28) |
			((uint32_t)input[53] << 20) |
			((uint32_t)(input[54] & 0xf0) << 12);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 436 to 451
	value = ((uint32_t)(input[54] & 0x0f) << 28) |
			((uint32_t)input[55] << 20) |
			((uint32_t)(input[56] & 0xf0) << 12);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 452 to 467
	value = ((uint32_t)(input[56] & 0x0f) << 28) |
			((uint32_t)input[57] << 20) |
			((uint32_t)(input[58] & 0xf0) << 12);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 468 to 483
	value = ((uint32_t)(input[58] & 0x0f) << 28) |
			((uint32_t)input[59] << 20) |
			((uint32_t)(input[60] & 0xf0) << 12);
	output[29] = (double)(value >> 16);
}

static void unpack_30_16bit_unsigned_4off(const uint8_t * input, double * output, void *closure) {
	// Unpack 30 values into output
	// Values are 16-bit unsigned
	// Skip 4 bits, read 480 bits of data.
	// Input must be at least 61 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 4 to 19
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20) |
			((uint32_t)(input[2] & 0xf0) << 12);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 20 to 35
	value = ((uint32_t)(input[2] & 0x0f) << 28) |
			((uint32_t)input[3] << 20) |
			((uint32_t)(input[4] & 0xf0) << 12);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 36 to 51
	value = ((uint32_t)(input[4] & 0x0f) << 28) |
			((uint32_t)input[5] << 20) |
			((uint32_t)(input[6] & 0xf0) << 12);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 52 to 67
	value = ((uint32_t)(input[6] & 0x0f) << 28) |
			((uint32_t)input[7] << 20) |
			((uint32_t)(input[8] & 0xf0) << 12);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 68 to 83
	value = ((uint32_t)(input[8] & 0x0f) << 28) |
			((uint32_t)input[9] << 20) |
			((uint32_t)(input[10] & 0xf0) << 12);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 84 to 99
	value = ((uint32_t)(input[10] & 0x0f) << 28) |
			((uint32_t)input[11] << 20) |
			((uint32_t)(input[12] & 0xf0) << 12);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 100 to 115
	value = ((uint32_t)(input[12] & 0x0f) << 28) |
			((uint32_t)input[13] << 20) |
			((uint32_t)(input[14] & 0xf0) << 12);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 116 to 131
	value = ((uint32_t)(input[14] & 0x0f) << 28) |
			((uint32_t)input[15] << 20) |
			((uint32_t)(input[16] & 0xf0) << 12);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 132 to 147
	value = ((uint32_t)(input[16] & 0x0f) << 28) |
			((uint32_t)input[17] << 20) |
			((uint32_t)(input[18] & 0xf0) << 12);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 148 to 163
	value = ((uint32_t)(input[18] & 0x0f) << 28) |
			((uint32_t)input[19] << 20) |
			((uint32_t)(input[20] & 0xf0) << 12);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 164 to 179
	value = ((uint32_t)(input[20] & 0x0f) << 28) |
			((uint32_t)input[21] << 20) |
			((uint32_t)(input[22] & 0xf0) << 12);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 180 to 195
	value = ((uint32_t)(input[22] & 0x0f) << 28) |
			((uint32_t)input[23] << 20) |
			((uint32_t)(input[24] & 0xf0) << 12);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 196 to 211
	value = ((uint32_t)(input[24] & 0x0f) << 28) |
			((uint32_t)input[25] << 20) |
			((uint32_t)(input[26] & 0xf0) << 12);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 212 to 227
	value = ((uint32_t)(input[26] & 0x0f) << 28) |
			((uint32_t)input[27] << 20) |
			((uint32_t)(input[28] & 0xf0) << 12);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 228 to 243
	value = ((uint32_t)(input[28] & 0x0f) << 28) |
			((uint32_t)input[29] << 20) |
			((uint32_t)(input[30] & 0xf0) << 12);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 244 to 259
	value = ((uint32_t)(input[30] & 0x0f) << 28) |
			((uint32_t)input[31] << 20) |
			((uint32_t)(input[32] & 0xf0) << 12);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 260 to 275
	value = ((uint32_t)(input[32] & 0x0f) << 28) |
			((uint32_t)input[33] << 20) |
			((uint32_t)(input[34] & 0xf0) << 12);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 276 to 291
	value = ((uint32_t)(input[34] & 0x0f) << 28) |
			((uint32_t)input[35] << 20) |
			((uint32_t)(input[36] & 0xf0) << 12);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 292 to 307
	value = ((uint32_t)(input[36] & 0x0f) << 28) |
			((uint32_t)input[37] << 20) |
			((uint32_t)(input[38] & 0xf0) << 12);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 308 to 323
	value = ((uint32_t)(input[38] & 0x0f) << 28) |
			((uint32_t)input[39] << 20) |
			((uint32_t)(input[40] & 0xf0) << 12);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 324 to 339
	value = ((uint32_t)(input[40] & 0x0f) << 28) |
			((uint32_t)input[41] << 20) |
			((uint32_t)(input[42] & 0xf0) << 12);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 340 to 355
	value = ((uint32_t)(input[42] & 0x0f) << 28) |
			((uint32_t)input[43] << 20) |
			((uint32_t)(input[44] & 0xf0) << 12);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 356 to 371
	value = ((uint32_t)(input[44] & 0x0f) << 28) |
			((uint32_t)input[45] << 20) |
			((uint32_t)(input[46] & 0xf0) << 12);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 372 to 387
	value = ((uint32_t)(input[46] & 0x0f) << 28) |
			((uint32_t)input[47] << 20) |
			((uint32_t)(input[48] & 0xf0) << 12);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 388 to 403
	value = ((uint32_t)(input[48] & 0x0f) << 28) |
			((uint32_t)input[49] << 20) |
			((uint32_t)(input[50] & 0xf0) << 12);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 404 to 419
	value = ((uint32_t)(input[50] & 0x0f) << 28) |
			((uint32_t)input[51] << 20) |
			((uint32_t)(input[52] & 0xf0) << 12);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 420 to 435
	value = ((uint32_t)(input[52] & 0x0f) << 28) |
			((uint32_t)input[53] << 20) |
			((uint32_t)(input[54] & 0xf0) << 12);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 436 to 451
	value = ((uint32_t)(input[54] & 0x0f) << 28) |
			((uint32_t)input[55] << 20) |
			((uint32_t)(input[56] & 0xf0) << 12);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 452 to 467
	value = ((uint32_t)(input[56] & 0x0f) << 28) |
			((uint32_t)input[57] << 20) |
			((uint32_t)(input[58] & 0xf0) << 12);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 468 to 483
	value = ((uint32_t)(input[58] & 0x0f) << 28) |
			((uint32_t)input[59] << 20) |
			((uint32_t)(input[60] & 0xf0) << 12);
	output[29] = (double)(value >> 16);
}

static void unpack_30_16bit_signed_5off(const uint8_t * input, double * output, void *closure) {
	// Unpack 30 values into output
	// Values are 16-bit signed
	// Skip 5 bits, read 480 bits of data.
	// Input must be at least 61 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 5 to 20
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)(input[2] & 0xf8) << 13);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 21 to 36
	value = ((uint32_t)(input[2] & 0x07) << 29) |
			((uint32_t)input[3] << 21) |
			((uint32_t)(input[4] & 0xf8) << 13);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 37 to 52
	value = ((uint32_t)(input[4] & 0x07) << 29) |
			((uint32_t)input[5] << 21) |
			((uint32_t)(input[6] & 0xf8) << 13);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 53 to 68
	value = ((uint32_t)(input[6] & 0x07) << 29) |
			((uint32_t)input[7] << 21) |
			((uint32_t)(input[8] & 0xf8) << 13);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 69 to 84
	value = ((uint32_t)(input[8] & 0x07) << 29) |
			((uint32_t)input[9] << 21) |
			((uint32_t)(input[10] & 0xf8) << 13);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 85 to 100
	value = ((uint32_t)(input[10] & 0x07) << 29) |
			((uint32_t)input[11] << 21) |
			((uint32_t)(input[12] & 0xf8) << 13);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 101 to 116
	value = ((uint32_t)(input[12] & 0x07) << 29) |
			((uint32_t)input[13] << 21) |
			((uint32_t)(input[14] & 0xf8) << 13);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 117 to 132
	value = ((uint32_t)(input[14] & 0x07) << 29) |
			((uint32_t)input[15] << 21) |
			((uint32_t)(input[16] & 0xf8) << 13);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 133 to 148
	value = ((uint32_t)(input[16] & 0x07) << 29) |
			((uint32_t)input[17] << 21) |
			((uint32_t)(input[18] & 0xf8) << 13);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 149 to 164
	value = ((uint32_t)(input[18] & 0x07) << 29) |
			((uint32_t)input[19] << 21) |
			((uint32_t)(input[20] & 0xf8) << 13);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 165 to 180
	value = ((uint32_t)(input[20] & 0x07) << 29) |
			((uint32_t)input[21] << 21) |
			((uint32_t)(input[22] & 0xf8) << 13);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 181 to 196
	value = ((uint32_t)(input[22] & 0x07) << 29) |
			((uint32_t)input[23] << 21) |
			((uint32_t)(input[24] & 0xf8) << 13);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 197 to 212
	value = ((uint32_t)(input[24] & 0x07) << 29) |
			((uint32_t)input[25] << 21) |
			((uint32_t)(input[26] & 0xf8) << 13);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 213 to 228
	value = ((uint32_t)(input[26] & 0x07) << 29) |
			((uint32_t)input[27] << 21) |
			((uint32_t)(input[28] & 0xf8) << 13);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 229 to 244
	value = ((uint32_t)(input[28] & 0x07) << 29) |
			((uint32_t)input[29] << 21) |
			((uint32_t)(input[30] & 0xf8) << 13);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 245 to 260
	value = ((uint32_t)(input[30] & 0x07) << 29) |
			((uint32_t)input[31] << 21) |
			((uint32_t)(input[32] & 0xf8) << 13);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 261 to 276
	value = ((uint32_t)(input[32] & 0x07) << 29) |
			((uint32_t)input[33] << 21) |
			((uint32_t)(input[34] & 0xf8) << 13);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 277 to 292
	value = ((uint32_t)(input[34] & 0x07) << 29) |
			((uint32_t)input[35] << 21) |
			((uint32_t)(input[36] & 0xf8) << 13);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 293 to 308
	value = ((uint32_t)(input[36] & 0x07) << 29) |
			((uint32_t)input[37] << 21) |
			((uint32_t)(input[38] & 0xf8) << 13);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 309 to 324
	value = ((uint32_t)(input[38] & 0x07) << 29) |
			((uint32_t)input[39] << 21) |
			((uint32_t)(input[40] & 0xf8) << 13);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 325 to 340
	value = ((uint32_t)(input[40] & 0x07) << 29) |
			((uint32_t)input[41] << 21) |
			((uint32_t)(input[42] & 0xf8) << 13);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 341 to 356
	value = ((uint32_t)(input[42] & 0x07) << 29) |
			((uint32_t)input[43] << 21) |
			((uint32_t)(input[44] & 0xf8) << 13);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 357 to 372
	value = ((uint32_t)(input[44] & 0x07) << 29) |
			((uint32_t)input[45] << 21) |
			((uint32_t)(input[46] & 0xf8) << 13);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 373 to 388
	value = ((uint32_t)(input[46] & 0x07) << 29) |
			((uint32_t)input[47] << 21) |
			((uint32_t)(input[48] & 0xf8) << 13);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 389 to 404
	value = ((uint32_t)(input[48] & 0x07) << 29) |
			((uint32_t)input[49] << 21) |
			((uint32_t)(input[50] & 0xf8) << 13);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 405 to 420
	value = ((uint32_t)(input[50] & 0x07) << 29) |
			((uint32_t)input[51] << 21) |
			((uint32_t)(input[52] & 0xf8) << 13);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 421 to 436
	value = ((uint32_t)(input[52] & 0x07) << 29) |
			((uint32_t)input[53] << 21) |
			((uint32_t)(input[54] & 0xf8) << 13);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 437 to 452
	value = ((uint32_t)(input[54] & 0x07) << 29) |
			((uint32_t)input[55] << 21) |
			((uint32_t)(input[56] & 0xf8) << 13);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 453 to 468
	value = ((uint32_t)(input[56] & 0x07) << 29) |
			((uint32_t)input[57] << 21) |
			((uint32_t)(input[58] & 0xf8) << 13);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 469 to 484
	value = ((uint32_t)(input[58] & 0x07) << 29) |
			((uint32_t)input[59] << 21) |
			((uint32_t)(input[60] & 0xf8) << 13);
	output[29] = (double)(value >> 16);
}

static void unpack_30_16bit_unsigned_5off(const uint8_t * input, double * output, void *closure) {
	// Unpack 30 values into output
	// Values are 16-bit unsigned
	// Skip 5 bits, read 480 bits of data.
	// Input must be at least 61 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 5 to 20
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)(input[2] & 0xf8) << 13);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 21 to 36
	value = ((uint32_t)(input[2] & 0x07) << 29) |
			((uint32_t)input[3] << 21) |
			((uint32_t)(input[4] & 0xf8) << 13);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 37 to 52
	value = ((uint32_t)(input[4] & 0x07) << 29) |
			((uint32_t)input[5] << 21) |
			((uint32_t)(input[6] & 0xf8) << 13);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 53 to 68
	value = ((uint32_t)(input[6] & 0x07) << 29) |
			((uint32_t)input[7] << 21) |
			((uint32_t)(input[8] & 0xf8) << 13);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 69 to 84
	value = ((uint32_t)(input[8] & 0x07) << 29) |
			((uint32_t)input[9] << 21) |
			((uint32_t)(input[10] & 0xf8) << 13);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 85 to 100
	value = ((uint32_t)(input[10] & 0x07) << 29) |
			((uint32_t)input[11] << 21) |
			((uint32_t)(input[12] & 0xf8) << 13);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 101 to 116
	value = ((uint32_t)(input[12] & 0x07) << 29) |
			((uint32_t)input[13] << 21) |
			((uint32_t)(input[14] & 0xf8) << 13);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 117 to 132
	value = ((uint32_t)(input[14] & 0x07) << 29) |
			((uint32_t)input[15] << 21) |
			((uint32_t)(input[16] & 0xf8) << 13);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 133 to 148
	value = ((uint32_t)(input[16] & 0x07) << 29) |
			((uint32_t)input[17] << 21) |
			((uint32_t)(input[18] & 0xf8) << 13);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 149 to 164
	value = ((uint32_t)(input[18] & 0x07) << 29) |
			((uint32_t)input[19] << 21) |
			((uint32_t)(input[20] & 0xf8) << 13);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 165 to 180
	value = ((uint32_t)(input[20] & 0x07) << 29) |
			((uint32_t)input[21] << 21) |
			((uint32_t)(input[22] & 0xf8) << 13);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 181 to 196
	value = ((uint32_t)(input[22] & 0x07) << 29) |
			((uint32_t)input[23] << 21) |
			((uint32_t)(input[24] & 0xf8) << 13);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 197 to 212
	value = ((uint32_t)(input[24] & 0x07) << 29) |
			((uint32_t)input[25] << 21) |
			((uint32_t)(input[26] & 0xf8) << 13);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 213 to 228
	value = ((uint32_t)(input[26] & 0x07) << 29) |
			((uint32_t)input[27] << 21) |
			((uint32_t)(input[28] & 0xf8) << 13);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 229 to 244
	value = ((uint32_t)(input[28] & 0x07) << 29) |
			((uint32_t)input[29] << 21) |
			((uint32_t)(input[30] & 0xf8) << 13);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 245 to 260
	value = ((uint32_t)(input[30] & 0x07) << 29) |
			((uint32_t)input[31] << 21) |
			((uint32_t)(input[32] & 0xf8) << 13);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 261 to 276
	value = ((uint32_t)(input[32] & 0x07) << 29) |
			((uint32_t)input[33] << 21) |
			((uint32_t)(input[34] & 0xf8) << 13);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 277 to 292
	value = ((uint32_t)(input[34] & 0x07) << 29) |
			((uint32_t)input[35] << 21) |
			((uint32_t)(input[36] & 0xf8) << 13);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 293 to 308
	value = ((uint32_t)(input[36] & 0x07) << 29) |
			((uint32_t)input[37] << 21) |
			((uint32_t)(input[38] & 0xf8) << 13);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 309 to 324
	value = ((uint32_t)(input[38] & 0x07) << 29) |
			((uint32_t)input[39] << 21) |
			((uint32_t)(input[40] & 0xf8) << 13);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 325 to 340
	value = ((uint32_t)(input[40] & 0x07) << 29) |
			((uint32_t)input[41] << 21) |
			((uint32_t)(input[42] & 0xf8) << 13);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 341 to 356
	value = ((uint32_t)(input[42] & 0x07) << 29) |
			((uint32_t)input[43] << 21) |
			((uint32_t)(input[44] & 0xf8) << 13);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 357 to 372
	value = ((uint32_t)(input[44] & 0x07) << 29) |
			((uint32_t)input[45] << 21) |
			((uint32_t)(input[46] & 0xf8) << 13);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 373 to 388
	value = ((uint32_t)(input[46] & 0x07) << 29) |
			((uint32_t)input[47] << 21) |
			((uint32_t)(input[48] & 0xf8) << 13);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 389 to 404
	value = ((uint32_t)(input[48] & 0x07) << 29) |
			((uint32_t)input[49] << 21) |
			((uint32_t)(input[50] & 0xf8) << 13);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 405 to 420
	value = ((uint32_t)(input[50] & 0x07) << 29) |
			((uint32_t)input[51] << 21) |
			((uint32_t)(input[52] & 0xf8) << 13);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 421 to 436
	value = ((uint32_t)(input[52] & 0x07) << 29) |
			((uint32_t)input[53] << 21) |
			((uint32_t)(input[54] & 0xf8) << 13);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 437 to 452
	value = ((uint32_t)(input[54] & 0x07) << 29) |
			((uint32_t)input[55] << 21) |
			((uint32_t)(input[56] & 0xf8) << 13);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 453 to 468
	value = ((uint32_t)(input[56] & 0x07) << 29) |
			((uint32_t)input[57] << 21) |
			((uint32_t)(input[58] & 0xf8) << 13);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 469 to 484
	value = ((uint32_t)(input[58] & 0x07) << 29) |
			((uint32_t)input[59] << 21) |
			((uint32_t)(input[60] & 0xf8) << 13);
	output[29] = (double)(value >> 16);
}

static void unpack_30_16bit_signed_6off(const uint8_t * input, double * output, void *closure) {
	// Unpack 30 values into output
	// Values are 16-bit signed
	// Skip 6 bits, read 480 bits of data.
	// Input must be at least 61 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 6 to 21
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)(input[2] & 0xfc) << 14);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 22 to 37
	value = ((uint32_t)(input[2] & 0x03) << 30) |
			((uint32_t)input[3] << 22) |
			((uint32_t)(input[4] & 0xfc) << 14);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 38 to 53
	value = ((uint32_t)(input[4] & 0x03) << 30) |
			((uint32_t)input[5] << 22) |
			((uint32_t)(input[6] & 0xfc) << 14);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 54 to 69
	value = ((uint32_t)(input[6] & 0x03) << 30) |
			((uint32_t)input[7] << 22) |
			((uint32_t)(input[8] & 0xfc) << 14);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 70 to 85
	value = ((uint32_t)(input[8] & 0x03) << 30) |
			((uint32_t)input[9] << 22) |
			((uint32_t)(input[10] & 0xfc) << 14);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 86 to 101
	value = ((uint32_t)(input[10] & 0x03) << 30) |
			((uint32_t)input[11] << 22) |
			((uint32_t)(input[12] & 0xfc) << 14);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 102 to 117
	value = ((uint32_t)(input[12] & 0x03) << 30) |
			((uint32_t)input[13] << 22) |
			((uint32_t)(input[14] & 0xfc) << 14);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 118 to 133
	value = ((uint32_t)(input[14] & 0x03) << 30) |
			((uint32_t)input[15] << 22) |
			((uint32_t)(input[16] & 0xfc) << 14);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 134 to 149
	value = ((uint32_t)(input[16] & 0x03) << 30) |
			((uint32_t)input[17] << 22) |
			((uint32_t)(input[18] & 0xfc) << 14);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 150 to 165
	value = ((uint32_t)(input[18] & 0x03) << 30) |
			((uint32_t)input[19] << 22) |
			((uint32_t)(input[20] & 0xfc) << 14);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 166 to 181
	value = ((uint32_t)(input[20] & 0x03) << 30) |
			((uint32_t)input[21] << 22) |
			((uint32_t)(input[22] & 0xfc) << 14);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 182 to 197
	value = ((uint32_t)(input[22] & 0x03) << 30) |
			((uint32_t)input[23] << 22) |
			((uint32_t)(input[24] & 0xfc) << 14);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 198 to 213
	value = ((uint32_t)(input[24] & 0x03) << 30) |
			((uint32_t)input[25] << 22) |
			((uint32_t)(input[26] & 0xfc) << 14);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 214 to 229
	value = ((uint32_t)(input[26] & 0x03) << 30) |
			((uint32_t)input[27] << 22) |
			((uint32_t)(input[28] & 0xfc) << 14);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 230 to 245
	value = ((uint32_t)(input[28] & 0x03) << 30) |
			((uint32_t)input[29] << 22) |
			((uint32_t)(input[30] & 0xfc) << 14);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 246 to 261
	value = ((uint32_t)(input[30] & 0x03) << 30) |
			((uint32_t)input[31] << 22) |
			((uint32_t)(input[32] & 0xfc) << 14);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 262 to 277
	value = ((uint32_t)(input[32] & 0x03) << 30) |
			((uint32_t)input[33] << 22) |
			((uint32_t)(input[34] & 0xfc) << 14);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 278 to 293
	value = ((uint32_t)(input[34] & 0x03) << 30) |
			((uint32_t)input[35] << 22) |
			((uint32_t)(input[36] & 0xfc) << 14);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 294 to 309
	value = ((uint32_t)(input[36] & 0x03) << 30) |
			((uint32_t)input[37] << 22) |
			((uint32_t)(input[38] & 0xfc) << 14);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 310 to 325
	value = ((uint32_t)(input[38] & 0x03) << 30) |
			((uint32_t)input[39] << 22) |
			((uint32_t)(input[40] & 0xfc) << 14);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 326 to 341
	value = ((uint32_t)(input[40] & 0x03) << 30) |
			((uint32_t)input[41] << 22) |
			((uint32_t)(input[42] & 0xfc) << 14);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 342 to 357
	value = ((uint32_t)(input[42] & 0x03) << 30) |
			((uint32_t)input[43] << 22) |
			((uint32_t)(input[44] & 0xfc) << 14);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 358 to 373
	value = ((uint32_t)(input[44] & 0x03) << 30) |
			((uint32_t)input[45] << 22) |
			((uint32_t)(input[46] & 0xfc) << 14);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 374 to 389
	value = ((uint32_t)(input[46] & 0x03) << 30) |
			((uint32_t)input[47] << 22) |
			((uint32_t)(input[48] & 0xfc) << 14);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 390 to 405
	value = ((uint32_t)(input[48] & 0x03) << 30) |
			((uint32_t)input[49] << 22) |
			((uint32_t)(input[50] & 0xfc) << 14);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 406 to 421
	value = ((uint32_t)(input[50] & 0x03) << 30) |
			((uint32_t)input[51] << 22) |
			((uint32_t)(input[52] & 0xfc) << 14);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 422 to 437
	value = ((uint32_t)(input[52] & 0x03) << 30) |
			((uint32_t)input[53] << 22) |
			((uint32_t)(input[54] & 0xfc) << 14);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 438 to 453
	value = ((uint32_t)(input[54] & 0x03) << 30) |
			((uint32_t)input[55] << 22) |
			((uint32_t)(input[56] & 0xfc) << 14);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 454 to 469
	value = ((uint32_t)(input[56] & 0x03) << 30) |
			((uint32_t)input[57] << 22) |
			((uint32_t)(input[58] & 0xfc) << 14);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 470 to 485
	value = ((uint32_t)(input[58] & 0x03) << 30) |
			((uint32_t)input[59] << 22) |
			((uint32_t)(input[60] & 0xfc) << 14);
	output[29] = (double)(value >> 16);
}

static void unpack_30_16bit_unsigned_6off(const uint8_t * input, double * output, void *closure) {
	// Unpack 30 values into output
	// Values are 16-bit unsigned
	// Skip 6 bits, read 480 bits of data.
	// Input must be at least 61 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 6 to 21
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)(input[2] & 0xfc) << 14);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 22 to 37
	value = ((uint32_t)(input[2] & 0x03) << 30) |
			((uint32_t)input[3] << 22) |
			((uint32_t)(input[4] & 0xfc) << 14);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 38 to 53
	value = ((uint32_t)(input[4] & 0x03) << 30) |
			((uint32_t)input[5] << 22) |
			((uint32_t)(input[6] & 0xfc) << 14);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 54 to 69
	value = ((uint32_t)(input[6] & 0x03) << 30) |
			((uint32_t)input[7] << 22) |
			((uint32_t)(input[8] & 0xfc) << 14);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 70 to 85
	value = ((uint32_t)(input[8] & 0x03) << 30) |
			((uint32_t)input[9] << 22) |
			((uint32_t)(input[10] & 0xfc) << 14);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 86 to 101
	value = ((uint32_t)(input[10] & 0x03) << 30) |
			((uint32_t)input[11] << 22) |
			((uint32_t)(input[12] & 0xfc) << 14);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 102 to 117
	value = ((uint32_t)(input[12] & 0x03) << 30) |
			((uint32_t)input[13] << 22) |
			((uint32_t)(input[14] & 0xfc) << 14);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 118 to 133
	value = ((uint32_t)(input[14] & 0x03) << 30) |
			((uint32_t)input[15] << 22) |
			((uint32_t)(input[16] & 0xfc) << 14);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 134 to 149
	value = ((uint32_t)(input[16] & 0x03) << 30) |
			((uint32_t)input[17] << 22) |
			((uint32_t)(input[18] & 0xfc) << 14);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 150 to 165
	value = ((uint32_t)(input[18] & 0x03) << 30) |
			((uint32_t)input[19] << 22) |
			((uint32_t)(input[20] & 0xfc) << 14);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 166 to 181
	value = ((uint32_t)(input[20] & 0x03) << 30) |
			((uint32_t)input[21] << 22) |
			((uint32_t)(input[22] & 0xfc) << 14);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 182 to 197
	value = ((uint32_t)(input[22] & 0x03) << 30) |
			((uint32_t)input[23] << 22) |
			((uint32_t)(input[24] & 0xfc) << 14);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 198 to 213
	value = ((uint32_t)(input[24] & 0x03) << 30) |
			((uint32_t)input[25] << 22) |
			((uint32_t)(input[26] & 0xfc) << 14);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 214 to 229
	value = ((uint32_t)(input[26] & 0x03) << 30) |
			((uint32_t)input[27] << 22) |
			((uint32_t)(input[28] & 0xfc) << 14);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 230 to 245
	value = ((uint32_t)(input[28] & 0x03) << 30) |
			((uint32_t)input[29] << 22) |
			((uint32_t)(input[30] & 0xfc) << 14);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 246 to 261
	value = ((uint32_t)(input[30] & 0x03) << 30) |
			((uint32_t)input[31] << 22) |
			((uint32_t)(input[32] & 0xfc) << 14);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 262 to 277
	value = ((uint32_t)(input[32] & 0x03) << 30) |
			((uint32_t)input[33] << 22) |
			((uint32_t)(input[34] & 0xfc) << 14);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 278 to 293
	value = ((uint32_t)(input[34] & 0x03) << 30) |
			((uint32_t)input[35] << 22) |
			((uint32_t)(input[36] & 0xfc) << 14);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 294 to 309
	value = ((uint32_t)(input[36] & 0x03) << 30) |
			((uint32_t)input[37] << 22) |
			((uint32_t)(input[38] & 0xfc) << 14);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 310 to 325
	value = ((uint32_t)(input[38] & 0x03) << 30) |
			((uint32_t)input[39] << 22) |
			((uint32_t)(input[40] & 0xfc) << 14);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 326 to 341
	value = ((uint32_t)(input[40] & 0x03) << 30) |
			((uint32_t)input[41] << 22) |
			((uint32_t)(input[42] & 0xfc) << 14);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 342 to 357
	value = ((uint32_t)(input[42] & 0x03) << 30) |
			((uint32_t)input[43] << 22) |
			((uint32_t)(input[44] & 0xfc) << 14);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 358 to 373
	value = ((uint32_t)(input[44] & 0x03) << 30) |
			((uint32_t)input[45] << 22) |
			((uint32_t)(input[46] & 0xfc) << 14);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 374 to 389
	value = ((uint32_t)(input[46] & 0x03) << 30) |
			((uint32_t)input[47] << 22) |
			((uint32_t)(input[48] & 0xfc) << 14);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 390 to 405
	value = ((uint32_t)(input[48] & 0x03) << 30) |
			((uint32_t)input[49] << 22) |
			((uint32_t)(input[50] & 0xfc) << 14);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 406 to 421
	value = ((uint32_t)(input[50] & 0x03) << 30) |
			((uint32_t)input[51] << 22) |
			((uint32_t)(input[52] & 0xfc) << 14);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 422 to 437
	value = ((uint32_t)(input[52] & 0x03) << 30) |
			((uint32_t)input[53] << 22) |
			((uint32_t)(input[54] & 0xfc) << 14);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 438 to 453
	value = ((uint32_t)(input[54] & 0x03) << 30) |
			((uint32_t)input[55] << 22) |
			((uint32_t)(input[56] & 0xfc) << 14);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 454 to 469
	value = ((uint32_t)(input[56] & 0x03) << 30) |
			((uint32_t)input[57] << 22) |
			((uint32_t)(input[58] & 0xfc) << 14);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 470 to 485
	value = ((uint32_t)(input[58] & 0x03) << 30) |
			((uint32_t)input[59] << 22) |
			((uint32_t)(input[60] & 0xfc) << 14);
	output[29] = (double)(value >> 16);
}

static void unpack_30_16bit_signed_7off(const uint8_t * input, double * output, void *closure) {
	// Unpack 30 values into output
	// Values are 16-bit signed
	// Skip 7 bits, read 480 bits of data.
	// Input must be at least 61 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 7 to 22
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)(input[2] & 0xfe) << 15);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 23 to 38
	value = ((uint32_t)(input[2] & 0x01) << 31) |
			((uint32_t)input[3] << 23) |
			((uint32_t)(input[4] & 0xfe) << 15);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 39 to 54
	value = ((uint32_t)(input[4] & 0x01) << 31) |
			((uint32_t)input[5] << 23) |
			((uint32_t)(input[6] & 0xfe) << 15);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 55 to 70
	value = ((uint32_t)(input[6] & 0x01) << 31) |
			((uint32_t)input[7] << 23) |
			((uint32_t)(input[8] & 0xfe) << 15);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 71 to 86
	value = ((uint32_t)(input[8] & 0x01) << 31) |
			((uint32_t)input[9] << 23) |
			((uint32_t)(input[10] & 0xfe) << 15);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 87 to 102
	value = ((uint32_t)(input[10] & 0x01) << 31) |
			((uint32_t)input[11] << 23) |
			((uint32_t)(input[12] & 0xfe) << 15);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 103 to 118
	value = ((uint32_t)(input[12] & 0x01) << 31) |
			((uint32_t)input[13] << 23) |
			((uint32_t)(input[14] & 0xfe) << 15);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 119 to 134
	value = ((uint32_t)(input[14] & 0x01) << 31) |
			((uint32_t)input[15] << 23) |
			((uint32_t)(input[16] & 0xfe) << 15);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 135 to 150
	value = ((uint32_t)(input[16] & 0x01) << 31) |
			((uint32_t)input[17] << 23) |
			((uint32_t)(input[18] & 0xfe) << 15);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 151 to 166
	value = ((uint32_t)(input[18] & 0x01) << 31) |
			((uint32_t)input[19] << 23) |
			((uint32_t)(input[20] & 0xfe) << 15);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 167 to 182
	value = ((uint32_t)(input[20] & 0x01) << 31) |
			((uint32_t)input[21] << 23) |
			((uint32_t)(input[22] & 0xfe) << 15);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 183 to 198
	value = ((uint32_t)(input[22] & 0x01) << 31) |
			((uint32_t)input[23] << 23) |
			((uint32_t)(input[24] & 0xfe) << 15);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 199 to 214
	value = ((uint32_t)(input[24] & 0x01) << 31) |
			((uint32_t)input[25] << 23) |
			((uint32_t)(input[26] & 0xfe) << 15);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 215 to 230
	value = ((uint32_t)(input[26] & 0x01) << 31) |
			((uint32_t)input[27] << 23) |
			((uint32_t)(input[28] & 0xfe) << 15);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 231 to 246
	value = ((uint32_t)(input[28] & 0x01) << 31) |
			((uint32_t)input[29] << 23) |
			((uint32_t)(input[30] & 0xfe) << 15);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 247 to 262
	value = ((uint32_t)(input[30] & 0x01) << 31) |
			((uint32_t)input[31] << 23) |
			((uint32_t)(input[32] & 0xfe) << 15);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 263 to 278
	value = ((uint32_t)(input[32] & 0x01) << 31) |
			((uint32_t)input[33] << 23) |
			((uint32_t)(input[34] & 0xfe) << 15);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 279 to 294
	value = ((uint32_t)(input[34] & 0x01) << 31) |
			((uint32_t)input[35] << 23) |
			((uint32_t)(input[36] & 0xfe) << 15);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 295 to 310
	value = ((uint32_t)(input[36] & 0x01) << 31) |
			((uint32_t)input[37] << 23) |
			((uint32_t)(input[38] & 0xfe) << 15);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 311 to 326
	value = ((uint32_t)(input[38] & 0x01) << 31) |
			((uint32_t)input[39] << 23) |
			((uint32_t)(input[40] & 0xfe) << 15);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 327 to 342
	value = ((uint32_t)(input[40] & 0x01) << 31) |
			((uint32_t)input[41] << 23) |
			((uint32_t)(input[42] & 0xfe) << 15);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 343 to 358
	value = ((uint32_t)(input[42] & 0x01) << 31) |
			((uint32_t)input[43] << 23) |
			((uint32_t)(input[44] & 0xfe) << 15);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 359 to 374
	value = ((uint32_t)(input[44] & 0x01) << 31) |
			((uint32_t)input[45] << 23) |
			((uint32_t)(input[46] & 0xfe) << 15);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 375 to 390
	value = ((uint32_t)(input[46] & 0x01) << 31) |
			((uint32_t)input[47] << 23) |
			((uint32_t)(input[48] & 0xfe) << 15);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 391 to 406
	value = ((uint32_t)(input[48] & 0x01) << 31) |
			((uint32_t)input[49] << 23) |
			((uint32_t)(input[50] & 0xfe) << 15);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 407 to 422
	value = ((uint32_t)(input[50] & 0x01) << 31) |
			((uint32_t)input[51] << 23) |
			((uint32_t)(input[52] & 0xfe) << 15);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 423 to 438
	value = ((uint32_t)(input[52] & 0x01) << 31) |
			((uint32_t)input[53] << 23) |
			((uint32_t)(input[54] & 0xfe) << 15);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 439 to 454
	value = ((uint32_t)(input[54] & 0x01) << 31) |
			((uint32_t)input[55] << 23) |
			((uint32_t)(input[56] & 0xfe) << 15);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 455 to 470
	value = ((uint32_t)(input[56] & 0x01) << 31) |
			((uint32_t)input[57] << 23) |
			((uint32_t)(input[58] & 0xfe) << 15);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 471 to 486
	value = ((uint32_t)(input[58] & 0x01) << 31) |
			((uint32_t)input[59] << 23) |
			((uint32_t)(input[60] & 0xfe) << 15);
	output[29] = (double)(value >> 16);
}

static void unpack_30_16bit_unsigned_7off(const uint8_t * input, double * output, void *closure) {
	// Unpack 30 values into output
	// Values are 16-bit unsigned
	// Skip 7 bits, read 480 bits of data.
	// Input must be at least 61 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 7 to 22
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)(input[2] & 0xfe) << 15);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 23 to 38
	value = ((uint32_t)(input[2] & 0x01) << 31) |
			((uint32_t)input[3] << 23) |
			((uint32_t)(input[4] & 0xfe) << 15);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 39 to 54
	value = ((uint32_t)(input[4] & 0x01) << 31) |
			((uint32_t)input[5] << 23) |
			((uint32_t)(input[6] & 0xfe) << 15);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 55 to 70
	value = ((uint32_t)(input[6] & 0x01) << 31) |
			((uint32_t)input[7] << 23) |
			((uint32_t)(input[8] & 0xfe) << 15);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 71 to 86
	value = ((uint32_t)(input[8] & 0x01) << 31) |
			((uint32_t)input[9] << 23) |
			((uint32_t)(input[10] & 0xfe) << 15);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 87 to 102
	value = ((uint32_t)(input[10] & 0x01) << 31) |
			((uint32_t)input[11] << 23) |
			((uint32_t)(input[12] & 0xfe) << 15);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 103 to 118
	value = ((uint32_t)(input[12] & 0x01) << 31) |
			((uint32_t)input[13] << 23) |
			((uint32_t)(input[14] & 0xfe) << 15);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 119 to 134
	value = ((uint32_t)(input[14] & 0x01) << 31) |
			((uint32_t)input[15] << 23) |
			((uint32_t)(input[16] & 0xfe) << 15);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 135 to 150
	value = ((uint32_t)(input[16] & 0x01) << 31) |
			((uint32_t)input[17] << 23) |
			((uint32_t)(input[18] & 0xfe) << 15);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 151 to 166
	value = ((uint32_t)(input[18] & 0x01) << 31) |
			((uint32_t)input[19] << 23) |
			((uint32_t)(input[20] & 0xfe) << 15);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 167 to 182
	value = ((uint32_t)(input[20] & 0x01) << 31) |
			((uint32_t)input[21] << 23) |
			((uint32_t)(input[22] & 0xfe) << 15);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 183 to 198
	value = ((uint32_t)(input[22] & 0x01) << 31) |
			((uint32_t)input[23] << 23) |
			((uint32_t)(input[24] & 0xfe) << 15);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 199 to 214
	value = ((uint32_t)(input[24] & 0x01) << 31) |
			((uint32_t)input[25] << 23) |
			((uint32_t)(input[26] & 0xfe) << 15);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 215 to 230
	value = ((uint32_t)(input[26] & 0x01) << 31) |
			((uint32_t)input[27] << 23) |
			((uint32_t)(input[28] & 0xfe) << 15);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 231 to 246
	value = ((uint32_t)(input[28] & 0x01) << 31) |
			((uint32_t)input[29] << 23) |
			((uint32_t)(input[30] & 0xfe) << 15);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 247 to 262
	value = ((uint32_t)(input[30] & 0x01) << 31) |
			((uint32_t)input[31] << 23) |
			((uint32_t)(input[32] & 0xfe) << 15);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 263 to 278
	value = ((uint32_t)(input[32] & 0x01) << 31) |
			((uint32_t)input[33] << 23) |
			((uint32_t)(input[34] & 0xfe) << 15);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 279 to 294
	value = ((uint32_t)(input[34] & 0x01) << 31) |
			((uint32_t)input[35] << 23) |
			((uint32_t)(input[36] & 0xfe) << 15);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 295 to 310
	value = ((uint32_t)(input[36] & 0x01) << 31) |
			((uint32_t)input[37] << 23) |
			((uint32_t)(input[38] & 0xfe) << 15);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 311 to 326
	value = ((uint32_t)(input[38] & 0x01) << 31) |
			((uint32_t)input[39] << 23) |
			((uint32_t)(input[40] & 0xfe) << 15);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 327 to 342
	value = ((uint32_t)(input[40] & 0x01) << 31) |
			((uint32_t)input[41] << 23) |
			((uint32_t)(input[42] & 0xfe) << 15);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 343 to 358
	value = ((uint32_t)(input[42] & 0x01) << 31) |
			((uint32_t)input[43] << 23) |
			((uint32_t)(input[44] & 0xfe) << 15);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 359 to 374
	value = ((uint32_t)(input[44] & 0x01) << 31) |
			((uint32_t)input[45] << 23) |
			((uint32_t)(input[46] & 0xfe) << 15);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 375 to 390
	value = ((uint32_t)(input[46] & 0x01) << 31) |
			((uint32_t)input[47] << 23) |
			((uint32_t)(input[48] & 0xfe) << 15);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 391 to 406
	value = ((uint32_t)(input[48] & 0x01) << 31) |
			((uint32_t)input[49] << 23) |
			((uint32_t)(input[50] & 0xfe) << 15);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 407 to 422
	value = ((uint32_t)(input[50] & 0x01) << 31) |
			((uint32_t)input[51] << 23) |
			((uint32_t)(input[52] & 0xfe) << 15);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 423 to 438
	value = ((uint32_t)(input[52] & 0x01) << 31) |
			((uint32_t)input[53] << 23) |
			((uint32_t)(input[54] & 0xfe) << 15);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 439 to 454
	value = ((uint32_t)(input[54] & 0x01) << 31) |
			((uint32_t)input[55] << 23) |
			((uint32_t)(input[56] & 0xfe) << 15);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 455 to 470
	value = ((uint32_t)(input[56] & 0x01) << 31) |
			((uint32_t)input[57] << 23) |
			((uint32_t)(input[58] & 0xfe) << 15);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 471 to 486
	value = ((uint32_t)(input[58] & 0x01) << 31) |
			((uint32_t)input[59] << 23) |
			((uint32_t)(input[60] & 0xfe) << 15);
	output[29] = (double)(value >> 16);
}

static void unpack_31_16bit_signed_0off(const uint8_t * input, double * output, void *closure) {
	// Unpack 31 values into output
	// Values are 16-bit signed
	// Skip 0 bits, read 496 bits of data.
	// Input must be at least 62 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 0 to 15
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)input[1] << 16);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 16 to 31
	value = ((uint32_t)input[2] << 24) |
			((uint32_t)input[3] << 16);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 32 to 47
	value = ((uint32_t)input[4] << 24) |
			((uint32_t)input[5] << 16);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 48 to 63
	value = ((uint32_t)input[6] << 24) |
			((uint32_t)input[7] << 16);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 64 to 79
	value = ((uint32_t)input[8] << 24) |
			((uint32_t)input[9] << 16);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 80 to 95
	value = ((uint32_t)input[10] << 24) |
			((uint32_t)input[11] << 16);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 96 to 111
	value = ((uint32_t)input[12] << 24) |
			((uint32_t)input[13] << 16);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 112 to 127
	value = ((uint32_t)input[14] << 24) |
			((uint32_t)input[15] << 16);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 128 to 143
	value = ((uint32_t)input[16] << 24) |
			((uint32_t)input[17] << 16);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 144 to 159
	value = ((uint32_t)input[18] << 24) |
			((uint32_t)input[19] << 16);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 160 to 175
	value = ((uint32_t)input[20] << 24) |
			((uint32_t)input[21] << 16);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 176 to 191
	value = ((uint32_t)input[22] << 24) |
			((uint32_t)input[23] << 16);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 192 to 207
	value = ((uint32_t)input[24] << 24) |
			((uint32_t)input[25] << 16);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 208 to 223
	value = ((uint32_t)input[26] << 24) |
			((uint32_t)input[27] << 16);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 224 to 239
	value = ((uint32_t)input[28] << 24) |
			((uint32_t)input[29] << 16);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 240 to 255
	value = ((uint32_t)input[30] << 24) |
			((uint32_t)input[31] << 16);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 256 to 271
	value = ((uint32_t)input[32] << 24) |
			((uint32_t)input[33] << 16);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 272 to 287
	value = ((uint32_t)input[34] << 24) |
			((uint32_t)input[35] << 16);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 288 to 303
	value = ((uint32_t)input[36] << 24) |
			((uint32_t)input[37] << 16);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 304 to 319
	value = ((uint32_t)input[38] << 24) |
			((uint32_t)input[39] << 16);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 320 to 335
	value = ((uint32_t)input[40] << 24) |
			((uint32_t)input[41] << 16);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 336 to 351
	value = ((uint32_t)input[42] << 24) |
			((uint32_t)input[43] << 16);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 352 to 367
	value = ((uint32_t)input[44] << 24) |
			((uint32_t)input[45] << 16);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 368 to 383
	value = ((uint32_t)input[46] << 24) |
			((uint32_t)input[47] << 16);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 384 to 399
	value = ((uint32_t)input[48] << 24) |
			((uint32_t)input[49] << 16);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 400 to 415
	value = ((uint32_t)input[50] << 24) |
			((uint32_t)input[51] << 16);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 416 to 431
	value = ((uint32_t)input[52] << 24) |
			((uint32_t)input[53] << 16);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 432 to 447
	value = ((uint32_t)input[54] << 24) |
			((uint32_t)input[55] << 16);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 448 to 463
	value = ((uint32_t)input[56] << 24) |
			((uint32_t)input[57] << 16);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 464 to 479
	value = ((uint32_t)input[58] << 24) |
			((uint32_t)input[59] << 16);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 480 to 495
	value = ((uint32_t)input[60] << 24) |
			((uint32_t)input[61] << 16);
	output[30] = (double)(value >> 16);
}

static void unpack_31_16bit_unsigned_0off(const uint8_t * input, double * output, void *closure) {
	// Unpack 31 values into output
	// Values are 16-bit unsigned
	// Skip 0 bits, read 496 bits of data.
	// Input must be at least 62 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 0 to 15
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)input[1] << 16);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 16 to 31
	value = ((uint32_t)input[2] << 24) |
			((uint32_t)input[3] << 16);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 32 to 47
	value = ((uint32_t)input[4] << 24) |
			((uint32_t)input[5] << 16);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 48 to 63
	value = ((uint32_t)input[6] << 24) |
			((uint32_t)input[7] << 16);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 64 to 79
	value = ((uint32_t)input[8] << 24) |
			((uint32_t)input[9] << 16);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 80 to 95
	value = ((uint32_t)input[10] << 24) |
			((uint32_t)input[11] << 16);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 96 to 111
	value = ((uint32_t)input[12] << 24) |
			((uint32_t)input[13] << 16);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 112 to 127
	value = ((uint32_t)input[14] << 24) |
			((uint32_t)input[15] << 16);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 128 to 143
	value = ((uint32_t)input[16] << 24) |
			((uint32_t)input[17] << 16);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 144 to 159
	value = ((uint32_t)input[18] << 24) |
			((uint32_t)input[19] << 16);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 160 to 175
	value = ((uint32_t)input[20] << 24) |
			((uint32_t)input[21] << 16);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 176 to 191
	value = ((uint32_t)input[22] << 24) |
			((uint32_t)input[23] << 16);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 192 to 207
	value = ((uint32_t)input[24] << 24) |
			((uint32_t)input[25] << 16);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 208 to 223
	value = ((uint32_t)input[26] << 24) |
			((uint32_t)input[27] << 16);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 224 to 239
	value = ((uint32_t)input[28] << 24) |
			((uint32_t)input[29] << 16);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 240 to 255
	value = ((uint32_t)input[30] << 24) |
			((uint32_t)input[31] << 16);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 256 to 271
	value = ((uint32_t)input[32] << 24) |
			((uint32_t)input[33] << 16);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 272 to 287
	value = ((uint32_t)input[34] << 24) |
			((uint32_t)input[35] << 16);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 288 to 303
	value = ((uint32_t)input[36] << 24) |
			((uint32_t)input[37] << 16);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 304 to 319
	value = ((uint32_t)input[38] << 24) |
			((uint32_t)input[39] << 16);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 320 to 335
	value = ((uint32_t)input[40] << 24) |
			((uint32_t)input[41] << 16);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 336 to 351
	value = ((uint32_t)input[42] << 24) |
			((uint32_t)input[43] << 16);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 352 to 367
	value = ((uint32_t)input[44] << 24) |
			((uint32_t)input[45] << 16);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 368 to 383
	value = ((uint32_t)input[46] << 24) |
			((uint32_t)input[47] << 16);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 384 to 399
	value = ((uint32_t)input[48] << 24) |
			((uint32_t)input[49] << 16);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 400 to 415
	value = ((uint32_t)input[50] << 24) |
			((uint32_t)input[51] << 16);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 416 to 431
	value = ((uint32_t)input[52] << 24) |
			((uint32_t)input[53] << 16);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 432 to 447
	value = ((uint32_t)input[54] << 24) |
			((uint32_t)input[55] << 16);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 448 to 463
	value = ((uint32_t)input[56] << 24) |
			((uint32_t)input[57] << 16);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 464 to 479
	value = ((uint32_t)input[58] << 24) |
			((uint32_t)input[59] << 16);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 480 to 495
	value = ((uint32_t)input[60] << 24) |
			((uint32_t)input[61] << 16);
	output[30] = (double)(value >> 16);
}

static void unpack_31_16bit_signed_1off(const uint8_t * input, double * output, void *closure) {
	// Unpack 31 values into output
	// Values are 16-bit signed
	// Skip 1 bits, read 496 bits of data.
	// Input must be at least 63 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 1 to 16
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)input[1] << 17) |
			((uint32_t)(input[2] & 0x80) << 9);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 17 to 32
	value = ((uint32_t)(input[2] & 0x7f) << 25) |
			((uint32_t)input[3] << 17) |
			((uint32_t)(input[4] & 0x80) << 9);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 33 to 48
	value = ((uint32_t)(input[4] & 0x7f) << 25) |
			((uint32_t)input[5] << 17) |
			((uint32_t)(input[6] & 0x80) << 9);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 49 to 64
	value = ((uint32_t)(input[6] & 0x7f) << 25) |
			((uint32_t)input[7] << 17) |
			((uint32_t)(input[8] & 0x80) << 9);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 65 to 80
	value = ((uint32_t)(input[8] & 0x7f) << 25) |
			((uint32_t)input[9] << 17) |
			((uint32_t)(input[10] & 0x80) << 9);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 81 to 96
	value = ((uint32_t)(input[10] & 0x7f) << 25) |
			((uint32_t)input[11] << 17) |
			((uint32_t)(input[12] & 0x80) << 9);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 97 to 112
	value = ((uint32_t)(input[12] & 0x7f) << 25) |
			((uint32_t)input[13] << 17) |
			((uint32_t)(input[14] & 0x80) << 9);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 113 to 128
	value = ((uint32_t)(input[14] & 0x7f) << 25) |
			((uint32_t)input[15] << 17) |
			((uint32_t)(input[16] & 0x80) << 9);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 129 to 144
	value = ((uint32_t)(input[16] & 0x7f) << 25) |
			((uint32_t)input[17] << 17) |
			((uint32_t)(input[18] & 0x80) << 9);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 145 to 160
	value = ((uint32_t)(input[18] & 0x7f) << 25) |
			((uint32_t)input[19] << 17) |
			((uint32_t)(input[20] & 0x80) << 9);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 161 to 176
	value = ((uint32_t)(input[20] & 0x7f) << 25) |
			((uint32_t)input[21] << 17) |
			((uint32_t)(input[22] & 0x80) << 9);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 177 to 192
	value = ((uint32_t)(input[22] & 0x7f) << 25) |
			((uint32_t)input[23] << 17) |
			((uint32_t)(input[24] & 0x80) << 9);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 193 to 208
	value = ((uint32_t)(input[24] & 0x7f) << 25) |
			((uint32_t)input[25] << 17) |
			((uint32_t)(input[26] & 0x80) << 9);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 209 to 224
	value = ((uint32_t)(input[26] & 0x7f) << 25) |
			((uint32_t)input[27] << 17) |
			((uint32_t)(input[28] & 0x80) << 9);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 225 to 240
	value = ((uint32_t)(input[28] & 0x7f) << 25) |
			((uint32_t)input[29] << 17) |
			((uint32_t)(input[30] & 0x80) << 9);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 241 to 256
	value = ((uint32_t)(input[30] & 0x7f) << 25) |
			((uint32_t)input[31] << 17) |
			((uint32_t)(input[32] & 0x80) << 9);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 257 to 272
	value = ((uint32_t)(input[32] & 0x7f) << 25) |
			((uint32_t)input[33] << 17) |
			((uint32_t)(input[34] & 0x80) << 9);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 273 to 288
	value = ((uint32_t)(input[34] & 0x7f) << 25) |
			((uint32_t)input[35] << 17) |
			((uint32_t)(input[36] & 0x80) << 9);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 289 to 304
	value = ((uint32_t)(input[36] & 0x7f) << 25) |
			((uint32_t)input[37] << 17) |
			((uint32_t)(input[38] & 0x80) << 9);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 305 to 320
	value = ((uint32_t)(input[38] & 0x7f) << 25) |
			((uint32_t)input[39] << 17) |
			((uint32_t)(input[40] & 0x80) << 9);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 321 to 336
	value = ((uint32_t)(input[40] & 0x7f) << 25) |
			((uint32_t)input[41] << 17) |
			((uint32_t)(input[42] & 0x80) << 9);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 337 to 352
	value = ((uint32_t)(input[42] & 0x7f) << 25) |
			((uint32_t)input[43] << 17) |
			((uint32_t)(input[44] & 0x80) << 9);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 353 to 368
	value = ((uint32_t)(input[44] & 0x7f) << 25) |
			((uint32_t)input[45] << 17) |
			((uint32_t)(input[46] & 0x80) << 9);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 369 to 384
	value = ((uint32_t)(input[46] & 0x7f) << 25) |
			((uint32_t)input[47] << 17) |
			((uint32_t)(input[48] & 0x80) << 9);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 385 to 400
	value = ((uint32_t)(input[48] & 0x7f) << 25) |
			((uint32_t)input[49] << 17) |
			((uint32_t)(input[50] & 0x80) << 9);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 401 to 416
	value = ((uint32_t)(input[50] & 0x7f) << 25) |
			((uint32_t)input[51] << 17) |
			((uint32_t)(input[52] & 0x80) << 9);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 417 to 432
	value = ((uint32_t)(input[52] & 0x7f) << 25) |
			((uint32_t)input[53] << 17) |
			((uint32_t)(input[54] & 0x80) << 9);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 433 to 448
	value = ((uint32_t)(input[54] & 0x7f) << 25) |
			((uint32_t)input[55] << 17) |
			((uint32_t)(input[56] & 0x80) << 9);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 449 to 464
	value = ((uint32_t)(input[56] & 0x7f) << 25) |
			((uint32_t)input[57] << 17) |
			((uint32_t)(input[58] & 0x80) << 9);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 465 to 480
	value = ((uint32_t)(input[58] & 0x7f) << 25) |
			((uint32_t)input[59] << 17) |
			((uint32_t)(input[60] & 0x80) << 9);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 481 to 496
	value = ((uint32_t)(input[60] & 0x7f) << 25) |
			((uint32_t)input[61] << 17) |
			((uint32_t)(input[62] & 0x80) << 9);
	output[30] = (double)(value >> 16);
}

static void unpack_31_16bit_unsigned_1off(const uint8_t * input, double * output, void *closure) {
	// Unpack 31 values into output
	// Values are 16-bit unsigned
	// Skip 1 bits, read 496 bits of data.
	// Input must be at least 63 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 1 to 16
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)input[1] << 17) |
			((uint32_t)(input[2] & 0x80) << 9);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 17 to 32
	value = ((uint32_t)(input[2] & 0x7f) << 25) |
			((uint32_t)input[3] << 17) |
			((uint32_t)(input[4] & 0x80) << 9);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 33 to 48
	value = ((uint32_t)(input[4] & 0x7f) << 25) |
			((uint32_t)input[5] << 17) |
			((uint32_t)(input[6] & 0x80) << 9);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 49 to 64
	value = ((uint32_t)(input[6] & 0x7f) << 25) |
			((uint32_t)input[7] << 17) |
			((uint32_t)(input[8] & 0x80) << 9);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 65 to 80
	value = ((uint32_t)(input[8] & 0x7f) << 25) |
			((uint32_t)input[9] << 17) |
			((uint32_t)(input[10] & 0x80) << 9);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 81 to 96
	value = ((uint32_t)(input[10] & 0x7f) << 25) |
			((uint32_t)input[11] << 17) |
			((uint32_t)(input[12] & 0x80) << 9);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 97 to 112
	value = ((uint32_t)(input[12] & 0x7f) << 25) |
			((uint32_t)input[13] << 17) |
			((uint32_t)(input[14] & 0x80) << 9);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 113 to 128
	value = ((uint32_t)(input[14] & 0x7f) << 25) |
			((uint32_t)input[15] << 17) |
			((uint32_t)(input[16] & 0x80) << 9);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 129 to 144
	value = ((uint32_t)(input[16] & 0x7f) << 25) |
			((uint32_t)input[17] << 17) |
			((uint32_t)(input[18] & 0x80) << 9);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 145 to 160
	value = ((uint32_t)(input[18] & 0x7f) << 25) |
			((uint32_t)input[19] << 17) |
			((uint32_t)(input[20] & 0x80) << 9);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 161 to 176
	value = ((uint32_t)(input[20] & 0x7f) << 25) |
			((uint32_t)input[21] << 17) |
			((uint32_t)(input[22] & 0x80) << 9);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 177 to 192
	value = ((uint32_t)(input[22] & 0x7f) << 25) |
			((uint32_t)input[23] << 17) |
			((uint32_t)(input[24] & 0x80) << 9);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 193 to 208
	value = ((uint32_t)(input[24] & 0x7f) << 25) |
			((uint32_t)input[25] << 17) |
			((uint32_t)(input[26] & 0x80) << 9);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 209 to 224
	value = ((uint32_t)(input[26] & 0x7f) << 25) |
			((uint32_t)input[27] << 17) |
			((uint32_t)(input[28] & 0x80) << 9);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 225 to 240
	value = ((uint32_t)(input[28] & 0x7f) << 25) |
			((uint32_t)input[29] << 17) |
			((uint32_t)(input[30] & 0x80) << 9);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 241 to 256
	value = ((uint32_t)(input[30] & 0x7f) << 25) |
			((uint32_t)input[31] << 17) |
			((uint32_t)(input[32] & 0x80) << 9);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 257 to 272
	value = ((uint32_t)(input[32] & 0x7f) << 25) |
			((uint32_t)input[33] << 17) |
			((uint32_t)(input[34] & 0x80) << 9);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 273 to 288
	value = ((uint32_t)(input[34] & 0x7f) << 25) |
			((uint32_t)input[35] << 17) |
			((uint32_t)(input[36] & 0x80) << 9);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 289 to 304
	value = ((uint32_t)(input[36] & 0x7f) << 25) |
			((uint32_t)input[37] << 17) |
			((uint32_t)(input[38] & 0x80) << 9);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 305 to 320
	value = ((uint32_t)(input[38] & 0x7f) << 25) |
			((uint32_t)input[39] << 17) |
			((uint32_t)(input[40] & 0x80) << 9);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 321 to 336
	value = ((uint32_t)(input[40] & 0x7f) << 25) |
			((uint32_t)input[41] << 17) |
			((uint32_t)(input[42] & 0x80) << 9);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 337 to 352
	value = ((uint32_t)(input[42] & 0x7f) << 25) |
			((uint32_t)input[43] << 17) |
			((uint32_t)(input[44] & 0x80) << 9);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 353 to 368
	value = ((uint32_t)(input[44] & 0x7f) << 25) |
			((uint32_t)input[45] << 17) |
			((uint32_t)(input[46] & 0x80) << 9);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 369 to 384
	value = ((uint32_t)(input[46] & 0x7f) << 25) |
			((uint32_t)input[47] << 17) |
			((uint32_t)(input[48] & 0x80) << 9);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 385 to 400
	value = ((uint32_t)(input[48] & 0x7f) << 25) |
			((uint32_t)input[49] << 17) |
			((uint32_t)(input[50] & 0x80) << 9);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 401 to 416
	value = ((uint32_t)(input[50] & 0x7f) << 25) |
			((uint32_t)input[51] << 17) |
			((uint32_t)(input[52] & 0x80) << 9);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 417 to 432
	value = ((uint32_t)(input[52] & 0x7f) << 25) |
			((uint32_t)input[53] << 17) |
			((uint32_t)(input[54] & 0x80) << 9);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 433 to 448
	value = ((uint32_t)(input[54] & 0x7f) << 25) |
			((uint32_t)input[55] << 17) |
			((uint32_t)(input[56] & 0x80) << 9);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 449 to 464
	value = ((uint32_t)(input[56] & 0x7f) << 25) |
			((uint32_t)input[57] << 17) |
			((uint32_t)(input[58] & 0x80) << 9);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 465 to 480
	value = ((uint32_t)(input[58] & 0x7f) << 25) |
			((uint32_t)input[59] << 17) |
			((uint32_t)(input[60] & 0x80) << 9);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 481 to 496
	value = ((uint32_t)(input[60] & 0x7f) << 25) |
			((uint32_t)input[61] << 17) |
			((uint32_t)(input[62] & 0x80) << 9);
	output[30] = (double)(value >> 16);
}

static void unpack_31_16bit_signed_2off(const uint8_t * input, double * output, void *closure) {
	// Unpack 31 values into output
	// Values are 16-bit signed
	// Skip 2 bits, read 496 bits of data.
	// Input must be at least 63 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 2 to 17
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)input[1] << 18) |
			((uint32_t)(input[2] & 0xc0) << 10);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 18 to 33
	value = ((uint32_t)(input[2] & 0x3f) << 26) |
			((uint32_t)input[3] << 18) |
			((uint32_t)(input[4] & 0xc0) << 10);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 34 to 49
	value = ((uint32_t)(input[4] & 0x3f) << 26) |
			((uint32_t)input[5] << 18) |
			((uint32_t)(input[6] & 0xc0) << 10);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 50 to 65
	value = ((uint32_t)(input[6] & 0x3f) << 26) |
			((uint32_t)input[7] << 18) |
			((uint32_t)(input[8] & 0xc0) << 10);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 66 to 81
	value = ((uint32_t)(input[8] & 0x3f) << 26) |
			((uint32_t)input[9] << 18) |
			((uint32_t)(input[10] & 0xc0) << 10);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 82 to 97
	value = ((uint32_t)(input[10] & 0x3f) << 26) |
			((uint32_t)input[11] << 18) |
			((uint32_t)(input[12] & 0xc0) << 10);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 98 to 113
	value = ((uint32_t)(input[12] & 0x3f) << 26) |
			((uint32_t)input[13] << 18) |
			((uint32_t)(input[14] & 0xc0) << 10);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 114 to 129
	value = ((uint32_t)(input[14] & 0x3f) << 26) |
			((uint32_t)input[15] << 18) |
			((uint32_t)(input[16] & 0xc0) << 10);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 130 to 145
	value = ((uint32_t)(input[16] & 0x3f) << 26) |
			((uint32_t)input[17] << 18) |
			((uint32_t)(input[18] & 0xc0) << 10);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 146 to 161
	value = ((uint32_t)(input[18] & 0x3f) << 26) |
			((uint32_t)input[19] << 18) |
			((uint32_t)(input[20] & 0xc0) << 10);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 162 to 177
	value = ((uint32_t)(input[20] & 0x3f) << 26) |
			((uint32_t)input[21] << 18) |
			((uint32_t)(input[22] & 0xc0) << 10);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 178 to 193
	value = ((uint32_t)(input[22] & 0x3f) << 26) |
			((uint32_t)input[23] << 18) |
			((uint32_t)(input[24] & 0xc0) << 10);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 194 to 209
	value = ((uint32_t)(input[24] & 0x3f) << 26) |
			((uint32_t)input[25] << 18) |
			((uint32_t)(input[26] & 0xc0) << 10);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 210 to 225
	value = ((uint32_t)(input[26] & 0x3f) << 26) |
			((uint32_t)input[27] << 18) |
			((uint32_t)(input[28] & 0xc0) << 10);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 226 to 241
	value = ((uint32_t)(input[28] & 0x3f) << 26) |
			((uint32_t)input[29] << 18) |
			((uint32_t)(input[30] & 0xc0) << 10);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 242 to 257
	value = ((uint32_t)(input[30] & 0x3f) << 26) |
			((uint32_t)input[31] << 18) |
			((uint32_t)(input[32] & 0xc0) << 10);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 258 to 273
	value = ((uint32_t)(input[32] & 0x3f) << 26) |
			((uint32_t)input[33] << 18) |
			((uint32_t)(input[34] & 0xc0) << 10);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 274 to 289
	value = ((uint32_t)(input[34] & 0x3f) << 26) |
			((uint32_t)input[35] << 18) |
			((uint32_t)(input[36] & 0xc0) << 10);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 290 to 305
	value = ((uint32_t)(input[36] & 0x3f) << 26) |
			((uint32_t)input[37] << 18) |
			((uint32_t)(input[38] & 0xc0) << 10);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 306 to 321
	value = ((uint32_t)(input[38] & 0x3f) << 26) |
			((uint32_t)input[39] << 18) |
			((uint32_t)(input[40] & 0xc0) << 10);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 322 to 337
	value = ((uint32_t)(input[40] & 0x3f) << 26) |
			((uint32_t)input[41] << 18) |
			((uint32_t)(input[42] & 0xc0) << 10);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 338 to 353
	value = ((uint32_t)(input[42] & 0x3f) << 26) |
			((uint32_t)input[43] << 18) |
			((uint32_t)(input[44] & 0xc0) << 10);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 354 to 369
	value = ((uint32_t)(input[44] & 0x3f) << 26) |
			((uint32_t)input[45] << 18) |
			((uint32_t)(input[46] & 0xc0) << 10);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 370 to 385
	value = ((uint32_t)(input[46] & 0x3f) << 26) |
			((uint32_t)input[47] << 18) |
			((uint32_t)(input[48] & 0xc0) << 10);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 386 to 401
	value = ((uint32_t)(input[48] & 0x3f) << 26) |
			((uint32_t)input[49] << 18) |
			((uint32_t)(input[50] & 0xc0) << 10);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 402 to 417
	value = ((uint32_t)(input[50] & 0x3f) << 26) |
			((uint32_t)input[51] << 18) |
			((uint32_t)(input[52] & 0xc0) << 10);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 418 to 433
	value = ((uint32_t)(input[52] & 0x3f) << 26) |
			((uint32_t)input[53] << 18) |
			((uint32_t)(input[54] & 0xc0) << 10);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 434 to 449
	value = ((uint32_t)(input[54] & 0x3f) << 26) |
			((uint32_t)input[55] << 18) |
			((uint32_t)(input[56] & 0xc0) << 10);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 450 to 465
	value = ((uint32_t)(input[56] & 0x3f) << 26) |
			((uint32_t)input[57] << 18) |
			((uint32_t)(input[58] & 0xc0) << 10);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 466 to 481
	value = ((uint32_t)(input[58] & 0x3f) << 26) |
			((uint32_t)input[59] << 18) |
			((uint32_t)(input[60] & 0xc0) << 10);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 482 to 497
	value = ((uint32_t)(input[60] & 0x3f) << 26) |
			((uint32_t)input[61] << 18) |
			((uint32_t)(input[62] & 0xc0) << 10);
	output[30] = (double)(value >> 16);
}

static void unpack_31_16bit_unsigned_2off(const uint8_t * input, double * output, void *closure) {
	// Unpack 31 values into output
	// Values are 16-bit unsigned
	// Skip 2 bits, read 496 bits of data.
	// Input must be at least 63 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 2 to 17
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)input[1] << 18) |
			((uint32_t)(input[2] & 0xc0) << 10);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 18 to 33
	value = ((uint32_t)(input[2] & 0x3f) << 26) |
			((uint32_t)input[3] << 18) |
			((uint32_t)(input[4] & 0xc0) << 10);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 34 to 49
	value = ((uint32_t)(input[4] & 0x3f) << 26) |
			((uint32_t)input[5] << 18) |
			((uint32_t)(input[6] & 0xc0) << 10);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 50 to 65
	value = ((uint32_t)(input[6] & 0x3f) << 26) |
			((uint32_t)input[7] << 18) |
			((uint32_t)(input[8] & 0xc0) << 10);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 66 to 81
	value = ((uint32_t)(input[8] & 0x3f) << 26) |
			((uint32_t)input[9] << 18) |
			((uint32_t)(input[10] & 0xc0) << 10);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 82 to 97
	value = ((uint32_t)(input[10] & 0x3f) << 26) |
			((uint32_t)input[11] << 18) |
			((uint32_t)(input[12] & 0xc0) << 10);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 98 to 113
	value = ((uint32_t)(input[12] & 0x3f) << 26) |
			((uint32_t)input[13] << 18) |
			((uint32_t)(input[14] & 0xc0) << 10);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 114 to 129
	value = ((uint32_t)(input[14] & 0x3f) << 26) |
			((uint32_t)input[15] << 18) |
			((uint32_t)(input[16] & 0xc0) << 10);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 130 to 145
	value = ((uint32_t)(input[16] & 0x3f) << 26) |
			((uint32_t)input[17] << 18) |
			((uint32_t)(input[18] & 0xc0) << 10);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 146 to 161
	value = ((uint32_t)(input[18] & 0x3f) << 26) |
			((uint32_t)input[19] << 18) |
			((uint32_t)(input[20] & 0xc0) << 10);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 162 to 177
	value = ((uint32_t)(input[20] & 0x3f) << 26) |
			((uint32_t)input[21] << 18) |
			((uint32_t)(input[22] & 0xc0) << 10);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 178 to 193
	value = ((uint32_t)(input[22] & 0x3f) << 26) |
			((uint32_t)input[23] << 18) |
			((uint32_t)(input[24] & 0xc0) << 10);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 194 to 209
	value = ((uint32_t)(input[24] & 0x3f) << 26) |
			((uint32_t)input[25] << 18) |
			((uint32_t)(input[26] & 0xc0) << 10);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 210 to 225
	value = ((uint32_t)(input[26] & 0x3f) << 26) |
			((uint32_t)input[27] << 18) |
			((uint32_t)(input[28] & 0xc0) << 10);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 226 to 241
	value = ((uint32_t)(input[28] & 0x3f) << 26) |
			((uint32_t)input[29] << 18) |
			((uint32_t)(input[30] & 0xc0) << 10);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 242 to 257
	value = ((uint32_t)(input[30] & 0x3f) << 26) |
			((uint32_t)input[31] << 18) |
			((uint32_t)(input[32] & 0xc0) << 10);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 258 to 273
	value = ((uint32_t)(input[32] & 0x3f) << 26) |
			((uint32_t)input[33] << 18) |
			((uint32_t)(input[34] & 0xc0) << 10);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 274 to 289
	value = ((uint32_t)(input[34] & 0x3f) << 26) |
			((uint32_t)input[35] << 18) |
			((uint32_t)(input[36] & 0xc0) << 10);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 290 to 305
	value = ((uint32_t)(input[36] & 0x3f) << 26) |
			((uint32_t)input[37] << 18) |
			((uint32_t)(input[38] & 0xc0) << 10);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 306 to 321
	value = ((uint32_t)(input[38] & 0x3f) << 26) |
			((uint32_t)input[39] << 18) |
			((uint32_t)(input[40] & 0xc0) << 10);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 322 to 337
	value = ((uint32_t)(input[40] & 0x3f) << 26) |
			((uint32_t)input[41] << 18) |
			((uint32_t)(input[42] & 0xc0) << 10);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 338 to 353
	value = ((uint32_t)(input[42] & 0x3f) << 26) |
			((uint32_t)input[43] << 18) |
			((uint32_t)(input[44] & 0xc0) << 10);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 354 to 369
	value = ((uint32_t)(input[44] & 0x3f) << 26) |
			((uint32_t)input[45] << 18) |
			((uint32_t)(input[46] & 0xc0) << 10);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 370 to 385
	value = ((uint32_t)(input[46] & 0x3f) << 26) |
			((uint32_t)input[47] << 18) |
			((uint32_t)(input[48] & 0xc0) << 10);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 386 to 401
	value = ((uint32_t)(input[48] & 0x3f) << 26) |
			((uint32_t)input[49] << 18) |
			((uint32_t)(input[50] & 0xc0) << 10);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 402 to 417
	value = ((uint32_t)(input[50] & 0x3f) << 26) |
			((uint32_t)input[51] << 18) |
			((uint32_t)(input[52] & 0xc0) << 10);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 418 to 433
	value = ((uint32_t)(input[52] & 0x3f) << 26) |
			((uint32_t)input[53] << 18) |
			((uint32_t)(input[54] & 0xc0) << 10);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 434 to 449
	value = ((uint32_t)(input[54] & 0x3f) << 26) |
			((uint32_t)input[55] << 18) |
			((uint32_t)(input[56] & 0xc0) << 10);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 450 to 465
	value = ((uint32_t)(input[56] & 0x3f) << 26) |
			((uint32_t)input[57] << 18) |
			((uint32_t)(input[58] & 0xc0) << 10);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 466 to 481
	value = ((uint32_t)(input[58] & 0x3f) << 26) |
			((uint32_t)input[59] << 18) |
			((uint32_t)(input[60] & 0xc0) << 10);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 482 to 497
	value = ((uint32_t)(input[60] & 0x3f) << 26) |
			((uint32_t)input[61] << 18) |
			((uint32_t)(input[62] & 0xc0) << 10);
	output[30] = (double)(value >> 16);
}

static void unpack_31_16bit_signed_3off(const uint8_t * input, double * output, void *closure) {
	// Unpack 31 values into output
	// Values are 16-bit signed
	// Skip 3 bits, read 496 bits of data.
	// Input must be at least 63 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 3 to 18
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)input[1] << 19) |
			((uint32_t)(input[2] & 0xe0) << 11);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 19 to 34
	value = ((uint32_t)(input[2] & 0x1f) << 27) |
			((uint32_t)input[3] << 19) |
			((uint32_t)(input[4] & 0xe0) << 11);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 35 to 50
	value = ((uint32_t)(input[4] & 0x1f) << 27) |
			((uint32_t)input[5] << 19) |
			((uint32_t)(input[6] & 0xe0) << 11);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 51 to 66
	value = ((uint32_t)(input[6] & 0x1f) << 27) |
			((uint32_t)input[7] << 19) |
			((uint32_t)(input[8] & 0xe0) << 11);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 67 to 82
	value = ((uint32_t)(input[8] & 0x1f) << 27) |
			((uint32_t)input[9] << 19) |
			((uint32_t)(input[10] & 0xe0) << 11);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 83 to 98
	value = ((uint32_t)(input[10] & 0x1f) << 27) |
			((uint32_t)input[11] << 19) |
			((uint32_t)(input[12] & 0xe0) << 11);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 99 to 114
	value = ((uint32_t)(input[12] & 0x1f) << 27) |
			((uint32_t)input[13] << 19) |
			((uint32_t)(input[14] & 0xe0) << 11);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 115 to 130
	value = ((uint32_t)(input[14] & 0x1f) << 27) |
			((uint32_t)input[15] << 19) |
			((uint32_t)(input[16] & 0xe0) << 11);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 131 to 146
	value = ((uint32_t)(input[16] & 0x1f) << 27) |
			((uint32_t)input[17] << 19) |
			((uint32_t)(input[18] & 0xe0) << 11);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 147 to 162
	value = ((uint32_t)(input[18] & 0x1f) << 27) |
			((uint32_t)input[19] << 19) |
			((uint32_t)(input[20] & 0xe0) << 11);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 163 to 178
	value = ((uint32_t)(input[20] & 0x1f) << 27) |
			((uint32_t)input[21] << 19) |
			((uint32_t)(input[22] & 0xe0) << 11);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 179 to 194
	value = ((uint32_t)(input[22] & 0x1f) << 27) |
			((uint32_t)input[23] << 19) |
			((uint32_t)(input[24] & 0xe0) << 11);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 195 to 210
	value = ((uint32_t)(input[24] & 0x1f) << 27) |
			((uint32_t)input[25] << 19) |
			((uint32_t)(input[26] & 0xe0) << 11);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 211 to 226
	value = ((uint32_t)(input[26] & 0x1f) << 27) |
			((uint32_t)input[27] << 19) |
			((uint32_t)(input[28] & 0xe0) << 11);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 227 to 242
	value = ((uint32_t)(input[28] & 0x1f) << 27) |
			((uint32_t)input[29] << 19) |
			((uint32_t)(input[30] & 0xe0) << 11);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 243 to 258
	value = ((uint32_t)(input[30] & 0x1f) << 27) |
			((uint32_t)input[31] << 19) |
			((uint32_t)(input[32] & 0xe0) << 11);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 259 to 274
	value = ((uint32_t)(input[32] & 0x1f) << 27) |
			((uint32_t)input[33] << 19) |
			((uint32_t)(input[34] & 0xe0) << 11);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 275 to 290
	value = ((uint32_t)(input[34] & 0x1f) << 27) |
			((uint32_t)input[35] << 19) |
			((uint32_t)(input[36] & 0xe0) << 11);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 291 to 306
	value = ((uint32_t)(input[36] & 0x1f) << 27) |
			((uint32_t)input[37] << 19) |
			((uint32_t)(input[38] & 0xe0) << 11);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 307 to 322
	value = ((uint32_t)(input[38] & 0x1f) << 27) |
			((uint32_t)input[39] << 19) |
			((uint32_t)(input[40] & 0xe0) << 11);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 323 to 338
	value = ((uint32_t)(input[40] & 0x1f) << 27) |
			((uint32_t)input[41] << 19) |
			((uint32_t)(input[42] & 0xe0) << 11);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 339 to 354
	value = ((uint32_t)(input[42] & 0x1f) << 27) |
			((uint32_t)input[43] << 19) |
			((uint32_t)(input[44] & 0xe0) << 11);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 355 to 370
	value = ((uint32_t)(input[44] & 0x1f) << 27) |
			((uint32_t)input[45] << 19) |
			((uint32_t)(input[46] & 0xe0) << 11);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 371 to 386
	value = ((uint32_t)(input[46] & 0x1f) << 27) |
			((uint32_t)input[47] << 19) |
			((uint32_t)(input[48] & 0xe0) << 11);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 387 to 402
	value = ((uint32_t)(input[48] & 0x1f) << 27) |
			((uint32_t)input[49] << 19) |
			((uint32_t)(input[50] & 0xe0) << 11);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 403 to 418
	value = ((uint32_t)(input[50] & 0x1f) << 27) |
			((uint32_t)input[51] << 19) |
			((uint32_t)(input[52] & 0xe0) << 11);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 419 to 434
	value = ((uint32_t)(input[52] & 0x1f) << 27) |
			((uint32_t)input[53] << 19) |
			((uint32_t)(input[54] & 0xe0) << 11);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 435 to 450
	value = ((uint32_t)(input[54] & 0x1f) << 27) |
			((uint32_t)input[55] << 19) |
			((uint32_t)(input[56] & 0xe0) << 11);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 451 to 466
	value = ((uint32_t)(input[56] & 0x1f) << 27) |
			((uint32_t)input[57] << 19) |
			((uint32_t)(input[58] & 0xe0) << 11);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 467 to 482
	value = ((uint32_t)(input[58] & 0x1f) << 27) |
			((uint32_t)input[59] << 19) |
			((uint32_t)(input[60] & 0xe0) << 11);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 483 to 498
	value = ((uint32_t)(input[60] & 0x1f) << 27) |
			((uint32_t)input[61] << 19) |
			((uint32_t)(input[62] & 0xe0) << 11);
	output[30] = (double)(value >> 16);
}

static void unpack_31_16bit_unsigned_3off(const uint8_t * input, double * output, void *closure) {
	// Unpack 31 values into output
	// Values are 16-bit unsigned
	// Skip 3 bits, read 496 bits of data.
	// Input must be at least 63 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 3 to 18
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)input[1] << 19) |
			((uint32_t)(input[2] & 0xe0) << 11);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 19 to 34
	value = ((uint32_t)(input[2] & 0x1f) << 27) |
			((uint32_t)input[3] << 19) |
			((uint32_t)(input[4] & 0xe0) << 11);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 35 to 50
	value = ((uint32_t)(input[4] & 0x1f) << 27) |
			((uint32_t)input[5] << 19) |
			((uint32_t)(input[6] & 0xe0) << 11);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 51 to 66
	value = ((uint32_t)(input[6] & 0x1f) << 27) |
			((uint32_t)input[7] << 19) |
			((uint32_t)(input[8] & 0xe0) << 11);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 67 to 82
	value = ((uint32_t)(input[8] & 0x1f) << 27) |
			((uint32_t)input[9] << 19) |
			((uint32_t)(input[10] & 0xe0) << 11);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 83 to 98
	value = ((uint32_t)(input[10] & 0x1f) << 27) |
			((uint32_t)input[11] << 19) |
			((uint32_t)(input[12] & 0xe0) << 11);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 99 to 114
	value = ((uint32_t)(input[12] & 0x1f) << 27) |
			((uint32_t)input[13] << 19) |
			((uint32_t)(input[14] & 0xe0) << 11);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 115 to 130
	value = ((uint32_t)(input[14] & 0x1f) << 27) |
			((uint32_t)input[15] << 19) |
			((uint32_t)(input[16] & 0xe0) << 11);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 131 to 146
	value = ((uint32_t)(input[16] & 0x1f) << 27) |
			((uint32_t)input[17] << 19) |
			((uint32_t)(input[18] & 0xe0) << 11);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 147 to 162
	value = ((uint32_t)(input[18] & 0x1f) << 27) |
			((uint32_t)input[19] << 19) |
			((uint32_t)(input[20] & 0xe0) << 11);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 163 to 178
	value = ((uint32_t)(input[20] & 0x1f) << 27) |
			((uint32_t)input[21] << 19) |
			((uint32_t)(input[22] & 0xe0) << 11);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 179 to 194
	value = ((uint32_t)(input[22] & 0x1f) << 27) |
			((uint32_t)input[23] << 19) |
			((uint32_t)(input[24] & 0xe0) << 11);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 195 to 210
	value = ((uint32_t)(input[24] & 0x1f) << 27) |
			((uint32_t)input[25] << 19) |
			((uint32_t)(input[26] & 0xe0) << 11);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 211 to 226
	value = ((uint32_t)(input[26] & 0x1f) << 27) |
			((uint32_t)input[27] << 19) |
			((uint32_t)(input[28] & 0xe0) << 11);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 227 to 242
	value = ((uint32_t)(input[28] & 0x1f) << 27) |
			((uint32_t)input[29] << 19) |
			((uint32_t)(input[30] & 0xe0) << 11);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 243 to 258
	value = ((uint32_t)(input[30] & 0x1f) << 27) |
			((uint32_t)input[31] << 19) |
			((uint32_t)(input[32] & 0xe0) << 11);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 259 to 274
	value = ((uint32_t)(input[32] & 0x1f) << 27) |
			((uint32_t)input[33] << 19) |
			((uint32_t)(input[34] & 0xe0) << 11);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 275 to 290
	value = ((uint32_t)(input[34] & 0x1f) << 27) |
			((uint32_t)input[35] << 19) |
			((uint32_t)(input[36] & 0xe0) << 11);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 291 to 306
	value = ((uint32_t)(input[36] & 0x1f) << 27) |
			((uint32_t)input[37] << 19) |
			((uint32_t)(input[38] & 0xe0) << 11);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 307 to 322
	value = ((uint32_t)(input[38] & 0x1f) << 27) |
			((uint32_t)input[39] << 19) |
			((uint32_t)(input[40] & 0xe0) << 11);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 323 to 338
	value = ((uint32_t)(input[40] & 0x1f) << 27) |
			((uint32_t)input[41] << 19) |
			((uint32_t)(input[42] & 0xe0) << 11);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 339 to 354
	value = ((uint32_t)(input[42] & 0x1f) << 27) |
			((uint32_t)input[43] << 19) |
			((uint32_t)(input[44] & 0xe0) << 11);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 355 to 370
	value = ((uint32_t)(input[44] & 0x1f) << 27) |
			((uint32_t)input[45] << 19) |
			((uint32_t)(input[46] & 0xe0) << 11);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 371 to 386
	value = ((uint32_t)(input[46] & 0x1f) << 27) |
			((uint32_t)input[47] << 19) |
			((uint32_t)(input[48] & 0xe0) << 11);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 387 to 402
	value = ((uint32_t)(input[48] & 0x1f) << 27) |
			((uint32_t)input[49] << 19) |
			((uint32_t)(input[50] & 0xe0) << 11);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 403 to 418
	value = ((uint32_t)(input[50] & 0x1f) << 27) |
			((uint32_t)input[51] << 19) |
			((uint32_t)(input[52] & 0xe0) << 11);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 419 to 434
	value = ((uint32_t)(input[52] & 0x1f) << 27) |
			((uint32_t)input[53] << 19) |
			((uint32_t)(input[54] & 0xe0) << 11);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 435 to 450
	value = ((uint32_t)(input[54] & 0x1f) << 27) |
			((uint32_t)input[55] << 19) |
			((uint32_t)(input[56] & 0xe0) << 11);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 451 to 466
	value = ((uint32_t)(input[56] & 0x1f) << 27) |
			((uint32_t)input[57] << 19) |
			((uint32_t)(input[58] & 0xe0) << 11);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 467 to 482
	value = ((uint32_t)(input[58] & 0x1f) << 27) |
			((uint32_t)input[59] << 19) |
			((uint32_t)(input[60] & 0xe0) << 11);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 483 to 498
	value = ((uint32_t)(input[60] & 0x1f) << 27) |
			((uint32_t)input[61] << 19) |
			((uint32_t)(input[62] & 0xe0) << 11);
	output[30] = (double)(value >> 16);
}

static void unpack_31_16bit_signed_4off(const uint8_t * input, double * output, void *closure) {
	// Unpack 31 values into output
	// Values are 16-bit signed
	// Skip 4 bits, read 496 bits of data.
	// Input must be at least 63 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 4 to 19
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20) |
			((uint32_t)(input[2] & 0xf0) << 12);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 20 to 35
	value = ((uint32_t)(input[2] & 0x0f) << 28) |
			((uint32_t)input[3] << 20) |
			((uint32_t)(input[4] & 0xf0) << 12);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 36 to 51
	value = ((uint32_t)(input[4] & 0x0f) << 28) |
			((uint32_t)input[5] << 20) |
			((uint32_t)(input[6] & 0xf0) << 12);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 52 to 67
	value = ((uint32_t)(input[6] & 0x0f) << 28) |
			((uint32_t)input[7] << 20) |
			((uint32_t)(input[8] & 0xf0) << 12);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 68 to 83
	value = ((uint32_t)(input[8] & 0x0f) << 28) |
			((uint32_t)input[9] << 20) |
			((uint32_t)(input[10] & 0xf0) << 12);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 84 to 99
	value = ((uint32_t)(input[10] & 0x0f) << 28) |
			((uint32_t)input[11] << 20) |
			((uint32_t)(input[12] & 0xf0) << 12);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 100 to 115
	value = ((uint32_t)(input[12] & 0x0f) << 28) |
			((uint32_t)input[13] << 20) |
			((uint32_t)(input[14] & 0xf0) << 12);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 116 to 131
	value = ((uint32_t)(input[14] & 0x0f) << 28) |
			((uint32_t)input[15] << 20) |
			((uint32_t)(input[16] & 0xf0) << 12);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 132 to 147
	value = ((uint32_t)(input[16] & 0x0f) << 28) |
			((uint32_t)input[17] << 20) |
			((uint32_t)(input[18] & 0xf0) << 12);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 148 to 163
	value = ((uint32_t)(input[18] & 0x0f) << 28) |
			((uint32_t)input[19] << 20) |
			((uint32_t)(input[20] & 0xf0) << 12);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 164 to 179
	value = ((uint32_t)(input[20] & 0x0f) << 28) |
			((uint32_t)input[21] << 20) |
			((uint32_t)(input[22] & 0xf0) << 12);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 180 to 195
	value = ((uint32_t)(input[22] & 0x0f) << 28) |
			((uint32_t)input[23] << 20) |
			((uint32_t)(input[24] & 0xf0) << 12);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 196 to 211
	value = ((uint32_t)(input[24] & 0x0f) << 28) |
			((uint32_t)input[25] << 20) |
			((uint32_t)(input[26] & 0xf0) << 12);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 212 to 227
	value = ((uint32_t)(input[26] & 0x0f) << 28) |
			((uint32_t)input[27] << 20) |
			((uint32_t)(input[28] & 0xf0) << 12);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 228 to 243
	value = ((uint32_t)(input[28] & 0x0f) << 28) |
			((uint32_t)input[29] << 20) |
			((uint32_t)(input[30] & 0xf0) << 12);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 244 to 259
	value = ((uint32_t)(input[30] & 0x0f) << 28) |
			((uint32_t)input[31] << 20) |
			((uint32_t)(input[32] & 0xf0) << 12);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 260 to 275
	value = ((uint32_t)(input[32] & 0x0f) << 28) |
			((uint32_t)input[33] << 20) |
			((uint32_t)(input[34] & 0xf0) << 12);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 276 to 291
	value = ((uint32_t)(input[34] & 0x0f) << 28) |
			((uint32_t)input[35] << 20) |
			((uint32_t)(input[36] & 0xf0) << 12);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 292 to 307
	value = ((uint32_t)(input[36] & 0x0f) << 28) |
			((uint32_t)input[37] << 20) |
			((uint32_t)(input[38] & 0xf0) << 12);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 308 to 323
	value = ((uint32_t)(input[38] & 0x0f) << 28) |
			((uint32_t)input[39] << 20) |
			((uint32_t)(input[40] & 0xf0) << 12);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 324 to 339
	value = ((uint32_t)(input[40] & 0x0f) << 28) |
			((uint32_t)input[41] << 20) |
			((uint32_t)(input[42] & 0xf0) << 12);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 340 to 355
	value = ((uint32_t)(input[42] & 0x0f) << 28) |
			((uint32_t)input[43] << 20) |
			((uint32_t)(input[44] & 0xf0) << 12);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 356 to 371
	value = ((uint32_t)(input[44] & 0x0f) << 28) |
			((uint32_t)input[45] << 20) |
			((uint32_t)(input[46] & 0xf0) << 12);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 372 to 387
	value = ((uint32_t)(input[46] & 0x0f) << 28) |
			((uint32_t)input[47] << 20) |
			((uint32_t)(input[48] & 0xf0) << 12);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 388 to 403
	value = ((uint32_t)(input[48] & 0x0f) << 28) |
			((uint32_t)input[49] << 20) |
			((uint32_t)(input[50] & 0xf0) << 12);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 404 to 419
	value = ((uint32_t)(input[50] & 0x0f) << 28) |
			((uint32_t)input[51] << 20) |
			((uint32_t)(input[52] & 0xf0) << 12);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 420 to 435
	value = ((uint32_t)(input[52] & 0x0f) << 28) |
			((uint32_t)input[53] << 20) |
			((uint32_t)(input[54] & 0xf0) << 12);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 436 to 451
	value = ((uint32_t)(input[54] & 0x0f) << 28) |
			((uint32_t)input[55] << 20) |
			((uint32_t)(input[56] & 0xf0) << 12);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 452 to 467
	value = ((uint32_t)(input[56] & 0x0f) << 28) |
			((uint32_t)input[57] << 20) |
			((uint32_t)(input[58] & 0xf0) << 12);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 468 to 483
	value = ((uint32_t)(input[58] & 0x0f) << 28) |
			((uint32_t)input[59] << 20) |
			((uint32_t)(input[60] & 0xf0) << 12);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 484 to 499
	value = ((uint32_t)(input[60] & 0x0f) << 28) |
			((uint32_t)input[61] << 20) |
			((uint32_t)(input[62] & 0xf0) << 12);
	output[30] = (double)(value >> 16);
}

static void unpack_31_16bit_unsigned_4off(const uint8_t * input, double * output, void *closure) {
	// Unpack 31 values into output
	// Values are 16-bit unsigned
	// Skip 4 bits, read 496 bits of data.
	// Input must be at least 63 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 4 to 19
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20) |
			((uint32_t)(input[2] & 0xf0) << 12);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 20 to 35
	value = ((uint32_t)(input[2] & 0x0f) << 28) |
			((uint32_t)input[3] << 20) |
			((uint32_t)(input[4] & 0xf0) << 12);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 36 to 51
	value = ((uint32_t)(input[4] & 0x0f) << 28) |
			((uint32_t)input[5] << 20) |
			((uint32_t)(input[6] & 0xf0) << 12);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 52 to 67
	value = ((uint32_t)(input[6] & 0x0f) << 28) |
			((uint32_t)input[7] << 20) |
			((uint32_t)(input[8] & 0xf0) << 12);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 68 to 83
	value = ((uint32_t)(input[8] & 0x0f) << 28) |
			((uint32_t)input[9] << 20) |
			((uint32_t)(input[10] & 0xf0) << 12);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 84 to 99
	value = ((uint32_t)(input[10] & 0x0f) << 28) |
			((uint32_t)input[11] << 20) |
			((uint32_t)(input[12] & 0xf0) << 12);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 100 to 115
	value = ((uint32_t)(input[12] & 0x0f) << 28) |
			((uint32_t)input[13] << 20) |
			((uint32_t)(input[14] & 0xf0) << 12);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 116 to 131
	value = ((uint32_t)(input[14] & 0x0f) << 28) |
			((uint32_t)input[15] << 20) |
			((uint32_t)(input[16] & 0xf0) << 12);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 132 to 147
	value = ((uint32_t)(input[16] & 0x0f) << 28) |
			((uint32_t)input[17] << 20) |
			((uint32_t)(input[18] & 0xf0) << 12);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 148 to 163
	value = ((uint32_t)(input[18] & 0x0f) << 28) |
			((uint32_t)input[19] << 20) |
			((uint32_t)(input[20] & 0xf0) << 12);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 164 to 179
	value = ((uint32_t)(input[20] & 0x0f) << 28) |
			((uint32_t)input[21] << 20) |
			((uint32_t)(input[22] & 0xf0) << 12);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 180 to 195
	value = ((uint32_t)(input[22] & 0x0f) << 28) |
			((uint32_t)input[23] << 20) |
			((uint32_t)(input[24] & 0xf0) << 12);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 196 to 211
	value = ((uint32_t)(input[24] & 0x0f) << 28) |
			((uint32_t)input[25] << 20) |
			((uint32_t)(input[26] & 0xf0) << 12);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 212 to 227
	value = ((uint32_t)(input[26] & 0x0f) << 28) |
			((uint32_t)input[27] << 20) |
			((uint32_t)(input[28] & 0xf0) << 12);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 228 to 243
	value = ((uint32_t)(input[28] & 0x0f) << 28) |
			((uint32_t)input[29] << 20) |
			((uint32_t)(input[30] & 0xf0) << 12);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 244 to 259
	value = ((uint32_t)(input[30] & 0x0f) << 28) |
			((uint32_t)input[31] << 20) |
			((uint32_t)(input[32] & 0xf0) << 12);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 260 to 275
	value = ((uint32_t)(input[32] & 0x0f) << 28) |
			((uint32_t)input[33] << 20) |
			((uint32_t)(input[34] & 0xf0) << 12);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 276 to 291
	value = ((uint32_t)(input[34] & 0x0f) << 28) |
			((uint32_t)input[35] << 20) |
			((uint32_t)(input[36] & 0xf0) << 12);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 292 to 307
	value = ((uint32_t)(input[36] & 0x0f) << 28) |
			((uint32_t)input[37] << 20) |
			((uint32_t)(input[38] & 0xf0) << 12);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 308 to 323
	value = ((uint32_t)(input[38] & 0x0f) << 28) |
			((uint32_t)input[39] << 20) |
			((uint32_t)(input[40] & 0xf0) << 12);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 324 to 339
	value = ((uint32_t)(input[40] & 0x0f) << 28) |
			((uint32_t)input[41] << 20) |
			((uint32_t)(input[42] & 0xf0) << 12);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 340 to 355
	value = ((uint32_t)(input[42] & 0x0f) << 28) |
			((uint32_t)input[43] << 20) |
			((uint32_t)(input[44] & 0xf0) << 12);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 356 to 371
	value = ((uint32_t)(input[44] & 0x0f) << 28) |
			((uint32_t)input[45] << 20) |
			((uint32_t)(input[46] & 0xf0) << 12);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 372 to 387
	value = ((uint32_t)(input[46] & 0x0f) << 28) |
			((uint32_t)input[47] << 20) |
			((uint32_t)(input[48] & 0xf0) << 12);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 388 to 403
	value = ((uint32_t)(input[48] & 0x0f) << 28) |
			((uint32_t)input[49] << 20) |
			((uint32_t)(input[50] & 0xf0) << 12);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 404 to 419
	value = ((uint32_t)(input[50] & 0x0f) << 28) |
			((uint32_t)input[51] << 20) |
			((uint32_t)(input[52] & 0xf0) << 12);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 420 to 435
	value = ((uint32_t)(input[52] & 0x0f) << 28) |
			((uint32_t)input[53] << 20) |
			((uint32_t)(input[54] & 0xf0) << 12);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 436 to 451
	value = ((uint32_t)(input[54] & 0x0f) << 28) |
			((uint32_t)input[55] << 20) |
			((uint32_t)(input[56] & 0xf0) << 12);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 452 to 467
	value = ((uint32_t)(input[56] & 0x0f) << 28) |
			((uint32_t)input[57] << 20) |
			((uint32_t)(input[58] & 0xf0) << 12);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 468 to 483
	value = ((uint32_t)(input[58] & 0x0f) << 28) |
			((uint32_t)input[59] << 20) |
			((uint32_t)(input[60] & 0xf0) << 12);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 484 to 499
	value = ((uint32_t)(input[60] & 0x0f) << 28) |
			((uint32_t)input[61] << 20) |
			((uint32_t)(input[62] & 0xf0) << 12);
	output[30] = (double)(value >> 16);
}

static void unpack_31_16bit_signed_5off(const uint8_t * input, double * output, void *closure) {
	// Unpack 31 values into output
	// Values are 16-bit signed
	// Skip 5 bits, read 496 bits of data.
	// Input must be at least 63 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 5 to 20
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)(input[2] & 0xf8) << 13);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 21 to 36
	value = ((uint32_t)(input[2] & 0x07) << 29) |
			((uint32_t)input[3] << 21) |
			((uint32_t)(input[4] & 0xf8) << 13);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 37 to 52
	value = ((uint32_t)(input[4] & 0x07) << 29) |
			((uint32_t)input[5] << 21) |
			((uint32_t)(input[6] & 0xf8) << 13);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 53 to 68
	value = ((uint32_t)(input[6] & 0x07) << 29) |
			((uint32_t)input[7] << 21) |
			((uint32_t)(input[8] & 0xf8) << 13);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 69 to 84
	value = ((uint32_t)(input[8] & 0x07) << 29) |
			((uint32_t)input[9] << 21) |
			((uint32_t)(input[10] & 0xf8) << 13);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 85 to 100
	value = ((uint32_t)(input[10] & 0x07) << 29) |
			((uint32_t)input[11] << 21) |
			((uint32_t)(input[12] & 0xf8) << 13);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 101 to 116
	value = ((uint32_t)(input[12] & 0x07) << 29) |
			((uint32_t)input[13] << 21) |
			((uint32_t)(input[14] & 0xf8) << 13);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 117 to 132
	value = ((uint32_t)(input[14] & 0x07) << 29) |
			((uint32_t)input[15] << 21) |
			((uint32_t)(input[16] & 0xf8) << 13);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 133 to 148
	value = ((uint32_t)(input[16] & 0x07) << 29) |
			((uint32_t)input[17] << 21) |
			((uint32_t)(input[18] & 0xf8) << 13);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 149 to 164
	value = ((uint32_t)(input[18] & 0x07) << 29) |
			((uint32_t)input[19] << 21) |
			((uint32_t)(input[20] & 0xf8) << 13);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 165 to 180
	value = ((uint32_t)(input[20] & 0x07) << 29) |
			((uint32_t)input[21] << 21) |
			((uint32_t)(input[22] & 0xf8) << 13);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 181 to 196
	value = ((uint32_t)(input[22] & 0x07) << 29) |
			((uint32_t)input[23] << 21) |
			((uint32_t)(input[24] & 0xf8) << 13);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 197 to 212
	value = ((uint32_t)(input[24] & 0x07) << 29) |
			((uint32_t)input[25] << 21) |
			((uint32_t)(input[26] & 0xf8) << 13);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 213 to 228
	value = ((uint32_t)(input[26] & 0x07) << 29) |
			((uint32_t)input[27] << 21) |
			((uint32_t)(input[28] & 0xf8) << 13);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 229 to 244
	value = ((uint32_t)(input[28] & 0x07) << 29) |
			((uint32_t)input[29] << 21) |
			((uint32_t)(input[30] & 0xf8) << 13);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 245 to 260
	value = ((uint32_t)(input[30] & 0x07) << 29) |
			((uint32_t)input[31] << 21) |
			((uint32_t)(input[32] & 0xf8) << 13);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 261 to 276
	value = ((uint32_t)(input[32] & 0x07) << 29) |
			((uint32_t)input[33] << 21) |
			((uint32_t)(input[34] & 0xf8) << 13);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 277 to 292
	value = ((uint32_t)(input[34] & 0x07) << 29) |
			((uint32_t)input[35] << 21) |
			((uint32_t)(input[36] & 0xf8) << 13);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 293 to 308
	value = ((uint32_t)(input[36] & 0x07) << 29) |
			((uint32_t)input[37] << 21) |
			((uint32_t)(input[38] & 0xf8) << 13);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 309 to 324
	value = ((uint32_t)(input[38] & 0x07) << 29) |
			((uint32_t)input[39] << 21) |
			((uint32_t)(input[40] & 0xf8) << 13);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 325 to 340
	value = ((uint32_t)(input[40] & 0x07) << 29) |
			((uint32_t)input[41] << 21) |
			((uint32_t)(input[42] & 0xf8) << 13);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 341 to 356
	value = ((uint32_t)(input[42] & 0x07) << 29) |
			((uint32_t)input[43] << 21) |
			((uint32_t)(input[44] & 0xf8) << 13);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 357 to 372
	value = ((uint32_t)(input[44] & 0x07) << 29) |
			((uint32_t)input[45] << 21) |
			((uint32_t)(input[46] & 0xf8) << 13);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 373 to 388
	value = ((uint32_t)(input[46] & 0x07) << 29) |
			((uint32_t)input[47] << 21) |
			((uint32_t)(input[48] & 0xf8) << 13);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 389 to 404
	value = ((uint32_t)(input[48] & 0x07) << 29) |
			((uint32_t)input[49] << 21) |
			((uint32_t)(input[50] & 0xf8) << 13);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 405 to 420
	value = ((uint32_t)(input[50] & 0x07) << 29) |
			((uint32_t)input[51] << 21) |
			((uint32_t)(input[52] & 0xf8) << 13);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 421 to 436
	value = ((uint32_t)(input[52] & 0x07) << 29) |
			((uint32_t)input[53] << 21) |
			((uint32_t)(input[54] & 0xf8) << 13);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 437 to 452
	value = ((uint32_t)(input[54] & 0x07) << 29) |
			((uint32_t)input[55] << 21) |
			((uint32_t)(input[56] & 0xf8) << 13);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 453 to 468
	value = ((uint32_t)(input[56] & 0x07) << 29) |
			((uint32_t)input[57] << 21) |
			((uint32_t)(input[58] & 0xf8) << 13);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 469 to 484
	value = ((uint32_t)(input[58] & 0x07) << 29) |
			((uint32_t)input[59] << 21) |
			((uint32_t)(input[60] & 0xf8) << 13);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 485 to 500
	value = ((uint32_t)(input[60] & 0x07) << 29) |
			((uint32_t)input[61] << 21) |
			((uint32_t)(input[62] & 0xf8) << 13);
	output[30] = (double)(value >> 16);
}

static void unpack_31_16bit_unsigned_5off(const uint8_t * input, double * output, void *closure) {
	// Unpack 31 values into output
	// Values are 16-bit unsigned
	// Skip 5 bits, read 496 bits of data.
	// Input must be at least 63 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 5 to 20
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)(input[2] & 0xf8) << 13);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 21 to 36
	value = ((uint32_t)(input[2] & 0x07) << 29) |
			((uint32_t)input[3] << 21) |
			((uint32_t)(input[4] & 0xf8) << 13);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 37 to 52
	value = ((uint32_t)(input[4] & 0x07) << 29) |
			((uint32_t)input[5] << 21) |
			((uint32_t)(input[6] & 0xf8) << 13);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 53 to 68
	value = ((uint32_t)(input[6] & 0x07) << 29) |
			((uint32_t)input[7] << 21) |
			((uint32_t)(input[8] & 0xf8) << 13);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 69 to 84
	value = ((uint32_t)(input[8] & 0x07) << 29) |
			((uint32_t)input[9] << 21) |
			((uint32_t)(input[10] & 0xf8) << 13);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 85 to 100
	value = ((uint32_t)(input[10] & 0x07) << 29) |
			((uint32_t)input[11] << 21) |
			((uint32_t)(input[12] & 0xf8) << 13);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 101 to 116
	value = ((uint32_t)(input[12] & 0x07) << 29) |
			((uint32_t)input[13] << 21) |
			((uint32_t)(input[14] & 0xf8) << 13);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 117 to 132
	value = ((uint32_t)(input[14] & 0x07) << 29) |
			((uint32_t)input[15] << 21) |
			((uint32_t)(input[16] & 0xf8) << 13);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 133 to 148
	value = ((uint32_t)(input[16] & 0x07) << 29) |
			((uint32_t)input[17] << 21) |
			((uint32_t)(input[18] & 0xf8) << 13);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 149 to 164
	value = ((uint32_t)(input[18] & 0x07) << 29) |
			((uint32_t)input[19] << 21) |
			((uint32_t)(input[20] & 0xf8) << 13);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 165 to 180
	value = ((uint32_t)(input[20] & 0x07) << 29) |
			((uint32_t)input[21] << 21) |
			((uint32_t)(input[22] & 0xf8) << 13);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 181 to 196
	value = ((uint32_t)(input[22] & 0x07) << 29) |
			((uint32_t)input[23] << 21) |
			((uint32_t)(input[24] & 0xf8) << 13);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 197 to 212
	value = ((uint32_t)(input[24] & 0x07) << 29) |
			((uint32_t)input[25] << 21) |
			((uint32_t)(input[26] & 0xf8) << 13);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 213 to 228
	value = ((uint32_t)(input[26] & 0x07) << 29) |
			((uint32_t)input[27] << 21) |
			((uint32_t)(input[28] & 0xf8) << 13);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 229 to 244
	value = ((uint32_t)(input[28] & 0x07) << 29) |
			((uint32_t)input[29] << 21) |
			((uint32_t)(input[30] & 0xf8) << 13);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 245 to 260
	value = ((uint32_t)(input[30] & 0x07) << 29) |
			((uint32_t)input[31] << 21) |
			((uint32_t)(input[32] & 0xf8) << 13);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 261 to 276
	value = ((uint32_t)(input[32] & 0x07) << 29) |
			((uint32_t)input[33] << 21) |
			((uint32_t)(input[34] & 0xf8) << 13);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 277 to 292
	value = ((uint32_t)(input[34] & 0x07) << 29) |
			((uint32_t)input[35] << 21) |
			((uint32_t)(input[36] & 0xf8) << 13);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 293 to 308
	value = ((uint32_t)(input[36] & 0x07) << 29) |
			((uint32_t)input[37] << 21) |
			((uint32_t)(input[38] & 0xf8) << 13);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 309 to 324
	value = ((uint32_t)(input[38] & 0x07) << 29) |
			((uint32_t)input[39] << 21) |
			((uint32_t)(input[40] & 0xf8) << 13);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 325 to 340
	value = ((uint32_t)(input[40] & 0x07) << 29) |
			((uint32_t)input[41] << 21) |
			((uint32_t)(input[42] & 0xf8) << 13);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 341 to 356
	value = ((uint32_t)(input[42] & 0x07) << 29) |
			((uint32_t)input[43] << 21) |
			((uint32_t)(input[44] & 0xf8) << 13);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 357 to 372
	value = ((uint32_t)(input[44] & 0x07) << 29) |
			((uint32_t)input[45] << 21) |
			((uint32_t)(input[46] & 0xf8) << 13);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 373 to 388
	value = ((uint32_t)(input[46] & 0x07) << 29) |
			((uint32_t)input[47] << 21) |
			((uint32_t)(input[48] & 0xf8) << 13);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 389 to 404
	value = ((uint32_t)(input[48] & 0x07) << 29) |
			((uint32_t)input[49] << 21) |
			((uint32_t)(input[50] & 0xf8) << 13);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 405 to 420
	value = ((uint32_t)(input[50] & 0x07) << 29) |
			((uint32_t)input[51] << 21) |
			((uint32_t)(input[52] & 0xf8) << 13);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 421 to 436
	value = ((uint32_t)(input[52] & 0x07) << 29) |
			((uint32_t)input[53] << 21) |
			((uint32_t)(input[54] & 0xf8) << 13);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 437 to 452
	value = ((uint32_t)(input[54] & 0x07) << 29) |
			((uint32_t)input[55] << 21) |
			((uint32_t)(input[56] & 0xf8) << 13);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 453 to 468
	value = ((uint32_t)(input[56] & 0x07) << 29) |
			((uint32_t)input[57] << 21) |
			((uint32_t)(input[58] & 0xf8) << 13);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 469 to 484
	value = ((uint32_t)(input[58] & 0x07) << 29) |
			((uint32_t)input[59] << 21) |
			((uint32_t)(input[60] & 0xf8) << 13);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 485 to 500
	value = ((uint32_t)(input[60] & 0x07) << 29) |
			((uint32_t)input[61] << 21) |
			((uint32_t)(input[62] & 0xf8) << 13);
	output[30] = (double)(value >> 16);
}

static void unpack_31_16bit_signed_6off(const uint8_t * input, double * output, void *closure) {
	// Unpack 31 values into output
	// Values are 16-bit signed
	// Skip 6 bits, read 496 bits of data.
	// Input must be at least 63 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 6 to 21
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)(input[2] & 0xfc) << 14);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 22 to 37
	value = ((uint32_t)(input[2] & 0x03) << 30) |
			((uint32_t)input[3] << 22) |
			((uint32_t)(input[4] & 0xfc) << 14);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 38 to 53
	value = ((uint32_t)(input[4] & 0x03) << 30) |
			((uint32_t)input[5] << 22) |
			((uint32_t)(input[6] & 0xfc) << 14);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 54 to 69
	value = ((uint32_t)(input[6] & 0x03) << 30) |
			((uint32_t)input[7] << 22) |
			((uint32_t)(input[8] & 0xfc) << 14);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 70 to 85
	value = ((uint32_t)(input[8] & 0x03) << 30) |
			((uint32_t)input[9] << 22) |
			((uint32_t)(input[10] & 0xfc) << 14);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 86 to 101
	value = ((uint32_t)(input[10] & 0x03) << 30) |
			((uint32_t)input[11] << 22) |
			((uint32_t)(input[12] & 0xfc) << 14);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 102 to 117
	value = ((uint32_t)(input[12] & 0x03) << 30) |
			((uint32_t)input[13] << 22) |
			((uint32_t)(input[14] & 0xfc) << 14);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 118 to 133
	value = ((uint32_t)(input[14] & 0x03) << 30) |
			((uint32_t)input[15] << 22) |
			((uint32_t)(input[16] & 0xfc) << 14);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 134 to 149
	value = ((uint32_t)(input[16] & 0x03) << 30) |
			((uint32_t)input[17] << 22) |
			((uint32_t)(input[18] & 0xfc) << 14);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 150 to 165
	value = ((uint32_t)(input[18] & 0x03) << 30) |
			((uint32_t)input[19] << 22) |
			((uint32_t)(input[20] & 0xfc) << 14);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 166 to 181
	value = ((uint32_t)(input[20] & 0x03) << 30) |
			((uint32_t)input[21] << 22) |
			((uint32_t)(input[22] & 0xfc) << 14);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 182 to 197
	value = ((uint32_t)(input[22] & 0x03) << 30) |
			((uint32_t)input[23] << 22) |
			((uint32_t)(input[24] & 0xfc) << 14);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 198 to 213
	value = ((uint32_t)(input[24] & 0x03) << 30) |
			((uint32_t)input[25] << 22) |
			((uint32_t)(input[26] & 0xfc) << 14);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 214 to 229
	value = ((uint32_t)(input[26] & 0x03) << 30) |
			((uint32_t)input[27] << 22) |
			((uint32_t)(input[28] & 0xfc) << 14);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 230 to 245
	value = ((uint32_t)(input[28] & 0x03) << 30) |
			((uint32_t)input[29] << 22) |
			((uint32_t)(input[30] & 0xfc) << 14);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 246 to 261
	value = ((uint32_t)(input[30] & 0x03) << 30) |
			((uint32_t)input[31] << 22) |
			((uint32_t)(input[32] & 0xfc) << 14);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 262 to 277
	value = ((uint32_t)(input[32] & 0x03) << 30) |
			((uint32_t)input[33] << 22) |
			((uint32_t)(input[34] & 0xfc) << 14);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 278 to 293
	value = ((uint32_t)(input[34] & 0x03) << 30) |
			((uint32_t)input[35] << 22) |
			((uint32_t)(input[36] & 0xfc) << 14);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 294 to 309
	value = ((uint32_t)(input[36] & 0x03) << 30) |
			((uint32_t)input[37] << 22) |
			((uint32_t)(input[38] & 0xfc) << 14);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 310 to 325
	value = ((uint32_t)(input[38] & 0x03) << 30) |
			((uint32_t)input[39] << 22) |
			((uint32_t)(input[40] & 0xfc) << 14);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 326 to 341
	value = ((uint32_t)(input[40] & 0x03) << 30) |
			((uint32_t)input[41] << 22) |
			((uint32_t)(input[42] & 0xfc) << 14);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 342 to 357
	value = ((uint32_t)(input[42] & 0x03) << 30) |
			((uint32_t)input[43] << 22) |
			((uint32_t)(input[44] & 0xfc) << 14);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 358 to 373
	value = ((uint32_t)(input[44] & 0x03) << 30) |
			((uint32_t)input[45] << 22) |
			((uint32_t)(input[46] & 0xfc) << 14);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 374 to 389
	value = ((uint32_t)(input[46] & 0x03) << 30) |
			((uint32_t)input[47] << 22) |
			((uint32_t)(input[48] & 0xfc) << 14);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 390 to 405
	value = ((uint32_t)(input[48] & 0x03) << 30) |
			((uint32_t)input[49] << 22) |
			((uint32_t)(input[50] & 0xfc) << 14);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 406 to 421
	value = ((uint32_t)(input[50] & 0x03) << 30) |
			((uint32_t)input[51] << 22) |
			((uint32_t)(input[52] & 0xfc) << 14);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 422 to 437
	value = ((uint32_t)(input[52] & 0x03) << 30) |
			((uint32_t)input[53] << 22) |
			((uint32_t)(input[54] & 0xfc) << 14);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 438 to 453
	value = ((uint32_t)(input[54] & 0x03) << 30) |
			((uint32_t)input[55] << 22) |
			((uint32_t)(input[56] & 0xfc) << 14);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 454 to 469
	value = ((uint32_t)(input[56] & 0x03) << 30) |
			((uint32_t)input[57] << 22) |
			((uint32_t)(input[58] & 0xfc) << 14);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 470 to 485
	value = ((uint32_t)(input[58] & 0x03) << 30) |
			((uint32_t)input[59] << 22) |
			((uint32_t)(input[60] & 0xfc) << 14);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 486 to 501
	value = ((uint32_t)(input[60] & 0x03) << 30) |
			((uint32_t)input[61] << 22) |
			((uint32_t)(input[62] & 0xfc) << 14);
	output[30] = (double)(value >> 16);
}

static void unpack_31_16bit_unsigned_6off(const uint8_t * input, double * output, void *closure) {
	// Unpack 31 values into output
	// Values are 16-bit unsigned
	// Skip 6 bits, read 496 bits of data.
	// Input must be at least 63 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 6 to 21
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)(input[2] & 0xfc) << 14);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 22 to 37
	value = ((uint32_t)(input[2] & 0x03) << 30) |
			((uint32_t)input[3] << 22) |
			((uint32_t)(input[4] & 0xfc) << 14);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 38 to 53
	value = ((uint32_t)(input[4] & 0x03) << 30) |
			((uint32_t)input[5] << 22) |
			((uint32_t)(input[6] & 0xfc) << 14);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 54 to 69
	value = ((uint32_t)(input[6] & 0x03) << 30) |
			((uint32_t)input[7] << 22) |
			((uint32_t)(input[8] & 0xfc) << 14);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 70 to 85
	value = ((uint32_t)(input[8] & 0x03) << 30) |
			((uint32_t)input[9] << 22) |
			((uint32_t)(input[10] & 0xfc) << 14);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 86 to 101
	value = ((uint32_t)(input[10] & 0x03) << 30) |
			((uint32_t)input[11] << 22) |
			((uint32_t)(input[12] & 0xfc) << 14);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 102 to 117
	value = ((uint32_t)(input[12] & 0x03) << 30) |
			((uint32_t)input[13] << 22) |
			((uint32_t)(input[14] & 0xfc) << 14);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 118 to 133
	value = ((uint32_t)(input[14] & 0x03) << 30) |
			((uint32_t)input[15] << 22) |
			((uint32_t)(input[16] & 0xfc) << 14);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 134 to 149
	value = ((uint32_t)(input[16] & 0x03) << 30) |
			((uint32_t)input[17] << 22) |
			((uint32_t)(input[18] & 0xfc) << 14);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 150 to 165
	value = ((uint32_t)(input[18] & 0x03) << 30) |
			((uint32_t)input[19] << 22) |
			((uint32_t)(input[20] & 0xfc) << 14);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 166 to 181
	value = ((uint32_t)(input[20] & 0x03) << 30) |
			((uint32_t)input[21] << 22) |
			((uint32_t)(input[22] & 0xfc) << 14);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 182 to 197
	value = ((uint32_t)(input[22] & 0x03) << 30) |
			((uint32_t)input[23] << 22) |
			((uint32_t)(input[24] & 0xfc) << 14);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 198 to 213
	value = ((uint32_t)(input[24] & 0x03) << 30) |
			((uint32_t)input[25] << 22) |
			((uint32_t)(input[26] & 0xfc) << 14);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 214 to 229
	value = ((uint32_t)(input[26] & 0x03) << 30) |
			((uint32_t)input[27] << 22) |
			((uint32_t)(input[28] & 0xfc) << 14);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 230 to 245
	value = ((uint32_t)(input[28] & 0x03) << 30) |
			((uint32_t)input[29] << 22) |
			((uint32_t)(input[30] & 0xfc) << 14);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 246 to 261
	value = ((uint32_t)(input[30] & 0x03) << 30) |
			((uint32_t)input[31] << 22) |
			((uint32_t)(input[32] & 0xfc) << 14);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 262 to 277
	value = ((uint32_t)(input[32] & 0x03) << 30) |
			((uint32_t)input[33] << 22) |
			((uint32_t)(input[34] & 0xfc) << 14);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 278 to 293
	value = ((uint32_t)(input[34] & 0x03) << 30) |
			((uint32_t)input[35] << 22) |
			((uint32_t)(input[36] & 0xfc) << 14);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 294 to 309
	value = ((uint32_t)(input[36] & 0x03) << 30) |
			((uint32_t)input[37] << 22) |
			((uint32_t)(input[38] & 0xfc) << 14);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 310 to 325
	value = ((uint32_t)(input[38] & 0x03) << 30) |
			((uint32_t)input[39] << 22) |
			((uint32_t)(input[40] & 0xfc) << 14);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 326 to 341
	value = ((uint32_t)(input[40] & 0x03) << 30) |
			((uint32_t)input[41] << 22) |
			((uint32_t)(input[42] & 0xfc) << 14);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 342 to 357
	value = ((uint32_t)(input[42] & 0x03) << 30) |
			((uint32_t)input[43] << 22) |
			((uint32_t)(input[44] & 0xfc) << 14);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 358 to 373
	value = ((uint32_t)(input[44] & 0x03) << 30) |
			((uint32_t)input[45] << 22) |
			((uint32_t)(input[46] & 0xfc) << 14);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 374 to 389
	value = ((uint32_t)(input[46] & 0x03) << 30) |
			((uint32_t)input[47] << 22) |
			((uint32_t)(input[48] & 0xfc) << 14);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 390 to 405
	value = ((uint32_t)(input[48] & 0x03) << 30) |
			((uint32_t)input[49] << 22) |
			((uint32_t)(input[50] & 0xfc) << 14);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 406 to 421
	value = ((uint32_t)(input[50] & 0x03) << 30) |
			((uint32_t)input[51] << 22) |
			((uint32_t)(input[52] & 0xfc) << 14);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 422 to 437
	value = ((uint32_t)(input[52] & 0x03) << 30) |
			((uint32_t)input[53] << 22) |
			((uint32_t)(input[54] & 0xfc) << 14);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 438 to 453
	value = ((uint32_t)(input[54] & 0x03) << 30) |
			((uint32_t)input[55] << 22) |
			((uint32_t)(input[56] & 0xfc) << 14);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 454 to 469
	value = ((uint32_t)(input[56] & 0x03) << 30) |
			((uint32_t)input[57] << 22) |
			((uint32_t)(input[58] & 0xfc) << 14);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 470 to 485
	value = ((uint32_t)(input[58] & 0x03) << 30) |
			((uint32_t)input[59] << 22) |
			((uint32_t)(input[60] & 0xfc) << 14);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 486 to 501
	value = ((uint32_t)(input[60] & 0x03) << 30) |
			((uint32_t)input[61] << 22) |
			((uint32_t)(input[62] & 0xfc) << 14);
	output[30] = (double)(value >> 16);
}

static void unpack_31_16bit_signed_7off(const uint8_t * input, double * output, void *closure) {
	// Unpack 31 values into output
	// Values are 16-bit signed
	// Skip 7 bits, read 496 bits of data.
	// Input must be at least 63 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 7 to 22
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)(input[2] & 0xfe) << 15);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 23 to 38
	value = ((uint32_t)(input[2] & 0x01) << 31) |
			((uint32_t)input[3] << 23) |
			((uint32_t)(input[4] & 0xfe) << 15);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 39 to 54
	value = ((uint32_t)(input[4] & 0x01) << 31) |
			((uint32_t)input[5] << 23) |
			((uint32_t)(input[6] & 0xfe) << 15);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 55 to 70
	value = ((uint32_t)(input[6] & 0x01) << 31) |
			((uint32_t)input[7] << 23) |
			((uint32_t)(input[8] & 0xfe) << 15);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 71 to 86
	value = ((uint32_t)(input[8] & 0x01) << 31) |
			((uint32_t)input[9] << 23) |
			((uint32_t)(input[10] & 0xfe) << 15);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 87 to 102
	value = ((uint32_t)(input[10] & 0x01) << 31) |
			((uint32_t)input[11] << 23) |
			((uint32_t)(input[12] & 0xfe) << 15);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 103 to 118
	value = ((uint32_t)(input[12] & 0x01) << 31) |
			((uint32_t)input[13] << 23) |
			((uint32_t)(input[14] & 0xfe) << 15);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 119 to 134
	value = ((uint32_t)(input[14] & 0x01) << 31) |
			((uint32_t)input[15] << 23) |
			((uint32_t)(input[16] & 0xfe) << 15);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 135 to 150
	value = ((uint32_t)(input[16] & 0x01) << 31) |
			((uint32_t)input[17] << 23) |
			((uint32_t)(input[18] & 0xfe) << 15);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 151 to 166
	value = ((uint32_t)(input[18] & 0x01) << 31) |
			((uint32_t)input[19] << 23) |
			((uint32_t)(input[20] & 0xfe) << 15);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 167 to 182
	value = ((uint32_t)(input[20] & 0x01) << 31) |
			((uint32_t)input[21] << 23) |
			((uint32_t)(input[22] & 0xfe) << 15);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 183 to 198
	value = ((uint32_t)(input[22] & 0x01) << 31) |
			((uint32_t)input[23] << 23) |
			((uint32_t)(input[24] & 0xfe) << 15);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 199 to 214
	value = ((uint32_t)(input[24] & 0x01) << 31) |
			((uint32_t)input[25] << 23) |
			((uint32_t)(input[26] & 0xfe) << 15);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 215 to 230
	value = ((uint32_t)(input[26] & 0x01) << 31) |
			((uint32_t)input[27] << 23) |
			((uint32_t)(input[28] & 0xfe) << 15);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 231 to 246
	value = ((uint32_t)(input[28] & 0x01) << 31) |
			((uint32_t)input[29] << 23) |
			((uint32_t)(input[30] & 0xfe) << 15);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 247 to 262
	value = ((uint32_t)(input[30] & 0x01) << 31) |
			((uint32_t)input[31] << 23) |
			((uint32_t)(input[32] & 0xfe) << 15);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 263 to 278
	value = ((uint32_t)(input[32] & 0x01) << 31) |
			((uint32_t)input[33] << 23) |
			((uint32_t)(input[34] & 0xfe) << 15);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 279 to 294
	value = ((uint32_t)(input[34] & 0x01) << 31) |
			((uint32_t)input[35] << 23) |
			((uint32_t)(input[36] & 0xfe) << 15);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 295 to 310
	value = ((uint32_t)(input[36] & 0x01) << 31) |
			((uint32_t)input[37] << 23) |
			((uint32_t)(input[38] & 0xfe) << 15);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 311 to 326
	value = ((uint32_t)(input[38] & 0x01) << 31) |
			((uint32_t)input[39] << 23) |
			((uint32_t)(input[40] & 0xfe) << 15);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 327 to 342
	value = ((uint32_t)(input[40] & 0x01) << 31) |
			((uint32_t)input[41] << 23) |
			((uint32_t)(input[42] & 0xfe) << 15);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 343 to 358
	value = ((uint32_t)(input[42] & 0x01) << 31) |
			((uint32_t)input[43] << 23) |
			((uint32_t)(input[44] & 0xfe) << 15);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 359 to 374
	value = ((uint32_t)(input[44] & 0x01) << 31) |
			((uint32_t)input[45] << 23) |
			((uint32_t)(input[46] & 0xfe) << 15);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 375 to 390
	value = ((uint32_t)(input[46] & 0x01) << 31) |
			((uint32_t)input[47] << 23) |
			((uint32_t)(input[48] & 0xfe) << 15);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 391 to 406
	value = ((uint32_t)(input[48] & 0x01) << 31) |
			((uint32_t)input[49] << 23) |
			((uint32_t)(input[50] & 0xfe) << 15);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 407 to 422
	value = ((uint32_t)(input[50] & 0x01) << 31) |
			((uint32_t)input[51] << 23) |
			((uint32_t)(input[52] & 0xfe) << 15);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 423 to 438
	value = ((uint32_t)(input[52] & 0x01) << 31) |
			((uint32_t)input[53] << 23) |
			((uint32_t)(input[54] & 0xfe) << 15);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 439 to 454
	value = ((uint32_t)(input[54] & 0x01) << 31) |
			((uint32_t)input[55] << 23) |
			((uint32_t)(input[56] & 0xfe) << 15);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 455 to 470
	value = ((uint32_t)(input[56] & 0x01) << 31) |
			((uint32_t)input[57] << 23) |
			((uint32_t)(input[58] & 0xfe) << 15);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 471 to 486
	value = ((uint32_t)(input[58] & 0x01) << 31) |
			((uint32_t)input[59] << 23) |
			((uint32_t)(input[60] & 0xfe) << 15);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 487 to 502
	value = ((uint32_t)(input[60] & 0x01) << 31) |
			((uint32_t)input[61] << 23) |
			((uint32_t)(input[62] & 0xfe) << 15);
	output[30] = (double)(value >> 16);
}

static void unpack_31_16bit_unsigned_7off(const uint8_t * input, double * output, void *closure) {
	// Unpack 31 values into output
	// Values are 16-bit unsigned
	// Skip 7 bits, read 496 bits of data.
	// Input must be at least 63 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 7 to 22
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)(input[2] & 0xfe) << 15);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 23 to 38
	value = ((uint32_t)(input[2] & 0x01) << 31) |
			((uint32_t)input[3] << 23) |
			((uint32_t)(input[4] & 0xfe) << 15);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 39 to 54
	value = ((uint32_t)(input[4] & 0x01) << 31) |
			((uint32_t)input[5] << 23) |
			((uint32_t)(input[6] & 0xfe) << 15);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 55 to 70
	value = ((uint32_t)(input[6] & 0x01) << 31) |
			((uint32_t)input[7] << 23) |
			((uint32_t)(input[8] & 0xfe) << 15);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 71 to 86
	value = ((uint32_t)(input[8] & 0x01) << 31) |
			((uint32_t)input[9] << 23) |
			((uint32_t)(input[10] & 0xfe) << 15);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 87 to 102
	value = ((uint32_t)(input[10] & 0x01) << 31) |
			((uint32_t)input[11] << 23) |
			((uint32_t)(input[12] & 0xfe) << 15);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 103 to 118
	value = ((uint32_t)(input[12] & 0x01) << 31) |
			((uint32_t)input[13] << 23) |
			((uint32_t)(input[14] & 0xfe) << 15);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 119 to 134
	value = ((uint32_t)(input[14] & 0x01) << 31) |
			((uint32_t)input[15] << 23) |
			((uint32_t)(input[16] & 0xfe) << 15);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 135 to 150
	value = ((uint32_t)(input[16] & 0x01) << 31) |
			((uint32_t)input[17] << 23) |
			((uint32_t)(input[18] & 0xfe) << 15);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 151 to 166
	value = ((uint32_t)(input[18] & 0x01) << 31) |
			((uint32_t)input[19] << 23) |
			((uint32_t)(input[20] & 0xfe) << 15);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 167 to 182
	value = ((uint32_t)(input[20] & 0x01) << 31) |
			((uint32_t)input[21] << 23) |
			((uint32_t)(input[22] & 0xfe) << 15);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 183 to 198
	value = ((uint32_t)(input[22] & 0x01) << 31) |
			((uint32_t)input[23] << 23) |
			((uint32_t)(input[24] & 0xfe) << 15);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 199 to 214
	value = ((uint32_t)(input[24] & 0x01) << 31) |
			((uint32_t)input[25] << 23) |
			((uint32_t)(input[26] & 0xfe) << 15);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 215 to 230
	value = ((uint32_t)(input[26] & 0x01) << 31) |
			((uint32_t)input[27] << 23) |
			((uint32_t)(input[28] & 0xfe) << 15);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 231 to 246
	value = ((uint32_t)(input[28] & 0x01) << 31) |
			((uint32_t)input[29] << 23) |
			((uint32_t)(input[30] & 0xfe) << 15);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 247 to 262
	value = ((uint32_t)(input[30] & 0x01) << 31) |
			((uint32_t)input[31] << 23) |
			((uint32_t)(input[32] & 0xfe) << 15);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 263 to 278
	value = ((uint32_t)(input[32] & 0x01) << 31) |
			((uint32_t)input[33] << 23) |
			((uint32_t)(input[34] & 0xfe) << 15);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 279 to 294
	value = ((uint32_t)(input[34] & 0x01) << 31) |
			((uint32_t)input[35] << 23) |
			((uint32_t)(input[36] & 0xfe) << 15);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 295 to 310
	value = ((uint32_t)(input[36] & 0x01) << 31) |
			((uint32_t)input[37] << 23) |
			((uint32_t)(input[38] & 0xfe) << 15);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 311 to 326
	value = ((uint32_t)(input[38] & 0x01) << 31) |
			((uint32_t)input[39] << 23) |
			((uint32_t)(input[40] & 0xfe) << 15);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 327 to 342
	value = ((uint32_t)(input[40] & 0x01) << 31) |
			((uint32_t)input[41] << 23) |
			((uint32_t)(input[42] & 0xfe) << 15);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 343 to 358
	value = ((uint32_t)(input[42] & 0x01) << 31) |
			((uint32_t)input[43] << 23) |
			((uint32_t)(input[44] & 0xfe) << 15);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 359 to 374
	value = ((uint32_t)(input[44] & 0x01) << 31) |
			((uint32_t)input[45] << 23) |
			((uint32_t)(input[46] & 0xfe) << 15);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 375 to 390
	value = ((uint32_t)(input[46] & 0x01) << 31) |
			((uint32_t)input[47] << 23) |
			((uint32_t)(input[48] & 0xfe) << 15);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 391 to 406
	value = ((uint32_t)(input[48] & 0x01) << 31) |
			((uint32_t)input[49] << 23) |
			((uint32_t)(input[50] & 0xfe) << 15);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 407 to 422
	value = ((uint32_t)(input[50] & 0x01) << 31) |
			((uint32_t)input[51] << 23) |
			((uint32_t)(input[52] & 0xfe) << 15);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 423 to 438
	value = ((uint32_t)(input[52] & 0x01) << 31) |
			((uint32_t)input[53] << 23) |
			((uint32_t)(input[54] & 0xfe) << 15);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 439 to 454
	value = ((uint32_t)(input[54] & 0x01) << 31) |
			((uint32_t)input[55] << 23) |
			((uint32_t)(input[56] & 0xfe) << 15);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 455 to 470
	value = ((uint32_t)(input[56] & 0x01) << 31) |
			((uint32_t)input[57] << 23) |
			((uint32_t)(input[58] & 0xfe) << 15);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 471 to 486
	value = ((uint32_t)(input[58] & 0x01) << 31) |
			((uint32_t)input[59] << 23) |
			((uint32_t)(input[60] & 0xfe) << 15);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 487 to 502
	value = ((uint32_t)(input[60] & 0x01) << 31) |
			((uint32_t)input[61] << 23) |
			((uint32_t)(input[62] & 0xfe) << 15);
	output[30] = (double)(value >> 16);
}

static void unpack_32_16bit_signed_0off(const uint8_t * input, double * output, void *closure) {
	// Unpack 32 values into output
	// Values are 16-bit signed
	// Skip 0 bits, read 512 bits of data.
	// Input must be at least 64 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 0 to 15
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)input[1] << 16);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 16 to 31
	value = ((uint32_t)input[2] << 24) |
			((uint32_t)input[3] << 16);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 32 to 47
	value = ((uint32_t)input[4] << 24) |
			((uint32_t)input[5] << 16);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 48 to 63
	value = ((uint32_t)input[6] << 24) |
			((uint32_t)input[7] << 16);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 64 to 79
	value = ((uint32_t)input[8] << 24) |
			((uint32_t)input[9] << 16);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 80 to 95
	value = ((uint32_t)input[10] << 24) |
			((uint32_t)input[11] << 16);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 96 to 111
	value = ((uint32_t)input[12] << 24) |
			((uint32_t)input[13] << 16);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 112 to 127
	value = ((uint32_t)input[14] << 24) |
			((uint32_t)input[15] << 16);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 128 to 143
	value = ((uint32_t)input[16] << 24) |
			((uint32_t)input[17] << 16);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 144 to 159
	value = ((uint32_t)input[18] << 24) |
			((uint32_t)input[19] << 16);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 160 to 175
	value = ((uint32_t)input[20] << 24) |
			((uint32_t)input[21] << 16);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 176 to 191
	value = ((uint32_t)input[22] << 24) |
			((uint32_t)input[23] << 16);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 192 to 207
	value = ((uint32_t)input[24] << 24) |
			((uint32_t)input[25] << 16);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 208 to 223
	value = ((uint32_t)input[26] << 24) |
			((uint32_t)input[27] << 16);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 224 to 239
	value = ((uint32_t)input[28] << 24) |
			((uint32_t)input[29] << 16);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 240 to 255
	value = ((uint32_t)input[30] << 24) |
			((uint32_t)input[31] << 16);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 256 to 271
	value = ((uint32_t)input[32] << 24) |
			((uint32_t)input[33] << 16);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 272 to 287
	value = ((uint32_t)input[34] << 24) |
			((uint32_t)input[35] << 16);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 288 to 303
	value = ((uint32_t)input[36] << 24) |
			((uint32_t)input[37] << 16);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 304 to 319
	value = ((uint32_t)input[38] << 24) |
			((uint32_t)input[39] << 16);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 320 to 335
	value = ((uint32_t)input[40] << 24) |
			((uint32_t)input[41] << 16);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 336 to 351
	value = ((uint32_t)input[42] << 24) |
			((uint32_t)input[43] << 16);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 352 to 367
	value = ((uint32_t)input[44] << 24) |
			((uint32_t)input[45] << 16);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 368 to 383
	value = ((uint32_t)input[46] << 24) |
			((uint32_t)input[47] << 16);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 384 to 399
	value = ((uint32_t)input[48] << 24) |
			((uint32_t)input[49] << 16);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 400 to 415
	value = ((uint32_t)input[50] << 24) |
			((uint32_t)input[51] << 16);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 416 to 431
	value = ((uint32_t)input[52] << 24) |
			((uint32_t)input[53] << 16);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 432 to 447
	value = ((uint32_t)input[54] << 24) |
			((uint32_t)input[55] << 16);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 448 to 463
	value = ((uint32_t)input[56] << 24) |
			((uint32_t)input[57] << 16);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 464 to 479
	value = ((uint32_t)input[58] << 24) |
			((uint32_t)input[59] << 16);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 480 to 495
	value = ((uint32_t)input[60] << 24) |
			((uint32_t)input[61] << 16);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 496 to 511
	value = ((uint32_t)input[62] << 24) |
			((uint32_t)input[63] << 16);
	output[31] = (double)(value >> 16);
}

static void unpack_32_16bit_unsigned_0off(const uint8_t * input, double * output, void *closure) {
	// Unpack 32 values into output
	// Values are 16-bit unsigned
	// Skip 0 bits, read 512 bits of data.
	// Input must be at least 64 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 0 to 15
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)input[1] << 16);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 16 to 31
	value = ((uint32_t)input[2] << 24) |
			((uint32_t)input[3] << 16);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 32 to 47
	value = ((uint32_t)input[4] << 24) |
			((uint32_t)input[5] << 16);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 48 to 63
	value = ((uint32_t)input[6] << 24) |
			((uint32_t)input[7] << 16);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 64 to 79
	value = ((uint32_t)input[8] << 24) |
			((uint32_t)input[9] << 16);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 80 to 95
	value = ((uint32_t)input[10] << 24) |
			((uint32_t)input[11] << 16);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 96 to 111
	value = ((uint32_t)input[12] << 24) |
			((uint32_t)input[13] << 16);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 112 to 127
	value = ((uint32_t)input[14] << 24) |
			((uint32_t)input[15] << 16);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 128 to 143
	value = ((uint32_t)input[16] << 24) |
			((uint32_t)input[17] << 16);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 144 to 159
	value = ((uint32_t)input[18] << 24) |
			((uint32_t)input[19] << 16);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 160 to 175
	value = ((uint32_t)input[20] << 24) |
			((uint32_t)input[21] << 16);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 176 to 191
	value = ((uint32_t)input[22] << 24) |
			((uint32_t)input[23] << 16);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 192 to 207
	value = ((uint32_t)input[24] << 24) |
			((uint32_t)input[25] << 16);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 208 to 223
	value = ((uint32_t)input[26] << 24) |
			((uint32_t)input[27] << 16);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 224 to 239
	value = ((uint32_t)input[28] << 24) |
			((uint32_t)input[29] << 16);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 240 to 255
	value = ((uint32_t)input[30] << 24) |
			((uint32_t)input[31] << 16);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 256 to 271
	value = ((uint32_t)input[32] << 24) |
			((uint32_t)input[33] << 16);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 272 to 287
	value = ((uint32_t)input[34] << 24) |
			((uint32_t)input[35] << 16);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 288 to 303
	value = ((uint32_t)input[36] << 24) |
			((uint32_t)input[37] << 16);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 304 to 319
	value = ((uint32_t)input[38] << 24) |
			((uint32_t)input[39] << 16);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 320 to 335
	value = ((uint32_t)input[40] << 24) |
			((uint32_t)input[41] << 16);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 336 to 351
	value = ((uint32_t)input[42] << 24) |
			((uint32_t)input[43] << 16);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 352 to 367
	value = ((uint32_t)input[44] << 24) |
			((uint32_t)input[45] << 16);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 368 to 383
	value = ((uint32_t)input[46] << 24) |
			((uint32_t)input[47] << 16);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 384 to 399
	value = ((uint32_t)input[48] << 24) |
			((uint32_t)input[49] << 16);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 400 to 415
	value = ((uint32_t)input[50] << 24) |
			((uint32_t)input[51] << 16);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 416 to 431
	value = ((uint32_t)input[52] << 24) |
			((uint32_t)input[53] << 16);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 432 to 447
	value = ((uint32_t)input[54] << 24) |
			((uint32_t)input[55] << 16);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 448 to 463
	value = ((uint32_t)input[56] << 24) |
			((uint32_t)input[57] << 16);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 464 to 479
	value = ((uint32_t)input[58] << 24) |
			((uint32_t)input[59] << 16);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 480 to 495
	value = ((uint32_t)input[60] << 24) |
			((uint32_t)input[61] << 16);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 496 to 511
	value = ((uint32_t)input[62] << 24) |
			((uint32_t)input[63] << 16);
	output[31] = (double)(value >> 16);
}

static void unpack_32_16bit_signed_1off(const uint8_t * input, double * output, void *closure) {
	// Unpack 32 values into output
	// Values are 16-bit signed
	// Skip 1 bits, read 512 bits of data.
	// Input must be at least 65 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 1 to 16
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)input[1] << 17) |
			((uint32_t)(input[2] & 0x80) << 9);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 17 to 32
	value = ((uint32_t)(input[2] & 0x7f) << 25) |
			((uint32_t)input[3] << 17) |
			((uint32_t)(input[4] & 0x80) << 9);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 33 to 48
	value = ((uint32_t)(input[4] & 0x7f) << 25) |
			((uint32_t)input[5] << 17) |
			((uint32_t)(input[6] & 0x80) << 9);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 49 to 64
	value = ((uint32_t)(input[6] & 0x7f) << 25) |
			((uint32_t)input[7] << 17) |
			((uint32_t)(input[8] & 0x80) << 9);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 65 to 80
	value = ((uint32_t)(input[8] & 0x7f) << 25) |
			((uint32_t)input[9] << 17) |
			((uint32_t)(input[10] & 0x80) << 9);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 81 to 96
	value = ((uint32_t)(input[10] & 0x7f) << 25) |
			((uint32_t)input[11] << 17) |
			((uint32_t)(input[12] & 0x80) << 9);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 97 to 112
	value = ((uint32_t)(input[12] & 0x7f) << 25) |
			((uint32_t)input[13] << 17) |
			((uint32_t)(input[14] & 0x80) << 9);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 113 to 128
	value = ((uint32_t)(input[14] & 0x7f) << 25) |
			((uint32_t)input[15] << 17) |
			((uint32_t)(input[16] & 0x80) << 9);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 129 to 144
	value = ((uint32_t)(input[16] & 0x7f) << 25) |
			((uint32_t)input[17] << 17) |
			((uint32_t)(input[18] & 0x80) << 9);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 145 to 160
	value = ((uint32_t)(input[18] & 0x7f) << 25) |
			((uint32_t)input[19] << 17) |
			((uint32_t)(input[20] & 0x80) << 9);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 161 to 176
	value = ((uint32_t)(input[20] & 0x7f) << 25) |
			((uint32_t)input[21] << 17) |
			((uint32_t)(input[22] & 0x80) << 9);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 177 to 192
	value = ((uint32_t)(input[22] & 0x7f) << 25) |
			((uint32_t)input[23] << 17) |
			((uint32_t)(input[24] & 0x80) << 9);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 193 to 208
	value = ((uint32_t)(input[24] & 0x7f) << 25) |
			((uint32_t)input[25] << 17) |
			((uint32_t)(input[26] & 0x80) << 9);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 209 to 224
	value = ((uint32_t)(input[26] & 0x7f) << 25) |
			((uint32_t)input[27] << 17) |
			((uint32_t)(input[28] & 0x80) << 9);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 225 to 240
	value = ((uint32_t)(input[28] & 0x7f) << 25) |
			((uint32_t)input[29] << 17) |
			((uint32_t)(input[30] & 0x80) << 9);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 241 to 256
	value = ((uint32_t)(input[30] & 0x7f) << 25) |
			((uint32_t)input[31] << 17) |
			((uint32_t)(input[32] & 0x80) << 9);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 257 to 272
	value = ((uint32_t)(input[32] & 0x7f) << 25) |
			((uint32_t)input[33] << 17) |
			((uint32_t)(input[34] & 0x80) << 9);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 273 to 288
	value = ((uint32_t)(input[34] & 0x7f) << 25) |
			((uint32_t)input[35] << 17) |
			((uint32_t)(input[36] & 0x80) << 9);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 289 to 304
	value = ((uint32_t)(input[36] & 0x7f) << 25) |
			((uint32_t)input[37] << 17) |
			((uint32_t)(input[38] & 0x80) << 9);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 305 to 320
	value = ((uint32_t)(input[38] & 0x7f) << 25) |
			((uint32_t)input[39] << 17) |
			((uint32_t)(input[40] & 0x80) << 9);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 321 to 336
	value = ((uint32_t)(input[40] & 0x7f) << 25) |
			((uint32_t)input[41] << 17) |
			((uint32_t)(input[42] & 0x80) << 9);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 337 to 352
	value = ((uint32_t)(input[42] & 0x7f) << 25) |
			((uint32_t)input[43] << 17) |
			((uint32_t)(input[44] & 0x80) << 9);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 353 to 368
	value = ((uint32_t)(input[44] & 0x7f) << 25) |
			((uint32_t)input[45] << 17) |
			((uint32_t)(input[46] & 0x80) << 9);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 369 to 384
	value = ((uint32_t)(input[46] & 0x7f) << 25) |
			((uint32_t)input[47] << 17) |
			((uint32_t)(input[48] & 0x80) << 9);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 385 to 400
	value = ((uint32_t)(input[48] & 0x7f) << 25) |
			((uint32_t)input[49] << 17) |
			((uint32_t)(input[50] & 0x80) << 9);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 401 to 416
	value = ((uint32_t)(input[50] & 0x7f) << 25) |
			((uint32_t)input[51] << 17) |
			((uint32_t)(input[52] & 0x80) << 9);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 417 to 432
	value = ((uint32_t)(input[52] & 0x7f) << 25) |
			((uint32_t)input[53] << 17) |
			((uint32_t)(input[54] & 0x80) << 9);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 433 to 448
	value = ((uint32_t)(input[54] & 0x7f) << 25) |
			((uint32_t)input[55] << 17) |
			((uint32_t)(input[56] & 0x80) << 9);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 449 to 464
	value = ((uint32_t)(input[56] & 0x7f) << 25) |
			((uint32_t)input[57] << 17) |
			((uint32_t)(input[58] & 0x80) << 9);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 465 to 480
	value = ((uint32_t)(input[58] & 0x7f) << 25) |
			((uint32_t)input[59] << 17) |
			((uint32_t)(input[60] & 0x80) << 9);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 481 to 496
	value = ((uint32_t)(input[60] & 0x7f) << 25) |
			((uint32_t)input[61] << 17) |
			((uint32_t)(input[62] & 0x80) << 9);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 497 to 512
	value = ((uint32_t)(input[62] & 0x7f) << 25) |
			((uint32_t)input[63] << 17) |
			((uint32_t)(input[64] & 0x80) << 9);
	output[31] = (double)(value >> 16);
}

static void unpack_32_16bit_unsigned_1off(const uint8_t * input, double * output, void *closure) {
	// Unpack 32 values into output
	// Values are 16-bit unsigned
	// Skip 1 bits, read 512 bits of data.
	// Input must be at least 65 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 1 to 16
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)input[1] << 17) |
			((uint32_t)(input[2] & 0x80) << 9);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 17 to 32
	value = ((uint32_t)(input[2] & 0x7f) << 25) |
			((uint32_t)input[3] << 17) |
			((uint32_t)(input[4] & 0x80) << 9);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 33 to 48
	value = ((uint32_t)(input[4] & 0x7f) << 25) |
			((uint32_t)input[5] << 17) |
			((uint32_t)(input[6] & 0x80) << 9);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 49 to 64
	value = ((uint32_t)(input[6] & 0x7f) << 25) |
			((uint32_t)input[7] << 17) |
			((uint32_t)(input[8] & 0x80) << 9);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 65 to 80
	value = ((uint32_t)(input[8] & 0x7f) << 25) |
			((uint32_t)input[9] << 17) |
			((uint32_t)(input[10] & 0x80) << 9);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 81 to 96
	value = ((uint32_t)(input[10] & 0x7f) << 25) |
			((uint32_t)input[11] << 17) |
			((uint32_t)(input[12] & 0x80) << 9);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 97 to 112
	value = ((uint32_t)(input[12] & 0x7f) << 25) |
			((uint32_t)input[13] << 17) |
			((uint32_t)(input[14] & 0x80) << 9);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 113 to 128
	value = ((uint32_t)(input[14] & 0x7f) << 25) |
			((uint32_t)input[15] << 17) |
			((uint32_t)(input[16] & 0x80) << 9);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 129 to 144
	value = ((uint32_t)(input[16] & 0x7f) << 25) |
			((uint32_t)input[17] << 17) |
			((uint32_t)(input[18] & 0x80) << 9);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 145 to 160
	value = ((uint32_t)(input[18] & 0x7f) << 25) |
			((uint32_t)input[19] << 17) |
			((uint32_t)(input[20] & 0x80) << 9);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 161 to 176
	value = ((uint32_t)(input[20] & 0x7f) << 25) |
			((uint32_t)input[21] << 17) |
			((uint32_t)(input[22] & 0x80) << 9);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 177 to 192
	value = ((uint32_t)(input[22] & 0x7f) << 25) |
			((uint32_t)input[23] << 17) |
			((uint32_t)(input[24] & 0x80) << 9);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 193 to 208
	value = ((uint32_t)(input[24] & 0x7f) << 25) |
			((uint32_t)input[25] << 17) |
			((uint32_t)(input[26] & 0x80) << 9);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 209 to 224
	value = ((uint32_t)(input[26] & 0x7f) << 25) |
			((uint32_t)input[27] << 17) |
			((uint32_t)(input[28] & 0x80) << 9);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 225 to 240
	value = ((uint32_t)(input[28] & 0x7f) << 25) |
			((uint32_t)input[29] << 17) |
			((uint32_t)(input[30] & 0x80) << 9);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 241 to 256
	value = ((uint32_t)(input[30] & 0x7f) << 25) |
			((uint32_t)input[31] << 17) |
			((uint32_t)(input[32] & 0x80) << 9);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 257 to 272
	value = ((uint32_t)(input[32] & 0x7f) << 25) |
			((uint32_t)input[33] << 17) |
			((uint32_t)(input[34] & 0x80) << 9);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 273 to 288
	value = ((uint32_t)(input[34] & 0x7f) << 25) |
			((uint32_t)input[35] << 17) |
			((uint32_t)(input[36] & 0x80) << 9);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 289 to 304
	value = ((uint32_t)(input[36] & 0x7f) << 25) |
			((uint32_t)input[37] << 17) |
			((uint32_t)(input[38] & 0x80) << 9);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 305 to 320
	value = ((uint32_t)(input[38] & 0x7f) << 25) |
			((uint32_t)input[39] << 17) |
			((uint32_t)(input[40] & 0x80) << 9);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 321 to 336
	value = ((uint32_t)(input[40] & 0x7f) << 25) |
			((uint32_t)input[41] << 17) |
			((uint32_t)(input[42] & 0x80) << 9);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 337 to 352
	value = ((uint32_t)(input[42] & 0x7f) << 25) |
			((uint32_t)input[43] << 17) |
			((uint32_t)(input[44] & 0x80) << 9);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 353 to 368
	value = ((uint32_t)(input[44] & 0x7f) << 25) |
			((uint32_t)input[45] << 17) |
			((uint32_t)(input[46] & 0x80) << 9);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 369 to 384
	value = ((uint32_t)(input[46] & 0x7f) << 25) |
			((uint32_t)input[47] << 17) |
			((uint32_t)(input[48] & 0x80) << 9);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 385 to 400
	value = ((uint32_t)(input[48] & 0x7f) << 25) |
			((uint32_t)input[49] << 17) |
			((uint32_t)(input[50] & 0x80) << 9);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 401 to 416
	value = ((uint32_t)(input[50] & 0x7f) << 25) |
			((uint32_t)input[51] << 17) |
			((uint32_t)(input[52] & 0x80) << 9);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 417 to 432
	value = ((uint32_t)(input[52] & 0x7f) << 25) |
			((uint32_t)input[53] << 17) |
			((uint32_t)(input[54] & 0x80) << 9);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 433 to 448
	value = ((uint32_t)(input[54] & 0x7f) << 25) |
			((uint32_t)input[55] << 17) |
			((uint32_t)(input[56] & 0x80) << 9);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 449 to 464
	value = ((uint32_t)(input[56] & 0x7f) << 25) |
			((uint32_t)input[57] << 17) |
			((uint32_t)(input[58] & 0x80) << 9);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 465 to 480
	value = ((uint32_t)(input[58] & 0x7f) << 25) |
			((uint32_t)input[59] << 17) |
			((uint32_t)(input[60] & 0x80) << 9);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 481 to 496
	value = ((uint32_t)(input[60] & 0x7f) << 25) |
			((uint32_t)input[61] << 17) |
			((uint32_t)(input[62] & 0x80) << 9);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 497 to 512
	value = ((uint32_t)(input[62] & 0x7f) << 25) |
			((uint32_t)input[63] << 17) |
			((uint32_t)(input[64] & 0x80) << 9);
	output[31] = (double)(value >> 16);
}

static void unpack_32_16bit_signed_2off(const uint8_t * input, double * output, void *closure) {
	// Unpack 32 values into output
	// Values are 16-bit signed
	// Skip 2 bits, read 512 bits of data.
	// Input must be at least 65 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 2 to 17
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)input[1] << 18) |
			((uint32_t)(input[2] & 0xc0) << 10);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 18 to 33
	value = ((uint32_t)(input[2] & 0x3f) << 26) |
			((uint32_t)input[3] << 18) |
			((uint32_t)(input[4] & 0xc0) << 10);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 34 to 49
	value = ((uint32_t)(input[4] & 0x3f) << 26) |
			((uint32_t)input[5] << 18) |
			((uint32_t)(input[6] & 0xc0) << 10);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 50 to 65
	value = ((uint32_t)(input[6] & 0x3f) << 26) |
			((uint32_t)input[7] << 18) |
			((uint32_t)(input[8] & 0xc0) << 10);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 66 to 81
	value = ((uint32_t)(input[8] & 0x3f) << 26) |
			((uint32_t)input[9] << 18) |
			((uint32_t)(input[10] & 0xc0) << 10);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 82 to 97
	value = ((uint32_t)(input[10] & 0x3f) << 26) |
			((uint32_t)input[11] << 18) |
			((uint32_t)(input[12] & 0xc0) << 10);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 98 to 113
	value = ((uint32_t)(input[12] & 0x3f) << 26) |
			((uint32_t)input[13] << 18) |
			((uint32_t)(input[14] & 0xc0) << 10);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 114 to 129
	value = ((uint32_t)(input[14] & 0x3f) << 26) |
			((uint32_t)input[15] << 18) |
			((uint32_t)(input[16] & 0xc0) << 10);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 130 to 145
	value = ((uint32_t)(input[16] & 0x3f) << 26) |
			((uint32_t)input[17] << 18) |
			((uint32_t)(input[18] & 0xc0) << 10);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 146 to 161
	value = ((uint32_t)(input[18] & 0x3f) << 26) |
			((uint32_t)input[19] << 18) |
			((uint32_t)(input[20] & 0xc0) << 10);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 162 to 177
	value = ((uint32_t)(input[20] & 0x3f) << 26) |
			((uint32_t)input[21] << 18) |
			((uint32_t)(input[22] & 0xc0) << 10);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 178 to 193
	value = ((uint32_t)(input[22] & 0x3f) << 26) |
			((uint32_t)input[23] << 18) |
			((uint32_t)(input[24] & 0xc0) << 10);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 194 to 209
	value = ((uint32_t)(input[24] & 0x3f) << 26) |
			((uint32_t)input[25] << 18) |
			((uint32_t)(input[26] & 0xc0) << 10);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 210 to 225
	value = ((uint32_t)(input[26] & 0x3f) << 26) |
			((uint32_t)input[27] << 18) |
			((uint32_t)(input[28] & 0xc0) << 10);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 226 to 241
	value = ((uint32_t)(input[28] & 0x3f) << 26) |
			((uint32_t)input[29] << 18) |
			((uint32_t)(input[30] & 0xc0) << 10);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 242 to 257
	value = ((uint32_t)(input[30] & 0x3f) << 26) |
			((uint32_t)input[31] << 18) |
			((uint32_t)(input[32] & 0xc0) << 10);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 258 to 273
	value = ((uint32_t)(input[32] & 0x3f) << 26) |
			((uint32_t)input[33] << 18) |
			((uint32_t)(input[34] & 0xc0) << 10);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 274 to 289
	value = ((uint32_t)(input[34] & 0x3f) << 26) |
			((uint32_t)input[35] << 18) |
			((uint32_t)(input[36] & 0xc0) << 10);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 290 to 305
	value = ((uint32_t)(input[36] & 0x3f) << 26) |
			((uint32_t)input[37] << 18) |
			((uint32_t)(input[38] & 0xc0) << 10);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 306 to 321
	value = ((uint32_t)(input[38] & 0x3f) << 26) |
			((uint32_t)input[39] << 18) |
			((uint32_t)(input[40] & 0xc0) << 10);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 322 to 337
	value = ((uint32_t)(input[40] & 0x3f) << 26) |
			((uint32_t)input[41] << 18) |
			((uint32_t)(input[42] & 0xc0) << 10);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 338 to 353
	value = ((uint32_t)(input[42] & 0x3f) << 26) |
			((uint32_t)input[43] << 18) |
			((uint32_t)(input[44] & 0xc0) << 10);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 354 to 369
	value = ((uint32_t)(input[44] & 0x3f) << 26) |
			((uint32_t)input[45] << 18) |
			((uint32_t)(input[46] & 0xc0) << 10);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 370 to 385
	value = ((uint32_t)(input[46] & 0x3f) << 26) |
			((uint32_t)input[47] << 18) |
			((uint32_t)(input[48] & 0xc0) << 10);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 386 to 401
	value = ((uint32_t)(input[48] & 0x3f) << 26) |
			((uint32_t)input[49] << 18) |
			((uint32_t)(input[50] & 0xc0) << 10);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 402 to 417
	value = ((uint32_t)(input[50] & 0x3f) << 26) |
			((uint32_t)input[51] << 18) |
			((uint32_t)(input[52] & 0xc0) << 10);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 418 to 433
	value = ((uint32_t)(input[52] & 0x3f) << 26) |
			((uint32_t)input[53] << 18) |
			((uint32_t)(input[54] & 0xc0) << 10);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 434 to 449
	value = ((uint32_t)(input[54] & 0x3f) << 26) |
			((uint32_t)input[55] << 18) |
			((uint32_t)(input[56] & 0xc0) << 10);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 450 to 465
	value = ((uint32_t)(input[56] & 0x3f) << 26) |
			((uint32_t)input[57] << 18) |
			((uint32_t)(input[58] & 0xc0) << 10);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 466 to 481
	value = ((uint32_t)(input[58] & 0x3f) << 26) |
			((uint32_t)input[59] << 18) |
			((uint32_t)(input[60] & 0xc0) << 10);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 482 to 497
	value = ((uint32_t)(input[60] & 0x3f) << 26) |
			((uint32_t)input[61] << 18) |
			((uint32_t)(input[62] & 0xc0) << 10);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 498 to 513
	value = ((uint32_t)(input[62] & 0x3f) << 26) |
			((uint32_t)input[63] << 18) |
			((uint32_t)(input[64] & 0xc0) << 10);
	output[31] = (double)(value >> 16);
}

static void unpack_32_16bit_unsigned_2off(const uint8_t * input, double * output, void *closure) {
	// Unpack 32 values into output
	// Values are 16-bit unsigned
	// Skip 2 bits, read 512 bits of data.
	// Input must be at least 65 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 2 to 17
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)input[1] << 18) |
			((uint32_t)(input[2] & 0xc0) << 10);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 18 to 33
	value = ((uint32_t)(input[2] & 0x3f) << 26) |
			((uint32_t)input[3] << 18) |
			((uint32_t)(input[4] & 0xc0) << 10);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 34 to 49
	value = ((uint32_t)(input[4] & 0x3f) << 26) |
			((uint32_t)input[5] << 18) |
			((uint32_t)(input[6] & 0xc0) << 10);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 50 to 65
	value = ((uint32_t)(input[6] & 0x3f) << 26) |
			((uint32_t)input[7] << 18) |
			((uint32_t)(input[8] & 0xc0) << 10);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 66 to 81
	value = ((uint32_t)(input[8] & 0x3f) << 26) |
			((uint32_t)input[9] << 18) |
			((uint32_t)(input[10] & 0xc0) << 10);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 82 to 97
	value = ((uint32_t)(input[10] & 0x3f) << 26) |
			((uint32_t)input[11] << 18) |
			((uint32_t)(input[12] & 0xc0) << 10);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 98 to 113
	value = ((uint32_t)(input[12] & 0x3f) << 26) |
			((uint32_t)input[13] << 18) |
			((uint32_t)(input[14] & 0xc0) << 10);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 114 to 129
	value = ((uint32_t)(input[14] & 0x3f) << 26) |
			((uint32_t)input[15] << 18) |
			((uint32_t)(input[16] & 0xc0) << 10);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 130 to 145
	value = ((uint32_t)(input[16] & 0x3f) << 26) |
			((uint32_t)input[17] << 18) |
			((uint32_t)(input[18] & 0xc0) << 10);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 146 to 161
	value = ((uint32_t)(input[18] & 0x3f) << 26) |
			((uint32_t)input[19] << 18) |
			((uint32_t)(input[20] & 0xc0) << 10);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 162 to 177
	value = ((uint32_t)(input[20] & 0x3f) << 26) |
			((uint32_t)input[21] << 18) |
			((uint32_t)(input[22] & 0xc0) << 10);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 178 to 193
	value = ((uint32_t)(input[22] & 0x3f) << 26) |
			((uint32_t)input[23] << 18) |
			((uint32_t)(input[24] & 0xc0) << 10);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 194 to 209
	value = ((uint32_t)(input[24] & 0x3f) << 26) |
			((uint32_t)input[25] << 18) |
			((uint32_t)(input[26] & 0xc0) << 10);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 210 to 225
	value = ((uint32_t)(input[26] & 0x3f) << 26) |
			((uint32_t)input[27] << 18) |
			((uint32_t)(input[28] & 0xc0) << 10);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 226 to 241
	value = ((uint32_t)(input[28] & 0x3f) << 26) |
			((uint32_t)input[29] << 18) |
			((uint32_t)(input[30] & 0xc0) << 10);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 242 to 257
	value = ((uint32_t)(input[30] & 0x3f) << 26) |
			((uint32_t)input[31] << 18) |
			((uint32_t)(input[32] & 0xc0) << 10);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 258 to 273
	value = ((uint32_t)(input[32] & 0x3f) << 26) |
			((uint32_t)input[33] << 18) |
			((uint32_t)(input[34] & 0xc0) << 10);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 274 to 289
	value = ((uint32_t)(input[34] & 0x3f) << 26) |
			((uint32_t)input[35] << 18) |
			((uint32_t)(input[36] & 0xc0) << 10);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 290 to 305
	value = ((uint32_t)(input[36] & 0x3f) << 26) |
			((uint32_t)input[37] << 18) |
			((uint32_t)(input[38] & 0xc0) << 10);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 306 to 321
	value = ((uint32_t)(input[38] & 0x3f) << 26) |
			((uint32_t)input[39] << 18) |
			((uint32_t)(input[40] & 0xc0) << 10);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 322 to 337
	value = ((uint32_t)(input[40] & 0x3f) << 26) |
			((uint32_t)input[41] << 18) |
			((uint32_t)(input[42] & 0xc0) << 10);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 338 to 353
	value = ((uint32_t)(input[42] & 0x3f) << 26) |
			((uint32_t)input[43] << 18) |
			((uint32_t)(input[44] & 0xc0) << 10);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 354 to 369
	value = ((uint32_t)(input[44] & 0x3f) << 26) |
			((uint32_t)input[45] << 18) |
			((uint32_t)(input[46] & 0xc0) << 10);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 370 to 385
	value = ((uint32_t)(input[46] & 0x3f) << 26) |
			((uint32_t)input[47] << 18) |
			((uint32_t)(input[48] & 0xc0) << 10);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 386 to 401
	value = ((uint32_t)(input[48] & 0x3f) << 26) |
			((uint32_t)input[49] << 18) |
			((uint32_t)(input[50] & 0xc0) << 10);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 402 to 417
	value = ((uint32_t)(input[50] & 0x3f) << 26) |
			((uint32_t)input[51] << 18) |
			((uint32_t)(input[52] & 0xc0) << 10);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 418 to 433
	value = ((uint32_t)(input[52] & 0x3f) << 26) |
			((uint32_t)input[53] << 18) |
			((uint32_t)(input[54] & 0xc0) << 10);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 434 to 449
	value = ((uint32_t)(input[54] & 0x3f) << 26) |
			((uint32_t)input[55] << 18) |
			((uint32_t)(input[56] & 0xc0) << 10);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 450 to 465
	value = ((uint32_t)(input[56] & 0x3f) << 26) |
			((uint32_t)input[57] << 18) |
			((uint32_t)(input[58] & 0xc0) << 10);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 466 to 481
	value = ((uint32_t)(input[58] & 0x3f) << 26) |
			((uint32_t)input[59] << 18) |
			((uint32_t)(input[60] & 0xc0) << 10);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 482 to 497
	value = ((uint32_t)(input[60] & 0x3f) << 26) |
			((uint32_t)input[61] << 18) |
			((uint32_t)(input[62] & 0xc0) << 10);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 498 to 513
	value = ((uint32_t)(input[62] & 0x3f) << 26) |
			((uint32_t)input[63] << 18) |
			((uint32_t)(input[64] & 0xc0) << 10);
	output[31] = (double)(value >> 16);
}

static void unpack_32_16bit_signed_3off(const uint8_t * input, double * output, void *closure) {
	// Unpack 32 values into output
	// Values are 16-bit signed
	// Skip 3 bits, read 512 bits of data.
	// Input must be at least 65 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 3 to 18
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)input[1] << 19) |
			((uint32_t)(input[2] & 0xe0) << 11);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 19 to 34
	value = ((uint32_t)(input[2] & 0x1f) << 27) |
			((uint32_t)input[3] << 19) |
			((uint32_t)(input[4] & 0xe0) << 11);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 35 to 50
	value = ((uint32_t)(input[4] & 0x1f) << 27) |
			((uint32_t)input[5] << 19) |
			((uint32_t)(input[6] & 0xe0) << 11);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 51 to 66
	value = ((uint32_t)(input[6] & 0x1f) << 27) |
			((uint32_t)input[7] << 19) |
			((uint32_t)(input[8] & 0xe0) << 11);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 67 to 82
	value = ((uint32_t)(input[8] & 0x1f) << 27) |
			((uint32_t)input[9] << 19) |
			((uint32_t)(input[10] & 0xe0) << 11);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 83 to 98
	value = ((uint32_t)(input[10] & 0x1f) << 27) |
			((uint32_t)input[11] << 19) |
			((uint32_t)(input[12] & 0xe0) << 11);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 99 to 114
	value = ((uint32_t)(input[12] & 0x1f) << 27) |
			((uint32_t)input[13] << 19) |
			((uint32_t)(input[14] & 0xe0) << 11);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 115 to 130
	value = ((uint32_t)(input[14] & 0x1f) << 27) |
			((uint32_t)input[15] << 19) |
			((uint32_t)(input[16] & 0xe0) << 11);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 131 to 146
	value = ((uint32_t)(input[16] & 0x1f) << 27) |
			((uint32_t)input[17] << 19) |
			((uint32_t)(input[18] & 0xe0) << 11);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 147 to 162
	value = ((uint32_t)(input[18] & 0x1f) << 27) |
			((uint32_t)input[19] << 19) |
			((uint32_t)(input[20] & 0xe0) << 11);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 163 to 178
	value = ((uint32_t)(input[20] & 0x1f) << 27) |
			((uint32_t)input[21] << 19) |
			((uint32_t)(input[22] & 0xe0) << 11);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 179 to 194
	value = ((uint32_t)(input[22] & 0x1f) << 27) |
			((uint32_t)input[23] << 19) |
			((uint32_t)(input[24] & 0xe0) << 11);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 195 to 210
	value = ((uint32_t)(input[24] & 0x1f) << 27) |
			((uint32_t)input[25] << 19) |
			((uint32_t)(input[26] & 0xe0) << 11);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 211 to 226
	value = ((uint32_t)(input[26] & 0x1f) << 27) |
			((uint32_t)input[27] << 19) |
			((uint32_t)(input[28] & 0xe0) << 11);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 227 to 242
	value = ((uint32_t)(input[28] & 0x1f) << 27) |
			((uint32_t)input[29] << 19) |
			((uint32_t)(input[30] & 0xe0) << 11);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 243 to 258
	value = ((uint32_t)(input[30] & 0x1f) << 27) |
			((uint32_t)input[31] << 19) |
			((uint32_t)(input[32] & 0xe0) << 11);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 259 to 274
	value = ((uint32_t)(input[32] & 0x1f) << 27) |
			((uint32_t)input[33] << 19) |
			((uint32_t)(input[34] & 0xe0) << 11);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 275 to 290
	value = ((uint32_t)(input[34] & 0x1f) << 27) |
			((uint32_t)input[35] << 19) |
			((uint32_t)(input[36] & 0xe0) << 11);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 291 to 306
	value = ((uint32_t)(input[36] & 0x1f) << 27) |
			((uint32_t)input[37] << 19) |
			((uint32_t)(input[38] & 0xe0) << 11);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 307 to 322
	value = ((uint32_t)(input[38] & 0x1f) << 27) |
			((uint32_t)input[39] << 19) |
			((uint32_t)(input[40] & 0xe0) << 11);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 323 to 338
	value = ((uint32_t)(input[40] & 0x1f) << 27) |
			((uint32_t)input[41] << 19) |
			((uint32_t)(input[42] & 0xe0) << 11);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 339 to 354
	value = ((uint32_t)(input[42] & 0x1f) << 27) |
			((uint32_t)input[43] << 19) |
			((uint32_t)(input[44] & 0xe0) << 11);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 355 to 370
	value = ((uint32_t)(input[44] & 0x1f) << 27) |
			((uint32_t)input[45] << 19) |
			((uint32_t)(input[46] & 0xe0) << 11);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 371 to 386
	value = ((uint32_t)(input[46] & 0x1f) << 27) |
			((uint32_t)input[47] << 19) |
			((uint32_t)(input[48] & 0xe0) << 11);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 387 to 402
	value = ((uint32_t)(input[48] & 0x1f) << 27) |
			((uint32_t)input[49] << 19) |
			((uint32_t)(input[50] & 0xe0) << 11);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 403 to 418
	value = ((uint32_t)(input[50] & 0x1f) << 27) |
			((uint32_t)input[51] << 19) |
			((uint32_t)(input[52] & 0xe0) << 11);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 419 to 434
	value = ((uint32_t)(input[52] & 0x1f) << 27) |
			((uint32_t)input[53] << 19) |
			((uint32_t)(input[54] & 0xe0) << 11);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 435 to 450
	value = ((uint32_t)(input[54] & 0x1f) << 27) |
			((uint32_t)input[55] << 19) |
			((uint32_t)(input[56] & 0xe0) << 11);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 451 to 466
	value = ((uint32_t)(input[56] & 0x1f) << 27) |
			((uint32_t)input[57] << 19) |
			((uint32_t)(input[58] & 0xe0) << 11);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 467 to 482
	value = ((uint32_t)(input[58] & 0x1f) << 27) |
			((uint32_t)input[59] << 19) |
			((uint32_t)(input[60] & 0xe0) << 11);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 483 to 498
	value = ((uint32_t)(input[60] & 0x1f) << 27) |
			((uint32_t)input[61] << 19) |
			((uint32_t)(input[62] & 0xe0) << 11);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 499 to 514
	value = ((uint32_t)(input[62] & 0x1f) << 27) |
			((uint32_t)input[63] << 19) |
			((uint32_t)(input[64] & 0xe0) << 11);
	output[31] = (double)(value >> 16);
}

static void unpack_32_16bit_unsigned_3off(const uint8_t * input, double * output, void *closure) {
	// Unpack 32 values into output
	// Values are 16-bit unsigned
	// Skip 3 bits, read 512 bits of data.
	// Input must be at least 65 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 3 to 18
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)input[1] << 19) |
			((uint32_t)(input[2] & 0xe0) << 11);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 19 to 34
	value = ((uint32_t)(input[2] & 0x1f) << 27) |
			((uint32_t)input[3] << 19) |
			((uint32_t)(input[4] & 0xe0) << 11);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 35 to 50
	value = ((uint32_t)(input[4] & 0x1f) << 27) |
			((uint32_t)input[5] << 19) |
			((uint32_t)(input[6] & 0xe0) << 11);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 51 to 66
	value = ((uint32_t)(input[6] & 0x1f) << 27) |
			((uint32_t)input[7] << 19) |
			((uint32_t)(input[8] & 0xe0) << 11);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 67 to 82
	value = ((uint32_t)(input[8] & 0x1f) << 27) |
			((uint32_t)input[9] << 19) |
			((uint32_t)(input[10] & 0xe0) << 11);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 83 to 98
	value = ((uint32_t)(input[10] & 0x1f) << 27) |
			((uint32_t)input[11] << 19) |
			((uint32_t)(input[12] & 0xe0) << 11);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 99 to 114
	value = ((uint32_t)(input[12] & 0x1f) << 27) |
			((uint32_t)input[13] << 19) |
			((uint32_t)(input[14] & 0xe0) << 11);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 115 to 130
	value = ((uint32_t)(input[14] & 0x1f) << 27) |
			((uint32_t)input[15] << 19) |
			((uint32_t)(input[16] & 0xe0) << 11);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 131 to 146
	value = ((uint32_t)(input[16] & 0x1f) << 27) |
			((uint32_t)input[17] << 19) |
			((uint32_t)(input[18] & 0xe0) << 11);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 147 to 162
	value = ((uint32_t)(input[18] & 0x1f) << 27) |
			((uint32_t)input[19] << 19) |
			((uint32_t)(input[20] & 0xe0) << 11);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 163 to 178
	value = ((uint32_t)(input[20] & 0x1f) << 27) |
			((uint32_t)input[21] << 19) |
			((uint32_t)(input[22] & 0xe0) << 11);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 179 to 194
	value = ((uint32_t)(input[22] & 0x1f) << 27) |
			((uint32_t)input[23] << 19) |
			((uint32_t)(input[24] & 0xe0) << 11);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 195 to 210
	value = ((uint32_t)(input[24] & 0x1f) << 27) |
			((uint32_t)input[25] << 19) |
			((uint32_t)(input[26] & 0xe0) << 11);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 211 to 226
	value = ((uint32_t)(input[26] & 0x1f) << 27) |
			((uint32_t)input[27] << 19) |
			((uint32_t)(input[28] & 0xe0) << 11);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 227 to 242
	value = ((uint32_t)(input[28] & 0x1f) << 27) |
			((uint32_t)input[29] << 19) |
			((uint32_t)(input[30] & 0xe0) << 11);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 243 to 258
	value = ((uint32_t)(input[30] & 0x1f) << 27) |
			((uint32_t)input[31] << 19) |
			((uint32_t)(input[32] & 0xe0) << 11);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 259 to 274
	value = ((uint32_t)(input[32] & 0x1f) << 27) |
			((uint32_t)input[33] << 19) |
			((uint32_t)(input[34] & 0xe0) << 11);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 275 to 290
	value = ((uint32_t)(input[34] & 0x1f) << 27) |
			((uint32_t)input[35] << 19) |
			((uint32_t)(input[36] & 0xe0) << 11);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 291 to 306
	value = ((uint32_t)(input[36] & 0x1f) << 27) |
			((uint32_t)input[37] << 19) |
			((uint32_t)(input[38] & 0xe0) << 11);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 307 to 322
	value = ((uint32_t)(input[38] & 0x1f) << 27) |
			((uint32_t)input[39] << 19) |
			((uint32_t)(input[40] & 0xe0) << 11);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 323 to 338
	value = ((uint32_t)(input[40] & 0x1f) << 27) |
			((uint32_t)input[41] << 19) |
			((uint32_t)(input[42] & 0xe0) << 11);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 339 to 354
	value = ((uint32_t)(input[42] & 0x1f) << 27) |
			((uint32_t)input[43] << 19) |
			((uint32_t)(input[44] & 0xe0) << 11);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 355 to 370
	value = ((uint32_t)(input[44] & 0x1f) << 27) |
			((uint32_t)input[45] << 19) |
			((uint32_t)(input[46] & 0xe0) << 11);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 371 to 386
	value = ((uint32_t)(input[46] & 0x1f) << 27) |
			((uint32_t)input[47] << 19) |
			((uint32_t)(input[48] & 0xe0) << 11);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 387 to 402
	value = ((uint32_t)(input[48] & 0x1f) << 27) |
			((uint32_t)input[49] << 19) |
			((uint32_t)(input[50] & 0xe0) << 11);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 403 to 418
	value = ((uint32_t)(input[50] & 0x1f) << 27) |
			((uint32_t)input[51] << 19) |
			((uint32_t)(input[52] & 0xe0) << 11);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 419 to 434
	value = ((uint32_t)(input[52] & 0x1f) << 27) |
			((uint32_t)input[53] << 19) |
			((uint32_t)(input[54] & 0xe0) << 11);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 435 to 450
	value = ((uint32_t)(input[54] & 0x1f) << 27) |
			((uint32_t)input[55] << 19) |
			((uint32_t)(input[56] & 0xe0) << 11);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 451 to 466
	value = ((uint32_t)(input[56] & 0x1f) << 27) |
			((uint32_t)input[57] << 19) |
			((uint32_t)(input[58] & 0xe0) << 11);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 467 to 482
	value = ((uint32_t)(input[58] & 0x1f) << 27) |
			((uint32_t)input[59] << 19) |
			((uint32_t)(input[60] & 0xe0) << 11);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 483 to 498
	value = ((uint32_t)(input[60] & 0x1f) << 27) |
			((uint32_t)input[61] << 19) |
			((uint32_t)(input[62] & 0xe0) << 11);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 499 to 514
	value = ((uint32_t)(input[62] & 0x1f) << 27) |
			((uint32_t)input[63] << 19) |
			((uint32_t)(input[64] & 0xe0) << 11);
	output[31] = (double)(value >> 16);
}

static void unpack_32_16bit_signed_4off(const uint8_t * input, double * output, void *closure) {
	// Unpack 32 values into output
	// Values are 16-bit signed
	// Skip 4 bits, read 512 bits of data.
	// Input must be at least 65 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 4 to 19
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20) |
			((uint32_t)(input[2] & 0xf0) << 12);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 20 to 35
	value = ((uint32_t)(input[2] & 0x0f) << 28) |
			((uint32_t)input[3] << 20) |
			((uint32_t)(input[4] & 0xf0) << 12);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 36 to 51
	value = ((uint32_t)(input[4] & 0x0f) << 28) |
			((uint32_t)input[5] << 20) |
			((uint32_t)(input[6] & 0xf0) << 12);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 52 to 67
	value = ((uint32_t)(input[6] & 0x0f) << 28) |
			((uint32_t)input[7] << 20) |
			((uint32_t)(input[8] & 0xf0) << 12);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 68 to 83
	value = ((uint32_t)(input[8] & 0x0f) << 28) |
			((uint32_t)input[9] << 20) |
			((uint32_t)(input[10] & 0xf0) << 12);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 84 to 99
	value = ((uint32_t)(input[10] & 0x0f) << 28) |
			((uint32_t)input[11] << 20) |
			((uint32_t)(input[12] & 0xf0) << 12);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 100 to 115
	value = ((uint32_t)(input[12] & 0x0f) << 28) |
			((uint32_t)input[13] << 20) |
			((uint32_t)(input[14] & 0xf0) << 12);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 116 to 131
	value = ((uint32_t)(input[14] & 0x0f) << 28) |
			((uint32_t)input[15] << 20) |
			((uint32_t)(input[16] & 0xf0) << 12);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 132 to 147
	value = ((uint32_t)(input[16] & 0x0f) << 28) |
			((uint32_t)input[17] << 20) |
			((uint32_t)(input[18] & 0xf0) << 12);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 148 to 163
	value = ((uint32_t)(input[18] & 0x0f) << 28) |
			((uint32_t)input[19] << 20) |
			((uint32_t)(input[20] & 0xf0) << 12);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 164 to 179
	value = ((uint32_t)(input[20] & 0x0f) << 28) |
			((uint32_t)input[21] << 20) |
			((uint32_t)(input[22] & 0xf0) << 12);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 180 to 195
	value = ((uint32_t)(input[22] & 0x0f) << 28) |
			((uint32_t)input[23] << 20) |
			((uint32_t)(input[24] & 0xf0) << 12);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 196 to 211
	value = ((uint32_t)(input[24] & 0x0f) << 28) |
			((uint32_t)input[25] << 20) |
			((uint32_t)(input[26] & 0xf0) << 12);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 212 to 227
	value = ((uint32_t)(input[26] & 0x0f) << 28) |
			((uint32_t)input[27] << 20) |
			((uint32_t)(input[28] & 0xf0) << 12);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 228 to 243
	value = ((uint32_t)(input[28] & 0x0f) << 28) |
			((uint32_t)input[29] << 20) |
			((uint32_t)(input[30] & 0xf0) << 12);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 244 to 259
	value = ((uint32_t)(input[30] & 0x0f) << 28) |
			((uint32_t)input[31] << 20) |
			((uint32_t)(input[32] & 0xf0) << 12);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 260 to 275
	value = ((uint32_t)(input[32] & 0x0f) << 28) |
			((uint32_t)input[33] << 20) |
			((uint32_t)(input[34] & 0xf0) << 12);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 276 to 291
	value = ((uint32_t)(input[34] & 0x0f) << 28) |
			((uint32_t)input[35] << 20) |
			((uint32_t)(input[36] & 0xf0) << 12);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 292 to 307
	value = ((uint32_t)(input[36] & 0x0f) << 28) |
			((uint32_t)input[37] << 20) |
			((uint32_t)(input[38] & 0xf0) << 12);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 308 to 323
	value = ((uint32_t)(input[38] & 0x0f) << 28) |
			((uint32_t)input[39] << 20) |
			((uint32_t)(input[40] & 0xf0) << 12);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 324 to 339
	value = ((uint32_t)(input[40] & 0x0f) << 28) |
			((uint32_t)input[41] << 20) |
			((uint32_t)(input[42] & 0xf0) << 12);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 340 to 355
	value = ((uint32_t)(input[42] & 0x0f) << 28) |
			((uint32_t)input[43] << 20) |
			((uint32_t)(input[44] & 0xf0) << 12);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 356 to 371
	value = ((uint32_t)(input[44] & 0x0f) << 28) |
			((uint32_t)input[45] << 20) |
			((uint32_t)(input[46] & 0xf0) << 12);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 372 to 387
	value = ((uint32_t)(input[46] & 0x0f) << 28) |
			((uint32_t)input[47] << 20) |
			((uint32_t)(input[48] & 0xf0) << 12);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 388 to 403
	value = ((uint32_t)(input[48] & 0x0f) << 28) |
			((uint32_t)input[49] << 20) |
			((uint32_t)(input[50] & 0xf0) << 12);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 404 to 419
	value = ((uint32_t)(input[50] & 0x0f) << 28) |
			((uint32_t)input[51] << 20) |
			((uint32_t)(input[52] & 0xf0) << 12);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 420 to 435
	value = ((uint32_t)(input[52] & 0x0f) << 28) |
			((uint32_t)input[53] << 20) |
			((uint32_t)(input[54] & 0xf0) << 12);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 436 to 451
	value = ((uint32_t)(input[54] & 0x0f) << 28) |
			((uint32_t)input[55] << 20) |
			((uint32_t)(input[56] & 0xf0) << 12);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 452 to 467
	value = ((uint32_t)(input[56] & 0x0f) << 28) |
			((uint32_t)input[57] << 20) |
			((uint32_t)(input[58] & 0xf0) << 12);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 468 to 483
	value = ((uint32_t)(input[58] & 0x0f) << 28) |
			((uint32_t)input[59] << 20) |
			((uint32_t)(input[60] & 0xf0) << 12);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 484 to 499
	value = ((uint32_t)(input[60] & 0x0f) << 28) |
			((uint32_t)input[61] << 20) |
			((uint32_t)(input[62] & 0xf0) << 12);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 500 to 515
	value = ((uint32_t)(input[62] & 0x0f) << 28) |
			((uint32_t)input[63] << 20) |
			((uint32_t)(input[64] & 0xf0) << 12);
	output[31] = (double)(value >> 16);
}

static void unpack_32_16bit_unsigned_4off(const uint8_t * input, double * output, void *closure) {
	// Unpack 32 values into output
	// Values are 16-bit unsigned
	// Skip 4 bits, read 512 bits of data.
	// Input must be at least 65 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 4 to 19
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20) |
			((uint32_t)(input[2] & 0xf0) << 12);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 20 to 35
	value = ((uint32_t)(input[2] & 0x0f) << 28) |
			((uint32_t)input[3] << 20) |
			((uint32_t)(input[4] & 0xf0) << 12);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 36 to 51
	value = ((uint32_t)(input[4] & 0x0f) << 28) |
			((uint32_t)input[5] << 20) |
			((uint32_t)(input[6] & 0xf0) << 12);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 52 to 67
	value = ((uint32_t)(input[6] & 0x0f) << 28) |
			((uint32_t)input[7] << 20) |
			((uint32_t)(input[8] & 0xf0) << 12);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 68 to 83
	value = ((uint32_t)(input[8] & 0x0f) << 28) |
			((uint32_t)input[9] << 20) |
			((uint32_t)(input[10] & 0xf0) << 12);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 84 to 99
	value = ((uint32_t)(input[10] & 0x0f) << 28) |
			((uint32_t)input[11] << 20) |
			((uint32_t)(input[12] & 0xf0) << 12);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 100 to 115
	value = ((uint32_t)(input[12] & 0x0f) << 28) |
			((uint32_t)input[13] << 20) |
			((uint32_t)(input[14] & 0xf0) << 12);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 116 to 131
	value = ((uint32_t)(input[14] & 0x0f) << 28) |
			((uint32_t)input[15] << 20) |
			((uint32_t)(input[16] & 0xf0) << 12);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 132 to 147
	value = ((uint32_t)(input[16] & 0x0f) << 28) |
			((uint32_t)input[17] << 20) |
			((uint32_t)(input[18] & 0xf0) << 12);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 148 to 163
	value = ((uint32_t)(input[18] & 0x0f) << 28) |
			((uint32_t)input[19] << 20) |
			((uint32_t)(input[20] & 0xf0) << 12);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 164 to 179
	value = ((uint32_t)(input[20] & 0x0f) << 28) |
			((uint32_t)input[21] << 20) |
			((uint32_t)(input[22] & 0xf0) << 12);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 180 to 195
	value = ((uint32_t)(input[22] & 0x0f) << 28) |
			((uint32_t)input[23] << 20) |
			((uint32_t)(input[24] & 0xf0) << 12);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 196 to 211
	value = ((uint32_t)(input[24] & 0x0f) << 28) |
			((uint32_t)input[25] << 20) |
			((uint32_t)(input[26] & 0xf0) << 12);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 212 to 227
	value = ((uint32_t)(input[26] & 0x0f) << 28) |
			((uint32_t)input[27] << 20) |
			((uint32_t)(input[28] & 0xf0) << 12);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 228 to 243
	value = ((uint32_t)(input[28] & 0x0f) << 28) |
			((uint32_t)input[29] << 20) |
			((uint32_t)(input[30] & 0xf0) << 12);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 244 to 259
	value = ((uint32_t)(input[30] & 0x0f) << 28) |
			((uint32_t)input[31] << 20) |
			((uint32_t)(input[32] & 0xf0) << 12);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 260 to 275
	value = ((uint32_t)(input[32] & 0x0f) << 28) |
			((uint32_t)input[33] << 20) |
			((uint32_t)(input[34] & 0xf0) << 12);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 276 to 291
	value = ((uint32_t)(input[34] & 0x0f) << 28) |
			((uint32_t)input[35] << 20) |
			((uint32_t)(input[36] & 0xf0) << 12);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 292 to 307
	value = ((uint32_t)(input[36] & 0x0f) << 28) |
			((uint32_t)input[37] << 20) |
			((uint32_t)(input[38] & 0xf0) << 12);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 308 to 323
	value = ((uint32_t)(input[38] & 0x0f) << 28) |
			((uint32_t)input[39] << 20) |
			((uint32_t)(input[40] & 0xf0) << 12);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 324 to 339
	value = ((uint32_t)(input[40] & 0x0f) << 28) |
			((uint32_t)input[41] << 20) |
			((uint32_t)(input[42] & 0xf0) << 12);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 340 to 355
	value = ((uint32_t)(input[42] & 0x0f) << 28) |
			((uint32_t)input[43] << 20) |
			((uint32_t)(input[44] & 0xf0) << 12);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 356 to 371
	value = ((uint32_t)(input[44] & 0x0f) << 28) |
			((uint32_t)input[45] << 20) |
			((uint32_t)(input[46] & 0xf0) << 12);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 372 to 387
	value = ((uint32_t)(input[46] & 0x0f) << 28) |
			((uint32_t)input[47] << 20) |
			((uint32_t)(input[48] & 0xf0) << 12);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 388 to 403
	value = ((uint32_t)(input[48] & 0x0f) << 28) |
			((uint32_t)input[49] << 20) |
			((uint32_t)(input[50] & 0xf0) << 12);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 404 to 419
	value = ((uint32_t)(input[50] & 0x0f) << 28) |
			((uint32_t)input[51] << 20) |
			((uint32_t)(input[52] & 0xf0) << 12);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 420 to 435
	value = ((uint32_t)(input[52] & 0x0f) << 28) |
			((uint32_t)input[53] << 20) |
			((uint32_t)(input[54] & 0xf0) << 12);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 436 to 451
	value = ((uint32_t)(input[54] & 0x0f) << 28) |
			((uint32_t)input[55] << 20) |
			((uint32_t)(input[56] & 0xf0) << 12);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 452 to 467
	value = ((uint32_t)(input[56] & 0x0f) << 28) |
			((uint32_t)input[57] << 20) |
			((uint32_t)(input[58] & 0xf0) << 12);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 468 to 483
	value = ((uint32_t)(input[58] & 0x0f) << 28) |
			((uint32_t)input[59] << 20) |
			((uint32_t)(input[60] & 0xf0) << 12);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 484 to 499
	value = ((uint32_t)(input[60] & 0x0f) << 28) |
			((uint32_t)input[61] << 20) |
			((uint32_t)(input[62] & 0xf0) << 12);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 500 to 515
	value = ((uint32_t)(input[62] & 0x0f) << 28) |
			((uint32_t)input[63] << 20) |
			((uint32_t)(input[64] & 0xf0) << 12);
	output[31] = (double)(value >> 16);
}

static void unpack_32_16bit_signed_5off(const uint8_t * input, double * output, void *closure) {
	// Unpack 32 values into output
	// Values are 16-bit signed
	// Skip 5 bits, read 512 bits of data.
	// Input must be at least 65 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 5 to 20
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)(input[2] & 0xf8) << 13);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 21 to 36
	value = ((uint32_t)(input[2] & 0x07) << 29) |
			((uint32_t)input[3] << 21) |
			((uint32_t)(input[4] & 0xf8) << 13);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 37 to 52
	value = ((uint32_t)(input[4] & 0x07) << 29) |
			((uint32_t)input[5] << 21) |
			((uint32_t)(input[6] & 0xf8) << 13);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 53 to 68
	value = ((uint32_t)(input[6] & 0x07) << 29) |
			((uint32_t)input[7] << 21) |
			((uint32_t)(input[8] & 0xf8) << 13);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 69 to 84
	value = ((uint32_t)(input[8] & 0x07) << 29) |
			((uint32_t)input[9] << 21) |
			((uint32_t)(input[10] & 0xf8) << 13);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 85 to 100
	value = ((uint32_t)(input[10] & 0x07) << 29) |
			((uint32_t)input[11] << 21) |
			((uint32_t)(input[12] & 0xf8) << 13);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 101 to 116
	value = ((uint32_t)(input[12] & 0x07) << 29) |
			((uint32_t)input[13] << 21) |
			((uint32_t)(input[14] & 0xf8) << 13);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 117 to 132
	value = ((uint32_t)(input[14] & 0x07) << 29) |
			((uint32_t)input[15] << 21) |
			((uint32_t)(input[16] & 0xf8) << 13);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 133 to 148
	value = ((uint32_t)(input[16] & 0x07) << 29) |
			((uint32_t)input[17] << 21) |
			((uint32_t)(input[18] & 0xf8) << 13);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 149 to 164
	value = ((uint32_t)(input[18] & 0x07) << 29) |
			((uint32_t)input[19] << 21) |
			((uint32_t)(input[20] & 0xf8) << 13);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 165 to 180
	value = ((uint32_t)(input[20] & 0x07) << 29) |
			((uint32_t)input[21] << 21) |
			((uint32_t)(input[22] & 0xf8) << 13);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 181 to 196
	value = ((uint32_t)(input[22] & 0x07) << 29) |
			((uint32_t)input[23] << 21) |
			((uint32_t)(input[24] & 0xf8) << 13);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 197 to 212
	value = ((uint32_t)(input[24] & 0x07) << 29) |
			((uint32_t)input[25] << 21) |
			((uint32_t)(input[26] & 0xf8) << 13);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 213 to 228
	value = ((uint32_t)(input[26] & 0x07) << 29) |
			((uint32_t)input[27] << 21) |
			((uint32_t)(input[28] & 0xf8) << 13);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 229 to 244
	value = ((uint32_t)(input[28] & 0x07) << 29) |
			((uint32_t)input[29] << 21) |
			((uint32_t)(input[30] & 0xf8) << 13);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 245 to 260
	value = ((uint32_t)(input[30] & 0x07) << 29) |
			((uint32_t)input[31] << 21) |
			((uint32_t)(input[32] & 0xf8) << 13);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 261 to 276
	value = ((uint32_t)(input[32] & 0x07) << 29) |
			((uint32_t)input[33] << 21) |
			((uint32_t)(input[34] & 0xf8) << 13);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 277 to 292
	value = ((uint32_t)(input[34] & 0x07) << 29) |
			((uint32_t)input[35] << 21) |
			((uint32_t)(input[36] & 0xf8) << 13);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 293 to 308
	value = ((uint32_t)(input[36] & 0x07) << 29) |
			((uint32_t)input[37] << 21) |
			((uint32_t)(input[38] & 0xf8) << 13);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 309 to 324
	value = ((uint32_t)(input[38] & 0x07) << 29) |
			((uint32_t)input[39] << 21) |
			((uint32_t)(input[40] & 0xf8) << 13);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 325 to 340
	value = ((uint32_t)(input[40] & 0x07) << 29) |
			((uint32_t)input[41] << 21) |
			((uint32_t)(input[42] & 0xf8) << 13);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 341 to 356
	value = ((uint32_t)(input[42] & 0x07) << 29) |
			((uint32_t)input[43] << 21) |
			((uint32_t)(input[44] & 0xf8) << 13);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 357 to 372
	value = ((uint32_t)(input[44] & 0x07) << 29) |
			((uint32_t)input[45] << 21) |
			((uint32_t)(input[46] & 0xf8) << 13);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 373 to 388
	value = ((uint32_t)(input[46] & 0x07) << 29) |
			((uint32_t)input[47] << 21) |
			((uint32_t)(input[48] & 0xf8) << 13);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 389 to 404
	value = ((uint32_t)(input[48] & 0x07) << 29) |
			((uint32_t)input[49] << 21) |
			((uint32_t)(input[50] & 0xf8) << 13);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 405 to 420
	value = ((uint32_t)(input[50] & 0x07) << 29) |
			((uint32_t)input[51] << 21) |
			((uint32_t)(input[52] & 0xf8) << 13);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 421 to 436
	value = ((uint32_t)(input[52] & 0x07) << 29) |
			((uint32_t)input[53] << 21) |
			((uint32_t)(input[54] & 0xf8) << 13);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 437 to 452
	value = ((uint32_t)(input[54] & 0x07) << 29) |
			((uint32_t)input[55] << 21) |
			((uint32_t)(input[56] & 0xf8) << 13);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 453 to 468
	value = ((uint32_t)(input[56] & 0x07) << 29) |
			((uint32_t)input[57] << 21) |
			((uint32_t)(input[58] & 0xf8) << 13);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 469 to 484
	value = ((uint32_t)(input[58] & 0x07) << 29) |
			((uint32_t)input[59] << 21) |
			((uint32_t)(input[60] & 0xf8) << 13);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 485 to 500
	value = ((uint32_t)(input[60] & 0x07) << 29) |
			((uint32_t)input[61] << 21) |
			((uint32_t)(input[62] & 0xf8) << 13);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 501 to 516
	value = ((uint32_t)(input[62] & 0x07) << 29) |
			((uint32_t)input[63] << 21) |
			((uint32_t)(input[64] & 0xf8) << 13);
	output[31] = (double)(value >> 16);
}

static void unpack_32_16bit_unsigned_5off(const uint8_t * input, double * output, void *closure) {
	// Unpack 32 values into output
	// Values are 16-bit unsigned
	// Skip 5 bits, read 512 bits of data.
	// Input must be at least 65 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 5 to 20
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)(input[2] & 0xf8) << 13);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 21 to 36
	value = ((uint32_t)(input[2] & 0x07) << 29) |
			((uint32_t)input[3] << 21) |
			((uint32_t)(input[4] & 0xf8) << 13);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 37 to 52
	value = ((uint32_t)(input[4] & 0x07) << 29) |
			((uint32_t)input[5] << 21) |
			((uint32_t)(input[6] & 0xf8) << 13);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 53 to 68
	value = ((uint32_t)(input[6] & 0x07) << 29) |
			((uint32_t)input[7] << 21) |
			((uint32_t)(input[8] & 0xf8) << 13);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 69 to 84
	value = ((uint32_t)(input[8] & 0x07) << 29) |
			((uint32_t)input[9] << 21) |
			((uint32_t)(input[10] & 0xf8) << 13);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 85 to 100
	value = ((uint32_t)(input[10] & 0x07) << 29) |
			((uint32_t)input[11] << 21) |
			((uint32_t)(input[12] & 0xf8) << 13);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 101 to 116
	value = ((uint32_t)(input[12] & 0x07) << 29) |
			((uint32_t)input[13] << 21) |
			((uint32_t)(input[14] & 0xf8) << 13);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 117 to 132
	value = ((uint32_t)(input[14] & 0x07) << 29) |
			((uint32_t)input[15] << 21) |
			((uint32_t)(input[16] & 0xf8) << 13);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 133 to 148
	value = ((uint32_t)(input[16] & 0x07) << 29) |
			((uint32_t)input[17] << 21) |
			((uint32_t)(input[18] & 0xf8) << 13);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 149 to 164
	value = ((uint32_t)(input[18] & 0x07) << 29) |
			((uint32_t)input[19] << 21) |
			((uint32_t)(input[20] & 0xf8) << 13);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 165 to 180
	value = ((uint32_t)(input[20] & 0x07) << 29) |
			((uint32_t)input[21] << 21) |
			((uint32_t)(input[22] & 0xf8) << 13);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 181 to 196
	value = ((uint32_t)(input[22] & 0x07) << 29) |
			((uint32_t)input[23] << 21) |
			((uint32_t)(input[24] & 0xf8) << 13);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 197 to 212
	value = ((uint32_t)(input[24] & 0x07) << 29) |
			((uint32_t)input[25] << 21) |
			((uint32_t)(input[26] & 0xf8) << 13);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 213 to 228
	value = ((uint32_t)(input[26] & 0x07) << 29) |
			((uint32_t)input[27] << 21) |
			((uint32_t)(input[28] & 0xf8) << 13);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 229 to 244
	value = ((uint32_t)(input[28] & 0x07) << 29) |
			((uint32_t)input[29] << 21) |
			((uint32_t)(input[30] & 0xf8) << 13);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 245 to 260
	value = ((uint32_t)(input[30] & 0x07) << 29) |
			((uint32_t)input[31] << 21) |
			((uint32_t)(input[32] & 0xf8) << 13);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 261 to 276
	value = ((uint32_t)(input[32] & 0x07) << 29) |
			((uint32_t)input[33] << 21) |
			((uint32_t)(input[34] & 0xf8) << 13);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 277 to 292
	value = ((uint32_t)(input[34] & 0x07) << 29) |
			((uint32_t)input[35] << 21) |
			((uint32_t)(input[36] & 0xf8) << 13);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 293 to 308
	value = ((uint32_t)(input[36] & 0x07) << 29) |
			((uint32_t)input[37] << 21) |
			((uint32_t)(input[38] & 0xf8) << 13);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 309 to 324
	value = ((uint32_t)(input[38] & 0x07) << 29) |
			((uint32_t)input[39] << 21) |
			((uint32_t)(input[40] & 0xf8) << 13);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 325 to 340
	value = ((uint32_t)(input[40] & 0x07) << 29) |
			((uint32_t)input[41] << 21) |
			((uint32_t)(input[42] & 0xf8) << 13);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 341 to 356
	value = ((uint32_t)(input[42] & 0x07) << 29) |
			((uint32_t)input[43] << 21) |
			((uint32_t)(input[44] & 0xf8) << 13);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 357 to 372
	value = ((uint32_t)(input[44] & 0x07) << 29) |
			((uint32_t)input[45] << 21) |
			((uint32_t)(input[46] & 0xf8) << 13);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 373 to 388
	value = ((uint32_t)(input[46] & 0x07) << 29) |
			((uint32_t)input[47] << 21) |
			((uint32_t)(input[48] & 0xf8) << 13);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 389 to 404
	value = ((uint32_t)(input[48] & 0x07) << 29) |
			((uint32_t)input[49] << 21) |
			((uint32_t)(input[50] & 0xf8) << 13);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 405 to 420
	value = ((uint32_t)(input[50] & 0x07) << 29) |
			((uint32_t)input[51] << 21) |
			((uint32_t)(input[52] & 0xf8) << 13);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 421 to 436
	value = ((uint32_t)(input[52] & 0x07) << 29) |
			((uint32_t)input[53] << 21) |
			((uint32_t)(input[54] & 0xf8) << 13);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 437 to 452
	value = ((uint32_t)(input[54] & 0x07) << 29) |
			((uint32_t)input[55] << 21) |
			((uint32_t)(input[56] & 0xf8) << 13);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 453 to 468
	value = ((uint32_t)(input[56] & 0x07) << 29) |
			((uint32_t)input[57] << 21) |
			((uint32_t)(input[58] & 0xf8) << 13);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 469 to 484
	value = ((uint32_t)(input[58] & 0x07) << 29) |
			((uint32_t)input[59] << 21) |
			((uint32_t)(input[60] & 0xf8) << 13);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 485 to 500
	value = ((uint32_t)(input[60] & 0x07) << 29) |
			((uint32_t)input[61] << 21) |
			((uint32_t)(input[62] & 0xf8) << 13);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 501 to 516
	value = ((uint32_t)(input[62] & 0x07) << 29) |
			((uint32_t)input[63] << 21) |
			((uint32_t)(input[64] & 0xf8) << 13);
	output[31] = (double)(value >> 16);
}

static void unpack_32_16bit_signed_6off(const uint8_t * input, double * output, void *closure) {
	// Unpack 32 values into output
	// Values are 16-bit signed
	// Skip 6 bits, read 512 bits of data.
	// Input must be at least 65 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 6 to 21
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)(input[2] & 0xfc) << 14);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 22 to 37
	value = ((uint32_t)(input[2] & 0x03) << 30) |
			((uint32_t)input[3] << 22) |
			((uint32_t)(input[4] & 0xfc) << 14);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 38 to 53
	value = ((uint32_t)(input[4] & 0x03) << 30) |
			((uint32_t)input[5] << 22) |
			((uint32_t)(input[6] & 0xfc) << 14);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 54 to 69
	value = ((uint32_t)(input[6] & 0x03) << 30) |
			((uint32_t)input[7] << 22) |
			((uint32_t)(input[8] & 0xfc) << 14);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 70 to 85
	value = ((uint32_t)(input[8] & 0x03) << 30) |
			((uint32_t)input[9] << 22) |
			((uint32_t)(input[10] & 0xfc) << 14);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 86 to 101
	value = ((uint32_t)(input[10] & 0x03) << 30) |
			((uint32_t)input[11] << 22) |
			((uint32_t)(input[12] & 0xfc) << 14);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 102 to 117
	value = ((uint32_t)(input[12] & 0x03) << 30) |
			((uint32_t)input[13] << 22) |
			((uint32_t)(input[14] & 0xfc) << 14);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 118 to 133
	value = ((uint32_t)(input[14] & 0x03) << 30) |
			((uint32_t)input[15] << 22) |
			((uint32_t)(input[16] & 0xfc) << 14);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 134 to 149
	value = ((uint32_t)(input[16] & 0x03) << 30) |
			((uint32_t)input[17] << 22) |
			((uint32_t)(input[18] & 0xfc) << 14);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 150 to 165
	value = ((uint32_t)(input[18] & 0x03) << 30) |
			((uint32_t)input[19] << 22) |
			((uint32_t)(input[20] & 0xfc) << 14);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 166 to 181
	value = ((uint32_t)(input[20] & 0x03) << 30) |
			((uint32_t)input[21] << 22) |
			((uint32_t)(input[22] & 0xfc) << 14);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 182 to 197
	value = ((uint32_t)(input[22] & 0x03) << 30) |
			((uint32_t)input[23] << 22) |
			((uint32_t)(input[24] & 0xfc) << 14);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 198 to 213
	value = ((uint32_t)(input[24] & 0x03) << 30) |
			((uint32_t)input[25] << 22) |
			((uint32_t)(input[26] & 0xfc) << 14);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 214 to 229
	value = ((uint32_t)(input[26] & 0x03) << 30) |
			((uint32_t)input[27] << 22) |
			((uint32_t)(input[28] & 0xfc) << 14);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 230 to 245
	value = ((uint32_t)(input[28] & 0x03) << 30) |
			((uint32_t)input[29] << 22) |
			((uint32_t)(input[30] & 0xfc) << 14);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 246 to 261
	value = ((uint32_t)(input[30] & 0x03) << 30) |
			((uint32_t)input[31] << 22) |
			((uint32_t)(input[32] & 0xfc) << 14);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 262 to 277
	value = ((uint32_t)(input[32] & 0x03) << 30) |
			((uint32_t)input[33] << 22) |
			((uint32_t)(input[34] & 0xfc) << 14);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 278 to 293
	value = ((uint32_t)(input[34] & 0x03) << 30) |
			((uint32_t)input[35] << 22) |
			((uint32_t)(input[36] & 0xfc) << 14);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 294 to 309
	value = ((uint32_t)(input[36] & 0x03) << 30) |
			((uint32_t)input[37] << 22) |
			((uint32_t)(input[38] & 0xfc) << 14);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 310 to 325
	value = ((uint32_t)(input[38] & 0x03) << 30) |
			((uint32_t)input[39] << 22) |
			((uint32_t)(input[40] & 0xfc) << 14);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 326 to 341
	value = ((uint32_t)(input[40] & 0x03) << 30) |
			((uint32_t)input[41] << 22) |
			((uint32_t)(input[42] & 0xfc) << 14);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 342 to 357
	value = ((uint32_t)(input[42] & 0x03) << 30) |
			((uint32_t)input[43] << 22) |
			((uint32_t)(input[44] & 0xfc) << 14);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 358 to 373
	value = ((uint32_t)(input[44] & 0x03) << 30) |
			((uint32_t)input[45] << 22) |
			((uint32_t)(input[46] & 0xfc) << 14);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 374 to 389
	value = ((uint32_t)(input[46] & 0x03) << 30) |
			((uint32_t)input[47] << 22) |
			((uint32_t)(input[48] & 0xfc) << 14);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 390 to 405
	value = ((uint32_t)(input[48] & 0x03) << 30) |
			((uint32_t)input[49] << 22) |
			((uint32_t)(input[50] & 0xfc) << 14);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 406 to 421
	value = ((uint32_t)(input[50] & 0x03) << 30) |
			((uint32_t)input[51] << 22) |
			((uint32_t)(input[52] & 0xfc) << 14);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 422 to 437
	value = ((uint32_t)(input[52] & 0x03) << 30) |
			((uint32_t)input[53] << 22) |
			((uint32_t)(input[54] & 0xfc) << 14);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 438 to 453
	value = ((uint32_t)(input[54] & 0x03) << 30) |
			((uint32_t)input[55] << 22) |
			((uint32_t)(input[56] & 0xfc) << 14);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 454 to 469
	value = ((uint32_t)(input[56] & 0x03) << 30) |
			((uint32_t)input[57] << 22) |
			((uint32_t)(input[58] & 0xfc) << 14);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 470 to 485
	value = ((uint32_t)(input[58] & 0x03) << 30) |
			((uint32_t)input[59] << 22) |
			((uint32_t)(input[60] & 0xfc) << 14);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 486 to 501
	value = ((uint32_t)(input[60] & 0x03) << 30) |
			((uint32_t)input[61] << 22) |
			((uint32_t)(input[62] & 0xfc) << 14);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 502 to 517
	value = ((uint32_t)(input[62] & 0x03) << 30) |
			((uint32_t)input[63] << 22) |
			((uint32_t)(input[64] & 0xfc) << 14);
	output[31] = (double)(value >> 16);
}

static void unpack_32_16bit_unsigned_6off(const uint8_t * input, double * output, void *closure) {
	// Unpack 32 values into output
	// Values are 16-bit unsigned
	// Skip 6 bits, read 512 bits of data.
	// Input must be at least 65 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 6 to 21
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)(input[2] & 0xfc) << 14);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 22 to 37
	value = ((uint32_t)(input[2] & 0x03) << 30) |
			((uint32_t)input[3] << 22) |
			((uint32_t)(input[4] & 0xfc) << 14);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 38 to 53
	value = ((uint32_t)(input[4] & 0x03) << 30) |
			((uint32_t)input[5] << 22) |
			((uint32_t)(input[6] & 0xfc) << 14);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 54 to 69
	value = ((uint32_t)(input[6] & 0x03) << 30) |
			((uint32_t)input[7] << 22) |
			((uint32_t)(input[8] & 0xfc) << 14);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 70 to 85
	value = ((uint32_t)(input[8] & 0x03) << 30) |
			((uint32_t)input[9] << 22) |
			((uint32_t)(input[10] & 0xfc) << 14);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 86 to 101
	value = ((uint32_t)(input[10] & 0x03) << 30) |
			((uint32_t)input[11] << 22) |
			((uint32_t)(input[12] & 0xfc) << 14);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 102 to 117
	value = ((uint32_t)(input[12] & 0x03) << 30) |
			((uint32_t)input[13] << 22) |
			((uint32_t)(input[14] & 0xfc) << 14);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 118 to 133
	value = ((uint32_t)(input[14] & 0x03) << 30) |
			((uint32_t)input[15] << 22) |
			((uint32_t)(input[16] & 0xfc) << 14);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 134 to 149
	value = ((uint32_t)(input[16] & 0x03) << 30) |
			((uint32_t)input[17] << 22) |
			((uint32_t)(input[18] & 0xfc) << 14);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 150 to 165
	value = ((uint32_t)(input[18] & 0x03) << 30) |
			((uint32_t)input[19] << 22) |
			((uint32_t)(input[20] & 0xfc) << 14);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 166 to 181
	value = ((uint32_t)(input[20] & 0x03) << 30) |
			((uint32_t)input[21] << 22) |
			((uint32_t)(input[22] & 0xfc) << 14);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 182 to 197
	value = ((uint32_t)(input[22] & 0x03) << 30) |
			((uint32_t)input[23] << 22) |
			((uint32_t)(input[24] & 0xfc) << 14);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 198 to 213
	value = ((uint32_t)(input[24] & 0x03) << 30) |
			((uint32_t)input[25] << 22) |
			((uint32_t)(input[26] & 0xfc) << 14);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 214 to 229
	value = ((uint32_t)(input[26] & 0x03) << 30) |
			((uint32_t)input[27] << 22) |
			((uint32_t)(input[28] & 0xfc) << 14);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 230 to 245
	value = ((uint32_t)(input[28] & 0x03) << 30) |
			((uint32_t)input[29] << 22) |
			((uint32_t)(input[30] & 0xfc) << 14);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 246 to 261
	value = ((uint32_t)(input[30] & 0x03) << 30) |
			((uint32_t)input[31] << 22) |
			((uint32_t)(input[32] & 0xfc) << 14);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 262 to 277
	value = ((uint32_t)(input[32] & 0x03) << 30) |
			((uint32_t)input[33] << 22) |
			((uint32_t)(input[34] & 0xfc) << 14);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 278 to 293
	value = ((uint32_t)(input[34] & 0x03) << 30) |
			((uint32_t)input[35] << 22) |
			((uint32_t)(input[36] & 0xfc) << 14);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 294 to 309
	value = ((uint32_t)(input[36] & 0x03) << 30) |
			((uint32_t)input[37] << 22) |
			((uint32_t)(input[38] & 0xfc) << 14);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 310 to 325
	value = ((uint32_t)(input[38] & 0x03) << 30) |
			((uint32_t)input[39] << 22) |
			((uint32_t)(input[40] & 0xfc) << 14);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 326 to 341
	value = ((uint32_t)(input[40] & 0x03) << 30) |
			((uint32_t)input[41] << 22) |
			((uint32_t)(input[42] & 0xfc) << 14);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 342 to 357
	value = ((uint32_t)(input[42] & 0x03) << 30) |
			((uint32_t)input[43] << 22) |
			((uint32_t)(input[44] & 0xfc) << 14);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 358 to 373
	value = ((uint32_t)(input[44] & 0x03) << 30) |
			((uint32_t)input[45] << 22) |
			((uint32_t)(input[46] & 0xfc) << 14);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 374 to 389
	value = ((uint32_t)(input[46] & 0x03) << 30) |
			((uint32_t)input[47] << 22) |
			((uint32_t)(input[48] & 0xfc) << 14);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 390 to 405
	value = ((uint32_t)(input[48] & 0x03) << 30) |
			((uint32_t)input[49] << 22) |
			((uint32_t)(input[50] & 0xfc) << 14);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 406 to 421
	value = ((uint32_t)(input[50] & 0x03) << 30) |
			((uint32_t)input[51] << 22) |
			((uint32_t)(input[52] & 0xfc) << 14);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 422 to 437
	value = ((uint32_t)(input[52] & 0x03) << 30) |
			((uint32_t)input[53] << 22) |
			((uint32_t)(input[54] & 0xfc) << 14);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 438 to 453
	value = ((uint32_t)(input[54] & 0x03) << 30) |
			((uint32_t)input[55] << 22) |
			((uint32_t)(input[56] & 0xfc) << 14);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 454 to 469
	value = ((uint32_t)(input[56] & 0x03) << 30) |
			((uint32_t)input[57] << 22) |
			((uint32_t)(input[58] & 0xfc) << 14);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 470 to 485
	value = ((uint32_t)(input[58] & 0x03) << 30) |
			((uint32_t)input[59] << 22) |
			((uint32_t)(input[60] & 0xfc) << 14);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 486 to 501
	value = ((uint32_t)(input[60] & 0x03) << 30) |
			((uint32_t)input[61] << 22) |
			((uint32_t)(input[62] & 0xfc) << 14);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 502 to 517
	value = ((uint32_t)(input[62] & 0x03) << 30) |
			((uint32_t)input[63] << 22) |
			((uint32_t)(input[64] & 0xfc) << 14);
	output[31] = (double)(value >> 16);
}

static void unpack_32_16bit_signed_7off(const uint8_t * input, double * output, void *closure) {
	// Unpack 32 values into output
	// Values are 16-bit signed
	// Skip 7 bits, read 512 bits of data.
	// Input must be at least 65 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 7 to 22
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)(input[2] & 0xfe) << 15);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 23 to 38
	value = ((uint32_t)(input[2] & 0x01) << 31) |
			((uint32_t)input[3] << 23) |
			((uint32_t)(input[4] & 0xfe) << 15);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 39 to 54
	value = ((uint32_t)(input[4] & 0x01) << 31) |
			((uint32_t)input[5] << 23) |
			((uint32_t)(input[6] & 0xfe) << 15);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 55 to 70
	value = ((uint32_t)(input[6] & 0x01) << 31) |
			((uint32_t)input[7] << 23) |
			((uint32_t)(input[8] & 0xfe) << 15);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 71 to 86
	value = ((uint32_t)(input[8] & 0x01) << 31) |
			((uint32_t)input[9] << 23) |
			((uint32_t)(input[10] & 0xfe) << 15);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 87 to 102
	value = ((uint32_t)(input[10] & 0x01) << 31) |
			((uint32_t)input[11] << 23) |
			((uint32_t)(input[12] & 0xfe) << 15);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 103 to 118
	value = ((uint32_t)(input[12] & 0x01) << 31) |
			((uint32_t)input[13] << 23) |
			((uint32_t)(input[14] & 0xfe) << 15);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 119 to 134
	value = ((uint32_t)(input[14] & 0x01) << 31) |
			((uint32_t)input[15] << 23) |
			((uint32_t)(input[16] & 0xfe) << 15);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 135 to 150
	value = ((uint32_t)(input[16] & 0x01) << 31) |
			((uint32_t)input[17] << 23) |
			((uint32_t)(input[18] & 0xfe) << 15);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 151 to 166
	value = ((uint32_t)(input[18] & 0x01) << 31) |
			((uint32_t)input[19] << 23) |
			((uint32_t)(input[20] & 0xfe) << 15);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 167 to 182
	value = ((uint32_t)(input[20] & 0x01) << 31) |
			((uint32_t)input[21] << 23) |
			((uint32_t)(input[22] & 0xfe) << 15);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 183 to 198
	value = ((uint32_t)(input[22] & 0x01) << 31) |
			((uint32_t)input[23] << 23) |
			((uint32_t)(input[24] & 0xfe) << 15);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 199 to 214
	value = ((uint32_t)(input[24] & 0x01) << 31) |
			((uint32_t)input[25] << 23) |
			((uint32_t)(input[26] & 0xfe) << 15);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 215 to 230
	value = ((uint32_t)(input[26] & 0x01) << 31) |
			((uint32_t)input[27] << 23) |
			((uint32_t)(input[28] & 0xfe) << 15);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 231 to 246
	value = ((uint32_t)(input[28] & 0x01) << 31) |
			((uint32_t)input[29] << 23) |
			((uint32_t)(input[30] & 0xfe) << 15);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 247 to 262
	value = ((uint32_t)(input[30] & 0x01) << 31) |
			((uint32_t)input[31] << 23) |
			((uint32_t)(input[32] & 0xfe) << 15);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 263 to 278
	value = ((uint32_t)(input[32] & 0x01) << 31) |
			((uint32_t)input[33] << 23) |
			((uint32_t)(input[34] & 0xfe) << 15);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 279 to 294
	value = ((uint32_t)(input[34] & 0x01) << 31) |
			((uint32_t)input[35] << 23) |
			((uint32_t)(input[36] & 0xfe) << 15);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 295 to 310
	value = ((uint32_t)(input[36] & 0x01) << 31) |
			((uint32_t)input[37] << 23) |
			((uint32_t)(input[38] & 0xfe) << 15);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 311 to 326
	value = ((uint32_t)(input[38] & 0x01) << 31) |
			((uint32_t)input[39] << 23) |
			((uint32_t)(input[40] & 0xfe) << 15);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 327 to 342
	value = ((uint32_t)(input[40] & 0x01) << 31) |
			((uint32_t)input[41] << 23) |
			((uint32_t)(input[42] & 0xfe) << 15);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 343 to 358
	value = ((uint32_t)(input[42] & 0x01) << 31) |
			((uint32_t)input[43] << 23) |
			((uint32_t)(input[44] & 0xfe) << 15);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 359 to 374
	value = ((uint32_t)(input[44] & 0x01) << 31) |
			((uint32_t)input[45] << 23) |
			((uint32_t)(input[46] & 0xfe) << 15);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 375 to 390
	value = ((uint32_t)(input[46] & 0x01) << 31) |
			((uint32_t)input[47] << 23) |
			((uint32_t)(input[48] & 0xfe) << 15);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 391 to 406
	value = ((uint32_t)(input[48] & 0x01) << 31) |
			((uint32_t)input[49] << 23) |
			((uint32_t)(input[50] & 0xfe) << 15);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 407 to 422
	value = ((uint32_t)(input[50] & 0x01) << 31) |
			((uint32_t)input[51] << 23) |
			((uint32_t)(input[52] & 0xfe) << 15);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 423 to 438
	value = ((uint32_t)(input[52] & 0x01) << 31) |
			((uint32_t)input[53] << 23) |
			((uint32_t)(input[54] & 0xfe) << 15);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 439 to 454
	value = ((uint32_t)(input[54] & 0x01) << 31) |
			((uint32_t)input[55] << 23) |
			((uint32_t)(input[56] & 0xfe) << 15);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 455 to 470
	value = ((uint32_t)(input[56] & 0x01) << 31) |
			((uint32_t)input[57] << 23) |
			((uint32_t)(input[58] & 0xfe) << 15);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 471 to 486
	value = ((uint32_t)(input[58] & 0x01) << 31) |
			((uint32_t)input[59] << 23) |
			((uint32_t)(input[60] & 0xfe) << 15);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 487 to 502
	value = ((uint32_t)(input[60] & 0x01) << 31) |
			((uint32_t)input[61] << 23) |
			((uint32_t)(input[62] & 0xfe) << 15);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 503 to 518
	value = ((uint32_t)(input[62] & 0x01) << 31) |
			((uint32_t)input[63] << 23) |
			((uint32_t)(input[64] & 0xfe) << 15);
	output[31] = (double)(value >> 16);
}

static void unpack_32_16bit_unsigned_7off(const uint8_t * input, double * output, void *closure) {
	// Unpack 32 values into output
	// Values are 16-bit unsigned
	// Skip 7 bits, read 512 bits of data.
	// Input must be at least 65 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 7 to 22
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)(input[2] & 0xfe) << 15);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 23 to 38
	value = ((uint32_t)(input[2] & 0x01) << 31) |
			((uint32_t)input[3] << 23) |
			((uint32_t)(input[4] & 0xfe) << 15);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 39 to 54
	value = ((uint32_t)(input[4] & 0x01) << 31) |
			((uint32_t)input[5] << 23) |
			((uint32_t)(input[6] & 0xfe) << 15);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 55 to 70
	value = ((uint32_t)(input[6] & 0x01) << 31) |
			((uint32_t)input[7] << 23) |
			((uint32_t)(input[8] & 0xfe) << 15);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 71 to 86
	value = ((uint32_t)(input[8] & 0x01) << 31) |
			((uint32_t)input[9] << 23) |
			((uint32_t)(input[10] & 0xfe) << 15);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 87 to 102
	value = ((uint32_t)(input[10] & 0x01) << 31) |
			((uint32_t)input[11] << 23) |
			((uint32_t)(input[12] & 0xfe) << 15);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 103 to 118
	value = ((uint32_t)(input[12] & 0x01) << 31) |
			((uint32_t)input[13] << 23) |
			((uint32_t)(input[14] & 0xfe) << 15);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 119 to 134
	value = ((uint32_t)(input[14] & 0x01) << 31) |
			((uint32_t)input[15] << 23) |
			((uint32_t)(input[16] & 0xfe) << 15);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 135 to 150
	value = ((uint32_t)(input[16] & 0x01) << 31) |
			((uint32_t)input[17] << 23) |
			((uint32_t)(input[18] & 0xfe) << 15);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 151 to 166
	value = ((uint32_t)(input[18] & 0x01) << 31) |
			((uint32_t)input[19] << 23) |
			((uint32_t)(input[20] & 0xfe) << 15);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 167 to 182
	value = ((uint32_t)(input[20] & 0x01) << 31) |
			((uint32_t)input[21] << 23) |
			((uint32_t)(input[22] & 0xfe) << 15);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 183 to 198
	value = ((uint32_t)(input[22] & 0x01) << 31) |
			((uint32_t)input[23] << 23) |
			((uint32_t)(input[24] & 0xfe) << 15);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 199 to 214
	value = ((uint32_t)(input[24] & 0x01) << 31) |
			((uint32_t)input[25] << 23) |
			((uint32_t)(input[26] & 0xfe) << 15);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 215 to 230
	value = ((uint32_t)(input[26] & 0x01) << 31) |
			((uint32_t)input[27] << 23) |
			((uint32_t)(input[28] & 0xfe) << 15);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 231 to 246
	value = ((uint32_t)(input[28] & 0x01) << 31) |
			((uint32_t)input[29] << 23) |
			((uint32_t)(input[30] & 0xfe) << 15);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 247 to 262
	value = ((uint32_t)(input[30] & 0x01) << 31) |
			((uint32_t)input[31] << 23) |
			((uint32_t)(input[32] & 0xfe) << 15);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 263 to 278
	value = ((uint32_t)(input[32] & 0x01) << 31) |
			((uint32_t)input[33] << 23) |
			((uint32_t)(input[34] & 0xfe) << 15);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 279 to 294
	value = ((uint32_t)(input[34] & 0x01) << 31) |
			((uint32_t)input[35] << 23) |
			((uint32_t)(input[36] & 0xfe) << 15);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 295 to 310
	value = ((uint32_t)(input[36] & 0x01) << 31) |
			((uint32_t)input[37] << 23) |
			((uint32_t)(input[38] & 0xfe) << 15);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 311 to 326
	value = ((uint32_t)(input[38] & 0x01) << 31) |
			((uint32_t)input[39] << 23) |
			((uint32_t)(input[40] & 0xfe) << 15);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 327 to 342
	value = ((uint32_t)(input[40] & 0x01) << 31) |
			((uint32_t)input[41] << 23) |
			((uint32_t)(input[42] & 0xfe) << 15);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 343 to 358
	value = ((uint32_t)(input[42] & 0x01) << 31) |
			((uint32_t)input[43] << 23) |
			((uint32_t)(input[44] & 0xfe) << 15);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 359 to 374
	value = ((uint32_t)(input[44] & 0x01) << 31) |
			((uint32_t)input[45] << 23) |
			((uint32_t)(input[46] & 0xfe) << 15);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 375 to 390
	value = ((uint32_t)(input[46] & 0x01) << 31) |
			((uint32_t)input[47] << 23) |
			((uint32_t)(input[48] & 0xfe) << 15);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 391 to 406
	value = ((uint32_t)(input[48] & 0x01) << 31) |
			((uint32_t)input[49] << 23) |
			((uint32_t)(input[50] & 0xfe) << 15);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 407 to 422
	value = ((uint32_t)(input[50] & 0x01) << 31) |
			((uint32_t)input[51] << 23) |
			((uint32_t)(input[52] & 0xfe) << 15);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 423 to 438
	value = ((uint32_t)(input[52] & 0x01) << 31) |
			((uint32_t)input[53] << 23) |
			((uint32_t)(input[54] & 0xfe) << 15);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 439 to 454
	value = ((uint32_t)(input[54] & 0x01) << 31) |
			((uint32_t)input[55] << 23) |
			((uint32_t)(input[56] & 0xfe) << 15);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 455 to 470
	value = ((uint32_t)(input[56] & 0x01) << 31) |
			((uint32_t)input[57] << 23) |
			((uint32_t)(input[58] & 0xfe) << 15);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 471 to 486
	value = ((uint32_t)(input[58] & 0x01) << 31) |
			((uint32_t)input[59] << 23) |
			((uint32_t)(input[60] & 0xfe) << 15);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 487 to 502
	value = ((uint32_t)(input[60] & 0x01) << 31) |
			((uint32_t)input[61] << 23) |
			((uint32_t)(input[62] & 0xfe) << 15);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 503 to 518
	value = ((uint32_t)(input[62] & 0x01) << 31) |
			((uint32_t)input[63] << 23) |
			((uint32_t)(input[64] & 0xfe) << 15);
	output[31] = (double)(value >> 16);
}

static void unpack_33_16bit_signed_0off(const uint8_t * input, double * output, void *closure) {
	// Unpack 33 values into output
	// Values are 16-bit signed
	// Skip 0 bits, read 528 bits of data.
	// Input must be at least 66 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 0 to 15
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)input[1] << 16);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 16 to 31
	value = ((uint32_t)input[2] << 24) |
			((uint32_t)input[3] << 16);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 32 to 47
	value = ((uint32_t)input[4] << 24) |
			((uint32_t)input[5] << 16);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 48 to 63
	value = ((uint32_t)input[6] << 24) |
			((uint32_t)input[7] << 16);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 64 to 79
	value = ((uint32_t)input[8] << 24) |
			((uint32_t)input[9] << 16);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 80 to 95
	value = ((uint32_t)input[10] << 24) |
			((uint32_t)input[11] << 16);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 96 to 111
	value = ((uint32_t)input[12] << 24) |
			((uint32_t)input[13] << 16);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 112 to 127
	value = ((uint32_t)input[14] << 24) |
			((uint32_t)input[15] << 16);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 128 to 143
	value = ((uint32_t)input[16] << 24) |
			((uint32_t)input[17] << 16);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 144 to 159
	value = ((uint32_t)input[18] << 24) |
			((uint32_t)input[19] << 16);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 160 to 175
	value = ((uint32_t)input[20] << 24) |
			((uint32_t)input[21] << 16);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 176 to 191
	value = ((uint32_t)input[22] << 24) |
			((uint32_t)input[23] << 16);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 192 to 207
	value = ((uint32_t)input[24] << 24) |
			((uint32_t)input[25] << 16);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 208 to 223
	value = ((uint32_t)input[26] << 24) |
			((uint32_t)input[27] << 16);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 224 to 239
	value = ((uint32_t)input[28] << 24) |
			((uint32_t)input[29] << 16);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 240 to 255
	value = ((uint32_t)input[30] << 24) |
			((uint32_t)input[31] << 16);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 256 to 271
	value = ((uint32_t)input[32] << 24) |
			((uint32_t)input[33] << 16);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 272 to 287
	value = ((uint32_t)input[34] << 24) |
			((uint32_t)input[35] << 16);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 288 to 303
	value = ((uint32_t)input[36] << 24) |
			((uint32_t)input[37] << 16);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 304 to 319
	value = ((uint32_t)input[38] << 24) |
			((uint32_t)input[39] << 16);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 320 to 335
	value = ((uint32_t)input[40] << 24) |
			((uint32_t)input[41] << 16);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 336 to 351
	value = ((uint32_t)input[42] << 24) |
			((uint32_t)input[43] << 16);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 352 to 367
	value = ((uint32_t)input[44] << 24) |
			((uint32_t)input[45] << 16);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 368 to 383
	value = ((uint32_t)input[46] << 24) |
			((uint32_t)input[47] << 16);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 384 to 399
	value = ((uint32_t)input[48] << 24) |
			((uint32_t)input[49] << 16);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 400 to 415
	value = ((uint32_t)input[50] << 24) |
			((uint32_t)input[51] << 16);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 416 to 431
	value = ((uint32_t)input[52] << 24) |
			((uint32_t)input[53] << 16);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 432 to 447
	value = ((uint32_t)input[54] << 24) |
			((uint32_t)input[55] << 16);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 448 to 463
	value = ((uint32_t)input[56] << 24) |
			((uint32_t)input[57] << 16);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 464 to 479
	value = ((uint32_t)input[58] << 24) |
			((uint32_t)input[59] << 16);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 480 to 495
	value = ((uint32_t)input[60] << 24) |
			((uint32_t)input[61] << 16);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 496 to 511
	value = ((uint32_t)input[62] << 24) |
			((uint32_t)input[63] << 16);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 512 to 527
	value = ((uint32_t)input[64] << 24) |
			((uint32_t)input[65] << 16);
	output[32] = (double)(value >> 16);
}

static void unpack_33_16bit_unsigned_0off(const uint8_t * input, double * output, void *closure) {
	// Unpack 33 values into output
	// Values are 16-bit unsigned
	// Skip 0 bits, read 528 bits of data.
	// Input must be at least 66 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 0 to 15
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)input[1] << 16);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 16 to 31
	value = ((uint32_t)input[2] << 24) |
			((uint32_t)input[3] << 16);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 32 to 47
	value = ((uint32_t)input[4] << 24) |
			((uint32_t)input[5] << 16);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 48 to 63
	value = ((uint32_t)input[6] << 24) |
			((uint32_t)input[7] << 16);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 64 to 79
	value = ((uint32_t)input[8] << 24) |
			((uint32_t)input[9] << 16);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 80 to 95
	value = ((uint32_t)input[10] << 24) |
			((uint32_t)input[11] << 16);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 96 to 111
	value = ((uint32_t)input[12] << 24) |
			((uint32_t)input[13] << 16);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 112 to 127
	value = ((uint32_t)input[14] << 24) |
			((uint32_t)input[15] << 16);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 128 to 143
	value = ((uint32_t)input[16] << 24) |
			((uint32_t)input[17] << 16);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 144 to 159
	value = ((uint32_t)input[18] << 24) |
			((uint32_t)input[19] << 16);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 160 to 175
	value = ((uint32_t)input[20] << 24) |
			((uint32_t)input[21] << 16);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 176 to 191
	value = ((uint32_t)input[22] << 24) |
			((uint32_t)input[23] << 16);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 192 to 207
	value = ((uint32_t)input[24] << 24) |
			((uint32_t)input[25] << 16);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 208 to 223
	value = ((uint32_t)input[26] << 24) |
			((uint32_t)input[27] << 16);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 224 to 239
	value = ((uint32_t)input[28] << 24) |
			((uint32_t)input[29] << 16);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 240 to 255
	value = ((uint32_t)input[30] << 24) |
			((uint32_t)input[31] << 16);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 256 to 271
	value = ((uint32_t)input[32] << 24) |
			((uint32_t)input[33] << 16);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 272 to 287
	value = ((uint32_t)input[34] << 24) |
			((uint32_t)input[35] << 16);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 288 to 303
	value = ((uint32_t)input[36] << 24) |
			((uint32_t)input[37] << 16);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 304 to 319
	value = ((uint32_t)input[38] << 24) |
			((uint32_t)input[39] << 16);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 320 to 335
	value = ((uint32_t)input[40] << 24) |
			((uint32_t)input[41] << 16);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 336 to 351
	value = ((uint32_t)input[42] << 24) |
			((uint32_t)input[43] << 16);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 352 to 367
	value = ((uint32_t)input[44] << 24) |
			((uint32_t)input[45] << 16);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 368 to 383
	value = ((uint32_t)input[46] << 24) |
			((uint32_t)input[47] << 16);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 384 to 399
	value = ((uint32_t)input[48] << 24) |
			((uint32_t)input[49] << 16);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 400 to 415
	value = ((uint32_t)input[50] << 24) |
			((uint32_t)input[51] << 16);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 416 to 431
	value = ((uint32_t)input[52] << 24) |
			((uint32_t)input[53] << 16);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 432 to 447
	value = ((uint32_t)input[54] << 24) |
			((uint32_t)input[55] << 16);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 448 to 463
	value = ((uint32_t)input[56] << 24) |
			((uint32_t)input[57] << 16);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 464 to 479
	value = ((uint32_t)input[58] << 24) |
			((uint32_t)input[59] << 16);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 480 to 495
	value = ((uint32_t)input[60] << 24) |
			((uint32_t)input[61] << 16);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 496 to 511
	value = ((uint32_t)input[62] << 24) |
			((uint32_t)input[63] << 16);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 512 to 527
	value = ((uint32_t)input[64] << 24) |
			((uint32_t)input[65] << 16);
	output[32] = (double)(value >> 16);
}

static void unpack_33_16bit_signed_1off(const uint8_t * input, double * output, void *closure) {
	// Unpack 33 values into output
	// Values are 16-bit signed
	// Skip 1 bits, read 528 bits of data.
	// Input must be at least 67 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 1 to 16
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)input[1] << 17) |
			((uint32_t)(input[2] & 0x80) << 9);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 17 to 32
	value = ((uint32_t)(input[2] & 0x7f) << 25) |
			((uint32_t)input[3] << 17) |
			((uint32_t)(input[4] & 0x80) << 9);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 33 to 48
	value = ((uint32_t)(input[4] & 0x7f) << 25) |
			((uint32_t)input[5] << 17) |
			((uint32_t)(input[6] & 0x80) << 9);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 49 to 64
	value = ((uint32_t)(input[6] & 0x7f) << 25) |
			((uint32_t)input[7] << 17) |
			((uint32_t)(input[8] & 0x80) << 9);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 65 to 80
	value = ((uint32_t)(input[8] & 0x7f) << 25) |
			((uint32_t)input[9] << 17) |
			((uint32_t)(input[10] & 0x80) << 9);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 81 to 96
	value = ((uint32_t)(input[10] & 0x7f) << 25) |
			((uint32_t)input[11] << 17) |
			((uint32_t)(input[12] & 0x80) << 9);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 97 to 112
	value = ((uint32_t)(input[12] & 0x7f) << 25) |
			((uint32_t)input[13] << 17) |
			((uint32_t)(input[14] & 0x80) << 9);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 113 to 128
	value = ((uint32_t)(input[14] & 0x7f) << 25) |
			((uint32_t)input[15] << 17) |
			((uint32_t)(input[16] & 0x80) << 9);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 129 to 144
	value = ((uint32_t)(input[16] & 0x7f) << 25) |
			((uint32_t)input[17] << 17) |
			((uint32_t)(input[18] & 0x80) << 9);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 145 to 160
	value = ((uint32_t)(input[18] & 0x7f) << 25) |
			((uint32_t)input[19] << 17) |
			((uint32_t)(input[20] & 0x80) << 9);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 161 to 176
	value = ((uint32_t)(input[20] & 0x7f) << 25) |
			((uint32_t)input[21] << 17) |
			((uint32_t)(input[22] & 0x80) << 9);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 177 to 192
	value = ((uint32_t)(input[22] & 0x7f) << 25) |
			((uint32_t)input[23] << 17) |
			((uint32_t)(input[24] & 0x80) << 9);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 193 to 208
	value = ((uint32_t)(input[24] & 0x7f) << 25) |
			((uint32_t)input[25] << 17) |
			((uint32_t)(input[26] & 0x80) << 9);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 209 to 224
	value = ((uint32_t)(input[26] & 0x7f) << 25) |
			((uint32_t)input[27] << 17) |
			((uint32_t)(input[28] & 0x80) << 9);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 225 to 240
	value = ((uint32_t)(input[28] & 0x7f) << 25) |
			((uint32_t)input[29] << 17) |
			((uint32_t)(input[30] & 0x80) << 9);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 241 to 256
	value = ((uint32_t)(input[30] & 0x7f) << 25) |
			((uint32_t)input[31] << 17) |
			((uint32_t)(input[32] & 0x80) << 9);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 257 to 272
	value = ((uint32_t)(input[32] & 0x7f) << 25) |
			((uint32_t)input[33] << 17) |
			((uint32_t)(input[34] & 0x80) << 9);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 273 to 288
	value = ((uint32_t)(input[34] & 0x7f) << 25) |
			((uint32_t)input[35] << 17) |
			((uint32_t)(input[36] & 0x80) << 9);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 289 to 304
	value = ((uint32_t)(input[36] & 0x7f) << 25) |
			((uint32_t)input[37] << 17) |
			((uint32_t)(input[38] & 0x80) << 9);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 305 to 320
	value = ((uint32_t)(input[38] & 0x7f) << 25) |
			((uint32_t)input[39] << 17) |
			((uint32_t)(input[40] & 0x80) << 9);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 321 to 336
	value = ((uint32_t)(input[40] & 0x7f) << 25) |
			((uint32_t)input[41] << 17) |
			((uint32_t)(input[42] & 0x80) << 9);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 337 to 352
	value = ((uint32_t)(input[42] & 0x7f) << 25) |
			((uint32_t)input[43] << 17) |
			((uint32_t)(input[44] & 0x80) << 9);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 353 to 368
	value = ((uint32_t)(input[44] & 0x7f) << 25) |
			((uint32_t)input[45] << 17) |
			((uint32_t)(input[46] & 0x80) << 9);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 369 to 384
	value = ((uint32_t)(input[46] & 0x7f) << 25) |
			((uint32_t)input[47] << 17) |
			((uint32_t)(input[48] & 0x80) << 9);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 385 to 400
	value = ((uint32_t)(input[48] & 0x7f) << 25) |
			((uint32_t)input[49] << 17) |
			((uint32_t)(input[50] & 0x80) << 9);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 401 to 416
	value = ((uint32_t)(input[50] & 0x7f) << 25) |
			((uint32_t)input[51] << 17) |
			((uint32_t)(input[52] & 0x80) << 9);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 417 to 432
	value = ((uint32_t)(input[52] & 0x7f) << 25) |
			((uint32_t)input[53] << 17) |
			((uint32_t)(input[54] & 0x80) << 9);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 433 to 448
	value = ((uint32_t)(input[54] & 0x7f) << 25) |
			((uint32_t)input[55] << 17) |
			((uint32_t)(input[56] & 0x80) << 9);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 449 to 464
	value = ((uint32_t)(input[56] & 0x7f) << 25) |
			((uint32_t)input[57] << 17) |
			((uint32_t)(input[58] & 0x80) << 9);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 465 to 480
	value = ((uint32_t)(input[58] & 0x7f) << 25) |
			((uint32_t)input[59] << 17) |
			((uint32_t)(input[60] & 0x80) << 9);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 481 to 496
	value = ((uint32_t)(input[60] & 0x7f) << 25) |
			((uint32_t)input[61] << 17) |
			((uint32_t)(input[62] & 0x80) << 9);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 497 to 512
	value = ((uint32_t)(input[62] & 0x7f) << 25) |
			((uint32_t)input[63] << 17) |
			((uint32_t)(input[64] & 0x80) << 9);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 513 to 528
	value = ((uint32_t)(input[64] & 0x7f) << 25) |
			((uint32_t)input[65] << 17) |
			((uint32_t)(input[66] & 0x80) << 9);
	output[32] = (double)(value >> 16);
}

static void unpack_33_16bit_unsigned_1off(const uint8_t * input, double * output, void *closure) {
	// Unpack 33 values into output
	// Values are 16-bit unsigned
	// Skip 1 bits, read 528 bits of data.
	// Input must be at least 67 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 1 to 16
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)input[1] << 17) |
			((uint32_t)(input[2] & 0x80) << 9);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 17 to 32
	value = ((uint32_t)(input[2] & 0x7f) << 25) |
			((uint32_t)input[3] << 17) |
			((uint32_t)(input[4] & 0x80) << 9);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 33 to 48
	value = ((uint32_t)(input[4] & 0x7f) << 25) |
			((uint32_t)input[5] << 17) |
			((uint32_t)(input[6] & 0x80) << 9);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 49 to 64
	value = ((uint32_t)(input[6] & 0x7f) << 25) |
			((uint32_t)input[7] << 17) |
			((uint32_t)(input[8] & 0x80) << 9);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 65 to 80
	value = ((uint32_t)(input[8] & 0x7f) << 25) |
			((uint32_t)input[9] << 17) |
			((uint32_t)(input[10] & 0x80) << 9);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 81 to 96
	value = ((uint32_t)(input[10] & 0x7f) << 25) |
			((uint32_t)input[11] << 17) |
			((uint32_t)(input[12] & 0x80) << 9);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 97 to 112
	value = ((uint32_t)(input[12] & 0x7f) << 25) |
			((uint32_t)input[13] << 17) |
			((uint32_t)(input[14] & 0x80) << 9);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 113 to 128
	value = ((uint32_t)(input[14] & 0x7f) << 25) |
			((uint32_t)input[15] << 17) |
			((uint32_t)(input[16] & 0x80) << 9);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 129 to 144
	value = ((uint32_t)(input[16] & 0x7f) << 25) |
			((uint32_t)input[17] << 17) |
			((uint32_t)(input[18] & 0x80) << 9);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 145 to 160
	value = ((uint32_t)(input[18] & 0x7f) << 25) |
			((uint32_t)input[19] << 17) |
			((uint32_t)(input[20] & 0x80) << 9);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 161 to 176
	value = ((uint32_t)(input[20] & 0x7f) << 25) |
			((uint32_t)input[21] << 17) |
			((uint32_t)(input[22] & 0x80) << 9);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 177 to 192
	value = ((uint32_t)(input[22] & 0x7f) << 25) |
			((uint32_t)input[23] << 17) |
			((uint32_t)(input[24] & 0x80) << 9);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 193 to 208
	value = ((uint32_t)(input[24] & 0x7f) << 25) |
			((uint32_t)input[25] << 17) |
			((uint32_t)(input[26] & 0x80) << 9);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 209 to 224
	value = ((uint32_t)(input[26] & 0x7f) << 25) |
			((uint32_t)input[27] << 17) |
			((uint32_t)(input[28] & 0x80) << 9);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 225 to 240
	value = ((uint32_t)(input[28] & 0x7f) << 25) |
			((uint32_t)input[29] << 17) |
			((uint32_t)(input[30] & 0x80) << 9);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 241 to 256
	value = ((uint32_t)(input[30] & 0x7f) << 25) |
			((uint32_t)input[31] << 17) |
			((uint32_t)(input[32] & 0x80) << 9);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 257 to 272
	value = ((uint32_t)(input[32] & 0x7f) << 25) |
			((uint32_t)input[33] << 17) |
			((uint32_t)(input[34] & 0x80) << 9);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 273 to 288
	value = ((uint32_t)(input[34] & 0x7f) << 25) |
			((uint32_t)input[35] << 17) |
			((uint32_t)(input[36] & 0x80) << 9);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 289 to 304
	value = ((uint32_t)(input[36] & 0x7f) << 25) |
			((uint32_t)input[37] << 17) |
			((uint32_t)(input[38] & 0x80) << 9);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 305 to 320
	value = ((uint32_t)(input[38] & 0x7f) << 25) |
			((uint32_t)input[39] << 17) |
			((uint32_t)(input[40] & 0x80) << 9);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 321 to 336
	value = ((uint32_t)(input[40] & 0x7f) << 25) |
			((uint32_t)input[41] << 17) |
			((uint32_t)(input[42] & 0x80) << 9);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 337 to 352
	value = ((uint32_t)(input[42] & 0x7f) << 25) |
			((uint32_t)input[43] << 17) |
			((uint32_t)(input[44] & 0x80) << 9);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 353 to 368
	value = ((uint32_t)(input[44] & 0x7f) << 25) |
			((uint32_t)input[45] << 17) |
			((uint32_t)(input[46] & 0x80) << 9);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 369 to 384
	value = ((uint32_t)(input[46] & 0x7f) << 25) |
			((uint32_t)input[47] << 17) |
			((uint32_t)(input[48] & 0x80) << 9);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 385 to 400
	value = ((uint32_t)(input[48] & 0x7f) << 25) |
			((uint32_t)input[49] << 17) |
			((uint32_t)(input[50] & 0x80) << 9);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 401 to 416
	value = ((uint32_t)(input[50] & 0x7f) << 25) |
			((uint32_t)input[51] << 17) |
			((uint32_t)(input[52] & 0x80) << 9);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 417 to 432
	value = ((uint32_t)(input[52] & 0x7f) << 25) |
			((uint32_t)input[53] << 17) |
			((uint32_t)(input[54] & 0x80) << 9);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 433 to 448
	value = ((uint32_t)(input[54] & 0x7f) << 25) |
			((uint32_t)input[55] << 17) |
			((uint32_t)(input[56] & 0x80) << 9);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 449 to 464
	value = ((uint32_t)(input[56] & 0x7f) << 25) |
			((uint32_t)input[57] << 17) |
			((uint32_t)(input[58] & 0x80) << 9);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 465 to 480
	value = ((uint32_t)(input[58] & 0x7f) << 25) |
			((uint32_t)input[59] << 17) |
			((uint32_t)(input[60] & 0x80) << 9);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 481 to 496
	value = ((uint32_t)(input[60] & 0x7f) << 25) |
			((uint32_t)input[61] << 17) |
			((uint32_t)(input[62] & 0x80) << 9);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 497 to 512
	value = ((uint32_t)(input[62] & 0x7f) << 25) |
			((uint32_t)input[63] << 17) |
			((uint32_t)(input[64] & 0x80) << 9);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 513 to 528
	value = ((uint32_t)(input[64] & 0x7f) << 25) |
			((uint32_t)input[65] << 17) |
			((uint32_t)(input[66] & 0x80) << 9);
	output[32] = (double)(value >> 16);
}

static void unpack_33_16bit_signed_2off(const uint8_t * input, double * output, void *closure) {
	// Unpack 33 values into output
	// Values are 16-bit signed
	// Skip 2 bits, read 528 bits of data.
	// Input must be at least 67 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 2 to 17
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)input[1] << 18) |
			((uint32_t)(input[2] & 0xc0) << 10);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 18 to 33
	value = ((uint32_t)(input[2] & 0x3f) << 26) |
			((uint32_t)input[3] << 18) |
			((uint32_t)(input[4] & 0xc0) << 10);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 34 to 49
	value = ((uint32_t)(input[4] & 0x3f) << 26) |
			((uint32_t)input[5] << 18) |
			((uint32_t)(input[6] & 0xc0) << 10);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 50 to 65
	value = ((uint32_t)(input[6] & 0x3f) << 26) |
			((uint32_t)input[7] << 18) |
			((uint32_t)(input[8] & 0xc0) << 10);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 66 to 81
	value = ((uint32_t)(input[8] & 0x3f) << 26) |
			((uint32_t)input[9] << 18) |
			((uint32_t)(input[10] & 0xc0) << 10);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 82 to 97
	value = ((uint32_t)(input[10] & 0x3f) << 26) |
			((uint32_t)input[11] << 18) |
			((uint32_t)(input[12] & 0xc0) << 10);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 98 to 113
	value = ((uint32_t)(input[12] & 0x3f) << 26) |
			((uint32_t)input[13] << 18) |
			((uint32_t)(input[14] & 0xc0) << 10);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 114 to 129
	value = ((uint32_t)(input[14] & 0x3f) << 26) |
			((uint32_t)input[15] << 18) |
			((uint32_t)(input[16] & 0xc0) << 10);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 130 to 145
	value = ((uint32_t)(input[16] & 0x3f) << 26) |
			((uint32_t)input[17] << 18) |
			((uint32_t)(input[18] & 0xc0) << 10);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 146 to 161
	value = ((uint32_t)(input[18] & 0x3f) << 26) |
			((uint32_t)input[19] << 18) |
			((uint32_t)(input[20] & 0xc0) << 10);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 162 to 177
	value = ((uint32_t)(input[20] & 0x3f) << 26) |
			((uint32_t)input[21] << 18) |
			((uint32_t)(input[22] & 0xc0) << 10);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 178 to 193
	value = ((uint32_t)(input[22] & 0x3f) << 26) |
			((uint32_t)input[23] << 18) |
			((uint32_t)(input[24] & 0xc0) << 10);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 194 to 209
	value = ((uint32_t)(input[24] & 0x3f) << 26) |
			((uint32_t)input[25] << 18) |
			((uint32_t)(input[26] & 0xc0) << 10);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 210 to 225
	value = ((uint32_t)(input[26] & 0x3f) << 26) |
			((uint32_t)input[27] << 18) |
			((uint32_t)(input[28] & 0xc0) << 10);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 226 to 241
	value = ((uint32_t)(input[28] & 0x3f) << 26) |
			((uint32_t)input[29] << 18) |
			((uint32_t)(input[30] & 0xc0) << 10);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 242 to 257
	value = ((uint32_t)(input[30] & 0x3f) << 26) |
			((uint32_t)input[31] << 18) |
			((uint32_t)(input[32] & 0xc0) << 10);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 258 to 273
	value = ((uint32_t)(input[32] & 0x3f) << 26) |
			((uint32_t)input[33] << 18) |
			((uint32_t)(input[34] & 0xc0) << 10);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 274 to 289
	value = ((uint32_t)(input[34] & 0x3f) << 26) |
			((uint32_t)input[35] << 18) |
			((uint32_t)(input[36] & 0xc0) << 10);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 290 to 305
	value = ((uint32_t)(input[36] & 0x3f) << 26) |
			((uint32_t)input[37] << 18) |
			((uint32_t)(input[38] & 0xc0) << 10);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 306 to 321
	value = ((uint32_t)(input[38] & 0x3f) << 26) |
			((uint32_t)input[39] << 18) |
			((uint32_t)(input[40] & 0xc0) << 10);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 322 to 337
	value = ((uint32_t)(input[40] & 0x3f) << 26) |
			((uint32_t)input[41] << 18) |
			((uint32_t)(input[42] & 0xc0) << 10);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 338 to 353
	value = ((uint32_t)(input[42] & 0x3f) << 26) |
			((uint32_t)input[43] << 18) |
			((uint32_t)(input[44] & 0xc0) << 10);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 354 to 369
	value = ((uint32_t)(input[44] & 0x3f) << 26) |
			((uint32_t)input[45] << 18) |
			((uint32_t)(input[46] & 0xc0) << 10);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 370 to 385
	value = ((uint32_t)(input[46] & 0x3f) << 26) |
			((uint32_t)input[47] << 18) |
			((uint32_t)(input[48] & 0xc0) << 10);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 386 to 401
	value = ((uint32_t)(input[48] & 0x3f) << 26) |
			((uint32_t)input[49] << 18) |
			((uint32_t)(input[50] & 0xc0) << 10);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 402 to 417
	value = ((uint32_t)(input[50] & 0x3f) << 26) |
			((uint32_t)input[51] << 18) |
			((uint32_t)(input[52] & 0xc0) << 10);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 418 to 433
	value = ((uint32_t)(input[52] & 0x3f) << 26) |
			((uint32_t)input[53] << 18) |
			((uint32_t)(input[54] & 0xc0) << 10);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 434 to 449
	value = ((uint32_t)(input[54] & 0x3f) << 26) |
			((uint32_t)input[55] << 18) |
			((uint32_t)(input[56] & 0xc0) << 10);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 450 to 465
	value = ((uint32_t)(input[56] & 0x3f) << 26) |
			((uint32_t)input[57] << 18) |
			((uint32_t)(input[58] & 0xc0) << 10);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 466 to 481
	value = ((uint32_t)(input[58] & 0x3f) << 26) |
			((uint32_t)input[59] << 18) |
			((uint32_t)(input[60] & 0xc0) << 10);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 482 to 497
	value = ((uint32_t)(input[60] & 0x3f) << 26) |
			((uint32_t)input[61] << 18) |
			((uint32_t)(input[62] & 0xc0) << 10);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 498 to 513
	value = ((uint32_t)(input[62] & 0x3f) << 26) |
			((uint32_t)input[63] << 18) |
			((uint32_t)(input[64] & 0xc0) << 10);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 514 to 529
	value = ((uint32_t)(input[64] & 0x3f) << 26) |
			((uint32_t)input[65] << 18) |
			((uint32_t)(input[66] & 0xc0) << 10);
	output[32] = (double)(value >> 16);
}

static void unpack_33_16bit_unsigned_2off(const uint8_t * input, double * output, void *closure) {
	// Unpack 33 values into output
	// Values are 16-bit unsigned
	// Skip 2 bits, read 528 bits of data.
	// Input must be at least 67 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 2 to 17
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)input[1] << 18) |
			((uint32_t)(input[2] & 0xc0) << 10);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 18 to 33
	value = ((uint32_t)(input[2] & 0x3f) << 26) |
			((uint32_t)input[3] << 18) |
			((uint32_t)(input[4] & 0xc0) << 10);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 34 to 49
	value = ((uint32_t)(input[4] & 0x3f) << 26) |
			((uint32_t)input[5] << 18) |
			((uint32_t)(input[6] & 0xc0) << 10);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 50 to 65
	value = ((uint32_t)(input[6] & 0x3f) << 26) |
			((uint32_t)input[7] << 18) |
			((uint32_t)(input[8] & 0xc0) << 10);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 66 to 81
	value = ((uint32_t)(input[8] & 0x3f) << 26) |
			((uint32_t)input[9] << 18) |
			((uint32_t)(input[10] & 0xc0) << 10);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 82 to 97
	value = ((uint32_t)(input[10] & 0x3f) << 26) |
			((uint32_t)input[11] << 18) |
			((uint32_t)(input[12] & 0xc0) << 10);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 98 to 113
	value = ((uint32_t)(input[12] & 0x3f) << 26) |
			((uint32_t)input[13] << 18) |
			((uint32_t)(input[14] & 0xc0) << 10);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 114 to 129
	value = ((uint32_t)(input[14] & 0x3f) << 26) |
			((uint32_t)input[15] << 18) |
			((uint32_t)(input[16] & 0xc0) << 10);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 130 to 145
	value = ((uint32_t)(input[16] & 0x3f) << 26) |
			((uint32_t)input[17] << 18) |
			((uint32_t)(input[18] & 0xc0) << 10);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 146 to 161
	value = ((uint32_t)(input[18] & 0x3f) << 26) |
			((uint32_t)input[19] << 18) |
			((uint32_t)(input[20] & 0xc0) << 10);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 162 to 177
	value = ((uint32_t)(input[20] & 0x3f) << 26) |
			((uint32_t)input[21] << 18) |
			((uint32_t)(input[22] & 0xc0) << 10);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 178 to 193
	value = ((uint32_t)(input[22] & 0x3f) << 26) |
			((uint32_t)input[23] << 18) |
			((uint32_t)(input[24] & 0xc0) << 10);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 194 to 209
	value = ((uint32_t)(input[24] & 0x3f) << 26) |
			((uint32_t)input[25] << 18) |
			((uint32_t)(input[26] & 0xc0) << 10);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 210 to 225
	value = ((uint32_t)(input[26] & 0x3f) << 26) |
			((uint32_t)input[27] << 18) |
			((uint32_t)(input[28] & 0xc0) << 10);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 226 to 241
	value = ((uint32_t)(input[28] & 0x3f) << 26) |
			((uint32_t)input[29] << 18) |
			((uint32_t)(input[30] & 0xc0) << 10);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 242 to 257
	value = ((uint32_t)(input[30] & 0x3f) << 26) |
			((uint32_t)input[31] << 18) |
			((uint32_t)(input[32] & 0xc0) << 10);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 258 to 273
	value = ((uint32_t)(input[32] & 0x3f) << 26) |
			((uint32_t)input[33] << 18) |
			((uint32_t)(input[34] & 0xc0) << 10);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 274 to 289
	value = ((uint32_t)(input[34] & 0x3f) << 26) |
			((uint32_t)input[35] << 18) |
			((uint32_t)(input[36] & 0xc0) << 10);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 290 to 305
	value = ((uint32_t)(input[36] & 0x3f) << 26) |
			((uint32_t)input[37] << 18) |
			((uint32_t)(input[38] & 0xc0) << 10);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 306 to 321
	value = ((uint32_t)(input[38] & 0x3f) << 26) |
			((uint32_t)input[39] << 18) |
			((uint32_t)(input[40] & 0xc0) << 10);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 322 to 337
	value = ((uint32_t)(input[40] & 0x3f) << 26) |
			((uint32_t)input[41] << 18) |
			((uint32_t)(input[42] & 0xc0) << 10);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 338 to 353
	value = ((uint32_t)(input[42] & 0x3f) << 26) |
			((uint32_t)input[43] << 18) |
			((uint32_t)(input[44] & 0xc0) << 10);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 354 to 369
	value = ((uint32_t)(input[44] & 0x3f) << 26) |
			((uint32_t)input[45] << 18) |
			((uint32_t)(input[46] & 0xc0) << 10);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 370 to 385
	value = ((uint32_t)(input[46] & 0x3f) << 26) |
			((uint32_t)input[47] << 18) |
			((uint32_t)(input[48] & 0xc0) << 10);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 386 to 401
	value = ((uint32_t)(input[48] & 0x3f) << 26) |
			((uint32_t)input[49] << 18) |
			((uint32_t)(input[50] & 0xc0) << 10);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 402 to 417
	value = ((uint32_t)(input[50] & 0x3f) << 26) |
			((uint32_t)input[51] << 18) |
			((uint32_t)(input[52] & 0xc0) << 10);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 418 to 433
	value = ((uint32_t)(input[52] & 0x3f) << 26) |
			((uint32_t)input[53] << 18) |
			((uint32_t)(input[54] & 0xc0) << 10);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 434 to 449
	value = ((uint32_t)(input[54] & 0x3f) << 26) |
			((uint32_t)input[55] << 18) |
			((uint32_t)(input[56] & 0xc0) << 10);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 450 to 465
	value = ((uint32_t)(input[56] & 0x3f) << 26) |
			((uint32_t)input[57] << 18) |
			((uint32_t)(input[58] & 0xc0) << 10);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 466 to 481
	value = ((uint32_t)(input[58] & 0x3f) << 26) |
			((uint32_t)input[59] << 18) |
			((uint32_t)(input[60] & 0xc0) << 10);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 482 to 497
	value = ((uint32_t)(input[60] & 0x3f) << 26) |
			((uint32_t)input[61] << 18) |
			((uint32_t)(input[62] & 0xc0) << 10);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 498 to 513
	value = ((uint32_t)(input[62] & 0x3f) << 26) |
			((uint32_t)input[63] << 18) |
			((uint32_t)(input[64] & 0xc0) << 10);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 514 to 529
	value = ((uint32_t)(input[64] & 0x3f) << 26) |
			((uint32_t)input[65] << 18) |
			((uint32_t)(input[66] & 0xc0) << 10);
	output[32] = (double)(value >> 16);
}

static void unpack_33_16bit_signed_3off(const uint8_t * input, double * output, void *closure) {
	// Unpack 33 values into output
	// Values are 16-bit signed
	// Skip 3 bits, read 528 bits of data.
	// Input must be at least 67 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 3 to 18
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)input[1] << 19) |
			((uint32_t)(input[2] & 0xe0) << 11);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 19 to 34
	value = ((uint32_t)(input[2] & 0x1f) << 27) |
			((uint32_t)input[3] << 19) |
			((uint32_t)(input[4] & 0xe0) << 11);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 35 to 50
	value = ((uint32_t)(input[4] & 0x1f) << 27) |
			((uint32_t)input[5] << 19) |
			((uint32_t)(input[6] & 0xe0) << 11);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 51 to 66
	value = ((uint32_t)(input[6] & 0x1f) << 27) |
			((uint32_t)input[7] << 19) |
			((uint32_t)(input[8] & 0xe0) << 11);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 67 to 82
	value = ((uint32_t)(input[8] & 0x1f) << 27) |
			((uint32_t)input[9] << 19) |
			((uint32_t)(input[10] & 0xe0) << 11);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 83 to 98
	value = ((uint32_t)(input[10] & 0x1f) << 27) |
			((uint32_t)input[11] << 19) |
			((uint32_t)(input[12] & 0xe0) << 11);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 99 to 114
	value = ((uint32_t)(input[12] & 0x1f) << 27) |
			((uint32_t)input[13] << 19) |
			((uint32_t)(input[14] & 0xe0) << 11);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 115 to 130
	value = ((uint32_t)(input[14] & 0x1f) << 27) |
			((uint32_t)input[15] << 19) |
			((uint32_t)(input[16] & 0xe0) << 11);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 131 to 146
	value = ((uint32_t)(input[16] & 0x1f) << 27) |
			((uint32_t)input[17] << 19) |
			((uint32_t)(input[18] & 0xe0) << 11);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 147 to 162
	value = ((uint32_t)(input[18] & 0x1f) << 27) |
			((uint32_t)input[19] << 19) |
			((uint32_t)(input[20] & 0xe0) << 11);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 163 to 178
	value = ((uint32_t)(input[20] & 0x1f) << 27) |
			((uint32_t)input[21] << 19) |
			((uint32_t)(input[22] & 0xe0) << 11);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 179 to 194
	value = ((uint32_t)(input[22] & 0x1f) << 27) |
			((uint32_t)input[23] << 19) |
			((uint32_t)(input[24] & 0xe0) << 11);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 195 to 210
	value = ((uint32_t)(input[24] & 0x1f) << 27) |
			((uint32_t)input[25] << 19) |
			((uint32_t)(input[26] & 0xe0) << 11);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 211 to 226
	value = ((uint32_t)(input[26] & 0x1f) << 27) |
			((uint32_t)input[27] << 19) |
			((uint32_t)(input[28] & 0xe0) << 11);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 227 to 242
	value = ((uint32_t)(input[28] & 0x1f) << 27) |
			((uint32_t)input[29] << 19) |
			((uint32_t)(input[30] & 0xe0) << 11);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 243 to 258
	value = ((uint32_t)(input[30] & 0x1f) << 27) |
			((uint32_t)input[31] << 19) |
			((uint32_t)(input[32] & 0xe0) << 11);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 259 to 274
	value = ((uint32_t)(input[32] & 0x1f) << 27) |
			((uint32_t)input[33] << 19) |
			((uint32_t)(input[34] & 0xe0) << 11);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 275 to 290
	value = ((uint32_t)(input[34] & 0x1f) << 27) |
			((uint32_t)input[35] << 19) |
			((uint32_t)(input[36] & 0xe0) << 11);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 291 to 306
	value = ((uint32_t)(input[36] & 0x1f) << 27) |
			((uint32_t)input[37] << 19) |
			((uint32_t)(input[38] & 0xe0) << 11);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 307 to 322
	value = ((uint32_t)(input[38] & 0x1f) << 27) |
			((uint32_t)input[39] << 19) |
			((uint32_t)(input[40] & 0xe0) << 11);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 323 to 338
	value = ((uint32_t)(input[40] & 0x1f) << 27) |
			((uint32_t)input[41] << 19) |
			((uint32_t)(input[42] & 0xe0) << 11);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 339 to 354
	value = ((uint32_t)(input[42] & 0x1f) << 27) |
			((uint32_t)input[43] << 19) |
			((uint32_t)(input[44] & 0xe0) << 11);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 355 to 370
	value = ((uint32_t)(input[44] & 0x1f) << 27) |
			((uint32_t)input[45] << 19) |
			((uint32_t)(input[46] & 0xe0) << 11);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 371 to 386
	value = ((uint32_t)(input[46] & 0x1f) << 27) |
			((uint32_t)input[47] << 19) |
			((uint32_t)(input[48] & 0xe0) << 11);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 387 to 402
	value = ((uint32_t)(input[48] & 0x1f) << 27) |
			((uint32_t)input[49] << 19) |
			((uint32_t)(input[50] & 0xe0) << 11);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 403 to 418
	value = ((uint32_t)(input[50] & 0x1f) << 27) |
			((uint32_t)input[51] << 19) |
			((uint32_t)(input[52] & 0xe0) << 11);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 419 to 434
	value = ((uint32_t)(input[52] & 0x1f) << 27) |
			((uint32_t)input[53] << 19) |
			((uint32_t)(input[54] & 0xe0) << 11);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 435 to 450
	value = ((uint32_t)(input[54] & 0x1f) << 27) |
			((uint32_t)input[55] << 19) |
			((uint32_t)(input[56] & 0xe0) << 11);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 451 to 466
	value = ((uint32_t)(input[56] & 0x1f) << 27) |
			((uint32_t)input[57] << 19) |
			((uint32_t)(input[58] & 0xe0) << 11);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 467 to 482
	value = ((uint32_t)(input[58] & 0x1f) << 27) |
			((uint32_t)input[59] << 19) |
			((uint32_t)(input[60] & 0xe0) << 11);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 483 to 498
	value = ((uint32_t)(input[60] & 0x1f) << 27) |
			((uint32_t)input[61] << 19) |
			((uint32_t)(input[62] & 0xe0) << 11);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 499 to 514
	value = ((uint32_t)(input[62] & 0x1f) << 27) |
			((uint32_t)input[63] << 19) |
			((uint32_t)(input[64] & 0xe0) << 11);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 515 to 530
	value = ((uint32_t)(input[64] & 0x1f) << 27) |
			((uint32_t)input[65] << 19) |
			((uint32_t)(input[66] & 0xe0) << 11);
	output[32] = (double)(value >> 16);
}

static void unpack_33_16bit_unsigned_3off(const uint8_t * input, double * output, void *closure) {
	// Unpack 33 values into output
	// Values are 16-bit unsigned
	// Skip 3 bits, read 528 bits of data.
	// Input must be at least 67 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 3 to 18
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)input[1] << 19) |
			((uint32_t)(input[2] & 0xe0) << 11);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 19 to 34
	value = ((uint32_t)(input[2] & 0x1f) << 27) |
			((uint32_t)input[3] << 19) |
			((uint32_t)(input[4] & 0xe0) << 11);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 35 to 50
	value = ((uint32_t)(input[4] & 0x1f) << 27) |
			((uint32_t)input[5] << 19) |
			((uint32_t)(input[6] & 0xe0) << 11);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 51 to 66
	value = ((uint32_t)(input[6] & 0x1f) << 27) |
			((uint32_t)input[7] << 19) |
			((uint32_t)(input[8] & 0xe0) << 11);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 67 to 82
	value = ((uint32_t)(input[8] & 0x1f) << 27) |
			((uint32_t)input[9] << 19) |
			((uint32_t)(input[10] & 0xe0) << 11);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 83 to 98
	value = ((uint32_t)(input[10] & 0x1f) << 27) |
			((uint32_t)input[11] << 19) |
			((uint32_t)(input[12] & 0xe0) << 11);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 99 to 114
	value = ((uint32_t)(input[12] & 0x1f) << 27) |
			((uint32_t)input[13] << 19) |
			((uint32_t)(input[14] & 0xe0) << 11);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 115 to 130
	value = ((uint32_t)(input[14] & 0x1f) << 27) |
			((uint32_t)input[15] << 19) |
			((uint32_t)(input[16] & 0xe0) << 11);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 131 to 146
	value = ((uint32_t)(input[16] & 0x1f) << 27) |
			((uint32_t)input[17] << 19) |
			((uint32_t)(input[18] & 0xe0) << 11);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 147 to 162
	value = ((uint32_t)(input[18] & 0x1f) << 27) |
			((uint32_t)input[19] << 19) |
			((uint32_t)(input[20] & 0xe0) << 11);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 163 to 178
	value = ((uint32_t)(input[20] & 0x1f) << 27) |
			((uint32_t)input[21] << 19) |
			((uint32_t)(input[22] & 0xe0) << 11);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 179 to 194
	value = ((uint32_t)(input[22] & 0x1f) << 27) |
			((uint32_t)input[23] << 19) |
			((uint32_t)(input[24] & 0xe0) << 11);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 195 to 210
	value = ((uint32_t)(input[24] & 0x1f) << 27) |
			((uint32_t)input[25] << 19) |
			((uint32_t)(input[26] & 0xe0) << 11);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 211 to 226
	value = ((uint32_t)(input[26] & 0x1f) << 27) |
			((uint32_t)input[27] << 19) |
			((uint32_t)(input[28] & 0xe0) << 11);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 227 to 242
	value = ((uint32_t)(input[28] & 0x1f) << 27) |
			((uint32_t)input[29] << 19) |
			((uint32_t)(input[30] & 0xe0) << 11);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 243 to 258
	value = ((uint32_t)(input[30] & 0x1f) << 27) |
			((uint32_t)input[31] << 19) |
			((uint32_t)(input[32] & 0xe0) << 11);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 259 to 274
	value = ((uint32_t)(input[32] & 0x1f) << 27) |
			((uint32_t)input[33] << 19) |
			((uint32_t)(input[34] & 0xe0) << 11);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 275 to 290
	value = ((uint32_t)(input[34] & 0x1f) << 27) |
			((uint32_t)input[35] << 19) |
			((uint32_t)(input[36] & 0xe0) << 11);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 291 to 306
	value = ((uint32_t)(input[36] & 0x1f) << 27) |
			((uint32_t)input[37] << 19) |
			((uint32_t)(input[38] & 0xe0) << 11);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 307 to 322
	value = ((uint32_t)(input[38] & 0x1f) << 27) |
			((uint32_t)input[39] << 19) |
			((uint32_t)(input[40] & 0xe0) << 11);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 323 to 338
	value = ((uint32_t)(input[40] & 0x1f) << 27) |
			((uint32_t)input[41] << 19) |
			((uint32_t)(input[42] & 0xe0) << 11);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 339 to 354
	value = ((uint32_t)(input[42] & 0x1f) << 27) |
			((uint32_t)input[43] << 19) |
			((uint32_t)(input[44] & 0xe0) << 11);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 355 to 370
	value = ((uint32_t)(input[44] & 0x1f) << 27) |
			((uint32_t)input[45] << 19) |
			((uint32_t)(input[46] & 0xe0) << 11);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 371 to 386
	value = ((uint32_t)(input[46] & 0x1f) << 27) |
			((uint32_t)input[47] << 19) |
			((uint32_t)(input[48] & 0xe0) << 11);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 387 to 402
	value = ((uint32_t)(input[48] & 0x1f) << 27) |
			((uint32_t)input[49] << 19) |
			((uint32_t)(input[50] & 0xe0) << 11);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 403 to 418
	value = ((uint32_t)(input[50] & 0x1f) << 27) |
			((uint32_t)input[51] << 19) |
			((uint32_t)(input[52] & 0xe0) << 11);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 419 to 434
	value = ((uint32_t)(input[52] & 0x1f) << 27) |
			((uint32_t)input[53] << 19) |
			((uint32_t)(input[54] & 0xe0) << 11);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 435 to 450
	value = ((uint32_t)(input[54] & 0x1f) << 27) |
			((uint32_t)input[55] << 19) |
			((uint32_t)(input[56] & 0xe0) << 11);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 451 to 466
	value = ((uint32_t)(input[56] & 0x1f) << 27) |
			((uint32_t)input[57] << 19) |
			((uint32_t)(input[58] & 0xe0) << 11);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 467 to 482
	value = ((uint32_t)(input[58] & 0x1f) << 27) |
			((uint32_t)input[59] << 19) |
			((uint32_t)(input[60] & 0xe0) << 11);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 483 to 498
	value = ((uint32_t)(input[60] & 0x1f) << 27) |
			((uint32_t)input[61] << 19) |
			((uint32_t)(input[62] & 0xe0) << 11);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 499 to 514
	value = ((uint32_t)(input[62] & 0x1f) << 27) |
			((uint32_t)input[63] << 19) |
			((uint32_t)(input[64] & 0xe0) << 11);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 515 to 530
	value = ((uint32_t)(input[64] & 0x1f) << 27) |
			((uint32_t)input[65] << 19) |
			((uint32_t)(input[66] & 0xe0) << 11);
	output[32] = (double)(value >> 16);
}

static void unpack_33_16bit_signed_4off(const uint8_t * input, double * output, void *closure) {
	// Unpack 33 values into output
	// Values are 16-bit signed
	// Skip 4 bits, read 528 bits of data.
	// Input must be at least 67 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 4 to 19
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20) |
			((uint32_t)(input[2] & 0xf0) << 12);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 20 to 35
	value = ((uint32_t)(input[2] & 0x0f) << 28) |
			((uint32_t)input[3] << 20) |
			((uint32_t)(input[4] & 0xf0) << 12);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 36 to 51
	value = ((uint32_t)(input[4] & 0x0f) << 28) |
			((uint32_t)input[5] << 20) |
			((uint32_t)(input[6] & 0xf0) << 12);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 52 to 67
	value = ((uint32_t)(input[6] & 0x0f) << 28) |
			((uint32_t)input[7] << 20) |
			((uint32_t)(input[8] & 0xf0) << 12);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 68 to 83
	value = ((uint32_t)(input[8] & 0x0f) << 28) |
			((uint32_t)input[9] << 20) |
			((uint32_t)(input[10] & 0xf0) << 12);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 84 to 99
	value = ((uint32_t)(input[10] & 0x0f) << 28) |
			((uint32_t)input[11] << 20) |
			((uint32_t)(input[12] & 0xf0) << 12);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 100 to 115
	value = ((uint32_t)(input[12] & 0x0f) << 28) |
			((uint32_t)input[13] << 20) |
			((uint32_t)(input[14] & 0xf0) << 12);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 116 to 131
	value = ((uint32_t)(input[14] & 0x0f) << 28) |
			((uint32_t)input[15] << 20) |
			((uint32_t)(input[16] & 0xf0) << 12);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 132 to 147
	value = ((uint32_t)(input[16] & 0x0f) << 28) |
			((uint32_t)input[17] << 20) |
			((uint32_t)(input[18] & 0xf0) << 12);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 148 to 163
	value = ((uint32_t)(input[18] & 0x0f) << 28) |
			((uint32_t)input[19] << 20) |
			((uint32_t)(input[20] & 0xf0) << 12);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 164 to 179
	value = ((uint32_t)(input[20] & 0x0f) << 28) |
			((uint32_t)input[21] << 20) |
			((uint32_t)(input[22] & 0xf0) << 12);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 180 to 195
	value = ((uint32_t)(input[22] & 0x0f) << 28) |
			((uint32_t)input[23] << 20) |
			((uint32_t)(input[24] & 0xf0) << 12);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 196 to 211
	value = ((uint32_t)(input[24] & 0x0f) << 28) |
			((uint32_t)input[25] << 20) |
			((uint32_t)(input[26] & 0xf0) << 12);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 212 to 227
	value = ((uint32_t)(input[26] & 0x0f) << 28) |
			((uint32_t)input[27] << 20) |
			((uint32_t)(input[28] & 0xf0) << 12);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 228 to 243
	value = ((uint32_t)(input[28] & 0x0f) << 28) |
			((uint32_t)input[29] << 20) |
			((uint32_t)(input[30] & 0xf0) << 12);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 244 to 259
	value = ((uint32_t)(input[30] & 0x0f) << 28) |
			((uint32_t)input[31] << 20) |
			((uint32_t)(input[32] & 0xf0) << 12);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 260 to 275
	value = ((uint32_t)(input[32] & 0x0f) << 28) |
			((uint32_t)input[33] << 20) |
			((uint32_t)(input[34] & 0xf0) << 12);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 276 to 291
	value = ((uint32_t)(input[34] & 0x0f) << 28) |
			((uint32_t)input[35] << 20) |
			((uint32_t)(input[36] & 0xf0) << 12);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 292 to 307
	value = ((uint32_t)(input[36] & 0x0f) << 28) |
			((uint32_t)input[37] << 20) |
			((uint32_t)(input[38] & 0xf0) << 12);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 308 to 323
	value = ((uint32_t)(input[38] & 0x0f) << 28) |
			((uint32_t)input[39] << 20) |
			((uint32_t)(input[40] & 0xf0) << 12);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 324 to 339
	value = ((uint32_t)(input[40] & 0x0f) << 28) |
			((uint32_t)input[41] << 20) |
			((uint32_t)(input[42] & 0xf0) << 12);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 340 to 355
	value = ((uint32_t)(input[42] & 0x0f) << 28) |
			((uint32_t)input[43] << 20) |
			((uint32_t)(input[44] & 0xf0) << 12);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 356 to 371
	value = ((uint32_t)(input[44] & 0x0f) << 28) |
			((uint32_t)input[45] << 20) |
			((uint32_t)(input[46] & 0xf0) << 12);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 372 to 387
	value = ((uint32_t)(input[46] & 0x0f) << 28) |
			((uint32_t)input[47] << 20) |
			((uint32_t)(input[48] & 0xf0) << 12);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 388 to 403
	value = ((uint32_t)(input[48] & 0x0f) << 28) |
			((uint32_t)input[49] << 20) |
			((uint32_t)(input[50] & 0xf0) << 12);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 404 to 419
	value = ((uint32_t)(input[50] & 0x0f) << 28) |
			((uint32_t)input[51] << 20) |
			((uint32_t)(input[52] & 0xf0) << 12);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 420 to 435
	value = ((uint32_t)(input[52] & 0x0f) << 28) |
			((uint32_t)input[53] << 20) |
			((uint32_t)(input[54] & 0xf0) << 12);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 436 to 451
	value = ((uint32_t)(input[54] & 0x0f) << 28) |
			((uint32_t)input[55] << 20) |
			((uint32_t)(input[56] & 0xf0) << 12);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 452 to 467
	value = ((uint32_t)(input[56] & 0x0f) << 28) |
			((uint32_t)input[57] << 20) |
			((uint32_t)(input[58] & 0xf0) << 12);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 468 to 483
	value = ((uint32_t)(input[58] & 0x0f) << 28) |
			((uint32_t)input[59] << 20) |
			((uint32_t)(input[60] & 0xf0) << 12);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 484 to 499
	value = ((uint32_t)(input[60] & 0x0f) << 28) |
			((uint32_t)input[61] << 20) |
			((uint32_t)(input[62] & 0xf0) << 12);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 500 to 515
	value = ((uint32_t)(input[62] & 0x0f) << 28) |
			((uint32_t)input[63] << 20) |
			((uint32_t)(input[64] & 0xf0) << 12);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 516 to 531
	value = ((uint32_t)(input[64] & 0x0f) << 28) |
			((uint32_t)input[65] << 20) |
			((uint32_t)(input[66] & 0xf0) << 12);
	output[32] = (double)(value >> 16);
}

static void unpack_33_16bit_unsigned_4off(const uint8_t * input, double * output, void *closure) {
	// Unpack 33 values into output
	// Values are 16-bit unsigned
	// Skip 4 bits, read 528 bits of data.
	// Input must be at least 67 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 4 to 19
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20) |
			((uint32_t)(input[2] & 0xf0) << 12);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 20 to 35
	value = ((uint32_t)(input[2] & 0x0f) << 28) |
			((uint32_t)input[3] << 20) |
			((uint32_t)(input[4] & 0xf0) << 12);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 36 to 51
	value = ((uint32_t)(input[4] & 0x0f) << 28) |
			((uint32_t)input[5] << 20) |
			((uint32_t)(input[6] & 0xf0) << 12);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 52 to 67
	value = ((uint32_t)(input[6] & 0x0f) << 28) |
			((uint32_t)input[7] << 20) |
			((uint32_t)(input[8] & 0xf0) << 12);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 68 to 83
	value = ((uint32_t)(input[8] & 0x0f) << 28) |
			((uint32_t)input[9] << 20) |
			((uint32_t)(input[10] & 0xf0) << 12);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 84 to 99
	value = ((uint32_t)(input[10] & 0x0f) << 28) |
			((uint32_t)input[11] << 20) |
			((uint32_t)(input[12] & 0xf0) << 12);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 100 to 115
	value = ((uint32_t)(input[12] & 0x0f) << 28) |
			((uint32_t)input[13] << 20) |
			((uint32_t)(input[14] & 0xf0) << 12);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 116 to 131
	value = ((uint32_t)(input[14] & 0x0f) << 28) |
			((uint32_t)input[15] << 20) |
			((uint32_t)(input[16] & 0xf0) << 12);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 132 to 147
	value = ((uint32_t)(input[16] & 0x0f) << 28) |
			((uint32_t)input[17] << 20) |
			((uint32_t)(input[18] & 0xf0) << 12);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 148 to 163
	value = ((uint32_t)(input[18] & 0x0f) << 28) |
			((uint32_t)input[19] << 20) |
			((uint32_t)(input[20] & 0xf0) << 12);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 164 to 179
	value = ((uint32_t)(input[20] & 0x0f) << 28) |
			((uint32_t)input[21] << 20) |
			((uint32_t)(input[22] & 0xf0) << 12);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 180 to 195
	value = ((uint32_t)(input[22] & 0x0f) << 28) |
			((uint32_t)input[23] << 20) |
			((uint32_t)(input[24] & 0xf0) << 12);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 196 to 211
	value = ((uint32_t)(input[24] & 0x0f) << 28) |
			((uint32_t)input[25] << 20) |
			((uint32_t)(input[26] & 0xf0) << 12);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 212 to 227
	value = ((uint32_t)(input[26] & 0x0f) << 28) |
			((uint32_t)input[27] << 20) |
			((uint32_t)(input[28] & 0xf0) << 12);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 228 to 243
	value = ((uint32_t)(input[28] & 0x0f) << 28) |
			((uint32_t)input[29] << 20) |
			((uint32_t)(input[30] & 0xf0) << 12);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 244 to 259
	value = ((uint32_t)(input[30] & 0x0f) << 28) |
			((uint32_t)input[31] << 20) |
			((uint32_t)(input[32] & 0xf0) << 12);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 260 to 275
	value = ((uint32_t)(input[32] & 0x0f) << 28) |
			((uint32_t)input[33] << 20) |
			((uint32_t)(input[34] & 0xf0) << 12);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 276 to 291
	value = ((uint32_t)(input[34] & 0x0f) << 28) |
			((uint32_t)input[35] << 20) |
			((uint32_t)(input[36] & 0xf0) << 12);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 292 to 307
	value = ((uint32_t)(input[36] & 0x0f) << 28) |
			((uint32_t)input[37] << 20) |
			((uint32_t)(input[38] & 0xf0) << 12);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 308 to 323
	value = ((uint32_t)(input[38] & 0x0f) << 28) |
			((uint32_t)input[39] << 20) |
			((uint32_t)(input[40] & 0xf0) << 12);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 324 to 339
	value = ((uint32_t)(input[40] & 0x0f) << 28) |
			((uint32_t)input[41] << 20) |
			((uint32_t)(input[42] & 0xf0) << 12);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 340 to 355
	value = ((uint32_t)(input[42] & 0x0f) << 28) |
			((uint32_t)input[43] << 20) |
			((uint32_t)(input[44] & 0xf0) << 12);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 356 to 371
	value = ((uint32_t)(input[44] & 0x0f) << 28) |
			((uint32_t)input[45] << 20) |
			((uint32_t)(input[46] & 0xf0) << 12);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 372 to 387
	value = ((uint32_t)(input[46] & 0x0f) << 28) |
			((uint32_t)input[47] << 20) |
			((uint32_t)(input[48] & 0xf0) << 12);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 388 to 403
	value = ((uint32_t)(input[48] & 0x0f) << 28) |
			((uint32_t)input[49] << 20) |
			((uint32_t)(input[50] & 0xf0) << 12);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 404 to 419
	value = ((uint32_t)(input[50] & 0x0f) << 28) |
			((uint32_t)input[51] << 20) |
			((uint32_t)(input[52] & 0xf0) << 12);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 420 to 435
	value = ((uint32_t)(input[52] & 0x0f) << 28) |
			((uint32_t)input[53] << 20) |
			((uint32_t)(input[54] & 0xf0) << 12);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 436 to 451
	value = ((uint32_t)(input[54] & 0x0f) << 28) |
			((uint32_t)input[55] << 20) |
			((uint32_t)(input[56] & 0xf0) << 12);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 452 to 467
	value = ((uint32_t)(input[56] & 0x0f) << 28) |
			((uint32_t)input[57] << 20) |
			((uint32_t)(input[58] & 0xf0) << 12);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 468 to 483
	value = ((uint32_t)(input[58] & 0x0f) << 28) |
			((uint32_t)input[59] << 20) |
			((uint32_t)(input[60] & 0xf0) << 12);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 484 to 499
	value = ((uint32_t)(input[60] & 0x0f) << 28) |
			((uint32_t)input[61] << 20) |
			((uint32_t)(input[62] & 0xf0) << 12);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 500 to 515
	value = ((uint32_t)(input[62] & 0x0f) << 28) |
			((uint32_t)input[63] << 20) |
			((uint32_t)(input[64] & 0xf0) << 12);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 516 to 531
	value = ((uint32_t)(input[64] & 0x0f) << 28) |
			((uint32_t)input[65] << 20) |
			((uint32_t)(input[66] & 0xf0) << 12);
	output[32] = (double)(value >> 16);
}

static void unpack_33_16bit_signed_5off(const uint8_t * input, double * output, void *closure) {
	// Unpack 33 values into output
	// Values are 16-bit signed
	// Skip 5 bits, read 528 bits of data.
	// Input must be at least 67 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 5 to 20
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)(input[2] & 0xf8) << 13);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 21 to 36
	value = ((uint32_t)(input[2] & 0x07) << 29) |
			((uint32_t)input[3] << 21) |
			((uint32_t)(input[4] & 0xf8) << 13);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 37 to 52
	value = ((uint32_t)(input[4] & 0x07) << 29) |
			((uint32_t)input[5] << 21) |
			((uint32_t)(input[6] & 0xf8) << 13);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 53 to 68
	value = ((uint32_t)(input[6] & 0x07) << 29) |
			((uint32_t)input[7] << 21) |
			((uint32_t)(input[8] & 0xf8) << 13);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 69 to 84
	value = ((uint32_t)(input[8] & 0x07) << 29) |
			((uint32_t)input[9] << 21) |
			((uint32_t)(input[10] & 0xf8) << 13);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 85 to 100
	value = ((uint32_t)(input[10] & 0x07) << 29) |
			((uint32_t)input[11] << 21) |
			((uint32_t)(input[12] & 0xf8) << 13);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 101 to 116
	value = ((uint32_t)(input[12] & 0x07) << 29) |
			((uint32_t)input[13] << 21) |
			((uint32_t)(input[14] & 0xf8) << 13);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 117 to 132
	value = ((uint32_t)(input[14] & 0x07) << 29) |
			((uint32_t)input[15] << 21) |
			((uint32_t)(input[16] & 0xf8) << 13);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 133 to 148
	value = ((uint32_t)(input[16] & 0x07) << 29) |
			((uint32_t)input[17] << 21) |
			((uint32_t)(input[18] & 0xf8) << 13);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 149 to 164
	value = ((uint32_t)(input[18] & 0x07) << 29) |
			((uint32_t)input[19] << 21) |
			((uint32_t)(input[20] & 0xf8) << 13);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 165 to 180
	value = ((uint32_t)(input[20] & 0x07) << 29) |
			((uint32_t)input[21] << 21) |
			((uint32_t)(input[22] & 0xf8) << 13);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 181 to 196
	value = ((uint32_t)(input[22] & 0x07) << 29) |
			((uint32_t)input[23] << 21) |
			((uint32_t)(input[24] & 0xf8) << 13);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 197 to 212
	value = ((uint32_t)(input[24] & 0x07) << 29) |
			((uint32_t)input[25] << 21) |
			((uint32_t)(input[26] & 0xf8) << 13);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 213 to 228
	value = ((uint32_t)(input[26] & 0x07) << 29) |
			((uint32_t)input[27] << 21) |
			((uint32_t)(input[28] & 0xf8) << 13);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 229 to 244
	value = ((uint32_t)(input[28] & 0x07) << 29) |
			((uint32_t)input[29] << 21) |
			((uint32_t)(input[30] & 0xf8) << 13);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 245 to 260
	value = ((uint32_t)(input[30] & 0x07) << 29) |
			((uint32_t)input[31] << 21) |
			((uint32_t)(input[32] & 0xf8) << 13);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 261 to 276
	value = ((uint32_t)(input[32] & 0x07) << 29) |
			((uint32_t)input[33] << 21) |
			((uint32_t)(input[34] & 0xf8) << 13);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 277 to 292
	value = ((uint32_t)(input[34] & 0x07) << 29) |
			((uint32_t)input[35] << 21) |
			((uint32_t)(input[36] & 0xf8) << 13);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 293 to 308
	value = ((uint32_t)(input[36] & 0x07) << 29) |
			((uint32_t)input[37] << 21) |
			((uint32_t)(input[38] & 0xf8) << 13);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 309 to 324
	value = ((uint32_t)(input[38] & 0x07) << 29) |
			((uint32_t)input[39] << 21) |
			((uint32_t)(input[40] & 0xf8) << 13);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 325 to 340
	value = ((uint32_t)(input[40] & 0x07) << 29) |
			((uint32_t)input[41] << 21) |
			((uint32_t)(input[42] & 0xf8) << 13);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 341 to 356
	value = ((uint32_t)(input[42] & 0x07) << 29) |
			((uint32_t)input[43] << 21) |
			((uint32_t)(input[44] & 0xf8) << 13);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 357 to 372
	value = ((uint32_t)(input[44] & 0x07) << 29) |
			((uint32_t)input[45] << 21) |
			((uint32_t)(input[46] & 0xf8) << 13);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 373 to 388
	value = ((uint32_t)(input[46] & 0x07) << 29) |
			((uint32_t)input[47] << 21) |
			((uint32_t)(input[48] & 0xf8) << 13);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 389 to 404
	value = ((uint32_t)(input[48] & 0x07) << 29) |
			((uint32_t)input[49] << 21) |
			((uint32_t)(input[50] & 0xf8) << 13);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 405 to 420
	value = ((uint32_t)(input[50] & 0x07) << 29) |
			((uint32_t)input[51] << 21) |
			((uint32_t)(input[52] & 0xf8) << 13);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 421 to 436
	value = ((uint32_t)(input[52] & 0x07) << 29) |
			((uint32_t)input[53] << 21) |
			((uint32_t)(input[54] & 0xf8) << 13);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 437 to 452
	value = ((uint32_t)(input[54] & 0x07) << 29) |
			((uint32_t)input[55] << 21) |
			((uint32_t)(input[56] & 0xf8) << 13);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 453 to 468
	value = ((uint32_t)(input[56] & 0x07) << 29) |
			((uint32_t)input[57] << 21) |
			((uint32_t)(input[58] & 0xf8) << 13);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 469 to 484
	value = ((uint32_t)(input[58] & 0x07) << 29) |
			((uint32_t)input[59] << 21) |
			((uint32_t)(input[60] & 0xf8) << 13);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 485 to 500
	value = ((uint32_t)(input[60] & 0x07) << 29) |
			((uint32_t)input[61] << 21) |
			((uint32_t)(input[62] & 0xf8) << 13);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 501 to 516
	value = ((uint32_t)(input[62] & 0x07) << 29) |
			((uint32_t)input[63] << 21) |
			((uint32_t)(input[64] & 0xf8) << 13);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 517 to 532
	value = ((uint32_t)(input[64] & 0x07) << 29) |
			((uint32_t)input[65] << 21) |
			((uint32_t)(input[66] & 0xf8) << 13);
	output[32] = (double)(value >> 16);
}

static void unpack_33_16bit_unsigned_5off(const uint8_t * input, double * output, void *closure) {
	// Unpack 33 values into output
	// Values are 16-bit unsigned
	// Skip 5 bits, read 528 bits of data.
	// Input must be at least 67 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 5 to 20
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)(input[2] & 0xf8) << 13);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 21 to 36
	value = ((uint32_t)(input[2] & 0x07) << 29) |
			((uint32_t)input[3] << 21) |
			((uint32_t)(input[4] & 0xf8) << 13);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 37 to 52
	value = ((uint32_t)(input[4] & 0x07) << 29) |
			((uint32_t)input[5] << 21) |
			((uint32_t)(input[6] & 0xf8) << 13);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 53 to 68
	value = ((uint32_t)(input[6] & 0x07) << 29) |
			((uint32_t)input[7] << 21) |
			((uint32_t)(input[8] & 0xf8) << 13);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 69 to 84
	value = ((uint32_t)(input[8] & 0x07) << 29) |
			((uint32_t)input[9] << 21) |
			((uint32_t)(input[10] & 0xf8) << 13);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 85 to 100
	value = ((uint32_t)(input[10] & 0x07) << 29) |
			((uint32_t)input[11] << 21) |
			((uint32_t)(input[12] & 0xf8) << 13);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 101 to 116
	value = ((uint32_t)(input[12] & 0x07) << 29) |
			((uint32_t)input[13] << 21) |
			((uint32_t)(input[14] & 0xf8) << 13);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 117 to 132
	value = ((uint32_t)(input[14] & 0x07) << 29) |
			((uint32_t)input[15] << 21) |
			((uint32_t)(input[16] & 0xf8) << 13);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 133 to 148
	value = ((uint32_t)(input[16] & 0x07) << 29) |
			((uint32_t)input[17] << 21) |
			((uint32_t)(input[18] & 0xf8) << 13);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 149 to 164
	value = ((uint32_t)(input[18] & 0x07) << 29) |
			((uint32_t)input[19] << 21) |
			((uint32_t)(input[20] & 0xf8) << 13);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 165 to 180
	value = ((uint32_t)(input[20] & 0x07) << 29) |
			((uint32_t)input[21] << 21) |
			((uint32_t)(input[22] & 0xf8) << 13);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 181 to 196
	value = ((uint32_t)(input[22] & 0x07) << 29) |
			((uint32_t)input[23] << 21) |
			((uint32_t)(input[24] & 0xf8) << 13);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 197 to 212
	value = ((uint32_t)(input[24] & 0x07) << 29) |
			((uint32_t)input[25] << 21) |
			((uint32_t)(input[26] & 0xf8) << 13);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 213 to 228
	value = ((uint32_t)(input[26] & 0x07) << 29) |
			((uint32_t)input[27] << 21) |
			((uint32_t)(input[28] & 0xf8) << 13);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 229 to 244
	value = ((uint32_t)(input[28] & 0x07) << 29) |
			((uint32_t)input[29] << 21) |
			((uint32_t)(input[30] & 0xf8) << 13);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 245 to 260
	value = ((uint32_t)(input[30] & 0x07) << 29) |
			((uint32_t)input[31] << 21) |
			((uint32_t)(input[32] & 0xf8) << 13);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 261 to 276
	value = ((uint32_t)(input[32] & 0x07) << 29) |
			((uint32_t)input[33] << 21) |
			((uint32_t)(input[34] & 0xf8) << 13);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 277 to 292
	value = ((uint32_t)(input[34] & 0x07) << 29) |
			((uint32_t)input[35] << 21) |
			((uint32_t)(input[36] & 0xf8) << 13);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 293 to 308
	value = ((uint32_t)(input[36] & 0x07) << 29) |
			((uint32_t)input[37] << 21) |
			((uint32_t)(input[38] & 0xf8) << 13);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 309 to 324
	value = ((uint32_t)(input[38] & 0x07) << 29) |
			((uint32_t)input[39] << 21) |
			((uint32_t)(input[40] & 0xf8) << 13);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 325 to 340
	value = ((uint32_t)(input[40] & 0x07) << 29) |
			((uint32_t)input[41] << 21) |
			((uint32_t)(input[42] & 0xf8) << 13);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 341 to 356
	value = ((uint32_t)(input[42] & 0x07) << 29) |
			((uint32_t)input[43] << 21) |
			((uint32_t)(input[44] & 0xf8) << 13);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 357 to 372
	value = ((uint32_t)(input[44] & 0x07) << 29) |
			((uint32_t)input[45] << 21) |
			((uint32_t)(input[46] & 0xf8) << 13);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 373 to 388
	value = ((uint32_t)(input[46] & 0x07) << 29) |
			((uint32_t)input[47] << 21) |
			((uint32_t)(input[48] & 0xf8) << 13);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 389 to 404
	value = ((uint32_t)(input[48] & 0x07) << 29) |
			((uint32_t)input[49] << 21) |
			((uint32_t)(input[50] & 0xf8) << 13);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 405 to 420
	value = ((uint32_t)(input[50] & 0x07) << 29) |
			((uint32_t)input[51] << 21) |
			((uint32_t)(input[52] & 0xf8) << 13);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 421 to 436
	value = ((uint32_t)(input[52] & 0x07) << 29) |
			((uint32_t)input[53] << 21) |
			((uint32_t)(input[54] & 0xf8) << 13);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 437 to 452
	value = ((uint32_t)(input[54] & 0x07) << 29) |
			((uint32_t)input[55] << 21) |
			((uint32_t)(input[56] & 0xf8) << 13);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 453 to 468
	value = ((uint32_t)(input[56] & 0x07) << 29) |
			((uint32_t)input[57] << 21) |
			((uint32_t)(input[58] & 0xf8) << 13);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 469 to 484
	value = ((uint32_t)(input[58] & 0x07) << 29) |
			((uint32_t)input[59] << 21) |
			((uint32_t)(input[60] & 0xf8) << 13);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 485 to 500
	value = ((uint32_t)(input[60] & 0x07) << 29) |
			((uint32_t)input[61] << 21) |
			((uint32_t)(input[62] & 0xf8) << 13);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 501 to 516
	value = ((uint32_t)(input[62] & 0x07) << 29) |
			((uint32_t)input[63] << 21) |
			((uint32_t)(input[64] & 0xf8) << 13);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 517 to 532
	value = ((uint32_t)(input[64] & 0x07) << 29) |
			((uint32_t)input[65] << 21) |
			((uint32_t)(input[66] & 0xf8) << 13);
	output[32] = (double)(value >> 16);
}

static void unpack_33_16bit_signed_6off(const uint8_t * input, double * output, void *closure) {
	// Unpack 33 values into output
	// Values are 16-bit signed
	// Skip 6 bits, read 528 bits of data.
	// Input must be at least 67 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 6 to 21
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)(input[2] & 0xfc) << 14);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 22 to 37
	value = ((uint32_t)(input[2] & 0x03) << 30) |
			((uint32_t)input[3] << 22) |
			((uint32_t)(input[4] & 0xfc) << 14);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 38 to 53
	value = ((uint32_t)(input[4] & 0x03) << 30) |
			((uint32_t)input[5] << 22) |
			((uint32_t)(input[6] & 0xfc) << 14);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 54 to 69
	value = ((uint32_t)(input[6] & 0x03) << 30) |
			((uint32_t)input[7] << 22) |
			((uint32_t)(input[8] & 0xfc) << 14);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 70 to 85
	value = ((uint32_t)(input[8] & 0x03) << 30) |
			((uint32_t)input[9] << 22) |
			((uint32_t)(input[10] & 0xfc) << 14);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 86 to 101
	value = ((uint32_t)(input[10] & 0x03) << 30) |
			((uint32_t)input[11] << 22) |
			((uint32_t)(input[12] & 0xfc) << 14);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 102 to 117
	value = ((uint32_t)(input[12] & 0x03) << 30) |
			((uint32_t)input[13] << 22) |
			((uint32_t)(input[14] & 0xfc) << 14);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 118 to 133
	value = ((uint32_t)(input[14] & 0x03) << 30) |
			((uint32_t)input[15] << 22) |
			((uint32_t)(input[16] & 0xfc) << 14);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 134 to 149
	value = ((uint32_t)(input[16] & 0x03) << 30) |
			((uint32_t)input[17] << 22) |
			((uint32_t)(input[18] & 0xfc) << 14);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 150 to 165
	value = ((uint32_t)(input[18] & 0x03) << 30) |
			((uint32_t)input[19] << 22) |
			((uint32_t)(input[20] & 0xfc) << 14);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 166 to 181
	value = ((uint32_t)(input[20] & 0x03) << 30) |
			((uint32_t)input[21] << 22) |
			((uint32_t)(input[22] & 0xfc) << 14);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 182 to 197
	value = ((uint32_t)(input[22] & 0x03) << 30) |
			((uint32_t)input[23] << 22) |
			((uint32_t)(input[24] & 0xfc) << 14);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 198 to 213
	value = ((uint32_t)(input[24] & 0x03) << 30) |
			((uint32_t)input[25] << 22) |
			((uint32_t)(input[26] & 0xfc) << 14);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 214 to 229
	value = ((uint32_t)(input[26] & 0x03) << 30) |
			((uint32_t)input[27] << 22) |
			((uint32_t)(input[28] & 0xfc) << 14);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 230 to 245
	value = ((uint32_t)(input[28] & 0x03) << 30) |
			((uint32_t)input[29] << 22) |
			((uint32_t)(input[30] & 0xfc) << 14);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 246 to 261
	value = ((uint32_t)(input[30] & 0x03) << 30) |
			((uint32_t)input[31] << 22) |
			((uint32_t)(input[32] & 0xfc) << 14);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 262 to 277
	value = ((uint32_t)(input[32] & 0x03) << 30) |
			((uint32_t)input[33] << 22) |
			((uint32_t)(input[34] & 0xfc) << 14);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 278 to 293
	value = ((uint32_t)(input[34] & 0x03) << 30) |
			((uint32_t)input[35] << 22) |
			((uint32_t)(input[36] & 0xfc) << 14);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 294 to 309
	value = ((uint32_t)(input[36] & 0x03) << 30) |
			((uint32_t)input[37] << 22) |
			((uint32_t)(input[38] & 0xfc) << 14);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 310 to 325
	value = ((uint32_t)(input[38] & 0x03) << 30) |
			((uint32_t)input[39] << 22) |
			((uint32_t)(input[40] & 0xfc) << 14);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 326 to 341
	value = ((uint32_t)(input[40] & 0x03) << 30) |
			((uint32_t)input[41] << 22) |
			((uint32_t)(input[42] & 0xfc) << 14);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 342 to 357
	value = ((uint32_t)(input[42] & 0x03) << 30) |
			((uint32_t)input[43] << 22) |
			((uint32_t)(input[44] & 0xfc) << 14);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 358 to 373
	value = ((uint32_t)(input[44] & 0x03) << 30) |
			((uint32_t)input[45] << 22) |
			((uint32_t)(input[46] & 0xfc) << 14);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 374 to 389
	value = ((uint32_t)(input[46] & 0x03) << 30) |
			((uint32_t)input[47] << 22) |
			((uint32_t)(input[48] & 0xfc) << 14);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 390 to 405
	value = ((uint32_t)(input[48] & 0x03) << 30) |
			((uint32_t)input[49] << 22) |
			((uint32_t)(input[50] & 0xfc) << 14);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 406 to 421
	value = ((uint32_t)(input[50] & 0x03) << 30) |
			((uint32_t)input[51] << 22) |
			((uint32_t)(input[52] & 0xfc) << 14);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 422 to 437
	value = ((uint32_t)(input[52] & 0x03) << 30) |
			((uint32_t)input[53] << 22) |
			((uint32_t)(input[54] & 0xfc) << 14);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 438 to 453
	value = ((uint32_t)(input[54] & 0x03) << 30) |
			((uint32_t)input[55] << 22) |
			((uint32_t)(input[56] & 0xfc) << 14);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 454 to 469
	value = ((uint32_t)(input[56] & 0x03) << 30) |
			((uint32_t)input[57] << 22) |
			((uint32_t)(input[58] & 0xfc) << 14);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 470 to 485
	value = ((uint32_t)(input[58] & 0x03) << 30) |
			((uint32_t)input[59] << 22) |
			((uint32_t)(input[60] & 0xfc) << 14);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 486 to 501
	value = ((uint32_t)(input[60] & 0x03) << 30) |
			((uint32_t)input[61] << 22) |
			((uint32_t)(input[62] & 0xfc) << 14);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 502 to 517
	value = ((uint32_t)(input[62] & 0x03) << 30) |
			((uint32_t)input[63] << 22) |
			((uint32_t)(input[64] & 0xfc) << 14);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 518 to 533
	value = ((uint32_t)(input[64] & 0x03) << 30) |
			((uint32_t)input[65] << 22) |
			((uint32_t)(input[66] & 0xfc) << 14);
	output[32] = (double)(value >> 16);
}

static void unpack_33_16bit_unsigned_6off(const uint8_t * input, double * output, void *closure) {
	// Unpack 33 values into output
	// Values are 16-bit unsigned
	// Skip 6 bits, read 528 bits of data.
	// Input must be at least 67 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 6 to 21
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)(input[2] & 0xfc) << 14);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 22 to 37
	value = ((uint32_t)(input[2] & 0x03) << 30) |
			((uint32_t)input[3] << 22) |
			((uint32_t)(input[4] & 0xfc) << 14);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 38 to 53
	value = ((uint32_t)(input[4] & 0x03) << 30) |
			((uint32_t)input[5] << 22) |
			((uint32_t)(input[6] & 0xfc) << 14);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 54 to 69
	value = ((uint32_t)(input[6] & 0x03) << 30) |
			((uint32_t)input[7] << 22) |
			((uint32_t)(input[8] & 0xfc) << 14);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 70 to 85
	value = ((uint32_t)(input[8] & 0x03) << 30) |
			((uint32_t)input[9] << 22) |
			((uint32_t)(input[10] & 0xfc) << 14);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 86 to 101
	value = ((uint32_t)(input[10] & 0x03) << 30) |
			((uint32_t)input[11] << 22) |
			((uint32_t)(input[12] & 0xfc) << 14);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 102 to 117
	value = ((uint32_t)(input[12] & 0x03) << 30) |
			((uint32_t)input[13] << 22) |
			((uint32_t)(input[14] & 0xfc) << 14);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 118 to 133
	value = ((uint32_t)(input[14] & 0x03) << 30) |
			((uint32_t)input[15] << 22) |
			((uint32_t)(input[16] & 0xfc) << 14);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 134 to 149
	value = ((uint32_t)(input[16] & 0x03) << 30) |
			((uint32_t)input[17] << 22) |
			((uint32_t)(input[18] & 0xfc) << 14);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 150 to 165
	value = ((uint32_t)(input[18] & 0x03) << 30) |
			((uint32_t)input[19] << 22) |
			((uint32_t)(input[20] & 0xfc) << 14);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 166 to 181
	value = ((uint32_t)(input[20] & 0x03) << 30) |
			((uint32_t)input[21] << 22) |
			((uint32_t)(input[22] & 0xfc) << 14);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 182 to 197
	value = ((uint32_t)(input[22] & 0x03) << 30) |
			((uint32_t)input[23] << 22) |
			((uint32_t)(input[24] & 0xfc) << 14);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 198 to 213
	value = ((uint32_t)(input[24] & 0x03) << 30) |
			((uint32_t)input[25] << 22) |
			((uint32_t)(input[26] & 0xfc) << 14);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 214 to 229
	value = ((uint32_t)(input[26] & 0x03) << 30) |
			((uint32_t)input[27] << 22) |
			((uint32_t)(input[28] & 0xfc) << 14);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 230 to 245
	value = ((uint32_t)(input[28] & 0x03) << 30) |
			((uint32_t)input[29] << 22) |
			((uint32_t)(input[30] & 0xfc) << 14);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 246 to 261
	value = ((uint32_t)(input[30] & 0x03) << 30) |
			((uint32_t)input[31] << 22) |
			((uint32_t)(input[32] & 0xfc) << 14);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 262 to 277
	value = ((uint32_t)(input[32] & 0x03) << 30) |
			((uint32_t)input[33] << 22) |
			((uint32_t)(input[34] & 0xfc) << 14);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 278 to 293
	value = ((uint32_t)(input[34] & 0x03) << 30) |
			((uint32_t)input[35] << 22) |
			((uint32_t)(input[36] & 0xfc) << 14);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 294 to 309
	value = ((uint32_t)(input[36] & 0x03) << 30) |
			((uint32_t)input[37] << 22) |
			((uint32_t)(input[38] & 0xfc) << 14);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 310 to 325
	value = ((uint32_t)(input[38] & 0x03) << 30) |
			((uint32_t)input[39] << 22) |
			((uint32_t)(input[40] & 0xfc) << 14);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 326 to 341
	value = ((uint32_t)(input[40] & 0x03) << 30) |
			((uint32_t)input[41] << 22) |
			((uint32_t)(input[42] & 0xfc) << 14);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 342 to 357
	value = ((uint32_t)(input[42] & 0x03) << 30) |
			((uint32_t)input[43] << 22) |
			((uint32_t)(input[44] & 0xfc) << 14);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 358 to 373
	value = ((uint32_t)(input[44] & 0x03) << 30) |
			((uint32_t)input[45] << 22) |
			((uint32_t)(input[46] & 0xfc) << 14);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 374 to 389
	value = ((uint32_t)(input[46] & 0x03) << 30) |
			((uint32_t)input[47] << 22) |
			((uint32_t)(input[48] & 0xfc) << 14);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 390 to 405
	value = ((uint32_t)(input[48] & 0x03) << 30) |
			((uint32_t)input[49] << 22) |
			((uint32_t)(input[50] & 0xfc) << 14);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 406 to 421
	value = ((uint32_t)(input[50] & 0x03) << 30) |
			((uint32_t)input[51] << 22) |
			((uint32_t)(input[52] & 0xfc) << 14);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 422 to 437
	value = ((uint32_t)(input[52] & 0x03) << 30) |
			((uint32_t)input[53] << 22) |
			((uint32_t)(input[54] & 0xfc) << 14);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 438 to 453
	value = ((uint32_t)(input[54] & 0x03) << 30) |
			((uint32_t)input[55] << 22) |
			((uint32_t)(input[56] & 0xfc) << 14);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 454 to 469
	value = ((uint32_t)(input[56] & 0x03) << 30) |
			((uint32_t)input[57] << 22) |
			((uint32_t)(input[58] & 0xfc) << 14);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 470 to 485
	value = ((uint32_t)(input[58] & 0x03) << 30) |
			((uint32_t)input[59] << 22) |
			((uint32_t)(input[60] & 0xfc) << 14);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 486 to 501
	value = ((uint32_t)(input[60] & 0x03) << 30) |
			((uint32_t)input[61] << 22) |
			((uint32_t)(input[62] & 0xfc) << 14);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 502 to 517
	value = ((uint32_t)(input[62] & 0x03) << 30) |
			((uint32_t)input[63] << 22) |
			((uint32_t)(input[64] & 0xfc) << 14);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 518 to 533
	value = ((uint32_t)(input[64] & 0x03) << 30) |
			((uint32_t)input[65] << 22) |
			((uint32_t)(input[66] & 0xfc) << 14);
	output[32] = (double)(value >> 16);
}

static void unpack_33_16bit_signed_7off(const uint8_t * input, double * output, void *closure) {
	// Unpack 33 values into output
	// Values are 16-bit signed
	// Skip 7 bits, read 528 bits of data.
	// Input must be at least 67 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 7 to 22
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)(input[2] & 0xfe) << 15);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 23 to 38
	value = ((uint32_t)(input[2] & 0x01) << 31) |
			((uint32_t)input[3] << 23) |
			((uint32_t)(input[4] & 0xfe) << 15);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 39 to 54
	value = ((uint32_t)(input[4] & 0x01) << 31) |
			((uint32_t)input[5] << 23) |
			((uint32_t)(input[6] & 0xfe) << 15);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 55 to 70
	value = ((uint32_t)(input[6] & 0x01) << 31) |
			((uint32_t)input[7] << 23) |
			((uint32_t)(input[8] & 0xfe) << 15);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 71 to 86
	value = ((uint32_t)(input[8] & 0x01) << 31) |
			((uint32_t)input[9] << 23) |
			((uint32_t)(input[10] & 0xfe) << 15);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 87 to 102
	value = ((uint32_t)(input[10] & 0x01) << 31) |
			((uint32_t)input[11] << 23) |
			((uint32_t)(input[12] & 0xfe) << 15);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 103 to 118
	value = ((uint32_t)(input[12] & 0x01) << 31) |
			((uint32_t)input[13] << 23) |
			((uint32_t)(input[14] & 0xfe) << 15);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 119 to 134
	value = ((uint32_t)(input[14] & 0x01) << 31) |
			((uint32_t)input[15] << 23) |
			((uint32_t)(input[16] & 0xfe) << 15);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 135 to 150
	value = ((uint32_t)(input[16] & 0x01) << 31) |
			((uint32_t)input[17] << 23) |
			((uint32_t)(input[18] & 0xfe) << 15);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 151 to 166
	value = ((uint32_t)(input[18] & 0x01) << 31) |
			((uint32_t)input[19] << 23) |
			((uint32_t)(input[20] & 0xfe) << 15);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 167 to 182
	value = ((uint32_t)(input[20] & 0x01) << 31) |
			((uint32_t)input[21] << 23) |
			((uint32_t)(input[22] & 0xfe) << 15);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 183 to 198
	value = ((uint32_t)(input[22] & 0x01) << 31) |
			((uint32_t)input[23] << 23) |
			((uint32_t)(input[24] & 0xfe) << 15);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 199 to 214
	value = ((uint32_t)(input[24] & 0x01) << 31) |
			((uint32_t)input[25] << 23) |
			((uint32_t)(input[26] & 0xfe) << 15);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 215 to 230
	value = ((uint32_t)(input[26] & 0x01) << 31) |
			((uint32_t)input[27] << 23) |
			((uint32_t)(input[28] & 0xfe) << 15);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 231 to 246
	value = ((uint32_t)(input[28] & 0x01) << 31) |
			((uint32_t)input[29] << 23) |
			((uint32_t)(input[30] & 0xfe) << 15);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 247 to 262
	value = ((uint32_t)(input[30] & 0x01) << 31) |
			((uint32_t)input[31] << 23) |
			((uint32_t)(input[32] & 0xfe) << 15);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 263 to 278
	value = ((uint32_t)(input[32] & 0x01) << 31) |
			((uint32_t)input[33] << 23) |
			((uint32_t)(input[34] & 0xfe) << 15);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 279 to 294
	value = ((uint32_t)(input[34] & 0x01) << 31) |
			((uint32_t)input[35] << 23) |
			((uint32_t)(input[36] & 0xfe) << 15);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 295 to 310
	value = ((uint32_t)(input[36] & 0x01) << 31) |
			((uint32_t)input[37] << 23) |
			((uint32_t)(input[38] & 0xfe) << 15);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 311 to 326
	value = ((uint32_t)(input[38] & 0x01) << 31) |
			((uint32_t)input[39] << 23) |
			((uint32_t)(input[40] & 0xfe) << 15);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 327 to 342
	value = ((uint32_t)(input[40] & 0x01) << 31) |
			((uint32_t)input[41] << 23) |
			((uint32_t)(input[42] & 0xfe) << 15);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 343 to 358
	value = ((uint32_t)(input[42] & 0x01) << 31) |
			((uint32_t)input[43] << 23) |
			((uint32_t)(input[44] & 0xfe) << 15);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 359 to 374
	value = ((uint32_t)(input[44] & 0x01) << 31) |
			((uint32_t)input[45] << 23) |
			((uint32_t)(input[46] & 0xfe) << 15);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 375 to 390
	value = ((uint32_t)(input[46] & 0x01) << 31) |
			((uint32_t)input[47] << 23) |
			((uint32_t)(input[48] & 0xfe) << 15);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 391 to 406
	value = ((uint32_t)(input[48] & 0x01) << 31) |
			((uint32_t)input[49] << 23) |
			((uint32_t)(input[50] & 0xfe) << 15);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 407 to 422
	value = ((uint32_t)(input[50] & 0x01) << 31) |
			((uint32_t)input[51] << 23) |
			((uint32_t)(input[52] & 0xfe) << 15);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 423 to 438
	value = ((uint32_t)(input[52] & 0x01) << 31) |
			((uint32_t)input[53] << 23) |
			((uint32_t)(input[54] & 0xfe) << 15);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 439 to 454
	value = ((uint32_t)(input[54] & 0x01) << 31) |
			((uint32_t)input[55] << 23) |
			((uint32_t)(input[56] & 0xfe) << 15);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 455 to 470
	value = ((uint32_t)(input[56] & 0x01) << 31) |
			((uint32_t)input[57] << 23) |
			((uint32_t)(input[58] & 0xfe) << 15);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 471 to 486
	value = ((uint32_t)(input[58] & 0x01) << 31) |
			((uint32_t)input[59] << 23) |
			((uint32_t)(input[60] & 0xfe) << 15);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 487 to 502
	value = ((uint32_t)(input[60] & 0x01) << 31) |
			((uint32_t)input[61] << 23) |
			((uint32_t)(input[62] & 0xfe) << 15);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 503 to 518
	value = ((uint32_t)(input[62] & 0x01) << 31) |
			((uint32_t)input[63] << 23) |
			((uint32_t)(input[64] & 0xfe) << 15);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 519 to 534
	value = ((uint32_t)(input[64] & 0x01) << 31) |
			((uint32_t)input[65] << 23) |
			((uint32_t)(input[66] & 0xfe) << 15);
	output[32] = (double)(value >> 16);
}

static void unpack_33_16bit_unsigned_7off(const uint8_t * input, double * output, void *closure) {
	// Unpack 33 values into output
	// Values are 16-bit unsigned
	// Skip 7 bits, read 528 bits of data.
	// Input must be at least 67 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 7 to 22
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)(input[2] & 0xfe) << 15);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 23 to 38
	value = ((uint32_t)(input[2] & 0x01) << 31) |
			((uint32_t)input[3] << 23) |
			((uint32_t)(input[4] & 0xfe) << 15);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 39 to 54
	value = ((uint32_t)(input[4] & 0x01) << 31) |
			((uint32_t)input[5] << 23) |
			((uint32_t)(input[6] & 0xfe) << 15);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 55 to 70
	value = ((uint32_t)(input[6] & 0x01) << 31) |
			((uint32_t)input[7] << 23) |
			((uint32_t)(input[8] & 0xfe) << 15);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 71 to 86
	value = ((uint32_t)(input[8] & 0x01) << 31) |
			((uint32_t)input[9] << 23) |
			((uint32_t)(input[10] & 0xfe) << 15);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 87 to 102
	value = ((uint32_t)(input[10] & 0x01) << 31) |
			((uint32_t)input[11] << 23) |
			((uint32_t)(input[12] & 0xfe) << 15);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 103 to 118
	value = ((uint32_t)(input[12] & 0x01) << 31) |
			((uint32_t)input[13] << 23) |
			((uint32_t)(input[14] & 0xfe) << 15);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 119 to 134
	value = ((uint32_t)(input[14] & 0x01) << 31) |
			((uint32_t)input[15] << 23) |
			((uint32_t)(input[16] & 0xfe) << 15);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 135 to 150
	value = ((uint32_t)(input[16] & 0x01) << 31) |
			((uint32_t)input[17] << 23) |
			((uint32_t)(input[18] & 0xfe) << 15);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 151 to 166
	value = ((uint32_t)(input[18] & 0x01) << 31) |
			((uint32_t)input[19] << 23) |
			((uint32_t)(input[20] & 0xfe) << 15);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 167 to 182
	value = ((uint32_t)(input[20] & 0x01) << 31) |
			((uint32_t)input[21] << 23) |
			((uint32_t)(input[22] & 0xfe) << 15);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 183 to 198
	value = ((uint32_t)(input[22] & 0x01) << 31) |
			((uint32_t)input[23] << 23) |
			((uint32_t)(input[24] & 0xfe) << 15);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 199 to 214
	value = ((uint32_t)(input[24] & 0x01) << 31) |
			((uint32_t)input[25] << 23) |
			((uint32_t)(input[26] & 0xfe) << 15);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 215 to 230
	value = ((uint32_t)(input[26] & 0x01) << 31) |
			((uint32_t)input[27] << 23) |
			((uint32_t)(input[28] & 0xfe) << 15);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 231 to 246
	value = ((uint32_t)(input[28] & 0x01) << 31) |
			((uint32_t)input[29] << 23) |
			((uint32_t)(input[30] & 0xfe) << 15);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 247 to 262
	value = ((uint32_t)(input[30] & 0x01) << 31) |
			((uint32_t)input[31] << 23) |
			((uint32_t)(input[32] & 0xfe) << 15);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 263 to 278
	value = ((uint32_t)(input[32] & 0x01) << 31) |
			((uint32_t)input[33] << 23) |
			((uint32_t)(input[34] & 0xfe) << 15);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 279 to 294
	value = ((uint32_t)(input[34] & 0x01) << 31) |
			((uint32_t)input[35] << 23) |
			((uint32_t)(input[36] & 0xfe) << 15);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 295 to 310
	value = ((uint32_t)(input[36] & 0x01) << 31) |
			((uint32_t)input[37] << 23) |
			((uint32_t)(input[38] & 0xfe) << 15);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 311 to 326
	value = ((uint32_t)(input[38] & 0x01) << 31) |
			((uint32_t)input[39] << 23) |
			((uint32_t)(input[40] & 0xfe) << 15);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 327 to 342
	value = ((uint32_t)(input[40] & 0x01) << 31) |
			((uint32_t)input[41] << 23) |
			((uint32_t)(input[42] & 0xfe) << 15);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 343 to 358
	value = ((uint32_t)(input[42] & 0x01) << 31) |
			((uint32_t)input[43] << 23) |
			((uint32_t)(input[44] & 0xfe) << 15);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 359 to 374
	value = ((uint32_t)(input[44] & 0x01) << 31) |
			((uint32_t)input[45] << 23) |
			((uint32_t)(input[46] & 0xfe) << 15);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 375 to 390
	value = ((uint32_t)(input[46] & 0x01) << 31) |
			((uint32_t)input[47] << 23) |
			((uint32_t)(input[48] & 0xfe) << 15);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 391 to 406
	value = ((uint32_t)(input[48] & 0x01) << 31) |
			((uint32_t)input[49] << 23) |
			((uint32_t)(input[50] & 0xfe) << 15);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 407 to 422
	value = ((uint32_t)(input[50] & 0x01) << 31) |
			((uint32_t)input[51] << 23) |
			((uint32_t)(input[52] & 0xfe) << 15);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 423 to 438
	value = ((uint32_t)(input[52] & 0x01) << 31) |
			((uint32_t)input[53] << 23) |
			((uint32_t)(input[54] & 0xfe) << 15);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 439 to 454
	value = ((uint32_t)(input[54] & 0x01) << 31) |
			((uint32_t)input[55] << 23) |
			((uint32_t)(input[56] & 0xfe) << 15);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 455 to 470
	value = ((uint32_t)(input[56] & 0x01) << 31) |
			((uint32_t)input[57] << 23) |
			((uint32_t)(input[58] & 0xfe) << 15);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 471 to 486
	value = ((uint32_t)(input[58] & 0x01) << 31) |
			((uint32_t)input[59] << 23) |
			((uint32_t)(input[60] & 0xfe) << 15);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 487 to 502
	value = ((uint32_t)(input[60] & 0x01) << 31) |
			((uint32_t)input[61] << 23) |
			((uint32_t)(input[62] & 0xfe) << 15);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 503 to 518
	value = ((uint32_t)(input[62] & 0x01) << 31) |
			((uint32_t)input[63] << 23) |
			((uint32_t)(input[64] & 0xfe) << 15);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 519 to 534
	value = ((uint32_t)(input[64] & 0x01) << 31) |
			((uint32_t)input[65] << 23) |
			((uint32_t)(input[66] & 0xfe) << 15);
	output[32] = (double)(value >> 16);
}

static void unpack_34_16bit_signed_0off(const uint8_t * input, double * output, void *closure) {
	// Unpack 34 values into output
	// Values are 16-bit signed
	// Skip 0 bits, read 544 bits of data.
	// Input must be at least 68 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 0 to 15
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)input[1] << 16);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 16 to 31
	value = ((uint32_t)input[2] << 24) |
			((uint32_t)input[3] << 16);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 32 to 47
	value = ((uint32_t)input[4] << 24) |
			((uint32_t)input[5] << 16);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 48 to 63
	value = ((uint32_t)input[6] << 24) |
			((uint32_t)input[7] << 16);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 64 to 79
	value = ((uint32_t)input[8] << 24) |
			((uint32_t)input[9] << 16);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 80 to 95
	value = ((uint32_t)input[10] << 24) |
			((uint32_t)input[11] << 16);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 96 to 111
	value = ((uint32_t)input[12] << 24) |
			((uint32_t)input[13] << 16);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 112 to 127
	value = ((uint32_t)input[14] << 24) |
			((uint32_t)input[15] << 16);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 128 to 143
	value = ((uint32_t)input[16] << 24) |
			((uint32_t)input[17] << 16);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 144 to 159
	value = ((uint32_t)input[18] << 24) |
			((uint32_t)input[19] << 16);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 160 to 175
	value = ((uint32_t)input[20] << 24) |
			((uint32_t)input[21] << 16);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 176 to 191
	value = ((uint32_t)input[22] << 24) |
			((uint32_t)input[23] << 16);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 192 to 207
	value = ((uint32_t)input[24] << 24) |
			((uint32_t)input[25] << 16);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 208 to 223
	value = ((uint32_t)input[26] << 24) |
			((uint32_t)input[27] << 16);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 224 to 239
	value = ((uint32_t)input[28] << 24) |
			((uint32_t)input[29] << 16);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 240 to 255
	value = ((uint32_t)input[30] << 24) |
			((uint32_t)input[31] << 16);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 256 to 271
	value = ((uint32_t)input[32] << 24) |
			((uint32_t)input[33] << 16);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 272 to 287
	value = ((uint32_t)input[34] << 24) |
			((uint32_t)input[35] << 16);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 288 to 303
	value = ((uint32_t)input[36] << 24) |
			((uint32_t)input[37] << 16);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 304 to 319
	value = ((uint32_t)input[38] << 24) |
			((uint32_t)input[39] << 16);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 320 to 335
	value = ((uint32_t)input[40] << 24) |
			((uint32_t)input[41] << 16);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 336 to 351
	value = ((uint32_t)input[42] << 24) |
			((uint32_t)input[43] << 16);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 352 to 367
	value = ((uint32_t)input[44] << 24) |
			((uint32_t)input[45] << 16);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 368 to 383
	value = ((uint32_t)input[46] << 24) |
			((uint32_t)input[47] << 16);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 384 to 399
	value = ((uint32_t)input[48] << 24) |
			((uint32_t)input[49] << 16);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 400 to 415
	value = ((uint32_t)input[50] << 24) |
			((uint32_t)input[51] << 16);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 416 to 431
	value = ((uint32_t)input[52] << 24) |
			((uint32_t)input[53] << 16);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 432 to 447
	value = ((uint32_t)input[54] << 24) |
			((uint32_t)input[55] << 16);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 448 to 463
	value = ((uint32_t)input[56] << 24) |
			((uint32_t)input[57] << 16);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 464 to 479
	value = ((uint32_t)input[58] << 24) |
			((uint32_t)input[59] << 16);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 480 to 495
	value = ((uint32_t)input[60] << 24) |
			((uint32_t)input[61] << 16);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 496 to 511
	value = ((uint32_t)input[62] << 24) |
			((uint32_t)input[63] << 16);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 512 to 527
	value = ((uint32_t)input[64] << 24) |
			((uint32_t)input[65] << 16);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 528 to 543
	value = ((uint32_t)input[66] << 24) |
			((uint32_t)input[67] << 16);
	output[33] = (double)(value >> 16);
}

static void unpack_34_16bit_unsigned_0off(const uint8_t * input, double * output, void *closure) {
	// Unpack 34 values into output
	// Values are 16-bit unsigned
	// Skip 0 bits, read 544 bits of data.
	// Input must be at least 68 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 0 to 15
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)input[1] << 16);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 16 to 31
	value = ((uint32_t)input[2] << 24) |
			((uint32_t)input[3] << 16);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 32 to 47
	value = ((uint32_t)input[4] << 24) |
			((uint32_t)input[5] << 16);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 48 to 63
	value = ((uint32_t)input[6] << 24) |
			((uint32_t)input[7] << 16);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 64 to 79
	value = ((uint32_t)input[8] << 24) |
			((uint32_t)input[9] << 16);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 80 to 95
	value = ((uint32_t)input[10] << 24) |
			((uint32_t)input[11] << 16);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 96 to 111
	value = ((uint32_t)input[12] << 24) |
			((uint32_t)input[13] << 16);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 112 to 127
	value = ((uint32_t)input[14] << 24) |
			((uint32_t)input[15] << 16);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 128 to 143
	value = ((uint32_t)input[16] << 24) |
			((uint32_t)input[17] << 16);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 144 to 159
	value = ((uint32_t)input[18] << 24) |
			((uint32_t)input[19] << 16);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 160 to 175
	value = ((uint32_t)input[20] << 24) |
			((uint32_t)input[21] << 16);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 176 to 191
	value = ((uint32_t)input[22] << 24) |
			((uint32_t)input[23] << 16);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 192 to 207
	value = ((uint32_t)input[24] << 24) |
			((uint32_t)input[25] << 16);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 208 to 223
	value = ((uint32_t)input[26] << 24) |
			((uint32_t)input[27] << 16);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 224 to 239
	value = ((uint32_t)input[28] << 24) |
			((uint32_t)input[29] << 16);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 240 to 255
	value = ((uint32_t)input[30] << 24) |
			((uint32_t)input[31] << 16);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 256 to 271
	value = ((uint32_t)input[32] << 24) |
			((uint32_t)input[33] << 16);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 272 to 287
	value = ((uint32_t)input[34] << 24) |
			((uint32_t)input[35] << 16);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 288 to 303
	value = ((uint32_t)input[36] << 24) |
			((uint32_t)input[37] << 16);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 304 to 319
	value = ((uint32_t)input[38] << 24) |
			((uint32_t)input[39] << 16);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 320 to 335
	value = ((uint32_t)input[40] << 24) |
			((uint32_t)input[41] << 16);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 336 to 351
	value = ((uint32_t)input[42] << 24) |
			((uint32_t)input[43] << 16);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 352 to 367
	value = ((uint32_t)input[44] << 24) |
			((uint32_t)input[45] << 16);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 368 to 383
	value = ((uint32_t)input[46] << 24) |
			((uint32_t)input[47] << 16);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 384 to 399
	value = ((uint32_t)input[48] << 24) |
			((uint32_t)input[49] << 16);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 400 to 415
	value = ((uint32_t)input[50] << 24) |
			((uint32_t)input[51] << 16);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 416 to 431
	value = ((uint32_t)input[52] << 24) |
			((uint32_t)input[53] << 16);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 432 to 447
	value = ((uint32_t)input[54] << 24) |
			((uint32_t)input[55] << 16);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 448 to 463
	value = ((uint32_t)input[56] << 24) |
			((uint32_t)input[57] << 16);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 464 to 479
	value = ((uint32_t)input[58] << 24) |
			((uint32_t)input[59] << 16);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 480 to 495
	value = ((uint32_t)input[60] << 24) |
			((uint32_t)input[61] << 16);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 496 to 511
	value = ((uint32_t)input[62] << 24) |
			((uint32_t)input[63] << 16);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 512 to 527
	value = ((uint32_t)input[64] << 24) |
			((uint32_t)input[65] << 16);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 528 to 543
	value = ((uint32_t)input[66] << 24) |
			((uint32_t)input[67] << 16);
	output[33] = (double)(value >> 16);
}

static void unpack_34_16bit_signed_1off(const uint8_t * input, double * output, void *closure) {
	// Unpack 34 values into output
	// Values are 16-bit signed
	// Skip 1 bits, read 544 bits of data.
	// Input must be at least 69 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 1 to 16
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)input[1] << 17) |
			((uint32_t)(input[2] & 0x80) << 9);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 17 to 32
	value = ((uint32_t)(input[2] & 0x7f) << 25) |
			((uint32_t)input[3] << 17) |
			((uint32_t)(input[4] & 0x80) << 9);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 33 to 48
	value = ((uint32_t)(input[4] & 0x7f) << 25) |
			((uint32_t)input[5] << 17) |
			((uint32_t)(input[6] & 0x80) << 9);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 49 to 64
	value = ((uint32_t)(input[6] & 0x7f) << 25) |
			((uint32_t)input[7] << 17) |
			((uint32_t)(input[8] & 0x80) << 9);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 65 to 80
	value = ((uint32_t)(input[8] & 0x7f) << 25) |
			((uint32_t)input[9] << 17) |
			((uint32_t)(input[10] & 0x80) << 9);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 81 to 96
	value = ((uint32_t)(input[10] & 0x7f) << 25) |
			((uint32_t)input[11] << 17) |
			((uint32_t)(input[12] & 0x80) << 9);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 97 to 112
	value = ((uint32_t)(input[12] & 0x7f) << 25) |
			((uint32_t)input[13] << 17) |
			((uint32_t)(input[14] & 0x80) << 9);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 113 to 128
	value = ((uint32_t)(input[14] & 0x7f) << 25) |
			((uint32_t)input[15] << 17) |
			((uint32_t)(input[16] & 0x80) << 9);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 129 to 144
	value = ((uint32_t)(input[16] & 0x7f) << 25) |
			((uint32_t)input[17] << 17) |
			((uint32_t)(input[18] & 0x80) << 9);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 145 to 160
	value = ((uint32_t)(input[18] & 0x7f) << 25) |
			((uint32_t)input[19] << 17) |
			((uint32_t)(input[20] & 0x80) << 9);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 161 to 176
	value = ((uint32_t)(input[20] & 0x7f) << 25) |
			((uint32_t)input[21] << 17) |
			((uint32_t)(input[22] & 0x80) << 9);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 177 to 192
	value = ((uint32_t)(input[22] & 0x7f) << 25) |
			((uint32_t)input[23] << 17) |
			((uint32_t)(input[24] & 0x80) << 9);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 193 to 208
	value = ((uint32_t)(input[24] & 0x7f) << 25) |
			((uint32_t)input[25] << 17) |
			((uint32_t)(input[26] & 0x80) << 9);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 209 to 224
	value = ((uint32_t)(input[26] & 0x7f) << 25) |
			((uint32_t)input[27] << 17) |
			((uint32_t)(input[28] & 0x80) << 9);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 225 to 240
	value = ((uint32_t)(input[28] & 0x7f) << 25) |
			((uint32_t)input[29] << 17) |
			((uint32_t)(input[30] & 0x80) << 9);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 241 to 256
	value = ((uint32_t)(input[30] & 0x7f) << 25) |
			((uint32_t)input[31] << 17) |
			((uint32_t)(input[32] & 0x80) << 9);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 257 to 272
	value = ((uint32_t)(input[32] & 0x7f) << 25) |
			((uint32_t)input[33] << 17) |
			((uint32_t)(input[34] & 0x80) << 9);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 273 to 288
	value = ((uint32_t)(input[34] & 0x7f) << 25) |
			((uint32_t)input[35] << 17) |
			((uint32_t)(input[36] & 0x80) << 9);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 289 to 304
	value = ((uint32_t)(input[36] & 0x7f) << 25) |
			((uint32_t)input[37] << 17) |
			((uint32_t)(input[38] & 0x80) << 9);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 305 to 320
	value = ((uint32_t)(input[38] & 0x7f) << 25) |
			((uint32_t)input[39] << 17) |
			((uint32_t)(input[40] & 0x80) << 9);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 321 to 336
	value = ((uint32_t)(input[40] & 0x7f) << 25) |
			((uint32_t)input[41] << 17) |
			((uint32_t)(input[42] & 0x80) << 9);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 337 to 352
	value = ((uint32_t)(input[42] & 0x7f) << 25) |
			((uint32_t)input[43] << 17) |
			((uint32_t)(input[44] & 0x80) << 9);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 353 to 368
	value = ((uint32_t)(input[44] & 0x7f) << 25) |
			((uint32_t)input[45] << 17) |
			((uint32_t)(input[46] & 0x80) << 9);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 369 to 384
	value = ((uint32_t)(input[46] & 0x7f) << 25) |
			((uint32_t)input[47] << 17) |
			((uint32_t)(input[48] & 0x80) << 9);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 385 to 400
	value = ((uint32_t)(input[48] & 0x7f) << 25) |
			((uint32_t)input[49] << 17) |
			((uint32_t)(input[50] & 0x80) << 9);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 401 to 416
	value = ((uint32_t)(input[50] & 0x7f) << 25) |
			((uint32_t)input[51] << 17) |
			((uint32_t)(input[52] & 0x80) << 9);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 417 to 432
	value = ((uint32_t)(input[52] & 0x7f) << 25) |
			((uint32_t)input[53] << 17) |
			((uint32_t)(input[54] & 0x80) << 9);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 433 to 448
	value = ((uint32_t)(input[54] & 0x7f) << 25) |
			((uint32_t)input[55] << 17) |
			((uint32_t)(input[56] & 0x80) << 9);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 449 to 464
	value = ((uint32_t)(input[56] & 0x7f) << 25) |
			((uint32_t)input[57] << 17) |
			((uint32_t)(input[58] & 0x80) << 9);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 465 to 480
	value = ((uint32_t)(input[58] & 0x7f) << 25) |
			((uint32_t)input[59] << 17) |
			((uint32_t)(input[60] & 0x80) << 9);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 481 to 496
	value = ((uint32_t)(input[60] & 0x7f) << 25) |
			((uint32_t)input[61] << 17) |
			((uint32_t)(input[62] & 0x80) << 9);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 497 to 512
	value = ((uint32_t)(input[62] & 0x7f) << 25) |
			((uint32_t)input[63] << 17) |
			((uint32_t)(input[64] & 0x80) << 9);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 513 to 528
	value = ((uint32_t)(input[64] & 0x7f) << 25) |
			((uint32_t)input[65] << 17) |
			((uint32_t)(input[66] & 0x80) << 9);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 529 to 544
	value = ((uint32_t)(input[66] & 0x7f) << 25) |
			((uint32_t)input[67] << 17) |
			((uint32_t)(input[68] & 0x80) << 9);
	output[33] = (double)(value >> 16);
}

static void unpack_34_16bit_unsigned_1off(const uint8_t * input, double * output, void *closure) {
	// Unpack 34 values into output
	// Values are 16-bit unsigned
	// Skip 1 bits, read 544 bits of data.
	// Input must be at least 69 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 1 to 16
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)input[1] << 17) |
			((uint32_t)(input[2] & 0x80) << 9);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 17 to 32
	value = ((uint32_t)(input[2] & 0x7f) << 25) |
			((uint32_t)input[3] << 17) |
			((uint32_t)(input[4] & 0x80) << 9);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 33 to 48
	value = ((uint32_t)(input[4] & 0x7f) << 25) |
			((uint32_t)input[5] << 17) |
			((uint32_t)(input[6] & 0x80) << 9);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 49 to 64
	value = ((uint32_t)(input[6] & 0x7f) << 25) |
			((uint32_t)input[7] << 17) |
			((uint32_t)(input[8] & 0x80) << 9);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 65 to 80
	value = ((uint32_t)(input[8] & 0x7f) << 25) |
			((uint32_t)input[9] << 17) |
			((uint32_t)(input[10] & 0x80) << 9);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 81 to 96
	value = ((uint32_t)(input[10] & 0x7f) << 25) |
			((uint32_t)input[11] << 17) |
			((uint32_t)(input[12] & 0x80) << 9);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 97 to 112
	value = ((uint32_t)(input[12] & 0x7f) << 25) |
			((uint32_t)input[13] << 17) |
			((uint32_t)(input[14] & 0x80) << 9);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 113 to 128
	value = ((uint32_t)(input[14] & 0x7f) << 25) |
			((uint32_t)input[15] << 17) |
			((uint32_t)(input[16] & 0x80) << 9);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 129 to 144
	value = ((uint32_t)(input[16] & 0x7f) << 25) |
			((uint32_t)input[17] << 17) |
			((uint32_t)(input[18] & 0x80) << 9);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 145 to 160
	value = ((uint32_t)(input[18] & 0x7f) << 25) |
			((uint32_t)input[19] << 17) |
			((uint32_t)(input[20] & 0x80) << 9);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 161 to 176
	value = ((uint32_t)(input[20] & 0x7f) << 25) |
			((uint32_t)input[21] << 17) |
			((uint32_t)(input[22] & 0x80) << 9);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 177 to 192
	value = ((uint32_t)(input[22] & 0x7f) << 25) |
			((uint32_t)input[23] << 17) |
			((uint32_t)(input[24] & 0x80) << 9);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 193 to 208
	value = ((uint32_t)(input[24] & 0x7f) << 25) |
			((uint32_t)input[25] << 17) |
			((uint32_t)(input[26] & 0x80) << 9);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 209 to 224
	value = ((uint32_t)(input[26] & 0x7f) << 25) |
			((uint32_t)input[27] << 17) |
			((uint32_t)(input[28] & 0x80) << 9);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 225 to 240
	value = ((uint32_t)(input[28] & 0x7f) << 25) |
			((uint32_t)input[29] << 17) |
			((uint32_t)(input[30] & 0x80) << 9);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 241 to 256
	value = ((uint32_t)(input[30] & 0x7f) << 25) |
			((uint32_t)input[31] << 17) |
			((uint32_t)(input[32] & 0x80) << 9);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 257 to 272
	value = ((uint32_t)(input[32] & 0x7f) << 25) |
			((uint32_t)input[33] << 17) |
			((uint32_t)(input[34] & 0x80) << 9);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 273 to 288
	value = ((uint32_t)(input[34] & 0x7f) << 25) |
			((uint32_t)input[35] << 17) |
			((uint32_t)(input[36] & 0x80) << 9);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 289 to 304
	value = ((uint32_t)(input[36] & 0x7f) << 25) |
			((uint32_t)input[37] << 17) |
			((uint32_t)(input[38] & 0x80) << 9);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 305 to 320
	value = ((uint32_t)(input[38] & 0x7f) << 25) |
			((uint32_t)input[39] << 17) |
			((uint32_t)(input[40] & 0x80) << 9);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 321 to 336
	value = ((uint32_t)(input[40] & 0x7f) << 25) |
			((uint32_t)input[41] << 17) |
			((uint32_t)(input[42] & 0x80) << 9);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 337 to 352
	value = ((uint32_t)(input[42] & 0x7f) << 25) |
			((uint32_t)input[43] << 17) |
			((uint32_t)(input[44] & 0x80) << 9);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 353 to 368
	value = ((uint32_t)(input[44] & 0x7f) << 25) |
			((uint32_t)input[45] << 17) |
			((uint32_t)(input[46] & 0x80) << 9);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 369 to 384
	value = ((uint32_t)(input[46] & 0x7f) << 25) |
			((uint32_t)input[47] << 17) |
			((uint32_t)(input[48] & 0x80) << 9);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 385 to 400
	value = ((uint32_t)(input[48] & 0x7f) << 25) |
			((uint32_t)input[49] << 17) |
			((uint32_t)(input[50] & 0x80) << 9);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 401 to 416
	value = ((uint32_t)(input[50] & 0x7f) << 25) |
			((uint32_t)input[51] << 17) |
			((uint32_t)(input[52] & 0x80) << 9);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 417 to 432
	value = ((uint32_t)(input[52] & 0x7f) << 25) |
			((uint32_t)input[53] << 17) |
			((uint32_t)(input[54] & 0x80) << 9);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 433 to 448
	value = ((uint32_t)(input[54] & 0x7f) << 25) |
			((uint32_t)input[55] << 17) |
			((uint32_t)(input[56] & 0x80) << 9);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 449 to 464
	value = ((uint32_t)(input[56] & 0x7f) << 25) |
			((uint32_t)input[57] << 17) |
			((uint32_t)(input[58] & 0x80) << 9);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 465 to 480
	value = ((uint32_t)(input[58] & 0x7f) << 25) |
			((uint32_t)input[59] << 17) |
			((uint32_t)(input[60] & 0x80) << 9);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 481 to 496
	value = ((uint32_t)(input[60] & 0x7f) << 25) |
			((uint32_t)input[61] << 17) |
			((uint32_t)(input[62] & 0x80) << 9);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 497 to 512
	value = ((uint32_t)(input[62] & 0x7f) << 25) |
			((uint32_t)input[63] << 17) |
			((uint32_t)(input[64] & 0x80) << 9);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 513 to 528
	value = ((uint32_t)(input[64] & 0x7f) << 25) |
			((uint32_t)input[65] << 17) |
			((uint32_t)(input[66] & 0x80) << 9);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 529 to 544
	value = ((uint32_t)(input[66] & 0x7f) << 25) |
			((uint32_t)input[67] << 17) |
			((uint32_t)(input[68] & 0x80) << 9);
	output[33] = (double)(value >> 16);
}

static void unpack_34_16bit_signed_2off(const uint8_t * input, double * output, void *closure) {
	// Unpack 34 values into output
	// Values are 16-bit signed
	// Skip 2 bits, read 544 bits of data.
	// Input must be at least 69 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 2 to 17
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)input[1] << 18) |
			((uint32_t)(input[2] & 0xc0) << 10);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 18 to 33
	value = ((uint32_t)(input[2] & 0x3f) << 26) |
			((uint32_t)input[3] << 18) |
			((uint32_t)(input[4] & 0xc0) << 10);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 34 to 49
	value = ((uint32_t)(input[4] & 0x3f) << 26) |
			((uint32_t)input[5] << 18) |
			((uint32_t)(input[6] & 0xc0) << 10);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 50 to 65
	value = ((uint32_t)(input[6] & 0x3f) << 26) |
			((uint32_t)input[7] << 18) |
			((uint32_t)(input[8] & 0xc0) << 10);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 66 to 81
	value = ((uint32_t)(input[8] & 0x3f) << 26) |
			((uint32_t)input[9] << 18) |
			((uint32_t)(input[10] & 0xc0) << 10);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 82 to 97
	value = ((uint32_t)(input[10] & 0x3f) << 26) |
			((uint32_t)input[11] << 18) |
			((uint32_t)(input[12] & 0xc0) << 10);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 98 to 113
	value = ((uint32_t)(input[12] & 0x3f) << 26) |
			((uint32_t)input[13] << 18) |
			((uint32_t)(input[14] & 0xc0) << 10);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 114 to 129
	value = ((uint32_t)(input[14] & 0x3f) << 26) |
			((uint32_t)input[15] << 18) |
			((uint32_t)(input[16] & 0xc0) << 10);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 130 to 145
	value = ((uint32_t)(input[16] & 0x3f) << 26) |
			((uint32_t)input[17] << 18) |
			((uint32_t)(input[18] & 0xc0) << 10);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 146 to 161
	value = ((uint32_t)(input[18] & 0x3f) << 26) |
			((uint32_t)input[19] << 18) |
			((uint32_t)(input[20] & 0xc0) << 10);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 162 to 177
	value = ((uint32_t)(input[20] & 0x3f) << 26) |
			((uint32_t)input[21] << 18) |
			((uint32_t)(input[22] & 0xc0) << 10);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 178 to 193
	value = ((uint32_t)(input[22] & 0x3f) << 26) |
			((uint32_t)input[23] << 18) |
			((uint32_t)(input[24] & 0xc0) << 10);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 194 to 209
	value = ((uint32_t)(input[24] & 0x3f) << 26) |
			((uint32_t)input[25] << 18) |
			((uint32_t)(input[26] & 0xc0) << 10);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 210 to 225
	value = ((uint32_t)(input[26] & 0x3f) << 26) |
			((uint32_t)input[27] << 18) |
			((uint32_t)(input[28] & 0xc0) << 10);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 226 to 241
	value = ((uint32_t)(input[28] & 0x3f) << 26) |
			((uint32_t)input[29] << 18) |
			((uint32_t)(input[30] & 0xc0) << 10);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 242 to 257
	value = ((uint32_t)(input[30] & 0x3f) << 26) |
			((uint32_t)input[31] << 18) |
			((uint32_t)(input[32] & 0xc0) << 10);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 258 to 273
	value = ((uint32_t)(input[32] & 0x3f) << 26) |
			((uint32_t)input[33] << 18) |
			((uint32_t)(input[34] & 0xc0) << 10);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 274 to 289
	value = ((uint32_t)(input[34] & 0x3f) << 26) |
			((uint32_t)input[35] << 18) |
			((uint32_t)(input[36] & 0xc0) << 10);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 290 to 305
	value = ((uint32_t)(input[36] & 0x3f) << 26) |
			((uint32_t)input[37] << 18) |
			((uint32_t)(input[38] & 0xc0) << 10);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 306 to 321
	value = ((uint32_t)(input[38] & 0x3f) << 26) |
			((uint32_t)input[39] << 18) |
			((uint32_t)(input[40] & 0xc0) << 10);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 322 to 337
	value = ((uint32_t)(input[40] & 0x3f) << 26) |
			((uint32_t)input[41] << 18) |
			((uint32_t)(input[42] & 0xc0) << 10);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 338 to 353
	value = ((uint32_t)(input[42] & 0x3f) << 26) |
			((uint32_t)input[43] << 18) |
			((uint32_t)(input[44] & 0xc0) << 10);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 354 to 369
	value = ((uint32_t)(input[44] & 0x3f) << 26) |
			((uint32_t)input[45] << 18) |
			((uint32_t)(input[46] & 0xc0) << 10);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 370 to 385
	value = ((uint32_t)(input[46] & 0x3f) << 26) |
			((uint32_t)input[47] << 18) |
			((uint32_t)(input[48] & 0xc0) << 10);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 386 to 401
	value = ((uint32_t)(input[48] & 0x3f) << 26) |
			((uint32_t)input[49] << 18) |
			((uint32_t)(input[50] & 0xc0) << 10);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 402 to 417
	value = ((uint32_t)(input[50] & 0x3f) << 26) |
			((uint32_t)input[51] << 18) |
			((uint32_t)(input[52] & 0xc0) << 10);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 418 to 433
	value = ((uint32_t)(input[52] & 0x3f) << 26) |
			((uint32_t)input[53] << 18) |
			((uint32_t)(input[54] & 0xc0) << 10);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 434 to 449
	value = ((uint32_t)(input[54] & 0x3f) << 26) |
			((uint32_t)input[55] << 18) |
			((uint32_t)(input[56] & 0xc0) << 10);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 450 to 465
	value = ((uint32_t)(input[56] & 0x3f) << 26) |
			((uint32_t)input[57] << 18) |
			((uint32_t)(input[58] & 0xc0) << 10);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 466 to 481
	value = ((uint32_t)(input[58] & 0x3f) << 26) |
			((uint32_t)input[59] << 18) |
			((uint32_t)(input[60] & 0xc0) << 10);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 482 to 497
	value = ((uint32_t)(input[60] & 0x3f) << 26) |
			((uint32_t)input[61] << 18) |
			((uint32_t)(input[62] & 0xc0) << 10);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 498 to 513
	value = ((uint32_t)(input[62] & 0x3f) << 26) |
			((uint32_t)input[63] << 18) |
			((uint32_t)(input[64] & 0xc0) << 10);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 514 to 529
	value = ((uint32_t)(input[64] & 0x3f) << 26) |
			((uint32_t)input[65] << 18) |
			((uint32_t)(input[66] & 0xc0) << 10);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 530 to 545
	value = ((uint32_t)(input[66] & 0x3f) << 26) |
			((uint32_t)input[67] << 18) |
			((uint32_t)(input[68] & 0xc0) << 10);
	output[33] = (double)(value >> 16);
}

static void unpack_34_16bit_unsigned_2off(const uint8_t * input, double * output, void *closure) {
	// Unpack 34 values into output
	// Values are 16-bit unsigned
	// Skip 2 bits, read 544 bits of data.
	// Input must be at least 69 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 2 to 17
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)input[1] << 18) |
			((uint32_t)(input[2] & 0xc0) << 10);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 18 to 33
	value = ((uint32_t)(input[2] & 0x3f) << 26) |
			((uint32_t)input[3] << 18) |
			((uint32_t)(input[4] & 0xc0) << 10);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 34 to 49
	value = ((uint32_t)(input[4] & 0x3f) << 26) |
			((uint32_t)input[5] << 18) |
			((uint32_t)(input[6] & 0xc0) << 10);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 50 to 65
	value = ((uint32_t)(input[6] & 0x3f) << 26) |
			((uint32_t)input[7] << 18) |
			((uint32_t)(input[8] & 0xc0) << 10);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 66 to 81
	value = ((uint32_t)(input[8] & 0x3f) << 26) |
			((uint32_t)input[9] << 18) |
			((uint32_t)(input[10] & 0xc0) << 10);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 82 to 97
	value = ((uint32_t)(input[10] & 0x3f) << 26) |
			((uint32_t)input[11] << 18) |
			((uint32_t)(input[12] & 0xc0) << 10);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 98 to 113
	value = ((uint32_t)(input[12] & 0x3f) << 26) |
			((uint32_t)input[13] << 18) |
			((uint32_t)(input[14] & 0xc0) << 10);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 114 to 129
	value = ((uint32_t)(input[14] & 0x3f) << 26) |
			((uint32_t)input[15] << 18) |
			((uint32_t)(input[16] & 0xc0) << 10);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 130 to 145
	value = ((uint32_t)(input[16] & 0x3f) << 26) |
			((uint32_t)input[17] << 18) |
			((uint32_t)(input[18] & 0xc0) << 10);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 146 to 161
	value = ((uint32_t)(input[18] & 0x3f) << 26) |
			((uint32_t)input[19] << 18) |
			((uint32_t)(input[20] & 0xc0) << 10);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 162 to 177
	value = ((uint32_t)(input[20] & 0x3f) << 26) |
			((uint32_t)input[21] << 18) |
			((uint32_t)(input[22] & 0xc0) << 10);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 178 to 193
	value = ((uint32_t)(input[22] & 0x3f) << 26) |
			((uint32_t)input[23] << 18) |
			((uint32_t)(input[24] & 0xc0) << 10);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 194 to 209
	value = ((uint32_t)(input[24] & 0x3f) << 26) |
			((uint32_t)input[25] << 18) |
			((uint32_t)(input[26] & 0xc0) << 10);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 210 to 225
	value = ((uint32_t)(input[26] & 0x3f) << 26) |
			((uint32_t)input[27] << 18) |
			((uint32_t)(input[28] & 0xc0) << 10);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 226 to 241
	value = ((uint32_t)(input[28] & 0x3f) << 26) |
			((uint32_t)input[29] << 18) |
			((uint32_t)(input[30] & 0xc0) << 10);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 242 to 257
	value = ((uint32_t)(input[30] & 0x3f) << 26) |
			((uint32_t)input[31] << 18) |
			((uint32_t)(input[32] & 0xc0) << 10);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 258 to 273
	value = ((uint32_t)(input[32] & 0x3f) << 26) |
			((uint32_t)input[33] << 18) |
			((uint32_t)(input[34] & 0xc0) << 10);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 274 to 289
	value = ((uint32_t)(input[34] & 0x3f) << 26) |
			((uint32_t)input[35] << 18) |
			((uint32_t)(input[36] & 0xc0) << 10);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 290 to 305
	value = ((uint32_t)(input[36] & 0x3f) << 26) |
			((uint32_t)input[37] << 18) |
			((uint32_t)(input[38] & 0xc0) << 10);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 306 to 321
	value = ((uint32_t)(input[38] & 0x3f) << 26) |
			((uint32_t)input[39] << 18) |
			((uint32_t)(input[40] & 0xc0) << 10);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 322 to 337
	value = ((uint32_t)(input[40] & 0x3f) << 26) |
			((uint32_t)input[41] << 18) |
			((uint32_t)(input[42] & 0xc0) << 10);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 338 to 353
	value = ((uint32_t)(input[42] & 0x3f) << 26) |
			((uint32_t)input[43] << 18) |
			((uint32_t)(input[44] & 0xc0) << 10);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 354 to 369
	value = ((uint32_t)(input[44] & 0x3f) << 26) |
			((uint32_t)input[45] << 18) |
			((uint32_t)(input[46] & 0xc0) << 10);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 370 to 385
	value = ((uint32_t)(input[46] & 0x3f) << 26) |
			((uint32_t)input[47] << 18) |
			((uint32_t)(input[48] & 0xc0) << 10);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 386 to 401
	value = ((uint32_t)(input[48] & 0x3f) << 26) |
			((uint32_t)input[49] << 18) |
			((uint32_t)(input[50] & 0xc0) << 10);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 402 to 417
	value = ((uint32_t)(input[50] & 0x3f) << 26) |
			((uint32_t)input[51] << 18) |
			((uint32_t)(input[52] & 0xc0) << 10);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 418 to 433
	value = ((uint32_t)(input[52] & 0x3f) << 26) |
			((uint32_t)input[53] << 18) |
			((uint32_t)(input[54] & 0xc0) << 10);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 434 to 449
	value = ((uint32_t)(input[54] & 0x3f) << 26) |
			((uint32_t)input[55] << 18) |
			((uint32_t)(input[56] & 0xc0) << 10);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 450 to 465
	value = ((uint32_t)(input[56] & 0x3f) << 26) |
			((uint32_t)input[57] << 18) |
			((uint32_t)(input[58] & 0xc0) << 10);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 466 to 481
	value = ((uint32_t)(input[58] & 0x3f) << 26) |
			((uint32_t)input[59] << 18) |
			((uint32_t)(input[60] & 0xc0) << 10);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 482 to 497
	value = ((uint32_t)(input[60] & 0x3f) << 26) |
			((uint32_t)input[61] << 18) |
			((uint32_t)(input[62] & 0xc0) << 10);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 498 to 513
	value = ((uint32_t)(input[62] & 0x3f) << 26) |
			((uint32_t)input[63] << 18) |
			((uint32_t)(input[64] & 0xc0) << 10);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 514 to 529
	value = ((uint32_t)(input[64] & 0x3f) << 26) |
			((uint32_t)input[65] << 18) |
			((uint32_t)(input[66] & 0xc0) << 10);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 530 to 545
	value = ((uint32_t)(input[66] & 0x3f) << 26) |
			((uint32_t)input[67] << 18) |
			((uint32_t)(input[68] & 0xc0) << 10);
	output[33] = (double)(value >> 16);
}

static void unpack_34_16bit_signed_3off(const uint8_t * input, double * output, void *closure) {
	// Unpack 34 values into output
	// Values are 16-bit signed
	// Skip 3 bits, read 544 bits of data.
	// Input must be at least 69 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 3 to 18
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)input[1] << 19) |
			((uint32_t)(input[2] & 0xe0) << 11);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 19 to 34
	value = ((uint32_t)(input[2] & 0x1f) << 27) |
			((uint32_t)input[3] << 19) |
			((uint32_t)(input[4] & 0xe0) << 11);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 35 to 50
	value = ((uint32_t)(input[4] & 0x1f) << 27) |
			((uint32_t)input[5] << 19) |
			((uint32_t)(input[6] & 0xe0) << 11);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 51 to 66
	value = ((uint32_t)(input[6] & 0x1f) << 27) |
			((uint32_t)input[7] << 19) |
			((uint32_t)(input[8] & 0xe0) << 11);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 67 to 82
	value = ((uint32_t)(input[8] & 0x1f) << 27) |
			((uint32_t)input[9] << 19) |
			((uint32_t)(input[10] & 0xe0) << 11);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 83 to 98
	value = ((uint32_t)(input[10] & 0x1f) << 27) |
			((uint32_t)input[11] << 19) |
			((uint32_t)(input[12] & 0xe0) << 11);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 99 to 114
	value = ((uint32_t)(input[12] & 0x1f) << 27) |
			((uint32_t)input[13] << 19) |
			((uint32_t)(input[14] & 0xe0) << 11);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 115 to 130
	value = ((uint32_t)(input[14] & 0x1f) << 27) |
			((uint32_t)input[15] << 19) |
			((uint32_t)(input[16] & 0xe0) << 11);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 131 to 146
	value = ((uint32_t)(input[16] & 0x1f) << 27) |
			((uint32_t)input[17] << 19) |
			((uint32_t)(input[18] & 0xe0) << 11);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 147 to 162
	value = ((uint32_t)(input[18] & 0x1f) << 27) |
			((uint32_t)input[19] << 19) |
			((uint32_t)(input[20] & 0xe0) << 11);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 163 to 178
	value = ((uint32_t)(input[20] & 0x1f) << 27) |
			((uint32_t)input[21] << 19) |
			((uint32_t)(input[22] & 0xe0) << 11);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 179 to 194
	value = ((uint32_t)(input[22] & 0x1f) << 27) |
			((uint32_t)input[23] << 19) |
			((uint32_t)(input[24] & 0xe0) << 11);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 195 to 210
	value = ((uint32_t)(input[24] & 0x1f) << 27) |
			((uint32_t)input[25] << 19) |
			((uint32_t)(input[26] & 0xe0) << 11);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 211 to 226
	value = ((uint32_t)(input[26] & 0x1f) << 27) |
			((uint32_t)input[27] << 19) |
			((uint32_t)(input[28] & 0xe0) << 11);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 227 to 242
	value = ((uint32_t)(input[28] & 0x1f) << 27) |
			((uint32_t)input[29] << 19) |
			((uint32_t)(input[30] & 0xe0) << 11);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 243 to 258
	value = ((uint32_t)(input[30] & 0x1f) << 27) |
			((uint32_t)input[31] << 19) |
			((uint32_t)(input[32] & 0xe0) << 11);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 259 to 274
	value = ((uint32_t)(input[32] & 0x1f) << 27) |
			((uint32_t)input[33] << 19) |
			((uint32_t)(input[34] & 0xe0) << 11);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 275 to 290
	value = ((uint32_t)(input[34] & 0x1f) << 27) |
			((uint32_t)input[35] << 19) |
			((uint32_t)(input[36] & 0xe0) << 11);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 291 to 306
	value = ((uint32_t)(input[36] & 0x1f) << 27) |
			((uint32_t)input[37] << 19) |
			((uint32_t)(input[38] & 0xe0) << 11);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 307 to 322
	value = ((uint32_t)(input[38] & 0x1f) << 27) |
			((uint32_t)input[39] << 19) |
			((uint32_t)(input[40] & 0xe0) << 11);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 323 to 338
	value = ((uint32_t)(input[40] & 0x1f) << 27) |
			((uint32_t)input[41] << 19) |
			((uint32_t)(input[42] & 0xe0) << 11);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 339 to 354
	value = ((uint32_t)(input[42] & 0x1f) << 27) |
			((uint32_t)input[43] << 19) |
			((uint32_t)(input[44] & 0xe0) << 11);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 355 to 370
	value = ((uint32_t)(input[44] & 0x1f) << 27) |
			((uint32_t)input[45] << 19) |
			((uint32_t)(input[46] & 0xe0) << 11);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 371 to 386
	value = ((uint32_t)(input[46] & 0x1f) << 27) |
			((uint32_t)input[47] << 19) |
			((uint32_t)(input[48] & 0xe0) << 11);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 387 to 402
	value = ((uint32_t)(input[48] & 0x1f) << 27) |
			((uint32_t)input[49] << 19) |
			((uint32_t)(input[50] & 0xe0) << 11);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 403 to 418
	value = ((uint32_t)(input[50] & 0x1f) << 27) |
			((uint32_t)input[51] << 19) |
			((uint32_t)(input[52] & 0xe0) << 11);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 419 to 434
	value = ((uint32_t)(input[52] & 0x1f) << 27) |
			((uint32_t)input[53] << 19) |
			((uint32_t)(input[54] & 0xe0) << 11);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 435 to 450
	value = ((uint32_t)(input[54] & 0x1f) << 27) |
			((uint32_t)input[55] << 19) |
			((uint32_t)(input[56] & 0xe0) << 11);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 451 to 466
	value = ((uint32_t)(input[56] & 0x1f) << 27) |
			((uint32_t)input[57] << 19) |
			((uint32_t)(input[58] & 0xe0) << 11);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 467 to 482
	value = ((uint32_t)(input[58] & 0x1f) << 27) |
			((uint32_t)input[59] << 19) |
			((uint32_t)(input[60] & 0xe0) << 11);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 483 to 498
	value = ((uint32_t)(input[60] & 0x1f) << 27) |
			((uint32_t)input[61] << 19) |
			((uint32_t)(input[62] & 0xe0) << 11);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 499 to 514
	value = ((uint32_t)(input[62] & 0x1f) << 27) |
			((uint32_t)input[63] << 19) |
			((uint32_t)(input[64] & 0xe0) << 11);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 515 to 530
	value = ((uint32_t)(input[64] & 0x1f) << 27) |
			((uint32_t)input[65] << 19) |
			((uint32_t)(input[66] & 0xe0) << 11);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 531 to 546
	value = ((uint32_t)(input[66] & 0x1f) << 27) |
			((uint32_t)input[67] << 19) |
			((uint32_t)(input[68] & 0xe0) << 11);
	output[33] = (double)(value >> 16);
}

static void unpack_34_16bit_unsigned_3off(const uint8_t * input, double * output, void *closure) {
	// Unpack 34 values into output
	// Values are 16-bit unsigned
	// Skip 3 bits, read 544 bits of data.
	// Input must be at least 69 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 3 to 18
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)input[1] << 19) |
			((uint32_t)(input[2] & 0xe0) << 11);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 19 to 34
	value = ((uint32_t)(input[2] & 0x1f) << 27) |
			((uint32_t)input[3] << 19) |
			((uint32_t)(input[4] & 0xe0) << 11);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 35 to 50
	value = ((uint32_t)(input[4] & 0x1f) << 27) |
			((uint32_t)input[5] << 19) |
			((uint32_t)(input[6] & 0xe0) << 11);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 51 to 66
	value = ((uint32_t)(input[6] & 0x1f) << 27) |
			((uint32_t)input[7] << 19) |
			((uint32_t)(input[8] & 0xe0) << 11);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 67 to 82
	value = ((uint32_t)(input[8] & 0x1f) << 27) |
			((uint32_t)input[9] << 19) |
			((uint32_t)(input[10] & 0xe0) << 11);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 83 to 98
	value = ((uint32_t)(input[10] & 0x1f) << 27) |
			((uint32_t)input[11] << 19) |
			((uint32_t)(input[12] & 0xe0) << 11);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 99 to 114
	value = ((uint32_t)(input[12] & 0x1f) << 27) |
			((uint32_t)input[13] << 19) |
			((uint32_t)(input[14] & 0xe0) << 11);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 115 to 130
	value = ((uint32_t)(input[14] & 0x1f) << 27) |
			((uint32_t)input[15] << 19) |
			((uint32_t)(input[16] & 0xe0) << 11);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 131 to 146
	value = ((uint32_t)(input[16] & 0x1f) << 27) |
			((uint32_t)input[17] << 19) |
			((uint32_t)(input[18] & 0xe0) << 11);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 147 to 162
	value = ((uint32_t)(input[18] & 0x1f) << 27) |
			((uint32_t)input[19] << 19) |
			((uint32_t)(input[20] & 0xe0) << 11);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 163 to 178
	value = ((uint32_t)(input[20] & 0x1f) << 27) |
			((uint32_t)input[21] << 19) |
			((uint32_t)(input[22] & 0xe0) << 11);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 179 to 194
	value = ((uint32_t)(input[22] & 0x1f) << 27) |
			((uint32_t)input[23] << 19) |
			((uint32_t)(input[24] & 0xe0) << 11);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 195 to 210
	value = ((uint32_t)(input[24] & 0x1f) << 27) |
			((uint32_t)input[25] << 19) |
			((uint32_t)(input[26] & 0xe0) << 11);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 211 to 226
	value = ((uint32_t)(input[26] & 0x1f) << 27) |
			((uint32_t)input[27] << 19) |
			((uint32_t)(input[28] & 0xe0) << 11);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 227 to 242
	value = ((uint32_t)(input[28] & 0x1f) << 27) |
			((uint32_t)input[29] << 19) |
			((uint32_t)(input[30] & 0xe0) << 11);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 243 to 258
	value = ((uint32_t)(input[30] & 0x1f) << 27) |
			((uint32_t)input[31] << 19) |
			((uint32_t)(input[32] & 0xe0) << 11);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 259 to 274
	value = ((uint32_t)(input[32] & 0x1f) << 27) |
			((uint32_t)input[33] << 19) |
			((uint32_t)(input[34] & 0xe0) << 11);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 275 to 290
	value = ((uint32_t)(input[34] & 0x1f) << 27) |
			((uint32_t)input[35] << 19) |
			((uint32_t)(input[36] & 0xe0) << 11);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 291 to 306
	value = ((uint32_t)(input[36] & 0x1f) << 27) |
			((uint32_t)input[37] << 19) |
			((uint32_t)(input[38] & 0xe0) << 11);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 307 to 322
	value = ((uint32_t)(input[38] & 0x1f) << 27) |
			((uint32_t)input[39] << 19) |
			((uint32_t)(input[40] & 0xe0) << 11);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 323 to 338
	value = ((uint32_t)(input[40] & 0x1f) << 27) |
			((uint32_t)input[41] << 19) |
			((uint32_t)(input[42] & 0xe0) << 11);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 339 to 354
	value = ((uint32_t)(input[42] & 0x1f) << 27) |
			((uint32_t)input[43] << 19) |
			((uint32_t)(input[44] & 0xe0) << 11);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 355 to 370
	value = ((uint32_t)(input[44] & 0x1f) << 27) |
			((uint32_t)input[45] << 19) |
			((uint32_t)(input[46] & 0xe0) << 11);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 371 to 386
	value = ((uint32_t)(input[46] & 0x1f) << 27) |
			((uint32_t)input[47] << 19) |
			((uint32_t)(input[48] & 0xe0) << 11);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 387 to 402
	value = ((uint32_t)(input[48] & 0x1f) << 27) |
			((uint32_t)input[49] << 19) |
			((uint32_t)(input[50] & 0xe0) << 11);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 403 to 418
	value = ((uint32_t)(input[50] & 0x1f) << 27) |
			((uint32_t)input[51] << 19) |
			((uint32_t)(input[52] & 0xe0) << 11);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 419 to 434
	value = ((uint32_t)(input[52] & 0x1f) << 27) |
			((uint32_t)input[53] << 19) |
			((uint32_t)(input[54] & 0xe0) << 11);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 435 to 450
	value = ((uint32_t)(input[54] & 0x1f) << 27) |
			((uint32_t)input[55] << 19) |
			((uint32_t)(input[56] & 0xe0) << 11);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 451 to 466
	value = ((uint32_t)(input[56] & 0x1f) << 27) |
			((uint32_t)input[57] << 19) |
			((uint32_t)(input[58] & 0xe0) << 11);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 467 to 482
	value = ((uint32_t)(input[58] & 0x1f) << 27) |
			((uint32_t)input[59] << 19) |
			((uint32_t)(input[60] & 0xe0) << 11);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 483 to 498
	value = ((uint32_t)(input[60] & 0x1f) << 27) |
			((uint32_t)input[61] << 19) |
			((uint32_t)(input[62] & 0xe0) << 11);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 499 to 514
	value = ((uint32_t)(input[62] & 0x1f) << 27) |
			((uint32_t)input[63] << 19) |
			((uint32_t)(input[64] & 0xe0) << 11);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 515 to 530
	value = ((uint32_t)(input[64] & 0x1f) << 27) |
			((uint32_t)input[65] << 19) |
			((uint32_t)(input[66] & 0xe0) << 11);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 531 to 546
	value = ((uint32_t)(input[66] & 0x1f) << 27) |
			((uint32_t)input[67] << 19) |
			((uint32_t)(input[68] & 0xe0) << 11);
	output[33] = (double)(value >> 16);
}

static void unpack_34_16bit_signed_4off(const uint8_t * input, double * output, void *closure) {
	// Unpack 34 values into output
	// Values are 16-bit signed
	// Skip 4 bits, read 544 bits of data.
	// Input must be at least 69 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 4 to 19
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20) |
			((uint32_t)(input[2] & 0xf0) << 12);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 20 to 35
	value = ((uint32_t)(input[2] & 0x0f) << 28) |
			((uint32_t)input[3] << 20) |
			((uint32_t)(input[4] & 0xf0) << 12);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 36 to 51
	value = ((uint32_t)(input[4] & 0x0f) << 28) |
			((uint32_t)input[5] << 20) |
			((uint32_t)(input[6] & 0xf0) << 12);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 52 to 67
	value = ((uint32_t)(input[6] & 0x0f) << 28) |
			((uint32_t)input[7] << 20) |
			((uint32_t)(input[8] & 0xf0) << 12);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 68 to 83
	value = ((uint32_t)(input[8] & 0x0f) << 28) |
			((uint32_t)input[9] << 20) |
			((uint32_t)(input[10] & 0xf0) << 12);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 84 to 99
	value = ((uint32_t)(input[10] & 0x0f) << 28) |
			((uint32_t)input[11] << 20) |
			((uint32_t)(input[12] & 0xf0) << 12);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 100 to 115
	value = ((uint32_t)(input[12] & 0x0f) << 28) |
			((uint32_t)input[13] << 20) |
			((uint32_t)(input[14] & 0xf0) << 12);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 116 to 131
	value = ((uint32_t)(input[14] & 0x0f) << 28) |
			((uint32_t)input[15] << 20) |
			((uint32_t)(input[16] & 0xf0) << 12);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 132 to 147
	value = ((uint32_t)(input[16] & 0x0f) << 28) |
			((uint32_t)input[17] << 20) |
			((uint32_t)(input[18] & 0xf0) << 12);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 148 to 163
	value = ((uint32_t)(input[18] & 0x0f) << 28) |
			((uint32_t)input[19] << 20) |
			((uint32_t)(input[20] & 0xf0) << 12);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 164 to 179
	value = ((uint32_t)(input[20] & 0x0f) << 28) |
			((uint32_t)input[21] << 20) |
			((uint32_t)(input[22] & 0xf0) << 12);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 180 to 195
	value = ((uint32_t)(input[22] & 0x0f) << 28) |
			((uint32_t)input[23] << 20) |
			((uint32_t)(input[24] & 0xf0) << 12);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 196 to 211
	value = ((uint32_t)(input[24] & 0x0f) << 28) |
			((uint32_t)input[25] << 20) |
			((uint32_t)(input[26] & 0xf0) << 12);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 212 to 227
	value = ((uint32_t)(input[26] & 0x0f) << 28) |
			((uint32_t)input[27] << 20) |
			((uint32_t)(input[28] & 0xf0) << 12);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 228 to 243
	value = ((uint32_t)(input[28] & 0x0f) << 28) |
			((uint32_t)input[29] << 20) |
			((uint32_t)(input[30] & 0xf0) << 12);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 244 to 259
	value = ((uint32_t)(input[30] & 0x0f) << 28) |
			((uint32_t)input[31] << 20) |
			((uint32_t)(input[32] & 0xf0) << 12);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 260 to 275
	value = ((uint32_t)(input[32] & 0x0f) << 28) |
			((uint32_t)input[33] << 20) |
			((uint32_t)(input[34] & 0xf0) << 12);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 276 to 291
	value = ((uint32_t)(input[34] & 0x0f) << 28) |
			((uint32_t)input[35] << 20) |
			((uint32_t)(input[36] & 0xf0) << 12);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 292 to 307
	value = ((uint32_t)(input[36] & 0x0f) << 28) |
			((uint32_t)input[37] << 20) |
			((uint32_t)(input[38] & 0xf0) << 12);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 308 to 323
	value = ((uint32_t)(input[38] & 0x0f) << 28) |
			((uint32_t)input[39] << 20) |
			((uint32_t)(input[40] & 0xf0) << 12);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 324 to 339
	value = ((uint32_t)(input[40] & 0x0f) << 28) |
			((uint32_t)input[41] << 20) |
			((uint32_t)(input[42] & 0xf0) << 12);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 340 to 355
	value = ((uint32_t)(input[42] & 0x0f) << 28) |
			((uint32_t)input[43] << 20) |
			((uint32_t)(input[44] & 0xf0) << 12);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 356 to 371
	value = ((uint32_t)(input[44] & 0x0f) << 28) |
			((uint32_t)input[45] << 20) |
			((uint32_t)(input[46] & 0xf0) << 12);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 372 to 387
	value = ((uint32_t)(input[46] & 0x0f) << 28) |
			((uint32_t)input[47] << 20) |
			((uint32_t)(input[48] & 0xf0) << 12);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 388 to 403
	value = ((uint32_t)(input[48] & 0x0f) << 28) |
			((uint32_t)input[49] << 20) |
			((uint32_t)(input[50] & 0xf0) << 12);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 404 to 419
	value = ((uint32_t)(input[50] & 0x0f) << 28) |
			((uint32_t)input[51] << 20) |
			((uint32_t)(input[52] & 0xf0) << 12);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 420 to 435
	value = ((uint32_t)(input[52] & 0x0f) << 28) |
			((uint32_t)input[53] << 20) |
			((uint32_t)(input[54] & 0xf0) << 12);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 436 to 451
	value = ((uint32_t)(input[54] & 0x0f) << 28) |
			((uint32_t)input[55] << 20) |
			((uint32_t)(input[56] & 0xf0) << 12);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 452 to 467
	value = ((uint32_t)(input[56] & 0x0f) << 28) |
			((uint32_t)input[57] << 20) |
			((uint32_t)(input[58] & 0xf0) << 12);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 468 to 483
	value = ((uint32_t)(input[58] & 0x0f) << 28) |
			((uint32_t)input[59] << 20) |
			((uint32_t)(input[60] & 0xf0) << 12);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 484 to 499
	value = ((uint32_t)(input[60] & 0x0f) << 28) |
			((uint32_t)input[61] << 20) |
			((uint32_t)(input[62] & 0xf0) << 12);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 500 to 515
	value = ((uint32_t)(input[62] & 0x0f) << 28) |
			((uint32_t)input[63] << 20) |
			((uint32_t)(input[64] & 0xf0) << 12);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 516 to 531
	value = ((uint32_t)(input[64] & 0x0f) << 28) |
			((uint32_t)input[65] << 20) |
			((uint32_t)(input[66] & 0xf0) << 12);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 532 to 547
	value = ((uint32_t)(input[66] & 0x0f) << 28) |
			((uint32_t)input[67] << 20) |
			((uint32_t)(input[68] & 0xf0) << 12);
	output[33] = (double)(value >> 16);
}

static void unpack_34_16bit_unsigned_4off(const uint8_t * input, double * output, void *closure) {
	// Unpack 34 values into output
	// Values are 16-bit unsigned
	// Skip 4 bits, read 544 bits of data.
	// Input must be at least 69 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 4 to 19
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20) |
			((uint32_t)(input[2] & 0xf0) << 12);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 20 to 35
	value = ((uint32_t)(input[2] & 0x0f) << 28) |
			((uint32_t)input[3] << 20) |
			((uint32_t)(input[4] & 0xf0) << 12);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 36 to 51
	value = ((uint32_t)(input[4] & 0x0f) << 28) |
			((uint32_t)input[5] << 20) |
			((uint32_t)(input[6] & 0xf0) << 12);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 52 to 67
	value = ((uint32_t)(input[6] & 0x0f) << 28) |
			((uint32_t)input[7] << 20) |
			((uint32_t)(input[8] & 0xf0) << 12);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 68 to 83
	value = ((uint32_t)(input[8] & 0x0f) << 28) |
			((uint32_t)input[9] << 20) |
			((uint32_t)(input[10] & 0xf0) << 12);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 84 to 99
	value = ((uint32_t)(input[10] & 0x0f) << 28) |
			((uint32_t)input[11] << 20) |
			((uint32_t)(input[12] & 0xf0) << 12);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 100 to 115
	value = ((uint32_t)(input[12] & 0x0f) << 28) |
			((uint32_t)input[13] << 20) |
			((uint32_t)(input[14] & 0xf0) << 12);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 116 to 131
	value = ((uint32_t)(input[14] & 0x0f) << 28) |
			((uint32_t)input[15] << 20) |
			((uint32_t)(input[16] & 0xf0) << 12);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 132 to 147
	value = ((uint32_t)(input[16] & 0x0f) << 28) |
			((uint32_t)input[17] << 20) |
			((uint32_t)(input[18] & 0xf0) << 12);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 148 to 163
	value = ((uint32_t)(input[18] & 0x0f) << 28) |
			((uint32_t)input[19] << 20) |
			((uint32_t)(input[20] & 0xf0) << 12);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 164 to 179
	value = ((uint32_t)(input[20] & 0x0f) << 28) |
			((uint32_t)input[21] << 20) |
			((uint32_t)(input[22] & 0xf0) << 12);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 180 to 195
	value = ((uint32_t)(input[22] & 0x0f) << 28) |
			((uint32_t)input[23] << 20) |
			((uint32_t)(input[24] & 0xf0) << 12);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 196 to 211
	value = ((uint32_t)(input[24] & 0x0f) << 28) |
			((uint32_t)input[25] << 20) |
			((uint32_t)(input[26] & 0xf0) << 12);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 212 to 227
	value = ((uint32_t)(input[26] & 0x0f) << 28) |
			((uint32_t)input[27] << 20) |
			((uint32_t)(input[28] & 0xf0) << 12);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 228 to 243
	value = ((uint32_t)(input[28] & 0x0f) << 28) |
			((uint32_t)input[29] << 20) |
			((uint32_t)(input[30] & 0xf0) << 12);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 244 to 259
	value = ((uint32_t)(input[30] & 0x0f) << 28) |
			((uint32_t)input[31] << 20) |
			((uint32_t)(input[32] & 0xf0) << 12);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 260 to 275
	value = ((uint32_t)(input[32] & 0x0f) << 28) |
			((uint32_t)input[33] << 20) |
			((uint32_t)(input[34] & 0xf0) << 12);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 276 to 291
	value = ((uint32_t)(input[34] & 0x0f) << 28) |
			((uint32_t)input[35] << 20) |
			((uint32_t)(input[36] & 0xf0) << 12);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 292 to 307
	value = ((uint32_t)(input[36] & 0x0f) << 28) |
			((uint32_t)input[37] << 20) |
			((uint32_t)(input[38] & 0xf0) << 12);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 308 to 323
	value = ((uint32_t)(input[38] & 0x0f) << 28) |
			((uint32_t)input[39] << 20) |
			((uint32_t)(input[40] & 0xf0) << 12);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 324 to 339
	value = ((uint32_t)(input[40] & 0x0f) << 28) |
			((uint32_t)input[41] << 20) |
			((uint32_t)(input[42] & 0xf0) << 12);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 340 to 355
	value = ((uint32_t)(input[42] & 0x0f) << 28) |
			((uint32_t)input[43] << 20) |
			((uint32_t)(input[44] & 0xf0) << 12);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 356 to 371
	value = ((uint32_t)(input[44] & 0x0f) << 28) |
			((uint32_t)input[45] << 20) |
			((uint32_t)(input[46] & 0xf0) << 12);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 372 to 387
	value = ((uint32_t)(input[46] & 0x0f) << 28) |
			((uint32_t)input[47] << 20) |
			((uint32_t)(input[48] & 0xf0) << 12);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 388 to 403
	value = ((uint32_t)(input[48] & 0x0f) << 28) |
			((uint32_t)input[49] << 20) |
			((uint32_t)(input[50] & 0xf0) << 12);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 404 to 419
	value = ((uint32_t)(input[50] & 0x0f) << 28) |
			((uint32_t)input[51] << 20) |
			((uint32_t)(input[52] & 0xf0) << 12);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 420 to 435
	value = ((uint32_t)(input[52] & 0x0f) << 28) |
			((uint32_t)input[53] << 20) |
			((uint32_t)(input[54] & 0xf0) << 12);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 436 to 451
	value = ((uint32_t)(input[54] & 0x0f) << 28) |
			((uint32_t)input[55] << 20) |
			((uint32_t)(input[56] & 0xf0) << 12);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 452 to 467
	value = ((uint32_t)(input[56] & 0x0f) << 28) |
			((uint32_t)input[57] << 20) |
			((uint32_t)(input[58] & 0xf0) << 12);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 468 to 483
	value = ((uint32_t)(input[58] & 0x0f) << 28) |
			((uint32_t)input[59] << 20) |
			((uint32_t)(input[60] & 0xf0) << 12);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 484 to 499
	value = ((uint32_t)(input[60] & 0x0f) << 28) |
			((uint32_t)input[61] << 20) |
			((uint32_t)(input[62] & 0xf0) << 12);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 500 to 515
	value = ((uint32_t)(input[62] & 0x0f) << 28) |
			((uint32_t)input[63] << 20) |
			((uint32_t)(input[64] & 0xf0) << 12);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 516 to 531
	value = ((uint32_t)(input[64] & 0x0f) << 28) |
			((uint32_t)input[65] << 20) |
			((uint32_t)(input[66] & 0xf0) << 12);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 532 to 547
	value = ((uint32_t)(input[66] & 0x0f) << 28) |
			((uint32_t)input[67] << 20) |
			((uint32_t)(input[68] & 0xf0) << 12);
	output[33] = (double)(value >> 16);
}

static void unpack_34_16bit_signed_5off(const uint8_t * input, double * output, void *closure) {
	// Unpack 34 values into output
	// Values are 16-bit signed
	// Skip 5 bits, read 544 bits of data.
	// Input must be at least 69 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 5 to 20
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)(input[2] & 0xf8) << 13);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 21 to 36
	value = ((uint32_t)(input[2] & 0x07) << 29) |
			((uint32_t)input[3] << 21) |
			((uint32_t)(input[4] & 0xf8) << 13);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 37 to 52
	value = ((uint32_t)(input[4] & 0x07) << 29) |
			((uint32_t)input[5] << 21) |
			((uint32_t)(input[6] & 0xf8) << 13);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 53 to 68
	value = ((uint32_t)(input[6] & 0x07) << 29) |
			((uint32_t)input[7] << 21) |
			((uint32_t)(input[8] & 0xf8) << 13);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 69 to 84
	value = ((uint32_t)(input[8] & 0x07) << 29) |
			((uint32_t)input[9] << 21) |
			((uint32_t)(input[10] & 0xf8) << 13);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 85 to 100
	value = ((uint32_t)(input[10] & 0x07) << 29) |
			((uint32_t)input[11] << 21) |
			((uint32_t)(input[12] & 0xf8) << 13);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 101 to 116
	value = ((uint32_t)(input[12] & 0x07) << 29) |
			((uint32_t)input[13] << 21) |
			((uint32_t)(input[14] & 0xf8) << 13);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 117 to 132
	value = ((uint32_t)(input[14] & 0x07) << 29) |
			((uint32_t)input[15] << 21) |
			((uint32_t)(input[16] & 0xf8) << 13);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 133 to 148
	value = ((uint32_t)(input[16] & 0x07) << 29) |
			((uint32_t)input[17] << 21) |
			((uint32_t)(input[18] & 0xf8) << 13);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 149 to 164
	value = ((uint32_t)(input[18] & 0x07) << 29) |
			((uint32_t)input[19] << 21) |
			((uint32_t)(input[20] & 0xf8) << 13);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 165 to 180
	value = ((uint32_t)(input[20] & 0x07) << 29) |
			((uint32_t)input[21] << 21) |
			((uint32_t)(input[22] & 0xf8) << 13);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 181 to 196
	value = ((uint32_t)(input[22] & 0x07) << 29) |
			((uint32_t)input[23] << 21) |
			((uint32_t)(input[24] & 0xf8) << 13);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 197 to 212
	value = ((uint32_t)(input[24] & 0x07) << 29) |
			((uint32_t)input[25] << 21) |
			((uint32_t)(input[26] & 0xf8) << 13);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 213 to 228
	value = ((uint32_t)(input[26] & 0x07) << 29) |
			((uint32_t)input[27] << 21) |
			((uint32_t)(input[28] & 0xf8) << 13);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 229 to 244
	value = ((uint32_t)(input[28] & 0x07) << 29) |
			((uint32_t)input[29] << 21) |
			((uint32_t)(input[30] & 0xf8) << 13);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 245 to 260
	value = ((uint32_t)(input[30] & 0x07) << 29) |
			((uint32_t)input[31] << 21) |
			((uint32_t)(input[32] & 0xf8) << 13);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 261 to 276
	value = ((uint32_t)(input[32] & 0x07) << 29) |
			((uint32_t)input[33] << 21) |
			((uint32_t)(input[34] & 0xf8) << 13);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 277 to 292
	value = ((uint32_t)(input[34] & 0x07) << 29) |
			((uint32_t)input[35] << 21) |
			((uint32_t)(input[36] & 0xf8) << 13);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 293 to 308
	value = ((uint32_t)(input[36] & 0x07) << 29) |
			((uint32_t)input[37] << 21) |
			((uint32_t)(input[38] & 0xf8) << 13);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 309 to 324
	value = ((uint32_t)(input[38] & 0x07) << 29) |
			((uint32_t)input[39] << 21) |
			((uint32_t)(input[40] & 0xf8) << 13);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 325 to 340
	value = ((uint32_t)(input[40] & 0x07) << 29) |
			((uint32_t)input[41] << 21) |
			((uint32_t)(input[42] & 0xf8) << 13);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 341 to 356
	value = ((uint32_t)(input[42] & 0x07) << 29) |
			((uint32_t)input[43] << 21) |
			((uint32_t)(input[44] & 0xf8) << 13);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 357 to 372
	value = ((uint32_t)(input[44] & 0x07) << 29) |
			((uint32_t)input[45] << 21) |
			((uint32_t)(input[46] & 0xf8) << 13);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 373 to 388
	value = ((uint32_t)(input[46] & 0x07) << 29) |
			((uint32_t)input[47] << 21) |
			((uint32_t)(input[48] & 0xf8) << 13);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 389 to 404
	value = ((uint32_t)(input[48] & 0x07) << 29) |
			((uint32_t)input[49] << 21) |
			((uint32_t)(input[50] & 0xf8) << 13);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 405 to 420
	value = ((uint32_t)(input[50] & 0x07) << 29) |
			((uint32_t)input[51] << 21) |
			((uint32_t)(input[52] & 0xf8) << 13);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 421 to 436
	value = ((uint32_t)(input[52] & 0x07) << 29) |
			((uint32_t)input[53] << 21) |
			((uint32_t)(input[54] & 0xf8) << 13);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 437 to 452
	value = ((uint32_t)(input[54] & 0x07) << 29) |
			((uint32_t)input[55] << 21) |
			((uint32_t)(input[56] & 0xf8) << 13);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 453 to 468
	value = ((uint32_t)(input[56] & 0x07) << 29) |
			((uint32_t)input[57] << 21) |
			((uint32_t)(input[58] & 0xf8) << 13);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 469 to 484
	value = ((uint32_t)(input[58] & 0x07) << 29) |
			((uint32_t)input[59] << 21) |
			((uint32_t)(input[60] & 0xf8) << 13);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 485 to 500
	value = ((uint32_t)(input[60] & 0x07) << 29) |
			((uint32_t)input[61] << 21) |
			((uint32_t)(input[62] & 0xf8) << 13);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 501 to 516
	value = ((uint32_t)(input[62] & 0x07) << 29) |
			((uint32_t)input[63] << 21) |
			((uint32_t)(input[64] & 0xf8) << 13);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 517 to 532
	value = ((uint32_t)(input[64] & 0x07) << 29) |
			((uint32_t)input[65] << 21) |
			((uint32_t)(input[66] & 0xf8) << 13);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 533 to 548
	value = ((uint32_t)(input[66] & 0x07) << 29) |
			((uint32_t)input[67] << 21) |
			((uint32_t)(input[68] & 0xf8) << 13);
	output[33] = (double)(value >> 16);
}

static void unpack_34_16bit_unsigned_5off(const uint8_t * input, double * output, void *closure) {
	// Unpack 34 values into output
	// Values are 16-bit unsigned
	// Skip 5 bits, read 544 bits of data.
	// Input must be at least 69 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 5 to 20
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)(input[2] & 0xf8) << 13);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 21 to 36
	value = ((uint32_t)(input[2] & 0x07) << 29) |
			((uint32_t)input[3] << 21) |
			((uint32_t)(input[4] & 0xf8) << 13);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 37 to 52
	value = ((uint32_t)(input[4] & 0x07) << 29) |
			((uint32_t)input[5] << 21) |
			((uint32_t)(input[6] & 0xf8) << 13);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 53 to 68
	value = ((uint32_t)(input[6] & 0x07) << 29) |
			((uint32_t)input[7] << 21) |
			((uint32_t)(input[8] & 0xf8) << 13);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 69 to 84
	value = ((uint32_t)(input[8] & 0x07) << 29) |
			((uint32_t)input[9] << 21) |
			((uint32_t)(input[10] & 0xf8) << 13);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 85 to 100
	value = ((uint32_t)(input[10] & 0x07) << 29) |
			((uint32_t)input[11] << 21) |
			((uint32_t)(input[12] & 0xf8) << 13);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 101 to 116
	value = ((uint32_t)(input[12] & 0x07) << 29) |
			((uint32_t)input[13] << 21) |
			((uint32_t)(input[14] & 0xf8) << 13);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 117 to 132
	value = ((uint32_t)(input[14] & 0x07) << 29) |
			((uint32_t)input[15] << 21) |
			((uint32_t)(input[16] & 0xf8) << 13);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 133 to 148
	value = ((uint32_t)(input[16] & 0x07) << 29) |
			((uint32_t)input[17] << 21) |
			((uint32_t)(input[18] & 0xf8) << 13);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 149 to 164
	value = ((uint32_t)(input[18] & 0x07) << 29) |
			((uint32_t)input[19] << 21) |
			((uint32_t)(input[20] & 0xf8) << 13);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 165 to 180
	value = ((uint32_t)(input[20] & 0x07) << 29) |
			((uint32_t)input[21] << 21) |
			((uint32_t)(input[22] & 0xf8) << 13);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 181 to 196
	value = ((uint32_t)(input[22] & 0x07) << 29) |
			((uint32_t)input[23] << 21) |
			((uint32_t)(input[24] & 0xf8) << 13);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 197 to 212
	value = ((uint32_t)(input[24] & 0x07) << 29) |
			((uint32_t)input[25] << 21) |
			((uint32_t)(input[26] & 0xf8) << 13);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 213 to 228
	value = ((uint32_t)(input[26] & 0x07) << 29) |
			((uint32_t)input[27] << 21) |
			((uint32_t)(input[28] & 0xf8) << 13);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 229 to 244
	value = ((uint32_t)(input[28] & 0x07) << 29) |
			((uint32_t)input[29] << 21) |
			((uint32_t)(input[30] & 0xf8) << 13);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 245 to 260
	value = ((uint32_t)(input[30] & 0x07) << 29) |
			((uint32_t)input[31] << 21) |
			((uint32_t)(input[32] & 0xf8) << 13);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 261 to 276
	value = ((uint32_t)(input[32] & 0x07) << 29) |
			((uint32_t)input[33] << 21) |
			((uint32_t)(input[34] & 0xf8) << 13);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 277 to 292
	value = ((uint32_t)(input[34] & 0x07) << 29) |
			((uint32_t)input[35] << 21) |
			((uint32_t)(input[36] & 0xf8) << 13);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 293 to 308
	value = ((uint32_t)(input[36] & 0x07) << 29) |
			((uint32_t)input[37] << 21) |
			((uint32_t)(input[38] & 0xf8) << 13);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 309 to 324
	value = ((uint32_t)(input[38] & 0x07) << 29) |
			((uint32_t)input[39] << 21) |
			((uint32_t)(input[40] & 0xf8) << 13);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 325 to 340
	value = ((uint32_t)(input[40] & 0x07) << 29) |
			((uint32_t)input[41] << 21) |
			((uint32_t)(input[42] & 0xf8) << 13);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 341 to 356
	value = ((uint32_t)(input[42] & 0x07) << 29) |
			((uint32_t)input[43] << 21) |
			((uint32_t)(input[44] & 0xf8) << 13);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 357 to 372
	value = ((uint32_t)(input[44] & 0x07) << 29) |
			((uint32_t)input[45] << 21) |
			((uint32_t)(input[46] & 0xf8) << 13);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 373 to 388
	value = ((uint32_t)(input[46] & 0x07) << 29) |
			((uint32_t)input[47] << 21) |
			((uint32_t)(input[48] & 0xf8) << 13);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 389 to 404
	value = ((uint32_t)(input[48] & 0x07) << 29) |
			((uint32_t)input[49] << 21) |
			((uint32_t)(input[50] & 0xf8) << 13);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 405 to 420
	value = ((uint32_t)(input[50] & 0x07) << 29) |
			((uint32_t)input[51] << 21) |
			((uint32_t)(input[52] & 0xf8) << 13);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 421 to 436
	value = ((uint32_t)(input[52] & 0x07) << 29) |
			((uint32_t)input[53] << 21) |
			((uint32_t)(input[54] & 0xf8) << 13);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 437 to 452
	value = ((uint32_t)(input[54] & 0x07) << 29) |
			((uint32_t)input[55] << 21) |
			((uint32_t)(input[56] & 0xf8) << 13);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 453 to 468
	value = ((uint32_t)(input[56] & 0x07) << 29) |
			((uint32_t)input[57] << 21) |
			((uint32_t)(input[58] & 0xf8) << 13);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 469 to 484
	value = ((uint32_t)(input[58] & 0x07) << 29) |
			((uint32_t)input[59] << 21) |
			((uint32_t)(input[60] & 0xf8) << 13);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 485 to 500
	value = ((uint32_t)(input[60] & 0x07) << 29) |
			((uint32_t)input[61] << 21) |
			((uint32_t)(input[62] & 0xf8) << 13);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 501 to 516
	value = ((uint32_t)(input[62] & 0x07) << 29) |
			((uint32_t)input[63] << 21) |
			((uint32_t)(input[64] & 0xf8) << 13);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 517 to 532
	value = ((uint32_t)(input[64] & 0x07) << 29) |
			((uint32_t)input[65] << 21) |
			((uint32_t)(input[66] & 0xf8) << 13);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 533 to 548
	value = ((uint32_t)(input[66] & 0x07) << 29) |
			((uint32_t)input[67] << 21) |
			((uint32_t)(input[68] & 0xf8) << 13);
	output[33] = (double)(value >> 16);
}

static void unpack_34_16bit_signed_6off(const uint8_t * input, double * output, void *closure) {
	// Unpack 34 values into output
	// Values are 16-bit signed
	// Skip 6 bits, read 544 bits of data.
	// Input must be at least 69 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 6 to 21
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)(input[2] & 0xfc) << 14);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 22 to 37
	value = ((uint32_t)(input[2] & 0x03) << 30) |
			((uint32_t)input[3] << 22) |
			((uint32_t)(input[4] & 0xfc) << 14);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 38 to 53
	value = ((uint32_t)(input[4] & 0x03) << 30) |
			((uint32_t)input[5] << 22) |
			((uint32_t)(input[6] & 0xfc) << 14);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 54 to 69
	value = ((uint32_t)(input[6] & 0x03) << 30) |
			((uint32_t)input[7] << 22) |
			((uint32_t)(input[8] & 0xfc) << 14);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 70 to 85
	value = ((uint32_t)(input[8] & 0x03) << 30) |
			((uint32_t)input[9] << 22) |
			((uint32_t)(input[10] & 0xfc) << 14);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 86 to 101
	value = ((uint32_t)(input[10] & 0x03) << 30) |
			((uint32_t)input[11] << 22) |
			((uint32_t)(input[12] & 0xfc) << 14);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 102 to 117
	value = ((uint32_t)(input[12] & 0x03) << 30) |
			((uint32_t)input[13] << 22) |
			((uint32_t)(input[14] & 0xfc) << 14);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 118 to 133
	value = ((uint32_t)(input[14] & 0x03) << 30) |
			((uint32_t)input[15] << 22) |
			((uint32_t)(input[16] & 0xfc) << 14);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 134 to 149
	value = ((uint32_t)(input[16] & 0x03) << 30) |
			((uint32_t)input[17] << 22) |
			((uint32_t)(input[18] & 0xfc) << 14);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 150 to 165
	value = ((uint32_t)(input[18] & 0x03) << 30) |
			((uint32_t)input[19] << 22) |
			((uint32_t)(input[20] & 0xfc) << 14);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 166 to 181
	value = ((uint32_t)(input[20] & 0x03) << 30) |
			((uint32_t)input[21] << 22) |
			((uint32_t)(input[22] & 0xfc) << 14);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 182 to 197
	value = ((uint32_t)(input[22] & 0x03) << 30) |
			((uint32_t)input[23] << 22) |
			((uint32_t)(input[24] & 0xfc) << 14);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 198 to 213
	value = ((uint32_t)(input[24] & 0x03) << 30) |
			((uint32_t)input[25] << 22) |
			((uint32_t)(input[26] & 0xfc) << 14);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 214 to 229
	value = ((uint32_t)(input[26] & 0x03) << 30) |
			((uint32_t)input[27] << 22) |
			((uint32_t)(input[28] & 0xfc) << 14);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 230 to 245
	value = ((uint32_t)(input[28] & 0x03) << 30) |
			((uint32_t)input[29] << 22) |
			((uint32_t)(input[30] & 0xfc) << 14);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 246 to 261
	value = ((uint32_t)(input[30] & 0x03) << 30) |
			((uint32_t)input[31] << 22) |
			((uint32_t)(input[32] & 0xfc) << 14);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 262 to 277
	value = ((uint32_t)(input[32] & 0x03) << 30) |
			((uint32_t)input[33] << 22) |
			((uint32_t)(input[34] & 0xfc) << 14);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 278 to 293
	value = ((uint32_t)(input[34] & 0x03) << 30) |
			((uint32_t)input[35] << 22) |
			((uint32_t)(input[36] & 0xfc) << 14);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 294 to 309
	value = ((uint32_t)(input[36] & 0x03) << 30) |
			((uint32_t)input[37] << 22) |
			((uint32_t)(input[38] & 0xfc) << 14);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 310 to 325
	value = ((uint32_t)(input[38] & 0x03) << 30) |
			((uint32_t)input[39] << 22) |
			((uint32_t)(input[40] & 0xfc) << 14);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 326 to 341
	value = ((uint32_t)(input[40] & 0x03) << 30) |
			((uint32_t)input[41] << 22) |
			((uint32_t)(input[42] & 0xfc) << 14);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 342 to 357
	value = ((uint32_t)(input[42] & 0x03) << 30) |
			((uint32_t)input[43] << 22) |
			((uint32_t)(input[44] & 0xfc) << 14);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 358 to 373
	value = ((uint32_t)(input[44] & 0x03) << 30) |
			((uint32_t)input[45] << 22) |
			((uint32_t)(input[46] & 0xfc) << 14);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 374 to 389
	value = ((uint32_t)(input[46] & 0x03) << 30) |
			((uint32_t)input[47] << 22) |
			((uint32_t)(input[48] & 0xfc) << 14);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 390 to 405
	value = ((uint32_t)(input[48] & 0x03) << 30) |
			((uint32_t)input[49] << 22) |
			((uint32_t)(input[50] & 0xfc) << 14);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 406 to 421
	value = ((uint32_t)(input[50] & 0x03) << 30) |
			((uint32_t)input[51] << 22) |
			((uint32_t)(input[52] & 0xfc) << 14);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 422 to 437
	value = ((uint32_t)(input[52] & 0x03) << 30) |
			((uint32_t)input[53] << 22) |
			((uint32_t)(input[54] & 0xfc) << 14);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 438 to 453
	value = ((uint32_t)(input[54] & 0x03) << 30) |
			((uint32_t)input[55] << 22) |
			((uint32_t)(input[56] & 0xfc) << 14);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 454 to 469
	value = ((uint32_t)(input[56] & 0x03) << 30) |
			((uint32_t)input[57] << 22) |
			((uint32_t)(input[58] & 0xfc) << 14);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 470 to 485
	value = ((uint32_t)(input[58] & 0x03) << 30) |
			((uint32_t)input[59] << 22) |
			((uint32_t)(input[60] & 0xfc) << 14);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 486 to 501
	value = ((uint32_t)(input[60] & 0x03) << 30) |
			((uint32_t)input[61] << 22) |
			((uint32_t)(input[62] & 0xfc) << 14);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 502 to 517
	value = ((uint32_t)(input[62] & 0x03) << 30) |
			((uint32_t)input[63] << 22) |
			((uint32_t)(input[64] & 0xfc) << 14);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 518 to 533
	value = ((uint32_t)(input[64] & 0x03) << 30) |
			((uint32_t)input[65] << 22) |
			((uint32_t)(input[66] & 0xfc) << 14);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 534 to 549
	value = ((uint32_t)(input[66] & 0x03) << 30) |
			((uint32_t)input[67] << 22) |
			((uint32_t)(input[68] & 0xfc) << 14);
	output[33] = (double)(value >> 16);
}

static void unpack_34_16bit_unsigned_6off(const uint8_t * input, double * output, void *closure) {
	// Unpack 34 values into output
	// Values are 16-bit unsigned
	// Skip 6 bits, read 544 bits of data.
	// Input must be at least 69 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 6 to 21
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)(input[2] & 0xfc) << 14);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 22 to 37
	value = ((uint32_t)(input[2] & 0x03) << 30) |
			((uint32_t)input[3] << 22) |
			((uint32_t)(input[4] & 0xfc) << 14);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 38 to 53
	value = ((uint32_t)(input[4] & 0x03) << 30) |
			((uint32_t)input[5] << 22) |
			((uint32_t)(input[6] & 0xfc) << 14);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 54 to 69
	value = ((uint32_t)(input[6] & 0x03) << 30) |
			((uint32_t)input[7] << 22) |
			((uint32_t)(input[8] & 0xfc) << 14);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 70 to 85
	value = ((uint32_t)(input[8] & 0x03) << 30) |
			((uint32_t)input[9] << 22) |
			((uint32_t)(input[10] & 0xfc) << 14);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 86 to 101
	value = ((uint32_t)(input[10] & 0x03) << 30) |
			((uint32_t)input[11] << 22) |
			((uint32_t)(input[12] & 0xfc) << 14);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 102 to 117
	value = ((uint32_t)(input[12] & 0x03) << 30) |
			((uint32_t)input[13] << 22) |
			((uint32_t)(input[14] & 0xfc) << 14);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 118 to 133
	value = ((uint32_t)(input[14] & 0x03) << 30) |
			((uint32_t)input[15] << 22) |
			((uint32_t)(input[16] & 0xfc) << 14);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 134 to 149
	value = ((uint32_t)(input[16] & 0x03) << 30) |
			((uint32_t)input[17] << 22) |
			((uint32_t)(input[18] & 0xfc) << 14);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 150 to 165
	value = ((uint32_t)(input[18] & 0x03) << 30) |
			((uint32_t)input[19] << 22) |
			((uint32_t)(input[20] & 0xfc) << 14);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 166 to 181
	value = ((uint32_t)(input[20] & 0x03) << 30) |
			((uint32_t)input[21] << 22) |
			((uint32_t)(input[22] & 0xfc) << 14);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 182 to 197
	value = ((uint32_t)(input[22] & 0x03) << 30) |
			((uint32_t)input[23] << 22) |
			((uint32_t)(input[24] & 0xfc) << 14);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 198 to 213
	value = ((uint32_t)(input[24] & 0x03) << 30) |
			((uint32_t)input[25] << 22) |
			((uint32_t)(input[26] & 0xfc) << 14);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 214 to 229
	value = ((uint32_t)(input[26] & 0x03) << 30) |
			((uint32_t)input[27] << 22) |
			((uint32_t)(input[28] & 0xfc) << 14);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 230 to 245
	value = ((uint32_t)(input[28] & 0x03) << 30) |
			((uint32_t)input[29] << 22) |
			((uint32_t)(input[30] & 0xfc) << 14);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 246 to 261
	value = ((uint32_t)(input[30] & 0x03) << 30) |
			((uint32_t)input[31] << 22) |
			((uint32_t)(input[32] & 0xfc) << 14);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 262 to 277
	value = ((uint32_t)(input[32] & 0x03) << 30) |
			((uint32_t)input[33] << 22) |
			((uint32_t)(input[34] & 0xfc) << 14);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 278 to 293
	value = ((uint32_t)(input[34] & 0x03) << 30) |
			((uint32_t)input[35] << 22) |
			((uint32_t)(input[36] & 0xfc) << 14);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 294 to 309
	value = ((uint32_t)(input[36] & 0x03) << 30) |
			((uint32_t)input[37] << 22) |
			((uint32_t)(input[38] & 0xfc) << 14);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 310 to 325
	value = ((uint32_t)(input[38] & 0x03) << 30) |
			((uint32_t)input[39] << 22) |
			((uint32_t)(input[40] & 0xfc) << 14);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 326 to 341
	value = ((uint32_t)(input[40] & 0x03) << 30) |
			((uint32_t)input[41] << 22) |
			((uint32_t)(input[42] & 0xfc) << 14);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 342 to 357
	value = ((uint32_t)(input[42] & 0x03) << 30) |
			((uint32_t)input[43] << 22) |
			((uint32_t)(input[44] & 0xfc) << 14);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 358 to 373
	value = ((uint32_t)(input[44] & 0x03) << 30) |
			((uint32_t)input[45] << 22) |
			((uint32_t)(input[46] & 0xfc) << 14);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 374 to 389
	value = ((uint32_t)(input[46] & 0x03) << 30) |
			((uint32_t)input[47] << 22) |
			((uint32_t)(input[48] & 0xfc) << 14);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 390 to 405
	value = ((uint32_t)(input[48] & 0x03) << 30) |
			((uint32_t)input[49] << 22) |
			((uint32_t)(input[50] & 0xfc) << 14);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 406 to 421
	value = ((uint32_t)(input[50] & 0x03) << 30) |
			((uint32_t)input[51] << 22) |
			((uint32_t)(input[52] & 0xfc) << 14);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 422 to 437
	value = ((uint32_t)(input[52] & 0x03) << 30) |
			((uint32_t)input[53] << 22) |
			((uint32_t)(input[54] & 0xfc) << 14);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 438 to 453
	value = ((uint32_t)(input[54] & 0x03) << 30) |
			((uint32_t)input[55] << 22) |
			((uint32_t)(input[56] & 0xfc) << 14);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 454 to 469
	value = ((uint32_t)(input[56] & 0x03) << 30) |
			((uint32_t)input[57] << 22) |
			((uint32_t)(input[58] & 0xfc) << 14);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 470 to 485
	value = ((uint32_t)(input[58] & 0x03) << 30) |
			((uint32_t)input[59] << 22) |
			((uint32_t)(input[60] & 0xfc) << 14);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 486 to 501
	value = ((uint32_t)(input[60] & 0x03) << 30) |
			((uint32_t)input[61] << 22) |
			((uint32_t)(input[62] & 0xfc) << 14);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 502 to 517
	value = ((uint32_t)(input[62] & 0x03) << 30) |
			((uint32_t)input[63] << 22) |
			((uint32_t)(input[64] & 0xfc) << 14);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 518 to 533
	value = ((uint32_t)(input[64] & 0x03) << 30) |
			((uint32_t)input[65] << 22) |
			((uint32_t)(input[66] & 0xfc) << 14);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 534 to 549
	value = ((uint32_t)(input[66] & 0x03) << 30) |
			((uint32_t)input[67] << 22) |
			((uint32_t)(input[68] & 0xfc) << 14);
	output[33] = (double)(value >> 16);
}

static void unpack_34_16bit_signed_7off(const uint8_t * input, double * output, void *closure) {
	// Unpack 34 values into output
	// Values are 16-bit signed
	// Skip 7 bits, read 544 bits of data.
	// Input must be at least 69 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 7 to 22
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)(input[2] & 0xfe) << 15);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 23 to 38
	value = ((uint32_t)(input[2] & 0x01) << 31) |
			((uint32_t)input[3] << 23) |
			((uint32_t)(input[4] & 0xfe) << 15);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 39 to 54
	value = ((uint32_t)(input[4] & 0x01) << 31) |
			((uint32_t)input[5] << 23) |
			((uint32_t)(input[6] & 0xfe) << 15);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 55 to 70
	value = ((uint32_t)(input[6] & 0x01) << 31) |
			((uint32_t)input[7] << 23) |
			((uint32_t)(input[8] & 0xfe) << 15);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 71 to 86
	value = ((uint32_t)(input[8] & 0x01) << 31) |
			((uint32_t)input[9] << 23) |
			((uint32_t)(input[10] & 0xfe) << 15);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 87 to 102
	value = ((uint32_t)(input[10] & 0x01) << 31) |
			((uint32_t)input[11] << 23) |
			((uint32_t)(input[12] & 0xfe) << 15);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 103 to 118
	value = ((uint32_t)(input[12] & 0x01) << 31) |
			((uint32_t)input[13] << 23) |
			((uint32_t)(input[14] & 0xfe) << 15);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 119 to 134
	value = ((uint32_t)(input[14] & 0x01) << 31) |
			((uint32_t)input[15] << 23) |
			((uint32_t)(input[16] & 0xfe) << 15);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 135 to 150
	value = ((uint32_t)(input[16] & 0x01) << 31) |
			((uint32_t)input[17] << 23) |
			((uint32_t)(input[18] & 0xfe) << 15);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 151 to 166
	value = ((uint32_t)(input[18] & 0x01) << 31) |
			((uint32_t)input[19] << 23) |
			((uint32_t)(input[20] & 0xfe) << 15);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 167 to 182
	value = ((uint32_t)(input[20] & 0x01) << 31) |
			((uint32_t)input[21] << 23) |
			((uint32_t)(input[22] & 0xfe) << 15);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 183 to 198
	value = ((uint32_t)(input[22] & 0x01) << 31) |
			((uint32_t)input[23] << 23) |
			((uint32_t)(input[24] & 0xfe) << 15);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 199 to 214
	value = ((uint32_t)(input[24] & 0x01) << 31) |
			((uint32_t)input[25] << 23) |
			((uint32_t)(input[26] & 0xfe) << 15);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 215 to 230
	value = ((uint32_t)(input[26] & 0x01) << 31) |
			((uint32_t)input[27] << 23) |
			((uint32_t)(input[28] & 0xfe) << 15);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 231 to 246
	value = ((uint32_t)(input[28] & 0x01) << 31) |
			((uint32_t)input[29] << 23) |
			((uint32_t)(input[30] & 0xfe) << 15);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 247 to 262
	value = ((uint32_t)(input[30] & 0x01) << 31) |
			((uint32_t)input[31] << 23) |
			((uint32_t)(input[32] & 0xfe) << 15);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 263 to 278
	value = ((uint32_t)(input[32] & 0x01) << 31) |
			((uint32_t)input[33] << 23) |
			((uint32_t)(input[34] & 0xfe) << 15);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 279 to 294
	value = ((uint32_t)(input[34] & 0x01) << 31) |
			((uint32_t)input[35] << 23) |
			((uint32_t)(input[36] & 0xfe) << 15);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 295 to 310
	value = ((uint32_t)(input[36] & 0x01) << 31) |
			((uint32_t)input[37] << 23) |
			((uint32_t)(input[38] & 0xfe) << 15);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 311 to 326
	value = ((uint32_t)(input[38] & 0x01) << 31) |
			((uint32_t)input[39] << 23) |
			((uint32_t)(input[40] & 0xfe) << 15);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 327 to 342
	value = ((uint32_t)(input[40] & 0x01) << 31) |
			((uint32_t)input[41] << 23) |
			((uint32_t)(input[42] & 0xfe) << 15);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 343 to 358
	value = ((uint32_t)(input[42] & 0x01) << 31) |
			((uint32_t)input[43] << 23) |
			((uint32_t)(input[44] & 0xfe) << 15);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 359 to 374
	value = ((uint32_t)(input[44] & 0x01) << 31) |
			((uint32_t)input[45] << 23) |
			((uint32_t)(input[46] & 0xfe) << 15);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 375 to 390
	value = ((uint32_t)(input[46] & 0x01) << 31) |
			((uint32_t)input[47] << 23) |
			((uint32_t)(input[48] & 0xfe) << 15);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 391 to 406
	value = ((uint32_t)(input[48] & 0x01) << 31) |
			((uint32_t)input[49] << 23) |
			((uint32_t)(input[50] & 0xfe) << 15);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 407 to 422
	value = ((uint32_t)(input[50] & 0x01) << 31) |
			((uint32_t)input[51] << 23) |
			((uint32_t)(input[52] & 0xfe) << 15);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 423 to 438
	value = ((uint32_t)(input[52] & 0x01) << 31) |
			((uint32_t)input[53] << 23) |
			((uint32_t)(input[54] & 0xfe) << 15);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 439 to 454
	value = ((uint32_t)(input[54] & 0x01) << 31) |
			((uint32_t)input[55] << 23) |
			((uint32_t)(input[56] & 0xfe) << 15);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 455 to 470
	value = ((uint32_t)(input[56] & 0x01) << 31) |
			((uint32_t)input[57] << 23) |
			((uint32_t)(input[58] & 0xfe) << 15);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 471 to 486
	value = ((uint32_t)(input[58] & 0x01) << 31) |
			((uint32_t)input[59] << 23) |
			((uint32_t)(input[60] & 0xfe) << 15);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 487 to 502
	value = ((uint32_t)(input[60] & 0x01) << 31) |
			((uint32_t)input[61] << 23) |
			((uint32_t)(input[62] & 0xfe) << 15);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 503 to 518
	value = ((uint32_t)(input[62] & 0x01) << 31) |
			((uint32_t)input[63] << 23) |
			((uint32_t)(input[64] & 0xfe) << 15);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 519 to 534
	value = ((uint32_t)(input[64] & 0x01) << 31) |
			((uint32_t)input[65] << 23) |
			((uint32_t)(input[66] & 0xfe) << 15);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 535 to 550
	value = ((uint32_t)(input[66] & 0x01) << 31) |
			((uint32_t)input[67] << 23) |
			((uint32_t)(input[68] & 0xfe) << 15);
	output[33] = (double)(value >> 16);
}

static void unpack_34_16bit_unsigned_7off(const uint8_t * input, double * output, void *closure) {
	// Unpack 34 values into output
	// Values are 16-bit unsigned
	// Skip 7 bits, read 544 bits of data.
	// Input must be at least 69 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 7 to 22
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)(input[2] & 0xfe) << 15);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 23 to 38
	value = ((uint32_t)(input[2] & 0x01) << 31) |
			((uint32_t)input[3] << 23) |
			((uint32_t)(input[4] & 0xfe) << 15);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 39 to 54
	value = ((uint32_t)(input[4] & 0x01) << 31) |
			((uint32_t)input[5] << 23) |
			((uint32_t)(input[6] & 0xfe) << 15);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 55 to 70
	value = ((uint32_t)(input[6] & 0x01) << 31) |
			((uint32_t)input[7] << 23) |
			((uint32_t)(input[8] & 0xfe) << 15);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 71 to 86
	value = ((uint32_t)(input[8] & 0x01) << 31) |
			((uint32_t)input[9] << 23) |
			((uint32_t)(input[10] & 0xfe) << 15);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 87 to 102
	value = ((uint32_t)(input[10] & 0x01) << 31) |
			((uint32_t)input[11] << 23) |
			((uint32_t)(input[12] & 0xfe) << 15);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 103 to 118
	value = ((uint32_t)(input[12] & 0x01) << 31) |
			((uint32_t)input[13] << 23) |
			((uint32_t)(input[14] & 0xfe) << 15);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 119 to 134
	value = ((uint32_t)(input[14] & 0x01) << 31) |
			((uint32_t)input[15] << 23) |
			((uint32_t)(input[16] & 0xfe) << 15);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 135 to 150
	value = ((uint32_t)(input[16] & 0x01) << 31) |
			((uint32_t)input[17] << 23) |
			((uint32_t)(input[18] & 0xfe) << 15);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 151 to 166
	value = ((uint32_t)(input[18] & 0x01) << 31) |
			((uint32_t)input[19] << 23) |
			((uint32_t)(input[20] & 0xfe) << 15);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 167 to 182
	value = ((uint32_t)(input[20] & 0x01) << 31) |
			((uint32_t)input[21] << 23) |
			((uint32_t)(input[22] & 0xfe) << 15);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 183 to 198
	value = ((uint32_t)(input[22] & 0x01) << 31) |
			((uint32_t)input[23] << 23) |
			((uint32_t)(input[24] & 0xfe) << 15);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 199 to 214
	value = ((uint32_t)(input[24] & 0x01) << 31) |
			((uint32_t)input[25] << 23) |
			((uint32_t)(input[26] & 0xfe) << 15);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 215 to 230
	value = ((uint32_t)(input[26] & 0x01) << 31) |
			((uint32_t)input[27] << 23) |
			((uint32_t)(input[28] & 0xfe) << 15);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 231 to 246
	value = ((uint32_t)(input[28] & 0x01) << 31) |
			((uint32_t)input[29] << 23) |
			((uint32_t)(input[30] & 0xfe) << 15);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 247 to 262
	value = ((uint32_t)(input[30] & 0x01) << 31) |
			((uint32_t)input[31] << 23) |
			((uint32_t)(input[32] & 0xfe) << 15);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 263 to 278
	value = ((uint32_t)(input[32] & 0x01) << 31) |
			((uint32_t)input[33] << 23) |
			((uint32_t)(input[34] & 0xfe) << 15);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 279 to 294
	value = ((uint32_t)(input[34] & 0x01) << 31) |
			((uint32_t)input[35] << 23) |
			((uint32_t)(input[36] & 0xfe) << 15);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 295 to 310
	value = ((uint32_t)(input[36] & 0x01) << 31) |
			((uint32_t)input[37] << 23) |
			((uint32_t)(input[38] & 0xfe) << 15);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 311 to 326
	value = ((uint32_t)(input[38] & 0x01) << 31) |
			((uint32_t)input[39] << 23) |
			((uint32_t)(input[40] & 0xfe) << 15);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 327 to 342
	value = ((uint32_t)(input[40] & 0x01) << 31) |
			((uint32_t)input[41] << 23) |
			((uint32_t)(input[42] & 0xfe) << 15);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 343 to 358
	value = ((uint32_t)(input[42] & 0x01) << 31) |
			((uint32_t)input[43] << 23) |
			((uint32_t)(input[44] & 0xfe) << 15);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 359 to 374
	value = ((uint32_t)(input[44] & 0x01) << 31) |
			((uint32_t)input[45] << 23) |
			((uint32_t)(input[46] & 0xfe) << 15);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 375 to 390
	value = ((uint32_t)(input[46] & 0x01) << 31) |
			((uint32_t)input[47] << 23) |
			((uint32_t)(input[48] & 0xfe) << 15);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 391 to 406
	value = ((uint32_t)(input[48] & 0x01) << 31) |
			((uint32_t)input[49] << 23) |
			((uint32_t)(input[50] & 0xfe) << 15);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 407 to 422
	value = ((uint32_t)(input[50] & 0x01) << 31) |
			((uint32_t)input[51] << 23) |
			((uint32_t)(input[52] & 0xfe) << 15);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 423 to 438
	value = ((uint32_t)(input[52] & 0x01) << 31) |
			((uint32_t)input[53] << 23) |
			((uint32_t)(input[54] & 0xfe) << 15);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 439 to 454
	value = ((uint32_t)(input[54] & 0x01) << 31) |
			((uint32_t)input[55] << 23) |
			((uint32_t)(input[56] & 0xfe) << 15);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 455 to 470
	value = ((uint32_t)(input[56] & 0x01) << 31) |
			((uint32_t)input[57] << 23) |
			((uint32_t)(input[58] & 0xfe) << 15);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 471 to 486
	value = ((uint32_t)(input[58] & 0x01) << 31) |
			((uint32_t)input[59] << 23) |
			((uint32_t)(input[60] & 0xfe) << 15);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 487 to 502
	value = ((uint32_t)(input[60] & 0x01) << 31) |
			((uint32_t)input[61] << 23) |
			((uint32_t)(input[62] & 0xfe) << 15);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 503 to 518
	value = ((uint32_t)(input[62] & 0x01) << 31) |
			((uint32_t)input[63] << 23) |
			((uint32_t)(input[64] & 0xfe) << 15);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 519 to 534
	value = ((uint32_t)(input[64] & 0x01) << 31) |
			((uint32_t)input[65] << 23) |
			((uint32_t)(input[66] & 0xfe) << 15);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 535 to 550
	value = ((uint32_t)(input[66] & 0x01) << 31) |
			((uint32_t)input[67] << 23) |
			((uint32_t)(input[68] & 0xfe) << 15);
	output[33] = (double)(value >> 16);
}

static void unpack_35_16bit_signed_0off(const uint8_t * input, double * output, void *closure) {
	// Unpack 35 values into output
	// Values are 16-bit signed
	// Skip 0 bits, read 560 bits of data.
	// Input must be at least 70 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 0 to 15
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)input[1] << 16);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 16 to 31
	value = ((uint32_t)input[2] << 24) |
			((uint32_t)input[3] << 16);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 32 to 47
	value = ((uint32_t)input[4] << 24) |
			((uint32_t)input[5] << 16);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 48 to 63
	value = ((uint32_t)input[6] << 24) |
			((uint32_t)input[7] << 16);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 64 to 79
	value = ((uint32_t)input[8] << 24) |
			((uint32_t)input[9] << 16);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 80 to 95
	value = ((uint32_t)input[10] << 24) |
			((uint32_t)input[11] << 16);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 96 to 111
	value = ((uint32_t)input[12] << 24) |
			((uint32_t)input[13] << 16);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 112 to 127
	value = ((uint32_t)input[14] << 24) |
			((uint32_t)input[15] << 16);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 128 to 143
	value = ((uint32_t)input[16] << 24) |
			((uint32_t)input[17] << 16);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 144 to 159
	value = ((uint32_t)input[18] << 24) |
			((uint32_t)input[19] << 16);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 160 to 175
	value = ((uint32_t)input[20] << 24) |
			((uint32_t)input[21] << 16);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 176 to 191
	value = ((uint32_t)input[22] << 24) |
			((uint32_t)input[23] << 16);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 192 to 207
	value = ((uint32_t)input[24] << 24) |
			((uint32_t)input[25] << 16);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 208 to 223
	value = ((uint32_t)input[26] << 24) |
			((uint32_t)input[27] << 16);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 224 to 239
	value = ((uint32_t)input[28] << 24) |
			((uint32_t)input[29] << 16);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 240 to 255
	value = ((uint32_t)input[30] << 24) |
			((uint32_t)input[31] << 16);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 256 to 271
	value = ((uint32_t)input[32] << 24) |
			((uint32_t)input[33] << 16);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 272 to 287
	value = ((uint32_t)input[34] << 24) |
			((uint32_t)input[35] << 16);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 288 to 303
	value = ((uint32_t)input[36] << 24) |
			((uint32_t)input[37] << 16);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 304 to 319
	value = ((uint32_t)input[38] << 24) |
			((uint32_t)input[39] << 16);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 320 to 335
	value = ((uint32_t)input[40] << 24) |
			((uint32_t)input[41] << 16);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 336 to 351
	value = ((uint32_t)input[42] << 24) |
			((uint32_t)input[43] << 16);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 352 to 367
	value = ((uint32_t)input[44] << 24) |
			((uint32_t)input[45] << 16);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 368 to 383
	value = ((uint32_t)input[46] << 24) |
			((uint32_t)input[47] << 16);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 384 to 399
	value = ((uint32_t)input[48] << 24) |
			((uint32_t)input[49] << 16);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 400 to 415
	value = ((uint32_t)input[50] << 24) |
			((uint32_t)input[51] << 16);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 416 to 431
	value = ((uint32_t)input[52] << 24) |
			((uint32_t)input[53] << 16);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 432 to 447
	value = ((uint32_t)input[54] << 24) |
			((uint32_t)input[55] << 16);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 448 to 463
	value = ((uint32_t)input[56] << 24) |
			((uint32_t)input[57] << 16);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 464 to 479
	value = ((uint32_t)input[58] << 24) |
			((uint32_t)input[59] << 16);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 480 to 495
	value = ((uint32_t)input[60] << 24) |
			((uint32_t)input[61] << 16);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 496 to 511
	value = ((uint32_t)input[62] << 24) |
			((uint32_t)input[63] << 16);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 512 to 527
	value = ((uint32_t)input[64] << 24) |
			((uint32_t)input[65] << 16);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 528 to 543
	value = ((uint32_t)input[66] << 24) |
			((uint32_t)input[67] << 16);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 544 to 559
	value = ((uint32_t)input[68] << 24) |
			((uint32_t)input[69] << 16);
	output[34] = (double)(value >> 16);
}

static void unpack_35_16bit_unsigned_0off(const uint8_t * input, double * output, void *closure) {
	// Unpack 35 values into output
	// Values are 16-bit unsigned
	// Skip 0 bits, read 560 bits of data.
	// Input must be at least 70 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 0 to 15
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)input[1] << 16);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 16 to 31
	value = ((uint32_t)input[2] << 24) |
			((uint32_t)input[3] << 16);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 32 to 47
	value = ((uint32_t)input[4] << 24) |
			((uint32_t)input[5] << 16);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 48 to 63
	value = ((uint32_t)input[6] << 24) |
			((uint32_t)input[7] << 16);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 64 to 79
	value = ((uint32_t)input[8] << 24) |
			((uint32_t)input[9] << 16);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 80 to 95
	value = ((uint32_t)input[10] << 24) |
			((uint32_t)input[11] << 16);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 96 to 111
	value = ((uint32_t)input[12] << 24) |
			((uint32_t)input[13] << 16);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 112 to 127
	value = ((uint32_t)input[14] << 24) |
			((uint32_t)input[15] << 16);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 128 to 143
	value = ((uint32_t)input[16] << 24) |
			((uint32_t)input[17] << 16);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 144 to 159
	value = ((uint32_t)input[18] << 24) |
			((uint32_t)input[19] << 16);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 160 to 175
	value = ((uint32_t)input[20] << 24) |
			((uint32_t)input[21] << 16);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 176 to 191
	value = ((uint32_t)input[22] << 24) |
			((uint32_t)input[23] << 16);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 192 to 207
	value = ((uint32_t)input[24] << 24) |
			((uint32_t)input[25] << 16);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 208 to 223
	value = ((uint32_t)input[26] << 24) |
			((uint32_t)input[27] << 16);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 224 to 239
	value = ((uint32_t)input[28] << 24) |
			((uint32_t)input[29] << 16);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 240 to 255
	value = ((uint32_t)input[30] << 24) |
			((uint32_t)input[31] << 16);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 256 to 271
	value = ((uint32_t)input[32] << 24) |
			((uint32_t)input[33] << 16);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 272 to 287
	value = ((uint32_t)input[34] << 24) |
			((uint32_t)input[35] << 16);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 288 to 303
	value = ((uint32_t)input[36] << 24) |
			((uint32_t)input[37] << 16);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 304 to 319
	value = ((uint32_t)input[38] << 24) |
			((uint32_t)input[39] << 16);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 320 to 335
	value = ((uint32_t)input[40] << 24) |
			((uint32_t)input[41] << 16);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 336 to 351
	value = ((uint32_t)input[42] << 24) |
			((uint32_t)input[43] << 16);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 352 to 367
	value = ((uint32_t)input[44] << 24) |
			((uint32_t)input[45] << 16);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 368 to 383
	value = ((uint32_t)input[46] << 24) |
			((uint32_t)input[47] << 16);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 384 to 399
	value = ((uint32_t)input[48] << 24) |
			((uint32_t)input[49] << 16);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 400 to 415
	value = ((uint32_t)input[50] << 24) |
			((uint32_t)input[51] << 16);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 416 to 431
	value = ((uint32_t)input[52] << 24) |
			((uint32_t)input[53] << 16);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 432 to 447
	value = ((uint32_t)input[54] << 24) |
			((uint32_t)input[55] << 16);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 448 to 463
	value = ((uint32_t)input[56] << 24) |
			((uint32_t)input[57] << 16);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 464 to 479
	value = ((uint32_t)input[58] << 24) |
			((uint32_t)input[59] << 16);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 480 to 495
	value = ((uint32_t)input[60] << 24) |
			((uint32_t)input[61] << 16);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 496 to 511
	value = ((uint32_t)input[62] << 24) |
			((uint32_t)input[63] << 16);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 512 to 527
	value = ((uint32_t)input[64] << 24) |
			((uint32_t)input[65] << 16);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 528 to 543
	value = ((uint32_t)input[66] << 24) |
			((uint32_t)input[67] << 16);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 544 to 559
	value = ((uint32_t)input[68] << 24) |
			((uint32_t)input[69] << 16);
	output[34] = (double)(value >> 16);
}

static void unpack_35_16bit_signed_1off(const uint8_t * input, double * output, void *closure) {
	// Unpack 35 values into output
	// Values are 16-bit signed
	// Skip 1 bits, read 560 bits of data.
	// Input must be at least 71 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 1 to 16
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)input[1] << 17) |
			((uint32_t)(input[2] & 0x80) << 9);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 17 to 32
	value = ((uint32_t)(input[2] & 0x7f) << 25) |
			((uint32_t)input[3] << 17) |
			((uint32_t)(input[4] & 0x80) << 9);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 33 to 48
	value = ((uint32_t)(input[4] & 0x7f) << 25) |
			((uint32_t)input[5] << 17) |
			((uint32_t)(input[6] & 0x80) << 9);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 49 to 64
	value = ((uint32_t)(input[6] & 0x7f) << 25) |
			((uint32_t)input[7] << 17) |
			((uint32_t)(input[8] & 0x80) << 9);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 65 to 80
	value = ((uint32_t)(input[8] & 0x7f) << 25) |
			((uint32_t)input[9] << 17) |
			((uint32_t)(input[10] & 0x80) << 9);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 81 to 96
	value = ((uint32_t)(input[10] & 0x7f) << 25) |
			((uint32_t)input[11] << 17) |
			((uint32_t)(input[12] & 0x80) << 9);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 97 to 112
	value = ((uint32_t)(input[12] & 0x7f) << 25) |
			((uint32_t)input[13] << 17) |
			((uint32_t)(input[14] & 0x80) << 9);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 113 to 128
	value = ((uint32_t)(input[14] & 0x7f) << 25) |
			((uint32_t)input[15] << 17) |
			((uint32_t)(input[16] & 0x80) << 9);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 129 to 144
	value = ((uint32_t)(input[16] & 0x7f) << 25) |
			((uint32_t)input[17] << 17) |
			((uint32_t)(input[18] & 0x80) << 9);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 145 to 160
	value = ((uint32_t)(input[18] & 0x7f) << 25) |
			((uint32_t)input[19] << 17) |
			((uint32_t)(input[20] & 0x80) << 9);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 161 to 176
	value = ((uint32_t)(input[20] & 0x7f) << 25) |
			((uint32_t)input[21] << 17) |
			((uint32_t)(input[22] & 0x80) << 9);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 177 to 192
	value = ((uint32_t)(input[22] & 0x7f) << 25) |
			((uint32_t)input[23] << 17) |
			((uint32_t)(input[24] & 0x80) << 9);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 193 to 208
	value = ((uint32_t)(input[24] & 0x7f) << 25) |
			((uint32_t)input[25] << 17) |
			((uint32_t)(input[26] & 0x80) << 9);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 209 to 224
	value = ((uint32_t)(input[26] & 0x7f) << 25) |
			((uint32_t)input[27] << 17) |
			((uint32_t)(input[28] & 0x80) << 9);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 225 to 240
	value = ((uint32_t)(input[28] & 0x7f) << 25) |
			((uint32_t)input[29] << 17) |
			((uint32_t)(input[30] & 0x80) << 9);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 241 to 256
	value = ((uint32_t)(input[30] & 0x7f) << 25) |
			((uint32_t)input[31] << 17) |
			((uint32_t)(input[32] & 0x80) << 9);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 257 to 272
	value = ((uint32_t)(input[32] & 0x7f) << 25) |
			((uint32_t)input[33] << 17) |
			((uint32_t)(input[34] & 0x80) << 9);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 273 to 288
	value = ((uint32_t)(input[34] & 0x7f) << 25) |
			((uint32_t)input[35] << 17) |
			((uint32_t)(input[36] & 0x80) << 9);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 289 to 304
	value = ((uint32_t)(input[36] & 0x7f) << 25) |
			((uint32_t)input[37] << 17) |
			((uint32_t)(input[38] & 0x80) << 9);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 305 to 320
	value = ((uint32_t)(input[38] & 0x7f) << 25) |
			((uint32_t)input[39] << 17) |
			((uint32_t)(input[40] & 0x80) << 9);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 321 to 336
	value = ((uint32_t)(input[40] & 0x7f) << 25) |
			((uint32_t)input[41] << 17) |
			((uint32_t)(input[42] & 0x80) << 9);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 337 to 352
	value = ((uint32_t)(input[42] & 0x7f) << 25) |
			((uint32_t)input[43] << 17) |
			((uint32_t)(input[44] & 0x80) << 9);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 353 to 368
	value = ((uint32_t)(input[44] & 0x7f) << 25) |
			((uint32_t)input[45] << 17) |
			((uint32_t)(input[46] & 0x80) << 9);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 369 to 384
	value = ((uint32_t)(input[46] & 0x7f) << 25) |
			((uint32_t)input[47] << 17) |
			((uint32_t)(input[48] & 0x80) << 9);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 385 to 400
	value = ((uint32_t)(input[48] & 0x7f) << 25) |
			((uint32_t)input[49] << 17) |
			((uint32_t)(input[50] & 0x80) << 9);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 401 to 416
	value = ((uint32_t)(input[50] & 0x7f) << 25) |
			((uint32_t)input[51] << 17) |
			((uint32_t)(input[52] & 0x80) << 9);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 417 to 432
	value = ((uint32_t)(input[52] & 0x7f) << 25) |
			((uint32_t)input[53] << 17) |
			((uint32_t)(input[54] & 0x80) << 9);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 433 to 448
	value = ((uint32_t)(input[54] & 0x7f) << 25) |
			((uint32_t)input[55] << 17) |
			((uint32_t)(input[56] & 0x80) << 9);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 449 to 464
	value = ((uint32_t)(input[56] & 0x7f) << 25) |
			((uint32_t)input[57] << 17) |
			((uint32_t)(input[58] & 0x80) << 9);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 465 to 480
	value = ((uint32_t)(input[58] & 0x7f) << 25) |
			((uint32_t)input[59] << 17) |
			((uint32_t)(input[60] & 0x80) << 9);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 481 to 496
	value = ((uint32_t)(input[60] & 0x7f) << 25) |
			((uint32_t)input[61] << 17) |
			((uint32_t)(input[62] & 0x80) << 9);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 497 to 512
	value = ((uint32_t)(input[62] & 0x7f) << 25) |
			((uint32_t)input[63] << 17) |
			((uint32_t)(input[64] & 0x80) << 9);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 513 to 528
	value = ((uint32_t)(input[64] & 0x7f) << 25) |
			((uint32_t)input[65] << 17) |
			((uint32_t)(input[66] & 0x80) << 9);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 529 to 544
	value = ((uint32_t)(input[66] & 0x7f) << 25) |
			((uint32_t)input[67] << 17) |
			((uint32_t)(input[68] & 0x80) << 9);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 545 to 560
	value = ((uint32_t)(input[68] & 0x7f) << 25) |
			((uint32_t)input[69] << 17) |
			((uint32_t)(input[70] & 0x80) << 9);
	output[34] = (double)(value >> 16);
}

static void unpack_35_16bit_unsigned_1off(const uint8_t * input, double * output, void *closure) {
	// Unpack 35 values into output
	// Values are 16-bit unsigned
	// Skip 1 bits, read 560 bits of data.
	// Input must be at least 71 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 1 to 16
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)input[1] << 17) |
			((uint32_t)(input[2] & 0x80) << 9);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 17 to 32
	value = ((uint32_t)(input[2] & 0x7f) << 25) |
			((uint32_t)input[3] << 17) |
			((uint32_t)(input[4] & 0x80) << 9);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 33 to 48
	value = ((uint32_t)(input[4] & 0x7f) << 25) |
			((uint32_t)input[5] << 17) |
			((uint32_t)(input[6] & 0x80) << 9);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 49 to 64
	value = ((uint32_t)(input[6] & 0x7f) << 25) |
			((uint32_t)input[7] << 17) |
			((uint32_t)(input[8] & 0x80) << 9);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 65 to 80
	value = ((uint32_t)(input[8] & 0x7f) << 25) |
			((uint32_t)input[9] << 17) |
			((uint32_t)(input[10] & 0x80) << 9);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 81 to 96
	value = ((uint32_t)(input[10] & 0x7f) << 25) |
			((uint32_t)input[11] << 17) |
			((uint32_t)(input[12] & 0x80) << 9);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 97 to 112
	value = ((uint32_t)(input[12] & 0x7f) << 25) |
			((uint32_t)input[13] << 17) |
			((uint32_t)(input[14] & 0x80) << 9);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 113 to 128
	value = ((uint32_t)(input[14] & 0x7f) << 25) |
			((uint32_t)input[15] << 17) |
			((uint32_t)(input[16] & 0x80) << 9);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 129 to 144
	value = ((uint32_t)(input[16] & 0x7f) << 25) |
			((uint32_t)input[17] << 17) |
			((uint32_t)(input[18] & 0x80) << 9);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 145 to 160
	value = ((uint32_t)(input[18] & 0x7f) << 25) |
			((uint32_t)input[19] << 17) |
			((uint32_t)(input[20] & 0x80) << 9);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 161 to 176
	value = ((uint32_t)(input[20] & 0x7f) << 25) |
			((uint32_t)input[21] << 17) |
			((uint32_t)(input[22] & 0x80) << 9);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 177 to 192
	value = ((uint32_t)(input[22] & 0x7f) << 25) |
			((uint32_t)input[23] << 17) |
			((uint32_t)(input[24] & 0x80) << 9);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 193 to 208
	value = ((uint32_t)(input[24] & 0x7f) << 25) |
			((uint32_t)input[25] << 17) |
			((uint32_t)(input[26] & 0x80) << 9);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 209 to 224
	value = ((uint32_t)(input[26] & 0x7f) << 25) |
			((uint32_t)input[27] << 17) |
			((uint32_t)(input[28] & 0x80) << 9);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 225 to 240
	value = ((uint32_t)(input[28] & 0x7f) << 25) |
			((uint32_t)input[29] << 17) |
			((uint32_t)(input[30] & 0x80) << 9);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 241 to 256
	value = ((uint32_t)(input[30] & 0x7f) << 25) |
			((uint32_t)input[31] << 17) |
			((uint32_t)(input[32] & 0x80) << 9);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 257 to 272
	value = ((uint32_t)(input[32] & 0x7f) << 25) |
			((uint32_t)input[33] << 17) |
			((uint32_t)(input[34] & 0x80) << 9);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 273 to 288
	value = ((uint32_t)(input[34] & 0x7f) << 25) |
			((uint32_t)input[35] << 17) |
			((uint32_t)(input[36] & 0x80) << 9);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 289 to 304
	value = ((uint32_t)(input[36] & 0x7f) << 25) |
			((uint32_t)input[37] << 17) |
			((uint32_t)(input[38] & 0x80) << 9);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 305 to 320
	value = ((uint32_t)(input[38] & 0x7f) << 25) |
			((uint32_t)input[39] << 17) |
			((uint32_t)(input[40] & 0x80) << 9);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 321 to 336
	value = ((uint32_t)(input[40] & 0x7f) << 25) |
			((uint32_t)input[41] << 17) |
			((uint32_t)(input[42] & 0x80) << 9);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 337 to 352
	value = ((uint32_t)(input[42] & 0x7f) << 25) |
			((uint32_t)input[43] << 17) |
			((uint32_t)(input[44] & 0x80) << 9);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 353 to 368
	value = ((uint32_t)(input[44] & 0x7f) << 25) |
			((uint32_t)input[45] << 17) |
			((uint32_t)(input[46] & 0x80) << 9);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 369 to 384
	value = ((uint32_t)(input[46] & 0x7f) << 25) |
			((uint32_t)input[47] << 17) |
			((uint32_t)(input[48] & 0x80) << 9);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 385 to 400
	value = ((uint32_t)(input[48] & 0x7f) << 25) |
			((uint32_t)input[49] << 17) |
			((uint32_t)(input[50] & 0x80) << 9);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 401 to 416
	value = ((uint32_t)(input[50] & 0x7f) << 25) |
			((uint32_t)input[51] << 17) |
			((uint32_t)(input[52] & 0x80) << 9);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 417 to 432
	value = ((uint32_t)(input[52] & 0x7f) << 25) |
			((uint32_t)input[53] << 17) |
			((uint32_t)(input[54] & 0x80) << 9);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 433 to 448
	value = ((uint32_t)(input[54] & 0x7f) << 25) |
			((uint32_t)input[55] << 17) |
			((uint32_t)(input[56] & 0x80) << 9);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 449 to 464
	value = ((uint32_t)(input[56] & 0x7f) << 25) |
			((uint32_t)input[57] << 17) |
			((uint32_t)(input[58] & 0x80) << 9);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 465 to 480
	value = ((uint32_t)(input[58] & 0x7f) << 25) |
			((uint32_t)input[59] << 17) |
			((uint32_t)(input[60] & 0x80) << 9);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 481 to 496
	value = ((uint32_t)(input[60] & 0x7f) << 25) |
			((uint32_t)input[61] << 17) |
			((uint32_t)(input[62] & 0x80) << 9);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 497 to 512
	value = ((uint32_t)(input[62] & 0x7f) << 25) |
			((uint32_t)input[63] << 17) |
			((uint32_t)(input[64] & 0x80) << 9);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 513 to 528
	value = ((uint32_t)(input[64] & 0x7f) << 25) |
			((uint32_t)input[65] << 17) |
			((uint32_t)(input[66] & 0x80) << 9);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 529 to 544
	value = ((uint32_t)(input[66] & 0x7f) << 25) |
			((uint32_t)input[67] << 17) |
			((uint32_t)(input[68] & 0x80) << 9);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 545 to 560
	value = ((uint32_t)(input[68] & 0x7f) << 25) |
			((uint32_t)input[69] << 17) |
			((uint32_t)(input[70] & 0x80) << 9);
	output[34] = (double)(value >> 16);
}

static void unpack_35_16bit_signed_2off(const uint8_t * input, double * output, void *closure) {
	// Unpack 35 values into output
	// Values are 16-bit signed
	// Skip 2 bits, read 560 bits of data.
	// Input must be at least 71 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 2 to 17
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)input[1] << 18) |
			((uint32_t)(input[2] & 0xc0) << 10);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 18 to 33
	value = ((uint32_t)(input[2] & 0x3f) << 26) |
			((uint32_t)input[3] << 18) |
			((uint32_t)(input[4] & 0xc0) << 10);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 34 to 49
	value = ((uint32_t)(input[4] & 0x3f) << 26) |
			((uint32_t)input[5] << 18) |
			((uint32_t)(input[6] & 0xc0) << 10);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 50 to 65
	value = ((uint32_t)(input[6] & 0x3f) << 26) |
			((uint32_t)input[7] << 18) |
			((uint32_t)(input[8] & 0xc0) << 10);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 66 to 81
	value = ((uint32_t)(input[8] & 0x3f) << 26) |
			((uint32_t)input[9] << 18) |
			((uint32_t)(input[10] & 0xc0) << 10);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 82 to 97
	value = ((uint32_t)(input[10] & 0x3f) << 26) |
			((uint32_t)input[11] << 18) |
			((uint32_t)(input[12] & 0xc0) << 10);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 98 to 113
	value = ((uint32_t)(input[12] & 0x3f) << 26) |
			((uint32_t)input[13] << 18) |
			((uint32_t)(input[14] & 0xc0) << 10);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 114 to 129
	value = ((uint32_t)(input[14] & 0x3f) << 26) |
			((uint32_t)input[15] << 18) |
			((uint32_t)(input[16] & 0xc0) << 10);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 130 to 145
	value = ((uint32_t)(input[16] & 0x3f) << 26) |
			((uint32_t)input[17] << 18) |
			((uint32_t)(input[18] & 0xc0) << 10);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 146 to 161
	value = ((uint32_t)(input[18] & 0x3f) << 26) |
			((uint32_t)input[19] << 18) |
			((uint32_t)(input[20] & 0xc0) << 10);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 162 to 177
	value = ((uint32_t)(input[20] & 0x3f) << 26) |
			((uint32_t)input[21] << 18) |
			((uint32_t)(input[22] & 0xc0) << 10);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 178 to 193
	value = ((uint32_t)(input[22] & 0x3f) << 26) |
			((uint32_t)input[23] << 18) |
			((uint32_t)(input[24] & 0xc0) << 10);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 194 to 209
	value = ((uint32_t)(input[24] & 0x3f) << 26) |
			((uint32_t)input[25] << 18) |
			((uint32_t)(input[26] & 0xc0) << 10);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 210 to 225
	value = ((uint32_t)(input[26] & 0x3f) << 26) |
			((uint32_t)input[27] << 18) |
			((uint32_t)(input[28] & 0xc0) << 10);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 226 to 241
	value = ((uint32_t)(input[28] & 0x3f) << 26) |
			((uint32_t)input[29] << 18) |
			((uint32_t)(input[30] & 0xc0) << 10);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 242 to 257
	value = ((uint32_t)(input[30] & 0x3f) << 26) |
			((uint32_t)input[31] << 18) |
			((uint32_t)(input[32] & 0xc0) << 10);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 258 to 273
	value = ((uint32_t)(input[32] & 0x3f) << 26) |
			((uint32_t)input[33] << 18) |
			((uint32_t)(input[34] & 0xc0) << 10);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 274 to 289
	value = ((uint32_t)(input[34] & 0x3f) << 26) |
			((uint32_t)input[35] << 18) |
			((uint32_t)(input[36] & 0xc0) << 10);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 290 to 305
	value = ((uint32_t)(input[36] & 0x3f) << 26) |
			((uint32_t)input[37] << 18) |
			((uint32_t)(input[38] & 0xc0) << 10);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 306 to 321
	value = ((uint32_t)(input[38] & 0x3f) << 26) |
			((uint32_t)input[39] << 18) |
			((uint32_t)(input[40] & 0xc0) << 10);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 322 to 337
	value = ((uint32_t)(input[40] & 0x3f) << 26) |
			((uint32_t)input[41] << 18) |
			((uint32_t)(input[42] & 0xc0) << 10);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 338 to 353
	value = ((uint32_t)(input[42] & 0x3f) << 26) |
			((uint32_t)input[43] << 18) |
			((uint32_t)(input[44] & 0xc0) << 10);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 354 to 369
	value = ((uint32_t)(input[44] & 0x3f) << 26) |
			((uint32_t)input[45] << 18) |
			((uint32_t)(input[46] & 0xc0) << 10);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 370 to 385
	value = ((uint32_t)(input[46] & 0x3f) << 26) |
			((uint32_t)input[47] << 18) |
			((uint32_t)(input[48] & 0xc0) << 10);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 386 to 401
	value = ((uint32_t)(input[48] & 0x3f) << 26) |
			((uint32_t)input[49] << 18) |
			((uint32_t)(input[50] & 0xc0) << 10);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 402 to 417
	value = ((uint32_t)(input[50] & 0x3f) << 26) |
			((uint32_t)input[51] << 18) |
			((uint32_t)(input[52] & 0xc0) << 10);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 418 to 433
	value = ((uint32_t)(input[52] & 0x3f) << 26) |
			((uint32_t)input[53] << 18) |
			((uint32_t)(input[54] & 0xc0) << 10);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 434 to 449
	value = ((uint32_t)(input[54] & 0x3f) << 26) |
			((uint32_t)input[55] << 18) |
			((uint32_t)(input[56] & 0xc0) << 10);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 450 to 465
	value = ((uint32_t)(input[56] & 0x3f) << 26) |
			((uint32_t)input[57] << 18) |
			((uint32_t)(input[58] & 0xc0) << 10);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 466 to 481
	value = ((uint32_t)(input[58] & 0x3f) << 26) |
			((uint32_t)input[59] << 18) |
			((uint32_t)(input[60] & 0xc0) << 10);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 482 to 497
	value = ((uint32_t)(input[60] & 0x3f) << 26) |
			((uint32_t)input[61] << 18) |
			((uint32_t)(input[62] & 0xc0) << 10);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 498 to 513
	value = ((uint32_t)(input[62] & 0x3f) << 26) |
			((uint32_t)input[63] << 18) |
			((uint32_t)(input[64] & 0xc0) << 10);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 514 to 529
	value = ((uint32_t)(input[64] & 0x3f) << 26) |
			((uint32_t)input[65] << 18) |
			((uint32_t)(input[66] & 0xc0) << 10);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 530 to 545
	value = ((uint32_t)(input[66] & 0x3f) << 26) |
			((uint32_t)input[67] << 18) |
			((uint32_t)(input[68] & 0xc0) << 10);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 546 to 561
	value = ((uint32_t)(input[68] & 0x3f) << 26) |
			((uint32_t)input[69] << 18) |
			((uint32_t)(input[70] & 0xc0) << 10);
	output[34] = (double)(value >> 16);
}

static void unpack_35_16bit_unsigned_2off(const uint8_t * input, double * output, void *closure) {
	// Unpack 35 values into output
	// Values are 16-bit unsigned
	// Skip 2 bits, read 560 bits of data.
	// Input must be at least 71 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 2 to 17
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)input[1] << 18) |
			((uint32_t)(input[2] & 0xc0) << 10);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 18 to 33
	value = ((uint32_t)(input[2] & 0x3f) << 26) |
			((uint32_t)input[3] << 18) |
			((uint32_t)(input[4] & 0xc0) << 10);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 34 to 49
	value = ((uint32_t)(input[4] & 0x3f) << 26) |
			((uint32_t)input[5] << 18) |
			((uint32_t)(input[6] & 0xc0) << 10);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 50 to 65
	value = ((uint32_t)(input[6] & 0x3f) << 26) |
			((uint32_t)input[7] << 18) |
			((uint32_t)(input[8] & 0xc0) << 10);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 66 to 81
	value = ((uint32_t)(input[8] & 0x3f) << 26) |
			((uint32_t)input[9] << 18) |
			((uint32_t)(input[10] & 0xc0) << 10);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 82 to 97
	value = ((uint32_t)(input[10] & 0x3f) << 26) |
			((uint32_t)input[11] << 18) |
			((uint32_t)(input[12] & 0xc0) << 10);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 98 to 113
	value = ((uint32_t)(input[12] & 0x3f) << 26) |
			((uint32_t)input[13] << 18) |
			((uint32_t)(input[14] & 0xc0) << 10);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 114 to 129
	value = ((uint32_t)(input[14] & 0x3f) << 26) |
			((uint32_t)input[15] << 18) |
			((uint32_t)(input[16] & 0xc0) << 10);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 130 to 145
	value = ((uint32_t)(input[16] & 0x3f) << 26) |
			((uint32_t)input[17] << 18) |
			((uint32_t)(input[18] & 0xc0) << 10);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 146 to 161
	value = ((uint32_t)(input[18] & 0x3f) << 26) |
			((uint32_t)input[19] << 18) |
			((uint32_t)(input[20] & 0xc0) << 10);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 162 to 177
	value = ((uint32_t)(input[20] & 0x3f) << 26) |
			((uint32_t)input[21] << 18) |
			((uint32_t)(input[22] & 0xc0) << 10);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 178 to 193
	value = ((uint32_t)(input[22] & 0x3f) << 26) |
			((uint32_t)input[23] << 18) |
			((uint32_t)(input[24] & 0xc0) << 10);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 194 to 209
	value = ((uint32_t)(input[24] & 0x3f) << 26) |
			((uint32_t)input[25] << 18) |
			((uint32_t)(input[26] & 0xc0) << 10);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 210 to 225
	value = ((uint32_t)(input[26] & 0x3f) << 26) |
			((uint32_t)input[27] << 18) |
			((uint32_t)(input[28] & 0xc0) << 10);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 226 to 241
	value = ((uint32_t)(input[28] & 0x3f) << 26) |
			((uint32_t)input[29] << 18) |
			((uint32_t)(input[30] & 0xc0) << 10);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 242 to 257
	value = ((uint32_t)(input[30] & 0x3f) << 26) |
			((uint32_t)input[31] << 18) |
			((uint32_t)(input[32] & 0xc0) << 10);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 258 to 273
	value = ((uint32_t)(input[32] & 0x3f) << 26) |
			((uint32_t)input[33] << 18) |
			((uint32_t)(input[34] & 0xc0) << 10);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 274 to 289
	value = ((uint32_t)(input[34] & 0x3f) << 26) |
			((uint32_t)input[35] << 18) |
			((uint32_t)(input[36] & 0xc0) << 10);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 290 to 305
	value = ((uint32_t)(input[36] & 0x3f) << 26) |
			((uint32_t)input[37] << 18) |
			((uint32_t)(input[38] & 0xc0) << 10);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 306 to 321
	value = ((uint32_t)(input[38] & 0x3f) << 26) |
			((uint32_t)input[39] << 18) |
			((uint32_t)(input[40] & 0xc0) << 10);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 322 to 337
	value = ((uint32_t)(input[40] & 0x3f) << 26) |
			((uint32_t)input[41] << 18) |
			((uint32_t)(input[42] & 0xc0) << 10);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 338 to 353
	value = ((uint32_t)(input[42] & 0x3f) << 26) |
			((uint32_t)input[43] << 18) |
			((uint32_t)(input[44] & 0xc0) << 10);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 354 to 369
	value = ((uint32_t)(input[44] & 0x3f) << 26) |
			((uint32_t)input[45] << 18) |
			((uint32_t)(input[46] & 0xc0) << 10);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 370 to 385
	value = ((uint32_t)(input[46] & 0x3f) << 26) |
			((uint32_t)input[47] << 18) |
			((uint32_t)(input[48] & 0xc0) << 10);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 386 to 401
	value = ((uint32_t)(input[48] & 0x3f) << 26) |
			((uint32_t)input[49] << 18) |
			((uint32_t)(input[50] & 0xc0) << 10);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 402 to 417
	value = ((uint32_t)(input[50] & 0x3f) << 26) |
			((uint32_t)input[51] << 18) |
			((uint32_t)(input[52] & 0xc0) << 10);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 418 to 433
	value = ((uint32_t)(input[52] & 0x3f) << 26) |
			((uint32_t)input[53] << 18) |
			((uint32_t)(input[54] & 0xc0) << 10);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 434 to 449
	value = ((uint32_t)(input[54] & 0x3f) << 26) |
			((uint32_t)input[55] << 18) |
			((uint32_t)(input[56] & 0xc0) << 10);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 450 to 465
	value = ((uint32_t)(input[56] & 0x3f) << 26) |
			((uint32_t)input[57] << 18) |
			((uint32_t)(input[58] & 0xc0) << 10);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 466 to 481
	value = ((uint32_t)(input[58] & 0x3f) << 26) |
			((uint32_t)input[59] << 18) |
			((uint32_t)(input[60] & 0xc0) << 10);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 482 to 497
	value = ((uint32_t)(input[60] & 0x3f) << 26) |
			((uint32_t)input[61] << 18) |
			((uint32_t)(input[62] & 0xc0) << 10);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 498 to 513
	value = ((uint32_t)(input[62] & 0x3f) << 26) |
			((uint32_t)input[63] << 18) |
			((uint32_t)(input[64] & 0xc0) << 10);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 514 to 529
	value = ((uint32_t)(input[64] & 0x3f) << 26) |
			((uint32_t)input[65] << 18) |
			((uint32_t)(input[66] & 0xc0) << 10);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 530 to 545
	value = ((uint32_t)(input[66] & 0x3f) << 26) |
			((uint32_t)input[67] << 18) |
			((uint32_t)(input[68] & 0xc0) << 10);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 546 to 561
	value = ((uint32_t)(input[68] & 0x3f) << 26) |
			((uint32_t)input[69] << 18) |
			((uint32_t)(input[70] & 0xc0) << 10);
	output[34] = (double)(value >> 16);
}

static void unpack_35_16bit_signed_3off(const uint8_t * input, double * output, void *closure) {
	// Unpack 35 values into output
	// Values are 16-bit signed
	// Skip 3 bits, read 560 bits of data.
	// Input must be at least 71 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 3 to 18
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)input[1] << 19) |
			((uint32_t)(input[2] & 0xe0) << 11);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 19 to 34
	value = ((uint32_t)(input[2] & 0x1f) << 27) |
			((uint32_t)input[3] << 19) |
			((uint32_t)(input[4] & 0xe0) << 11);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 35 to 50
	value = ((uint32_t)(input[4] & 0x1f) << 27) |
			((uint32_t)input[5] << 19) |
			((uint32_t)(input[6] & 0xe0) << 11);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 51 to 66
	value = ((uint32_t)(input[6] & 0x1f) << 27) |
			((uint32_t)input[7] << 19) |
			((uint32_t)(input[8] & 0xe0) << 11);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 67 to 82
	value = ((uint32_t)(input[8] & 0x1f) << 27) |
			((uint32_t)input[9] << 19) |
			((uint32_t)(input[10] & 0xe0) << 11);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 83 to 98
	value = ((uint32_t)(input[10] & 0x1f) << 27) |
			((uint32_t)input[11] << 19) |
			((uint32_t)(input[12] & 0xe0) << 11);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 99 to 114
	value = ((uint32_t)(input[12] & 0x1f) << 27) |
			((uint32_t)input[13] << 19) |
			((uint32_t)(input[14] & 0xe0) << 11);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 115 to 130
	value = ((uint32_t)(input[14] & 0x1f) << 27) |
			((uint32_t)input[15] << 19) |
			((uint32_t)(input[16] & 0xe0) << 11);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 131 to 146
	value = ((uint32_t)(input[16] & 0x1f) << 27) |
			((uint32_t)input[17] << 19) |
			((uint32_t)(input[18] & 0xe0) << 11);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 147 to 162
	value = ((uint32_t)(input[18] & 0x1f) << 27) |
			((uint32_t)input[19] << 19) |
			((uint32_t)(input[20] & 0xe0) << 11);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 163 to 178
	value = ((uint32_t)(input[20] & 0x1f) << 27) |
			((uint32_t)input[21] << 19) |
			((uint32_t)(input[22] & 0xe0) << 11);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 179 to 194
	value = ((uint32_t)(input[22] & 0x1f) << 27) |
			((uint32_t)input[23] << 19) |
			((uint32_t)(input[24] & 0xe0) << 11);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 195 to 210
	value = ((uint32_t)(input[24] & 0x1f) << 27) |
			((uint32_t)input[25] << 19) |
			((uint32_t)(input[26] & 0xe0) << 11);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 211 to 226
	value = ((uint32_t)(input[26] & 0x1f) << 27) |
			((uint32_t)input[27] << 19) |
			((uint32_t)(input[28] & 0xe0) << 11);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 227 to 242
	value = ((uint32_t)(input[28] & 0x1f) << 27) |
			((uint32_t)input[29] << 19) |
			((uint32_t)(input[30] & 0xe0) << 11);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 243 to 258
	value = ((uint32_t)(input[30] & 0x1f) << 27) |
			((uint32_t)input[31] << 19) |
			((uint32_t)(input[32] & 0xe0) << 11);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 259 to 274
	value = ((uint32_t)(input[32] & 0x1f) << 27) |
			((uint32_t)input[33] << 19) |
			((uint32_t)(input[34] & 0xe0) << 11);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 275 to 290
	value = ((uint32_t)(input[34] & 0x1f) << 27) |
			((uint32_t)input[35] << 19) |
			((uint32_t)(input[36] & 0xe0) << 11);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 291 to 306
	value = ((uint32_t)(input[36] & 0x1f) << 27) |
			((uint32_t)input[37] << 19) |
			((uint32_t)(input[38] & 0xe0) << 11);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 307 to 322
	value = ((uint32_t)(input[38] & 0x1f) << 27) |
			((uint32_t)input[39] << 19) |
			((uint32_t)(input[40] & 0xe0) << 11);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 323 to 338
	value = ((uint32_t)(input[40] & 0x1f) << 27) |
			((uint32_t)input[41] << 19) |
			((uint32_t)(input[42] & 0xe0) << 11);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 339 to 354
	value = ((uint32_t)(input[42] & 0x1f) << 27) |
			((uint32_t)input[43] << 19) |
			((uint32_t)(input[44] & 0xe0) << 11);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 355 to 370
	value = ((uint32_t)(input[44] & 0x1f) << 27) |
			((uint32_t)input[45] << 19) |
			((uint32_t)(input[46] & 0xe0) << 11);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 371 to 386
	value = ((uint32_t)(input[46] & 0x1f) << 27) |
			((uint32_t)input[47] << 19) |
			((uint32_t)(input[48] & 0xe0) << 11);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 387 to 402
	value = ((uint32_t)(input[48] & 0x1f) << 27) |
			((uint32_t)input[49] << 19) |
			((uint32_t)(input[50] & 0xe0) << 11);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 403 to 418
	value = ((uint32_t)(input[50] & 0x1f) << 27) |
			((uint32_t)input[51] << 19) |
			((uint32_t)(input[52] & 0xe0) << 11);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 419 to 434
	value = ((uint32_t)(input[52] & 0x1f) << 27) |
			((uint32_t)input[53] << 19) |
			((uint32_t)(input[54] & 0xe0) << 11);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 435 to 450
	value = ((uint32_t)(input[54] & 0x1f) << 27) |
			((uint32_t)input[55] << 19) |
			((uint32_t)(input[56] & 0xe0) << 11);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 451 to 466
	value = ((uint32_t)(input[56] & 0x1f) << 27) |
			((uint32_t)input[57] << 19) |
			((uint32_t)(input[58] & 0xe0) << 11);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 467 to 482
	value = ((uint32_t)(input[58] & 0x1f) << 27) |
			((uint32_t)input[59] << 19) |
			((uint32_t)(input[60] & 0xe0) << 11);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 483 to 498
	value = ((uint32_t)(input[60] & 0x1f) << 27) |
			((uint32_t)input[61] << 19) |
			((uint32_t)(input[62] & 0xe0) << 11);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 499 to 514
	value = ((uint32_t)(input[62] & 0x1f) << 27) |
			((uint32_t)input[63] << 19) |
			((uint32_t)(input[64] & 0xe0) << 11);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 515 to 530
	value = ((uint32_t)(input[64] & 0x1f) << 27) |
			((uint32_t)input[65] << 19) |
			((uint32_t)(input[66] & 0xe0) << 11);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 531 to 546
	value = ((uint32_t)(input[66] & 0x1f) << 27) |
			((uint32_t)input[67] << 19) |
			((uint32_t)(input[68] & 0xe0) << 11);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 547 to 562
	value = ((uint32_t)(input[68] & 0x1f) << 27) |
			((uint32_t)input[69] << 19) |
			((uint32_t)(input[70] & 0xe0) << 11);
	output[34] = (double)(value >> 16);
}

static void unpack_35_16bit_unsigned_3off(const uint8_t * input, double * output, void *closure) {
	// Unpack 35 values into output
	// Values are 16-bit unsigned
	// Skip 3 bits, read 560 bits of data.
	// Input must be at least 71 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 3 to 18
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)input[1] << 19) |
			((uint32_t)(input[2] & 0xe0) << 11);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 19 to 34
	value = ((uint32_t)(input[2] & 0x1f) << 27) |
			((uint32_t)input[3] << 19) |
			((uint32_t)(input[4] & 0xe0) << 11);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 35 to 50
	value = ((uint32_t)(input[4] & 0x1f) << 27) |
			((uint32_t)input[5] << 19) |
			((uint32_t)(input[6] & 0xe0) << 11);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 51 to 66
	value = ((uint32_t)(input[6] & 0x1f) << 27) |
			((uint32_t)input[7] << 19) |
			((uint32_t)(input[8] & 0xe0) << 11);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 67 to 82
	value = ((uint32_t)(input[8] & 0x1f) << 27) |
			((uint32_t)input[9] << 19) |
			((uint32_t)(input[10] & 0xe0) << 11);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 83 to 98
	value = ((uint32_t)(input[10] & 0x1f) << 27) |
			((uint32_t)input[11] << 19) |
			((uint32_t)(input[12] & 0xe0) << 11);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 99 to 114
	value = ((uint32_t)(input[12] & 0x1f) << 27) |
			((uint32_t)input[13] << 19) |
			((uint32_t)(input[14] & 0xe0) << 11);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 115 to 130
	value = ((uint32_t)(input[14] & 0x1f) << 27) |
			((uint32_t)input[15] << 19) |
			((uint32_t)(input[16] & 0xe0) << 11);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 131 to 146
	value = ((uint32_t)(input[16] & 0x1f) << 27) |
			((uint32_t)input[17] << 19) |
			((uint32_t)(input[18] & 0xe0) << 11);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 147 to 162
	value = ((uint32_t)(input[18] & 0x1f) << 27) |
			((uint32_t)input[19] << 19) |
			((uint32_t)(input[20] & 0xe0) << 11);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 163 to 178
	value = ((uint32_t)(input[20] & 0x1f) << 27) |
			((uint32_t)input[21] << 19) |
			((uint32_t)(input[22] & 0xe0) << 11);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 179 to 194
	value = ((uint32_t)(input[22] & 0x1f) << 27) |
			((uint32_t)input[23] << 19) |
			((uint32_t)(input[24] & 0xe0) << 11);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 195 to 210
	value = ((uint32_t)(input[24] & 0x1f) << 27) |
			((uint32_t)input[25] << 19) |
			((uint32_t)(input[26] & 0xe0) << 11);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 211 to 226
	value = ((uint32_t)(input[26] & 0x1f) << 27) |
			((uint32_t)input[27] << 19) |
			((uint32_t)(input[28] & 0xe0) << 11);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 227 to 242
	value = ((uint32_t)(input[28] & 0x1f) << 27) |
			((uint32_t)input[29] << 19) |
			((uint32_t)(input[30] & 0xe0) << 11);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 243 to 258
	value = ((uint32_t)(input[30] & 0x1f) << 27) |
			((uint32_t)input[31] << 19) |
			((uint32_t)(input[32] & 0xe0) << 11);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 259 to 274
	value = ((uint32_t)(input[32] & 0x1f) << 27) |
			((uint32_t)input[33] << 19) |
			((uint32_t)(input[34] & 0xe0) << 11);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 275 to 290
	value = ((uint32_t)(input[34] & 0x1f) << 27) |
			((uint32_t)input[35] << 19) |
			((uint32_t)(input[36] & 0xe0) << 11);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 291 to 306
	value = ((uint32_t)(input[36] & 0x1f) << 27) |
			((uint32_t)input[37] << 19) |
			((uint32_t)(input[38] & 0xe0) << 11);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 307 to 322
	value = ((uint32_t)(input[38] & 0x1f) << 27) |
			((uint32_t)input[39] << 19) |
			((uint32_t)(input[40] & 0xe0) << 11);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 323 to 338
	value = ((uint32_t)(input[40] & 0x1f) << 27) |
			((uint32_t)input[41] << 19) |
			((uint32_t)(input[42] & 0xe0) << 11);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 339 to 354
	value = ((uint32_t)(input[42] & 0x1f) << 27) |
			((uint32_t)input[43] << 19) |
			((uint32_t)(input[44] & 0xe0) << 11);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 355 to 370
	value = ((uint32_t)(input[44] & 0x1f) << 27) |
			((uint32_t)input[45] << 19) |
			((uint32_t)(input[46] & 0xe0) << 11);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 371 to 386
	value = ((uint32_t)(input[46] & 0x1f) << 27) |
			((uint32_t)input[47] << 19) |
			((uint32_t)(input[48] & 0xe0) << 11);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 387 to 402
	value = ((uint32_t)(input[48] & 0x1f) << 27) |
			((uint32_t)input[49] << 19) |
			((uint32_t)(input[50] & 0xe0) << 11);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 403 to 418
	value = ((uint32_t)(input[50] & 0x1f) << 27) |
			((uint32_t)input[51] << 19) |
			((uint32_t)(input[52] & 0xe0) << 11);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 419 to 434
	value = ((uint32_t)(input[52] & 0x1f) << 27) |
			((uint32_t)input[53] << 19) |
			((uint32_t)(input[54] & 0xe0) << 11);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 435 to 450
	value = ((uint32_t)(input[54] & 0x1f) << 27) |
			((uint32_t)input[55] << 19) |
			((uint32_t)(input[56] & 0xe0) << 11);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 451 to 466
	value = ((uint32_t)(input[56] & 0x1f) << 27) |
			((uint32_t)input[57] << 19) |
			((uint32_t)(input[58] & 0xe0) << 11);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 467 to 482
	value = ((uint32_t)(input[58] & 0x1f) << 27) |
			((uint32_t)input[59] << 19) |
			((uint32_t)(input[60] & 0xe0) << 11);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 483 to 498
	value = ((uint32_t)(input[60] & 0x1f) << 27) |
			((uint32_t)input[61] << 19) |
			((uint32_t)(input[62] & 0xe0) << 11);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 499 to 514
	value = ((uint32_t)(input[62] & 0x1f) << 27) |
			((uint32_t)input[63] << 19) |
			((uint32_t)(input[64] & 0xe0) << 11);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 515 to 530
	value = ((uint32_t)(input[64] & 0x1f) << 27) |
			((uint32_t)input[65] << 19) |
			((uint32_t)(input[66] & 0xe0) << 11);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 531 to 546
	value = ((uint32_t)(input[66] & 0x1f) << 27) |
			((uint32_t)input[67] << 19) |
			((uint32_t)(input[68] & 0xe0) << 11);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 547 to 562
	value = ((uint32_t)(input[68] & 0x1f) << 27) |
			((uint32_t)input[69] << 19) |
			((uint32_t)(input[70] & 0xe0) << 11);
	output[34] = (double)(value >> 16);
}

static void unpack_35_16bit_signed_4off(const uint8_t * input, double * output, void *closure) {
	// Unpack 35 values into output
	// Values are 16-bit signed
	// Skip 4 bits, read 560 bits of data.
	// Input must be at least 71 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 4 to 19
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20) |
			((uint32_t)(input[2] & 0xf0) << 12);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 20 to 35
	value = ((uint32_t)(input[2] & 0x0f) << 28) |
			((uint32_t)input[3] << 20) |
			((uint32_t)(input[4] & 0xf0) << 12);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 36 to 51
	value = ((uint32_t)(input[4] & 0x0f) << 28) |
			((uint32_t)input[5] << 20) |
			((uint32_t)(input[6] & 0xf0) << 12);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 52 to 67
	value = ((uint32_t)(input[6] & 0x0f) << 28) |
			((uint32_t)input[7] << 20) |
			((uint32_t)(input[8] & 0xf0) << 12);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 68 to 83
	value = ((uint32_t)(input[8] & 0x0f) << 28) |
			((uint32_t)input[9] << 20) |
			((uint32_t)(input[10] & 0xf0) << 12);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 84 to 99
	value = ((uint32_t)(input[10] & 0x0f) << 28) |
			((uint32_t)input[11] << 20) |
			((uint32_t)(input[12] & 0xf0) << 12);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 100 to 115
	value = ((uint32_t)(input[12] & 0x0f) << 28) |
			((uint32_t)input[13] << 20) |
			((uint32_t)(input[14] & 0xf0) << 12);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 116 to 131
	value = ((uint32_t)(input[14] & 0x0f) << 28) |
			((uint32_t)input[15] << 20) |
			((uint32_t)(input[16] & 0xf0) << 12);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 132 to 147
	value = ((uint32_t)(input[16] & 0x0f) << 28) |
			((uint32_t)input[17] << 20) |
			((uint32_t)(input[18] & 0xf0) << 12);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 148 to 163
	value = ((uint32_t)(input[18] & 0x0f) << 28) |
			((uint32_t)input[19] << 20) |
			((uint32_t)(input[20] & 0xf0) << 12);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 164 to 179
	value = ((uint32_t)(input[20] & 0x0f) << 28) |
			((uint32_t)input[21] << 20) |
			((uint32_t)(input[22] & 0xf0) << 12);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 180 to 195
	value = ((uint32_t)(input[22] & 0x0f) << 28) |
			((uint32_t)input[23] << 20) |
			((uint32_t)(input[24] & 0xf0) << 12);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 196 to 211
	value = ((uint32_t)(input[24] & 0x0f) << 28) |
			((uint32_t)input[25] << 20) |
			((uint32_t)(input[26] & 0xf0) << 12);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 212 to 227
	value = ((uint32_t)(input[26] & 0x0f) << 28) |
			((uint32_t)input[27] << 20) |
			((uint32_t)(input[28] & 0xf0) << 12);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 228 to 243
	value = ((uint32_t)(input[28] & 0x0f) << 28) |
			((uint32_t)input[29] << 20) |
			((uint32_t)(input[30] & 0xf0) << 12);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 244 to 259
	value = ((uint32_t)(input[30] & 0x0f) << 28) |
			((uint32_t)input[31] << 20) |
			((uint32_t)(input[32] & 0xf0) << 12);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 260 to 275
	value = ((uint32_t)(input[32] & 0x0f) << 28) |
			((uint32_t)input[33] << 20) |
			((uint32_t)(input[34] & 0xf0) << 12);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 276 to 291
	value = ((uint32_t)(input[34] & 0x0f) << 28) |
			((uint32_t)input[35] << 20) |
			((uint32_t)(input[36] & 0xf0) << 12);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 292 to 307
	value = ((uint32_t)(input[36] & 0x0f) << 28) |
			((uint32_t)input[37] << 20) |
			((uint32_t)(input[38] & 0xf0) << 12);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 308 to 323
	value = ((uint32_t)(input[38] & 0x0f) << 28) |
			((uint32_t)input[39] << 20) |
			((uint32_t)(input[40] & 0xf0) << 12);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 324 to 339
	value = ((uint32_t)(input[40] & 0x0f) << 28) |
			((uint32_t)input[41] << 20) |
			((uint32_t)(input[42] & 0xf0) << 12);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 340 to 355
	value = ((uint32_t)(input[42] & 0x0f) << 28) |
			((uint32_t)input[43] << 20) |
			((uint32_t)(input[44] & 0xf0) << 12);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 356 to 371
	value = ((uint32_t)(input[44] & 0x0f) << 28) |
			((uint32_t)input[45] << 20) |
			((uint32_t)(input[46] & 0xf0) << 12);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 372 to 387
	value = ((uint32_t)(input[46] & 0x0f) << 28) |
			((uint32_t)input[47] << 20) |
			((uint32_t)(input[48] & 0xf0) << 12);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 388 to 403
	value = ((uint32_t)(input[48] & 0x0f) << 28) |
			((uint32_t)input[49] << 20) |
			((uint32_t)(input[50] & 0xf0) << 12);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 404 to 419
	value = ((uint32_t)(input[50] & 0x0f) << 28) |
			((uint32_t)input[51] << 20) |
			((uint32_t)(input[52] & 0xf0) << 12);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 420 to 435
	value = ((uint32_t)(input[52] & 0x0f) << 28) |
			((uint32_t)input[53] << 20) |
			((uint32_t)(input[54] & 0xf0) << 12);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 436 to 451
	value = ((uint32_t)(input[54] & 0x0f) << 28) |
			((uint32_t)input[55] << 20) |
			((uint32_t)(input[56] & 0xf0) << 12);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 452 to 467
	value = ((uint32_t)(input[56] & 0x0f) << 28) |
			((uint32_t)input[57] << 20) |
			((uint32_t)(input[58] & 0xf0) << 12);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 468 to 483
	value = ((uint32_t)(input[58] & 0x0f) << 28) |
			((uint32_t)input[59] << 20) |
			((uint32_t)(input[60] & 0xf0) << 12);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 484 to 499
	value = ((uint32_t)(input[60] & 0x0f) << 28) |
			((uint32_t)input[61] << 20) |
			((uint32_t)(input[62] & 0xf0) << 12);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 500 to 515
	value = ((uint32_t)(input[62] & 0x0f) << 28) |
			((uint32_t)input[63] << 20) |
			((uint32_t)(input[64] & 0xf0) << 12);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 516 to 531
	value = ((uint32_t)(input[64] & 0x0f) << 28) |
			((uint32_t)input[65] << 20) |
			((uint32_t)(input[66] & 0xf0) << 12);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 532 to 547
	value = ((uint32_t)(input[66] & 0x0f) << 28) |
			((uint32_t)input[67] << 20) |
			((uint32_t)(input[68] & 0xf0) << 12);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 548 to 563
	value = ((uint32_t)(input[68] & 0x0f) << 28) |
			((uint32_t)input[69] << 20) |
			((uint32_t)(input[70] & 0xf0) << 12);
	output[34] = (double)(value >> 16);
}

static void unpack_35_16bit_unsigned_4off(const uint8_t * input, double * output, void *closure) {
	// Unpack 35 values into output
	// Values are 16-bit unsigned
	// Skip 4 bits, read 560 bits of data.
	// Input must be at least 71 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 4 to 19
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20) |
			((uint32_t)(input[2] & 0xf0) << 12);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 20 to 35
	value = ((uint32_t)(input[2] & 0x0f) << 28) |
			((uint32_t)input[3] << 20) |
			((uint32_t)(input[4] & 0xf0) << 12);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 36 to 51
	value = ((uint32_t)(input[4] & 0x0f) << 28) |
			((uint32_t)input[5] << 20) |
			((uint32_t)(input[6] & 0xf0) << 12);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 52 to 67
	value = ((uint32_t)(input[6] & 0x0f) << 28) |
			((uint32_t)input[7] << 20) |
			((uint32_t)(input[8] & 0xf0) << 12);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 68 to 83
	value = ((uint32_t)(input[8] & 0x0f) << 28) |
			((uint32_t)input[9] << 20) |
			((uint32_t)(input[10] & 0xf0) << 12);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 84 to 99
	value = ((uint32_t)(input[10] & 0x0f) << 28) |
			((uint32_t)input[11] << 20) |
			((uint32_t)(input[12] & 0xf0) << 12);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 100 to 115
	value = ((uint32_t)(input[12] & 0x0f) << 28) |
			((uint32_t)input[13] << 20) |
			((uint32_t)(input[14] & 0xf0) << 12);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 116 to 131
	value = ((uint32_t)(input[14] & 0x0f) << 28) |
			((uint32_t)input[15] << 20) |
			((uint32_t)(input[16] & 0xf0) << 12);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 132 to 147
	value = ((uint32_t)(input[16] & 0x0f) << 28) |
			((uint32_t)input[17] << 20) |
			((uint32_t)(input[18] & 0xf0) << 12);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 148 to 163
	value = ((uint32_t)(input[18] & 0x0f) << 28) |
			((uint32_t)input[19] << 20) |
			((uint32_t)(input[20] & 0xf0) << 12);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 164 to 179
	value = ((uint32_t)(input[20] & 0x0f) << 28) |
			((uint32_t)input[21] << 20) |
			((uint32_t)(input[22] & 0xf0) << 12);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 180 to 195
	value = ((uint32_t)(input[22] & 0x0f) << 28) |
			((uint32_t)input[23] << 20) |
			((uint32_t)(input[24] & 0xf0) << 12);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 196 to 211
	value = ((uint32_t)(input[24] & 0x0f) << 28) |
			((uint32_t)input[25] << 20) |
			((uint32_t)(input[26] & 0xf0) << 12);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 212 to 227
	value = ((uint32_t)(input[26] & 0x0f) << 28) |
			((uint32_t)input[27] << 20) |
			((uint32_t)(input[28] & 0xf0) << 12);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 228 to 243
	value = ((uint32_t)(input[28] & 0x0f) << 28) |
			((uint32_t)input[29] << 20) |
			((uint32_t)(input[30] & 0xf0) << 12);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 244 to 259
	value = ((uint32_t)(input[30] & 0x0f) << 28) |
			((uint32_t)input[31] << 20) |
			((uint32_t)(input[32] & 0xf0) << 12);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 260 to 275
	value = ((uint32_t)(input[32] & 0x0f) << 28) |
			((uint32_t)input[33] << 20) |
			((uint32_t)(input[34] & 0xf0) << 12);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 276 to 291
	value = ((uint32_t)(input[34] & 0x0f) << 28) |
			((uint32_t)input[35] << 20) |
			((uint32_t)(input[36] & 0xf0) << 12);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 292 to 307
	value = ((uint32_t)(input[36] & 0x0f) << 28) |
			((uint32_t)input[37] << 20) |
			((uint32_t)(input[38] & 0xf0) << 12);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 308 to 323
	value = ((uint32_t)(input[38] & 0x0f) << 28) |
			((uint32_t)input[39] << 20) |
			((uint32_t)(input[40] & 0xf0) << 12);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 324 to 339
	value = ((uint32_t)(input[40] & 0x0f) << 28) |
			((uint32_t)input[41] << 20) |
			((uint32_t)(input[42] & 0xf0) << 12);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 340 to 355
	value = ((uint32_t)(input[42] & 0x0f) << 28) |
			((uint32_t)input[43] << 20) |
			((uint32_t)(input[44] & 0xf0) << 12);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 356 to 371
	value = ((uint32_t)(input[44] & 0x0f) << 28) |
			((uint32_t)input[45] << 20) |
			((uint32_t)(input[46] & 0xf0) << 12);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 372 to 387
	value = ((uint32_t)(input[46] & 0x0f) << 28) |
			((uint32_t)input[47] << 20) |
			((uint32_t)(input[48] & 0xf0) << 12);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 388 to 403
	value = ((uint32_t)(input[48] & 0x0f) << 28) |
			((uint32_t)input[49] << 20) |
			((uint32_t)(input[50] & 0xf0) << 12);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 404 to 419
	value = ((uint32_t)(input[50] & 0x0f) << 28) |
			((uint32_t)input[51] << 20) |
			((uint32_t)(input[52] & 0xf0) << 12);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 420 to 435
	value = ((uint32_t)(input[52] & 0x0f) << 28) |
			((uint32_t)input[53] << 20) |
			((uint32_t)(input[54] & 0xf0) << 12);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 436 to 451
	value = ((uint32_t)(input[54] & 0x0f) << 28) |
			((uint32_t)input[55] << 20) |
			((uint32_t)(input[56] & 0xf0) << 12);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 452 to 467
	value = ((uint32_t)(input[56] & 0x0f) << 28) |
			((uint32_t)input[57] << 20) |
			((uint32_t)(input[58] & 0xf0) << 12);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 468 to 483
	value = ((uint32_t)(input[58] & 0x0f) << 28) |
			((uint32_t)input[59] << 20) |
			((uint32_t)(input[60] & 0xf0) << 12);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 484 to 499
	value = ((uint32_t)(input[60] & 0x0f) << 28) |
			((uint32_t)input[61] << 20) |
			((uint32_t)(input[62] & 0xf0) << 12);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 500 to 515
	value = ((uint32_t)(input[62] & 0x0f) << 28) |
			((uint32_t)input[63] << 20) |
			((uint32_t)(input[64] & 0xf0) << 12);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 516 to 531
	value = ((uint32_t)(input[64] & 0x0f) << 28) |
			((uint32_t)input[65] << 20) |
			((uint32_t)(input[66] & 0xf0) << 12);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 532 to 547
	value = ((uint32_t)(input[66] & 0x0f) << 28) |
			((uint32_t)input[67] << 20) |
			((uint32_t)(input[68] & 0xf0) << 12);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 548 to 563
	value = ((uint32_t)(input[68] & 0x0f) << 28) |
			((uint32_t)input[69] << 20) |
			((uint32_t)(input[70] & 0xf0) << 12);
	output[34] = (double)(value >> 16);
}

static void unpack_35_16bit_signed_5off(const uint8_t * input, double * output, void *closure) {
	// Unpack 35 values into output
	// Values are 16-bit signed
	// Skip 5 bits, read 560 bits of data.
	// Input must be at least 71 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 5 to 20
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)(input[2] & 0xf8) << 13);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 21 to 36
	value = ((uint32_t)(input[2] & 0x07) << 29) |
			((uint32_t)input[3] << 21) |
			((uint32_t)(input[4] & 0xf8) << 13);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 37 to 52
	value = ((uint32_t)(input[4] & 0x07) << 29) |
			((uint32_t)input[5] << 21) |
			((uint32_t)(input[6] & 0xf8) << 13);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 53 to 68
	value = ((uint32_t)(input[6] & 0x07) << 29) |
			((uint32_t)input[7] << 21) |
			((uint32_t)(input[8] & 0xf8) << 13);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 69 to 84
	value = ((uint32_t)(input[8] & 0x07) << 29) |
			((uint32_t)input[9] << 21) |
			((uint32_t)(input[10] & 0xf8) << 13);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 85 to 100
	value = ((uint32_t)(input[10] & 0x07) << 29) |
			((uint32_t)input[11] << 21) |
			((uint32_t)(input[12] & 0xf8) << 13);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 101 to 116
	value = ((uint32_t)(input[12] & 0x07) << 29) |
			((uint32_t)input[13] << 21) |
			((uint32_t)(input[14] & 0xf8) << 13);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 117 to 132
	value = ((uint32_t)(input[14] & 0x07) << 29) |
			((uint32_t)input[15] << 21) |
			((uint32_t)(input[16] & 0xf8) << 13);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 133 to 148
	value = ((uint32_t)(input[16] & 0x07) << 29) |
			((uint32_t)input[17] << 21) |
			((uint32_t)(input[18] & 0xf8) << 13);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 149 to 164
	value = ((uint32_t)(input[18] & 0x07) << 29) |
			((uint32_t)input[19] << 21) |
			((uint32_t)(input[20] & 0xf8) << 13);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 165 to 180
	value = ((uint32_t)(input[20] & 0x07) << 29) |
			((uint32_t)input[21] << 21) |
			((uint32_t)(input[22] & 0xf8) << 13);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 181 to 196
	value = ((uint32_t)(input[22] & 0x07) << 29) |
			((uint32_t)input[23] << 21) |
			((uint32_t)(input[24] & 0xf8) << 13);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 197 to 212
	value = ((uint32_t)(input[24] & 0x07) << 29) |
			((uint32_t)input[25] << 21) |
			((uint32_t)(input[26] & 0xf8) << 13);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 213 to 228
	value = ((uint32_t)(input[26] & 0x07) << 29) |
			((uint32_t)input[27] << 21) |
			((uint32_t)(input[28] & 0xf8) << 13);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 229 to 244
	value = ((uint32_t)(input[28] & 0x07) << 29) |
			((uint32_t)input[29] << 21) |
			((uint32_t)(input[30] & 0xf8) << 13);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 245 to 260
	value = ((uint32_t)(input[30] & 0x07) << 29) |
			((uint32_t)input[31] << 21) |
			((uint32_t)(input[32] & 0xf8) << 13);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 261 to 276
	value = ((uint32_t)(input[32] & 0x07) << 29) |
			((uint32_t)input[33] << 21) |
			((uint32_t)(input[34] & 0xf8) << 13);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 277 to 292
	value = ((uint32_t)(input[34] & 0x07) << 29) |
			((uint32_t)input[35] << 21) |
			((uint32_t)(input[36] & 0xf8) << 13);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 293 to 308
	value = ((uint32_t)(input[36] & 0x07) << 29) |
			((uint32_t)input[37] << 21) |
			((uint32_t)(input[38] & 0xf8) << 13);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 309 to 324
	value = ((uint32_t)(input[38] & 0x07) << 29) |
			((uint32_t)input[39] << 21) |
			((uint32_t)(input[40] & 0xf8) << 13);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 325 to 340
	value = ((uint32_t)(input[40] & 0x07) << 29) |
			((uint32_t)input[41] << 21) |
			((uint32_t)(input[42] & 0xf8) << 13);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 341 to 356
	value = ((uint32_t)(input[42] & 0x07) << 29) |
			((uint32_t)input[43] << 21) |
			((uint32_t)(input[44] & 0xf8) << 13);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 357 to 372
	value = ((uint32_t)(input[44] & 0x07) << 29) |
			((uint32_t)input[45] << 21) |
			((uint32_t)(input[46] & 0xf8) << 13);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 373 to 388
	value = ((uint32_t)(input[46] & 0x07) << 29) |
			((uint32_t)input[47] << 21) |
			((uint32_t)(input[48] & 0xf8) << 13);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 389 to 404
	value = ((uint32_t)(input[48] & 0x07) << 29) |
			((uint32_t)input[49] << 21) |
			((uint32_t)(input[50] & 0xf8) << 13);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 405 to 420
	value = ((uint32_t)(input[50] & 0x07) << 29) |
			((uint32_t)input[51] << 21) |
			((uint32_t)(input[52] & 0xf8) << 13);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 421 to 436
	value = ((uint32_t)(input[52] & 0x07) << 29) |
			((uint32_t)input[53] << 21) |
			((uint32_t)(input[54] & 0xf8) << 13);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 437 to 452
	value = ((uint32_t)(input[54] & 0x07) << 29) |
			((uint32_t)input[55] << 21) |
			((uint32_t)(input[56] & 0xf8) << 13);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 453 to 468
	value = ((uint32_t)(input[56] & 0x07) << 29) |
			((uint32_t)input[57] << 21) |
			((uint32_t)(input[58] & 0xf8) << 13);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 469 to 484
	value = ((uint32_t)(input[58] & 0x07) << 29) |
			((uint32_t)input[59] << 21) |
			((uint32_t)(input[60] & 0xf8) << 13);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 485 to 500
	value = ((uint32_t)(input[60] & 0x07) << 29) |
			((uint32_t)input[61] << 21) |
			((uint32_t)(input[62] & 0xf8) << 13);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 501 to 516
	value = ((uint32_t)(input[62] & 0x07) << 29) |
			((uint32_t)input[63] << 21) |
			((uint32_t)(input[64] & 0xf8) << 13);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 517 to 532
	value = ((uint32_t)(input[64] & 0x07) << 29) |
			((uint32_t)input[65] << 21) |
			((uint32_t)(input[66] & 0xf8) << 13);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 533 to 548
	value = ((uint32_t)(input[66] & 0x07) << 29) |
			((uint32_t)input[67] << 21) |
			((uint32_t)(input[68] & 0xf8) << 13);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 549 to 564
	value = ((uint32_t)(input[68] & 0x07) << 29) |
			((uint32_t)input[69] << 21) |
			((uint32_t)(input[70] & 0xf8) << 13);
	output[34] = (double)(value >> 16);
}

static void unpack_35_16bit_unsigned_5off(const uint8_t * input, double * output, void *closure) {
	// Unpack 35 values into output
	// Values are 16-bit unsigned
	// Skip 5 bits, read 560 bits of data.
	// Input must be at least 71 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 5 to 20
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)(input[2] & 0xf8) << 13);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 21 to 36
	value = ((uint32_t)(input[2] & 0x07) << 29) |
			((uint32_t)input[3] << 21) |
			((uint32_t)(input[4] & 0xf8) << 13);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 37 to 52
	value = ((uint32_t)(input[4] & 0x07) << 29) |
			((uint32_t)input[5] << 21) |
			((uint32_t)(input[6] & 0xf8) << 13);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 53 to 68
	value = ((uint32_t)(input[6] & 0x07) << 29) |
			((uint32_t)input[7] << 21) |
			((uint32_t)(input[8] & 0xf8) << 13);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 69 to 84
	value = ((uint32_t)(input[8] & 0x07) << 29) |
			((uint32_t)input[9] << 21) |
			((uint32_t)(input[10] & 0xf8) << 13);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 85 to 100
	value = ((uint32_t)(input[10] & 0x07) << 29) |
			((uint32_t)input[11] << 21) |
			((uint32_t)(input[12] & 0xf8) << 13);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 101 to 116
	value = ((uint32_t)(input[12] & 0x07) << 29) |
			((uint32_t)input[13] << 21) |
			((uint32_t)(input[14] & 0xf8) << 13);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 117 to 132
	value = ((uint32_t)(input[14] & 0x07) << 29) |
			((uint32_t)input[15] << 21) |
			((uint32_t)(input[16] & 0xf8) << 13);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 133 to 148
	value = ((uint32_t)(input[16] & 0x07) << 29) |
			((uint32_t)input[17] << 21) |
			((uint32_t)(input[18] & 0xf8) << 13);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 149 to 164
	value = ((uint32_t)(input[18] & 0x07) << 29) |
			((uint32_t)input[19] << 21) |
			((uint32_t)(input[20] & 0xf8) << 13);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 165 to 180
	value = ((uint32_t)(input[20] & 0x07) << 29) |
			((uint32_t)input[21] << 21) |
			((uint32_t)(input[22] & 0xf8) << 13);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 181 to 196
	value = ((uint32_t)(input[22] & 0x07) << 29) |
			((uint32_t)input[23] << 21) |
			((uint32_t)(input[24] & 0xf8) << 13);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 197 to 212
	value = ((uint32_t)(input[24] & 0x07) << 29) |
			((uint32_t)input[25] << 21) |
			((uint32_t)(input[26] & 0xf8) << 13);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 213 to 228
	value = ((uint32_t)(input[26] & 0x07) << 29) |
			((uint32_t)input[27] << 21) |
			((uint32_t)(input[28] & 0xf8) << 13);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 229 to 244
	value = ((uint32_t)(input[28] & 0x07) << 29) |
			((uint32_t)input[29] << 21) |
			((uint32_t)(input[30] & 0xf8) << 13);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 245 to 260
	value = ((uint32_t)(input[30] & 0x07) << 29) |
			((uint32_t)input[31] << 21) |
			((uint32_t)(input[32] & 0xf8) << 13);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 261 to 276
	value = ((uint32_t)(input[32] & 0x07) << 29) |
			((uint32_t)input[33] << 21) |
			((uint32_t)(input[34] & 0xf8) << 13);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 277 to 292
	value = ((uint32_t)(input[34] & 0x07) << 29) |
			((uint32_t)input[35] << 21) |
			((uint32_t)(input[36] & 0xf8) << 13);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 293 to 308
	value = ((uint32_t)(input[36] & 0x07) << 29) |
			((uint32_t)input[37] << 21) |
			((uint32_t)(input[38] & 0xf8) << 13);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 309 to 324
	value = ((uint32_t)(input[38] & 0x07) << 29) |
			((uint32_t)input[39] << 21) |
			((uint32_t)(input[40] & 0xf8) << 13);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 325 to 340
	value = ((uint32_t)(input[40] & 0x07) << 29) |
			((uint32_t)input[41] << 21) |
			((uint32_t)(input[42] & 0xf8) << 13);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 341 to 356
	value = ((uint32_t)(input[42] & 0x07) << 29) |
			((uint32_t)input[43] << 21) |
			((uint32_t)(input[44] & 0xf8) << 13);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 357 to 372
	value = ((uint32_t)(input[44] & 0x07) << 29) |
			((uint32_t)input[45] << 21) |
			((uint32_t)(input[46] & 0xf8) << 13);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 373 to 388
	value = ((uint32_t)(input[46] & 0x07) << 29) |
			((uint32_t)input[47] << 21) |
			((uint32_t)(input[48] & 0xf8) << 13);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 389 to 404
	value = ((uint32_t)(input[48] & 0x07) << 29) |
			((uint32_t)input[49] << 21) |
			((uint32_t)(input[50] & 0xf8) << 13);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 405 to 420
	value = ((uint32_t)(input[50] & 0x07) << 29) |
			((uint32_t)input[51] << 21) |
			((uint32_t)(input[52] & 0xf8) << 13);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 421 to 436
	value = ((uint32_t)(input[52] & 0x07) << 29) |
			((uint32_t)input[53] << 21) |
			((uint32_t)(input[54] & 0xf8) << 13);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 437 to 452
	value = ((uint32_t)(input[54] & 0x07) << 29) |
			((uint32_t)input[55] << 21) |
			((uint32_t)(input[56] & 0xf8) << 13);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 453 to 468
	value = ((uint32_t)(input[56] & 0x07) << 29) |
			((uint32_t)input[57] << 21) |
			((uint32_t)(input[58] & 0xf8) << 13);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 469 to 484
	value = ((uint32_t)(input[58] & 0x07) << 29) |
			((uint32_t)input[59] << 21) |
			((uint32_t)(input[60] & 0xf8) << 13);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 485 to 500
	value = ((uint32_t)(input[60] & 0x07) << 29) |
			((uint32_t)input[61] << 21) |
			((uint32_t)(input[62] & 0xf8) << 13);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 501 to 516
	value = ((uint32_t)(input[62] & 0x07) << 29) |
			((uint32_t)input[63] << 21) |
			((uint32_t)(input[64] & 0xf8) << 13);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 517 to 532
	value = ((uint32_t)(input[64] & 0x07) << 29) |
			((uint32_t)input[65] << 21) |
			((uint32_t)(input[66] & 0xf8) << 13);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 533 to 548
	value = ((uint32_t)(input[66] & 0x07) << 29) |
			((uint32_t)input[67] << 21) |
			((uint32_t)(input[68] & 0xf8) << 13);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 549 to 564
	value = ((uint32_t)(input[68] & 0x07) << 29) |
			((uint32_t)input[69] << 21) |
			((uint32_t)(input[70] & 0xf8) << 13);
	output[34] = (double)(value >> 16);
}

static void unpack_35_16bit_signed_6off(const uint8_t * input, double * output, void *closure) {
	// Unpack 35 values into output
	// Values are 16-bit signed
	// Skip 6 bits, read 560 bits of data.
	// Input must be at least 71 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 6 to 21
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)(input[2] & 0xfc) << 14);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 22 to 37
	value = ((uint32_t)(input[2] & 0x03) << 30) |
			((uint32_t)input[3] << 22) |
			((uint32_t)(input[4] & 0xfc) << 14);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 38 to 53
	value = ((uint32_t)(input[4] & 0x03) << 30) |
			((uint32_t)input[5] << 22) |
			((uint32_t)(input[6] & 0xfc) << 14);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 54 to 69
	value = ((uint32_t)(input[6] & 0x03) << 30) |
			((uint32_t)input[7] << 22) |
			((uint32_t)(input[8] & 0xfc) << 14);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 70 to 85
	value = ((uint32_t)(input[8] & 0x03) << 30) |
			((uint32_t)input[9] << 22) |
			((uint32_t)(input[10] & 0xfc) << 14);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 86 to 101
	value = ((uint32_t)(input[10] & 0x03) << 30) |
			((uint32_t)input[11] << 22) |
			((uint32_t)(input[12] & 0xfc) << 14);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 102 to 117
	value = ((uint32_t)(input[12] & 0x03) << 30) |
			((uint32_t)input[13] << 22) |
			((uint32_t)(input[14] & 0xfc) << 14);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 118 to 133
	value = ((uint32_t)(input[14] & 0x03) << 30) |
			((uint32_t)input[15] << 22) |
			((uint32_t)(input[16] & 0xfc) << 14);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 134 to 149
	value = ((uint32_t)(input[16] & 0x03) << 30) |
			((uint32_t)input[17] << 22) |
			((uint32_t)(input[18] & 0xfc) << 14);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 150 to 165
	value = ((uint32_t)(input[18] & 0x03) << 30) |
			((uint32_t)input[19] << 22) |
			((uint32_t)(input[20] & 0xfc) << 14);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 166 to 181
	value = ((uint32_t)(input[20] & 0x03) << 30) |
			((uint32_t)input[21] << 22) |
			((uint32_t)(input[22] & 0xfc) << 14);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 182 to 197
	value = ((uint32_t)(input[22] & 0x03) << 30) |
			((uint32_t)input[23] << 22) |
			((uint32_t)(input[24] & 0xfc) << 14);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 198 to 213
	value = ((uint32_t)(input[24] & 0x03) << 30) |
			((uint32_t)input[25] << 22) |
			((uint32_t)(input[26] & 0xfc) << 14);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 214 to 229
	value = ((uint32_t)(input[26] & 0x03) << 30) |
			((uint32_t)input[27] << 22) |
			((uint32_t)(input[28] & 0xfc) << 14);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 230 to 245
	value = ((uint32_t)(input[28] & 0x03) << 30) |
			((uint32_t)input[29] << 22) |
			((uint32_t)(input[30] & 0xfc) << 14);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 246 to 261
	value = ((uint32_t)(input[30] & 0x03) << 30) |
			((uint32_t)input[31] << 22) |
			((uint32_t)(input[32] & 0xfc) << 14);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 262 to 277
	value = ((uint32_t)(input[32] & 0x03) << 30) |
			((uint32_t)input[33] << 22) |
			((uint32_t)(input[34] & 0xfc) << 14);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 278 to 293
	value = ((uint32_t)(input[34] & 0x03) << 30) |
			((uint32_t)input[35] << 22) |
			((uint32_t)(input[36] & 0xfc) << 14);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 294 to 309
	value = ((uint32_t)(input[36] & 0x03) << 30) |
			((uint32_t)input[37] << 22) |
			((uint32_t)(input[38] & 0xfc) << 14);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 310 to 325
	value = ((uint32_t)(input[38] & 0x03) << 30) |
			((uint32_t)input[39] << 22) |
			((uint32_t)(input[40] & 0xfc) << 14);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 326 to 341
	value = ((uint32_t)(input[40] & 0x03) << 30) |
			((uint32_t)input[41] << 22) |
			((uint32_t)(input[42] & 0xfc) << 14);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 342 to 357
	value = ((uint32_t)(input[42] & 0x03) << 30) |
			((uint32_t)input[43] << 22) |
			((uint32_t)(input[44] & 0xfc) << 14);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 358 to 373
	value = ((uint32_t)(input[44] & 0x03) << 30) |
			((uint32_t)input[45] << 22) |
			((uint32_t)(input[46] & 0xfc) << 14);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 374 to 389
	value = ((uint32_t)(input[46] & 0x03) << 30) |
			((uint32_t)input[47] << 22) |
			((uint32_t)(input[48] & 0xfc) << 14);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 390 to 405
	value = ((uint32_t)(input[48] & 0x03) << 30) |
			((uint32_t)input[49] << 22) |
			((uint32_t)(input[50] & 0xfc) << 14);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 406 to 421
	value = ((uint32_t)(input[50] & 0x03) << 30) |
			((uint32_t)input[51] << 22) |
			((uint32_t)(input[52] & 0xfc) << 14);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 422 to 437
	value = ((uint32_t)(input[52] & 0x03) << 30) |
			((uint32_t)input[53] << 22) |
			((uint32_t)(input[54] & 0xfc) << 14);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 438 to 453
	value = ((uint32_t)(input[54] & 0x03) << 30) |
			((uint32_t)input[55] << 22) |
			((uint32_t)(input[56] & 0xfc) << 14);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 454 to 469
	value = ((uint32_t)(input[56] & 0x03) << 30) |
			((uint32_t)input[57] << 22) |
			((uint32_t)(input[58] & 0xfc) << 14);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 470 to 485
	value = ((uint32_t)(input[58] & 0x03) << 30) |
			((uint32_t)input[59] << 22) |
			((uint32_t)(input[60] & 0xfc) << 14);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 486 to 501
	value = ((uint32_t)(input[60] & 0x03) << 30) |
			((uint32_t)input[61] << 22) |
			((uint32_t)(input[62] & 0xfc) << 14);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 502 to 517
	value = ((uint32_t)(input[62] & 0x03) << 30) |
			((uint32_t)input[63] << 22) |
			((uint32_t)(input[64] & 0xfc) << 14);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 518 to 533
	value = ((uint32_t)(input[64] & 0x03) << 30) |
			((uint32_t)input[65] << 22) |
			((uint32_t)(input[66] & 0xfc) << 14);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 534 to 549
	value = ((uint32_t)(input[66] & 0x03) << 30) |
			((uint32_t)input[67] << 22) |
			((uint32_t)(input[68] & 0xfc) << 14);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 550 to 565
	value = ((uint32_t)(input[68] & 0x03) << 30) |
			((uint32_t)input[69] << 22) |
			((uint32_t)(input[70] & 0xfc) << 14);
	output[34] = (double)(value >> 16);
}

static void unpack_35_16bit_unsigned_6off(const uint8_t * input, double * output, void *closure) {
	// Unpack 35 values into output
	// Values are 16-bit unsigned
	// Skip 6 bits, read 560 bits of data.
	// Input must be at least 71 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 6 to 21
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)(input[2] & 0xfc) << 14);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 22 to 37
	value = ((uint32_t)(input[2] & 0x03) << 30) |
			((uint32_t)input[3] << 22) |
			((uint32_t)(input[4] & 0xfc) << 14);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 38 to 53
	value = ((uint32_t)(input[4] & 0x03) << 30) |
			((uint32_t)input[5] << 22) |
			((uint32_t)(input[6] & 0xfc) << 14);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 54 to 69
	value = ((uint32_t)(input[6] & 0x03) << 30) |
			((uint32_t)input[7] << 22) |
			((uint32_t)(input[8] & 0xfc) << 14);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 70 to 85
	value = ((uint32_t)(input[8] & 0x03) << 30) |
			((uint32_t)input[9] << 22) |
			((uint32_t)(input[10] & 0xfc) << 14);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 86 to 101
	value = ((uint32_t)(input[10] & 0x03) << 30) |
			((uint32_t)input[11] << 22) |
			((uint32_t)(input[12] & 0xfc) << 14);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 102 to 117
	value = ((uint32_t)(input[12] & 0x03) << 30) |
			((uint32_t)input[13] << 22) |
			((uint32_t)(input[14] & 0xfc) << 14);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 118 to 133
	value = ((uint32_t)(input[14] & 0x03) << 30) |
			((uint32_t)input[15] << 22) |
			((uint32_t)(input[16] & 0xfc) << 14);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 134 to 149
	value = ((uint32_t)(input[16] & 0x03) << 30) |
			((uint32_t)input[17] << 22) |
			((uint32_t)(input[18] & 0xfc) << 14);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 150 to 165
	value = ((uint32_t)(input[18] & 0x03) << 30) |
			((uint32_t)input[19] << 22) |
			((uint32_t)(input[20] & 0xfc) << 14);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 166 to 181
	value = ((uint32_t)(input[20] & 0x03) << 30) |
			((uint32_t)input[21] << 22) |
			((uint32_t)(input[22] & 0xfc) << 14);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 182 to 197
	value = ((uint32_t)(input[22] & 0x03) << 30) |
			((uint32_t)input[23] << 22) |
			((uint32_t)(input[24] & 0xfc) << 14);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 198 to 213
	value = ((uint32_t)(input[24] & 0x03) << 30) |
			((uint32_t)input[25] << 22) |
			((uint32_t)(input[26] & 0xfc) << 14);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 214 to 229
	value = ((uint32_t)(input[26] & 0x03) << 30) |
			((uint32_t)input[27] << 22) |
			((uint32_t)(input[28] & 0xfc) << 14);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 230 to 245
	value = ((uint32_t)(input[28] & 0x03) << 30) |
			((uint32_t)input[29] << 22) |
			((uint32_t)(input[30] & 0xfc) << 14);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 246 to 261
	value = ((uint32_t)(input[30] & 0x03) << 30) |
			((uint32_t)input[31] << 22) |
			((uint32_t)(input[32] & 0xfc) << 14);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 262 to 277
	value = ((uint32_t)(input[32] & 0x03) << 30) |
			((uint32_t)input[33] << 22) |
			((uint32_t)(input[34] & 0xfc) << 14);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 278 to 293
	value = ((uint32_t)(input[34] & 0x03) << 30) |
			((uint32_t)input[35] << 22) |
			((uint32_t)(input[36] & 0xfc) << 14);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 294 to 309
	value = ((uint32_t)(input[36] & 0x03) << 30) |
			((uint32_t)input[37] << 22) |
			((uint32_t)(input[38] & 0xfc) << 14);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 310 to 325
	value = ((uint32_t)(input[38] & 0x03) << 30) |
			((uint32_t)input[39] << 22) |
			((uint32_t)(input[40] & 0xfc) << 14);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 326 to 341
	value = ((uint32_t)(input[40] & 0x03) << 30) |
			((uint32_t)input[41] << 22) |
			((uint32_t)(input[42] & 0xfc) << 14);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 342 to 357
	value = ((uint32_t)(input[42] & 0x03) << 30) |
			((uint32_t)input[43] << 22) |
			((uint32_t)(input[44] & 0xfc) << 14);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 358 to 373
	value = ((uint32_t)(input[44] & 0x03) << 30) |
			((uint32_t)input[45] << 22) |
			((uint32_t)(input[46] & 0xfc) << 14);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 374 to 389
	value = ((uint32_t)(input[46] & 0x03) << 30) |
			((uint32_t)input[47] << 22) |
			((uint32_t)(input[48] & 0xfc) << 14);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 390 to 405
	value = ((uint32_t)(input[48] & 0x03) << 30) |
			((uint32_t)input[49] << 22) |
			((uint32_t)(input[50] & 0xfc) << 14);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 406 to 421
	value = ((uint32_t)(input[50] & 0x03) << 30) |
			((uint32_t)input[51] << 22) |
			((uint32_t)(input[52] & 0xfc) << 14);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 422 to 437
	value = ((uint32_t)(input[52] & 0x03) << 30) |
			((uint32_t)input[53] << 22) |
			((uint32_t)(input[54] & 0xfc) << 14);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 438 to 453
	value = ((uint32_t)(input[54] & 0x03) << 30) |
			((uint32_t)input[55] << 22) |
			((uint32_t)(input[56] & 0xfc) << 14);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 454 to 469
	value = ((uint32_t)(input[56] & 0x03) << 30) |
			((uint32_t)input[57] << 22) |
			((uint32_t)(input[58] & 0xfc) << 14);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 470 to 485
	value = ((uint32_t)(input[58] & 0x03) << 30) |
			((uint32_t)input[59] << 22) |
			((uint32_t)(input[60] & 0xfc) << 14);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 486 to 501
	value = ((uint32_t)(input[60] & 0x03) << 30) |
			((uint32_t)input[61] << 22) |
			((uint32_t)(input[62] & 0xfc) << 14);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 502 to 517
	value = ((uint32_t)(input[62] & 0x03) << 30) |
			((uint32_t)input[63] << 22) |
			((uint32_t)(input[64] & 0xfc) << 14);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 518 to 533
	value = ((uint32_t)(input[64] & 0x03) << 30) |
			((uint32_t)input[65] << 22) |
			((uint32_t)(input[66] & 0xfc) << 14);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 534 to 549
	value = ((uint32_t)(input[66] & 0x03) << 30) |
			((uint32_t)input[67] << 22) |
			((uint32_t)(input[68] & 0xfc) << 14);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 550 to 565
	value = ((uint32_t)(input[68] & 0x03) << 30) |
			((uint32_t)input[69] << 22) |
			((uint32_t)(input[70] & 0xfc) << 14);
	output[34] = (double)(value >> 16);
}

static void unpack_35_16bit_signed_7off(const uint8_t * input, double * output, void *closure) {
	// Unpack 35 values into output
	// Values are 16-bit signed
	// Skip 7 bits, read 560 bits of data.
	// Input must be at least 71 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 7 to 22
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)(input[2] & 0xfe) << 15);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 23 to 38
	value = ((uint32_t)(input[2] & 0x01) << 31) |
			((uint32_t)input[3] << 23) |
			((uint32_t)(input[4] & 0xfe) << 15);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 39 to 54
	value = ((uint32_t)(input[4] & 0x01) << 31) |
			((uint32_t)input[5] << 23) |
			((uint32_t)(input[6] & 0xfe) << 15);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 55 to 70
	value = ((uint32_t)(input[6] & 0x01) << 31) |
			((uint32_t)input[7] << 23) |
			((uint32_t)(input[8] & 0xfe) << 15);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 71 to 86
	value = ((uint32_t)(input[8] & 0x01) << 31) |
			((uint32_t)input[9] << 23) |
			((uint32_t)(input[10] & 0xfe) << 15);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 87 to 102
	value = ((uint32_t)(input[10] & 0x01) << 31) |
			((uint32_t)input[11] << 23) |
			((uint32_t)(input[12] & 0xfe) << 15);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 103 to 118
	value = ((uint32_t)(input[12] & 0x01) << 31) |
			((uint32_t)input[13] << 23) |
			((uint32_t)(input[14] & 0xfe) << 15);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 119 to 134
	value = ((uint32_t)(input[14] & 0x01) << 31) |
			((uint32_t)input[15] << 23) |
			((uint32_t)(input[16] & 0xfe) << 15);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 135 to 150
	value = ((uint32_t)(input[16] & 0x01) << 31) |
			((uint32_t)input[17] << 23) |
			((uint32_t)(input[18] & 0xfe) << 15);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 151 to 166
	value = ((uint32_t)(input[18] & 0x01) << 31) |
			((uint32_t)input[19] << 23) |
			((uint32_t)(input[20] & 0xfe) << 15);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 167 to 182
	value = ((uint32_t)(input[20] & 0x01) << 31) |
			((uint32_t)input[21] << 23) |
			((uint32_t)(input[22] & 0xfe) << 15);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 183 to 198
	value = ((uint32_t)(input[22] & 0x01) << 31) |
			((uint32_t)input[23] << 23) |
			((uint32_t)(input[24] & 0xfe) << 15);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 199 to 214
	value = ((uint32_t)(input[24] & 0x01) << 31) |
			((uint32_t)input[25] << 23) |
			((uint32_t)(input[26] & 0xfe) << 15);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 215 to 230
	value = ((uint32_t)(input[26] & 0x01) << 31) |
			((uint32_t)input[27] << 23) |
			((uint32_t)(input[28] & 0xfe) << 15);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 231 to 246
	value = ((uint32_t)(input[28] & 0x01) << 31) |
			((uint32_t)input[29] << 23) |
			((uint32_t)(input[30] & 0xfe) << 15);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 247 to 262
	value = ((uint32_t)(input[30] & 0x01) << 31) |
			((uint32_t)input[31] << 23) |
			((uint32_t)(input[32] & 0xfe) << 15);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 263 to 278
	value = ((uint32_t)(input[32] & 0x01) << 31) |
			((uint32_t)input[33] << 23) |
			((uint32_t)(input[34] & 0xfe) << 15);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 279 to 294
	value = ((uint32_t)(input[34] & 0x01) << 31) |
			((uint32_t)input[35] << 23) |
			((uint32_t)(input[36] & 0xfe) << 15);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 295 to 310
	value = ((uint32_t)(input[36] & 0x01) << 31) |
			((uint32_t)input[37] << 23) |
			((uint32_t)(input[38] & 0xfe) << 15);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 311 to 326
	value = ((uint32_t)(input[38] & 0x01) << 31) |
			((uint32_t)input[39] << 23) |
			((uint32_t)(input[40] & 0xfe) << 15);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 327 to 342
	value = ((uint32_t)(input[40] & 0x01) << 31) |
			((uint32_t)input[41] << 23) |
			((uint32_t)(input[42] & 0xfe) << 15);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 343 to 358
	value = ((uint32_t)(input[42] & 0x01) << 31) |
			((uint32_t)input[43] << 23) |
			((uint32_t)(input[44] & 0xfe) << 15);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 359 to 374
	value = ((uint32_t)(input[44] & 0x01) << 31) |
			((uint32_t)input[45] << 23) |
			((uint32_t)(input[46] & 0xfe) << 15);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 375 to 390
	value = ((uint32_t)(input[46] & 0x01) << 31) |
			((uint32_t)input[47] << 23) |
			((uint32_t)(input[48] & 0xfe) << 15);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 391 to 406
	value = ((uint32_t)(input[48] & 0x01) << 31) |
			((uint32_t)input[49] << 23) |
			((uint32_t)(input[50] & 0xfe) << 15);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 407 to 422
	value = ((uint32_t)(input[50] & 0x01) << 31) |
			((uint32_t)input[51] << 23) |
			((uint32_t)(input[52] & 0xfe) << 15);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 423 to 438
	value = ((uint32_t)(input[52] & 0x01) << 31) |
			((uint32_t)input[53] << 23) |
			((uint32_t)(input[54] & 0xfe) << 15);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 439 to 454
	value = ((uint32_t)(input[54] & 0x01) << 31) |
			((uint32_t)input[55] << 23) |
			((uint32_t)(input[56] & 0xfe) << 15);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 455 to 470
	value = ((uint32_t)(input[56] & 0x01) << 31) |
			((uint32_t)input[57] << 23) |
			((uint32_t)(input[58] & 0xfe) << 15);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 471 to 486
	value = ((uint32_t)(input[58] & 0x01) << 31) |
			((uint32_t)input[59] << 23) |
			((uint32_t)(input[60] & 0xfe) << 15);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 487 to 502
	value = ((uint32_t)(input[60] & 0x01) << 31) |
			((uint32_t)input[61] << 23) |
			((uint32_t)(input[62] & 0xfe) << 15);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 503 to 518
	value = ((uint32_t)(input[62] & 0x01) << 31) |
			((uint32_t)input[63] << 23) |
			((uint32_t)(input[64] & 0xfe) << 15);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 519 to 534
	value = ((uint32_t)(input[64] & 0x01) << 31) |
			((uint32_t)input[65] << 23) |
			((uint32_t)(input[66] & 0xfe) << 15);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 535 to 550
	value = ((uint32_t)(input[66] & 0x01) << 31) |
			((uint32_t)input[67] << 23) |
			((uint32_t)(input[68] & 0xfe) << 15);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 551 to 566
	value = ((uint32_t)(input[68] & 0x01) << 31) |
			((uint32_t)input[69] << 23) |
			((uint32_t)(input[70] & 0xfe) << 15);
	output[34] = (double)(value >> 16);
}

static void unpack_35_16bit_unsigned_7off(const uint8_t * input, double * output, void *closure) {
	// Unpack 35 values into output
	// Values are 16-bit unsigned
	// Skip 7 bits, read 560 bits of data.
	// Input must be at least 71 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 7 to 22
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)(input[2] & 0xfe) << 15);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 23 to 38
	value = ((uint32_t)(input[2] & 0x01) << 31) |
			((uint32_t)input[3] << 23) |
			((uint32_t)(input[4] & 0xfe) << 15);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 39 to 54
	value = ((uint32_t)(input[4] & 0x01) << 31) |
			((uint32_t)input[5] << 23) |
			((uint32_t)(input[6] & 0xfe) << 15);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 55 to 70
	value = ((uint32_t)(input[6] & 0x01) << 31) |
			((uint32_t)input[7] << 23) |
			((uint32_t)(input[8] & 0xfe) << 15);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 71 to 86
	value = ((uint32_t)(input[8] & 0x01) << 31) |
			((uint32_t)input[9] << 23) |
			((uint32_t)(input[10] & 0xfe) << 15);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 87 to 102
	value = ((uint32_t)(input[10] & 0x01) << 31) |
			((uint32_t)input[11] << 23) |
			((uint32_t)(input[12] & 0xfe) << 15);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 103 to 118
	value = ((uint32_t)(input[12] & 0x01) << 31) |
			((uint32_t)input[13] << 23) |
			((uint32_t)(input[14] & 0xfe) << 15);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 119 to 134
	value = ((uint32_t)(input[14] & 0x01) << 31) |
			((uint32_t)input[15] << 23) |
			((uint32_t)(input[16] & 0xfe) << 15);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 135 to 150
	value = ((uint32_t)(input[16] & 0x01) << 31) |
			((uint32_t)input[17] << 23) |
			((uint32_t)(input[18] & 0xfe) << 15);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 151 to 166
	value = ((uint32_t)(input[18] & 0x01) << 31) |
			((uint32_t)input[19] << 23) |
			((uint32_t)(input[20] & 0xfe) << 15);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 167 to 182
	value = ((uint32_t)(input[20] & 0x01) << 31) |
			((uint32_t)input[21] << 23) |
			((uint32_t)(input[22] & 0xfe) << 15);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 183 to 198
	value = ((uint32_t)(input[22] & 0x01) << 31) |
			((uint32_t)input[23] << 23) |
			((uint32_t)(input[24] & 0xfe) << 15);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 199 to 214
	value = ((uint32_t)(input[24] & 0x01) << 31) |
			((uint32_t)input[25] << 23) |
			((uint32_t)(input[26] & 0xfe) << 15);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 215 to 230
	value = ((uint32_t)(input[26] & 0x01) << 31) |
			((uint32_t)input[27] << 23) |
			((uint32_t)(input[28] & 0xfe) << 15);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 231 to 246
	value = ((uint32_t)(input[28] & 0x01) << 31) |
			((uint32_t)input[29] << 23) |
			((uint32_t)(input[30] & 0xfe) << 15);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 247 to 262
	value = ((uint32_t)(input[30] & 0x01) << 31) |
			((uint32_t)input[31] << 23) |
			((uint32_t)(input[32] & 0xfe) << 15);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 263 to 278
	value = ((uint32_t)(input[32] & 0x01) << 31) |
			((uint32_t)input[33] << 23) |
			((uint32_t)(input[34] & 0xfe) << 15);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 279 to 294
	value = ((uint32_t)(input[34] & 0x01) << 31) |
			((uint32_t)input[35] << 23) |
			((uint32_t)(input[36] & 0xfe) << 15);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 295 to 310
	value = ((uint32_t)(input[36] & 0x01) << 31) |
			((uint32_t)input[37] << 23) |
			((uint32_t)(input[38] & 0xfe) << 15);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 311 to 326
	value = ((uint32_t)(input[38] & 0x01) << 31) |
			((uint32_t)input[39] << 23) |
			((uint32_t)(input[40] & 0xfe) << 15);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 327 to 342
	value = ((uint32_t)(input[40] & 0x01) << 31) |
			((uint32_t)input[41] << 23) |
			((uint32_t)(input[42] & 0xfe) << 15);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 343 to 358
	value = ((uint32_t)(input[42] & 0x01) << 31) |
			((uint32_t)input[43] << 23) |
			((uint32_t)(input[44] & 0xfe) << 15);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 359 to 374
	value = ((uint32_t)(input[44] & 0x01) << 31) |
			((uint32_t)input[45] << 23) |
			((uint32_t)(input[46] & 0xfe) << 15);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 375 to 390
	value = ((uint32_t)(input[46] & 0x01) << 31) |
			((uint32_t)input[47] << 23) |
			((uint32_t)(input[48] & 0xfe) << 15);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 391 to 406
	value = ((uint32_t)(input[48] & 0x01) << 31) |
			((uint32_t)input[49] << 23) |
			((uint32_t)(input[50] & 0xfe) << 15);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 407 to 422
	value = ((uint32_t)(input[50] & 0x01) << 31) |
			((uint32_t)input[51] << 23) |
			((uint32_t)(input[52] & 0xfe) << 15);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 423 to 438
	value = ((uint32_t)(input[52] & 0x01) << 31) |
			((uint32_t)input[53] << 23) |
			((uint32_t)(input[54] & 0xfe) << 15);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 439 to 454
	value = ((uint32_t)(input[54] & 0x01) << 31) |
			((uint32_t)input[55] << 23) |
			((uint32_t)(input[56] & 0xfe) << 15);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 455 to 470
	value = ((uint32_t)(input[56] & 0x01) << 31) |
			((uint32_t)input[57] << 23) |
			((uint32_t)(input[58] & 0xfe) << 15);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 471 to 486
	value = ((uint32_t)(input[58] & 0x01) << 31) |
			((uint32_t)input[59] << 23) |
			((uint32_t)(input[60] & 0xfe) << 15);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 487 to 502
	value = ((uint32_t)(input[60] & 0x01) << 31) |
			((uint32_t)input[61] << 23) |
			((uint32_t)(input[62] & 0xfe) << 15);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 503 to 518
	value = ((uint32_t)(input[62] & 0x01) << 31) |
			((uint32_t)input[63] << 23) |
			((uint32_t)(input[64] & 0xfe) << 15);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 519 to 534
	value = ((uint32_t)(input[64] & 0x01) << 31) |
			((uint32_t)input[65] << 23) |
			((uint32_t)(input[66] & 0xfe) << 15);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 535 to 550
	value = ((uint32_t)(input[66] & 0x01) << 31) |
			((uint32_t)input[67] << 23) |
			((uint32_t)(input[68] & 0xfe) << 15);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 551 to 566
	value = ((uint32_t)(input[68] & 0x01) << 31) |
			((uint32_t)input[69] << 23) |
			((uint32_t)(input[70] & 0xfe) << 15);
	output[34] = (double)(value >> 16);
}

static void unpack_36_16bit_signed_0off(const uint8_t * input, double * output, void *closure) {
	// Unpack 36 values into output
	// Values are 16-bit signed
	// Skip 0 bits, read 576 bits of data.
	// Input must be at least 72 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 0 to 15
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)input[1] << 16);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 16 to 31
	value = ((uint32_t)input[2] << 24) |
			((uint32_t)input[3] << 16);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 32 to 47
	value = ((uint32_t)input[4] << 24) |
			((uint32_t)input[5] << 16);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 48 to 63
	value = ((uint32_t)input[6] << 24) |
			((uint32_t)input[7] << 16);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 64 to 79
	value = ((uint32_t)input[8] << 24) |
			((uint32_t)input[9] << 16);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 80 to 95
	value = ((uint32_t)input[10] << 24) |
			((uint32_t)input[11] << 16);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 96 to 111
	value = ((uint32_t)input[12] << 24) |
			((uint32_t)input[13] << 16);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 112 to 127
	value = ((uint32_t)input[14] << 24) |
			((uint32_t)input[15] << 16);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 128 to 143
	value = ((uint32_t)input[16] << 24) |
			((uint32_t)input[17] << 16);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 144 to 159
	value = ((uint32_t)input[18] << 24) |
			((uint32_t)input[19] << 16);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 160 to 175
	value = ((uint32_t)input[20] << 24) |
			((uint32_t)input[21] << 16);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 176 to 191
	value = ((uint32_t)input[22] << 24) |
			((uint32_t)input[23] << 16);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 192 to 207
	value = ((uint32_t)input[24] << 24) |
			((uint32_t)input[25] << 16);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 208 to 223
	value = ((uint32_t)input[26] << 24) |
			((uint32_t)input[27] << 16);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 224 to 239
	value = ((uint32_t)input[28] << 24) |
			((uint32_t)input[29] << 16);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 240 to 255
	value = ((uint32_t)input[30] << 24) |
			((uint32_t)input[31] << 16);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 256 to 271
	value = ((uint32_t)input[32] << 24) |
			((uint32_t)input[33] << 16);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 272 to 287
	value = ((uint32_t)input[34] << 24) |
			((uint32_t)input[35] << 16);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 288 to 303
	value = ((uint32_t)input[36] << 24) |
			((uint32_t)input[37] << 16);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 304 to 319
	value = ((uint32_t)input[38] << 24) |
			((uint32_t)input[39] << 16);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 320 to 335
	value = ((uint32_t)input[40] << 24) |
			((uint32_t)input[41] << 16);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 336 to 351
	value = ((uint32_t)input[42] << 24) |
			((uint32_t)input[43] << 16);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 352 to 367
	value = ((uint32_t)input[44] << 24) |
			((uint32_t)input[45] << 16);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 368 to 383
	value = ((uint32_t)input[46] << 24) |
			((uint32_t)input[47] << 16);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 384 to 399
	value = ((uint32_t)input[48] << 24) |
			((uint32_t)input[49] << 16);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 400 to 415
	value = ((uint32_t)input[50] << 24) |
			((uint32_t)input[51] << 16);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 416 to 431
	value = ((uint32_t)input[52] << 24) |
			((uint32_t)input[53] << 16);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 432 to 447
	value = ((uint32_t)input[54] << 24) |
			((uint32_t)input[55] << 16);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 448 to 463
	value = ((uint32_t)input[56] << 24) |
			((uint32_t)input[57] << 16);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 464 to 479
	value = ((uint32_t)input[58] << 24) |
			((uint32_t)input[59] << 16);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 480 to 495
	value = ((uint32_t)input[60] << 24) |
			((uint32_t)input[61] << 16);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 496 to 511
	value = ((uint32_t)input[62] << 24) |
			((uint32_t)input[63] << 16);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 512 to 527
	value = ((uint32_t)input[64] << 24) |
			((uint32_t)input[65] << 16);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 528 to 543
	value = ((uint32_t)input[66] << 24) |
			((uint32_t)input[67] << 16);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 544 to 559
	value = ((uint32_t)input[68] << 24) |
			((uint32_t)input[69] << 16);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 560 to 575
	value = ((uint32_t)input[70] << 24) |
			((uint32_t)input[71] << 16);
	output[35] = (double)(value >> 16);
}

static void unpack_36_16bit_unsigned_0off(const uint8_t * input, double * output, void *closure) {
	// Unpack 36 values into output
	// Values are 16-bit unsigned
	// Skip 0 bits, read 576 bits of data.
	// Input must be at least 72 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 0 to 15
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)input[1] << 16);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 16 to 31
	value = ((uint32_t)input[2] << 24) |
			((uint32_t)input[3] << 16);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 32 to 47
	value = ((uint32_t)input[4] << 24) |
			((uint32_t)input[5] << 16);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 48 to 63
	value = ((uint32_t)input[6] << 24) |
			((uint32_t)input[7] << 16);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 64 to 79
	value = ((uint32_t)input[8] << 24) |
			((uint32_t)input[9] << 16);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 80 to 95
	value = ((uint32_t)input[10] << 24) |
			((uint32_t)input[11] << 16);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 96 to 111
	value = ((uint32_t)input[12] << 24) |
			((uint32_t)input[13] << 16);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 112 to 127
	value = ((uint32_t)input[14] << 24) |
			((uint32_t)input[15] << 16);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 128 to 143
	value = ((uint32_t)input[16] << 24) |
			((uint32_t)input[17] << 16);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 144 to 159
	value = ((uint32_t)input[18] << 24) |
			((uint32_t)input[19] << 16);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 160 to 175
	value = ((uint32_t)input[20] << 24) |
			((uint32_t)input[21] << 16);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 176 to 191
	value = ((uint32_t)input[22] << 24) |
			((uint32_t)input[23] << 16);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 192 to 207
	value = ((uint32_t)input[24] << 24) |
			((uint32_t)input[25] << 16);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 208 to 223
	value = ((uint32_t)input[26] << 24) |
			((uint32_t)input[27] << 16);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 224 to 239
	value = ((uint32_t)input[28] << 24) |
			((uint32_t)input[29] << 16);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 240 to 255
	value = ((uint32_t)input[30] << 24) |
			((uint32_t)input[31] << 16);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 256 to 271
	value = ((uint32_t)input[32] << 24) |
			((uint32_t)input[33] << 16);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 272 to 287
	value = ((uint32_t)input[34] << 24) |
			((uint32_t)input[35] << 16);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 288 to 303
	value = ((uint32_t)input[36] << 24) |
			((uint32_t)input[37] << 16);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 304 to 319
	value = ((uint32_t)input[38] << 24) |
			((uint32_t)input[39] << 16);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 320 to 335
	value = ((uint32_t)input[40] << 24) |
			((uint32_t)input[41] << 16);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 336 to 351
	value = ((uint32_t)input[42] << 24) |
			((uint32_t)input[43] << 16);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 352 to 367
	value = ((uint32_t)input[44] << 24) |
			((uint32_t)input[45] << 16);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 368 to 383
	value = ((uint32_t)input[46] << 24) |
			((uint32_t)input[47] << 16);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 384 to 399
	value = ((uint32_t)input[48] << 24) |
			((uint32_t)input[49] << 16);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 400 to 415
	value = ((uint32_t)input[50] << 24) |
			((uint32_t)input[51] << 16);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 416 to 431
	value = ((uint32_t)input[52] << 24) |
			((uint32_t)input[53] << 16);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 432 to 447
	value = ((uint32_t)input[54] << 24) |
			((uint32_t)input[55] << 16);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 448 to 463
	value = ((uint32_t)input[56] << 24) |
			((uint32_t)input[57] << 16);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 464 to 479
	value = ((uint32_t)input[58] << 24) |
			((uint32_t)input[59] << 16);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 480 to 495
	value = ((uint32_t)input[60] << 24) |
			((uint32_t)input[61] << 16);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 496 to 511
	value = ((uint32_t)input[62] << 24) |
			((uint32_t)input[63] << 16);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 512 to 527
	value = ((uint32_t)input[64] << 24) |
			((uint32_t)input[65] << 16);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 528 to 543
	value = ((uint32_t)input[66] << 24) |
			((uint32_t)input[67] << 16);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 544 to 559
	value = ((uint32_t)input[68] << 24) |
			((uint32_t)input[69] << 16);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 560 to 575
	value = ((uint32_t)input[70] << 24) |
			((uint32_t)input[71] << 16);
	output[35] = (double)(value >> 16);
}

static void unpack_36_16bit_signed_1off(const uint8_t * input, double * output, void *closure) {
	// Unpack 36 values into output
	// Values are 16-bit signed
	// Skip 1 bits, read 576 bits of data.
	// Input must be at least 73 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 1 to 16
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)input[1] << 17) |
			((uint32_t)(input[2] & 0x80) << 9);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 17 to 32
	value = ((uint32_t)(input[2] & 0x7f) << 25) |
			((uint32_t)input[3] << 17) |
			((uint32_t)(input[4] & 0x80) << 9);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 33 to 48
	value = ((uint32_t)(input[4] & 0x7f) << 25) |
			((uint32_t)input[5] << 17) |
			((uint32_t)(input[6] & 0x80) << 9);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 49 to 64
	value = ((uint32_t)(input[6] & 0x7f) << 25) |
			((uint32_t)input[7] << 17) |
			((uint32_t)(input[8] & 0x80) << 9);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 65 to 80
	value = ((uint32_t)(input[8] & 0x7f) << 25) |
			((uint32_t)input[9] << 17) |
			((uint32_t)(input[10] & 0x80) << 9);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 81 to 96
	value = ((uint32_t)(input[10] & 0x7f) << 25) |
			((uint32_t)input[11] << 17) |
			((uint32_t)(input[12] & 0x80) << 9);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 97 to 112
	value = ((uint32_t)(input[12] & 0x7f) << 25) |
			((uint32_t)input[13] << 17) |
			((uint32_t)(input[14] & 0x80) << 9);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 113 to 128
	value = ((uint32_t)(input[14] & 0x7f) << 25) |
			((uint32_t)input[15] << 17) |
			((uint32_t)(input[16] & 0x80) << 9);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 129 to 144
	value = ((uint32_t)(input[16] & 0x7f) << 25) |
			((uint32_t)input[17] << 17) |
			((uint32_t)(input[18] & 0x80) << 9);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 145 to 160
	value = ((uint32_t)(input[18] & 0x7f) << 25) |
			((uint32_t)input[19] << 17) |
			((uint32_t)(input[20] & 0x80) << 9);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 161 to 176
	value = ((uint32_t)(input[20] & 0x7f) << 25) |
			((uint32_t)input[21] << 17) |
			((uint32_t)(input[22] & 0x80) << 9);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 177 to 192
	value = ((uint32_t)(input[22] & 0x7f) << 25) |
			((uint32_t)input[23] << 17) |
			((uint32_t)(input[24] & 0x80) << 9);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 193 to 208
	value = ((uint32_t)(input[24] & 0x7f) << 25) |
			((uint32_t)input[25] << 17) |
			((uint32_t)(input[26] & 0x80) << 9);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 209 to 224
	value = ((uint32_t)(input[26] & 0x7f) << 25) |
			((uint32_t)input[27] << 17) |
			((uint32_t)(input[28] & 0x80) << 9);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 225 to 240
	value = ((uint32_t)(input[28] & 0x7f) << 25) |
			((uint32_t)input[29] << 17) |
			((uint32_t)(input[30] & 0x80) << 9);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 241 to 256
	value = ((uint32_t)(input[30] & 0x7f) << 25) |
			((uint32_t)input[31] << 17) |
			((uint32_t)(input[32] & 0x80) << 9);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 257 to 272
	value = ((uint32_t)(input[32] & 0x7f) << 25) |
			((uint32_t)input[33] << 17) |
			((uint32_t)(input[34] & 0x80) << 9);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 273 to 288
	value = ((uint32_t)(input[34] & 0x7f) << 25) |
			((uint32_t)input[35] << 17) |
			((uint32_t)(input[36] & 0x80) << 9);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 289 to 304
	value = ((uint32_t)(input[36] & 0x7f) << 25) |
			((uint32_t)input[37] << 17) |
			((uint32_t)(input[38] & 0x80) << 9);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 305 to 320
	value = ((uint32_t)(input[38] & 0x7f) << 25) |
			((uint32_t)input[39] << 17) |
			((uint32_t)(input[40] & 0x80) << 9);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 321 to 336
	value = ((uint32_t)(input[40] & 0x7f) << 25) |
			((uint32_t)input[41] << 17) |
			((uint32_t)(input[42] & 0x80) << 9);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 337 to 352
	value = ((uint32_t)(input[42] & 0x7f) << 25) |
			((uint32_t)input[43] << 17) |
			((uint32_t)(input[44] & 0x80) << 9);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 353 to 368
	value = ((uint32_t)(input[44] & 0x7f) << 25) |
			((uint32_t)input[45] << 17) |
			((uint32_t)(input[46] & 0x80) << 9);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 369 to 384
	value = ((uint32_t)(input[46] & 0x7f) << 25) |
			((uint32_t)input[47] << 17) |
			((uint32_t)(input[48] & 0x80) << 9);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 385 to 400
	value = ((uint32_t)(input[48] & 0x7f) << 25) |
			((uint32_t)input[49] << 17) |
			((uint32_t)(input[50] & 0x80) << 9);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 401 to 416
	value = ((uint32_t)(input[50] & 0x7f) << 25) |
			((uint32_t)input[51] << 17) |
			((uint32_t)(input[52] & 0x80) << 9);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 417 to 432
	value = ((uint32_t)(input[52] & 0x7f) << 25) |
			((uint32_t)input[53] << 17) |
			((uint32_t)(input[54] & 0x80) << 9);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 433 to 448
	value = ((uint32_t)(input[54] & 0x7f) << 25) |
			((uint32_t)input[55] << 17) |
			((uint32_t)(input[56] & 0x80) << 9);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 449 to 464
	value = ((uint32_t)(input[56] & 0x7f) << 25) |
			((uint32_t)input[57] << 17) |
			((uint32_t)(input[58] & 0x80) << 9);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 465 to 480
	value = ((uint32_t)(input[58] & 0x7f) << 25) |
			((uint32_t)input[59] << 17) |
			((uint32_t)(input[60] & 0x80) << 9);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 481 to 496
	value = ((uint32_t)(input[60] & 0x7f) << 25) |
			((uint32_t)input[61] << 17) |
			((uint32_t)(input[62] & 0x80) << 9);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 497 to 512
	value = ((uint32_t)(input[62] & 0x7f) << 25) |
			((uint32_t)input[63] << 17) |
			((uint32_t)(input[64] & 0x80) << 9);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 513 to 528
	value = ((uint32_t)(input[64] & 0x7f) << 25) |
			((uint32_t)input[65] << 17) |
			((uint32_t)(input[66] & 0x80) << 9);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 529 to 544
	value = ((uint32_t)(input[66] & 0x7f) << 25) |
			((uint32_t)input[67] << 17) |
			((uint32_t)(input[68] & 0x80) << 9);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 545 to 560
	value = ((uint32_t)(input[68] & 0x7f) << 25) |
			((uint32_t)input[69] << 17) |
			((uint32_t)(input[70] & 0x80) << 9);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 561 to 576
	value = ((uint32_t)(input[70] & 0x7f) << 25) |
			((uint32_t)input[71] << 17) |
			((uint32_t)(input[72] & 0x80) << 9);
	output[35] = (double)(value >> 16);
}

static void unpack_36_16bit_unsigned_1off(const uint8_t * input, double * output, void *closure) {
	// Unpack 36 values into output
	// Values are 16-bit unsigned
	// Skip 1 bits, read 576 bits of data.
	// Input must be at least 73 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 1 to 16
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)input[1] << 17) |
			((uint32_t)(input[2] & 0x80) << 9);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 17 to 32
	value = ((uint32_t)(input[2] & 0x7f) << 25) |
			((uint32_t)input[3] << 17) |
			((uint32_t)(input[4] & 0x80) << 9);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 33 to 48
	value = ((uint32_t)(input[4] & 0x7f) << 25) |
			((uint32_t)input[5] << 17) |
			((uint32_t)(input[6] & 0x80) << 9);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 49 to 64
	value = ((uint32_t)(input[6] & 0x7f) << 25) |
			((uint32_t)input[7] << 17) |
			((uint32_t)(input[8] & 0x80) << 9);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 65 to 80
	value = ((uint32_t)(input[8] & 0x7f) << 25) |
			((uint32_t)input[9] << 17) |
			((uint32_t)(input[10] & 0x80) << 9);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 81 to 96
	value = ((uint32_t)(input[10] & 0x7f) << 25) |
			((uint32_t)input[11] << 17) |
			((uint32_t)(input[12] & 0x80) << 9);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 97 to 112
	value = ((uint32_t)(input[12] & 0x7f) << 25) |
			((uint32_t)input[13] << 17) |
			((uint32_t)(input[14] & 0x80) << 9);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 113 to 128
	value = ((uint32_t)(input[14] & 0x7f) << 25) |
			((uint32_t)input[15] << 17) |
			((uint32_t)(input[16] & 0x80) << 9);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 129 to 144
	value = ((uint32_t)(input[16] & 0x7f) << 25) |
			((uint32_t)input[17] << 17) |
			((uint32_t)(input[18] & 0x80) << 9);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 145 to 160
	value = ((uint32_t)(input[18] & 0x7f) << 25) |
			((uint32_t)input[19] << 17) |
			((uint32_t)(input[20] & 0x80) << 9);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 161 to 176
	value = ((uint32_t)(input[20] & 0x7f) << 25) |
			((uint32_t)input[21] << 17) |
			((uint32_t)(input[22] & 0x80) << 9);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 177 to 192
	value = ((uint32_t)(input[22] & 0x7f) << 25) |
			((uint32_t)input[23] << 17) |
			((uint32_t)(input[24] & 0x80) << 9);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 193 to 208
	value = ((uint32_t)(input[24] & 0x7f) << 25) |
			((uint32_t)input[25] << 17) |
			((uint32_t)(input[26] & 0x80) << 9);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 209 to 224
	value = ((uint32_t)(input[26] & 0x7f) << 25) |
			((uint32_t)input[27] << 17) |
			((uint32_t)(input[28] & 0x80) << 9);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 225 to 240
	value = ((uint32_t)(input[28] & 0x7f) << 25) |
			((uint32_t)input[29] << 17) |
			((uint32_t)(input[30] & 0x80) << 9);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 241 to 256
	value = ((uint32_t)(input[30] & 0x7f) << 25) |
			((uint32_t)input[31] << 17) |
			((uint32_t)(input[32] & 0x80) << 9);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 257 to 272
	value = ((uint32_t)(input[32] & 0x7f) << 25) |
			((uint32_t)input[33] << 17) |
			((uint32_t)(input[34] & 0x80) << 9);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 273 to 288
	value = ((uint32_t)(input[34] & 0x7f) << 25) |
			((uint32_t)input[35] << 17) |
			((uint32_t)(input[36] & 0x80) << 9);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 289 to 304
	value = ((uint32_t)(input[36] & 0x7f) << 25) |
			((uint32_t)input[37] << 17) |
			((uint32_t)(input[38] & 0x80) << 9);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 305 to 320
	value = ((uint32_t)(input[38] & 0x7f) << 25) |
			((uint32_t)input[39] << 17) |
			((uint32_t)(input[40] & 0x80) << 9);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 321 to 336
	value = ((uint32_t)(input[40] & 0x7f) << 25) |
			((uint32_t)input[41] << 17) |
			((uint32_t)(input[42] & 0x80) << 9);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 337 to 352
	value = ((uint32_t)(input[42] & 0x7f) << 25) |
			((uint32_t)input[43] << 17) |
			((uint32_t)(input[44] & 0x80) << 9);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 353 to 368
	value = ((uint32_t)(input[44] & 0x7f) << 25) |
			((uint32_t)input[45] << 17) |
			((uint32_t)(input[46] & 0x80) << 9);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 369 to 384
	value = ((uint32_t)(input[46] & 0x7f) << 25) |
			((uint32_t)input[47] << 17) |
			((uint32_t)(input[48] & 0x80) << 9);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 385 to 400
	value = ((uint32_t)(input[48] & 0x7f) << 25) |
			((uint32_t)input[49] << 17) |
			((uint32_t)(input[50] & 0x80) << 9);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 401 to 416
	value = ((uint32_t)(input[50] & 0x7f) << 25) |
			((uint32_t)input[51] << 17) |
			((uint32_t)(input[52] & 0x80) << 9);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 417 to 432
	value = ((uint32_t)(input[52] & 0x7f) << 25) |
			((uint32_t)input[53] << 17) |
			((uint32_t)(input[54] & 0x80) << 9);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 433 to 448
	value = ((uint32_t)(input[54] & 0x7f) << 25) |
			((uint32_t)input[55] << 17) |
			((uint32_t)(input[56] & 0x80) << 9);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 449 to 464
	value = ((uint32_t)(input[56] & 0x7f) << 25) |
			((uint32_t)input[57] << 17) |
			((uint32_t)(input[58] & 0x80) << 9);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 465 to 480
	value = ((uint32_t)(input[58] & 0x7f) << 25) |
			((uint32_t)input[59] << 17) |
			((uint32_t)(input[60] & 0x80) << 9);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 481 to 496
	value = ((uint32_t)(input[60] & 0x7f) << 25) |
			((uint32_t)input[61] << 17) |
			((uint32_t)(input[62] & 0x80) << 9);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 497 to 512
	value = ((uint32_t)(input[62] & 0x7f) << 25) |
			((uint32_t)input[63] << 17) |
			((uint32_t)(input[64] & 0x80) << 9);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 513 to 528
	value = ((uint32_t)(input[64] & 0x7f) << 25) |
			((uint32_t)input[65] << 17) |
			((uint32_t)(input[66] & 0x80) << 9);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 529 to 544
	value = ((uint32_t)(input[66] & 0x7f) << 25) |
			((uint32_t)input[67] << 17) |
			((uint32_t)(input[68] & 0x80) << 9);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 545 to 560
	value = ((uint32_t)(input[68] & 0x7f) << 25) |
			((uint32_t)input[69] << 17) |
			((uint32_t)(input[70] & 0x80) << 9);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 561 to 576
	value = ((uint32_t)(input[70] & 0x7f) << 25) |
			((uint32_t)input[71] << 17) |
			((uint32_t)(input[72] & 0x80) << 9);
	output[35] = (double)(value >> 16);
}

static void unpack_36_16bit_signed_2off(const uint8_t * input, double * output, void *closure) {
	// Unpack 36 values into output
	// Values are 16-bit signed
	// Skip 2 bits, read 576 bits of data.
	// Input must be at least 73 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 2 to 17
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)input[1] << 18) |
			((uint32_t)(input[2] & 0xc0) << 10);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 18 to 33
	value = ((uint32_t)(input[2] & 0x3f) << 26) |
			((uint32_t)input[3] << 18) |
			((uint32_t)(input[4] & 0xc0) << 10);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 34 to 49
	value = ((uint32_t)(input[4] & 0x3f) << 26) |
			((uint32_t)input[5] << 18) |
			((uint32_t)(input[6] & 0xc0) << 10);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 50 to 65
	value = ((uint32_t)(input[6] & 0x3f) << 26) |
			((uint32_t)input[7] << 18) |
			((uint32_t)(input[8] & 0xc0) << 10);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 66 to 81
	value = ((uint32_t)(input[8] & 0x3f) << 26) |
			((uint32_t)input[9] << 18) |
			((uint32_t)(input[10] & 0xc0) << 10);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 82 to 97
	value = ((uint32_t)(input[10] & 0x3f) << 26) |
			((uint32_t)input[11] << 18) |
			((uint32_t)(input[12] & 0xc0) << 10);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 98 to 113
	value = ((uint32_t)(input[12] & 0x3f) << 26) |
			((uint32_t)input[13] << 18) |
			((uint32_t)(input[14] & 0xc0) << 10);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 114 to 129
	value = ((uint32_t)(input[14] & 0x3f) << 26) |
			((uint32_t)input[15] << 18) |
			((uint32_t)(input[16] & 0xc0) << 10);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 130 to 145
	value = ((uint32_t)(input[16] & 0x3f) << 26) |
			((uint32_t)input[17] << 18) |
			((uint32_t)(input[18] & 0xc0) << 10);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 146 to 161
	value = ((uint32_t)(input[18] & 0x3f) << 26) |
			((uint32_t)input[19] << 18) |
			((uint32_t)(input[20] & 0xc0) << 10);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 162 to 177
	value = ((uint32_t)(input[20] & 0x3f) << 26) |
			((uint32_t)input[21] << 18) |
			((uint32_t)(input[22] & 0xc0) << 10);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 178 to 193
	value = ((uint32_t)(input[22] & 0x3f) << 26) |
			((uint32_t)input[23] << 18) |
			((uint32_t)(input[24] & 0xc0) << 10);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 194 to 209
	value = ((uint32_t)(input[24] & 0x3f) << 26) |
			((uint32_t)input[25] << 18) |
			((uint32_t)(input[26] & 0xc0) << 10);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 210 to 225
	value = ((uint32_t)(input[26] & 0x3f) << 26) |
			((uint32_t)input[27] << 18) |
			((uint32_t)(input[28] & 0xc0) << 10);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 226 to 241
	value = ((uint32_t)(input[28] & 0x3f) << 26) |
			((uint32_t)input[29] << 18) |
			((uint32_t)(input[30] & 0xc0) << 10);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 242 to 257
	value = ((uint32_t)(input[30] & 0x3f) << 26) |
			((uint32_t)input[31] << 18) |
			((uint32_t)(input[32] & 0xc0) << 10);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 258 to 273
	value = ((uint32_t)(input[32] & 0x3f) << 26) |
			((uint32_t)input[33] << 18) |
			((uint32_t)(input[34] & 0xc0) << 10);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 274 to 289
	value = ((uint32_t)(input[34] & 0x3f) << 26) |
			((uint32_t)input[35] << 18) |
			((uint32_t)(input[36] & 0xc0) << 10);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 290 to 305
	value = ((uint32_t)(input[36] & 0x3f) << 26) |
			((uint32_t)input[37] << 18) |
			((uint32_t)(input[38] & 0xc0) << 10);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 306 to 321
	value = ((uint32_t)(input[38] & 0x3f) << 26) |
			((uint32_t)input[39] << 18) |
			((uint32_t)(input[40] & 0xc0) << 10);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 322 to 337
	value = ((uint32_t)(input[40] & 0x3f) << 26) |
			((uint32_t)input[41] << 18) |
			((uint32_t)(input[42] & 0xc0) << 10);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 338 to 353
	value = ((uint32_t)(input[42] & 0x3f) << 26) |
			((uint32_t)input[43] << 18) |
			((uint32_t)(input[44] & 0xc0) << 10);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 354 to 369
	value = ((uint32_t)(input[44] & 0x3f) << 26) |
			((uint32_t)input[45] << 18) |
			((uint32_t)(input[46] & 0xc0) << 10);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 370 to 385
	value = ((uint32_t)(input[46] & 0x3f) << 26) |
			((uint32_t)input[47] << 18) |
			((uint32_t)(input[48] & 0xc0) << 10);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 386 to 401
	value = ((uint32_t)(input[48] & 0x3f) << 26) |
			((uint32_t)input[49] << 18) |
			((uint32_t)(input[50] & 0xc0) << 10);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 402 to 417
	value = ((uint32_t)(input[50] & 0x3f) << 26) |
			((uint32_t)input[51] << 18) |
			((uint32_t)(input[52] & 0xc0) << 10);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 418 to 433
	value = ((uint32_t)(input[52] & 0x3f) << 26) |
			((uint32_t)input[53] << 18) |
			((uint32_t)(input[54] & 0xc0) << 10);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 434 to 449
	value = ((uint32_t)(input[54] & 0x3f) << 26) |
			((uint32_t)input[55] << 18) |
			((uint32_t)(input[56] & 0xc0) << 10);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 450 to 465
	value = ((uint32_t)(input[56] & 0x3f) << 26) |
			((uint32_t)input[57] << 18) |
			((uint32_t)(input[58] & 0xc0) << 10);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 466 to 481
	value = ((uint32_t)(input[58] & 0x3f) << 26) |
			((uint32_t)input[59] << 18) |
			((uint32_t)(input[60] & 0xc0) << 10);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 482 to 497
	value = ((uint32_t)(input[60] & 0x3f) << 26) |
			((uint32_t)input[61] << 18) |
			((uint32_t)(input[62] & 0xc0) << 10);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 498 to 513
	value = ((uint32_t)(input[62] & 0x3f) << 26) |
			((uint32_t)input[63] << 18) |
			((uint32_t)(input[64] & 0xc0) << 10);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 514 to 529
	value = ((uint32_t)(input[64] & 0x3f) << 26) |
			((uint32_t)input[65] << 18) |
			((uint32_t)(input[66] & 0xc0) << 10);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 530 to 545
	value = ((uint32_t)(input[66] & 0x3f) << 26) |
			((uint32_t)input[67] << 18) |
			((uint32_t)(input[68] & 0xc0) << 10);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 546 to 561
	value = ((uint32_t)(input[68] & 0x3f) << 26) |
			((uint32_t)input[69] << 18) |
			((uint32_t)(input[70] & 0xc0) << 10);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 562 to 577
	value = ((uint32_t)(input[70] & 0x3f) << 26) |
			((uint32_t)input[71] << 18) |
			((uint32_t)(input[72] & 0xc0) << 10);
	output[35] = (double)(value >> 16);
}

static void unpack_36_16bit_unsigned_2off(const uint8_t * input, double * output, void *closure) {
	// Unpack 36 values into output
	// Values are 16-bit unsigned
	// Skip 2 bits, read 576 bits of data.
	// Input must be at least 73 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 2 to 17
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)input[1] << 18) |
			((uint32_t)(input[2] & 0xc0) << 10);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 18 to 33
	value = ((uint32_t)(input[2] & 0x3f) << 26) |
			((uint32_t)input[3] << 18) |
			((uint32_t)(input[4] & 0xc0) << 10);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 34 to 49
	value = ((uint32_t)(input[4] & 0x3f) << 26) |
			((uint32_t)input[5] << 18) |
			((uint32_t)(input[6] & 0xc0) << 10);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 50 to 65
	value = ((uint32_t)(input[6] & 0x3f) << 26) |
			((uint32_t)input[7] << 18) |
			((uint32_t)(input[8] & 0xc0) << 10);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 66 to 81
	value = ((uint32_t)(input[8] & 0x3f) << 26) |
			((uint32_t)input[9] << 18) |
			((uint32_t)(input[10] & 0xc0) << 10);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 82 to 97
	value = ((uint32_t)(input[10] & 0x3f) << 26) |
			((uint32_t)input[11] << 18) |
			((uint32_t)(input[12] & 0xc0) << 10);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 98 to 113
	value = ((uint32_t)(input[12] & 0x3f) << 26) |
			((uint32_t)input[13] << 18) |
			((uint32_t)(input[14] & 0xc0) << 10);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 114 to 129
	value = ((uint32_t)(input[14] & 0x3f) << 26) |
			((uint32_t)input[15] << 18) |
			((uint32_t)(input[16] & 0xc0) << 10);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 130 to 145
	value = ((uint32_t)(input[16] & 0x3f) << 26) |
			((uint32_t)input[17] << 18) |
			((uint32_t)(input[18] & 0xc0) << 10);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 146 to 161
	value = ((uint32_t)(input[18] & 0x3f) << 26) |
			((uint32_t)input[19] << 18) |
			((uint32_t)(input[20] & 0xc0) << 10);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 162 to 177
	value = ((uint32_t)(input[20] & 0x3f) << 26) |
			((uint32_t)input[21] << 18) |
			((uint32_t)(input[22] & 0xc0) << 10);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 178 to 193
	value = ((uint32_t)(input[22] & 0x3f) << 26) |
			((uint32_t)input[23] << 18) |
			((uint32_t)(input[24] & 0xc0) << 10);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 194 to 209
	value = ((uint32_t)(input[24] & 0x3f) << 26) |
			((uint32_t)input[25] << 18) |
			((uint32_t)(input[26] & 0xc0) << 10);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 210 to 225
	value = ((uint32_t)(input[26] & 0x3f) << 26) |
			((uint32_t)input[27] << 18) |
			((uint32_t)(input[28] & 0xc0) << 10);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 226 to 241
	value = ((uint32_t)(input[28] & 0x3f) << 26) |
			((uint32_t)input[29] << 18) |
			((uint32_t)(input[30] & 0xc0) << 10);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 242 to 257
	value = ((uint32_t)(input[30] & 0x3f) << 26) |
			((uint32_t)input[31] << 18) |
			((uint32_t)(input[32] & 0xc0) << 10);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 258 to 273
	value = ((uint32_t)(input[32] & 0x3f) << 26) |
			((uint32_t)input[33] << 18) |
			((uint32_t)(input[34] & 0xc0) << 10);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 274 to 289
	value = ((uint32_t)(input[34] & 0x3f) << 26) |
			((uint32_t)input[35] << 18) |
			((uint32_t)(input[36] & 0xc0) << 10);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 290 to 305
	value = ((uint32_t)(input[36] & 0x3f) << 26) |
			((uint32_t)input[37] << 18) |
			((uint32_t)(input[38] & 0xc0) << 10);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 306 to 321
	value = ((uint32_t)(input[38] & 0x3f) << 26) |
			((uint32_t)input[39] << 18) |
			((uint32_t)(input[40] & 0xc0) << 10);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 322 to 337
	value = ((uint32_t)(input[40] & 0x3f) << 26) |
			((uint32_t)input[41] << 18) |
			((uint32_t)(input[42] & 0xc0) << 10);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 338 to 353
	value = ((uint32_t)(input[42] & 0x3f) << 26) |
			((uint32_t)input[43] << 18) |
			((uint32_t)(input[44] & 0xc0) << 10);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 354 to 369
	value = ((uint32_t)(input[44] & 0x3f) << 26) |
			((uint32_t)input[45] << 18) |
			((uint32_t)(input[46] & 0xc0) << 10);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 370 to 385
	value = ((uint32_t)(input[46] & 0x3f) << 26) |
			((uint32_t)input[47] << 18) |
			((uint32_t)(input[48] & 0xc0) << 10);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 386 to 401
	value = ((uint32_t)(input[48] & 0x3f) << 26) |
			((uint32_t)input[49] << 18) |
			((uint32_t)(input[50] & 0xc0) << 10);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 402 to 417
	value = ((uint32_t)(input[50] & 0x3f) << 26) |
			((uint32_t)input[51] << 18) |
			((uint32_t)(input[52] & 0xc0) << 10);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 418 to 433
	value = ((uint32_t)(input[52] & 0x3f) << 26) |
			((uint32_t)input[53] << 18) |
			((uint32_t)(input[54] & 0xc0) << 10);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 434 to 449
	value = ((uint32_t)(input[54] & 0x3f) << 26) |
			((uint32_t)input[55] << 18) |
			((uint32_t)(input[56] & 0xc0) << 10);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 450 to 465
	value = ((uint32_t)(input[56] & 0x3f) << 26) |
			((uint32_t)input[57] << 18) |
			((uint32_t)(input[58] & 0xc0) << 10);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 466 to 481
	value = ((uint32_t)(input[58] & 0x3f) << 26) |
			((uint32_t)input[59] << 18) |
			((uint32_t)(input[60] & 0xc0) << 10);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 482 to 497
	value = ((uint32_t)(input[60] & 0x3f) << 26) |
			((uint32_t)input[61] << 18) |
			((uint32_t)(input[62] & 0xc0) << 10);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 498 to 513
	value = ((uint32_t)(input[62] & 0x3f) << 26) |
			((uint32_t)input[63] << 18) |
			((uint32_t)(input[64] & 0xc0) << 10);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 514 to 529
	value = ((uint32_t)(input[64] & 0x3f) << 26) |
			((uint32_t)input[65] << 18) |
			((uint32_t)(input[66] & 0xc0) << 10);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 530 to 545
	value = ((uint32_t)(input[66] & 0x3f) << 26) |
			((uint32_t)input[67] << 18) |
			((uint32_t)(input[68] & 0xc0) << 10);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 546 to 561
	value = ((uint32_t)(input[68] & 0x3f) << 26) |
			((uint32_t)input[69] << 18) |
			((uint32_t)(input[70] & 0xc0) << 10);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 562 to 577
	value = ((uint32_t)(input[70] & 0x3f) << 26) |
			((uint32_t)input[71] << 18) |
			((uint32_t)(input[72] & 0xc0) << 10);
	output[35] = (double)(value >> 16);
}

static void unpack_36_16bit_signed_3off(const uint8_t * input, double * output, void *closure) {
	// Unpack 36 values into output
	// Values are 16-bit signed
	// Skip 3 bits, read 576 bits of data.
	// Input must be at least 73 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 3 to 18
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)input[1] << 19) |
			((uint32_t)(input[2] & 0xe0) << 11);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 19 to 34
	value = ((uint32_t)(input[2] & 0x1f) << 27) |
			((uint32_t)input[3] << 19) |
			((uint32_t)(input[4] & 0xe0) << 11);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 35 to 50
	value = ((uint32_t)(input[4] & 0x1f) << 27) |
			((uint32_t)input[5] << 19) |
			((uint32_t)(input[6] & 0xe0) << 11);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 51 to 66
	value = ((uint32_t)(input[6] & 0x1f) << 27) |
			((uint32_t)input[7] << 19) |
			((uint32_t)(input[8] & 0xe0) << 11);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 67 to 82
	value = ((uint32_t)(input[8] & 0x1f) << 27) |
			((uint32_t)input[9] << 19) |
			((uint32_t)(input[10] & 0xe0) << 11);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 83 to 98
	value = ((uint32_t)(input[10] & 0x1f) << 27) |
			((uint32_t)input[11] << 19) |
			((uint32_t)(input[12] & 0xe0) << 11);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 99 to 114
	value = ((uint32_t)(input[12] & 0x1f) << 27) |
			((uint32_t)input[13] << 19) |
			((uint32_t)(input[14] & 0xe0) << 11);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 115 to 130
	value = ((uint32_t)(input[14] & 0x1f) << 27) |
			((uint32_t)input[15] << 19) |
			((uint32_t)(input[16] & 0xe0) << 11);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 131 to 146
	value = ((uint32_t)(input[16] & 0x1f) << 27) |
			((uint32_t)input[17] << 19) |
			((uint32_t)(input[18] & 0xe0) << 11);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 147 to 162
	value = ((uint32_t)(input[18] & 0x1f) << 27) |
			((uint32_t)input[19] << 19) |
			((uint32_t)(input[20] & 0xe0) << 11);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 163 to 178
	value = ((uint32_t)(input[20] & 0x1f) << 27) |
			((uint32_t)input[21] << 19) |
			((uint32_t)(input[22] & 0xe0) << 11);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 179 to 194
	value = ((uint32_t)(input[22] & 0x1f) << 27) |
			((uint32_t)input[23] << 19) |
			((uint32_t)(input[24] & 0xe0) << 11);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 195 to 210
	value = ((uint32_t)(input[24] & 0x1f) << 27) |
			((uint32_t)input[25] << 19) |
			((uint32_t)(input[26] & 0xe0) << 11);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 211 to 226
	value = ((uint32_t)(input[26] & 0x1f) << 27) |
			((uint32_t)input[27] << 19) |
			((uint32_t)(input[28] & 0xe0) << 11);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 227 to 242
	value = ((uint32_t)(input[28] & 0x1f) << 27) |
			((uint32_t)input[29] << 19) |
			((uint32_t)(input[30] & 0xe0) << 11);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 243 to 258
	value = ((uint32_t)(input[30] & 0x1f) << 27) |
			((uint32_t)input[31] << 19) |
			((uint32_t)(input[32] & 0xe0) << 11);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 259 to 274
	value = ((uint32_t)(input[32] & 0x1f) << 27) |
			((uint32_t)input[33] << 19) |
			((uint32_t)(input[34] & 0xe0) << 11);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 275 to 290
	value = ((uint32_t)(input[34] & 0x1f) << 27) |
			((uint32_t)input[35] << 19) |
			((uint32_t)(input[36] & 0xe0) << 11);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 291 to 306
	value = ((uint32_t)(input[36] & 0x1f) << 27) |
			((uint32_t)input[37] << 19) |
			((uint32_t)(input[38] & 0xe0) << 11);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 307 to 322
	value = ((uint32_t)(input[38] & 0x1f) << 27) |
			((uint32_t)input[39] << 19) |
			((uint32_t)(input[40] & 0xe0) << 11);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 323 to 338
	value = ((uint32_t)(input[40] & 0x1f) << 27) |
			((uint32_t)input[41] << 19) |
			((uint32_t)(input[42] & 0xe0) << 11);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 339 to 354
	value = ((uint32_t)(input[42] & 0x1f) << 27) |
			((uint32_t)input[43] << 19) |
			((uint32_t)(input[44] & 0xe0) << 11);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 355 to 370
	value = ((uint32_t)(input[44] & 0x1f) << 27) |
			((uint32_t)input[45] << 19) |
			((uint32_t)(input[46] & 0xe0) << 11);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 371 to 386
	value = ((uint32_t)(input[46] & 0x1f) << 27) |
			((uint32_t)input[47] << 19) |
			((uint32_t)(input[48] & 0xe0) << 11);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 387 to 402
	value = ((uint32_t)(input[48] & 0x1f) << 27) |
			((uint32_t)input[49] << 19) |
			((uint32_t)(input[50] & 0xe0) << 11);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 403 to 418
	value = ((uint32_t)(input[50] & 0x1f) << 27) |
			((uint32_t)input[51] << 19) |
			((uint32_t)(input[52] & 0xe0) << 11);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 419 to 434
	value = ((uint32_t)(input[52] & 0x1f) << 27) |
			((uint32_t)input[53] << 19) |
			((uint32_t)(input[54] & 0xe0) << 11);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 435 to 450
	value = ((uint32_t)(input[54] & 0x1f) << 27) |
			((uint32_t)input[55] << 19) |
			((uint32_t)(input[56] & 0xe0) << 11);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 451 to 466
	value = ((uint32_t)(input[56] & 0x1f) << 27) |
			((uint32_t)input[57] << 19) |
			((uint32_t)(input[58] & 0xe0) << 11);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 467 to 482
	value = ((uint32_t)(input[58] & 0x1f) << 27) |
			((uint32_t)input[59] << 19) |
			((uint32_t)(input[60] & 0xe0) << 11);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 483 to 498
	value = ((uint32_t)(input[60] & 0x1f) << 27) |
			((uint32_t)input[61] << 19) |
			((uint32_t)(input[62] & 0xe0) << 11);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 499 to 514
	value = ((uint32_t)(input[62] & 0x1f) << 27) |
			((uint32_t)input[63] << 19) |
			((uint32_t)(input[64] & 0xe0) << 11);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 515 to 530
	value = ((uint32_t)(input[64] & 0x1f) << 27) |
			((uint32_t)input[65] << 19) |
			((uint32_t)(input[66] & 0xe0) << 11);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 531 to 546
	value = ((uint32_t)(input[66] & 0x1f) << 27) |
			((uint32_t)input[67] << 19) |
			((uint32_t)(input[68] & 0xe0) << 11);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 547 to 562
	value = ((uint32_t)(input[68] & 0x1f) << 27) |
			((uint32_t)input[69] << 19) |
			((uint32_t)(input[70] & 0xe0) << 11);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 563 to 578
	value = ((uint32_t)(input[70] & 0x1f) << 27) |
			((uint32_t)input[71] << 19) |
			((uint32_t)(input[72] & 0xe0) << 11);
	output[35] = (double)(value >> 16);
}

static void unpack_36_16bit_unsigned_3off(const uint8_t * input, double * output, void *closure) {
	// Unpack 36 values into output
	// Values are 16-bit unsigned
	// Skip 3 bits, read 576 bits of data.
	// Input must be at least 73 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 3 to 18
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)input[1] << 19) |
			((uint32_t)(input[2] & 0xe0) << 11);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 19 to 34
	value = ((uint32_t)(input[2] & 0x1f) << 27) |
			((uint32_t)input[3] << 19) |
			((uint32_t)(input[4] & 0xe0) << 11);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 35 to 50
	value = ((uint32_t)(input[4] & 0x1f) << 27) |
			((uint32_t)input[5] << 19) |
			((uint32_t)(input[6] & 0xe0) << 11);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 51 to 66
	value = ((uint32_t)(input[6] & 0x1f) << 27) |
			((uint32_t)input[7] << 19) |
			((uint32_t)(input[8] & 0xe0) << 11);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 67 to 82
	value = ((uint32_t)(input[8] & 0x1f) << 27) |
			((uint32_t)input[9] << 19) |
			((uint32_t)(input[10] & 0xe0) << 11);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 83 to 98
	value = ((uint32_t)(input[10] & 0x1f) << 27) |
			((uint32_t)input[11] << 19) |
			((uint32_t)(input[12] & 0xe0) << 11);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 99 to 114
	value = ((uint32_t)(input[12] & 0x1f) << 27) |
			((uint32_t)input[13] << 19) |
			((uint32_t)(input[14] & 0xe0) << 11);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 115 to 130
	value = ((uint32_t)(input[14] & 0x1f) << 27) |
			((uint32_t)input[15] << 19) |
			((uint32_t)(input[16] & 0xe0) << 11);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 131 to 146
	value = ((uint32_t)(input[16] & 0x1f) << 27) |
			((uint32_t)input[17] << 19) |
			((uint32_t)(input[18] & 0xe0) << 11);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 147 to 162
	value = ((uint32_t)(input[18] & 0x1f) << 27) |
			((uint32_t)input[19] << 19) |
			((uint32_t)(input[20] & 0xe0) << 11);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 163 to 178
	value = ((uint32_t)(input[20] & 0x1f) << 27) |
			((uint32_t)input[21] << 19) |
			((uint32_t)(input[22] & 0xe0) << 11);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 179 to 194
	value = ((uint32_t)(input[22] & 0x1f) << 27) |
			((uint32_t)input[23] << 19) |
			((uint32_t)(input[24] & 0xe0) << 11);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 195 to 210
	value = ((uint32_t)(input[24] & 0x1f) << 27) |
			((uint32_t)input[25] << 19) |
			((uint32_t)(input[26] & 0xe0) << 11);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 211 to 226
	value = ((uint32_t)(input[26] & 0x1f) << 27) |
			((uint32_t)input[27] << 19) |
			((uint32_t)(input[28] & 0xe0) << 11);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 227 to 242
	value = ((uint32_t)(input[28] & 0x1f) << 27) |
			((uint32_t)input[29] << 19) |
			((uint32_t)(input[30] & 0xe0) << 11);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 243 to 258
	value = ((uint32_t)(input[30] & 0x1f) << 27) |
			((uint32_t)input[31] << 19) |
			((uint32_t)(input[32] & 0xe0) << 11);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 259 to 274
	value = ((uint32_t)(input[32] & 0x1f) << 27) |
			((uint32_t)input[33] << 19) |
			((uint32_t)(input[34] & 0xe0) << 11);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 275 to 290
	value = ((uint32_t)(input[34] & 0x1f) << 27) |
			((uint32_t)input[35] << 19) |
			((uint32_t)(input[36] & 0xe0) << 11);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 291 to 306
	value = ((uint32_t)(input[36] & 0x1f) << 27) |
			((uint32_t)input[37] << 19) |
			((uint32_t)(input[38] & 0xe0) << 11);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 307 to 322
	value = ((uint32_t)(input[38] & 0x1f) << 27) |
			((uint32_t)input[39] << 19) |
			((uint32_t)(input[40] & 0xe0) << 11);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 323 to 338
	value = ((uint32_t)(input[40] & 0x1f) << 27) |
			((uint32_t)input[41] << 19) |
			((uint32_t)(input[42] & 0xe0) << 11);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 339 to 354
	value = ((uint32_t)(input[42] & 0x1f) << 27) |
			((uint32_t)input[43] << 19) |
			((uint32_t)(input[44] & 0xe0) << 11);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 355 to 370
	value = ((uint32_t)(input[44] & 0x1f) << 27) |
			((uint32_t)input[45] << 19) |
			((uint32_t)(input[46] & 0xe0) << 11);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 371 to 386
	value = ((uint32_t)(input[46] & 0x1f) << 27) |
			((uint32_t)input[47] << 19) |
			((uint32_t)(input[48] & 0xe0) << 11);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 387 to 402
	value = ((uint32_t)(input[48] & 0x1f) << 27) |
			((uint32_t)input[49] << 19) |
			((uint32_t)(input[50] & 0xe0) << 11);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 403 to 418
	value = ((uint32_t)(input[50] & 0x1f) << 27) |
			((uint32_t)input[51] << 19) |
			((uint32_t)(input[52] & 0xe0) << 11);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 419 to 434
	value = ((uint32_t)(input[52] & 0x1f) << 27) |
			((uint32_t)input[53] << 19) |
			((uint32_t)(input[54] & 0xe0) << 11);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 435 to 450
	value = ((uint32_t)(input[54] & 0x1f) << 27) |
			((uint32_t)input[55] << 19) |
			((uint32_t)(input[56] & 0xe0) << 11);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 451 to 466
	value = ((uint32_t)(input[56] & 0x1f) << 27) |
			((uint32_t)input[57] << 19) |
			((uint32_t)(input[58] & 0xe0) << 11);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 467 to 482
	value = ((uint32_t)(input[58] & 0x1f) << 27) |
			((uint32_t)input[59] << 19) |
			((uint32_t)(input[60] & 0xe0) << 11);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 483 to 498
	value = ((uint32_t)(input[60] & 0x1f) << 27) |
			((uint32_t)input[61] << 19) |
			((uint32_t)(input[62] & 0xe0) << 11);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 499 to 514
	value = ((uint32_t)(input[62] & 0x1f) << 27) |
			((uint32_t)input[63] << 19) |
			((uint32_t)(input[64] & 0xe0) << 11);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 515 to 530
	value = ((uint32_t)(input[64] & 0x1f) << 27) |
			((uint32_t)input[65] << 19) |
			((uint32_t)(input[66] & 0xe0) << 11);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 531 to 546
	value = ((uint32_t)(input[66] & 0x1f) << 27) |
			((uint32_t)input[67] << 19) |
			((uint32_t)(input[68] & 0xe0) << 11);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 547 to 562
	value = ((uint32_t)(input[68] & 0x1f) << 27) |
			((uint32_t)input[69] << 19) |
			((uint32_t)(input[70] & 0xe0) << 11);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 563 to 578
	value = ((uint32_t)(input[70] & 0x1f) << 27) |
			((uint32_t)input[71] << 19) |
			((uint32_t)(input[72] & 0xe0) << 11);
	output[35] = (double)(value >> 16);
}

static void unpack_36_16bit_signed_4off(const uint8_t * input, double * output, void *closure) {
	// Unpack 36 values into output
	// Values are 16-bit signed
	// Skip 4 bits, read 576 bits of data.
	// Input must be at least 73 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 4 to 19
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20) |
			((uint32_t)(input[2] & 0xf0) << 12);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 20 to 35
	value = ((uint32_t)(input[2] & 0x0f) << 28) |
			((uint32_t)input[3] << 20) |
			((uint32_t)(input[4] & 0xf0) << 12);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 36 to 51
	value = ((uint32_t)(input[4] & 0x0f) << 28) |
			((uint32_t)input[5] << 20) |
			((uint32_t)(input[6] & 0xf0) << 12);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 52 to 67
	value = ((uint32_t)(input[6] & 0x0f) << 28) |
			((uint32_t)input[7] << 20) |
			((uint32_t)(input[8] & 0xf0) << 12);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 68 to 83
	value = ((uint32_t)(input[8] & 0x0f) << 28) |
			((uint32_t)input[9] << 20) |
			((uint32_t)(input[10] & 0xf0) << 12);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 84 to 99
	value = ((uint32_t)(input[10] & 0x0f) << 28) |
			((uint32_t)input[11] << 20) |
			((uint32_t)(input[12] & 0xf0) << 12);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 100 to 115
	value = ((uint32_t)(input[12] & 0x0f) << 28) |
			((uint32_t)input[13] << 20) |
			((uint32_t)(input[14] & 0xf0) << 12);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 116 to 131
	value = ((uint32_t)(input[14] & 0x0f) << 28) |
			((uint32_t)input[15] << 20) |
			((uint32_t)(input[16] & 0xf0) << 12);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 132 to 147
	value = ((uint32_t)(input[16] & 0x0f) << 28) |
			((uint32_t)input[17] << 20) |
			((uint32_t)(input[18] & 0xf0) << 12);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 148 to 163
	value = ((uint32_t)(input[18] & 0x0f) << 28) |
			((uint32_t)input[19] << 20) |
			((uint32_t)(input[20] & 0xf0) << 12);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 164 to 179
	value = ((uint32_t)(input[20] & 0x0f) << 28) |
			((uint32_t)input[21] << 20) |
			((uint32_t)(input[22] & 0xf0) << 12);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 180 to 195
	value = ((uint32_t)(input[22] & 0x0f) << 28) |
			((uint32_t)input[23] << 20) |
			((uint32_t)(input[24] & 0xf0) << 12);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 196 to 211
	value = ((uint32_t)(input[24] & 0x0f) << 28) |
			((uint32_t)input[25] << 20) |
			((uint32_t)(input[26] & 0xf0) << 12);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 212 to 227
	value = ((uint32_t)(input[26] & 0x0f) << 28) |
			((uint32_t)input[27] << 20) |
			((uint32_t)(input[28] & 0xf0) << 12);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 228 to 243
	value = ((uint32_t)(input[28] & 0x0f) << 28) |
			((uint32_t)input[29] << 20) |
			((uint32_t)(input[30] & 0xf0) << 12);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 244 to 259
	value = ((uint32_t)(input[30] & 0x0f) << 28) |
			((uint32_t)input[31] << 20) |
			((uint32_t)(input[32] & 0xf0) << 12);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 260 to 275
	value = ((uint32_t)(input[32] & 0x0f) << 28) |
			((uint32_t)input[33] << 20) |
			((uint32_t)(input[34] & 0xf0) << 12);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 276 to 291
	value = ((uint32_t)(input[34] & 0x0f) << 28) |
			((uint32_t)input[35] << 20) |
			((uint32_t)(input[36] & 0xf0) << 12);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 292 to 307
	value = ((uint32_t)(input[36] & 0x0f) << 28) |
			((uint32_t)input[37] << 20) |
			((uint32_t)(input[38] & 0xf0) << 12);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 308 to 323
	value = ((uint32_t)(input[38] & 0x0f) << 28) |
			((uint32_t)input[39] << 20) |
			((uint32_t)(input[40] & 0xf0) << 12);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 324 to 339
	value = ((uint32_t)(input[40] & 0x0f) << 28) |
			((uint32_t)input[41] << 20) |
			((uint32_t)(input[42] & 0xf0) << 12);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 340 to 355
	value = ((uint32_t)(input[42] & 0x0f) << 28) |
			((uint32_t)input[43] << 20) |
			((uint32_t)(input[44] & 0xf0) << 12);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 356 to 371
	value = ((uint32_t)(input[44] & 0x0f) << 28) |
			((uint32_t)input[45] << 20) |
			((uint32_t)(input[46] & 0xf0) << 12);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 372 to 387
	value = ((uint32_t)(input[46] & 0x0f) << 28) |
			((uint32_t)input[47] << 20) |
			((uint32_t)(input[48] & 0xf0) << 12);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 388 to 403
	value = ((uint32_t)(input[48] & 0x0f) << 28) |
			((uint32_t)input[49] << 20) |
			((uint32_t)(input[50] & 0xf0) << 12);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 404 to 419
	value = ((uint32_t)(input[50] & 0x0f) << 28) |
			((uint32_t)input[51] << 20) |
			((uint32_t)(input[52] & 0xf0) << 12);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 420 to 435
	value = ((uint32_t)(input[52] & 0x0f) << 28) |
			((uint32_t)input[53] << 20) |
			((uint32_t)(input[54] & 0xf0) << 12);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 436 to 451
	value = ((uint32_t)(input[54] & 0x0f) << 28) |
			((uint32_t)input[55] << 20) |
			((uint32_t)(input[56] & 0xf0) << 12);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 452 to 467
	value = ((uint32_t)(input[56] & 0x0f) << 28) |
			((uint32_t)input[57] << 20) |
			((uint32_t)(input[58] & 0xf0) << 12);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 468 to 483
	value = ((uint32_t)(input[58] & 0x0f) << 28) |
			((uint32_t)input[59] << 20) |
			((uint32_t)(input[60] & 0xf0) << 12);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 484 to 499
	value = ((uint32_t)(input[60] & 0x0f) << 28) |
			((uint32_t)input[61] << 20) |
			((uint32_t)(input[62] & 0xf0) << 12);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 500 to 515
	value = ((uint32_t)(input[62] & 0x0f) << 28) |
			((uint32_t)input[63] << 20) |
			((uint32_t)(input[64] & 0xf0) << 12);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 516 to 531
	value = ((uint32_t)(input[64] & 0x0f) << 28) |
			((uint32_t)input[65] << 20) |
			((uint32_t)(input[66] & 0xf0) << 12);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 532 to 547
	value = ((uint32_t)(input[66] & 0x0f) << 28) |
			((uint32_t)input[67] << 20) |
			((uint32_t)(input[68] & 0xf0) << 12);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 548 to 563
	value = ((uint32_t)(input[68] & 0x0f) << 28) |
			((uint32_t)input[69] << 20) |
			((uint32_t)(input[70] & 0xf0) << 12);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 564 to 579
	value = ((uint32_t)(input[70] & 0x0f) << 28) |
			((uint32_t)input[71] << 20) |
			((uint32_t)(input[72] & 0xf0) << 12);
	output[35] = (double)(value >> 16);
}

static void unpack_36_16bit_unsigned_4off(const uint8_t * input, double * output, void *closure) {
	// Unpack 36 values into output
	// Values are 16-bit unsigned
	// Skip 4 bits, read 576 bits of data.
	// Input must be at least 73 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 4 to 19
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20) |
			((uint32_t)(input[2] & 0xf0) << 12);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 20 to 35
	value = ((uint32_t)(input[2] & 0x0f) << 28) |
			((uint32_t)input[3] << 20) |
			((uint32_t)(input[4] & 0xf0) << 12);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 36 to 51
	value = ((uint32_t)(input[4] & 0x0f) << 28) |
			((uint32_t)input[5] << 20) |
			((uint32_t)(input[6] & 0xf0) << 12);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 52 to 67
	value = ((uint32_t)(input[6] & 0x0f) << 28) |
			((uint32_t)input[7] << 20) |
			((uint32_t)(input[8] & 0xf0) << 12);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 68 to 83
	value = ((uint32_t)(input[8] & 0x0f) << 28) |
			((uint32_t)input[9] << 20) |
			((uint32_t)(input[10] & 0xf0) << 12);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 84 to 99
	value = ((uint32_t)(input[10] & 0x0f) << 28) |
			((uint32_t)input[11] << 20) |
			((uint32_t)(input[12] & 0xf0) << 12);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 100 to 115
	value = ((uint32_t)(input[12] & 0x0f) << 28) |
			((uint32_t)input[13] << 20) |
			((uint32_t)(input[14] & 0xf0) << 12);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 116 to 131
	value = ((uint32_t)(input[14] & 0x0f) << 28) |
			((uint32_t)input[15] << 20) |
			((uint32_t)(input[16] & 0xf0) << 12);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 132 to 147
	value = ((uint32_t)(input[16] & 0x0f) << 28) |
			((uint32_t)input[17] << 20) |
			((uint32_t)(input[18] & 0xf0) << 12);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 148 to 163
	value = ((uint32_t)(input[18] & 0x0f) << 28) |
			((uint32_t)input[19] << 20) |
			((uint32_t)(input[20] & 0xf0) << 12);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 164 to 179
	value = ((uint32_t)(input[20] & 0x0f) << 28) |
			((uint32_t)input[21] << 20) |
			((uint32_t)(input[22] & 0xf0) << 12);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 180 to 195
	value = ((uint32_t)(input[22] & 0x0f) << 28) |
			((uint32_t)input[23] << 20) |
			((uint32_t)(input[24] & 0xf0) << 12);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 196 to 211
	value = ((uint32_t)(input[24] & 0x0f) << 28) |
			((uint32_t)input[25] << 20) |
			((uint32_t)(input[26] & 0xf0) << 12);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 212 to 227
	value = ((uint32_t)(input[26] & 0x0f) << 28) |
			((uint32_t)input[27] << 20) |
			((uint32_t)(input[28] & 0xf0) << 12);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 228 to 243
	value = ((uint32_t)(input[28] & 0x0f) << 28) |
			((uint32_t)input[29] << 20) |
			((uint32_t)(input[30] & 0xf0) << 12);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 244 to 259
	value = ((uint32_t)(input[30] & 0x0f) << 28) |
			((uint32_t)input[31] << 20) |
			((uint32_t)(input[32] & 0xf0) << 12);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 260 to 275
	value = ((uint32_t)(input[32] & 0x0f) << 28) |
			((uint32_t)input[33] << 20) |
			((uint32_t)(input[34] & 0xf0) << 12);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 276 to 291
	value = ((uint32_t)(input[34] & 0x0f) << 28) |
			((uint32_t)input[35] << 20) |
			((uint32_t)(input[36] & 0xf0) << 12);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 292 to 307
	value = ((uint32_t)(input[36] & 0x0f) << 28) |
			((uint32_t)input[37] << 20) |
			((uint32_t)(input[38] & 0xf0) << 12);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 308 to 323
	value = ((uint32_t)(input[38] & 0x0f) << 28) |
			((uint32_t)input[39] << 20) |
			((uint32_t)(input[40] & 0xf0) << 12);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 324 to 339
	value = ((uint32_t)(input[40] & 0x0f) << 28) |
			((uint32_t)input[41] << 20) |
			((uint32_t)(input[42] & 0xf0) << 12);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 340 to 355
	value = ((uint32_t)(input[42] & 0x0f) << 28) |
			((uint32_t)input[43] << 20) |
			((uint32_t)(input[44] & 0xf0) << 12);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 356 to 371
	value = ((uint32_t)(input[44] & 0x0f) << 28) |
			((uint32_t)input[45] << 20) |
			((uint32_t)(input[46] & 0xf0) << 12);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 372 to 387
	value = ((uint32_t)(input[46] & 0x0f) << 28) |
			((uint32_t)input[47] << 20) |
			((uint32_t)(input[48] & 0xf0) << 12);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 388 to 403
	value = ((uint32_t)(input[48] & 0x0f) << 28) |
			((uint32_t)input[49] << 20) |
			((uint32_t)(input[50] & 0xf0) << 12);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 404 to 419
	value = ((uint32_t)(input[50] & 0x0f) << 28) |
			((uint32_t)input[51] << 20) |
			((uint32_t)(input[52] & 0xf0) << 12);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 420 to 435
	value = ((uint32_t)(input[52] & 0x0f) << 28) |
			((uint32_t)input[53] << 20) |
			((uint32_t)(input[54] & 0xf0) << 12);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 436 to 451
	value = ((uint32_t)(input[54] & 0x0f) << 28) |
			((uint32_t)input[55] << 20) |
			((uint32_t)(input[56] & 0xf0) << 12);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 452 to 467
	value = ((uint32_t)(input[56] & 0x0f) << 28) |
			((uint32_t)input[57] << 20) |
			((uint32_t)(input[58] & 0xf0) << 12);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 468 to 483
	value = ((uint32_t)(input[58] & 0x0f) << 28) |
			((uint32_t)input[59] << 20) |
			((uint32_t)(input[60] & 0xf0) << 12);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 484 to 499
	value = ((uint32_t)(input[60] & 0x0f) << 28) |
			((uint32_t)input[61] << 20) |
			((uint32_t)(input[62] & 0xf0) << 12);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 500 to 515
	value = ((uint32_t)(input[62] & 0x0f) << 28) |
			((uint32_t)input[63] << 20) |
			((uint32_t)(input[64] & 0xf0) << 12);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 516 to 531
	value = ((uint32_t)(input[64] & 0x0f) << 28) |
			((uint32_t)input[65] << 20) |
			((uint32_t)(input[66] & 0xf0) << 12);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 532 to 547
	value = ((uint32_t)(input[66] & 0x0f) << 28) |
			((uint32_t)input[67] << 20) |
			((uint32_t)(input[68] & 0xf0) << 12);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 548 to 563
	value = ((uint32_t)(input[68] & 0x0f) << 28) |
			((uint32_t)input[69] << 20) |
			((uint32_t)(input[70] & 0xf0) << 12);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 564 to 579
	value = ((uint32_t)(input[70] & 0x0f) << 28) |
			((uint32_t)input[71] << 20) |
			((uint32_t)(input[72] & 0xf0) << 12);
	output[35] = (double)(value >> 16);
}

static void unpack_36_16bit_signed_5off(const uint8_t * input, double * output, void *closure) {
	// Unpack 36 values into output
	// Values are 16-bit signed
	// Skip 5 bits, read 576 bits of data.
	// Input must be at least 73 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 5 to 20
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)(input[2] & 0xf8) << 13);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 21 to 36
	value = ((uint32_t)(input[2] & 0x07) << 29) |
			((uint32_t)input[3] << 21) |
			((uint32_t)(input[4] & 0xf8) << 13);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 37 to 52
	value = ((uint32_t)(input[4] & 0x07) << 29) |
			((uint32_t)input[5] << 21) |
			((uint32_t)(input[6] & 0xf8) << 13);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 53 to 68
	value = ((uint32_t)(input[6] & 0x07) << 29) |
			((uint32_t)input[7] << 21) |
			((uint32_t)(input[8] & 0xf8) << 13);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 69 to 84
	value = ((uint32_t)(input[8] & 0x07) << 29) |
			((uint32_t)input[9] << 21) |
			((uint32_t)(input[10] & 0xf8) << 13);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 85 to 100
	value = ((uint32_t)(input[10] & 0x07) << 29) |
			((uint32_t)input[11] << 21) |
			((uint32_t)(input[12] & 0xf8) << 13);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 101 to 116
	value = ((uint32_t)(input[12] & 0x07) << 29) |
			((uint32_t)input[13] << 21) |
			((uint32_t)(input[14] & 0xf8) << 13);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 117 to 132
	value = ((uint32_t)(input[14] & 0x07) << 29) |
			((uint32_t)input[15] << 21) |
			((uint32_t)(input[16] & 0xf8) << 13);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 133 to 148
	value = ((uint32_t)(input[16] & 0x07) << 29) |
			((uint32_t)input[17] << 21) |
			((uint32_t)(input[18] & 0xf8) << 13);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 149 to 164
	value = ((uint32_t)(input[18] & 0x07) << 29) |
			((uint32_t)input[19] << 21) |
			((uint32_t)(input[20] & 0xf8) << 13);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 165 to 180
	value = ((uint32_t)(input[20] & 0x07) << 29) |
			((uint32_t)input[21] << 21) |
			((uint32_t)(input[22] & 0xf8) << 13);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 181 to 196
	value = ((uint32_t)(input[22] & 0x07) << 29) |
			((uint32_t)input[23] << 21) |
			((uint32_t)(input[24] & 0xf8) << 13);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 197 to 212
	value = ((uint32_t)(input[24] & 0x07) << 29) |
			((uint32_t)input[25] << 21) |
			((uint32_t)(input[26] & 0xf8) << 13);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 213 to 228
	value = ((uint32_t)(input[26] & 0x07) << 29) |
			((uint32_t)input[27] << 21) |
			((uint32_t)(input[28] & 0xf8) << 13);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 229 to 244
	value = ((uint32_t)(input[28] & 0x07) << 29) |
			((uint32_t)input[29] << 21) |
			((uint32_t)(input[30] & 0xf8) << 13);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 245 to 260
	value = ((uint32_t)(input[30] & 0x07) << 29) |
			((uint32_t)input[31] << 21) |
			((uint32_t)(input[32] & 0xf8) << 13);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 261 to 276
	value = ((uint32_t)(input[32] & 0x07) << 29) |
			((uint32_t)input[33] << 21) |
			((uint32_t)(input[34] & 0xf8) << 13);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 277 to 292
	value = ((uint32_t)(input[34] & 0x07) << 29) |
			((uint32_t)input[35] << 21) |
			((uint32_t)(input[36] & 0xf8) << 13);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 293 to 308
	value = ((uint32_t)(input[36] & 0x07) << 29) |
			((uint32_t)input[37] << 21) |
			((uint32_t)(input[38] & 0xf8) << 13);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 309 to 324
	value = ((uint32_t)(input[38] & 0x07) << 29) |
			((uint32_t)input[39] << 21) |
			((uint32_t)(input[40] & 0xf8) << 13);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 325 to 340
	value = ((uint32_t)(input[40] & 0x07) << 29) |
			((uint32_t)input[41] << 21) |
			((uint32_t)(input[42] & 0xf8) << 13);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 341 to 356
	value = ((uint32_t)(input[42] & 0x07) << 29) |
			((uint32_t)input[43] << 21) |
			((uint32_t)(input[44] & 0xf8) << 13);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 357 to 372
	value = ((uint32_t)(input[44] & 0x07) << 29) |
			((uint32_t)input[45] << 21) |
			((uint32_t)(input[46] & 0xf8) << 13);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 373 to 388
	value = ((uint32_t)(input[46] & 0x07) << 29) |
			((uint32_t)input[47] << 21) |
			((uint32_t)(input[48] & 0xf8) << 13);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 389 to 404
	value = ((uint32_t)(input[48] & 0x07) << 29) |
			((uint32_t)input[49] << 21) |
			((uint32_t)(input[50] & 0xf8) << 13);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 405 to 420
	value = ((uint32_t)(input[50] & 0x07) << 29) |
			((uint32_t)input[51] << 21) |
			((uint32_t)(input[52] & 0xf8) << 13);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 421 to 436
	value = ((uint32_t)(input[52] & 0x07) << 29) |
			((uint32_t)input[53] << 21) |
			((uint32_t)(input[54] & 0xf8) << 13);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 437 to 452
	value = ((uint32_t)(input[54] & 0x07) << 29) |
			((uint32_t)input[55] << 21) |
			((uint32_t)(input[56] & 0xf8) << 13);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 453 to 468
	value = ((uint32_t)(input[56] & 0x07) << 29) |
			((uint32_t)input[57] << 21) |
			((uint32_t)(input[58] & 0xf8) << 13);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 469 to 484
	value = ((uint32_t)(input[58] & 0x07) << 29) |
			((uint32_t)input[59] << 21) |
			((uint32_t)(input[60] & 0xf8) << 13);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 485 to 500
	value = ((uint32_t)(input[60] & 0x07) << 29) |
			((uint32_t)input[61] << 21) |
			((uint32_t)(input[62] & 0xf8) << 13);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 501 to 516
	value = ((uint32_t)(input[62] & 0x07) << 29) |
			((uint32_t)input[63] << 21) |
			((uint32_t)(input[64] & 0xf8) << 13);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 517 to 532
	value = ((uint32_t)(input[64] & 0x07) << 29) |
			((uint32_t)input[65] << 21) |
			((uint32_t)(input[66] & 0xf8) << 13);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 533 to 548
	value = ((uint32_t)(input[66] & 0x07) << 29) |
			((uint32_t)input[67] << 21) |
			((uint32_t)(input[68] & 0xf8) << 13);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 549 to 564
	value = ((uint32_t)(input[68] & 0x07) << 29) |
			((uint32_t)input[69] << 21) |
			((uint32_t)(input[70] & 0xf8) << 13);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 565 to 580
	value = ((uint32_t)(input[70] & 0x07) << 29) |
			((uint32_t)input[71] << 21) |
			((uint32_t)(input[72] & 0xf8) << 13);
	output[35] = (double)(value >> 16);
}

static void unpack_36_16bit_unsigned_5off(const uint8_t * input, double * output, void *closure) {
	// Unpack 36 values into output
	// Values are 16-bit unsigned
	// Skip 5 bits, read 576 bits of data.
	// Input must be at least 73 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 5 to 20
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)(input[2] & 0xf8) << 13);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 21 to 36
	value = ((uint32_t)(input[2] & 0x07) << 29) |
			((uint32_t)input[3] << 21) |
			((uint32_t)(input[4] & 0xf8) << 13);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 37 to 52
	value = ((uint32_t)(input[4] & 0x07) << 29) |
			((uint32_t)input[5] << 21) |
			((uint32_t)(input[6] & 0xf8) << 13);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 53 to 68
	value = ((uint32_t)(input[6] & 0x07) << 29) |
			((uint32_t)input[7] << 21) |
			((uint32_t)(input[8] & 0xf8) << 13);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 69 to 84
	value = ((uint32_t)(input[8] & 0x07) << 29) |
			((uint32_t)input[9] << 21) |
			((uint32_t)(input[10] & 0xf8) << 13);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 85 to 100
	value = ((uint32_t)(input[10] & 0x07) << 29) |
			((uint32_t)input[11] << 21) |
			((uint32_t)(input[12] & 0xf8) << 13);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 101 to 116
	value = ((uint32_t)(input[12] & 0x07) << 29) |
			((uint32_t)input[13] << 21) |
			((uint32_t)(input[14] & 0xf8) << 13);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 117 to 132
	value = ((uint32_t)(input[14] & 0x07) << 29) |
			((uint32_t)input[15] << 21) |
			((uint32_t)(input[16] & 0xf8) << 13);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 133 to 148
	value = ((uint32_t)(input[16] & 0x07) << 29) |
			((uint32_t)input[17] << 21) |
			((uint32_t)(input[18] & 0xf8) << 13);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 149 to 164
	value = ((uint32_t)(input[18] & 0x07) << 29) |
			((uint32_t)input[19] << 21) |
			((uint32_t)(input[20] & 0xf8) << 13);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 165 to 180
	value = ((uint32_t)(input[20] & 0x07) << 29) |
			((uint32_t)input[21] << 21) |
			((uint32_t)(input[22] & 0xf8) << 13);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 181 to 196
	value = ((uint32_t)(input[22] & 0x07) << 29) |
			((uint32_t)input[23] << 21) |
			((uint32_t)(input[24] & 0xf8) << 13);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 197 to 212
	value = ((uint32_t)(input[24] & 0x07) << 29) |
			((uint32_t)input[25] << 21) |
			((uint32_t)(input[26] & 0xf8) << 13);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 213 to 228
	value = ((uint32_t)(input[26] & 0x07) << 29) |
			((uint32_t)input[27] << 21) |
			((uint32_t)(input[28] & 0xf8) << 13);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 229 to 244
	value = ((uint32_t)(input[28] & 0x07) << 29) |
			((uint32_t)input[29] << 21) |
			((uint32_t)(input[30] & 0xf8) << 13);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 245 to 260
	value = ((uint32_t)(input[30] & 0x07) << 29) |
			((uint32_t)input[31] << 21) |
			((uint32_t)(input[32] & 0xf8) << 13);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 261 to 276
	value = ((uint32_t)(input[32] & 0x07) << 29) |
			((uint32_t)input[33] << 21) |
			((uint32_t)(input[34] & 0xf8) << 13);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 277 to 292
	value = ((uint32_t)(input[34] & 0x07) << 29) |
			((uint32_t)input[35] << 21) |
			((uint32_t)(input[36] & 0xf8) << 13);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 293 to 308
	value = ((uint32_t)(input[36] & 0x07) << 29) |
			((uint32_t)input[37] << 21) |
			((uint32_t)(input[38] & 0xf8) << 13);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 309 to 324
	value = ((uint32_t)(input[38] & 0x07) << 29) |
			((uint32_t)input[39] << 21) |
			((uint32_t)(input[40] & 0xf8) << 13);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 325 to 340
	value = ((uint32_t)(input[40] & 0x07) << 29) |
			((uint32_t)input[41] << 21) |
			((uint32_t)(input[42] & 0xf8) << 13);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 341 to 356
	value = ((uint32_t)(input[42] & 0x07) << 29) |
			((uint32_t)input[43] << 21) |
			((uint32_t)(input[44] & 0xf8) << 13);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 357 to 372
	value = ((uint32_t)(input[44] & 0x07) << 29) |
			((uint32_t)input[45] << 21) |
			((uint32_t)(input[46] & 0xf8) << 13);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 373 to 388
	value = ((uint32_t)(input[46] & 0x07) << 29) |
			((uint32_t)input[47] << 21) |
			((uint32_t)(input[48] & 0xf8) << 13);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 389 to 404
	value = ((uint32_t)(input[48] & 0x07) << 29) |
			((uint32_t)input[49] << 21) |
			((uint32_t)(input[50] & 0xf8) << 13);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 405 to 420
	value = ((uint32_t)(input[50] & 0x07) << 29) |
			((uint32_t)input[51] << 21) |
			((uint32_t)(input[52] & 0xf8) << 13);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 421 to 436
	value = ((uint32_t)(input[52] & 0x07) << 29) |
			((uint32_t)input[53] << 21) |
			((uint32_t)(input[54] & 0xf8) << 13);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 437 to 452
	value = ((uint32_t)(input[54] & 0x07) << 29) |
			((uint32_t)input[55] << 21) |
			((uint32_t)(input[56] & 0xf8) << 13);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 453 to 468
	value = ((uint32_t)(input[56] & 0x07) << 29) |
			((uint32_t)input[57] << 21) |
			((uint32_t)(input[58] & 0xf8) << 13);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 469 to 484
	value = ((uint32_t)(input[58] & 0x07) << 29) |
			((uint32_t)input[59] << 21) |
			((uint32_t)(input[60] & 0xf8) << 13);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 485 to 500
	value = ((uint32_t)(input[60] & 0x07) << 29) |
			((uint32_t)input[61] << 21) |
			((uint32_t)(input[62] & 0xf8) << 13);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 501 to 516
	value = ((uint32_t)(input[62] & 0x07) << 29) |
			((uint32_t)input[63] << 21) |
			((uint32_t)(input[64] & 0xf8) << 13);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 517 to 532
	value = ((uint32_t)(input[64] & 0x07) << 29) |
			((uint32_t)input[65] << 21) |
			((uint32_t)(input[66] & 0xf8) << 13);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 533 to 548
	value = ((uint32_t)(input[66] & 0x07) << 29) |
			((uint32_t)input[67] << 21) |
			((uint32_t)(input[68] & 0xf8) << 13);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 549 to 564
	value = ((uint32_t)(input[68] & 0x07) << 29) |
			((uint32_t)input[69] << 21) |
			((uint32_t)(input[70] & 0xf8) << 13);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 565 to 580
	value = ((uint32_t)(input[70] & 0x07) << 29) |
			((uint32_t)input[71] << 21) |
			((uint32_t)(input[72] & 0xf8) << 13);
	output[35] = (double)(value >> 16);
}

static void unpack_36_16bit_signed_6off(const uint8_t * input, double * output, void *closure) {
	// Unpack 36 values into output
	// Values are 16-bit signed
	// Skip 6 bits, read 576 bits of data.
	// Input must be at least 73 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 6 to 21
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)(input[2] & 0xfc) << 14);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 22 to 37
	value = ((uint32_t)(input[2] & 0x03) << 30) |
			((uint32_t)input[3] << 22) |
			((uint32_t)(input[4] & 0xfc) << 14);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 38 to 53
	value = ((uint32_t)(input[4] & 0x03) << 30) |
			((uint32_t)input[5] << 22) |
			((uint32_t)(input[6] & 0xfc) << 14);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 54 to 69
	value = ((uint32_t)(input[6] & 0x03) << 30) |
			((uint32_t)input[7] << 22) |
			((uint32_t)(input[8] & 0xfc) << 14);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 70 to 85
	value = ((uint32_t)(input[8] & 0x03) << 30) |
			((uint32_t)input[9] << 22) |
			((uint32_t)(input[10] & 0xfc) << 14);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 86 to 101
	value = ((uint32_t)(input[10] & 0x03) << 30) |
			((uint32_t)input[11] << 22) |
			((uint32_t)(input[12] & 0xfc) << 14);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 102 to 117
	value = ((uint32_t)(input[12] & 0x03) << 30) |
			((uint32_t)input[13] << 22) |
			((uint32_t)(input[14] & 0xfc) << 14);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 118 to 133
	value = ((uint32_t)(input[14] & 0x03) << 30) |
			((uint32_t)input[15] << 22) |
			((uint32_t)(input[16] & 0xfc) << 14);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 134 to 149
	value = ((uint32_t)(input[16] & 0x03) << 30) |
			((uint32_t)input[17] << 22) |
			((uint32_t)(input[18] & 0xfc) << 14);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 150 to 165
	value = ((uint32_t)(input[18] & 0x03) << 30) |
			((uint32_t)input[19] << 22) |
			((uint32_t)(input[20] & 0xfc) << 14);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 166 to 181
	value = ((uint32_t)(input[20] & 0x03) << 30) |
			((uint32_t)input[21] << 22) |
			((uint32_t)(input[22] & 0xfc) << 14);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 182 to 197
	value = ((uint32_t)(input[22] & 0x03) << 30) |
			((uint32_t)input[23] << 22) |
			((uint32_t)(input[24] & 0xfc) << 14);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 198 to 213
	value = ((uint32_t)(input[24] & 0x03) << 30) |
			((uint32_t)input[25] << 22) |
			((uint32_t)(input[26] & 0xfc) << 14);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 214 to 229
	value = ((uint32_t)(input[26] & 0x03) << 30) |
			((uint32_t)input[27] << 22) |
			((uint32_t)(input[28] & 0xfc) << 14);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 230 to 245
	value = ((uint32_t)(input[28] & 0x03) << 30) |
			((uint32_t)input[29] << 22) |
			((uint32_t)(input[30] & 0xfc) << 14);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 246 to 261
	value = ((uint32_t)(input[30] & 0x03) << 30) |
			((uint32_t)input[31] << 22) |
			((uint32_t)(input[32] & 0xfc) << 14);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 262 to 277
	value = ((uint32_t)(input[32] & 0x03) << 30) |
			((uint32_t)input[33] << 22) |
			((uint32_t)(input[34] & 0xfc) << 14);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 278 to 293
	value = ((uint32_t)(input[34] & 0x03) << 30) |
			((uint32_t)input[35] << 22) |
			((uint32_t)(input[36] & 0xfc) << 14);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 294 to 309
	value = ((uint32_t)(input[36] & 0x03) << 30) |
			((uint32_t)input[37] << 22) |
			((uint32_t)(input[38] & 0xfc) << 14);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 310 to 325
	value = ((uint32_t)(input[38] & 0x03) << 30) |
			((uint32_t)input[39] << 22) |
			((uint32_t)(input[40] & 0xfc) << 14);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 326 to 341
	value = ((uint32_t)(input[40] & 0x03) << 30) |
			((uint32_t)input[41] << 22) |
			((uint32_t)(input[42] & 0xfc) << 14);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 342 to 357
	value = ((uint32_t)(input[42] & 0x03) << 30) |
			((uint32_t)input[43] << 22) |
			((uint32_t)(input[44] & 0xfc) << 14);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 358 to 373
	value = ((uint32_t)(input[44] & 0x03) << 30) |
			((uint32_t)input[45] << 22) |
			((uint32_t)(input[46] & 0xfc) << 14);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 374 to 389
	value = ((uint32_t)(input[46] & 0x03) << 30) |
			((uint32_t)input[47] << 22) |
			((uint32_t)(input[48] & 0xfc) << 14);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 390 to 405
	value = ((uint32_t)(input[48] & 0x03) << 30) |
			((uint32_t)input[49] << 22) |
			((uint32_t)(input[50] & 0xfc) << 14);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 406 to 421
	value = ((uint32_t)(input[50] & 0x03) << 30) |
			((uint32_t)input[51] << 22) |
			((uint32_t)(input[52] & 0xfc) << 14);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 422 to 437
	value = ((uint32_t)(input[52] & 0x03) << 30) |
			((uint32_t)input[53] << 22) |
			((uint32_t)(input[54] & 0xfc) << 14);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 438 to 453
	value = ((uint32_t)(input[54] & 0x03) << 30) |
			((uint32_t)input[55] << 22) |
			((uint32_t)(input[56] & 0xfc) << 14);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 454 to 469
	value = ((uint32_t)(input[56] & 0x03) << 30) |
			((uint32_t)input[57] << 22) |
			((uint32_t)(input[58] & 0xfc) << 14);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 470 to 485
	value = ((uint32_t)(input[58] & 0x03) << 30) |
			((uint32_t)input[59] << 22) |
			((uint32_t)(input[60] & 0xfc) << 14);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 486 to 501
	value = ((uint32_t)(input[60] & 0x03) << 30) |
			((uint32_t)input[61] << 22) |
			((uint32_t)(input[62] & 0xfc) << 14);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 502 to 517
	value = ((uint32_t)(input[62] & 0x03) << 30) |
			((uint32_t)input[63] << 22) |
			((uint32_t)(input[64] & 0xfc) << 14);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 518 to 533
	value = ((uint32_t)(input[64] & 0x03) << 30) |
			((uint32_t)input[65] << 22) |
			((uint32_t)(input[66] & 0xfc) << 14);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 534 to 549
	value = ((uint32_t)(input[66] & 0x03) << 30) |
			((uint32_t)input[67] << 22) |
			((uint32_t)(input[68] & 0xfc) << 14);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 550 to 565
	value = ((uint32_t)(input[68] & 0x03) << 30) |
			((uint32_t)input[69] << 22) |
			((uint32_t)(input[70] & 0xfc) << 14);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 566 to 581
	value = ((uint32_t)(input[70] & 0x03) << 30) |
			((uint32_t)input[71] << 22) |
			((uint32_t)(input[72] & 0xfc) << 14);
	output[35] = (double)(value >> 16);
}

static void unpack_36_16bit_unsigned_6off(const uint8_t * input, double * output, void *closure) {
	// Unpack 36 values into output
	// Values are 16-bit unsigned
	// Skip 6 bits, read 576 bits of data.
	// Input must be at least 73 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 6 to 21
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)(input[2] & 0xfc) << 14);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 22 to 37
	value = ((uint32_t)(input[2] & 0x03) << 30) |
			((uint32_t)input[3] << 22) |
			((uint32_t)(input[4] & 0xfc) << 14);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 38 to 53
	value = ((uint32_t)(input[4] & 0x03) << 30) |
			((uint32_t)input[5] << 22) |
			((uint32_t)(input[6] & 0xfc) << 14);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 54 to 69
	value = ((uint32_t)(input[6] & 0x03) << 30) |
			((uint32_t)input[7] << 22) |
			((uint32_t)(input[8] & 0xfc) << 14);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 70 to 85
	value = ((uint32_t)(input[8] & 0x03) << 30) |
			((uint32_t)input[9] << 22) |
			((uint32_t)(input[10] & 0xfc) << 14);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 86 to 101
	value = ((uint32_t)(input[10] & 0x03) << 30) |
			((uint32_t)input[11] << 22) |
			((uint32_t)(input[12] & 0xfc) << 14);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 102 to 117
	value = ((uint32_t)(input[12] & 0x03) << 30) |
			((uint32_t)input[13] << 22) |
			((uint32_t)(input[14] & 0xfc) << 14);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 118 to 133
	value = ((uint32_t)(input[14] & 0x03) << 30) |
			((uint32_t)input[15] << 22) |
			((uint32_t)(input[16] & 0xfc) << 14);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 134 to 149
	value = ((uint32_t)(input[16] & 0x03) << 30) |
			((uint32_t)input[17] << 22) |
			((uint32_t)(input[18] & 0xfc) << 14);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 150 to 165
	value = ((uint32_t)(input[18] & 0x03) << 30) |
			((uint32_t)input[19] << 22) |
			((uint32_t)(input[20] & 0xfc) << 14);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 166 to 181
	value = ((uint32_t)(input[20] & 0x03) << 30) |
			((uint32_t)input[21] << 22) |
			((uint32_t)(input[22] & 0xfc) << 14);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 182 to 197
	value = ((uint32_t)(input[22] & 0x03) << 30) |
			((uint32_t)input[23] << 22) |
			((uint32_t)(input[24] & 0xfc) << 14);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 198 to 213
	value = ((uint32_t)(input[24] & 0x03) << 30) |
			((uint32_t)input[25] << 22) |
			((uint32_t)(input[26] & 0xfc) << 14);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 214 to 229
	value = ((uint32_t)(input[26] & 0x03) << 30) |
			((uint32_t)input[27] << 22) |
			((uint32_t)(input[28] & 0xfc) << 14);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 230 to 245
	value = ((uint32_t)(input[28] & 0x03) << 30) |
			((uint32_t)input[29] << 22) |
			((uint32_t)(input[30] & 0xfc) << 14);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 246 to 261
	value = ((uint32_t)(input[30] & 0x03) << 30) |
			((uint32_t)input[31] << 22) |
			((uint32_t)(input[32] & 0xfc) << 14);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 262 to 277
	value = ((uint32_t)(input[32] & 0x03) << 30) |
			((uint32_t)input[33] << 22) |
			((uint32_t)(input[34] & 0xfc) << 14);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 278 to 293
	value = ((uint32_t)(input[34] & 0x03) << 30) |
			((uint32_t)input[35] << 22) |
			((uint32_t)(input[36] & 0xfc) << 14);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 294 to 309
	value = ((uint32_t)(input[36] & 0x03) << 30) |
			((uint32_t)input[37] << 22) |
			((uint32_t)(input[38] & 0xfc) << 14);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 310 to 325
	value = ((uint32_t)(input[38] & 0x03) << 30) |
			((uint32_t)input[39] << 22) |
			((uint32_t)(input[40] & 0xfc) << 14);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 326 to 341
	value = ((uint32_t)(input[40] & 0x03) << 30) |
			((uint32_t)input[41] << 22) |
			((uint32_t)(input[42] & 0xfc) << 14);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 342 to 357
	value = ((uint32_t)(input[42] & 0x03) << 30) |
			((uint32_t)input[43] << 22) |
			((uint32_t)(input[44] & 0xfc) << 14);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 358 to 373
	value = ((uint32_t)(input[44] & 0x03) << 30) |
			((uint32_t)input[45] << 22) |
			((uint32_t)(input[46] & 0xfc) << 14);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 374 to 389
	value = ((uint32_t)(input[46] & 0x03) << 30) |
			((uint32_t)input[47] << 22) |
			((uint32_t)(input[48] & 0xfc) << 14);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 390 to 405
	value = ((uint32_t)(input[48] & 0x03) << 30) |
			((uint32_t)input[49] << 22) |
			((uint32_t)(input[50] & 0xfc) << 14);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 406 to 421
	value = ((uint32_t)(input[50] & 0x03) << 30) |
			((uint32_t)input[51] << 22) |
			((uint32_t)(input[52] & 0xfc) << 14);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 422 to 437
	value = ((uint32_t)(input[52] & 0x03) << 30) |
			((uint32_t)input[53] << 22) |
			((uint32_t)(input[54] & 0xfc) << 14);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 438 to 453
	value = ((uint32_t)(input[54] & 0x03) << 30) |
			((uint32_t)input[55] << 22) |
			((uint32_t)(input[56] & 0xfc) << 14);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 454 to 469
	value = ((uint32_t)(input[56] & 0x03) << 30) |
			((uint32_t)input[57] << 22) |
			((uint32_t)(input[58] & 0xfc) << 14);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 470 to 485
	value = ((uint32_t)(input[58] & 0x03) << 30) |
			((uint32_t)input[59] << 22) |
			((uint32_t)(input[60] & 0xfc) << 14);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 486 to 501
	value = ((uint32_t)(input[60] & 0x03) << 30) |
			((uint32_t)input[61] << 22) |
			((uint32_t)(input[62] & 0xfc) << 14);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 502 to 517
	value = ((uint32_t)(input[62] & 0x03) << 30) |
			((uint32_t)input[63] << 22) |
			((uint32_t)(input[64] & 0xfc) << 14);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 518 to 533
	value = ((uint32_t)(input[64] & 0x03) << 30) |
			((uint32_t)input[65] << 22) |
			((uint32_t)(input[66] & 0xfc) << 14);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 534 to 549
	value = ((uint32_t)(input[66] & 0x03) << 30) |
			((uint32_t)input[67] << 22) |
			((uint32_t)(input[68] & 0xfc) << 14);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 550 to 565
	value = ((uint32_t)(input[68] & 0x03) << 30) |
			((uint32_t)input[69] << 22) |
			((uint32_t)(input[70] & 0xfc) << 14);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 566 to 581
	value = ((uint32_t)(input[70] & 0x03) << 30) |
			((uint32_t)input[71] << 22) |
			((uint32_t)(input[72] & 0xfc) << 14);
	output[35] = (double)(value >> 16);
}

static void unpack_36_16bit_signed_7off(const uint8_t * input, double * output, void *closure) {
	// Unpack 36 values into output
	// Values are 16-bit signed
	// Skip 7 bits, read 576 bits of data.
	// Input must be at least 73 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 7 to 22
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)(input[2] & 0xfe) << 15);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 23 to 38
	value = ((uint32_t)(input[2] & 0x01) << 31) |
			((uint32_t)input[3] << 23) |
			((uint32_t)(input[4] & 0xfe) << 15);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 39 to 54
	value = ((uint32_t)(input[4] & 0x01) << 31) |
			((uint32_t)input[5] << 23) |
			((uint32_t)(input[6] & 0xfe) << 15);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 55 to 70
	value = ((uint32_t)(input[6] & 0x01) << 31) |
			((uint32_t)input[7] << 23) |
			((uint32_t)(input[8] & 0xfe) << 15);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 71 to 86
	value = ((uint32_t)(input[8] & 0x01) << 31) |
			((uint32_t)input[9] << 23) |
			((uint32_t)(input[10] & 0xfe) << 15);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 87 to 102
	value = ((uint32_t)(input[10] & 0x01) << 31) |
			((uint32_t)input[11] << 23) |
			((uint32_t)(input[12] & 0xfe) << 15);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 103 to 118
	value = ((uint32_t)(input[12] & 0x01) << 31) |
			((uint32_t)input[13] << 23) |
			((uint32_t)(input[14] & 0xfe) << 15);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 119 to 134
	value = ((uint32_t)(input[14] & 0x01) << 31) |
			((uint32_t)input[15] << 23) |
			((uint32_t)(input[16] & 0xfe) << 15);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 135 to 150
	value = ((uint32_t)(input[16] & 0x01) << 31) |
			((uint32_t)input[17] << 23) |
			((uint32_t)(input[18] & 0xfe) << 15);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 151 to 166
	value = ((uint32_t)(input[18] & 0x01) << 31) |
			((uint32_t)input[19] << 23) |
			((uint32_t)(input[20] & 0xfe) << 15);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 167 to 182
	value = ((uint32_t)(input[20] & 0x01) << 31) |
			((uint32_t)input[21] << 23) |
			((uint32_t)(input[22] & 0xfe) << 15);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 183 to 198
	value = ((uint32_t)(input[22] & 0x01) << 31) |
			((uint32_t)input[23] << 23) |
			((uint32_t)(input[24] & 0xfe) << 15);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 199 to 214
	value = ((uint32_t)(input[24] & 0x01) << 31) |
			((uint32_t)input[25] << 23) |
			((uint32_t)(input[26] & 0xfe) << 15);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 215 to 230
	value = ((uint32_t)(input[26] & 0x01) << 31) |
			((uint32_t)input[27] << 23) |
			((uint32_t)(input[28] & 0xfe) << 15);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 231 to 246
	value = ((uint32_t)(input[28] & 0x01) << 31) |
			((uint32_t)input[29] << 23) |
			((uint32_t)(input[30] & 0xfe) << 15);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 247 to 262
	value = ((uint32_t)(input[30] & 0x01) << 31) |
			((uint32_t)input[31] << 23) |
			((uint32_t)(input[32] & 0xfe) << 15);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 263 to 278
	value = ((uint32_t)(input[32] & 0x01) << 31) |
			((uint32_t)input[33] << 23) |
			((uint32_t)(input[34] & 0xfe) << 15);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 279 to 294
	value = ((uint32_t)(input[34] & 0x01) << 31) |
			((uint32_t)input[35] << 23) |
			((uint32_t)(input[36] & 0xfe) << 15);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 295 to 310
	value = ((uint32_t)(input[36] & 0x01) << 31) |
			((uint32_t)input[37] << 23) |
			((uint32_t)(input[38] & 0xfe) << 15);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 311 to 326
	value = ((uint32_t)(input[38] & 0x01) << 31) |
			((uint32_t)input[39] << 23) |
			((uint32_t)(input[40] & 0xfe) << 15);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 327 to 342
	value = ((uint32_t)(input[40] & 0x01) << 31) |
			((uint32_t)input[41] << 23) |
			((uint32_t)(input[42] & 0xfe) << 15);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 343 to 358
	value = ((uint32_t)(input[42] & 0x01) << 31) |
			((uint32_t)input[43] << 23) |
			((uint32_t)(input[44] & 0xfe) << 15);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 359 to 374
	value = ((uint32_t)(input[44] & 0x01) << 31) |
			((uint32_t)input[45] << 23) |
			((uint32_t)(input[46] & 0xfe) << 15);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 375 to 390
	value = ((uint32_t)(input[46] & 0x01) << 31) |
			((uint32_t)input[47] << 23) |
			((uint32_t)(input[48] & 0xfe) << 15);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 391 to 406
	value = ((uint32_t)(input[48] & 0x01) << 31) |
			((uint32_t)input[49] << 23) |
			((uint32_t)(input[50] & 0xfe) << 15);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 407 to 422
	value = ((uint32_t)(input[50] & 0x01) << 31) |
			((uint32_t)input[51] << 23) |
			((uint32_t)(input[52] & 0xfe) << 15);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 423 to 438
	value = ((uint32_t)(input[52] & 0x01) << 31) |
			((uint32_t)input[53] << 23) |
			((uint32_t)(input[54] & 0xfe) << 15);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 439 to 454
	value = ((uint32_t)(input[54] & 0x01) << 31) |
			((uint32_t)input[55] << 23) |
			((uint32_t)(input[56] & 0xfe) << 15);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 455 to 470
	value = ((uint32_t)(input[56] & 0x01) << 31) |
			((uint32_t)input[57] << 23) |
			((uint32_t)(input[58] & 0xfe) << 15);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 471 to 486
	value = ((uint32_t)(input[58] & 0x01) << 31) |
			((uint32_t)input[59] << 23) |
			((uint32_t)(input[60] & 0xfe) << 15);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 487 to 502
	value = ((uint32_t)(input[60] & 0x01) << 31) |
			((uint32_t)input[61] << 23) |
			((uint32_t)(input[62] & 0xfe) << 15);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 503 to 518
	value = ((uint32_t)(input[62] & 0x01) << 31) |
			((uint32_t)input[63] << 23) |
			((uint32_t)(input[64] & 0xfe) << 15);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 519 to 534
	value = ((uint32_t)(input[64] & 0x01) << 31) |
			((uint32_t)input[65] << 23) |
			((uint32_t)(input[66] & 0xfe) << 15);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 535 to 550
	value = ((uint32_t)(input[66] & 0x01) << 31) |
			((uint32_t)input[67] << 23) |
			((uint32_t)(input[68] & 0xfe) << 15);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 551 to 566
	value = ((uint32_t)(input[68] & 0x01) << 31) |
			((uint32_t)input[69] << 23) |
			((uint32_t)(input[70] & 0xfe) << 15);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 567 to 582
	value = ((uint32_t)(input[70] & 0x01) << 31) |
			((uint32_t)input[71] << 23) |
			((uint32_t)(input[72] & 0xfe) << 15);
	output[35] = (double)(value >> 16);
}

static void unpack_36_16bit_unsigned_7off(const uint8_t * input, double * output, void *closure) {
	// Unpack 36 values into output
	// Values are 16-bit unsigned
	// Skip 7 bits, read 576 bits of data.
	// Input must be at least 73 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 7 to 22
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)(input[2] & 0xfe) << 15);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 23 to 38
	value = ((uint32_t)(input[2] & 0x01) << 31) |
			((uint32_t)input[3] << 23) |
			((uint32_t)(input[4] & 0xfe) << 15);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 39 to 54
	value = ((uint32_t)(input[4] & 0x01) << 31) |
			((uint32_t)input[5] << 23) |
			((uint32_t)(input[6] & 0xfe) << 15);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 55 to 70
	value = ((uint32_t)(input[6] & 0x01) << 31) |
			((uint32_t)input[7] << 23) |
			((uint32_t)(input[8] & 0xfe) << 15);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 71 to 86
	value = ((uint32_t)(input[8] & 0x01) << 31) |
			((uint32_t)input[9] << 23) |
			((uint32_t)(input[10] & 0xfe) << 15);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 87 to 102
	value = ((uint32_t)(input[10] & 0x01) << 31) |
			((uint32_t)input[11] << 23) |
			((uint32_t)(input[12] & 0xfe) << 15);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 103 to 118
	value = ((uint32_t)(input[12] & 0x01) << 31) |
			((uint32_t)input[13] << 23) |
			((uint32_t)(input[14] & 0xfe) << 15);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 119 to 134
	value = ((uint32_t)(input[14] & 0x01) << 31) |
			((uint32_t)input[15] << 23) |
			((uint32_t)(input[16] & 0xfe) << 15);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 135 to 150
	value = ((uint32_t)(input[16] & 0x01) << 31) |
			((uint32_t)input[17] << 23) |
			((uint32_t)(input[18] & 0xfe) << 15);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 151 to 166
	value = ((uint32_t)(input[18] & 0x01) << 31) |
			((uint32_t)input[19] << 23) |
			((uint32_t)(input[20] & 0xfe) << 15);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 167 to 182
	value = ((uint32_t)(input[20] & 0x01) << 31) |
			((uint32_t)input[21] << 23) |
			((uint32_t)(input[22] & 0xfe) << 15);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 183 to 198
	value = ((uint32_t)(input[22] & 0x01) << 31) |
			((uint32_t)input[23] << 23) |
			((uint32_t)(input[24] & 0xfe) << 15);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 199 to 214
	value = ((uint32_t)(input[24] & 0x01) << 31) |
			((uint32_t)input[25] << 23) |
			((uint32_t)(input[26] & 0xfe) << 15);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 215 to 230
	value = ((uint32_t)(input[26] & 0x01) << 31) |
			((uint32_t)input[27] << 23) |
			((uint32_t)(input[28] & 0xfe) << 15);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 231 to 246
	value = ((uint32_t)(input[28] & 0x01) << 31) |
			((uint32_t)input[29] << 23) |
			((uint32_t)(input[30] & 0xfe) << 15);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 247 to 262
	value = ((uint32_t)(input[30] & 0x01) << 31) |
			((uint32_t)input[31] << 23) |
			((uint32_t)(input[32] & 0xfe) << 15);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 263 to 278
	value = ((uint32_t)(input[32] & 0x01) << 31) |
			((uint32_t)input[33] << 23) |
			((uint32_t)(input[34] & 0xfe) << 15);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 279 to 294
	value = ((uint32_t)(input[34] & 0x01) << 31) |
			((uint32_t)input[35] << 23) |
			((uint32_t)(input[36] & 0xfe) << 15);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 295 to 310
	value = ((uint32_t)(input[36] & 0x01) << 31) |
			((uint32_t)input[37] << 23) |
			((uint32_t)(input[38] & 0xfe) << 15);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 311 to 326
	value = ((uint32_t)(input[38] & 0x01) << 31) |
			((uint32_t)input[39] << 23) |
			((uint32_t)(input[40] & 0xfe) << 15);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 327 to 342
	value = ((uint32_t)(input[40] & 0x01) << 31) |
			((uint32_t)input[41] << 23) |
			((uint32_t)(input[42] & 0xfe) << 15);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 343 to 358
	value = ((uint32_t)(input[42] & 0x01) << 31) |
			((uint32_t)input[43] << 23) |
			((uint32_t)(input[44] & 0xfe) << 15);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 359 to 374
	value = ((uint32_t)(input[44] & 0x01) << 31) |
			((uint32_t)input[45] << 23) |
			((uint32_t)(input[46] & 0xfe) << 15);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 375 to 390
	value = ((uint32_t)(input[46] & 0x01) << 31) |
			((uint32_t)input[47] << 23) |
			((uint32_t)(input[48] & 0xfe) << 15);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 391 to 406
	value = ((uint32_t)(input[48] & 0x01) << 31) |
			((uint32_t)input[49] << 23) |
			((uint32_t)(input[50] & 0xfe) << 15);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 407 to 422
	value = ((uint32_t)(input[50] & 0x01) << 31) |
			((uint32_t)input[51] << 23) |
			((uint32_t)(input[52] & 0xfe) << 15);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 423 to 438
	value = ((uint32_t)(input[52] & 0x01) << 31) |
			((uint32_t)input[53] << 23) |
			((uint32_t)(input[54] & 0xfe) << 15);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 439 to 454
	value = ((uint32_t)(input[54] & 0x01) << 31) |
			((uint32_t)input[55] << 23) |
			((uint32_t)(input[56] & 0xfe) << 15);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 455 to 470
	value = ((uint32_t)(input[56] & 0x01) << 31) |
			((uint32_t)input[57] << 23) |
			((uint32_t)(input[58] & 0xfe) << 15);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 471 to 486
	value = ((uint32_t)(input[58] & 0x01) << 31) |
			((uint32_t)input[59] << 23) |
			((uint32_t)(input[60] & 0xfe) << 15);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 487 to 502
	value = ((uint32_t)(input[60] & 0x01) << 31) |
			((uint32_t)input[61] << 23) |
			((uint32_t)(input[62] & 0xfe) << 15);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 503 to 518
	value = ((uint32_t)(input[62] & 0x01) << 31) |
			((uint32_t)input[63] << 23) |
			((uint32_t)(input[64] & 0xfe) << 15);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 519 to 534
	value = ((uint32_t)(input[64] & 0x01) << 31) |
			((uint32_t)input[65] << 23) |
			((uint32_t)(input[66] & 0xfe) << 15);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 535 to 550
	value = ((uint32_t)(input[66] & 0x01) << 31) |
			((uint32_t)input[67] << 23) |
			((uint32_t)(input[68] & 0xfe) << 15);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 551 to 566
	value = ((uint32_t)(input[68] & 0x01) << 31) |
			((uint32_t)input[69] << 23) |
			((uint32_t)(input[70] & 0xfe) << 15);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 567 to 582
	value = ((uint32_t)(input[70] & 0x01) << 31) |
			((uint32_t)input[71] << 23) |
			((uint32_t)(input[72] & 0xfe) << 15);
	output[35] = (double)(value >> 16);
}

static void unpack_37_16bit_signed_0off(const uint8_t * input, double * output, void *closure) {
	// Unpack 37 values into output
	// Values are 16-bit signed
	// Skip 0 bits, read 592 bits of data.
	// Input must be at least 74 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 0 to 15
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)input[1] << 16);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 16 to 31
	value = ((uint32_t)input[2] << 24) |
			((uint32_t)input[3] << 16);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 32 to 47
	value = ((uint32_t)input[4] << 24) |
			((uint32_t)input[5] << 16);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 48 to 63
	value = ((uint32_t)input[6] << 24) |
			((uint32_t)input[7] << 16);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 64 to 79
	value = ((uint32_t)input[8] << 24) |
			((uint32_t)input[9] << 16);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 80 to 95
	value = ((uint32_t)input[10] << 24) |
			((uint32_t)input[11] << 16);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 96 to 111
	value = ((uint32_t)input[12] << 24) |
			((uint32_t)input[13] << 16);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 112 to 127
	value = ((uint32_t)input[14] << 24) |
			((uint32_t)input[15] << 16);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 128 to 143
	value = ((uint32_t)input[16] << 24) |
			((uint32_t)input[17] << 16);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 144 to 159
	value = ((uint32_t)input[18] << 24) |
			((uint32_t)input[19] << 16);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 160 to 175
	value = ((uint32_t)input[20] << 24) |
			((uint32_t)input[21] << 16);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 176 to 191
	value = ((uint32_t)input[22] << 24) |
			((uint32_t)input[23] << 16);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 192 to 207
	value = ((uint32_t)input[24] << 24) |
			((uint32_t)input[25] << 16);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 208 to 223
	value = ((uint32_t)input[26] << 24) |
			((uint32_t)input[27] << 16);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 224 to 239
	value = ((uint32_t)input[28] << 24) |
			((uint32_t)input[29] << 16);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 240 to 255
	value = ((uint32_t)input[30] << 24) |
			((uint32_t)input[31] << 16);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 256 to 271
	value = ((uint32_t)input[32] << 24) |
			((uint32_t)input[33] << 16);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 272 to 287
	value = ((uint32_t)input[34] << 24) |
			((uint32_t)input[35] << 16);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 288 to 303
	value = ((uint32_t)input[36] << 24) |
			((uint32_t)input[37] << 16);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 304 to 319
	value = ((uint32_t)input[38] << 24) |
			((uint32_t)input[39] << 16);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 320 to 335
	value = ((uint32_t)input[40] << 24) |
			((uint32_t)input[41] << 16);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 336 to 351
	value = ((uint32_t)input[42] << 24) |
			((uint32_t)input[43] << 16);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 352 to 367
	value = ((uint32_t)input[44] << 24) |
			((uint32_t)input[45] << 16);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 368 to 383
	value = ((uint32_t)input[46] << 24) |
			((uint32_t)input[47] << 16);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 384 to 399
	value = ((uint32_t)input[48] << 24) |
			((uint32_t)input[49] << 16);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 400 to 415
	value = ((uint32_t)input[50] << 24) |
			((uint32_t)input[51] << 16);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 416 to 431
	value = ((uint32_t)input[52] << 24) |
			((uint32_t)input[53] << 16);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 432 to 447
	value = ((uint32_t)input[54] << 24) |
			((uint32_t)input[55] << 16);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 448 to 463
	value = ((uint32_t)input[56] << 24) |
			((uint32_t)input[57] << 16);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 464 to 479
	value = ((uint32_t)input[58] << 24) |
			((uint32_t)input[59] << 16);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 480 to 495
	value = ((uint32_t)input[60] << 24) |
			((uint32_t)input[61] << 16);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 496 to 511
	value = ((uint32_t)input[62] << 24) |
			((uint32_t)input[63] << 16);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 512 to 527
	value = ((uint32_t)input[64] << 24) |
			((uint32_t)input[65] << 16);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 528 to 543
	value = ((uint32_t)input[66] << 24) |
			((uint32_t)input[67] << 16);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 544 to 559
	value = ((uint32_t)input[68] << 24) |
			((uint32_t)input[69] << 16);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 560 to 575
	value = ((uint32_t)input[70] << 24) |
			((uint32_t)input[71] << 16);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 576 to 591
	value = ((uint32_t)input[72] << 24) |
			((uint32_t)input[73] << 16);
	output[36] = (double)(value >> 16);
}

static void unpack_37_16bit_unsigned_0off(const uint8_t * input, double * output, void *closure) {
	// Unpack 37 values into output
	// Values are 16-bit unsigned
	// Skip 0 bits, read 592 bits of data.
	// Input must be at least 74 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 0 to 15
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)input[1] << 16);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 16 to 31
	value = ((uint32_t)input[2] << 24) |
			((uint32_t)input[3] << 16);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 32 to 47
	value = ((uint32_t)input[4] << 24) |
			((uint32_t)input[5] << 16);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 48 to 63
	value = ((uint32_t)input[6] << 24) |
			((uint32_t)input[7] << 16);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 64 to 79
	value = ((uint32_t)input[8] << 24) |
			((uint32_t)input[9] << 16);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 80 to 95
	value = ((uint32_t)input[10] << 24) |
			((uint32_t)input[11] << 16);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 96 to 111
	value = ((uint32_t)input[12] << 24) |
			((uint32_t)input[13] << 16);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 112 to 127
	value = ((uint32_t)input[14] << 24) |
			((uint32_t)input[15] << 16);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 128 to 143
	value = ((uint32_t)input[16] << 24) |
			((uint32_t)input[17] << 16);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 144 to 159
	value = ((uint32_t)input[18] << 24) |
			((uint32_t)input[19] << 16);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 160 to 175
	value = ((uint32_t)input[20] << 24) |
			((uint32_t)input[21] << 16);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 176 to 191
	value = ((uint32_t)input[22] << 24) |
			((uint32_t)input[23] << 16);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 192 to 207
	value = ((uint32_t)input[24] << 24) |
			((uint32_t)input[25] << 16);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 208 to 223
	value = ((uint32_t)input[26] << 24) |
			((uint32_t)input[27] << 16);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 224 to 239
	value = ((uint32_t)input[28] << 24) |
			((uint32_t)input[29] << 16);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 240 to 255
	value = ((uint32_t)input[30] << 24) |
			((uint32_t)input[31] << 16);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 256 to 271
	value = ((uint32_t)input[32] << 24) |
			((uint32_t)input[33] << 16);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 272 to 287
	value = ((uint32_t)input[34] << 24) |
			((uint32_t)input[35] << 16);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 288 to 303
	value = ((uint32_t)input[36] << 24) |
			((uint32_t)input[37] << 16);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 304 to 319
	value = ((uint32_t)input[38] << 24) |
			((uint32_t)input[39] << 16);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 320 to 335
	value = ((uint32_t)input[40] << 24) |
			((uint32_t)input[41] << 16);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 336 to 351
	value = ((uint32_t)input[42] << 24) |
			((uint32_t)input[43] << 16);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 352 to 367
	value = ((uint32_t)input[44] << 24) |
			((uint32_t)input[45] << 16);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 368 to 383
	value = ((uint32_t)input[46] << 24) |
			((uint32_t)input[47] << 16);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 384 to 399
	value = ((uint32_t)input[48] << 24) |
			((uint32_t)input[49] << 16);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 400 to 415
	value = ((uint32_t)input[50] << 24) |
			((uint32_t)input[51] << 16);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 416 to 431
	value = ((uint32_t)input[52] << 24) |
			((uint32_t)input[53] << 16);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 432 to 447
	value = ((uint32_t)input[54] << 24) |
			((uint32_t)input[55] << 16);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 448 to 463
	value = ((uint32_t)input[56] << 24) |
			((uint32_t)input[57] << 16);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 464 to 479
	value = ((uint32_t)input[58] << 24) |
			((uint32_t)input[59] << 16);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 480 to 495
	value = ((uint32_t)input[60] << 24) |
			((uint32_t)input[61] << 16);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 496 to 511
	value = ((uint32_t)input[62] << 24) |
			((uint32_t)input[63] << 16);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 512 to 527
	value = ((uint32_t)input[64] << 24) |
			((uint32_t)input[65] << 16);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 528 to 543
	value = ((uint32_t)input[66] << 24) |
			((uint32_t)input[67] << 16);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 544 to 559
	value = ((uint32_t)input[68] << 24) |
			((uint32_t)input[69] << 16);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 560 to 575
	value = ((uint32_t)input[70] << 24) |
			((uint32_t)input[71] << 16);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 576 to 591
	value = ((uint32_t)input[72] << 24) |
			((uint32_t)input[73] << 16);
	output[36] = (double)(value >> 16);
}

static void unpack_37_16bit_signed_1off(const uint8_t * input, double * output, void *closure) {
	// Unpack 37 values into output
	// Values are 16-bit signed
	// Skip 1 bits, read 592 bits of data.
	// Input must be at least 75 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 1 to 16
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)input[1] << 17) |
			((uint32_t)(input[2] & 0x80) << 9);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 17 to 32
	value = ((uint32_t)(input[2] & 0x7f) << 25) |
			((uint32_t)input[3] << 17) |
			((uint32_t)(input[4] & 0x80) << 9);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 33 to 48
	value = ((uint32_t)(input[4] & 0x7f) << 25) |
			((uint32_t)input[5] << 17) |
			((uint32_t)(input[6] & 0x80) << 9);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 49 to 64
	value = ((uint32_t)(input[6] & 0x7f) << 25) |
			((uint32_t)input[7] << 17) |
			((uint32_t)(input[8] & 0x80) << 9);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 65 to 80
	value = ((uint32_t)(input[8] & 0x7f) << 25) |
			((uint32_t)input[9] << 17) |
			((uint32_t)(input[10] & 0x80) << 9);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 81 to 96
	value = ((uint32_t)(input[10] & 0x7f) << 25) |
			((uint32_t)input[11] << 17) |
			((uint32_t)(input[12] & 0x80) << 9);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 97 to 112
	value = ((uint32_t)(input[12] & 0x7f) << 25) |
			((uint32_t)input[13] << 17) |
			((uint32_t)(input[14] & 0x80) << 9);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 113 to 128
	value = ((uint32_t)(input[14] & 0x7f) << 25) |
			((uint32_t)input[15] << 17) |
			((uint32_t)(input[16] & 0x80) << 9);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 129 to 144
	value = ((uint32_t)(input[16] & 0x7f) << 25) |
			((uint32_t)input[17] << 17) |
			((uint32_t)(input[18] & 0x80) << 9);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 145 to 160
	value = ((uint32_t)(input[18] & 0x7f) << 25) |
			((uint32_t)input[19] << 17) |
			((uint32_t)(input[20] & 0x80) << 9);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 161 to 176
	value = ((uint32_t)(input[20] & 0x7f) << 25) |
			((uint32_t)input[21] << 17) |
			((uint32_t)(input[22] & 0x80) << 9);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 177 to 192
	value = ((uint32_t)(input[22] & 0x7f) << 25) |
			((uint32_t)input[23] << 17) |
			((uint32_t)(input[24] & 0x80) << 9);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 193 to 208
	value = ((uint32_t)(input[24] & 0x7f) << 25) |
			((uint32_t)input[25] << 17) |
			((uint32_t)(input[26] & 0x80) << 9);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 209 to 224
	value = ((uint32_t)(input[26] & 0x7f) << 25) |
			((uint32_t)input[27] << 17) |
			((uint32_t)(input[28] & 0x80) << 9);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 225 to 240
	value = ((uint32_t)(input[28] & 0x7f) << 25) |
			((uint32_t)input[29] << 17) |
			((uint32_t)(input[30] & 0x80) << 9);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 241 to 256
	value = ((uint32_t)(input[30] & 0x7f) << 25) |
			((uint32_t)input[31] << 17) |
			((uint32_t)(input[32] & 0x80) << 9);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 257 to 272
	value = ((uint32_t)(input[32] & 0x7f) << 25) |
			((uint32_t)input[33] << 17) |
			((uint32_t)(input[34] & 0x80) << 9);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 273 to 288
	value = ((uint32_t)(input[34] & 0x7f) << 25) |
			((uint32_t)input[35] << 17) |
			((uint32_t)(input[36] & 0x80) << 9);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 289 to 304
	value = ((uint32_t)(input[36] & 0x7f) << 25) |
			((uint32_t)input[37] << 17) |
			((uint32_t)(input[38] & 0x80) << 9);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 305 to 320
	value = ((uint32_t)(input[38] & 0x7f) << 25) |
			((uint32_t)input[39] << 17) |
			((uint32_t)(input[40] & 0x80) << 9);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 321 to 336
	value = ((uint32_t)(input[40] & 0x7f) << 25) |
			((uint32_t)input[41] << 17) |
			((uint32_t)(input[42] & 0x80) << 9);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 337 to 352
	value = ((uint32_t)(input[42] & 0x7f) << 25) |
			((uint32_t)input[43] << 17) |
			((uint32_t)(input[44] & 0x80) << 9);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 353 to 368
	value = ((uint32_t)(input[44] & 0x7f) << 25) |
			((uint32_t)input[45] << 17) |
			((uint32_t)(input[46] & 0x80) << 9);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 369 to 384
	value = ((uint32_t)(input[46] & 0x7f) << 25) |
			((uint32_t)input[47] << 17) |
			((uint32_t)(input[48] & 0x80) << 9);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 385 to 400
	value = ((uint32_t)(input[48] & 0x7f) << 25) |
			((uint32_t)input[49] << 17) |
			((uint32_t)(input[50] & 0x80) << 9);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 401 to 416
	value = ((uint32_t)(input[50] & 0x7f) << 25) |
			((uint32_t)input[51] << 17) |
			((uint32_t)(input[52] & 0x80) << 9);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 417 to 432
	value = ((uint32_t)(input[52] & 0x7f) << 25) |
			((uint32_t)input[53] << 17) |
			((uint32_t)(input[54] & 0x80) << 9);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 433 to 448
	value = ((uint32_t)(input[54] & 0x7f) << 25) |
			((uint32_t)input[55] << 17) |
			((uint32_t)(input[56] & 0x80) << 9);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 449 to 464
	value = ((uint32_t)(input[56] & 0x7f) << 25) |
			((uint32_t)input[57] << 17) |
			((uint32_t)(input[58] & 0x80) << 9);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 465 to 480
	value = ((uint32_t)(input[58] & 0x7f) << 25) |
			((uint32_t)input[59] << 17) |
			((uint32_t)(input[60] & 0x80) << 9);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 481 to 496
	value = ((uint32_t)(input[60] & 0x7f) << 25) |
			((uint32_t)input[61] << 17) |
			((uint32_t)(input[62] & 0x80) << 9);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 497 to 512
	value = ((uint32_t)(input[62] & 0x7f) << 25) |
			((uint32_t)input[63] << 17) |
			((uint32_t)(input[64] & 0x80) << 9);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 513 to 528
	value = ((uint32_t)(input[64] & 0x7f) << 25) |
			((uint32_t)input[65] << 17) |
			((uint32_t)(input[66] & 0x80) << 9);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 529 to 544
	value = ((uint32_t)(input[66] & 0x7f) << 25) |
			((uint32_t)input[67] << 17) |
			((uint32_t)(input[68] & 0x80) << 9);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 545 to 560
	value = ((uint32_t)(input[68] & 0x7f) << 25) |
			((uint32_t)input[69] << 17) |
			((uint32_t)(input[70] & 0x80) << 9);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 561 to 576
	value = ((uint32_t)(input[70] & 0x7f) << 25) |
			((uint32_t)input[71] << 17) |
			((uint32_t)(input[72] & 0x80) << 9);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 577 to 592
	value = ((uint32_t)(input[72] & 0x7f) << 25) |
			((uint32_t)input[73] << 17) |
			((uint32_t)(input[74] & 0x80) << 9);
	output[36] = (double)(value >> 16);
}

static void unpack_37_16bit_unsigned_1off(const uint8_t * input, double * output, void *closure) {
	// Unpack 37 values into output
	// Values are 16-bit unsigned
	// Skip 1 bits, read 592 bits of data.
	// Input must be at least 75 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 1 to 16
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)input[1] << 17) |
			((uint32_t)(input[2] & 0x80) << 9);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 17 to 32
	value = ((uint32_t)(input[2] & 0x7f) << 25) |
			((uint32_t)input[3] << 17) |
			((uint32_t)(input[4] & 0x80) << 9);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 33 to 48
	value = ((uint32_t)(input[4] & 0x7f) << 25) |
			((uint32_t)input[5] << 17) |
			((uint32_t)(input[6] & 0x80) << 9);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 49 to 64
	value = ((uint32_t)(input[6] & 0x7f) << 25) |
			((uint32_t)input[7] << 17) |
			((uint32_t)(input[8] & 0x80) << 9);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 65 to 80
	value = ((uint32_t)(input[8] & 0x7f) << 25) |
			((uint32_t)input[9] << 17) |
			((uint32_t)(input[10] & 0x80) << 9);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 81 to 96
	value = ((uint32_t)(input[10] & 0x7f) << 25) |
			((uint32_t)input[11] << 17) |
			((uint32_t)(input[12] & 0x80) << 9);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 97 to 112
	value = ((uint32_t)(input[12] & 0x7f) << 25) |
			((uint32_t)input[13] << 17) |
			((uint32_t)(input[14] & 0x80) << 9);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 113 to 128
	value = ((uint32_t)(input[14] & 0x7f) << 25) |
			((uint32_t)input[15] << 17) |
			((uint32_t)(input[16] & 0x80) << 9);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 129 to 144
	value = ((uint32_t)(input[16] & 0x7f) << 25) |
			((uint32_t)input[17] << 17) |
			((uint32_t)(input[18] & 0x80) << 9);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 145 to 160
	value = ((uint32_t)(input[18] & 0x7f) << 25) |
			((uint32_t)input[19] << 17) |
			((uint32_t)(input[20] & 0x80) << 9);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 161 to 176
	value = ((uint32_t)(input[20] & 0x7f) << 25) |
			((uint32_t)input[21] << 17) |
			((uint32_t)(input[22] & 0x80) << 9);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 177 to 192
	value = ((uint32_t)(input[22] & 0x7f) << 25) |
			((uint32_t)input[23] << 17) |
			((uint32_t)(input[24] & 0x80) << 9);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 193 to 208
	value = ((uint32_t)(input[24] & 0x7f) << 25) |
			((uint32_t)input[25] << 17) |
			((uint32_t)(input[26] & 0x80) << 9);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 209 to 224
	value = ((uint32_t)(input[26] & 0x7f) << 25) |
			((uint32_t)input[27] << 17) |
			((uint32_t)(input[28] & 0x80) << 9);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 225 to 240
	value = ((uint32_t)(input[28] & 0x7f) << 25) |
			((uint32_t)input[29] << 17) |
			((uint32_t)(input[30] & 0x80) << 9);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 241 to 256
	value = ((uint32_t)(input[30] & 0x7f) << 25) |
			((uint32_t)input[31] << 17) |
			((uint32_t)(input[32] & 0x80) << 9);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 257 to 272
	value = ((uint32_t)(input[32] & 0x7f) << 25) |
			((uint32_t)input[33] << 17) |
			((uint32_t)(input[34] & 0x80) << 9);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 273 to 288
	value = ((uint32_t)(input[34] & 0x7f) << 25) |
			((uint32_t)input[35] << 17) |
			((uint32_t)(input[36] & 0x80) << 9);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 289 to 304
	value = ((uint32_t)(input[36] & 0x7f) << 25) |
			((uint32_t)input[37] << 17) |
			((uint32_t)(input[38] & 0x80) << 9);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 305 to 320
	value = ((uint32_t)(input[38] & 0x7f) << 25) |
			((uint32_t)input[39] << 17) |
			((uint32_t)(input[40] & 0x80) << 9);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 321 to 336
	value = ((uint32_t)(input[40] & 0x7f) << 25) |
			((uint32_t)input[41] << 17) |
			((uint32_t)(input[42] & 0x80) << 9);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 337 to 352
	value = ((uint32_t)(input[42] & 0x7f) << 25) |
			((uint32_t)input[43] << 17) |
			((uint32_t)(input[44] & 0x80) << 9);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 353 to 368
	value = ((uint32_t)(input[44] & 0x7f) << 25) |
			((uint32_t)input[45] << 17) |
			((uint32_t)(input[46] & 0x80) << 9);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 369 to 384
	value = ((uint32_t)(input[46] & 0x7f) << 25) |
			((uint32_t)input[47] << 17) |
			((uint32_t)(input[48] & 0x80) << 9);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 385 to 400
	value = ((uint32_t)(input[48] & 0x7f) << 25) |
			((uint32_t)input[49] << 17) |
			((uint32_t)(input[50] & 0x80) << 9);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 401 to 416
	value = ((uint32_t)(input[50] & 0x7f) << 25) |
			((uint32_t)input[51] << 17) |
			((uint32_t)(input[52] & 0x80) << 9);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 417 to 432
	value = ((uint32_t)(input[52] & 0x7f) << 25) |
			((uint32_t)input[53] << 17) |
			((uint32_t)(input[54] & 0x80) << 9);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 433 to 448
	value = ((uint32_t)(input[54] & 0x7f) << 25) |
			((uint32_t)input[55] << 17) |
			((uint32_t)(input[56] & 0x80) << 9);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 449 to 464
	value = ((uint32_t)(input[56] & 0x7f) << 25) |
			((uint32_t)input[57] << 17) |
			((uint32_t)(input[58] & 0x80) << 9);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 465 to 480
	value = ((uint32_t)(input[58] & 0x7f) << 25) |
			((uint32_t)input[59] << 17) |
			((uint32_t)(input[60] & 0x80) << 9);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 481 to 496
	value = ((uint32_t)(input[60] & 0x7f) << 25) |
			((uint32_t)input[61] << 17) |
			((uint32_t)(input[62] & 0x80) << 9);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 497 to 512
	value = ((uint32_t)(input[62] & 0x7f) << 25) |
			((uint32_t)input[63] << 17) |
			((uint32_t)(input[64] & 0x80) << 9);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 513 to 528
	value = ((uint32_t)(input[64] & 0x7f) << 25) |
			((uint32_t)input[65] << 17) |
			((uint32_t)(input[66] & 0x80) << 9);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 529 to 544
	value = ((uint32_t)(input[66] & 0x7f) << 25) |
			((uint32_t)input[67] << 17) |
			((uint32_t)(input[68] & 0x80) << 9);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 545 to 560
	value = ((uint32_t)(input[68] & 0x7f) << 25) |
			((uint32_t)input[69] << 17) |
			((uint32_t)(input[70] & 0x80) << 9);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 561 to 576
	value = ((uint32_t)(input[70] & 0x7f) << 25) |
			((uint32_t)input[71] << 17) |
			((uint32_t)(input[72] & 0x80) << 9);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 577 to 592
	value = ((uint32_t)(input[72] & 0x7f) << 25) |
			((uint32_t)input[73] << 17) |
			((uint32_t)(input[74] & 0x80) << 9);
	output[36] = (double)(value >> 16);
}

static void unpack_37_16bit_signed_2off(const uint8_t * input, double * output, void *closure) {
	// Unpack 37 values into output
	// Values are 16-bit signed
	// Skip 2 bits, read 592 bits of data.
	// Input must be at least 75 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 2 to 17
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)input[1] << 18) |
			((uint32_t)(input[2] & 0xc0) << 10);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 18 to 33
	value = ((uint32_t)(input[2] & 0x3f) << 26) |
			((uint32_t)input[3] << 18) |
			((uint32_t)(input[4] & 0xc0) << 10);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 34 to 49
	value = ((uint32_t)(input[4] & 0x3f) << 26) |
			((uint32_t)input[5] << 18) |
			((uint32_t)(input[6] & 0xc0) << 10);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 50 to 65
	value = ((uint32_t)(input[6] & 0x3f) << 26) |
			((uint32_t)input[7] << 18) |
			((uint32_t)(input[8] & 0xc0) << 10);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 66 to 81
	value = ((uint32_t)(input[8] & 0x3f) << 26) |
			((uint32_t)input[9] << 18) |
			((uint32_t)(input[10] & 0xc0) << 10);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 82 to 97
	value = ((uint32_t)(input[10] & 0x3f) << 26) |
			((uint32_t)input[11] << 18) |
			((uint32_t)(input[12] & 0xc0) << 10);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 98 to 113
	value = ((uint32_t)(input[12] & 0x3f) << 26) |
			((uint32_t)input[13] << 18) |
			((uint32_t)(input[14] & 0xc0) << 10);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 114 to 129
	value = ((uint32_t)(input[14] & 0x3f) << 26) |
			((uint32_t)input[15] << 18) |
			((uint32_t)(input[16] & 0xc0) << 10);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 130 to 145
	value = ((uint32_t)(input[16] & 0x3f) << 26) |
			((uint32_t)input[17] << 18) |
			((uint32_t)(input[18] & 0xc0) << 10);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 146 to 161
	value = ((uint32_t)(input[18] & 0x3f) << 26) |
			((uint32_t)input[19] << 18) |
			((uint32_t)(input[20] & 0xc0) << 10);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 162 to 177
	value = ((uint32_t)(input[20] & 0x3f) << 26) |
			((uint32_t)input[21] << 18) |
			((uint32_t)(input[22] & 0xc0) << 10);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 178 to 193
	value = ((uint32_t)(input[22] & 0x3f) << 26) |
			((uint32_t)input[23] << 18) |
			((uint32_t)(input[24] & 0xc0) << 10);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 194 to 209
	value = ((uint32_t)(input[24] & 0x3f) << 26) |
			((uint32_t)input[25] << 18) |
			((uint32_t)(input[26] & 0xc0) << 10);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 210 to 225
	value = ((uint32_t)(input[26] & 0x3f) << 26) |
			((uint32_t)input[27] << 18) |
			((uint32_t)(input[28] & 0xc0) << 10);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 226 to 241
	value = ((uint32_t)(input[28] & 0x3f) << 26) |
			((uint32_t)input[29] << 18) |
			((uint32_t)(input[30] & 0xc0) << 10);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 242 to 257
	value = ((uint32_t)(input[30] & 0x3f) << 26) |
			((uint32_t)input[31] << 18) |
			((uint32_t)(input[32] & 0xc0) << 10);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 258 to 273
	value = ((uint32_t)(input[32] & 0x3f) << 26) |
			((uint32_t)input[33] << 18) |
			((uint32_t)(input[34] & 0xc0) << 10);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 274 to 289
	value = ((uint32_t)(input[34] & 0x3f) << 26) |
			((uint32_t)input[35] << 18) |
			((uint32_t)(input[36] & 0xc0) << 10);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 290 to 305
	value = ((uint32_t)(input[36] & 0x3f) << 26) |
			((uint32_t)input[37] << 18) |
			((uint32_t)(input[38] & 0xc0) << 10);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 306 to 321
	value = ((uint32_t)(input[38] & 0x3f) << 26) |
			((uint32_t)input[39] << 18) |
			((uint32_t)(input[40] & 0xc0) << 10);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 322 to 337
	value = ((uint32_t)(input[40] & 0x3f) << 26) |
			((uint32_t)input[41] << 18) |
			((uint32_t)(input[42] & 0xc0) << 10);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 338 to 353
	value = ((uint32_t)(input[42] & 0x3f) << 26) |
			((uint32_t)input[43] << 18) |
			((uint32_t)(input[44] & 0xc0) << 10);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 354 to 369
	value = ((uint32_t)(input[44] & 0x3f) << 26) |
			((uint32_t)input[45] << 18) |
			((uint32_t)(input[46] & 0xc0) << 10);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 370 to 385
	value = ((uint32_t)(input[46] & 0x3f) << 26) |
			((uint32_t)input[47] << 18) |
			((uint32_t)(input[48] & 0xc0) << 10);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 386 to 401
	value = ((uint32_t)(input[48] & 0x3f) << 26) |
			((uint32_t)input[49] << 18) |
			((uint32_t)(input[50] & 0xc0) << 10);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 402 to 417
	value = ((uint32_t)(input[50] & 0x3f) << 26) |
			((uint32_t)input[51] << 18) |
			((uint32_t)(input[52] & 0xc0) << 10);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 418 to 433
	value = ((uint32_t)(input[52] & 0x3f) << 26) |
			((uint32_t)input[53] << 18) |
			((uint32_t)(input[54] & 0xc0) << 10);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 434 to 449
	value = ((uint32_t)(input[54] & 0x3f) << 26) |
			((uint32_t)input[55] << 18) |
			((uint32_t)(input[56] & 0xc0) << 10);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 450 to 465
	value = ((uint32_t)(input[56] & 0x3f) << 26) |
			((uint32_t)input[57] << 18) |
			((uint32_t)(input[58] & 0xc0) << 10);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 466 to 481
	value = ((uint32_t)(input[58] & 0x3f) << 26) |
			((uint32_t)input[59] << 18) |
			((uint32_t)(input[60] & 0xc0) << 10);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 482 to 497
	value = ((uint32_t)(input[60] & 0x3f) << 26) |
			((uint32_t)input[61] << 18) |
			((uint32_t)(input[62] & 0xc0) << 10);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 498 to 513
	value = ((uint32_t)(input[62] & 0x3f) << 26) |
			((uint32_t)input[63] << 18) |
			((uint32_t)(input[64] & 0xc0) << 10);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 514 to 529
	value = ((uint32_t)(input[64] & 0x3f) << 26) |
			((uint32_t)input[65] << 18) |
			((uint32_t)(input[66] & 0xc0) << 10);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 530 to 545
	value = ((uint32_t)(input[66] & 0x3f) << 26) |
			((uint32_t)input[67] << 18) |
			((uint32_t)(input[68] & 0xc0) << 10);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 546 to 561
	value = ((uint32_t)(input[68] & 0x3f) << 26) |
			((uint32_t)input[69] << 18) |
			((uint32_t)(input[70] & 0xc0) << 10);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 562 to 577
	value = ((uint32_t)(input[70] & 0x3f) << 26) |
			((uint32_t)input[71] << 18) |
			((uint32_t)(input[72] & 0xc0) << 10);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 578 to 593
	value = ((uint32_t)(input[72] & 0x3f) << 26) |
			((uint32_t)input[73] << 18) |
			((uint32_t)(input[74] & 0xc0) << 10);
	output[36] = (double)(value >> 16);
}

static void unpack_37_16bit_unsigned_2off(const uint8_t * input, double * output, void *closure) {
	// Unpack 37 values into output
	// Values are 16-bit unsigned
	// Skip 2 bits, read 592 bits of data.
	// Input must be at least 75 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 2 to 17
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)input[1] << 18) |
			((uint32_t)(input[2] & 0xc0) << 10);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 18 to 33
	value = ((uint32_t)(input[2] & 0x3f) << 26) |
			((uint32_t)input[3] << 18) |
			((uint32_t)(input[4] & 0xc0) << 10);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 34 to 49
	value = ((uint32_t)(input[4] & 0x3f) << 26) |
			((uint32_t)input[5] << 18) |
			((uint32_t)(input[6] & 0xc0) << 10);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 50 to 65
	value = ((uint32_t)(input[6] & 0x3f) << 26) |
			((uint32_t)input[7] << 18) |
			((uint32_t)(input[8] & 0xc0) << 10);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 66 to 81
	value = ((uint32_t)(input[8] & 0x3f) << 26) |
			((uint32_t)input[9] << 18) |
			((uint32_t)(input[10] & 0xc0) << 10);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 82 to 97
	value = ((uint32_t)(input[10] & 0x3f) << 26) |
			((uint32_t)input[11] << 18) |
			((uint32_t)(input[12] & 0xc0) << 10);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 98 to 113
	value = ((uint32_t)(input[12] & 0x3f) << 26) |
			((uint32_t)input[13] << 18) |
			((uint32_t)(input[14] & 0xc0) << 10);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 114 to 129
	value = ((uint32_t)(input[14] & 0x3f) << 26) |
			((uint32_t)input[15] << 18) |
			((uint32_t)(input[16] & 0xc0) << 10);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 130 to 145
	value = ((uint32_t)(input[16] & 0x3f) << 26) |
			((uint32_t)input[17] << 18) |
			((uint32_t)(input[18] & 0xc0) << 10);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 146 to 161
	value = ((uint32_t)(input[18] & 0x3f) << 26) |
			((uint32_t)input[19] << 18) |
			((uint32_t)(input[20] & 0xc0) << 10);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 162 to 177
	value = ((uint32_t)(input[20] & 0x3f) << 26) |
			((uint32_t)input[21] << 18) |
			((uint32_t)(input[22] & 0xc0) << 10);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 178 to 193
	value = ((uint32_t)(input[22] & 0x3f) << 26) |
			((uint32_t)input[23] << 18) |
			((uint32_t)(input[24] & 0xc0) << 10);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 194 to 209
	value = ((uint32_t)(input[24] & 0x3f) << 26) |
			((uint32_t)input[25] << 18) |
			((uint32_t)(input[26] & 0xc0) << 10);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 210 to 225
	value = ((uint32_t)(input[26] & 0x3f) << 26) |
			((uint32_t)input[27] << 18) |
			((uint32_t)(input[28] & 0xc0) << 10);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 226 to 241
	value = ((uint32_t)(input[28] & 0x3f) << 26) |
			((uint32_t)input[29] << 18) |
			((uint32_t)(input[30] & 0xc0) << 10);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 242 to 257
	value = ((uint32_t)(input[30] & 0x3f) << 26) |
			((uint32_t)input[31] << 18) |
			((uint32_t)(input[32] & 0xc0) << 10);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 258 to 273
	value = ((uint32_t)(input[32] & 0x3f) << 26) |
			((uint32_t)input[33] << 18) |
			((uint32_t)(input[34] & 0xc0) << 10);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 274 to 289
	value = ((uint32_t)(input[34] & 0x3f) << 26) |
			((uint32_t)input[35] << 18) |
			((uint32_t)(input[36] & 0xc0) << 10);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 290 to 305
	value = ((uint32_t)(input[36] & 0x3f) << 26) |
			((uint32_t)input[37] << 18) |
			((uint32_t)(input[38] & 0xc0) << 10);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 306 to 321
	value = ((uint32_t)(input[38] & 0x3f) << 26) |
			((uint32_t)input[39] << 18) |
			((uint32_t)(input[40] & 0xc0) << 10);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 322 to 337
	value = ((uint32_t)(input[40] & 0x3f) << 26) |
			((uint32_t)input[41] << 18) |
			((uint32_t)(input[42] & 0xc0) << 10);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 338 to 353
	value = ((uint32_t)(input[42] & 0x3f) << 26) |
			((uint32_t)input[43] << 18) |
			((uint32_t)(input[44] & 0xc0) << 10);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 354 to 369
	value = ((uint32_t)(input[44] & 0x3f) << 26) |
			((uint32_t)input[45] << 18) |
			((uint32_t)(input[46] & 0xc0) << 10);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 370 to 385
	value = ((uint32_t)(input[46] & 0x3f) << 26) |
			((uint32_t)input[47] << 18) |
			((uint32_t)(input[48] & 0xc0) << 10);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 386 to 401
	value = ((uint32_t)(input[48] & 0x3f) << 26) |
			((uint32_t)input[49] << 18) |
			((uint32_t)(input[50] & 0xc0) << 10);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 402 to 417
	value = ((uint32_t)(input[50] & 0x3f) << 26) |
			((uint32_t)input[51] << 18) |
			((uint32_t)(input[52] & 0xc0) << 10);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 418 to 433
	value = ((uint32_t)(input[52] & 0x3f) << 26) |
			((uint32_t)input[53] << 18) |
			((uint32_t)(input[54] & 0xc0) << 10);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 434 to 449
	value = ((uint32_t)(input[54] & 0x3f) << 26) |
			((uint32_t)input[55] << 18) |
			((uint32_t)(input[56] & 0xc0) << 10);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 450 to 465
	value = ((uint32_t)(input[56] & 0x3f) << 26) |
			((uint32_t)input[57] << 18) |
			((uint32_t)(input[58] & 0xc0) << 10);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 466 to 481
	value = ((uint32_t)(input[58] & 0x3f) << 26) |
			((uint32_t)input[59] << 18) |
			((uint32_t)(input[60] & 0xc0) << 10);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 482 to 497
	value = ((uint32_t)(input[60] & 0x3f) << 26) |
			((uint32_t)input[61] << 18) |
			((uint32_t)(input[62] & 0xc0) << 10);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 498 to 513
	value = ((uint32_t)(input[62] & 0x3f) << 26) |
			((uint32_t)input[63] << 18) |
			((uint32_t)(input[64] & 0xc0) << 10);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 514 to 529
	value = ((uint32_t)(input[64] & 0x3f) << 26) |
			((uint32_t)input[65] << 18) |
			((uint32_t)(input[66] & 0xc0) << 10);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 530 to 545
	value = ((uint32_t)(input[66] & 0x3f) << 26) |
			((uint32_t)input[67] << 18) |
			((uint32_t)(input[68] & 0xc0) << 10);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 546 to 561
	value = ((uint32_t)(input[68] & 0x3f) << 26) |
			((uint32_t)input[69] << 18) |
			((uint32_t)(input[70] & 0xc0) << 10);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 562 to 577
	value = ((uint32_t)(input[70] & 0x3f) << 26) |
			((uint32_t)input[71] << 18) |
			((uint32_t)(input[72] & 0xc0) << 10);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 578 to 593
	value = ((uint32_t)(input[72] & 0x3f) << 26) |
			((uint32_t)input[73] << 18) |
			((uint32_t)(input[74] & 0xc0) << 10);
	output[36] = (double)(value >> 16);
}

static void unpack_37_16bit_signed_3off(const uint8_t * input, double * output, void *closure) {
	// Unpack 37 values into output
	// Values are 16-bit signed
	// Skip 3 bits, read 592 bits of data.
	// Input must be at least 75 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 3 to 18
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)input[1] << 19) |
			((uint32_t)(input[2] & 0xe0) << 11);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 19 to 34
	value = ((uint32_t)(input[2] & 0x1f) << 27) |
			((uint32_t)input[3] << 19) |
			((uint32_t)(input[4] & 0xe0) << 11);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 35 to 50
	value = ((uint32_t)(input[4] & 0x1f) << 27) |
			((uint32_t)input[5] << 19) |
			((uint32_t)(input[6] & 0xe0) << 11);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 51 to 66
	value = ((uint32_t)(input[6] & 0x1f) << 27) |
			((uint32_t)input[7] << 19) |
			((uint32_t)(input[8] & 0xe0) << 11);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 67 to 82
	value = ((uint32_t)(input[8] & 0x1f) << 27) |
			((uint32_t)input[9] << 19) |
			((uint32_t)(input[10] & 0xe0) << 11);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 83 to 98
	value = ((uint32_t)(input[10] & 0x1f) << 27) |
			((uint32_t)input[11] << 19) |
			((uint32_t)(input[12] & 0xe0) << 11);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 99 to 114
	value = ((uint32_t)(input[12] & 0x1f) << 27) |
			((uint32_t)input[13] << 19) |
			((uint32_t)(input[14] & 0xe0) << 11);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 115 to 130
	value = ((uint32_t)(input[14] & 0x1f) << 27) |
			((uint32_t)input[15] << 19) |
			((uint32_t)(input[16] & 0xe0) << 11);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 131 to 146
	value = ((uint32_t)(input[16] & 0x1f) << 27) |
			((uint32_t)input[17] << 19) |
			((uint32_t)(input[18] & 0xe0) << 11);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 147 to 162
	value = ((uint32_t)(input[18] & 0x1f) << 27) |
			((uint32_t)input[19] << 19) |
			((uint32_t)(input[20] & 0xe0) << 11);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 163 to 178
	value = ((uint32_t)(input[20] & 0x1f) << 27) |
			((uint32_t)input[21] << 19) |
			((uint32_t)(input[22] & 0xe0) << 11);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 179 to 194
	value = ((uint32_t)(input[22] & 0x1f) << 27) |
			((uint32_t)input[23] << 19) |
			((uint32_t)(input[24] & 0xe0) << 11);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 195 to 210
	value = ((uint32_t)(input[24] & 0x1f) << 27) |
			((uint32_t)input[25] << 19) |
			((uint32_t)(input[26] & 0xe0) << 11);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 211 to 226
	value = ((uint32_t)(input[26] & 0x1f) << 27) |
			((uint32_t)input[27] << 19) |
			((uint32_t)(input[28] & 0xe0) << 11);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 227 to 242
	value = ((uint32_t)(input[28] & 0x1f) << 27) |
			((uint32_t)input[29] << 19) |
			((uint32_t)(input[30] & 0xe0) << 11);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 243 to 258
	value = ((uint32_t)(input[30] & 0x1f) << 27) |
			((uint32_t)input[31] << 19) |
			((uint32_t)(input[32] & 0xe0) << 11);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 259 to 274
	value = ((uint32_t)(input[32] & 0x1f) << 27) |
			((uint32_t)input[33] << 19) |
			((uint32_t)(input[34] & 0xe0) << 11);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 275 to 290
	value = ((uint32_t)(input[34] & 0x1f) << 27) |
			((uint32_t)input[35] << 19) |
			((uint32_t)(input[36] & 0xe0) << 11);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 291 to 306
	value = ((uint32_t)(input[36] & 0x1f) << 27) |
			((uint32_t)input[37] << 19) |
			((uint32_t)(input[38] & 0xe0) << 11);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 307 to 322
	value = ((uint32_t)(input[38] & 0x1f) << 27) |
			((uint32_t)input[39] << 19) |
			((uint32_t)(input[40] & 0xe0) << 11);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 323 to 338
	value = ((uint32_t)(input[40] & 0x1f) << 27) |
			((uint32_t)input[41] << 19) |
			((uint32_t)(input[42] & 0xe0) << 11);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 339 to 354
	value = ((uint32_t)(input[42] & 0x1f) << 27) |
			((uint32_t)input[43] << 19) |
			((uint32_t)(input[44] & 0xe0) << 11);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 355 to 370
	value = ((uint32_t)(input[44] & 0x1f) << 27) |
			((uint32_t)input[45] << 19) |
			((uint32_t)(input[46] & 0xe0) << 11);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 371 to 386
	value = ((uint32_t)(input[46] & 0x1f) << 27) |
			((uint32_t)input[47] << 19) |
			((uint32_t)(input[48] & 0xe0) << 11);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 387 to 402
	value = ((uint32_t)(input[48] & 0x1f) << 27) |
			((uint32_t)input[49] << 19) |
			((uint32_t)(input[50] & 0xe0) << 11);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 403 to 418
	value = ((uint32_t)(input[50] & 0x1f) << 27) |
			((uint32_t)input[51] << 19) |
			((uint32_t)(input[52] & 0xe0) << 11);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 419 to 434
	value = ((uint32_t)(input[52] & 0x1f) << 27) |
			((uint32_t)input[53] << 19) |
			((uint32_t)(input[54] & 0xe0) << 11);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 435 to 450
	value = ((uint32_t)(input[54] & 0x1f) << 27) |
			((uint32_t)input[55] << 19) |
			((uint32_t)(input[56] & 0xe0) << 11);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 451 to 466
	value = ((uint32_t)(input[56] & 0x1f) << 27) |
			((uint32_t)input[57] << 19) |
			((uint32_t)(input[58] & 0xe0) << 11);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 467 to 482
	value = ((uint32_t)(input[58] & 0x1f) << 27) |
			((uint32_t)input[59] << 19) |
			((uint32_t)(input[60] & 0xe0) << 11);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 483 to 498
	value = ((uint32_t)(input[60] & 0x1f) << 27) |
			((uint32_t)input[61] << 19) |
			((uint32_t)(input[62] & 0xe0) << 11);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 499 to 514
	value = ((uint32_t)(input[62] & 0x1f) << 27) |
			((uint32_t)input[63] << 19) |
			((uint32_t)(input[64] & 0xe0) << 11);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 515 to 530
	value = ((uint32_t)(input[64] & 0x1f) << 27) |
			((uint32_t)input[65] << 19) |
			((uint32_t)(input[66] & 0xe0) << 11);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 531 to 546
	value = ((uint32_t)(input[66] & 0x1f) << 27) |
			((uint32_t)input[67] << 19) |
			((uint32_t)(input[68] & 0xe0) << 11);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 547 to 562
	value = ((uint32_t)(input[68] & 0x1f) << 27) |
			((uint32_t)input[69] << 19) |
			((uint32_t)(input[70] & 0xe0) << 11);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 563 to 578
	value = ((uint32_t)(input[70] & 0x1f) << 27) |
			((uint32_t)input[71] << 19) |
			((uint32_t)(input[72] & 0xe0) << 11);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 579 to 594
	value = ((uint32_t)(input[72] & 0x1f) << 27) |
			((uint32_t)input[73] << 19) |
			((uint32_t)(input[74] & 0xe0) << 11);
	output[36] = (double)(value >> 16);
}

static void unpack_37_16bit_unsigned_3off(const uint8_t * input, double * output, void *closure) {
	// Unpack 37 values into output
	// Values are 16-bit unsigned
	// Skip 3 bits, read 592 bits of data.
	// Input must be at least 75 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 3 to 18
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)input[1] << 19) |
			((uint32_t)(input[2] & 0xe0) << 11);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 19 to 34
	value = ((uint32_t)(input[2] & 0x1f) << 27) |
			((uint32_t)input[3] << 19) |
			((uint32_t)(input[4] & 0xe0) << 11);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 35 to 50
	value = ((uint32_t)(input[4] & 0x1f) << 27) |
			((uint32_t)input[5] << 19) |
			((uint32_t)(input[6] & 0xe0) << 11);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 51 to 66
	value = ((uint32_t)(input[6] & 0x1f) << 27) |
			((uint32_t)input[7] << 19) |
			((uint32_t)(input[8] & 0xe0) << 11);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 67 to 82
	value = ((uint32_t)(input[8] & 0x1f) << 27) |
			((uint32_t)input[9] << 19) |
			((uint32_t)(input[10] & 0xe0) << 11);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 83 to 98
	value = ((uint32_t)(input[10] & 0x1f) << 27) |
			((uint32_t)input[11] << 19) |
			((uint32_t)(input[12] & 0xe0) << 11);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 99 to 114
	value = ((uint32_t)(input[12] & 0x1f) << 27) |
			((uint32_t)input[13] << 19) |
			((uint32_t)(input[14] & 0xe0) << 11);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 115 to 130
	value = ((uint32_t)(input[14] & 0x1f) << 27) |
			((uint32_t)input[15] << 19) |
			((uint32_t)(input[16] & 0xe0) << 11);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 131 to 146
	value = ((uint32_t)(input[16] & 0x1f) << 27) |
			((uint32_t)input[17] << 19) |
			((uint32_t)(input[18] & 0xe0) << 11);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 147 to 162
	value = ((uint32_t)(input[18] & 0x1f) << 27) |
			((uint32_t)input[19] << 19) |
			((uint32_t)(input[20] & 0xe0) << 11);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 163 to 178
	value = ((uint32_t)(input[20] & 0x1f) << 27) |
			((uint32_t)input[21] << 19) |
			((uint32_t)(input[22] & 0xe0) << 11);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 179 to 194
	value = ((uint32_t)(input[22] & 0x1f) << 27) |
			((uint32_t)input[23] << 19) |
			((uint32_t)(input[24] & 0xe0) << 11);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 195 to 210
	value = ((uint32_t)(input[24] & 0x1f) << 27) |
			((uint32_t)input[25] << 19) |
			((uint32_t)(input[26] & 0xe0) << 11);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 211 to 226
	value = ((uint32_t)(input[26] & 0x1f) << 27) |
			((uint32_t)input[27] << 19) |
			((uint32_t)(input[28] & 0xe0) << 11);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 227 to 242
	value = ((uint32_t)(input[28] & 0x1f) << 27) |
			((uint32_t)input[29] << 19) |
			((uint32_t)(input[30] & 0xe0) << 11);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 243 to 258
	value = ((uint32_t)(input[30] & 0x1f) << 27) |
			((uint32_t)input[31] << 19) |
			((uint32_t)(input[32] & 0xe0) << 11);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 259 to 274
	value = ((uint32_t)(input[32] & 0x1f) << 27) |
			((uint32_t)input[33] << 19) |
			((uint32_t)(input[34] & 0xe0) << 11);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 275 to 290
	value = ((uint32_t)(input[34] & 0x1f) << 27) |
			((uint32_t)input[35] << 19) |
			((uint32_t)(input[36] & 0xe0) << 11);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 291 to 306
	value = ((uint32_t)(input[36] & 0x1f) << 27) |
			((uint32_t)input[37] << 19) |
			((uint32_t)(input[38] & 0xe0) << 11);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 307 to 322
	value = ((uint32_t)(input[38] & 0x1f) << 27) |
			((uint32_t)input[39] << 19) |
			((uint32_t)(input[40] & 0xe0) << 11);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 323 to 338
	value = ((uint32_t)(input[40] & 0x1f) << 27) |
			((uint32_t)input[41] << 19) |
			((uint32_t)(input[42] & 0xe0) << 11);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 339 to 354
	value = ((uint32_t)(input[42] & 0x1f) << 27) |
			((uint32_t)input[43] << 19) |
			((uint32_t)(input[44] & 0xe0) << 11);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 355 to 370
	value = ((uint32_t)(input[44] & 0x1f) << 27) |
			((uint32_t)input[45] << 19) |
			((uint32_t)(input[46] & 0xe0) << 11);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 371 to 386
	value = ((uint32_t)(input[46] & 0x1f) << 27) |
			((uint32_t)input[47] << 19) |
			((uint32_t)(input[48] & 0xe0) << 11);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 387 to 402
	value = ((uint32_t)(input[48] & 0x1f) << 27) |
			((uint32_t)input[49] << 19) |
			((uint32_t)(input[50] & 0xe0) << 11);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 403 to 418
	value = ((uint32_t)(input[50] & 0x1f) << 27) |
			((uint32_t)input[51] << 19) |
			((uint32_t)(input[52] & 0xe0) << 11);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 419 to 434
	value = ((uint32_t)(input[52] & 0x1f) << 27) |
			((uint32_t)input[53] << 19) |
			((uint32_t)(input[54] & 0xe0) << 11);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 435 to 450
	value = ((uint32_t)(input[54] & 0x1f) << 27) |
			((uint32_t)input[55] << 19) |
			((uint32_t)(input[56] & 0xe0) << 11);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 451 to 466
	value = ((uint32_t)(input[56] & 0x1f) << 27) |
			((uint32_t)input[57] << 19) |
			((uint32_t)(input[58] & 0xe0) << 11);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 467 to 482
	value = ((uint32_t)(input[58] & 0x1f) << 27) |
			((uint32_t)input[59] << 19) |
			((uint32_t)(input[60] & 0xe0) << 11);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 483 to 498
	value = ((uint32_t)(input[60] & 0x1f) << 27) |
			((uint32_t)input[61] << 19) |
			((uint32_t)(input[62] & 0xe0) << 11);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 499 to 514
	value = ((uint32_t)(input[62] & 0x1f) << 27) |
			((uint32_t)input[63] << 19) |
			((uint32_t)(input[64] & 0xe0) << 11);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 515 to 530
	value = ((uint32_t)(input[64] & 0x1f) << 27) |
			((uint32_t)input[65] << 19) |
			((uint32_t)(input[66] & 0xe0) << 11);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 531 to 546
	value = ((uint32_t)(input[66] & 0x1f) << 27) |
			((uint32_t)input[67] << 19) |
			((uint32_t)(input[68] & 0xe0) << 11);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 547 to 562
	value = ((uint32_t)(input[68] & 0x1f) << 27) |
			((uint32_t)input[69] << 19) |
			((uint32_t)(input[70] & 0xe0) << 11);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 563 to 578
	value = ((uint32_t)(input[70] & 0x1f) << 27) |
			((uint32_t)input[71] << 19) |
			((uint32_t)(input[72] & 0xe0) << 11);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 579 to 594
	value = ((uint32_t)(input[72] & 0x1f) << 27) |
			((uint32_t)input[73] << 19) |
			((uint32_t)(input[74] & 0xe0) << 11);
	output[36] = (double)(value >> 16);
}

static void unpack_37_16bit_signed_4off(const uint8_t * input, double * output, void *closure) {
	// Unpack 37 values into output
	// Values are 16-bit signed
	// Skip 4 bits, read 592 bits of data.
	// Input must be at least 75 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 4 to 19
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20) |
			((uint32_t)(input[2] & 0xf0) << 12);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 20 to 35
	value = ((uint32_t)(input[2] & 0x0f) << 28) |
			((uint32_t)input[3] << 20) |
			((uint32_t)(input[4] & 0xf0) << 12);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 36 to 51
	value = ((uint32_t)(input[4] & 0x0f) << 28) |
			((uint32_t)input[5] << 20) |
			((uint32_t)(input[6] & 0xf0) << 12);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 52 to 67
	value = ((uint32_t)(input[6] & 0x0f) << 28) |
			((uint32_t)input[7] << 20) |
			((uint32_t)(input[8] & 0xf0) << 12);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 68 to 83
	value = ((uint32_t)(input[8] & 0x0f) << 28) |
			((uint32_t)input[9] << 20) |
			((uint32_t)(input[10] & 0xf0) << 12);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 84 to 99
	value = ((uint32_t)(input[10] & 0x0f) << 28) |
			((uint32_t)input[11] << 20) |
			((uint32_t)(input[12] & 0xf0) << 12);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 100 to 115
	value = ((uint32_t)(input[12] & 0x0f) << 28) |
			((uint32_t)input[13] << 20) |
			((uint32_t)(input[14] & 0xf0) << 12);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 116 to 131
	value = ((uint32_t)(input[14] & 0x0f) << 28) |
			((uint32_t)input[15] << 20) |
			((uint32_t)(input[16] & 0xf0) << 12);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 132 to 147
	value = ((uint32_t)(input[16] & 0x0f) << 28) |
			((uint32_t)input[17] << 20) |
			((uint32_t)(input[18] & 0xf0) << 12);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 148 to 163
	value = ((uint32_t)(input[18] & 0x0f) << 28) |
			((uint32_t)input[19] << 20) |
			((uint32_t)(input[20] & 0xf0) << 12);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 164 to 179
	value = ((uint32_t)(input[20] & 0x0f) << 28) |
			((uint32_t)input[21] << 20) |
			((uint32_t)(input[22] & 0xf0) << 12);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 180 to 195
	value = ((uint32_t)(input[22] & 0x0f) << 28) |
			((uint32_t)input[23] << 20) |
			((uint32_t)(input[24] & 0xf0) << 12);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 196 to 211
	value = ((uint32_t)(input[24] & 0x0f) << 28) |
			((uint32_t)input[25] << 20) |
			((uint32_t)(input[26] & 0xf0) << 12);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 212 to 227
	value = ((uint32_t)(input[26] & 0x0f) << 28) |
			((uint32_t)input[27] << 20) |
			((uint32_t)(input[28] & 0xf0) << 12);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 228 to 243
	value = ((uint32_t)(input[28] & 0x0f) << 28) |
			((uint32_t)input[29] << 20) |
			((uint32_t)(input[30] & 0xf0) << 12);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 244 to 259
	value = ((uint32_t)(input[30] & 0x0f) << 28) |
			((uint32_t)input[31] << 20) |
			((uint32_t)(input[32] & 0xf0) << 12);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 260 to 275
	value = ((uint32_t)(input[32] & 0x0f) << 28) |
			((uint32_t)input[33] << 20) |
			((uint32_t)(input[34] & 0xf0) << 12);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 276 to 291
	value = ((uint32_t)(input[34] & 0x0f) << 28) |
			((uint32_t)input[35] << 20) |
			((uint32_t)(input[36] & 0xf0) << 12);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 292 to 307
	value = ((uint32_t)(input[36] & 0x0f) << 28) |
			((uint32_t)input[37] << 20) |
			((uint32_t)(input[38] & 0xf0) << 12);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 308 to 323
	value = ((uint32_t)(input[38] & 0x0f) << 28) |
			((uint32_t)input[39] << 20) |
			((uint32_t)(input[40] & 0xf0) << 12);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 324 to 339
	value = ((uint32_t)(input[40] & 0x0f) << 28) |
			((uint32_t)input[41] << 20) |
			((uint32_t)(input[42] & 0xf0) << 12);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 340 to 355
	value = ((uint32_t)(input[42] & 0x0f) << 28) |
			((uint32_t)input[43] << 20) |
			((uint32_t)(input[44] & 0xf0) << 12);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 356 to 371
	value = ((uint32_t)(input[44] & 0x0f) << 28) |
			((uint32_t)input[45] << 20) |
			((uint32_t)(input[46] & 0xf0) << 12);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 372 to 387
	value = ((uint32_t)(input[46] & 0x0f) << 28) |
			((uint32_t)input[47] << 20) |
			((uint32_t)(input[48] & 0xf0) << 12);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 388 to 403
	value = ((uint32_t)(input[48] & 0x0f) << 28) |
			((uint32_t)input[49] << 20) |
			((uint32_t)(input[50] & 0xf0) << 12);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 404 to 419
	value = ((uint32_t)(input[50] & 0x0f) << 28) |
			((uint32_t)input[51] << 20) |
			((uint32_t)(input[52] & 0xf0) << 12);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 420 to 435
	value = ((uint32_t)(input[52] & 0x0f) << 28) |
			((uint32_t)input[53] << 20) |
			((uint32_t)(input[54] & 0xf0) << 12);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 436 to 451
	value = ((uint32_t)(input[54] & 0x0f) << 28) |
			((uint32_t)input[55] << 20) |
			((uint32_t)(input[56] & 0xf0) << 12);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 452 to 467
	value = ((uint32_t)(input[56] & 0x0f) << 28) |
			((uint32_t)input[57] << 20) |
			((uint32_t)(input[58] & 0xf0) << 12);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 468 to 483
	value = ((uint32_t)(input[58] & 0x0f) << 28) |
			((uint32_t)input[59] << 20) |
			((uint32_t)(input[60] & 0xf0) << 12);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 484 to 499
	value = ((uint32_t)(input[60] & 0x0f) << 28) |
			((uint32_t)input[61] << 20) |
			((uint32_t)(input[62] & 0xf0) << 12);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 500 to 515
	value = ((uint32_t)(input[62] & 0x0f) << 28) |
			((uint32_t)input[63] << 20) |
			((uint32_t)(input[64] & 0xf0) << 12);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 516 to 531
	value = ((uint32_t)(input[64] & 0x0f) << 28) |
			((uint32_t)input[65] << 20) |
			((uint32_t)(input[66] & 0xf0) << 12);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 532 to 547
	value = ((uint32_t)(input[66] & 0x0f) << 28) |
			((uint32_t)input[67] << 20) |
			((uint32_t)(input[68] & 0xf0) << 12);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 548 to 563
	value = ((uint32_t)(input[68] & 0x0f) << 28) |
			((uint32_t)input[69] << 20) |
			((uint32_t)(input[70] & 0xf0) << 12);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 564 to 579
	value = ((uint32_t)(input[70] & 0x0f) << 28) |
			((uint32_t)input[71] << 20) |
			((uint32_t)(input[72] & 0xf0) << 12);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 580 to 595
	value = ((uint32_t)(input[72] & 0x0f) << 28) |
			((uint32_t)input[73] << 20) |
			((uint32_t)(input[74] & 0xf0) << 12);
	output[36] = (double)(value >> 16);
}

static void unpack_37_16bit_unsigned_4off(const uint8_t * input, double * output, void *closure) {
	// Unpack 37 values into output
	// Values are 16-bit unsigned
	// Skip 4 bits, read 592 bits of data.
	// Input must be at least 75 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 4 to 19
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20) |
			((uint32_t)(input[2] & 0xf0) << 12);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 20 to 35
	value = ((uint32_t)(input[2] & 0x0f) << 28) |
			((uint32_t)input[3] << 20) |
			((uint32_t)(input[4] & 0xf0) << 12);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 36 to 51
	value = ((uint32_t)(input[4] & 0x0f) << 28) |
			((uint32_t)input[5] << 20) |
			((uint32_t)(input[6] & 0xf0) << 12);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 52 to 67
	value = ((uint32_t)(input[6] & 0x0f) << 28) |
			((uint32_t)input[7] << 20) |
			((uint32_t)(input[8] & 0xf0) << 12);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 68 to 83
	value = ((uint32_t)(input[8] & 0x0f) << 28) |
			((uint32_t)input[9] << 20) |
			((uint32_t)(input[10] & 0xf0) << 12);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 84 to 99
	value = ((uint32_t)(input[10] & 0x0f) << 28) |
			((uint32_t)input[11] << 20) |
			((uint32_t)(input[12] & 0xf0) << 12);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 100 to 115
	value = ((uint32_t)(input[12] & 0x0f) << 28) |
			((uint32_t)input[13] << 20) |
			((uint32_t)(input[14] & 0xf0) << 12);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 116 to 131
	value = ((uint32_t)(input[14] & 0x0f) << 28) |
			((uint32_t)input[15] << 20) |
			((uint32_t)(input[16] & 0xf0) << 12);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 132 to 147
	value = ((uint32_t)(input[16] & 0x0f) << 28) |
			((uint32_t)input[17] << 20) |
			((uint32_t)(input[18] & 0xf0) << 12);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 148 to 163
	value = ((uint32_t)(input[18] & 0x0f) << 28) |
			((uint32_t)input[19] << 20) |
			((uint32_t)(input[20] & 0xf0) << 12);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 164 to 179
	value = ((uint32_t)(input[20] & 0x0f) << 28) |
			((uint32_t)input[21] << 20) |
			((uint32_t)(input[22] & 0xf0) << 12);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 180 to 195
	value = ((uint32_t)(input[22] & 0x0f) << 28) |
			((uint32_t)input[23] << 20) |
			((uint32_t)(input[24] & 0xf0) << 12);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 196 to 211
	value = ((uint32_t)(input[24] & 0x0f) << 28) |
			((uint32_t)input[25] << 20) |
			((uint32_t)(input[26] & 0xf0) << 12);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 212 to 227
	value = ((uint32_t)(input[26] & 0x0f) << 28) |
			((uint32_t)input[27] << 20) |
			((uint32_t)(input[28] & 0xf0) << 12);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 228 to 243
	value = ((uint32_t)(input[28] & 0x0f) << 28) |
			((uint32_t)input[29] << 20) |
			((uint32_t)(input[30] & 0xf0) << 12);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 244 to 259
	value = ((uint32_t)(input[30] & 0x0f) << 28) |
			((uint32_t)input[31] << 20) |
			((uint32_t)(input[32] & 0xf0) << 12);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 260 to 275
	value = ((uint32_t)(input[32] & 0x0f) << 28) |
			((uint32_t)input[33] << 20) |
			((uint32_t)(input[34] & 0xf0) << 12);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 276 to 291
	value = ((uint32_t)(input[34] & 0x0f) << 28) |
			((uint32_t)input[35] << 20) |
			((uint32_t)(input[36] & 0xf0) << 12);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 292 to 307
	value = ((uint32_t)(input[36] & 0x0f) << 28) |
			((uint32_t)input[37] << 20) |
			((uint32_t)(input[38] & 0xf0) << 12);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 308 to 323
	value = ((uint32_t)(input[38] & 0x0f) << 28) |
			((uint32_t)input[39] << 20) |
			((uint32_t)(input[40] & 0xf0) << 12);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 324 to 339
	value = ((uint32_t)(input[40] & 0x0f) << 28) |
			((uint32_t)input[41] << 20) |
			((uint32_t)(input[42] & 0xf0) << 12);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 340 to 355
	value = ((uint32_t)(input[42] & 0x0f) << 28) |
			((uint32_t)input[43] << 20) |
			((uint32_t)(input[44] & 0xf0) << 12);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 356 to 371
	value = ((uint32_t)(input[44] & 0x0f) << 28) |
			((uint32_t)input[45] << 20) |
			((uint32_t)(input[46] & 0xf0) << 12);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 372 to 387
	value = ((uint32_t)(input[46] & 0x0f) << 28) |
			((uint32_t)input[47] << 20) |
			((uint32_t)(input[48] & 0xf0) << 12);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 388 to 403
	value = ((uint32_t)(input[48] & 0x0f) << 28) |
			((uint32_t)input[49] << 20) |
			((uint32_t)(input[50] & 0xf0) << 12);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 404 to 419
	value = ((uint32_t)(input[50] & 0x0f) << 28) |
			((uint32_t)input[51] << 20) |
			((uint32_t)(input[52] & 0xf0) << 12);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 420 to 435
	value = ((uint32_t)(input[52] & 0x0f) << 28) |
			((uint32_t)input[53] << 20) |
			((uint32_t)(input[54] & 0xf0) << 12);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 436 to 451
	value = ((uint32_t)(input[54] & 0x0f) << 28) |
			((uint32_t)input[55] << 20) |
			((uint32_t)(input[56] & 0xf0) << 12);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 452 to 467
	value = ((uint32_t)(input[56] & 0x0f) << 28) |
			((uint32_t)input[57] << 20) |
			((uint32_t)(input[58] & 0xf0) << 12);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 468 to 483
	value = ((uint32_t)(input[58] & 0x0f) << 28) |
			((uint32_t)input[59] << 20) |
			((uint32_t)(input[60] & 0xf0) << 12);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 484 to 499
	value = ((uint32_t)(input[60] & 0x0f) << 28) |
			((uint32_t)input[61] << 20) |
			((uint32_t)(input[62] & 0xf0) << 12);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 500 to 515
	value = ((uint32_t)(input[62] & 0x0f) << 28) |
			((uint32_t)input[63] << 20) |
			((uint32_t)(input[64] & 0xf0) << 12);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 516 to 531
	value = ((uint32_t)(input[64] & 0x0f) << 28) |
			((uint32_t)input[65] << 20) |
			((uint32_t)(input[66] & 0xf0) << 12);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 532 to 547
	value = ((uint32_t)(input[66] & 0x0f) << 28) |
			((uint32_t)input[67] << 20) |
			((uint32_t)(input[68] & 0xf0) << 12);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 548 to 563
	value = ((uint32_t)(input[68] & 0x0f) << 28) |
			((uint32_t)input[69] << 20) |
			((uint32_t)(input[70] & 0xf0) << 12);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 564 to 579
	value = ((uint32_t)(input[70] & 0x0f) << 28) |
			((uint32_t)input[71] << 20) |
			((uint32_t)(input[72] & 0xf0) << 12);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 580 to 595
	value = ((uint32_t)(input[72] & 0x0f) << 28) |
			((uint32_t)input[73] << 20) |
			((uint32_t)(input[74] & 0xf0) << 12);
	output[36] = (double)(value >> 16);
}

static void unpack_37_16bit_signed_5off(const uint8_t * input, double * output, void *closure) {
	// Unpack 37 values into output
	// Values are 16-bit signed
	// Skip 5 bits, read 592 bits of data.
	// Input must be at least 75 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 5 to 20
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)(input[2] & 0xf8) << 13);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 21 to 36
	value = ((uint32_t)(input[2] & 0x07) << 29) |
			((uint32_t)input[3] << 21) |
			((uint32_t)(input[4] & 0xf8) << 13);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 37 to 52
	value = ((uint32_t)(input[4] & 0x07) << 29) |
			((uint32_t)input[5] << 21) |
			((uint32_t)(input[6] & 0xf8) << 13);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 53 to 68
	value = ((uint32_t)(input[6] & 0x07) << 29) |
			((uint32_t)input[7] << 21) |
			((uint32_t)(input[8] & 0xf8) << 13);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 69 to 84
	value = ((uint32_t)(input[8] & 0x07) << 29) |
			((uint32_t)input[9] << 21) |
			((uint32_t)(input[10] & 0xf8) << 13);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 85 to 100
	value = ((uint32_t)(input[10] & 0x07) << 29) |
			((uint32_t)input[11] << 21) |
			((uint32_t)(input[12] & 0xf8) << 13);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 101 to 116
	value = ((uint32_t)(input[12] & 0x07) << 29) |
			((uint32_t)input[13] << 21) |
			((uint32_t)(input[14] & 0xf8) << 13);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 117 to 132
	value = ((uint32_t)(input[14] & 0x07) << 29) |
			((uint32_t)input[15] << 21) |
			((uint32_t)(input[16] & 0xf8) << 13);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 133 to 148
	value = ((uint32_t)(input[16] & 0x07) << 29) |
			((uint32_t)input[17] << 21) |
			((uint32_t)(input[18] & 0xf8) << 13);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 149 to 164
	value = ((uint32_t)(input[18] & 0x07) << 29) |
			((uint32_t)input[19] << 21) |
			((uint32_t)(input[20] & 0xf8) << 13);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 165 to 180
	value = ((uint32_t)(input[20] & 0x07) << 29) |
			((uint32_t)input[21] << 21) |
			((uint32_t)(input[22] & 0xf8) << 13);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 181 to 196
	value = ((uint32_t)(input[22] & 0x07) << 29) |
			((uint32_t)input[23] << 21) |
			((uint32_t)(input[24] & 0xf8) << 13);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 197 to 212
	value = ((uint32_t)(input[24] & 0x07) << 29) |
			((uint32_t)input[25] << 21) |
			((uint32_t)(input[26] & 0xf8) << 13);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 213 to 228
	value = ((uint32_t)(input[26] & 0x07) << 29) |
			((uint32_t)input[27] << 21) |
			((uint32_t)(input[28] & 0xf8) << 13);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 229 to 244
	value = ((uint32_t)(input[28] & 0x07) << 29) |
			((uint32_t)input[29] << 21) |
			((uint32_t)(input[30] & 0xf8) << 13);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 245 to 260
	value = ((uint32_t)(input[30] & 0x07) << 29) |
			((uint32_t)input[31] << 21) |
			((uint32_t)(input[32] & 0xf8) << 13);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 261 to 276
	value = ((uint32_t)(input[32] & 0x07) << 29) |
			((uint32_t)input[33] << 21) |
			((uint32_t)(input[34] & 0xf8) << 13);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 277 to 292
	value = ((uint32_t)(input[34] & 0x07) << 29) |
			((uint32_t)input[35] << 21) |
			((uint32_t)(input[36] & 0xf8) << 13);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 293 to 308
	value = ((uint32_t)(input[36] & 0x07) << 29) |
			((uint32_t)input[37] << 21) |
			((uint32_t)(input[38] & 0xf8) << 13);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 309 to 324
	value = ((uint32_t)(input[38] & 0x07) << 29) |
			((uint32_t)input[39] << 21) |
			((uint32_t)(input[40] & 0xf8) << 13);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 325 to 340
	value = ((uint32_t)(input[40] & 0x07) << 29) |
			((uint32_t)input[41] << 21) |
			((uint32_t)(input[42] & 0xf8) << 13);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 341 to 356
	value = ((uint32_t)(input[42] & 0x07) << 29) |
			((uint32_t)input[43] << 21) |
			((uint32_t)(input[44] & 0xf8) << 13);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 357 to 372
	value = ((uint32_t)(input[44] & 0x07) << 29) |
			((uint32_t)input[45] << 21) |
			((uint32_t)(input[46] & 0xf8) << 13);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 373 to 388
	value = ((uint32_t)(input[46] & 0x07) << 29) |
			((uint32_t)input[47] << 21) |
			((uint32_t)(input[48] & 0xf8) << 13);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 389 to 404
	value = ((uint32_t)(input[48] & 0x07) << 29) |
			((uint32_t)input[49] << 21) |
			((uint32_t)(input[50] & 0xf8) << 13);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 405 to 420
	value = ((uint32_t)(input[50] & 0x07) << 29) |
			((uint32_t)input[51] << 21) |
			((uint32_t)(input[52] & 0xf8) << 13);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 421 to 436
	value = ((uint32_t)(input[52] & 0x07) << 29) |
			((uint32_t)input[53] << 21) |
			((uint32_t)(input[54] & 0xf8) << 13);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 437 to 452
	value = ((uint32_t)(input[54] & 0x07) << 29) |
			((uint32_t)input[55] << 21) |
			((uint32_t)(input[56] & 0xf8) << 13);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 453 to 468
	value = ((uint32_t)(input[56] & 0x07) << 29) |
			((uint32_t)input[57] << 21) |
			((uint32_t)(input[58] & 0xf8) << 13);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 469 to 484
	value = ((uint32_t)(input[58] & 0x07) << 29) |
			((uint32_t)input[59] << 21) |
			((uint32_t)(input[60] & 0xf8) << 13);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 485 to 500
	value = ((uint32_t)(input[60] & 0x07) << 29) |
			((uint32_t)input[61] << 21) |
			((uint32_t)(input[62] & 0xf8) << 13);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 501 to 516
	value = ((uint32_t)(input[62] & 0x07) << 29) |
			((uint32_t)input[63] << 21) |
			((uint32_t)(input[64] & 0xf8) << 13);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 517 to 532
	value = ((uint32_t)(input[64] & 0x07) << 29) |
			((uint32_t)input[65] << 21) |
			((uint32_t)(input[66] & 0xf8) << 13);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 533 to 548
	value = ((uint32_t)(input[66] & 0x07) << 29) |
			((uint32_t)input[67] << 21) |
			((uint32_t)(input[68] & 0xf8) << 13);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 549 to 564
	value = ((uint32_t)(input[68] & 0x07) << 29) |
			((uint32_t)input[69] << 21) |
			((uint32_t)(input[70] & 0xf8) << 13);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 565 to 580
	value = ((uint32_t)(input[70] & 0x07) << 29) |
			((uint32_t)input[71] << 21) |
			((uint32_t)(input[72] & 0xf8) << 13);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 581 to 596
	value = ((uint32_t)(input[72] & 0x07) << 29) |
			((uint32_t)input[73] << 21) |
			((uint32_t)(input[74] & 0xf8) << 13);
	output[36] = (double)(value >> 16);
}

static void unpack_37_16bit_unsigned_5off(const uint8_t * input, double * output, void *closure) {
	// Unpack 37 values into output
	// Values are 16-bit unsigned
	// Skip 5 bits, read 592 bits of data.
	// Input must be at least 75 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 5 to 20
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)(input[2] & 0xf8) << 13);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 21 to 36
	value = ((uint32_t)(input[2] & 0x07) << 29) |
			((uint32_t)input[3] << 21) |
			((uint32_t)(input[4] & 0xf8) << 13);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 37 to 52
	value = ((uint32_t)(input[4] & 0x07) << 29) |
			((uint32_t)input[5] << 21) |
			((uint32_t)(input[6] & 0xf8) << 13);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 53 to 68
	value = ((uint32_t)(input[6] & 0x07) << 29) |
			((uint32_t)input[7] << 21) |
			((uint32_t)(input[8] & 0xf8) << 13);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 69 to 84
	value = ((uint32_t)(input[8] & 0x07) << 29) |
			((uint32_t)input[9] << 21) |
			((uint32_t)(input[10] & 0xf8) << 13);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 85 to 100
	value = ((uint32_t)(input[10] & 0x07) << 29) |
			((uint32_t)input[11] << 21) |
			((uint32_t)(input[12] & 0xf8) << 13);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 101 to 116
	value = ((uint32_t)(input[12] & 0x07) << 29) |
			((uint32_t)input[13] << 21) |
			((uint32_t)(input[14] & 0xf8) << 13);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 117 to 132
	value = ((uint32_t)(input[14] & 0x07) << 29) |
			((uint32_t)input[15] << 21) |
			((uint32_t)(input[16] & 0xf8) << 13);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 133 to 148
	value = ((uint32_t)(input[16] & 0x07) << 29) |
			((uint32_t)input[17] << 21) |
			((uint32_t)(input[18] & 0xf8) << 13);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 149 to 164
	value = ((uint32_t)(input[18] & 0x07) << 29) |
			((uint32_t)input[19] << 21) |
			((uint32_t)(input[20] & 0xf8) << 13);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 165 to 180
	value = ((uint32_t)(input[20] & 0x07) << 29) |
			((uint32_t)input[21] << 21) |
			((uint32_t)(input[22] & 0xf8) << 13);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 181 to 196
	value = ((uint32_t)(input[22] & 0x07) << 29) |
			((uint32_t)input[23] << 21) |
			((uint32_t)(input[24] & 0xf8) << 13);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 197 to 212
	value = ((uint32_t)(input[24] & 0x07) << 29) |
			((uint32_t)input[25] << 21) |
			((uint32_t)(input[26] & 0xf8) << 13);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 213 to 228
	value = ((uint32_t)(input[26] & 0x07) << 29) |
			((uint32_t)input[27] << 21) |
			((uint32_t)(input[28] & 0xf8) << 13);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 229 to 244
	value = ((uint32_t)(input[28] & 0x07) << 29) |
			((uint32_t)input[29] << 21) |
			((uint32_t)(input[30] & 0xf8) << 13);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 245 to 260
	value = ((uint32_t)(input[30] & 0x07) << 29) |
			((uint32_t)input[31] << 21) |
			((uint32_t)(input[32] & 0xf8) << 13);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 261 to 276
	value = ((uint32_t)(input[32] & 0x07) << 29) |
			((uint32_t)input[33] << 21) |
			((uint32_t)(input[34] & 0xf8) << 13);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 277 to 292
	value = ((uint32_t)(input[34] & 0x07) << 29) |
			((uint32_t)input[35] << 21) |
			((uint32_t)(input[36] & 0xf8) << 13);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 293 to 308
	value = ((uint32_t)(input[36] & 0x07) << 29) |
			((uint32_t)input[37] << 21) |
			((uint32_t)(input[38] & 0xf8) << 13);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 309 to 324
	value = ((uint32_t)(input[38] & 0x07) << 29) |
			((uint32_t)input[39] << 21) |
			((uint32_t)(input[40] & 0xf8) << 13);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 325 to 340
	value = ((uint32_t)(input[40] & 0x07) << 29) |
			((uint32_t)input[41] << 21) |
			((uint32_t)(input[42] & 0xf8) << 13);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 341 to 356
	value = ((uint32_t)(input[42] & 0x07) << 29) |
			((uint32_t)input[43] << 21) |
			((uint32_t)(input[44] & 0xf8) << 13);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 357 to 372
	value = ((uint32_t)(input[44] & 0x07) << 29) |
			((uint32_t)input[45] << 21) |
			((uint32_t)(input[46] & 0xf8) << 13);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 373 to 388
	value = ((uint32_t)(input[46] & 0x07) << 29) |
			((uint32_t)input[47] << 21) |
			((uint32_t)(input[48] & 0xf8) << 13);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 389 to 404
	value = ((uint32_t)(input[48] & 0x07) << 29) |
			((uint32_t)input[49] << 21) |
			((uint32_t)(input[50] & 0xf8) << 13);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 405 to 420
	value = ((uint32_t)(input[50] & 0x07) << 29) |
			((uint32_t)input[51] << 21) |
			((uint32_t)(input[52] & 0xf8) << 13);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 421 to 436
	value = ((uint32_t)(input[52] & 0x07) << 29) |
			((uint32_t)input[53] << 21) |
			((uint32_t)(input[54] & 0xf8) << 13);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 437 to 452
	value = ((uint32_t)(input[54] & 0x07) << 29) |
			((uint32_t)input[55] << 21) |
			((uint32_t)(input[56] & 0xf8) << 13);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 453 to 468
	value = ((uint32_t)(input[56] & 0x07) << 29) |
			((uint32_t)input[57] << 21) |
			((uint32_t)(input[58] & 0xf8) << 13);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 469 to 484
	value = ((uint32_t)(input[58] & 0x07) << 29) |
			((uint32_t)input[59] << 21) |
			((uint32_t)(input[60] & 0xf8) << 13);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 485 to 500
	value = ((uint32_t)(input[60] & 0x07) << 29) |
			((uint32_t)input[61] << 21) |
			((uint32_t)(input[62] & 0xf8) << 13);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 501 to 516
	value = ((uint32_t)(input[62] & 0x07) << 29) |
			((uint32_t)input[63] << 21) |
			((uint32_t)(input[64] & 0xf8) << 13);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 517 to 532
	value = ((uint32_t)(input[64] & 0x07) << 29) |
			((uint32_t)input[65] << 21) |
			((uint32_t)(input[66] & 0xf8) << 13);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 533 to 548
	value = ((uint32_t)(input[66] & 0x07) << 29) |
			((uint32_t)input[67] << 21) |
			((uint32_t)(input[68] & 0xf8) << 13);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 549 to 564
	value = ((uint32_t)(input[68] & 0x07) << 29) |
			((uint32_t)input[69] << 21) |
			((uint32_t)(input[70] & 0xf8) << 13);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 565 to 580
	value = ((uint32_t)(input[70] & 0x07) << 29) |
			((uint32_t)input[71] << 21) |
			((uint32_t)(input[72] & 0xf8) << 13);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 581 to 596
	value = ((uint32_t)(input[72] & 0x07) << 29) |
			((uint32_t)input[73] << 21) |
			((uint32_t)(input[74] & 0xf8) << 13);
	output[36] = (double)(value >> 16);
}

static void unpack_37_16bit_signed_6off(const uint8_t * input, double * output, void *closure) {
	// Unpack 37 values into output
	// Values are 16-bit signed
	// Skip 6 bits, read 592 bits of data.
	// Input must be at least 75 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 6 to 21
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)(input[2] & 0xfc) << 14);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 22 to 37
	value = ((uint32_t)(input[2] & 0x03) << 30) |
			((uint32_t)input[3] << 22) |
			((uint32_t)(input[4] & 0xfc) << 14);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 38 to 53
	value = ((uint32_t)(input[4] & 0x03) << 30) |
			((uint32_t)input[5] << 22) |
			((uint32_t)(input[6] & 0xfc) << 14);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 54 to 69
	value = ((uint32_t)(input[6] & 0x03) << 30) |
			((uint32_t)input[7] << 22) |
			((uint32_t)(input[8] & 0xfc) << 14);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 70 to 85
	value = ((uint32_t)(input[8] & 0x03) << 30) |
			((uint32_t)input[9] << 22) |
			((uint32_t)(input[10] & 0xfc) << 14);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 86 to 101
	value = ((uint32_t)(input[10] & 0x03) << 30) |
			((uint32_t)input[11] << 22) |
			((uint32_t)(input[12] & 0xfc) << 14);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 102 to 117
	value = ((uint32_t)(input[12] & 0x03) << 30) |
			((uint32_t)input[13] << 22) |
			((uint32_t)(input[14] & 0xfc) << 14);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 118 to 133
	value = ((uint32_t)(input[14] & 0x03) << 30) |
			((uint32_t)input[15] << 22) |
			((uint32_t)(input[16] & 0xfc) << 14);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 134 to 149
	value = ((uint32_t)(input[16] & 0x03) << 30) |
			((uint32_t)input[17] << 22) |
			((uint32_t)(input[18] & 0xfc) << 14);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 150 to 165
	value = ((uint32_t)(input[18] & 0x03) << 30) |
			((uint32_t)input[19] << 22) |
			((uint32_t)(input[20] & 0xfc) << 14);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 166 to 181
	value = ((uint32_t)(input[20] & 0x03) << 30) |
			((uint32_t)input[21] << 22) |
			((uint32_t)(input[22] & 0xfc) << 14);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 182 to 197
	value = ((uint32_t)(input[22] & 0x03) << 30) |
			((uint32_t)input[23] << 22) |
			((uint32_t)(input[24] & 0xfc) << 14);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 198 to 213
	value = ((uint32_t)(input[24] & 0x03) << 30) |
			((uint32_t)input[25] << 22) |
			((uint32_t)(input[26] & 0xfc) << 14);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 214 to 229
	value = ((uint32_t)(input[26] & 0x03) << 30) |
			((uint32_t)input[27] << 22) |
			((uint32_t)(input[28] & 0xfc) << 14);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 230 to 245
	value = ((uint32_t)(input[28] & 0x03) << 30) |
			((uint32_t)input[29] << 22) |
			((uint32_t)(input[30] & 0xfc) << 14);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 246 to 261
	value = ((uint32_t)(input[30] & 0x03) << 30) |
			((uint32_t)input[31] << 22) |
			((uint32_t)(input[32] & 0xfc) << 14);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 262 to 277
	value = ((uint32_t)(input[32] & 0x03) << 30) |
			((uint32_t)input[33] << 22) |
			((uint32_t)(input[34] & 0xfc) << 14);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 278 to 293
	value = ((uint32_t)(input[34] & 0x03) << 30) |
			((uint32_t)input[35] << 22) |
			((uint32_t)(input[36] & 0xfc) << 14);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 294 to 309
	value = ((uint32_t)(input[36] & 0x03) << 30) |
			((uint32_t)input[37] << 22) |
			((uint32_t)(input[38] & 0xfc) << 14);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 310 to 325
	value = ((uint32_t)(input[38] & 0x03) << 30) |
			((uint32_t)input[39] << 22) |
			((uint32_t)(input[40] & 0xfc) << 14);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 326 to 341
	value = ((uint32_t)(input[40] & 0x03) << 30) |
			((uint32_t)input[41] << 22) |
			((uint32_t)(input[42] & 0xfc) << 14);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 342 to 357
	value = ((uint32_t)(input[42] & 0x03) << 30) |
			((uint32_t)input[43] << 22) |
			((uint32_t)(input[44] & 0xfc) << 14);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 358 to 373
	value = ((uint32_t)(input[44] & 0x03) << 30) |
			((uint32_t)input[45] << 22) |
			((uint32_t)(input[46] & 0xfc) << 14);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 374 to 389
	value = ((uint32_t)(input[46] & 0x03) << 30) |
			((uint32_t)input[47] << 22) |
			((uint32_t)(input[48] & 0xfc) << 14);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 390 to 405
	value = ((uint32_t)(input[48] & 0x03) << 30) |
			((uint32_t)input[49] << 22) |
			((uint32_t)(input[50] & 0xfc) << 14);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 406 to 421
	value = ((uint32_t)(input[50] & 0x03) << 30) |
			((uint32_t)input[51] << 22) |
			((uint32_t)(input[52] & 0xfc) << 14);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 422 to 437
	value = ((uint32_t)(input[52] & 0x03) << 30) |
			((uint32_t)input[53] << 22) |
			((uint32_t)(input[54] & 0xfc) << 14);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 438 to 453
	value = ((uint32_t)(input[54] & 0x03) << 30) |
			((uint32_t)input[55] << 22) |
			((uint32_t)(input[56] & 0xfc) << 14);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 454 to 469
	value = ((uint32_t)(input[56] & 0x03) << 30) |
			((uint32_t)input[57] << 22) |
			((uint32_t)(input[58] & 0xfc) << 14);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 470 to 485
	value = ((uint32_t)(input[58] & 0x03) << 30) |
			((uint32_t)input[59] << 22) |
			((uint32_t)(input[60] & 0xfc) << 14);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 486 to 501
	value = ((uint32_t)(input[60] & 0x03) << 30) |
			((uint32_t)input[61] << 22) |
			((uint32_t)(input[62] & 0xfc) << 14);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 502 to 517
	value = ((uint32_t)(input[62] & 0x03) << 30) |
			((uint32_t)input[63] << 22) |
			((uint32_t)(input[64] & 0xfc) << 14);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 518 to 533
	value = ((uint32_t)(input[64] & 0x03) << 30) |
			((uint32_t)input[65] << 22) |
			((uint32_t)(input[66] & 0xfc) << 14);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 534 to 549
	value = ((uint32_t)(input[66] & 0x03) << 30) |
			((uint32_t)input[67] << 22) |
			((uint32_t)(input[68] & 0xfc) << 14);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 550 to 565
	value = ((uint32_t)(input[68] & 0x03) << 30) |
			((uint32_t)input[69] << 22) |
			((uint32_t)(input[70] & 0xfc) << 14);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 566 to 581
	value = ((uint32_t)(input[70] & 0x03) << 30) |
			((uint32_t)input[71] << 22) |
			((uint32_t)(input[72] & 0xfc) << 14);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 582 to 597
	value = ((uint32_t)(input[72] & 0x03) << 30) |
			((uint32_t)input[73] << 22) |
			((uint32_t)(input[74] & 0xfc) << 14);
	output[36] = (double)(value >> 16);
}

static void unpack_37_16bit_unsigned_6off(const uint8_t * input, double * output, void *closure) {
	// Unpack 37 values into output
	// Values are 16-bit unsigned
	// Skip 6 bits, read 592 bits of data.
	// Input must be at least 75 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 6 to 21
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)(input[2] & 0xfc) << 14);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 22 to 37
	value = ((uint32_t)(input[2] & 0x03) << 30) |
			((uint32_t)input[3] << 22) |
			((uint32_t)(input[4] & 0xfc) << 14);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 38 to 53
	value = ((uint32_t)(input[4] & 0x03) << 30) |
			((uint32_t)input[5] << 22) |
			((uint32_t)(input[6] & 0xfc) << 14);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 54 to 69
	value = ((uint32_t)(input[6] & 0x03) << 30) |
			((uint32_t)input[7] << 22) |
			((uint32_t)(input[8] & 0xfc) << 14);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 70 to 85
	value = ((uint32_t)(input[8] & 0x03) << 30) |
			((uint32_t)input[9] << 22) |
			((uint32_t)(input[10] & 0xfc) << 14);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 86 to 101
	value = ((uint32_t)(input[10] & 0x03) << 30) |
			((uint32_t)input[11] << 22) |
			((uint32_t)(input[12] & 0xfc) << 14);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 102 to 117
	value = ((uint32_t)(input[12] & 0x03) << 30) |
			((uint32_t)input[13] << 22) |
			((uint32_t)(input[14] & 0xfc) << 14);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 118 to 133
	value = ((uint32_t)(input[14] & 0x03) << 30) |
			((uint32_t)input[15] << 22) |
			((uint32_t)(input[16] & 0xfc) << 14);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 134 to 149
	value = ((uint32_t)(input[16] & 0x03) << 30) |
			((uint32_t)input[17] << 22) |
			((uint32_t)(input[18] & 0xfc) << 14);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 150 to 165
	value = ((uint32_t)(input[18] & 0x03) << 30) |
			((uint32_t)input[19] << 22) |
			((uint32_t)(input[20] & 0xfc) << 14);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 166 to 181
	value = ((uint32_t)(input[20] & 0x03) << 30) |
			((uint32_t)input[21] << 22) |
			((uint32_t)(input[22] & 0xfc) << 14);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 182 to 197
	value = ((uint32_t)(input[22] & 0x03) << 30) |
			((uint32_t)input[23] << 22) |
			((uint32_t)(input[24] & 0xfc) << 14);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 198 to 213
	value = ((uint32_t)(input[24] & 0x03) << 30) |
			((uint32_t)input[25] << 22) |
			((uint32_t)(input[26] & 0xfc) << 14);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 214 to 229
	value = ((uint32_t)(input[26] & 0x03) << 30) |
			((uint32_t)input[27] << 22) |
			((uint32_t)(input[28] & 0xfc) << 14);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 230 to 245
	value = ((uint32_t)(input[28] & 0x03) << 30) |
			((uint32_t)input[29] << 22) |
			((uint32_t)(input[30] & 0xfc) << 14);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 246 to 261
	value = ((uint32_t)(input[30] & 0x03) << 30) |
			((uint32_t)input[31] << 22) |
			((uint32_t)(input[32] & 0xfc) << 14);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 262 to 277
	value = ((uint32_t)(input[32] & 0x03) << 30) |
			((uint32_t)input[33] << 22) |
			((uint32_t)(input[34] & 0xfc) << 14);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 278 to 293
	value = ((uint32_t)(input[34] & 0x03) << 30) |
			((uint32_t)input[35] << 22) |
			((uint32_t)(input[36] & 0xfc) << 14);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 294 to 309
	value = ((uint32_t)(input[36] & 0x03) << 30) |
			((uint32_t)input[37] << 22) |
			((uint32_t)(input[38] & 0xfc) << 14);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 310 to 325
	value = ((uint32_t)(input[38] & 0x03) << 30) |
			((uint32_t)input[39] << 22) |
			((uint32_t)(input[40] & 0xfc) << 14);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 326 to 341
	value = ((uint32_t)(input[40] & 0x03) << 30) |
			((uint32_t)input[41] << 22) |
			((uint32_t)(input[42] & 0xfc) << 14);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 342 to 357
	value = ((uint32_t)(input[42] & 0x03) << 30) |
			((uint32_t)input[43] << 22) |
			((uint32_t)(input[44] & 0xfc) << 14);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 358 to 373
	value = ((uint32_t)(input[44] & 0x03) << 30) |
			((uint32_t)input[45] << 22) |
			((uint32_t)(input[46] & 0xfc) << 14);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 374 to 389
	value = ((uint32_t)(input[46] & 0x03) << 30) |
			((uint32_t)input[47] << 22) |
			((uint32_t)(input[48] & 0xfc) << 14);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 390 to 405
	value = ((uint32_t)(input[48] & 0x03) << 30) |
			((uint32_t)input[49] << 22) |
			((uint32_t)(input[50] & 0xfc) << 14);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 406 to 421
	value = ((uint32_t)(input[50] & 0x03) << 30) |
			((uint32_t)input[51] << 22) |
			((uint32_t)(input[52] & 0xfc) << 14);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 422 to 437
	value = ((uint32_t)(input[52] & 0x03) << 30) |
			((uint32_t)input[53] << 22) |
			((uint32_t)(input[54] & 0xfc) << 14);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 438 to 453
	value = ((uint32_t)(input[54] & 0x03) << 30) |
			((uint32_t)input[55] << 22) |
			((uint32_t)(input[56] & 0xfc) << 14);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 454 to 469
	value = ((uint32_t)(input[56] & 0x03) << 30) |
			((uint32_t)input[57] << 22) |
			((uint32_t)(input[58] & 0xfc) << 14);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 470 to 485
	value = ((uint32_t)(input[58] & 0x03) << 30) |
			((uint32_t)input[59] << 22) |
			((uint32_t)(input[60] & 0xfc) << 14);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 486 to 501
	value = ((uint32_t)(input[60] & 0x03) << 30) |
			((uint32_t)input[61] << 22) |
			((uint32_t)(input[62] & 0xfc) << 14);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 502 to 517
	value = ((uint32_t)(input[62] & 0x03) << 30) |
			((uint32_t)input[63] << 22) |
			((uint32_t)(input[64] & 0xfc) << 14);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 518 to 533
	value = ((uint32_t)(input[64] & 0x03) << 30) |
			((uint32_t)input[65] << 22) |
			((uint32_t)(input[66] & 0xfc) << 14);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 534 to 549
	value = ((uint32_t)(input[66] & 0x03) << 30) |
			((uint32_t)input[67] << 22) |
			((uint32_t)(input[68] & 0xfc) << 14);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 550 to 565
	value = ((uint32_t)(input[68] & 0x03) << 30) |
			((uint32_t)input[69] << 22) |
			((uint32_t)(input[70] & 0xfc) << 14);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 566 to 581
	value = ((uint32_t)(input[70] & 0x03) << 30) |
			((uint32_t)input[71] << 22) |
			((uint32_t)(input[72] & 0xfc) << 14);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 582 to 597
	value = ((uint32_t)(input[72] & 0x03) << 30) |
			((uint32_t)input[73] << 22) |
			((uint32_t)(input[74] & 0xfc) << 14);
	output[36] = (double)(value >> 16);
}

static void unpack_37_16bit_signed_7off(const uint8_t * input, double * output, void *closure) {
	// Unpack 37 values into output
	// Values are 16-bit signed
	// Skip 7 bits, read 592 bits of data.
	// Input must be at least 75 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 7 to 22
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)(input[2] & 0xfe) << 15);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 23 to 38
	value = ((uint32_t)(input[2] & 0x01) << 31) |
			((uint32_t)input[3] << 23) |
			((uint32_t)(input[4] & 0xfe) << 15);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 39 to 54
	value = ((uint32_t)(input[4] & 0x01) << 31) |
			((uint32_t)input[5] << 23) |
			((uint32_t)(input[6] & 0xfe) << 15);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 55 to 70
	value = ((uint32_t)(input[6] & 0x01) << 31) |
			((uint32_t)input[7] << 23) |
			((uint32_t)(input[8] & 0xfe) << 15);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 71 to 86
	value = ((uint32_t)(input[8] & 0x01) << 31) |
			((uint32_t)input[9] << 23) |
			((uint32_t)(input[10] & 0xfe) << 15);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 87 to 102
	value = ((uint32_t)(input[10] & 0x01) << 31) |
			((uint32_t)input[11] << 23) |
			((uint32_t)(input[12] & 0xfe) << 15);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 103 to 118
	value = ((uint32_t)(input[12] & 0x01) << 31) |
			((uint32_t)input[13] << 23) |
			((uint32_t)(input[14] & 0xfe) << 15);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 119 to 134
	value = ((uint32_t)(input[14] & 0x01) << 31) |
			((uint32_t)input[15] << 23) |
			((uint32_t)(input[16] & 0xfe) << 15);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 135 to 150
	value = ((uint32_t)(input[16] & 0x01) << 31) |
			((uint32_t)input[17] << 23) |
			((uint32_t)(input[18] & 0xfe) << 15);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 151 to 166
	value = ((uint32_t)(input[18] & 0x01) << 31) |
			((uint32_t)input[19] << 23) |
			((uint32_t)(input[20] & 0xfe) << 15);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 167 to 182
	value = ((uint32_t)(input[20] & 0x01) << 31) |
			((uint32_t)input[21] << 23) |
			((uint32_t)(input[22] & 0xfe) << 15);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 183 to 198
	value = ((uint32_t)(input[22] & 0x01) << 31) |
			((uint32_t)input[23] << 23) |
			((uint32_t)(input[24] & 0xfe) << 15);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 199 to 214
	value = ((uint32_t)(input[24] & 0x01) << 31) |
			((uint32_t)input[25] << 23) |
			((uint32_t)(input[26] & 0xfe) << 15);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 215 to 230
	value = ((uint32_t)(input[26] & 0x01) << 31) |
			((uint32_t)input[27] << 23) |
			((uint32_t)(input[28] & 0xfe) << 15);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 231 to 246
	value = ((uint32_t)(input[28] & 0x01) << 31) |
			((uint32_t)input[29] << 23) |
			((uint32_t)(input[30] & 0xfe) << 15);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 247 to 262
	value = ((uint32_t)(input[30] & 0x01) << 31) |
			((uint32_t)input[31] << 23) |
			((uint32_t)(input[32] & 0xfe) << 15);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 263 to 278
	value = ((uint32_t)(input[32] & 0x01) << 31) |
			((uint32_t)input[33] << 23) |
			((uint32_t)(input[34] & 0xfe) << 15);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 279 to 294
	value = ((uint32_t)(input[34] & 0x01) << 31) |
			((uint32_t)input[35] << 23) |
			((uint32_t)(input[36] & 0xfe) << 15);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 295 to 310
	value = ((uint32_t)(input[36] & 0x01) << 31) |
			((uint32_t)input[37] << 23) |
			((uint32_t)(input[38] & 0xfe) << 15);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 311 to 326
	value = ((uint32_t)(input[38] & 0x01) << 31) |
			((uint32_t)input[39] << 23) |
			((uint32_t)(input[40] & 0xfe) << 15);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 327 to 342
	value = ((uint32_t)(input[40] & 0x01) << 31) |
			((uint32_t)input[41] << 23) |
			((uint32_t)(input[42] & 0xfe) << 15);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 343 to 358
	value = ((uint32_t)(input[42] & 0x01) << 31) |
			((uint32_t)input[43] << 23) |
			((uint32_t)(input[44] & 0xfe) << 15);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 359 to 374
	value = ((uint32_t)(input[44] & 0x01) << 31) |
			((uint32_t)input[45] << 23) |
			((uint32_t)(input[46] & 0xfe) << 15);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 375 to 390
	value = ((uint32_t)(input[46] & 0x01) << 31) |
			((uint32_t)input[47] << 23) |
			((uint32_t)(input[48] & 0xfe) << 15);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 391 to 406
	value = ((uint32_t)(input[48] & 0x01) << 31) |
			((uint32_t)input[49] << 23) |
			((uint32_t)(input[50] & 0xfe) << 15);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 407 to 422
	value = ((uint32_t)(input[50] & 0x01) << 31) |
			((uint32_t)input[51] << 23) |
			((uint32_t)(input[52] & 0xfe) << 15);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 423 to 438
	value = ((uint32_t)(input[52] & 0x01) << 31) |
			((uint32_t)input[53] << 23) |
			((uint32_t)(input[54] & 0xfe) << 15);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 439 to 454
	value = ((uint32_t)(input[54] & 0x01) << 31) |
			((uint32_t)input[55] << 23) |
			((uint32_t)(input[56] & 0xfe) << 15);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 455 to 470
	value = ((uint32_t)(input[56] & 0x01) << 31) |
			((uint32_t)input[57] << 23) |
			((uint32_t)(input[58] & 0xfe) << 15);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 471 to 486
	value = ((uint32_t)(input[58] & 0x01) << 31) |
			((uint32_t)input[59] << 23) |
			((uint32_t)(input[60] & 0xfe) << 15);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 487 to 502
	value = ((uint32_t)(input[60] & 0x01) << 31) |
			((uint32_t)input[61] << 23) |
			((uint32_t)(input[62] & 0xfe) << 15);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 503 to 518
	value = ((uint32_t)(input[62] & 0x01) << 31) |
			((uint32_t)input[63] << 23) |
			((uint32_t)(input[64] & 0xfe) << 15);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 519 to 534
	value = ((uint32_t)(input[64] & 0x01) << 31) |
			((uint32_t)input[65] << 23) |
			((uint32_t)(input[66] & 0xfe) << 15);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 535 to 550
	value = ((uint32_t)(input[66] & 0x01) << 31) |
			((uint32_t)input[67] << 23) |
			((uint32_t)(input[68] & 0xfe) << 15);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 551 to 566
	value = ((uint32_t)(input[68] & 0x01) << 31) |
			((uint32_t)input[69] << 23) |
			((uint32_t)(input[70] & 0xfe) << 15);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 567 to 582
	value = ((uint32_t)(input[70] & 0x01) << 31) |
			((uint32_t)input[71] << 23) |
			((uint32_t)(input[72] & 0xfe) << 15);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 583 to 598
	value = ((uint32_t)(input[72] & 0x01) << 31) |
			((uint32_t)input[73] << 23) |
			((uint32_t)(input[74] & 0xfe) << 15);
	output[36] = (double)(value >> 16);
}

static void unpack_37_16bit_unsigned_7off(const uint8_t * input, double * output, void *closure) {
	// Unpack 37 values into output
	// Values are 16-bit unsigned
	// Skip 7 bits, read 592 bits of data.
	// Input must be at least 75 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 7 to 22
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)(input[2] & 0xfe) << 15);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 23 to 38
	value = ((uint32_t)(input[2] & 0x01) << 31) |
			((uint32_t)input[3] << 23) |
			((uint32_t)(input[4] & 0xfe) << 15);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 39 to 54
	value = ((uint32_t)(input[4] & 0x01) << 31) |
			((uint32_t)input[5] << 23) |
			((uint32_t)(input[6] & 0xfe) << 15);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 55 to 70
	value = ((uint32_t)(input[6] & 0x01) << 31) |
			((uint32_t)input[7] << 23) |
			((uint32_t)(input[8] & 0xfe) << 15);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 71 to 86
	value = ((uint32_t)(input[8] & 0x01) << 31) |
			((uint32_t)input[9] << 23) |
			((uint32_t)(input[10] & 0xfe) << 15);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 87 to 102
	value = ((uint32_t)(input[10] & 0x01) << 31) |
			((uint32_t)input[11] << 23) |
			((uint32_t)(input[12] & 0xfe) << 15);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 103 to 118
	value = ((uint32_t)(input[12] & 0x01) << 31) |
			((uint32_t)input[13] << 23) |
			((uint32_t)(input[14] & 0xfe) << 15);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 119 to 134
	value = ((uint32_t)(input[14] & 0x01) << 31) |
			((uint32_t)input[15] << 23) |
			((uint32_t)(input[16] & 0xfe) << 15);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 135 to 150
	value = ((uint32_t)(input[16] & 0x01) << 31) |
			((uint32_t)input[17] << 23) |
			((uint32_t)(input[18] & 0xfe) << 15);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 151 to 166
	value = ((uint32_t)(input[18] & 0x01) << 31) |
			((uint32_t)input[19] << 23) |
			((uint32_t)(input[20] & 0xfe) << 15);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 167 to 182
	value = ((uint32_t)(input[20] & 0x01) << 31) |
			((uint32_t)input[21] << 23) |
			((uint32_t)(input[22] & 0xfe) << 15);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 183 to 198
	value = ((uint32_t)(input[22] & 0x01) << 31) |
			((uint32_t)input[23] << 23) |
			((uint32_t)(input[24] & 0xfe) << 15);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 199 to 214
	value = ((uint32_t)(input[24] & 0x01) << 31) |
			((uint32_t)input[25] << 23) |
			((uint32_t)(input[26] & 0xfe) << 15);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 215 to 230
	value = ((uint32_t)(input[26] & 0x01) << 31) |
			((uint32_t)input[27] << 23) |
			((uint32_t)(input[28] & 0xfe) << 15);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 231 to 246
	value = ((uint32_t)(input[28] & 0x01) << 31) |
			((uint32_t)input[29] << 23) |
			((uint32_t)(input[30] & 0xfe) << 15);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 247 to 262
	value = ((uint32_t)(input[30] & 0x01) << 31) |
			((uint32_t)input[31] << 23) |
			((uint32_t)(input[32] & 0xfe) << 15);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 263 to 278
	value = ((uint32_t)(input[32] & 0x01) << 31) |
			((uint32_t)input[33] << 23) |
			((uint32_t)(input[34] & 0xfe) << 15);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 279 to 294
	value = ((uint32_t)(input[34] & 0x01) << 31) |
			((uint32_t)input[35] << 23) |
			((uint32_t)(input[36] & 0xfe) << 15);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 295 to 310
	value = ((uint32_t)(input[36] & 0x01) << 31) |
			((uint32_t)input[37] << 23) |
			((uint32_t)(input[38] & 0xfe) << 15);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 311 to 326
	value = ((uint32_t)(input[38] & 0x01) << 31) |
			((uint32_t)input[39] << 23) |
			((uint32_t)(input[40] & 0xfe) << 15);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 327 to 342
	value = ((uint32_t)(input[40] & 0x01) << 31) |
			((uint32_t)input[41] << 23) |
			((uint32_t)(input[42] & 0xfe) << 15);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 343 to 358
	value = ((uint32_t)(input[42] & 0x01) << 31) |
			((uint32_t)input[43] << 23) |
			((uint32_t)(input[44] & 0xfe) << 15);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 359 to 374
	value = ((uint32_t)(input[44] & 0x01) << 31) |
			((uint32_t)input[45] << 23) |
			((uint32_t)(input[46] & 0xfe) << 15);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 375 to 390
	value = ((uint32_t)(input[46] & 0x01) << 31) |
			((uint32_t)input[47] << 23) |
			((uint32_t)(input[48] & 0xfe) << 15);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 391 to 406
	value = ((uint32_t)(input[48] & 0x01) << 31) |
			((uint32_t)input[49] << 23) |
			((uint32_t)(input[50] & 0xfe) << 15);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 407 to 422
	value = ((uint32_t)(input[50] & 0x01) << 31) |
			((uint32_t)input[51] << 23) |
			((uint32_t)(input[52] & 0xfe) << 15);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 423 to 438
	value = ((uint32_t)(input[52] & 0x01) << 31) |
			((uint32_t)input[53] << 23) |
			((uint32_t)(input[54] & 0xfe) << 15);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 439 to 454
	value = ((uint32_t)(input[54] & 0x01) << 31) |
			((uint32_t)input[55] << 23) |
			((uint32_t)(input[56] & 0xfe) << 15);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 455 to 470
	value = ((uint32_t)(input[56] & 0x01) << 31) |
			((uint32_t)input[57] << 23) |
			((uint32_t)(input[58] & 0xfe) << 15);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 471 to 486
	value = ((uint32_t)(input[58] & 0x01) << 31) |
			((uint32_t)input[59] << 23) |
			((uint32_t)(input[60] & 0xfe) << 15);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 487 to 502
	value = ((uint32_t)(input[60] & 0x01) << 31) |
			((uint32_t)input[61] << 23) |
			((uint32_t)(input[62] & 0xfe) << 15);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 503 to 518
	value = ((uint32_t)(input[62] & 0x01) << 31) |
			((uint32_t)input[63] << 23) |
			((uint32_t)(input[64] & 0xfe) << 15);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 519 to 534
	value = ((uint32_t)(input[64] & 0x01) << 31) |
			((uint32_t)input[65] << 23) |
			((uint32_t)(input[66] & 0xfe) << 15);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 535 to 550
	value = ((uint32_t)(input[66] & 0x01) << 31) |
			((uint32_t)input[67] << 23) |
			((uint32_t)(input[68] & 0xfe) << 15);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 551 to 566
	value = ((uint32_t)(input[68] & 0x01) << 31) |
			((uint32_t)input[69] << 23) |
			((uint32_t)(input[70] & 0xfe) << 15);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 567 to 582
	value = ((uint32_t)(input[70] & 0x01) << 31) |
			((uint32_t)input[71] << 23) |
			((uint32_t)(input[72] & 0xfe) << 15);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 583 to 598
	value = ((uint32_t)(input[72] & 0x01) << 31) |
			((uint32_t)input[73] << 23) |
			((uint32_t)(input[74] & 0xfe) << 15);
	output[36] = (double)(value >> 16);
}

static void unpack_38_16bit_signed_0off(const uint8_t * input, double * output, void *closure) {
	// Unpack 38 values into output
	// Values are 16-bit signed
	// Skip 0 bits, read 608 bits of data.
	// Input must be at least 76 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 0 to 15
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)input[1] << 16);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 16 to 31
	value = ((uint32_t)input[2] << 24) |
			((uint32_t)input[3] << 16);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 32 to 47
	value = ((uint32_t)input[4] << 24) |
			((uint32_t)input[5] << 16);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 48 to 63
	value = ((uint32_t)input[6] << 24) |
			((uint32_t)input[7] << 16);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 64 to 79
	value = ((uint32_t)input[8] << 24) |
			((uint32_t)input[9] << 16);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 80 to 95
	value = ((uint32_t)input[10] << 24) |
			((uint32_t)input[11] << 16);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 96 to 111
	value = ((uint32_t)input[12] << 24) |
			((uint32_t)input[13] << 16);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 112 to 127
	value = ((uint32_t)input[14] << 24) |
			((uint32_t)input[15] << 16);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 128 to 143
	value = ((uint32_t)input[16] << 24) |
			((uint32_t)input[17] << 16);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 144 to 159
	value = ((uint32_t)input[18] << 24) |
			((uint32_t)input[19] << 16);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 160 to 175
	value = ((uint32_t)input[20] << 24) |
			((uint32_t)input[21] << 16);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 176 to 191
	value = ((uint32_t)input[22] << 24) |
			((uint32_t)input[23] << 16);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 192 to 207
	value = ((uint32_t)input[24] << 24) |
			((uint32_t)input[25] << 16);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 208 to 223
	value = ((uint32_t)input[26] << 24) |
			((uint32_t)input[27] << 16);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 224 to 239
	value = ((uint32_t)input[28] << 24) |
			((uint32_t)input[29] << 16);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 240 to 255
	value = ((uint32_t)input[30] << 24) |
			((uint32_t)input[31] << 16);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 256 to 271
	value = ((uint32_t)input[32] << 24) |
			((uint32_t)input[33] << 16);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 272 to 287
	value = ((uint32_t)input[34] << 24) |
			((uint32_t)input[35] << 16);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 288 to 303
	value = ((uint32_t)input[36] << 24) |
			((uint32_t)input[37] << 16);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 304 to 319
	value = ((uint32_t)input[38] << 24) |
			((uint32_t)input[39] << 16);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 320 to 335
	value = ((uint32_t)input[40] << 24) |
			((uint32_t)input[41] << 16);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 336 to 351
	value = ((uint32_t)input[42] << 24) |
			((uint32_t)input[43] << 16);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 352 to 367
	value = ((uint32_t)input[44] << 24) |
			((uint32_t)input[45] << 16);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 368 to 383
	value = ((uint32_t)input[46] << 24) |
			((uint32_t)input[47] << 16);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 384 to 399
	value = ((uint32_t)input[48] << 24) |
			((uint32_t)input[49] << 16);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 400 to 415
	value = ((uint32_t)input[50] << 24) |
			((uint32_t)input[51] << 16);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 416 to 431
	value = ((uint32_t)input[52] << 24) |
			((uint32_t)input[53] << 16);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 432 to 447
	value = ((uint32_t)input[54] << 24) |
			((uint32_t)input[55] << 16);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 448 to 463
	value = ((uint32_t)input[56] << 24) |
			((uint32_t)input[57] << 16);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 464 to 479
	value = ((uint32_t)input[58] << 24) |
			((uint32_t)input[59] << 16);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 480 to 495
	value = ((uint32_t)input[60] << 24) |
			((uint32_t)input[61] << 16);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 496 to 511
	value = ((uint32_t)input[62] << 24) |
			((uint32_t)input[63] << 16);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 512 to 527
	value = ((uint32_t)input[64] << 24) |
			((uint32_t)input[65] << 16);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 528 to 543
	value = ((uint32_t)input[66] << 24) |
			((uint32_t)input[67] << 16);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 544 to 559
	value = ((uint32_t)input[68] << 24) |
			((uint32_t)input[69] << 16);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 560 to 575
	value = ((uint32_t)input[70] << 24) |
			((uint32_t)input[71] << 16);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 576 to 591
	value = ((uint32_t)input[72] << 24) |
			((uint32_t)input[73] << 16);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 592 to 607
	value = ((uint32_t)input[74] << 24) |
			((uint32_t)input[75] << 16);
	output[37] = (double)(value >> 16);
}

static void unpack_38_16bit_unsigned_0off(const uint8_t * input, double * output, void *closure) {
	// Unpack 38 values into output
	// Values are 16-bit unsigned
	// Skip 0 bits, read 608 bits of data.
	// Input must be at least 76 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 0 to 15
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)input[1] << 16);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 16 to 31
	value = ((uint32_t)input[2] << 24) |
			((uint32_t)input[3] << 16);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 32 to 47
	value = ((uint32_t)input[4] << 24) |
			((uint32_t)input[5] << 16);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 48 to 63
	value = ((uint32_t)input[6] << 24) |
			((uint32_t)input[7] << 16);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 64 to 79
	value = ((uint32_t)input[8] << 24) |
			((uint32_t)input[9] << 16);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 80 to 95
	value = ((uint32_t)input[10] << 24) |
			((uint32_t)input[11] << 16);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 96 to 111
	value = ((uint32_t)input[12] << 24) |
			((uint32_t)input[13] << 16);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 112 to 127
	value = ((uint32_t)input[14] << 24) |
			((uint32_t)input[15] << 16);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 128 to 143
	value = ((uint32_t)input[16] << 24) |
			((uint32_t)input[17] << 16);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 144 to 159
	value = ((uint32_t)input[18] << 24) |
			((uint32_t)input[19] << 16);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 160 to 175
	value = ((uint32_t)input[20] << 24) |
			((uint32_t)input[21] << 16);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 176 to 191
	value = ((uint32_t)input[22] << 24) |
			((uint32_t)input[23] << 16);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 192 to 207
	value = ((uint32_t)input[24] << 24) |
			((uint32_t)input[25] << 16);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 208 to 223
	value = ((uint32_t)input[26] << 24) |
			((uint32_t)input[27] << 16);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 224 to 239
	value = ((uint32_t)input[28] << 24) |
			((uint32_t)input[29] << 16);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 240 to 255
	value = ((uint32_t)input[30] << 24) |
			((uint32_t)input[31] << 16);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 256 to 271
	value = ((uint32_t)input[32] << 24) |
			((uint32_t)input[33] << 16);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 272 to 287
	value = ((uint32_t)input[34] << 24) |
			((uint32_t)input[35] << 16);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 288 to 303
	value = ((uint32_t)input[36] << 24) |
			((uint32_t)input[37] << 16);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 304 to 319
	value = ((uint32_t)input[38] << 24) |
			((uint32_t)input[39] << 16);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 320 to 335
	value = ((uint32_t)input[40] << 24) |
			((uint32_t)input[41] << 16);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 336 to 351
	value = ((uint32_t)input[42] << 24) |
			((uint32_t)input[43] << 16);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 352 to 367
	value = ((uint32_t)input[44] << 24) |
			((uint32_t)input[45] << 16);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 368 to 383
	value = ((uint32_t)input[46] << 24) |
			((uint32_t)input[47] << 16);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 384 to 399
	value = ((uint32_t)input[48] << 24) |
			((uint32_t)input[49] << 16);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 400 to 415
	value = ((uint32_t)input[50] << 24) |
			((uint32_t)input[51] << 16);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 416 to 431
	value = ((uint32_t)input[52] << 24) |
			((uint32_t)input[53] << 16);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 432 to 447
	value = ((uint32_t)input[54] << 24) |
			((uint32_t)input[55] << 16);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 448 to 463
	value = ((uint32_t)input[56] << 24) |
			((uint32_t)input[57] << 16);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 464 to 479
	value = ((uint32_t)input[58] << 24) |
			((uint32_t)input[59] << 16);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 480 to 495
	value = ((uint32_t)input[60] << 24) |
			((uint32_t)input[61] << 16);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 496 to 511
	value = ((uint32_t)input[62] << 24) |
			((uint32_t)input[63] << 16);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 512 to 527
	value = ((uint32_t)input[64] << 24) |
			((uint32_t)input[65] << 16);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 528 to 543
	value = ((uint32_t)input[66] << 24) |
			((uint32_t)input[67] << 16);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 544 to 559
	value = ((uint32_t)input[68] << 24) |
			((uint32_t)input[69] << 16);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 560 to 575
	value = ((uint32_t)input[70] << 24) |
			((uint32_t)input[71] << 16);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 576 to 591
	value = ((uint32_t)input[72] << 24) |
			((uint32_t)input[73] << 16);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 592 to 607
	value = ((uint32_t)input[74] << 24) |
			((uint32_t)input[75] << 16);
	output[37] = (double)(value >> 16);
}

static void unpack_38_16bit_signed_1off(const uint8_t * input, double * output, void *closure) {
	// Unpack 38 values into output
	// Values are 16-bit signed
	// Skip 1 bits, read 608 bits of data.
	// Input must be at least 77 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 1 to 16
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)input[1] << 17) |
			((uint32_t)(input[2] & 0x80) << 9);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 17 to 32
	value = ((uint32_t)(input[2] & 0x7f) << 25) |
			((uint32_t)input[3] << 17) |
			((uint32_t)(input[4] & 0x80) << 9);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 33 to 48
	value = ((uint32_t)(input[4] & 0x7f) << 25) |
			((uint32_t)input[5] << 17) |
			((uint32_t)(input[6] & 0x80) << 9);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 49 to 64
	value = ((uint32_t)(input[6] & 0x7f) << 25) |
			((uint32_t)input[7] << 17) |
			((uint32_t)(input[8] & 0x80) << 9);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 65 to 80
	value = ((uint32_t)(input[8] & 0x7f) << 25) |
			((uint32_t)input[9] << 17) |
			((uint32_t)(input[10] & 0x80) << 9);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 81 to 96
	value = ((uint32_t)(input[10] & 0x7f) << 25) |
			((uint32_t)input[11] << 17) |
			((uint32_t)(input[12] & 0x80) << 9);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 97 to 112
	value = ((uint32_t)(input[12] & 0x7f) << 25) |
			((uint32_t)input[13] << 17) |
			((uint32_t)(input[14] & 0x80) << 9);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 113 to 128
	value = ((uint32_t)(input[14] & 0x7f) << 25) |
			((uint32_t)input[15] << 17) |
			((uint32_t)(input[16] & 0x80) << 9);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 129 to 144
	value = ((uint32_t)(input[16] & 0x7f) << 25) |
			((uint32_t)input[17] << 17) |
			((uint32_t)(input[18] & 0x80) << 9);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 145 to 160
	value = ((uint32_t)(input[18] & 0x7f) << 25) |
			((uint32_t)input[19] << 17) |
			((uint32_t)(input[20] & 0x80) << 9);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 161 to 176
	value = ((uint32_t)(input[20] & 0x7f) << 25) |
			((uint32_t)input[21] << 17) |
			((uint32_t)(input[22] & 0x80) << 9);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 177 to 192
	value = ((uint32_t)(input[22] & 0x7f) << 25) |
			((uint32_t)input[23] << 17) |
			((uint32_t)(input[24] & 0x80) << 9);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 193 to 208
	value = ((uint32_t)(input[24] & 0x7f) << 25) |
			((uint32_t)input[25] << 17) |
			((uint32_t)(input[26] & 0x80) << 9);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 209 to 224
	value = ((uint32_t)(input[26] & 0x7f) << 25) |
			((uint32_t)input[27] << 17) |
			((uint32_t)(input[28] & 0x80) << 9);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 225 to 240
	value = ((uint32_t)(input[28] & 0x7f) << 25) |
			((uint32_t)input[29] << 17) |
			((uint32_t)(input[30] & 0x80) << 9);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 241 to 256
	value = ((uint32_t)(input[30] & 0x7f) << 25) |
			((uint32_t)input[31] << 17) |
			((uint32_t)(input[32] & 0x80) << 9);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 257 to 272
	value = ((uint32_t)(input[32] & 0x7f) << 25) |
			((uint32_t)input[33] << 17) |
			((uint32_t)(input[34] & 0x80) << 9);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 273 to 288
	value = ((uint32_t)(input[34] & 0x7f) << 25) |
			((uint32_t)input[35] << 17) |
			((uint32_t)(input[36] & 0x80) << 9);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 289 to 304
	value = ((uint32_t)(input[36] & 0x7f) << 25) |
			((uint32_t)input[37] << 17) |
			((uint32_t)(input[38] & 0x80) << 9);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 305 to 320
	value = ((uint32_t)(input[38] & 0x7f) << 25) |
			((uint32_t)input[39] << 17) |
			((uint32_t)(input[40] & 0x80) << 9);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 321 to 336
	value = ((uint32_t)(input[40] & 0x7f) << 25) |
			((uint32_t)input[41] << 17) |
			((uint32_t)(input[42] & 0x80) << 9);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 337 to 352
	value = ((uint32_t)(input[42] & 0x7f) << 25) |
			((uint32_t)input[43] << 17) |
			((uint32_t)(input[44] & 0x80) << 9);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 353 to 368
	value = ((uint32_t)(input[44] & 0x7f) << 25) |
			((uint32_t)input[45] << 17) |
			((uint32_t)(input[46] & 0x80) << 9);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 369 to 384
	value = ((uint32_t)(input[46] & 0x7f) << 25) |
			((uint32_t)input[47] << 17) |
			((uint32_t)(input[48] & 0x80) << 9);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 385 to 400
	value = ((uint32_t)(input[48] & 0x7f) << 25) |
			((uint32_t)input[49] << 17) |
			((uint32_t)(input[50] & 0x80) << 9);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 401 to 416
	value = ((uint32_t)(input[50] & 0x7f) << 25) |
			((uint32_t)input[51] << 17) |
			((uint32_t)(input[52] & 0x80) << 9);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 417 to 432
	value = ((uint32_t)(input[52] & 0x7f) << 25) |
			((uint32_t)input[53] << 17) |
			((uint32_t)(input[54] & 0x80) << 9);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 433 to 448
	value = ((uint32_t)(input[54] & 0x7f) << 25) |
			((uint32_t)input[55] << 17) |
			((uint32_t)(input[56] & 0x80) << 9);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 449 to 464
	value = ((uint32_t)(input[56] & 0x7f) << 25) |
			((uint32_t)input[57] << 17) |
			((uint32_t)(input[58] & 0x80) << 9);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 465 to 480
	value = ((uint32_t)(input[58] & 0x7f) << 25) |
			((uint32_t)input[59] << 17) |
			((uint32_t)(input[60] & 0x80) << 9);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 481 to 496
	value = ((uint32_t)(input[60] & 0x7f) << 25) |
			((uint32_t)input[61] << 17) |
			((uint32_t)(input[62] & 0x80) << 9);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 497 to 512
	value = ((uint32_t)(input[62] & 0x7f) << 25) |
			((uint32_t)input[63] << 17) |
			((uint32_t)(input[64] & 0x80) << 9);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 513 to 528
	value = ((uint32_t)(input[64] & 0x7f) << 25) |
			((uint32_t)input[65] << 17) |
			((uint32_t)(input[66] & 0x80) << 9);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 529 to 544
	value = ((uint32_t)(input[66] & 0x7f) << 25) |
			((uint32_t)input[67] << 17) |
			((uint32_t)(input[68] & 0x80) << 9);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 545 to 560
	value = ((uint32_t)(input[68] & 0x7f) << 25) |
			((uint32_t)input[69] << 17) |
			((uint32_t)(input[70] & 0x80) << 9);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 561 to 576
	value = ((uint32_t)(input[70] & 0x7f) << 25) |
			((uint32_t)input[71] << 17) |
			((uint32_t)(input[72] & 0x80) << 9);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 577 to 592
	value = ((uint32_t)(input[72] & 0x7f) << 25) |
			((uint32_t)input[73] << 17) |
			((uint32_t)(input[74] & 0x80) << 9);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 593 to 608
	value = ((uint32_t)(input[74] & 0x7f) << 25) |
			((uint32_t)input[75] << 17) |
			((uint32_t)(input[76] & 0x80) << 9);
	output[37] = (double)(value >> 16);
}

static void unpack_38_16bit_unsigned_1off(const uint8_t * input, double * output, void *closure) {
	// Unpack 38 values into output
	// Values are 16-bit unsigned
	// Skip 1 bits, read 608 bits of data.
	// Input must be at least 77 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 1 to 16
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)input[1] << 17) |
			((uint32_t)(input[2] & 0x80) << 9);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 17 to 32
	value = ((uint32_t)(input[2] & 0x7f) << 25) |
			((uint32_t)input[3] << 17) |
			((uint32_t)(input[4] & 0x80) << 9);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 33 to 48
	value = ((uint32_t)(input[4] & 0x7f) << 25) |
			((uint32_t)input[5] << 17) |
			((uint32_t)(input[6] & 0x80) << 9);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 49 to 64
	value = ((uint32_t)(input[6] & 0x7f) << 25) |
			((uint32_t)input[7] << 17) |
			((uint32_t)(input[8] & 0x80) << 9);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 65 to 80
	value = ((uint32_t)(input[8] & 0x7f) << 25) |
			((uint32_t)input[9] << 17) |
			((uint32_t)(input[10] & 0x80) << 9);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 81 to 96
	value = ((uint32_t)(input[10] & 0x7f) << 25) |
			((uint32_t)input[11] << 17) |
			((uint32_t)(input[12] & 0x80) << 9);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 97 to 112
	value = ((uint32_t)(input[12] & 0x7f) << 25) |
			((uint32_t)input[13] << 17) |
			((uint32_t)(input[14] & 0x80) << 9);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 113 to 128
	value = ((uint32_t)(input[14] & 0x7f) << 25) |
			((uint32_t)input[15] << 17) |
			((uint32_t)(input[16] & 0x80) << 9);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 129 to 144
	value = ((uint32_t)(input[16] & 0x7f) << 25) |
			((uint32_t)input[17] << 17) |
			((uint32_t)(input[18] & 0x80) << 9);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 145 to 160
	value = ((uint32_t)(input[18] & 0x7f) << 25) |
			((uint32_t)input[19] << 17) |
			((uint32_t)(input[20] & 0x80) << 9);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 161 to 176
	value = ((uint32_t)(input[20] & 0x7f) << 25) |
			((uint32_t)input[21] << 17) |
			((uint32_t)(input[22] & 0x80) << 9);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 177 to 192
	value = ((uint32_t)(input[22] & 0x7f) << 25) |
			((uint32_t)input[23] << 17) |
			((uint32_t)(input[24] & 0x80) << 9);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 193 to 208
	value = ((uint32_t)(input[24] & 0x7f) << 25) |
			((uint32_t)input[25] << 17) |
			((uint32_t)(input[26] & 0x80) << 9);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 209 to 224
	value = ((uint32_t)(input[26] & 0x7f) << 25) |
			((uint32_t)input[27] << 17) |
			((uint32_t)(input[28] & 0x80) << 9);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 225 to 240
	value = ((uint32_t)(input[28] & 0x7f) << 25) |
			((uint32_t)input[29] << 17) |
			((uint32_t)(input[30] & 0x80) << 9);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 241 to 256
	value = ((uint32_t)(input[30] & 0x7f) << 25) |
			((uint32_t)input[31] << 17) |
			((uint32_t)(input[32] & 0x80) << 9);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 257 to 272
	value = ((uint32_t)(input[32] & 0x7f) << 25) |
			((uint32_t)input[33] << 17) |
			((uint32_t)(input[34] & 0x80) << 9);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 273 to 288
	value = ((uint32_t)(input[34] & 0x7f) << 25) |
			((uint32_t)input[35] << 17) |
			((uint32_t)(input[36] & 0x80) << 9);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 289 to 304
	value = ((uint32_t)(input[36] & 0x7f) << 25) |
			((uint32_t)input[37] << 17) |
			((uint32_t)(input[38] & 0x80) << 9);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 305 to 320
	value = ((uint32_t)(input[38] & 0x7f) << 25) |
			((uint32_t)input[39] << 17) |
			((uint32_t)(input[40] & 0x80) << 9);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 321 to 336
	value = ((uint32_t)(input[40] & 0x7f) << 25) |
			((uint32_t)input[41] << 17) |
			((uint32_t)(input[42] & 0x80) << 9);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 337 to 352
	value = ((uint32_t)(input[42] & 0x7f) << 25) |
			((uint32_t)input[43] << 17) |
			((uint32_t)(input[44] & 0x80) << 9);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 353 to 368
	value = ((uint32_t)(input[44] & 0x7f) << 25) |
			((uint32_t)input[45] << 17) |
			((uint32_t)(input[46] & 0x80) << 9);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 369 to 384
	value = ((uint32_t)(input[46] & 0x7f) << 25) |
			((uint32_t)input[47] << 17) |
			((uint32_t)(input[48] & 0x80) << 9);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 385 to 400
	value = ((uint32_t)(input[48] & 0x7f) << 25) |
			((uint32_t)input[49] << 17) |
			((uint32_t)(input[50] & 0x80) << 9);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 401 to 416
	value = ((uint32_t)(input[50] & 0x7f) << 25) |
			((uint32_t)input[51] << 17) |
			((uint32_t)(input[52] & 0x80) << 9);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 417 to 432
	value = ((uint32_t)(input[52] & 0x7f) << 25) |
			((uint32_t)input[53] << 17) |
			((uint32_t)(input[54] & 0x80) << 9);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 433 to 448
	value = ((uint32_t)(input[54] & 0x7f) << 25) |
			((uint32_t)input[55] << 17) |
			((uint32_t)(input[56] & 0x80) << 9);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 449 to 464
	value = ((uint32_t)(input[56] & 0x7f) << 25) |
			((uint32_t)input[57] << 17) |
			((uint32_t)(input[58] & 0x80) << 9);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 465 to 480
	value = ((uint32_t)(input[58] & 0x7f) << 25) |
			((uint32_t)input[59] << 17) |
			((uint32_t)(input[60] & 0x80) << 9);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 481 to 496
	value = ((uint32_t)(input[60] & 0x7f) << 25) |
			((uint32_t)input[61] << 17) |
			((uint32_t)(input[62] & 0x80) << 9);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 497 to 512
	value = ((uint32_t)(input[62] & 0x7f) << 25) |
			((uint32_t)input[63] << 17) |
			((uint32_t)(input[64] & 0x80) << 9);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 513 to 528
	value = ((uint32_t)(input[64] & 0x7f) << 25) |
			((uint32_t)input[65] << 17) |
			((uint32_t)(input[66] & 0x80) << 9);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 529 to 544
	value = ((uint32_t)(input[66] & 0x7f) << 25) |
			((uint32_t)input[67] << 17) |
			((uint32_t)(input[68] & 0x80) << 9);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 545 to 560
	value = ((uint32_t)(input[68] & 0x7f) << 25) |
			((uint32_t)input[69] << 17) |
			((uint32_t)(input[70] & 0x80) << 9);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 561 to 576
	value = ((uint32_t)(input[70] & 0x7f) << 25) |
			((uint32_t)input[71] << 17) |
			((uint32_t)(input[72] & 0x80) << 9);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 577 to 592
	value = ((uint32_t)(input[72] & 0x7f) << 25) |
			((uint32_t)input[73] << 17) |
			((uint32_t)(input[74] & 0x80) << 9);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 593 to 608
	value = ((uint32_t)(input[74] & 0x7f) << 25) |
			((uint32_t)input[75] << 17) |
			((uint32_t)(input[76] & 0x80) << 9);
	output[37] = (double)(value >> 16);
}

static void unpack_38_16bit_signed_2off(const uint8_t * input, double * output, void *closure) {
	// Unpack 38 values into output
	// Values are 16-bit signed
	// Skip 2 bits, read 608 bits of data.
	// Input must be at least 77 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 2 to 17
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)input[1] << 18) |
			((uint32_t)(input[2] & 0xc0) << 10);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 18 to 33
	value = ((uint32_t)(input[2] & 0x3f) << 26) |
			((uint32_t)input[3] << 18) |
			((uint32_t)(input[4] & 0xc0) << 10);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 34 to 49
	value = ((uint32_t)(input[4] & 0x3f) << 26) |
			((uint32_t)input[5] << 18) |
			((uint32_t)(input[6] & 0xc0) << 10);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 50 to 65
	value = ((uint32_t)(input[6] & 0x3f) << 26) |
			((uint32_t)input[7] << 18) |
			((uint32_t)(input[8] & 0xc0) << 10);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 66 to 81
	value = ((uint32_t)(input[8] & 0x3f) << 26) |
			((uint32_t)input[9] << 18) |
			((uint32_t)(input[10] & 0xc0) << 10);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 82 to 97
	value = ((uint32_t)(input[10] & 0x3f) << 26) |
			((uint32_t)input[11] << 18) |
			((uint32_t)(input[12] & 0xc0) << 10);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 98 to 113
	value = ((uint32_t)(input[12] & 0x3f) << 26) |
			((uint32_t)input[13] << 18) |
			((uint32_t)(input[14] & 0xc0) << 10);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 114 to 129
	value = ((uint32_t)(input[14] & 0x3f) << 26) |
			((uint32_t)input[15] << 18) |
			((uint32_t)(input[16] & 0xc0) << 10);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 130 to 145
	value = ((uint32_t)(input[16] & 0x3f) << 26) |
			((uint32_t)input[17] << 18) |
			((uint32_t)(input[18] & 0xc0) << 10);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 146 to 161
	value = ((uint32_t)(input[18] & 0x3f) << 26) |
			((uint32_t)input[19] << 18) |
			((uint32_t)(input[20] & 0xc0) << 10);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 162 to 177
	value = ((uint32_t)(input[20] & 0x3f) << 26) |
			((uint32_t)input[21] << 18) |
			((uint32_t)(input[22] & 0xc0) << 10);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 178 to 193
	value = ((uint32_t)(input[22] & 0x3f) << 26) |
			((uint32_t)input[23] << 18) |
			((uint32_t)(input[24] & 0xc0) << 10);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 194 to 209
	value = ((uint32_t)(input[24] & 0x3f) << 26) |
			((uint32_t)input[25] << 18) |
			((uint32_t)(input[26] & 0xc0) << 10);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 210 to 225
	value = ((uint32_t)(input[26] & 0x3f) << 26) |
			((uint32_t)input[27] << 18) |
			((uint32_t)(input[28] & 0xc0) << 10);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 226 to 241
	value = ((uint32_t)(input[28] & 0x3f) << 26) |
			((uint32_t)input[29] << 18) |
			((uint32_t)(input[30] & 0xc0) << 10);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 242 to 257
	value = ((uint32_t)(input[30] & 0x3f) << 26) |
			((uint32_t)input[31] << 18) |
			((uint32_t)(input[32] & 0xc0) << 10);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 258 to 273
	value = ((uint32_t)(input[32] & 0x3f) << 26) |
			((uint32_t)input[33] << 18) |
			((uint32_t)(input[34] & 0xc0) << 10);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 274 to 289
	value = ((uint32_t)(input[34] & 0x3f) << 26) |
			((uint32_t)input[35] << 18) |
			((uint32_t)(input[36] & 0xc0) << 10);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 290 to 305
	value = ((uint32_t)(input[36] & 0x3f) << 26) |
			((uint32_t)input[37] << 18) |
			((uint32_t)(input[38] & 0xc0) << 10);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 306 to 321
	value = ((uint32_t)(input[38] & 0x3f) << 26) |
			((uint32_t)input[39] << 18) |
			((uint32_t)(input[40] & 0xc0) << 10);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 322 to 337
	value = ((uint32_t)(input[40] & 0x3f) << 26) |
			((uint32_t)input[41] << 18) |
			((uint32_t)(input[42] & 0xc0) << 10);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 338 to 353
	value = ((uint32_t)(input[42] & 0x3f) << 26) |
			((uint32_t)input[43] << 18) |
			((uint32_t)(input[44] & 0xc0) << 10);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 354 to 369
	value = ((uint32_t)(input[44] & 0x3f) << 26) |
			((uint32_t)input[45] << 18) |
			((uint32_t)(input[46] & 0xc0) << 10);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 370 to 385
	value = ((uint32_t)(input[46] & 0x3f) << 26) |
			((uint32_t)input[47] << 18) |
			((uint32_t)(input[48] & 0xc0) << 10);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 386 to 401
	value = ((uint32_t)(input[48] & 0x3f) << 26) |
			((uint32_t)input[49] << 18) |
			((uint32_t)(input[50] & 0xc0) << 10);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 402 to 417
	value = ((uint32_t)(input[50] & 0x3f) << 26) |
			((uint32_t)input[51] << 18) |
			((uint32_t)(input[52] & 0xc0) << 10);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 418 to 433
	value = ((uint32_t)(input[52] & 0x3f) << 26) |
			((uint32_t)input[53] << 18) |
			((uint32_t)(input[54] & 0xc0) << 10);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 434 to 449
	value = ((uint32_t)(input[54] & 0x3f) << 26) |
			((uint32_t)input[55] << 18) |
			((uint32_t)(input[56] & 0xc0) << 10);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 450 to 465
	value = ((uint32_t)(input[56] & 0x3f) << 26) |
			((uint32_t)input[57] << 18) |
			((uint32_t)(input[58] & 0xc0) << 10);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 466 to 481
	value = ((uint32_t)(input[58] & 0x3f) << 26) |
			((uint32_t)input[59] << 18) |
			((uint32_t)(input[60] & 0xc0) << 10);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 482 to 497
	value = ((uint32_t)(input[60] & 0x3f) << 26) |
			((uint32_t)input[61] << 18) |
			((uint32_t)(input[62] & 0xc0) << 10);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 498 to 513
	value = ((uint32_t)(input[62] & 0x3f) << 26) |
			((uint32_t)input[63] << 18) |
			((uint32_t)(input[64] & 0xc0) << 10);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 514 to 529
	value = ((uint32_t)(input[64] & 0x3f) << 26) |
			((uint32_t)input[65] << 18) |
			((uint32_t)(input[66] & 0xc0) << 10);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 530 to 545
	value = ((uint32_t)(input[66] & 0x3f) << 26) |
			((uint32_t)input[67] << 18) |
			((uint32_t)(input[68] & 0xc0) << 10);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 546 to 561
	value = ((uint32_t)(input[68] & 0x3f) << 26) |
			((uint32_t)input[69] << 18) |
			((uint32_t)(input[70] & 0xc0) << 10);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 562 to 577
	value = ((uint32_t)(input[70] & 0x3f) << 26) |
			((uint32_t)input[71] << 18) |
			((uint32_t)(input[72] & 0xc0) << 10);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 578 to 593
	value = ((uint32_t)(input[72] & 0x3f) << 26) |
			((uint32_t)input[73] << 18) |
			((uint32_t)(input[74] & 0xc0) << 10);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 594 to 609
	value = ((uint32_t)(input[74] & 0x3f) << 26) |
			((uint32_t)input[75] << 18) |
			((uint32_t)(input[76] & 0xc0) << 10);
	output[37] = (double)(value >> 16);
}

static void unpack_38_16bit_unsigned_2off(const uint8_t * input, double * output, void *closure) {
	// Unpack 38 values into output
	// Values are 16-bit unsigned
	// Skip 2 bits, read 608 bits of data.
	// Input must be at least 77 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 2 to 17
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)input[1] << 18) |
			((uint32_t)(input[2] & 0xc0) << 10);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 18 to 33
	value = ((uint32_t)(input[2] & 0x3f) << 26) |
			((uint32_t)input[3] << 18) |
			((uint32_t)(input[4] & 0xc0) << 10);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 34 to 49
	value = ((uint32_t)(input[4] & 0x3f) << 26) |
			((uint32_t)input[5] << 18) |
			((uint32_t)(input[6] & 0xc0) << 10);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 50 to 65
	value = ((uint32_t)(input[6] & 0x3f) << 26) |
			((uint32_t)input[7] << 18) |
			((uint32_t)(input[8] & 0xc0) << 10);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 66 to 81
	value = ((uint32_t)(input[8] & 0x3f) << 26) |
			((uint32_t)input[9] << 18) |
			((uint32_t)(input[10] & 0xc0) << 10);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 82 to 97
	value = ((uint32_t)(input[10] & 0x3f) << 26) |
			((uint32_t)input[11] << 18) |
			((uint32_t)(input[12] & 0xc0) << 10);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 98 to 113
	value = ((uint32_t)(input[12] & 0x3f) << 26) |
			((uint32_t)input[13] << 18) |
			((uint32_t)(input[14] & 0xc0) << 10);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 114 to 129
	value = ((uint32_t)(input[14] & 0x3f) << 26) |
			((uint32_t)input[15] << 18) |
			((uint32_t)(input[16] & 0xc0) << 10);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 130 to 145
	value = ((uint32_t)(input[16] & 0x3f) << 26) |
			((uint32_t)input[17] << 18) |
			((uint32_t)(input[18] & 0xc0) << 10);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 146 to 161
	value = ((uint32_t)(input[18] & 0x3f) << 26) |
			((uint32_t)input[19] << 18) |
			((uint32_t)(input[20] & 0xc0) << 10);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 162 to 177
	value = ((uint32_t)(input[20] & 0x3f) << 26) |
			((uint32_t)input[21] << 18) |
			((uint32_t)(input[22] & 0xc0) << 10);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 178 to 193
	value = ((uint32_t)(input[22] & 0x3f) << 26) |
			((uint32_t)input[23] << 18) |
			((uint32_t)(input[24] & 0xc0) << 10);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 194 to 209
	value = ((uint32_t)(input[24] & 0x3f) << 26) |
			((uint32_t)input[25] << 18) |
			((uint32_t)(input[26] & 0xc0) << 10);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 210 to 225
	value = ((uint32_t)(input[26] & 0x3f) << 26) |
			((uint32_t)input[27] << 18) |
			((uint32_t)(input[28] & 0xc0) << 10);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 226 to 241
	value = ((uint32_t)(input[28] & 0x3f) << 26) |
			((uint32_t)input[29] << 18) |
			((uint32_t)(input[30] & 0xc0) << 10);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 242 to 257
	value = ((uint32_t)(input[30] & 0x3f) << 26) |
			((uint32_t)input[31] << 18) |
			((uint32_t)(input[32] & 0xc0) << 10);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 258 to 273
	value = ((uint32_t)(input[32] & 0x3f) << 26) |
			((uint32_t)input[33] << 18) |
			((uint32_t)(input[34] & 0xc0) << 10);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 274 to 289
	value = ((uint32_t)(input[34] & 0x3f) << 26) |
			((uint32_t)input[35] << 18) |
			((uint32_t)(input[36] & 0xc0) << 10);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 290 to 305
	value = ((uint32_t)(input[36] & 0x3f) << 26) |
			((uint32_t)input[37] << 18) |
			((uint32_t)(input[38] & 0xc0) << 10);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 306 to 321
	value = ((uint32_t)(input[38] & 0x3f) << 26) |
			((uint32_t)input[39] << 18) |
			((uint32_t)(input[40] & 0xc0) << 10);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 322 to 337
	value = ((uint32_t)(input[40] & 0x3f) << 26) |
			((uint32_t)input[41] << 18) |
			((uint32_t)(input[42] & 0xc0) << 10);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 338 to 353
	value = ((uint32_t)(input[42] & 0x3f) << 26) |
			((uint32_t)input[43] << 18) |
			((uint32_t)(input[44] & 0xc0) << 10);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 354 to 369
	value = ((uint32_t)(input[44] & 0x3f) << 26) |
			((uint32_t)input[45] << 18) |
			((uint32_t)(input[46] & 0xc0) << 10);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 370 to 385
	value = ((uint32_t)(input[46] & 0x3f) << 26) |
			((uint32_t)input[47] << 18) |
			((uint32_t)(input[48] & 0xc0) << 10);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 386 to 401
	value = ((uint32_t)(input[48] & 0x3f) << 26) |
			((uint32_t)input[49] << 18) |
			((uint32_t)(input[50] & 0xc0) << 10);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 402 to 417
	value = ((uint32_t)(input[50] & 0x3f) << 26) |
			((uint32_t)input[51] << 18) |
			((uint32_t)(input[52] & 0xc0) << 10);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 418 to 433
	value = ((uint32_t)(input[52] & 0x3f) << 26) |
			((uint32_t)input[53] << 18) |
			((uint32_t)(input[54] & 0xc0) << 10);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 434 to 449
	value = ((uint32_t)(input[54] & 0x3f) << 26) |
			((uint32_t)input[55] << 18) |
			((uint32_t)(input[56] & 0xc0) << 10);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 450 to 465
	value = ((uint32_t)(input[56] & 0x3f) << 26) |
			((uint32_t)input[57] << 18) |
			((uint32_t)(input[58] & 0xc0) << 10);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 466 to 481
	value = ((uint32_t)(input[58] & 0x3f) << 26) |
			((uint32_t)input[59] << 18) |
			((uint32_t)(input[60] & 0xc0) << 10);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 482 to 497
	value = ((uint32_t)(input[60] & 0x3f) << 26) |
			((uint32_t)input[61] << 18) |
			((uint32_t)(input[62] & 0xc0) << 10);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 498 to 513
	value = ((uint32_t)(input[62] & 0x3f) << 26) |
			((uint32_t)input[63] << 18) |
			((uint32_t)(input[64] & 0xc0) << 10);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 514 to 529
	value = ((uint32_t)(input[64] & 0x3f) << 26) |
			((uint32_t)input[65] << 18) |
			((uint32_t)(input[66] & 0xc0) << 10);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 530 to 545
	value = ((uint32_t)(input[66] & 0x3f) << 26) |
			((uint32_t)input[67] << 18) |
			((uint32_t)(input[68] & 0xc0) << 10);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 546 to 561
	value = ((uint32_t)(input[68] & 0x3f) << 26) |
			((uint32_t)input[69] << 18) |
			((uint32_t)(input[70] & 0xc0) << 10);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 562 to 577
	value = ((uint32_t)(input[70] & 0x3f) << 26) |
			((uint32_t)input[71] << 18) |
			((uint32_t)(input[72] & 0xc0) << 10);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 578 to 593
	value = ((uint32_t)(input[72] & 0x3f) << 26) |
			((uint32_t)input[73] << 18) |
			((uint32_t)(input[74] & 0xc0) << 10);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 594 to 609
	value = ((uint32_t)(input[74] & 0x3f) << 26) |
			((uint32_t)input[75] << 18) |
			((uint32_t)(input[76] & 0xc0) << 10);
	output[37] = (double)(value >> 16);
}

static void unpack_38_16bit_signed_3off(const uint8_t * input, double * output, void *closure) {
	// Unpack 38 values into output
	// Values are 16-bit signed
	// Skip 3 bits, read 608 bits of data.
	// Input must be at least 77 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 3 to 18
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)input[1] << 19) |
			((uint32_t)(input[2] & 0xe0) << 11);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 19 to 34
	value = ((uint32_t)(input[2] & 0x1f) << 27) |
			((uint32_t)input[3] << 19) |
			((uint32_t)(input[4] & 0xe0) << 11);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 35 to 50
	value = ((uint32_t)(input[4] & 0x1f) << 27) |
			((uint32_t)input[5] << 19) |
			((uint32_t)(input[6] & 0xe0) << 11);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 51 to 66
	value = ((uint32_t)(input[6] & 0x1f) << 27) |
			((uint32_t)input[7] << 19) |
			((uint32_t)(input[8] & 0xe0) << 11);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 67 to 82
	value = ((uint32_t)(input[8] & 0x1f) << 27) |
			((uint32_t)input[9] << 19) |
			((uint32_t)(input[10] & 0xe0) << 11);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 83 to 98
	value = ((uint32_t)(input[10] & 0x1f) << 27) |
			((uint32_t)input[11] << 19) |
			((uint32_t)(input[12] & 0xe0) << 11);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 99 to 114
	value = ((uint32_t)(input[12] & 0x1f) << 27) |
			((uint32_t)input[13] << 19) |
			((uint32_t)(input[14] & 0xe0) << 11);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 115 to 130
	value = ((uint32_t)(input[14] & 0x1f) << 27) |
			((uint32_t)input[15] << 19) |
			((uint32_t)(input[16] & 0xe0) << 11);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 131 to 146
	value = ((uint32_t)(input[16] & 0x1f) << 27) |
			((uint32_t)input[17] << 19) |
			((uint32_t)(input[18] & 0xe0) << 11);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 147 to 162
	value = ((uint32_t)(input[18] & 0x1f) << 27) |
			((uint32_t)input[19] << 19) |
			((uint32_t)(input[20] & 0xe0) << 11);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 163 to 178
	value = ((uint32_t)(input[20] & 0x1f) << 27) |
			((uint32_t)input[21] << 19) |
			((uint32_t)(input[22] & 0xe0) << 11);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 179 to 194
	value = ((uint32_t)(input[22] & 0x1f) << 27) |
			((uint32_t)input[23] << 19) |
			((uint32_t)(input[24] & 0xe0) << 11);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 195 to 210
	value = ((uint32_t)(input[24] & 0x1f) << 27) |
			((uint32_t)input[25] << 19) |
			((uint32_t)(input[26] & 0xe0) << 11);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 211 to 226
	value = ((uint32_t)(input[26] & 0x1f) << 27) |
			((uint32_t)input[27] << 19) |
			((uint32_t)(input[28] & 0xe0) << 11);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 227 to 242
	value = ((uint32_t)(input[28] & 0x1f) << 27) |
			((uint32_t)input[29] << 19) |
			((uint32_t)(input[30] & 0xe0) << 11);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 243 to 258
	value = ((uint32_t)(input[30] & 0x1f) << 27) |
			((uint32_t)input[31] << 19) |
			((uint32_t)(input[32] & 0xe0) << 11);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 259 to 274
	value = ((uint32_t)(input[32] & 0x1f) << 27) |
			((uint32_t)input[33] << 19) |
			((uint32_t)(input[34] & 0xe0) << 11);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 275 to 290
	value = ((uint32_t)(input[34] & 0x1f) << 27) |
			((uint32_t)input[35] << 19) |
			((uint32_t)(input[36] & 0xe0) << 11);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 291 to 306
	value = ((uint32_t)(input[36] & 0x1f) << 27) |
			((uint32_t)input[37] << 19) |
			((uint32_t)(input[38] & 0xe0) << 11);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 307 to 322
	value = ((uint32_t)(input[38] & 0x1f) << 27) |
			((uint32_t)input[39] << 19) |
			((uint32_t)(input[40] & 0xe0) << 11);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 323 to 338
	value = ((uint32_t)(input[40] & 0x1f) << 27) |
			((uint32_t)input[41] << 19) |
			((uint32_t)(input[42] & 0xe0) << 11);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 339 to 354
	value = ((uint32_t)(input[42] & 0x1f) << 27) |
			((uint32_t)input[43] << 19) |
			((uint32_t)(input[44] & 0xe0) << 11);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 355 to 370
	value = ((uint32_t)(input[44] & 0x1f) << 27) |
			((uint32_t)input[45] << 19) |
			((uint32_t)(input[46] & 0xe0) << 11);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 371 to 386
	value = ((uint32_t)(input[46] & 0x1f) << 27) |
			((uint32_t)input[47] << 19) |
			((uint32_t)(input[48] & 0xe0) << 11);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 387 to 402
	value = ((uint32_t)(input[48] & 0x1f) << 27) |
			((uint32_t)input[49] << 19) |
			((uint32_t)(input[50] & 0xe0) << 11);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 403 to 418
	value = ((uint32_t)(input[50] & 0x1f) << 27) |
			((uint32_t)input[51] << 19) |
			((uint32_t)(input[52] & 0xe0) << 11);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 419 to 434
	value = ((uint32_t)(input[52] & 0x1f) << 27) |
			((uint32_t)input[53] << 19) |
			((uint32_t)(input[54] & 0xe0) << 11);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 435 to 450
	value = ((uint32_t)(input[54] & 0x1f) << 27) |
			((uint32_t)input[55] << 19) |
			((uint32_t)(input[56] & 0xe0) << 11);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 451 to 466
	value = ((uint32_t)(input[56] & 0x1f) << 27) |
			((uint32_t)input[57] << 19) |
			((uint32_t)(input[58] & 0xe0) << 11);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 467 to 482
	value = ((uint32_t)(input[58] & 0x1f) << 27) |
			((uint32_t)input[59] << 19) |
			((uint32_t)(input[60] & 0xe0) << 11);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 483 to 498
	value = ((uint32_t)(input[60] & 0x1f) << 27) |
			((uint32_t)input[61] << 19) |
			((uint32_t)(input[62] & 0xe0) << 11);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 499 to 514
	value = ((uint32_t)(input[62] & 0x1f) << 27) |
			((uint32_t)input[63] << 19) |
			((uint32_t)(input[64] & 0xe0) << 11);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 515 to 530
	value = ((uint32_t)(input[64] & 0x1f) << 27) |
			((uint32_t)input[65] << 19) |
			((uint32_t)(input[66] & 0xe0) << 11);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 531 to 546
	value = ((uint32_t)(input[66] & 0x1f) << 27) |
			((uint32_t)input[67] << 19) |
			((uint32_t)(input[68] & 0xe0) << 11);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 547 to 562
	value = ((uint32_t)(input[68] & 0x1f) << 27) |
			((uint32_t)input[69] << 19) |
			((uint32_t)(input[70] & 0xe0) << 11);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 563 to 578
	value = ((uint32_t)(input[70] & 0x1f) << 27) |
			((uint32_t)input[71] << 19) |
			((uint32_t)(input[72] & 0xe0) << 11);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 579 to 594
	value = ((uint32_t)(input[72] & 0x1f) << 27) |
			((uint32_t)input[73] << 19) |
			((uint32_t)(input[74] & 0xe0) << 11);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 595 to 610
	value = ((uint32_t)(input[74] & 0x1f) << 27) |
			((uint32_t)input[75] << 19) |
			((uint32_t)(input[76] & 0xe0) << 11);
	output[37] = (double)(value >> 16);
}

static void unpack_38_16bit_unsigned_3off(const uint8_t * input, double * output, void *closure) {
	// Unpack 38 values into output
	// Values are 16-bit unsigned
	// Skip 3 bits, read 608 bits of data.
	// Input must be at least 77 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 3 to 18
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)input[1] << 19) |
			((uint32_t)(input[2] & 0xe0) << 11);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 19 to 34
	value = ((uint32_t)(input[2] & 0x1f) << 27) |
			((uint32_t)input[3] << 19) |
			((uint32_t)(input[4] & 0xe0) << 11);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 35 to 50
	value = ((uint32_t)(input[4] & 0x1f) << 27) |
			((uint32_t)input[5] << 19) |
			((uint32_t)(input[6] & 0xe0) << 11);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 51 to 66
	value = ((uint32_t)(input[6] & 0x1f) << 27) |
			((uint32_t)input[7] << 19) |
			((uint32_t)(input[8] & 0xe0) << 11);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 67 to 82
	value = ((uint32_t)(input[8] & 0x1f) << 27) |
			((uint32_t)input[9] << 19) |
			((uint32_t)(input[10] & 0xe0) << 11);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 83 to 98
	value = ((uint32_t)(input[10] & 0x1f) << 27) |
			((uint32_t)input[11] << 19) |
			((uint32_t)(input[12] & 0xe0) << 11);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 99 to 114
	value = ((uint32_t)(input[12] & 0x1f) << 27) |
			((uint32_t)input[13] << 19) |
			((uint32_t)(input[14] & 0xe0) << 11);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 115 to 130
	value = ((uint32_t)(input[14] & 0x1f) << 27) |
			((uint32_t)input[15] << 19) |
			((uint32_t)(input[16] & 0xe0) << 11);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 131 to 146
	value = ((uint32_t)(input[16] & 0x1f) << 27) |
			((uint32_t)input[17] << 19) |
			((uint32_t)(input[18] & 0xe0) << 11);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 147 to 162
	value = ((uint32_t)(input[18] & 0x1f) << 27) |
			((uint32_t)input[19] << 19) |
			((uint32_t)(input[20] & 0xe0) << 11);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 163 to 178
	value = ((uint32_t)(input[20] & 0x1f) << 27) |
			((uint32_t)input[21] << 19) |
			((uint32_t)(input[22] & 0xe0) << 11);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 179 to 194
	value = ((uint32_t)(input[22] & 0x1f) << 27) |
			((uint32_t)input[23] << 19) |
			((uint32_t)(input[24] & 0xe0) << 11);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 195 to 210
	value = ((uint32_t)(input[24] & 0x1f) << 27) |
			((uint32_t)input[25] << 19) |
			((uint32_t)(input[26] & 0xe0) << 11);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 211 to 226
	value = ((uint32_t)(input[26] & 0x1f) << 27) |
			((uint32_t)input[27] << 19) |
			((uint32_t)(input[28] & 0xe0) << 11);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 227 to 242
	value = ((uint32_t)(input[28] & 0x1f) << 27) |
			((uint32_t)input[29] << 19) |
			((uint32_t)(input[30] & 0xe0) << 11);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 243 to 258
	value = ((uint32_t)(input[30] & 0x1f) << 27) |
			((uint32_t)input[31] << 19) |
			((uint32_t)(input[32] & 0xe0) << 11);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 259 to 274
	value = ((uint32_t)(input[32] & 0x1f) << 27) |
			((uint32_t)input[33] << 19) |
			((uint32_t)(input[34] & 0xe0) << 11);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 275 to 290
	value = ((uint32_t)(input[34] & 0x1f) << 27) |
			((uint32_t)input[35] << 19) |
			((uint32_t)(input[36] & 0xe0) << 11);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 291 to 306
	value = ((uint32_t)(input[36] & 0x1f) << 27) |
			((uint32_t)input[37] << 19) |
			((uint32_t)(input[38] & 0xe0) << 11);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 307 to 322
	value = ((uint32_t)(input[38] & 0x1f) << 27) |
			((uint32_t)input[39] << 19) |
			((uint32_t)(input[40] & 0xe0) << 11);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 323 to 338
	value = ((uint32_t)(input[40] & 0x1f) << 27) |
			((uint32_t)input[41] << 19) |
			((uint32_t)(input[42] & 0xe0) << 11);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 339 to 354
	value = ((uint32_t)(input[42] & 0x1f) << 27) |
			((uint32_t)input[43] << 19) |
			((uint32_t)(input[44] & 0xe0) << 11);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 355 to 370
	value = ((uint32_t)(input[44] & 0x1f) << 27) |
			((uint32_t)input[45] << 19) |
			((uint32_t)(input[46] & 0xe0) << 11);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 371 to 386
	value = ((uint32_t)(input[46] & 0x1f) << 27) |
			((uint32_t)input[47] << 19) |
			((uint32_t)(input[48] & 0xe0) << 11);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 387 to 402
	value = ((uint32_t)(input[48] & 0x1f) << 27) |
			((uint32_t)input[49] << 19) |
			((uint32_t)(input[50] & 0xe0) << 11);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 403 to 418
	value = ((uint32_t)(input[50] & 0x1f) << 27) |
			((uint32_t)input[51] << 19) |
			((uint32_t)(input[52] & 0xe0) << 11);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 419 to 434
	value = ((uint32_t)(input[52] & 0x1f) << 27) |
			((uint32_t)input[53] << 19) |
			((uint32_t)(input[54] & 0xe0) << 11);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 435 to 450
	value = ((uint32_t)(input[54] & 0x1f) << 27) |
			((uint32_t)input[55] << 19) |
			((uint32_t)(input[56] & 0xe0) << 11);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 451 to 466
	value = ((uint32_t)(input[56] & 0x1f) << 27) |
			((uint32_t)input[57] << 19) |
			((uint32_t)(input[58] & 0xe0) << 11);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 467 to 482
	value = ((uint32_t)(input[58] & 0x1f) << 27) |
			((uint32_t)input[59] << 19) |
			((uint32_t)(input[60] & 0xe0) << 11);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 483 to 498
	value = ((uint32_t)(input[60] & 0x1f) << 27) |
			((uint32_t)input[61] << 19) |
			((uint32_t)(input[62] & 0xe0) << 11);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 499 to 514
	value = ((uint32_t)(input[62] & 0x1f) << 27) |
			((uint32_t)input[63] << 19) |
			((uint32_t)(input[64] & 0xe0) << 11);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 515 to 530
	value = ((uint32_t)(input[64] & 0x1f) << 27) |
			((uint32_t)input[65] << 19) |
			((uint32_t)(input[66] & 0xe0) << 11);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 531 to 546
	value = ((uint32_t)(input[66] & 0x1f) << 27) |
			((uint32_t)input[67] << 19) |
			((uint32_t)(input[68] & 0xe0) << 11);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 547 to 562
	value = ((uint32_t)(input[68] & 0x1f) << 27) |
			((uint32_t)input[69] << 19) |
			((uint32_t)(input[70] & 0xe0) << 11);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 563 to 578
	value = ((uint32_t)(input[70] & 0x1f) << 27) |
			((uint32_t)input[71] << 19) |
			((uint32_t)(input[72] & 0xe0) << 11);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 579 to 594
	value = ((uint32_t)(input[72] & 0x1f) << 27) |
			((uint32_t)input[73] << 19) |
			((uint32_t)(input[74] & 0xe0) << 11);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 595 to 610
	value = ((uint32_t)(input[74] & 0x1f) << 27) |
			((uint32_t)input[75] << 19) |
			((uint32_t)(input[76] & 0xe0) << 11);
	output[37] = (double)(value >> 16);
}

static void unpack_38_16bit_signed_4off(const uint8_t * input, double * output, void *closure) {
	// Unpack 38 values into output
	// Values are 16-bit signed
	// Skip 4 bits, read 608 bits of data.
	// Input must be at least 77 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 4 to 19
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20) |
			((uint32_t)(input[2] & 0xf0) << 12);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 20 to 35
	value = ((uint32_t)(input[2] & 0x0f) << 28) |
			((uint32_t)input[3] << 20) |
			((uint32_t)(input[4] & 0xf0) << 12);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 36 to 51
	value = ((uint32_t)(input[4] & 0x0f) << 28) |
			((uint32_t)input[5] << 20) |
			((uint32_t)(input[6] & 0xf0) << 12);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 52 to 67
	value = ((uint32_t)(input[6] & 0x0f) << 28) |
			((uint32_t)input[7] << 20) |
			((uint32_t)(input[8] & 0xf0) << 12);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 68 to 83
	value = ((uint32_t)(input[8] & 0x0f) << 28) |
			((uint32_t)input[9] << 20) |
			((uint32_t)(input[10] & 0xf0) << 12);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 84 to 99
	value = ((uint32_t)(input[10] & 0x0f) << 28) |
			((uint32_t)input[11] << 20) |
			((uint32_t)(input[12] & 0xf0) << 12);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 100 to 115
	value = ((uint32_t)(input[12] & 0x0f) << 28) |
			((uint32_t)input[13] << 20) |
			((uint32_t)(input[14] & 0xf0) << 12);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 116 to 131
	value = ((uint32_t)(input[14] & 0x0f) << 28) |
			((uint32_t)input[15] << 20) |
			((uint32_t)(input[16] & 0xf0) << 12);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 132 to 147
	value = ((uint32_t)(input[16] & 0x0f) << 28) |
			((uint32_t)input[17] << 20) |
			((uint32_t)(input[18] & 0xf0) << 12);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 148 to 163
	value = ((uint32_t)(input[18] & 0x0f) << 28) |
			((uint32_t)input[19] << 20) |
			((uint32_t)(input[20] & 0xf0) << 12);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 164 to 179
	value = ((uint32_t)(input[20] & 0x0f) << 28) |
			((uint32_t)input[21] << 20) |
			((uint32_t)(input[22] & 0xf0) << 12);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 180 to 195
	value = ((uint32_t)(input[22] & 0x0f) << 28) |
			((uint32_t)input[23] << 20) |
			((uint32_t)(input[24] & 0xf0) << 12);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 196 to 211
	value = ((uint32_t)(input[24] & 0x0f) << 28) |
			((uint32_t)input[25] << 20) |
			((uint32_t)(input[26] & 0xf0) << 12);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 212 to 227
	value = ((uint32_t)(input[26] & 0x0f) << 28) |
			((uint32_t)input[27] << 20) |
			((uint32_t)(input[28] & 0xf0) << 12);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 228 to 243
	value = ((uint32_t)(input[28] & 0x0f) << 28) |
			((uint32_t)input[29] << 20) |
			((uint32_t)(input[30] & 0xf0) << 12);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 244 to 259
	value = ((uint32_t)(input[30] & 0x0f) << 28) |
			((uint32_t)input[31] << 20) |
			((uint32_t)(input[32] & 0xf0) << 12);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 260 to 275
	value = ((uint32_t)(input[32] & 0x0f) << 28) |
			((uint32_t)input[33] << 20) |
			((uint32_t)(input[34] & 0xf0) << 12);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 276 to 291
	value = ((uint32_t)(input[34] & 0x0f) << 28) |
			((uint32_t)input[35] << 20) |
			((uint32_t)(input[36] & 0xf0) << 12);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 292 to 307
	value = ((uint32_t)(input[36] & 0x0f) << 28) |
			((uint32_t)input[37] << 20) |
			((uint32_t)(input[38] & 0xf0) << 12);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 308 to 323
	value = ((uint32_t)(input[38] & 0x0f) << 28) |
			((uint32_t)input[39] << 20) |
			((uint32_t)(input[40] & 0xf0) << 12);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 324 to 339
	value = ((uint32_t)(input[40] & 0x0f) << 28) |
			((uint32_t)input[41] << 20) |
			((uint32_t)(input[42] & 0xf0) << 12);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 340 to 355
	value = ((uint32_t)(input[42] & 0x0f) << 28) |
			((uint32_t)input[43] << 20) |
			((uint32_t)(input[44] & 0xf0) << 12);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 356 to 371
	value = ((uint32_t)(input[44] & 0x0f) << 28) |
			((uint32_t)input[45] << 20) |
			((uint32_t)(input[46] & 0xf0) << 12);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 372 to 387
	value = ((uint32_t)(input[46] & 0x0f) << 28) |
			((uint32_t)input[47] << 20) |
			((uint32_t)(input[48] & 0xf0) << 12);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 388 to 403
	value = ((uint32_t)(input[48] & 0x0f) << 28) |
			((uint32_t)input[49] << 20) |
			((uint32_t)(input[50] & 0xf0) << 12);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 404 to 419
	value = ((uint32_t)(input[50] & 0x0f) << 28) |
			((uint32_t)input[51] << 20) |
			((uint32_t)(input[52] & 0xf0) << 12);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 420 to 435
	value = ((uint32_t)(input[52] & 0x0f) << 28) |
			((uint32_t)input[53] << 20) |
			((uint32_t)(input[54] & 0xf0) << 12);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 436 to 451
	value = ((uint32_t)(input[54] & 0x0f) << 28) |
			((uint32_t)input[55] << 20) |
			((uint32_t)(input[56] & 0xf0) << 12);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 452 to 467
	value = ((uint32_t)(input[56] & 0x0f) << 28) |
			((uint32_t)input[57] << 20) |
			((uint32_t)(input[58] & 0xf0) << 12);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 468 to 483
	value = ((uint32_t)(input[58] & 0x0f) << 28) |
			((uint32_t)input[59] << 20) |
			((uint32_t)(input[60] & 0xf0) << 12);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 484 to 499
	value = ((uint32_t)(input[60] & 0x0f) << 28) |
			((uint32_t)input[61] << 20) |
			((uint32_t)(input[62] & 0xf0) << 12);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 500 to 515
	value = ((uint32_t)(input[62] & 0x0f) << 28) |
			((uint32_t)input[63] << 20) |
			((uint32_t)(input[64] & 0xf0) << 12);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 516 to 531
	value = ((uint32_t)(input[64] & 0x0f) << 28) |
			((uint32_t)input[65] << 20) |
			((uint32_t)(input[66] & 0xf0) << 12);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 532 to 547
	value = ((uint32_t)(input[66] & 0x0f) << 28) |
			((uint32_t)input[67] << 20) |
			((uint32_t)(input[68] & 0xf0) << 12);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 548 to 563
	value = ((uint32_t)(input[68] & 0x0f) << 28) |
			((uint32_t)input[69] << 20) |
			((uint32_t)(input[70] & 0xf0) << 12);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 564 to 579
	value = ((uint32_t)(input[70] & 0x0f) << 28) |
			((uint32_t)input[71] << 20) |
			((uint32_t)(input[72] & 0xf0) << 12);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 580 to 595
	value = ((uint32_t)(input[72] & 0x0f) << 28) |
			((uint32_t)input[73] << 20) |
			((uint32_t)(input[74] & 0xf0) << 12);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 596 to 611
	value = ((uint32_t)(input[74] & 0x0f) << 28) |
			((uint32_t)input[75] << 20) |
			((uint32_t)(input[76] & 0xf0) << 12);
	output[37] = (double)(value >> 16);
}

static void unpack_38_16bit_unsigned_4off(const uint8_t * input, double * output, void *closure) {
	// Unpack 38 values into output
	// Values are 16-bit unsigned
	// Skip 4 bits, read 608 bits of data.
	// Input must be at least 77 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 4 to 19
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20) |
			((uint32_t)(input[2] & 0xf0) << 12);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 20 to 35
	value = ((uint32_t)(input[2] & 0x0f) << 28) |
			((uint32_t)input[3] << 20) |
			((uint32_t)(input[4] & 0xf0) << 12);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 36 to 51
	value = ((uint32_t)(input[4] & 0x0f) << 28) |
			((uint32_t)input[5] << 20) |
			((uint32_t)(input[6] & 0xf0) << 12);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 52 to 67
	value = ((uint32_t)(input[6] & 0x0f) << 28) |
			((uint32_t)input[7] << 20) |
			((uint32_t)(input[8] & 0xf0) << 12);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 68 to 83
	value = ((uint32_t)(input[8] & 0x0f) << 28) |
			((uint32_t)input[9] << 20) |
			((uint32_t)(input[10] & 0xf0) << 12);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 84 to 99
	value = ((uint32_t)(input[10] & 0x0f) << 28) |
			((uint32_t)input[11] << 20) |
			((uint32_t)(input[12] & 0xf0) << 12);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 100 to 115
	value = ((uint32_t)(input[12] & 0x0f) << 28) |
			((uint32_t)input[13] << 20) |
			((uint32_t)(input[14] & 0xf0) << 12);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 116 to 131
	value = ((uint32_t)(input[14] & 0x0f) << 28) |
			((uint32_t)input[15] << 20) |
			((uint32_t)(input[16] & 0xf0) << 12);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 132 to 147
	value = ((uint32_t)(input[16] & 0x0f) << 28) |
			((uint32_t)input[17] << 20) |
			((uint32_t)(input[18] & 0xf0) << 12);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 148 to 163
	value = ((uint32_t)(input[18] & 0x0f) << 28) |
			((uint32_t)input[19] << 20) |
			((uint32_t)(input[20] & 0xf0) << 12);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 164 to 179
	value = ((uint32_t)(input[20] & 0x0f) << 28) |
			((uint32_t)input[21] << 20) |
			((uint32_t)(input[22] & 0xf0) << 12);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 180 to 195
	value = ((uint32_t)(input[22] & 0x0f) << 28) |
			((uint32_t)input[23] << 20) |
			((uint32_t)(input[24] & 0xf0) << 12);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 196 to 211
	value = ((uint32_t)(input[24] & 0x0f) << 28) |
			((uint32_t)input[25] << 20) |
			((uint32_t)(input[26] & 0xf0) << 12);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 212 to 227
	value = ((uint32_t)(input[26] & 0x0f) << 28) |
			((uint32_t)input[27] << 20) |
			((uint32_t)(input[28] & 0xf0) << 12);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 228 to 243
	value = ((uint32_t)(input[28] & 0x0f) << 28) |
			((uint32_t)input[29] << 20) |
			((uint32_t)(input[30] & 0xf0) << 12);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 244 to 259
	value = ((uint32_t)(input[30] & 0x0f) << 28) |
			((uint32_t)input[31] << 20) |
			((uint32_t)(input[32] & 0xf0) << 12);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 260 to 275
	value = ((uint32_t)(input[32] & 0x0f) << 28) |
			((uint32_t)input[33] << 20) |
			((uint32_t)(input[34] & 0xf0) << 12);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 276 to 291
	value = ((uint32_t)(input[34] & 0x0f) << 28) |
			((uint32_t)input[35] << 20) |
			((uint32_t)(input[36] & 0xf0) << 12);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 292 to 307
	value = ((uint32_t)(input[36] & 0x0f) << 28) |
			((uint32_t)input[37] << 20) |
			((uint32_t)(input[38] & 0xf0) << 12);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 308 to 323
	value = ((uint32_t)(input[38] & 0x0f) << 28) |
			((uint32_t)input[39] << 20) |
			((uint32_t)(input[40] & 0xf0) << 12);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 324 to 339
	value = ((uint32_t)(input[40] & 0x0f) << 28) |
			((uint32_t)input[41] << 20) |
			((uint32_t)(input[42] & 0xf0) << 12);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 340 to 355
	value = ((uint32_t)(input[42] & 0x0f) << 28) |
			((uint32_t)input[43] << 20) |
			((uint32_t)(input[44] & 0xf0) << 12);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 356 to 371
	value = ((uint32_t)(input[44] & 0x0f) << 28) |
			((uint32_t)input[45] << 20) |
			((uint32_t)(input[46] & 0xf0) << 12);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 372 to 387
	value = ((uint32_t)(input[46] & 0x0f) << 28) |
			((uint32_t)input[47] << 20) |
			((uint32_t)(input[48] & 0xf0) << 12);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 388 to 403
	value = ((uint32_t)(input[48] & 0x0f) << 28) |
			((uint32_t)input[49] << 20) |
			((uint32_t)(input[50] & 0xf0) << 12);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 404 to 419
	value = ((uint32_t)(input[50] & 0x0f) << 28) |
			((uint32_t)input[51] << 20) |
			((uint32_t)(input[52] & 0xf0) << 12);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 420 to 435
	value = ((uint32_t)(input[52] & 0x0f) << 28) |
			((uint32_t)input[53] << 20) |
			((uint32_t)(input[54] & 0xf0) << 12);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 436 to 451
	value = ((uint32_t)(input[54] & 0x0f) << 28) |
			((uint32_t)input[55] << 20) |
			((uint32_t)(input[56] & 0xf0) << 12);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 452 to 467
	value = ((uint32_t)(input[56] & 0x0f) << 28) |
			((uint32_t)input[57] << 20) |
			((uint32_t)(input[58] & 0xf0) << 12);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 468 to 483
	value = ((uint32_t)(input[58] & 0x0f) << 28) |
			((uint32_t)input[59] << 20) |
			((uint32_t)(input[60] & 0xf0) << 12);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 484 to 499
	value = ((uint32_t)(input[60] & 0x0f) << 28) |
			((uint32_t)input[61] << 20) |
			((uint32_t)(input[62] & 0xf0) << 12);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 500 to 515
	value = ((uint32_t)(input[62] & 0x0f) << 28) |
			((uint32_t)input[63] << 20) |
			((uint32_t)(input[64] & 0xf0) << 12);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 516 to 531
	value = ((uint32_t)(input[64] & 0x0f) << 28) |
			((uint32_t)input[65] << 20) |
			((uint32_t)(input[66] & 0xf0) << 12);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 532 to 547
	value = ((uint32_t)(input[66] & 0x0f) << 28) |
			((uint32_t)input[67] << 20) |
			((uint32_t)(input[68] & 0xf0) << 12);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 548 to 563
	value = ((uint32_t)(input[68] & 0x0f) << 28) |
			((uint32_t)input[69] << 20) |
			((uint32_t)(input[70] & 0xf0) << 12);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 564 to 579
	value = ((uint32_t)(input[70] & 0x0f) << 28) |
			((uint32_t)input[71] << 20) |
			((uint32_t)(input[72] & 0xf0) << 12);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 580 to 595
	value = ((uint32_t)(input[72] & 0x0f) << 28) |
			((uint32_t)input[73] << 20) |
			((uint32_t)(input[74] & 0xf0) << 12);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 596 to 611
	value = ((uint32_t)(input[74] & 0x0f) << 28) |
			((uint32_t)input[75] << 20) |
			((uint32_t)(input[76] & 0xf0) << 12);
	output[37] = (double)(value >> 16);
}

static void unpack_38_16bit_signed_5off(const uint8_t * input, double * output, void *closure) {
	// Unpack 38 values into output
	// Values are 16-bit signed
	// Skip 5 bits, read 608 bits of data.
	// Input must be at least 77 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 5 to 20
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)(input[2] & 0xf8) << 13);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 21 to 36
	value = ((uint32_t)(input[2] & 0x07) << 29) |
			((uint32_t)input[3] << 21) |
			((uint32_t)(input[4] & 0xf8) << 13);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 37 to 52
	value = ((uint32_t)(input[4] & 0x07) << 29) |
			((uint32_t)input[5] << 21) |
			((uint32_t)(input[6] & 0xf8) << 13);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 53 to 68
	value = ((uint32_t)(input[6] & 0x07) << 29) |
			((uint32_t)input[7] << 21) |
			((uint32_t)(input[8] & 0xf8) << 13);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 69 to 84
	value = ((uint32_t)(input[8] & 0x07) << 29) |
			((uint32_t)input[9] << 21) |
			((uint32_t)(input[10] & 0xf8) << 13);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 85 to 100
	value = ((uint32_t)(input[10] & 0x07) << 29) |
			((uint32_t)input[11] << 21) |
			((uint32_t)(input[12] & 0xf8) << 13);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 101 to 116
	value = ((uint32_t)(input[12] & 0x07) << 29) |
			((uint32_t)input[13] << 21) |
			((uint32_t)(input[14] & 0xf8) << 13);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 117 to 132
	value = ((uint32_t)(input[14] & 0x07) << 29) |
			((uint32_t)input[15] << 21) |
			((uint32_t)(input[16] & 0xf8) << 13);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 133 to 148
	value = ((uint32_t)(input[16] & 0x07) << 29) |
			((uint32_t)input[17] << 21) |
			((uint32_t)(input[18] & 0xf8) << 13);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 149 to 164
	value = ((uint32_t)(input[18] & 0x07) << 29) |
			((uint32_t)input[19] << 21) |
			((uint32_t)(input[20] & 0xf8) << 13);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 165 to 180
	value = ((uint32_t)(input[20] & 0x07) << 29) |
			((uint32_t)input[21] << 21) |
			((uint32_t)(input[22] & 0xf8) << 13);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 181 to 196
	value = ((uint32_t)(input[22] & 0x07) << 29) |
			((uint32_t)input[23] << 21) |
			((uint32_t)(input[24] & 0xf8) << 13);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 197 to 212
	value = ((uint32_t)(input[24] & 0x07) << 29) |
			((uint32_t)input[25] << 21) |
			((uint32_t)(input[26] & 0xf8) << 13);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 213 to 228
	value = ((uint32_t)(input[26] & 0x07) << 29) |
			((uint32_t)input[27] << 21) |
			((uint32_t)(input[28] & 0xf8) << 13);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 229 to 244
	value = ((uint32_t)(input[28] & 0x07) << 29) |
			((uint32_t)input[29] << 21) |
			((uint32_t)(input[30] & 0xf8) << 13);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 245 to 260
	value = ((uint32_t)(input[30] & 0x07) << 29) |
			((uint32_t)input[31] << 21) |
			((uint32_t)(input[32] & 0xf8) << 13);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 261 to 276
	value = ((uint32_t)(input[32] & 0x07) << 29) |
			((uint32_t)input[33] << 21) |
			((uint32_t)(input[34] & 0xf8) << 13);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 277 to 292
	value = ((uint32_t)(input[34] & 0x07) << 29) |
			((uint32_t)input[35] << 21) |
			((uint32_t)(input[36] & 0xf8) << 13);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 293 to 308
	value = ((uint32_t)(input[36] & 0x07) << 29) |
			((uint32_t)input[37] << 21) |
			((uint32_t)(input[38] & 0xf8) << 13);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 309 to 324
	value = ((uint32_t)(input[38] & 0x07) << 29) |
			((uint32_t)input[39] << 21) |
			((uint32_t)(input[40] & 0xf8) << 13);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 325 to 340
	value = ((uint32_t)(input[40] & 0x07) << 29) |
			((uint32_t)input[41] << 21) |
			((uint32_t)(input[42] & 0xf8) << 13);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 341 to 356
	value = ((uint32_t)(input[42] & 0x07) << 29) |
			((uint32_t)input[43] << 21) |
			((uint32_t)(input[44] & 0xf8) << 13);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 357 to 372
	value = ((uint32_t)(input[44] & 0x07) << 29) |
			((uint32_t)input[45] << 21) |
			((uint32_t)(input[46] & 0xf8) << 13);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 373 to 388
	value = ((uint32_t)(input[46] & 0x07) << 29) |
			((uint32_t)input[47] << 21) |
			((uint32_t)(input[48] & 0xf8) << 13);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 389 to 404
	value = ((uint32_t)(input[48] & 0x07) << 29) |
			((uint32_t)input[49] << 21) |
			((uint32_t)(input[50] & 0xf8) << 13);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 405 to 420
	value = ((uint32_t)(input[50] & 0x07) << 29) |
			((uint32_t)input[51] << 21) |
			((uint32_t)(input[52] & 0xf8) << 13);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 421 to 436
	value = ((uint32_t)(input[52] & 0x07) << 29) |
			((uint32_t)input[53] << 21) |
			((uint32_t)(input[54] & 0xf8) << 13);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 437 to 452
	value = ((uint32_t)(input[54] & 0x07) << 29) |
			((uint32_t)input[55] << 21) |
			((uint32_t)(input[56] & 0xf8) << 13);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 453 to 468
	value = ((uint32_t)(input[56] & 0x07) << 29) |
			((uint32_t)input[57] << 21) |
			((uint32_t)(input[58] & 0xf8) << 13);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 469 to 484
	value = ((uint32_t)(input[58] & 0x07) << 29) |
			((uint32_t)input[59] << 21) |
			((uint32_t)(input[60] & 0xf8) << 13);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 485 to 500
	value = ((uint32_t)(input[60] & 0x07) << 29) |
			((uint32_t)input[61] << 21) |
			((uint32_t)(input[62] & 0xf8) << 13);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 501 to 516
	value = ((uint32_t)(input[62] & 0x07) << 29) |
			((uint32_t)input[63] << 21) |
			((uint32_t)(input[64] & 0xf8) << 13);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 517 to 532
	value = ((uint32_t)(input[64] & 0x07) << 29) |
			((uint32_t)input[65] << 21) |
			((uint32_t)(input[66] & 0xf8) << 13);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 533 to 548
	value = ((uint32_t)(input[66] & 0x07) << 29) |
			((uint32_t)input[67] << 21) |
			((uint32_t)(input[68] & 0xf8) << 13);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 549 to 564
	value = ((uint32_t)(input[68] & 0x07) << 29) |
			((uint32_t)input[69] << 21) |
			((uint32_t)(input[70] & 0xf8) << 13);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 565 to 580
	value = ((uint32_t)(input[70] & 0x07) << 29) |
			((uint32_t)input[71] << 21) |
			((uint32_t)(input[72] & 0xf8) << 13);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 581 to 596
	value = ((uint32_t)(input[72] & 0x07) << 29) |
			((uint32_t)input[73] << 21) |
			((uint32_t)(input[74] & 0xf8) << 13);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 597 to 612
	value = ((uint32_t)(input[74] & 0x07) << 29) |
			((uint32_t)input[75] << 21) |
			((uint32_t)(input[76] & 0xf8) << 13);
	output[37] = (double)(value >> 16);
}

static void unpack_38_16bit_unsigned_5off(const uint8_t * input, double * output, void *closure) {
	// Unpack 38 values into output
	// Values are 16-bit unsigned
	// Skip 5 bits, read 608 bits of data.
	// Input must be at least 77 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 5 to 20
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)(input[2] & 0xf8) << 13);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 21 to 36
	value = ((uint32_t)(input[2] & 0x07) << 29) |
			((uint32_t)input[3] << 21) |
			((uint32_t)(input[4] & 0xf8) << 13);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 37 to 52
	value = ((uint32_t)(input[4] & 0x07) << 29) |
			((uint32_t)input[5] << 21) |
			((uint32_t)(input[6] & 0xf8) << 13);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 53 to 68
	value = ((uint32_t)(input[6] & 0x07) << 29) |
			((uint32_t)input[7] << 21) |
			((uint32_t)(input[8] & 0xf8) << 13);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 69 to 84
	value = ((uint32_t)(input[8] & 0x07) << 29) |
			((uint32_t)input[9] << 21) |
			((uint32_t)(input[10] & 0xf8) << 13);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 85 to 100
	value = ((uint32_t)(input[10] & 0x07) << 29) |
			((uint32_t)input[11] << 21) |
			((uint32_t)(input[12] & 0xf8) << 13);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 101 to 116
	value = ((uint32_t)(input[12] & 0x07) << 29) |
			((uint32_t)input[13] << 21) |
			((uint32_t)(input[14] & 0xf8) << 13);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 117 to 132
	value = ((uint32_t)(input[14] & 0x07) << 29) |
			((uint32_t)input[15] << 21) |
			((uint32_t)(input[16] & 0xf8) << 13);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 133 to 148
	value = ((uint32_t)(input[16] & 0x07) << 29) |
			((uint32_t)input[17] << 21) |
			((uint32_t)(input[18] & 0xf8) << 13);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 149 to 164
	value = ((uint32_t)(input[18] & 0x07) << 29) |
			((uint32_t)input[19] << 21) |
			((uint32_t)(input[20] & 0xf8) << 13);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 165 to 180
	value = ((uint32_t)(input[20] & 0x07) << 29) |
			((uint32_t)input[21] << 21) |
			((uint32_t)(input[22] & 0xf8) << 13);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 181 to 196
	value = ((uint32_t)(input[22] & 0x07) << 29) |
			((uint32_t)input[23] << 21) |
			((uint32_t)(input[24] & 0xf8) << 13);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 197 to 212
	value = ((uint32_t)(input[24] & 0x07) << 29) |
			((uint32_t)input[25] << 21) |
			((uint32_t)(input[26] & 0xf8) << 13);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 213 to 228
	value = ((uint32_t)(input[26] & 0x07) << 29) |
			((uint32_t)input[27] << 21) |
			((uint32_t)(input[28] & 0xf8) << 13);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 229 to 244
	value = ((uint32_t)(input[28] & 0x07) << 29) |
			((uint32_t)input[29] << 21) |
			((uint32_t)(input[30] & 0xf8) << 13);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 245 to 260
	value = ((uint32_t)(input[30] & 0x07) << 29) |
			((uint32_t)input[31] << 21) |
			((uint32_t)(input[32] & 0xf8) << 13);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 261 to 276
	value = ((uint32_t)(input[32] & 0x07) << 29) |
			((uint32_t)input[33] << 21) |
			((uint32_t)(input[34] & 0xf8) << 13);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 277 to 292
	value = ((uint32_t)(input[34] & 0x07) << 29) |
			((uint32_t)input[35] << 21) |
			((uint32_t)(input[36] & 0xf8) << 13);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 293 to 308
	value = ((uint32_t)(input[36] & 0x07) << 29) |
			((uint32_t)input[37] << 21) |
			((uint32_t)(input[38] & 0xf8) << 13);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 309 to 324
	value = ((uint32_t)(input[38] & 0x07) << 29) |
			((uint32_t)input[39] << 21) |
			((uint32_t)(input[40] & 0xf8) << 13);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 325 to 340
	value = ((uint32_t)(input[40] & 0x07) << 29) |
			((uint32_t)input[41] << 21) |
			((uint32_t)(input[42] & 0xf8) << 13);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 341 to 356
	value = ((uint32_t)(input[42] & 0x07) << 29) |
			((uint32_t)input[43] << 21) |
			((uint32_t)(input[44] & 0xf8) << 13);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 357 to 372
	value = ((uint32_t)(input[44] & 0x07) << 29) |
			((uint32_t)input[45] << 21) |
			((uint32_t)(input[46] & 0xf8) << 13);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 373 to 388
	value = ((uint32_t)(input[46] & 0x07) << 29) |
			((uint32_t)input[47] << 21) |
			((uint32_t)(input[48] & 0xf8) << 13);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 389 to 404
	value = ((uint32_t)(input[48] & 0x07) << 29) |
			((uint32_t)input[49] << 21) |
			((uint32_t)(input[50] & 0xf8) << 13);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 405 to 420
	value = ((uint32_t)(input[50] & 0x07) << 29) |
			((uint32_t)input[51] << 21) |
			((uint32_t)(input[52] & 0xf8) << 13);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 421 to 436
	value = ((uint32_t)(input[52] & 0x07) << 29) |
			((uint32_t)input[53] << 21) |
			((uint32_t)(input[54] & 0xf8) << 13);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 437 to 452
	value = ((uint32_t)(input[54] & 0x07) << 29) |
			((uint32_t)input[55] << 21) |
			((uint32_t)(input[56] & 0xf8) << 13);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 453 to 468
	value = ((uint32_t)(input[56] & 0x07) << 29) |
			((uint32_t)input[57] << 21) |
			((uint32_t)(input[58] & 0xf8) << 13);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 469 to 484
	value = ((uint32_t)(input[58] & 0x07) << 29) |
			((uint32_t)input[59] << 21) |
			((uint32_t)(input[60] & 0xf8) << 13);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 485 to 500
	value = ((uint32_t)(input[60] & 0x07) << 29) |
			((uint32_t)input[61] << 21) |
			((uint32_t)(input[62] & 0xf8) << 13);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 501 to 516
	value = ((uint32_t)(input[62] & 0x07) << 29) |
			((uint32_t)input[63] << 21) |
			((uint32_t)(input[64] & 0xf8) << 13);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 517 to 532
	value = ((uint32_t)(input[64] & 0x07) << 29) |
			((uint32_t)input[65] << 21) |
			((uint32_t)(input[66] & 0xf8) << 13);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 533 to 548
	value = ((uint32_t)(input[66] & 0x07) << 29) |
			((uint32_t)input[67] << 21) |
			((uint32_t)(input[68] & 0xf8) << 13);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 549 to 564
	value = ((uint32_t)(input[68] & 0x07) << 29) |
			((uint32_t)input[69] << 21) |
			((uint32_t)(input[70] & 0xf8) << 13);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 565 to 580
	value = ((uint32_t)(input[70] & 0x07) << 29) |
			((uint32_t)input[71] << 21) |
			((uint32_t)(input[72] & 0xf8) << 13);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 581 to 596
	value = ((uint32_t)(input[72] & 0x07) << 29) |
			((uint32_t)input[73] << 21) |
			((uint32_t)(input[74] & 0xf8) << 13);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 597 to 612
	value = ((uint32_t)(input[74] & 0x07) << 29) |
			((uint32_t)input[75] << 21) |
			((uint32_t)(input[76] & 0xf8) << 13);
	output[37] = (double)(value >> 16);
}

static void unpack_38_16bit_signed_6off(const uint8_t * input, double * output, void *closure) {
	// Unpack 38 values into output
	// Values are 16-bit signed
	// Skip 6 bits, read 608 bits of data.
	// Input must be at least 77 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 6 to 21
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)(input[2] & 0xfc) << 14);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 22 to 37
	value = ((uint32_t)(input[2] & 0x03) << 30) |
			((uint32_t)input[3] << 22) |
			((uint32_t)(input[4] & 0xfc) << 14);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 38 to 53
	value = ((uint32_t)(input[4] & 0x03) << 30) |
			((uint32_t)input[5] << 22) |
			((uint32_t)(input[6] & 0xfc) << 14);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 54 to 69
	value = ((uint32_t)(input[6] & 0x03) << 30) |
			((uint32_t)input[7] << 22) |
			((uint32_t)(input[8] & 0xfc) << 14);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 70 to 85
	value = ((uint32_t)(input[8] & 0x03) << 30) |
			((uint32_t)input[9] << 22) |
			((uint32_t)(input[10] & 0xfc) << 14);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 86 to 101
	value = ((uint32_t)(input[10] & 0x03) << 30) |
			((uint32_t)input[11] << 22) |
			((uint32_t)(input[12] & 0xfc) << 14);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 102 to 117
	value = ((uint32_t)(input[12] & 0x03) << 30) |
			((uint32_t)input[13] << 22) |
			((uint32_t)(input[14] & 0xfc) << 14);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 118 to 133
	value = ((uint32_t)(input[14] & 0x03) << 30) |
			((uint32_t)input[15] << 22) |
			((uint32_t)(input[16] & 0xfc) << 14);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 134 to 149
	value = ((uint32_t)(input[16] & 0x03) << 30) |
			((uint32_t)input[17] << 22) |
			((uint32_t)(input[18] & 0xfc) << 14);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 150 to 165
	value = ((uint32_t)(input[18] & 0x03) << 30) |
			((uint32_t)input[19] << 22) |
			((uint32_t)(input[20] & 0xfc) << 14);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 166 to 181
	value = ((uint32_t)(input[20] & 0x03) << 30) |
			((uint32_t)input[21] << 22) |
			((uint32_t)(input[22] & 0xfc) << 14);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 182 to 197
	value = ((uint32_t)(input[22] & 0x03) << 30) |
			((uint32_t)input[23] << 22) |
			((uint32_t)(input[24] & 0xfc) << 14);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 198 to 213
	value = ((uint32_t)(input[24] & 0x03) << 30) |
			((uint32_t)input[25] << 22) |
			((uint32_t)(input[26] & 0xfc) << 14);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 214 to 229
	value = ((uint32_t)(input[26] & 0x03) << 30) |
			((uint32_t)input[27] << 22) |
			((uint32_t)(input[28] & 0xfc) << 14);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 230 to 245
	value = ((uint32_t)(input[28] & 0x03) << 30) |
			((uint32_t)input[29] << 22) |
			((uint32_t)(input[30] & 0xfc) << 14);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 246 to 261
	value = ((uint32_t)(input[30] & 0x03) << 30) |
			((uint32_t)input[31] << 22) |
			((uint32_t)(input[32] & 0xfc) << 14);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 262 to 277
	value = ((uint32_t)(input[32] & 0x03) << 30) |
			((uint32_t)input[33] << 22) |
			((uint32_t)(input[34] & 0xfc) << 14);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 278 to 293
	value = ((uint32_t)(input[34] & 0x03) << 30) |
			((uint32_t)input[35] << 22) |
			((uint32_t)(input[36] & 0xfc) << 14);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 294 to 309
	value = ((uint32_t)(input[36] & 0x03) << 30) |
			((uint32_t)input[37] << 22) |
			((uint32_t)(input[38] & 0xfc) << 14);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 310 to 325
	value = ((uint32_t)(input[38] & 0x03) << 30) |
			((uint32_t)input[39] << 22) |
			((uint32_t)(input[40] & 0xfc) << 14);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 326 to 341
	value = ((uint32_t)(input[40] & 0x03) << 30) |
			((uint32_t)input[41] << 22) |
			((uint32_t)(input[42] & 0xfc) << 14);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 342 to 357
	value = ((uint32_t)(input[42] & 0x03) << 30) |
			((uint32_t)input[43] << 22) |
			((uint32_t)(input[44] & 0xfc) << 14);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 358 to 373
	value = ((uint32_t)(input[44] & 0x03) << 30) |
			((uint32_t)input[45] << 22) |
			((uint32_t)(input[46] & 0xfc) << 14);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 374 to 389
	value = ((uint32_t)(input[46] & 0x03) << 30) |
			((uint32_t)input[47] << 22) |
			((uint32_t)(input[48] & 0xfc) << 14);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 390 to 405
	value = ((uint32_t)(input[48] & 0x03) << 30) |
			((uint32_t)input[49] << 22) |
			((uint32_t)(input[50] & 0xfc) << 14);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 406 to 421
	value = ((uint32_t)(input[50] & 0x03) << 30) |
			((uint32_t)input[51] << 22) |
			((uint32_t)(input[52] & 0xfc) << 14);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 422 to 437
	value = ((uint32_t)(input[52] & 0x03) << 30) |
			((uint32_t)input[53] << 22) |
			((uint32_t)(input[54] & 0xfc) << 14);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 438 to 453
	value = ((uint32_t)(input[54] & 0x03) << 30) |
			((uint32_t)input[55] << 22) |
			((uint32_t)(input[56] & 0xfc) << 14);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 454 to 469
	value = ((uint32_t)(input[56] & 0x03) << 30) |
			((uint32_t)input[57] << 22) |
			((uint32_t)(input[58] & 0xfc) << 14);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 470 to 485
	value = ((uint32_t)(input[58] & 0x03) << 30) |
			((uint32_t)input[59] << 22) |
			((uint32_t)(input[60] & 0xfc) << 14);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 486 to 501
	value = ((uint32_t)(input[60] & 0x03) << 30) |
			((uint32_t)input[61] << 22) |
			((uint32_t)(input[62] & 0xfc) << 14);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 502 to 517
	value = ((uint32_t)(input[62] & 0x03) << 30) |
			((uint32_t)input[63] << 22) |
			((uint32_t)(input[64] & 0xfc) << 14);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 518 to 533
	value = ((uint32_t)(input[64] & 0x03) << 30) |
			((uint32_t)input[65] << 22) |
			((uint32_t)(input[66] & 0xfc) << 14);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 534 to 549
	value = ((uint32_t)(input[66] & 0x03) << 30) |
			((uint32_t)input[67] << 22) |
			((uint32_t)(input[68] & 0xfc) << 14);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 550 to 565
	value = ((uint32_t)(input[68] & 0x03) << 30) |
			((uint32_t)input[69] << 22) |
			((uint32_t)(input[70] & 0xfc) << 14);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 566 to 581
	value = ((uint32_t)(input[70] & 0x03) << 30) |
			((uint32_t)input[71] << 22) |
			((uint32_t)(input[72] & 0xfc) << 14);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 582 to 597
	value = ((uint32_t)(input[72] & 0x03) << 30) |
			((uint32_t)input[73] << 22) |
			((uint32_t)(input[74] & 0xfc) << 14);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 598 to 613
	value = ((uint32_t)(input[74] & 0x03) << 30) |
			((uint32_t)input[75] << 22) |
			((uint32_t)(input[76] & 0xfc) << 14);
	output[37] = (double)(value >> 16);
}

static void unpack_38_16bit_unsigned_6off(const uint8_t * input, double * output, void *closure) {
	// Unpack 38 values into output
	// Values are 16-bit unsigned
	// Skip 6 bits, read 608 bits of data.
	// Input must be at least 77 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 6 to 21
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)(input[2] & 0xfc) << 14);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 22 to 37
	value = ((uint32_t)(input[2] & 0x03) << 30) |
			((uint32_t)input[3] << 22) |
			((uint32_t)(input[4] & 0xfc) << 14);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 38 to 53
	value = ((uint32_t)(input[4] & 0x03) << 30) |
			((uint32_t)input[5] << 22) |
			((uint32_t)(input[6] & 0xfc) << 14);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 54 to 69
	value = ((uint32_t)(input[6] & 0x03) << 30) |
			((uint32_t)input[7] << 22) |
			((uint32_t)(input[8] & 0xfc) << 14);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 70 to 85
	value = ((uint32_t)(input[8] & 0x03) << 30) |
			((uint32_t)input[9] << 22) |
			((uint32_t)(input[10] & 0xfc) << 14);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 86 to 101
	value = ((uint32_t)(input[10] & 0x03) << 30) |
			((uint32_t)input[11] << 22) |
			((uint32_t)(input[12] & 0xfc) << 14);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 102 to 117
	value = ((uint32_t)(input[12] & 0x03) << 30) |
			((uint32_t)input[13] << 22) |
			((uint32_t)(input[14] & 0xfc) << 14);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 118 to 133
	value = ((uint32_t)(input[14] & 0x03) << 30) |
			((uint32_t)input[15] << 22) |
			((uint32_t)(input[16] & 0xfc) << 14);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 134 to 149
	value = ((uint32_t)(input[16] & 0x03) << 30) |
			((uint32_t)input[17] << 22) |
			((uint32_t)(input[18] & 0xfc) << 14);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 150 to 165
	value = ((uint32_t)(input[18] & 0x03) << 30) |
			((uint32_t)input[19] << 22) |
			((uint32_t)(input[20] & 0xfc) << 14);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 166 to 181
	value = ((uint32_t)(input[20] & 0x03) << 30) |
			((uint32_t)input[21] << 22) |
			((uint32_t)(input[22] & 0xfc) << 14);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 182 to 197
	value = ((uint32_t)(input[22] & 0x03) << 30) |
			((uint32_t)input[23] << 22) |
			((uint32_t)(input[24] & 0xfc) << 14);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 198 to 213
	value = ((uint32_t)(input[24] & 0x03) << 30) |
			((uint32_t)input[25] << 22) |
			((uint32_t)(input[26] & 0xfc) << 14);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 214 to 229
	value = ((uint32_t)(input[26] & 0x03) << 30) |
			((uint32_t)input[27] << 22) |
			((uint32_t)(input[28] & 0xfc) << 14);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 230 to 245
	value = ((uint32_t)(input[28] & 0x03) << 30) |
			((uint32_t)input[29] << 22) |
			((uint32_t)(input[30] & 0xfc) << 14);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 246 to 261
	value = ((uint32_t)(input[30] & 0x03) << 30) |
			((uint32_t)input[31] << 22) |
			((uint32_t)(input[32] & 0xfc) << 14);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 262 to 277
	value = ((uint32_t)(input[32] & 0x03) << 30) |
			((uint32_t)input[33] << 22) |
			((uint32_t)(input[34] & 0xfc) << 14);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 278 to 293
	value = ((uint32_t)(input[34] & 0x03) << 30) |
			((uint32_t)input[35] << 22) |
			((uint32_t)(input[36] & 0xfc) << 14);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 294 to 309
	value = ((uint32_t)(input[36] & 0x03) << 30) |
			((uint32_t)input[37] << 22) |
			((uint32_t)(input[38] & 0xfc) << 14);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 310 to 325
	value = ((uint32_t)(input[38] & 0x03) << 30) |
			((uint32_t)input[39] << 22) |
			((uint32_t)(input[40] & 0xfc) << 14);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 326 to 341
	value = ((uint32_t)(input[40] & 0x03) << 30) |
			((uint32_t)input[41] << 22) |
			((uint32_t)(input[42] & 0xfc) << 14);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 342 to 357
	value = ((uint32_t)(input[42] & 0x03) << 30) |
			((uint32_t)input[43] << 22) |
			((uint32_t)(input[44] & 0xfc) << 14);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 358 to 373
	value = ((uint32_t)(input[44] & 0x03) << 30) |
			((uint32_t)input[45] << 22) |
			((uint32_t)(input[46] & 0xfc) << 14);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 374 to 389
	value = ((uint32_t)(input[46] & 0x03) << 30) |
			((uint32_t)input[47] << 22) |
			((uint32_t)(input[48] & 0xfc) << 14);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 390 to 405
	value = ((uint32_t)(input[48] & 0x03) << 30) |
			((uint32_t)input[49] << 22) |
			((uint32_t)(input[50] & 0xfc) << 14);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 406 to 421
	value = ((uint32_t)(input[50] & 0x03) << 30) |
			((uint32_t)input[51] << 22) |
			((uint32_t)(input[52] & 0xfc) << 14);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 422 to 437
	value = ((uint32_t)(input[52] & 0x03) << 30) |
			((uint32_t)input[53] << 22) |
			((uint32_t)(input[54] & 0xfc) << 14);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 438 to 453
	value = ((uint32_t)(input[54] & 0x03) << 30) |
			((uint32_t)input[55] << 22) |
			((uint32_t)(input[56] & 0xfc) << 14);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 454 to 469
	value = ((uint32_t)(input[56] & 0x03) << 30) |
			((uint32_t)input[57] << 22) |
			((uint32_t)(input[58] & 0xfc) << 14);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 470 to 485
	value = ((uint32_t)(input[58] & 0x03) << 30) |
			((uint32_t)input[59] << 22) |
			((uint32_t)(input[60] & 0xfc) << 14);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 486 to 501
	value = ((uint32_t)(input[60] & 0x03) << 30) |
			((uint32_t)input[61] << 22) |
			((uint32_t)(input[62] & 0xfc) << 14);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 502 to 517
	value = ((uint32_t)(input[62] & 0x03) << 30) |
			((uint32_t)input[63] << 22) |
			((uint32_t)(input[64] & 0xfc) << 14);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 518 to 533
	value = ((uint32_t)(input[64] & 0x03) << 30) |
			((uint32_t)input[65] << 22) |
			((uint32_t)(input[66] & 0xfc) << 14);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 534 to 549
	value = ((uint32_t)(input[66] & 0x03) << 30) |
			((uint32_t)input[67] << 22) |
			((uint32_t)(input[68] & 0xfc) << 14);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 550 to 565
	value = ((uint32_t)(input[68] & 0x03) << 30) |
			((uint32_t)input[69] << 22) |
			((uint32_t)(input[70] & 0xfc) << 14);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 566 to 581
	value = ((uint32_t)(input[70] & 0x03) << 30) |
			((uint32_t)input[71] << 22) |
			((uint32_t)(input[72] & 0xfc) << 14);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 582 to 597
	value = ((uint32_t)(input[72] & 0x03) << 30) |
			((uint32_t)input[73] << 22) |
			((uint32_t)(input[74] & 0xfc) << 14);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 598 to 613
	value = ((uint32_t)(input[74] & 0x03) << 30) |
			((uint32_t)input[75] << 22) |
			((uint32_t)(input[76] & 0xfc) << 14);
	output[37] = (double)(value >> 16);
}

static void unpack_38_16bit_signed_7off(const uint8_t * input, double * output, void *closure) {
	// Unpack 38 values into output
	// Values are 16-bit signed
	// Skip 7 bits, read 608 bits of data.
	// Input must be at least 77 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 7 to 22
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)(input[2] & 0xfe) << 15);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 23 to 38
	value = ((uint32_t)(input[2] & 0x01) << 31) |
			((uint32_t)input[3] << 23) |
			((uint32_t)(input[4] & 0xfe) << 15);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 39 to 54
	value = ((uint32_t)(input[4] & 0x01) << 31) |
			((uint32_t)input[5] << 23) |
			((uint32_t)(input[6] & 0xfe) << 15);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 55 to 70
	value = ((uint32_t)(input[6] & 0x01) << 31) |
			((uint32_t)input[7] << 23) |
			((uint32_t)(input[8] & 0xfe) << 15);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 71 to 86
	value = ((uint32_t)(input[8] & 0x01) << 31) |
			((uint32_t)input[9] << 23) |
			((uint32_t)(input[10] & 0xfe) << 15);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 87 to 102
	value = ((uint32_t)(input[10] & 0x01) << 31) |
			((uint32_t)input[11] << 23) |
			((uint32_t)(input[12] & 0xfe) << 15);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 103 to 118
	value = ((uint32_t)(input[12] & 0x01) << 31) |
			((uint32_t)input[13] << 23) |
			((uint32_t)(input[14] & 0xfe) << 15);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 119 to 134
	value = ((uint32_t)(input[14] & 0x01) << 31) |
			((uint32_t)input[15] << 23) |
			((uint32_t)(input[16] & 0xfe) << 15);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 135 to 150
	value = ((uint32_t)(input[16] & 0x01) << 31) |
			((uint32_t)input[17] << 23) |
			((uint32_t)(input[18] & 0xfe) << 15);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 151 to 166
	value = ((uint32_t)(input[18] & 0x01) << 31) |
			((uint32_t)input[19] << 23) |
			((uint32_t)(input[20] & 0xfe) << 15);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 167 to 182
	value = ((uint32_t)(input[20] & 0x01) << 31) |
			((uint32_t)input[21] << 23) |
			((uint32_t)(input[22] & 0xfe) << 15);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 183 to 198
	value = ((uint32_t)(input[22] & 0x01) << 31) |
			((uint32_t)input[23] << 23) |
			((uint32_t)(input[24] & 0xfe) << 15);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 199 to 214
	value = ((uint32_t)(input[24] & 0x01) << 31) |
			((uint32_t)input[25] << 23) |
			((uint32_t)(input[26] & 0xfe) << 15);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 215 to 230
	value = ((uint32_t)(input[26] & 0x01) << 31) |
			((uint32_t)input[27] << 23) |
			((uint32_t)(input[28] & 0xfe) << 15);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 231 to 246
	value = ((uint32_t)(input[28] & 0x01) << 31) |
			((uint32_t)input[29] << 23) |
			((uint32_t)(input[30] & 0xfe) << 15);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 247 to 262
	value = ((uint32_t)(input[30] & 0x01) << 31) |
			((uint32_t)input[31] << 23) |
			((uint32_t)(input[32] & 0xfe) << 15);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 263 to 278
	value = ((uint32_t)(input[32] & 0x01) << 31) |
			((uint32_t)input[33] << 23) |
			((uint32_t)(input[34] & 0xfe) << 15);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 279 to 294
	value = ((uint32_t)(input[34] & 0x01) << 31) |
			((uint32_t)input[35] << 23) |
			((uint32_t)(input[36] & 0xfe) << 15);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 295 to 310
	value = ((uint32_t)(input[36] & 0x01) << 31) |
			((uint32_t)input[37] << 23) |
			((uint32_t)(input[38] & 0xfe) << 15);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 311 to 326
	value = ((uint32_t)(input[38] & 0x01) << 31) |
			((uint32_t)input[39] << 23) |
			((uint32_t)(input[40] & 0xfe) << 15);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 327 to 342
	value = ((uint32_t)(input[40] & 0x01) << 31) |
			((uint32_t)input[41] << 23) |
			((uint32_t)(input[42] & 0xfe) << 15);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 343 to 358
	value = ((uint32_t)(input[42] & 0x01) << 31) |
			((uint32_t)input[43] << 23) |
			((uint32_t)(input[44] & 0xfe) << 15);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 359 to 374
	value = ((uint32_t)(input[44] & 0x01) << 31) |
			((uint32_t)input[45] << 23) |
			((uint32_t)(input[46] & 0xfe) << 15);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 375 to 390
	value = ((uint32_t)(input[46] & 0x01) << 31) |
			((uint32_t)input[47] << 23) |
			((uint32_t)(input[48] & 0xfe) << 15);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 391 to 406
	value = ((uint32_t)(input[48] & 0x01) << 31) |
			((uint32_t)input[49] << 23) |
			((uint32_t)(input[50] & 0xfe) << 15);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 407 to 422
	value = ((uint32_t)(input[50] & 0x01) << 31) |
			((uint32_t)input[51] << 23) |
			((uint32_t)(input[52] & 0xfe) << 15);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 423 to 438
	value = ((uint32_t)(input[52] & 0x01) << 31) |
			((uint32_t)input[53] << 23) |
			((uint32_t)(input[54] & 0xfe) << 15);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 439 to 454
	value = ((uint32_t)(input[54] & 0x01) << 31) |
			((uint32_t)input[55] << 23) |
			((uint32_t)(input[56] & 0xfe) << 15);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 455 to 470
	value = ((uint32_t)(input[56] & 0x01) << 31) |
			((uint32_t)input[57] << 23) |
			((uint32_t)(input[58] & 0xfe) << 15);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 471 to 486
	value = ((uint32_t)(input[58] & 0x01) << 31) |
			((uint32_t)input[59] << 23) |
			((uint32_t)(input[60] & 0xfe) << 15);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 487 to 502
	value = ((uint32_t)(input[60] & 0x01) << 31) |
			((uint32_t)input[61] << 23) |
			((uint32_t)(input[62] & 0xfe) << 15);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 503 to 518
	value = ((uint32_t)(input[62] & 0x01) << 31) |
			((uint32_t)input[63] << 23) |
			((uint32_t)(input[64] & 0xfe) << 15);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 519 to 534
	value = ((uint32_t)(input[64] & 0x01) << 31) |
			((uint32_t)input[65] << 23) |
			((uint32_t)(input[66] & 0xfe) << 15);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 535 to 550
	value = ((uint32_t)(input[66] & 0x01) << 31) |
			((uint32_t)input[67] << 23) |
			((uint32_t)(input[68] & 0xfe) << 15);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 551 to 566
	value = ((uint32_t)(input[68] & 0x01) << 31) |
			((uint32_t)input[69] << 23) |
			((uint32_t)(input[70] & 0xfe) << 15);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 567 to 582
	value = ((uint32_t)(input[70] & 0x01) << 31) |
			((uint32_t)input[71] << 23) |
			((uint32_t)(input[72] & 0xfe) << 15);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 583 to 598
	value = ((uint32_t)(input[72] & 0x01) << 31) |
			((uint32_t)input[73] << 23) |
			((uint32_t)(input[74] & 0xfe) << 15);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 599 to 614
	value = ((uint32_t)(input[74] & 0x01) << 31) |
			((uint32_t)input[75] << 23) |
			((uint32_t)(input[76] & 0xfe) << 15);
	output[37] = (double)(value >> 16);
}

static void unpack_38_16bit_unsigned_7off(const uint8_t * input, double * output, void *closure) {
	// Unpack 38 values into output
	// Values are 16-bit unsigned
	// Skip 7 bits, read 608 bits of data.
	// Input must be at least 77 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 7 to 22
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)(input[2] & 0xfe) << 15);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 23 to 38
	value = ((uint32_t)(input[2] & 0x01) << 31) |
			((uint32_t)input[3] << 23) |
			((uint32_t)(input[4] & 0xfe) << 15);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 39 to 54
	value = ((uint32_t)(input[4] & 0x01) << 31) |
			((uint32_t)input[5] << 23) |
			((uint32_t)(input[6] & 0xfe) << 15);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 55 to 70
	value = ((uint32_t)(input[6] & 0x01) << 31) |
			((uint32_t)input[7] << 23) |
			((uint32_t)(input[8] & 0xfe) << 15);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 71 to 86
	value = ((uint32_t)(input[8] & 0x01) << 31) |
			((uint32_t)input[9] << 23) |
			((uint32_t)(input[10] & 0xfe) << 15);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 87 to 102
	value = ((uint32_t)(input[10] & 0x01) << 31) |
			((uint32_t)input[11] << 23) |
			((uint32_t)(input[12] & 0xfe) << 15);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 103 to 118
	value = ((uint32_t)(input[12] & 0x01) << 31) |
			((uint32_t)input[13] << 23) |
			((uint32_t)(input[14] & 0xfe) << 15);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 119 to 134
	value = ((uint32_t)(input[14] & 0x01) << 31) |
			((uint32_t)input[15] << 23) |
			((uint32_t)(input[16] & 0xfe) << 15);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 135 to 150
	value = ((uint32_t)(input[16] & 0x01) << 31) |
			((uint32_t)input[17] << 23) |
			((uint32_t)(input[18] & 0xfe) << 15);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 151 to 166
	value = ((uint32_t)(input[18] & 0x01) << 31) |
			((uint32_t)input[19] << 23) |
			((uint32_t)(input[20] & 0xfe) << 15);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 167 to 182
	value = ((uint32_t)(input[20] & 0x01) << 31) |
			((uint32_t)input[21] << 23) |
			((uint32_t)(input[22] & 0xfe) << 15);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 183 to 198
	value = ((uint32_t)(input[22] & 0x01) << 31) |
			((uint32_t)input[23] << 23) |
			((uint32_t)(input[24] & 0xfe) << 15);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 199 to 214
	value = ((uint32_t)(input[24] & 0x01) << 31) |
			((uint32_t)input[25] << 23) |
			((uint32_t)(input[26] & 0xfe) << 15);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 215 to 230
	value = ((uint32_t)(input[26] & 0x01) << 31) |
			((uint32_t)input[27] << 23) |
			((uint32_t)(input[28] & 0xfe) << 15);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 231 to 246
	value = ((uint32_t)(input[28] & 0x01) << 31) |
			((uint32_t)input[29] << 23) |
			((uint32_t)(input[30] & 0xfe) << 15);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 247 to 262
	value = ((uint32_t)(input[30] & 0x01) << 31) |
			((uint32_t)input[31] << 23) |
			((uint32_t)(input[32] & 0xfe) << 15);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 263 to 278
	value = ((uint32_t)(input[32] & 0x01) << 31) |
			((uint32_t)input[33] << 23) |
			((uint32_t)(input[34] & 0xfe) << 15);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 279 to 294
	value = ((uint32_t)(input[34] & 0x01) << 31) |
			((uint32_t)input[35] << 23) |
			((uint32_t)(input[36] & 0xfe) << 15);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 295 to 310
	value = ((uint32_t)(input[36] & 0x01) << 31) |
			((uint32_t)input[37] << 23) |
			((uint32_t)(input[38] & 0xfe) << 15);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 311 to 326
	value = ((uint32_t)(input[38] & 0x01) << 31) |
			((uint32_t)input[39] << 23) |
			((uint32_t)(input[40] & 0xfe) << 15);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 327 to 342
	value = ((uint32_t)(input[40] & 0x01) << 31) |
			((uint32_t)input[41] << 23) |
			((uint32_t)(input[42] & 0xfe) << 15);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 343 to 358
	value = ((uint32_t)(input[42] & 0x01) << 31) |
			((uint32_t)input[43] << 23) |
			((uint32_t)(input[44] & 0xfe) << 15);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 359 to 374
	value = ((uint32_t)(input[44] & 0x01) << 31) |
			((uint32_t)input[45] << 23) |
			((uint32_t)(input[46] & 0xfe) << 15);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 375 to 390
	value = ((uint32_t)(input[46] & 0x01) << 31) |
			((uint32_t)input[47] << 23) |
			((uint32_t)(input[48] & 0xfe) << 15);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 391 to 406
	value = ((uint32_t)(input[48] & 0x01) << 31) |
			((uint32_t)input[49] << 23) |
			((uint32_t)(input[50] & 0xfe) << 15);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 407 to 422
	value = ((uint32_t)(input[50] & 0x01) << 31) |
			((uint32_t)input[51] << 23) |
			((uint32_t)(input[52] & 0xfe) << 15);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 423 to 438
	value = ((uint32_t)(input[52] & 0x01) << 31) |
			((uint32_t)input[53] << 23) |
			((uint32_t)(input[54] & 0xfe) << 15);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 439 to 454
	value = ((uint32_t)(input[54] & 0x01) << 31) |
			((uint32_t)input[55] << 23) |
			((uint32_t)(input[56] & 0xfe) << 15);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 455 to 470
	value = ((uint32_t)(input[56] & 0x01) << 31) |
			((uint32_t)input[57] << 23) |
			((uint32_t)(input[58] & 0xfe) << 15);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 471 to 486
	value = ((uint32_t)(input[58] & 0x01) << 31) |
			((uint32_t)input[59] << 23) |
			((uint32_t)(input[60] & 0xfe) << 15);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 487 to 502
	value = ((uint32_t)(input[60] & 0x01) << 31) |
			((uint32_t)input[61] << 23) |
			((uint32_t)(input[62] & 0xfe) << 15);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 503 to 518
	value = ((uint32_t)(input[62] & 0x01) << 31) |
			((uint32_t)input[63] << 23) |
			((uint32_t)(input[64] & 0xfe) << 15);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 519 to 534
	value = ((uint32_t)(input[64] & 0x01) << 31) |
			((uint32_t)input[65] << 23) |
			((uint32_t)(input[66] & 0xfe) << 15);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 535 to 550
	value = ((uint32_t)(input[66] & 0x01) << 31) |
			((uint32_t)input[67] << 23) |
			((uint32_t)(input[68] & 0xfe) << 15);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 551 to 566
	value = ((uint32_t)(input[68] & 0x01) << 31) |
			((uint32_t)input[69] << 23) |
			((uint32_t)(input[70] & 0xfe) << 15);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 567 to 582
	value = ((uint32_t)(input[70] & 0x01) << 31) |
			((uint32_t)input[71] << 23) |
			((uint32_t)(input[72] & 0xfe) << 15);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 583 to 598
	value = ((uint32_t)(input[72] & 0x01) << 31) |
			((uint32_t)input[73] << 23) |
			((uint32_t)(input[74] & 0xfe) << 15);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 599 to 614
	value = ((uint32_t)(input[74] & 0x01) << 31) |
			((uint32_t)input[75] << 23) |
			((uint32_t)(input[76] & 0xfe) << 15);
	output[37] = (double)(value >> 16);
}

static void unpack_39_16bit_signed_0off(const uint8_t * input, double * output, void *closure) {
	// Unpack 39 values into output
	// Values are 16-bit signed
	// Skip 0 bits, read 624 bits of data.
	// Input must be at least 78 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 0 to 15
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)input[1] << 16);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 16 to 31
	value = ((uint32_t)input[2] << 24) |
			((uint32_t)input[3] << 16);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 32 to 47
	value = ((uint32_t)input[4] << 24) |
			((uint32_t)input[5] << 16);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 48 to 63
	value = ((uint32_t)input[6] << 24) |
			((uint32_t)input[7] << 16);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 64 to 79
	value = ((uint32_t)input[8] << 24) |
			((uint32_t)input[9] << 16);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 80 to 95
	value = ((uint32_t)input[10] << 24) |
			((uint32_t)input[11] << 16);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 96 to 111
	value = ((uint32_t)input[12] << 24) |
			((uint32_t)input[13] << 16);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 112 to 127
	value = ((uint32_t)input[14] << 24) |
			((uint32_t)input[15] << 16);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 128 to 143
	value = ((uint32_t)input[16] << 24) |
			((uint32_t)input[17] << 16);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 144 to 159
	value = ((uint32_t)input[18] << 24) |
			((uint32_t)input[19] << 16);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 160 to 175
	value = ((uint32_t)input[20] << 24) |
			((uint32_t)input[21] << 16);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 176 to 191
	value = ((uint32_t)input[22] << 24) |
			((uint32_t)input[23] << 16);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 192 to 207
	value = ((uint32_t)input[24] << 24) |
			((uint32_t)input[25] << 16);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 208 to 223
	value = ((uint32_t)input[26] << 24) |
			((uint32_t)input[27] << 16);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 224 to 239
	value = ((uint32_t)input[28] << 24) |
			((uint32_t)input[29] << 16);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 240 to 255
	value = ((uint32_t)input[30] << 24) |
			((uint32_t)input[31] << 16);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 256 to 271
	value = ((uint32_t)input[32] << 24) |
			((uint32_t)input[33] << 16);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 272 to 287
	value = ((uint32_t)input[34] << 24) |
			((uint32_t)input[35] << 16);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 288 to 303
	value = ((uint32_t)input[36] << 24) |
			((uint32_t)input[37] << 16);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 304 to 319
	value = ((uint32_t)input[38] << 24) |
			((uint32_t)input[39] << 16);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 320 to 335
	value = ((uint32_t)input[40] << 24) |
			((uint32_t)input[41] << 16);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 336 to 351
	value = ((uint32_t)input[42] << 24) |
			((uint32_t)input[43] << 16);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 352 to 367
	value = ((uint32_t)input[44] << 24) |
			((uint32_t)input[45] << 16);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 368 to 383
	value = ((uint32_t)input[46] << 24) |
			((uint32_t)input[47] << 16);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 384 to 399
	value = ((uint32_t)input[48] << 24) |
			((uint32_t)input[49] << 16);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 400 to 415
	value = ((uint32_t)input[50] << 24) |
			((uint32_t)input[51] << 16);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 416 to 431
	value = ((uint32_t)input[52] << 24) |
			((uint32_t)input[53] << 16);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 432 to 447
	value = ((uint32_t)input[54] << 24) |
			((uint32_t)input[55] << 16);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 448 to 463
	value = ((uint32_t)input[56] << 24) |
			((uint32_t)input[57] << 16);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 464 to 479
	value = ((uint32_t)input[58] << 24) |
			((uint32_t)input[59] << 16);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 480 to 495
	value = ((uint32_t)input[60] << 24) |
			((uint32_t)input[61] << 16);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 496 to 511
	value = ((uint32_t)input[62] << 24) |
			((uint32_t)input[63] << 16);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 512 to 527
	value = ((uint32_t)input[64] << 24) |
			((uint32_t)input[65] << 16);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 528 to 543
	value = ((uint32_t)input[66] << 24) |
			((uint32_t)input[67] << 16);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 544 to 559
	value = ((uint32_t)input[68] << 24) |
			((uint32_t)input[69] << 16);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 560 to 575
	value = ((uint32_t)input[70] << 24) |
			((uint32_t)input[71] << 16);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 576 to 591
	value = ((uint32_t)input[72] << 24) |
			((uint32_t)input[73] << 16);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 592 to 607
	value = ((uint32_t)input[74] << 24) |
			((uint32_t)input[75] << 16);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 608 to 623
	value = ((uint32_t)input[76] << 24) |
			((uint32_t)input[77] << 16);
	output[38] = (double)(value >> 16);
}

static void unpack_39_16bit_unsigned_0off(const uint8_t * input, double * output, void *closure) {
	// Unpack 39 values into output
	// Values are 16-bit unsigned
	// Skip 0 bits, read 624 bits of data.
	// Input must be at least 78 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 0 to 15
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)input[1] << 16);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 16 to 31
	value = ((uint32_t)input[2] << 24) |
			((uint32_t)input[3] << 16);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 32 to 47
	value = ((uint32_t)input[4] << 24) |
			((uint32_t)input[5] << 16);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 48 to 63
	value = ((uint32_t)input[6] << 24) |
			((uint32_t)input[7] << 16);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 64 to 79
	value = ((uint32_t)input[8] << 24) |
			((uint32_t)input[9] << 16);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 80 to 95
	value = ((uint32_t)input[10] << 24) |
			((uint32_t)input[11] << 16);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 96 to 111
	value = ((uint32_t)input[12] << 24) |
			((uint32_t)input[13] << 16);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 112 to 127
	value = ((uint32_t)input[14] << 24) |
			((uint32_t)input[15] << 16);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 128 to 143
	value = ((uint32_t)input[16] << 24) |
			((uint32_t)input[17] << 16);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 144 to 159
	value = ((uint32_t)input[18] << 24) |
			((uint32_t)input[19] << 16);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 160 to 175
	value = ((uint32_t)input[20] << 24) |
			((uint32_t)input[21] << 16);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 176 to 191
	value = ((uint32_t)input[22] << 24) |
			((uint32_t)input[23] << 16);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 192 to 207
	value = ((uint32_t)input[24] << 24) |
			((uint32_t)input[25] << 16);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 208 to 223
	value = ((uint32_t)input[26] << 24) |
			((uint32_t)input[27] << 16);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 224 to 239
	value = ((uint32_t)input[28] << 24) |
			((uint32_t)input[29] << 16);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 240 to 255
	value = ((uint32_t)input[30] << 24) |
			((uint32_t)input[31] << 16);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 256 to 271
	value = ((uint32_t)input[32] << 24) |
			((uint32_t)input[33] << 16);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 272 to 287
	value = ((uint32_t)input[34] << 24) |
			((uint32_t)input[35] << 16);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 288 to 303
	value = ((uint32_t)input[36] << 24) |
			((uint32_t)input[37] << 16);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 304 to 319
	value = ((uint32_t)input[38] << 24) |
			((uint32_t)input[39] << 16);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 320 to 335
	value = ((uint32_t)input[40] << 24) |
			((uint32_t)input[41] << 16);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 336 to 351
	value = ((uint32_t)input[42] << 24) |
			((uint32_t)input[43] << 16);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 352 to 367
	value = ((uint32_t)input[44] << 24) |
			((uint32_t)input[45] << 16);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 368 to 383
	value = ((uint32_t)input[46] << 24) |
			((uint32_t)input[47] << 16);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 384 to 399
	value = ((uint32_t)input[48] << 24) |
			((uint32_t)input[49] << 16);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 400 to 415
	value = ((uint32_t)input[50] << 24) |
			((uint32_t)input[51] << 16);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 416 to 431
	value = ((uint32_t)input[52] << 24) |
			((uint32_t)input[53] << 16);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 432 to 447
	value = ((uint32_t)input[54] << 24) |
			((uint32_t)input[55] << 16);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 448 to 463
	value = ((uint32_t)input[56] << 24) |
			((uint32_t)input[57] << 16);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 464 to 479
	value = ((uint32_t)input[58] << 24) |
			((uint32_t)input[59] << 16);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 480 to 495
	value = ((uint32_t)input[60] << 24) |
			((uint32_t)input[61] << 16);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 496 to 511
	value = ((uint32_t)input[62] << 24) |
			((uint32_t)input[63] << 16);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 512 to 527
	value = ((uint32_t)input[64] << 24) |
			((uint32_t)input[65] << 16);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 528 to 543
	value = ((uint32_t)input[66] << 24) |
			((uint32_t)input[67] << 16);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 544 to 559
	value = ((uint32_t)input[68] << 24) |
			((uint32_t)input[69] << 16);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 560 to 575
	value = ((uint32_t)input[70] << 24) |
			((uint32_t)input[71] << 16);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 576 to 591
	value = ((uint32_t)input[72] << 24) |
			((uint32_t)input[73] << 16);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 592 to 607
	value = ((uint32_t)input[74] << 24) |
			((uint32_t)input[75] << 16);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 608 to 623
	value = ((uint32_t)input[76] << 24) |
			((uint32_t)input[77] << 16);
	output[38] = (double)(value >> 16);
}

static void unpack_39_16bit_signed_1off(const uint8_t * input, double * output, void *closure) {
	// Unpack 39 values into output
	// Values are 16-bit signed
	// Skip 1 bits, read 624 bits of data.
	// Input must be at least 79 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 1 to 16
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)input[1] << 17) |
			((uint32_t)(input[2] & 0x80) << 9);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 17 to 32
	value = ((uint32_t)(input[2] & 0x7f) << 25) |
			((uint32_t)input[3] << 17) |
			((uint32_t)(input[4] & 0x80) << 9);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 33 to 48
	value = ((uint32_t)(input[4] & 0x7f) << 25) |
			((uint32_t)input[5] << 17) |
			((uint32_t)(input[6] & 0x80) << 9);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 49 to 64
	value = ((uint32_t)(input[6] & 0x7f) << 25) |
			((uint32_t)input[7] << 17) |
			((uint32_t)(input[8] & 0x80) << 9);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 65 to 80
	value = ((uint32_t)(input[8] & 0x7f) << 25) |
			((uint32_t)input[9] << 17) |
			((uint32_t)(input[10] & 0x80) << 9);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 81 to 96
	value = ((uint32_t)(input[10] & 0x7f) << 25) |
			((uint32_t)input[11] << 17) |
			((uint32_t)(input[12] & 0x80) << 9);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 97 to 112
	value = ((uint32_t)(input[12] & 0x7f) << 25) |
			((uint32_t)input[13] << 17) |
			((uint32_t)(input[14] & 0x80) << 9);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 113 to 128
	value = ((uint32_t)(input[14] & 0x7f) << 25) |
			((uint32_t)input[15] << 17) |
			((uint32_t)(input[16] & 0x80) << 9);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 129 to 144
	value = ((uint32_t)(input[16] & 0x7f) << 25) |
			((uint32_t)input[17] << 17) |
			((uint32_t)(input[18] & 0x80) << 9);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 145 to 160
	value = ((uint32_t)(input[18] & 0x7f) << 25) |
			((uint32_t)input[19] << 17) |
			((uint32_t)(input[20] & 0x80) << 9);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 161 to 176
	value = ((uint32_t)(input[20] & 0x7f) << 25) |
			((uint32_t)input[21] << 17) |
			((uint32_t)(input[22] & 0x80) << 9);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 177 to 192
	value = ((uint32_t)(input[22] & 0x7f) << 25) |
			((uint32_t)input[23] << 17) |
			((uint32_t)(input[24] & 0x80) << 9);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 193 to 208
	value = ((uint32_t)(input[24] & 0x7f) << 25) |
			((uint32_t)input[25] << 17) |
			((uint32_t)(input[26] & 0x80) << 9);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 209 to 224
	value = ((uint32_t)(input[26] & 0x7f) << 25) |
			((uint32_t)input[27] << 17) |
			((uint32_t)(input[28] & 0x80) << 9);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 225 to 240
	value = ((uint32_t)(input[28] & 0x7f) << 25) |
			((uint32_t)input[29] << 17) |
			((uint32_t)(input[30] & 0x80) << 9);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 241 to 256
	value = ((uint32_t)(input[30] & 0x7f) << 25) |
			((uint32_t)input[31] << 17) |
			((uint32_t)(input[32] & 0x80) << 9);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 257 to 272
	value = ((uint32_t)(input[32] & 0x7f) << 25) |
			((uint32_t)input[33] << 17) |
			((uint32_t)(input[34] & 0x80) << 9);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 273 to 288
	value = ((uint32_t)(input[34] & 0x7f) << 25) |
			((uint32_t)input[35] << 17) |
			((uint32_t)(input[36] & 0x80) << 9);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 289 to 304
	value = ((uint32_t)(input[36] & 0x7f) << 25) |
			((uint32_t)input[37] << 17) |
			((uint32_t)(input[38] & 0x80) << 9);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 305 to 320
	value = ((uint32_t)(input[38] & 0x7f) << 25) |
			((uint32_t)input[39] << 17) |
			((uint32_t)(input[40] & 0x80) << 9);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 321 to 336
	value = ((uint32_t)(input[40] & 0x7f) << 25) |
			((uint32_t)input[41] << 17) |
			((uint32_t)(input[42] & 0x80) << 9);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 337 to 352
	value = ((uint32_t)(input[42] & 0x7f) << 25) |
			((uint32_t)input[43] << 17) |
			((uint32_t)(input[44] & 0x80) << 9);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 353 to 368
	value = ((uint32_t)(input[44] & 0x7f) << 25) |
			((uint32_t)input[45] << 17) |
			((uint32_t)(input[46] & 0x80) << 9);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 369 to 384
	value = ((uint32_t)(input[46] & 0x7f) << 25) |
			((uint32_t)input[47] << 17) |
			((uint32_t)(input[48] & 0x80) << 9);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 385 to 400
	value = ((uint32_t)(input[48] & 0x7f) << 25) |
			((uint32_t)input[49] << 17) |
			((uint32_t)(input[50] & 0x80) << 9);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 401 to 416
	value = ((uint32_t)(input[50] & 0x7f) << 25) |
			((uint32_t)input[51] << 17) |
			((uint32_t)(input[52] & 0x80) << 9);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 417 to 432
	value = ((uint32_t)(input[52] & 0x7f) << 25) |
			((uint32_t)input[53] << 17) |
			((uint32_t)(input[54] & 0x80) << 9);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 433 to 448
	value = ((uint32_t)(input[54] & 0x7f) << 25) |
			((uint32_t)input[55] << 17) |
			((uint32_t)(input[56] & 0x80) << 9);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 449 to 464
	value = ((uint32_t)(input[56] & 0x7f) << 25) |
			((uint32_t)input[57] << 17) |
			((uint32_t)(input[58] & 0x80) << 9);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 465 to 480
	value = ((uint32_t)(input[58] & 0x7f) << 25) |
			((uint32_t)input[59] << 17) |
			((uint32_t)(input[60] & 0x80) << 9);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 481 to 496
	value = ((uint32_t)(input[60] & 0x7f) << 25) |
			((uint32_t)input[61] << 17) |
			((uint32_t)(input[62] & 0x80) << 9);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 497 to 512
	value = ((uint32_t)(input[62] & 0x7f) << 25) |
			((uint32_t)input[63] << 17) |
			((uint32_t)(input[64] & 0x80) << 9);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 513 to 528
	value = ((uint32_t)(input[64] & 0x7f) << 25) |
			((uint32_t)input[65] << 17) |
			((uint32_t)(input[66] & 0x80) << 9);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 529 to 544
	value = ((uint32_t)(input[66] & 0x7f) << 25) |
			((uint32_t)input[67] << 17) |
			((uint32_t)(input[68] & 0x80) << 9);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 545 to 560
	value = ((uint32_t)(input[68] & 0x7f) << 25) |
			((uint32_t)input[69] << 17) |
			((uint32_t)(input[70] & 0x80) << 9);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 561 to 576
	value = ((uint32_t)(input[70] & 0x7f) << 25) |
			((uint32_t)input[71] << 17) |
			((uint32_t)(input[72] & 0x80) << 9);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 577 to 592
	value = ((uint32_t)(input[72] & 0x7f) << 25) |
			((uint32_t)input[73] << 17) |
			((uint32_t)(input[74] & 0x80) << 9);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 593 to 608
	value = ((uint32_t)(input[74] & 0x7f) << 25) |
			((uint32_t)input[75] << 17) |
			((uint32_t)(input[76] & 0x80) << 9);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 609 to 624
	value = ((uint32_t)(input[76] & 0x7f) << 25) |
			((uint32_t)input[77] << 17) |
			((uint32_t)(input[78] & 0x80) << 9);
	output[38] = (double)(value >> 16);
}

static void unpack_39_16bit_unsigned_1off(const uint8_t * input, double * output, void *closure) {
	// Unpack 39 values into output
	// Values are 16-bit unsigned
	// Skip 1 bits, read 624 bits of data.
	// Input must be at least 79 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 1 to 16
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)input[1] << 17) |
			((uint32_t)(input[2] & 0x80) << 9);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 17 to 32
	value = ((uint32_t)(input[2] & 0x7f) << 25) |
			((uint32_t)input[3] << 17) |
			((uint32_t)(input[4] & 0x80) << 9);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 33 to 48
	value = ((uint32_t)(input[4] & 0x7f) << 25) |
			((uint32_t)input[5] << 17) |
			((uint32_t)(input[6] & 0x80) << 9);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 49 to 64
	value = ((uint32_t)(input[6] & 0x7f) << 25) |
			((uint32_t)input[7] << 17) |
			((uint32_t)(input[8] & 0x80) << 9);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 65 to 80
	value = ((uint32_t)(input[8] & 0x7f) << 25) |
			((uint32_t)input[9] << 17) |
			((uint32_t)(input[10] & 0x80) << 9);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 81 to 96
	value = ((uint32_t)(input[10] & 0x7f) << 25) |
			((uint32_t)input[11] << 17) |
			((uint32_t)(input[12] & 0x80) << 9);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 97 to 112
	value = ((uint32_t)(input[12] & 0x7f) << 25) |
			((uint32_t)input[13] << 17) |
			((uint32_t)(input[14] & 0x80) << 9);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 113 to 128
	value = ((uint32_t)(input[14] & 0x7f) << 25) |
			((uint32_t)input[15] << 17) |
			((uint32_t)(input[16] & 0x80) << 9);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 129 to 144
	value = ((uint32_t)(input[16] & 0x7f) << 25) |
			((uint32_t)input[17] << 17) |
			((uint32_t)(input[18] & 0x80) << 9);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 145 to 160
	value = ((uint32_t)(input[18] & 0x7f) << 25) |
			((uint32_t)input[19] << 17) |
			((uint32_t)(input[20] & 0x80) << 9);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 161 to 176
	value = ((uint32_t)(input[20] & 0x7f) << 25) |
			((uint32_t)input[21] << 17) |
			((uint32_t)(input[22] & 0x80) << 9);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 177 to 192
	value = ((uint32_t)(input[22] & 0x7f) << 25) |
			((uint32_t)input[23] << 17) |
			((uint32_t)(input[24] & 0x80) << 9);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 193 to 208
	value = ((uint32_t)(input[24] & 0x7f) << 25) |
			((uint32_t)input[25] << 17) |
			((uint32_t)(input[26] & 0x80) << 9);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 209 to 224
	value = ((uint32_t)(input[26] & 0x7f) << 25) |
			((uint32_t)input[27] << 17) |
			((uint32_t)(input[28] & 0x80) << 9);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 225 to 240
	value = ((uint32_t)(input[28] & 0x7f) << 25) |
			((uint32_t)input[29] << 17) |
			((uint32_t)(input[30] & 0x80) << 9);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 241 to 256
	value = ((uint32_t)(input[30] & 0x7f) << 25) |
			((uint32_t)input[31] << 17) |
			((uint32_t)(input[32] & 0x80) << 9);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 257 to 272
	value = ((uint32_t)(input[32] & 0x7f) << 25) |
			((uint32_t)input[33] << 17) |
			((uint32_t)(input[34] & 0x80) << 9);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 273 to 288
	value = ((uint32_t)(input[34] & 0x7f) << 25) |
			((uint32_t)input[35] << 17) |
			((uint32_t)(input[36] & 0x80) << 9);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 289 to 304
	value = ((uint32_t)(input[36] & 0x7f) << 25) |
			((uint32_t)input[37] << 17) |
			((uint32_t)(input[38] & 0x80) << 9);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 305 to 320
	value = ((uint32_t)(input[38] & 0x7f) << 25) |
			((uint32_t)input[39] << 17) |
			((uint32_t)(input[40] & 0x80) << 9);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 321 to 336
	value = ((uint32_t)(input[40] & 0x7f) << 25) |
			((uint32_t)input[41] << 17) |
			((uint32_t)(input[42] & 0x80) << 9);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 337 to 352
	value = ((uint32_t)(input[42] & 0x7f) << 25) |
			((uint32_t)input[43] << 17) |
			((uint32_t)(input[44] & 0x80) << 9);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 353 to 368
	value = ((uint32_t)(input[44] & 0x7f) << 25) |
			((uint32_t)input[45] << 17) |
			((uint32_t)(input[46] & 0x80) << 9);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 369 to 384
	value = ((uint32_t)(input[46] & 0x7f) << 25) |
			((uint32_t)input[47] << 17) |
			((uint32_t)(input[48] & 0x80) << 9);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 385 to 400
	value = ((uint32_t)(input[48] & 0x7f) << 25) |
			((uint32_t)input[49] << 17) |
			((uint32_t)(input[50] & 0x80) << 9);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 401 to 416
	value = ((uint32_t)(input[50] & 0x7f) << 25) |
			((uint32_t)input[51] << 17) |
			((uint32_t)(input[52] & 0x80) << 9);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 417 to 432
	value = ((uint32_t)(input[52] & 0x7f) << 25) |
			((uint32_t)input[53] << 17) |
			((uint32_t)(input[54] & 0x80) << 9);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 433 to 448
	value = ((uint32_t)(input[54] & 0x7f) << 25) |
			((uint32_t)input[55] << 17) |
			((uint32_t)(input[56] & 0x80) << 9);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 449 to 464
	value = ((uint32_t)(input[56] & 0x7f) << 25) |
			((uint32_t)input[57] << 17) |
			((uint32_t)(input[58] & 0x80) << 9);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 465 to 480
	value = ((uint32_t)(input[58] & 0x7f) << 25) |
			((uint32_t)input[59] << 17) |
			((uint32_t)(input[60] & 0x80) << 9);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 481 to 496
	value = ((uint32_t)(input[60] & 0x7f) << 25) |
			((uint32_t)input[61] << 17) |
			((uint32_t)(input[62] & 0x80) << 9);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 497 to 512
	value = ((uint32_t)(input[62] & 0x7f) << 25) |
			((uint32_t)input[63] << 17) |
			((uint32_t)(input[64] & 0x80) << 9);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 513 to 528
	value = ((uint32_t)(input[64] & 0x7f) << 25) |
			((uint32_t)input[65] << 17) |
			((uint32_t)(input[66] & 0x80) << 9);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 529 to 544
	value = ((uint32_t)(input[66] & 0x7f) << 25) |
			((uint32_t)input[67] << 17) |
			((uint32_t)(input[68] & 0x80) << 9);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 545 to 560
	value = ((uint32_t)(input[68] & 0x7f) << 25) |
			((uint32_t)input[69] << 17) |
			((uint32_t)(input[70] & 0x80) << 9);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 561 to 576
	value = ((uint32_t)(input[70] & 0x7f) << 25) |
			((uint32_t)input[71] << 17) |
			((uint32_t)(input[72] & 0x80) << 9);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 577 to 592
	value = ((uint32_t)(input[72] & 0x7f) << 25) |
			((uint32_t)input[73] << 17) |
			((uint32_t)(input[74] & 0x80) << 9);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 593 to 608
	value = ((uint32_t)(input[74] & 0x7f) << 25) |
			((uint32_t)input[75] << 17) |
			((uint32_t)(input[76] & 0x80) << 9);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 609 to 624
	value = ((uint32_t)(input[76] & 0x7f) << 25) |
			((uint32_t)input[77] << 17) |
			((uint32_t)(input[78] & 0x80) << 9);
	output[38] = (double)(value >> 16);
}

static void unpack_39_16bit_signed_2off(const uint8_t * input, double * output, void *closure) {
	// Unpack 39 values into output
	// Values are 16-bit signed
	// Skip 2 bits, read 624 bits of data.
	// Input must be at least 79 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 2 to 17
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)input[1] << 18) |
			((uint32_t)(input[2] & 0xc0) << 10);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 18 to 33
	value = ((uint32_t)(input[2] & 0x3f) << 26) |
			((uint32_t)input[3] << 18) |
			((uint32_t)(input[4] & 0xc0) << 10);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 34 to 49
	value = ((uint32_t)(input[4] & 0x3f) << 26) |
			((uint32_t)input[5] << 18) |
			((uint32_t)(input[6] & 0xc0) << 10);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 50 to 65
	value = ((uint32_t)(input[6] & 0x3f) << 26) |
			((uint32_t)input[7] << 18) |
			((uint32_t)(input[8] & 0xc0) << 10);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 66 to 81
	value = ((uint32_t)(input[8] & 0x3f) << 26) |
			((uint32_t)input[9] << 18) |
			((uint32_t)(input[10] & 0xc0) << 10);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 82 to 97
	value = ((uint32_t)(input[10] & 0x3f) << 26) |
			((uint32_t)input[11] << 18) |
			((uint32_t)(input[12] & 0xc0) << 10);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 98 to 113
	value = ((uint32_t)(input[12] & 0x3f) << 26) |
			((uint32_t)input[13] << 18) |
			((uint32_t)(input[14] & 0xc0) << 10);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 114 to 129
	value = ((uint32_t)(input[14] & 0x3f) << 26) |
			((uint32_t)input[15] << 18) |
			((uint32_t)(input[16] & 0xc0) << 10);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 130 to 145
	value = ((uint32_t)(input[16] & 0x3f) << 26) |
			((uint32_t)input[17] << 18) |
			((uint32_t)(input[18] & 0xc0) << 10);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 146 to 161
	value = ((uint32_t)(input[18] & 0x3f) << 26) |
			((uint32_t)input[19] << 18) |
			((uint32_t)(input[20] & 0xc0) << 10);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 162 to 177
	value = ((uint32_t)(input[20] & 0x3f) << 26) |
			((uint32_t)input[21] << 18) |
			((uint32_t)(input[22] & 0xc0) << 10);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 178 to 193
	value = ((uint32_t)(input[22] & 0x3f) << 26) |
			((uint32_t)input[23] << 18) |
			((uint32_t)(input[24] & 0xc0) << 10);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 194 to 209
	value = ((uint32_t)(input[24] & 0x3f) << 26) |
			((uint32_t)input[25] << 18) |
			((uint32_t)(input[26] & 0xc0) << 10);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 210 to 225
	value = ((uint32_t)(input[26] & 0x3f) << 26) |
			((uint32_t)input[27] << 18) |
			((uint32_t)(input[28] & 0xc0) << 10);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 226 to 241
	value = ((uint32_t)(input[28] & 0x3f) << 26) |
			((uint32_t)input[29] << 18) |
			((uint32_t)(input[30] & 0xc0) << 10);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 242 to 257
	value = ((uint32_t)(input[30] & 0x3f) << 26) |
			((uint32_t)input[31] << 18) |
			((uint32_t)(input[32] & 0xc0) << 10);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 258 to 273
	value = ((uint32_t)(input[32] & 0x3f) << 26) |
			((uint32_t)input[33] << 18) |
			((uint32_t)(input[34] & 0xc0) << 10);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 274 to 289
	value = ((uint32_t)(input[34] & 0x3f) << 26) |
			((uint32_t)input[35] << 18) |
			((uint32_t)(input[36] & 0xc0) << 10);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 290 to 305
	value = ((uint32_t)(input[36] & 0x3f) << 26) |
			((uint32_t)input[37] << 18) |
			((uint32_t)(input[38] & 0xc0) << 10);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 306 to 321
	value = ((uint32_t)(input[38] & 0x3f) << 26) |
			((uint32_t)input[39] << 18) |
			((uint32_t)(input[40] & 0xc0) << 10);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 322 to 337
	value = ((uint32_t)(input[40] & 0x3f) << 26) |
			((uint32_t)input[41] << 18) |
			((uint32_t)(input[42] & 0xc0) << 10);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 338 to 353
	value = ((uint32_t)(input[42] & 0x3f) << 26) |
			((uint32_t)input[43] << 18) |
			((uint32_t)(input[44] & 0xc0) << 10);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 354 to 369
	value = ((uint32_t)(input[44] & 0x3f) << 26) |
			((uint32_t)input[45] << 18) |
			((uint32_t)(input[46] & 0xc0) << 10);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 370 to 385
	value = ((uint32_t)(input[46] & 0x3f) << 26) |
			((uint32_t)input[47] << 18) |
			((uint32_t)(input[48] & 0xc0) << 10);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 386 to 401
	value = ((uint32_t)(input[48] & 0x3f) << 26) |
			((uint32_t)input[49] << 18) |
			((uint32_t)(input[50] & 0xc0) << 10);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 402 to 417
	value = ((uint32_t)(input[50] & 0x3f) << 26) |
			((uint32_t)input[51] << 18) |
			((uint32_t)(input[52] & 0xc0) << 10);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 418 to 433
	value = ((uint32_t)(input[52] & 0x3f) << 26) |
			((uint32_t)input[53] << 18) |
			((uint32_t)(input[54] & 0xc0) << 10);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 434 to 449
	value = ((uint32_t)(input[54] & 0x3f) << 26) |
			((uint32_t)input[55] << 18) |
			((uint32_t)(input[56] & 0xc0) << 10);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 450 to 465
	value = ((uint32_t)(input[56] & 0x3f) << 26) |
			((uint32_t)input[57] << 18) |
			((uint32_t)(input[58] & 0xc0) << 10);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 466 to 481
	value = ((uint32_t)(input[58] & 0x3f) << 26) |
			((uint32_t)input[59] << 18) |
			((uint32_t)(input[60] & 0xc0) << 10);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 482 to 497
	value = ((uint32_t)(input[60] & 0x3f) << 26) |
			((uint32_t)input[61] << 18) |
			((uint32_t)(input[62] & 0xc0) << 10);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 498 to 513
	value = ((uint32_t)(input[62] & 0x3f) << 26) |
			((uint32_t)input[63] << 18) |
			((uint32_t)(input[64] & 0xc0) << 10);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 514 to 529
	value = ((uint32_t)(input[64] & 0x3f) << 26) |
			((uint32_t)input[65] << 18) |
			((uint32_t)(input[66] & 0xc0) << 10);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 530 to 545
	value = ((uint32_t)(input[66] & 0x3f) << 26) |
			((uint32_t)input[67] << 18) |
			((uint32_t)(input[68] & 0xc0) << 10);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 546 to 561
	value = ((uint32_t)(input[68] & 0x3f) << 26) |
			((uint32_t)input[69] << 18) |
			((uint32_t)(input[70] & 0xc0) << 10);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 562 to 577
	value = ((uint32_t)(input[70] & 0x3f) << 26) |
			((uint32_t)input[71] << 18) |
			((uint32_t)(input[72] & 0xc0) << 10);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 578 to 593
	value = ((uint32_t)(input[72] & 0x3f) << 26) |
			((uint32_t)input[73] << 18) |
			((uint32_t)(input[74] & 0xc0) << 10);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 594 to 609
	value = ((uint32_t)(input[74] & 0x3f) << 26) |
			((uint32_t)input[75] << 18) |
			((uint32_t)(input[76] & 0xc0) << 10);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 610 to 625
	value = ((uint32_t)(input[76] & 0x3f) << 26) |
			((uint32_t)input[77] << 18) |
			((uint32_t)(input[78] & 0xc0) << 10);
	output[38] = (double)(value >> 16);
}

static void unpack_39_16bit_unsigned_2off(const uint8_t * input, double * output, void *closure) {
	// Unpack 39 values into output
	// Values are 16-bit unsigned
	// Skip 2 bits, read 624 bits of data.
	// Input must be at least 79 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 2 to 17
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)input[1] << 18) |
			((uint32_t)(input[2] & 0xc0) << 10);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 18 to 33
	value = ((uint32_t)(input[2] & 0x3f) << 26) |
			((uint32_t)input[3] << 18) |
			((uint32_t)(input[4] & 0xc0) << 10);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 34 to 49
	value = ((uint32_t)(input[4] & 0x3f) << 26) |
			((uint32_t)input[5] << 18) |
			((uint32_t)(input[6] & 0xc0) << 10);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 50 to 65
	value = ((uint32_t)(input[6] & 0x3f) << 26) |
			((uint32_t)input[7] << 18) |
			((uint32_t)(input[8] & 0xc0) << 10);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 66 to 81
	value = ((uint32_t)(input[8] & 0x3f) << 26) |
			((uint32_t)input[9] << 18) |
			((uint32_t)(input[10] & 0xc0) << 10);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 82 to 97
	value = ((uint32_t)(input[10] & 0x3f) << 26) |
			((uint32_t)input[11] << 18) |
			((uint32_t)(input[12] & 0xc0) << 10);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 98 to 113
	value = ((uint32_t)(input[12] & 0x3f) << 26) |
			((uint32_t)input[13] << 18) |
			((uint32_t)(input[14] & 0xc0) << 10);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 114 to 129
	value = ((uint32_t)(input[14] & 0x3f) << 26) |
			((uint32_t)input[15] << 18) |
			((uint32_t)(input[16] & 0xc0) << 10);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 130 to 145
	value = ((uint32_t)(input[16] & 0x3f) << 26) |
			((uint32_t)input[17] << 18) |
			((uint32_t)(input[18] & 0xc0) << 10);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 146 to 161
	value = ((uint32_t)(input[18] & 0x3f) << 26) |
			((uint32_t)input[19] << 18) |
			((uint32_t)(input[20] & 0xc0) << 10);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 162 to 177
	value = ((uint32_t)(input[20] & 0x3f) << 26) |
			((uint32_t)input[21] << 18) |
			((uint32_t)(input[22] & 0xc0) << 10);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 178 to 193
	value = ((uint32_t)(input[22] & 0x3f) << 26) |
			((uint32_t)input[23] << 18) |
			((uint32_t)(input[24] & 0xc0) << 10);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 194 to 209
	value = ((uint32_t)(input[24] & 0x3f) << 26) |
			((uint32_t)input[25] << 18) |
			((uint32_t)(input[26] & 0xc0) << 10);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 210 to 225
	value = ((uint32_t)(input[26] & 0x3f) << 26) |
			((uint32_t)input[27] << 18) |
			((uint32_t)(input[28] & 0xc0) << 10);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 226 to 241
	value = ((uint32_t)(input[28] & 0x3f) << 26) |
			((uint32_t)input[29] << 18) |
			((uint32_t)(input[30] & 0xc0) << 10);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 242 to 257
	value = ((uint32_t)(input[30] & 0x3f) << 26) |
			((uint32_t)input[31] << 18) |
			((uint32_t)(input[32] & 0xc0) << 10);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 258 to 273
	value = ((uint32_t)(input[32] & 0x3f) << 26) |
			((uint32_t)input[33] << 18) |
			((uint32_t)(input[34] & 0xc0) << 10);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 274 to 289
	value = ((uint32_t)(input[34] & 0x3f) << 26) |
			((uint32_t)input[35] << 18) |
			((uint32_t)(input[36] & 0xc0) << 10);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 290 to 305
	value = ((uint32_t)(input[36] & 0x3f) << 26) |
			((uint32_t)input[37] << 18) |
			((uint32_t)(input[38] & 0xc0) << 10);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 306 to 321
	value = ((uint32_t)(input[38] & 0x3f) << 26) |
			((uint32_t)input[39] << 18) |
			((uint32_t)(input[40] & 0xc0) << 10);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 322 to 337
	value = ((uint32_t)(input[40] & 0x3f) << 26) |
			((uint32_t)input[41] << 18) |
			((uint32_t)(input[42] & 0xc0) << 10);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 338 to 353
	value = ((uint32_t)(input[42] & 0x3f) << 26) |
			((uint32_t)input[43] << 18) |
			((uint32_t)(input[44] & 0xc0) << 10);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 354 to 369
	value = ((uint32_t)(input[44] & 0x3f) << 26) |
			((uint32_t)input[45] << 18) |
			((uint32_t)(input[46] & 0xc0) << 10);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 370 to 385
	value = ((uint32_t)(input[46] & 0x3f) << 26) |
			((uint32_t)input[47] << 18) |
			((uint32_t)(input[48] & 0xc0) << 10);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 386 to 401
	value = ((uint32_t)(input[48] & 0x3f) << 26) |
			((uint32_t)input[49] << 18) |
			((uint32_t)(input[50] & 0xc0) << 10);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 402 to 417
	value = ((uint32_t)(input[50] & 0x3f) << 26) |
			((uint32_t)input[51] << 18) |
			((uint32_t)(input[52] & 0xc0) << 10);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 418 to 433
	value = ((uint32_t)(input[52] & 0x3f) << 26) |
			((uint32_t)input[53] << 18) |
			((uint32_t)(input[54] & 0xc0) << 10);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 434 to 449
	value = ((uint32_t)(input[54] & 0x3f) << 26) |
			((uint32_t)input[55] << 18) |
			((uint32_t)(input[56] & 0xc0) << 10);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 450 to 465
	value = ((uint32_t)(input[56] & 0x3f) << 26) |
			((uint32_t)input[57] << 18) |
			((uint32_t)(input[58] & 0xc0) << 10);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 466 to 481
	value = ((uint32_t)(input[58] & 0x3f) << 26) |
			((uint32_t)input[59] << 18) |
			((uint32_t)(input[60] & 0xc0) << 10);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 482 to 497
	value = ((uint32_t)(input[60] & 0x3f) << 26) |
			((uint32_t)input[61] << 18) |
			((uint32_t)(input[62] & 0xc0) << 10);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 498 to 513
	value = ((uint32_t)(input[62] & 0x3f) << 26) |
			((uint32_t)input[63] << 18) |
			((uint32_t)(input[64] & 0xc0) << 10);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 514 to 529
	value = ((uint32_t)(input[64] & 0x3f) << 26) |
			((uint32_t)input[65] << 18) |
			((uint32_t)(input[66] & 0xc0) << 10);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 530 to 545
	value = ((uint32_t)(input[66] & 0x3f) << 26) |
			((uint32_t)input[67] << 18) |
			((uint32_t)(input[68] & 0xc0) << 10);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 546 to 561
	value = ((uint32_t)(input[68] & 0x3f) << 26) |
			((uint32_t)input[69] << 18) |
			((uint32_t)(input[70] & 0xc0) << 10);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 562 to 577
	value = ((uint32_t)(input[70] & 0x3f) << 26) |
			((uint32_t)input[71] << 18) |
			((uint32_t)(input[72] & 0xc0) << 10);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 578 to 593
	value = ((uint32_t)(input[72] & 0x3f) << 26) |
			((uint32_t)input[73] << 18) |
			((uint32_t)(input[74] & 0xc0) << 10);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 594 to 609
	value = ((uint32_t)(input[74] & 0x3f) << 26) |
			((uint32_t)input[75] << 18) |
			((uint32_t)(input[76] & 0xc0) << 10);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 610 to 625
	value = ((uint32_t)(input[76] & 0x3f) << 26) |
			((uint32_t)input[77] << 18) |
			((uint32_t)(input[78] & 0xc0) << 10);
	output[38] = (double)(value >> 16);
}

static void unpack_39_16bit_signed_3off(const uint8_t * input, double * output, void *closure) {
	// Unpack 39 values into output
	// Values are 16-bit signed
	// Skip 3 bits, read 624 bits of data.
	// Input must be at least 79 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 3 to 18
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)input[1] << 19) |
			((uint32_t)(input[2] & 0xe0) << 11);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 19 to 34
	value = ((uint32_t)(input[2] & 0x1f) << 27) |
			((uint32_t)input[3] << 19) |
			((uint32_t)(input[4] & 0xe0) << 11);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 35 to 50
	value = ((uint32_t)(input[4] & 0x1f) << 27) |
			((uint32_t)input[5] << 19) |
			((uint32_t)(input[6] & 0xe0) << 11);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 51 to 66
	value = ((uint32_t)(input[6] & 0x1f) << 27) |
			((uint32_t)input[7] << 19) |
			((uint32_t)(input[8] & 0xe0) << 11);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 67 to 82
	value = ((uint32_t)(input[8] & 0x1f) << 27) |
			((uint32_t)input[9] << 19) |
			((uint32_t)(input[10] & 0xe0) << 11);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 83 to 98
	value = ((uint32_t)(input[10] & 0x1f) << 27) |
			((uint32_t)input[11] << 19) |
			((uint32_t)(input[12] & 0xe0) << 11);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 99 to 114
	value = ((uint32_t)(input[12] & 0x1f) << 27) |
			((uint32_t)input[13] << 19) |
			((uint32_t)(input[14] & 0xe0) << 11);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 115 to 130
	value = ((uint32_t)(input[14] & 0x1f) << 27) |
			((uint32_t)input[15] << 19) |
			((uint32_t)(input[16] & 0xe0) << 11);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 131 to 146
	value = ((uint32_t)(input[16] & 0x1f) << 27) |
			((uint32_t)input[17] << 19) |
			((uint32_t)(input[18] & 0xe0) << 11);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 147 to 162
	value = ((uint32_t)(input[18] & 0x1f) << 27) |
			((uint32_t)input[19] << 19) |
			((uint32_t)(input[20] & 0xe0) << 11);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 163 to 178
	value = ((uint32_t)(input[20] & 0x1f) << 27) |
			((uint32_t)input[21] << 19) |
			((uint32_t)(input[22] & 0xe0) << 11);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 179 to 194
	value = ((uint32_t)(input[22] & 0x1f) << 27) |
			((uint32_t)input[23] << 19) |
			((uint32_t)(input[24] & 0xe0) << 11);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 195 to 210
	value = ((uint32_t)(input[24] & 0x1f) << 27) |
			((uint32_t)input[25] << 19) |
			((uint32_t)(input[26] & 0xe0) << 11);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 211 to 226
	value = ((uint32_t)(input[26] & 0x1f) << 27) |
			((uint32_t)input[27] << 19) |
			((uint32_t)(input[28] & 0xe0) << 11);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 227 to 242
	value = ((uint32_t)(input[28] & 0x1f) << 27) |
			((uint32_t)input[29] << 19) |
			((uint32_t)(input[30] & 0xe0) << 11);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 243 to 258
	value = ((uint32_t)(input[30] & 0x1f) << 27) |
			((uint32_t)input[31] << 19) |
			((uint32_t)(input[32] & 0xe0) << 11);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 259 to 274
	value = ((uint32_t)(input[32] & 0x1f) << 27) |
			((uint32_t)input[33] << 19) |
			((uint32_t)(input[34] & 0xe0) << 11);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 275 to 290
	value = ((uint32_t)(input[34] & 0x1f) << 27) |
			((uint32_t)input[35] << 19) |
			((uint32_t)(input[36] & 0xe0) << 11);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 291 to 306
	value = ((uint32_t)(input[36] & 0x1f) << 27) |
			((uint32_t)input[37] << 19) |
			((uint32_t)(input[38] & 0xe0) << 11);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 307 to 322
	value = ((uint32_t)(input[38] & 0x1f) << 27) |
			((uint32_t)input[39] << 19) |
			((uint32_t)(input[40] & 0xe0) << 11);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 323 to 338
	value = ((uint32_t)(input[40] & 0x1f) << 27) |
			((uint32_t)input[41] << 19) |
			((uint32_t)(input[42] & 0xe0) << 11);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 339 to 354
	value = ((uint32_t)(input[42] & 0x1f) << 27) |
			((uint32_t)input[43] << 19) |
			((uint32_t)(input[44] & 0xe0) << 11);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 355 to 370
	value = ((uint32_t)(input[44] & 0x1f) << 27) |
			((uint32_t)input[45] << 19) |
			((uint32_t)(input[46] & 0xe0) << 11);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 371 to 386
	value = ((uint32_t)(input[46] & 0x1f) << 27) |
			((uint32_t)input[47] << 19) |
			((uint32_t)(input[48] & 0xe0) << 11);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 387 to 402
	value = ((uint32_t)(input[48] & 0x1f) << 27) |
			((uint32_t)input[49] << 19) |
			((uint32_t)(input[50] & 0xe0) << 11);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 403 to 418
	value = ((uint32_t)(input[50] & 0x1f) << 27) |
			((uint32_t)input[51] << 19) |
			((uint32_t)(input[52] & 0xe0) << 11);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 419 to 434
	value = ((uint32_t)(input[52] & 0x1f) << 27) |
			((uint32_t)input[53] << 19) |
			((uint32_t)(input[54] & 0xe0) << 11);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 435 to 450
	value = ((uint32_t)(input[54] & 0x1f) << 27) |
			((uint32_t)input[55] << 19) |
			((uint32_t)(input[56] & 0xe0) << 11);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 451 to 466
	value = ((uint32_t)(input[56] & 0x1f) << 27) |
			((uint32_t)input[57] << 19) |
			((uint32_t)(input[58] & 0xe0) << 11);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 467 to 482
	value = ((uint32_t)(input[58] & 0x1f) << 27) |
			((uint32_t)input[59] << 19) |
			((uint32_t)(input[60] & 0xe0) << 11);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 483 to 498
	value = ((uint32_t)(input[60] & 0x1f) << 27) |
			((uint32_t)input[61] << 19) |
			((uint32_t)(input[62] & 0xe0) << 11);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 499 to 514
	value = ((uint32_t)(input[62] & 0x1f) << 27) |
			((uint32_t)input[63] << 19) |
			((uint32_t)(input[64] & 0xe0) << 11);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 515 to 530
	value = ((uint32_t)(input[64] & 0x1f) << 27) |
			((uint32_t)input[65] << 19) |
			((uint32_t)(input[66] & 0xe0) << 11);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 531 to 546
	value = ((uint32_t)(input[66] & 0x1f) << 27) |
			((uint32_t)input[67] << 19) |
			((uint32_t)(input[68] & 0xe0) << 11);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 547 to 562
	value = ((uint32_t)(input[68] & 0x1f) << 27) |
			((uint32_t)input[69] << 19) |
			((uint32_t)(input[70] & 0xe0) << 11);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 563 to 578
	value = ((uint32_t)(input[70] & 0x1f) << 27) |
			((uint32_t)input[71] << 19) |
			((uint32_t)(input[72] & 0xe0) << 11);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 579 to 594
	value = ((uint32_t)(input[72] & 0x1f) << 27) |
			((uint32_t)input[73] << 19) |
			((uint32_t)(input[74] & 0xe0) << 11);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 595 to 610
	value = ((uint32_t)(input[74] & 0x1f) << 27) |
			((uint32_t)input[75] << 19) |
			((uint32_t)(input[76] & 0xe0) << 11);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 611 to 626
	value = ((uint32_t)(input[76] & 0x1f) << 27) |
			((uint32_t)input[77] << 19) |
			((uint32_t)(input[78] & 0xe0) << 11);
	output[38] = (double)(value >> 16);
}

static void unpack_39_16bit_unsigned_3off(const uint8_t * input, double * output, void *closure) {
	// Unpack 39 values into output
	// Values are 16-bit unsigned
	// Skip 3 bits, read 624 bits of data.
	// Input must be at least 79 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 3 to 18
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)input[1] << 19) |
			((uint32_t)(input[2] & 0xe0) << 11);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 19 to 34
	value = ((uint32_t)(input[2] & 0x1f) << 27) |
			((uint32_t)input[3] << 19) |
			((uint32_t)(input[4] & 0xe0) << 11);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 35 to 50
	value = ((uint32_t)(input[4] & 0x1f) << 27) |
			((uint32_t)input[5] << 19) |
			((uint32_t)(input[6] & 0xe0) << 11);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 51 to 66
	value = ((uint32_t)(input[6] & 0x1f) << 27) |
			((uint32_t)input[7] << 19) |
			((uint32_t)(input[8] & 0xe0) << 11);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 67 to 82
	value = ((uint32_t)(input[8] & 0x1f) << 27) |
			((uint32_t)input[9] << 19) |
			((uint32_t)(input[10] & 0xe0) << 11);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 83 to 98
	value = ((uint32_t)(input[10] & 0x1f) << 27) |
			((uint32_t)input[11] << 19) |
			((uint32_t)(input[12] & 0xe0) << 11);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 99 to 114
	value = ((uint32_t)(input[12] & 0x1f) << 27) |
			((uint32_t)input[13] << 19) |
			((uint32_t)(input[14] & 0xe0) << 11);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 115 to 130
	value = ((uint32_t)(input[14] & 0x1f) << 27) |
			((uint32_t)input[15] << 19) |
			((uint32_t)(input[16] & 0xe0) << 11);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 131 to 146
	value = ((uint32_t)(input[16] & 0x1f) << 27) |
			((uint32_t)input[17] << 19) |
			((uint32_t)(input[18] & 0xe0) << 11);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 147 to 162
	value = ((uint32_t)(input[18] & 0x1f) << 27) |
			((uint32_t)input[19] << 19) |
			((uint32_t)(input[20] & 0xe0) << 11);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 163 to 178
	value = ((uint32_t)(input[20] & 0x1f) << 27) |
			((uint32_t)input[21] << 19) |
			((uint32_t)(input[22] & 0xe0) << 11);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 179 to 194
	value = ((uint32_t)(input[22] & 0x1f) << 27) |
			((uint32_t)input[23] << 19) |
			((uint32_t)(input[24] & 0xe0) << 11);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 195 to 210
	value = ((uint32_t)(input[24] & 0x1f) << 27) |
			((uint32_t)input[25] << 19) |
			((uint32_t)(input[26] & 0xe0) << 11);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 211 to 226
	value = ((uint32_t)(input[26] & 0x1f) << 27) |
			((uint32_t)input[27] << 19) |
			((uint32_t)(input[28] & 0xe0) << 11);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 227 to 242
	value = ((uint32_t)(input[28] & 0x1f) << 27) |
			((uint32_t)input[29] << 19) |
			((uint32_t)(input[30] & 0xe0) << 11);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 243 to 258
	value = ((uint32_t)(input[30] & 0x1f) << 27) |
			((uint32_t)input[31] << 19) |
			((uint32_t)(input[32] & 0xe0) << 11);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 259 to 274
	value = ((uint32_t)(input[32] & 0x1f) << 27) |
			((uint32_t)input[33] << 19) |
			((uint32_t)(input[34] & 0xe0) << 11);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 275 to 290
	value = ((uint32_t)(input[34] & 0x1f) << 27) |
			((uint32_t)input[35] << 19) |
			((uint32_t)(input[36] & 0xe0) << 11);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 291 to 306
	value = ((uint32_t)(input[36] & 0x1f) << 27) |
			((uint32_t)input[37] << 19) |
			((uint32_t)(input[38] & 0xe0) << 11);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 307 to 322
	value = ((uint32_t)(input[38] & 0x1f) << 27) |
			((uint32_t)input[39] << 19) |
			((uint32_t)(input[40] & 0xe0) << 11);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 323 to 338
	value = ((uint32_t)(input[40] & 0x1f) << 27) |
			((uint32_t)input[41] << 19) |
			((uint32_t)(input[42] & 0xe0) << 11);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 339 to 354
	value = ((uint32_t)(input[42] & 0x1f) << 27) |
			((uint32_t)input[43] << 19) |
			((uint32_t)(input[44] & 0xe0) << 11);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 355 to 370
	value = ((uint32_t)(input[44] & 0x1f) << 27) |
			((uint32_t)input[45] << 19) |
			((uint32_t)(input[46] & 0xe0) << 11);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 371 to 386
	value = ((uint32_t)(input[46] & 0x1f) << 27) |
			((uint32_t)input[47] << 19) |
			((uint32_t)(input[48] & 0xe0) << 11);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 387 to 402
	value = ((uint32_t)(input[48] & 0x1f) << 27) |
			((uint32_t)input[49] << 19) |
			((uint32_t)(input[50] & 0xe0) << 11);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 403 to 418
	value = ((uint32_t)(input[50] & 0x1f) << 27) |
			((uint32_t)input[51] << 19) |
			((uint32_t)(input[52] & 0xe0) << 11);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 419 to 434
	value = ((uint32_t)(input[52] & 0x1f) << 27) |
			((uint32_t)input[53] << 19) |
			((uint32_t)(input[54] & 0xe0) << 11);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 435 to 450
	value = ((uint32_t)(input[54] & 0x1f) << 27) |
			((uint32_t)input[55] << 19) |
			((uint32_t)(input[56] & 0xe0) << 11);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 451 to 466
	value = ((uint32_t)(input[56] & 0x1f) << 27) |
			((uint32_t)input[57] << 19) |
			((uint32_t)(input[58] & 0xe0) << 11);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 467 to 482
	value = ((uint32_t)(input[58] & 0x1f) << 27) |
			((uint32_t)input[59] << 19) |
			((uint32_t)(input[60] & 0xe0) << 11);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 483 to 498
	value = ((uint32_t)(input[60] & 0x1f) << 27) |
			((uint32_t)input[61] << 19) |
			((uint32_t)(input[62] & 0xe0) << 11);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 499 to 514
	value = ((uint32_t)(input[62] & 0x1f) << 27) |
			((uint32_t)input[63] << 19) |
			((uint32_t)(input[64] & 0xe0) << 11);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 515 to 530
	value = ((uint32_t)(input[64] & 0x1f) << 27) |
			((uint32_t)input[65] << 19) |
			((uint32_t)(input[66] & 0xe0) << 11);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 531 to 546
	value = ((uint32_t)(input[66] & 0x1f) << 27) |
			((uint32_t)input[67] << 19) |
			((uint32_t)(input[68] & 0xe0) << 11);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 547 to 562
	value = ((uint32_t)(input[68] & 0x1f) << 27) |
			((uint32_t)input[69] << 19) |
			((uint32_t)(input[70] & 0xe0) << 11);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 563 to 578
	value = ((uint32_t)(input[70] & 0x1f) << 27) |
			((uint32_t)input[71] << 19) |
			((uint32_t)(input[72] & 0xe0) << 11);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 579 to 594
	value = ((uint32_t)(input[72] & 0x1f) << 27) |
			((uint32_t)input[73] << 19) |
			((uint32_t)(input[74] & 0xe0) << 11);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 595 to 610
	value = ((uint32_t)(input[74] & 0x1f) << 27) |
			((uint32_t)input[75] << 19) |
			((uint32_t)(input[76] & 0xe0) << 11);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 611 to 626
	value = ((uint32_t)(input[76] & 0x1f) << 27) |
			((uint32_t)input[77] << 19) |
			((uint32_t)(input[78] & 0xe0) << 11);
	output[38] = (double)(value >> 16);
}

static void unpack_39_16bit_signed_4off(const uint8_t * input, double * output, void *closure) {
	// Unpack 39 values into output
	// Values are 16-bit signed
	// Skip 4 bits, read 624 bits of data.
	// Input must be at least 79 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 4 to 19
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20) |
			((uint32_t)(input[2] & 0xf0) << 12);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 20 to 35
	value = ((uint32_t)(input[2] & 0x0f) << 28) |
			((uint32_t)input[3] << 20) |
			((uint32_t)(input[4] & 0xf0) << 12);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 36 to 51
	value = ((uint32_t)(input[4] & 0x0f) << 28) |
			((uint32_t)input[5] << 20) |
			((uint32_t)(input[6] & 0xf0) << 12);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 52 to 67
	value = ((uint32_t)(input[6] & 0x0f) << 28) |
			((uint32_t)input[7] << 20) |
			((uint32_t)(input[8] & 0xf0) << 12);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 68 to 83
	value = ((uint32_t)(input[8] & 0x0f) << 28) |
			((uint32_t)input[9] << 20) |
			((uint32_t)(input[10] & 0xf0) << 12);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 84 to 99
	value = ((uint32_t)(input[10] & 0x0f) << 28) |
			((uint32_t)input[11] << 20) |
			((uint32_t)(input[12] & 0xf0) << 12);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 100 to 115
	value = ((uint32_t)(input[12] & 0x0f) << 28) |
			((uint32_t)input[13] << 20) |
			((uint32_t)(input[14] & 0xf0) << 12);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 116 to 131
	value = ((uint32_t)(input[14] & 0x0f) << 28) |
			((uint32_t)input[15] << 20) |
			((uint32_t)(input[16] & 0xf0) << 12);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 132 to 147
	value = ((uint32_t)(input[16] & 0x0f) << 28) |
			((uint32_t)input[17] << 20) |
			((uint32_t)(input[18] & 0xf0) << 12);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 148 to 163
	value = ((uint32_t)(input[18] & 0x0f) << 28) |
			((uint32_t)input[19] << 20) |
			((uint32_t)(input[20] & 0xf0) << 12);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 164 to 179
	value = ((uint32_t)(input[20] & 0x0f) << 28) |
			((uint32_t)input[21] << 20) |
			((uint32_t)(input[22] & 0xf0) << 12);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 180 to 195
	value = ((uint32_t)(input[22] & 0x0f) << 28) |
			((uint32_t)input[23] << 20) |
			((uint32_t)(input[24] & 0xf0) << 12);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 196 to 211
	value = ((uint32_t)(input[24] & 0x0f) << 28) |
			((uint32_t)input[25] << 20) |
			((uint32_t)(input[26] & 0xf0) << 12);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 212 to 227
	value = ((uint32_t)(input[26] & 0x0f) << 28) |
			((uint32_t)input[27] << 20) |
			((uint32_t)(input[28] & 0xf0) << 12);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 228 to 243
	value = ((uint32_t)(input[28] & 0x0f) << 28) |
			((uint32_t)input[29] << 20) |
			((uint32_t)(input[30] & 0xf0) << 12);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 244 to 259
	value = ((uint32_t)(input[30] & 0x0f) << 28) |
			((uint32_t)input[31] << 20) |
			((uint32_t)(input[32] & 0xf0) << 12);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 260 to 275
	value = ((uint32_t)(input[32] & 0x0f) << 28) |
			((uint32_t)input[33] << 20) |
			((uint32_t)(input[34] & 0xf0) << 12);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 276 to 291
	value = ((uint32_t)(input[34] & 0x0f) << 28) |
			((uint32_t)input[35] << 20) |
			((uint32_t)(input[36] & 0xf0) << 12);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 292 to 307
	value = ((uint32_t)(input[36] & 0x0f) << 28) |
			((uint32_t)input[37] << 20) |
			((uint32_t)(input[38] & 0xf0) << 12);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 308 to 323
	value = ((uint32_t)(input[38] & 0x0f) << 28) |
			((uint32_t)input[39] << 20) |
			((uint32_t)(input[40] & 0xf0) << 12);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 324 to 339
	value = ((uint32_t)(input[40] & 0x0f) << 28) |
			((uint32_t)input[41] << 20) |
			((uint32_t)(input[42] & 0xf0) << 12);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 340 to 355
	value = ((uint32_t)(input[42] & 0x0f) << 28) |
			((uint32_t)input[43] << 20) |
			((uint32_t)(input[44] & 0xf0) << 12);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 356 to 371
	value = ((uint32_t)(input[44] & 0x0f) << 28) |
			((uint32_t)input[45] << 20) |
			((uint32_t)(input[46] & 0xf0) << 12);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 372 to 387
	value = ((uint32_t)(input[46] & 0x0f) << 28) |
			((uint32_t)input[47] << 20) |
			((uint32_t)(input[48] & 0xf0) << 12);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 388 to 403
	value = ((uint32_t)(input[48] & 0x0f) << 28) |
			((uint32_t)input[49] << 20) |
			((uint32_t)(input[50] & 0xf0) << 12);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 404 to 419
	value = ((uint32_t)(input[50] & 0x0f) << 28) |
			((uint32_t)input[51] << 20) |
			((uint32_t)(input[52] & 0xf0) << 12);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 420 to 435
	value = ((uint32_t)(input[52] & 0x0f) << 28) |
			((uint32_t)input[53] << 20) |
			((uint32_t)(input[54] & 0xf0) << 12);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 436 to 451
	value = ((uint32_t)(input[54] & 0x0f) << 28) |
			((uint32_t)input[55] << 20) |
			((uint32_t)(input[56] & 0xf0) << 12);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 452 to 467
	value = ((uint32_t)(input[56] & 0x0f) << 28) |
			((uint32_t)input[57] << 20) |
			((uint32_t)(input[58] & 0xf0) << 12);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 468 to 483
	value = ((uint32_t)(input[58] & 0x0f) << 28) |
			((uint32_t)input[59] << 20) |
			((uint32_t)(input[60] & 0xf0) << 12);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 484 to 499
	value = ((uint32_t)(input[60] & 0x0f) << 28) |
			((uint32_t)input[61] << 20) |
			((uint32_t)(input[62] & 0xf0) << 12);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 500 to 515
	value = ((uint32_t)(input[62] & 0x0f) << 28) |
			((uint32_t)input[63] << 20) |
			((uint32_t)(input[64] & 0xf0) << 12);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 516 to 531
	value = ((uint32_t)(input[64] & 0x0f) << 28) |
			((uint32_t)input[65] << 20) |
			((uint32_t)(input[66] & 0xf0) << 12);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 532 to 547
	value = ((uint32_t)(input[66] & 0x0f) << 28) |
			((uint32_t)input[67] << 20) |
			((uint32_t)(input[68] & 0xf0) << 12);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 548 to 563
	value = ((uint32_t)(input[68] & 0x0f) << 28) |
			((uint32_t)input[69] << 20) |
			((uint32_t)(input[70] & 0xf0) << 12);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 564 to 579
	value = ((uint32_t)(input[70] & 0x0f) << 28) |
			((uint32_t)input[71] << 20) |
			((uint32_t)(input[72] & 0xf0) << 12);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 580 to 595
	value = ((uint32_t)(input[72] & 0x0f) << 28) |
			((uint32_t)input[73] << 20) |
			((uint32_t)(input[74] & 0xf0) << 12);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 596 to 611
	value = ((uint32_t)(input[74] & 0x0f) << 28) |
			((uint32_t)input[75] << 20) |
			((uint32_t)(input[76] & 0xf0) << 12);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 612 to 627
	value = ((uint32_t)(input[76] & 0x0f) << 28) |
			((uint32_t)input[77] << 20) |
			((uint32_t)(input[78] & 0xf0) << 12);
	output[38] = (double)(value >> 16);
}

static void unpack_39_16bit_unsigned_4off(const uint8_t * input, double * output, void *closure) {
	// Unpack 39 values into output
	// Values are 16-bit unsigned
	// Skip 4 bits, read 624 bits of data.
	// Input must be at least 79 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 4 to 19
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20) |
			((uint32_t)(input[2] & 0xf0) << 12);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 20 to 35
	value = ((uint32_t)(input[2] & 0x0f) << 28) |
			((uint32_t)input[3] << 20) |
			((uint32_t)(input[4] & 0xf0) << 12);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 36 to 51
	value = ((uint32_t)(input[4] & 0x0f) << 28) |
			((uint32_t)input[5] << 20) |
			((uint32_t)(input[6] & 0xf0) << 12);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 52 to 67
	value = ((uint32_t)(input[6] & 0x0f) << 28) |
			((uint32_t)input[7] << 20) |
			((uint32_t)(input[8] & 0xf0) << 12);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 68 to 83
	value = ((uint32_t)(input[8] & 0x0f) << 28) |
			((uint32_t)input[9] << 20) |
			((uint32_t)(input[10] & 0xf0) << 12);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 84 to 99
	value = ((uint32_t)(input[10] & 0x0f) << 28) |
			((uint32_t)input[11] << 20) |
			((uint32_t)(input[12] & 0xf0) << 12);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 100 to 115
	value = ((uint32_t)(input[12] & 0x0f) << 28) |
			((uint32_t)input[13] << 20) |
			((uint32_t)(input[14] & 0xf0) << 12);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 116 to 131
	value = ((uint32_t)(input[14] & 0x0f) << 28) |
			((uint32_t)input[15] << 20) |
			((uint32_t)(input[16] & 0xf0) << 12);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 132 to 147
	value = ((uint32_t)(input[16] & 0x0f) << 28) |
			((uint32_t)input[17] << 20) |
			((uint32_t)(input[18] & 0xf0) << 12);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 148 to 163
	value = ((uint32_t)(input[18] & 0x0f) << 28) |
			((uint32_t)input[19] << 20) |
			((uint32_t)(input[20] & 0xf0) << 12);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 164 to 179
	value = ((uint32_t)(input[20] & 0x0f) << 28) |
			((uint32_t)input[21] << 20) |
			((uint32_t)(input[22] & 0xf0) << 12);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 180 to 195
	value = ((uint32_t)(input[22] & 0x0f) << 28) |
			((uint32_t)input[23] << 20) |
			((uint32_t)(input[24] & 0xf0) << 12);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 196 to 211
	value = ((uint32_t)(input[24] & 0x0f) << 28) |
			((uint32_t)input[25] << 20) |
			((uint32_t)(input[26] & 0xf0) << 12);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 212 to 227
	value = ((uint32_t)(input[26] & 0x0f) << 28) |
			((uint32_t)input[27] << 20) |
			((uint32_t)(input[28] & 0xf0) << 12);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 228 to 243
	value = ((uint32_t)(input[28] & 0x0f) << 28) |
			((uint32_t)input[29] << 20) |
			((uint32_t)(input[30] & 0xf0) << 12);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 244 to 259
	value = ((uint32_t)(input[30] & 0x0f) << 28) |
			((uint32_t)input[31] << 20) |
			((uint32_t)(input[32] & 0xf0) << 12);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 260 to 275
	value = ((uint32_t)(input[32] & 0x0f) << 28) |
			((uint32_t)input[33] << 20) |
			((uint32_t)(input[34] & 0xf0) << 12);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 276 to 291
	value = ((uint32_t)(input[34] & 0x0f) << 28) |
			((uint32_t)input[35] << 20) |
			((uint32_t)(input[36] & 0xf0) << 12);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 292 to 307
	value = ((uint32_t)(input[36] & 0x0f) << 28) |
			((uint32_t)input[37] << 20) |
			((uint32_t)(input[38] & 0xf0) << 12);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 308 to 323
	value = ((uint32_t)(input[38] & 0x0f) << 28) |
			((uint32_t)input[39] << 20) |
			((uint32_t)(input[40] & 0xf0) << 12);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 324 to 339
	value = ((uint32_t)(input[40] & 0x0f) << 28) |
			((uint32_t)input[41] << 20) |
			((uint32_t)(input[42] & 0xf0) << 12);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 340 to 355
	value = ((uint32_t)(input[42] & 0x0f) << 28) |
			((uint32_t)input[43] << 20) |
			((uint32_t)(input[44] & 0xf0) << 12);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 356 to 371
	value = ((uint32_t)(input[44] & 0x0f) << 28) |
			((uint32_t)input[45] << 20) |
			((uint32_t)(input[46] & 0xf0) << 12);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 372 to 387
	value = ((uint32_t)(input[46] & 0x0f) << 28) |
			((uint32_t)input[47] << 20) |
			((uint32_t)(input[48] & 0xf0) << 12);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 388 to 403
	value = ((uint32_t)(input[48] & 0x0f) << 28) |
			((uint32_t)input[49] << 20) |
			((uint32_t)(input[50] & 0xf0) << 12);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 404 to 419
	value = ((uint32_t)(input[50] & 0x0f) << 28) |
			((uint32_t)input[51] << 20) |
			((uint32_t)(input[52] & 0xf0) << 12);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 420 to 435
	value = ((uint32_t)(input[52] & 0x0f) << 28) |
			((uint32_t)input[53] << 20) |
			((uint32_t)(input[54] & 0xf0) << 12);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 436 to 451
	value = ((uint32_t)(input[54] & 0x0f) << 28) |
			((uint32_t)input[55] << 20) |
			((uint32_t)(input[56] & 0xf0) << 12);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 452 to 467
	value = ((uint32_t)(input[56] & 0x0f) << 28) |
			((uint32_t)input[57] << 20) |
			((uint32_t)(input[58] & 0xf0) << 12);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 468 to 483
	value = ((uint32_t)(input[58] & 0x0f) << 28) |
			((uint32_t)input[59] << 20) |
			((uint32_t)(input[60] & 0xf0) << 12);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 484 to 499
	value = ((uint32_t)(input[60] & 0x0f) << 28) |
			((uint32_t)input[61] << 20) |
			((uint32_t)(input[62] & 0xf0) << 12);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 500 to 515
	value = ((uint32_t)(input[62] & 0x0f) << 28) |
			((uint32_t)input[63] << 20) |
			((uint32_t)(input[64] & 0xf0) << 12);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 516 to 531
	value = ((uint32_t)(input[64] & 0x0f) << 28) |
			((uint32_t)input[65] << 20) |
			((uint32_t)(input[66] & 0xf0) << 12);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 532 to 547
	value = ((uint32_t)(input[66] & 0x0f) << 28) |
			((uint32_t)input[67] << 20) |
			((uint32_t)(input[68] & 0xf0) << 12);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 548 to 563
	value = ((uint32_t)(input[68] & 0x0f) << 28) |
			((uint32_t)input[69] << 20) |
			((uint32_t)(input[70] & 0xf0) << 12);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 564 to 579
	value = ((uint32_t)(input[70] & 0x0f) << 28) |
			((uint32_t)input[71] << 20) |
			((uint32_t)(input[72] & 0xf0) << 12);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 580 to 595
	value = ((uint32_t)(input[72] & 0x0f) << 28) |
			((uint32_t)input[73] << 20) |
			((uint32_t)(input[74] & 0xf0) << 12);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 596 to 611
	value = ((uint32_t)(input[74] & 0x0f) << 28) |
			((uint32_t)input[75] << 20) |
			((uint32_t)(input[76] & 0xf0) << 12);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 612 to 627
	value = ((uint32_t)(input[76] & 0x0f) << 28) |
			((uint32_t)input[77] << 20) |
			((uint32_t)(input[78] & 0xf0) << 12);
	output[38] = (double)(value >> 16);
}

static void unpack_39_16bit_signed_5off(const uint8_t * input, double * output, void *closure) {
	// Unpack 39 values into output
	// Values are 16-bit signed
	// Skip 5 bits, read 624 bits of data.
	// Input must be at least 79 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 5 to 20
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)(input[2] & 0xf8) << 13);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 21 to 36
	value = ((uint32_t)(input[2] & 0x07) << 29) |
			((uint32_t)input[3] << 21) |
			((uint32_t)(input[4] & 0xf8) << 13);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 37 to 52
	value = ((uint32_t)(input[4] & 0x07) << 29) |
			((uint32_t)input[5] << 21) |
			((uint32_t)(input[6] & 0xf8) << 13);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 53 to 68
	value = ((uint32_t)(input[6] & 0x07) << 29) |
			((uint32_t)input[7] << 21) |
			((uint32_t)(input[8] & 0xf8) << 13);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 69 to 84
	value = ((uint32_t)(input[8] & 0x07) << 29) |
			((uint32_t)input[9] << 21) |
			((uint32_t)(input[10] & 0xf8) << 13);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 85 to 100
	value = ((uint32_t)(input[10] & 0x07) << 29) |
			((uint32_t)input[11] << 21) |
			((uint32_t)(input[12] & 0xf8) << 13);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 101 to 116
	value = ((uint32_t)(input[12] & 0x07) << 29) |
			((uint32_t)input[13] << 21) |
			((uint32_t)(input[14] & 0xf8) << 13);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 117 to 132
	value = ((uint32_t)(input[14] & 0x07) << 29) |
			((uint32_t)input[15] << 21) |
			((uint32_t)(input[16] & 0xf8) << 13);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 133 to 148
	value = ((uint32_t)(input[16] & 0x07) << 29) |
			((uint32_t)input[17] << 21) |
			((uint32_t)(input[18] & 0xf8) << 13);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 149 to 164
	value = ((uint32_t)(input[18] & 0x07) << 29) |
			((uint32_t)input[19] << 21) |
			((uint32_t)(input[20] & 0xf8) << 13);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 165 to 180
	value = ((uint32_t)(input[20] & 0x07) << 29) |
			((uint32_t)input[21] << 21) |
			((uint32_t)(input[22] & 0xf8) << 13);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 181 to 196
	value = ((uint32_t)(input[22] & 0x07) << 29) |
			((uint32_t)input[23] << 21) |
			((uint32_t)(input[24] & 0xf8) << 13);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 197 to 212
	value = ((uint32_t)(input[24] & 0x07) << 29) |
			((uint32_t)input[25] << 21) |
			((uint32_t)(input[26] & 0xf8) << 13);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 213 to 228
	value = ((uint32_t)(input[26] & 0x07) << 29) |
			((uint32_t)input[27] << 21) |
			((uint32_t)(input[28] & 0xf8) << 13);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 229 to 244
	value = ((uint32_t)(input[28] & 0x07) << 29) |
			((uint32_t)input[29] << 21) |
			((uint32_t)(input[30] & 0xf8) << 13);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 245 to 260
	value = ((uint32_t)(input[30] & 0x07) << 29) |
			((uint32_t)input[31] << 21) |
			((uint32_t)(input[32] & 0xf8) << 13);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 261 to 276
	value = ((uint32_t)(input[32] & 0x07) << 29) |
			((uint32_t)input[33] << 21) |
			((uint32_t)(input[34] & 0xf8) << 13);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 277 to 292
	value = ((uint32_t)(input[34] & 0x07) << 29) |
			((uint32_t)input[35] << 21) |
			((uint32_t)(input[36] & 0xf8) << 13);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 293 to 308
	value = ((uint32_t)(input[36] & 0x07) << 29) |
			((uint32_t)input[37] << 21) |
			((uint32_t)(input[38] & 0xf8) << 13);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 309 to 324
	value = ((uint32_t)(input[38] & 0x07) << 29) |
			((uint32_t)input[39] << 21) |
			((uint32_t)(input[40] & 0xf8) << 13);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 325 to 340
	value = ((uint32_t)(input[40] & 0x07) << 29) |
			((uint32_t)input[41] << 21) |
			((uint32_t)(input[42] & 0xf8) << 13);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 341 to 356
	value = ((uint32_t)(input[42] & 0x07) << 29) |
			((uint32_t)input[43] << 21) |
			((uint32_t)(input[44] & 0xf8) << 13);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 357 to 372
	value = ((uint32_t)(input[44] & 0x07) << 29) |
			((uint32_t)input[45] << 21) |
			((uint32_t)(input[46] & 0xf8) << 13);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 373 to 388
	value = ((uint32_t)(input[46] & 0x07) << 29) |
			((uint32_t)input[47] << 21) |
			((uint32_t)(input[48] & 0xf8) << 13);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 389 to 404
	value = ((uint32_t)(input[48] & 0x07) << 29) |
			((uint32_t)input[49] << 21) |
			((uint32_t)(input[50] & 0xf8) << 13);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 405 to 420
	value = ((uint32_t)(input[50] & 0x07) << 29) |
			((uint32_t)input[51] << 21) |
			((uint32_t)(input[52] & 0xf8) << 13);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 421 to 436
	value = ((uint32_t)(input[52] & 0x07) << 29) |
			((uint32_t)input[53] << 21) |
			((uint32_t)(input[54] & 0xf8) << 13);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 437 to 452
	value = ((uint32_t)(input[54] & 0x07) << 29) |
			((uint32_t)input[55] << 21) |
			((uint32_t)(input[56] & 0xf8) << 13);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 453 to 468
	value = ((uint32_t)(input[56] & 0x07) << 29) |
			((uint32_t)input[57] << 21) |
			((uint32_t)(input[58] & 0xf8) << 13);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 469 to 484
	value = ((uint32_t)(input[58] & 0x07) << 29) |
			((uint32_t)input[59] << 21) |
			((uint32_t)(input[60] & 0xf8) << 13);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 485 to 500
	value = ((uint32_t)(input[60] & 0x07) << 29) |
			((uint32_t)input[61] << 21) |
			((uint32_t)(input[62] & 0xf8) << 13);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 501 to 516
	value = ((uint32_t)(input[62] & 0x07) << 29) |
			((uint32_t)input[63] << 21) |
			((uint32_t)(input[64] & 0xf8) << 13);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 517 to 532
	value = ((uint32_t)(input[64] & 0x07) << 29) |
			((uint32_t)input[65] << 21) |
			((uint32_t)(input[66] & 0xf8) << 13);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 533 to 548
	value = ((uint32_t)(input[66] & 0x07) << 29) |
			((uint32_t)input[67] << 21) |
			((uint32_t)(input[68] & 0xf8) << 13);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 549 to 564
	value = ((uint32_t)(input[68] & 0x07) << 29) |
			((uint32_t)input[69] << 21) |
			((uint32_t)(input[70] & 0xf8) << 13);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 565 to 580
	value = ((uint32_t)(input[70] & 0x07) << 29) |
			((uint32_t)input[71] << 21) |
			((uint32_t)(input[72] & 0xf8) << 13);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 581 to 596
	value = ((uint32_t)(input[72] & 0x07) << 29) |
			((uint32_t)input[73] << 21) |
			((uint32_t)(input[74] & 0xf8) << 13);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 597 to 612
	value = ((uint32_t)(input[74] & 0x07) << 29) |
			((uint32_t)input[75] << 21) |
			((uint32_t)(input[76] & 0xf8) << 13);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 613 to 628
	value = ((uint32_t)(input[76] & 0x07) << 29) |
			((uint32_t)input[77] << 21) |
			((uint32_t)(input[78] & 0xf8) << 13);
	output[38] = (double)(value >> 16);
}

static void unpack_39_16bit_unsigned_5off(const uint8_t * input, double * output, void *closure) {
	// Unpack 39 values into output
	// Values are 16-bit unsigned
	// Skip 5 bits, read 624 bits of data.
	// Input must be at least 79 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 5 to 20
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)(input[2] & 0xf8) << 13);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 21 to 36
	value = ((uint32_t)(input[2] & 0x07) << 29) |
			((uint32_t)input[3] << 21) |
			((uint32_t)(input[4] & 0xf8) << 13);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 37 to 52
	value = ((uint32_t)(input[4] & 0x07) << 29) |
			((uint32_t)input[5] << 21) |
			((uint32_t)(input[6] & 0xf8) << 13);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 53 to 68
	value = ((uint32_t)(input[6] & 0x07) << 29) |
			((uint32_t)input[7] << 21) |
			((uint32_t)(input[8] & 0xf8) << 13);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 69 to 84
	value = ((uint32_t)(input[8] & 0x07) << 29) |
			((uint32_t)input[9] << 21) |
			((uint32_t)(input[10] & 0xf8) << 13);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 85 to 100
	value = ((uint32_t)(input[10] & 0x07) << 29) |
			((uint32_t)input[11] << 21) |
			((uint32_t)(input[12] & 0xf8) << 13);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 101 to 116
	value = ((uint32_t)(input[12] & 0x07) << 29) |
			((uint32_t)input[13] << 21) |
			((uint32_t)(input[14] & 0xf8) << 13);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 117 to 132
	value = ((uint32_t)(input[14] & 0x07) << 29) |
			((uint32_t)input[15] << 21) |
			((uint32_t)(input[16] & 0xf8) << 13);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 133 to 148
	value = ((uint32_t)(input[16] & 0x07) << 29) |
			((uint32_t)input[17] << 21) |
			((uint32_t)(input[18] & 0xf8) << 13);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 149 to 164
	value = ((uint32_t)(input[18] & 0x07) << 29) |
			((uint32_t)input[19] << 21) |
			((uint32_t)(input[20] & 0xf8) << 13);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 165 to 180
	value = ((uint32_t)(input[20] & 0x07) << 29) |
			((uint32_t)input[21] << 21) |
			((uint32_t)(input[22] & 0xf8) << 13);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 181 to 196
	value = ((uint32_t)(input[22] & 0x07) << 29) |
			((uint32_t)input[23] << 21) |
			((uint32_t)(input[24] & 0xf8) << 13);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 197 to 212
	value = ((uint32_t)(input[24] & 0x07) << 29) |
			((uint32_t)input[25] << 21) |
			((uint32_t)(input[26] & 0xf8) << 13);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 213 to 228
	value = ((uint32_t)(input[26] & 0x07) << 29) |
			((uint32_t)input[27] << 21) |
			((uint32_t)(input[28] & 0xf8) << 13);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 229 to 244
	value = ((uint32_t)(input[28] & 0x07) << 29) |
			((uint32_t)input[29] << 21) |
			((uint32_t)(input[30] & 0xf8) << 13);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 245 to 260
	value = ((uint32_t)(input[30] & 0x07) << 29) |
			((uint32_t)input[31] << 21) |
			((uint32_t)(input[32] & 0xf8) << 13);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 261 to 276
	value = ((uint32_t)(input[32] & 0x07) << 29) |
			((uint32_t)input[33] << 21) |
			((uint32_t)(input[34] & 0xf8) << 13);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 277 to 292
	value = ((uint32_t)(input[34] & 0x07) << 29) |
			((uint32_t)input[35] << 21) |
			((uint32_t)(input[36] & 0xf8) << 13);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 293 to 308
	value = ((uint32_t)(input[36] & 0x07) << 29) |
			((uint32_t)input[37] << 21) |
			((uint32_t)(input[38] & 0xf8) << 13);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 309 to 324
	value = ((uint32_t)(input[38] & 0x07) << 29) |
			((uint32_t)input[39] << 21) |
			((uint32_t)(input[40] & 0xf8) << 13);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 325 to 340
	value = ((uint32_t)(input[40] & 0x07) << 29) |
			((uint32_t)input[41] << 21) |
			((uint32_t)(input[42] & 0xf8) << 13);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 341 to 356
	value = ((uint32_t)(input[42] & 0x07) << 29) |
			((uint32_t)input[43] << 21) |
			((uint32_t)(input[44] & 0xf8) << 13);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 357 to 372
	value = ((uint32_t)(input[44] & 0x07) << 29) |
			((uint32_t)input[45] << 21) |
			((uint32_t)(input[46] & 0xf8) << 13);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 373 to 388
	value = ((uint32_t)(input[46] & 0x07) << 29) |
			((uint32_t)input[47] << 21) |
			((uint32_t)(input[48] & 0xf8) << 13);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 389 to 404
	value = ((uint32_t)(input[48] & 0x07) << 29) |
			((uint32_t)input[49] << 21) |
			((uint32_t)(input[50] & 0xf8) << 13);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 405 to 420
	value = ((uint32_t)(input[50] & 0x07) << 29) |
			((uint32_t)input[51] << 21) |
			((uint32_t)(input[52] & 0xf8) << 13);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 421 to 436
	value = ((uint32_t)(input[52] & 0x07) << 29) |
			((uint32_t)input[53] << 21) |
			((uint32_t)(input[54] & 0xf8) << 13);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 437 to 452
	value = ((uint32_t)(input[54] & 0x07) << 29) |
			((uint32_t)input[55] << 21) |
			((uint32_t)(input[56] & 0xf8) << 13);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 453 to 468
	value = ((uint32_t)(input[56] & 0x07) << 29) |
			((uint32_t)input[57] << 21) |
			((uint32_t)(input[58] & 0xf8) << 13);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 469 to 484
	value = ((uint32_t)(input[58] & 0x07) << 29) |
			((uint32_t)input[59] << 21) |
			((uint32_t)(input[60] & 0xf8) << 13);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 485 to 500
	value = ((uint32_t)(input[60] & 0x07) << 29) |
			((uint32_t)input[61] << 21) |
			((uint32_t)(input[62] & 0xf8) << 13);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 501 to 516
	value = ((uint32_t)(input[62] & 0x07) << 29) |
			((uint32_t)input[63] << 21) |
			((uint32_t)(input[64] & 0xf8) << 13);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 517 to 532
	value = ((uint32_t)(input[64] & 0x07) << 29) |
			((uint32_t)input[65] << 21) |
			((uint32_t)(input[66] & 0xf8) << 13);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 533 to 548
	value = ((uint32_t)(input[66] & 0x07) << 29) |
			((uint32_t)input[67] << 21) |
			((uint32_t)(input[68] & 0xf8) << 13);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 549 to 564
	value = ((uint32_t)(input[68] & 0x07) << 29) |
			((uint32_t)input[69] << 21) |
			((uint32_t)(input[70] & 0xf8) << 13);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 565 to 580
	value = ((uint32_t)(input[70] & 0x07) << 29) |
			((uint32_t)input[71] << 21) |
			((uint32_t)(input[72] & 0xf8) << 13);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 581 to 596
	value = ((uint32_t)(input[72] & 0x07) << 29) |
			((uint32_t)input[73] << 21) |
			((uint32_t)(input[74] & 0xf8) << 13);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 597 to 612
	value = ((uint32_t)(input[74] & 0x07) << 29) |
			((uint32_t)input[75] << 21) |
			((uint32_t)(input[76] & 0xf8) << 13);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 613 to 628
	value = ((uint32_t)(input[76] & 0x07) << 29) |
			((uint32_t)input[77] << 21) |
			((uint32_t)(input[78] & 0xf8) << 13);
	output[38] = (double)(value >> 16);
}

static void unpack_39_16bit_signed_6off(const uint8_t * input, double * output, void *closure) {
	// Unpack 39 values into output
	// Values are 16-bit signed
	// Skip 6 bits, read 624 bits of data.
	// Input must be at least 79 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 6 to 21
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)(input[2] & 0xfc) << 14);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 22 to 37
	value = ((uint32_t)(input[2] & 0x03) << 30) |
			((uint32_t)input[3] << 22) |
			((uint32_t)(input[4] & 0xfc) << 14);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 38 to 53
	value = ((uint32_t)(input[4] & 0x03) << 30) |
			((uint32_t)input[5] << 22) |
			((uint32_t)(input[6] & 0xfc) << 14);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 54 to 69
	value = ((uint32_t)(input[6] & 0x03) << 30) |
			((uint32_t)input[7] << 22) |
			((uint32_t)(input[8] & 0xfc) << 14);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 70 to 85
	value = ((uint32_t)(input[8] & 0x03) << 30) |
			((uint32_t)input[9] << 22) |
			((uint32_t)(input[10] & 0xfc) << 14);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 86 to 101
	value = ((uint32_t)(input[10] & 0x03) << 30) |
			((uint32_t)input[11] << 22) |
			((uint32_t)(input[12] & 0xfc) << 14);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 102 to 117
	value = ((uint32_t)(input[12] & 0x03) << 30) |
			((uint32_t)input[13] << 22) |
			((uint32_t)(input[14] & 0xfc) << 14);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 118 to 133
	value = ((uint32_t)(input[14] & 0x03) << 30) |
			((uint32_t)input[15] << 22) |
			((uint32_t)(input[16] & 0xfc) << 14);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 134 to 149
	value = ((uint32_t)(input[16] & 0x03) << 30) |
			((uint32_t)input[17] << 22) |
			((uint32_t)(input[18] & 0xfc) << 14);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 150 to 165
	value = ((uint32_t)(input[18] & 0x03) << 30) |
			((uint32_t)input[19] << 22) |
			((uint32_t)(input[20] & 0xfc) << 14);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 166 to 181
	value = ((uint32_t)(input[20] & 0x03) << 30) |
			((uint32_t)input[21] << 22) |
			((uint32_t)(input[22] & 0xfc) << 14);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 182 to 197
	value = ((uint32_t)(input[22] & 0x03) << 30) |
			((uint32_t)input[23] << 22) |
			((uint32_t)(input[24] & 0xfc) << 14);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 198 to 213
	value = ((uint32_t)(input[24] & 0x03) << 30) |
			((uint32_t)input[25] << 22) |
			((uint32_t)(input[26] & 0xfc) << 14);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 214 to 229
	value = ((uint32_t)(input[26] & 0x03) << 30) |
			((uint32_t)input[27] << 22) |
			((uint32_t)(input[28] & 0xfc) << 14);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 230 to 245
	value = ((uint32_t)(input[28] & 0x03) << 30) |
			((uint32_t)input[29] << 22) |
			((uint32_t)(input[30] & 0xfc) << 14);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 246 to 261
	value = ((uint32_t)(input[30] & 0x03) << 30) |
			((uint32_t)input[31] << 22) |
			((uint32_t)(input[32] & 0xfc) << 14);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 262 to 277
	value = ((uint32_t)(input[32] & 0x03) << 30) |
			((uint32_t)input[33] << 22) |
			((uint32_t)(input[34] & 0xfc) << 14);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 278 to 293
	value = ((uint32_t)(input[34] & 0x03) << 30) |
			((uint32_t)input[35] << 22) |
			((uint32_t)(input[36] & 0xfc) << 14);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 294 to 309
	value = ((uint32_t)(input[36] & 0x03) << 30) |
			((uint32_t)input[37] << 22) |
			((uint32_t)(input[38] & 0xfc) << 14);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 310 to 325
	value = ((uint32_t)(input[38] & 0x03) << 30) |
			((uint32_t)input[39] << 22) |
			((uint32_t)(input[40] & 0xfc) << 14);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 326 to 341
	value = ((uint32_t)(input[40] & 0x03) << 30) |
			((uint32_t)input[41] << 22) |
			((uint32_t)(input[42] & 0xfc) << 14);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 342 to 357
	value = ((uint32_t)(input[42] & 0x03) << 30) |
			((uint32_t)input[43] << 22) |
			((uint32_t)(input[44] & 0xfc) << 14);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 358 to 373
	value = ((uint32_t)(input[44] & 0x03) << 30) |
			((uint32_t)input[45] << 22) |
			((uint32_t)(input[46] & 0xfc) << 14);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 374 to 389
	value = ((uint32_t)(input[46] & 0x03) << 30) |
			((uint32_t)input[47] << 22) |
			((uint32_t)(input[48] & 0xfc) << 14);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 390 to 405
	value = ((uint32_t)(input[48] & 0x03) << 30) |
			((uint32_t)input[49] << 22) |
			((uint32_t)(input[50] & 0xfc) << 14);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 406 to 421
	value = ((uint32_t)(input[50] & 0x03) << 30) |
			((uint32_t)input[51] << 22) |
			((uint32_t)(input[52] & 0xfc) << 14);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 422 to 437
	value = ((uint32_t)(input[52] & 0x03) << 30) |
			((uint32_t)input[53] << 22) |
			((uint32_t)(input[54] & 0xfc) << 14);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 438 to 453
	value = ((uint32_t)(input[54] & 0x03) << 30) |
			((uint32_t)input[55] << 22) |
			((uint32_t)(input[56] & 0xfc) << 14);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 454 to 469
	value = ((uint32_t)(input[56] & 0x03) << 30) |
			((uint32_t)input[57] << 22) |
			((uint32_t)(input[58] & 0xfc) << 14);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 470 to 485
	value = ((uint32_t)(input[58] & 0x03) << 30) |
			((uint32_t)input[59] << 22) |
			((uint32_t)(input[60] & 0xfc) << 14);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 486 to 501
	value = ((uint32_t)(input[60] & 0x03) << 30) |
			((uint32_t)input[61] << 22) |
			((uint32_t)(input[62] & 0xfc) << 14);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 502 to 517
	value = ((uint32_t)(input[62] & 0x03) << 30) |
			((uint32_t)input[63] << 22) |
			((uint32_t)(input[64] & 0xfc) << 14);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 518 to 533
	value = ((uint32_t)(input[64] & 0x03) << 30) |
			((uint32_t)input[65] << 22) |
			((uint32_t)(input[66] & 0xfc) << 14);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 534 to 549
	value = ((uint32_t)(input[66] & 0x03) << 30) |
			((uint32_t)input[67] << 22) |
			((uint32_t)(input[68] & 0xfc) << 14);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 550 to 565
	value = ((uint32_t)(input[68] & 0x03) << 30) |
			((uint32_t)input[69] << 22) |
			((uint32_t)(input[70] & 0xfc) << 14);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 566 to 581
	value = ((uint32_t)(input[70] & 0x03) << 30) |
			((uint32_t)input[71] << 22) |
			((uint32_t)(input[72] & 0xfc) << 14);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 582 to 597
	value = ((uint32_t)(input[72] & 0x03) << 30) |
			((uint32_t)input[73] << 22) |
			((uint32_t)(input[74] & 0xfc) << 14);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 598 to 613
	value = ((uint32_t)(input[74] & 0x03) << 30) |
			((uint32_t)input[75] << 22) |
			((uint32_t)(input[76] & 0xfc) << 14);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 614 to 629
	value = ((uint32_t)(input[76] & 0x03) << 30) |
			((uint32_t)input[77] << 22) |
			((uint32_t)(input[78] & 0xfc) << 14);
	output[38] = (double)(value >> 16);
}

static void unpack_39_16bit_unsigned_6off(const uint8_t * input, double * output, void *closure) {
	// Unpack 39 values into output
	// Values are 16-bit unsigned
	// Skip 6 bits, read 624 bits of data.
	// Input must be at least 79 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 6 to 21
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)(input[2] & 0xfc) << 14);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 22 to 37
	value = ((uint32_t)(input[2] & 0x03) << 30) |
			((uint32_t)input[3] << 22) |
			((uint32_t)(input[4] & 0xfc) << 14);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 38 to 53
	value = ((uint32_t)(input[4] & 0x03) << 30) |
			((uint32_t)input[5] << 22) |
			((uint32_t)(input[6] & 0xfc) << 14);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 54 to 69
	value = ((uint32_t)(input[6] & 0x03) << 30) |
			((uint32_t)input[7] << 22) |
			((uint32_t)(input[8] & 0xfc) << 14);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 70 to 85
	value = ((uint32_t)(input[8] & 0x03) << 30) |
			((uint32_t)input[9] << 22) |
			((uint32_t)(input[10] & 0xfc) << 14);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 86 to 101
	value = ((uint32_t)(input[10] & 0x03) << 30) |
			((uint32_t)input[11] << 22) |
			((uint32_t)(input[12] & 0xfc) << 14);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 102 to 117
	value = ((uint32_t)(input[12] & 0x03) << 30) |
			((uint32_t)input[13] << 22) |
			((uint32_t)(input[14] & 0xfc) << 14);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 118 to 133
	value = ((uint32_t)(input[14] & 0x03) << 30) |
			((uint32_t)input[15] << 22) |
			((uint32_t)(input[16] & 0xfc) << 14);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 134 to 149
	value = ((uint32_t)(input[16] & 0x03) << 30) |
			((uint32_t)input[17] << 22) |
			((uint32_t)(input[18] & 0xfc) << 14);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 150 to 165
	value = ((uint32_t)(input[18] & 0x03) << 30) |
			((uint32_t)input[19] << 22) |
			((uint32_t)(input[20] & 0xfc) << 14);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 166 to 181
	value = ((uint32_t)(input[20] & 0x03) << 30) |
			((uint32_t)input[21] << 22) |
			((uint32_t)(input[22] & 0xfc) << 14);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 182 to 197
	value = ((uint32_t)(input[22] & 0x03) << 30) |
			((uint32_t)input[23] << 22) |
			((uint32_t)(input[24] & 0xfc) << 14);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 198 to 213
	value = ((uint32_t)(input[24] & 0x03) << 30) |
			((uint32_t)input[25] << 22) |
			((uint32_t)(input[26] & 0xfc) << 14);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 214 to 229
	value = ((uint32_t)(input[26] & 0x03) << 30) |
			((uint32_t)input[27] << 22) |
			((uint32_t)(input[28] & 0xfc) << 14);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 230 to 245
	value = ((uint32_t)(input[28] & 0x03) << 30) |
			((uint32_t)input[29] << 22) |
			((uint32_t)(input[30] & 0xfc) << 14);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 246 to 261
	value = ((uint32_t)(input[30] & 0x03) << 30) |
			((uint32_t)input[31] << 22) |
			((uint32_t)(input[32] & 0xfc) << 14);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 262 to 277
	value = ((uint32_t)(input[32] & 0x03) << 30) |
			((uint32_t)input[33] << 22) |
			((uint32_t)(input[34] & 0xfc) << 14);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 278 to 293
	value = ((uint32_t)(input[34] & 0x03) << 30) |
			((uint32_t)input[35] << 22) |
			((uint32_t)(input[36] & 0xfc) << 14);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 294 to 309
	value = ((uint32_t)(input[36] & 0x03) << 30) |
			((uint32_t)input[37] << 22) |
			((uint32_t)(input[38] & 0xfc) << 14);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 310 to 325
	value = ((uint32_t)(input[38] & 0x03) << 30) |
			((uint32_t)input[39] << 22) |
			((uint32_t)(input[40] & 0xfc) << 14);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 326 to 341
	value = ((uint32_t)(input[40] & 0x03) << 30) |
			((uint32_t)input[41] << 22) |
			((uint32_t)(input[42] & 0xfc) << 14);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 342 to 357
	value = ((uint32_t)(input[42] & 0x03) << 30) |
			((uint32_t)input[43] << 22) |
			((uint32_t)(input[44] & 0xfc) << 14);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 358 to 373
	value = ((uint32_t)(input[44] & 0x03) << 30) |
			((uint32_t)input[45] << 22) |
			((uint32_t)(input[46] & 0xfc) << 14);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 374 to 389
	value = ((uint32_t)(input[46] & 0x03) << 30) |
			((uint32_t)input[47] << 22) |
			((uint32_t)(input[48] & 0xfc) << 14);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 390 to 405
	value = ((uint32_t)(input[48] & 0x03) << 30) |
			((uint32_t)input[49] << 22) |
			((uint32_t)(input[50] & 0xfc) << 14);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 406 to 421
	value = ((uint32_t)(input[50] & 0x03) << 30) |
			((uint32_t)input[51] << 22) |
			((uint32_t)(input[52] & 0xfc) << 14);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 422 to 437
	value = ((uint32_t)(input[52] & 0x03) << 30) |
			((uint32_t)input[53] << 22) |
			((uint32_t)(input[54] & 0xfc) << 14);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 438 to 453
	value = ((uint32_t)(input[54] & 0x03) << 30) |
			((uint32_t)input[55] << 22) |
			((uint32_t)(input[56] & 0xfc) << 14);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 454 to 469
	value = ((uint32_t)(input[56] & 0x03) << 30) |
			((uint32_t)input[57] << 22) |
			((uint32_t)(input[58] & 0xfc) << 14);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 470 to 485
	value = ((uint32_t)(input[58] & 0x03) << 30) |
			((uint32_t)input[59] << 22) |
			((uint32_t)(input[60] & 0xfc) << 14);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 486 to 501
	value = ((uint32_t)(input[60] & 0x03) << 30) |
			((uint32_t)input[61] << 22) |
			((uint32_t)(input[62] & 0xfc) << 14);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 502 to 517
	value = ((uint32_t)(input[62] & 0x03) << 30) |
			((uint32_t)input[63] << 22) |
			((uint32_t)(input[64] & 0xfc) << 14);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 518 to 533
	value = ((uint32_t)(input[64] & 0x03) << 30) |
			((uint32_t)input[65] << 22) |
			((uint32_t)(input[66] & 0xfc) << 14);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 534 to 549
	value = ((uint32_t)(input[66] & 0x03) << 30) |
			((uint32_t)input[67] << 22) |
			((uint32_t)(input[68] & 0xfc) << 14);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 550 to 565
	value = ((uint32_t)(input[68] & 0x03) << 30) |
			((uint32_t)input[69] << 22) |
			((uint32_t)(input[70] & 0xfc) << 14);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 566 to 581
	value = ((uint32_t)(input[70] & 0x03) << 30) |
			((uint32_t)input[71] << 22) |
			((uint32_t)(input[72] & 0xfc) << 14);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 582 to 597
	value = ((uint32_t)(input[72] & 0x03) << 30) |
			((uint32_t)input[73] << 22) |
			((uint32_t)(input[74] & 0xfc) << 14);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 598 to 613
	value = ((uint32_t)(input[74] & 0x03) << 30) |
			((uint32_t)input[75] << 22) |
			((uint32_t)(input[76] & 0xfc) << 14);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 614 to 629
	value = ((uint32_t)(input[76] & 0x03) << 30) |
			((uint32_t)input[77] << 22) |
			((uint32_t)(input[78] & 0xfc) << 14);
	output[38] = (double)(value >> 16);
}

static void unpack_39_16bit_signed_7off(const uint8_t * input, double * output, void *closure) {
	// Unpack 39 values into output
	// Values are 16-bit signed
	// Skip 7 bits, read 624 bits of data.
	// Input must be at least 79 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 7 to 22
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)(input[2] & 0xfe) << 15);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 23 to 38
	value = ((uint32_t)(input[2] & 0x01) << 31) |
			((uint32_t)input[3] << 23) |
			((uint32_t)(input[4] & 0xfe) << 15);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 39 to 54
	value = ((uint32_t)(input[4] & 0x01) << 31) |
			((uint32_t)input[5] << 23) |
			((uint32_t)(input[6] & 0xfe) << 15);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 55 to 70
	value = ((uint32_t)(input[6] & 0x01) << 31) |
			((uint32_t)input[7] << 23) |
			((uint32_t)(input[8] & 0xfe) << 15);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 71 to 86
	value = ((uint32_t)(input[8] & 0x01) << 31) |
			((uint32_t)input[9] << 23) |
			((uint32_t)(input[10] & 0xfe) << 15);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 87 to 102
	value = ((uint32_t)(input[10] & 0x01) << 31) |
			((uint32_t)input[11] << 23) |
			((uint32_t)(input[12] & 0xfe) << 15);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 103 to 118
	value = ((uint32_t)(input[12] & 0x01) << 31) |
			((uint32_t)input[13] << 23) |
			((uint32_t)(input[14] & 0xfe) << 15);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 119 to 134
	value = ((uint32_t)(input[14] & 0x01) << 31) |
			((uint32_t)input[15] << 23) |
			((uint32_t)(input[16] & 0xfe) << 15);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 135 to 150
	value = ((uint32_t)(input[16] & 0x01) << 31) |
			((uint32_t)input[17] << 23) |
			((uint32_t)(input[18] & 0xfe) << 15);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 151 to 166
	value = ((uint32_t)(input[18] & 0x01) << 31) |
			((uint32_t)input[19] << 23) |
			((uint32_t)(input[20] & 0xfe) << 15);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 167 to 182
	value = ((uint32_t)(input[20] & 0x01) << 31) |
			((uint32_t)input[21] << 23) |
			((uint32_t)(input[22] & 0xfe) << 15);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 183 to 198
	value = ((uint32_t)(input[22] & 0x01) << 31) |
			((uint32_t)input[23] << 23) |
			((uint32_t)(input[24] & 0xfe) << 15);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 199 to 214
	value = ((uint32_t)(input[24] & 0x01) << 31) |
			((uint32_t)input[25] << 23) |
			((uint32_t)(input[26] & 0xfe) << 15);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 215 to 230
	value = ((uint32_t)(input[26] & 0x01) << 31) |
			((uint32_t)input[27] << 23) |
			((uint32_t)(input[28] & 0xfe) << 15);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 231 to 246
	value = ((uint32_t)(input[28] & 0x01) << 31) |
			((uint32_t)input[29] << 23) |
			((uint32_t)(input[30] & 0xfe) << 15);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 247 to 262
	value = ((uint32_t)(input[30] & 0x01) << 31) |
			((uint32_t)input[31] << 23) |
			((uint32_t)(input[32] & 0xfe) << 15);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 263 to 278
	value = ((uint32_t)(input[32] & 0x01) << 31) |
			((uint32_t)input[33] << 23) |
			((uint32_t)(input[34] & 0xfe) << 15);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 279 to 294
	value = ((uint32_t)(input[34] & 0x01) << 31) |
			((uint32_t)input[35] << 23) |
			((uint32_t)(input[36] & 0xfe) << 15);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 295 to 310
	value = ((uint32_t)(input[36] & 0x01) << 31) |
			((uint32_t)input[37] << 23) |
			((uint32_t)(input[38] & 0xfe) << 15);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 311 to 326
	value = ((uint32_t)(input[38] & 0x01) << 31) |
			((uint32_t)input[39] << 23) |
			((uint32_t)(input[40] & 0xfe) << 15);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 327 to 342
	value = ((uint32_t)(input[40] & 0x01) << 31) |
			((uint32_t)input[41] << 23) |
			((uint32_t)(input[42] & 0xfe) << 15);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 343 to 358
	value = ((uint32_t)(input[42] & 0x01) << 31) |
			((uint32_t)input[43] << 23) |
			((uint32_t)(input[44] & 0xfe) << 15);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 359 to 374
	value = ((uint32_t)(input[44] & 0x01) << 31) |
			((uint32_t)input[45] << 23) |
			((uint32_t)(input[46] & 0xfe) << 15);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 375 to 390
	value = ((uint32_t)(input[46] & 0x01) << 31) |
			((uint32_t)input[47] << 23) |
			((uint32_t)(input[48] & 0xfe) << 15);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 391 to 406
	value = ((uint32_t)(input[48] & 0x01) << 31) |
			((uint32_t)input[49] << 23) |
			((uint32_t)(input[50] & 0xfe) << 15);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 407 to 422
	value = ((uint32_t)(input[50] & 0x01) << 31) |
			((uint32_t)input[51] << 23) |
			((uint32_t)(input[52] & 0xfe) << 15);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 423 to 438
	value = ((uint32_t)(input[52] & 0x01) << 31) |
			((uint32_t)input[53] << 23) |
			((uint32_t)(input[54] & 0xfe) << 15);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 439 to 454
	value = ((uint32_t)(input[54] & 0x01) << 31) |
			((uint32_t)input[55] << 23) |
			((uint32_t)(input[56] & 0xfe) << 15);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 455 to 470
	value = ((uint32_t)(input[56] & 0x01) << 31) |
			((uint32_t)input[57] << 23) |
			((uint32_t)(input[58] & 0xfe) << 15);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 471 to 486
	value = ((uint32_t)(input[58] & 0x01) << 31) |
			((uint32_t)input[59] << 23) |
			((uint32_t)(input[60] & 0xfe) << 15);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 487 to 502
	value = ((uint32_t)(input[60] & 0x01) << 31) |
			((uint32_t)input[61] << 23) |
			((uint32_t)(input[62] & 0xfe) << 15);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 503 to 518
	value = ((uint32_t)(input[62] & 0x01) << 31) |
			((uint32_t)input[63] << 23) |
			((uint32_t)(input[64] & 0xfe) << 15);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 519 to 534
	value = ((uint32_t)(input[64] & 0x01) << 31) |
			((uint32_t)input[65] << 23) |
			((uint32_t)(input[66] & 0xfe) << 15);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 535 to 550
	value = ((uint32_t)(input[66] & 0x01) << 31) |
			((uint32_t)input[67] << 23) |
			((uint32_t)(input[68] & 0xfe) << 15);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 551 to 566
	value = ((uint32_t)(input[68] & 0x01) << 31) |
			((uint32_t)input[69] << 23) |
			((uint32_t)(input[70] & 0xfe) << 15);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 567 to 582
	value = ((uint32_t)(input[70] & 0x01) << 31) |
			((uint32_t)input[71] << 23) |
			((uint32_t)(input[72] & 0xfe) << 15);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 583 to 598
	value = ((uint32_t)(input[72] & 0x01) << 31) |
			((uint32_t)input[73] << 23) |
			((uint32_t)(input[74] & 0xfe) << 15);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 599 to 614
	value = ((uint32_t)(input[74] & 0x01) << 31) |
			((uint32_t)input[75] << 23) |
			((uint32_t)(input[76] & 0xfe) << 15);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 615 to 630
	value = ((uint32_t)(input[76] & 0x01) << 31) |
			((uint32_t)input[77] << 23) |
			((uint32_t)(input[78] & 0xfe) << 15);
	output[38] = (double)(value >> 16);
}

static void unpack_39_16bit_unsigned_7off(const uint8_t * input, double * output, void *closure) {
	// Unpack 39 values into output
	// Values are 16-bit unsigned
	// Skip 7 bits, read 624 bits of data.
	// Input must be at least 79 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 7 to 22
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)(input[2] & 0xfe) << 15);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 23 to 38
	value = ((uint32_t)(input[2] & 0x01) << 31) |
			((uint32_t)input[3] << 23) |
			((uint32_t)(input[4] & 0xfe) << 15);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 39 to 54
	value = ((uint32_t)(input[4] & 0x01) << 31) |
			((uint32_t)input[5] << 23) |
			((uint32_t)(input[6] & 0xfe) << 15);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 55 to 70
	value = ((uint32_t)(input[6] & 0x01) << 31) |
			((uint32_t)input[7] << 23) |
			((uint32_t)(input[8] & 0xfe) << 15);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 71 to 86
	value = ((uint32_t)(input[8] & 0x01) << 31) |
			((uint32_t)input[9] << 23) |
			((uint32_t)(input[10] & 0xfe) << 15);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 87 to 102
	value = ((uint32_t)(input[10] & 0x01) << 31) |
			((uint32_t)input[11] << 23) |
			((uint32_t)(input[12] & 0xfe) << 15);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 103 to 118
	value = ((uint32_t)(input[12] & 0x01) << 31) |
			((uint32_t)input[13] << 23) |
			((uint32_t)(input[14] & 0xfe) << 15);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 119 to 134
	value = ((uint32_t)(input[14] & 0x01) << 31) |
			((uint32_t)input[15] << 23) |
			((uint32_t)(input[16] & 0xfe) << 15);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 135 to 150
	value = ((uint32_t)(input[16] & 0x01) << 31) |
			((uint32_t)input[17] << 23) |
			((uint32_t)(input[18] & 0xfe) << 15);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 151 to 166
	value = ((uint32_t)(input[18] & 0x01) << 31) |
			((uint32_t)input[19] << 23) |
			((uint32_t)(input[20] & 0xfe) << 15);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 167 to 182
	value = ((uint32_t)(input[20] & 0x01) << 31) |
			((uint32_t)input[21] << 23) |
			((uint32_t)(input[22] & 0xfe) << 15);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 183 to 198
	value = ((uint32_t)(input[22] & 0x01) << 31) |
			((uint32_t)input[23] << 23) |
			((uint32_t)(input[24] & 0xfe) << 15);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 199 to 214
	value = ((uint32_t)(input[24] & 0x01) << 31) |
			((uint32_t)input[25] << 23) |
			((uint32_t)(input[26] & 0xfe) << 15);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 215 to 230
	value = ((uint32_t)(input[26] & 0x01) << 31) |
			((uint32_t)input[27] << 23) |
			((uint32_t)(input[28] & 0xfe) << 15);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 231 to 246
	value = ((uint32_t)(input[28] & 0x01) << 31) |
			((uint32_t)input[29] << 23) |
			((uint32_t)(input[30] & 0xfe) << 15);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 247 to 262
	value = ((uint32_t)(input[30] & 0x01) << 31) |
			((uint32_t)input[31] << 23) |
			((uint32_t)(input[32] & 0xfe) << 15);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 263 to 278
	value = ((uint32_t)(input[32] & 0x01) << 31) |
			((uint32_t)input[33] << 23) |
			((uint32_t)(input[34] & 0xfe) << 15);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 279 to 294
	value = ((uint32_t)(input[34] & 0x01) << 31) |
			((uint32_t)input[35] << 23) |
			((uint32_t)(input[36] & 0xfe) << 15);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 295 to 310
	value = ((uint32_t)(input[36] & 0x01) << 31) |
			((uint32_t)input[37] << 23) |
			((uint32_t)(input[38] & 0xfe) << 15);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 311 to 326
	value = ((uint32_t)(input[38] & 0x01) << 31) |
			((uint32_t)input[39] << 23) |
			((uint32_t)(input[40] & 0xfe) << 15);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 327 to 342
	value = ((uint32_t)(input[40] & 0x01) << 31) |
			((uint32_t)input[41] << 23) |
			((uint32_t)(input[42] & 0xfe) << 15);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 343 to 358
	value = ((uint32_t)(input[42] & 0x01) << 31) |
			((uint32_t)input[43] << 23) |
			((uint32_t)(input[44] & 0xfe) << 15);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 359 to 374
	value = ((uint32_t)(input[44] & 0x01) << 31) |
			((uint32_t)input[45] << 23) |
			((uint32_t)(input[46] & 0xfe) << 15);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 375 to 390
	value = ((uint32_t)(input[46] & 0x01) << 31) |
			((uint32_t)input[47] << 23) |
			((uint32_t)(input[48] & 0xfe) << 15);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 391 to 406
	value = ((uint32_t)(input[48] & 0x01) << 31) |
			((uint32_t)input[49] << 23) |
			((uint32_t)(input[50] & 0xfe) << 15);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 407 to 422
	value = ((uint32_t)(input[50] & 0x01) << 31) |
			((uint32_t)input[51] << 23) |
			((uint32_t)(input[52] & 0xfe) << 15);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 423 to 438
	value = ((uint32_t)(input[52] & 0x01) << 31) |
			((uint32_t)input[53] << 23) |
			((uint32_t)(input[54] & 0xfe) << 15);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 439 to 454
	value = ((uint32_t)(input[54] & 0x01) << 31) |
			((uint32_t)input[55] << 23) |
			((uint32_t)(input[56] & 0xfe) << 15);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 455 to 470
	value = ((uint32_t)(input[56] & 0x01) << 31) |
			((uint32_t)input[57] << 23) |
			((uint32_t)(input[58] & 0xfe) << 15);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 471 to 486
	value = ((uint32_t)(input[58] & 0x01) << 31) |
			((uint32_t)input[59] << 23) |
			((uint32_t)(input[60] & 0xfe) << 15);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 487 to 502
	value = ((uint32_t)(input[60] & 0x01) << 31) |
			((uint32_t)input[61] << 23) |
			((uint32_t)(input[62] & 0xfe) << 15);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 503 to 518
	value = ((uint32_t)(input[62] & 0x01) << 31) |
			((uint32_t)input[63] << 23) |
			((uint32_t)(input[64] & 0xfe) << 15);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 519 to 534
	value = ((uint32_t)(input[64] & 0x01) << 31) |
			((uint32_t)input[65] << 23) |
			((uint32_t)(input[66] & 0xfe) << 15);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 535 to 550
	value = ((uint32_t)(input[66] & 0x01) << 31) |
			((uint32_t)input[67] << 23) |
			((uint32_t)(input[68] & 0xfe) << 15);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 551 to 566
	value = ((uint32_t)(input[68] & 0x01) << 31) |
			((uint32_t)input[69] << 23) |
			((uint32_t)(input[70] & 0xfe) << 15);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 567 to 582
	value = ((uint32_t)(input[70] & 0x01) << 31) |
			((uint32_t)input[71] << 23) |
			((uint32_t)(input[72] & 0xfe) << 15);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 583 to 598
	value = ((uint32_t)(input[72] & 0x01) << 31) |
			((uint32_t)input[73] << 23) |
			((uint32_t)(input[74] & 0xfe) << 15);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 599 to 614
	value = ((uint32_t)(input[74] & 0x01) << 31) |
			((uint32_t)input[75] << 23) |
			((uint32_t)(input[76] & 0xfe) << 15);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 615 to 630
	value = ((uint32_t)(input[76] & 0x01) << 31) |
			((uint32_t)input[77] << 23) |
			((uint32_t)(input[78] & 0xfe) << 15);
	output[38] = (double)(value >> 16);
}

static void unpack_40_16bit_signed_0off(const uint8_t * input, double * output, void *closure) {
	// Unpack 40 values into output
	// Values are 16-bit signed
	// Skip 0 bits, read 640 bits of data.
	// Input must be at least 80 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 0 to 15
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)input[1] << 16);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 16 to 31
	value = ((uint32_t)input[2] << 24) |
			((uint32_t)input[3] << 16);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 32 to 47
	value = ((uint32_t)input[4] << 24) |
			((uint32_t)input[5] << 16);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 48 to 63
	value = ((uint32_t)input[6] << 24) |
			((uint32_t)input[7] << 16);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 64 to 79
	value = ((uint32_t)input[8] << 24) |
			((uint32_t)input[9] << 16);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 80 to 95
	value = ((uint32_t)input[10] << 24) |
			((uint32_t)input[11] << 16);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 96 to 111
	value = ((uint32_t)input[12] << 24) |
			((uint32_t)input[13] << 16);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 112 to 127
	value = ((uint32_t)input[14] << 24) |
			((uint32_t)input[15] << 16);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 128 to 143
	value = ((uint32_t)input[16] << 24) |
			((uint32_t)input[17] << 16);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 144 to 159
	value = ((uint32_t)input[18] << 24) |
			((uint32_t)input[19] << 16);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 160 to 175
	value = ((uint32_t)input[20] << 24) |
			((uint32_t)input[21] << 16);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 176 to 191
	value = ((uint32_t)input[22] << 24) |
			((uint32_t)input[23] << 16);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 192 to 207
	value = ((uint32_t)input[24] << 24) |
			((uint32_t)input[25] << 16);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 208 to 223
	value = ((uint32_t)input[26] << 24) |
			((uint32_t)input[27] << 16);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 224 to 239
	value = ((uint32_t)input[28] << 24) |
			((uint32_t)input[29] << 16);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 240 to 255
	value = ((uint32_t)input[30] << 24) |
			((uint32_t)input[31] << 16);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 256 to 271
	value = ((uint32_t)input[32] << 24) |
			((uint32_t)input[33] << 16);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 272 to 287
	value = ((uint32_t)input[34] << 24) |
			((uint32_t)input[35] << 16);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 288 to 303
	value = ((uint32_t)input[36] << 24) |
			((uint32_t)input[37] << 16);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 304 to 319
	value = ((uint32_t)input[38] << 24) |
			((uint32_t)input[39] << 16);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 320 to 335
	value = ((uint32_t)input[40] << 24) |
			((uint32_t)input[41] << 16);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 336 to 351
	value = ((uint32_t)input[42] << 24) |
			((uint32_t)input[43] << 16);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 352 to 367
	value = ((uint32_t)input[44] << 24) |
			((uint32_t)input[45] << 16);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 368 to 383
	value = ((uint32_t)input[46] << 24) |
			((uint32_t)input[47] << 16);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 384 to 399
	value = ((uint32_t)input[48] << 24) |
			((uint32_t)input[49] << 16);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 400 to 415
	value = ((uint32_t)input[50] << 24) |
			((uint32_t)input[51] << 16);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 416 to 431
	value = ((uint32_t)input[52] << 24) |
			((uint32_t)input[53] << 16);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 432 to 447
	value = ((uint32_t)input[54] << 24) |
			((uint32_t)input[55] << 16);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 448 to 463
	value = ((uint32_t)input[56] << 24) |
			((uint32_t)input[57] << 16);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 464 to 479
	value = ((uint32_t)input[58] << 24) |
			((uint32_t)input[59] << 16);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 480 to 495
	value = ((uint32_t)input[60] << 24) |
			((uint32_t)input[61] << 16);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 496 to 511
	value = ((uint32_t)input[62] << 24) |
			((uint32_t)input[63] << 16);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 512 to 527
	value = ((uint32_t)input[64] << 24) |
			((uint32_t)input[65] << 16);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 528 to 543
	value = ((uint32_t)input[66] << 24) |
			((uint32_t)input[67] << 16);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 544 to 559
	value = ((uint32_t)input[68] << 24) |
			((uint32_t)input[69] << 16);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 560 to 575
	value = ((uint32_t)input[70] << 24) |
			((uint32_t)input[71] << 16);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 576 to 591
	value = ((uint32_t)input[72] << 24) |
			((uint32_t)input[73] << 16);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 592 to 607
	value = ((uint32_t)input[74] << 24) |
			((uint32_t)input[75] << 16);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 608 to 623
	value = ((uint32_t)input[76] << 24) |
			((uint32_t)input[77] << 16);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 624 to 639
	value = ((uint32_t)input[78] << 24) |
			((uint32_t)input[79] << 16);
	output[39] = (double)(value >> 16);
}

static void unpack_40_16bit_unsigned_0off(const uint8_t * input, double * output, void *closure) {
	// Unpack 40 values into output
	// Values are 16-bit unsigned
	// Skip 0 bits, read 640 bits of data.
	// Input must be at least 80 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 0 to 15
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)input[1] << 16);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 16 to 31
	value = ((uint32_t)input[2] << 24) |
			((uint32_t)input[3] << 16);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 32 to 47
	value = ((uint32_t)input[4] << 24) |
			((uint32_t)input[5] << 16);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 48 to 63
	value = ((uint32_t)input[6] << 24) |
			((uint32_t)input[7] << 16);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 64 to 79
	value = ((uint32_t)input[8] << 24) |
			((uint32_t)input[9] << 16);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 80 to 95
	value = ((uint32_t)input[10] << 24) |
			((uint32_t)input[11] << 16);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 96 to 111
	value = ((uint32_t)input[12] << 24) |
			((uint32_t)input[13] << 16);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 112 to 127
	value = ((uint32_t)input[14] << 24) |
			((uint32_t)input[15] << 16);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 128 to 143
	value = ((uint32_t)input[16] << 24) |
			((uint32_t)input[17] << 16);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 144 to 159
	value = ((uint32_t)input[18] << 24) |
			((uint32_t)input[19] << 16);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 160 to 175
	value = ((uint32_t)input[20] << 24) |
			((uint32_t)input[21] << 16);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 176 to 191
	value = ((uint32_t)input[22] << 24) |
			((uint32_t)input[23] << 16);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 192 to 207
	value = ((uint32_t)input[24] << 24) |
			((uint32_t)input[25] << 16);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 208 to 223
	value = ((uint32_t)input[26] << 24) |
			((uint32_t)input[27] << 16);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 224 to 239
	value = ((uint32_t)input[28] << 24) |
			((uint32_t)input[29] << 16);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 240 to 255
	value = ((uint32_t)input[30] << 24) |
			((uint32_t)input[31] << 16);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 256 to 271
	value = ((uint32_t)input[32] << 24) |
			((uint32_t)input[33] << 16);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 272 to 287
	value = ((uint32_t)input[34] << 24) |
			((uint32_t)input[35] << 16);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 288 to 303
	value = ((uint32_t)input[36] << 24) |
			((uint32_t)input[37] << 16);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 304 to 319
	value = ((uint32_t)input[38] << 24) |
			((uint32_t)input[39] << 16);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 320 to 335
	value = ((uint32_t)input[40] << 24) |
			((uint32_t)input[41] << 16);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 336 to 351
	value = ((uint32_t)input[42] << 24) |
			((uint32_t)input[43] << 16);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 352 to 367
	value = ((uint32_t)input[44] << 24) |
			((uint32_t)input[45] << 16);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 368 to 383
	value = ((uint32_t)input[46] << 24) |
			((uint32_t)input[47] << 16);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 384 to 399
	value = ((uint32_t)input[48] << 24) |
			((uint32_t)input[49] << 16);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 400 to 415
	value = ((uint32_t)input[50] << 24) |
			((uint32_t)input[51] << 16);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 416 to 431
	value = ((uint32_t)input[52] << 24) |
			((uint32_t)input[53] << 16);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 432 to 447
	value = ((uint32_t)input[54] << 24) |
			((uint32_t)input[55] << 16);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 448 to 463
	value = ((uint32_t)input[56] << 24) |
			((uint32_t)input[57] << 16);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 464 to 479
	value = ((uint32_t)input[58] << 24) |
			((uint32_t)input[59] << 16);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 480 to 495
	value = ((uint32_t)input[60] << 24) |
			((uint32_t)input[61] << 16);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 496 to 511
	value = ((uint32_t)input[62] << 24) |
			((uint32_t)input[63] << 16);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 512 to 527
	value = ((uint32_t)input[64] << 24) |
			((uint32_t)input[65] << 16);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 528 to 543
	value = ((uint32_t)input[66] << 24) |
			((uint32_t)input[67] << 16);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 544 to 559
	value = ((uint32_t)input[68] << 24) |
			((uint32_t)input[69] << 16);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 560 to 575
	value = ((uint32_t)input[70] << 24) |
			((uint32_t)input[71] << 16);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 576 to 591
	value = ((uint32_t)input[72] << 24) |
			((uint32_t)input[73] << 16);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 592 to 607
	value = ((uint32_t)input[74] << 24) |
			((uint32_t)input[75] << 16);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 608 to 623
	value = ((uint32_t)input[76] << 24) |
			((uint32_t)input[77] << 16);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 624 to 639
	value = ((uint32_t)input[78] << 24) |
			((uint32_t)input[79] << 16);
	output[39] = (double)(value >> 16);
}

static void unpack_40_16bit_signed_1off(const uint8_t * input, double * output, void *closure) {
	// Unpack 40 values into output
	// Values are 16-bit signed
	// Skip 1 bits, read 640 bits of data.
	// Input must be at least 81 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 1 to 16
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)input[1] << 17) |
			((uint32_t)(input[2] & 0x80) << 9);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 17 to 32
	value = ((uint32_t)(input[2] & 0x7f) << 25) |
			((uint32_t)input[3] << 17) |
			((uint32_t)(input[4] & 0x80) << 9);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 33 to 48
	value = ((uint32_t)(input[4] & 0x7f) << 25) |
			((uint32_t)input[5] << 17) |
			((uint32_t)(input[6] & 0x80) << 9);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 49 to 64
	value = ((uint32_t)(input[6] & 0x7f) << 25) |
			((uint32_t)input[7] << 17) |
			((uint32_t)(input[8] & 0x80) << 9);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 65 to 80
	value = ((uint32_t)(input[8] & 0x7f) << 25) |
			((uint32_t)input[9] << 17) |
			((uint32_t)(input[10] & 0x80) << 9);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 81 to 96
	value = ((uint32_t)(input[10] & 0x7f) << 25) |
			((uint32_t)input[11] << 17) |
			((uint32_t)(input[12] & 0x80) << 9);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 97 to 112
	value = ((uint32_t)(input[12] & 0x7f) << 25) |
			((uint32_t)input[13] << 17) |
			((uint32_t)(input[14] & 0x80) << 9);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 113 to 128
	value = ((uint32_t)(input[14] & 0x7f) << 25) |
			((uint32_t)input[15] << 17) |
			((uint32_t)(input[16] & 0x80) << 9);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 129 to 144
	value = ((uint32_t)(input[16] & 0x7f) << 25) |
			((uint32_t)input[17] << 17) |
			((uint32_t)(input[18] & 0x80) << 9);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 145 to 160
	value = ((uint32_t)(input[18] & 0x7f) << 25) |
			((uint32_t)input[19] << 17) |
			((uint32_t)(input[20] & 0x80) << 9);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 161 to 176
	value = ((uint32_t)(input[20] & 0x7f) << 25) |
			((uint32_t)input[21] << 17) |
			((uint32_t)(input[22] & 0x80) << 9);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 177 to 192
	value = ((uint32_t)(input[22] & 0x7f) << 25) |
			((uint32_t)input[23] << 17) |
			((uint32_t)(input[24] & 0x80) << 9);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 193 to 208
	value = ((uint32_t)(input[24] & 0x7f) << 25) |
			((uint32_t)input[25] << 17) |
			((uint32_t)(input[26] & 0x80) << 9);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 209 to 224
	value = ((uint32_t)(input[26] & 0x7f) << 25) |
			((uint32_t)input[27] << 17) |
			((uint32_t)(input[28] & 0x80) << 9);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 225 to 240
	value = ((uint32_t)(input[28] & 0x7f) << 25) |
			((uint32_t)input[29] << 17) |
			((uint32_t)(input[30] & 0x80) << 9);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 241 to 256
	value = ((uint32_t)(input[30] & 0x7f) << 25) |
			((uint32_t)input[31] << 17) |
			((uint32_t)(input[32] & 0x80) << 9);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 257 to 272
	value = ((uint32_t)(input[32] & 0x7f) << 25) |
			((uint32_t)input[33] << 17) |
			((uint32_t)(input[34] & 0x80) << 9);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 273 to 288
	value = ((uint32_t)(input[34] & 0x7f) << 25) |
			((uint32_t)input[35] << 17) |
			((uint32_t)(input[36] & 0x80) << 9);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 289 to 304
	value = ((uint32_t)(input[36] & 0x7f) << 25) |
			((uint32_t)input[37] << 17) |
			((uint32_t)(input[38] & 0x80) << 9);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 305 to 320
	value = ((uint32_t)(input[38] & 0x7f) << 25) |
			((uint32_t)input[39] << 17) |
			((uint32_t)(input[40] & 0x80) << 9);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 321 to 336
	value = ((uint32_t)(input[40] & 0x7f) << 25) |
			((uint32_t)input[41] << 17) |
			((uint32_t)(input[42] & 0x80) << 9);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 337 to 352
	value = ((uint32_t)(input[42] & 0x7f) << 25) |
			((uint32_t)input[43] << 17) |
			((uint32_t)(input[44] & 0x80) << 9);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 353 to 368
	value = ((uint32_t)(input[44] & 0x7f) << 25) |
			((uint32_t)input[45] << 17) |
			((uint32_t)(input[46] & 0x80) << 9);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 369 to 384
	value = ((uint32_t)(input[46] & 0x7f) << 25) |
			((uint32_t)input[47] << 17) |
			((uint32_t)(input[48] & 0x80) << 9);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 385 to 400
	value = ((uint32_t)(input[48] & 0x7f) << 25) |
			((uint32_t)input[49] << 17) |
			((uint32_t)(input[50] & 0x80) << 9);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 401 to 416
	value = ((uint32_t)(input[50] & 0x7f) << 25) |
			((uint32_t)input[51] << 17) |
			((uint32_t)(input[52] & 0x80) << 9);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 417 to 432
	value = ((uint32_t)(input[52] & 0x7f) << 25) |
			((uint32_t)input[53] << 17) |
			((uint32_t)(input[54] & 0x80) << 9);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 433 to 448
	value = ((uint32_t)(input[54] & 0x7f) << 25) |
			((uint32_t)input[55] << 17) |
			((uint32_t)(input[56] & 0x80) << 9);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 449 to 464
	value = ((uint32_t)(input[56] & 0x7f) << 25) |
			((uint32_t)input[57] << 17) |
			((uint32_t)(input[58] & 0x80) << 9);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 465 to 480
	value = ((uint32_t)(input[58] & 0x7f) << 25) |
			((uint32_t)input[59] << 17) |
			((uint32_t)(input[60] & 0x80) << 9);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 481 to 496
	value = ((uint32_t)(input[60] & 0x7f) << 25) |
			((uint32_t)input[61] << 17) |
			((uint32_t)(input[62] & 0x80) << 9);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 497 to 512
	value = ((uint32_t)(input[62] & 0x7f) << 25) |
			((uint32_t)input[63] << 17) |
			((uint32_t)(input[64] & 0x80) << 9);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 513 to 528
	value = ((uint32_t)(input[64] & 0x7f) << 25) |
			((uint32_t)input[65] << 17) |
			((uint32_t)(input[66] & 0x80) << 9);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 529 to 544
	value = ((uint32_t)(input[66] & 0x7f) << 25) |
			((uint32_t)input[67] << 17) |
			((uint32_t)(input[68] & 0x80) << 9);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 545 to 560
	value = ((uint32_t)(input[68] & 0x7f) << 25) |
			((uint32_t)input[69] << 17) |
			((uint32_t)(input[70] & 0x80) << 9);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 561 to 576
	value = ((uint32_t)(input[70] & 0x7f) << 25) |
			((uint32_t)input[71] << 17) |
			((uint32_t)(input[72] & 0x80) << 9);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 577 to 592
	value = ((uint32_t)(input[72] & 0x7f) << 25) |
			((uint32_t)input[73] << 17) |
			((uint32_t)(input[74] & 0x80) << 9);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 593 to 608
	value = ((uint32_t)(input[74] & 0x7f) << 25) |
			((uint32_t)input[75] << 17) |
			((uint32_t)(input[76] & 0x80) << 9);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 609 to 624
	value = ((uint32_t)(input[76] & 0x7f) << 25) |
			((uint32_t)input[77] << 17) |
			((uint32_t)(input[78] & 0x80) << 9);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 625 to 640
	value = ((uint32_t)(input[78] & 0x7f) << 25) |
			((uint32_t)input[79] << 17) |
			((uint32_t)(input[80] & 0x80) << 9);
	output[39] = (double)(value >> 16);
}

static void unpack_40_16bit_unsigned_1off(const uint8_t * input, double * output, void *closure) {
	// Unpack 40 values into output
	// Values are 16-bit unsigned
	// Skip 1 bits, read 640 bits of data.
	// Input must be at least 81 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 1 to 16
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)input[1] << 17) |
			((uint32_t)(input[2] & 0x80) << 9);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 17 to 32
	value = ((uint32_t)(input[2] & 0x7f) << 25) |
			((uint32_t)input[3] << 17) |
			((uint32_t)(input[4] & 0x80) << 9);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 33 to 48
	value = ((uint32_t)(input[4] & 0x7f) << 25) |
			((uint32_t)input[5] << 17) |
			((uint32_t)(input[6] & 0x80) << 9);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 49 to 64
	value = ((uint32_t)(input[6] & 0x7f) << 25) |
			((uint32_t)input[7] << 17) |
			((uint32_t)(input[8] & 0x80) << 9);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 65 to 80
	value = ((uint32_t)(input[8] & 0x7f) << 25) |
			((uint32_t)input[9] << 17) |
			((uint32_t)(input[10] & 0x80) << 9);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 81 to 96
	value = ((uint32_t)(input[10] & 0x7f) << 25) |
			((uint32_t)input[11] << 17) |
			((uint32_t)(input[12] & 0x80) << 9);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 97 to 112
	value = ((uint32_t)(input[12] & 0x7f) << 25) |
			((uint32_t)input[13] << 17) |
			((uint32_t)(input[14] & 0x80) << 9);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 113 to 128
	value = ((uint32_t)(input[14] & 0x7f) << 25) |
			((uint32_t)input[15] << 17) |
			((uint32_t)(input[16] & 0x80) << 9);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 129 to 144
	value = ((uint32_t)(input[16] & 0x7f) << 25) |
			((uint32_t)input[17] << 17) |
			((uint32_t)(input[18] & 0x80) << 9);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 145 to 160
	value = ((uint32_t)(input[18] & 0x7f) << 25) |
			((uint32_t)input[19] << 17) |
			((uint32_t)(input[20] & 0x80) << 9);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 161 to 176
	value = ((uint32_t)(input[20] & 0x7f) << 25) |
			((uint32_t)input[21] << 17) |
			((uint32_t)(input[22] & 0x80) << 9);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 177 to 192
	value = ((uint32_t)(input[22] & 0x7f) << 25) |
			((uint32_t)input[23] << 17) |
			((uint32_t)(input[24] & 0x80) << 9);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 193 to 208
	value = ((uint32_t)(input[24] & 0x7f) << 25) |
			((uint32_t)input[25] << 17) |
			((uint32_t)(input[26] & 0x80) << 9);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 209 to 224
	value = ((uint32_t)(input[26] & 0x7f) << 25) |
			((uint32_t)input[27] << 17) |
			((uint32_t)(input[28] & 0x80) << 9);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 225 to 240
	value = ((uint32_t)(input[28] & 0x7f) << 25) |
			((uint32_t)input[29] << 17) |
			((uint32_t)(input[30] & 0x80) << 9);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 241 to 256
	value = ((uint32_t)(input[30] & 0x7f) << 25) |
			((uint32_t)input[31] << 17) |
			((uint32_t)(input[32] & 0x80) << 9);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 257 to 272
	value = ((uint32_t)(input[32] & 0x7f) << 25) |
			((uint32_t)input[33] << 17) |
			((uint32_t)(input[34] & 0x80) << 9);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 273 to 288
	value = ((uint32_t)(input[34] & 0x7f) << 25) |
			((uint32_t)input[35] << 17) |
			((uint32_t)(input[36] & 0x80) << 9);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 289 to 304
	value = ((uint32_t)(input[36] & 0x7f) << 25) |
			((uint32_t)input[37] << 17) |
			((uint32_t)(input[38] & 0x80) << 9);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 305 to 320
	value = ((uint32_t)(input[38] & 0x7f) << 25) |
			((uint32_t)input[39] << 17) |
			((uint32_t)(input[40] & 0x80) << 9);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 321 to 336
	value = ((uint32_t)(input[40] & 0x7f) << 25) |
			((uint32_t)input[41] << 17) |
			((uint32_t)(input[42] & 0x80) << 9);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 337 to 352
	value = ((uint32_t)(input[42] & 0x7f) << 25) |
			((uint32_t)input[43] << 17) |
			((uint32_t)(input[44] & 0x80) << 9);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 353 to 368
	value = ((uint32_t)(input[44] & 0x7f) << 25) |
			((uint32_t)input[45] << 17) |
			((uint32_t)(input[46] & 0x80) << 9);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 369 to 384
	value = ((uint32_t)(input[46] & 0x7f) << 25) |
			((uint32_t)input[47] << 17) |
			((uint32_t)(input[48] & 0x80) << 9);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 385 to 400
	value = ((uint32_t)(input[48] & 0x7f) << 25) |
			((uint32_t)input[49] << 17) |
			((uint32_t)(input[50] & 0x80) << 9);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 401 to 416
	value = ((uint32_t)(input[50] & 0x7f) << 25) |
			((uint32_t)input[51] << 17) |
			((uint32_t)(input[52] & 0x80) << 9);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 417 to 432
	value = ((uint32_t)(input[52] & 0x7f) << 25) |
			((uint32_t)input[53] << 17) |
			((uint32_t)(input[54] & 0x80) << 9);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 433 to 448
	value = ((uint32_t)(input[54] & 0x7f) << 25) |
			((uint32_t)input[55] << 17) |
			((uint32_t)(input[56] & 0x80) << 9);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 449 to 464
	value = ((uint32_t)(input[56] & 0x7f) << 25) |
			((uint32_t)input[57] << 17) |
			((uint32_t)(input[58] & 0x80) << 9);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 465 to 480
	value = ((uint32_t)(input[58] & 0x7f) << 25) |
			((uint32_t)input[59] << 17) |
			((uint32_t)(input[60] & 0x80) << 9);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 481 to 496
	value = ((uint32_t)(input[60] & 0x7f) << 25) |
			((uint32_t)input[61] << 17) |
			((uint32_t)(input[62] & 0x80) << 9);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 497 to 512
	value = ((uint32_t)(input[62] & 0x7f) << 25) |
			((uint32_t)input[63] << 17) |
			((uint32_t)(input[64] & 0x80) << 9);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 513 to 528
	value = ((uint32_t)(input[64] & 0x7f) << 25) |
			((uint32_t)input[65] << 17) |
			((uint32_t)(input[66] & 0x80) << 9);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 529 to 544
	value = ((uint32_t)(input[66] & 0x7f) << 25) |
			((uint32_t)input[67] << 17) |
			((uint32_t)(input[68] & 0x80) << 9);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 545 to 560
	value = ((uint32_t)(input[68] & 0x7f) << 25) |
			((uint32_t)input[69] << 17) |
			((uint32_t)(input[70] & 0x80) << 9);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 561 to 576
	value = ((uint32_t)(input[70] & 0x7f) << 25) |
			((uint32_t)input[71] << 17) |
			((uint32_t)(input[72] & 0x80) << 9);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 577 to 592
	value = ((uint32_t)(input[72] & 0x7f) << 25) |
			((uint32_t)input[73] << 17) |
			((uint32_t)(input[74] & 0x80) << 9);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 593 to 608
	value = ((uint32_t)(input[74] & 0x7f) << 25) |
			((uint32_t)input[75] << 17) |
			((uint32_t)(input[76] & 0x80) << 9);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 609 to 624
	value = ((uint32_t)(input[76] & 0x7f) << 25) |
			((uint32_t)input[77] << 17) |
			((uint32_t)(input[78] & 0x80) << 9);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 625 to 640
	value = ((uint32_t)(input[78] & 0x7f) << 25) |
			((uint32_t)input[79] << 17) |
			((uint32_t)(input[80] & 0x80) << 9);
	output[39] = (double)(value >> 16);
}

static void unpack_40_16bit_signed_2off(const uint8_t * input, double * output, void *closure) {
	// Unpack 40 values into output
	// Values are 16-bit signed
	// Skip 2 bits, read 640 bits of data.
	// Input must be at least 81 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 2 to 17
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)input[1] << 18) |
			((uint32_t)(input[2] & 0xc0) << 10);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 18 to 33
	value = ((uint32_t)(input[2] & 0x3f) << 26) |
			((uint32_t)input[3] << 18) |
			((uint32_t)(input[4] & 0xc0) << 10);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 34 to 49
	value = ((uint32_t)(input[4] & 0x3f) << 26) |
			((uint32_t)input[5] << 18) |
			((uint32_t)(input[6] & 0xc0) << 10);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 50 to 65
	value = ((uint32_t)(input[6] & 0x3f) << 26) |
			((uint32_t)input[7] << 18) |
			((uint32_t)(input[8] & 0xc0) << 10);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 66 to 81
	value = ((uint32_t)(input[8] & 0x3f) << 26) |
			((uint32_t)input[9] << 18) |
			((uint32_t)(input[10] & 0xc0) << 10);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 82 to 97
	value = ((uint32_t)(input[10] & 0x3f) << 26) |
			((uint32_t)input[11] << 18) |
			((uint32_t)(input[12] & 0xc0) << 10);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 98 to 113
	value = ((uint32_t)(input[12] & 0x3f) << 26) |
			((uint32_t)input[13] << 18) |
			((uint32_t)(input[14] & 0xc0) << 10);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 114 to 129
	value = ((uint32_t)(input[14] & 0x3f) << 26) |
			((uint32_t)input[15] << 18) |
			((uint32_t)(input[16] & 0xc0) << 10);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 130 to 145
	value = ((uint32_t)(input[16] & 0x3f) << 26) |
			((uint32_t)input[17] << 18) |
			((uint32_t)(input[18] & 0xc0) << 10);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 146 to 161
	value = ((uint32_t)(input[18] & 0x3f) << 26) |
			((uint32_t)input[19] << 18) |
			((uint32_t)(input[20] & 0xc0) << 10);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 162 to 177
	value = ((uint32_t)(input[20] & 0x3f) << 26) |
			((uint32_t)input[21] << 18) |
			((uint32_t)(input[22] & 0xc0) << 10);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 178 to 193
	value = ((uint32_t)(input[22] & 0x3f) << 26) |
			((uint32_t)input[23] << 18) |
			((uint32_t)(input[24] & 0xc0) << 10);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 194 to 209
	value = ((uint32_t)(input[24] & 0x3f) << 26) |
			((uint32_t)input[25] << 18) |
			((uint32_t)(input[26] & 0xc0) << 10);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 210 to 225
	value = ((uint32_t)(input[26] & 0x3f) << 26) |
			((uint32_t)input[27] << 18) |
			((uint32_t)(input[28] & 0xc0) << 10);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 226 to 241
	value = ((uint32_t)(input[28] & 0x3f) << 26) |
			((uint32_t)input[29] << 18) |
			((uint32_t)(input[30] & 0xc0) << 10);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 242 to 257
	value = ((uint32_t)(input[30] & 0x3f) << 26) |
			((uint32_t)input[31] << 18) |
			((uint32_t)(input[32] & 0xc0) << 10);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 258 to 273
	value = ((uint32_t)(input[32] & 0x3f) << 26) |
			((uint32_t)input[33] << 18) |
			((uint32_t)(input[34] & 0xc0) << 10);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 274 to 289
	value = ((uint32_t)(input[34] & 0x3f) << 26) |
			((uint32_t)input[35] << 18) |
			((uint32_t)(input[36] & 0xc0) << 10);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 290 to 305
	value = ((uint32_t)(input[36] & 0x3f) << 26) |
			((uint32_t)input[37] << 18) |
			((uint32_t)(input[38] & 0xc0) << 10);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 306 to 321
	value = ((uint32_t)(input[38] & 0x3f) << 26) |
			((uint32_t)input[39] << 18) |
			((uint32_t)(input[40] & 0xc0) << 10);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 322 to 337
	value = ((uint32_t)(input[40] & 0x3f) << 26) |
			((uint32_t)input[41] << 18) |
			((uint32_t)(input[42] & 0xc0) << 10);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 338 to 353
	value = ((uint32_t)(input[42] & 0x3f) << 26) |
			((uint32_t)input[43] << 18) |
			((uint32_t)(input[44] & 0xc0) << 10);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 354 to 369
	value = ((uint32_t)(input[44] & 0x3f) << 26) |
			((uint32_t)input[45] << 18) |
			((uint32_t)(input[46] & 0xc0) << 10);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 370 to 385
	value = ((uint32_t)(input[46] & 0x3f) << 26) |
			((uint32_t)input[47] << 18) |
			((uint32_t)(input[48] & 0xc0) << 10);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 386 to 401
	value = ((uint32_t)(input[48] & 0x3f) << 26) |
			((uint32_t)input[49] << 18) |
			((uint32_t)(input[50] & 0xc0) << 10);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 402 to 417
	value = ((uint32_t)(input[50] & 0x3f) << 26) |
			((uint32_t)input[51] << 18) |
			((uint32_t)(input[52] & 0xc0) << 10);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 418 to 433
	value = ((uint32_t)(input[52] & 0x3f) << 26) |
			((uint32_t)input[53] << 18) |
			((uint32_t)(input[54] & 0xc0) << 10);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 434 to 449
	value = ((uint32_t)(input[54] & 0x3f) << 26) |
			((uint32_t)input[55] << 18) |
			((uint32_t)(input[56] & 0xc0) << 10);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 450 to 465
	value = ((uint32_t)(input[56] & 0x3f) << 26) |
			((uint32_t)input[57] << 18) |
			((uint32_t)(input[58] & 0xc0) << 10);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 466 to 481
	value = ((uint32_t)(input[58] & 0x3f) << 26) |
			((uint32_t)input[59] << 18) |
			((uint32_t)(input[60] & 0xc0) << 10);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 482 to 497
	value = ((uint32_t)(input[60] & 0x3f) << 26) |
			((uint32_t)input[61] << 18) |
			((uint32_t)(input[62] & 0xc0) << 10);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 498 to 513
	value = ((uint32_t)(input[62] & 0x3f) << 26) |
			((uint32_t)input[63] << 18) |
			((uint32_t)(input[64] & 0xc0) << 10);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 514 to 529
	value = ((uint32_t)(input[64] & 0x3f) << 26) |
			((uint32_t)input[65] << 18) |
			((uint32_t)(input[66] & 0xc0) << 10);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 530 to 545
	value = ((uint32_t)(input[66] & 0x3f) << 26) |
			((uint32_t)input[67] << 18) |
			((uint32_t)(input[68] & 0xc0) << 10);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 546 to 561
	value = ((uint32_t)(input[68] & 0x3f) << 26) |
			((uint32_t)input[69] << 18) |
			((uint32_t)(input[70] & 0xc0) << 10);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 562 to 577
	value = ((uint32_t)(input[70] & 0x3f) << 26) |
			((uint32_t)input[71] << 18) |
			((uint32_t)(input[72] & 0xc0) << 10);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 578 to 593
	value = ((uint32_t)(input[72] & 0x3f) << 26) |
			((uint32_t)input[73] << 18) |
			((uint32_t)(input[74] & 0xc0) << 10);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 594 to 609
	value = ((uint32_t)(input[74] & 0x3f) << 26) |
			((uint32_t)input[75] << 18) |
			((uint32_t)(input[76] & 0xc0) << 10);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 610 to 625
	value = ((uint32_t)(input[76] & 0x3f) << 26) |
			((uint32_t)input[77] << 18) |
			((uint32_t)(input[78] & 0xc0) << 10);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 626 to 641
	value = ((uint32_t)(input[78] & 0x3f) << 26) |
			((uint32_t)input[79] << 18) |
			((uint32_t)(input[80] & 0xc0) << 10);
	output[39] = (double)(value >> 16);
}

static void unpack_40_16bit_unsigned_2off(const uint8_t * input, double * output, void *closure) {
	// Unpack 40 values into output
	// Values are 16-bit unsigned
	// Skip 2 bits, read 640 bits of data.
	// Input must be at least 81 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 2 to 17
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)input[1] << 18) |
			((uint32_t)(input[2] & 0xc0) << 10);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 18 to 33
	value = ((uint32_t)(input[2] & 0x3f) << 26) |
			((uint32_t)input[3] << 18) |
			((uint32_t)(input[4] & 0xc0) << 10);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 34 to 49
	value = ((uint32_t)(input[4] & 0x3f) << 26) |
			((uint32_t)input[5] << 18) |
			((uint32_t)(input[6] & 0xc0) << 10);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 50 to 65
	value = ((uint32_t)(input[6] & 0x3f) << 26) |
			((uint32_t)input[7] << 18) |
			((uint32_t)(input[8] & 0xc0) << 10);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 66 to 81
	value = ((uint32_t)(input[8] & 0x3f) << 26) |
			((uint32_t)input[9] << 18) |
			((uint32_t)(input[10] & 0xc0) << 10);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 82 to 97
	value = ((uint32_t)(input[10] & 0x3f) << 26) |
			((uint32_t)input[11] << 18) |
			((uint32_t)(input[12] & 0xc0) << 10);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 98 to 113
	value = ((uint32_t)(input[12] & 0x3f) << 26) |
			((uint32_t)input[13] << 18) |
			((uint32_t)(input[14] & 0xc0) << 10);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 114 to 129
	value = ((uint32_t)(input[14] & 0x3f) << 26) |
			((uint32_t)input[15] << 18) |
			((uint32_t)(input[16] & 0xc0) << 10);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 130 to 145
	value = ((uint32_t)(input[16] & 0x3f) << 26) |
			((uint32_t)input[17] << 18) |
			((uint32_t)(input[18] & 0xc0) << 10);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 146 to 161
	value = ((uint32_t)(input[18] & 0x3f) << 26) |
			((uint32_t)input[19] << 18) |
			((uint32_t)(input[20] & 0xc0) << 10);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 162 to 177
	value = ((uint32_t)(input[20] & 0x3f) << 26) |
			((uint32_t)input[21] << 18) |
			((uint32_t)(input[22] & 0xc0) << 10);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 178 to 193
	value = ((uint32_t)(input[22] & 0x3f) << 26) |
			((uint32_t)input[23] << 18) |
			((uint32_t)(input[24] & 0xc0) << 10);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 194 to 209
	value = ((uint32_t)(input[24] & 0x3f) << 26) |
			((uint32_t)input[25] << 18) |
			((uint32_t)(input[26] & 0xc0) << 10);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 210 to 225
	value = ((uint32_t)(input[26] & 0x3f) << 26) |
			((uint32_t)input[27] << 18) |
			((uint32_t)(input[28] & 0xc0) << 10);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 226 to 241
	value = ((uint32_t)(input[28] & 0x3f) << 26) |
			((uint32_t)input[29] << 18) |
			((uint32_t)(input[30] & 0xc0) << 10);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 242 to 257
	value = ((uint32_t)(input[30] & 0x3f) << 26) |
			((uint32_t)input[31] << 18) |
			((uint32_t)(input[32] & 0xc0) << 10);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 258 to 273
	value = ((uint32_t)(input[32] & 0x3f) << 26) |
			((uint32_t)input[33] << 18) |
			((uint32_t)(input[34] & 0xc0) << 10);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 274 to 289
	value = ((uint32_t)(input[34] & 0x3f) << 26) |
			((uint32_t)input[35] << 18) |
			((uint32_t)(input[36] & 0xc0) << 10);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 290 to 305
	value = ((uint32_t)(input[36] & 0x3f) << 26) |
			((uint32_t)input[37] << 18) |
			((uint32_t)(input[38] & 0xc0) << 10);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 306 to 321
	value = ((uint32_t)(input[38] & 0x3f) << 26) |
			((uint32_t)input[39] << 18) |
			((uint32_t)(input[40] & 0xc0) << 10);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 322 to 337
	value = ((uint32_t)(input[40] & 0x3f) << 26) |
			((uint32_t)input[41] << 18) |
			((uint32_t)(input[42] & 0xc0) << 10);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 338 to 353
	value = ((uint32_t)(input[42] & 0x3f) << 26) |
			((uint32_t)input[43] << 18) |
			((uint32_t)(input[44] & 0xc0) << 10);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 354 to 369
	value = ((uint32_t)(input[44] & 0x3f) << 26) |
			((uint32_t)input[45] << 18) |
			((uint32_t)(input[46] & 0xc0) << 10);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 370 to 385
	value = ((uint32_t)(input[46] & 0x3f) << 26) |
			((uint32_t)input[47] << 18) |
			((uint32_t)(input[48] & 0xc0) << 10);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 386 to 401
	value = ((uint32_t)(input[48] & 0x3f) << 26) |
			((uint32_t)input[49] << 18) |
			((uint32_t)(input[50] & 0xc0) << 10);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 402 to 417
	value = ((uint32_t)(input[50] & 0x3f) << 26) |
			((uint32_t)input[51] << 18) |
			((uint32_t)(input[52] & 0xc0) << 10);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 418 to 433
	value = ((uint32_t)(input[52] & 0x3f) << 26) |
			((uint32_t)input[53] << 18) |
			((uint32_t)(input[54] & 0xc0) << 10);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 434 to 449
	value = ((uint32_t)(input[54] & 0x3f) << 26) |
			((uint32_t)input[55] << 18) |
			((uint32_t)(input[56] & 0xc0) << 10);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 450 to 465
	value = ((uint32_t)(input[56] & 0x3f) << 26) |
			((uint32_t)input[57] << 18) |
			((uint32_t)(input[58] & 0xc0) << 10);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 466 to 481
	value = ((uint32_t)(input[58] & 0x3f) << 26) |
			((uint32_t)input[59] << 18) |
			((uint32_t)(input[60] & 0xc0) << 10);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 482 to 497
	value = ((uint32_t)(input[60] & 0x3f) << 26) |
			((uint32_t)input[61] << 18) |
			((uint32_t)(input[62] & 0xc0) << 10);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 498 to 513
	value = ((uint32_t)(input[62] & 0x3f) << 26) |
			((uint32_t)input[63] << 18) |
			((uint32_t)(input[64] & 0xc0) << 10);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 514 to 529
	value = ((uint32_t)(input[64] & 0x3f) << 26) |
			((uint32_t)input[65] << 18) |
			((uint32_t)(input[66] & 0xc0) << 10);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 530 to 545
	value = ((uint32_t)(input[66] & 0x3f) << 26) |
			((uint32_t)input[67] << 18) |
			((uint32_t)(input[68] & 0xc0) << 10);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 546 to 561
	value = ((uint32_t)(input[68] & 0x3f) << 26) |
			((uint32_t)input[69] << 18) |
			((uint32_t)(input[70] & 0xc0) << 10);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 562 to 577
	value = ((uint32_t)(input[70] & 0x3f) << 26) |
			((uint32_t)input[71] << 18) |
			((uint32_t)(input[72] & 0xc0) << 10);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 578 to 593
	value = ((uint32_t)(input[72] & 0x3f) << 26) |
			((uint32_t)input[73] << 18) |
			((uint32_t)(input[74] & 0xc0) << 10);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 594 to 609
	value = ((uint32_t)(input[74] & 0x3f) << 26) |
			((uint32_t)input[75] << 18) |
			((uint32_t)(input[76] & 0xc0) << 10);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 610 to 625
	value = ((uint32_t)(input[76] & 0x3f) << 26) |
			((uint32_t)input[77] << 18) |
			((uint32_t)(input[78] & 0xc0) << 10);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 626 to 641
	value = ((uint32_t)(input[78] & 0x3f) << 26) |
			((uint32_t)input[79] << 18) |
			((uint32_t)(input[80] & 0xc0) << 10);
	output[39] = (double)(value >> 16);
}

static void unpack_40_16bit_signed_3off(const uint8_t * input, double * output, void *closure) {
	// Unpack 40 values into output
	// Values are 16-bit signed
	// Skip 3 bits, read 640 bits of data.
	// Input must be at least 81 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 3 to 18
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)input[1] << 19) |
			((uint32_t)(input[2] & 0xe0) << 11);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 19 to 34
	value = ((uint32_t)(input[2] & 0x1f) << 27) |
			((uint32_t)input[3] << 19) |
			((uint32_t)(input[4] & 0xe0) << 11);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 35 to 50
	value = ((uint32_t)(input[4] & 0x1f) << 27) |
			((uint32_t)input[5] << 19) |
			((uint32_t)(input[6] & 0xe0) << 11);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 51 to 66
	value = ((uint32_t)(input[6] & 0x1f) << 27) |
			((uint32_t)input[7] << 19) |
			((uint32_t)(input[8] & 0xe0) << 11);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 67 to 82
	value = ((uint32_t)(input[8] & 0x1f) << 27) |
			((uint32_t)input[9] << 19) |
			((uint32_t)(input[10] & 0xe0) << 11);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 83 to 98
	value = ((uint32_t)(input[10] & 0x1f) << 27) |
			((uint32_t)input[11] << 19) |
			((uint32_t)(input[12] & 0xe0) << 11);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 99 to 114
	value = ((uint32_t)(input[12] & 0x1f) << 27) |
			((uint32_t)input[13] << 19) |
			((uint32_t)(input[14] & 0xe0) << 11);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 115 to 130
	value = ((uint32_t)(input[14] & 0x1f) << 27) |
			((uint32_t)input[15] << 19) |
			((uint32_t)(input[16] & 0xe0) << 11);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 131 to 146
	value = ((uint32_t)(input[16] & 0x1f) << 27) |
			((uint32_t)input[17] << 19) |
			((uint32_t)(input[18] & 0xe0) << 11);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 147 to 162
	value = ((uint32_t)(input[18] & 0x1f) << 27) |
			((uint32_t)input[19] << 19) |
			((uint32_t)(input[20] & 0xe0) << 11);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 163 to 178
	value = ((uint32_t)(input[20] & 0x1f) << 27) |
			((uint32_t)input[21] << 19) |
			((uint32_t)(input[22] & 0xe0) << 11);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 179 to 194
	value = ((uint32_t)(input[22] & 0x1f) << 27) |
			((uint32_t)input[23] << 19) |
			((uint32_t)(input[24] & 0xe0) << 11);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 195 to 210
	value = ((uint32_t)(input[24] & 0x1f) << 27) |
			((uint32_t)input[25] << 19) |
			((uint32_t)(input[26] & 0xe0) << 11);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 211 to 226
	value = ((uint32_t)(input[26] & 0x1f) << 27) |
			((uint32_t)input[27] << 19) |
			((uint32_t)(input[28] & 0xe0) << 11);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 227 to 242
	value = ((uint32_t)(input[28] & 0x1f) << 27) |
			((uint32_t)input[29] << 19) |
			((uint32_t)(input[30] & 0xe0) << 11);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 243 to 258
	value = ((uint32_t)(input[30] & 0x1f) << 27) |
			((uint32_t)input[31] << 19) |
			((uint32_t)(input[32] & 0xe0) << 11);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 259 to 274
	value = ((uint32_t)(input[32] & 0x1f) << 27) |
			((uint32_t)input[33] << 19) |
			((uint32_t)(input[34] & 0xe0) << 11);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 275 to 290
	value = ((uint32_t)(input[34] & 0x1f) << 27) |
			((uint32_t)input[35] << 19) |
			((uint32_t)(input[36] & 0xe0) << 11);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 291 to 306
	value = ((uint32_t)(input[36] & 0x1f) << 27) |
			((uint32_t)input[37] << 19) |
			((uint32_t)(input[38] & 0xe0) << 11);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 307 to 322
	value = ((uint32_t)(input[38] & 0x1f) << 27) |
			((uint32_t)input[39] << 19) |
			((uint32_t)(input[40] & 0xe0) << 11);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 323 to 338
	value = ((uint32_t)(input[40] & 0x1f) << 27) |
			((uint32_t)input[41] << 19) |
			((uint32_t)(input[42] & 0xe0) << 11);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 339 to 354
	value = ((uint32_t)(input[42] & 0x1f) << 27) |
			((uint32_t)input[43] << 19) |
			((uint32_t)(input[44] & 0xe0) << 11);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 355 to 370
	value = ((uint32_t)(input[44] & 0x1f) << 27) |
			((uint32_t)input[45] << 19) |
			((uint32_t)(input[46] & 0xe0) << 11);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 371 to 386
	value = ((uint32_t)(input[46] & 0x1f) << 27) |
			((uint32_t)input[47] << 19) |
			((uint32_t)(input[48] & 0xe0) << 11);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 387 to 402
	value = ((uint32_t)(input[48] & 0x1f) << 27) |
			((uint32_t)input[49] << 19) |
			((uint32_t)(input[50] & 0xe0) << 11);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 403 to 418
	value = ((uint32_t)(input[50] & 0x1f) << 27) |
			((uint32_t)input[51] << 19) |
			((uint32_t)(input[52] & 0xe0) << 11);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 419 to 434
	value = ((uint32_t)(input[52] & 0x1f) << 27) |
			((uint32_t)input[53] << 19) |
			((uint32_t)(input[54] & 0xe0) << 11);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 435 to 450
	value = ((uint32_t)(input[54] & 0x1f) << 27) |
			((uint32_t)input[55] << 19) |
			((uint32_t)(input[56] & 0xe0) << 11);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 451 to 466
	value = ((uint32_t)(input[56] & 0x1f) << 27) |
			((uint32_t)input[57] << 19) |
			((uint32_t)(input[58] & 0xe0) << 11);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 467 to 482
	value = ((uint32_t)(input[58] & 0x1f) << 27) |
			((uint32_t)input[59] << 19) |
			((uint32_t)(input[60] & 0xe0) << 11);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 483 to 498
	value = ((uint32_t)(input[60] & 0x1f) << 27) |
			((uint32_t)input[61] << 19) |
			((uint32_t)(input[62] & 0xe0) << 11);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 499 to 514
	value = ((uint32_t)(input[62] & 0x1f) << 27) |
			((uint32_t)input[63] << 19) |
			((uint32_t)(input[64] & 0xe0) << 11);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 515 to 530
	value = ((uint32_t)(input[64] & 0x1f) << 27) |
			((uint32_t)input[65] << 19) |
			((uint32_t)(input[66] & 0xe0) << 11);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 531 to 546
	value = ((uint32_t)(input[66] & 0x1f) << 27) |
			((uint32_t)input[67] << 19) |
			((uint32_t)(input[68] & 0xe0) << 11);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 547 to 562
	value = ((uint32_t)(input[68] & 0x1f) << 27) |
			((uint32_t)input[69] << 19) |
			((uint32_t)(input[70] & 0xe0) << 11);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 563 to 578
	value = ((uint32_t)(input[70] & 0x1f) << 27) |
			((uint32_t)input[71] << 19) |
			((uint32_t)(input[72] & 0xe0) << 11);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 579 to 594
	value = ((uint32_t)(input[72] & 0x1f) << 27) |
			((uint32_t)input[73] << 19) |
			((uint32_t)(input[74] & 0xe0) << 11);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 595 to 610
	value = ((uint32_t)(input[74] & 0x1f) << 27) |
			((uint32_t)input[75] << 19) |
			((uint32_t)(input[76] & 0xe0) << 11);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 611 to 626
	value = ((uint32_t)(input[76] & 0x1f) << 27) |
			((uint32_t)input[77] << 19) |
			((uint32_t)(input[78] & 0xe0) << 11);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 627 to 642
	value = ((uint32_t)(input[78] & 0x1f) << 27) |
			((uint32_t)input[79] << 19) |
			((uint32_t)(input[80] & 0xe0) << 11);
	output[39] = (double)(value >> 16);
}

static void unpack_40_16bit_unsigned_3off(const uint8_t * input, double * output, void *closure) {
	// Unpack 40 values into output
	// Values are 16-bit unsigned
	// Skip 3 bits, read 640 bits of data.
	// Input must be at least 81 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 3 to 18
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)input[1] << 19) |
			((uint32_t)(input[2] & 0xe0) << 11);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 19 to 34
	value = ((uint32_t)(input[2] & 0x1f) << 27) |
			((uint32_t)input[3] << 19) |
			((uint32_t)(input[4] & 0xe0) << 11);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 35 to 50
	value = ((uint32_t)(input[4] & 0x1f) << 27) |
			((uint32_t)input[5] << 19) |
			((uint32_t)(input[6] & 0xe0) << 11);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 51 to 66
	value = ((uint32_t)(input[6] & 0x1f) << 27) |
			((uint32_t)input[7] << 19) |
			((uint32_t)(input[8] & 0xe0) << 11);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 67 to 82
	value = ((uint32_t)(input[8] & 0x1f) << 27) |
			((uint32_t)input[9] << 19) |
			((uint32_t)(input[10] & 0xe0) << 11);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 83 to 98
	value = ((uint32_t)(input[10] & 0x1f) << 27) |
			((uint32_t)input[11] << 19) |
			((uint32_t)(input[12] & 0xe0) << 11);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 99 to 114
	value = ((uint32_t)(input[12] & 0x1f) << 27) |
			((uint32_t)input[13] << 19) |
			((uint32_t)(input[14] & 0xe0) << 11);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 115 to 130
	value = ((uint32_t)(input[14] & 0x1f) << 27) |
			((uint32_t)input[15] << 19) |
			((uint32_t)(input[16] & 0xe0) << 11);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 131 to 146
	value = ((uint32_t)(input[16] & 0x1f) << 27) |
			((uint32_t)input[17] << 19) |
			((uint32_t)(input[18] & 0xe0) << 11);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 147 to 162
	value = ((uint32_t)(input[18] & 0x1f) << 27) |
			((uint32_t)input[19] << 19) |
			((uint32_t)(input[20] & 0xe0) << 11);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 163 to 178
	value = ((uint32_t)(input[20] & 0x1f) << 27) |
			((uint32_t)input[21] << 19) |
			((uint32_t)(input[22] & 0xe0) << 11);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 179 to 194
	value = ((uint32_t)(input[22] & 0x1f) << 27) |
			((uint32_t)input[23] << 19) |
			((uint32_t)(input[24] & 0xe0) << 11);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 195 to 210
	value = ((uint32_t)(input[24] & 0x1f) << 27) |
			((uint32_t)input[25] << 19) |
			((uint32_t)(input[26] & 0xe0) << 11);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 211 to 226
	value = ((uint32_t)(input[26] & 0x1f) << 27) |
			((uint32_t)input[27] << 19) |
			((uint32_t)(input[28] & 0xe0) << 11);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 227 to 242
	value = ((uint32_t)(input[28] & 0x1f) << 27) |
			((uint32_t)input[29] << 19) |
			((uint32_t)(input[30] & 0xe0) << 11);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 243 to 258
	value = ((uint32_t)(input[30] & 0x1f) << 27) |
			((uint32_t)input[31] << 19) |
			((uint32_t)(input[32] & 0xe0) << 11);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 259 to 274
	value = ((uint32_t)(input[32] & 0x1f) << 27) |
			((uint32_t)input[33] << 19) |
			((uint32_t)(input[34] & 0xe0) << 11);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 275 to 290
	value = ((uint32_t)(input[34] & 0x1f) << 27) |
			((uint32_t)input[35] << 19) |
			((uint32_t)(input[36] & 0xe0) << 11);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 291 to 306
	value = ((uint32_t)(input[36] & 0x1f) << 27) |
			((uint32_t)input[37] << 19) |
			((uint32_t)(input[38] & 0xe0) << 11);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 307 to 322
	value = ((uint32_t)(input[38] & 0x1f) << 27) |
			((uint32_t)input[39] << 19) |
			((uint32_t)(input[40] & 0xe0) << 11);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 323 to 338
	value = ((uint32_t)(input[40] & 0x1f) << 27) |
			((uint32_t)input[41] << 19) |
			((uint32_t)(input[42] & 0xe0) << 11);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 339 to 354
	value = ((uint32_t)(input[42] & 0x1f) << 27) |
			((uint32_t)input[43] << 19) |
			((uint32_t)(input[44] & 0xe0) << 11);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 355 to 370
	value = ((uint32_t)(input[44] & 0x1f) << 27) |
			((uint32_t)input[45] << 19) |
			((uint32_t)(input[46] & 0xe0) << 11);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 371 to 386
	value = ((uint32_t)(input[46] & 0x1f) << 27) |
			((uint32_t)input[47] << 19) |
			((uint32_t)(input[48] & 0xe0) << 11);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 387 to 402
	value = ((uint32_t)(input[48] & 0x1f) << 27) |
			((uint32_t)input[49] << 19) |
			((uint32_t)(input[50] & 0xe0) << 11);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 403 to 418
	value = ((uint32_t)(input[50] & 0x1f) << 27) |
			((uint32_t)input[51] << 19) |
			((uint32_t)(input[52] & 0xe0) << 11);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 419 to 434
	value = ((uint32_t)(input[52] & 0x1f) << 27) |
			((uint32_t)input[53] << 19) |
			((uint32_t)(input[54] & 0xe0) << 11);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 435 to 450
	value = ((uint32_t)(input[54] & 0x1f) << 27) |
			((uint32_t)input[55] << 19) |
			((uint32_t)(input[56] & 0xe0) << 11);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 451 to 466
	value = ((uint32_t)(input[56] & 0x1f) << 27) |
			((uint32_t)input[57] << 19) |
			((uint32_t)(input[58] & 0xe0) << 11);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 467 to 482
	value = ((uint32_t)(input[58] & 0x1f) << 27) |
			((uint32_t)input[59] << 19) |
			((uint32_t)(input[60] & 0xe0) << 11);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 483 to 498
	value = ((uint32_t)(input[60] & 0x1f) << 27) |
			((uint32_t)input[61] << 19) |
			((uint32_t)(input[62] & 0xe0) << 11);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 499 to 514
	value = ((uint32_t)(input[62] & 0x1f) << 27) |
			((uint32_t)input[63] << 19) |
			((uint32_t)(input[64] & 0xe0) << 11);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 515 to 530
	value = ((uint32_t)(input[64] & 0x1f) << 27) |
			((uint32_t)input[65] << 19) |
			((uint32_t)(input[66] & 0xe0) << 11);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 531 to 546
	value = ((uint32_t)(input[66] & 0x1f) << 27) |
			((uint32_t)input[67] << 19) |
			((uint32_t)(input[68] & 0xe0) << 11);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 547 to 562
	value = ((uint32_t)(input[68] & 0x1f) << 27) |
			((uint32_t)input[69] << 19) |
			((uint32_t)(input[70] & 0xe0) << 11);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 563 to 578
	value = ((uint32_t)(input[70] & 0x1f) << 27) |
			((uint32_t)input[71] << 19) |
			((uint32_t)(input[72] & 0xe0) << 11);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 579 to 594
	value = ((uint32_t)(input[72] & 0x1f) << 27) |
			((uint32_t)input[73] << 19) |
			((uint32_t)(input[74] & 0xe0) << 11);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 595 to 610
	value = ((uint32_t)(input[74] & 0x1f) << 27) |
			((uint32_t)input[75] << 19) |
			((uint32_t)(input[76] & 0xe0) << 11);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 611 to 626
	value = ((uint32_t)(input[76] & 0x1f) << 27) |
			((uint32_t)input[77] << 19) |
			((uint32_t)(input[78] & 0xe0) << 11);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 627 to 642
	value = ((uint32_t)(input[78] & 0x1f) << 27) |
			((uint32_t)input[79] << 19) |
			((uint32_t)(input[80] & 0xe0) << 11);
	output[39] = (double)(value >> 16);
}

static void unpack_40_16bit_signed_4off(const uint8_t * input, double * output, void *closure) {
	// Unpack 40 values into output
	// Values are 16-bit signed
	// Skip 4 bits, read 640 bits of data.
	// Input must be at least 81 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 4 to 19
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20) |
			((uint32_t)(input[2] & 0xf0) << 12);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 20 to 35
	value = ((uint32_t)(input[2] & 0x0f) << 28) |
			((uint32_t)input[3] << 20) |
			((uint32_t)(input[4] & 0xf0) << 12);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 36 to 51
	value = ((uint32_t)(input[4] & 0x0f) << 28) |
			((uint32_t)input[5] << 20) |
			((uint32_t)(input[6] & 0xf0) << 12);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 52 to 67
	value = ((uint32_t)(input[6] & 0x0f) << 28) |
			((uint32_t)input[7] << 20) |
			((uint32_t)(input[8] & 0xf0) << 12);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 68 to 83
	value = ((uint32_t)(input[8] & 0x0f) << 28) |
			((uint32_t)input[9] << 20) |
			((uint32_t)(input[10] & 0xf0) << 12);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 84 to 99
	value = ((uint32_t)(input[10] & 0x0f) << 28) |
			((uint32_t)input[11] << 20) |
			((uint32_t)(input[12] & 0xf0) << 12);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 100 to 115
	value = ((uint32_t)(input[12] & 0x0f) << 28) |
			((uint32_t)input[13] << 20) |
			((uint32_t)(input[14] & 0xf0) << 12);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 116 to 131
	value = ((uint32_t)(input[14] & 0x0f) << 28) |
			((uint32_t)input[15] << 20) |
			((uint32_t)(input[16] & 0xf0) << 12);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 132 to 147
	value = ((uint32_t)(input[16] & 0x0f) << 28) |
			((uint32_t)input[17] << 20) |
			((uint32_t)(input[18] & 0xf0) << 12);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 148 to 163
	value = ((uint32_t)(input[18] & 0x0f) << 28) |
			((uint32_t)input[19] << 20) |
			((uint32_t)(input[20] & 0xf0) << 12);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 164 to 179
	value = ((uint32_t)(input[20] & 0x0f) << 28) |
			((uint32_t)input[21] << 20) |
			((uint32_t)(input[22] & 0xf0) << 12);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 180 to 195
	value = ((uint32_t)(input[22] & 0x0f) << 28) |
			((uint32_t)input[23] << 20) |
			((uint32_t)(input[24] & 0xf0) << 12);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 196 to 211
	value = ((uint32_t)(input[24] & 0x0f) << 28) |
			((uint32_t)input[25] << 20) |
			((uint32_t)(input[26] & 0xf0) << 12);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 212 to 227
	value = ((uint32_t)(input[26] & 0x0f) << 28) |
			((uint32_t)input[27] << 20) |
			((uint32_t)(input[28] & 0xf0) << 12);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 228 to 243
	value = ((uint32_t)(input[28] & 0x0f) << 28) |
			((uint32_t)input[29] << 20) |
			((uint32_t)(input[30] & 0xf0) << 12);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 244 to 259
	value = ((uint32_t)(input[30] & 0x0f) << 28) |
			((uint32_t)input[31] << 20) |
			((uint32_t)(input[32] & 0xf0) << 12);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 260 to 275
	value = ((uint32_t)(input[32] & 0x0f) << 28) |
			((uint32_t)input[33] << 20) |
			((uint32_t)(input[34] & 0xf0) << 12);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 276 to 291
	value = ((uint32_t)(input[34] & 0x0f) << 28) |
			((uint32_t)input[35] << 20) |
			((uint32_t)(input[36] & 0xf0) << 12);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 292 to 307
	value = ((uint32_t)(input[36] & 0x0f) << 28) |
			((uint32_t)input[37] << 20) |
			((uint32_t)(input[38] & 0xf0) << 12);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 308 to 323
	value = ((uint32_t)(input[38] & 0x0f) << 28) |
			((uint32_t)input[39] << 20) |
			((uint32_t)(input[40] & 0xf0) << 12);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 324 to 339
	value = ((uint32_t)(input[40] & 0x0f) << 28) |
			((uint32_t)input[41] << 20) |
			((uint32_t)(input[42] & 0xf0) << 12);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 340 to 355
	value = ((uint32_t)(input[42] & 0x0f) << 28) |
			((uint32_t)input[43] << 20) |
			((uint32_t)(input[44] & 0xf0) << 12);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 356 to 371
	value = ((uint32_t)(input[44] & 0x0f) << 28) |
			((uint32_t)input[45] << 20) |
			((uint32_t)(input[46] & 0xf0) << 12);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 372 to 387
	value = ((uint32_t)(input[46] & 0x0f) << 28) |
			((uint32_t)input[47] << 20) |
			((uint32_t)(input[48] & 0xf0) << 12);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 388 to 403
	value = ((uint32_t)(input[48] & 0x0f) << 28) |
			((uint32_t)input[49] << 20) |
			((uint32_t)(input[50] & 0xf0) << 12);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 404 to 419
	value = ((uint32_t)(input[50] & 0x0f) << 28) |
			((uint32_t)input[51] << 20) |
			((uint32_t)(input[52] & 0xf0) << 12);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 420 to 435
	value = ((uint32_t)(input[52] & 0x0f) << 28) |
			((uint32_t)input[53] << 20) |
			((uint32_t)(input[54] & 0xf0) << 12);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 436 to 451
	value = ((uint32_t)(input[54] & 0x0f) << 28) |
			((uint32_t)input[55] << 20) |
			((uint32_t)(input[56] & 0xf0) << 12);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 452 to 467
	value = ((uint32_t)(input[56] & 0x0f) << 28) |
			((uint32_t)input[57] << 20) |
			((uint32_t)(input[58] & 0xf0) << 12);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 468 to 483
	value = ((uint32_t)(input[58] & 0x0f) << 28) |
			((uint32_t)input[59] << 20) |
			((uint32_t)(input[60] & 0xf0) << 12);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 484 to 499
	value = ((uint32_t)(input[60] & 0x0f) << 28) |
			((uint32_t)input[61] << 20) |
			((uint32_t)(input[62] & 0xf0) << 12);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 500 to 515
	value = ((uint32_t)(input[62] & 0x0f) << 28) |
			((uint32_t)input[63] << 20) |
			((uint32_t)(input[64] & 0xf0) << 12);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 516 to 531
	value = ((uint32_t)(input[64] & 0x0f) << 28) |
			((uint32_t)input[65] << 20) |
			((uint32_t)(input[66] & 0xf0) << 12);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 532 to 547
	value = ((uint32_t)(input[66] & 0x0f) << 28) |
			((uint32_t)input[67] << 20) |
			((uint32_t)(input[68] & 0xf0) << 12);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 548 to 563
	value = ((uint32_t)(input[68] & 0x0f) << 28) |
			((uint32_t)input[69] << 20) |
			((uint32_t)(input[70] & 0xf0) << 12);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 564 to 579
	value = ((uint32_t)(input[70] & 0x0f) << 28) |
			((uint32_t)input[71] << 20) |
			((uint32_t)(input[72] & 0xf0) << 12);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 580 to 595
	value = ((uint32_t)(input[72] & 0x0f) << 28) |
			((uint32_t)input[73] << 20) |
			((uint32_t)(input[74] & 0xf0) << 12);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 596 to 611
	value = ((uint32_t)(input[74] & 0x0f) << 28) |
			((uint32_t)input[75] << 20) |
			((uint32_t)(input[76] & 0xf0) << 12);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 612 to 627
	value = ((uint32_t)(input[76] & 0x0f) << 28) |
			((uint32_t)input[77] << 20) |
			((uint32_t)(input[78] & 0xf0) << 12);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 628 to 643
	value = ((uint32_t)(input[78] & 0x0f) << 28) |
			((uint32_t)input[79] << 20) |
			((uint32_t)(input[80] & 0xf0) << 12);
	output[39] = (double)(value >> 16);
}

static void unpack_40_16bit_unsigned_4off(const uint8_t * input, double * output, void *closure) {
	// Unpack 40 values into output
	// Values are 16-bit unsigned
	// Skip 4 bits, read 640 bits of data.
	// Input must be at least 81 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 4 to 19
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20) |
			((uint32_t)(input[2] & 0xf0) << 12);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 20 to 35
	value = ((uint32_t)(input[2] & 0x0f) << 28) |
			((uint32_t)input[3] << 20) |
			((uint32_t)(input[4] & 0xf0) << 12);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 36 to 51
	value = ((uint32_t)(input[4] & 0x0f) << 28) |
			((uint32_t)input[5] << 20) |
			((uint32_t)(input[6] & 0xf0) << 12);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 52 to 67
	value = ((uint32_t)(input[6] & 0x0f) << 28) |
			((uint32_t)input[7] << 20) |
			((uint32_t)(input[8] & 0xf0) << 12);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 68 to 83
	value = ((uint32_t)(input[8] & 0x0f) << 28) |
			((uint32_t)input[9] << 20) |
			((uint32_t)(input[10] & 0xf0) << 12);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 84 to 99
	value = ((uint32_t)(input[10] & 0x0f) << 28) |
			((uint32_t)input[11] << 20) |
			((uint32_t)(input[12] & 0xf0) << 12);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 100 to 115
	value = ((uint32_t)(input[12] & 0x0f) << 28) |
			((uint32_t)input[13] << 20) |
			((uint32_t)(input[14] & 0xf0) << 12);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 116 to 131
	value = ((uint32_t)(input[14] & 0x0f) << 28) |
			((uint32_t)input[15] << 20) |
			((uint32_t)(input[16] & 0xf0) << 12);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 132 to 147
	value = ((uint32_t)(input[16] & 0x0f) << 28) |
			((uint32_t)input[17] << 20) |
			((uint32_t)(input[18] & 0xf0) << 12);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 148 to 163
	value = ((uint32_t)(input[18] & 0x0f) << 28) |
			((uint32_t)input[19] << 20) |
			((uint32_t)(input[20] & 0xf0) << 12);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 164 to 179
	value = ((uint32_t)(input[20] & 0x0f) << 28) |
			((uint32_t)input[21] << 20) |
			((uint32_t)(input[22] & 0xf0) << 12);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 180 to 195
	value = ((uint32_t)(input[22] & 0x0f) << 28) |
			((uint32_t)input[23] << 20) |
			((uint32_t)(input[24] & 0xf0) << 12);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 196 to 211
	value = ((uint32_t)(input[24] & 0x0f) << 28) |
			((uint32_t)input[25] << 20) |
			((uint32_t)(input[26] & 0xf0) << 12);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 212 to 227
	value = ((uint32_t)(input[26] & 0x0f) << 28) |
			((uint32_t)input[27] << 20) |
			((uint32_t)(input[28] & 0xf0) << 12);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 228 to 243
	value = ((uint32_t)(input[28] & 0x0f) << 28) |
			((uint32_t)input[29] << 20) |
			((uint32_t)(input[30] & 0xf0) << 12);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 244 to 259
	value = ((uint32_t)(input[30] & 0x0f) << 28) |
			((uint32_t)input[31] << 20) |
			((uint32_t)(input[32] & 0xf0) << 12);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 260 to 275
	value = ((uint32_t)(input[32] & 0x0f) << 28) |
			((uint32_t)input[33] << 20) |
			((uint32_t)(input[34] & 0xf0) << 12);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 276 to 291
	value = ((uint32_t)(input[34] & 0x0f) << 28) |
			((uint32_t)input[35] << 20) |
			((uint32_t)(input[36] & 0xf0) << 12);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 292 to 307
	value = ((uint32_t)(input[36] & 0x0f) << 28) |
			((uint32_t)input[37] << 20) |
			((uint32_t)(input[38] & 0xf0) << 12);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 308 to 323
	value = ((uint32_t)(input[38] & 0x0f) << 28) |
			((uint32_t)input[39] << 20) |
			((uint32_t)(input[40] & 0xf0) << 12);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 324 to 339
	value = ((uint32_t)(input[40] & 0x0f) << 28) |
			((uint32_t)input[41] << 20) |
			((uint32_t)(input[42] & 0xf0) << 12);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 340 to 355
	value = ((uint32_t)(input[42] & 0x0f) << 28) |
			((uint32_t)input[43] << 20) |
			((uint32_t)(input[44] & 0xf0) << 12);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 356 to 371
	value = ((uint32_t)(input[44] & 0x0f) << 28) |
			((uint32_t)input[45] << 20) |
			((uint32_t)(input[46] & 0xf0) << 12);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 372 to 387
	value = ((uint32_t)(input[46] & 0x0f) << 28) |
			((uint32_t)input[47] << 20) |
			((uint32_t)(input[48] & 0xf0) << 12);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 388 to 403
	value = ((uint32_t)(input[48] & 0x0f) << 28) |
			((uint32_t)input[49] << 20) |
			((uint32_t)(input[50] & 0xf0) << 12);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 404 to 419
	value = ((uint32_t)(input[50] & 0x0f) << 28) |
			((uint32_t)input[51] << 20) |
			((uint32_t)(input[52] & 0xf0) << 12);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 420 to 435
	value = ((uint32_t)(input[52] & 0x0f) << 28) |
			((uint32_t)input[53] << 20) |
			((uint32_t)(input[54] & 0xf0) << 12);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 436 to 451
	value = ((uint32_t)(input[54] & 0x0f) << 28) |
			((uint32_t)input[55] << 20) |
			((uint32_t)(input[56] & 0xf0) << 12);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 452 to 467
	value = ((uint32_t)(input[56] & 0x0f) << 28) |
			((uint32_t)input[57] << 20) |
			((uint32_t)(input[58] & 0xf0) << 12);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 468 to 483
	value = ((uint32_t)(input[58] & 0x0f) << 28) |
			((uint32_t)input[59] << 20) |
			((uint32_t)(input[60] & 0xf0) << 12);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 484 to 499
	value = ((uint32_t)(input[60] & 0x0f) << 28) |
			((uint32_t)input[61] << 20) |
			((uint32_t)(input[62] & 0xf0) << 12);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 500 to 515
	value = ((uint32_t)(input[62] & 0x0f) << 28) |
			((uint32_t)input[63] << 20) |
			((uint32_t)(input[64] & 0xf0) << 12);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 516 to 531
	value = ((uint32_t)(input[64] & 0x0f) << 28) |
			((uint32_t)input[65] << 20) |
			((uint32_t)(input[66] & 0xf0) << 12);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 532 to 547
	value = ((uint32_t)(input[66] & 0x0f) << 28) |
			((uint32_t)input[67] << 20) |
			((uint32_t)(input[68] & 0xf0) << 12);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 548 to 563
	value = ((uint32_t)(input[68] & 0x0f) << 28) |
			((uint32_t)input[69] << 20) |
			((uint32_t)(input[70] & 0xf0) << 12);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 564 to 579
	value = ((uint32_t)(input[70] & 0x0f) << 28) |
			((uint32_t)input[71] << 20) |
			((uint32_t)(input[72] & 0xf0) << 12);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 580 to 595
	value = ((uint32_t)(input[72] & 0x0f) << 28) |
			((uint32_t)input[73] << 20) |
			((uint32_t)(input[74] & 0xf0) << 12);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 596 to 611
	value = ((uint32_t)(input[74] & 0x0f) << 28) |
			((uint32_t)input[75] << 20) |
			((uint32_t)(input[76] & 0xf0) << 12);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 612 to 627
	value = ((uint32_t)(input[76] & 0x0f) << 28) |
			((uint32_t)input[77] << 20) |
			((uint32_t)(input[78] & 0xf0) << 12);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 628 to 643
	value = ((uint32_t)(input[78] & 0x0f) << 28) |
			((uint32_t)input[79] << 20) |
			((uint32_t)(input[80] & 0xf0) << 12);
	output[39] = (double)(value >> 16);
}

static void unpack_40_16bit_signed_5off(const uint8_t * input, double * output, void *closure) {
	// Unpack 40 values into output
	// Values are 16-bit signed
	// Skip 5 bits, read 640 bits of data.
	// Input must be at least 81 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 5 to 20
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)(input[2] & 0xf8) << 13);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 21 to 36
	value = ((uint32_t)(input[2] & 0x07) << 29) |
			((uint32_t)input[3] << 21) |
			((uint32_t)(input[4] & 0xf8) << 13);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 37 to 52
	value = ((uint32_t)(input[4] & 0x07) << 29) |
			((uint32_t)input[5] << 21) |
			((uint32_t)(input[6] & 0xf8) << 13);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 53 to 68
	value = ((uint32_t)(input[6] & 0x07) << 29) |
			((uint32_t)input[7] << 21) |
			((uint32_t)(input[8] & 0xf8) << 13);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 69 to 84
	value = ((uint32_t)(input[8] & 0x07) << 29) |
			((uint32_t)input[9] << 21) |
			((uint32_t)(input[10] & 0xf8) << 13);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 85 to 100
	value = ((uint32_t)(input[10] & 0x07) << 29) |
			((uint32_t)input[11] << 21) |
			((uint32_t)(input[12] & 0xf8) << 13);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 101 to 116
	value = ((uint32_t)(input[12] & 0x07) << 29) |
			((uint32_t)input[13] << 21) |
			((uint32_t)(input[14] & 0xf8) << 13);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 117 to 132
	value = ((uint32_t)(input[14] & 0x07) << 29) |
			((uint32_t)input[15] << 21) |
			((uint32_t)(input[16] & 0xf8) << 13);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 133 to 148
	value = ((uint32_t)(input[16] & 0x07) << 29) |
			((uint32_t)input[17] << 21) |
			((uint32_t)(input[18] & 0xf8) << 13);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 149 to 164
	value = ((uint32_t)(input[18] & 0x07) << 29) |
			((uint32_t)input[19] << 21) |
			((uint32_t)(input[20] & 0xf8) << 13);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 165 to 180
	value = ((uint32_t)(input[20] & 0x07) << 29) |
			((uint32_t)input[21] << 21) |
			((uint32_t)(input[22] & 0xf8) << 13);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 181 to 196
	value = ((uint32_t)(input[22] & 0x07) << 29) |
			((uint32_t)input[23] << 21) |
			((uint32_t)(input[24] & 0xf8) << 13);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 197 to 212
	value = ((uint32_t)(input[24] & 0x07) << 29) |
			((uint32_t)input[25] << 21) |
			((uint32_t)(input[26] & 0xf8) << 13);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 213 to 228
	value = ((uint32_t)(input[26] & 0x07) << 29) |
			((uint32_t)input[27] << 21) |
			((uint32_t)(input[28] & 0xf8) << 13);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 229 to 244
	value = ((uint32_t)(input[28] & 0x07) << 29) |
			((uint32_t)input[29] << 21) |
			((uint32_t)(input[30] & 0xf8) << 13);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 245 to 260
	value = ((uint32_t)(input[30] & 0x07) << 29) |
			((uint32_t)input[31] << 21) |
			((uint32_t)(input[32] & 0xf8) << 13);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 261 to 276
	value = ((uint32_t)(input[32] & 0x07) << 29) |
			((uint32_t)input[33] << 21) |
			((uint32_t)(input[34] & 0xf8) << 13);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 277 to 292
	value = ((uint32_t)(input[34] & 0x07) << 29) |
			((uint32_t)input[35] << 21) |
			((uint32_t)(input[36] & 0xf8) << 13);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 293 to 308
	value = ((uint32_t)(input[36] & 0x07) << 29) |
			((uint32_t)input[37] << 21) |
			((uint32_t)(input[38] & 0xf8) << 13);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 309 to 324
	value = ((uint32_t)(input[38] & 0x07) << 29) |
			((uint32_t)input[39] << 21) |
			((uint32_t)(input[40] & 0xf8) << 13);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 325 to 340
	value = ((uint32_t)(input[40] & 0x07) << 29) |
			((uint32_t)input[41] << 21) |
			((uint32_t)(input[42] & 0xf8) << 13);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 341 to 356
	value = ((uint32_t)(input[42] & 0x07) << 29) |
			((uint32_t)input[43] << 21) |
			((uint32_t)(input[44] & 0xf8) << 13);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 357 to 372
	value = ((uint32_t)(input[44] & 0x07) << 29) |
			((uint32_t)input[45] << 21) |
			((uint32_t)(input[46] & 0xf8) << 13);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 373 to 388
	value = ((uint32_t)(input[46] & 0x07) << 29) |
			((uint32_t)input[47] << 21) |
			((uint32_t)(input[48] & 0xf8) << 13);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 389 to 404
	value = ((uint32_t)(input[48] & 0x07) << 29) |
			((uint32_t)input[49] << 21) |
			((uint32_t)(input[50] & 0xf8) << 13);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 405 to 420
	value = ((uint32_t)(input[50] & 0x07) << 29) |
			((uint32_t)input[51] << 21) |
			((uint32_t)(input[52] & 0xf8) << 13);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 421 to 436
	value = ((uint32_t)(input[52] & 0x07) << 29) |
			((uint32_t)input[53] << 21) |
			((uint32_t)(input[54] & 0xf8) << 13);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 437 to 452
	value = ((uint32_t)(input[54] & 0x07) << 29) |
			((uint32_t)input[55] << 21) |
			((uint32_t)(input[56] & 0xf8) << 13);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 453 to 468
	value = ((uint32_t)(input[56] & 0x07) << 29) |
			((uint32_t)input[57] << 21) |
			((uint32_t)(input[58] & 0xf8) << 13);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 469 to 484
	value = ((uint32_t)(input[58] & 0x07) << 29) |
			((uint32_t)input[59] << 21) |
			((uint32_t)(input[60] & 0xf8) << 13);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 485 to 500
	value = ((uint32_t)(input[60] & 0x07) << 29) |
			((uint32_t)input[61] << 21) |
			((uint32_t)(input[62] & 0xf8) << 13);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 501 to 516
	value = ((uint32_t)(input[62] & 0x07) << 29) |
			((uint32_t)input[63] << 21) |
			((uint32_t)(input[64] & 0xf8) << 13);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 517 to 532
	value = ((uint32_t)(input[64] & 0x07) << 29) |
			((uint32_t)input[65] << 21) |
			((uint32_t)(input[66] & 0xf8) << 13);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 533 to 548
	value = ((uint32_t)(input[66] & 0x07) << 29) |
			((uint32_t)input[67] << 21) |
			((uint32_t)(input[68] & 0xf8) << 13);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 549 to 564
	value = ((uint32_t)(input[68] & 0x07) << 29) |
			((uint32_t)input[69] << 21) |
			((uint32_t)(input[70] & 0xf8) << 13);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 565 to 580
	value = ((uint32_t)(input[70] & 0x07) << 29) |
			((uint32_t)input[71] << 21) |
			((uint32_t)(input[72] & 0xf8) << 13);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 581 to 596
	value = ((uint32_t)(input[72] & 0x07) << 29) |
			((uint32_t)input[73] << 21) |
			((uint32_t)(input[74] & 0xf8) << 13);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 597 to 612
	value = ((uint32_t)(input[74] & 0x07) << 29) |
			((uint32_t)input[75] << 21) |
			((uint32_t)(input[76] & 0xf8) << 13);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 613 to 628
	value = ((uint32_t)(input[76] & 0x07) << 29) |
			((uint32_t)input[77] << 21) |
			((uint32_t)(input[78] & 0xf8) << 13);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 629 to 644
	value = ((uint32_t)(input[78] & 0x07) << 29) |
			((uint32_t)input[79] << 21) |
			((uint32_t)(input[80] & 0xf8) << 13);
	output[39] = (double)(value >> 16);
}

static void unpack_40_16bit_unsigned_5off(const uint8_t * input, double * output, void *closure) {
	// Unpack 40 values into output
	// Values are 16-bit unsigned
	// Skip 5 bits, read 640 bits of data.
	// Input must be at least 81 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 5 to 20
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)(input[2] & 0xf8) << 13);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 21 to 36
	value = ((uint32_t)(input[2] & 0x07) << 29) |
			((uint32_t)input[3] << 21) |
			((uint32_t)(input[4] & 0xf8) << 13);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 37 to 52
	value = ((uint32_t)(input[4] & 0x07) << 29) |
			((uint32_t)input[5] << 21) |
			((uint32_t)(input[6] & 0xf8) << 13);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 53 to 68
	value = ((uint32_t)(input[6] & 0x07) << 29) |
			((uint32_t)input[7] << 21) |
			((uint32_t)(input[8] & 0xf8) << 13);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 69 to 84
	value = ((uint32_t)(input[8] & 0x07) << 29) |
			((uint32_t)input[9] << 21) |
			((uint32_t)(input[10] & 0xf8) << 13);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 85 to 100
	value = ((uint32_t)(input[10] & 0x07) << 29) |
			((uint32_t)input[11] << 21) |
			((uint32_t)(input[12] & 0xf8) << 13);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 101 to 116
	value = ((uint32_t)(input[12] & 0x07) << 29) |
			((uint32_t)input[13] << 21) |
			((uint32_t)(input[14] & 0xf8) << 13);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 117 to 132
	value = ((uint32_t)(input[14] & 0x07) << 29) |
			((uint32_t)input[15] << 21) |
			((uint32_t)(input[16] & 0xf8) << 13);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 133 to 148
	value = ((uint32_t)(input[16] & 0x07) << 29) |
			((uint32_t)input[17] << 21) |
			((uint32_t)(input[18] & 0xf8) << 13);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 149 to 164
	value = ((uint32_t)(input[18] & 0x07) << 29) |
			((uint32_t)input[19] << 21) |
			((uint32_t)(input[20] & 0xf8) << 13);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 165 to 180
	value = ((uint32_t)(input[20] & 0x07) << 29) |
			((uint32_t)input[21] << 21) |
			((uint32_t)(input[22] & 0xf8) << 13);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 181 to 196
	value = ((uint32_t)(input[22] & 0x07) << 29) |
			((uint32_t)input[23] << 21) |
			((uint32_t)(input[24] & 0xf8) << 13);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 197 to 212
	value = ((uint32_t)(input[24] & 0x07) << 29) |
			((uint32_t)input[25] << 21) |
			((uint32_t)(input[26] & 0xf8) << 13);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 213 to 228
	value = ((uint32_t)(input[26] & 0x07) << 29) |
			((uint32_t)input[27] << 21) |
			((uint32_t)(input[28] & 0xf8) << 13);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 229 to 244
	value = ((uint32_t)(input[28] & 0x07) << 29) |
			((uint32_t)input[29] << 21) |
			((uint32_t)(input[30] & 0xf8) << 13);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 245 to 260
	value = ((uint32_t)(input[30] & 0x07) << 29) |
			((uint32_t)input[31] << 21) |
			((uint32_t)(input[32] & 0xf8) << 13);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 261 to 276
	value = ((uint32_t)(input[32] & 0x07) << 29) |
			((uint32_t)input[33] << 21) |
			((uint32_t)(input[34] & 0xf8) << 13);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 277 to 292
	value = ((uint32_t)(input[34] & 0x07) << 29) |
			((uint32_t)input[35] << 21) |
			((uint32_t)(input[36] & 0xf8) << 13);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 293 to 308
	value = ((uint32_t)(input[36] & 0x07) << 29) |
			((uint32_t)input[37] << 21) |
			((uint32_t)(input[38] & 0xf8) << 13);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 309 to 324
	value = ((uint32_t)(input[38] & 0x07) << 29) |
			((uint32_t)input[39] << 21) |
			((uint32_t)(input[40] & 0xf8) << 13);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 325 to 340
	value = ((uint32_t)(input[40] & 0x07) << 29) |
			((uint32_t)input[41] << 21) |
			((uint32_t)(input[42] & 0xf8) << 13);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 341 to 356
	value = ((uint32_t)(input[42] & 0x07) << 29) |
			((uint32_t)input[43] << 21) |
			((uint32_t)(input[44] & 0xf8) << 13);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 357 to 372
	value = ((uint32_t)(input[44] & 0x07) << 29) |
			((uint32_t)input[45] << 21) |
			((uint32_t)(input[46] & 0xf8) << 13);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 373 to 388
	value = ((uint32_t)(input[46] & 0x07) << 29) |
			((uint32_t)input[47] << 21) |
			((uint32_t)(input[48] & 0xf8) << 13);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 389 to 404
	value = ((uint32_t)(input[48] & 0x07) << 29) |
			((uint32_t)input[49] << 21) |
			((uint32_t)(input[50] & 0xf8) << 13);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 405 to 420
	value = ((uint32_t)(input[50] & 0x07) << 29) |
			((uint32_t)input[51] << 21) |
			((uint32_t)(input[52] & 0xf8) << 13);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 421 to 436
	value = ((uint32_t)(input[52] & 0x07) << 29) |
			((uint32_t)input[53] << 21) |
			((uint32_t)(input[54] & 0xf8) << 13);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 437 to 452
	value = ((uint32_t)(input[54] & 0x07) << 29) |
			((uint32_t)input[55] << 21) |
			((uint32_t)(input[56] & 0xf8) << 13);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 453 to 468
	value = ((uint32_t)(input[56] & 0x07) << 29) |
			((uint32_t)input[57] << 21) |
			((uint32_t)(input[58] & 0xf8) << 13);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 469 to 484
	value = ((uint32_t)(input[58] & 0x07) << 29) |
			((uint32_t)input[59] << 21) |
			((uint32_t)(input[60] & 0xf8) << 13);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 485 to 500
	value = ((uint32_t)(input[60] & 0x07) << 29) |
			((uint32_t)input[61] << 21) |
			((uint32_t)(input[62] & 0xf8) << 13);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 501 to 516
	value = ((uint32_t)(input[62] & 0x07) << 29) |
			((uint32_t)input[63] << 21) |
			((uint32_t)(input[64] & 0xf8) << 13);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 517 to 532
	value = ((uint32_t)(input[64] & 0x07) << 29) |
			((uint32_t)input[65] << 21) |
			((uint32_t)(input[66] & 0xf8) << 13);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 533 to 548
	value = ((uint32_t)(input[66] & 0x07) << 29) |
			((uint32_t)input[67] << 21) |
			((uint32_t)(input[68] & 0xf8) << 13);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 549 to 564
	value = ((uint32_t)(input[68] & 0x07) << 29) |
			((uint32_t)input[69] << 21) |
			((uint32_t)(input[70] & 0xf8) << 13);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 565 to 580
	value = ((uint32_t)(input[70] & 0x07) << 29) |
			((uint32_t)input[71] << 21) |
			((uint32_t)(input[72] & 0xf8) << 13);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 581 to 596
	value = ((uint32_t)(input[72] & 0x07) << 29) |
			((uint32_t)input[73] << 21) |
			((uint32_t)(input[74] & 0xf8) << 13);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 597 to 612
	value = ((uint32_t)(input[74] & 0x07) << 29) |
			((uint32_t)input[75] << 21) |
			((uint32_t)(input[76] & 0xf8) << 13);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 613 to 628
	value = ((uint32_t)(input[76] & 0x07) << 29) |
			((uint32_t)input[77] << 21) |
			((uint32_t)(input[78] & 0xf8) << 13);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 629 to 644
	value = ((uint32_t)(input[78] & 0x07) << 29) |
			((uint32_t)input[79] << 21) |
			((uint32_t)(input[80] & 0xf8) << 13);
	output[39] = (double)(value >> 16);
}

static void unpack_40_16bit_signed_6off(const uint8_t * input, double * output, void *closure) {
	// Unpack 40 values into output
	// Values are 16-bit signed
	// Skip 6 bits, read 640 bits of data.
	// Input must be at least 81 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 6 to 21
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)(input[2] & 0xfc) << 14);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 22 to 37
	value = ((uint32_t)(input[2] & 0x03) << 30) |
			((uint32_t)input[3] << 22) |
			((uint32_t)(input[4] & 0xfc) << 14);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 38 to 53
	value = ((uint32_t)(input[4] & 0x03) << 30) |
			((uint32_t)input[5] << 22) |
			((uint32_t)(input[6] & 0xfc) << 14);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 54 to 69
	value = ((uint32_t)(input[6] & 0x03) << 30) |
			((uint32_t)input[7] << 22) |
			((uint32_t)(input[8] & 0xfc) << 14);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 70 to 85
	value = ((uint32_t)(input[8] & 0x03) << 30) |
			((uint32_t)input[9] << 22) |
			((uint32_t)(input[10] & 0xfc) << 14);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 86 to 101
	value = ((uint32_t)(input[10] & 0x03) << 30) |
			((uint32_t)input[11] << 22) |
			((uint32_t)(input[12] & 0xfc) << 14);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 102 to 117
	value = ((uint32_t)(input[12] & 0x03) << 30) |
			((uint32_t)input[13] << 22) |
			((uint32_t)(input[14] & 0xfc) << 14);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 118 to 133
	value = ((uint32_t)(input[14] & 0x03) << 30) |
			((uint32_t)input[15] << 22) |
			((uint32_t)(input[16] & 0xfc) << 14);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 134 to 149
	value = ((uint32_t)(input[16] & 0x03) << 30) |
			((uint32_t)input[17] << 22) |
			((uint32_t)(input[18] & 0xfc) << 14);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 150 to 165
	value = ((uint32_t)(input[18] & 0x03) << 30) |
			((uint32_t)input[19] << 22) |
			((uint32_t)(input[20] & 0xfc) << 14);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 166 to 181
	value = ((uint32_t)(input[20] & 0x03) << 30) |
			((uint32_t)input[21] << 22) |
			((uint32_t)(input[22] & 0xfc) << 14);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 182 to 197
	value = ((uint32_t)(input[22] & 0x03) << 30) |
			((uint32_t)input[23] << 22) |
			((uint32_t)(input[24] & 0xfc) << 14);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 198 to 213
	value = ((uint32_t)(input[24] & 0x03) << 30) |
			((uint32_t)input[25] << 22) |
			((uint32_t)(input[26] & 0xfc) << 14);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 214 to 229
	value = ((uint32_t)(input[26] & 0x03) << 30) |
			((uint32_t)input[27] << 22) |
			((uint32_t)(input[28] & 0xfc) << 14);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 230 to 245
	value = ((uint32_t)(input[28] & 0x03) << 30) |
			((uint32_t)input[29] << 22) |
			((uint32_t)(input[30] & 0xfc) << 14);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 246 to 261
	value = ((uint32_t)(input[30] & 0x03) << 30) |
			((uint32_t)input[31] << 22) |
			((uint32_t)(input[32] & 0xfc) << 14);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 262 to 277
	value = ((uint32_t)(input[32] & 0x03) << 30) |
			((uint32_t)input[33] << 22) |
			((uint32_t)(input[34] & 0xfc) << 14);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 278 to 293
	value = ((uint32_t)(input[34] & 0x03) << 30) |
			((uint32_t)input[35] << 22) |
			((uint32_t)(input[36] & 0xfc) << 14);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 294 to 309
	value = ((uint32_t)(input[36] & 0x03) << 30) |
			((uint32_t)input[37] << 22) |
			((uint32_t)(input[38] & 0xfc) << 14);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 310 to 325
	value = ((uint32_t)(input[38] & 0x03) << 30) |
			((uint32_t)input[39] << 22) |
			((uint32_t)(input[40] & 0xfc) << 14);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 326 to 341
	value = ((uint32_t)(input[40] & 0x03) << 30) |
			((uint32_t)input[41] << 22) |
			((uint32_t)(input[42] & 0xfc) << 14);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 342 to 357
	value = ((uint32_t)(input[42] & 0x03) << 30) |
			((uint32_t)input[43] << 22) |
			((uint32_t)(input[44] & 0xfc) << 14);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 358 to 373
	value = ((uint32_t)(input[44] & 0x03) << 30) |
			((uint32_t)input[45] << 22) |
			((uint32_t)(input[46] & 0xfc) << 14);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 374 to 389
	value = ((uint32_t)(input[46] & 0x03) << 30) |
			((uint32_t)input[47] << 22) |
			((uint32_t)(input[48] & 0xfc) << 14);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 390 to 405
	value = ((uint32_t)(input[48] & 0x03) << 30) |
			((uint32_t)input[49] << 22) |
			((uint32_t)(input[50] & 0xfc) << 14);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 406 to 421
	value = ((uint32_t)(input[50] & 0x03) << 30) |
			((uint32_t)input[51] << 22) |
			((uint32_t)(input[52] & 0xfc) << 14);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 422 to 437
	value = ((uint32_t)(input[52] & 0x03) << 30) |
			((uint32_t)input[53] << 22) |
			((uint32_t)(input[54] & 0xfc) << 14);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 438 to 453
	value = ((uint32_t)(input[54] & 0x03) << 30) |
			((uint32_t)input[55] << 22) |
			((uint32_t)(input[56] & 0xfc) << 14);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 454 to 469
	value = ((uint32_t)(input[56] & 0x03) << 30) |
			((uint32_t)input[57] << 22) |
			((uint32_t)(input[58] & 0xfc) << 14);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 470 to 485
	value = ((uint32_t)(input[58] & 0x03) << 30) |
			((uint32_t)input[59] << 22) |
			((uint32_t)(input[60] & 0xfc) << 14);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 486 to 501
	value = ((uint32_t)(input[60] & 0x03) << 30) |
			((uint32_t)input[61] << 22) |
			((uint32_t)(input[62] & 0xfc) << 14);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 502 to 517
	value = ((uint32_t)(input[62] & 0x03) << 30) |
			((uint32_t)input[63] << 22) |
			((uint32_t)(input[64] & 0xfc) << 14);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 518 to 533
	value = ((uint32_t)(input[64] & 0x03) << 30) |
			((uint32_t)input[65] << 22) |
			((uint32_t)(input[66] & 0xfc) << 14);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 534 to 549
	value = ((uint32_t)(input[66] & 0x03) << 30) |
			((uint32_t)input[67] << 22) |
			((uint32_t)(input[68] & 0xfc) << 14);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 550 to 565
	value = ((uint32_t)(input[68] & 0x03) << 30) |
			((uint32_t)input[69] << 22) |
			((uint32_t)(input[70] & 0xfc) << 14);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 566 to 581
	value = ((uint32_t)(input[70] & 0x03) << 30) |
			((uint32_t)input[71] << 22) |
			((uint32_t)(input[72] & 0xfc) << 14);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 582 to 597
	value = ((uint32_t)(input[72] & 0x03) << 30) |
			((uint32_t)input[73] << 22) |
			((uint32_t)(input[74] & 0xfc) << 14);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 598 to 613
	value = ((uint32_t)(input[74] & 0x03) << 30) |
			((uint32_t)input[75] << 22) |
			((uint32_t)(input[76] & 0xfc) << 14);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 614 to 629
	value = ((uint32_t)(input[76] & 0x03) << 30) |
			((uint32_t)input[77] << 22) |
			((uint32_t)(input[78] & 0xfc) << 14);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 630 to 645
	value = ((uint32_t)(input[78] & 0x03) << 30) |
			((uint32_t)input[79] << 22) |
			((uint32_t)(input[80] & 0xfc) << 14);
	output[39] = (double)(value >> 16);
}

static void unpack_40_16bit_unsigned_6off(const uint8_t * input, double * output, void *closure) {
	// Unpack 40 values into output
	// Values are 16-bit unsigned
	// Skip 6 bits, read 640 bits of data.
	// Input must be at least 81 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 6 to 21
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)(input[2] & 0xfc) << 14);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 22 to 37
	value = ((uint32_t)(input[2] & 0x03) << 30) |
			((uint32_t)input[3] << 22) |
			((uint32_t)(input[4] & 0xfc) << 14);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 38 to 53
	value = ((uint32_t)(input[4] & 0x03) << 30) |
			((uint32_t)input[5] << 22) |
			((uint32_t)(input[6] & 0xfc) << 14);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 54 to 69
	value = ((uint32_t)(input[6] & 0x03) << 30) |
			((uint32_t)input[7] << 22) |
			((uint32_t)(input[8] & 0xfc) << 14);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 70 to 85
	value = ((uint32_t)(input[8] & 0x03) << 30) |
			((uint32_t)input[9] << 22) |
			((uint32_t)(input[10] & 0xfc) << 14);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 86 to 101
	value = ((uint32_t)(input[10] & 0x03) << 30) |
			((uint32_t)input[11] << 22) |
			((uint32_t)(input[12] & 0xfc) << 14);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 102 to 117
	value = ((uint32_t)(input[12] & 0x03) << 30) |
			((uint32_t)input[13] << 22) |
			((uint32_t)(input[14] & 0xfc) << 14);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 118 to 133
	value = ((uint32_t)(input[14] & 0x03) << 30) |
			((uint32_t)input[15] << 22) |
			((uint32_t)(input[16] & 0xfc) << 14);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 134 to 149
	value = ((uint32_t)(input[16] & 0x03) << 30) |
			((uint32_t)input[17] << 22) |
			((uint32_t)(input[18] & 0xfc) << 14);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 150 to 165
	value = ((uint32_t)(input[18] & 0x03) << 30) |
			((uint32_t)input[19] << 22) |
			((uint32_t)(input[20] & 0xfc) << 14);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 166 to 181
	value = ((uint32_t)(input[20] & 0x03) << 30) |
			((uint32_t)input[21] << 22) |
			((uint32_t)(input[22] & 0xfc) << 14);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 182 to 197
	value = ((uint32_t)(input[22] & 0x03) << 30) |
			((uint32_t)input[23] << 22) |
			((uint32_t)(input[24] & 0xfc) << 14);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 198 to 213
	value = ((uint32_t)(input[24] & 0x03) << 30) |
			((uint32_t)input[25] << 22) |
			((uint32_t)(input[26] & 0xfc) << 14);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 214 to 229
	value = ((uint32_t)(input[26] & 0x03) << 30) |
			((uint32_t)input[27] << 22) |
			((uint32_t)(input[28] & 0xfc) << 14);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 230 to 245
	value = ((uint32_t)(input[28] & 0x03) << 30) |
			((uint32_t)input[29] << 22) |
			((uint32_t)(input[30] & 0xfc) << 14);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 246 to 261
	value = ((uint32_t)(input[30] & 0x03) << 30) |
			((uint32_t)input[31] << 22) |
			((uint32_t)(input[32] & 0xfc) << 14);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 262 to 277
	value = ((uint32_t)(input[32] & 0x03) << 30) |
			((uint32_t)input[33] << 22) |
			((uint32_t)(input[34] & 0xfc) << 14);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 278 to 293
	value = ((uint32_t)(input[34] & 0x03) << 30) |
			((uint32_t)input[35] << 22) |
			((uint32_t)(input[36] & 0xfc) << 14);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 294 to 309
	value = ((uint32_t)(input[36] & 0x03) << 30) |
			((uint32_t)input[37] << 22) |
			((uint32_t)(input[38] & 0xfc) << 14);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 310 to 325
	value = ((uint32_t)(input[38] & 0x03) << 30) |
			((uint32_t)input[39] << 22) |
			((uint32_t)(input[40] & 0xfc) << 14);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 326 to 341
	value = ((uint32_t)(input[40] & 0x03) << 30) |
			((uint32_t)input[41] << 22) |
			((uint32_t)(input[42] & 0xfc) << 14);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 342 to 357
	value = ((uint32_t)(input[42] & 0x03) << 30) |
			((uint32_t)input[43] << 22) |
			((uint32_t)(input[44] & 0xfc) << 14);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 358 to 373
	value = ((uint32_t)(input[44] & 0x03) << 30) |
			((uint32_t)input[45] << 22) |
			((uint32_t)(input[46] & 0xfc) << 14);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 374 to 389
	value = ((uint32_t)(input[46] & 0x03) << 30) |
			((uint32_t)input[47] << 22) |
			((uint32_t)(input[48] & 0xfc) << 14);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 390 to 405
	value = ((uint32_t)(input[48] & 0x03) << 30) |
			((uint32_t)input[49] << 22) |
			((uint32_t)(input[50] & 0xfc) << 14);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 406 to 421
	value = ((uint32_t)(input[50] & 0x03) << 30) |
			((uint32_t)input[51] << 22) |
			((uint32_t)(input[52] & 0xfc) << 14);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 422 to 437
	value = ((uint32_t)(input[52] & 0x03) << 30) |
			((uint32_t)input[53] << 22) |
			((uint32_t)(input[54] & 0xfc) << 14);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 438 to 453
	value = ((uint32_t)(input[54] & 0x03) << 30) |
			((uint32_t)input[55] << 22) |
			((uint32_t)(input[56] & 0xfc) << 14);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 454 to 469
	value = ((uint32_t)(input[56] & 0x03) << 30) |
			((uint32_t)input[57] << 22) |
			((uint32_t)(input[58] & 0xfc) << 14);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 470 to 485
	value = ((uint32_t)(input[58] & 0x03) << 30) |
			((uint32_t)input[59] << 22) |
			((uint32_t)(input[60] & 0xfc) << 14);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 486 to 501
	value = ((uint32_t)(input[60] & 0x03) << 30) |
			((uint32_t)input[61] << 22) |
			((uint32_t)(input[62] & 0xfc) << 14);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 502 to 517
	value = ((uint32_t)(input[62] & 0x03) << 30) |
			((uint32_t)input[63] << 22) |
			((uint32_t)(input[64] & 0xfc) << 14);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 518 to 533
	value = ((uint32_t)(input[64] & 0x03) << 30) |
			((uint32_t)input[65] << 22) |
			((uint32_t)(input[66] & 0xfc) << 14);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 534 to 549
	value = ((uint32_t)(input[66] & 0x03) << 30) |
			((uint32_t)input[67] << 22) |
			((uint32_t)(input[68] & 0xfc) << 14);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 550 to 565
	value = ((uint32_t)(input[68] & 0x03) << 30) |
			((uint32_t)input[69] << 22) |
			((uint32_t)(input[70] & 0xfc) << 14);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 566 to 581
	value = ((uint32_t)(input[70] & 0x03) << 30) |
			((uint32_t)input[71] << 22) |
			((uint32_t)(input[72] & 0xfc) << 14);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 582 to 597
	value = ((uint32_t)(input[72] & 0x03) << 30) |
			((uint32_t)input[73] << 22) |
			((uint32_t)(input[74] & 0xfc) << 14);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 598 to 613
	value = ((uint32_t)(input[74] & 0x03) << 30) |
			((uint32_t)input[75] << 22) |
			((uint32_t)(input[76] & 0xfc) << 14);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 614 to 629
	value = ((uint32_t)(input[76] & 0x03) << 30) |
			((uint32_t)input[77] << 22) |
			((uint32_t)(input[78] & 0xfc) << 14);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 630 to 645
	value = ((uint32_t)(input[78] & 0x03) << 30) |
			((uint32_t)input[79] << 22) |
			((uint32_t)(input[80] & 0xfc) << 14);
	output[39] = (double)(value >> 16);
}

static void unpack_40_16bit_signed_7off(const uint8_t * input, double * output, void *closure) {
	// Unpack 40 values into output
	// Values are 16-bit signed
	// Skip 7 bits, read 640 bits of data.
	// Input must be at least 81 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 7 to 22
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)(input[2] & 0xfe) << 15);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 23 to 38
	value = ((uint32_t)(input[2] & 0x01) << 31) |
			((uint32_t)input[3] << 23) |
			((uint32_t)(input[4] & 0xfe) << 15);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 39 to 54
	value = ((uint32_t)(input[4] & 0x01) << 31) |
			((uint32_t)input[5] << 23) |
			((uint32_t)(input[6] & 0xfe) << 15);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 55 to 70
	value = ((uint32_t)(input[6] & 0x01) << 31) |
			((uint32_t)input[7] << 23) |
			((uint32_t)(input[8] & 0xfe) << 15);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 71 to 86
	value = ((uint32_t)(input[8] & 0x01) << 31) |
			((uint32_t)input[9] << 23) |
			((uint32_t)(input[10] & 0xfe) << 15);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 87 to 102
	value = ((uint32_t)(input[10] & 0x01) << 31) |
			((uint32_t)input[11] << 23) |
			((uint32_t)(input[12] & 0xfe) << 15);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 103 to 118
	value = ((uint32_t)(input[12] & 0x01) << 31) |
			((uint32_t)input[13] << 23) |
			((uint32_t)(input[14] & 0xfe) << 15);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 119 to 134
	value = ((uint32_t)(input[14] & 0x01) << 31) |
			((uint32_t)input[15] << 23) |
			((uint32_t)(input[16] & 0xfe) << 15);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 135 to 150
	value = ((uint32_t)(input[16] & 0x01) << 31) |
			((uint32_t)input[17] << 23) |
			((uint32_t)(input[18] & 0xfe) << 15);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 151 to 166
	value = ((uint32_t)(input[18] & 0x01) << 31) |
			((uint32_t)input[19] << 23) |
			((uint32_t)(input[20] & 0xfe) << 15);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 167 to 182
	value = ((uint32_t)(input[20] & 0x01) << 31) |
			((uint32_t)input[21] << 23) |
			((uint32_t)(input[22] & 0xfe) << 15);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 183 to 198
	value = ((uint32_t)(input[22] & 0x01) << 31) |
			((uint32_t)input[23] << 23) |
			((uint32_t)(input[24] & 0xfe) << 15);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 199 to 214
	value = ((uint32_t)(input[24] & 0x01) << 31) |
			((uint32_t)input[25] << 23) |
			((uint32_t)(input[26] & 0xfe) << 15);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 215 to 230
	value = ((uint32_t)(input[26] & 0x01) << 31) |
			((uint32_t)input[27] << 23) |
			((uint32_t)(input[28] & 0xfe) << 15);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 231 to 246
	value = ((uint32_t)(input[28] & 0x01) << 31) |
			((uint32_t)input[29] << 23) |
			((uint32_t)(input[30] & 0xfe) << 15);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 247 to 262
	value = ((uint32_t)(input[30] & 0x01) << 31) |
			((uint32_t)input[31] << 23) |
			((uint32_t)(input[32] & 0xfe) << 15);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 263 to 278
	value = ((uint32_t)(input[32] & 0x01) << 31) |
			((uint32_t)input[33] << 23) |
			((uint32_t)(input[34] & 0xfe) << 15);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 279 to 294
	value = ((uint32_t)(input[34] & 0x01) << 31) |
			((uint32_t)input[35] << 23) |
			((uint32_t)(input[36] & 0xfe) << 15);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 295 to 310
	value = ((uint32_t)(input[36] & 0x01) << 31) |
			((uint32_t)input[37] << 23) |
			((uint32_t)(input[38] & 0xfe) << 15);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 311 to 326
	value = ((uint32_t)(input[38] & 0x01) << 31) |
			((uint32_t)input[39] << 23) |
			((uint32_t)(input[40] & 0xfe) << 15);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 327 to 342
	value = ((uint32_t)(input[40] & 0x01) << 31) |
			((uint32_t)input[41] << 23) |
			((uint32_t)(input[42] & 0xfe) << 15);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 343 to 358
	value = ((uint32_t)(input[42] & 0x01) << 31) |
			((uint32_t)input[43] << 23) |
			((uint32_t)(input[44] & 0xfe) << 15);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 359 to 374
	value = ((uint32_t)(input[44] & 0x01) << 31) |
			((uint32_t)input[45] << 23) |
			((uint32_t)(input[46] & 0xfe) << 15);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 375 to 390
	value = ((uint32_t)(input[46] & 0x01) << 31) |
			((uint32_t)input[47] << 23) |
			((uint32_t)(input[48] & 0xfe) << 15);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 391 to 406
	value = ((uint32_t)(input[48] & 0x01) << 31) |
			((uint32_t)input[49] << 23) |
			((uint32_t)(input[50] & 0xfe) << 15);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 407 to 422
	value = ((uint32_t)(input[50] & 0x01) << 31) |
			((uint32_t)input[51] << 23) |
			((uint32_t)(input[52] & 0xfe) << 15);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 423 to 438
	value = ((uint32_t)(input[52] & 0x01) << 31) |
			((uint32_t)input[53] << 23) |
			((uint32_t)(input[54] & 0xfe) << 15);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 439 to 454
	value = ((uint32_t)(input[54] & 0x01) << 31) |
			((uint32_t)input[55] << 23) |
			((uint32_t)(input[56] & 0xfe) << 15);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 455 to 470
	value = ((uint32_t)(input[56] & 0x01) << 31) |
			((uint32_t)input[57] << 23) |
			((uint32_t)(input[58] & 0xfe) << 15);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 471 to 486
	value = ((uint32_t)(input[58] & 0x01) << 31) |
			((uint32_t)input[59] << 23) |
			((uint32_t)(input[60] & 0xfe) << 15);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 487 to 502
	value = ((uint32_t)(input[60] & 0x01) << 31) |
			((uint32_t)input[61] << 23) |
			((uint32_t)(input[62] & 0xfe) << 15);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 503 to 518
	value = ((uint32_t)(input[62] & 0x01) << 31) |
			((uint32_t)input[63] << 23) |
			((uint32_t)(input[64] & 0xfe) << 15);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 519 to 534
	value = ((uint32_t)(input[64] & 0x01) << 31) |
			((uint32_t)input[65] << 23) |
			((uint32_t)(input[66] & 0xfe) << 15);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 535 to 550
	value = ((uint32_t)(input[66] & 0x01) << 31) |
			((uint32_t)input[67] << 23) |
			((uint32_t)(input[68] & 0xfe) << 15);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 551 to 566
	value = ((uint32_t)(input[68] & 0x01) << 31) |
			((uint32_t)input[69] << 23) |
			((uint32_t)(input[70] & 0xfe) << 15);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 567 to 582
	value = ((uint32_t)(input[70] & 0x01) << 31) |
			((uint32_t)input[71] << 23) |
			((uint32_t)(input[72] & 0xfe) << 15);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 583 to 598
	value = ((uint32_t)(input[72] & 0x01) << 31) |
			((uint32_t)input[73] << 23) |
			((uint32_t)(input[74] & 0xfe) << 15);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 599 to 614
	value = ((uint32_t)(input[74] & 0x01) << 31) |
			((uint32_t)input[75] << 23) |
			((uint32_t)(input[76] & 0xfe) << 15);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 615 to 630
	value = ((uint32_t)(input[76] & 0x01) << 31) |
			((uint32_t)input[77] << 23) |
			((uint32_t)(input[78] & 0xfe) << 15);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 631 to 646
	value = ((uint32_t)(input[78] & 0x01) << 31) |
			((uint32_t)input[79] << 23) |
			((uint32_t)(input[80] & 0xfe) << 15);
	output[39] = (double)(value >> 16);
}

static void unpack_40_16bit_unsigned_7off(const uint8_t * input, double * output, void *closure) {
	// Unpack 40 values into output
	// Values are 16-bit unsigned
	// Skip 7 bits, read 640 bits of data.
	// Input must be at least 81 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 7 to 22
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)(input[2] & 0xfe) << 15);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 23 to 38
	value = ((uint32_t)(input[2] & 0x01) << 31) |
			((uint32_t)input[3] << 23) |
			((uint32_t)(input[4] & 0xfe) << 15);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 39 to 54
	value = ((uint32_t)(input[4] & 0x01) << 31) |
			((uint32_t)input[5] << 23) |
			((uint32_t)(input[6] & 0xfe) << 15);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 55 to 70
	value = ((uint32_t)(input[6] & 0x01) << 31) |
			((uint32_t)input[7] << 23) |
			((uint32_t)(input[8] & 0xfe) << 15);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 71 to 86
	value = ((uint32_t)(input[8] & 0x01) << 31) |
			((uint32_t)input[9] << 23) |
			((uint32_t)(input[10] & 0xfe) << 15);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 87 to 102
	value = ((uint32_t)(input[10] & 0x01) << 31) |
			((uint32_t)input[11] << 23) |
			((uint32_t)(input[12] & 0xfe) << 15);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 103 to 118
	value = ((uint32_t)(input[12] & 0x01) << 31) |
			((uint32_t)input[13] << 23) |
			((uint32_t)(input[14] & 0xfe) << 15);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 119 to 134
	value = ((uint32_t)(input[14] & 0x01) << 31) |
			((uint32_t)input[15] << 23) |
			((uint32_t)(input[16] & 0xfe) << 15);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 135 to 150
	value = ((uint32_t)(input[16] & 0x01) << 31) |
			((uint32_t)input[17] << 23) |
			((uint32_t)(input[18] & 0xfe) << 15);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 151 to 166
	value = ((uint32_t)(input[18] & 0x01) << 31) |
			((uint32_t)input[19] << 23) |
			((uint32_t)(input[20] & 0xfe) << 15);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 167 to 182
	value = ((uint32_t)(input[20] & 0x01) << 31) |
			((uint32_t)input[21] << 23) |
			((uint32_t)(input[22] & 0xfe) << 15);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 183 to 198
	value = ((uint32_t)(input[22] & 0x01) << 31) |
			((uint32_t)input[23] << 23) |
			((uint32_t)(input[24] & 0xfe) << 15);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 199 to 214
	value = ((uint32_t)(input[24] & 0x01) << 31) |
			((uint32_t)input[25] << 23) |
			((uint32_t)(input[26] & 0xfe) << 15);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 215 to 230
	value = ((uint32_t)(input[26] & 0x01) << 31) |
			((uint32_t)input[27] << 23) |
			((uint32_t)(input[28] & 0xfe) << 15);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 231 to 246
	value = ((uint32_t)(input[28] & 0x01) << 31) |
			((uint32_t)input[29] << 23) |
			((uint32_t)(input[30] & 0xfe) << 15);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 247 to 262
	value = ((uint32_t)(input[30] & 0x01) << 31) |
			((uint32_t)input[31] << 23) |
			((uint32_t)(input[32] & 0xfe) << 15);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 263 to 278
	value = ((uint32_t)(input[32] & 0x01) << 31) |
			((uint32_t)input[33] << 23) |
			((uint32_t)(input[34] & 0xfe) << 15);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 279 to 294
	value = ((uint32_t)(input[34] & 0x01) << 31) |
			((uint32_t)input[35] << 23) |
			((uint32_t)(input[36] & 0xfe) << 15);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 295 to 310
	value = ((uint32_t)(input[36] & 0x01) << 31) |
			((uint32_t)input[37] << 23) |
			((uint32_t)(input[38] & 0xfe) << 15);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 311 to 326
	value = ((uint32_t)(input[38] & 0x01) << 31) |
			((uint32_t)input[39] << 23) |
			((uint32_t)(input[40] & 0xfe) << 15);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 327 to 342
	value = ((uint32_t)(input[40] & 0x01) << 31) |
			((uint32_t)input[41] << 23) |
			((uint32_t)(input[42] & 0xfe) << 15);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 343 to 358
	value = ((uint32_t)(input[42] & 0x01) << 31) |
			((uint32_t)input[43] << 23) |
			((uint32_t)(input[44] & 0xfe) << 15);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 359 to 374
	value = ((uint32_t)(input[44] & 0x01) << 31) |
			((uint32_t)input[45] << 23) |
			((uint32_t)(input[46] & 0xfe) << 15);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 375 to 390
	value = ((uint32_t)(input[46] & 0x01) << 31) |
			((uint32_t)input[47] << 23) |
			((uint32_t)(input[48] & 0xfe) << 15);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 391 to 406
	value = ((uint32_t)(input[48] & 0x01) << 31) |
			((uint32_t)input[49] << 23) |
			((uint32_t)(input[50] & 0xfe) << 15);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 407 to 422
	value = ((uint32_t)(input[50] & 0x01) << 31) |
			((uint32_t)input[51] << 23) |
			((uint32_t)(input[52] & 0xfe) << 15);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 423 to 438
	value = ((uint32_t)(input[52] & 0x01) << 31) |
			((uint32_t)input[53] << 23) |
			((uint32_t)(input[54] & 0xfe) << 15);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 439 to 454
	value = ((uint32_t)(input[54] & 0x01) << 31) |
			((uint32_t)input[55] << 23) |
			((uint32_t)(input[56] & 0xfe) << 15);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 455 to 470
	value = ((uint32_t)(input[56] & 0x01) << 31) |
			((uint32_t)input[57] << 23) |
			((uint32_t)(input[58] & 0xfe) << 15);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 471 to 486
	value = ((uint32_t)(input[58] & 0x01) << 31) |
			((uint32_t)input[59] << 23) |
			((uint32_t)(input[60] & 0xfe) << 15);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 487 to 502
	value = ((uint32_t)(input[60] & 0x01) << 31) |
			((uint32_t)input[61] << 23) |
			((uint32_t)(input[62] & 0xfe) << 15);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 503 to 518
	value = ((uint32_t)(input[62] & 0x01) << 31) |
			((uint32_t)input[63] << 23) |
			((uint32_t)(input[64] & 0xfe) << 15);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 519 to 534
	value = ((uint32_t)(input[64] & 0x01) << 31) |
			((uint32_t)input[65] << 23) |
			((uint32_t)(input[66] & 0xfe) << 15);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 535 to 550
	value = ((uint32_t)(input[66] & 0x01) << 31) |
			((uint32_t)input[67] << 23) |
			((uint32_t)(input[68] & 0xfe) << 15);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 551 to 566
	value = ((uint32_t)(input[68] & 0x01) << 31) |
			((uint32_t)input[69] << 23) |
			((uint32_t)(input[70] & 0xfe) << 15);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 567 to 582
	value = ((uint32_t)(input[70] & 0x01) << 31) |
			((uint32_t)input[71] << 23) |
			((uint32_t)(input[72] & 0xfe) << 15);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 583 to 598
	value = ((uint32_t)(input[72] & 0x01) << 31) |
			((uint32_t)input[73] << 23) |
			((uint32_t)(input[74] & 0xfe) << 15);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 599 to 614
	value = ((uint32_t)(input[74] & 0x01) << 31) |
			((uint32_t)input[75] << 23) |
			((uint32_t)(input[76] & 0xfe) << 15);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 615 to 630
	value = ((uint32_t)(input[76] & 0x01) << 31) |
			((uint32_t)input[77] << 23) |
			((uint32_t)(input[78] & 0xfe) << 15);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 631 to 646
	value = ((uint32_t)(input[78] & 0x01) << 31) |
			((uint32_t)input[79] << 23) |
			((uint32_t)(input[80] & 0xfe) << 15);
	output[39] = (double)(value >> 16);
}

static void unpack_41_16bit_signed_0off(const uint8_t * input, double * output, void *closure) {
	// Unpack 41 values into output
	// Values are 16-bit signed
	// Skip 0 bits, read 656 bits of data.
	// Input must be at least 82 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 0 to 15
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)input[1] << 16);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 16 to 31
	value = ((uint32_t)input[2] << 24) |
			((uint32_t)input[3] << 16);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 32 to 47
	value = ((uint32_t)input[4] << 24) |
			((uint32_t)input[5] << 16);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 48 to 63
	value = ((uint32_t)input[6] << 24) |
			((uint32_t)input[7] << 16);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 64 to 79
	value = ((uint32_t)input[8] << 24) |
			((uint32_t)input[9] << 16);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 80 to 95
	value = ((uint32_t)input[10] << 24) |
			((uint32_t)input[11] << 16);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 96 to 111
	value = ((uint32_t)input[12] << 24) |
			((uint32_t)input[13] << 16);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 112 to 127
	value = ((uint32_t)input[14] << 24) |
			((uint32_t)input[15] << 16);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 128 to 143
	value = ((uint32_t)input[16] << 24) |
			((uint32_t)input[17] << 16);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 144 to 159
	value = ((uint32_t)input[18] << 24) |
			((uint32_t)input[19] << 16);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 160 to 175
	value = ((uint32_t)input[20] << 24) |
			((uint32_t)input[21] << 16);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 176 to 191
	value = ((uint32_t)input[22] << 24) |
			((uint32_t)input[23] << 16);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 192 to 207
	value = ((uint32_t)input[24] << 24) |
			((uint32_t)input[25] << 16);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 208 to 223
	value = ((uint32_t)input[26] << 24) |
			((uint32_t)input[27] << 16);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 224 to 239
	value = ((uint32_t)input[28] << 24) |
			((uint32_t)input[29] << 16);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 240 to 255
	value = ((uint32_t)input[30] << 24) |
			((uint32_t)input[31] << 16);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 256 to 271
	value = ((uint32_t)input[32] << 24) |
			((uint32_t)input[33] << 16);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 272 to 287
	value = ((uint32_t)input[34] << 24) |
			((uint32_t)input[35] << 16);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 288 to 303
	value = ((uint32_t)input[36] << 24) |
			((uint32_t)input[37] << 16);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 304 to 319
	value = ((uint32_t)input[38] << 24) |
			((uint32_t)input[39] << 16);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 320 to 335
	value = ((uint32_t)input[40] << 24) |
			((uint32_t)input[41] << 16);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 336 to 351
	value = ((uint32_t)input[42] << 24) |
			((uint32_t)input[43] << 16);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 352 to 367
	value = ((uint32_t)input[44] << 24) |
			((uint32_t)input[45] << 16);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 368 to 383
	value = ((uint32_t)input[46] << 24) |
			((uint32_t)input[47] << 16);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 384 to 399
	value = ((uint32_t)input[48] << 24) |
			((uint32_t)input[49] << 16);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 400 to 415
	value = ((uint32_t)input[50] << 24) |
			((uint32_t)input[51] << 16);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 416 to 431
	value = ((uint32_t)input[52] << 24) |
			((uint32_t)input[53] << 16);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 432 to 447
	value = ((uint32_t)input[54] << 24) |
			((uint32_t)input[55] << 16);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 448 to 463
	value = ((uint32_t)input[56] << 24) |
			((uint32_t)input[57] << 16);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 464 to 479
	value = ((uint32_t)input[58] << 24) |
			((uint32_t)input[59] << 16);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 480 to 495
	value = ((uint32_t)input[60] << 24) |
			((uint32_t)input[61] << 16);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 496 to 511
	value = ((uint32_t)input[62] << 24) |
			((uint32_t)input[63] << 16);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 512 to 527
	value = ((uint32_t)input[64] << 24) |
			((uint32_t)input[65] << 16);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 528 to 543
	value = ((uint32_t)input[66] << 24) |
			((uint32_t)input[67] << 16);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 544 to 559
	value = ((uint32_t)input[68] << 24) |
			((uint32_t)input[69] << 16);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 560 to 575
	value = ((uint32_t)input[70] << 24) |
			((uint32_t)input[71] << 16);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 576 to 591
	value = ((uint32_t)input[72] << 24) |
			((uint32_t)input[73] << 16);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 592 to 607
	value = ((uint32_t)input[74] << 24) |
			((uint32_t)input[75] << 16);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 608 to 623
	value = ((uint32_t)input[76] << 24) |
			((uint32_t)input[77] << 16);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 624 to 639
	value = ((uint32_t)input[78] << 24) |
			((uint32_t)input[79] << 16);
	output[39] = (double)(value >> 16);

	// read output[40]: from bit 640 to 655
	value = ((uint32_t)input[80] << 24) |
			((uint32_t)input[81] << 16);
	output[40] = (double)(value >> 16);
}

static void unpack_41_16bit_unsigned_0off(const uint8_t * input, double * output, void *closure) {
	// Unpack 41 values into output
	// Values are 16-bit unsigned
	// Skip 0 bits, read 656 bits of data.
	// Input must be at least 82 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 0 to 15
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)input[1] << 16);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 16 to 31
	value = ((uint32_t)input[2] << 24) |
			((uint32_t)input[3] << 16);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 32 to 47
	value = ((uint32_t)input[4] << 24) |
			((uint32_t)input[5] << 16);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 48 to 63
	value = ((uint32_t)input[6] << 24) |
			((uint32_t)input[7] << 16);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 64 to 79
	value = ((uint32_t)input[8] << 24) |
			((uint32_t)input[9] << 16);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 80 to 95
	value = ((uint32_t)input[10] << 24) |
			((uint32_t)input[11] << 16);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 96 to 111
	value = ((uint32_t)input[12] << 24) |
			((uint32_t)input[13] << 16);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 112 to 127
	value = ((uint32_t)input[14] << 24) |
			((uint32_t)input[15] << 16);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 128 to 143
	value = ((uint32_t)input[16] << 24) |
			((uint32_t)input[17] << 16);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 144 to 159
	value = ((uint32_t)input[18] << 24) |
			((uint32_t)input[19] << 16);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 160 to 175
	value = ((uint32_t)input[20] << 24) |
			((uint32_t)input[21] << 16);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 176 to 191
	value = ((uint32_t)input[22] << 24) |
			((uint32_t)input[23] << 16);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 192 to 207
	value = ((uint32_t)input[24] << 24) |
			((uint32_t)input[25] << 16);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 208 to 223
	value = ((uint32_t)input[26] << 24) |
			((uint32_t)input[27] << 16);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 224 to 239
	value = ((uint32_t)input[28] << 24) |
			((uint32_t)input[29] << 16);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 240 to 255
	value = ((uint32_t)input[30] << 24) |
			((uint32_t)input[31] << 16);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 256 to 271
	value = ((uint32_t)input[32] << 24) |
			((uint32_t)input[33] << 16);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 272 to 287
	value = ((uint32_t)input[34] << 24) |
			((uint32_t)input[35] << 16);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 288 to 303
	value = ((uint32_t)input[36] << 24) |
			((uint32_t)input[37] << 16);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 304 to 319
	value = ((uint32_t)input[38] << 24) |
			((uint32_t)input[39] << 16);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 320 to 335
	value = ((uint32_t)input[40] << 24) |
			((uint32_t)input[41] << 16);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 336 to 351
	value = ((uint32_t)input[42] << 24) |
			((uint32_t)input[43] << 16);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 352 to 367
	value = ((uint32_t)input[44] << 24) |
			((uint32_t)input[45] << 16);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 368 to 383
	value = ((uint32_t)input[46] << 24) |
			((uint32_t)input[47] << 16);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 384 to 399
	value = ((uint32_t)input[48] << 24) |
			((uint32_t)input[49] << 16);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 400 to 415
	value = ((uint32_t)input[50] << 24) |
			((uint32_t)input[51] << 16);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 416 to 431
	value = ((uint32_t)input[52] << 24) |
			((uint32_t)input[53] << 16);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 432 to 447
	value = ((uint32_t)input[54] << 24) |
			((uint32_t)input[55] << 16);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 448 to 463
	value = ((uint32_t)input[56] << 24) |
			((uint32_t)input[57] << 16);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 464 to 479
	value = ((uint32_t)input[58] << 24) |
			((uint32_t)input[59] << 16);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 480 to 495
	value = ((uint32_t)input[60] << 24) |
			((uint32_t)input[61] << 16);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 496 to 511
	value = ((uint32_t)input[62] << 24) |
			((uint32_t)input[63] << 16);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 512 to 527
	value = ((uint32_t)input[64] << 24) |
			((uint32_t)input[65] << 16);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 528 to 543
	value = ((uint32_t)input[66] << 24) |
			((uint32_t)input[67] << 16);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 544 to 559
	value = ((uint32_t)input[68] << 24) |
			((uint32_t)input[69] << 16);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 560 to 575
	value = ((uint32_t)input[70] << 24) |
			((uint32_t)input[71] << 16);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 576 to 591
	value = ((uint32_t)input[72] << 24) |
			((uint32_t)input[73] << 16);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 592 to 607
	value = ((uint32_t)input[74] << 24) |
			((uint32_t)input[75] << 16);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 608 to 623
	value = ((uint32_t)input[76] << 24) |
			((uint32_t)input[77] << 16);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 624 to 639
	value = ((uint32_t)input[78] << 24) |
			((uint32_t)input[79] << 16);
	output[39] = (double)(value >> 16);

	// read output[40]: from bit 640 to 655
	value = ((uint32_t)input[80] << 24) |
			((uint32_t)input[81] << 16);
	output[40] = (double)(value >> 16);
}

static void unpack_41_16bit_signed_1off(const uint8_t * input, double * output, void *closure) {
	// Unpack 41 values into output
	// Values are 16-bit signed
	// Skip 1 bits, read 656 bits of data.
	// Input must be at least 83 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 1 to 16
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)input[1] << 17) |
			((uint32_t)(input[2] & 0x80) << 9);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 17 to 32
	value = ((uint32_t)(input[2] & 0x7f) << 25) |
			((uint32_t)input[3] << 17) |
			((uint32_t)(input[4] & 0x80) << 9);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 33 to 48
	value = ((uint32_t)(input[4] & 0x7f) << 25) |
			((uint32_t)input[5] << 17) |
			((uint32_t)(input[6] & 0x80) << 9);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 49 to 64
	value = ((uint32_t)(input[6] & 0x7f) << 25) |
			((uint32_t)input[7] << 17) |
			((uint32_t)(input[8] & 0x80) << 9);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 65 to 80
	value = ((uint32_t)(input[8] & 0x7f) << 25) |
			((uint32_t)input[9] << 17) |
			((uint32_t)(input[10] & 0x80) << 9);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 81 to 96
	value = ((uint32_t)(input[10] & 0x7f) << 25) |
			((uint32_t)input[11] << 17) |
			((uint32_t)(input[12] & 0x80) << 9);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 97 to 112
	value = ((uint32_t)(input[12] & 0x7f) << 25) |
			((uint32_t)input[13] << 17) |
			((uint32_t)(input[14] & 0x80) << 9);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 113 to 128
	value = ((uint32_t)(input[14] & 0x7f) << 25) |
			((uint32_t)input[15] << 17) |
			((uint32_t)(input[16] & 0x80) << 9);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 129 to 144
	value = ((uint32_t)(input[16] & 0x7f) << 25) |
			((uint32_t)input[17] << 17) |
			((uint32_t)(input[18] & 0x80) << 9);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 145 to 160
	value = ((uint32_t)(input[18] & 0x7f) << 25) |
			((uint32_t)input[19] << 17) |
			((uint32_t)(input[20] & 0x80) << 9);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 161 to 176
	value = ((uint32_t)(input[20] & 0x7f) << 25) |
			((uint32_t)input[21] << 17) |
			((uint32_t)(input[22] & 0x80) << 9);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 177 to 192
	value = ((uint32_t)(input[22] & 0x7f) << 25) |
			((uint32_t)input[23] << 17) |
			((uint32_t)(input[24] & 0x80) << 9);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 193 to 208
	value = ((uint32_t)(input[24] & 0x7f) << 25) |
			((uint32_t)input[25] << 17) |
			((uint32_t)(input[26] & 0x80) << 9);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 209 to 224
	value = ((uint32_t)(input[26] & 0x7f) << 25) |
			((uint32_t)input[27] << 17) |
			((uint32_t)(input[28] & 0x80) << 9);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 225 to 240
	value = ((uint32_t)(input[28] & 0x7f) << 25) |
			((uint32_t)input[29] << 17) |
			((uint32_t)(input[30] & 0x80) << 9);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 241 to 256
	value = ((uint32_t)(input[30] & 0x7f) << 25) |
			((uint32_t)input[31] << 17) |
			((uint32_t)(input[32] & 0x80) << 9);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 257 to 272
	value = ((uint32_t)(input[32] & 0x7f) << 25) |
			((uint32_t)input[33] << 17) |
			((uint32_t)(input[34] & 0x80) << 9);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 273 to 288
	value = ((uint32_t)(input[34] & 0x7f) << 25) |
			((uint32_t)input[35] << 17) |
			((uint32_t)(input[36] & 0x80) << 9);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 289 to 304
	value = ((uint32_t)(input[36] & 0x7f) << 25) |
			((uint32_t)input[37] << 17) |
			((uint32_t)(input[38] & 0x80) << 9);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 305 to 320
	value = ((uint32_t)(input[38] & 0x7f) << 25) |
			((uint32_t)input[39] << 17) |
			((uint32_t)(input[40] & 0x80) << 9);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 321 to 336
	value = ((uint32_t)(input[40] & 0x7f) << 25) |
			((uint32_t)input[41] << 17) |
			((uint32_t)(input[42] & 0x80) << 9);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 337 to 352
	value = ((uint32_t)(input[42] & 0x7f) << 25) |
			((uint32_t)input[43] << 17) |
			((uint32_t)(input[44] & 0x80) << 9);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 353 to 368
	value = ((uint32_t)(input[44] & 0x7f) << 25) |
			((uint32_t)input[45] << 17) |
			((uint32_t)(input[46] & 0x80) << 9);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 369 to 384
	value = ((uint32_t)(input[46] & 0x7f) << 25) |
			((uint32_t)input[47] << 17) |
			((uint32_t)(input[48] & 0x80) << 9);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 385 to 400
	value = ((uint32_t)(input[48] & 0x7f) << 25) |
			((uint32_t)input[49] << 17) |
			((uint32_t)(input[50] & 0x80) << 9);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 401 to 416
	value = ((uint32_t)(input[50] & 0x7f) << 25) |
			((uint32_t)input[51] << 17) |
			((uint32_t)(input[52] & 0x80) << 9);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 417 to 432
	value = ((uint32_t)(input[52] & 0x7f) << 25) |
			((uint32_t)input[53] << 17) |
			((uint32_t)(input[54] & 0x80) << 9);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 433 to 448
	value = ((uint32_t)(input[54] & 0x7f) << 25) |
			((uint32_t)input[55] << 17) |
			((uint32_t)(input[56] & 0x80) << 9);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 449 to 464
	value = ((uint32_t)(input[56] & 0x7f) << 25) |
			((uint32_t)input[57] << 17) |
			((uint32_t)(input[58] & 0x80) << 9);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 465 to 480
	value = ((uint32_t)(input[58] & 0x7f) << 25) |
			((uint32_t)input[59] << 17) |
			((uint32_t)(input[60] & 0x80) << 9);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 481 to 496
	value = ((uint32_t)(input[60] & 0x7f) << 25) |
			((uint32_t)input[61] << 17) |
			((uint32_t)(input[62] & 0x80) << 9);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 497 to 512
	value = ((uint32_t)(input[62] & 0x7f) << 25) |
			((uint32_t)input[63] << 17) |
			((uint32_t)(input[64] & 0x80) << 9);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 513 to 528
	value = ((uint32_t)(input[64] & 0x7f) << 25) |
			((uint32_t)input[65] << 17) |
			((uint32_t)(input[66] & 0x80) << 9);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 529 to 544
	value = ((uint32_t)(input[66] & 0x7f) << 25) |
			((uint32_t)input[67] << 17) |
			((uint32_t)(input[68] & 0x80) << 9);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 545 to 560
	value = ((uint32_t)(input[68] & 0x7f) << 25) |
			((uint32_t)input[69] << 17) |
			((uint32_t)(input[70] & 0x80) << 9);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 561 to 576
	value = ((uint32_t)(input[70] & 0x7f) << 25) |
			((uint32_t)input[71] << 17) |
			((uint32_t)(input[72] & 0x80) << 9);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 577 to 592
	value = ((uint32_t)(input[72] & 0x7f) << 25) |
			((uint32_t)input[73] << 17) |
			((uint32_t)(input[74] & 0x80) << 9);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 593 to 608
	value = ((uint32_t)(input[74] & 0x7f) << 25) |
			((uint32_t)input[75] << 17) |
			((uint32_t)(input[76] & 0x80) << 9);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 609 to 624
	value = ((uint32_t)(input[76] & 0x7f) << 25) |
			((uint32_t)input[77] << 17) |
			((uint32_t)(input[78] & 0x80) << 9);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 625 to 640
	value = ((uint32_t)(input[78] & 0x7f) << 25) |
			((uint32_t)input[79] << 17) |
			((uint32_t)(input[80] & 0x80) << 9);
	output[39] = (double)(value >> 16);

	// read output[40]: from bit 641 to 656
	value = ((uint32_t)(input[80] & 0x7f) << 25) |
			((uint32_t)input[81] << 17) |
			((uint32_t)(input[82] & 0x80) << 9);
	output[40] = (double)(value >> 16);
}

static void unpack_41_16bit_unsigned_1off(const uint8_t * input, double * output, void *closure) {
	// Unpack 41 values into output
	// Values are 16-bit unsigned
	// Skip 1 bits, read 656 bits of data.
	// Input must be at least 83 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 1 to 16
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)input[1] << 17) |
			((uint32_t)(input[2] & 0x80) << 9);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 17 to 32
	value = ((uint32_t)(input[2] & 0x7f) << 25) |
			((uint32_t)input[3] << 17) |
			((uint32_t)(input[4] & 0x80) << 9);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 33 to 48
	value = ((uint32_t)(input[4] & 0x7f) << 25) |
			((uint32_t)input[5] << 17) |
			((uint32_t)(input[6] & 0x80) << 9);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 49 to 64
	value = ((uint32_t)(input[6] & 0x7f) << 25) |
			((uint32_t)input[7] << 17) |
			((uint32_t)(input[8] & 0x80) << 9);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 65 to 80
	value = ((uint32_t)(input[8] & 0x7f) << 25) |
			((uint32_t)input[9] << 17) |
			((uint32_t)(input[10] & 0x80) << 9);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 81 to 96
	value = ((uint32_t)(input[10] & 0x7f) << 25) |
			((uint32_t)input[11] << 17) |
			((uint32_t)(input[12] & 0x80) << 9);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 97 to 112
	value = ((uint32_t)(input[12] & 0x7f) << 25) |
			((uint32_t)input[13] << 17) |
			((uint32_t)(input[14] & 0x80) << 9);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 113 to 128
	value = ((uint32_t)(input[14] & 0x7f) << 25) |
			((uint32_t)input[15] << 17) |
			((uint32_t)(input[16] & 0x80) << 9);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 129 to 144
	value = ((uint32_t)(input[16] & 0x7f) << 25) |
			((uint32_t)input[17] << 17) |
			((uint32_t)(input[18] & 0x80) << 9);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 145 to 160
	value = ((uint32_t)(input[18] & 0x7f) << 25) |
			((uint32_t)input[19] << 17) |
			((uint32_t)(input[20] & 0x80) << 9);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 161 to 176
	value = ((uint32_t)(input[20] & 0x7f) << 25) |
			((uint32_t)input[21] << 17) |
			((uint32_t)(input[22] & 0x80) << 9);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 177 to 192
	value = ((uint32_t)(input[22] & 0x7f) << 25) |
			((uint32_t)input[23] << 17) |
			((uint32_t)(input[24] & 0x80) << 9);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 193 to 208
	value = ((uint32_t)(input[24] & 0x7f) << 25) |
			((uint32_t)input[25] << 17) |
			((uint32_t)(input[26] & 0x80) << 9);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 209 to 224
	value = ((uint32_t)(input[26] & 0x7f) << 25) |
			((uint32_t)input[27] << 17) |
			((uint32_t)(input[28] & 0x80) << 9);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 225 to 240
	value = ((uint32_t)(input[28] & 0x7f) << 25) |
			((uint32_t)input[29] << 17) |
			((uint32_t)(input[30] & 0x80) << 9);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 241 to 256
	value = ((uint32_t)(input[30] & 0x7f) << 25) |
			((uint32_t)input[31] << 17) |
			((uint32_t)(input[32] & 0x80) << 9);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 257 to 272
	value = ((uint32_t)(input[32] & 0x7f) << 25) |
			((uint32_t)input[33] << 17) |
			((uint32_t)(input[34] & 0x80) << 9);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 273 to 288
	value = ((uint32_t)(input[34] & 0x7f) << 25) |
			((uint32_t)input[35] << 17) |
			((uint32_t)(input[36] & 0x80) << 9);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 289 to 304
	value = ((uint32_t)(input[36] & 0x7f) << 25) |
			((uint32_t)input[37] << 17) |
			((uint32_t)(input[38] & 0x80) << 9);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 305 to 320
	value = ((uint32_t)(input[38] & 0x7f) << 25) |
			((uint32_t)input[39] << 17) |
			((uint32_t)(input[40] & 0x80) << 9);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 321 to 336
	value = ((uint32_t)(input[40] & 0x7f) << 25) |
			((uint32_t)input[41] << 17) |
			((uint32_t)(input[42] & 0x80) << 9);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 337 to 352
	value = ((uint32_t)(input[42] & 0x7f) << 25) |
			((uint32_t)input[43] << 17) |
			((uint32_t)(input[44] & 0x80) << 9);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 353 to 368
	value = ((uint32_t)(input[44] & 0x7f) << 25) |
			((uint32_t)input[45] << 17) |
			((uint32_t)(input[46] & 0x80) << 9);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 369 to 384
	value = ((uint32_t)(input[46] & 0x7f) << 25) |
			((uint32_t)input[47] << 17) |
			((uint32_t)(input[48] & 0x80) << 9);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 385 to 400
	value = ((uint32_t)(input[48] & 0x7f) << 25) |
			((uint32_t)input[49] << 17) |
			((uint32_t)(input[50] & 0x80) << 9);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 401 to 416
	value = ((uint32_t)(input[50] & 0x7f) << 25) |
			((uint32_t)input[51] << 17) |
			((uint32_t)(input[52] & 0x80) << 9);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 417 to 432
	value = ((uint32_t)(input[52] & 0x7f) << 25) |
			((uint32_t)input[53] << 17) |
			((uint32_t)(input[54] & 0x80) << 9);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 433 to 448
	value = ((uint32_t)(input[54] & 0x7f) << 25) |
			((uint32_t)input[55] << 17) |
			((uint32_t)(input[56] & 0x80) << 9);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 449 to 464
	value = ((uint32_t)(input[56] & 0x7f) << 25) |
			((uint32_t)input[57] << 17) |
			((uint32_t)(input[58] & 0x80) << 9);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 465 to 480
	value = ((uint32_t)(input[58] & 0x7f) << 25) |
			((uint32_t)input[59] << 17) |
			((uint32_t)(input[60] & 0x80) << 9);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 481 to 496
	value = ((uint32_t)(input[60] & 0x7f) << 25) |
			((uint32_t)input[61] << 17) |
			((uint32_t)(input[62] & 0x80) << 9);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 497 to 512
	value = ((uint32_t)(input[62] & 0x7f) << 25) |
			((uint32_t)input[63] << 17) |
			((uint32_t)(input[64] & 0x80) << 9);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 513 to 528
	value = ((uint32_t)(input[64] & 0x7f) << 25) |
			((uint32_t)input[65] << 17) |
			((uint32_t)(input[66] & 0x80) << 9);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 529 to 544
	value = ((uint32_t)(input[66] & 0x7f) << 25) |
			((uint32_t)input[67] << 17) |
			((uint32_t)(input[68] & 0x80) << 9);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 545 to 560
	value = ((uint32_t)(input[68] & 0x7f) << 25) |
			((uint32_t)input[69] << 17) |
			((uint32_t)(input[70] & 0x80) << 9);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 561 to 576
	value = ((uint32_t)(input[70] & 0x7f) << 25) |
			((uint32_t)input[71] << 17) |
			((uint32_t)(input[72] & 0x80) << 9);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 577 to 592
	value = ((uint32_t)(input[72] & 0x7f) << 25) |
			((uint32_t)input[73] << 17) |
			((uint32_t)(input[74] & 0x80) << 9);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 593 to 608
	value = ((uint32_t)(input[74] & 0x7f) << 25) |
			((uint32_t)input[75] << 17) |
			((uint32_t)(input[76] & 0x80) << 9);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 609 to 624
	value = ((uint32_t)(input[76] & 0x7f) << 25) |
			((uint32_t)input[77] << 17) |
			((uint32_t)(input[78] & 0x80) << 9);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 625 to 640
	value = ((uint32_t)(input[78] & 0x7f) << 25) |
			((uint32_t)input[79] << 17) |
			((uint32_t)(input[80] & 0x80) << 9);
	output[39] = (double)(value >> 16);

	// read output[40]: from bit 641 to 656
	value = ((uint32_t)(input[80] & 0x7f) << 25) |
			((uint32_t)input[81] << 17) |
			((uint32_t)(input[82] & 0x80) << 9);
	output[40] = (double)(value >> 16);
}

static void unpack_41_16bit_signed_2off(const uint8_t * input, double * output, void *closure) {
	// Unpack 41 values into output
	// Values are 16-bit signed
	// Skip 2 bits, read 656 bits of data.
	// Input must be at least 83 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 2 to 17
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)input[1] << 18) |
			((uint32_t)(input[2] & 0xc0) << 10);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 18 to 33
	value = ((uint32_t)(input[2] & 0x3f) << 26) |
			((uint32_t)input[3] << 18) |
			((uint32_t)(input[4] & 0xc0) << 10);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 34 to 49
	value = ((uint32_t)(input[4] & 0x3f) << 26) |
			((uint32_t)input[5] << 18) |
			((uint32_t)(input[6] & 0xc0) << 10);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 50 to 65
	value = ((uint32_t)(input[6] & 0x3f) << 26) |
			((uint32_t)input[7] << 18) |
			((uint32_t)(input[8] & 0xc0) << 10);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 66 to 81
	value = ((uint32_t)(input[8] & 0x3f) << 26) |
			((uint32_t)input[9] << 18) |
			((uint32_t)(input[10] & 0xc0) << 10);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 82 to 97
	value = ((uint32_t)(input[10] & 0x3f) << 26) |
			((uint32_t)input[11] << 18) |
			((uint32_t)(input[12] & 0xc0) << 10);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 98 to 113
	value = ((uint32_t)(input[12] & 0x3f) << 26) |
			((uint32_t)input[13] << 18) |
			((uint32_t)(input[14] & 0xc0) << 10);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 114 to 129
	value = ((uint32_t)(input[14] & 0x3f) << 26) |
			((uint32_t)input[15] << 18) |
			((uint32_t)(input[16] & 0xc0) << 10);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 130 to 145
	value = ((uint32_t)(input[16] & 0x3f) << 26) |
			((uint32_t)input[17] << 18) |
			((uint32_t)(input[18] & 0xc0) << 10);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 146 to 161
	value = ((uint32_t)(input[18] & 0x3f) << 26) |
			((uint32_t)input[19] << 18) |
			((uint32_t)(input[20] & 0xc0) << 10);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 162 to 177
	value = ((uint32_t)(input[20] & 0x3f) << 26) |
			((uint32_t)input[21] << 18) |
			((uint32_t)(input[22] & 0xc0) << 10);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 178 to 193
	value = ((uint32_t)(input[22] & 0x3f) << 26) |
			((uint32_t)input[23] << 18) |
			((uint32_t)(input[24] & 0xc0) << 10);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 194 to 209
	value = ((uint32_t)(input[24] & 0x3f) << 26) |
			((uint32_t)input[25] << 18) |
			((uint32_t)(input[26] & 0xc0) << 10);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 210 to 225
	value = ((uint32_t)(input[26] & 0x3f) << 26) |
			((uint32_t)input[27] << 18) |
			((uint32_t)(input[28] & 0xc0) << 10);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 226 to 241
	value = ((uint32_t)(input[28] & 0x3f) << 26) |
			((uint32_t)input[29] << 18) |
			((uint32_t)(input[30] & 0xc0) << 10);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 242 to 257
	value = ((uint32_t)(input[30] & 0x3f) << 26) |
			((uint32_t)input[31] << 18) |
			((uint32_t)(input[32] & 0xc0) << 10);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 258 to 273
	value = ((uint32_t)(input[32] & 0x3f) << 26) |
			((uint32_t)input[33] << 18) |
			((uint32_t)(input[34] & 0xc0) << 10);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 274 to 289
	value = ((uint32_t)(input[34] & 0x3f) << 26) |
			((uint32_t)input[35] << 18) |
			((uint32_t)(input[36] & 0xc0) << 10);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 290 to 305
	value = ((uint32_t)(input[36] & 0x3f) << 26) |
			((uint32_t)input[37] << 18) |
			((uint32_t)(input[38] & 0xc0) << 10);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 306 to 321
	value = ((uint32_t)(input[38] & 0x3f) << 26) |
			((uint32_t)input[39] << 18) |
			((uint32_t)(input[40] & 0xc0) << 10);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 322 to 337
	value = ((uint32_t)(input[40] & 0x3f) << 26) |
			((uint32_t)input[41] << 18) |
			((uint32_t)(input[42] & 0xc0) << 10);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 338 to 353
	value = ((uint32_t)(input[42] & 0x3f) << 26) |
			((uint32_t)input[43] << 18) |
			((uint32_t)(input[44] & 0xc0) << 10);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 354 to 369
	value = ((uint32_t)(input[44] & 0x3f) << 26) |
			((uint32_t)input[45] << 18) |
			((uint32_t)(input[46] & 0xc0) << 10);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 370 to 385
	value = ((uint32_t)(input[46] & 0x3f) << 26) |
			((uint32_t)input[47] << 18) |
			((uint32_t)(input[48] & 0xc0) << 10);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 386 to 401
	value = ((uint32_t)(input[48] & 0x3f) << 26) |
			((uint32_t)input[49] << 18) |
			((uint32_t)(input[50] & 0xc0) << 10);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 402 to 417
	value = ((uint32_t)(input[50] & 0x3f) << 26) |
			((uint32_t)input[51] << 18) |
			((uint32_t)(input[52] & 0xc0) << 10);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 418 to 433
	value = ((uint32_t)(input[52] & 0x3f) << 26) |
			((uint32_t)input[53] << 18) |
			((uint32_t)(input[54] & 0xc0) << 10);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 434 to 449
	value = ((uint32_t)(input[54] & 0x3f) << 26) |
			((uint32_t)input[55] << 18) |
			((uint32_t)(input[56] & 0xc0) << 10);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 450 to 465
	value = ((uint32_t)(input[56] & 0x3f) << 26) |
			((uint32_t)input[57] << 18) |
			((uint32_t)(input[58] & 0xc0) << 10);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 466 to 481
	value = ((uint32_t)(input[58] & 0x3f) << 26) |
			((uint32_t)input[59] << 18) |
			((uint32_t)(input[60] & 0xc0) << 10);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 482 to 497
	value = ((uint32_t)(input[60] & 0x3f) << 26) |
			((uint32_t)input[61] << 18) |
			((uint32_t)(input[62] & 0xc0) << 10);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 498 to 513
	value = ((uint32_t)(input[62] & 0x3f) << 26) |
			((uint32_t)input[63] << 18) |
			((uint32_t)(input[64] & 0xc0) << 10);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 514 to 529
	value = ((uint32_t)(input[64] & 0x3f) << 26) |
			((uint32_t)input[65] << 18) |
			((uint32_t)(input[66] & 0xc0) << 10);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 530 to 545
	value = ((uint32_t)(input[66] & 0x3f) << 26) |
			((uint32_t)input[67] << 18) |
			((uint32_t)(input[68] & 0xc0) << 10);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 546 to 561
	value = ((uint32_t)(input[68] & 0x3f) << 26) |
			((uint32_t)input[69] << 18) |
			((uint32_t)(input[70] & 0xc0) << 10);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 562 to 577
	value = ((uint32_t)(input[70] & 0x3f) << 26) |
			((uint32_t)input[71] << 18) |
			((uint32_t)(input[72] & 0xc0) << 10);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 578 to 593
	value = ((uint32_t)(input[72] & 0x3f) << 26) |
			((uint32_t)input[73] << 18) |
			((uint32_t)(input[74] & 0xc0) << 10);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 594 to 609
	value = ((uint32_t)(input[74] & 0x3f) << 26) |
			((uint32_t)input[75] << 18) |
			((uint32_t)(input[76] & 0xc0) << 10);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 610 to 625
	value = ((uint32_t)(input[76] & 0x3f) << 26) |
			((uint32_t)input[77] << 18) |
			((uint32_t)(input[78] & 0xc0) << 10);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 626 to 641
	value = ((uint32_t)(input[78] & 0x3f) << 26) |
			((uint32_t)input[79] << 18) |
			((uint32_t)(input[80] & 0xc0) << 10);
	output[39] = (double)(value >> 16);

	// read output[40]: from bit 642 to 657
	value = ((uint32_t)(input[80] & 0x3f) << 26) |
			((uint32_t)input[81] << 18) |
			((uint32_t)(input[82] & 0xc0) << 10);
	output[40] = (double)(value >> 16);
}

static void unpack_41_16bit_unsigned_2off(const uint8_t * input, double * output, void *closure) {
	// Unpack 41 values into output
	// Values are 16-bit unsigned
	// Skip 2 bits, read 656 bits of data.
	// Input must be at least 83 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 2 to 17
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)input[1] << 18) |
			((uint32_t)(input[2] & 0xc0) << 10);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 18 to 33
	value = ((uint32_t)(input[2] & 0x3f) << 26) |
			((uint32_t)input[3] << 18) |
			((uint32_t)(input[4] & 0xc0) << 10);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 34 to 49
	value = ((uint32_t)(input[4] & 0x3f) << 26) |
			((uint32_t)input[5] << 18) |
			((uint32_t)(input[6] & 0xc0) << 10);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 50 to 65
	value = ((uint32_t)(input[6] & 0x3f) << 26) |
			((uint32_t)input[7] << 18) |
			((uint32_t)(input[8] & 0xc0) << 10);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 66 to 81
	value = ((uint32_t)(input[8] & 0x3f) << 26) |
			((uint32_t)input[9] << 18) |
			((uint32_t)(input[10] & 0xc0) << 10);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 82 to 97
	value = ((uint32_t)(input[10] & 0x3f) << 26) |
			((uint32_t)input[11] << 18) |
			((uint32_t)(input[12] & 0xc0) << 10);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 98 to 113
	value = ((uint32_t)(input[12] & 0x3f) << 26) |
			((uint32_t)input[13] << 18) |
			((uint32_t)(input[14] & 0xc0) << 10);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 114 to 129
	value = ((uint32_t)(input[14] & 0x3f) << 26) |
			((uint32_t)input[15] << 18) |
			((uint32_t)(input[16] & 0xc0) << 10);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 130 to 145
	value = ((uint32_t)(input[16] & 0x3f) << 26) |
			((uint32_t)input[17] << 18) |
			((uint32_t)(input[18] & 0xc0) << 10);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 146 to 161
	value = ((uint32_t)(input[18] & 0x3f) << 26) |
			((uint32_t)input[19] << 18) |
			((uint32_t)(input[20] & 0xc0) << 10);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 162 to 177
	value = ((uint32_t)(input[20] & 0x3f) << 26) |
			((uint32_t)input[21] << 18) |
			((uint32_t)(input[22] & 0xc0) << 10);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 178 to 193
	value = ((uint32_t)(input[22] & 0x3f) << 26) |
			((uint32_t)input[23] << 18) |
			((uint32_t)(input[24] & 0xc0) << 10);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 194 to 209
	value = ((uint32_t)(input[24] & 0x3f) << 26) |
			((uint32_t)input[25] << 18) |
			((uint32_t)(input[26] & 0xc0) << 10);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 210 to 225
	value = ((uint32_t)(input[26] & 0x3f) << 26) |
			((uint32_t)input[27] << 18) |
			((uint32_t)(input[28] & 0xc0) << 10);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 226 to 241
	value = ((uint32_t)(input[28] & 0x3f) << 26) |
			((uint32_t)input[29] << 18) |
			((uint32_t)(input[30] & 0xc0) << 10);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 242 to 257
	value = ((uint32_t)(input[30] & 0x3f) << 26) |
			((uint32_t)input[31] << 18) |
			((uint32_t)(input[32] & 0xc0) << 10);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 258 to 273
	value = ((uint32_t)(input[32] & 0x3f) << 26) |
			((uint32_t)input[33] << 18) |
			((uint32_t)(input[34] & 0xc0) << 10);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 274 to 289
	value = ((uint32_t)(input[34] & 0x3f) << 26) |
			((uint32_t)input[35] << 18) |
			((uint32_t)(input[36] & 0xc0) << 10);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 290 to 305
	value = ((uint32_t)(input[36] & 0x3f) << 26) |
			((uint32_t)input[37] << 18) |
			((uint32_t)(input[38] & 0xc0) << 10);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 306 to 321
	value = ((uint32_t)(input[38] & 0x3f) << 26) |
			((uint32_t)input[39] << 18) |
			((uint32_t)(input[40] & 0xc0) << 10);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 322 to 337
	value = ((uint32_t)(input[40] & 0x3f) << 26) |
			((uint32_t)input[41] << 18) |
			((uint32_t)(input[42] & 0xc0) << 10);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 338 to 353
	value = ((uint32_t)(input[42] & 0x3f) << 26) |
			((uint32_t)input[43] << 18) |
			((uint32_t)(input[44] & 0xc0) << 10);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 354 to 369
	value = ((uint32_t)(input[44] & 0x3f) << 26) |
			((uint32_t)input[45] << 18) |
			((uint32_t)(input[46] & 0xc0) << 10);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 370 to 385
	value = ((uint32_t)(input[46] & 0x3f) << 26) |
			((uint32_t)input[47] << 18) |
			((uint32_t)(input[48] & 0xc0) << 10);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 386 to 401
	value = ((uint32_t)(input[48] & 0x3f) << 26) |
			((uint32_t)input[49] << 18) |
			((uint32_t)(input[50] & 0xc0) << 10);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 402 to 417
	value = ((uint32_t)(input[50] & 0x3f) << 26) |
			((uint32_t)input[51] << 18) |
			((uint32_t)(input[52] & 0xc0) << 10);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 418 to 433
	value = ((uint32_t)(input[52] & 0x3f) << 26) |
			((uint32_t)input[53] << 18) |
			((uint32_t)(input[54] & 0xc0) << 10);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 434 to 449
	value = ((uint32_t)(input[54] & 0x3f) << 26) |
			((uint32_t)input[55] << 18) |
			((uint32_t)(input[56] & 0xc0) << 10);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 450 to 465
	value = ((uint32_t)(input[56] & 0x3f) << 26) |
			((uint32_t)input[57] << 18) |
			((uint32_t)(input[58] & 0xc0) << 10);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 466 to 481
	value = ((uint32_t)(input[58] & 0x3f) << 26) |
			((uint32_t)input[59] << 18) |
			((uint32_t)(input[60] & 0xc0) << 10);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 482 to 497
	value = ((uint32_t)(input[60] & 0x3f) << 26) |
			((uint32_t)input[61] << 18) |
			((uint32_t)(input[62] & 0xc0) << 10);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 498 to 513
	value = ((uint32_t)(input[62] & 0x3f) << 26) |
			((uint32_t)input[63] << 18) |
			((uint32_t)(input[64] & 0xc0) << 10);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 514 to 529
	value = ((uint32_t)(input[64] & 0x3f) << 26) |
			((uint32_t)input[65] << 18) |
			((uint32_t)(input[66] & 0xc0) << 10);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 530 to 545
	value = ((uint32_t)(input[66] & 0x3f) << 26) |
			((uint32_t)input[67] << 18) |
			((uint32_t)(input[68] & 0xc0) << 10);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 546 to 561
	value = ((uint32_t)(input[68] & 0x3f) << 26) |
			((uint32_t)input[69] << 18) |
			((uint32_t)(input[70] & 0xc0) << 10);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 562 to 577
	value = ((uint32_t)(input[70] & 0x3f) << 26) |
			((uint32_t)input[71] << 18) |
			((uint32_t)(input[72] & 0xc0) << 10);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 578 to 593
	value = ((uint32_t)(input[72] & 0x3f) << 26) |
			((uint32_t)input[73] << 18) |
			((uint32_t)(input[74] & 0xc0) << 10);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 594 to 609
	value = ((uint32_t)(input[74] & 0x3f) << 26) |
			((uint32_t)input[75] << 18) |
			((uint32_t)(input[76] & 0xc0) << 10);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 610 to 625
	value = ((uint32_t)(input[76] & 0x3f) << 26) |
			((uint32_t)input[77] << 18) |
			((uint32_t)(input[78] & 0xc0) << 10);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 626 to 641
	value = ((uint32_t)(input[78] & 0x3f) << 26) |
			((uint32_t)input[79] << 18) |
			((uint32_t)(input[80] & 0xc0) << 10);
	output[39] = (double)(value >> 16);

	// read output[40]: from bit 642 to 657
	value = ((uint32_t)(input[80] & 0x3f) << 26) |
			((uint32_t)input[81] << 18) |
			((uint32_t)(input[82] & 0xc0) << 10);
	output[40] = (double)(value >> 16);
}

static void unpack_41_16bit_signed_3off(const uint8_t * input, double * output, void *closure) {
	// Unpack 41 values into output
	// Values are 16-bit signed
	// Skip 3 bits, read 656 bits of data.
	// Input must be at least 83 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 3 to 18
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)input[1] << 19) |
			((uint32_t)(input[2] & 0xe0) << 11);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 19 to 34
	value = ((uint32_t)(input[2] & 0x1f) << 27) |
			((uint32_t)input[3] << 19) |
			((uint32_t)(input[4] & 0xe0) << 11);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 35 to 50
	value = ((uint32_t)(input[4] & 0x1f) << 27) |
			((uint32_t)input[5] << 19) |
			((uint32_t)(input[6] & 0xe0) << 11);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 51 to 66
	value = ((uint32_t)(input[6] & 0x1f) << 27) |
			((uint32_t)input[7] << 19) |
			((uint32_t)(input[8] & 0xe0) << 11);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 67 to 82
	value = ((uint32_t)(input[8] & 0x1f) << 27) |
			((uint32_t)input[9] << 19) |
			((uint32_t)(input[10] & 0xe0) << 11);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 83 to 98
	value = ((uint32_t)(input[10] & 0x1f) << 27) |
			((uint32_t)input[11] << 19) |
			((uint32_t)(input[12] & 0xe0) << 11);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 99 to 114
	value = ((uint32_t)(input[12] & 0x1f) << 27) |
			((uint32_t)input[13] << 19) |
			((uint32_t)(input[14] & 0xe0) << 11);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 115 to 130
	value = ((uint32_t)(input[14] & 0x1f) << 27) |
			((uint32_t)input[15] << 19) |
			((uint32_t)(input[16] & 0xe0) << 11);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 131 to 146
	value = ((uint32_t)(input[16] & 0x1f) << 27) |
			((uint32_t)input[17] << 19) |
			((uint32_t)(input[18] & 0xe0) << 11);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 147 to 162
	value = ((uint32_t)(input[18] & 0x1f) << 27) |
			((uint32_t)input[19] << 19) |
			((uint32_t)(input[20] & 0xe0) << 11);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 163 to 178
	value = ((uint32_t)(input[20] & 0x1f) << 27) |
			((uint32_t)input[21] << 19) |
			((uint32_t)(input[22] & 0xe0) << 11);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 179 to 194
	value = ((uint32_t)(input[22] & 0x1f) << 27) |
			((uint32_t)input[23] << 19) |
			((uint32_t)(input[24] & 0xe0) << 11);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 195 to 210
	value = ((uint32_t)(input[24] & 0x1f) << 27) |
			((uint32_t)input[25] << 19) |
			((uint32_t)(input[26] & 0xe0) << 11);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 211 to 226
	value = ((uint32_t)(input[26] & 0x1f) << 27) |
			((uint32_t)input[27] << 19) |
			((uint32_t)(input[28] & 0xe0) << 11);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 227 to 242
	value = ((uint32_t)(input[28] & 0x1f) << 27) |
			((uint32_t)input[29] << 19) |
			((uint32_t)(input[30] & 0xe0) << 11);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 243 to 258
	value = ((uint32_t)(input[30] & 0x1f) << 27) |
			((uint32_t)input[31] << 19) |
			((uint32_t)(input[32] & 0xe0) << 11);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 259 to 274
	value = ((uint32_t)(input[32] & 0x1f) << 27) |
			((uint32_t)input[33] << 19) |
			((uint32_t)(input[34] & 0xe0) << 11);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 275 to 290
	value = ((uint32_t)(input[34] & 0x1f) << 27) |
			((uint32_t)input[35] << 19) |
			((uint32_t)(input[36] & 0xe0) << 11);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 291 to 306
	value = ((uint32_t)(input[36] & 0x1f) << 27) |
			((uint32_t)input[37] << 19) |
			((uint32_t)(input[38] & 0xe0) << 11);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 307 to 322
	value = ((uint32_t)(input[38] & 0x1f) << 27) |
			((uint32_t)input[39] << 19) |
			((uint32_t)(input[40] & 0xe0) << 11);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 323 to 338
	value = ((uint32_t)(input[40] & 0x1f) << 27) |
			((uint32_t)input[41] << 19) |
			((uint32_t)(input[42] & 0xe0) << 11);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 339 to 354
	value = ((uint32_t)(input[42] & 0x1f) << 27) |
			((uint32_t)input[43] << 19) |
			((uint32_t)(input[44] & 0xe0) << 11);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 355 to 370
	value = ((uint32_t)(input[44] & 0x1f) << 27) |
			((uint32_t)input[45] << 19) |
			((uint32_t)(input[46] & 0xe0) << 11);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 371 to 386
	value = ((uint32_t)(input[46] & 0x1f) << 27) |
			((uint32_t)input[47] << 19) |
			((uint32_t)(input[48] & 0xe0) << 11);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 387 to 402
	value = ((uint32_t)(input[48] & 0x1f) << 27) |
			((uint32_t)input[49] << 19) |
			((uint32_t)(input[50] & 0xe0) << 11);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 403 to 418
	value = ((uint32_t)(input[50] & 0x1f) << 27) |
			((uint32_t)input[51] << 19) |
			((uint32_t)(input[52] & 0xe0) << 11);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 419 to 434
	value = ((uint32_t)(input[52] & 0x1f) << 27) |
			((uint32_t)input[53] << 19) |
			((uint32_t)(input[54] & 0xe0) << 11);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 435 to 450
	value = ((uint32_t)(input[54] & 0x1f) << 27) |
			((uint32_t)input[55] << 19) |
			((uint32_t)(input[56] & 0xe0) << 11);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 451 to 466
	value = ((uint32_t)(input[56] & 0x1f) << 27) |
			((uint32_t)input[57] << 19) |
			((uint32_t)(input[58] & 0xe0) << 11);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 467 to 482
	value = ((uint32_t)(input[58] & 0x1f) << 27) |
			((uint32_t)input[59] << 19) |
			((uint32_t)(input[60] & 0xe0) << 11);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 483 to 498
	value = ((uint32_t)(input[60] & 0x1f) << 27) |
			((uint32_t)input[61] << 19) |
			((uint32_t)(input[62] & 0xe0) << 11);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 499 to 514
	value = ((uint32_t)(input[62] & 0x1f) << 27) |
			((uint32_t)input[63] << 19) |
			((uint32_t)(input[64] & 0xe0) << 11);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 515 to 530
	value = ((uint32_t)(input[64] & 0x1f) << 27) |
			((uint32_t)input[65] << 19) |
			((uint32_t)(input[66] & 0xe0) << 11);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 531 to 546
	value = ((uint32_t)(input[66] & 0x1f) << 27) |
			((uint32_t)input[67] << 19) |
			((uint32_t)(input[68] & 0xe0) << 11);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 547 to 562
	value = ((uint32_t)(input[68] & 0x1f) << 27) |
			((uint32_t)input[69] << 19) |
			((uint32_t)(input[70] & 0xe0) << 11);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 563 to 578
	value = ((uint32_t)(input[70] & 0x1f) << 27) |
			((uint32_t)input[71] << 19) |
			((uint32_t)(input[72] & 0xe0) << 11);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 579 to 594
	value = ((uint32_t)(input[72] & 0x1f) << 27) |
			((uint32_t)input[73] << 19) |
			((uint32_t)(input[74] & 0xe0) << 11);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 595 to 610
	value = ((uint32_t)(input[74] & 0x1f) << 27) |
			((uint32_t)input[75] << 19) |
			((uint32_t)(input[76] & 0xe0) << 11);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 611 to 626
	value = ((uint32_t)(input[76] & 0x1f) << 27) |
			((uint32_t)input[77] << 19) |
			((uint32_t)(input[78] & 0xe0) << 11);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 627 to 642
	value = ((uint32_t)(input[78] & 0x1f) << 27) |
			((uint32_t)input[79] << 19) |
			((uint32_t)(input[80] & 0xe0) << 11);
	output[39] = (double)(value >> 16);

	// read output[40]: from bit 643 to 658
	value = ((uint32_t)(input[80] & 0x1f) << 27) |
			((uint32_t)input[81] << 19) |
			((uint32_t)(input[82] & 0xe0) << 11);
	output[40] = (double)(value >> 16);
}

static void unpack_41_16bit_unsigned_3off(const uint8_t * input, double * output, void *closure) {
	// Unpack 41 values into output
	// Values are 16-bit unsigned
	// Skip 3 bits, read 656 bits of data.
	// Input must be at least 83 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 3 to 18
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)input[1] << 19) |
			((uint32_t)(input[2] & 0xe0) << 11);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 19 to 34
	value = ((uint32_t)(input[2] & 0x1f) << 27) |
			((uint32_t)input[3] << 19) |
			((uint32_t)(input[4] & 0xe0) << 11);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 35 to 50
	value = ((uint32_t)(input[4] & 0x1f) << 27) |
			((uint32_t)input[5] << 19) |
			((uint32_t)(input[6] & 0xe0) << 11);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 51 to 66
	value = ((uint32_t)(input[6] & 0x1f) << 27) |
			((uint32_t)input[7] << 19) |
			((uint32_t)(input[8] & 0xe0) << 11);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 67 to 82
	value = ((uint32_t)(input[8] & 0x1f) << 27) |
			((uint32_t)input[9] << 19) |
			((uint32_t)(input[10] & 0xe0) << 11);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 83 to 98
	value = ((uint32_t)(input[10] & 0x1f) << 27) |
			((uint32_t)input[11] << 19) |
			((uint32_t)(input[12] & 0xe0) << 11);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 99 to 114
	value = ((uint32_t)(input[12] & 0x1f) << 27) |
			((uint32_t)input[13] << 19) |
			((uint32_t)(input[14] & 0xe0) << 11);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 115 to 130
	value = ((uint32_t)(input[14] & 0x1f) << 27) |
			((uint32_t)input[15] << 19) |
			((uint32_t)(input[16] & 0xe0) << 11);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 131 to 146
	value = ((uint32_t)(input[16] & 0x1f) << 27) |
			((uint32_t)input[17] << 19) |
			((uint32_t)(input[18] & 0xe0) << 11);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 147 to 162
	value = ((uint32_t)(input[18] & 0x1f) << 27) |
			((uint32_t)input[19] << 19) |
			((uint32_t)(input[20] & 0xe0) << 11);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 163 to 178
	value = ((uint32_t)(input[20] & 0x1f) << 27) |
			((uint32_t)input[21] << 19) |
			((uint32_t)(input[22] & 0xe0) << 11);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 179 to 194
	value = ((uint32_t)(input[22] & 0x1f) << 27) |
			((uint32_t)input[23] << 19) |
			((uint32_t)(input[24] & 0xe0) << 11);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 195 to 210
	value = ((uint32_t)(input[24] & 0x1f) << 27) |
			((uint32_t)input[25] << 19) |
			((uint32_t)(input[26] & 0xe0) << 11);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 211 to 226
	value = ((uint32_t)(input[26] & 0x1f) << 27) |
			((uint32_t)input[27] << 19) |
			((uint32_t)(input[28] & 0xe0) << 11);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 227 to 242
	value = ((uint32_t)(input[28] & 0x1f) << 27) |
			((uint32_t)input[29] << 19) |
			((uint32_t)(input[30] & 0xe0) << 11);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 243 to 258
	value = ((uint32_t)(input[30] & 0x1f) << 27) |
			((uint32_t)input[31] << 19) |
			((uint32_t)(input[32] & 0xe0) << 11);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 259 to 274
	value = ((uint32_t)(input[32] & 0x1f) << 27) |
			((uint32_t)input[33] << 19) |
			((uint32_t)(input[34] & 0xe0) << 11);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 275 to 290
	value = ((uint32_t)(input[34] & 0x1f) << 27) |
			((uint32_t)input[35] << 19) |
			((uint32_t)(input[36] & 0xe0) << 11);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 291 to 306
	value = ((uint32_t)(input[36] & 0x1f) << 27) |
			((uint32_t)input[37] << 19) |
			((uint32_t)(input[38] & 0xe0) << 11);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 307 to 322
	value = ((uint32_t)(input[38] & 0x1f) << 27) |
			((uint32_t)input[39] << 19) |
			((uint32_t)(input[40] & 0xe0) << 11);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 323 to 338
	value = ((uint32_t)(input[40] & 0x1f) << 27) |
			((uint32_t)input[41] << 19) |
			((uint32_t)(input[42] & 0xe0) << 11);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 339 to 354
	value = ((uint32_t)(input[42] & 0x1f) << 27) |
			((uint32_t)input[43] << 19) |
			((uint32_t)(input[44] & 0xe0) << 11);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 355 to 370
	value = ((uint32_t)(input[44] & 0x1f) << 27) |
			((uint32_t)input[45] << 19) |
			((uint32_t)(input[46] & 0xe0) << 11);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 371 to 386
	value = ((uint32_t)(input[46] & 0x1f) << 27) |
			((uint32_t)input[47] << 19) |
			((uint32_t)(input[48] & 0xe0) << 11);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 387 to 402
	value = ((uint32_t)(input[48] & 0x1f) << 27) |
			((uint32_t)input[49] << 19) |
			((uint32_t)(input[50] & 0xe0) << 11);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 403 to 418
	value = ((uint32_t)(input[50] & 0x1f) << 27) |
			((uint32_t)input[51] << 19) |
			((uint32_t)(input[52] & 0xe0) << 11);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 419 to 434
	value = ((uint32_t)(input[52] & 0x1f) << 27) |
			((uint32_t)input[53] << 19) |
			((uint32_t)(input[54] & 0xe0) << 11);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 435 to 450
	value = ((uint32_t)(input[54] & 0x1f) << 27) |
			((uint32_t)input[55] << 19) |
			((uint32_t)(input[56] & 0xe0) << 11);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 451 to 466
	value = ((uint32_t)(input[56] & 0x1f) << 27) |
			((uint32_t)input[57] << 19) |
			((uint32_t)(input[58] & 0xe0) << 11);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 467 to 482
	value = ((uint32_t)(input[58] & 0x1f) << 27) |
			((uint32_t)input[59] << 19) |
			((uint32_t)(input[60] & 0xe0) << 11);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 483 to 498
	value = ((uint32_t)(input[60] & 0x1f) << 27) |
			((uint32_t)input[61] << 19) |
			((uint32_t)(input[62] & 0xe0) << 11);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 499 to 514
	value = ((uint32_t)(input[62] & 0x1f) << 27) |
			((uint32_t)input[63] << 19) |
			((uint32_t)(input[64] & 0xe0) << 11);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 515 to 530
	value = ((uint32_t)(input[64] & 0x1f) << 27) |
			((uint32_t)input[65] << 19) |
			((uint32_t)(input[66] & 0xe0) << 11);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 531 to 546
	value = ((uint32_t)(input[66] & 0x1f) << 27) |
			((uint32_t)input[67] << 19) |
			((uint32_t)(input[68] & 0xe0) << 11);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 547 to 562
	value = ((uint32_t)(input[68] & 0x1f) << 27) |
			((uint32_t)input[69] << 19) |
			((uint32_t)(input[70] & 0xe0) << 11);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 563 to 578
	value = ((uint32_t)(input[70] & 0x1f) << 27) |
			((uint32_t)input[71] << 19) |
			((uint32_t)(input[72] & 0xe0) << 11);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 579 to 594
	value = ((uint32_t)(input[72] & 0x1f) << 27) |
			((uint32_t)input[73] << 19) |
			((uint32_t)(input[74] & 0xe0) << 11);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 595 to 610
	value = ((uint32_t)(input[74] & 0x1f) << 27) |
			((uint32_t)input[75] << 19) |
			((uint32_t)(input[76] & 0xe0) << 11);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 611 to 626
	value = ((uint32_t)(input[76] & 0x1f) << 27) |
			((uint32_t)input[77] << 19) |
			((uint32_t)(input[78] & 0xe0) << 11);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 627 to 642
	value = ((uint32_t)(input[78] & 0x1f) << 27) |
			((uint32_t)input[79] << 19) |
			((uint32_t)(input[80] & 0xe0) << 11);
	output[39] = (double)(value >> 16);

	// read output[40]: from bit 643 to 658
	value = ((uint32_t)(input[80] & 0x1f) << 27) |
			((uint32_t)input[81] << 19) |
			((uint32_t)(input[82] & 0xe0) << 11);
	output[40] = (double)(value >> 16);
}

static void unpack_41_16bit_signed_4off(const uint8_t * input, double * output, void *closure) {
	// Unpack 41 values into output
	// Values are 16-bit signed
	// Skip 4 bits, read 656 bits of data.
	// Input must be at least 83 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 4 to 19
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20) |
			((uint32_t)(input[2] & 0xf0) << 12);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 20 to 35
	value = ((uint32_t)(input[2] & 0x0f) << 28) |
			((uint32_t)input[3] << 20) |
			((uint32_t)(input[4] & 0xf0) << 12);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 36 to 51
	value = ((uint32_t)(input[4] & 0x0f) << 28) |
			((uint32_t)input[5] << 20) |
			((uint32_t)(input[6] & 0xf0) << 12);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 52 to 67
	value = ((uint32_t)(input[6] & 0x0f) << 28) |
			((uint32_t)input[7] << 20) |
			((uint32_t)(input[8] & 0xf0) << 12);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 68 to 83
	value = ((uint32_t)(input[8] & 0x0f) << 28) |
			((uint32_t)input[9] << 20) |
			((uint32_t)(input[10] & 0xf0) << 12);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 84 to 99
	value = ((uint32_t)(input[10] & 0x0f) << 28) |
			((uint32_t)input[11] << 20) |
			((uint32_t)(input[12] & 0xf0) << 12);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 100 to 115
	value = ((uint32_t)(input[12] & 0x0f) << 28) |
			((uint32_t)input[13] << 20) |
			((uint32_t)(input[14] & 0xf0) << 12);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 116 to 131
	value = ((uint32_t)(input[14] & 0x0f) << 28) |
			((uint32_t)input[15] << 20) |
			((uint32_t)(input[16] & 0xf0) << 12);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 132 to 147
	value = ((uint32_t)(input[16] & 0x0f) << 28) |
			((uint32_t)input[17] << 20) |
			((uint32_t)(input[18] & 0xf0) << 12);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 148 to 163
	value = ((uint32_t)(input[18] & 0x0f) << 28) |
			((uint32_t)input[19] << 20) |
			((uint32_t)(input[20] & 0xf0) << 12);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 164 to 179
	value = ((uint32_t)(input[20] & 0x0f) << 28) |
			((uint32_t)input[21] << 20) |
			((uint32_t)(input[22] & 0xf0) << 12);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 180 to 195
	value = ((uint32_t)(input[22] & 0x0f) << 28) |
			((uint32_t)input[23] << 20) |
			((uint32_t)(input[24] & 0xf0) << 12);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 196 to 211
	value = ((uint32_t)(input[24] & 0x0f) << 28) |
			((uint32_t)input[25] << 20) |
			((uint32_t)(input[26] & 0xf0) << 12);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 212 to 227
	value = ((uint32_t)(input[26] & 0x0f) << 28) |
			((uint32_t)input[27] << 20) |
			((uint32_t)(input[28] & 0xf0) << 12);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 228 to 243
	value = ((uint32_t)(input[28] & 0x0f) << 28) |
			((uint32_t)input[29] << 20) |
			((uint32_t)(input[30] & 0xf0) << 12);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 244 to 259
	value = ((uint32_t)(input[30] & 0x0f) << 28) |
			((uint32_t)input[31] << 20) |
			((uint32_t)(input[32] & 0xf0) << 12);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 260 to 275
	value = ((uint32_t)(input[32] & 0x0f) << 28) |
			((uint32_t)input[33] << 20) |
			((uint32_t)(input[34] & 0xf0) << 12);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 276 to 291
	value = ((uint32_t)(input[34] & 0x0f) << 28) |
			((uint32_t)input[35] << 20) |
			((uint32_t)(input[36] & 0xf0) << 12);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 292 to 307
	value = ((uint32_t)(input[36] & 0x0f) << 28) |
			((uint32_t)input[37] << 20) |
			((uint32_t)(input[38] & 0xf0) << 12);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 308 to 323
	value = ((uint32_t)(input[38] & 0x0f) << 28) |
			((uint32_t)input[39] << 20) |
			((uint32_t)(input[40] & 0xf0) << 12);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 324 to 339
	value = ((uint32_t)(input[40] & 0x0f) << 28) |
			((uint32_t)input[41] << 20) |
			((uint32_t)(input[42] & 0xf0) << 12);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 340 to 355
	value = ((uint32_t)(input[42] & 0x0f) << 28) |
			((uint32_t)input[43] << 20) |
			((uint32_t)(input[44] & 0xf0) << 12);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 356 to 371
	value = ((uint32_t)(input[44] & 0x0f) << 28) |
			((uint32_t)input[45] << 20) |
			((uint32_t)(input[46] & 0xf0) << 12);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 372 to 387
	value = ((uint32_t)(input[46] & 0x0f) << 28) |
			((uint32_t)input[47] << 20) |
			((uint32_t)(input[48] & 0xf0) << 12);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 388 to 403
	value = ((uint32_t)(input[48] & 0x0f) << 28) |
			((uint32_t)input[49] << 20) |
			((uint32_t)(input[50] & 0xf0) << 12);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 404 to 419
	value = ((uint32_t)(input[50] & 0x0f) << 28) |
			((uint32_t)input[51] << 20) |
			((uint32_t)(input[52] & 0xf0) << 12);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 420 to 435
	value = ((uint32_t)(input[52] & 0x0f) << 28) |
			((uint32_t)input[53] << 20) |
			((uint32_t)(input[54] & 0xf0) << 12);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 436 to 451
	value = ((uint32_t)(input[54] & 0x0f) << 28) |
			((uint32_t)input[55] << 20) |
			((uint32_t)(input[56] & 0xf0) << 12);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 452 to 467
	value = ((uint32_t)(input[56] & 0x0f) << 28) |
			((uint32_t)input[57] << 20) |
			((uint32_t)(input[58] & 0xf0) << 12);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 468 to 483
	value = ((uint32_t)(input[58] & 0x0f) << 28) |
			((uint32_t)input[59] << 20) |
			((uint32_t)(input[60] & 0xf0) << 12);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 484 to 499
	value = ((uint32_t)(input[60] & 0x0f) << 28) |
			((uint32_t)input[61] << 20) |
			((uint32_t)(input[62] & 0xf0) << 12);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 500 to 515
	value = ((uint32_t)(input[62] & 0x0f) << 28) |
			((uint32_t)input[63] << 20) |
			((uint32_t)(input[64] & 0xf0) << 12);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 516 to 531
	value = ((uint32_t)(input[64] & 0x0f) << 28) |
			((uint32_t)input[65] << 20) |
			((uint32_t)(input[66] & 0xf0) << 12);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 532 to 547
	value = ((uint32_t)(input[66] & 0x0f) << 28) |
			((uint32_t)input[67] << 20) |
			((uint32_t)(input[68] & 0xf0) << 12);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 548 to 563
	value = ((uint32_t)(input[68] & 0x0f) << 28) |
			((uint32_t)input[69] << 20) |
			((uint32_t)(input[70] & 0xf0) << 12);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 564 to 579
	value = ((uint32_t)(input[70] & 0x0f) << 28) |
			((uint32_t)input[71] << 20) |
			((uint32_t)(input[72] & 0xf0) << 12);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 580 to 595
	value = ((uint32_t)(input[72] & 0x0f) << 28) |
			((uint32_t)input[73] << 20) |
			((uint32_t)(input[74] & 0xf0) << 12);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 596 to 611
	value = ((uint32_t)(input[74] & 0x0f) << 28) |
			((uint32_t)input[75] << 20) |
			((uint32_t)(input[76] & 0xf0) << 12);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 612 to 627
	value = ((uint32_t)(input[76] & 0x0f) << 28) |
			((uint32_t)input[77] << 20) |
			((uint32_t)(input[78] & 0xf0) << 12);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 628 to 643
	value = ((uint32_t)(input[78] & 0x0f) << 28) |
			((uint32_t)input[79] << 20) |
			((uint32_t)(input[80] & 0xf0) << 12);
	output[39] = (double)(value >> 16);

	// read output[40]: from bit 644 to 659
	value = ((uint32_t)(input[80] & 0x0f) << 28) |
			((uint32_t)input[81] << 20) |
			((uint32_t)(input[82] & 0xf0) << 12);
	output[40] = (double)(value >> 16);
}

static void unpack_41_16bit_unsigned_4off(const uint8_t * input, double * output, void *closure) {
	// Unpack 41 values into output
	// Values are 16-bit unsigned
	// Skip 4 bits, read 656 bits of data.
	// Input must be at least 83 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 4 to 19
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20) |
			((uint32_t)(input[2] & 0xf0) << 12);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 20 to 35
	value = ((uint32_t)(input[2] & 0x0f) << 28) |
			((uint32_t)input[3] << 20) |
			((uint32_t)(input[4] & 0xf0) << 12);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 36 to 51
	value = ((uint32_t)(input[4] & 0x0f) << 28) |
			((uint32_t)input[5] << 20) |
			((uint32_t)(input[6] & 0xf0) << 12);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 52 to 67
	value = ((uint32_t)(input[6] & 0x0f) << 28) |
			((uint32_t)input[7] << 20) |
			((uint32_t)(input[8] & 0xf0) << 12);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 68 to 83
	value = ((uint32_t)(input[8] & 0x0f) << 28) |
			((uint32_t)input[9] << 20) |
			((uint32_t)(input[10] & 0xf0) << 12);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 84 to 99
	value = ((uint32_t)(input[10] & 0x0f) << 28) |
			((uint32_t)input[11] << 20) |
			((uint32_t)(input[12] & 0xf0) << 12);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 100 to 115
	value = ((uint32_t)(input[12] & 0x0f) << 28) |
			((uint32_t)input[13] << 20) |
			((uint32_t)(input[14] & 0xf0) << 12);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 116 to 131
	value = ((uint32_t)(input[14] & 0x0f) << 28) |
			((uint32_t)input[15] << 20) |
			((uint32_t)(input[16] & 0xf0) << 12);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 132 to 147
	value = ((uint32_t)(input[16] & 0x0f) << 28) |
			((uint32_t)input[17] << 20) |
			((uint32_t)(input[18] & 0xf0) << 12);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 148 to 163
	value = ((uint32_t)(input[18] & 0x0f) << 28) |
			((uint32_t)input[19] << 20) |
			((uint32_t)(input[20] & 0xf0) << 12);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 164 to 179
	value = ((uint32_t)(input[20] & 0x0f) << 28) |
			((uint32_t)input[21] << 20) |
			((uint32_t)(input[22] & 0xf0) << 12);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 180 to 195
	value = ((uint32_t)(input[22] & 0x0f) << 28) |
			((uint32_t)input[23] << 20) |
			((uint32_t)(input[24] & 0xf0) << 12);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 196 to 211
	value = ((uint32_t)(input[24] & 0x0f) << 28) |
			((uint32_t)input[25] << 20) |
			((uint32_t)(input[26] & 0xf0) << 12);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 212 to 227
	value = ((uint32_t)(input[26] & 0x0f) << 28) |
			((uint32_t)input[27] << 20) |
			((uint32_t)(input[28] & 0xf0) << 12);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 228 to 243
	value = ((uint32_t)(input[28] & 0x0f) << 28) |
			((uint32_t)input[29] << 20) |
			((uint32_t)(input[30] & 0xf0) << 12);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 244 to 259
	value = ((uint32_t)(input[30] & 0x0f) << 28) |
			((uint32_t)input[31] << 20) |
			((uint32_t)(input[32] & 0xf0) << 12);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 260 to 275
	value = ((uint32_t)(input[32] & 0x0f) << 28) |
			((uint32_t)input[33] << 20) |
			((uint32_t)(input[34] & 0xf0) << 12);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 276 to 291
	value = ((uint32_t)(input[34] & 0x0f) << 28) |
			((uint32_t)input[35] << 20) |
			((uint32_t)(input[36] & 0xf0) << 12);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 292 to 307
	value = ((uint32_t)(input[36] & 0x0f) << 28) |
			((uint32_t)input[37] << 20) |
			((uint32_t)(input[38] & 0xf0) << 12);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 308 to 323
	value = ((uint32_t)(input[38] & 0x0f) << 28) |
			((uint32_t)input[39] << 20) |
			((uint32_t)(input[40] & 0xf0) << 12);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 324 to 339
	value = ((uint32_t)(input[40] & 0x0f) << 28) |
			((uint32_t)input[41] << 20) |
			((uint32_t)(input[42] & 0xf0) << 12);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 340 to 355
	value = ((uint32_t)(input[42] & 0x0f) << 28) |
			((uint32_t)input[43] << 20) |
			((uint32_t)(input[44] & 0xf0) << 12);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 356 to 371
	value = ((uint32_t)(input[44] & 0x0f) << 28) |
			((uint32_t)input[45] << 20) |
			((uint32_t)(input[46] & 0xf0) << 12);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 372 to 387
	value = ((uint32_t)(input[46] & 0x0f) << 28) |
			((uint32_t)input[47] << 20) |
			((uint32_t)(input[48] & 0xf0) << 12);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 388 to 403
	value = ((uint32_t)(input[48] & 0x0f) << 28) |
			((uint32_t)input[49] << 20) |
			((uint32_t)(input[50] & 0xf0) << 12);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 404 to 419
	value = ((uint32_t)(input[50] & 0x0f) << 28) |
			((uint32_t)input[51] << 20) |
			((uint32_t)(input[52] & 0xf0) << 12);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 420 to 435
	value = ((uint32_t)(input[52] & 0x0f) << 28) |
			((uint32_t)input[53] << 20) |
			((uint32_t)(input[54] & 0xf0) << 12);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 436 to 451
	value = ((uint32_t)(input[54] & 0x0f) << 28) |
			((uint32_t)input[55] << 20) |
			((uint32_t)(input[56] & 0xf0) << 12);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 452 to 467
	value = ((uint32_t)(input[56] & 0x0f) << 28) |
			((uint32_t)input[57] << 20) |
			((uint32_t)(input[58] & 0xf0) << 12);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 468 to 483
	value = ((uint32_t)(input[58] & 0x0f) << 28) |
			((uint32_t)input[59] << 20) |
			((uint32_t)(input[60] & 0xf0) << 12);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 484 to 499
	value = ((uint32_t)(input[60] & 0x0f) << 28) |
			((uint32_t)input[61] << 20) |
			((uint32_t)(input[62] & 0xf0) << 12);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 500 to 515
	value = ((uint32_t)(input[62] & 0x0f) << 28) |
			((uint32_t)input[63] << 20) |
			((uint32_t)(input[64] & 0xf0) << 12);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 516 to 531
	value = ((uint32_t)(input[64] & 0x0f) << 28) |
			((uint32_t)input[65] << 20) |
			((uint32_t)(input[66] & 0xf0) << 12);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 532 to 547
	value = ((uint32_t)(input[66] & 0x0f) << 28) |
			((uint32_t)input[67] << 20) |
			((uint32_t)(input[68] & 0xf0) << 12);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 548 to 563
	value = ((uint32_t)(input[68] & 0x0f) << 28) |
			((uint32_t)input[69] << 20) |
			((uint32_t)(input[70] & 0xf0) << 12);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 564 to 579
	value = ((uint32_t)(input[70] & 0x0f) << 28) |
			((uint32_t)input[71] << 20) |
			((uint32_t)(input[72] & 0xf0) << 12);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 580 to 595
	value = ((uint32_t)(input[72] & 0x0f) << 28) |
			((uint32_t)input[73] << 20) |
			((uint32_t)(input[74] & 0xf0) << 12);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 596 to 611
	value = ((uint32_t)(input[74] & 0x0f) << 28) |
			((uint32_t)input[75] << 20) |
			((uint32_t)(input[76] & 0xf0) << 12);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 612 to 627
	value = ((uint32_t)(input[76] & 0x0f) << 28) |
			((uint32_t)input[77] << 20) |
			((uint32_t)(input[78] & 0xf0) << 12);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 628 to 643
	value = ((uint32_t)(input[78] & 0x0f) << 28) |
			((uint32_t)input[79] << 20) |
			((uint32_t)(input[80] & 0xf0) << 12);
	output[39] = (double)(value >> 16);

	// read output[40]: from bit 644 to 659
	value = ((uint32_t)(input[80] & 0x0f) << 28) |
			((uint32_t)input[81] << 20) |
			((uint32_t)(input[82] & 0xf0) << 12);
	output[40] = (double)(value >> 16);
}

static void unpack_41_16bit_signed_5off(const uint8_t * input, double * output, void *closure) {
	// Unpack 41 values into output
	// Values are 16-bit signed
	// Skip 5 bits, read 656 bits of data.
	// Input must be at least 83 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 5 to 20
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)(input[2] & 0xf8) << 13);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 21 to 36
	value = ((uint32_t)(input[2] & 0x07) << 29) |
			((uint32_t)input[3] << 21) |
			((uint32_t)(input[4] & 0xf8) << 13);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 37 to 52
	value = ((uint32_t)(input[4] & 0x07) << 29) |
			((uint32_t)input[5] << 21) |
			((uint32_t)(input[6] & 0xf8) << 13);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 53 to 68
	value = ((uint32_t)(input[6] & 0x07) << 29) |
			((uint32_t)input[7] << 21) |
			((uint32_t)(input[8] & 0xf8) << 13);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 69 to 84
	value = ((uint32_t)(input[8] & 0x07) << 29) |
			((uint32_t)input[9] << 21) |
			((uint32_t)(input[10] & 0xf8) << 13);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 85 to 100
	value = ((uint32_t)(input[10] & 0x07) << 29) |
			((uint32_t)input[11] << 21) |
			((uint32_t)(input[12] & 0xf8) << 13);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 101 to 116
	value = ((uint32_t)(input[12] & 0x07) << 29) |
			((uint32_t)input[13] << 21) |
			((uint32_t)(input[14] & 0xf8) << 13);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 117 to 132
	value = ((uint32_t)(input[14] & 0x07) << 29) |
			((uint32_t)input[15] << 21) |
			((uint32_t)(input[16] & 0xf8) << 13);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 133 to 148
	value = ((uint32_t)(input[16] & 0x07) << 29) |
			((uint32_t)input[17] << 21) |
			((uint32_t)(input[18] & 0xf8) << 13);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 149 to 164
	value = ((uint32_t)(input[18] & 0x07) << 29) |
			((uint32_t)input[19] << 21) |
			((uint32_t)(input[20] & 0xf8) << 13);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 165 to 180
	value = ((uint32_t)(input[20] & 0x07) << 29) |
			((uint32_t)input[21] << 21) |
			((uint32_t)(input[22] & 0xf8) << 13);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 181 to 196
	value = ((uint32_t)(input[22] & 0x07) << 29) |
			((uint32_t)input[23] << 21) |
			((uint32_t)(input[24] & 0xf8) << 13);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 197 to 212
	value = ((uint32_t)(input[24] & 0x07) << 29) |
			((uint32_t)input[25] << 21) |
			((uint32_t)(input[26] & 0xf8) << 13);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 213 to 228
	value = ((uint32_t)(input[26] & 0x07) << 29) |
			((uint32_t)input[27] << 21) |
			((uint32_t)(input[28] & 0xf8) << 13);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 229 to 244
	value = ((uint32_t)(input[28] & 0x07) << 29) |
			((uint32_t)input[29] << 21) |
			((uint32_t)(input[30] & 0xf8) << 13);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 245 to 260
	value = ((uint32_t)(input[30] & 0x07) << 29) |
			((uint32_t)input[31] << 21) |
			((uint32_t)(input[32] & 0xf8) << 13);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 261 to 276
	value = ((uint32_t)(input[32] & 0x07) << 29) |
			((uint32_t)input[33] << 21) |
			((uint32_t)(input[34] & 0xf8) << 13);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 277 to 292
	value = ((uint32_t)(input[34] & 0x07) << 29) |
			((uint32_t)input[35] << 21) |
			((uint32_t)(input[36] & 0xf8) << 13);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 293 to 308
	value = ((uint32_t)(input[36] & 0x07) << 29) |
			((uint32_t)input[37] << 21) |
			((uint32_t)(input[38] & 0xf8) << 13);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 309 to 324
	value = ((uint32_t)(input[38] & 0x07) << 29) |
			((uint32_t)input[39] << 21) |
			((uint32_t)(input[40] & 0xf8) << 13);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 325 to 340
	value = ((uint32_t)(input[40] & 0x07) << 29) |
			((uint32_t)input[41] << 21) |
			((uint32_t)(input[42] & 0xf8) << 13);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 341 to 356
	value = ((uint32_t)(input[42] & 0x07) << 29) |
			((uint32_t)input[43] << 21) |
			((uint32_t)(input[44] & 0xf8) << 13);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 357 to 372
	value = ((uint32_t)(input[44] & 0x07) << 29) |
			((uint32_t)input[45] << 21) |
			((uint32_t)(input[46] & 0xf8) << 13);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 373 to 388
	value = ((uint32_t)(input[46] & 0x07) << 29) |
			((uint32_t)input[47] << 21) |
			((uint32_t)(input[48] & 0xf8) << 13);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 389 to 404
	value = ((uint32_t)(input[48] & 0x07) << 29) |
			((uint32_t)input[49] << 21) |
			((uint32_t)(input[50] & 0xf8) << 13);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 405 to 420
	value = ((uint32_t)(input[50] & 0x07) << 29) |
			((uint32_t)input[51] << 21) |
			((uint32_t)(input[52] & 0xf8) << 13);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 421 to 436
	value = ((uint32_t)(input[52] & 0x07) << 29) |
			((uint32_t)input[53] << 21) |
			((uint32_t)(input[54] & 0xf8) << 13);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 437 to 452
	value = ((uint32_t)(input[54] & 0x07) << 29) |
			((uint32_t)input[55] << 21) |
			((uint32_t)(input[56] & 0xf8) << 13);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 453 to 468
	value = ((uint32_t)(input[56] & 0x07) << 29) |
			((uint32_t)input[57] << 21) |
			((uint32_t)(input[58] & 0xf8) << 13);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 469 to 484
	value = ((uint32_t)(input[58] & 0x07) << 29) |
			((uint32_t)input[59] << 21) |
			((uint32_t)(input[60] & 0xf8) << 13);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 485 to 500
	value = ((uint32_t)(input[60] & 0x07) << 29) |
			((uint32_t)input[61] << 21) |
			((uint32_t)(input[62] & 0xf8) << 13);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 501 to 516
	value = ((uint32_t)(input[62] & 0x07) << 29) |
			((uint32_t)input[63] << 21) |
			((uint32_t)(input[64] & 0xf8) << 13);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 517 to 532
	value = ((uint32_t)(input[64] & 0x07) << 29) |
			((uint32_t)input[65] << 21) |
			((uint32_t)(input[66] & 0xf8) << 13);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 533 to 548
	value = ((uint32_t)(input[66] & 0x07) << 29) |
			((uint32_t)input[67] << 21) |
			((uint32_t)(input[68] & 0xf8) << 13);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 549 to 564
	value = ((uint32_t)(input[68] & 0x07) << 29) |
			((uint32_t)input[69] << 21) |
			((uint32_t)(input[70] & 0xf8) << 13);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 565 to 580
	value = ((uint32_t)(input[70] & 0x07) << 29) |
			((uint32_t)input[71] << 21) |
			((uint32_t)(input[72] & 0xf8) << 13);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 581 to 596
	value = ((uint32_t)(input[72] & 0x07) << 29) |
			((uint32_t)input[73] << 21) |
			((uint32_t)(input[74] & 0xf8) << 13);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 597 to 612
	value = ((uint32_t)(input[74] & 0x07) << 29) |
			((uint32_t)input[75] << 21) |
			((uint32_t)(input[76] & 0xf8) << 13);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 613 to 628
	value = ((uint32_t)(input[76] & 0x07) << 29) |
			((uint32_t)input[77] << 21) |
			((uint32_t)(input[78] & 0xf8) << 13);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 629 to 644
	value = ((uint32_t)(input[78] & 0x07) << 29) |
			((uint32_t)input[79] << 21) |
			((uint32_t)(input[80] & 0xf8) << 13);
	output[39] = (double)(value >> 16);

	// read output[40]: from bit 645 to 660
	value = ((uint32_t)(input[80] & 0x07) << 29) |
			((uint32_t)input[81] << 21) |
			((uint32_t)(input[82] & 0xf8) << 13);
	output[40] = (double)(value >> 16);
}

static void unpack_41_16bit_unsigned_5off(const uint8_t * input, double * output, void *closure) {
	// Unpack 41 values into output
	// Values are 16-bit unsigned
	// Skip 5 bits, read 656 bits of data.
	// Input must be at least 83 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 5 to 20
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)(input[2] & 0xf8) << 13);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 21 to 36
	value = ((uint32_t)(input[2] & 0x07) << 29) |
			((uint32_t)input[3] << 21) |
			((uint32_t)(input[4] & 0xf8) << 13);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 37 to 52
	value = ((uint32_t)(input[4] & 0x07) << 29) |
			((uint32_t)input[5] << 21) |
			((uint32_t)(input[6] & 0xf8) << 13);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 53 to 68
	value = ((uint32_t)(input[6] & 0x07) << 29) |
			((uint32_t)input[7] << 21) |
			((uint32_t)(input[8] & 0xf8) << 13);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 69 to 84
	value = ((uint32_t)(input[8] & 0x07) << 29) |
			((uint32_t)input[9] << 21) |
			((uint32_t)(input[10] & 0xf8) << 13);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 85 to 100
	value = ((uint32_t)(input[10] & 0x07) << 29) |
			((uint32_t)input[11] << 21) |
			((uint32_t)(input[12] & 0xf8) << 13);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 101 to 116
	value = ((uint32_t)(input[12] & 0x07) << 29) |
			((uint32_t)input[13] << 21) |
			((uint32_t)(input[14] & 0xf8) << 13);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 117 to 132
	value = ((uint32_t)(input[14] & 0x07) << 29) |
			((uint32_t)input[15] << 21) |
			((uint32_t)(input[16] & 0xf8) << 13);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 133 to 148
	value = ((uint32_t)(input[16] & 0x07) << 29) |
			((uint32_t)input[17] << 21) |
			((uint32_t)(input[18] & 0xf8) << 13);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 149 to 164
	value = ((uint32_t)(input[18] & 0x07) << 29) |
			((uint32_t)input[19] << 21) |
			((uint32_t)(input[20] & 0xf8) << 13);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 165 to 180
	value = ((uint32_t)(input[20] & 0x07) << 29) |
			((uint32_t)input[21] << 21) |
			((uint32_t)(input[22] & 0xf8) << 13);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 181 to 196
	value = ((uint32_t)(input[22] & 0x07) << 29) |
			((uint32_t)input[23] << 21) |
			((uint32_t)(input[24] & 0xf8) << 13);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 197 to 212
	value = ((uint32_t)(input[24] & 0x07) << 29) |
			((uint32_t)input[25] << 21) |
			((uint32_t)(input[26] & 0xf8) << 13);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 213 to 228
	value = ((uint32_t)(input[26] & 0x07) << 29) |
			((uint32_t)input[27] << 21) |
			((uint32_t)(input[28] & 0xf8) << 13);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 229 to 244
	value = ((uint32_t)(input[28] & 0x07) << 29) |
			((uint32_t)input[29] << 21) |
			((uint32_t)(input[30] & 0xf8) << 13);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 245 to 260
	value = ((uint32_t)(input[30] & 0x07) << 29) |
			((uint32_t)input[31] << 21) |
			((uint32_t)(input[32] & 0xf8) << 13);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 261 to 276
	value = ((uint32_t)(input[32] & 0x07) << 29) |
			((uint32_t)input[33] << 21) |
			((uint32_t)(input[34] & 0xf8) << 13);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 277 to 292
	value = ((uint32_t)(input[34] & 0x07) << 29) |
			((uint32_t)input[35] << 21) |
			((uint32_t)(input[36] & 0xf8) << 13);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 293 to 308
	value = ((uint32_t)(input[36] & 0x07) << 29) |
			((uint32_t)input[37] << 21) |
			((uint32_t)(input[38] & 0xf8) << 13);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 309 to 324
	value = ((uint32_t)(input[38] & 0x07) << 29) |
			((uint32_t)input[39] << 21) |
			((uint32_t)(input[40] & 0xf8) << 13);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 325 to 340
	value = ((uint32_t)(input[40] & 0x07) << 29) |
			((uint32_t)input[41] << 21) |
			((uint32_t)(input[42] & 0xf8) << 13);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 341 to 356
	value = ((uint32_t)(input[42] & 0x07) << 29) |
			((uint32_t)input[43] << 21) |
			((uint32_t)(input[44] & 0xf8) << 13);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 357 to 372
	value = ((uint32_t)(input[44] & 0x07) << 29) |
			((uint32_t)input[45] << 21) |
			((uint32_t)(input[46] & 0xf8) << 13);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 373 to 388
	value = ((uint32_t)(input[46] & 0x07) << 29) |
			((uint32_t)input[47] << 21) |
			((uint32_t)(input[48] & 0xf8) << 13);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 389 to 404
	value = ((uint32_t)(input[48] & 0x07) << 29) |
			((uint32_t)input[49] << 21) |
			((uint32_t)(input[50] & 0xf8) << 13);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 405 to 420
	value = ((uint32_t)(input[50] & 0x07) << 29) |
			((uint32_t)input[51] << 21) |
			((uint32_t)(input[52] & 0xf8) << 13);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 421 to 436
	value = ((uint32_t)(input[52] & 0x07) << 29) |
			((uint32_t)input[53] << 21) |
			((uint32_t)(input[54] & 0xf8) << 13);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 437 to 452
	value = ((uint32_t)(input[54] & 0x07) << 29) |
			((uint32_t)input[55] << 21) |
			((uint32_t)(input[56] & 0xf8) << 13);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 453 to 468
	value = ((uint32_t)(input[56] & 0x07) << 29) |
			((uint32_t)input[57] << 21) |
			((uint32_t)(input[58] & 0xf8) << 13);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 469 to 484
	value = ((uint32_t)(input[58] & 0x07) << 29) |
			((uint32_t)input[59] << 21) |
			((uint32_t)(input[60] & 0xf8) << 13);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 485 to 500
	value = ((uint32_t)(input[60] & 0x07) << 29) |
			((uint32_t)input[61] << 21) |
			((uint32_t)(input[62] & 0xf8) << 13);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 501 to 516
	value = ((uint32_t)(input[62] & 0x07) << 29) |
			((uint32_t)input[63] << 21) |
			((uint32_t)(input[64] & 0xf8) << 13);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 517 to 532
	value = ((uint32_t)(input[64] & 0x07) << 29) |
			((uint32_t)input[65] << 21) |
			((uint32_t)(input[66] & 0xf8) << 13);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 533 to 548
	value = ((uint32_t)(input[66] & 0x07) << 29) |
			((uint32_t)input[67] << 21) |
			((uint32_t)(input[68] & 0xf8) << 13);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 549 to 564
	value = ((uint32_t)(input[68] & 0x07) << 29) |
			((uint32_t)input[69] << 21) |
			((uint32_t)(input[70] & 0xf8) << 13);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 565 to 580
	value = ((uint32_t)(input[70] & 0x07) << 29) |
			((uint32_t)input[71] << 21) |
			((uint32_t)(input[72] & 0xf8) << 13);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 581 to 596
	value = ((uint32_t)(input[72] & 0x07) << 29) |
			((uint32_t)input[73] << 21) |
			((uint32_t)(input[74] & 0xf8) << 13);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 597 to 612
	value = ((uint32_t)(input[74] & 0x07) << 29) |
			((uint32_t)input[75] << 21) |
			((uint32_t)(input[76] & 0xf8) << 13);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 613 to 628
	value = ((uint32_t)(input[76] & 0x07) << 29) |
			((uint32_t)input[77] << 21) |
			((uint32_t)(input[78] & 0xf8) << 13);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 629 to 644
	value = ((uint32_t)(input[78] & 0x07) << 29) |
			((uint32_t)input[79] << 21) |
			((uint32_t)(input[80] & 0xf8) << 13);
	output[39] = (double)(value >> 16);

	// read output[40]: from bit 645 to 660
	value = ((uint32_t)(input[80] & 0x07) << 29) |
			((uint32_t)input[81] << 21) |
			((uint32_t)(input[82] & 0xf8) << 13);
	output[40] = (double)(value >> 16);
}

static void unpack_41_16bit_signed_6off(const uint8_t * input, double * output, void *closure) {
	// Unpack 41 values into output
	// Values are 16-bit signed
	// Skip 6 bits, read 656 bits of data.
	// Input must be at least 83 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 6 to 21
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)(input[2] & 0xfc) << 14);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 22 to 37
	value = ((uint32_t)(input[2] & 0x03) << 30) |
			((uint32_t)input[3] << 22) |
			((uint32_t)(input[4] & 0xfc) << 14);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 38 to 53
	value = ((uint32_t)(input[4] & 0x03) << 30) |
			((uint32_t)input[5] << 22) |
			((uint32_t)(input[6] & 0xfc) << 14);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 54 to 69
	value = ((uint32_t)(input[6] & 0x03) << 30) |
			((uint32_t)input[7] << 22) |
			((uint32_t)(input[8] & 0xfc) << 14);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 70 to 85
	value = ((uint32_t)(input[8] & 0x03) << 30) |
			((uint32_t)input[9] << 22) |
			((uint32_t)(input[10] & 0xfc) << 14);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 86 to 101
	value = ((uint32_t)(input[10] & 0x03) << 30) |
			((uint32_t)input[11] << 22) |
			((uint32_t)(input[12] & 0xfc) << 14);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 102 to 117
	value = ((uint32_t)(input[12] & 0x03) << 30) |
			((uint32_t)input[13] << 22) |
			((uint32_t)(input[14] & 0xfc) << 14);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 118 to 133
	value = ((uint32_t)(input[14] & 0x03) << 30) |
			((uint32_t)input[15] << 22) |
			((uint32_t)(input[16] & 0xfc) << 14);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 134 to 149
	value = ((uint32_t)(input[16] & 0x03) << 30) |
			((uint32_t)input[17] << 22) |
			((uint32_t)(input[18] & 0xfc) << 14);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 150 to 165
	value = ((uint32_t)(input[18] & 0x03) << 30) |
			((uint32_t)input[19] << 22) |
			((uint32_t)(input[20] & 0xfc) << 14);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 166 to 181
	value = ((uint32_t)(input[20] & 0x03) << 30) |
			((uint32_t)input[21] << 22) |
			((uint32_t)(input[22] & 0xfc) << 14);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 182 to 197
	value = ((uint32_t)(input[22] & 0x03) << 30) |
			((uint32_t)input[23] << 22) |
			((uint32_t)(input[24] & 0xfc) << 14);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 198 to 213
	value = ((uint32_t)(input[24] & 0x03) << 30) |
			((uint32_t)input[25] << 22) |
			((uint32_t)(input[26] & 0xfc) << 14);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 214 to 229
	value = ((uint32_t)(input[26] & 0x03) << 30) |
			((uint32_t)input[27] << 22) |
			((uint32_t)(input[28] & 0xfc) << 14);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 230 to 245
	value = ((uint32_t)(input[28] & 0x03) << 30) |
			((uint32_t)input[29] << 22) |
			((uint32_t)(input[30] & 0xfc) << 14);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 246 to 261
	value = ((uint32_t)(input[30] & 0x03) << 30) |
			((uint32_t)input[31] << 22) |
			((uint32_t)(input[32] & 0xfc) << 14);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 262 to 277
	value = ((uint32_t)(input[32] & 0x03) << 30) |
			((uint32_t)input[33] << 22) |
			((uint32_t)(input[34] & 0xfc) << 14);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 278 to 293
	value = ((uint32_t)(input[34] & 0x03) << 30) |
			((uint32_t)input[35] << 22) |
			((uint32_t)(input[36] & 0xfc) << 14);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 294 to 309
	value = ((uint32_t)(input[36] & 0x03) << 30) |
			((uint32_t)input[37] << 22) |
			((uint32_t)(input[38] & 0xfc) << 14);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 310 to 325
	value = ((uint32_t)(input[38] & 0x03) << 30) |
			((uint32_t)input[39] << 22) |
			((uint32_t)(input[40] & 0xfc) << 14);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 326 to 341
	value = ((uint32_t)(input[40] & 0x03) << 30) |
			((uint32_t)input[41] << 22) |
			((uint32_t)(input[42] & 0xfc) << 14);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 342 to 357
	value = ((uint32_t)(input[42] & 0x03) << 30) |
			((uint32_t)input[43] << 22) |
			((uint32_t)(input[44] & 0xfc) << 14);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 358 to 373
	value = ((uint32_t)(input[44] & 0x03) << 30) |
			((uint32_t)input[45] << 22) |
			((uint32_t)(input[46] & 0xfc) << 14);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 374 to 389
	value = ((uint32_t)(input[46] & 0x03) << 30) |
			((uint32_t)input[47] << 22) |
			((uint32_t)(input[48] & 0xfc) << 14);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 390 to 405
	value = ((uint32_t)(input[48] & 0x03) << 30) |
			((uint32_t)input[49] << 22) |
			((uint32_t)(input[50] & 0xfc) << 14);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 406 to 421
	value = ((uint32_t)(input[50] & 0x03) << 30) |
			((uint32_t)input[51] << 22) |
			((uint32_t)(input[52] & 0xfc) << 14);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 422 to 437
	value = ((uint32_t)(input[52] & 0x03) << 30) |
			((uint32_t)input[53] << 22) |
			((uint32_t)(input[54] & 0xfc) << 14);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 438 to 453
	value = ((uint32_t)(input[54] & 0x03) << 30) |
			((uint32_t)input[55] << 22) |
			((uint32_t)(input[56] & 0xfc) << 14);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 454 to 469
	value = ((uint32_t)(input[56] & 0x03) << 30) |
			((uint32_t)input[57] << 22) |
			((uint32_t)(input[58] & 0xfc) << 14);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 470 to 485
	value = ((uint32_t)(input[58] & 0x03) << 30) |
			((uint32_t)input[59] << 22) |
			((uint32_t)(input[60] & 0xfc) << 14);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 486 to 501
	value = ((uint32_t)(input[60] & 0x03) << 30) |
			((uint32_t)input[61] << 22) |
			((uint32_t)(input[62] & 0xfc) << 14);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 502 to 517
	value = ((uint32_t)(input[62] & 0x03) << 30) |
			((uint32_t)input[63] << 22) |
			((uint32_t)(input[64] & 0xfc) << 14);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 518 to 533
	value = ((uint32_t)(input[64] & 0x03) << 30) |
			((uint32_t)input[65] << 22) |
			((uint32_t)(input[66] & 0xfc) << 14);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 534 to 549
	value = ((uint32_t)(input[66] & 0x03) << 30) |
			((uint32_t)input[67] << 22) |
			((uint32_t)(input[68] & 0xfc) << 14);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 550 to 565
	value = ((uint32_t)(input[68] & 0x03) << 30) |
			((uint32_t)input[69] << 22) |
			((uint32_t)(input[70] & 0xfc) << 14);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 566 to 581
	value = ((uint32_t)(input[70] & 0x03) << 30) |
			((uint32_t)input[71] << 22) |
			((uint32_t)(input[72] & 0xfc) << 14);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 582 to 597
	value = ((uint32_t)(input[72] & 0x03) << 30) |
			((uint32_t)input[73] << 22) |
			((uint32_t)(input[74] & 0xfc) << 14);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 598 to 613
	value = ((uint32_t)(input[74] & 0x03) << 30) |
			((uint32_t)input[75] << 22) |
			((uint32_t)(input[76] & 0xfc) << 14);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 614 to 629
	value = ((uint32_t)(input[76] & 0x03) << 30) |
			((uint32_t)input[77] << 22) |
			((uint32_t)(input[78] & 0xfc) << 14);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 630 to 645
	value = ((uint32_t)(input[78] & 0x03) << 30) |
			((uint32_t)input[79] << 22) |
			((uint32_t)(input[80] & 0xfc) << 14);
	output[39] = (double)(value >> 16);

	// read output[40]: from bit 646 to 661
	value = ((uint32_t)(input[80] & 0x03) << 30) |
			((uint32_t)input[81] << 22) |
			((uint32_t)(input[82] & 0xfc) << 14);
	output[40] = (double)(value >> 16);
}

static void unpack_41_16bit_unsigned_6off(const uint8_t * input, double * output, void *closure) {
	// Unpack 41 values into output
	// Values are 16-bit unsigned
	// Skip 6 bits, read 656 bits of data.
	// Input must be at least 83 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 6 to 21
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)(input[2] & 0xfc) << 14);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 22 to 37
	value = ((uint32_t)(input[2] & 0x03) << 30) |
			((uint32_t)input[3] << 22) |
			((uint32_t)(input[4] & 0xfc) << 14);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 38 to 53
	value = ((uint32_t)(input[4] & 0x03) << 30) |
			((uint32_t)input[5] << 22) |
			((uint32_t)(input[6] & 0xfc) << 14);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 54 to 69
	value = ((uint32_t)(input[6] & 0x03) << 30) |
			((uint32_t)input[7] << 22) |
			((uint32_t)(input[8] & 0xfc) << 14);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 70 to 85
	value = ((uint32_t)(input[8] & 0x03) << 30) |
			((uint32_t)input[9] << 22) |
			((uint32_t)(input[10] & 0xfc) << 14);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 86 to 101
	value = ((uint32_t)(input[10] & 0x03) << 30) |
			((uint32_t)input[11] << 22) |
			((uint32_t)(input[12] & 0xfc) << 14);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 102 to 117
	value = ((uint32_t)(input[12] & 0x03) << 30) |
			((uint32_t)input[13] << 22) |
			((uint32_t)(input[14] & 0xfc) << 14);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 118 to 133
	value = ((uint32_t)(input[14] & 0x03) << 30) |
			((uint32_t)input[15] << 22) |
			((uint32_t)(input[16] & 0xfc) << 14);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 134 to 149
	value = ((uint32_t)(input[16] & 0x03) << 30) |
			((uint32_t)input[17] << 22) |
			((uint32_t)(input[18] & 0xfc) << 14);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 150 to 165
	value = ((uint32_t)(input[18] & 0x03) << 30) |
			((uint32_t)input[19] << 22) |
			((uint32_t)(input[20] & 0xfc) << 14);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 166 to 181
	value = ((uint32_t)(input[20] & 0x03) << 30) |
			((uint32_t)input[21] << 22) |
			((uint32_t)(input[22] & 0xfc) << 14);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 182 to 197
	value = ((uint32_t)(input[22] & 0x03) << 30) |
			((uint32_t)input[23] << 22) |
			((uint32_t)(input[24] & 0xfc) << 14);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 198 to 213
	value = ((uint32_t)(input[24] & 0x03) << 30) |
			((uint32_t)input[25] << 22) |
			((uint32_t)(input[26] & 0xfc) << 14);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 214 to 229
	value = ((uint32_t)(input[26] & 0x03) << 30) |
			((uint32_t)input[27] << 22) |
			((uint32_t)(input[28] & 0xfc) << 14);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 230 to 245
	value = ((uint32_t)(input[28] & 0x03) << 30) |
			((uint32_t)input[29] << 22) |
			((uint32_t)(input[30] & 0xfc) << 14);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 246 to 261
	value = ((uint32_t)(input[30] & 0x03) << 30) |
			((uint32_t)input[31] << 22) |
			((uint32_t)(input[32] & 0xfc) << 14);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 262 to 277
	value = ((uint32_t)(input[32] & 0x03) << 30) |
			((uint32_t)input[33] << 22) |
			((uint32_t)(input[34] & 0xfc) << 14);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 278 to 293
	value = ((uint32_t)(input[34] & 0x03) << 30) |
			((uint32_t)input[35] << 22) |
			((uint32_t)(input[36] & 0xfc) << 14);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 294 to 309
	value = ((uint32_t)(input[36] & 0x03) << 30) |
			((uint32_t)input[37] << 22) |
			((uint32_t)(input[38] & 0xfc) << 14);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 310 to 325
	value = ((uint32_t)(input[38] & 0x03) << 30) |
			((uint32_t)input[39] << 22) |
			((uint32_t)(input[40] & 0xfc) << 14);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 326 to 341
	value = ((uint32_t)(input[40] & 0x03) << 30) |
			((uint32_t)input[41] << 22) |
			((uint32_t)(input[42] & 0xfc) << 14);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 342 to 357
	value = ((uint32_t)(input[42] & 0x03) << 30) |
			((uint32_t)input[43] << 22) |
			((uint32_t)(input[44] & 0xfc) << 14);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 358 to 373
	value = ((uint32_t)(input[44] & 0x03) << 30) |
			((uint32_t)input[45] << 22) |
			((uint32_t)(input[46] & 0xfc) << 14);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 374 to 389
	value = ((uint32_t)(input[46] & 0x03) << 30) |
			((uint32_t)input[47] << 22) |
			((uint32_t)(input[48] & 0xfc) << 14);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 390 to 405
	value = ((uint32_t)(input[48] & 0x03) << 30) |
			((uint32_t)input[49] << 22) |
			((uint32_t)(input[50] & 0xfc) << 14);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 406 to 421
	value = ((uint32_t)(input[50] & 0x03) << 30) |
			((uint32_t)input[51] << 22) |
			((uint32_t)(input[52] & 0xfc) << 14);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 422 to 437
	value = ((uint32_t)(input[52] & 0x03) << 30) |
			((uint32_t)input[53] << 22) |
			((uint32_t)(input[54] & 0xfc) << 14);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 438 to 453
	value = ((uint32_t)(input[54] & 0x03) << 30) |
			((uint32_t)input[55] << 22) |
			((uint32_t)(input[56] & 0xfc) << 14);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 454 to 469
	value = ((uint32_t)(input[56] & 0x03) << 30) |
			((uint32_t)input[57] << 22) |
			((uint32_t)(input[58] & 0xfc) << 14);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 470 to 485
	value = ((uint32_t)(input[58] & 0x03) << 30) |
			((uint32_t)input[59] << 22) |
			((uint32_t)(input[60] & 0xfc) << 14);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 486 to 501
	value = ((uint32_t)(input[60] & 0x03) << 30) |
			((uint32_t)input[61] << 22) |
			((uint32_t)(input[62] & 0xfc) << 14);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 502 to 517
	value = ((uint32_t)(input[62] & 0x03) << 30) |
			((uint32_t)input[63] << 22) |
			((uint32_t)(input[64] & 0xfc) << 14);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 518 to 533
	value = ((uint32_t)(input[64] & 0x03) << 30) |
			((uint32_t)input[65] << 22) |
			((uint32_t)(input[66] & 0xfc) << 14);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 534 to 549
	value = ((uint32_t)(input[66] & 0x03) << 30) |
			((uint32_t)input[67] << 22) |
			((uint32_t)(input[68] & 0xfc) << 14);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 550 to 565
	value = ((uint32_t)(input[68] & 0x03) << 30) |
			((uint32_t)input[69] << 22) |
			((uint32_t)(input[70] & 0xfc) << 14);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 566 to 581
	value = ((uint32_t)(input[70] & 0x03) << 30) |
			((uint32_t)input[71] << 22) |
			((uint32_t)(input[72] & 0xfc) << 14);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 582 to 597
	value = ((uint32_t)(input[72] & 0x03) << 30) |
			((uint32_t)input[73] << 22) |
			((uint32_t)(input[74] & 0xfc) << 14);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 598 to 613
	value = ((uint32_t)(input[74] & 0x03) << 30) |
			((uint32_t)input[75] << 22) |
			((uint32_t)(input[76] & 0xfc) << 14);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 614 to 629
	value = ((uint32_t)(input[76] & 0x03) << 30) |
			((uint32_t)input[77] << 22) |
			((uint32_t)(input[78] & 0xfc) << 14);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 630 to 645
	value = ((uint32_t)(input[78] & 0x03) << 30) |
			((uint32_t)input[79] << 22) |
			((uint32_t)(input[80] & 0xfc) << 14);
	output[39] = (double)(value >> 16);

	// read output[40]: from bit 646 to 661
	value = ((uint32_t)(input[80] & 0x03) << 30) |
			((uint32_t)input[81] << 22) |
			((uint32_t)(input[82] & 0xfc) << 14);
	output[40] = (double)(value >> 16);
}

static void unpack_41_16bit_signed_7off(const uint8_t * input, double * output, void *closure) {
	// Unpack 41 values into output
	// Values are 16-bit signed
	// Skip 7 bits, read 656 bits of data.
	// Input must be at least 83 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 7 to 22
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)(input[2] & 0xfe) << 15);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 23 to 38
	value = ((uint32_t)(input[2] & 0x01) << 31) |
			((uint32_t)input[3] << 23) |
			((uint32_t)(input[4] & 0xfe) << 15);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 39 to 54
	value = ((uint32_t)(input[4] & 0x01) << 31) |
			((uint32_t)input[5] << 23) |
			((uint32_t)(input[6] & 0xfe) << 15);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 55 to 70
	value = ((uint32_t)(input[6] & 0x01) << 31) |
			((uint32_t)input[7] << 23) |
			((uint32_t)(input[8] & 0xfe) << 15);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 71 to 86
	value = ((uint32_t)(input[8] & 0x01) << 31) |
			((uint32_t)input[9] << 23) |
			((uint32_t)(input[10] & 0xfe) << 15);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 87 to 102
	value = ((uint32_t)(input[10] & 0x01) << 31) |
			((uint32_t)input[11] << 23) |
			((uint32_t)(input[12] & 0xfe) << 15);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 103 to 118
	value = ((uint32_t)(input[12] & 0x01) << 31) |
			((uint32_t)input[13] << 23) |
			((uint32_t)(input[14] & 0xfe) << 15);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 119 to 134
	value = ((uint32_t)(input[14] & 0x01) << 31) |
			((uint32_t)input[15] << 23) |
			((uint32_t)(input[16] & 0xfe) << 15);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 135 to 150
	value = ((uint32_t)(input[16] & 0x01) << 31) |
			((uint32_t)input[17] << 23) |
			((uint32_t)(input[18] & 0xfe) << 15);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 151 to 166
	value = ((uint32_t)(input[18] & 0x01) << 31) |
			((uint32_t)input[19] << 23) |
			((uint32_t)(input[20] & 0xfe) << 15);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 167 to 182
	value = ((uint32_t)(input[20] & 0x01) << 31) |
			((uint32_t)input[21] << 23) |
			((uint32_t)(input[22] & 0xfe) << 15);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 183 to 198
	value = ((uint32_t)(input[22] & 0x01) << 31) |
			((uint32_t)input[23] << 23) |
			((uint32_t)(input[24] & 0xfe) << 15);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 199 to 214
	value = ((uint32_t)(input[24] & 0x01) << 31) |
			((uint32_t)input[25] << 23) |
			((uint32_t)(input[26] & 0xfe) << 15);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 215 to 230
	value = ((uint32_t)(input[26] & 0x01) << 31) |
			((uint32_t)input[27] << 23) |
			((uint32_t)(input[28] & 0xfe) << 15);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 231 to 246
	value = ((uint32_t)(input[28] & 0x01) << 31) |
			((uint32_t)input[29] << 23) |
			((uint32_t)(input[30] & 0xfe) << 15);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 247 to 262
	value = ((uint32_t)(input[30] & 0x01) << 31) |
			((uint32_t)input[31] << 23) |
			((uint32_t)(input[32] & 0xfe) << 15);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 263 to 278
	value = ((uint32_t)(input[32] & 0x01) << 31) |
			((uint32_t)input[33] << 23) |
			((uint32_t)(input[34] & 0xfe) << 15);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 279 to 294
	value = ((uint32_t)(input[34] & 0x01) << 31) |
			((uint32_t)input[35] << 23) |
			((uint32_t)(input[36] & 0xfe) << 15);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 295 to 310
	value = ((uint32_t)(input[36] & 0x01) << 31) |
			((uint32_t)input[37] << 23) |
			((uint32_t)(input[38] & 0xfe) << 15);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 311 to 326
	value = ((uint32_t)(input[38] & 0x01) << 31) |
			((uint32_t)input[39] << 23) |
			((uint32_t)(input[40] & 0xfe) << 15);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 327 to 342
	value = ((uint32_t)(input[40] & 0x01) << 31) |
			((uint32_t)input[41] << 23) |
			((uint32_t)(input[42] & 0xfe) << 15);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 343 to 358
	value = ((uint32_t)(input[42] & 0x01) << 31) |
			((uint32_t)input[43] << 23) |
			((uint32_t)(input[44] & 0xfe) << 15);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 359 to 374
	value = ((uint32_t)(input[44] & 0x01) << 31) |
			((uint32_t)input[45] << 23) |
			((uint32_t)(input[46] & 0xfe) << 15);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 375 to 390
	value = ((uint32_t)(input[46] & 0x01) << 31) |
			((uint32_t)input[47] << 23) |
			((uint32_t)(input[48] & 0xfe) << 15);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 391 to 406
	value = ((uint32_t)(input[48] & 0x01) << 31) |
			((uint32_t)input[49] << 23) |
			((uint32_t)(input[50] & 0xfe) << 15);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 407 to 422
	value = ((uint32_t)(input[50] & 0x01) << 31) |
			((uint32_t)input[51] << 23) |
			((uint32_t)(input[52] & 0xfe) << 15);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 423 to 438
	value = ((uint32_t)(input[52] & 0x01) << 31) |
			((uint32_t)input[53] << 23) |
			((uint32_t)(input[54] & 0xfe) << 15);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 439 to 454
	value = ((uint32_t)(input[54] & 0x01) << 31) |
			((uint32_t)input[55] << 23) |
			((uint32_t)(input[56] & 0xfe) << 15);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 455 to 470
	value = ((uint32_t)(input[56] & 0x01) << 31) |
			((uint32_t)input[57] << 23) |
			((uint32_t)(input[58] & 0xfe) << 15);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 471 to 486
	value = ((uint32_t)(input[58] & 0x01) << 31) |
			((uint32_t)input[59] << 23) |
			((uint32_t)(input[60] & 0xfe) << 15);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 487 to 502
	value = ((uint32_t)(input[60] & 0x01) << 31) |
			((uint32_t)input[61] << 23) |
			((uint32_t)(input[62] & 0xfe) << 15);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 503 to 518
	value = ((uint32_t)(input[62] & 0x01) << 31) |
			((uint32_t)input[63] << 23) |
			((uint32_t)(input[64] & 0xfe) << 15);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 519 to 534
	value = ((uint32_t)(input[64] & 0x01) << 31) |
			((uint32_t)input[65] << 23) |
			((uint32_t)(input[66] & 0xfe) << 15);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 535 to 550
	value = ((uint32_t)(input[66] & 0x01) << 31) |
			((uint32_t)input[67] << 23) |
			((uint32_t)(input[68] & 0xfe) << 15);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 551 to 566
	value = ((uint32_t)(input[68] & 0x01) << 31) |
			((uint32_t)input[69] << 23) |
			((uint32_t)(input[70] & 0xfe) << 15);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 567 to 582
	value = ((uint32_t)(input[70] & 0x01) << 31) |
			((uint32_t)input[71] << 23) |
			((uint32_t)(input[72] & 0xfe) << 15);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 583 to 598
	value = ((uint32_t)(input[72] & 0x01) << 31) |
			((uint32_t)input[73] << 23) |
			((uint32_t)(input[74] & 0xfe) << 15);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 599 to 614
	value = ((uint32_t)(input[74] & 0x01) << 31) |
			((uint32_t)input[75] << 23) |
			((uint32_t)(input[76] & 0xfe) << 15);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 615 to 630
	value = ((uint32_t)(input[76] & 0x01) << 31) |
			((uint32_t)input[77] << 23) |
			((uint32_t)(input[78] & 0xfe) << 15);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 631 to 646
	value = ((uint32_t)(input[78] & 0x01) << 31) |
			((uint32_t)input[79] << 23) |
			((uint32_t)(input[80] & 0xfe) << 15);
	output[39] = (double)(value >> 16);

	// read output[40]: from bit 647 to 662
	value = ((uint32_t)(input[80] & 0x01) << 31) |
			((uint32_t)input[81] << 23) |
			((uint32_t)(input[82] & 0xfe) << 15);
	output[40] = (double)(value >> 16);
}

static void unpack_41_16bit_unsigned_7off(const uint8_t * input, double * output, void *closure) {
	// Unpack 41 values into output
	// Values are 16-bit unsigned
	// Skip 7 bits, read 656 bits of data.
	// Input must be at least 83 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 7 to 22
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)(input[2] & 0xfe) << 15);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 23 to 38
	value = ((uint32_t)(input[2] & 0x01) << 31) |
			((uint32_t)input[3] << 23) |
			((uint32_t)(input[4] & 0xfe) << 15);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 39 to 54
	value = ((uint32_t)(input[4] & 0x01) << 31) |
			((uint32_t)input[5] << 23) |
			((uint32_t)(input[6] & 0xfe) << 15);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 55 to 70
	value = ((uint32_t)(input[6] & 0x01) << 31) |
			((uint32_t)input[7] << 23) |
			((uint32_t)(input[8] & 0xfe) << 15);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 71 to 86
	value = ((uint32_t)(input[8] & 0x01) << 31) |
			((uint32_t)input[9] << 23) |
			((uint32_t)(input[10] & 0xfe) << 15);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 87 to 102
	value = ((uint32_t)(input[10] & 0x01) << 31) |
			((uint32_t)input[11] << 23) |
			((uint32_t)(input[12] & 0xfe) << 15);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 103 to 118
	value = ((uint32_t)(input[12] & 0x01) << 31) |
			((uint32_t)input[13] << 23) |
			((uint32_t)(input[14] & 0xfe) << 15);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 119 to 134
	value = ((uint32_t)(input[14] & 0x01) << 31) |
			((uint32_t)input[15] << 23) |
			((uint32_t)(input[16] & 0xfe) << 15);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 135 to 150
	value = ((uint32_t)(input[16] & 0x01) << 31) |
			((uint32_t)input[17] << 23) |
			((uint32_t)(input[18] & 0xfe) << 15);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 151 to 166
	value = ((uint32_t)(input[18] & 0x01) << 31) |
			((uint32_t)input[19] << 23) |
			((uint32_t)(input[20] & 0xfe) << 15);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 167 to 182
	value = ((uint32_t)(input[20] & 0x01) << 31) |
			((uint32_t)input[21] << 23) |
			((uint32_t)(input[22] & 0xfe) << 15);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 183 to 198
	value = ((uint32_t)(input[22] & 0x01) << 31) |
			((uint32_t)input[23] << 23) |
			((uint32_t)(input[24] & 0xfe) << 15);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 199 to 214
	value = ((uint32_t)(input[24] & 0x01) << 31) |
			((uint32_t)input[25] << 23) |
			((uint32_t)(input[26] & 0xfe) << 15);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 215 to 230
	value = ((uint32_t)(input[26] & 0x01) << 31) |
			((uint32_t)input[27] << 23) |
			((uint32_t)(input[28] & 0xfe) << 15);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 231 to 246
	value = ((uint32_t)(input[28] & 0x01) << 31) |
			((uint32_t)input[29] << 23) |
			((uint32_t)(input[30] & 0xfe) << 15);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 247 to 262
	value = ((uint32_t)(input[30] & 0x01) << 31) |
			((uint32_t)input[31] << 23) |
			((uint32_t)(input[32] & 0xfe) << 15);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 263 to 278
	value = ((uint32_t)(input[32] & 0x01) << 31) |
			((uint32_t)input[33] << 23) |
			((uint32_t)(input[34] & 0xfe) << 15);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 279 to 294
	value = ((uint32_t)(input[34] & 0x01) << 31) |
			((uint32_t)input[35] << 23) |
			((uint32_t)(input[36] & 0xfe) << 15);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 295 to 310
	value = ((uint32_t)(input[36] & 0x01) << 31) |
			((uint32_t)input[37] << 23) |
			((uint32_t)(input[38] & 0xfe) << 15);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 311 to 326
	value = ((uint32_t)(input[38] & 0x01) << 31) |
			((uint32_t)input[39] << 23) |
			((uint32_t)(input[40] & 0xfe) << 15);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 327 to 342
	value = ((uint32_t)(input[40] & 0x01) << 31) |
			((uint32_t)input[41] << 23) |
			((uint32_t)(input[42] & 0xfe) << 15);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 343 to 358
	value = ((uint32_t)(input[42] & 0x01) << 31) |
			((uint32_t)input[43] << 23) |
			((uint32_t)(input[44] & 0xfe) << 15);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 359 to 374
	value = ((uint32_t)(input[44] & 0x01) << 31) |
			((uint32_t)input[45] << 23) |
			((uint32_t)(input[46] & 0xfe) << 15);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 375 to 390
	value = ((uint32_t)(input[46] & 0x01) << 31) |
			((uint32_t)input[47] << 23) |
			((uint32_t)(input[48] & 0xfe) << 15);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 391 to 406
	value = ((uint32_t)(input[48] & 0x01) << 31) |
			((uint32_t)input[49] << 23) |
			((uint32_t)(input[50] & 0xfe) << 15);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 407 to 422
	value = ((uint32_t)(input[50] & 0x01) << 31) |
			((uint32_t)input[51] << 23) |
			((uint32_t)(input[52] & 0xfe) << 15);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 423 to 438
	value = ((uint32_t)(input[52] & 0x01) << 31) |
			((uint32_t)input[53] << 23) |
			((uint32_t)(input[54] & 0xfe) << 15);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 439 to 454
	value = ((uint32_t)(input[54] & 0x01) << 31) |
			((uint32_t)input[55] << 23) |
			((uint32_t)(input[56] & 0xfe) << 15);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 455 to 470
	value = ((uint32_t)(input[56] & 0x01) << 31) |
			((uint32_t)input[57] << 23) |
			((uint32_t)(input[58] & 0xfe) << 15);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 471 to 486
	value = ((uint32_t)(input[58] & 0x01) << 31) |
			((uint32_t)input[59] << 23) |
			((uint32_t)(input[60] & 0xfe) << 15);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 487 to 502
	value = ((uint32_t)(input[60] & 0x01) << 31) |
			((uint32_t)input[61] << 23) |
			((uint32_t)(input[62] & 0xfe) << 15);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 503 to 518
	value = ((uint32_t)(input[62] & 0x01) << 31) |
			((uint32_t)input[63] << 23) |
			((uint32_t)(input[64] & 0xfe) << 15);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 519 to 534
	value = ((uint32_t)(input[64] & 0x01) << 31) |
			((uint32_t)input[65] << 23) |
			((uint32_t)(input[66] & 0xfe) << 15);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 535 to 550
	value = ((uint32_t)(input[66] & 0x01) << 31) |
			((uint32_t)input[67] << 23) |
			((uint32_t)(input[68] & 0xfe) << 15);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 551 to 566
	value = ((uint32_t)(input[68] & 0x01) << 31) |
			((uint32_t)input[69] << 23) |
			((uint32_t)(input[70] & 0xfe) << 15);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 567 to 582
	value = ((uint32_t)(input[70] & 0x01) << 31) |
			((uint32_t)input[71] << 23) |
			((uint32_t)(input[72] & 0xfe) << 15);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 583 to 598
	value = ((uint32_t)(input[72] & 0x01) << 31) |
			((uint32_t)input[73] << 23) |
			((uint32_t)(input[74] & 0xfe) << 15);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 599 to 614
	value = ((uint32_t)(input[74] & 0x01) << 31) |
			((uint32_t)input[75] << 23) |
			((uint32_t)(input[76] & 0xfe) << 15);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 615 to 630
	value = ((uint32_t)(input[76] & 0x01) << 31) |
			((uint32_t)input[77] << 23) |
			((uint32_t)(input[78] & 0xfe) << 15);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 631 to 646
	value = ((uint32_t)(input[78] & 0x01) << 31) |
			((uint32_t)input[79] << 23) |
			((uint32_t)(input[80] & 0xfe) << 15);
	output[39] = (double)(value >> 16);

	// read output[40]: from bit 647 to 662
	value = ((uint32_t)(input[80] & 0x01) << 31) |
			((uint32_t)input[81] << 23) |
			((uint32_t)(input[82] & 0xfe) << 15);
	output[40] = (double)(value >> 16);
}

static void unpack_42_16bit_signed_0off(const uint8_t * input, double * output, void *closure) {
	// Unpack 42 values into output
	// Values are 16-bit signed
	// Skip 0 bits, read 672 bits of data.
	// Input must be at least 84 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 0 to 15
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)input[1] << 16);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 16 to 31
	value = ((uint32_t)input[2] << 24) |
			((uint32_t)input[3] << 16);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 32 to 47
	value = ((uint32_t)input[4] << 24) |
			((uint32_t)input[5] << 16);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 48 to 63
	value = ((uint32_t)input[6] << 24) |
			((uint32_t)input[7] << 16);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 64 to 79
	value = ((uint32_t)input[8] << 24) |
			((uint32_t)input[9] << 16);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 80 to 95
	value = ((uint32_t)input[10] << 24) |
			((uint32_t)input[11] << 16);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 96 to 111
	value = ((uint32_t)input[12] << 24) |
			((uint32_t)input[13] << 16);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 112 to 127
	value = ((uint32_t)input[14] << 24) |
			((uint32_t)input[15] << 16);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 128 to 143
	value = ((uint32_t)input[16] << 24) |
			((uint32_t)input[17] << 16);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 144 to 159
	value = ((uint32_t)input[18] << 24) |
			((uint32_t)input[19] << 16);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 160 to 175
	value = ((uint32_t)input[20] << 24) |
			((uint32_t)input[21] << 16);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 176 to 191
	value = ((uint32_t)input[22] << 24) |
			((uint32_t)input[23] << 16);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 192 to 207
	value = ((uint32_t)input[24] << 24) |
			((uint32_t)input[25] << 16);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 208 to 223
	value = ((uint32_t)input[26] << 24) |
			((uint32_t)input[27] << 16);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 224 to 239
	value = ((uint32_t)input[28] << 24) |
			((uint32_t)input[29] << 16);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 240 to 255
	value = ((uint32_t)input[30] << 24) |
			((uint32_t)input[31] << 16);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 256 to 271
	value = ((uint32_t)input[32] << 24) |
			((uint32_t)input[33] << 16);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 272 to 287
	value = ((uint32_t)input[34] << 24) |
			((uint32_t)input[35] << 16);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 288 to 303
	value = ((uint32_t)input[36] << 24) |
			((uint32_t)input[37] << 16);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 304 to 319
	value = ((uint32_t)input[38] << 24) |
			((uint32_t)input[39] << 16);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 320 to 335
	value = ((uint32_t)input[40] << 24) |
			((uint32_t)input[41] << 16);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 336 to 351
	value = ((uint32_t)input[42] << 24) |
			((uint32_t)input[43] << 16);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 352 to 367
	value = ((uint32_t)input[44] << 24) |
			((uint32_t)input[45] << 16);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 368 to 383
	value = ((uint32_t)input[46] << 24) |
			((uint32_t)input[47] << 16);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 384 to 399
	value = ((uint32_t)input[48] << 24) |
			((uint32_t)input[49] << 16);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 400 to 415
	value = ((uint32_t)input[50] << 24) |
			((uint32_t)input[51] << 16);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 416 to 431
	value = ((uint32_t)input[52] << 24) |
			((uint32_t)input[53] << 16);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 432 to 447
	value = ((uint32_t)input[54] << 24) |
			((uint32_t)input[55] << 16);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 448 to 463
	value = ((uint32_t)input[56] << 24) |
			((uint32_t)input[57] << 16);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 464 to 479
	value = ((uint32_t)input[58] << 24) |
			((uint32_t)input[59] << 16);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 480 to 495
	value = ((uint32_t)input[60] << 24) |
			((uint32_t)input[61] << 16);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 496 to 511
	value = ((uint32_t)input[62] << 24) |
			((uint32_t)input[63] << 16);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 512 to 527
	value = ((uint32_t)input[64] << 24) |
			((uint32_t)input[65] << 16);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 528 to 543
	value = ((uint32_t)input[66] << 24) |
			((uint32_t)input[67] << 16);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 544 to 559
	value = ((uint32_t)input[68] << 24) |
			((uint32_t)input[69] << 16);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 560 to 575
	value = ((uint32_t)input[70] << 24) |
			((uint32_t)input[71] << 16);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 576 to 591
	value = ((uint32_t)input[72] << 24) |
			((uint32_t)input[73] << 16);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 592 to 607
	value = ((uint32_t)input[74] << 24) |
			((uint32_t)input[75] << 16);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 608 to 623
	value = ((uint32_t)input[76] << 24) |
			((uint32_t)input[77] << 16);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 624 to 639
	value = ((uint32_t)input[78] << 24) |
			((uint32_t)input[79] << 16);
	output[39] = (double)(value >> 16);

	// read output[40]: from bit 640 to 655
	value = ((uint32_t)input[80] << 24) |
			((uint32_t)input[81] << 16);
	output[40] = (double)(value >> 16);

	// read output[41]: from bit 656 to 671
	value = ((uint32_t)input[82] << 24) |
			((uint32_t)input[83] << 16);
	output[41] = (double)(value >> 16);
}

static void unpack_42_16bit_unsigned_0off(const uint8_t * input, double * output, void *closure) {
	// Unpack 42 values into output
	// Values are 16-bit unsigned
	// Skip 0 bits, read 672 bits of data.
	// Input must be at least 84 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 0 to 15
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)input[1] << 16);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 16 to 31
	value = ((uint32_t)input[2] << 24) |
			((uint32_t)input[3] << 16);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 32 to 47
	value = ((uint32_t)input[4] << 24) |
			((uint32_t)input[5] << 16);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 48 to 63
	value = ((uint32_t)input[6] << 24) |
			((uint32_t)input[7] << 16);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 64 to 79
	value = ((uint32_t)input[8] << 24) |
			((uint32_t)input[9] << 16);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 80 to 95
	value = ((uint32_t)input[10] << 24) |
			((uint32_t)input[11] << 16);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 96 to 111
	value = ((uint32_t)input[12] << 24) |
			((uint32_t)input[13] << 16);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 112 to 127
	value = ((uint32_t)input[14] << 24) |
			((uint32_t)input[15] << 16);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 128 to 143
	value = ((uint32_t)input[16] << 24) |
			((uint32_t)input[17] << 16);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 144 to 159
	value = ((uint32_t)input[18] << 24) |
			((uint32_t)input[19] << 16);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 160 to 175
	value = ((uint32_t)input[20] << 24) |
			((uint32_t)input[21] << 16);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 176 to 191
	value = ((uint32_t)input[22] << 24) |
			((uint32_t)input[23] << 16);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 192 to 207
	value = ((uint32_t)input[24] << 24) |
			((uint32_t)input[25] << 16);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 208 to 223
	value = ((uint32_t)input[26] << 24) |
			((uint32_t)input[27] << 16);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 224 to 239
	value = ((uint32_t)input[28] << 24) |
			((uint32_t)input[29] << 16);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 240 to 255
	value = ((uint32_t)input[30] << 24) |
			((uint32_t)input[31] << 16);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 256 to 271
	value = ((uint32_t)input[32] << 24) |
			((uint32_t)input[33] << 16);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 272 to 287
	value = ((uint32_t)input[34] << 24) |
			((uint32_t)input[35] << 16);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 288 to 303
	value = ((uint32_t)input[36] << 24) |
			((uint32_t)input[37] << 16);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 304 to 319
	value = ((uint32_t)input[38] << 24) |
			((uint32_t)input[39] << 16);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 320 to 335
	value = ((uint32_t)input[40] << 24) |
			((uint32_t)input[41] << 16);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 336 to 351
	value = ((uint32_t)input[42] << 24) |
			((uint32_t)input[43] << 16);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 352 to 367
	value = ((uint32_t)input[44] << 24) |
			((uint32_t)input[45] << 16);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 368 to 383
	value = ((uint32_t)input[46] << 24) |
			((uint32_t)input[47] << 16);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 384 to 399
	value = ((uint32_t)input[48] << 24) |
			((uint32_t)input[49] << 16);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 400 to 415
	value = ((uint32_t)input[50] << 24) |
			((uint32_t)input[51] << 16);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 416 to 431
	value = ((uint32_t)input[52] << 24) |
			((uint32_t)input[53] << 16);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 432 to 447
	value = ((uint32_t)input[54] << 24) |
			((uint32_t)input[55] << 16);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 448 to 463
	value = ((uint32_t)input[56] << 24) |
			((uint32_t)input[57] << 16);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 464 to 479
	value = ((uint32_t)input[58] << 24) |
			((uint32_t)input[59] << 16);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 480 to 495
	value = ((uint32_t)input[60] << 24) |
			((uint32_t)input[61] << 16);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 496 to 511
	value = ((uint32_t)input[62] << 24) |
			((uint32_t)input[63] << 16);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 512 to 527
	value = ((uint32_t)input[64] << 24) |
			((uint32_t)input[65] << 16);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 528 to 543
	value = ((uint32_t)input[66] << 24) |
			((uint32_t)input[67] << 16);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 544 to 559
	value = ((uint32_t)input[68] << 24) |
			((uint32_t)input[69] << 16);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 560 to 575
	value = ((uint32_t)input[70] << 24) |
			((uint32_t)input[71] << 16);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 576 to 591
	value = ((uint32_t)input[72] << 24) |
			((uint32_t)input[73] << 16);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 592 to 607
	value = ((uint32_t)input[74] << 24) |
			((uint32_t)input[75] << 16);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 608 to 623
	value = ((uint32_t)input[76] << 24) |
			((uint32_t)input[77] << 16);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 624 to 639
	value = ((uint32_t)input[78] << 24) |
			((uint32_t)input[79] << 16);
	output[39] = (double)(value >> 16);

	// read output[40]: from bit 640 to 655
	value = ((uint32_t)input[80] << 24) |
			((uint32_t)input[81] << 16);
	output[40] = (double)(value >> 16);

	// read output[41]: from bit 656 to 671
	value = ((uint32_t)input[82] << 24) |
			((uint32_t)input[83] << 16);
	output[41] = (double)(value >> 16);
}

static void unpack_42_16bit_signed_1off(const uint8_t * input, double * output, void *closure) {
	// Unpack 42 values into output
	// Values are 16-bit signed
	// Skip 1 bits, read 672 bits of data.
	// Input must be at least 85 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 1 to 16
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)input[1] << 17) |
			((uint32_t)(input[2] & 0x80) << 9);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 17 to 32
	value = ((uint32_t)(input[2] & 0x7f) << 25) |
			((uint32_t)input[3] << 17) |
			((uint32_t)(input[4] & 0x80) << 9);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 33 to 48
	value = ((uint32_t)(input[4] & 0x7f) << 25) |
			((uint32_t)input[5] << 17) |
			((uint32_t)(input[6] & 0x80) << 9);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 49 to 64
	value = ((uint32_t)(input[6] & 0x7f) << 25) |
			((uint32_t)input[7] << 17) |
			((uint32_t)(input[8] & 0x80) << 9);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 65 to 80
	value = ((uint32_t)(input[8] & 0x7f) << 25) |
			((uint32_t)input[9] << 17) |
			((uint32_t)(input[10] & 0x80) << 9);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 81 to 96
	value = ((uint32_t)(input[10] & 0x7f) << 25) |
			((uint32_t)input[11] << 17) |
			((uint32_t)(input[12] & 0x80) << 9);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 97 to 112
	value = ((uint32_t)(input[12] & 0x7f) << 25) |
			((uint32_t)input[13] << 17) |
			((uint32_t)(input[14] & 0x80) << 9);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 113 to 128
	value = ((uint32_t)(input[14] & 0x7f) << 25) |
			((uint32_t)input[15] << 17) |
			((uint32_t)(input[16] & 0x80) << 9);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 129 to 144
	value = ((uint32_t)(input[16] & 0x7f) << 25) |
			((uint32_t)input[17] << 17) |
			((uint32_t)(input[18] & 0x80) << 9);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 145 to 160
	value = ((uint32_t)(input[18] & 0x7f) << 25) |
			((uint32_t)input[19] << 17) |
			((uint32_t)(input[20] & 0x80) << 9);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 161 to 176
	value = ((uint32_t)(input[20] & 0x7f) << 25) |
			((uint32_t)input[21] << 17) |
			((uint32_t)(input[22] & 0x80) << 9);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 177 to 192
	value = ((uint32_t)(input[22] & 0x7f) << 25) |
			((uint32_t)input[23] << 17) |
			((uint32_t)(input[24] & 0x80) << 9);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 193 to 208
	value = ((uint32_t)(input[24] & 0x7f) << 25) |
			((uint32_t)input[25] << 17) |
			((uint32_t)(input[26] & 0x80) << 9);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 209 to 224
	value = ((uint32_t)(input[26] & 0x7f) << 25) |
			((uint32_t)input[27] << 17) |
			((uint32_t)(input[28] & 0x80) << 9);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 225 to 240
	value = ((uint32_t)(input[28] & 0x7f) << 25) |
			((uint32_t)input[29] << 17) |
			((uint32_t)(input[30] & 0x80) << 9);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 241 to 256
	value = ((uint32_t)(input[30] & 0x7f) << 25) |
			((uint32_t)input[31] << 17) |
			((uint32_t)(input[32] & 0x80) << 9);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 257 to 272
	value = ((uint32_t)(input[32] & 0x7f) << 25) |
			((uint32_t)input[33] << 17) |
			((uint32_t)(input[34] & 0x80) << 9);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 273 to 288
	value = ((uint32_t)(input[34] & 0x7f) << 25) |
			((uint32_t)input[35] << 17) |
			((uint32_t)(input[36] & 0x80) << 9);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 289 to 304
	value = ((uint32_t)(input[36] & 0x7f) << 25) |
			((uint32_t)input[37] << 17) |
			((uint32_t)(input[38] & 0x80) << 9);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 305 to 320
	value = ((uint32_t)(input[38] & 0x7f) << 25) |
			((uint32_t)input[39] << 17) |
			((uint32_t)(input[40] & 0x80) << 9);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 321 to 336
	value = ((uint32_t)(input[40] & 0x7f) << 25) |
			((uint32_t)input[41] << 17) |
			((uint32_t)(input[42] & 0x80) << 9);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 337 to 352
	value = ((uint32_t)(input[42] & 0x7f) << 25) |
			((uint32_t)input[43] << 17) |
			((uint32_t)(input[44] & 0x80) << 9);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 353 to 368
	value = ((uint32_t)(input[44] & 0x7f) << 25) |
			((uint32_t)input[45] << 17) |
			((uint32_t)(input[46] & 0x80) << 9);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 369 to 384
	value = ((uint32_t)(input[46] & 0x7f) << 25) |
			((uint32_t)input[47] << 17) |
			((uint32_t)(input[48] & 0x80) << 9);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 385 to 400
	value = ((uint32_t)(input[48] & 0x7f) << 25) |
			((uint32_t)input[49] << 17) |
			((uint32_t)(input[50] & 0x80) << 9);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 401 to 416
	value = ((uint32_t)(input[50] & 0x7f) << 25) |
			((uint32_t)input[51] << 17) |
			((uint32_t)(input[52] & 0x80) << 9);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 417 to 432
	value = ((uint32_t)(input[52] & 0x7f) << 25) |
			((uint32_t)input[53] << 17) |
			((uint32_t)(input[54] & 0x80) << 9);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 433 to 448
	value = ((uint32_t)(input[54] & 0x7f) << 25) |
			((uint32_t)input[55] << 17) |
			((uint32_t)(input[56] & 0x80) << 9);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 449 to 464
	value = ((uint32_t)(input[56] & 0x7f) << 25) |
			((uint32_t)input[57] << 17) |
			((uint32_t)(input[58] & 0x80) << 9);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 465 to 480
	value = ((uint32_t)(input[58] & 0x7f) << 25) |
			((uint32_t)input[59] << 17) |
			((uint32_t)(input[60] & 0x80) << 9);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 481 to 496
	value = ((uint32_t)(input[60] & 0x7f) << 25) |
			((uint32_t)input[61] << 17) |
			((uint32_t)(input[62] & 0x80) << 9);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 497 to 512
	value = ((uint32_t)(input[62] & 0x7f) << 25) |
			((uint32_t)input[63] << 17) |
			((uint32_t)(input[64] & 0x80) << 9);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 513 to 528
	value = ((uint32_t)(input[64] & 0x7f) << 25) |
			((uint32_t)input[65] << 17) |
			((uint32_t)(input[66] & 0x80) << 9);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 529 to 544
	value = ((uint32_t)(input[66] & 0x7f) << 25) |
			((uint32_t)input[67] << 17) |
			((uint32_t)(input[68] & 0x80) << 9);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 545 to 560
	value = ((uint32_t)(input[68] & 0x7f) << 25) |
			((uint32_t)input[69] << 17) |
			((uint32_t)(input[70] & 0x80) << 9);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 561 to 576
	value = ((uint32_t)(input[70] & 0x7f) << 25) |
			((uint32_t)input[71] << 17) |
			((uint32_t)(input[72] & 0x80) << 9);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 577 to 592
	value = ((uint32_t)(input[72] & 0x7f) << 25) |
			((uint32_t)input[73] << 17) |
			((uint32_t)(input[74] & 0x80) << 9);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 593 to 608
	value = ((uint32_t)(input[74] & 0x7f) << 25) |
			((uint32_t)input[75] << 17) |
			((uint32_t)(input[76] & 0x80) << 9);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 609 to 624
	value = ((uint32_t)(input[76] & 0x7f) << 25) |
			((uint32_t)input[77] << 17) |
			((uint32_t)(input[78] & 0x80) << 9);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 625 to 640
	value = ((uint32_t)(input[78] & 0x7f) << 25) |
			((uint32_t)input[79] << 17) |
			((uint32_t)(input[80] & 0x80) << 9);
	output[39] = (double)(value >> 16);

	// read output[40]: from bit 641 to 656
	value = ((uint32_t)(input[80] & 0x7f) << 25) |
			((uint32_t)input[81] << 17) |
			((uint32_t)(input[82] & 0x80) << 9);
	output[40] = (double)(value >> 16);

	// read output[41]: from bit 657 to 672
	value = ((uint32_t)(input[82] & 0x7f) << 25) |
			((uint32_t)input[83] << 17) |
			((uint32_t)(input[84] & 0x80) << 9);
	output[41] = (double)(value >> 16);
}

static void unpack_42_16bit_unsigned_1off(const uint8_t * input, double * output, void *closure) {
	// Unpack 42 values into output
	// Values are 16-bit unsigned
	// Skip 1 bits, read 672 bits of data.
	// Input must be at least 85 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 1 to 16
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)input[1] << 17) |
			((uint32_t)(input[2] & 0x80) << 9);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 17 to 32
	value = ((uint32_t)(input[2] & 0x7f) << 25) |
			((uint32_t)input[3] << 17) |
			((uint32_t)(input[4] & 0x80) << 9);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 33 to 48
	value = ((uint32_t)(input[4] & 0x7f) << 25) |
			((uint32_t)input[5] << 17) |
			((uint32_t)(input[6] & 0x80) << 9);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 49 to 64
	value = ((uint32_t)(input[6] & 0x7f) << 25) |
			((uint32_t)input[7] << 17) |
			((uint32_t)(input[8] & 0x80) << 9);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 65 to 80
	value = ((uint32_t)(input[8] & 0x7f) << 25) |
			((uint32_t)input[9] << 17) |
			((uint32_t)(input[10] & 0x80) << 9);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 81 to 96
	value = ((uint32_t)(input[10] & 0x7f) << 25) |
			((uint32_t)input[11] << 17) |
			((uint32_t)(input[12] & 0x80) << 9);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 97 to 112
	value = ((uint32_t)(input[12] & 0x7f) << 25) |
			((uint32_t)input[13] << 17) |
			((uint32_t)(input[14] & 0x80) << 9);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 113 to 128
	value = ((uint32_t)(input[14] & 0x7f) << 25) |
			((uint32_t)input[15] << 17) |
			((uint32_t)(input[16] & 0x80) << 9);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 129 to 144
	value = ((uint32_t)(input[16] & 0x7f) << 25) |
			((uint32_t)input[17] << 17) |
			((uint32_t)(input[18] & 0x80) << 9);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 145 to 160
	value = ((uint32_t)(input[18] & 0x7f) << 25) |
			((uint32_t)input[19] << 17) |
			((uint32_t)(input[20] & 0x80) << 9);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 161 to 176
	value = ((uint32_t)(input[20] & 0x7f) << 25) |
			((uint32_t)input[21] << 17) |
			((uint32_t)(input[22] & 0x80) << 9);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 177 to 192
	value = ((uint32_t)(input[22] & 0x7f) << 25) |
			((uint32_t)input[23] << 17) |
			((uint32_t)(input[24] & 0x80) << 9);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 193 to 208
	value = ((uint32_t)(input[24] & 0x7f) << 25) |
			((uint32_t)input[25] << 17) |
			((uint32_t)(input[26] & 0x80) << 9);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 209 to 224
	value = ((uint32_t)(input[26] & 0x7f) << 25) |
			((uint32_t)input[27] << 17) |
			((uint32_t)(input[28] & 0x80) << 9);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 225 to 240
	value = ((uint32_t)(input[28] & 0x7f) << 25) |
			((uint32_t)input[29] << 17) |
			((uint32_t)(input[30] & 0x80) << 9);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 241 to 256
	value = ((uint32_t)(input[30] & 0x7f) << 25) |
			((uint32_t)input[31] << 17) |
			((uint32_t)(input[32] & 0x80) << 9);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 257 to 272
	value = ((uint32_t)(input[32] & 0x7f) << 25) |
			((uint32_t)input[33] << 17) |
			((uint32_t)(input[34] & 0x80) << 9);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 273 to 288
	value = ((uint32_t)(input[34] & 0x7f) << 25) |
			((uint32_t)input[35] << 17) |
			((uint32_t)(input[36] & 0x80) << 9);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 289 to 304
	value = ((uint32_t)(input[36] & 0x7f) << 25) |
			((uint32_t)input[37] << 17) |
			((uint32_t)(input[38] & 0x80) << 9);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 305 to 320
	value = ((uint32_t)(input[38] & 0x7f) << 25) |
			((uint32_t)input[39] << 17) |
			((uint32_t)(input[40] & 0x80) << 9);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 321 to 336
	value = ((uint32_t)(input[40] & 0x7f) << 25) |
			((uint32_t)input[41] << 17) |
			((uint32_t)(input[42] & 0x80) << 9);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 337 to 352
	value = ((uint32_t)(input[42] & 0x7f) << 25) |
			((uint32_t)input[43] << 17) |
			((uint32_t)(input[44] & 0x80) << 9);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 353 to 368
	value = ((uint32_t)(input[44] & 0x7f) << 25) |
			((uint32_t)input[45] << 17) |
			((uint32_t)(input[46] & 0x80) << 9);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 369 to 384
	value = ((uint32_t)(input[46] & 0x7f) << 25) |
			((uint32_t)input[47] << 17) |
			((uint32_t)(input[48] & 0x80) << 9);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 385 to 400
	value = ((uint32_t)(input[48] & 0x7f) << 25) |
			((uint32_t)input[49] << 17) |
			((uint32_t)(input[50] & 0x80) << 9);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 401 to 416
	value = ((uint32_t)(input[50] & 0x7f) << 25) |
			((uint32_t)input[51] << 17) |
			((uint32_t)(input[52] & 0x80) << 9);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 417 to 432
	value = ((uint32_t)(input[52] & 0x7f) << 25) |
			((uint32_t)input[53] << 17) |
			((uint32_t)(input[54] & 0x80) << 9);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 433 to 448
	value = ((uint32_t)(input[54] & 0x7f) << 25) |
			((uint32_t)input[55] << 17) |
			((uint32_t)(input[56] & 0x80) << 9);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 449 to 464
	value = ((uint32_t)(input[56] & 0x7f) << 25) |
			((uint32_t)input[57] << 17) |
			((uint32_t)(input[58] & 0x80) << 9);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 465 to 480
	value = ((uint32_t)(input[58] & 0x7f) << 25) |
			((uint32_t)input[59] << 17) |
			((uint32_t)(input[60] & 0x80) << 9);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 481 to 496
	value = ((uint32_t)(input[60] & 0x7f) << 25) |
			((uint32_t)input[61] << 17) |
			((uint32_t)(input[62] & 0x80) << 9);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 497 to 512
	value = ((uint32_t)(input[62] & 0x7f) << 25) |
			((uint32_t)input[63] << 17) |
			((uint32_t)(input[64] & 0x80) << 9);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 513 to 528
	value = ((uint32_t)(input[64] & 0x7f) << 25) |
			((uint32_t)input[65] << 17) |
			((uint32_t)(input[66] & 0x80) << 9);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 529 to 544
	value = ((uint32_t)(input[66] & 0x7f) << 25) |
			((uint32_t)input[67] << 17) |
			((uint32_t)(input[68] & 0x80) << 9);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 545 to 560
	value = ((uint32_t)(input[68] & 0x7f) << 25) |
			((uint32_t)input[69] << 17) |
			((uint32_t)(input[70] & 0x80) << 9);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 561 to 576
	value = ((uint32_t)(input[70] & 0x7f) << 25) |
			((uint32_t)input[71] << 17) |
			((uint32_t)(input[72] & 0x80) << 9);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 577 to 592
	value = ((uint32_t)(input[72] & 0x7f) << 25) |
			((uint32_t)input[73] << 17) |
			((uint32_t)(input[74] & 0x80) << 9);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 593 to 608
	value = ((uint32_t)(input[74] & 0x7f) << 25) |
			((uint32_t)input[75] << 17) |
			((uint32_t)(input[76] & 0x80) << 9);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 609 to 624
	value = ((uint32_t)(input[76] & 0x7f) << 25) |
			((uint32_t)input[77] << 17) |
			((uint32_t)(input[78] & 0x80) << 9);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 625 to 640
	value = ((uint32_t)(input[78] & 0x7f) << 25) |
			((uint32_t)input[79] << 17) |
			((uint32_t)(input[80] & 0x80) << 9);
	output[39] = (double)(value >> 16);

	// read output[40]: from bit 641 to 656
	value = ((uint32_t)(input[80] & 0x7f) << 25) |
			((uint32_t)input[81] << 17) |
			((uint32_t)(input[82] & 0x80) << 9);
	output[40] = (double)(value >> 16);

	// read output[41]: from bit 657 to 672
	value = ((uint32_t)(input[82] & 0x7f) << 25) |
			((uint32_t)input[83] << 17) |
			((uint32_t)(input[84] & 0x80) << 9);
	output[41] = (double)(value >> 16);
}

static void unpack_42_16bit_signed_2off(const uint8_t * input, double * output, void *closure) {
	// Unpack 42 values into output
	// Values are 16-bit signed
	// Skip 2 bits, read 672 bits of data.
	// Input must be at least 85 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 2 to 17
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)input[1] << 18) |
			((uint32_t)(input[2] & 0xc0) << 10);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 18 to 33
	value = ((uint32_t)(input[2] & 0x3f) << 26) |
			((uint32_t)input[3] << 18) |
			((uint32_t)(input[4] & 0xc0) << 10);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 34 to 49
	value = ((uint32_t)(input[4] & 0x3f) << 26) |
			((uint32_t)input[5] << 18) |
			((uint32_t)(input[6] & 0xc0) << 10);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 50 to 65
	value = ((uint32_t)(input[6] & 0x3f) << 26) |
			((uint32_t)input[7] << 18) |
			((uint32_t)(input[8] & 0xc0) << 10);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 66 to 81
	value = ((uint32_t)(input[8] & 0x3f) << 26) |
			((uint32_t)input[9] << 18) |
			((uint32_t)(input[10] & 0xc0) << 10);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 82 to 97
	value = ((uint32_t)(input[10] & 0x3f) << 26) |
			((uint32_t)input[11] << 18) |
			((uint32_t)(input[12] & 0xc0) << 10);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 98 to 113
	value = ((uint32_t)(input[12] & 0x3f) << 26) |
			((uint32_t)input[13] << 18) |
			((uint32_t)(input[14] & 0xc0) << 10);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 114 to 129
	value = ((uint32_t)(input[14] & 0x3f) << 26) |
			((uint32_t)input[15] << 18) |
			((uint32_t)(input[16] & 0xc0) << 10);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 130 to 145
	value = ((uint32_t)(input[16] & 0x3f) << 26) |
			((uint32_t)input[17] << 18) |
			((uint32_t)(input[18] & 0xc0) << 10);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 146 to 161
	value = ((uint32_t)(input[18] & 0x3f) << 26) |
			((uint32_t)input[19] << 18) |
			((uint32_t)(input[20] & 0xc0) << 10);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 162 to 177
	value = ((uint32_t)(input[20] & 0x3f) << 26) |
			((uint32_t)input[21] << 18) |
			((uint32_t)(input[22] & 0xc0) << 10);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 178 to 193
	value = ((uint32_t)(input[22] & 0x3f) << 26) |
			((uint32_t)input[23] << 18) |
			((uint32_t)(input[24] & 0xc0) << 10);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 194 to 209
	value = ((uint32_t)(input[24] & 0x3f) << 26) |
			((uint32_t)input[25] << 18) |
			((uint32_t)(input[26] & 0xc0) << 10);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 210 to 225
	value = ((uint32_t)(input[26] & 0x3f) << 26) |
			((uint32_t)input[27] << 18) |
			((uint32_t)(input[28] & 0xc0) << 10);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 226 to 241
	value = ((uint32_t)(input[28] & 0x3f) << 26) |
			((uint32_t)input[29] << 18) |
			((uint32_t)(input[30] & 0xc0) << 10);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 242 to 257
	value = ((uint32_t)(input[30] & 0x3f) << 26) |
			((uint32_t)input[31] << 18) |
			((uint32_t)(input[32] & 0xc0) << 10);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 258 to 273
	value = ((uint32_t)(input[32] & 0x3f) << 26) |
			((uint32_t)input[33] << 18) |
			((uint32_t)(input[34] & 0xc0) << 10);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 274 to 289
	value = ((uint32_t)(input[34] & 0x3f) << 26) |
			((uint32_t)input[35] << 18) |
			((uint32_t)(input[36] & 0xc0) << 10);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 290 to 305
	value = ((uint32_t)(input[36] & 0x3f) << 26) |
			((uint32_t)input[37] << 18) |
			((uint32_t)(input[38] & 0xc0) << 10);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 306 to 321
	value = ((uint32_t)(input[38] & 0x3f) << 26) |
			((uint32_t)input[39] << 18) |
			((uint32_t)(input[40] & 0xc0) << 10);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 322 to 337
	value = ((uint32_t)(input[40] & 0x3f) << 26) |
			((uint32_t)input[41] << 18) |
			((uint32_t)(input[42] & 0xc0) << 10);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 338 to 353
	value = ((uint32_t)(input[42] & 0x3f) << 26) |
			((uint32_t)input[43] << 18) |
			((uint32_t)(input[44] & 0xc0) << 10);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 354 to 369
	value = ((uint32_t)(input[44] & 0x3f) << 26) |
			((uint32_t)input[45] << 18) |
			((uint32_t)(input[46] & 0xc0) << 10);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 370 to 385
	value = ((uint32_t)(input[46] & 0x3f) << 26) |
			((uint32_t)input[47] << 18) |
			((uint32_t)(input[48] & 0xc0) << 10);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 386 to 401
	value = ((uint32_t)(input[48] & 0x3f) << 26) |
			((uint32_t)input[49] << 18) |
			((uint32_t)(input[50] & 0xc0) << 10);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 402 to 417
	value = ((uint32_t)(input[50] & 0x3f) << 26) |
			((uint32_t)input[51] << 18) |
			((uint32_t)(input[52] & 0xc0) << 10);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 418 to 433
	value = ((uint32_t)(input[52] & 0x3f) << 26) |
			((uint32_t)input[53] << 18) |
			((uint32_t)(input[54] & 0xc0) << 10);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 434 to 449
	value = ((uint32_t)(input[54] & 0x3f) << 26) |
			((uint32_t)input[55] << 18) |
			((uint32_t)(input[56] & 0xc0) << 10);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 450 to 465
	value = ((uint32_t)(input[56] & 0x3f) << 26) |
			((uint32_t)input[57] << 18) |
			((uint32_t)(input[58] & 0xc0) << 10);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 466 to 481
	value = ((uint32_t)(input[58] & 0x3f) << 26) |
			((uint32_t)input[59] << 18) |
			((uint32_t)(input[60] & 0xc0) << 10);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 482 to 497
	value = ((uint32_t)(input[60] & 0x3f) << 26) |
			((uint32_t)input[61] << 18) |
			((uint32_t)(input[62] & 0xc0) << 10);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 498 to 513
	value = ((uint32_t)(input[62] & 0x3f) << 26) |
			((uint32_t)input[63] << 18) |
			((uint32_t)(input[64] & 0xc0) << 10);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 514 to 529
	value = ((uint32_t)(input[64] & 0x3f) << 26) |
			((uint32_t)input[65] << 18) |
			((uint32_t)(input[66] & 0xc0) << 10);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 530 to 545
	value = ((uint32_t)(input[66] & 0x3f) << 26) |
			((uint32_t)input[67] << 18) |
			((uint32_t)(input[68] & 0xc0) << 10);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 546 to 561
	value = ((uint32_t)(input[68] & 0x3f) << 26) |
			((uint32_t)input[69] << 18) |
			((uint32_t)(input[70] & 0xc0) << 10);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 562 to 577
	value = ((uint32_t)(input[70] & 0x3f) << 26) |
			((uint32_t)input[71] << 18) |
			((uint32_t)(input[72] & 0xc0) << 10);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 578 to 593
	value = ((uint32_t)(input[72] & 0x3f) << 26) |
			((uint32_t)input[73] << 18) |
			((uint32_t)(input[74] & 0xc0) << 10);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 594 to 609
	value = ((uint32_t)(input[74] & 0x3f) << 26) |
			((uint32_t)input[75] << 18) |
			((uint32_t)(input[76] & 0xc0) << 10);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 610 to 625
	value = ((uint32_t)(input[76] & 0x3f) << 26) |
			((uint32_t)input[77] << 18) |
			((uint32_t)(input[78] & 0xc0) << 10);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 626 to 641
	value = ((uint32_t)(input[78] & 0x3f) << 26) |
			((uint32_t)input[79] << 18) |
			((uint32_t)(input[80] & 0xc0) << 10);
	output[39] = (double)(value >> 16);

	// read output[40]: from bit 642 to 657
	value = ((uint32_t)(input[80] & 0x3f) << 26) |
			((uint32_t)input[81] << 18) |
			((uint32_t)(input[82] & 0xc0) << 10);
	output[40] = (double)(value >> 16);

	// read output[41]: from bit 658 to 673
	value = ((uint32_t)(input[82] & 0x3f) << 26) |
			((uint32_t)input[83] << 18) |
			((uint32_t)(input[84] & 0xc0) << 10);
	output[41] = (double)(value >> 16);
}

static void unpack_42_16bit_unsigned_2off(const uint8_t * input, double * output, void *closure) {
	// Unpack 42 values into output
	// Values are 16-bit unsigned
	// Skip 2 bits, read 672 bits of data.
	// Input must be at least 85 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 2 to 17
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)input[1] << 18) |
			((uint32_t)(input[2] & 0xc0) << 10);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 18 to 33
	value = ((uint32_t)(input[2] & 0x3f) << 26) |
			((uint32_t)input[3] << 18) |
			((uint32_t)(input[4] & 0xc0) << 10);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 34 to 49
	value = ((uint32_t)(input[4] & 0x3f) << 26) |
			((uint32_t)input[5] << 18) |
			((uint32_t)(input[6] & 0xc0) << 10);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 50 to 65
	value = ((uint32_t)(input[6] & 0x3f) << 26) |
			((uint32_t)input[7] << 18) |
			((uint32_t)(input[8] & 0xc0) << 10);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 66 to 81
	value = ((uint32_t)(input[8] & 0x3f) << 26) |
			((uint32_t)input[9] << 18) |
			((uint32_t)(input[10] & 0xc0) << 10);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 82 to 97
	value = ((uint32_t)(input[10] & 0x3f) << 26) |
			((uint32_t)input[11] << 18) |
			((uint32_t)(input[12] & 0xc0) << 10);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 98 to 113
	value = ((uint32_t)(input[12] & 0x3f) << 26) |
			((uint32_t)input[13] << 18) |
			((uint32_t)(input[14] & 0xc0) << 10);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 114 to 129
	value = ((uint32_t)(input[14] & 0x3f) << 26) |
			((uint32_t)input[15] << 18) |
			((uint32_t)(input[16] & 0xc0) << 10);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 130 to 145
	value = ((uint32_t)(input[16] & 0x3f) << 26) |
			((uint32_t)input[17] << 18) |
			((uint32_t)(input[18] & 0xc0) << 10);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 146 to 161
	value = ((uint32_t)(input[18] & 0x3f) << 26) |
			((uint32_t)input[19] << 18) |
			((uint32_t)(input[20] & 0xc0) << 10);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 162 to 177
	value = ((uint32_t)(input[20] & 0x3f) << 26) |
			((uint32_t)input[21] << 18) |
			((uint32_t)(input[22] & 0xc0) << 10);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 178 to 193
	value = ((uint32_t)(input[22] & 0x3f) << 26) |
			((uint32_t)input[23] << 18) |
			((uint32_t)(input[24] & 0xc0) << 10);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 194 to 209
	value = ((uint32_t)(input[24] & 0x3f) << 26) |
			((uint32_t)input[25] << 18) |
			((uint32_t)(input[26] & 0xc0) << 10);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 210 to 225
	value = ((uint32_t)(input[26] & 0x3f) << 26) |
			((uint32_t)input[27] << 18) |
			((uint32_t)(input[28] & 0xc0) << 10);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 226 to 241
	value = ((uint32_t)(input[28] & 0x3f) << 26) |
			((uint32_t)input[29] << 18) |
			((uint32_t)(input[30] & 0xc0) << 10);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 242 to 257
	value = ((uint32_t)(input[30] & 0x3f) << 26) |
			((uint32_t)input[31] << 18) |
			((uint32_t)(input[32] & 0xc0) << 10);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 258 to 273
	value = ((uint32_t)(input[32] & 0x3f) << 26) |
			((uint32_t)input[33] << 18) |
			((uint32_t)(input[34] & 0xc0) << 10);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 274 to 289
	value = ((uint32_t)(input[34] & 0x3f) << 26) |
			((uint32_t)input[35] << 18) |
			((uint32_t)(input[36] & 0xc0) << 10);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 290 to 305
	value = ((uint32_t)(input[36] & 0x3f) << 26) |
			((uint32_t)input[37] << 18) |
			((uint32_t)(input[38] & 0xc0) << 10);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 306 to 321
	value = ((uint32_t)(input[38] & 0x3f) << 26) |
			((uint32_t)input[39] << 18) |
			((uint32_t)(input[40] & 0xc0) << 10);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 322 to 337
	value = ((uint32_t)(input[40] & 0x3f) << 26) |
			((uint32_t)input[41] << 18) |
			((uint32_t)(input[42] & 0xc0) << 10);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 338 to 353
	value = ((uint32_t)(input[42] & 0x3f) << 26) |
			((uint32_t)input[43] << 18) |
			((uint32_t)(input[44] & 0xc0) << 10);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 354 to 369
	value = ((uint32_t)(input[44] & 0x3f) << 26) |
			((uint32_t)input[45] << 18) |
			((uint32_t)(input[46] & 0xc0) << 10);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 370 to 385
	value = ((uint32_t)(input[46] & 0x3f) << 26) |
			((uint32_t)input[47] << 18) |
			((uint32_t)(input[48] & 0xc0) << 10);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 386 to 401
	value = ((uint32_t)(input[48] & 0x3f) << 26) |
			((uint32_t)input[49] << 18) |
			((uint32_t)(input[50] & 0xc0) << 10);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 402 to 417
	value = ((uint32_t)(input[50] & 0x3f) << 26) |
			((uint32_t)input[51] << 18) |
			((uint32_t)(input[52] & 0xc0) << 10);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 418 to 433
	value = ((uint32_t)(input[52] & 0x3f) << 26) |
			((uint32_t)input[53] << 18) |
			((uint32_t)(input[54] & 0xc0) << 10);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 434 to 449
	value = ((uint32_t)(input[54] & 0x3f) << 26) |
			((uint32_t)input[55] << 18) |
			((uint32_t)(input[56] & 0xc0) << 10);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 450 to 465
	value = ((uint32_t)(input[56] & 0x3f) << 26) |
			((uint32_t)input[57] << 18) |
			((uint32_t)(input[58] & 0xc0) << 10);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 466 to 481
	value = ((uint32_t)(input[58] & 0x3f) << 26) |
			((uint32_t)input[59] << 18) |
			((uint32_t)(input[60] & 0xc0) << 10);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 482 to 497
	value = ((uint32_t)(input[60] & 0x3f) << 26) |
			((uint32_t)input[61] << 18) |
			((uint32_t)(input[62] & 0xc0) << 10);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 498 to 513
	value = ((uint32_t)(input[62] & 0x3f) << 26) |
			((uint32_t)input[63] << 18) |
			((uint32_t)(input[64] & 0xc0) << 10);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 514 to 529
	value = ((uint32_t)(input[64] & 0x3f) << 26) |
			((uint32_t)input[65] << 18) |
			((uint32_t)(input[66] & 0xc0) << 10);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 530 to 545
	value = ((uint32_t)(input[66] & 0x3f) << 26) |
			((uint32_t)input[67] << 18) |
			((uint32_t)(input[68] & 0xc0) << 10);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 546 to 561
	value = ((uint32_t)(input[68] & 0x3f) << 26) |
			((uint32_t)input[69] << 18) |
			((uint32_t)(input[70] & 0xc0) << 10);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 562 to 577
	value = ((uint32_t)(input[70] & 0x3f) << 26) |
			((uint32_t)input[71] << 18) |
			((uint32_t)(input[72] & 0xc0) << 10);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 578 to 593
	value = ((uint32_t)(input[72] & 0x3f) << 26) |
			((uint32_t)input[73] << 18) |
			((uint32_t)(input[74] & 0xc0) << 10);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 594 to 609
	value = ((uint32_t)(input[74] & 0x3f) << 26) |
			((uint32_t)input[75] << 18) |
			((uint32_t)(input[76] & 0xc0) << 10);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 610 to 625
	value = ((uint32_t)(input[76] & 0x3f) << 26) |
			((uint32_t)input[77] << 18) |
			((uint32_t)(input[78] & 0xc0) << 10);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 626 to 641
	value = ((uint32_t)(input[78] & 0x3f) << 26) |
			((uint32_t)input[79] << 18) |
			((uint32_t)(input[80] & 0xc0) << 10);
	output[39] = (double)(value >> 16);

	// read output[40]: from bit 642 to 657
	value = ((uint32_t)(input[80] & 0x3f) << 26) |
			((uint32_t)input[81] << 18) |
			((uint32_t)(input[82] & 0xc0) << 10);
	output[40] = (double)(value >> 16);

	// read output[41]: from bit 658 to 673
	value = ((uint32_t)(input[82] & 0x3f) << 26) |
			((uint32_t)input[83] << 18) |
			((uint32_t)(input[84] & 0xc0) << 10);
	output[41] = (double)(value >> 16);
}

static void unpack_42_16bit_signed_3off(const uint8_t * input, double * output, void *closure) {
	// Unpack 42 values into output
	// Values are 16-bit signed
	// Skip 3 bits, read 672 bits of data.
	// Input must be at least 85 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 3 to 18
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)input[1] << 19) |
			((uint32_t)(input[2] & 0xe0) << 11);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 19 to 34
	value = ((uint32_t)(input[2] & 0x1f) << 27) |
			((uint32_t)input[3] << 19) |
			((uint32_t)(input[4] & 0xe0) << 11);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 35 to 50
	value = ((uint32_t)(input[4] & 0x1f) << 27) |
			((uint32_t)input[5] << 19) |
			((uint32_t)(input[6] & 0xe0) << 11);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 51 to 66
	value = ((uint32_t)(input[6] & 0x1f) << 27) |
			((uint32_t)input[7] << 19) |
			((uint32_t)(input[8] & 0xe0) << 11);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 67 to 82
	value = ((uint32_t)(input[8] & 0x1f) << 27) |
			((uint32_t)input[9] << 19) |
			((uint32_t)(input[10] & 0xe0) << 11);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 83 to 98
	value = ((uint32_t)(input[10] & 0x1f) << 27) |
			((uint32_t)input[11] << 19) |
			((uint32_t)(input[12] & 0xe0) << 11);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 99 to 114
	value = ((uint32_t)(input[12] & 0x1f) << 27) |
			((uint32_t)input[13] << 19) |
			((uint32_t)(input[14] & 0xe0) << 11);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 115 to 130
	value = ((uint32_t)(input[14] & 0x1f) << 27) |
			((uint32_t)input[15] << 19) |
			((uint32_t)(input[16] & 0xe0) << 11);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 131 to 146
	value = ((uint32_t)(input[16] & 0x1f) << 27) |
			((uint32_t)input[17] << 19) |
			((uint32_t)(input[18] & 0xe0) << 11);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 147 to 162
	value = ((uint32_t)(input[18] & 0x1f) << 27) |
			((uint32_t)input[19] << 19) |
			((uint32_t)(input[20] & 0xe0) << 11);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 163 to 178
	value = ((uint32_t)(input[20] & 0x1f) << 27) |
			((uint32_t)input[21] << 19) |
			((uint32_t)(input[22] & 0xe0) << 11);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 179 to 194
	value = ((uint32_t)(input[22] & 0x1f) << 27) |
			((uint32_t)input[23] << 19) |
			((uint32_t)(input[24] & 0xe0) << 11);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 195 to 210
	value = ((uint32_t)(input[24] & 0x1f) << 27) |
			((uint32_t)input[25] << 19) |
			((uint32_t)(input[26] & 0xe0) << 11);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 211 to 226
	value = ((uint32_t)(input[26] & 0x1f) << 27) |
			((uint32_t)input[27] << 19) |
			((uint32_t)(input[28] & 0xe0) << 11);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 227 to 242
	value = ((uint32_t)(input[28] & 0x1f) << 27) |
			((uint32_t)input[29] << 19) |
			((uint32_t)(input[30] & 0xe0) << 11);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 243 to 258
	value = ((uint32_t)(input[30] & 0x1f) << 27) |
			((uint32_t)input[31] << 19) |
			((uint32_t)(input[32] & 0xe0) << 11);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 259 to 274
	value = ((uint32_t)(input[32] & 0x1f) << 27) |
			((uint32_t)input[33] << 19) |
			((uint32_t)(input[34] & 0xe0) << 11);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 275 to 290
	value = ((uint32_t)(input[34] & 0x1f) << 27) |
			((uint32_t)input[35] << 19) |
			((uint32_t)(input[36] & 0xe0) << 11);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 291 to 306
	value = ((uint32_t)(input[36] & 0x1f) << 27) |
			((uint32_t)input[37] << 19) |
			((uint32_t)(input[38] & 0xe0) << 11);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 307 to 322
	value = ((uint32_t)(input[38] & 0x1f) << 27) |
			((uint32_t)input[39] << 19) |
			((uint32_t)(input[40] & 0xe0) << 11);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 323 to 338
	value = ((uint32_t)(input[40] & 0x1f) << 27) |
			((uint32_t)input[41] << 19) |
			((uint32_t)(input[42] & 0xe0) << 11);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 339 to 354
	value = ((uint32_t)(input[42] & 0x1f) << 27) |
			((uint32_t)input[43] << 19) |
			((uint32_t)(input[44] & 0xe0) << 11);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 355 to 370
	value = ((uint32_t)(input[44] & 0x1f) << 27) |
			((uint32_t)input[45] << 19) |
			((uint32_t)(input[46] & 0xe0) << 11);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 371 to 386
	value = ((uint32_t)(input[46] & 0x1f) << 27) |
			((uint32_t)input[47] << 19) |
			((uint32_t)(input[48] & 0xe0) << 11);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 387 to 402
	value = ((uint32_t)(input[48] & 0x1f) << 27) |
			((uint32_t)input[49] << 19) |
			((uint32_t)(input[50] & 0xe0) << 11);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 403 to 418
	value = ((uint32_t)(input[50] & 0x1f) << 27) |
			((uint32_t)input[51] << 19) |
			((uint32_t)(input[52] & 0xe0) << 11);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 419 to 434
	value = ((uint32_t)(input[52] & 0x1f) << 27) |
			((uint32_t)input[53] << 19) |
			((uint32_t)(input[54] & 0xe0) << 11);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 435 to 450
	value = ((uint32_t)(input[54] & 0x1f) << 27) |
			((uint32_t)input[55] << 19) |
			((uint32_t)(input[56] & 0xe0) << 11);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 451 to 466
	value = ((uint32_t)(input[56] & 0x1f) << 27) |
			((uint32_t)input[57] << 19) |
			((uint32_t)(input[58] & 0xe0) << 11);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 467 to 482
	value = ((uint32_t)(input[58] & 0x1f) << 27) |
			((uint32_t)input[59] << 19) |
			((uint32_t)(input[60] & 0xe0) << 11);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 483 to 498
	value = ((uint32_t)(input[60] & 0x1f) << 27) |
			((uint32_t)input[61] << 19) |
			((uint32_t)(input[62] & 0xe0) << 11);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 499 to 514
	value = ((uint32_t)(input[62] & 0x1f) << 27) |
			((uint32_t)input[63] << 19) |
			((uint32_t)(input[64] & 0xe0) << 11);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 515 to 530
	value = ((uint32_t)(input[64] & 0x1f) << 27) |
			((uint32_t)input[65] << 19) |
			((uint32_t)(input[66] & 0xe0) << 11);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 531 to 546
	value = ((uint32_t)(input[66] & 0x1f) << 27) |
			((uint32_t)input[67] << 19) |
			((uint32_t)(input[68] & 0xe0) << 11);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 547 to 562
	value = ((uint32_t)(input[68] & 0x1f) << 27) |
			((uint32_t)input[69] << 19) |
			((uint32_t)(input[70] & 0xe0) << 11);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 563 to 578
	value = ((uint32_t)(input[70] & 0x1f) << 27) |
			((uint32_t)input[71] << 19) |
			((uint32_t)(input[72] & 0xe0) << 11);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 579 to 594
	value = ((uint32_t)(input[72] & 0x1f) << 27) |
			((uint32_t)input[73] << 19) |
			((uint32_t)(input[74] & 0xe0) << 11);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 595 to 610
	value = ((uint32_t)(input[74] & 0x1f) << 27) |
			((uint32_t)input[75] << 19) |
			((uint32_t)(input[76] & 0xe0) << 11);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 611 to 626
	value = ((uint32_t)(input[76] & 0x1f) << 27) |
			((uint32_t)input[77] << 19) |
			((uint32_t)(input[78] & 0xe0) << 11);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 627 to 642
	value = ((uint32_t)(input[78] & 0x1f) << 27) |
			((uint32_t)input[79] << 19) |
			((uint32_t)(input[80] & 0xe0) << 11);
	output[39] = (double)(value >> 16);

	// read output[40]: from bit 643 to 658
	value = ((uint32_t)(input[80] & 0x1f) << 27) |
			((uint32_t)input[81] << 19) |
			((uint32_t)(input[82] & 0xe0) << 11);
	output[40] = (double)(value >> 16);

	// read output[41]: from bit 659 to 674
	value = ((uint32_t)(input[82] & 0x1f) << 27) |
			((uint32_t)input[83] << 19) |
			((uint32_t)(input[84] & 0xe0) << 11);
	output[41] = (double)(value >> 16);
}

static void unpack_42_16bit_unsigned_3off(const uint8_t * input, double * output, void *closure) {
	// Unpack 42 values into output
	// Values are 16-bit unsigned
	// Skip 3 bits, read 672 bits of data.
	// Input must be at least 85 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 3 to 18
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)input[1] << 19) |
			((uint32_t)(input[2] & 0xe0) << 11);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 19 to 34
	value = ((uint32_t)(input[2] & 0x1f) << 27) |
			((uint32_t)input[3] << 19) |
			((uint32_t)(input[4] & 0xe0) << 11);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 35 to 50
	value = ((uint32_t)(input[4] & 0x1f) << 27) |
			((uint32_t)input[5] << 19) |
			((uint32_t)(input[6] & 0xe0) << 11);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 51 to 66
	value = ((uint32_t)(input[6] & 0x1f) << 27) |
			((uint32_t)input[7] << 19) |
			((uint32_t)(input[8] & 0xe0) << 11);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 67 to 82
	value = ((uint32_t)(input[8] & 0x1f) << 27) |
			((uint32_t)input[9] << 19) |
			((uint32_t)(input[10] & 0xe0) << 11);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 83 to 98
	value = ((uint32_t)(input[10] & 0x1f) << 27) |
			((uint32_t)input[11] << 19) |
			((uint32_t)(input[12] & 0xe0) << 11);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 99 to 114
	value = ((uint32_t)(input[12] & 0x1f) << 27) |
			((uint32_t)input[13] << 19) |
			((uint32_t)(input[14] & 0xe0) << 11);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 115 to 130
	value = ((uint32_t)(input[14] & 0x1f) << 27) |
			((uint32_t)input[15] << 19) |
			((uint32_t)(input[16] & 0xe0) << 11);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 131 to 146
	value = ((uint32_t)(input[16] & 0x1f) << 27) |
			((uint32_t)input[17] << 19) |
			((uint32_t)(input[18] & 0xe0) << 11);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 147 to 162
	value = ((uint32_t)(input[18] & 0x1f) << 27) |
			((uint32_t)input[19] << 19) |
			((uint32_t)(input[20] & 0xe0) << 11);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 163 to 178
	value = ((uint32_t)(input[20] & 0x1f) << 27) |
			((uint32_t)input[21] << 19) |
			((uint32_t)(input[22] & 0xe0) << 11);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 179 to 194
	value = ((uint32_t)(input[22] & 0x1f) << 27) |
			((uint32_t)input[23] << 19) |
			((uint32_t)(input[24] & 0xe0) << 11);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 195 to 210
	value = ((uint32_t)(input[24] & 0x1f) << 27) |
			((uint32_t)input[25] << 19) |
			((uint32_t)(input[26] & 0xe0) << 11);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 211 to 226
	value = ((uint32_t)(input[26] & 0x1f) << 27) |
			((uint32_t)input[27] << 19) |
			((uint32_t)(input[28] & 0xe0) << 11);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 227 to 242
	value = ((uint32_t)(input[28] & 0x1f) << 27) |
			((uint32_t)input[29] << 19) |
			((uint32_t)(input[30] & 0xe0) << 11);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 243 to 258
	value = ((uint32_t)(input[30] & 0x1f) << 27) |
			((uint32_t)input[31] << 19) |
			((uint32_t)(input[32] & 0xe0) << 11);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 259 to 274
	value = ((uint32_t)(input[32] & 0x1f) << 27) |
			((uint32_t)input[33] << 19) |
			((uint32_t)(input[34] & 0xe0) << 11);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 275 to 290
	value = ((uint32_t)(input[34] & 0x1f) << 27) |
			((uint32_t)input[35] << 19) |
			((uint32_t)(input[36] & 0xe0) << 11);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 291 to 306
	value = ((uint32_t)(input[36] & 0x1f) << 27) |
			((uint32_t)input[37] << 19) |
			((uint32_t)(input[38] & 0xe0) << 11);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 307 to 322
	value = ((uint32_t)(input[38] & 0x1f) << 27) |
			((uint32_t)input[39] << 19) |
			((uint32_t)(input[40] & 0xe0) << 11);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 323 to 338
	value = ((uint32_t)(input[40] & 0x1f) << 27) |
			((uint32_t)input[41] << 19) |
			((uint32_t)(input[42] & 0xe0) << 11);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 339 to 354
	value = ((uint32_t)(input[42] & 0x1f) << 27) |
			((uint32_t)input[43] << 19) |
			((uint32_t)(input[44] & 0xe0) << 11);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 355 to 370
	value = ((uint32_t)(input[44] & 0x1f) << 27) |
			((uint32_t)input[45] << 19) |
			((uint32_t)(input[46] & 0xe0) << 11);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 371 to 386
	value = ((uint32_t)(input[46] & 0x1f) << 27) |
			((uint32_t)input[47] << 19) |
			((uint32_t)(input[48] & 0xe0) << 11);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 387 to 402
	value = ((uint32_t)(input[48] & 0x1f) << 27) |
			((uint32_t)input[49] << 19) |
			((uint32_t)(input[50] & 0xe0) << 11);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 403 to 418
	value = ((uint32_t)(input[50] & 0x1f) << 27) |
			((uint32_t)input[51] << 19) |
			((uint32_t)(input[52] & 0xe0) << 11);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 419 to 434
	value = ((uint32_t)(input[52] & 0x1f) << 27) |
			((uint32_t)input[53] << 19) |
			((uint32_t)(input[54] & 0xe0) << 11);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 435 to 450
	value = ((uint32_t)(input[54] & 0x1f) << 27) |
			((uint32_t)input[55] << 19) |
			((uint32_t)(input[56] & 0xe0) << 11);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 451 to 466
	value = ((uint32_t)(input[56] & 0x1f) << 27) |
			((uint32_t)input[57] << 19) |
			((uint32_t)(input[58] & 0xe0) << 11);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 467 to 482
	value = ((uint32_t)(input[58] & 0x1f) << 27) |
			((uint32_t)input[59] << 19) |
			((uint32_t)(input[60] & 0xe0) << 11);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 483 to 498
	value = ((uint32_t)(input[60] & 0x1f) << 27) |
			((uint32_t)input[61] << 19) |
			((uint32_t)(input[62] & 0xe0) << 11);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 499 to 514
	value = ((uint32_t)(input[62] & 0x1f) << 27) |
			((uint32_t)input[63] << 19) |
			((uint32_t)(input[64] & 0xe0) << 11);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 515 to 530
	value = ((uint32_t)(input[64] & 0x1f) << 27) |
			((uint32_t)input[65] << 19) |
			((uint32_t)(input[66] & 0xe0) << 11);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 531 to 546
	value = ((uint32_t)(input[66] & 0x1f) << 27) |
			((uint32_t)input[67] << 19) |
			((uint32_t)(input[68] & 0xe0) << 11);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 547 to 562
	value = ((uint32_t)(input[68] & 0x1f) << 27) |
			((uint32_t)input[69] << 19) |
			((uint32_t)(input[70] & 0xe0) << 11);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 563 to 578
	value = ((uint32_t)(input[70] & 0x1f) << 27) |
			((uint32_t)input[71] << 19) |
			((uint32_t)(input[72] & 0xe0) << 11);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 579 to 594
	value = ((uint32_t)(input[72] & 0x1f) << 27) |
			((uint32_t)input[73] << 19) |
			((uint32_t)(input[74] & 0xe0) << 11);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 595 to 610
	value = ((uint32_t)(input[74] & 0x1f) << 27) |
			((uint32_t)input[75] << 19) |
			((uint32_t)(input[76] & 0xe0) << 11);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 611 to 626
	value = ((uint32_t)(input[76] & 0x1f) << 27) |
			((uint32_t)input[77] << 19) |
			((uint32_t)(input[78] & 0xe0) << 11);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 627 to 642
	value = ((uint32_t)(input[78] & 0x1f) << 27) |
			((uint32_t)input[79] << 19) |
			((uint32_t)(input[80] & 0xe0) << 11);
	output[39] = (double)(value >> 16);

	// read output[40]: from bit 643 to 658
	value = ((uint32_t)(input[80] & 0x1f) << 27) |
			((uint32_t)input[81] << 19) |
			((uint32_t)(input[82] & 0xe0) << 11);
	output[40] = (double)(value >> 16);

	// read output[41]: from bit 659 to 674
	value = ((uint32_t)(input[82] & 0x1f) << 27) |
			((uint32_t)input[83] << 19) |
			((uint32_t)(input[84] & 0xe0) << 11);
	output[41] = (double)(value >> 16);
}

static void unpack_42_16bit_signed_4off(const uint8_t * input, double * output, void *closure) {
	// Unpack 42 values into output
	// Values are 16-bit signed
	// Skip 4 bits, read 672 bits of data.
	// Input must be at least 85 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 4 to 19
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20) |
			((uint32_t)(input[2] & 0xf0) << 12);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 20 to 35
	value = ((uint32_t)(input[2] & 0x0f) << 28) |
			((uint32_t)input[3] << 20) |
			((uint32_t)(input[4] & 0xf0) << 12);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 36 to 51
	value = ((uint32_t)(input[4] & 0x0f) << 28) |
			((uint32_t)input[5] << 20) |
			((uint32_t)(input[6] & 0xf0) << 12);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 52 to 67
	value = ((uint32_t)(input[6] & 0x0f) << 28) |
			((uint32_t)input[7] << 20) |
			((uint32_t)(input[8] & 0xf0) << 12);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 68 to 83
	value = ((uint32_t)(input[8] & 0x0f) << 28) |
			((uint32_t)input[9] << 20) |
			((uint32_t)(input[10] & 0xf0) << 12);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 84 to 99
	value = ((uint32_t)(input[10] & 0x0f) << 28) |
			((uint32_t)input[11] << 20) |
			((uint32_t)(input[12] & 0xf0) << 12);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 100 to 115
	value = ((uint32_t)(input[12] & 0x0f) << 28) |
			((uint32_t)input[13] << 20) |
			((uint32_t)(input[14] & 0xf0) << 12);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 116 to 131
	value = ((uint32_t)(input[14] & 0x0f) << 28) |
			((uint32_t)input[15] << 20) |
			((uint32_t)(input[16] & 0xf0) << 12);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 132 to 147
	value = ((uint32_t)(input[16] & 0x0f) << 28) |
			((uint32_t)input[17] << 20) |
			((uint32_t)(input[18] & 0xf0) << 12);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 148 to 163
	value = ((uint32_t)(input[18] & 0x0f) << 28) |
			((uint32_t)input[19] << 20) |
			((uint32_t)(input[20] & 0xf0) << 12);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 164 to 179
	value = ((uint32_t)(input[20] & 0x0f) << 28) |
			((uint32_t)input[21] << 20) |
			((uint32_t)(input[22] & 0xf0) << 12);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 180 to 195
	value = ((uint32_t)(input[22] & 0x0f) << 28) |
			((uint32_t)input[23] << 20) |
			((uint32_t)(input[24] & 0xf0) << 12);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 196 to 211
	value = ((uint32_t)(input[24] & 0x0f) << 28) |
			((uint32_t)input[25] << 20) |
			((uint32_t)(input[26] & 0xf0) << 12);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 212 to 227
	value = ((uint32_t)(input[26] & 0x0f) << 28) |
			((uint32_t)input[27] << 20) |
			((uint32_t)(input[28] & 0xf0) << 12);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 228 to 243
	value = ((uint32_t)(input[28] & 0x0f) << 28) |
			((uint32_t)input[29] << 20) |
			((uint32_t)(input[30] & 0xf0) << 12);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 244 to 259
	value = ((uint32_t)(input[30] & 0x0f) << 28) |
			((uint32_t)input[31] << 20) |
			((uint32_t)(input[32] & 0xf0) << 12);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 260 to 275
	value = ((uint32_t)(input[32] & 0x0f) << 28) |
			((uint32_t)input[33] << 20) |
			((uint32_t)(input[34] & 0xf0) << 12);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 276 to 291
	value = ((uint32_t)(input[34] & 0x0f) << 28) |
			((uint32_t)input[35] << 20) |
			((uint32_t)(input[36] & 0xf0) << 12);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 292 to 307
	value = ((uint32_t)(input[36] & 0x0f) << 28) |
			((uint32_t)input[37] << 20) |
			((uint32_t)(input[38] & 0xf0) << 12);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 308 to 323
	value = ((uint32_t)(input[38] & 0x0f) << 28) |
			((uint32_t)input[39] << 20) |
			((uint32_t)(input[40] & 0xf0) << 12);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 324 to 339
	value = ((uint32_t)(input[40] & 0x0f) << 28) |
			((uint32_t)input[41] << 20) |
			((uint32_t)(input[42] & 0xf0) << 12);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 340 to 355
	value = ((uint32_t)(input[42] & 0x0f) << 28) |
			((uint32_t)input[43] << 20) |
			((uint32_t)(input[44] & 0xf0) << 12);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 356 to 371
	value = ((uint32_t)(input[44] & 0x0f) << 28) |
			((uint32_t)input[45] << 20) |
			((uint32_t)(input[46] & 0xf0) << 12);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 372 to 387
	value = ((uint32_t)(input[46] & 0x0f) << 28) |
			((uint32_t)input[47] << 20) |
			((uint32_t)(input[48] & 0xf0) << 12);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 388 to 403
	value = ((uint32_t)(input[48] & 0x0f) << 28) |
			((uint32_t)input[49] << 20) |
			((uint32_t)(input[50] & 0xf0) << 12);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 404 to 419
	value = ((uint32_t)(input[50] & 0x0f) << 28) |
			((uint32_t)input[51] << 20) |
			((uint32_t)(input[52] & 0xf0) << 12);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 420 to 435
	value = ((uint32_t)(input[52] & 0x0f) << 28) |
			((uint32_t)input[53] << 20) |
			((uint32_t)(input[54] & 0xf0) << 12);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 436 to 451
	value = ((uint32_t)(input[54] & 0x0f) << 28) |
			((uint32_t)input[55] << 20) |
			((uint32_t)(input[56] & 0xf0) << 12);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 452 to 467
	value = ((uint32_t)(input[56] & 0x0f) << 28) |
			((uint32_t)input[57] << 20) |
			((uint32_t)(input[58] & 0xf0) << 12);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 468 to 483
	value = ((uint32_t)(input[58] & 0x0f) << 28) |
			((uint32_t)input[59] << 20) |
			((uint32_t)(input[60] & 0xf0) << 12);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 484 to 499
	value = ((uint32_t)(input[60] & 0x0f) << 28) |
			((uint32_t)input[61] << 20) |
			((uint32_t)(input[62] & 0xf0) << 12);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 500 to 515
	value = ((uint32_t)(input[62] & 0x0f) << 28) |
			((uint32_t)input[63] << 20) |
			((uint32_t)(input[64] & 0xf0) << 12);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 516 to 531
	value = ((uint32_t)(input[64] & 0x0f) << 28) |
			((uint32_t)input[65] << 20) |
			((uint32_t)(input[66] & 0xf0) << 12);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 532 to 547
	value = ((uint32_t)(input[66] & 0x0f) << 28) |
			((uint32_t)input[67] << 20) |
			((uint32_t)(input[68] & 0xf0) << 12);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 548 to 563
	value = ((uint32_t)(input[68] & 0x0f) << 28) |
			((uint32_t)input[69] << 20) |
			((uint32_t)(input[70] & 0xf0) << 12);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 564 to 579
	value = ((uint32_t)(input[70] & 0x0f) << 28) |
			((uint32_t)input[71] << 20) |
			((uint32_t)(input[72] & 0xf0) << 12);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 580 to 595
	value = ((uint32_t)(input[72] & 0x0f) << 28) |
			((uint32_t)input[73] << 20) |
			((uint32_t)(input[74] & 0xf0) << 12);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 596 to 611
	value = ((uint32_t)(input[74] & 0x0f) << 28) |
			((uint32_t)input[75] << 20) |
			((uint32_t)(input[76] & 0xf0) << 12);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 612 to 627
	value = ((uint32_t)(input[76] & 0x0f) << 28) |
			((uint32_t)input[77] << 20) |
			((uint32_t)(input[78] & 0xf0) << 12);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 628 to 643
	value = ((uint32_t)(input[78] & 0x0f) << 28) |
			((uint32_t)input[79] << 20) |
			((uint32_t)(input[80] & 0xf0) << 12);
	output[39] = (double)(value >> 16);

	// read output[40]: from bit 644 to 659
	value = ((uint32_t)(input[80] & 0x0f) << 28) |
			((uint32_t)input[81] << 20) |
			((uint32_t)(input[82] & 0xf0) << 12);
	output[40] = (double)(value >> 16);

	// read output[41]: from bit 660 to 675
	value = ((uint32_t)(input[82] & 0x0f) << 28) |
			((uint32_t)input[83] << 20) |
			((uint32_t)(input[84] & 0xf0) << 12);
	output[41] = (double)(value >> 16);
}

static void unpack_42_16bit_unsigned_4off(const uint8_t * input, double * output, void *closure) {
	// Unpack 42 values into output
	// Values are 16-bit unsigned
	// Skip 4 bits, read 672 bits of data.
	// Input must be at least 85 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 4 to 19
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20) |
			((uint32_t)(input[2] & 0xf0) << 12);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 20 to 35
	value = ((uint32_t)(input[2] & 0x0f) << 28) |
			((uint32_t)input[3] << 20) |
			((uint32_t)(input[4] & 0xf0) << 12);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 36 to 51
	value = ((uint32_t)(input[4] & 0x0f) << 28) |
			((uint32_t)input[5] << 20) |
			((uint32_t)(input[6] & 0xf0) << 12);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 52 to 67
	value = ((uint32_t)(input[6] & 0x0f) << 28) |
			((uint32_t)input[7] << 20) |
			((uint32_t)(input[8] & 0xf0) << 12);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 68 to 83
	value = ((uint32_t)(input[8] & 0x0f) << 28) |
			((uint32_t)input[9] << 20) |
			((uint32_t)(input[10] & 0xf0) << 12);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 84 to 99
	value = ((uint32_t)(input[10] & 0x0f) << 28) |
			((uint32_t)input[11] << 20) |
			((uint32_t)(input[12] & 0xf0) << 12);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 100 to 115
	value = ((uint32_t)(input[12] & 0x0f) << 28) |
			((uint32_t)input[13] << 20) |
			((uint32_t)(input[14] & 0xf0) << 12);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 116 to 131
	value = ((uint32_t)(input[14] & 0x0f) << 28) |
			((uint32_t)input[15] << 20) |
			((uint32_t)(input[16] & 0xf0) << 12);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 132 to 147
	value = ((uint32_t)(input[16] & 0x0f) << 28) |
			((uint32_t)input[17] << 20) |
			((uint32_t)(input[18] & 0xf0) << 12);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 148 to 163
	value = ((uint32_t)(input[18] & 0x0f) << 28) |
			((uint32_t)input[19] << 20) |
			((uint32_t)(input[20] & 0xf0) << 12);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 164 to 179
	value = ((uint32_t)(input[20] & 0x0f) << 28) |
			((uint32_t)input[21] << 20) |
			((uint32_t)(input[22] & 0xf0) << 12);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 180 to 195
	value = ((uint32_t)(input[22] & 0x0f) << 28) |
			((uint32_t)input[23] << 20) |
			((uint32_t)(input[24] & 0xf0) << 12);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 196 to 211
	value = ((uint32_t)(input[24] & 0x0f) << 28) |
			((uint32_t)input[25] << 20) |
			((uint32_t)(input[26] & 0xf0) << 12);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 212 to 227
	value = ((uint32_t)(input[26] & 0x0f) << 28) |
			((uint32_t)input[27] << 20) |
			((uint32_t)(input[28] & 0xf0) << 12);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 228 to 243
	value = ((uint32_t)(input[28] & 0x0f) << 28) |
			((uint32_t)input[29] << 20) |
			((uint32_t)(input[30] & 0xf0) << 12);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 244 to 259
	value = ((uint32_t)(input[30] & 0x0f) << 28) |
			((uint32_t)input[31] << 20) |
			((uint32_t)(input[32] & 0xf0) << 12);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 260 to 275
	value = ((uint32_t)(input[32] & 0x0f) << 28) |
			((uint32_t)input[33] << 20) |
			((uint32_t)(input[34] & 0xf0) << 12);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 276 to 291
	value = ((uint32_t)(input[34] & 0x0f) << 28) |
			((uint32_t)input[35] << 20) |
			((uint32_t)(input[36] & 0xf0) << 12);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 292 to 307
	value = ((uint32_t)(input[36] & 0x0f) << 28) |
			((uint32_t)input[37] << 20) |
			((uint32_t)(input[38] & 0xf0) << 12);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 308 to 323
	value = ((uint32_t)(input[38] & 0x0f) << 28) |
			((uint32_t)input[39] << 20) |
			((uint32_t)(input[40] & 0xf0) << 12);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 324 to 339
	value = ((uint32_t)(input[40] & 0x0f) << 28) |
			((uint32_t)input[41] << 20) |
			((uint32_t)(input[42] & 0xf0) << 12);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 340 to 355
	value = ((uint32_t)(input[42] & 0x0f) << 28) |
			((uint32_t)input[43] << 20) |
			((uint32_t)(input[44] & 0xf0) << 12);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 356 to 371
	value = ((uint32_t)(input[44] & 0x0f) << 28) |
			((uint32_t)input[45] << 20) |
			((uint32_t)(input[46] & 0xf0) << 12);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 372 to 387
	value = ((uint32_t)(input[46] & 0x0f) << 28) |
			((uint32_t)input[47] << 20) |
			((uint32_t)(input[48] & 0xf0) << 12);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 388 to 403
	value = ((uint32_t)(input[48] & 0x0f) << 28) |
			((uint32_t)input[49] << 20) |
			((uint32_t)(input[50] & 0xf0) << 12);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 404 to 419
	value = ((uint32_t)(input[50] & 0x0f) << 28) |
			((uint32_t)input[51] << 20) |
			((uint32_t)(input[52] & 0xf0) << 12);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 420 to 435
	value = ((uint32_t)(input[52] & 0x0f) << 28) |
			((uint32_t)input[53] << 20) |
			((uint32_t)(input[54] & 0xf0) << 12);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 436 to 451
	value = ((uint32_t)(input[54] & 0x0f) << 28) |
			((uint32_t)input[55] << 20) |
			((uint32_t)(input[56] & 0xf0) << 12);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 452 to 467
	value = ((uint32_t)(input[56] & 0x0f) << 28) |
			((uint32_t)input[57] << 20) |
			((uint32_t)(input[58] & 0xf0) << 12);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 468 to 483
	value = ((uint32_t)(input[58] & 0x0f) << 28) |
			((uint32_t)input[59] << 20) |
			((uint32_t)(input[60] & 0xf0) << 12);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 484 to 499
	value = ((uint32_t)(input[60] & 0x0f) << 28) |
			((uint32_t)input[61] << 20) |
			((uint32_t)(input[62] & 0xf0) << 12);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 500 to 515
	value = ((uint32_t)(input[62] & 0x0f) << 28) |
			((uint32_t)input[63] << 20) |
			((uint32_t)(input[64] & 0xf0) << 12);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 516 to 531
	value = ((uint32_t)(input[64] & 0x0f) << 28) |
			((uint32_t)input[65] << 20) |
			((uint32_t)(input[66] & 0xf0) << 12);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 532 to 547
	value = ((uint32_t)(input[66] & 0x0f) << 28) |
			((uint32_t)input[67] << 20) |
			((uint32_t)(input[68] & 0xf0) << 12);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 548 to 563
	value = ((uint32_t)(input[68] & 0x0f) << 28) |
			((uint32_t)input[69] << 20) |
			((uint32_t)(input[70] & 0xf0) << 12);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 564 to 579
	value = ((uint32_t)(input[70] & 0x0f) << 28) |
			((uint32_t)input[71] << 20) |
			((uint32_t)(input[72] & 0xf0) << 12);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 580 to 595
	value = ((uint32_t)(input[72] & 0x0f) << 28) |
			((uint32_t)input[73] << 20) |
			((uint32_t)(input[74] & 0xf0) << 12);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 596 to 611
	value = ((uint32_t)(input[74] & 0x0f) << 28) |
			((uint32_t)input[75] << 20) |
			((uint32_t)(input[76] & 0xf0) << 12);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 612 to 627
	value = ((uint32_t)(input[76] & 0x0f) << 28) |
			((uint32_t)input[77] << 20) |
			((uint32_t)(input[78] & 0xf0) << 12);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 628 to 643
	value = ((uint32_t)(input[78] & 0x0f) << 28) |
			((uint32_t)input[79] << 20) |
			((uint32_t)(input[80] & 0xf0) << 12);
	output[39] = (double)(value >> 16);

	// read output[40]: from bit 644 to 659
	value = ((uint32_t)(input[80] & 0x0f) << 28) |
			((uint32_t)input[81] << 20) |
			((uint32_t)(input[82] & 0xf0) << 12);
	output[40] = (double)(value >> 16);

	// read output[41]: from bit 660 to 675
	value = ((uint32_t)(input[82] & 0x0f) << 28) |
			((uint32_t)input[83] << 20) |
			((uint32_t)(input[84] & 0xf0) << 12);
	output[41] = (double)(value >> 16);
}

static void unpack_42_16bit_signed_5off(const uint8_t * input, double * output, void *closure) {
	// Unpack 42 values into output
	// Values are 16-bit signed
	// Skip 5 bits, read 672 bits of data.
	// Input must be at least 85 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 5 to 20
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)(input[2] & 0xf8) << 13);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 21 to 36
	value = ((uint32_t)(input[2] & 0x07) << 29) |
			((uint32_t)input[3] << 21) |
			((uint32_t)(input[4] & 0xf8) << 13);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 37 to 52
	value = ((uint32_t)(input[4] & 0x07) << 29) |
			((uint32_t)input[5] << 21) |
			((uint32_t)(input[6] & 0xf8) << 13);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 53 to 68
	value = ((uint32_t)(input[6] & 0x07) << 29) |
			((uint32_t)input[7] << 21) |
			((uint32_t)(input[8] & 0xf8) << 13);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 69 to 84
	value = ((uint32_t)(input[8] & 0x07) << 29) |
			((uint32_t)input[9] << 21) |
			((uint32_t)(input[10] & 0xf8) << 13);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 85 to 100
	value = ((uint32_t)(input[10] & 0x07) << 29) |
			((uint32_t)input[11] << 21) |
			((uint32_t)(input[12] & 0xf8) << 13);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 101 to 116
	value = ((uint32_t)(input[12] & 0x07) << 29) |
			((uint32_t)input[13] << 21) |
			((uint32_t)(input[14] & 0xf8) << 13);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 117 to 132
	value = ((uint32_t)(input[14] & 0x07) << 29) |
			((uint32_t)input[15] << 21) |
			((uint32_t)(input[16] & 0xf8) << 13);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 133 to 148
	value = ((uint32_t)(input[16] & 0x07) << 29) |
			((uint32_t)input[17] << 21) |
			((uint32_t)(input[18] & 0xf8) << 13);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 149 to 164
	value = ((uint32_t)(input[18] & 0x07) << 29) |
			((uint32_t)input[19] << 21) |
			((uint32_t)(input[20] & 0xf8) << 13);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 165 to 180
	value = ((uint32_t)(input[20] & 0x07) << 29) |
			((uint32_t)input[21] << 21) |
			((uint32_t)(input[22] & 0xf8) << 13);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 181 to 196
	value = ((uint32_t)(input[22] & 0x07) << 29) |
			((uint32_t)input[23] << 21) |
			((uint32_t)(input[24] & 0xf8) << 13);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 197 to 212
	value = ((uint32_t)(input[24] & 0x07) << 29) |
			((uint32_t)input[25] << 21) |
			((uint32_t)(input[26] & 0xf8) << 13);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 213 to 228
	value = ((uint32_t)(input[26] & 0x07) << 29) |
			((uint32_t)input[27] << 21) |
			((uint32_t)(input[28] & 0xf8) << 13);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 229 to 244
	value = ((uint32_t)(input[28] & 0x07) << 29) |
			((uint32_t)input[29] << 21) |
			((uint32_t)(input[30] & 0xf8) << 13);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 245 to 260
	value = ((uint32_t)(input[30] & 0x07) << 29) |
			((uint32_t)input[31] << 21) |
			((uint32_t)(input[32] & 0xf8) << 13);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 261 to 276
	value = ((uint32_t)(input[32] & 0x07) << 29) |
			((uint32_t)input[33] << 21) |
			((uint32_t)(input[34] & 0xf8) << 13);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 277 to 292
	value = ((uint32_t)(input[34] & 0x07) << 29) |
			((uint32_t)input[35] << 21) |
			((uint32_t)(input[36] & 0xf8) << 13);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 293 to 308
	value = ((uint32_t)(input[36] & 0x07) << 29) |
			((uint32_t)input[37] << 21) |
			((uint32_t)(input[38] & 0xf8) << 13);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 309 to 324
	value = ((uint32_t)(input[38] & 0x07) << 29) |
			((uint32_t)input[39] << 21) |
			((uint32_t)(input[40] & 0xf8) << 13);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 325 to 340
	value = ((uint32_t)(input[40] & 0x07) << 29) |
			((uint32_t)input[41] << 21) |
			((uint32_t)(input[42] & 0xf8) << 13);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 341 to 356
	value = ((uint32_t)(input[42] & 0x07) << 29) |
			((uint32_t)input[43] << 21) |
			((uint32_t)(input[44] & 0xf8) << 13);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 357 to 372
	value = ((uint32_t)(input[44] & 0x07) << 29) |
			((uint32_t)input[45] << 21) |
			((uint32_t)(input[46] & 0xf8) << 13);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 373 to 388
	value = ((uint32_t)(input[46] & 0x07) << 29) |
			((uint32_t)input[47] << 21) |
			((uint32_t)(input[48] & 0xf8) << 13);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 389 to 404
	value = ((uint32_t)(input[48] & 0x07) << 29) |
			((uint32_t)input[49] << 21) |
			((uint32_t)(input[50] & 0xf8) << 13);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 405 to 420
	value = ((uint32_t)(input[50] & 0x07) << 29) |
			((uint32_t)input[51] << 21) |
			((uint32_t)(input[52] & 0xf8) << 13);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 421 to 436
	value = ((uint32_t)(input[52] & 0x07) << 29) |
			((uint32_t)input[53] << 21) |
			((uint32_t)(input[54] & 0xf8) << 13);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 437 to 452
	value = ((uint32_t)(input[54] & 0x07) << 29) |
			((uint32_t)input[55] << 21) |
			((uint32_t)(input[56] & 0xf8) << 13);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 453 to 468
	value = ((uint32_t)(input[56] & 0x07) << 29) |
			((uint32_t)input[57] << 21) |
			((uint32_t)(input[58] & 0xf8) << 13);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 469 to 484
	value = ((uint32_t)(input[58] & 0x07) << 29) |
			((uint32_t)input[59] << 21) |
			((uint32_t)(input[60] & 0xf8) << 13);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 485 to 500
	value = ((uint32_t)(input[60] & 0x07) << 29) |
			((uint32_t)input[61] << 21) |
			((uint32_t)(input[62] & 0xf8) << 13);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 501 to 516
	value = ((uint32_t)(input[62] & 0x07) << 29) |
			((uint32_t)input[63] << 21) |
			((uint32_t)(input[64] & 0xf8) << 13);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 517 to 532
	value = ((uint32_t)(input[64] & 0x07) << 29) |
			((uint32_t)input[65] << 21) |
			((uint32_t)(input[66] & 0xf8) << 13);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 533 to 548
	value = ((uint32_t)(input[66] & 0x07) << 29) |
			((uint32_t)input[67] << 21) |
			((uint32_t)(input[68] & 0xf8) << 13);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 549 to 564
	value = ((uint32_t)(input[68] & 0x07) << 29) |
			((uint32_t)input[69] << 21) |
			((uint32_t)(input[70] & 0xf8) << 13);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 565 to 580
	value = ((uint32_t)(input[70] & 0x07) << 29) |
			((uint32_t)input[71] << 21) |
			((uint32_t)(input[72] & 0xf8) << 13);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 581 to 596
	value = ((uint32_t)(input[72] & 0x07) << 29) |
			((uint32_t)input[73] << 21) |
			((uint32_t)(input[74] & 0xf8) << 13);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 597 to 612
	value = ((uint32_t)(input[74] & 0x07) << 29) |
			((uint32_t)input[75] << 21) |
			((uint32_t)(input[76] & 0xf8) << 13);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 613 to 628
	value = ((uint32_t)(input[76] & 0x07) << 29) |
			((uint32_t)input[77] << 21) |
			((uint32_t)(input[78] & 0xf8) << 13);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 629 to 644
	value = ((uint32_t)(input[78] & 0x07) << 29) |
			((uint32_t)input[79] << 21) |
			((uint32_t)(input[80] & 0xf8) << 13);
	output[39] = (double)(value >> 16);

	// read output[40]: from bit 645 to 660
	value = ((uint32_t)(input[80] & 0x07) << 29) |
			((uint32_t)input[81] << 21) |
			((uint32_t)(input[82] & 0xf8) << 13);
	output[40] = (double)(value >> 16);

	// read output[41]: from bit 661 to 676
	value = ((uint32_t)(input[82] & 0x07) << 29) |
			((uint32_t)input[83] << 21) |
			((uint32_t)(input[84] & 0xf8) << 13);
	output[41] = (double)(value >> 16);
}

static void unpack_42_16bit_unsigned_5off(const uint8_t * input, double * output, void *closure) {
	// Unpack 42 values into output
	// Values are 16-bit unsigned
	// Skip 5 bits, read 672 bits of data.
	// Input must be at least 85 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 5 to 20
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)(input[2] & 0xf8) << 13);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 21 to 36
	value = ((uint32_t)(input[2] & 0x07) << 29) |
			((uint32_t)input[3] << 21) |
			((uint32_t)(input[4] & 0xf8) << 13);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 37 to 52
	value = ((uint32_t)(input[4] & 0x07) << 29) |
			((uint32_t)input[5] << 21) |
			((uint32_t)(input[6] & 0xf8) << 13);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 53 to 68
	value = ((uint32_t)(input[6] & 0x07) << 29) |
			((uint32_t)input[7] << 21) |
			((uint32_t)(input[8] & 0xf8) << 13);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 69 to 84
	value = ((uint32_t)(input[8] & 0x07) << 29) |
			((uint32_t)input[9] << 21) |
			((uint32_t)(input[10] & 0xf8) << 13);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 85 to 100
	value = ((uint32_t)(input[10] & 0x07) << 29) |
			((uint32_t)input[11] << 21) |
			((uint32_t)(input[12] & 0xf8) << 13);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 101 to 116
	value = ((uint32_t)(input[12] & 0x07) << 29) |
			((uint32_t)input[13] << 21) |
			((uint32_t)(input[14] & 0xf8) << 13);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 117 to 132
	value = ((uint32_t)(input[14] & 0x07) << 29) |
			((uint32_t)input[15] << 21) |
			((uint32_t)(input[16] & 0xf8) << 13);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 133 to 148
	value = ((uint32_t)(input[16] & 0x07) << 29) |
			((uint32_t)input[17] << 21) |
			((uint32_t)(input[18] & 0xf8) << 13);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 149 to 164
	value = ((uint32_t)(input[18] & 0x07) << 29) |
			((uint32_t)input[19] << 21) |
			((uint32_t)(input[20] & 0xf8) << 13);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 165 to 180
	value = ((uint32_t)(input[20] & 0x07) << 29) |
			((uint32_t)input[21] << 21) |
			((uint32_t)(input[22] & 0xf8) << 13);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 181 to 196
	value = ((uint32_t)(input[22] & 0x07) << 29) |
			((uint32_t)input[23] << 21) |
			((uint32_t)(input[24] & 0xf8) << 13);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 197 to 212
	value = ((uint32_t)(input[24] & 0x07) << 29) |
			((uint32_t)input[25] << 21) |
			((uint32_t)(input[26] & 0xf8) << 13);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 213 to 228
	value = ((uint32_t)(input[26] & 0x07) << 29) |
			((uint32_t)input[27] << 21) |
			((uint32_t)(input[28] & 0xf8) << 13);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 229 to 244
	value = ((uint32_t)(input[28] & 0x07) << 29) |
			((uint32_t)input[29] << 21) |
			((uint32_t)(input[30] & 0xf8) << 13);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 245 to 260
	value = ((uint32_t)(input[30] & 0x07) << 29) |
			((uint32_t)input[31] << 21) |
			((uint32_t)(input[32] & 0xf8) << 13);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 261 to 276
	value = ((uint32_t)(input[32] & 0x07) << 29) |
			((uint32_t)input[33] << 21) |
			((uint32_t)(input[34] & 0xf8) << 13);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 277 to 292
	value = ((uint32_t)(input[34] & 0x07) << 29) |
			((uint32_t)input[35] << 21) |
			((uint32_t)(input[36] & 0xf8) << 13);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 293 to 308
	value = ((uint32_t)(input[36] & 0x07) << 29) |
			((uint32_t)input[37] << 21) |
			((uint32_t)(input[38] & 0xf8) << 13);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 309 to 324
	value = ((uint32_t)(input[38] & 0x07) << 29) |
			((uint32_t)input[39] << 21) |
			((uint32_t)(input[40] & 0xf8) << 13);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 325 to 340
	value = ((uint32_t)(input[40] & 0x07) << 29) |
			((uint32_t)input[41] << 21) |
			((uint32_t)(input[42] & 0xf8) << 13);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 341 to 356
	value = ((uint32_t)(input[42] & 0x07) << 29) |
			((uint32_t)input[43] << 21) |
			((uint32_t)(input[44] & 0xf8) << 13);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 357 to 372
	value = ((uint32_t)(input[44] & 0x07) << 29) |
			((uint32_t)input[45] << 21) |
			((uint32_t)(input[46] & 0xf8) << 13);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 373 to 388
	value = ((uint32_t)(input[46] & 0x07) << 29) |
			((uint32_t)input[47] << 21) |
			((uint32_t)(input[48] & 0xf8) << 13);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 389 to 404
	value = ((uint32_t)(input[48] & 0x07) << 29) |
			((uint32_t)input[49] << 21) |
			((uint32_t)(input[50] & 0xf8) << 13);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 405 to 420
	value = ((uint32_t)(input[50] & 0x07) << 29) |
			((uint32_t)input[51] << 21) |
			((uint32_t)(input[52] & 0xf8) << 13);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 421 to 436
	value = ((uint32_t)(input[52] & 0x07) << 29) |
			((uint32_t)input[53] << 21) |
			((uint32_t)(input[54] & 0xf8) << 13);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 437 to 452
	value = ((uint32_t)(input[54] & 0x07) << 29) |
			((uint32_t)input[55] << 21) |
			((uint32_t)(input[56] & 0xf8) << 13);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 453 to 468
	value = ((uint32_t)(input[56] & 0x07) << 29) |
			((uint32_t)input[57] << 21) |
			((uint32_t)(input[58] & 0xf8) << 13);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 469 to 484
	value = ((uint32_t)(input[58] & 0x07) << 29) |
			((uint32_t)input[59] << 21) |
			((uint32_t)(input[60] & 0xf8) << 13);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 485 to 500
	value = ((uint32_t)(input[60] & 0x07) << 29) |
			((uint32_t)input[61] << 21) |
			((uint32_t)(input[62] & 0xf8) << 13);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 501 to 516
	value = ((uint32_t)(input[62] & 0x07) << 29) |
			((uint32_t)input[63] << 21) |
			((uint32_t)(input[64] & 0xf8) << 13);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 517 to 532
	value = ((uint32_t)(input[64] & 0x07) << 29) |
			((uint32_t)input[65] << 21) |
			((uint32_t)(input[66] & 0xf8) << 13);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 533 to 548
	value = ((uint32_t)(input[66] & 0x07) << 29) |
			((uint32_t)input[67] << 21) |
			((uint32_t)(input[68] & 0xf8) << 13);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 549 to 564
	value = ((uint32_t)(input[68] & 0x07) << 29) |
			((uint32_t)input[69] << 21) |
			((uint32_t)(input[70] & 0xf8) << 13);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 565 to 580
	value = ((uint32_t)(input[70] & 0x07) << 29) |
			((uint32_t)input[71] << 21) |
			((uint32_t)(input[72] & 0xf8) << 13);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 581 to 596
	value = ((uint32_t)(input[72] & 0x07) << 29) |
			((uint32_t)input[73] << 21) |
			((uint32_t)(input[74] & 0xf8) << 13);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 597 to 612
	value = ((uint32_t)(input[74] & 0x07) << 29) |
			((uint32_t)input[75] << 21) |
			((uint32_t)(input[76] & 0xf8) << 13);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 613 to 628
	value = ((uint32_t)(input[76] & 0x07) << 29) |
			((uint32_t)input[77] << 21) |
			((uint32_t)(input[78] & 0xf8) << 13);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 629 to 644
	value = ((uint32_t)(input[78] & 0x07) << 29) |
			((uint32_t)input[79] << 21) |
			((uint32_t)(input[80] & 0xf8) << 13);
	output[39] = (double)(value >> 16);

	// read output[40]: from bit 645 to 660
	value = ((uint32_t)(input[80] & 0x07) << 29) |
			((uint32_t)input[81] << 21) |
			((uint32_t)(input[82] & 0xf8) << 13);
	output[40] = (double)(value >> 16);

	// read output[41]: from bit 661 to 676
	value = ((uint32_t)(input[82] & 0x07) << 29) |
			((uint32_t)input[83] << 21) |
			((uint32_t)(input[84] & 0xf8) << 13);
	output[41] = (double)(value >> 16);
}

static void unpack_42_16bit_signed_6off(const uint8_t * input, double * output, void *closure) {
	// Unpack 42 values into output
	// Values are 16-bit signed
	// Skip 6 bits, read 672 bits of data.
	// Input must be at least 85 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 6 to 21
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)(input[2] & 0xfc) << 14);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 22 to 37
	value = ((uint32_t)(input[2] & 0x03) << 30) |
			((uint32_t)input[3] << 22) |
			((uint32_t)(input[4] & 0xfc) << 14);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 38 to 53
	value = ((uint32_t)(input[4] & 0x03) << 30) |
			((uint32_t)input[5] << 22) |
			((uint32_t)(input[6] & 0xfc) << 14);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 54 to 69
	value = ((uint32_t)(input[6] & 0x03) << 30) |
			((uint32_t)input[7] << 22) |
			((uint32_t)(input[8] & 0xfc) << 14);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 70 to 85
	value = ((uint32_t)(input[8] & 0x03) << 30) |
			((uint32_t)input[9] << 22) |
			((uint32_t)(input[10] & 0xfc) << 14);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 86 to 101
	value = ((uint32_t)(input[10] & 0x03) << 30) |
			((uint32_t)input[11] << 22) |
			((uint32_t)(input[12] & 0xfc) << 14);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 102 to 117
	value = ((uint32_t)(input[12] & 0x03) << 30) |
			((uint32_t)input[13] << 22) |
			((uint32_t)(input[14] & 0xfc) << 14);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 118 to 133
	value = ((uint32_t)(input[14] & 0x03) << 30) |
			((uint32_t)input[15] << 22) |
			((uint32_t)(input[16] & 0xfc) << 14);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 134 to 149
	value = ((uint32_t)(input[16] & 0x03) << 30) |
			((uint32_t)input[17] << 22) |
			((uint32_t)(input[18] & 0xfc) << 14);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 150 to 165
	value = ((uint32_t)(input[18] & 0x03) << 30) |
			((uint32_t)input[19] << 22) |
			((uint32_t)(input[20] & 0xfc) << 14);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 166 to 181
	value = ((uint32_t)(input[20] & 0x03) << 30) |
			((uint32_t)input[21] << 22) |
			((uint32_t)(input[22] & 0xfc) << 14);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 182 to 197
	value = ((uint32_t)(input[22] & 0x03) << 30) |
			((uint32_t)input[23] << 22) |
			((uint32_t)(input[24] & 0xfc) << 14);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 198 to 213
	value = ((uint32_t)(input[24] & 0x03) << 30) |
			((uint32_t)input[25] << 22) |
			((uint32_t)(input[26] & 0xfc) << 14);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 214 to 229
	value = ((uint32_t)(input[26] & 0x03) << 30) |
			((uint32_t)input[27] << 22) |
			((uint32_t)(input[28] & 0xfc) << 14);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 230 to 245
	value = ((uint32_t)(input[28] & 0x03) << 30) |
			((uint32_t)input[29] << 22) |
			((uint32_t)(input[30] & 0xfc) << 14);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 246 to 261
	value = ((uint32_t)(input[30] & 0x03) << 30) |
			((uint32_t)input[31] << 22) |
			((uint32_t)(input[32] & 0xfc) << 14);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 262 to 277
	value = ((uint32_t)(input[32] & 0x03) << 30) |
			((uint32_t)input[33] << 22) |
			((uint32_t)(input[34] & 0xfc) << 14);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 278 to 293
	value = ((uint32_t)(input[34] & 0x03) << 30) |
			((uint32_t)input[35] << 22) |
			((uint32_t)(input[36] & 0xfc) << 14);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 294 to 309
	value = ((uint32_t)(input[36] & 0x03) << 30) |
			((uint32_t)input[37] << 22) |
			((uint32_t)(input[38] & 0xfc) << 14);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 310 to 325
	value = ((uint32_t)(input[38] & 0x03) << 30) |
			((uint32_t)input[39] << 22) |
			((uint32_t)(input[40] & 0xfc) << 14);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 326 to 341
	value = ((uint32_t)(input[40] & 0x03) << 30) |
			((uint32_t)input[41] << 22) |
			((uint32_t)(input[42] & 0xfc) << 14);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 342 to 357
	value = ((uint32_t)(input[42] & 0x03) << 30) |
			((uint32_t)input[43] << 22) |
			((uint32_t)(input[44] & 0xfc) << 14);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 358 to 373
	value = ((uint32_t)(input[44] & 0x03) << 30) |
			((uint32_t)input[45] << 22) |
			((uint32_t)(input[46] & 0xfc) << 14);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 374 to 389
	value = ((uint32_t)(input[46] & 0x03) << 30) |
			((uint32_t)input[47] << 22) |
			((uint32_t)(input[48] & 0xfc) << 14);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 390 to 405
	value = ((uint32_t)(input[48] & 0x03) << 30) |
			((uint32_t)input[49] << 22) |
			((uint32_t)(input[50] & 0xfc) << 14);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 406 to 421
	value = ((uint32_t)(input[50] & 0x03) << 30) |
			((uint32_t)input[51] << 22) |
			((uint32_t)(input[52] & 0xfc) << 14);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 422 to 437
	value = ((uint32_t)(input[52] & 0x03) << 30) |
			((uint32_t)input[53] << 22) |
			((uint32_t)(input[54] & 0xfc) << 14);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 438 to 453
	value = ((uint32_t)(input[54] & 0x03) << 30) |
			((uint32_t)input[55] << 22) |
			((uint32_t)(input[56] & 0xfc) << 14);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 454 to 469
	value = ((uint32_t)(input[56] & 0x03) << 30) |
			((uint32_t)input[57] << 22) |
			((uint32_t)(input[58] & 0xfc) << 14);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 470 to 485
	value = ((uint32_t)(input[58] & 0x03) << 30) |
			((uint32_t)input[59] << 22) |
			((uint32_t)(input[60] & 0xfc) << 14);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 486 to 501
	value = ((uint32_t)(input[60] & 0x03) << 30) |
			((uint32_t)input[61] << 22) |
			((uint32_t)(input[62] & 0xfc) << 14);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 502 to 517
	value = ((uint32_t)(input[62] & 0x03) << 30) |
			((uint32_t)input[63] << 22) |
			((uint32_t)(input[64] & 0xfc) << 14);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 518 to 533
	value = ((uint32_t)(input[64] & 0x03) << 30) |
			((uint32_t)input[65] << 22) |
			((uint32_t)(input[66] & 0xfc) << 14);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 534 to 549
	value = ((uint32_t)(input[66] & 0x03) << 30) |
			((uint32_t)input[67] << 22) |
			((uint32_t)(input[68] & 0xfc) << 14);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 550 to 565
	value = ((uint32_t)(input[68] & 0x03) << 30) |
			((uint32_t)input[69] << 22) |
			((uint32_t)(input[70] & 0xfc) << 14);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 566 to 581
	value = ((uint32_t)(input[70] & 0x03) << 30) |
			((uint32_t)input[71] << 22) |
			((uint32_t)(input[72] & 0xfc) << 14);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 582 to 597
	value = ((uint32_t)(input[72] & 0x03) << 30) |
			((uint32_t)input[73] << 22) |
			((uint32_t)(input[74] & 0xfc) << 14);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 598 to 613
	value = ((uint32_t)(input[74] & 0x03) << 30) |
			((uint32_t)input[75] << 22) |
			((uint32_t)(input[76] & 0xfc) << 14);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 614 to 629
	value = ((uint32_t)(input[76] & 0x03) << 30) |
			((uint32_t)input[77] << 22) |
			((uint32_t)(input[78] & 0xfc) << 14);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 630 to 645
	value = ((uint32_t)(input[78] & 0x03) << 30) |
			((uint32_t)input[79] << 22) |
			((uint32_t)(input[80] & 0xfc) << 14);
	output[39] = (double)(value >> 16);

	// read output[40]: from bit 646 to 661
	value = ((uint32_t)(input[80] & 0x03) << 30) |
			((uint32_t)input[81] << 22) |
			((uint32_t)(input[82] & 0xfc) << 14);
	output[40] = (double)(value >> 16);

	// read output[41]: from bit 662 to 677
	value = ((uint32_t)(input[82] & 0x03) << 30) |
			((uint32_t)input[83] << 22) |
			((uint32_t)(input[84] & 0xfc) << 14);
	output[41] = (double)(value >> 16);
}

static void unpack_42_16bit_unsigned_6off(const uint8_t * input, double * output, void *closure) {
	// Unpack 42 values into output
	// Values are 16-bit unsigned
	// Skip 6 bits, read 672 bits of data.
	// Input must be at least 85 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 6 to 21
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)(input[2] & 0xfc) << 14);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 22 to 37
	value = ((uint32_t)(input[2] & 0x03) << 30) |
			((uint32_t)input[3] << 22) |
			((uint32_t)(input[4] & 0xfc) << 14);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 38 to 53
	value = ((uint32_t)(input[4] & 0x03) << 30) |
			((uint32_t)input[5] << 22) |
			((uint32_t)(input[6] & 0xfc) << 14);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 54 to 69
	value = ((uint32_t)(input[6] & 0x03) << 30) |
			((uint32_t)input[7] << 22) |
			((uint32_t)(input[8] & 0xfc) << 14);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 70 to 85
	value = ((uint32_t)(input[8] & 0x03) << 30) |
			((uint32_t)input[9] << 22) |
			((uint32_t)(input[10] & 0xfc) << 14);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 86 to 101
	value = ((uint32_t)(input[10] & 0x03) << 30) |
			((uint32_t)input[11] << 22) |
			((uint32_t)(input[12] & 0xfc) << 14);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 102 to 117
	value = ((uint32_t)(input[12] & 0x03) << 30) |
			((uint32_t)input[13] << 22) |
			((uint32_t)(input[14] & 0xfc) << 14);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 118 to 133
	value = ((uint32_t)(input[14] & 0x03) << 30) |
			((uint32_t)input[15] << 22) |
			((uint32_t)(input[16] & 0xfc) << 14);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 134 to 149
	value = ((uint32_t)(input[16] & 0x03) << 30) |
			((uint32_t)input[17] << 22) |
			((uint32_t)(input[18] & 0xfc) << 14);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 150 to 165
	value = ((uint32_t)(input[18] & 0x03) << 30) |
			((uint32_t)input[19] << 22) |
			((uint32_t)(input[20] & 0xfc) << 14);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 166 to 181
	value = ((uint32_t)(input[20] & 0x03) << 30) |
			((uint32_t)input[21] << 22) |
			((uint32_t)(input[22] & 0xfc) << 14);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 182 to 197
	value = ((uint32_t)(input[22] & 0x03) << 30) |
			((uint32_t)input[23] << 22) |
			((uint32_t)(input[24] & 0xfc) << 14);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 198 to 213
	value = ((uint32_t)(input[24] & 0x03) << 30) |
			((uint32_t)input[25] << 22) |
			((uint32_t)(input[26] & 0xfc) << 14);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 214 to 229
	value = ((uint32_t)(input[26] & 0x03) << 30) |
			((uint32_t)input[27] << 22) |
			((uint32_t)(input[28] & 0xfc) << 14);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 230 to 245
	value = ((uint32_t)(input[28] & 0x03) << 30) |
			((uint32_t)input[29] << 22) |
			((uint32_t)(input[30] & 0xfc) << 14);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 246 to 261
	value = ((uint32_t)(input[30] & 0x03) << 30) |
			((uint32_t)input[31] << 22) |
			((uint32_t)(input[32] & 0xfc) << 14);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 262 to 277
	value = ((uint32_t)(input[32] & 0x03) << 30) |
			((uint32_t)input[33] << 22) |
			((uint32_t)(input[34] & 0xfc) << 14);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 278 to 293
	value = ((uint32_t)(input[34] & 0x03) << 30) |
			((uint32_t)input[35] << 22) |
			((uint32_t)(input[36] & 0xfc) << 14);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 294 to 309
	value = ((uint32_t)(input[36] & 0x03) << 30) |
			((uint32_t)input[37] << 22) |
			((uint32_t)(input[38] & 0xfc) << 14);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 310 to 325
	value = ((uint32_t)(input[38] & 0x03) << 30) |
			((uint32_t)input[39] << 22) |
			((uint32_t)(input[40] & 0xfc) << 14);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 326 to 341
	value = ((uint32_t)(input[40] & 0x03) << 30) |
			((uint32_t)input[41] << 22) |
			((uint32_t)(input[42] & 0xfc) << 14);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 342 to 357
	value = ((uint32_t)(input[42] & 0x03) << 30) |
			((uint32_t)input[43] << 22) |
			((uint32_t)(input[44] & 0xfc) << 14);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 358 to 373
	value = ((uint32_t)(input[44] & 0x03) << 30) |
			((uint32_t)input[45] << 22) |
			((uint32_t)(input[46] & 0xfc) << 14);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 374 to 389
	value = ((uint32_t)(input[46] & 0x03) << 30) |
			((uint32_t)input[47] << 22) |
			((uint32_t)(input[48] & 0xfc) << 14);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 390 to 405
	value = ((uint32_t)(input[48] & 0x03) << 30) |
			((uint32_t)input[49] << 22) |
			((uint32_t)(input[50] & 0xfc) << 14);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 406 to 421
	value = ((uint32_t)(input[50] & 0x03) << 30) |
			((uint32_t)input[51] << 22) |
			((uint32_t)(input[52] & 0xfc) << 14);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 422 to 437
	value = ((uint32_t)(input[52] & 0x03) << 30) |
			((uint32_t)input[53] << 22) |
			((uint32_t)(input[54] & 0xfc) << 14);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 438 to 453
	value = ((uint32_t)(input[54] & 0x03) << 30) |
			((uint32_t)input[55] << 22) |
			((uint32_t)(input[56] & 0xfc) << 14);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 454 to 469
	value = ((uint32_t)(input[56] & 0x03) << 30) |
			((uint32_t)input[57] << 22) |
			((uint32_t)(input[58] & 0xfc) << 14);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 470 to 485
	value = ((uint32_t)(input[58] & 0x03) << 30) |
			((uint32_t)input[59] << 22) |
			((uint32_t)(input[60] & 0xfc) << 14);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 486 to 501
	value = ((uint32_t)(input[60] & 0x03) << 30) |
			((uint32_t)input[61] << 22) |
			((uint32_t)(input[62] & 0xfc) << 14);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 502 to 517
	value = ((uint32_t)(input[62] & 0x03) << 30) |
			((uint32_t)input[63] << 22) |
			((uint32_t)(input[64] & 0xfc) << 14);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 518 to 533
	value = ((uint32_t)(input[64] & 0x03) << 30) |
			((uint32_t)input[65] << 22) |
			((uint32_t)(input[66] & 0xfc) << 14);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 534 to 549
	value = ((uint32_t)(input[66] & 0x03) << 30) |
			((uint32_t)input[67] << 22) |
			((uint32_t)(input[68] & 0xfc) << 14);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 550 to 565
	value = ((uint32_t)(input[68] & 0x03) << 30) |
			((uint32_t)input[69] << 22) |
			((uint32_t)(input[70] & 0xfc) << 14);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 566 to 581
	value = ((uint32_t)(input[70] & 0x03) << 30) |
			((uint32_t)input[71] << 22) |
			((uint32_t)(input[72] & 0xfc) << 14);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 582 to 597
	value = ((uint32_t)(input[72] & 0x03) << 30) |
			((uint32_t)input[73] << 22) |
			((uint32_t)(input[74] & 0xfc) << 14);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 598 to 613
	value = ((uint32_t)(input[74] & 0x03) << 30) |
			((uint32_t)input[75] << 22) |
			((uint32_t)(input[76] & 0xfc) << 14);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 614 to 629
	value = ((uint32_t)(input[76] & 0x03) << 30) |
			((uint32_t)input[77] << 22) |
			((uint32_t)(input[78] & 0xfc) << 14);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 630 to 645
	value = ((uint32_t)(input[78] & 0x03) << 30) |
			((uint32_t)input[79] << 22) |
			((uint32_t)(input[80] & 0xfc) << 14);
	output[39] = (double)(value >> 16);

	// read output[40]: from bit 646 to 661
	value = ((uint32_t)(input[80] & 0x03) << 30) |
			((uint32_t)input[81] << 22) |
			((uint32_t)(input[82] & 0xfc) << 14);
	output[40] = (double)(value >> 16);

	// read output[41]: from bit 662 to 677
	value = ((uint32_t)(input[82] & 0x03) << 30) |
			((uint32_t)input[83] << 22) |
			((uint32_t)(input[84] & 0xfc) << 14);
	output[41] = (double)(value >> 16);
}

static void unpack_42_16bit_signed_7off(const uint8_t * input, double * output, void *closure) {
	// Unpack 42 values into output
	// Values are 16-bit signed
	// Skip 7 bits, read 672 bits of data.
	// Input must be at least 85 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 7 to 22
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)(input[2] & 0xfe) << 15);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 23 to 38
	value = ((uint32_t)(input[2] & 0x01) << 31) |
			((uint32_t)input[3] << 23) |
			((uint32_t)(input[4] & 0xfe) << 15);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 39 to 54
	value = ((uint32_t)(input[4] & 0x01) << 31) |
			((uint32_t)input[5] << 23) |
			((uint32_t)(input[6] & 0xfe) << 15);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 55 to 70
	value = ((uint32_t)(input[6] & 0x01) << 31) |
			((uint32_t)input[7] << 23) |
			((uint32_t)(input[8] & 0xfe) << 15);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 71 to 86
	value = ((uint32_t)(input[8] & 0x01) << 31) |
			((uint32_t)input[9] << 23) |
			((uint32_t)(input[10] & 0xfe) << 15);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 87 to 102
	value = ((uint32_t)(input[10] & 0x01) << 31) |
			((uint32_t)input[11] << 23) |
			((uint32_t)(input[12] & 0xfe) << 15);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 103 to 118
	value = ((uint32_t)(input[12] & 0x01) << 31) |
			((uint32_t)input[13] << 23) |
			((uint32_t)(input[14] & 0xfe) << 15);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 119 to 134
	value = ((uint32_t)(input[14] & 0x01) << 31) |
			((uint32_t)input[15] << 23) |
			((uint32_t)(input[16] & 0xfe) << 15);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 135 to 150
	value = ((uint32_t)(input[16] & 0x01) << 31) |
			((uint32_t)input[17] << 23) |
			((uint32_t)(input[18] & 0xfe) << 15);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 151 to 166
	value = ((uint32_t)(input[18] & 0x01) << 31) |
			((uint32_t)input[19] << 23) |
			((uint32_t)(input[20] & 0xfe) << 15);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 167 to 182
	value = ((uint32_t)(input[20] & 0x01) << 31) |
			((uint32_t)input[21] << 23) |
			((uint32_t)(input[22] & 0xfe) << 15);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 183 to 198
	value = ((uint32_t)(input[22] & 0x01) << 31) |
			((uint32_t)input[23] << 23) |
			((uint32_t)(input[24] & 0xfe) << 15);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 199 to 214
	value = ((uint32_t)(input[24] & 0x01) << 31) |
			((uint32_t)input[25] << 23) |
			((uint32_t)(input[26] & 0xfe) << 15);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 215 to 230
	value = ((uint32_t)(input[26] & 0x01) << 31) |
			((uint32_t)input[27] << 23) |
			((uint32_t)(input[28] & 0xfe) << 15);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 231 to 246
	value = ((uint32_t)(input[28] & 0x01) << 31) |
			((uint32_t)input[29] << 23) |
			((uint32_t)(input[30] & 0xfe) << 15);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 247 to 262
	value = ((uint32_t)(input[30] & 0x01) << 31) |
			((uint32_t)input[31] << 23) |
			((uint32_t)(input[32] & 0xfe) << 15);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 263 to 278
	value = ((uint32_t)(input[32] & 0x01) << 31) |
			((uint32_t)input[33] << 23) |
			((uint32_t)(input[34] & 0xfe) << 15);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 279 to 294
	value = ((uint32_t)(input[34] & 0x01) << 31) |
			((uint32_t)input[35] << 23) |
			((uint32_t)(input[36] & 0xfe) << 15);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 295 to 310
	value = ((uint32_t)(input[36] & 0x01) << 31) |
			((uint32_t)input[37] << 23) |
			((uint32_t)(input[38] & 0xfe) << 15);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 311 to 326
	value = ((uint32_t)(input[38] & 0x01) << 31) |
			((uint32_t)input[39] << 23) |
			((uint32_t)(input[40] & 0xfe) << 15);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 327 to 342
	value = ((uint32_t)(input[40] & 0x01) << 31) |
			((uint32_t)input[41] << 23) |
			((uint32_t)(input[42] & 0xfe) << 15);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 343 to 358
	value = ((uint32_t)(input[42] & 0x01) << 31) |
			((uint32_t)input[43] << 23) |
			((uint32_t)(input[44] & 0xfe) << 15);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 359 to 374
	value = ((uint32_t)(input[44] & 0x01) << 31) |
			((uint32_t)input[45] << 23) |
			((uint32_t)(input[46] & 0xfe) << 15);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 375 to 390
	value = ((uint32_t)(input[46] & 0x01) << 31) |
			((uint32_t)input[47] << 23) |
			((uint32_t)(input[48] & 0xfe) << 15);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 391 to 406
	value = ((uint32_t)(input[48] & 0x01) << 31) |
			((uint32_t)input[49] << 23) |
			((uint32_t)(input[50] & 0xfe) << 15);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 407 to 422
	value = ((uint32_t)(input[50] & 0x01) << 31) |
			((uint32_t)input[51] << 23) |
			((uint32_t)(input[52] & 0xfe) << 15);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 423 to 438
	value = ((uint32_t)(input[52] & 0x01) << 31) |
			((uint32_t)input[53] << 23) |
			((uint32_t)(input[54] & 0xfe) << 15);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 439 to 454
	value = ((uint32_t)(input[54] & 0x01) << 31) |
			((uint32_t)input[55] << 23) |
			((uint32_t)(input[56] & 0xfe) << 15);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 455 to 470
	value = ((uint32_t)(input[56] & 0x01) << 31) |
			((uint32_t)input[57] << 23) |
			((uint32_t)(input[58] & 0xfe) << 15);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 471 to 486
	value = ((uint32_t)(input[58] & 0x01) << 31) |
			((uint32_t)input[59] << 23) |
			((uint32_t)(input[60] & 0xfe) << 15);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 487 to 502
	value = ((uint32_t)(input[60] & 0x01) << 31) |
			((uint32_t)input[61] << 23) |
			((uint32_t)(input[62] & 0xfe) << 15);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 503 to 518
	value = ((uint32_t)(input[62] & 0x01) << 31) |
			((uint32_t)input[63] << 23) |
			((uint32_t)(input[64] & 0xfe) << 15);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 519 to 534
	value = ((uint32_t)(input[64] & 0x01) << 31) |
			((uint32_t)input[65] << 23) |
			((uint32_t)(input[66] & 0xfe) << 15);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 535 to 550
	value = ((uint32_t)(input[66] & 0x01) << 31) |
			((uint32_t)input[67] << 23) |
			((uint32_t)(input[68] & 0xfe) << 15);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 551 to 566
	value = ((uint32_t)(input[68] & 0x01) << 31) |
			((uint32_t)input[69] << 23) |
			((uint32_t)(input[70] & 0xfe) << 15);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 567 to 582
	value = ((uint32_t)(input[70] & 0x01) << 31) |
			((uint32_t)input[71] << 23) |
			((uint32_t)(input[72] & 0xfe) << 15);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 583 to 598
	value = ((uint32_t)(input[72] & 0x01) << 31) |
			((uint32_t)input[73] << 23) |
			((uint32_t)(input[74] & 0xfe) << 15);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 599 to 614
	value = ((uint32_t)(input[74] & 0x01) << 31) |
			((uint32_t)input[75] << 23) |
			((uint32_t)(input[76] & 0xfe) << 15);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 615 to 630
	value = ((uint32_t)(input[76] & 0x01) << 31) |
			((uint32_t)input[77] << 23) |
			((uint32_t)(input[78] & 0xfe) << 15);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 631 to 646
	value = ((uint32_t)(input[78] & 0x01) << 31) |
			((uint32_t)input[79] << 23) |
			((uint32_t)(input[80] & 0xfe) << 15);
	output[39] = (double)(value >> 16);

	// read output[40]: from bit 647 to 662
	value = ((uint32_t)(input[80] & 0x01) << 31) |
			((uint32_t)input[81] << 23) |
			((uint32_t)(input[82] & 0xfe) << 15);
	output[40] = (double)(value >> 16);

	// read output[41]: from bit 663 to 678
	value = ((uint32_t)(input[82] & 0x01) << 31) |
			((uint32_t)input[83] << 23) |
			((uint32_t)(input[84] & 0xfe) << 15);
	output[41] = (double)(value >> 16);
}

static void unpack_42_16bit_unsigned_7off(const uint8_t * input, double * output, void *closure) {
	// Unpack 42 values into output
	// Values are 16-bit unsigned
	// Skip 7 bits, read 672 bits of data.
	// Input must be at least 85 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 7 to 22
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)(input[2] & 0xfe) << 15);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 23 to 38
	value = ((uint32_t)(input[2] & 0x01) << 31) |
			((uint32_t)input[3] << 23) |
			((uint32_t)(input[4] & 0xfe) << 15);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 39 to 54
	value = ((uint32_t)(input[4] & 0x01) << 31) |
			((uint32_t)input[5] << 23) |
			((uint32_t)(input[6] & 0xfe) << 15);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 55 to 70
	value = ((uint32_t)(input[6] & 0x01) << 31) |
			((uint32_t)input[7] << 23) |
			((uint32_t)(input[8] & 0xfe) << 15);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 71 to 86
	value = ((uint32_t)(input[8] & 0x01) << 31) |
			((uint32_t)input[9] << 23) |
			((uint32_t)(input[10] & 0xfe) << 15);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 87 to 102
	value = ((uint32_t)(input[10] & 0x01) << 31) |
			((uint32_t)input[11] << 23) |
			((uint32_t)(input[12] & 0xfe) << 15);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 103 to 118
	value = ((uint32_t)(input[12] & 0x01) << 31) |
			((uint32_t)input[13] << 23) |
			((uint32_t)(input[14] & 0xfe) << 15);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 119 to 134
	value = ((uint32_t)(input[14] & 0x01) << 31) |
			((uint32_t)input[15] << 23) |
			((uint32_t)(input[16] & 0xfe) << 15);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 135 to 150
	value = ((uint32_t)(input[16] & 0x01) << 31) |
			((uint32_t)input[17] << 23) |
			((uint32_t)(input[18] & 0xfe) << 15);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 151 to 166
	value = ((uint32_t)(input[18] & 0x01) << 31) |
			((uint32_t)input[19] << 23) |
			((uint32_t)(input[20] & 0xfe) << 15);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 167 to 182
	value = ((uint32_t)(input[20] & 0x01) << 31) |
			((uint32_t)input[21] << 23) |
			((uint32_t)(input[22] & 0xfe) << 15);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 183 to 198
	value = ((uint32_t)(input[22] & 0x01) << 31) |
			((uint32_t)input[23] << 23) |
			((uint32_t)(input[24] & 0xfe) << 15);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 199 to 214
	value = ((uint32_t)(input[24] & 0x01) << 31) |
			((uint32_t)input[25] << 23) |
			((uint32_t)(input[26] & 0xfe) << 15);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 215 to 230
	value = ((uint32_t)(input[26] & 0x01) << 31) |
			((uint32_t)input[27] << 23) |
			((uint32_t)(input[28] & 0xfe) << 15);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 231 to 246
	value = ((uint32_t)(input[28] & 0x01) << 31) |
			((uint32_t)input[29] << 23) |
			((uint32_t)(input[30] & 0xfe) << 15);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 247 to 262
	value = ((uint32_t)(input[30] & 0x01) << 31) |
			((uint32_t)input[31] << 23) |
			((uint32_t)(input[32] & 0xfe) << 15);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 263 to 278
	value = ((uint32_t)(input[32] & 0x01) << 31) |
			((uint32_t)input[33] << 23) |
			((uint32_t)(input[34] & 0xfe) << 15);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 279 to 294
	value = ((uint32_t)(input[34] & 0x01) << 31) |
			((uint32_t)input[35] << 23) |
			((uint32_t)(input[36] & 0xfe) << 15);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 295 to 310
	value = ((uint32_t)(input[36] & 0x01) << 31) |
			((uint32_t)input[37] << 23) |
			((uint32_t)(input[38] & 0xfe) << 15);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 311 to 326
	value = ((uint32_t)(input[38] & 0x01) << 31) |
			((uint32_t)input[39] << 23) |
			((uint32_t)(input[40] & 0xfe) << 15);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 327 to 342
	value = ((uint32_t)(input[40] & 0x01) << 31) |
			((uint32_t)input[41] << 23) |
			((uint32_t)(input[42] & 0xfe) << 15);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 343 to 358
	value = ((uint32_t)(input[42] & 0x01) << 31) |
			((uint32_t)input[43] << 23) |
			((uint32_t)(input[44] & 0xfe) << 15);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 359 to 374
	value = ((uint32_t)(input[44] & 0x01) << 31) |
			((uint32_t)input[45] << 23) |
			((uint32_t)(input[46] & 0xfe) << 15);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 375 to 390
	value = ((uint32_t)(input[46] & 0x01) << 31) |
			((uint32_t)input[47] << 23) |
			((uint32_t)(input[48] & 0xfe) << 15);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 391 to 406
	value = ((uint32_t)(input[48] & 0x01) << 31) |
			((uint32_t)input[49] << 23) |
			((uint32_t)(input[50] & 0xfe) << 15);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 407 to 422
	value = ((uint32_t)(input[50] & 0x01) << 31) |
			((uint32_t)input[51] << 23) |
			((uint32_t)(input[52] & 0xfe) << 15);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 423 to 438
	value = ((uint32_t)(input[52] & 0x01) << 31) |
			((uint32_t)input[53] << 23) |
			((uint32_t)(input[54] & 0xfe) << 15);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 439 to 454
	value = ((uint32_t)(input[54] & 0x01) << 31) |
			((uint32_t)input[55] << 23) |
			((uint32_t)(input[56] & 0xfe) << 15);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 455 to 470
	value = ((uint32_t)(input[56] & 0x01) << 31) |
			((uint32_t)input[57] << 23) |
			((uint32_t)(input[58] & 0xfe) << 15);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 471 to 486
	value = ((uint32_t)(input[58] & 0x01) << 31) |
			((uint32_t)input[59] << 23) |
			((uint32_t)(input[60] & 0xfe) << 15);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 487 to 502
	value = ((uint32_t)(input[60] & 0x01) << 31) |
			((uint32_t)input[61] << 23) |
			((uint32_t)(input[62] & 0xfe) << 15);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 503 to 518
	value = ((uint32_t)(input[62] & 0x01) << 31) |
			((uint32_t)input[63] << 23) |
			((uint32_t)(input[64] & 0xfe) << 15);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 519 to 534
	value = ((uint32_t)(input[64] & 0x01) << 31) |
			((uint32_t)input[65] << 23) |
			((uint32_t)(input[66] & 0xfe) << 15);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 535 to 550
	value = ((uint32_t)(input[66] & 0x01) << 31) |
			((uint32_t)input[67] << 23) |
			((uint32_t)(input[68] & 0xfe) << 15);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 551 to 566
	value = ((uint32_t)(input[68] & 0x01) << 31) |
			((uint32_t)input[69] << 23) |
			((uint32_t)(input[70] & 0xfe) << 15);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 567 to 582
	value = ((uint32_t)(input[70] & 0x01) << 31) |
			((uint32_t)input[71] << 23) |
			((uint32_t)(input[72] & 0xfe) << 15);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 583 to 598
	value = ((uint32_t)(input[72] & 0x01) << 31) |
			((uint32_t)input[73] << 23) |
			((uint32_t)(input[74] & 0xfe) << 15);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 599 to 614
	value = ((uint32_t)(input[74] & 0x01) << 31) |
			((uint32_t)input[75] << 23) |
			((uint32_t)(input[76] & 0xfe) << 15);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 615 to 630
	value = ((uint32_t)(input[76] & 0x01) << 31) |
			((uint32_t)input[77] << 23) |
			((uint32_t)(input[78] & 0xfe) << 15);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 631 to 646
	value = ((uint32_t)(input[78] & 0x01) << 31) |
			((uint32_t)input[79] << 23) |
			((uint32_t)(input[80] & 0xfe) << 15);
	output[39] = (double)(value >> 16);

	// read output[40]: from bit 647 to 662
	value = ((uint32_t)(input[80] & 0x01) << 31) |
			((uint32_t)input[81] << 23) |
			((uint32_t)(input[82] & 0xfe) << 15);
	output[40] = (double)(value >> 16);

	// read output[41]: from bit 663 to 678
	value = ((uint32_t)(input[82] & 0x01) << 31) |
			((uint32_t)input[83] << 23) |
			((uint32_t)(input[84] & 0xfe) << 15);
	output[41] = (double)(value >> 16);
}

static void unpack_43_16bit_signed_0off(const uint8_t * input, double * output, void *closure) {
	// Unpack 43 values into output
	// Values are 16-bit signed
	// Skip 0 bits, read 688 bits of data.
	// Input must be at least 86 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 0 to 15
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)input[1] << 16);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 16 to 31
	value = ((uint32_t)input[2] << 24) |
			((uint32_t)input[3] << 16);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 32 to 47
	value = ((uint32_t)input[4] << 24) |
			((uint32_t)input[5] << 16);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 48 to 63
	value = ((uint32_t)input[6] << 24) |
			((uint32_t)input[7] << 16);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 64 to 79
	value = ((uint32_t)input[8] << 24) |
			((uint32_t)input[9] << 16);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 80 to 95
	value = ((uint32_t)input[10] << 24) |
			((uint32_t)input[11] << 16);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 96 to 111
	value = ((uint32_t)input[12] << 24) |
			((uint32_t)input[13] << 16);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 112 to 127
	value = ((uint32_t)input[14] << 24) |
			((uint32_t)input[15] << 16);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 128 to 143
	value = ((uint32_t)input[16] << 24) |
			((uint32_t)input[17] << 16);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 144 to 159
	value = ((uint32_t)input[18] << 24) |
			((uint32_t)input[19] << 16);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 160 to 175
	value = ((uint32_t)input[20] << 24) |
			((uint32_t)input[21] << 16);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 176 to 191
	value = ((uint32_t)input[22] << 24) |
			((uint32_t)input[23] << 16);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 192 to 207
	value = ((uint32_t)input[24] << 24) |
			((uint32_t)input[25] << 16);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 208 to 223
	value = ((uint32_t)input[26] << 24) |
			((uint32_t)input[27] << 16);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 224 to 239
	value = ((uint32_t)input[28] << 24) |
			((uint32_t)input[29] << 16);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 240 to 255
	value = ((uint32_t)input[30] << 24) |
			((uint32_t)input[31] << 16);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 256 to 271
	value = ((uint32_t)input[32] << 24) |
			((uint32_t)input[33] << 16);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 272 to 287
	value = ((uint32_t)input[34] << 24) |
			((uint32_t)input[35] << 16);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 288 to 303
	value = ((uint32_t)input[36] << 24) |
			((uint32_t)input[37] << 16);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 304 to 319
	value = ((uint32_t)input[38] << 24) |
			((uint32_t)input[39] << 16);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 320 to 335
	value = ((uint32_t)input[40] << 24) |
			((uint32_t)input[41] << 16);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 336 to 351
	value = ((uint32_t)input[42] << 24) |
			((uint32_t)input[43] << 16);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 352 to 367
	value = ((uint32_t)input[44] << 24) |
			((uint32_t)input[45] << 16);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 368 to 383
	value = ((uint32_t)input[46] << 24) |
			((uint32_t)input[47] << 16);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 384 to 399
	value = ((uint32_t)input[48] << 24) |
			((uint32_t)input[49] << 16);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 400 to 415
	value = ((uint32_t)input[50] << 24) |
			((uint32_t)input[51] << 16);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 416 to 431
	value = ((uint32_t)input[52] << 24) |
			((uint32_t)input[53] << 16);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 432 to 447
	value = ((uint32_t)input[54] << 24) |
			((uint32_t)input[55] << 16);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 448 to 463
	value = ((uint32_t)input[56] << 24) |
			((uint32_t)input[57] << 16);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 464 to 479
	value = ((uint32_t)input[58] << 24) |
			((uint32_t)input[59] << 16);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 480 to 495
	value = ((uint32_t)input[60] << 24) |
			((uint32_t)input[61] << 16);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 496 to 511
	value = ((uint32_t)input[62] << 24) |
			((uint32_t)input[63] << 16);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 512 to 527
	value = ((uint32_t)input[64] << 24) |
			((uint32_t)input[65] << 16);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 528 to 543
	value = ((uint32_t)input[66] << 24) |
			((uint32_t)input[67] << 16);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 544 to 559
	value = ((uint32_t)input[68] << 24) |
			((uint32_t)input[69] << 16);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 560 to 575
	value = ((uint32_t)input[70] << 24) |
			((uint32_t)input[71] << 16);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 576 to 591
	value = ((uint32_t)input[72] << 24) |
			((uint32_t)input[73] << 16);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 592 to 607
	value = ((uint32_t)input[74] << 24) |
			((uint32_t)input[75] << 16);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 608 to 623
	value = ((uint32_t)input[76] << 24) |
			((uint32_t)input[77] << 16);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 624 to 639
	value = ((uint32_t)input[78] << 24) |
			((uint32_t)input[79] << 16);
	output[39] = (double)(value >> 16);

	// read output[40]: from bit 640 to 655
	value = ((uint32_t)input[80] << 24) |
			((uint32_t)input[81] << 16);
	output[40] = (double)(value >> 16);

	// read output[41]: from bit 656 to 671
	value = ((uint32_t)input[82] << 24) |
			((uint32_t)input[83] << 16);
	output[41] = (double)(value >> 16);

	// read output[42]: from bit 672 to 687
	value = ((uint32_t)input[84] << 24) |
			((uint32_t)input[85] << 16);
	output[42] = (double)(value >> 16);
}

static void unpack_43_16bit_unsigned_0off(const uint8_t * input, double * output, void *closure) {
	// Unpack 43 values into output
	// Values are 16-bit unsigned
	// Skip 0 bits, read 688 bits of data.
	// Input must be at least 86 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 0 to 15
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)input[1] << 16);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 16 to 31
	value = ((uint32_t)input[2] << 24) |
			((uint32_t)input[3] << 16);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 32 to 47
	value = ((uint32_t)input[4] << 24) |
			((uint32_t)input[5] << 16);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 48 to 63
	value = ((uint32_t)input[6] << 24) |
			((uint32_t)input[7] << 16);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 64 to 79
	value = ((uint32_t)input[8] << 24) |
			((uint32_t)input[9] << 16);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 80 to 95
	value = ((uint32_t)input[10] << 24) |
			((uint32_t)input[11] << 16);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 96 to 111
	value = ((uint32_t)input[12] << 24) |
			((uint32_t)input[13] << 16);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 112 to 127
	value = ((uint32_t)input[14] << 24) |
			((uint32_t)input[15] << 16);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 128 to 143
	value = ((uint32_t)input[16] << 24) |
			((uint32_t)input[17] << 16);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 144 to 159
	value = ((uint32_t)input[18] << 24) |
			((uint32_t)input[19] << 16);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 160 to 175
	value = ((uint32_t)input[20] << 24) |
			((uint32_t)input[21] << 16);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 176 to 191
	value = ((uint32_t)input[22] << 24) |
			((uint32_t)input[23] << 16);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 192 to 207
	value = ((uint32_t)input[24] << 24) |
			((uint32_t)input[25] << 16);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 208 to 223
	value = ((uint32_t)input[26] << 24) |
			((uint32_t)input[27] << 16);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 224 to 239
	value = ((uint32_t)input[28] << 24) |
			((uint32_t)input[29] << 16);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 240 to 255
	value = ((uint32_t)input[30] << 24) |
			((uint32_t)input[31] << 16);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 256 to 271
	value = ((uint32_t)input[32] << 24) |
			((uint32_t)input[33] << 16);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 272 to 287
	value = ((uint32_t)input[34] << 24) |
			((uint32_t)input[35] << 16);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 288 to 303
	value = ((uint32_t)input[36] << 24) |
			((uint32_t)input[37] << 16);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 304 to 319
	value = ((uint32_t)input[38] << 24) |
			((uint32_t)input[39] << 16);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 320 to 335
	value = ((uint32_t)input[40] << 24) |
			((uint32_t)input[41] << 16);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 336 to 351
	value = ((uint32_t)input[42] << 24) |
			((uint32_t)input[43] << 16);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 352 to 367
	value = ((uint32_t)input[44] << 24) |
			((uint32_t)input[45] << 16);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 368 to 383
	value = ((uint32_t)input[46] << 24) |
			((uint32_t)input[47] << 16);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 384 to 399
	value = ((uint32_t)input[48] << 24) |
			((uint32_t)input[49] << 16);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 400 to 415
	value = ((uint32_t)input[50] << 24) |
			((uint32_t)input[51] << 16);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 416 to 431
	value = ((uint32_t)input[52] << 24) |
			((uint32_t)input[53] << 16);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 432 to 447
	value = ((uint32_t)input[54] << 24) |
			((uint32_t)input[55] << 16);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 448 to 463
	value = ((uint32_t)input[56] << 24) |
			((uint32_t)input[57] << 16);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 464 to 479
	value = ((uint32_t)input[58] << 24) |
			((uint32_t)input[59] << 16);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 480 to 495
	value = ((uint32_t)input[60] << 24) |
			((uint32_t)input[61] << 16);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 496 to 511
	value = ((uint32_t)input[62] << 24) |
			((uint32_t)input[63] << 16);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 512 to 527
	value = ((uint32_t)input[64] << 24) |
			((uint32_t)input[65] << 16);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 528 to 543
	value = ((uint32_t)input[66] << 24) |
			((uint32_t)input[67] << 16);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 544 to 559
	value = ((uint32_t)input[68] << 24) |
			((uint32_t)input[69] << 16);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 560 to 575
	value = ((uint32_t)input[70] << 24) |
			((uint32_t)input[71] << 16);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 576 to 591
	value = ((uint32_t)input[72] << 24) |
			((uint32_t)input[73] << 16);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 592 to 607
	value = ((uint32_t)input[74] << 24) |
			((uint32_t)input[75] << 16);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 608 to 623
	value = ((uint32_t)input[76] << 24) |
			((uint32_t)input[77] << 16);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 624 to 639
	value = ((uint32_t)input[78] << 24) |
			((uint32_t)input[79] << 16);
	output[39] = (double)(value >> 16);

	// read output[40]: from bit 640 to 655
	value = ((uint32_t)input[80] << 24) |
			((uint32_t)input[81] << 16);
	output[40] = (double)(value >> 16);

	// read output[41]: from bit 656 to 671
	value = ((uint32_t)input[82] << 24) |
			((uint32_t)input[83] << 16);
	output[41] = (double)(value >> 16);

	// read output[42]: from bit 672 to 687
	value = ((uint32_t)input[84] << 24) |
			((uint32_t)input[85] << 16);
	output[42] = (double)(value >> 16);
}

static void unpack_43_16bit_signed_1off(const uint8_t * input, double * output, void *closure) {
	// Unpack 43 values into output
	// Values are 16-bit signed
	// Skip 1 bits, read 688 bits of data.
	// Input must be at least 87 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 1 to 16
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)input[1] << 17) |
			((uint32_t)(input[2] & 0x80) << 9);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 17 to 32
	value = ((uint32_t)(input[2] & 0x7f) << 25) |
			((uint32_t)input[3] << 17) |
			((uint32_t)(input[4] & 0x80) << 9);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 33 to 48
	value = ((uint32_t)(input[4] & 0x7f) << 25) |
			((uint32_t)input[5] << 17) |
			((uint32_t)(input[6] & 0x80) << 9);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 49 to 64
	value = ((uint32_t)(input[6] & 0x7f) << 25) |
			((uint32_t)input[7] << 17) |
			((uint32_t)(input[8] & 0x80) << 9);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 65 to 80
	value = ((uint32_t)(input[8] & 0x7f) << 25) |
			((uint32_t)input[9] << 17) |
			((uint32_t)(input[10] & 0x80) << 9);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 81 to 96
	value = ((uint32_t)(input[10] & 0x7f) << 25) |
			((uint32_t)input[11] << 17) |
			((uint32_t)(input[12] & 0x80) << 9);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 97 to 112
	value = ((uint32_t)(input[12] & 0x7f) << 25) |
			((uint32_t)input[13] << 17) |
			((uint32_t)(input[14] & 0x80) << 9);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 113 to 128
	value = ((uint32_t)(input[14] & 0x7f) << 25) |
			((uint32_t)input[15] << 17) |
			((uint32_t)(input[16] & 0x80) << 9);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 129 to 144
	value = ((uint32_t)(input[16] & 0x7f) << 25) |
			((uint32_t)input[17] << 17) |
			((uint32_t)(input[18] & 0x80) << 9);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 145 to 160
	value = ((uint32_t)(input[18] & 0x7f) << 25) |
			((uint32_t)input[19] << 17) |
			((uint32_t)(input[20] & 0x80) << 9);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 161 to 176
	value = ((uint32_t)(input[20] & 0x7f) << 25) |
			((uint32_t)input[21] << 17) |
			((uint32_t)(input[22] & 0x80) << 9);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 177 to 192
	value = ((uint32_t)(input[22] & 0x7f) << 25) |
			((uint32_t)input[23] << 17) |
			((uint32_t)(input[24] & 0x80) << 9);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 193 to 208
	value = ((uint32_t)(input[24] & 0x7f) << 25) |
			((uint32_t)input[25] << 17) |
			((uint32_t)(input[26] & 0x80) << 9);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 209 to 224
	value = ((uint32_t)(input[26] & 0x7f) << 25) |
			((uint32_t)input[27] << 17) |
			((uint32_t)(input[28] & 0x80) << 9);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 225 to 240
	value = ((uint32_t)(input[28] & 0x7f) << 25) |
			((uint32_t)input[29] << 17) |
			((uint32_t)(input[30] & 0x80) << 9);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 241 to 256
	value = ((uint32_t)(input[30] & 0x7f) << 25) |
			((uint32_t)input[31] << 17) |
			((uint32_t)(input[32] & 0x80) << 9);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 257 to 272
	value = ((uint32_t)(input[32] & 0x7f) << 25) |
			((uint32_t)input[33] << 17) |
			((uint32_t)(input[34] & 0x80) << 9);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 273 to 288
	value = ((uint32_t)(input[34] & 0x7f) << 25) |
			((uint32_t)input[35] << 17) |
			((uint32_t)(input[36] & 0x80) << 9);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 289 to 304
	value = ((uint32_t)(input[36] & 0x7f) << 25) |
			((uint32_t)input[37] << 17) |
			((uint32_t)(input[38] & 0x80) << 9);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 305 to 320
	value = ((uint32_t)(input[38] & 0x7f) << 25) |
			((uint32_t)input[39] << 17) |
			((uint32_t)(input[40] & 0x80) << 9);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 321 to 336
	value = ((uint32_t)(input[40] & 0x7f) << 25) |
			((uint32_t)input[41] << 17) |
			((uint32_t)(input[42] & 0x80) << 9);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 337 to 352
	value = ((uint32_t)(input[42] & 0x7f) << 25) |
			((uint32_t)input[43] << 17) |
			((uint32_t)(input[44] & 0x80) << 9);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 353 to 368
	value = ((uint32_t)(input[44] & 0x7f) << 25) |
			((uint32_t)input[45] << 17) |
			((uint32_t)(input[46] & 0x80) << 9);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 369 to 384
	value = ((uint32_t)(input[46] & 0x7f) << 25) |
			((uint32_t)input[47] << 17) |
			((uint32_t)(input[48] & 0x80) << 9);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 385 to 400
	value = ((uint32_t)(input[48] & 0x7f) << 25) |
			((uint32_t)input[49] << 17) |
			((uint32_t)(input[50] & 0x80) << 9);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 401 to 416
	value = ((uint32_t)(input[50] & 0x7f) << 25) |
			((uint32_t)input[51] << 17) |
			((uint32_t)(input[52] & 0x80) << 9);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 417 to 432
	value = ((uint32_t)(input[52] & 0x7f) << 25) |
			((uint32_t)input[53] << 17) |
			((uint32_t)(input[54] & 0x80) << 9);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 433 to 448
	value = ((uint32_t)(input[54] & 0x7f) << 25) |
			((uint32_t)input[55] << 17) |
			((uint32_t)(input[56] & 0x80) << 9);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 449 to 464
	value = ((uint32_t)(input[56] & 0x7f) << 25) |
			((uint32_t)input[57] << 17) |
			((uint32_t)(input[58] & 0x80) << 9);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 465 to 480
	value = ((uint32_t)(input[58] & 0x7f) << 25) |
			((uint32_t)input[59] << 17) |
			((uint32_t)(input[60] & 0x80) << 9);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 481 to 496
	value = ((uint32_t)(input[60] & 0x7f) << 25) |
			((uint32_t)input[61] << 17) |
			((uint32_t)(input[62] & 0x80) << 9);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 497 to 512
	value = ((uint32_t)(input[62] & 0x7f) << 25) |
			((uint32_t)input[63] << 17) |
			((uint32_t)(input[64] & 0x80) << 9);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 513 to 528
	value = ((uint32_t)(input[64] & 0x7f) << 25) |
			((uint32_t)input[65] << 17) |
			((uint32_t)(input[66] & 0x80) << 9);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 529 to 544
	value = ((uint32_t)(input[66] & 0x7f) << 25) |
			((uint32_t)input[67] << 17) |
			((uint32_t)(input[68] & 0x80) << 9);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 545 to 560
	value = ((uint32_t)(input[68] & 0x7f) << 25) |
			((uint32_t)input[69] << 17) |
			((uint32_t)(input[70] & 0x80) << 9);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 561 to 576
	value = ((uint32_t)(input[70] & 0x7f) << 25) |
			((uint32_t)input[71] << 17) |
			((uint32_t)(input[72] & 0x80) << 9);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 577 to 592
	value = ((uint32_t)(input[72] & 0x7f) << 25) |
			((uint32_t)input[73] << 17) |
			((uint32_t)(input[74] & 0x80) << 9);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 593 to 608
	value = ((uint32_t)(input[74] & 0x7f) << 25) |
			((uint32_t)input[75] << 17) |
			((uint32_t)(input[76] & 0x80) << 9);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 609 to 624
	value = ((uint32_t)(input[76] & 0x7f) << 25) |
			((uint32_t)input[77] << 17) |
			((uint32_t)(input[78] & 0x80) << 9);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 625 to 640
	value = ((uint32_t)(input[78] & 0x7f) << 25) |
			((uint32_t)input[79] << 17) |
			((uint32_t)(input[80] & 0x80) << 9);
	output[39] = (double)(value >> 16);

	// read output[40]: from bit 641 to 656
	value = ((uint32_t)(input[80] & 0x7f) << 25) |
			((uint32_t)input[81] << 17) |
			((uint32_t)(input[82] & 0x80) << 9);
	output[40] = (double)(value >> 16);

	// read output[41]: from bit 657 to 672
	value = ((uint32_t)(input[82] & 0x7f) << 25) |
			((uint32_t)input[83] << 17) |
			((uint32_t)(input[84] & 0x80) << 9);
	output[41] = (double)(value >> 16);

	// read output[42]: from bit 673 to 688
	value = ((uint32_t)(input[84] & 0x7f) << 25) |
			((uint32_t)input[85] << 17) |
			((uint32_t)(input[86] & 0x80) << 9);
	output[42] = (double)(value >> 16);
}

static void unpack_43_16bit_unsigned_1off(const uint8_t * input, double * output, void *closure) {
	// Unpack 43 values into output
	// Values are 16-bit unsigned
	// Skip 1 bits, read 688 bits of data.
	// Input must be at least 87 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 1 to 16
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)input[1] << 17) |
			((uint32_t)(input[2] & 0x80) << 9);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 17 to 32
	value = ((uint32_t)(input[2] & 0x7f) << 25) |
			((uint32_t)input[3] << 17) |
			((uint32_t)(input[4] & 0x80) << 9);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 33 to 48
	value = ((uint32_t)(input[4] & 0x7f) << 25) |
			((uint32_t)input[5] << 17) |
			((uint32_t)(input[6] & 0x80) << 9);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 49 to 64
	value = ((uint32_t)(input[6] & 0x7f) << 25) |
			((uint32_t)input[7] << 17) |
			((uint32_t)(input[8] & 0x80) << 9);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 65 to 80
	value = ((uint32_t)(input[8] & 0x7f) << 25) |
			((uint32_t)input[9] << 17) |
			((uint32_t)(input[10] & 0x80) << 9);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 81 to 96
	value = ((uint32_t)(input[10] & 0x7f) << 25) |
			((uint32_t)input[11] << 17) |
			((uint32_t)(input[12] & 0x80) << 9);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 97 to 112
	value = ((uint32_t)(input[12] & 0x7f) << 25) |
			((uint32_t)input[13] << 17) |
			((uint32_t)(input[14] & 0x80) << 9);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 113 to 128
	value = ((uint32_t)(input[14] & 0x7f) << 25) |
			((uint32_t)input[15] << 17) |
			((uint32_t)(input[16] & 0x80) << 9);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 129 to 144
	value = ((uint32_t)(input[16] & 0x7f) << 25) |
			((uint32_t)input[17] << 17) |
			((uint32_t)(input[18] & 0x80) << 9);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 145 to 160
	value = ((uint32_t)(input[18] & 0x7f) << 25) |
			((uint32_t)input[19] << 17) |
			((uint32_t)(input[20] & 0x80) << 9);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 161 to 176
	value = ((uint32_t)(input[20] & 0x7f) << 25) |
			((uint32_t)input[21] << 17) |
			((uint32_t)(input[22] & 0x80) << 9);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 177 to 192
	value = ((uint32_t)(input[22] & 0x7f) << 25) |
			((uint32_t)input[23] << 17) |
			((uint32_t)(input[24] & 0x80) << 9);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 193 to 208
	value = ((uint32_t)(input[24] & 0x7f) << 25) |
			((uint32_t)input[25] << 17) |
			((uint32_t)(input[26] & 0x80) << 9);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 209 to 224
	value = ((uint32_t)(input[26] & 0x7f) << 25) |
			((uint32_t)input[27] << 17) |
			((uint32_t)(input[28] & 0x80) << 9);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 225 to 240
	value = ((uint32_t)(input[28] & 0x7f) << 25) |
			((uint32_t)input[29] << 17) |
			((uint32_t)(input[30] & 0x80) << 9);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 241 to 256
	value = ((uint32_t)(input[30] & 0x7f) << 25) |
			((uint32_t)input[31] << 17) |
			((uint32_t)(input[32] & 0x80) << 9);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 257 to 272
	value = ((uint32_t)(input[32] & 0x7f) << 25) |
			((uint32_t)input[33] << 17) |
			((uint32_t)(input[34] & 0x80) << 9);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 273 to 288
	value = ((uint32_t)(input[34] & 0x7f) << 25) |
			((uint32_t)input[35] << 17) |
			((uint32_t)(input[36] & 0x80) << 9);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 289 to 304
	value = ((uint32_t)(input[36] & 0x7f) << 25) |
			((uint32_t)input[37] << 17) |
			((uint32_t)(input[38] & 0x80) << 9);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 305 to 320
	value = ((uint32_t)(input[38] & 0x7f) << 25) |
			((uint32_t)input[39] << 17) |
			((uint32_t)(input[40] & 0x80) << 9);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 321 to 336
	value = ((uint32_t)(input[40] & 0x7f) << 25) |
			((uint32_t)input[41] << 17) |
			((uint32_t)(input[42] & 0x80) << 9);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 337 to 352
	value = ((uint32_t)(input[42] & 0x7f) << 25) |
			((uint32_t)input[43] << 17) |
			((uint32_t)(input[44] & 0x80) << 9);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 353 to 368
	value = ((uint32_t)(input[44] & 0x7f) << 25) |
			((uint32_t)input[45] << 17) |
			((uint32_t)(input[46] & 0x80) << 9);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 369 to 384
	value = ((uint32_t)(input[46] & 0x7f) << 25) |
			((uint32_t)input[47] << 17) |
			((uint32_t)(input[48] & 0x80) << 9);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 385 to 400
	value = ((uint32_t)(input[48] & 0x7f) << 25) |
			((uint32_t)input[49] << 17) |
			((uint32_t)(input[50] & 0x80) << 9);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 401 to 416
	value = ((uint32_t)(input[50] & 0x7f) << 25) |
			((uint32_t)input[51] << 17) |
			((uint32_t)(input[52] & 0x80) << 9);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 417 to 432
	value = ((uint32_t)(input[52] & 0x7f) << 25) |
			((uint32_t)input[53] << 17) |
			((uint32_t)(input[54] & 0x80) << 9);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 433 to 448
	value = ((uint32_t)(input[54] & 0x7f) << 25) |
			((uint32_t)input[55] << 17) |
			((uint32_t)(input[56] & 0x80) << 9);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 449 to 464
	value = ((uint32_t)(input[56] & 0x7f) << 25) |
			((uint32_t)input[57] << 17) |
			((uint32_t)(input[58] & 0x80) << 9);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 465 to 480
	value = ((uint32_t)(input[58] & 0x7f) << 25) |
			((uint32_t)input[59] << 17) |
			((uint32_t)(input[60] & 0x80) << 9);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 481 to 496
	value = ((uint32_t)(input[60] & 0x7f) << 25) |
			((uint32_t)input[61] << 17) |
			((uint32_t)(input[62] & 0x80) << 9);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 497 to 512
	value = ((uint32_t)(input[62] & 0x7f) << 25) |
			((uint32_t)input[63] << 17) |
			((uint32_t)(input[64] & 0x80) << 9);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 513 to 528
	value = ((uint32_t)(input[64] & 0x7f) << 25) |
			((uint32_t)input[65] << 17) |
			((uint32_t)(input[66] & 0x80) << 9);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 529 to 544
	value = ((uint32_t)(input[66] & 0x7f) << 25) |
			((uint32_t)input[67] << 17) |
			((uint32_t)(input[68] & 0x80) << 9);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 545 to 560
	value = ((uint32_t)(input[68] & 0x7f) << 25) |
			((uint32_t)input[69] << 17) |
			((uint32_t)(input[70] & 0x80) << 9);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 561 to 576
	value = ((uint32_t)(input[70] & 0x7f) << 25) |
			((uint32_t)input[71] << 17) |
			((uint32_t)(input[72] & 0x80) << 9);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 577 to 592
	value = ((uint32_t)(input[72] & 0x7f) << 25) |
			((uint32_t)input[73] << 17) |
			((uint32_t)(input[74] & 0x80) << 9);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 593 to 608
	value = ((uint32_t)(input[74] & 0x7f) << 25) |
			((uint32_t)input[75] << 17) |
			((uint32_t)(input[76] & 0x80) << 9);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 609 to 624
	value = ((uint32_t)(input[76] & 0x7f) << 25) |
			((uint32_t)input[77] << 17) |
			((uint32_t)(input[78] & 0x80) << 9);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 625 to 640
	value = ((uint32_t)(input[78] & 0x7f) << 25) |
			((uint32_t)input[79] << 17) |
			((uint32_t)(input[80] & 0x80) << 9);
	output[39] = (double)(value >> 16);

	// read output[40]: from bit 641 to 656
	value = ((uint32_t)(input[80] & 0x7f) << 25) |
			((uint32_t)input[81] << 17) |
			((uint32_t)(input[82] & 0x80) << 9);
	output[40] = (double)(value >> 16);

	// read output[41]: from bit 657 to 672
	value = ((uint32_t)(input[82] & 0x7f) << 25) |
			((uint32_t)input[83] << 17) |
			((uint32_t)(input[84] & 0x80) << 9);
	output[41] = (double)(value >> 16);

	// read output[42]: from bit 673 to 688
	value = ((uint32_t)(input[84] & 0x7f) << 25) |
			((uint32_t)input[85] << 17) |
			((uint32_t)(input[86] & 0x80) << 9);
	output[42] = (double)(value >> 16);
}

static void unpack_43_16bit_signed_2off(const uint8_t * input, double * output, void *closure) {
	// Unpack 43 values into output
	// Values are 16-bit signed
	// Skip 2 bits, read 688 bits of data.
	// Input must be at least 87 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 2 to 17
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)input[1] << 18) |
			((uint32_t)(input[2] & 0xc0) << 10);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 18 to 33
	value = ((uint32_t)(input[2] & 0x3f) << 26) |
			((uint32_t)input[3] << 18) |
			((uint32_t)(input[4] & 0xc0) << 10);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 34 to 49
	value = ((uint32_t)(input[4] & 0x3f) << 26) |
			((uint32_t)input[5] << 18) |
			((uint32_t)(input[6] & 0xc0) << 10);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 50 to 65
	value = ((uint32_t)(input[6] & 0x3f) << 26) |
			((uint32_t)input[7] << 18) |
			((uint32_t)(input[8] & 0xc0) << 10);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 66 to 81
	value = ((uint32_t)(input[8] & 0x3f) << 26) |
			((uint32_t)input[9] << 18) |
			((uint32_t)(input[10] & 0xc0) << 10);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 82 to 97
	value = ((uint32_t)(input[10] & 0x3f) << 26) |
			((uint32_t)input[11] << 18) |
			((uint32_t)(input[12] & 0xc0) << 10);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 98 to 113
	value = ((uint32_t)(input[12] & 0x3f) << 26) |
			((uint32_t)input[13] << 18) |
			((uint32_t)(input[14] & 0xc0) << 10);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 114 to 129
	value = ((uint32_t)(input[14] & 0x3f) << 26) |
			((uint32_t)input[15] << 18) |
			((uint32_t)(input[16] & 0xc0) << 10);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 130 to 145
	value = ((uint32_t)(input[16] & 0x3f) << 26) |
			((uint32_t)input[17] << 18) |
			((uint32_t)(input[18] & 0xc0) << 10);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 146 to 161
	value = ((uint32_t)(input[18] & 0x3f) << 26) |
			((uint32_t)input[19] << 18) |
			((uint32_t)(input[20] & 0xc0) << 10);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 162 to 177
	value = ((uint32_t)(input[20] & 0x3f) << 26) |
			((uint32_t)input[21] << 18) |
			((uint32_t)(input[22] & 0xc0) << 10);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 178 to 193
	value = ((uint32_t)(input[22] & 0x3f) << 26) |
			((uint32_t)input[23] << 18) |
			((uint32_t)(input[24] & 0xc0) << 10);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 194 to 209
	value = ((uint32_t)(input[24] & 0x3f) << 26) |
			((uint32_t)input[25] << 18) |
			((uint32_t)(input[26] & 0xc0) << 10);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 210 to 225
	value = ((uint32_t)(input[26] & 0x3f) << 26) |
			((uint32_t)input[27] << 18) |
			((uint32_t)(input[28] & 0xc0) << 10);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 226 to 241
	value = ((uint32_t)(input[28] & 0x3f) << 26) |
			((uint32_t)input[29] << 18) |
			((uint32_t)(input[30] & 0xc0) << 10);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 242 to 257
	value = ((uint32_t)(input[30] & 0x3f) << 26) |
			((uint32_t)input[31] << 18) |
			((uint32_t)(input[32] & 0xc0) << 10);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 258 to 273
	value = ((uint32_t)(input[32] & 0x3f) << 26) |
			((uint32_t)input[33] << 18) |
			((uint32_t)(input[34] & 0xc0) << 10);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 274 to 289
	value = ((uint32_t)(input[34] & 0x3f) << 26) |
			((uint32_t)input[35] << 18) |
			((uint32_t)(input[36] & 0xc0) << 10);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 290 to 305
	value = ((uint32_t)(input[36] & 0x3f) << 26) |
			((uint32_t)input[37] << 18) |
			((uint32_t)(input[38] & 0xc0) << 10);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 306 to 321
	value = ((uint32_t)(input[38] & 0x3f) << 26) |
			((uint32_t)input[39] << 18) |
			((uint32_t)(input[40] & 0xc0) << 10);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 322 to 337
	value = ((uint32_t)(input[40] & 0x3f) << 26) |
			((uint32_t)input[41] << 18) |
			((uint32_t)(input[42] & 0xc0) << 10);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 338 to 353
	value = ((uint32_t)(input[42] & 0x3f) << 26) |
			((uint32_t)input[43] << 18) |
			((uint32_t)(input[44] & 0xc0) << 10);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 354 to 369
	value = ((uint32_t)(input[44] & 0x3f) << 26) |
			((uint32_t)input[45] << 18) |
			((uint32_t)(input[46] & 0xc0) << 10);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 370 to 385
	value = ((uint32_t)(input[46] & 0x3f) << 26) |
			((uint32_t)input[47] << 18) |
			((uint32_t)(input[48] & 0xc0) << 10);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 386 to 401
	value = ((uint32_t)(input[48] & 0x3f) << 26) |
			((uint32_t)input[49] << 18) |
			((uint32_t)(input[50] & 0xc0) << 10);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 402 to 417
	value = ((uint32_t)(input[50] & 0x3f) << 26) |
			((uint32_t)input[51] << 18) |
			((uint32_t)(input[52] & 0xc0) << 10);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 418 to 433
	value = ((uint32_t)(input[52] & 0x3f) << 26) |
			((uint32_t)input[53] << 18) |
			((uint32_t)(input[54] & 0xc0) << 10);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 434 to 449
	value = ((uint32_t)(input[54] & 0x3f) << 26) |
			((uint32_t)input[55] << 18) |
			((uint32_t)(input[56] & 0xc0) << 10);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 450 to 465
	value = ((uint32_t)(input[56] & 0x3f) << 26) |
			((uint32_t)input[57] << 18) |
			((uint32_t)(input[58] & 0xc0) << 10);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 466 to 481
	value = ((uint32_t)(input[58] & 0x3f) << 26) |
			((uint32_t)input[59] << 18) |
			((uint32_t)(input[60] & 0xc0) << 10);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 482 to 497
	value = ((uint32_t)(input[60] & 0x3f) << 26) |
			((uint32_t)input[61] << 18) |
			((uint32_t)(input[62] & 0xc0) << 10);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 498 to 513
	value = ((uint32_t)(input[62] & 0x3f) << 26) |
			((uint32_t)input[63] << 18) |
			((uint32_t)(input[64] & 0xc0) << 10);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 514 to 529
	value = ((uint32_t)(input[64] & 0x3f) << 26) |
			((uint32_t)input[65] << 18) |
			((uint32_t)(input[66] & 0xc0) << 10);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 530 to 545
	value = ((uint32_t)(input[66] & 0x3f) << 26) |
			((uint32_t)input[67] << 18) |
			((uint32_t)(input[68] & 0xc0) << 10);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 546 to 561
	value = ((uint32_t)(input[68] & 0x3f) << 26) |
			((uint32_t)input[69] << 18) |
			((uint32_t)(input[70] & 0xc0) << 10);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 562 to 577
	value = ((uint32_t)(input[70] & 0x3f) << 26) |
			((uint32_t)input[71] << 18) |
			((uint32_t)(input[72] & 0xc0) << 10);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 578 to 593
	value = ((uint32_t)(input[72] & 0x3f) << 26) |
			((uint32_t)input[73] << 18) |
			((uint32_t)(input[74] & 0xc0) << 10);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 594 to 609
	value = ((uint32_t)(input[74] & 0x3f) << 26) |
			((uint32_t)input[75] << 18) |
			((uint32_t)(input[76] & 0xc0) << 10);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 610 to 625
	value = ((uint32_t)(input[76] & 0x3f) << 26) |
			((uint32_t)input[77] << 18) |
			((uint32_t)(input[78] & 0xc0) << 10);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 626 to 641
	value = ((uint32_t)(input[78] & 0x3f) << 26) |
			((uint32_t)input[79] << 18) |
			((uint32_t)(input[80] & 0xc0) << 10);
	output[39] = (double)(value >> 16);

	// read output[40]: from bit 642 to 657
	value = ((uint32_t)(input[80] & 0x3f) << 26) |
			((uint32_t)input[81] << 18) |
			((uint32_t)(input[82] & 0xc0) << 10);
	output[40] = (double)(value >> 16);

	// read output[41]: from bit 658 to 673
	value = ((uint32_t)(input[82] & 0x3f) << 26) |
			((uint32_t)input[83] << 18) |
			((uint32_t)(input[84] & 0xc0) << 10);
	output[41] = (double)(value >> 16);

	// read output[42]: from bit 674 to 689
	value = ((uint32_t)(input[84] & 0x3f) << 26) |
			((uint32_t)input[85] << 18) |
			((uint32_t)(input[86] & 0xc0) << 10);
	output[42] = (double)(value >> 16);
}

static void unpack_43_16bit_unsigned_2off(const uint8_t * input, double * output, void *closure) {
	// Unpack 43 values into output
	// Values are 16-bit unsigned
	// Skip 2 bits, read 688 bits of data.
	// Input must be at least 87 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 2 to 17
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)input[1] << 18) |
			((uint32_t)(input[2] & 0xc0) << 10);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 18 to 33
	value = ((uint32_t)(input[2] & 0x3f) << 26) |
			((uint32_t)input[3] << 18) |
			((uint32_t)(input[4] & 0xc0) << 10);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 34 to 49
	value = ((uint32_t)(input[4] & 0x3f) << 26) |
			((uint32_t)input[5] << 18) |
			((uint32_t)(input[6] & 0xc0) << 10);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 50 to 65
	value = ((uint32_t)(input[6] & 0x3f) << 26) |
			((uint32_t)input[7] << 18) |
			((uint32_t)(input[8] & 0xc0) << 10);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 66 to 81
	value = ((uint32_t)(input[8] & 0x3f) << 26) |
			((uint32_t)input[9] << 18) |
			((uint32_t)(input[10] & 0xc0) << 10);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 82 to 97
	value = ((uint32_t)(input[10] & 0x3f) << 26) |
			((uint32_t)input[11] << 18) |
			((uint32_t)(input[12] & 0xc0) << 10);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 98 to 113
	value = ((uint32_t)(input[12] & 0x3f) << 26) |
			((uint32_t)input[13] << 18) |
			((uint32_t)(input[14] & 0xc0) << 10);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 114 to 129
	value = ((uint32_t)(input[14] & 0x3f) << 26) |
			((uint32_t)input[15] << 18) |
			((uint32_t)(input[16] & 0xc0) << 10);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 130 to 145
	value = ((uint32_t)(input[16] & 0x3f) << 26) |
			((uint32_t)input[17] << 18) |
			((uint32_t)(input[18] & 0xc0) << 10);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 146 to 161
	value = ((uint32_t)(input[18] & 0x3f) << 26) |
			((uint32_t)input[19] << 18) |
			((uint32_t)(input[20] & 0xc0) << 10);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 162 to 177
	value = ((uint32_t)(input[20] & 0x3f) << 26) |
			((uint32_t)input[21] << 18) |
			((uint32_t)(input[22] & 0xc0) << 10);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 178 to 193
	value = ((uint32_t)(input[22] & 0x3f) << 26) |
			((uint32_t)input[23] << 18) |
			((uint32_t)(input[24] & 0xc0) << 10);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 194 to 209
	value = ((uint32_t)(input[24] & 0x3f) << 26) |
			((uint32_t)input[25] << 18) |
			((uint32_t)(input[26] & 0xc0) << 10);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 210 to 225
	value = ((uint32_t)(input[26] & 0x3f) << 26) |
			((uint32_t)input[27] << 18) |
			((uint32_t)(input[28] & 0xc0) << 10);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 226 to 241
	value = ((uint32_t)(input[28] & 0x3f) << 26) |
			((uint32_t)input[29] << 18) |
			((uint32_t)(input[30] & 0xc0) << 10);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 242 to 257
	value = ((uint32_t)(input[30] & 0x3f) << 26) |
			((uint32_t)input[31] << 18) |
			((uint32_t)(input[32] & 0xc0) << 10);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 258 to 273
	value = ((uint32_t)(input[32] & 0x3f) << 26) |
			((uint32_t)input[33] << 18) |
			((uint32_t)(input[34] & 0xc0) << 10);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 274 to 289
	value = ((uint32_t)(input[34] & 0x3f) << 26) |
			((uint32_t)input[35] << 18) |
			((uint32_t)(input[36] & 0xc0) << 10);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 290 to 305
	value = ((uint32_t)(input[36] & 0x3f) << 26) |
			((uint32_t)input[37] << 18) |
			((uint32_t)(input[38] & 0xc0) << 10);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 306 to 321
	value = ((uint32_t)(input[38] & 0x3f) << 26) |
			((uint32_t)input[39] << 18) |
			((uint32_t)(input[40] & 0xc0) << 10);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 322 to 337
	value = ((uint32_t)(input[40] & 0x3f) << 26) |
			((uint32_t)input[41] << 18) |
			((uint32_t)(input[42] & 0xc0) << 10);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 338 to 353
	value = ((uint32_t)(input[42] & 0x3f) << 26) |
			((uint32_t)input[43] << 18) |
			((uint32_t)(input[44] & 0xc0) << 10);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 354 to 369
	value = ((uint32_t)(input[44] & 0x3f) << 26) |
			((uint32_t)input[45] << 18) |
			((uint32_t)(input[46] & 0xc0) << 10);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 370 to 385
	value = ((uint32_t)(input[46] & 0x3f) << 26) |
			((uint32_t)input[47] << 18) |
			((uint32_t)(input[48] & 0xc0) << 10);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 386 to 401
	value = ((uint32_t)(input[48] & 0x3f) << 26) |
			((uint32_t)input[49] << 18) |
			((uint32_t)(input[50] & 0xc0) << 10);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 402 to 417
	value = ((uint32_t)(input[50] & 0x3f) << 26) |
			((uint32_t)input[51] << 18) |
			((uint32_t)(input[52] & 0xc0) << 10);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 418 to 433
	value = ((uint32_t)(input[52] & 0x3f) << 26) |
			((uint32_t)input[53] << 18) |
			((uint32_t)(input[54] & 0xc0) << 10);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 434 to 449
	value = ((uint32_t)(input[54] & 0x3f) << 26) |
			((uint32_t)input[55] << 18) |
			((uint32_t)(input[56] & 0xc0) << 10);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 450 to 465
	value = ((uint32_t)(input[56] & 0x3f) << 26) |
			((uint32_t)input[57] << 18) |
			((uint32_t)(input[58] & 0xc0) << 10);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 466 to 481
	value = ((uint32_t)(input[58] & 0x3f) << 26) |
			((uint32_t)input[59] << 18) |
			((uint32_t)(input[60] & 0xc0) << 10);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 482 to 497
	value = ((uint32_t)(input[60] & 0x3f) << 26) |
			((uint32_t)input[61] << 18) |
			((uint32_t)(input[62] & 0xc0) << 10);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 498 to 513
	value = ((uint32_t)(input[62] & 0x3f) << 26) |
			((uint32_t)input[63] << 18) |
			((uint32_t)(input[64] & 0xc0) << 10);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 514 to 529
	value = ((uint32_t)(input[64] & 0x3f) << 26) |
			((uint32_t)input[65] << 18) |
			((uint32_t)(input[66] & 0xc0) << 10);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 530 to 545
	value = ((uint32_t)(input[66] & 0x3f) << 26) |
			((uint32_t)input[67] << 18) |
			((uint32_t)(input[68] & 0xc0) << 10);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 546 to 561
	value = ((uint32_t)(input[68] & 0x3f) << 26) |
			((uint32_t)input[69] << 18) |
			((uint32_t)(input[70] & 0xc0) << 10);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 562 to 577
	value = ((uint32_t)(input[70] & 0x3f) << 26) |
			((uint32_t)input[71] << 18) |
			((uint32_t)(input[72] & 0xc0) << 10);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 578 to 593
	value = ((uint32_t)(input[72] & 0x3f) << 26) |
			((uint32_t)input[73] << 18) |
			((uint32_t)(input[74] & 0xc0) << 10);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 594 to 609
	value = ((uint32_t)(input[74] & 0x3f) << 26) |
			((uint32_t)input[75] << 18) |
			((uint32_t)(input[76] & 0xc0) << 10);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 610 to 625
	value = ((uint32_t)(input[76] & 0x3f) << 26) |
			((uint32_t)input[77] << 18) |
			((uint32_t)(input[78] & 0xc0) << 10);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 626 to 641
	value = ((uint32_t)(input[78] & 0x3f) << 26) |
			((uint32_t)input[79] << 18) |
			((uint32_t)(input[80] & 0xc0) << 10);
	output[39] = (double)(value >> 16);

	// read output[40]: from bit 642 to 657
	value = ((uint32_t)(input[80] & 0x3f) << 26) |
			((uint32_t)input[81] << 18) |
			((uint32_t)(input[82] & 0xc0) << 10);
	output[40] = (double)(value >> 16);

	// read output[41]: from bit 658 to 673
	value = ((uint32_t)(input[82] & 0x3f) << 26) |
			((uint32_t)input[83] << 18) |
			((uint32_t)(input[84] & 0xc0) << 10);
	output[41] = (double)(value >> 16);

	// read output[42]: from bit 674 to 689
	value = ((uint32_t)(input[84] & 0x3f) << 26) |
			((uint32_t)input[85] << 18) |
			((uint32_t)(input[86] & 0xc0) << 10);
	output[42] = (double)(value >> 16);
}

static void unpack_43_16bit_signed_3off(const uint8_t * input, double * output, void *closure) {
	// Unpack 43 values into output
	// Values are 16-bit signed
	// Skip 3 bits, read 688 bits of data.
	// Input must be at least 87 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 3 to 18
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)input[1] << 19) |
			((uint32_t)(input[2] & 0xe0) << 11);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 19 to 34
	value = ((uint32_t)(input[2] & 0x1f) << 27) |
			((uint32_t)input[3] << 19) |
			((uint32_t)(input[4] & 0xe0) << 11);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 35 to 50
	value = ((uint32_t)(input[4] & 0x1f) << 27) |
			((uint32_t)input[5] << 19) |
			((uint32_t)(input[6] & 0xe0) << 11);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 51 to 66
	value = ((uint32_t)(input[6] & 0x1f) << 27) |
			((uint32_t)input[7] << 19) |
			((uint32_t)(input[8] & 0xe0) << 11);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 67 to 82
	value = ((uint32_t)(input[8] & 0x1f) << 27) |
			((uint32_t)input[9] << 19) |
			((uint32_t)(input[10] & 0xe0) << 11);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 83 to 98
	value = ((uint32_t)(input[10] & 0x1f) << 27) |
			((uint32_t)input[11] << 19) |
			((uint32_t)(input[12] & 0xe0) << 11);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 99 to 114
	value = ((uint32_t)(input[12] & 0x1f) << 27) |
			((uint32_t)input[13] << 19) |
			((uint32_t)(input[14] & 0xe0) << 11);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 115 to 130
	value = ((uint32_t)(input[14] & 0x1f) << 27) |
			((uint32_t)input[15] << 19) |
			((uint32_t)(input[16] & 0xe0) << 11);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 131 to 146
	value = ((uint32_t)(input[16] & 0x1f) << 27) |
			((uint32_t)input[17] << 19) |
			((uint32_t)(input[18] & 0xe0) << 11);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 147 to 162
	value = ((uint32_t)(input[18] & 0x1f) << 27) |
			((uint32_t)input[19] << 19) |
			((uint32_t)(input[20] & 0xe0) << 11);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 163 to 178
	value = ((uint32_t)(input[20] & 0x1f) << 27) |
			((uint32_t)input[21] << 19) |
			((uint32_t)(input[22] & 0xe0) << 11);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 179 to 194
	value = ((uint32_t)(input[22] & 0x1f) << 27) |
			((uint32_t)input[23] << 19) |
			((uint32_t)(input[24] & 0xe0) << 11);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 195 to 210
	value = ((uint32_t)(input[24] & 0x1f) << 27) |
			((uint32_t)input[25] << 19) |
			((uint32_t)(input[26] & 0xe0) << 11);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 211 to 226
	value = ((uint32_t)(input[26] & 0x1f) << 27) |
			((uint32_t)input[27] << 19) |
			((uint32_t)(input[28] & 0xe0) << 11);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 227 to 242
	value = ((uint32_t)(input[28] & 0x1f) << 27) |
			((uint32_t)input[29] << 19) |
			((uint32_t)(input[30] & 0xe0) << 11);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 243 to 258
	value = ((uint32_t)(input[30] & 0x1f) << 27) |
			((uint32_t)input[31] << 19) |
			((uint32_t)(input[32] & 0xe0) << 11);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 259 to 274
	value = ((uint32_t)(input[32] & 0x1f) << 27) |
			((uint32_t)input[33] << 19) |
			((uint32_t)(input[34] & 0xe0) << 11);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 275 to 290
	value = ((uint32_t)(input[34] & 0x1f) << 27) |
			((uint32_t)input[35] << 19) |
			((uint32_t)(input[36] & 0xe0) << 11);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 291 to 306
	value = ((uint32_t)(input[36] & 0x1f) << 27) |
			((uint32_t)input[37] << 19) |
			((uint32_t)(input[38] & 0xe0) << 11);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 307 to 322
	value = ((uint32_t)(input[38] & 0x1f) << 27) |
			((uint32_t)input[39] << 19) |
			((uint32_t)(input[40] & 0xe0) << 11);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 323 to 338
	value = ((uint32_t)(input[40] & 0x1f) << 27) |
			((uint32_t)input[41] << 19) |
			((uint32_t)(input[42] & 0xe0) << 11);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 339 to 354
	value = ((uint32_t)(input[42] & 0x1f) << 27) |
			((uint32_t)input[43] << 19) |
			((uint32_t)(input[44] & 0xe0) << 11);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 355 to 370
	value = ((uint32_t)(input[44] & 0x1f) << 27) |
			((uint32_t)input[45] << 19) |
			((uint32_t)(input[46] & 0xe0) << 11);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 371 to 386
	value = ((uint32_t)(input[46] & 0x1f) << 27) |
			((uint32_t)input[47] << 19) |
			((uint32_t)(input[48] & 0xe0) << 11);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 387 to 402
	value = ((uint32_t)(input[48] & 0x1f) << 27) |
			((uint32_t)input[49] << 19) |
			((uint32_t)(input[50] & 0xe0) << 11);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 403 to 418
	value = ((uint32_t)(input[50] & 0x1f) << 27) |
			((uint32_t)input[51] << 19) |
			((uint32_t)(input[52] & 0xe0) << 11);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 419 to 434
	value = ((uint32_t)(input[52] & 0x1f) << 27) |
			((uint32_t)input[53] << 19) |
			((uint32_t)(input[54] & 0xe0) << 11);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 435 to 450
	value = ((uint32_t)(input[54] & 0x1f) << 27) |
			((uint32_t)input[55] << 19) |
			((uint32_t)(input[56] & 0xe0) << 11);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 451 to 466
	value = ((uint32_t)(input[56] & 0x1f) << 27) |
			((uint32_t)input[57] << 19) |
			((uint32_t)(input[58] & 0xe0) << 11);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 467 to 482
	value = ((uint32_t)(input[58] & 0x1f) << 27) |
			((uint32_t)input[59] << 19) |
			((uint32_t)(input[60] & 0xe0) << 11);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 483 to 498
	value = ((uint32_t)(input[60] & 0x1f) << 27) |
			((uint32_t)input[61] << 19) |
			((uint32_t)(input[62] & 0xe0) << 11);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 499 to 514
	value = ((uint32_t)(input[62] & 0x1f) << 27) |
			((uint32_t)input[63] << 19) |
			((uint32_t)(input[64] & 0xe0) << 11);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 515 to 530
	value = ((uint32_t)(input[64] & 0x1f) << 27) |
			((uint32_t)input[65] << 19) |
			((uint32_t)(input[66] & 0xe0) << 11);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 531 to 546
	value = ((uint32_t)(input[66] & 0x1f) << 27) |
			((uint32_t)input[67] << 19) |
			((uint32_t)(input[68] & 0xe0) << 11);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 547 to 562
	value = ((uint32_t)(input[68] & 0x1f) << 27) |
			((uint32_t)input[69] << 19) |
			((uint32_t)(input[70] & 0xe0) << 11);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 563 to 578
	value = ((uint32_t)(input[70] & 0x1f) << 27) |
			((uint32_t)input[71] << 19) |
			((uint32_t)(input[72] & 0xe0) << 11);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 579 to 594
	value = ((uint32_t)(input[72] & 0x1f) << 27) |
			((uint32_t)input[73] << 19) |
			((uint32_t)(input[74] & 0xe0) << 11);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 595 to 610
	value = ((uint32_t)(input[74] & 0x1f) << 27) |
			((uint32_t)input[75] << 19) |
			((uint32_t)(input[76] & 0xe0) << 11);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 611 to 626
	value = ((uint32_t)(input[76] & 0x1f) << 27) |
			((uint32_t)input[77] << 19) |
			((uint32_t)(input[78] & 0xe0) << 11);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 627 to 642
	value = ((uint32_t)(input[78] & 0x1f) << 27) |
			((uint32_t)input[79] << 19) |
			((uint32_t)(input[80] & 0xe0) << 11);
	output[39] = (double)(value >> 16);

	// read output[40]: from bit 643 to 658
	value = ((uint32_t)(input[80] & 0x1f) << 27) |
			((uint32_t)input[81] << 19) |
			((uint32_t)(input[82] & 0xe0) << 11);
	output[40] = (double)(value >> 16);

	// read output[41]: from bit 659 to 674
	value = ((uint32_t)(input[82] & 0x1f) << 27) |
			((uint32_t)input[83] << 19) |
			((uint32_t)(input[84] & 0xe0) << 11);
	output[41] = (double)(value >> 16);

	// read output[42]: from bit 675 to 690
	value = ((uint32_t)(input[84] & 0x1f) << 27) |
			((uint32_t)input[85] << 19) |
			((uint32_t)(input[86] & 0xe0) << 11);
	output[42] = (double)(value >> 16);
}

static void unpack_43_16bit_unsigned_3off(const uint8_t * input, double * output, void *closure) {
	// Unpack 43 values into output
	// Values are 16-bit unsigned
	// Skip 3 bits, read 688 bits of data.
	// Input must be at least 87 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 3 to 18
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)input[1] << 19) |
			((uint32_t)(input[2] & 0xe0) << 11);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 19 to 34
	value = ((uint32_t)(input[2] & 0x1f) << 27) |
			((uint32_t)input[3] << 19) |
			((uint32_t)(input[4] & 0xe0) << 11);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 35 to 50
	value = ((uint32_t)(input[4] & 0x1f) << 27) |
			((uint32_t)input[5] << 19) |
			((uint32_t)(input[6] & 0xe0) << 11);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 51 to 66
	value = ((uint32_t)(input[6] & 0x1f) << 27) |
			((uint32_t)input[7] << 19) |
			((uint32_t)(input[8] & 0xe0) << 11);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 67 to 82
	value = ((uint32_t)(input[8] & 0x1f) << 27) |
			((uint32_t)input[9] << 19) |
			((uint32_t)(input[10] & 0xe0) << 11);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 83 to 98
	value = ((uint32_t)(input[10] & 0x1f) << 27) |
			((uint32_t)input[11] << 19) |
			((uint32_t)(input[12] & 0xe0) << 11);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 99 to 114
	value = ((uint32_t)(input[12] & 0x1f) << 27) |
			((uint32_t)input[13] << 19) |
			((uint32_t)(input[14] & 0xe0) << 11);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 115 to 130
	value = ((uint32_t)(input[14] & 0x1f) << 27) |
			((uint32_t)input[15] << 19) |
			((uint32_t)(input[16] & 0xe0) << 11);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 131 to 146
	value = ((uint32_t)(input[16] & 0x1f) << 27) |
			((uint32_t)input[17] << 19) |
			((uint32_t)(input[18] & 0xe0) << 11);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 147 to 162
	value = ((uint32_t)(input[18] & 0x1f) << 27) |
			((uint32_t)input[19] << 19) |
			((uint32_t)(input[20] & 0xe0) << 11);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 163 to 178
	value = ((uint32_t)(input[20] & 0x1f) << 27) |
			((uint32_t)input[21] << 19) |
			((uint32_t)(input[22] & 0xe0) << 11);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 179 to 194
	value = ((uint32_t)(input[22] & 0x1f) << 27) |
			((uint32_t)input[23] << 19) |
			((uint32_t)(input[24] & 0xe0) << 11);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 195 to 210
	value = ((uint32_t)(input[24] & 0x1f) << 27) |
			((uint32_t)input[25] << 19) |
			((uint32_t)(input[26] & 0xe0) << 11);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 211 to 226
	value = ((uint32_t)(input[26] & 0x1f) << 27) |
			((uint32_t)input[27] << 19) |
			((uint32_t)(input[28] & 0xe0) << 11);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 227 to 242
	value = ((uint32_t)(input[28] & 0x1f) << 27) |
			((uint32_t)input[29] << 19) |
			((uint32_t)(input[30] & 0xe0) << 11);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 243 to 258
	value = ((uint32_t)(input[30] & 0x1f) << 27) |
			((uint32_t)input[31] << 19) |
			((uint32_t)(input[32] & 0xe0) << 11);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 259 to 274
	value = ((uint32_t)(input[32] & 0x1f) << 27) |
			((uint32_t)input[33] << 19) |
			((uint32_t)(input[34] & 0xe0) << 11);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 275 to 290
	value = ((uint32_t)(input[34] & 0x1f) << 27) |
			((uint32_t)input[35] << 19) |
			((uint32_t)(input[36] & 0xe0) << 11);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 291 to 306
	value = ((uint32_t)(input[36] & 0x1f) << 27) |
			((uint32_t)input[37] << 19) |
			((uint32_t)(input[38] & 0xe0) << 11);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 307 to 322
	value = ((uint32_t)(input[38] & 0x1f) << 27) |
			((uint32_t)input[39] << 19) |
			((uint32_t)(input[40] & 0xe0) << 11);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 323 to 338
	value = ((uint32_t)(input[40] & 0x1f) << 27) |
			((uint32_t)input[41] << 19) |
			((uint32_t)(input[42] & 0xe0) << 11);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 339 to 354
	value = ((uint32_t)(input[42] & 0x1f) << 27) |
			((uint32_t)input[43] << 19) |
			((uint32_t)(input[44] & 0xe0) << 11);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 355 to 370
	value = ((uint32_t)(input[44] & 0x1f) << 27) |
			((uint32_t)input[45] << 19) |
			((uint32_t)(input[46] & 0xe0) << 11);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 371 to 386
	value = ((uint32_t)(input[46] & 0x1f) << 27) |
			((uint32_t)input[47] << 19) |
			((uint32_t)(input[48] & 0xe0) << 11);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 387 to 402
	value = ((uint32_t)(input[48] & 0x1f) << 27) |
			((uint32_t)input[49] << 19) |
			((uint32_t)(input[50] & 0xe0) << 11);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 403 to 418
	value = ((uint32_t)(input[50] & 0x1f) << 27) |
			((uint32_t)input[51] << 19) |
			((uint32_t)(input[52] & 0xe0) << 11);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 419 to 434
	value = ((uint32_t)(input[52] & 0x1f) << 27) |
			((uint32_t)input[53] << 19) |
			((uint32_t)(input[54] & 0xe0) << 11);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 435 to 450
	value = ((uint32_t)(input[54] & 0x1f) << 27) |
			((uint32_t)input[55] << 19) |
			((uint32_t)(input[56] & 0xe0) << 11);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 451 to 466
	value = ((uint32_t)(input[56] & 0x1f) << 27) |
			((uint32_t)input[57] << 19) |
			((uint32_t)(input[58] & 0xe0) << 11);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 467 to 482
	value = ((uint32_t)(input[58] & 0x1f) << 27) |
			((uint32_t)input[59] << 19) |
			((uint32_t)(input[60] & 0xe0) << 11);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 483 to 498
	value = ((uint32_t)(input[60] & 0x1f) << 27) |
			((uint32_t)input[61] << 19) |
			((uint32_t)(input[62] & 0xe0) << 11);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 499 to 514
	value = ((uint32_t)(input[62] & 0x1f) << 27) |
			((uint32_t)input[63] << 19) |
			((uint32_t)(input[64] & 0xe0) << 11);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 515 to 530
	value = ((uint32_t)(input[64] & 0x1f) << 27) |
			((uint32_t)input[65] << 19) |
			((uint32_t)(input[66] & 0xe0) << 11);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 531 to 546
	value = ((uint32_t)(input[66] & 0x1f) << 27) |
			((uint32_t)input[67] << 19) |
			((uint32_t)(input[68] & 0xe0) << 11);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 547 to 562
	value = ((uint32_t)(input[68] & 0x1f) << 27) |
			((uint32_t)input[69] << 19) |
			((uint32_t)(input[70] & 0xe0) << 11);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 563 to 578
	value = ((uint32_t)(input[70] & 0x1f) << 27) |
			((uint32_t)input[71] << 19) |
			((uint32_t)(input[72] & 0xe0) << 11);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 579 to 594
	value = ((uint32_t)(input[72] & 0x1f) << 27) |
			((uint32_t)input[73] << 19) |
			((uint32_t)(input[74] & 0xe0) << 11);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 595 to 610
	value = ((uint32_t)(input[74] & 0x1f) << 27) |
			((uint32_t)input[75] << 19) |
			((uint32_t)(input[76] & 0xe0) << 11);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 611 to 626
	value = ((uint32_t)(input[76] & 0x1f) << 27) |
			((uint32_t)input[77] << 19) |
			((uint32_t)(input[78] & 0xe0) << 11);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 627 to 642
	value = ((uint32_t)(input[78] & 0x1f) << 27) |
			((uint32_t)input[79] << 19) |
			((uint32_t)(input[80] & 0xe0) << 11);
	output[39] = (double)(value >> 16);

	// read output[40]: from bit 643 to 658
	value = ((uint32_t)(input[80] & 0x1f) << 27) |
			((uint32_t)input[81] << 19) |
			((uint32_t)(input[82] & 0xe0) << 11);
	output[40] = (double)(value >> 16);

	// read output[41]: from bit 659 to 674
	value = ((uint32_t)(input[82] & 0x1f) << 27) |
			((uint32_t)input[83] << 19) |
			((uint32_t)(input[84] & 0xe0) << 11);
	output[41] = (double)(value >> 16);

	// read output[42]: from bit 675 to 690
	value = ((uint32_t)(input[84] & 0x1f) << 27) |
			((uint32_t)input[85] << 19) |
			((uint32_t)(input[86] & 0xe0) << 11);
	output[42] = (double)(value >> 16);
}

static void unpack_43_16bit_signed_4off(const uint8_t * input, double * output, void *closure) {
	// Unpack 43 values into output
	// Values are 16-bit signed
	// Skip 4 bits, read 688 bits of data.
	// Input must be at least 87 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 4 to 19
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20) |
			((uint32_t)(input[2] & 0xf0) << 12);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 20 to 35
	value = ((uint32_t)(input[2] & 0x0f) << 28) |
			((uint32_t)input[3] << 20) |
			((uint32_t)(input[4] & 0xf0) << 12);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 36 to 51
	value = ((uint32_t)(input[4] & 0x0f) << 28) |
			((uint32_t)input[5] << 20) |
			((uint32_t)(input[6] & 0xf0) << 12);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 52 to 67
	value = ((uint32_t)(input[6] & 0x0f) << 28) |
			((uint32_t)input[7] << 20) |
			((uint32_t)(input[8] & 0xf0) << 12);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 68 to 83
	value = ((uint32_t)(input[8] & 0x0f) << 28) |
			((uint32_t)input[9] << 20) |
			((uint32_t)(input[10] & 0xf0) << 12);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 84 to 99
	value = ((uint32_t)(input[10] & 0x0f) << 28) |
			((uint32_t)input[11] << 20) |
			((uint32_t)(input[12] & 0xf0) << 12);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 100 to 115
	value = ((uint32_t)(input[12] & 0x0f) << 28) |
			((uint32_t)input[13] << 20) |
			((uint32_t)(input[14] & 0xf0) << 12);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 116 to 131
	value = ((uint32_t)(input[14] & 0x0f) << 28) |
			((uint32_t)input[15] << 20) |
			((uint32_t)(input[16] & 0xf0) << 12);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 132 to 147
	value = ((uint32_t)(input[16] & 0x0f) << 28) |
			((uint32_t)input[17] << 20) |
			((uint32_t)(input[18] & 0xf0) << 12);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 148 to 163
	value = ((uint32_t)(input[18] & 0x0f) << 28) |
			((uint32_t)input[19] << 20) |
			((uint32_t)(input[20] & 0xf0) << 12);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 164 to 179
	value = ((uint32_t)(input[20] & 0x0f) << 28) |
			((uint32_t)input[21] << 20) |
			((uint32_t)(input[22] & 0xf0) << 12);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 180 to 195
	value = ((uint32_t)(input[22] & 0x0f) << 28) |
			((uint32_t)input[23] << 20) |
			((uint32_t)(input[24] & 0xf0) << 12);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 196 to 211
	value = ((uint32_t)(input[24] & 0x0f) << 28) |
			((uint32_t)input[25] << 20) |
			((uint32_t)(input[26] & 0xf0) << 12);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 212 to 227
	value = ((uint32_t)(input[26] & 0x0f) << 28) |
			((uint32_t)input[27] << 20) |
			((uint32_t)(input[28] & 0xf0) << 12);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 228 to 243
	value = ((uint32_t)(input[28] & 0x0f) << 28) |
			((uint32_t)input[29] << 20) |
			((uint32_t)(input[30] & 0xf0) << 12);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 244 to 259
	value = ((uint32_t)(input[30] & 0x0f) << 28) |
			((uint32_t)input[31] << 20) |
			((uint32_t)(input[32] & 0xf0) << 12);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 260 to 275
	value = ((uint32_t)(input[32] & 0x0f) << 28) |
			((uint32_t)input[33] << 20) |
			((uint32_t)(input[34] & 0xf0) << 12);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 276 to 291
	value = ((uint32_t)(input[34] & 0x0f) << 28) |
			((uint32_t)input[35] << 20) |
			((uint32_t)(input[36] & 0xf0) << 12);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 292 to 307
	value = ((uint32_t)(input[36] & 0x0f) << 28) |
			((uint32_t)input[37] << 20) |
			((uint32_t)(input[38] & 0xf0) << 12);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 308 to 323
	value = ((uint32_t)(input[38] & 0x0f) << 28) |
			((uint32_t)input[39] << 20) |
			((uint32_t)(input[40] & 0xf0) << 12);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 324 to 339
	value = ((uint32_t)(input[40] & 0x0f) << 28) |
			((uint32_t)input[41] << 20) |
			((uint32_t)(input[42] & 0xf0) << 12);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 340 to 355
	value = ((uint32_t)(input[42] & 0x0f) << 28) |
			((uint32_t)input[43] << 20) |
			((uint32_t)(input[44] & 0xf0) << 12);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 356 to 371
	value = ((uint32_t)(input[44] & 0x0f) << 28) |
			((uint32_t)input[45] << 20) |
			((uint32_t)(input[46] & 0xf0) << 12);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 372 to 387
	value = ((uint32_t)(input[46] & 0x0f) << 28) |
			((uint32_t)input[47] << 20) |
			((uint32_t)(input[48] & 0xf0) << 12);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 388 to 403
	value = ((uint32_t)(input[48] & 0x0f) << 28) |
			((uint32_t)input[49] << 20) |
			((uint32_t)(input[50] & 0xf0) << 12);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 404 to 419
	value = ((uint32_t)(input[50] & 0x0f) << 28) |
			((uint32_t)input[51] << 20) |
			((uint32_t)(input[52] & 0xf0) << 12);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 420 to 435
	value = ((uint32_t)(input[52] & 0x0f) << 28) |
			((uint32_t)input[53] << 20) |
			((uint32_t)(input[54] & 0xf0) << 12);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 436 to 451
	value = ((uint32_t)(input[54] & 0x0f) << 28) |
			((uint32_t)input[55] << 20) |
			((uint32_t)(input[56] & 0xf0) << 12);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 452 to 467
	value = ((uint32_t)(input[56] & 0x0f) << 28) |
			((uint32_t)input[57] << 20) |
			((uint32_t)(input[58] & 0xf0) << 12);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 468 to 483
	value = ((uint32_t)(input[58] & 0x0f) << 28) |
			((uint32_t)input[59] << 20) |
			((uint32_t)(input[60] & 0xf0) << 12);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 484 to 499
	value = ((uint32_t)(input[60] & 0x0f) << 28) |
			((uint32_t)input[61] << 20) |
			((uint32_t)(input[62] & 0xf0) << 12);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 500 to 515
	value = ((uint32_t)(input[62] & 0x0f) << 28) |
			((uint32_t)input[63] << 20) |
			((uint32_t)(input[64] & 0xf0) << 12);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 516 to 531
	value = ((uint32_t)(input[64] & 0x0f) << 28) |
			((uint32_t)input[65] << 20) |
			((uint32_t)(input[66] & 0xf0) << 12);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 532 to 547
	value = ((uint32_t)(input[66] & 0x0f) << 28) |
			((uint32_t)input[67] << 20) |
			((uint32_t)(input[68] & 0xf0) << 12);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 548 to 563
	value = ((uint32_t)(input[68] & 0x0f) << 28) |
			((uint32_t)input[69] << 20) |
			((uint32_t)(input[70] & 0xf0) << 12);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 564 to 579
	value = ((uint32_t)(input[70] & 0x0f) << 28) |
			((uint32_t)input[71] << 20) |
			((uint32_t)(input[72] & 0xf0) << 12);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 580 to 595
	value = ((uint32_t)(input[72] & 0x0f) << 28) |
			((uint32_t)input[73] << 20) |
			((uint32_t)(input[74] & 0xf0) << 12);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 596 to 611
	value = ((uint32_t)(input[74] & 0x0f) << 28) |
			((uint32_t)input[75] << 20) |
			((uint32_t)(input[76] & 0xf0) << 12);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 612 to 627
	value = ((uint32_t)(input[76] & 0x0f) << 28) |
			((uint32_t)input[77] << 20) |
			((uint32_t)(input[78] & 0xf0) << 12);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 628 to 643
	value = ((uint32_t)(input[78] & 0x0f) << 28) |
			((uint32_t)input[79] << 20) |
			((uint32_t)(input[80] & 0xf0) << 12);
	output[39] = (double)(value >> 16);

	// read output[40]: from bit 644 to 659
	value = ((uint32_t)(input[80] & 0x0f) << 28) |
			((uint32_t)input[81] << 20) |
			((uint32_t)(input[82] & 0xf0) << 12);
	output[40] = (double)(value >> 16);

	// read output[41]: from bit 660 to 675
	value = ((uint32_t)(input[82] & 0x0f) << 28) |
			((uint32_t)input[83] << 20) |
			((uint32_t)(input[84] & 0xf0) << 12);
	output[41] = (double)(value >> 16);

	// read output[42]: from bit 676 to 691
	value = ((uint32_t)(input[84] & 0x0f) << 28) |
			((uint32_t)input[85] << 20) |
			((uint32_t)(input[86] & 0xf0) << 12);
	output[42] = (double)(value >> 16);
}

static void unpack_43_16bit_unsigned_4off(const uint8_t * input, double * output, void *closure) {
	// Unpack 43 values into output
	// Values are 16-bit unsigned
	// Skip 4 bits, read 688 bits of data.
	// Input must be at least 87 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 4 to 19
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20) |
			((uint32_t)(input[2] & 0xf0) << 12);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 20 to 35
	value = ((uint32_t)(input[2] & 0x0f) << 28) |
			((uint32_t)input[3] << 20) |
			((uint32_t)(input[4] & 0xf0) << 12);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 36 to 51
	value = ((uint32_t)(input[4] & 0x0f) << 28) |
			((uint32_t)input[5] << 20) |
			((uint32_t)(input[6] & 0xf0) << 12);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 52 to 67
	value = ((uint32_t)(input[6] & 0x0f) << 28) |
			((uint32_t)input[7] << 20) |
			((uint32_t)(input[8] & 0xf0) << 12);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 68 to 83
	value = ((uint32_t)(input[8] & 0x0f) << 28) |
			((uint32_t)input[9] << 20) |
			((uint32_t)(input[10] & 0xf0) << 12);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 84 to 99
	value = ((uint32_t)(input[10] & 0x0f) << 28) |
			((uint32_t)input[11] << 20) |
			((uint32_t)(input[12] & 0xf0) << 12);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 100 to 115
	value = ((uint32_t)(input[12] & 0x0f) << 28) |
			((uint32_t)input[13] << 20) |
			((uint32_t)(input[14] & 0xf0) << 12);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 116 to 131
	value = ((uint32_t)(input[14] & 0x0f) << 28) |
			((uint32_t)input[15] << 20) |
			((uint32_t)(input[16] & 0xf0) << 12);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 132 to 147
	value = ((uint32_t)(input[16] & 0x0f) << 28) |
			((uint32_t)input[17] << 20) |
			((uint32_t)(input[18] & 0xf0) << 12);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 148 to 163
	value = ((uint32_t)(input[18] & 0x0f) << 28) |
			((uint32_t)input[19] << 20) |
			((uint32_t)(input[20] & 0xf0) << 12);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 164 to 179
	value = ((uint32_t)(input[20] & 0x0f) << 28) |
			((uint32_t)input[21] << 20) |
			((uint32_t)(input[22] & 0xf0) << 12);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 180 to 195
	value = ((uint32_t)(input[22] & 0x0f) << 28) |
			((uint32_t)input[23] << 20) |
			((uint32_t)(input[24] & 0xf0) << 12);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 196 to 211
	value = ((uint32_t)(input[24] & 0x0f) << 28) |
			((uint32_t)input[25] << 20) |
			((uint32_t)(input[26] & 0xf0) << 12);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 212 to 227
	value = ((uint32_t)(input[26] & 0x0f) << 28) |
			((uint32_t)input[27] << 20) |
			((uint32_t)(input[28] & 0xf0) << 12);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 228 to 243
	value = ((uint32_t)(input[28] & 0x0f) << 28) |
			((uint32_t)input[29] << 20) |
			((uint32_t)(input[30] & 0xf0) << 12);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 244 to 259
	value = ((uint32_t)(input[30] & 0x0f) << 28) |
			((uint32_t)input[31] << 20) |
			((uint32_t)(input[32] & 0xf0) << 12);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 260 to 275
	value = ((uint32_t)(input[32] & 0x0f) << 28) |
			((uint32_t)input[33] << 20) |
			((uint32_t)(input[34] & 0xf0) << 12);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 276 to 291
	value = ((uint32_t)(input[34] & 0x0f) << 28) |
			((uint32_t)input[35] << 20) |
			((uint32_t)(input[36] & 0xf0) << 12);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 292 to 307
	value = ((uint32_t)(input[36] & 0x0f) << 28) |
			((uint32_t)input[37] << 20) |
			((uint32_t)(input[38] & 0xf0) << 12);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 308 to 323
	value = ((uint32_t)(input[38] & 0x0f) << 28) |
			((uint32_t)input[39] << 20) |
			((uint32_t)(input[40] & 0xf0) << 12);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 324 to 339
	value = ((uint32_t)(input[40] & 0x0f) << 28) |
			((uint32_t)input[41] << 20) |
			((uint32_t)(input[42] & 0xf0) << 12);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 340 to 355
	value = ((uint32_t)(input[42] & 0x0f) << 28) |
			((uint32_t)input[43] << 20) |
			((uint32_t)(input[44] & 0xf0) << 12);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 356 to 371
	value = ((uint32_t)(input[44] & 0x0f) << 28) |
			((uint32_t)input[45] << 20) |
			((uint32_t)(input[46] & 0xf0) << 12);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 372 to 387
	value = ((uint32_t)(input[46] & 0x0f) << 28) |
			((uint32_t)input[47] << 20) |
			((uint32_t)(input[48] & 0xf0) << 12);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 388 to 403
	value = ((uint32_t)(input[48] & 0x0f) << 28) |
			((uint32_t)input[49] << 20) |
			((uint32_t)(input[50] & 0xf0) << 12);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 404 to 419
	value = ((uint32_t)(input[50] & 0x0f) << 28) |
			((uint32_t)input[51] << 20) |
			((uint32_t)(input[52] & 0xf0) << 12);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 420 to 435
	value = ((uint32_t)(input[52] & 0x0f) << 28) |
			((uint32_t)input[53] << 20) |
			((uint32_t)(input[54] & 0xf0) << 12);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 436 to 451
	value = ((uint32_t)(input[54] & 0x0f) << 28) |
			((uint32_t)input[55] << 20) |
			((uint32_t)(input[56] & 0xf0) << 12);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 452 to 467
	value = ((uint32_t)(input[56] & 0x0f) << 28) |
			((uint32_t)input[57] << 20) |
			((uint32_t)(input[58] & 0xf0) << 12);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 468 to 483
	value = ((uint32_t)(input[58] & 0x0f) << 28) |
			((uint32_t)input[59] << 20) |
			((uint32_t)(input[60] & 0xf0) << 12);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 484 to 499
	value = ((uint32_t)(input[60] & 0x0f) << 28) |
			((uint32_t)input[61] << 20) |
			((uint32_t)(input[62] & 0xf0) << 12);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 500 to 515
	value = ((uint32_t)(input[62] & 0x0f) << 28) |
			((uint32_t)input[63] << 20) |
			((uint32_t)(input[64] & 0xf0) << 12);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 516 to 531
	value = ((uint32_t)(input[64] & 0x0f) << 28) |
			((uint32_t)input[65] << 20) |
			((uint32_t)(input[66] & 0xf0) << 12);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 532 to 547
	value = ((uint32_t)(input[66] & 0x0f) << 28) |
			((uint32_t)input[67] << 20) |
			((uint32_t)(input[68] & 0xf0) << 12);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 548 to 563
	value = ((uint32_t)(input[68] & 0x0f) << 28) |
			((uint32_t)input[69] << 20) |
			((uint32_t)(input[70] & 0xf0) << 12);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 564 to 579
	value = ((uint32_t)(input[70] & 0x0f) << 28) |
			((uint32_t)input[71] << 20) |
			((uint32_t)(input[72] & 0xf0) << 12);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 580 to 595
	value = ((uint32_t)(input[72] & 0x0f) << 28) |
			((uint32_t)input[73] << 20) |
			((uint32_t)(input[74] & 0xf0) << 12);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 596 to 611
	value = ((uint32_t)(input[74] & 0x0f) << 28) |
			((uint32_t)input[75] << 20) |
			((uint32_t)(input[76] & 0xf0) << 12);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 612 to 627
	value = ((uint32_t)(input[76] & 0x0f) << 28) |
			((uint32_t)input[77] << 20) |
			((uint32_t)(input[78] & 0xf0) << 12);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 628 to 643
	value = ((uint32_t)(input[78] & 0x0f) << 28) |
			((uint32_t)input[79] << 20) |
			((uint32_t)(input[80] & 0xf0) << 12);
	output[39] = (double)(value >> 16);

	// read output[40]: from bit 644 to 659
	value = ((uint32_t)(input[80] & 0x0f) << 28) |
			((uint32_t)input[81] << 20) |
			((uint32_t)(input[82] & 0xf0) << 12);
	output[40] = (double)(value >> 16);

	// read output[41]: from bit 660 to 675
	value = ((uint32_t)(input[82] & 0x0f) << 28) |
			((uint32_t)input[83] << 20) |
			((uint32_t)(input[84] & 0xf0) << 12);
	output[41] = (double)(value >> 16);

	// read output[42]: from bit 676 to 691
	value = ((uint32_t)(input[84] & 0x0f) << 28) |
			((uint32_t)input[85] << 20) |
			((uint32_t)(input[86] & 0xf0) << 12);
	output[42] = (double)(value >> 16);
}

static void unpack_43_16bit_signed_5off(const uint8_t * input, double * output, void *closure) {
	// Unpack 43 values into output
	// Values are 16-bit signed
	// Skip 5 bits, read 688 bits of data.
	// Input must be at least 87 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 5 to 20
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)(input[2] & 0xf8) << 13);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 21 to 36
	value = ((uint32_t)(input[2] & 0x07) << 29) |
			((uint32_t)input[3] << 21) |
			((uint32_t)(input[4] & 0xf8) << 13);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 37 to 52
	value = ((uint32_t)(input[4] & 0x07) << 29) |
			((uint32_t)input[5] << 21) |
			((uint32_t)(input[6] & 0xf8) << 13);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 53 to 68
	value = ((uint32_t)(input[6] & 0x07) << 29) |
			((uint32_t)input[7] << 21) |
			((uint32_t)(input[8] & 0xf8) << 13);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 69 to 84
	value = ((uint32_t)(input[8] & 0x07) << 29) |
			((uint32_t)input[9] << 21) |
			((uint32_t)(input[10] & 0xf8) << 13);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 85 to 100
	value = ((uint32_t)(input[10] & 0x07) << 29) |
			((uint32_t)input[11] << 21) |
			((uint32_t)(input[12] & 0xf8) << 13);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 101 to 116
	value = ((uint32_t)(input[12] & 0x07) << 29) |
			((uint32_t)input[13] << 21) |
			((uint32_t)(input[14] & 0xf8) << 13);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 117 to 132
	value = ((uint32_t)(input[14] & 0x07) << 29) |
			((uint32_t)input[15] << 21) |
			((uint32_t)(input[16] & 0xf8) << 13);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 133 to 148
	value = ((uint32_t)(input[16] & 0x07) << 29) |
			((uint32_t)input[17] << 21) |
			((uint32_t)(input[18] & 0xf8) << 13);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 149 to 164
	value = ((uint32_t)(input[18] & 0x07) << 29) |
			((uint32_t)input[19] << 21) |
			((uint32_t)(input[20] & 0xf8) << 13);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 165 to 180
	value = ((uint32_t)(input[20] & 0x07) << 29) |
			((uint32_t)input[21] << 21) |
			((uint32_t)(input[22] & 0xf8) << 13);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 181 to 196
	value = ((uint32_t)(input[22] & 0x07) << 29) |
			((uint32_t)input[23] << 21) |
			((uint32_t)(input[24] & 0xf8) << 13);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 197 to 212
	value = ((uint32_t)(input[24] & 0x07) << 29) |
			((uint32_t)input[25] << 21) |
			((uint32_t)(input[26] & 0xf8) << 13);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 213 to 228
	value = ((uint32_t)(input[26] & 0x07) << 29) |
			((uint32_t)input[27] << 21) |
			((uint32_t)(input[28] & 0xf8) << 13);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 229 to 244
	value = ((uint32_t)(input[28] & 0x07) << 29) |
			((uint32_t)input[29] << 21) |
			((uint32_t)(input[30] & 0xf8) << 13);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 245 to 260
	value = ((uint32_t)(input[30] & 0x07) << 29) |
			((uint32_t)input[31] << 21) |
			((uint32_t)(input[32] & 0xf8) << 13);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 261 to 276
	value = ((uint32_t)(input[32] & 0x07) << 29) |
			((uint32_t)input[33] << 21) |
			((uint32_t)(input[34] & 0xf8) << 13);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 277 to 292
	value = ((uint32_t)(input[34] & 0x07) << 29) |
			((uint32_t)input[35] << 21) |
			((uint32_t)(input[36] & 0xf8) << 13);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 293 to 308
	value = ((uint32_t)(input[36] & 0x07) << 29) |
			((uint32_t)input[37] << 21) |
			((uint32_t)(input[38] & 0xf8) << 13);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 309 to 324
	value = ((uint32_t)(input[38] & 0x07) << 29) |
			((uint32_t)input[39] << 21) |
			((uint32_t)(input[40] & 0xf8) << 13);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 325 to 340
	value = ((uint32_t)(input[40] & 0x07) << 29) |
			((uint32_t)input[41] << 21) |
			((uint32_t)(input[42] & 0xf8) << 13);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 341 to 356
	value = ((uint32_t)(input[42] & 0x07) << 29) |
			((uint32_t)input[43] << 21) |
			((uint32_t)(input[44] & 0xf8) << 13);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 357 to 372
	value = ((uint32_t)(input[44] & 0x07) << 29) |
			((uint32_t)input[45] << 21) |
			((uint32_t)(input[46] & 0xf8) << 13);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 373 to 388
	value = ((uint32_t)(input[46] & 0x07) << 29) |
			((uint32_t)input[47] << 21) |
			((uint32_t)(input[48] & 0xf8) << 13);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 389 to 404
	value = ((uint32_t)(input[48] & 0x07) << 29) |
			((uint32_t)input[49] << 21) |
			((uint32_t)(input[50] & 0xf8) << 13);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 405 to 420
	value = ((uint32_t)(input[50] & 0x07) << 29) |
			((uint32_t)input[51] << 21) |
			((uint32_t)(input[52] & 0xf8) << 13);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 421 to 436
	value = ((uint32_t)(input[52] & 0x07) << 29) |
			((uint32_t)input[53] << 21) |
			((uint32_t)(input[54] & 0xf8) << 13);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 437 to 452
	value = ((uint32_t)(input[54] & 0x07) << 29) |
			((uint32_t)input[55] << 21) |
			((uint32_t)(input[56] & 0xf8) << 13);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 453 to 468
	value = ((uint32_t)(input[56] & 0x07) << 29) |
			((uint32_t)input[57] << 21) |
			((uint32_t)(input[58] & 0xf8) << 13);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 469 to 484
	value = ((uint32_t)(input[58] & 0x07) << 29) |
			((uint32_t)input[59] << 21) |
			((uint32_t)(input[60] & 0xf8) << 13);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 485 to 500
	value = ((uint32_t)(input[60] & 0x07) << 29) |
			((uint32_t)input[61] << 21) |
			((uint32_t)(input[62] & 0xf8) << 13);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 501 to 516
	value = ((uint32_t)(input[62] & 0x07) << 29) |
			((uint32_t)input[63] << 21) |
			((uint32_t)(input[64] & 0xf8) << 13);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 517 to 532
	value = ((uint32_t)(input[64] & 0x07) << 29) |
			((uint32_t)input[65] << 21) |
			((uint32_t)(input[66] & 0xf8) << 13);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 533 to 548
	value = ((uint32_t)(input[66] & 0x07) << 29) |
			((uint32_t)input[67] << 21) |
			((uint32_t)(input[68] & 0xf8) << 13);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 549 to 564
	value = ((uint32_t)(input[68] & 0x07) << 29) |
			((uint32_t)input[69] << 21) |
			((uint32_t)(input[70] & 0xf8) << 13);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 565 to 580
	value = ((uint32_t)(input[70] & 0x07) << 29) |
			((uint32_t)input[71] << 21) |
			((uint32_t)(input[72] & 0xf8) << 13);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 581 to 596
	value = ((uint32_t)(input[72] & 0x07) << 29) |
			((uint32_t)input[73] << 21) |
			((uint32_t)(input[74] & 0xf8) << 13);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 597 to 612
	value = ((uint32_t)(input[74] & 0x07) << 29) |
			((uint32_t)input[75] << 21) |
			((uint32_t)(input[76] & 0xf8) << 13);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 613 to 628
	value = ((uint32_t)(input[76] & 0x07) << 29) |
			((uint32_t)input[77] << 21) |
			((uint32_t)(input[78] & 0xf8) << 13);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 629 to 644
	value = ((uint32_t)(input[78] & 0x07) << 29) |
			((uint32_t)input[79] << 21) |
			((uint32_t)(input[80] & 0xf8) << 13);
	output[39] = (double)(value >> 16);

	// read output[40]: from bit 645 to 660
	value = ((uint32_t)(input[80] & 0x07) << 29) |
			((uint32_t)input[81] << 21) |
			((uint32_t)(input[82] & 0xf8) << 13);
	output[40] = (double)(value >> 16);

	// read output[41]: from bit 661 to 676
	value = ((uint32_t)(input[82] & 0x07) << 29) |
			((uint32_t)input[83] << 21) |
			((uint32_t)(input[84] & 0xf8) << 13);
	output[41] = (double)(value >> 16);

	// read output[42]: from bit 677 to 692
	value = ((uint32_t)(input[84] & 0x07) << 29) |
			((uint32_t)input[85] << 21) |
			((uint32_t)(input[86] & 0xf8) << 13);
	output[42] = (double)(value >> 16);
}

static void unpack_43_16bit_unsigned_5off(const uint8_t * input, double * output, void *closure) {
	// Unpack 43 values into output
	// Values are 16-bit unsigned
	// Skip 5 bits, read 688 bits of data.
	// Input must be at least 87 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 5 to 20
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)(input[2] & 0xf8) << 13);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 21 to 36
	value = ((uint32_t)(input[2] & 0x07) << 29) |
			((uint32_t)input[3] << 21) |
			((uint32_t)(input[4] & 0xf8) << 13);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 37 to 52
	value = ((uint32_t)(input[4] & 0x07) << 29) |
			((uint32_t)input[5] << 21) |
			((uint32_t)(input[6] & 0xf8) << 13);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 53 to 68
	value = ((uint32_t)(input[6] & 0x07) << 29) |
			((uint32_t)input[7] << 21) |
			((uint32_t)(input[8] & 0xf8) << 13);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 69 to 84
	value = ((uint32_t)(input[8] & 0x07) << 29) |
			((uint32_t)input[9] << 21) |
			((uint32_t)(input[10] & 0xf8) << 13);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 85 to 100
	value = ((uint32_t)(input[10] & 0x07) << 29) |
			((uint32_t)input[11] << 21) |
			((uint32_t)(input[12] & 0xf8) << 13);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 101 to 116
	value = ((uint32_t)(input[12] & 0x07) << 29) |
			((uint32_t)input[13] << 21) |
			((uint32_t)(input[14] & 0xf8) << 13);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 117 to 132
	value = ((uint32_t)(input[14] & 0x07) << 29) |
			((uint32_t)input[15] << 21) |
			((uint32_t)(input[16] & 0xf8) << 13);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 133 to 148
	value = ((uint32_t)(input[16] & 0x07) << 29) |
			((uint32_t)input[17] << 21) |
			((uint32_t)(input[18] & 0xf8) << 13);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 149 to 164
	value = ((uint32_t)(input[18] & 0x07) << 29) |
			((uint32_t)input[19] << 21) |
			((uint32_t)(input[20] & 0xf8) << 13);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 165 to 180
	value = ((uint32_t)(input[20] & 0x07) << 29) |
			((uint32_t)input[21] << 21) |
			((uint32_t)(input[22] & 0xf8) << 13);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 181 to 196
	value = ((uint32_t)(input[22] & 0x07) << 29) |
			((uint32_t)input[23] << 21) |
			((uint32_t)(input[24] & 0xf8) << 13);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 197 to 212
	value = ((uint32_t)(input[24] & 0x07) << 29) |
			((uint32_t)input[25] << 21) |
			((uint32_t)(input[26] & 0xf8) << 13);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 213 to 228
	value = ((uint32_t)(input[26] & 0x07) << 29) |
			((uint32_t)input[27] << 21) |
			((uint32_t)(input[28] & 0xf8) << 13);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 229 to 244
	value = ((uint32_t)(input[28] & 0x07) << 29) |
			((uint32_t)input[29] << 21) |
			((uint32_t)(input[30] & 0xf8) << 13);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 245 to 260
	value = ((uint32_t)(input[30] & 0x07) << 29) |
			((uint32_t)input[31] << 21) |
			((uint32_t)(input[32] & 0xf8) << 13);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 261 to 276
	value = ((uint32_t)(input[32] & 0x07) << 29) |
			((uint32_t)input[33] << 21) |
			((uint32_t)(input[34] & 0xf8) << 13);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 277 to 292
	value = ((uint32_t)(input[34] & 0x07) << 29) |
			((uint32_t)input[35] << 21) |
			((uint32_t)(input[36] & 0xf8) << 13);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 293 to 308
	value = ((uint32_t)(input[36] & 0x07) << 29) |
			((uint32_t)input[37] << 21) |
			((uint32_t)(input[38] & 0xf8) << 13);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 309 to 324
	value = ((uint32_t)(input[38] & 0x07) << 29) |
			((uint32_t)input[39] << 21) |
			((uint32_t)(input[40] & 0xf8) << 13);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 325 to 340
	value = ((uint32_t)(input[40] & 0x07) << 29) |
			((uint32_t)input[41] << 21) |
			((uint32_t)(input[42] & 0xf8) << 13);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 341 to 356
	value = ((uint32_t)(input[42] & 0x07) << 29) |
			((uint32_t)input[43] << 21) |
			((uint32_t)(input[44] & 0xf8) << 13);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 357 to 372
	value = ((uint32_t)(input[44] & 0x07) << 29) |
			((uint32_t)input[45] << 21) |
			((uint32_t)(input[46] & 0xf8) << 13);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 373 to 388
	value = ((uint32_t)(input[46] & 0x07) << 29) |
			((uint32_t)input[47] << 21) |
			((uint32_t)(input[48] & 0xf8) << 13);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 389 to 404
	value = ((uint32_t)(input[48] & 0x07) << 29) |
			((uint32_t)input[49] << 21) |
			((uint32_t)(input[50] & 0xf8) << 13);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 405 to 420
	value = ((uint32_t)(input[50] & 0x07) << 29) |
			((uint32_t)input[51] << 21) |
			((uint32_t)(input[52] & 0xf8) << 13);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 421 to 436
	value = ((uint32_t)(input[52] & 0x07) << 29) |
			((uint32_t)input[53] << 21) |
			((uint32_t)(input[54] & 0xf8) << 13);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 437 to 452
	value = ((uint32_t)(input[54] & 0x07) << 29) |
			((uint32_t)input[55] << 21) |
			((uint32_t)(input[56] & 0xf8) << 13);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 453 to 468
	value = ((uint32_t)(input[56] & 0x07) << 29) |
			((uint32_t)input[57] << 21) |
			((uint32_t)(input[58] & 0xf8) << 13);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 469 to 484
	value = ((uint32_t)(input[58] & 0x07) << 29) |
			((uint32_t)input[59] << 21) |
			((uint32_t)(input[60] & 0xf8) << 13);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 485 to 500
	value = ((uint32_t)(input[60] & 0x07) << 29) |
			((uint32_t)input[61] << 21) |
			((uint32_t)(input[62] & 0xf8) << 13);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 501 to 516
	value = ((uint32_t)(input[62] & 0x07) << 29) |
			((uint32_t)input[63] << 21) |
			((uint32_t)(input[64] & 0xf8) << 13);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 517 to 532
	value = ((uint32_t)(input[64] & 0x07) << 29) |
			((uint32_t)input[65] << 21) |
			((uint32_t)(input[66] & 0xf8) << 13);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 533 to 548
	value = ((uint32_t)(input[66] & 0x07) << 29) |
			((uint32_t)input[67] << 21) |
			((uint32_t)(input[68] & 0xf8) << 13);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 549 to 564
	value = ((uint32_t)(input[68] & 0x07) << 29) |
			((uint32_t)input[69] << 21) |
			((uint32_t)(input[70] & 0xf8) << 13);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 565 to 580
	value = ((uint32_t)(input[70] & 0x07) << 29) |
			((uint32_t)input[71] << 21) |
			((uint32_t)(input[72] & 0xf8) << 13);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 581 to 596
	value = ((uint32_t)(input[72] & 0x07) << 29) |
			((uint32_t)input[73] << 21) |
			((uint32_t)(input[74] & 0xf8) << 13);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 597 to 612
	value = ((uint32_t)(input[74] & 0x07) << 29) |
			((uint32_t)input[75] << 21) |
			((uint32_t)(input[76] & 0xf8) << 13);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 613 to 628
	value = ((uint32_t)(input[76] & 0x07) << 29) |
			((uint32_t)input[77] << 21) |
			((uint32_t)(input[78] & 0xf8) << 13);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 629 to 644
	value = ((uint32_t)(input[78] & 0x07) << 29) |
			((uint32_t)input[79] << 21) |
			((uint32_t)(input[80] & 0xf8) << 13);
	output[39] = (double)(value >> 16);

	// read output[40]: from bit 645 to 660
	value = ((uint32_t)(input[80] & 0x07) << 29) |
			((uint32_t)input[81] << 21) |
			((uint32_t)(input[82] & 0xf8) << 13);
	output[40] = (double)(value >> 16);

	// read output[41]: from bit 661 to 676
	value = ((uint32_t)(input[82] & 0x07) << 29) |
			((uint32_t)input[83] << 21) |
			((uint32_t)(input[84] & 0xf8) << 13);
	output[41] = (double)(value >> 16);

	// read output[42]: from bit 677 to 692
	value = ((uint32_t)(input[84] & 0x07) << 29) |
			((uint32_t)input[85] << 21) |
			((uint32_t)(input[86] & 0xf8) << 13);
	output[42] = (double)(value >> 16);
}

static void unpack_43_16bit_signed_6off(const uint8_t * input, double * output, void *closure) {
	// Unpack 43 values into output
	// Values are 16-bit signed
	// Skip 6 bits, read 688 bits of data.
	// Input must be at least 87 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 6 to 21
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)(input[2] & 0xfc) << 14);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 22 to 37
	value = ((uint32_t)(input[2] & 0x03) << 30) |
			((uint32_t)input[3] << 22) |
			((uint32_t)(input[4] & 0xfc) << 14);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 38 to 53
	value = ((uint32_t)(input[4] & 0x03) << 30) |
			((uint32_t)input[5] << 22) |
			((uint32_t)(input[6] & 0xfc) << 14);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 54 to 69
	value = ((uint32_t)(input[6] & 0x03) << 30) |
			((uint32_t)input[7] << 22) |
			((uint32_t)(input[8] & 0xfc) << 14);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 70 to 85
	value = ((uint32_t)(input[8] & 0x03) << 30) |
			((uint32_t)input[9] << 22) |
			((uint32_t)(input[10] & 0xfc) << 14);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 86 to 101
	value = ((uint32_t)(input[10] & 0x03) << 30) |
			((uint32_t)input[11] << 22) |
			((uint32_t)(input[12] & 0xfc) << 14);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 102 to 117
	value = ((uint32_t)(input[12] & 0x03) << 30) |
			((uint32_t)input[13] << 22) |
			((uint32_t)(input[14] & 0xfc) << 14);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 118 to 133
	value = ((uint32_t)(input[14] & 0x03) << 30) |
			((uint32_t)input[15] << 22) |
			((uint32_t)(input[16] & 0xfc) << 14);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 134 to 149
	value = ((uint32_t)(input[16] & 0x03) << 30) |
			((uint32_t)input[17] << 22) |
			((uint32_t)(input[18] & 0xfc) << 14);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 150 to 165
	value = ((uint32_t)(input[18] & 0x03) << 30) |
			((uint32_t)input[19] << 22) |
			((uint32_t)(input[20] & 0xfc) << 14);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 166 to 181
	value = ((uint32_t)(input[20] & 0x03) << 30) |
			((uint32_t)input[21] << 22) |
			((uint32_t)(input[22] & 0xfc) << 14);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 182 to 197
	value = ((uint32_t)(input[22] & 0x03) << 30) |
			((uint32_t)input[23] << 22) |
			((uint32_t)(input[24] & 0xfc) << 14);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 198 to 213
	value = ((uint32_t)(input[24] & 0x03) << 30) |
			((uint32_t)input[25] << 22) |
			((uint32_t)(input[26] & 0xfc) << 14);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 214 to 229
	value = ((uint32_t)(input[26] & 0x03) << 30) |
			((uint32_t)input[27] << 22) |
			((uint32_t)(input[28] & 0xfc) << 14);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 230 to 245
	value = ((uint32_t)(input[28] & 0x03) << 30) |
			((uint32_t)input[29] << 22) |
			((uint32_t)(input[30] & 0xfc) << 14);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 246 to 261
	value = ((uint32_t)(input[30] & 0x03) << 30) |
			((uint32_t)input[31] << 22) |
			((uint32_t)(input[32] & 0xfc) << 14);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 262 to 277
	value = ((uint32_t)(input[32] & 0x03) << 30) |
			((uint32_t)input[33] << 22) |
			((uint32_t)(input[34] & 0xfc) << 14);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 278 to 293
	value = ((uint32_t)(input[34] & 0x03) << 30) |
			((uint32_t)input[35] << 22) |
			((uint32_t)(input[36] & 0xfc) << 14);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 294 to 309
	value = ((uint32_t)(input[36] & 0x03) << 30) |
			((uint32_t)input[37] << 22) |
			((uint32_t)(input[38] & 0xfc) << 14);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 310 to 325
	value = ((uint32_t)(input[38] & 0x03) << 30) |
			((uint32_t)input[39] << 22) |
			((uint32_t)(input[40] & 0xfc) << 14);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 326 to 341
	value = ((uint32_t)(input[40] & 0x03) << 30) |
			((uint32_t)input[41] << 22) |
			((uint32_t)(input[42] & 0xfc) << 14);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 342 to 357
	value = ((uint32_t)(input[42] & 0x03) << 30) |
			((uint32_t)input[43] << 22) |
			((uint32_t)(input[44] & 0xfc) << 14);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 358 to 373
	value = ((uint32_t)(input[44] & 0x03) << 30) |
			((uint32_t)input[45] << 22) |
			((uint32_t)(input[46] & 0xfc) << 14);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 374 to 389
	value = ((uint32_t)(input[46] & 0x03) << 30) |
			((uint32_t)input[47] << 22) |
			((uint32_t)(input[48] & 0xfc) << 14);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 390 to 405
	value = ((uint32_t)(input[48] & 0x03) << 30) |
			((uint32_t)input[49] << 22) |
			((uint32_t)(input[50] & 0xfc) << 14);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 406 to 421
	value = ((uint32_t)(input[50] & 0x03) << 30) |
			((uint32_t)input[51] << 22) |
			((uint32_t)(input[52] & 0xfc) << 14);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 422 to 437
	value = ((uint32_t)(input[52] & 0x03) << 30) |
			((uint32_t)input[53] << 22) |
			((uint32_t)(input[54] & 0xfc) << 14);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 438 to 453
	value = ((uint32_t)(input[54] & 0x03) << 30) |
			((uint32_t)input[55] << 22) |
			((uint32_t)(input[56] & 0xfc) << 14);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 454 to 469
	value = ((uint32_t)(input[56] & 0x03) << 30) |
			((uint32_t)input[57] << 22) |
			((uint32_t)(input[58] & 0xfc) << 14);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 470 to 485
	value = ((uint32_t)(input[58] & 0x03) << 30) |
			((uint32_t)input[59] << 22) |
			((uint32_t)(input[60] & 0xfc) << 14);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 486 to 501
	value = ((uint32_t)(input[60] & 0x03) << 30) |
			((uint32_t)input[61] << 22) |
			((uint32_t)(input[62] & 0xfc) << 14);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 502 to 517
	value = ((uint32_t)(input[62] & 0x03) << 30) |
			((uint32_t)input[63] << 22) |
			((uint32_t)(input[64] & 0xfc) << 14);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 518 to 533
	value = ((uint32_t)(input[64] & 0x03) << 30) |
			((uint32_t)input[65] << 22) |
			((uint32_t)(input[66] & 0xfc) << 14);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 534 to 549
	value = ((uint32_t)(input[66] & 0x03) << 30) |
			((uint32_t)input[67] << 22) |
			((uint32_t)(input[68] & 0xfc) << 14);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 550 to 565
	value = ((uint32_t)(input[68] & 0x03) << 30) |
			((uint32_t)input[69] << 22) |
			((uint32_t)(input[70] & 0xfc) << 14);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 566 to 581
	value = ((uint32_t)(input[70] & 0x03) << 30) |
			((uint32_t)input[71] << 22) |
			((uint32_t)(input[72] & 0xfc) << 14);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 582 to 597
	value = ((uint32_t)(input[72] & 0x03) << 30) |
			((uint32_t)input[73] << 22) |
			((uint32_t)(input[74] & 0xfc) << 14);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 598 to 613
	value = ((uint32_t)(input[74] & 0x03) << 30) |
			((uint32_t)input[75] << 22) |
			((uint32_t)(input[76] & 0xfc) << 14);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 614 to 629
	value = ((uint32_t)(input[76] & 0x03) << 30) |
			((uint32_t)input[77] << 22) |
			((uint32_t)(input[78] & 0xfc) << 14);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 630 to 645
	value = ((uint32_t)(input[78] & 0x03) << 30) |
			((uint32_t)input[79] << 22) |
			((uint32_t)(input[80] & 0xfc) << 14);
	output[39] = (double)(value >> 16);

	// read output[40]: from bit 646 to 661
	value = ((uint32_t)(input[80] & 0x03) << 30) |
			((uint32_t)input[81] << 22) |
			((uint32_t)(input[82] & 0xfc) << 14);
	output[40] = (double)(value >> 16);

	// read output[41]: from bit 662 to 677
	value = ((uint32_t)(input[82] & 0x03) << 30) |
			((uint32_t)input[83] << 22) |
			((uint32_t)(input[84] & 0xfc) << 14);
	output[41] = (double)(value >> 16);

	// read output[42]: from bit 678 to 693
	value = ((uint32_t)(input[84] & 0x03) << 30) |
			((uint32_t)input[85] << 22) |
			((uint32_t)(input[86] & 0xfc) << 14);
	output[42] = (double)(value >> 16);
}

static void unpack_43_16bit_unsigned_6off(const uint8_t * input, double * output, void *closure) {
	// Unpack 43 values into output
	// Values are 16-bit unsigned
	// Skip 6 bits, read 688 bits of data.
	// Input must be at least 87 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 6 to 21
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)(input[2] & 0xfc) << 14);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 22 to 37
	value = ((uint32_t)(input[2] & 0x03) << 30) |
			((uint32_t)input[3] << 22) |
			((uint32_t)(input[4] & 0xfc) << 14);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 38 to 53
	value = ((uint32_t)(input[4] & 0x03) << 30) |
			((uint32_t)input[5] << 22) |
			((uint32_t)(input[6] & 0xfc) << 14);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 54 to 69
	value = ((uint32_t)(input[6] & 0x03) << 30) |
			((uint32_t)input[7] << 22) |
			((uint32_t)(input[8] & 0xfc) << 14);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 70 to 85
	value = ((uint32_t)(input[8] & 0x03) << 30) |
			((uint32_t)input[9] << 22) |
			((uint32_t)(input[10] & 0xfc) << 14);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 86 to 101
	value = ((uint32_t)(input[10] & 0x03) << 30) |
			((uint32_t)input[11] << 22) |
			((uint32_t)(input[12] & 0xfc) << 14);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 102 to 117
	value = ((uint32_t)(input[12] & 0x03) << 30) |
			((uint32_t)input[13] << 22) |
			((uint32_t)(input[14] & 0xfc) << 14);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 118 to 133
	value = ((uint32_t)(input[14] & 0x03) << 30) |
			((uint32_t)input[15] << 22) |
			((uint32_t)(input[16] & 0xfc) << 14);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 134 to 149
	value = ((uint32_t)(input[16] & 0x03) << 30) |
			((uint32_t)input[17] << 22) |
			((uint32_t)(input[18] & 0xfc) << 14);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 150 to 165
	value = ((uint32_t)(input[18] & 0x03) << 30) |
			((uint32_t)input[19] << 22) |
			((uint32_t)(input[20] & 0xfc) << 14);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 166 to 181
	value = ((uint32_t)(input[20] & 0x03) << 30) |
			((uint32_t)input[21] << 22) |
			((uint32_t)(input[22] & 0xfc) << 14);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 182 to 197
	value = ((uint32_t)(input[22] & 0x03) << 30) |
			((uint32_t)input[23] << 22) |
			((uint32_t)(input[24] & 0xfc) << 14);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 198 to 213
	value = ((uint32_t)(input[24] & 0x03) << 30) |
			((uint32_t)input[25] << 22) |
			((uint32_t)(input[26] & 0xfc) << 14);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 214 to 229
	value = ((uint32_t)(input[26] & 0x03) << 30) |
			((uint32_t)input[27] << 22) |
			((uint32_t)(input[28] & 0xfc) << 14);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 230 to 245
	value = ((uint32_t)(input[28] & 0x03) << 30) |
			((uint32_t)input[29] << 22) |
			((uint32_t)(input[30] & 0xfc) << 14);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 246 to 261
	value = ((uint32_t)(input[30] & 0x03) << 30) |
			((uint32_t)input[31] << 22) |
			((uint32_t)(input[32] & 0xfc) << 14);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 262 to 277
	value = ((uint32_t)(input[32] & 0x03) << 30) |
			((uint32_t)input[33] << 22) |
			((uint32_t)(input[34] & 0xfc) << 14);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 278 to 293
	value = ((uint32_t)(input[34] & 0x03) << 30) |
			((uint32_t)input[35] << 22) |
			((uint32_t)(input[36] & 0xfc) << 14);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 294 to 309
	value = ((uint32_t)(input[36] & 0x03) << 30) |
			((uint32_t)input[37] << 22) |
			((uint32_t)(input[38] & 0xfc) << 14);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 310 to 325
	value = ((uint32_t)(input[38] & 0x03) << 30) |
			((uint32_t)input[39] << 22) |
			((uint32_t)(input[40] & 0xfc) << 14);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 326 to 341
	value = ((uint32_t)(input[40] & 0x03) << 30) |
			((uint32_t)input[41] << 22) |
			((uint32_t)(input[42] & 0xfc) << 14);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 342 to 357
	value = ((uint32_t)(input[42] & 0x03) << 30) |
			((uint32_t)input[43] << 22) |
			((uint32_t)(input[44] & 0xfc) << 14);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 358 to 373
	value = ((uint32_t)(input[44] & 0x03) << 30) |
			((uint32_t)input[45] << 22) |
			((uint32_t)(input[46] & 0xfc) << 14);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 374 to 389
	value = ((uint32_t)(input[46] & 0x03) << 30) |
			((uint32_t)input[47] << 22) |
			((uint32_t)(input[48] & 0xfc) << 14);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 390 to 405
	value = ((uint32_t)(input[48] & 0x03) << 30) |
			((uint32_t)input[49] << 22) |
			((uint32_t)(input[50] & 0xfc) << 14);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 406 to 421
	value = ((uint32_t)(input[50] & 0x03) << 30) |
			((uint32_t)input[51] << 22) |
			((uint32_t)(input[52] & 0xfc) << 14);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 422 to 437
	value = ((uint32_t)(input[52] & 0x03) << 30) |
			((uint32_t)input[53] << 22) |
			((uint32_t)(input[54] & 0xfc) << 14);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 438 to 453
	value = ((uint32_t)(input[54] & 0x03) << 30) |
			((uint32_t)input[55] << 22) |
			((uint32_t)(input[56] & 0xfc) << 14);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 454 to 469
	value = ((uint32_t)(input[56] & 0x03) << 30) |
			((uint32_t)input[57] << 22) |
			((uint32_t)(input[58] & 0xfc) << 14);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 470 to 485
	value = ((uint32_t)(input[58] & 0x03) << 30) |
			((uint32_t)input[59] << 22) |
			((uint32_t)(input[60] & 0xfc) << 14);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 486 to 501
	value = ((uint32_t)(input[60] & 0x03) << 30) |
			((uint32_t)input[61] << 22) |
			((uint32_t)(input[62] & 0xfc) << 14);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 502 to 517
	value = ((uint32_t)(input[62] & 0x03) << 30) |
			((uint32_t)input[63] << 22) |
			((uint32_t)(input[64] & 0xfc) << 14);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 518 to 533
	value = ((uint32_t)(input[64] & 0x03) << 30) |
			((uint32_t)input[65] << 22) |
			((uint32_t)(input[66] & 0xfc) << 14);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 534 to 549
	value = ((uint32_t)(input[66] & 0x03) << 30) |
			((uint32_t)input[67] << 22) |
			((uint32_t)(input[68] & 0xfc) << 14);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 550 to 565
	value = ((uint32_t)(input[68] & 0x03) << 30) |
			((uint32_t)input[69] << 22) |
			((uint32_t)(input[70] & 0xfc) << 14);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 566 to 581
	value = ((uint32_t)(input[70] & 0x03) << 30) |
			((uint32_t)input[71] << 22) |
			((uint32_t)(input[72] & 0xfc) << 14);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 582 to 597
	value = ((uint32_t)(input[72] & 0x03) << 30) |
			((uint32_t)input[73] << 22) |
			((uint32_t)(input[74] & 0xfc) << 14);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 598 to 613
	value = ((uint32_t)(input[74] & 0x03) << 30) |
			((uint32_t)input[75] << 22) |
			((uint32_t)(input[76] & 0xfc) << 14);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 614 to 629
	value = ((uint32_t)(input[76] & 0x03) << 30) |
			((uint32_t)input[77] << 22) |
			((uint32_t)(input[78] & 0xfc) << 14);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 630 to 645
	value = ((uint32_t)(input[78] & 0x03) << 30) |
			((uint32_t)input[79] << 22) |
			((uint32_t)(input[80] & 0xfc) << 14);
	output[39] = (double)(value >> 16);

	// read output[40]: from bit 646 to 661
	value = ((uint32_t)(input[80] & 0x03) << 30) |
			((uint32_t)input[81] << 22) |
			((uint32_t)(input[82] & 0xfc) << 14);
	output[40] = (double)(value >> 16);

	// read output[41]: from bit 662 to 677
	value = ((uint32_t)(input[82] & 0x03) << 30) |
			((uint32_t)input[83] << 22) |
			((uint32_t)(input[84] & 0xfc) << 14);
	output[41] = (double)(value >> 16);

	// read output[42]: from bit 678 to 693
	value = ((uint32_t)(input[84] & 0x03) << 30) |
			((uint32_t)input[85] << 22) |
			((uint32_t)(input[86] & 0xfc) << 14);
	output[42] = (double)(value >> 16);
}

static void unpack_43_16bit_signed_7off(const uint8_t * input, double * output, void *closure) {
	// Unpack 43 values into output
	// Values are 16-bit signed
	// Skip 7 bits, read 688 bits of data.
	// Input must be at least 87 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 7 to 22
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)(input[2] & 0xfe) << 15);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 23 to 38
	value = ((uint32_t)(input[2] & 0x01) << 31) |
			((uint32_t)input[3] << 23) |
			((uint32_t)(input[4] & 0xfe) << 15);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 39 to 54
	value = ((uint32_t)(input[4] & 0x01) << 31) |
			((uint32_t)input[5] << 23) |
			((uint32_t)(input[6] & 0xfe) << 15);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 55 to 70
	value = ((uint32_t)(input[6] & 0x01) << 31) |
			((uint32_t)input[7] << 23) |
			((uint32_t)(input[8] & 0xfe) << 15);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 71 to 86
	value = ((uint32_t)(input[8] & 0x01) << 31) |
			((uint32_t)input[9] << 23) |
			((uint32_t)(input[10] & 0xfe) << 15);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 87 to 102
	value = ((uint32_t)(input[10] & 0x01) << 31) |
			((uint32_t)input[11] << 23) |
			((uint32_t)(input[12] & 0xfe) << 15);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 103 to 118
	value = ((uint32_t)(input[12] & 0x01) << 31) |
			((uint32_t)input[13] << 23) |
			((uint32_t)(input[14] & 0xfe) << 15);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 119 to 134
	value = ((uint32_t)(input[14] & 0x01) << 31) |
			((uint32_t)input[15] << 23) |
			((uint32_t)(input[16] & 0xfe) << 15);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 135 to 150
	value = ((uint32_t)(input[16] & 0x01) << 31) |
			((uint32_t)input[17] << 23) |
			((uint32_t)(input[18] & 0xfe) << 15);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 151 to 166
	value = ((uint32_t)(input[18] & 0x01) << 31) |
			((uint32_t)input[19] << 23) |
			((uint32_t)(input[20] & 0xfe) << 15);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 167 to 182
	value = ((uint32_t)(input[20] & 0x01) << 31) |
			((uint32_t)input[21] << 23) |
			((uint32_t)(input[22] & 0xfe) << 15);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 183 to 198
	value = ((uint32_t)(input[22] & 0x01) << 31) |
			((uint32_t)input[23] << 23) |
			((uint32_t)(input[24] & 0xfe) << 15);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 199 to 214
	value = ((uint32_t)(input[24] & 0x01) << 31) |
			((uint32_t)input[25] << 23) |
			((uint32_t)(input[26] & 0xfe) << 15);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 215 to 230
	value = ((uint32_t)(input[26] & 0x01) << 31) |
			((uint32_t)input[27] << 23) |
			((uint32_t)(input[28] & 0xfe) << 15);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 231 to 246
	value = ((uint32_t)(input[28] & 0x01) << 31) |
			((uint32_t)input[29] << 23) |
			((uint32_t)(input[30] & 0xfe) << 15);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 247 to 262
	value = ((uint32_t)(input[30] & 0x01) << 31) |
			((uint32_t)input[31] << 23) |
			((uint32_t)(input[32] & 0xfe) << 15);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 263 to 278
	value = ((uint32_t)(input[32] & 0x01) << 31) |
			((uint32_t)input[33] << 23) |
			((uint32_t)(input[34] & 0xfe) << 15);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 279 to 294
	value = ((uint32_t)(input[34] & 0x01) << 31) |
			((uint32_t)input[35] << 23) |
			((uint32_t)(input[36] & 0xfe) << 15);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 295 to 310
	value = ((uint32_t)(input[36] & 0x01) << 31) |
			((uint32_t)input[37] << 23) |
			((uint32_t)(input[38] & 0xfe) << 15);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 311 to 326
	value = ((uint32_t)(input[38] & 0x01) << 31) |
			((uint32_t)input[39] << 23) |
			((uint32_t)(input[40] & 0xfe) << 15);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 327 to 342
	value = ((uint32_t)(input[40] & 0x01) << 31) |
			((uint32_t)input[41] << 23) |
			((uint32_t)(input[42] & 0xfe) << 15);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 343 to 358
	value = ((uint32_t)(input[42] & 0x01) << 31) |
			((uint32_t)input[43] << 23) |
			((uint32_t)(input[44] & 0xfe) << 15);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 359 to 374
	value = ((uint32_t)(input[44] & 0x01) << 31) |
			((uint32_t)input[45] << 23) |
			((uint32_t)(input[46] & 0xfe) << 15);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 375 to 390
	value = ((uint32_t)(input[46] & 0x01) << 31) |
			((uint32_t)input[47] << 23) |
			((uint32_t)(input[48] & 0xfe) << 15);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 391 to 406
	value = ((uint32_t)(input[48] & 0x01) << 31) |
			((uint32_t)input[49] << 23) |
			((uint32_t)(input[50] & 0xfe) << 15);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 407 to 422
	value = ((uint32_t)(input[50] & 0x01) << 31) |
			((uint32_t)input[51] << 23) |
			((uint32_t)(input[52] & 0xfe) << 15);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 423 to 438
	value = ((uint32_t)(input[52] & 0x01) << 31) |
			((uint32_t)input[53] << 23) |
			((uint32_t)(input[54] & 0xfe) << 15);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 439 to 454
	value = ((uint32_t)(input[54] & 0x01) << 31) |
			((uint32_t)input[55] << 23) |
			((uint32_t)(input[56] & 0xfe) << 15);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 455 to 470
	value = ((uint32_t)(input[56] & 0x01) << 31) |
			((uint32_t)input[57] << 23) |
			((uint32_t)(input[58] & 0xfe) << 15);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 471 to 486
	value = ((uint32_t)(input[58] & 0x01) << 31) |
			((uint32_t)input[59] << 23) |
			((uint32_t)(input[60] & 0xfe) << 15);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 487 to 502
	value = ((uint32_t)(input[60] & 0x01) << 31) |
			((uint32_t)input[61] << 23) |
			((uint32_t)(input[62] & 0xfe) << 15);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 503 to 518
	value = ((uint32_t)(input[62] & 0x01) << 31) |
			((uint32_t)input[63] << 23) |
			((uint32_t)(input[64] & 0xfe) << 15);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 519 to 534
	value = ((uint32_t)(input[64] & 0x01) << 31) |
			((uint32_t)input[65] << 23) |
			((uint32_t)(input[66] & 0xfe) << 15);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 535 to 550
	value = ((uint32_t)(input[66] & 0x01) << 31) |
			((uint32_t)input[67] << 23) |
			((uint32_t)(input[68] & 0xfe) << 15);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 551 to 566
	value = ((uint32_t)(input[68] & 0x01) << 31) |
			((uint32_t)input[69] << 23) |
			((uint32_t)(input[70] & 0xfe) << 15);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 567 to 582
	value = ((uint32_t)(input[70] & 0x01) << 31) |
			((uint32_t)input[71] << 23) |
			((uint32_t)(input[72] & 0xfe) << 15);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 583 to 598
	value = ((uint32_t)(input[72] & 0x01) << 31) |
			((uint32_t)input[73] << 23) |
			((uint32_t)(input[74] & 0xfe) << 15);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 599 to 614
	value = ((uint32_t)(input[74] & 0x01) << 31) |
			((uint32_t)input[75] << 23) |
			((uint32_t)(input[76] & 0xfe) << 15);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 615 to 630
	value = ((uint32_t)(input[76] & 0x01) << 31) |
			((uint32_t)input[77] << 23) |
			((uint32_t)(input[78] & 0xfe) << 15);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 631 to 646
	value = ((uint32_t)(input[78] & 0x01) << 31) |
			((uint32_t)input[79] << 23) |
			((uint32_t)(input[80] & 0xfe) << 15);
	output[39] = (double)(value >> 16);

	// read output[40]: from bit 647 to 662
	value = ((uint32_t)(input[80] & 0x01) << 31) |
			((uint32_t)input[81] << 23) |
			((uint32_t)(input[82] & 0xfe) << 15);
	output[40] = (double)(value >> 16);

	// read output[41]: from bit 663 to 678
	value = ((uint32_t)(input[82] & 0x01) << 31) |
			((uint32_t)input[83] << 23) |
			((uint32_t)(input[84] & 0xfe) << 15);
	output[41] = (double)(value >> 16);

	// read output[42]: from bit 679 to 694
	value = ((uint32_t)(input[84] & 0x01) << 31) |
			((uint32_t)input[85] << 23) |
			((uint32_t)(input[86] & 0xfe) << 15);
	output[42] = (double)(value >> 16);
}

static void unpack_43_16bit_unsigned_7off(const uint8_t * input, double * output, void *closure) {
	// Unpack 43 values into output
	// Values are 16-bit unsigned
	// Skip 7 bits, read 688 bits of data.
	// Input must be at least 87 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 7 to 22
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)(input[2] & 0xfe) << 15);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 23 to 38
	value = ((uint32_t)(input[2] & 0x01) << 31) |
			((uint32_t)input[3] << 23) |
			((uint32_t)(input[4] & 0xfe) << 15);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 39 to 54
	value = ((uint32_t)(input[4] & 0x01) << 31) |
			((uint32_t)input[5] << 23) |
			((uint32_t)(input[6] & 0xfe) << 15);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 55 to 70
	value = ((uint32_t)(input[6] & 0x01) << 31) |
			((uint32_t)input[7] << 23) |
			((uint32_t)(input[8] & 0xfe) << 15);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 71 to 86
	value = ((uint32_t)(input[8] & 0x01) << 31) |
			((uint32_t)input[9] << 23) |
			((uint32_t)(input[10] & 0xfe) << 15);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 87 to 102
	value = ((uint32_t)(input[10] & 0x01) << 31) |
			((uint32_t)input[11] << 23) |
			((uint32_t)(input[12] & 0xfe) << 15);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 103 to 118
	value = ((uint32_t)(input[12] & 0x01) << 31) |
			((uint32_t)input[13] << 23) |
			((uint32_t)(input[14] & 0xfe) << 15);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 119 to 134
	value = ((uint32_t)(input[14] & 0x01) << 31) |
			((uint32_t)input[15] << 23) |
			((uint32_t)(input[16] & 0xfe) << 15);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 135 to 150
	value = ((uint32_t)(input[16] & 0x01) << 31) |
			((uint32_t)input[17] << 23) |
			((uint32_t)(input[18] & 0xfe) << 15);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 151 to 166
	value = ((uint32_t)(input[18] & 0x01) << 31) |
			((uint32_t)input[19] << 23) |
			((uint32_t)(input[20] & 0xfe) << 15);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 167 to 182
	value = ((uint32_t)(input[20] & 0x01) << 31) |
			((uint32_t)input[21] << 23) |
			((uint32_t)(input[22] & 0xfe) << 15);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 183 to 198
	value = ((uint32_t)(input[22] & 0x01) << 31) |
			((uint32_t)input[23] << 23) |
			((uint32_t)(input[24] & 0xfe) << 15);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 199 to 214
	value = ((uint32_t)(input[24] & 0x01) << 31) |
			((uint32_t)input[25] << 23) |
			((uint32_t)(input[26] & 0xfe) << 15);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 215 to 230
	value = ((uint32_t)(input[26] & 0x01) << 31) |
			((uint32_t)input[27] << 23) |
			((uint32_t)(input[28] & 0xfe) << 15);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 231 to 246
	value = ((uint32_t)(input[28] & 0x01) << 31) |
			((uint32_t)input[29] << 23) |
			((uint32_t)(input[30] & 0xfe) << 15);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 247 to 262
	value = ((uint32_t)(input[30] & 0x01) << 31) |
			((uint32_t)input[31] << 23) |
			((uint32_t)(input[32] & 0xfe) << 15);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 263 to 278
	value = ((uint32_t)(input[32] & 0x01) << 31) |
			((uint32_t)input[33] << 23) |
			((uint32_t)(input[34] & 0xfe) << 15);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 279 to 294
	value = ((uint32_t)(input[34] & 0x01) << 31) |
			((uint32_t)input[35] << 23) |
			((uint32_t)(input[36] & 0xfe) << 15);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 295 to 310
	value = ((uint32_t)(input[36] & 0x01) << 31) |
			((uint32_t)input[37] << 23) |
			((uint32_t)(input[38] & 0xfe) << 15);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 311 to 326
	value = ((uint32_t)(input[38] & 0x01) << 31) |
			((uint32_t)input[39] << 23) |
			((uint32_t)(input[40] & 0xfe) << 15);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 327 to 342
	value = ((uint32_t)(input[40] & 0x01) << 31) |
			((uint32_t)input[41] << 23) |
			((uint32_t)(input[42] & 0xfe) << 15);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 343 to 358
	value = ((uint32_t)(input[42] & 0x01) << 31) |
			((uint32_t)input[43] << 23) |
			((uint32_t)(input[44] & 0xfe) << 15);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 359 to 374
	value = ((uint32_t)(input[44] & 0x01) << 31) |
			((uint32_t)input[45] << 23) |
			((uint32_t)(input[46] & 0xfe) << 15);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 375 to 390
	value = ((uint32_t)(input[46] & 0x01) << 31) |
			((uint32_t)input[47] << 23) |
			((uint32_t)(input[48] & 0xfe) << 15);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 391 to 406
	value = ((uint32_t)(input[48] & 0x01) << 31) |
			((uint32_t)input[49] << 23) |
			((uint32_t)(input[50] & 0xfe) << 15);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 407 to 422
	value = ((uint32_t)(input[50] & 0x01) << 31) |
			((uint32_t)input[51] << 23) |
			((uint32_t)(input[52] & 0xfe) << 15);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 423 to 438
	value = ((uint32_t)(input[52] & 0x01) << 31) |
			((uint32_t)input[53] << 23) |
			((uint32_t)(input[54] & 0xfe) << 15);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 439 to 454
	value = ((uint32_t)(input[54] & 0x01) << 31) |
			((uint32_t)input[55] << 23) |
			((uint32_t)(input[56] & 0xfe) << 15);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 455 to 470
	value = ((uint32_t)(input[56] & 0x01) << 31) |
			((uint32_t)input[57] << 23) |
			((uint32_t)(input[58] & 0xfe) << 15);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 471 to 486
	value = ((uint32_t)(input[58] & 0x01) << 31) |
			((uint32_t)input[59] << 23) |
			((uint32_t)(input[60] & 0xfe) << 15);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 487 to 502
	value = ((uint32_t)(input[60] & 0x01) << 31) |
			((uint32_t)input[61] << 23) |
			((uint32_t)(input[62] & 0xfe) << 15);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 503 to 518
	value = ((uint32_t)(input[62] & 0x01) << 31) |
			((uint32_t)input[63] << 23) |
			((uint32_t)(input[64] & 0xfe) << 15);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 519 to 534
	value = ((uint32_t)(input[64] & 0x01) << 31) |
			((uint32_t)input[65] << 23) |
			((uint32_t)(input[66] & 0xfe) << 15);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 535 to 550
	value = ((uint32_t)(input[66] & 0x01) << 31) |
			((uint32_t)input[67] << 23) |
			((uint32_t)(input[68] & 0xfe) << 15);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 551 to 566
	value = ((uint32_t)(input[68] & 0x01) << 31) |
			((uint32_t)input[69] << 23) |
			((uint32_t)(input[70] & 0xfe) << 15);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 567 to 582
	value = ((uint32_t)(input[70] & 0x01) << 31) |
			((uint32_t)input[71] << 23) |
			((uint32_t)(input[72] & 0xfe) << 15);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 583 to 598
	value = ((uint32_t)(input[72] & 0x01) << 31) |
			((uint32_t)input[73] << 23) |
			((uint32_t)(input[74] & 0xfe) << 15);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 599 to 614
	value = ((uint32_t)(input[74] & 0x01) << 31) |
			((uint32_t)input[75] << 23) |
			((uint32_t)(input[76] & 0xfe) << 15);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 615 to 630
	value = ((uint32_t)(input[76] & 0x01) << 31) |
			((uint32_t)input[77] << 23) |
			((uint32_t)(input[78] & 0xfe) << 15);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 631 to 646
	value = ((uint32_t)(input[78] & 0x01) << 31) |
			((uint32_t)input[79] << 23) |
			((uint32_t)(input[80] & 0xfe) << 15);
	output[39] = (double)(value >> 16);

	// read output[40]: from bit 647 to 662
	value = ((uint32_t)(input[80] & 0x01) << 31) |
			((uint32_t)input[81] << 23) |
			((uint32_t)(input[82] & 0xfe) << 15);
	output[40] = (double)(value >> 16);

	// read output[41]: from bit 663 to 678
	value = ((uint32_t)(input[82] & 0x01) << 31) |
			((uint32_t)input[83] << 23) |
			((uint32_t)(input[84] & 0xfe) << 15);
	output[41] = (double)(value >> 16);

	// read output[42]: from bit 679 to 694
	value = ((uint32_t)(input[84] & 0x01) << 31) |
			((uint32_t)input[85] << 23) |
			((uint32_t)(input[86] & 0xfe) << 15);
	output[42] = (double)(value >> 16);
}

static void unpack_44_16bit_signed_0off(const uint8_t * input, double * output, void *closure) {
	// Unpack 44 values into output
	// Values are 16-bit signed
	// Skip 0 bits, read 704 bits of data.
	// Input must be at least 88 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 0 to 15
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)input[1] << 16);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 16 to 31
	value = ((uint32_t)input[2] << 24) |
			((uint32_t)input[3] << 16);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 32 to 47
	value = ((uint32_t)input[4] << 24) |
			((uint32_t)input[5] << 16);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 48 to 63
	value = ((uint32_t)input[6] << 24) |
			((uint32_t)input[7] << 16);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 64 to 79
	value = ((uint32_t)input[8] << 24) |
			((uint32_t)input[9] << 16);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 80 to 95
	value = ((uint32_t)input[10] << 24) |
			((uint32_t)input[11] << 16);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 96 to 111
	value = ((uint32_t)input[12] << 24) |
			((uint32_t)input[13] << 16);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 112 to 127
	value = ((uint32_t)input[14] << 24) |
			((uint32_t)input[15] << 16);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 128 to 143
	value = ((uint32_t)input[16] << 24) |
			((uint32_t)input[17] << 16);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 144 to 159
	value = ((uint32_t)input[18] << 24) |
			((uint32_t)input[19] << 16);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 160 to 175
	value = ((uint32_t)input[20] << 24) |
			((uint32_t)input[21] << 16);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 176 to 191
	value = ((uint32_t)input[22] << 24) |
			((uint32_t)input[23] << 16);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 192 to 207
	value = ((uint32_t)input[24] << 24) |
			((uint32_t)input[25] << 16);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 208 to 223
	value = ((uint32_t)input[26] << 24) |
			((uint32_t)input[27] << 16);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 224 to 239
	value = ((uint32_t)input[28] << 24) |
			((uint32_t)input[29] << 16);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 240 to 255
	value = ((uint32_t)input[30] << 24) |
			((uint32_t)input[31] << 16);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 256 to 271
	value = ((uint32_t)input[32] << 24) |
			((uint32_t)input[33] << 16);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 272 to 287
	value = ((uint32_t)input[34] << 24) |
			((uint32_t)input[35] << 16);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 288 to 303
	value = ((uint32_t)input[36] << 24) |
			((uint32_t)input[37] << 16);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 304 to 319
	value = ((uint32_t)input[38] << 24) |
			((uint32_t)input[39] << 16);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 320 to 335
	value = ((uint32_t)input[40] << 24) |
			((uint32_t)input[41] << 16);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 336 to 351
	value = ((uint32_t)input[42] << 24) |
			((uint32_t)input[43] << 16);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 352 to 367
	value = ((uint32_t)input[44] << 24) |
			((uint32_t)input[45] << 16);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 368 to 383
	value = ((uint32_t)input[46] << 24) |
			((uint32_t)input[47] << 16);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 384 to 399
	value = ((uint32_t)input[48] << 24) |
			((uint32_t)input[49] << 16);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 400 to 415
	value = ((uint32_t)input[50] << 24) |
			((uint32_t)input[51] << 16);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 416 to 431
	value = ((uint32_t)input[52] << 24) |
			((uint32_t)input[53] << 16);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 432 to 447
	value = ((uint32_t)input[54] << 24) |
			((uint32_t)input[55] << 16);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 448 to 463
	value = ((uint32_t)input[56] << 24) |
			((uint32_t)input[57] << 16);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 464 to 479
	value = ((uint32_t)input[58] << 24) |
			((uint32_t)input[59] << 16);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 480 to 495
	value = ((uint32_t)input[60] << 24) |
			((uint32_t)input[61] << 16);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 496 to 511
	value = ((uint32_t)input[62] << 24) |
			((uint32_t)input[63] << 16);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 512 to 527
	value = ((uint32_t)input[64] << 24) |
			((uint32_t)input[65] << 16);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 528 to 543
	value = ((uint32_t)input[66] << 24) |
			((uint32_t)input[67] << 16);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 544 to 559
	value = ((uint32_t)input[68] << 24) |
			((uint32_t)input[69] << 16);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 560 to 575
	value = ((uint32_t)input[70] << 24) |
			((uint32_t)input[71] << 16);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 576 to 591
	value = ((uint32_t)input[72] << 24) |
			((uint32_t)input[73] << 16);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 592 to 607
	value = ((uint32_t)input[74] << 24) |
			((uint32_t)input[75] << 16);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 608 to 623
	value = ((uint32_t)input[76] << 24) |
			((uint32_t)input[77] << 16);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 624 to 639
	value = ((uint32_t)input[78] << 24) |
			((uint32_t)input[79] << 16);
	output[39] = (double)(value >> 16);

	// read output[40]: from bit 640 to 655
	value = ((uint32_t)input[80] << 24) |
			((uint32_t)input[81] << 16);
	output[40] = (double)(value >> 16);

	// read output[41]: from bit 656 to 671
	value = ((uint32_t)input[82] << 24) |
			((uint32_t)input[83] << 16);
	output[41] = (double)(value >> 16);

	// read output[42]: from bit 672 to 687
	value = ((uint32_t)input[84] << 24) |
			((uint32_t)input[85] << 16);
	output[42] = (double)(value >> 16);

	// read output[43]: from bit 688 to 703
	value = ((uint32_t)input[86] << 24) |
			((uint32_t)input[87] << 16);
	output[43] = (double)(value >> 16);
}

static void unpack_44_16bit_unsigned_0off(const uint8_t * input, double * output, void *closure) {
	// Unpack 44 values into output
	// Values are 16-bit unsigned
	// Skip 0 bits, read 704 bits of data.
	// Input must be at least 88 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 0 to 15
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)input[1] << 16);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 16 to 31
	value = ((uint32_t)input[2] << 24) |
			((uint32_t)input[3] << 16);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 32 to 47
	value = ((uint32_t)input[4] << 24) |
			((uint32_t)input[5] << 16);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 48 to 63
	value = ((uint32_t)input[6] << 24) |
			((uint32_t)input[7] << 16);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 64 to 79
	value = ((uint32_t)input[8] << 24) |
			((uint32_t)input[9] << 16);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 80 to 95
	value = ((uint32_t)input[10] << 24) |
			((uint32_t)input[11] << 16);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 96 to 111
	value = ((uint32_t)input[12] << 24) |
			((uint32_t)input[13] << 16);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 112 to 127
	value = ((uint32_t)input[14] << 24) |
			((uint32_t)input[15] << 16);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 128 to 143
	value = ((uint32_t)input[16] << 24) |
			((uint32_t)input[17] << 16);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 144 to 159
	value = ((uint32_t)input[18] << 24) |
			((uint32_t)input[19] << 16);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 160 to 175
	value = ((uint32_t)input[20] << 24) |
			((uint32_t)input[21] << 16);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 176 to 191
	value = ((uint32_t)input[22] << 24) |
			((uint32_t)input[23] << 16);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 192 to 207
	value = ((uint32_t)input[24] << 24) |
			((uint32_t)input[25] << 16);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 208 to 223
	value = ((uint32_t)input[26] << 24) |
			((uint32_t)input[27] << 16);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 224 to 239
	value = ((uint32_t)input[28] << 24) |
			((uint32_t)input[29] << 16);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 240 to 255
	value = ((uint32_t)input[30] << 24) |
			((uint32_t)input[31] << 16);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 256 to 271
	value = ((uint32_t)input[32] << 24) |
			((uint32_t)input[33] << 16);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 272 to 287
	value = ((uint32_t)input[34] << 24) |
			((uint32_t)input[35] << 16);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 288 to 303
	value = ((uint32_t)input[36] << 24) |
			((uint32_t)input[37] << 16);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 304 to 319
	value = ((uint32_t)input[38] << 24) |
			((uint32_t)input[39] << 16);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 320 to 335
	value = ((uint32_t)input[40] << 24) |
			((uint32_t)input[41] << 16);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 336 to 351
	value = ((uint32_t)input[42] << 24) |
			((uint32_t)input[43] << 16);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 352 to 367
	value = ((uint32_t)input[44] << 24) |
			((uint32_t)input[45] << 16);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 368 to 383
	value = ((uint32_t)input[46] << 24) |
			((uint32_t)input[47] << 16);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 384 to 399
	value = ((uint32_t)input[48] << 24) |
			((uint32_t)input[49] << 16);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 400 to 415
	value = ((uint32_t)input[50] << 24) |
			((uint32_t)input[51] << 16);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 416 to 431
	value = ((uint32_t)input[52] << 24) |
			((uint32_t)input[53] << 16);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 432 to 447
	value = ((uint32_t)input[54] << 24) |
			((uint32_t)input[55] << 16);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 448 to 463
	value = ((uint32_t)input[56] << 24) |
			((uint32_t)input[57] << 16);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 464 to 479
	value = ((uint32_t)input[58] << 24) |
			((uint32_t)input[59] << 16);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 480 to 495
	value = ((uint32_t)input[60] << 24) |
			((uint32_t)input[61] << 16);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 496 to 511
	value = ((uint32_t)input[62] << 24) |
			((uint32_t)input[63] << 16);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 512 to 527
	value = ((uint32_t)input[64] << 24) |
			((uint32_t)input[65] << 16);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 528 to 543
	value = ((uint32_t)input[66] << 24) |
			((uint32_t)input[67] << 16);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 544 to 559
	value = ((uint32_t)input[68] << 24) |
			((uint32_t)input[69] << 16);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 560 to 575
	value = ((uint32_t)input[70] << 24) |
			((uint32_t)input[71] << 16);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 576 to 591
	value = ((uint32_t)input[72] << 24) |
			((uint32_t)input[73] << 16);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 592 to 607
	value = ((uint32_t)input[74] << 24) |
			((uint32_t)input[75] << 16);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 608 to 623
	value = ((uint32_t)input[76] << 24) |
			((uint32_t)input[77] << 16);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 624 to 639
	value = ((uint32_t)input[78] << 24) |
			((uint32_t)input[79] << 16);
	output[39] = (double)(value >> 16);

	// read output[40]: from bit 640 to 655
	value = ((uint32_t)input[80] << 24) |
			((uint32_t)input[81] << 16);
	output[40] = (double)(value >> 16);

	// read output[41]: from bit 656 to 671
	value = ((uint32_t)input[82] << 24) |
			((uint32_t)input[83] << 16);
	output[41] = (double)(value >> 16);

	// read output[42]: from bit 672 to 687
	value = ((uint32_t)input[84] << 24) |
			((uint32_t)input[85] << 16);
	output[42] = (double)(value >> 16);

	// read output[43]: from bit 688 to 703
	value = ((uint32_t)input[86] << 24) |
			((uint32_t)input[87] << 16);
	output[43] = (double)(value >> 16);
}

static void unpack_44_16bit_signed_1off(const uint8_t * input, double * output, void *closure) {
	// Unpack 44 values into output
	// Values are 16-bit signed
	// Skip 1 bits, read 704 bits of data.
	// Input must be at least 89 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 1 to 16
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)input[1] << 17) |
			((uint32_t)(input[2] & 0x80) << 9);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 17 to 32
	value = ((uint32_t)(input[2] & 0x7f) << 25) |
			((uint32_t)input[3] << 17) |
			((uint32_t)(input[4] & 0x80) << 9);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 33 to 48
	value = ((uint32_t)(input[4] & 0x7f) << 25) |
			((uint32_t)input[5] << 17) |
			((uint32_t)(input[6] & 0x80) << 9);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 49 to 64
	value = ((uint32_t)(input[6] & 0x7f) << 25) |
			((uint32_t)input[7] << 17) |
			((uint32_t)(input[8] & 0x80) << 9);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 65 to 80
	value = ((uint32_t)(input[8] & 0x7f) << 25) |
			((uint32_t)input[9] << 17) |
			((uint32_t)(input[10] & 0x80) << 9);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 81 to 96
	value = ((uint32_t)(input[10] & 0x7f) << 25) |
			((uint32_t)input[11] << 17) |
			((uint32_t)(input[12] & 0x80) << 9);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 97 to 112
	value = ((uint32_t)(input[12] & 0x7f) << 25) |
			((uint32_t)input[13] << 17) |
			((uint32_t)(input[14] & 0x80) << 9);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 113 to 128
	value = ((uint32_t)(input[14] & 0x7f) << 25) |
			((uint32_t)input[15] << 17) |
			((uint32_t)(input[16] & 0x80) << 9);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 129 to 144
	value = ((uint32_t)(input[16] & 0x7f) << 25) |
			((uint32_t)input[17] << 17) |
			((uint32_t)(input[18] & 0x80) << 9);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 145 to 160
	value = ((uint32_t)(input[18] & 0x7f) << 25) |
			((uint32_t)input[19] << 17) |
			((uint32_t)(input[20] & 0x80) << 9);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 161 to 176
	value = ((uint32_t)(input[20] & 0x7f) << 25) |
			((uint32_t)input[21] << 17) |
			((uint32_t)(input[22] & 0x80) << 9);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 177 to 192
	value = ((uint32_t)(input[22] & 0x7f) << 25) |
			((uint32_t)input[23] << 17) |
			((uint32_t)(input[24] & 0x80) << 9);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 193 to 208
	value = ((uint32_t)(input[24] & 0x7f) << 25) |
			((uint32_t)input[25] << 17) |
			((uint32_t)(input[26] & 0x80) << 9);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 209 to 224
	value = ((uint32_t)(input[26] & 0x7f) << 25) |
			((uint32_t)input[27] << 17) |
			((uint32_t)(input[28] & 0x80) << 9);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 225 to 240
	value = ((uint32_t)(input[28] & 0x7f) << 25) |
			((uint32_t)input[29] << 17) |
			((uint32_t)(input[30] & 0x80) << 9);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 241 to 256
	value = ((uint32_t)(input[30] & 0x7f) << 25) |
			((uint32_t)input[31] << 17) |
			((uint32_t)(input[32] & 0x80) << 9);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 257 to 272
	value = ((uint32_t)(input[32] & 0x7f) << 25) |
			((uint32_t)input[33] << 17) |
			((uint32_t)(input[34] & 0x80) << 9);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 273 to 288
	value = ((uint32_t)(input[34] & 0x7f) << 25) |
			((uint32_t)input[35] << 17) |
			((uint32_t)(input[36] & 0x80) << 9);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 289 to 304
	value = ((uint32_t)(input[36] & 0x7f) << 25) |
			((uint32_t)input[37] << 17) |
			((uint32_t)(input[38] & 0x80) << 9);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 305 to 320
	value = ((uint32_t)(input[38] & 0x7f) << 25) |
			((uint32_t)input[39] << 17) |
			((uint32_t)(input[40] & 0x80) << 9);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 321 to 336
	value = ((uint32_t)(input[40] & 0x7f) << 25) |
			((uint32_t)input[41] << 17) |
			((uint32_t)(input[42] & 0x80) << 9);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 337 to 352
	value = ((uint32_t)(input[42] & 0x7f) << 25) |
			((uint32_t)input[43] << 17) |
			((uint32_t)(input[44] & 0x80) << 9);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 353 to 368
	value = ((uint32_t)(input[44] & 0x7f) << 25) |
			((uint32_t)input[45] << 17) |
			((uint32_t)(input[46] & 0x80) << 9);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 369 to 384
	value = ((uint32_t)(input[46] & 0x7f) << 25) |
			((uint32_t)input[47] << 17) |
			((uint32_t)(input[48] & 0x80) << 9);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 385 to 400
	value = ((uint32_t)(input[48] & 0x7f) << 25) |
			((uint32_t)input[49] << 17) |
			((uint32_t)(input[50] & 0x80) << 9);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 401 to 416
	value = ((uint32_t)(input[50] & 0x7f) << 25) |
			((uint32_t)input[51] << 17) |
			((uint32_t)(input[52] & 0x80) << 9);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 417 to 432
	value = ((uint32_t)(input[52] & 0x7f) << 25) |
			((uint32_t)input[53] << 17) |
			((uint32_t)(input[54] & 0x80) << 9);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 433 to 448
	value = ((uint32_t)(input[54] & 0x7f) << 25) |
			((uint32_t)input[55] << 17) |
			((uint32_t)(input[56] & 0x80) << 9);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 449 to 464
	value = ((uint32_t)(input[56] & 0x7f) << 25) |
			((uint32_t)input[57] << 17) |
			((uint32_t)(input[58] & 0x80) << 9);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 465 to 480
	value = ((uint32_t)(input[58] & 0x7f) << 25) |
			((uint32_t)input[59] << 17) |
			((uint32_t)(input[60] & 0x80) << 9);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 481 to 496
	value = ((uint32_t)(input[60] & 0x7f) << 25) |
			((uint32_t)input[61] << 17) |
			((uint32_t)(input[62] & 0x80) << 9);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 497 to 512
	value = ((uint32_t)(input[62] & 0x7f) << 25) |
			((uint32_t)input[63] << 17) |
			((uint32_t)(input[64] & 0x80) << 9);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 513 to 528
	value = ((uint32_t)(input[64] & 0x7f) << 25) |
			((uint32_t)input[65] << 17) |
			((uint32_t)(input[66] & 0x80) << 9);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 529 to 544
	value = ((uint32_t)(input[66] & 0x7f) << 25) |
			((uint32_t)input[67] << 17) |
			((uint32_t)(input[68] & 0x80) << 9);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 545 to 560
	value = ((uint32_t)(input[68] & 0x7f) << 25) |
			((uint32_t)input[69] << 17) |
			((uint32_t)(input[70] & 0x80) << 9);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 561 to 576
	value = ((uint32_t)(input[70] & 0x7f) << 25) |
			((uint32_t)input[71] << 17) |
			((uint32_t)(input[72] & 0x80) << 9);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 577 to 592
	value = ((uint32_t)(input[72] & 0x7f) << 25) |
			((uint32_t)input[73] << 17) |
			((uint32_t)(input[74] & 0x80) << 9);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 593 to 608
	value = ((uint32_t)(input[74] & 0x7f) << 25) |
			((uint32_t)input[75] << 17) |
			((uint32_t)(input[76] & 0x80) << 9);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 609 to 624
	value = ((uint32_t)(input[76] & 0x7f) << 25) |
			((uint32_t)input[77] << 17) |
			((uint32_t)(input[78] & 0x80) << 9);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 625 to 640
	value = ((uint32_t)(input[78] & 0x7f) << 25) |
			((uint32_t)input[79] << 17) |
			((uint32_t)(input[80] & 0x80) << 9);
	output[39] = (double)(value >> 16);

	// read output[40]: from bit 641 to 656
	value = ((uint32_t)(input[80] & 0x7f) << 25) |
			((uint32_t)input[81] << 17) |
			((uint32_t)(input[82] & 0x80) << 9);
	output[40] = (double)(value >> 16);

	// read output[41]: from bit 657 to 672
	value = ((uint32_t)(input[82] & 0x7f) << 25) |
			((uint32_t)input[83] << 17) |
			((uint32_t)(input[84] & 0x80) << 9);
	output[41] = (double)(value >> 16);

	// read output[42]: from bit 673 to 688
	value = ((uint32_t)(input[84] & 0x7f) << 25) |
			((uint32_t)input[85] << 17) |
			((uint32_t)(input[86] & 0x80) << 9);
	output[42] = (double)(value >> 16);

	// read output[43]: from bit 689 to 704
	value = ((uint32_t)(input[86] & 0x7f) << 25) |
			((uint32_t)input[87] << 17) |
			((uint32_t)(input[88] & 0x80) << 9);
	output[43] = (double)(value >> 16);
}

static void unpack_44_16bit_unsigned_1off(const uint8_t * input, double * output, void *closure) {
	// Unpack 44 values into output
	// Values are 16-bit unsigned
	// Skip 1 bits, read 704 bits of data.
	// Input must be at least 89 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 1 to 16
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)input[1] << 17) |
			((uint32_t)(input[2] & 0x80) << 9);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 17 to 32
	value = ((uint32_t)(input[2] & 0x7f) << 25) |
			((uint32_t)input[3] << 17) |
			((uint32_t)(input[4] & 0x80) << 9);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 33 to 48
	value = ((uint32_t)(input[4] & 0x7f) << 25) |
			((uint32_t)input[5] << 17) |
			((uint32_t)(input[6] & 0x80) << 9);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 49 to 64
	value = ((uint32_t)(input[6] & 0x7f) << 25) |
			((uint32_t)input[7] << 17) |
			((uint32_t)(input[8] & 0x80) << 9);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 65 to 80
	value = ((uint32_t)(input[8] & 0x7f) << 25) |
			((uint32_t)input[9] << 17) |
			((uint32_t)(input[10] & 0x80) << 9);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 81 to 96
	value = ((uint32_t)(input[10] & 0x7f) << 25) |
			((uint32_t)input[11] << 17) |
			((uint32_t)(input[12] & 0x80) << 9);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 97 to 112
	value = ((uint32_t)(input[12] & 0x7f) << 25) |
			((uint32_t)input[13] << 17) |
			((uint32_t)(input[14] & 0x80) << 9);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 113 to 128
	value = ((uint32_t)(input[14] & 0x7f) << 25) |
			((uint32_t)input[15] << 17) |
			((uint32_t)(input[16] & 0x80) << 9);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 129 to 144
	value = ((uint32_t)(input[16] & 0x7f) << 25) |
			((uint32_t)input[17] << 17) |
			((uint32_t)(input[18] & 0x80) << 9);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 145 to 160
	value = ((uint32_t)(input[18] & 0x7f) << 25) |
			((uint32_t)input[19] << 17) |
			((uint32_t)(input[20] & 0x80) << 9);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 161 to 176
	value = ((uint32_t)(input[20] & 0x7f) << 25) |
			((uint32_t)input[21] << 17) |
			((uint32_t)(input[22] & 0x80) << 9);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 177 to 192
	value = ((uint32_t)(input[22] & 0x7f) << 25) |
			((uint32_t)input[23] << 17) |
			((uint32_t)(input[24] & 0x80) << 9);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 193 to 208
	value = ((uint32_t)(input[24] & 0x7f) << 25) |
			((uint32_t)input[25] << 17) |
			((uint32_t)(input[26] & 0x80) << 9);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 209 to 224
	value = ((uint32_t)(input[26] & 0x7f) << 25) |
			((uint32_t)input[27] << 17) |
			((uint32_t)(input[28] & 0x80) << 9);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 225 to 240
	value = ((uint32_t)(input[28] & 0x7f) << 25) |
			((uint32_t)input[29] << 17) |
			((uint32_t)(input[30] & 0x80) << 9);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 241 to 256
	value = ((uint32_t)(input[30] & 0x7f) << 25) |
			((uint32_t)input[31] << 17) |
			((uint32_t)(input[32] & 0x80) << 9);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 257 to 272
	value = ((uint32_t)(input[32] & 0x7f) << 25) |
			((uint32_t)input[33] << 17) |
			((uint32_t)(input[34] & 0x80) << 9);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 273 to 288
	value = ((uint32_t)(input[34] & 0x7f) << 25) |
			((uint32_t)input[35] << 17) |
			((uint32_t)(input[36] & 0x80) << 9);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 289 to 304
	value = ((uint32_t)(input[36] & 0x7f) << 25) |
			((uint32_t)input[37] << 17) |
			((uint32_t)(input[38] & 0x80) << 9);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 305 to 320
	value = ((uint32_t)(input[38] & 0x7f) << 25) |
			((uint32_t)input[39] << 17) |
			((uint32_t)(input[40] & 0x80) << 9);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 321 to 336
	value = ((uint32_t)(input[40] & 0x7f) << 25) |
			((uint32_t)input[41] << 17) |
			((uint32_t)(input[42] & 0x80) << 9);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 337 to 352
	value = ((uint32_t)(input[42] & 0x7f) << 25) |
			((uint32_t)input[43] << 17) |
			((uint32_t)(input[44] & 0x80) << 9);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 353 to 368
	value = ((uint32_t)(input[44] & 0x7f) << 25) |
			((uint32_t)input[45] << 17) |
			((uint32_t)(input[46] & 0x80) << 9);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 369 to 384
	value = ((uint32_t)(input[46] & 0x7f) << 25) |
			((uint32_t)input[47] << 17) |
			((uint32_t)(input[48] & 0x80) << 9);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 385 to 400
	value = ((uint32_t)(input[48] & 0x7f) << 25) |
			((uint32_t)input[49] << 17) |
			((uint32_t)(input[50] & 0x80) << 9);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 401 to 416
	value = ((uint32_t)(input[50] & 0x7f) << 25) |
			((uint32_t)input[51] << 17) |
			((uint32_t)(input[52] & 0x80) << 9);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 417 to 432
	value = ((uint32_t)(input[52] & 0x7f) << 25) |
			((uint32_t)input[53] << 17) |
			((uint32_t)(input[54] & 0x80) << 9);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 433 to 448
	value = ((uint32_t)(input[54] & 0x7f) << 25) |
			((uint32_t)input[55] << 17) |
			((uint32_t)(input[56] & 0x80) << 9);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 449 to 464
	value = ((uint32_t)(input[56] & 0x7f) << 25) |
			((uint32_t)input[57] << 17) |
			((uint32_t)(input[58] & 0x80) << 9);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 465 to 480
	value = ((uint32_t)(input[58] & 0x7f) << 25) |
			((uint32_t)input[59] << 17) |
			((uint32_t)(input[60] & 0x80) << 9);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 481 to 496
	value = ((uint32_t)(input[60] & 0x7f) << 25) |
			((uint32_t)input[61] << 17) |
			((uint32_t)(input[62] & 0x80) << 9);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 497 to 512
	value = ((uint32_t)(input[62] & 0x7f) << 25) |
			((uint32_t)input[63] << 17) |
			((uint32_t)(input[64] & 0x80) << 9);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 513 to 528
	value = ((uint32_t)(input[64] & 0x7f) << 25) |
			((uint32_t)input[65] << 17) |
			((uint32_t)(input[66] & 0x80) << 9);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 529 to 544
	value = ((uint32_t)(input[66] & 0x7f) << 25) |
			((uint32_t)input[67] << 17) |
			((uint32_t)(input[68] & 0x80) << 9);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 545 to 560
	value = ((uint32_t)(input[68] & 0x7f) << 25) |
			((uint32_t)input[69] << 17) |
			((uint32_t)(input[70] & 0x80) << 9);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 561 to 576
	value = ((uint32_t)(input[70] & 0x7f) << 25) |
			((uint32_t)input[71] << 17) |
			((uint32_t)(input[72] & 0x80) << 9);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 577 to 592
	value = ((uint32_t)(input[72] & 0x7f) << 25) |
			((uint32_t)input[73] << 17) |
			((uint32_t)(input[74] & 0x80) << 9);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 593 to 608
	value = ((uint32_t)(input[74] & 0x7f) << 25) |
			((uint32_t)input[75] << 17) |
			((uint32_t)(input[76] & 0x80) << 9);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 609 to 624
	value = ((uint32_t)(input[76] & 0x7f) << 25) |
			((uint32_t)input[77] << 17) |
			((uint32_t)(input[78] & 0x80) << 9);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 625 to 640
	value = ((uint32_t)(input[78] & 0x7f) << 25) |
			((uint32_t)input[79] << 17) |
			((uint32_t)(input[80] & 0x80) << 9);
	output[39] = (double)(value >> 16);

	// read output[40]: from bit 641 to 656
	value = ((uint32_t)(input[80] & 0x7f) << 25) |
			((uint32_t)input[81] << 17) |
			((uint32_t)(input[82] & 0x80) << 9);
	output[40] = (double)(value >> 16);

	// read output[41]: from bit 657 to 672
	value = ((uint32_t)(input[82] & 0x7f) << 25) |
			((uint32_t)input[83] << 17) |
			((uint32_t)(input[84] & 0x80) << 9);
	output[41] = (double)(value >> 16);

	// read output[42]: from bit 673 to 688
	value = ((uint32_t)(input[84] & 0x7f) << 25) |
			((uint32_t)input[85] << 17) |
			((uint32_t)(input[86] & 0x80) << 9);
	output[42] = (double)(value >> 16);

	// read output[43]: from bit 689 to 704
	value = ((uint32_t)(input[86] & 0x7f) << 25) |
			((uint32_t)input[87] << 17) |
			((uint32_t)(input[88] & 0x80) << 9);
	output[43] = (double)(value >> 16);
}

static void unpack_44_16bit_signed_2off(const uint8_t * input, double * output, void *closure) {
	// Unpack 44 values into output
	// Values are 16-bit signed
	// Skip 2 bits, read 704 bits of data.
	// Input must be at least 89 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 2 to 17
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)input[1] << 18) |
			((uint32_t)(input[2] & 0xc0) << 10);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 18 to 33
	value = ((uint32_t)(input[2] & 0x3f) << 26) |
			((uint32_t)input[3] << 18) |
			((uint32_t)(input[4] & 0xc0) << 10);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 34 to 49
	value = ((uint32_t)(input[4] & 0x3f) << 26) |
			((uint32_t)input[5] << 18) |
			((uint32_t)(input[6] & 0xc0) << 10);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 50 to 65
	value = ((uint32_t)(input[6] & 0x3f) << 26) |
			((uint32_t)input[7] << 18) |
			((uint32_t)(input[8] & 0xc0) << 10);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 66 to 81
	value = ((uint32_t)(input[8] & 0x3f) << 26) |
			((uint32_t)input[9] << 18) |
			((uint32_t)(input[10] & 0xc0) << 10);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 82 to 97
	value = ((uint32_t)(input[10] & 0x3f) << 26) |
			((uint32_t)input[11] << 18) |
			((uint32_t)(input[12] & 0xc0) << 10);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 98 to 113
	value = ((uint32_t)(input[12] & 0x3f) << 26) |
			((uint32_t)input[13] << 18) |
			((uint32_t)(input[14] & 0xc0) << 10);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 114 to 129
	value = ((uint32_t)(input[14] & 0x3f) << 26) |
			((uint32_t)input[15] << 18) |
			((uint32_t)(input[16] & 0xc0) << 10);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 130 to 145
	value = ((uint32_t)(input[16] & 0x3f) << 26) |
			((uint32_t)input[17] << 18) |
			((uint32_t)(input[18] & 0xc0) << 10);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 146 to 161
	value = ((uint32_t)(input[18] & 0x3f) << 26) |
			((uint32_t)input[19] << 18) |
			((uint32_t)(input[20] & 0xc0) << 10);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 162 to 177
	value = ((uint32_t)(input[20] & 0x3f) << 26) |
			((uint32_t)input[21] << 18) |
			((uint32_t)(input[22] & 0xc0) << 10);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 178 to 193
	value = ((uint32_t)(input[22] & 0x3f) << 26) |
			((uint32_t)input[23] << 18) |
			((uint32_t)(input[24] & 0xc0) << 10);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 194 to 209
	value = ((uint32_t)(input[24] & 0x3f) << 26) |
			((uint32_t)input[25] << 18) |
			((uint32_t)(input[26] & 0xc0) << 10);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 210 to 225
	value = ((uint32_t)(input[26] & 0x3f) << 26) |
			((uint32_t)input[27] << 18) |
			((uint32_t)(input[28] & 0xc0) << 10);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 226 to 241
	value = ((uint32_t)(input[28] & 0x3f) << 26) |
			((uint32_t)input[29] << 18) |
			((uint32_t)(input[30] & 0xc0) << 10);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 242 to 257
	value = ((uint32_t)(input[30] & 0x3f) << 26) |
			((uint32_t)input[31] << 18) |
			((uint32_t)(input[32] & 0xc0) << 10);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 258 to 273
	value = ((uint32_t)(input[32] & 0x3f) << 26) |
			((uint32_t)input[33] << 18) |
			((uint32_t)(input[34] & 0xc0) << 10);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 274 to 289
	value = ((uint32_t)(input[34] & 0x3f) << 26) |
			((uint32_t)input[35] << 18) |
			((uint32_t)(input[36] & 0xc0) << 10);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 290 to 305
	value = ((uint32_t)(input[36] & 0x3f) << 26) |
			((uint32_t)input[37] << 18) |
			((uint32_t)(input[38] & 0xc0) << 10);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 306 to 321
	value = ((uint32_t)(input[38] & 0x3f) << 26) |
			((uint32_t)input[39] << 18) |
			((uint32_t)(input[40] & 0xc0) << 10);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 322 to 337
	value = ((uint32_t)(input[40] & 0x3f) << 26) |
			((uint32_t)input[41] << 18) |
			((uint32_t)(input[42] & 0xc0) << 10);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 338 to 353
	value = ((uint32_t)(input[42] & 0x3f) << 26) |
			((uint32_t)input[43] << 18) |
			((uint32_t)(input[44] & 0xc0) << 10);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 354 to 369
	value = ((uint32_t)(input[44] & 0x3f) << 26) |
			((uint32_t)input[45] << 18) |
			((uint32_t)(input[46] & 0xc0) << 10);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 370 to 385
	value = ((uint32_t)(input[46] & 0x3f) << 26) |
			((uint32_t)input[47] << 18) |
			((uint32_t)(input[48] & 0xc0) << 10);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 386 to 401
	value = ((uint32_t)(input[48] & 0x3f) << 26) |
			((uint32_t)input[49] << 18) |
			((uint32_t)(input[50] & 0xc0) << 10);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 402 to 417
	value = ((uint32_t)(input[50] & 0x3f) << 26) |
			((uint32_t)input[51] << 18) |
			((uint32_t)(input[52] & 0xc0) << 10);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 418 to 433
	value = ((uint32_t)(input[52] & 0x3f) << 26) |
			((uint32_t)input[53] << 18) |
			((uint32_t)(input[54] & 0xc0) << 10);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 434 to 449
	value = ((uint32_t)(input[54] & 0x3f) << 26) |
			((uint32_t)input[55] << 18) |
			((uint32_t)(input[56] & 0xc0) << 10);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 450 to 465
	value = ((uint32_t)(input[56] & 0x3f) << 26) |
			((uint32_t)input[57] << 18) |
			((uint32_t)(input[58] & 0xc0) << 10);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 466 to 481
	value = ((uint32_t)(input[58] & 0x3f) << 26) |
			((uint32_t)input[59] << 18) |
			((uint32_t)(input[60] & 0xc0) << 10);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 482 to 497
	value = ((uint32_t)(input[60] & 0x3f) << 26) |
			((uint32_t)input[61] << 18) |
			((uint32_t)(input[62] & 0xc0) << 10);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 498 to 513
	value = ((uint32_t)(input[62] & 0x3f) << 26) |
			((uint32_t)input[63] << 18) |
			((uint32_t)(input[64] & 0xc0) << 10);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 514 to 529
	value = ((uint32_t)(input[64] & 0x3f) << 26) |
			((uint32_t)input[65] << 18) |
			((uint32_t)(input[66] & 0xc0) << 10);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 530 to 545
	value = ((uint32_t)(input[66] & 0x3f) << 26) |
			((uint32_t)input[67] << 18) |
			((uint32_t)(input[68] & 0xc0) << 10);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 546 to 561
	value = ((uint32_t)(input[68] & 0x3f) << 26) |
			((uint32_t)input[69] << 18) |
			((uint32_t)(input[70] & 0xc0) << 10);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 562 to 577
	value = ((uint32_t)(input[70] & 0x3f) << 26) |
			((uint32_t)input[71] << 18) |
			((uint32_t)(input[72] & 0xc0) << 10);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 578 to 593
	value = ((uint32_t)(input[72] & 0x3f) << 26) |
			((uint32_t)input[73] << 18) |
			((uint32_t)(input[74] & 0xc0) << 10);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 594 to 609
	value = ((uint32_t)(input[74] & 0x3f) << 26) |
			((uint32_t)input[75] << 18) |
			((uint32_t)(input[76] & 0xc0) << 10);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 610 to 625
	value = ((uint32_t)(input[76] & 0x3f) << 26) |
			((uint32_t)input[77] << 18) |
			((uint32_t)(input[78] & 0xc0) << 10);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 626 to 641
	value = ((uint32_t)(input[78] & 0x3f) << 26) |
			((uint32_t)input[79] << 18) |
			((uint32_t)(input[80] & 0xc0) << 10);
	output[39] = (double)(value >> 16);

	// read output[40]: from bit 642 to 657
	value = ((uint32_t)(input[80] & 0x3f) << 26) |
			((uint32_t)input[81] << 18) |
			((uint32_t)(input[82] & 0xc0) << 10);
	output[40] = (double)(value >> 16);

	// read output[41]: from bit 658 to 673
	value = ((uint32_t)(input[82] & 0x3f) << 26) |
			((uint32_t)input[83] << 18) |
			((uint32_t)(input[84] & 0xc0) << 10);
	output[41] = (double)(value >> 16);

	// read output[42]: from bit 674 to 689
	value = ((uint32_t)(input[84] & 0x3f) << 26) |
			((uint32_t)input[85] << 18) |
			((uint32_t)(input[86] & 0xc0) << 10);
	output[42] = (double)(value >> 16);

	// read output[43]: from bit 690 to 705
	value = ((uint32_t)(input[86] & 0x3f) << 26) |
			((uint32_t)input[87] << 18) |
			((uint32_t)(input[88] & 0xc0) << 10);
	output[43] = (double)(value >> 16);
}

static void unpack_44_16bit_unsigned_2off(const uint8_t * input, double * output, void *closure) {
	// Unpack 44 values into output
	// Values are 16-bit unsigned
	// Skip 2 bits, read 704 bits of data.
	// Input must be at least 89 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 2 to 17
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)input[1] << 18) |
			((uint32_t)(input[2] & 0xc0) << 10);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 18 to 33
	value = ((uint32_t)(input[2] & 0x3f) << 26) |
			((uint32_t)input[3] << 18) |
			((uint32_t)(input[4] & 0xc0) << 10);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 34 to 49
	value = ((uint32_t)(input[4] & 0x3f) << 26) |
			((uint32_t)input[5] << 18) |
			((uint32_t)(input[6] & 0xc0) << 10);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 50 to 65
	value = ((uint32_t)(input[6] & 0x3f) << 26) |
			((uint32_t)input[7] << 18) |
			((uint32_t)(input[8] & 0xc0) << 10);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 66 to 81
	value = ((uint32_t)(input[8] & 0x3f) << 26) |
			((uint32_t)input[9] << 18) |
			((uint32_t)(input[10] & 0xc0) << 10);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 82 to 97
	value = ((uint32_t)(input[10] & 0x3f) << 26) |
			((uint32_t)input[11] << 18) |
			((uint32_t)(input[12] & 0xc0) << 10);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 98 to 113
	value = ((uint32_t)(input[12] & 0x3f) << 26) |
			((uint32_t)input[13] << 18) |
			((uint32_t)(input[14] & 0xc0) << 10);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 114 to 129
	value = ((uint32_t)(input[14] & 0x3f) << 26) |
			((uint32_t)input[15] << 18) |
			((uint32_t)(input[16] & 0xc0) << 10);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 130 to 145
	value = ((uint32_t)(input[16] & 0x3f) << 26) |
			((uint32_t)input[17] << 18) |
			((uint32_t)(input[18] & 0xc0) << 10);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 146 to 161
	value = ((uint32_t)(input[18] & 0x3f) << 26) |
			((uint32_t)input[19] << 18) |
			((uint32_t)(input[20] & 0xc0) << 10);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 162 to 177
	value = ((uint32_t)(input[20] & 0x3f) << 26) |
			((uint32_t)input[21] << 18) |
			((uint32_t)(input[22] & 0xc0) << 10);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 178 to 193
	value = ((uint32_t)(input[22] & 0x3f) << 26) |
			((uint32_t)input[23] << 18) |
			((uint32_t)(input[24] & 0xc0) << 10);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 194 to 209
	value = ((uint32_t)(input[24] & 0x3f) << 26) |
			((uint32_t)input[25] << 18) |
			((uint32_t)(input[26] & 0xc0) << 10);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 210 to 225
	value = ((uint32_t)(input[26] & 0x3f) << 26) |
			((uint32_t)input[27] << 18) |
			((uint32_t)(input[28] & 0xc0) << 10);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 226 to 241
	value = ((uint32_t)(input[28] & 0x3f) << 26) |
			((uint32_t)input[29] << 18) |
			((uint32_t)(input[30] & 0xc0) << 10);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 242 to 257
	value = ((uint32_t)(input[30] & 0x3f) << 26) |
			((uint32_t)input[31] << 18) |
			((uint32_t)(input[32] & 0xc0) << 10);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 258 to 273
	value = ((uint32_t)(input[32] & 0x3f) << 26) |
			((uint32_t)input[33] << 18) |
			((uint32_t)(input[34] & 0xc0) << 10);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 274 to 289
	value = ((uint32_t)(input[34] & 0x3f) << 26) |
			((uint32_t)input[35] << 18) |
			((uint32_t)(input[36] & 0xc0) << 10);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 290 to 305
	value = ((uint32_t)(input[36] & 0x3f) << 26) |
			((uint32_t)input[37] << 18) |
			((uint32_t)(input[38] & 0xc0) << 10);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 306 to 321
	value = ((uint32_t)(input[38] & 0x3f) << 26) |
			((uint32_t)input[39] << 18) |
			((uint32_t)(input[40] & 0xc0) << 10);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 322 to 337
	value = ((uint32_t)(input[40] & 0x3f) << 26) |
			((uint32_t)input[41] << 18) |
			((uint32_t)(input[42] & 0xc0) << 10);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 338 to 353
	value = ((uint32_t)(input[42] & 0x3f) << 26) |
			((uint32_t)input[43] << 18) |
			((uint32_t)(input[44] & 0xc0) << 10);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 354 to 369
	value = ((uint32_t)(input[44] & 0x3f) << 26) |
			((uint32_t)input[45] << 18) |
			((uint32_t)(input[46] & 0xc0) << 10);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 370 to 385
	value = ((uint32_t)(input[46] & 0x3f) << 26) |
			((uint32_t)input[47] << 18) |
			((uint32_t)(input[48] & 0xc0) << 10);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 386 to 401
	value = ((uint32_t)(input[48] & 0x3f) << 26) |
			((uint32_t)input[49] << 18) |
			((uint32_t)(input[50] & 0xc0) << 10);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 402 to 417
	value = ((uint32_t)(input[50] & 0x3f) << 26) |
			((uint32_t)input[51] << 18) |
			((uint32_t)(input[52] & 0xc0) << 10);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 418 to 433
	value = ((uint32_t)(input[52] & 0x3f) << 26) |
			((uint32_t)input[53] << 18) |
			((uint32_t)(input[54] & 0xc0) << 10);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 434 to 449
	value = ((uint32_t)(input[54] & 0x3f) << 26) |
			((uint32_t)input[55] << 18) |
			((uint32_t)(input[56] & 0xc0) << 10);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 450 to 465
	value = ((uint32_t)(input[56] & 0x3f) << 26) |
			((uint32_t)input[57] << 18) |
			((uint32_t)(input[58] & 0xc0) << 10);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 466 to 481
	value = ((uint32_t)(input[58] & 0x3f) << 26) |
			((uint32_t)input[59] << 18) |
			((uint32_t)(input[60] & 0xc0) << 10);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 482 to 497
	value = ((uint32_t)(input[60] & 0x3f) << 26) |
			((uint32_t)input[61] << 18) |
			((uint32_t)(input[62] & 0xc0) << 10);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 498 to 513
	value = ((uint32_t)(input[62] & 0x3f) << 26) |
			((uint32_t)input[63] << 18) |
			((uint32_t)(input[64] & 0xc0) << 10);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 514 to 529
	value = ((uint32_t)(input[64] & 0x3f) << 26) |
			((uint32_t)input[65] << 18) |
			((uint32_t)(input[66] & 0xc0) << 10);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 530 to 545
	value = ((uint32_t)(input[66] & 0x3f) << 26) |
			((uint32_t)input[67] << 18) |
			((uint32_t)(input[68] & 0xc0) << 10);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 546 to 561
	value = ((uint32_t)(input[68] & 0x3f) << 26) |
			((uint32_t)input[69] << 18) |
			((uint32_t)(input[70] & 0xc0) << 10);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 562 to 577
	value = ((uint32_t)(input[70] & 0x3f) << 26) |
			((uint32_t)input[71] << 18) |
			((uint32_t)(input[72] & 0xc0) << 10);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 578 to 593
	value = ((uint32_t)(input[72] & 0x3f) << 26) |
			((uint32_t)input[73] << 18) |
			((uint32_t)(input[74] & 0xc0) << 10);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 594 to 609
	value = ((uint32_t)(input[74] & 0x3f) << 26) |
			((uint32_t)input[75] << 18) |
			((uint32_t)(input[76] & 0xc0) << 10);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 610 to 625
	value = ((uint32_t)(input[76] & 0x3f) << 26) |
			((uint32_t)input[77] << 18) |
			((uint32_t)(input[78] & 0xc0) << 10);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 626 to 641
	value = ((uint32_t)(input[78] & 0x3f) << 26) |
			((uint32_t)input[79] << 18) |
			((uint32_t)(input[80] & 0xc0) << 10);
	output[39] = (double)(value >> 16);

	// read output[40]: from bit 642 to 657
	value = ((uint32_t)(input[80] & 0x3f) << 26) |
			((uint32_t)input[81] << 18) |
			((uint32_t)(input[82] & 0xc0) << 10);
	output[40] = (double)(value >> 16);

	// read output[41]: from bit 658 to 673
	value = ((uint32_t)(input[82] & 0x3f) << 26) |
			((uint32_t)input[83] << 18) |
			((uint32_t)(input[84] & 0xc0) << 10);
	output[41] = (double)(value >> 16);

	// read output[42]: from bit 674 to 689
	value = ((uint32_t)(input[84] & 0x3f) << 26) |
			((uint32_t)input[85] << 18) |
			((uint32_t)(input[86] & 0xc0) << 10);
	output[42] = (double)(value >> 16);

	// read output[43]: from bit 690 to 705
	value = ((uint32_t)(input[86] & 0x3f) << 26) |
			((uint32_t)input[87] << 18) |
			((uint32_t)(input[88] & 0xc0) << 10);
	output[43] = (double)(value >> 16);
}

static void unpack_44_16bit_signed_3off(const uint8_t * input, double * output, void *closure) {
	// Unpack 44 values into output
	// Values are 16-bit signed
	// Skip 3 bits, read 704 bits of data.
	// Input must be at least 89 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 3 to 18
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)input[1] << 19) |
			((uint32_t)(input[2] & 0xe0) << 11);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 19 to 34
	value = ((uint32_t)(input[2] & 0x1f) << 27) |
			((uint32_t)input[3] << 19) |
			((uint32_t)(input[4] & 0xe0) << 11);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 35 to 50
	value = ((uint32_t)(input[4] & 0x1f) << 27) |
			((uint32_t)input[5] << 19) |
			((uint32_t)(input[6] & 0xe0) << 11);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 51 to 66
	value = ((uint32_t)(input[6] & 0x1f) << 27) |
			((uint32_t)input[7] << 19) |
			((uint32_t)(input[8] & 0xe0) << 11);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 67 to 82
	value = ((uint32_t)(input[8] & 0x1f) << 27) |
			((uint32_t)input[9] << 19) |
			((uint32_t)(input[10] & 0xe0) << 11);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 83 to 98
	value = ((uint32_t)(input[10] & 0x1f) << 27) |
			((uint32_t)input[11] << 19) |
			((uint32_t)(input[12] & 0xe0) << 11);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 99 to 114
	value = ((uint32_t)(input[12] & 0x1f) << 27) |
			((uint32_t)input[13] << 19) |
			((uint32_t)(input[14] & 0xe0) << 11);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 115 to 130
	value = ((uint32_t)(input[14] & 0x1f) << 27) |
			((uint32_t)input[15] << 19) |
			((uint32_t)(input[16] & 0xe0) << 11);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 131 to 146
	value = ((uint32_t)(input[16] & 0x1f) << 27) |
			((uint32_t)input[17] << 19) |
			((uint32_t)(input[18] & 0xe0) << 11);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 147 to 162
	value = ((uint32_t)(input[18] & 0x1f) << 27) |
			((uint32_t)input[19] << 19) |
			((uint32_t)(input[20] & 0xe0) << 11);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 163 to 178
	value = ((uint32_t)(input[20] & 0x1f) << 27) |
			((uint32_t)input[21] << 19) |
			((uint32_t)(input[22] & 0xe0) << 11);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 179 to 194
	value = ((uint32_t)(input[22] & 0x1f) << 27) |
			((uint32_t)input[23] << 19) |
			((uint32_t)(input[24] & 0xe0) << 11);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 195 to 210
	value = ((uint32_t)(input[24] & 0x1f) << 27) |
			((uint32_t)input[25] << 19) |
			((uint32_t)(input[26] & 0xe0) << 11);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 211 to 226
	value = ((uint32_t)(input[26] & 0x1f) << 27) |
			((uint32_t)input[27] << 19) |
			((uint32_t)(input[28] & 0xe0) << 11);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 227 to 242
	value = ((uint32_t)(input[28] & 0x1f) << 27) |
			((uint32_t)input[29] << 19) |
			((uint32_t)(input[30] & 0xe0) << 11);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 243 to 258
	value = ((uint32_t)(input[30] & 0x1f) << 27) |
			((uint32_t)input[31] << 19) |
			((uint32_t)(input[32] & 0xe0) << 11);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 259 to 274
	value = ((uint32_t)(input[32] & 0x1f) << 27) |
			((uint32_t)input[33] << 19) |
			((uint32_t)(input[34] & 0xe0) << 11);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 275 to 290
	value = ((uint32_t)(input[34] & 0x1f) << 27) |
			((uint32_t)input[35] << 19) |
			((uint32_t)(input[36] & 0xe0) << 11);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 291 to 306
	value = ((uint32_t)(input[36] & 0x1f) << 27) |
			((uint32_t)input[37] << 19) |
			((uint32_t)(input[38] & 0xe0) << 11);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 307 to 322
	value = ((uint32_t)(input[38] & 0x1f) << 27) |
			((uint32_t)input[39] << 19) |
			((uint32_t)(input[40] & 0xe0) << 11);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 323 to 338
	value = ((uint32_t)(input[40] & 0x1f) << 27) |
			((uint32_t)input[41] << 19) |
			((uint32_t)(input[42] & 0xe0) << 11);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 339 to 354
	value = ((uint32_t)(input[42] & 0x1f) << 27) |
			((uint32_t)input[43] << 19) |
			((uint32_t)(input[44] & 0xe0) << 11);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 355 to 370
	value = ((uint32_t)(input[44] & 0x1f) << 27) |
			((uint32_t)input[45] << 19) |
			((uint32_t)(input[46] & 0xe0) << 11);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 371 to 386
	value = ((uint32_t)(input[46] & 0x1f) << 27) |
			((uint32_t)input[47] << 19) |
			((uint32_t)(input[48] & 0xe0) << 11);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 387 to 402
	value = ((uint32_t)(input[48] & 0x1f) << 27) |
			((uint32_t)input[49] << 19) |
			((uint32_t)(input[50] & 0xe0) << 11);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 403 to 418
	value = ((uint32_t)(input[50] & 0x1f) << 27) |
			((uint32_t)input[51] << 19) |
			((uint32_t)(input[52] & 0xe0) << 11);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 419 to 434
	value = ((uint32_t)(input[52] & 0x1f) << 27) |
			((uint32_t)input[53] << 19) |
			((uint32_t)(input[54] & 0xe0) << 11);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 435 to 450
	value = ((uint32_t)(input[54] & 0x1f) << 27) |
			((uint32_t)input[55] << 19) |
			((uint32_t)(input[56] & 0xe0) << 11);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 451 to 466
	value = ((uint32_t)(input[56] & 0x1f) << 27) |
			((uint32_t)input[57] << 19) |
			((uint32_t)(input[58] & 0xe0) << 11);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 467 to 482
	value = ((uint32_t)(input[58] & 0x1f) << 27) |
			((uint32_t)input[59] << 19) |
			((uint32_t)(input[60] & 0xe0) << 11);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 483 to 498
	value = ((uint32_t)(input[60] & 0x1f) << 27) |
			((uint32_t)input[61] << 19) |
			((uint32_t)(input[62] & 0xe0) << 11);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 499 to 514
	value = ((uint32_t)(input[62] & 0x1f) << 27) |
			((uint32_t)input[63] << 19) |
			((uint32_t)(input[64] & 0xe0) << 11);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 515 to 530
	value = ((uint32_t)(input[64] & 0x1f) << 27) |
			((uint32_t)input[65] << 19) |
			((uint32_t)(input[66] & 0xe0) << 11);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 531 to 546
	value = ((uint32_t)(input[66] & 0x1f) << 27) |
			((uint32_t)input[67] << 19) |
			((uint32_t)(input[68] & 0xe0) << 11);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 547 to 562
	value = ((uint32_t)(input[68] & 0x1f) << 27) |
			((uint32_t)input[69] << 19) |
			((uint32_t)(input[70] & 0xe0) << 11);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 563 to 578
	value = ((uint32_t)(input[70] & 0x1f) << 27) |
			((uint32_t)input[71] << 19) |
			((uint32_t)(input[72] & 0xe0) << 11);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 579 to 594
	value = ((uint32_t)(input[72] & 0x1f) << 27) |
			((uint32_t)input[73] << 19) |
			((uint32_t)(input[74] & 0xe0) << 11);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 595 to 610
	value = ((uint32_t)(input[74] & 0x1f) << 27) |
			((uint32_t)input[75] << 19) |
			((uint32_t)(input[76] & 0xe0) << 11);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 611 to 626
	value = ((uint32_t)(input[76] & 0x1f) << 27) |
			((uint32_t)input[77] << 19) |
			((uint32_t)(input[78] & 0xe0) << 11);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 627 to 642
	value = ((uint32_t)(input[78] & 0x1f) << 27) |
			((uint32_t)input[79] << 19) |
			((uint32_t)(input[80] & 0xe0) << 11);
	output[39] = (double)(value >> 16);

	// read output[40]: from bit 643 to 658
	value = ((uint32_t)(input[80] & 0x1f) << 27) |
			((uint32_t)input[81] << 19) |
			((uint32_t)(input[82] & 0xe0) << 11);
	output[40] = (double)(value >> 16);

	// read output[41]: from bit 659 to 674
	value = ((uint32_t)(input[82] & 0x1f) << 27) |
			((uint32_t)input[83] << 19) |
			((uint32_t)(input[84] & 0xe0) << 11);
	output[41] = (double)(value >> 16);

	// read output[42]: from bit 675 to 690
	value = ((uint32_t)(input[84] & 0x1f) << 27) |
			((uint32_t)input[85] << 19) |
			((uint32_t)(input[86] & 0xe0) << 11);
	output[42] = (double)(value >> 16);

	// read output[43]: from bit 691 to 706
	value = ((uint32_t)(input[86] & 0x1f) << 27) |
			((uint32_t)input[87] << 19) |
			((uint32_t)(input[88] & 0xe0) << 11);
	output[43] = (double)(value >> 16);
}

static void unpack_44_16bit_unsigned_3off(const uint8_t * input, double * output, void *closure) {
	// Unpack 44 values into output
	// Values are 16-bit unsigned
	// Skip 3 bits, read 704 bits of data.
	// Input must be at least 89 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 3 to 18
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)input[1] << 19) |
			((uint32_t)(input[2] & 0xe0) << 11);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 19 to 34
	value = ((uint32_t)(input[2] & 0x1f) << 27) |
			((uint32_t)input[3] << 19) |
			((uint32_t)(input[4] & 0xe0) << 11);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 35 to 50
	value = ((uint32_t)(input[4] & 0x1f) << 27) |
			((uint32_t)input[5] << 19) |
			((uint32_t)(input[6] & 0xe0) << 11);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 51 to 66
	value = ((uint32_t)(input[6] & 0x1f) << 27) |
			((uint32_t)input[7] << 19) |
			((uint32_t)(input[8] & 0xe0) << 11);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 67 to 82
	value = ((uint32_t)(input[8] & 0x1f) << 27) |
			((uint32_t)input[9] << 19) |
			((uint32_t)(input[10] & 0xe0) << 11);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 83 to 98
	value = ((uint32_t)(input[10] & 0x1f) << 27) |
			((uint32_t)input[11] << 19) |
			((uint32_t)(input[12] & 0xe0) << 11);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 99 to 114
	value = ((uint32_t)(input[12] & 0x1f) << 27) |
			((uint32_t)input[13] << 19) |
			((uint32_t)(input[14] & 0xe0) << 11);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 115 to 130
	value = ((uint32_t)(input[14] & 0x1f) << 27) |
			((uint32_t)input[15] << 19) |
			((uint32_t)(input[16] & 0xe0) << 11);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 131 to 146
	value = ((uint32_t)(input[16] & 0x1f) << 27) |
			((uint32_t)input[17] << 19) |
			((uint32_t)(input[18] & 0xe0) << 11);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 147 to 162
	value = ((uint32_t)(input[18] & 0x1f) << 27) |
			((uint32_t)input[19] << 19) |
			((uint32_t)(input[20] & 0xe0) << 11);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 163 to 178
	value = ((uint32_t)(input[20] & 0x1f) << 27) |
			((uint32_t)input[21] << 19) |
			((uint32_t)(input[22] & 0xe0) << 11);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 179 to 194
	value = ((uint32_t)(input[22] & 0x1f) << 27) |
			((uint32_t)input[23] << 19) |
			((uint32_t)(input[24] & 0xe0) << 11);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 195 to 210
	value = ((uint32_t)(input[24] & 0x1f) << 27) |
			((uint32_t)input[25] << 19) |
			((uint32_t)(input[26] & 0xe0) << 11);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 211 to 226
	value = ((uint32_t)(input[26] & 0x1f) << 27) |
			((uint32_t)input[27] << 19) |
			((uint32_t)(input[28] & 0xe0) << 11);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 227 to 242
	value = ((uint32_t)(input[28] & 0x1f) << 27) |
			((uint32_t)input[29] << 19) |
			((uint32_t)(input[30] & 0xe0) << 11);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 243 to 258
	value = ((uint32_t)(input[30] & 0x1f) << 27) |
			((uint32_t)input[31] << 19) |
			((uint32_t)(input[32] & 0xe0) << 11);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 259 to 274
	value = ((uint32_t)(input[32] & 0x1f) << 27) |
			((uint32_t)input[33] << 19) |
			((uint32_t)(input[34] & 0xe0) << 11);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 275 to 290
	value = ((uint32_t)(input[34] & 0x1f) << 27) |
			((uint32_t)input[35] << 19) |
			((uint32_t)(input[36] & 0xe0) << 11);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 291 to 306
	value = ((uint32_t)(input[36] & 0x1f) << 27) |
			((uint32_t)input[37] << 19) |
			((uint32_t)(input[38] & 0xe0) << 11);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 307 to 322
	value = ((uint32_t)(input[38] & 0x1f) << 27) |
			((uint32_t)input[39] << 19) |
			((uint32_t)(input[40] & 0xe0) << 11);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 323 to 338
	value = ((uint32_t)(input[40] & 0x1f) << 27) |
			((uint32_t)input[41] << 19) |
			((uint32_t)(input[42] & 0xe0) << 11);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 339 to 354
	value = ((uint32_t)(input[42] & 0x1f) << 27) |
			((uint32_t)input[43] << 19) |
			((uint32_t)(input[44] & 0xe0) << 11);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 355 to 370
	value = ((uint32_t)(input[44] & 0x1f) << 27) |
			((uint32_t)input[45] << 19) |
			((uint32_t)(input[46] & 0xe0) << 11);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 371 to 386
	value = ((uint32_t)(input[46] & 0x1f) << 27) |
			((uint32_t)input[47] << 19) |
			((uint32_t)(input[48] & 0xe0) << 11);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 387 to 402
	value = ((uint32_t)(input[48] & 0x1f) << 27) |
			((uint32_t)input[49] << 19) |
			((uint32_t)(input[50] & 0xe0) << 11);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 403 to 418
	value = ((uint32_t)(input[50] & 0x1f) << 27) |
			((uint32_t)input[51] << 19) |
			((uint32_t)(input[52] & 0xe0) << 11);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 419 to 434
	value = ((uint32_t)(input[52] & 0x1f) << 27) |
			((uint32_t)input[53] << 19) |
			((uint32_t)(input[54] & 0xe0) << 11);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 435 to 450
	value = ((uint32_t)(input[54] & 0x1f) << 27) |
			((uint32_t)input[55] << 19) |
			((uint32_t)(input[56] & 0xe0) << 11);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 451 to 466
	value = ((uint32_t)(input[56] & 0x1f) << 27) |
			((uint32_t)input[57] << 19) |
			((uint32_t)(input[58] & 0xe0) << 11);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 467 to 482
	value = ((uint32_t)(input[58] & 0x1f) << 27) |
			((uint32_t)input[59] << 19) |
			((uint32_t)(input[60] & 0xe0) << 11);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 483 to 498
	value = ((uint32_t)(input[60] & 0x1f) << 27) |
			((uint32_t)input[61] << 19) |
			((uint32_t)(input[62] & 0xe0) << 11);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 499 to 514
	value = ((uint32_t)(input[62] & 0x1f) << 27) |
			((uint32_t)input[63] << 19) |
			((uint32_t)(input[64] & 0xe0) << 11);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 515 to 530
	value = ((uint32_t)(input[64] & 0x1f) << 27) |
			((uint32_t)input[65] << 19) |
			((uint32_t)(input[66] & 0xe0) << 11);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 531 to 546
	value = ((uint32_t)(input[66] & 0x1f) << 27) |
			((uint32_t)input[67] << 19) |
			((uint32_t)(input[68] & 0xe0) << 11);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 547 to 562
	value = ((uint32_t)(input[68] & 0x1f) << 27) |
			((uint32_t)input[69] << 19) |
			((uint32_t)(input[70] & 0xe0) << 11);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 563 to 578
	value = ((uint32_t)(input[70] & 0x1f) << 27) |
			((uint32_t)input[71] << 19) |
			((uint32_t)(input[72] & 0xe0) << 11);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 579 to 594
	value = ((uint32_t)(input[72] & 0x1f) << 27) |
			((uint32_t)input[73] << 19) |
			((uint32_t)(input[74] & 0xe0) << 11);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 595 to 610
	value = ((uint32_t)(input[74] & 0x1f) << 27) |
			((uint32_t)input[75] << 19) |
			((uint32_t)(input[76] & 0xe0) << 11);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 611 to 626
	value = ((uint32_t)(input[76] & 0x1f) << 27) |
			((uint32_t)input[77] << 19) |
			((uint32_t)(input[78] & 0xe0) << 11);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 627 to 642
	value = ((uint32_t)(input[78] & 0x1f) << 27) |
			((uint32_t)input[79] << 19) |
			((uint32_t)(input[80] & 0xe0) << 11);
	output[39] = (double)(value >> 16);

	// read output[40]: from bit 643 to 658
	value = ((uint32_t)(input[80] & 0x1f) << 27) |
			((uint32_t)input[81] << 19) |
			((uint32_t)(input[82] & 0xe0) << 11);
	output[40] = (double)(value >> 16);

	// read output[41]: from bit 659 to 674
	value = ((uint32_t)(input[82] & 0x1f) << 27) |
			((uint32_t)input[83] << 19) |
			((uint32_t)(input[84] & 0xe0) << 11);
	output[41] = (double)(value >> 16);

	// read output[42]: from bit 675 to 690
	value = ((uint32_t)(input[84] & 0x1f) << 27) |
			((uint32_t)input[85] << 19) |
			((uint32_t)(input[86] & 0xe0) << 11);
	output[42] = (double)(value >> 16);

	// read output[43]: from bit 691 to 706
	value = ((uint32_t)(input[86] & 0x1f) << 27) |
			((uint32_t)input[87] << 19) |
			((uint32_t)(input[88] & 0xe0) << 11);
	output[43] = (double)(value >> 16);
}

static void unpack_44_16bit_signed_4off(const uint8_t * input, double * output, void *closure) {
	// Unpack 44 values into output
	// Values are 16-bit signed
	// Skip 4 bits, read 704 bits of data.
	// Input must be at least 89 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 4 to 19
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20) |
			((uint32_t)(input[2] & 0xf0) << 12);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 20 to 35
	value = ((uint32_t)(input[2] & 0x0f) << 28) |
			((uint32_t)input[3] << 20) |
			((uint32_t)(input[4] & 0xf0) << 12);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 36 to 51
	value = ((uint32_t)(input[4] & 0x0f) << 28) |
			((uint32_t)input[5] << 20) |
			((uint32_t)(input[6] & 0xf0) << 12);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 52 to 67
	value = ((uint32_t)(input[6] & 0x0f) << 28) |
			((uint32_t)input[7] << 20) |
			((uint32_t)(input[8] & 0xf0) << 12);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 68 to 83
	value = ((uint32_t)(input[8] & 0x0f) << 28) |
			((uint32_t)input[9] << 20) |
			((uint32_t)(input[10] & 0xf0) << 12);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 84 to 99
	value = ((uint32_t)(input[10] & 0x0f) << 28) |
			((uint32_t)input[11] << 20) |
			((uint32_t)(input[12] & 0xf0) << 12);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 100 to 115
	value = ((uint32_t)(input[12] & 0x0f) << 28) |
			((uint32_t)input[13] << 20) |
			((uint32_t)(input[14] & 0xf0) << 12);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 116 to 131
	value = ((uint32_t)(input[14] & 0x0f) << 28) |
			((uint32_t)input[15] << 20) |
			((uint32_t)(input[16] & 0xf0) << 12);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 132 to 147
	value = ((uint32_t)(input[16] & 0x0f) << 28) |
			((uint32_t)input[17] << 20) |
			((uint32_t)(input[18] & 0xf0) << 12);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 148 to 163
	value = ((uint32_t)(input[18] & 0x0f) << 28) |
			((uint32_t)input[19] << 20) |
			((uint32_t)(input[20] & 0xf0) << 12);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 164 to 179
	value = ((uint32_t)(input[20] & 0x0f) << 28) |
			((uint32_t)input[21] << 20) |
			((uint32_t)(input[22] & 0xf0) << 12);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 180 to 195
	value = ((uint32_t)(input[22] & 0x0f) << 28) |
			((uint32_t)input[23] << 20) |
			((uint32_t)(input[24] & 0xf0) << 12);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 196 to 211
	value = ((uint32_t)(input[24] & 0x0f) << 28) |
			((uint32_t)input[25] << 20) |
			((uint32_t)(input[26] & 0xf0) << 12);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 212 to 227
	value = ((uint32_t)(input[26] & 0x0f) << 28) |
			((uint32_t)input[27] << 20) |
			((uint32_t)(input[28] & 0xf0) << 12);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 228 to 243
	value = ((uint32_t)(input[28] & 0x0f) << 28) |
			((uint32_t)input[29] << 20) |
			((uint32_t)(input[30] & 0xf0) << 12);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 244 to 259
	value = ((uint32_t)(input[30] & 0x0f) << 28) |
			((uint32_t)input[31] << 20) |
			((uint32_t)(input[32] & 0xf0) << 12);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 260 to 275
	value = ((uint32_t)(input[32] & 0x0f) << 28) |
			((uint32_t)input[33] << 20) |
			((uint32_t)(input[34] & 0xf0) << 12);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 276 to 291
	value = ((uint32_t)(input[34] & 0x0f) << 28) |
			((uint32_t)input[35] << 20) |
			((uint32_t)(input[36] & 0xf0) << 12);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 292 to 307
	value = ((uint32_t)(input[36] & 0x0f) << 28) |
			((uint32_t)input[37] << 20) |
			((uint32_t)(input[38] & 0xf0) << 12);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 308 to 323
	value = ((uint32_t)(input[38] & 0x0f) << 28) |
			((uint32_t)input[39] << 20) |
			((uint32_t)(input[40] & 0xf0) << 12);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 324 to 339
	value = ((uint32_t)(input[40] & 0x0f) << 28) |
			((uint32_t)input[41] << 20) |
			((uint32_t)(input[42] & 0xf0) << 12);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 340 to 355
	value = ((uint32_t)(input[42] & 0x0f) << 28) |
			((uint32_t)input[43] << 20) |
			((uint32_t)(input[44] & 0xf0) << 12);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 356 to 371
	value = ((uint32_t)(input[44] & 0x0f) << 28) |
			((uint32_t)input[45] << 20) |
			((uint32_t)(input[46] & 0xf0) << 12);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 372 to 387
	value = ((uint32_t)(input[46] & 0x0f) << 28) |
			((uint32_t)input[47] << 20) |
			((uint32_t)(input[48] & 0xf0) << 12);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 388 to 403
	value = ((uint32_t)(input[48] & 0x0f) << 28) |
			((uint32_t)input[49] << 20) |
			((uint32_t)(input[50] & 0xf0) << 12);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 404 to 419
	value = ((uint32_t)(input[50] & 0x0f) << 28) |
			((uint32_t)input[51] << 20) |
			((uint32_t)(input[52] & 0xf0) << 12);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 420 to 435
	value = ((uint32_t)(input[52] & 0x0f) << 28) |
			((uint32_t)input[53] << 20) |
			((uint32_t)(input[54] & 0xf0) << 12);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 436 to 451
	value = ((uint32_t)(input[54] & 0x0f) << 28) |
			((uint32_t)input[55] << 20) |
			((uint32_t)(input[56] & 0xf0) << 12);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 452 to 467
	value = ((uint32_t)(input[56] & 0x0f) << 28) |
			((uint32_t)input[57] << 20) |
			((uint32_t)(input[58] & 0xf0) << 12);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 468 to 483
	value = ((uint32_t)(input[58] & 0x0f) << 28) |
			((uint32_t)input[59] << 20) |
			((uint32_t)(input[60] & 0xf0) << 12);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 484 to 499
	value = ((uint32_t)(input[60] & 0x0f) << 28) |
			((uint32_t)input[61] << 20) |
			((uint32_t)(input[62] & 0xf0) << 12);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 500 to 515
	value = ((uint32_t)(input[62] & 0x0f) << 28) |
			((uint32_t)input[63] << 20) |
			((uint32_t)(input[64] & 0xf0) << 12);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 516 to 531
	value = ((uint32_t)(input[64] & 0x0f) << 28) |
			((uint32_t)input[65] << 20) |
			((uint32_t)(input[66] & 0xf0) << 12);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 532 to 547
	value = ((uint32_t)(input[66] & 0x0f) << 28) |
			((uint32_t)input[67] << 20) |
			((uint32_t)(input[68] & 0xf0) << 12);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 548 to 563
	value = ((uint32_t)(input[68] & 0x0f) << 28) |
			((uint32_t)input[69] << 20) |
			((uint32_t)(input[70] & 0xf0) << 12);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 564 to 579
	value = ((uint32_t)(input[70] & 0x0f) << 28) |
			((uint32_t)input[71] << 20) |
			((uint32_t)(input[72] & 0xf0) << 12);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 580 to 595
	value = ((uint32_t)(input[72] & 0x0f) << 28) |
			((uint32_t)input[73] << 20) |
			((uint32_t)(input[74] & 0xf0) << 12);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 596 to 611
	value = ((uint32_t)(input[74] & 0x0f) << 28) |
			((uint32_t)input[75] << 20) |
			((uint32_t)(input[76] & 0xf0) << 12);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 612 to 627
	value = ((uint32_t)(input[76] & 0x0f) << 28) |
			((uint32_t)input[77] << 20) |
			((uint32_t)(input[78] & 0xf0) << 12);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 628 to 643
	value = ((uint32_t)(input[78] & 0x0f) << 28) |
			((uint32_t)input[79] << 20) |
			((uint32_t)(input[80] & 0xf0) << 12);
	output[39] = (double)(value >> 16);

	// read output[40]: from bit 644 to 659
	value = ((uint32_t)(input[80] & 0x0f) << 28) |
			((uint32_t)input[81] << 20) |
			((uint32_t)(input[82] & 0xf0) << 12);
	output[40] = (double)(value >> 16);

	// read output[41]: from bit 660 to 675
	value = ((uint32_t)(input[82] & 0x0f) << 28) |
			((uint32_t)input[83] << 20) |
			((uint32_t)(input[84] & 0xf0) << 12);
	output[41] = (double)(value >> 16);

	// read output[42]: from bit 676 to 691
	value = ((uint32_t)(input[84] & 0x0f) << 28) |
			((uint32_t)input[85] << 20) |
			((uint32_t)(input[86] & 0xf0) << 12);
	output[42] = (double)(value >> 16);

	// read output[43]: from bit 692 to 707
	value = ((uint32_t)(input[86] & 0x0f) << 28) |
			((uint32_t)input[87] << 20) |
			((uint32_t)(input[88] & 0xf0) << 12);
	output[43] = (double)(value >> 16);
}

static void unpack_44_16bit_unsigned_4off(const uint8_t * input, double * output, void *closure) {
	// Unpack 44 values into output
	// Values are 16-bit unsigned
	// Skip 4 bits, read 704 bits of data.
	// Input must be at least 89 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 4 to 19
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20) |
			((uint32_t)(input[2] & 0xf0) << 12);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 20 to 35
	value = ((uint32_t)(input[2] & 0x0f) << 28) |
			((uint32_t)input[3] << 20) |
			((uint32_t)(input[4] & 0xf0) << 12);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 36 to 51
	value = ((uint32_t)(input[4] & 0x0f) << 28) |
			((uint32_t)input[5] << 20) |
			((uint32_t)(input[6] & 0xf0) << 12);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 52 to 67
	value = ((uint32_t)(input[6] & 0x0f) << 28) |
			((uint32_t)input[7] << 20) |
			((uint32_t)(input[8] & 0xf0) << 12);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 68 to 83
	value = ((uint32_t)(input[8] & 0x0f) << 28) |
			((uint32_t)input[9] << 20) |
			((uint32_t)(input[10] & 0xf0) << 12);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 84 to 99
	value = ((uint32_t)(input[10] & 0x0f) << 28) |
			((uint32_t)input[11] << 20) |
			((uint32_t)(input[12] & 0xf0) << 12);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 100 to 115
	value = ((uint32_t)(input[12] & 0x0f) << 28) |
			((uint32_t)input[13] << 20) |
			((uint32_t)(input[14] & 0xf0) << 12);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 116 to 131
	value = ((uint32_t)(input[14] & 0x0f) << 28) |
			((uint32_t)input[15] << 20) |
			((uint32_t)(input[16] & 0xf0) << 12);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 132 to 147
	value = ((uint32_t)(input[16] & 0x0f) << 28) |
			((uint32_t)input[17] << 20) |
			((uint32_t)(input[18] & 0xf0) << 12);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 148 to 163
	value = ((uint32_t)(input[18] & 0x0f) << 28) |
			((uint32_t)input[19] << 20) |
			((uint32_t)(input[20] & 0xf0) << 12);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 164 to 179
	value = ((uint32_t)(input[20] & 0x0f) << 28) |
			((uint32_t)input[21] << 20) |
			((uint32_t)(input[22] & 0xf0) << 12);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 180 to 195
	value = ((uint32_t)(input[22] & 0x0f) << 28) |
			((uint32_t)input[23] << 20) |
			((uint32_t)(input[24] & 0xf0) << 12);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 196 to 211
	value = ((uint32_t)(input[24] & 0x0f) << 28) |
			((uint32_t)input[25] << 20) |
			((uint32_t)(input[26] & 0xf0) << 12);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 212 to 227
	value = ((uint32_t)(input[26] & 0x0f) << 28) |
			((uint32_t)input[27] << 20) |
			((uint32_t)(input[28] & 0xf0) << 12);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 228 to 243
	value = ((uint32_t)(input[28] & 0x0f) << 28) |
			((uint32_t)input[29] << 20) |
			((uint32_t)(input[30] & 0xf0) << 12);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 244 to 259
	value = ((uint32_t)(input[30] & 0x0f) << 28) |
			((uint32_t)input[31] << 20) |
			((uint32_t)(input[32] & 0xf0) << 12);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 260 to 275
	value = ((uint32_t)(input[32] & 0x0f) << 28) |
			((uint32_t)input[33] << 20) |
			((uint32_t)(input[34] & 0xf0) << 12);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 276 to 291
	value = ((uint32_t)(input[34] & 0x0f) << 28) |
			((uint32_t)input[35] << 20) |
			((uint32_t)(input[36] & 0xf0) << 12);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 292 to 307
	value = ((uint32_t)(input[36] & 0x0f) << 28) |
			((uint32_t)input[37] << 20) |
			((uint32_t)(input[38] & 0xf0) << 12);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 308 to 323
	value = ((uint32_t)(input[38] & 0x0f) << 28) |
			((uint32_t)input[39] << 20) |
			((uint32_t)(input[40] & 0xf0) << 12);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 324 to 339
	value = ((uint32_t)(input[40] & 0x0f) << 28) |
			((uint32_t)input[41] << 20) |
			((uint32_t)(input[42] & 0xf0) << 12);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 340 to 355
	value = ((uint32_t)(input[42] & 0x0f) << 28) |
			((uint32_t)input[43] << 20) |
			((uint32_t)(input[44] & 0xf0) << 12);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 356 to 371
	value = ((uint32_t)(input[44] & 0x0f) << 28) |
			((uint32_t)input[45] << 20) |
			((uint32_t)(input[46] & 0xf0) << 12);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 372 to 387
	value = ((uint32_t)(input[46] & 0x0f) << 28) |
			((uint32_t)input[47] << 20) |
			((uint32_t)(input[48] & 0xf0) << 12);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 388 to 403
	value = ((uint32_t)(input[48] & 0x0f) << 28) |
			((uint32_t)input[49] << 20) |
			((uint32_t)(input[50] & 0xf0) << 12);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 404 to 419
	value = ((uint32_t)(input[50] & 0x0f) << 28) |
			((uint32_t)input[51] << 20) |
			((uint32_t)(input[52] & 0xf0) << 12);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 420 to 435
	value = ((uint32_t)(input[52] & 0x0f) << 28) |
			((uint32_t)input[53] << 20) |
			((uint32_t)(input[54] & 0xf0) << 12);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 436 to 451
	value = ((uint32_t)(input[54] & 0x0f) << 28) |
			((uint32_t)input[55] << 20) |
			((uint32_t)(input[56] & 0xf0) << 12);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 452 to 467
	value = ((uint32_t)(input[56] & 0x0f) << 28) |
			((uint32_t)input[57] << 20) |
			((uint32_t)(input[58] & 0xf0) << 12);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 468 to 483
	value = ((uint32_t)(input[58] & 0x0f) << 28) |
			((uint32_t)input[59] << 20) |
			((uint32_t)(input[60] & 0xf0) << 12);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 484 to 499
	value = ((uint32_t)(input[60] & 0x0f) << 28) |
			((uint32_t)input[61] << 20) |
			((uint32_t)(input[62] & 0xf0) << 12);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 500 to 515
	value = ((uint32_t)(input[62] & 0x0f) << 28) |
			((uint32_t)input[63] << 20) |
			((uint32_t)(input[64] & 0xf0) << 12);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 516 to 531
	value = ((uint32_t)(input[64] & 0x0f) << 28) |
			((uint32_t)input[65] << 20) |
			((uint32_t)(input[66] & 0xf0) << 12);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 532 to 547
	value = ((uint32_t)(input[66] & 0x0f) << 28) |
			((uint32_t)input[67] << 20) |
			((uint32_t)(input[68] & 0xf0) << 12);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 548 to 563
	value = ((uint32_t)(input[68] & 0x0f) << 28) |
			((uint32_t)input[69] << 20) |
			((uint32_t)(input[70] & 0xf0) << 12);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 564 to 579
	value = ((uint32_t)(input[70] & 0x0f) << 28) |
			((uint32_t)input[71] << 20) |
			((uint32_t)(input[72] & 0xf0) << 12);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 580 to 595
	value = ((uint32_t)(input[72] & 0x0f) << 28) |
			((uint32_t)input[73] << 20) |
			((uint32_t)(input[74] & 0xf0) << 12);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 596 to 611
	value = ((uint32_t)(input[74] & 0x0f) << 28) |
			((uint32_t)input[75] << 20) |
			((uint32_t)(input[76] & 0xf0) << 12);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 612 to 627
	value = ((uint32_t)(input[76] & 0x0f) << 28) |
			((uint32_t)input[77] << 20) |
			((uint32_t)(input[78] & 0xf0) << 12);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 628 to 643
	value = ((uint32_t)(input[78] & 0x0f) << 28) |
			((uint32_t)input[79] << 20) |
			((uint32_t)(input[80] & 0xf0) << 12);
	output[39] = (double)(value >> 16);

	// read output[40]: from bit 644 to 659
	value = ((uint32_t)(input[80] & 0x0f) << 28) |
			((uint32_t)input[81] << 20) |
			((uint32_t)(input[82] & 0xf0) << 12);
	output[40] = (double)(value >> 16);

	// read output[41]: from bit 660 to 675
	value = ((uint32_t)(input[82] & 0x0f) << 28) |
			((uint32_t)input[83] << 20) |
			((uint32_t)(input[84] & 0xf0) << 12);
	output[41] = (double)(value >> 16);

	// read output[42]: from bit 676 to 691
	value = ((uint32_t)(input[84] & 0x0f) << 28) |
			((uint32_t)input[85] << 20) |
			((uint32_t)(input[86] & 0xf0) << 12);
	output[42] = (double)(value >> 16);

	// read output[43]: from bit 692 to 707
	value = ((uint32_t)(input[86] & 0x0f) << 28) |
			((uint32_t)input[87] << 20) |
			((uint32_t)(input[88] & 0xf0) << 12);
	output[43] = (double)(value >> 16);
}

static void unpack_44_16bit_signed_5off(const uint8_t * input, double * output, void *closure) {
	// Unpack 44 values into output
	// Values are 16-bit signed
	// Skip 5 bits, read 704 bits of data.
	// Input must be at least 89 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 5 to 20
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)(input[2] & 0xf8) << 13);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 21 to 36
	value = ((uint32_t)(input[2] & 0x07) << 29) |
			((uint32_t)input[3] << 21) |
			((uint32_t)(input[4] & 0xf8) << 13);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 37 to 52
	value = ((uint32_t)(input[4] & 0x07) << 29) |
			((uint32_t)input[5] << 21) |
			((uint32_t)(input[6] & 0xf8) << 13);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 53 to 68
	value = ((uint32_t)(input[6] & 0x07) << 29) |
			((uint32_t)input[7] << 21) |
			((uint32_t)(input[8] & 0xf8) << 13);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 69 to 84
	value = ((uint32_t)(input[8] & 0x07) << 29) |
			((uint32_t)input[9] << 21) |
			((uint32_t)(input[10] & 0xf8) << 13);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 85 to 100
	value = ((uint32_t)(input[10] & 0x07) << 29) |
			((uint32_t)input[11] << 21) |
			((uint32_t)(input[12] & 0xf8) << 13);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 101 to 116
	value = ((uint32_t)(input[12] & 0x07) << 29) |
			((uint32_t)input[13] << 21) |
			((uint32_t)(input[14] & 0xf8) << 13);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 117 to 132
	value = ((uint32_t)(input[14] & 0x07) << 29) |
			((uint32_t)input[15] << 21) |
			((uint32_t)(input[16] & 0xf8) << 13);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 133 to 148
	value = ((uint32_t)(input[16] & 0x07) << 29) |
			((uint32_t)input[17] << 21) |
			((uint32_t)(input[18] & 0xf8) << 13);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 149 to 164
	value = ((uint32_t)(input[18] & 0x07) << 29) |
			((uint32_t)input[19] << 21) |
			((uint32_t)(input[20] & 0xf8) << 13);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 165 to 180
	value = ((uint32_t)(input[20] & 0x07) << 29) |
			((uint32_t)input[21] << 21) |
			((uint32_t)(input[22] & 0xf8) << 13);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 181 to 196
	value = ((uint32_t)(input[22] & 0x07) << 29) |
			((uint32_t)input[23] << 21) |
			((uint32_t)(input[24] & 0xf8) << 13);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 197 to 212
	value = ((uint32_t)(input[24] & 0x07) << 29) |
			((uint32_t)input[25] << 21) |
			((uint32_t)(input[26] & 0xf8) << 13);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 213 to 228
	value = ((uint32_t)(input[26] & 0x07) << 29) |
			((uint32_t)input[27] << 21) |
			((uint32_t)(input[28] & 0xf8) << 13);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 229 to 244
	value = ((uint32_t)(input[28] & 0x07) << 29) |
			((uint32_t)input[29] << 21) |
			((uint32_t)(input[30] & 0xf8) << 13);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 245 to 260
	value = ((uint32_t)(input[30] & 0x07) << 29) |
			((uint32_t)input[31] << 21) |
			((uint32_t)(input[32] & 0xf8) << 13);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 261 to 276
	value = ((uint32_t)(input[32] & 0x07) << 29) |
			((uint32_t)input[33] << 21) |
			((uint32_t)(input[34] & 0xf8) << 13);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 277 to 292
	value = ((uint32_t)(input[34] & 0x07) << 29) |
			((uint32_t)input[35] << 21) |
			((uint32_t)(input[36] & 0xf8) << 13);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 293 to 308
	value = ((uint32_t)(input[36] & 0x07) << 29) |
			((uint32_t)input[37] << 21) |
			((uint32_t)(input[38] & 0xf8) << 13);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 309 to 324
	value = ((uint32_t)(input[38] & 0x07) << 29) |
			((uint32_t)input[39] << 21) |
			((uint32_t)(input[40] & 0xf8) << 13);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 325 to 340
	value = ((uint32_t)(input[40] & 0x07) << 29) |
			((uint32_t)input[41] << 21) |
			((uint32_t)(input[42] & 0xf8) << 13);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 341 to 356
	value = ((uint32_t)(input[42] & 0x07) << 29) |
			((uint32_t)input[43] << 21) |
			((uint32_t)(input[44] & 0xf8) << 13);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 357 to 372
	value = ((uint32_t)(input[44] & 0x07) << 29) |
			((uint32_t)input[45] << 21) |
			((uint32_t)(input[46] & 0xf8) << 13);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 373 to 388
	value = ((uint32_t)(input[46] & 0x07) << 29) |
			((uint32_t)input[47] << 21) |
			((uint32_t)(input[48] & 0xf8) << 13);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 389 to 404
	value = ((uint32_t)(input[48] & 0x07) << 29) |
			((uint32_t)input[49] << 21) |
			((uint32_t)(input[50] & 0xf8) << 13);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 405 to 420
	value = ((uint32_t)(input[50] & 0x07) << 29) |
			((uint32_t)input[51] << 21) |
			((uint32_t)(input[52] & 0xf8) << 13);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 421 to 436
	value = ((uint32_t)(input[52] & 0x07) << 29) |
			((uint32_t)input[53] << 21) |
			((uint32_t)(input[54] & 0xf8) << 13);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 437 to 452
	value = ((uint32_t)(input[54] & 0x07) << 29) |
			((uint32_t)input[55] << 21) |
			((uint32_t)(input[56] & 0xf8) << 13);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 453 to 468
	value = ((uint32_t)(input[56] & 0x07) << 29) |
			((uint32_t)input[57] << 21) |
			((uint32_t)(input[58] & 0xf8) << 13);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 469 to 484
	value = ((uint32_t)(input[58] & 0x07) << 29) |
			((uint32_t)input[59] << 21) |
			((uint32_t)(input[60] & 0xf8) << 13);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 485 to 500
	value = ((uint32_t)(input[60] & 0x07) << 29) |
			((uint32_t)input[61] << 21) |
			((uint32_t)(input[62] & 0xf8) << 13);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 501 to 516
	value = ((uint32_t)(input[62] & 0x07) << 29) |
			((uint32_t)input[63] << 21) |
			((uint32_t)(input[64] & 0xf8) << 13);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 517 to 532
	value = ((uint32_t)(input[64] & 0x07) << 29) |
			((uint32_t)input[65] << 21) |
			((uint32_t)(input[66] & 0xf8) << 13);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 533 to 548
	value = ((uint32_t)(input[66] & 0x07) << 29) |
			((uint32_t)input[67] << 21) |
			((uint32_t)(input[68] & 0xf8) << 13);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 549 to 564
	value = ((uint32_t)(input[68] & 0x07) << 29) |
			((uint32_t)input[69] << 21) |
			((uint32_t)(input[70] & 0xf8) << 13);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 565 to 580
	value = ((uint32_t)(input[70] & 0x07) << 29) |
			((uint32_t)input[71] << 21) |
			((uint32_t)(input[72] & 0xf8) << 13);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 581 to 596
	value = ((uint32_t)(input[72] & 0x07) << 29) |
			((uint32_t)input[73] << 21) |
			((uint32_t)(input[74] & 0xf8) << 13);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 597 to 612
	value = ((uint32_t)(input[74] & 0x07) << 29) |
			((uint32_t)input[75] << 21) |
			((uint32_t)(input[76] & 0xf8) << 13);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 613 to 628
	value = ((uint32_t)(input[76] & 0x07) << 29) |
			((uint32_t)input[77] << 21) |
			((uint32_t)(input[78] & 0xf8) << 13);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 629 to 644
	value = ((uint32_t)(input[78] & 0x07) << 29) |
			((uint32_t)input[79] << 21) |
			((uint32_t)(input[80] & 0xf8) << 13);
	output[39] = (double)(value >> 16);

	// read output[40]: from bit 645 to 660
	value = ((uint32_t)(input[80] & 0x07) << 29) |
			((uint32_t)input[81] << 21) |
			((uint32_t)(input[82] & 0xf8) << 13);
	output[40] = (double)(value >> 16);

	// read output[41]: from bit 661 to 676
	value = ((uint32_t)(input[82] & 0x07) << 29) |
			((uint32_t)input[83] << 21) |
			((uint32_t)(input[84] & 0xf8) << 13);
	output[41] = (double)(value >> 16);

	// read output[42]: from bit 677 to 692
	value = ((uint32_t)(input[84] & 0x07) << 29) |
			((uint32_t)input[85] << 21) |
			((uint32_t)(input[86] & 0xf8) << 13);
	output[42] = (double)(value >> 16);

	// read output[43]: from bit 693 to 708
	value = ((uint32_t)(input[86] & 0x07) << 29) |
			((uint32_t)input[87] << 21) |
			((uint32_t)(input[88] & 0xf8) << 13);
	output[43] = (double)(value >> 16);
}

static void unpack_44_16bit_unsigned_5off(const uint8_t * input, double * output, void *closure) {
	// Unpack 44 values into output
	// Values are 16-bit unsigned
	// Skip 5 bits, read 704 bits of data.
	// Input must be at least 89 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 5 to 20
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)(input[2] & 0xf8) << 13);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 21 to 36
	value = ((uint32_t)(input[2] & 0x07) << 29) |
			((uint32_t)input[3] << 21) |
			((uint32_t)(input[4] & 0xf8) << 13);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 37 to 52
	value = ((uint32_t)(input[4] & 0x07) << 29) |
			((uint32_t)input[5] << 21) |
			((uint32_t)(input[6] & 0xf8) << 13);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 53 to 68
	value = ((uint32_t)(input[6] & 0x07) << 29) |
			((uint32_t)input[7] << 21) |
			((uint32_t)(input[8] & 0xf8) << 13);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 69 to 84
	value = ((uint32_t)(input[8] & 0x07) << 29) |
			((uint32_t)input[9] << 21) |
			((uint32_t)(input[10] & 0xf8) << 13);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 85 to 100
	value = ((uint32_t)(input[10] & 0x07) << 29) |
			((uint32_t)input[11] << 21) |
			((uint32_t)(input[12] & 0xf8) << 13);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 101 to 116
	value = ((uint32_t)(input[12] & 0x07) << 29) |
			((uint32_t)input[13] << 21) |
			((uint32_t)(input[14] & 0xf8) << 13);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 117 to 132
	value = ((uint32_t)(input[14] & 0x07) << 29) |
			((uint32_t)input[15] << 21) |
			((uint32_t)(input[16] & 0xf8) << 13);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 133 to 148
	value = ((uint32_t)(input[16] & 0x07) << 29) |
			((uint32_t)input[17] << 21) |
			((uint32_t)(input[18] & 0xf8) << 13);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 149 to 164
	value = ((uint32_t)(input[18] & 0x07) << 29) |
			((uint32_t)input[19] << 21) |
			((uint32_t)(input[20] & 0xf8) << 13);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 165 to 180
	value = ((uint32_t)(input[20] & 0x07) << 29) |
			((uint32_t)input[21] << 21) |
			((uint32_t)(input[22] & 0xf8) << 13);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 181 to 196
	value = ((uint32_t)(input[22] & 0x07) << 29) |
			((uint32_t)input[23] << 21) |
			((uint32_t)(input[24] & 0xf8) << 13);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 197 to 212
	value = ((uint32_t)(input[24] & 0x07) << 29) |
			((uint32_t)input[25] << 21) |
			((uint32_t)(input[26] & 0xf8) << 13);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 213 to 228
	value = ((uint32_t)(input[26] & 0x07) << 29) |
			((uint32_t)input[27] << 21) |
			((uint32_t)(input[28] & 0xf8) << 13);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 229 to 244
	value = ((uint32_t)(input[28] & 0x07) << 29) |
			((uint32_t)input[29] << 21) |
			((uint32_t)(input[30] & 0xf8) << 13);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 245 to 260
	value = ((uint32_t)(input[30] & 0x07) << 29) |
			((uint32_t)input[31] << 21) |
			((uint32_t)(input[32] & 0xf8) << 13);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 261 to 276
	value = ((uint32_t)(input[32] & 0x07) << 29) |
			((uint32_t)input[33] << 21) |
			((uint32_t)(input[34] & 0xf8) << 13);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 277 to 292
	value = ((uint32_t)(input[34] & 0x07) << 29) |
			((uint32_t)input[35] << 21) |
			((uint32_t)(input[36] & 0xf8) << 13);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 293 to 308
	value = ((uint32_t)(input[36] & 0x07) << 29) |
			((uint32_t)input[37] << 21) |
			((uint32_t)(input[38] & 0xf8) << 13);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 309 to 324
	value = ((uint32_t)(input[38] & 0x07) << 29) |
			((uint32_t)input[39] << 21) |
			((uint32_t)(input[40] & 0xf8) << 13);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 325 to 340
	value = ((uint32_t)(input[40] & 0x07) << 29) |
			((uint32_t)input[41] << 21) |
			((uint32_t)(input[42] & 0xf8) << 13);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 341 to 356
	value = ((uint32_t)(input[42] & 0x07) << 29) |
			((uint32_t)input[43] << 21) |
			((uint32_t)(input[44] & 0xf8) << 13);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 357 to 372
	value = ((uint32_t)(input[44] & 0x07) << 29) |
			((uint32_t)input[45] << 21) |
			((uint32_t)(input[46] & 0xf8) << 13);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 373 to 388
	value = ((uint32_t)(input[46] & 0x07) << 29) |
			((uint32_t)input[47] << 21) |
			((uint32_t)(input[48] & 0xf8) << 13);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 389 to 404
	value = ((uint32_t)(input[48] & 0x07) << 29) |
			((uint32_t)input[49] << 21) |
			((uint32_t)(input[50] & 0xf8) << 13);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 405 to 420
	value = ((uint32_t)(input[50] & 0x07) << 29) |
			((uint32_t)input[51] << 21) |
			((uint32_t)(input[52] & 0xf8) << 13);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 421 to 436
	value = ((uint32_t)(input[52] & 0x07) << 29) |
			((uint32_t)input[53] << 21) |
			((uint32_t)(input[54] & 0xf8) << 13);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 437 to 452
	value = ((uint32_t)(input[54] & 0x07) << 29) |
			((uint32_t)input[55] << 21) |
			((uint32_t)(input[56] & 0xf8) << 13);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 453 to 468
	value = ((uint32_t)(input[56] & 0x07) << 29) |
			((uint32_t)input[57] << 21) |
			((uint32_t)(input[58] & 0xf8) << 13);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 469 to 484
	value = ((uint32_t)(input[58] & 0x07) << 29) |
			((uint32_t)input[59] << 21) |
			((uint32_t)(input[60] & 0xf8) << 13);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 485 to 500
	value = ((uint32_t)(input[60] & 0x07) << 29) |
			((uint32_t)input[61] << 21) |
			((uint32_t)(input[62] & 0xf8) << 13);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 501 to 516
	value = ((uint32_t)(input[62] & 0x07) << 29) |
			((uint32_t)input[63] << 21) |
			((uint32_t)(input[64] & 0xf8) << 13);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 517 to 532
	value = ((uint32_t)(input[64] & 0x07) << 29) |
			((uint32_t)input[65] << 21) |
			((uint32_t)(input[66] & 0xf8) << 13);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 533 to 548
	value = ((uint32_t)(input[66] & 0x07) << 29) |
			((uint32_t)input[67] << 21) |
			((uint32_t)(input[68] & 0xf8) << 13);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 549 to 564
	value = ((uint32_t)(input[68] & 0x07) << 29) |
			((uint32_t)input[69] << 21) |
			((uint32_t)(input[70] & 0xf8) << 13);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 565 to 580
	value = ((uint32_t)(input[70] & 0x07) << 29) |
			((uint32_t)input[71] << 21) |
			((uint32_t)(input[72] & 0xf8) << 13);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 581 to 596
	value = ((uint32_t)(input[72] & 0x07) << 29) |
			((uint32_t)input[73] << 21) |
			((uint32_t)(input[74] & 0xf8) << 13);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 597 to 612
	value = ((uint32_t)(input[74] & 0x07) << 29) |
			((uint32_t)input[75] << 21) |
			((uint32_t)(input[76] & 0xf8) << 13);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 613 to 628
	value = ((uint32_t)(input[76] & 0x07) << 29) |
			((uint32_t)input[77] << 21) |
			((uint32_t)(input[78] & 0xf8) << 13);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 629 to 644
	value = ((uint32_t)(input[78] & 0x07) << 29) |
			((uint32_t)input[79] << 21) |
			((uint32_t)(input[80] & 0xf8) << 13);
	output[39] = (double)(value >> 16);

	// read output[40]: from bit 645 to 660
	value = ((uint32_t)(input[80] & 0x07) << 29) |
			((uint32_t)input[81] << 21) |
			((uint32_t)(input[82] & 0xf8) << 13);
	output[40] = (double)(value >> 16);

	// read output[41]: from bit 661 to 676
	value = ((uint32_t)(input[82] & 0x07) << 29) |
			((uint32_t)input[83] << 21) |
			((uint32_t)(input[84] & 0xf8) << 13);
	output[41] = (double)(value >> 16);

	// read output[42]: from bit 677 to 692
	value = ((uint32_t)(input[84] & 0x07) << 29) |
			((uint32_t)input[85] << 21) |
			((uint32_t)(input[86] & 0xf8) << 13);
	output[42] = (double)(value >> 16);

	// read output[43]: from bit 693 to 708
	value = ((uint32_t)(input[86] & 0x07) << 29) |
			((uint32_t)input[87] << 21) |
			((uint32_t)(input[88] & 0xf8) << 13);
	output[43] = (double)(value >> 16);
}

static void unpack_44_16bit_signed_6off(const uint8_t * input, double * output, void *closure) {
	// Unpack 44 values into output
	// Values are 16-bit signed
	// Skip 6 bits, read 704 bits of data.
	// Input must be at least 89 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 6 to 21
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)(input[2] & 0xfc) << 14);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 22 to 37
	value = ((uint32_t)(input[2] & 0x03) << 30) |
			((uint32_t)input[3] << 22) |
			((uint32_t)(input[4] & 0xfc) << 14);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 38 to 53
	value = ((uint32_t)(input[4] & 0x03) << 30) |
			((uint32_t)input[5] << 22) |
			((uint32_t)(input[6] & 0xfc) << 14);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 54 to 69
	value = ((uint32_t)(input[6] & 0x03) << 30) |
			((uint32_t)input[7] << 22) |
			((uint32_t)(input[8] & 0xfc) << 14);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 70 to 85
	value = ((uint32_t)(input[8] & 0x03) << 30) |
			((uint32_t)input[9] << 22) |
			((uint32_t)(input[10] & 0xfc) << 14);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 86 to 101
	value = ((uint32_t)(input[10] & 0x03) << 30) |
			((uint32_t)input[11] << 22) |
			((uint32_t)(input[12] & 0xfc) << 14);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 102 to 117
	value = ((uint32_t)(input[12] & 0x03) << 30) |
			((uint32_t)input[13] << 22) |
			((uint32_t)(input[14] & 0xfc) << 14);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 118 to 133
	value = ((uint32_t)(input[14] & 0x03) << 30) |
			((uint32_t)input[15] << 22) |
			((uint32_t)(input[16] & 0xfc) << 14);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 134 to 149
	value = ((uint32_t)(input[16] & 0x03) << 30) |
			((uint32_t)input[17] << 22) |
			((uint32_t)(input[18] & 0xfc) << 14);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 150 to 165
	value = ((uint32_t)(input[18] & 0x03) << 30) |
			((uint32_t)input[19] << 22) |
			((uint32_t)(input[20] & 0xfc) << 14);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 166 to 181
	value = ((uint32_t)(input[20] & 0x03) << 30) |
			((uint32_t)input[21] << 22) |
			((uint32_t)(input[22] & 0xfc) << 14);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 182 to 197
	value = ((uint32_t)(input[22] & 0x03) << 30) |
			((uint32_t)input[23] << 22) |
			((uint32_t)(input[24] & 0xfc) << 14);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 198 to 213
	value = ((uint32_t)(input[24] & 0x03) << 30) |
			((uint32_t)input[25] << 22) |
			((uint32_t)(input[26] & 0xfc) << 14);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 214 to 229
	value = ((uint32_t)(input[26] & 0x03) << 30) |
			((uint32_t)input[27] << 22) |
			((uint32_t)(input[28] & 0xfc) << 14);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 230 to 245
	value = ((uint32_t)(input[28] & 0x03) << 30) |
			((uint32_t)input[29] << 22) |
			((uint32_t)(input[30] & 0xfc) << 14);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 246 to 261
	value = ((uint32_t)(input[30] & 0x03) << 30) |
			((uint32_t)input[31] << 22) |
			((uint32_t)(input[32] & 0xfc) << 14);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 262 to 277
	value = ((uint32_t)(input[32] & 0x03) << 30) |
			((uint32_t)input[33] << 22) |
			((uint32_t)(input[34] & 0xfc) << 14);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 278 to 293
	value = ((uint32_t)(input[34] & 0x03) << 30) |
			((uint32_t)input[35] << 22) |
			((uint32_t)(input[36] & 0xfc) << 14);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 294 to 309
	value = ((uint32_t)(input[36] & 0x03) << 30) |
			((uint32_t)input[37] << 22) |
			((uint32_t)(input[38] & 0xfc) << 14);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 310 to 325
	value = ((uint32_t)(input[38] & 0x03) << 30) |
			((uint32_t)input[39] << 22) |
			((uint32_t)(input[40] & 0xfc) << 14);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 326 to 341
	value = ((uint32_t)(input[40] & 0x03) << 30) |
			((uint32_t)input[41] << 22) |
			((uint32_t)(input[42] & 0xfc) << 14);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 342 to 357
	value = ((uint32_t)(input[42] & 0x03) << 30) |
			((uint32_t)input[43] << 22) |
			((uint32_t)(input[44] & 0xfc) << 14);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 358 to 373
	value = ((uint32_t)(input[44] & 0x03) << 30) |
			((uint32_t)input[45] << 22) |
			((uint32_t)(input[46] & 0xfc) << 14);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 374 to 389
	value = ((uint32_t)(input[46] & 0x03) << 30) |
			((uint32_t)input[47] << 22) |
			((uint32_t)(input[48] & 0xfc) << 14);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 390 to 405
	value = ((uint32_t)(input[48] & 0x03) << 30) |
			((uint32_t)input[49] << 22) |
			((uint32_t)(input[50] & 0xfc) << 14);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 406 to 421
	value = ((uint32_t)(input[50] & 0x03) << 30) |
			((uint32_t)input[51] << 22) |
			((uint32_t)(input[52] & 0xfc) << 14);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 422 to 437
	value = ((uint32_t)(input[52] & 0x03) << 30) |
			((uint32_t)input[53] << 22) |
			((uint32_t)(input[54] & 0xfc) << 14);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 438 to 453
	value = ((uint32_t)(input[54] & 0x03) << 30) |
			((uint32_t)input[55] << 22) |
			((uint32_t)(input[56] & 0xfc) << 14);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 454 to 469
	value = ((uint32_t)(input[56] & 0x03) << 30) |
			((uint32_t)input[57] << 22) |
			((uint32_t)(input[58] & 0xfc) << 14);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 470 to 485
	value = ((uint32_t)(input[58] & 0x03) << 30) |
			((uint32_t)input[59] << 22) |
			((uint32_t)(input[60] & 0xfc) << 14);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 486 to 501
	value = ((uint32_t)(input[60] & 0x03) << 30) |
			((uint32_t)input[61] << 22) |
			((uint32_t)(input[62] & 0xfc) << 14);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 502 to 517
	value = ((uint32_t)(input[62] & 0x03) << 30) |
			((uint32_t)input[63] << 22) |
			((uint32_t)(input[64] & 0xfc) << 14);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 518 to 533
	value = ((uint32_t)(input[64] & 0x03) << 30) |
			((uint32_t)input[65] << 22) |
			((uint32_t)(input[66] & 0xfc) << 14);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 534 to 549
	value = ((uint32_t)(input[66] & 0x03) << 30) |
			((uint32_t)input[67] << 22) |
			((uint32_t)(input[68] & 0xfc) << 14);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 550 to 565
	value = ((uint32_t)(input[68] & 0x03) << 30) |
			((uint32_t)input[69] << 22) |
			((uint32_t)(input[70] & 0xfc) << 14);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 566 to 581
	value = ((uint32_t)(input[70] & 0x03) << 30) |
			((uint32_t)input[71] << 22) |
			((uint32_t)(input[72] & 0xfc) << 14);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 582 to 597
	value = ((uint32_t)(input[72] & 0x03) << 30) |
			((uint32_t)input[73] << 22) |
			((uint32_t)(input[74] & 0xfc) << 14);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 598 to 613
	value = ((uint32_t)(input[74] & 0x03) << 30) |
			((uint32_t)input[75] << 22) |
			((uint32_t)(input[76] & 0xfc) << 14);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 614 to 629
	value = ((uint32_t)(input[76] & 0x03) << 30) |
			((uint32_t)input[77] << 22) |
			((uint32_t)(input[78] & 0xfc) << 14);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 630 to 645
	value = ((uint32_t)(input[78] & 0x03) << 30) |
			((uint32_t)input[79] << 22) |
			((uint32_t)(input[80] & 0xfc) << 14);
	output[39] = (double)(value >> 16);

	// read output[40]: from bit 646 to 661
	value = ((uint32_t)(input[80] & 0x03) << 30) |
			((uint32_t)input[81] << 22) |
			((uint32_t)(input[82] & 0xfc) << 14);
	output[40] = (double)(value >> 16);

	// read output[41]: from bit 662 to 677
	value = ((uint32_t)(input[82] & 0x03) << 30) |
			((uint32_t)input[83] << 22) |
			((uint32_t)(input[84] & 0xfc) << 14);
	output[41] = (double)(value >> 16);

	// read output[42]: from bit 678 to 693
	value = ((uint32_t)(input[84] & 0x03) << 30) |
			((uint32_t)input[85] << 22) |
			((uint32_t)(input[86] & 0xfc) << 14);
	output[42] = (double)(value >> 16);

	// read output[43]: from bit 694 to 709
	value = ((uint32_t)(input[86] & 0x03) << 30) |
			((uint32_t)input[87] << 22) |
			((uint32_t)(input[88] & 0xfc) << 14);
	output[43] = (double)(value >> 16);
}

static void unpack_44_16bit_unsigned_6off(const uint8_t * input, double * output, void *closure) {
	// Unpack 44 values into output
	// Values are 16-bit unsigned
	// Skip 6 bits, read 704 bits of data.
	// Input must be at least 89 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 6 to 21
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)(input[2] & 0xfc) << 14);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 22 to 37
	value = ((uint32_t)(input[2] & 0x03) << 30) |
			((uint32_t)input[3] << 22) |
			((uint32_t)(input[4] & 0xfc) << 14);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 38 to 53
	value = ((uint32_t)(input[4] & 0x03) << 30) |
			((uint32_t)input[5] << 22) |
			((uint32_t)(input[6] & 0xfc) << 14);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 54 to 69
	value = ((uint32_t)(input[6] & 0x03) << 30) |
			((uint32_t)input[7] << 22) |
			((uint32_t)(input[8] & 0xfc) << 14);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 70 to 85
	value = ((uint32_t)(input[8] & 0x03) << 30) |
			((uint32_t)input[9] << 22) |
			((uint32_t)(input[10] & 0xfc) << 14);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 86 to 101
	value = ((uint32_t)(input[10] & 0x03) << 30) |
			((uint32_t)input[11] << 22) |
			((uint32_t)(input[12] & 0xfc) << 14);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 102 to 117
	value = ((uint32_t)(input[12] & 0x03) << 30) |
			((uint32_t)input[13] << 22) |
			((uint32_t)(input[14] & 0xfc) << 14);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 118 to 133
	value = ((uint32_t)(input[14] & 0x03) << 30) |
			((uint32_t)input[15] << 22) |
			((uint32_t)(input[16] & 0xfc) << 14);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 134 to 149
	value = ((uint32_t)(input[16] & 0x03) << 30) |
			((uint32_t)input[17] << 22) |
			((uint32_t)(input[18] & 0xfc) << 14);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 150 to 165
	value = ((uint32_t)(input[18] & 0x03) << 30) |
			((uint32_t)input[19] << 22) |
			((uint32_t)(input[20] & 0xfc) << 14);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 166 to 181
	value = ((uint32_t)(input[20] & 0x03) << 30) |
			((uint32_t)input[21] << 22) |
			((uint32_t)(input[22] & 0xfc) << 14);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 182 to 197
	value = ((uint32_t)(input[22] & 0x03) << 30) |
			((uint32_t)input[23] << 22) |
			((uint32_t)(input[24] & 0xfc) << 14);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 198 to 213
	value = ((uint32_t)(input[24] & 0x03) << 30) |
			((uint32_t)input[25] << 22) |
			((uint32_t)(input[26] & 0xfc) << 14);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 214 to 229
	value = ((uint32_t)(input[26] & 0x03) << 30) |
			((uint32_t)input[27] << 22) |
			((uint32_t)(input[28] & 0xfc) << 14);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 230 to 245
	value = ((uint32_t)(input[28] & 0x03) << 30) |
			((uint32_t)input[29] << 22) |
			((uint32_t)(input[30] & 0xfc) << 14);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 246 to 261
	value = ((uint32_t)(input[30] & 0x03) << 30) |
			((uint32_t)input[31] << 22) |
			((uint32_t)(input[32] & 0xfc) << 14);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 262 to 277
	value = ((uint32_t)(input[32] & 0x03) << 30) |
			((uint32_t)input[33] << 22) |
			((uint32_t)(input[34] & 0xfc) << 14);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 278 to 293
	value = ((uint32_t)(input[34] & 0x03) << 30) |
			((uint32_t)input[35] << 22) |
			((uint32_t)(input[36] & 0xfc) << 14);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 294 to 309
	value = ((uint32_t)(input[36] & 0x03) << 30) |
			((uint32_t)input[37] << 22) |
			((uint32_t)(input[38] & 0xfc) << 14);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 310 to 325
	value = ((uint32_t)(input[38] & 0x03) << 30) |
			((uint32_t)input[39] << 22) |
			((uint32_t)(input[40] & 0xfc) << 14);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 326 to 341
	value = ((uint32_t)(input[40] & 0x03) << 30) |
			((uint32_t)input[41] << 22) |
			((uint32_t)(input[42] & 0xfc) << 14);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 342 to 357
	value = ((uint32_t)(input[42] & 0x03) << 30) |
			((uint32_t)input[43] << 22) |
			((uint32_t)(input[44] & 0xfc) << 14);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 358 to 373
	value = ((uint32_t)(input[44] & 0x03) << 30) |
			((uint32_t)input[45] << 22) |
			((uint32_t)(input[46] & 0xfc) << 14);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 374 to 389
	value = ((uint32_t)(input[46] & 0x03) << 30) |
			((uint32_t)input[47] << 22) |
			((uint32_t)(input[48] & 0xfc) << 14);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 390 to 405
	value = ((uint32_t)(input[48] & 0x03) << 30) |
			((uint32_t)input[49] << 22) |
			((uint32_t)(input[50] & 0xfc) << 14);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 406 to 421
	value = ((uint32_t)(input[50] & 0x03) << 30) |
			((uint32_t)input[51] << 22) |
			((uint32_t)(input[52] & 0xfc) << 14);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 422 to 437
	value = ((uint32_t)(input[52] & 0x03) << 30) |
			((uint32_t)input[53] << 22) |
			((uint32_t)(input[54] & 0xfc) << 14);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 438 to 453
	value = ((uint32_t)(input[54] & 0x03) << 30) |
			((uint32_t)input[55] << 22) |
			((uint32_t)(input[56] & 0xfc) << 14);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 454 to 469
	value = ((uint32_t)(input[56] & 0x03) << 30) |
			((uint32_t)input[57] << 22) |
			((uint32_t)(input[58] & 0xfc) << 14);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 470 to 485
	value = ((uint32_t)(input[58] & 0x03) << 30) |
			((uint32_t)input[59] << 22) |
			((uint32_t)(input[60] & 0xfc) << 14);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 486 to 501
	value = ((uint32_t)(input[60] & 0x03) << 30) |
			((uint32_t)input[61] << 22) |
			((uint32_t)(input[62] & 0xfc) << 14);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 502 to 517
	value = ((uint32_t)(input[62] & 0x03) << 30) |
			((uint32_t)input[63] << 22) |
			((uint32_t)(input[64] & 0xfc) << 14);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 518 to 533
	value = ((uint32_t)(input[64] & 0x03) << 30) |
			((uint32_t)input[65] << 22) |
			((uint32_t)(input[66] & 0xfc) << 14);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 534 to 549
	value = ((uint32_t)(input[66] & 0x03) << 30) |
			((uint32_t)input[67] << 22) |
			((uint32_t)(input[68] & 0xfc) << 14);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 550 to 565
	value = ((uint32_t)(input[68] & 0x03) << 30) |
			((uint32_t)input[69] << 22) |
			((uint32_t)(input[70] & 0xfc) << 14);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 566 to 581
	value = ((uint32_t)(input[70] & 0x03) << 30) |
			((uint32_t)input[71] << 22) |
			((uint32_t)(input[72] & 0xfc) << 14);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 582 to 597
	value = ((uint32_t)(input[72] & 0x03) << 30) |
			((uint32_t)input[73] << 22) |
			((uint32_t)(input[74] & 0xfc) << 14);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 598 to 613
	value = ((uint32_t)(input[74] & 0x03) << 30) |
			((uint32_t)input[75] << 22) |
			((uint32_t)(input[76] & 0xfc) << 14);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 614 to 629
	value = ((uint32_t)(input[76] & 0x03) << 30) |
			((uint32_t)input[77] << 22) |
			((uint32_t)(input[78] & 0xfc) << 14);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 630 to 645
	value = ((uint32_t)(input[78] & 0x03) << 30) |
			((uint32_t)input[79] << 22) |
			((uint32_t)(input[80] & 0xfc) << 14);
	output[39] = (double)(value >> 16);

	// read output[40]: from bit 646 to 661
	value = ((uint32_t)(input[80] & 0x03) << 30) |
			((uint32_t)input[81] << 22) |
			((uint32_t)(input[82] & 0xfc) << 14);
	output[40] = (double)(value >> 16);

	// read output[41]: from bit 662 to 677
	value = ((uint32_t)(input[82] & 0x03) << 30) |
			((uint32_t)input[83] << 22) |
			((uint32_t)(input[84] & 0xfc) << 14);
	output[41] = (double)(value >> 16);

	// read output[42]: from bit 678 to 693
	value = ((uint32_t)(input[84] & 0x03) << 30) |
			((uint32_t)input[85] << 22) |
			((uint32_t)(input[86] & 0xfc) << 14);
	output[42] = (double)(value >> 16);

	// read output[43]: from bit 694 to 709
	value = ((uint32_t)(input[86] & 0x03) << 30) |
			((uint32_t)input[87] << 22) |
			((uint32_t)(input[88] & 0xfc) << 14);
	output[43] = (double)(value >> 16);
}

static void unpack_44_16bit_signed_7off(const uint8_t * input, double * output, void *closure) {
	// Unpack 44 values into output
	// Values are 16-bit signed
	// Skip 7 bits, read 704 bits of data.
	// Input must be at least 89 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 7 to 22
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)(input[2] & 0xfe) << 15);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 23 to 38
	value = ((uint32_t)(input[2] & 0x01) << 31) |
			((uint32_t)input[3] << 23) |
			((uint32_t)(input[4] & 0xfe) << 15);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 39 to 54
	value = ((uint32_t)(input[4] & 0x01) << 31) |
			((uint32_t)input[5] << 23) |
			((uint32_t)(input[6] & 0xfe) << 15);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 55 to 70
	value = ((uint32_t)(input[6] & 0x01) << 31) |
			((uint32_t)input[7] << 23) |
			((uint32_t)(input[8] & 0xfe) << 15);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 71 to 86
	value = ((uint32_t)(input[8] & 0x01) << 31) |
			((uint32_t)input[9] << 23) |
			((uint32_t)(input[10] & 0xfe) << 15);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 87 to 102
	value = ((uint32_t)(input[10] & 0x01) << 31) |
			((uint32_t)input[11] << 23) |
			((uint32_t)(input[12] & 0xfe) << 15);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 103 to 118
	value = ((uint32_t)(input[12] & 0x01) << 31) |
			((uint32_t)input[13] << 23) |
			((uint32_t)(input[14] & 0xfe) << 15);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 119 to 134
	value = ((uint32_t)(input[14] & 0x01) << 31) |
			((uint32_t)input[15] << 23) |
			((uint32_t)(input[16] & 0xfe) << 15);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 135 to 150
	value = ((uint32_t)(input[16] & 0x01) << 31) |
			((uint32_t)input[17] << 23) |
			((uint32_t)(input[18] & 0xfe) << 15);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 151 to 166
	value = ((uint32_t)(input[18] & 0x01) << 31) |
			((uint32_t)input[19] << 23) |
			((uint32_t)(input[20] & 0xfe) << 15);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 167 to 182
	value = ((uint32_t)(input[20] & 0x01) << 31) |
			((uint32_t)input[21] << 23) |
			((uint32_t)(input[22] & 0xfe) << 15);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 183 to 198
	value = ((uint32_t)(input[22] & 0x01) << 31) |
			((uint32_t)input[23] << 23) |
			((uint32_t)(input[24] & 0xfe) << 15);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 199 to 214
	value = ((uint32_t)(input[24] & 0x01) << 31) |
			((uint32_t)input[25] << 23) |
			((uint32_t)(input[26] & 0xfe) << 15);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 215 to 230
	value = ((uint32_t)(input[26] & 0x01) << 31) |
			((uint32_t)input[27] << 23) |
			((uint32_t)(input[28] & 0xfe) << 15);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 231 to 246
	value = ((uint32_t)(input[28] & 0x01) << 31) |
			((uint32_t)input[29] << 23) |
			((uint32_t)(input[30] & 0xfe) << 15);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 247 to 262
	value = ((uint32_t)(input[30] & 0x01) << 31) |
			((uint32_t)input[31] << 23) |
			((uint32_t)(input[32] & 0xfe) << 15);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 263 to 278
	value = ((uint32_t)(input[32] & 0x01) << 31) |
			((uint32_t)input[33] << 23) |
			((uint32_t)(input[34] & 0xfe) << 15);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 279 to 294
	value = ((uint32_t)(input[34] & 0x01) << 31) |
			((uint32_t)input[35] << 23) |
			((uint32_t)(input[36] & 0xfe) << 15);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 295 to 310
	value = ((uint32_t)(input[36] & 0x01) << 31) |
			((uint32_t)input[37] << 23) |
			((uint32_t)(input[38] & 0xfe) << 15);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 311 to 326
	value = ((uint32_t)(input[38] & 0x01) << 31) |
			((uint32_t)input[39] << 23) |
			((uint32_t)(input[40] & 0xfe) << 15);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 327 to 342
	value = ((uint32_t)(input[40] & 0x01) << 31) |
			((uint32_t)input[41] << 23) |
			((uint32_t)(input[42] & 0xfe) << 15);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 343 to 358
	value = ((uint32_t)(input[42] & 0x01) << 31) |
			((uint32_t)input[43] << 23) |
			((uint32_t)(input[44] & 0xfe) << 15);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 359 to 374
	value = ((uint32_t)(input[44] & 0x01) << 31) |
			((uint32_t)input[45] << 23) |
			((uint32_t)(input[46] & 0xfe) << 15);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 375 to 390
	value = ((uint32_t)(input[46] & 0x01) << 31) |
			((uint32_t)input[47] << 23) |
			((uint32_t)(input[48] & 0xfe) << 15);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 391 to 406
	value = ((uint32_t)(input[48] & 0x01) << 31) |
			((uint32_t)input[49] << 23) |
			((uint32_t)(input[50] & 0xfe) << 15);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 407 to 422
	value = ((uint32_t)(input[50] & 0x01) << 31) |
			((uint32_t)input[51] << 23) |
			((uint32_t)(input[52] & 0xfe) << 15);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 423 to 438
	value = ((uint32_t)(input[52] & 0x01) << 31) |
			((uint32_t)input[53] << 23) |
			((uint32_t)(input[54] & 0xfe) << 15);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 439 to 454
	value = ((uint32_t)(input[54] & 0x01) << 31) |
			((uint32_t)input[55] << 23) |
			((uint32_t)(input[56] & 0xfe) << 15);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 455 to 470
	value = ((uint32_t)(input[56] & 0x01) << 31) |
			((uint32_t)input[57] << 23) |
			((uint32_t)(input[58] & 0xfe) << 15);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 471 to 486
	value = ((uint32_t)(input[58] & 0x01) << 31) |
			((uint32_t)input[59] << 23) |
			((uint32_t)(input[60] & 0xfe) << 15);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 487 to 502
	value = ((uint32_t)(input[60] & 0x01) << 31) |
			((uint32_t)input[61] << 23) |
			((uint32_t)(input[62] & 0xfe) << 15);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 503 to 518
	value = ((uint32_t)(input[62] & 0x01) << 31) |
			((uint32_t)input[63] << 23) |
			((uint32_t)(input[64] & 0xfe) << 15);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 519 to 534
	value = ((uint32_t)(input[64] & 0x01) << 31) |
			((uint32_t)input[65] << 23) |
			((uint32_t)(input[66] & 0xfe) << 15);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 535 to 550
	value = ((uint32_t)(input[66] & 0x01) << 31) |
			((uint32_t)input[67] << 23) |
			((uint32_t)(input[68] & 0xfe) << 15);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 551 to 566
	value = ((uint32_t)(input[68] & 0x01) << 31) |
			((uint32_t)input[69] << 23) |
			((uint32_t)(input[70] & 0xfe) << 15);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 567 to 582
	value = ((uint32_t)(input[70] & 0x01) << 31) |
			((uint32_t)input[71] << 23) |
			((uint32_t)(input[72] & 0xfe) << 15);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 583 to 598
	value = ((uint32_t)(input[72] & 0x01) << 31) |
			((uint32_t)input[73] << 23) |
			((uint32_t)(input[74] & 0xfe) << 15);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 599 to 614
	value = ((uint32_t)(input[74] & 0x01) << 31) |
			((uint32_t)input[75] << 23) |
			((uint32_t)(input[76] & 0xfe) << 15);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 615 to 630
	value = ((uint32_t)(input[76] & 0x01) << 31) |
			((uint32_t)input[77] << 23) |
			((uint32_t)(input[78] & 0xfe) << 15);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 631 to 646
	value = ((uint32_t)(input[78] & 0x01) << 31) |
			((uint32_t)input[79] << 23) |
			((uint32_t)(input[80] & 0xfe) << 15);
	output[39] = (double)(value >> 16);

	// read output[40]: from bit 647 to 662
	value = ((uint32_t)(input[80] & 0x01) << 31) |
			((uint32_t)input[81] << 23) |
			((uint32_t)(input[82] & 0xfe) << 15);
	output[40] = (double)(value >> 16);

	// read output[41]: from bit 663 to 678
	value = ((uint32_t)(input[82] & 0x01) << 31) |
			((uint32_t)input[83] << 23) |
			((uint32_t)(input[84] & 0xfe) << 15);
	output[41] = (double)(value >> 16);

	// read output[42]: from bit 679 to 694
	value = ((uint32_t)(input[84] & 0x01) << 31) |
			((uint32_t)input[85] << 23) |
			((uint32_t)(input[86] & 0xfe) << 15);
	output[42] = (double)(value >> 16);

	// read output[43]: from bit 695 to 710
	value = ((uint32_t)(input[86] & 0x01) << 31) |
			((uint32_t)input[87] << 23) |
			((uint32_t)(input[88] & 0xfe) << 15);
	output[43] = (double)(value >> 16);
}

static void unpack_44_16bit_unsigned_7off(const uint8_t * input, double * output, void *closure) {
	// Unpack 44 values into output
	// Values are 16-bit unsigned
	// Skip 7 bits, read 704 bits of data.
	// Input must be at least 89 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 7 to 22
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)(input[2] & 0xfe) << 15);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 23 to 38
	value = ((uint32_t)(input[2] & 0x01) << 31) |
			((uint32_t)input[3] << 23) |
			((uint32_t)(input[4] & 0xfe) << 15);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 39 to 54
	value = ((uint32_t)(input[4] & 0x01) << 31) |
			((uint32_t)input[5] << 23) |
			((uint32_t)(input[6] & 0xfe) << 15);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 55 to 70
	value = ((uint32_t)(input[6] & 0x01) << 31) |
			((uint32_t)input[7] << 23) |
			((uint32_t)(input[8] & 0xfe) << 15);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 71 to 86
	value = ((uint32_t)(input[8] & 0x01) << 31) |
			((uint32_t)input[9] << 23) |
			((uint32_t)(input[10] & 0xfe) << 15);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 87 to 102
	value = ((uint32_t)(input[10] & 0x01) << 31) |
			((uint32_t)input[11] << 23) |
			((uint32_t)(input[12] & 0xfe) << 15);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 103 to 118
	value = ((uint32_t)(input[12] & 0x01) << 31) |
			((uint32_t)input[13] << 23) |
			((uint32_t)(input[14] & 0xfe) << 15);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 119 to 134
	value = ((uint32_t)(input[14] & 0x01) << 31) |
			((uint32_t)input[15] << 23) |
			((uint32_t)(input[16] & 0xfe) << 15);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 135 to 150
	value = ((uint32_t)(input[16] & 0x01) << 31) |
			((uint32_t)input[17] << 23) |
			((uint32_t)(input[18] & 0xfe) << 15);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 151 to 166
	value = ((uint32_t)(input[18] & 0x01) << 31) |
			((uint32_t)input[19] << 23) |
			((uint32_t)(input[20] & 0xfe) << 15);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 167 to 182
	value = ((uint32_t)(input[20] & 0x01) << 31) |
			((uint32_t)input[21] << 23) |
			((uint32_t)(input[22] & 0xfe) << 15);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 183 to 198
	value = ((uint32_t)(input[22] & 0x01) << 31) |
			((uint32_t)input[23] << 23) |
			((uint32_t)(input[24] & 0xfe) << 15);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 199 to 214
	value = ((uint32_t)(input[24] & 0x01) << 31) |
			((uint32_t)input[25] << 23) |
			((uint32_t)(input[26] & 0xfe) << 15);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 215 to 230
	value = ((uint32_t)(input[26] & 0x01) << 31) |
			((uint32_t)input[27] << 23) |
			((uint32_t)(input[28] & 0xfe) << 15);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 231 to 246
	value = ((uint32_t)(input[28] & 0x01) << 31) |
			((uint32_t)input[29] << 23) |
			((uint32_t)(input[30] & 0xfe) << 15);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 247 to 262
	value = ((uint32_t)(input[30] & 0x01) << 31) |
			((uint32_t)input[31] << 23) |
			((uint32_t)(input[32] & 0xfe) << 15);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 263 to 278
	value = ((uint32_t)(input[32] & 0x01) << 31) |
			((uint32_t)input[33] << 23) |
			((uint32_t)(input[34] & 0xfe) << 15);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 279 to 294
	value = ((uint32_t)(input[34] & 0x01) << 31) |
			((uint32_t)input[35] << 23) |
			((uint32_t)(input[36] & 0xfe) << 15);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 295 to 310
	value = ((uint32_t)(input[36] & 0x01) << 31) |
			((uint32_t)input[37] << 23) |
			((uint32_t)(input[38] & 0xfe) << 15);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 311 to 326
	value = ((uint32_t)(input[38] & 0x01) << 31) |
			((uint32_t)input[39] << 23) |
			((uint32_t)(input[40] & 0xfe) << 15);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 327 to 342
	value = ((uint32_t)(input[40] & 0x01) << 31) |
			((uint32_t)input[41] << 23) |
			((uint32_t)(input[42] & 0xfe) << 15);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 343 to 358
	value = ((uint32_t)(input[42] & 0x01) << 31) |
			((uint32_t)input[43] << 23) |
			((uint32_t)(input[44] & 0xfe) << 15);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 359 to 374
	value = ((uint32_t)(input[44] & 0x01) << 31) |
			((uint32_t)input[45] << 23) |
			((uint32_t)(input[46] & 0xfe) << 15);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 375 to 390
	value = ((uint32_t)(input[46] & 0x01) << 31) |
			((uint32_t)input[47] << 23) |
			((uint32_t)(input[48] & 0xfe) << 15);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 391 to 406
	value = ((uint32_t)(input[48] & 0x01) << 31) |
			((uint32_t)input[49] << 23) |
			((uint32_t)(input[50] & 0xfe) << 15);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 407 to 422
	value = ((uint32_t)(input[50] & 0x01) << 31) |
			((uint32_t)input[51] << 23) |
			((uint32_t)(input[52] & 0xfe) << 15);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 423 to 438
	value = ((uint32_t)(input[52] & 0x01) << 31) |
			((uint32_t)input[53] << 23) |
			((uint32_t)(input[54] & 0xfe) << 15);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 439 to 454
	value = ((uint32_t)(input[54] & 0x01) << 31) |
			((uint32_t)input[55] << 23) |
			((uint32_t)(input[56] & 0xfe) << 15);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 455 to 470
	value = ((uint32_t)(input[56] & 0x01) << 31) |
			((uint32_t)input[57] << 23) |
			((uint32_t)(input[58] & 0xfe) << 15);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 471 to 486
	value = ((uint32_t)(input[58] & 0x01) << 31) |
			((uint32_t)input[59] << 23) |
			((uint32_t)(input[60] & 0xfe) << 15);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 487 to 502
	value = ((uint32_t)(input[60] & 0x01) << 31) |
			((uint32_t)input[61] << 23) |
			((uint32_t)(input[62] & 0xfe) << 15);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 503 to 518
	value = ((uint32_t)(input[62] & 0x01) << 31) |
			((uint32_t)input[63] << 23) |
			((uint32_t)(input[64] & 0xfe) << 15);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 519 to 534
	value = ((uint32_t)(input[64] & 0x01) << 31) |
			((uint32_t)input[65] << 23) |
			((uint32_t)(input[66] & 0xfe) << 15);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 535 to 550
	value = ((uint32_t)(input[66] & 0x01) << 31) |
			((uint32_t)input[67] << 23) |
			((uint32_t)(input[68] & 0xfe) << 15);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 551 to 566
	value = ((uint32_t)(input[68] & 0x01) << 31) |
			((uint32_t)input[69] << 23) |
			((uint32_t)(input[70] & 0xfe) << 15);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 567 to 582
	value = ((uint32_t)(input[70] & 0x01) << 31) |
			((uint32_t)input[71] << 23) |
			((uint32_t)(input[72] & 0xfe) << 15);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 583 to 598
	value = ((uint32_t)(input[72] & 0x01) << 31) |
			((uint32_t)input[73] << 23) |
			((uint32_t)(input[74] & 0xfe) << 15);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 599 to 614
	value = ((uint32_t)(input[74] & 0x01) << 31) |
			((uint32_t)input[75] << 23) |
			((uint32_t)(input[76] & 0xfe) << 15);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 615 to 630
	value = ((uint32_t)(input[76] & 0x01) << 31) |
			((uint32_t)input[77] << 23) |
			((uint32_t)(input[78] & 0xfe) << 15);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 631 to 646
	value = ((uint32_t)(input[78] & 0x01) << 31) |
			((uint32_t)input[79] << 23) |
			((uint32_t)(input[80] & 0xfe) << 15);
	output[39] = (double)(value >> 16);

	// read output[40]: from bit 647 to 662
	value = ((uint32_t)(input[80] & 0x01) << 31) |
			((uint32_t)input[81] << 23) |
			((uint32_t)(input[82] & 0xfe) << 15);
	output[40] = (double)(value >> 16);

	// read output[41]: from bit 663 to 678
	value = ((uint32_t)(input[82] & 0x01) << 31) |
			((uint32_t)input[83] << 23) |
			((uint32_t)(input[84] & 0xfe) << 15);
	output[41] = (double)(value >> 16);

	// read output[42]: from bit 679 to 694
	value = ((uint32_t)(input[84] & 0x01) << 31) |
			((uint32_t)input[85] << 23) |
			((uint32_t)(input[86] & 0xfe) << 15);
	output[42] = (double)(value >> 16);

	// read output[43]: from bit 695 to 710
	value = ((uint32_t)(input[86] & 0x01) << 31) |
			((uint32_t)input[87] << 23) |
			((uint32_t)(input[88] & 0xfe) << 15);
	output[43] = (double)(value >> 16);
}

static void unpack_45_16bit_signed_0off(const uint8_t * input, double * output, void *closure) {
	// Unpack 45 values into output
	// Values are 16-bit signed
	// Skip 0 bits, read 720 bits of data.
	// Input must be at least 90 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 0 to 15
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)input[1] << 16);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 16 to 31
	value = ((uint32_t)input[2] << 24) |
			((uint32_t)input[3] << 16);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 32 to 47
	value = ((uint32_t)input[4] << 24) |
			((uint32_t)input[5] << 16);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 48 to 63
	value = ((uint32_t)input[6] << 24) |
			((uint32_t)input[7] << 16);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 64 to 79
	value = ((uint32_t)input[8] << 24) |
			((uint32_t)input[9] << 16);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 80 to 95
	value = ((uint32_t)input[10] << 24) |
			((uint32_t)input[11] << 16);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 96 to 111
	value = ((uint32_t)input[12] << 24) |
			((uint32_t)input[13] << 16);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 112 to 127
	value = ((uint32_t)input[14] << 24) |
			((uint32_t)input[15] << 16);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 128 to 143
	value = ((uint32_t)input[16] << 24) |
			((uint32_t)input[17] << 16);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 144 to 159
	value = ((uint32_t)input[18] << 24) |
			((uint32_t)input[19] << 16);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 160 to 175
	value = ((uint32_t)input[20] << 24) |
			((uint32_t)input[21] << 16);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 176 to 191
	value = ((uint32_t)input[22] << 24) |
			((uint32_t)input[23] << 16);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 192 to 207
	value = ((uint32_t)input[24] << 24) |
			((uint32_t)input[25] << 16);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 208 to 223
	value = ((uint32_t)input[26] << 24) |
			((uint32_t)input[27] << 16);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 224 to 239
	value = ((uint32_t)input[28] << 24) |
			((uint32_t)input[29] << 16);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 240 to 255
	value = ((uint32_t)input[30] << 24) |
			((uint32_t)input[31] << 16);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 256 to 271
	value = ((uint32_t)input[32] << 24) |
			((uint32_t)input[33] << 16);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 272 to 287
	value = ((uint32_t)input[34] << 24) |
			((uint32_t)input[35] << 16);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 288 to 303
	value = ((uint32_t)input[36] << 24) |
			((uint32_t)input[37] << 16);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 304 to 319
	value = ((uint32_t)input[38] << 24) |
			((uint32_t)input[39] << 16);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 320 to 335
	value = ((uint32_t)input[40] << 24) |
			((uint32_t)input[41] << 16);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 336 to 351
	value = ((uint32_t)input[42] << 24) |
			((uint32_t)input[43] << 16);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 352 to 367
	value = ((uint32_t)input[44] << 24) |
			((uint32_t)input[45] << 16);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 368 to 383
	value = ((uint32_t)input[46] << 24) |
			((uint32_t)input[47] << 16);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 384 to 399
	value = ((uint32_t)input[48] << 24) |
			((uint32_t)input[49] << 16);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 400 to 415
	value = ((uint32_t)input[50] << 24) |
			((uint32_t)input[51] << 16);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 416 to 431
	value = ((uint32_t)input[52] << 24) |
			((uint32_t)input[53] << 16);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 432 to 447
	value = ((uint32_t)input[54] << 24) |
			((uint32_t)input[55] << 16);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 448 to 463
	value = ((uint32_t)input[56] << 24) |
			((uint32_t)input[57] << 16);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 464 to 479
	value = ((uint32_t)input[58] << 24) |
			((uint32_t)input[59] << 16);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 480 to 495
	value = ((uint32_t)input[60] << 24) |
			((uint32_t)input[61] << 16);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 496 to 511
	value = ((uint32_t)input[62] << 24) |
			((uint32_t)input[63] << 16);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 512 to 527
	value = ((uint32_t)input[64] << 24) |
			((uint32_t)input[65] << 16);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 528 to 543
	value = ((uint32_t)input[66] << 24) |
			((uint32_t)input[67] << 16);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 544 to 559
	value = ((uint32_t)input[68] << 24) |
			((uint32_t)input[69] << 16);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 560 to 575
	value = ((uint32_t)input[70] << 24) |
			((uint32_t)input[71] << 16);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 576 to 591
	value = ((uint32_t)input[72] << 24) |
			((uint32_t)input[73] << 16);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 592 to 607
	value = ((uint32_t)input[74] << 24) |
			((uint32_t)input[75] << 16);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 608 to 623
	value = ((uint32_t)input[76] << 24) |
			((uint32_t)input[77] << 16);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 624 to 639
	value = ((uint32_t)input[78] << 24) |
			((uint32_t)input[79] << 16);
	output[39] = (double)(value >> 16);

	// read output[40]: from bit 640 to 655
	value = ((uint32_t)input[80] << 24) |
			((uint32_t)input[81] << 16);
	output[40] = (double)(value >> 16);

	// read output[41]: from bit 656 to 671
	value = ((uint32_t)input[82] << 24) |
			((uint32_t)input[83] << 16);
	output[41] = (double)(value >> 16);

	// read output[42]: from bit 672 to 687
	value = ((uint32_t)input[84] << 24) |
			((uint32_t)input[85] << 16);
	output[42] = (double)(value >> 16);

	// read output[43]: from bit 688 to 703
	value = ((uint32_t)input[86] << 24) |
			((uint32_t)input[87] << 16);
	output[43] = (double)(value >> 16);

	// read output[44]: from bit 704 to 719
	value = ((uint32_t)input[88] << 24) |
			((uint32_t)input[89] << 16);
	output[44] = (double)(value >> 16);
}

static void unpack_45_16bit_unsigned_0off(const uint8_t * input, double * output, void *closure) {
	// Unpack 45 values into output
	// Values are 16-bit unsigned
	// Skip 0 bits, read 720 bits of data.
	// Input must be at least 90 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 0 to 15
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)input[1] << 16);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 16 to 31
	value = ((uint32_t)input[2] << 24) |
			((uint32_t)input[3] << 16);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 32 to 47
	value = ((uint32_t)input[4] << 24) |
			((uint32_t)input[5] << 16);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 48 to 63
	value = ((uint32_t)input[6] << 24) |
			((uint32_t)input[7] << 16);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 64 to 79
	value = ((uint32_t)input[8] << 24) |
			((uint32_t)input[9] << 16);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 80 to 95
	value = ((uint32_t)input[10] << 24) |
			((uint32_t)input[11] << 16);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 96 to 111
	value = ((uint32_t)input[12] << 24) |
			((uint32_t)input[13] << 16);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 112 to 127
	value = ((uint32_t)input[14] << 24) |
			((uint32_t)input[15] << 16);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 128 to 143
	value = ((uint32_t)input[16] << 24) |
			((uint32_t)input[17] << 16);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 144 to 159
	value = ((uint32_t)input[18] << 24) |
			((uint32_t)input[19] << 16);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 160 to 175
	value = ((uint32_t)input[20] << 24) |
			((uint32_t)input[21] << 16);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 176 to 191
	value = ((uint32_t)input[22] << 24) |
			((uint32_t)input[23] << 16);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 192 to 207
	value = ((uint32_t)input[24] << 24) |
			((uint32_t)input[25] << 16);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 208 to 223
	value = ((uint32_t)input[26] << 24) |
			((uint32_t)input[27] << 16);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 224 to 239
	value = ((uint32_t)input[28] << 24) |
			((uint32_t)input[29] << 16);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 240 to 255
	value = ((uint32_t)input[30] << 24) |
			((uint32_t)input[31] << 16);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 256 to 271
	value = ((uint32_t)input[32] << 24) |
			((uint32_t)input[33] << 16);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 272 to 287
	value = ((uint32_t)input[34] << 24) |
			((uint32_t)input[35] << 16);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 288 to 303
	value = ((uint32_t)input[36] << 24) |
			((uint32_t)input[37] << 16);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 304 to 319
	value = ((uint32_t)input[38] << 24) |
			((uint32_t)input[39] << 16);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 320 to 335
	value = ((uint32_t)input[40] << 24) |
			((uint32_t)input[41] << 16);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 336 to 351
	value = ((uint32_t)input[42] << 24) |
			((uint32_t)input[43] << 16);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 352 to 367
	value = ((uint32_t)input[44] << 24) |
			((uint32_t)input[45] << 16);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 368 to 383
	value = ((uint32_t)input[46] << 24) |
			((uint32_t)input[47] << 16);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 384 to 399
	value = ((uint32_t)input[48] << 24) |
			((uint32_t)input[49] << 16);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 400 to 415
	value = ((uint32_t)input[50] << 24) |
			((uint32_t)input[51] << 16);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 416 to 431
	value = ((uint32_t)input[52] << 24) |
			((uint32_t)input[53] << 16);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 432 to 447
	value = ((uint32_t)input[54] << 24) |
			((uint32_t)input[55] << 16);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 448 to 463
	value = ((uint32_t)input[56] << 24) |
			((uint32_t)input[57] << 16);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 464 to 479
	value = ((uint32_t)input[58] << 24) |
			((uint32_t)input[59] << 16);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 480 to 495
	value = ((uint32_t)input[60] << 24) |
			((uint32_t)input[61] << 16);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 496 to 511
	value = ((uint32_t)input[62] << 24) |
			((uint32_t)input[63] << 16);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 512 to 527
	value = ((uint32_t)input[64] << 24) |
			((uint32_t)input[65] << 16);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 528 to 543
	value = ((uint32_t)input[66] << 24) |
			((uint32_t)input[67] << 16);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 544 to 559
	value = ((uint32_t)input[68] << 24) |
			((uint32_t)input[69] << 16);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 560 to 575
	value = ((uint32_t)input[70] << 24) |
			((uint32_t)input[71] << 16);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 576 to 591
	value = ((uint32_t)input[72] << 24) |
			((uint32_t)input[73] << 16);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 592 to 607
	value = ((uint32_t)input[74] << 24) |
			((uint32_t)input[75] << 16);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 608 to 623
	value = ((uint32_t)input[76] << 24) |
			((uint32_t)input[77] << 16);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 624 to 639
	value = ((uint32_t)input[78] << 24) |
			((uint32_t)input[79] << 16);
	output[39] = (double)(value >> 16);

	// read output[40]: from bit 640 to 655
	value = ((uint32_t)input[80] << 24) |
			((uint32_t)input[81] << 16);
	output[40] = (double)(value >> 16);

	// read output[41]: from bit 656 to 671
	value = ((uint32_t)input[82] << 24) |
			((uint32_t)input[83] << 16);
	output[41] = (double)(value >> 16);

	// read output[42]: from bit 672 to 687
	value = ((uint32_t)input[84] << 24) |
			((uint32_t)input[85] << 16);
	output[42] = (double)(value >> 16);

	// read output[43]: from bit 688 to 703
	value = ((uint32_t)input[86] << 24) |
			((uint32_t)input[87] << 16);
	output[43] = (double)(value >> 16);

	// read output[44]: from bit 704 to 719
	value = ((uint32_t)input[88] << 24) |
			((uint32_t)input[89] << 16);
	output[44] = (double)(value >> 16);
}

static void unpack_45_16bit_signed_1off(const uint8_t * input, double * output, void *closure) {
	// Unpack 45 values into output
	// Values are 16-bit signed
	// Skip 1 bits, read 720 bits of data.
	// Input must be at least 91 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 1 to 16
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)input[1] << 17) |
			((uint32_t)(input[2] & 0x80) << 9);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 17 to 32
	value = ((uint32_t)(input[2] & 0x7f) << 25) |
			((uint32_t)input[3] << 17) |
			((uint32_t)(input[4] & 0x80) << 9);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 33 to 48
	value = ((uint32_t)(input[4] & 0x7f) << 25) |
			((uint32_t)input[5] << 17) |
			((uint32_t)(input[6] & 0x80) << 9);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 49 to 64
	value = ((uint32_t)(input[6] & 0x7f) << 25) |
			((uint32_t)input[7] << 17) |
			((uint32_t)(input[8] & 0x80) << 9);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 65 to 80
	value = ((uint32_t)(input[8] & 0x7f) << 25) |
			((uint32_t)input[9] << 17) |
			((uint32_t)(input[10] & 0x80) << 9);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 81 to 96
	value = ((uint32_t)(input[10] & 0x7f) << 25) |
			((uint32_t)input[11] << 17) |
			((uint32_t)(input[12] & 0x80) << 9);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 97 to 112
	value = ((uint32_t)(input[12] & 0x7f) << 25) |
			((uint32_t)input[13] << 17) |
			((uint32_t)(input[14] & 0x80) << 9);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 113 to 128
	value = ((uint32_t)(input[14] & 0x7f) << 25) |
			((uint32_t)input[15] << 17) |
			((uint32_t)(input[16] & 0x80) << 9);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 129 to 144
	value = ((uint32_t)(input[16] & 0x7f) << 25) |
			((uint32_t)input[17] << 17) |
			((uint32_t)(input[18] & 0x80) << 9);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 145 to 160
	value = ((uint32_t)(input[18] & 0x7f) << 25) |
			((uint32_t)input[19] << 17) |
			((uint32_t)(input[20] & 0x80) << 9);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 161 to 176
	value = ((uint32_t)(input[20] & 0x7f) << 25) |
			((uint32_t)input[21] << 17) |
			((uint32_t)(input[22] & 0x80) << 9);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 177 to 192
	value = ((uint32_t)(input[22] & 0x7f) << 25) |
			((uint32_t)input[23] << 17) |
			((uint32_t)(input[24] & 0x80) << 9);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 193 to 208
	value = ((uint32_t)(input[24] & 0x7f) << 25) |
			((uint32_t)input[25] << 17) |
			((uint32_t)(input[26] & 0x80) << 9);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 209 to 224
	value = ((uint32_t)(input[26] & 0x7f) << 25) |
			((uint32_t)input[27] << 17) |
			((uint32_t)(input[28] & 0x80) << 9);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 225 to 240
	value = ((uint32_t)(input[28] & 0x7f) << 25) |
			((uint32_t)input[29] << 17) |
			((uint32_t)(input[30] & 0x80) << 9);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 241 to 256
	value = ((uint32_t)(input[30] & 0x7f) << 25) |
			((uint32_t)input[31] << 17) |
			((uint32_t)(input[32] & 0x80) << 9);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 257 to 272
	value = ((uint32_t)(input[32] & 0x7f) << 25) |
			((uint32_t)input[33] << 17) |
			((uint32_t)(input[34] & 0x80) << 9);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 273 to 288
	value = ((uint32_t)(input[34] & 0x7f) << 25) |
			((uint32_t)input[35] << 17) |
			((uint32_t)(input[36] & 0x80) << 9);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 289 to 304
	value = ((uint32_t)(input[36] & 0x7f) << 25) |
			((uint32_t)input[37] << 17) |
			((uint32_t)(input[38] & 0x80) << 9);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 305 to 320
	value = ((uint32_t)(input[38] & 0x7f) << 25) |
			((uint32_t)input[39] << 17) |
			((uint32_t)(input[40] & 0x80) << 9);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 321 to 336
	value = ((uint32_t)(input[40] & 0x7f) << 25) |
			((uint32_t)input[41] << 17) |
			((uint32_t)(input[42] & 0x80) << 9);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 337 to 352
	value = ((uint32_t)(input[42] & 0x7f) << 25) |
			((uint32_t)input[43] << 17) |
			((uint32_t)(input[44] & 0x80) << 9);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 353 to 368
	value = ((uint32_t)(input[44] & 0x7f) << 25) |
			((uint32_t)input[45] << 17) |
			((uint32_t)(input[46] & 0x80) << 9);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 369 to 384
	value = ((uint32_t)(input[46] & 0x7f) << 25) |
			((uint32_t)input[47] << 17) |
			((uint32_t)(input[48] & 0x80) << 9);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 385 to 400
	value = ((uint32_t)(input[48] & 0x7f) << 25) |
			((uint32_t)input[49] << 17) |
			((uint32_t)(input[50] & 0x80) << 9);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 401 to 416
	value = ((uint32_t)(input[50] & 0x7f) << 25) |
			((uint32_t)input[51] << 17) |
			((uint32_t)(input[52] & 0x80) << 9);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 417 to 432
	value = ((uint32_t)(input[52] & 0x7f) << 25) |
			((uint32_t)input[53] << 17) |
			((uint32_t)(input[54] & 0x80) << 9);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 433 to 448
	value = ((uint32_t)(input[54] & 0x7f) << 25) |
			((uint32_t)input[55] << 17) |
			((uint32_t)(input[56] & 0x80) << 9);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 449 to 464
	value = ((uint32_t)(input[56] & 0x7f) << 25) |
			((uint32_t)input[57] << 17) |
			((uint32_t)(input[58] & 0x80) << 9);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 465 to 480
	value = ((uint32_t)(input[58] & 0x7f) << 25) |
			((uint32_t)input[59] << 17) |
			((uint32_t)(input[60] & 0x80) << 9);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 481 to 496
	value = ((uint32_t)(input[60] & 0x7f) << 25) |
			((uint32_t)input[61] << 17) |
			((uint32_t)(input[62] & 0x80) << 9);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 497 to 512
	value = ((uint32_t)(input[62] & 0x7f) << 25) |
			((uint32_t)input[63] << 17) |
			((uint32_t)(input[64] & 0x80) << 9);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 513 to 528
	value = ((uint32_t)(input[64] & 0x7f) << 25) |
			((uint32_t)input[65] << 17) |
			((uint32_t)(input[66] & 0x80) << 9);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 529 to 544
	value = ((uint32_t)(input[66] & 0x7f) << 25) |
			((uint32_t)input[67] << 17) |
			((uint32_t)(input[68] & 0x80) << 9);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 545 to 560
	value = ((uint32_t)(input[68] & 0x7f) << 25) |
			((uint32_t)input[69] << 17) |
			((uint32_t)(input[70] & 0x80) << 9);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 561 to 576
	value = ((uint32_t)(input[70] & 0x7f) << 25) |
			((uint32_t)input[71] << 17) |
			((uint32_t)(input[72] & 0x80) << 9);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 577 to 592
	value = ((uint32_t)(input[72] & 0x7f) << 25) |
			((uint32_t)input[73] << 17) |
			((uint32_t)(input[74] & 0x80) << 9);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 593 to 608
	value = ((uint32_t)(input[74] & 0x7f) << 25) |
			((uint32_t)input[75] << 17) |
			((uint32_t)(input[76] & 0x80) << 9);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 609 to 624
	value = ((uint32_t)(input[76] & 0x7f) << 25) |
			((uint32_t)input[77] << 17) |
			((uint32_t)(input[78] & 0x80) << 9);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 625 to 640
	value = ((uint32_t)(input[78] & 0x7f) << 25) |
			((uint32_t)input[79] << 17) |
			((uint32_t)(input[80] & 0x80) << 9);
	output[39] = (double)(value >> 16);

	// read output[40]: from bit 641 to 656
	value = ((uint32_t)(input[80] & 0x7f) << 25) |
			((uint32_t)input[81] << 17) |
			((uint32_t)(input[82] & 0x80) << 9);
	output[40] = (double)(value >> 16);

	// read output[41]: from bit 657 to 672
	value = ((uint32_t)(input[82] & 0x7f) << 25) |
			((uint32_t)input[83] << 17) |
			((uint32_t)(input[84] & 0x80) << 9);
	output[41] = (double)(value >> 16);

	// read output[42]: from bit 673 to 688
	value = ((uint32_t)(input[84] & 0x7f) << 25) |
			((uint32_t)input[85] << 17) |
			((uint32_t)(input[86] & 0x80) << 9);
	output[42] = (double)(value >> 16);

	// read output[43]: from bit 689 to 704
	value = ((uint32_t)(input[86] & 0x7f) << 25) |
			((uint32_t)input[87] << 17) |
			((uint32_t)(input[88] & 0x80) << 9);
	output[43] = (double)(value >> 16);

	// read output[44]: from bit 705 to 720
	value = ((uint32_t)(input[88] & 0x7f) << 25) |
			((uint32_t)input[89] << 17) |
			((uint32_t)(input[90] & 0x80) << 9);
	output[44] = (double)(value >> 16);
}

static void unpack_45_16bit_unsigned_1off(const uint8_t * input, double * output, void *closure) {
	// Unpack 45 values into output
	// Values are 16-bit unsigned
	// Skip 1 bits, read 720 bits of data.
	// Input must be at least 91 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 1 to 16
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)input[1] << 17) |
			((uint32_t)(input[2] & 0x80) << 9);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 17 to 32
	value = ((uint32_t)(input[2] & 0x7f) << 25) |
			((uint32_t)input[3] << 17) |
			((uint32_t)(input[4] & 0x80) << 9);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 33 to 48
	value = ((uint32_t)(input[4] & 0x7f) << 25) |
			((uint32_t)input[5] << 17) |
			((uint32_t)(input[6] & 0x80) << 9);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 49 to 64
	value = ((uint32_t)(input[6] & 0x7f) << 25) |
			((uint32_t)input[7] << 17) |
			((uint32_t)(input[8] & 0x80) << 9);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 65 to 80
	value = ((uint32_t)(input[8] & 0x7f) << 25) |
			((uint32_t)input[9] << 17) |
			((uint32_t)(input[10] & 0x80) << 9);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 81 to 96
	value = ((uint32_t)(input[10] & 0x7f) << 25) |
			((uint32_t)input[11] << 17) |
			((uint32_t)(input[12] & 0x80) << 9);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 97 to 112
	value = ((uint32_t)(input[12] & 0x7f) << 25) |
			((uint32_t)input[13] << 17) |
			((uint32_t)(input[14] & 0x80) << 9);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 113 to 128
	value = ((uint32_t)(input[14] & 0x7f) << 25) |
			((uint32_t)input[15] << 17) |
			((uint32_t)(input[16] & 0x80) << 9);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 129 to 144
	value = ((uint32_t)(input[16] & 0x7f) << 25) |
			((uint32_t)input[17] << 17) |
			((uint32_t)(input[18] & 0x80) << 9);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 145 to 160
	value = ((uint32_t)(input[18] & 0x7f) << 25) |
			((uint32_t)input[19] << 17) |
			((uint32_t)(input[20] & 0x80) << 9);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 161 to 176
	value = ((uint32_t)(input[20] & 0x7f) << 25) |
			((uint32_t)input[21] << 17) |
			((uint32_t)(input[22] & 0x80) << 9);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 177 to 192
	value = ((uint32_t)(input[22] & 0x7f) << 25) |
			((uint32_t)input[23] << 17) |
			((uint32_t)(input[24] & 0x80) << 9);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 193 to 208
	value = ((uint32_t)(input[24] & 0x7f) << 25) |
			((uint32_t)input[25] << 17) |
			((uint32_t)(input[26] & 0x80) << 9);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 209 to 224
	value = ((uint32_t)(input[26] & 0x7f) << 25) |
			((uint32_t)input[27] << 17) |
			((uint32_t)(input[28] & 0x80) << 9);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 225 to 240
	value = ((uint32_t)(input[28] & 0x7f) << 25) |
			((uint32_t)input[29] << 17) |
			((uint32_t)(input[30] & 0x80) << 9);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 241 to 256
	value = ((uint32_t)(input[30] & 0x7f) << 25) |
			((uint32_t)input[31] << 17) |
			((uint32_t)(input[32] & 0x80) << 9);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 257 to 272
	value = ((uint32_t)(input[32] & 0x7f) << 25) |
			((uint32_t)input[33] << 17) |
			((uint32_t)(input[34] & 0x80) << 9);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 273 to 288
	value = ((uint32_t)(input[34] & 0x7f) << 25) |
			((uint32_t)input[35] << 17) |
			((uint32_t)(input[36] & 0x80) << 9);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 289 to 304
	value = ((uint32_t)(input[36] & 0x7f) << 25) |
			((uint32_t)input[37] << 17) |
			((uint32_t)(input[38] & 0x80) << 9);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 305 to 320
	value = ((uint32_t)(input[38] & 0x7f) << 25) |
			((uint32_t)input[39] << 17) |
			((uint32_t)(input[40] & 0x80) << 9);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 321 to 336
	value = ((uint32_t)(input[40] & 0x7f) << 25) |
			((uint32_t)input[41] << 17) |
			((uint32_t)(input[42] & 0x80) << 9);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 337 to 352
	value = ((uint32_t)(input[42] & 0x7f) << 25) |
			((uint32_t)input[43] << 17) |
			((uint32_t)(input[44] & 0x80) << 9);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 353 to 368
	value = ((uint32_t)(input[44] & 0x7f) << 25) |
			((uint32_t)input[45] << 17) |
			((uint32_t)(input[46] & 0x80) << 9);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 369 to 384
	value = ((uint32_t)(input[46] & 0x7f) << 25) |
			((uint32_t)input[47] << 17) |
			((uint32_t)(input[48] & 0x80) << 9);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 385 to 400
	value = ((uint32_t)(input[48] & 0x7f) << 25) |
			((uint32_t)input[49] << 17) |
			((uint32_t)(input[50] & 0x80) << 9);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 401 to 416
	value = ((uint32_t)(input[50] & 0x7f) << 25) |
			((uint32_t)input[51] << 17) |
			((uint32_t)(input[52] & 0x80) << 9);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 417 to 432
	value = ((uint32_t)(input[52] & 0x7f) << 25) |
			((uint32_t)input[53] << 17) |
			((uint32_t)(input[54] & 0x80) << 9);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 433 to 448
	value = ((uint32_t)(input[54] & 0x7f) << 25) |
			((uint32_t)input[55] << 17) |
			((uint32_t)(input[56] & 0x80) << 9);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 449 to 464
	value = ((uint32_t)(input[56] & 0x7f) << 25) |
			((uint32_t)input[57] << 17) |
			((uint32_t)(input[58] & 0x80) << 9);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 465 to 480
	value = ((uint32_t)(input[58] & 0x7f) << 25) |
			((uint32_t)input[59] << 17) |
			((uint32_t)(input[60] & 0x80) << 9);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 481 to 496
	value = ((uint32_t)(input[60] & 0x7f) << 25) |
			((uint32_t)input[61] << 17) |
			((uint32_t)(input[62] & 0x80) << 9);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 497 to 512
	value = ((uint32_t)(input[62] & 0x7f) << 25) |
			((uint32_t)input[63] << 17) |
			((uint32_t)(input[64] & 0x80) << 9);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 513 to 528
	value = ((uint32_t)(input[64] & 0x7f) << 25) |
			((uint32_t)input[65] << 17) |
			((uint32_t)(input[66] & 0x80) << 9);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 529 to 544
	value = ((uint32_t)(input[66] & 0x7f) << 25) |
			((uint32_t)input[67] << 17) |
			((uint32_t)(input[68] & 0x80) << 9);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 545 to 560
	value = ((uint32_t)(input[68] & 0x7f) << 25) |
			((uint32_t)input[69] << 17) |
			((uint32_t)(input[70] & 0x80) << 9);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 561 to 576
	value = ((uint32_t)(input[70] & 0x7f) << 25) |
			((uint32_t)input[71] << 17) |
			((uint32_t)(input[72] & 0x80) << 9);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 577 to 592
	value = ((uint32_t)(input[72] & 0x7f) << 25) |
			((uint32_t)input[73] << 17) |
			((uint32_t)(input[74] & 0x80) << 9);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 593 to 608
	value = ((uint32_t)(input[74] & 0x7f) << 25) |
			((uint32_t)input[75] << 17) |
			((uint32_t)(input[76] & 0x80) << 9);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 609 to 624
	value = ((uint32_t)(input[76] & 0x7f) << 25) |
			((uint32_t)input[77] << 17) |
			((uint32_t)(input[78] & 0x80) << 9);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 625 to 640
	value = ((uint32_t)(input[78] & 0x7f) << 25) |
			((uint32_t)input[79] << 17) |
			((uint32_t)(input[80] & 0x80) << 9);
	output[39] = (double)(value >> 16);

	// read output[40]: from bit 641 to 656
	value = ((uint32_t)(input[80] & 0x7f) << 25) |
			((uint32_t)input[81] << 17) |
			((uint32_t)(input[82] & 0x80) << 9);
	output[40] = (double)(value >> 16);

	// read output[41]: from bit 657 to 672
	value = ((uint32_t)(input[82] & 0x7f) << 25) |
			((uint32_t)input[83] << 17) |
			((uint32_t)(input[84] & 0x80) << 9);
	output[41] = (double)(value >> 16);

	// read output[42]: from bit 673 to 688
	value = ((uint32_t)(input[84] & 0x7f) << 25) |
			((uint32_t)input[85] << 17) |
			((uint32_t)(input[86] & 0x80) << 9);
	output[42] = (double)(value >> 16);

	// read output[43]: from bit 689 to 704
	value = ((uint32_t)(input[86] & 0x7f) << 25) |
			((uint32_t)input[87] << 17) |
			((uint32_t)(input[88] & 0x80) << 9);
	output[43] = (double)(value >> 16);

	// read output[44]: from bit 705 to 720
	value = ((uint32_t)(input[88] & 0x7f) << 25) |
			((uint32_t)input[89] << 17) |
			((uint32_t)(input[90] & 0x80) << 9);
	output[44] = (double)(value >> 16);
}

static void unpack_45_16bit_signed_2off(const uint8_t * input, double * output, void *closure) {
	// Unpack 45 values into output
	// Values are 16-bit signed
	// Skip 2 bits, read 720 bits of data.
	// Input must be at least 91 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 2 to 17
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)input[1] << 18) |
			((uint32_t)(input[2] & 0xc0) << 10);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 18 to 33
	value = ((uint32_t)(input[2] & 0x3f) << 26) |
			((uint32_t)input[3] << 18) |
			((uint32_t)(input[4] & 0xc0) << 10);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 34 to 49
	value = ((uint32_t)(input[4] & 0x3f) << 26) |
			((uint32_t)input[5] << 18) |
			((uint32_t)(input[6] & 0xc0) << 10);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 50 to 65
	value = ((uint32_t)(input[6] & 0x3f) << 26) |
			((uint32_t)input[7] << 18) |
			((uint32_t)(input[8] & 0xc0) << 10);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 66 to 81
	value = ((uint32_t)(input[8] & 0x3f) << 26) |
			((uint32_t)input[9] << 18) |
			((uint32_t)(input[10] & 0xc0) << 10);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 82 to 97
	value = ((uint32_t)(input[10] & 0x3f) << 26) |
			((uint32_t)input[11] << 18) |
			((uint32_t)(input[12] & 0xc0) << 10);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 98 to 113
	value = ((uint32_t)(input[12] & 0x3f) << 26) |
			((uint32_t)input[13] << 18) |
			((uint32_t)(input[14] & 0xc0) << 10);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 114 to 129
	value = ((uint32_t)(input[14] & 0x3f) << 26) |
			((uint32_t)input[15] << 18) |
			((uint32_t)(input[16] & 0xc0) << 10);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 130 to 145
	value = ((uint32_t)(input[16] & 0x3f) << 26) |
			((uint32_t)input[17] << 18) |
			((uint32_t)(input[18] & 0xc0) << 10);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 146 to 161
	value = ((uint32_t)(input[18] & 0x3f) << 26) |
			((uint32_t)input[19] << 18) |
			((uint32_t)(input[20] & 0xc0) << 10);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 162 to 177
	value = ((uint32_t)(input[20] & 0x3f) << 26) |
			((uint32_t)input[21] << 18) |
			((uint32_t)(input[22] & 0xc0) << 10);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 178 to 193
	value = ((uint32_t)(input[22] & 0x3f) << 26) |
			((uint32_t)input[23] << 18) |
			((uint32_t)(input[24] & 0xc0) << 10);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 194 to 209
	value = ((uint32_t)(input[24] & 0x3f) << 26) |
			((uint32_t)input[25] << 18) |
			((uint32_t)(input[26] & 0xc0) << 10);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 210 to 225
	value = ((uint32_t)(input[26] & 0x3f) << 26) |
			((uint32_t)input[27] << 18) |
			((uint32_t)(input[28] & 0xc0) << 10);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 226 to 241
	value = ((uint32_t)(input[28] & 0x3f) << 26) |
			((uint32_t)input[29] << 18) |
			((uint32_t)(input[30] & 0xc0) << 10);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 242 to 257
	value = ((uint32_t)(input[30] & 0x3f) << 26) |
			((uint32_t)input[31] << 18) |
			((uint32_t)(input[32] & 0xc0) << 10);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 258 to 273
	value = ((uint32_t)(input[32] & 0x3f) << 26) |
			((uint32_t)input[33] << 18) |
			((uint32_t)(input[34] & 0xc0) << 10);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 274 to 289
	value = ((uint32_t)(input[34] & 0x3f) << 26) |
			((uint32_t)input[35] << 18) |
			((uint32_t)(input[36] & 0xc0) << 10);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 290 to 305
	value = ((uint32_t)(input[36] & 0x3f) << 26) |
			((uint32_t)input[37] << 18) |
			((uint32_t)(input[38] & 0xc0) << 10);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 306 to 321
	value = ((uint32_t)(input[38] & 0x3f) << 26) |
			((uint32_t)input[39] << 18) |
			((uint32_t)(input[40] & 0xc0) << 10);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 322 to 337
	value = ((uint32_t)(input[40] & 0x3f) << 26) |
			((uint32_t)input[41] << 18) |
			((uint32_t)(input[42] & 0xc0) << 10);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 338 to 353
	value = ((uint32_t)(input[42] & 0x3f) << 26) |
			((uint32_t)input[43] << 18) |
			((uint32_t)(input[44] & 0xc0) << 10);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 354 to 369
	value = ((uint32_t)(input[44] & 0x3f) << 26) |
			((uint32_t)input[45] << 18) |
			((uint32_t)(input[46] & 0xc0) << 10);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 370 to 385
	value = ((uint32_t)(input[46] & 0x3f) << 26) |
			((uint32_t)input[47] << 18) |
			((uint32_t)(input[48] & 0xc0) << 10);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 386 to 401
	value = ((uint32_t)(input[48] & 0x3f) << 26) |
			((uint32_t)input[49] << 18) |
			((uint32_t)(input[50] & 0xc0) << 10);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 402 to 417
	value = ((uint32_t)(input[50] & 0x3f) << 26) |
			((uint32_t)input[51] << 18) |
			((uint32_t)(input[52] & 0xc0) << 10);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 418 to 433
	value = ((uint32_t)(input[52] & 0x3f) << 26) |
			((uint32_t)input[53] << 18) |
			((uint32_t)(input[54] & 0xc0) << 10);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 434 to 449
	value = ((uint32_t)(input[54] & 0x3f) << 26) |
			((uint32_t)input[55] << 18) |
			((uint32_t)(input[56] & 0xc0) << 10);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 450 to 465
	value = ((uint32_t)(input[56] & 0x3f) << 26) |
			((uint32_t)input[57] << 18) |
			((uint32_t)(input[58] & 0xc0) << 10);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 466 to 481
	value = ((uint32_t)(input[58] & 0x3f) << 26) |
			((uint32_t)input[59] << 18) |
			((uint32_t)(input[60] & 0xc0) << 10);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 482 to 497
	value = ((uint32_t)(input[60] & 0x3f) << 26) |
			((uint32_t)input[61] << 18) |
			((uint32_t)(input[62] & 0xc0) << 10);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 498 to 513
	value = ((uint32_t)(input[62] & 0x3f) << 26) |
			((uint32_t)input[63] << 18) |
			((uint32_t)(input[64] & 0xc0) << 10);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 514 to 529
	value = ((uint32_t)(input[64] & 0x3f) << 26) |
			((uint32_t)input[65] << 18) |
			((uint32_t)(input[66] & 0xc0) << 10);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 530 to 545
	value = ((uint32_t)(input[66] & 0x3f) << 26) |
			((uint32_t)input[67] << 18) |
			((uint32_t)(input[68] & 0xc0) << 10);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 546 to 561
	value = ((uint32_t)(input[68] & 0x3f) << 26) |
			((uint32_t)input[69] << 18) |
			((uint32_t)(input[70] & 0xc0) << 10);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 562 to 577
	value = ((uint32_t)(input[70] & 0x3f) << 26) |
			((uint32_t)input[71] << 18) |
			((uint32_t)(input[72] & 0xc0) << 10);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 578 to 593
	value = ((uint32_t)(input[72] & 0x3f) << 26) |
			((uint32_t)input[73] << 18) |
			((uint32_t)(input[74] & 0xc0) << 10);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 594 to 609
	value = ((uint32_t)(input[74] & 0x3f) << 26) |
			((uint32_t)input[75] << 18) |
			((uint32_t)(input[76] & 0xc0) << 10);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 610 to 625
	value = ((uint32_t)(input[76] & 0x3f) << 26) |
			((uint32_t)input[77] << 18) |
			((uint32_t)(input[78] & 0xc0) << 10);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 626 to 641
	value = ((uint32_t)(input[78] & 0x3f) << 26) |
			((uint32_t)input[79] << 18) |
			((uint32_t)(input[80] & 0xc0) << 10);
	output[39] = (double)(value >> 16);

	// read output[40]: from bit 642 to 657
	value = ((uint32_t)(input[80] & 0x3f) << 26) |
			((uint32_t)input[81] << 18) |
			((uint32_t)(input[82] & 0xc0) << 10);
	output[40] = (double)(value >> 16);

	// read output[41]: from bit 658 to 673
	value = ((uint32_t)(input[82] & 0x3f) << 26) |
			((uint32_t)input[83] << 18) |
			((uint32_t)(input[84] & 0xc0) << 10);
	output[41] = (double)(value >> 16);

	// read output[42]: from bit 674 to 689
	value = ((uint32_t)(input[84] & 0x3f) << 26) |
			((uint32_t)input[85] << 18) |
			((uint32_t)(input[86] & 0xc0) << 10);
	output[42] = (double)(value >> 16);

	// read output[43]: from bit 690 to 705
	value = ((uint32_t)(input[86] & 0x3f) << 26) |
			((uint32_t)input[87] << 18) |
			((uint32_t)(input[88] & 0xc0) << 10);
	output[43] = (double)(value >> 16);

	// read output[44]: from bit 706 to 721
	value = ((uint32_t)(input[88] & 0x3f) << 26) |
			((uint32_t)input[89] << 18) |
			((uint32_t)(input[90] & 0xc0) << 10);
	output[44] = (double)(value >> 16);
}

static void unpack_45_16bit_unsigned_2off(const uint8_t * input, double * output, void *closure) {
	// Unpack 45 values into output
	// Values are 16-bit unsigned
	// Skip 2 bits, read 720 bits of data.
	// Input must be at least 91 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 2 to 17
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)input[1] << 18) |
			((uint32_t)(input[2] & 0xc0) << 10);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 18 to 33
	value = ((uint32_t)(input[2] & 0x3f) << 26) |
			((uint32_t)input[3] << 18) |
			((uint32_t)(input[4] & 0xc0) << 10);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 34 to 49
	value = ((uint32_t)(input[4] & 0x3f) << 26) |
			((uint32_t)input[5] << 18) |
			((uint32_t)(input[6] & 0xc0) << 10);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 50 to 65
	value = ((uint32_t)(input[6] & 0x3f) << 26) |
			((uint32_t)input[7] << 18) |
			((uint32_t)(input[8] & 0xc0) << 10);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 66 to 81
	value = ((uint32_t)(input[8] & 0x3f) << 26) |
			((uint32_t)input[9] << 18) |
			((uint32_t)(input[10] & 0xc0) << 10);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 82 to 97
	value = ((uint32_t)(input[10] & 0x3f) << 26) |
			((uint32_t)input[11] << 18) |
			((uint32_t)(input[12] & 0xc0) << 10);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 98 to 113
	value = ((uint32_t)(input[12] & 0x3f) << 26) |
			((uint32_t)input[13] << 18) |
			((uint32_t)(input[14] & 0xc0) << 10);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 114 to 129
	value = ((uint32_t)(input[14] & 0x3f) << 26) |
			((uint32_t)input[15] << 18) |
			((uint32_t)(input[16] & 0xc0) << 10);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 130 to 145
	value = ((uint32_t)(input[16] & 0x3f) << 26) |
			((uint32_t)input[17] << 18) |
			((uint32_t)(input[18] & 0xc0) << 10);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 146 to 161
	value = ((uint32_t)(input[18] & 0x3f) << 26) |
			((uint32_t)input[19] << 18) |
			((uint32_t)(input[20] & 0xc0) << 10);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 162 to 177
	value = ((uint32_t)(input[20] & 0x3f) << 26) |
			((uint32_t)input[21] << 18) |
			((uint32_t)(input[22] & 0xc0) << 10);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 178 to 193
	value = ((uint32_t)(input[22] & 0x3f) << 26) |
			((uint32_t)input[23] << 18) |
			((uint32_t)(input[24] & 0xc0) << 10);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 194 to 209
	value = ((uint32_t)(input[24] & 0x3f) << 26) |
			((uint32_t)input[25] << 18) |
			((uint32_t)(input[26] & 0xc0) << 10);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 210 to 225
	value = ((uint32_t)(input[26] & 0x3f) << 26) |
			((uint32_t)input[27] << 18) |
			((uint32_t)(input[28] & 0xc0) << 10);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 226 to 241
	value = ((uint32_t)(input[28] & 0x3f) << 26) |
			((uint32_t)input[29] << 18) |
			((uint32_t)(input[30] & 0xc0) << 10);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 242 to 257
	value = ((uint32_t)(input[30] & 0x3f) << 26) |
			((uint32_t)input[31] << 18) |
			((uint32_t)(input[32] & 0xc0) << 10);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 258 to 273
	value = ((uint32_t)(input[32] & 0x3f) << 26) |
			((uint32_t)input[33] << 18) |
			((uint32_t)(input[34] & 0xc0) << 10);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 274 to 289
	value = ((uint32_t)(input[34] & 0x3f) << 26) |
			((uint32_t)input[35] << 18) |
			((uint32_t)(input[36] & 0xc0) << 10);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 290 to 305
	value = ((uint32_t)(input[36] & 0x3f) << 26) |
			((uint32_t)input[37] << 18) |
			((uint32_t)(input[38] & 0xc0) << 10);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 306 to 321
	value = ((uint32_t)(input[38] & 0x3f) << 26) |
			((uint32_t)input[39] << 18) |
			((uint32_t)(input[40] & 0xc0) << 10);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 322 to 337
	value = ((uint32_t)(input[40] & 0x3f) << 26) |
			((uint32_t)input[41] << 18) |
			((uint32_t)(input[42] & 0xc0) << 10);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 338 to 353
	value = ((uint32_t)(input[42] & 0x3f) << 26) |
			((uint32_t)input[43] << 18) |
			((uint32_t)(input[44] & 0xc0) << 10);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 354 to 369
	value = ((uint32_t)(input[44] & 0x3f) << 26) |
			((uint32_t)input[45] << 18) |
			((uint32_t)(input[46] & 0xc0) << 10);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 370 to 385
	value = ((uint32_t)(input[46] & 0x3f) << 26) |
			((uint32_t)input[47] << 18) |
			((uint32_t)(input[48] & 0xc0) << 10);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 386 to 401
	value = ((uint32_t)(input[48] & 0x3f) << 26) |
			((uint32_t)input[49] << 18) |
			((uint32_t)(input[50] & 0xc0) << 10);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 402 to 417
	value = ((uint32_t)(input[50] & 0x3f) << 26) |
			((uint32_t)input[51] << 18) |
			((uint32_t)(input[52] & 0xc0) << 10);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 418 to 433
	value = ((uint32_t)(input[52] & 0x3f) << 26) |
			((uint32_t)input[53] << 18) |
			((uint32_t)(input[54] & 0xc0) << 10);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 434 to 449
	value = ((uint32_t)(input[54] & 0x3f) << 26) |
			((uint32_t)input[55] << 18) |
			((uint32_t)(input[56] & 0xc0) << 10);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 450 to 465
	value = ((uint32_t)(input[56] & 0x3f) << 26) |
			((uint32_t)input[57] << 18) |
			((uint32_t)(input[58] & 0xc0) << 10);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 466 to 481
	value = ((uint32_t)(input[58] & 0x3f) << 26) |
			((uint32_t)input[59] << 18) |
			((uint32_t)(input[60] & 0xc0) << 10);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 482 to 497
	value = ((uint32_t)(input[60] & 0x3f) << 26) |
			((uint32_t)input[61] << 18) |
			((uint32_t)(input[62] & 0xc0) << 10);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 498 to 513
	value = ((uint32_t)(input[62] & 0x3f) << 26) |
			((uint32_t)input[63] << 18) |
			((uint32_t)(input[64] & 0xc0) << 10);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 514 to 529
	value = ((uint32_t)(input[64] & 0x3f) << 26) |
			((uint32_t)input[65] << 18) |
			((uint32_t)(input[66] & 0xc0) << 10);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 530 to 545
	value = ((uint32_t)(input[66] & 0x3f) << 26) |
			((uint32_t)input[67] << 18) |
			((uint32_t)(input[68] & 0xc0) << 10);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 546 to 561
	value = ((uint32_t)(input[68] & 0x3f) << 26) |
			((uint32_t)input[69] << 18) |
			((uint32_t)(input[70] & 0xc0) << 10);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 562 to 577
	value = ((uint32_t)(input[70] & 0x3f) << 26) |
			((uint32_t)input[71] << 18) |
			((uint32_t)(input[72] & 0xc0) << 10);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 578 to 593
	value = ((uint32_t)(input[72] & 0x3f) << 26) |
			((uint32_t)input[73] << 18) |
			((uint32_t)(input[74] & 0xc0) << 10);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 594 to 609
	value = ((uint32_t)(input[74] & 0x3f) << 26) |
			((uint32_t)input[75] << 18) |
			((uint32_t)(input[76] & 0xc0) << 10);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 610 to 625
	value = ((uint32_t)(input[76] & 0x3f) << 26) |
			((uint32_t)input[77] << 18) |
			((uint32_t)(input[78] & 0xc0) << 10);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 626 to 641
	value = ((uint32_t)(input[78] & 0x3f) << 26) |
			((uint32_t)input[79] << 18) |
			((uint32_t)(input[80] & 0xc0) << 10);
	output[39] = (double)(value >> 16);

	// read output[40]: from bit 642 to 657
	value = ((uint32_t)(input[80] & 0x3f) << 26) |
			((uint32_t)input[81] << 18) |
			((uint32_t)(input[82] & 0xc0) << 10);
	output[40] = (double)(value >> 16);

	// read output[41]: from bit 658 to 673
	value = ((uint32_t)(input[82] & 0x3f) << 26) |
			((uint32_t)input[83] << 18) |
			((uint32_t)(input[84] & 0xc0) << 10);
	output[41] = (double)(value >> 16);

	// read output[42]: from bit 674 to 689
	value = ((uint32_t)(input[84] & 0x3f) << 26) |
			((uint32_t)input[85] << 18) |
			((uint32_t)(input[86] & 0xc0) << 10);
	output[42] = (double)(value >> 16);

	// read output[43]: from bit 690 to 705
	value = ((uint32_t)(input[86] & 0x3f) << 26) |
			((uint32_t)input[87] << 18) |
			((uint32_t)(input[88] & 0xc0) << 10);
	output[43] = (double)(value >> 16);

	// read output[44]: from bit 706 to 721
	value = ((uint32_t)(input[88] & 0x3f) << 26) |
			((uint32_t)input[89] << 18) |
			((uint32_t)(input[90] & 0xc0) << 10);
	output[44] = (double)(value >> 16);
}

static void unpack_45_16bit_signed_3off(const uint8_t * input, double * output, void *closure) {
	// Unpack 45 values into output
	// Values are 16-bit signed
	// Skip 3 bits, read 720 bits of data.
	// Input must be at least 91 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 3 to 18
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)input[1] << 19) |
			((uint32_t)(input[2] & 0xe0) << 11);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 19 to 34
	value = ((uint32_t)(input[2] & 0x1f) << 27) |
			((uint32_t)input[3] << 19) |
			((uint32_t)(input[4] & 0xe0) << 11);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 35 to 50
	value = ((uint32_t)(input[4] & 0x1f) << 27) |
			((uint32_t)input[5] << 19) |
			((uint32_t)(input[6] & 0xe0) << 11);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 51 to 66
	value = ((uint32_t)(input[6] & 0x1f) << 27) |
			((uint32_t)input[7] << 19) |
			((uint32_t)(input[8] & 0xe0) << 11);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 67 to 82
	value = ((uint32_t)(input[8] & 0x1f) << 27) |
			((uint32_t)input[9] << 19) |
			((uint32_t)(input[10] & 0xe0) << 11);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 83 to 98
	value = ((uint32_t)(input[10] & 0x1f) << 27) |
			((uint32_t)input[11] << 19) |
			((uint32_t)(input[12] & 0xe0) << 11);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 99 to 114
	value = ((uint32_t)(input[12] & 0x1f) << 27) |
			((uint32_t)input[13] << 19) |
			((uint32_t)(input[14] & 0xe0) << 11);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 115 to 130
	value = ((uint32_t)(input[14] & 0x1f) << 27) |
			((uint32_t)input[15] << 19) |
			((uint32_t)(input[16] & 0xe0) << 11);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 131 to 146
	value = ((uint32_t)(input[16] & 0x1f) << 27) |
			((uint32_t)input[17] << 19) |
			((uint32_t)(input[18] & 0xe0) << 11);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 147 to 162
	value = ((uint32_t)(input[18] & 0x1f) << 27) |
			((uint32_t)input[19] << 19) |
			((uint32_t)(input[20] & 0xe0) << 11);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 163 to 178
	value = ((uint32_t)(input[20] & 0x1f) << 27) |
			((uint32_t)input[21] << 19) |
			((uint32_t)(input[22] & 0xe0) << 11);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 179 to 194
	value = ((uint32_t)(input[22] & 0x1f) << 27) |
			((uint32_t)input[23] << 19) |
			((uint32_t)(input[24] & 0xe0) << 11);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 195 to 210
	value = ((uint32_t)(input[24] & 0x1f) << 27) |
			((uint32_t)input[25] << 19) |
			((uint32_t)(input[26] & 0xe0) << 11);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 211 to 226
	value = ((uint32_t)(input[26] & 0x1f) << 27) |
			((uint32_t)input[27] << 19) |
			((uint32_t)(input[28] & 0xe0) << 11);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 227 to 242
	value = ((uint32_t)(input[28] & 0x1f) << 27) |
			((uint32_t)input[29] << 19) |
			((uint32_t)(input[30] & 0xe0) << 11);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 243 to 258
	value = ((uint32_t)(input[30] & 0x1f) << 27) |
			((uint32_t)input[31] << 19) |
			((uint32_t)(input[32] & 0xe0) << 11);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 259 to 274
	value = ((uint32_t)(input[32] & 0x1f) << 27) |
			((uint32_t)input[33] << 19) |
			((uint32_t)(input[34] & 0xe0) << 11);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 275 to 290
	value = ((uint32_t)(input[34] & 0x1f) << 27) |
			((uint32_t)input[35] << 19) |
			((uint32_t)(input[36] & 0xe0) << 11);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 291 to 306
	value = ((uint32_t)(input[36] & 0x1f) << 27) |
			((uint32_t)input[37] << 19) |
			((uint32_t)(input[38] & 0xe0) << 11);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 307 to 322
	value = ((uint32_t)(input[38] & 0x1f) << 27) |
			((uint32_t)input[39] << 19) |
			((uint32_t)(input[40] & 0xe0) << 11);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 323 to 338
	value = ((uint32_t)(input[40] & 0x1f) << 27) |
			((uint32_t)input[41] << 19) |
			((uint32_t)(input[42] & 0xe0) << 11);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 339 to 354
	value = ((uint32_t)(input[42] & 0x1f) << 27) |
			((uint32_t)input[43] << 19) |
			((uint32_t)(input[44] & 0xe0) << 11);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 355 to 370
	value = ((uint32_t)(input[44] & 0x1f) << 27) |
			((uint32_t)input[45] << 19) |
			((uint32_t)(input[46] & 0xe0) << 11);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 371 to 386
	value = ((uint32_t)(input[46] & 0x1f) << 27) |
			((uint32_t)input[47] << 19) |
			((uint32_t)(input[48] & 0xe0) << 11);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 387 to 402
	value = ((uint32_t)(input[48] & 0x1f) << 27) |
			((uint32_t)input[49] << 19) |
			((uint32_t)(input[50] & 0xe0) << 11);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 403 to 418
	value = ((uint32_t)(input[50] & 0x1f) << 27) |
			((uint32_t)input[51] << 19) |
			((uint32_t)(input[52] & 0xe0) << 11);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 419 to 434
	value = ((uint32_t)(input[52] & 0x1f) << 27) |
			((uint32_t)input[53] << 19) |
			((uint32_t)(input[54] & 0xe0) << 11);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 435 to 450
	value = ((uint32_t)(input[54] & 0x1f) << 27) |
			((uint32_t)input[55] << 19) |
			((uint32_t)(input[56] & 0xe0) << 11);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 451 to 466
	value = ((uint32_t)(input[56] & 0x1f) << 27) |
			((uint32_t)input[57] << 19) |
			((uint32_t)(input[58] & 0xe0) << 11);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 467 to 482
	value = ((uint32_t)(input[58] & 0x1f) << 27) |
			((uint32_t)input[59] << 19) |
			((uint32_t)(input[60] & 0xe0) << 11);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 483 to 498
	value = ((uint32_t)(input[60] & 0x1f) << 27) |
			((uint32_t)input[61] << 19) |
			((uint32_t)(input[62] & 0xe0) << 11);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 499 to 514
	value = ((uint32_t)(input[62] & 0x1f) << 27) |
			((uint32_t)input[63] << 19) |
			((uint32_t)(input[64] & 0xe0) << 11);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 515 to 530
	value = ((uint32_t)(input[64] & 0x1f) << 27) |
			((uint32_t)input[65] << 19) |
			((uint32_t)(input[66] & 0xe0) << 11);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 531 to 546
	value = ((uint32_t)(input[66] & 0x1f) << 27) |
			((uint32_t)input[67] << 19) |
			((uint32_t)(input[68] & 0xe0) << 11);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 547 to 562
	value = ((uint32_t)(input[68] & 0x1f) << 27) |
			((uint32_t)input[69] << 19) |
			((uint32_t)(input[70] & 0xe0) << 11);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 563 to 578
	value = ((uint32_t)(input[70] & 0x1f) << 27) |
			((uint32_t)input[71] << 19) |
			((uint32_t)(input[72] & 0xe0) << 11);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 579 to 594
	value = ((uint32_t)(input[72] & 0x1f) << 27) |
			((uint32_t)input[73] << 19) |
			((uint32_t)(input[74] & 0xe0) << 11);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 595 to 610
	value = ((uint32_t)(input[74] & 0x1f) << 27) |
			((uint32_t)input[75] << 19) |
			((uint32_t)(input[76] & 0xe0) << 11);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 611 to 626
	value = ((uint32_t)(input[76] & 0x1f) << 27) |
			((uint32_t)input[77] << 19) |
			((uint32_t)(input[78] & 0xe0) << 11);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 627 to 642
	value = ((uint32_t)(input[78] & 0x1f) << 27) |
			((uint32_t)input[79] << 19) |
			((uint32_t)(input[80] & 0xe0) << 11);
	output[39] = (double)(value >> 16);

	// read output[40]: from bit 643 to 658
	value = ((uint32_t)(input[80] & 0x1f) << 27) |
			((uint32_t)input[81] << 19) |
			((uint32_t)(input[82] & 0xe0) << 11);
	output[40] = (double)(value >> 16);

	// read output[41]: from bit 659 to 674
	value = ((uint32_t)(input[82] & 0x1f) << 27) |
			((uint32_t)input[83] << 19) |
			((uint32_t)(input[84] & 0xe0) << 11);
	output[41] = (double)(value >> 16);

	// read output[42]: from bit 675 to 690
	value = ((uint32_t)(input[84] & 0x1f) << 27) |
			((uint32_t)input[85] << 19) |
			((uint32_t)(input[86] & 0xe0) << 11);
	output[42] = (double)(value >> 16);

	// read output[43]: from bit 691 to 706
	value = ((uint32_t)(input[86] & 0x1f) << 27) |
			((uint32_t)input[87] << 19) |
			((uint32_t)(input[88] & 0xe0) << 11);
	output[43] = (double)(value >> 16);

	// read output[44]: from bit 707 to 722
	value = ((uint32_t)(input[88] & 0x1f) << 27) |
			((uint32_t)input[89] << 19) |
			((uint32_t)(input[90] & 0xe0) << 11);
	output[44] = (double)(value >> 16);
}

static void unpack_45_16bit_unsigned_3off(const uint8_t * input, double * output, void *closure) {
	// Unpack 45 values into output
	// Values are 16-bit unsigned
	// Skip 3 bits, read 720 bits of data.
	// Input must be at least 91 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 3 to 18
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)input[1] << 19) |
			((uint32_t)(input[2] & 0xe0) << 11);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 19 to 34
	value = ((uint32_t)(input[2] & 0x1f) << 27) |
			((uint32_t)input[3] << 19) |
			((uint32_t)(input[4] & 0xe0) << 11);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 35 to 50
	value = ((uint32_t)(input[4] & 0x1f) << 27) |
			((uint32_t)input[5] << 19) |
			((uint32_t)(input[6] & 0xe0) << 11);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 51 to 66
	value = ((uint32_t)(input[6] & 0x1f) << 27) |
			((uint32_t)input[7] << 19) |
			((uint32_t)(input[8] & 0xe0) << 11);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 67 to 82
	value = ((uint32_t)(input[8] & 0x1f) << 27) |
			((uint32_t)input[9] << 19) |
			((uint32_t)(input[10] & 0xe0) << 11);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 83 to 98
	value = ((uint32_t)(input[10] & 0x1f) << 27) |
			((uint32_t)input[11] << 19) |
			((uint32_t)(input[12] & 0xe0) << 11);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 99 to 114
	value = ((uint32_t)(input[12] & 0x1f) << 27) |
			((uint32_t)input[13] << 19) |
			((uint32_t)(input[14] & 0xe0) << 11);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 115 to 130
	value = ((uint32_t)(input[14] & 0x1f) << 27) |
			((uint32_t)input[15] << 19) |
			((uint32_t)(input[16] & 0xe0) << 11);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 131 to 146
	value = ((uint32_t)(input[16] & 0x1f) << 27) |
			((uint32_t)input[17] << 19) |
			((uint32_t)(input[18] & 0xe0) << 11);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 147 to 162
	value = ((uint32_t)(input[18] & 0x1f) << 27) |
			((uint32_t)input[19] << 19) |
			((uint32_t)(input[20] & 0xe0) << 11);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 163 to 178
	value = ((uint32_t)(input[20] & 0x1f) << 27) |
			((uint32_t)input[21] << 19) |
			((uint32_t)(input[22] & 0xe0) << 11);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 179 to 194
	value = ((uint32_t)(input[22] & 0x1f) << 27) |
			((uint32_t)input[23] << 19) |
			((uint32_t)(input[24] & 0xe0) << 11);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 195 to 210
	value = ((uint32_t)(input[24] & 0x1f) << 27) |
			((uint32_t)input[25] << 19) |
			((uint32_t)(input[26] & 0xe0) << 11);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 211 to 226
	value = ((uint32_t)(input[26] & 0x1f) << 27) |
			((uint32_t)input[27] << 19) |
			((uint32_t)(input[28] & 0xe0) << 11);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 227 to 242
	value = ((uint32_t)(input[28] & 0x1f) << 27) |
			((uint32_t)input[29] << 19) |
			((uint32_t)(input[30] & 0xe0) << 11);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 243 to 258
	value = ((uint32_t)(input[30] & 0x1f) << 27) |
			((uint32_t)input[31] << 19) |
			((uint32_t)(input[32] & 0xe0) << 11);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 259 to 274
	value = ((uint32_t)(input[32] & 0x1f) << 27) |
			((uint32_t)input[33] << 19) |
			((uint32_t)(input[34] & 0xe0) << 11);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 275 to 290
	value = ((uint32_t)(input[34] & 0x1f) << 27) |
			((uint32_t)input[35] << 19) |
			((uint32_t)(input[36] & 0xe0) << 11);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 291 to 306
	value = ((uint32_t)(input[36] & 0x1f) << 27) |
			((uint32_t)input[37] << 19) |
			((uint32_t)(input[38] & 0xe0) << 11);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 307 to 322
	value = ((uint32_t)(input[38] & 0x1f) << 27) |
			((uint32_t)input[39] << 19) |
			((uint32_t)(input[40] & 0xe0) << 11);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 323 to 338
	value = ((uint32_t)(input[40] & 0x1f) << 27) |
			((uint32_t)input[41] << 19) |
			((uint32_t)(input[42] & 0xe0) << 11);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 339 to 354
	value = ((uint32_t)(input[42] & 0x1f) << 27) |
			((uint32_t)input[43] << 19) |
			((uint32_t)(input[44] & 0xe0) << 11);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 355 to 370
	value = ((uint32_t)(input[44] & 0x1f) << 27) |
			((uint32_t)input[45] << 19) |
			((uint32_t)(input[46] & 0xe0) << 11);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 371 to 386
	value = ((uint32_t)(input[46] & 0x1f) << 27) |
			((uint32_t)input[47] << 19) |
			((uint32_t)(input[48] & 0xe0) << 11);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 387 to 402
	value = ((uint32_t)(input[48] & 0x1f) << 27) |
			((uint32_t)input[49] << 19) |
			((uint32_t)(input[50] & 0xe0) << 11);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 403 to 418
	value = ((uint32_t)(input[50] & 0x1f) << 27) |
			((uint32_t)input[51] << 19) |
			((uint32_t)(input[52] & 0xe0) << 11);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 419 to 434
	value = ((uint32_t)(input[52] & 0x1f) << 27) |
			((uint32_t)input[53] << 19) |
			((uint32_t)(input[54] & 0xe0) << 11);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 435 to 450
	value = ((uint32_t)(input[54] & 0x1f) << 27) |
			((uint32_t)input[55] << 19) |
			((uint32_t)(input[56] & 0xe0) << 11);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 451 to 466
	value = ((uint32_t)(input[56] & 0x1f) << 27) |
			((uint32_t)input[57] << 19) |
			((uint32_t)(input[58] & 0xe0) << 11);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 467 to 482
	value = ((uint32_t)(input[58] & 0x1f) << 27) |
			((uint32_t)input[59] << 19) |
			((uint32_t)(input[60] & 0xe0) << 11);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 483 to 498
	value = ((uint32_t)(input[60] & 0x1f) << 27) |
			((uint32_t)input[61] << 19) |
			((uint32_t)(input[62] & 0xe0) << 11);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 499 to 514
	value = ((uint32_t)(input[62] & 0x1f) << 27) |
			((uint32_t)input[63] << 19) |
			((uint32_t)(input[64] & 0xe0) << 11);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 515 to 530
	value = ((uint32_t)(input[64] & 0x1f) << 27) |
			((uint32_t)input[65] << 19) |
			((uint32_t)(input[66] & 0xe0) << 11);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 531 to 546
	value = ((uint32_t)(input[66] & 0x1f) << 27) |
			((uint32_t)input[67] << 19) |
			((uint32_t)(input[68] & 0xe0) << 11);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 547 to 562
	value = ((uint32_t)(input[68] & 0x1f) << 27) |
			((uint32_t)input[69] << 19) |
			((uint32_t)(input[70] & 0xe0) << 11);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 563 to 578
	value = ((uint32_t)(input[70] & 0x1f) << 27) |
			((uint32_t)input[71] << 19) |
			((uint32_t)(input[72] & 0xe0) << 11);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 579 to 594
	value = ((uint32_t)(input[72] & 0x1f) << 27) |
			((uint32_t)input[73] << 19) |
			((uint32_t)(input[74] & 0xe0) << 11);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 595 to 610
	value = ((uint32_t)(input[74] & 0x1f) << 27) |
			((uint32_t)input[75] << 19) |
			((uint32_t)(input[76] & 0xe0) << 11);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 611 to 626
	value = ((uint32_t)(input[76] & 0x1f) << 27) |
			((uint32_t)input[77] << 19) |
			((uint32_t)(input[78] & 0xe0) << 11);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 627 to 642
	value = ((uint32_t)(input[78] & 0x1f) << 27) |
			((uint32_t)input[79] << 19) |
			((uint32_t)(input[80] & 0xe0) << 11);
	output[39] = (double)(value >> 16);

	// read output[40]: from bit 643 to 658
	value = ((uint32_t)(input[80] & 0x1f) << 27) |
			((uint32_t)input[81] << 19) |
			((uint32_t)(input[82] & 0xe0) << 11);
	output[40] = (double)(value >> 16);

	// read output[41]: from bit 659 to 674
	value = ((uint32_t)(input[82] & 0x1f) << 27) |
			((uint32_t)input[83] << 19) |
			((uint32_t)(input[84] & 0xe0) << 11);
	output[41] = (double)(value >> 16);

	// read output[42]: from bit 675 to 690
	value = ((uint32_t)(input[84] & 0x1f) << 27) |
			((uint32_t)input[85] << 19) |
			((uint32_t)(input[86] & 0xe0) << 11);
	output[42] = (double)(value >> 16);

	// read output[43]: from bit 691 to 706
	value = ((uint32_t)(input[86] & 0x1f) << 27) |
			((uint32_t)input[87] << 19) |
			((uint32_t)(input[88] & 0xe0) << 11);
	output[43] = (double)(value >> 16);

	// read output[44]: from bit 707 to 722
	value = ((uint32_t)(input[88] & 0x1f) << 27) |
			((uint32_t)input[89] << 19) |
			((uint32_t)(input[90] & 0xe0) << 11);
	output[44] = (double)(value >> 16);
}

static void unpack_45_16bit_signed_4off(const uint8_t * input, double * output, void *closure) {
	// Unpack 45 values into output
	// Values are 16-bit signed
	// Skip 4 bits, read 720 bits of data.
	// Input must be at least 91 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 4 to 19
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20) |
			((uint32_t)(input[2] & 0xf0) << 12);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 20 to 35
	value = ((uint32_t)(input[2] & 0x0f) << 28) |
			((uint32_t)input[3] << 20) |
			((uint32_t)(input[4] & 0xf0) << 12);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 36 to 51
	value = ((uint32_t)(input[4] & 0x0f) << 28) |
			((uint32_t)input[5] << 20) |
			((uint32_t)(input[6] & 0xf0) << 12);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 52 to 67
	value = ((uint32_t)(input[6] & 0x0f) << 28) |
			((uint32_t)input[7] << 20) |
			((uint32_t)(input[8] & 0xf0) << 12);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 68 to 83
	value = ((uint32_t)(input[8] & 0x0f) << 28) |
			((uint32_t)input[9] << 20) |
			((uint32_t)(input[10] & 0xf0) << 12);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 84 to 99
	value = ((uint32_t)(input[10] & 0x0f) << 28) |
			((uint32_t)input[11] << 20) |
			((uint32_t)(input[12] & 0xf0) << 12);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 100 to 115
	value = ((uint32_t)(input[12] & 0x0f) << 28) |
			((uint32_t)input[13] << 20) |
			((uint32_t)(input[14] & 0xf0) << 12);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 116 to 131
	value = ((uint32_t)(input[14] & 0x0f) << 28) |
			((uint32_t)input[15] << 20) |
			((uint32_t)(input[16] & 0xf0) << 12);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 132 to 147
	value = ((uint32_t)(input[16] & 0x0f) << 28) |
			((uint32_t)input[17] << 20) |
			((uint32_t)(input[18] & 0xf0) << 12);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 148 to 163
	value = ((uint32_t)(input[18] & 0x0f) << 28) |
			((uint32_t)input[19] << 20) |
			((uint32_t)(input[20] & 0xf0) << 12);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 164 to 179
	value = ((uint32_t)(input[20] & 0x0f) << 28) |
			((uint32_t)input[21] << 20) |
			((uint32_t)(input[22] & 0xf0) << 12);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 180 to 195
	value = ((uint32_t)(input[22] & 0x0f) << 28) |
			((uint32_t)input[23] << 20) |
			((uint32_t)(input[24] & 0xf0) << 12);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 196 to 211
	value = ((uint32_t)(input[24] & 0x0f) << 28) |
			((uint32_t)input[25] << 20) |
			((uint32_t)(input[26] & 0xf0) << 12);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 212 to 227
	value = ((uint32_t)(input[26] & 0x0f) << 28) |
			((uint32_t)input[27] << 20) |
			((uint32_t)(input[28] & 0xf0) << 12);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 228 to 243
	value = ((uint32_t)(input[28] & 0x0f) << 28) |
			((uint32_t)input[29] << 20) |
			((uint32_t)(input[30] & 0xf0) << 12);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 244 to 259
	value = ((uint32_t)(input[30] & 0x0f) << 28) |
			((uint32_t)input[31] << 20) |
			((uint32_t)(input[32] & 0xf0) << 12);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 260 to 275
	value = ((uint32_t)(input[32] & 0x0f) << 28) |
			((uint32_t)input[33] << 20) |
			((uint32_t)(input[34] & 0xf0) << 12);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 276 to 291
	value = ((uint32_t)(input[34] & 0x0f) << 28) |
			((uint32_t)input[35] << 20) |
			((uint32_t)(input[36] & 0xf0) << 12);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 292 to 307
	value = ((uint32_t)(input[36] & 0x0f) << 28) |
			((uint32_t)input[37] << 20) |
			((uint32_t)(input[38] & 0xf0) << 12);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 308 to 323
	value = ((uint32_t)(input[38] & 0x0f) << 28) |
			((uint32_t)input[39] << 20) |
			((uint32_t)(input[40] & 0xf0) << 12);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 324 to 339
	value = ((uint32_t)(input[40] & 0x0f) << 28) |
			((uint32_t)input[41] << 20) |
			((uint32_t)(input[42] & 0xf0) << 12);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 340 to 355
	value = ((uint32_t)(input[42] & 0x0f) << 28) |
			((uint32_t)input[43] << 20) |
			((uint32_t)(input[44] & 0xf0) << 12);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 356 to 371
	value = ((uint32_t)(input[44] & 0x0f) << 28) |
			((uint32_t)input[45] << 20) |
			((uint32_t)(input[46] & 0xf0) << 12);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 372 to 387
	value = ((uint32_t)(input[46] & 0x0f) << 28) |
			((uint32_t)input[47] << 20) |
			((uint32_t)(input[48] & 0xf0) << 12);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 388 to 403
	value = ((uint32_t)(input[48] & 0x0f) << 28) |
			((uint32_t)input[49] << 20) |
			((uint32_t)(input[50] & 0xf0) << 12);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 404 to 419
	value = ((uint32_t)(input[50] & 0x0f) << 28) |
			((uint32_t)input[51] << 20) |
			((uint32_t)(input[52] & 0xf0) << 12);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 420 to 435
	value = ((uint32_t)(input[52] & 0x0f) << 28) |
			((uint32_t)input[53] << 20) |
			((uint32_t)(input[54] & 0xf0) << 12);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 436 to 451
	value = ((uint32_t)(input[54] & 0x0f) << 28) |
			((uint32_t)input[55] << 20) |
			((uint32_t)(input[56] & 0xf0) << 12);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 452 to 467
	value = ((uint32_t)(input[56] & 0x0f) << 28) |
			((uint32_t)input[57] << 20) |
			((uint32_t)(input[58] & 0xf0) << 12);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 468 to 483
	value = ((uint32_t)(input[58] & 0x0f) << 28) |
			((uint32_t)input[59] << 20) |
			((uint32_t)(input[60] & 0xf0) << 12);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 484 to 499
	value = ((uint32_t)(input[60] & 0x0f) << 28) |
			((uint32_t)input[61] << 20) |
			((uint32_t)(input[62] & 0xf0) << 12);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 500 to 515
	value = ((uint32_t)(input[62] & 0x0f) << 28) |
			((uint32_t)input[63] << 20) |
			((uint32_t)(input[64] & 0xf0) << 12);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 516 to 531
	value = ((uint32_t)(input[64] & 0x0f) << 28) |
			((uint32_t)input[65] << 20) |
			((uint32_t)(input[66] & 0xf0) << 12);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 532 to 547
	value = ((uint32_t)(input[66] & 0x0f) << 28) |
			((uint32_t)input[67] << 20) |
			((uint32_t)(input[68] & 0xf0) << 12);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 548 to 563
	value = ((uint32_t)(input[68] & 0x0f) << 28) |
			((uint32_t)input[69] << 20) |
			((uint32_t)(input[70] & 0xf0) << 12);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 564 to 579
	value = ((uint32_t)(input[70] & 0x0f) << 28) |
			((uint32_t)input[71] << 20) |
			((uint32_t)(input[72] & 0xf0) << 12);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 580 to 595
	value = ((uint32_t)(input[72] & 0x0f) << 28) |
			((uint32_t)input[73] << 20) |
			((uint32_t)(input[74] & 0xf0) << 12);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 596 to 611
	value = ((uint32_t)(input[74] & 0x0f) << 28) |
			((uint32_t)input[75] << 20) |
			((uint32_t)(input[76] & 0xf0) << 12);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 612 to 627
	value = ((uint32_t)(input[76] & 0x0f) << 28) |
			((uint32_t)input[77] << 20) |
			((uint32_t)(input[78] & 0xf0) << 12);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 628 to 643
	value = ((uint32_t)(input[78] & 0x0f) << 28) |
			((uint32_t)input[79] << 20) |
			((uint32_t)(input[80] & 0xf0) << 12);
	output[39] = (double)(value >> 16);

	// read output[40]: from bit 644 to 659
	value = ((uint32_t)(input[80] & 0x0f) << 28) |
			((uint32_t)input[81] << 20) |
			((uint32_t)(input[82] & 0xf0) << 12);
	output[40] = (double)(value >> 16);

	// read output[41]: from bit 660 to 675
	value = ((uint32_t)(input[82] & 0x0f) << 28) |
			((uint32_t)input[83] << 20) |
			((uint32_t)(input[84] & 0xf0) << 12);
	output[41] = (double)(value >> 16);

	// read output[42]: from bit 676 to 691
	value = ((uint32_t)(input[84] & 0x0f) << 28) |
			((uint32_t)input[85] << 20) |
			((uint32_t)(input[86] & 0xf0) << 12);
	output[42] = (double)(value >> 16);

	// read output[43]: from bit 692 to 707
	value = ((uint32_t)(input[86] & 0x0f) << 28) |
			((uint32_t)input[87] << 20) |
			((uint32_t)(input[88] & 0xf0) << 12);
	output[43] = (double)(value >> 16);

	// read output[44]: from bit 708 to 723
	value = ((uint32_t)(input[88] & 0x0f) << 28) |
			((uint32_t)input[89] << 20) |
			((uint32_t)(input[90] & 0xf0) << 12);
	output[44] = (double)(value >> 16);
}

static void unpack_45_16bit_unsigned_4off(const uint8_t * input, double * output, void *closure) {
	// Unpack 45 values into output
	// Values are 16-bit unsigned
	// Skip 4 bits, read 720 bits of data.
	// Input must be at least 91 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 4 to 19
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20) |
			((uint32_t)(input[2] & 0xf0) << 12);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 20 to 35
	value = ((uint32_t)(input[2] & 0x0f) << 28) |
			((uint32_t)input[3] << 20) |
			((uint32_t)(input[4] & 0xf0) << 12);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 36 to 51
	value = ((uint32_t)(input[4] & 0x0f) << 28) |
			((uint32_t)input[5] << 20) |
			((uint32_t)(input[6] & 0xf0) << 12);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 52 to 67
	value = ((uint32_t)(input[6] & 0x0f) << 28) |
			((uint32_t)input[7] << 20) |
			((uint32_t)(input[8] & 0xf0) << 12);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 68 to 83
	value = ((uint32_t)(input[8] & 0x0f) << 28) |
			((uint32_t)input[9] << 20) |
			((uint32_t)(input[10] & 0xf0) << 12);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 84 to 99
	value = ((uint32_t)(input[10] & 0x0f) << 28) |
			((uint32_t)input[11] << 20) |
			((uint32_t)(input[12] & 0xf0) << 12);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 100 to 115
	value = ((uint32_t)(input[12] & 0x0f) << 28) |
			((uint32_t)input[13] << 20) |
			((uint32_t)(input[14] & 0xf0) << 12);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 116 to 131
	value = ((uint32_t)(input[14] & 0x0f) << 28) |
			((uint32_t)input[15] << 20) |
			((uint32_t)(input[16] & 0xf0) << 12);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 132 to 147
	value = ((uint32_t)(input[16] & 0x0f) << 28) |
			((uint32_t)input[17] << 20) |
			((uint32_t)(input[18] & 0xf0) << 12);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 148 to 163
	value = ((uint32_t)(input[18] & 0x0f) << 28) |
			((uint32_t)input[19] << 20) |
			((uint32_t)(input[20] & 0xf0) << 12);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 164 to 179
	value = ((uint32_t)(input[20] & 0x0f) << 28) |
			((uint32_t)input[21] << 20) |
			((uint32_t)(input[22] & 0xf0) << 12);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 180 to 195
	value = ((uint32_t)(input[22] & 0x0f) << 28) |
			((uint32_t)input[23] << 20) |
			((uint32_t)(input[24] & 0xf0) << 12);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 196 to 211
	value = ((uint32_t)(input[24] & 0x0f) << 28) |
			((uint32_t)input[25] << 20) |
			((uint32_t)(input[26] & 0xf0) << 12);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 212 to 227
	value = ((uint32_t)(input[26] & 0x0f) << 28) |
			((uint32_t)input[27] << 20) |
			((uint32_t)(input[28] & 0xf0) << 12);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 228 to 243
	value = ((uint32_t)(input[28] & 0x0f) << 28) |
			((uint32_t)input[29] << 20) |
			((uint32_t)(input[30] & 0xf0) << 12);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 244 to 259
	value = ((uint32_t)(input[30] & 0x0f) << 28) |
			((uint32_t)input[31] << 20) |
			((uint32_t)(input[32] & 0xf0) << 12);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 260 to 275
	value = ((uint32_t)(input[32] & 0x0f) << 28) |
			((uint32_t)input[33] << 20) |
			((uint32_t)(input[34] & 0xf0) << 12);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 276 to 291
	value = ((uint32_t)(input[34] & 0x0f) << 28) |
			((uint32_t)input[35] << 20) |
			((uint32_t)(input[36] & 0xf0) << 12);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 292 to 307
	value = ((uint32_t)(input[36] & 0x0f) << 28) |
			((uint32_t)input[37] << 20) |
			((uint32_t)(input[38] & 0xf0) << 12);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 308 to 323
	value = ((uint32_t)(input[38] & 0x0f) << 28) |
			((uint32_t)input[39] << 20) |
			((uint32_t)(input[40] & 0xf0) << 12);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 324 to 339
	value = ((uint32_t)(input[40] & 0x0f) << 28) |
			((uint32_t)input[41] << 20) |
			((uint32_t)(input[42] & 0xf0) << 12);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 340 to 355
	value = ((uint32_t)(input[42] & 0x0f) << 28) |
			((uint32_t)input[43] << 20) |
			((uint32_t)(input[44] & 0xf0) << 12);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 356 to 371
	value = ((uint32_t)(input[44] & 0x0f) << 28) |
			((uint32_t)input[45] << 20) |
			((uint32_t)(input[46] & 0xf0) << 12);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 372 to 387
	value = ((uint32_t)(input[46] & 0x0f) << 28) |
			((uint32_t)input[47] << 20) |
			((uint32_t)(input[48] & 0xf0) << 12);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 388 to 403
	value = ((uint32_t)(input[48] & 0x0f) << 28) |
			((uint32_t)input[49] << 20) |
			((uint32_t)(input[50] & 0xf0) << 12);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 404 to 419
	value = ((uint32_t)(input[50] & 0x0f) << 28) |
			((uint32_t)input[51] << 20) |
			((uint32_t)(input[52] & 0xf0) << 12);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 420 to 435
	value = ((uint32_t)(input[52] & 0x0f) << 28) |
			((uint32_t)input[53] << 20) |
			((uint32_t)(input[54] & 0xf0) << 12);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 436 to 451
	value = ((uint32_t)(input[54] & 0x0f) << 28) |
			((uint32_t)input[55] << 20) |
			((uint32_t)(input[56] & 0xf0) << 12);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 452 to 467
	value = ((uint32_t)(input[56] & 0x0f) << 28) |
			((uint32_t)input[57] << 20) |
			((uint32_t)(input[58] & 0xf0) << 12);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 468 to 483
	value = ((uint32_t)(input[58] & 0x0f) << 28) |
			((uint32_t)input[59] << 20) |
			((uint32_t)(input[60] & 0xf0) << 12);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 484 to 499
	value = ((uint32_t)(input[60] & 0x0f) << 28) |
			((uint32_t)input[61] << 20) |
			((uint32_t)(input[62] & 0xf0) << 12);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 500 to 515
	value = ((uint32_t)(input[62] & 0x0f) << 28) |
			((uint32_t)input[63] << 20) |
			((uint32_t)(input[64] & 0xf0) << 12);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 516 to 531
	value = ((uint32_t)(input[64] & 0x0f) << 28) |
			((uint32_t)input[65] << 20) |
			((uint32_t)(input[66] & 0xf0) << 12);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 532 to 547
	value = ((uint32_t)(input[66] & 0x0f) << 28) |
			((uint32_t)input[67] << 20) |
			((uint32_t)(input[68] & 0xf0) << 12);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 548 to 563
	value = ((uint32_t)(input[68] & 0x0f) << 28) |
			((uint32_t)input[69] << 20) |
			((uint32_t)(input[70] & 0xf0) << 12);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 564 to 579
	value = ((uint32_t)(input[70] & 0x0f) << 28) |
			((uint32_t)input[71] << 20) |
			((uint32_t)(input[72] & 0xf0) << 12);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 580 to 595
	value = ((uint32_t)(input[72] & 0x0f) << 28) |
			((uint32_t)input[73] << 20) |
			((uint32_t)(input[74] & 0xf0) << 12);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 596 to 611
	value = ((uint32_t)(input[74] & 0x0f) << 28) |
			((uint32_t)input[75] << 20) |
			((uint32_t)(input[76] & 0xf0) << 12);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 612 to 627
	value = ((uint32_t)(input[76] & 0x0f) << 28) |
			((uint32_t)input[77] << 20) |
			((uint32_t)(input[78] & 0xf0) << 12);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 628 to 643
	value = ((uint32_t)(input[78] & 0x0f) << 28) |
			((uint32_t)input[79] << 20) |
			((uint32_t)(input[80] & 0xf0) << 12);
	output[39] = (double)(value >> 16);

	// read output[40]: from bit 644 to 659
	value = ((uint32_t)(input[80] & 0x0f) << 28) |
			((uint32_t)input[81] << 20) |
			((uint32_t)(input[82] & 0xf0) << 12);
	output[40] = (double)(value >> 16);

	// read output[41]: from bit 660 to 675
	value = ((uint32_t)(input[82] & 0x0f) << 28) |
			((uint32_t)input[83] << 20) |
			((uint32_t)(input[84] & 0xf0) << 12);
	output[41] = (double)(value >> 16);

	// read output[42]: from bit 676 to 691
	value = ((uint32_t)(input[84] & 0x0f) << 28) |
			((uint32_t)input[85] << 20) |
			((uint32_t)(input[86] & 0xf0) << 12);
	output[42] = (double)(value >> 16);

	// read output[43]: from bit 692 to 707
	value = ((uint32_t)(input[86] & 0x0f) << 28) |
			((uint32_t)input[87] << 20) |
			((uint32_t)(input[88] & 0xf0) << 12);
	output[43] = (double)(value >> 16);

	// read output[44]: from bit 708 to 723
	value = ((uint32_t)(input[88] & 0x0f) << 28) |
			((uint32_t)input[89] << 20) |
			((uint32_t)(input[90] & 0xf0) << 12);
	output[44] = (double)(value >> 16);
}

static void unpack_45_16bit_signed_5off(const uint8_t * input, double * output, void *closure) {
	// Unpack 45 values into output
	// Values are 16-bit signed
	// Skip 5 bits, read 720 bits of data.
	// Input must be at least 91 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 5 to 20
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)(input[2] & 0xf8) << 13);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 21 to 36
	value = ((uint32_t)(input[2] & 0x07) << 29) |
			((uint32_t)input[3] << 21) |
			((uint32_t)(input[4] & 0xf8) << 13);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 37 to 52
	value = ((uint32_t)(input[4] & 0x07) << 29) |
			((uint32_t)input[5] << 21) |
			((uint32_t)(input[6] & 0xf8) << 13);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 53 to 68
	value = ((uint32_t)(input[6] & 0x07) << 29) |
			((uint32_t)input[7] << 21) |
			((uint32_t)(input[8] & 0xf8) << 13);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 69 to 84
	value = ((uint32_t)(input[8] & 0x07) << 29) |
			((uint32_t)input[9] << 21) |
			((uint32_t)(input[10] & 0xf8) << 13);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 85 to 100
	value = ((uint32_t)(input[10] & 0x07) << 29) |
			((uint32_t)input[11] << 21) |
			((uint32_t)(input[12] & 0xf8) << 13);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 101 to 116
	value = ((uint32_t)(input[12] & 0x07) << 29) |
			((uint32_t)input[13] << 21) |
			((uint32_t)(input[14] & 0xf8) << 13);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 117 to 132
	value = ((uint32_t)(input[14] & 0x07) << 29) |
			((uint32_t)input[15] << 21) |
			((uint32_t)(input[16] & 0xf8) << 13);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 133 to 148
	value = ((uint32_t)(input[16] & 0x07) << 29) |
			((uint32_t)input[17] << 21) |
			((uint32_t)(input[18] & 0xf8) << 13);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 149 to 164
	value = ((uint32_t)(input[18] & 0x07) << 29) |
			((uint32_t)input[19] << 21) |
			((uint32_t)(input[20] & 0xf8) << 13);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 165 to 180
	value = ((uint32_t)(input[20] & 0x07) << 29) |
			((uint32_t)input[21] << 21) |
			((uint32_t)(input[22] & 0xf8) << 13);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 181 to 196
	value = ((uint32_t)(input[22] & 0x07) << 29) |
			((uint32_t)input[23] << 21) |
			((uint32_t)(input[24] & 0xf8) << 13);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 197 to 212
	value = ((uint32_t)(input[24] & 0x07) << 29) |
			((uint32_t)input[25] << 21) |
			((uint32_t)(input[26] & 0xf8) << 13);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 213 to 228
	value = ((uint32_t)(input[26] & 0x07) << 29) |
			((uint32_t)input[27] << 21) |
			((uint32_t)(input[28] & 0xf8) << 13);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 229 to 244
	value = ((uint32_t)(input[28] & 0x07) << 29) |
			((uint32_t)input[29] << 21) |
			((uint32_t)(input[30] & 0xf8) << 13);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 245 to 260
	value = ((uint32_t)(input[30] & 0x07) << 29) |
			((uint32_t)input[31] << 21) |
			((uint32_t)(input[32] & 0xf8) << 13);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 261 to 276
	value = ((uint32_t)(input[32] & 0x07) << 29) |
			((uint32_t)input[33] << 21) |
			((uint32_t)(input[34] & 0xf8) << 13);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 277 to 292
	value = ((uint32_t)(input[34] & 0x07) << 29) |
			((uint32_t)input[35] << 21) |
			((uint32_t)(input[36] & 0xf8) << 13);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 293 to 308
	value = ((uint32_t)(input[36] & 0x07) << 29) |
			((uint32_t)input[37] << 21) |
			((uint32_t)(input[38] & 0xf8) << 13);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 309 to 324
	value = ((uint32_t)(input[38] & 0x07) << 29) |
			((uint32_t)input[39] << 21) |
			((uint32_t)(input[40] & 0xf8) << 13);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 325 to 340
	value = ((uint32_t)(input[40] & 0x07) << 29) |
			((uint32_t)input[41] << 21) |
			((uint32_t)(input[42] & 0xf8) << 13);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 341 to 356
	value = ((uint32_t)(input[42] & 0x07) << 29) |
			((uint32_t)input[43] << 21) |
			((uint32_t)(input[44] & 0xf8) << 13);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 357 to 372
	value = ((uint32_t)(input[44] & 0x07) << 29) |
			((uint32_t)input[45] << 21) |
			((uint32_t)(input[46] & 0xf8) << 13);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 373 to 388
	value = ((uint32_t)(input[46] & 0x07) << 29) |
			((uint32_t)input[47] << 21) |
			((uint32_t)(input[48] & 0xf8) << 13);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 389 to 404
	value = ((uint32_t)(input[48] & 0x07) << 29) |
			((uint32_t)input[49] << 21) |
			((uint32_t)(input[50] & 0xf8) << 13);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 405 to 420
	value = ((uint32_t)(input[50] & 0x07) << 29) |
			((uint32_t)input[51] << 21) |
			((uint32_t)(input[52] & 0xf8) << 13);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 421 to 436
	value = ((uint32_t)(input[52] & 0x07) << 29) |
			((uint32_t)input[53] << 21) |
			((uint32_t)(input[54] & 0xf8) << 13);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 437 to 452
	value = ((uint32_t)(input[54] & 0x07) << 29) |
			((uint32_t)input[55] << 21) |
			((uint32_t)(input[56] & 0xf8) << 13);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 453 to 468
	value = ((uint32_t)(input[56] & 0x07) << 29) |
			((uint32_t)input[57] << 21) |
			((uint32_t)(input[58] & 0xf8) << 13);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 469 to 484
	value = ((uint32_t)(input[58] & 0x07) << 29) |
			((uint32_t)input[59] << 21) |
			((uint32_t)(input[60] & 0xf8) << 13);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 485 to 500
	value = ((uint32_t)(input[60] & 0x07) << 29) |
			((uint32_t)input[61] << 21) |
			((uint32_t)(input[62] & 0xf8) << 13);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 501 to 516
	value = ((uint32_t)(input[62] & 0x07) << 29) |
			((uint32_t)input[63] << 21) |
			((uint32_t)(input[64] & 0xf8) << 13);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 517 to 532
	value = ((uint32_t)(input[64] & 0x07) << 29) |
			((uint32_t)input[65] << 21) |
			((uint32_t)(input[66] & 0xf8) << 13);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 533 to 548
	value = ((uint32_t)(input[66] & 0x07) << 29) |
			((uint32_t)input[67] << 21) |
			((uint32_t)(input[68] & 0xf8) << 13);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 549 to 564
	value = ((uint32_t)(input[68] & 0x07) << 29) |
			((uint32_t)input[69] << 21) |
			((uint32_t)(input[70] & 0xf8) << 13);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 565 to 580
	value = ((uint32_t)(input[70] & 0x07) << 29) |
			((uint32_t)input[71] << 21) |
			((uint32_t)(input[72] & 0xf8) << 13);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 581 to 596
	value = ((uint32_t)(input[72] & 0x07) << 29) |
			((uint32_t)input[73] << 21) |
			((uint32_t)(input[74] & 0xf8) << 13);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 597 to 612
	value = ((uint32_t)(input[74] & 0x07) << 29) |
			((uint32_t)input[75] << 21) |
			((uint32_t)(input[76] & 0xf8) << 13);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 613 to 628
	value = ((uint32_t)(input[76] & 0x07) << 29) |
			((uint32_t)input[77] << 21) |
			((uint32_t)(input[78] & 0xf8) << 13);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 629 to 644
	value = ((uint32_t)(input[78] & 0x07) << 29) |
			((uint32_t)input[79] << 21) |
			((uint32_t)(input[80] & 0xf8) << 13);
	output[39] = (double)(value >> 16);

	// read output[40]: from bit 645 to 660
	value = ((uint32_t)(input[80] & 0x07) << 29) |
			((uint32_t)input[81] << 21) |
			((uint32_t)(input[82] & 0xf8) << 13);
	output[40] = (double)(value >> 16);

	// read output[41]: from bit 661 to 676
	value = ((uint32_t)(input[82] & 0x07) << 29) |
			((uint32_t)input[83] << 21) |
			((uint32_t)(input[84] & 0xf8) << 13);
	output[41] = (double)(value >> 16);

	// read output[42]: from bit 677 to 692
	value = ((uint32_t)(input[84] & 0x07) << 29) |
			((uint32_t)input[85] << 21) |
			((uint32_t)(input[86] & 0xf8) << 13);
	output[42] = (double)(value >> 16);

	// read output[43]: from bit 693 to 708
	value = ((uint32_t)(input[86] & 0x07) << 29) |
			((uint32_t)input[87] << 21) |
			((uint32_t)(input[88] & 0xf8) << 13);
	output[43] = (double)(value >> 16);

	// read output[44]: from bit 709 to 724
	value = ((uint32_t)(input[88] & 0x07) << 29) |
			((uint32_t)input[89] << 21) |
			((uint32_t)(input[90] & 0xf8) << 13);
	output[44] = (double)(value >> 16);
}

static void unpack_45_16bit_unsigned_5off(const uint8_t * input, double * output, void *closure) {
	// Unpack 45 values into output
	// Values are 16-bit unsigned
	// Skip 5 bits, read 720 bits of data.
	// Input must be at least 91 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 5 to 20
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)(input[2] & 0xf8) << 13);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 21 to 36
	value = ((uint32_t)(input[2] & 0x07) << 29) |
			((uint32_t)input[3] << 21) |
			((uint32_t)(input[4] & 0xf8) << 13);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 37 to 52
	value = ((uint32_t)(input[4] & 0x07) << 29) |
			((uint32_t)input[5] << 21) |
			((uint32_t)(input[6] & 0xf8) << 13);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 53 to 68
	value = ((uint32_t)(input[6] & 0x07) << 29) |
			((uint32_t)input[7] << 21) |
			((uint32_t)(input[8] & 0xf8) << 13);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 69 to 84
	value = ((uint32_t)(input[8] & 0x07) << 29) |
			((uint32_t)input[9] << 21) |
			((uint32_t)(input[10] & 0xf8) << 13);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 85 to 100
	value = ((uint32_t)(input[10] & 0x07) << 29) |
			((uint32_t)input[11] << 21) |
			((uint32_t)(input[12] & 0xf8) << 13);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 101 to 116
	value = ((uint32_t)(input[12] & 0x07) << 29) |
			((uint32_t)input[13] << 21) |
			((uint32_t)(input[14] & 0xf8) << 13);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 117 to 132
	value = ((uint32_t)(input[14] & 0x07) << 29) |
			((uint32_t)input[15] << 21) |
			((uint32_t)(input[16] & 0xf8) << 13);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 133 to 148
	value = ((uint32_t)(input[16] & 0x07) << 29) |
			((uint32_t)input[17] << 21) |
			((uint32_t)(input[18] & 0xf8) << 13);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 149 to 164
	value = ((uint32_t)(input[18] & 0x07) << 29) |
			((uint32_t)input[19] << 21) |
			((uint32_t)(input[20] & 0xf8) << 13);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 165 to 180
	value = ((uint32_t)(input[20] & 0x07) << 29) |
			((uint32_t)input[21] << 21) |
			((uint32_t)(input[22] & 0xf8) << 13);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 181 to 196
	value = ((uint32_t)(input[22] & 0x07) << 29) |
			((uint32_t)input[23] << 21) |
			((uint32_t)(input[24] & 0xf8) << 13);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 197 to 212
	value = ((uint32_t)(input[24] & 0x07) << 29) |
			((uint32_t)input[25] << 21) |
			((uint32_t)(input[26] & 0xf8) << 13);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 213 to 228
	value = ((uint32_t)(input[26] & 0x07) << 29) |
			((uint32_t)input[27] << 21) |
			((uint32_t)(input[28] & 0xf8) << 13);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 229 to 244
	value = ((uint32_t)(input[28] & 0x07) << 29) |
			((uint32_t)input[29] << 21) |
			((uint32_t)(input[30] & 0xf8) << 13);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 245 to 260
	value = ((uint32_t)(input[30] & 0x07) << 29) |
			((uint32_t)input[31] << 21) |
			((uint32_t)(input[32] & 0xf8) << 13);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 261 to 276
	value = ((uint32_t)(input[32] & 0x07) << 29) |
			((uint32_t)input[33] << 21) |
			((uint32_t)(input[34] & 0xf8) << 13);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 277 to 292
	value = ((uint32_t)(input[34] & 0x07) << 29) |
			((uint32_t)input[35] << 21) |
			((uint32_t)(input[36] & 0xf8) << 13);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 293 to 308
	value = ((uint32_t)(input[36] & 0x07) << 29) |
			((uint32_t)input[37] << 21) |
			((uint32_t)(input[38] & 0xf8) << 13);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 309 to 324
	value = ((uint32_t)(input[38] & 0x07) << 29) |
			((uint32_t)input[39] << 21) |
			((uint32_t)(input[40] & 0xf8) << 13);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 325 to 340
	value = ((uint32_t)(input[40] & 0x07) << 29) |
			((uint32_t)input[41] << 21) |
			((uint32_t)(input[42] & 0xf8) << 13);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 341 to 356
	value = ((uint32_t)(input[42] & 0x07) << 29) |
			((uint32_t)input[43] << 21) |
			((uint32_t)(input[44] & 0xf8) << 13);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 357 to 372
	value = ((uint32_t)(input[44] & 0x07) << 29) |
			((uint32_t)input[45] << 21) |
			((uint32_t)(input[46] & 0xf8) << 13);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 373 to 388
	value = ((uint32_t)(input[46] & 0x07) << 29) |
			((uint32_t)input[47] << 21) |
			((uint32_t)(input[48] & 0xf8) << 13);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 389 to 404
	value = ((uint32_t)(input[48] & 0x07) << 29) |
			((uint32_t)input[49] << 21) |
			((uint32_t)(input[50] & 0xf8) << 13);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 405 to 420
	value = ((uint32_t)(input[50] & 0x07) << 29) |
			((uint32_t)input[51] << 21) |
			((uint32_t)(input[52] & 0xf8) << 13);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 421 to 436
	value = ((uint32_t)(input[52] & 0x07) << 29) |
			((uint32_t)input[53] << 21) |
			((uint32_t)(input[54] & 0xf8) << 13);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 437 to 452
	value = ((uint32_t)(input[54] & 0x07) << 29) |
			((uint32_t)input[55] << 21) |
			((uint32_t)(input[56] & 0xf8) << 13);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 453 to 468
	value = ((uint32_t)(input[56] & 0x07) << 29) |
			((uint32_t)input[57] << 21) |
			((uint32_t)(input[58] & 0xf8) << 13);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 469 to 484
	value = ((uint32_t)(input[58] & 0x07) << 29) |
			((uint32_t)input[59] << 21) |
			((uint32_t)(input[60] & 0xf8) << 13);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 485 to 500
	value = ((uint32_t)(input[60] & 0x07) << 29) |
			((uint32_t)input[61] << 21) |
			((uint32_t)(input[62] & 0xf8) << 13);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 501 to 516
	value = ((uint32_t)(input[62] & 0x07) << 29) |
			((uint32_t)input[63] << 21) |
			((uint32_t)(input[64] & 0xf8) << 13);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 517 to 532
	value = ((uint32_t)(input[64] & 0x07) << 29) |
			((uint32_t)input[65] << 21) |
			((uint32_t)(input[66] & 0xf8) << 13);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 533 to 548
	value = ((uint32_t)(input[66] & 0x07) << 29) |
			((uint32_t)input[67] << 21) |
			((uint32_t)(input[68] & 0xf8) << 13);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 549 to 564
	value = ((uint32_t)(input[68] & 0x07) << 29) |
			((uint32_t)input[69] << 21) |
			((uint32_t)(input[70] & 0xf8) << 13);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 565 to 580
	value = ((uint32_t)(input[70] & 0x07) << 29) |
			((uint32_t)input[71] << 21) |
			((uint32_t)(input[72] & 0xf8) << 13);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 581 to 596
	value = ((uint32_t)(input[72] & 0x07) << 29) |
			((uint32_t)input[73] << 21) |
			((uint32_t)(input[74] & 0xf8) << 13);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 597 to 612
	value = ((uint32_t)(input[74] & 0x07) << 29) |
			((uint32_t)input[75] << 21) |
			((uint32_t)(input[76] & 0xf8) << 13);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 613 to 628
	value = ((uint32_t)(input[76] & 0x07) << 29) |
			((uint32_t)input[77] << 21) |
			((uint32_t)(input[78] & 0xf8) << 13);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 629 to 644
	value = ((uint32_t)(input[78] & 0x07) << 29) |
			((uint32_t)input[79] << 21) |
			((uint32_t)(input[80] & 0xf8) << 13);
	output[39] = (double)(value >> 16);

	// read output[40]: from bit 645 to 660
	value = ((uint32_t)(input[80] & 0x07) << 29) |
			((uint32_t)input[81] << 21) |
			((uint32_t)(input[82] & 0xf8) << 13);
	output[40] = (double)(value >> 16);

	// read output[41]: from bit 661 to 676
	value = ((uint32_t)(input[82] & 0x07) << 29) |
			((uint32_t)input[83] << 21) |
			((uint32_t)(input[84] & 0xf8) << 13);
	output[41] = (double)(value >> 16);

	// read output[42]: from bit 677 to 692
	value = ((uint32_t)(input[84] & 0x07) << 29) |
			((uint32_t)input[85] << 21) |
			((uint32_t)(input[86] & 0xf8) << 13);
	output[42] = (double)(value >> 16);

	// read output[43]: from bit 693 to 708
	value = ((uint32_t)(input[86] & 0x07) << 29) |
			((uint32_t)input[87] << 21) |
			((uint32_t)(input[88] & 0xf8) << 13);
	output[43] = (double)(value >> 16);

	// read output[44]: from bit 709 to 724
	value = ((uint32_t)(input[88] & 0x07) << 29) |
			((uint32_t)input[89] << 21) |
			((uint32_t)(input[90] & 0xf8) << 13);
	output[44] = (double)(value >> 16);
}

static void unpack_45_16bit_signed_6off(const uint8_t * input, double * output, void *closure) {
	// Unpack 45 values into output
	// Values are 16-bit signed
	// Skip 6 bits, read 720 bits of data.
	// Input must be at least 91 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 6 to 21
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)(input[2] & 0xfc) << 14);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 22 to 37
	value = ((uint32_t)(input[2] & 0x03) << 30) |
			((uint32_t)input[3] << 22) |
			((uint32_t)(input[4] & 0xfc) << 14);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 38 to 53
	value = ((uint32_t)(input[4] & 0x03) << 30) |
			((uint32_t)input[5] << 22) |
			((uint32_t)(input[6] & 0xfc) << 14);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 54 to 69
	value = ((uint32_t)(input[6] & 0x03) << 30) |
			((uint32_t)input[7] << 22) |
			((uint32_t)(input[8] & 0xfc) << 14);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 70 to 85
	value = ((uint32_t)(input[8] & 0x03) << 30) |
			((uint32_t)input[9] << 22) |
			((uint32_t)(input[10] & 0xfc) << 14);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 86 to 101
	value = ((uint32_t)(input[10] & 0x03) << 30) |
			((uint32_t)input[11] << 22) |
			((uint32_t)(input[12] & 0xfc) << 14);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 102 to 117
	value = ((uint32_t)(input[12] & 0x03) << 30) |
			((uint32_t)input[13] << 22) |
			((uint32_t)(input[14] & 0xfc) << 14);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 118 to 133
	value = ((uint32_t)(input[14] & 0x03) << 30) |
			((uint32_t)input[15] << 22) |
			((uint32_t)(input[16] & 0xfc) << 14);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 134 to 149
	value = ((uint32_t)(input[16] & 0x03) << 30) |
			((uint32_t)input[17] << 22) |
			((uint32_t)(input[18] & 0xfc) << 14);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 150 to 165
	value = ((uint32_t)(input[18] & 0x03) << 30) |
			((uint32_t)input[19] << 22) |
			((uint32_t)(input[20] & 0xfc) << 14);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 166 to 181
	value = ((uint32_t)(input[20] & 0x03) << 30) |
			((uint32_t)input[21] << 22) |
			((uint32_t)(input[22] & 0xfc) << 14);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 182 to 197
	value = ((uint32_t)(input[22] & 0x03) << 30) |
			((uint32_t)input[23] << 22) |
			((uint32_t)(input[24] & 0xfc) << 14);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 198 to 213
	value = ((uint32_t)(input[24] & 0x03) << 30) |
			((uint32_t)input[25] << 22) |
			((uint32_t)(input[26] & 0xfc) << 14);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 214 to 229
	value = ((uint32_t)(input[26] & 0x03) << 30) |
			((uint32_t)input[27] << 22) |
			((uint32_t)(input[28] & 0xfc) << 14);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 230 to 245
	value = ((uint32_t)(input[28] & 0x03) << 30) |
			((uint32_t)input[29] << 22) |
			((uint32_t)(input[30] & 0xfc) << 14);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 246 to 261
	value = ((uint32_t)(input[30] & 0x03) << 30) |
			((uint32_t)input[31] << 22) |
			((uint32_t)(input[32] & 0xfc) << 14);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 262 to 277
	value = ((uint32_t)(input[32] & 0x03) << 30) |
			((uint32_t)input[33] << 22) |
			((uint32_t)(input[34] & 0xfc) << 14);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 278 to 293
	value = ((uint32_t)(input[34] & 0x03) << 30) |
			((uint32_t)input[35] << 22) |
			((uint32_t)(input[36] & 0xfc) << 14);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 294 to 309
	value = ((uint32_t)(input[36] & 0x03) << 30) |
			((uint32_t)input[37] << 22) |
			((uint32_t)(input[38] & 0xfc) << 14);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 310 to 325
	value = ((uint32_t)(input[38] & 0x03) << 30) |
			((uint32_t)input[39] << 22) |
			((uint32_t)(input[40] & 0xfc) << 14);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 326 to 341
	value = ((uint32_t)(input[40] & 0x03) << 30) |
			((uint32_t)input[41] << 22) |
			((uint32_t)(input[42] & 0xfc) << 14);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 342 to 357
	value = ((uint32_t)(input[42] & 0x03) << 30) |
			((uint32_t)input[43] << 22) |
			((uint32_t)(input[44] & 0xfc) << 14);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 358 to 373
	value = ((uint32_t)(input[44] & 0x03) << 30) |
			((uint32_t)input[45] << 22) |
			((uint32_t)(input[46] & 0xfc) << 14);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 374 to 389
	value = ((uint32_t)(input[46] & 0x03) << 30) |
			((uint32_t)input[47] << 22) |
			((uint32_t)(input[48] & 0xfc) << 14);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 390 to 405
	value = ((uint32_t)(input[48] & 0x03) << 30) |
			((uint32_t)input[49] << 22) |
			((uint32_t)(input[50] & 0xfc) << 14);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 406 to 421
	value = ((uint32_t)(input[50] & 0x03) << 30) |
			((uint32_t)input[51] << 22) |
			((uint32_t)(input[52] & 0xfc) << 14);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 422 to 437
	value = ((uint32_t)(input[52] & 0x03) << 30) |
			((uint32_t)input[53] << 22) |
			((uint32_t)(input[54] & 0xfc) << 14);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 438 to 453
	value = ((uint32_t)(input[54] & 0x03) << 30) |
			((uint32_t)input[55] << 22) |
			((uint32_t)(input[56] & 0xfc) << 14);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 454 to 469
	value = ((uint32_t)(input[56] & 0x03) << 30) |
			((uint32_t)input[57] << 22) |
			((uint32_t)(input[58] & 0xfc) << 14);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 470 to 485
	value = ((uint32_t)(input[58] & 0x03) << 30) |
			((uint32_t)input[59] << 22) |
			((uint32_t)(input[60] & 0xfc) << 14);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 486 to 501
	value = ((uint32_t)(input[60] & 0x03) << 30) |
			((uint32_t)input[61] << 22) |
			((uint32_t)(input[62] & 0xfc) << 14);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 502 to 517
	value = ((uint32_t)(input[62] & 0x03) << 30) |
			((uint32_t)input[63] << 22) |
			((uint32_t)(input[64] & 0xfc) << 14);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 518 to 533
	value = ((uint32_t)(input[64] & 0x03) << 30) |
			((uint32_t)input[65] << 22) |
			((uint32_t)(input[66] & 0xfc) << 14);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 534 to 549
	value = ((uint32_t)(input[66] & 0x03) << 30) |
			((uint32_t)input[67] << 22) |
			((uint32_t)(input[68] & 0xfc) << 14);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 550 to 565
	value = ((uint32_t)(input[68] & 0x03) << 30) |
			((uint32_t)input[69] << 22) |
			((uint32_t)(input[70] & 0xfc) << 14);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 566 to 581
	value = ((uint32_t)(input[70] & 0x03) << 30) |
			((uint32_t)input[71] << 22) |
			((uint32_t)(input[72] & 0xfc) << 14);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 582 to 597
	value = ((uint32_t)(input[72] & 0x03) << 30) |
			((uint32_t)input[73] << 22) |
			((uint32_t)(input[74] & 0xfc) << 14);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 598 to 613
	value = ((uint32_t)(input[74] & 0x03) << 30) |
			((uint32_t)input[75] << 22) |
			((uint32_t)(input[76] & 0xfc) << 14);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 614 to 629
	value = ((uint32_t)(input[76] & 0x03) << 30) |
			((uint32_t)input[77] << 22) |
			((uint32_t)(input[78] & 0xfc) << 14);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 630 to 645
	value = ((uint32_t)(input[78] & 0x03) << 30) |
			((uint32_t)input[79] << 22) |
			((uint32_t)(input[80] & 0xfc) << 14);
	output[39] = (double)(value >> 16);

	// read output[40]: from bit 646 to 661
	value = ((uint32_t)(input[80] & 0x03) << 30) |
			((uint32_t)input[81] << 22) |
			((uint32_t)(input[82] & 0xfc) << 14);
	output[40] = (double)(value >> 16);

	// read output[41]: from bit 662 to 677
	value = ((uint32_t)(input[82] & 0x03) << 30) |
			((uint32_t)input[83] << 22) |
			((uint32_t)(input[84] & 0xfc) << 14);
	output[41] = (double)(value >> 16);

	// read output[42]: from bit 678 to 693
	value = ((uint32_t)(input[84] & 0x03) << 30) |
			((uint32_t)input[85] << 22) |
			((uint32_t)(input[86] & 0xfc) << 14);
	output[42] = (double)(value >> 16);

	// read output[43]: from bit 694 to 709
	value = ((uint32_t)(input[86] & 0x03) << 30) |
			((uint32_t)input[87] << 22) |
			((uint32_t)(input[88] & 0xfc) << 14);
	output[43] = (double)(value >> 16);

	// read output[44]: from bit 710 to 725
	value = ((uint32_t)(input[88] & 0x03) << 30) |
			((uint32_t)input[89] << 22) |
			((uint32_t)(input[90] & 0xfc) << 14);
	output[44] = (double)(value >> 16);
}

static void unpack_45_16bit_unsigned_6off(const uint8_t * input, double * output, void *closure) {
	// Unpack 45 values into output
	// Values are 16-bit unsigned
	// Skip 6 bits, read 720 bits of data.
	// Input must be at least 91 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 6 to 21
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)(input[2] & 0xfc) << 14);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 22 to 37
	value = ((uint32_t)(input[2] & 0x03) << 30) |
			((uint32_t)input[3] << 22) |
			((uint32_t)(input[4] & 0xfc) << 14);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 38 to 53
	value = ((uint32_t)(input[4] & 0x03) << 30) |
			((uint32_t)input[5] << 22) |
			((uint32_t)(input[6] & 0xfc) << 14);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 54 to 69
	value = ((uint32_t)(input[6] & 0x03) << 30) |
			((uint32_t)input[7] << 22) |
			((uint32_t)(input[8] & 0xfc) << 14);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 70 to 85
	value = ((uint32_t)(input[8] & 0x03) << 30) |
			((uint32_t)input[9] << 22) |
			((uint32_t)(input[10] & 0xfc) << 14);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 86 to 101
	value = ((uint32_t)(input[10] & 0x03) << 30) |
			((uint32_t)input[11] << 22) |
			((uint32_t)(input[12] & 0xfc) << 14);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 102 to 117
	value = ((uint32_t)(input[12] & 0x03) << 30) |
			((uint32_t)input[13] << 22) |
			((uint32_t)(input[14] & 0xfc) << 14);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 118 to 133
	value = ((uint32_t)(input[14] & 0x03) << 30) |
			((uint32_t)input[15] << 22) |
			((uint32_t)(input[16] & 0xfc) << 14);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 134 to 149
	value = ((uint32_t)(input[16] & 0x03) << 30) |
			((uint32_t)input[17] << 22) |
			((uint32_t)(input[18] & 0xfc) << 14);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 150 to 165
	value = ((uint32_t)(input[18] & 0x03) << 30) |
			((uint32_t)input[19] << 22) |
			((uint32_t)(input[20] & 0xfc) << 14);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 166 to 181
	value = ((uint32_t)(input[20] & 0x03) << 30) |
			((uint32_t)input[21] << 22) |
			((uint32_t)(input[22] & 0xfc) << 14);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 182 to 197
	value = ((uint32_t)(input[22] & 0x03) << 30) |
			((uint32_t)input[23] << 22) |
			((uint32_t)(input[24] & 0xfc) << 14);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 198 to 213
	value = ((uint32_t)(input[24] & 0x03) << 30) |
			((uint32_t)input[25] << 22) |
			((uint32_t)(input[26] & 0xfc) << 14);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 214 to 229
	value = ((uint32_t)(input[26] & 0x03) << 30) |
			((uint32_t)input[27] << 22) |
			((uint32_t)(input[28] & 0xfc) << 14);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 230 to 245
	value = ((uint32_t)(input[28] & 0x03) << 30) |
			((uint32_t)input[29] << 22) |
			((uint32_t)(input[30] & 0xfc) << 14);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 246 to 261
	value = ((uint32_t)(input[30] & 0x03) << 30) |
			((uint32_t)input[31] << 22) |
			((uint32_t)(input[32] & 0xfc) << 14);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 262 to 277
	value = ((uint32_t)(input[32] & 0x03) << 30) |
			((uint32_t)input[33] << 22) |
			((uint32_t)(input[34] & 0xfc) << 14);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 278 to 293
	value = ((uint32_t)(input[34] & 0x03) << 30) |
			((uint32_t)input[35] << 22) |
			((uint32_t)(input[36] & 0xfc) << 14);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 294 to 309
	value = ((uint32_t)(input[36] & 0x03) << 30) |
			((uint32_t)input[37] << 22) |
			((uint32_t)(input[38] & 0xfc) << 14);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 310 to 325
	value = ((uint32_t)(input[38] & 0x03) << 30) |
			((uint32_t)input[39] << 22) |
			((uint32_t)(input[40] & 0xfc) << 14);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 326 to 341
	value = ((uint32_t)(input[40] & 0x03) << 30) |
			((uint32_t)input[41] << 22) |
			((uint32_t)(input[42] & 0xfc) << 14);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 342 to 357
	value = ((uint32_t)(input[42] & 0x03) << 30) |
			((uint32_t)input[43] << 22) |
			((uint32_t)(input[44] & 0xfc) << 14);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 358 to 373
	value = ((uint32_t)(input[44] & 0x03) << 30) |
			((uint32_t)input[45] << 22) |
			((uint32_t)(input[46] & 0xfc) << 14);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 374 to 389
	value = ((uint32_t)(input[46] & 0x03) << 30) |
			((uint32_t)input[47] << 22) |
			((uint32_t)(input[48] & 0xfc) << 14);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 390 to 405
	value = ((uint32_t)(input[48] & 0x03) << 30) |
			((uint32_t)input[49] << 22) |
			((uint32_t)(input[50] & 0xfc) << 14);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 406 to 421
	value = ((uint32_t)(input[50] & 0x03) << 30) |
			((uint32_t)input[51] << 22) |
			((uint32_t)(input[52] & 0xfc) << 14);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 422 to 437
	value = ((uint32_t)(input[52] & 0x03) << 30) |
			((uint32_t)input[53] << 22) |
			((uint32_t)(input[54] & 0xfc) << 14);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 438 to 453
	value = ((uint32_t)(input[54] & 0x03) << 30) |
			((uint32_t)input[55] << 22) |
			((uint32_t)(input[56] & 0xfc) << 14);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 454 to 469
	value = ((uint32_t)(input[56] & 0x03) << 30) |
			((uint32_t)input[57] << 22) |
			((uint32_t)(input[58] & 0xfc) << 14);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 470 to 485
	value = ((uint32_t)(input[58] & 0x03) << 30) |
			((uint32_t)input[59] << 22) |
			((uint32_t)(input[60] & 0xfc) << 14);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 486 to 501
	value = ((uint32_t)(input[60] & 0x03) << 30) |
			((uint32_t)input[61] << 22) |
			((uint32_t)(input[62] & 0xfc) << 14);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 502 to 517
	value = ((uint32_t)(input[62] & 0x03) << 30) |
			((uint32_t)input[63] << 22) |
			((uint32_t)(input[64] & 0xfc) << 14);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 518 to 533
	value = ((uint32_t)(input[64] & 0x03) << 30) |
			((uint32_t)input[65] << 22) |
			((uint32_t)(input[66] & 0xfc) << 14);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 534 to 549
	value = ((uint32_t)(input[66] & 0x03) << 30) |
			((uint32_t)input[67] << 22) |
			((uint32_t)(input[68] & 0xfc) << 14);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 550 to 565
	value = ((uint32_t)(input[68] & 0x03) << 30) |
			((uint32_t)input[69] << 22) |
			((uint32_t)(input[70] & 0xfc) << 14);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 566 to 581
	value = ((uint32_t)(input[70] & 0x03) << 30) |
			((uint32_t)input[71] << 22) |
			((uint32_t)(input[72] & 0xfc) << 14);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 582 to 597
	value = ((uint32_t)(input[72] & 0x03) << 30) |
			((uint32_t)input[73] << 22) |
			((uint32_t)(input[74] & 0xfc) << 14);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 598 to 613
	value = ((uint32_t)(input[74] & 0x03) << 30) |
			((uint32_t)input[75] << 22) |
			((uint32_t)(input[76] & 0xfc) << 14);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 614 to 629
	value = ((uint32_t)(input[76] & 0x03) << 30) |
			((uint32_t)input[77] << 22) |
			((uint32_t)(input[78] & 0xfc) << 14);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 630 to 645
	value = ((uint32_t)(input[78] & 0x03) << 30) |
			((uint32_t)input[79] << 22) |
			((uint32_t)(input[80] & 0xfc) << 14);
	output[39] = (double)(value >> 16);

	// read output[40]: from bit 646 to 661
	value = ((uint32_t)(input[80] & 0x03) << 30) |
			((uint32_t)input[81] << 22) |
			((uint32_t)(input[82] & 0xfc) << 14);
	output[40] = (double)(value >> 16);

	// read output[41]: from bit 662 to 677
	value = ((uint32_t)(input[82] & 0x03) << 30) |
			((uint32_t)input[83] << 22) |
			((uint32_t)(input[84] & 0xfc) << 14);
	output[41] = (double)(value >> 16);

	// read output[42]: from bit 678 to 693
	value = ((uint32_t)(input[84] & 0x03) << 30) |
			((uint32_t)input[85] << 22) |
			((uint32_t)(input[86] & 0xfc) << 14);
	output[42] = (double)(value >> 16);

	// read output[43]: from bit 694 to 709
	value = ((uint32_t)(input[86] & 0x03) << 30) |
			((uint32_t)input[87] << 22) |
			((uint32_t)(input[88] & 0xfc) << 14);
	output[43] = (double)(value >> 16);

	// read output[44]: from bit 710 to 725
	value = ((uint32_t)(input[88] & 0x03) << 30) |
			((uint32_t)input[89] << 22) |
			((uint32_t)(input[90] & 0xfc) << 14);
	output[44] = (double)(value >> 16);
}

static void unpack_45_16bit_signed_7off(const uint8_t * input, double * output, void *closure) {
	// Unpack 45 values into output
	// Values are 16-bit signed
	// Skip 7 bits, read 720 bits of data.
	// Input must be at least 91 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 7 to 22
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)(input[2] & 0xfe) << 15);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 23 to 38
	value = ((uint32_t)(input[2] & 0x01) << 31) |
			((uint32_t)input[3] << 23) |
			((uint32_t)(input[4] & 0xfe) << 15);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 39 to 54
	value = ((uint32_t)(input[4] & 0x01) << 31) |
			((uint32_t)input[5] << 23) |
			((uint32_t)(input[6] & 0xfe) << 15);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 55 to 70
	value = ((uint32_t)(input[6] & 0x01) << 31) |
			((uint32_t)input[7] << 23) |
			((uint32_t)(input[8] & 0xfe) << 15);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 71 to 86
	value = ((uint32_t)(input[8] & 0x01) << 31) |
			((uint32_t)input[9] << 23) |
			((uint32_t)(input[10] & 0xfe) << 15);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 87 to 102
	value = ((uint32_t)(input[10] & 0x01) << 31) |
			((uint32_t)input[11] << 23) |
			((uint32_t)(input[12] & 0xfe) << 15);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 103 to 118
	value = ((uint32_t)(input[12] & 0x01) << 31) |
			((uint32_t)input[13] << 23) |
			((uint32_t)(input[14] & 0xfe) << 15);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 119 to 134
	value = ((uint32_t)(input[14] & 0x01) << 31) |
			((uint32_t)input[15] << 23) |
			((uint32_t)(input[16] & 0xfe) << 15);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 135 to 150
	value = ((uint32_t)(input[16] & 0x01) << 31) |
			((uint32_t)input[17] << 23) |
			((uint32_t)(input[18] & 0xfe) << 15);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 151 to 166
	value = ((uint32_t)(input[18] & 0x01) << 31) |
			((uint32_t)input[19] << 23) |
			((uint32_t)(input[20] & 0xfe) << 15);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 167 to 182
	value = ((uint32_t)(input[20] & 0x01) << 31) |
			((uint32_t)input[21] << 23) |
			((uint32_t)(input[22] & 0xfe) << 15);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 183 to 198
	value = ((uint32_t)(input[22] & 0x01) << 31) |
			((uint32_t)input[23] << 23) |
			((uint32_t)(input[24] & 0xfe) << 15);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 199 to 214
	value = ((uint32_t)(input[24] & 0x01) << 31) |
			((uint32_t)input[25] << 23) |
			((uint32_t)(input[26] & 0xfe) << 15);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 215 to 230
	value = ((uint32_t)(input[26] & 0x01) << 31) |
			((uint32_t)input[27] << 23) |
			((uint32_t)(input[28] & 0xfe) << 15);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 231 to 246
	value = ((uint32_t)(input[28] & 0x01) << 31) |
			((uint32_t)input[29] << 23) |
			((uint32_t)(input[30] & 0xfe) << 15);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 247 to 262
	value = ((uint32_t)(input[30] & 0x01) << 31) |
			((uint32_t)input[31] << 23) |
			((uint32_t)(input[32] & 0xfe) << 15);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 263 to 278
	value = ((uint32_t)(input[32] & 0x01) << 31) |
			((uint32_t)input[33] << 23) |
			((uint32_t)(input[34] & 0xfe) << 15);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 279 to 294
	value = ((uint32_t)(input[34] & 0x01) << 31) |
			((uint32_t)input[35] << 23) |
			((uint32_t)(input[36] & 0xfe) << 15);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 295 to 310
	value = ((uint32_t)(input[36] & 0x01) << 31) |
			((uint32_t)input[37] << 23) |
			((uint32_t)(input[38] & 0xfe) << 15);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 311 to 326
	value = ((uint32_t)(input[38] & 0x01) << 31) |
			((uint32_t)input[39] << 23) |
			((uint32_t)(input[40] & 0xfe) << 15);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 327 to 342
	value = ((uint32_t)(input[40] & 0x01) << 31) |
			((uint32_t)input[41] << 23) |
			((uint32_t)(input[42] & 0xfe) << 15);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 343 to 358
	value = ((uint32_t)(input[42] & 0x01) << 31) |
			((uint32_t)input[43] << 23) |
			((uint32_t)(input[44] & 0xfe) << 15);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 359 to 374
	value = ((uint32_t)(input[44] & 0x01) << 31) |
			((uint32_t)input[45] << 23) |
			((uint32_t)(input[46] & 0xfe) << 15);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 375 to 390
	value = ((uint32_t)(input[46] & 0x01) << 31) |
			((uint32_t)input[47] << 23) |
			((uint32_t)(input[48] & 0xfe) << 15);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 391 to 406
	value = ((uint32_t)(input[48] & 0x01) << 31) |
			((uint32_t)input[49] << 23) |
			((uint32_t)(input[50] & 0xfe) << 15);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 407 to 422
	value = ((uint32_t)(input[50] & 0x01) << 31) |
			((uint32_t)input[51] << 23) |
			((uint32_t)(input[52] & 0xfe) << 15);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 423 to 438
	value = ((uint32_t)(input[52] & 0x01) << 31) |
			((uint32_t)input[53] << 23) |
			((uint32_t)(input[54] & 0xfe) << 15);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 439 to 454
	value = ((uint32_t)(input[54] & 0x01) << 31) |
			((uint32_t)input[55] << 23) |
			((uint32_t)(input[56] & 0xfe) << 15);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 455 to 470
	value = ((uint32_t)(input[56] & 0x01) << 31) |
			((uint32_t)input[57] << 23) |
			((uint32_t)(input[58] & 0xfe) << 15);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 471 to 486
	value = ((uint32_t)(input[58] & 0x01) << 31) |
			((uint32_t)input[59] << 23) |
			((uint32_t)(input[60] & 0xfe) << 15);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 487 to 502
	value = ((uint32_t)(input[60] & 0x01) << 31) |
			((uint32_t)input[61] << 23) |
			((uint32_t)(input[62] & 0xfe) << 15);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 503 to 518
	value = ((uint32_t)(input[62] & 0x01) << 31) |
			((uint32_t)input[63] << 23) |
			((uint32_t)(input[64] & 0xfe) << 15);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 519 to 534
	value = ((uint32_t)(input[64] & 0x01) << 31) |
			((uint32_t)input[65] << 23) |
			((uint32_t)(input[66] & 0xfe) << 15);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 535 to 550
	value = ((uint32_t)(input[66] & 0x01) << 31) |
			((uint32_t)input[67] << 23) |
			((uint32_t)(input[68] & 0xfe) << 15);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 551 to 566
	value = ((uint32_t)(input[68] & 0x01) << 31) |
			((uint32_t)input[69] << 23) |
			((uint32_t)(input[70] & 0xfe) << 15);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 567 to 582
	value = ((uint32_t)(input[70] & 0x01) << 31) |
			((uint32_t)input[71] << 23) |
			((uint32_t)(input[72] & 0xfe) << 15);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 583 to 598
	value = ((uint32_t)(input[72] & 0x01) << 31) |
			((uint32_t)input[73] << 23) |
			((uint32_t)(input[74] & 0xfe) << 15);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 599 to 614
	value = ((uint32_t)(input[74] & 0x01) << 31) |
			((uint32_t)input[75] << 23) |
			((uint32_t)(input[76] & 0xfe) << 15);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 615 to 630
	value = ((uint32_t)(input[76] & 0x01) << 31) |
			((uint32_t)input[77] << 23) |
			((uint32_t)(input[78] & 0xfe) << 15);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 631 to 646
	value = ((uint32_t)(input[78] & 0x01) << 31) |
			((uint32_t)input[79] << 23) |
			((uint32_t)(input[80] & 0xfe) << 15);
	output[39] = (double)(value >> 16);

	// read output[40]: from bit 647 to 662
	value = ((uint32_t)(input[80] & 0x01) << 31) |
			((uint32_t)input[81] << 23) |
			((uint32_t)(input[82] & 0xfe) << 15);
	output[40] = (double)(value >> 16);

	// read output[41]: from bit 663 to 678
	value = ((uint32_t)(input[82] & 0x01) << 31) |
			((uint32_t)input[83] << 23) |
			((uint32_t)(input[84] & 0xfe) << 15);
	output[41] = (double)(value >> 16);

	// read output[42]: from bit 679 to 694
	value = ((uint32_t)(input[84] & 0x01) << 31) |
			((uint32_t)input[85] << 23) |
			((uint32_t)(input[86] & 0xfe) << 15);
	output[42] = (double)(value >> 16);

	// read output[43]: from bit 695 to 710
	value = ((uint32_t)(input[86] & 0x01) << 31) |
			((uint32_t)input[87] << 23) |
			((uint32_t)(input[88] & 0xfe) << 15);
	output[43] = (double)(value >> 16);

	// read output[44]: from bit 711 to 726
	value = ((uint32_t)(input[88] & 0x01) << 31) |
			((uint32_t)input[89] << 23) |
			((uint32_t)(input[90] & 0xfe) << 15);
	output[44] = (double)(value >> 16);
}

static void unpack_45_16bit_unsigned_7off(const uint8_t * input, double * output, void *closure) {
	// Unpack 45 values into output
	// Values are 16-bit unsigned
	// Skip 7 bits, read 720 bits of data.
	// Input must be at least 91 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 7 to 22
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)(input[2] & 0xfe) << 15);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 23 to 38
	value = ((uint32_t)(input[2] & 0x01) << 31) |
			((uint32_t)input[3] << 23) |
			((uint32_t)(input[4] & 0xfe) << 15);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 39 to 54
	value = ((uint32_t)(input[4] & 0x01) << 31) |
			((uint32_t)input[5] << 23) |
			((uint32_t)(input[6] & 0xfe) << 15);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 55 to 70
	value = ((uint32_t)(input[6] & 0x01) << 31) |
			((uint32_t)input[7] << 23) |
			((uint32_t)(input[8] & 0xfe) << 15);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 71 to 86
	value = ((uint32_t)(input[8] & 0x01) << 31) |
			((uint32_t)input[9] << 23) |
			((uint32_t)(input[10] & 0xfe) << 15);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 87 to 102
	value = ((uint32_t)(input[10] & 0x01) << 31) |
			((uint32_t)input[11] << 23) |
			((uint32_t)(input[12] & 0xfe) << 15);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 103 to 118
	value = ((uint32_t)(input[12] & 0x01) << 31) |
			((uint32_t)input[13] << 23) |
			((uint32_t)(input[14] & 0xfe) << 15);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 119 to 134
	value = ((uint32_t)(input[14] & 0x01) << 31) |
			((uint32_t)input[15] << 23) |
			((uint32_t)(input[16] & 0xfe) << 15);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 135 to 150
	value = ((uint32_t)(input[16] & 0x01) << 31) |
			((uint32_t)input[17] << 23) |
			((uint32_t)(input[18] & 0xfe) << 15);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 151 to 166
	value = ((uint32_t)(input[18] & 0x01) << 31) |
			((uint32_t)input[19] << 23) |
			((uint32_t)(input[20] & 0xfe) << 15);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 167 to 182
	value = ((uint32_t)(input[20] & 0x01) << 31) |
			((uint32_t)input[21] << 23) |
			((uint32_t)(input[22] & 0xfe) << 15);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 183 to 198
	value = ((uint32_t)(input[22] & 0x01) << 31) |
			((uint32_t)input[23] << 23) |
			((uint32_t)(input[24] & 0xfe) << 15);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 199 to 214
	value = ((uint32_t)(input[24] & 0x01) << 31) |
			((uint32_t)input[25] << 23) |
			((uint32_t)(input[26] & 0xfe) << 15);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 215 to 230
	value = ((uint32_t)(input[26] & 0x01) << 31) |
			((uint32_t)input[27] << 23) |
			((uint32_t)(input[28] & 0xfe) << 15);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 231 to 246
	value = ((uint32_t)(input[28] & 0x01) << 31) |
			((uint32_t)input[29] << 23) |
			((uint32_t)(input[30] & 0xfe) << 15);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 247 to 262
	value = ((uint32_t)(input[30] & 0x01) << 31) |
			((uint32_t)input[31] << 23) |
			((uint32_t)(input[32] & 0xfe) << 15);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 263 to 278
	value = ((uint32_t)(input[32] & 0x01) << 31) |
			((uint32_t)input[33] << 23) |
			((uint32_t)(input[34] & 0xfe) << 15);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 279 to 294
	value = ((uint32_t)(input[34] & 0x01) << 31) |
			((uint32_t)input[35] << 23) |
			((uint32_t)(input[36] & 0xfe) << 15);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 295 to 310
	value = ((uint32_t)(input[36] & 0x01) << 31) |
			((uint32_t)input[37] << 23) |
			((uint32_t)(input[38] & 0xfe) << 15);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 311 to 326
	value = ((uint32_t)(input[38] & 0x01) << 31) |
			((uint32_t)input[39] << 23) |
			((uint32_t)(input[40] & 0xfe) << 15);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 327 to 342
	value = ((uint32_t)(input[40] & 0x01) << 31) |
			((uint32_t)input[41] << 23) |
			((uint32_t)(input[42] & 0xfe) << 15);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 343 to 358
	value = ((uint32_t)(input[42] & 0x01) << 31) |
			((uint32_t)input[43] << 23) |
			((uint32_t)(input[44] & 0xfe) << 15);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 359 to 374
	value = ((uint32_t)(input[44] & 0x01) << 31) |
			((uint32_t)input[45] << 23) |
			((uint32_t)(input[46] & 0xfe) << 15);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 375 to 390
	value = ((uint32_t)(input[46] & 0x01) << 31) |
			((uint32_t)input[47] << 23) |
			((uint32_t)(input[48] & 0xfe) << 15);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 391 to 406
	value = ((uint32_t)(input[48] & 0x01) << 31) |
			((uint32_t)input[49] << 23) |
			((uint32_t)(input[50] & 0xfe) << 15);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 407 to 422
	value = ((uint32_t)(input[50] & 0x01) << 31) |
			((uint32_t)input[51] << 23) |
			((uint32_t)(input[52] & 0xfe) << 15);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 423 to 438
	value = ((uint32_t)(input[52] & 0x01) << 31) |
			((uint32_t)input[53] << 23) |
			((uint32_t)(input[54] & 0xfe) << 15);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 439 to 454
	value = ((uint32_t)(input[54] & 0x01) << 31) |
			((uint32_t)input[55] << 23) |
			((uint32_t)(input[56] & 0xfe) << 15);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 455 to 470
	value = ((uint32_t)(input[56] & 0x01) << 31) |
			((uint32_t)input[57] << 23) |
			((uint32_t)(input[58] & 0xfe) << 15);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 471 to 486
	value = ((uint32_t)(input[58] & 0x01) << 31) |
			((uint32_t)input[59] << 23) |
			((uint32_t)(input[60] & 0xfe) << 15);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 487 to 502
	value = ((uint32_t)(input[60] & 0x01) << 31) |
			((uint32_t)input[61] << 23) |
			((uint32_t)(input[62] & 0xfe) << 15);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 503 to 518
	value = ((uint32_t)(input[62] & 0x01) << 31) |
			((uint32_t)input[63] << 23) |
			((uint32_t)(input[64] & 0xfe) << 15);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 519 to 534
	value = ((uint32_t)(input[64] & 0x01) << 31) |
			((uint32_t)input[65] << 23) |
			((uint32_t)(input[66] & 0xfe) << 15);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 535 to 550
	value = ((uint32_t)(input[66] & 0x01) << 31) |
			((uint32_t)input[67] << 23) |
			((uint32_t)(input[68] & 0xfe) << 15);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 551 to 566
	value = ((uint32_t)(input[68] & 0x01) << 31) |
			((uint32_t)input[69] << 23) |
			((uint32_t)(input[70] & 0xfe) << 15);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 567 to 582
	value = ((uint32_t)(input[70] & 0x01) << 31) |
			((uint32_t)input[71] << 23) |
			((uint32_t)(input[72] & 0xfe) << 15);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 583 to 598
	value = ((uint32_t)(input[72] & 0x01) << 31) |
			((uint32_t)input[73] << 23) |
			((uint32_t)(input[74] & 0xfe) << 15);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 599 to 614
	value = ((uint32_t)(input[74] & 0x01) << 31) |
			((uint32_t)input[75] << 23) |
			((uint32_t)(input[76] & 0xfe) << 15);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 615 to 630
	value = ((uint32_t)(input[76] & 0x01) << 31) |
			((uint32_t)input[77] << 23) |
			((uint32_t)(input[78] & 0xfe) << 15);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 631 to 646
	value = ((uint32_t)(input[78] & 0x01) << 31) |
			((uint32_t)input[79] << 23) |
			((uint32_t)(input[80] & 0xfe) << 15);
	output[39] = (double)(value >> 16);

	// read output[40]: from bit 647 to 662
	value = ((uint32_t)(input[80] & 0x01) << 31) |
			((uint32_t)input[81] << 23) |
			((uint32_t)(input[82] & 0xfe) << 15);
	output[40] = (double)(value >> 16);

	// read output[41]: from bit 663 to 678
	value = ((uint32_t)(input[82] & 0x01) << 31) |
			((uint32_t)input[83] << 23) |
			((uint32_t)(input[84] & 0xfe) << 15);
	output[41] = (double)(value >> 16);

	// read output[42]: from bit 679 to 694
	value = ((uint32_t)(input[84] & 0x01) << 31) |
			((uint32_t)input[85] << 23) |
			((uint32_t)(input[86] & 0xfe) << 15);
	output[42] = (double)(value >> 16);

	// read output[43]: from bit 695 to 710
	value = ((uint32_t)(input[86] & 0x01) << 31) |
			((uint32_t)input[87] << 23) |
			((uint32_t)(input[88] & 0xfe) << 15);
	output[43] = (double)(value >> 16);

	// read output[44]: from bit 711 to 726
	value = ((uint32_t)(input[88] & 0x01) << 31) |
			((uint32_t)input[89] << 23) |
			((uint32_t)(input[90] & 0xfe) << 15);
	output[44] = (double)(value >> 16);
}

static void unpack_46_16bit_signed_0off(const uint8_t * input, double * output, void *closure) {
	// Unpack 46 values into output
	// Values are 16-bit signed
	// Skip 0 bits, read 736 bits of data.
	// Input must be at least 92 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 0 to 15
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)input[1] << 16);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 16 to 31
	value = ((uint32_t)input[2] << 24) |
			((uint32_t)input[3] << 16);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 32 to 47
	value = ((uint32_t)input[4] << 24) |
			((uint32_t)input[5] << 16);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 48 to 63
	value = ((uint32_t)input[6] << 24) |
			((uint32_t)input[7] << 16);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 64 to 79
	value = ((uint32_t)input[8] << 24) |
			((uint32_t)input[9] << 16);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 80 to 95
	value = ((uint32_t)input[10] << 24) |
			((uint32_t)input[11] << 16);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 96 to 111
	value = ((uint32_t)input[12] << 24) |
			((uint32_t)input[13] << 16);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 112 to 127
	value = ((uint32_t)input[14] << 24) |
			((uint32_t)input[15] << 16);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 128 to 143
	value = ((uint32_t)input[16] << 24) |
			((uint32_t)input[17] << 16);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 144 to 159
	value = ((uint32_t)input[18] << 24) |
			((uint32_t)input[19] << 16);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 160 to 175
	value = ((uint32_t)input[20] << 24) |
			((uint32_t)input[21] << 16);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 176 to 191
	value = ((uint32_t)input[22] << 24) |
			((uint32_t)input[23] << 16);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 192 to 207
	value = ((uint32_t)input[24] << 24) |
			((uint32_t)input[25] << 16);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 208 to 223
	value = ((uint32_t)input[26] << 24) |
			((uint32_t)input[27] << 16);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 224 to 239
	value = ((uint32_t)input[28] << 24) |
			((uint32_t)input[29] << 16);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 240 to 255
	value = ((uint32_t)input[30] << 24) |
			((uint32_t)input[31] << 16);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 256 to 271
	value = ((uint32_t)input[32] << 24) |
			((uint32_t)input[33] << 16);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 272 to 287
	value = ((uint32_t)input[34] << 24) |
			((uint32_t)input[35] << 16);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 288 to 303
	value = ((uint32_t)input[36] << 24) |
			((uint32_t)input[37] << 16);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 304 to 319
	value = ((uint32_t)input[38] << 24) |
			((uint32_t)input[39] << 16);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 320 to 335
	value = ((uint32_t)input[40] << 24) |
			((uint32_t)input[41] << 16);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 336 to 351
	value = ((uint32_t)input[42] << 24) |
			((uint32_t)input[43] << 16);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 352 to 367
	value = ((uint32_t)input[44] << 24) |
			((uint32_t)input[45] << 16);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 368 to 383
	value = ((uint32_t)input[46] << 24) |
			((uint32_t)input[47] << 16);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 384 to 399
	value = ((uint32_t)input[48] << 24) |
			((uint32_t)input[49] << 16);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 400 to 415
	value = ((uint32_t)input[50] << 24) |
			((uint32_t)input[51] << 16);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 416 to 431
	value = ((uint32_t)input[52] << 24) |
			((uint32_t)input[53] << 16);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 432 to 447
	value = ((uint32_t)input[54] << 24) |
			((uint32_t)input[55] << 16);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 448 to 463
	value = ((uint32_t)input[56] << 24) |
			((uint32_t)input[57] << 16);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 464 to 479
	value = ((uint32_t)input[58] << 24) |
			((uint32_t)input[59] << 16);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 480 to 495
	value = ((uint32_t)input[60] << 24) |
			((uint32_t)input[61] << 16);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 496 to 511
	value = ((uint32_t)input[62] << 24) |
			((uint32_t)input[63] << 16);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 512 to 527
	value = ((uint32_t)input[64] << 24) |
			((uint32_t)input[65] << 16);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 528 to 543
	value = ((uint32_t)input[66] << 24) |
			((uint32_t)input[67] << 16);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 544 to 559
	value = ((uint32_t)input[68] << 24) |
			((uint32_t)input[69] << 16);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 560 to 575
	value = ((uint32_t)input[70] << 24) |
			((uint32_t)input[71] << 16);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 576 to 591
	value = ((uint32_t)input[72] << 24) |
			((uint32_t)input[73] << 16);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 592 to 607
	value = ((uint32_t)input[74] << 24) |
			((uint32_t)input[75] << 16);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 608 to 623
	value = ((uint32_t)input[76] << 24) |
			((uint32_t)input[77] << 16);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 624 to 639
	value = ((uint32_t)input[78] << 24) |
			((uint32_t)input[79] << 16);
	output[39] = (double)(value >> 16);

	// read output[40]: from bit 640 to 655
	value = ((uint32_t)input[80] << 24) |
			((uint32_t)input[81] << 16);
	output[40] = (double)(value >> 16);

	// read output[41]: from bit 656 to 671
	value = ((uint32_t)input[82] << 24) |
			((uint32_t)input[83] << 16);
	output[41] = (double)(value >> 16);

	// read output[42]: from bit 672 to 687
	value = ((uint32_t)input[84] << 24) |
			((uint32_t)input[85] << 16);
	output[42] = (double)(value >> 16);

	// read output[43]: from bit 688 to 703
	value = ((uint32_t)input[86] << 24) |
			((uint32_t)input[87] << 16);
	output[43] = (double)(value >> 16);

	// read output[44]: from bit 704 to 719
	value = ((uint32_t)input[88] << 24) |
			((uint32_t)input[89] << 16);
	output[44] = (double)(value >> 16);

	// read output[45]: from bit 720 to 735
	value = ((uint32_t)input[90] << 24) |
			((uint32_t)input[91] << 16);
	output[45] = (double)(value >> 16);
}

static void unpack_46_16bit_unsigned_0off(const uint8_t * input, double * output, void *closure) {
	// Unpack 46 values into output
	// Values are 16-bit unsigned
	// Skip 0 bits, read 736 bits of data.
	// Input must be at least 92 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 0 to 15
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)input[1] << 16);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 16 to 31
	value = ((uint32_t)input[2] << 24) |
			((uint32_t)input[3] << 16);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 32 to 47
	value = ((uint32_t)input[4] << 24) |
			((uint32_t)input[5] << 16);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 48 to 63
	value = ((uint32_t)input[6] << 24) |
			((uint32_t)input[7] << 16);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 64 to 79
	value = ((uint32_t)input[8] << 24) |
			((uint32_t)input[9] << 16);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 80 to 95
	value = ((uint32_t)input[10] << 24) |
			((uint32_t)input[11] << 16);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 96 to 111
	value = ((uint32_t)input[12] << 24) |
			((uint32_t)input[13] << 16);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 112 to 127
	value = ((uint32_t)input[14] << 24) |
			((uint32_t)input[15] << 16);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 128 to 143
	value = ((uint32_t)input[16] << 24) |
			((uint32_t)input[17] << 16);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 144 to 159
	value = ((uint32_t)input[18] << 24) |
			((uint32_t)input[19] << 16);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 160 to 175
	value = ((uint32_t)input[20] << 24) |
			((uint32_t)input[21] << 16);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 176 to 191
	value = ((uint32_t)input[22] << 24) |
			((uint32_t)input[23] << 16);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 192 to 207
	value = ((uint32_t)input[24] << 24) |
			((uint32_t)input[25] << 16);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 208 to 223
	value = ((uint32_t)input[26] << 24) |
			((uint32_t)input[27] << 16);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 224 to 239
	value = ((uint32_t)input[28] << 24) |
			((uint32_t)input[29] << 16);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 240 to 255
	value = ((uint32_t)input[30] << 24) |
			((uint32_t)input[31] << 16);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 256 to 271
	value = ((uint32_t)input[32] << 24) |
			((uint32_t)input[33] << 16);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 272 to 287
	value = ((uint32_t)input[34] << 24) |
			((uint32_t)input[35] << 16);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 288 to 303
	value = ((uint32_t)input[36] << 24) |
			((uint32_t)input[37] << 16);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 304 to 319
	value = ((uint32_t)input[38] << 24) |
			((uint32_t)input[39] << 16);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 320 to 335
	value = ((uint32_t)input[40] << 24) |
			((uint32_t)input[41] << 16);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 336 to 351
	value = ((uint32_t)input[42] << 24) |
			((uint32_t)input[43] << 16);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 352 to 367
	value = ((uint32_t)input[44] << 24) |
			((uint32_t)input[45] << 16);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 368 to 383
	value = ((uint32_t)input[46] << 24) |
			((uint32_t)input[47] << 16);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 384 to 399
	value = ((uint32_t)input[48] << 24) |
			((uint32_t)input[49] << 16);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 400 to 415
	value = ((uint32_t)input[50] << 24) |
			((uint32_t)input[51] << 16);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 416 to 431
	value = ((uint32_t)input[52] << 24) |
			((uint32_t)input[53] << 16);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 432 to 447
	value = ((uint32_t)input[54] << 24) |
			((uint32_t)input[55] << 16);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 448 to 463
	value = ((uint32_t)input[56] << 24) |
			((uint32_t)input[57] << 16);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 464 to 479
	value = ((uint32_t)input[58] << 24) |
			((uint32_t)input[59] << 16);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 480 to 495
	value = ((uint32_t)input[60] << 24) |
			((uint32_t)input[61] << 16);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 496 to 511
	value = ((uint32_t)input[62] << 24) |
			((uint32_t)input[63] << 16);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 512 to 527
	value = ((uint32_t)input[64] << 24) |
			((uint32_t)input[65] << 16);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 528 to 543
	value = ((uint32_t)input[66] << 24) |
			((uint32_t)input[67] << 16);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 544 to 559
	value = ((uint32_t)input[68] << 24) |
			((uint32_t)input[69] << 16);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 560 to 575
	value = ((uint32_t)input[70] << 24) |
			((uint32_t)input[71] << 16);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 576 to 591
	value = ((uint32_t)input[72] << 24) |
			((uint32_t)input[73] << 16);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 592 to 607
	value = ((uint32_t)input[74] << 24) |
			((uint32_t)input[75] << 16);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 608 to 623
	value = ((uint32_t)input[76] << 24) |
			((uint32_t)input[77] << 16);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 624 to 639
	value = ((uint32_t)input[78] << 24) |
			((uint32_t)input[79] << 16);
	output[39] = (double)(value >> 16);

	// read output[40]: from bit 640 to 655
	value = ((uint32_t)input[80] << 24) |
			((uint32_t)input[81] << 16);
	output[40] = (double)(value >> 16);

	// read output[41]: from bit 656 to 671
	value = ((uint32_t)input[82] << 24) |
			((uint32_t)input[83] << 16);
	output[41] = (double)(value >> 16);

	// read output[42]: from bit 672 to 687
	value = ((uint32_t)input[84] << 24) |
			((uint32_t)input[85] << 16);
	output[42] = (double)(value >> 16);

	// read output[43]: from bit 688 to 703
	value = ((uint32_t)input[86] << 24) |
			((uint32_t)input[87] << 16);
	output[43] = (double)(value >> 16);

	// read output[44]: from bit 704 to 719
	value = ((uint32_t)input[88] << 24) |
			((uint32_t)input[89] << 16);
	output[44] = (double)(value >> 16);

	// read output[45]: from bit 720 to 735
	value = ((uint32_t)input[90] << 24) |
			((uint32_t)input[91] << 16);
	output[45] = (double)(value >> 16);
}

static void unpack_46_16bit_signed_1off(const uint8_t * input, double * output, void *closure) {
	// Unpack 46 values into output
	// Values are 16-bit signed
	// Skip 1 bits, read 736 bits of data.
	// Input must be at least 93 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 1 to 16
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)input[1] << 17) |
			((uint32_t)(input[2] & 0x80) << 9);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 17 to 32
	value = ((uint32_t)(input[2] & 0x7f) << 25) |
			((uint32_t)input[3] << 17) |
			((uint32_t)(input[4] & 0x80) << 9);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 33 to 48
	value = ((uint32_t)(input[4] & 0x7f) << 25) |
			((uint32_t)input[5] << 17) |
			((uint32_t)(input[6] & 0x80) << 9);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 49 to 64
	value = ((uint32_t)(input[6] & 0x7f) << 25) |
			((uint32_t)input[7] << 17) |
			((uint32_t)(input[8] & 0x80) << 9);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 65 to 80
	value = ((uint32_t)(input[8] & 0x7f) << 25) |
			((uint32_t)input[9] << 17) |
			((uint32_t)(input[10] & 0x80) << 9);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 81 to 96
	value = ((uint32_t)(input[10] & 0x7f) << 25) |
			((uint32_t)input[11] << 17) |
			((uint32_t)(input[12] & 0x80) << 9);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 97 to 112
	value = ((uint32_t)(input[12] & 0x7f) << 25) |
			((uint32_t)input[13] << 17) |
			((uint32_t)(input[14] & 0x80) << 9);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 113 to 128
	value = ((uint32_t)(input[14] & 0x7f) << 25) |
			((uint32_t)input[15] << 17) |
			((uint32_t)(input[16] & 0x80) << 9);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 129 to 144
	value = ((uint32_t)(input[16] & 0x7f) << 25) |
			((uint32_t)input[17] << 17) |
			((uint32_t)(input[18] & 0x80) << 9);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 145 to 160
	value = ((uint32_t)(input[18] & 0x7f) << 25) |
			((uint32_t)input[19] << 17) |
			((uint32_t)(input[20] & 0x80) << 9);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 161 to 176
	value = ((uint32_t)(input[20] & 0x7f) << 25) |
			((uint32_t)input[21] << 17) |
			((uint32_t)(input[22] & 0x80) << 9);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 177 to 192
	value = ((uint32_t)(input[22] & 0x7f) << 25) |
			((uint32_t)input[23] << 17) |
			((uint32_t)(input[24] & 0x80) << 9);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 193 to 208
	value = ((uint32_t)(input[24] & 0x7f) << 25) |
			((uint32_t)input[25] << 17) |
			((uint32_t)(input[26] & 0x80) << 9);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 209 to 224
	value = ((uint32_t)(input[26] & 0x7f) << 25) |
			((uint32_t)input[27] << 17) |
			((uint32_t)(input[28] & 0x80) << 9);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 225 to 240
	value = ((uint32_t)(input[28] & 0x7f) << 25) |
			((uint32_t)input[29] << 17) |
			((uint32_t)(input[30] & 0x80) << 9);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 241 to 256
	value = ((uint32_t)(input[30] & 0x7f) << 25) |
			((uint32_t)input[31] << 17) |
			((uint32_t)(input[32] & 0x80) << 9);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 257 to 272
	value = ((uint32_t)(input[32] & 0x7f) << 25) |
			((uint32_t)input[33] << 17) |
			((uint32_t)(input[34] & 0x80) << 9);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 273 to 288
	value = ((uint32_t)(input[34] & 0x7f) << 25) |
			((uint32_t)input[35] << 17) |
			((uint32_t)(input[36] & 0x80) << 9);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 289 to 304
	value = ((uint32_t)(input[36] & 0x7f) << 25) |
			((uint32_t)input[37] << 17) |
			((uint32_t)(input[38] & 0x80) << 9);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 305 to 320
	value = ((uint32_t)(input[38] & 0x7f) << 25) |
			((uint32_t)input[39] << 17) |
			((uint32_t)(input[40] & 0x80) << 9);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 321 to 336
	value = ((uint32_t)(input[40] & 0x7f) << 25) |
			((uint32_t)input[41] << 17) |
			((uint32_t)(input[42] & 0x80) << 9);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 337 to 352
	value = ((uint32_t)(input[42] & 0x7f) << 25) |
			((uint32_t)input[43] << 17) |
			((uint32_t)(input[44] & 0x80) << 9);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 353 to 368
	value = ((uint32_t)(input[44] & 0x7f) << 25) |
			((uint32_t)input[45] << 17) |
			((uint32_t)(input[46] & 0x80) << 9);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 369 to 384
	value = ((uint32_t)(input[46] & 0x7f) << 25) |
			((uint32_t)input[47] << 17) |
			((uint32_t)(input[48] & 0x80) << 9);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 385 to 400
	value = ((uint32_t)(input[48] & 0x7f) << 25) |
			((uint32_t)input[49] << 17) |
			((uint32_t)(input[50] & 0x80) << 9);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 401 to 416
	value = ((uint32_t)(input[50] & 0x7f) << 25) |
			((uint32_t)input[51] << 17) |
			((uint32_t)(input[52] & 0x80) << 9);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 417 to 432
	value = ((uint32_t)(input[52] & 0x7f) << 25) |
			((uint32_t)input[53] << 17) |
			((uint32_t)(input[54] & 0x80) << 9);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 433 to 448
	value = ((uint32_t)(input[54] & 0x7f) << 25) |
			((uint32_t)input[55] << 17) |
			((uint32_t)(input[56] & 0x80) << 9);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 449 to 464
	value = ((uint32_t)(input[56] & 0x7f) << 25) |
			((uint32_t)input[57] << 17) |
			((uint32_t)(input[58] & 0x80) << 9);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 465 to 480
	value = ((uint32_t)(input[58] & 0x7f) << 25) |
			((uint32_t)input[59] << 17) |
			((uint32_t)(input[60] & 0x80) << 9);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 481 to 496
	value = ((uint32_t)(input[60] & 0x7f) << 25) |
			((uint32_t)input[61] << 17) |
			((uint32_t)(input[62] & 0x80) << 9);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 497 to 512
	value = ((uint32_t)(input[62] & 0x7f) << 25) |
			((uint32_t)input[63] << 17) |
			((uint32_t)(input[64] & 0x80) << 9);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 513 to 528
	value = ((uint32_t)(input[64] & 0x7f) << 25) |
			((uint32_t)input[65] << 17) |
			((uint32_t)(input[66] & 0x80) << 9);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 529 to 544
	value = ((uint32_t)(input[66] & 0x7f) << 25) |
			((uint32_t)input[67] << 17) |
			((uint32_t)(input[68] & 0x80) << 9);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 545 to 560
	value = ((uint32_t)(input[68] & 0x7f) << 25) |
			((uint32_t)input[69] << 17) |
			((uint32_t)(input[70] & 0x80) << 9);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 561 to 576
	value = ((uint32_t)(input[70] & 0x7f) << 25) |
			((uint32_t)input[71] << 17) |
			((uint32_t)(input[72] & 0x80) << 9);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 577 to 592
	value = ((uint32_t)(input[72] & 0x7f) << 25) |
			((uint32_t)input[73] << 17) |
			((uint32_t)(input[74] & 0x80) << 9);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 593 to 608
	value = ((uint32_t)(input[74] & 0x7f) << 25) |
			((uint32_t)input[75] << 17) |
			((uint32_t)(input[76] & 0x80) << 9);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 609 to 624
	value = ((uint32_t)(input[76] & 0x7f) << 25) |
			((uint32_t)input[77] << 17) |
			((uint32_t)(input[78] & 0x80) << 9);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 625 to 640
	value = ((uint32_t)(input[78] & 0x7f) << 25) |
			((uint32_t)input[79] << 17) |
			((uint32_t)(input[80] & 0x80) << 9);
	output[39] = (double)(value >> 16);

	// read output[40]: from bit 641 to 656
	value = ((uint32_t)(input[80] & 0x7f) << 25) |
			((uint32_t)input[81] << 17) |
			((uint32_t)(input[82] & 0x80) << 9);
	output[40] = (double)(value >> 16);

	// read output[41]: from bit 657 to 672
	value = ((uint32_t)(input[82] & 0x7f) << 25) |
			((uint32_t)input[83] << 17) |
			((uint32_t)(input[84] & 0x80) << 9);
	output[41] = (double)(value >> 16);

	// read output[42]: from bit 673 to 688
	value = ((uint32_t)(input[84] & 0x7f) << 25) |
			((uint32_t)input[85] << 17) |
			((uint32_t)(input[86] & 0x80) << 9);
	output[42] = (double)(value >> 16);

	// read output[43]: from bit 689 to 704
	value = ((uint32_t)(input[86] & 0x7f) << 25) |
			((uint32_t)input[87] << 17) |
			((uint32_t)(input[88] & 0x80) << 9);
	output[43] = (double)(value >> 16);

	// read output[44]: from bit 705 to 720
	value = ((uint32_t)(input[88] & 0x7f) << 25) |
			((uint32_t)input[89] << 17) |
			((uint32_t)(input[90] & 0x80) << 9);
	output[44] = (double)(value >> 16);

	// read output[45]: from bit 721 to 736
	value = ((uint32_t)(input[90] & 0x7f) << 25) |
			((uint32_t)input[91] << 17) |
			((uint32_t)(input[92] & 0x80) << 9);
	output[45] = (double)(value >> 16);
}

static void unpack_46_16bit_unsigned_1off(const uint8_t * input, double * output, void *closure) {
	// Unpack 46 values into output
	// Values are 16-bit unsigned
	// Skip 1 bits, read 736 bits of data.
	// Input must be at least 93 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 1 to 16
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)input[1] << 17) |
			((uint32_t)(input[2] & 0x80) << 9);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 17 to 32
	value = ((uint32_t)(input[2] & 0x7f) << 25) |
			((uint32_t)input[3] << 17) |
			((uint32_t)(input[4] & 0x80) << 9);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 33 to 48
	value = ((uint32_t)(input[4] & 0x7f) << 25) |
			((uint32_t)input[5] << 17) |
			((uint32_t)(input[6] & 0x80) << 9);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 49 to 64
	value = ((uint32_t)(input[6] & 0x7f) << 25) |
			((uint32_t)input[7] << 17) |
			((uint32_t)(input[8] & 0x80) << 9);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 65 to 80
	value = ((uint32_t)(input[8] & 0x7f) << 25) |
			((uint32_t)input[9] << 17) |
			((uint32_t)(input[10] & 0x80) << 9);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 81 to 96
	value = ((uint32_t)(input[10] & 0x7f) << 25) |
			((uint32_t)input[11] << 17) |
			((uint32_t)(input[12] & 0x80) << 9);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 97 to 112
	value = ((uint32_t)(input[12] & 0x7f) << 25) |
			((uint32_t)input[13] << 17) |
			((uint32_t)(input[14] & 0x80) << 9);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 113 to 128
	value = ((uint32_t)(input[14] & 0x7f) << 25) |
			((uint32_t)input[15] << 17) |
			((uint32_t)(input[16] & 0x80) << 9);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 129 to 144
	value = ((uint32_t)(input[16] & 0x7f) << 25) |
			((uint32_t)input[17] << 17) |
			((uint32_t)(input[18] & 0x80) << 9);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 145 to 160
	value = ((uint32_t)(input[18] & 0x7f) << 25) |
			((uint32_t)input[19] << 17) |
			((uint32_t)(input[20] & 0x80) << 9);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 161 to 176
	value = ((uint32_t)(input[20] & 0x7f) << 25) |
			((uint32_t)input[21] << 17) |
			((uint32_t)(input[22] & 0x80) << 9);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 177 to 192
	value = ((uint32_t)(input[22] & 0x7f) << 25) |
			((uint32_t)input[23] << 17) |
			((uint32_t)(input[24] & 0x80) << 9);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 193 to 208
	value = ((uint32_t)(input[24] & 0x7f) << 25) |
			((uint32_t)input[25] << 17) |
			((uint32_t)(input[26] & 0x80) << 9);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 209 to 224
	value = ((uint32_t)(input[26] & 0x7f) << 25) |
			((uint32_t)input[27] << 17) |
			((uint32_t)(input[28] & 0x80) << 9);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 225 to 240
	value = ((uint32_t)(input[28] & 0x7f) << 25) |
			((uint32_t)input[29] << 17) |
			((uint32_t)(input[30] & 0x80) << 9);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 241 to 256
	value = ((uint32_t)(input[30] & 0x7f) << 25) |
			((uint32_t)input[31] << 17) |
			((uint32_t)(input[32] & 0x80) << 9);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 257 to 272
	value = ((uint32_t)(input[32] & 0x7f) << 25) |
			((uint32_t)input[33] << 17) |
			((uint32_t)(input[34] & 0x80) << 9);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 273 to 288
	value = ((uint32_t)(input[34] & 0x7f) << 25) |
			((uint32_t)input[35] << 17) |
			((uint32_t)(input[36] & 0x80) << 9);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 289 to 304
	value = ((uint32_t)(input[36] & 0x7f) << 25) |
			((uint32_t)input[37] << 17) |
			((uint32_t)(input[38] & 0x80) << 9);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 305 to 320
	value = ((uint32_t)(input[38] & 0x7f) << 25) |
			((uint32_t)input[39] << 17) |
			((uint32_t)(input[40] & 0x80) << 9);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 321 to 336
	value = ((uint32_t)(input[40] & 0x7f) << 25) |
			((uint32_t)input[41] << 17) |
			((uint32_t)(input[42] & 0x80) << 9);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 337 to 352
	value = ((uint32_t)(input[42] & 0x7f) << 25) |
			((uint32_t)input[43] << 17) |
			((uint32_t)(input[44] & 0x80) << 9);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 353 to 368
	value = ((uint32_t)(input[44] & 0x7f) << 25) |
			((uint32_t)input[45] << 17) |
			((uint32_t)(input[46] & 0x80) << 9);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 369 to 384
	value = ((uint32_t)(input[46] & 0x7f) << 25) |
			((uint32_t)input[47] << 17) |
			((uint32_t)(input[48] & 0x80) << 9);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 385 to 400
	value = ((uint32_t)(input[48] & 0x7f) << 25) |
			((uint32_t)input[49] << 17) |
			((uint32_t)(input[50] & 0x80) << 9);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 401 to 416
	value = ((uint32_t)(input[50] & 0x7f) << 25) |
			((uint32_t)input[51] << 17) |
			((uint32_t)(input[52] & 0x80) << 9);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 417 to 432
	value = ((uint32_t)(input[52] & 0x7f) << 25) |
			((uint32_t)input[53] << 17) |
			((uint32_t)(input[54] & 0x80) << 9);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 433 to 448
	value = ((uint32_t)(input[54] & 0x7f) << 25) |
			((uint32_t)input[55] << 17) |
			((uint32_t)(input[56] & 0x80) << 9);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 449 to 464
	value = ((uint32_t)(input[56] & 0x7f) << 25) |
			((uint32_t)input[57] << 17) |
			((uint32_t)(input[58] & 0x80) << 9);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 465 to 480
	value = ((uint32_t)(input[58] & 0x7f) << 25) |
			((uint32_t)input[59] << 17) |
			((uint32_t)(input[60] & 0x80) << 9);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 481 to 496
	value = ((uint32_t)(input[60] & 0x7f) << 25) |
			((uint32_t)input[61] << 17) |
			((uint32_t)(input[62] & 0x80) << 9);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 497 to 512
	value = ((uint32_t)(input[62] & 0x7f) << 25) |
			((uint32_t)input[63] << 17) |
			((uint32_t)(input[64] & 0x80) << 9);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 513 to 528
	value = ((uint32_t)(input[64] & 0x7f) << 25) |
			((uint32_t)input[65] << 17) |
			((uint32_t)(input[66] & 0x80) << 9);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 529 to 544
	value = ((uint32_t)(input[66] & 0x7f) << 25) |
			((uint32_t)input[67] << 17) |
			((uint32_t)(input[68] & 0x80) << 9);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 545 to 560
	value = ((uint32_t)(input[68] & 0x7f) << 25) |
			((uint32_t)input[69] << 17) |
			((uint32_t)(input[70] & 0x80) << 9);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 561 to 576
	value = ((uint32_t)(input[70] & 0x7f) << 25) |
			((uint32_t)input[71] << 17) |
			((uint32_t)(input[72] & 0x80) << 9);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 577 to 592
	value = ((uint32_t)(input[72] & 0x7f) << 25) |
			((uint32_t)input[73] << 17) |
			((uint32_t)(input[74] & 0x80) << 9);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 593 to 608
	value = ((uint32_t)(input[74] & 0x7f) << 25) |
			((uint32_t)input[75] << 17) |
			((uint32_t)(input[76] & 0x80) << 9);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 609 to 624
	value = ((uint32_t)(input[76] & 0x7f) << 25) |
			((uint32_t)input[77] << 17) |
			((uint32_t)(input[78] & 0x80) << 9);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 625 to 640
	value = ((uint32_t)(input[78] & 0x7f) << 25) |
			((uint32_t)input[79] << 17) |
			((uint32_t)(input[80] & 0x80) << 9);
	output[39] = (double)(value >> 16);

	// read output[40]: from bit 641 to 656
	value = ((uint32_t)(input[80] & 0x7f) << 25) |
			((uint32_t)input[81] << 17) |
			((uint32_t)(input[82] & 0x80) << 9);
	output[40] = (double)(value >> 16);

	// read output[41]: from bit 657 to 672
	value = ((uint32_t)(input[82] & 0x7f) << 25) |
			((uint32_t)input[83] << 17) |
			((uint32_t)(input[84] & 0x80) << 9);
	output[41] = (double)(value >> 16);

	// read output[42]: from bit 673 to 688
	value = ((uint32_t)(input[84] & 0x7f) << 25) |
			((uint32_t)input[85] << 17) |
			((uint32_t)(input[86] & 0x80) << 9);
	output[42] = (double)(value >> 16);

	// read output[43]: from bit 689 to 704
	value = ((uint32_t)(input[86] & 0x7f) << 25) |
			((uint32_t)input[87] << 17) |
			((uint32_t)(input[88] & 0x80) << 9);
	output[43] = (double)(value >> 16);

	// read output[44]: from bit 705 to 720
	value = ((uint32_t)(input[88] & 0x7f) << 25) |
			((uint32_t)input[89] << 17) |
			((uint32_t)(input[90] & 0x80) << 9);
	output[44] = (double)(value >> 16);

	// read output[45]: from bit 721 to 736
	value = ((uint32_t)(input[90] & 0x7f) << 25) |
			((uint32_t)input[91] << 17) |
			((uint32_t)(input[92] & 0x80) << 9);
	output[45] = (double)(value >> 16);
}

static void unpack_46_16bit_signed_2off(const uint8_t * input, double * output, void *closure) {
	// Unpack 46 values into output
	// Values are 16-bit signed
	// Skip 2 bits, read 736 bits of data.
	// Input must be at least 93 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 2 to 17
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)input[1] << 18) |
			((uint32_t)(input[2] & 0xc0) << 10);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 18 to 33
	value = ((uint32_t)(input[2] & 0x3f) << 26) |
			((uint32_t)input[3] << 18) |
			((uint32_t)(input[4] & 0xc0) << 10);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 34 to 49
	value = ((uint32_t)(input[4] & 0x3f) << 26) |
			((uint32_t)input[5] << 18) |
			((uint32_t)(input[6] & 0xc0) << 10);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 50 to 65
	value = ((uint32_t)(input[6] & 0x3f) << 26) |
			((uint32_t)input[7] << 18) |
			((uint32_t)(input[8] & 0xc0) << 10);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 66 to 81
	value = ((uint32_t)(input[8] & 0x3f) << 26) |
			((uint32_t)input[9] << 18) |
			((uint32_t)(input[10] & 0xc0) << 10);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 82 to 97
	value = ((uint32_t)(input[10] & 0x3f) << 26) |
			((uint32_t)input[11] << 18) |
			((uint32_t)(input[12] & 0xc0) << 10);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 98 to 113
	value = ((uint32_t)(input[12] & 0x3f) << 26) |
			((uint32_t)input[13] << 18) |
			((uint32_t)(input[14] & 0xc0) << 10);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 114 to 129
	value = ((uint32_t)(input[14] & 0x3f) << 26) |
			((uint32_t)input[15] << 18) |
			((uint32_t)(input[16] & 0xc0) << 10);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 130 to 145
	value = ((uint32_t)(input[16] & 0x3f) << 26) |
			((uint32_t)input[17] << 18) |
			((uint32_t)(input[18] & 0xc0) << 10);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 146 to 161
	value = ((uint32_t)(input[18] & 0x3f) << 26) |
			((uint32_t)input[19] << 18) |
			((uint32_t)(input[20] & 0xc0) << 10);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 162 to 177
	value = ((uint32_t)(input[20] & 0x3f) << 26) |
			((uint32_t)input[21] << 18) |
			((uint32_t)(input[22] & 0xc0) << 10);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 178 to 193
	value = ((uint32_t)(input[22] & 0x3f) << 26) |
			((uint32_t)input[23] << 18) |
			((uint32_t)(input[24] & 0xc0) << 10);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 194 to 209
	value = ((uint32_t)(input[24] & 0x3f) << 26) |
			((uint32_t)input[25] << 18) |
			((uint32_t)(input[26] & 0xc0) << 10);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 210 to 225
	value = ((uint32_t)(input[26] & 0x3f) << 26) |
			((uint32_t)input[27] << 18) |
			((uint32_t)(input[28] & 0xc0) << 10);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 226 to 241
	value = ((uint32_t)(input[28] & 0x3f) << 26) |
			((uint32_t)input[29] << 18) |
			((uint32_t)(input[30] & 0xc0) << 10);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 242 to 257
	value = ((uint32_t)(input[30] & 0x3f) << 26) |
			((uint32_t)input[31] << 18) |
			((uint32_t)(input[32] & 0xc0) << 10);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 258 to 273
	value = ((uint32_t)(input[32] & 0x3f) << 26) |
			((uint32_t)input[33] << 18) |
			((uint32_t)(input[34] & 0xc0) << 10);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 274 to 289
	value = ((uint32_t)(input[34] & 0x3f) << 26) |
			((uint32_t)input[35] << 18) |
			((uint32_t)(input[36] & 0xc0) << 10);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 290 to 305
	value = ((uint32_t)(input[36] & 0x3f) << 26) |
			((uint32_t)input[37] << 18) |
			((uint32_t)(input[38] & 0xc0) << 10);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 306 to 321
	value = ((uint32_t)(input[38] & 0x3f) << 26) |
			((uint32_t)input[39] << 18) |
			((uint32_t)(input[40] & 0xc0) << 10);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 322 to 337
	value = ((uint32_t)(input[40] & 0x3f) << 26) |
			((uint32_t)input[41] << 18) |
			((uint32_t)(input[42] & 0xc0) << 10);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 338 to 353
	value = ((uint32_t)(input[42] & 0x3f) << 26) |
			((uint32_t)input[43] << 18) |
			((uint32_t)(input[44] & 0xc0) << 10);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 354 to 369
	value = ((uint32_t)(input[44] & 0x3f) << 26) |
			((uint32_t)input[45] << 18) |
			((uint32_t)(input[46] & 0xc0) << 10);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 370 to 385
	value = ((uint32_t)(input[46] & 0x3f) << 26) |
			((uint32_t)input[47] << 18) |
			((uint32_t)(input[48] & 0xc0) << 10);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 386 to 401
	value = ((uint32_t)(input[48] & 0x3f) << 26) |
			((uint32_t)input[49] << 18) |
			((uint32_t)(input[50] & 0xc0) << 10);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 402 to 417
	value = ((uint32_t)(input[50] & 0x3f) << 26) |
			((uint32_t)input[51] << 18) |
			((uint32_t)(input[52] & 0xc0) << 10);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 418 to 433
	value = ((uint32_t)(input[52] & 0x3f) << 26) |
			((uint32_t)input[53] << 18) |
			((uint32_t)(input[54] & 0xc0) << 10);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 434 to 449
	value = ((uint32_t)(input[54] & 0x3f) << 26) |
			((uint32_t)input[55] << 18) |
			((uint32_t)(input[56] & 0xc0) << 10);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 450 to 465
	value = ((uint32_t)(input[56] & 0x3f) << 26) |
			((uint32_t)input[57] << 18) |
			((uint32_t)(input[58] & 0xc0) << 10);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 466 to 481
	value = ((uint32_t)(input[58] & 0x3f) << 26) |
			((uint32_t)input[59] << 18) |
			((uint32_t)(input[60] & 0xc0) << 10);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 482 to 497
	value = ((uint32_t)(input[60] & 0x3f) << 26) |
			((uint32_t)input[61] << 18) |
			((uint32_t)(input[62] & 0xc0) << 10);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 498 to 513
	value = ((uint32_t)(input[62] & 0x3f) << 26) |
			((uint32_t)input[63] << 18) |
			((uint32_t)(input[64] & 0xc0) << 10);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 514 to 529
	value = ((uint32_t)(input[64] & 0x3f) << 26) |
			((uint32_t)input[65] << 18) |
			((uint32_t)(input[66] & 0xc0) << 10);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 530 to 545
	value = ((uint32_t)(input[66] & 0x3f) << 26) |
			((uint32_t)input[67] << 18) |
			((uint32_t)(input[68] & 0xc0) << 10);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 546 to 561
	value = ((uint32_t)(input[68] & 0x3f) << 26) |
			((uint32_t)input[69] << 18) |
			((uint32_t)(input[70] & 0xc0) << 10);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 562 to 577
	value = ((uint32_t)(input[70] & 0x3f) << 26) |
			((uint32_t)input[71] << 18) |
			((uint32_t)(input[72] & 0xc0) << 10);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 578 to 593
	value = ((uint32_t)(input[72] & 0x3f) << 26) |
			((uint32_t)input[73] << 18) |
			((uint32_t)(input[74] & 0xc0) << 10);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 594 to 609
	value = ((uint32_t)(input[74] & 0x3f) << 26) |
			((uint32_t)input[75] << 18) |
			((uint32_t)(input[76] & 0xc0) << 10);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 610 to 625
	value = ((uint32_t)(input[76] & 0x3f) << 26) |
			((uint32_t)input[77] << 18) |
			((uint32_t)(input[78] & 0xc0) << 10);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 626 to 641
	value = ((uint32_t)(input[78] & 0x3f) << 26) |
			((uint32_t)input[79] << 18) |
			((uint32_t)(input[80] & 0xc0) << 10);
	output[39] = (double)(value >> 16);

	// read output[40]: from bit 642 to 657
	value = ((uint32_t)(input[80] & 0x3f) << 26) |
			((uint32_t)input[81] << 18) |
			((uint32_t)(input[82] & 0xc0) << 10);
	output[40] = (double)(value >> 16);

	// read output[41]: from bit 658 to 673
	value = ((uint32_t)(input[82] & 0x3f) << 26) |
			((uint32_t)input[83] << 18) |
			((uint32_t)(input[84] & 0xc0) << 10);
	output[41] = (double)(value >> 16);

	// read output[42]: from bit 674 to 689
	value = ((uint32_t)(input[84] & 0x3f) << 26) |
			((uint32_t)input[85] << 18) |
			((uint32_t)(input[86] & 0xc0) << 10);
	output[42] = (double)(value >> 16);

	// read output[43]: from bit 690 to 705
	value = ((uint32_t)(input[86] & 0x3f) << 26) |
			((uint32_t)input[87] << 18) |
			((uint32_t)(input[88] & 0xc0) << 10);
	output[43] = (double)(value >> 16);

	// read output[44]: from bit 706 to 721
	value = ((uint32_t)(input[88] & 0x3f) << 26) |
			((uint32_t)input[89] << 18) |
			((uint32_t)(input[90] & 0xc0) << 10);
	output[44] = (double)(value >> 16);

	// read output[45]: from bit 722 to 737
	value = ((uint32_t)(input[90] & 0x3f) << 26) |
			((uint32_t)input[91] << 18) |
			((uint32_t)(input[92] & 0xc0) << 10);
	output[45] = (double)(value >> 16);
}

static void unpack_46_16bit_unsigned_2off(const uint8_t * input, double * output, void *closure) {
	// Unpack 46 values into output
	// Values are 16-bit unsigned
	// Skip 2 bits, read 736 bits of data.
	// Input must be at least 93 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 2 to 17
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)input[1] << 18) |
			((uint32_t)(input[2] & 0xc0) << 10);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 18 to 33
	value = ((uint32_t)(input[2] & 0x3f) << 26) |
			((uint32_t)input[3] << 18) |
			((uint32_t)(input[4] & 0xc0) << 10);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 34 to 49
	value = ((uint32_t)(input[4] & 0x3f) << 26) |
			((uint32_t)input[5] << 18) |
			((uint32_t)(input[6] & 0xc0) << 10);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 50 to 65
	value = ((uint32_t)(input[6] & 0x3f) << 26) |
			((uint32_t)input[7] << 18) |
			((uint32_t)(input[8] & 0xc0) << 10);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 66 to 81
	value = ((uint32_t)(input[8] & 0x3f) << 26) |
			((uint32_t)input[9] << 18) |
			((uint32_t)(input[10] & 0xc0) << 10);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 82 to 97
	value = ((uint32_t)(input[10] & 0x3f) << 26) |
			((uint32_t)input[11] << 18) |
			((uint32_t)(input[12] & 0xc0) << 10);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 98 to 113
	value = ((uint32_t)(input[12] & 0x3f) << 26) |
			((uint32_t)input[13] << 18) |
			((uint32_t)(input[14] & 0xc0) << 10);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 114 to 129
	value = ((uint32_t)(input[14] & 0x3f) << 26) |
			((uint32_t)input[15] << 18) |
			((uint32_t)(input[16] & 0xc0) << 10);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 130 to 145
	value = ((uint32_t)(input[16] & 0x3f) << 26) |
			((uint32_t)input[17] << 18) |
			((uint32_t)(input[18] & 0xc0) << 10);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 146 to 161
	value = ((uint32_t)(input[18] & 0x3f) << 26) |
			((uint32_t)input[19] << 18) |
			((uint32_t)(input[20] & 0xc0) << 10);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 162 to 177
	value = ((uint32_t)(input[20] & 0x3f) << 26) |
			((uint32_t)input[21] << 18) |
			((uint32_t)(input[22] & 0xc0) << 10);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 178 to 193
	value = ((uint32_t)(input[22] & 0x3f) << 26) |
			((uint32_t)input[23] << 18) |
			((uint32_t)(input[24] & 0xc0) << 10);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 194 to 209
	value = ((uint32_t)(input[24] & 0x3f) << 26) |
			((uint32_t)input[25] << 18) |
			((uint32_t)(input[26] & 0xc0) << 10);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 210 to 225
	value = ((uint32_t)(input[26] & 0x3f) << 26) |
			((uint32_t)input[27] << 18) |
			((uint32_t)(input[28] & 0xc0) << 10);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 226 to 241
	value = ((uint32_t)(input[28] & 0x3f) << 26) |
			((uint32_t)input[29] << 18) |
			((uint32_t)(input[30] & 0xc0) << 10);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 242 to 257
	value = ((uint32_t)(input[30] & 0x3f) << 26) |
			((uint32_t)input[31] << 18) |
			((uint32_t)(input[32] & 0xc0) << 10);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 258 to 273
	value = ((uint32_t)(input[32] & 0x3f) << 26) |
			((uint32_t)input[33] << 18) |
			((uint32_t)(input[34] & 0xc0) << 10);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 274 to 289
	value = ((uint32_t)(input[34] & 0x3f) << 26) |
			((uint32_t)input[35] << 18) |
			((uint32_t)(input[36] & 0xc0) << 10);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 290 to 305
	value = ((uint32_t)(input[36] & 0x3f) << 26) |
			((uint32_t)input[37] << 18) |
			((uint32_t)(input[38] & 0xc0) << 10);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 306 to 321
	value = ((uint32_t)(input[38] & 0x3f) << 26) |
			((uint32_t)input[39] << 18) |
			((uint32_t)(input[40] & 0xc0) << 10);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 322 to 337
	value = ((uint32_t)(input[40] & 0x3f) << 26) |
			((uint32_t)input[41] << 18) |
			((uint32_t)(input[42] & 0xc0) << 10);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 338 to 353
	value = ((uint32_t)(input[42] & 0x3f) << 26) |
			((uint32_t)input[43] << 18) |
			((uint32_t)(input[44] & 0xc0) << 10);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 354 to 369
	value = ((uint32_t)(input[44] & 0x3f) << 26) |
			((uint32_t)input[45] << 18) |
			((uint32_t)(input[46] & 0xc0) << 10);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 370 to 385
	value = ((uint32_t)(input[46] & 0x3f) << 26) |
			((uint32_t)input[47] << 18) |
			((uint32_t)(input[48] & 0xc0) << 10);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 386 to 401
	value = ((uint32_t)(input[48] & 0x3f) << 26) |
			((uint32_t)input[49] << 18) |
			((uint32_t)(input[50] & 0xc0) << 10);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 402 to 417
	value = ((uint32_t)(input[50] & 0x3f) << 26) |
			((uint32_t)input[51] << 18) |
			((uint32_t)(input[52] & 0xc0) << 10);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 418 to 433
	value = ((uint32_t)(input[52] & 0x3f) << 26) |
			((uint32_t)input[53] << 18) |
			((uint32_t)(input[54] & 0xc0) << 10);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 434 to 449
	value = ((uint32_t)(input[54] & 0x3f) << 26) |
			((uint32_t)input[55] << 18) |
			((uint32_t)(input[56] & 0xc0) << 10);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 450 to 465
	value = ((uint32_t)(input[56] & 0x3f) << 26) |
			((uint32_t)input[57] << 18) |
			((uint32_t)(input[58] & 0xc0) << 10);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 466 to 481
	value = ((uint32_t)(input[58] & 0x3f) << 26) |
			((uint32_t)input[59] << 18) |
			((uint32_t)(input[60] & 0xc0) << 10);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 482 to 497
	value = ((uint32_t)(input[60] & 0x3f) << 26) |
			((uint32_t)input[61] << 18) |
			((uint32_t)(input[62] & 0xc0) << 10);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 498 to 513
	value = ((uint32_t)(input[62] & 0x3f) << 26) |
			((uint32_t)input[63] << 18) |
			((uint32_t)(input[64] & 0xc0) << 10);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 514 to 529
	value = ((uint32_t)(input[64] & 0x3f) << 26) |
			((uint32_t)input[65] << 18) |
			((uint32_t)(input[66] & 0xc0) << 10);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 530 to 545
	value = ((uint32_t)(input[66] & 0x3f) << 26) |
			((uint32_t)input[67] << 18) |
			((uint32_t)(input[68] & 0xc0) << 10);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 546 to 561
	value = ((uint32_t)(input[68] & 0x3f) << 26) |
			((uint32_t)input[69] << 18) |
			((uint32_t)(input[70] & 0xc0) << 10);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 562 to 577
	value = ((uint32_t)(input[70] & 0x3f) << 26) |
			((uint32_t)input[71] << 18) |
			((uint32_t)(input[72] & 0xc0) << 10);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 578 to 593
	value = ((uint32_t)(input[72] & 0x3f) << 26) |
			((uint32_t)input[73] << 18) |
			((uint32_t)(input[74] & 0xc0) << 10);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 594 to 609
	value = ((uint32_t)(input[74] & 0x3f) << 26) |
			((uint32_t)input[75] << 18) |
			((uint32_t)(input[76] & 0xc0) << 10);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 610 to 625
	value = ((uint32_t)(input[76] & 0x3f) << 26) |
			((uint32_t)input[77] << 18) |
			((uint32_t)(input[78] & 0xc0) << 10);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 626 to 641
	value = ((uint32_t)(input[78] & 0x3f) << 26) |
			((uint32_t)input[79] << 18) |
			((uint32_t)(input[80] & 0xc0) << 10);
	output[39] = (double)(value >> 16);

	// read output[40]: from bit 642 to 657
	value = ((uint32_t)(input[80] & 0x3f) << 26) |
			((uint32_t)input[81] << 18) |
			((uint32_t)(input[82] & 0xc0) << 10);
	output[40] = (double)(value >> 16);

	// read output[41]: from bit 658 to 673
	value = ((uint32_t)(input[82] & 0x3f) << 26) |
			((uint32_t)input[83] << 18) |
			((uint32_t)(input[84] & 0xc0) << 10);
	output[41] = (double)(value >> 16);

	// read output[42]: from bit 674 to 689
	value = ((uint32_t)(input[84] & 0x3f) << 26) |
			((uint32_t)input[85] << 18) |
			((uint32_t)(input[86] & 0xc0) << 10);
	output[42] = (double)(value >> 16);

	// read output[43]: from bit 690 to 705
	value = ((uint32_t)(input[86] & 0x3f) << 26) |
			((uint32_t)input[87] << 18) |
			((uint32_t)(input[88] & 0xc0) << 10);
	output[43] = (double)(value >> 16);

	// read output[44]: from bit 706 to 721
	value = ((uint32_t)(input[88] & 0x3f) << 26) |
			((uint32_t)input[89] << 18) |
			((uint32_t)(input[90] & 0xc0) << 10);
	output[44] = (double)(value >> 16);

	// read output[45]: from bit 722 to 737
	value = ((uint32_t)(input[90] & 0x3f) << 26) |
			((uint32_t)input[91] << 18) |
			((uint32_t)(input[92] & 0xc0) << 10);
	output[45] = (double)(value >> 16);
}

static void unpack_46_16bit_signed_3off(const uint8_t * input, double * output, void *closure) {
	// Unpack 46 values into output
	// Values are 16-bit signed
	// Skip 3 bits, read 736 bits of data.
	// Input must be at least 93 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 3 to 18
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)input[1] << 19) |
			((uint32_t)(input[2] & 0xe0) << 11);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 19 to 34
	value = ((uint32_t)(input[2] & 0x1f) << 27) |
			((uint32_t)input[3] << 19) |
			((uint32_t)(input[4] & 0xe0) << 11);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 35 to 50
	value = ((uint32_t)(input[4] & 0x1f) << 27) |
			((uint32_t)input[5] << 19) |
			((uint32_t)(input[6] & 0xe0) << 11);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 51 to 66
	value = ((uint32_t)(input[6] & 0x1f) << 27) |
			((uint32_t)input[7] << 19) |
			((uint32_t)(input[8] & 0xe0) << 11);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 67 to 82
	value = ((uint32_t)(input[8] & 0x1f) << 27) |
			((uint32_t)input[9] << 19) |
			((uint32_t)(input[10] & 0xe0) << 11);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 83 to 98
	value = ((uint32_t)(input[10] & 0x1f) << 27) |
			((uint32_t)input[11] << 19) |
			((uint32_t)(input[12] & 0xe0) << 11);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 99 to 114
	value = ((uint32_t)(input[12] & 0x1f) << 27) |
			((uint32_t)input[13] << 19) |
			((uint32_t)(input[14] & 0xe0) << 11);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 115 to 130
	value = ((uint32_t)(input[14] & 0x1f) << 27) |
			((uint32_t)input[15] << 19) |
			((uint32_t)(input[16] & 0xe0) << 11);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 131 to 146
	value = ((uint32_t)(input[16] & 0x1f) << 27) |
			((uint32_t)input[17] << 19) |
			((uint32_t)(input[18] & 0xe0) << 11);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 147 to 162
	value = ((uint32_t)(input[18] & 0x1f) << 27) |
			((uint32_t)input[19] << 19) |
			((uint32_t)(input[20] & 0xe0) << 11);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 163 to 178
	value = ((uint32_t)(input[20] & 0x1f) << 27) |
			((uint32_t)input[21] << 19) |
			((uint32_t)(input[22] & 0xe0) << 11);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 179 to 194
	value = ((uint32_t)(input[22] & 0x1f) << 27) |
			((uint32_t)input[23] << 19) |
			((uint32_t)(input[24] & 0xe0) << 11);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 195 to 210
	value = ((uint32_t)(input[24] & 0x1f) << 27) |
			((uint32_t)input[25] << 19) |
			((uint32_t)(input[26] & 0xe0) << 11);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 211 to 226
	value = ((uint32_t)(input[26] & 0x1f) << 27) |
			((uint32_t)input[27] << 19) |
			((uint32_t)(input[28] & 0xe0) << 11);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 227 to 242
	value = ((uint32_t)(input[28] & 0x1f) << 27) |
			((uint32_t)input[29] << 19) |
			((uint32_t)(input[30] & 0xe0) << 11);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 243 to 258
	value = ((uint32_t)(input[30] & 0x1f) << 27) |
			((uint32_t)input[31] << 19) |
			((uint32_t)(input[32] & 0xe0) << 11);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 259 to 274
	value = ((uint32_t)(input[32] & 0x1f) << 27) |
			((uint32_t)input[33] << 19) |
			((uint32_t)(input[34] & 0xe0) << 11);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 275 to 290
	value = ((uint32_t)(input[34] & 0x1f) << 27) |
			((uint32_t)input[35] << 19) |
			((uint32_t)(input[36] & 0xe0) << 11);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 291 to 306
	value = ((uint32_t)(input[36] & 0x1f) << 27) |
			((uint32_t)input[37] << 19) |
			((uint32_t)(input[38] & 0xe0) << 11);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 307 to 322
	value = ((uint32_t)(input[38] & 0x1f) << 27) |
			((uint32_t)input[39] << 19) |
			((uint32_t)(input[40] & 0xe0) << 11);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 323 to 338
	value = ((uint32_t)(input[40] & 0x1f) << 27) |
			((uint32_t)input[41] << 19) |
			((uint32_t)(input[42] & 0xe0) << 11);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 339 to 354
	value = ((uint32_t)(input[42] & 0x1f) << 27) |
			((uint32_t)input[43] << 19) |
			((uint32_t)(input[44] & 0xe0) << 11);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 355 to 370
	value = ((uint32_t)(input[44] & 0x1f) << 27) |
			((uint32_t)input[45] << 19) |
			((uint32_t)(input[46] & 0xe0) << 11);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 371 to 386
	value = ((uint32_t)(input[46] & 0x1f) << 27) |
			((uint32_t)input[47] << 19) |
			((uint32_t)(input[48] & 0xe0) << 11);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 387 to 402
	value = ((uint32_t)(input[48] & 0x1f) << 27) |
			((uint32_t)input[49] << 19) |
			((uint32_t)(input[50] & 0xe0) << 11);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 403 to 418
	value = ((uint32_t)(input[50] & 0x1f) << 27) |
			((uint32_t)input[51] << 19) |
			((uint32_t)(input[52] & 0xe0) << 11);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 419 to 434
	value = ((uint32_t)(input[52] & 0x1f) << 27) |
			((uint32_t)input[53] << 19) |
			((uint32_t)(input[54] & 0xe0) << 11);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 435 to 450
	value = ((uint32_t)(input[54] & 0x1f) << 27) |
			((uint32_t)input[55] << 19) |
			((uint32_t)(input[56] & 0xe0) << 11);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 451 to 466
	value = ((uint32_t)(input[56] & 0x1f) << 27) |
			((uint32_t)input[57] << 19) |
			((uint32_t)(input[58] & 0xe0) << 11);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 467 to 482
	value = ((uint32_t)(input[58] & 0x1f) << 27) |
			((uint32_t)input[59] << 19) |
			((uint32_t)(input[60] & 0xe0) << 11);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 483 to 498
	value = ((uint32_t)(input[60] & 0x1f) << 27) |
			((uint32_t)input[61] << 19) |
			((uint32_t)(input[62] & 0xe0) << 11);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 499 to 514
	value = ((uint32_t)(input[62] & 0x1f) << 27) |
			((uint32_t)input[63] << 19) |
			((uint32_t)(input[64] & 0xe0) << 11);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 515 to 530
	value = ((uint32_t)(input[64] & 0x1f) << 27) |
			((uint32_t)input[65] << 19) |
			((uint32_t)(input[66] & 0xe0) << 11);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 531 to 546
	value = ((uint32_t)(input[66] & 0x1f) << 27) |
			((uint32_t)input[67] << 19) |
			((uint32_t)(input[68] & 0xe0) << 11);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 547 to 562
	value = ((uint32_t)(input[68] & 0x1f) << 27) |
			((uint32_t)input[69] << 19) |
			((uint32_t)(input[70] & 0xe0) << 11);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 563 to 578
	value = ((uint32_t)(input[70] & 0x1f) << 27) |
			((uint32_t)input[71] << 19) |
			((uint32_t)(input[72] & 0xe0) << 11);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 579 to 594
	value = ((uint32_t)(input[72] & 0x1f) << 27) |
			((uint32_t)input[73] << 19) |
			((uint32_t)(input[74] & 0xe0) << 11);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 595 to 610
	value = ((uint32_t)(input[74] & 0x1f) << 27) |
			((uint32_t)input[75] << 19) |
			((uint32_t)(input[76] & 0xe0) << 11);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 611 to 626
	value = ((uint32_t)(input[76] & 0x1f) << 27) |
			((uint32_t)input[77] << 19) |
			((uint32_t)(input[78] & 0xe0) << 11);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 627 to 642
	value = ((uint32_t)(input[78] & 0x1f) << 27) |
			((uint32_t)input[79] << 19) |
			((uint32_t)(input[80] & 0xe0) << 11);
	output[39] = (double)(value >> 16);

	// read output[40]: from bit 643 to 658
	value = ((uint32_t)(input[80] & 0x1f) << 27) |
			((uint32_t)input[81] << 19) |
			((uint32_t)(input[82] & 0xe0) << 11);
	output[40] = (double)(value >> 16);

	// read output[41]: from bit 659 to 674
	value = ((uint32_t)(input[82] & 0x1f) << 27) |
			((uint32_t)input[83] << 19) |
			((uint32_t)(input[84] & 0xe0) << 11);
	output[41] = (double)(value >> 16);

	// read output[42]: from bit 675 to 690
	value = ((uint32_t)(input[84] & 0x1f) << 27) |
			((uint32_t)input[85] << 19) |
			((uint32_t)(input[86] & 0xe0) << 11);
	output[42] = (double)(value >> 16);

	// read output[43]: from bit 691 to 706
	value = ((uint32_t)(input[86] & 0x1f) << 27) |
			((uint32_t)input[87] << 19) |
			((uint32_t)(input[88] & 0xe0) << 11);
	output[43] = (double)(value >> 16);

	// read output[44]: from bit 707 to 722
	value = ((uint32_t)(input[88] & 0x1f) << 27) |
			((uint32_t)input[89] << 19) |
			((uint32_t)(input[90] & 0xe0) << 11);
	output[44] = (double)(value >> 16);

	// read output[45]: from bit 723 to 738
	value = ((uint32_t)(input[90] & 0x1f) << 27) |
			((uint32_t)input[91] << 19) |
			((uint32_t)(input[92] & 0xe0) << 11);
	output[45] = (double)(value >> 16);
}

static void unpack_46_16bit_unsigned_3off(const uint8_t * input, double * output, void *closure) {
	// Unpack 46 values into output
	// Values are 16-bit unsigned
	// Skip 3 bits, read 736 bits of data.
	// Input must be at least 93 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 3 to 18
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)input[1] << 19) |
			((uint32_t)(input[2] & 0xe0) << 11);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 19 to 34
	value = ((uint32_t)(input[2] & 0x1f) << 27) |
			((uint32_t)input[3] << 19) |
			((uint32_t)(input[4] & 0xe0) << 11);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 35 to 50
	value = ((uint32_t)(input[4] & 0x1f) << 27) |
			((uint32_t)input[5] << 19) |
			((uint32_t)(input[6] & 0xe0) << 11);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 51 to 66
	value = ((uint32_t)(input[6] & 0x1f) << 27) |
			((uint32_t)input[7] << 19) |
			((uint32_t)(input[8] & 0xe0) << 11);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 67 to 82
	value = ((uint32_t)(input[8] & 0x1f) << 27) |
			((uint32_t)input[9] << 19) |
			((uint32_t)(input[10] & 0xe0) << 11);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 83 to 98
	value = ((uint32_t)(input[10] & 0x1f) << 27) |
			((uint32_t)input[11] << 19) |
			((uint32_t)(input[12] & 0xe0) << 11);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 99 to 114
	value = ((uint32_t)(input[12] & 0x1f) << 27) |
			((uint32_t)input[13] << 19) |
			((uint32_t)(input[14] & 0xe0) << 11);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 115 to 130
	value = ((uint32_t)(input[14] & 0x1f) << 27) |
			((uint32_t)input[15] << 19) |
			((uint32_t)(input[16] & 0xe0) << 11);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 131 to 146
	value = ((uint32_t)(input[16] & 0x1f) << 27) |
			((uint32_t)input[17] << 19) |
			((uint32_t)(input[18] & 0xe0) << 11);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 147 to 162
	value = ((uint32_t)(input[18] & 0x1f) << 27) |
			((uint32_t)input[19] << 19) |
			((uint32_t)(input[20] & 0xe0) << 11);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 163 to 178
	value = ((uint32_t)(input[20] & 0x1f) << 27) |
			((uint32_t)input[21] << 19) |
			((uint32_t)(input[22] & 0xe0) << 11);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 179 to 194
	value = ((uint32_t)(input[22] & 0x1f) << 27) |
			((uint32_t)input[23] << 19) |
			((uint32_t)(input[24] & 0xe0) << 11);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 195 to 210
	value = ((uint32_t)(input[24] & 0x1f) << 27) |
			((uint32_t)input[25] << 19) |
			((uint32_t)(input[26] & 0xe0) << 11);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 211 to 226
	value = ((uint32_t)(input[26] & 0x1f) << 27) |
			((uint32_t)input[27] << 19) |
			((uint32_t)(input[28] & 0xe0) << 11);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 227 to 242
	value = ((uint32_t)(input[28] & 0x1f) << 27) |
			((uint32_t)input[29] << 19) |
			((uint32_t)(input[30] & 0xe0) << 11);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 243 to 258
	value = ((uint32_t)(input[30] & 0x1f) << 27) |
			((uint32_t)input[31] << 19) |
			((uint32_t)(input[32] & 0xe0) << 11);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 259 to 274
	value = ((uint32_t)(input[32] & 0x1f) << 27) |
			((uint32_t)input[33] << 19) |
			((uint32_t)(input[34] & 0xe0) << 11);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 275 to 290
	value = ((uint32_t)(input[34] & 0x1f) << 27) |
			((uint32_t)input[35] << 19) |
			((uint32_t)(input[36] & 0xe0) << 11);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 291 to 306
	value = ((uint32_t)(input[36] & 0x1f) << 27) |
			((uint32_t)input[37] << 19) |
			((uint32_t)(input[38] & 0xe0) << 11);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 307 to 322
	value = ((uint32_t)(input[38] & 0x1f) << 27) |
			((uint32_t)input[39] << 19) |
			((uint32_t)(input[40] & 0xe0) << 11);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 323 to 338
	value = ((uint32_t)(input[40] & 0x1f) << 27) |
			((uint32_t)input[41] << 19) |
			((uint32_t)(input[42] & 0xe0) << 11);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 339 to 354
	value = ((uint32_t)(input[42] & 0x1f) << 27) |
			((uint32_t)input[43] << 19) |
			((uint32_t)(input[44] & 0xe0) << 11);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 355 to 370
	value = ((uint32_t)(input[44] & 0x1f) << 27) |
			((uint32_t)input[45] << 19) |
			((uint32_t)(input[46] & 0xe0) << 11);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 371 to 386
	value = ((uint32_t)(input[46] & 0x1f) << 27) |
			((uint32_t)input[47] << 19) |
			((uint32_t)(input[48] & 0xe0) << 11);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 387 to 402
	value = ((uint32_t)(input[48] & 0x1f) << 27) |
			((uint32_t)input[49] << 19) |
			((uint32_t)(input[50] & 0xe0) << 11);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 403 to 418
	value = ((uint32_t)(input[50] & 0x1f) << 27) |
			((uint32_t)input[51] << 19) |
			((uint32_t)(input[52] & 0xe0) << 11);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 419 to 434
	value = ((uint32_t)(input[52] & 0x1f) << 27) |
			((uint32_t)input[53] << 19) |
			((uint32_t)(input[54] & 0xe0) << 11);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 435 to 450
	value = ((uint32_t)(input[54] & 0x1f) << 27) |
			((uint32_t)input[55] << 19) |
			((uint32_t)(input[56] & 0xe0) << 11);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 451 to 466
	value = ((uint32_t)(input[56] & 0x1f) << 27) |
			((uint32_t)input[57] << 19) |
			((uint32_t)(input[58] & 0xe0) << 11);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 467 to 482
	value = ((uint32_t)(input[58] & 0x1f) << 27) |
			((uint32_t)input[59] << 19) |
			((uint32_t)(input[60] & 0xe0) << 11);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 483 to 498
	value = ((uint32_t)(input[60] & 0x1f) << 27) |
			((uint32_t)input[61] << 19) |
			((uint32_t)(input[62] & 0xe0) << 11);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 499 to 514
	value = ((uint32_t)(input[62] & 0x1f) << 27) |
			((uint32_t)input[63] << 19) |
			((uint32_t)(input[64] & 0xe0) << 11);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 515 to 530
	value = ((uint32_t)(input[64] & 0x1f) << 27) |
			((uint32_t)input[65] << 19) |
			((uint32_t)(input[66] & 0xe0) << 11);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 531 to 546
	value = ((uint32_t)(input[66] & 0x1f) << 27) |
			((uint32_t)input[67] << 19) |
			((uint32_t)(input[68] & 0xe0) << 11);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 547 to 562
	value = ((uint32_t)(input[68] & 0x1f) << 27) |
			((uint32_t)input[69] << 19) |
			((uint32_t)(input[70] & 0xe0) << 11);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 563 to 578
	value = ((uint32_t)(input[70] & 0x1f) << 27) |
			((uint32_t)input[71] << 19) |
			((uint32_t)(input[72] & 0xe0) << 11);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 579 to 594
	value = ((uint32_t)(input[72] & 0x1f) << 27) |
			((uint32_t)input[73] << 19) |
			((uint32_t)(input[74] & 0xe0) << 11);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 595 to 610
	value = ((uint32_t)(input[74] & 0x1f) << 27) |
			((uint32_t)input[75] << 19) |
			((uint32_t)(input[76] & 0xe0) << 11);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 611 to 626
	value = ((uint32_t)(input[76] & 0x1f) << 27) |
			((uint32_t)input[77] << 19) |
			((uint32_t)(input[78] & 0xe0) << 11);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 627 to 642
	value = ((uint32_t)(input[78] & 0x1f) << 27) |
			((uint32_t)input[79] << 19) |
			((uint32_t)(input[80] & 0xe0) << 11);
	output[39] = (double)(value >> 16);

	// read output[40]: from bit 643 to 658
	value = ((uint32_t)(input[80] & 0x1f) << 27) |
			((uint32_t)input[81] << 19) |
			((uint32_t)(input[82] & 0xe0) << 11);
	output[40] = (double)(value >> 16);

	// read output[41]: from bit 659 to 674
	value = ((uint32_t)(input[82] & 0x1f) << 27) |
			((uint32_t)input[83] << 19) |
			((uint32_t)(input[84] & 0xe0) << 11);
	output[41] = (double)(value >> 16);

	// read output[42]: from bit 675 to 690
	value = ((uint32_t)(input[84] & 0x1f) << 27) |
			((uint32_t)input[85] << 19) |
			((uint32_t)(input[86] & 0xe0) << 11);
	output[42] = (double)(value >> 16);

	// read output[43]: from bit 691 to 706
	value = ((uint32_t)(input[86] & 0x1f) << 27) |
			((uint32_t)input[87] << 19) |
			((uint32_t)(input[88] & 0xe0) << 11);
	output[43] = (double)(value >> 16);

	// read output[44]: from bit 707 to 722
	value = ((uint32_t)(input[88] & 0x1f) << 27) |
			((uint32_t)input[89] << 19) |
			((uint32_t)(input[90] & 0xe0) << 11);
	output[44] = (double)(value >> 16);

	// read output[45]: from bit 723 to 738
	value = ((uint32_t)(input[90] & 0x1f) << 27) |
			((uint32_t)input[91] << 19) |
			((uint32_t)(input[92] & 0xe0) << 11);
	output[45] = (double)(value >> 16);
}

static void unpack_46_16bit_signed_4off(const uint8_t * input, double * output, void *closure) {
	// Unpack 46 values into output
	// Values are 16-bit signed
	// Skip 4 bits, read 736 bits of data.
	// Input must be at least 93 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 4 to 19
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20) |
			((uint32_t)(input[2] & 0xf0) << 12);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 20 to 35
	value = ((uint32_t)(input[2] & 0x0f) << 28) |
			((uint32_t)input[3] << 20) |
			((uint32_t)(input[4] & 0xf0) << 12);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 36 to 51
	value = ((uint32_t)(input[4] & 0x0f) << 28) |
			((uint32_t)input[5] << 20) |
			((uint32_t)(input[6] & 0xf0) << 12);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 52 to 67
	value = ((uint32_t)(input[6] & 0x0f) << 28) |
			((uint32_t)input[7] << 20) |
			((uint32_t)(input[8] & 0xf0) << 12);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 68 to 83
	value = ((uint32_t)(input[8] & 0x0f) << 28) |
			((uint32_t)input[9] << 20) |
			((uint32_t)(input[10] & 0xf0) << 12);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 84 to 99
	value = ((uint32_t)(input[10] & 0x0f) << 28) |
			((uint32_t)input[11] << 20) |
			((uint32_t)(input[12] & 0xf0) << 12);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 100 to 115
	value = ((uint32_t)(input[12] & 0x0f) << 28) |
			((uint32_t)input[13] << 20) |
			((uint32_t)(input[14] & 0xf0) << 12);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 116 to 131
	value = ((uint32_t)(input[14] & 0x0f) << 28) |
			((uint32_t)input[15] << 20) |
			((uint32_t)(input[16] & 0xf0) << 12);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 132 to 147
	value = ((uint32_t)(input[16] & 0x0f) << 28) |
			((uint32_t)input[17] << 20) |
			((uint32_t)(input[18] & 0xf0) << 12);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 148 to 163
	value = ((uint32_t)(input[18] & 0x0f) << 28) |
			((uint32_t)input[19] << 20) |
			((uint32_t)(input[20] & 0xf0) << 12);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 164 to 179
	value = ((uint32_t)(input[20] & 0x0f) << 28) |
			((uint32_t)input[21] << 20) |
			((uint32_t)(input[22] & 0xf0) << 12);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 180 to 195
	value = ((uint32_t)(input[22] & 0x0f) << 28) |
			((uint32_t)input[23] << 20) |
			((uint32_t)(input[24] & 0xf0) << 12);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 196 to 211
	value = ((uint32_t)(input[24] & 0x0f) << 28) |
			((uint32_t)input[25] << 20) |
			((uint32_t)(input[26] & 0xf0) << 12);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 212 to 227
	value = ((uint32_t)(input[26] & 0x0f) << 28) |
			((uint32_t)input[27] << 20) |
			((uint32_t)(input[28] & 0xf0) << 12);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 228 to 243
	value = ((uint32_t)(input[28] & 0x0f) << 28) |
			((uint32_t)input[29] << 20) |
			((uint32_t)(input[30] & 0xf0) << 12);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 244 to 259
	value = ((uint32_t)(input[30] & 0x0f) << 28) |
			((uint32_t)input[31] << 20) |
			((uint32_t)(input[32] & 0xf0) << 12);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 260 to 275
	value = ((uint32_t)(input[32] & 0x0f) << 28) |
			((uint32_t)input[33] << 20) |
			((uint32_t)(input[34] & 0xf0) << 12);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 276 to 291
	value = ((uint32_t)(input[34] & 0x0f) << 28) |
			((uint32_t)input[35] << 20) |
			((uint32_t)(input[36] & 0xf0) << 12);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 292 to 307
	value = ((uint32_t)(input[36] & 0x0f) << 28) |
			((uint32_t)input[37] << 20) |
			((uint32_t)(input[38] & 0xf0) << 12);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 308 to 323
	value = ((uint32_t)(input[38] & 0x0f) << 28) |
			((uint32_t)input[39] << 20) |
			((uint32_t)(input[40] & 0xf0) << 12);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 324 to 339
	value = ((uint32_t)(input[40] & 0x0f) << 28) |
			((uint32_t)input[41] << 20) |
			((uint32_t)(input[42] & 0xf0) << 12);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 340 to 355
	value = ((uint32_t)(input[42] & 0x0f) << 28) |
			((uint32_t)input[43] << 20) |
			((uint32_t)(input[44] & 0xf0) << 12);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 356 to 371
	value = ((uint32_t)(input[44] & 0x0f) << 28) |
			((uint32_t)input[45] << 20) |
			((uint32_t)(input[46] & 0xf0) << 12);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 372 to 387
	value = ((uint32_t)(input[46] & 0x0f) << 28) |
			((uint32_t)input[47] << 20) |
			((uint32_t)(input[48] & 0xf0) << 12);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 388 to 403
	value = ((uint32_t)(input[48] & 0x0f) << 28) |
			((uint32_t)input[49] << 20) |
			((uint32_t)(input[50] & 0xf0) << 12);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 404 to 419
	value = ((uint32_t)(input[50] & 0x0f) << 28) |
			((uint32_t)input[51] << 20) |
			((uint32_t)(input[52] & 0xf0) << 12);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 420 to 435
	value = ((uint32_t)(input[52] & 0x0f) << 28) |
			((uint32_t)input[53] << 20) |
			((uint32_t)(input[54] & 0xf0) << 12);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 436 to 451
	value = ((uint32_t)(input[54] & 0x0f) << 28) |
			((uint32_t)input[55] << 20) |
			((uint32_t)(input[56] & 0xf0) << 12);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 452 to 467
	value = ((uint32_t)(input[56] & 0x0f) << 28) |
			((uint32_t)input[57] << 20) |
			((uint32_t)(input[58] & 0xf0) << 12);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 468 to 483
	value = ((uint32_t)(input[58] & 0x0f) << 28) |
			((uint32_t)input[59] << 20) |
			((uint32_t)(input[60] & 0xf0) << 12);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 484 to 499
	value = ((uint32_t)(input[60] & 0x0f) << 28) |
			((uint32_t)input[61] << 20) |
			((uint32_t)(input[62] & 0xf0) << 12);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 500 to 515
	value = ((uint32_t)(input[62] & 0x0f) << 28) |
			((uint32_t)input[63] << 20) |
			((uint32_t)(input[64] & 0xf0) << 12);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 516 to 531
	value = ((uint32_t)(input[64] & 0x0f) << 28) |
			((uint32_t)input[65] << 20) |
			((uint32_t)(input[66] & 0xf0) << 12);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 532 to 547
	value = ((uint32_t)(input[66] & 0x0f) << 28) |
			((uint32_t)input[67] << 20) |
			((uint32_t)(input[68] & 0xf0) << 12);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 548 to 563
	value = ((uint32_t)(input[68] & 0x0f) << 28) |
			((uint32_t)input[69] << 20) |
			((uint32_t)(input[70] & 0xf0) << 12);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 564 to 579
	value = ((uint32_t)(input[70] & 0x0f) << 28) |
			((uint32_t)input[71] << 20) |
			((uint32_t)(input[72] & 0xf0) << 12);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 580 to 595
	value = ((uint32_t)(input[72] & 0x0f) << 28) |
			((uint32_t)input[73] << 20) |
			((uint32_t)(input[74] & 0xf0) << 12);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 596 to 611
	value = ((uint32_t)(input[74] & 0x0f) << 28) |
			((uint32_t)input[75] << 20) |
			((uint32_t)(input[76] & 0xf0) << 12);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 612 to 627
	value = ((uint32_t)(input[76] & 0x0f) << 28) |
			((uint32_t)input[77] << 20) |
			((uint32_t)(input[78] & 0xf0) << 12);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 628 to 643
	value = ((uint32_t)(input[78] & 0x0f) << 28) |
			((uint32_t)input[79] << 20) |
			((uint32_t)(input[80] & 0xf0) << 12);
	output[39] = (double)(value >> 16);

	// read output[40]: from bit 644 to 659
	value = ((uint32_t)(input[80] & 0x0f) << 28) |
			((uint32_t)input[81] << 20) |
			((uint32_t)(input[82] & 0xf0) << 12);
	output[40] = (double)(value >> 16);

	// read output[41]: from bit 660 to 675
	value = ((uint32_t)(input[82] & 0x0f) << 28) |
			((uint32_t)input[83] << 20) |
			((uint32_t)(input[84] & 0xf0) << 12);
	output[41] = (double)(value >> 16);

	// read output[42]: from bit 676 to 691
	value = ((uint32_t)(input[84] & 0x0f) << 28) |
			((uint32_t)input[85] << 20) |
			((uint32_t)(input[86] & 0xf0) << 12);
	output[42] = (double)(value >> 16);

	// read output[43]: from bit 692 to 707
	value = ((uint32_t)(input[86] & 0x0f) << 28) |
			((uint32_t)input[87] << 20) |
			((uint32_t)(input[88] & 0xf0) << 12);
	output[43] = (double)(value >> 16);

	// read output[44]: from bit 708 to 723
	value = ((uint32_t)(input[88] & 0x0f) << 28) |
			((uint32_t)input[89] << 20) |
			((uint32_t)(input[90] & 0xf0) << 12);
	output[44] = (double)(value >> 16);

	// read output[45]: from bit 724 to 739
	value = ((uint32_t)(input[90] & 0x0f) << 28) |
			((uint32_t)input[91] << 20) |
			((uint32_t)(input[92] & 0xf0) << 12);
	output[45] = (double)(value >> 16);
}

static void unpack_46_16bit_unsigned_4off(const uint8_t * input, double * output, void *closure) {
	// Unpack 46 values into output
	// Values are 16-bit unsigned
	// Skip 4 bits, read 736 bits of data.
	// Input must be at least 93 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 4 to 19
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20) |
			((uint32_t)(input[2] & 0xf0) << 12);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 20 to 35
	value = ((uint32_t)(input[2] & 0x0f) << 28) |
			((uint32_t)input[3] << 20) |
			((uint32_t)(input[4] & 0xf0) << 12);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 36 to 51
	value = ((uint32_t)(input[4] & 0x0f) << 28) |
			((uint32_t)input[5] << 20) |
			((uint32_t)(input[6] & 0xf0) << 12);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 52 to 67
	value = ((uint32_t)(input[6] & 0x0f) << 28) |
			((uint32_t)input[7] << 20) |
			((uint32_t)(input[8] & 0xf0) << 12);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 68 to 83
	value = ((uint32_t)(input[8] & 0x0f) << 28) |
			((uint32_t)input[9] << 20) |
			((uint32_t)(input[10] & 0xf0) << 12);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 84 to 99
	value = ((uint32_t)(input[10] & 0x0f) << 28) |
			((uint32_t)input[11] << 20) |
			((uint32_t)(input[12] & 0xf0) << 12);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 100 to 115
	value = ((uint32_t)(input[12] & 0x0f) << 28) |
			((uint32_t)input[13] << 20) |
			((uint32_t)(input[14] & 0xf0) << 12);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 116 to 131
	value = ((uint32_t)(input[14] & 0x0f) << 28) |
			((uint32_t)input[15] << 20) |
			((uint32_t)(input[16] & 0xf0) << 12);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 132 to 147
	value = ((uint32_t)(input[16] & 0x0f) << 28) |
			((uint32_t)input[17] << 20) |
			((uint32_t)(input[18] & 0xf0) << 12);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 148 to 163
	value = ((uint32_t)(input[18] & 0x0f) << 28) |
			((uint32_t)input[19] << 20) |
			((uint32_t)(input[20] & 0xf0) << 12);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 164 to 179
	value = ((uint32_t)(input[20] & 0x0f) << 28) |
			((uint32_t)input[21] << 20) |
			((uint32_t)(input[22] & 0xf0) << 12);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 180 to 195
	value = ((uint32_t)(input[22] & 0x0f) << 28) |
			((uint32_t)input[23] << 20) |
			((uint32_t)(input[24] & 0xf0) << 12);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 196 to 211
	value = ((uint32_t)(input[24] & 0x0f) << 28) |
			((uint32_t)input[25] << 20) |
			((uint32_t)(input[26] & 0xf0) << 12);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 212 to 227
	value = ((uint32_t)(input[26] & 0x0f) << 28) |
			((uint32_t)input[27] << 20) |
			((uint32_t)(input[28] & 0xf0) << 12);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 228 to 243
	value = ((uint32_t)(input[28] & 0x0f) << 28) |
			((uint32_t)input[29] << 20) |
			((uint32_t)(input[30] & 0xf0) << 12);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 244 to 259
	value = ((uint32_t)(input[30] & 0x0f) << 28) |
			((uint32_t)input[31] << 20) |
			((uint32_t)(input[32] & 0xf0) << 12);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 260 to 275
	value = ((uint32_t)(input[32] & 0x0f) << 28) |
			((uint32_t)input[33] << 20) |
			((uint32_t)(input[34] & 0xf0) << 12);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 276 to 291
	value = ((uint32_t)(input[34] & 0x0f) << 28) |
			((uint32_t)input[35] << 20) |
			((uint32_t)(input[36] & 0xf0) << 12);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 292 to 307
	value = ((uint32_t)(input[36] & 0x0f) << 28) |
			((uint32_t)input[37] << 20) |
			((uint32_t)(input[38] & 0xf0) << 12);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 308 to 323
	value = ((uint32_t)(input[38] & 0x0f) << 28) |
			((uint32_t)input[39] << 20) |
			((uint32_t)(input[40] & 0xf0) << 12);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 324 to 339
	value = ((uint32_t)(input[40] & 0x0f) << 28) |
			((uint32_t)input[41] << 20) |
			((uint32_t)(input[42] & 0xf0) << 12);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 340 to 355
	value = ((uint32_t)(input[42] & 0x0f) << 28) |
			((uint32_t)input[43] << 20) |
			((uint32_t)(input[44] & 0xf0) << 12);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 356 to 371
	value = ((uint32_t)(input[44] & 0x0f) << 28) |
			((uint32_t)input[45] << 20) |
			((uint32_t)(input[46] & 0xf0) << 12);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 372 to 387
	value = ((uint32_t)(input[46] & 0x0f) << 28) |
			((uint32_t)input[47] << 20) |
			((uint32_t)(input[48] & 0xf0) << 12);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 388 to 403
	value = ((uint32_t)(input[48] & 0x0f) << 28) |
			((uint32_t)input[49] << 20) |
			((uint32_t)(input[50] & 0xf0) << 12);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 404 to 419
	value = ((uint32_t)(input[50] & 0x0f) << 28) |
			((uint32_t)input[51] << 20) |
			((uint32_t)(input[52] & 0xf0) << 12);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 420 to 435
	value = ((uint32_t)(input[52] & 0x0f) << 28) |
			((uint32_t)input[53] << 20) |
			((uint32_t)(input[54] & 0xf0) << 12);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 436 to 451
	value = ((uint32_t)(input[54] & 0x0f) << 28) |
			((uint32_t)input[55] << 20) |
			((uint32_t)(input[56] & 0xf0) << 12);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 452 to 467
	value = ((uint32_t)(input[56] & 0x0f) << 28) |
			((uint32_t)input[57] << 20) |
			((uint32_t)(input[58] & 0xf0) << 12);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 468 to 483
	value = ((uint32_t)(input[58] & 0x0f) << 28) |
			((uint32_t)input[59] << 20) |
			((uint32_t)(input[60] & 0xf0) << 12);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 484 to 499
	value = ((uint32_t)(input[60] & 0x0f) << 28) |
			((uint32_t)input[61] << 20) |
			((uint32_t)(input[62] & 0xf0) << 12);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 500 to 515
	value = ((uint32_t)(input[62] & 0x0f) << 28) |
			((uint32_t)input[63] << 20) |
			((uint32_t)(input[64] & 0xf0) << 12);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 516 to 531
	value = ((uint32_t)(input[64] & 0x0f) << 28) |
			((uint32_t)input[65] << 20) |
			((uint32_t)(input[66] & 0xf0) << 12);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 532 to 547
	value = ((uint32_t)(input[66] & 0x0f) << 28) |
			((uint32_t)input[67] << 20) |
			((uint32_t)(input[68] & 0xf0) << 12);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 548 to 563
	value = ((uint32_t)(input[68] & 0x0f) << 28) |
			((uint32_t)input[69] << 20) |
			((uint32_t)(input[70] & 0xf0) << 12);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 564 to 579
	value = ((uint32_t)(input[70] & 0x0f) << 28) |
			((uint32_t)input[71] << 20) |
			((uint32_t)(input[72] & 0xf0) << 12);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 580 to 595
	value = ((uint32_t)(input[72] & 0x0f) << 28) |
			((uint32_t)input[73] << 20) |
			((uint32_t)(input[74] & 0xf0) << 12);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 596 to 611
	value = ((uint32_t)(input[74] & 0x0f) << 28) |
			((uint32_t)input[75] << 20) |
			((uint32_t)(input[76] & 0xf0) << 12);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 612 to 627
	value = ((uint32_t)(input[76] & 0x0f) << 28) |
			((uint32_t)input[77] << 20) |
			((uint32_t)(input[78] & 0xf0) << 12);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 628 to 643
	value = ((uint32_t)(input[78] & 0x0f) << 28) |
			((uint32_t)input[79] << 20) |
			((uint32_t)(input[80] & 0xf0) << 12);
	output[39] = (double)(value >> 16);

	// read output[40]: from bit 644 to 659
	value = ((uint32_t)(input[80] & 0x0f) << 28) |
			((uint32_t)input[81] << 20) |
			((uint32_t)(input[82] & 0xf0) << 12);
	output[40] = (double)(value >> 16);

	// read output[41]: from bit 660 to 675
	value = ((uint32_t)(input[82] & 0x0f) << 28) |
			((uint32_t)input[83] << 20) |
			((uint32_t)(input[84] & 0xf0) << 12);
	output[41] = (double)(value >> 16);

	// read output[42]: from bit 676 to 691
	value = ((uint32_t)(input[84] & 0x0f) << 28) |
			((uint32_t)input[85] << 20) |
			((uint32_t)(input[86] & 0xf0) << 12);
	output[42] = (double)(value >> 16);

	// read output[43]: from bit 692 to 707
	value = ((uint32_t)(input[86] & 0x0f) << 28) |
			((uint32_t)input[87] << 20) |
			((uint32_t)(input[88] & 0xf0) << 12);
	output[43] = (double)(value >> 16);

	// read output[44]: from bit 708 to 723
	value = ((uint32_t)(input[88] & 0x0f) << 28) |
			((uint32_t)input[89] << 20) |
			((uint32_t)(input[90] & 0xf0) << 12);
	output[44] = (double)(value >> 16);

	// read output[45]: from bit 724 to 739
	value = ((uint32_t)(input[90] & 0x0f) << 28) |
			((uint32_t)input[91] << 20) |
			((uint32_t)(input[92] & 0xf0) << 12);
	output[45] = (double)(value >> 16);
}

static void unpack_46_16bit_signed_5off(const uint8_t * input, double * output, void *closure) {
	// Unpack 46 values into output
	// Values are 16-bit signed
	// Skip 5 bits, read 736 bits of data.
	// Input must be at least 93 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 5 to 20
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)(input[2] & 0xf8) << 13);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 21 to 36
	value = ((uint32_t)(input[2] & 0x07) << 29) |
			((uint32_t)input[3] << 21) |
			((uint32_t)(input[4] & 0xf8) << 13);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 37 to 52
	value = ((uint32_t)(input[4] & 0x07) << 29) |
			((uint32_t)input[5] << 21) |
			((uint32_t)(input[6] & 0xf8) << 13);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 53 to 68
	value = ((uint32_t)(input[6] & 0x07) << 29) |
			((uint32_t)input[7] << 21) |
			((uint32_t)(input[8] & 0xf8) << 13);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 69 to 84
	value = ((uint32_t)(input[8] & 0x07) << 29) |
			((uint32_t)input[9] << 21) |
			((uint32_t)(input[10] & 0xf8) << 13);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 85 to 100
	value = ((uint32_t)(input[10] & 0x07) << 29) |
			((uint32_t)input[11] << 21) |
			((uint32_t)(input[12] & 0xf8) << 13);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 101 to 116
	value = ((uint32_t)(input[12] & 0x07) << 29) |
			((uint32_t)input[13] << 21) |
			((uint32_t)(input[14] & 0xf8) << 13);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 117 to 132
	value = ((uint32_t)(input[14] & 0x07) << 29) |
			((uint32_t)input[15] << 21) |
			((uint32_t)(input[16] & 0xf8) << 13);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 133 to 148
	value = ((uint32_t)(input[16] & 0x07) << 29) |
			((uint32_t)input[17] << 21) |
			((uint32_t)(input[18] & 0xf8) << 13);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 149 to 164
	value = ((uint32_t)(input[18] & 0x07) << 29) |
			((uint32_t)input[19] << 21) |
			((uint32_t)(input[20] & 0xf8) << 13);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 165 to 180
	value = ((uint32_t)(input[20] & 0x07) << 29) |
			((uint32_t)input[21] << 21) |
			((uint32_t)(input[22] & 0xf8) << 13);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 181 to 196
	value = ((uint32_t)(input[22] & 0x07) << 29) |
			((uint32_t)input[23] << 21) |
			((uint32_t)(input[24] & 0xf8) << 13);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 197 to 212
	value = ((uint32_t)(input[24] & 0x07) << 29) |
			((uint32_t)input[25] << 21) |
			((uint32_t)(input[26] & 0xf8) << 13);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 213 to 228
	value = ((uint32_t)(input[26] & 0x07) << 29) |
			((uint32_t)input[27] << 21) |
			((uint32_t)(input[28] & 0xf8) << 13);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 229 to 244
	value = ((uint32_t)(input[28] & 0x07) << 29) |
			((uint32_t)input[29] << 21) |
			((uint32_t)(input[30] & 0xf8) << 13);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 245 to 260
	value = ((uint32_t)(input[30] & 0x07) << 29) |
			((uint32_t)input[31] << 21) |
			((uint32_t)(input[32] & 0xf8) << 13);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 261 to 276
	value = ((uint32_t)(input[32] & 0x07) << 29) |
			((uint32_t)input[33] << 21) |
			((uint32_t)(input[34] & 0xf8) << 13);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 277 to 292
	value = ((uint32_t)(input[34] & 0x07) << 29) |
			((uint32_t)input[35] << 21) |
			((uint32_t)(input[36] & 0xf8) << 13);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 293 to 308
	value = ((uint32_t)(input[36] & 0x07) << 29) |
			((uint32_t)input[37] << 21) |
			((uint32_t)(input[38] & 0xf8) << 13);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 309 to 324
	value = ((uint32_t)(input[38] & 0x07) << 29) |
			((uint32_t)input[39] << 21) |
			((uint32_t)(input[40] & 0xf8) << 13);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 325 to 340
	value = ((uint32_t)(input[40] & 0x07) << 29) |
			((uint32_t)input[41] << 21) |
			((uint32_t)(input[42] & 0xf8) << 13);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 341 to 356
	value = ((uint32_t)(input[42] & 0x07) << 29) |
			((uint32_t)input[43] << 21) |
			((uint32_t)(input[44] & 0xf8) << 13);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 357 to 372
	value = ((uint32_t)(input[44] & 0x07) << 29) |
			((uint32_t)input[45] << 21) |
			((uint32_t)(input[46] & 0xf8) << 13);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 373 to 388
	value = ((uint32_t)(input[46] & 0x07) << 29) |
			((uint32_t)input[47] << 21) |
			((uint32_t)(input[48] & 0xf8) << 13);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 389 to 404
	value = ((uint32_t)(input[48] & 0x07) << 29) |
			((uint32_t)input[49] << 21) |
			((uint32_t)(input[50] & 0xf8) << 13);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 405 to 420
	value = ((uint32_t)(input[50] & 0x07) << 29) |
			((uint32_t)input[51] << 21) |
			((uint32_t)(input[52] & 0xf8) << 13);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 421 to 436
	value = ((uint32_t)(input[52] & 0x07) << 29) |
			((uint32_t)input[53] << 21) |
			((uint32_t)(input[54] & 0xf8) << 13);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 437 to 452
	value = ((uint32_t)(input[54] & 0x07) << 29) |
			((uint32_t)input[55] << 21) |
			((uint32_t)(input[56] & 0xf8) << 13);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 453 to 468
	value = ((uint32_t)(input[56] & 0x07) << 29) |
			((uint32_t)input[57] << 21) |
			((uint32_t)(input[58] & 0xf8) << 13);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 469 to 484
	value = ((uint32_t)(input[58] & 0x07) << 29) |
			((uint32_t)input[59] << 21) |
			((uint32_t)(input[60] & 0xf8) << 13);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 485 to 500
	value = ((uint32_t)(input[60] & 0x07) << 29) |
			((uint32_t)input[61] << 21) |
			((uint32_t)(input[62] & 0xf8) << 13);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 501 to 516
	value = ((uint32_t)(input[62] & 0x07) << 29) |
			((uint32_t)input[63] << 21) |
			((uint32_t)(input[64] & 0xf8) << 13);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 517 to 532
	value = ((uint32_t)(input[64] & 0x07) << 29) |
			((uint32_t)input[65] << 21) |
			((uint32_t)(input[66] & 0xf8) << 13);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 533 to 548
	value = ((uint32_t)(input[66] & 0x07) << 29) |
			((uint32_t)input[67] << 21) |
			((uint32_t)(input[68] & 0xf8) << 13);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 549 to 564
	value = ((uint32_t)(input[68] & 0x07) << 29) |
			((uint32_t)input[69] << 21) |
			((uint32_t)(input[70] & 0xf8) << 13);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 565 to 580
	value = ((uint32_t)(input[70] & 0x07) << 29) |
			((uint32_t)input[71] << 21) |
			((uint32_t)(input[72] & 0xf8) << 13);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 581 to 596
	value = ((uint32_t)(input[72] & 0x07) << 29) |
			((uint32_t)input[73] << 21) |
			((uint32_t)(input[74] & 0xf8) << 13);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 597 to 612
	value = ((uint32_t)(input[74] & 0x07) << 29) |
			((uint32_t)input[75] << 21) |
			((uint32_t)(input[76] & 0xf8) << 13);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 613 to 628
	value = ((uint32_t)(input[76] & 0x07) << 29) |
			((uint32_t)input[77] << 21) |
			((uint32_t)(input[78] & 0xf8) << 13);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 629 to 644
	value = ((uint32_t)(input[78] & 0x07) << 29) |
			((uint32_t)input[79] << 21) |
			((uint32_t)(input[80] & 0xf8) << 13);
	output[39] = (double)(value >> 16);

	// read output[40]: from bit 645 to 660
	value = ((uint32_t)(input[80] & 0x07) << 29) |
			((uint32_t)input[81] << 21) |
			((uint32_t)(input[82] & 0xf8) << 13);
	output[40] = (double)(value >> 16);

	// read output[41]: from bit 661 to 676
	value = ((uint32_t)(input[82] & 0x07) << 29) |
			((uint32_t)input[83] << 21) |
			((uint32_t)(input[84] & 0xf8) << 13);
	output[41] = (double)(value >> 16);

	// read output[42]: from bit 677 to 692
	value = ((uint32_t)(input[84] & 0x07) << 29) |
			((uint32_t)input[85] << 21) |
			((uint32_t)(input[86] & 0xf8) << 13);
	output[42] = (double)(value >> 16);

	// read output[43]: from bit 693 to 708
	value = ((uint32_t)(input[86] & 0x07) << 29) |
			((uint32_t)input[87] << 21) |
			((uint32_t)(input[88] & 0xf8) << 13);
	output[43] = (double)(value >> 16);

	// read output[44]: from bit 709 to 724
	value = ((uint32_t)(input[88] & 0x07) << 29) |
			((uint32_t)input[89] << 21) |
			((uint32_t)(input[90] & 0xf8) << 13);
	output[44] = (double)(value >> 16);

	// read output[45]: from bit 725 to 740
	value = ((uint32_t)(input[90] & 0x07) << 29) |
			((uint32_t)input[91] << 21) |
			((uint32_t)(input[92] & 0xf8) << 13);
	output[45] = (double)(value >> 16);
}

static void unpack_46_16bit_unsigned_5off(const uint8_t * input, double * output, void *closure) {
	// Unpack 46 values into output
	// Values are 16-bit unsigned
	// Skip 5 bits, read 736 bits of data.
	// Input must be at least 93 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 5 to 20
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)(input[2] & 0xf8) << 13);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 21 to 36
	value = ((uint32_t)(input[2] & 0x07) << 29) |
			((uint32_t)input[3] << 21) |
			((uint32_t)(input[4] & 0xf8) << 13);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 37 to 52
	value = ((uint32_t)(input[4] & 0x07) << 29) |
			((uint32_t)input[5] << 21) |
			((uint32_t)(input[6] & 0xf8) << 13);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 53 to 68
	value = ((uint32_t)(input[6] & 0x07) << 29) |
			((uint32_t)input[7] << 21) |
			((uint32_t)(input[8] & 0xf8) << 13);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 69 to 84
	value = ((uint32_t)(input[8] & 0x07) << 29) |
			((uint32_t)input[9] << 21) |
			((uint32_t)(input[10] & 0xf8) << 13);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 85 to 100
	value = ((uint32_t)(input[10] & 0x07) << 29) |
			((uint32_t)input[11] << 21) |
			((uint32_t)(input[12] & 0xf8) << 13);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 101 to 116
	value = ((uint32_t)(input[12] & 0x07) << 29) |
			((uint32_t)input[13] << 21) |
			((uint32_t)(input[14] & 0xf8) << 13);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 117 to 132
	value = ((uint32_t)(input[14] & 0x07) << 29) |
			((uint32_t)input[15] << 21) |
			((uint32_t)(input[16] & 0xf8) << 13);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 133 to 148
	value = ((uint32_t)(input[16] & 0x07) << 29) |
			((uint32_t)input[17] << 21) |
			((uint32_t)(input[18] & 0xf8) << 13);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 149 to 164
	value = ((uint32_t)(input[18] & 0x07) << 29) |
			((uint32_t)input[19] << 21) |
			((uint32_t)(input[20] & 0xf8) << 13);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 165 to 180
	value = ((uint32_t)(input[20] & 0x07) << 29) |
			((uint32_t)input[21] << 21) |
			((uint32_t)(input[22] & 0xf8) << 13);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 181 to 196
	value = ((uint32_t)(input[22] & 0x07) << 29) |
			((uint32_t)input[23] << 21) |
			((uint32_t)(input[24] & 0xf8) << 13);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 197 to 212
	value = ((uint32_t)(input[24] & 0x07) << 29) |
			((uint32_t)input[25] << 21) |
			((uint32_t)(input[26] & 0xf8) << 13);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 213 to 228
	value = ((uint32_t)(input[26] & 0x07) << 29) |
			((uint32_t)input[27] << 21) |
			((uint32_t)(input[28] & 0xf8) << 13);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 229 to 244
	value = ((uint32_t)(input[28] & 0x07) << 29) |
			((uint32_t)input[29] << 21) |
			((uint32_t)(input[30] & 0xf8) << 13);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 245 to 260
	value = ((uint32_t)(input[30] & 0x07) << 29) |
			((uint32_t)input[31] << 21) |
			((uint32_t)(input[32] & 0xf8) << 13);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 261 to 276
	value = ((uint32_t)(input[32] & 0x07) << 29) |
			((uint32_t)input[33] << 21) |
			((uint32_t)(input[34] & 0xf8) << 13);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 277 to 292
	value = ((uint32_t)(input[34] & 0x07) << 29) |
			((uint32_t)input[35] << 21) |
			((uint32_t)(input[36] & 0xf8) << 13);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 293 to 308
	value = ((uint32_t)(input[36] & 0x07) << 29) |
			((uint32_t)input[37] << 21) |
			((uint32_t)(input[38] & 0xf8) << 13);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 309 to 324
	value = ((uint32_t)(input[38] & 0x07) << 29) |
			((uint32_t)input[39] << 21) |
			((uint32_t)(input[40] & 0xf8) << 13);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 325 to 340
	value = ((uint32_t)(input[40] & 0x07) << 29) |
			((uint32_t)input[41] << 21) |
			((uint32_t)(input[42] & 0xf8) << 13);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 341 to 356
	value = ((uint32_t)(input[42] & 0x07) << 29) |
			((uint32_t)input[43] << 21) |
			((uint32_t)(input[44] & 0xf8) << 13);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 357 to 372
	value = ((uint32_t)(input[44] & 0x07) << 29) |
			((uint32_t)input[45] << 21) |
			((uint32_t)(input[46] & 0xf8) << 13);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 373 to 388
	value = ((uint32_t)(input[46] & 0x07) << 29) |
			((uint32_t)input[47] << 21) |
			((uint32_t)(input[48] & 0xf8) << 13);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 389 to 404
	value = ((uint32_t)(input[48] & 0x07) << 29) |
			((uint32_t)input[49] << 21) |
			((uint32_t)(input[50] & 0xf8) << 13);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 405 to 420
	value = ((uint32_t)(input[50] & 0x07) << 29) |
			((uint32_t)input[51] << 21) |
			((uint32_t)(input[52] & 0xf8) << 13);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 421 to 436
	value = ((uint32_t)(input[52] & 0x07) << 29) |
			((uint32_t)input[53] << 21) |
			((uint32_t)(input[54] & 0xf8) << 13);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 437 to 452
	value = ((uint32_t)(input[54] & 0x07) << 29) |
			((uint32_t)input[55] << 21) |
			((uint32_t)(input[56] & 0xf8) << 13);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 453 to 468
	value = ((uint32_t)(input[56] & 0x07) << 29) |
			((uint32_t)input[57] << 21) |
			((uint32_t)(input[58] & 0xf8) << 13);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 469 to 484
	value = ((uint32_t)(input[58] & 0x07) << 29) |
			((uint32_t)input[59] << 21) |
			((uint32_t)(input[60] & 0xf8) << 13);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 485 to 500
	value = ((uint32_t)(input[60] & 0x07) << 29) |
			((uint32_t)input[61] << 21) |
			((uint32_t)(input[62] & 0xf8) << 13);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 501 to 516
	value = ((uint32_t)(input[62] & 0x07) << 29) |
			((uint32_t)input[63] << 21) |
			((uint32_t)(input[64] & 0xf8) << 13);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 517 to 532
	value = ((uint32_t)(input[64] & 0x07) << 29) |
			((uint32_t)input[65] << 21) |
			((uint32_t)(input[66] & 0xf8) << 13);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 533 to 548
	value = ((uint32_t)(input[66] & 0x07) << 29) |
			((uint32_t)input[67] << 21) |
			((uint32_t)(input[68] & 0xf8) << 13);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 549 to 564
	value = ((uint32_t)(input[68] & 0x07) << 29) |
			((uint32_t)input[69] << 21) |
			((uint32_t)(input[70] & 0xf8) << 13);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 565 to 580
	value = ((uint32_t)(input[70] & 0x07) << 29) |
			((uint32_t)input[71] << 21) |
			((uint32_t)(input[72] & 0xf8) << 13);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 581 to 596
	value = ((uint32_t)(input[72] & 0x07) << 29) |
			((uint32_t)input[73] << 21) |
			((uint32_t)(input[74] & 0xf8) << 13);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 597 to 612
	value = ((uint32_t)(input[74] & 0x07) << 29) |
			((uint32_t)input[75] << 21) |
			((uint32_t)(input[76] & 0xf8) << 13);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 613 to 628
	value = ((uint32_t)(input[76] & 0x07) << 29) |
			((uint32_t)input[77] << 21) |
			((uint32_t)(input[78] & 0xf8) << 13);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 629 to 644
	value = ((uint32_t)(input[78] & 0x07) << 29) |
			((uint32_t)input[79] << 21) |
			((uint32_t)(input[80] & 0xf8) << 13);
	output[39] = (double)(value >> 16);

	// read output[40]: from bit 645 to 660
	value = ((uint32_t)(input[80] & 0x07) << 29) |
			((uint32_t)input[81] << 21) |
			((uint32_t)(input[82] & 0xf8) << 13);
	output[40] = (double)(value >> 16);

	// read output[41]: from bit 661 to 676
	value = ((uint32_t)(input[82] & 0x07) << 29) |
			((uint32_t)input[83] << 21) |
			((uint32_t)(input[84] & 0xf8) << 13);
	output[41] = (double)(value >> 16);

	// read output[42]: from bit 677 to 692
	value = ((uint32_t)(input[84] & 0x07) << 29) |
			((uint32_t)input[85] << 21) |
			((uint32_t)(input[86] & 0xf8) << 13);
	output[42] = (double)(value >> 16);

	// read output[43]: from bit 693 to 708
	value = ((uint32_t)(input[86] & 0x07) << 29) |
			((uint32_t)input[87] << 21) |
			((uint32_t)(input[88] & 0xf8) << 13);
	output[43] = (double)(value >> 16);

	// read output[44]: from bit 709 to 724
	value = ((uint32_t)(input[88] & 0x07) << 29) |
			((uint32_t)input[89] << 21) |
			((uint32_t)(input[90] & 0xf8) << 13);
	output[44] = (double)(value >> 16);

	// read output[45]: from bit 725 to 740
	value = ((uint32_t)(input[90] & 0x07) << 29) |
			((uint32_t)input[91] << 21) |
			((uint32_t)(input[92] & 0xf8) << 13);
	output[45] = (double)(value >> 16);
}

static void unpack_46_16bit_signed_6off(const uint8_t * input, double * output, void *closure) {
	// Unpack 46 values into output
	// Values are 16-bit signed
	// Skip 6 bits, read 736 bits of data.
	// Input must be at least 93 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 6 to 21
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)(input[2] & 0xfc) << 14);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 22 to 37
	value = ((uint32_t)(input[2] & 0x03) << 30) |
			((uint32_t)input[3] << 22) |
			((uint32_t)(input[4] & 0xfc) << 14);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 38 to 53
	value = ((uint32_t)(input[4] & 0x03) << 30) |
			((uint32_t)input[5] << 22) |
			((uint32_t)(input[6] & 0xfc) << 14);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 54 to 69
	value = ((uint32_t)(input[6] & 0x03) << 30) |
			((uint32_t)input[7] << 22) |
			((uint32_t)(input[8] & 0xfc) << 14);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 70 to 85
	value = ((uint32_t)(input[8] & 0x03) << 30) |
			((uint32_t)input[9] << 22) |
			((uint32_t)(input[10] & 0xfc) << 14);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 86 to 101
	value = ((uint32_t)(input[10] & 0x03) << 30) |
			((uint32_t)input[11] << 22) |
			((uint32_t)(input[12] & 0xfc) << 14);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 102 to 117
	value = ((uint32_t)(input[12] & 0x03) << 30) |
			((uint32_t)input[13] << 22) |
			((uint32_t)(input[14] & 0xfc) << 14);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 118 to 133
	value = ((uint32_t)(input[14] & 0x03) << 30) |
			((uint32_t)input[15] << 22) |
			((uint32_t)(input[16] & 0xfc) << 14);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 134 to 149
	value = ((uint32_t)(input[16] & 0x03) << 30) |
			((uint32_t)input[17] << 22) |
			((uint32_t)(input[18] & 0xfc) << 14);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 150 to 165
	value = ((uint32_t)(input[18] & 0x03) << 30) |
			((uint32_t)input[19] << 22) |
			((uint32_t)(input[20] & 0xfc) << 14);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 166 to 181
	value = ((uint32_t)(input[20] & 0x03) << 30) |
			((uint32_t)input[21] << 22) |
			((uint32_t)(input[22] & 0xfc) << 14);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 182 to 197
	value = ((uint32_t)(input[22] & 0x03) << 30) |
			((uint32_t)input[23] << 22) |
			((uint32_t)(input[24] & 0xfc) << 14);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 198 to 213
	value = ((uint32_t)(input[24] & 0x03) << 30) |
			((uint32_t)input[25] << 22) |
			((uint32_t)(input[26] & 0xfc) << 14);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 214 to 229
	value = ((uint32_t)(input[26] & 0x03) << 30) |
			((uint32_t)input[27] << 22) |
			((uint32_t)(input[28] & 0xfc) << 14);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 230 to 245
	value = ((uint32_t)(input[28] & 0x03) << 30) |
			((uint32_t)input[29] << 22) |
			((uint32_t)(input[30] & 0xfc) << 14);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 246 to 261
	value = ((uint32_t)(input[30] & 0x03) << 30) |
			((uint32_t)input[31] << 22) |
			((uint32_t)(input[32] & 0xfc) << 14);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 262 to 277
	value = ((uint32_t)(input[32] & 0x03) << 30) |
			((uint32_t)input[33] << 22) |
			((uint32_t)(input[34] & 0xfc) << 14);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 278 to 293
	value = ((uint32_t)(input[34] & 0x03) << 30) |
			((uint32_t)input[35] << 22) |
			((uint32_t)(input[36] & 0xfc) << 14);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 294 to 309
	value = ((uint32_t)(input[36] & 0x03) << 30) |
			((uint32_t)input[37] << 22) |
			((uint32_t)(input[38] & 0xfc) << 14);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 310 to 325
	value = ((uint32_t)(input[38] & 0x03) << 30) |
			((uint32_t)input[39] << 22) |
			((uint32_t)(input[40] & 0xfc) << 14);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 326 to 341
	value = ((uint32_t)(input[40] & 0x03) << 30) |
			((uint32_t)input[41] << 22) |
			((uint32_t)(input[42] & 0xfc) << 14);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 342 to 357
	value = ((uint32_t)(input[42] & 0x03) << 30) |
			((uint32_t)input[43] << 22) |
			((uint32_t)(input[44] & 0xfc) << 14);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 358 to 373
	value = ((uint32_t)(input[44] & 0x03) << 30) |
			((uint32_t)input[45] << 22) |
			((uint32_t)(input[46] & 0xfc) << 14);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 374 to 389
	value = ((uint32_t)(input[46] & 0x03) << 30) |
			((uint32_t)input[47] << 22) |
			((uint32_t)(input[48] & 0xfc) << 14);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 390 to 405
	value = ((uint32_t)(input[48] & 0x03) << 30) |
			((uint32_t)input[49] << 22) |
			((uint32_t)(input[50] & 0xfc) << 14);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 406 to 421
	value = ((uint32_t)(input[50] & 0x03) << 30) |
			((uint32_t)input[51] << 22) |
			((uint32_t)(input[52] & 0xfc) << 14);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 422 to 437
	value = ((uint32_t)(input[52] & 0x03) << 30) |
			((uint32_t)input[53] << 22) |
			((uint32_t)(input[54] & 0xfc) << 14);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 438 to 453
	value = ((uint32_t)(input[54] & 0x03) << 30) |
			((uint32_t)input[55] << 22) |
			((uint32_t)(input[56] & 0xfc) << 14);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 454 to 469
	value = ((uint32_t)(input[56] & 0x03) << 30) |
			((uint32_t)input[57] << 22) |
			((uint32_t)(input[58] & 0xfc) << 14);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 470 to 485
	value = ((uint32_t)(input[58] & 0x03) << 30) |
			((uint32_t)input[59] << 22) |
			((uint32_t)(input[60] & 0xfc) << 14);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 486 to 501
	value = ((uint32_t)(input[60] & 0x03) << 30) |
			((uint32_t)input[61] << 22) |
			((uint32_t)(input[62] & 0xfc) << 14);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 502 to 517
	value = ((uint32_t)(input[62] & 0x03) << 30) |
			((uint32_t)input[63] << 22) |
			((uint32_t)(input[64] & 0xfc) << 14);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 518 to 533
	value = ((uint32_t)(input[64] & 0x03) << 30) |
			((uint32_t)input[65] << 22) |
			((uint32_t)(input[66] & 0xfc) << 14);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 534 to 549
	value = ((uint32_t)(input[66] & 0x03) << 30) |
			((uint32_t)input[67] << 22) |
			((uint32_t)(input[68] & 0xfc) << 14);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 550 to 565
	value = ((uint32_t)(input[68] & 0x03) << 30) |
			((uint32_t)input[69] << 22) |
			((uint32_t)(input[70] & 0xfc) << 14);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 566 to 581
	value = ((uint32_t)(input[70] & 0x03) << 30) |
			((uint32_t)input[71] << 22) |
			((uint32_t)(input[72] & 0xfc) << 14);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 582 to 597
	value = ((uint32_t)(input[72] & 0x03) << 30) |
			((uint32_t)input[73] << 22) |
			((uint32_t)(input[74] & 0xfc) << 14);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 598 to 613
	value = ((uint32_t)(input[74] & 0x03) << 30) |
			((uint32_t)input[75] << 22) |
			((uint32_t)(input[76] & 0xfc) << 14);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 614 to 629
	value = ((uint32_t)(input[76] & 0x03) << 30) |
			((uint32_t)input[77] << 22) |
			((uint32_t)(input[78] & 0xfc) << 14);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 630 to 645
	value = ((uint32_t)(input[78] & 0x03) << 30) |
			((uint32_t)input[79] << 22) |
			((uint32_t)(input[80] & 0xfc) << 14);
	output[39] = (double)(value >> 16);

	// read output[40]: from bit 646 to 661
	value = ((uint32_t)(input[80] & 0x03) << 30) |
			((uint32_t)input[81] << 22) |
			((uint32_t)(input[82] & 0xfc) << 14);
	output[40] = (double)(value >> 16);

	// read output[41]: from bit 662 to 677
	value = ((uint32_t)(input[82] & 0x03) << 30) |
			((uint32_t)input[83] << 22) |
			((uint32_t)(input[84] & 0xfc) << 14);
	output[41] = (double)(value >> 16);

	// read output[42]: from bit 678 to 693
	value = ((uint32_t)(input[84] & 0x03) << 30) |
			((uint32_t)input[85] << 22) |
			((uint32_t)(input[86] & 0xfc) << 14);
	output[42] = (double)(value >> 16);

	// read output[43]: from bit 694 to 709
	value = ((uint32_t)(input[86] & 0x03) << 30) |
			((uint32_t)input[87] << 22) |
			((uint32_t)(input[88] & 0xfc) << 14);
	output[43] = (double)(value >> 16);

	// read output[44]: from bit 710 to 725
	value = ((uint32_t)(input[88] & 0x03) << 30) |
			((uint32_t)input[89] << 22) |
			((uint32_t)(input[90] & 0xfc) << 14);
	output[44] = (double)(value >> 16);

	// read output[45]: from bit 726 to 741
	value = ((uint32_t)(input[90] & 0x03) << 30) |
			((uint32_t)input[91] << 22) |
			((uint32_t)(input[92] & 0xfc) << 14);
	output[45] = (double)(value >> 16);
}

static void unpack_46_16bit_unsigned_6off(const uint8_t * input, double * output, void *closure) {
	// Unpack 46 values into output
	// Values are 16-bit unsigned
	// Skip 6 bits, read 736 bits of data.
	// Input must be at least 93 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 6 to 21
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)(input[2] & 0xfc) << 14);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 22 to 37
	value = ((uint32_t)(input[2] & 0x03) << 30) |
			((uint32_t)input[3] << 22) |
			((uint32_t)(input[4] & 0xfc) << 14);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 38 to 53
	value = ((uint32_t)(input[4] & 0x03) << 30) |
			((uint32_t)input[5] << 22) |
			((uint32_t)(input[6] & 0xfc) << 14);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 54 to 69
	value = ((uint32_t)(input[6] & 0x03) << 30) |
			((uint32_t)input[7] << 22) |
			((uint32_t)(input[8] & 0xfc) << 14);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 70 to 85
	value = ((uint32_t)(input[8] & 0x03) << 30) |
			((uint32_t)input[9] << 22) |
			((uint32_t)(input[10] & 0xfc) << 14);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 86 to 101
	value = ((uint32_t)(input[10] & 0x03) << 30) |
			((uint32_t)input[11] << 22) |
			((uint32_t)(input[12] & 0xfc) << 14);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 102 to 117
	value = ((uint32_t)(input[12] & 0x03) << 30) |
			((uint32_t)input[13] << 22) |
			((uint32_t)(input[14] & 0xfc) << 14);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 118 to 133
	value = ((uint32_t)(input[14] & 0x03) << 30) |
			((uint32_t)input[15] << 22) |
			((uint32_t)(input[16] & 0xfc) << 14);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 134 to 149
	value = ((uint32_t)(input[16] & 0x03) << 30) |
			((uint32_t)input[17] << 22) |
			((uint32_t)(input[18] & 0xfc) << 14);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 150 to 165
	value = ((uint32_t)(input[18] & 0x03) << 30) |
			((uint32_t)input[19] << 22) |
			((uint32_t)(input[20] & 0xfc) << 14);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 166 to 181
	value = ((uint32_t)(input[20] & 0x03) << 30) |
			((uint32_t)input[21] << 22) |
			((uint32_t)(input[22] & 0xfc) << 14);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 182 to 197
	value = ((uint32_t)(input[22] & 0x03) << 30) |
			((uint32_t)input[23] << 22) |
			((uint32_t)(input[24] & 0xfc) << 14);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 198 to 213
	value = ((uint32_t)(input[24] & 0x03) << 30) |
			((uint32_t)input[25] << 22) |
			((uint32_t)(input[26] & 0xfc) << 14);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 214 to 229
	value = ((uint32_t)(input[26] & 0x03) << 30) |
			((uint32_t)input[27] << 22) |
			((uint32_t)(input[28] & 0xfc) << 14);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 230 to 245
	value = ((uint32_t)(input[28] & 0x03) << 30) |
			((uint32_t)input[29] << 22) |
			((uint32_t)(input[30] & 0xfc) << 14);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 246 to 261
	value = ((uint32_t)(input[30] & 0x03) << 30) |
			((uint32_t)input[31] << 22) |
			((uint32_t)(input[32] & 0xfc) << 14);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 262 to 277
	value = ((uint32_t)(input[32] & 0x03) << 30) |
			((uint32_t)input[33] << 22) |
			((uint32_t)(input[34] & 0xfc) << 14);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 278 to 293
	value = ((uint32_t)(input[34] & 0x03) << 30) |
			((uint32_t)input[35] << 22) |
			((uint32_t)(input[36] & 0xfc) << 14);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 294 to 309
	value = ((uint32_t)(input[36] & 0x03) << 30) |
			((uint32_t)input[37] << 22) |
			((uint32_t)(input[38] & 0xfc) << 14);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 310 to 325
	value = ((uint32_t)(input[38] & 0x03) << 30) |
			((uint32_t)input[39] << 22) |
			((uint32_t)(input[40] & 0xfc) << 14);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 326 to 341
	value = ((uint32_t)(input[40] & 0x03) << 30) |
			((uint32_t)input[41] << 22) |
			((uint32_t)(input[42] & 0xfc) << 14);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 342 to 357
	value = ((uint32_t)(input[42] & 0x03) << 30) |
			((uint32_t)input[43] << 22) |
			((uint32_t)(input[44] & 0xfc) << 14);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 358 to 373
	value = ((uint32_t)(input[44] & 0x03) << 30) |
			((uint32_t)input[45] << 22) |
			((uint32_t)(input[46] & 0xfc) << 14);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 374 to 389
	value = ((uint32_t)(input[46] & 0x03) << 30) |
			((uint32_t)input[47] << 22) |
			((uint32_t)(input[48] & 0xfc) << 14);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 390 to 405
	value = ((uint32_t)(input[48] & 0x03) << 30) |
			((uint32_t)input[49] << 22) |
			((uint32_t)(input[50] & 0xfc) << 14);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 406 to 421
	value = ((uint32_t)(input[50] & 0x03) << 30) |
			((uint32_t)input[51] << 22) |
			((uint32_t)(input[52] & 0xfc) << 14);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 422 to 437
	value = ((uint32_t)(input[52] & 0x03) << 30) |
			((uint32_t)input[53] << 22) |
			((uint32_t)(input[54] & 0xfc) << 14);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 438 to 453
	value = ((uint32_t)(input[54] & 0x03) << 30) |
			((uint32_t)input[55] << 22) |
			((uint32_t)(input[56] & 0xfc) << 14);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 454 to 469
	value = ((uint32_t)(input[56] & 0x03) << 30) |
			((uint32_t)input[57] << 22) |
			((uint32_t)(input[58] & 0xfc) << 14);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 470 to 485
	value = ((uint32_t)(input[58] & 0x03) << 30) |
			((uint32_t)input[59] << 22) |
			((uint32_t)(input[60] & 0xfc) << 14);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 486 to 501
	value = ((uint32_t)(input[60] & 0x03) << 30) |
			((uint32_t)input[61] << 22) |
			((uint32_t)(input[62] & 0xfc) << 14);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 502 to 517
	value = ((uint32_t)(input[62] & 0x03) << 30) |
			((uint32_t)input[63] << 22) |
			((uint32_t)(input[64] & 0xfc) << 14);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 518 to 533
	value = ((uint32_t)(input[64] & 0x03) << 30) |
			((uint32_t)input[65] << 22) |
			((uint32_t)(input[66] & 0xfc) << 14);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 534 to 549
	value = ((uint32_t)(input[66] & 0x03) << 30) |
			((uint32_t)input[67] << 22) |
			((uint32_t)(input[68] & 0xfc) << 14);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 550 to 565
	value = ((uint32_t)(input[68] & 0x03) << 30) |
			((uint32_t)input[69] << 22) |
			((uint32_t)(input[70] & 0xfc) << 14);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 566 to 581
	value = ((uint32_t)(input[70] & 0x03) << 30) |
			((uint32_t)input[71] << 22) |
			((uint32_t)(input[72] & 0xfc) << 14);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 582 to 597
	value = ((uint32_t)(input[72] & 0x03) << 30) |
			((uint32_t)input[73] << 22) |
			((uint32_t)(input[74] & 0xfc) << 14);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 598 to 613
	value = ((uint32_t)(input[74] & 0x03) << 30) |
			((uint32_t)input[75] << 22) |
			((uint32_t)(input[76] & 0xfc) << 14);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 614 to 629
	value = ((uint32_t)(input[76] & 0x03) << 30) |
			((uint32_t)input[77] << 22) |
			((uint32_t)(input[78] & 0xfc) << 14);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 630 to 645
	value = ((uint32_t)(input[78] & 0x03) << 30) |
			((uint32_t)input[79] << 22) |
			((uint32_t)(input[80] & 0xfc) << 14);
	output[39] = (double)(value >> 16);

	// read output[40]: from bit 646 to 661
	value = ((uint32_t)(input[80] & 0x03) << 30) |
			((uint32_t)input[81] << 22) |
			((uint32_t)(input[82] & 0xfc) << 14);
	output[40] = (double)(value >> 16);

	// read output[41]: from bit 662 to 677
	value = ((uint32_t)(input[82] & 0x03) << 30) |
			((uint32_t)input[83] << 22) |
			((uint32_t)(input[84] & 0xfc) << 14);
	output[41] = (double)(value >> 16);

	// read output[42]: from bit 678 to 693
	value = ((uint32_t)(input[84] & 0x03) << 30) |
			((uint32_t)input[85] << 22) |
			((uint32_t)(input[86] & 0xfc) << 14);
	output[42] = (double)(value >> 16);

	// read output[43]: from bit 694 to 709
	value = ((uint32_t)(input[86] & 0x03) << 30) |
			((uint32_t)input[87] << 22) |
			((uint32_t)(input[88] & 0xfc) << 14);
	output[43] = (double)(value >> 16);

	// read output[44]: from bit 710 to 725
	value = ((uint32_t)(input[88] & 0x03) << 30) |
			((uint32_t)input[89] << 22) |
			((uint32_t)(input[90] & 0xfc) << 14);
	output[44] = (double)(value >> 16);

	// read output[45]: from bit 726 to 741
	value = ((uint32_t)(input[90] & 0x03) << 30) |
			((uint32_t)input[91] << 22) |
			((uint32_t)(input[92] & 0xfc) << 14);
	output[45] = (double)(value >> 16);
}

static void unpack_46_16bit_signed_7off(const uint8_t * input, double * output, void *closure) {
	// Unpack 46 values into output
	// Values are 16-bit signed
	// Skip 7 bits, read 736 bits of data.
	// Input must be at least 93 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 7 to 22
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)(input[2] & 0xfe) << 15);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 23 to 38
	value = ((uint32_t)(input[2] & 0x01) << 31) |
			((uint32_t)input[3] << 23) |
			((uint32_t)(input[4] & 0xfe) << 15);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 39 to 54
	value = ((uint32_t)(input[4] & 0x01) << 31) |
			((uint32_t)input[5] << 23) |
			((uint32_t)(input[6] & 0xfe) << 15);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 55 to 70
	value = ((uint32_t)(input[6] & 0x01) << 31) |
			((uint32_t)input[7] << 23) |
			((uint32_t)(input[8] & 0xfe) << 15);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 71 to 86
	value = ((uint32_t)(input[8] & 0x01) << 31) |
			((uint32_t)input[9] << 23) |
			((uint32_t)(input[10] & 0xfe) << 15);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 87 to 102
	value = ((uint32_t)(input[10] & 0x01) << 31) |
			((uint32_t)input[11] << 23) |
			((uint32_t)(input[12] & 0xfe) << 15);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 103 to 118
	value = ((uint32_t)(input[12] & 0x01) << 31) |
			((uint32_t)input[13] << 23) |
			((uint32_t)(input[14] & 0xfe) << 15);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 119 to 134
	value = ((uint32_t)(input[14] & 0x01) << 31) |
			((uint32_t)input[15] << 23) |
			((uint32_t)(input[16] & 0xfe) << 15);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 135 to 150
	value = ((uint32_t)(input[16] & 0x01) << 31) |
			((uint32_t)input[17] << 23) |
			((uint32_t)(input[18] & 0xfe) << 15);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 151 to 166
	value = ((uint32_t)(input[18] & 0x01) << 31) |
			((uint32_t)input[19] << 23) |
			((uint32_t)(input[20] & 0xfe) << 15);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 167 to 182
	value = ((uint32_t)(input[20] & 0x01) << 31) |
			((uint32_t)input[21] << 23) |
			((uint32_t)(input[22] & 0xfe) << 15);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 183 to 198
	value = ((uint32_t)(input[22] & 0x01) << 31) |
			((uint32_t)input[23] << 23) |
			((uint32_t)(input[24] & 0xfe) << 15);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 199 to 214
	value = ((uint32_t)(input[24] & 0x01) << 31) |
			((uint32_t)input[25] << 23) |
			((uint32_t)(input[26] & 0xfe) << 15);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 215 to 230
	value = ((uint32_t)(input[26] & 0x01) << 31) |
			((uint32_t)input[27] << 23) |
			((uint32_t)(input[28] & 0xfe) << 15);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 231 to 246
	value = ((uint32_t)(input[28] & 0x01) << 31) |
			((uint32_t)input[29] << 23) |
			((uint32_t)(input[30] & 0xfe) << 15);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 247 to 262
	value = ((uint32_t)(input[30] & 0x01) << 31) |
			((uint32_t)input[31] << 23) |
			((uint32_t)(input[32] & 0xfe) << 15);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 263 to 278
	value = ((uint32_t)(input[32] & 0x01) << 31) |
			((uint32_t)input[33] << 23) |
			((uint32_t)(input[34] & 0xfe) << 15);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 279 to 294
	value = ((uint32_t)(input[34] & 0x01) << 31) |
			((uint32_t)input[35] << 23) |
			((uint32_t)(input[36] & 0xfe) << 15);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 295 to 310
	value = ((uint32_t)(input[36] & 0x01) << 31) |
			((uint32_t)input[37] << 23) |
			((uint32_t)(input[38] & 0xfe) << 15);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 311 to 326
	value = ((uint32_t)(input[38] & 0x01) << 31) |
			((uint32_t)input[39] << 23) |
			((uint32_t)(input[40] & 0xfe) << 15);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 327 to 342
	value = ((uint32_t)(input[40] & 0x01) << 31) |
			((uint32_t)input[41] << 23) |
			((uint32_t)(input[42] & 0xfe) << 15);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 343 to 358
	value = ((uint32_t)(input[42] & 0x01) << 31) |
			((uint32_t)input[43] << 23) |
			((uint32_t)(input[44] & 0xfe) << 15);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 359 to 374
	value = ((uint32_t)(input[44] & 0x01) << 31) |
			((uint32_t)input[45] << 23) |
			((uint32_t)(input[46] & 0xfe) << 15);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 375 to 390
	value = ((uint32_t)(input[46] & 0x01) << 31) |
			((uint32_t)input[47] << 23) |
			((uint32_t)(input[48] & 0xfe) << 15);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 391 to 406
	value = ((uint32_t)(input[48] & 0x01) << 31) |
			((uint32_t)input[49] << 23) |
			((uint32_t)(input[50] & 0xfe) << 15);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 407 to 422
	value = ((uint32_t)(input[50] & 0x01) << 31) |
			((uint32_t)input[51] << 23) |
			((uint32_t)(input[52] & 0xfe) << 15);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 423 to 438
	value = ((uint32_t)(input[52] & 0x01) << 31) |
			((uint32_t)input[53] << 23) |
			((uint32_t)(input[54] & 0xfe) << 15);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 439 to 454
	value = ((uint32_t)(input[54] & 0x01) << 31) |
			((uint32_t)input[55] << 23) |
			((uint32_t)(input[56] & 0xfe) << 15);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 455 to 470
	value = ((uint32_t)(input[56] & 0x01) << 31) |
			((uint32_t)input[57] << 23) |
			((uint32_t)(input[58] & 0xfe) << 15);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 471 to 486
	value = ((uint32_t)(input[58] & 0x01) << 31) |
			((uint32_t)input[59] << 23) |
			((uint32_t)(input[60] & 0xfe) << 15);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 487 to 502
	value = ((uint32_t)(input[60] & 0x01) << 31) |
			((uint32_t)input[61] << 23) |
			((uint32_t)(input[62] & 0xfe) << 15);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 503 to 518
	value = ((uint32_t)(input[62] & 0x01) << 31) |
			((uint32_t)input[63] << 23) |
			((uint32_t)(input[64] & 0xfe) << 15);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 519 to 534
	value = ((uint32_t)(input[64] & 0x01) << 31) |
			((uint32_t)input[65] << 23) |
			((uint32_t)(input[66] & 0xfe) << 15);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 535 to 550
	value = ((uint32_t)(input[66] & 0x01) << 31) |
			((uint32_t)input[67] << 23) |
			((uint32_t)(input[68] & 0xfe) << 15);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 551 to 566
	value = ((uint32_t)(input[68] & 0x01) << 31) |
			((uint32_t)input[69] << 23) |
			((uint32_t)(input[70] & 0xfe) << 15);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 567 to 582
	value = ((uint32_t)(input[70] & 0x01) << 31) |
			((uint32_t)input[71] << 23) |
			((uint32_t)(input[72] & 0xfe) << 15);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 583 to 598
	value = ((uint32_t)(input[72] & 0x01) << 31) |
			((uint32_t)input[73] << 23) |
			((uint32_t)(input[74] & 0xfe) << 15);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 599 to 614
	value = ((uint32_t)(input[74] & 0x01) << 31) |
			((uint32_t)input[75] << 23) |
			((uint32_t)(input[76] & 0xfe) << 15);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 615 to 630
	value = ((uint32_t)(input[76] & 0x01) << 31) |
			((uint32_t)input[77] << 23) |
			((uint32_t)(input[78] & 0xfe) << 15);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 631 to 646
	value = ((uint32_t)(input[78] & 0x01) << 31) |
			((uint32_t)input[79] << 23) |
			((uint32_t)(input[80] & 0xfe) << 15);
	output[39] = (double)(value >> 16);

	// read output[40]: from bit 647 to 662
	value = ((uint32_t)(input[80] & 0x01) << 31) |
			((uint32_t)input[81] << 23) |
			((uint32_t)(input[82] & 0xfe) << 15);
	output[40] = (double)(value >> 16);

	// read output[41]: from bit 663 to 678
	value = ((uint32_t)(input[82] & 0x01) << 31) |
			((uint32_t)input[83] << 23) |
			((uint32_t)(input[84] & 0xfe) << 15);
	output[41] = (double)(value >> 16);

	// read output[42]: from bit 679 to 694
	value = ((uint32_t)(input[84] & 0x01) << 31) |
			((uint32_t)input[85] << 23) |
			((uint32_t)(input[86] & 0xfe) << 15);
	output[42] = (double)(value >> 16);

	// read output[43]: from bit 695 to 710
	value = ((uint32_t)(input[86] & 0x01) << 31) |
			((uint32_t)input[87] << 23) |
			((uint32_t)(input[88] & 0xfe) << 15);
	output[43] = (double)(value >> 16);

	// read output[44]: from bit 711 to 726
	value = ((uint32_t)(input[88] & 0x01) << 31) |
			((uint32_t)input[89] << 23) |
			((uint32_t)(input[90] & 0xfe) << 15);
	output[44] = (double)(value >> 16);

	// read output[45]: from bit 727 to 742
	value = ((uint32_t)(input[90] & 0x01) << 31) |
			((uint32_t)input[91] << 23) |
			((uint32_t)(input[92] & 0xfe) << 15);
	output[45] = (double)(value >> 16);
}

static void unpack_46_16bit_unsigned_7off(const uint8_t * input, double * output, void *closure) {
	// Unpack 46 values into output
	// Values are 16-bit unsigned
	// Skip 7 bits, read 736 bits of data.
	// Input must be at least 93 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 7 to 22
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)(input[2] & 0xfe) << 15);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 23 to 38
	value = ((uint32_t)(input[2] & 0x01) << 31) |
			((uint32_t)input[3] << 23) |
			((uint32_t)(input[4] & 0xfe) << 15);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 39 to 54
	value = ((uint32_t)(input[4] & 0x01) << 31) |
			((uint32_t)input[5] << 23) |
			((uint32_t)(input[6] & 0xfe) << 15);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 55 to 70
	value = ((uint32_t)(input[6] & 0x01) << 31) |
			((uint32_t)input[7] << 23) |
			((uint32_t)(input[8] & 0xfe) << 15);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 71 to 86
	value = ((uint32_t)(input[8] & 0x01) << 31) |
			((uint32_t)input[9] << 23) |
			((uint32_t)(input[10] & 0xfe) << 15);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 87 to 102
	value = ((uint32_t)(input[10] & 0x01) << 31) |
			((uint32_t)input[11] << 23) |
			((uint32_t)(input[12] & 0xfe) << 15);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 103 to 118
	value = ((uint32_t)(input[12] & 0x01) << 31) |
			((uint32_t)input[13] << 23) |
			((uint32_t)(input[14] & 0xfe) << 15);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 119 to 134
	value = ((uint32_t)(input[14] & 0x01) << 31) |
			((uint32_t)input[15] << 23) |
			((uint32_t)(input[16] & 0xfe) << 15);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 135 to 150
	value = ((uint32_t)(input[16] & 0x01) << 31) |
			((uint32_t)input[17] << 23) |
			((uint32_t)(input[18] & 0xfe) << 15);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 151 to 166
	value = ((uint32_t)(input[18] & 0x01) << 31) |
			((uint32_t)input[19] << 23) |
			((uint32_t)(input[20] & 0xfe) << 15);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 167 to 182
	value = ((uint32_t)(input[20] & 0x01) << 31) |
			((uint32_t)input[21] << 23) |
			((uint32_t)(input[22] & 0xfe) << 15);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 183 to 198
	value = ((uint32_t)(input[22] & 0x01) << 31) |
			((uint32_t)input[23] << 23) |
			((uint32_t)(input[24] & 0xfe) << 15);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 199 to 214
	value = ((uint32_t)(input[24] & 0x01) << 31) |
			((uint32_t)input[25] << 23) |
			((uint32_t)(input[26] & 0xfe) << 15);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 215 to 230
	value = ((uint32_t)(input[26] & 0x01) << 31) |
			((uint32_t)input[27] << 23) |
			((uint32_t)(input[28] & 0xfe) << 15);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 231 to 246
	value = ((uint32_t)(input[28] & 0x01) << 31) |
			((uint32_t)input[29] << 23) |
			((uint32_t)(input[30] & 0xfe) << 15);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 247 to 262
	value = ((uint32_t)(input[30] & 0x01) << 31) |
			((uint32_t)input[31] << 23) |
			((uint32_t)(input[32] & 0xfe) << 15);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 263 to 278
	value = ((uint32_t)(input[32] & 0x01) << 31) |
			((uint32_t)input[33] << 23) |
			((uint32_t)(input[34] & 0xfe) << 15);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 279 to 294
	value = ((uint32_t)(input[34] & 0x01) << 31) |
			((uint32_t)input[35] << 23) |
			((uint32_t)(input[36] & 0xfe) << 15);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 295 to 310
	value = ((uint32_t)(input[36] & 0x01) << 31) |
			((uint32_t)input[37] << 23) |
			((uint32_t)(input[38] & 0xfe) << 15);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 311 to 326
	value = ((uint32_t)(input[38] & 0x01) << 31) |
			((uint32_t)input[39] << 23) |
			((uint32_t)(input[40] & 0xfe) << 15);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 327 to 342
	value = ((uint32_t)(input[40] & 0x01) << 31) |
			((uint32_t)input[41] << 23) |
			((uint32_t)(input[42] & 0xfe) << 15);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 343 to 358
	value = ((uint32_t)(input[42] & 0x01) << 31) |
			((uint32_t)input[43] << 23) |
			((uint32_t)(input[44] & 0xfe) << 15);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 359 to 374
	value = ((uint32_t)(input[44] & 0x01) << 31) |
			((uint32_t)input[45] << 23) |
			((uint32_t)(input[46] & 0xfe) << 15);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 375 to 390
	value = ((uint32_t)(input[46] & 0x01) << 31) |
			((uint32_t)input[47] << 23) |
			((uint32_t)(input[48] & 0xfe) << 15);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 391 to 406
	value = ((uint32_t)(input[48] & 0x01) << 31) |
			((uint32_t)input[49] << 23) |
			((uint32_t)(input[50] & 0xfe) << 15);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 407 to 422
	value = ((uint32_t)(input[50] & 0x01) << 31) |
			((uint32_t)input[51] << 23) |
			((uint32_t)(input[52] & 0xfe) << 15);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 423 to 438
	value = ((uint32_t)(input[52] & 0x01) << 31) |
			((uint32_t)input[53] << 23) |
			((uint32_t)(input[54] & 0xfe) << 15);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 439 to 454
	value = ((uint32_t)(input[54] & 0x01) << 31) |
			((uint32_t)input[55] << 23) |
			((uint32_t)(input[56] & 0xfe) << 15);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 455 to 470
	value = ((uint32_t)(input[56] & 0x01) << 31) |
			((uint32_t)input[57] << 23) |
			((uint32_t)(input[58] & 0xfe) << 15);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 471 to 486
	value = ((uint32_t)(input[58] & 0x01) << 31) |
			((uint32_t)input[59] << 23) |
			((uint32_t)(input[60] & 0xfe) << 15);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 487 to 502
	value = ((uint32_t)(input[60] & 0x01) << 31) |
			((uint32_t)input[61] << 23) |
			((uint32_t)(input[62] & 0xfe) << 15);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 503 to 518
	value = ((uint32_t)(input[62] & 0x01) << 31) |
			((uint32_t)input[63] << 23) |
			((uint32_t)(input[64] & 0xfe) << 15);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 519 to 534
	value = ((uint32_t)(input[64] & 0x01) << 31) |
			((uint32_t)input[65] << 23) |
			((uint32_t)(input[66] & 0xfe) << 15);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 535 to 550
	value = ((uint32_t)(input[66] & 0x01) << 31) |
			((uint32_t)input[67] << 23) |
			((uint32_t)(input[68] & 0xfe) << 15);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 551 to 566
	value = ((uint32_t)(input[68] & 0x01) << 31) |
			((uint32_t)input[69] << 23) |
			((uint32_t)(input[70] & 0xfe) << 15);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 567 to 582
	value = ((uint32_t)(input[70] & 0x01) << 31) |
			((uint32_t)input[71] << 23) |
			((uint32_t)(input[72] & 0xfe) << 15);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 583 to 598
	value = ((uint32_t)(input[72] & 0x01) << 31) |
			((uint32_t)input[73] << 23) |
			((uint32_t)(input[74] & 0xfe) << 15);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 599 to 614
	value = ((uint32_t)(input[74] & 0x01) << 31) |
			((uint32_t)input[75] << 23) |
			((uint32_t)(input[76] & 0xfe) << 15);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 615 to 630
	value = ((uint32_t)(input[76] & 0x01) << 31) |
			((uint32_t)input[77] << 23) |
			((uint32_t)(input[78] & 0xfe) << 15);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 631 to 646
	value = ((uint32_t)(input[78] & 0x01) << 31) |
			((uint32_t)input[79] << 23) |
			((uint32_t)(input[80] & 0xfe) << 15);
	output[39] = (double)(value >> 16);

	// read output[40]: from bit 647 to 662
	value = ((uint32_t)(input[80] & 0x01) << 31) |
			((uint32_t)input[81] << 23) |
			((uint32_t)(input[82] & 0xfe) << 15);
	output[40] = (double)(value >> 16);

	// read output[41]: from bit 663 to 678
	value = ((uint32_t)(input[82] & 0x01) << 31) |
			((uint32_t)input[83] << 23) |
			((uint32_t)(input[84] & 0xfe) << 15);
	output[41] = (double)(value >> 16);

	// read output[42]: from bit 679 to 694
	value = ((uint32_t)(input[84] & 0x01) << 31) |
			((uint32_t)input[85] << 23) |
			((uint32_t)(input[86] & 0xfe) << 15);
	output[42] = (double)(value >> 16);

	// read output[43]: from bit 695 to 710
	value = ((uint32_t)(input[86] & 0x01) << 31) |
			((uint32_t)input[87] << 23) |
			((uint32_t)(input[88] & 0xfe) << 15);
	output[43] = (double)(value >> 16);

	// read output[44]: from bit 711 to 726
	value = ((uint32_t)(input[88] & 0x01) << 31) |
			((uint32_t)input[89] << 23) |
			((uint32_t)(input[90] & 0xfe) << 15);
	output[44] = (double)(value >> 16);

	// read output[45]: from bit 727 to 742
	value = ((uint32_t)(input[90] & 0x01) << 31) |
			((uint32_t)input[91] << 23) |
			((uint32_t)(input[92] & 0xfe) << 15);
	output[45] = (double)(value >> 16);
}

static void unpack_47_16bit_signed_0off(const uint8_t * input, double * output, void *closure) {
	// Unpack 47 values into output
	// Values are 16-bit signed
	// Skip 0 bits, read 752 bits of data.
	// Input must be at least 94 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 0 to 15
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)input[1] << 16);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 16 to 31
	value = ((uint32_t)input[2] << 24) |
			((uint32_t)input[3] << 16);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 32 to 47
	value = ((uint32_t)input[4] << 24) |
			((uint32_t)input[5] << 16);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 48 to 63
	value = ((uint32_t)input[6] << 24) |
			((uint32_t)input[7] << 16);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 64 to 79
	value = ((uint32_t)input[8] << 24) |
			((uint32_t)input[9] << 16);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 80 to 95
	value = ((uint32_t)input[10] << 24) |
			((uint32_t)input[11] << 16);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 96 to 111
	value = ((uint32_t)input[12] << 24) |
			((uint32_t)input[13] << 16);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 112 to 127
	value = ((uint32_t)input[14] << 24) |
			((uint32_t)input[15] << 16);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 128 to 143
	value = ((uint32_t)input[16] << 24) |
			((uint32_t)input[17] << 16);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 144 to 159
	value = ((uint32_t)input[18] << 24) |
			((uint32_t)input[19] << 16);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 160 to 175
	value = ((uint32_t)input[20] << 24) |
			((uint32_t)input[21] << 16);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 176 to 191
	value = ((uint32_t)input[22] << 24) |
			((uint32_t)input[23] << 16);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 192 to 207
	value = ((uint32_t)input[24] << 24) |
			((uint32_t)input[25] << 16);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 208 to 223
	value = ((uint32_t)input[26] << 24) |
			((uint32_t)input[27] << 16);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 224 to 239
	value = ((uint32_t)input[28] << 24) |
			((uint32_t)input[29] << 16);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 240 to 255
	value = ((uint32_t)input[30] << 24) |
			((uint32_t)input[31] << 16);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 256 to 271
	value = ((uint32_t)input[32] << 24) |
			((uint32_t)input[33] << 16);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 272 to 287
	value = ((uint32_t)input[34] << 24) |
			((uint32_t)input[35] << 16);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 288 to 303
	value = ((uint32_t)input[36] << 24) |
			((uint32_t)input[37] << 16);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 304 to 319
	value = ((uint32_t)input[38] << 24) |
			((uint32_t)input[39] << 16);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 320 to 335
	value = ((uint32_t)input[40] << 24) |
			((uint32_t)input[41] << 16);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 336 to 351
	value = ((uint32_t)input[42] << 24) |
			((uint32_t)input[43] << 16);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 352 to 367
	value = ((uint32_t)input[44] << 24) |
			((uint32_t)input[45] << 16);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 368 to 383
	value = ((uint32_t)input[46] << 24) |
			((uint32_t)input[47] << 16);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 384 to 399
	value = ((uint32_t)input[48] << 24) |
			((uint32_t)input[49] << 16);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 400 to 415
	value = ((uint32_t)input[50] << 24) |
			((uint32_t)input[51] << 16);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 416 to 431
	value = ((uint32_t)input[52] << 24) |
			((uint32_t)input[53] << 16);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 432 to 447
	value = ((uint32_t)input[54] << 24) |
			((uint32_t)input[55] << 16);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 448 to 463
	value = ((uint32_t)input[56] << 24) |
			((uint32_t)input[57] << 16);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 464 to 479
	value = ((uint32_t)input[58] << 24) |
			((uint32_t)input[59] << 16);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 480 to 495
	value = ((uint32_t)input[60] << 24) |
			((uint32_t)input[61] << 16);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 496 to 511
	value = ((uint32_t)input[62] << 24) |
			((uint32_t)input[63] << 16);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 512 to 527
	value = ((uint32_t)input[64] << 24) |
			((uint32_t)input[65] << 16);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 528 to 543
	value = ((uint32_t)input[66] << 24) |
			((uint32_t)input[67] << 16);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 544 to 559
	value = ((uint32_t)input[68] << 24) |
			((uint32_t)input[69] << 16);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 560 to 575
	value = ((uint32_t)input[70] << 24) |
			((uint32_t)input[71] << 16);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 576 to 591
	value = ((uint32_t)input[72] << 24) |
			((uint32_t)input[73] << 16);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 592 to 607
	value = ((uint32_t)input[74] << 24) |
			((uint32_t)input[75] << 16);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 608 to 623
	value = ((uint32_t)input[76] << 24) |
			((uint32_t)input[77] << 16);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 624 to 639
	value = ((uint32_t)input[78] << 24) |
			((uint32_t)input[79] << 16);
	output[39] = (double)(value >> 16);

	// read output[40]: from bit 640 to 655
	value = ((uint32_t)input[80] << 24) |
			((uint32_t)input[81] << 16);
	output[40] = (double)(value >> 16);

	// read output[41]: from bit 656 to 671
	value = ((uint32_t)input[82] << 24) |
			((uint32_t)input[83] << 16);
	output[41] = (double)(value >> 16);

	// read output[42]: from bit 672 to 687
	value = ((uint32_t)input[84] << 24) |
			((uint32_t)input[85] << 16);
	output[42] = (double)(value >> 16);

	// read output[43]: from bit 688 to 703
	value = ((uint32_t)input[86] << 24) |
			((uint32_t)input[87] << 16);
	output[43] = (double)(value >> 16);

	// read output[44]: from bit 704 to 719
	value = ((uint32_t)input[88] << 24) |
			((uint32_t)input[89] << 16);
	output[44] = (double)(value >> 16);

	// read output[45]: from bit 720 to 735
	value = ((uint32_t)input[90] << 24) |
			((uint32_t)input[91] << 16);
	output[45] = (double)(value >> 16);

	// read output[46]: from bit 736 to 751
	value = ((uint32_t)input[92] << 24) |
			((uint32_t)input[93] << 16);
	output[46] = (double)(value >> 16);
}

static void unpack_47_16bit_unsigned_0off(const uint8_t * input, double * output, void *closure) {
	// Unpack 47 values into output
	// Values are 16-bit unsigned
	// Skip 0 bits, read 752 bits of data.
	// Input must be at least 94 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 0 to 15
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)input[1] << 16);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 16 to 31
	value = ((uint32_t)input[2] << 24) |
			((uint32_t)input[3] << 16);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 32 to 47
	value = ((uint32_t)input[4] << 24) |
			((uint32_t)input[5] << 16);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 48 to 63
	value = ((uint32_t)input[6] << 24) |
			((uint32_t)input[7] << 16);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 64 to 79
	value = ((uint32_t)input[8] << 24) |
			((uint32_t)input[9] << 16);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 80 to 95
	value = ((uint32_t)input[10] << 24) |
			((uint32_t)input[11] << 16);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 96 to 111
	value = ((uint32_t)input[12] << 24) |
			((uint32_t)input[13] << 16);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 112 to 127
	value = ((uint32_t)input[14] << 24) |
			((uint32_t)input[15] << 16);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 128 to 143
	value = ((uint32_t)input[16] << 24) |
			((uint32_t)input[17] << 16);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 144 to 159
	value = ((uint32_t)input[18] << 24) |
			((uint32_t)input[19] << 16);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 160 to 175
	value = ((uint32_t)input[20] << 24) |
			((uint32_t)input[21] << 16);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 176 to 191
	value = ((uint32_t)input[22] << 24) |
			((uint32_t)input[23] << 16);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 192 to 207
	value = ((uint32_t)input[24] << 24) |
			((uint32_t)input[25] << 16);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 208 to 223
	value = ((uint32_t)input[26] << 24) |
			((uint32_t)input[27] << 16);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 224 to 239
	value = ((uint32_t)input[28] << 24) |
			((uint32_t)input[29] << 16);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 240 to 255
	value = ((uint32_t)input[30] << 24) |
			((uint32_t)input[31] << 16);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 256 to 271
	value = ((uint32_t)input[32] << 24) |
			((uint32_t)input[33] << 16);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 272 to 287
	value = ((uint32_t)input[34] << 24) |
			((uint32_t)input[35] << 16);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 288 to 303
	value = ((uint32_t)input[36] << 24) |
			((uint32_t)input[37] << 16);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 304 to 319
	value = ((uint32_t)input[38] << 24) |
			((uint32_t)input[39] << 16);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 320 to 335
	value = ((uint32_t)input[40] << 24) |
			((uint32_t)input[41] << 16);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 336 to 351
	value = ((uint32_t)input[42] << 24) |
			((uint32_t)input[43] << 16);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 352 to 367
	value = ((uint32_t)input[44] << 24) |
			((uint32_t)input[45] << 16);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 368 to 383
	value = ((uint32_t)input[46] << 24) |
			((uint32_t)input[47] << 16);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 384 to 399
	value = ((uint32_t)input[48] << 24) |
			((uint32_t)input[49] << 16);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 400 to 415
	value = ((uint32_t)input[50] << 24) |
			((uint32_t)input[51] << 16);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 416 to 431
	value = ((uint32_t)input[52] << 24) |
			((uint32_t)input[53] << 16);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 432 to 447
	value = ((uint32_t)input[54] << 24) |
			((uint32_t)input[55] << 16);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 448 to 463
	value = ((uint32_t)input[56] << 24) |
			((uint32_t)input[57] << 16);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 464 to 479
	value = ((uint32_t)input[58] << 24) |
			((uint32_t)input[59] << 16);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 480 to 495
	value = ((uint32_t)input[60] << 24) |
			((uint32_t)input[61] << 16);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 496 to 511
	value = ((uint32_t)input[62] << 24) |
			((uint32_t)input[63] << 16);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 512 to 527
	value = ((uint32_t)input[64] << 24) |
			((uint32_t)input[65] << 16);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 528 to 543
	value = ((uint32_t)input[66] << 24) |
			((uint32_t)input[67] << 16);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 544 to 559
	value = ((uint32_t)input[68] << 24) |
			((uint32_t)input[69] << 16);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 560 to 575
	value = ((uint32_t)input[70] << 24) |
			((uint32_t)input[71] << 16);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 576 to 591
	value = ((uint32_t)input[72] << 24) |
			((uint32_t)input[73] << 16);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 592 to 607
	value = ((uint32_t)input[74] << 24) |
			((uint32_t)input[75] << 16);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 608 to 623
	value = ((uint32_t)input[76] << 24) |
			((uint32_t)input[77] << 16);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 624 to 639
	value = ((uint32_t)input[78] << 24) |
			((uint32_t)input[79] << 16);
	output[39] = (double)(value >> 16);

	// read output[40]: from bit 640 to 655
	value = ((uint32_t)input[80] << 24) |
			((uint32_t)input[81] << 16);
	output[40] = (double)(value >> 16);

	// read output[41]: from bit 656 to 671
	value = ((uint32_t)input[82] << 24) |
			((uint32_t)input[83] << 16);
	output[41] = (double)(value >> 16);

	// read output[42]: from bit 672 to 687
	value = ((uint32_t)input[84] << 24) |
			((uint32_t)input[85] << 16);
	output[42] = (double)(value >> 16);

	// read output[43]: from bit 688 to 703
	value = ((uint32_t)input[86] << 24) |
			((uint32_t)input[87] << 16);
	output[43] = (double)(value >> 16);

	// read output[44]: from bit 704 to 719
	value = ((uint32_t)input[88] << 24) |
			((uint32_t)input[89] << 16);
	output[44] = (double)(value >> 16);

	// read output[45]: from bit 720 to 735
	value = ((uint32_t)input[90] << 24) |
			((uint32_t)input[91] << 16);
	output[45] = (double)(value >> 16);

	// read output[46]: from bit 736 to 751
	value = ((uint32_t)input[92] << 24) |
			((uint32_t)input[93] << 16);
	output[46] = (double)(value >> 16);
}

static void unpack_47_16bit_signed_1off(const uint8_t * input, double * output, void *closure) {
	// Unpack 47 values into output
	// Values are 16-bit signed
	// Skip 1 bits, read 752 bits of data.
	// Input must be at least 95 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 1 to 16
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)input[1] << 17) |
			((uint32_t)(input[2] & 0x80) << 9);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 17 to 32
	value = ((uint32_t)(input[2] & 0x7f) << 25) |
			((uint32_t)input[3] << 17) |
			((uint32_t)(input[4] & 0x80) << 9);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 33 to 48
	value = ((uint32_t)(input[4] & 0x7f) << 25) |
			((uint32_t)input[5] << 17) |
			((uint32_t)(input[6] & 0x80) << 9);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 49 to 64
	value = ((uint32_t)(input[6] & 0x7f) << 25) |
			((uint32_t)input[7] << 17) |
			((uint32_t)(input[8] & 0x80) << 9);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 65 to 80
	value = ((uint32_t)(input[8] & 0x7f) << 25) |
			((uint32_t)input[9] << 17) |
			((uint32_t)(input[10] & 0x80) << 9);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 81 to 96
	value = ((uint32_t)(input[10] & 0x7f) << 25) |
			((uint32_t)input[11] << 17) |
			((uint32_t)(input[12] & 0x80) << 9);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 97 to 112
	value = ((uint32_t)(input[12] & 0x7f) << 25) |
			((uint32_t)input[13] << 17) |
			((uint32_t)(input[14] & 0x80) << 9);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 113 to 128
	value = ((uint32_t)(input[14] & 0x7f) << 25) |
			((uint32_t)input[15] << 17) |
			((uint32_t)(input[16] & 0x80) << 9);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 129 to 144
	value = ((uint32_t)(input[16] & 0x7f) << 25) |
			((uint32_t)input[17] << 17) |
			((uint32_t)(input[18] & 0x80) << 9);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 145 to 160
	value = ((uint32_t)(input[18] & 0x7f) << 25) |
			((uint32_t)input[19] << 17) |
			((uint32_t)(input[20] & 0x80) << 9);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 161 to 176
	value = ((uint32_t)(input[20] & 0x7f) << 25) |
			((uint32_t)input[21] << 17) |
			((uint32_t)(input[22] & 0x80) << 9);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 177 to 192
	value = ((uint32_t)(input[22] & 0x7f) << 25) |
			((uint32_t)input[23] << 17) |
			((uint32_t)(input[24] & 0x80) << 9);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 193 to 208
	value = ((uint32_t)(input[24] & 0x7f) << 25) |
			((uint32_t)input[25] << 17) |
			((uint32_t)(input[26] & 0x80) << 9);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 209 to 224
	value = ((uint32_t)(input[26] & 0x7f) << 25) |
			((uint32_t)input[27] << 17) |
			((uint32_t)(input[28] & 0x80) << 9);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 225 to 240
	value = ((uint32_t)(input[28] & 0x7f) << 25) |
			((uint32_t)input[29] << 17) |
			((uint32_t)(input[30] & 0x80) << 9);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 241 to 256
	value = ((uint32_t)(input[30] & 0x7f) << 25) |
			((uint32_t)input[31] << 17) |
			((uint32_t)(input[32] & 0x80) << 9);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 257 to 272
	value = ((uint32_t)(input[32] & 0x7f) << 25) |
			((uint32_t)input[33] << 17) |
			((uint32_t)(input[34] & 0x80) << 9);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 273 to 288
	value = ((uint32_t)(input[34] & 0x7f) << 25) |
			((uint32_t)input[35] << 17) |
			((uint32_t)(input[36] & 0x80) << 9);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 289 to 304
	value = ((uint32_t)(input[36] & 0x7f) << 25) |
			((uint32_t)input[37] << 17) |
			((uint32_t)(input[38] & 0x80) << 9);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 305 to 320
	value = ((uint32_t)(input[38] & 0x7f) << 25) |
			((uint32_t)input[39] << 17) |
			((uint32_t)(input[40] & 0x80) << 9);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 321 to 336
	value = ((uint32_t)(input[40] & 0x7f) << 25) |
			((uint32_t)input[41] << 17) |
			((uint32_t)(input[42] & 0x80) << 9);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 337 to 352
	value = ((uint32_t)(input[42] & 0x7f) << 25) |
			((uint32_t)input[43] << 17) |
			((uint32_t)(input[44] & 0x80) << 9);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 353 to 368
	value = ((uint32_t)(input[44] & 0x7f) << 25) |
			((uint32_t)input[45] << 17) |
			((uint32_t)(input[46] & 0x80) << 9);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 369 to 384
	value = ((uint32_t)(input[46] & 0x7f) << 25) |
			((uint32_t)input[47] << 17) |
			((uint32_t)(input[48] & 0x80) << 9);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 385 to 400
	value = ((uint32_t)(input[48] & 0x7f) << 25) |
			((uint32_t)input[49] << 17) |
			((uint32_t)(input[50] & 0x80) << 9);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 401 to 416
	value = ((uint32_t)(input[50] & 0x7f) << 25) |
			((uint32_t)input[51] << 17) |
			((uint32_t)(input[52] & 0x80) << 9);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 417 to 432
	value = ((uint32_t)(input[52] & 0x7f) << 25) |
			((uint32_t)input[53] << 17) |
			((uint32_t)(input[54] & 0x80) << 9);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 433 to 448
	value = ((uint32_t)(input[54] & 0x7f) << 25) |
			((uint32_t)input[55] << 17) |
			((uint32_t)(input[56] & 0x80) << 9);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 449 to 464
	value = ((uint32_t)(input[56] & 0x7f) << 25) |
			((uint32_t)input[57] << 17) |
			((uint32_t)(input[58] & 0x80) << 9);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 465 to 480
	value = ((uint32_t)(input[58] & 0x7f) << 25) |
			((uint32_t)input[59] << 17) |
			((uint32_t)(input[60] & 0x80) << 9);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 481 to 496
	value = ((uint32_t)(input[60] & 0x7f) << 25) |
			((uint32_t)input[61] << 17) |
			((uint32_t)(input[62] & 0x80) << 9);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 497 to 512
	value = ((uint32_t)(input[62] & 0x7f) << 25) |
			((uint32_t)input[63] << 17) |
			((uint32_t)(input[64] & 0x80) << 9);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 513 to 528
	value = ((uint32_t)(input[64] & 0x7f) << 25) |
			((uint32_t)input[65] << 17) |
			((uint32_t)(input[66] & 0x80) << 9);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 529 to 544
	value = ((uint32_t)(input[66] & 0x7f) << 25) |
			((uint32_t)input[67] << 17) |
			((uint32_t)(input[68] & 0x80) << 9);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 545 to 560
	value = ((uint32_t)(input[68] & 0x7f) << 25) |
			((uint32_t)input[69] << 17) |
			((uint32_t)(input[70] & 0x80) << 9);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 561 to 576
	value = ((uint32_t)(input[70] & 0x7f) << 25) |
			((uint32_t)input[71] << 17) |
			((uint32_t)(input[72] & 0x80) << 9);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 577 to 592
	value = ((uint32_t)(input[72] & 0x7f) << 25) |
			((uint32_t)input[73] << 17) |
			((uint32_t)(input[74] & 0x80) << 9);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 593 to 608
	value = ((uint32_t)(input[74] & 0x7f) << 25) |
			((uint32_t)input[75] << 17) |
			((uint32_t)(input[76] & 0x80) << 9);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 609 to 624
	value = ((uint32_t)(input[76] & 0x7f) << 25) |
			((uint32_t)input[77] << 17) |
			((uint32_t)(input[78] & 0x80) << 9);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 625 to 640
	value = ((uint32_t)(input[78] & 0x7f) << 25) |
			((uint32_t)input[79] << 17) |
			((uint32_t)(input[80] & 0x80) << 9);
	output[39] = (double)(value >> 16);

	// read output[40]: from bit 641 to 656
	value = ((uint32_t)(input[80] & 0x7f) << 25) |
			((uint32_t)input[81] << 17) |
			((uint32_t)(input[82] & 0x80) << 9);
	output[40] = (double)(value >> 16);

	// read output[41]: from bit 657 to 672
	value = ((uint32_t)(input[82] & 0x7f) << 25) |
			((uint32_t)input[83] << 17) |
			((uint32_t)(input[84] & 0x80) << 9);
	output[41] = (double)(value >> 16);

	// read output[42]: from bit 673 to 688
	value = ((uint32_t)(input[84] & 0x7f) << 25) |
			((uint32_t)input[85] << 17) |
			((uint32_t)(input[86] & 0x80) << 9);
	output[42] = (double)(value >> 16);

	// read output[43]: from bit 689 to 704
	value = ((uint32_t)(input[86] & 0x7f) << 25) |
			((uint32_t)input[87] << 17) |
			((uint32_t)(input[88] & 0x80) << 9);
	output[43] = (double)(value >> 16);

	// read output[44]: from bit 705 to 720
	value = ((uint32_t)(input[88] & 0x7f) << 25) |
			((uint32_t)input[89] << 17) |
			((uint32_t)(input[90] & 0x80) << 9);
	output[44] = (double)(value >> 16);

	// read output[45]: from bit 721 to 736
	value = ((uint32_t)(input[90] & 0x7f) << 25) |
			((uint32_t)input[91] << 17) |
			((uint32_t)(input[92] & 0x80) << 9);
	output[45] = (double)(value >> 16);

	// read output[46]: from bit 737 to 752
	value = ((uint32_t)(input[92] & 0x7f) << 25) |
			((uint32_t)input[93] << 17) |
			((uint32_t)(input[94] & 0x80) << 9);
	output[46] = (double)(value >> 16);
}

static void unpack_47_16bit_unsigned_1off(const uint8_t * input, double * output, void *closure) {
	// Unpack 47 values into output
	// Values are 16-bit unsigned
	// Skip 1 bits, read 752 bits of data.
	// Input must be at least 95 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 1 to 16
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)input[1] << 17) |
			((uint32_t)(input[2] & 0x80) << 9);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 17 to 32
	value = ((uint32_t)(input[2] & 0x7f) << 25) |
			((uint32_t)input[3] << 17) |
			((uint32_t)(input[4] & 0x80) << 9);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 33 to 48
	value = ((uint32_t)(input[4] & 0x7f) << 25) |
			((uint32_t)input[5] << 17) |
			((uint32_t)(input[6] & 0x80) << 9);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 49 to 64
	value = ((uint32_t)(input[6] & 0x7f) << 25) |
			((uint32_t)input[7] << 17) |
			((uint32_t)(input[8] & 0x80) << 9);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 65 to 80
	value = ((uint32_t)(input[8] & 0x7f) << 25) |
			((uint32_t)input[9] << 17) |
			((uint32_t)(input[10] & 0x80) << 9);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 81 to 96
	value = ((uint32_t)(input[10] & 0x7f) << 25) |
			((uint32_t)input[11] << 17) |
			((uint32_t)(input[12] & 0x80) << 9);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 97 to 112
	value = ((uint32_t)(input[12] & 0x7f) << 25) |
			((uint32_t)input[13] << 17) |
			((uint32_t)(input[14] & 0x80) << 9);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 113 to 128
	value = ((uint32_t)(input[14] & 0x7f) << 25) |
			((uint32_t)input[15] << 17) |
			((uint32_t)(input[16] & 0x80) << 9);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 129 to 144
	value = ((uint32_t)(input[16] & 0x7f) << 25) |
			((uint32_t)input[17] << 17) |
			((uint32_t)(input[18] & 0x80) << 9);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 145 to 160
	value = ((uint32_t)(input[18] & 0x7f) << 25) |
			((uint32_t)input[19] << 17) |
			((uint32_t)(input[20] & 0x80) << 9);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 161 to 176
	value = ((uint32_t)(input[20] & 0x7f) << 25) |
			((uint32_t)input[21] << 17) |
			((uint32_t)(input[22] & 0x80) << 9);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 177 to 192
	value = ((uint32_t)(input[22] & 0x7f) << 25) |
			((uint32_t)input[23] << 17) |
			((uint32_t)(input[24] & 0x80) << 9);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 193 to 208
	value = ((uint32_t)(input[24] & 0x7f) << 25) |
			((uint32_t)input[25] << 17) |
			((uint32_t)(input[26] & 0x80) << 9);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 209 to 224
	value = ((uint32_t)(input[26] & 0x7f) << 25) |
			((uint32_t)input[27] << 17) |
			((uint32_t)(input[28] & 0x80) << 9);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 225 to 240
	value = ((uint32_t)(input[28] & 0x7f) << 25) |
			((uint32_t)input[29] << 17) |
			((uint32_t)(input[30] & 0x80) << 9);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 241 to 256
	value = ((uint32_t)(input[30] & 0x7f) << 25) |
			((uint32_t)input[31] << 17) |
			((uint32_t)(input[32] & 0x80) << 9);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 257 to 272
	value = ((uint32_t)(input[32] & 0x7f) << 25) |
			((uint32_t)input[33] << 17) |
			((uint32_t)(input[34] & 0x80) << 9);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 273 to 288
	value = ((uint32_t)(input[34] & 0x7f) << 25) |
			((uint32_t)input[35] << 17) |
			((uint32_t)(input[36] & 0x80) << 9);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 289 to 304
	value = ((uint32_t)(input[36] & 0x7f) << 25) |
			((uint32_t)input[37] << 17) |
			((uint32_t)(input[38] & 0x80) << 9);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 305 to 320
	value = ((uint32_t)(input[38] & 0x7f) << 25) |
			((uint32_t)input[39] << 17) |
			((uint32_t)(input[40] & 0x80) << 9);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 321 to 336
	value = ((uint32_t)(input[40] & 0x7f) << 25) |
			((uint32_t)input[41] << 17) |
			((uint32_t)(input[42] & 0x80) << 9);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 337 to 352
	value = ((uint32_t)(input[42] & 0x7f) << 25) |
			((uint32_t)input[43] << 17) |
			((uint32_t)(input[44] & 0x80) << 9);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 353 to 368
	value = ((uint32_t)(input[44] & 0x7f) << 25) |
			((uint32_t)input[45] << 17) |
			((uint32_t)(input[46] & 0x80) << 9);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 369 to 384
	value = ((uint32_t)(input[46] & 0x7f) << 25) |
			((uint32_t)input[47] << 17) |
			((uint32_t)(input[48] & 0x80) << 9);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 385 to 400
	value = ((uint32_t)(input[48] & 0x7f) << 25) |
			((uint32_t)input[49] << 17) |
			((uint32_t)(input[50] & 0x80) << 9);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 401 to 416
	value = ((uint32_t)(input[50] & 0x7f) << 25) |
			((uint32_t)input[51] << 17) |
			((uint32_t)(input[52] & 0x80) << 9);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 417 to 432
	value = ((uint32_t)(input[52] & 0x7f) << 25) |
			((uint32_t)input[53] << 17) |
			((uint32_t)(input[54] & 0x80) << 9);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 433 to 448
	value = ((uint32_t)(input[54] & 0x7f) << 25) |
			((uint32_t)input[55] << 17) |
			((uint32_t)(input[56] & 0x80) << 9);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 449 to 464
	value = ((uint32_t)(input[56] & 0x7f) << 25) |
			((uint32_t)input[57] << 17) |
			((uint32_t)(input[58] & 0x80) << 9);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 465 to 480
	value = ((uint32_t)(input[58] & 0x7f) << 25) |
			((uint32_t)input[59] << 17) |
			((uint32_t)(input[60] & 0x80) << 9);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 481 to 496
	value = ((uint32_t)(input[60] & 0x7f) << 25) |
			((uint32_t)input[61] << 17) |
			((uint32_t)(input[62] & 0x80) << 9);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 497 to 512
	value = ((uint32_t)(input[62] & 0x7f) << 25) |
			((uint32_t)input[63] << 17) |
			((uint32_t)(input[64] & 0x80) << 9);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 513 to 528
	value = ((uint32_t)(input[64] & 0x7f) << 25) |
			((uint32_t)input[65] << 17) |
			((uint32_t)(input[66] & 0x80) << 9);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 529 to 544
	value = ((uint32_t)(input[66] & 0x7f) << 25) |
			((uint32_t)input[67] << 17) |
			((uint32_t)(input[68] & 0x80) << 9);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 545 to 560
	value = ((uint32_t)(input[68] & 0x7f) << 25) |
			((uint32_t)input[69] << 17) |
			((uint32_t)(input[70] & 0x80) << 9);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 561 to 576
	value = ((uint32_t)(input[70] & 0x7f) << 25) |
			((uint32_t)input[71] << 17) |
			((uint32_t)(input[72] & 0x80) << 9);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 577 to 592
	value = ((uint32_t)(input[72] & 0x7f) << 25) |
			((uint32_t)input[73] << 17) |
			((uint32_t)(input[74] & 0x80) << 9);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 593 to 608
	value = ((uint32_t)(input[74] & 0x7f) << 25) |
			((uint32_t)input[75] << 17) |
			((uint32_t)(input[76] & 0x80) << 9);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 609 to 624
	value = ((uint32_t)(input[76] & 0x7f) << 25) |
			((uint32_t)input[77] << 17) |
			((uint32_t)(input[78] & 0x80) << 9);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 625 to 640
	value = ((uint32_t)(input[78] & 0x7f) << 25) |
			((uint32_t)input[79] << 17) |
			((uint32_t)(input[80] & 0x80) << 9);
	output[39] = (double)(value >> 16);

	// read output[40]: from bit 641 to 656
	value = ((uint32_t)(input[80] & 0x7f) << 25) |
			((uint32_t)input[81] << 17) |
			((uint32_t)(input[82] & 0x80) << 9);
	output[40] = (double)(value >> 16);

	// read output[41]: from bit 657 to 672
	value = ((uint32_t)(input[82] & 0x7f) << 25) |
			((uint32_t)input[83] << 17) |
			((uint32_t)(input[84] & 0x80) << 9);
	output[41] = (double)(value >> 16);

	// read output[42]: from bit 673 to 688
	value = ((uint32_t)(input[84] & 0x7f) << 25) |
			((uint32_t)input[85] << 17) |
			((uint32_t)(input[86] & 0x80) << 9);
	output[42] = (double)(value >> 16);

	// read output[43]: from bit 689 to 704
	value = ((uint32_t)(input[86] & 0x7f) << 25) |
			((uint32_t)input[87] << 17) |
			((uint32_t)(input[88] & 0x80) << 9);
	output[43] = (double)(value >> 16);

	// read output[44]: from bit 705 to 720
	value = ((uint32_t)(input[88] & 0x7f) << 25) |
			((uint32_t)input[89] << 17) |
			((uint32_t)(input[90] & 0x80) << 9);
	output[44] = (double)(value >> 16);

	// read output[45]: from bit 721 to 736
	value = ((uint32_t)(input[90] & 0x7f) << 25) |
			((uint32_t)input[91] << 17) |
			((uint32_t)(input[92] & 0x80) << 9);
	output[45] = (double)(value >> 16);

	// read output[46]: from bit 737 to 752
	value = ((uint32_t)(input[92] & 0x7f) << 25) |
			((uint32_t)input[93] << 17) |
			((uint32_t)(input[94] & 0x80) << 9);
	output[46] = (double)(value >> 16);
}

static void unpack_47_16bit_signed_2off(const uint8_t * input, double * output, void *closure) {
	// Unpack 47 values into output
	// Values are 16-bit signed
	// Skip 2 bits, read 752 bits of data.
	// Input must be at least 95 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 2 to 17
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)input[1] << 18) |
			((uint32_t)(input[2] & 0xc0) << 10);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 18 to 33
	value = ((uint32_t)(input[2] & 0x3f) << 26) |
			((uint32_t)input[3] << 18) |
			((uint32_t)(input[4] & 0xc0) << 10);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 34 to 49
	value = ((uint32_t)(input[4] & 0x3f) << 26) |
			((uint32_t)input[5] << 18) |
			((uint32_t)(input[6] & 0xc0) << 10);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 50 to 65
	value = ((uint32_t)(input[6] & 0x3f) << 26) |
			((uint32_t)input[7] << 18) |
			((uint32_t)(input[8] & 0xc0) << 10);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 66 to 81
	value = ((uint32_t)(input[8] & 0x3f) << 26) |
			((uint32_t)input[9] << 18) |
			((uint32_t)(input[10] & 0xc0) << 10);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 82 to 97
	value = ((uint32_t)(input[10] & 0x3f) << 26) |
			((uint32_t)input[11] << 18) |
			((uint32_t)(input[12] & 0xc0) << 10);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 98 to 113
	value = ((uint32_t)(input[12] & 0x3f) << 26) |
			((uint32_t)input[13] << 18) |
			((uint32_t)(input[14] & 0xc0) << 10);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 114 to 129
	value = ((uint32_t)(input[14] & 0x3f) << 26) |
			((uint32_t)input[15] << 18) |
			((uint32_t)(input[16] & 0xc0) << 10);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 130 to 145
	value = ((uint32_t)(input[16] & 0x3f) << 26) |
			((uint32_t)input[17] << 18) |
			((uint32_t)(input[18] & 0xc0) << 10);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 146 to 161
	value = ((uint32_t)(input[18] & 0x3f) << 26) |
			((uint32_t)input[19] << 18) |
			((uint32_t)(input[20] & 0xc0) << 10);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 162 to 177
	value = ((uint32_t)(input[20] & 0x3f) << 26) |
			((uint32_t)input[21] << 18) |
			((uint32_t)(input[22] & 0xc0) << 10);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 178 to 193
	value = ((uint32_t)(input[22] & 0x3f) << 26) |
			((uint32_t)input[23] << 18) |
			((uint32_t)(input[24] & 0xc0) << 10);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 194 to 209
	value = ((uint32_t)(input[24] & 0x3f) << 26) |
			((uint32_t)input[25] << 18) |
			((uint32_t)(input[26] & 0xc0) << 10);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 210 to 225
	value = ((uint32_t)(input[26] & 0x3f) << 26) |
			((uint32_t)input[27] << 18) |
			((uint32_t)(input[28] & 0xc0) << 10);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 226 to 241
	value = ((uint32_t)(input[28] & 0x3f) << 26) |
			((uint32_t)input[29] << 18) |
			((uint32_t)(input[30] & 0xc0) << 10);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 242 to 257
	value = ((uint32_t)(input[30] & 0x3f) << 26) |
			((uint32_t)input[31] << 18) |
			((uint32_t)(input[32] & 0xc0) << 10);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 258 to 273
	value = ((uint32_t)(input[32] & 0x3f) << 26) |
			((uint32_t)input[33] << 18) |
			((uint32_t)(input[34] & 0xc0) << 10);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 274 to 289
	value = ((uint32_t)(input[34] & 0x3f) << 26) |
			((uint32_t)input[35] << 18) |
			((uint32_t)(input[36] & 0xc0) << 10);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 290 to 305
	value = ((uint32_t)(input[36] & 0x3f) << 26) |
			((uint32_t)input[37] << 18) |
			((uint32_t)(input[38] & 0xc0) << 10);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 306 to 321
	value = ((uint32_t)(input[38] & 0x3f) << 26) |
			((uint32_t)input[39] << 18) |
			((uint32_t)(input[40] & 0xc0) << 10);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 322 to 337
	value = ((uint32_t)(input[40] & 0x3f) << 26) |
			((uint32_t)input[41] << 18) |
			((uint32_t)(input[42] & 0xc0) << 10);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 338 to 353
	value = ((uint32_t)(input[42] & 0x3f) << 26) |
			((uint32_t)input[43] << 18) |
			((uint32_t)(input[44] & 0xc0) << 10);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 354 to 369
	value = ((uint32_t)(input[44] & 0x3f) << 26) |
			((uint32_t)input[45] << 18) |
			((uint32_t)(input[46] & 0xc0) << 10);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 370 to 385
	value = ((uint32_t)(input[46] & 0x3f) << 26) |
			((uint32_t)input[47] << 18) |
			((uint32_t)(input[48] & 0xc0) << 10);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 386 to 401
	value = ((uint32_t)(input[48] & 0x3f) << 26) |
			((uint32_t)input[49] << 18) |
			((uint32_t)(input[50] & 0xc0) << 10);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 402 to 417
	value = ((uint32_t)(input[50] & 0x3f) << 26) |
			((uint32_t)input[51] << 18) |
			((uint32_t)(input[52] & 0xc0) << 10);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 418 to 433
	value = ((uint32_t)(input[52] & 0x3f) << 26) |
			((uint32_t)input[53] << 18) |
			((uint32_t)(input[54] & 0xc0) << 10);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 434 to 449
	value = ((uint32_t)(input[54] & 0x3f) << 26) |
			((uint32_t)input[55] << 18) |
			((uint32_t)(input[56] & 0xc0) << 10);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 450 to 465
	value = ((uint32_t)(input[56] & 0x3f) << 26) |
			((uint32_t)input[57] << 18) |
			((uint32_t)(input[58] & 0xc0) << 10);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 466 to 481
	value = ((uint32_t)(input[58] & 0x3f) << 26) |
			((uint32_t)input[59] << 18) |
			((uint32_t)(input[60] & 0xc0) << 10);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 482 to 497
	value = ((uint32_t)(input[60] & 0x3f) << 26) |
			((uint32_t)input[61] << 18) |
			((uint32_t)(input[62] & 0xc0) << 10);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 498 to 513
	value = ((uint32_t)(input[62] & 0x3f) << 26) |
			((uint32_t)input[63] << 18) |
			((uint32_t)(input[64] & 0xc0) << 10);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 514 to 529
	value = ((uint32_t)(input[64] & 0x3f) << 26) |
			((uint32_t)input[65] << 18) |
			((uint32_t)(input[66] & 0xc0) << 10);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 530 to 545
	value = ((uint32_t)(input[66] & 0x3f) << 26) |
			((uint32_t)input[67] << 18) |
			((uint32_t)(input[68] & 0xc0) << 10);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 546 to 561
	value = ((uint32_t)(input[68] & 0x3f) << 26) |
			((uint32_t)input[69] << 18) |
			((uint32_t)(input[70] & 0xc0) << 10);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 562 to 577
	value = ((uint32_t)(input[70] & 0x3f) << 26) |
			((uint32_t)input[71] << 18) |
			((uint32_t)(input[72] & 0xc0) << 10);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 578 to 593
	value = ((uint32_t)(input[72] & 0x3f) << 26) |
			((uint32_t)input[73] << 18) |
			((uint32_t)(input[74] & 0xc0) << 10);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 594 to 609
	value = ((uint32_t)(input[74] & 0x3f) << 26) |
			((uint32_t)input[75] << 18) |
			((uint32_t)(input[76] & 0xc0) << 10);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 610 to 625
	value = ((uint32_t)(input[76] & 0x3f) << 26) |
			((uint32_t)input[77] << 18) |
			((uint32_t)(input[78] & 0xc0) << 10);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 626 to 641
	value = ((uint32_t)(input[78] & 0x3f) << 26) |
			((uint32_t)input[79] << 18) |
			((uint32_t)(input[80] & 0xc0) << 10);
	output[39] = (double)(value >> 16);

	// read output[40]: from bit 642 to 657
	value = ((uint32_t)(input[80] & 0x3f) << 26) |
			((uint32_t)input[81] << 18) |
			((uint32_t)(input[82] & 0xc0) << 10);
	output[40] = (double)(value >> 16);

	// read output[41]: from bit 658 to 673
	value = ((uint32_t)(input[82] & 0x3f) << 26) |
			((uint32_t)input[83] << 18) |
			((uint32_t)(input[84] & 0xc0) << 10);
	output[41] = (double)(value >> 16);

	// read output[42]: from bit 674 to 689
	value = ((uint32_t)(input[84] & 0x3f) << 26) |
			((uint32_t)input[85] << 18) |
			((uint32_t)(input[86] & 0xc0) << 10);
	output[42] = (double)(value >> 16);

	// read output[43]: from bit 690 to 705
	value = ((uint32_t)(input[86] & 0x3f) << 26) |
			((uint32_t)input[87] << 18) |
			((uint32_t)(input[88] & 0xc0) << 10);
	output[43] = (double)(value >> 16);

	// read output[44]: from bit 706 to 721
	value = ((uint32_t)(input[88] & 0x3f) << 26) |
			((uint32_t)input[89] << 18) |
			((uint32_t)(input[90] & 0xc0) << 10);
	output[44] = (double)(value >> 16);

	// read output[45]: from bit 722 to 737
	value = ((uint32_t)(input[90] & 0x3f) << 26) |
			((uint32_t)input[91] << 18) |
			((uint32_t)(input[92] & 0xc0) << 10);
	output[45] = (double)(value >> 16);

	// read output[46]: from bit 738 to 753
	value = ((uint32_t)(input[92] & 0x3f) << 26) |
			((uint32_t)input[93] << 18) |
			((uint32_t)(input[94] & 0xc0) << 10);
	output[46] = (double)(value >> 16);
}

static void unpack_47_16bit_unsigned_2off(const uint8_t * input, double * output, void *closure) {
	// Unpack 47 values into output
	// Values are 16-bit unsigned
	// Skip 2 bits, read 752 bits of data.
	// Input must be at least 95 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 2 to 17
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)input[1] << 18) |
			((uint32_t)(input[2] & 0xc0) << 10);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 18 to 33
	value = ((uint32_t)(input[2] & 0x3f) << 26) |
			((uint32_t)input[3] << 18) |
			((uint32_t)(input[4] & 0xc0) << 10);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 34 to 49
	value = ((uint32_t)(input[4] & 0x3f) << 26) |
			((uint32_t)input[5] << 18) |
			((uint32_t)(input[6] & 0xc0) << 10);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 50 to 65
	value = ((uint32_t)(input[6] & 0x3f) << 26) |
			((uint32_t)input[7] << 18) |
			((uint32_t)(input[8] & 0xc0) << 10);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 66 to 81
	value = ((uint32_t)(input[8] & 0x3f) << 26) |
			((uint32_t)input[9] << 18) |
			((uint32_t)(input[10] & 0xc0) << 10);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 82 to 97
	value = ((uint32_t)(input[10] & 0x3f) << 26) |
			((uint32_t)input[11] << 18) |
			((uint32_t)(input[12] & 0xc0) << 10);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 98 to 113
	value = ((uint32_t)(input[12] & 0x3f) << 26) |
			((uint32_t)input[13] << 18) |
			((uint32_t)(input[14] & 0xc0) << 10);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 114 to 129
	value = ((uint32_t)(input[14] & 0x3f) << 26) |
			((uint32_t)input[15] << 18) |
			((uint32_t)(input[16] & 0xc0) << 10);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 130 to 145
	value = ((uint32_t)(input[16] & 0x3f) << 26) |
			((uint32_t)input[17] << 18) |
			((uint32_t)(input[18] & 0xc0) << 10);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 146 to 161
	value = ((uint32_t)(input[18] & 0x3f) << 26) |
			((uint32_t)input[19] << 18) |
			((uint32_t)(input[20] & 0xc0) << 10);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 162 to 177
	value = ((uint32_t)(input[20] & 0x3f) << 26) |
			((uint32_t)input[21] << 18) |
			((uint32_t)(input[22] & 0xc0) << 10);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 178 to 193
	value = ((uint32_t)(input[22] & 0x3f) << 26) |
			((uint32_t)input[23] << 18) |
			((uint32_t)(input[24] & 0xc0) << 10);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 194 to 209
	value = ((uint32_t)(input[24] & 0x3f) << 26) |
			((uint32_t)input[25] << 18) |
			((uint32_t)(input[26] & 0xc0) << 10);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 210 to 225
	value = ((uint32_t)(input[26] & 0x3f) << 26) |
			((uint32_t)input[27] << 18) |
			((uint32_t)(input[28] & 0xc0) << 10);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 226 to 241
	value = ((uint32_t)(input[28] & 0x3f) << 26) |
			((uint32_t)input[29] << 18) |
			((uint32_t)(input[30] & 0xc0) << 10);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 242 to 257
	value = ((uint32_t)(input[30] & 0x3f) << 26) |
			((uint32_t)input[31] << 18) |
			((uint32_t)(input[32] & 0xc0) << 10);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 258 to 273
	value = ((uint32_t)(input[32] & 0x3f) << 26) |
			((uint32_t)input[33] << 18) |
			((uint32_t)(input[34] & 0xc0) << 10);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 274 to 289
	value = ((uint32_t)(input[34] & 0x3f) << 26) |
			((uint32_t)input[35] << 18) |
			((uint32_t)(input[36] & 0xc0) << 10);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 290 to 305
	value = ((uint32_t)(input[36] & 0x3f) << 26) |
			((uint32_t)input[37] << 18) |
			((uint32_t)(input[38] & 0xc0) << 10);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 306 to 321
	value = ((uint32_t)(input[38] & 0x3f) << 26) |
			((uint32_t)input[39] << 18) |
			((uint32_t)(input[40] & 0xc0) << 10);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 322 to 337
	value = ((uint32_t)(input[40] & 0x3f) << 26) |
			((uint32_t)input[41] << 18) |
			((uint32_t)(input[42] & 0xc0) << 10);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 338 to 353
	value = ((uint32_t)(input[42] & 0x3f) << 26) |
			((uint32_t)input[43] << 18) |
			((uint32_t)(input[44] & 0xc0) << 10);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 354 to 369
	value = ((uint32_t)(input[44] & 0x3f) << 26) |
			((uint32_t)input[45] << 18) |
			((uint32_t)(input[46] & 0xc0) << 10);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 370 to 385
	value = ((uint32_t)(input[46] & 0x3f) << 26) |
			((uint32_t)input[47] << 18) |
			((uint32_t)(input[48] & 0xc0) << 10);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 386 to 401
	value = ((uint32_t)(input[48] & 0x3f) << 26) |
			((uint32_t)input[49] << 18) |
			((uint32_t)(input[50] & 0xc0) << 10);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 402 to 417
	value = ((uint32_t)(input[50] & 0x3f) << 26) |
			((uint32_t)input[51] << 18) |
			((uint32_t)(input[52] & 0xc0) << 10);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 418 to 433
	value = ((uint32_t)(input[52] & 0x3f) << 26) |
			((uint32_t)input[53] << 18) |
			((uint32_t)(input[54] & 0xc0) << 10);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 434 to 449
	value = ((uint32_t)(input[54] & 0x3f) << 26) |
			((uint32_t)input[55] << 18) |
			((uint32_t)(input[56] & 0xc0) << 10);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 450 to 465
	value = ((uint32_t)(input[56] & 0x3f) << 26) |
			((uint32_t)input[57] << 18) |
			((uint32_t)(input[58] & 0xc0) << 10);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 466 to 481
	value = ((uint32_t)(input[58] & 0x3f) << 26) |
			((uint32_t)input[59] << 18) |
			((uint32_t)(input[60] & 0xc0) << 10);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 482 to 497
	value = ((uint32_t)(input[60] & 0x3f) << 26) |
			((uint32_t)input[61] << 18) |
			((uint32_t)(input[62] & 0xc0) << 10);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 498 to 513
	value = ((uint32_t)(input[62] & 0x3f) << 26) |
			((uint32_t)input[63] << 18) |
			((uint32_t)(input[64] & 0xc0) << 10);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 514 to 529
	value = ((uint32_t)(input[64] & 0x3f) << 26) |
			((uint32_t)input[65] << 18) |
			((uint32_t)(input[66] & 0xc0) << 10);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 530 to 545
	value = ((uint32_t)(input[66] & 0x3f) << 26) |
			((uint32_t)input[67] << 18) |
			((uint32_t)(input[68] & 0xc0) << 10);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 546 to 561
	value = ((uint32_t)(input[68] & 0x3f) << 26) |
			((uint32_t)input[69] << 18) |
			((uint32_t)(input[70] & 0xc0) << 10);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 562 to 577
	value = ((uint32_t)(input[70] & 0x3f) << 26) |
			((uint32_t)input[71] << 18) |
			((uint32_t)(input[72] & 0xc0) << 10);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 578 to 593
	value = ((uint32_t)(input[72] & 0x3f) << 26) |
			((uint32_t)input[73] << 18) |
			((uint32_t)(input[74] & 0xc0) << 10);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 594 to 609
	value = ((uint32_t)(input[74] & 0x3f) << 26) |
			((uint32_t)input[75] << 18) |
			((uint32_t)(input[76] & 0xc0) << 10);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 610 to 625
	value = ((uint32_t)(input[76] & 0x3f) << 26) |
			((uint32_t)input[77] << 18) |
			((uint32_t)(input[78] & 0xc0) << 10);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 626 to 641
	value = ((uint32_t)(input[78] & 0x3f) << 26) |
			((uint32_t)input[79] << 18) |
			((uint32_t)(input[80] & 0xc0) << 10);
	output[39] = (double)(value >> 16);

	// read output[40]: from bit 642 to 657
	value = ((uint32_t)(input[80] & 0x3f) << 26) |
			((uint32_t)input[81] << 18) |
			((uint32_t)(input[82] & 0xc0) << 10);
	output[40] = (double)(value >> 16);

	// read output[41]: from bit 658 to 673
	value = ((uint32_t)(input[82] & 0x3f) << 26) |
			((uint32_t)input[83] << 18) |
			((uint32_t)(input[84] & 0xc0) << 10);
	output[41] = (double)(value >> 16);

	// read output[42]: from bit 674 to 689
	value = ((uint32_t)(input[84] & 0x3f) << 26) |
			((uint32_t)input[85] << 18) |
			((uint32_t)(input[86] & 0xc0) << 10);
	output[42] = (double)(value >> 16);

	// read output[43]: from bit 690 to 705
	value = ((uint32_t)(input[86] & 0x3f) << 26) |
			((uint32_t)input[87] << 18) |
			((uint32_t)(input[88] & 0xc0) << 10);
	output[43] = (double)(value >> 16);

	// read output[44]: from bit 706 to 721
	value = ((uint32_t)(input[88] & 0x3f) << 26) |
			((uint32_t)input[89] << 18) |
			((uint32_t)(input[90] & 0xc0) << 10);
	output[44] = (double)(value >> 16);

	// read output[45]: from bit 722 to 737
	value = ((uint32_t)(input[90] & 0x3f) << 26) |
			((uint32_t)input[91] << 18) |
			((uint32_t)(input[92] & 0xc0) << 10);
	output[45] = (double)(value >> 16);

	// read output[46]: from bit 738 to 753
	value = ((uint32_t)(input[92] & 0x3f) << 26) |
			((uint32_t)input[93] << 18) |
			((uint32_t)(input[94] & 0xc0) << 10);
	output[46] = (double)(value >> 16);
}

static void unpack_47_16bit_signed_3off(const uint8_t * input, double * output, void *closure) {
	// Unpack 47 values into output
	// Values are 16-bit signed
	// Skip 3 bits, read 752 bits of data.
	// Input must be at least 95 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 3 to 18
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)input[1] << 19) |
			((uint32_t)(input[2] & 0xe0) << 11);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 19 to 34
	value = ((uint32_t)(input[2] & 0x1f) << 27) |
			((uint32_t)input[3] << 19) |
			((uint32_t)(input[4] & 0xe0) << 11);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 35 to 50
	value = ((uint32_t)(input[4] & 0x1f) << 27) |
			((uint32_t)input[5] << 19) |
			((uint32_t)(input[6] & 0xe0) << 11);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 51 to 66
	value = ((uint32_t)(input[6] & 0x1f) << 27) |
			((uint32_t)input[7] << 19) |
			((uint32_t)(input[8] & 0xe0) << 11);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 67 to 82
	value = ((uint32_t)(input[8] & 0x1f) << 27) |
			((uint32_t)input[9] << 19) |
			((uint32_t)(input[10] & 0xe0) << 11);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 83 to 98
	value = ((uint32_t)(input[10] & 0x1f) << 27) |
			((uint32_t)input[11] << 19) |
			((uint32_t)(input[12] & 0xe0) << 11);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 99 to 114
	value = ((uint32_t)(input[12] & 0x1f) << 27) |
			((uint32_t)input[13] << 19) |
			((uint32_t)(input[14] & 0xe0) << 11);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 115 to 130
	value = ((uint32_t)(input[14] & 0x1f) << 27) |
			((uint32_t)input[15] << 19) |
			((uint32_t)(input[16] & 0xe0) << 11);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 131 to 146
	value = ((uint32_t)(input[16] & 0x1f) << 27) |
			((uint32_t)input[17] << 19) |
			((uint32_t)(input[18] & 0xe0) << 11);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 147 to 162
	value = ((uint32_t)(input[18] & 0x1f) << 27) |
			((uint32_t)input[19] << 19) |
			((uint32_t)(input[20] & 0xe0) << 11);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 163 to 178
	value = ((uint32_t)(input[20] & 0x1f) << 27) |
			((uint32_t)input[21] << 19) |
			((uint32_t)(input[22] & 0xe0) << 11);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 179 to 194
	value = ((uint32_t)(input[22] & 0x1f) << 27) |
			((uint32_t)input[23] << 19) |
			((uint32_t)(input[24] & 0xe0) << 11);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 195 to 210
	value = ((uint32_t)(input[24] & 0x1f) << 27) |
			((uint32_t)input[25] << 19) |
			((uint32_t)(input[26] & 0xe0) << 11);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 211 to 226
	value = ((uint32_t)(input[26] & 0x1f) << 27) |
			((uint32_t)input[27] << 19) |
			((uint32_t)(input[28] & 0xe0) << 11);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 227 to 242
	value = ((uint32_t)(input[28] & 0x1f) << 27) |
			((uint32_t)input[29] << 19) |
			((uint32_t)(input[30] & 0xe0) << 11);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 243 to 258
	value = ((uint32_t)(input[30] & 0x1f) << 27) |
			((uint32_t)input[31] << 19) |
			((uint32_t)(input[32] & 0xe0) << 11);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 259 to 274
	value = ((uint32_t)(input[32] & 0x1f) << 27) |
			((uint32_t)input[33] << 19) |
			((uint32_t)(input[34] & 0xe0) << 11);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 275 to 290
	value = ((uint32_t)(input[34] & 0x1f) << 27) |
			((uint32_t)input[35] << 19) |
			((uint32_t)(input[36] & 0xe0) << 11);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 291 to 306
	value = ((uint32_t)(input[36] & 0x1f) << 27) |
			((uint32_t)input[37] << 19) |
			((uint32_t)(input[38] & 0xe0) << 11);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 307 to 322
	value = ((uint32_t)(input[38] & 0x1f) << 27) |
			((uint32_t)input[39] << 19) |
			((uint32_t)(input[40] & 0xe0) << 11);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 323 to 338
	value = ((uint32_t)(input[40] & 0x1f) << 27) |
			((uint32_t)input[41] << 19) |
			((uint32_t)(input[42] & 0xe0) << 11);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 339 to 354
	value = ((uint32_t)(input[42] & 0x1f) << 27) |
			((uint32_t)input[43] << 19) |
			((uint32_t)(input[44] & 0xe0) << 11);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 355 to 370
	value = ((uint32_t)(input[44] & 0x1f) << 27) |
			((uint32_t)input[45] << 19) |
			((uint32_t)(input[46] & 0xe0) << 11);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 371 to 386
	value = ((uint32_t)(input[46] & 0x1f) << 27) |
			((uint32_t)input[47] << 19) |
			((uint32_t)(input[48] & 0xe0) << 11);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 387 to 402
	value = ((uint32_t)(input[48] & 0x1f) << 27) |
			((uint32_t)input[49] << 19) |
			((uint32_t)(input[50] & 0xe0) << 11);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 403 to 418
	value = ((uint32_t)(input[50] & 0x1f) << 27) |
			((uint32_t)input[51] << 19) |
			((uint32_t)(input[52] & 0xe0) << 11);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 419 to 434
	value = ((uint32_t)(input[52] & 0x1f) << 27) |
			((uint32_t)input[53] << 19) |
			((uint32_t)(input[54] & 0xe0) << 11);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 435 to 450
	value = ((uint32_t)(input[54] & 0x1f) << 27) |
			((uint32_t)input[55] << 19) |
			((uint32_t)(input[56] & 0xe0) << 11);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 451 to 466
	value = ((uint32_t)(input[56] & 0x1f) << 27) |
			((uint32_t)input[57] << 19) |
			((uint32_t)(input[58] & 0xe0) << 11);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 467 to 482
	value = ((uint32_t)(input[58] & 0x1f) << 27) |
			((uint32_t)input[59] << 19) |
			((uint32_t)(input[60] & 0xe0) << 11);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 483 to 498
	value = ((uint32_t)(input[60] & 0x1f) << 27) |
			((uint32_t)input[61] << 19) |
			((uint32_t)(input[62] & 0xe0) << 11);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 499 to 514
	value = ((uint32_t)(input[62] & 0x1f) << 27) |
			((uint32_t)input[63] << 19) |
			((uint32_t)(input[64] & 0xe0) << 11);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 515 to 530
	value = ((uint32_t)(input[64] & 0x1f) << 27) |
			((uint32_t)input[65] << 19) |
			((uint32_t)(input[66] & 0xe0) << 11);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 531 to 546
	value = ((uint32_t)(input[66] & 0x1f) << 27) |
			((uint32_t)input[67] << 19) |
			((uint32_t)(input[68] & 0xe0) << 11);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 547 to 562
	value = ((uint32_t)(input[68] & 0x1f) << 27) |
			((uint32_t)input[69] << 19) |
			((uint32_t)(input[70] & 0xe0) << 11);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 563 to 578
	value = ((uint32_t)(input[70] & 0x1f) << 27) |
			((uint32_t)input[71] << 19) |
			((uint32_t)(input[72] & 0xe0) << 11);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 579 to 594
	value = ((uint32_t)(input[72] & 0x1f) << 27) |
			((uint32_t)input[73] << 19) |
			((uint32_t)(input[74] & 0xe0) << 11);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 595 to 610
	value = ((uint32_t)(input[74] & 0x1f) << 27) |
			((uint32_t)input[75] << 19) |
			((uint32_t)(input[76] & 0xe0) << 11);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 611 to 626
	value = ((uint32_t)(input[76] & 0x1f) << 27) |
			((uint32_t)input[77] << 19) |
			((uint32_t)(input[78] & 0xe0) << 11);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 627 to 642
	value = ((uint32_t)(input[78] & 0x1f) << 27) |
			((uint32_t)input[79] << 19) |
			((uint32_t)(input[80] & 0xe0) << 11);
	output[39] = (double)(value >> 16);

	// read output[40]: from bit 643 to 658
	value = ((uint32_t)(input[80] & 0x1f) << 27) |
			((uint32_t)input[81] << 19) |
			((uint32_t)(input[82] & 0xe0) << 11);
	output[40] = (double)(value >> 16);

	// read output[41]: from bit 659 to 674
	value = ((uint32_t)(input[82] & 0x1f) << 27) |
			((uint32_t)input[83] << 19) |
			((uint32_t)(input[84] & 0xe0) << 11);
	output[41] = (double)(value >> 16);

	// read output[42]: from bit 675 to 690
	value = ((uint32_t)(input[84] & 0x1f) << 27) |
			((uint32_t)input[85] << 19) |
			((uint32_t)(input[86] & 0xe0) << 11);
	output[42] = (double)(value >> 16);

	// read output[43]: from bit 691 to 706
	value = ((uint32_t)(input[86] & 0x1f) << 27) |
			((uint32_t)input[87] << 19) |
			((uint32_t)(input[88] & 0xe0) << 11);
	output[43] = (double)(value >> 16);

	// read output[44]: from bit 707 to 722
	value = ((uint32_t)(input[88] & 0x1f) << 27) |
			((uint32_t)input[89] << 19) |
			((uint32_t)(input[90] & 0xe0) << 11);
	output[44] = (double)(value >> 16);

	// read output[45]: from bit 723 to 738
	value = ((uint32_t)(input[90] & 0x1f) << 27) |
			((uint32_t)input[91] << 19) |
			((uint32_t)(input[92] & 0xe0) << 11);
	output[45] = (double)(value >> 16);

	// read output[46]: from bit 739 to 754
	value = ((uint32_t)(input[92] & 0x1f) << 27) |
			((uint32_t)input[93] << 19) |
			((uint32_t)(input[94] & 0xe0) << 11);
	output[46] = (double)(value >> 16);
}

static void unpack_47_16bit_unsigned_3off(const uint8_t * input, double * output, void *closure) {
	// Unpack 47 values into output
	// Values are 16-bit unsigned
	// Skip 3 bits, read 752 bits of data.
	// Input must be at least 95 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 3 to 18
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)input[1] << 19) |
			((uint32_t)(input[2] & 0xe0) << 11);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 19 to 34
	value = ((uint32_t)(input[2] & 0x1f) << 27) |
			((uint32_t)input[3] << 19) |
			((uint32_t)(input[4] & 0xe0) << 11);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 35 to 50
	value = ((uint32_t)(input[4] & 0x1f) << 27) |
			((uint32_t)input[5] << 19) |
			((uint32_t)(input[6] & 0xe0) << 11);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 51 to 66
	value = ((uint32_t)(input[6] & 0x1f) << 27) |
			((uint32_t)input[7] << 19) |
			((uint32_t)(input[8] & 0xe0) << 11);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 67 to 82
	value = ((uint32_t)(input[8] & 0x1f) << 27) |
			((uint32_t)input[9] << 19) |
			((uint32_t)(input[10] & 0xe0) << 11);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 83 to 98
	value = ((uint32_t)(input[10] & 0x1f) << 27) |
			((uint32_t)input[11] << 19) |
			((uint32_t)(input[12] & 0xe0) << 11);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 99 to 114
	value = ((uint32_t)(input[12] & 0x1f) << 27) |
			((uint32_t)input[13] << 19) |
			((uint32_t)(input[14] & 0xe0) << 11);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 115 to 130
	value = ((uint32_t)(input[14] & 0x1f) << 27) |
			((uint32_t)input[15] << 19) |
			((uint32_t)(input[16] & 0xe0) << 11);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 131 to 146
	value = ((uint32_t)(input[16] & 0x1f) << 27) |
			((uint32_t)input[17] << 19) |
			((uint32_t)(input[18] & 0xe0) << 11);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 147 to 162
	value = ((uint32_t)(input[18] & 0x1f) << 27) |
			((uint32_t)input[19] << 19) |
			((uint32_t)(input[20] & 0xe0) << 11);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 163 to 178
	value = ((uint32_t)(input[20] & 0x1f) << 27) |
			((uint32_t)input[21] << 19) |
			((uint32_t)(input[22] & 0xe0) << 11);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 179 to 194
	value = ((uint32_t)(input[22] & 0x1f) << 27) |
			((uint32_t)input[23] << 19) |
			((uint32_t)(input[24] & 0xe0) << 11);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 195 to 210
	value = ((uint32_t)(input[24] & 0x1f) << 27) |
			((uint32_t)input[25] << 19) |
			((uint32_t)(input[26] & 0xe0) << 11);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 211 to 226
	value = ((uint32_t)(input[26] & 0x1f) << 27) |
			((uint32_t)input[27] << 19) |
			((uint32_t)(input[28] & 0xe0) << 11);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 227 to 242
	value = ((uint32_t)(input[28] & 0x1f) << 27) |
			((uint32_t)input[29] << 19) |
			((uint32_t)(input[30] & 0xe0) << 11);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 243 to 258
	value = ((uint32_t)(input[30] & 0x1f) << 27) |
			((uint32_t)input[31] << 19) |
			((uint32_t)(input[32] & 0xe0) << 11);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 259 to 274
	value = ((uint32_t)(input[32] & 0x1f) << 27) |
			((uint32_t)input[33] << 19) |
			((uint32_t)(input[34] & 0xe0) << 11);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 275 to 290
	value = ((uint32_t)(input[34] & 0x1f) << 27) |
			((uint32_t)input[35] << 19) |
			((uint32_t)(input[36] & 0xe0) << 11);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 291 to 306
	value = ((uint32_t)(input[36] & 0x1f) << 27) |
			((uint32_t)input[37] << 19) |
			((uint32_t)(input[38] & 0xe0) << 11);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 307 to 322
	value = ((uint32_t)(input[38] & 0x1f) << 27) |
			((uint32_t)input[39] << 19) |
			((uint32_t)(input[40] & 0xe0) << 11);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 323 to 338
	value = ((uint32_t)(input[40] & 0x1f) << 27) |
			((uint32_t)input[41] << 19) |
			((uint32_t)(input[42] & 0xe0) << 11);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 339 to 354
	value = ((uint32_t)(input[42] & 0x1f) << 27) |
			((uint32_t)input[43] << 19) |
			((uint32_t)(input[44] & 0xe0) << 11);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 355 to 370
	value = ((uint32_t)(input[44] & 0x1f) << 27) |
			((uint32_t)input[45] << 19) |
			((uint32_t)(input[46] & 0xe0) << 11);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 371 to 386
	value = ((uint32_t)(input[46] & 0x1f) << 27) |
			((uint32_t)input[47] << 19) |
			((uint32_t)(input[48] & 0xe0) << 11);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 387 to 402
	value = ((uint32_t)(input[48] & 0x1f) << 27) |
			((uint32_t)input[49] << 19) |
			((uint32_t)(input[50] & 0xe0) << 11);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 403 to 418
	value = ((uint32_t)(input[50] & 0x1f) << 27) |
			((uint32_t)input[51] << 19) |
			((uint32_t)(input[52] & 0xe0) << 11);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 419 to 434
	value = ((uint32_t)(input[52] & 0x1f) << 27) |
			((uint32_t)input[53] << 19) |
			((uint32_t)(input[54] & 0xe0) << 11);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 435 to 450
	value = ((uint32_t)(input[54] & 0x1f) << 27) |
			((uint32_t)input[55] << 19) |
			((uint32_t)(input[56] & 0xe0) << 11);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 451 to 466
	value = ((uint32_t)(input[56] & 0x1f) << 27) |
			((uint32_t)input[57] << 19) |
			((uint32_t)(input[58] & 0xe0) << 11);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 467 to 482
	value = ((uint32_t)(input[58] & 0x1f) << 27) |
			((uint32_t)input[59] << 19) |
			((uint32_t)(input[60] & 0xe0) << 11);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 483 to 498
	value = ((uint32_t)(input[60] & 0x1f) << 27) |
			((uint32_t)input[61] << 19) |
			((uint32_t)(input[62] & 0xe0) << 11);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 499 to 514
	value = ((uint32_t)(input[62] & 0x1f) << 27) |
			((uint32_t)input[63] << 19) |
			((uint32_t)(input[64] & 0xe0) << 11);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 515 to 530
	value = ((uint32_t)(input[64] & 0x1f) << 27) |
			((uint32_t)input[65] << 19) |
			((uint32_t)(input[66] & 0xe0) << 11);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 531 to 546
	value = ((uint32_t)(input[66] & 0x1f) << 27) |
			((uint32_t)input[67] << 19) |
			((uint32_t)(input[68] & 0xe0) << 11);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 547 to 562
	value = ((uint32_t)(input[68] & 0x1f) << 27) |
			((uint32_t)input[69] << 19) |
			((uint32_t)(input[70] & 0xe0) << 11);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 563 to 578
	value = ((uint32_t)(input[70] & 0x1f) << 27) |
			((uint32_t)input[71] << 19) |
			((uint32_t)(input[72] & 0xe0) << 11);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 579 to 594
	value = ((uint32_t)(input[72] & 0x1f) << 27) |
			((uint32_t)input[73] << 19) |
			((uint32_t)(input[74] & 0xe0) << 11);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 595 to 610
	value = ((uint32_t)(input[74] & 0x1f) << 27) |
			((uint32_t)input[75] << 19) |
			((uint32_t)(input[76] & 0xe0) << 11);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 611 to 626
	value = ((uint32_t)(input[76] & 0x1f) << 27) |
			((uint32_t)input[77] << 19) |
			((uint32_t)(input[78] & 0xe0) << 11);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 627 to 642
	value = ((uint32_t)(input[78] & 0x1f) << 27) |
			((uint32_t)input[79] << 19) |
			((uint32_t)(input[80] & 0xe0) << 11);
	output[39] = (double)(value >> 16);

	// read output[40]: from bit 643 to 658
	value = ((uint32_t)(input[80] & 0x1f) << 27) |
			((uint32_t)input[81] << 19) |
			((uint32_t)(input[82] & 0xe0) << 11);
	output[40] = (double)(value >> 16);

	// read output[41]: from bit 659 to 674
	value = ((uint32_t)(input[82] & 0x1f) << 27) |
			((uint32_t)input[83] << 19) |
			((uint32_t)(input[84] & 0xe0) << 11);
	output[41] = (double)(value >> 16);

	// read output[42]: from bit 675 to 690
	value = ((uint32_t)(input[84] & 0x1f) << 27) |
			((uint32_t)input[85] << 19) |
			((uint32_t)(input[86] & 0xe0) << 11);
	output[42] = (double)(value >> 16);

	// read output[43]: from bit 691 to 706
	value = ((uint32_t)(input[86] & 0x1f) << 27) |
			((uint32_t)input[87] << 19) |
			((uint32_t)(input[88] & 0xe0) << 11);
	output[43] = (double)(value >> 16);

	// read output[44]: from bit 707 to 722
	value = ((uint32_t)(input[88] & 0x1f) << 27) |
			((uint32_t)input[89] << 19) |
			((uint32_t)(input[90] & 0xe0) << 11);
	output[44] = (double)(value >> 16);

	// read output[45]: from bit 723 to 738
	value = ((uint32_t)(input[90] & 0x1f) << 27) |
			((uint32_t)input[91] << 19) |
			((uint32_t)(input[92] & 0xe0) << 11);
	output[45] = (double)(value >> 16);

	// read output[46]: from bit 739 to 754
	value = ((uint32_t)(input[92] & 0x1f) << 27) |
			((uint32_t)input[93] << 19) |
			((uint32_t)(input[94] & 0xe0) << 11);
	output[46] = (double)(value >> 16);
}

static void unpack_47_16bit_signed_4off(const uint8_t * input, double * output, void *closure) {
	// Unpack 47 values into output
	// Values are 16-bit signed
	// Skip 4 bits, read 752 bits of data.
	// Input must be at least 95 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 4 to 19
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20) |
			((uint32_t)(input[2] & 0xf0) << 12);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 20 to 35
	value = ((uint32_t)(input[2] & 0x0f) << 28) |
			((uint32_t)input[3] << 20) |
			((uint32_t)(input[4] & 0xf0) << 12);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 36 to 51
	value = ((uint32_t)(input[4] & 0x0f) << 28) |
			((uint32_t)input[5] << 20) |
			((uint32_t)(input[6] & 0xf0) << 12);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 52 to 67
	value = ((uint32_t)(input[6] & 0x0f) << 28) |
			((uint32_t)input[7] << 20) |
			((uint32_t)(input[8] & 0xf0) << 12);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 68 to 83
	value = ((uint32_t)(input[8] & 0x0f) << 28) |
			((uint32_t)input[9] << 20) |
			((uint32_t)(input[10] & 0xf0) << 12);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 84 to 99
	value = ((uint32_t)(input[10] & 0x0f) << 28) |
			((uint32_t)input[11] << 20) |
			((uint32_t)(input[12] & 0xf0) << 12);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 100 to 115
	value = ((uint32_t)(input[12] & 0x0f) << 28) |
			((uint32_t)input[13] << 20) |
			((uint32_t)(input[14] & 0xf0) << 12);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 116 to 131
	value = ((uint32_t)(input[14] & 0x0f) << 28) |
			((uint32_t)input[15] << 20) |
			((uint32_t)(input[16] & 0xf0) << 12);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 132 to 147
	value = ((uint32_t)(input[16] & 0x0f) << 28) |
			((uint32_t)input[17] << 20) |
			((uint32_t)(input[18] & 0xf0) << 12);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 148 to 163
	value = ((uint32_t)(input[18] & 0x0f) << 28) |
			((uint32_t)input[19] << 20) |
			((uint32_t)(input[20] & 0xf0) << 12);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 164 to 179
	value = ((uint32_t)(input[20] & 0x0f) << 28) |
			((uint32_t)input[21] << 20) |
			((uint32_t)(input[22] & 0xf0) << 12);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 180 to 195
	value = ((uint32_t)(input[22] & 0x0f) << 28) |
			((uint32_t)input[23] << 20) |
			((uint32_t)(input[24] & 0xf0) << 12);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 196 to 211
	value = ((uint32_t)(input[24] & 0x0f) << 28) |
			((uint32_t)input[25] << 20) |
			((uint32_t)(input[26] & 0xf0) << 12);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 212 to 227
	value = ((uint32_t)(input[26] & 0x0f) << 28) |
			((uint32_t)input[27] << 20) |
			((uint32_t)(input[28] & 0xf0) << 12);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 228 to 243
	value = ((uint32_t)(input[28] & 0x0f) << 28) |
			((uint32_t)input[29] << 20) |
			((uint32_t)(input[30] & 0xf0) << 12);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 244 to 259
	value = ((uint32_t)(input[30] & 0x0f) << 28) |
			((uint32_t)input[31] << 20) |
			((uint32_t)(input[32] & 0xf0) << 12);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 260 to 275
	value = ((uint32_t)(input[32] & 0x0f) << 28) |
			((uint32_t)input[33] << 20) |
			((uint32_t)(input[34] & 0xf0) << 12);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 276 to 291
	value = ((uint32_t)(input[34] & 0x0f) << 28) |
			((uint32_t)input[35] << 20) |
			((uint32_t)(input[36] & 0xf0) << 12);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 292 to 307
	value = ((uint32_t)(input[36] & 0x0f) << 28) |
			((uint32_t)input[37] << 20) |
			((uint32_t)(input[38] & 0xf0) << 12);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 308 to 323
	value = ((uint32_t)(input[38] & 0x0f) << 28) |
			((uint32_t)input[39] << 20) |
			((uint32_t)(input[40] & 0xf0) << 12);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 324 to 339
	value = ((uint32_t)(input[40] & 0x0f) << 28) |
			((uint32_t)input[41] << 20) |
			((uint32_t)(input[42] & 0xf0) << 12);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 340 to 355
	value = ((uint32_t)(input[42] & 0x0f) << 28) |
			((uint32_t)input[43] << 20) |
			((uint32_t)(input[44] & 0xf0) << 12);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 356 to 371
	value = ((uint32_t)(input[44] & 0x0f) << 28) |
			((uint32_t)input[45] << 20) |
			((uint32_t)(input[46] & 0xf0) << 12);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 372 to 387
	value = ((uint32_t)(input[46] & 0x0f) << 28) |
			((uint32_t)input[47] << 20) |
			((uint32_t)(input[48] & 0xf0) << 12);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 388 to 403
	value = ((uint32_t)(input[48] & 0x0f) << 28) |
			((uint32_t)input[49] << 20) |
			((uint32_t)(input[50] & 0xf0) << 12);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 404 to 419
	value = ((uint32_t)(input[50] & 0x0f) << 28) |
			((uint32_t)input[51] << 20) |
			((uint32_t)(input[52] & 0xf0) << 12);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 420 to 435
	value = ((uint32_t)(input[52] & 0x0f) << 28) |
			((uint32_t)input[53] << 20) |
			((uint32_t)(input[54] & 0xf0) << 12);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 436 to 451
	value = ((uint32_t)(input[54] & 0x0f) << 28) |
			((uint32_t)input[55] << 20) |
			((uint32_t)(input[56] & 0xf0) << 12);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 452 to 467
	value = ((uint32_t)(input[56] & 0x0f) << 28) |
			((uint32_t)input[57] << 20) |
			((uint32_t)(input[58] & 0xf0) << 12);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 468 to 483
	value = ((uint32_t)(input[58] & 0x0f) << 28) |
			((uint32_t)input[59] << 20) |
			((uint32_t)(input[60] & 0xf0) << 12);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 484 to 499
	value = ((uint32_t)(input[60] & 0x0f) << 28) |
			((uint32_t)input[61] << 20) |
			((uint32_t)(input[62] & 0xf0) << 12);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 500 to 515
	value = ((uint32_t)(input[62] & 0x0f) << 28) |
			((uint32_t)input[63] << 20) |
			((uint32_t)(input[64] & 0xf0) << 12);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 516 to 531
	value = ((uint32_t)(input[64] & 0x0f) << 28) |
			((uint32_t)input[65] << 20) |
			((uint32_t)(input[66] & 0xf0) << 12);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 532 to 547
	value = ((uint32_t)(input[66] & 0x0f) << 28) |
			((uint32_t)input[67] << 20) |
			((uint32_t)(input[68] & 0xf0) << 12);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 548 to 563
	value = ((uint32_t)(input[68] & 0x0f) << 28) |
			((uint32_t)input[69] << 20) |
			((uint32_t)(input[70] & 0xf0) << 12);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 564 to 579
	value = ((uint32_t)(input[70] & 0x0f) << 28) |
			((uint32_t)input[71] << 20) |
			((uint32_t)(input[72] & 0xf0) << 12);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 580 to 595
	value = ((uint32_t)(input[72] & 0x0f) << 28) |
			((uint32_t)input[73] << 20) |
			((uint32_t)(input[74] & 0xf0) << 12);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 596 to 611
	value = ((uint32_t)(input[74] & 0x0f) << 28) |
			((uint32_t)input[75] << 20) |
			((uint32_t)(input[76] & 0xf0) << 12);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 612 to 627
	value = ((uint32_t)(input[76] & 0x0f) << 28) |
			((uint32_t)input[77] << 20) |
			((uint32_t)(input[78] & 0xf0) << 12);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 628 to 643
	value = ((uint32_t)(input[78] & 0x0f) << 28) |
			((uint32_t)input[79] << 20) |
			((uint32_t)(input[80] & 0xf0) << 12);
	output[39] = (double)(value >> 16);

	// read output[40]: from bit 644 to 659
	value = ((uint32_t)(input[80] & 0x0f) << 28) |
			((uint32_t)input[81] << 20) |
			((uint32_t)(input[82] & 0xf0) << 12);
	output[40] = (double)(value >> 16);

	// read output[41]: from bit 660 to 675
	value = ((uint32_t)(input[82] & 0x0f) << 28) |
			((uint32_t)input[83] << 20) |
			((uint32_t)(input[84] & 0xf0) << 12);
	output[41] = (double)(value >> 16);

	// read output[42]: from bit 676 to 691
	value = ((uint32_t)(input[84] & 0x0f) << 28) |
			((uint32_t)input[85] << 20) |
			((uint32_t)(input[86] & 0xf0) << 12);
	output[42] = (double)(value >> 16);

	// read output[43]: from bit 692 to 707
	value = ((uint32_t)(input[86] & 0x0f) << 28) |
			((uint32_t)input[87] << 20) |
			((uint32_t)(input[88] & 0xf0) << 12);
	output[43] = (double)(value >> 16);

	// read output[44]: from bit 708 to 723
	value = ((uint32_t)(input[88] & 0x0f) << 28) |
			((uint32_t)input[89] << 20) |
			((uint32_t)(input[90] & 0xf0) << 12);
	output[44] = (double)(value >> 16);

	// read output[45]: from bit 724 to 739
	value = ((uint32_t)(input[90] & 0x0f) << 28) |
			((uint32_t)input[91] << 20) |
			((uint32_t)(input[92] & 0xf0) << 12);
	output[45] = (double)(value >> 16);

	// read output[46]: from bit 740 to 755
	value = ((uint32_t)(input[92] & 0x0f) << 28) |
			((uint32_t)input[93] << 20) |
			((uint32_t)(input[94] & 0xf0) << 12);
	output[46] = (double)(value >> 16);
}

static void unpack_47_16bit_unsigned_4off(const uint8_t * input, double * output, void *closure) {
	// Unpack 47 values into output
	// Values are 16-bit unsigned
	// Skip 4 bits, read 752 bits of data.
	// Input must be at least 95 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 4 to 19
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20) |
			((uint32_t)(input[2] & 0xf0) << 12);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 20 to 35
	value = ((uint32_t)(input[2] & 0x0f) << 28) |
			((uint32_t)input[3] << 20) |
			((uint32_t)(input[4] & 0xf0) << 12);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 36 to 51
	value = ((uint32_t)(input[4] & 0x0f) << 28) |
			((uint32_t)input[5] << 20) |
			((uint32_t)(input[6] & 0xf0) << 12);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 52 to 67
	value = ((uint32_t)(input[6] & 0x0f) << 28) |
			((uint32_t)input[7] << 20) |
			((uint32_t)(input[8] & 0xf0) << 12);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 68 to 83
	value = ((uint32_t)(input[8] & 0x0f) << 28) |
			((uint32_t)input[9] << 20) |
			((uint32_t)(input[10] & 0xf0) << 12);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 84 to 99
	value = ((uint32_t)(input[10] & 0x0f) << 28) |
			((uint32_t)input[11] << 20) |
			((uint32_t)(input[12] & 0xf0) << 12);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 100 to 115
	value = ((uint32_t)(input[12] & 0x0f) << 28) |
			((uint32_t)input[13] << 20) |
			((uint32_t)(input[14] & 0xf0) << 12);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 116 to 131
	value = ((uint32_t)(input[14] & 0x0f) << 28) |
			((uint32_t)input[15] << 20) |
			((uint32_t)(input[16] & 0xf0) << 12);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 132 to 147
	value = ((uint32_t)(input[16] & 0x0f) << 28) |
			((uint32_t)input[17] << 20) |
			((uint32_t)(input[18] & 0xf0) << 12);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 148 to 163
	value = ((uint32_t)(input[18] & 0x0f) << 28) |
			((uint32_t)input[19] << 20) |
			((uint32_t)(input[20] & 0xf0) << 12);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 164 to 179
	value = ((uint32_t)(input[20] & 0x0f) << 28) |
			((uint32_t)input[21] << 20) |
			((uint32_t)(input[22] & 0xf0) << 12);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 180 to 195
	value = ((uint32_t)(input[22] & 0x0f) << 28) |
			((uint32_t)input[23] << 20) |
			((uint32_t)(input[24] & 0xf0) << 12);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 196 to 211
	value = ((uint32_t)(input[24] & 0x0f) << 28) |
			((uint32_t)input[25] << 20) |
			((uint32_t)(input[26] & 0xf0) << 12);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 212 to 227
	value = ((uint32_t)(input[26] & 0x0f) << 28) |
			((uint32_t)input[27] << 20) |
			((uint32_t)(input[28] & 0xf0) << 12);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 228 to 243
	value = ((uint32_t)(input[28] & 0x0f) << 28) |
			((uint32_t)input[29] << 20) |
			((uint32_t)(input[30] & 0xf0) << 12);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 244 to 259
	value = ((uint32_t)(input[30] & 0x0f) << 28) |
			((uint32_t)input[31] << 20) |
			((uint32_t)(input[32] & 0xf0) << 12);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 260 to 275
	value = ((uint32_t)(input[32] & 0x0f) << 28) |
			((uint32_t)input[33] << 20) |
			((uint32_t)(input[34] & 0xf0) << 12);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 276 to 291
	value = ((uint32_t)(input[34] & 0x0f) << 28) |
			((uint32_t)input[35] << 20) |
			((uint32_t)(input[36] & 0xf0) << 12);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 292 to 307
	value = ((uint32_t)(input[36] & 0x0f) << 28) |
			((uint32_t)input[37] << 20) |
			((uint32_t)(input[38] & 0xf0) << 12);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 308 to 323
	value = ((uint32_t)(input[38] & 0x0f) << 28) |
			((uint32_t)input[39] << 20) |
			((uint32_t)(input[40] & 0xf0) << 12);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 324 to 339
	value = ((uint32_t)(input[40] & 0x0f) << 28) |
			((uint32_t)input[41] << 20) |
			((uint32_t)(input[42] & 0xf0) << 12);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 340 to 355
	value = ((uint32_t)(input[42] & 0x0f) << 28) |
			((uint32_t)input[43] << 20) |
			((uint32_t)(input[44] & 0xf0) << 12);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 356 to 371
	value = ((uint32_t)(input[44] & 0x0f) << 28) |
			((uint32_t)input[45] << 20) |
			((uint32_t)(input[46] & 0xf0) << 12);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 372 to 387
	value = ((uint32_t)(input[46] & 0x0f) << 28) |
			((uint32_t)input[47] << 20) |
			((uint32_t)(input[48] & 0xf0) << 12);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 388 to 403
	value = ((uint32_t)(input[48] & 0x0f) << 28) |
			((uint32_t)input[49] << 20) |
			((uint32_t)(input[50] & 0xf0) << 12);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 404 to 419
	value = ((uint32_t)(input[50] & 0x0f) << 28) |
			((uint32_t)input[51] << 20) |
			((uint32_t)(input[52] & 0xf0) << 12);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 420 to 435
	value = ((uint32_t)(input[52] & 0x0f) << 28) |
			((uint32_t)input[53] << 20) |
			((uint32_t)(input[54] & 0xf0) << 12);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 436 to 451
	value = ((uint32_t)(input[54] & 0x0f) << 28) |
			((uint32_t)input[55] << 20) |
			((uint32_t)(input[56] & 0xf0) << 12);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 452 to 467
	value = ((uint32_t)(input[56] & 0x0f) << 28) |
			((uint32_t)input[57] << 20) |
			((uint32_t)(input[58] & 0xf0) << 12);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 468 to 483
	value = ((uint32_t)(input[58] & 0x0f) << 28) |
			((uint32_t)input[59] << 20) |
			((uint32_t)(input[60] & 0xf0) << 12);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 484 to 499
	value = ((uint32_t)(input[60] & 0x0f) << 28) |
			((uint32_t)input[61] << 20) |
			((uint32_t)(input[62] & 0xf0) << 12);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 500 to 515
	value = ((uint32_t)(input[62] & 0x0f) << 28) |
			((uint32_t)input[63] << 20) |
			((uint32_t)(input[64] & 0xf0) << 12);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 516 to 531
	value = ((uint32_t)(input[64] & 0x0f) << 28) |
			((uint32_t)input[65] << 20) |
			((uint32_t)(input[66] & 0xf0) << 12);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 532 to 547
	value = ((uint32_t)(input[66] & 0x0f) << 28) |
			((uint32_t)input[67] << 20) |
			((uint32_t)(input[68] & 0xf0) << 12);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 548 to 563
	value = ((uint32_t)(input[68] & 0x0f) << 28) |
			((uint32_t)input[69] << 20) |
			((uint32_t)(input[70] & 0xf0) << 12);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 564 to 579
	value = ((uint32_t)(input[70] & 0x0f) << 28) |
			((uint32_t)input[71] << 20) |
			((uint32_t)(input[72] & 0xf0) << 12);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 580 to 595
	value = ((uint32_t)(input[72] & 0x0f) << 28) |
			((uint32_t)input[73] << 20) |
			((uint32_t)(input[74] & 0xf0) << 12);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 596 to 611
	value = ((uint32_t)(input[74] & 0x0f) << 28) |
			((uint32_t)input[75] << 20) |
			((uint32_t)(input[76] & 0xf0) << 12);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 612 to 627
	value = ((uint32_t)(input[76] & 0x0f) << 28) |
			((uint32_t)input[77] << 20) |
			((uint32_t)(input[78] & 0xf0) << 12);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 628 to 643
	value = ((uint32_t)(input[78] & 0x0f) << 28) |
			((uint32_t)input[79] << 20) |
			((uint32_t)(input[80] & 0xf0) << 12);
	output[39] = (double)(value >> 16);

	// read output[40]: from bit 644 to 659
	value = ((uint32_t)(input[80] & 0x0f) << 28) |
			((uint32_t)input[81] << 20) |
			((uint32_t)(input[82] & 0xf0) << 12);
	output[40] = (double)(value >> 16);

	// read output[41]: from bit 660 to 675
	value = ((uint32_t)(input[82] & 0x0f) << 28) |
			((uint32_t)input[83] << 20) |
			((uint32_t)(input[84] & 0xf0) << 12);
	output[41] = (double)(value >> 16);

	// read output[42]: from bit 676 to 691
	value = ((uint32_t)(input[84] & 0x0f) << 28) |
			((uint32_t)input[85] << 20) |
			((uint32_t)(input[86] & 0xf0) << 12);
	output[42] = (double)(value >> 16);

	// read output[43]: from bit 692 to 707
	value = ((uint32_t)(input[86] & 0x0f) << 28) |
			((uint32_t)input[87] << 20) |
			((uint32_t)(input[88] & 0xf0) << 12);
	output[43] = (double)(value >> 16);

	// read output[44]: from bit 708 to 723
	value = ((uint32_t)(input[88] & 0x0f) << 28) |
			((uint32_t)input[89] << 20) |
			((uint32_t)(input[90] & 0xf0) << 12);
	output[44] = (double)(value >> 16);

	// read output[45]: from bit 724 to 739
	value = ((uint32_t)(input[90] & 0x0f) << 28) |
			((uint32_t)input[91] << 20) |
			((uint32_t)(input[92] & 0xf0) << 12);
	output[45] = (double)(value >> 16);

	// read output[46]: from bit 740 to 755
	value = ((uint32_t)(input[92] & 0x0f) << 28) |
			((uint32_t)input[93] << 20) |
			((uint32_t)(input[94] & 0xf0) << 12);
	output[46] = (double)(value >> 16);
}

static void unpack_47_16bit_signed_5off(const uint8_t * input, double * output, void *closure) {
	// Unpack 47 values into output
	// Values are 16-bit signed
	// Skip 5 bits, read 752 bits of data.
	// Input must be at least 95 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 5 to 20
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)(input[2] & 0xf8) << 13);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 21 to 36
	value = ((uint32_t)(input[2] & 0x07) << 29) |
			((uint32_t)input[3] << 21) |
			((uint32_t)(input[4] & 0xf8) << 13);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 37 to 52
	value = ((uint32_t)(input[4] & 0x07) << 29) |
			((uint32_t)input[5] << 21) |
			((uint32_t)(input[6] & 0xf8) << 13);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 53 to 68
	value = ((uint32_t)(input[6] & 0x07) << 29) |
			((uint32_t)input[7] << 21) |
			((uint32_t)(input[8] & 0xf8) << 13);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 69 to 84
	value = ((uint32_t)(input[8] & 0x07) << 29) |
			((uint32_t)input[9] << 21) |
			((uint32_t)(input[10] & 0xf8) << 13);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 85 to 100
	value = ((uint32_t)(input[10] & 0x07) << 29) |
			((uint32_t)input[11] << 21) |
			((uint32_t)(input[12] & 0xf8) << 13);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 101 to 116
	value = ((uint32_t)(input[12] & 0x07) << 29) |
			((uint32_t)input[13] << 21) |
			((uint32_t)(input[14] & 0xf8) << 13);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 117 to 132
	value = ((uint32_t)(input[14] & 0x07) << 29) |
			((uint32_t)input[15] << 21) |
			((uint32_t)(input[16] & 0xf8) << 13);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 133 to 148
	value = ((uint32_t)(input[16] & 0x07) << 29) |
			((uint32_t)input[17] << 21) |
			((uint32_t)(input[18] & 0xf8) << 13);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 149 to 164
	value = ((uint32_t)(input[18] & 0x07) << 29) |
			((uint32_t)input[19] << 21) |
			((uint32_t)(input[20] & 0xf8) << 13);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 165 to 180
	value = ((uint32_t)(input[20] & 0x07) << 29) |
			((uint32_t)input[21] << 21) |
			((uint32_t)(input[22] & 0xf8) << 13);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 181 to 196
	value = ((uint32_t)(input[22] & 0x07) << 29) |
			((uint32_t)input[23] << 21) |
			((uint32_t)(input[24] & 0xf8) << 13);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 197 to 212
	value = ((uint32_t)(input[24] & 0x07) << 29) |
			((uint32_t)input[25] << 21) |
			((uint32_t)(input[26] & 0xf8) << 13);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 213 to 228
	value = ((uint32_t)(input[26] & 0x07) << 29) |
			((uint32_t)input[27] << 21) |
			((uint32_t)(input[28] & 0xf8) << 13);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 229 to 244
	value = ((uint32_t)(input[28] & 0x07) << 29) |
			((uint32_t)input[29] << 21) |
			((uint32_t)(input[30] & 0xf8) << 13);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 245 to 260
	value = ((uint32_t)(input[30] & 0x07) << 29) |
			((uint32_t)input[31] << 21) |
			((uint32_t)(input[32] & 0xf8) << 13);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 261 to 276
	value = ((uint32_t)(input[32] & 0x07) << 29) |
			((uint32_t)input[33] << 21) |
			((uint32_t)(input[34] & 0xf8) << 13);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 277 to 292
	value = ((uint32_t)(input[34] & 0x07) << 29) |
			((uint32_t)input[35] << 21) |
			((uint32_t)(input[36] & 0xf8) << 13);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 293 to 308
	value = ((uint32_t)(input[36] & 0x07) << 29) |
			((uint32_t)input[37] << 21) |
			((uint32_t)(input[38] & 0xf8) << 13);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 309 to 324
	value = ((uint32_t)(input[38] & 0x07) << 29) |
			((uint32_t)input[39] << 21) |
			((uint32_t)(input[40] & 0xf8) << 13);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 325 to 340
	value = ((uint32_t)(input[40] & 0x07) << 29) |
			((uint32_t)input[41] << 21) |
			((uint32_t)(input[42] & 0xf8) << 13);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 341 to 356
	value = ((uint32_t)(input[42] & 0x07) << 29) |
			((uint32_t)input[43] << 21) |
			((uint32_t)(input[44] & 0xf8) << 13);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 357 to 372
	value = ((uint32_t)(input[44] & 0x07) << 29) |
			((uint32_t)input[45] << 21) |
			((uint32_t)(input[46] & 0xf8) << 13);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 373 to 388
	value = ((uint32_t)(input[46] & 0x07) << 29) |
			((uint32_t)input[47] << 21) |
			((uint32_t)(input[48] & 0xf8) << 13);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 389 to 404
	value = ((uint32_t)(input[48] & 0x07) << 29) |
			((uint32_t)input[49] << 21) |
			((uint32_t)(input[50] & 0xf8) << 13);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 405 to 420
	value = ((uint32_t)(input[50] & 0x07) << 29) |
			((uint32_t)input[51] << 21) |
			((uint32_t)(input[52] & 0xf8) << 13);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 421 to 436
	value = ((uint32_t)(input[52] & 0x07) << 29) |
			((uint32_t)input[53] << 21) |
			((uint32_t)(input[54] & 0xf8) << 13);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 437 to 452
	value = ((uint32_t)(input[54] & 0x07) << 29) |
			((uint32_t)input[55] << 21) |
			((uint32_t)(input[56] & 0xf8) << 13);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 453 to 468
	value = ((uint32_t)(input[56] & 0x07) << 29) |
			((uint32_t)input[57] << 21) |
			((uint32_t)(input[58] & 0xf8) << 13);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 469 to 484
	value = ((uint32_t)(input[58] & 0x07) << 29) |
			((uint32_t)input[59] << 21) |
			((uint32_t)(input[60] & 0xf8) << 13);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 485 to 500
	value = ((uint32_t)(input[60] & 0x07) << 29) |
			((uint32_t)input[61] << 21) |
			((uint32_t)(input[62] & 0xf8) << 13);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 501 to 516
	value = ((uint32_t)(input[62] & 0x07) << 29) |
			((uint32_t)input[63] << 21) |
			((uint32_t)(input[64] & 0xf8) << 13);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 517 to 532
	value = ((uint32_t)(input[64] & 0x07) << 29) |
			((uint32_t)input[65] << 21) |
			((uint32_t)(input[66] & 0xf8) << 13);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 533 to 548
	value = ((uint32_t)(input[66] & 0x07) << 29) |
			((uint32_t)input[67] << 21) |
			((uint32_t)(input[68] & 0xf8) << 13);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 549 to 564
	value = ((uint32_t)(input[68] & 0x07) << 29) |
			((uint32_t)input[69] << 21) |
			((uint32_t)(input[70] & 0xf8) << 13);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 565 to 580
	value = ((uint32_t)(input[70] & 0x07) << 29) |
			((uint32_t)input[71] << 21) |
			((uint32_t)(input[72] & 0xf8) << 13);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 581 to 596
	value = ((uint32_t)(input[72] & 0x07) << 29) |
			((uint32_t)input[73] << 21) |
			((uint32_t)(input[74] & 0xf8) << 13);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 597 to 612
	value = ((uint32_t)(input[74] & 0x07) << 29) |
			((uint32_t)input[75] << 21) |
			((uint32_t)(input[76] & 0xf8) << 13);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 613 to 628
	value = ((uint32_t)(input[76] & 0x07) << 29) |
			((uint32_t)input[77] << 21) |
			((uint32_t)(input[78] & 0xf8) << 13);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 629 to 644
	value = ((uint32_t)(input[78] & 0x07) << 29) |
			((uint32_t)input[79] << 21) |
			((uint32_t)(input[80] & 0xf8) << 13);
	output[39] = (double)(value >> 16);

	// read output[40]: from bit 645 to 660
	value = ((uint32_t)(input[80] & 0x07) << 29) |
			((uint32_t)input[81] << 21) |
			((uint32_t)(input[82] & 0xf8) << 13);
	output[40] = (double)(value >> 16);

	// read output[41]: from bit 661 to 676
	value = ((uint32_t)(input[82] & 0x07) << 29) |
			((uint32_t)input[83] << 21) |
			((uint32_t)(input[84] & 0xf8) << 13);
	output[41] = (double)(value >> 16);

	// read output[42]: from bit 677 to 692
	value = ((uint32_t)(input[84] & 0x07) << 29) |
			((uint32_t)input[85] << 21) |
			((uint32_t)(input[86] & 0xf8) << 13);
	output[42] = (double)(value >> 16);

	// read output[43]: from bit 693 to 708
	value = ((uint32_t)(input[86] & 0x07) << 29) |
			((uint32_t)input[87] << 21) |
			((uint32_t)(input[88] & 0xf8) << 13);
	output[43] = (double)(value >> 16);

	// read output[44]: from bit 709 to 724
	value = ((uint32_t)(input[88] & 0x07) << 29) |
			((uint32_t)input[89] << 21) |
			((uint32_t)(input[90] & 0xf8) << 13);
	output[44] = (double)(value >> 16);

	// read output[45]: from bit 725 to 740
	value = ((uint32_t)(input[90] & 0x07) << 29) |
			((uint32_t)input[91] << 21) |
			((uint32_t)(input[92] & 0xf8) << 13);
	output[45] = (double)(value >> 16);

	// read output[46]: from bit 741 to 756
	value = ((uint32_t)(input[92] & 0x07) << 29) |
			((uint32_t)input[93] << 21) |
			((uint32_t)(input[94] & 0xf8) << 13);
	output[46] = (double)(value >> 16);
}

static void unpack_47_16bit_unsigned_5off(const uint8_t * input, double * output, void *closure) {
	// Unpack 47 values into output
	// Values are 16-bit unsigned
	// Skip 5 bits, read 752 bits of data.
	// Input must be at least 95 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 5 to 20
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)(input[2] & 0xf8) << 13);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 21 to 36
	value = ((uint32_t)(input[2] & 0x07) << 29) |
			((uint32_t)input[3] << 21) |
			((uint32_t)(input[4] & 0xf8) << 13);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 37 to 52
	value = ((uint32_t)(input[4] & 0x07) << 29) |
			((uint32_t)input[5] << 21) |
			((uint32_t)(input[6] & 0xf8) << 13);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 53 to 68
	value = ((uint32_t)(input[6] & 0x07) << 29) |
			((uint32_t)input[7] << 21) |
			((uint32_t)(input[8] & 0xf8) << 13);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 69 to 84
	value = ((uint32_t)(input[8] & 0x07) << 29) |
			((uint32_t)input[9] << 21) |
			((uint32_t)(input[10] & 0xf8) << 13);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 85 to 100
	value = ((uint32_t)(input[10] & 0x07) << 29) |
			((uint32_t)input[11] << 21) |
			((uint32_t)(input[12] & 0xf8) << 13);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 101 to 116
	value = ((uint32_t)(input[12] & 0x07) << 29) |
			((uint32_t)input[13] << 21) |
			((uint32_t)(input[14] & 0xf8) << 13);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 117 to 132
	value = ((uint32_t)(input[14] & 0x07) << 29) |
			((uint32_t)input[15] << 21) |
			((uint32_t)(input[16] & 0xf8) << 13);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 133 to 148
	value = ((uint32_t)(input[16] & 0x07) << 29) |
			((uint32_t)input[17] << 21) |
			((uint32_t)(input[18] & 0xf8) << 13);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 149 to 164
	value = ((uint32_t)(input[18] & 0x07) << 29) |
			((uint32_t)input[19] << 21) |
			((uint32_t)(input[20] & 0xf8) << 13);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 165 to 180
	value = ((uint32_t)(input[20] & 0x07) << 29) |
			((uint32_t)input[21] << 21) |
			((uint32_t)(input[22] & 0xf8) << 13);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 181 to 196
	value = ((uint32_t)(input[22] & 0x07) << 29) |
			((uint32_t)input[23] << 21) |
			((uint32_t)(input[24] & 0xf8) << 13);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 197 to 212
	value = ((uint32_t)(input[24] & 0x07) << 29) |
			((uint32_t)input[25] << 21) |
			((uint32_t)(input[26] & 0xf8) << 13);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 213 to 228
	value = ((uint32_t)(input[26] & 0x07) << 29) |
			((uint32_t)input[27] << 21) |
			((uint32_t)(input[28] & 0xf8) << 13);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 229 to 244
	value = ((uint32_t)(input[28] & 0x07) << 29) |
			((uint32_t)input[29] << 21) |
			((uint32_t)(input[30] & 0xf8) << 13);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 245 to 260
	value = ((uint32_t)(input[30] & 0x07) << 29) |
			((uint32_t)input[31] << 21) |
			((uint32_t)(input[32] & 0xf8) << 13);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 261 to 276
	value = ((uint32_t)(input[32] & 0x07) << 29) |
			((uint32_t)input[33] << 21) |
			((uint32_t)(input[34] & 0xf8) << 13);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 277 to 292
	value = ((uint32_t)(input[34] & 0x07) << 29) |
			((uint32_t)input[35] << 21) |
			((uint32_t)(input[36] & 0xf8) << 13);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 293 to 308
	value = ((uint32_t)(input[36] & 0x07) << 29) |
			((uint32_t)input[37] << 21) |
			((uint32_t)(input[38] & 0xf8) << 13);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 309 to 324
	value = ((uint32_t)(input[38] & 0x07) << 29) |
			((uint32_t)input[39] << 21) |
			((uint32_t)(input[40] & 0xf8) << 13);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 325 to 340
	value = ((uint32_t)(input[40] & 0x07) << 29) |
			((uint32_t)input[41] << 21) |
			((uint32_t)(input[42] & 0xf8) << 13);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 341 to 356
	value = ((uint32_t)(input[42] & 0x07) << 29) |
			((uint32_t)input[43] << 21) |
			((uint32_t)(input[44] & 0xf8) << 13);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 357 to 372
	value = ((uint32_t)(input[44] & 0x07) << 29) |
			((uint32_t)input[45] << 21) |
			((uint32_t)(input[46] & 0xf8) << 13);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 373 to 388
	value = ((uint32_t)(input[46] & 0x07) << 29) |
			((uint32_t)input[47] << 21) |
			((uint32_t)(input[48] & 0xf8) << 13);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 389 to 404
	value = ((uint32_t)(input[48] & 0x07) << 29) |
			((uint32_t)input[49] << 21) |
			((uint32_t)(input[50] & 0xf8) << 13);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 405 to 420
	value = ((uint32_t)(input[50] & 0x07) << 29) |
			((uint32_t)input[51] << 21) |
			((uint32_t)(input[52] & 0xf8) << 13);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 421 to 436
	value = ((uint32_t)(input[52] & 0x07) << 29) |
			((uint32_t)input[53] << 21) |
			((uint32_t)(input[54] & 0xf8) << 13);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 437 to 452
	value = ((uint32_t)(input[54] & 0x07) << 29) |
			((uint32_t)input[55] << 21) |
			((uint32_t)(input[56] & 0xf8) << 13);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 453 to 468
	value = ((uint32_t)(input[56] & 0x07) << 29) |
			((uint32_t)input[57] << 21) |
			((uint32_t)(input[58] & 0xf8) << 13);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 469 to 484
	value = ((uint32_t)(input[58] & 0x07) << 29) |
			((uint32_t)input[59] << 21) |
			((uint32_t)(input[60] & 0xf8) << 13);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 485 to 500
	value = ((uint32_t)(input[60] & 0x07) << 29) |
			((uint32_t)input[61] << 21) |
			((uint32_t)(input[62] & 0xf8) << 13);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 501 to 516
	value = ((uint32_t)(input[62] & 0x07) << 29) |
			((uint32_t)input[63] << 21) |
			((uint32_t)(input[64] & 0xf8) << 13);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 517 to 532
	value = ((uint32_t)(input[64] & 0x07) << 29) |
			((uint32_t)input[65] << 21) |
			((uint32_t)(input[66] & 0xf8) << 13);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 533 to 548
	value = ((uint32_t)(input[66] & 0x07) << 29) |
			((uint32_t)input[67] << 21) |
			((uint32_t)(input[68] & 0xf8) << 13);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 549 to 564
	value = ((uint32_t)(input[68] & 0x07) << 29) |
			((uint32_t)input[69] << 21) |
			((uint32_t)(input[70] & 0xf8) << 13);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 565 to 580
	value = ((uint32_t)(input[70] & 0x07) << 29) |
			((uint32_t)input[71] << 21) |
			((uint32_t)(input[72] & 0xf8) << 13);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 581 to 596
	value = ((uint32_t)(input[72] & 0x07) << 29) |
			((uint32_t)input[73] << 21) |
			((uint32_t)(input[74] & 0xf8) << 13);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 597 to 612
	value = ((uint32_t)(input[74] & 0x07) << 29) |
			((uint32_t)input[75] << 21) |
			((uint32_t)(input[76] & 0xf8) << 13);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 613 to 628
	value = ((uint32_t)(input[76] & 0x07) << 29) |
			((uint32_t)input[77] << 21) |
			((uint32_t)(input[78] & 0xf8) << 13);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 629 to 644
	value = ((uint32_t)(input[78] & 0x07) << 29) |
			((uint32_t)input[79] << 21) |
			((uint32_t)(input[80] & 0xf8) << 13);
	output[39] = (double)(value >> 16);

	// read output[40]: from bit 645 to 660
	value = ((uint32_t)(input[80] & 0x07) << 29) |
			((uint32_t)input[81] << 21) |
			((uint32_t)(input[82] & 0xf8) << 13);
	output[40] = (double)(value >> 16);

	// read output[41]: from bit 661 to 676
	value = ((uint32_t)(input[82] & 0x07) << 29) |
			((uint32_t)input[83] << 21) |
			((uint32_t)(input[84] & 0xf8) << 13);
	output[41] = (double)(value >> 16);

	// read output[42]: from bit 677 to 692
	value = ((uint32_t)(input[84] & 0x07) << 29) |
			((uint32_t)input[85] << 21) |
			((uint32_t)(input[86] & 0xf8) << 13);
	output[42] = (double)(value >> 16);

	// read output[43]: from bit 693 to 708
	value = ((uint32_t)(input[86] & 0x07) << 29) |
			((uint32_t)input[87] << 21) |
			((uint32_t)(input[88] & 0xf8) << 13);
	output[43] = (double)(value >> 16);

	// read output[44]: from bit 709 to 724
	value = ((uint32_t)(input[88] & 0x07) << 29) |
			((uint32_t)input[89] << 21) |
			((uint32_t)(input[90] & 0xf8) << 13);
	output[44] = (double)(value >> 16);

	// read output[45]: from bit 725 to 740
	value = ((uint32_t)(input[90] & 0x07) << 29) |
			((uint32_t)input[91] << 21) |
			((uint32_t)(input[92] & 0xf8) << 13);
	output[45] = (double)(value >> 16);

	// read output[46]: from bit 741 to 756
	value = ((uint32_t)(input[92] & 0x07) << 29) |
			((uint32_t)input[93] << 21) |
			((uint32_t)(input[94] & 0xf8) << 13);
	output[46] = (double)(value >> 16);
}

static void unpack_47_16bit_signed_6off(const uint8_t * input, double * output, void *closure) {
	// Unpack 47 values into output
	// Values are 16-bit signed
	// Skip 6 bits, read 752 bits of data.
	// Input must be at least 95 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 6 to 21
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)(input[2] & 0xfc) << 14);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 22 to 37
	value = ((uint32_t)(input[2] & 0x03) << 30) |
			((uint32_t)input[3] << 22) |
			((uint32_t)(input[4] & 0xfc) << 14);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 38 to 53
	value = ((uint32_t)(input[4] & 0x03) << 30) |
			((uint32_t)input[5] << 22) |
			((uint32_t)(input[6] & 0xfc) << 14);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 54 to 69
	value = ((uint32_t)(input[6] & 0x03) << 30) |
			((uint32_t)input[7] << 22) |
			((uint32_t)(input[8] & 0xfc) << 14);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 70 to 85
	value = ((uint32_t)(input[8] & 0x03) << 30) |
			((uint32_t)input[9] << 22) |
			((uint32_t)(input[10] & 0xfc) << 14);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 86 to 101
	value = ((uint32_t)(input[10] & 0x03) << 30) |
			((uint32_t)input[11] << 22) |
			((uint32_t)(input[12] & 0xfc) << 14);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 102 to 117
	value = ((uint32_t)(input[12] & 0x03) << 30) |
			((uint32_t)input[13] << 22) |
			((uint32_t)(input[14] & 0xfc) << 14);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 118 to 133
	value = ((uint32_t)(input[14] & 0x03) << 30) |
			((uint32_t)input[15] << 22) |
			((uint32_t)(input[16] & 0xfc) << 14);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 134 to 149
	value = ((uint32_t)(input[16] & 0x03) << 30) |
			((uint32_t)input[17] << 22) |
			((uint32_t)(input[18] & 0xfc) << 14);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 150 to 165
	value = ((uint32_t)(input[18] & 0x03) << 30) |
			((uint32_t)input[19] << 22) |
			((uint32_t)(input[20] & 0xfc) << 14);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 166 to 181
	value = ((uint32_t)(input[20] & 0x03) << 30) |
			((uint32_t)input[21] << 22) |
			((uint32_t)(input[22] & 0xfc) << 14);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 182 to 197
	value = ((uint32_t)(input[22] & 0x03) << 30) |
			((uint32_t)input[23] << 22) |
			((uint32_t)(input[24] & 0xfc) << 14);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 198 to 213
	value = ((uint32_t)(input[24] & 0x03) << 30) |
			((uint32_t)input[25] << 22) |
			((uint32_t)(input[26] & 0xfc) << 14);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 214 to 229
	value = ((uint32_t)(input[26] & 0x03) << 30) |
			((uint32_t)input[27] << 22) |
			((uint32_t)(input[28] & 0xfc) << 14);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 230 to 245
	value = ((uint32_t)(input[28] & 0x03) << 30) |
			((uint32_t)input[29] << 22) |
			((uint32_t)(input[30] & 0xfc) << 14);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 246 to 261
	value = ((uint32_t)(input[30] & 0x03) << 30) |
			((uint32_t)input[31] << 22) |
			((uint32_t)(input[32] & 0xfc) << 14);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 262 to 277
	value = ((uint32_t)(input[32] & 0x03) << 30) |
			((uint32_t)input[33] << 22) |
			((uint32_t)(input[34] & 0xfc) << 14);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 278 to 293
	value = ((uint32_t)(input[34] & 0x03) << 30) |
			((uint32_t)input[35] << 22) |
			((uint32_t)(input[36] & 0xfc) << 14);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 294 to 309
	value = ((uint32_t)(input[36] & 0x03) << 30) |
			((uint32_t)input[37] << 22) |
			((uint32_t)(input[38] & 0xfc) << 14);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 310 to 325
	value = ((uint32_t)(input[38] & 0x03) << 30) |
			((uint32_t)input[39] << 22) |
			((uint32_t)(input[40] & 0xfc) << 14);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 326 to 341
	value = ((uint32_t)(input[40] & 0x03) << 30) |
			((uint32_t)input[41] << 22) |
			((uint32_t)(input[42] & 0xfc) << 14);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 342 to 357
	value = ((uint32_t)(input[42] & 0x03) << 30) |
			((uint32_t)input[43] << 22) |
			((uint32_t)(input[44] & 0xfc) << 14);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 358 to 373
	value = ((uint32_t)(input[44] & 0x03) << 30) |
			((uint32_t)input[45] << 22) |
			((uint32_t)(input[46] & 0xfc) << 14);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 374 to 389
	value = ((uint32_t)(input[46] & 0x03) << 30) |
			((uint32_t)input[47] << 22) |
			((uint32_t)(input[48] & 0xfc) << 14);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 390 to 405
	value = ((uint32_t)(input[48] & 0x03) << 30) |
			((uint32_t)input[49] << 22) |
			((uint32_t)(input[50] & 0xfc) << 14);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 406 to 421
	value = ((uint32_t)(input[50] & 0x03) << 30) |
			((uint32_t)input[51] << 22) |
			((uint32_t)(input[52] & 0xfc) << 14);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 422 to 437
	value = ((uint32_t)(input[52] & 0x03) << 30) |
			((uint32_t)input[53] << 22) |
			((uint32_t)(input[54] & 0xfc) << 14);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 438 to 453
	value = ((uint32_t)(input[54] & 0x03) << 30) |
			((uint32_t)input[55] << 22) |
			((uint32_t)(input[56] & 0xfc) << 14);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 454 to 469
	value = ((uint32_t)(input[56] & 0x03) << 30) |
			((uint32_t)input[57] << 22) |
			((uint32_t)(input[58] & 0xfc) << 14);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 470 to 485
	value = ((uint32_t)(input[58] & 0x03) << 30) |
			((uint32_t)input[59] << 22) |
			((uint32_t)(input[60] & 0xfc) << 14);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 486 to 501
	value = ((uint32_t)(input[60] & 0x03) << 30) |
			((uint32_t)input[61] << 22) |
			((uint32_t)(input[62] & 0xfc) << 14);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 502 to 517
	value = ((uint32_t)(input[62] & 0x03) << 30) |
			((uint32_t)input[63] << 22) |
			((uint32_t)(input[64] & 0xfc) << 14);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 518 to 533
	value = ((uint32_t)(input[64] & 0x03) << 30) |
			((uint32_t)input[65] << 22) |
			((uint32_t)(input[66] & 0xfc) << 14);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 534 to 549
	value = ((uint32_t)(input[66] & 0x03) << 30) |
			((uint32_t)input[67] << 22) |
			((uint32_t)(input[68] & 0xfc) << 14);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 550 to 565
	value = ((uint32_t)(input[68] & 0x03) << 30) |
			((uint32_t)input[69] << 22) |
			((uint32_t)(input[70] & 0xfc) << 14);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 566 to 581
	value = ((uint32_t)(input[70] & 0x03) << 30) |
			((uint32_t)input[71] << 22) |
			((uint32_t)(input[72] & 0xfc) << 14);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 582 to 597
	value = ((uint32_t)(input[72] & 0x03) << 30) |
			((uint32_t)input[73] << 22) |
			((uint32_t)(input[74] & 0xfc) << 14);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 598 to 613
	value = ((uint32_t)(input[74] & 0x03) << 30) |
			((uint32_t)input[75] << 22) |
			((uint32_t)(input[76] & 0xfc) << 14);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 614 to 629
	value = ((uint32_t)(input[76] & 0x03) << 30) |
			((uint32_t)input[77] << 22) |
			((uint32_t)(input[78] & 0xfc) << 14);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 630 to 645
	value = ((uint32_t)(input[78] & 0x03) << 30) |
			((uint32_t)input[79] << 22) |
			((uint32_t)(input[80] & 0xfc) << 14);
	output[39] = (double)(value >> 16);

	// read output[40]: from bit 646 to 661
	value = ((uint32_t)(input[80] & 0x03) << 30) |
			((uint32_t)input[81] << 22) |
			((uint32_t)(input[82] & 0xfc) << 14);
	output[40] = (double)(value >> 16);

	// read output[41]: from bit 662 to 677
	value = ((uint32_t)(input[82] & 0x03) << 30) |
			((uint32_t)input[83] << 22) |
			((uint32_t)(input[84] & 0xfc) << 14);
	output[41] = (double)(value >> 16);

	// read output[42]: from bit 678 to 693
	value = ((uint32_t)(input[84] & 0x03) << 30) |
			((uint32_t)input[85] << 22) |
			((uint32_t)(input[86] & 0xfc) << 14);
	output[42] = (double)(value >> 16);

	// read output[43]: from bit 694 to 709
	value = ((uint32_t)(input[86] & 0x03) << 30) |
			((uint32_t)input[87] << 22) |
			((uint32_t)(input[88] & 0xfc) << 14);
	output[43] = (double)(value >> 16);

	// read output[44]: from bit 710 to 725
	value = ((uint32_t)(input[88] & 0x03) << 30) |
			((uint32_t)input[89] << 22) |
			((uint32_t)(input[90] & 0xfc) << 14);
	output[44] = (double)(value >> 16);

	// read output[45]: from bit 726 to 741
	value = ((uint32_t)(input[90] & 0x03) << 30) |
			((uint32_t)input[91] << 22) |
			((uint32_t)(input[92] & 0xfc) << 14);
	output[45] = (double)(value >> 16);

	// read output[46]: from bit 742 to 757
	value = ((uint32_t)(input[92] & 0x03) << 30) |
			((uint32_t)input[93] << 22) |
			((uint32_t)(input[94] & 0xfc) << 14);
	output[46] = (double)(value >> 16);
}

static void unpack_47_16bit_unsigned_6off(const uint8_t * input, double * output, void *closure) {
	// Unpack 47 values into output
	// Values are 16-bit unsigned
	// Skip 6 bits, read 752 bits of data.
	// Input must be at least 95 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 6 to 21
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)(input[2] & 0xfc) << 14);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 22 to 37
	value = ((uint32_t)(input[2] & 0x03) << 30) |
			((uint32_t)input[3] << 22) |
			((uint32_t)(input[4] & 0xfc) << 14);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 38 to 53
	value = ((uint32_t)(input[4] & 0x03) << 30) |
			((uint32_t)input[5] << 22) |
			((uint32_t)(input[6] & 0xfc) << 14);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 54 to 69
	value = ((uint32_t)(input[6] & 0x03) << 30) |
			((uint32_t)input[7] << 22) |
			((uint32_t)(input[8] & 0xfc) << 14);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 70 to 85
	value = ((uint32_t)(input[8] & 0x03) << 30) |
			((uint32_t)input[9] << 22) |
			((uint32_t)(input[10] & 0xfc) << 14);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 86 to 101
	value = ((uint32_t)(input[10] & 0x03) << 30) |
			((uint32_t)input[11] << 22) |
			((uint32_t)(input[12] & 0xfc) << 14);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 102 to 117
	value = ((uint32_t)(input[12] & 0x03) << 30) |
			((uint32_t)input[13] << 22) |
			((uint32_t)(input[14] & 0xfc) << 14);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 118 to 133
	value = ((uint32_t)(input[14] & 0x03) << 30) |
			((uint32_t)input[15] << 22) |
			((uint32_t)(input[16] & 0xfc) << 14);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 134 to 149
	value = ((uint32_t)(input[16] & 0x03) << 30) |
			((uint32_t)input[17] << 22) |
			((uint32_t)(input[18] & 0xfc) << 14);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 150 to 165
	value = ((uint32_t)(input[18] & 0x03) << 30) |
			((uint32_t)input[19] << 22) |
			((uint32_t)(input[20] & 0xfc) << 14);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 166 to 181
	value = ((uint32_t)(input[20] & 0x03) << 30) |
			((uint32_t)input[21] << 22) |
			((uint32_t)(input[22] & 0xfc) << 14);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 182 to 197
	value = ((uint32_t)(input[22] & 0x03) << 30) |
			((uint32_t)input[23] << 22) |
			((uint32_t)(input[24] & 0xfc) << 14);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 198 to 213
	value = ((uint32_t)(input[24] & 0x03) << 30) |
			((uint32_t)input[25] << 22) |
			((uint32_t)(input[26] & 0xfc) << 14);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 214 to 229
	value = ((uint32_t)(input[26] & 0x03) << 30) |
			((uint32_t)input[27] << 22) |
			((uint32_t)(input[28] & 0xfc) << 14);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 230 to 245
	value = ((uint32_t)(input[28] & 0x03) << 30) |
			((uint32_t)input[29] << 22) |
			((uint32_t)(input[30] & 0xfc) << 14);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 246 to 261
	value = ((uint32_t)(input[30] & 0x03) << 30) |
			((uint32_t)input[31] << 22) |
			((uint32_t)(input[32] & 0xfc) << 14);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 262 to 277
	value = ((uint32_t)(input[32] & 0x03) << 30) |
			((uint32_t)input[33] << 22) |
			((uint32_t)(input[34] & 0xfc) << 14);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 278 to 293
	value = ((uint32_t)(input[34] & 0x03) << 30) |
			((uint32_t)input[35] << 22) |
			((uint32_t)(input[36] & 0xfc) << 14);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 294 to 309
	value = ((uint32_t)(input[36] & 0x03) << 30) |
			((uint32_t)input[37] << 22) |
			((uint32_t)(input[38] & 0xfc) << 14);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 310 to 325
	value = ((uint32_t)(input[38] & 0x03) << 30) |
			((uint32_t)input[39] << 22) |
			((uint32_t)(input[40] & 0xfc) << 14);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 326 to 341
	value = ((uint32_t)(input[40] & 0x03) << 30) |
			((uint32_t)input[41] << 22) |
			((uint32_t)(input[42] & 0xfc) << 14);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 342 to 357
	value = ((uint32_t)(input[42] & 0x03) << 30) |
			((uint32_t)input[43] << 22) |
			((uint32_t)(input[44] & 0xfc) << 14);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 358 to 373
	value = ((uint32_t)(input[44] & 0x03) << 30) |
			((uint32_t)input[45] << 22) |
			((uint32_t)(input[46] & 0xfc) << 14);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 374 to 389
	value = ((uint32_t)(input[46] & 0x03) << 30) |
			((uint32_t)input[47] << 22) |
			((uint32_t)(input[48] & 0xfc) << 14);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 390 to 405
	value = ((uint32_t)(input[48] & 0x03) << 30) |
			((uint32_t)input[49] << 22) |
			((uint32_t)(input[50] & 0xfc) << 14);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 406 to 421
	value = ((uint32_t)(input[50] & 0x03) << 30) |
			((uint32_t)input[51] << 22) |
			((uint32_t)(input[52] & 0xfc) << 14);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 422 to 437
	value = ((uint32_t)(input[52] & 0x03) << 30) |
			((uint32_t)input[53] << 22) |
			((uint32_t)(input[54] & 0xfc) << 14);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 438 to 453
	value = ((uint32_t)(input[54] & 0x03) << 30) |
			((uint32_t)input[55] << 22) |
			((uint32_t)(input[56] & 0xfc) << 14);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 454 to 469
	value = ((uint32_t)(input[56] & 0x03) << 30) |
			((uint32_t)input[57] << 22) |
			((uint32_t)(input[58] & 0xfc) << 14);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 470 to 485
	value = ((uint32_t)(input[58] & 0x03) << 30) |
			((uint32_t)input[59] << 22) |
			((uint32_t)(input[60] & 0xfc) << 14);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 486 to 501
	value = ((uint32_t)(input[60] & 0x03) << 30) |
			((uint32_t)input[61] << 22) |
			((uint32_t)(input[62] & 0xfc) << 14);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 502 to 517
	value = ((uint32_t)(input[62] & 0x03) << 30) |
			((uint32_t)input[63] << 22) |
			((uint32_t)(input[64] & 0xfc) << 14);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 518 to 533
	value = ((uint32_t)(input[64] & 0x03) << 30) |
			((uint32_t)input[65] << 22) |
			((uint32_t)(input[66] & 0xfc) << 14);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 534 to 549
	value = ((uint32_t)(input[66] & 0x03) << 30) |
			((uint32_t)input[67] << 22) |
			((uint32_t)(input[68] & 0xfc) << 14);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 550 to 565
	value = ((uint32_t)(input[68] & 0x03) << 30) |
			((uint32_t)input[69] << 22) |
			((uint32_t)(input[70] & 0xfc) << 14);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 566 to 581
	value = ((uint32_t)(input[70] & 0x03) << 30) |
			((uint32_t)input[71] << 22) |
			((uint32_t)(input[72] & 0xfc) << 14);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 582 to 597
	value = ((uint32_t)(input[72] & 0x03) << 30) |
			((uint32_t)input[73] << 22) |
			((uint32_t)(input[74] & 0xfc) << 14);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 598 to 613
	value = ((uint32_t)(input[74] & 0x03) << 30) |
			((uint32_t)input[75] << 22) |
			((uint32_t)(input[76] & 0xfc) << 14);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 614 to 629
	value = ((uint32_t)(input[76] & 0x03) << 30) |
			((uint32_t)input[77] << 22) |
			((uint32_t)(input[78] & 0xfc) << 14);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 630 to 645
	value = ((uint32_t)(input[78] & 0x03) << 30) |
			((uint32_t)input[79] << 22) |
			((uint32_t)(input[80] & 0xfc) << 14);
	output[39] = (double)(value >> 16);

	// read output[40]: from bit 646 to 661
	value = ((uint32_t)(input[80] & 0x03) << 30) |
			((uint32_t)input[81] << 22) |
			((uint32_t)(input[82] & 0xfc) << 14);
	output[40] = (double)(value >> 16);

	// read output[41]: from bit 662 to 677
	value = ((uint32_t)(input[82] & 0x03) << 30) |
			((uint32_t)input[83] << 22) |
			((uint32_t)(input[84] & 0xfc) << 14);
	output[41] = (double)(value >> 16);

	// read output[42]: from bit 678 to 693
	value = ((uint32_t)(input[84] & 0x03) << 30) |
			((uint32_t)input[85] << 22) |
			((uint32_t)(input[86] & 0xfc) << 14);
	output[42] = (double)(value >> 16);

	// read output[43]: from bit 694 to 709
	value = ((uint32_t)(input[86] & 0x03) << 30) |
			((uint32_t)input[87] << 22) |
			((uint32_t)(input[88] & 0xfc) << 14);
	output[43] = (double)(value >> 16);

	// read output[44]: from bit 710 to 725
	value = ((uint32_t)(input[88] & 0x03) << 30) |
			((uint32_t)input[89] << 22) |
			((uint32_t)(input[90] & 0xfc) << 14);
	output[44] = (double)(value >> 16);

	// read output[45]: from bit 726 to 741
	value = ((uint32_t)(input[90] & 0x03) << 30) |
			((uint32_t)input[91] << 22) |
			((uint32_t)(input[92] & 0xfc) << 14);
	output[45] = (double)(value >> 16);

	// read output[46]: from bit 742 to 757
	value = ((uint32_t)(input[92] & 0x03) << 30) |
			((uint32_t)input[93] << 22) |
			((uint32_t)(input[94] & 0xfc) << 14);
	output[46] = (double)(value >> 16);
}

static void unpack_47_16bit_signed_7off(const uint8_t * input, double * output, void *closure) {
	// Unpack 47 values into output
	// Values are 16-bit signed
	// Skip 7 bits, read 752 bits of data.
	// Input must be at least 95 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 7 to 22
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)(input[2] & 0xfe) << 15);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 23 to 38
	value = ((uint32_t)(input[2] & 0x01) << 31) |
			((uint32_t)input[3] << 23) |
			((uint32_t)(input[4] & 0xfe) << 15);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 39 to 54
	value = ((uint32_t)(input[4] & 0x01) << 31) |
			((uint32_t)input[5] << 23) |
			((uint32_t)(input[6] & 0xfe) << 15);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 55 to 70
	value = ((uint32_t)(input[6] & 0x01) << 31) |
			((uint32_t)input[7] << 23) |
			((uint32_t)(input[8] & 0xfe) << 15);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 71 to 86
	value = ((uint32_t)(input[8] & 0x01) << 31) |
			((uint32_t)input[9] << 23) |
			((uint32_t)(input[10] & 0xfe) << 15);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 87 to 102
	value = ((uint32_t)(input[10] & 0x01) << 31) |
			((uint32_t)input[11] << 23) |
			((uint32_t)(input[12] & 0xfe) << 15);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 103 to 118
	value = ((uint32_t)(input[12] & 0x01) << 31) |
			((uint32_t)input[13] << 23) |
			((uint32_t)(input[14] & 0xfe) << 15);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 119 to 134
	value = ((uint32_t)(input[14] & 0x01) << 31) |
			((uint32_t)input[15] << 23) |
			((uint32_t)(input[16] & 0xfe) << 15);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 135 to 150
	value = ((uint32_t)(input[16] & 0x01) << 31) |
			((uint32_t)input[17] << 23) |
			((uint32_t)(input[18] & 0xfe) << 15);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 151 to 166
	value = ((uint32_t)(input[18] & 0x01) << 31) |
			((uint32_t)input[19] << 23) |
			((uint32_t)(input[20] & 0xfe) << 15);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 167 to 182
	value = ((uint32_t)(input[20] & 0x01) << 31) |
			((uint32_t)input[21] << 23) |
			((uint32_t)(input[22] & 0xfe) << 15);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 183 to 198
	value = ((uint32_t)(input[22] & 0x01) << 31) |
			((uint32_t)input[23] << 23) |
			((uint32_t)(input[24] & 0xfe) << 15);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 199 to 214
	value = ((uint32_t)(input[24] & 0x01) << 31) |
			((uint32_t)input[25] << 23) |
			((uint32_t)(input[26] & 0xfe) << 15);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 215 to 230
	value = ((uint32_t)(input[26] & 0x01) << 31) |
			((uint32_t)input[27] << 23) |
			((uint32_t)(input[28] & 0xfe) << 15);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 231 to 246
	value = ((uint32_t)(input[28] & 0x01) << 31) |
			((uint32_t)input[29] << 23) |
			((uint32_t)(input[30] & 0xfe) << 15);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 247 to 262
	value = ((uint32_t)(input[30] & 0x01) << 31) |
			((uint32_t)input[31] << 23) |
			((uint32_t)(input[32] & 0xfe) << 15);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 263 to 278
	value = ((uint32_t)(input[32] & 0x01) << 31) |
			((uint32_t)input[33] << 23) |
			((uint32_t)(input[34] & 0xfe) << 15);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 279 to 294
	value = ((uint32_t)(input[34] & 0x01) << 31) |
			((uint32_t)input[35] << 23) |
			((uint32_t)(input[36] & 0xfe) << 15);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 295 to 310
	value = ((uint32_t)(input[36] & 0x01) << 31) |
			((uint32_t)input[37] << 23) |
			((uint32_t)(input[38] & 0xfe) << 15);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 311 to 326
	value = ((uint32_t)(input[38] & 0x01) << 31) |
			((uint32_t)input[39] << 23) |
			((uint32_t)(input[40] & 0xfe) << 15);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 327 to 342
	value = ((uint32_t)(input[40] & 0x01) << 31) |
			((uint32_t)input[41] << 23) |
			((uint32_t)(input[42] & 0xfe) << 15);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 343 to 358
	value = ((uint32_t)(input[42] & 0x01) << 31) |
			((uint32_t)input[43] << 23) |
			((uint32_t)(input[44] & 0xfe) << 15);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 359 to 374
	value = ((uint32_t)(input[44] & 0x01) << 31) |
			((uint32_t)input[45] << 23) |
			((uint32_t)(input[46] & 0xfe) << 15);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 375 to 390
	value = ((uint32_t)(input[46] & 0x01) << 31) |
			((uint32_t)input[47] << 23) |
			((uint32_t)(input[48] & 0xfe) << 15);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 391 to 406
	value = ((uint32_t)(input[48] & 0x01) << 31) |
			((uint32_t)input[49] << 23) |
			((uint32_t)(input[50] & 0xfe) << 15);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 407 to 422
	value = ((uint32_t)(input[50] & 0x01) << 31) |
			((uint32_t)input[51] << 23) |
			((uint32_t)(input[52] & 0xfe) << 15);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 423 to 438
	value = ((uint32_t)(input[52] & 0x01) << 31) |
			((uint32_t)input[53] << 23) |
			((uint32_t)(input[54] & 0xfe) << 15);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 439 to 454
	value = ((uint32_t)(input[54] & 0x01) << 31) |
			((uint32_t)input[55] << 23) |
			((uint32_t)(input[56] & 0xfe) << 15);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 455 to 470
	value = ((uint32_t)(input[56] & 0x01) << 31) |
			((uint32_t)input[57] << 23) |
			((uint32_t)(input[58] & 0xfe) << 15);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 471 to 486
	value = ((uint32_t)(input[58] & 0x01) << 31) |
			((uint32_t)input[59] << 23) |
			((uint32_t)(input[60] & 0xfe) << 15);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 487 to 502
	value = ((uint32_t)(input[60] & 0x01) << 31) |
			((uint32_t)input[61] << 23) |
			((uint32_t)(input[62] & 0xfe) << 15);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 503 to 518
	value = ((uint32_t)(input[62] & 0x01) << 31) |
			((uint32_t)input[63] << 23) |
			((uint32_t)(input[64] & 0xfe) << 15);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 519 to 534
	value = ((uint32_t)(input[64] & 0x01) << 31) |
			((uint32_t)input[65] << 23) |
			((uint32_t)(input[66] & 0xfe) << 15);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 535 to 550
	value = ((uint32_t)(input[66] & 0x01) << 31) |
			((uint32_t)input[67] << 23) |
			((uint32_t)(input[68] & 0xfe) << 15);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 551 to 566
	value = ((uint32_t)(input[68] & 0x01) << 31) |
			((uint32_t)input[69] << 23) |
			((uint32_t)(input[70] & 0xfe) << 15);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 567 to 582
	value = ((uint32_t)(input[70] & 0x01) << 31) |
			((uint32_t)input[71] << 23) |
			((uint32_t)(input[72] & 0xfe) << 15);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 583 to 598
	value = ((uint32_t)(input[72] & 0x01) << 31) |
			((uint32_t)input[73] << 23) |
			((uint32_t)(input[74] & 0xfe) << 15);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 599 to 614
	value = ((uint32_t)(input[74] & 0x01) << 31) |
			((uint32_t)input[75] << 23) |
			((uint32_t)(input[76] & 0xfe) << 15);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 615 to 630
	value = ((uint32_t)(input[76] & 0x01) << 31) |
			((uint32_t)input[77] << 23) |
			((uint32_t)(input[78] & 0xfe) << 15);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 631 to 646
	value = ((uint32_t)(input[78] & 0x01) << 31) |
			((uint32_t)input[79] << 23) |
			((uint32_t)(input[80] & 0xfe) << 15);
	output[39] = (double)(value >> 16);

	// read output[40]: from bit 647 to 662
	value = ((uint32_t)(input[80] & 0x01) << 31) |
			((uint32_t)input[81] << 23) |
			((uint32_t)(input[82] & 0xfe) << 15);
	output[40] = (double)(value >> 16);

	// read output[41]: from bit 663 to 678
	value = ((uint32_t)(input[82] & 0x01) << 31) |
			((uint32_t)input[83] << 23) |
			((uint32_t)(input[84] & 0xfe) << 15);
	output[41] = (double)(value >> 16);

	// read output[42]: from bit 679 to 694
	value = ((uint32_t)(input[84] & 0x01) << 31) |
			((uint32_t)input[85] << 23) |
			((uint32_t)(input[86] & 0xfe) << 15);
	output[42] = (double)(value >> 16);

	// read output[43]: from bit 695 to 710
	value = ((uint32_t)(input[86] & 0x01) << 31) |
			((uint32_t)input[87] << 23) |
			((uint32_t)(input[88] & 0xfe) << 15);
	output[43] = (double)(value >> 16);

	// read output[44]: from bit 711 to 726
	value = ((uint32_t)(input[88] & 0x01) << 31) |
			((uint32_t)input[89] << 23) |
			((uint32_t)(input[90] & 0xfe) << 15);
	output[44] = (double)(value >> 16);

	// read output[45]: from bit 727 to 742
	value = ((uint32_t)(input[90] & 0x01) << 31) |
			((uint32_t)input[91] << 23) |
			((uint32_t)(input[92] & 0xfe) << 15);
	output[45] = (double)(value >> 16);

	// read output[46]: from bit 743 to 758
	value = ((uint32_t)(input[92] & 0x01) << 31) |
			((uint32_t)input[93] << 23) |
			((uint32_t)(input[94] & 0xfe) << 15);
	output[46] = (double)(value >> 16);
}

static void unpack_47_16bit_unsigned_7off(const uint8_t * input, double * output, void *closure) {
	// Unpack 47 values into output
	// Values are 16-bit unsigned
	// Skip 7 bits, read 752 bits of data.
	// Input must be at least 95 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 7 to 22
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)(input[2] & 0xfe) << 15);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 23 to 38
	value = ((uint32_t)(input[2] & 0x01) << 31) |
			((uint32_t)input[3] << 23) |
			((uint32_t)(input[4] & 0xfe) << 15);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 39 to 54
	value = ((uint32_t)(input[4] & 0x01) << 31) |
			((uint32_t)input[5] << 23) |
			((uint32_t)(input[6] & 0xfe) << 15);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 55 to 70
	value = ((uint32_t)(input[6] & 0x01) << 31) |
			((uint32_t)input[7] << 23) |
			((uint32_t)(input[8] & 0xfe) << 15);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 71 to 86
	value = ((uint32_t)(input[8] & 0x01) << 31) |
			((uint32_t)input[9] << 23) |
			((uint32_t)(input[10] & 0xfe) << 15);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 87 to 102
	value = ((uint32_t)(input[10] & 0x01) << 31) |
			((uint32_t)input[11] << 23) |
			((uint32_t)(input[12] & 0xfe) << 15);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 103 to 118
	value = ((uint32_t)(input[12] & 0x01) << 31) |
			((uint32_t)input[13] << 23) |
			((uint32_t)(input[14] & 0xfe) << 15);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 119 to 134
	value = ((uint32_t)(input[14] & 0x01) << 31) |
			((uint32_t)input[15] << 23) |
			((uint32_t)(input[16] & 0xfe) << 15);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 135 to 150
	value = ((uint32_t)(input[16] & 0x01) << 31) |
			((uint32_t)input[17] << 23) |
			((uint32_t)(input[18] & 0xfe) << 15);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 151 to 166
	value = ((uint32_t)(input[18] & 0x01) << 31) |
			((uint32_t)input[19] << 23) |
			((uint32_t)(input[20] & 0xfe) << 15);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 167 to 182
	value = ((uint32_t)(input[20] & 0x01) << 31) |
			((uint32_t)input[21] << 23) |
			((uint32_t)(input[22] & 0xfe) << 15);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 183 to 198
	value = ((uint32_t)(input[22] & 0x01) << 31) |
			((uint32_t)input[23] << 23) |
			((uint32_t)(input[24] & 0xfe) << 15);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 199 to 214
	value = ((uint32_t)(input[24] & 0x01) << 31) |
			((uint32_t)input[25] << 23) |
			((uint32_t)(input[26] & 0xfe) << 15);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 215 to 230
	value = ((uint32_t)(input[26] & 0x01) << 31) |
			((uint32_t)input[27] << 23) |
			((uint32_t)(input[28] & 0xfe) << 15);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 231 to 246
	value = ((uint32_t)(input[28] & 0x01) << 31) |
			((uint32_t)input[29] << 23) |
			((uint32_t)(input[30] & 0xfe) << 15);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 247 to 262
	value = ((uint32_t)(input[30] & 0x01) << 31) |
			((uint32_t)input[31] << 23) |
			((uint32_t)(input[32] & 0xfe) << 15);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 263 to 278
	value = ((uint32_t)(input[32] & 0x01) << 31) |
			((uint32_t)input[33] << 23) |
			((uint32_t)(input[34] & 0xfe) << 15);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 279 to 294
	value = ((uint32_t)(input[34] & 0x01) << 31) |
			((uint32_t)input[35] << 23) |
			((uint32_t)(input[36] & 0xfe) << 15);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 295 to 310
	value = ((uint32_t)(input[36] & 0x01) << 31) |
			((uint32_t)input[37] << 23) |
			((uint32_t)(input[38] & 0xfe) << 15);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 311 to 326
	value = ((uint32_t)(input[38] & 0x01) << 31) |
			((uint32_t)input[39] << 23) |
			((uint32_t)(input[40] & 0xfe) << 15);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 327 to 342
	value = ((uint32_t)(input[40] & 0x01) << 31) |
			((uint32_t)input[41] << 23) |
			((uint32_t)(input[42] & 0xfe) << 15);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 343 to 358
	value = ((uint32_t)(input[42] & 0x01) << 31) |
			((uint32_t)input[43] << 23) |
			((uint32_t)(input[44] & 0xfe) << 15);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 359 to 374
	value = ((uint32_t)(input[44] & 0x01) << 31) |
			((uint32_t)input[45] << 23) |
			((uint32_t)(input[46] & 0xfe) << 15);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 375 to 390
	value = ((uint32_t)(input[46] & 0x01) << 31) |
			((uint32_t)input[47] << 23) |
			((uint32_t)(input[48] & 0xfe) << 15);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 391 to 406
	value = ((uint32_t)(input[48] & 0x01) << 31) |
			((uint32_t)input[49] << 23) |
			((uint32_t)(input[50] & 0xfe) << 15);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 407 to 422
	value = ((uint32_t)(input[50] & 0x01) << 31) |
			((uint32_t)input[51] << 23) |
			((uint32_t)(input[52] & 0xfe) << 15);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 423 to 438
	value = ((uint32_t)(input[52] & 0x01) << 31) |
			((uint32_t)input[53] << 23) |
			((uint32_t)(input[54] & 0xfe) << 15);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 439 to 454
	value = ((uint32_t)(input[54] & 0x01) << 31) |
			((uint32_t)input[55] << 23) |
			((uint32_t)(input[56] & 0xfe) << 15);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 455 to 470
	value = ((uint32_t)(input[56] & 0x01) << 31) |
			((uint32_t)input[57] << 23) |
			((uint32_t)(input[58] & 0xfe) << 15);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 471 to 486
	value = ((uint32_t)(input[58] & 0x01) << 31) |
			((uint32_t)input[59] << 23) |
			((uint32_t)(input[60] & 0xfe) << 15);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 487 to 502
	value = ((uint32_t)(input[60] & 0x01) << 31) |
			((uint32_t)input[61] << 23) |
			((uint32_t)(input[62] & 0xfe) << 15);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 503 to 518
	value = ((uint32_t)(input[62] & 0x01) << 31) |
			((uint32_t)input[63] << 23) |
			((uint32_t)(input[64] & 0xfe) << 15);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 519 to 534
	value = ((uint32_t)(input[64] & 0x01) << 31) |
			((uint32_t)input[65] << 23) |
			((uint32_t)(input[66] & 0xfe) << 15);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 535 to 550
	value = ((uint32_t)(input[66] & 0x01) << 31) |
			((uint32_t)input[67] << 23) |
			((uint32_t)(input[68] & 0xfe) << 15);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 551 to 566
	value = ((uint32_t)(input[68] & 0x01) << 31) |
			((uint32_t)input[69] << 23) |
			((uint32_t)(input[70] & 0xfe) << 15);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 567 to 582
	value = ((uint32_t)(input[70] & 0x01) << 31) |
			((uint32_t)input[71] << 23) |
			((uint32_t)(input[72] & 0xfe) << 15);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 583 to 598
	value = ((uint32_t)(input[72] & 0x01) << 31) |
			((uint32_t)input[73] << 23) |
			((uint32_t)(input[74] & 0xfe) << 15);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 599 to 614
	value = ((uint32_t)(input[74] & 0x01) << 31) |
			((uint32_t)input[75] << 23) |
			((uint32_t)(input[76] & 0xfe) << 15);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 615 to 630
	value = ((uint32_t)(input[76] & 0x01) << 31) |
			((uint32_t)input[77] << 23) |
			((uint32_t)(input[78] & 0xfe) << 15);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 631 to 646
	value = ((uint32_t)(input[78] & 0x01) << 31) |
			((uint32_t)input[79] << 23) |
			((uint32_t)(input[80] & 0xfe) << 15);
	output[39] = (double)(value >> 16);

	// read output[40]: from bit 647 to 662
	value = ((uint32_t)(input[80] & 0x01) << 31) |
			((uint32_t)input[81] << 23) |
			((uint32_t)(input[82] & 0xfe) << 15);
	output[40] = (double)(value >> 16);

	// read output[41]: from bit 663 to 678
	value = ((uint32_t)(input[82] & 0x01) << 31) |
			((uint32_t)input[83] << 23) |
			((uint32_t)(input[84] & 0xfe) << 15);
	output[41] = (double)(value >> 16);

	// read output[42]: from bit 679 to 694
	value = ((uint32_t)(input[84] & 0x01) << 31) |
			((uint32_t)input[85] << 23) |
			((uint32_t)(input[86] & 0xfe) << 15);
	output[42] = (double)(value >> 16);

	// read output[43]: from bit 695 to 710
	value = ((uint32_t)(input[86] & 0x01) << 31) |
			((uint32_t)input[87] << 23) |
			((uint32_t)(input[88] & 0xfe) << 15);
	output[43] = (double)(value >> 16);

	// read output[44]: from bit 711 to 726
	value = ((uint32_t)(input[88] & 0x01) << 31) |
			((uint32_t)input[89] << 23) |
			((uint32_t)(input[90] & 0xfe) << 15);
	output[44] = (double)(value >> 16);

	// read output[45]: from bit 727 to 742
	value = ((uint32_t)(input[90] & 0x01) << 31) |
			((uint32_t)input[91] << 23) |
			((uint32_t)(input[92] & 0xfe) << 15);
	output[45] = (double)(value >> 16);

	// read output[46]: from bit 743 to 758
	value = ((uint32_t)(input[92] & 0x01) << 31) |
			((uint32_t)input[93] << 23) |
			((uint32_t)(input[94] & 0xfe) << 15);
	output[46] = (double)(value >> 16);
}

static void unpack_48_16bit_signed_0off(const uint8_t * input, double * output, void *closure) {
	// Unpack 48 values into output
	// Values are 16-bit signed
	// Skip 0 bits, read 768 bits of data.
	// Input must be at least 96 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 0 to 15
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)input[1] << 16);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 16 to 31
	value = ((uint32_t)input[2] << 24) |
			((uint32_t)input[3] << 16);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 32 to 47
	value = ((uint32_t)input[4] << 24) |
			((uint32_t)input[5] << 16);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 48 to 63
	value = ((uint32_t)input[6] << 24) |
			((uint32_t)input[7] << 16);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 64 to 79
	value = ((uint32_t)input[8] << 24) |
			((uint32_t)input[9] << 16);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 80 to 95
	value = ((uint32_t)input[10] << 24) |
			((uint32_t)input[11] << 16);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 96 to 111
	value = ((uint32_t)input[12] << 24) |
			((uint32_t)input[13] << 16);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 112 to 127
	value = ((uint32_t)input[14] << 24) |
			((uint32_t)input[15] << 16);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 128 to 143
	value = ((uint32_t)input[16] << 24) |
			((uint32_t)input[17] << 16);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 144 to 159
	value = ((uint32_t)input[18] << 24) |
			((uint32_t)input[19] << 16);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 160 to 175
	value = ((uint32_t)input[20] << 24) |
			((uint32_t)input[21] << 16);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 176 to 191
	value = ((uint32_t)input[22] << 24) |
			((uint32_t)input[23] << 16);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 192 to 207
	value = ((uint32_t)input[24] << 24) |
			((uint32_t)input[25] << 16);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 208 to 223
	value = ((uint32_t)input[26] << 24) |
			((uint32_t)input[27] << 16);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 224 to 239
	value = ((uint32_t)input[28] << 24) |
			((uint32_t)input[29] << 16);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 240 to 255
	value = ((uint32_t)input[30] << 24) |
			((uint32_t)input[31] << 16);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 256 to 271
	value = ((uint32_t)input[32] << 24) |
			((uint32_t)input[33] << 16);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 272 to 287
	value = ((uint32_t)input[34] << 24) |
			((uint32_t)input[35] << 16);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 288 to 303
	value = ((uint32_t)input[36] << 24) |
			((uint32_t)input[37] << 16);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 304 to 319
	value = ((uint32_t)input[38] << 24) |
			((uint32_t)input[39] << 16);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 320 to 335
	value = ((uint32_t)input[40] << 24) |
			((uint32_t)input[41] << 16);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 336 to 351
	value = ((uint32_t)input[42] << 24) |
			((uint32_t)input[43] << 16);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 352 to 367
	value = ((uint32_t)input[44] << 24) |
			((uint32_t)input[45] << 16);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 368 to 383
	value = ((uint32_t)input[46] << 24) |
			((uint32_t)input[47] << 16);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 384 to 399
	value = ((uint32_t)input[48] << 24) |
			((uint32_t)input[49] << 16);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 400 to 415
	value = ((uint32_t)input[50] << 24) |
			((uint32_t)input[51] << 16);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 416 to 431
	value = ((uint32_t)input[52] << 24) |
			((uint32_t)input[53] << 16);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 432 to 447
	value = ((uint32_t)input[54] << 24) |
			((uint32_t)input[55] << 16);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 448 to 463
	value = ((uint32_t)input[56] << 24) |
			((uint32_t)input[57] << 16);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 464 to 479
	value = ((uint32_t)input[58] << 24) |
			((uint32_t)input[59] << 16);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 480 to 495
	value = ((uint32_t)input[60] << 24) |
			((uint32_t)input[61] << 16);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 496 to 511
	value = ((uint32_t)input[62] << 24) |
			((uint32_t)input[63] << 16);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 512 to 527
	value = ((uint32_t)input[64] << 24) |
			((uint32_t)input[65] << 16);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 528 to 543
	value = ((uint32_t)input[66] << 24) |
			((uint32_t)input[67] << 16);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 544 to 559
	value = ((uint32_t)input[68] << 24) |
			((uint32_t)input[69] << 16);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 560 to 575
	value = ((uint32_t)input[70] << 24) |
			((uint32_t)input[71] << 16);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 576 to 591
	value = ((uint32_t)input[72] << 24) |
			((uint32_t)input[73] << 16);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 592 to 607
	value = ((uint32_t)input[74] << 24) |
			((uint32_t)input[75] << 16);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 608 to 623
	value = ((uint32_t)input[76] << 24) |
			((uint32_t)input[77] << 16);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 624 to 639
	value = ((uint32_t)input[78] << 24) |
			((uint32_t)input[79] << 16);
	output[39] = (double)(value >> 16);

	// read output[40]: from bit 640 to 655
	value = ((uint32_t)input[80] << 24) |
			((uint32_t)input[81] << 16);
	output[40] = (double)(value >> 16);

	// read output[41]: from bit 656 to 671
	value = ((uint32_t)input[82] << 24) |
			((uint32_t)input[83] << 16);
	output[41] = (double)(value >> 16);

	// read output[42]: from bit 672 to 687
	value = ((uint32_t)input[84] << 24) |
			((uint32_t)input[85] << 16);
	output[42] = (double)(value >> 16);

	// read output[43]: from bit 688 to 703
	value = ((uint32_t)input[86] << 24) |
			((uint32_t)input[87] << 16);
	output[43] = (double)(value >> 16);

	// read output[44]: from bit 704 to 719
	value = ((uint32_t)input[88] << 24) |
			((uint32_t)input[89] << 16);
	output[44] = (double)(value >> 16);

	// read output[45]: from bit 720 to 735
	value = ((uint32_t)input[90] << 24) |
			((uint32_t)input[91] << 16);
	output[45] = (double)(value >> 16);

	// read output[46]: from bit 736 to 751
	value = ((uint32_t)input[92] << 24) |
			((uint32_t)input[93] << 16);
	output[46] = (double)(value >> 16);

	// read output[47]: from bit 752 to 767
	value = ((uint32_t)input[94] << 24) |
			((uint32_t)input[95] << 16);
	output[47] = (double)(value >> 16);
}

static void unpack_48_16bit_unsigned_0off(const uint8_t * input, double * output, void *closure) {
	// Unpack 48 values into output
	// Values are 16-bit unsigned
	// Skip 0 bits, read 768 bits of data.
	// Input must be at least 96 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 0 to 15
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)input[1] << 16);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 16 to 31
	value = ((uint32_t)input[2] << 24) |
			((uint32_t)input[3] << 16);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 32 to 47
	value = ((uint32_t)input[4] << 24) |
			((uint32_t)input[5] << 16);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 48 to 63
	value = ((uint32_t)input[6] << 24) |
			((uint32_t)input[7] << 16);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 64 to 79
	value = ((uint32_t)input[8] << 24) |
			((uint32_t)input[9] << 16);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 80 to 95
	value = ((uint32_t)input[10] << 24) |
			((uint32_t)input[11] << 16);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 96 to 111
	value = ((uint32_t)input[12] << 24) |
			((uint32_t)input[13] << 16);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 112 to 127
	value = ((uint32_t)input[14] << 24) |
			((uint32_t)input[15] << 16);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 128 to 143
	value = ((uint32_t)input[16] << 24) |
			((uint32_t)input[17] << 16);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 144 to 159
	value = ((uint32_t)input[18] << 24) |
			((uint32_t)input[19] << 16);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 160 to 175
	value = ((uint32_t)input[20] << 24) |
			((uint32_t)input[21] << 16);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 176 to 191
	value = ((uint32_t)input[22] << 24) |
			((uint32_t)input[23] << 16);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 192 to 207
	value = ((uint32_t)input[24] << 24) |
			((uint32_t)input[25] << 16);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 208 to 223
	value = ((uint32_t)input[26] << 24) |
			((uint32_t)input[27] << 16);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 224 to 239
	value = ((uint32_t)input[28] << 24) |
			((uint32_t)input[29] << 16);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 240 to 255
	value = ((uint32_t)input[30] << 24) |
			((uint32_t)input[31] << 16);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 256 to 271
	value = ((uint32_t)input[32] << 24) |
			((uint32_t)input[33] << 16);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 272 to 287
	value = ((uint32_t)input[34] << 24) |
			((uint32_t)input[35] << 16);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 288 to 303
	value = ((uint32_t)input[36] << 24) |
			((uint32_t)input[37] << 16);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 304 to 319
	value = ((uint32_t)input[38] << 24) |
			((uint32_t)input[39] << 16);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 320 to 335
	value = ((uint32_t)input[40] << 24) |
			((uint32_t)input[41] << 16);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 336 to 351
	value = ((uint32_t)input[42] << 24) |
			((uint32_t)input[43] << 16);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 352 to 367
	value = ((uint32_t)input[44] << 24) |
			((uint32_t)input[45] << 16);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 368 to 383
	value = ((uint32_t)input[46] << 24) |
			((uint32_t)input[47] << 16);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 384 to 399
	value = ((uint32_t)input[48] << 24) |
			((uint32_t)input[49] << 16);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 400 to 415
	value = ((uint32_t)input[50] << 24) |
			((uint32_t)input[51] << 16);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 416 to 431
	value = ((uint32_t)input[52] << 24) |
			((uint32_t)input[53] << 16);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 432 to 447
	value = ((uint32_t)input[54] << 24) |
			((uint32_t)input[55] << 16);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 448 to 463
	value = ((uint32_t)input[56] << 24) |
			((uint32_t)input[57] << 16);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 464 to 479
	value = ((uint32_t)input[58] << 24) |
			((uint32_t)input[59] << 16);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 480 to 495
	value = ((uint32_t)input[60] << 24) |
			((uint32_t)input[61] << 16);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 496 to 511
	value = ((uint32_t)input[62] << 24) |
			((uint32_t)input[63] << 16);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 512 to 527
	value = ((uint32_t)input[64] << 24) |
			((uint32_t)input[65] << 16);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 528 to 543
	value = ((uint32_t)input[66] << 24) |
			((uint32_t)input[67] << 16);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 544 to 559
	value = ((uint32_t)input[68] << 24) |
			((uint32_t)input[69] << 16);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 560 to 575
	value = ((uint32_t)input[70] << 24) |
			((uint32_t)input[71] << 16);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 576 to 591
	value = ((uint32_t)input[72] << 24) |
			((uint32_t)input[73] << 16);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 592 to 607
	value = ((uint32_t)input[74] << 24) |
			((uint32_t)input[75] << 16);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 608 to 623
	value = ((uint32_t)input[76] << 24) |
			((uint32_t)input[77] << 16);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 624 to 639
	value = ((uint32_t)input[78] << 24) |
			((uint32_t)input[79] << 16);
	output[39] = (double)(value >> 16);

	// read output[40]: from bit 640 to 655
	value = ((uint32_t)input[80] << 24) |
			((uint32_t)input[81] << 16);
	output[40] = (double)(value >> 16);

	// read output[41]: from bit 656 to 671
	value = ((uint32_t)input[82] << 24) |
			((uint32_t)input[83] << 16);
	output[41] = (double)(value >> 16);

	// read output[42]: from bit 672 to 687
	value = ((uint32_t)input[84] << 24) |
			((uint32_t)input[85] << 16);
	output[42] = (double)(value >> 16);

	// read output[43]: from bit 688 to 703
	value = ((uint32_t)input[86] << 24) |
			((uint32_t)input[87] << 16);
	output[43] = (double)(value >> 16);

	// read output[44]: from bit 704 to 719
	value = ((uint32_t)input[88] << 24) |
			((uint32_t)input[89] << 16);
	output[44] = (double)(value >> 16);

	// read output[45]: from bit 720 to 735
	value = ((uint32_t)input[90] << 24) |
			((uint32_t)input[91] << 16);
	output[45] = (double)(value >> 16);

	// read output[46]: from bit 736 to 751
	value = ((uint32_t)input[92] << 24) |
			((uint32_t)input[93] << 16);
	output[46] = (double)(value >> 16);

	// read output[47]: from bit 752 to 767
	value = ((uint32_t)input[94] << 24) |
			((uint32_t)input[95] << 16);
	output[47] = (double)(value >> 16);
}

static void unpack_48_16bit_signed_1off(const uint8_t * input, double * output, void *closure) {
	// Unpack 48 values into output
	// Values are 16-bit signed
	// Skip 1 bits, read 768 bits of data.
	// Input must be at least 97 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 1 to 16
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)input[1] << 17) |
			((uint32_t)(input[2] & 0x80) << 9);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 17 to 32
	value = ((uint32_t)(input[2] & 0x7f) << 25) |
			((uint32_t)input[3] << 17) |
			((uint32_t)(input[4] & 0x80) << 9);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 33 to 48
	value = ((uint32_t)(input[4] & 0x7f) << 25) |
			((uint32_t)input[5] << 17) |
			((uint32_t)(input[6] & 0x80) << 9);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 49 to 64
	value = ((uint32_t)(input[6] & 0x7f) << 25) |
			((uint32_t)input[7] << 17) |
			((uint32_t)(input[8] & 0x80) << 9);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 65 to 80
	value = ((uint32_t)(input[8] & 0x7f) << 25) |
			((uint32_t)input[9] << 17) |
			((uint32_t)(input[10] & 0x80) << 9);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 81 to 96
	value = ((uint32_t)(input[10] & 0x7f) << 25) |
			((uint32_t)input[11] << 17) |
			((uint32_t)(input[12] & 0x80) << 9);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 97 to 112
	value = ((uint32_t)(input[12] & 0x7f) << 25) |
			((uint32_t)input[13] << 17) |
			((uint32_t)(input[14] & 0x80) << 9);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 113 to 128
	value = ((uint32_t)(input[14] & 0x7f) << 25) |
			((uint32_t)input[15] << 17) |
			((uint32_t)(input[16] & 0x80) << 9);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 129 to 144
	value = ((uint32_t)(input[16] & 0x7f) << 25) |
			((uint32_t)input[17] << 17) |
			((uint32_t)(input[18] & 0x80) << 9);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 145 to 160
	value = ((uint32_t)(input[18] & 0x7f) << 25) |
			((uint32_t)input[19] << 17) |
			((uint32_t)(input[20] & 0x80) << 9);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 161 to 176
	value = ((uint32_t)(input[20] & 0x7f) << 25) |
			((uint32_t)input[21] << 17) |
			((uint32_t)(input[22] & 0x80) << 9);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 177 to 192
	value = ((uint32_t)(input[22] & 0x7f) << 25) |
			((uint32_t)input[23] << 17) |
			((uint32_t)(input[24] & 0x80) << 9);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 193 to 208
	value = ((uint32_t)(input[24] & 0x7f) << 25) |
			((uint32_t)input[25] << 17) |
			((uint32_t)(input[26] & 0x80) << 9);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 209 to 224
	value = ((uint32_t)(input[26] & 0x7f) << 25) |
			((uint32_t)input[27] << 17) |
			((uint32_t)(input[28] & 0x80) << 9);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 225 to 240
	value = ((uint32_t)(input[28] & 0x7f) << 25) |
			((uint32_t)input[29] << 17) |
			((uint32_t)(input[30] & 0x80) << 9);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 241 to 256
	value = ((uint32_t)(input[30] & 0x7f) << 25) |
			((uint32_t)input[31] << 17) |
			((uint32_t)(input[32] & 0x80) << 9);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 257 to 272
	value = ((uint32_t)(input[32] & 0x7f) << 25) |
			((uint32_t)input[33] << 17) |
			((uint32_t)(input[34] & 0x80) << 9);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 273 to 288
	value = ((uint32_t)(input[34] & 0x7f) << 25) |
			((uint32_t)input[35] << 17) |
			((uint32_t)(input[36] & 0x80) << 9);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 289 to 304
	value = ((uint32_t)(input[36] & 0x7f) << 25) |
			((uint32_t)input[37] << 17) |
			((uint32_t)(input[38] & 0x80) << 9);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 305 to 320
	value = ((uint32_t)(input[38] & 0x7f) << 25) |
			((uint32_t)input[39] << 17) |
			((uint32_t)(input[40] & 0x80) << 9);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 321 to 336
	value = ((uint32_t)(input[40] & 0x7f) << 25) |
			((uint32_t)input[41] << 17) |
			((uint32_t)(input[42] & 0x80) << 9);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 337 to 352
	value = ((uint32_t)(input[42] & 0x7f) << 25) |
			((uint32_t)input[43] << 17) |
			((uint32_t)(input[44] & 0x80) << 9);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 353 to 368
	value = ((uint32_t)(input[44] & 0x7f) << 25) |
			((uint32_t)input[45] << 17) |
			((uint32_t)(input[46] & 0x80) << 9);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 369 to 384
	value = ((uint32_t)(input[46] & 0x7f) << 25) |
			((uint32_t)input[47] << 17) |
			((uint32_t)(input[48] & 0x80) << 9);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 385 to 400
	value = ((uint32_t)(input[48] & 0x7f) << 25) |
			((uint32_t)input[49] << 17) |
			((uint32_t)(input[50] & 0x80) << 9);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 401 to 416
	value = ((uint32_t)(input[50] & 0x7f) << 25) |
			((uint32_t)input[51] << 17) |
			((uint32_t)(input[52] & 0x80) << 9);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 417 to 432
	value = ((uint32_t)(input[52] & 0x7f) << 25) |
			((uint32_t)input[53] << 17) |
			((uint32_t)(input[54] & 0x80) << 9);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 433 to 448
	value = ((uint32_t)(input[54] & 0x7f) << 25) |
			((uint32_t)input[55] << 17) |
			((uint32_t)(input[56] & 0x80) << 9);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 449 to 464
	value = ((uint32_t)(input[56] & 0x7f) << 25) |
			((uint32_t)input[57] << 17) |
			((uint32_t)(input[58] & 0x80) << 9);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 465 to 480
	value = ((uint32_t)(input[58] & 0x7f) << 25) |
			((uint32_t)input[59] << 17) |
			((uint32_t)(input[60] & 0x80) << 9);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 481 to 496
	value = ((uint32_t)(input[60] & 0x7f) << 25) |
			((uint32_t)input[61] << 17) |
			((uint32_t)(input[62] & 0x80) << 9);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 497 to 512
	value = ((uint32_t)(input[62] & 0x7f) << 25) |
			((uint32_t)input[63] << 17) |
			((uint32_t)(input[64] & 0x80) << 9);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 513 to 528
	value = ((uint32_t)(input[64] & 0x7f) << 25) |
			((uint32_t)input[65] << 17) |
			((uint32_t)(input[66] & 0x80) << 9);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 529 to 544
	value = ((uint32_t)(input[66] & 0x7f) << 25) |
			((uint32_t)input[67] << 17) |
			((uint32_t)(input[68] & 0x80) << 9);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 545 to 560
	value = ((uint32_t)(input[68] & 0x7f) << 25) |
			((uint32_t)input[69] << 17) |
			((uint32_t)(input[70] & 0x80) << 9);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 561 to 576
	value = ((uint32_t)(input[70] & 0x7f) << 25) |
			((uint32_t)input[71] << 17) |
			((uint32_t)(input[72] & 0x80) << 9);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 577 to 592
	value = ((uint32_t)(input[72] & 0x7f) << 25) |
			((uint32_t)input[73] << 17) |
			((uint32_t)(input[74] & 0x80) << 9);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 593 to 608
	value = ((uint32_t)(input[74] & 0x7f) << 25) |
			((uint32_t)input[75] << 17) |
			((uint32_t)(input[76] & 0x80) << 9);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 609 to 624
	value = ((uint32_t)(input[76] & 0x7f) << 25) |
			((uint32_t)input[77] << 17) |
			((uint32_t)(input[78] & 0x80) << 9);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 625 to 640
	value = ((uint32_t)(input[78] & 0x7f) << 25) |
			((uint32_t)input[79] << 17) |
			((uint32_t)(input[80] & 0x80) << 9);
	output[39] = (double)(value >> 16);

	// read output[40]: from bit 641 to 656
	value = ((uint32_t)(input[80] & 0x7f) << 25) |
			((uint32_t)input[81] << 17) |
			((uint32_t)(input[82] & 0x80) << 9);
	output[40] = (double)(value >> 16);

	// read output[41]: from bit 657 to 672
	value = ((uint32_t)(input[82] & 0x7f) << 25) |
			((uint32_t)input[83] << 17) |
			((uint32_t)(input[84] & 0x80) << 9);
	output[41] = (double)(value >> 16);

	// read output[42]: from bit 673 to 688
	value = ((uint32_t)(input[84] & 0x7f) << 25) |
			((uint32_t)input[85] << 17) |
			((uint32_t)(input[86] & 0x80) << 9);
	output[42] = (double)(value >> 16);

	// read output[43]: from bit 689 to 704
	value = ((uint32_t)(input[86] & 0x7f) << 25) |
			((uint32_t)input[87] << 17) |
			((uint32_t)(input[88] & 0x80) << 9);
	output[43] = (double)(value >> 16);

	// read output[44]: from bit 705 to 720
	value = ((uint32_t)(input[88] & 0x7f) << 25) |
			((uint32_t)input[89] << 17) |
			((uint32_t)(input[90] & 0x80) << 9);
	output[44] = (double)(value >> 16);

	// read output[45]: from bit 721 to 736
	value = ((uint32_t)(input[90] & 0x7f) << 25) |
			((uint32_t)input[91] << 17) |
			((uint32_t)(input[92] & 0x80) << 9);
	output[45] = (double)(value >> 16);

	// read output[46]: from bit 737 to 752
	value = ((uint32_t)(input[92] & 0x7f) << 25) |
			((uint32_t)input[93] << 17) |
			((uint32_t)(input[94] & 0x80) << 9);
	output[46] = (double)(value >> 16);

	// read output[47]: from bit 753 to 768
	value = ((uint32_t)(input[94] & 0x7f) << 25) |
			((uint32_t)input[95] << 17) |
			((uint32_t)(input[96] & 0x80) << 9);
	output[47] = (double)(value >> 16);
}

static void unpack_48_16bit_unsigned_1off(const uint8_t * input, double * output, void *closure) {
	// Unpack 48 values into output
	// Values are 16-bit unsigned
	// Skip 1 bits, read 768 bits of data.
	// Input must be at least 97 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 1 to 16
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)input[1] << 17) |
			((uint32_t)(input[2] & 0x80) << 9);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 17 to 32
	value = ((uint32_t)(input[2] & 0x7f) << 25) |
			((uint32_t)input[3] << 17) |
			((uint32_t)(input[4] & 0x80) << 9);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 33 to 48
	value = ((uint32_t)(input[4] & 0x7f) << 25) |
			((uint32_t)input[5] << 17) |
			((uint32_t)(input[6] & 0x80) << 9);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 49 to 64
	value = ((uint32_t)(input[6] & 0x7f) << 25) |
			((uint32_t)input[7] << 17) |
			((uint32_t)(input[8] & 0x80) << 9);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 65 to 80
	value = ((uint32_t)(input[8] & 0x7f) << 25) |
			((uint32_t)input[9] << 17) |
			((uint32_t)(input[10] & 0x80) << 9);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 81 to 96
	value = ((uint32_t)(input[10] & 0x7f) << 25) |
			((uint32_t)input[11] << 17) |
			((uint32_t)(input[12] & 0x80) << 9);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 97 to 112
	value = ((uint32_t)(input[12] & 0x7f) << 25) |
			((uint32_t)input[13] << 17) |
			((uint32_t)(input[14] & 0x80) << 9);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 113 to 128
	value = ((uint32_t)(input[14] & 0x7f) << 25) |
			((uint32_t)input[15] << 17) |
			((uint32_t)(input[16] & 0x80) << 9);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 129 to 144
	value = ((uint32_t)(input[16] & 0x7f) << 25) |
			((uint32_t)input[17] << 17) |
			((uint32_t)(input[18] & 0x80) << 9);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 145 to 160
	value = ((uint32_t)(input[18] & 0x7f) << 25) |
			((uint32_t)input[19] << 17) |
			((uint32_t)(input[20] & 0x80) << 9);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 161 to 176
	value = ((uint32_t)(input[20] & 0x7f) << 25) |
			((uint32_t)input[21] << 17) |
			((uint32_t)(input[22] & 0x80) << 9);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 177 to 192
	value = ((uint32_t)(input[22] & 0x7f) << 25) |
			((uint32_t)input[23] << 17) |
			((uint32_t)(input[24] & 0x80) << 9);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 193 to 208
	value = ((uint32_t)(input[24] & 0x7f) << 25) |
			((uint32_t)input[25] << 17) |
			((uint32_t)(input[26] & 0x80) << 9);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 209 to 224
	value = ((uint32_t)(input[26] & 0x7f) << 25) |
			((uint32_t)input[27] << 17) |
			((uint32_t)(input[28] & 0x80) << 9);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 225 to 240
	value = ((uint32_t)(input[28] & 0x7f) << 25) |
			((uint32_t)input[29] << 17) |
			((uint32_t)(input[30] & 0x80) << 9);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 241 to 256
	value = ((uint32_t)(input[30] & 0x7f) << 25) |
			((uint32_t)input[31] << 17) |
			((uint32_t)(input[32] & 0x80) << 9);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 257 to 272
	value = ((uint32_t)(input[32] & 0x7f) << 25) |
			((uint32_t)input[33] << 17) |
			((uint32_t)(input[34] & 0x80) << 9);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 273 to 288
	value = ((uint32_t)(input[34] & 0x7f) << 25) |
			((uint32_t)input[35] << 17) |
			((uint32_t)(input[36] & 0x80) << 9);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 289 to 304
	value = ((uint32_t)(input[36] & 0x7f) << 25) |
			((uint32_t)input[37] << 17) |
			((uint32_t)(input[38] & 0x80) << 9);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 305 to 320
	value = ((uint32_t)(input[38] & 0x7f) << 25) |
			((uint32_t)input[39] << 17) |
			((uint32_t)(input[40] & 0x80) << 9);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 321 to 336
	value = ((uint32_t)(input[40] & 0x7f) << 25) |
			((uint32_t)input[41] << 17) |
			((uint32_t)(input[42] & 0x80) << 9);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 337 to 352
	value = ((uint32_t)(input[42] & 0x7f) << 25) |
			((uint32_t)input[43] << 17) |
			((uint32_t)(input[44] & 0x80) << 9);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 353 to 368
	value = ((uint32_t)(input[44] & 0x7f) << 25) |
			((uint32_t)input[45] << 17) |
			((uint32_t)(input[46] & 0x80) << 9);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 369 to 384
	value = ((uint32_t)(input[46] & 0x7f) << 25) |
			((uint32_t)input[47] << 17) |
			((uint32_t)(input[48] & 0x80) << 9);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 385 to 400
	value = ((uint32_t)(input[48] & 0x7f) << 25) |
			((uint32_t)input[49] << 17) |
			((uint32_t)(input[50] & 0x80) << 9);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 401 to 416
	value = ((uint32_t)(input[50] & 0x7f) << 25) |
			((uint32_t)input[51] << 17) |
			((uint32_t)(input[52] & 0x80) << 9);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 417 to 432
	value = ((uint32_t)(input[52] & 0x7f) << 25) |
			((uint32_t)input[53] << 17) |
			((uint32_t)(input[54] & 0x80) << 9);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 433 to 448
	value = ((uint32_t)(input[54] & 0x7f) << 25) |
			((uint32_t)input[55] << 17) |
			((uint32_t)(input[56] & 0x80) << 9);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 449 to 464
	value = ((uint32_t)(input[56] & 0x7f) << 25) |
			((uint32_t)input[57] << 17) |
			((uint32_t)(input[58] & 0x80) << 9);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 465 to 480
	value = ((uint32_t)(input[58] & 0x7f) << 25) |
			((uint32_t)input[59] << 17) |
			((uint32_t)(input[60] & 0x80) << 9);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 481 to 496
	value = ((uint32_t)(input[60] & 0x7f) << 25) |
			((uint32_t)input[61] << 17) |
			((uint32_t)(input[62] & 0x80) << 9);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 497 to 512
	value = ((uint32_t)(input[62] & 0x7f) << 25) |
			((uint32_t)input[63] << 17) |
			((uint32_t)(input[64] & 0x80) << 9);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 513 to 528
	value = ((uint32_t)(input[64] & 0x7f) << 25) |
			((uint32_t)input[65] << 17) |
			((uint32_t)(input[66] & 0x80) << 9);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 529 to 544
	value = ((uint32_t)(input[66] & 0x7f) << 25) |
			((uint32_t)input[67] << 17) |
			((uint32_t)(input[68] & 0x80) << 9);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 545 to 560
	value = ((uint32_t)(input[68] & 0x7f) << 25) |
			((uint32_t)input[69] << 17) |
			((uint32_t)(input[70] & 0x80) << 9);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 561 to 576
	value = ((uint32_t)(input[70] & 0x7f) << 25) |
			((uint32_t)input[71] << 17) |
			((uint32_t)(input[72] & 0x80) << 9);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 577 to 592
	value = ((uint32_t)(input[72] & 0x7f) << 25) |
			((uint32_t)input[73] << 17) |
			((uint32_t)(input[74] & 0x80) << 9);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 593 to 608
	value = ((uint32_t)(input[74] & 0x7f) << 25) |
			((uint32_t)input[75] << 17) |
			((uint32_t)(input[76] & 0x80) << 9);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 609 to 624
	value = ((uint32_t)(input[76] & 0x7f) << 25) |
			((uint32_t)input[77] << 17) |
			((uint32_t)(input[78] & 0x80) << 9);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 625 to 640
	value = ((uint32_t)(input[78] & 0x7f) << 25) |
			((uint32_t)input[79] << 17) |
			((uint32_t)(input[80] & 0x80) << 9);
	output[39] = (double)(value >> 16);

	// read output[40]: from bit 641 to 656
	value = ((uint32_t)(input[80] & 0x7f) << 25) |
			((uint32_t)input[81] << 17) |
			((uint32_t)(input[82] & 0x80) << 9);
	output[40] = (double)(value >> 16);

	// read output[41]: from bit 657 to 672
	value = ((uint32_t)(input[82] & 0x7f) << 25) |
			((uint32_t)input[83] << 17) |
			((uint32_t)(input[84] & 0x80) << 9);
	output[41] = (double)(value >> 16);

	// read output[42]: from bit 673 to 688
	value = ((uint32_t)(input[84] & 0x7f) << 25) |
			((uint32_t)input[85] << 17) |
			((uint32_t)(input[86] & 0x80) << 9);
	output[42] = (double)(value >> 16);

	// read output[43]: from bit 689 to 704
	value = ((uint32_t)(input[86] & 0x7f) << 25) |
			((uint32_t)input[87] << 17) |
			((uint32_t)(input[88] & 0x80) << 9);
	output[43] = (double)(value >> 16);

	// read output[44]: from bit 705 to 720
	value = ((uint32_t)(input[88] & 0x7f) << 25) |
			((uint32_t)input[89] << 17) |
			((uint32_t)(input[90] & 0x80) << 9);
	output[44] = (double)(value >> 16);

	// read output[45]: from bit 721 to 736
	value = ((uint32_t)(input[90] & 0x7f) << 25) |
			((uint32_t)input[91] << 17) |
			((uint32_t)(input[92] & 0x80) << 9);
	output[45] = (double)(value >> 16);

	// read output[46]: from bit 737 to 752
	value = ((uint32_t)(input[92] & 0x7f) << 25) |
			((uint32_t)input[93] << 17) |
			((uint32_t)(input[94] & 0x80) << 9);
	output[46] = (double)(value >> 16);

	// read output[47]: from bit 753 to 768
	value = ((uint32_t)(input[94] & 0x7f) << 25) |
			((uint32_t)input[95] << 17) |
			((uint32_t)(input[96] & 0x80) << 9);
	output[47] = (double)(value >> 16);
}

static void unpack_48_16bit_signed_2off(const uint8_t * input, double * output, void *closure) {
	// Unpack 48 values into output
	// Values are 16-bit signed
	// Skip 2 bits, read 768 bits of data.
	// Input must be at least 97 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 2 to 17
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)input[1] << 18) |
			((uint32_t)(input[2] & 0xc0) << 10);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 18 to 33
	value = ((uint32_t)(input[2] & 0x3f) << 26) |
			((uint32_t)input[3] << 18) |
			((uint32_t)(input[4] & 0xc0) << 10);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 34 to 49
	value = ((uint32_t)(input[4] & 0x3f) << 26) |
			((uint32_t)input[5] << 18) |
			((uint32_t)(input[6] & 0xc0) << 10);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 50 to 65
	value = ((uint32_t)(input[6] & 0x3f) << 26) |
			((uint32_t)input[7] << 18) |
			((uint32_t)(input[8] & 0xc0) << 10);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 66 to 81
	value = ((uint32_t)(input[8] & 0x3f) << 26) |
			((uint32_t)input[9] << 18) |
			((uint32_t)(input[10] & 0xc0) << 10);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 82 to 97
	value = ((uint32_t)(input[10] & 0x3f) << 26) |
			((uint32_t)input[11] << 18) |
			((uint32_t)(input[12] & 0xc0) << 10);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 98 to 113
	value = ((uint32_t)(input[12] & 0x3f) << 26) |
			((uint32_t)input[13] << 18) |
			((uint32_t)(input[14] & 0xc0) << 10);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 114 to 129
	value = ((uint32_t)(input[14] & 0x3f) << 26) |
			((uint32_t)input[15] << 18) |
			((uint32_t)(input[16] & 0xc0) << 10);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 130 to 145
	value = ((uint32_t)(input[16] & 0x3f) << 26) |
			((uint32_t)input[17] << 18) |
			((uint32_t)(input[18] & 0xc0) << 10);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 146 to 161
	value = ((uint32_t)(input[18] & 0x3f) << 26) |
			((uint32_t)input[19] << 18) |
			((uint32_t)(input[20] & 0xc0) << 10);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 162 to 177
	value = ((uint32_t)(input[20] & 0x3f) << 26) |
			((uint32_t)input[21] << 18) |
			((uint32_t)(input[22] & 0xc0) << 10);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 178 to 193
	value = ((uint32_t)(input[22] & 0x3f) << 26) |
			((uint32_t)input[23] << 18) |
			((uint32_t)(input[24] & 0xc0) << 10);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 194 to 209
	value = ((uint32_t)(input[24] & 0x3f) << 26) |
			((uint32_t)input[25] << 18) |
			((uint32_t)(input[26] & 0xc0) << 10);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 210 to 225
	value = ((uint32_t)(input[26] & 0x3f) << 26) |
			((uint32_t)input[27] << 18) |
			((uint32_t)(input[28] & 0xc0) << 10);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 226 to 241
	value = ((uint32_t)(input[28] & 0x3f) << 26) |
			((uint32_t)input[29] << 18) |
			((uint32_t)(input[30] & 0xc0) << 10);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 242 to 257
	value = ((uint32_t)(input[30] & 0x3f) << 26) |
			((uint32_t)input[31] << 18) |
			((uint32_t)(input[32] & 0xc0) << 10);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 258 to 273
	value = ((uint32_t)(input[32] & 0x3f) << 26) |
			((uint32_t)input[33] << 18) |
			((uint32_t)(input[34] & 0xc0) << 10);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 274 to 289
	value = ((uint32_t)(input[34] & 0x3f) << 26) |
			((uint32_t)input[35] << 18) |
			((uint32_t)(input[36] & 0xc0) << 10);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 290 to 305
	value = ((uint32_t)(input[36] & 0x3f) << 26) |
			((uint32_t)input[37] << 18) |
			((uint32_t)(input[38] & 0xc0) << 10);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 306 to 321
	value = ((uint32_t)(input[38] & 0x3f) << 26) |
			((uint32_t)input[39] << 18) |
			((uint32_t)(input[40] & 0xc0) << 10);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 322 to 337
	value = ((uint32_t)(input[40] & 0x3f) << 26) |
			((uint32_t)input[41] << 18) |
			((uint32_t)(input[42] & 0xc0) << 10);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 338 to 353
	value = ((uint32_t)(input[42] & 0x3f) << 26) |
			((uint32_t)input[43] << 18) |
			((uint32_t)(input[44] & 0xc0) << 10);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 354 to 369
	value = ((uint32_t)(input[44] & 0x3f) << 26) |
			((uint32_t)input[45] << 18) |
			((uint32_t)(input[46] & 0xc0) << 10);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 370 to 385
	value = ((uint32_t)(input[46] & 0x3f) << 26) |
			((uint32_t)input[47] << 18) |
			((uint32_t)(input[48] & 0xc0) << 10);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 386 to 401
	value = ((uint32_t)(input[48] & 0x3f) << 26) |
			((uint32_t)input[49] << 18) |
			((uint32_t)(input[50] & 0xc0) << 10);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 402 to 417
	value = ((uint32_t)(input[50] & 0x3f) << 26) |
			((uint32_t)input[51] << 18) |
			((uint32_t)(input[52] & 0xc0) << 10);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 418 to 433
	value = ((uint32_t)(input[52] & 0x3f) << 26) |
			((uint32_t)input[53] << 18) |
			((uint32_t)(input[54] & 0xc0) << 10);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 434 to 449
	value = ((uint32_t)(input[54] & 0x3f) << 26) |
			((uint32_t)input[55] << 18) |
			((uint32_t)(input[56] & 0xc0) << 10);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 450 to 465
	value = ((uint32_t)(input[56] & 0x3f) << 26) |
			((uint32_t)input[57] << 18) |
			((uint32_t)(input[58] & 0xc0) << 10);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 466 to 481
	value = ((uint32_t)(input[58] & 0x3f) << 26) |
			((uint32_t)input[59] << 18) |
			((uint32_t)(input[60] & 0xc0) << 10);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 482 to 497
	value = ((uint32_t)(input[60] & 0x3f) << 26) |
			((uint32_t)input[61] << 18) |
			((uint32_t)(input[62] & 0xc0) << 10);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 498 to 513
	value = ((uint32_t)(input[62] & 0x3f) << 26) |
			((uint32_t)input[63] << 18) |
			((uint32_t)(input[64] & 0xc0) << 10);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 514 to 529
	value = ((uint32_t)(input[64] & 0x3f) << 26) |
			((uint32_t)input[65] << 18) |
			((uint32_t)(input[66] & 0xc0) << 10);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 530 to 545
	value = ((uint32_t)(input[66] & 0x3f) << 26) |
			((uint32_t)input[67] << 18) |
			((uint32_t)(input[68] & 0xc0) << 10);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 546 to 561
	value = ((uint32_t)(input[68] & 0x3f) << 26) |
			((uint32_t)input[69] << 18) |
			((uint32_t)(input[70] & 0xc0) << 10);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 562 to 577
	value = ((uint32_t)(input[70] & 0x3f) << 26) |
			((uint32_t)input[71] << 18) |
			((uint32_t)(input[72] & 0xc0) << 10);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 578 to 593
	value = ((uint32_t)(input[72] & 0x3f) << 26) |
			((uint32_t)input[73] << 18) |
			((uint32_t)(input[74] & 0xc0) << 10);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 594 to 609
	value = ((uint32_t)(input[74] & 0x3f) << 26) |
			((uint32_t)input[75] << 18) |
			((uint32_t)(input[76] & 0xc0) << 10);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 610 to 625
	value = ((uint32_t)(input[76] & 0x3f) << 26) |
			((uint32_t)input[77] << 18) |
			((uint32_t)(input[78] & 0xc0) << 10);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 626 to 641
	value = ((uint32_t)(input[78] & 0x3f) << 26) |
			((uint32_t)input[79] << 18) |
			((uint32_t)(input[80] & 0xc0) << 10);
	output[39] = (double)(value >> 16);

	// read output[40]: from bit 642 to 657
	value = ((uint32_t)(input[80] & 0x3f) << 26) |
			((uint32_t)input[81] << 18) |
			((uint32_t)(input[82] & 0xc0) << 10);
	output[40] = (double)(value >> 16);

	// read output[41]: from bit 658 to 673
	value = ((uint32_t)(input[82] & 0x3f) << 26) |
			((uint32_t)input[83] << 18) |
			((uint32_t)(input[84] & 0xc0) << 10);
	output[41] = (double)(value >> 16);

	// read output[42]: from bit 674 to 689
	value = ((uint32_t)(input[84] & 0x3f) << 26) |
			((uint32_t)input[85] << 18) |
			((uint32_t)(input[86] & 0xc0) << 10);
	output[42] = (double)(value >> 16);

	// read output[43]: from bit 690 to 705
	value = ((uint32_t)(input[86] & 0x3f) << 26) |
			((uint32_t)input[87] << 18) |
			((uint32_t)(input[88] & 0xc0) << 10);
	output[43] = (double)(value >> 16);

	// read output[44]: from bit 706 to 721
	value = ((uint32_t)(input[88] & 0x3f) << 26) |
			((uint32_t)input[89] << 18) |
			((uint32_t)(input[90] & 0xc0) << 10);
	output[44] = (double)(value >> 16);

	// read output[45]: from bit 722 to 737
	value = ((uint32_t)(input[90] & 0x3f) << 26) |
			((uint32_t)input[91] << 18) |
			((uint32_t)(input[92] & 0xc0) << 10);
	output[45] = (double)(value >> 16);

	// read output[46]: from bit 738 to 753
	value = ((uint32_t)(input[92] & 0x3f) << 26) |
			((uint32_t)input[93] << 18) |
			((uint32_t)(input[94] & 0xc0) << 10);
	output[46] = (double)(value >> 16);

	// read output[47]: from bit 754 to 769
	value = ((uint32_t)(input[94] & 0x3f) << 26) |
			((uint32_t)input[95] << 18) |
			((uint32_t)(input[96] & 0xc0) << 10);
	output[47] = (double)(value >> 16);
}

static void unpack_48_16bit_unsigned_2off(const uint8_t * input, double * output, void *closure) {
	// Unpack 48 values into output
	// Values are 16-bit unsigned
	// Skip 2 bits, read 768 bits of data.
	// Input must be at least 97 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 2 to 17
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)input[1] << 18) |
			((uint32_t)(input[2] & 0xc0) << 10);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 18 to 33
	value = ((uint32_t)(input[2] & 0x3f) << 26) |
			((uint32_t)input[3] << 18) |
			((uint32_t)(input[4] & 0xc0) << 10);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 34 to 49
	value = ((uint32_t)(input[4] & 0x3f) << 26) |
			((uint32_t)input[5] << 18) |
			((uint32_t)(input[6] & 0xc0) << 10);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 50 to 65
	value = ((uint32_t)(input[6] & 0x3f) << 26) |
			((uint32_t)input[7] << 18) |
			((uint32_t)(input[8] & 0xc0) << 10);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 66 to 81
	value = ((uint32_t)(input[8] & 0x3f) << 26) |
			((uint32_t)input[9] << 18) |
			((uint32_t)(input[10] & 0xc0) << 10);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 82 to 97
	value = ((uint32_t)(input[10] & 0x3f) << 26) |
			((uint32_t)input[11] << 18) |
			((uint32_t)(input[12] & 0xc0) << 10);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 98 to 113
	value = ((uint32_t)(input[12] & 0x3f) << 26) |
			((uint32_t)input[13] << 18) |
			((uint32_t)(input[14] & 0xc0) << 10);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 114 to 129
	value = ((uint32_t)(input[14] & 0x3f) << 26) |
			((uint32_t)input[15] << 18) |
			((uint32_t)(input[16] & 0xc0) << 10);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 130 to 145
	value = ((uint32_t)(input[16] & 0x3f) << 26) |
			((uint32_t)input[17] << 18) |
			((uint32_t)(input[18] & 0xc0) << 10);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 146 to 161
	value = ((uint32_t)(input[18] & 0x3f) << 26) |
			((uint32_t)input[19] << 18) |
			((uint32_t)(input[20] & 0xc0) << 10);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 162 to 177
	value = ((uint32_t)(input[20] & 0x3f) << 26) |
			((uint32_t)input[21] << 18) |
			((uint32_t)(input[22] & 0xc0) << 10);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 178 to 193
	value = ((uint32_t)(input[22] & 0x3f) << 26) |
			((uint32_t)input[23] << 18) |
			((uint32_t)(input[24] & 0xc0) << 10);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 194 to 209
	value = ((uint32_t)(input[24] & 0x3f) << 26) |
			((uint32_t)input[25] << 18) |
			((uint32_t)(input[26] & 0xc0) << 10);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 210 to 225
	value = ((uint32_t)(input[26] & 0x3f) << 26) |
			((uint32_t)input[27] << 18) |
			((uint32_t)(input[28] & 0xc0) << 10);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 226 to 241
	value = ((uint32_t)(input[28] & 0x3f) << 26) |
			((uint32_t)input[29] << 18) |
			((uint32_t)(input[30] & 0xc0) << 10);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 242 to 257
	value = ((uint32_t)(input[30] & 0x3f) << 26) |
			((uint32_t)input[31] << 18) |
			((uint32_t)(input[32] & 0xc0) << 10);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 258 to 273
	value = ((uint32_t)(input[32] & 0x3f) << 26) |
			((uint32_t)input[33] << 18) |
			((uint32_t)(input[34] & 0xc0) << 10);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 274 to 289
	value = ((uint32_t)(input[34] & 0x3f) << 26) |
			((uint32_t)input[35] << 18) |
			((uint32_t)(input[36] & 0xc0) << 10);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 290 to 305
	value = ((uint32_t)(input[36] & 0x3f) << 26) |
			((uint32_t)input[37] << 18) |
			((uint32_t)(input[38] & 0xc0) << 10);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 306 to 321
	value = ((uint32_t)(input[38] & 0x3f) << 26) |
			((uint32_t)input[39] << 18) |
			((uint32_t)(input[40] & 0xc0) << 10);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 322 to 337
	value = ((uint32_t)(input[40] & 0x3f) << 26) |
			((uint32_t)input[41] << 18) |
			((uint32_t)(input[42] & 0xc0) << 10);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 338 to 353
	value = ((uint32_t)(input[42] & 0x3f) << 26) |
			((uint32_t)input[43] << 18) |
			((uint32_t)(input[44] & 0xc0) << 10);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 354 to 369
	value = ((uint32_t)(input[44] & 0x3f) << 26) |
			((uint32_t)input[45] << 18) |
			((uint32_t)(input[46] & 0xc0) << 10);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 370 to 385
	value = ((uint32_t)(input[46] & 0x3f) << 26) |
			((uint32_t)input[47] << 18) |
			((uint32_t)(input[48] & 0xc0) << 10);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 386 to 401
	value = ((uint32_t)(input[48] & 0x3f) << 26) |
			((uint32_t)input[49] << 18) |
			((uint32_t)(input[50] & 0xc0) << 10);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 402 to 417
	value = ((uint32_t)(input[50] & 0x3f) << 26) |
			((uint32_t)input[51] << 18) |
			((uint32_t)(input[52] & 0xc0) << 10);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 418 to 433
	value = ((uint32_t)(input[52] & 0x3f) << 26) |
			((uint32_t)input[53] << 18) |
			((uint32_t)(input[54] & 0xc0) << 10);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 434 to 449
	value = ((uint32_t)(input[54] & 0x3f) << 26) |
			((uint32_t)input[55] << 18) |
			((uint32_t)(input[56] & 0xc0) << 10);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 450 to 465
	value = ((uint32_t)(input[56] & 0x3f) << 26) |
			((uint32_t)input[57] << 18) |
			((uint32_t)(input[58] & 0xc0) << 10);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 466 to 481
	value = ((uint32_t)(input[58] & 0x3f) << 26) |
			((uint32_t)input[59] << 18) |
			((uint32_t)(input[60] & 0xc0) << 10);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 482 to 497
	value = ((uint32_t)(input[60] & 0x3f) << 26) |
			((uint32_t)input[61] << 18) |
			((uint32_t)(input[62] & 0xc0) << 10);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 498 to 513
	value = ((uint32_t)(input[62] & 0x3f) << 26) |
			((uint32_t)input[63] << 18) |
			((uint32_t)(input[64] & 0xc0) << 10);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 514 to 529
	value = ((uint32_t)(input[64] & 0x3f) << 26) |
			((uint32_t)input[65] << 18) |
			((uint32_t)(input[66] & 0xc0) << 10);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 530 to 545
	value = ((uint32_t)(input[66] & 0x3f) << 26) |
			((uint32_t)input[67] << 18) |
			((uint32_t)(input[68] & 0xc0) << 10);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 546 to 561
	value = ((uint32_t)(input[68] & 0x3f) << 26) |
			((uint32_t)input[69] << 18) |
			((uint32_t)(input[70] & 0xc0) << 10);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 562 to 577
	value = ((uint32_t)(input[70] & 0x3f) << 26) |
			((uint32_t)input[71] << 18) |
			((uint32_t)(input[72] & 0xc0) << 10);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 578 to 593
	value = ((uint32_t)(input[72] & 0x3f) << 26) |
			((uint32_t)input[73] << 18) |
			((uint32_t)(input[74] & 0xc0) << 10);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 594 to 609
	value = ((uint32_t)(input[74] & 0x3f) << 26) |
			((uint32_t)input[75] << 18) |
			((uint32_t)(input[76] & 0xc0) << 10);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 610 to 625
	value = ((uint32_t)(input[76] & 0x3f) << 26) |
			((uint32_t)input[77] << 18) |
			((uint32_t)(input[78] & 0xc0) << 10);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 626 to 641
	value = ((uint32_t)(input[78] & 0x3f) << 26) |
			((uint32_t)input[79] << 18) |
			((uint32_t)(input[80] & 0xc0) << 10);
	output[39] = (double)(value >> 16);

	// read output[40]: from bit 642 to 657
	value = ((uint32_t)(input[80] & 0x3f) << 26) |
			((uint32_t)input[81] << 18) |
			((uint32_t)(input[82] & 0xc0) << 10);
	output[40] = (double)(value >> 16);

	// read output[41]: from bit 658 to 673
	value = ((uint32_t)(input[82] & 0x3f) << 26) |
			((uint32_t)input[83] << 18) |
			((uint32_t)(input[84] & 0xc0) << 10);
	output[41] = (double)(value >> 16);

	// read output[42]: from bit 674 to 689
	value = ((uint32_t)(input[84] & 0x3f) << 26) |
			((uint32_t)input[85] << 18) |
			((uint32_t)(input[86] & 0xc0) << 10);
	output[42] = (double)(value >> 16);

	// read output[43]: from bit 690 to 705
	value = ((uint32_t)(input[86] & 0x3f) << 26) |
			((uint32_t)input[87] << 18) |
			((uint32_t)(input[88] & 0xc0) << 10);
	output[43] = (double)(value >> 16);

	// read output[44]: from bit 706 to 721
	value = ((uint32_t)(input[88] & 0x3f) << 26) |
			((uint32_t)input[89] << 18) |
			((uint32_t)(input[90] & 0xc0) << 10);
	output[44] = (double)(value >> 16);

	// read output[45]: from bit 722 to 737
	value = ((uint32_t)(input[90] & 0x3f) << 26) |
			((uint32_t)input[91] << 18) |
			((uint32_t)(input[92] & 0xc0) << 10);
	output[45] = (double)(value >> 16);

	// read output[46]: from bit 738 to 753
	value = ((uint32_t)(input[92] & 0x3f) << 26) |
			((uint32_t)input[93] << 18) |
			((uint32_t)(input[94] & 0xc0) << 10);
	output[46] = (double)(value >> 16);

	// read output[47]: from bit 754 to 769
	value = ((uint32_t)(input[94] & 0x3f) << 26) |
			((uint32_t)input[95] << 18) |
			((uint32_t)(input[96] & 0xc0) << 10);
	output[47] = (double)(value >> 16);
}

static void unpack_48_16bit_signed_3off(const uint8_t * input, double * output, void *closure) {
	// Unpack 48 values into output
	// Values are 16-bit signed
	// Skip 3 bits, read 768 bits of data.
	// Input must be at least 97 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 3 to 18
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)input[1] << 19) |
			((uint32_t)(input[2] & 0xe0) << 11);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 19 to 34
	value = ((uint32_t)(input[2] & 0x1f) << 27) |
			((uint32_t)input[3] << 19) |
			((uint32_t)(input[4] & 0xe0) << 11);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 35 to 50
	value = ((uint32_t)(input[4] & 0x1f) << 27) |
			((uint32_t)input[5] << 19) |
			((uint32_t)(input[6] & 0xe0) << 11);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 51 to 66
	value = ((uint32_t)(input[6] & 0x1f) << 27) |
			((uint32_t)input[7] << 19) |
			((uint32_t)(input[8] & 0xe0) << 11);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 67 to 82
	value = ((uint32_t)(input[8] & 0x1f) << 27) |
			((uint32_t)input[9] << 19) |
			((uint32_t)(input[10] & 0xe0) << 11);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 83 to 98
	value = ((uint32_t)(input[10] & 0x1f) << 27) |
			((uint32_t)input[11] << 19) |
			((uint32_t)(input[12] & 0xe0) << 11);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 99 to 114
	value = ((uint32_t)(input[12] & 0x1f) << 27) |
			((uint32_t)input[13] << 19) |
			((uint32_t)(input[14] & 0xe0) << 11);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 115 to 130
	value = ((uint32_t)(input[14] & 0x1f) << 27) |
			((uint32_t)input[15] << 19) |
			((uint32_t)(input[16] & 0xe0) << 11);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 131 to 146
	value = ((uint32_t)(input[16] & 0x1f) << 27) |
			((uint32_t)input[17] << 19) |
			((uint32_t)(input[18] & 0xe0) << 11);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 147 to 162
	value = ((uint32_t)(input[18] & 0x1f) << 27) |
			((uint32_t)input[19] << 19) |
			((uint32_t)(input[20] & 0xe0) << 11);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 163 to 178
	value = ((uint32_t)(input[20] & 0x1f) << 27) |
			((uint32_t)input[21] << 19) |
			((uint32_t)(input[22] & 0xe0) << 11);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 179 to 194
	value = ((uint32_t)(input[22] & 0x1f) << 27) |
			((uint32_t)input[23] << 19) |
			((uint32_t)(input[24] & 0xe0) << 11);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 195 to 210
	value = ((uint32_t)(input[24] & 0x1f) << 27) |
			((uint32_t)input[25] << 19) |
			((uint32_t)(input[26] & 0xe0) << 11);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 211 to 226
	value = ((uint32_t)(input[26] & 0x1f) << 27) |
			((uint32_t)input[27] << 19) |
			((uint32_t)(input[28] & 0xe0) << 11);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 227 to 242
	value = ((uint32_t)(input[28] & 0x1f) << 27) |
			((uint32_t)input[29] << 19) |
			((uint32_t)(input[30] & 0xe0) << 11);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 243 to 258
	value = ((uint32_t)(input[30] & 0x1f) << 27) |
			((uint32_t)input[31] << 19) |
			((uint32_t)(input[32] & 0xe0) << 11);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 259 to 274
	value = ((uint32_t)(input[32] & 0x1f) << 27) |
			((uint32_t)input[33] << 19) |
			((uint32_t)(input[34] & 0xe0) << 11);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 275 to 290
	value = ((uint32_t)(input[34] & 0x1f) << 27) |
			((uint32_t)input[35] << 19) |
			((uint32_t)(input[36] & 0xe0) << 11);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 291 to 306
	value = ((uint32_t)(input[36] & 0x1f) << 27) |
			((uint32_t)input[37] << 19) |
			((uint32_t)(input[38] & 0xe0) << 11);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 307 to 322
	value = ((uint32_t)(input[38] & 0x1f) << 27) |
			((uint32_t)input[39] << 19) |
			((uint32_t)(input[40] & 0xe0) << 11);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 323 to 338
	value = ((uint32_t)(input[40] & 0x1f) << 27) |
			((uint32_t)input[41] << 19) |
			((uint32_t)(input[42] & 0xe0) << 11);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 339 to 354
	value = ((uint32_t)(input[42] & 0x1f) << 27) |
			((uint32_t)input[43] << 19) |
			((uint32_t)(input[44] & 0xe0) << 11);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 355 to 370
	value = ((uint32_t)(input[44] & 0x1f) << 27) |
			((uint32_t)input[45] << 19) |
			((uint32_t)(input[46] & 0xe0) << 11);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 371 to 386
	value = ((uint32_t)(input[46] & 0x1f) << 27) |
			((uint32_t)input[47] << 19) |
			((uint32_t)(input[48] & 0xe0) << 11);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 387 to 402
	value = ((uint32_t)(input[48] & 0x1f) << 27) |
			((uint32_t)input[49] << 19) |
			((uint32_t)(input[50] & 0xe0) << 11);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 403 to 418
	value = ((uint32_t)(input[50] & 0x1f) << 27) |
			((uint32_t)input[51] << 19) |
			((uint32_t)(input[52] & 0xe0) << 11);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 419 to 434
	value = ((uint32_t)(input[52] & 0x1f) << 27) |
			((uint32_t)input[53] << 19) |
			((uint32_t)(input[54] & 0xe0) << 11);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 435 to 450
	value = ((uint32_t)(input[54] & 0x1f) << 27) |
			((uint32_t)input[55] << 19) |
			((uint32_t)(input[56] & 0xe0) << 11);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 451 to 466
	value = ((uint32_t)(input[56] & 0x1f) << 27) |
			((uint32_t)input[57] << 19) |
			((uint32_t)(input[58] & 0xe0) << 11);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 467 to 482
	value = ((uint32_t)(input[58] & 0x1f) << 27) |
			((uint32_t)input[59] << 19) |
			((uint32_t)(input[60] & 0xe0) << 11);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 483 to 498
	value = ((uint32_t)(input[60] & 0x1f) << 27) |
			((uint32_t)input[61] << 19) |
			((uint32_t)(input[62] & 0xe0) << 11);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 499 to 514
	value = ((uint32_t)(input[62] & 0x1f) << 27) |
			((uint32_t)input[63] << 19) |
			((uint32_t)(input[64] & 0xe0) << 11);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 515 to 530
	value = ((uint32_t)(input[64] & 0x1f) << 27) |
			((uint32_t)input[65] << 19) |
			((uint32_t)(input[66] & 0xe0) << 11);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 531 to 546
	value = ((uint32_t)(input[66] & 0x1f) << 27) |
			((uint32_t)input[67] << 19) |
			((uint32_t)(input[68] & 0xe0) << 11);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 547 to 562
	value = ((uint32_t)(input[68] & 0x1f) << 27) |
			((uint32_t)input[69] << 19) |
			((uint32_t)(input[70] & 0xe0) << 11);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 563 to 578
	value = ((uint32_t)(input[70] & 0x1f) << 27) |
			((uint32_t)input[71] << 19) |
			((uint32_t)(input[72] & 0xe0) << 11);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 579 to 594
	value = ((uint32_t)(input[72] & 0x1f) << 27) |
			((uint32_t)input[73] << 19) |
			((uint32_t)(input[74] & 0xe0) << 11);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 595 to 610
	value = ((uint32_t)(input[74] & 0x1f) << 27) |
			((uint32_t)input[75] << 19) |
			((uint32_t)(input[76] & 0xe0) << 11);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 611 to 626
	value = ((uint32_t)(input[76] & 0x1f) << 27) |
			((uint32_t)input[77] << 19) |
			((uint32_t)(input[78] & 0xe0) << 11);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 627 to 642
	value = ((uint32_t)(input[78] & 0x1f) << 27) |
			((uint32_t)input[79] << 19) |
			((uint32_t)(input[80] & 0xe0) << 11);
	output[39] = (double)(value >> 16);

	// read output[40]: from bit 643 to 658
	value = ((uint32_t)(input[80] & 0x1f) << 27) |
			((uint32_t)input[81] << 19) |
			((uint32_t)(input[82] & 0xe0) << 11);
	output[40] = (double)(value >> 16);

	// read output[41]: from bit 659 to 674
	value = ((uint32_t)(input[82] & 0x1f) << 27) |
			((uint32_t)input[83] << 19) |
			((uint32_t)(input[84] & 0xe0) << 11);
	output[41] = (double)(value >> 16);

	// read output[42]: from bit 675 to 690
	value = ((uint32_t)(input[84] & 0x1f) << 27) |
			((uint32_t)input[85] << 19) |
			((uint32_t)(input[86] & 0xe0) << 11);
	output[42] = (double)(value >> 16);

	// read output[43]: from bit 691 to 706
	value = ((uint32_t)(input[86] & 0x1f) << 27) |
			((uint32_t)input[87] << 19) |
			((uint32_t)(input[88] & 0xe0) << 11);
	output[43] = (double)(value >> 16);

	// read output[44]: from bit 707 to 722
	value = ((uint32_t)(input[88] & 0x1f) << 27) |
			((uint32_t)input[89] << 19) |
			((uint32_t)(input[90] & 0xe0) << 11);
	output[44] = (double)(value >> 16);

	// read output[45]: from bit 723 to 738
	value = ((uint32_t)(input[90] & 0x1f) << 27) |
			((uint32_t)input[91] << 19) |
			((uint32_t)(input[92] & 0xe0) << 11);
	output[45] = (double)(value >> 16);

	// read output[46]: from bit 739 to 754
	value = ((uint32_t)(input[92] & 0x1f) << 27) |
			((uint32_t)input[93] << 19) |
			((uint32_t)(input[94] & 0xe0) << 11);
	output[46] = (double)(value >> 16);

	// read output[47]: from bit 755 to 770
	value = ((uint32_t)(input[94] & 0x1f) << 27) |
			((uint32_t)input[95] << 19) |
			((uint32_t)(input[96] & 0xe0) << 11);
	output[47] = (double)(value >> 16);
}

static void unpack_48_16bit_unsigned_3off(const uint8_t * input, double * output, void *closure) {
	// Unpack 48 values into output
	// Values are 16-bit unsigned
	// Skip 3 bits, read 768 bits of data.
	// Input must be at least 97 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 3 to 18
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)input[1] << 19) |
			((uint32_t)(input[2] & 0xe0) << 11);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 19 to 34
	value = ((uint32_t)(input[2] & 0x1f) << 27) |
			((uint32_t)input[3] << 19) |
			((uint32_t)(input[4] & 0xe0) << 11);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 35 to 50
	value = ((uint32_t)(input[4] & 0x1f) << 27) |
			((uint32_t)input[5] << 19) |
			((uint32_t)(input[6] & 0xe0) << 11);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 51 to 66
	value = ((uint32_t)(input[6] & 0x1f) << 27) |
			((uint32_t)input[7] << 19) |
			((uint32_t)(input[8] & 0xe0) << 11);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 67 to 82
	value = ((uint32_t)(input[8] & 0x1f) << 27) |
			((uint32_t)input[9] << 19) |
			((uint32_t)(input[10] & 0xe0) << 11);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 83 to 98
	value = ((uint32_t)(input[10] & 0x1f) << 27) |
			((uint32_t)input[11] << 19) |
			((uint32_t)(input[12] & 0xe0) << 11);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 99 to 114
	value = ((uint32_t)(input[12] & 0x1f) << 27) |
			((uint32_t)input[13] << 19) |
			((uint32_t)(input[14] & 0xe0) << 11);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 115 to 130
	value = ((uint32_t)(input[14] & 0x1f) << 27) |
			((uint32_t)input[15] << 19) |
			((uint32_t)(input[16] & 0xe0) << 11);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 131 to 146
	value = ((uint32_t)(input[16] & 0x1f) << 27) |
			((uint32_t)input[17] << 19) |
			((uint32_t)(input[18] & 0xe0) << 11);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 147 to 162
	value = ((uint32_t)(input[18] & 0x1f) << 27) |
			((uint32_t)input[19] << 19) |
			((uint32_t)(input[20] & 0xe0) << 11);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 163 to 178
	value = ((uint32_t)(input[20] & 0x1f) << 27) |
			((uint32_t)input[21] << 19) |
			((uint32_t)(input[22] & 0xe0) << 11);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 179 to 194
	value = ((uint32_t)(input[22] & 0x1f) << 27) |
			((uint32_t)input[23] << 19) |
			((uint32_t)(input[24] & 0xe0) << 11);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 195 to 210
	value = ((uint32_t)(input[24] & 0x1f) << 27) |
			((uint32_t)input[25] << 19) |
			((uint32_t)(input[26] & 0xe0) << 11);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 211 to 226
	value = ((uint32_t)(input[26] & 0x1f) << 27) |
			((uint32_t)input[27] << 19) |
			((uint32_t)(input[28] & 0xe0) << 11);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 227 to 242
	value = ((uint32_t)(input[28] & 0x1f) << 27) |
			((uint32_t)input[29] << 19) |
			((uint32_t)(input[30] & 0xe0) << 11);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 243 to 258
	value = ((uint32_t)(input[30] & 0x1f) << 27) |
			((uint32_t)input[31] << 19) |
			((uint32_t)(input[32] & 0xe0) << 11);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 259 to 274
	value = ((uint32_t)(input[32] & 0x1f) << 27) |
			((uint32_t)input[33] << 19) |
			((uint32_t)(input[34] & 0xe0) << 11);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 275 to 290
	value = ((uint32_t)(input[34] & 0x1f) << 27) |
			((uint32_t)input[35] << 19) |
			((uint32_t)(input[36] & 0xe0) << 11);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 291 to 306
	value = ((uint32_t)(input[36] & 0x1f) << 27) |
			((uint32_t)input[37] << 19) |
			((uint32_t)(input[38] & 0xe0) << 11);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 307 to 322
	value = ((uint32_t)(input[38] & 0x1f) << 27) |
			((uint32_t)input[39] << 19) |
			((uint32_t)(input[40] & 0xe0) << 11);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 323 to 338
	value = ((uint32_t)(input[40] & 0x1f) << 27) |
			((uint32_t)input[41] << 19) |
			((uint32_t)(input[42] & 0xe0) << 11);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 339 to 354
	value = ((uint32_t)(input[42] & 0x1f) << 27) |
			((uint32_t)input[43] << 19) |
			((uint32_t)(input[44] & 0xe0) << 11);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 355 to 370
	value = ((uint32_t)(input[44] & 0x1f) << 27) |
			((uint32_t)input[45] << 19) |
			((uint32_t)(input[46] & 0xe0) << 11);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 371 to 386
	value = ((uint32_t)(input[46] & 0x1f) << 27) |
			((uint32_t)input[47] << 19) |
			((uint32_t)(input[48] & 0xe0) << 11);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 387 to 402
	value = ((uint32_t)(input[48] & 0x1f) << 27) |
			((uint32_t)input[49] << 19) |
			((uint32_t)(input[50] & 0xe0) << 11);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 403 to 418
	value = ((uint32_t)(input[50] & 0x1f) << 27) |
			((uint32_t)input[51] << 19) |
			((uint32_t)(input[52] & 0xe0) << 11);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 419 to 434
	value = ((uint32_t)(input[52] & 0x1f) << 27) |
			((uint32_t)input[53] << 19) |
			((uint32_t)(input[54] & 0xe0) << 11);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 435 to 450
	value = ((uint32_t)(input[54] & 0x1f) << 27) |
			((uint32_t)input[55] << 19) |
			((uint32_t)(input[56] & 0xe0) << 11);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 451 to 466
	value = ((uint32_t)(input[56] & 0x1f) << 27) |
			((uint32_t)input[57] << 19) |
			((uint32_t)(input[58] & 0xe0) << 11);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 467 to 482
	value = ((uint32_t)(input[58] & 0x1f) << 27) |
			((uint32_t)input[59] << 19) |
			((uint32_t)(input[60] & 0xe0) << 11);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 483 to 498
	value = ((uint32_t)(input[60] & 0x1f) << 27) |
			((uint32_t)input[61] << 19) |
			((uint32_t)(input[62] & 0xe0) << 11);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 499 to 514
	value = ((uint32_t)(input[62] & 0x1f) << 27) |
			((uint32_t)input[63] << 19) |
			((uint32_t)(input[64] & 0xe0) << 11);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 515 to 530
	value = ((uint32_t)(input[64] & 0x1f) << 27) |
			((uint32_t)input[65] << 19) |
			((uint32_t)(input[66] & 0xe0) << 11);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 531 to 546
	value = ((uint32_t)(input[66] & 0x1f) << 27) |
			((uint32_t)input[67] << 19) |
			((uint32_t)(input[68] & 0xe0) << 11);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 547 to 562
	value = ((uint32_t)(input[68] & 0x1f) << 27) |
			((uint32_t)input[69] << 19) |
			((uint32_t)(input[70] & 0xe0) << 11);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 563 to 578
	value = ((uint32_t)(input[70] & 0x1f) << 27) |
			((uint32_t)input[71] << 19) |
			((uint32_t)(input[72] & 0xe0) << 11);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 579 to 594
	value = ((uint32_t)(input[72] & 0x1f) << 27) |
			((uint32_t)input[73] << 19) |
			((uint32_t)(input[74] & 0xe0) << 11);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 595 to 610
	value = ((uint32_t)(input[74] & 0x1f) << 27) |
			((uint32_t)input[75] << 19) |
			((uint32_t)(input[76] & 0xe0) << 11);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 611 to 626
	value = ((uint32_t)(input[76] & 0x1f) << 27) |
			((uint32_t)input[77] << 19) |
			((uint32_t)(input[78] & 0xe0) << 11);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 627 to 642
	value = ((uint32_t)(input[78] & 0x1f) << 27) |
			((uint32_t)input[79] << 19) |
			((uint32_t)(input[80] & 0xe0) << 11);
	output[39] = (double)(value >> 16);

	// read output[40]: from bit 643 to 658
	value = ((uint32_t)(input[80] & 0x1f) << 27) |
			((uint32_t)input[81] << 19) |
			((uint32_t)(input[82] & 0xe0) << 11);
	output[40] = (double)(value >> 16);

	// read output[41]: from bit 659 to 674
	value = ((uint32_t)(input[82] & 0x1f) << 27) |
			((uint32_t)input[83] << 19) |
			((uint32_t)(input[84] & 0xe0) << 11);
	output[41] = (double)(value >> 16);

	// read output[42]: from bit 675 to 690
	value = ((uint32_t)(input[84] & 0x1f) << 27) |
			((uint32_t)input[85] << 19) |
			((uint32_t)(input[86] & 0xe0) << 11);
	output[42] = (double)(value >> 16);

	// read output[43]: from bit 691 to 706
	value = ((uint32_t)(input[86] & 0x1f) << 27) |
			((uint32_t)input[87] << 19) |
			((uint32_t)(input[88] & 0xe0) << 11);
	output[43] = (double)(value >> 16);

	// read output[44]: from bit 707 to 722
	value = ((uint32_t)(input[88] & 0x1f) << 27) |
			((uint32_t)input[89] << 19) |
			((uint32_t)(input[90] & 0xe0) << 11);
	output[44] = (double)(value >> 16);

	// read output[45]: from bit 723 to 738
	value = ((uint32_t)(input[90] & 0x1f) << 27) |
			((uint32_t)input[91] << 19) |
			((uint32_t)(input[92] & 0xe0) << 11);
	output[45] = (double)(value >> 16);

	// read output[46]: from bit 739 to 754
	value = ((uint32_t)(input[92] & 0x1f) << 27) |
			((uint32_t)input[93] << 19) |
			((uint32_t)(input[94] & 0xe0) << 11);
	output[46] = (double)(value >> 16);

	// read output[47]: from bit 755 to 770
	value = ((uint32_t)(input[94] & 0x1f) << 27) |
			((uint32_t)input[95] << 19) |
			((uint32_t)(input[96] & 0xe0) << 11);
	output[47] = (double)(value >> 16);
}

static void unpack_48_16bit_signed_4off(const uint8_t * input, double * output, void *closure) {
	// Unpack 48 values into output
	// Values are 16-bit signed
	// Skip 4 bits, read 768 bits of data.
	// Input must be at least 97 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 4 to 19
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20) |
			((uint32_t)(input[2] & 0xf0) << 12);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 20 to 35
	value = ((uint32_t)(input[2] & 0x0f) << 28) |
			((uint32_t)input[3] << 20) |
			((uint32_t)(input[4] & 0xf0) << 12);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 36 to 51
	value = ((uint32_t)(input[4] & 0x0f) << 28) |
			((uint32_t)input[5] << 20) |
			((uint32_t)(input[6] & 0xf0) << 12);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 52 to 67
	value = ((uint32_t)(input[6] & 0x0f) << 28) |
			((uint32_t)input[7] << 20) |
			((uint32_t)(input[8] & 0xf0) << 12);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 68 to 83
	value = ((uint32_t)(input[8] & 0x0f) << 28) |
			((uint32_t)input[9] << 20) |
			((uint32_t)(input[10] & 0xf0) << 12);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 84 to 99
	value = ((uint32_t)(input[10] & 0x0f) << 28) |
			((uint32_t)input[11] << 20) |
			((uint32_t)(input[12] & 0xf0) << 12);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 100 to 115
	value = ((uint32_t)(input[12] & 0x0f) << 28) |
			((uint32_t)input[13] << 20) |
			((uint32_t)(input[14] & 0xf0) << 12);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 116 to 131
	value = ((uint32_t)(input[14] & 0x0f) << 28) |
			((uint32_t)input[15] << 20) |
			((uint32_t)(input[16] & 0xf0) << 12);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 132 to 147
	value = ((uint32_t)(input[16] & 0x0f) << 28) |
			((uint32_t)input[17] << 20) |
			((uint32_t)(input[18] & 0xf0) << 12);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 148 to 163
	value = ((uint32_t)(input[18] & 0x0f) << 28) |
			((uint32_t)input[19] << 20) |
			((uint32_t)(input[20] & 0xf0) << 12);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 164 to 179
	value = ((uint32_t)(input[20] & 0x0f) << 28) |
			((uint32_t)input[21] << 20) |
			((uint32_t)(input[22] & 0xf0) << 12);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 180 to 195
	value = ((uint32_t)(input[22] & 0x0f) << 28) |
			((uint32_t)input[23] << 20) |
			((uint32_t)(input[24] & 0xf0) << 12);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 196 to 211
	value = ((uint32_t)(input[24] & 0x0f) << 28) |
			((uint32_t)input[25] << 20) |
			((uint32_t)(input[26] & 0xf0) << 12);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 212 to 227
	value = ((uint32_t)(input[26] & 0x0f) << 28) |
			((uint32_t)input[27] << 20) |
			((uint32_t)(input[28] & 0xf0) << 12);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 228 to 243
	value = ((uint32_t)(input[28] & 0x0f) << 28) |
			((uint32_t)input[29] << 20) |
			((uint32_t)(input[30] & 0xf0) << 12);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 244 to 259
	value = ((uint32_t)(input[30] & 0x0f) << 28) |
			((uint32_t)input[31] << 20) |
			((uint32_t)(input[32] & 0xf0) << 12);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 260 to 275
	value = ((uint32_t)(input[32] & 0x0f) << 28) |
			((uint32_t)input[33] << 20) |
			((uint32_t)(input[34] & 0xf0) << 12);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 276 to 291
	value = ((uint32_t)(input[34] & 0x0f) << 28) |
			((uint32_t)input[35] << 20) |
			((uint32_t)(input[36] & 0xf0) << 12);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 292 to 307
	value = ((uint32_t)(input[36] & 0x0f) << 28) |
			((uint32_t)input[37] << 20) |
			((uint32_t)(input[38] & 0xf0) << 12);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 308 to 323
	value = ((uint32_t)(input[38] & 0x0f) << 28) |
			((uint32_t)input[39] << 20) |
			((uint32_t)(input[40] & 0xf0) << 12);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 324 to 339
	value = ((uint32_t)(input[40] & 0x0f) << 28) |
			((uint32_t)input[41] << 20) |
			((uint32_t)(input[42] & 0xf0) << 12);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 340 to 355
	value = ((uint32_t)(input[42] & 0x0f) << 28) |
			((uint32_t)input[43] << 20) |
			((uint32_t)(input[44] & 0xf0) << 12);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 356 to 371
	value = ((uint32_t)(input[44] & 0x0f) << 28) |
			((uint32_t)input[45] << 20) |
			((uint32_t)(input[46] & 0xf0) << 12);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 372 to 387
	value = ((uint32_t)(input[46] & 0x0f) << 28) |
			((uint32_t)input[47] << 20) |
			((uint32_t)(input[48] & 0xf0) << 12);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 388 to 403
	value = ((uint32_t)(input[48] & 0x0f) << 28) |
			((uint32_t)input[49] << 20) |
			((uint32_t)(input[50] & 0xf0) << 12);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 404 to 419
	value = ((uint32_t)(input[50] & 0x0f) << 28) |
			((uint32_t)input[51] << 20) |
			((uint32_t)(input[52] & 0xf0) << 12);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 420 to 435
	value = ((uint32_t)(input[52] & 0x0f) << 28) |
			((uint32_t)input[53] << 20) |
			((uint32_t)(input[54] & 0xf0) << 12);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 436 to 451
	value = ((uint32_t)(input[54] & 0x0f) << 28) |
			((uint32_t)input[55] << 20) |
			((uint32_t)(input[56] & 0xf0) << 12);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 452 to 467
	value = ((uint32_t)(input[56] & 0x0f) << 28) |
			((uint32_t)input[57] << 20) |
			((uint32_t)(input[58] & 0xf0) << 12);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 468 to 483
	value = ((uint32_t)(input[58] & 0x0f) << 28) |
			((uint32_t)input[59] << 20) |
			((uint32_t)(input[60] & 0xf0) << 12);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 484 to 499
	value = ((uint32_t)(input[60] & 0x0f) << 28) |
			((uint32_t)input[61] << 20) |
			((uint32_t)(input[62] & 0xf0) << 12);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 500 to 515
	value = ((uint32_t)(input[62] & 0x0f) << 28) |
			((uint32_t)input[63] << 20) |
			((uint32_t)(input[64] & 0xf0) << 12);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 516 to 531
	value = ((uint32_t)(input[64] & 0x0f) << 28) |
			((uint32_t)input[65] << 20) |
			((uint32_t)(input[66] & 0xf0) << 12);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 532 to 547
	value = ((uint32_t)(input[66] & 0x0f) << 28) |
			((uint32_t)input[67] << 20) |
			((uint32_t)(input[68] & 0xf0) << 12);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 548 to 563
	value = ((uint32_t)(input[68] & 0x0f) << 28) |
			((uint32_t)input[69] << 20) |
			((uint32_t)(input[70] & 0xf0) << 12);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 564 to 579
	value = ((uint32_t)(input[70] & 0x0f) << 28) |
			((uint32_t)input[71] << 20) |
			((uint32_t)(input[72] & 0xf0) << 12);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 580 to 595
	value = ((uint32_t)(input[72] & 0x0f) << 28) |
			((uint32_t)input[73] << 20) |
			((uint32_t)(input[74] & 0xf0) << 12);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 596 to 611
	value = ((uint32_t)(input[74] & 0x0f) << 28) |
			((uint32_t)input[75] << 20) |
			((uint32_t)(input[76] & 0xf0) << 12);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 612 to 627
	value = ((uint32_t)(input[76] & 0x0f) << 28) |
			((uint32_t)input[77] << 20) |
			((uint32_t)(input[78] & 0xf0) << 12);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 628 to 643
	value = ((uint32_t)(input[78] & 0x0f) << 28) |
			((uint32_t)input[79] << 20) |
			((uint32_t)(input[80] & 0xf0) << 12);
	output[39] = (double)(value >> 16);

	// read output[40]: from bit 644 to 659
	value = ((uint32_t)(input[80] & 0x0f) << 28) |
			((uint32_t)input[81] << 20) |
			((uint32_t)(input[82] & 0xf0) << 12);
	output[40] = (double)(value >> 16);

	// read output[41]: from bit 660 to 675
	value = ((uint32_t)(input[82] & 0x0f) << 28) |
			((uint32_t)input[83] << 20) |
			((uint32_t)(input[84] & 0xf0) << 12);
	output[41] = (double)(value >> 16);

	// read output[42]: from bit 676 to 691
	value = ((uint32_t)(input[84] & 0x0f) << 28) |
			((uint32_t)input[85] << 20) |
			((uint32_t)(input[86] & 0xf0) << 12);
	output[42] = (double)(value >> 16);

	// read output[43]: from bit 692 to 707
	value = ((uint32_t)(input[86] & 0x0f) << 28) |
			((uint32_t)input[87] << 20) |
			((uint32_t)(input[88] & 0xf0) << 12);
	output[43] = (double)(value >> 16);

	// read output[44]: from bit 708 to 723
	value = ((uint32_t)(input[88] & 0x0f) << 28) |
			((uint32_t)input[89] << 20) |
			((uint32_t)(input[90] & 0xf0) << 12);
	output[44] = (double)(value >> 16);

	// read output[45]: from bit 724 to 739
	value = ((uint32_t)(input[90] & 0x0f) << 28) |
			((uint32_t)input[91] << 20) |
			((uint32_t)(input[92] & 0xf0) << 12);
	output[45] = (double)(value >> 16);

	// read output[46]: from bit 740 to 755
	value = ((uint32_t)(input[92] & 0x0f) << 28) |
			((uint32_t)input[93] << 20) |
			((uint32_t)(input[94] & 0xf0) << 12);
	output[46] = (double)(value >> 16);

	// read output[47]: from bit 756 to 771
	value = ((uint32_t)(input[94] & 0x0f) << 28) |
			((uint32_t)input[95] << 20) |
			((uint32_t)(input[96] & 0xf0) << 12);
	output[47] = (double)(value >> 16);
}

static void unpack_48_16bit_unsigned_4off(const uint8_t * input, double * output, void *closure) {
	// Unpack 48 values into output
	// Values are 16-bit unsigned
	// Skip 4 bits, read 768 bits of data.
	// Input must be at least 97 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 4 to 19
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20) |
			((uint32_t)(input[2] & 0xf0) << 12);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 20 to 35
	value = ((uint32_t)(input[2] & 0x0f) << 28) |
			((uint32_t)input[3] << 20) |
			((uint32_t)(input[4] & 0xf0) << 12);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 36 to 51
	value = ((uint32_t)(input[4] & 0x0f) << 28) |
			((uint32_t)input[5] << 20) |
			((uint32_t)(input[6] & 0xf0) << 12);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 52 to 67
	value = ((uint32_t)(input[6] & 0x0f) << 28) |
			((uint32_t)input[7] << 20) |
			((uint32_t)(input[8] & 0xf0) << 12);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 68 to 83
	value = ((uint32_t)(input[8] & 0x0f) << 28) |
			((uint32_t)input[9] << 20) |
			((uint32_t)(input[10] & 0xf0) << 12);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 84 to 99
	value = ((uint32_t)(input[10] & 0x0f) << 28) |
			((uint32_t)input[11] << 20) |
			((uint32_t)(input[12] & 0xf0) << 12);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 100 to 115
	value = ((uint32_t)(input[12] & 0x0f) << 28) |
			((uint32_t)input[13] << 20) |
			((uint32_t)(input[14] & 0xf0) << 12);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 116 to 131
	value = ((uint32_t)(input[14] & 0x0f) << 28) |
			((uint32_t)input[15] << 20) |
			((uint32_t)(input[16] & 0xf0) << 12);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 132 to 147
	value = ((uint32_t)(input[16] & 0x0f) << 28) |
			((uint32_t)input[17] << 20) |
			((uint32_t)(input[18] & 0xf0) << 12);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 148 to 163
	value = ((uint32_t)(input[18] & 0x0f) << 28) |
			((uint32_t)input[19] << 20) |
			((uint32_t)(input[20] & 0xf0) << 12);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 164 to 179
	value = ((uint32_t)(input[20] & 0x0f) << 28) |
			((uint32_t)input[21] << 20) |
			((uint32_t)(input[22] & 0xf0) << 12);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 180 to 195
	value = ((uint32_t)(input[22] & 0x0f) << 28) |
			((uint32_t)input[23] << 20) |
			((uint32_t)(input[24] & 0xf0) << 12);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 196 to 211
	value = ((uint32_t)(input[24] & 0x0f) << 28) |
			((uint32_t)input[25] << 20) |
			((uint32_t)(input[26] & 0xf0) << 12);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 212 to 227
	value = ((uint32_t)(input[26] & 0x0f) << 28) |
			((uint32_t)input[27] << 20) |
			((uint32_t)(input[28] & 0xf0) << 12);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 228 to 243
	value = ((uint32_t)(input[28] & 0x0f) << 28) |
			((uint32_t)input[29] << 20) |
			((uint32_t)(input[30] & 0xf0) << 12);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 244 to 259
	value = ((uint32_t)(input[30] & 0x0f) << 28) |
			((uint32_t)input[31] << 20) |
			((uint32_t)(input[32] & 0xf0) << 12);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 260 to 275
	value = ((uint32_t)(input[32] & 0x0f) << 28) |
			((uint32_t)input[33] << 20) |
			((uint32_t)(input[34] & 0xf0) << 12);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 276 to 291
	value = ((uint32_t)(input[34] & 0x0f) << 28) |
			((uint32_t)input[35] << 20) |
			((uint32_t)(input[36] & 0xf0) << 12);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 292 to 307
	value = ((uint32_t)(input[36] & 0x0f) << 28) |
			((uint32_t)input[37] << 20) |
			((uint32_t)(input[38] & 0xf0) << 12);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 308 to 323
	value = ((uint32_t)(input[38] & 0x0f) << 28) |
			((uint32_t)input[39] << 20) |
			((uint32_t)(input[40] & 0xf0) << 12);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 324 to 339
	value = ((uint32_t)(input[40] & 0x0f) << 28) |
			((uint32_t)input[41] << 20) |
			((uint32_t)(input[42] & 0xf0) << 12);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 340 to 355
	value = ((uint32_t)(input[42] & 0x0f) << 28) |
			((uint32_t)input[43] << 20) |
			((uint32_t)(input[44] & 0xf0) << 12);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 356 to 371
	value = ((uint32_t)(input[44] & 0x0f) << 28) |
			((uint32_t)input[45] << 20) |
			((uint32_t)(input[46] & 0xf0) << 12);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 372 to 387
	value = ((uint32_t)(input[46] & 0x0f) << 28) |
			((uint32_t)input[47] << 20) |
			((uint32_t)(input[48] & 0xf0) << 12);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 388 to 403
	value = ((uint32_t)(input[48] & 0x0f) << 28) |
			((uint32_t)input[49] << 20) |
			((uint32_t)(input[50] & 0xf0) << 12);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 404 to 419
	value = ((uint32_t)(input[50] & 0x0f) << 28) |
			((uint32_t)input[51] << 20) |
			((uint32_t)(input[52] & 0xf0) << 12);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 420 to 435
	value = ((uint32_t)(input[52] & 0x0f) << 28) |
			((uint32_t)input[53] << 20) |
			((uint32_t)(input[54] & 0xf0) << 12);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 436 to 451
	value = ((uint32_t)(input[54] & 0x0f) << 28) |
			((uint32_t)input[55] << 20) |
			((uint32_t)(input[56] & 0xf0) << 12);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 452 to 467
	value = ((uint32_t)(input[56] & 0x0f) << 28) |
			((uint32_t)input[57] << 20) |
			((uint32_t)(input[58] & 0xf0) << 12);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 468 to 483
	value = ((uint32_t)(input[58] & 0x0f) << 28) |
			((uint32_t)input[59] << 20) |
			((uint32_t)(input[60] & 0xf0) << 12);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 484 to 499
	value = ((uint32_t)(input[60] & 0x0f) << 28) |
			((uint32_t)input[61] << 20) |
			((uint32_t)(input[62] & 0xf0) << 12);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 500 to 515
	value = ((uint32_t)(input[62] & 0x0f) << 28) |
			((uint32_t)input[63] << 20) |
			((uint32_t)(input[64] & 0xf0) << 12);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 516 to 531
	value = ((uint32_t)(input[64] & 0x0f) << 28) |
			((uint32_t)input[65] << 20) |
			((uint32_t)(input[66] & 0xf0) << 12);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 532 to 547
	value = ((uint32_t)(input[66] & 0x0f) << 28) |
			((uint32_t)input[67] << 20) |
			((uint32_t)(input[68] & 0xf0) << 12);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 548 to 563
	value = ((uint32_t)(input[68] & 0x0f) << 28) |
			((uint32_t)input[69] << 20) |
			((uint32_t)(input[70] & 0xf0) << 12);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 564 to 579
	value = ((uint32_t)(input[70] & 0x0f) << 28) |
			((uint32_t)input[71] << 20) |
			((uint32_t)(input[72] & 0xf0) << 12);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 580 to 595
	value = ((uint32_t)(input[72] & 0x0f) << 28) |
			((uint32_t)input[73] << 20) |
			((uint32_t)(input[74] & 0xf0) << 12);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 596 to 611
	value = ((uint32_t)(input[74] & 0x0f) << 28) |
			((uint32_t)input[75] << 20) |
			((uint32_t)(input[76] & 0xf0) << 12);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 612 to 627
	value = ((uint32_t)(input[76] & 0x0f) << 28) |
			((uint32_t)input[77] << 20) |
			((uint32_t)(input[78] & 0xf0) << 12);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 628 to 643
	value = ((uint32_t)(input[78] & 0x0f) << 28) |
			((uint32_t)input[79] << 20) |
			((uint32_t)(input[80] & 0xf0) << 12);
	output[39] = (double)(value >> 16);

	// read output[40]: from bit 644 to 659
	value = ((uint32_t)(input[80] & 0x0f) << 28) |
			((uint32_t)input[81] << 20) |
			((uint32_t)(input[82] & 0xf0) << 12);
	output[40] = (double)(value >> 16);

	// read output[41]: from bit 660 to 675
	value = ((uint32_t)(input[82] & 0x0f) << 28) |
			((uint32_t)input[83] << 20) |
			((uint32_t)(input[84] & 0xf0) << 12);
	output[41] = (double)(value >> 16);

	// read output[42]: from bit 676 to 691
	value = ((uint32_t)(input[84] & 0x0f) << 28) |
			((uint32_t)input[85] << 20) |
			((uint32_t)(input[86] & 0xf0) << 12);
	output[42] = (double)(value >> 16);

	// read output[43]: from bit 692 to 707
	value = ((uint32_t)(input[86] & 0x0f) << 28) |
			((uint32_t)input[87] << 20) |
			((uint32_t)(input[88] & 0xf0) << 12);
	output[43] = (double)(value >> 16);

	// read output[44]: from bit 708 to 723
	value = ((uint32_t)(input[88] & 0x0f) << 28) |
			((uint32_t)input[89] << 20) |
			((uint32_t)(input[90] & 0xf0) << 12);
	output[44] = (double)(value >> 16);

	// read output[45]: from bit 724 to 739
	value = ((uint32_t)(input[90] & 0x0f) << 28) |
			((uint32_t)input[91] << 20) |
			((uint32_t)(input[92] & 0xf0) << 12);
	output[45] = (double)(value >> 16);

	// read output[46]: from bit 740 to 755
	value = ((uint32_t)(input[92] & 0x0f) << 28) |
			((uint32_t)input[93] << 20) |
			((uint32_t)(input[94] & 0xf0) << 12);
	output[46] = (double)(value >> 16);

	// read output[47]: from bit 756 to 771
	value = ((uint32_t)(input[94] & 0x0f) << 28) |
			((uint32_t)input[95] << 20) |
			((uint32_t)(input[96] & 0xf0) << 12);
	output[47] = (double)(value >> 16);
}

static void unpack_48_16bit_signed_5off(const uint8_t * input, double * output, void *closure) {
	// Unpack 48 values into output
	// Values are 16-bit signed
	// Skip 5 bits, read 768 bits of data.
	// Input must be at least 97 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 5 to 20
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)(input[2] & 0xf8) << 13);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 21 to 36
	value = ((uint32_t)(input[2] & 0x07) << 29) |
			((uint32_t)input[3] << 21) |
			((uint32_t)(input[4] & 0xf8) << 13);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 37 to 52
	value = ((uint32_t)(input[4] & 0x07) << 29) |
			((uint32_t)input[5] << 21) |
			((uint32_t)(input[6] & 0xf8) << 13);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 53 to 68
	value = ((uint32_t)(input[6] & 0x07) << 29) |
			((uint32_t)input[7] << 21) |
			((uint32_t)(input[8] & 0xf8) << 13);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 69 to 84
	value = ((uint32_t)(input[8] & 0x07) << 29) |
			((uint32_t)input[9] << 21) |
			((uint32_t)(input[10] & 0xf8) << 13);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 85 to 100
	value = ((uint32_t)(input[10] & 0x07) << 29) |
			((uint32_t)input[11] << 21) |
			((uint32_t)(input[12] & 0xf8) << 13);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 101 to 116
	value = ((uint32_t)(input[12] & 0x07) << 29) |
			((uint32_t)input[13] << 21) |
			((uint32_t)(input[14] & 0xf8) << 13);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 117 to 132
	value = ((uint32_t)(input[14] & 0x07) << 29) |
			((uint32_t)input[15] << 21) |
			((uint32_t)(input[16] & 0xf8) << 13);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 133 to 148
	value = ((uint32_t)(input[16] & 0x07) << 29) |
			((uint32_t)input[17] << 21) |
			((uint32_t)(input[18] & 0xf8) << 13);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 149 to 164
	value = ((uint32_t)(input[18] & 0x07) << 29) |
			((uint32_t)input[19] << 21) |
			((uint32_t)(input[20] & 0xf8) << 13);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 165 to 180
	value = ((uint32_t)(input[20] & 0x07) << 29) |
			((uint32_t)input[21] << 21) |
			((uint32_t)(input[22] & 0xf8) << 13);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 181 to 196
	value = ((uint32_t)(input[22] & 0x07) << 29) |
			((uint32_t)input[23] << 21) |
			((uint32_t)(input[24] & 0xf8) << 13);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 197 to 212
	value = ((uint32_t)(input[24] & 0x07) << 29) |
			((uint32_t)input[25] << 21) |
			((uint32_t)(input[26] & 0xf8) << 13);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 213 to 228
	value = ((uint32_t)(input[26] & 0x07) << 29) |
			((uint32_t)input[27] << 21) |
			((uint32_t)(input[28] & 0xf8) << 13);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 229 to 244
	value = ((uint32_t)(input[28] & 0x07) << 29) |
			((uint32_t)input[29] << 21) |
			((uint32_t)(input[30] & 0xf8) << 13);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 245 to 260
	value = ((uint32_t)(input[30] & 0x07) << 29) |
			((uint32_t)input[31] << 21) |
			((uint32_t)(input[32] & 0xf8) << 13);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 261 to 276
	value = ((uint32_t)(input[32] & 0x07) << 29) |
			((uint32_t)input[33] << 21) |
			((uint32_t)(input[34] & 0xf8) << 13);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 277 to 292
	value = ((uint32_t)(input[34] & 0x07) << 29) |
			((uint32_t)input[35] << 21) |
			((uint32_t)(input[36] & 0xf8) << 13);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 293 to 308
	value = ((uint32_t)(input[36] & 0x07) << 29) |
			((uint32_t)input[37] << 21) |
			((uint32_t)(input[38] & 0xf8) << 13);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 309 to 324
	value = ((uint32_t)(input[38] & 0x07) << 29) |
			((uint32_t)input[39] << 21) |
			((uint32_t)(input[40] & 0xf8) << 13);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 325 to 340
	value = ((uint32_t)(input[40] & 0x07) << 29) |
			((uint32_t)input[41] << 21) |
			((uint32_t)(input[42] & 0xf8) << 13);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 341 to 356
	value = ((uint32_t)(input[42] & 0x07) << 29) |
			((uint32_t)input[43] << 21) |
			((uint32_t)(input[44] & 0xf8) << 13);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 357 to 372
	value = ((uint32_t)(input[44] & 0x07) << 29) |
			((uint32_t)input[45] << 21) |
			((uint32_t)(input[46] & 0xf8) << 13);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 373 to 388
	value = ((uint32_t)(input[46] & 0x07) << 29) |
			((uint32_t)input[47] << 21) |
			((uint32_t)(input[48] & 0xf8) << 13);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 389 to 404
	value = ((uint32_t)(input[48] & 0x07) << 29) |
			((uint32_t)input[49] << 21) |
			((uint32_t)(input[50] & 0xf8) << 13);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 405 to 420
	value = ((uint32_t)(input[50] & 0x07) << 29) |
			((uint32_t)input[51] << 21) |
			((uint32_t)(input[52] & 0xf8) << 13);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 421 to 436
	value = ((uint32_t)(input[52] & 0x07) << 29) |
			((uint32_t)input[53] << 21) |
			((uint32_t)(input[54] & 0xf8) << 13);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 437 to 452
	value = ((uint32_t)(input[54] & 0x07) << 29) |
			((uint32_t)input[55] << 21) |
			((uint32_t)(input[56] & 0xf8) << 13);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 453 to 468
	value = ((uint32_t)(input[56] & 0x07) << 29) |
			((uint32_t)input[57] << 21) |
			((uint32_t)(input[58] & 0xf8) << 13);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 469 to 484
	value = ((uint32_t)(input[58] & 0x07) << 29) |
			((uint32_t)input[59] << 21) |
			((uint32_t)(input[60] & 0xf8) << 13);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 485 to 500
	value = ((uint32_t)(input[60] & 0x07) << 29) |
			((uint32_t)input[61] << 21) |
			((uint32_t)(input[62] & 0xf8) << 13);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 501 to 516
	value = ((uint32_t)(input[62] & 0x07) << 29) |
			((uint32_t)input[63] << 21) |
			((uint32_t)(input[64] & 0xf8) << 13);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 517 to 532
	value = ((uint32_t)(input[64] & 0x07) << 29) |
			((uint32_t)input[65] << 21) |
			((uint32_t)(input[66] & 0xf8) << 13);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 533 to 548
	value = ((uint32_t)(input[66] & 0x07) << 29) |
			((uint32_t)input[67] << 21) |
			((uint32_t)(input[68] & 0xf8) << 13);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 549 to 564
	value = ((uint32_t)(input[68] & 0x07) << 29) |
			((uint32_t)input[69] << 21) |
			((uint32_t)(input[70] & 0xf8) << 13);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 565 to 580
	value = ((uint32_t)(input[70] & 0x07) << 29) |
			((uint32_t)input[71] << 21) |
			((uint32_t)(input[72] & 0xf8) << 13);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 581 to 596
	value = ((uint32_t)(input[72] & 0x07) << 29) |
			((uint32_t)input[73] << 21) |
			((uint32_t)(input[74] & 0xf8) << 13);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 597 to 612
	value = ((uint32_t)(input[74] & 0x07) << 29) |
			((uint32_t)input[75] << 21) |
			((uint32_t)(input[76] & 0xf8) << 13);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 613 to 628
	value = ((uint32_t)(input[76] & 0x07) << 29) |
			((uint32_t)input[77] << 21) |
			((uint32_t)(input[78] & 0xf8) << 13);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 629 to 644
	value = ((uint32_t)(input[78] & 0x07) << 29) |
			((uint32_t)input[79] << 21) |
			((uint32_t)(input[80] & 0xf8) << 13);
	output[39] = (double)(value >> 16);

	// read output[40]: from bit 645 to 660
	value = ((uint32_t)(input[80] & 0x07) << 29) |
			((uint32_t)input[81] << 21) |
			((uint32_t)(input[82] & 0xf8) << 13);
	output[40] = (double)(value >> 16);

	// read output[41]: from bit 661 to 676
	value = ((uint32_t)(input[82] & 0x07) << 29) |
			((uint32_t)input[83] << 21) |
			((uint32_t)(input[84] & 0xf8) << 13);
	output[41] = (double)(value >> 16);

	// read output[42]: from bit 677 to 692
	value = ((uint32_t)(input[84] & 0x07) << 29) |
			((uint32_t)input[85] << 21) |
			((uint32_t)(input[86] & 0xf8) << 13);
	output[42] = (double)(value >> 16);

	// read output[43]: from bit 693 to 708
	value = ((uint32_t)(input[86] & 0x07) << 29) |
			((uint32_t)input[87] << 21) |
			((uint32_t)(input[88] & 0xf8) << 13);
	output[43] = (double)(value >> 16);

	// read output[44]: from bit 709 to 724
	value = ((uint32_t)(input[88] & 0x07) << 29) |
			((uint32_t)input[89] << 21) |
			((uint32_t)(input[90] & 0xf8) << 13);
	output[44] = (double)(value >> 16);

	// read output[45]: from bit 725 to 740
	value = ((uint32_t)(input[90] & 0x07) << 29) |
			((uint32_t)input[91] << 21) |
			((uint32_t)(input[92] & 0xf8) << 13);
	output[45] = (double)(value >> 16);

	// read output[46]: from bit 741 to 756
	value = ((uint32_t)(input[92] & 0x07) << 29) |
			((uint32_t)input[93] << 21) |
			((uint32_t)(input[94] & 0xf8) << 13);
	output[46] = (double)(value >> 16);

	// read output[47]: from bit 757 to 772
	value = ((uint32_t)(input[94] & 0x07) << 29) |
			((uint32_t)input[95] << 21) |
			((uint32_t)(input[96] & 0xf8) << 13);
	output[47] = (double)(value >> 16);
}

static void unpack_48_16bit_unsigned_5off(const uint8_t * input, double * output, void *closure) {
	// Unpack 48 values into output
	// Values are 16-bit unsigned
	// Skip 5 bits, read 768 bits of data.
	// Input must be at least 97 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 5 to 20
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)(input[2] & 0xf8) << 13);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 21 to 36
	value = ((uint32_t)(input[2] & 0x07) << 29) |
			((uint32_t)input[3] << 21) |
			((uint32_t)(input[4] & 0xf8) << 13);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 37 to 52
	value = ((uint32_t)(input[4] & 0x07) << 29) |
			((uint32_t)input[5] << 21) |
			((uint32_t)(input[6] & 0xf8) << 13);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 53 to 68
	value = ((uint32_t)(input[6] & 0x07) << 29) |
			((uint32_t)input[7] << 21) |
			((uint32_t)(input[8] & 0xf8) << 13);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 69 to 84
	value = ((uint32_t)(input[8] & 0x07) << 29) |
			((uint32_t)input[9] << 21) |
			((uint32_t)(input[10] & 0xf8) << 13);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 85 to 100
	value = ((uint32_t)(input[10] & 0x07) << 29) |
			((uint32_t)input[11] << 21) |
			((uint32_t)(input[12] & 0xf8) << 13);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 101 to 116
	value = ((uint32_t)(input[12] & 0x07) << 29) |
			((uint32_t)input[13] << 21) |
			((uint32_t)(input[14] & 0xf8) << 13);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 117 to 132
	value = ((uint32_t)(input[14] & 0x07) << 29) |
			((uint32_t)input[15] << 21) |
			((uint32_t)(input[16] & 0xf8) << 13);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 133 to 148
	value = ((uint32_t)(input[16] & 0x07) << 29) |
			((uint32_t)input[17] << 21) |
			((uint32_t)(input[18] & 0xf8) << 13);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 149 to 164
	value = ((uint32_t)(input[18] & 0x07) << 29) |
			((uint32_t)input[19] << 21) |
			((uint32_t)(input[20] & 0xf8) << 13);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 165 to 180
	value = ((uint32_t)(input[20] & 0x07) << 29) |
			((uint32_t)input[21] << 21) |
			((uint32_t)(input[22] & 0xf8) << 13);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 181 to 196
	value = ((uint32_t)(input[22] & 0x07) << 29) |
			((uint32_t)input[23] << 21) |
			((uint32_t)(input[24] & 0xf8) << 13);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 197 to 212
	value = ((uint32_t)(input[24] & 0x07) << 29) |
			((uint32_t)input[25] << 21) |
			((uint32_t)(input[26] & 0xf8) << 13);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 213 to 228
	value = ((uint32_t)(input[26] & 0x07) << 29) |
			((uint32_t)input[27] << 21) |
			((uint32_t)(input[28] & 0xf8) << 13);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 229 to 244
	value = ((uint32_t)(input[28] & 0x07) << 29) |
			((uint32_t)input[29] << 21) |
			((uint32_t)(input[30] & 0xf8) << 13);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 245 to 260
	value = ((uint32_t)(input[30] & 0x07) << 29) |
			((uint32_t)input[31] << 21) |
			((uint32_t)(input[32] & 0xf8) << 13);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 261 to 276
	value = ((uint32_t)(input[32] & 0x07) << 29) |
			((uint32_t)input[33] << 21) |
			((uint32_t)(input[34] & 0xf8) << 13);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 277 to 292
	value = ((uint32_t)(input[34] & 0x07) << 29) |
			((uint32_t)input[35] << 21) |
			((uint32_t)(input[36] & 0xf8) << 13);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 293 to 308
	value = ((uint32_t)(input[36] & 0x07) << 29) |
			((uint32_t)input[37] << 21) |
			((uint32_t)(input[38] & 0xf8) << 13);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 309 to 324
	value = ((uint32_t)(input[38] & 0x07) << 29) |
			((uint32_t)input[39] << 21) |
			((uint32_t)(input[40] & 0xf8) << 13);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 325 to 340
	value = ((uint32_t)(input[40] & 0x07) << 29) |
			((uint32_t)input[41] << 21) |
			((uint32_t)(input[42] & 0xf8) << 13);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 341 to 356
	value = ((uint32_t)(input[42] & 0x07) << 29) |
			((uint32_t)input[43] << 21) |
			((uint32_t)(input[44] & 0xf8) << 13);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 357 to 372
	value = ((uint32_t)(input[44] & 0x07) << 29) |
			((uint32_t)input[45] << 21) |
			((uint32_t)(input[46] & 0xf8) << 13);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 373 to 388
	value = ((uint32_t)(input[46] & 0x07) << 29) |
			((uint32_t)input[47] << 21) |
			((uint32_t)(input[48] & 0xf8) << 13);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 389 to 404
	value = ((uint32_t)(input[48] & 0x07) << 29) |
			((uint32_t)input[49] << 21) |
			((uint32_t)(input[50] & 0xf8) << 13);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 405 to 420
	value = ((uint32_t)(input[50] & 0x07) << 29) |
			((uint32_t)input[51] << 21) |
			((uint32_t)(input[52] & 0xf8) << 13);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 421 to 436
	value = ((uint32_t)(input[52] & 0x07) << 29) |
			((uint32_t)input[53] << 21) |
			((uint32_t)(input[54] & 0xf8) << 13);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 437 to 452
	value = ((uint32_t)(input[54] & 0x07) << 29) |
			((uint32_t)input[55] << 21) |
			((uint32_t)(input[56] & 0xf8) << 13);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 453 to 468
	value = ((uint32_t)(input[56] & 0x07) << 29) |
			((uint32_t)input[57] << 21) |
			((uint32_t)(input[58] & 0xf8) << 13);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 469 to 484
	value = ((uint32_t)(input[58] & 0x07) << 29) |
			((uint32_t)input[59] << 21) |
			((uint32_t)(input[60] & 0xf8) << 13);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 485 to 500
	value = ((uint32_t)(input[60] & 0x07) << 29) |
			((uint32_t)input[61] << 21) |
			((uint32_t)(input[62] & 0xf8) << 13);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 501 to 516
	value = ((uint32_t)(input[62] & 0x07) << 29) |
			((uint32_t)input[63] << 21) |
			((uint32_t)(input[64] & 0xf8) << 13);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 517 to 532
	value = ((uint32_t)(input[64] & 0x07) << 29) |
			((uint32_t)input[65] << 21) |
			((uint32_t)(input[66] & 0xf8) << 13);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 533 to 548
	value = ((uint32_t)(input[66] & 0x07) << 29) |
			((uint32_t)input[67] << 21) |
			((uint32_t)(input[68] & 0xf8) << 13);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 549 to 564
	value = ((uint32_t)(input[68] & 0x07) << 29) |
			((uint32_t)input[69] << 21) |
			((uint32_t)(input[70] & 0xf8) << 13);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 565 to 580
	value = ((uint32_t)(input[70] & 0x07) << 29) |
			((uint32_t)input[71] << 21) |
			((uint32_t)(input[72] & 0xf8) << 13);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 581 to 596
	value = ((uint32_t)(input[72] & 0x07) << 29) |
			((uint32_t)input[73] << 21) |
			((uint32_t)(input[74] & 0xf8) << 13);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 597 to 612
	value = ((uint32_t)(input[74] & 0x07) << 29) |
			((uint32_t)input[75] << 21) |
			((uint32_t)(input[76] & 0xf8) << 13);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 613 to 628
	value = ((uint32_t)(input[76] & 0x07) << 29) |
			((uint32_t)input[77] << 21) |
			((uint32_t)(input[78] & 0xf8) << 13);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 629 to 644
	value = ((uint32_t)(input[78] & 0x07) << 29) |
			((uint32_t)input[79] << 21) |
			((uint32_t)(input[80] & 0xf8) << 13);
	output[39] = (double)(value >> 16);

	// read output[40]: from bit 645 to 660
	value = ((uint32_t)(input[80] & 0x07) << 29) |
			((uint32_t)input[81] << 21) |
			((uint32_t)(input[82] & 0xf8) << 13);
	output[40] = (double)(value >> 16);

	// read output[41]: from bit 661 to 676
	value = ((uint32_t)(input[82] & 0x07) << 29) |
			((uint32_t)input[83] << 21) |
			((uint32_t)(input[84] & 0xf8) << 13);
	output[41] = (double)(value >> 16);

	// read output[42]: from bit 677 to 692
	value = ((uint32_t)(input[84] & 0x07) << 29) |
			((uint32_t)input[85] << 21) |
			((uint32_t)(input[86] & 0xf8) << 13);
	output[42] = (double)(value >> 16);

	// read output[43]: from bit 693 to 708
	value = ((uint32_t)(input[86] & 0x07) << 29) |
			((uint32_t)input[87] << 21) |
			((uint32_t)(input[88] & 0xf8) << 13);
	output[43] = (double)(value >> 16);

	// read output[44]: from bit 709 to 724
	value = ((uint32_t)(input[88] & 0x07) << 29) |
			((uint32_t)input[89] << 21) |
			((uint32_t)(input[90] & 0xf8) << 13);
	output[44] = (double)(value >> 16);

	// read output[45]: from bit 725 to 740
	value = ((uint32_t)(input[90] & 0x07) << 29) |
			((uint32_t)input[91] << 21) |
			((uint32_t)(input[92] & 0xf8) << 13);
	output[45] = (double)(value >> 16);

	// read output[46]: from bit 741 to 756
	value = ((uint32_t)(input[92] & 0x07) << 29) |
			((uint32_t)input[93] << 21) |
			((uint32_t)(input[94] & 0xf8) << 13);
	output[46] = (double)(value >> 16);

	// read output[47]: from bit 757 to 772
	value = ((uint32_t)(input[94] & 0x07) << 29) |
			((uint32_t)input[95] << 21) |
			((uint32_t)(input[96] & 0xf8) << 13);
	output[47] = (double)(value >> 16);
}

static void unpack_48_16bit_signed_6off(const uint8_t * input, double * output, void *closure) {
	// Unpack 48 values into output
	// Values are 16-bit signed
	// Skip 6 bits, read 768 bits of data.
	// Input must be at least 97 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 6 to 21
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)(input[2] & 0xfc) << 14);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 22 to 37
	value = ((uint32_t)(input[2] & 0x03) << 30) |
			((uint32_t)input[3] << 22) |
			((uint32_t)(input[4] & 0xfc) << 14);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 38 to 53
	value = ((uint32_t)(input[4] & 0x03) << 30) |
			((uint32_t)input[5] << 22) |
			((uint32_t)(input[6] & 0xfc) << 14);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 54 to 69
	value = ((uint32_t)(input[6] & 0x03) << 30) |
			((uint32_t)input[7] << 22) |
			((uint32_t)(input[8] & 0xfc) << 14);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 70 to 85
	value = ((uint32_t)(input[8] & 0x03) << 30) |
			((uint32_t)input[9] << 22) |
			((uint32_t)(input[10] & 0xfc) << 14);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 86 to 101
	value = ((uint32_t)(input[10] & 0x03) << 30) |
			((uint32_t)input[11] << 22) |
			((uint32_t)(input[12] & 0xfc) << 14);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 102 to 117
	value = ((uint32_t)(input[12] & 0x03) << 30) |
			((uint32_t)input[13] << 22) |
			((uint32_t)(input[14] & 0xfc) << 14);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 118 to 133
	value = ((uint32_t)(input[14] & 0x03) << 30) |
			((uint32_t)input[15] << 22) |
			((uint32_t)(input[16] & 0xfc) << 14);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 134 to 149
	value = ((uint32_t)(input[16] & 0x03) << 30) |
			((uint32_t)input[17] << 22) |
			((uint32_t)(input[18] & 0xfc) << 14);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 150 to 165
	value = ((uint32_t)(input[18] & 0x03) << 30) |
			((uint32_t)input[19] << 22) |
			((uint32_t)(input[20] & 0xfc) << 14);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 166 to 181
	value = ((uint32_t)(input[20] & 0x03) << 30) |
			((uint32_t)input[21] << 22) |
			((uint32_t)(input[22] & 0xfc) << 14);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 182 to 197
	value = ((uint32_t)(input[22] & 0x03) << 30) |
			((uint32_t)input[23] << 22) |
			((uint32_t)(input[24] & 0xfc) << 14);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 198 to 213
	value = ((uint32_t)(input[24] & 0x03) << 30) |
			((uint32_t)input[25] << 22) |
			((uint32_t)(input[26] & 0xfc) << 14);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 214 to 229
	value = ((uint32_t)(input[26] & 0x03) << 30) |
			((uint32_t)input[27] << 22) |
			((uint32_t)(input[28] & 0xfc) << 14);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 230 to 245
	value = ((uint32_t)(input[28] & 0x03) << 30) |
			((uint32_t)input[29] << 22) |
			((uint32_t)(input[30] & 0xfc) << 14);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 246 to 261
	value = ((uint32_t)(input[30] & 0x03) << 30) |
			((uint32_t)input[31] << 22) |
			((uint32_t)(input[32] & 0xfc) << 14);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 262 to 277
	value = ((uint32_t)(input[32] & 0x03) << 30) |
			((uint32_t)input[33] << 22) |
			((uint32_t)(input[34] & 0xfc) << 14);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 278 to 293
	value = ((uint32_t)(input[34] & 0x03) << 30) |
			((uint32_t)input[35] << 22) |
			((uint32_t)(input[36] & 0xfc) << 14);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 294 to 309
	value = ((uint32_t)(input[36] & 0x03) << 30) |
			((uint32_t)input[37] << 22) |
			((uint32_t)(input[38] & 0xfc) << 14);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 310 to 325
	value = ((uint32_t)(input[38] & 0x03) << 30) |
			((uint32_t)input[39] << 22) |
			((uint32_t)(input[40] & 0xfc) << 14);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 326 to 341
	value = ((uint32_t)(input[40] & 0x03) << 30) |
			((uint32_t)input[41] << 22) |
			((uint32_t)(input[42] & 0xfc) << 14);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 342 to 357
	value = ((uint32_t)(input[42] & 0x03) << 30) |
			((uint32_t)input[43] << 22) |
			((uint32_t)(input[44] & 0xfc) << 14);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 358 to 373
	value = ((uint32_t)(input[44] & 0x03) << 30) |
			((uint32_t)input[45] << 22) |
			((uint32_t)(input[46] & 0xfc) << 14);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 374 to 389
	value = ((uint32_t)(input[46] & 0x03) << 30) |
			((uint32_t)input[47] << 22) |
			((uint32_t)(input[48] & 0xfc) << 14);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 390 to 405
	value = ((uint32_t)(input[48] & 0x03) << 30) |
			((uint32_t)input[49] << 22) |
			((uint32_t)(input[50] & 0xfc) << 14);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 406 to 421
	value = ((uint32_t)(input[50] & 0x03) << 30) |
			((uint32_t)input[51] << 22) |
			((uint32_t)(input[52] & 0xfc) << 14);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 422 to 437
	value = ((uint32_t)(input[52] & 0x03) << 30) |
			((uint32_t)input[53] << 22) |
			((uint32_t)(input[54] & 0xfc) << 14);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 438 to 453
	value = ((uint32_t)(input[54] & 0x03) << 30) |
			((uint32_t)input[55] << 22) |
			((uint32_t)(input[56] & 0xfc) << 14);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 454 to 469
	value = ((uint32_t)(input[56] & 0x03) << 30) |
			((uint32_t)input[57] << 22) |
			((uint32_t)(input[58] & 0xfc) << 14);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 470 to 485
	value = ((uint32_t)(input[58] & 0x03) << 30) |
			((uint32_t)input[59] << 22) |
			((uint32_t)(input[60] & 0xfc) << 14);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 486 to 501
	value = ((uint32_t)(input[60] & 0x03) << 30) |
			((uint32_t)input[61] << 22) |
			((uint32_t)(input[62] & 0xfc) << 14);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 502 to 517
	value = ((uint32_t)(input[62] & 0x03) << 30) |
			((uint32_t)input[63] << 22) |
			((uint32_t)(input[64] & 0xfc) << 14);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 518 to 533
	value = ((uint32_t)(input[64] & 0x03) << 30) |
			((uint32_t)input[65] << 22) |
			((uint32_t)(input[66] & 0xfc) << 14);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 534 to 549
	value = ((uint32_t)(input[66] & 0x03) << 30) |
			((uint32_t)input[67] << 22) |
			((uint32_t)(input[68] & 0xfc) << 14);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 550 to 565
	value = ((uint32_t)(input[68] & 0x03) << 30) |
			((uint32_t)input[69] << 22) |
			((uint32_t)(input[70] & 0xfc) << 14);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 566 to 581
	value = ((uint32_t)(input[70] & 0x03) << 30) |
			((uint32_t)input[71] << 22) |
			((uint32_t)(input[72] & 0xfc) << 14);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 582 to 597
	value = ((uint32_t)(input[72] & 0x03) << 30) |
			((uint32_t)input[73] << 22) |
			((uint32_t)(input[74] & 0xfc) << 14);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 598 to 613
	value = ((uint32_t)(input[74] & 0x03) << 30) |
			((uint32_t)input[75] << 22) |
			((uint32_t)(input[76] & 0xfc) << 14);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 614 to 629
	value = ((uint32_t)(input[76] & 0x03) << 30) |
			((uint32_t)input[77] << 22) |
			((uint32_t)(input[78] & 0xfc) << 14);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 630 to 645
	value = ((uint32_t)(input[78] & 0x03) << 30) |
			((uint32_t)input[79] << 22) |
			((uint32_t)(input[80] & 0xfc) << 14);
	output[39] = (double)(value >> 16);

	// read output[40]: from bit 646 to 661
	value = ((uint32_t)(input[80] & 0x03) << 30) |
			((uint32_t)input[81] << 22) |
			((uint32_t)(input[82] & 0xfc) << 14);
	output[40] = (double)(value >> 16);

	// read output[41]: from bit 662 to 677
	value = ((uint32_t)(input[82] & 0x03) << 30) |
			((uint32_t)input[83] << 22) |
			((uint32_t)(input[84] & 0xfc) << 14);
	output[41] = (double)(value >> 16);

	// read output[42]: from bit 678 to 693
	value = ((uint32_t)(input[84] & 0x03) << 30) |
			((uint32_t)input[85] << 22) |
			((uint32_t)(input[86] & 0xfc) << 14);
	output[42] = (double)(value >> 16);

	// read output[43]: from bit 694 to 709
	value = ((uint32_t)(input[86] & 0x03) << 30) |
			((uint32_t)input[87] << 22) |
			((uint32_t)(input[88] & 0xfc) << 14);
	output[43] = (double)(value >> 16);

	// read output[44]: from bit 710 to 725
	value = ((uint32_t)(input[88] & 0x03) << 30) |
			((uint32_t)input[89] << 22) |
			((uint32_t)(input[90] & 0xfc) << 14);
	output[44] = (double)(value >> 16);

	// read output[45]: from bit 726 to 741
	value = ((uint32_t)(input[90] & 0x03) << 30) |
			((uint32_t)input[91] << 22) |
			((uint32_t)(input[92] & 0xfc) << 14);
	output[45] = (double)(value >> 16);

	// read output[46]: from bit 742 to 757
	value = ((uint32_t)(input[92] & 0x03) << 30) |
			((uint32_t)input[93] << 22) |
			((uint32_t)(input[94] & 0xfc) << 14);
	output[46] = (double)(value >> 16);

	// read output[47]: from bit 758 to 773
	value = ((uint32_t)(input[94] & 0x03) << 30) |
			((uint32_t)input[95] << 22) |
			((uint32_t)(input[96] & 0xfc) << 14);
	output[47] = (double)(value >> 16);
}

static void unpack_48_16bit_unsigned_6off(const uint8_t * input, double * output, void *closure) {
	// Unpack 48 values into output
	// Values are 16-bit unsigned
	// Skip 6 bits, read 768 bits of data.
	// Input must be at least 97 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 6 to 21
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)(input[2] & 0xfc) << 14);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 22 to 37
	value = ((uint32_t)(input[2] & 0x03) << 30) |
			((uint32_t)input[3] << 22) |
			((uint32_t)(input[4] & 0xfc) << 14);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 38 to 53
	value = ((uint32_t)(input[4] & 0x03) << 30) |
			((uint32_t)input[5] << 22) |
			((uint32_t)(input[6] & 0xfc) << 14);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 54 to 69
	value = ((uint32_t)(input[6] & 0x03) << 30) |
			((uint32_t)input[7] << 22) |
			((uint32_t)(input[8] & 0xfc) << 14);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 70 to 85
	value = ((uint32_t)(input[8] & 0x03) << 30) |
			((uint32_t)input[9] << 22) |
			((uint32_t)(input[10] & 0xfc) << 14);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 86 to 101
	value = ((uint32_t)(input[10] & 0x03) << 30) |
			((uint32_t)input[11] << 22) |
			((uint32_t)(input[12] & 0xfc) << 14);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 102 to 117
	value = ((uint32_t)(input[12] & 0x03) << 30) |
			((uint32_t)input[13] << 22) |
			((uint32_t)(input[14] & 0xfc) << 14);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 118 to 133
	value = ((uint32_t)(input[14] & 0x03) << 30) |
			((uint32_t)input[15] << 22) |
			((uint32_t)(input[16] & 0xfc) << 14);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 134 to 149
	value = ((uint32_t)(input[16] & 0x03) << 30) |
			((uint32_t)input[17] << 22) |
			((uint32_t)(input[18] & 0xfc) << 14);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 150 to 165
	value = ((uint32_t)(input[18] & 0x03) << 30) |
			((uint32_t)input[19] << 22) |
			((uint32_t)(input[20] & 0xfc) << 14);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 166 to 181
	value = ((uint32_t)(input[20] & 0x03) << 30) |
			((uint32_t)input[21] << 22) |
			((uint32_t)(input[22] & 0xfc) << 14);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 182 to 197
	value = ((uint32_t)(input[22] & 0x03) << 30) |
			((uint32_t)input[23] << 22) |
			((uint32_t)(input[24] & 0xfc) << 14);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 198 to 213
	value = ((uint32_t)(input[24] & 0x03) << 30) |
			((uint32_t)input[25] << 22) |
			((uint32_t)(input[26] & 0xfc) << 14);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 214 to 229
	value = ((uint32_t)(input[26] & 0x03) << 30) |
			((uint32_t)input[27] << 22) |
			((uint32_t)(input[28] & 0xfc) << 14);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 230 to 245
	value = ((uint32_t)(input[28] & 0x03) << 30) |
			((uint32_t)input[29] << 22) |
			((uint32_t)(input[30] & 0xfc) << 14);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 246 to 261
	value = ((uint32_t)(input[30] & 0x03) << 30) |
			((uint32_t)input[31] << 22) |
			((uint32_t)(input[32] & 0xfc) << 14);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 262 to 277
	value = ((uint32_t)(input[32] & 0x03) << 30) |
			((uint32_t)input[33] << 22) |
			((uint32_t)(input[34] & 0xfc) << 14);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 278 to 293
	value = ((uint32_t)(input[34] & 0x03) << 30) |
			((uint32_t)input[35] << 22) |
			((uint32_t)(input[36] & 0xfc) << 14);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 294 to 309
	value = ((uint32_t)(input[36] & 0x03) << 30) |
			((uint32_t)input[37] << 22) |
			((uint32_t)(input[38] & 0xfc) << 14);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 310 to 325
	value = ((uint32_t)(input[38] & 0x03) << 30) |
			((uint32_t)input[39] << 22) |
			((uint32_t)(input[40] & 0xfc) << 14);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 326 to 341
	value = ((uint32_t)(input[40] & 0x03) << 30) |
			((uint32_t)input[41] << 22) |
			((uint32_t)(input[42] & 0xfc) << 14);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 342 to 357
	value = ((uint32_t)(input[42] & 0x03) << 30) |
			((uint32_t)input[43] << 22) |
			((uint32_t)(input[44] & 0xfc) << 14);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 358 to 373
	value = ((uint32_t)(input[44] & 0x03) << 30) |
			((uint32_t)input[45] << 22) |
			((uint32_t)(input[46] & 0xfc) << 14);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 374 to 389
	value = ((uint32_t)(input[46] & 0x03) << 30) |
			((uint32_t)input[47] << 22) |
			((uint32_t)(input[48] & 0xfc) << 14);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 390 to 405
	value = ((uint32_t)(input[48] & 0x03) << 30) |
			((uint32_t)input[49] << 22) |
			((uint32_t)(input[50] & 0xfc) << 14);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 406 to 421
	value = ((uint32_t)(input[50] & 0x03) << 30) |
			((uint32_t)input[51] << 22) |
			((uint32_t)(input[52] & 0xfc) << 14);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 422 to 437
	value = ((uint32_t)(input[52] & 0x03) << 30) |
			((uint32_t)input[53] << 22) |
			((uint32_t)(input[54] & 0xfc) << 14);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 438 to 453
	value = ((uint32_t)(input[54] & 0x03) << 30) |
			((uint32_t)input[55] << 22) |
			((uint32_t)(input[56] & 0xfc) << 14);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 454 to 469
	value = ((uint32_t)(input[56] & 0x03) << 30) |
			((uint32_t)input[57] << 22) |
			((uint32_t)(input[58] & 0xfc) << 14);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 470 to 485
	value = ((uint32_t)(input[58] & 0x03) << 30) |
			((uint32_t)input[59] << 22) |
			((uint32_t)(input[60] & 0xfc) << 14);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 486 to 501
	value = ((uint32_t)(input[60] & 0x03) << 30) |
			((uint32_t)input[61] << 22) |
			((uint32_t)(input[62] & 0xfc) << 14);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 502 to 517
	value = ((uint32_t)(input[62] & 0x03) << 30) |
			((uint32_t)input[63] << 22) |
			((uint32_t)(input[64] & 0xfc) << 14);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 518 to 533
	value = ((uint32_t)(input[64] & 0x03) << 30) |
			((uint32_t)input[65] << 22) |
			((uint32_t)(input[66] & 0xfc) << 14);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 534 to 549
	value = ((uint32_t)(input[66] & 0x03) << 30) |
			((uint32_t)input[67] << 22) |
			((uint32_t)(input[68] & 0xfc) << 14);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 550 to 565
	value = ((uint32_t)(input[68] & 0x03) << 30) |
			((uint32_t)input[69] << 22) |
			((uint32_t)(input[70] & 0xfc) << 14);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 566 to 581
	value = ((uint32_t)(input[70] & 0x03) << 30) |
			((uint32_t)input[71] << 22) |
			((uint32_t)(input[72] & 0xfc) << 14);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 582 to 597
	value = ((uint32_t)(input[72] & 0x03) << 30) |
			((uint32_t)input[73] << 22) |
			((uint32_t)(input[74] & 0xfc) << 14);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 598 to 613
	value = ((uint32_t)(input[74] & 0x03) << 30) |
			((uint32_t)input[75] << 22) |
			((uint32_t)(input[76] & 0xfc) << 14);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 614 to 629
	value = ((uint32_t)(input[76] & 0x03) << 30) |
			((uint32_t)input[77] << 22) |
			((uint32_t)(input[78] & 0xfc) << 14);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 630 to 645
	value = ((uint32_t)(input[78] & 0x03) << 30) |
			((uint32_t)input[79] << 22) |
			((uint32_t)(input[80] & 0xfc) << 14);
	output[39] = (double)(value >> 16);

	// read output[40]: from bit 646 to 661
	value = ((uint32_t)(input[80] & 0x03) << 30) |
			((uint32_t)input[81] << 22) |
			((uint32_t)(input[82] & 0xfc) << 14);
	output[40] = (double)(value >> 16);

	// read output[41]: from bit 662 to 677
	value = ((uint32_t)(input[82] & 0x03) << 30) |
			((uint32_t)input[83] << 22) |
			((uint32_t)(input[84] & 0xfc) << 14);
	output[41] = (double)(value >> 16);

	// read output[42]: from bit 678 to 693
	value = ((uint32_t)(input[84] & 0x03) << 30) |
			((uint32_t)input[85] << 22) |
			((uint32_t)(input[86] & 0xfc) << 14);
	output[42] = (double)(value >> 16);

	// read output[43]: from bit 694 to 709
	value = ((uint32_t)(input[86] & 0x03) << 30) |
			((uint32_t)input[87] << 22) |
			((uint32_t)(input[88] & 0xfc) << 14);
	output[43] = (double)(value >> 16);

	// read output[44]: from bit 710 to 725
	value = ((uint32_t)(input[88] & 0x03) << 30) |
			((uint32_t)input[89] << 22) |
			((uint32_t)(input[90] & 0xfc) << 14);
	output[44] = (double)(value >> 16);

	// read output[45]: from bit 726 to 741
	value = ((uint32_t)(input[90] & 0x03) << 30) |
			((uint32_t)input[91] << 22) |
			((uint32_t)(input[92] & 0xfc) << 14);
	output[45] = (double)(value >> 16);

	// read output[46]: from bit 742 to 757
	value = ((uint32_t)(input[92] & 0x03) << 30) |
			((uint32_t)input[93] << 22) |
			((uint32_t)(input[94] & 0xfc) << 14);
	output[46] = (double)(value >> 16);

	// read output[47]: from bit 758 to 773
	value = ((uint32_t)(input[94] & 0x03) << 30) |
			((uint32_t)input[95] << 22) |
			((uint32_t)(input[96] & 0xfc) << 14);
	output[47] = (double)(value >> 16);
}

static void unpack_48_16bit_signed_7off(const uint8_t * input, double * output, void *closure) {
	// Unpack 48 values into output
	// Values are 16-bit signed
	// Skip 7 bits, read 768 bits of data.
	// Input must be at least 97 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 7 to 22
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)(input[2] & 0xfe) << 15);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 23 to 38
	value = ((uint32_t)(input[2] & 0x01) << 31) |
			((uint32_t)input[3] << 23) |
			((uint32_t)(input[4] & 0xfe) << 15);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 39 to 54
	value = ((uint32_t)(input[4] & 0x01) << 31) |
			((uint32_t)input[5] << 23) |
			((uint32_t)(input[6] & 0xfe) << 15);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 55 to 70
	value = ((uint32_t)(input[6] & 0x01) << 31) |
			((uint32_t)input[7] << 23) |
			((uint32_t)(input[8] & 0xfe) << 15);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 71 to 86
	value = ((uint32_t)(input[8] & 0x01) << 31) |
			((uint32_t)input[9] << 23) |
			((uint32_t)(input[10] & 0xfe) << 15);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 87 to 102
	value = ((uint32_t)(input[10] & 0x01) << 31) |
			((uint32_t)input[11] << 23) |
			((uint32_t)(input[12] & 0xfe) << 15);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 103 to 118
	value = ((uint32_t)(input[12] & 0x01) << 31) |
			((uint32_t)input[13] << 23) |
			((uint32_t)(input[14] & 0xfe) << 15);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 119 to 134
	value = ((uint32_t)(input[14] & 0x01) << 31) |
			((uint32_t)input[15] << 23) |
			((uint32_t)(input[16] & 0xfe) << 15);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 135 to 150
	value = ((uint32_t)(input[16] & 0x01) << 31) |
			((uint32_t)input[17] << 23) |
			((uint32_t)(input[18] & 0xfe) << 15);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 151 to 166
	value = ((uint32_t)(input[18] & 0x01) << 31) |
			((uint32_t)input[19] << 23) |
			((uint32_t)(input[20] & 0xfe) << 15);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 167 to 182
	value = ((uint32_t)(input[20] & 0x01) << 31) |
			((uint32_t)input[21] << 23) |
			((uint32_t)(input[22] & 0xfe) << 15);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 183 to 198
	value = ((uint32_t)(input[22] & 0x01) << 31) |
			((uint32_t)input[23] << 23) |
			((uint32_t)(input[24] & 0xfe) << 15);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 199 to 214
	value = ((uint32_t)(input[24] & 0x01) << 31) |
			((uint32_t)input[25] << 23) |
			((uint32_t)(input[26] & 0xfe) << 15);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 215 to 230
	value = ((uint32_t)(input[26] & 0x01) << 31) |
			((uint32_t)input[27] << 23) |
			((uint32_t)(input[28] & 0xfe) << 15);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 231 to 246
	value = ((uint32_t)(input[28] & 0x01) << 31) |
			((uint32_t)input[29] << 23) |
			((uint32_t)(input[30] & 0xfe) << 15);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 247 to 262
	value = ((uint32_t)(input[30] & 0x01) << 31) |
			((uint32_t)input[31] << 23) |
			((uint32_t)(input[32] & 0xfe) << 15);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 263 to 278
	value = ((uint32_t)(input[32] & 0x01) << 31) |
			((uint32_t)input[33] << 23) |
			((uint32_t)(input[34] & 0xfe) << 15);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 279 to 294
	value = ((uint32_t)(input[34] & 0x01) << 31) |
			((uint32_t)input[35] << 23) |
			((uint32_t)(input[36] & 0xfe) << 15);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 295 to 310
	value = ((uint32_t)(input[36] & 0x01) << 31) |
			((uint32_t)input[37] << 23) |
			((uint32_t)(input[38] & 0xfe) << 15);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 311 to 326
	value = ((uint32_t)(input[38] & 0x01) << 31) |
			((uint32_t)input[39] << 23) |
			((uint32_t)(input[40] & 0xfe) << 15);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 327 to 342
	value = ((uint32_t)(input[40] & 0x01) << 31) |
			((uint32_t)input[41] << 23) |
			((uint32_t)(input[42] & 0xfe) << 15);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 343 to 358
	value = ((uint32_t)(input[42] & 0x01) << 31) |
			((uint32_t)input[43] << 23) |
			((uint32_t)(input[44] & 0xfe) << 15);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 359 to 374
	value = ((uint32_t)(input[44] & 0x01) << 31) |
			((uint32_t)input[45] << 23) |
			((uint32_t)(input[46] & 0xfe) << 15);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 375 to 390
	value = ((uint32_t)(input[46] & 0x01) << 31) |
			((uint32_t)input[47] << 23) |
			((uint32_t)(input[48] & 0xfe) << 15);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 391 to 406
	value = ((uint32_t)(input[48] & 0x01) << 31) |
			((uint32_t)input[49] << 23) |
			((uint32_t)(input[50] & 0xfe) << 15);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 407 to 422
	value = ((uint32_t)(input[50] & 0x01) << 31) |
			((uint32_t)input[51] << 23) |
			((uint32_t)(input[52] & 0xfe) << 15);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 423 to 438
	value = ((uint32_t)(input[52] & 0x01) << 31) |
			((uint32_t)input[53] << 23) |
			((uint32_t)(input[54] & 0xfe) << 15);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 439 to 454
	value = ((uint32_t)(input[54] & 0x01) << 31) |
			((uint32_t)input[55] << 23) |
			((uint32_t)(input[56] & 0xfe) << 15);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 455 to 470
	value = ((uint32_t)(input[56] & 0x01) << 31) |
			((uint32_t)input[57] << 23) |
			((uint32_t)(input[58] & 0xfe) << 15);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 471 to 486
	value = ((uint32_t)(input[58] & 0x01) << 31) |
			((uint32_t)input[59] << 23) |
			((uint32_t)(input[60] & 0xfe) << 15);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 487 to 502
	value = ((uint32_t)(input[60] & 0x01) << 31) |
			((uint32_t)input[61] << 23) |
			((uint32_t)(input[62] & 0xfe) << 15);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 503 to 518
	value = ((uint32_t)(input[62] & 0x01) << 31) |
			((uint32_t)input[63] << 23) |
			((uint32_t)(input[64] & 0xfe) << 15);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 519 to 534
	value = ((uint32_t)(input[64] & 0x01) << 31) |
			((uint32_t)input[65] << 23) |
			((uint32_t)(input[66] & 0xfe) << 15);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 535 to 550
	value = ((uint32_t)(input[66] & 0x01) << 31) |
			((uint32_t)input[67] << 23) |
			((uint32_t)(input[68] & 0xfe) << 15);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 551 to 566
	value = ((uint32_t)(input[68] & 0x01) << 31) |
			((uint32_t)input[69] << 23) |
			((uint32_t)(input[70] & 0xfe) << 15);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 567 to 582
	value = ((uint32_t)(input[70] & 0x01) << 31) |
			((uint32_t)input[71] << 23) |
			((uint32_t)(input[72] & 0xfe) << 15);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 583 to 598
	value = ((uint32_t)(input[72] & 0x01) << 31) |
			((uint32_t)input[73] << 23) |
			((uint32_t)(input[74] & 0xfe) << 15);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 599 to 614
	value = ((uint32_t)(input[74] & 0x01) << 31) |
			((uint32_t)input[75] << 23) |
			((uint32_t)(input[76] & 0xfe) << 15);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 615 to 630
	value = ((uint32_t)(input[76] & 0x01) << 31) |
			((uint32_t)input[77] << 23) |
			((uint32_t)(input[78] & 0xfe) << 15);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 631 to 646
	value = ((uint32_t)(input[78] & 0x01) << 31) |
			((uint32_t)input[79] << 23) |
			((uint32_t)(input[80] & 0xfe) << 15);
	output[39] = (double)(value >> 16);

	// read output[40]: from bit 647 to 662
	value = ((uint32_t)(input[80] & 0x01) << 31) |
			((uint32_t)input[81] << 23) |
			((uint32_t)(input[82] & 0xfe) << 15);
	output[40] = (double)(value >> 16);

	// read output[41]: from bit 663 to 678
	value = ((uint32_t)(input[82] & 0x01) << 31) |
			((uint32_t)input[83] << 23) |
			((uint32_t)(input[84] & 0xfe) << 15);
	output[41] = (double)(value >> 16);

	// read output[42]: from bit 679 to 694
	value = ((uint32_t)(input[84] & 0x01) << 31) |
			((uint32_t)input[85] << 23) |
			((uint32_t)(input[86] & 0xfe) << 15);
	output[42] = (double)(value >> 16);

	// read output[43]: from bit 695 to 710
	value = ((uint32_t)(input[86] & 0x01) << 31) |
			((uint32_t)input[87] << 23) |
			((uint32_t)(input[88] & 0xfe) << 15);
	output[43] = (double)(value >> 16);

	// read output[44]: from bit 711 to 726
	value = ((uint32_t)(input[88] & 0x01) << 31) |
			((uint32_t)input[89] << 23) |
			((uint32_t)(input[90] & 0xfe) << 15);
	output[44] = (double)(value >> 16);

	// read output[45]: from bit 727 to 742
	value = ((uint32_t)(input[90] & 0x01) << 31) |
			((uint32_t)input[91] << 23) |
			((uint32_t)(input[92] & 0xfe) << 15);
	output[45] = (double)(value >> 16);

	// read output[46]: from bit 743 to 758
	value = ((uint32_t)(input[92] & 0x01) << 31) |
			((uint32_t)input[93] << 23) |
			((uint32_t)(input[94] & 0xfe) << 15);
	output[46] = (double)(value >> 16);

	// read output[47]: from bit 759 to 774
	value = ((uint32_t)(input[94] & 0x01) << 31) |
			((uint32_t)input[95] << 23) |
			((uint32_t)(input[96] & 0xfe) << 15);
	output[47] = (double)(value >> 16);
}

static void unpack_48_16bit_unsigned_7off(const uint8_t * input, double * output, void *closure) {
	// Unpack 48 values into output
	// Values are 16-bit unsigned
	// Skip 7 bits, read 768 bits of data.
	// Input must be at least 97 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 7 to 22
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)(input[2] & 0xfe) << 15);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 23 to 38
	value = ((uint32_t)(input[2] & 0x01) << 31) |
			((uint32_t)input[3] << 23) |
			((uint32_t)(input[4] & 0xfe) << 15);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 39 to 54
	value = ((uint32_t)(input[4] & 0x01) << 31) |
			((uint32_t)input[5] << 23) |
			((uint32_t)(input[6] & 0xfe) << 15);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 55 to 70
	value = ((uint32_t)(input[6] & 0x01) << 31) |
			((uint32_t)input[7] << 23) |
			((uint32_t)(input[8] & 0xfe) << 15);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 71 to 86
	value = ((uint32_t)(input[8] & 0x01) << 31) |
			((uint32_t)input[9] << 23) |
			((uint32_t)(input[10] & 0xfe) << 15);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 87 to 102
	value = ((uint32_t)(input[10] & 0x01) << 31) |
			((uint32_t)input[11] << 23) |
			((uint32_t)(input[12] & 0xfe) << 15);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 103 to 118
	value = ((uint32_t)(input[12] & 0x01) << 31) |
			((uint32_t)input[13] << 23) |
			((uint32_t)(input[14] & 0xfe) << 15);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 119 to 134
	value = ((uint32_t)(input[14] & 0x01) << 31) |
			((uint32_t)input[15] << 23) |
			((uint32_t)(input[16] & 0xfe) << 15);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 135 to 150
	value = ((uint32_t)(input[16] & 0x01) << 31) |
			((uint32_t)input[17] << 23) |
			((uint32_t)(input[18] & 0xfe) << 15);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 151 to 166
	value = ((uint32_t)(input[18] & 0x01) << 31) |
			((uint32_t)input[19] << 23) |
			((uint32_t)(input[20] & 0xfe) << 15);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 167 to 182
	value = ((uint32_t)(input[20] & 0x01) << 31) |
			((uint32_t)input[21] << 23) |
			((uint32_t)(input[22] & 0xfe) << 15);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 183 to 198
	value = ((uint32_t)(input[22] & 0x01) << 31) |
			((uint32_t)input[23] << 23) |
			((uint32_t)(input[24] & 0xfe) << 15);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 199 to 214
	value = ((uint32_t)(input[24] & 0x01) << 31) |
			((uint32_t)input[25] << 23) |
			((uint32_t)(input[26] & 0xfe) << 15);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 215 to 230
	value = ((uint32_t)(input[26] & 0x01) << 31) |
			((uint32_t)input[27] << 23) |
			((uint32_t)(input[28] & 0xfe) << 15);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 231 to 246
	value = ((uint32_t)(input[28] & 0x01) << 31) |
			((uint32_t)input[29] << 23) |
			((uint32_t)(input[30] & 0xfe) << 15);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 247 to 262
	value = ((uint32_t)(input[30] & 0x01) << 31) |
			((uint32_t)input[31] << 23) |
			((uint32_t)(input[32] & 0xfe) << 15);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 263 to 278
	value = ((uint32_t)(input[32] & 0x01) << 31) |
			((uint32_t)input[33] << 23) |
			((uint32_t)(input[34] & 0xfe) << 15);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 279 to 294
	value = ((uint32_t)(input[34] & 0x01) << 31) |
			((uint32_t)input[35] << 23) |
			((uint32_t)(input[36] & 0xfe) << 15);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 295 to 310
	value = ((uint32_t)(input[36] & 0x01) << 31) |
			((uint32_t)input[37] << 23) |
			((uint32_t)(input[38] & 0xfe) << 15);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 311 to 326
	value = ((uint32_t)(input[38] & 0x01) << 31) |
			((uint32_t)input[39] << 23) |
			((uint32_t)(input[40] & 0xfe) << 15);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 327 to 342
	value = ((uint32_t)(input[40] & 0x01) << 31) |
			((uint32_t)input[41] << 23) |
			((uint32_t)(input[42] & 0xfe) << 15);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 343 to 358
	value = ((uint32_t)(input[42] & 0x01) << 31) |
			((uint32_t)input[43] << 23) |
			((uint32_t)(input[44] & 0xfe) << 15);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 359 to 374
	value = ((uint32_t)(input[44] & 0x01) << 31) |
			((uint32_t)input[45] << 23) |
			((uint32_t)(input[46] & 0xfe) << 15);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 375 to 390
	value = ((uint32_t)(input[46] & 0x01) << 31) |
			((uint32_t)input[47] << 23) |
			((uint32_t)(input[48] & 0xfe) << 15);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 391 to 406
	value = ((uint32_t)(input[48] & 0x01) << 31) |
			((uint32_t)input[49] << 23) |
			((uint32_t)(input[50] & 0xfe) << 15);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 407 to 422
	value = ((uint32_t)(input[50] & 0x01) << 31) |
			((uint32_t)input[51] << 23) |
			((uint32_t)(input[52] & 0xfe) << 15);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 423 to 438
	value = ((uint32_t)(input[52] & 0x01) << 31) |
			((uint32_t)input[53] << 23) |
			((uint32_t)(input[54] & 0xfe) << 15);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 439 to 454
	value = ((uint32_t)(input[54] & 0x01) << 31) |
			((uint32_t)input[55] << 23) |
			((uint32_t)(input[56] & 0xfe) << 15);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 455 to 470
	value = ((uint32_t)(input[56] & 0x01) << 31) |
			((uint32_t)input[57] << 23) |
			((uint32_t)(input[58] & 0xfe) << 15);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 471 to 486
	value = ((uint32_t)(input[58] & 0x01) << 31) |
			((uint32_t)input[59] << 23) |
			((uint32_t)(input[60] & 0xfe) << 15);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 487 to 502
	value = ((uint32_t)(input[60] & 0x01) << 31) |
			((uint32_t)input[61] << 23) |
			((uint32_t)(input[62] & 0xfe) << 15);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 503 to 518
	value = ((uint32_t)(input[62] & 0x01) << 31) |
			((uint32_t)input[63] << 23) |
			((uint32_t)(input[64] & 0xfe) << 15);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 519 to 534
	value = ((uint32_t)(input[64] & 0x01) << 31) |
			((uint32_t)input[65] << 23) |
			((uint32_t)(input[66] & 0xfe) << 15);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 535 to 550
	value = ((uint32_t)(input[66] & 0x01) << 31) |
			((uint32_t)input[67] << 23) |
			((uint32_t)(input[68] & 0xfe) << 15);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 551 to 566
	value = ((uint32_t)(input[68] & 0x01) << 31) |
			((uint32_t)input[69] << 23) |
			((uint32_t)(input[70] & 0xfe) << 15);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 567 to 582
	value = ((uint32_t)(input[70] & 0x01) << 31) |
			((uint32_t)input[71] << 23) |
			((uint32_t)(input[72] & 0xfe) << 15);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 583 to 598
	value = ((uint32_t)(input[72] & 0x01) << 31) |
			((uint32_t)input[73] << 23) |
			((uint32_t)(input[74] & 0xfe) << 15);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 599 to 614
	value = ((uint32_t)(input[74] & 0x01) << 31) |
			((uint32_t)input[75] << 23) |
			((uint32_t)(input[76] & 0xfe) << 15);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 615 to 630
	value = ((uint32_t)(input[76] & 0x01) << 31) |
			((uint32_t)input[77] << 23) |
			((uint32_t)(input[78] & 0xfe) << 15);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 631 to 646
	value = ((uint32_t)(input[78] & 0x01) << 31) |
			((uint32_t)input[79] << 23) |
			((uint32_t)(input[80] & 0xfe) << 15);
	output[39] = (double)(value >> 16);

	// read output[40]: from bit 647 to 662
	value = ((uint32_t)(input[80] & 0x01) << 31) |
			((uint32_t)input[81] << 23) |
			((uint32_t)(input[82] & 0xfe) << 15);
	output[40] = (double)(value >> 16);

	// read output[41]: from bit 663 to 678
	value = ((uint32_t)(input[82] & 0x01) << 31) |
			((uint32_t)input[83] << 23) |
			((uint32_t)(input[84] & 0xfe) << 15);
	output[41] = (double)(value >> 16);

	// read output[42]: from bit 679 to 694
	value = ((uint32_t)(input[84] & 0x01) << 31) |
			((uint32_t)input[85] << 23) |
			((uint32_t)(input[86] & 0xfe) << 15);
	output[42] = (double)(value >> 16);

	// read output[43]: from bit 695 to 710
	value = ((uint32_t)(input[86] & 0x01) << 31) |
			((uint32_t)input[87] << 23) |
			((uint32_t)(input[88] & 0xfe) << 15);
	output[43] = (double)(value >> 16);

	// read output[44]: from bit 711 to 726
	value = ((uint32_t)(input[88] & 0x01) << 31) |
			((uint32_t)input[89] << 23) |
			((uint32_t)(input[90] & 0xfe) << 15);
	output[44] = (double)(value >> 16);

	// read output[45]: from bit 727 to 742
	value = ((uint32_t)(input[90] & 0x01) << 31) |
			((uint32_t)input[91] << 23) |
			((uint32_t)(input[92] & 0xfe) << 15);
	output[45] = (double)(value >> 16);

	// read output[46]: from bit 743 to 758
	value = ((uint32_t)(input[92] & 0x01) << 31) |
			((uint32_t)input[93] << 23) |
			((uint32_t)(input[94] & 0xfe) << 15);
	output[46] = (double)(value >> 16);

	// read output[47]: from bit 759 to 774
	value = ((uint32_t)(input[94] & 0x01) << 31) |
			((uint32_t)input[95] << 23) |
			((uint32_t)(input[96] & 0xfe) << 15);
	output[47] = (double)(value >> 16);
}

static void unpack_49_16bit_signed_0off(const uint8_t * input, double * output, void *closure) {
	// Unpack 49 values into output
	// Values are 16-bit signed
	// Skip 0 bits, read 784 bits of data.
	// Input must be at least 98 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 0 to 15
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)input[1] << 16);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 16 to 31
	value = ((uint32_t)input[2] << 24) |
			((uint32_t)input[3] << 16);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 32 to 47
	value = ((uint32_t)input[4] << 24) |
			((uint32_t)input[5] << 16);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 48 to 63
	value = ((uint32_t)input[6] << 24) |
			((uint32_t)input[7] << 16);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 64 to 79
	value = ((uint32_t)input[8] << 24) |
			((uint32_t)input[9] << 16);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 80 to 95
	value = ((uint32_t)input[10] << 24) |
			((uint32_t)input[11] << 16);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 96 to 111
	value = ((uint32_t)input[12] << 24) |
			((uint32_t)input[13] << 16);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 112 to 127
	value = ((uint32_t)input[14] << 24) |
			((uint32_t)input[15] << 16);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 128 to 143
	value = ((uint32_t)input[16] << 24) |
			((uint32_t)input[17] << 16);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 144 to 159
	value = ((uint32_t)input[18] << 24) |
			((uint32_t)input[19] << 16);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 160 to 175
	value = ((uint32_t)input[20] << 24) |
			((uint32_t)input[21] << 16);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 176 to 191
	value = ((uint32_t)input[22] << 24) |
			((uint32_t)input[23] << 16);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 192 to 207
	value = ((uint32_t)input[24] << 24) |
			((uint32_t)input[25] << 16);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 208 to 223
	value = ((uint32_t)input[26] << 24) |
			((uint32_t)input[27] << 16);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 224 to 239
	value = ((uint32_t)input[28] << 24) |
			((uint32_t)input[29] << 16);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 240 to 255
	value = ((uint32_t)input[30] << 24) |
			((uint32_t)input[31] << 16);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 256 to 271
	value = ((uint32_t)input[32] << 24) |
			((uint32_t)input[33] << 16);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 272 to 287
	value = ((uint32_t)input[34] << 24) |
			((uint32_t)input[35] << 16);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 288 to 303
	value = ((uint32_t)input[36] << 24) |
			((uint32_t)input[37] << 16);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 304 to 319
	value = ((uint32_t)input[38] << 24) |
			((uint32_t)input[39] << 16);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 320 to 335
	value = ((uint32_t)input[40] << 24) |
			((uint32_t)input[41] << 16);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 336 to 351
	value = ((uint32_t)input[42] << 24) |
			((uint32_t)input[43] << 16);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 352 to 367
	value = ((uint32_t)input[44] << 24) |
			((uint32_t)input[45] << 16);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 368 to 383
	value = ((uint32_t)input[46] << 24) |
			((uint32_t)input[47] << 16);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 384 to 399
	value = ((uint32_t)input[48] << 24) |
			((uint32_t)input[49] << 16);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 400 to 415
	value = ((uint32_t)input[50] << 24) |
			((uint32_t)input[51] << 16);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 416 to 431
	value = ((uint32_t)input[52] << 24) |
			((uint32_t)input[53] << 16);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 432 to 447
	value = ((uint32_t)input[54] << 24) |
			((uint32_t)input[55] << 16);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 448 to 463
	value = ((uint32_t)input[56] << 24) |
			((uint32_t)input[57] << 16);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 464 to 479
	value = ((uint32_t)input[58] << 24) |
			((uint32_t)input[59] << 16);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 480 to 495
	value = ((uint32_t)input[60] << 24) |
			((uint32_t)input[61] << 16);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 496 to 511
	value = ((uint32_t)input[62] << 24) |
			((uint32_t)input[63] << 16);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 512 to 527
	value = ((uint32_t)input[64] << 24) |
			((uint32_t)input[65] << 16);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 528 to 543
	value = ((uint32_t)input[66] << 24) |
			((uint32_t)input[67] << 16);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 544 to 559
	value = ((uint32_t)input[68] << 24) |
			((uint32_t)input[69] << 16);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 560 to 575
	value = ((uint32_t)input[70] << 24) |
			((uint32_t)input[71] << 16);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 576 to 591
	value = ((uint32_t)input[72] << 24) |
			((uint32_t)input[73] << 16);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 592 to 607
	value = ((uint32_t)input[74] << 24) |
			((uint32_t)input[75] << 16);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 608 to 623
	value = ((uint32_t)input[76] << 24) |
			((uint32_t)input[77] << 16);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 624 to 639
	value = ((uint32_t)input[78] << 24) |
			((uint32_t)input[79] << 16);
	output[39] = (double)(value >> 16);

	// read output[40]: from bit 640 to 655
	value = ((uint32_t)input[80] << 24) |
			((uint32_t)input[81] << 16);
	output[40] = (double)(value >> 16);

	// read output[41]: from bit 656 to 671
	value = ((uint32_t)input[82] << 24) |
			((uint32_t)input[83] << 16);
	output[41] = (double)(value >> 16);

	// read output[42]: from bit 672 to 687
	value = ((uint32_t)input[84] << 24) |
			((uint32_t)input[85] << 16);
	output[42] = (double)(value >> 16);

	// read output[43]: from bit 688 to 703
	value = ((uint32_t)input[86] << 24) |
			((uint32_t)input[87] << 16);
	output[43] = (double)(value >> 16);

	// read output[44]: from bit 704 to 719
	value = ((uint32_t)input[88] << 24) |
			((uint32_t)input[89] << 16);
	output[44] = (double)(value >> 16);

	// read output[45]: from bit 720 to 735
	value = ((uint32_t)input[90] << 24) |
			((uint32_t)input[91] << 16);
	output[45] = (double)(value >> 16);

	// read output[46]: from bit 736 to 751
	value = ((uint32_t)input[92] << 24) |
			((uint32_t)input[93] << 16);
	output[46] = (double)(value >> 16);

	// read output[47]: from bit 752 to 767
	value = ((uint32_t)input[94] << 24) |
			((uint32_t)input[95] << 16);
	output[47] = (double)(value >> 16);

	// read output[48]: from bit 768 to 783
	value = ((uint32_t)input[96] << 24) |
			((uint32_t)input[97] << 16);
	output[48] = (double)(value >> 16);
}

static void unpack_49_16bit_unsigned_0off(const uint8_t * input, double * output, void *closure) {
	// Unpack 49 values into output
	// Values are 16-bit unsigned
	// Skip 0 bits, read 784 bits of data.
	// Input must be at least 98 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 0 to 15
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)input[1] << 16);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 16 to 31
	value = ((uint32_t)input[2] << 24) |
			((uint32_t)input[3] << 16);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 32 to 47
	value = ((uint32_t)input[4] << 24) |
			((uint32_t)input[5] << 16);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 48 to 63
	value = ((uint32_t)input[6] << 24) |
			((uint32_t)input[7] << 16);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 64 to 79
	value = ((uint32_t)input[8] << 24) |
			((uint32_t)input[9] << 16);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 80 to 95
	value = ((uint32_t)input[10] << 24) |
			((uint32_t)input[11] << 16);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 96 to 111
	value = ((uint32_t)input[12] << 24) |
			((uint32_t)input[13] << 16);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 112 to 127
	value = ((uint32_t)input[14] << 24) |
			((uint32_t)input[15] << 16);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 128 to 143
	value = ((uint32_t)input[16] << 24) |
			((uint32_t)input[17] << 16);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 144 to 159
	value = ((uint32_t)input[18] << 24) |
			((uint32_t)input[19] << 16);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 160 to 175
	value = ((uint32_t)input[20] << 24) |
			((uint32_t)input[21] << 16);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 176 to 191
	value = ((uint32_t)input[22] << 24) |
			((uint32_t)input[23] << 16);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 192 to 207
	value = ((uint32_t)input[24] << 24) |
			((uint32_t)input[25] << 16);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 208 to 223
	value = ((uint32_t)input[26] << 24) |
			((uint32_t)input[27] << 16);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 224 to 239
	value = ((uint32_t)input[28] << 24) |
			((uint32_t)input[29] << 16);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 240 to 255
	value = ((uint32_t)input[30] << 24) |
			((uint32_t)input[31] << 16);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 256 to 271
	value = ((uint32_t)input[32] << 24) |
			((uint32_t)input[33] << 16);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 272 to 287
	value = ((uint32_t)input[34] << 24) |
			((uint32_t)input[35] << 16);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 288 to 303
	value = ((uint32_t)input[36] << 24) |
			((uint32_t)input[37] << 16);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 304 to 319
	value = ((uint32_t)input[38] << 24) |
			((uint32_t)input[39] << 16);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 320 to 335
	value = ((uint32_t)input[40] << 24) |
			((uint32_t)input[41] << 16);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 336 to 351
	value = ((uint32_t)input[42] << 24) |
			((uint32_t)input[43] << 16);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 352 to 367
	value = ((uint32_t)input[44] << 24) |
			((uint32_t)input[45] << 16);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 368 to 383
	value = ((uint32_t)input[46] << 24) |
			((uint32_t)input[47] << 16);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 384 to 399
	value = ((uint32_t)input[48] << 24) |
			((uint32_t)input[49] << 16);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 400 to 415
	value = ((uint32_t)input[50] << 24) |
			((uint32_t)input[51] << 16);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 416 to 431
	value = ((uint32_t)input[52] << 24) |
			((uint32_t)input[53] << 16);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 432 to 447
	value = ((uint32_t)input[54] << 24) |
			((uint32_t)input[55] << 16);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 448 to 463
	value = ((uint32_t)input[56] << 24) |
			((uint32_t)input[57] << 16);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 464 to 479
	value = ((uint32_t)input[58] << 24) |
			((uint32_t)input[59] << 16);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 480 to 495
	value = ((uint32_t)input[60] << 24) |
			((uint32_t)input[61] << 16);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 496 to 511
	value = ((uint32_t)input[62] << 24) |
			((uint32_t)input[63] << 16);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 512 to 527
	value = ((uint32_t)input[64] << 24) |
			((uint32_t)input[65] << 16);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 528 to 543
	value = ((uint32_t)input[66] << 24) |
			((uint32_t)input[67] << 16);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 544 to 559
	value = ((uint32_t)input[68] << 24) |
			((uint32_t)input[69] << 16);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 560 to 575
	value = ((uint32_t)input[70] << 24) |
			((uint32_t)input[71] << 16);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 576 to 591
	value = ((uint32_t)input[72] << 24) |
			((uint32_t)input[73] << 16);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 592 to 607
	value = ((uint32_t)input[74] << 24) |
			((uint32_t)input[75] << 16);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 608 to 623
	value = ((uint32_t)input[76] << 24) |
			((uint32_t)input[77] << 16);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 624 to 639
	value = ((uint32_t)input[78] << 24) |
			((uint32_t)input[79] << 16);
	output[39] = (double)(value >> 16);

	// read output[40]: from bit 640 to 655
	value = ((uint32_t)input[80] << 24) |
			((uint32_t)input[81] << 16);
	output[40] = (double)(value >> 16);

	// read output[41]: from bit 656 to 671
	value = ((uint32_t)input[82] << 24) |
			((uint32_t)input[83] << 16);
	output[41] = (double)(value >> 16);

	// read output[42]: from bit 672 to 687
	value = ((uint32_t)input[84] << 24) |
			((uint32_t)input[85] << 16);
	output[42] = (double)(value >> 16);

	// read output[43]: from bit 688 to 703
	value = ((uint32_t)input[86] << 24) |
			((uint32_t)input[87] << 16);
	output[43] = (double)(value >> 16);

	// read output[44]: from bit 704 to 719
	value = ((uint32_t)input[88] << 24) |
			((uint32_t)input[89] << 16);
	output[44] = (double)(value >> 16);

	// read output[45]: from bit 720 to 735
	value = ((uint32_t)input[90] << 24) |
			((uint32_t)input[91] << 16);
	output[45] = (double)(value >> 16);

	// read output[46]: from bit 736 to 751
	value = ((uint32_t)input[92] << 24) |
			((uint32_t)input[93] << 16);
	output[46] = (double)(value >> 16);

	// read output[47]: from bit 752 to 767
	value = ((uint32_t)input[94] << 24) |
			((uint32_t)input[95] << 16);
	output[47] = (double)(value >> 16);

	// read output[48]: from bit 768 to 783
	value = ((uint32_t)input[96] << 24) |
			((uint32_t)input[97] << 16);
	output[48] = (double)(value >> 16);
}

static void unpack_49_16bit_signed_1off(const uint8_t * input, double * output, void *closure) {
	// Unpack 49 values into output
	// Values are 16-bit signed
	// Skip 1 bits, read 784 bits of data.
	// Input must be at least 99 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 1 to 16
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)input[1] << 17) |
			((uint32_t)(input[2] & 0x80) << 9);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 17 to 32
	value = ((uint32_t)(input[2] & 0x7f) << 25) |
			((uint32_t)input[3] << 17) |
			((uint32_t)(input[4] & 0x80) << 9);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 33 to 48
	value = ((uint32_t)(input[4] & 0x7f) << 25) |
			((uint32_t)input[5] << 17) |
			((uint32_t)(input[6] & 0x80) << 9);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 49 to 64
	value = ((uint32_t)(input[6] & 0x7f) << 25) |
			((uint32_t)input[7] << 17) |
			((uint32_t)(input[8] & 0x80) << 9);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 65 to 80
	value = ((uint32_t)(input[8] & 0x7f) << 25) |
			((uint32_t)input[9] << 17) |
			((uint32_t)(input[10] & 0x80) << 9);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 81 to 96
	value = ((uint32_t)(input[10] & 0x7f) << 25) |
			((uint32_t)input[11] << 17) |
			((uint32_t)(input[12] & 0x80) << 9);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 97 to 112
	value = ((uint32_t)(input[12] & 0x7f) << 25) |
			((uint32_t)input[13] << 17) |
			((uint32_t)(input[14] & 0x80) << 9);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 113 to 128
	value = ((uint32_t)(input[14] & 0x7f) << 25) |
			((uint32_t)input[15] << 17) |
			((uint32_t)(input[16] & 0x80) << 9);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 129 to 144
	value = ((uint32_t)(input[16] & 0x7f) << 25) |
			((uint32_t)input[17] << 17) |
			((uint32_t)(input[18] & 0x80) << 9);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 145 to 160
	value = ((uint32_t)(input[18] & 0x7f) << 25) |
			((uint32_t)input[19] << 17) |
			((uint32_t)(input[20] & 0x80) << 9);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 161 to 176
	value = ((uint32_t)(input[20] & 0x7f) << 25) |
			((uint32_t)input[21] << 17) |
			((uint32_t)(input[22] & 0x80) << 9);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 177 to 192
	value = ((uint32_t)(input[22] & 0x7f) << 25) |
			((uint32_t)input[23] << 17) |
			((uint32_t)(input[24] & 0x80) << 9);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 193 to 208
	value = ((uint32_t)(input[24] & 0x7f) << 25) |
			((uint32_t)input[25] << 17) |
			((uint32_t)(input[26] & 0x80) << 9);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 209 to 224
	value = ((uint32_t)(input[26] & 0x7f) << 25) |
			((uint32_t)input[27] << 17) |
			((uint32_t)(input[28] & 0x80) << 9);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 225 to 240
	value = ((uint32_t)(input[28] & 0x7f) << 25) |
			((uint32_t)input[29] << 17) |
			((uint32_t)(input[30] & 0x80) << 9);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 241 to 256
	value = ((uint32_t)(input[30] & 0x7f) << 25) |
			((uint32_t)input[31] << 17) |
			((uint32_t)(input[32] & 0x80) << 9);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 257 to 272
	value = ((uint32_t)(input[32] & 0x7f) << 25) |
			((uint32_t)input[33] << 17) |
			((uint32_t)(input[34] & 0x80) << 9);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 273 to 288
	value = ((uint32_t)(input[34] & 0x7f) << 25) |
			((uint32_t)input[35] << 17) |
			((uint32_t)(input[36] & 0x80) << 9);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 289 to 304
	value = ((uint32_t)(input[36] & 0x7f) << 25) |
			((uint32_t)input[37] << 17) |
			((uint32_t)(input[38] & 0x80) << 9);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 305 to 320
	value = ((uint32_t)(input[38] & 0x7f) << 25) |
			((uint32_t)input[39] << 17) |
			((uint32_t)(input[40] & 0x80) << 9);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 321 to 336
	value = ((uint32_t)(input[40] & 0x7f) << 25) |
			((uint32_t)input[41] << 17) |
			((uint32_t)(input[42] & 0x80) << 9);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 337 to 352
	value = ((uint32_t)(input[42] & 0x7f) << 25) |
			((uint32_t)input[43] << 17) |
			((uint32_t)(input[44] & 0x80) << 9);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 353 to 368
	value = ((uint32_t)(input[44] & 0x7f) << 25) |
			((uint32_t)input[45] << 17) |
			((uint32_t)(input[46] & 0x80) << 9);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 369 to 384
	value = ((uint32_t)(input[46] & 0x7f) << 25) |
			((uint32_t)input[47] << 17) |
			((uint32_t)(input[48] & 0x80) << 9);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 385 to 400
	value = ((uint32_t)(input[48] & 0x7f) << 25) |
			((uint32_t)input[49] << 17) |
			((uint32_t)(input[50] & 0x80) << 9);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 401 to 416
	value = ((uint32_t)(input[50] & 0x7f) << 25) |
			((uint32_t)input[51] << 17) |
			((uint32_t)(input[52] & 0x80) << 9);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 417 to 432
	value = ((uint32_t)(input[52] & 0x7f) << 25) |
			((uint32_t)input[53] << 17) |
			((uint32_t)(input[54] & 0x80) << 9);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 433 to 448
	value = ((uint32_t)(input[54] & 0x7f) << 25) |
			((uint32_t)input[55] << 17) |
			((uint32_t)(input[56] & 0x80) << 9);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 449 to 464
	value = ((uint32_t)(input[56] & 0x7f) << 25) |
			((uint32_t)input[57] << 17) |
			((uint32_t)(input[58] & 0x80) << 9);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 465 to 480
	value = ((uint32_t)(input[58] & 0x7f) << 25) |
			((uint32_t)input[59] << 17) |
			((uint32_t)(input[60] & 0x80) << 9);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 481 to 496
	value = ((uint32_t)(input[60] & 0x7f) << 25) |
			((uint32_t)input[61] << 17) |
			((uint32_t)(input[62] & 0x80) << 9);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 497 to 512
	value = ((uint32_t)(input[62] & 0x7f) << 25) |
			((uint32_t)input[63] << 17) |
			((uint32_t)(input[64] & 0x80) << 9);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 513 to 528
	value = ((uint32_t)(input[64] & 0x7f) << 25) |
			((uint32_t)input[65] << 17) |
			((uint32_t)(input[66] & 0x80) << 9);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 529 to 544
	value = ((uint32_t)(input[66] & 0x7f) << 25) |
			((uint32_t)input[67] << 17) |
			((uint32_t)(input[68] & 0x80) << 9);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 545 to 560
	value = ((uint32_t)(input[68] & 0x7f) << 25) |
			((uint32_t)input[69] << 17) |
			((uint32_t)(input[70] & 0x80) << 9);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 561 to 576
	value = ((uint32_t)(input[70] & 0x7f) << 25) |
			((uint32_t)input[71] << 17) |
			((uint32_t)(input[72] & 0x80) << 9);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 577 to 592
	value = ((uint32_t)(input[72] & 0x7f) << 25) |
			((uint32_t)input[73] << 17) |
			((uint32_t)(input[74] & 0x80) << 9);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 593 to 608
	value = ((uint32_t)(input[74] & 0x7f) << 25) |
			((uint32_t)input[75] << 17) |
			((uint32_t)(input[76] & 0x80) << 9);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 609 to 624
	value = ((uint32_t)(input[76] & 0x7f) << 25) |
			((uint32_t)input[77] << 17) |
			((uint32_t)(input[78] & 0x80) << 9);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 625 to 640
	value = ((uint32_t)(input[78] & 0x7f) << 25) |
			((uint32_t)input[79] << 17) |
			((uint32_t)(input[80] & 0x80) << 9);
	output[39] = (double)(value >> 16);

	// read output[40]: from bit 641 to 656
	value = ((uint32_t)(input[80] & 0x7f) << 25) |
			((uint32_t)input[81] << 17) |
			((uint32_t)(input[82] & 0x80) << 9);
	output[40] = (double)(value >> 16);

	// read output[41]: from bit 657 to 672
	value = ((uint32_t)(input[82] & 0x7f) << 25) |
			((uint32_t)input[83] << 17) |
			((uint32_t)(input[84] & 0x80) << 9);
	output[41] = (double)(value >> 16);

	// read output[42]: from bit 673 to 688
	value = ((uint32_t)(input[84] & 0x7f) << 25) |
			((uint32_t)input[85] << 17) |
			((uint32_t)(input[86] & 0x80) << 9);
	output[42] = (double)(value >> 16);

	// read output[43]: from bit 689 to 704
	value = ((uint32_t)(input[86] & 0x7f) << 25) |
			((uint32_t)input[87] << 17) |
			((uint32_t)(input[88] & 0x80) << 9);
	output[43] = (double)(value >> 16);

	// read output[44]: from bit 705 to 720
	value = ((uint32_t)(input[88] & 0x7f) << 25) |
			((uint32_t)input[89] << 17) |
			((uint32_t)(input[90] & 0x80) << 9);
	output[44] = (double)(value >> 16);

	// read output[45]: from bit 721 to 736
	value = ((uint32_t)(input[90] & 0x7f) << 25) |
			((uint32_t)input[91] << 17) |
			((uint32_t)(input[92] & 0x80) << 9);
	output[45] = (double)(value >> 16);

	// read output[46]: from bit 737 to 752
	value = ((uint32_t)(input[92] & 0x7f) << 25) |
			((uint32_t)input[93] << 17) |
			((uint32_t)(input[94] & 0x80) << 9);
	output[46] = (double)(value >> 16);

	// read output[47]: from bit 753 to 768
	value = ((uint32_t)(input[94] & 0x7f) << 25) |
			((uint32_t)input[95] << 17) |
			((uint32_t)(input[96] & 0x80) << 9);
	output[47] = (double)(value >> 16);

	// read output[48]: from bit 769 to 784
	value = ((uint32_t)(input[96] & 0x7f) << 25) |
			((uint32_t)input[97] << 17) |
			((uint32_t)(input[98] & 0x80) << 9);
	output[48] = (double)(value >> 16);
}

static void unpack_49_16bit_unsigned_1off(const uint8_t * input, double * output, void *closure) {
	// Unpack 49 values into output
	// Values are 16-bit unsigned
	// Skip 1 bits, read 784 bits of data.
	// Input must be at least 99 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 1 to 16
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)input[1] << 17) |
			((uint32_t)(input[2] & 0x80) << 9);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 17 to 32
	value = ((uint32_t)(input[2] & 0x7f) << 25) |
			((uint32_t)input[3] << 17) |
			((uint32_t)(input[4] & 0x80) << 9);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 33 to 48
	value = ((uint32_t)(input[4] & 0x7f) << 25) |
			((uint32_t)input[5] << 17) |
			((uint32_t)(input[6] & 0x80) << 9);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 49 to 64
	value = ((uint32_t)(input[6] & 0x7f) << 25) |
			((uint32_t)input[7] << 17) |
			((uint32_t)(input[8] & 0x80) << 9);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 65 to 80
	value = ((uint32_t)(input[8] & 0x7f) << 25) |
			((uint32_t)input[9] << 17) |
			((uint32_t)(input[10] & 0x80) << 9);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 81 to 96
	value = ((uint32_t)(input[10] & 0x7f) << 25) |
			((uint32_t)input[11] << 17) |
			((uint32_t)(input[12] & 0x80) << 9);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 97 to 112
	value = ((uint32_t)(input[12] & 0x7f) << 25) |
			((uint32_t)input[13] << 17) |
			((uint32_t)(input[14] & 0x80) << 9);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 113 to 128
	value = ((uint32_t)(input[14] & 0x7f) << 25) |
			((uint32_t)input[15] << 17) |
			((uint32_t)(input[16] & 0x80) << 9);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 129 to 144
	value = ((uint32_t)(input[16] & 0x7f) << 25) |
			((uint32_t)input[17] << 17) |
			((uint32_t)(input[18] & 0x80) << 9);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 145 to 160
	value = ((uint32_t)(input[18] & 0x7f) << 25) |
			((uint32_t)input[19] << 17) |
			((uint32_t)(input[20] & 0x80) << 9);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 161 to 176
	value = ((uint32_t)(input[20] & 0x7f) << 25) |
			((uint32_t)input[21] << 17) |
			((uint32_t)(input[22] & 0x80) << 9);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 177 to 192
	value = ((uint32_t)(input[22] & 0x7f) << 25) |
			((uint32_t)input[23] << 17) |
			((uint32_t)(input[24] & 0x80) << 9);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 193 to 208
	value = ((uint32_t)(input[24] & 0x7f) << 25) |
			((uint32_t)input[25] << 17) |
			((uint32_t)(input[26] & 0x80) << 9);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 209 to 224
	value = ((uint32_t)(input[26] & 0x7f) << 25) |
			((uint32_t)input[27] << 17) |
			((uint32_t)(input[28] & 0x80) << 9);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 225 to 240
	value = ((uint32_t)(input[28] & 0x7f) << 25) |
			((uint32_t)input[29] << 17) |
			((uint32_t)(input[30] & 0x80) << 9);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 241 to 256
	value = ((uint32_t)(input[30] & 0x7f) << 25) |
			((uint32_t)input[31] << 17) |
			((uint32_t)(input[32] & 0x80) << 9);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 257 to 272
	value = ((uint32_t)(input[32] & 0x7f) << 25) |
			((uint32_t)input[33] << 17) |
			((uint32_t)(input[34] & 0x80) << 9);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 273 to 288
	value = ((uint32_t)(input[34] & 0x7f) << 25) |
			((uint32_t)input[35] << 17) |
			((uint32_t)(input[36] & 0x80) << 9);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 289 to 304
	value = ((uint32_t)(input[36] & 0x7f) << 25) |
			((uint32_t)input[37] << 17) |
			((uint32_t)(input[38] & 0x80) << 9);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 305 to 320
	value = ((uint32_t)(input[38] & 0x7f) << 25) |
			((uint32_t)input[39] << 17) |
			((uint32_t)(input[40] & 0x80) << 9);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 321 to 336
	value = ((uint32_t)(input[40] & 0x7f) << 25) |
			((uint32_t)input[41] << 17) |
			((uint32_t)(input[42] & 0x80) << 9);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 337 to 352
	value = ((uint32_t)(input[42] & 0x7f) << 25) |
			((uint32_t)input[43] << 17) |
			((uint32_t)(input[44] & 0x80) << 9);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 353 to 368
	value = ((uint32_t)(input[44] & 0x7f) << 25) |
			((uint32_t)input[45] << 17) |
			((uint32_t)(input[46] & 0x80) << 9);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 369 to 384
	value = ((uint32_t)(input[46] & 0x7f) << 25) |
			((uint32_t)input[47] << 17) |
			((uint32_t)(input[48] & 0x80) << 9);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 385 to 400
	value = ((uint32_t)(input[48] & 0x7f) << 25) |
			((uint32_t)input[49] << 17) |
			((uint32_t)(input[50] & 0x80) << 9);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 401 to 416
	value = ((uint32_t)(input[50] & 0x7f) << 25) |
			((uint32_t)input[51] << 17) |
			((uint32_t)(input[52] & 0x80) << 9);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 417 to 432
	value = ((uint32_t)(input[52] & 0x7f) << 25) |
			((uint32_t)input[53] << 17) |
			((uint32_t)(input[54] & 0x80) << 9);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 433 to 448
	value = ((uint32_t)(input[54] & 0x7f) << 25) |
			((uint32_t)input[55] << 17) |
			((uint32_t)(input[56] & 0x80) << 9);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 449 to 464
	value = ((uint32_t)(input[56] & 0x7f) << 25) |
			((uint32_t)input[57] << 17) |
			((uint32_t)(input[58] & 0x80) << 9);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 465 to 480
	value = ((uint32_t)(input[58] & 0x7f) << 25) |
			((uint32_t)input[59] << 17) |
			((uint32_t)(input[60] & 0x80) << 9);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 481 to 496
	value = ((uint32_t)(input[60] & 0x7f) << 25) |
			((uint32_t)input[61] << 17) |
			((uint32_t)(input[62] & 0x80) << 9);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 497 to 512
	value = ((uint32_t)(input[62] & 0x7f) << 25) |
			((uint32_t)input[63] << 17) |
			((uint32_t)(input[64] & 0x80) << 9);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 513 to 528
	value = ((uint32_t)(input[64] & 0x7f) << 25) |
			((uint32_t)input[65] << 17) |
			((uint32_t)(input[66] & 0x80) << 9);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 529 to 544
	value = ((uint32_t)(input[66] & 0x7f) << 25) |
			((uint32_t)input[67] << 17) |
			((uint32_t)(input[68] & 0x80) << 9);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 545 to 560
	value = ((uint32_t)(input[68] & 0x7f) << 25) |
			((uint32_t)input[69] << 17) |
			((uint32_t)(input[70] & 0x80) << 9);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 561 to 576
	value = ((uint32_t)(input[70] & 0x7f) << 25) |
			((uint32_t)input[71] << 17) |
			((uint32_t)(input[72] & 0x80) << 9);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 577 to 592
	value = ((uint32_t)(input[72] & 0x7f) << 25) |
			((uint32_t)input[73] << 17) |
			((uint32_t)(input[74] & 0x80) << 9);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 593 to 608
	value = ((uint32_t)(input[74] & 0x7f) << 25) |
			((uint32_t)input[75] << 17) |
			((uint32_t)(input[76] & 0x80) << 9);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 609 to 624
	value = ((uint32_t)(input[76] & 0x7f) << 25) |
			((uint32_t)input[77] << 17) |
			((uint32_t)(input[78] & 0x80) << 9);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 625 to 640
	value = ((uint32_t)(input[78] & 0x7f) << 25) |
			((uint32_t)input[79] << 17) |
			((uint32_t)(input[80] & 0x80) << 9);
	output[39] = (double)(value >> 16);

	// read output[40]: from bit 641 to 656
	value = ((uint32_t)(input[80] & 0x7f) << 25) |
			((uint32_t)input[81] << 17) |
			((uint32_t)(input[82] & 0x80) << 9);
	output[40] = (double)(value >> 16);

	// read output[41]: from bit 657 to 672
	value = ((uint32_t)(input[82] & 0x7f) << 25) |
			((uint32_t)input[83] << 17) |
			((uint32_t)(input[84] & 0x80) << 9);
	output[41] = (double)(value >> 16);

	// read output[42]: from bit 673 to 688
	value = ((uint32_t)(input[84] & 0x7f) << 25) |
			((uint32_t)input[85] << 17) |
			((uint32_t)(input[86] & 0x80) << 9);
	output[42] = (double)(value >> 16);

	// read output[43]: from bit 689 to 704
	value = ((uint32_t)(input[86] & 0x7f) << 25) |
			((uint32_t)input[87] << 17) |
			((uint32_t)(input[88] & 0x80) << 9);
	output[43] = (double)(value >> 16);

	// read output[44]: from bit 705 to 720
	value = ((uint32_t)(input[88] & 0x7f) << 25) |
			((uint32_t)input[89] << 17) |
			((uint32_t)(input[90] & 0x80) << 9);
	output[44] = (double)(value >> 16);

	// read output[45]: from bit 721 to 736
	value = ((uint32_t)(input[90] & 0x7f) << 25) |
			((uint32_t)input[91] << 17) |
			((uint32_t)(input[92] & 0x80) << 9);
	output[45] = (double)(value >> 16);

	// read output[46]: from bit 737 to 752
	value = ((uint32_t)(input[92] & 0x7f) << 25) |
			((uint32_t)input[93] << 17) |
			((uint32_t)(input[94] & 0x80) << 9);
	output[46] = (double)(value >> 16);

	// read output[47]: from bit 753 to 768
	value = ((uint32_t)(input[94] & 0x7f) << 25) |
			((uint32_t)input[95] << 17) |
			((uint32_t)(input[96] & 0x80) << 9);
	output[47] = (double)(value >> 16);

	// read output[48]: from bit 769 to 784
	value = ((uint32_t)(input[96] & 0x7f) << 25) |
			((uint32_t)input[97] << 17) |
			((uint32_t)(input[98] & 0x80) << 9);
	output[48] = (double)(value >> 16);
}

static void unpack_49_16bit_signed_2off(const uint8_t * input, double * output, void *closure) {
	// Unpack 49 values into output
	// Values are 16-bit signed
	// Skip 2 bits, read 784 bits of data.
	// Input must be at least 99 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 2 to 17
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)input[1] << 18) |
			((uint32_t)(input[2] & 0xc0) << 10);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 18 to 33
	value = ((uint32_t)(input[2] & 0x3f) << 26) |
			((uint32_t)input[3] << 18) |
			((uint32_t)(input[4] & 0xc0) << 10);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 34 to 49
	value = ((uint32_t)(input[4] & 0x3f) << 26) |
			((uint32_t)input[5] << 18) |
			((uint32_t)(input[6] & 0xc0) << 10);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 50 to 65
	value = ((uint32_t)(input[6] & 0x3f) << 26) |
			((uint32_t)input[7] << 18) |
			((uint32_t)(input[8] & 0xc0) << 10);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 66 to 81
	value = ((uint32_t)(input[8] & 0x3f) << 26) |
			((uint32_t)input[9] << 18) |
			((uint32_t)(input[10] & 0xc0) << 10);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 82 to 97
	value = ((uint32_t)(input[10] & 0x3f) << 26) |
			((uint32_t)input[11] << 18) |
			((uint32_t)(input[12] & 0xc0) << 10);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 98 to 113
	value = ((uint32_t)(input[12] & 0x3f) << 26) |
			((uint32_t)input[13] << 18) |
			((uint32_t)(input[14] & 0xc0) << 10);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 114 to 129
	value = ((uint32_t)(input[14] & 0x3f) << 26) |
			((uint32_t)input[15] << 18) |
			((uint32_t)(input[16] & 0xc0) << 10);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 130 to 145
	value = ((uint32_t)(input[16] & 0x3f) << 26) |
			((uint32_t)input[17] << 18) |
			((uint32_t)(input[18] & 0xc0) << 10);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 146 to 161
	value = ((uint32_t)(input[18] & 0x3f) << 26) |
			((uint32_t)input[19] << 18) |
			((uint32_t)(input[20] & 0xc0) << 10);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 162 to 177
	value = ((uint32_t)(input[20] & 0x3f) << 26) |
			((uint32_t)input[21] << 18) |
			((uint32_t)(input[22] & 0xc0) << 10);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 178 to 193
	value = ((uint32_t)(input[22] & 0x3f) << 26) |
			((uint32_t)input[23] << 18) |
			((uint32_t)(input[24] & 0xc0) << 10);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 194 to 209
	value = ((uint32_t)(input[24] & 0x3f) << 26) |
			((uint32_t)input[25] << 18) |
			((uint32_t)(input[26] & 0xc0) << 10);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 210 to 225
	value = ((uint32_t)(input[26] & 0x3f) << 26) |
			((uint32_t)input[27] << 18) |
			((uint32_t)(input[28] & 0xc0) << 10);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 226 to 241
	value = ((uint32_t)(input[28] & 0x3f) << 26) |
			((uint32_t)input[29] << 18) |
			((uint32_t)(input[30] & 0xc0) << 10);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 242 to 257
	value = ((uint32_t)(input[30] & 0x3f) << 26) |
			((uint32_t)input[31] << 18) |
			((uint32_t)(input[32] & 0xc0) << 10);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 258 to 273
	value = ((uint32_t)(input[32] & 0x3f) << 26) |
			((uint32_t)input[33] << 18) |
			((uint32_t)(input[34] & 0xc0) << 10);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 274 to 289
	value = ((uint32_t)(input[34] & 0x3f) << 26) |
			((uint32_t)input[35] << 18) |
			((uint32_t)(input[36] & 0xc0) << 10);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 290 to 305
	value = ((uint32_t)(input[36] & 0x3f) << 26) |
			((uint32_t)input[37] << 18) |
			((uint32_t)(input[38] & 0xc0) << 10);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 306 to 321
	value = ((uint32_t)(input[38] & 0x3f) << 26) |
			((uint32_t)input[39] << 18) |
			((uint32_t)(input[40] & 0xc0) << 10);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 322 to 337
	value = ((uint32_t)(input[40] & 0x3f) << 26) |
			((uint32_t)input[41] << 18) |
			((uint32_t)(input[42] & 0xc0) << 10);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 338 to 353
	value = ((uint32_t)(input[42] & 0x3f) << 26) |
			((uint32_t)input[43] << 18) |
			((uint32_t)(input[44] & 0xc0) << 10);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 354 to 369
	value = ((uint32_t)(input[44] & 0x3f) << 26) |
			((uint32_t)input[45] << 18) |
			((uint32_t)(input[46] & 0xc0) << 10);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 370 to 385
	value = ((uint32_t)(input[46] & 0x3f) << 26) |
			((uint32_t)input[47] << 18) |
			((uint32_t)(input[48] & 0xc0) << 10);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 386 to 401
	value = ((uint32_t)(input[48] & 0x3f) << 26) |
			((uint32_t)input[49] << 18) |
			((uint32_t)(input[50] & 0xc0) << 10);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 402 to 417
	value = ((uint32_t)(input[50] & 0x3f) << 26) |
			((uint32_t)input[51] << 18) |
			((uint32_t)(input[52] & 0xc0) << 10);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 418 to 433
	value = ((uint32_t)(input[52] & 0x3f) << 26) |
			((uint32_t)input[53] << 18) |
			((uint32_t)(input[54] & 0xc0) << 10);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 434 to 449
	value = ((uint32_t)(input[54] & 0x3f) << 26) |
			((uint32_t)input[55] << 18) |
			((uint32_t)(input[56] & 0xc0) << 10);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 450 to 465
	value = ((uint32_t)(input[56] & 0x3f) << 26) |
			((uint32_t)input[57] << 18) |
			((uint32_t)(input[58] & 0xc0) << 10);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 466 to 481
	value = ((uint32_t)(input[58] & 0x3f) << 26) |
			((uint32_t)input[59] << 18) |
			((uint32_t)(input[60] & 0xc0) << 10);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 482 to 497
	value = ((uint32_t)(input[60] & 0x3f) << 26) |
			((uint32_t)input[61] << 18) |
			((uint32_t)(input[62] & 0xc0) << 10);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 498 to 513
	value = ((uint32_t)(input[62] & 0x3f) << 26) |
			((uint32_t)input[63] << 18) |
			((uint32_t)(input[64] & 0xc0) << 10);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 514 to 529
	value = ((uint32_t)(input[64] & 0x3f) << 26) |
			((uint32_t)input[65] << 18) |
			((uint32_t)(input[66] & 0xc0) << 10);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 530 to 545
	value = ((uint32_t)(input[66] & 0x3f) << 26) |
			((uint32_t)input[67] << 18) |
			((uint32_t)(input[68] & 0xc0) << 10);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 546 to 561
	value = ((uint32_t)(input[68] & 0x3f) << 26) |
			((uint32_t)input[69] << 18) |
			((uint32_t)(input[70] & 0xc0) << 10);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 562 to 577
	value = ((uint32_t)(input[70] & 0x3f) << 26) |
			((uint32_t)input[71] << 18) |
			((uint32_t)(input[72] & 0xc0) << 10);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 578 to 593
	value = ((uint32_t)(input[72] & 0x3f) << 26) |
			((uint32_t)input[73] << 18) |
			((uint32_t)(input[74] & 0xc0) << 10);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 594 to 609
	value = ((uint32_t)(input[74] & 0x3f) << 26) |
			((uint32_t)input[75] << 18) |
			((uint32_t)(input[76] & 0xc0) << 10);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 610 to 625
	value = ((uint32_t)(input[76] & 0x3f) << 26) |
			((uint32_t)input[77] << 18) |
			((uint32_t)(input[78] & 0xc0) << 10);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 626 to 641
	value = ((uint32_t)(input[78] & 0x3f) << 26) |
			((uint32_t)input[79] << 18) |
			((uint32_t)(input[80] & 0xc0) << 10);
	output[39] = (double)(value >> 16);

	// read output[40]: from bit 642 to 657
	value = ((uint32_t)(input[80] & 0x3f) << 26) |
			((uint32_t)input[81] << 18) |
			((uint32_t)(input[82] & 0xc0) << 10);
	output[40] = (double)(value >> 16);

	// read output[41]: from bit 658 to 673
	value = ((uint32_t)(input[82] & 0x3f) << 26) |
			((uint32_t)input[83] << 18) |
			((uint32_t)(input[84] & 0xc0) << 10);
	output[41] = (double)(value >> 16);

	// read output[42]: from bit 674 to 689
	value = ((uint32_t)(input[84] & 0x3f) << 26) |
			((uint32_t)input[85] << 18) |
			((uint32_t)(input[86] & 0xc0) << 10);
	output[42] = (double)(value >> 16);

	// read output[43]: from bit 690 to 705
	value = ((uint32_t)(input[86] & 0x3f) << 26) |
			((uint32_t)input[87] << 18) |
			((uint32_t)(input[88] & 0xc0) << 10);
	output[43] = (double)(value >> 16);

	// read output[44]: from bit 706 to 721
	value = ((uint32_t)(input[88] & 0x3f) << 26) |
			((uint32_t)input[89] << 18) |
			((uint32_t)(input[90] & 0xc0) << 10);
	output[44] = (double)(value >> 16);

	// read output[45]: from bit 722 to 737
	value = ((uint32_t)(input[90] & 0x3f) << 26) |
			((uint32_t)input[91] << 18) |
			((uint32_t)(input[92] & 0xc0) << 10);
	output[45] = (double)(value >> 16);

	// read output[46]: from bit 738 to 753
	value = ((uint32_t)(input[92] & 0x3f) << 26) |
			((uint32_t)input[93] << 18) |
			((uint32_t)(input[94] & 0xc0) << 10);
	output[46] = (double)(value >> 16);

	// read output[47]: from bit 754 to 769
	value = ((uint32_t)(input[94] & 0x3f) << 26) |
			((uint32_t)input[95] << 18) |
			((uint32_t)(input[96] & 0xc0) << 10);
	output[47] = (double)(value >> 16);

	// read output[48]: from bit 770 to 785
	value = ((uint32_t)(input[96] & 0x3f) << 26) |
			((uint32_t)input[97] << 18) |
			((uint32_t)(input[98] & 0xc0) << 10);
	output[48] = (double)(value >> 16);
}

static void unpack_49_16bit_unsigned_2off(const uint8_t * input, double * output, void *closure) {
	// Unpack 49 values into output
	// Values are 16-bit unsigned
	// Skip 2 bits, read 784 bits of data.
	// Input must be at least 99 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 2 to 17
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)input[1] << 18) |
			((uint32_t)(input[2] & 0xc0) << 10);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 18 to 33
	value = ((uint32_t)(input[2] & 0x3f) << 26) |
			((uint32_t)input[3] << 18) |
			((uint32_t)(input[4] & 0xc0) << 10);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 34 to 49
	value = ((uint32_t)(input[4] & 0x3f) << 26) |
			((uint32_t)input[5] << 18) |
			((uint32_t)(input[6] & 0xc0) << 10);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 50 to 65
	value = ((uint32_t)(input[6] & 0x3f) << 26) |
			((uint32_t)input[7] << 18) |
			((uint32_t)(input[8] & 0xc0) << 10);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 66 to 81
	value = ((uint32_t)(input[8] & 0x3f) << 26) |
			((uint32_t)input[9] << 18) |
			((uint32_t)(input[10] & 0xc0) << 10);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 82 to 97
	value = ((uint32_t)(input[10] & 0x3f) << 26) |
			((uint32_t)input[11] << 18) |
			((uint32_t)(input[12] & 0xc0) << 10);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 98 to 113
	value = ((uint32_t)(input[12] & 0x3f) << 26) |
			((uint32_t)input[13] << 18) |
			((uint32_t)(input[14] & 0xc0) << 10);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 114 to 129
	value = ((uint32_t)(input[14] & 0x3f) << 26) |
			((uint32_t)input[15] << 18) |
			((uint32_t)(input[16] & 0xc0) << 10);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 130 to 145
	value = ((uint32_t)(input[16] & 0x3f) << 26) |
			((uint32_t)input[17] << 18) |
			((uint32_t)(input[18] & 0xc0) << 10);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 146 to 161
	value = ((uint32_t)(input[18] & 0x3f) << 26) |
			((uint32_t)input[19] << 18) |
			((uint32_t)(input[20] & 0xc0) << 10);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 162 to 177
	value = ((uint32_t)(input[20] & 0x3f) << 26) |
			((uint32_t)input[21] << 18) |
			((uint32_t)(input[22] & 0xc0) << 10);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 178 to 193
	value = ((uint32_t)(input[22] & 0x3f) << 26) |
			((uint32_t)input[23] << 18) |
			((uint32_t)(input[24] & 0xc0) << 10);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 194 to 209
	value = ((uint32_t)(input[24] & 0x3f) << 26) |
			((uint32_t)input[25] << 18) |
			((uint32_t)(input[26] & 0xc0) << 10);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 210 to 225
	value = ((uint32_t)(input[26] & 0x3f) << 26) |
			((uint32_t)input[27] << 18) |
			((uint32_t)(input[28] & 0xc0) << 10);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 226 to 241
	value = ((uint32_t)(input[28] & 0x3f) << 26) |
			((uint32_t)input[29] << 18) |
			((uint32_t)(input[30] & 0xc0) << 10);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 242 to 257
	value = ((uint32_t)(input[30] & 0x3f) << 26) |
			((uint32_t)input[31] << 18) |
			((uint32_t)(input[32] & 0xc0) << 10);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 258 to 273
	value = ((uint32_t)(input[32] & 0x3f) << 26) |
			((uint32_t)input[33] << 18) |
			((uint32_t)(input[34] & 0xc0) << 10);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 274 to 289
	value = ((uint32_t)(input[34] & 0x3f) << 26) |
			((uint32_t)input[35] << 18) |
			((uint32_t)(input[36] & 0xc0) << 10);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 290 to 305
	value = ((uint32_t)(input[36] & 0x3f) << 26) |
			((uint32_t)input[37] << 18) |
			((uint32_t)(input[38] & 0xc0) << 10);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 306 to 321
	value = ((uint32_t)(input[38] & 0x3f) << 26) |
			((uint32_t)input[39] << 18) |
			((uint32_t)(input[40] & 0xc0) << 10);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 322 to 337
	value = ((uint32_t)(input[40] & 0x3f) << 26) |
			((uint32_t)input[41] << 18) |
			((uint32_t)(input[42] & 0xc0) << 10);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 338 to 353
	value = ((uint32_t)(input[42] & 0x3f) << 26) |
			((uint32_t)input[43] << 18) |
			((uint32_t)(input[44] & 0xc0) << 10);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 354 to 369
	value = ((uint32_t)(input[44] & 0x3f) << 26) |
			((uint32_t)input[45] << 18) |
			((uint32_t)(input[46] & 0xc0) << 10);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 370 to 385
	value = ((uint32_t)(input[46] & 0x3f) << 26) |
			((uint32_t)input[47] << 18) |
			((uint32_t)(input[48] & 0xc0) << 10);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 386 to 401
	value = ((uint32_t)(input[48] & 0x3f) << 26) |
			((uint32_t)input[49] << 18) |
			((uint32_t)(input[50] & 0xc0) << 10);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 402 to 417
	value = ((uint32_t)(input[50] & 0x3f) << 26) |
			((uint32_t)input[51] << 18) |
			((uint32_t)(input[52] & 0xc0) << 10);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 418 to 433
	value = ((uint32_t)(input[52] & 0x3f) << 26) |
			((uint32_t)input[53] << 18) |
			((uint32_t)(input[54] & 0xc0) << 10);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 434 to 449
	value = ((uint32_t)(input[54] & 0x3f) << 26) |
			((uint32_t)input[55] << 18) |
			((uint32_t)(input[56] & 0xc0) << 10);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 450 to 465
	value = ((uint32_t)(input[56] & 0x3f) << 26) |
			((uint32_t)input[57] << 18) |
			((uint32_t)(input[58] & 0xc0) << 10);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 466 to 481
	value = ((uint32_t)(input[58] & 0x3f) << 26) |
			((uint32_t)input[59] << 18) |
			((uint32_t)(input[60] & 0xc0) << 10);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 482 to 497
	value = ((uint32_t)(input[60] & 0x3f) << 26) |
			((uint32_t)input[61] << 18) |
			((uint32_t)(input[62] & 0xc0) << 10);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 498 to 513
	value = ((uint32_t)(input[62] & 0x3f) << 26) |
			((uint32_t)input[63] << 18) |
			((uint32_t)(input[64] & 0xc0) << 10);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 514 to 529
	value = ((uint32_t)(input[64] & 0x3f) << 26) |
			((uint32_t)input[65] << 18) |
			((uint32_t)(input[66] & 0xc0) << 10);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 530 to 545
	value = ((uint32_t)(input[66] & 0x3f) << 26) |
			((uint32_t)input[67] << 18) |
			((uint32_t)(input[68] & 0xc0) << 10);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 546 to 561
	value = ((uint32_t)(input[68] & 0x3f) << 26) |
			((uint32_t)input[69] << 18) |
			((uint32_t)(input[70] & 0xc0) << 10);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 562 to 577
	value = ((uint32_t)(input[70] & 0x3f) << 26) |
			((uint32_t)input[71] << 18) |
			((uint32_t)(input[72] & 0xc0) << 10);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 578 to 593
	value = ((uint32_t)(input[72] & 0x3f) << 26) |
			((uint32_t)input[73] << 18) |
			((uint32_t)(input[74] & 0xc0) << 10);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 594 to 609
	value = ((uint32_t)(input[74] & 0x3f) << 26) |
			((uint32_t)input[75] << 18) |
			((uint32_t)(input[76] & 0xc0) << 10);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 610 to 625
	value = ((uint32_t)(input[76] & 0x3f) << 26) |
			((uint32_t)input[77] << 18) |
			((uint32_t)(input[78] & 0xc0) << 10);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 626 to 641
	value = ((uint32_t)(input[78] & 0x3f) << 26) |
			((uint32_t)input[79] << 18) |
			((uint32_t)(input[80] & 0xc0) << 10);
	output[39] = (double)(value >> 16);

	// read output[40]: from bit 642 to 657
	value = ((uint32_t)(input[80] & 0x3f) << 26) |
			((uint32_t)input[81] << 18) |
			((uint32_t)(input[82] & 0xc0) << 10);
	output[40] = (double)(value >> 16);

	// read output[41]: from bit 658 to 673
	value = ((uint32_t)(input[82] & 0x3f) << 26) |
			((uint32_t)input[83] << 18) |
			((uint32_t)(input[84] & 0xc0) << 10);
	output[41] = (double)(value >> 16);

	// read output[42]: from bit 674 to 689
	value = ((uint32_t)(input[84] & 0x3f) << 26) |
			((uint32_t)input[85] << 18) |
			((uint32_t)(input[86] & 0xc0) << 10);
	output[42] = (double)(value >> 16);

	// read output[43]: from bit 690 to 705
	value = ((uint32_t)(input[86] & 0x3f) << 26) |
			((uint32_t)input[87] << 18) |
			((uint32_t)(input[88] & 0xc0) << 10);
	output[43] = (double)(value >> 16);

	// read output[44]: from bit 706 to 721
	value = ((uint32_t)(input[88] & 0x3f) << 26) |
			((uint32_t)input[89] << 18) |
			((uint32_t)(input[90] & 0xc0) << 10);
	output[44] = (double)(value >> 16);

	// read output[45]: from bit 722 to 737
	value = ((uint32_t)(input[90] & 0x3f) << 26) |
			((uint32_t)input[91] << 18) |
			((uint32_t)(input[92] & 0xc0) << 10);
	output[45] = (double)(value >> 16);

	// read output[46]: from bit 738 to 753
	value = ((uint32_t)(input[92] & 0x3f) << 26) |
			((uint32_t)input[93] << 18) |
			((uint32_t)(input[94] & 0xc0) << 10);
	output[46] = (double)(value >> 16);

	// read output[47]: from bit 754 to 769
	value = ((uint32_t)(input[94] & 0x3f) << 26) |
			((uint32_t)input[95] << 18) |
			((uint32_t)(input[96] & 0xc0) << 10);
	output[47] = (double)(value >> 16);

	// read output[48]: from bit 770 to 785
	value = ((uint32_t)(input[96] & 0x3f) << 26) |
			((uint32_t)input[97] << 18) |
			((uint32_t)(input[98] & 0xc0) << 10);
	output[48] = (double)(value >> 16);
}

static void unpack_49_16bit_signed_3off(const uint8_t * input, double * output, void *closure) {
	// Unpack 49 values into output
	// Values are 16-bit signed
	// Skip 3 bits, read 784 bits of data.
	// Input must be at least 99 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 3 to 18
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)input[1] << 19) |
			((uint32_t)(input[2] & 0xe0) << 11);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 19 to 34
	value = ((uint32_t)(input[2] & 0x1f) << 27) |
			((uint32_t)input[3] << 19) |
			((uint32_t)(input[4] & 0xe0) << 11);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 35 to 50
	value = ((uint32_t)(input[4] & 0x1f) << 27) |
			((uint32_t)input[5] << 19) |
			((uint32_t)(input[6] & 0xe0) << 11);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 51 to 66
	value = ((uint32_t)(input[6] & 0x1f) << 27) |
			((uint32_t)input[7] << 19) |
			((uint32_t)(input[8] & 0xe0) << 11);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 67 to 82
	value = ((uint32_t)(input[8] & 0x1f) << 27) |
			((uint32_t)input[9] << 19) |
			((uint32_t)(input[10] & 0xe0) << 11);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 83 to 98
	value = ((uint32_t)(input[10] & 0x1f) << 27) |
			((uint32_t)input[11] << 19) |
			((uint32_t)(input[12] & 0xe0) << 11);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 99 to 114
	value = ((uint32_t)(input[12] & 0x1f) << 27) |
			((uint32_t)input[13] << 19) |
			((uint32_t)(input[14] & 0xe0) << 11);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 115 to 130
	value = ((uint32_t)(input[14] & 0x1f) << 27) |
			((uint32_t)input[15] << 19) |
			((uint32_t)(input[16] & 0xe0) << 11);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 131 to 146
	value = ((uint32_t)(input[16] & 0x1f) << 27) |
			((uint32_t)input[17] << 19) |
			((uint32_t)(input[18] & 0xe0) << 11);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 147 to 162
	value = ((uint32_t)(input[18] & 0x1f) << 27) |
			((uint32_t)input[19] << 19) |
			((uint32_t)(input[20] & 0xe0) << 11);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 163 to 178
	value = ((uint32_t)(input[20] & 0x1f) << 27) |
			((uint32_t)input[21] << 19) |
			((uint32_t)(input[22] & 0xe0) << 11);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 179 to 194
	value = ((uint32_t)(input[22] & 0x1f) << 27) |
			((uint32_t)input[23] << 19) |
			((uint32_t)(input[24] & 0xe0) << 11);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 195 to 210
	value = ((uint32_t)(input[24] & 0x1f) << 27) |
			((uint32_t)input[25] << 19) |
			((uint32_t)(input[26] & 0xe0) << 11);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 211 to 226
	value = ((uint32_t)(input[26] & 0x1f) << 27) |
			((uint32_t)input[27] << 19) |
			((uint32_t)(input[28] & 0xe0) << 11);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 227 to 242
	value = ((uint32_t)(input[28] & 0x1f) << 27) |
			((uint32_t)input[29] << 19) |
			((uint32_t)(input[30] & 0xe0) << 11);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 243 to 258
	value = ((uint32_t)(input[30] & 0x1f) << 27) |
			((uint32_t)input[31] << 19) |
			((uint32_t)(input[32] & 0xe0) << 11);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 259 to 274
	value = ((uint32_t)(input[32] & 0x1f) << 27) |
			((uint32_t)input[33] << 19) |
			((uint32_t)(input[34] & 0xe0) << 11);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 275 to 290
	value = ((uint32_t)(input[34] & 0x1f) << 27) |
			((uint32_t)input[35] << 19) |
			((uint32_t)(input[36] & 0xe0) << 11);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 291 to 306
	value = ((uint32_t)(input[36] & 0x1f) << 27) |
			((uint32_t)input[37] << 19) |
			((uint32_t)(input[38] & 0xe0) << 11);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 307 to 322
	value = ((uint32_t)(input[38] & 0x1f) << 27) |
			((uint32_t)input[39] << 19) |
			((uint32_t)(input[40] & 0xe0) << 11);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 323 to 338
	value = ((uint32_t)(input[40] & 0x1f) << 27) |
			((uint32_t)input[41] << 19) |
			((uint32_t)(input[42] & 0xe0) << 11);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 339 to 354
	value = ((uint32_t)(input[42] & 0x1f) << 27) |
			((uint32_t)input[43] << 19) |
			((uint32_t)(input[44] & 0xe0) << 11);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 355 to 370
	value = ((uint32_t)(input[44] & 0x1f) << 27) |
			((uint32_t)input[45] << 19) |
			((uint32_t)(input[46] & 0xe0) << 11);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 371 to 386
	value = ((uint32_t)(input[46] & 0x1f) << 27) |
			((uint32_t)input[47] << 19) |
			((uint32_t)(input[48] & 0xe0) << 11);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 387 to 402
	value = ((uint32_t)(input[48] & 0x1f) << 27) |
			((uint32_t)input[49] << 19) |
			((uint32_t)(input[50] & 0xe0) << 11);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 403 to 418
	value = ((uint32_t)(input[50] & 0x1f) << 27) |
			((uint32_t)input[51] << 19) |
			((uint32_t)(input[52] & 0xe0) << 11);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 419 to 434
	value = ((uint32_t)(input[52] & 0x1f) << 27) |
			((uint32_t)input[53] << 19) |
			((uint32_t)(input[54] & 0xe0) << 11);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 435 to 450
	value = ((uint32_t)(input[54] & 0x1f) << 27) |
			((uint32_t)input[55] << 19) |
			((uint32_t)(input[56] & 0xe0) << 11);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 451 to 466
	value = ((uint32_t)(input[56] & 0x1f) << 27) |
			((uint32_t)input[57] << 19) |
			((uint32_t)(input[58] & 0xe0) << 11);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 467 to 482
	value = ((uint32_t)(input[58] & 0x1f) << 27) |
			((uint32_t)input[59] << 19) |
			((uint32_t)(input[60] & 0xe0) << 11);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 483 to 498
	value = ((uint32_t)(input[60] & 0x1f) << 27) |
			((uint32_t)input[61] << 19) |
			((uint32_t)(input[62] & 0xe0) << 11);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 499 to 514
	value = ((uint32_t)(input[62] & 0x1f) << 27) |
			((uint32_t)input[63] << 19) |
			((uint32_t)(input[64] & 0xe0) << 11);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 515 to 530
	value = ((uint32_t)(input[64] & 0x1f) << 27) |
			((uint32_t)input[65] << 19) |
			((uint32_t)(input[66] & 0xe0) << 11);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 531 to 546
	value = ((uint32_t)(input[66] & 0x1f) << 27) |
			((uint32_t)input[67] << 19) |
			((uint32_t)(input[68] & 0xe0) << 11);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 547 to 562
	value = ((uint32_t)(input[68] & 0x1f) << 27) |
			((uint32_t)input[69] << 19) |
			((uint32_t)(input[70] & 0xe0) << 11);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 563 to 578
	value = ((uint32_t)(input[70] & 0x1f) << 27) |
			((uint32_t)input[71] << 19) |
			((uint32_t)(input[72] & 0xe0) << 11);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 579 to 594
	value = ((uint32_t)(input[72] & 0x1f) << 27) |
			((uint32_t)input[73] << 19) |
			((uint32_t)(input[74] & 0xe0) << 11);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 595 to 610
	value = ((uint32_t)(input[74] & 0x1f) << 27) |
			((uint32_t)input[75] << 19) |
			((uint32_t)(input[76] & 0xe0) << 11);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 611 to 626
	value = ((uint32_t)(input[76] & 0x1f) << 27) |
			((uint32_t)input[77] << 19) |
			((uint32_t)(input[78] & 0xe0) << 11);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 627 to 642
	value = ((uint32_t)(input[78] & 0x1f) << 27) |
			((uint32_t)input[79] << 19) |
			((uint32_t)(input[80] & 0xe0) << 11);
	output[39] = (double)(value >> 16);

	// read output[40]: from bit 643 to 658
	value = ((uint32_t)(input[80] & 0x1f) << 27) |
			((uint32_t)input[81] << 19) |
			((uint32_t)(input[82] & 0xe0) << 11);
	output[40] = (double)(value >> 16);

	// read output[41]: from bit 659 to 674
	value = ((uint32_t)(input[82] & 0x1f) << 27) |
			((uint32_t)input[83] << 19) |
			((uint32_t)(input[84] & 0xe0) << 11);
	output[41] = (double)(value >> 16);

	// read output[42]: from bit 675 to 690
	value = ((uint32_t)(input[84] & 0x1f) << 27) |
			((uint32_t)input[85] << 19) |
			((uint32_t)(input[86] & 0xe0) << 11);
	output[42] = (double)(value >> 16);

	// read output[43]: from bit 691 to 706
	value = ((uint32_t)(input[86] & 0x1f) << 27) |
			((uint32_t)input[87] << 19) |
			((uint32_t)(input[88] & 0xe0) << 11);
	output[43] = (double)(value >> 16);

	// read output[44]: from bit 707 to 722
	value = ((uint32_t)(input[88] & 0x1f) << 27) |
			((uint32_t)input[89] << 19) |
			((uint32_t)(input[90] & 0xe0) << 11);
	output[44] = (double)(value >> 16);

	// read output[45]: from bit 723 to 738
	value = ((uint32_t)(input[90] & 0x1f) << 27) |
			((uint32_t)input[91] << 19) |
			((uint32_t)(input[92] & 0xe0) << 11);
	output[45] = (double)(value >> 16);

	// read output[46]: from bit 739 to 754
	value = ((uint32_t)(input[92] & 0x1f) << 27) |
			((uint32_t)input[93] << 19) |
			((uint32_t)(input[94] & 0xe0) << 11);
	output[46] = (double)(value >> 16);

	// read output[47]: from bit 755 to 770
	value = ((uint32_t)(input[94] & 0x1f) << 27) |
			((uint32_t)input[95] << 19) |
			((uint32_t)(input[96] & 0xe0) << 11);
	output[47] = (double)(value >> 16);

	// read output[48]: from bit 771 to 786
	value = ((uint32_t)(input[96] & 0x1f) << 27) |
			((uint32_t)input[97] << 19) |
			((uint32_t)(input[98] & 0xe0) << 11);
	output[48] = (double)(value >> 16);
}

static void unpack_49_16bit_unsigned_3off(const uint8_t * input, double * output, void *closure) {
	// Unpack 49 values into output
	// Values are 16-bit unsigned
	// Skip 3 bits, read 784 bits of data.
	// Input must be at least 99 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 3 to 18
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)input[1] << 19) |
			((uint32_t)(input[2] & 0xe0) << 11);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 19 to 34
	value = ((uint32_t)(input[2] & 0x1f) << 27) |
			((uint32_t)input[3] << 19) |
			((uint32_t)(input[4] & 0xe0) << 11);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 35 to 50
	value = ((uint32_t)(input[4] & 0x1f) << 27) |
			((uint32_t)input[5] << 19) |
			((uint32_t)(input[6] & 0xe0) << 11);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 51 to 66
	value = ((uint32_t)(input[6] & 0x1f) << 27) |
			((uint32_t)input[7] << 19) |
			((uint32_t)(input[8] & 0xe0) << 11);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 67 to 82
	value = ((uint32_t)(input[8] & 0x1f) << 27) |
			((uint32_t)input[9] << 19) |
			((uint32_t)(input[10] & 0xe0) << 11);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 83 to 98
	value = ((uint32_t)(input[10] & 0x1f) << 27) |
			((uint32_t)input[11] << 19) |
			((uint32_t)(input[12] & 0xe0) << 11);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 99 to 114
	value = ((uint32_t)(input[12] & 0x1f) << 27) |
			((uint32_t)input[13] << 19) |
			((uint32_t)(input[14] & 0xe0) << 11);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 115 to 130
	value = ((uint32_t)(input[14] & 0x1f) << 27) |
			((uint32_t)input[15] << 19) |
			((uint32_t)(input[16] & 0xe0) << 11);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 131 to 146
	value = ((uint32_t)(input[16] & 0x1f) << 27) |
			((uint32_t)input[17] << 19) |
			((uint32_t)(input[18] & 0xe0) << 11);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 147 to 162
	value = ((uint32_t)(input[18] & 0x1f) << 27) |
			((uint32_t)input[19] << 19) |
			((uint32_t)(input[20] & 0xe0) << 11);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 163 to 178
	value = ((uint32_t)(input[20] & 0x1f) << 27) |
			((uint32_t)input[21] << 19) |
			((uint32_t)(input[22] & 0xe0) << 11);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 179 to 194
	value = ((uint32_t)(input[22] & 0x1f) << 27) |
			((uint32_t)input[23] << 19) |
			((uint32_t)(input[24] & 0xe0) << 11);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 195 to 210
	value = ((uint32_t)(input[24] & 0x1f) << 27) |
			((uint32_t)input[25] << 19) |
			((uint32_t)(input[26] & 0xe0) << 11);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 211 to 226
	value = ((uint32_t)(input[26] & 0x1f) << 27) |
			((uint32_t)input[27] << 19) |
			((uint32_t)(input[28] & 0xe0) << 11);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 227 to 242
	value = ((uint32_t)(input[28] & 0x1f) << 27) |
			((uint32_t)input[29] << 19) |
			((uint32_t)(input[30] & 0xe0) << 11);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 243 to 258
	value = ((uint32_t)(input[30] & 0x1f) << 27) |
			((uint32_t)input[31] << 19) |
			((uint32_t)(input[32] & 0xe0) << 11);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 259 to 274
	value = ((uint32_t)(input[32] & 0x1f) << 27) |
			((uint32_t)input[33] << 19) |
			((uint32_t)(input[34] & 0xe0) << 11);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 275 to 290
	value = ((uint32_t)(input[34] & 0x1f) << 27) |
			((uint32_t)input[35] << 19) |
			((uint32_t)(input[36] & 0xe0) << 11);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 291 to 306
	value = ((uint32_t)(input[36] & 0x1f) << 27) |
			((uint32_t)input[37] << 19) |
			((uint32_t)(input[38] & 0xe0) << 11);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 307 to 322
	value = ((uint32_t)(input[38] & 0x1f) << 27) |
			((uint32_t)input[39] << 19) |
			((uint32_t)(input[40] & 0xe0) << 11);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 323 to 338
	value = ((uint32_t)(input[40] & 0x1f) << 27) |
			((uint32_t)input[41] << 19) |
			((uint32_t)(input[42] & 0xe0) << 11);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 339 to 354
	value = ((uint32_t)(input[42] & 0x1f) << 27) |
			((uint32_t)input[43] << 19) |
			((uint32_t)(input[44] & 0xe0) << 11);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 355 to 370
	value = ((uint32_t)(input[44] & 0x1f) << 27) |
			((uint32_t)input[45] << 19) |
			((uint32_t)(input[46] & 0xe0) << 11);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 371 to 386
	value = ((uint32_t)(input[46] & 0x1f) << 27) |
			((uint32_t)input[47] << 19) |
			((uint32_t)(input[48] & 0xe0) << 11);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 387 to 402
	value = ((uint32_t)(input[48] & 0x1f) << 27) |
			((uint32_t)input[49] << 19) |
			((uint32_t)(input[50] & 0xe0) << 11);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 403 to 418
	value = ((uint32_t)(input[50] & 0x1f) << 27) |
			((uint32_t)input[51] << 19) |
			((uint32_t)(input[52] & 0xe0) << 11);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 419 to 434
	value = ((uint32_t)(input[52] & 0x1f) << 27) |
			((uint32_t)input[53] << 19) |
			((uint32_t)(input[54] & 0xe0) << 11);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 435 to 450
	value = ((uint32_t)(input[54] & 0x1f) << 27) |
			((uint32_t)input[55] << 19) |
			((uint32_t)(input[56] & 0xe0) << 11);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 451 to 466
	value = ((uint32_t)(input[56] & 0x1f) << 27) |
			((uint32_t)input[57] << 19) |
			((uint32_t)(input[58] & 0xe0) << 11);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 467 to 482
	value = ((uint32_t)(input[58] & 0x1f) << 27) |
			((uint32_t)input[59] << 19) |
			((uint32_t)(input[60] & 0xe0) << 11);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 483 to 498
	value = ((uint32_t)(input[60] & 0x1f) << 27) |
			((uint32_t)input[61] << 19) |
			((uint32_t)(input[62] & 0xe0) << 11);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 499 to 514
	value = ((uint32_t)(input[62] & 0x1f) << 27) |
			((uint32_t)input[63] << 19) |
			((uint32_t)(input[64] & 0xe0) << 11);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 515 to 530
	value = ((uint32_t)(input[64] & 0x1f) << 27) |
			((uint32_t)input[65] << 19) |
			((uint32_t)(input[66] & 0xe0) << 11);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 531 to 546
	value = ((uint32_t)(input[66] & 0x1f) << 27) |
			((uint32_t)input[67] << 19) |
			((uint32_t)(input[68] & 0xe0) << 11);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 547 to 562
	value = ((uint32_t)(input[68] & 0x1f) << 27) |
			((uint32_t)input[69] << 19) |
			((uint32_t)(input[70] & 0xe0) << 11);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 563 to 578
	value = ((uint32_t)(input[70] & 0x1f) << 27) |
			((uint32_t)input[71] << 19) |
			((uint32_t)(input[72] & 0xe0) << 11);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 579 to 594
	value = ((uint32_t)(input[72] & 0x1f) << 27) |
			((uint32_t)input[73] << 19) |
			((uint32_t)(input[74] & 0xe0) << 11);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 595 to 610
	value = ((uint32_t)(input[74] & 0x1f) << 27) |
			((uint32_t)input[75] << 19) |
			((uint32_t)(input[76] & 0xe0) << 11);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 611 to 626
	value = ((uint32_t)(input[76] & 0x1f) << 27) |
			((uint32_t)input[77] << 19) |
			((uint32_t)(input[78] & 0xe0) << 11);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 627 to 642
	value = ((uint32_t)(input[78] & 0x1f) << 27) |
			((uint32_t)input[79] << 19) |
			((uint32_t)(input[80] & 0xe0) << 11);
	output[39] = (double)(value >> 16);

	// read output[40]: from bit 643 to 658
	value = ((uint32_t)(input[80] & 0x1f) << 27) |
			((uint32_t)input[81] << 19) |
			((uint32_t)(input[82] & 0xe0) << 11);
	output[40] = (double)(value >> 16);

	// read output[41]: from bit 659 to 674
	value = ((uint32_t)(input[82] & 0x1f) << 27) |
			((uint32_t)input[83] << 19) |
			((uint32_t)(input[84] & 0xe0) << 11);
	output[41] = (double)(value >> 16);

	// read output[42]: from bit 675 to 690
	value = ((uint32_t)(input[84] & 0x1f) << 27) |
			((uint32_t)input[85] << 19) |
			((uint32_t)(input[86] & 0xe0) << 11);
	output[42] = (double)(value >> 16);

	// read output[43]: from bit 691 to 706
	value = ((uint32_t)(input[86] & 0x1f) << 27) |
			((uint32_t)input[87] << 19) |
			((uint32_t)(input[88] & 0xe0) << 11);
	output[43] = (double)(value >> 16);

	// read output[44]: from bit 707 to 722
	value = ((uint32_t)(input[88] & 0x1f) << 27) |
			((uint32_t)input[89] << 19) |
			((uint32_t)(input[90] & 0xe0) << 11);
	output[44] = (double)(value >> 16);

	// read output[45]: from bit 723 to 738
	value = ((uint32_t)(input[90] & 0x1f) << 27) |
			((uint32_t)input[91] << 19) |
			((uint32_t)(input[92] & 0xe0) << 11);
	output[45] = (double)(value >> 16);

	// read output[46]: from bit 739 to 754
	value = ((uint32_t)(input[92] & 0x1f) << 27) |
			((uint32_t)input[93] << 19) |
			((uint32_t)(input[94] & 0xe0) << 11);
	output[46] = (double)(value >> 16);

	// read output[47]: from bit 755 to 770
	value = ((uint32_t)(input[94] & 0x1f) << 27) |
			((uint32_t)input[95] << 19) |
			((uint32_t)(input[96] & 0xe0) << 11);
	output[47] = (double)(value >> 16);

	// read output[48]: from bit 771 to 786
	value = ((uint32_t)(input[96] & 0x1f) << 27) |
			((uint32_t)input[97] << 19) |
			((uint32_t)(input[98] & 0xe0) << 11);
	output[48] = (double)(value >> 16);
}

static void unpack_49_16bit_signed_4off(const uint8_t * input, double * output, void *closure) {
	// Unpack 49 values into output
	// Values are 16-bit signed
	// Skip 4 bits, read 784 bits of data.
	// Input must be at least 99 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 4 to 19
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20) |
			((uint32_t)(input[2] & 0xf0) << 12);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 20 to 35
	value = ((uint32_t)(input[2] & 0x0f) << 28) |
			((uint32_t)input[3] << 20) |
			((uint32_t)(input[4] & 0xf0) << 12);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 36 to 51
	value = ((uint32_t)(input[4] & 0x0f) << 28) |
			((uint32_t)input[5] << 20) |
			((uint32_t)(input[6] & 0xf0) << 12);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 52 to 67
	value = ((uint32_t)(input[6] & 0x0f) << 28) |
			((uint32_t)input[7] << 20) |
			((uint32_t)(input[8] & 0xf0) << 12);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 68 to 83
	value = ((uint32_t)(input[8] & 0x0f) << 28) |
			((uint32_t)input[9] << 20) |
			((uint32_t)(input[10] & 0xf0) << 12);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 84 to 99
	value = ((uint32_t)(input[10] & 0x0f) << 28) |
			((uint32_t)input[11] << 20) |
			((uint32_t)(input[12] & 0xf0) << 12);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 100 to 115
	value = ((uint32_t)(input[12] & 0x0f) << 28) |
			((uint32_t)input[13] << 20) |
			((uint32_t)(input[14] & 0xf0) << 12);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 116 to 131
	value = ((uint32_t)(input[14] & 0x0f) << 28) |
			((uint32_t)input[15] << 20) |
			((uint32_t)(input[16] & 0xf0) << 12);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 132 to 147
	value = ((uint32_t)(input[16] & 0x0f) << 28) |
			((uint32_t)input[17] << 20) |
			((uint32_t)(input[18] & 0xf0) << 12);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 148 to 163
	value = ((uint32_t)(input[18] & 0x0f) << 28) |
			((uint32_t)input[19] << 20) |
			((uint32_t)(input[20] & 0xf0) << 12);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 164 to 179
	value = ((uint32_t)(input[20] & 0x0f) << 28) |
			((uint32_t)input[21] << 20) |
			((uint32_t)(input[22] & 0xf0) << 12);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 180 to 195
	value = ((uint32_t)(input[22] & 0x0f) << 28) |
			((uint32_t)input[23] << 20) |
			((uint32_t)(input[24] & 0xf0) << 12);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 196 to 211
	value = ((uint32_t)(input[24] & 0x0f) << 28) |
			((uint32_t)input[25] << 20) |
			((uint32_t)(input[26] & 0xf0) << 12);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 212 to 227
	value = ((uint32_t)(input[26] & 0x0f) << 28) |
			((uint32_t)input[27] << 20) |
			((uint32_t)(input[28] & 0xf0) << 12);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 228 to 243
	value = ((uint32_t)(input[28] & 0x0f) << 28) |
			((uint32_t)input[29] << 20) |
			((uint32_t)(input[30] & 0xf0) << 12);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 244 to 259
	value = ((uint32_t)(input[30] & 0x0f) << 28) |
			((uint32_t)input[31] << 20) |
			((uint32_t)(input[32] & 0xf0) << 12);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 260 to 275
	value = ((uint32_t)(input[32] & 0x0f) << 28) |
			((uint32_t)input[33] << 20) |
			((uint32_t)(input[34] & 0xf0) << 12);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 276 to 291
	value = ((uint32_t)(input[34] & 0x0f) << 28) |
			((uint32_t)input[35] << 20) |
			((uint32_t)(input[36] & 0xf0) << 12);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 292 to 307
	value = ((uint32_t)(input[36] & 0x0f) << 28) |
			((uint32_t)input[37] << 20) |
			((uint32_t)(input[38] & 0xf0) << 12);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 308 to 323
	value = ((uint32_t)(input[38] & 0x0f) << 28) |
			((uint32_t)input[39] << 20) |
			((uint32_t)(input[40] & 0xf0) << 12);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 324 to 339
	value = ((uint32_t)(input[40] & 0x0f) << 28) |
			((uint32_t)input[41] << 20) |
			((uint32_t)(input[42] & 0xf0) << 12);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 340 to 355
	value = ((uint32_t)(input[42] & 0x0f) << 28) |
			((uint32_t)input[43] << 20) |
			((uint32_t)(input[44] & 0xf0) << 12);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 356 to 371
	value = ((uint32_t)(input[44] & 0x0f) << 28) |
			((uint32_t)input[45] << 20) |
			((uint32_t)(input[46] & 0xf0) << 12);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 372 to 387
	value = ((uint32_t)(input[46] & 0x0f) << 28) |
			((uint32_t)input[47] << 20) |
			((uint32_t)(input[48] & 0xf0) << 12);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 388 to 403
	value = ((uint32_t)(input[48] & 0x0f) << 28) |
			((uint32_t)input[49] << 20) |
			((uint32_t)(input[50] & 0xf0) << 12);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 404 to 419
	value = ((uint32_t)(input[50] & 0x0f) << 28) |
			((uint32_t)input[51] << 20) |
			((uint32_t)(input[52] & 0xf0) << 12);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 420 to 435
	value = ((uint32_t)(input[52] & 0x0f) << 28) |
			((uint32_t)input[53] << 20) |
			((uint32_t)(input[54] & 0xf0) << 12);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 436 to 451
	value = ((uint32_t)(input[54] & 0x0f) << 28) |
			((uint32_t)input[55] << 20) |
			((uint32_t)(input[56] & 0xf0) << 12);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 452 to 467
	value = ((uint32_t)(input[56] & 0x0f) << 28) |
			((uint32_t)input[57] << 20) |
			((uint32_t)(input[58] & 0xf0) << 12);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 468 to 483
	value = ((uint32_t)(input[58] & 0x0f) << 28) |
			((uint32_t)input[59] << 20) |
			((uint32_t)(input[60] & 0xf0) << 12);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 484 to 499
	value = ((uint32_t)(input[60] & 0x0f) << 28) |
			((uint32_t)input[61] << 20) |
			((uint32_t)(input[62] & 0xf0) << 12);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 500 to 515
	value = ((uint32_t)(input[62] & 0x0f) << 28) |
			((uint32_t)input[63] << 20) |
			((uint32_t)(input[64] & 0xf0) << 12);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 516 to 531
	value = ((uint32_t)(input[64] & 0x0f) << 28) |
			((uint32_t)input[65] << 20) |
			((uint32_t)(input[66] & 0xf0) << 12);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 532 to 547
	value = ((uint32_t)(input[66] & 0x0f) << 28) |
			((uint32_t)input[67] << 20) |
			((uint32_t)(input[68] & 0xf0) << 12);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 548 to 563
	value = ((uint32_t)(input[68] & 0x0f) << 28) |
			((uint32_t)input[69] << 20) |
			((uint32_t)(input[70] & 0xf0) << 12);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 564 to 579
	value = ((uint32_t)(input[70] & 0x0f) << 28) |
			((uint32_t)input[71] << 20) |
			((uint32_t)(input[72] & 0xf0) << 12);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 580 to 595
	value = ((uint32_t)(input[72] & 0x0f) << 28) |
			((uint32_t)input[73] << 20) |
			((uint32_t)(input[74] & 0xf0) << 12);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 596 to 611
	value = ((uint32_t)(input[74] & 0x0f) << 28) |
			((uint32_t)input[75] << 20) |
			((uint32_t)(input[76] & 0xf0) << 12);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 612 to 627
	value = ((uint32_t)(input[76] & 0x0f) << 28) |
			((uint32_t)input[77] << 20) |
			((uint32_t)(input[78] & 0xf0) << 12);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 628 to 643
	value = ((uint32_t)(input[78] & 0x0f) << 28) |
			((uint32_t)input[79] << 20) |
			((uint32_t)(input[80] & 0xf0) << 12);
	output[39] = (double)(value >> 16);

	// read output[40]: from bit 644 to 659
	value = ((uint32_t)(input[80] & 0x0f) << 28) |
			((uint32_t)input[81] << 20) |
			((uint32_t)(input[82] & 0xf0) << 12);
	output[40] = (double)(value >> 16);

	// read output[41]: from bit 660 to 675
	value = ((uint32_t)(input[82] & 0x0f) << 28) |
			((uint32_t)input[83] << 20) |
			((uint32_t)(input[84] & 0xf0) << 12);
	output[41] = (double)(value >> 16);

	// read output[42]: from bit 676 to 691
	value = ((uint32_t)(input[84] & 0x0f) << 28) |
			((uint32_t)input[85] << 20) |
			((uint32_t)(input[86] & 0xf0) << 12);
	output[42] = (double)(value >> 16);

	// read output[43]: from bit 692 to 707
	value = ((uint32_t)(input[86] & 0x0f) << 28) |
			((uint32_t)input[87] << 20) |
			((uint32_t)(input[88] & 0xf0) << 12);
	output[43] = (double)(value >> 16);

	// read output[44]: from bit 708 to 723
	value = ((uint32_t)(input[88] & 0x0f) << 28) |
			((uint32_t)input[89] << 20) |
			((uint32_t)(input[90] & 0xf0) << 12);
	output[44] = (double)(value >> 16);

	// read output[45]: from bit 724 to 739
	value = ((uint32_t)(input[90] & 0x0f) << 28) |
			((uint32_t)input[91] << 20) |
			((uint32_t)(input[92] & 0xf0) << 12);
	output[45] = (double)(value >> 16);

	// read output[46]: from bit 740 to 755
	value = ((uint32_t)(input[92] & 0x0f) << 28) |
			((uint32_t)input[93] << 20) |
			((uint32_t)(input[94] & 0xf0) << 12);
	output[46] = (double)(value >> 16);

	// read output[47]: from bit 756 to 771
	value = ((uint32_t)(input[94] & 0x0f) << 28) |
			((uint32_t)input[95] << 20) |
			((uint32_t)(input[96] & 0xf0) << 12);
	output[47] = (double)(value >> 16);

	// read output[48]: from bit 772 to 787
	value = ((uint32_t)(input[96] & 0x0f) << 28) |
			((uint32_t)input[97] << 20) |
			((uint32_t)(input[98] & 0xf0) << 12);
	output[48] = (double)(value >> 16);
}

static void unpack_49_16bit_unsigned_4off(const uint8_t * input, double * output, void *closure) {
	// Unpack 49 values into output
	// Values are 16-bit unsigned
	// Skip 4 bits, read 784 bits of data.
	// Input must be at least 99 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 4 to 19
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20) |
			((uint32_t)(input[2] & 0xf0) << 12);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 20 to 35
	value = ((uint32_t)(input[2] & 0x0f) << 28) |
			((uint32_t)input[3] << 20) |
			((uint32_t)(input[4] & 0xf0) << 12);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 36 to 51
	value = ((uint32_t)(input[4] & 0x0f) << 28) |
			((uint32_t)input[5] << 20) |
			((uint32_t)(input[6] & 0xf0) << 12);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 52 to 67
	value = ((uint32_t)(input[6] & 0x0f) << 28) |
			((uint32_t)input[7] << 20) |
			((uint32_t)(input[8] & 0xf0) << 12);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 68 to 83
	value = ((uint32_t)(input[8] & 0x0f) << 28) |
			((uint32_t)input[9] << 20) |
			((uint32_t)(input[10] & 0xf0) << 12);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 84 to 99
	value = ((uint32_t)(input[10] & 0x0f) << 28) |
			((uint32_t)input[11] << 20) |
			((uint32_t)(input[12] & 0xf0) << 12);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 100 to 115
	value = ((uint32_t)(input[12] & 0x0f) << 28) |
			((uint32_t)input[13] << 20) |
			((uint32_t)(input[14] & 0xf0) << 12);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 116 to 131
	value = ((uint32_t)(input[14] & 0x0f) << 28) |
			((uint32_t)input[15] << 20) |
			((uint32_t)(input[16] & 0xf0) << 12);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 132 to 147
	value = ((uint32_t)(input[16] & 0x0f) << 28) |
			((uint32_t)input[17] << 20) |
			((uint32_t)(input[18] & 0xf0) << 12);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 148 to 163
	value = ((uint32_t)(input[18] & 0x0f) << 28) |
			((uint32_t)input[19] << 20) |
			((uint32_t)(input[20] & 0xf0) << 12);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 164 to 179
	value = ((uint32_t)(input[20] & 0x0f) << 28) |
			((uint32_t)input[21] << 20) |
			((uint32_t)(input[22] & 0xf0) << 12);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 180 to 195
	value = ((uint32_t)(input[22] & 0x0f) << 28) |
			((uint32_t)input[23] << 20) |
			((uint32_t)(input[24] & 0xf0) << 12);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 196 to 211
	value = ((uint32_t)(input[24] & 0x0f) << 28) |
			((uint32_t)input[25] << 20) |
			((uint32_t)(input[26] & 0xf0) << 12);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 212 to 227
	value = ((uint32_t)(input[26] & 0x0f) << 28) |
			((uint32_t)input[27] << 20) |
			((uint32_t)(input[28] & 0xf0) << 12);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 228 to 243
	value = ((uint32_t)(input[28] & 0x0f) << 28) |
			((uint32_t)input[29] << 20) |
			((uint32_t)(input[30] & 0xf0) << 12);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 244 to 259
	value = ((uint32_t)(input[30] & 0x0f) << 28) |
			((uint32_t)input[31] << 20) |
			((uint32_t)(input[32] & 0xf0) << 12);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 260 to 275
	value = ((uint32_t)(input[32] & 0x0f) << 28) |
			((uint32_t)input[33] << 20) |
			((uint32_t)(input[34] & 0xf0) << 12);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 276 to 291
	value = ((uint32_t)(input[34] & 0x0f) << 28) |
			((uint32_t)input[35] << 20) |
			((uint32_t)(input[36] & 0xf0) << 12);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 292 to 307
	value = ((uint32_t)(input[36] & 0x0f) << 28) |
			((uint32_t)input[37] << 20) |
			((uint32_t)(input[38] & 0xf0) << 12);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 308 to 323
	value = ((uint32_t)(input[38] & 0x0f) << 28) |
			((uint32_t)input[39] << 20) |
			((uint32_t)(input[40] & 0xf0) << 12);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 324 to 339
	value = ((uint32_t)(input[40] & 0x0f) << 28) |
			((uint32_t)input[41] << 20) |
			((uint32_t)(input[42] & 0xf0) << 12);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 340 to 355
	value = ((uint32_t)(input[42] & 0x0f) << 28) |
			((uint32_t)input[43] << 20) |
			((uint32_t)(input[44] & 0xf0) << 12);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 356 to 371
	value = ((uint32_t)(input[44] & 0x0f) << 28) |
			((uint32_t)input[45] << 20) |
			((uint32_t)(input[46] & 0xf0) << 12);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 372 to 387
	value = ((uint32_t)(input[46] & 0x0f) << 28) |
			((uint32_t)input[47] << 20) |
			((uint32_t)(input[48] & 0xf0) << 12);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 388 to 403
	value = ((uint32_t)(input[48] & 0x0f) << 28) |
			((uint32_t)input[49] << 20) |
			((uint32_t)(input[50] & 0xf0) << 12);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 404 to 419
	value = ((uint32_t)(input[50] & 0x0f) << 28) |
			((uint32_t)input[51] << 20) |
			((uint32_t)(input[52] & 0xf0) << 12);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 420 to 435
	value = ((uint32_t)(input[52] & 0x0f) << 28) |
			((uint32_t)input[53] << 20) |
			((uint32_t)(input[54] & 0xf0) << 12);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 436 to 451
	value = ((uint32_t)(input[54] & 0x0f) << 28) |
			((uint32_t)input[55] << 20) |
			((uint32_t)(input[56] & 0xf0) << 12);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 452 to 467
	value = ((uint32_t)(input[56] & 0x0f) << 28) |
			((uint32_t)input[57] << 20) |
			((uint32_t)(input[58] & 0xf0) << 12);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 468 to 483
	value = ((uint32_t)(input[58] & 0x0f) << 28) |
			((uint32_t)input[59] << 20) |
			((uint32_t)(input[60] & 0xf0) << 12);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 484 to 499
	value = ((uint32_t)(input[60] & 0x0f) << 28) |
			((uint32_t)input[61] << 20) |
			((uint32_t)(input[62] & 0xf0) << 12);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 500 to 515
	value = ((uint32_t)(input[62] & 0x0f) << 28) |
			((uint32_t)input[63] << 20) |
			((uint32_t)(input[64] & 0xf0) << 12);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 516 to 531
	value = ((uint32_t)(input[64] & 0x0f) << 28) |
			((uint32_t)input[65] << 20) |
			((uint32_t)(input[66] & 0xf0) << 12);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 532 to 547
	value = ((uint32_t)(input[66] & 0x0f) << 28) |
			((uint32_t)input[67] << 20) |
			((uint32_t)(input[68] & 0xf0) << 12);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 548 to 563
	value = ((uint32_t)(input[68] & 0x0f) << 28) |
			((uint32_t)input[69] << 20) |
			((uint32_t)(input[70] & 0xf0) << 12);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 564 to 579
	value = ((uint32_t)(input[70] & 0x0f) << 28) |
			((uint32_t)input[71] << 20) |
			((uint32_t)(input[72] & 0xf0) << 12);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 580 to 595
	value = ((uint32_t)(input[72] & 0x0f) << 28) |
			((uint32_t)input[73] << 20) |
			((uint32_t)(input[74] & 0xf0) << 12);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 596 to 611
	value = ((uint32_t)(input[74] & 0x0f) << 28) |
			((uint32_t)input[75] << 20) |
			((uint32_t)(input[76] & 0xf0) << 12);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 612 to 627
	value = ((uint32_t)(input[76] & 0x0f) << 28) |
			((uint32_t)input[77] << 20) |
			((uint32_t)(input[78] & 0xf0) << 12);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 628 to 643
	value = ((uint32_t)(input[78] & 0x0f) << 28) |
			((uint32_t)input[79] << 20) |
			((uint32_t)(input[80] & 0xf0) << 12);
	output[39] = (double)(value >> 16);

	// read output[40]: from bit 644 to 659
	value = ((uint32_t)(input[80] & 0x0f) << 28) |
			((uint32_t)input[81] << 20) |
			((uint32_t)(input[82] & 0xf0) << 12);
	output[40] = (double)(value >> 16);

	// read output[41]: from bit 660 to 675
	value = ((uint32_t)(input[82] & 0x0f) << 28) |
			((uint32_t)input[83] << 20) |
			((uint32_t)(input[84] & 0xf0) << 12);
	output[41] = (double)(value >> 16);

	// read output[42]: from bit 676 to 691
	value = ((uint32_t)(input[84] & 0x0f) << 28) |
			((uint32_t)input[85] << 20) |
			((uint32_t)(input[86] & 0xf0) << 12);
	output[42] = (double)(value >> 16);

	// read output[43]: from bit 692 to 707
	value = ((uint32_t)(input[86] & 0x0f) << 28) |
			((uint32_t)input[87] << 20) |
			((uint32_t)(input[88] & 0xf0) << 12);
	output[43] = (double)(value >> 16);

	// read output[44]: from bit 708 to 723
	value = ((uint32_t)(input[88] & 0x0f) << 28) |
			((uint32_t)input[89] << 20) |
			((uint32_t)(input[90] & 0xf0) << 12);
	output[44] = (double)(value >> 16);

	// read output[45]: from bit 724 to 739
	value = ((uint32_t)(input[90] & 0x0f) << 28) |
			((uint32_t)input[91] << 20) |
			((uint32_t)(input[92] & 0xf0) << 12);
	output[45] = (double)(value >> 16);

	// read output[46]: from bit 740 to 755
	value = ((uint32_t)(input[92] & 0x0f) << 28) |
			((uint32_t)input[93] << 20) |
			((uint32_t)(input[94] & 0xf0) << 12);
	output[46] = (double)(value >> 16);

	// read output[47]: from bit 756 to 771
	value = ((uint32_t)(input[94] & 0x0f) << 28) |
			((uint32_t)input[95] << 20) |
			((uint32_t)(input[96] & 0xf0) << 12);
	output[47] = (double)(value >> 16);

	// read output[48]: from bit 772 to 787
	value = ((uint32_t)(input[96] & 0x0f) << 28) |
			((uint32_t)input[97] << 20) |
			((uint32_t)(input[98] & 0xf0) << 12);
	output[48] = (double)(value >> 16);
}

static void unpack_49_16bit_signed_5off(const uint8_t * input, double * output, void *closure) {
	// Unpack 49 values into output
	// Values are 16-bit signed
	// Skip 5 bits, read 784 bits of data.
	// Input must be at least 99 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 5 to 20
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)(input[2] & 0xf8) << 13);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 21 to 36
	value = ((uint32_t)(input[2] & 0x07) << 29) |
			((uint32_t)input[3] << 21) |
			((uint32_t)(input[4] & 0xf8) << 13);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 37 to 52
	value = ((uint32_t)(input[4] & 0x07) << 29) |
			((uint32_t)input[5] << 21) |
			((uint32_t)(input[6] & 0xf8) << 13);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 53 to 68
	value = ((uint32_t)(input[6] & 0x07) << 29) |
			((uint32_t)input[7] << 21) |
			((uint32_t)(input[8] & 0xf8) << 13);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 69 to 84
	value = ((uint32_t)(input[8] & 0x07) << 29) |
			((uint32_t)input[9] << 21) |
			((uint32_t)(input[10] & 0xf8) << 13);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 85 to 100
	value = ((uint32_t)(input[10] & 0x07) << 29) |
			((uint32_t)input[11] << 21) |
			((uint32_t)(input[12] & 0xf8) << 13);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 101 to 116
	value = ((uint32_t)(input[12] & 0x07) << 29) |
			((uint32_t)input[13] << 21) |
			((uint32_t)(input[14] & 0xf8) << 13);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 117 to 132
	value = ((uint32_t)(input[14] & 0x07) << 29) |
			((uint32_t)input[15] << 21) |
			((uint32_t)(input[16] & 0xf8) << 13);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 133 to 148
	value = ((uint32_t)(input[16] & 0x07) << 29) |
			((uint32_t)input[17] << 21) |
			((uint32_t)(input[18] & 0xf8) << 13);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 149 to 164
	value = ((uint32_t)(input[18] & 0x07) << 29) |
			((uint32_t)input[19] << 21) |
			((uint32_t)(input[20] & 0xf8) << 13);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 165 to 180
	value = ((uint32_t)(input[20] & 0x07) << 29) |
			((uint32_t)input[21] << 21) |
			((uint32_t)(input[22] & 0xf8) << 13);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 181 to 196
	value = ((uint32_t)(input[22] & 0x07) << 29) |
			((uint32_t)input[23] << 21) |
			((uint32_t)(input[24] & 0xf8) << 13);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 197 to 212
	value = ((uint32_t)(input[24] & 0x07) << 29) |
			((uint32_t)input[25] << 21) |
			((uint32_t)(input[26] & 0xf8) << 13);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 213 to 228
	value = ((uint32_t)(input[26] & 0x07) << 29) |
			((uint32_t)input[27] << 21) |
			((uint32_t)(input[28] & 0xf8) << 13);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 229 to 244
	value = ((uint32_t)(input[28] & 0x07) << 29) |
			((uint32_t)input[29] << 21) |
			((uint32_t)(input[30] & 0xf8) << 13);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 245 to 260
	value = ((uint32_t)(input[30] & 0x07) << 29) |
			((uint32_t)input[31] << 21) |
			((uint32_t)(input[32] & 0xf8) << 13);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 261 to 276
	value = ((uint32_t)(input[32] & 0x07) << 29) |
			((uint32_t)input[33] << 21) |
			((uint32_t)(input[34] & 0xf8) << 13);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 277 to 292
	value = ((uint32_t)(input[34] & 0x07) << 29) |
			((uint32_t)input[35] << 21) |
			((uint32_t)(input[36] & 0xf8) << 13);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 293 to 308
	value = ((uint32_t)(input[36] & 0x07) << 29) |
			((uint32_t)input[37] << 21) |
			((uint32_t)(input[38] & 0xf8) << 13);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 309 to 324
	value = ((uint32_t)(input[38] & 0x07) << 29) |
			((uint32_t)input[39] << 21) |
			((uint32_t)(input[40] & 0xf8) << 13);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 325 to 340
	value = ((uint32_t)(input[40] & 0x07) << 29) |
			((uint32_t)input[41] << 21) |
			((uint32_t)(input[42] & 0xf8) << 13);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 341 to 356
	value = ((uint32_t)(input[42] & 0x07) << 29) |
			((uint32_t)input[43] << 21) |
			((uint32_t)(input[44] & 0xf8) << 13);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 357 to 372
	value = ((uint32_t)(input[44] & 0x07) << 29) |
			((uint32_t)input[45] << 21) |
			((uint32_t)(input[46] & 0xf8) << 13);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 373 to 388
	value = ((uint32_t)(input[46] & 0x07) << 29) |
			((uint32_t)input[47] << 21) |
			((uint32_t)(input[48] & 0xf8) << 13);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 389 to 404
	value = ((uint32_t)(input[48] & 0x07) << 29) |
			((uint32_t)input[49] << 21) |
			((uint32_t)(input[50] & 0xf8) << 13);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 405 to 420
	value = ((uint32_t)(input[50] & 0x07) << 29) |
			((uint32_t)input[51] << 21) |
			((uint32_t)(input[52] & 0xf8) << 13);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 421 to 436
	value = ((uint32_t)(input[52] & 0x07) << 29) |
			((uint32_t)input[53] << 21) |
			((uint32_t)(input[54] & 0xf8) << 13);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 437 to 452
	value = ((uint32_t)(input[54] & 0x07) << 29) |
			((uint32_t)input[55] << 21) |
			((uint32_t)(input[56] & 0xf8) << 13);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 453 to 468
	value = ((uint32_t)(input[56] & 0x07) << 29) |
			((uint32_t)input[57] << 21) |
			((uint32_t)(input[58] & 0xf8) << 13);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 469 to 484
	value = ((uint32_t)(input[58] & 0x07) << 29) |
			((uint32_t)input[59] << 21) |
			((uint32_t)(input[60] & 0xf8) << 13);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 485 to 500
	value = ((uint32_t)(input[60] & 0x07) << 29) |
			((uint32_t)input[61] << 21) |
			((uint32_t)(input[62] & 0xf8) << 13);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 501 to 516
	value = ((uint32_t)(input[62] & 0x07) << 29) |
			((uint32_t)input[63] << 21) |
			((uint32_t)(input[64] & 0xf8) << 13);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 517 to 532
	value = ((uint32_t)(input[64] & 0x07) << 29) |
			((uint32_t)input[65] << 21) |
			((uint32_t)(input[66] & 0xf8) << 13);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 533 to 548
	value = ((uint32_t)(input[66] & 0x07) << 29) |
			((uint32_t)input[67] << 21) |
			((uint32_t)(input[68] & 0xf8) << 13);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 549 to 564
	value = ((uint32_t)(input[68] & 0x07) << 29) |
			((uint32_t)input[69] << 21) |
			((uint32_t)(input[70] & 0xf8) << 13);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 565 to 580
	value = ((uint32_t)(input[70] & 0x07) << 29) |
			((uint32_t)input[71] << 21) |
			((uint32_t)(input[72] & 0xf8) << 13);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 581 to 596
	value = ((uint32_t)(input[72] & 0x07) << 29) |
			((uint32_t)input[73] << 21) |
			((uint32_t)(input[74] & 0xf8) << 13);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 597 to 612
	value = ((uint32_t)(input[74] & 0x07) << 29) |
			((uint32_t)input[75] << 21) |
			((uint32_t)(input[76] & 0xf8) << 13);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 613 to 628
	value = ((uint32_t)(input[76] & 0x07) << 29) |
			((uint32_t)input[77] << 21) |
			((uint32_t)(input[78] & 0xf8) << 13);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 629 to 644
	value = ((uint32_t)(input[78] & 0x07) << 29) |
			((uint32_t)input[79] << 21) |
			((uint32_t)(input[80] & 0xf8) << 13);
	output[39] = (double)(value >> 16);

	// read output[40]: from bit 645 to 660
	value = ((uint32_t)(input[80] & 0x07) << 29) |
			((uint32_t)input[81] << 21) |
			((uint32_t)(input[82] & 0xf8) << 13);
	output[40] = (double)(value >> 16);

	// read output[41]: from bit 661 to 676
	value = ((uint32_t)(input[82] & 0x07) << 29) |
			((uint32_t)input[83] << 21) |
			((uint32_t)(input[84] & 0xf8) << 13);
	output[41] = (double)(value >> 16);

	// read output[42]: from bit 677 to 692
	value = ((uint32_t)(input[84] & 0x07) << 29) |
			((uint32_t)input[85] << 21) |
			((uint32_t)(input[86] & 0xf8) << 13);
	output[42] = (double)(value >> 16);

	// read output[43]: from bit 693 to 708
	value = ((uint32_t)(input[86] & 0x07) << 29) |
			((uint32_t)input[87] << 21) |
			((uint32_t)(input[88] & 0xf8) << 13);
	output[43] = (double)(value >> 16);

	// read output[44]: from bit 709 to 724
	value = ((uint32_t)(input[88] & 0x07) << 29) |
			((uint32_t)input[89] << 21) |
			((uint32_t)(input[90] & 0xf8) << 13);
	output[44] = (double)(value >> 16);

	// read output[45]: from bit 725 to 740
	value = ((uint32_t)(input[90] & 0x07) << 29) |
			((uint32_t)input[91] << 21) |
			((uint32_t)(input[92] & 0xf8) << 13);
	output[45] = (double)(value >> 16);

	// read output[46]: from bit 741 to 756
	value = ((uint32_t)(input[92] & 0x07) << 29) |
			((uint32_t)input[93] << 21) |
			((uint32_t)(input[94] & 0xf8) << 13);
	output[46] = (double)(value >> 16);

	// read output[47]: from bit 757 to 772
	value = ((uint32_t)(input[94] & 0x07) << 29) |
			((uint32_t)input[95] << 21) |
			((uint32_t)(input[96] & 0xf8) << 13);
	output[47] = (double)(value >> 16);

	// read output[48]: from bit 773 to 788
	value = ((uint32_t)(input[96] & 0x07) << 29) |
			((uint32_t)input[97] << 21) |
			((uint32_t)(input[98] & 0xf8) << 13);
	output[48] = (double)(value >> 16);
}

static void unpack_49_16bit_unsigned_5off(const uint8_t * input, double * output, void *closure) {
	// Unpack 49 values into output
	// Values are 16-bit unsigned
	// Skip 5 bits, read 784 bits of data.
	// Input must be at least 99 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 5 to 20
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)(input[2] & 0xf8) << 13);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 21 to 36
	value = ((uint32_t)(input[2] & 0x07) << 29) |
			((uint32_t)input[3] << 21) |
			((uint32_t)(input[4] & 0xf8) << 13);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 37 to 52
	value = ((uint32_t)(input[4] & 0x07) << 29) |
			((uint32_t)input[5] << 21) |
			((uint32_t)(input[6] & 0xf8) << 13);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 53 to 68
	value = ((uint32_t)(input[6] & 0x07) << 29) |
			((uint32_t)input[7] << 21) |
			((uint32_t)(input[8] & 0xf8) << 13);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 69 to 84
	value = ((uint32_t)(input[8] & 0x07) << 29) |
			((uint32_t)input[9] << 21) |
			((uint32_t)(input[10] & 0xf8) << 13);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 85 to 100
	value = ((uint32_t)(input[10] & 0x07) << 29) |
			((uint32_t)input[11] << 21) |
			((uint32_t)(input[12] & 0xf8) << 13);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 101 to 116
	value = ((uint32_t)(input[12] & 0x07) << 29) |
			((uint32_t)input[13] << 21) |
			((uint32_t)(input[14] & 0xf8) << 13);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 117 to 132
	value = ((uint32_t)(input[14] & 0x07) << 29) |
			((uint32_t)input[15] << 21) |
			((uint32_t)(input[16] & 0xf8) << 13);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 133 to 148
	value = ((uint32_t)(input[16] & 0x07) << 29) |
			((uint32_t)input[17] << 21) |
			((uint32_t)(input[18] & 0xf8) << 13);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 149 to 164
	value = ((uint32_t)(input[18] & 0x07) << 29) |
			((uint32_t)input[19] << 21) |
			((uint32_t)(input[20] & 0xf8) << 13);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 165 to 180
	value = ((uint32_t)(input[20] & 0x07) << 29) |
			((uint32_t)input[21] << 21) |
			((uint32_t)(input[22] & 0xf8) << 13);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 181 to 196
	value = ((uint32_t)(input[22] & 0x07) << 29) |
			((uint32_t)input[23] << 21) |
			((uint32_t)(input[24] & 0xf8) << 13);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 197 to 212
	value = ((uint32_t)(input[24] & 0x07) << 29) |
			((uint32_t)input[25] << 21) |
			((uint32_t)(input[26] & 0xf8) << 13);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 213 to 228
	value = ((uint32_t)(input[26] & 0x07) << 29) |
			((uint32_t)input[27] << 21) |
			((uint32_t)(input[28] & 0xf8) << 13);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 229 to 244
	value = ((uint32_t)(input[28] & 0x07) << 29) |
			((uint32_t)input[29] << 21) |
			((uint32_t)(input[30] & 0xf8) << 13);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 245 to 260
	value = ((uint32_t)(input[30] & 0x07) << 29) |
			((uint32_t)input[31] << 21) |
			((uint32_t)(input[32] & 0xf8) << 13);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 261 to 276
	value = ((uint32_t)(input[32] & 0x07) << 29) |
			((uint32_t)input[33] << 21) |
			((uint32_t)(input[34] & 0xf8) << 13);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 277 to 292
	value = ((uint32_t)(input[34] & 0x07) << 29) |
			((uint32_t)input[35] << 21) |
			((uint32_t)(input[36] & 0xf8) << 13);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 293 to 308
	value = ((uint32_t)(input[36] & 0x07) << 29) |
			((uint32_t)input[37] << 21) |
			((uint32_t)(input[38] & 0xf8) << 13);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 309 to 324
	value = ((uint32_t)(input[38] & 0x07) << 29) |
			((uint32_t)input[39] << 21) |
			((uint32_t)(input[40] & 0xf8) << 13);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 325 to 340
	value = ((uint32_t)(input[40] & 0x07) << 29) |
			((uint32_t)input[41] << 21) |
			((uint32_t)(input[42] & 0xf8) << 13);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 341 to 356
	value = ((uint32_t)(input[42] & 0x07) << 29) |
			((uint32_t)input[43] << 21) |
			((uint32_t)(input[44] & 0xf8) << 13);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 357 to 372
	value = ((uint32_t)(input[44] & 0x07) << 29) |
			((uint32_t)input[45] << 21) |
			((uint32_t)(input[46] & 0xf8) << 13);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 373 to 388
	value = ((uint32_t)(input[46] & 0x07) << 29) |
			((uint32_t)input[47] << 21) |
			((uint32_t)(input[48] & 0xf8) << 13);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 389 to 404
	value = ((uint32_t)(input[48] & 0x07) << 29) |
			((uint32_t)input[49] << 21) |
			((uint32_t)(input[50] & 0xf8) << 13);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 405 to 420
	value = ((uint32_t)(input[50] & 0x07) << 29) |
			((uint32_t)input[51] << 21) |
			((uint32_t)(input[52] & 0xf8) << 13);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 421 to 436
	value = ((uint32_t)(input[52] & 0x07) << 29) |
			((uint32_t)input[53] << 21) |
			((uint32_t)(input[54] & 0xf8) << 13);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 437 to 452
	value = ((uint32_t)(input[54] & 0x07) << 29) |
			((uint32_t)input[55] << 21) |
			((uint32_t)(input[56] & 0xf8) << 13);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 453 to 468
	value = ((uint32_t)(input[56] & 0x07) << 29) |
			((uint32_t)input[57] << 21) |
			((uint32_t)(input[58] & 0xf8) << 13);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 469 to 484
	value = ((uint32_t)(input[58] & 0x07) << 29) |
			((uint32_t)input[59] << 21) |
			((uint32_t)(input[60] & 0xf8) << 13);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 485 to 500
	value = ((uint32_t)(input[60] & 0x07) << 29) |
			((uint32_t)input[61] << 21) |
			((uint32_t)(input[62] & 0xf8) << 13);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 501 to 516
	value = ((uint32_t)(input[62] & 0x07) << 29) |
			((uint32_t)input[63] << 21) |
			((uint32_t)(input[64] & 0xf8) << 13);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 517 to 532
	value = ((uint32_t)(input[64] & 0x07) << 29) |
			((uint32_t)input[65] << 21) |
			((uint32_t)(input[66] & 0xf8) << 13);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 533 to 548
	value = ((uint32_t)(input[66] & 0x07) << 29) |
			((uint32_t)input[67] << 21) |
			((uint32_t)(input[68] & 0xf8) << 13);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 549 to 564
	value = ((uint32_t)(input[68] & 0x07) << 29) |
			((uint32_t)input[69] << 21) |
			((uint32_t)(input[70] & 0xf8) << 13);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 565 to 580
	value = ((uint32_t)(input[70] & 0x07) << 29) |
			((uint32_t)input[71] << 21) |
			((uint32_t)(input[72] & 0xf8) << 13);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 581 to 596
	value = ((uint32_t)(input[72] & 0x07) << 29) |
			((uint32_t)input[73] << 21) |
			((uint32_t)(input[74] & 0xf8) << 13);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 597 to 612
	value = ((uint32_t)(input[74] & 0x07) << 29) |
			((uint32_t)input[75] << 21) |
			((uint32_t)(input[76] & 0xf8) << 13);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 613 to 628
	value = ((uint32_t)(input[76] & 0x07) << 29) |
			((uint32_t)input[77] << 21) |
			((uint32_t)(input[78] & 0xf8) << 13);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 629 to 644
	value = ((uint32_t)(input[78] & 0x07) << 29) |
			((uint32_t)input[79] << 21) |
			((uint32_t)(input[80] & 0xf8) << 13);
	output[39] = (double)(value >> 16);

	// read output[40]: from bit 645 to 660
	value = ((uint32_t)(input[80] & 0x07) << 29) |
			((uint32_t)input[81] << 21) |
			((uint32_t)(input[82] & 0xf8) << 13);
	output[40] = (double)(value >> 16);

	// read output[41]: from bit 661 to 676
	value = ((uint32_t)(input[82] & 0x07) << 29) |
			((uint32_t)input[83] << 21) |
			((uint32_t)(input[84] & 0xf8) << 13);
	output[41] = (double)(value >> 16);

	// read output[42]: from bit 677 to 692
	value = ((uint32_t)(input[84] & 0x07) << 29) |
			((uint32_t)input[85] << 21) |
			((uint32_t)(input[86] & 0xf8) << 13);
	output[42] = (double)(value >> 16);

	// read output[43]: from bit 693 to 708
	value = ((uint32_t)(input[86] & 0x07) << 29) |
			((uint32_t)input[87] << 21) |
			((uint32_t)(input[88] & 0xf8) << 13);
	output[43] = (double)(value >> 16);

	// read output[44]: from bit 709 to 724
	value = ((uint32_t)(input[88] & 0x07) << 29) |
			((uint32_t)input[89] << 21) |
			((uint32_t)(input[90] & 0xf8) << 13);
	output[44] = (double)(value >> 16);

	// read output[45]: from bit 725 to 740
	value = ((uint32_t)(input[90] & 0x07) << 29) |
			((uint32_t)input[91] << 21) |
			((uint32_t)(input[92] & 0xf8) << 13);
	output[45] = (double)(value >> 16);

	// read output[46]: from bit 741 to 756
	value = ((uint32_t)(input[92] & 0x07) << 29) |
			((uint32_t)input[93] << 21) |
			((uint32_t)(input[94] & 0xf8) << 13);
	output[46] = (double)(value >> 16);

	// read output[47]: from bit 757 to 772
	value = ((uint32_t)(input[94] & 0x07) << 29) |
			((uint32_t)input[95] << 21) |
			((uint32_t)(input[96] & 0xf8) << 13);
	output[47] = (double)(value >> 16);

	// read output[48]: from bit 773 to 788
	value = ((uint32_t)(input[96] & 0x07) << 29) |
			((uint32_t)input[97] << 21) |
			((uint32_t)(input[98] & 0xf8) << 13);
	output[48] = (double)(value >> 16);
}

static void unpack_49_16bit_signed_6off(const uint8_t * input, double * output, void *closure) {
	// Unpack 49 values into output
	// Values are 16-bit signed
	// Skip 6 bits, read 784 bits of data.
	// Input must be at least 99 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 6 to 21
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)(input[2] & 0xfc) << 14);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 22 to 37
	value = ((uint32_t)(input[2] & 0x03) << 30) |
			((uint32_t)input[3] << 22) |
			((uint32_t)(input[4] & 0xfc) << 14);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 38 to 53
	value = ((uint32_t)(input[4] & 0x03) << 30) |
			((uint32_t)input[5] << 22) |
			((uint32_t)(input[6] & 0xfc) << 14);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 54 to 69
	value = ((uint32_t)(input[6] & 0x03) << 30) |
			((uint32_t)input[7] << 22) |
			((uint32_t)(input[8] & 0xfc) << 14);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 70 to 85
	value = ((uint32_t)(input[8] & 0x03) << 30) |
			((uint32_t)input[9] << 22) |
			((uint32_t)(input[10] & 0xfc) << 14);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 86 to 101
	value = ((uint32_t)(input[10] & 0x03) << 30) |
			((uint32_t)input[11] << 22) |
			((uint32_t)(input[12] & 0xfc) << 14);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 102 to 117
	value = ((uint32_t)(input[12] & 0x03) << 30) |
			((uint32_t)input[13] << 22) |
			((uint32_t)(input[14] & 0xfc) << 14);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 118 to 133
	value = ((uint32_t)(input[14] & 0x03) << 30) |
			((uint32_t)input[15] << 22) |
			((uint32_t)(input[16] & 0xfc) << 14);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 134 to 149
	value = ((uint32_t)(input[16] & 0x03) << 30) |
			((uint32_t)input[17] << 22) |
			((uint32_t)(input[18] & 0xfc) << 14);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 150 to 165
	value = ((uint32_t)(input[18] & 0x03) << 30) |
			((uint32_t)input[19] << 22) |
			((uint32_t)(input[20] & 0xfc) << 14);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 166 to 181
	value = ((uint32_t)(input[20] & 0x03) << 30) |
			((uint32_t)input[21] << 22) |
			((uint32_t)(input[22] & 0xfc) << 14);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 182 to 197
	value = ((uint32_t)(input[22] & 0x03) << 30) |
			((uint32_t)input[23] << 22) |
			((uint32_t)(input[24] & 0xfc) << 14);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 198 to 213
	value = ((uint32_t)(input[24] & 0x03) << 30) |
			((uint32_t)input[25] << 22) |
			((uint32_t)(input[26] & 0xfc) << 14);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 214 to 229
	value = ((uint32_t)(input[26] & 0x03) << 30) |
			((uint32_t)input[27] << 22) |
			((uint32_t)(input[28] & 0xfc) << 14);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 230 to 245
	value = ((uint32_t)(input[28] & 0x03) << 30) |
			((uint32_t)input[29] << 22) |
			((uint32_t)(input[30] & 0xfc) << 14);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 246 to 261
	value = ((uint32_t)(input[30] & 0x03) << 30) |
			((uint32_t)input[31] << 22) |
			((uint32_t)(input[32] & 0xfc) << 14);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 262 to 277
	value = ((uint32_t)(input[32] & 0x03) << 30) |
			((uint32_t)input[33] << 22) |
			((uint32_t)(input[34] & 0xfc) << 14);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 278 to 293
	value = ((uint32_t)(input[34] & 0x03) << 30) |
			((uint32_t)input[35] << 22) |
			((uint32_t)(input[36] & 0xfc) << 14);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 294 to 309
	value = ((uint32_t)(input[36] & 0x03) << 30) |
			((uint32_t)input[37] << 22) |
			((uint32_t)(input[38] & 0xfc) << 14);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 310 to 325
	value = ((uint32_t)(input[38] & 0x03) << 30) |
			((uint32_t)input[39] << 22) |
			((uint32_t)(input[40] & 0xfc) << 14);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 326 to 341
	value = ((uint32_t)(input[40] & 0x03) << 30) |
			((uint32_t)input[41] << 22) |
			((uint32_t)(input[42] & 0xfc) << 14);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 342 to 357
	value = ((uint32_t)(input[42] & 0x03) << 30) |
			((uint32_t)input[43] << 22) |
			((uint32_t)(input[44] & 0xfc) << 14);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 358 to 373
	value = ((uint32_t)(input[44] & 0x03) << 30) |
			((uint32_t)input[45] << 22) |
			((uint32_t)(input[46] & 0xfc) << 14);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 374 to 389
	value = ((uint32_t)(input[46] & 0x03) << 30) |
			((uint32_t)input[47] << 22) |
			((uint32_t)(input[48] & 0xfc) << 14);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 390 to 405
	value = ((uint32_t)(input[48] & 0x03) << 30) |
			((uint32_t)input[49] << 22) |
			((uint32_t)(input[50] & 0xfc) << 14);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 406 to 421
	value = ((uint32_t)(input[50] & 0x03) << 30) |
			((uint32_t)input[51] << 22) |
			((uint32_t)(input[52] & 0xfc) << 14);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 422 to 437
	value = ((uint32_t)(input[52] & 0x03) << 30) |
			((uint32_t)input[53] << 22) |
			((uint32_t)(input[54] & 0xfc) << 14);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 438 to 453
	value = ((uint32_t)(input[54] & 0x03) << 30) |
			((uint32_t)input[55] << 22) |
			((uint32_t)(input[56] & 0xfc) << 14);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 454 to 469
	value = ((uint32_t)(input[56] & 0x03) << 30) |
			((uint32_t)input[57] << 22) |
			((uint32_t)(input[58] & 0xfc) << 14);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 470 to 485
	value = ((uint32_t)(input[58] & 0x03) << 30) |
			((uint32_t)input[59] << 22) |
			((uint32_t)(input[60] & 0xfc) << 14);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 486 to 501
	value = ((uint32_t)(input[60] & 0x03) << 30) |
			((uint32_t)input[61] << 22) |
			((uint32_t)(input[62] & 0xfc) << 14);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 502 to 517
	value = ((uint32_t)(input[62] & 0x03) << 30) |
			((uint32_t)input[63] << 22) |
			((uint32_t)(input[64] & 0xfc) << 14);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 518 to 533
	value = ((uint32_t)(input[64] & 0x03) << 30) |
			((uint32_t)input[65] << 22) |
			((uint32_t)(input[66] & 0xfc) << 14);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 534 to 549
	value = ((uint32_t)(input[66] & 0x03) << 30) |
			((uint32_t)input[67] << 22) |
			((uint32_t)(input[68] & 0xfc) << 14);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 550 to 565
	value = ((uint32_t)(input[68] & 0x03) << 30) |
			((uint32_t)input[69] << 22) |
			((uint32_t)(input[70] & 0xfc) << 14);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 566 to 581
	value = ((uint32_t)(input[70] & 0x03) << 30) |
			((uint32_t)input[71] << 22) |
			((uint32_t)(input[72] & 0xfc) << 14);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 582 to 597
	value = ((uint32_t)(input[72] & 0x03) << 30) |
			((uint32_t)input[73] << 22) |
			((uint32_t)(input[74] & 0xfc) << 14);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 598 to 613
	value = ((uint32_t)(input[74] & 0x03) << 30) |
			((uint32_t)input[75] << 22) |
			((uint32_t)(input[76] & 0xfc) << 14);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 614 to 629
	value = ((uint32_t)(input[76] & 0x03) << 30) |
			((uint32_t)input[77] << 22) |
			((uint32_t)(input[78] & 0xfc) << 14);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 630 to 645
	value = ((uint32_t)(input[78] & 0x03) << 30) |
			((uint32_t)input[79] << 22) |
			((uint32_t)(input[80] & 0xfc) << 14);
	output[39] = (double)(value >> 16);

	// read output[40]: from bit 646 to 661
	value = ((uint32_t)(input[80] & 0x03) << 30) |
			((uint32_t)input[81] << 22) |
			((uint32_t)(input[82] & 0xfc) << 14);
	output[40] = (double)(value >> 16);

	// read output[41]: from bit 662 to 677
	value = ((uint32_t)(input[82] & 0x03) << 30) |
			((uint32_t)input[83] << 22) |
			((uint32_t)(input[84] & 0xfc) << 14);
	output[41] = (double)(value >> 16);

	// read output[42]: from bit 678 to 693
	value = ((uint32_t)(input[84] & 0x03) << 30) |
			((uint32_t)input[85] << 22) |
			((uint32_t)(input[86] & 0xfc) << 14);
	output[42] = (double)(value >> 16);

	// read output[43]: from bit 694 to 709
	value = ((uint32_t)(input[86] & 0x03) << 30) |
			((uint32_t)input[87] << 22) |
			((uint32_t)(input[88] & 0xfc) << 14);
	output[43] = (double)(value >> 16);

	// read output[44]: from bit 710 to 725
	value = ((uint32_t)(input[88] & 0x03) << 30) |
			((uint32_t)input[89] << 22) |
			((uint32_t)(input[90] & 0xfc) << 14);
	output[44] = (double)(value >> 16);

	// read output[45]: from bit 726 to 741
	value = ((uint32_t)(input[90] & 0x03) << 30) |
			((uint32_t)input[91] << 22) |
			((uint32_t)(input[92] & 0xfc) << 14);
	output[45] = (double)(value >> 16);

	// read output[46]: from bit 742 to 757
	value = ((uint32_t)(input[92] & 0x03) << 30) |
			((uint32_t)input[93] << 22) |
			((uint32_t)(input[94] & 0xfc) << 14);
	output[46] = (double)(value >> 16);

	// read output[47]: from bit 758 to 773
	value = ((uint32_t)(input[94] & 0x03) << 30) |
			((uint32_t)input[95] << 22) |
			((uint32_t)(input[96] & 0xfc) << 14);
	output[47] = (double)(value >> 16);

	// read output[48]: from bit 774 to 789
	value = ((uint32_t)(input[96] & 0x03) << 30) |
			((uint32_t)input[97] << 22) |
			((uint32_t)(input[98] & 0xfc) << 14);
	output[48] = (double)(value >> 16);
}

static void unpack_49_16bit_unsigned_6off(const uint8_t * input, double * output, void *closure) {
	// Unpack 49 values into output
	// Values are 16-bit unsigned
	// Skip 6 bits, read 784 bits of data.
	// Input must be at least 99 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 6 to 21
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)(input[2] & 0xfc) << 14);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 22 to 37
	value = ((uint32_t)(input[2] & 0x03) << 30) |
			((uint32_t)input[3] << 22) |
			((uint32_t)(input[4] & 0xfc) << 14);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 38 to 53
	value = ((uint32_t)(input[4] & 0x03) << 30) |
			((uint32_t)input[5] << 22) |
			((uint32_t)(input[6] & 0xfc) << 14);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 54 to 69
	value = ((uint32_t)(input[6] & 0x03) << 30) |
			((uint32_t)input[7] << 22) |
			((uint32_t)(input[8] & 0xfc) << 14);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 70 to 85
	value = ((uint32_t)(input[8] & 0x03) << 30) |
			((uint32_t)input[9] << 22) |
			((uint32_t)(input[10] & 0xfc) << 14);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 86 to 101
	value = ((uint32_t)(input[10] & 0x03) << 30) |
			((uint32_t)input[11] << 22) |
			((uint32_t)(input[12] & 0xfc) << 14);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 102 to 117
	value = ((uint32_t)(input[12] & 0x03) << 30) |
			((uint32_t)input[13] << 22) |
			((uint32_t)(input[14] & 0xfc) << 14);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 118 to 133
	value = ((uint32_t)(input[14] & 0x03) << 30) |
			((uint32_t)input[15] << 22) |
			((uint32_t)(input[16] & 0xfc) << 14);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 134 to 149
	value = ((uint32_t)(input[16] & 0x03) << 30) |
			((uint32_t)input[17] << 22) |
			((uint32_t)(input[18] & 0xfc) << 14);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 150 to 165
	value = ((uint32_t)(input[18] & 0x03) << 30) |
			((uint32_t)input[19] << 22) |
			((uint32_t)(input[20] & 0xfc) << 14);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 166 to 181
	value = ((uint32_t)(input[20] & 0x03) << 30) |
			((uint32_t)input[21] << 22) |
			((uint32_t)(input[22] & 0xfc) << 14);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 182 to 197
	value = ((uint32_t)(input[22] & 0x03) << 30) |
			((uint32_t)input[23] << 22) |
			((uint32_t)(input[24] & 0xfc) << 14);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 198 to 213
	value = ((uint32_t)(input[24] & 0x03) << 30) |
			((uint32_t)input[25] << 22) |
			((uint32_t)(input[26] & 0xfc) << 14);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 214 to 229
	value = ((uint32_t)(input[26] & 0x03) << 30) |
			((uint32_t)input[27] << 22) |
			((uint32_t)(input[28] & 0xfc) << 14);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 230 to 245
	value = ((uint32_t)(input[28] & 0x03) << 30) |
			((uint32_t)input[29] << 22) |
			((uint32_t)(input[30] & 0xfc) << 14);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 246 to 261
	value = ((uint32_t)(input[30] & 0x03) << 30) |
			((uint32_t)input[31] << 22) |
			((uint32_t)(input[32] & 0xfc) << 14);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 262 to 277
	value = ((uint32_t)(input[32] & 0x03) << 30) |
			((uint32_t)input[33] << 22) |
			((uint32_t)(input[34] & 0xfc) << 14);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 278 to 293
	value = ((uint32_t)(input[34] & 0x03) << 30) |
			((uint32_t)input[35] << 22) |
			((uint32_t)(input[36] & 0xfc) << 14);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 294 to 309
	value = ((uint32_t)(input[36] & 0x03) << 30) |
			((uint32_t)input[37] << 22) |
			((uint32_t)(input[38] & 0xfc) << 14);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 310 to 325
	value = ((uint32_t)(input[38] & 0x03) << 30) |
			((uint32_t)input[39] << 22) |
			((uint32_t)(input[40] & 0xfc) << 14);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 326 to 341
	value = ((uint32_t)(input[40] & 0x03) << 30) |
			((uint32_t)input[41] << 22) |
			((uint32_t)(input[42] & 0xfc) << 14);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 342 to 357
	value = ((uint32_t)(input[42] & 0x03) << 30) |
			((uint32_t)input[43] << 22) |
			((uint32_t)(input[44] & 0xfc) << 14);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 358 to 373
	value = ((uint32_t)(input[44] & 0x03) << 30) |
			((uint32_t)input[45] << 22) |
			((uint32_t)(input[46] & 0xfc) << 14);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 374 to 389
	value = ((uint32_t)(input[46] & 0x03) << 30) |
			((uint32_t)input[47] << 22) |
			((uint32_t)(input[48] & 0xfc) << 14);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 390 to 405
	value = ((uint32_t)(input[48] & 0x03) << 30) |
			((uint32_t)input[49] << 22) |
			((uint32_t)(input[50] & 0xfc) << 14);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 406 to 421
	value = ((uint32_t)(input[50] & 0x03) << 30) |
			((uint32_t)input[51] << 22) |
			((uint32_t)(input[52] & 0xfc) << 14);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 422 to 437
	value = ((uint32_t)(input[52] & 0x03) << 30) |
			((uint32_t)input[53] << 22) |
			((uint32_t)(input[54] & 0xfc) << 14);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 438 to 453
	value = ((uint32_t)(input[54] & 0x03) << 30) |
			((uint32_t)input[55] << 22) |
			((uint32_t)(input[56] & 0xfc) << 14);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 454 to 469
	value = ((uint32_t)(input[56] & 0x03) << 30) |
			((uint32_t)input[57] << 22) |
			((uint32_t)(input[58] & 0xfc) << 14);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 470 to 485
	value = ((uint32_t)(input[58] & 0x03) << 30) |
			((uint32_t)input[59] << 22) |
			((uint32_t)(input[60] & 0xfc) << 14);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 486 to 501
	value = ((uint32_t)(input[60] & 0x03) << 30) |
			((uint32_t)input[61] << 22) |
			((uint32_t)(input[62] & 0xfc) << 14);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 502 to 517
	value = ((uint32_t)(input[62] & 0x03) << 30) |
			((uint32_t)input[63] << 22) |
			((uint32_t)(input[64] & 0xfc) << 14);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 518 to 533
	value = ((uint32_t)(input[64] & 0x03) << 30) |
			((uint32_t)input[65] << 22) |
			((uint32_t)(input[66] & 0xfc) << 14);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 534 to 549
	value = ((uint32_t)(input[66] & 0x03) << 30) |
			((uint32_t)input[67] << 22) |
			((uint32_t)(input[68] & 0xfc) << 14);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 550 to 565
	value = ((uint32_t)(input[68] & 0x03) << 30) |
			((uint32_t)input[69] << 22) |
			((uint32_t)(input[70] & 0xfc) << 14);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 566 to 581
	value = ((uint32_t)(input[70] & 0x03) << 30) |
			((uint32_t)input[71] << 22) |
			((uint32_t)(input[72] & 0xfc) << 14);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 582 to 597
	value = ((uint32_t)(input[72] & 0x03) << 30) |
			((uint32_t)input[73] << 22) |
			((uint32_t)(input[74] & 0xfc) << 14);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 598 to 613
	value = ((uint32_t)(input[74] & 0x03) << 30) |
			((uint32_t)input[75] << 22) |
			((uint32_t)(input[76] & 0xfc) << 14);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 614 to 629
	value = ((uint32_t)(input[76] & 0x03) << 30) |
			((uint32_t)input[77] << 22) |
			((uint32_t)(input[78] & 0xfc) << 14);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 630 to 645
	value = ((uint32_t)(input[78] & 0x03) << 30) |
			((uint32_t)input[79] << 22) |
			((uint32_t)(input[80] & 0xfc) << 14);
	output[39] = (double)(value >> 16);

	// read output[40]: from bit 646 to 661
	value = ((uint32_t)(input[80] & 0x03) << 30) |
			((uint32_t)input[81] << 22) |
			((uint32_t)(input[82] & 0xfc) << 14);
	output[40] = (double)(value >> 16);

	// read output[41]: from bit 662 to 677
	value = ((uint32_t)(input[82] & 0x03) << 30) |
			((uint32_t)input[83] << 22) |
			((uint32_t)(input[84] & 0xfc) << 14);
	output[41] = (double)(value >> 16);

	// read output[42]: from bit 678 to 693
	value = ((uint32_t)(input[84] & 0x03) << 30) |
			((uint32_t)input[85] << 22) |
			((uint32_t)(input[86] & 0xfc) << 14);
	output[42] = (double)(value >> 16);

	// read output[43]: from bit 694 to 709
	value = ((uint32_t)(input[86] & 0x03) << 30) |
			((uint32_t)input[87] << 22) |
			((uint32_t)(input[88] & 0xfc) << 14);
	output[43] = (double)(value >> 16);

	// read output[44]: from bit 710 to 725
	value = ((uint32_t)(input[88] & 0x03) << 30) |
			((uint32_t)input[89] << 22) |
			((uint32_t)(input[90] & 0xfc) << 14);
	output[44] = (double)(value >> 16);

	// read output[45]: from bit 726 to 741
	value = ((uint32_t)(input[90] & 0x03) << 30) |
			((uint32_t)input[91] << 22) |
			((uint32_t)(input[92] & 0xfc) << 14);
	output[45] = (double)(value >> 16);

	// read output[46]: from bit 742 to 757
	value = ((uint32_t)(input[92] & 0x03) << 30) |
			((uint32_t)input[93] << 22) |
			((uint32_t)(input[94] & 0xfc) << 14);
	output[46] = (double)(value >> 16);

	// read output[47]: from bit 758 to 773
	value = ((uint32_t)(input[94] & 0x03) << 30) |
			((uint32_t)input[95] << 22) |
			((uint32_t)(input[96] & 0xfc) << 14);
	output[47] = (double)(value >> 16);

	// read output[48]: from bit 774 to 789
	value = ((uint32_t)(input[96] & 0x03) << 30) |
			((uint32_t)input[97] << 22) |
			((uint32_t)(input[98] & 0xfc) << 14);
	output[48] = (double)(value >> 16);
}

static void unpack_49_16bit_signed_7off(const uint8_t * input, double * output, void *closure) {
	// Unpack 49 values into output
	// Values are 16-bit signed
	// Skip 7 bits, read 784 bits of data.
	// Input must be at least 99 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 7 to 22
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)(input[2] & 0xfe) << 15);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 23 to 38
	value = ((uint32_t)(input[2] & 0x01) << 31) |
			((uint32_t)input[3] << 23) |
			((uint32_t)(input[4] & 0xfe) << 15);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 39 to 54
	value = ((uint32_t)(input[4] & 0x01) << 31) |
			((uint32_t)input[5] << 23) |
			((uint32_t)(input[6] & 0xfe) << 15);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 55 to 70
	value = ((uint32_t)(input[6] & 0x01) << 31) |
			((uint32_t)input[7] << 23) |
			((uint32_t)(input[8] & 0xfe) << 15);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 71 to 86
	value = ((uint32_t)(input[8] & 0x01) << 31) |
			((uint32_t)input[9] << 23) |
			((uint32_t)(input[10] & 0xfe) << 15);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 87 to 102
	value = ((uint32_t)(input[10] & 0x01) << 31) |
			((uint32_t)input[11] << 23) |
			((uint32_t)(input[12] & 0xfe) << 15);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 103 to 118
	value = ((uint32_t)(input[12] & 0x01) << 31) |
			((uint32_t)input[13] << 23) |
			((uint32_t)(input[14] & 0xfe) << 15);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 119 to 134
	value = ((uint32_t)(input[14] & 0x01) << 31) |
			((uint32_t)input[15] << 23) |
			((uint32_t)(input[16] & 0xfe) << 15);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 135 to 150
	value = ((uint32_t)(input[16] & 0x01) << 31) |
			((uint32_t)input[17] << 23) |
			((uint32_t)(input[18] & 0xfe) << 15);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 151 to 166
	value = ((uint32_t)(input[18] & 0x01) << 31) |
			((uint32_t)input[19] << 23) |
			((uint32_t)(input[20] & 0xfe) << 15);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 167 to 182
	value = ((uint32_t)(input[20] & 0x01) << 31) |
			((uint32_t)input[21] << 23) |
			((uint32_t)(input[22] & 0xfe) << 15);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 183 to 198
	value = ((uint32_t)(input[22] & 0x01) << 31) |
			((uint32_t)input[23] << 23) |
			((uint32_t)(input[24] & 0xfe) << 15);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 199 to 214
	value = ((uint32_t)(input[24] & 0x01) << 31) |
			((uint32_t)input[25] << 23) |
			((uint32_t)(input[26] & 0xfe) << 15);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 215 to 230
	value = ((uint32_t)(input[26] & 0x01) << 31) |
			((uint32_t)input[27] << 23) |
			((uint32_t)(input[28] & 0xfe) << 15);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 231 to 246
	value = ((uint32_t)(input[28] & 0x01) << 31) |
			((uint32_t)input[29] << 23) |
			((uint32_t)(input[30] & 0xfe) << 15);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 247 to 262
	value = ((uint32_t)(input[30] & 0x01) << 31) |
			((uint32_t)input[31] << 23) |
			((uint32_t)(input[32] & 0xfe) << 15);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 263 to 278
	value = ((uint32_t)(input[32] & 0x01) << 31) |
			((uint32_t)input[33] << 23) |
			((uint32_t)(input[34] & 0xfe) << 15);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 279 to 294
	value = ((uint32_t)(input[34] & 0x01) << 31) |
			((uint32_t)input[35] << 23) |
			((uint32_t)(input[36] & 0xfe) << 15);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 295 to 310
	value = ((uint32_t)(input[36] & 0x01) << 31) |
			((uint32_t)input[37] << 23) |
			((uint32_t)(input[38] & 0xfe) << 15);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 311 to 326
	value = ((uint32_t)(input[38] & 0x01) << 31) |
			((uint32_t)input[39] << 23) |
			((uint32_t)(input[40] & 0xfe) << 15);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 327 to 342
	value = ((uint32_t)(input[40] & 0x01) << 31) |
			((uint32_t)input[41] << 23) |
			((uint32_t)(input[42] & 0xfe) << 15);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 343 to 358
	value = ((uint32_t)(input[42] & 0x01) << 31) |
			((uint32_t)input[43] << 23) |
			((uint32_t)(input[44] & 0xfe) << 15);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 359 to 374
	value = ((uint32_t)(input[44] & 0x01) << 31) |
			((uint32_t)input[45] << 23) |
			((uint32_t)(input[46] & 0xfe) << 15);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 375 to 390
	value = ((uint32_t)(input[46] & 0x01) << 31) |
			((uint32_t)input[47] << 23) |
			((uint32_t)(input[48] & 0xfe) << 15);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 391 to 406
	value = ((uint32_t)(input[48] & 0x01) << 31) |
			((uint32_t)input[49] << 23) |
			((uint32_t)(input[50] & 0xfe) << 15);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 407 to 422
	value = ((uint32_t)(input[50] & 0x01) << 31) |
			((uint32_t)input[51] << 23) |
			((uint32_t)(input[52] & 0xfe) << 15);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 423 to 438
	value = ((uint32_t)(input[52] & 0x01) << 31) |
			((uint32_t)input[53] << 23) |
			((uint32_t)(input[54] & 0xfe) << 15);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 439 to 454
	value = ((uint32_t)(input[54] & 0x01) << 31) |
			((uint32_t)input[55] << 23) |
			((uint32_t)(input[56] & 0xfe) << 15);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 455 to 470
	value = ((uint32_t)(input[56] & 0x01) << 31) |
			((uint32_t)input[57] << 23) |
			((uint32_t)(input[58] & 0xfe) << 15);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 471 to 486
	value = ((uint32_t)(input[58] & 0x01) << 31) |
			((uint32_t)input[59] << 23) |
			((uint32_t)(input[60] & 0xfe) << 15);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 487 to 502
	value = ((uint32_t)(input[60] & 0x01) << 31) |
			((uint32_t)input[61] << 23) |
			((uint32_t)(input[62] & 0xfe) << 15);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 503 to 518
	value = ((uint32_t)(input[62] & 0x01) << 31) |
			((uint32_t)input[63] << 23) |
			((uint32_t)(input[64] & 0xfe) << 15);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 519 to 534
	value = ((uint32_t)(input[64] & 0x01) << 31) |
			((uint32_t)input[65] << 23) |
			((uint32_t)(input[66] & 0xfe) << 15);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 535 to 550
	value = ((uint32_t)(input[66] & 0x01) << 31) |
			((uint32_t)input[67] << 23) |
			((uint32_t)(input[68] & 0xfe) << 15);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 551 to 566
	value = ((uint32_t)(input[68] & 0x01) << 31) |
			((uint32_t)input[69] << 23) |
			((uint32_t)(input[70] & 0xfe) << 15);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 567 to 582
	value = ((uint32_t)(input[70] & 0x01) << 31) |
			((uint32_t)input[71] << 23) |
			((uint32_t)(input[72] & 0xfe) << 15);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 583 to 598
	value = ((uint32_t)(input[72] & 0x01) << 31) |
			((uint32_t)input[73] << 23) |
			((uint32_t)(input[74] & 0xfe) << 15);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 599 to 614
	value = ((uint32_t)(input[74] & 0x01) << 31) |
			((uint32_t)input[75] << 23) |
			((uint32_t)(input[76] & 0xfe) << 15);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 615 to 630
	value = ((uint32_t)(input[76] & 0x01) << 31) |
			((uint32_t)input[77] << 23) |
			((uint32_t)(input[78] & 0xfe) << 15);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 631 to 646
	value = ((uint32_t)(input[78] & 0x01) << 31) |
			((uint32_t)input[79] << 23) |
			((uint32_t)(input[80] & 0xfe) << 15);
	output[39] = (double)(value >> 16);

	// read output[40]: from bit 647 to 662
	value = ((uint32_t)(input[80] & 0x01) << 31) |
			((uint32_t)input[81] << 23) |
			((uint32_t)(input[82] & 0xfe) << 15);
	output[40] = (double)(value >> 16);

	// read output[41]: from bit 663 to 678
	value = ((uint32_t)(input[82] & 0x01) << 31) |
			((uint32_t)input[83] << 23) |
			((uint32_t)(input[84] & 0xfe) << 15);
	output[41] = (double)(value >> 16);

	// read output[42]: from bit 679 to 694
	value = ((uint32_t)(input[84] & 0x01) << 31) |
			((uint32_t)input[85] << 23) |
			((uint32_t)(input[86] & 0xfe) << 15);
	output[42] = (double)(value >> 16);

	// read output[43]: from bit 695 to 710
	value = ((uint32_t)(input[86] & 0x01) << 31) |
			((uint32_t)input[87] << 23) |
			((uint32_t)(input[88] & 0xfe) << 15);
	output[43] = (double)(value >> 16);

	// read output[44]: from bit 711 to 726
	value = ((uint32_t)(input[88] & 0x01) << 31) |
			((uint32_t)input[89] << 23) |
			((uint32_t)(input[90] & 0xfe) << 15);
	output[44] = (double)(value >> 16);

	// read output[45]: from bit 727 to 742
	value = ((uint32_t)(input[90] & 0x01) << 31) |
			((uint32_t)input[91] << 23) |
			((uint32_t)(input[92] & 0xfe) << 15);
	output[45] = (double)(value >> 16);

	// read output[46]: from bit 743 to 758
	value = ((uint32_t)(input[92] & 0x01) << 31) |
			((uint32_t)input[93] << 23) |
			((uint32_t)(input[94] & 0xfe) << 15);
	output[46] = (double)(value >> 16);

	// read output[47]: from bit 759 to 774
	value = ((uint32_t)(input[94] & 0x01) << 31) |
			((uint32_t)input[95] << 23) |
			((uint32_t)(input[96] & 0xfe) << 15);
	output[47] = (double)(value >> 16);

	// read output[48]: from bit 775 to 790
	value = ((uint32_t)(input[96] & 0x01) << 31) |
			((uint32_t)input[97] << 23) |
			((uint32_t)(input[98] & 0xfe) << 15);
	output[48] = (double)(value >> 16);
}

static void unpack_49_16bit_unsigned_7off(const uint8_t * input, double * output, void *closure) {
	// Unpack 49 values into output
	// Values are 16-bit unsigned
	// Skip 7 bits, read 784 bits of data.
	// Input must be at least 99 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 7 to 22
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)(input[2] & 0xfe) << 15);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 23 to 38
	value = ((uint32_t)(input[2] & 0x01) << 31) |
			((uint32_t)input[3] << 23) |
			((uint32_t)(input[4] & 0xfe) << 15);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 39 to 54
	value = ((uint32_t)(input[4] & 0x01) << 31) |
			((uint32_t)input[5] << 23) |
			((uint32_t)(input[6] & 0xfe) << 15);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 55 to 70
	value = ((uint32_t)(input[6] & 0x01) << 31) |
			((uint32_t)input[7] << 23) |
			((uint32_t)(input[8] & 0xfe) << 15);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 71 to 86
	value = ((uint32_t)(input[8] & 0x01) << 31) |
			((uint32_t)input[9] << 23) |
			((uint32_t)(input[10] & 0xfe) << 15);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 87 to 102
	value = ((uint32_t)(input[10] & 0x01) << 31) |
			((uint32_t)input[11] << 23) |
			((uint32_t)(input[12] & 0xfe) << 15);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 103 to 118
	value = ((uint32_t)(input[12] & 0x01) << 31) |
			((uint32_t)input[13] << 23) |
			((uint32_t)(input[14] & 0xfe) << 15);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 119 to 134
	value = ((uint32_t)(input[14] & 0x01) << 31) |
			((uint32_t)input[15] << 23) |
			((uint32_t)(input[16] & 0xfe) << 15);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 135 to 150
	value = ((uint32_t)(input[16] & 0x01) << 31) |
			((uint32_t)input[17] << 23) |
			((uint32_t)(input[18] & 0xfe) << 15);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 151 to 166
	value = ((uint32_t)(input[18] & 0x01) << 31) |
			((uint32_t)input[19] << 23) |
			((uint32_t)(input[20] & 0xfe) << 15);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 167 to 182
	value = ((uint32_t)(input[20] & 0x01) << 31) |
			((uint32_t)input[21] << 23) |
			((uint32_t)(input[22] & 0xfe) << 15);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 183 to 198
	value = ((uint32_t)(input[22] & 0x01) << 31) |
			((uint32_t)input[23] << 23) |
			((uint32_t)(input[24] & 0xfe) << 15);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 199 to 214
	value = ((uint32_t)(input[24] & 0x01) << 31) |
			((uint32_t)input[25] << 23) |
			((uint32_t)(input[26] & 0xfe) << 15);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 215 to 230
	value = ((uint32_t)(input[26] & 0x01) << 31) |
			((uint32_t)input[27] << 23) |
			((uint32_t)(input[28] & 0xfe) << 15);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 231 to 246
	value = ((uint32_t)(input[28] & 0x01) << 31) |
			((uint32_t)input[29] << 23) |
			((uint32_t)(input[30] & 0xfe) << 15);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 247 to 262
	value = ((uint32_t)(input[30] & 0x01) << 31) |
			((uint32_t)input[31] << 23) |
			((uint32_t)(input[32] & 0xfe) << 15);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 263 to 278
	value = ((uint32_t)(input[32] & 0x01) << 31) |
			((uint32_t)input[33] << 23) |
			((uint32_t)(input[34] & 0xfe) << 15);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 279 to 294
	value = ((uint32_t)(input[34] & 0x01) << 31) |
			((uint32_t)input[35] << 23) |
			((uint32_t)(input[36] & 0xfe) << 15);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 295 to 310
	value = ((uint32_t)(input[36] & 0x01) << 31) |
			((uint32_t)input[37] << 23) |
			((uint32_t)(input[38] & 0xfe) << 15);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 311 to 326
	value = ((uint32_t)(input[38] & 0x01) << 31) |
			((uint32_t)input[39] << 23) |
			((uint32_t)(input[40] & 0xfe) << 15);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 327 to 342
	value = ((uint32_t)(input[40] & 0x01) << 31) |
			((uint32_t)input[41] << 23) |
			((uint32_t)(input[42] & 0xfe) << 15);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 343 to 358
	value = ((uint32_t)(input[42] & 0x01) << 31) |
			((uint32_t)input[43] << 23) |
			((uint32_t)(input[44] & 0xfe) << 15);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 359 to 374
	value = ((uint32_t)(input[44] & 0x01) << 31) |
			((uint32_t)input[45] << 23) |
			((uint32_t)(input[46] & 0xfe) << 15);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 375 to 390
	value = ((uint32_t)(input[46] & 0x01) << 31) |
			((uint32_t)input[47] << 23) |
			((uint32_t)(input[48] & 0xfe) << 15);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 391 to 406
	value = ((uint32_t)(input[48] & 0x01) << 31) |
			((uint32_t)input[49] << 23) |
			((uint32_t)(input[50] & 0xfe) << 15);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 407 to 422
	value = ((uint32_t)(input[50] & 0x01) << 31) |
			((uint32_t)input[51] << 23) |
			((uint32_t)(input[52] & 0xfe) << 15);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 423 to 438
	value = ((uint32_t)(input[52] & 0x01) << 31) |
			((uint32_t)input[53] << 23) |
			((uint32_t)(input[54] & 0xfe) << 15);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 439 to 454
	value = ((uint32_t)(input[54] & 0x01) << 31) |
			((uint32_t)input[55] << 23) |
			((uint32_t)(input[56] & 0xfe) << 15);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 455 to 470
	value = ((uint32_t)(input[56] & 0x01) << 31) |
			((uint32_t)input[57] << 23) |
			((uint32_t)(input[58] & 0xfe) << 15);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 471 to 486
	value = ((uint32_t)(input[58] & 0x01) << 31) |
			((uint32_t)input[59] << 23) |
			((uint32_t)(input[60] & 0xfe) << 15);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 487 to 502
	value = ((uint32_t)(input[60] & 0x01) << 31) |
			((uint32_t)input[61] << 23) |
			((uint32_t)(input[62] & 0xfe) << 15);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 503 to 518
	value = ((uint32_t)(input[62] & 0x01) << 31) |
			((uint32_t)input[63] << 23) |
			((uint32_t)(input[64] & 0xfe) << 15);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 519 to 534
	value = ((uint32_t)(input[64] & 0x01) << 31) |
			((uint32_t)input[65] << 23) |
			((uint32_t)(input[66] & 0xfe) << 15);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 535 to 550
	value = ((uint32_t)(input[66] & 0x01) << 31) |
			((uint32_t)input[67] << 23) |
			((uint32_t)(input[68] & 0xfe) << 15);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 551 to 566
	value = ((uint32_t)(input[68] & 0x01) << 31) |
			((uint32_t)input[69] << 23) |
			((uint32_t)(input[70] & 0xfe) << 15);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 567 to 582
	value = ((uint32_t)(input[70] & 0x01) << 31) |
			((uint32_t)input[71] << 23) |
			((uint32_t)(input[72] & 0xfe) << 15);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 583 to 598
	value = ((uint32_t)(input[72] & 0x01) << 31) |
			((uint32_t)input[73] << 23) |
			((uint32_t)(input[74] & 0xfe) << 15);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 599 to 614
	value = ((uint32_t)(input[74] & 0x01) << 31) |
			((uint32_t)input[75] << 23) |
			((uint32_t)(input[76] & 0xfe) << 15);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 615 to 630
	value = ((uint32_t)(input[76] & 0x01) << 31) |
			((uint32_t)input[77] << 23) |
			((uint32_t)(input[78] & 0xfe) << 15);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 631 to 646
	value = ((uint32_t)(input[78] & 0x01) << 31) |
			((uint32_t)input[79] << 23) |
			((uint32_t)(input[80] & 0xfe) << 15);
	output[39] = (double)(value >> 16);

	// read output[40]: from bit 647 to 662
	value = ((uint32_t)(input[80] & 0x01) << 31) |
			((uint32_t)input[81] << 23) |
			((uint32_t)(input[82] & 0xfe) << 15);
	output[40] = (double)(value >> 16);

	// read output[41]: from bit 663 to 678
	value = ((uint32_t)(input[82] & 0x01) << 31) |
			((uint32_t)input[83] << 23) |
			((uint32_t)(input[84] & 0xfe) << 15);
	output[41] = (double)(value >> 16);

	// read output[42]: from bit 679 to 694
	value = ((uint32_t)(input[84] & 0x01) << 31) |
			((uint32_t)input[85] << 23) |
			((uint32_t)(input[86] & 0xfe) << 15);
	output[42] = (double)(value >> 16);

	// read output[43]: from bit 695 to 710
	value = ((uint32_t)(input[86] & 0x01) << 31) |
			((uint32_t)input[87] << 23) |
			((uint32_t)(input[88] & 0xfe) << 15);
	output[43] = (double)(value >> 16);

	// read output[44]: from bit 711 to 726
	value = ((uint32_t)(input[88] & 0x01) << 31) |
			((uint32_t)input[89] << 23) |
			((uint32_t)(input[90] & 0xfe) << 15);
	output[44] = (double)(value >> 16);

	// read output[45]: from bit 727 to 742
	value = ((uint32_t)(input[90] & 0x01) << 31) |
			((uint32_t)input[91] << 23) |
			((uint32_t)(input[92] & 0xfe) << 15);
	output[45] = (double)(value >> 16);

	// read output[46]: from bit 743 to 758
	value = ((uint32_t)(input[92] & 0x01) << 31) |
			((uint32_t)input[93] << 23) |
			((uint32_t)(input[94] & 0xfe) << 15);
	output[46] = (double)(value >> 16);

	// read output[47]: from bit 759 to 774
	value = ((uint32_t)(input[94] & 0x01) << 31) |
			((uint32_t)input[95] << 23) |
			((uint32_t)(input[96] & 0xfe) << 15);
	output[47] = (double)(value >> 16);

	// read output[48]: from bit 775 to 790
	value = ((uint32_t)(input[96] & 0x01) << 31) |
			((uint32_t)input[97] << 23) |
			((uint32_t)(input[98] & 0xfe) << 15);
	output[48] = (double)(value >> 16);
}

static void unpack_50_16bit_signed_0off(const uint8_t * input, double * output, void *closure) {
	// Unpack 50 values into output
	// Values are 16-bit signed
	// Skip 0 bits, read 800 bits of data.
	// Input must be at least 100 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 0 to 15
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)input[1] << 16);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 16 to 31
	value = ((uint32_t)input[2] << 24) |
			((uint32_t)input[3] << 16);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 32 to 47
	value = ((uint32_t)input[4] << 24) |
			((uint32_t)input[5] << 16);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 48 to 63
	value = ((uint32_t)input[6] << 24) |
			((uint32_t)input[7] << 16);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 64 to 79
	value = ((uint32_t)input[8] << 24) |
			((uint32_t)input[9] << 16);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 80 to 95
	value = ((uint32_t)input[10] << 24) |
			((uint32_t)input[11] << 16);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 96 to 111
	value = ((uint32_t)input[12] << 24) |
			((uint32_t)input[13] << 16);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 112 to 127
	value = ((uint32_t)input[14] << 24) |
			((uint32_t)input[15] << 16);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 128 to 143
	value = ((uint32_t)input[16] << 24) |
			((uint32_t)input[17] << 16);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 144 to 159
	value = ((uint32_t)input[18] << 24) |
			((uint32_t)input[19] << 16);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 160 to 175
	value = ((uint32_t)input[20] << 24) |
			((uint32_t)input[21] << 16);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 176 to 191
	value = ((uint32_t)input[22] << 24) |
			((uint32_t)input[23] << 16);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 192 to 207
	value = ((uint32_t)input[24] << 24) |
			((uint32_t)input[25] << 16);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 208 to 223
	value = ((uint32_t)input[26] << 24) |
			((uint32_t)input[27] << 16);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 224 to 239
	value = ((uint32_t)input[28] << 24) |
			((uint32_t)input[29] << 16);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 240 to 255
	value = ((uint32_t)input[30] << 24) |
			((uint32_t)input[31] << 16);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 256 to 271
	value = ((uint32_t)input[32] << 24) |
			((uint32_t)input[33] << 16);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 272 to 287
	value = ((uint32_t)input[34] << 24) |
			((uint32_t)input[35] << 16);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 288 to 303
	value = ((uint32_t)input[36] << 24) |
			((uint32_t)input[37] << 16);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 304 to 319
	value = ((uint32_t)input[38] << 24) |
			((uint32_t)input[39] << 16);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 320 to 335
	value = ((uint32_t)input[40] << 24) |
			((uint32_t)input[41] << 16);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 336 to 351
	value = ((uint32_t)input[42] << 24) |
			((uint32_t)input[43] << 16);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 352 to 367
	value = ((uint32_t)input[44] << 24) |
			((uint32_t)input[45] << 16);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 368 to 383
	value = ((uint32_t)input[46] << 24) |
			((uint32_t)input[47] << 16);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 384 to 399
	value = ((uint32_t)input[48] << 24) |
			((uint32_t)input[49] << 16);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 400 to 415
	value = ((uint32_t)input[50] << 24) |
			((uint32_t)input[51] << 16);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 416 to 431
	value = ((uint32_t)input[52] << 24) |
			((uint32_t)input[53] << 16);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 432 to 447
	value = ((uint32_t)input[54] << 24) |
			((uint32_t)input[55] << 16);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 448 to 463
	value = ((uint32_t)input[56] << 24) |
			((uint32_t)input[57] << 16);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 464 to 479
	value = ((uint32_t)input[58] << 24) |
			((uint32_t)input[59] << 16);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 480 to 495
	value = ((uint32_t)input[60] << 24) |
			((uint32_t)input[61] << 16);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 496 to 511
	value = ((uint32_t)input[62] << 24) |
			((uint32_t)input[63] << 16);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 512 to 527
	value = ((uint32_t)input[64] << 24) |
			((uint32_t)input[65] << 16);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 528 to 543
	value = ((uint32_t)input[66] << 24) |
			((uint32_t)input[67] << 16);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 544 to 559
	value = ((uint32_t)input[68] << 24) |
			((uint32_t)input[69] << 16);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 560 to 575
	value = ((uint32_t)input[70] << 24) |
			((uint32_t)input[71] << 16);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 576 to 591
	value = ((uint32_t)input[72] << 24) |
			((uint32_t)input[73] << 16);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 592 to 607
	value = ((uint32_t)input[74] << 24) |
			((uint32_t)input[75] << 16);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 608 to 623
	value = ((uint32_t)input[76] << 24) |
			((uint32_t)input[77] << 16);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 624 to 639
	value = ((uint32_t)input[78] << 24) |
			((uint32_t)input[79] << 16);
	output[39] = (double)(value >> 16);

	// read output[40]: from bit 640 to 655
	value = ((uint32_t)input[80] << 24) |
			((uint32_t)input[81] << 16);
	output[40] = (double)(value >> 16);

	// read output[41]: from bit 656 to 671
	value = ((uint32_t)input[82] << 24) |
			((uint32_t)input[83] << 16);
	output[41] = (double)(value >> 16);

	// read output[42]: from bit 672 to 687
	value = ((uint32_t)input[84] << 24) |
			((uint32_t)input[85] << 16);
	output[42] = (double)(value >> 16);

	// read output[43]: from bit 688 to 703
	value = ((uint32_t)input[86] << 24) |
			((uint32_t)input[87] << 16);
	output[43] = (double)(value >> 16);

	// read output[44]: from bit 704 to 719
	value = ((uint32_t)input[88] << 24) |
			((uint32_t)input[89] << 16);
	output[44] = (double)(value >> 16);

	// read output[45]: from bit 720 to 735
	value = ((uint32_t)input[90] << 24) |
			((uint32_t)input[91] << 16);
	output[45] = (double)(value >> 16);

	// read output[46]: from bit 736 to 751
	value = ((uint32_t)input[92] << 24) |
			((uint32_t)input[93] << 16);
	output[46] = (double)(value >> 16);

	// read output[47]: from bit 752 to 767
	value = ((uint32_t)input[94] << 24) |
			((uint32_t)input[95] << 16);
	output[47] = (double)(value >> 16);

	// read output[48]: from bit 768 to 783
	value = ((uint32_t)input[96] << 24) |
			((uint32_t)input[97] << 16);
	output[48] = (double)(value >> 16);

	// read output[49]: from bit 784 to 799
	value = ((uint32_t)input[98] << 24) |
			((uint32_t)input[99] << 16);
	output[49] = (double)(value >> 16);
}

static void unpack_50_16bit_unsigned_0off(const uint8_t * input, double * output, void *closure) {
	// Unpack 50 values into output
	// Values are 16-bit unsigned
	// Skip 0 bits, read 800 bits of data.
	// Input must be at least 100 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 0 to 15
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)input[1] << 16);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 16 to 31
	value = ((uint32_t)input[2] << 24) |
			((uint32_t)input[3] << 16);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 32 to 47
	value = ((uint32_t)input[4] << 24) |
			((uint32_t)input[5] << 16);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 48 to 63
	value = ((uint32_t)input[6] << 24) |
			((uint32_t)input[7] << 16);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 64 to 79
	value = ((uint32_t)input[8] << 24) |
			((uint32_t)input[9] << 16);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 80 to 95
	value = ((uint32_t)input[10] << 24) |
			((uint32_t)input[11] << 16);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 96 to 111
	value = ((uint32_t)input[12] << 24) |
			((uint32_t)input[13] << 16);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 112 to 127
	value = ((uint32_t)input[14] << 24) |
			((uint32_t)input[15] << 16);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 128 to 143
	value = ((uint32_t)input[16] << 24) |
			((uint32_t)input[17] << 16);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 144 to 159
	value = ((uint32_t)input[18] << 24) |
			((uint32_t)input[19] << 16);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 160 to 175
	value = ((uint32_t)input[20] << 24) |
			((uint32_t)input[21] << 16);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 176 to 191
	value = ((uint32_t)input[22] << 24) |
			((uint32_t)input[23] << 16);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 192 to 207
	value = ((uint32_t)input[24] << 24) |
			((uint32_t)input[25] << 16);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 208 to 223
	value = ((uint32_t)input[26] << 24) |
			((uint32_t)input[27] << 16);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 224 to 239
	value = ((uint32_t)input[28] << 24) |
			((uint32_t)input[29] << 16);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 240 to 255
	value = ((uint32_t)input[30] << 24) |
			((uint32_t)input[31] << 16);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 256 to 271
	value = ((uint32_t)input[32] << 24) |
			((uint32_t)input[33] << 16);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 272 to 287
	value = ((uint32_t)input[34] << 24) |
			((uint32_t)input[35] << 16);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 288 to 303
	value = ((uint32_t)input[36] << 24) |
			((uint32_t)input[37] << 16);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 304 to 319
	value = ((uint32_t)input[38] << 24) |
			((uint32_t)input[39] << 16);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 320 to 335
	value = ((uint32_t)input[40] << 24) |
			((uint32_t)input[41] << 16);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 336 to 351
	value = ((uint32_t)input[42] << 24) |
			((uint32_t)input[43] << 16);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 352 to 367
	value = ((uint32_t)input[44] << 24) |
			((uint32_t)input[45] << 16);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 368 to 383
	value = ((uint32_t)input[46] << 24) |
			((uint32_t)input[47] << 16);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 384 to 399
	value = ((uint32_t)input[48] << 24) |
			((uint32_t)input[49] << 16);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 400 to 415
	value = ((uint32_t)input[50] << 24) |
			((uint32_t)input[51] << 16);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 416 to 431
	value = ((uint32_t)input[52] << 24) |
			((uint32_t)input[53] << 16);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 432 to 447
	value = ((uint32_t)input[54] << 24) |
			((uint32_t)input[55] << 16);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 448 to 463
	value = ((uint32_t)input[56] << 24) |
			((uint32_t)input[57] << 16);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 464 to 479
	value = ((uint32_t)input[58] << 24) |
			((uint32_t)input[59] << 16);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 480 to 495
	value = ((uint32_t)input[60] << 24) |
			((uint32_t)input[61] << 16);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 496 to 511
	value = ((uint32_t)input[62] << 24) |
			((uint32_t)input[63] << 16);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 512 to 527
	value = ((uint32_t)input[64] << 24) |
			((uint32_t)input[65] << 16);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 528 to 543
	value = ((uint32_t)input[66] << 24) |
			((uint32_t)input[67] << 16);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 544 to 559
	value = ((uint32_t)input[68] << 24) |
			((uint32_t)input[69] << 16);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 560 to 575
	value = ((uint32_t)input[70] << 24) |
			((uint32_t)input[71] << 16);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 576 to 591
	value = ((uint32_t)input[72] << 24) |
			((uint32_t)input[73] << 16);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 592 to 607
	value = ((uint32_t)input[74] << 24) |
			((uint32_t)input[75] << 16);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 608 to 623
	value = ((uint32_t)input[76] << 24) |
			((uint32_t)input[77] << 16);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 624 to 639
	value = ((uint32_t)input[78] << 24) |
			((uint32_t)input[79] << 16);
	output[39] = (double)(value >> 16);

	// read output[40]: from bit 640 to 655
	value = ((uint32_t)input[80] << 24) |
			((uint32_t)input[81] << 16);
	output[40] = (double)(value >> 16);

	// read output[41]: from bit 656 to 671
	value = ((uint32_t)input[82] << 24) |
			((uint32_t)input[83] << 16);
	output[41] = (double)(value >> 16);

	// read output[42]: from bit 672 to 687
	value = ((uint32_t)input[84] << 24) |
			((uint32_t)input[85] << 16);
	output[42] = (double)(value >> 16);

	// read output[43]: from bit 688 to 703
	value = ((uint32_t)input[86] << 24) |
			((uint32_t)input[87] << 16);
	output[43] = (double)(value >> 16);

	// read output[44]: from bit 704 to 719
	value = ((uint32_t)input[88] << 24) |
			((uint32_t)input[89] << 16);
	output[44] = (double)(value >> 16);

	// read output[45]: from bit 720 to 735
	value = ((uint32_t)input[90] << 24) |
			((uint32_t)input[91] << 16);
	output[45] = (double)(value >> 16);

	// read output[46]: from bit 736 to 751
	value = ((uint32_t)input[92] << 24) |
			((uint32_t)input[93] << 16);
	output[46] = (double)(value >> 16);

	// read output[47]: from bit 752 to 767
	value = ((uint32_t)input[94] << 24) |
			((uint32_t)input[95] << 16);
	output[47] = (double)(value >> 16);

	// read output[48]: from bit 768 to 783
	value = ((uint32_t)input[96] << 24) |
			((uint32_t)input[97] << 16);
	output[48] = (double)(value >> 16);

	// read output[49]: from bit 784 to 799
	value = ((uint32_t)input[98] << 24) |
			((uint32_t)input[99] << 16);
	output[49] = (double)(value >> 16);
}

static void unpack_50_16bit_signed_1off(const uint8_t * input, double * output, void *closure) {
	// Unpack 50 values into output
	// Values are 16-bit signed
	// Skip 1 bits, read 800 bits of data.
	// Input must be at least 101 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 1 to 16
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)input[1] << 17) |
			((uint32_t)(input[2] & 0x80) << 9);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 17 to 32
	value = ((uint32_t)(input[2] & 0x7f) << 25) |
			((uint32_t)input[3] << 17) |
			((uint32_t)(input[4] & 0x80) << 9);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 33 to 48
	value = ((uint32_t)(input[4] & 0x7f) << 25) |
			((uint32_t)input[5] << 17) |
			((uint32_t)(input[6] & 0x80) << 9);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 49 to 64
	value = ((uint32_t)(input[6] & 0x7f) << 25) |
			((uint32_t)input[7] << 17) |
			((uint32_t)(input[8] & 0x80) << 9);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 65 to 80
	value = ((uint32_t)(input[8] & 0x7f) << 25) |
			((uint32_t)input[9] << 17) |
			((uint32_t)(input[10] & 0x80) << 9);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 81 to 96
	value = ((uint32_t)(input[10] & 0x7f) << 25) |
			((uint32_t)input[11] << 17) |
			((uint32_t)(input[12] & 0x80) << 9);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 97 to 112
	value = ((uint32_t)(input[12] & 0x7f) << 25) |
			((uint32_t)input[13] << 17) |
			((uint32_t)(input[14] & 0x80) << 9);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 113 to 128
	value = ((uint32_t)(input[14] & 0x7f) << 25) |
			((uint32_t)input[15] << 17) |
			((uint32_t)(input[16] & 0x80) << 9);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 129 to 144
	value = ((uint32_t)(input[16] & 0x7f) << 25) |
			((uint32_t)input[17] << 17) |
			((uint32_t)(input[18] & 0x80) << 9);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 145 to 160
	value = ((uint32_t)(input[18] & 0x7f) << 25) |
			((uint32_t)input[19] << 17) |
			((uint32_t)(input[20] & 0x80) << 9);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 161 to 176
	value = ((uint32_t)(input[20] & 0x7f) << 25) |
			((uint32_t)input[21] << 17) |
			((uint32_t)(input[22] & 0x80) << 9);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 177 to 192
	value = ((uint32_t)(input[22] & 0x7f) << 25) |
			((uint32_t)input[23] << 17) |
			((uint32_t)(input[24] & 0x80) << 9);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 193 to 208
	value = ((uint32_t)(input[24] & 0x7f) << 25) |
			((uint32_t)input[25] << 17) |
			((uint32_t)(input[26] & 0x80) << 9);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 209 to 224
	value = ((uint32_t)(input[26] & 0x7f) << 25) |
			((uint32_t)input[27] << 17) |
			((uint32_t)(input[28] & 0x80) << 9);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 225 to 240
	value = ((uint32_t)(input[28] & 0x7f) << 25) |
			((uint32_t)input[29] << 17) |
			((uint32_t)(input[30] & 0x80) << 9);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 241 to 256
	value = ((uint32_t)(input[30] & 0x7f) << 25) |
			((uint32_t)input[31] << 17) |
			((uint32_t)(input[32] & 0x80) << 9);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 257 to 272
	value = ((uint32_t)(input[32] & 0x7f) << 25) |
			((uint32_t)input[33] << 17) |
			((uint32_t)(input[34] & 0x80) << 9);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 273 to 288
	value = ((uint32_t)(input[34] & 0x7f) << 25) |
			((uint32_t)input[35] << 17) |
			((uint32_t)(input[36] & 0x80) << 9);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 289 to 304
	value = ((uint32_t)(input[36] & 0x7f) << 25) |
			((uint32_t)input[37] << 17) |
			((uint32_t)(input[38] & 0x80) << 9);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 305 to 320
	value = ((uint32_t)(input[38] & 0x7f) << 25) |
			((uint32_t)input[39] << 17) |
			((uint32_t)(input[40] & 0x80) << 9);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 321 to 336
	value = ((uint32_t)(input[40] & 0x7f) << 25) |
			((uint32_t)input[41] << 17) |
			((uint32_t)(input[42] & 0x80) << 9);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 337 to 352
	value = ((uint32_t)(input[42] & 0x7f) << 25) |
			((uint32_t)input[43] << 17) |
			((uint32_t)(input[44] & 0x80) << 9);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 353 to 368
	value = ((uint32_t)(input[44] & 0x7f) << 25) |
			((uint32_t)input[45] << 17) |
			((uint32_t)(input[46] & 0x80) << 9);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 369 to 384
	value = ((uint32_t)(input[46] & 0x7f) << 25) |
			((uint32_t)input[47] << 17) |
			((uint32_t)(input[48] & 0x80) << 9);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 385 to 400
	value = ((uint32_t)(input[48] & 0x7f) << 25) |
			((uint32_t)input[49] << 17) |
			((uint32_t)(input[50] & 0x80) << 9);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 401 to 416
	value = ((uint32_t)(input[50] & 0x7f) << 25) |
			((uint32_t)input[51] << 17) |
			((uint32_t)(input[52] & 0x80) << 9);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 417 to 432
	value = ((uint32_t)(input[52] & 0x7f) << 25) |
			((uint32_t)input[53] << 17) |
			((uint32_t)(input[54] & 0x80) << 9);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 433 to 448
	value = ((uint32_t)(input[54] & 0x7f) << 25) |
			((uint32_t)input[55] << 17) |
			((uint32_t)(input[56] & 0x80) << 9);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 449 to 464
	value = ((uint32_t)(input[56] & 0x7f) << 25) |
			((uint32_t)input[57] << 17) |
			((uint32_t)(input[58] & 0x80) << 9);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 465 to 480
	value = ((uint32_t)(input[58] & 0x7f) << 25) |
			((uint32_t)input[59] << 17) |
			((uint32_t)(input[60] & 0x80) << 9);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 481 to 496
	value = ((uint32_t)(input[60] & 0x7f) << 25) |
			((uint32_t)input[61] << 17) |
			((uint32_t)(input[62] & 0x80) << 9);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 497 to 512
	value = ((uint32_t)(input[62] & 0x7f) << 25) |
			((uint32_t)input[63] << 17) |
			((uint32_t)(input[64] & 0x80) << 9);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 513 to 528
	value = ((uint32_t)(input[64] & 0x7f) << 25) |
			((uint32_t)input[65] << 17) |
			((uint32_t)(input[66] & 0x80) << 9);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 529 to 544
	value = ((uint32_t)(input[66] & 0x7f) << 25) |
			((uint32_t)input[67] << 17) |
			((uint32_t)(input[68] & 0x80) << 9);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 545 to 560
	value = ((uint32_t)(input[68] & 0x7f) << 25) |
			((uint32_t)input[69] << 17) |
			((uint32_t)(input[70] & 0x80) << 9);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 561 to 576
	value = ((uint32_t)(input[70] & 0x7f) << 25) |
			((uint32_t)input[71] << 17) |
			((uint32_t)(input[72] & 0x80) << 9);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 577 to 592
	value = ((uint32_t)(input[72] & 0x7f) << 25) |
			((uint32_t)input[73] << 17) |
			((uint32_t)(input[74] & 0x80) << 9);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 593 to 608
	value = ((uint32_t)(input[74] & 0x7f) << 25) |
			((uint32_t)input[75] << 17) |
			((uint32_t)(input[76] & 0x80) << 9);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 609 to 624
	value = ((uint32_t)(input[76] & 0x7f) << 25) |
			((uint32_t)input[77] << 17) |
			((uint32_t)(input[78] & 0x80) << 9);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 625 to 640
	value = ((uint32_t)(input[78] & 0x7f) << 25) |
			((uint32_t)input[79] << 17) |
			((uint32_t)(input[80] & 0x80) << 9);
	output[39] = (double)(value >> 16);

	// read output[40]: from bit 641 to 656
	value = ((uint32_t)(input[80] & 0x7f) << 25) |
			((uint32_t)input[81] << 17) |
			((uint32_t)(input[82] & 0x80) << 9);
	output[40] = (double)(value >> 16);

	// read output[41]: from bit 657 to 672
	value = ((uint32_t)(input[82] & 0x7f) << 25) |
			((uint32_t)input[83] << 17) |
			((uint32_t)(input[84] & 0x80) << 9);
	output[41] = (double)(value >> 16);

	// read output[42]: from bit 673 to 688
	value = ((uint32_t)(input[84] & 0x7f) << 25) |
			((uint32_t)input[85] << 17) |
			((uint32_t)(input[86] & 0x80) << 9);
	output[42] = (double)(value >> 16);

	// read output[43]: from bit 689 to 704
	value = ((uint32_t)(input[86] & 0x7f) << 25) |
			((uint32_t)input[87] << 17) |
			((uint32_t)(input[88] & 0x80) << 9);
	output[43] = (double)(value >> 16);

	// read output[44]: from bit 705 to 720
	value = ((uint32_t)(input[88] & 0x7f) << 25) |
			((uint32_t)input[89] << 17) |
			((uint32_t)(input[90] & 0x80) << 9);
	output[44] = (double)(value >> 16);

	// read output[45]: from bit 721 to 736
	value = ((uint32_t)(input[90] & 0x7f) << 25) |
			((uint32_t)input[91] << 17) |
			((uint32_t)(input[92] & 0x80) << 9);
	output[45] = (double)(value >> 16);

	// read output[46]: from bit 737 to 752
	value = ((uint32_t)(input[92] & 0x7f) << 25) |
			((uint32_t)input[93] << 17) |
			((uint32_t)(input[94] & 0x80) << 9);
	output[46] = (double)(value >> 16);

	// read output[47]: from bit 753 to 768
	value = ((uint32_t)(input[94] & 0x7f) << 25) |
			((uint32_t)input[95] << 17) |
			((uint32_t)(input[96] & 0x80) << 9);
	output[47] = (double)(value >> 16);

	// read output[48]: from bit 769 to 784
	value = ((uint32_t)(input[96] & 0x7f) << 25) |
			((uint32_t)input[97] << 17) |
			((uint32_t)(input[98] & 0x80) << 9);
	output[48] = (double)(value >> 16);

	// read output[49]: from bit 785 to 800
	value = ((uint32_t)(input[98] & 0x7f) << 25) |
			((uint32_t)input[99] << 17) |
			((uint32_t)(input[100] & 0x80) << 9);
	output[49] = (double)(value >> 16);
}

static void unpack_50_16bit_unsigned_1off(const uint8_t * input, double * output, void *closure) {
	// Unpack 50 values into output
	// Values are 16-bit unsigned
	// Skip 1 bits, read 800 bits of data.
	// Input must be at least 101 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 1 to 16
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)input[1] << 17) |
			((uint32_t)(input[2] & 0x80) << 9);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 17 to 32
	value = ((uint32_t)(input[2] & 0x7f) << 25) |
			((uint32_t)input[3] << 17) |
			((uint32_t)(input[4] & 0x80) << 9);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 33 to 48
	value = ((uint32_t)(input[4] & 0x7f) << 25) |
			((uint32_t)input[5] << 17) |
			((uint32_t)(input[6] & 0x80) << 9);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 49 to 64
	value = ((uint32_t)(input[6] & 0x7f) << 25) |
			((uint32_t)input[7] << 17) |
			((uint32_t)(input[8] & 0x80) << 9);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 65 to 80
	value = ((uint32_t)(input[8] & 0x7f) << 25) |
			((uint32_t)input[9] << 17) |
			((uint32_t)(input[10] & 0x80) << 9);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 81 to 96
	value = ((uint32_t)(input[10] & 0x7f) << 25) |
			((uint32_t)input[11] << 17) |
			((uint32_t)(input[12] & 0x80) << 9);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 97 to 112
	value = ((uint32_t)(input[12] & 0x7f) << 25) |
			((uint32_t)input[13] << 17) |
			((uint32_t)(input[14] & 0x80) << 9);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 113 to 128
	value = ((uint32_t)(input[14] & 0x7f) << 25) |
			((uint32_t)input[15] << 17) |
			((uint32_t)(input[16] & 0x80) << 9);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 129 to 144
	value = ((uint32_t)(input[16] & 0x7f) << 25) |
			((uint32_t)input[17] << 17) |
			((uint32_t)(input[18] & 0x80) << 9);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 145 to 160
	value = ((uint32_t)(input[18] & 0x7f) << 25) |
			((uint32_t)input[19] << 17) |
			((uint32_t)(input[20] & 0x80) << 9);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 161 to 176
	value = ((uint32_t)(input[20] & 0x7f) << 25) |
			((uint32_t)input[21] << 17) |
			((uint32_t)(input[22] & 0x80) << 9);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 177 to 192
	value = ((uint32_t)(input[22] & 0x7f) << 25) |
			((uint32_t)input[23] << 17) |
			((uint32_t)(input[24] & 0x80) << 9);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 193 to 208
	value = ((uint32_t)(input[24] & 0x7f) << 25) |
			((uint32_t)input[25] << 17) |
			((uint32_t)(input[26] & 0x80) << 9);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 209 to 224
	value = ((uint32_t)(input[26] & 0x7f) << 25) |
			((uint32_t)input[27] << 17) |
			((uint32_t)(input[28] & 0x80) << 9);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 225 to 240
	value = ((uint32_t)(input[28] & 0x7f) << 25) |
			((uint32_t)input[29] << 17) |
			((uint32_t)(input[30] & 0x80) << 9);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 241 to 256
	value = ((uint32_t)(input[30] & 0x7f) << 25) |
			((uint32_t)input[31] << 17) |
			((uint32_t)(input[32] & 0x80) << 9);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 257 to 272
	value = ((uint32_t)(input[32] & 0x7f) << 25) |
			((uint32_t)input[33] << 17) |
			((uint32_t)(input[34] & 0x80) << 9);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 273 to 288
	value = ((uint32_t)(input[34] & 0x7f) << 25) |
			((uint32_t)input[35] << 17) |
			((uint32_t)(input[36] & 0x80) << 9);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 289 to 304
	value = ((uint32_t)(input[36] & 0x7f) << 25) |
			((uint32_t)input[37] << 17) |
			((uint32_t)(input[38] & 0x80) << 9);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 305 to 320
	value = ((uint32_t)(input[38] & 0x7f) << 25) |
			((uint32_t)input[39] << 17) |
			((uint32_t)(input[40] & 0x80) << 9);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 321 to 336
	value = ((uint32_t)(input[40] & 0x7f) << 25) |
			((uint32_t)input[41] << 17) |
			((uint32_t)(input[42] & 0x80) << 9);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 337 to 352
	value = ((uint32_t)(input[42] & 0x7f) << 25) |
			((uint32_t)input[43] << 17) |
			((uint32_t)(input[44] & 0x80) << 9);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 353 to 368
	value = ((uint32_t)(input[44] & 0x7f) << 25) |
			((uint32_t)input[45] << 17) |
			((uint32_t)(input[46] & 0x80) << 9);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 369 to 384
	value = ((uint32_t)(input[46] & 0x7f) << 25) |
			((uint32_t)input[47] << 17) |
			((uint32_t)(input[48] & 0x80) << 9);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 385 to 400
	value = ((uint32_t)(input[48] & 0x7f) << 25) |
			((uint32_t)input[49] << 17) |
			((uint32_t)(input[50] & 0x80) << 9);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 401 to 416
	value = ((uint32_t)(input[50] & 0x7f) << 25) |
			((uint32_t)input[51] << 17) |
			((uint32_t)(input[52] & 0x80) << 9);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 417 to 432
	value = ((uint32_t)(input[52] & 0x7f) << 25) |
			((uint32_t)input[53] << 17) |
			((uint32_t)(input[54] & 0x80) << 9);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 433 to 448
	value = ((uint32_t)(input[54] & 0x7f) << 25) |
			((uint32_t)input[55] << 17) |
			((uint32_t)(input[56] & 0x80) << 9);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 449 to 464
	value = ((uint32_t)(input[56] & 0x7f) << 25) |
			((uint32_t)input[57] << 17) |
			((uint32_t)(input[58] & 0x80) << 9);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 465 to 480
	value = ((uint32_t)(input[58] & 0x7f) << 25) |
			((uint32_t)input[59] << 17) |
			((uint32_t)(input[60] & 0x80) << 9);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 481 to 496
	value = ((uint32_t)(input[60] & 0x7f) << 25) |
			((uint32_t)input[61] << 17) |
			((uint32_t)(input[62] & 0x80) << 9);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 497 to 512
	value = ((uint32_t)(input[62] & 0x7f) << 25) |
			((uint32_t)input[63] << 17) |
			((uint32_t)(input[64] & 0x80) << 9);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 513 to 528
	value = ((uint32_t)(input[64] & 0x7f) << 25) |
			((uint32_t)input[65] << 17) |
			((uint32_t)(input[66] & 0x80) << 9);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 529 to 544
	value = ((uint32_t)(input[66] & 0x7f) << 25) |
			((uint32_t)input[67] << 17) |
			((uint32_t)(input[68] & 0x80) << 9);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 545 to 560
	value = ((uint32_t)(input[68] & 0x7f) << 25) |
			((uint32_t)input[69] << 17) |
			((uint32_t)(input[70] & 0x80) << 9);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 561 to 576
	value = ((uint32_t)(input[70] & 0x7f) << 25) |
			((uint32_t)input[71] << 17) |
			((uint32_t)(input[72] & 0x80) << 9);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 577 to 592
	value = ((uint32_t)(input[72] & 0x7f) << 25) |
			((uint32_t)input[73] << 17) |
			((uint32_t)(input[74] & 0x80) << 9);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 593 to 608
	value = ((uint32_t)(input[74] & 0x7f) << 25) |
			((uint32_t)input[75] << 17) |
			((uint32_t)(input[76] & 0x80) << 9);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 609 to 624
	value = ((uint32_t)(input[76] & 0x7f) << 25) |
			((uint32_t)input[77] << 17) |
			((uint32_t)(input[78] & 0x80) << 9);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 625 to 640
	value = ((uint32_t)(input[78] & 0x7f) << 25) |
			((uint32_t)input[79] << 17) |
			((uint32_t)(input[80] & 0x80) << 9);
	output[39] = (double)(value >> 16);

	// read output[40]: from bit 641 to 656
	value = ((uint32_t)(input[80] & 0x7f) << 25) |
			((uint32_t)input[81] << 17) |
			((uint32_t)(input[82] & 0x80) << 9);
	output[40] = (double)(value >> 16);

	// read output[41]: from bit 657 to 672
	value = ((uint32_t)(input[82] & 0x7f) << 25) |
			((uint32_t)input[83] << 17) |
			((uint32_t)(input[84] & 0x80) << 9);
	output[41] = (double)(value >> 16);

	// read output[42]: from bit 673 to 688
	value = ((uint32_t)(input[84] & 0x7f) << 25) |
			((uint32_t)input[85] << 17) |
			((uint32_t)(input[86] & 0x80) << 9);
	output[42] = (double)(value >> 16);

	// read output[43]: from bit 689 to 704
	value = ((uint32_t)(input[86] & 0x7f) << 25) |
			((uint32_t)input[87] << 17) |
			((uint32_t)(input[88] & 0x80) << 9);
	output[43] = (double)(value >> 16);

	// read output[44]: from bit 705 to 720
	value = ((uint32_t)(input[88] & 0x7f) << 25) |
			((uint32_t)input[89] << 17) |
			((uint32_t)(input[90] & 0x80) << 9);
	output[44] = (double)(value >> 16);

	// read output[45]: from bit 721 to 736
	value = ((uint32_t)(input[90] & 0x7f) << 25) |
			((uint32_t)input[91] << 17) |
			((uint32_t)(input[92] & 0x80) << 9);
	output[45] = (double)(value >> 16);

	// read output[46]: from bit 737 to 752
	value = ((uint32_t)(input[92] & 0x7f) << 25) |
			((uint32_t)input[93] << 17) |
			((uint32_t)(input[94] & 0x80) << 9);
	output[46] = (double)(value >> 16);

	// read output[47]: from bit 753 to 768
	value = ((uint32_t)(input[94] & 0x7f) << 25) |
			((uint32_t)input[95] << 17) |
			((uint32_t)(input[96] & 0x80) << 9);
	output[47] = (double)(value >> 16);

	// read output[48]: from bit 769 to 784
	value = ((uint32_t)(input[96] & 0x7f) << 25) |
			((uint32_t)input[97] << 17) |
			((uint32_t)(input[98] & 0x80) << 9);
	output[48] = (double)(value >> 16);

	// read output[49]: from bit 785 to 800
	value = ((uint32_t)(input[98] & 0x7f) << 25) |
			((uint32_t)input[99] << 17) |
			((uint32_t)(input[100] & 0x80) << 9);
	output[49] = (double)(value >> 16);
}

static void unpack_50_16bit_signed_2off(const uint8_t * input, double * output, void *closure) {
	// Unpack 50 values into output
	// Values are 16-bit signed
	// Skip 2 bits, read 800 bits of data.
	// Input must be at least 101 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 2 to 17
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)input[1] << 18) |
			((uint32_t)(input[2] & 0xc0) << 10);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 18 to 33
	value = ((uint32_t)(input[2] & 0x3f) << 26) |
			((uint32_t)input[3] << 18) |
			((uint32_t)(input[4] & 0xc0) << 10);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 34 to 49
	value = ((uint32_t)(input[4] & 0x3f) << 26) |
			((uint32_t)input[5] << 18) |
			((uint32_t)(input[6] & 0xc0) << 10);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 50 to 65
	value = ((uint32_t)(input[6] & 0x3f) << 26) |
			((uint32_t)input[7] << 18) |
			((uint32_t)(input[8] & 0xc0) << 10);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 66 to 81
	value = ((uint32_t)(input[8] & 0x3f) << 26) |
			((uint32_t)input[9] << 18) |
			((uint32_t)(input[10] & 0xc0) << 10);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 82 to 97
	value = ((uint32_t)(input[10] & 0x3f) << 26) |
			((uint32_t)input[11] << 18) |
			((uint32_t)(input[12] & 0xc0) << 10);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 98 to 113
	value = ((uint32_t)(input[12] & 0x3f) << 26) |
			((uint32_t)input[13] << 18) |
			((uint32_t)(input[14] & 0xc0) << 10);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 114 to 129
	value = ((uint32_t)(input[14] & 0x3f) << 26) |
			((uint32_t)input[15] << 18) |
			((uint32_t)(input[16] & 0xc0) << 10);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 130 to 145
	value = ((uint32_t)(input[16] & 0x3f) << 26) |
			((uint32_t)input[17] << 18) |
			((uint32_t)(input[18] & 0xc0) << 10);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 146 to 161
	value = ((uint32_t)(input[18] & 0x3f) << 26) |
			((uint32_t)input[19] << 18) |
			((uint32_t)(input[20] & 0xc0) << 10);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 162 to 177
	value = ((uint32_t)(input[20] & 0x3f) << 26) |
			((uint32_t)input[21] << 18) |
			((uint32_t)(input[22] & 0xc0) << 10);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 178 to 193
	value = ((uint32_t)(input[22] & 0x3f) << 26) |
			((uint32_t)input[23] << 18) |
			((uint32_t)(input[24] & 0xc0) << 10);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 194 to 209
	value = ((uint32_t)(input[24] & 0x3f) << 26) |
			((uint32_t)input[25] << 18) |
			((uint32_t)(input[26] & 0xc0) << 10);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 210 to 225
	value = ((uint32_t)(input[26] & 0x3f) << 26) |
			((uint32_t)input[27] << 18) |
			((uint32_t)(input[28] & 0xc0) << 10);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 226 to 241
	value = ((uint32_t)(input[28] & 0x3f) << 26) |
			((uint32_t)input[29] << 18) |
			((uint32_t)(input[30] & 0xc0) << 10);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 242 to 257
	value = ((uint32_t)(input[30] & 0x3f) << 26) |
			((uint32_t)input[31] << 18) |
			((uint32_t)(input[32] & 0xc0) << 10);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 258 to 273
	value = ((uint32_t)(input[32] & 0x3f) << 26) |
			((uint32_t)input[33] << 18) |
			((uint32_t)(input[34] & 0xc0) << 10);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 274 to 289
	value = ((uint32_t)(input[34] & 0x3f) << 26) |
			((uint32_t)input[35] << 18) |
			((uint32_t)(input[36] & 0xc0) << 10);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 290 to 305
	value = ((uint32_t)(input[36] & 0x3f) << 26) |
			((uint32_t)input[37] << 18) |
			((uint32_t)(input[38] & 0xc0) << 10);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 306 to 321
	value = ((uint32_t)(input[38] & 0x3f) << 26) |
			((uint32_t)input[39] << 18) |
			((uint32_t)(input[40] & 0xc0) << 10);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 322 to 337
	value = ((uint32_t)(input[40] & 0x3f) << 26) |
			((uint32_t)input[41] << 18) |
			((uint32_t)(input[42] & 0xc0) << 10);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 338 to 353
	value = ((uint32_t)(input[42] & 0x3f) << 26) |
			((uint32_t)input[43] << 18) |
			((uint32_t)(input[44] & 0xc0) << 10);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 354 to 369
	value = ((uint32_t)(input[44] & 0x3f) << 26) |
			((uint32_t)input[45] << 18) |
			((uint32_t)(input[46] & 0xc0) << 10);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 370 to 385
	value = ((uint32_t)(input[46] & 0x3f) << 26) |
			((uint32_t)input[47] << 18) |
			((uint32_t)(input[48] & 0xc0) << 10);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 386 to 401
	value = ((uint32_t)(input[48] & 0x3f) << 26) |
			((uint32_t)input[49] << 18) |
			((uint32_t)(input[50] & 0xc0) << 10);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 402 to 417
	value = ((uint32_t)(input[50] & 0x3f) << 26) |
			((uint32_t)input[51] << 18) |
			((uint32_t)(input[52] & 0xc0) << 10);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 418 to 433
	value = ((uint32_t)(input[52] & 0x3f) << 26) |
			((uint32_t)input[53] << 18) |
			((uint32_t)(input[54] & 0xc0) << 10);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 434 to 449
	value = ((uint32_t)(input[54] & 0x3f) << 26) |
			((uint32_t)input[55] << 18) |
			((uint32_t)(input[56] & 0xc0) << 10);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 450 to 465
	value = ((uint32_t)(input[56] & 0x3f) << 26) |
			((uint32_t)input[57] << 18) |
			((uint32_t)(input[58] & 0xc0) << 10);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 466 to 481
	value = ((uint32_t)(input[58] & 0x3f) << 26) |
			((uint32_t)input[59] << 18) |
			((uint32_t)(input[60] & 0xc0) << 10);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 482 to 497
	value = ((uint32_t)(input[60] & 0x3f) << 26) |
			((uint32_t)input[61] << 18) |
			((uint32_t)(input[62] & 0xc0) << 10);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 498 to 513
	value = ((uint32_t)(input[62] & 0x3f) << 26) |
			((uint32_t)input[63] << 18) |
			((uint32_t)(input[64] & 0xc0) << 10);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 514 to 529
	value = ((uint32_t)(input[64] & 0x3f) << 26) |
			((uint32_t)input[65] << 18) |
			((uint32_t)(input[66] & 0xc0) << 10);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 530 to 545
	value = ((uint32_t)(input[66] & 0x3f) << 26) |
			((uint32_t)input[67] << 18) |
			((uint32_t)(input[68] & 0xc0) << 10);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 546 to 561
	value = ((uint32_t)(input[68] & 0x3f) << 26) |
			((uint32_t)input[69] << 18) |
			((uint32_t)(input[70] & 0xc0) << 10);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 562 to 577
	value = ((uint32_t)(input[70] & 0x3f) << 26) |
			((uint32_t)input[71] << 18) |
			((uint32_t)(input[72] & 0xc0) << 10);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 578 to 593
	value = ((uint32_t)(input[72] & 0x3f) << 26) |
			((uint32_t)input[73] << 18) |
			((uint32_t)(input[74] & 0xc0) << 10);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 594 to 609
	value = ((uint32_t)(input[74] & 0x3f) << 26) |
			((uint32_t)input[75] << 18) |
			((uint32_t)(input[76] & 0xc0) << 10);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 610 to 625
	value = ((uint32_t)(input[76] & 0x3f) << 26) |
			((uint32_t)input[77] << 18) |
			((uint32_t)(input[78] & 0xc0) << 10);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 626 to 641
	value = ((uint32_t)(input[78] & 0x3f) << 26) |
			((uint32_t)input[79] << 18) |
			((uint32_t)(input[80] & 0xc0) << 10);
	output[39] = (double)(value >> 16);

	// read output[40]: from bit 642 to 657
	value = ((uint32_t)(input[80] & 0x3f) << 26) |
			((uint32_t)input[81] << 18) |
			((uint32_t)(input[82] & 0xc0) << 10);
	output[40] = (double)(value >> 16);

	// read output[41]: from bit 658 to 673
	value = ((uint32_t)(input[82] & 0x3f) << 26) |
			((uint32_t)input[83] << 18) |
			((uint32_t)(input[84] & 0xc0) << 10);
	output[41] = (double)(value >> 16);

	// read output[42]: from bit 674 to 689
	value = ((uint32_t)(input[84] & 0x3f) << 26) |
			((uint32_t)input[85] << 18) |
			((uint32_t)(input[86] & 0xc0) << 10);
	output[42] = (double)(value >> 16);

	// read output[43]: from bit 690 to 705
	value = ((uint32_t)(input[86] & 0x3f) << 26) |
			((uint32_t)input[87] << 18) |
			((uint32_t)(input[88] & 0xc0) << 10);
	output[43] = (double)(value >> 16);

	// read output[44]: from bit 706 to 721
	value = ((uint32_t)(input[88] & 0x3f) << 26) |
			((uint32_t)input[89] << 18) |
			((uint32_t)(input[90] & 0xc0) << 10);
	output[44] = (double)(value >> 16);

	// read output[45]: from bit 722 to 737
	value = ((uint32_t)(input[90] & 0x3f) << 26) |
			((uint32_t)input[91] << 18) |
			((uint32_t)(input[92] & 0xc0) << 10);
	output[45] = (double)(value >> 16);

	// read output[46]: from bit 738 to 753
	value = ((uint32_t)(input[92] & 0x3f) << 26) |
			((uint32_t)input[93] << 18) |
			((uint32_t)(input[94] & 0xc0) << 10);
	output[46] = (double)(value >> 16);

	// read output[47]: from bit 754 to 769
	value = ((uint32_t)(input[94] & 0x3f) << 26) |
			((uint32_t)input[95] << 18) |
			((uint32_t)(input[96] & 0xc0) << 10);
	output[47] = (double)(value >> 16);

	// read output[48]: from bit 770 to 785
	value = ((uint32_t)(input[96] & 0x3f) << 26) |
			((uint32_t)input[97] << 18) |
			((uint32_t)(input[98] & 0xc0) << 10);
	output[48] = (double)(value >> 16);

	// read output[49]: from bit 786 to 801
	value = ((uint32_t)(input[98] & 0x3f) << 26) |
			((uint32_t)input[99] << 18) |
			((uint32_t)(input[100] & 0xc0) << 10);
	output[49] = (double)(value >> 16);
}

static void unpack_50_16bit_unsigned_2off(const uint8_t * input, double * output, void *closure) {
	// Unpack 50 values into output
	// Values are 16-bit unsigned
	// Skip 2 bits, read 800 bits of data.
	// Input must be at least 101 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 2 to 17
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)input[1] << 18) |
			((uint32_t)(input[2] & 0xc0) << 10);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 18 to 33
	value = ((uint32_t)(input[2] & 0x3f) << 26) |
			((uint32_t)input[3] << 18) |
			((uint32_t)(input[4] & 0xc0) << 10);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 34 to 49
	value = ((uint32_t)(input[4] & 0x3f) << 26) |
			((uint32_t)input[5] << 18) |
			((uint32_t)(input[6] & 0xc0) << 10);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 50 to 65
	value = ((uint32_t)(input[6] & 0x3f) << 26) |
			((uint32_t)input[7] << 18) |
			((uint32_t)(input[8] & 0xc0) << 10);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 66 to 81
	value = ((uint32_t)(input[8] & 0x3f) << 26) |
			((uint32_t)input[9] << 18) |
			((uint32_t)(input[10] & 0xc0) << 10);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 82 to 97
	value = ((uint32_t)(input[10] & 0x3f) << 26) |
			((uint32_t)input[11] << 18) |
			((uint32_t)(input[12] & 0xc0) << 10);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 98 to 113
	value = ((uint32_t)(input[12] & 0x3f) << 26) |
			((uint32_t)input[13] << 18) |
			((uint32_t)(input[14] & 0xc0) << 10);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 114 to 129
	value = ((uint32_t)(input[14] & 0x3f) << 26) |
			((uint32_t)input[15] << 18) |
			((uint32_t)(input[16] & 0xc0) << 10);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 130 to 145
	value = ((uint32_t)(input[16] & 0x3f) << 26) |
			((uint32_t)input[17] << 18) |
			((uint32_t)(input[18] & 0xc0) << 10);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 146 to 161
	value = ((uint32_t)(input[18] & 0x3f) << 26) |
			((uint32_t)input[19] << 18) |
			((uint32_t)(input[20] & 0xc0) << 10);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 162 to 177
	value = ((uint32_t)(input[20] & 0x3f) << 26) |
			((uint32_t)input[21] << 18) |
			((uint32_t)(input[22] & 0xc0) << 10);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 178 to 193
	value = ((uint32_t)(input[22] & 0x3f) << 26) |
			((uint32_t)input[23] << 18) |
			((uint32_t)(input[24] & 0xc0) << 10);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 194 to 209
	value = ((uint32_t)(input[24] & 0x3f) << 26) |
			((uint32_t)input[25] << 18) |
			((uint32_t)(input[26] & 0xc0) << 10);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 210 to 225
	value = ((uint32_t)(input[26] & 0x3f) << 26) |
			((uint32_t)input[27] << 18) |
			((uint32_t)(input[28] & 0xc0) << 10);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 226 to 241
	value = ((uint32_t)(input[28] & 0x3f) << 26) |
			((uint32_t)input[29] << 18) |
			((uint32_t)(input[30] & 0xc0) << 10);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 242 to 257
	value = ((uint32_t)(input[30] & 0x3f) << 26) |
			((uint32_t)input[31] << 18) |
			((uint32_t)(input[32] & 0xc0) << 10);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 258 to 273
	value = ((uint32_t)(input[32] & 0x3f) << 26) |
			((uint32_t)input[33] << 18) |
			((uint32_t)(input[34] & 0xc0) << 10);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 274 to 289
	value = ((uint32_t)(input[34] & 0x3f) << 26) |
			((uint32_t)input[35] << 18) |
			((uint32_t)(input[36] & 0xc0) << 10);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 290 to 305
	value = ((uint32_t)(input[36] & 0x3f) << 26) |
			((uint32_t)input[37] << 18) |
			((uint32_t)(input[38] & 0xc0) << 10);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 306 to 321
	value = ((uint32_t)(input[38] & 0x3f) << 26) |
			((uint32_t)input[39] << 18) |
			((uint32_t)(input[40] & 0xc0) << 10);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 322 to 337
	value = ((uint32_t)(input[40] & 0x3f) << 26) |
			((uint32_t)input[41] << 18) |
			((uint32_t)(input[42] & 0xc0) << 10);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 338 to 353
	value = ((uint32_t)(input[42] & 0x3f) << 26) |
			((uint32_t)input[43] << 18) |
			((uint32_t)(input[44] & 0xc0) << 10);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 354 to 369
	value = ((uint32_t)(input[44] & 0x3f) << 26) |
			((uint32_t)input[45] << 18) |
			((uint32_t)(input[46] & 0xc0) << 10);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 370 to 385
	value = ((uint32_t)(input[46] & 0x3f) << 26) |
			((uint32_t)input[47] << 18) |
			((uint32_t)(input[48] & 0xc0) << 10);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 386 to 401
	value = ((uint32_t)(input[48] & 0x3f) << 26) |
			((uint32_t)input[49] << 18) |
			((uint32_t)(input[50] & 0xc0) << 10);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 402 to 417
	value = ((uint32_t)(input[50] & 0x3f) << 26) |
			((uint32_t)input[51] << 18) |
			((uint32_t)(input[52] & 0xc0) << 10);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 418 to 433
	value = ((uint32_t)(input[52] & 0x3f) << 26) |
			((uint32_t)input[53] << 18) |
			((uint32_t)(input[54] & 0xc0) << 10);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 434 to 449
	value = ((uint32_t)(input[54] & 0x3f) << 26) |
			((uint32_t)input[55] << 18) |
			((uint32_t)(input[56] & 0xc0) << 10);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 450 to 465
	value = ((uint32_t)(input[56] & 0x3f) << 26) |
			((uint32_t)input[57] << 18) |
			((uint32_t)(input[58] & 0xc0) << 10);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 466 to 481
	value = ((uint32_t)(input[58] & 0x3f) << 26) |
			((uint32_t)input[59] << 18) |
			((uint32_t)(input[60] & 0xc0) << 10);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 482 to 497
	value = ((uint32_t)(input[60] & 0x3f) << 26) |
			((uint32_t)input[61] << 18) |
			((uint32_t)(input[62] & 0xc0) << 10);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 498 to 513
	value = ((uint32_t)(input[62] & 0x3f) << 26) |
			((uint32_t)input[63] << 18) |
			((uint32_t)(input[64] & 0xc0) << 10);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 514 to 529
	value = ((uint32_t)(input[64] & 0x3f) << 26) |
			((uint32_t)input[65] << 18) |
			((uint32_t)(input[66] & 0xc0) << 10);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 530 to 545
	value = ((uint32_t)(input[66] & 0x3f) << 26) |
			((uint32_t)input[67] << 18) |
			((uint32_t)(input[68] & 0xc0) << 10);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 546 to 561
	value = ((uint32_t)(input[68] & 0x3f) << 26) |
			((uint32_t)input[69] << 18) |
			((uint32_t)(input[70] & 0xc0) << 10);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 562 to 577
	value = ((uint32_t)(input[70] & 0x3f) << 26) |
			((uint32_t)input[71] << 18) |
			((uint32_t)(input[72] & 0xc0) << 10);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 578 to 593
	value = ((uint32_t)(input[72] & 0x3f) << 26) |
			((uint32_t)input[73] << 18) |
			((uint32_t)(input[74] & 0xc0) << 10);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 594 to 609
	value = ((uint32_t)(input[74] & 0x3f) << 26) |
			((uint32_t)input[75] << 18) |
			((uint32_t)(input[76] & 0xc0) << 10);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 610 to 625
	value = ((uint32_t)(input[76] & 0x3f) << 26) |
			((uint32_t)input[77] << 18) |
			((uint32_t)(input[78] & 0xc0) << 10);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 626 to 641
	value = ((uint32_t)(input[78] & 0x3f) << 26) |
			((uint32_t)input[79] << 18) |
			((uint32_t)(input[80] & 0xc0) << 10);
	output[39] = (double)(value >> 16);

	// read output[40]: from bit 642 to 657
	value = ((uint32_t)(input[80] & 0x3f) << 26) |
			((uint32_t)input[81] << 18) |
			((uint32_t)(input[82] & 0xc0) << 10);
	output[40] = (double)(value >> 16);

	// read output[41]: from bit 658 to 673
	value = ((uint32_t)(input[82] & 0x3f) << 26) |
			((uint32_t)input[83] << 18) |
			((uint32_t)(input[84] & 0xc0) << 10);
	output[41] = (double)(value >> 16);

	// read output[42]: from bit 674 to 689
	value = ((uint32_t)(input[84] & 0x3f) << 26) |
			((uint32_t)input[85] << 18) |
			((uint32_t)(input[86] & 0xc0) << 10);
	output[42] = (double)(value >> 16);

	// read output[43]: from bit 690 to 705
	value = ((uint32_t)(input[86] & 0x3f) << 26) |
			((uint32_t)input[87] << 18) |
			((uint32_t)(input[88] & 0xc0) << 10);
	output[43] = (double)(value >> 16);

	// read output[44]: from bit 706 to 721
	value = ((uint32_t)(input[88] & 0x3f) << 26) |
			((uint32_t)input[89] << 18) |
			((uint32_t)(input[90] & 0xc0) << 10);
	output[44] = (double)(value >> 16);

	// read output[45]: from bit 722 to 737
	value = ((uint32_t)(input[90] & 0x3f) << 26) |
			((uint32_t)input[91] << 18) |
			((uint32_t)(input[92] & 0xc0) << 10);
	output[45] = (double)(value >> 16);

	// read output[46]: from bit 738 to 753
	value = ((uint32_t)(input[92] & 0x3f) << 26) |
			((uint32_t)input[93] << 18) |
			((uint32_t)(input[94] & 0xc0) << 10);
	output[46] = (double)(value >> 16);

	// read output[47]: from bit 754 to 769
	value = ((uint32_t)(input[94] & 0x3f) << 26) |
			((uint32_t)input[95] << 18) |
			((uint32_t)(input[96] & 0xc0) << 10);
	output[47] = (double)(value >> 16);

	// read output[48]: from bit 770 to 785
	value = ((uint32_t)(input[96] & 0x3f) << 26) |
			((uint32_t)input[97] << 18) |
			((uint32_t)(input[98] & 0xc0) << 10);
	output[48] = (double)(value >> 16);

	// read output[49]: from bit 786 to 801
	value = ((uint32_t)(input[98] & 0x3f) << 26) |
			((uint32_t)input[99] << 18) |
			((uint32_t)(input[100] & 0xc0) << 10);
	output[49] = (double)(value >> 16);
}

static void unpack_50_16bit_signed_3off(const uint8_t * input, double * output, void *closure) {
	// Unpack 50 values into output
	// Values are 16-bit signed
	// Skip 3 bits, read 800 bits of data.
	// Input must be at least 101 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 3 to 18
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)input[1] << 19) |
			((uint32_t)(input[2] & 0xe0) << 11);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 19 to 34
	value = ((uint32_t)(input[2] & 0x1f) << 27) |
			((uint32_t)input[3] << 19) |
			((uint32_t)(input[4] & 0xe0) << 11);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 35 to 50
	value = ((uint32_t)(input[4] & 0x1f) << 27) |
			((uint32_t)input[5] << 19) |
			((uint32_t)(input[6] & 0xe0) << 11);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 51 to 66
	value = ((uint32_t)(input[6] & 0x1f) << 27) |
			((uint32_t)input[7] << 19) |
			((uint32_t)(input[8] & 0xe0) << 11);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 67 to 82
	value = ((uint32_t)(input[8] & 0x1f) << 27) |
			((uint32_t)input[9] << 19) |
			((uint32_t)(input[10] & 0xe0) << 11);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 83 to 98
	value = ((uint32_t)(input[10] & 0x1f) << 27) |
			((uint32_t)input[11] << 19) |
			((uint32_t)(input[12] & 0xe0) << 11);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 99 to 114
	value = ((uint32_t)(input[12] & 0x1f) << 27) |
			((uint32_t)input[13] << 19) |
			((uint32_t)(input[14] & 0xe0) << 11);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 115 to 130
	value = ((uint32_t)(input[14] & 0x1f) << 27) |
			((uint32_t)input[15] << 19) |
			((uint32_t)(input[16] & 0xe0) << 11);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 131 to 146
	value = ((uint32_t)(input[16] & 0x1f) << 27) |
			((uint32_t)input[17] << 19) |
			((uint32_t)(input[18] & 0xe0) << 11);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 147 to 162
	value = ((uint32_t)(input[18] & 0x1f) << 27) |
			((uint32_t)input[19] << 19) |
			((uint32_t)(input[20] & 0xe0) << 11);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 163 to 178
	value = ((uint32_t)(input[20] & 0x1f) << 27) |
			((uint32_t)input[21] << 19) |
			((uint32_t)(input[22] & 0xe0) << 11);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 179 to 194
	value = ((uint32_t)(input[22] & 0x1f) << 27) |
			((uint32_t)input[23] << 19) |
			((uint32_t)(input[24] & 0xe0) << 11);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 195 to 210
	value = ((uint32_t)(input[24] & 0x1f) << 27) |
			((uint32_t)input[25] << 19) |
			((uint32_t)(input[26] & 0xe0) << 11);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 211 to 226
	value = ((uint32_t)(input[26] & 0x1f) << 27) |
			((uint32_t)input[27] << 19) |
			((uint32_t)(input[28] & 0xe0) << 11);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 227 to 242
	value = ((uint32_t)(input[28] & 0x1f) << 27) |
			((uint32_t)input[29] << 19) |
			((uint32_t)(input[30] & 0xe0) << 11);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 243 to 258
	value = ((uint32_t)(input[30] & 0x1f) << 27) |
			((uint32_t)input[31] << 19) |
			((uint32_t)(input[32] & 0xe0) << 11);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 259 to 274
	value = ((uint32_t)(input[32] & 0x1f) << 27) |
			((uint32_t)input[33] << 19) |
			((uint32_t)(input[34] & 0xe0) << 11);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 275 to 290
	value = ((uint32_t)(input[34] & 0x1f) << 27) |
			((uint32_t)input[35] << 19) |
			((uint32_t)(input[36] & 0xe0) << 11);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 291 to 306
	value = ((uint32_t)(input[36] & 0x1f) << 27) |
			((uint32_t)input[37] << 19) |
			((uint32_t)(input[38] & 0xe0) << 11);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 307 to 322
	value = ((uint32_t)(input[38] & 0x1f) << 27) |
			((uint32_t)input[39] << 19) |
			((uint32_t)(input[40] & 0xe0) << 11);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 323 to 338
	value = ((uint32_t)(input[40] & 0x1f) << 27) |
			((uint32_t)input[41] << 19) |
			((uint32_t)(input[42] & 0xe0) << 11);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 339 to 354
	value = ((uint32_t)(input[42] & 0x1f) << 27) |
			((uint32_t)input[43] << 19) |
			((uint32_t)(input[44] & 0xe0) << 11);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 355 to 370
	value = ((uint32_t)(input[44] & 0x1f) << 27) |
			((uint32_t)input[45] << 19) |
			((uint32_t)(input[46] & 0xe0) << 11);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 371 to 386
	value = ((uint32_t)(input[46] & 0x1f) << 27) |
			((uint32_t)input[47] << 19) |
			((uint32_t)(input[48] & 0xe0) << 11);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 387 to 402
	value = ((uint32_t)(input[48] & 0x1f) << 27) |
			((uint32_t)input[49] << 19) |
			((uint32_t)(input[50] & 0xe0) << 11);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 403 to 418
	value = ((uint32_t)(input[50] & 0x1f) << 27) |
			((uint32_t)input[51] << 19) |
			((uint32_t)(input[52] & 0xe0) << 11);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 419 to 434
	value = ((uint32_t)(input[52] & 0x1f) << 27) |
			((uint32_t)input[53] << 19) |
			((uint32_t)(input[54] & 0xe0) << 11);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 435 to 450
	value = ((uint32_t)(input[54] & 0x1f) << 27) |
			((uint32_t)input[55] << 19) |
			((uint32_t)(input[56] & 0xe0) << 11);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 451 to 466
	value = ((uint32_t)(input[56] & 0x1f) << 27) |
			((uint32_t)input[57] << 19) |
			((uint32_t)(input[58] & 0xe0) << 11);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 467 to 482
	value = ((uint32_t)(input[58] & 0x1f) << 27) |
			((uint32_t)input[59] << 19) |
			((uint32_t)(input[60] & 0xe0) << 11);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 483 to 498
	value = ((uint32_t)(input[60] & 0x1f) << 27) |
			((uint32_t)input[61] << 19) |
			((uint32_t)(input[62] & 0xe0) << 11);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 499 to 514
	value = ((uint32_t)(input[62] & 0x1f) << 27) |
			((uint32_t)input[63] << 19) |
			((uint32_t)(input[64] & 0xe0) << 11);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 515 to 530
	value = ((uint32_t)(input[64] & 0x1f) << 27) |
			((uint32_t)input[65] << 19) |
			((uint32_t)(input[66] & 0xe0) << 11);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 531 to 546
	value = ((uint32_t)(input[66] & 0x1f) << 27) |
			((uint32_t)input[67] << 19) |
			((uint32_t)(input[68] & 0xe0) << 11);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 547 to 562
	value = ((uint32_t)(input[68] & 0x1f) << 27) |
			((uint32_t)input[69] << 19) |
			((uint32_t)(input[70] & 0xe0) << 11);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 563 to 578
	value = ((uint32_t)(input[70] & 0x1f) << 27) |
			((uint32_t)input[71] << 19) |
			((uint32_t)(input[72] & 0xe0) << 11);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 579 to 594
	value = ((uint32_t)(input[72] & 0x1f) << 27) |
			((uint32_t)input[73] << 19) |
			((uint32_t)(input[74] & 0xe0) << 11);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 595 to 610
	value = ((uint32_t)(input[74] & 0x1f) << 27) |
			((uint32_t)input[75] << 19) |
			((uint32_t)(input[76] & 0xe0) << 11);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 611 to 626
	value = ((uint32_t)(input[76] & 0x1f) << 27) |
			((uint32_t)input[77] << 19) |
			((uint32_t)(input[78] & 0xe0) << 11);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 627 to 642
	value = ((uint32_t)(input[78] & 0x1f) << 27) |
			((uint32_t)input[79] << 19) |
			((uint32_t)(input[80] & 0xe0) << 11);
	output[39] = (double)(value >> 16);

	// read output[40]: from bit 643 to 658
	value = ((uint32_t)(input[80] & 0x1f) << 27) |
			((uint32_t)input[81] << 19) |
			((uint32_t)(input[82] & 0xe0) << 11);
	output[40] = (double)(value >> 16);

	// read output[41]: from bit 659 to 674
	value = ((uint32_t)(input[82] & 0x1f) << 27) |
			((uint32_t)input[83] << 19) |
			((uint32_t)(input[84] & 0xe0) << 11);
	output[41] = (double)(value >> 16);

	// read output[42]: from bit 675 to 690
	value = ((uint32_t)(input[84] & 0x1f) << 27) |
			((uint32_t)input[85] << 19) |
			((uint32_t)(input[86] & 0xe0) << 11);
	output[42] = (double)(value >> 16);

	// read output[43]: from bit 691 to 706
	value = ((uint32_t)(input[86] & 0x1f) << 27) |
			((uint32_t)input[87] << 19) |
			((uint32_t)(input[88] & 0xe0) << 11);
	output[43] = (double)(value >> 16);

	// read output[44]: from bit 707 to 722
	value = ((uint32_t)(input[88] & 0x1f) << 27) |
			((uint32_t)input[89] << 19) |
			((uint32_t)(input[90] & 0xe0) << 11);
	output[44] = (double)(value >> 16);

	// read output[45]: from bit 723 to 738
	value = ((uint32_t)(input[90] & 0x1f) << 27) |
			((uint32_t)input[91] << 19) |
			((uint32_t)(input[92] & 0xe0) << 11);
	output[45] = (double)(value >> 16);

	// read output[46]: from bit 739 to 754
	value = ((uint32_t)(input[92] & 0x1f) << 27) |
			((uint32_t)input[93] << 19) |
			((uint32_t)(input[94] & 0xe0) << 11);
	output[46] = (double)(value >> 16);

	// read output[47]: from bit 755 to 770
	value = ((uint32_t)(input[94] & 0x1f) << 27) |
			((uint32_t)input[95] << 19) |
			((uint32_t)(input[96] & 0xe0) << 11);
	output[47] = (double)(value >> 16);

	// read output[48]: from bit 771 to 786
	value = ((uint32_t)(input[96] & 0x1f) << 27) |
			((uint32_t)input[97] << 19) |
			((uint32_t)(input[98] & 0xe0) << 11);
	output[48] = (double)(value >> 16);

	// read output[49]: from bit 787 to 802
	value = ((uint32_t)(input[98] & 0x1f) << 27) |
			((uint32_t)input[99] << 19) |
			((uint32_t)(input[100] & 0xe0) << 11);
	output[49] = (double)(value >> 16);
}

static void unpack_50_16bit_unsigned_3off(const uint8_t * input, double * output, void *closure) {
	// Unpack 50 values into output
	// Values are 16-bit unsigned
	// Skip 3 bits, read 800 bits of data.
	// Input must be at least 101 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 3 to 18
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)input[1] << 19) |
			((uint32_t)(input[2] & 0xe0) << 11);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 19 to 34
	value = ((uint32_t)(input[2] & 0x1f) << 27) |
			((uint32_t)input[3] << 19) |
			((uint32_t)(input[4] & 0xe0) << 11);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 35 to 50
	value = ((uint32_t)(input[4] & 0x1f) << 27) |
			((uint32_t)input[5] << 19) |
			((uint32_t)(input[6] & 0xe0) << 11);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 51 to 66
	value = ((uint32_t)(input[6] & 0x1f) << 27) |
			((uint32_t)input[7] << 19) |
			((uint32_t)(input[8] & 0xe0) << 11);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 67 to 82
	value = ((uint32_t)(input[8] & 0x1f) << 27) |
			((uint32_t)input[9] << 19) |
			((uint32_t)(input[10] & 0xe0) << 11);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 83 to 98
	value = ((uint32_t)(input[10] & 0x1f) << 27) |
			((uint32_t)input[11] << 19) |
			((uint32_t)(input[12] & 0xe0) << 11);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 99 to 114
	value = ((uint32_t)(input[12] & 0x1f) << 27) |
			((uint32_t)input[13] << 19) |
			((uint32_t)(input[14] & 0xe0) << 11);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 115 to 130
	value = ((uint32_t)(input[14] & 0x1f) << 27) |
			((uint32_t)input[15] << 19) |
			((uint32_t)(input[16] & 0xe0) << 11);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 131 to 146
	value = ((uint32_t)(input[16] & 0x1f) << 27) |
			((uint32_t)input[17] << 19) |
			((uint32_t)(input[18] & 0xe0) << 11);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 147 to 162
	value = ((uint32_t)(input[18] & 0x1f) << 27) |
			((uint32_t)input[19] << 19) |
			((uint32_t)(input[20] & 0xe0) << 11);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 163 to 178
	value = ((uint32_t)(input[20] & 0x1f) << 27) |
			((uint32_t)input[21] << 19) |
			((uint32_t)(input[22] & 0xe0) << 11);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 179 to 194
	value = ((uint32_t)(input[22] & 0x1f) << 27) |
			((uint32_t)input[23] << 19) |
			((uint32_t)(input[24] & 0xe0) << 11);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 195 to 210
	value = ((uint32_t)(input[24] & 0x1f) << 27) |
			((uint32_t)input[25] << 19) |
			((uint32_t)(input[26] & 0xe0) << 11);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 211 to 226
	value = ((uint32_t)(input[26] & 0x1f) << 27) |
			((uint32_t)input[27] << 19) |
			((uint32_t)(input[28] & 0xe0) << 11);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 227 to 242
	value = ((uint32_t)(input[28] & 0x1f) << 27) |
			((uint32_t)input[29] << 19) |
			((uint32_t)(input[30] & 0xe0) << 11);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 243 to 258
	value = ((uint32_t)(input[30] & 0x1f) << 27) |
			((uint32_t)input[31] << 19) |
			((uint32_t)(input[32] & 0xe0) << 11);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 259 to 274
	value = ((uint32_t)(input[32] & 0x1f) << 27) |
			((uint32_t)input[33] << 19) |
			((uint32_t)(input[34] & 0xe0) << 11);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 275 to 290
	value = ((uint32_t)(input[34] & 0x1f) << 27) |
			((uint32_t)input[35] << 19) |
			((uint32_t)(input[36] & 0xe0) << 11);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 291 to 306
	value = ((uint32_t)(input[36] & 0x1f) << 27) |
			((uint32_t)input[37] << 19) |
			((uint32_t)(input[38] & 0xe0) << 11);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 307 to 322
	value = ((uint32_t)(input[38] & 0x1f) << 27) |
			((uint32_t)input[39] << 19) |
			((uint32_t)(input[40] & 0xe0) << 11);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 323 to 338
	value = ((uint32_t)(input[40] & 0x1f) << 27) |
			((uint32_t)input[41] << 19) |
			((uint32_t)(input[42] & 0xe0) << 11);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 339 to 354
	value = ((uint32_t)(input[42] & 0x1f) << 27) |
			((uint32_t)input[43] << 19) |
			((uint32_t)(input[44] & 0xe0) << 11);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 355 to 370
	value = ((uint32_t)(input[44] & 0x1f) << 27) |
			((uint32_t)input[45] << 19) |
			((uint32_t)(input[46] & 0xe0) << 11);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 371 to 386
	value = ((uint32_t)(input[46] & 0x1f) << 27) |
			((uint32_t)input[47] << 19) |
			((uint32_t)(input[48] & 0xe0) << 11);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 387 to 402
	value = ((uint32_t)(input[48] & 0x1f) << 27) |
			((uint32_t)input[49] << 19) |
			((uint32_t)(input[50] & 0xe0) << 11);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 403 to 418
	value = ((uint32_t)(input[50] & 0x1f) << 27) |
			((uint32_t)input[51] << 19) |
			((uint32_t)(input[52] & 0xe0) << 11);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 419 to 434
	value = ((uint32_t)(input[52] & 0x1f) << 27) |
			((uint32_t)input[53] << 19) |
			((uint32_t)(input[54] & 0xe0) << 11);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 435 to 450
	value = ((uint32_t)(input[54] & 0x1f) << 27) |
			((uint32_t)input[55] << 19) |
			((uint32_t)(input[56] & 0xe0) << 11);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 451 to 466
	value = ((uint32_t)(input[56] & 0x1f) << 27) |
			((uint32_t)input[57] << 19) |
			((uint32_t)(input[58] & 0xe0) << 11);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 467 to 482
	value = ((uint32_t)(input[58] & 0x1f) << 27) |
			((uint32_t)input[59] << 19) |
			((uint32_t)(input[60] & 0xe0) << 11);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 483 to 498
	value = ((uint32_t)(input[60] & 0x1f) << 27) |
			((uint32_t)input[61] << 19) |
			((uint32_t)(input[62] & 0xe0) << 11);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 499 to 514
	value = ((uint32_t)(input[62] & 0x1f) << 27) |
			((uint32_t)input[63] << 19) |
			((uint32_t)(input[64] & 0xe0) << 11);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 515 to 530
	value = ((uint32_t)(input[64] & 0x1f) << 27) |
			((uint32_t)input[65] << 19) |
			((uint32_t)(input[66] & 0xe0) << 11);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 531 to 546
	value = ((uint32_t)(input[66] & 0x1f) << 27) |
			((uint32_t)input[67] << 19) |
			((uint32_t)(input[68] & 0xe0) << 11);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 547 to 562
	value = ((uint32_t)(input[68] & 0x1f) << 27) |
			((uint32_t)input[69] << 19) |
			((uint32_t)(input[70] & 0xe0) << 11);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 563 to 578
	value = ((uint32_t)(input[70] & 0x1f) << 27) |
			((uint32_t)input[71] << 19) |
			((uint32_t)(input[72] & 0xe0) << 11);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 579 to 594
	value = ((uint32_t)(input[72] & 0x1f) << 27) |
			((uint32_t)input[73] << 19) |
			((uint32_t)(input[74] & 0xe0) << 11);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 595 to 610
	value = ((uint32_t)(input[74] & 0x1f) << 27) |
			((uint32_t)input[75] << 19) |
			((uint32_t)(input[76] & 0xe0) << 11);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 611 to 626
	value = ((uint32_t)(input[76] & 0x1f) << 27) |
			((uint32_t)input[77] << 19) |
			((uint32_t)(input[78] & 0xe0) << 11);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 627 to 642
	value = ((uint32_t)(input[78] & 0x1f) << 27) |
			((uint32_t)input[79] << 19) |
			((uint32_t)(input[80] & 0xe0) << 11);
	output[39] = (double)(value >> 16);

	// read output[40]: from bit 643 to 658
	value = ((uint32_t)(input[80] & 0x1f) << 27) |
			((uint32_t)input[81] << 19) |
			((uint32_t)(input[82] & 0xe0) << 11);
	output[40] = (double)(value >> 16);

	// read output[41]: from bit 659 to 674
	value = ((uint32_t)(input[82] & 0x1f) << 27) |
			((uint32_t)input[83] << 19) |
			((uint32_t)(input[84] & 0xe0) << 11);
	output[41] = (double)(value >> 16);

	// read output[42]: from bit 675 to 690
	value = ((uint32_t)(input[84] & 0x1f) << 27) |
			((uint32_t)input[85] << 19) |
			((uint32_t)(input[86] & 0xe0) << 11);
	output[42] = (double)(value >> 16);

	// read output[43]: from bit 691 to 706
	value = ((uint32_t)(input[86] & 0x1f) << 27) |
			((uint32_t)input[87] << 19) |
			((uint32_t)(input[88] & 0xe0) << 11);
	output[43] = (double)(value >> 16);

	// read output[44]: from bit 707 to 722
	value = ((uint32_t)(input[88] & 0x1f) << 27) |
			((uint32_t)input[89] << 19) |
			((uint32_t)(input[90] & 0xe0) << 11);
	output[44] = (double)(value >> 16);

	// read output[45]: from bit 723 to 738
	value = ((uint32_t)(input[90] & 0x1f) << 27) |
			((uint32_t)input[91] << 19) |
			((uint32_t)(input[92] & 0xe0) << 11);
	output[45] = (double)(value >> 16);

	// read output[46]: from bit 739 to 754
	value = ((uint32_t)(input[92] & 0x1f) << 27) |
			((uint32_t)input[93] << 19) |
			((uint32_t)(input[94] & 0xe0) << 11);
	output[46] = (double)(value >> 16);

	// read output[47]: from bit 755 to 770
	value = ((uint32_t)(input[94] & 0x1f) << 27) |
			((uint32_t)input[95] << 19) |
			((uint32_t)(input[96] & 0xe0) << 11);
	output[47] = (double)(value >> 16);

	// read output[48]: from bit 771 to 786
	value = ((uint32_t)(input[96] & 0x1f) << 27) |
			((uint32_t)input[97] << 19) |
			((uint32_t)(input[98] & 0xe0) << 11);
	output[48] = (double)(value >> 16);

	// read output[49]: from bit 787 to 802
	value = ((uint32_t)(input[98] & 0x1f) << 27) |
			((uint32_t)input[99] << 19) |
			((uint32_t)(input[100] & 0xe0) << 11);
	output[49] = (double)(value >> 16);
}

static void unpack_50_16bit_signed_4off(const uint8_t * input, double * output, void *closure) {
	// Unpack 50 values into output
	// Values are 16-bit signed
	// Skip 4 bits, read 800 bits of data.
	// Input must be at least 101 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 4 to 19
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20) |
			((uint32_t)(input[2] & 0xf0) << 12);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 20 to 35
	value = ((uint32_t)(input[2] & 0x0f) << 28) |
			((uint32_t)input[3] << 20) |
			((uint32_t)(input[4] & 0xf0) << 12);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 36 to 51
	value = ((uint32_t)(input[4] & 0x0f) << 28) |
			((uint32_t)input[5] << 20) |
			((uint32_t)(input[6] & 0xf0) << 12);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 52 to 67
	value = ((uint32_t)(input[6] & 0x0f) << 28) |
			((uint32_t)input[7] << 20) |
			((uint32_t)(input[8] & 0xf0) << 12);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 68 to 83
	value = ((uint32_t)(input[8] & 0x0f) << 28) |
			((uint32_t)input[9] << 20) |
			((uint32_t)(input[10] & 0xf0) << 12);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 84 to 99
	value = ((uint32_t)(input[10] & 0x0f) << 28) |
			((uint32_t)input[11] << 20) |
			((uint32_t)(input[12] & 0xf0) << 12);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 100 to 115
	value = ((uint32_t)(input[12] & 0x0f) << 28) |
			((uint32_t)input[13] << 20) |
			((uint32_t)(input[14] & 0xf0) << 12);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 116 to 131
	value = ((uint32_t)(input[14] & 0x0f) << 28) |
			((uint32_t)input[15] << 20) |
			((uint32_t)(input[16] & 0xf0) << 12);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 132 to 147
	value = ((uint32_t)(input[16] & 0x0f) << 28) |
			((uint32_t)input[17] << 20) |
			((uint32_t)(input[18] & 0xf0) << 12);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 148 to 163
	value = ((uint32_t)(input[18] & 0x0f) << 28) |
			((uint32_t)input[19] << 20) |
			((uint32_t)(input[20] & 0xf0) << 12);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 164 to 179
	value = ((uint32_t)(input[20] & 0x0f) << 28) |
			((uint32_t)input[21] << 20) |
			((uint32_t)(input[22] & 0xf0) << 12);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 180 to 195
	value = ((uint32_t)(input[22] & 0x0f) << 28) |
			((uint32_t)input[23] << 20) |
			((uint32_t)(input[24] & 0xf0) << 12);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 196 to 211
	value = ((uint32_t)(input[24] & 0x0f) << 28) |
			((uint32_t)input[25] << 20) |
			((uint32_t)(input[26] & 0xf0) << 12);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 212 to 227
	value = ((uint32_t)(input[26] & 0x0f) << 28) |
			((uint32_t)input[27] << 20) |
			((uint32_t)(input[28] & 0xf0) << 12);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 228 to 243
	value = ((uint32_t)(input[28] & 0x0f) << 28) |
			((uint32_t)input[29] << 20) |
			((uint32_t)(input[30] & 0xf0) << 12);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 244 to 259
	value = ((uint32_t)(input[30] & 0x0f) << 28) |
			((uint32_t)input[31] << 20) |
			((uint32_t)(input[32] & 0xf0) << 12);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 260 to 275
	value = ((uint32_t)(input[32] & 0x0f) << 28) |
			((uint32_t)input[33] << 20) |
			((uint32_t)(input[34] & 0xf0) << 12);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 276 to 291
	value = ((uint32_t)(input[34] & 0x0f) << 28) |
			((uint32_t)input[35] << 20) |
			((uint32_t)(input[36] & 0xf0) << 12);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 292 to 307
	value = ((uint32_t)(input[36] & 0x0f) << 28) |
			((uint32_t)input[37] << 20) |
			((uint32_t)(input[38] & 0xf0) << 12);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 308 to 323
	value = ((uint32_t)(input[38] & 0x0f) << 28) |
			((uint32_t)input[39] << 20) |
			((uint32_t)(input[40] & 0xf0) << 12);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 324 to 339
	value = ((uint32_t)(input[40] & 0x0f) << 28) |
			((uint32_t)input[41] << 20) |
			((uint32_t)(input[42] & 0xf0) << 12);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 340 to 355
	value = ((uint32_t)(input[42] & 0x0f) << 28) |
			((uint32_t)input[43] << 20) |
			((uint32_t)(input[44] & 0xf0) << 12);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 356 to 371
	value = ((uint32_t)(input[44] & 0x0f) << 28) |
			((uint32_t)input[45] << 20) |
			((uint32_t)(input[46] & 0xf0) << 12);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 372 to 387
	value = ((uint32_t)(input[46] & 0x0f) << 28) |
			((uint32_t)input[47] << 20) |
			((uint32_t)(input[48] & 0xf0) << 12);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 388 to 403
	value = ((uint32_t)(input[48] & 0x0f) << 28) |
			((uint32_t)input[49] << 20) |
			((uint32_t)(input[50] & 0xf0) << 12);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 404 to 419
	value = ((uint32_t)(input[50] & 0x0f) << 28) |
			((uint32_t)input[51] << 20) |
			((uint32_t)(input[52] & 0xf0) << 12);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 420 to 435
	value = ((uint32_t)(input[52] & 0x0f) << 28) |
			((uint32_t)input[53] << 20) |
			((uint32_t)(input[54] & 0xf0) << 12);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 436 to 451
	value = ((uint32_t)(input[54] & 0x0f) << 28) |
			((uint32_t)input[55] << 20) |
			((uint32_t)(input[56] & 0xf0) << 12);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 452 to 467
	value = ((uint32_t)(input[56] & 0x0f) << 28) |
			((uint32_t)input[57] << 20) |
			((uint32_t)(input[58] & 0xf0) << 12);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 468 to 483
	value = ((uint32_t)(input[58] & 0x0f) << 28) |
			((uint32_t)input[59] << 20) |
			((uint32_t)(input[60] & 0xf0) << 12);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 484 to 499
	value = ((uint32_t)(input[60] & 0x0f) << 28) |
			((uint32_t)input[61] << 20) |
			((uint32_t)(input[62] & 0xf0) << 12);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 500 to 515
	value = ((uint32_t)(input[62] & 0x0f) << 28) |
			((uint32_t)input[63] << 20) |
			((uint32_t)(input[64] & 0xf0) << 12);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 516 to 531
	value = ((uint32_t)(input[64] & 0x0f) << 28) |
			((uint32_t)input[65] << 20) |
			((uint32_t)(input[66] & 0xf0) << 12);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 532 to 547
	value = ((uint32_t)(input[66] & 0x0f) << 28) |
			((uint32_t)input[67] << 20) |
			((uint32_t)(input[68] & 0xf0) << 12);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 548 to 563
	value = ((uint32_t)(input[68] & 0x0f) << 28) |
			((uint32_t)input[69] << 20) |
			((uint32_t)(input[70] & 0xf0) << 12);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 564 to 579
	value = ((uint32_t)(input[70] & 0x0f) << 28) |
			((uint32_t)input[71] << 20) |
			((uint32_t)(input[72] & 0xf0) << 12);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 580 to 595
	value = ((uint32_t)(input[72] & 0x0f) << 28) |
			((uint32_t)input[73] << 20) |
			((uint32_t)(input[74] & 0xf0) << 12);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 596 to 611
	value = ((uint32_t)(input[74] & 0x0f) << 28) |
			((uint32_t)input[75] << 20) |
			((uint32_t)(input[76] & 0xf0) << 12);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 612 to 627
	value = ((uint32_t)(input[76] & 0x0f) << 28) |
			((uint32_t)input[77] << 20) |
			((uint32_t)(input[78] & 0xf0) << 12);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 628 to 643
	value = ((uint32_t)(input[78] & 0x0f) << 28) |
			((uint32_t)input[79] << 20) |
			((uint32_t)(input[80] & 0xf0) << 12);
	output[39] = (double)(value >> 16);

	// read output[40]: from bit 644 to 659
	value = ((uint32_t)(input[80] & 0x0f) << 28) |
			((uint32_t)input[81] << 20) |
			((uint32_t)(input[82] & 0xf0) << 12);
	output[40] = (double)(value >> 16);

	// read output[41]: from bit 660 to 675
	value = ((uint32_t)(input[82] & 0x0f) << 28) |
			((uint32_t)input[83] << 20) |
			((uint32_t)(input[84] & 0xf0) << 12);
	output[41] = (double)(value >> 16);

	// read output[42]: from bit 676 to 691
	value = ((uint32_t)(input[84] & 0x0f) << 28) |
			((uint32_t)input[85] << 20) |
			((uint32_t)(input[86] & 0xf0) << 12);
	output[42] = (double)(value >> 16);

	// read output[43]: from bit 692 to 707
	value = ((uint32_t)(input[86] & 0x0f) << 28) |
			((uint32_t)input[87] << 20) |
			((uint32_t)(input[88] & 0xf0) << 12);
	output[43] = (double)(value >> 16);

	// read output[44]: from bit 708 to 723
	value = ((uint32_t)(input[88] & 0x0f) << 28) |
			((uint32_t)input[89] << 20) |
			((uint32_t)(input[90] & 0xf0) << 12);
	output[44] = (double)(value >> 16);

	// read output[45]: from bit 724 to 739
	value = ((uint32_t)(input[90] & 0x0f) << 28) |
			((uint32_t)input[91] << 20) |
			((uint32_t)(input[92] & 0xf0) << 12);
	output[45] = (double)(value >> 16);

	// read output[46]: from bit 740 to 755
	value = ((uint32_t)(input[92] & 0x0f) << 28) |
			((uint32_t)input[93] << 20) |
			((uint32_t)(input[94] & 0xf0) << 12);
	output[46] = (double)(value >> 16);

	// read output[47]: from bit 756 to 771
	value = ((uint32_t)(input[94] & 0x0f) << 28) |
			((uint32_t)input[95] << 20) |
			((uint32_t)(input[96] & 0xf0) << 12);
	output[47] = (double)(value >> 16);

	// read output[48]: from bit 772 to 787
	value = ((uint32_t)(input[96] & 0x0f) << 28) |
			((uint32_t)input[97] << 20) |
			((uint32_t)(input[98] & 0xf0) << 12);
	output[48] = (double)(value >> 16);

	// read output[49]: from bit 788 to 803
	value = ((uint32_t)(input[98] & 0x0f) << 28) |
			((uint32_t)input[99] << 20) |
			((uint32_t)(input[100] & 0xf0) << 12);
	output[49] = (double)(value >> 16);
}

static void unpack_50_16bit_unsigned_4off(const uint8_t * input, double * output, void *closure) {
	// Unpack 50 values into output
	// Values are 16-bit unsigned
	// Skip 4 bits, read 800 bits of data.
	// Input must be at least 101 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 4 to 19
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20) |
			((uint32_t)(input[2] & 0xf0) << 12);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 20 to 35
	value = ((uint32_t)(input[2] & 0x0f) << 28) |
			((uint32_t)input[3] << 20) |
			((uint32_t)(input[4] & 0xf0) << 12);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 36 to 51
	value = ((uint32_t)(input[4] & 0x0f) << 28) |
			((uint32_t)input[5] << 20) |
			((uint32_t)(input[6] & 0xf0) << 12);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 52 to 67
	value = ((uint32_t)(input[6] & 0x0f) << 28) |
			((uint32_t)input[7] << 20) |
			((uint32_t)(input[8] & 0xf0) << 12);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 68 to 83
	value = ((uint32_t)(input[8] & 0x0f) << 28) |
			((uint32_t)input[9] << 20) |
			((uint32_t)(input[10] & 0xf0) << 12);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 84 to 99
	value = ((uint32_t)(input[10] & 0x0f) << 28) |
			((uint32_t)input[11] << 20) |
			((uint32_t)(input[12] & 0xf0) << 12);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 100 to 115
	value = ((uint32_t)(input[12] & 0x0f) << 28) |
			((uint32_t)input[13] << 20) |
			((uint32_t)(input[14] & 0xf0) << 12);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 116 to 131
	value = ((uint32_t)(input[14] & 0x0f) << 28) |
			((uint32_t)input[15] << 20) |
			((uint32_t)(input[16] & 0xf0) << 12);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 132 to 147
	value = ((uint32_t)(input[16] & 0x0f) << 28) |
			((uint32_t)input[17] << 20) |
			((uint32_t)(input[18] & 0xf0) << 12);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 148 to 163
	value = ((uint32_t)(input[18] & 0x0f) << 28) |
			((uint32_t)input[19] << 20) |
			((uint32_t)(input[20] & 0xf0) << 12);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 164 to 179
	value = ((uint32_t)(input[20] & 0x0f) << 28) |
			((uint32_t)input[21] << 20) |
			((uint32_t)(input[22] & 0xf0) << 12);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 180 to 195
	value = ((uint32_t)(input[22] & 0x0f) << 28) |
			((uint32_t)input[23] << 20) |
			((uint32_t)(input[24] & 0xf0) << 12);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 196 to 211
	value = ((uint32_t)(input[24] & 0x0f) << 28) |
			((uint32_t)input[25] << 20) |
			((uint32_t)(input[26] & 0xf0) << 12);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 212 to 227
	value = ((uint32_t)(input[26] & 0x0f) << 28) |
			((uint32_t)input[27] << 20) |
			((uint32_t)(input[28] & 0xf0) << 12);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 228 to 243
	value = ((uint32_t)(input[28] & 0x0f) << 28) |
			((uint32_t)input[29] << 20) |
			((uint32_t)(input[30] & 0xf0) << 12);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 244 to 259
	value = ((uint32_t)(input[30] & 0x0f) << 28) |
			((uint32_t)input[31] << 20) |
			((uint32_t)(input[32] & 0xf0) << 12);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 260 to 275
	value = ((uint32_t)(input[32] & 0x0f) << 28) |
			((uint32_t)input[33] << 20) |
			((uint32_t)(input[34] & 0xf0) << 12);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 276 to 291
	value = ((uint32_t)(input[34] & 0x0f) << 28) |
			((uint32_t)input[35] << 20) |
			((uint32_t)(input[36] & 0xf0) << 12);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 292 to 307
	value = ((uint32_t)(input[36] & 0x0f) << 28) |
			((uint32_t)input[37] << 20) |
			((uint32_t)(input[38] & 0xf0) << 12);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 308 to 323
	value = ((uint32_t)(input[38] & 0x0f) << 28) |
			((uint32_t)input[39] << 20) |
			((uint32_t)(input[40] & 0xf0) << 12);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 324 to 339
	value = ((uint32_t)(input[40] & 0x0f) << 28) |
			((uint32_t)input[41] << 20) |
			((uint32_t)(input[42] & 0xf0) << 12);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 340 to 355
	value = ((uint32_t)(input[42] & 0x0f) << 28) |
			((uint32_t)input[43] << 20) |
			((uint32_t)(input[44] & 0xf0) << 12);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 356 to 371
	value = ((uint32_t)(input[44] & 0x0f) << 28) |
			((uint32_t)input[45] << 20) |
			((uint32_t)(input[46] & 0xf0) << 12);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 372 to 387
	value = ((uint32_t)(input[46] & 0x0f) << 28) |
			((uint32_t)input[47] << 20) |
			((uint32_t)(input[48] & 0xf0) << 12);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 388 to 403
	value = ((uint32_t)(input[48] & 0x0f) << 28) |
			((uint32_t)input[49] << 20) |
			((uint32_t)(input[50] & 0xf0) << 12);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 404 to 419
	value = ((uint32_t)(input[50] & 0x0f) << 28) |
			((uint32_t)input[51] << 20) |
			((uint32_t)(input[52] & 0xf0) << 12);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 420 to 435
	value = ((uint32_t)(input[52] & 0x0f) << 28) |
			((uint32_t)input[53] << 20) |
			((uint32_t)(input[54] & 0xf0) << 12);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 436 to 451
	value = ((uint32_t)(input[54] & 0x0f) << 28) |
			((uint32_t)input[55] << 20) |
			((uint32_t)(input[56] & 0xf0) << 12);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 452 to 467
	value = ((uint32_t)(input[56] & 0x0f) << 28) |
			((uint32_t)input[57] << 20) |
			((uint32_t)(input[58] & 0xf0) << 12);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 468 to 483
	value = ((uint32_t)(input[58] & 0x0f) << 28) |
			((uint32_t)input[59] << 20) |
			((uint32_t)(input[60] & 0xf0) << 12);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 484 to 499
	value = ((uint32_t)(input[60] & 0x0f) << 28) |
			((uint32_t)input[61] << 20) |
			((uint32_t)(input[62] & 0xf0) << 12);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 500 to 515
	value = ((uint32_t)(input[62] & 0x0f) << 28) |
			((uint32_t)input[63] << 20) |
			((uint32_t)(input[64] & 0xf0) << 12);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 516 to 531
	value = ((uint32_t)(input[64] & 0x0f) << 28) |
			((uint32_t)input[65] << 20) |
			((uint32_t)(input[66] & 0xf0) << 12);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 532 to 547
	value = ((uint32_t)(input[66] & 0x0f) << 28) |
			((uint32_t)input[67] << 20) |
			((uint32_t)(input[68] & 0xf0) << 12);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 548 to 563
	value = ((uint32_t)(input[68] & 0x0f) << 28) |
			((uint32_t)input[69] << 20) |
			((uint32_t)(input[70] & 0xf0) << 12);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 564 to 579
	value = ((uint32_t)(input[70] & 0x0f) << 28) |
			((uint32_t)input[71] << 20) |
			((uint32_t)(input[72] & 0xf0) << 12);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 580 to 595
	value = ((uint32_t)(input[72] & 0x0f) << 28) |
			((uint32_t)input[73] << 20) |
			((uint32_t)(input[74] & 0xf0) << 12);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 596 to 611
	value = ((uint32_t)(input[74] & 0x0f) << 28) |
			((uint32_t)input[75] << 20) |
			((uint32_t)(input[76] & 0xf0) << 12);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 612 to 627
	value = ((uint32_t)(input[76] & 0x0f) << 28) |
			((uint32_t)input[77] << 20) |
			((uint32_t)(input[78] & 0xf0) << 12);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 628 to 643
	value = ((uint32_t)(input[78] & 0x0f) << 28) |
			((uint32_t)input[79] << 20) |
			((uint32_t)(input[80] & 0xf0) << 12);
	output[39] = (double)(value >> 16);

	// read output[40]: from bit 644 to 659
	value = ((uint32_t)(input[80] & 0x0f) << 28) |
			((uint32_t)input[81] << 20) |
			((uint32_t)(input[82] & 0xf0) << 12);
	output[40] = (double)(value >> 16);

	// read output[41]: from bit 660 to 675
	value = ((uint32_t)(input[82] & 0x0f) << 28) |
			((uint32_t)input[83] << 20) |
			((uint32_t)(input[84] & 0xf0) << 12);
	output[41] = (double)(value >> 16);

	// read output[42]: from bit 676 to 691
	value = ((uint32_t)(input[84] & 0x0f) << 28) |
			((uint32_t)input[85] << 20) |
			((uint32_t)(input[86] & 0xf0) << 12);
	output[42] = (double)(value >> 16);

	// read output[43]: from bit 692 to 707
	value = ((uint32_t)(input[86] & 0x0f) << 28) |
			((uint32_t)input[87] << 20) |
			((uint32_t)(input[88] & 0xf0) << 12);
	output[43] = (double)(value >> 16);

	// read output[44]: from bit 708 to 723
	value = ((uint32_t)(input[88] & 0x0f) << 28) |
			((uint32_t)input[89] << 20) |
			((uint32_t)(input[90] & 0xf0) << 12);
	output[44] = (double)(value >> 16);

	// read output[45]: from bit 724 to 739
	value = ((uint32_t)(input[90] & 0x0f) << 28) |
			((uint32_t)input[91] << 20) |
			((uint32_t)(input[92] & 0xf0) << 12);
	output[45] = (double)(value >> 16);

	// read output[46]: from bit 740 to 755
	value = ((uint32_t)(input[92] & 0x0f) << 28) |
			((uint32_t)input[93] << 20) |
			((uint32_t)(input[94] & 0xf0) << 12);
	output[46] = (double)(value >> 16);

	// read output[47]: from bit 756 to 771
	value = ((uint32_t)(input[94] & 0x0f) << 28) |
			((uint32_t)input[95] << 20) |
			((uint32_t)(input[96] & 0xf0) << 12);
	output[47] = (double)(value >> 16);

	// read output[48]: from bit 772 to 787
	value = ((uint32_t)(input[96] & 0x0f) << 28) |
			((uint32_t)input[97] << 20) |
			((uint32_t)(input[98] & 0xf0) << 12);
	output[48] = (double)(value >> 16);

	// read output[49]: from bit 788 to 803
	value = ((uint32_t)(input[98] & 0x0f) << 28) |
			((uint32_t)input[99] << 20) |
			((uint32_t)(input[100] & 0xf0) << 12);
	output[49] = (double)(value >> 16);
}

static void unpack_50_16bit_signed_5off(const uint8_t * input, double * output, void *closure) {
	// Unpack 50 values into output
	// Values are 16-bit signed
	// Skip 5 bits, read 800 bits of data.
	// Input must be at least 101 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 5 to 20
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)(input[2] & 0xf8) << 13);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 21 to 36
	value = ((uint32_t)(input[2] & 0x07) << 29) |
			((uint32_t)input[3] << 21) |
			((uint32_t)(input[4] & 0xf8) << 13);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 37 to 52
	value = ((uint32_t)(input[4] & 0x07) << 29) |
			((uint32_t)input[5] << 21) |
			((uint32_t)(input[6] & 0xf8) << 13);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 53 to 68
	value = ((uint32_t)(input[6] & 0x07) << 29) |
			((uint32_t)input[7] << 21) |
			((uint32_t)(input[8] & 0xf8) << 13);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 69 to 84
	value = ((uint32_t)(input[8] & 0x07) << 29) |
			((uint32_t)input[9] << 21) |
			((uint32_t)(input[10] & 0xf8) << 13);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 85 to 100
	value = ((uint32_t)(input[10] & 0x07) << 29) |
			((uint32_t)input[11] << 21) |
			((uint32_t)(input[12] & 0xf8) << 13);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 101 to 116
	value = ((uint32_t)(input[12] & 0x07) << 29) |
			((uint32_t)input[13] << 21) |
			((uint32_t)(input[14] & 0xf8) << 13);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 117 to 132
	value = ((uint32_t)(input[14] & 0x07) << 29) |
			((uint32_t)input[15] << 21) |
			((uint32_t)(input[16] & 0xf8) << 13);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 133 to 148
	value = ((uint32_t)(input[16] & 0x07) << 29) |
			((uint32_t)input[17] << 21) |
			((uint32_t)(input[18] & 0xf8) << 13);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 149 to 164
	value = ((uint32_t)(input[18] & 0x07) << 29) |
			((uint32_t)input[19] << 21) |
			((uint32_t)(input[20] & 0xf8) << 13);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 165 to 180
	value = ((uint32_t)(input[20] & 0x07) << 29) |
			((uint32_t)input[21] << 21) |
			((uint32_t)(input[22] & 0xf8) << 13);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 181 to 196
	value = ((uint32_t)(input[22] & 0x07) << 29) |
			((uint32_t)input[23] << 21) |
			((uint32_t)(input[24] & 0xf8) << 13);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 197 to 212
	value = ((uint32_t)(input[24] & 0x07) << 29) |
			((uint32_t)input[25] << 21) |
			((uint32_t)(input[26] & 0xf8) << 13);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 213 to 228
	value = ((uint32_t)(input[26] & 0x07) << 29) |
			((uint32_t)input[27] << 21) |
			((uint32_t)(input[28] & 0xf8) << 13);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 229 to 244
	value = ((uint32_t)(input[28] & 0x07) << 29) |
			((uint32_t)input[29] << 21) |
			((uint32_t)(input[30] & 0xf8) << 13);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 245 to 260
	value = ((uint32_t)(input[30] & 0x07) << 29) |
			((uint32_t)input[31] << 21) |
			((uint32_t)(input[32] & 0xf8) << 13);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 261 to 276
	value = ((uint32_t)(input[32] & 0x07) << 29) |
			((uint32_t)input[33] << 21) |
			((uint32_t)(input[34] & 0xf8) << 13);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 277 to 292
	value = ((uint32_t)(input[34] & 0x07) << 29) |
			((uint32_t)input[35] << 21) |
			((uint32_t)(input[36] & 0xf8) << 13);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 293 to 308
	value = ((uint32_t)(input[36] & 0x07) << 29) |
			((uint32_t)input[37] << 21) |
			((uint32_t)(input[38] & 0xf8) << 13);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 309 to 324
	value = ((uint32_t)(input[38] & 0x07) << 29) |
			((uint32_t)input[39] << 21) |
			((uint32_t)(input[40] & 0xf8) << 13);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 325 to 340
	value = ((uint32_t)(input[40] & 0x07) << 29) |
			((uint32_t)input[41] << 21) |
			((uint32_t)(input[42] & 0xf8) << 13);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 341 to 356
	value = ((uint32_t)(input[42] & 0x07) << 29) |
			((uint32_t)input[43] << 21) |
			((uint32_t)(input[44] & 0xf8) << 13);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 357 to 372
	value = ((uint32_t)(input[44] & 0x07) << 29) |
			((uint32_t)input[45] << 21) |
			((uint32_t)(input[46] & 0xf8) << 13);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 373 to 388
	value = ((uint32_t)(input[46] & 0x07) << 29) |
			((uint32_t)input[47] << 21) |
			((uint32_t)(input[48] & 0xf8) << 13);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 389 to 404
	value = ((uint32_t)(input[48] & 0x07) << 29) |
			((uint32_t)input[49] << 21) |
			((uint32_t)(input[50] & 0xf8) << 13);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 405 to 420
	value = ((uint32_t)(input[50] & 0x07) << 29) |
			((uint32_t)input[51] << 21) |
			((uint32_t)(input[52] & 0xf8) << 13);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 421 to 436
	value = ((uint32_t)(input[52] & 0x07) << 29) |
			((uint32_t)input[53] << 21) |
			((uint32_t)(input[54] & 0xf8) << 13);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 437 to 452
	value = ((uint32_t)(input[54] & 0x07) << 29) |
			((uint32_t)input[55] << 21) |
			((uint32_t)(input[56] & 0xf8) << 13);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 453 to 468
	value = ((uint32_t)(input[56] & 0x07) << 29) |
			((uint32_t)input[57] << 21) |
			((uint32_t)(input[58] & 0xf8) << 13);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 469 to 484
	value = ((uint32_t)(input[58] & 0x07) << 29) |
			((uint32_t)input[59] << 21) |
			((uint32_t)(input[60] & 0xf8) << 13);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 485 to 500
	value = ((uint32_t)(input[60] & 0x07) << 29) |
			((uint32_t)input[61] << 21) |
			((uint32_t)(input[62] & 0xf8) << 13);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 501 to 516
	value = ((uint32_t)(input[62] & 0x07) << 29) |
			((uint32_t)input[63] << 21) |
			((uint32_t)(input[64] & 0xf8) << 13);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 517 to 532
	value = ((uint32_t)(input[64] & 0x07) << 29) |
			((uint32_t)input[65] << 21) |
			((uint32_t)(input[66] & 0xf8) << 13);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 533 to 548
	value = ((uint32_t)(input[66] & 0x07) << 29) |
			((uint32_t)input[67] << 21) |
			((uint32_t)(input[68] & 0xf8) << 13);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 549 to 564
	value = ((uint32_t)(input[68] & 0x07) << 29) |
			((uint32_t)input[69] << 21) |
			((uint32_t)(input[70] & 0xf8) << 13);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 565 to 580
	value = ((uint32_t)(input[70] & 0x07) << 29) |
			((uint32_t)input[71] << 21) |
			((uint32_t)(input[72] & 0xf8) << 13);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 581 to 596
	value = ((uint32_t)(input[72] & 0x07) << 29) |
			((uint32_t)input[73] << 21) |
			((uint32_t)(input[74] & 0xf8) << 13);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 597 to 612
	value = ((uint32_t)(input[74] & 0x07) << 29) |
			((uint32_t)input[75] << 21) |
			((uint32_t)(input[76] & 0xf8) << 13);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 613 to 628
	value = ((uint32_t)(input[76] & 0x07) << 29) |
			((uint32_t)input[77] << 21) |
			((uint32_t)(input[78] & 0xf8) << 13);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 629 to 644
	value = ((uint32_t)(input[78] & 0x07) << 29) |
			((uint32_t)input[79] << 21) |
			((uint32_t)(input[80] & 0xf8) << 13);
	output[39] = (double)(value >> 16);

	// read output[40]: from bit 645 to 660
	value = ((uint32_t)(input[80] & 0x07) << 29) |
			((uint32_t)input[81] << 21) |
			((uint32_t)(input[82] & 0xf8) << 13);
	output[40] = (double)(value >> 16);

	// read output[41]: from bit 661 to 676
	value = ((uint32_t)(input[82] & 0x07) << 29) |
			((uint32_t)input[83] << 21) |
			((uint32_t)(input[84] & 0xf8) << 13);
	output[41] = (double)(value >> 16);

	// read output[42]: from bit 677 to 692
	value = ((uint32_t)(input[84] & 0x07) << 29) |
			((uint32_t)input[85] << 21) |
			((uint32_t)(input[86] & 0xf8) << 13);
	output[42] = (double)(value >> 16);

	// read output[43]: from bit 693 to 708
	value = ((uint32_t)(input[86] & 0x07) << 29) |
			((uint32_t)input[87] << 21) |
			((uint32_t)(input[88] & 0xf8) << 13);
	output[43] = (double)(value >> 16);

	// read output[44]: from bit 709 to 724
	value = ((uint32_t)(input[88] & 0x07) << 29) |
			((uint32_t)input[89] << 21) |
			((uint32_t)(input[90] & 0xf8) << 13);
	output[44] = (double)(value >> 16);

	// read output[45]: from bit 725 to 740
	value = ((uint32_t)(input[90] & 0x07) << 29) |
			((uint32_t)input[91] << 21) |
			((uint32_t)(input[92] & 0xf8) << 13);
	output[45] = (double)(value >> 16);

	// read output[46]: from bit 741 to 756
	value = ((uint32_t)(input[92] & 0x07) << 29) |
			((uint32_t)input[93] << 21) |
			((uint32_t)(input[94] & 0xf8) << 13);
	output[46] = (double)(value >> 16);

	// read output[47]: from bit 757 to 772
	value = ((uint32_t)(input[94] & 0x07) << 29) |
			((uint32_t)input[95] << 21) |
			((uint32_t)(input[96] & 0xf8) << 13);
	output[47] = (double)(value >> 16);

	// read output[48]: from bit 773 to 788
	value = ((uint32_t)(input[96] & 0x07) << 29) |
			((uint32_t)input[97] << 21) |
			((uint32_t)(input[98] & 0xf8) << 13);
	output[48] = (double)(value >> 16);

	// read output[49]: from bit 789 to 804
	value = ((uint32_t)(input[98] & 0x07) << 29) |
			((uint32_t)input[99] << 21) |
			((uint32_t)(input[100] & 0xf8) << 13);
	output[49] = (double)(value >> 16);
}

static void unpack_50_16bit_unsigned_5off(const uint8_t * input, double * output, void *closure) {
	// Unpack 50 values into output
	// Values are 16-bit unsigned
	// Skip 5 bits, read 800 bits of data.
	// Input must be at least 101 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 5 to 20
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)(input[2] & 0xf8) << 13);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 21 to 36
	value = ((uint32_t)(input[2] & 0x07) << 29) |
			((uint32_t)input[3] << 21) |
			((uint32_t)(input[4] & 0xf8) << 13);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 37 to 52
	value = ((uint32_t)(input[4] & 0x07) << 29) |
			((uint32_t)input[5] << 21) |
			((uint32_t)(input[6] & 0xf8) << 13);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 53 to 68
	value = ((uint32_t)(input[6] & 0x07) << 29) |
			((uint32_t)input[7] << 21) |
			((uint32_t)(input[8] & 0xf8) << 13);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 69 to 84
	value = ((uint32_t)(input[8] & 0x07) << 29) |
			((uint32_t)input[9] << 21) |
			((uint32_t)(input[10] & 0xf8) << 13);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 85 to 100
	value = ((uint32_t)(input[10] & 0x07) << 29) |
			((uint32_t)input[11] << 21) |
			((uint32_t)(input[12] & 0xf8) << 13);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 101 to 116
	value = ((uint32_t)(input[12] & 0x07) << 29) |
			((uint32_t)input[13] << 21) |
			((uint32_t)(input[14] & 0xf8) << 13);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 117 to 132
	value = ((uint32_t)(input[14] & 0x07) << 29) |
			((uint32_t)input[15] << 21) |
			((uint32_t)(input[16] & 0xf8) << 13);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 133 to 148
	value = ((uint32_t)(input[16] & 0x07) << 29) |
			((uint32_t)input[17] << 21) |
			((uint32_t)(input[18] & 0xf8) << 13);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 149 to 164
	value = ((uint32_t)(input[18] & 0x07) << 29) |
			((uint32_t)input[19] << 21) |
			((uint32_t)(input[20] & 0xf8) << 13);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 165 to 180
	value = ((uint32_t)(input[20] & 0x07) << 29) |
			((uint32_t)input[21] << 21) |
			((uint32_t)(input[22] & 0xf8) << 13);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 181 to 196
	value = ((uint32_t)(input[22] & 0x07) << 29) |
			((uint32_t)input[23] << 21) |
			((uint32_t)(input[24] & 0xf8) << 13);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 197 to 212
	value = ((uint32_t)(input[24] & 0x07) << 29) |
			((uint32_t)input[25] << 21) |
			((uint32_t)(input[26] & 0xf8) << 13);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 213 to 228
	value = ((uint32_t)(input[26] & 0x07) << 29) |
			((uint32_t)input[27] << 21) |
			((uint32_t)(input[28] & 0xf8) << 13);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 229 to 244
	value = ((uint32_t)(input[28] & 0x07) << 29) |
			((uint32_t)input[29] << 21) |
			((uint32_t)(input[30] & 0xf8) << 13);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 245 to 260
	value = ((uint32_t)(input[30] & 0x07) << 29) |
			((uint32_t)input[31] << 21) |
			((uint32_t)(input[32] & 0xf8) << 13);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 261 to 276
	value = ((uint32_t)(input[32] & 0x07) << 29) |
			((uint32_t)input[33] << 21) |
			((uint32_t)(input[34] & 0xf8) << 13);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 277 to 292
	value = ((uint32_t)(input[34] & 0x07) << 29) |
			((uint32_t)input[35] << 21) |
			((uint32_t)(input[36] & 0xf8) << 13);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 293 to 308
	value = ((uint32_t)(input[36] & 0x07) << 29) |
			((uint32_t)input[37] << 21) |
			((uint32_t)(input[38] & 0xf8) << 13);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 309 to 324
	value = ((uint32_t)(input[38] & 0x07) << 29) |
			((uint32_t)input[39] << 21) |
			((uint32_t)(input[40] & 0xf8) << 13);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 325 to 340
	value = ((uint32_t)(input[40] & 0x07) << 29) |
			((uint32_t)input[41] << 21) |
			((uint32_t)(input[42] & 0xf8) << 13);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 341 to 356
	value = ((uint32_t)(input[42] & 0x07) << 29) |
			((uint32_t)input[43] << 21) |
			((uint32_t)(input[44] & 0xf8) << 13);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 357 to 372
	value = ((uint32_t)(input[44] & 0x07) << 29) |
			((uint32_t)input[45] << 21) |
			((uint32_t)(input[46] & 0xf8) << 13);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 373 to 388
	value = ((uint32_t)(input[46] & 0x07) << 29) |
			((uint32_t)input[47] << 21) |
			((uint32_t)(input[48] & 0xf8) << 13);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 389 to 404
	value = ((uint32_t)(input[48] & 0x07) << 29) |
			((uint32_t)input[49] << 21) |
			((uint32_t)(input[50] & 0xf8) << 13);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 405 to 420
	value = ((uint32_t)(input[50] & 0x07) << 29) |
			((uint32_t)input[51] << 21) |
			((uint32_t)(input[52] & 0xf8) << 13);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 421 to 436
	value = ((uint32_t)(input[52] & 0x07) << 29) |
			((uint32_t)input[53] << 21) |
			((uint32_t)(input[54] & 0xf8) << 13);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 437 to 452
	value = ((uint32_t)(input[54] & 0x07) << 29) |
			((uint32_t)input[55] << 21) |
			((uint32_t)(input[56] & 0xf8) << 13);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 453 to 468
	value = ((uint32_t)(input[56] & 0x07) << 29) |
			((uint32_t)input[57] << 21) |
			((uint32_t)(input[58] & 0xf8) << 13);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 469 to 484
	value = ((uint32_t)(input[58] & 0x07) << 29) |
			((uint32_t)input[59] << 21) |
			((uint32_t)(input[60] & 0xf8) << 13);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 485 to 500
	value = ((uint32_t)(input[60] & 0x07) << 29) |
			((uint32_t)input[61] << 21) |
			((uint32_t)(input[62] & 0xf8) << 13);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 501 to 516
	value = ((uint32_t)(input[62] & 0x07) << 29) |
			((uint32_t)input[63] << 21) |
			((uint32_t)(input[64] & 0xf8) << 13);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 517 to 532
	value = ((uint32_t)(input[64] & 0x07) << 29) |
			((uint32_t)input[65] << 21) |
			((uint32_t)(input[66] & 0xf8) << 13);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 533 to 548
	value = ((uint32_t)(input[66] & 0x07) << 29) |
			((uint32_t)input[67] << 21) |
			((uint32_t)(input[68] & 0xf8) << 13);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 549 to 564
	value = ((uint32_t)(input[68] & 0x07) << 29) |
			((uint32_t)input[69] << 21) |
			((uint32_t)(input[70] & 0xf8) << 13);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 565 to 580
	value = ((uint32_t)(input[70] & 0x07) << 29) |
			((uint32_t)input[71] << 21) |
			((uint32_t)(input[72] & 0xf8) << 13);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 581 to 596
	value = ((uint32_t)(input[72] & 0x07) << 29) |
			((uint32_t)input[73] << 21) |
			((uint32_t)(input[74] & 0xf8) << 13);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 597 to 612
	value = ((uint32_t)(input[74] & 0x07) << 29) |
			((uint32_t)input[75] << 21) |
			((uint32_t)(input[76] & 0xf8) << 13);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 613 to 628
	value = ((uint32_t)(input[76] & 0x07) << 29) |
			((uint32_t)input[77] << 21) |
			((uint32_t)(input[78] & 0xf8) << 13);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 629 to 644
	value = ((uint32_t)(input[78] & 0x07) << 29) |
			((uint32_t)input[79] << 21) |
			((uint32_t)(input[80] & 0xf8) << 13);
	output[39] = (double)(value >> 16);

	// read output[40]: from bit 645 to 660
	value = ((uint32_t)(input[80] & 0x07) << 29) |
			((uint32_t)input[81] << 21) |
			((uint32_t)(input[82] & 0xf8) << 13);
	output[40] = (double)(value >> 16);

	// read output[41]: from bit 661 to 676
	value = ((uint32_t)(input[82] & 0x07) << 29) |
			((uint32_t)input[83] << 21) |
			((uint32_t)(input[84] & 0xf8) << 13);
	output[41] = (double)(value >> 16);

	// read output[42]: from bit 677 to 692
	value = ((uint32_t)(input[84] & 0x07) << 29) |
			((uint32_t)input[85] << 21) |
			((uint32_t)(input[86] & 0xf8) << 13);
	output[42] = (double)(value >> 16);

	// read output[43]: from bit 693 to 708
	value = ((uint32_t)(input[86] & 0x07) << 29) |
			((uint32_t)input[87] << 21) |
			((uint32_t)(input[88] & 0xf8) << 13);
	output[43] = (double)(value >> 16);

	// read output[44]: from bit 709 to 724
	value = ((uint32_t)(input[88] & 0x07) << 29) |
			((uint32_t)input[89] << 21) |
			((uint32_t)(input[90] & 0xf8) << 13);
	output[44] = (double)(value >> 16);

	// read output[45]: from bit 725 to 740
	value = ((uint32_t)(input[90] & 0x07) << 29) |
			((uint32_t)input[91] << 21) |
			((uint32_t)(input[92] & 0xf8) << 13);
	output[45] = (double)(value >> 16);

	// read output[46]: from bit 741 to 756
	value = ((uint32_t)(input[92] & 0x07) << 29) |
			((uint32_t)input[93] << 21) |
			((uint32_t)(input[94] & 0xf8) << 13);
	output[46] = (double)(value >> 16);

	// read output[47]: from bit 757 to 772
	value = ((uint32_t)(input[94] & 0x07) << 29) |
			((uint32_t)input[95] << 21) |
			((uint32_t)(input[96] & 0xf8) << 13);
	output[47] = (double)(value >> 16);

	// read output[48]: from bit 773 to 788
	value = ((uint32_t)(input[96] & 0x07) << 29) |
			((uint32_t)input[97] << 21) |
			((uint32_t)(input[98] & 0xf8) << 13);
	output[48] = (double)(value >> 16);

	// read output[49]: from bit 789 to 804
	value = ((uint32_t)(input[98] & 0x07) << 29) |
			((uint32_t)input[99] << 21) |
			((uint32_t)(input[100] & 0xf8) << 13);
	output[49] = (double)(value >> 16);
}

static void unpack_50_16bit_signed_6off(const uint8_t * input, double * output, void *closure) {
	// Unpack 50 values into output
	// Values are 16-bit signed
	// Skip 6 bits, read 800 bits of data.
	// Input must be at least 101 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 6 to 21
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)(input[2] & 0xfc) << 14);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 22 to 37
	value = ((uint32_t)(input[2] & 0x03) << 30) |
			((uint32_t)input[3] << 22) |
			((uint32_t)(input[4] & 0xfc) << 14);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 38 to 53
	value = ((uint32_t)(input[4] & 0x03) << 30) |
			((uint32_t)input[5] << 22) |
			((uint32_t)(input[6] & 0xfc) << 14);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 54 to 69
	value = ((uint32_t)(input[6] & 0x03) << 30) |
			((uint32_t)input[7] << 22) |
			((uint32_t)(input[8] & 0xfc) << 14);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 70 to 85
	value = ((uint32_t)(input[8] & 0x03) << 30) |
			((uint32_t)input[9] << 22) |
			((uint32_t)(input[10] & 0xfc) << 14);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 86 to 101
	value = ((uint32_t)(input[10] & 0x03) << 30) |
			((uint32_t)input[11] << 22) |
			((uint32_t)(input[12] & 0xfc) << 14);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 102 to 117
	value = ((uint32_t)(input[12] & 0x03) << 30) |
			((uint32_t)input[13] << 22) |
			((uint32_t)(input[14] & 0xfc) << 14);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 118 to 133
	value = ((uint32_t)(input[14] & 0x03) << 30) |
			((uint32_t)input[15] << 22) |
			((uint32_t)(input[16] & 0xfc) << 14);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 134 to 149
	value = ((uint32_t)(input[16] & 0x03) << 30) |
			((uint32_t)input[17] << 22) |
			((uint32_t)(input[18] & 0xfc) << 14);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 150 to 165
	value = ((uint32_t)(input[18] & 0x03) << 30) |
			((uint32_t)input[19] << 22) |
			((uint32_t)(input[20] & 0xfc) << 14);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 166 to 181
	value = ((uint32_t)(input[20] & 0x03) << 30) |
			((uint32_t)input[21] << 22) |
			((uint32_t)(input[22] & 0xfc) << 14);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 182 to 197
	value = ((uint32_t)(input[22] & 0x03) << 30) |
			((uint32_t)input[23] << 22) |
			((uint32_t)(input[24] & 0xfc) << 14);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 198 to 213
	value = ((uint32_t)(input[24] & 0x03) << 30) |
			((uint32_t)input[25] << 22) |
			((uint32_t)(input[26] & 0xfc) << 14);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 214 to 229
	value = ((uint32_t)(input[26] & 0x03) << 30) |
			((uint32_t)input[27] << 22) |
			((uint32_t)(input[28] & 0xfc) << 14);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 230 to 245
	value = ((uint32_t)(input[28] & 0x03) << 30) |
			((uint32_t)input[29] << 22) |
			((uint32_t)(input[30] & 0xfc) << 14);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 246 to 261
	value = ((uint32_t)(input[30] & 0x03) << 30) |
			((uint32_t)input[31] << 22) |
			((uint32_t)(input[32] & 0xfc) << 14);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 262 to 277
	value = ((uint32_t)(input[32] & 0x03) << 30) |
			((uint32_t)input[33] << 22) |
			((uint32_t)(input[34] & 0xfc) << 14);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 278 to 293
	value = ((uint32_t)(input[34] & 0x03) << 30) |
			((uint32_t)input[35] << 22) |
			((uint32_t)(input[36] & 0xfc) << 14);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 294 to 309
	value = ((uint32_t)(input[36] & 0x03) << 30) |
			((uint32_t)input[37] << 22) |
			((uint32_t)(input[38] & 0xfc) << 14);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 310 to 325
	value = ((uint32_t)(input[38] & 0x03) << 30) |
			((uint32_t)input[39] << 22) |
			((uint32_t)(input[40] & 0xfc) << 14);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 326 to 341
	value = ((uint32_t)(input[40] & 0x03) << 30) |
			((uint32_t)input[41] << 22) |
			((uint32_t)(input[42] & 0xfc) << 14);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 342 to 357
	value = ((uint32_t)(input[42] & 0x03) << 30) |
			((uint32_t)input[43] << 22) |
			((uint32_t)(input[44] & 0xfc) << 14);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 358 to 373
	value = ((uint32_t)(input[44] & 0x03) << 30) |
			((uint32_t)input[45] << 22) |
			((uint32_t)(input[46] & 0xfc) << 14);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 374 to 389
	value = ((uint32_t)(input[46] & 0x03) << 30) |
			((uint32_t)input[47] << 22) |
			((uint32_t)(input[48] & 0xfc) << 14);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 390 to 405
	value = ((uint32_t)(input[48] & 0x03) << 30) |
			((uint32_t)input[49] << 22) |
			((uint32_t)(input[50] & 0xfc) << 14);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 406 to 421
	value = ((uint32_t)(input[50] & 0x03) << 30) |
			((uint32_t)input[51] << 22) |
			((uint32_t)(input[52] & 0xfc) << 14);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 422 to 437
	value = ((uint32_t)(input[52] & 0x03) << 30) |
			((uint32_t)input[53] << 22) |
			((uint32_t)(input[54] & 0xfc) << 14);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 438 to 453
	value = ((uint32_t)(input[54] & 0x03) << 30) |
			((uint32_t)input[55] << 22) |
			((uint32_t)(input[56] & 0xfc) << 14);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 454 to 469
	value = ((uint32_t)(input[56] & 0x03) << 30) |
			((uint32_t)input[57] << 22) |
			((uint32_t)(input[58] & 0xfc) << 14);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 470 to 485
	value = ((uint32_t)(input[58] & 0x03) << 30) |
			((uint32_t)input[59] << 22) |
			((uint32_t)(input[60] & 0xfc) << 14);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 486 to 501
	value = ((uint32_t)(input[60] & 0x03) << 30) |
			((uint32_t)input[61] << 22) |
			((uint32_t)(input[62] & 0xfc) << 14);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 502 to 517
	value = ((uint32_t)(input[62] & 0x03) << 30) |
			((uint32_t)input[63] << 22) |
			((uint32_t)(input[64] & 0xfc) << 14);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 518 to 533
	value = ((uint32_t)(input[64] & 0x03) << 30) |
			((uint32_t)input[65] << 22) |
			((uint32_t)(input[66] & 0xfc) << 14);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 534 to 549
	value = ((uint32_t)(input[66] & 0x03) << 30) |
			((uint32_t)input[67] << 22) |
			((uint32_t)(input[68] & 0xfc) << 14);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 550 to 565
	value = ((uint32_t)(input[68] & 0x03) << 30) |
			((uint32_t)input[69] << 22) |
			((uint32_t)(input[70] & 0xfc) << 14);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 566 to 581
	value = ((uint32_t)(input[70] & 0x03) << 30) |
			((uint32_t)input[71] << 22) |
			((uint32_t)(input[72] & 0xfc) << 14);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 582 to 597
	value = ((uint32_t)(input[72] & 0x03) << 30) |
			((uint32_t)input[73] << 22) |
			((uint32_t)(input[74] & 0xfc) << 14);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 598 to 613
	value = ((uint32_t)(input[74] & 0x03) << 30) |
			((uint32_t)input[75] << 22) |
			((uint32_t)(input[76] & 0xfc) << 14);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 614 to 629
	value = ((uint32_t)(input[76] & 0x03) << 30) |
			((uint32_t)input[77] << 22) |
			((uint32_t)(input[78] & 0xfc) << 14);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 630 to 645
	value = ((uint32_t)(input[78] & 0x03) << 30) |
			((uint32_t)input[79] << 22) |
			((uint32_t)(input[80] & 0xfc) << 14);
	output[39] = (double)(value >> 16);

	// read output[40]: from bit 646 to 661
	value = ((uint32_t)(input[80] & 0x03) << 30) |
			((uint32_t)input[81] << 22) |
			((uint32_t)(input[82] & 0xfc) << 14);
	output[40] = (double)(value >> 16);

	// read output[41]: from bit 662 to 677
	value = ((uint32_t)(input[82] & 0x03) << 30) |
			((uint32_t)input[83] << 22) |
			((uint32_t)(input[84] & 0xfc) << 14);
	output[41] = (double)(value >> 16);

	// read output[42]: from bit 678 to 693
	value = ((uint32_t)(input[84] & 0x03) << 30) |
			((uint32_t)input[85] << 22) |
			((uint32_t)(input[86] & 0xfc) << 14);
	output[42] = (double)(value >> 16);

	// read output[43]: from bit 694 to 709
	value = ((uint32_t)(input[86] & 0x03) << 30) |
			((uint32_t)input[87] << 22) |
			((uint32_t)(input[88] & 0xfc) << 14);
	output[43] = (double)(value >> 16);

	// read output[44]: from bit 710 to 725
	value = ((uint32_t)(input[88] & 0x03) << 30) |
			((uint32_t)input[89] << 22) |
			((uint32_t)(input[90] & 0xfc) << 14);
	output[44] = (double)(value >> 16);

	// read output[45]: from bit 726 to 741
	value = ((uint32_t)(input[90] & 0x03) << 30) |
			((uint32_t)input[91] << 22) |
			((uint32_t)(input[92] & 0xfc) << 14);
	output[45] = (double)(value >> 16);

	// read output[46]: from bit 742 to 757
	value = ((uint32_t)(input[92] & 0x03) << 30) |
			((uint32_t)input[93] << 22) |
			((uint32_t)(input[94] & 0xfc) << 14);
	output[46] = (double)(value >> 16);

	// read output[47]: from bit 758 to 773
	value = ((uint32_t)(input[94] & 0x03) << 30) |
			((uint32_t)input[95] << 22) |
			((uint32_t)(input[96] & 0xfc) << 14);
	output[47] = (double)(value >> 16);

	// read output[48]: from bit 774 to 789
	value = ((uint32_t)(input[96] & 0x03) << 30) |
			((uint32_t)input[97] << 22) |
			((uint32_t)(input[98] & 0xfc) << 14);
	output[48] = (double)(value >> 16);

	// read output[49]: from bit 790 to 805
	value = ((uint32_t)(input[98] & 0x03) << 30) |
			((uint32_t)input[99] << 22) |
			((uint32_t)(input[100] & 0xfc) << 14);
	output[49] = (double)(value >> 16);
}

static void unpack_50_16bit_unsigned_6off(const uint8_t * input, double * output, void *closure) {
	// Unpack 50 values into output
	// Values are 16-bit unsigned
	// Skip 6 bits, read 800 bits of data.
	// Input must be at least 101 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 6 to 21
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)(input[2] & 0xfc) << 14);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 22 to 37
	value = ((uint32_t)(input[2] & 0x03) << 30) |
			((uint32_t)input[3] << 22) |
			((uint32_t)(input[4] & 0xfc) << 14);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 38 to 53
	value = ((uint32_t)(input[4] & 0x03) << 30) |
			((uint32_t)input[5] << 22) |
			((uint32_t)(input[6] & 0xfc) << 14);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 54 to 69
	value = ((uint32_t)(input[6] & 0x03) << 30) |
			((uint32_t)input[7] << 22) |
			((uint32_t)(input[8] & 0xfc) << 14);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 70 to 85
	value = ((uint32_t)(input[8] & 0x03) << 30) |
			((uint32_t)input[9] << 22) |
			((uint32_t)(input[10] & 0xfc) << 14);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 86 to 101
	value = ((uint32_t)(input[10] & 0x03) << 30) |
			((uint32_t)input[11] << 22) |
			((uint32_t)(input[12] & 0xfc) << 14);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 102 to 117
	value = ((uint32_t)(input[12] & 0x03) << 30) |
			((uint32_t)input[13] << 22) |
			((uint32_t)(input[14] & 0xfc) << 14);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 118 to 133
	value = ((uint32_t)(input[14] & 0x03) << 30) |
			((uint32_t)input[15] << 22) |
			((uint32_t)(input[16] & 0xfc) << 14);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 134 to 149
	value = ((uint32_t)(input[16] & 0x03) << 30) |
			((uint32_t)input[17] << 22) |
			((uint32_t)(input[18] & 0xfc) << 14);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 150 to 165
	value = ((uint32_t)(input[18] & 0x03) << 30) |
			((uint32_t)input[19] << 22) |
			((uint32_t)(input[20] & 0xfc) << 14);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 166 to 181
	value = ((uint32_t)(input[20] & 0x03) << 30) |
			((uint32_t)input[21] << 22) |
			((uint32_t)(input[22] & 0xfc) << 14);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 182 to 197
	value = ((uint32_t)(input[22] & 0x03) << 30) |
			((uint32_t)input[23] << 22) |
			((uint32_t)(input[24] & 0xfc) << 14);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 198 to 213
	value = ((uint32_t)(input[24] & 0x03) << 30) |
			((uint32_t)input[25] << 22) |
			((uint32_t)(input[26] & 0xfc) << 14);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 214 to 229
	value = ((uint32_t)(input[26] & 0x03) << 30) |
			((uint32_t)input[27] << 22) |
			((uint32_t)(input[28] & 0xfc) << 14);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 230 to 245
	value = ((uint32_t)(input[28] & 0x03) << 30) |
			((uint32_t)input[29] << 22) |
			((uint32_t)(input[30] & 0xfc) << 14);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 246 to 261
	value = ((uint32_t)(input[30] & 0x03) << 30) |
			((uint32_t)input[31] << 22) |
			((uint32_t)(input[32] & 0xfc) << 14);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 262 to 277
	value = ((uint32_t)(input[32] & 0x03) << 30) |
			((uint32_t)input[33] << 22) |
			((uint32_t)(input[34] & 0xfc) << 14);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 278 to 293
	value = ((uint32_t)(input[34] & 0x03) << 30) |
			((uint32_t)input[35] << 22) |
			((uint32_t)(input[36] & 0xfc) << 14);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 294 to 309
	value = ((uint32_t)(input[36] & 0x03) << 30) |
			((uint32_t)input[37] << 22) |
			((uint32_t)(input[38] & 0xfc) << 14);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 310 to 325
	value = ((uint32_t)(input[38] & 0x03) << 30) |
			((uint32_t)input[39] << 22) |
			((uint32_t)(input[40] & 0xfc) << 14);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 326 to 341
	value = ((uint32_t)(input[40] & 0x03) << 30) |
			((uint32_t)input[41] << 22) |
			((uint32_t)(input[42] & 0xfc) << 14);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 342 to 357
	value = ((uint32_t)(input[42] & 0x03) << 30) |
			((uint32_t)input[43] << 22) |
			((uint32_t)(input[44] & 0xfc) << 14);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 358 to 373
	value = ((uint32_t)(input[44] & 0x03) << 30) |
			((uint32_t)input[45] << 22) |
			((uint32_t)(input[46] & 0xfc) << 14);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 374 to 389
	value = ((uint32_t)(input[46] & 0x03) << 30) |
			((uint32_t)input[47] << 22) |
			((uint32_t)(input[48] & 0xfc) << 14);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 390 to 405
	value = ((uint32_t)(input[48] & 0x03) << 30) |
			((uint32_t)input[49] << 22) |
			((uint32_t)(input[50] & 0xfc) << 14);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 406 to 421
	value = ((uint32_t)(input[50] & 0x03) << 30) |
			((uint32_t)input[51] << 22) |
			((uint32_t)(input[52] & 0xfc) << 14);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 422 to 437
	value = ((uint32_t)(input[52] & 0x03) << 30) |
			((uint32_t)input[53] << 22) |
			((uint32_t)(input[54] & 0xfc) << 14);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 438 to 453
	value = ((uint32_t)(input[54] & 0x03) << 30) |
			((uint32_t)input[55] << 22) |
			((uint32_t)(input[56] & 0xfc) << 14);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 454 to 469
	value = ((uint32_t)(input[56] & 0x03) << 30) |
			((uint32_t)input[57] << 22) |
			((uint32_t)(input[58] & 0xfc) << 14);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 470 to 485
	value = ((uint32_t)(input[58] & 0x03) << 30) |
			((uint32_t)input[59] << 22) |
			((uint32_t)(input[60] & 0xfc) << 14);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 486 to 501
	value = ((uint32_t)(input[60] & 0x03) << 30) |
			((uint32_t)input[61] << 22) |
			((uint32_t)(input[62] & 0xfc) << 14);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 502 to 517
	value = ((uint32_t)(input[62] & 0x03) << 30) |
			((uint32_t)input[63] << 22) |
			((uint32_t)(input[64] & 0xfc) << 14);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 518 to 533
	value = ((uint32_t)(input[64] & 0x03) << 30) |
			((uint32_t)input[65] << 22) |
			((uint32_t)(input[66] & 0xfc) << 14);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 534 to 549
	value = ((uint32_t)(input[66] & 0x03) << 30) |
			((uint32_t)input[67] << 22) |
			((uint32_t)(input[68] & 0xfc) << 14);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 550 to 565
	value = ((uint32_t)(input[68] & 0x03) << 30) |
			((uint32_t)input[69] << 22) |
			((uint32_t)(input[70] & 0xfc) << 14);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 566 to 581
	value = ((uint32_t)(input[70] & 0x03) << 30) |
			((uint32_t)input[71] << 22) |
			((uint32_t)(input[72] & 0xfc) << 14);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 582 to 597
	value = ((uint32_t)(input[72] & 0x03) << 30) |
			((uint32_t)input[73] << 22) |
			((uint32_t)(input[74] & 0xfc) << 14);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 598 to 613
	value = ((uint32_t)(input[74] & 0x03) << 30) |
			((uint32_t)input[75] << 22) |
			((uint32_t)(input[76] & 0xfc) << 14);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 614 to 629
	value = ((uint32_t)(input[76] & 0x03) << 30) |
			((uint32_t)input[77] << 22) |
			((uint32_t)(input[78] & 0xfc) << 14);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 630 to 645
	value = ((uint32_t)(input[78] & 0x03) << 30) |
			((uint32_t)input[79] << 22) |
			((uint32_t)(input[80] & 0xfc) << 14);
	output[39] = (double)(value >> 16);

	// read output[40]: from bit 646 to 661
	value = ((uint32_t)(input[80] & 0x03) << 30) |
			((uint32_t)input[81] << 22) |
			((uint32_t)(input[82] & 0xfc) << 14);
	output[40] = (double)(value >> 16);

	// read output[41]: from bit 662 to 677
	value = ((uint32_t)(input[82] & 0x03) << 30) |
			((uint32_t)input[83] << 22) |
			((uint32_t)(input[84] & 0xfc) << 14);
	output[41] = (double)(value >> 16);

	// read output[42]: from bit 678 to 693
	value = ((uint32_t)(input[84] & 0x03) << 30) |
			((uint32_t)input[85] << 22) |
			((uint32_t)(input[86] & 0xfc) << 14);
	output[42] = (double)(value >> 16);

	// read output[43]: from bit 694 to 709
	value = ((uint32_t)(input[86] & 0x03) << 30) |
			((uint32_t)input[87] << 22) |
			((uint32_t)(input[88] & 0xfc) << 14);
	output[43] = (double)(value >> 16);

	// read output[44]: from bit 710 to 725
	value = ((uint32_t)(input[88] & 0x03) << 30) |
			((uint32_t)input[89] << 22) |
			((uint32_t)(input[90] & 0xfc) << 14);
	output[44] = (double)(value >> 16);

	// read output[45]: from bit 726 to 741
	value = ((uint32_t)(input[90] & 0x03) << 30) |
			((uint32_t)input[91] << 22) |
			((uint32_t)(input[92] & 0xfc) << 14);
	output[45] = (double)(value >> 16);

	// read output[46]: from bit 742 to 757
	value = ((uint32_t)(input[92] & 0x03) << 30) |
			((uint32_t)input[93] << 22) |
			((uint32_t)(input[94] & 0xfc) << 14);
	output[46] = (double)(value >> 16);

	// read output[47]: from bit 758 to 773
	value = ((uint32_t)(input[94] & 0x03) << 30) |
			((uint32_t)input[95] << 22) |
			((uint32_t)(input[96] & 0xfc) << 14);
	output[47] = (double)(value >> 16);

	// read output[48]: from bit 774 to 789
	value = ((uint32_t)(input[96] & 0x03) << 30) |
			((uint32_t)input[97] << 22) |
			((uint32_t)(input[98] & 0xfc) << 14);
	output[48] = (double)(value >> 16);

	// read output[49]: from bit 790 to 805
	value = ((uint32_t)(input[98] & 0x03) << 30) |
			((uint32_t)input[99] << 22) |
			((uint32_t)(input[100] & 0xfc) << 14);
	output[49] = (double)(value >> 16);
}

static void unpack_50_16bit_signed_7off(const uint8_t * input, double * output, void *closure) {
	// Unpack 50 values into output
	// Values are 16-bit signed
	// Skip 7 bits, read 800 bits of data.
	// Input must be at least 101 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 7 to 22
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)(input[2] & 0xfe) << 15);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 23 to 38
	value = ((uint32_t)(input[2] & 0x01) << 31) |
			((uint32_t)input[3] << 23) |
			((uint32_t)(input[4] & 0xfe) << 15);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 39 to 54
	value = ((uint32_t)(input[4] & 0x01) << 31) |
			((uint32_t)input[5] << 23) |
			((uint32_t)(input[6] & 0xfe) << 15);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 55 to 70
	value = ((uint32_t)(input[6] & 0x01) << 31) |
			((uint32_t)input[7] << 23) |
			((uint32_t)(input[8] & 0xfe) << 15);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 71 to 86
	value = ((uint32_t)(input[8] & 0x01) << 31) |
			((uint32_t)input[9] << 23) |
			((uint32_t)(input[10] & 0xfe) << 15);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 87 to 102
	value = ((uint32_t)(input[10] & 0x01) << 31) |
			((uint32_t)input[11] << 23) |
			((uint32_t)(input[12] & 0xfe) << 15);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 103 to 118
	value = ((uint32_t)(input[12] & 0x01) << 31) |
			((uint32_t)input[13] << 23) |
			((uint32_t)(input[14] & 0xfe) << 15);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 119 to 134
	value = ((uint32_t)(input[14] & 0x01) << 31) |
			((uint32_t)input[15] << 23) |
			((uint32_t)(input[16] & 0xfe) << 15);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 135 to 150
	value = ((uint32_t)(input[16] & 0x01) << 31) |
			((uint32_t)input[17] << 23) |
			((uint32_t)(input[18] & 0xfe) << 15);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 151 to 166
	value = ((uint32_t)(input[18] & 0x01) << 31) |
			((uint32_t)input[19] << 23) |
			((uint32_t)(input[20] & 0xfe) << 15);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 167 to 182
	value = ((uint32_t)(input[20] & 0x01) << 31) |
			((uint32_t)input[21] << 23) |
			((uint32_t)(input[22] & 0xfe) << 15);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 183 to 198
	value = ((uint32_t)(input[22] & 0x01) << 31) |
			((uint32_t)input[23] << 23) |
			((uint32_t)(input[24] & 0xfe) << 15);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 199 to 214
	value = ((uint32_t)(input[24] & 0x01) << 31) |
			((uint32_t)input[25] << 23) |
			((uint32_t)(input[26] & 0xfe) << 15);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 215 to 230
	value = ((uint32_t)(input[26] & 0x01) << 31) |
			((uint32_t)input[27] << 23) |
			((uint32_t)(input[28] & 0xfe) << 15);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 231 to 246
	value = ((uint32_t)(input[28] & 0x01) << 31) |
			((uint32_t)input[29] << 23) |
			((uint32_t)(input[30] & 0xfe) << 15);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 247 to 262
	value = ((uint32_t)(input[30] & 0x01) << 31) |
			((uint32_t)input[31] << 23) |
			((uint32_t)(input[32] & 0xfe) << 15);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 263 to 278
	value = ((uint32_t)(input[32] & 0x01) << 31) |
			((uint32_t)input[33] << 23) |
			((uint32_t)(input[34] & 0xfe) << 15);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 279 to 294
	value = ((uint32_t)(input[34] & 0x01) << 31) |
			((uint32_t)input[35] << 23) |
			((uint32_t)(input[36] & 0xfe) << 15);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 295 to 310
	value = ((uint32_t)(input[36] & 0x01) << 31) |
			((uint32_t)input[37] << 23) |
			((uint32_t)(input[38] & 0xfe) << 15);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 311 to 326
	value = ((uint32_t)(input[38] & 0x01) << 31) |
			((uint32_t)input[39] << 23) |
			((uint32_t)(input[40] & 0xfe) << 15);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 327 to 342
	value = ((uint32_t)(input[40] & 0x01) << 31) |
			((uint32_t)input[41] << 23) |
			((uint32_t)(input[42] & 0xfe) << 15);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 343 to 358
	value = ((uint32_t)(input[42] & 0x01) << 31) |
			((uint32_t)input[43] << 23) |
			((uint32_t)(input[44] & 0xfe) << 15);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 359 to 374
	value = ((uint32_t)(input[44] & 0x01) << 31) |
			((uint32_t)input[45] << 23) |
			((uint32_t)(input[46] & 0xfe) << 15);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 375 to 390
	value = ((uint32_t)(input[46] & 0x01) << 31) |
			((uint32_t)input[47] << 23) |
			((uint32_t)(input[48] & 0xfe) << 15);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 391 to 406
	value = ((uint32_t)(input[48] & 0x01) << 31) |
			((uint32_t)input[49] << 23) |
			((uint32_t)(input[50] & 0xfe) << 15);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 407 to 422
	value = ((uint32_t)(input[50] & 0x01) << 31) |
			((uint32_t)input[51] << 23) |
			((uint32_t)(input[52] & 0xfe) << 15);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 423 to 438
	value = ((uint32_t)(input[52] & 0x01) << 31) |
			((uint32_t)input[53] << 23) |
			((uint32_t)(input[54] & 0xfe) << 15);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 439 to 454
	value = ((uint32_t)(input[54] & 0x01) << 31) |
			((uint32_t)input[55] << 23) |
			((uint32_t)(input[56] & 0xfe) << 15);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 455 to 470
	value = ((uint32_t)(input[56] & 0x01) << 31) |
			((uint32_t)input[57] << 23) |
			((uint32_t)(input[58] & 0xfe) << 15);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 471 to 486
	value = ((uint32_t)(input[58] & 0x01) << 31) |
			((uint32_t)input[59] << 23) |
			((uint32_t)(input[60] & 0xfe) << 15);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 487 to 502
	value = ((uint32_t)(input[60] & 0x01) << 31) |
			((uint32_t)input[61] << 23) |
			((uint32_t)(input[62] & 0xfe) << 15);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 503 to 518
	value = ((uint32_t)(input[62] & 0x01) << 31) |
			((uint32_t)input[63] << 23) |
			((uint32_t)(input[64] & 0xfe) << 15);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 519 to 534
	value = ((uint32_t)(input[64] & 0x01) << 31) |
			((uint32_t)input[65] << 23) |
			((uint32_t)(input[66] & 0xfe) << 15);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 535 to 550
	value = ((uint32_t)(input[66] & 0x01) << 31) |
			((uint32_t)input[67] << 23) |
			((uint32_t)(input[68] & 0xfe) << 15);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 551 to 566
	value = ((uint32_t)(input[68] & 0x01) << 31) |
			((uint32_t)input[69] << 23) |
			((uint32_t)(input[70] & 0xfe) << 15);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 567 to 582
	value = ((uint32_t)(input[70] & 0x01) << 31) |
			((uint32_t)input[71] << 23) |
			((uint32_t)(input[72] & 0xfe) << 15);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 583 to 598
	value = ((uint32_t)(input[72] & 0x01) << 31) |
			((uint32_t)input[73] << 23) |
			((uint32_t)(input[74] & 0xfe) << 15);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 599 to 614
	value = ((uint32_t)(input[74] & 0x01) << 31) |
			((uint32_t)input[75] << 23) |
			((uint32_t)(input[76] & 0xfe) << 15);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 615 to 630
	value = ((uint32_t)(input[76] & 0x01) << 31) |
			((uint32_t)input[77] << 23) |
			((uint32_t)(input[78] & 0xfe) << 15);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 631 to 646
	value = ((uint32_t)(input[78] & 0x01) << 31) |
			((uint32_t)input[79] << 23) |
			((uint32_t)(input[80] & 0xfe) << 15);
	output[39] = (double)(value >> 16);

	// read output[40]: from bit 647 to 662
	value = ((uint32_t)(input[80] & 0x01) << 31) |
			((uint32_t)input[81] << 23) |
			((uint32_t)(input[82] & 0xfe) << 15);
	output[40] = (double)(value >> 16);

	// read output[41]: from bit 663 to 678
	value = ((uint32_t)(input[82] & 0x01) << 31) |
			((uint32_t)input[83] << 23) |
			((uint32_t)(input[84] & 0xfe) << 15);
	output[41] = (double)(value >> 16);

	// read output[42]: from bit 679 to 694
	value = ((uint32_t)(input[84] & 0x01) << 31) |
			((uint32_t)input[85] << 23) |
			((uint32_t)(input[86] & 0xfe) << 15);
	output[42] = (double)(value >> 16);

	// read output[43]: from bit 695 to 710
	value = ((uint32_t)(input[86] & 0x01) << 31) |
			((uint32_t)input[87] << 23) |
			((uint32_t)(input[88] & 0xfe) << 15);
	output[43] = (double)(value >> 16);

	// read output[44]: from bit 711 to 726
	value = ((uint32_t)(input[88] & 0x01) << 31) |
			((uint32_t)input[89] << 23) |
			((uint32_t)(input[90] & 0xfe) << 15);
	output[44] = (double)(value >> 16);

	// read output[45]: from bit 727 to 742
	value = ((uint32_t)(input[90] & 0x01) << 31) |
			((uint32_t)input[91] << 23) |
			((uint32_t)(input[92] & 0xfe) << 15);
	output[45] = (double)(value >> 16);

	// read output[46]: from bit 743 to 758
	value = ((uint32_t)(input[92] & 0x01) << 31) |
			((uint32_t)input[93] << 23) |
			((uint32_t)(input[94] & 0xfe) << 15);
	output[46] = (double)(value >> 16);

	// read output[47]: from bit 759 to 774
	value = ((uint32_t)(input[94] & 0x01) << 31) |
			((uint32_t)input[95] << 23) |
			((uint32_t)(input[96] & 0xfe) << 15);
	output[47] = (double)(value >> 16);

	// read output[48]: from bit 775 to 790
	value = ((uint32_t)(input[96] & 0x01) << 31) |
			((uint32_t)input[97] << 23) |
			((uint32_t)(input[98] & 0xfe) << 15);
	output[48] = (double)(value >> 16);

	// read output[49]: from bit 791 to 806
	value = ((uint32_t)(input[98] & 0x01) << 31) |
			((uint32_t)input[99] << 23) |
			((uint32_t)(input[100] & 0xfe) << 15);
	output[49] = (double)(value >> 16);
}

static void unpack_50_16bit_unsigned_7off(const uint8_t * input, double * output, void *closure) {
	// Unpack 50 values into output
	// Values are 16-bit unsigned
	// Skip 7 bits, read 800 bits of data.
	// Input must be at least 101 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 7 to 22
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)(input[2] & 0xfe) << 15);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 23 to 38
	value = ((uint32_t)(input[2] & 0x01) << 31) |
			((uint32_t)input[3] << 23) |
			((uint32_t)(input[4] & 0xfe) << 15);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 39 to 54
	value = ((uint32_t)(input[4] & 0x01) << 31) |
			((uint32_t)input[5] << 23) |
			((uint32_t)(input[6] & 0xfe) << 15);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 55 to 70
	value = ((uint32_t)(input[6] & 0x01) << 31) |
			((uint32_t)input[7] << 23) |
			((uint32_t)(input[8] & 0xfe) << 15);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 71 to 86
	value = ((uint32_t)(input[8] & 0x01) << 31) |
			((uint32_t)input[9] << 23) |
			((uint32_t)(input[10] & 0xfe) << 15);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 87 to 102
	value = ((uint32_t)(input[10] & 0x01) << 31) |
			((uint32_t)input[11] << 23) |
			((uint32_t)(input[12] & 0xfe) << 15);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 103 to 118
	value = ((uint32_t)(input[12] & 0x01) << 31) |
			((uint32_t)input[13] << 23) |
			((uint32_t)(input[14] & 0xfe) << 15);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 119 to 134
	value = ((uint32_t)(input[14] & 0x01) << 31) |
			((uint32_t)input[15] << 23) |
			((uint32_t)(input[16] & 0xfe) << 15);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 135 to 150
	value = ((uint32_t)(input[16] & 0x01) << 31) |
			((uint32_t)input[17] << 23) |
			((uint32_t)(input[18] & 0xfe) << 15);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 151 to 166
	value = ((uint32_t)(input[18] & 0x01) << 31) |
			((uint32_t)input[19] << 23) |
			((uint32_t)(input[20] & 0xfe) << 15);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 167 to 182
	value = ((uint32_t)(input[20] & 0x01) << 31) |
			((uint32_t)input[21] << 23) |
			((uint32_t)(input[22] & 0xfe) << 15);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 183 to 198
	value = ((uint32_t)(input[22] & 0x01) << 31) |
			((uint32_t)input[23] << 23) |
			((uint32_t)(input[24] & 0xfe) << 15);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 199 to 214
	value = ((uint32_t)(input[24] & 0x01) << 31) |
			((uint32_t)input[25] << 23) |
			((uint32_t)(input[26] & 0xfe) << 15);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 215 to 230
	value = ((uint32_t)(input[26] & 0x01) << 31) |
			((uint32_t)input[27] << 23) |
			((uint32_t)(input[28] & 0xfe) << 15);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 231 to 246
	value = ((uint32_t)(input[28] & 0x01) << 31) |
			((uint32_t)input[29] << 23) |
			((uint32_t)(input[30] & 0xfe) << 15);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 247 to 262
	value = ((uint32_t)(input[30] & 0x01) << 31) |
			((uint32_t)input[31] << 23) |
			((uint32_t)(input[32] & 0xfe) << 15);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 263 to 278
	value = ((uint32_t)(input[32] & 0x01) << 31) |
			((uint32_t)input[33] << 23) |
			((uint32_t)(input[34] & 0xfe) << 15);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 279 to 294
	value = ((uint32_t)(input[34] & 0x01) << 31) |
			((uint32_t)input[35] << 23) |
			((uint32_t)(input[36] & 0xfe) << 15);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 295 to 310
	value = ((uint32_t)(input[36] & 0x01) << 31) |
			((uint32_t)input[37] << 23) |
			((uint32_t)(input[38] & 0xfe) << 15);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 311 to 326
	value = ((uint32_t)(input[38] & 0x01) << 31) |
			((uint32_t)input[39] << 23) |
			((uint32_t)(input[40] & 0xfe) << 15);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 327 to 342
	value = ((uint32_t)(input[40] & 0x01) << 31) |
			((uint32_t)input[41] << 23) |
			((uint32_t)(input[42] & 0xfe) << 15);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 343 to 358
	value = ((uint32_t)(input[42] & 0x01) << 31) |
			((uint32_t)input[43] << 23) |
			((uint32_t)(input[44] & 0xfe) << 15);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 359 to 374
	value = ((uint32_t)(input[44] & 0x01) << 31) |
			((uint32_t)input[45] << 23) |
			((uint32_t)(input[46] & 0xfe) << 15);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 375 to 390
	value = ((uint32_t)(input[46] & 0x01) << 31) |
			((uint32_t)input[47] << 23) |
			((uint32_t)(input[48] & 0xfe) << 15);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 391 to 406
	value = ((uint32_t)(input[48] & 0x01) << 31) |
			((uint32_t)input[49] << 23) |
			((uint32_t)(input[50] & 0xfe) << 15);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 407 to 422
	value = ((uint32_t)(input[50] & 0x01) << 31) |
			((uint32_t)input[51] << 23) |
			((uint32_t)(input[52] & 0xfe) << 15);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 423 to 438
	value = ((uint32_t)(input[52] & 0x01) << 31) |
			((uint32_t)input[53] << 23) |
			((uint32_t)(input[54] & 0xfe) << 15);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 439 to 454
	value = ((uint32_t)(input[54] & 0x01) << 31) |
			((uint32_t)input[55] << 23) |
			((uint32_t)(input[56] & 0xfe) << 15);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 455 to 470
	value = ((uint32_t)(input[56] & 0x01) << 31) |
			((uint32_t)input[57] << 23) |
			((uint32_t)(input[58] & 0xfe) << 15);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 471 to 486
	value = ((uint32_t)(input[58] & 0x01) << 31) |
			((uint32_t)input[59] << 23) |
			((uint32_t)(input[60] & 0xfe) << 15);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 487 to 502
	value = ((uint32_t)(input[60] & 0x01) << 31) |
			((uint32_t)input[61] << 23) |
			((uint32_t)(input[62] & 0xfe) << 15);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 503 to 518
	value = ((uint32_t)(input[62] & 0x01) << 31) |
			((uint32_t)input[63] << 23) |
			((uint32_t)(input[64] & 0xfe) << 15);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 519 to 534
	value = ((uint32_t)(input[64] & 0x01) << 31) |
			((uint32_t)input[65] << 23) |
			((uint32_t)(input[66] & 0xfe) << 15);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 535 to 550
	value = ((uint32_t)(input[66] & 0x01) << 31) |
			((uint32_t)input[67] << 23) |
			((uint32_t)(input[68] & 0xfe) << 15);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 551 to 566
	value = ((uint32_t)(input[68] & 0x01) << 31) |
			((uint32_t)input[69] << 23) |
			((uint32_t)(input[70] & 0xfe) << 15);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 567 to 582
	value = ((uint32_t)(input[70] & 0x01) << 31) |
			((uint32_t)input[71] << 23) |
			((uint32_t)(input[72] & 0xfe) << 15);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 583 to 598
	value = ((uint32_t)(input[72] & 0x01) << 31) |
			((uint32_t)input[73] << 23) |
			((uint32_t)(input[74] & 0xfe) << 15);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 599 to 614
	value = ((uint32_t)(input[74] & 0x01) << 31) |
			((uint32_t)input[75] << 23) |
			((uint32_t)(input[76] & 0xfe) << 15);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 615 to 630
	value = ((uint32_t)(input[76] & 0x01) << 31) |
			((uint32_t)input[77] << 23) |
			((uint32_t)(input[78] & 0xfe) << 15);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 631 to 646
	value = ((uint32_t)(input[78] & 0x01) << 31) |
			((uint32_t)input[79] << 23) |
			((uint32_t)(input[80] & 0xfe) << 15);
	output[39] = (double)(value >> 16);

	// read output[40]: from bit 647 to 662
	value = ((uint32_t)(input[80] & 0x01) << 31) |
			((uint32_t)input[81] << 23) |
			((uint32_t)(input[82] & 0xfe) << 15);
	output[40] = (double)(value >> 16);

	// read output[41]: from bit 663 to 678
	value = ((uint32_t)(input[82] & 0x01) << 31) |
			((uint32_t)input[83] << 23) |
			((uint32_t)(input[84] & 0xfe) << 15);
	output[41] = (double)(value >> 16);

	// read output[42]: from bit 679 to 694
	value = ((uint32_t)(input[84] & 0x01) << 31) |
			((uint32_t)input[85] << 23) |
			((uint32_t)(input[86] & 0xfe) << 15);
	output[42] = (double)(value >> 16);

	// read output[43]: from bit 695 to 710
	value = ((uint32_t)(input[86] & 0x01) << 31) |
			((uint32_t)input[87] << 23) |
			((uint32_t)(input[88] & 0xfe) << 15);
	output[43] = (double)(value >> 16);

	// read output[44]: from bit 711 to 726
	value = ((uint32_t)(input[88] & 0x01) << 31) |
			((uint32_t)input[89] << 23) |
			((uint32_t)(input[90] & 0xfe) << 15);
	output[44] = (double)(value >> 16);

	// read output[45]: from bit 727 to 742
	value = ((uint32_t)(input[90] & 0x01) << 31) |
			((uint32_t)input[91] << 23) |
			((uint32_t)(input[92] & 0xfe) << 15);
	output[45] = (double)(value >> 16);

	// read output[46]: from bit 743 to 758
	value = ((uint32_t)(input[92] & 0x01) << 31) |
			((uint32_t)input[93] << 23) |
			((uint32_t)(input[94] & 0xfe) << 15);
	output[46] = (double)(value >> 16);

	// read output[47]: from bit 759 to 774
	value = ((uint32_t)(input[94] & 0x01) << 31) |
			((uint32_t)input[95] << 23) |
			((uint32_t)(input[96] & 0xfe) << 15);
	output[47] = (double)(value >> 16);

	// read output[48]: from bit 775 to 790
	value = ((uint32_t)(input[96] & 0x01) << 31) |
			((uint32_t)input[97] << 23) |
			((uint32_t)(input[98] & 0xfe) << 15);
	output[48] = (double)(value >> 16);

	// read output[49]: from bit 791 to 806
	value = ((uint32_t)(input[98] & 0x01) << 31) |
			((uint32_t)input[99] << 23) |
			((uint32_t)(input[100] & 0xfe) << 15);
	output[49] = (double)(value >> 16);
}

static void unpack_51_16bit_signed_0off(const uint8_t * input, double * output, void *closure) {
	// Unpack 51 values into output
	// Values are 16-bit signed
	// Skip 0 bits, read 816 bits of data.
	// Input must be at least 102 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 0 to 15
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)input[1] << 16);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 16 to 31
	value = ((uint32_t)input[2] << 24) |
			((uint32_t)input[3] << 16);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 32 to 47
	value = ((uint32_t)input[4] << 24) |
			((uint32_t)input[5] << 16);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 48 to 63
	value = ((uint32_t)input[6] << 24) |
			((uint32_t)input[7] << 16);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 64 to 79
	value = ((uint32_t)input[8] << 24) |
			((uint32_t)input[9] << 16);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 80 to 95
	value = ((uint32_t)input[10] << 24) |
			((uint32_t)input[11] << 16);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 96 to 111
	value = ((uint32_t)input[12] << 24) |
			((uint32_t)input[13] << 16);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 112 to 127
	value = ((uint32_t)input[14] << 24) |
			((uint32_t)input[15] << 16);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 128 to 143
	value = ((uint32_t)input[16] << 24) |
			((uint32_t)input[17] << 16);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 144 to 159
	value = ((uint32_t)input[18] << 24) |
			((uint32_t)input[19] << 16);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 160 to 175
	value = ((uint32_t)input[20] << 24) |
			((uint32_t)input[21] << 16);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 176 to 191
	value = ((uint32_t)input[22] << 24) |
			((uint32_t)input[23] << 16);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 192 to 207
	value = ((uint32_t)input[24] << 24) |
			((uint32_t)input[25] << 16);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 208 to 223
	value = ((uint32_t)input[26] << 24) |
			((uint32_t)input[27] << 16);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 224 to 239
	value = ((uint32_t)input[28] << 24) |
			((uint32_t)input[29] << 16);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 240 to 255
	value = ((uint32_t)input[30] << 24) |
			((uint32_t)input[31] << 16);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 256 to 271
	value = ((uint32_t)input[32] << 24) |
			((uint32_t)input[33] << 16);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 272 to 287
	value = ((uint32_t)input[34] << 24) |
			((uint32_t)input[35] << 16);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 288 to 303
	value = ((uint32_t)input[36] << 24) |
			((uint32_t)input[37] << 16);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 304 to 319
	value = ((uint32_t)input[38] << 24) |
			((uint32_t)input[39] << 16);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 320 to 335
	value = ((uint32_t)input[40] << 24) |
			((uint32_t)input[41] << 16);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 336 to 351
	value = ((uint32_t)input[42] << 24) |
			((uint32_t)input[43] << 16);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 352 to 367
	value = ((uint32_t)input[44] << 24) |
			((uint32_t)input[45] << 16);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 368 to 383
	value = ((uint32_t)input[46] << 24) |
			((uint32_t)input[47] << 16);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 384 to 399
	value = ((uint32_t)input[48] << 24) |
			((uint32_t)input[49] << 16);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 400 to 415
	value = ((uint32_t)input[50] << 24) |
			((uint32_t)input[51] << 16);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 416 to 431
	value = ((uint32_t)input[52] << 24) |
			((uint32_t)input[53] << 16);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 432 to 447
	value = ((uint32_t)input[54] << 24) |
			((uint32_t)input[55] << 16);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 448 to 463
	value = ((uint32_t)input[56] << 24) |
			((uint32_t)input[57] << 16);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 464 to 479
	value = ((uint32_t)input[58] << 24) |
			((uint32_t)input[59] << 16);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 480 to 495
	value = ((uint32_t)input[60] << 24) |
			((uint32_t)input[61] << 16);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 496 to 511
	value = ((uint32_t)input[62] << 24) |
			((uint32_t)input[63] << 16);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 512 to 527
	value = ((uint32_t)input[64] << 24) |
			((uint32_t)input[65] << 16);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 528 to 543
	value = ((uint32_t)input[66] << 24) |
			((uint32_t)input[67] << 16);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 544 to 559
	value = ((uint32_t)input[68] << 24) |
			((uint32_t)input[69] << 16);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 560 to 575
	value = ((uint32_t)input[70] << 24) |
			((uint32_t)input[71] << 16);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 576 to 591
	value = ((uint32_t)input[72] << 24) |
			((uint32_t)input[73] << 16);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 592 to 607
	value = ((uint32_t)input[74] << 24) |
			((uint32_t)input[75] << 16);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 608 to 623
	value = ((uint32_t)input[76] << 24) |
			((uint32_t)input[77] << 16);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 624 to 639
	value = ((uint32_t)input[78] << 24) |
			((uint32_t)input[79] << 16);
	output[39] = (double)(value >> 16);

	// read output[40]: from bit 640 to 655
	value = ((uint32_t)input[80] << 24) |
			((uint32_t)input[81] << 16);
	output[40] = (double)(value >> 16);

	// read output[41]: from bit 656 to 671
	value = ((uint32_t)input[82] << 24) |
			((uint32_t)input[83] << 16);
	output[41] = (double)(value >> 16);

	// read output[42]: from bit 672 to 687
	value = ((uint32_t)input[84] << 24) |
			((uint32_t)input[85] << 16);
	output[42] = (double)(value >> 16);

	// read output[43]: from bit 688 to 703
	value = ((uint32_t)input[86] << 24) |
			((uint32_t)input[87] << 16);
	output[43] = (double)(value >> 16);

	// read output[44]: from bit 704 to 719
	value = ((uint32_t)input[88] << 24) |
			((uint32_t)input[89] << 16);
	output[44] = (double)(value >> 16);

	// read output[45]: from bit 720 to 735
	value = ((uint32_t)input[90] << 24) |
			((uint32_t)input[91] << 16);
	output[45] = (double)(value >> 16);

	// read output[46]: from bit 736 to 751
	value = ((uint32_t)input[92] << 24) |
			((uint32_t)input[93] << 16);
	output[46] = (double)(value >> 16);

	// read output[47]: from bit 752 to 767
	value = ((uint32_t)input[94] << 24) |
			((uint32_t)input[95] << 16);
	output[47] = (double)(value >> 16);

	// read output[48]: from bit 768 to 783
	value = ((uint32_t)input[96] << 24) |
			((uint32_t)input[97] << 16);
	output[48] = (double)(value >> 16);

	// read output[49]: from bit 784 to 799
	value = ((uint32_t)input[98] << 24) |
			((uint32_t)input[99] << 16);
	output[49] = (double)(value >> 16);

	// read output[50]: from bit 800 to 815
	value = ((uint32_t)input[100] << 24) |
			((uint32_t)input[101] << 16);
	output[50] = (double)(value >> 16);
}

static void unpack_51_16bit_unsigned_0off(const uint8_t * input, double * output, void *closure) {
	// Unpack 51 values into output
	// Values are 16-bit unsigned
	// Skip 0 bits, read 816 bits of data.
	// Input must be at least 102 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 0 to 15
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)input[1] << 16);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 16 to 31
	value = ((uint32_t)input[2] << 24) |
			((uint32_t)input[3] << 16);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 32 to 47
	value = ((uint32_t)input[4] << 24) |
			((uint32_t)input[5] << 16);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 48 to 63
	value = ((uint32_t)input[6] << 24) |
			((uint32_t)input[7] << 16);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 64 to 79
	value = ((uint32_t)input[8] << 24) |
			((uint32_t)input[9] << 16);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 80 to 95
	value = ((uint32_t)input[10] << 24) |
			((uint32_t)input[11] << 16);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 96 to 111
	value = ((uint32_t)input[12] << 24) |
			((uint32_t)input[13] << 16);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 112 to 127
	value = ((uint32_t)input[14] << 24) |
			((uint32_t)input[15] << 16);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 128 to 143
	value = ((uint32_t)input[16] << 24) |
			((uint32_t)input[17] << 16);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 144 to 159
	value = ((uint32_t)input[18] << 24) |
			((uint32_t)input[19] << 16);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 160 to 175
	value = ((uint32_t)input[20] << 24) |
			((uint32_t)input[21] << 16);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 176 to 191
	value = ((uint32_t)input[22] << 24) |
			((uint32_t)input[23] << 16);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 192 to 207
	value = ((uint32_t)input[24] << 24) |
			((uint32_t)input[25] << 16);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 208 to 223
	value = ((uint32_t)input[26] << 24) |
			((uint32_t)input[27] << 16);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 224 to 239
	value = ((uint32_t)input[28] << 24) |
			((uint32_t)input[29] << 16);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 240 to 255
	value = ((uint32_t)input[30] << 24) |
			((uint32_t)input[31] << 16);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 256 to 271
	value = ((uint32_t)input[32] << 24) |
			((uint32_t)input[33] << 16);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 272 to 287
	value = ((uint32_t)input[34] << 24) |
			((uint32_t)input[35] << 16);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 288 to 303
	value = ((uint32_t)input[36] << 24) |
			((uint32_t)input[37] << 16);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 304 to 319
	value = ((uint32_t)input[38] << 24) |
			((uint32_t)input[39] << 16);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 320 to 335
	value = ((uint32_t)input[40] << 24) |
			((uint32_t)input[41] << 16);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 336 to 351
	value = ((uint32_t)input[42] << 24) |
			((uint32_t)input[43] << 16);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 352 to 367
	value = ((uint32_t)input[44] << 24) |
			((uint32_t)input[45] << 16);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 368 to 383
	value = ((uint32_t)input[46] << 24) |
			((uint32_t)input[47] << 16);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 384 to 399
	value = ((uint32_t)input[48] << 24) |
			((uint32_t)input[49] << 16);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 400 to 415
	value = ((uint32_t)input[50] << 24) |
			((uint32_t)input[51] << 16);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 416 to 431
	value = ((uint32_t)input[52] << 24) |
			((uint32_t)input[53] << 16);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 432 to 447
	value = ((uint32_t)input[54] << 24) |
			((uint32_t)input[55] << 16);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 448 to 463
	value = ((uint32_t)input[56] << 24) |
			((uint32_t)input[57] << 16);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 464 to 479
	value = ((uint32_t)input[58] << 24) |
			((uint32_t)input[59] << 16);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 480 to 495
	value = ((uint32_t)input[60] << 24) |
			((uint32_t)input[61] << 16);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 496 to 511
	value = ((uint32_t)input[62] << 24) |
			((uint32_t)input[63] << 16);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 512 to 527
	value = ((uint32_t)input[64] << 24) |
			((uint32_t)input[65] << 16);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 528 to 543
	value = ((uint32_t)input[66] << 24) |
			((uint32_t)input[67] << 16);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 544 to 559
	value = ((uint32_t)input[68] << 24) |
			((uint32_t)input[69] << 16);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 560 to 575
	value = ((uint32_t)input[70] << 24) |
			((uint32_t)input[71] << 16);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 576 to 591
	value = ((uint32_t)input[72] << 24) |
			((uint32_t)input[73] << 16);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 592 to 607
	value = ((uint32_t)input[74] << 24) |
			((uint32_t)input[75] << 16);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 608 to 623
	value = ((uint32_t)input[76] << 24) |
			((uint32_t)input[77] << 16);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 624 to 639
	value = ((uint32_t)input[78] << 24) |
			((uint32_t)input[79] << 16);
	output[39] = (double)(value >> 16);

	// read output[40]: from bit 640 to 655
	value = ((uint32_t)input[80] << 24) |
			((uint32_t)input[81] << 16);
	output[40] = (double)(value >> 16);

	// read output[41]: from bit 656 to 671
	value = ((uint32_t)input[82] << 24) |
			((uint32_t)input[83] << 16);
	output[41] = (double)(value >> 16);

	// read output[42]: from bit 672 to 687
	value = ((uint32_t)input[84] << 24) |
			((uint32_t)input[85] << 16);
	output[42] = (double)(value >> 16);

	// read output[43]: from bit 688 to 703
	value = ((uint32_t)input[86] << 24) |
			((uint32_t)input[87] << 16);
	output[43] = (double)(value >> 16);

	// read output[44]: from bit 704 to 719
	value = ((uint32_t)input[88] << 24) |
			((uint32_t)input[89] << 16);
	output[44] = (double)(value >> 16);

	// read output[45]: from bit 720 to 735
	value = ((uint32_t)input[90] << 24) |
			((uint32_t)input[91] << 16);
	output[45] = (double)(value >> 16);

	// read output[46]: from bit 736 to 751
	value = ((uint32_t)input[92] << 24) |
			((uint32_t)input[93] << 16);
	output[46] = (double)(value >> 16);

	// read output[47]: from bit 752 to 767
	value = ((uint32_t)input[94] << 24) |
			((uint32_t)input[95] << 16);
	output[47] = (double)(value >> 16);

	// read output[48]: from bit 768 to 783
	value = ((uint32_t)input[96] << 24) |
			((uint32_t)input[97] << 16);
	output[48] = (double)(value >> 16);

	// read output[49]: from bit 784 to 799
	value = ((uint32_t)input[98] << 24) |
			((uint32_t)input[99] << 16);
	output[49] = (double)(value >> 16);

	// read output[50]: from bit 800 to 815
	value = ((uint32_t)input[100] << 24) |
			((uint32_t)input[101] << 16);
	output[50] = (double)(value >> 16);
}

static void unpack_51_16bit_signed_1off(const uint8_t * input, double * output, void *closure) {
	// Unpack 51 values into output
	// Values are 16-bit signed
	// Skip 1 bits, read 816 bits of data.
	// Input must be at least 103 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 1 to 16
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)input[1] << 17) |
			((uint32_t)(input[2] & 0x80) << 9);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 17 to 32
	value = ((uint32_t)(input[2] & 0x7f) << 25) |
			((uint32_t)input[3] << 17) |
			((uint32_t)(input[4] & 0x80) << 9);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 33 to 48
	value = ((uint32_t)(input[4] & 0x7f) << 25) |
			((uint32_t)input[5] << 17) |
			((uint32_t)(input[6] & 0x80) << 9);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 49 to 64
	value = ((uint32_t)(input[6] & 0x7f) << 25) |
			((uint32_t)input[7] << 17) |
			((uint32_t)(input[8] & 0x80) << 9);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 65 to 80
	value = ((uint32_t)(input[8] & 0x7f) << 25) |
			((uint32_t)input[9] << 17) |
			((uint32_t)(input[10] & 0x80) << 9);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 81 to 96
	value = ((uint32_t)(input[10] & 0x7f) << 25) |
			((uint32_t)input[11] << 17) |
			((uint32_t)(input[12] & 0x80) << 9);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 97 to 112
	value = ((uint32_t)(input[12] & 0x7f) << 25) |
			((uint32_t)input[13] << 17) |
			((uint32_t)(input[14] & 0x80) << 9);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 113 to 128
	value = ((uint32_t)(input[14] & 0x7f) << 25) |
			((uint32_t)input[15] << 17) |
			((uint32_t)(input[16] & 0x80) << 9);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 129 to 144
	value = ((uint32_t)(input[16] & 0x7f) << 25) |
			((uint32_t)input[17] << 17) |
			((uint32_t)(input[18] & 0x80) << 9);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 145 to 160
	value = ((uint32_t)(input[18] & 0x7f) << 25) |
			((uint32_t)input[19] << 17) |
			((uint32_t)(input[20] & 0x80) << 9);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 161 to 176
	value = ((uint32_t)(input[20] & 0x7f) << 25) |
			((uint32_t)input[21] << 17) |
			((uint32_t)(input[22] & 0x80) << 9);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 177 to 192
	value = ((uint32_t)(input[22] & 0x7f) << 25) |
			((uint32_t)input[23] << 17) |
			((uint32_t)(input[24] & 0x80) << 9);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 193 to 208
	value = ((uint32_t)(input[24] & 0x7f) << 25) |
			((uint32_t)input[25] << 17) |
			((uint32_t)(input[26] & 0x80) << 9);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 209 to 224
	value = ((uint32_t)(input[26] & 0x7f) << 25) |
			((uint32_t)input[27] << 17) |
			((uint32_t)(input[28] & 0x80) << 9);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 225 to 240
	value = ((uint32_t)(input[28] & 0x7f) << 25) |
			((uint32_t)input[29] << 17) |
			((uint32_t)(input[30] & 0x80) << 9);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 241 to 256
	value = ((uint32_t)(input[30] & 0x7f) << 25) |
			((uint32_t)input[31] << 17) |
			((uint32_t)(input[32] & 0x80) << 9);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 257 to 272
	value = ((uint32_t)(input[32] & 0x7f) << 25) |
			((uint32_t)input[33] << 17) |
			((uint32_t)(input[34] & 0x80) << 9);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 273 to 288
	value = ((uint32_t)(input[34] & 0x7f) << 25) |
			((uint32_t)input[35] << 17) |
			((uint32_t)(input[36] & 0x80) << 9);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 289 to 304
	value = ((uint32_t)(input[36] & 0x7f) << 25) |
			((uint32_t)input[37] << 17) |
			((uint32_t)(input[38] & 0x80) << 9);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 305 to 320
	value = ((uint32_t)(input[38] & 0x7f) << 25) |
			((uint32_t)input[39] << 17) |
			((uint32_t)(input[40] & 0x80) << 9);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 321 to 336
	value = ((uint32_t)(input[40] & 0x7f) << 25) |
			((uint32_t)input[41] << 17) |
			((uint32_t)(input[42] & 0x80) << 9);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 337 to 352
	value = ((uint32_t)(input[42] & 0x7f) << 25) |
			((uint32_t)input[43] << 17) |
			((uint32_t)(input[44] & 0x80) << 9);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 353 to 368
	value = ((uint32_t)(input[44] & 0x7f) << 25) |
			((uint32_t)input[45] << 17) |
			((uint32_t)(input[46] & 0x80) << 9);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 369 to 384
	value = ((uint32_t)(input[46] & 0x7f) << 25) |
			((uint32_t)input[47] << 17) |
			((uint32_t)(input[48] & 0x80) << 9);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 385 to 400
	value = ((uint32_t)(input[48] & 0x7f) << 25) |
			((uint32_t)input[49] << 17) |
			((uint32_t)(input[50] & 0x80) << 9);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 401 to 416
	value = ((uint32_t)(input[50] & 0x7f) << 25) |
			((uint32_t)input[51] << 17) |
			((uint32_t)(input[52] & 0x80) << 9);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 417 to 432
	value = ((uint32_t)(input[52] & 0x7f) << 25) |
			((uint32_t)input[53] << 17) |
			((uint32_t)(input[54] & 0x80) << 9);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 433 to 448
	value = ((uint32_t)(input[54] & 0x7f) << 25) |
			((uint32_t)input[55] << 17) |
			((uint32_t)(input[56] & 0x80) << 9);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 449 to 464
	value = ((uint32_t)(input[56] & 0x7f) << 25) |
			((uint32_t)input[57] << 17) |
			((uint32_t)(input[58] & 0x80) << 9);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 465 to 480
	value = ((uint32_t)(input[58] & 0x7f) << 25) |
			((uint32_t)input[59] << 17) |
			((uint32_t)(input[60] & 0x80) << 9);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 481 to 496
	value = ((uint32_t)(input[60] & 0x7f) << 25) |
			((uint32_t)input[61] << 17) |
			((uint32_t)(input[62] & 0x80) << 9);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 497 to 512
	value = ((uint32_t)(input[62] & 0x7f) << 25) |
			((uint32_t)input[63] << 17) |
			((uint32_t)(input[64] & 0x80) << 9);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 513 to 528
	value = ((uint32_t)(input[64] & 0x7f) << 25) |
			((uint32_t)input[65] << 17) |
			((uint32_t)(input[66] & 0x80) << 9);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 529 to 544
	value = ((uint32_t)(input[66] & 0x7f) << 25) |
			((uint32_t)input[67] << 17) |
			((uint32_t)(input[68] & 0x80) << 9);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 545 to 560
	value = ((uint32_t)(input[68] & 0x7f) << 25) |
			((uint32_t)input[69] << 17) |
			((uint32_t)(input[70] & 0x80) << 9);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 561 to 576
	value = ((uint32_t)(input[70] & 0x7f) << 25) |
			((uint32_t)input[71] << 17) |
			((uint32_t)(input[72] & 0x80) << 9);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 577 to 592
	value = ((uint32_t)(input[72] & 0x7f) << 25) |
			((uint32_t)input[73] << 17) |
			((uint32_t)(input[74] & 0x80) << 9);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 593 to 608
	value = ((uint32_t)(input[74] & 0x7f) << 25) |
			((uint32_t)input[75] << 17) |
			((uint32_t)(input[76] & 0x80) << 9);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 609 to 624
	value = ((uint32_t)(input[76] & 0x7f) << 25) |
			((uint32_t)input[77] << 17) |
			((uint32_t)(input[78] & 0x80) << 9);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 625 to 640
	value = ((uint32_t)(input[78] & 0x7f) << 25) |
			((uint32_t)input[79] << 17) |
			((uint32_t)(input[80] & 0x80) << 9);
	output[39] = (double)(value >> 16);

	// read output[40]: from bit 641 to 656
	value = ((uint32_t)(input[80] & 0x7f) << 25) |
			((uint32_t)input[81] << 17) |
			((uint32_t)(input[82] & 0x80) << 9);
	output[40] = (double)(value >> 16);

	// read output[41]: from bit 657 to 672
	value = ((uint32_t)(input[82] & 0x7f) << 25) |
			((uint32_t)input[83] << 17) |
			((uint32_t)(input[84] & 0x80) << 9);
	output[41] = (double)(value >> 16);

	// read output[42]: from bit 673 to 688
	value = ((uint32_t)(input[84] & 0x7f) << 25) |
			((uint32_t)input[85] << 17) |
			((uint32_t)(input[86] & 0x80) << 9);
	output[42] = (double)(value >> 16);

	// read output[43]: from bit 689 to 704
	value = ((uint32_t)(input[86] & 0x7f) << 25) |
			((uint32_t)input[87] << 17) |
			((uint32_t)(input[88] & 0x80) << 9);
	output[43] = (double)(value >> 16);

	// read output[44]: from bit 705 to 720
	value = ((uint32_t)(input[88] & 0x7f) << 25) |
			((uint32_t)input[89] << 17) |
			((uint32_t)(input[90] & 0x80) << 9);
	output[44] = (double)(value >> 16);

	// read output[45]: from bit 721 to 736
	value = ((uint32_t)(input[90] & 0x7f) << 25) |
			((uint32_t)input[91] << 17) |
			((uint32_t)(input[92] & 0x80) << 9);
	output[45] = (double)(value >> 16);

	// read output[46]: from bit 737 to 752
	value = ((uint32_t)(input[92] & 0x7f) << 25) |
			((uint32_t)input[93] << 17) |
			((uint32_t)(input[94] & 0x80) << 9);
	output[46] = (double)(value >> 16);

	// read output[47]: from bit 753 to 768
	value = ((uint32_t)(input[94] & 0x7f) << 25) |
			((uint32_t)input[95] << 17) |
			((uint32_t)(input[96] & 0x80) << 9);
	output[47] = (double)(value >> 16);

	// read output[48]: from bit 769 to 784
	value = ((uint32_t)(input[96] & 0x7f) << 25) |
			((uint32_t)input[97] << 17) |
			((uint32_t)(input[98] & 0x80) << 9);
	output[48] = (double)(value >> 16);

	// read output[49]: from bit 785 to 800
	value = ((uint32_t)(input[98] & 0x7f) << 25) |
			((uint32_t)input[99] << 17) |
			((uint32_t)(input[100] & 0x80) << 9);
	output[49] = (double)(value >> 16);

	// read output[50]: from bit 801 to 816
	value = ((uint32_t)(input[100] & 0x7f) << 25) |
			((uint32_t)input[101] << 17) |
			((uint32_t)(input[102] & 0x80) << 9);
	output[50] = (double)(value >> 16);
}

static void unpack_51_16bit_unsigned_1off(const uint8_t * input, double * output, void *closure) {
	// Unpack 51 values into output
	// Values are 16-bit unsigned
	// Skip 1 bits, read 816 bits of data.
	// Input must be at least 103 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 1 to 16
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)input[1] << 17) |
			((uint32_t)(input[2] & 0x80) << 9);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 17 to 32
	value = ((uint32_t)(input[2] & 0x7f) << 25) |
			((uint32_t)input[3] << 17) |
			((uint32_t)(input[4] & 0x80) << 9);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 33 to 48
	value = ((uint32_t)(input[4] & 0x7f) << 25) |
			((uint32_t)input[5] << 17) |
			((uint32_t)(input[6] & 0x80) << 9);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 49 to 64
	value = ((uint32_t)(input[6] & 0x7f) << 25) |
			((uint32_t)input[7] << 17) |
			((uint32_t)(input[8] & 0x80) << 9);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 65 to 80
	value = ((uint32_t)(input[8] & 0x7f) << 25) |
			((uint32_t)input[9] << 17) |
			((uint32_t)(input[10] & 0x80) << 9);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 81 to 96
	value = ((uint32_t)(input[10] & 0x7f) << 25) |
			((uint32_t)input[11] << 17) |
			((uint32_t)(input[12] & 0x80) << 9);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 97 to 112
	value = ((uint32_t)(input[12] & 0x7f) << 25) |
			((uint32_t)input[13] << 17) |
			((uint32_t)(input[14] & 0x80) << 9);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 113 to 128
	value = ((uint32_t)(input[14] & 0x7f) << 25) |
			((uint32_t)input[15] << 17) |
			((uint32_t)(input[16] & 0x80) << 9);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 129 to 144
	value = ((uint32_t)(input[16] & 0x7f) << 25) |
			((uint32_t)input[17] << 17) |
			((uint32_t)(input[18] & 0x80) << 9);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 145 to 160
	value = ((uint32_t)(input[18] & 0x7f) << 25) |
			((uint32_t)input[19] << 17) |
			((uint32_t)(input[20] & 0x80) << 9);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 161 to 176
	value = ((uint32_t)(input[20] & 0x7f) << 25) |
			((uint32_t)input[21] << 17) |
			((uint32_t)(input[22] & 0x80) << 9);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 177 to 192
	value = ((uint32_t)(input[22] & 0x7f) << 25) |
			((uint32_t)input[23] << 17) |
			((uint32_t)(input[24] & 0x80) << 9);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 193 to 208
	value = ((uint32_t)(input[24] & 0x7f) << 25) |
			((uint32_t)input[25] << 17) |
			((uint32_t)(input[26] & 0x80) << 9);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 209 to 224
	value = ((uint32_t)(input[26] & 0x7f) << 25) |
			((uint32_t)input[27] << 17) |
			((uint32_t)(input[28] & 0x80) << 9);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 225 to 240
	value = ((uint32_t)(input[28] & 0x7f) << 25) |
			((uint32_t)input[29] << 17) |
			((uint32_t)(input[30] & 0x80) << 9);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 241 to 256
	value = ((uint32_t)(input[30] & 0x7f) << 25) |
			((uint32_t)input[31] << 17) |
			((uint32_t)(input[32] & 0x80) << 9);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 257 to 272
	value = ((uint32_t)(input[32] & 0x7f) << 25) |
			((uint32_t)input[33] << 17) |
			((uint32_t)(input[34] & 0x80) << 9);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 273 to 288
	value = ((uint32_t)(input[34] & 0x7f) << 25) |
			((uint32_t)input[35] << 17) |
			((uint32_t)(input[36] & 0x80) << 9);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 289 to 304
	value = ((uint32_t)(input[36] & 0x7f) << 25) |
			((uint32_t)input[37] << 17) |
			((uint32_t)(input[38] & 0x80) << 9);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 305 to 320
	value = ((uint32_t)(input[38] & 0x7f) << 25) |
			((uint32_t)input[39] << 17) |
			((uint32_t)(input[40] & 0x80) << 9);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 321 to 336
	value = ((uint32_t)(input[40] & 0x7f) << 25) |
			((uint32_t)input[41] << 17) |
			((uint32_t)(input[42] & 0x80) << 9);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 337 to 352
	value = ((uint32_t)(input[42] & 0x7f) << 25) |
			((uint32_t)input[43] << 17) |
			((uint32_t)(input[44] & 0x80) << 9);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 353 to 368
	value = ((uint32_t)(input[44] & 0x7f) << 25) |
			((uint32_t)input[45] << 17) |
			((uint32_t)(input[46] & 0x80) << 9);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 369 to 384
	value = ((uint32_t)(input[46] & 0x7f) << 25) |
			((uint32_t)input[47] << 17) |
			((uint32_t)(input[48] & 0x80) << 9);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 385 to 400
	value = ((uint32_t)(input[48] & 0x7f) << 25) |
			((uint32_t)input[49] << 17) |
			((uint32_t)(input[50] & 0x80) << 9);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 401 to 416
	value = ((uint32_t)(input[50] & 0x7f) << 25) |
			((uint32_t)input[51] << 17) |
			((uint32_t)(input[52] & 0x80) << 9);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 417 to 432
	value = ((uint32_t)(input[52] & 0x7f) << 25) |
			((uint32_t)input[53] << 17) |
			((uint32_t)(input[54] & 0x80) << 9);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 433 to 448
	value = ((uint32_t)(input[54] & 0x7f) << 25) |
			((uint32_t)input[55] << 17) |
			((uint32_t)(input[56] & 0x80) << 9);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 449 to 464
	value = ((uint32_t)(input[56] & 0x7f) << 25) |
			((uint32_t)input[57] << 17) |
			((uint32_t)(input[58] & 0x80) << 9);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 465 to 480
	value = ((uint32_t)(input[58] & 0x7f) << 25) |
			((uint32_t)input[59] << 17) |
			((uint32_t)(input[60] & 0x80) << 9);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 481 to 496
	value = ((uint32_t)(input[60] & 0x7f) << 25) |
			((uint32_t)input[61] << 17) |
			((uint32_t)(input[62] & 0x80) << 9);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 497 to 512
	value = ((uint32_t)(input[62] & 0x7f) << 25) |
			((uint32_t)input[63] << 17) |
			((uint32_t)(input[64] & 0x80) << 9);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 513 to 528
	value = ((uint32_t)(input[64] & 0x7f) << 25) |
			((uint32_t)input[65] << 17) |
			((uint32_t)(input[66] & 0x80) << 9);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 529 to 544
	value = ((uint32_t)(input[66] & 0x7f) << 25) |
			((uint32_t)input[67] << 17) |
			((uint32_t)(input[68] & 0x80) << 9);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 545 to 560
	value = ((uint32_t)(input[68] & 0x7f) << 25) |
			((uint32_t)input[69] << 17) |
			((uint32_t)(input[70] & 0x80) << 9);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 561 to 576
	value = ((uint32_t)(input[70] & 0x7f) << 25) |
			((uint32_t)input[71] << 17) |
			((uint32_t)(input[72] & 0x80) << 9);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 577 to 592
	value = ((uint32_t)(input[72] & 0x7f) << 25) |
			((uint32_t)input[73] << 17) |
			((uint32_t)(input[74] & 0x80) << 9);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 593 to 608
	value = ((uint32_t)(input[74] & 0x7f) << 25) |
			((uint32_t)input[75] << 17) |
			((uint32_t)(input[76] & 0x80) << 9);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 609 to 624
	value = ((uint32_t)(input[76] & 0x7f) << 25) |
			((uint32_t)input[77] << 17) |
			((uint32_t)(input[78] & 0x80) << 9);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 625 to 640
	value = ((uint32_t)(input[78] & 0x7f) << 25) |
			((uint32_t)input[79] << 17) |
			((uint32_t)(input[80] & 0x80) << 9);
	output[39] = (double)(value >> 16);

	// read output[40]: from bit 641 to 656
	value = ((uint32_t)(input[80] & 0x7f) << 25) |
			((uint32_t)input[81] << 17) |
			((uint32_t)(input[82] & 0x80) << 9);
	output[40] = (double)(value >> 16);

	// read output[41]: from bit 657 to 672
	value = ((uint32_t)(input[82] & 0x7f) << 25) |
			((uint32_t)input[83] << 17) |
			((uint32_t)(input[84] & 0x80) << 9);
	output[41] = (double)(value >> 16);

	// read output[42]: from bit 673 to 688
	value = ((uint32_t)(input[84] & 0x7f) << 25) |
			((uint32_t)input[85] << 17) |
			((uint32_t)(input[86] & 0x80) << 9);
	output[42] = (double)(value >> 16);

	// read output[43]: from bit 689 to 704
	value = ((uint32_t)(input[86] & 0x7f) << 25) |
			((uint32_t)input[87] << 17) |
			((uint32_t)(input[88] & 0x80) << 9);
	output[43] = (double)(value >> 16);

	// read output[44]: from bit 705 to 720
	value = ((uint32_t)(input[88] & 0x7f) << 25) |
			((uint32_t)input[89] << 17) |
			((uint32_t)(input[90] & 0x80) << 9);
	output[44] = (double)(value >> 16);

	// read output[45]: from bit 721 to 736
	value = ((uint32_t)(input[90] & 0x7f) << 25) |
			((uint32_t)input[91] << 17) |
			((uint32_t)(input[92] & 0x80) << 9);
	output[45] = (double)(value >> 16);

	// read output[46]: from bit 737 to 752
	value = ((uint32_t)(input[92] & 0x7f) << 25) |
			((uint32_t)input[93] << 17) |
			((uint32_t)(input[94] & 0x80) << 9);
	output[46] = (double)(value >> 16);

	// read output[47]: from bit 753 to 768
	value = ((uint32_t)(input[94] & 0x7f) << 25) |
			((uint32_t)input[95] << 17) |
			((uint32_t)(input[96] & 0x80) << 9);
	output[47] = (double)(value >> 16);

	// read output[48]: from bit 769 to 784
	value = ((uint32_t)(input[96] & 0x7f) << 25) |
			((uint32_t)input[97] << 17) |
			((uint32_t)(input[98] & 0x80) << 9);
	output[48] = (double)(value >> 16);

	// read output[49]: from bit 785 to 800
	value = ((uint32_t)(input[98] & 0x7f) << 25) |
			((uint32_t)input[99] << 17) |
			((uint32_t)(input[100] & 0x80) << 9);
	output[49] = (double)(value >> 16);

	// read output[50]: from bit 801 to 816
	value = ((uint32_t)(input[100] & 0x7f) << 25) |
			((uint32_t)input[101] << 17) |
			((uint32_t)(input[102] & 0x80) << 9);
	output[50] = (double)(value >> 16);
}

static void unpack_51_16bit_signed_2off(const uint8_t * input, double * output, void *closure) {
	// Unpack 51 values into output
	// Values are 16-bit signed
	// Skip 2 bits, read 816 bits of data.
	// Input must be at least 103 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 2 to 17
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)input[1] << 18) |
			((uint32_t)(input[2] & 0xc0) << 10);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 18 to 33
	value = ((uint32_t)(input[2] & 0x3f) << 26) |
			((uint32_t)input[3] << 18) |
			((uint32_t)(input[4] & 0xc0) << 10);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 34 to 49
	value = ((uint32_t)(input[4] & 0x3f) << 26) |
			((uint32_t)input[5] << 18) |
			((uint32_t)(input[6] & 0xc0) << 10);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 50 to 65
	value = ((uint32_t)(input[6] & 0x3f) << 26) |
			((uint32_t)input[7] << 18) |
			((uint32_t)(input[8] & 0xc0) << 10);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 66 to 81
	value = ((uint32_t)(input[8] & 0x3f) << 26) |
			((uint32_t)input[9] << 18) |
			((uint32_t)(input[10] & 0xc0) << 10);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 82 to 97
	value = ((uint32_t)(input[10] & 0x3f) << 26) |
			((uint32_t)input[11] << 18) |
			((uint32_t)(input[12] & 0xc0) << 10);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 98 to 113
	value = ((uint32_t)(input[12] & 0x3f) << 26) |
			((uint32_t)input[13] << 18) |
			((uint32_t)(input[14] & 0xc0) << 10);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 114 to 129
	value = ((uint32_t)(input[14] & 0x3f) << 26) |
			((uint32_t)input[15] << 18) |
			((uint32_t)(input[16] & 0xc0) << 10);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 130 to 145
	value = ((uint32_t)(input[16] & 0x3f) << 26) |
			((uint32_t)input[17] << 18) |
			((uint32_t)(input[18] & 0xc0) << 10);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 146 to 161
	value = ((uint32_t)(input[18] & 0x3f) << 26) |
			((uint32_t)input[19] << 18) |
			((uint32_t)(input[20] & 0xc0) << 10);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 162 to 177
	value = ((uint32_t)(input[20] & 0x3f) << 26) |
			((uint32_t)input[21] << 18) |
			((uint32_t)(input[22] & 0xc0) << 10);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 178 to 193
	value = ((uint32_t)(input[22] & 0x3f) << 26) |
			((uint32_t)input[23] << 18) |
			((uint32_t)(input[24] & 0xc0) << 10);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 194 to 209
	value = ((uint32_t)(input[24] & 0x3f) << 26) |
			((uint32_t)input[25] << 18) |
			((uint32_t)(input[26] & 0xc0) << 10);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 210 to 225
	value = ((uint32_t)(input[26] & 0x3f) << 26) |
			((uint32_t)input[27] << 18) |
			((uint32_t)(input[28] & 0xc0) << 10);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 226 to 241
	value = ((uint32_t)(input[28] & 0x3f) << 26) |
			((uint32_t)input[29] << 18) |
			((uint32_t)(input[30] & 0xc0) << 10);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 242 to 257
	value = ((uint32_t)(input[30] & 0x3f) << 26) |
			((uint32_t)input[31] << 18) |
			((uint32_t)(input[32] & 0xc0) << 10);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 258 to 273
	value = ((uint32_t)(input[32] & 0x3f) << 26) |
			((uint32_t)input[33] << 18) |
			((uint32_t)(input[34] & 0xc0) << 10);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 274 to 289
	value = ((uint32_t)(input[34] & 0x3f) << 26) |
			((uint32_t)input[35] << 18) |
			((uint32_t)(input[36] & 0xc0) << 10);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 290 to 305
	value = ((uint32_t)(input[36] & 0x3f) << 26) |
			((uint32_t)input[37] << 18) |
			((uint32_t)(input[38] & 0xc0) << 10);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 306 to 321
	value = ((uint32_t)(input[38] & 0x3f) << 26) |
			((uint32_t)input[39] << 18) |
			((uint32_t)(input[40] & 0xc0) << 10);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 322 to 337
	value = ((uint32_t)(input[40] & 0x3f) << 26) |
			((uint32_t)input[41] << 18) |
			((uint32_t)(input[42] & 0xc0) << 10);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 338 to 353
	value = ((uint32_t)(input[42] & 0x3f) << 26) |
			((uint32_t)input[43] << 18) |
			((uint32_t)(input[44] & 0xc0) << 10);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 354 to 369
	value = ((uint32_t)(input[44] & 0x3f) << 26) |
			((uint32_t)input[45] << 18) |
			((uint32_t)(input[46] & 0xc0) << 10);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 370 to 385
	value = ((uint32_t)(input[46] & 0x3f) << 26) |
			((uint32_t)input[47] << 18) |
			((uint32_t)(input[48] & 0xc0) << 10);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 386 to 401
	value = ((uint32_t)(input[48] & 0x3f) << 26) |
			((uint32_t)input[49] << 18) |
			((uint32_t)(input[50] & 0xc0) << 10);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 402 to 417
	value = ((uint32_t)(input[50] & 0x3f) << 26) |
			((uint32_t)input[51] << 18) |
			((uint32_t)(input[52] & 0xc0) << 10);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 418 to 433
	value = ((uint32_t)(input[52] & 0x3f) << 26) |
			((uint32_t)input[53] << 18) |
			((uint32_t)(input[54] & 0xc0) << 10);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 434 to 449
	value = ((uint32_t)(input[54] & 0x3f) << 26) |
			((uint32_t)input[55] << 18) |
			((uint32_t)(input[56] & 0xc0) << 10);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 450 to 465
	value = ((uint32_t)(input[56] & 0x3f) << 26) |
			((uint32_t)input[57] << 18) |
			((uint32_t)(input[58] & 0xc0) << 10);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 466 to 481
	value = ((uint32_t)(input[58] & 0x3f) << 26) |
			((uint32_t)input[59] << 18) |
			((uint32_t)(input[60] & 0xc0) << 10);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 482 to 497
	value = ((uint32_t)(input[60] & 0x3f) << 26) |
			((uint32_t)input[61] << 18) |
			((uint32_t)(input[62] & 0xc0) << 10);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 498 to 513
	value = ((uint32_t)(input[62] & 0x3f) << 26) |
			((uint32_t)input[63] << 18) |
			((uint32_t)(input[64] & 0xc0) << 10);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 514 to 529
	value = ((uint32_t)(input[64] & 0x3f) << 26) |
			((uint32_t)input[65] << 18) |
			((uint32_t)(input[66] & 0xc0) << 10);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 530 to 545
	value = ((uint32_t)(input[66] & 0x3f) << 26) |
			((uint32_t)input[67] << 18) |
			((uint32_t)(input[68] & 0xc0) << 10);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 546 to 561
	value = ((uint32_t)(input[68] & 0x3f) << 26) |
			((uint32_t)input[69] << 18) |
			((uint32_t)(input[70] & 0xc0) << 10);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 562 to 577
	value = ((uint32_t)(input[70] & 0x3f) << 26) |
			((uint32_t)input[71] << 18) |
			((uint32_t)(input[72] & 0xc0) << 10);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 578 to 593
	value = ((uint32_t)(input[72] & 0x3f) << 26) |
			((uint32_t)input[73] << 18) |
			((uint32_t)(input[74] & 0xc0) << 10);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 594 to 609
	value = ((uint32_t)(input[74] & 0x3f) << 26) |
			((uint32_t)input[75] << 18) |
			((uint32_t)(input[76] & 0xc0) << 10);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 610 to 625
	value = ((uint32_t)(input[76] & 0x3f) << 26) |
			((uint32_t)input[77] << 18) |
			((uint32_t)(input[78] & 0xc0) << 10);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 626 to 641
	value = ((uint32_t)(input[78] & 0x3f) << 26) |
			((uint32_t)input[79] << 18) |
			((uint32_t)(input[80] & 0xc0) << 10);
	output[39] = (double)(value >> 16);

	// read output[40]: from bit 642 to 657
	value = ((uint32_t)(input[80] & 0x3f) << 26) |
			((uint32_t)input[81] << 18) |
			((uint32_t)(input[82] & 0xc0) << 10);
	output[40] = (double)(value >> 16);

	// read output[41]: from bit 658 to 673
	value = ((uint32_t)(input[82] & 0x3f) << 26) |
			((uint32_t)input[83] << 18) |
			((uint32_t)(input[84] & 0xc0) << 10);
	output[41] = (double)(value >> 16);

	// read output[42]: from bit 674 to 689
	value = ((uint32_t)(input[84] & 0x3f) << 26) |
			((uint32_t)input[85] << 18) |
			((uint32_t)(input[86] & 0xc0) << 10);
	output[42] = (double)(value >> 16);

	// read output[43]: from bit 690 to 705
	value = ((uint32_t)(input[86] & 0x3f) << 26) |
			((uint32_t)input[87] << 18) |
			((uint32_t)(input[88] & 0xc0) << 10);
	output[43] = (double)(value >> 16);

	// read output[44]: from bit 706 to 721
	value = ((uint32_t)(input[88] & 0x3f) << 26) |
			((uint32_t)input[89] << 18) |
			((uint32_t)(input[90] & 0xc0) << 10);
	output[44] = (double)(value >> 16);

	// read output[45]: from bit 722 to 737
	value = ((uint32_t)(input[90] & 0x3f) << 26) |
			((uint32_t)input[91] << 18) |
			((uint32_t)(input[92] & 0xc0) << 10);
	output[45] = (double)(value >> 16);

	// read output[46]: from bit 738 to 753
	value = ((uint32_t)(input[92] & 0x3f) << 26) |
			((uint32_t)input[93] << 18) |
			((uint32_t)(input[94] & 0xc0) << 10);
	output[46] = (double)(value >> 16);

	// read output[47]: from bit 754 to 769
	value = ((uint32_t)(input[94] & 0x3f) << 26) |
			((uint32_t)input[95] << 18) |
			((uint32_t)(input[96] & 0xc0) << 10);
	output[47] = (double)(value >> 16);

	// read output[48]: from bit 770 to 785
	value = ((uint32_t)(input[96] & 0x3f) << 26) |
			((uint32_t)input[97] << 18) |
			((uint32_t)(input[98] & 0xc0) << 10);
	output[48] = (double)(value >> 16);

	// read output[49]: from bit 786 to 801
	value = ((uint32_t)(input[98] & 0x3f) << 26) |
			((uint32_t)input[99] << 18) |
			((uint32_t)(input[100] & 0xc0) << 10);
	output[49] = (double)(value >> 16);

	// read output[50]: from bit 802 to 817
	value = ((uint32_t)(input[100] & 0x3f) << 26) |
			((uint32_t)input[101] << 18) |
			((uint32_t)(input[102] & 0xc0) << 10);
	output[50] = (double)(value >> 16);
}

static void unpack_51_16bit_unsigned_2off(const uint8_t * input, double * output, void *closure) {
	// Unpack 51 values into output
	// Values are 16-bit unsigned
	// Skip 2 bits, read 816 bits of data.
	// Input must be at least 103 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 2 to 17
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)input[1] << 18) |
			((uint32_t)(input[2] & 0xc0) << 10);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 18 to 33
	value = ((uint32_t)(input[2] & 0x3f) << 26) |
			((uint32_t)input[3] << 18) |
			((uint32_t)(input[4] & 0xc0) << 10);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 34 to 49
	value = ((uint32_t)(input[4] & 0x3f) << 26) |
			((uint32_t)input[5] << 18) |
			((uint32_t)(input[6] & 0xc0) << 10);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 50 to 65
	value = ((uint32_t)(input[6] & 0x3f) << 26) |
			((uint32_t)input[7] << 18) |
			((uint32_t)(input[8] & 0xc0) << 10);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 66 to 81
	value = ((uint32_t)(input[8] & 0x3f) << 26) |
			((uint32_t)input[9] << 18) |
			((uint32_t)(input[10] & 0xc0) << 10);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 82 to 97
	value = ((uint32_t)(input[10] & 0x3f) << 26) |
			((uint32_t)input[11] << 18) |
			((uint32_t)(input[12] & 0xc0) << 10);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 98 to 113
	value = ((uint32_t)(input[12] & 0x3f) << 26) |
			((uint32_t)input[13] << 18) |
			((uint32_t)(input[14] & 0xc0) << 10);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 114 to 129
	value = ((uint32_t)(input[14] & 0x3f) << 26) |
			((uint32_t)input[15] << 18) |
			((uint32_t)(input[16] & 0xc0) << 10);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 130 to 145
	value = ((uint32_t)(input[16] & 0x3f) << 26) |
			((uint32_t)input[17] << 18) |
			((uint32_t)(input[18] & 0xc0) << 10);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 146 to 161
	value = ((uint32_t)(input[18] & 0x3f) << 26) |
			((uint32_t)input[19] << 18) |
			((uint32_t)(input[20] & 0xc0) << 10);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 162 to 177
	value = ((uint32_t)(input[20] & 0x3f) << 26) |
			((uint32_t)input[21] << 18) |
			((uint32_t)(input[22] & 0xc0) << 10);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 178 to 193
	value = ((uint32_t)(input[22] & 0x3f) << 26) |
			((uint32_t)input[23] << 18) |
			((uint32_t)(input[24] & 0xc0) << 10);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 194 to 209
	value = ((uint32_t)(input[24] & 0x3f) << 26) |
			((uint32_t)input[25] << 18) |
			((uint32_t)(input[26] & 0xc0) << 10);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 210 to 225
	value = ((uint32_t)(input[26] & 0x3f) << 26) |
			((uint32_t)input[27] << 18) |
			((uint32_t)(input[28] & 0xc0) << 10);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 226 to 241
	value = ((uint32_t)(input[28] & 0x3f) << 26) |
			((uint32_t)input[29] << 18) |
			((uint32_t)(input[30] & 0xc0) << 10);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 242 to 257
	value = ((uint32_t)(input[30] & 0x3f) << 26) |
			((uint32_t)input[31] << 18) |
			((uint32_t)(input[32] & 0xc0) << 10);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 258 to 273
	value = ((uint32_t)(input[32] & 0x3f) << 26) |
			((uint32_t)input[33] << 18) |
			((uint32_t)(input[34] & 0xc0) << 10);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 274 to 289
	value = ((uint32_t)(input[34] & 0x3f) << 26) |
			((uint32_t)input[35] << 18) |
			((uint32_t)(input[36] & 0xc0) << 10);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 290 to 305
	value = ((uint32_t)(input[36] & 0x3f) << 26) |
			((uint32_t)input[37] << 18) |
			((uint32_t)(input[38] & 0xc0) << 10);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 306 to 321
	value = ((uint32_t)(input[38] & 0x3f) << 26) |
			((uint32_t)input[39] << 18) |
			((uint32_t)(input[40] & 0xc0) << 10);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 322 to 337
	value = ((uint32_t)(input[40] & 0x3f) << 26) |
			((uint32_t)input[41] << 18) |
			((uint32_t)(input[42] & 0xc0) << 10);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 338 to 353
	value = ((uint32_t)(input[42] & 0x3f) << 26) |
			((uint32_t)input[43] << 18) |
			((uint32_t)(input[44] & 0xc0) << 10);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 354 to 369
	value = ((uint32_t)(input[44] & 0x3f) << 26) |
			((uint32_t)input[45] << 18) |
			((uint32_t)(input[46] & 0xc0) << 10);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 370 to 385
	value = ((uint32_t)(input[46] & 0x3f) << 26) |
			((uint32_t)input[47] << 18) |
			((uint32_t)(input[48] & 0xc0) << 10);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 386 to 401
	value = ((uint32_t)(input[48] & 0x3f) << 26) |
			((uint32_t)input[49] << 18) |
			((uint32_t)(input[50] & 0xc0) << 10);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 402 to 417
	value = ((uint32_t)(input[50] & 0x3f) << 26) |
			((uint32_t)input[51] << 18) |
			((uint32_t)(input[52] & 0xc0) << 10);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 418 to 433
	value = ((uint32_t)(input[52] & 0x3f) << 26) |
			((uint32_t)input[53] << 18) |
			((uint32_t)(input[54] & 0xc0) << 10);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 434 to 449
	value = ((uint32_t)(input[54] & 0x3f) << 26) |
			((uint32_t)input[55] << 18) |
			((uint32_t)(input[56] & 0xc0) << 10);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 450 to 465
	value = ((uint32_t)(input[56] & 0x3f) << 26) |
			((uint32_t)input[57] << 18) |
			((uint32_t)(input[58] & 0xc0) << 10);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 466 to 481
	value = ((uint32_t)(input[58] & 0x3f) << 26) |
			((uint32_t)input[59] << 18) |
			((uint32_t)(input[60] & 0xc0) << 10);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 482 to 497
	value = ((uint32_t)(input[60] & 0x3f) << 26) |
			((uint32_t)input[61] << 18) |
			((uint32_t)(input[62] & 0xc0) << 10);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 498 to 513
	value = ((uint32_t)(input[62] & 0x3f) << 26) |
			((uint32_t)input[63] << 18) |
			((uint32_t)(input[64] & 0xc0) << 10);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 514 to 529
	value = ((uint32_t)(input[64] & 0x3f) << 26) |
			((uint32_t)input[65] << 18) |
			((uint32_t)(input[66] & 0xc0) << 10);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 530 to 545
	value = ((uint32_t)(input[66] & 0x3f) << 26) |
			((uint32_t)input[67] << 18) |
			((uint32_t)(input[68] & 0xc0) << 10);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 546 to 561
	value = ((uint32_t)(input[68] & 0x3f) << 26) |
			((uint32_t)input[69] << 18) |
			((uint32_t)(input[70] & 0xc0) << 10);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 562 to 577
	value = ((uint32_t)(input[70] & 0x3f) << 26) |
			((uint32_t)input[71] << 18) |
			((uint32_t)(input[72] & 0xc0) << 10);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 578 to 593
	value = ((uint32_t)(input[72] & 0x3f) << 26) |
			((uint32_t)input[73] << 18) |
			((uint32_t)(input[74] & 0xc0) << 10);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 594 to 609
	value = ((uint32_t)(input[74] & 0x3f) << 26) |
			((uint32_t)input[75] << 18) |
			((uint32_t)(input[76] & 0xc0) << 10);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 610 to 625
	value = ((uint32_t)(input[76] & 0x3f) << 26) |
			((uint32_t)input[77] << 18) |
			((uint32_t)(input[78] & 0xc0) << 10);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 626 to 641
	value = ((uint32_t)(input[78] & 0x3f) << 26) |
			((uint32_t)input[79] << 18) |
			((uint32_t)(input[80] & 0xc0) << 10);
	output[39] = (double)(value >> 16);

	// read output[40]: from bit 642 to 657
	value = ((uint32_t)(input[80] & 0x3f) << 26) |
			((uint32_t)input[81] << 18) |
			((uint32_t)(input[82] & 0xc0) << 10);
	output[40] = (double)(value >> 16);

	// read output[41]: from bit 658 to 673
	value = ((uint32_t)(input[82] & 0x3f) << 26) |
			((uint32_t)input[83] << 18) |
			((uint32_t)(input[84] & 0xc0) << 10);
	output[41] = (double)(value >> 16);

	// read output[42]: from bit 674 to 689
	value = ((uint32_t)(input[84] & 0x3f) << 26) |
			((uint32_t)input[85] << 18) |
			((uint32_t)(input[86] & 0xc0) << 10);
	output[42] = (double)(value >> 16);

	// read output[43]: from bit 690 to 705
	value = ((uint32_t)(input[86] & 0x3f) << 26) |
			((uint32_t)input[87] << 18) |
			((uint32_t)(input[88] & 0xc0) << 10);
	output[43] = (double)(value >> 16);

	// read output[44]: from bit 706 to 721
	value = ((uint32_t)(input[88] & 0x3f) << 26) |
			((uint32_t)input[89] << 18) |
			((uint32_t)(input[90] & 0xc0) << 10);
	output[44] = (double)(value >> 16);

	// read output[45]: from bit 722 to 737
	value = ((uint32_t)(input[90] & 0x3f) << 26) |
			((uint32_t)input[91] << 18) |
			((uint32_t)(input[92] & 0xc0) << 10);
	output[45] = (double)(value >> 16);

	// read output[46]: from bit 738 to 753
	value = ((uint32_t)(input[92] & 0x3f) << 26) |
			((uint32_t)input[93] << 18) |
			((uint32_t)(input[94] & 0xc0) << 10);
	output[46] = (double)(value >> 16);

	// read output[47]: from bit 754 to 769
	value = ((uint32_t)(input[94] & 0x3f) << 26) |
			((uint32_t)input[95] << 18) |
			((uint32_t)(input[96] & 0xc0) << 10);
	output[47] = (double)(value >> 16);

	// read output[48]: from bit 770 to 785
	value = ((uint32_t)(input[96] & 0x3f) << 26) |
			((uint32_t)input[97] << 18) |
			((uint32_t)(input[98] & 0xc0) << 10);
	output[48] = (double)(value >> 16);

	// read output[49]: from bit 786 to 801
	value = ((uint32_t)(input[98] & 0x3f) << 26) |
			((uint32_t)input[99] << 18) |
			((uint32_t)(input[100] & 0xc0) << 10);
	output[49] = (double)(value >> 16);

	// read output[50]: from bit 802 to 817
	value = ((uint32_t)(input[100] & 0x3f) << 26) |
			((uint32_t)input[101] << 18) |
			((uint32_t)(input[102] & 0xc0) << 10);
	output[50] = (double)(value >> 16);
}

static void unpack_51_16bit_signed_3off(const uint8_t * input, double * output, void *closure) {
	// Unpack 51 values into output
	// Values are 16-bit signed
	// Skip 3 bits, read 816 bits of data.
	// Input must be at least 103 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 3 to 18
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)input[1] << 19) |
			((uint32_t)(input[2] & 0xe0) << 11);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 19 to 34
	value = ((uint32_t)(input[2] & 0x1f) << 27) |
			((uint32_t)input[3] << 19) |
			((uint32_t)(input[4] & 0xe0) << 11);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 35 to 50
	value = ((uint32_t)(input[4] & 0x1f) << 27) |
			((uint32_t)input[5] << 19) |
			((uint32_t)(input[6] & 0xe0) << 11);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 51 to 66
	value = ((uint32_t)(input[6] & 0x1f) << 27) |
			((uint32_t)input[7] << 19) |
			((uint32_t)(input[8] & 0xe0) << 11);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 67 to 82
	value = ((uint32_t)(input[8] & 0x1f) << 27) |
			((uint32_t)input[9] << 19) |
			((uint32_t)(input[10] & 0xe0) << 11);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 83 to 98
	value = ((uint32_t)(input[10] & 0x1f) << 27) |
			((uint32_t)input[11] << 19) |
			((uint32_t)(input[12] & 0xe0) << 11);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 99 to 114
	value = ((uint32_t)(input[12] & 0x1f) << 27) |
			((uint32_t)input[13] << 19) |
			((uint32_t)(input[14] & 0xe0) << 11);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 115 to 130
	value = ((uint32_t)(input[14] & 0x1f) << 27) |
			((uint32_t)input[15] << 19) |
			((uint32_t)(input[16] & 0xe0) << 11);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 131 to 146
	value = ((uint32_t)(input[16] & 0x1f) << 27) |
			((uint32_t)input[17] << 19) |
			((uint32_t)(input[18] & 0xe0) << 11);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 147 to 162
	value = ((uint32_t)(input[18] & 0x1f) << 27) |
			((uint32_t)input[19] << 19) |
			((uint32_t)(input[20] & 0xe0) << 11);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 163 to 178
	value = ((uint32_t)(input[20] & 0x1f) << 27) |
			((uint32_t)input[21] << 19) |
			((uint32_t)(input[22] & 0xe0) << 11);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 179 to 194
	value = ((uint32_t)(input[22] & 0x1f) << 27) |
			((uint32_t)input[23] << 19) |
			((uint32_t)(input[24] & 0xe0) << 11);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 195 to 210
	value = ((uint32_t)(input[24] & 0x1f) << 27) |
			((uint32_t)input[25] << 19) |
			((uint32_t)(input[26] & 0xe0) << 11);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 211 to 226
	value = ((uint32_t)(input[26] & 0x1f) << 27) |
			((uint32_t)input[27] << 19) |
			((uint32_t)(input[28] & 0xe0) << 11);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 227 to 242
	value = ((uint32_t)(input[28] & 0x1f) << 27) |
			((uint32_t)input[29] << 19) |
			((uint32_t)(input[30] & 0xe0) << 11);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 243 to 258
	value = ((uint32_t)(input[30] & 0x1f) << 27) |
			((uint32_t)input[31] << 19) |
			((uint32_t)(input[32] & 0xe0) << 11);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 259 to 274
	value = ((uint32_t)(input[32] & 0x1f) << 27) |
			((uint32_t)input[33] << 19) |
			((uint32_t)(input[34] & 0xe0) << 11);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 275 to 290
	value = ((uint32_t)(input[34] & 0x1f) << 27) |
			((uint32_t)input[35] << 19) |
			((uint32_t)(input[36] & 0xe0) << 11);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 291 to 306
	value = ((uint32_t)(input[36] & 0x1f) << 27) |
			((uint32_t)input[37] << 19) |
			((uint32_t)(input[38] & 0xe0) << 11);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 307 to 322
	value = ((uint32_t)(input[38] & 0x1f) << 27) |
			((uint32_t)input[39] << 19) |
			((uint32_t)(input[40] & 0xe0) << 11);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 323 to 338
	value = ((uint32_t)(input[40] & 0x1f) << 27) |
			((uint32_t)input[41] << 19) |
			((uint32_t)(input[42] & 0xe0) << 11);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 339 to 354
	value = ((uint32_t)(input[42] & 0x1f) << 27) |
			((uint32_t)input[43] << 19) |
			((uint32_t)(input[44] & 0xe0) << 11);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 355 to 370
	value = ((uint32_t)(input[44] & 0x1f) << 27) |
			((uint32_t)input[45] << 19) |
			((uint32_t)(input[46] & 0xe0) << 11);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 371 to 386
	value = ((uint32_t)(input[46] & 0x1f) << 27) |
			((uint32_t)input[47] << 19) |
			((uint32_t)(input[48] & 0xe0) << 11);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 387 to 402
	value = ((uint32_t)(input[48] & 0x1f) << 27) |
			((uint32_t)input[49] << 19) |
			((uint32_t)(input[50] & 0xe0) << 11);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 403 to 418
	value = ((uint32_t)(input[50] & 0x1f) << 27) |
			((uint32_t)input[51] << 19) |
			((uint32_t)(input[52] & 0xe0) << 11);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 419 to 434
	value = ((uint32_t)(input[52] & 0x1f) << 27) |
			((uint32_t)input[53] << 19) |
			((uint32_t)(input[54] & 0xe0) << 11);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 435 to 450
	value = ((uint32_t)(input[54] & 0x1f) << 27) |
			((uint32_t)input[55] << 19) |
			((uint32_t)(input[56] & 0xe0) << 11);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 451 to 466
	value = ((uint32_t)(input[56] & 0x1f) << 27) |
			((uint32_t)input[57] << 19) |
			((uint32_t)(input[58] & 0xe0) << 11);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 467 to 482
	value = ((uint32_t)(input[58] & 0x1f) << 27) |
			((uint32_t)input[59] << 19) |
			((uint32_t)(input[60] & 0xe0) << 11);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 483 to 498
	value = ((uint32_t)(input[60] & 0x1f) << 27) |
			((uint32_t)input[61] << 19) |
			((uint32_t)(input[62] & 0xe0) << 11);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 499 to 514
	value = ((uint32_t)(input[62] & 0x1f) << 27) |
			((uint32_t)input[63] << 19) |
			((uint32_t)(input[64] & 0xe0) << 11);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 515 to 530
	value = ((uint32_t)(input[64] & 0x1f) << 27) |
			((uint32_t)input[65] << 19) |
			((uint32_t)(input[66] & 0xe0) << 11);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 531 to 546
	value = ((uint32_t)(input[66] & 0x1f) << 27) |
			((uint32_t)input[67] << 19) |
			((uint32_t)(input[68] & 0xe0) << 11);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 547 to 562
	value = ((uint32_t)(input[68] & 0x1f) << 27) |
			((uint32_t)input[69] << 19) |
			((uint32_t)(input[70] & 0xe0) << 11);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 563 to 578
	value = ((uint32_t)(input[70] & 0x1f) << 27) |
			((uint32_t)input[71] << 19) |
			((uint32_t)(input[72] & 0xe0) << 11);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 579 to 594
	value = ((uint32_t)(input[72] & 0x1f) << 27) |
			((uint32_t)input[73] << 19) |
			((uint32_t)(input[74] & 0xe0) << 11);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 595 to 610
	value = ((uint32_t)(input[74] & 0x1f) << 27) |
			((uint32_t)input[75] << 19) |
			((uint32_t)(input[76] & 0xe0) << 11);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 611 to 626
	value = ((uint32_t)(input[76] & 0x1f) << 27) |
			((uint32_t)input[77] << 19) |
			((uint32_t)(input[78] & 0xe0) << 11);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 627 to 642
	value = ((uint32_t)(input[78] & 0x1f) << 27) |
			((uint32_t)input[79] << 19) |
			((uint32_t)(input[80] & 0xe0) << 11);
	output[39] = (double)(value >> 16);

	// read output[40]: from bit 643 to 658
	value = ((uint32_t)(input[80] & 0x1f) << 27) |
			((uint32_t)input[81] << 19) |
			((uint32_t)(input[82] & 0xe0) << 11);
	output[40] = (double)(value >> 16);

	// read output[41]: from bit 659 to 674
	value = ((uint32_t)(input[82] & 0x1f) << 27) |
			((uint32_t)input[83] << 19) |
			((uint32_t)(input[84] & 0xe0) << 11);
	output[41] = (double)(value >> 16);

	// read output[42]: from bit 675 to 690
	value = ((uint32_t)(input[84] & 0x1f) << 27) |
			((uint32_t)input[85] << 19) |
			((uint32_t)(input[86] & 0xe0) << 11);
	output[42] = (double)(value >> 16);

	// read output[43]: from bit 691 to 706
	value = ((uint32_t)(input[86] & 0x1f) << 27) |
			((uint32_t)input[87] << 19) |
			((uint32_t)(input[88] & 0xe0) << 11);
	output[43] = (double)(value >> 16);

	// read output[44]: from bit 707 to 722
	value = ((uint32_t)(input[88] & 0x1f) << 27) |
			((uint32_t)input[89] << 19) |
			((uint32_t)(input[90] & 0xe0) << 11);
	output[44] = (double)(value >> 16);

	// read output[45]: from bit 723 to 738
	value = ((uint32_t)(input[90] & 0x1f) << 27) |
			((uint32_t)input[91] << 19) |
			((uint32_t)(input[92] & 0xe0) << 11);
	output[45] = (double)(value >> 16);

	// read output[46]: from bit 739 to 754
	value = ((uint32_t)(input[92] & 0x1f) << 27) |
			((uint32_t)input[93] << 19) |
			((uint32_t)(input[94] & 0xe0) << 11);
	output[46] = (double)(value >> 16);

	// read output[47]: from bit 755 to 770
	value = ((uint32_t)(input[94] & 0x1f) << 27) |
			((uint32_t)input[95] << 19) |
			((uint32_t)(input[96] & 0xe0) << 11);
	output[47] = (double)(value >> 16);

	// read output[48]: from bit 771 to 786
	value = ((uint32_t)(input[96] & 0x1f) << 27) |
			((uint32_t)input[97] << 19) |
			((uint32_t)(input[98] & 0xe0) << 11);
	output[48] = (double)(value >> 16);

	// read output[49]: from bit 787 to 802
	value = ((uint32_t)(input[98] & 0x1f) << 27) |
			((uint32_t)input[99] << 19) |
			((uint32_t)(input[100] & 0xe0) << 11);
	output[49] = (double)(value >> 16);

	// read output[50]: from bit 803 to 818
	value = ((uint32_t)(input[100] & 0x1f) << 27) |
			((uint32_t)input[101] << 19) |
			((uint32_t)(input[102] & 0xe0) << 11);
	output[50] = (double)(value >> 16);
}

static void unpack_51_16bit_unsigned_3off(const uint8_t * input, double * output, void *closure) {
	// Unpack 51 values into output
	// Values are 16-bit unsigned
	// Skip 3 bits, read 816 bits of data.
	// Input must be at least 103 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 3 to 18
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)input[1] << 19) |
			((uint32_t)(input[2] & 0xe0) << 11);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 19 to 34
	value = ((uint32_t)(input[2] & 0x1f) << 27) |
			((uint32_t)input[3] << 19) |
			((uint32_t)(input[4] & 0xe0) << 11);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 35 to 50
	value = ((uint32_t)(input[4] & 0x1f) << 27) |
			((uint32_t)input[5] << 19) |
			((uint32_t)(input[6] & 0xe0) << 11);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 51 to 66
	value = ((uint32_t)(input[6] & 0x1f) << 27) |
			((uint32_t)input[7] << 19) |
			((uint32_t)(input[8] & 0xe0) << 11);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 67 to 82
	value = ((uint32_t)(input[8] & 0x1f) << 27) |
			((uint32_t)input[9] << 19) |
			((uint32_t)(input[10] & 0xe0) << 11);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 83 to 98
	value = ((uint32_t)(input[10] & 0x1f) << 27) |
			((uint32_t)input[11] << 19) |
			((uint32_t)(input[12] & 0xe0) << 11);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 99 to 114
	value = ((uint32_t)(input[12] & 0x1f) << 27) |
			((uint32_t)input[13] << 19) |
			((uint32_t)(input[14] & 0xe0) << 11);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 115 to 130
	value = ((uint32_t)(input[14] & 0x1f) << 27) |
			((uint32_t)input[15] << 19) |
			((uint32_t)(input[16] & 0xe0) << 11);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 131 to 146
	value = ((uint32_t)(input[16] & 0x1f) << 27) |
			((uint32_t)input[17] << 19) |
			((uint32_t)(input[18] & 0xe0) << 11);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 147 to 162
	value = ((uint32_t)(input[18] & 0x1f) << 27) |
			((uint32_t)input[19] << 19) |
			((uint32_t)(input[20] & 0xe0) << 11);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 163 to 178
	value = ((uint32_t)(input[20] & 0x1f) << 27) |
			((uint32_t)input[21] << 19) |
			((uint32_t)(input[22] & 0xe0) << 11);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 179 to 194
	value = ((uint32_t)(input[22] & 0x1f) << 27) |
			((uint32_t)input[23] << 19) |
			((uint32_t)(input[24] & 0xe0) << 11);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 195 to 210
	value = ((uint32_t)(input[24] & 0x1f) << 27) |
			((uint32_t)input[25] << 19) |
			((uint32_t)(input[26] & 0xe0) << 11);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 211 to 226
	value = ((uint32_t)(input[26] & 0x1f) << 27) |
			((uint32_t)input[27] << 19) |
			((uint32_t)(input[28] & 0xe0) << 11);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 227 to 242
	value = ((uint32_t)(input[28] & 0x1f) << 27) |
			((uint32_t)input[29] << 19) |
			((uint32_t)(input[30] & 0xe0) << 11);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 243 to 258
	value = ((uint32_t)(input[30] & 0x1f) << 27) |
			((uint32_t)input[31] << 19) |
			((uint32_t)(input[32] & 0xe0) << 11);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 259 to 274
	value = ((uint32_t)(input[32] & 0x1f) << 27) |
			((uint32_t)input[33] << 19) |
			((uint32_t)(input[34] & 0xe0) << 11);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 275 to 290
	value = ((uint32_t)(input[34] & 0x1f) << 27) |
			((uint32_t)input[35] << 19) |
			((uint32_t)(input[36] & 0xe0) << 11);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 291 to 306
	value = ((uint32_t)(input[36] & 0x1f) << 27) |
			((uint32_t)input[37] << 19) |
			((uint32_t)(input[38] & 0xe0) << 11);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 307 to 322
	value = ((uint32_t)(input[38] & 0x1f) << 27) |
			((uint32_t)input[39] << 19) |
			((uint32_t)(input[40] & 0xe0) << 11);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 323 to 338
	value = ((uint32_t)(input[40] & 0x1f) << 27) |
			((uint32_t)input[41] << 19) |
			((uint32_t)(input[42] & 0xe0) << 11);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 339 to 354
	value = ((uint32_t)(input[42] & 0x1f) << 27) |
			((uint32_t)input[43] << 19) |
			((uint32_t)(input[44] & 0xe0) << 11);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 355 to 370
	value = ((uint32_t)(input[44] & 0x1f) << 27) |
			((uint32_t)input[45] << 19) |
			((uint32_t)(input[46] & 0xe0) << 11);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 371 to 386
	value = ((uint32_t)(input[46] & 0x1f) << 27) |
			((uint32_t)input[47] << 19) |
			((uint32_t)(input[48] & 0xe0) << 11);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 387 to 402
	value = ((uint32_t)(input[48] & 0x1f) << 27) |
			((uint32_t)input[49] << 19) |
			((uint32_t)(input[50] & 0xe0) << 11);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 403 to 418
	value = ((uint32_t)(input[50] & 0x1f) << 27) |
			((uint32_t)input[51] << 19) |
			((uint32_t)(input[52] & 0xe0) << 11);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 419 to 434
	value = ((uint32_t)(input[52] & 0x1f) << 27) |
			((uint32_t)input[53] << 19) |
			((uint32_t)(input[54] & 0xe0) << 11);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 435 to 450
	value = ((uint32_t)(input[54] & 0x1f) << 27) |
			((uint32_t)input[55] << 19) |
			((uint32_t)(input[56] & 0xe0) << 11);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 451 to 466
	value = ((uint32_t)(input[56] & 0x1f) << 27) |
			((uint32_t)input[57] << 19) |
			((uint32_t)(input[58] & 0xe0) << 11);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 467 to 482
	value = ((uint32_t)(input[58] & 0x1f) << 27) |
			((uint32_t)input[59] << 19) |
			((uint32_t)(input[60] & 0xe0) << 11);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 483 to 498
	value = ((uint32_t)(input[60] & 0x1f) << 27) |
			((uint32_t)input[61] << 19) |
			((uint32_t)(input[62] & 0xe0) << 11);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 499 to 514
	value = ((uint32_t)(input[62] & 0x1f) << 27) |
			((uint32_t)input[63] << 19) |
			((uint32_t)(input[64] & 0xe0) << 11);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 515 to 530
	value = ((uint32_t)(input[64] & 0x1f) << 27) |
			((uint32_t)input[65] << 19) |
			((uint32_t)(input[66] & 0xe0) << 11);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 531 to 546
	value = ((uint32_t)(input[66] & 0x1f) << 27) |
			((uint32_t)input[67] << 19) |
			((uint32_t)(input[68] & 0xe0) << 11);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 547 to 562
	value = ((uint32_t)(input[68] & 0x1f) << 27) |
			((uint32_t)input[69] << 19) |
			((uint32_t)(input[70] & 0xe0) << 11);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 563 to 578
	value = ((uint32_t)(input[70] & 0x1f) << 27) |
			((uint32_t)input[71] << 19) |
			((uint32_t)(input[72] & 0xe0) << 11);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 579 to 594
	value = ((uint32_t)(input[72] & 0x1f) << 27) |
			((uint32_t)input[73] << 19) |
			((uint32_t)(input[74] & 0xe0) << 11);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 595 to 610
	value = ((uint32_t)(input[74] & 0x1f) << 27) |
			((uint32_t)input[75] << 19) |
			((uint32_t)(input[76] & 0xe0) << 11);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 611 to 626
	value = ((uint32_t)(input[76] & 0x1f) << 27) |
			((uint32_t)input[77] << 19) |
			((uint32_t)(input[78] & 0xe0) << 11);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 627 to 642
	value = ((uint32_t)(input[78] & 0x1f) << 27) |
			((uint32_t)input[79] << 19) |
			((uint32_t)(input[80] & 0xe0) << 11);
	output[39] = (double)(value >> 16);

	// read output[40]: from bit 643 to 658
	value = ((uint32_t)(input[80] & 0x1f) << 27) |
			((uint32_t)input[81] << 19) |
			((uint32_t)(input[82] & 0xe0) << 11);
	output[40] = (double)(value >> 16);

	// read output[41]: from bit 659 to 674
	value = ((uint32_t)(input[82] & 0x1f) << 27) |
			((uint32_t)input[83] << 19) |
			((uint32_t)(input[84] & 0xe0) << 11);
	output[41] = (double)(value >> 16);

	// read output[42]: from bit 675 to 690
	value = ((uint32_t)(input[84] & 0x1f) << 27) |
			((uint32_t)input[85] << 19) |
			((uint32_t)(input[86] & 0xe0) << 11);
	output[42] = (double)(value >> 16);

	// read output[43]: from bit 691 to 706
	value = ((uint32_t)(input[86] & 0x1f) << 27) |
			((uint32_t)input[87] << 19) |
			((uint32_t)(input[88] & 0xe0) << 11);
	output[43] = (double)(value >> 16);

	// read output[44]: from bit 707 to 722
	value = ((uint32_t)(input[88] & 0x1f) << 27) |
			((uint32_t)input[89] << 19) |
			((uint32_t)(input[90] & 0xe0) << 11);
	output[44] = (double)(value >> 16);

	// read output[45]: from bit 723 to 738
	value = ((uint32_t)(input[90] & 0x1f) << 27) |
			((uint32_t)input[91] << 19) |
			((uint32_t)(input[92] & 0xe0) << 11);
	output[45] = (double)(value >> 16);

	// read output[46]: from bit 739 to 754
	value = ((uint32_t)(input[92] & 0x1f) << 27) |
			((uint32_t)input[93] << 19) |
			((uint32_t)(input[94] & 0xe0) << 11);
	output[46] = (double)(value >> 16);

	// read output[47]: from bit 755 to 770
	value = ((uint32_t)(input[94] & 0x1f) << 27) |
			((uint32_t)input[95] << 19) |
			((uint32_t)(input[96] & 0xe0) << 11);
	output[47] = (double)(value >> 16);

	// read output[48]: from bit 771 to 786
	value = ((uint32_t)(input[96] & 0x1f) << 27) |
			((uint32_t)input[97] << 19) |
			((uint32_t)(input[98] & 0xe0) << 11);
	output[48] = (double)(value >> 16);

	// read output[49]: from bit 787 to 802
	value = ((uint32_t)(input[98] & 0x1f) << 27) |
			((uint32_t)input[99] << 19) |
			((uint32_t)(input[100] & 0xe0) << 11);
	output[49] = (double)(value >> 16);

	// read output[50]: from bit 803 to 818
	value = ((uint32_t)(input[100] & 0x1f) << 27) |
			((uint32_t)input[101] << 19) |
			((uint32_t)(input[102] & 0xe0) << 11);
	output[50] = (double)(value >> 16);
}

static void unpack_51_16bit_signed_4off(const uint8_t * input, double * output, void *closure) {
	// Unpack 51 values into output
	// Values are 16-bit signed
	// Skip 4 bits, read 816 bits of data.
	// Input must be at least 103 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 4 to 19
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20) |
			((uint32_t)(input[2] & 0xf0) << 12);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 20 to 35
	value = ((uint32_t)(input[2] & 0x0f) << 28) |
			((uint32_t)input[3] << 20) |
			((uint32_t)(input[4] & 0xf0) << 12);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 36 to 51
	value = ((uint32_t)(input[4] & 0x0f) << 28) |
			((uint32_t)input[5] << 20) |
			((uint32_t)(input[6] & 0xf0) << 12);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 52 to 67
	value = ((uint32_t)(input[6] & 0x0f) << 28) |
			((uint32_t)input[7] << 20) |
			((uint32_t)(input[8] & 0xf0) << 12);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 68 to 83
	value = ((uint32_t)(input[8] & 0x0f) << 28) |
			((uint32_t)input[9] << 20) |
			((uint32_t)(input[10] & 0xf0) << 12);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 84 to 99
	value = ((uint32_t)(input[10] & 0x0f) << 28) |
			((uint32_t)input[11] << 20) |
			((uint32_t)(input[12] & 0xf0) << 12);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 100 to 115
	value = ((uint32_t)(input[12] & 0x0f) << 28) |
			((uint32_t)input[13] << 20) |
			((uint32_t)(input[14] & 0xf0) << 12);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 116 to 131
	value = ((uint32_t)(input[14] & 0x0f) << 28) |
			((uint32_t)input[15] << 20) |
			((uint32_t)(input[16] & 0xf0) << 12);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 132 to 147
	value = ((uint32_t)(input[16] & 0x0f) << 28) |
			((uint32_t)input[17] << 20) |
			((uint32_t)(input[18] & 0xf0) << 12);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 148 to 163
	value = ((uint32_t)(input[18] & 0x0f) << 28) |
			((uint32_t)input[19] << 20) |
			((uint32_t)(input[20] & 0xf0) << 12);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 164 to 179
	value = ((uint32_t)(input[20] & 0x0f) << 28) |
			((uint32_t)input[21] << 20) |
			((uint32_t)(input[22] & 0xf0) << 12);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 180 to 195
	value = ((uint32_t)(input[22] & 0x0f) << 28) |
			((uint32_t)input[23] << 20) |
			((uint32_t)(input[24] & 0xf0) << 12);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 196 to 211
	value = ((uint32_t)(input[24] & 0x0f) << 28) |
			((uint32_t)input[25] << 20) |
			((uint32_t)(input[26] & 0xf0) << 12);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 212 to 227
	value = ((uint32_t)(input[26] & 0x0f) << 28) |
			((uint32_t)input[27] << 20) |
			((uint32_t)(input[28] & 0xf0) << 12);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 228 to 243
	value = ((uint32_t)(input[28] & 0x0f) << 28) |
			((uint32_t)input[29] << 20) |
			((uint32_t)(input[30] & 0xf0) << 12);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 244 to 259
	value = ((uint32_t)(input[30] & 0x0f) << 28) |
			((uint32_t)input[31] << 20) |
			((uint32_t)(input[32] & 0xf0) << 12);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 260 to 275
	value = ((uint32_t)(input[32] & 0x0f) << 28) |
			((uint32_t)input[33] << 20) |
			((uint32_t)(input[34] & 0xf0) << 12);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 276 to 291
	value = ((uint32_t)(input[34] & 0x0f) << 28) |
			((uint32_t)input[35] << 20) |
			((uint32_t)(input[36] & 0xf0) << 12);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 292 to 307
	value = ((uint32_t)(input[36] & 0x0f) << 28) |
			((uint32_t)input[37] << 20) |
			((uint32_t)(input[38] & 0xf0) << 12);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 308 to 323
	value = ((uint32_t)(input[38] & 0x0f) << 28) |
			((uint32_t)input[39] << 20) |
			((uint32_t)(input[40] & 0xf0) << 12);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 324 to 339
	value = ((uint32_t)(input[40] & 0x0f) << 28) |
			((uint32_t)input[41] << 20) |
			((uint32_t)(input[42] & 0xf0) << 12);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 340 to 355
	value = ((uint32_t)(input[42] & 0x0f) << 28) |
			((uint32_t)input[43] << 20) |
			((uint32_t)(input[44] & 0xf0) << 12);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 356 to 371
	value = ((uint32_t)(input[44] & 0x0f) << 28) |
			((uint32_t)input[45] << 20) |
			((uint32_t)(input[46] & 0xf0) << 12);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 372 to 387
	value = ((uint32_t)(input[46] & 0x0f) << 28) |
			((uint32_t)input[47] << 20) |
			((uint32_t)(input[48] & 0xf0) << 12);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 388 to 403
	value = ((uint32_t)(input[48] & 0x0f) << 28) |
			((uint32_t)input[49] << 20) |
			((uint32_t)(input[50] & 0xf0) << 12);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 404 to 419
	value = ((uint32_t)(input[50] & 0x0f) << 28) |
			((uint32_t)input[51] << 20) |
			((uint32_t)(input[52] & 0xf0) << 12);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 420 to 435
	value = ((uint32_t)(input[52] & 0x0f) << 28) |
			((uint32_t)input[53] << 20) |
			((uint32_t)(input[54] & 0xf0) << 12);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 436 to 451
	value = ((uint32_t)(input[54] & 0x0f) << 28) |
			((uint32_t)input[55] << 20) |
			((uint32_t)(input[56] & 0xf0) << 12);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 452 to 467
	value = ((uint32_t)(input[56] & 0x0f) << 28) |
			((uint32_t)input[57] << 20) |
			((uint32_t)(input[58] & 0xf0) << 12);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 468 to 483
	value = ((uint32_t)(input[58] & 0x0f) << 28) |
			((uint32_t)input[59] << 20) |
			((uint32_t)(input[60] & 0xf0) << 12);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 484 to 499
	value = ((uint32_t)(input[60] & 0x0f) << 28) |
			((uint32_t)input[61] << 20) |
			((uint32_t)(input[62] & 0xf0) << 12);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 500 to 515
	value = ((uint32_t)(input[62] & 0x0f) << 28) |
			((uint32_t)input[63] << 20) |
			((uint32_t)(input[64] & 0xf0) << 12);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 516 to 531
	value = ((uint32_t)(input[64] & 0x0f) << 28) |
			((uint32_t)input[65] << 20) |
			((uint32_t)(input[66] & 0xf0) << 12);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 532 to 547
	value = ((uint32_t)(input[66] & 0x0f) << 28) |
			((uint32_t)input[67] << 20) |
			((uint32_t)(input[68] & 0xf0) << 12);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 548 to 563
	value = ((uint32_t)(input[68] & 0x0f) << 28) |
			((uint32_t)input[69] << 20) |
			((uint32_t)(input[70] & 0xf0) << 12);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 564 to 579
	value = ((uint32_t)(input[70] & 0x0f) << 28) |
			((uint32_t)input[71] << 20) |
			((uint32_t)(input[72] & 0xf0) << 12);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 580 to 595
	value = ((uint32_t)(input[72] & 0x0f) << 28) |
			((uint32_t)input[73] << 20) |
			((uint32_t)(input[74] & 0xf0) << 12);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 596 to 611
	value = ((uint32_t)(input[74] & 0x0f) << 28) |
			((uint32_t)input[75] << 20) |
			((uint32_t)(input[76] & 0xf0) << 12);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 612 to 627
	value = ((uint32_t)(input[76] & 0x0f) << 28) |
			((uint32_t)input[77] << 20) |
			((uint32_t)(input[78] & 0xf0) << 12);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 628 to 643
	value = ((uint32_t)(input[78] & 0x0f) << 28) |
			((uint32_t)input[79] << 20) |
			((uint32_t)(input[80] & 0xf0) << 12);
	output[39] = (double)(value >> 16);

	// read output[40]: from bit 644 to 659
	value = ((uint32_t)(input[80] & 0x0f) << 28) |
			((uint32_t)input[81] << 20) |
			((uint32_t)(input[82] & 0xf0) << 12);
	output[40] = (double)(value >> 16);

	// read output[41]: from bit 660 to 675
	value = ((uint32_t)(input[82] & 0x0f) << 28) |
			((uint32_t)input[83] << 20) |
			((uint32_t)(input[84] & 0xf0) << 12);
	output[41] = (double)(value >> 16);

	// read output[42]: from bit 676 to 691
	value = ((uint32_t)(input[84] & 0x0f) << 28) |
			((uint32_t)input[85] << 20) |
			((uint32_t)(input[86] & 0xf0) << 12);
	output[42] = (double)(value >> 16);

	// read output[43]: from bit 692 to 707
	value = ((uint32_t)(input[86] & 0x0f) << 28) |
			((uint32_t)input[87] << 20) |
			((uint32_t)(input[88] & 0xf0) << 12);
	output[43] = (double)(value >> 16);

	// read output[44]: from bit 708 to 723
	value = ((uint32_t)(input[88] & 0x0f) << 28) |
			((uint32_t)input[89] << 20) |
			((uint32_t)(input[90] & 0xf0) << 12);
	output[44] = (double)(value >> 16);

	// read output[45]: from bit 724 to 739
	value = ((uint32_t)(input[90] & 0x0f) << 28) |
			((uint32_t)input[91] << 20) |
			((uint32_t)(input[92] & 0xf0) << 12);
	output[45] = (double)(value >> 16);

	// read output[46]: from bit 740 to 755
	value = ((uint32_t)(input[92] & 0x0f) << 28) |
			((uint32_t)input[93] << 20) |
			((uint32_t)(input[94] & 0xf0) << 12);
	output[46] = (double)(value >> 16);

	// read output[47]: from bit 756 to 771
	value = ((uint32_t)(input[94] & 0x0f) << 28) |
			((uint32_t)input[95] << 20) |
			((uint32_t)(input[96] & 0xf0) << 12);
	output[47] = (double)(value >> 16);

	// read output[48]: from bit 772 to 787
	value = ((uint32_t)(input[96] & 0x0f) << 28) |
			((uint32_t)input[97] << 20) |
			((uint32_t)(input[98] & 0xf0) << 12);
	output[48] = (double)(value >> 16);

	// read output[49]: from bit 788 to 803
	value = ((uint32_t)(input[98] & 0x0f) << 28) |
			((uint32_t)input[99] << 20) |
			((uint32_t)(input[100] & 0xf0) << 12);
	output[49] = (double)(value >> 16);

	// read output[50]: from bit 804 to 819
	value = ((uint32_t)(input[100] & 0x0f) << 28) |
			((uint32_t)input[101] << 20) |
			((uint32_t)(input[102] & 0xf0) << 12);
	output[50] = (double)(value >> 16);
}

static void unpack_51_16bit_unsigned_4off(const uint8_t * input, double * output, void *closure) {
	// Unpack 51 values into output
	// Values are 16-bit unsigned
	// Skip 4 bits, read 816 bits of data.
	// Input must be at least 103 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 4 to 19
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20) |
			((uint32_t)(input[2] & 0xf0) << 12);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 20 to 35
	value = ((uint32_t)(input[2] & 0x0f) << 28) |
			((uint32_t)input[3] << 20) |
			((uint32_t)(input[4] & 0xf0) << 12);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 36 to 51
	value = ((uint32_t)(input[4] & 0x0f) << 28) |
			((uint32_t)input[5] << 20) |
			((uint32_t)(input[6] & 0xf0) << 12);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 52 to 67
	value = ((uint32_t)(input[6] & 0x0f) << 28) |
			((uint32_t)input[7] << 20) |
			((uint32_t)(input[8] & 0xf0) << 12);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 68 to 83
	value = ((uint32_t)(input[8] & 0x0f) << 28) |
			((uint32_t)input[9] << 20) |
			((uint32_t)(input[10] & 0xf0) << 12);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 84 to 99
	value = ((uint32_t)(input[10] & 0x0f) << 28) |
			((uint32_t)input[11] << 20) |
			((uint32_t)(input[12] & 0xf0) << 12);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 100 to 115
	value = ((uint32_t)(input[12] & 0x0f) << 28) |
			((uint32_t)input[13] << 20) |
			((uint32_t)(input[14] & 0xf0) << 12);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 116 to 131
	value = ((uint32_t)(input[14] & 0x0f) << 28) |
			((uint32_t)input[15] << 20) |
			((uint32_t)(input[16] & 0xf0) << 12);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 132 to 147
	value = ((uint32_t)(input[16] & 0x0f) << 28) |
			((uint32_t)input[17] << 20) |
			((uint32_t)(input[18] & 0xf0) << 12);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 148 to 163
	value = ((uint32_t)(input[18] & 0x0f) << 28) |
			((uint32_t)input[19] << 20) |
			((uint32_t)(input[20] & 0xf0) << 12);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 164 to 179
	value = ((uint32_t)(input[20] & 0x0f) << 28) |
			((uint32_t)input[21] << 20) |
			((uint32_t)(input[22] & 0xf0) << 12);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 180 to 195
	value = ((uint32_t)(input[22] & 0x0f) << 28) |
			((uint32_t)input[23] << 20) |
			((uint32_t)(input[24] & 0xf0) << 12);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 196 to 211
	value = ((uint32_t)(input[24] & 0x0f) << 28) |
			((uint32_t)input[25] << 20) |
			((uint32_t)(input[26] & 0xf0) << 12);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 212 to 227
	value = ((uint32_t)(input[26] & 0x0f) << 28) |
			((uint32_t)input[27] << 20) |
			((uint32_t)(input[28] & 0xf0) << 12);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 228 to 243
	value = ((uint32_t)(input[28] & 0x0f) << 28) |
			((uint32_t)input[29] << 20) |
			((uint32_t)(input[30] & 0xf0) << 12);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 244 to 259
	value = ((uint32_t)(input[30] & 0x0f) << 28) |
			((uint32_t)input[31] << 20) |
			((uint32_t)(input[32] & 0xf0) << 12);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 260 to 275
	value = ((uint32_t)(input[32] & 0x0f) << 28) |
			((uint32_t)input[33] << 20) |
			((uint32_t)(input[34] & 0xf0) << 12);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 276 to 291
	value = ((uint32_t)(input[34] & 0x0f) << 28) |
			((uint32_t)input[35] << 20) |
			((uint32_t)(input[36] & 0xf0) << 12);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 292 to 307
	value = ((uint32_t)(input[36] & 0x0f) << 28) |
			((uint32_t)input[37] << 20) |
			((uint32_t)(input[38] & 0xf0) << 12);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 308 to 323
	value = ((uint32_t)(input[38] & 0x0f) << 28) |
			((uint32_t)input[39] << 20) |
			((uint32_t)(input[40] & 0xf0) << 12);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 324 to 339
	value = ((uint32_t)(input[40] & 0x0f) << 28) |
			((uint32_t)input[41] << 20) |
			((uint32_t)(input[42] & 0xf0) << 12);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 340 to 355
	value = ((uint32_t)(input[42] & 0x0f) << 28) |
			((uint32_t)input[43] << 20) |
			((uint32_t)(input[44] & 0xf0) << 12);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 356 to 371
	value = ((uint32_t)(input[44] & 0x0f) << 28) |
			((uint32_t)input[45] << 20) |
			((uint32_t)(input[46] & 0xf0) << 12);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 372 to 387
	value = ((uint32_t)(input[46] & 0x0f) << 28) |
			((uint32_t)input[47] << 20) |
			((uint32_t)(input[48] & 0xf0) << 12);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 388 to 403
	value = ((uint32_t)(input[48] & 0x0f) << 28) |
			((uint32_t)input[49] << 20) |
			((uint32_t)(input[50] & 0xf0) << 12);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 404 to 419
	value = ((uint32_t)(input[50] & 0x0f) << 28) |
			((uint32_t)input[51] << 20) |
			((uint32_t)(input[52] & 0xf0) << 12);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 420 to 435
	value = ((uint32_t)(input[52] & 0x0f) << 28) |
			((uint32_t)input[53] << 20) |
			((uint32_t)(input[54] & 0xf0) << 12);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 436 to 451
	value = ((uint32_t)(input[54] & 0x0f) << 28) |
			((uint32_t)input[55] << 20) |
			((uint32_t)(input[56] & 0xf0) << 12);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 452 to 467
	value = ((uint32_t)(input[56] & 0x0f) << 28) |
			((uint32_t)input[57] << 20) |
			((uint32_t)(input[58] & 0xf0) << 12);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 468 to 483
	value = ((uint32_t)(input[58] & 0x0f) << 28) |
			((uint32_t)input[59] << 20) |
			((uint32_t)(input[60] & 0xf0) << 12);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 484 to 499
	value = ((uint32_t)(input[60] & 0x0f) << 28) |
			((uint32_t)input[61] << 20) |
			((uint32_t)(input[62] & 0xf0) << 12);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 500 to 515
	value = ((uint32_t)(input[62] & 0x0f) << 28) |
			((uint32_t)input[63] << 20) |
			((uint32_t)(input[64] & 0xf0) << 12);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 516 to 531
	value = ((uint32_t)(input[64] & 0x0f) << 28) |
			((uint32_t)input[65] << 20) |
			((uint32_t)(input[66] & 0xf0) << 12);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 532 to 547
	value = ((uint32_t)(input[66] & 0x0f) << 28) |
			((uint32_t)input[67] << 20) |
			((uint32_t)(input[68] & 0xf0) << 12);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 548 to 563
	value = ((uint32_t)(input[68] & 0x0f) << 28) |
			((uint32_t)input[69] << 20) |
			((uint32_t)(input[70] & 0xf0) << 12);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 564 to 579
	value = ((uint32_t)(input[70] & 0x0f) << 28) |
			((uint32_t)input[71] << 20) |
			((uint32_t)(input[72] & 0xf0) << 12);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 580 to 595
	value = ((uint32_t)(input[72] & 0x0f) << 28) |
			((uint32_t)input[73] << 20) |
			((uint32_t)(input[74] & 0xf0) << 12);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 596 to 611
	value = ((uint32_t)(input[74] & 0x0f) << 28) |
			((uint32_t)input[75] << 20) |
			((uint32_t)(input[76] & 0xf0) << 12);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 612 to 627
	value = ((uint32_t)(input[76] & 0x0f) << 28) |
			((uint32_t)input[77] << 20) |
			((uint32_t)(input[78] & 0xf0) << 12);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 628 to 643
	value = ((uint32_t)(input[78] & 0x0f) << 28) |
			((uint32_t)input[79] << 20) |
			((uint32_t)(input[80] & 0xf0) << 12);
	output[39] = (double)(value >> 16);

	// read output[40]: from bit 644 to 659
	value = ((uint32_t)(input[80] & 0x0f) << 28) |
			((uint32_t)input[81] << 20) |
			((uint32_t)(input[82] & 0xf0) << 12);
	output[40] = (double)(value >> 16);

	// read output[41]: from bit 660 to 675
	value = ((uint32_t)(input[82] & 0x0f) << 28) |
			((uint32_t)input[83] << 20) |
			((uint32_t)(input[84] & 0xf0) << 12);
	output[41] = (double)(value >> 16);

	// read output[42]: from bit 676 to 691
	value = ((uint32_t)(input[84] & 0x0f) << 28) |
			((uint32_t)input[85] << 20) |
			((uint32_t)(input[86] & 0xf0) << 12);
	output[42] = (double)(value >> 16);

	// read output[43]: from bit 692 to 707
	value = ((uint32_t)(input[86] & 0x0f) << 28) |
			((uint32_t)input[87] << 20) |
			((uint32_t)(input[88] & 0xf0) << 12);
	output[43] = (double)(value >> 16);

	// read output[44]: from bit 708 to 723
	value = ((uint32_t)(input[88] & 0x0f) << 28) |
			((uint32_t)input[89] << 20) |
			((uint32_t)(input[90] & 0xf0) << 12);
	output[44] = (double)(value >> 16);

	// read output[45]: from bit 724 to 739
	value = ((uint32_t)(input[90] & 0x0f) << 28) |
			((uint32_t)input[91] << 20) |
			((uint32_t)(input[92] & 0xf0) << 12);
	output[45] = (double)(value >> 16);

	// read output[46]: from bit 740 to 755
	value = ((uint32_t)(input[92] & 0x0f) << 28) |
			((uint32_t)input[93] << 20) |
			((uint32_t)(input[94] & 0xf0) << 12);
	output[46] = (double)(value >> 16);

	// read output[47]: from bit 756 to 771
	value = ((uint32_t)(input[94] & 0x0f) << 28) |
			((uint32_t)input[95] << 20) |
			((uint32_t)(input[96] & 0xf0) << 12);
	output[47] = (double)(value >> 16);

	// read output[48]: from bit 772 to 787
	value = ((uint32_t)(input[96] & 0x0f) << 28) |
			((uint32_t)input[97] << 20) |
			((uint32_t)(input[98] & 0xf0) << 12);
	output[48] = (double)(value >> 16);

	// read output[49]: from bit 788 to 803
	value = ((uint32_t)(input[98] & 0x0f) << 28) |
			((uint32_t)input[99] << 20) |
			((uint32_t)(input[100] & 0xf0) << 12);
	output[49] = (double)(value >> 16);

	// read output[50]: from bit 804 to 819
	value = ((uint32_t)(input[100] & 0x0f) << 28) |
			((uint32_t)input[101] << 20) |
			((uint32_t)(input[102] & 0xf0) << 12);
	output[50] = (double)(value >> 16);
}

static void unpack_51_16bit_signed_5off(const uint8_t * input, double * output, void *closure) {
	// Unpack 51 values into output
	// Values are 16-bit signed
	// Skip 5 bits, read 816 bits of data.
	// Input must be at least 103 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 5 to 20
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)(input[2] & 0xf8) << 13);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 21 to 36
	value = ((uint32_t)(input[2] & 0x07) << 29) |
			((uint32_t)input[3] << 21) |
			((uint32_t)(input[4] & 0xf8) << 13);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 37 to 52
	value = ((uint32_t)(input[4] & 0x07) << 29) |
			((uint32_t)input[5] << 21) |
			((uint32_t)(input[6] & 0xf8) << 13);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 53 to 68
	value = ((uint32_t)(input[6] & 0x07) << 29) |
			((uint32_t)input[7] << 21) |
			((uint32_t)(input[8] & 0xf8) << 13);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 69 to 84
	value = ((uint32_t)(input[8] & 0x07) << 29) |
			((uint32_t)input[9] << 21) |
			((uint32_t)(input[10] & 0xf8) << 13);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 85 to 100
	value = ((uint32_t)(input[10] & 0x07) << 29) |
			((uint32_t)input[11] << 21) |
			((uint32_t)(input[12] & 0xf8) << 13);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 101 to 116
	value = ((uint32_t)(input[12] & 0x07) << 29) |
			((uint32_t)input[13] << 21) |
			((uint32_t)(input[14] & 0xf8) << 13);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 117 to 132
	value = ((uint32_t)(input[14] & 0x07) << 29) |
			((uint32_t)input[15] << 21) |
			((uint32_t)(input[16] & 0xf8) << 13);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 133 to 148
	value = ((uint32_t)(input[16] & 0x07) << 29) |
			((uint32_t)input[17] << 21) |
			((uint32_t)(input[18] & 0xf8) << 13);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 149 to 164
	value = ((uint32_t)(input[18] & 0x07) << 29) |
			((uint32_t)input[19] << 21) |
			((uint32_t)(input[20] & 0xf8) << 13);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 165 to 180
	value = ((uint32_t)(input[20] & 0x07) << 29) |
			((uint32_t)input[21] << 21) |
			((uint32_t)(input[22] & 0xf8) << 13);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 181 to 196
	value = ((uint32_t)(input[22] & 0x07) << 29) |
			((uint32_t)input[23] << 21) |
			((uint32_t)(input[24] & 0xf8) << 13);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 197 to 212
	value = ((uint32_t)(input[24] & 0x07) << 29) |
			((uint32_t)input[25] << 21) |
			((uint32_t)(input[26] & 0xf8) << 13);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 213 to 228
	value = ((uint32_t)(input[26] & 0x07) << 29) |
			((uint32_t)input[27] << 21) |
			((uint32_t)(input[28] & 0xf8) << 13);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 229 to 244
	value = ((uint32_t)(input[28] & 0x07) << 29) |
			((uint32_t)input[29] << 21) |
			((uint32_t)(input[30] & 0xf8) << 13);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 245 to 260
	value = ((uint32_t)(input[30] & 0x07) << 29) |
			((uint32_t)input[31] << 21) |
			((uint32_t)(input[32] & 0xf8) << 13);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 261 to 276
	value = ((uint32_t)(input[32] & 0x07) << 29) |
			((uint32_t)input[33] << 21) |
			((uint32_t)(input[34] & 0xf8) << 13);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 277 to 292
	value = ((uint32_t)(input[34] & 0x07) << 29) |
			((uint32_t)input[35] << 21) |
			((uint32_t)(input[36] & 0xf8) << 13);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 293 to 308
	value = ((uint32_t)(input[36] & 0x07) << 29) |
			((uint32_t)input[37] << 21) |
			((uint32_t)(input[38] & 0xf8) << 13);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 309 to 324
	value = ((uint32_t)(input[38] & 0x07) << 29) |
			((uint32_t)input[39] << 21) |
			((uint32_t)(input[40] & 0xf8) << 13);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 325 to 340
	value = ((uint32_t)(input[40] & 0x07) << 29) |
			((uint32_t)input[41] << 21) |
			((uint32_t)(input[42] & 0xf8) << 13);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 341 to 356
	value = ((uint32_t)(input[42] & 0x07) << 29) |
			((uint32_t)input[43] << 21) |
			((uint32_t)(input[44] & 0xf8) << 13);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 357 to 372
	value = ((uint32_t)(input[44] & 0x07) << 29) |
			((uint32_t)input[45] << 21) |
			((uint32_t)(input[46] & 0xf8) << 13);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 373 to 388
	value = ((uint32_t)(input[46] & 0x07) << 29) |
			((uint32_t)input[47] << 21) |
			((uint32_t)(input[48] & 0xf8) << 13);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 389 to 404
	value = ((uint32_t)(input[48] & 0x07) << 29) |
			((uint32_t)input[49] << 21) |
			((uint32_t)(input[50] & 0xf8) << 13);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 405 to 420
	value = ((uint32_t)(input[50] & 0x07) << 29) |
			((uint32_t)input[51] << 21) |
			((uint32_t)(input[52] & 0xf8) << 13);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 421 to 436
	value = ((uint32_t)(input[52] & 0x07) << 29) |
			((uint32_t)input[53] << 21) |
			((uint32_t)(input[54] & 0xf8) << 13);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 437 to 452
	value = ((uint32_t)(input[54] & 0x07) << 29) |
			((uint32_t)input[55] << 21) |
			((uint32_t)(input[56] & 0xf8) << 13);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 453 to 468
	value = ((uint32_t)(input[56] & 0x07) << 29) |
			((uint32_t)input[57] << 21) |
			((uint32_t)(input[58] & 0xf8) << 13);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 469 to 484
	value = ((uint32_t)(input[58] & 0x07) << 29) |
			((uint32_t)input[59] << 21) |
			((uint32_t)(input[60] & 0xf8) << 13);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 485 to 500
	value = ((uint32_t)(input[60] & 0x07) << 29) |
			((uint32_t)input[61] << 21) |
			((uint32_t)(input[62] & 0xf8) << 13);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 501 to 516
	value = ((uint32_t)(input[62] & 0x07) << 29) |
			((uint32_t)input[63] << 21) |
			((uint32_t)(input[64] & 0xf8) << 13);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 517 to 532
	value = ((uint32_t)(input[64] & 0x07) << 29) |
			((uint32_t)input[65] << 21) |
			((uint32_t)(input[66] & 0xf8) << 13);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 533 to 548
	value = ((uint32_t)(input[66] & 0x07) << 29) |
			((uint32_t)input[67] << 21) |
			((uint32_t)(input[68] & 0xf8) << 13);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 549 to 564
	value = ((uint32_t)(input[68] & 0x07) << 29) |
			((uint32_t)input[69] << 21) |
			((uint32_t)(input[70] & 0xf8) << 13);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 565 to 580
	value = ((uint32_t)(input[70] & 0x07) << 29) |
			((uint32_t)input[71] << 21) |
			((uint32_t)(input[72] & 0xf8) << 13);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 581 to 596
	value = ((uint32_t)(input[72] & 0x07) << 29) |
			((uint32_t)input[73] << 21) |
			((uint32_t)(input[74] & 0xf8) << 13);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 597 to 612
	value = ((uint32_t)(input[74] & 0x07) << 29) |
			((uint32_t)input[75] << 21) |
			((uint32_t)(input[76] & 0xf8) << 13);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 613 to 628
	value = ((uint32_t)(input[76] & 0x07) << 29) |
			((uint32_t)input[77] << 21) |
			((uint32_t)(input[78] & 0xf8) << 13);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 629 to 644
	value = ((uint32_t)(input[78] & 0x07) << 29) |
			((uint32_t)input[79] << 21) |
			((uint32_t)(input[80] & 0xf8) << 13);
	output[39] = (double)(value >> 16);

	// read output[40]: from bit 645 to 660
	value = ((uint32_t)(input[80] & 0x07) << 29) |
			((uint32_t)input[81] << 21) |
			((uint32_t)(input[82] & 0xf8) << 13);
	output[40] = (double)(value >> 16);

	// read output[41]: from bit 661 to 676
	value = ((uint32_t)(input[82] & 0x07) << 29) |
			((uint32_t)input[83] << 21) |
			((uint32_t)(input[84] & 0xf8) << 13);
	output[41] = (double)(value >> 16);

	// read output[42]: from bit 677 to 692
	value = ((uint32_t)(input[84] & 0x07) << 29) |
			((uint32_t)input[85] << 21) |
			((uint32_t)(input[86] & 0xf8) << 13);
	output[42] = (double)(value >> 16);

	// read output[43]: from bit 693 to 708
	value = ((uint32_t)(input[86] & 0x07) << 29) |
			((uint32_t)input[87] << 21) |
			((uint32_t)(input[88] & 0xf8) << 13);
	output[43] = (double)(value >> 16);

	// read output[44]: from bit 709 to 724
	value = ((uint32_t)(input[88] & 0x07) << 29) |
			((uint32_t)input[89] << 21) |
			((uint32_t)(input[90] & 0xf8) << 13);
	output[44] = (double)(value >> 16);

	// read output[45]: from bit 725 to 740
	value = ((uint32_t)(input[90] & 0x07) << 29) |
			((uint32_t)input[91] << 21) |
			((uint32_t)(input[92] & 0xf8) << 13);
	output[45] = (double)(value >> 16);

	// read output[46]: from bit 741 to 756
	value = ((uint32_t)(input[92] & 0x07) << 29) |
			((uint32_t)input[93] << 21) |
			((uint32_t)(input[94] & 0xf8) << 13);
	output[46] = (double)(value >> 16);

	// read output[47]: from bit 757 to 772
	value = ((uint32_t)(input[94] & 0x07) << 29) |
			((uint32_t)input[95] << 21) |
			((uint32_t)(input[96] & 0xf8) << 13);
	output[47] = (double)(value >> 16);

	// read output[48]: from bit 773 to 788
	value = ((uint32_t)(input[96] & 0x07) << 29) |
			((uint32_t)input[97] << 21) |
			((uint32_t)(input[98] & 0xf8) << 13);
	output[48] = (double)(value >> 16);

	// read output[49]: from bit 789 to 804
	value = ((uint32_t)(input[98] & 0x07) << 29) |
			((uint32_t)input[99] << 21) |
			((uint32_t)(input[100] & 0xf8) << 13);
	output[49] = (double)(value >> 16);

	// read output[50]: from bit 805 to 820
	value = ((uint32_t)(input[100] & 0x07) << 29) |
			((uint32_t)input[101] << 21) |
			((uint32_t)(input[102] & 0xf8) << 13);
	output[50] = (double)(value >> 16);
}

static void unpack_51_16bit_unsigned_5off(const uint8_t * input, double * output, void *closure) {
	// Unpack 51 values into output
	// Values are 16-bit unsigned
	// Skip 5 bits, read 816 bits of data.
	// Input must be at least 103 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 5 to 20
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)(input[2] & 0xf8) << 13);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 21 to 36
	value = ((uint32_t)(input[2] & 0x07) << 29) |
			((uint32_t)input[3] << 21) |
			((uint32_t)(input[4] & 0xf8) << 13);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 37 to 52
	value = ((uint32_t)(input[4] & 0x07) << 29) |
			((uint32_t)input[5] << 21) |
			((uint32_t)(input[6] & 0xf8) << 13);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 53 to 68
	value = ((uint32_t)(input[6] & 0x07) << 29) |
			((uint32_t)input[7] << 21) |
			((uint32_t)(input[8] & 0xf8) << 13);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 69 to 84
	value = ((uint32_t)(input[8] & 0x07) << 29) |
			((uint32_t)input[9] << 21) |
			((uint32_t)(input[10] & 0xf8) << 13);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 85 to 100
	value = ((uint32_t)(input[10] & 0x07) << 29) |
			((uint32_t)input[11] << 21) |
			((uint32_t)(input[12] & 0xf8) << 13);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 101 to 116
	value = ((uint32_t)(input[12] & 0x07) << 29) |
			((uint32_t)input[13] << 21) |
			((uint32_t)(input[14] & 0xf8) << 13);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 117 to 132
	value = ((uint32_t)(input[14] & 0x07) << 29) |
			((uint32_t)input[15] << 21) |
			((uint32_t)(input[16] & 0xf8) << 13);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 133 to 148
	value = ((uint32_t)(input[16] & 0x07) << 29) |
			((uint32_t)input[17] << 21) |
			((uint32_t)(input[18] & 0xf8) << 13);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 149 to 164
	value = ((uint32_t)(input[18] & 0x07) << 29) |
			((uint32_t)input[19] << 21) |
			((uint32_t)(input[20] & 0xf8) << 13);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 165 to 180
	value = ((uint32_t)(input[20] & 0x07) << 29) |
			((uint32_t)input[21] << 21) |
			((uint32_t)(input[22] & 0xf8) << 13);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 181 to 196
	value = ((uint32_t)(input[22] & 0x07) << 29) |
			((uint32_t)input[23] << 21) |
			((uint32_t)(input[24] & 0xf8) << 13);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 197 to 212
	value = ((uint32_t)(input[24] & 0x07) << 29) |
			((uint32_t)input[25] << 21) |
			((uint32_t)(input[26] & 0xf8) << 13);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 213 to 228
	value = ((uint32_t)(input[26] & 0x07) << 29) |
			((uint32_t)input[27] << 21) |
			((uint32_t)(input[28] & 0xf8) << 13);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 229 to 244
	value = ((uint32_t)(input[28] & 0x07) << 29) |
			((uint32_t)input[29] << 21) |
			((uint32_t)(input[30] & 0xf8) << 13);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 245 to 260
	value = ((uint32_t)(input[30] & 0x07) << 29) |
			((uint32_t)input[31] << 21) |
			((uint32_t)(input[32] & 0xf8) << 13);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 261 to 276
	value = ((uint32_t)(input[32] & 0x07) << 29) |
			((uint32_t)input[33] << 21) |
			((uint32_t)(input[34] & 0xf8) << 13);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 277 to 292
	value = ((uint32_t)(input[34] & 0x07) << 29) |
			((uint32_t)input[35] << 21) |
			((uint32_t)(input[36] & 0xf8) << 13);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 293 to 308
	value = ((uint32_t)(input[36] & 0x07) << 29) |
			((uint32_t)input[37] << 21) |
			((uint32_t)(input[38] & 0xf8) << 13);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 309 to 324
	value = ((uint32_t)(input[38] & 0x07) << 29) |
			((uint32_t)input[39] << 21) |
			((uint32_t)(input[40] & 0xf8) << 13);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 325 to 340
	value = ((uint32_t)(input[40] & 0x07) << 29) |
			((uint32_t)input[41] << 21) |
			((uint32_t)(input[42] & 0xf8) << 13);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 341 to 356
	value = ((uint32_t)(input[42] & 0x07) << 29) |
			((uint32_t)input[43] << 21) |
			((uint32_t)(input[44] & 0xf8) << 13);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 357 to 372
	value = ((uint32_t)(input[44] & 0x07) << 29) |
			((uint32_t)input[45] << 21) |
			((uint32_t)(input[46] & 0xf8) << 13);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 373 to 388
	value = ((uint32_t)(input[46] & 0x07) << 29) |
			((uint32_t)input[47] << 21) |
			((uint32_t)(input[48] & 0xf8) << 13);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 389 to 404
	value = ((uint32_t)(input[48] & 0x07) << 29) |
			((uint32_t)input[49] << 21) |
			((uint32_t)(input[50] & 0xf8) << 13);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 405 to 420
	value = ((uint32_t)(input[50] & 0x07) << 29) |
			((uint32_t)input[51] << 21) |
			((uint32_t)(input[52] & 0xf8) << 13);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 421 to 436
	value = ((uint32_t)(input[52] & 0x07) << 29) |
			((uint32_t)input[53] << 21) |
			((uint32_t)(input[54] & 0xf8) << 13);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 437 to 452
	value = ((uint32_t)(input[54] & 0x07) << 29) |
			((uint32_t)input[55] << 21) |
			((uint32_t)(input[56] & 0xf8) << 13);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 453 to 468
	value = ((uint32_t)(input[56] & 0x07) << 29) |
			((uint32_t)input[57] << 21) |
			((uint32_t)(input[58] & 0xf8) << 13);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 469 to 484
	value = ((uint32_t)(input[58] & 0x07) << 29) |
			((uint32_t)input[59] << 21) |
			((uint32_t)(input[60] & 0xf8) << 13);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 485 to 500
	value = ((uint32_t)(input[60] & 0x07) << 29) |
			((uint32_t)input[61] << 21) |
			((uint32_t)(input[62] & 0xf8) << 13);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 501 to 516
	value = ((uint32_t)(input[62] & 0x07) << 29) |
			((uint32_t)input[63] << 21) |
			((uint32_t)(input[64] & 0xf8) << 13);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 517 to 532
	value = ((uint32_t)(input[64] & 0x07) << 29) |
			((uint32_t)input[65] << 21) |
			((uint32_t)(input[66] & 0xf8) << 13);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 533 to 548
	value = ((uint32_t)(input[66] & 0x07) << 29) |
			((uint32_t)input[67] << 21) |
			((uint32_t)(input[68] & 0xf8) << 13);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 549 to 564
	value = ((uint32_t)(input[68] & 0x07) << 29) |
			((uint32_t)input[69] << 21) |
			((uint32_t)(input[70] & 0xf8) << 13);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 565 to 580
	value = ((uint32_t)(input[70] & 0x07) << 29) |
			((uint32_t)input[71] << 21) |
			((uint32_t)(input[72] & 0xf8) << 13);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 581 to 596
	value = ((uint32_t)(input[72] & 0x07) << 29) |
			((uint32_t)input[73] << 21) |
			((uint32_t)(input[74] & 0xf8) << 13);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 597 to 612
	value = ((uint32_t)(input[74] & 0x07) << 29) |
			((uint32_t)input[75] << 21) |
			((uint32_t)(input[76] & 0xf8) << 13);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 613 to 628
	value = ((uint32_t)(input[76] & 0x07) << 29) |
			((uint32_t)input[77] << 21) |
			((uint32_t)(input[78] & 0xf8) << 13);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 629 to 644
	value = ((uint32_t)(input[78] & 0x07) << 29) |
			((uint32_t)input[79] << 21) |
			((uint32_t)(input[80] & 0xf8) << 13);
	output[39] = (double)(value >> 16);

	// read output[40]: from bit 645 to 660
	value = ((uint32_t)(input[80] & 0x07) << 29) |
			((uint32_t)input[81] << 21) |
			((uint32_t)(input[82] & 0xf8) << 13);
	output[40] = (double)(value >> 16);

	// read output[41]: from bit 661 to 676
	value = ((uint32_t)(input[82] & 0x07) << 29) |
			((uint32_t)input[83] << 21) |
			((uint32_t)(input[84] & 0xf8) << 13);
	output[41] = (double)(value >> 16);

	// read output[42]: from bit 677 to 692
	value = ((uint32_t)(input[84] & 0x07) << 29) |
			((uint32_t)input[85] << 21) |
			((uint32_t)(input[86] & 0xf8) << 13);
	output[42] = (double)(value >> 16);

	// read output[43]: from bit 693 to 708
	value = ((uint32_t)(input[86] & 0x07) << 29) |
			((uint32_t)input[87] << 21) |
			((uint32_t)(input[88] & 0xf8) << 13);
	output[43] = (double)(value >> 16);

	// read output[44]: from bit 709 to 724
	value = ((uint32_t)(input[88] & 0x07) << 29) |
			((uint32_t)input[89] << 21) |
			((uint32_t)(input[90] & 0xf8) << 13);
	output[44] = (double)(value >> 16);

	// read output[45]: from bit 725 to 740
	value = ((uint32_t)(input[90] & 0x07) << 29) |
			((uint32_t)input[91] << 21) |
			((uint32_t)(input[92] & 0xf8) << 13);
	output[45] = (double)(value >> 16);

	// read output[46]: from bit 741 to 756
	value = ((uint32_t)(input[92] & 0x07) << 29) |
			((uint32_t)input[93] << 21) |
			((uint32_t)(input[94] & 0xf8) << 13);
	output[46] = (double)(value >> 16);

	// read output[47]: from bit 757 to 772
	value = ((uint32_t)(input[94] & 0x07) << 29) |
			((uint32_t)input[95] << 21) |
			((uint32_t)(input[96] & 0xf8) << 13);
	output[47] = (double)(value >> 16);

	// read output[48]: from bit 773 to 788
	value = ((uint32_t)(input[96] & 0x07) << 29) |
			((uint32_t)input[97] << 21) |
			((uint32_t)(input[98] & 0xf8) << 13);
	output[48] = (double)(value >> 16);

	// read output[49]: from bit 789 to 804
	value = ((uint32_t)(input[98] & 0x07) << 29) |
			((uint32_t)input[99] << 21) |
			((uint32_t)(input[100] & 0xf8) << 13);
	output[49] = (double)(value >> 16);

	// read output[50]: from bit 805 to 820
	value = ((uint32_t)(input[100] & 0x07) << 29) |
			((uint32_t)input[101] << 21) |
			((uint32_t)(input[102] & 0xf8) << 13);
	output[50] = (double)(value >> 16);
}

static void unpack_51_16bit_signed_6off(const uint8_t * input, double * output, void *closure) {
	// Unpack 51 values into output
	// Values are 16-bit signed
	// Skip 6 bits, read 816 bits of data.
	// Input must be at least 103 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 6 to 21
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)(input[2] & 0xfc) << 14);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 22 to 37
	value = ((uint32_t)(input[2] & 0x03) << 30) |
			((uint32_t)input[3] << 22) |
			((uint32_t)(input[4] & 0xfc) << 14);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 38 to 53
	value = ((uint32_t)(input[4] & 0x03) << 30) |
			((uint32_t)input[5] << 22) |
			((uint32_t)(input[6] & 0xfc) << 14);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 54 to 69
	value = ((uint32_t)(input[6] & 0x03) << 30) |
			((uint32_t)input[7] << 22) |
			((uint32_t)(input[8] & 0xfc) << 14);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 70 to 85
	value = ((uint32_t)(input[8] & 0x03) << 30) |
			((uint32_t)input[9] << 22) |
			((uint32_t)(input[10] & 0xfc) << 14);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 86 to 101
	value = ((uint32_t)(input[10] & 0x03) << 30) |
			((uint32_t)input[11] << 22) |
			((uint32_t)(input[12] & 0xfc) << 14);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 102 to 117
	value = ((uint32_t)(input[12] & 0x03) << 30) |
			((uint32_t)input[13] << 22) |
			((uint32_t)(input[14] & 0xfc) << 14);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 118 to 133
	value = ((uint32_t)(input[14] & 0x03) << 30) |
			((uint32_t)input[15] << 22) |
			((uint32_t)(input[16] & 0xfc) << 14);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 134 to 149
	value = ((uint32_t)(input[16] & 0x03) << 30) |
			((uint32_t)input[17] << 22) |
			((uint32_t)(input[18] & 0xfc) << 14);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 150 to 165
	value = ((uint32_t)(input[18] & 0x03) << 30) |
			((uint32_t)input[19] << 22) |
			((uint32_t)(input[20] & 0xfc) << 14);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 166 to 181
	value = ((uint32_t)(input[20] & 0x03) << 30) |
			((uint32_t)input[21] << 22) |
			((uint32_t)(input[22] & 0xfc) << 14);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 182 to 197
	value = ((uint32_t)(input[22] & 0x03) << 30) |
			((uint32_t)input[23] << 22) |
			((uint32_t)(input[24] & 0xfc) << 14);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 198 to 213
	value = ((uint32_t)(input[24] & 0x03) << 30) |
			((uint32_t)input[25] << 22) |
			((uint32_t)(input[26] & 0xfc) << 14);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 214 to 229
	value = ((uint32_t)(input[26] & 0x03) << 30) |
			((uint32_t)input[27] << 22) |
			((uint32_t)(input[28] & 0xfc) << 14);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 230 to 245
	value = ((uint32_t)(input[28] & 0x03) << 30) |
			((uint32_t)input[29] << 22) |
			((uint32_t)(input[30] & 0xfc) << 14);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 246 to 261
	value = ((uint32_t)(input[30] & 0x03) << 30) |
			((uint32_t)input[31] << 22) |
			((uint32_t)(input[32] & 0xfc) << 14);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 262 to 277
	value = ((uint32_t)(input[32] & 0x03) << 30) |
			((uint32_t)input[33] << 22) |
			((uint32_t)(input[34] & 0xfc) << 14);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 278 to 293
	value = ((uint32_t)(input[34] & 0x03) << 30) |
			((uint32_t)input[35] << 22) |
			((uint32_t)(input[36] & 0xfc) << 14);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 294 to 309
	value = ((uint32_t)(input[36] & 0x03) << 30) |
			((uint32_t)input[37] << 22) |
			((uint32_t)(input[38] & 0xfc) << 14);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 310 to 325
	value = ((uint32_t)(input[38] & 0x03) << 30) |
			((uint32_t)input[39] << 22) |
			((uint32_t)(input[40] & 0xfc) << 14);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 326 to 341
	value = ((uint32_t)(input[40] & 0x03) << 30) |
			((uint32_t)input[41] << 22) |
			((uint32_t)(input[42] & 0xfc) << 14);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 342 to 357
	value = ((uint32_t)(input[42] & 0x03) << 30) |
			((uint32_t)input[43] << 22) |
			((uint32_t)(input[44] & 0xfc) << 14);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 358 to 373
	value = ((uint32_t)(input[44] & 0x03) << 30) |
			((uint32_t)input[45] << 22) |
			((uint32_t)(input[46] & 0xfc) << 14);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 374 to 389
	value = ((uint32_t)(input[46] & 0x03) << 30) |
			((uint32_t)input[47] << 22) |
			((uint32_t)(input[48] & 0xfc) << 14);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 390 to 405
	value = ((uint32_t)(input[48] & 0x03) << 30) |
			((uint32_t)input[49] << 22) |
			((uint32_t)(input[50] & 0xfc) << 14);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 406 to 421
	value = ((uint32_t)(input[50] & 0x03) << 30) |
			((uint32_t)input[51] << 22) |
			((uint32_t)(input[52] & 0xfc) << 14);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 422 to 437
	value = ((uint32_t)(input[52] & 0x03) << 30) |
			((uint32_t)input[53] << 22) |
			((uint32_t)(input[54] & 0xfc) << 14);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 438 to 453
	value = ((uint32_t)(input[54] & 0x03) << 30) |
			((uint32_t)input[55] << 22) |
			((uint32_t)(input[56] & 0xfc) << 14);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 454 to 469
	value = ((uint32_t)(input[56] & 0x03) << 30) |
			((uint32_t)input[57] << 22) |
			((uint32_t)(input[58] & 0xfc) << 14);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 470 to 485
	value = ((uint32_t)(input[58] & 0x03) << 30) |
			((uint32_t)input[59] << 22) |
			((uint32_t)(input[60] & 0xfc) << 14);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 486 to 501
	value = ((uint32_t)(input[60] & 0x03) << 30) |
			((uint32_t)input[61] << 22) |
			((uint32_t)(input[62] & 0xfc) << 14);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 502 to 517
	value = ((uint32_t)(input[62] & 0x03) << 30) |
			((uint32_t)input[63] << 22) |
			((uint32_t)(input[64] & 0xfc) << 14);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 518 to 533
	value = ((uint32_t)(input[64] & 0x03) << 30) |
			((uint32_t)input[65] << 22) |
			((uint32_t)(input[66] & 0xfc) << 14);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 534 to 549
	value = ((uint32_t)(input[66] & 0x03) << 30) |
			((uint32_t)input[67] << 22) |
			((uint32_t)(input[68] & 0xfc) << 14);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 550 to 565
	value = ((uint32_t)(input[68] & 0x03) << 30) |
			((uint32_t)input[69] << 22) |
			((uint32_t)(input[70] & 0xfc) << 14);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 566 to 581
	value = ((uint32_t)(input[70] & 0x03) << 30) |
			((uint32_t)input[71] << 22) |
			((uint32_t)(input[72] & 0xfc) << 14);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 582 to 597
	value = ((uint32_t)(input[72] & 0x03) << 30) |
			((uint32_t)input[73] << 22) |
			((uint32_t)(input[74] & 0xfc) << 14);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 598 to 613
	value = ((uint32_t)(input[74] & 0x03) << 30) |
			((uint32_t)input[75] << 22) |
			((uint32_t)(input[76] & 0xfc) << 14);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 614 to 629
	value = ((uint32_t)(input[76] & 0x03) << 30) |
			((uint32_t)input[77] << 22) |
			((uint32_t)(input[78] & 0xfc) << 14);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 630 to 645
	value = ((uint32_t)(input[78] & 0x03) << 30) |
			((uint32_t)input[79] << 22) |
			((uint32_t)(input[80] & 0xfc) << 14);
	output[39] = (double)(value >> 16);

	// read output[40]: from bit 646 to 661
	value = ((uint32_t)(input[80] & 0x03) << 30) |
			((uint32_t)input[81] << 22) |
			((uint32_t)(input[82] & 0xfc) << 14);
	output[40] = (double)(value >> 16);

	// read output[41]: from bit 662 to 677
	value = ((uint32_t)(input[82] & 0x03) << 30) |
			((uint32_t)input[83] << 22) |
			((uint32_t)(input[84] & 0xfc) << 14);
	output[41] = (double)(value >> 16);

	// read output[42]: from bit 678 to 693
	value = ((uint32_t)(input[84] & 0x03) << 30) |
			((uint32_t)input[85] << 22) |
			((uint32_t)(input[86] & 0xfc) << 14);
	output[42] = (double)(value >> 16);

	// read output[43]: from bit 694 to 709
	value = ((uint32_t)(input[86] & 0x03) << 30) |
			((uint32_t)input[87] << 22) |
			((uint32_t)(input[88] & 0xfc) << 14);
	output[43] = (double)(value >> 16);

	// read output[44]: from bit 710 to 725
	value = ((uint32_t)(input[88] & 0x03) << 30) |
			((uint32_t)input[89] << 22) |
			((uint32_t)(input[90] & 0xfc) << 14);
	output[44] = (double)(value >> 16);

	// read output[45]: from bit 726 to 741
	value = ((uint32_t)(input[90] & 0x03) << 30) |
			((uint32_t)input[91] << 22) |
			((uint32_t)(input[92] & 0xfc) << 14);
	output[45] = (double)(value >> 16);

	// read output[46]: from bit 742 to 757
	value = ((uint32_t)(input[92] & 0x03) << 30) |
			((uint32_t)input[93] << 22) |
			((uint32_t)(input[94] & 0xfc) << 14);
	output[46] = (double)(value >> 16);

	// read output[47]: from bit 758 to 773
	value = ((uint32_t)(input[94] & 0x03) << 30) |
			((uint32_t)input[95] << 22) |
			((uint32_t)(input[96] & 0xfc) << 14);
	output[47] = (double)(value >> 16);

	// read output[48]: from bit 774 to 789
	value = ((uint32_t)(input[96] & 0x03) << 30) |
			((uint32_t)input[97] << 22) |
			((uint32_t)(input[98] & 0xfc) << 14);
	output[48] = (double)(value >> 16);

	// read output[49]: from bit 790 to 805
	value = ((uint32_t)(input[98] & 0x03) << 30) |
			((uint32_t)input[99] << 22) |
			((uint32_t)(input[100] & 0xfc) << 14);
	output[49] = (double)(value >> 16);

	// read output[50]: from bit 806 to 821
	value = ((uint32_t)(input[100] & 0x03) << 30) |
			((uint32_t)input[101] << 22) |
			((uint32_t)(input[102] & 0xfc) << 14);
	output[50] = (double)(value >> 16);
}

static void unpack_51_16bit_unsigned_6off(const uint8_t * input, double * output, void *closure) {
	// Unpack 51 values into output
	// Values are 16-bit unsigned
	// Skip 6 bits, read 816 bits of data.
	// Input must be at least 103 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 6 to 21
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)(input[2] & 0xfc) << 14);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 22 to 37
	value = ((uint32_t)(input[2] & 0x03) << 30) |
			((uint32_t)input[3] << 22) |
			((uint32_t)(input[4] & 0xfc) << 14);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 38 to 53
	value = ((uint32_t)(input[4] & 0x03) << 30) |
			((uint32_t)input[5] << 22) |
			((uint32_t)(input[6] & 0xfc) << 14);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 54 to 69
	value = ((uint32_t)(input[6] & 0x03) << 30) |
			((uint32_t)input[7] << 22) |
			((uint32_t)(input[8] & 0xfc) << 14);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 70 to 85
	value = ((uint32_t)(input[8] & 0x03) << 30) |
			((uint32_t)input[9] << 22) |
			((uint32_t)(input[10] & 0xfc) << 14);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 86 to 101
	value = ((uint32_t)(input[10] & 0x03) << 30) |
			((uint32_t)input[11] << 22) |
			((uint32_t)(input[12] & 0xfc) << 14);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 102 to 117
	value = ((uint32_t)(input[12] & 0x03) << 30) |
			((uint32_t)input[13] << 22) |
			((uint32_t)(input[14] & 0xfc) << 14);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 118 to 133
	value = ((uint32_t)(input[14] & 0x03) << 30) |
			((uint32_t)input[15] << 22) |
			((uint32_t)(input[16] & 0xfc) << 14);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 134 to 149
	value = ((uint32_t)(input[16] & 0x03) << 30) |
			((uint32_t)input[17] << 22) |
			((uint32_t)(input[18] & 0xfc) << 14);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 150 to 165
	value = ((uint32_t)(input[18] & 0x03) << 30) |
			((uint32_t)input[19] << 22) |
			((uint32_t)(input[20] & 0xfc) << 14);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 166 to 181
	value = ((uint32_t)(input[20] & 0x03) << 30) |
			((uint32_t)input[21] << 22) |
			((uint32_t)(input[22] & 0xfc) << 14);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 182 to 197
	value = ((uint32_t)(input[22] & 0x03) << 30) |
			((uint32_t)input[23] << 22) |
			((uint32_t)(input[24] & 0xfc) << 14);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 198 to 213
	value = ((uint32_t)(input[24] & 0x03) << 30) |
			((uint32_t)input[25] << 22) |
			((uint32_t)(input[26] & 0xfc) << 14);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 214 to 229
	value = ((uint32_t)(input[26] & 0x03) << 30) |
			((uint32_t)input[27] << 22) |
			((uint32_t)(input[28] & 0xfc) << 14);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 230 to 245
	value = ((uint32_t)(input[28] & 0x03) << 30) |
			((uint32_t)input[29] << 22) |
			((uint32_t)(input[30] & 0xfc) << 14);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 246 to 261
	value = ((uint32_t)(input[30] & 0x03) << 30) |
			((uint32_t)input[31] << 22) |
			((uint32_t)(input[32] & 0xfc) << 14);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 262 to 277
	value = ((uint32_t)(input[32] & 0x03) << 30) |
			((uint32_t)input[33] << 22) |
			((uint32_t)(input[34] & 0xfc) << 14);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 278 to 293
	value = ((uint32_t)(input[34] & 0x03) << 30) |
			((uint32_t)input[35] << 22) |
			((uint32_t)(input[36] & 0xfc) << 14);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 294 to 309
	value = ((uint32_t)(input[36] & 0x03) << 30) |
			((uint32_t)input[37] << 22) |
			((uint32_t)(input[38] & 0xfc) << 14);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 310 to 325
	value = ((uint32_t)(input[38] & 0x03) << 30) |
			((uint32_t)input[39] << 22) |
			((uint32_t)(input[40] & 0xfc) << 14);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 326 to 341
	value = ((uint32_t)(input[40] & 0x03) << 30) |
			((uint32_t)input[41] << 22) |
			((uint32_t)(input[42] & 0xfc) << 14);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 342 to 357
	value = ((uint32_t)(input[42] & 0x03) << 30) |
			((uint32_t)input[43] << 22) |
			((uint32_t)(input[44] & 0xfc) << 14);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 358 to 373
	value = ((uint32_t)(input[44] & 0x03) << 30) |
			((uint32_t)input[45] << 22) |
			((uint32_t)(input[46] & 0xfc) << 14);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 374 to 389
	value = ((uint32_t)(input[46] & 0x03) << 30) |
			((uint32_t)input[47] << 22) |
			((uint32_t)(input[48] & 0xfc) << 14);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 390 to 405
	value = ((uint32_t)(input[48] & 0x03) << 30) |
			((uint32_t)input[49] << 22) |
			((uint32_t)(input[50] & 0xfc) << 14);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 406 to 421
	value = ((uint32_t)(input[50] & 0x03) << 30) |
			((uint32_t)input[51] << 22) |
			((uint32_t)(input[52] & 0xfc) << 14);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 422 to 437
	value = ((uint32_t)(input[52] & 0x03) << 30) |
			((uint32_t)input[53] << 22) |
			((uint32_t)(input[54] & 0xfc) << 14);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 438 to 453
	value = ((uint32_t)(input[54] & 0x03) << 30) |
			((uint32_t)input[55] << 22) |
			((uint32_t)(input[56] & 0xfc) << 14);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 454 to 469
	value = ((uint32_t)(input[56] & 0x03) << 30) |
			((uint32_t)input[57] << 22) |
			((uint32_t)(input[58] & 0xfc) << 14);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 470 to 485
	value = ((uint32_t)(input[58] & 0x03) << 30) |
			((uint32_t)input[59] << 22) |
			((uint32_t)(input[60] & 0xfc) << 14);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 486 to 501
	value = ((uint32_t)(input[60] & 0x03) << 30) |
			((uint32_t)input[61] << 22) |
			((uint32_t)(input[62] & 0xfc) << 14);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 502 to 517
	value = ((uint32_t)(input[62] & 0x03) << 30) |
			((uint32_t)input[63] << 22) |
			((uint32_t)(input[64] & 0xfc) << 14);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 518 to 533
	value = ((uint32_t)(input[64] & 0x03) << 30) |
			((uint32_t)input[65] << 22) |
			((uint32_t)(input[66] & 0xfc) << 14);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 534 to 549
	value = ((uint32_t)(input[66] & 0x03) << 30) |
			((uint32_t)input[67] << 22) |
			((uint32_t)(input[68] & 0xfc) << 14);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 550 to 565
	value = ((uint32_t)(input[68] & 0x03) << 30) |
			((uint32_t)input[69] << 22) |
			((uint32_t)(input[70] & 0xfc) << 14);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 566 to 581
	value = ((uint32_t)(input[70] & 0x03) << 30) |
			((uint32_t)input[71] << 22) |
			((uint32_t)(input[72] & 0xfc) << 14);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 582 to 597
	value = ((uint32_t)(input[72] & 0x03) << 30) |
			((uint32_t)input[73] << 22) |
			((uint32_t)(input[74] & 0xfc) << 14);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 598 to 613
	value = ((uint32_t)(input[74] & 0x03) << 30) |
			((uint32_t)input[75] << 22) |
			((uint32_t)(input[76] & 0xfc) << 14);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 614 to 629
	value = ((uint32_t)(input[76] & 0x03) << 30) |
			((uint32_t)input[77] << 22) |
			((uint32_t)(input[78] & 0xfc) << 14);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 630 to 645
	value = ((uint32_t)(input[78] & 0x03) << 30) |
			((uint32_t)input[79] << 22) |
			((uint32_t)(input[80] & 0xfc) << 14);
	output[39] = (double)(value >> 16);

	// read output[40]: from bit 646 to 661
	value = ((uint32_t)(input[80] & 0x03) << 30) |
			((uint32_t)input[81] << 22) |
			((uint32_t)(input[82] & 0xfc) << 14);
	output[40] = (double)(value >> 16);

	// read output[41]: from bit 662 to 677
	value = ((uint32_t)(input[82] & 0x03) << 30) |
			((uint32_t)input[83] << 22) |
			((uint32_t)(input[84] & 0xfc) << 14);
	output[41] = (double)(value >> 16);

	// read output[42]: from bit 678 to 693
	value = ((uint32_t)(input[84] & 0x03) << 30) |
			((uint32_t)input[85] << 22) |
			((uint32_t)(input[86] & 0xfc) << 14);
	output[42] = (double)(value >> 16);

	// read output[43]: from bit 694 to 709
	value = ((uint32_t)(input[86] & 0x03) << 30) |
			((uint32_t)input[87] << 22) |
			((uint32_t)(input[88] & 0xfc) << 14);
	output[43] = (double)(value >> 16);

	// read output[44]: from bit 710 to 725
	value = ((uint32_t)(input[88] & 0x03) << 30) |
			((uint32_t)input[89] << 22) |
			((uint32_t)(input[90] & 0xfc) << 14);
	output[44] = (double)(value >> 16);

	// read output[45]: from bit 726 to 741
	value = ((uint32_t)(input[90] & 0x03) << 30) |
			((uint32_t)input[91] << 22) |
			((uint32_t)(input[92] & 0xfc) << 14);
	output[45] = (double)(value >> 16);

	// read output[46]: from bit 742 to 757
	value = ((uint32_t)(input[92] & 0x03) << 30) |
			((uint32_t)input[93] << 22) |
			((uint32_t)(input[94] & 0xfc) << 14);
	output[46] = (double)(value >> 16);

	// read output[47]: from bit 758 to 773
	value = ((uint32_t)(input[94] & 0x03) << 30) |
			((uint32_t)input[95] << 22) |
			((uint32_t)(input[96] & 0xfc) << 14);
	output[47] = (double)(value >> 16);

	// read output[48]: from bit 774 to 789
	value = ((uint32_t)(input[96] & 0x03) << 30) |
			((uint32_t)input[97] << 22) |
			((uint32_t)(input[98] & 0xfc) << 14);
	output[48] = (double)(value >> 16);

	// read output[49]: from bit 790 to 805
	value = ((uint32_t)(input[98] & 0x03) << 30) |
			((uint32_t)input[99] << 22) |
			((uint32_t)(input[100] & 0xfc) << 14);
	output[49] = (double)(value >> 16);

	// read output[50]: from bit 806 to 821
	value = ((uint32_t)(input[100] & 0x03) << 30) |
			((uint32_t)input[101] << 22) |
			((uint32_t)(input[102] & 0xfc) << 14);
	output[50] = (double)(value >> 16);
}

static void unpack_51_16bit_signed_7off(const uint8_t * input, double * output, void *closure) {
	// Unpack 51 values into output
	// Values are 16-bit signed
	// Skip 7 bits, read 816 bits of data.
	// Input must be at least 103 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 7 to 22
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)(input[2] & 0xfe) << 15);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 23 to 38
	value = ((uint32_t)(input[2] & 0x01) << 31) |
			((uint32_t)input[3] << 23) |
			((uint32_t)(input[4] & 0xfe) << 15);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 39 to 54
	value = ((uint32_t)(input[4] & 0x01) << 31) |
			((uint32_t)input[5] << 23) |
			((uint32_t)(input[6] & 0xfe) << 15);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 55 to 70
	value = ((uint32_t)(input[6] & 0x01) << 31) |
			((uint32_t)input[7] << 23) |
			((uint32_t)(input[8] & 0xfe) << 15);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 71 to 86
	value = ((uint32_t)(input[8] & 0x01) << 31) |
			((uint32_t)input[9] << 23) |
			((uint32_t)(input[10] & 0xfe) << 15);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 87 to 102
	value = ((uint32_t)(input[10] & 0x01) << 31) |
			((uint32_t)input[11] << 23) |
			((uint32_t)(input[12] & 0xfe) << 15);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 103 to 118
	value = ((uint32_t)(input[12] & 0x01) << 31) |
			((uint32_t)input[13] << 23) |
			((uint32_t)(input[14] & 0xfe) << 15);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 119 to 134
	value = ((uint32_t)(input[14] & 0x01) << 31) |
			((uint32_t)input[15] << 23) |
			((uint32_t)(input[16] & 0xfe) << 15);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 135 to 150
	value = ((uint32_t)(input[16] & 0x01) << 31) |
			((uint32_t)input[17] << 23) |
			((uint32_t)(input[18] & 0xfe) << 15);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 151 to 166
	value = ((uint32_t)(input[18] & 0x01) << 31) |
			((uint32_t)input[19] << 23) |
			((uint32_t)(input[20] & 0xfe) << 15);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 167 to 182
	value = ((uint32_t)(input[20] & 0x01) << 31) |
			((uint32_t)input[21] << 23) |
			((uint32_t)(input[22] & 0xfe) << 15);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 183 to 198
	value = ((uint32_t)(input[22] & 0x01) << 31) |
			((uint32_t)input[23] << 23) |
			((uint32_t)(input[24] & 0xfe) << 15);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 199 to 214
	value = ((uint32_t)(input[24] & 0x01) << 31) |
			((uint32_t)input[25] << 23) |
			((uint32_t)(input[26] & 0xfe) << 15);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 215 to 230
	value = ((uint32_t)(input[26] & 0x01) << 31) |
			((uint32_t)input[27] << 23) |
			((uint32_t)(input[28] & 0xfe) << 15);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 231 to 246
	value = ((uint32_t)(input[28] & 0x01) << 31) |
			((uint32_t)input[29] << 23) |
			((uint32_t)(input[30] & 0xfe) << 15);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 247 to 262
	value = ((uint32_t)(input[30] & 0x01) << 31) |
			((uint32_t)input[31] << 23) |
			((uint32_t)(input[32] & 0xfe) << 15);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 263 to 278
	value = ((uint32_t)(input[32] & 0x01) << 31) |
			((uint32_t)input[33] << 23) |
			((uint32_t)(input[34] & 0xfe) << 15);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 279 to 294
	value = ((uint32_t)(input[34] & 0x01) << 31) |
			((uint32_t)input[35] << 23) |
			((uint32_t)(input[36] & 0xfe) << 15);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 295 to 310
	value = ((uint32_t)(input[36] & 0x01) << 31) |
			((uint32_t)input[37] << 23) |
			((uint32_t)(input[38] & 0xfe) << 15);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 311 to 326
	value = ((uint32_t)(input[38] & 0x01) << 31) |
			((uint32_t)input[39] << 23) |
			((uint32_t)(input[40] & 0xfe) << 15);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 327 to 342
	value = ((uint32_t)(input[40] & 0x01) << 31) |
			((uint32_t)input[41] << 23) |
			((uint32_t)(input[42] & 0xfe) << 15);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 343 to 358
	value = ((uint32_t)(input[42] & 0x01) << 31) |
			((uint32_t)input[43] << 23) |
			((uint32_t)(input[44] & 0xfe) << 15);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 359 to 374
	value = ((uint32_t)(input[44] & 0x01) << 31) |
			((uint32_t)input[45] << 23) |
			((uint32_t)(input[46] & 0xfe) << 15);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 375 to 390
	value = ((uint32_t)(input[46] & 0x01) << 31) |
			((uint32_t)input[47] << 23) |
			((uint32_t)(input[48] & 0xfe) << 15);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 391 to 406
	value = ((uint32_t)(input[48] & 0x01) << 31) |
			((uint32_t)input[49] << 23) |
			((uint32_t)(input[50] & 0xfe) << 15);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 407 to 422
	value = ((uint32_t)(input[50] & 0x01) << 31) |
			((uint32_t)input[51] << 23) |
			((uint32_t)(input[52] & 0xfe) << 15);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 423 to 438
	value = ((uint32_t)(input[52] & 0x01) << 31) |
			((uint32_t)input[53] << 23) |
			((uint32_t)(input[54] & 0xfe) << 15);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 439 to 454
	value = ((uint32_t)(input[54] & 0x01) << 31) |
			((uint32_t)input[55] << 23) |
			((uint32_t)(input[56] & 0xfe) << 15);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 455 to 470
	value = ((uint32_t)(input[56] & 0x01) << 31) |
			((uint32_t)input[57] << 23) |
			((uint32_t)(input[58] & 0xfe) << 15);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 471 to 486
	value = ((uint32_t)(input[58] & 0x01) << 31) |
			((uint32_t)input[59] << 23) |
			((uint32_t)(input[60] & 0xfe) << 15);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 487 to 502
	value = ((uint32_t)(input[60] & 0x01) << 31) |
			((uint32_t)input[61] << 23) |
			((uint32_t)(input[62] & 0xfe) << 15);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 503 to 518
	value = ((uint32_t)(input[62] & 0x01) << 31) |
			((uint32_t)input[63] << 23) |
			((uint32_t)(input[64] & 0xfe) << 15);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 519 to 534
	value = ((uint32_t)(input[64] & 0x01) << 31) |
			((uint32_t)input[65] << 23) |
			((uint32_t)(input[66] & 0xfe) << 15);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 535 to 550
	value = ((uint32_t)(input[66] & 0x01) << 31) |
			((uint32_t)input[67] << 23) |
			((uint32_t)(input[68] & 0xfe) << 15);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 551 to 566
	value = ((uint32_t)(input[68] & 0x01) << 31) |
			((uint32_t)input[69] << 23) |
			((uint32_t)(input[70] & 0xfe) << 15);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 567 to 582
	value = ((uint32_t)(input[70] & 0x01) << 31) |
			((uint32_t)input[71] << 23) |
			((uint32_t)(input[72] & 0xfe) << 15);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 583 to 598
	value = ((uint32_t)(input[72] & 0x01) << 31) |
			((uint32_t)input[73] << 23) |
			((uint32_t)(input[74] & 0xfe) << 15);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 599 to 614
	value = ((uint32_t)(input[74] & 0x01) << 31) |
			((uint32_t)input[75] << 23) |
			((uint32_t)(input[76] & 0xfe) << 15);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 615 to 630
	value = ((uint32_t)(input[76] & 0x01) << 31) |
			((uint32_t)input[77] << 23) |
			((uint32_t)(input[78] & 0xfe) << 15);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 631 to 646
	value = ((uint32_t)(input[78] & 0x01) << 31) |
			((uint32_t)input[79] << 23) |
			((uint32_t)(input[80] & 0xfe) << 15);
	output[39] = (double)(value >> 16);

	// read output[40]: from bit 647 to 662
	value = ((uint32_t)(input[80] & 0x01) << 31) |
			((uint32_t)input[81] << 23) |
			((uint32_t)(input[82] & 0xfe) << 15);
	output[40] = (double)(value >> 16);

	// read output[41]: from bit 663 to 678
	value = ((uint32_t)(input[82] & 0x01) << 31) |
			((uint32_t)input[83] << 23) |
			((uint32_t)(input[84] & 0xfe) << 15);
	output[41] = (double)(value >> 16);

	// read output[42]: from bit 679 to 694
	value = ((uint32_t)(input[84] & 0x01) << 31) |
			((uint32_t)input[85] << 23) |
			((uint32_t)(input[86] & 0xfe) << 15);
	output[42] = (double)(value >> 16);

	// read output[43]: from bit 695 to 710
	value = ((uint32_t)(input[86] & 0x01) << 31) |
			((uint32_t)input[87] << 23) |
			((uint32_t)(input[88] & 0xfe) << 15);
	output[43] = (double)(value >> 16);

	// read output[44]: from bit 711 to 726
	value = ((uint32_t)(input[88] & 0x01) << 31) |
			((uint32_t)input[89] << 23) |
			((uint32_t)(input[90] & 0xfe) << 15);
	output[44] = (double)(value >> 16);

	// read output[45]: from bit 727 to 742
	value = ((uint32_t)(input[90] & 0x01) << 31) |
			((uint32_t)input[91] << 23) |
			((uint32_t)(input[92] & 0xfe) << 15);
	output[45] = (double)(value >> 16);

	// read output[46]: from bit 743 to 758
	value = ((uint32_t)(input[92] & 0x01) << 31) |
			((uint32_t)input[93] << 23) |
			((uint32_t)(input[94] & 0xfe) << 15);
	output[46] = (double)(value >> 16);

	// read output[47]: from bit 759 to 774
	value = ((uint32_t)(input[94] & 0x01) << 31) |
			((uint32_t)input[95] << 23) |
			((uint32_t)(input[96] & 0xfe) << 15);
	output[47] = (double)(value >> 16);

	// read output[48]: from bit 775 to 790
	value = ((uint32_t)(input[96] & 0x01) << 31) |
			((uint32_t)input[97] << 23) |
			((uint32_t)(input[98] & 0xfe) << 15);
	output[48] = (double)(value >> 16);

	// read output[49]: from bit 791 to 806
	value = ((uint32_t)(input[98] & 0x01) << 31) |
			((uint32_t)input[99] << 23) |
			((uint32_t)(input[100] & 0xfe) << 15);
	output[49] = (double)(value >> 16);

	// read output[50]: from bit 807 to 822
	value = ((uint32_t)(input[100] & 0x01) << 31) |
			((uint32_t)input[101] << 23) |
			((uint32_t)(input[102] & 0xfe) << 15);
	output[50] = (double)(value >> 16);
}

static void unpack_51_16bit_unsigned_7off(const uint8_t * input, double * output, void *closure) {
	// Unpack 51 values into output
	// Values are 16-bit unsigned
	// Skip 7 bits, read 816 bits of data.
	// Input must be at least 103 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 7 to 22
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)(input[2] & 0xfe) << 15);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 23 to 38
	value = ((uint32_t)(input[2] & 0x01) << 31) |
			((uint32_t)input[3] << 23) |
			((uint32_t)(input[4] & 0xfe) << 15);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 39 to 54
	value = ((uint32_t)(input[4] & 0x01) << 31) |
			((uint32_t)input[5] << 23) |
			((uint32_t)(input[6] & 0xfe) << 15);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 55 to 70
	value = ((uint32_t)(input[6] & 0x01) << 31) |
			((uint32_t)input[7] << 23) |
			((uint32_t)(input[8] & 0xfe) << 15);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 71 to 86
	value = ((uint32_t)(input[8] & 0x01) << 31) |
			((uint32_t)input[9] << 23) |
			((uint32_t)(input[10] & 0xfe) << 15);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 87 to 102
	value = ((uint32_t)(input[10] & 0x01) << 31) |
			((uint32_t)input[11] << 23) |
			((uint32_t)(input[12] & 0xfe) << 15);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 103 to 118
	value = ((uint32_t)(input[12] & 0x01) << 31) |
			((uint32_t)input[13] << 23) |
			((uint32_t)(input[14] & 0xfe) << 15);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 119 to 134
	value = ((uint32_t)(input[14] & 0x01) << 31) |
			((uint32_t)input[15] << 23) |
			((uint32_t)(input[16] & 0xfe) << 15);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 135 to 150
	value = ((uint32_t)(input[16] & 0x01) << 31) |
			((uint32_t)input[17] << 23) |
			((uint32_t)(input[18] & 0xfe) << 15);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 151 to 166
	value = ((uint32_t)(input[18] & 0x01) << 31) |
			((uint32_t)input[19] << 23) |
			((uint32_t)(input[20] & 0xfe) << 15);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 167 to 182
	value = ((uint32_t)(input[20] & 0x01) << 31) |
			((uint32_t)input[21] << 23) |
			((uint32_t)(input[22] & 0xfe) << 15);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 183 to 198
	value = ((uint32_t)(input[22] & 0x01) << 31) |
			((uint32_t)input[23] << 23) |
			((uint32_t)(input[24] & 0xfe) << 15);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 199 to 214
	value = ((uint32_t)(input[24] & 0x01) << 31) |
			((uint32_t)input[25] << 23) |
			((uint32_t)(input[26] & 0xfe) << 15);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 215 to 230
	value = ((uint32_t)(input[26] & 0x01) << 31) |
			((uint32_t)input[27] << 23) |
			((uint32_t)(input[28] & 0xfe) << 15);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 231 to 246
	value = ((uint32_t)(input[28] & 0x01) << 31) |
			((uint32_t)input[29] << 23) |
			((uint32_t)(input[30] & 0xfe) << 15);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 247 to 262
	value = ((uint32_t)(input[30] & 0x01) << 31) |
			((uint32_t)input[31] << 23) |
			((uint32_t)(input[32] & 0xfe) << 15);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 263 to 278
	value = ((uint32_t)(input[32] & 0x01) << 31) |
			((uint32_t)input[33] << 23) |
			((uint32_t)(input[34] & 0xfe) << 15);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 279 to 294
	value = ((uint32_t)(input[34] & 0x01) << 31) |
			((uint32_t)input[35] << 23) |
			((uint32_t)(input[36] & 0xfe) << 15);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 295 to 310
	value = ((uint32_t)(input[36] & 0x01) << 31) |
			((uint32_t)input[37] << 23) |
			((uint32_t)(input[38] & 0xfe) << 15);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 311 to 326
	value = ((uint32_t)(input[38] & 0x01) << 31) |
			((uint32_t)input[39] << 23) |
			((uint32_t)(input[40] & 0xfe) << 15);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 327 to 342
	value = ((uint32_t)(input[40] & 0x01) << 31) |
			((uint32_t)input[41] << 23) |
			((uint32_t)(input[42] & 0xfe) << 15);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 343 to 358
	value = ((uint32_t)(input[42] & 0x01) << 31) |
			((uint32_t)input[43] << 23) |
			((uint32_t)(input[44] & 0xfe) << 15);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 359 to 374
	value = ((uint32_t)(input[44] & 0x01) << 31) |
			((uint32_t)input[45] << 23) |
			((uint32_t)(input[46] & 0xfe) << 15);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 375 to 390
	value = ((uint32_t)(input[46] & 0x01) << 31) |
			((uint32_t)input[47] << 23) |
			((uint32_t)(input[48] & 0xfe) << 15);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 391 to 406
	value = ((uint32_t)(input[48] & 0x01) << 31) |
			((uint32_t)input[49] << 23) |
			((uint32_t)(input[50] & 0xfe) << 15);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 407 to 422
	value = ((uint32_t)(input[50] & 0x01) << 31) |
			((uint32_t)input[51] << 23) |
			((uint32_t)(input[52] & 0xfe) << 15);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 423 to 438
	value = ((uint32_t)(input[52] & 0x01) << 31) |
			((uint32_t)input[53] << 23) |
			((uint32_t)(input[54] & 0xfe) << 15);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 439 to 454
	value = ((uint32_t)(input[54] & 0x01) << 31) |
			((uint32_t)input[55] << 23) |
			((uint32_t)(input[56] & 0xfe) << 15);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 455 to 470
	value = ((uint32_t)(input[56] & 0x01) << 31) |
			((uint32_t)input[57] << 23) |
			((uint32_t)(input[58] & 0xfe) << 15);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 471 to 486
	value = ((uint32_t)(input[58] & 0x01) << 31) |
			((uint32_t)input[59] << 23) |
			((uint32_t)(input[60] & 0xfe) << 15);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 487 to 502
	value = ((uint32_t)(input[60] & 0x01) << 31) |
			((uint32_t)input[61] << 23) |
			((uint32_t)(input[62] & 0xfe) << 15);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 503 to 518
	value = ((uint32_t)(input[62] & 0x01) << 31) |
			((uint32_t)input[63] << 23) |
			((uint32_t)(input[64] & 0xfe) << 15);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 519 to 534
	value = ((uint32_t)(input[64] & 0x01) << 31) |
			((uint32_t)input[65] << 23) |
			((uint32_t)(input[66] & 0xfe) << 15);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 535 to 550
	value = ((uint32_t)(input[66] & 0x01) << 31) |
			((uint32_t)input[67] << 23) |
			((uint32_t)(input[68] & 0xfe) << 15);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 551 to 566
	value = ((uint32_t)(input[68] & 0x01) << 31) |
			((uint32_t)input[69] << 23) |
			((uint32_t)(input[70] & 0xfe) << 15);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 567 to 582
	value = ((uint32_t)(input[70] & 0x01) << 31) |
			((uint32_t)input[71] << 23) |
			((uint32_t)(input[72] & 0xfe) << 15);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 583 to 598
	value = ((uint32_t)(input[72] & 0x01) << 31) |
			((uint32_t)input[73] << 23) |
			((uint32_t)(input[74] & 0xfe) << 15);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 599 to 614
	value = ((uint32_t)(input[74] & 0x01) << 31) |
			((uint32_t)input[75] << 23) |
			((uint32_t)(input[76] & 0xfe) << 15);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 615 to 630
	value = ((uint32_t)(input[76] & 0x01) << 31) |
			((uint32_t)input[77] << 23) |
			((uint32_t)(input[78] & 0xfe) << 15);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 631 to 646
	value = ((uint32_t)(input[78] & 0x01) << 31) |
			((uint32_t)input[79] << 23) |
			((uint32_t)(input[80] & 0xfe) << 15);
	output[39] = (double)(value >> 16);

	// read output[40]: from bit 647 to 662
	value = ((uint32_t)(input[80] & 0x01) << 31) |
			((uint32_t)input[81] << 23) |
			((uint32_t)(input[82] & 0xfe) << 15);
	output[40] = (double)(value >> 16);

	// read output[41]: from bit 663 to 678
	value = ((uint32_t)(input[82] & 0x01) << 31) |
			((uint32_t)input[83] << 23) |
			((uint32_t)(input[84] & 0xfe) << 15);
	output[41] = (double)(value >> 16);

	// read output[42]: from bit 679 to 694
	value = ((uint32_t)(input[84] & 0x01) << 31) |
			((uint32_t)input[85] << 23) |
			((uint32_t)(input[86] & 0xfe) << 15);
	output[42] = (double)(value >> 16);

	// read output[43]: from bit 695 to 710
	value = ((uint32_t)(input[86] & 0x01) << 31) |
			((uint32_t)input[87] << 23) |
			((uint32_t)(input[88] & 0xfe) << 15);
	output[43] = (double)(value >> 16);

	// read output[44]: from bit 711 to 726
	value = ((uint32_t)(input[88] & 0x01) << 31) |
			((uint32_t)input[89] << 23) |
			((uint32_t)(input[90] & 0xfe) << 15);
	output[44] = (double)(value >> 16);

	// read output[45]: from bit 727 to 742
	value = ((uint32_t)(input[90] & 0x01) << 31) |
			((uint32_t)input[91] << 23) |
			((uint32_t)(input[92] & 0xfe) << 15);
	output[45] = (double)(value >> 16);

	// read output[46]: from bit 743 to 758
	value = ((uint32_t)(input[92] & 0x01) << 31) |
			((uint32_t)input[93] << 23) |
			((uint32_t)(input[94] & 0xfe) << 15);
	output[46] = (double)(value >> 16);

	// read output[47]: from bit 759 to 774
	value = ((uint32_t)(input[94] & 0x01) << 31) |
			((uint32_t)input[95] << 23) |
			((uint32_t)(input[96] & 0xfe) << 15);
	output[47] = (double)(value >> 16);

	// read output[48]: from bit 775 to 790
	value = ((uint32_t)(input[96] & 0x01) << 31) |
			((uint32_t)input[97] << 23) |
			((uint32_t)(input[98] & 0xfe) << 15);
	output[48] = (double)(value >> 16);

	// read output[49]: from bit 791 to 806
	value = ((uint32_t)(input[98] & 0x01) << 31) |
			((uint32_t)input[99] << 23) |
			((uint32_t)(input[100] & 0xfe) << 15);
	output[49] = (double)(value >> 16);

	// read output[50]: from bit 807 to 822
	value = ((uint32_t)(input[100] & 0x01) << 31) |
			((uint32_t)input[101] << 23) |
			((uint32_t)(input[102] & 0xfe) << 15);
	output[50] = (double)(value >> 16);
}

static void unpack_52_16bit_signed_0off(const uint8_t * input, double * output, void *closure) {
	// Unpack 52 values into output
	// Values are 16-bit signed
	// Skip 0 bits, read 832 bits of data.
	// Input must be at least 104 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 0 to 15
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)input[1] << 16);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 16 to 31
	value = ((uint32_t)input[2] << 24) |
			((uint32_t)input[3] << 16);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 32 to 47
	value = ((uint32_t)input[4] << 24) |
			((uint32_t)input[5] << 16);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 48 to 63
	value = ((uint32_t)input[6] << 24) |
			((uint32_t)input[7] << 16);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 64 to 79
	value = ((uint32_t)input[8] << 24) |
			((uint32_t)input[9] << 16);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 80 to 95
	value = ((uint32_t)input[10] << 24) |
			((uint32_t)input[11] << 16);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 96 to 111
	value = ((uint32_t)input[12] << 24) |
			((uint32_t)input[13] << 16);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 112 to 127
	value = ((uint32_t)input[14] << 24) |
			((uint32_t)input[15] << 16);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 128 to 143
	value = ((uint32_t)input[16] << 24) |
			((uint32_t)input[17] << 16);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 144 to 159
	value = ((uint32_t)input[18] << 24) |
			((uint32_t)input[19] << 16);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 160 to 175
	value = ((uint32_t)input[20] << 24) |
			((uint32_t)input[21] << 16);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 176 to 191
	value = ((uint32_t)input[22] << 24) |
			((uint32_t)input[23] << 16);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 192 to 207
	value = ((uint32_t)input[24] << 24) |
			((uint32_t)input[25] << 16);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 208 to 223
	value = ((uint32_t)input[26] << 24) |
			((uint32_t)input[27] << 16);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 224 to 239
	value = ((uint32_t)input[28] << 24) |
			((uint32_t)input[29] << 16);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 240 to 255
	value = ((uint32_t)input[30] << 24) |
			((uint32_t)input[31] << 16);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 256 to 271
	value = ((uint32_t)input[32] << 24) |
			((uint32_t)input[33] << 16);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 272 to 287
	value = ((uint32_t)input[34] << 24) |
			((uint32_t)input[35] << 16);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 288 to 303
	value = ((uint32_t)input[36] << 24) |
			((uint32_t)input[37] << 16);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 304 to 319
	value = ((uint32_t)input[38] << 24) |
			((uint32_t)input[39] << 16);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 320 to 335
	value = ((uint32_t)input[40] << 24) |
			((uint32_t)input[41] << 16);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 336 to 351
	value = ((uint32_t)input[42] << 24) |
			((uint32_t)input[43] << 16);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 352 to 367
	value = ((uint32_t)input[44] << 24) |
			((uint32_t)input[45] << 16);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 368 to 383
	value = ((uint32_t)input[46] << 24) |
			((uint32_t)input[47] << 16);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 384 to 399
	value = ((uint32_t)input[48] << 24) |
			((uint32_t)input[49] << 16);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 400 to 415
	value = ((uint32_t)input[50] << 24) |
			((uint32_t)input[51] << 16);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 416 to 431
	value = ((uint32_t)input[52] << 24) |
			((uint32_t)input[53] << 16);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 432 to 447
	value = ((uint32_t)input[54] << 24) |
			((uint32_t)input[55] << 16);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 448 to 463
	value = ((uint32_t)input[56] << 24) |
			((uint32_t)input[57] << 16);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 464 to 479
	value = ((uint32_t)input[58] << 24) |
			((uint32_t)input[59] << 16);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 480 to 495
	value = ((uint32_t)input[60] << 24) |
			((uint32_t)input[61] << 16);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 496 to 511
	value = ((uint32_t)input[62] << 24) |
			((uint32_t)input[63] << 16);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 512 to 527
	value = ((uint32_t)input[64] << 24) |
			((uint32_t)input[65] << 16);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 528 to 543
	value = ((uint32_t)input[66] << 24) |
			((uint32_t)input[67] << 16);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 544 to 559
	value = ((uint32_t)input[68] << 24) |
			((uint32_t)input[69] << 16);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 560 to 575
	value = ((uint32_t)input[70] << 24) |
			((uint32_t)input[71] << 16);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 576 to 591
	value = ((uint32_t)input[72] << 24) |
			((uint32_t)input[73] << 16);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 592 to 607
	value = ((uint32_t)input[74] << 24) |
			((uint32_t)input[75] << 16);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 608 to 623
	value = ((uint32_t)input[76] << 24) |
			((uint32_t)input[77] << 16);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 624 to 639
	value = ((uint32_t)input[78] << 24) |
			((uint32_t)input[79] << 16);
	output[39] = (double)(value >> 16);

	// read output[40]: from bit 640 to 655
	value = ((uint32_t)input[80] << 24) |
			((uint32_t)input[81] << 16);
	output[40] = (double)(value >> 16);

	// read output[41]: from bit 656 to 671
	value = ((uint32_t)input[82] << 24) |
			((uint32_t)input[83] << 16);
	output[41] = (double)(value >> 16);

	// read output[42]: from bit 672 to 687
	value = ((uint32_t)input[84] << 24) |
			((uint32_t)input[85] << 16);
	output[42] = (double)(value >> 16);

	// read output[43]: from bit 688 to 703
	value = ((uint32_t)input[86] << 24) |
			((uint32_t)input[87] << 16);
	output[43] = (double)(value >> 16);

	// read output[44]: from bit 704 to 719
	value = ((uint32_t)input[88] << 24) |
			((uint32_t)input[89] << 16);
	output[44] = (double)(value >> 16);

	// read output[45]: from bit 720 to 735
	value = ((uint32_t)input[90] << 24) |
			((uint32_t)input[91] << 16);
	output[45] = (double)(value >> 16);

	// read output[46]: from bit 736 to 751
	value = ((uint32_t)input[92] << 24) |
			((uint32_t)input[93] << 16);
	output[46] = (double)(value >> 16);

	// read output[47]: from bit 752 to 767
	value = ((uint32_t)input[94] << 24) |
			((uint32_t)input[95] << 16);
	output[47] = (double)(value >> 16);

	// read output[48]: from bit 768 to 783
	value = ((uint32_t)input[96] << 24) |
			((uint32_t)input[97] << 16);
	output[48] = (double)(value >> 16);

	// read output[49]: from bit 784 to 799
	value = ((uint32_t)input[98] << 24) |
			((uint32_t)input[99] << 16);
	output[49] = (double)(value >> 16);

	// read output[50]: from bit 800 to 815
	value = ((uint32_t)input[100] << 24) |
			((uint32_t)input[101] << 16);
	output[50] = (double)(value >> 16);

	// read output[51]: from bit 816 to 831
	value = ((uint32_t)input[102] << 24) |
			((uint32_t)input[103] << 16);
	output[51] = (double)(value >> 16);
}

static void unpack_52_16bit_unsigned_0off(const uint8_t * input, double * output, void *closure) {
	// Unpack 52 values into output
	// Values are 16-bit unsigned
	// Skip 0 bits, read 832 bits of data.
	// Input must be at least 104 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 0 to 15
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)input[1] << 16);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 16 to 31
	value = ((uint32_t)input[2] << 24) |
			((uint32_t)input[3] << 16);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 32 to 47
	value = ((uint32_t)input[4] << 24) |
			((uint32_t)input[5] << 16);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 48 to 63
	value = ((uint32_t)input[6] << 24) |
			((uint32_t)input[7] << 16);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 64 to 79
	value = ((uint32_t)input[8] << 24) |
			((uint32_t)input[9] << 16);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 80 to 95
	value = ((uint32_t)input[10] << 24) |
			((uint32_t)input[11] << 16);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 96 to 111
	value = ((uint32_t)input[12] << 24) |
			((uint32_t)input[13] << 16);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 112 to 127
	value = ((uint32_t)input[14] << 24) |
			((uint32_t)input[15] << 16);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 128 to 143
	value = ((uint32_t)input[16] << 24) |
			((uint32_t)input[17] << 16);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 144 to 159
	value = ((uint32_t)input[18] << 24) |
			((uint32_t)input[19] << 16);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 160 to 175
	value = ((uint32_t)input[20] << 24) |
			((uint32_t)input[21] << 16);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 176 to 191
	value = ((uint32_t)input[22] << 24) |
			((uint32_t)input[23] << 16);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 192 to 207
	value = ((uint32_t)input[24] << 24) |
			((uint32_t)input[25] << 16);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 208 to 223
	value = ((uint32_t)input[26] << 24) |
			((uint32_t)input[27] << 16);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 224 to 239
	value = ((uint32_t)input[28] << 24) |
			((uint32_t)input[29] << 16);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 240 to 255
	value = ((uint32_t)input[30] << 24) |
			((uint32_t)input[31] << 16);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 256 to 271
	value = ((uint32_t)input[32] << 24) |
			((uint32_t)input[33] << 16);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 272 to 287
	value = ((uint32_t)input[34] << 24) |
			((uint32_t)input[35] << 16);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 288 to 303
	value = ((uint32_t)input[36] << 24) |
			((uint32_t)input[37] << 16);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 304 to 319
	value = ((uint32_t)input[38] << 24) |
			((uint32_t)input[39] << 16);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 320 to 335
	value = ((uint32_t)input[40] << 24) |
			((uint32_t)input[41] << 16);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 336 to 351
	value = ((uint32_t)input[42] << 24) |
			((uint32_t)input[43] << 16);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 352 to 367
	value = ((uint32_t)input[44] << 24) |
			((uint32_t)input[45] << 16);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 368 to 383
	value = ((uint32_t)input[46] << 24) |
			((uint32_t)input[47] << 16);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 384 to 399
	value = ((uint32_t)input[48] << 24) |
			((uint32_t)input[49] << 16);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 400 to 415
	value = ((uint32_t)input[50] << 24) |
			((uint32_t)input[51] << 16);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 416 to 431
	value = ((uint32_t)input[52] << 24) |
			((uint32_t)input[53] << 16);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 432 to 447
	value = ((uint32_t)input[54] << 24) |
			((uint32_t)input[55] << 16);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 448 to 463
	value = ((uint32_t)input[56] << 24) |
			((uint32_t)input[57] << 16);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 464 to 479
	value = ((uint32_t)input[58] << 24) |
			((uint32_t)input[59] << 16);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 480 to 495
	value = ((uint32_t)input[60] << 24) |
			((uint32_t)input[61] << 16);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 496 to 511
	value = ((uint32_t)input[62] << 24) |
			((uint32_t)input[63] << 16);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 512 to 527
	value = ((uint32_t)input[64] << 24) |
			((uint32_t)input[65] << 16);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 528 to 543
	value = ((uint32_t)input[66] << 24) |
			((uint32_t)input[67] << 16);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 544 to 559
	value = ((uint32_t)input[68] << 24) |
			((uint32_t)input[69] << 16);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 560 to 575
	value = ((uint32_t)input[70] << 24) |
			((uint32_t)input[71] << 16);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 576 to 591
	value = ((uint32_t)input[72] << 24) |
			((uint32_t)input[73] << 16);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 592 to 607
	value = ((uint32_t)input[74] << 24) |
			((uint32_t)input[75] << 16);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 608 to 623
	value = ((uint32_t)input[76] << 24) |
			((uint32_t)input[77] << 16);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 624 to 639
	value = ((uint32_t)input[78] << 24) |
			((uint32_t)input[79] << 16);
	output[39] = (double)(value >> 16);

	// read output[40]: from bit 640 to 655
	value = ((uint32_t)input[80] << 24) |
			((uint32_t)input[81] << 16);
	output[40] = (double)(value >> 16);

	// read output[41]: from bit 656 to 671
	value = ((uint32_t)input[82] << 24) |
			((uint32_t)input[83] << 16);
	output[41] = (double)(value >> 16);

	// read output[42]: from bit 672 to 687
	value = ((uint32_t)input[84] << 24) |
			((uint32_t)input[85] << 16);
	output[42] = (double)(value >> 16);

	// read output[43]: from bit 688 to 703
	value = ((uint32_t)input[86] << 24) |
			((uint32_t)input[87] << 16);
	output[43] = (double)(value >> 16);

	// read output[44]: from bit 704 to 719
	value = ((uint32_t)input[88] << 24) |
			((uint32_t)input[89] << 16);
	output[44] = (double)(value >> 16);

	// read output[45]: from bit 720 to 735
	value = ((uint32_t)input[90] << 24) |
			((uint32_t)input[91] << 16);
	output[45] = (double)(value >> 16);

	// read output[46]: from bit 736 to 751
	value = ((uint32_t)input[92] << 24) |
			((uint32_t)input[93] << 16);
	output[46] = (double)(value >> 16);

	// read output[47]: from bit 752 to 767
	value = ((uint32_t)input[94] << 24) |
			((uint32_t)input[95] << 16);
	output[47] = (double)(value >> 16);

	// read output[48]: from bit 768 to 783
	value = ((uint32_t)input[96] << 24) |
			((uint32_t)input[97] << 16);
	output[48] = (double)(value >> 16);

	// read output[49]: from bit 784 to 799
	value = ((uint32_t)input[98] << 24) |
			((uint32_t)input[99] << 16);
	output[49] = (double)(value >> 16);

	// read output[50]: from bit 800 to 815
	value = ((uint32_t)input[100] << 24) |
			((uint32_t)input[101] << 16);
	output[50] = (double)(value >> 16);

	// read output[51]: from bit 816 to 831
	value = ((uint32_t)input[102] << 24) |
			((uint32_t)input[103] << 16);
	output[51] = (double)(value >> 16);
}

static void unpack_52_16bit_signed_1off(const uint8_t * input, double * output, void *closure) {
	// Unpack 52 values into output
	// Values are 16-bit signed
	// Skip 1 bits, read 832 bits of data.
	// Input must be at least 105 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 1 to 16
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)input[1] << 17) |
			((uint32_t)(input[2] & 0x80) << 9);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 17 to 32
	value = ((uint32_t)(input[2] & 0x7f) << 25) |
			((uint32_t)input[3] << 17) |
			((uint32_t)(input[4] & 0x80) << 9);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 33 to 48
	value = ((uint32_t)(input[4] & 0x7f) << 25) |
			((uint32_t)input[5] << 17) |
			((uint32_t)(input[6] & 0x80) << 9);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 49 to 64
	value = ((uint32_t)(input[6] & 0x7f) << 25) |
			((uint32_t)input[7] << 17) |
			((uint32_t)(input[8] & 0x80) << 9);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 65 to 80
	value = ((uint32_t)(input[8] & 0x7f) << 25) |
			((uint32_t)input[9] << 17) |
			((uint32_t)(input[10] & 0x80) << 9);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 81 to 96
	value = ((uint32_t)(input[10] & 0x7f) << 25) |
			((uint32_t)input[11] << 17) |
			((uint32_t)(input[12] & 0x80) << 9);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 97 to 112
	value = ((uint32_t)(input[12] & 0x7f) << 25) |
			((uint32_t)input[13] << 17) |
			((uint32_t)(input[14] & 0x80) << 9);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 113 to 128
	value = ((uint32_t)(input[14] & 0x7f) << 25) |
			((uint32_t)input[15] << 17) |
			((uint32_t)(input[16] & 0x80) << 9);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 129 to 144
	value = ((uint32_t)(input[16] & 0x7f) << 25) |
			((uint32_t)input[17] << 17) |
			((uint32_t)(input[18] & 0x80) << 9);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 145 to 160
	value = ((uint32_t)(input[18] & 0x7f) << 25) |
			((uint32_t)input[19] << 17) |
			((uint32_t)(input[20] & 0x80) << 9);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 161 to 176
	value = ((uint32_t)(input[20] & 0x7f) << 25) |
			((uint32_t)input[21] << 17) |
			((uint32_t)(input[22] & 0x80) << 9);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 177 to 192
	value = ((uint32_t)(input[22] & 0x7f) << 25) |
			((uint32_t)input[23] << 17) |
			((uint32_t)(input[24] & 0x80) << 9);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 193 to 208
	value = ((uint32_t)(input[24] & 0x7f) << 25) |
			((uint32_t)input[25] << 17) |
			((uint32_t)(input[26] & 0x80) << 9);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 209 to 224
	value = ((uint32_t)(input[26] & 0x7f) << 25) |
			((uint32_t)input[27] << 17) |
			((uint32_t)(input[28] & 0x80) << 9);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 225 to 240
	value = ((uint32_t)(input[28] & 0x7f) << 25) |
			((uint32_t)input[29] << 17) |
			((uint32_t)(input[30] & 0x80) << 9);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 241 to 256
	value = ((uint32_t)(input[30] & 0x7f) << 25) |
			((uint32_t)input[31] << 17) |
			((uint32_t)(input[32] & 0x80) << 9);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 257 to 272
	value = ((uint32_t)(input[32] & 0x7f) << 25) |
			((uint32_t)input[33] << 17) |
			((uint32_t)(input[34] & 0x80) << 9);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 273 to 288
	value = ((uint32_t)(input[34] & 0x7f) << 25) |
			((uint32_t)input[35] << 17) |
			((uint32_t)(input[36] & 0x80) << 9);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 289 to 304
	value = ((uint32_t)(input[36] & 0x7f) << 25) |
			((uint32_t)input[37] << 17) |
			((uint32_t)(input[38] & 0x80) << 9);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 305 to 320
	value = ((uint32_t)(input[38] & 0x7f) << 25) |
			((uint32_t)input[39] << 17) |
			((uint32_t)(input[40] & 0x80) << 9);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 321 to 336
	value = ((uint32_t)(input[40] & 0x7f) << 25) |
			((uint32_t)input[41] << 17) |
			((uint32_t)(input[42] & 0x80) << 9);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 337 to 352
	value = ((uint32_t)(input[42] & 0x7f) << 25) |
			((uint32_t)input[43] << 17) |
			((uint32_t)(input[44] & 0x80) << 9);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 353 to 368
	value = ((uint32_t)(input[44] & 0x7f) << 25) |
			((uint32_t)input[45] << 17) |
			((uint32_t)(input[46] & 0x80) << 9);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 369 to 384
	value = ((uint32_t)(input[46] & 0x7f) << 25) |
			((uint32_t)input[47] << 17) |
			((uint32_t)(input[48] & 0x80) << 9);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 385 to 400
	value = ((uint32_t)(input[48] & 0x7f) << 25) |
			((uint32_t)input[49] << 17) |
			((uint32_t)(input[50] & 0x80) << 9);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 401 to 416
	value = ((uint32_t)(input[50] & 0x7f) << 25) |
			((uint32_t)input[51] << 17) |
			((uint32_t)(input[52] & 0x80) << 9);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 417 to 432
	value = ((uint32_t)(input[52] & 0x7f) << 25) |
			((uint32_t)input[53] << 17) |
			((uint32_t)(input[54] & 0x80) << 9);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 433 to 448
	value = ((uint32_t)(input[54] & 0x7f) << 25) |
			((uint32_t)input[55] << 17) |
			((uint32_t)(input[56] & 0x80) << 9);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 449 to 464
	value = ((uint32_t)(input[56] & 0x7f) << 25) |
			((uint32_t)input[57] << 17) |
			((uint32_t)(input[58] & 0x80) << 9);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 465 to 480
	value = ((uint32_t)(input[58] & 0x7f) << 25) |
			((uint32_t)input[59] << 17) |
			((uint32_t)(input[60] & 0x80) << 9);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 481 to 496
	value = ((uint32_t)(input[60] & 0x7f) << 25) |
			((uint32_t)input[61] << 17) |
			((uint32_t)(input[62] & 0x80) << 9);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 497 to 512
	value = ((uint32_t)(input[62] & 0x7f) << 25) |
			((uint32_t)input[63] << 17) |
			((uint32_t)(input[64] & 0x80) << 9);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 513 to 528
	value = ((uint32_t)(input[64] & 0x7f) << 25) |
			((uint32_t)input[65] << 17) |
			((uint32_t)(input[66] & 0x80) << 9);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 529 to 544
	value = ((uint32_t)(input[66] & 0x7f) << 25) |
			((uint32_t)input[67] << 17) |
			((uint32_t)(input[68] & 0x80) << 9);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 545 to 560
	value = ((uint32_t)(input[68] & 0x7f) << 25) |
			((uint32_t)input[69] << 17) |
			((uint32_t)(input[70] & 0x80) << 9);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 561 to 576
	value = ((uint32_t)(input[70] & 0x7f) << 25) |
			((uint32_t)input[71] << 17) |
			((uint32_t)(input[72] & 0x80) << 9);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 577 to 592
	value = ((uint32_t)(input[72] & 0x7f) << 25) |
			((uint32_t)input[73] << 17) |
			((uint32_t)(input[74] & 0x80) << 9);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 593 to 608
	value = ((uint32_t)(input[74] & 0x7f) << 25) |
			((uint32_t)input[75] << 17) |
			((uint32_t)(input[76] & 0x80) << 9);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 609 to 624
	value = ((uint32_t)(input[76] & 0x7f) << 25) |
			((uint32_t)input[77] << 17) |
			((uint32_t)(input[78] & 0x80) << 9);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 625 to 640
	value = ((uint32_t)(input[78] & 0x7f) << 25) |
			((uint32_t)input[79] << 17) |
			((uint32_t)(input[80] & 0x80) << 9);
	output[39] = (double)(value >> 16);

	// read output[40]: from bit 641 to 656
	value = ((uint32_t)(input[80] & 0x7f) << 25) |
			((uint32_t)input[81] << 17) |
			((uint32_t)(input[82] & 0x80) << 9);
	output[40] = (double)(value >> 16);

	// read output[41]: from bit 657 to 672
	value = ((uint32_t)(input[82] & 0x7f) << 25) |
			((uint32_t)input[83] << 17) |
			((uint32_t)(input[84] & 0x80) << 9);
	output[41] = (double)(value >> 16);

	// read output[42]: from bit 673 to 688
	value = ((uint32_t)(input[84] & 0x7f) << 25) |
			((uint32_t)input[85] << 17) |
			((uint32_t)(input[86] & 0x80) << 9);
	output[42] = (double)(value >> 16);

	// read output[43]: from bit 689 to 704
	value = ((uint32_t)(input[86] & 0x7f) << 25) |
			((uint32_t)input[87] << 17) |
			((uint32_t)(input[88] & 0x80) << 9);
	output[43] = (double)(value >> 16);

	// read output[44]: from bit 705 to 720
	value = ((uint32_t)(input[88] & 0x7f) << 25) |
			((uint32_t)input[89] << 17) |
			((uint32_t)(input[90] & 0x80) << 9);
	output[44] = (double)(value >> 16);

	// read output[45]: from bit 721 to 736
	value = ((uint32_t)(input[90] & 0x7f) << 25) |
			((uint32_t)input[91] << 17) |
			((uint32_t)(input[92] & 0x80) << 9);
	output[45] = (double)(value >> 16);

	// read output[46]: from bit 737 to 752
	value = ((uint32_t)(input[92] & 0x7f) << 25) |
			((uint32_t)input[93] << 17) |
			((uint32_t)(input[94] & 0x80) << 9);
	output[46] = (double)(value >> 16);

	// read output[47]: from bit 753 to 768
	value = ((uint32_t)(input[94] & 0x7f) << 25) |
			((uint32_t)input[95] << 17) |
			((uint32_t)(input[96] & 0x80) << 9);
	output[47] = (double)(value >> 16);

	// read output[48]: from bit 769 to 784
	value = ((uint32_t)(input[96] & 0x7f) << 25) |
			((uint32_t)input[97] << 17) |
			((uint32_t)(input[98] & 0x80) << 9);
	output[48] = (double)(value >> 16);

	// read output[49]: from bit 785 to 800
	value = ((uint32_t)(input[98] & 0x7f) << 25) |
			((uint32_t)input[99] << 17) |
			((uint32_t)(input[100] & 0x80) << 9);
	output[49] = (double)(value >> 16);

	// read output[50]: from bit 801 to 816
	value = ((uint32_t)(input[100] & 0x7f) << 25) |
			((uint32_t)input[101] << 17) |
			((uint32_t)(input[102] & 0x80) << 9);
	output[50] = (double)(value >> 16);

	// read output[51]: from bit 817 to 832
	value = ((uint32_t)(input[102] & 0x7f) << 25) |
			((uint32_t)input[103] << 17) |
			((uint32_t)(input[104] & 0x80) << 9);
	output[51] = (double)(value >> 16);
}

static void unpack_52_16bit_unsigned_1off(const uint8_t * input, double * output, void *closure) {
	// Unpack 52 values into output
	// Values are 16-bit unsigned
	// Skip 1 bits, read 832 bits of data.
	// Input must be at least 105 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 1 to 16
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)input[1] << 17) |
			((uint32_t)(input[2] & 0x80) << 9);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 17 to 32
	value = ((uint32_t)(input[2] & 0x7f) << 25) |
			((uint32_t)input[3] << 17) |
			((uint32_t)(input[4] & 0x80) << 9);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 33 to 48
	value = ((uint32_t)(input[4] & 0x7f) << 25) |
			((uint32_t)input[5] << 17) |
			((uint32_t)(input[6] & 0x80) << 9);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 49 to 64
	value = ((uint32_t)(input[6] & 0x7f) << 25) |
			((uint32_t)input[7] << 17) |
			((uint32_t)(input[8] & 0x80) << 9);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 65 to 80
	value = ((uint32_t)(input[8] & 0x7f) << 25) |
			((uint32_t)input[9] << 17) |
			((uint32_t)(input[10] & 0x80) << 9);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 81 to 96
	value = ((uint32_t)(input[10] & 0x7f) << 25) |
			((uint32_t)input[11] << 17) |
			((uint32_t)(input[12] & 0x80) << 9);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 97 to 112
	value = ((uint32_t)(input[12] & 0x7f) << 25) |
			((uint32_t)input[13] << 17) |
			((uint32_t)(input[14] & 0x80) << 9);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 113 to 128
	value = ((uint32_t)(input[14] & 0x7f) << 25) |
			((uint32_t)input[15] << 17) |
			((uint32_t)(input[16] & 0x80) << 9);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 129 to 144
	value = ((uint32_t)(input[16] & 0x7f) << 25) |
			((uint32_t)input[17] << 17) |
			((uint32_t)(input[18] & 0x80) << 9);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 145 to 160
	value = ((uint32_t)(input[18] & 0x7f) << 25) |
			((uint32_t)input[19] << 17) |
			((uint32_t)(input[20] & 0x80) << 9);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 161 to 176
	value = ((uint32_t)(input[20] & 0x7f) << 25) |
			((uint32_t)input[21] << 17) |
			((uint32_t)(input[22] & 0x80) << 9);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 177 to 192
	value = ((uint32_t)(input[22] & 0x7f) << 25) |
			((uint32_t)input[23] << 17) |
			((uint32_t)(input[24] & 0x80) << 9);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 193 to 208
	value = ((uint32_t)(input[24] & 0x7f) << 25) |
			((uint32_t)input[25] << 17) |
			((uint32_t)(input[26] & 0x80) << 9);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 209 to 224
	value = ((uint32_t)(input[26] & 0x7f) << 25) |
			((uint32_t)input[27] << 17) |
			((uint32_t)(input[28] & 0x80) << 9);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 225 to 240
	value = ((uint32_t)(input[28] & 0x7f) << 25) |
			((uint32_t)input[29] << 17) |
			((uint32_t)(input[30] & 0x80) << 9);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 241 to 256
	value = ((uint32_t)(input[30] & 0x7f) << 25) |
			((uint32_t)input[31] << 17) |
			((uint32_t)(input[32] & 0x80) << 9);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 257 to 272
	value = ((uint32_t)(input[32] & 0x7f) << 25) |
			((uint32_t)input[33] << 17) |
			((uint32_t)(input[34] & 0x80) << 9);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 273 to 288
	value = ((uint32_t)(input[34] & 0x7f) << 25) |
			((uint32_t)input[35] << 17) |
			((uint32_t)(input[36] & 0x80) << 9);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 289 to 304
	value = ((uint32_t)(input[36] & 0x7f) << 25) |
			((uint32_t)input[37] << 17) |
			((uint32_t)(input[38] & 0x80) << 9);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 305 to 320
	value = ((uint32_t)(input[38] & 0x7f) << 25) |
			((uint32_t)input[39] << 17) |
			((uint32_t)(input[40] & 0x80) << 9);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 321 to 336
	value = ((uint32_t)(input[40] & 0x7f) << 25) |
			((uint32_t)input[41] << 17) |
			((uint32_t)(input[42] & 0x80) << 9);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 337 to 352
	value = ((uint32_t)(input[42] & 0x7f) << 25) |
			((uint32_t)input[43] << 17) |
			((uint32_t)(input[44] & 0x80) << 9);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 353 to 368
	value = ((uint32_t)(input[44] & 0x7f) << 25) |
			((uint32_t)input[45] << 17) |
			((uint32_t)(input[46] & 0x80) << 9);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 369 to 384
	value = ((uint32_t)(input[46] & 0x7f) << 25) |
			((uint32_t)input[47] << 17) |
			((uint32_t)(input[48] & 0x80) << 9);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 385 to 400
	value = ((uint32_t)(input[48] & 0x7f) << 25) |
			((uint32_t)input[49] << 17) |
			((uint32_t)(input[50] & 0x80) << 9);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 401 to 416
	value = ((uint32_t)(input[50] & 0x7f) << 25) |
			((uint32_t)input[51] << 17) |
			((uint32_t)(input[52] & 0x80) << 9);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 417 to 432
	value = ((uint32_t)(input[52] & 0x7f) << 25) |
			((uint32_t)input[53] << 17) |
			((uint32_t)(input[54] & 0x80) << 9);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 433 to 448
	value = ((uint32_t)(input[54] & 0x7f) << 25) |
			((uint32_t)input[55] << 17) |
			((uint32_t)(input[56] & 0x80) << 9);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 449 to 464
	value = ((uint32_t)(input[56] & 0x7f) << 25) |
			((uint32_t)input[57] << 17) |
			((uint32_t)(input[58] & 0x80) << 9);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 465 to 480
	value = ((uint32_t)(input[58] & 0x7f) << 25) |
			((uint32_t)input[59] << 17) |
			((uint32_t)(input[60] & 0x80) << 9);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 481 to 496
	value = ((uint32_t)(input[60] & 0x7f) << 25) |
			((uint32_t)input[61] << 17) |
			((uint32_t)(input[62] & 0x80) << 9);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 497 to 512
	value = ((uint32_t)(input[62] & 0x7f) << 25) |
			((uint32_t)input[63] << 17) |
			((uint32_t)(input[64] & 0x80) << 9);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 513 to 528
	value = ((uint32_t)(input[64] & 0x7f) << 25) |
			((uint32_t)input[65] << 17) |
			((uint32_t)(input[66] & 0x80) << 9);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 529 to 544
	value = ((uint32_t)(input[66] & 0x7f) << 25) |
			((uint32_t)input[67] << 17) |
			((uint32_t)(input[68] & 0x80) << 9);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 545 to 560
	value = ((uint32_t)(input[68] & 0x7f) << 25) |
			((uint32_t)input[69] << 17) |
			((uint32_t)(input[70] & 0x80) << 9);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 561 to 576
	value = ((uint32_t)(input[70] & 0x7f) << 25) |
			((uint32_t)input[71] << 17) |
			((uint32_t)(input[72] & 0x80) << 9);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 577 to 592
	value = ((uint32_t)(input[72] & 0x7f) << 25) |
			((uint32_t)input[73] << 17) |
			((uint32_t)(input[74] & 0x80) << 9);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 593 to 608
	value = ((uint32_t)(input[74] & 0x7f) << 25) |
			((uint32_t)input[75] << 17) |
			((uint32_t)(input[76] & 0x80) << 9);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 609 to 624
	value = ((uint32_t)(input[76] & 0x7f) << 25) |
			((uint32_t)input[77] << 17) |
			((uint32_t)(input[78] & 0x80) << 9);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 625 to 640
	value = ((uint32_t)(input[78] & 0x7f) << 25) |
			((uint32_t)input[79] << 17) |
			((uint32_t)(input[80] & 0x80) << 9);
	output[39] = (double)(value >> 16);

	// read output[40]: from bit 641 to 656
	value = ((uint32_t)(input[80] & 0x7f) << 25) |
			((uint32_t)input[81] << 17) |
			((uint32_t)(input[82] & 0x80) << 9);
	output[40] = (double)(value >> 16);

	// read output[41]: from bit 657 to 672
	value = ((uint32_t)(input[82] & 0x7f) << 25) |
			((uint32_t)input[83] << 17) |
			((uint32_t)(input[84] & 0x80) << 9);
	output[41] = (double)(value >> 16);

	// read output[42]: from bit 673 to 688
	value = ((uint32_t)(input[84] & 0x7f) << 25) |
			((uint32_t)input[85] << 17) |
			((uint32_t)(input[86] & 0x80) << 9);
	output[42] = (double)(value >> 16);

	// read output[43]: from bit 689 to 704
	value = ((uint32_t)(input[86] & 0x7f) << 25) |
			((uint32_t)input[87] << 17) |
			((uint32_t)(input[88] & 0x80) << 9);
	output[43] = (double)(value >> 16);

	// read output[44]: from bit 705 to 720
	value = ((uint32_t)(input[88] & 0x7f) << 25) |
			((uint32_t)input[89] << 17) |
			((uint32_t)(input[90] & 0x80) << 9);
	output[44] = (double)(value >> 16);

	// read output[45]: from bit 721 to 736
	value = ((uint32_t)(input[90] & 0x7f) << 25) |
			((uint32_t)input[91] << 17) |
			((uint32_t)(input[92] & 0x80) << 9);
	output[45] = (double)(value >> 16);

	// read output[46]: from bit 737 to 752
	value = ((uint32_t)(input[92] & 0x7f) << 25) |
			((uint32_t)input[93] << 17) |
			((uint32_t)(input[94] & 0x80) << 9);
	output[46] = (double)(value >> 16);

	// read output[47]: from bit 753 to 768
	value = ((uint32_t)(input[94] & 0x7f) << 25) |
			((uint32_t)input[95] << 17) |
			((uint32_t)(input[96] & 0x80) << 9);
	output[47] = (double)(value >> 16);

	// read output[48]: from bit 769 to 784
	value = ((uint32_t)(input[96] & 0x7f) << 25) |
			((uint32_t)input[97] << 17) |
			((uint32_t)(input[98] & 0x80) << 9);
	output[48] = (double)(value >> 16);

	// read output[49]: from bit 785 to 800
	value = ((uint32_t)(input[98] & 0x7f) << 25) |
			((uint32_t)input[99] << 17) |
			((uint32_t)(input[100] & 0x80) << 9);
	output[49] = (double)(value >> 16);

	// read output[50]: from bit 801 to 816
	value = ((uint32_t)(input[100] & 0x7f) << 25) |
			((uint32_t)input[101] << 17) |
			((uint32_t)(input[102] & 0x80) << 9);
	output[50] = (double)(value >> 16);

	// read output[51]: from bit 817 to 832
	value = ((uint32_t)(input[102] & 0x7f) << 25) |
			((uint32_t)input[103] << 17) |
			((uint32_t)(input[104] & 0x80) << 9);
	output[51] = (double)(value >> 16);
}

static void unpack_52_16bit_signed_2off(const uint8_t * input, double * output, void *closure) {
	// Unpack 52 values into output
	// Values are 16-bit signed
	// Skip 2 bits, read 832 bits of data.
	// Input must be at least 105 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 2 to 17
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)input[1] << 18) |
			((uint32_t)(input[2] & 0xc0) << 10);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 18 to 33
	value = ((uint32_t)(input[2] & 0x3f) << 26) |
			((uint32_t)input[3] << 18) |
			((uint32_t)(input[4] & 0xc0) << 10);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 34 to 49
	value = ((uint32_t)(input[4] & 0x3f) << 26) |
			((uint32_t)input[5] << 18) |
			((uint32_t)(input[6] & 0xc0) << 10);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 50 to 65
	value = ((uint32_t)(input[6] & 0x3f) << 26) |
			((uint32_t)input[7] << 18) |
			((uint32_t)(input[8] & 0xc0) << 10);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 66 to 81
	value = ((uint32_t)(input[8] & 0x3f) << 26) |
			((uint32_t)input[9] << 18) |
			((uint32_t)(input[10] & 0xc0) << 10);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 82 to 97
	value = ((uint32_t)(input[10] & 0x3f) << 26) |
			((uint32_t)input[11] << 18) |
			((uint32_t)(input[12] & 0xc0) << 10);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 98 to 113
	value = ((uint32_t)(input[12] & 0x3f) << 26) |
			((uint32_t)input[13] << 18) |
			((uint32_t)(input[14] & 0xc0) << 10);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 114 to 129
	value = ((uint32_t)(input[14] & 0x3f) << 26) |
			((uint32_t)input[15] << 18) |
			((uint32_t)(input[16] & 0xc0) << 10);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 130 to 145
	value = ((uint32_t)(input[16] & 0x3f) << 26) |
			((uint32_t)input[17] << 18) |
			((uint32_t)(input[18] & 0xc0) << 10);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 146 to 161
	value = ((uint32_t)(input[18] & 0x3f) << 26) |
			((uint32_t)input[19] << 18) |
			((uint32_t)(input[20] & 0xc0) << 10);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 162 to 177
	value = ((uint32_t)(input[20] & 0x3f) << 26) |
			((uint32_t)input[21] << 18) |
			((uint32_t)(input[22] & 0xc0) << 10);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 178 to 193
	value = ((uint32_t)(input[22] & 0x3f) << 26) |
			((uint32_t)input[23] << 18) |
			((uint32_t)(input[24] & 0xc0) << 10);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 194 to 209
	value = ((uint32_t)(input[24] & 0x3f) << 26) |
			((uint32_t)input[25] << 18) |
			((uint32_t)(input[26] & 0xc0) << 10);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 210 to 225
	value = ((uint32_t)(input[26] & 0x3f) << 26) |
			((uint32_t)input[27] << 18) |
			((uint32_t)(input[28] & 0xc0) << 10);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 226 to 241
	value = ((uint32_t)(input[28] & 0x3f) << 26) |
			((uint32_t)input[29] << 18) |
			((uint32_t)(input[30] & 0xc0) << 10);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 242 to 257
	value = ((uint32_t)(input[30] & 0x3f) << 26) |
			((uint32_t)input[31] << 18) |
			((uint32_t)(input[32] & 0xc0) << 10);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 258 to 273
	value = ((uint32_t)(input[32] & 0x3f) << 26) |
			((uint32_t)input[33] << 18) |
			((uint32_t)(input[34] & 0xc0) << 10);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 274 to 289
	value = ((uint32_t)(input[34] & 0x3f) << 26) |
			((uint32_t)input[35] << 18) |
			((uint32_t)(input[36] & 0xc0) << 10);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 290 to 305
	value = ((uint32_t)(input[36] & 0x3f) << 26) |
			((uint32_t)input[37] << 18) |
			((uint32_t)(input[38] & 0xc0) << 10);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 306 to 321
	value = ((uint32_t)(input[38] & 0x3f) << 26) |
			((uint32_t)input[39] << 18) |
			((uint32_t)(input[40] & 0xc0) << 10);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 322 to 337
	value = ((uint32_t)(input[40] & 0x3f) << 26) |
			((uint32_t)input[41] << 18) |
			((uint32_t)(input[42] & 0xc0) << 10);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 338 to 353
	value = ((uint32_t)(input[42] & 0x3f) << 26) |
			((uint32_t)input[43] << 18) |
			((uint32_t)(input[44] & 0xc0) << 10);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 354 to 369
	value = ((uint32_t)(input[44] & 0x3f) << 26) |
			((uint32_t)input[45] << 18) |
			((uint32_t)(input[46] & 0xc0) << 10);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 370 to 385
	value = ((uint32_t)(input[46] & 0x3f) << 26) |
			((uint32_t)input[47] << 18) |
			((uint32_t)(input[48] & 0xc0) << 10);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 386 to 401
	value = ((uint32_t)(input[48] & 0x3f) << 26) |
			((uint32_t)input[49] << 18) |
			((uint32_t)(input[50] & 0xc0) << 10);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 402 to 417
	value = ((uint32_t)(input[50] & 0x3f) << 26) |
			((uint32_t)input[51] << 18) |
			((uint32_t)(input[52] & 0xc0) << 10);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 418 to 433
	value = ((uint32_t)(input[52] & 0x3f) << 26) |
			((uint32_t)input[53] << 18) |
			((uint32_t)(input[54] & 0xc0) << 10);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 434 to 449
	value = ((uint32_t)(input[54] & 0x3f) << 26) |
			((uint32_t)input[55] << 18) |
			((uint32_t)(input[56] & 0xc0) << 10);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 450 to 465
	value = ((uint32_t)(input[56] & 0x3f) << 26) |
			((uint32_t)input[57] << 18) |
			((uint32_t)(input[58] & 0xc0) << 10);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 466 to 481
	value = ((uint32_t)(input[58] & 0x3f) << 26) |
			((uint32_t)input[59] << 18) |
			((uint32_t)(input[60] & 0xc0) << 10);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 482 to 497
	value = ((uint32_t)(input[60] & 0x3f) << 26) |
			((uint32_t)input[61] << 18) |
			((uint32_t)(input[62] & 0xc0) << 10);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 498 to 513
	value = ((uint32_t)(input[62] & 0x3f) << 26) |
			((uint32_t)input[63] << 18) |
			((uint32_t)(input[64] & 0xc0) << 10);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 514 to 529
	value = ((uint32_t)(input[64] & 0x3f) << 26) |
			((uint32_t)input[65] << 18) |
			((uint32_t)(input[66] & 0xc0) << 10);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 530 to 545
	value = ((uint32_t)(input[66] & 0x3f) << 26) |
			((uint32_t)input[67] << 18) |
			((uint32_t)(input[68] & 0xc0) << 10);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 546 to 561
	value = ((uint32_t)(input[68] & 0x3f) << 26) |
			((uint32_t)input[69] << 18) |
			((uint32_t)(input[70] & 0xc0) << 10);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 562 to 577
	value = ((uint32_t)(input[70] & 0x3f) << 26) |
			((uint32_t)input[71] << 18) |
			((uint32_t)(input[72] & 0xc0) << 10);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 578 to 593
	value = ((uint32_t)(input[72] & 0x3f) << 26) |
			((uint32_t)input[73] << 18) |
			((uint32_t)(input[74] & 0xc0) << 10);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 594 to 609
	value = ((uint32_t)(input[74] & 0x3f) << 26) |
			((uint32_t)input[75] << 18) |
			((uint32_t)(input[76] & 0xc0) << 10);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 610 to 625
	value = ((uint32_t)(input[76] & 0x3f) << 26) |
			((uint32_t)input[77] << 18) |
			((uint32_t)(input[78] & 0xc0) << 10);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 626 to 641
	value = ((uint32_t)(input[78] & 0x3f) << 26) |
			((uint32_t)input[79] << 18) |
			((uint32_t)(input[80] & 0xc0) << 10);
	output[39] = (double)(value >> 16);

	// read output[40]: from bit 642 to 657
	value = ((uint32_t)(input[80] & 0x3f) << 26) |
			((uint32_t)input[81] << 18) |
			((uint32_t)(input[82] & 0xc0) << 10);
	output[40] = (double)(value >> 16);

	// read output[41]: from bit 658 to 673
	value = ((uint32_t)(input[82] & 0x3f) << 26) |
			((uint32_t)input[83] << 18) |
			((uint32_t)(input[84] & 0xc0) << 10);
	output[41] = (double)(value >> 16);

	// read output[42]: from bit 674 to 689
	value = ((uint32_t)(input[84] & 0x3f) << 26) |
			((uint32_t)input[85] << 18) |
			((uint32_t)(input[86] & 0xc0) << 10);
	output[42] = (double)(value >> 16);

	// read output[43]: from bit 690 to 705
	value = ((uint32_t)(input[86] & 0x3f) << 26) |
			((uint32_t)input[87] << 18) |
			((uint32_t)(input[88] & 0xc0) << 10);
	output[43] = (double)(value >> 16);

	// read output[44]: from bit 706 to 721
	value = ((uint32_t)(input[88] & 0x3f) << 26) |
			((uint32_t)input[89] << 18) |
			((uint32_t)(input[90] & 0xc0) << 10);
	output[44] = (double)(value >> 16);

	// read output[45]: from bit 722 to 737
	value = ((uint32_t)(input[90] & 0x3f) << 26) |
			((uint32_t)input[91] << 18) |
			((uint32_t)(input[92] & 0xc0) << 10);
	output[45] = (double)(value >> 16);

	// read output[46]: from bit 738 to 753
	value = ((uint32_t)(input[92] & 0x3f) << 26) |
			((uint32_t)input[93] << 18) |
			((uint32_t)(input[94] & 0xc0) << 10);
	output[46] = (double)(value >> 16);

	// read output[47]: from bit 754 to 769
	value = ((uint32_t)(input[94] & 0x3f) << 26) |
			((uint32_t)input[95] << 18) |
			((uint32_t)(input[96] & 0xc0) << 10);
	output[47] = (double)(value >> 16);

	// read output[48]: from bit 770 to 785
	value = ((uint32_t)(input[96] & 0x3f) << 26) |
			((uint32_t)input[97] << 18) |
			((uint32_t)(input[98] & 0xc0) << 10);
	output[48] = (double)(value >> 16);

	// read output[49]: from bit 786 to 801
	value = ((uint32_t)(input[98] & 0x3f) << 26) |
			((uint32_t)input[99] << 18) |
			((uint32_t)(input[100] & 0xc0) << 10);
	output[49] = (double)(value >> 16);

	// read output[50]: from bit 802 to 817
	value = ((uint32_t)(input[100] & 0x3f) << 26) |
			((uint32_t)input[101] << 18) |
			((uint32_t)(input[102] & 0xc0) << 10);
	output[50] = (double)(value >> 16);

	// read output[51]: from bit 818 to 833
	value = ((uint32_t)(input[102] & 0x3f) << 26) |
			((uint32_t)input[103] << 18) |
			((uint32_t)(input[104] & 0xc0) << 10);
	output[51] = (double)(value >> 16);
}

static void unpack_52_16bit_unsigned_2off(const uint8_t * input, double * output, void *closure) {
	// Unpack 52 values into output
	// Values are 16-bit unsigned
	// Skip 2 bits, read 832 bits of data.
	// Input must be at least 105 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 2 to 17
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)input[1] << 18) |
			((uint32_t)(input[2] & 0xc0) << 10);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 18 to 33
	value = ((uint32_t)(input[2] & 0x3f) << 26) |
			((uint32_t)input[3] << 18) |
			((uint32_t)(input[4] & 0xc0) << 10);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 34 to 49
	value = ((uint32_t)(input[4] & 0x3f) << 26) |
			((uint32_t)input[5] << 18) |
			((uint32_t)(input[6] & 0xc0) << 10);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 50 to 65
	value = ((uint32_t)(input[6] & 0x3f) << 26) |
			((uint32_t)input[7] << 18) |
			((uint32_t)(input[8] & 0xc0) << 10);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 66 to 81
	value = ((uint32_t)(input[8] & 0x3f) << 26) |
			((uint32_t)input[9] << 18) |
			((uint32_t)(input[10] & 0xc0) << 10);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 82 to 97
	value = ((uint32_t)(input[10] & 0x3f) << 26) |
			((uint32_t)input[11] << 18) |
			((uint32_t)(input[12] & 0xc0) << 10);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 98 to 113
	value = ((uint32_t)(input[12] & 0x3f) << 26) |
			((uint32_t)input[13] << 18) |
			((uint32_t)(input[14] & 0xc0) << 10);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 114 to 129
	value = ((uint32_t)(input[14] & 0x3f) << 26) |
			((uint32_t)input[15] << 18) |
			((uint32_t)(input[16] & 0xc0) << 10);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 130 to 145
	value = ((uint32_t)(input[16] & 0x3f) << 26) |
			((uint32_t)input[17] << 18) |
			((uint32_t)(input[18] & 0xc0) << 10);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 146 to 161
	value = ((uint32_t)(input[18] & 0x3f) << 26) |
			((uint32_t)input[19] << 18) |
			((uint32_t)(input[20] & 0xc0) << 10);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 162 to 177
	value = ((uint32_t)(input[20] & 0x3f) << 26) |
			((uint32_t)input[21] << 18) |
			((uint32_t)(input[22] & 0xc0) << 10);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 178 to 193
	value = ((uint32_t)(input[22] & 0x3f) << 26) |
			((uint32_t)input[23] << 18) |
			((uint32_t)(input[24] & 0xc0) << 10);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 194 to 209
	value = ((uint32_t)(input[24] & 0x3f) << 26) |
			((uint32_t)input[25] << 18) |
			((uint32_t)(input[26] & 0xc0) << 10);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 210 to 225
	value = ((uint32_t)(input[26] & 0x3f) << 26) |
			((uint32_t)input[27] << 18) |
			((uint32_t)(input[28] & 0xc0) << 10);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 226 to 241
	value = ((uint32_t)(input[28] & 0x3f) << 26) |
			((uint32_t)input[29] << 18) |
			((uint32_t)(input[30] & 0xc0) << 10);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 242 to 257
	value = ((uint32_t)(input[30] & 0x3f) << 26) |
			((uint32_t)input[31] << 18) |
			((uint32_t)(input[32] & 0xc0) << 10);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 258 to 273
	value = ((uint32_t)(input[32] & 0x3f) << 26) |
			((uint32_t)input[33] << 18) |
			((uint32_t)(input[34] & 0xc0) << 10);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 274 to 289
	value = ((uint32_t)(input[34] & 0x3f) << 26) |
			((uint32_t)input[35] << 18) |
			((uint32_t)(input[36] & 0xc0) << 10);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 290 to 305
	value = ((uint32_t)(input[36] & 0x3f) << 26) |
			((uint32_t)input[37] << 18) |
			((uint32_t)(input[38] & 0xc0) << 10);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 306 to 321
	value = ((uint32_t)(input[38] & 0x3f) << 26) |
			((uint32_t)input[39] << 18) |
			((uint32_t)(input[40] & 0xc0) << 10);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 322 to 337
	value = ((uint32_t)(input[40] & 0x3f) << 26) |
			((uint32_t)input[41] << 18) |
			((uint32_t)(input[42] & 0xc0) << 10);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 338 to 353
	value = ((uint32_t)(input[42] & 0x3f) << 26) |
			((uint32_t)input[43] << 18) |
			((uint32_t)(input[44] & 0xc0) << 10);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 354 to 369
	value = ((uint32_t)(input[44] & 0x3f) << 26) |
			((uint32_t)input[45] << 18) |
			((uint32_t)(input[46] & 0xc0) << 10);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 370 to 385
	value = ((uint32_t)(input[46] & 0x3f) << 26) |
			((uint32_t)input[47] << 18) |
			((uint32_t)(input[48] & 0xc0) << 10);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 386 to 401
	value = ((uint32_t)(input[48] & 0x3f) << 26) |
			((uint32_t)input[49] << 18) |
			((uint32_t)(input[50] & 0xc0) << 10);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 402 to 417
	value = ((uint32_t)(input[50] & 0x3f) << 26) |
			((uint32_t)input[51] << 18) |
			((uint32_t)(input[52] & 0xc0) << 10);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 418 to 433
	value = ((uint32_t)(input[52] & 0x3f) << 26) |
			((uint32_t)input[53] << 18) |
			((uint32_t)(input[54] & 0xc0) << 10);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 434 to 449
	value = ((uint32_t)(input[54] & 0x3f) << 26) |
			((uint32_t)input[55] << 18) |
			((uint32_t)(input[56] & 0xc0) << 10);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 450 to 465
	value = ((uint32_t)(input[56] & 0x3f) << 26) |
			((uint32_t)input[57] << 18) |
			((uint32_t)(input[58] & 0xc0) << 10);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 466 to 481
	value = ((uint32_t)(input[58] & 0x3f) << 26) |
			((uint32_t)input[59] << 18) |
			((uint32_t)(input[60] & 0xc0) << 10);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 482 to 497
	value = ((uint32_t)(input[60] & 0x3f) << 26) |
			((uint32_t)input[61] << 18) |
			((uint32_t)(input[62] & 0xc0) << 10);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 498 to 513
	value = ((uint32_t)(input[62] & 0x3f) << 26) |
			((uint32_t)input[63] << 18) |
			((uint32_t)(input[64] & 0xc0) << 10);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 514 to 529
	value = ((uint32_t)(input[64] & 0x3f) << 26) |
			((uint32_t)input[65] << 18) |
			((uint32_t)(input[66] & 0xc0) << 10);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 530 to 545
	value = ((uint32_t)(input[66] & 0x3f) << 26) |
			((uint32_t)input[67] << 18) |
			((uint32_t)(input[68] & 0xc0) << 10);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 546 to 561
	value = ((uint32_t)(input[68] & 0x3f) << 26) |
			((uint32_t)input[69] << 18) |
			((uint32_t)(input[70] & 0xc0) << 10);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 562 to 577
	value = ((uint32_t)(input[70] & 0x3f) << 26) |
			((uint32_t)input[71] << 18) |
			((uint32_t)(input[72] & 0xc0) << 10);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 578 to 593
	value = ((uint32_t)(input[72] & 0x3f) << 26) |
			((uint32_t)input[73] << 18) |
			((uint32_t)(input[74] & 0xc0) << 10);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 594 to 609
	value = ((uint32_t)(input[74] & 0x3f) << 26) |
			((uint32_t)input[75] << 18) |
			((uint32_t)(input[76] & 0xc0) << 10);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 610 to 625
	value = ((uint32_t)(input[76] & 0x3f) << 26) |
			((uint32_t)input[77] << 18) |
			((uint32_t)(input[78] & 0xc0) << 10);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 626 to 641
	value = ((uint32_t)(input[78] & 0x3f) << 26) |
			((uint32_t)input[79] << 18) |
			((uint32_t)(input[80] & 0xc0) << 10);
	output[39] = (double)(value >> 16);

	// read output[40]: from bit 642 to 657
	value = ((uint32_t)(input[80] & 0x3f) << 26) |
			((uint32_t)input[81] << 18) |
			((uint32_t)(input[82] & 0xc0) << 10);
	output[40] = (double)(value >> 16);

	// read output[41]: from bit 658 to 673
	value = ((uint32_t)(input[82] & 0x3f) << 26) |
			((uint32_t)input[83] << 18) |
			((uint32_t)(input[84] & 0xc0) << 10);
	output[41] = (double)(value >> 16);

	// read output[42]: from bit 674 to 689
	value = ((uint32_t)(input[84] & 0x3f) << 26) |
			((uint32_t)input[85] << 18) |
			((uint32_t)(input[86] & 0xc0) << 10);
	output[42] = (double)(value >> 16);

	// read output[43]: from bit 690 to 705
	value = ((uint32_t)(input[86] & 0x3f) << 26) |
			((uint32_t)input[87] << 18) |
			((uint32_t)(input[88] & 0xc0) << 10);
	output[43] = (double)(value >> 16);

	// read output[44]: from bit 706 to 721
	value = ((uint32_t)(input[88] & 0x3f) << 26) |
			((uint32_t)input[89] << 18) |
			((uint32_t)(input[90] & 0xc0) << 10);
	output[44] = (double)(value >> 16);

	// read output[45]: from bit 722 to 737
	value = ((uint32_t)(input[90] & 0x3f) << 26) |
			((uint32_t)input[91] << 18) |
			((uint32_t)(input[92] & 0xc0) << 10);
	output[45] = (double)(value >> 16);

	// read output[46]: from bit 738 to 753
	value = ((uint32_t)(input[92] & 0x3f) << 26) |
			((uint32_t)input[93] << 18) |
			((uint32_t)(input[94] & 0xc0) << 10);
	output[46] = (double)(value >> 16);

	// read output[47]: from bit 754 to 769
	value = ((uint32_t)(input[94] & 0x3f) << 26) |
			((uint32_t)input[95] << 18) |
			((uint32_t)(input[96] & 0xc0) << 10);
	output[47] = (double)(value >> 16);

	// read output[48]: from bit 770 to 785
	value = ((uint32_t)(input[96] & 0x3f) << 26) |
			((uint32_t)input[97] << 18) |
			((uint32_t)(input[98] & 0xc0) << 10);
	output[48] = (double)(value >> 16);

	// read output[49]: from bit 786 to 801
	value = ((uint32_t)(input[98] & 0x3f) << 26) |
			((uint32_t)input[99] << 18) |
			((uint32_t)(input[100] & 0xc0) << 10);
	output[49] = (double)(value >> 16);

	// read output[50]: from bit 802 to 817
	value = ((uint32_t)(input[100] & 0x3f) << 26) |
			((uint32_t)input[101] << 18) |
			((uint32_t)(input[102] & 0xc0) << 10);
	output[50] = (double)(value >> 16);

	// read output[51]: from bit 818 to 833
	value = ((uint32_t)(input[102] & 0x3f) << 26) |
			((uint32_t)input[103] << 18) |
			((uint32_t)(input[104] & 0xc0) << 10);
	output[51] = (double)(value >> 16);
}

static void unpack_52_16bit_signed_3off(const uint8_t * input, double * output, void *closure) {
	// Unpack 52 values into output
	// Values are 16-bit signed
	// Skip 3 bits, read 832 bits of data.
	// Input must be at least 105 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 3 to 18
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)input[1] << 19) |
			((uint32_t)(input[2] & 0xe0) << 11);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 19 to 34
	value = ((uint32_t)(input[2] & 0x1f) << 27) |
			((uint32_t)input[3] << 19) |
			((uint32_t)(input[4] & 0xe0) << 11);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 35 to 50
	value = ((uint32_t)(input[4] & 0x1f) << 27) |
			((uint32_t)input[5] << 19) |
			((uint32_t)(input[6] & 0xe0) << 11);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 51 to 66
	value = ((uint32_t)(input[6] & 0x1f) << 27) |
			((uint32_t)input[7] << 19) |
			((uint32_t)(input[8] & 0xe0) << 11);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 67 to 82
	value = ((uint32_t)(input[8] & 0x1f) << 27) |
			((uint32_t)input[9] << 19) |
			((uint32_t)(input[10] & 0xe0) << 11);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 83 to 98
	value = ((uint32_t)(input[10] & 0x1f) << 27) |
			((uint32_t)input[11] << 19) |
			((uint32_t)(input[12] & 0xe0) << 11);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 99 to 114
	value = ((uint32_t)(input[12] & 0x1f) << 27) |
			((uint32_t)input[13] << 19) |
			((uint32_t)(input[14] & 0xe0) << 11);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 115 to 130
	value = ((uint32_t)(input[14] & 0x1f) << 27) |
			((uint32_t)input[15] << 19) |
			((uint32_t)(input[16] & 0xe0) << 11);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 131 to 146
	value = ((uint32_t)(input[16] & 0x1f) << 27) |
			((uint32_t)input[17] << 19) |
			((uint32_t)(input[18] & 0xe0) << 11);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 147 to 162
	value = ((uint32_t)(input[18] & 0x1f) << 27) |
			((uint32_t)input[19] << 19) |
			((uint32_t)(input[20] & 0xe0) << 11);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 163 to 178
	value = ((uint32_t)(input[20] & 0x1f) << 27) |
			((uint32_t)input[21] << 19) |
			((uint32_t)(input[22] & 0xe0) << 11);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 179 to 194
	value = ((uint32_t)(input[22] & 0x1f) << 27) |
			((uint32_t)input[23] << 19) |
			((uint32_t)(input[24] & 0xe0) << 11);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 195 to 210
	value = ((uint32_t)(input[24] & 0x1f) << 27) |
			((uint32_t)input[25] << 19) |
			((uint32_t)(input[26] & 0xe0) << 11);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 211 to 226
	value = ((uint32_t)(input[26] & 0x1f) << 27) |
			((uint32_t)input[27] << 19) |
			((uint32_t)(input[28] & 0xe0) << 11);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 227 to 242
	value = ((uint32_t)(input[28] & 0x1f) << 27) |
			((uint32_t)input[29] << 19) |
			((uint32_t)(input[30] & 0xe0) << 11);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 243 to 258
	value = ((uint32_t)(input[30] & 0x1f) << 27) |
			((uint32_t)input[31] << 19) |
			((uint32_t)(input[32] & 0xe0) << 11);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 259 to 274
	value = ((uint32_t)(input[32] & 0x1f) << 27) |
			((uint32_t)input[33] << 19) |
			((uint32_t)(input[34] & 0xe0) << 11);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 275 to 290
	value = ((uint32_t)(input[34] & 0x1f) << 27) |
			((uint32_t)input[35] << 19) |
			((uint32_t)(input[36] & 0xe0) << 11);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 291 to 306
	value = ((uint32_t)(input[36] & 0x1f) << 27) |
			((uint32_t)input[37] << 19) |
			((uint32_t)(input[38] & 0xe0) << 11);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 307 to 322
	value = ((uint32_t)(input[38] & 0x1f) << 27) |
			((uint32_t)input[39] << 19) |
			((uint32_t)(input[40] & 0xe0) << 11);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 323 to 338
	value = ((uint32_t)(input[40] & 0x1f) << 27) |
			((uint32_t)input[41] << 19) |
			((uint32_t)(input[42] & 0xe0) << 11);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 339 to 354
	value = ((uint32_t)(input[42] & 0x1f) << 27) |
			((uint32_t)input[43] << 19) |
			((uint32_t)(input[44] & 0xe0) << 11);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 355 to 370
	value = ((uint32_t)(input[44] & 0x1f) << 27) |
			((uint32_t)input[45] << 19) |
			((uint32_t)(input[46] & 0xe0) << 11);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 371 to 386
	value = ((uint32_t)(input[46] & 0x1f) << 27) |
			((uint32_t)input[47] << 19) |
			((uint32_t)(input[48] & 0xe0) << 11);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 387 to 402
	value = ((uint32_t)(input[48] & 0x1f) << 27) |
			((uint32_t)input[49] << 19) |
			((uint32_t)(input[50] & 0xe0) << 11);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 403 to 418
	value = ((uint32_t)(input[50] & 0x1f) << 27) |
			((uint32_t)input[51] << 19) |
			((uint32_t)(input[52] & 0xe0) << 11);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 419 to 434
	value = ((uint32_t)(input[52] & 0x1f) << 27) |
			((uint32_t)input[53] << 19) |
			((uint32_t)(input[54] & 0xe0) << 11);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 435 to 450
	value = ((uint32_t)(input[54] & 0x1f) << 27) |
			((uint32_t)input[55] << 19) |
			((uint32_t)(input[56] & 0xe0) << 11);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 451 to 466
	value = ((uint32_t)(input[56] & 0x1f) << 27) |
			((uint32_t)input[57] << 19) |
			((uint32_t)(input[58] & 0xe0) << 11);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 467 to 482
	value = ((uint32_t)(input[58] & 0x1f) << 27) |
			((uint32_t)input[59] << 19) |
			((uint32_t)(input[60] & 0xe0) << 11);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 483 to 498
	value = ((uint32_t)(input[60] & 0x1f) << 27) |
			((uint32_t)input[61] << 19) |
			((uint32_t)(input[62] & 0xe0) << 11);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 499 to 514
	value = ((uint32_t)(input[62] & 0x1f) << 27) |
			((uint32_t)input[63] << 19) |
			((uint32_t)(input[64] & 0xe0) << 11);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 515 to 530
	value = ((uint32_t)(input[64] & 0x1f) << 27) |
			((uint32_t)input[65] << 19) |
			((uint32_t)(input[66] & 0xe0) << 11);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 531 to 546
	value = ((uint32_t)(input[66] & 0x1f) << 27) |
			((uint32_t)input[67] << 19) |
			((uint32_t)(input[68] & 0xe0) << 11);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 547 to 562
	value = ((uint32_t)(input[68] & 0x1f) << 27) |
			((uint32_t)input[69] << 19) |
			((uint32_t)(input[70] & 0xe0) << 11);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 563 to 578
	value = ((uint32_t)(input[70] & 0x1f) << 27) |
			((uint32_t)input[71] << 19) |
			((uint32_t)(input[72] & 0xe0) << 11);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 579 to 594
	value = ((uint32_t)(input[72] & 0x1f) << 27) |
			((uint32_t)input[73] << 19) |
			((uint32_t)(input[74] & 0xe0) << 11);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 595 to 610
	value = ((uint32_t)(input[74] & 0x1f) << 27) |
			((uint32_t)input[75] << 19) |
			((uint32_t)(input[76] & 0xe0) << 11);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 611 to 626
	value = ((uint32_t)(input[76] & 0x1f) << 27) |
			((uint32_t)input[77] << 19) |
			((uint32_t)(input[78] & 0xe0) << 11);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 627 to 642
	value = ((uint32_t)(input[78] & 0x1f) << 27) |
			((uint32_t)input[79] << 19) |
			((uint32_t)(input[80] & 0xe0) << 11);
	output[39] = (double)(value >> 16);

	// read output[40]: from bit 643 to 658
	value = ((uint32_t)(input[80] & 0x1f) << 27) |
			((uint32_t)input[81] << 19) |
			((uint32_t)(input[82] & 0xe0) << 11);
	output[40] = (double)(value >> 16);

	// read output[41]: from bit 659 to 674
	value = ((uint32_t)(input[82] & 0x1f) << 27) |
			((uint32_t)input[83] << 19) |
			((uint32_t)(input[84] & 0xe0) << 11);
	output[41] = (double)(value >> 16);

	// read output[42]: from bit 675 to 690
	value = ((uint32_t)(input[84] & 0x1f) << 27) |
			((uint32_t)input[85] << 19) |
			((uint32_t)(input[86] & 0xe0) << 11);
	output[42] = (double)(value >> 16);

	// read output[43]: from bit 691 to 706
	value = ((uint32_t)(input[86] & 0x1f) << 27) |
			((uint32_t)input[87] << 19) |
			((uint32_t)(input[88] & 0xe0) << 11);
	output[43] = (double)(value >> 16);

	// read output[44]: from bit 707 to 722
	value = ((uint32_t)(input[88] & 0x1f) << 27) |
			((uint32_t)input[89] << 19) |
			((uint32_t)(input[90] & 0xe0) << 11);
	output[44] = (double)(value >> 16);

	// read output[45]: from bit 723 to 738
	value = ((uint32_t)(input[90] & 0x1f) << 27) |
			((uint32_t)input[91] << 19) |
			((uint32_t)(input[92] & 0xe0) << 11);
	output[45] = (double)(value >> 16);

	// read output[46]: from bit 739 to 754
	value = ((uint32_t)(input[92] & 0x1f) << 27) |
			((uint32_t)input[93] << 19) |
			((uint32_t)(input[94] & 0xe0) << 11);
	output[46] = (double)(value >> 16);

	// read output[47]: from bit 755 to 770
	value = ((uint32_t)(input[94] & 0x1f) << 27) |
			((uint32_t)input[95] << 19) |
			((uint32_t)(input[96] & 0xe0) << 11);
	output[47] = (double)(value >> 16);

	// read output[48]: from bit 771 to 786
	value = ((uint32_t)(input[96] & 0x1f) << 27) |
			((uint32_t)input[97] << 19) |
			((uint32_t)(input[98] & 0xe0) << 11);
	output[48] = (double)(value >> 16);

	// read output[49]: from bit 787 to 802
	value = ((uint32_t)(input[98] & 0x1f) << 27) |
			((uint32_t)input[99] << 19) |
			((uint32_t)(input[100] & 0xe0) << 11);
	output[49] = (double)(value >> 16);

	// read output[50]: from bit 803 to 818
	value = ((uint32_t)(input[100] & 0x1f) << 27) |
			((uint32_t)input[101] << 19) |
			((uint32_t)(input[102] & 0xe0) << 11);
	output[50] = (double)(value >> 16);

	// read output[51]: from bit 819 to 834
	value = ((uint32_t)(input[102] & 0x1f) << 27) |
			((uint32_t)input[103] << 19) |
			((uint32_t)(input[104] & 0xe0) << 11);
	output[51] = (double)(value >> 16);
}

static void unpack_52_16bit_unsigned_3off(const uint8_t * input, double * output, void *closure) {
	// Unpack 52 values into output
	// Values are 16-bit unsigned
	// Skip 3 bits, read 832 bits of data.
	// Input must be at least 105 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 3 to 18
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)input[1] << 19) |
			((uint32_t)(input[2] & 0xe0) << 11);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 19 to 34
	value = ((uint32_t)(input[2] & 0x1f) << 27) |
			((uint32_t)input[3] << 19) |
			((uint32_t)(input[4] & 0xe0) << 11);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 35 to 50
	value = ((uint32_t)(input[4] & 0x1f) << 27) |
			((uint32_t)input[5] << 19) |
			((uint32_t)(input[6] & 0xe0) << 11);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 51 to 66
	value = ((uint32_t)(input[6] & 0x1f) << 27) |
			((uint32_t)input[7] << 19) |
			((uint32_t)(input[8] & 0xe0) << 11);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 67 to 82
	value = ((uint32_t)(input[8] & 0x1f) << 27) |
			((uint32_t)input[9] << 19) |
			((uint32_t)(input[10] & 0xe0) << 11);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 83 to 98
	value = ((uint32_t)(input[10] & 0x1f) << 27) |
			((uint32_t)input[11] << 19) |
			((uint32_t)(input[12] & 0xe0) << 11);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 99 to 114
	value = ((uint32_t)(input[12] & 0x1f) << 27) |
			((uint32_t)input[13] << 19) |
			((uint32_t)(input[14] & 0xe0) << 11);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 115 to 130
	value = ((uint32_t)(input[14] & 0x1f) << 27) |
			((uint32_t)input[15] << 19) |
			((uint32_t)(input[16] & 0xe0) << 11);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 131 to 146
	value = ((uint32_t)(input[16] & 0x1f) << 27) |
			((uint32_t)input[17] << 19) |
			((uint32_t)(input[18] & 0xe0) << 11);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 147 to 162
	value = ((uint32_t)(input[18] & 0x1f) << 27) |
			((uint32_t)input[19] << 19) |
			((uint32_t)(input[20] & 0xe0) << 11);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 163 to 178
	value = ((uint32_t)(input[20] & 0x1f) << 27) |
			((uint32_t)input[21] << 19) |
			((uint32_t)(input[22] & 0xe0) << 11);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 179 to 194
	value = ((uint32_t)(input[22] & 0x1f) << 27) |
			((uint32_t)input[23] << 19) |
			((uint32_t)(input[24] & 0xe0) << 11);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 195 to 210
	value = ((uint32_t)(input[24] & 0x1f) << 27) |
			((uint32_t)input[25] << 19) |
			((uint32_t)(input[26] & 0xe0) << 11);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 211 to 226
	value = ((uint32_t)(input[26] & 0x1f) << 27) |
			((uint32_t)input[27] << 19) |
			((uint32_t)(input[28] & 0xe0) << 11);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 227 to 242
	value = ((uint32_t)(input[28] & 0x1f) << 27) |
			((uint32_t)input[29] << 19) |
			((uint32_t)(input[30] & 0xe0) << 11);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 243 to 258
	value = ((uint32_t)(input[30] & 0x1f) << 27) |
			((uint32_t)input[31] << 19) |
			((uint32_t)(input[32] & 0xe0) << 11);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 259 to 274
	value = ((uint32_t)(input[32] & 0x1f) << 27) |
			((uint32_t)input[33] << 19) |
			((uint32_t)(input[34] & 0xe0) << 11);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 275 to 290
	value = ((uint32_t)(input[34] & 0x1f) << 27) |
			((uint32_t)input[35] << 19) |
			((uint32_t)(input[36] & 0xe0) << 11);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 291 to 306
	value = ((uint32_t)(input[36] & 0x1f) << 27) |
			((uint32_t)input[37] << 19) |
			((uint32_t)(input[38] & 0xe0) << 11);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 307 to 322
	value = ((uint32_t)(input[38] & 0x1f) << 27) |
			((uint32_t)input[39] << 19) |
			((uint32_t)(input[40] & 0xe0) << 11);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 323 to 338
	value = ((uint32_t)(input[40] & 0x1f) << 27) |
			((uint32_t)input[41] << 19) |
			((uint32_t)(input[42] & 0xe0) << 11);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 339 to 354
	value = ((uint32_t)(input[42] & 0x1f) << 27) |
			((uint32_t)input[43] << 19) |
			((uint32_t)(input[44] & 0xe0) << 11);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 355 to 370
	value = ((uint32_t)(input[44] & 0x1f) << 27) |
			((uint32_t)input[45] << 19) |
			((uint32_t)(input[46] & 0xe0) << 11);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 371 to 386
	value = ((uint32_t)(input[46] & 0x1f) << 27) |
			((uint32_t)input[47] << 19) |
			((uint32_t)(input[48] & 0xe0) << 11);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 387 to 402
	value = ((uint32_t)(input[48] & 0x1f) << 27) |
			((uint32_t)input[49] << 19) |
			((uint32_t)(input[50] & 0xe0) << 11);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 403 to 418
	value = ((uint32_t)(input[50] & 0x1f) << 27) |
			((uint32_t)input[51] << 19) |
			((uint32_t)(input[52] & 0xe0) << 11);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 419 to 434
	value = ((uint32_t)(input[52] & 0x1f) << 27) |
			((uint32_t)input[53] << 19) |
			((uint32_t)(input[54] & 0xe0) << 11);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 435 to 450
	value = ((uint32_t)(input[54] & 0x1f) << 27) |
			((uint32_t)input[55] << 19) |
			((uint32_t)(input[56] & 0xe0) << 11);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 451 to 466
	value = ((uint32_t)(input[56] & 0x1f) << 27) |
			((uint32_t)input[57] << 19) |
			((uint32_t)(input[58] & 0xe0) << 11);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 467 to 482
	value = ((uint32_t)(input[58] & 0x1f) << 27) |
			((uint32_t)input[59] << 19) |
			((uint32_t)(input[60] & 0xe0) << 11);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 483 to 498
	value = ((uint32_t)(input[60] & 0x1f) << 27) |
			((uint32_t)input[61] << 19) |
			((uint32_t)(input[62] & 0xe0) << 11);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 499 to 514
	value = ((uint32_t)(input[62] & 0x1f) << 27) |
			((uint32_t)input[63] << 19) |
			((uint32_t)(input[64] & 0xe0) << 11);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 515 to 530
	value = ((uint32_t)(input[64] & 0x1f) << 27) |
			((uint32_t)input[65] << 19) |
			((uint32_t)(input[66] & 0xe0) << 11);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 531 to 546
	value = ((uint32_t)(input[66] & 0x1f) << 27) |
			((uint32_t)input[67] << 19) |
			((uint32_t)(input[68] & 0xe0) << 11);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 547 to 562
	value = ((uint32_t)(input[68] & 0x1f) << 27) |
			((uint32_t)input[69] << 19) |
			((uint32_t)(input[70] & 0xe0) << 11);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 563 to 578
	value = ((uint32_t)(input[70] & 0x1f) << 27) |
			((uint32_t)input[71] << 19) |
			((uint32_t)(input[72] & 0xe0) << 11);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 579 to 594
	value = ((uint32_t)(input[72] & 0x1f) << 27) |
			((uint32_t)input[73] << 19) |
			((uint32_t)(input[74] & 0xe0) << 11);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 595 to 610
	value = ((uint32_t)(input[74] & 0x1f) << 27) |
			((uint32_t)input[75] << 19) |
			((uint32_t)(input[76] & 0xe0) << 11);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 611 to 626
	value = ((uint32_t)(input[76] & 0x1f) << 27) |
			((uint32_t)input[77] << 19) |
			((uint32_t)(input[78] & 0xe0) << 11);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 627 to 642
	value = ((uint32_t)(input[78] & 0x1f) << 27) |
			((uint32_t)input[79] << 19) |
			((uint32_t)(input[80] & 0xe0) << 11);
	output[39] = (double)(value >> 16);

	// read output[40]: from bit 643 to 658
	value = ((uint32_t)(input[80] & 0x1f) << 27) |
			((uint32_t)input[81] << 19) |
			((uint32_t)(input[82] & 0xe0) << 11);
	output[40] = (double)(value >> 16);

	// read output[41]: from bit 659 to 674
	value = ((uint32_t)(input[82] & 0x1f) << 27) |
			((uint32_t)input[83] << 19) |
			((uint32_t)(input[84] & 0xe0) << 11);
	output[41] = (double)(value >> 16);

	// read output[42]: from bit 675 to 690
	value = ((uint32_t)(input[84] & 0x1f) << 27) |
			((uint32_t)input[85] << 19) |
			((uint32_t)(input[86] & 0xe0) << 11);
	output[42] = (double)(value >> 16);

	// read output[43]: from bit 691 to 706
	value = ((uint32_t)(input[86] & 0x1f) << 27) |
			((uint32_t)input[87] << 19) |
			((uint32_t)(input[88] & 0xe0) << 11);
	output[43] = (double)(value >> 16);

	// read output[44]: from bit 707 to 722
	value = ((uint32_t)(input[88] & 0x1f) << 27) |
			((uint32_t)input[89] << 19) |
			((uint32_t)(input[90] & 0xe0) << 11);
	output[44] = (double)(value >> 16);

	// read output[45]: from bit 723 to 738
	value = ((uint32_t)(input[90] & 0x1f) << 27) |
			((uint32_t)input[91] << 19) |
			((uint32_t)(input[92] & 0xe0) << 11);
	output[45] = (double)(value >> 16);

	// read output[46]: from bit 739 to 754
	value = ((uint32_t)(input[92] & 0x1f) << 27) |
			((uint32_t)input[93] << 19) |
			((uint32_t)(input[94] & 0xe0) << 11);
	output[46] = (double)(value >> 16);

	// read output[47]: from bit 755 to 770
	value = ((uint32_t)(input[94] & 0x1f) << 27) |
			((uint32_t)input[95] << 19) |
			((uint32_t)(input[96] & 0xe0) << 11);
	output[47] = (double)(value >> 16);

	// read output[48]: from bit 771 to 786
	value = ((uint32_t)(input[96] & 0x1f) << 27) |
			((uint32_t)input[97] << 19) |
			((uint32_t)(input[98] & 0xe0) << 11);
	output[48] = (double)(value >> 16);

	// read output[49]: from bit 787 to 802
	value = ((uint32_t)(input[98] & 0x1f) << 27) |
			((uint32_t)input[99] << 19) |
			((uint32_t)(input[100] & 0xe0) << 11);
	output[49] = (double)(value >> 16);

	// read output[50]: from bit 803 to 818
	value = ((uint32_t)(input[100] & 0x1f) << 27) |
			((uint32_t)input[101] << 19) |
			((uint32_t)(input[102] & 0xe0) << 11);
	output[50] = (double)(value >> 16);

	// read output[51]: from bit 819 to 834
	value = ((uint32_t)(input[102] & 0x1f) << 27) |
			((uint32_t)input[103] << 19) |
			((uint32_t)(input[104] & 0xe0) << 11);
	output[51] = (double)(value >> 16);
}

static void unpack_52_16bit_signed_4off(const uint8_t * input, double * output, void *closure) {
	// Unpack 52 values into output
	// Values are 16-bit signed
	// Skip 4 bits, read 832 bits of data.
	// Input must be at least 105 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 4 to 19
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20) |
			((uint32_t)(input[2] & 0xf0) << 12);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 20 to 35
	value = ((uint32_t)(input[2] & 0x0f) << 28) |
			((uint32_t)input[3] << 20) |
			((uint32_t)(input[4] & 0xf0) << 12);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 36 to 51
	value = ((uint32_t)(input[4] & 0x0f) << 28) |
			((uint32_t)input[5] << 20) |
			((uint32_t)(input[6] & 0xf0) << 12);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 52 to 67
	value = ((uint32_t)(input[6] & 0x0f) << 28) |
			((uint32_t)input[7] << 20) |
			((uint32_t)(input[8] & 0xf0) << 12);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 68 to 83
	value = ((uint32_t)(input[8] & 0x0f) << 28) |
			((uint32_t)input[9] << 20) |
			((uint32_t)(input[10] & 0xf0) << 12);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 84 to 99
	value = ((uint32_t)(input[10] & 0x0f) << 28) |
			((uint32_t)input[11] << 20) |
			((uint32_t)(input[12] & 0xf0) << 12);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 100 to 115
	value = ((uint32_t)(input[12] & 0x0f) << 28) |
			((uint32_t)input[13] << 20) |
			((uint32_t)(input[14] & 0xf0) << 12);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 116 to 131
	value = ((uint32_t)(input[14] & 0x0f) << 28) |
			((uint32_t)input[15] << 20) |
			((uint32_t)(input[16] & 0xf0) << 12);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 132 to 147
	value = ((uint32_t)(input[16] & 0x0f) << 28) |
			((uint32_t)input[17] << 20) |
			((uint32_t)(input[18] & 0xf0) << 12);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 148 to 163
	value = ((uint32_t)(input[18] & 0x0f) << 28) |
			((uint32_t)input[19] << 20) |
			((uint32_t)(input[20] & 0xf0) << 12);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 164 to 179
	value = ((uint32_t)(input[20] & 0x0f) << 28) |
			((uint32_t)input[21] << 20) |
			((uint32_t)(input[22] & 0xf0) << 12);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 180 to 195
	value = ((uint32_t)(input[22] & 0x0f) << 28) |
			((uint32_t)input[23] << 20) |
			((uint32_t)(input[24] & 0xf0) << 12);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 196 to 211
	value = ((uint32_t)(input[24] & 0x0f) << 28) |
			((uint32_t)input[25] << 20) |
			((uint32_t)(input[26] & 0xf0) << 12);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 212 to 227
	value = ((uint32_t)(input[26] & 0x0f) << 28) |
			((uint32_t)input[27] << 20) |
			((uint32_t)(input[28] & 0xf0) << 12);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 228 to 243
	value = ((uint32_t)(input[28] & 0x0f) << 28) |
			((uint32_t)input[29] << 20) |
			((uint32_t)(input[30] & 0xf0) << 12);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 244 to 259
	value = ((uint32_t)(input[30] & 0x0f) << 28) |
			((uint32_t)input[31] << 20) |
			((uint32_t)(input[32] & 0xf0) << 12);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 260 to 275
	value = ((uint32_t)(input[32] & 0x0f) << 28) |
			((uint32_t)input[33] << 20) |
			((uint32_t)(input[34] & 0xf0) << 12);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 276 to 291
	value = ((uint32_t)(input[34] & 0x0f) << 28) |
			((uint32_t)input[35] << 20) |
			((uint32_t)(input[36] & 0xf0) << 12);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 292 to 307
	value = ((uint32_t)(input[36] & 0x0f) << 28) |
			((uint32_t)input[37] << 20) |
			((uint32_t)(input[38] & 0xf0) << 12);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 308 to 323
	value = ((uint32_t)(input[38] & 0x0f) << 28) |
			((uint32_t)input[39] << 20) |
			((uint32_t)(input[40] & 0xf0) << 12);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 324 to 339
	value = ((uint32_t)(input[40] & 0x0f) << 28) |
			((uint32_t)input[41] << 20) |
			((uint32_t)(input[42] & 0xf0) << 12);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 340 to 355
	value = ((uint32_t)(input[42] & 0x0f) << 28) |
			((uint32_t)input[43] << 20) |
			((uint32_t)(input[44] & 0xf0) << 12);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 356 to 371
	value = ((uint32_t)(input[44] & 0x0f) << 28) |
			((uint32_t)input[45] << 20) |
			((uint32_t)(input[46] & 0xf0) << 12);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 372 to 387
	value = ((uint32_t)(input[46] & 0x0f) << 28) |
			((uint32_t)input[47] << 20) |
			((uint32_t)(input[48] & 0xf0) << 12);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 388 to 403
	value = ((uint32_t)(input[48] & 0x0f) << 28) |
			((uint32_t)input[49] << 20) |
			((uint32_t)(input[50] & 0xf0) << 12);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 404 to 419
	value = ((uint32_t)(input[50] & 0x0f) << 28) |
			((uint32_t)input[51] << 20) |
			((uint32_t)(input[52] & 0xf0) << 12);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 420 to 435
	value = ((uint32_t)(input[52] & 0x0f) << 28) |
			((uint32_t)input[53] << 20) |
			((uint32_t)(input[54] & 0xf0) << 12);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 436 to 451
	value = ((uint32_t)(input[54] & 0x0f) << 28) |
			((uint32_t)input[55] << 20) |
			((uint32_t)(input[56] & 0xf0) << 12);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 452 to 467
	value = ((uint32_t)(input[56] & 0x0f) << 28) |
			((uint32_t)input[57] << 20) |
			((uint32_t)(input[58] & 0xf0) << 12);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 468 to 483
	value = ((uint32_t)(input[58] & 0x0f) << 28) |
			((uint32_t)input[59] << 20) |
			((uint32_t)(input[60] & 0xf0) << 12);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 484 to 499
	value = ((uint32_t)(input[60] & 0x0f) << 28) |
			((uint32_t)input[61] << 20) |
			((uint32_t)(input[62] & 0xf0) << 12);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 500 to 515
	value = ((uint32_t)(input[62] & 0x0f) << 28) |
			((uint32_t)input[63] << 20) |
			((uint32_t)(input[64] & 0xf0) << 12);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 516 to 531
	value = ((uint32_t)(input[64] & 0x0f) << 28) |
			((uint32_t)input[65] << 20) |
			((uint32_t)(input[66] & 0xf0) << 12);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 532 to 547
	value = ((uint32_t)(input[66] & 0x0f) << 28) |
			((uint32_t)input[67] << 20) |
			((uint32_t)(input[68] & 0xf0) << 12);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 548 to 563
	value = ((uint32_t)(input[68] & 0x0f) << 28) |
			((uint32_t)input[69] << 20) |
			((uint32_t)(input[70] & 0xf0) << 12);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 564 to 579
	value = ((uint32_t)(input[70] & 0x0f) << 28) |
			((uint32_t)input[71] << 20) |
			((uint32_t)(input[72] & 0xf0) << 12);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 580 to 595
	value = ((uint32_t)(input[72] & 0x0f) << 28) |
			((uint32_t)input[73] << 20) |
			((uint32_t)(input[74] & 0xf0) << 12);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 596 to 611
	value = ((uint32_t)(input[74] & 0x0f) << 28) |
			((uint32_t)input[75] << 20) |
			((uint32_t)(input[76] & 0xf0) << 12);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 612 to 627
	value = ((uint32_t)(input[76] & 0x0f) << 28) |
			((uint32_t)input[77] << 20) |
			((uint32_t)(input[78] & 0xf0) << 12);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 628 to 643
	value = ((uint32_t)(input[78] & 0x0f) << 28) |
			((uint32_t)input[79] << 20) |
			((uint32_t)(input[80] & 0xf0) << 12);
	output[39] = (double)(value >> 16);

	// read output[40]: from bit 644 to 659
	value = ((uint32_t)(input[80] & 0x0f) << 28) |
			((uint32_t)input[81] << 20) |
			((uint32_t)(input[82] & 0xf0) << 12);
	output[40] = (double)(value >> 16);

	// read output[41]: from bit 660 to 675
	value = ((uint32_t)(input[82] & 0x0f) << 28) |
			((uint32_t)input[83] << 20) |
			((uint32_t)(input[84] & 0xf0) << 12);
	output[41] = (double)(value >> 16);

	// read output[42]: from bit 676 to 691
	value = ((uint32_t)(input[84] & 0x0f) << 28) |
			((uint32_t)input[85] << 20) |
			((uint32_t)(input[86] & 0xf0) << 12);
	output[42] = (double)(value >> 16);

	// read output[43]: from bit 692 to 707
	value = ((uint32_t)(input[86] & 0x0f) << 28) |
			((uint32_t)input[87] << 20) |
			((uint32_t)(input[88] & 0xf0) << 12);
	output[43] = (double)(value >> 16);

	// read output[44]: from bit 708 to 723
	value = ((uint32_t)(input[88] & 0x0f) << 28) |
			((uint32_t)input[89] << 20) |
			((uint32_t)(input[90] & 0xf0) << 12);
	output[44] = (double)(value >> 16);

	// read output[45]: from bit 724 to 739
	value = ((uint32_t)(input[90] & 0x0f) << 28) |
			((uint32_t)input[91] << 20) |
			((uint32_t)(input[92] & 0xf0) << 12);
	output[45] = (double)(value >> 16);

	// read output[46]: from bit 740 to 755
	value = ((uint32_t)(input[92] & 0x0f) << 28) |
			((uint32_t)input[93] << 20) |
			((uint32_t)(input[94] & 0xf0) << 12);
	output[46] = (double)(value >> 16);

	// read output[47]: from bit 756 to 771
	value = ((uint32_t)(input[94] & 0x0f) << 28) |
			((uint32_t)input[95] << 20) |
			((uint32_t)(input[96] & 0xf0) << 12);
	output[47] = (double)(value >> 16);

	// read output[48]: from bit 772 to 787
	value = ((uint32_t)(input[96] & 0x0f) << 28) |
			((uint32_t)input[97] << 20) |
			((uint32_t)(input[98] & 0xf0) << 12);
	output[48] = (double)(value >> 16);

	// read output[49]: from bit 788 to 803
	value = ((uint32_t)(input[98] & 0x0f) << 28) |
			((uint32_t)input[99] << 20) |
			((uint32_t)(input[100] & 0xf0) << 12);
	output[49] = (double)(value >> 16);

	// read output[50]: from bit 804 to 819
	value = ((uint32_t)(input[100] & 0x0f) << 28) |
			((uint32_t)input[101] << 20) |
			((uint32_t)(input[102] & 0xf0) << 12);
	output[50] = (double)(value >> 16);

	// read output[51]: from bit 820 to 835
	value = ((uint32_t)(input[102] & 0x0f) << 28) |
			((uint32_t)input[103] << 20) |
			((uint32_t)(input[104] & 0xf0) << 12);
	output[51] = (double)(value >> 16);
}

static void unpack_52_16bit_unsigned_4off(const uint8_t * input, double * output, void *closure) {
	// Unpack 52 values into output
	// Values are 16-bit unsigned
	// Skip 4 bits, read 832 bits of data.
	// Input must be at least 105 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 4 to 19
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20) |
			((uint32_t)(input[2] & 0xf0) << 12);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 20 to 35
	value = ((uint32_t)(input[2] & 0x0f) << 28) |
			((uint32_t)input[3] << 20) |
			((uint32_t)(input[4] & 0xf0) << 12);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 36 to 51
	value = ((uint32_t)(input[4] & 0x0f) << 28) |
			((uint32_t)input[5] << 20) |
			((uint32_t)(input[6] & 0xf0) << 12);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 52 to 67
	value = ((uint32_t)(input[6] & 0x0f) << 28) |
			((uint32_t)input[7] << 20) |
			((uint32_t)(input[8] & 0xf0) << 12);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 68 to 83
	value = ((uint32_t)(input[8] & 0x0f) << 28) |
			((uint32_t)input[9] << 20) |
			((uint32_t)(input[10] & 0xf0) << 12);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 84 to 99
	value = ((uint32_t)(input[10] & 0x0f) << 28) |
			((uint32_t)input[11] << 20) |
			((uint32_t)(input[12] & 0xf0) << 12);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 100 to 115
	value = ((uint32_t)(input[12] & 0x0f) << 28) |
			((uint32_t)input[13] << 20) |
			((uint32_t)(input[14] & 0xf0) << 12);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 116 to 131
	value = ((uint32_t)(input[14] & 0x0f) << 28) |
			((uint32_t)input[15] << 20) |
			((uint32_t)(input[16] & 0xf0) << 12);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 132 to 147
	value = ((uint32_t)(input[16] & 0x0f) << 28) |
			((uint32_t)input[17] << 20) |
			((uint32_t)(input[18] & 0xf0) << 12);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 148 to 163
	value = ((uint32_t)(input[18] & 0x0f) << 28) |
			((uint32_t)input[19] << 20) |
			((uint32_t)(input[20] & 0xf0) << 12);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 164 to 179
	value = ((uint32_t)(input[20] & 0x0f) << 28) |
			((uint32_t)input[21] << 20) |
			((uint32_t)(input[22] & 0xf0) << 12);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 180 to 195
	value = ((uint32_t)(input[22] & 0x0f) << 28) |
			((uint32_t)input[23] << 20) |
			((uint32_t)(input[24] & 0xf0) << 12);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 196 to 211
	value = ((uint32_t)(input[24] & 0x0f) << 28) |
			((uint32_t)input[25] << 20) |
			((uint32_t)(input[26] & 0xf0) << 12);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 212 to 227
	value = ((uint32_t)(input[26] & 0x0f) << 28) |
			((uint32_t)input[27] << 20) |
			((uint32_t)(input[28] & 0xf0) << 12);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 228 to 243
	value = ((uint32_t)(input[28] & 0x0f) << 28) |
			((uint32_t)input[29] << 20) |
			((uint32_t)(input[30] & 0xf0) << 12);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 244 to 259
	value = ((uint32_t)(input[30] & 0x0f) << 28) |
			((uint32_t)input[31] << 20) |
			((uint32_t)(input[32] & 0xf0) << 12);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 260 to 275
	value = ((uint32_t)(input[32] & 0x0f) << 28) |
			((uint32_t)input[33] << 20) |
			((uint32_t)(input[34] & 0xf0) << 12);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 276 to 291
	value = ((uint32_t)(input[34] & 0x0f) << 28) |
			((uint32_t)input[35] << 20) |
			((uint32_t)(input[36] & 0xf0) << 12);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 292 to 307
	value = ((uint32_t)(input[36] & 0x0f) << 28) |
			((uint32_t)input[37] << 20) |
			((uint32_t)(input[38] & 0xf0) << 12);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 308 to 323
	value = ((uint32_t)(input[38] & 0x0f) << 28) |
			((uint32_t)input[39] << 20) |
			((uint32_t)(input[40] & 0xf0) << 12);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 324 to 339
	value = ((uint32_t)(input[40] & 0x0f) << 28) |
			((uint32_t)input[41] << 20) |
			((uint32_t)(input[42] & 0xf0) << 12);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 340 to 355
	value = ((uint32_t)(input[42] & 0x0f) << 28) |
			((uint32_t)input[43] << 20) |
			((uint32_t)(input[44] & 0xf0) << 12);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 356 to 371
	value = ((uint32_t)(input[44] & 0x0f) << 28) |
			((uint32_t)input[45] << 20) |
			((uint32_t)(input[46] & 0xf0) << 12);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 372 to 387
	value = ((uint32_t)(input[46] & 0x0f) << 28) |
			((uint32_t)input[47] << 20) |
			((uint32_t)(input[48] & 0xf0) << 12);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 388 to 403
	value = ((uint32_t)(input[48] & 0x0f) << 28) |
			((uint32_t)input[49] << 20) |
			((uint32_t)(input[50] & 0xf0) << 12);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 404 to 419
	value = ((uint32_t)(input[50] & 0x0f) << 28) |
			((uint32_t)input[51] << 20) |
			((uint32_t)(input[52] & 0xf0) << 12);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 420 to 435
	value = ((uint32_t)(input[52] & 0x0f) << 28) |
			((uint32_t)input[53] << 20) |
			((uint32_t)(input[54] & 0xf0) << 12);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 436 to 451
	value = ((uint32_t)(input[54] & 0x0f) << 28) |
			((uint32_t)input[55] << 20) |
			((uint32_t)(input[56] & 0xf0) << 12);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 452 to 467
	value = ((uint32_t)(input[56] & 0x0f) << 28) |
			((uint32_t)input[57] << 20) |
			((uint32_t)(input[58] & 0xf0) << 12);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 468 to 483
	value = ((uint32_t)(input[58] & 0x0f) << 28) |
			((uint32_t)input[59] << 20) |
			((uint32_t)(input[60] & 0xf0) << 12);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 484 to 499
	value = ((uint32_t)(input[60] & 0x0f) << 28) |
			((uint32_t)input[61] << 20) |
			((uint32_t)(input[62] & 0xf0) << 12);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 500 to 515
	value = ((uint32_t)(input[62] & 0x0f) << 28) |
			((uint32_t)input[63] << 20) |
			((uint32_t)(input[64] & 0xf0) << 12);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 516 to 531
	value = ((uint32_t)(input[64] & 0x0f) << 28) |
			((uint32_t)input[65] << 20) |
			((uint32_t)(input[66] & 0xf0) << 12);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 532 to 547
	value = ((uint32_t)(input[66] & 0x0f) << 28) |
			((uint32_t)input[67] << 20) |
			((uint32_t)(input[68] & 0xf0) << 12);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 548 to 563
	value = ((uint32_t)(input[68] & 0x0f) << 28) |
			((uint32_t)input[69] << 20) |
			((uint32_t)(input[70] & 0xf0) << 12);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 564 to 579
	value = ((uint32_t)(input[70] & 0x0f) << 28) |
			((uint32_t)input[71] << 20) |
			((uint32_t)(input[72] & 0xf0) << 12);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 580 to 595
	value = ((uint32_t)(input[72] & 0x0f) << 28) |
			((uint32_t)input[73] << 20) |
			((uint32_t)(input[74] & 0xf0) << 12);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 596 to 611
	value = ((uint32_t)(input[74] & 0x0f) << 28) |
			((uint32_t)input[75] << 20) |
			((uint32_t)(input[76] & 0xf0) << 12);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 612 to 627
	value = ((uint32_t)(input[76] & 0x0f) << 28) |
			((uint32_t)input[77] << 20) |
			((uint32_t)(input[78] & 0xf0) << 12);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 628 to 643
	value = ((uint32_t)(input[78] & 0x0f) << 28) |
			((uint32_t)input[79] << 20) |
			((uint32_t)(input[80] & 0xf0) << 12);
	output[39] = (double)(value >> 16);

	// read output[40]: from bit 644 to 659
	value = ((uint32_t)(input[80] & 0x0f) << 28) |
			((uint32_t)input[81] << 20) |
			((uint32_t)(input[82] & 0xf0) << 12);
	output[40] = (double)(value >> 16);

	// read output[41]: from bit 660 to 675
	value = ((uint32_t)(input[82] & 0x0f) << 28) |
			((uint32_t)input[83] << 20) |
			((uint32_t)(input[84] & 0xf0) << 12);
	output[41] = (double)(value >> 16);

	// read output[42]: from bit 676 to 691
	value = ((uint32_t)(input[84] & 0x0f) << 28) |
			((uint32_t)input[85] << 20) |
			((uint32_t)(input[86] & 0xf0) << 12);
	output[42] = (double)(value >> 16);

	// read output[43]: from bit 692 to 707
	value = ((uint32_t)(input[86] & 0x0f) << 28) |
			((uint32_t)input[87] << 20) |
			((uint32_t)(input[88] & 0xf0) << 12);
	output[43] = (double)(value >> 16);

	// read output[44]: from bit 708 to 723
	value = ((uint32_t)(input[88] & 0x0f) << 28) |
			((uint32_t)input[89] << 20) |
			((uint32_t)(input[90] & 0xf0) << 12);
	output[44] = (double)(value >> 16);

	// read output[45]: from bit 724 to 739
	value = ((uint32_t)(input[90] & 0x0f) << 28) |
			((uint32_t)input[91] << 20) |
			((uint32_t)(input[92] & 0xf0) << 12);
	output[45] = (double)(value >> 16);

	// read output[46]: from bit 740 to 755
	value = ((uint32_t)(input[92] & 0x0f) << 28) |
			((uint32_t)input[93] << 20) |
			((uint32_t)(input[94] & 0xf0) << 12);
	output[46] = (double)(value >> 16);

	// read output[47]: from bit 756 to 771
	value = ((uint32_t)(input[94] & 0x0f) << 28) |
			((uint32_t)input[95] << 20) |
			((uint32_t)(input[96] & 0xf0) << 12);
	output[47] = (double)(value >> 16);

	// read output[48]: from bit 772 to 787
	value = ((uint32_t)(input[96] & 0x0f) << 28) |
			((uint32_t)input[97] << 20) |
			((uint32_t)(input[98] & 0xf0) << 12);
	output[48] = (double)(value >> 16);

	// read output[49]: from bit 788 to 803
	value = ((uint32_t)(input[98] & 0x0f) << 28) |
			((uint32_t)input[99] << 20) |
			((uint32_t)(input[100] & 0xf0) << 12);
	output[49] = (double)(value >> 16);

	// read output[50]: from bit 804 to 819
	value = ((uint32_t)(input[100] & 0x0f) << 28) |
			((uint32_t)input[101] << 20) |
			((uint32_t)(input[102] & 0xf0) << 12);
	output[50] = (double)(value >> 16);

	// read output[51]: from bit 820 to 835
	value = ((uint32_t)(input[102] & 0x0f) << 28) |
			((uint32_t)input[103] << 20) |
			((uint32_t)(input[104] & 0xf0) << 12);
	output[51] = (double)(value >> 16);
}

static void unpack_52_16bit_signed_5off(const uint8_t * input, double * output, void *closure) {
	// Unpack 52 values into output
	// Values are 16-bit signed
	// Skip 5 bits, read 832 bits of data.
	// Input must be at least 105 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 5 to 20
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)(input[2] & 0xf8) << 13);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 21 to 36
	value = ((uint32_t)(input[2] & 0x07) << 29) |
			((uint32_t)input[3] << 21) |
			((uint32_t)(input[4] & 0xf8) << 13);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 37 to 52
	value = ((uint32_t)(input[4] & 0x07) << 29) |
			((uint32_t)input[5] << 21) |
			((uint32_t)(input[6] & 0xf8) << 13);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 53 to 68
	value = ((uint32_t)(input[6] & 0x07) << 29) |
			((uint32_t)input[7] << 21) |
			((uint32_t)(input[8] & 0xf8) << 13);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 69 to 84
	value = ((uint32_t)(input[8] & 0x07) << 29) |
			((uint32_t)input[9] << 21) |
			((uint32_t)(input[10] & 0xf8) << 13);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 85 to 100
	value = ((uint32_t)(input[10] & 0x07) << 29) |
			((uint32_t)input[11] << 21) |
			((uint32_t)(input[12] & 0xf8) << 13);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 101 to 116
	value = ((uint32_t)(input[12] & 0x07) << 29) |
			((uint32_t)input[13] << 21) |
			((uint32_t)(input[14] & 0xf8) << 13);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 117 to 132
	value = ((uint32_t)(input[14] & 0x07) << 29) |
			((uint32_t)input[15] << 21) |
			((uint32_t)(input[16] & 0xf8) << 13);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 133 to 148
	value = ((uint32_t)(input[16] & 0x07) << 29) |
			((uint32_t)input[17] << 21) |
			((uint32_t)(input[18] & 0xf8) << 13);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 149 to 164
	value = ((uint32_t)(input[18] & 0x07) << 29) |
			((uint32_t)input[19] << 21) |
			((uint32_t)(input[20] & 0xf8) << 13);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 165 to 180
	value = ((uint32_t)(input[20] & 0x07) << 29) |
			((uint32_t)input[21] << 21) |
			((uint32_t)(input[22] & 0xf8) << 13);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 181 to 196
	value = ((uint32_t)(input[22] & 0x07) << 29) |
			((uint32_t)input[23] << 21) |
			((uint32_t)(input[24] & 0xf8) << 13);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 197 to 212
	value = ((uint32_t)(input[24] & 0x07) << 29) |
			((uint32_t)input[25] << 21) |
			((uint32_t)(input[26] & 0xf8) << 13);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 213 to 228
	value = ((uint32_t)(input[26] & 0x07) << 29) |
			((uint32_t)input[27] << 21) |
			((uint32_t)(input[28] & 0xf8) << 13);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 229 to 244
	value = ((uint32_t)(input[28] & 0x07) << 29) |
			((uint32_t)input[29] << 21) |
			((uint32_t)(input[30] & 0xf8) << 13);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 245 to 260
	value = ((uint32_t)(input[30] & 0x07) << 29) |
			((uint32_t)input[31] << 21) |
			((uint32_t)(input[32] & 0xf8) << 13);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 261 to 276
	value = ((uint32_t)(input[32] & 0x07) << 29) |
			((uint32_t)input[33] << 21) |
			((uint32_t)(input[34] & 0xf8) << 13);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 277 to 292
	value = ((uint32_t)(input[34] & 0x07) << 29) |
			((uint32_t)input[35] << 21) |
			((uint32_t)(input[36] & 0xf8) << 13);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 293 to 308
	value = ((uint32_t)(input[36] & 0x07) << 29) |
			((uint32_t)input[37] << 21) |
			((uint32_t)(input[38] & 0xf8) << 13);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 309 to 324
	value = ((uint32_t)(input[38] & 0x07) << 29) |
			((uint32_t)input[39] << 21) |
			((uint32_t)(input[40] & 0xf8) << 13);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 325 to 340
	value = ((uint32_t)(input[40] & 0x07) << 29) |
			((uint32_t)input[41] << 21) |
			((uint32_t)(input[42] & 0xf8) << 13);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 341 to 356
	value = ((uint32_t)(input[42] & 0x07) << 29) |
			((uint32_t)input[43] << 21) |
			((uint32_t)(input[44] & 0xf8) << 13);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 357 to 372
	value = ((uint32_t)(input[44] & 0x07) << 29) |
			((uint32_t)input[45] << 21) |
			((uint32_t)(input[46] & 0xf8) << 13);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 373 to 388
	value = ((uint32_t)(input[46] & 0x07) << 29) |
			((uint32_t)input[47] << 21) |
			((uint32_t)(input[48] & 0xf8) << 13);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 389 to 404
	value = ((uint32_t)(input[48] & 0x07) << 29) |
			((uint32_t)input[49] << 21) |
			((uint32_t)(input[50] & 0xf8) << 13);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 405 to 420
	value = ((uint32_t)(input[50] & 0x07) << 29) |
			((uint32_t)input[51] << 21) |
			((uint32_t)(input[52] & 0xf8) << 13);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 421 to 436
	value = ((uint32_t)(input[52] & 0x07) << 29) |
			((uint32_t)input[53] << 21) |
			((uint32_t)(input[54] & 0xf8) << 13);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 437 to 452
	value = ((uint32_t)(input[54] & 0x07) << 29) |
			((uint32_t)input[55] << 21) |
			((uint32_t)(input[56] & 0xf8) << 13);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 453 to 468
	value = ((uint32_t)(input[56] & 0x07) << 29) |
			((uint32_t)input[57] << 21) |
			((uint32_t)(input[58] & 0xf8) << 13);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 469 to 484
	value = ((uint32_t)(input[58] & 0x07) << 29) |
			((uint32_t)input[59] << 21) |
			((uint32_t)(input[60] & 0xf8) << 13);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 485 to 500
	value = ((uint32_t)(input[60] & 0x07) << 29) |
			((uint32_t)input[61] << 21) |
			((uint32_t)(input[62] & 0xf8) << 13);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 501 to 516
	value = ((uint32_t)(input[62] & 0x07) << 29) |
			((uint32_t)input[63] << 21) |
			((uint32_t)(input[64] & 0xf8) << 13);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 517 to 532
	value = ((uint32_t)(input[64] & 0x07) << 29) |
			((uint32_t)input[65] << 21) |
			((uint32_t)(input[66] & 0xf8) << 13);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 533 to 548
	value = ((uint32_t)(input[66] & 0x07) << 29) |
			((uint32_t)input[67] << 21) |
			((uint32_t)(input[68] & 0xf8) << 13);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 549 to 564
	value = ((uint32_t)(input[68] & 0x07) << 29) |
			((uint32_t)input[69] << 21) |
			((uint32_t)(input[70] & 0xf8) << 13);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 565 to 580
	value = ((uint32_t)(input[70] & 0x07) << 29) |
			((uint32_t)input[71] << 21) |
			((uint32_t)(input[72] & 0xf8) << 13);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 581 to 596
	value = ((uint32_t)(input[72] & 0x07) << 29) |
			((uint32_t)input[73] << 21) |
			((uint32_t)(input[74] & 0xf8) << 13);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 597 to 612
	value = ((uint32_t)(input[74] & 0x07) << 29) |
			((uint32_t)input[75] << 21) |
			((uint32_t)(input[76] & 0xf8) << 13);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 613 to 628
	value = ((uint32_t)(input[76] & 0x07) << 29) |
			((uint32_t)input[77] << 21) |
			((uint32_t)(input[78] & 0xf8) << 13);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 629 to 644
	value = ((uint32_t)(input[78] & 0x07) << 29) |
			((uint32_t)input[79] << 21) |
			((uint32_t)(input[80] & 0xf8) << 13);
	output[39] = (double)(value >> 16);

	// read output[40]: from bit 645 to 660
	value = ((uint32_t)(input[80] & 0x07) << 29) |
			((uint32_t)input[81] << 21) |
			((uint32_t)(input[82] & 0xf8) << 13);
	output[40] = (double)(value >> 16);

	// read output[41]: from bit 661 to 676
	value = ((uint32_t)(input[82] & 0x07) << 29) |
			((uint32_t)input[83] << 21) |
			((uint32_t)(input[84] & 0xf8) << 13);
	output[41] = (double)(value >> 16);

	// read output[42]: from bit 677 to 692
	value = ((uint32_t)(input[84] & 0x07) << 29) |
			((uint32_t)input[85] << 21) |
			((uint32_t)(input[86] & 0xf8) << 13);
	output[42] = (double)(value >> 16);

	// read output[43]: from bit 693 to 708
	value = ((uint32_t)(input[86] & 0x07) << 29) |
			((uint32_t)input[87] << 21) |
			((uint32_t)(input[88] & 0xf8) << 13);
	output[43] = (double)(value >> 16);

	// read output[44]: from bit 709 to 724
	value = ((uint32_t)(input[88] & 0x07) << 29) |
			((uint32_t)input[89] << 21) |
			((uint32_t)(input[90] & 0xf8) << 13);
	output[44] = (double)(value >> 16);

	// read output[45]: from bit 725 to 740
	value = ((uint32_t)(input[90] & 0x07) << 29) |
			((uint32_t)input[91] << 21) |
			((uint32_t)(input[92] & 0xf8) << 13);
	output[45] = (double)(value >> 16);

	// read output[46]: from bit 741 to 756
	value = ((uint32_t)(input[92] & 0x07) << 29) |
			((uint32_t)input[93] << 21) |
			((uint32_t)(input[94] & 0xf8) << 13);
	output[46] = (double)(value >> 16);

	// read output[47]: from bit 757 to 772
	value = ((uint32_t)(input[94] & 0x07) << 29) |
			((uint32_t)input[95] << 21) |
			((uint32_t)(input[96] & 0xf8) << 13);
	output[47] = (double)(value >> 16);

	// read output[48]: from bit 773 to 788
	value = ((uint32_t)(input[96] & 0x07) << 29) |
			((uint32_t)input[97] << 21) |
			((uint32_t)(input[98] & 0xf8) << 13);
	output[48] = (double)(value >> 16);

	// read output[49]: from bit 789 to 804
	value = ((uint32_t)(input[98] & 0x07) << 29) |
			((uint32_t)input[99] << 21) |
			((uint32_t)(input[100] & 0xf8) << 13);
	output[49] = (double)(value >> 16);

	// read output[50]: from bit 805 to 820
	value = ((uint32_t)(input[100] & 0x07) << 29) |
			((uint32_t)input[101] << 21) |
			((uint32_t)(input[102] & 0xf8) << 13);
	output[50] = (double)(value >> 16);

	// read output[51]: from bit 821 to 836
	value = ((uint32_t)(input[102] & 0x07) << 29) |
			((uint32_t)input[103] << 21) |
			((uint32_t)(input[104] & 0xf8) << 13);
	output[51] = (double)(value >> 16);
}

static void unpack_52_16bit_unsigned_5off(const uint8_t * input, double * output, void *closure) {
	// Unpack 52 values into output
	// Values are 16-bit unsigned
	// Skip 5 bits, read 832 bits of data.
	// Input must be at least 105 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 5 to 20
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)(input[2] & 0xf8) << 13);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 21 to 36
	value = ((uint32_t)(input[2] & 0x07) << 29) |
			((uint32_t)input[3] << 21) |
			((uint32_t)(input[4] & 0xf8) << 13);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 37 to 52
	value = ((uint32_t)(input[4] & 0x07) << 29) |
			((uint32_t)input[5] << 21) |
			((uint32_t)(input[6] & 0xf8) << 13);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 53 to 68
	value = ((uint32_t)(input[6] & 0x07) << 29) |
			((uint32_t)input[7] << 21) |
			((uint32_t)(input[8] & 0xf8) << 13);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 69 to 84
	value = ((uint32_t)(input[8] & 0x07) << 29) |
			((uint32_t)input[9] << 21) |
			((uint32_t)(input[10] & 0xf8) << 13);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 85 to 100
	value = ((uint32_t)(input[10] & 0x07) << 29) |
			((uint32_t)input[11] << 21) |
			((uint32_t)(input[12] & 0xf8) << 13);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 101 to 116
	value = ((uint32_t)(input[12] & 0x07) << 29) |
			((uint32_t)input[13] << 21) |
			((uint32_t)(input[14] & 0xf8) << 13);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 117 to 132
	value = ((uint32_t)(input[14] & 0x07) << 29) |
			((uint32_t)input[15] << 21) |
			((uint32_t)(input[16] & 0xf8) << 13);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 133 to 148
	value = ((uint32_t)(input[16] & 0x07) << 29) |
			((uint32_t)input[17] << 21) |
			((uint32_t)(input[18] & 0xf8) << 13);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 149 to 164
	value = ((uint32_t)(input[18] & 0x07) << 29) |
			((uint32_t)input[19] << 21) |
			((uint32_t)(input[20] & 0xf8) << 13);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 165 to 180
	value = ((uint32_t)(input[20] & 0x07) << 29) |
			((uint32_t)input[21] << 21) |
			((uint32_t)(input[22] & 0xf8) << 13);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 181 to 196
	value = ((uint32_t)(input[22] & 0x07) << 29) |
			((uint32_t)input[23] << 21) |
			((uint32_t)(input[24] & 0xf8) << 13);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 197 to 212
	value = ((uint32_t)(input[24] & 0x07) << 29) |
			((uint32_t)input[25] << 21) |
			((uint32_t)(input[26] & 0xf8) << 13);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 213 to 228
	value = ((uint32_t)(input[26] & 0x07) << 29) |
			((uint32_t)input[27] << 21) |
			((uint32_t)(input[28] & 0xf8) << 13);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 229 to 244
	value = ((uint32_t)(input[28] & 0x07) << 29) |
			((uint32_t)input[29] << 21) |
			((uint32_t)(input[30] & 0xf8) << 13);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 245 to 260
	value = ((uint32_t)(input[30] & 0x07) << 29) |
			((uint32_t)input[31] << 21) |
			((uint32_t)(input[32] & 0xf8) << 13);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 261 to 276
	value = ((uint32_t)(input[32] & 0x07) << 29) |
			((uint32_t)input[33] << 21) |
			((uint32_t)(input[34] & 0xf8) << 13);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 277 to 292
	value = ((uint32_t)(input[34] & 0x07) << 29) |
			((uint32_t)input[35] << 21) |
			((uint32_t)(input[36] & 0xf8) << 13);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 293 to 308
	value = ((uint32_t)(input[36] & 0x07) << 29) |
			((uint32_t)input[37] << 21) |
			((uint32_t)(input[38] & 0xf8) << 13);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 309 to 324
	value = ((uint32_t)(input[38] & 0x07) << 29) |
			((uint32_t)input[39] << 21) |
			((uint32_t)(input[40] & 0xf8) << 13);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 325 to 340
	value = ((uint32_t)(input[40] & 0x07) << 29) |
			((uint32_t)input[41] << 21) |
			((uint32_t)(input[42] & 0xf8) << 13);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 341 to 356
	value = ((uint32_t)(input[42] & 0x07) << 29) |
			((uint32_t)input[43] << 21) |
			((uint32_t)(input[44] & 0xf8) << 13);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 357 to 372
	value = ((uint32_t)(input[44] & 0x07) << 29) |
			((uint32_t)input[45] << 21) |
			((uint32_t)(input[46] & 0xf8) << 13);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 373 to 388
	value = ((uint32_t)(input[46] & 0x07) << 29) |
			((uint32_t)input[47] << 21) |
			((uint32_t)(input[48] & 0xf8) << 13);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 389 to 404
	value = ((uint32_t)(input[48] & 0x07) << 29) |
			((uint32_t)input[49] << 21) |
			((uint32_t)(input[50] & 0xf8) << 13);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 405 to 420
	value = ((uint32_t)(input[50] & 0x07) << 29) |
			((uint32_t)input[51] << 21) |
			((uint32_t)(input[52] & 0xf8) << 13);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 421 to 436
	value = ((uint32_t)(input[52] & 0x07) << 29) |
			((uint32_t)input[53] << 21) |
			((uint32_t)(input[54] & 0xf8) << 13);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 437 to 452
	value = ((uint32_t)(input[54] & 0x07) << 29) |
			((uint32_t)input[55] << 21) |
			((uint32_t)(input[56] & 0xf8) << 13);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 453 to 468
	value = ((uint32_t)(input[56] & 0x07) << 29) |
			((uint32_t)input[57] << 21) |
			((uint32_t)(input[58] & 0xf8) << 13);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 469 to 484
	value = ((uint32_t)(input[58] & 0x07) << 29) |
			((uint32_t)input[59] << 21) |
			((uint32_t)(input[60] & 0xf8) << 13);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 485 to 500
	value = ((uint32_t)(input[60] & 0x07) << 29) |
			((uint32_t)input[61] << 21) |
			((uint32_t)(input[62] & 0xf8) << 13);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 501 to 516
	value = ((uint32_t)(input[62] & 0x07) << 29) |
			((uint32_t)input[63] << 21) |
			((uint32_t)(input[64] & 0xf8) << 13);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 517 to 532
	value = ((uint32_t)(input[64] & 0x07) << 29) |
			((uint32_t)input[65] << 21) |
			((uint32_t)(input[66] & 0xf8) << 13);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 533 to 548
	value = ((uint32_t)(input[66] & 0x07) << 29) |
			((uint32_t)input[67] << 21) |
			((uint32_t)(input[68] & 0xf8) << 13);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 549 to 564
	value = ((uint32_t)(input[68] & 0x07) << 29) |
			((uint32_t)input[69] << 21) |
			((uint32_t)(input[70] & 0xf8) << 13);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 565 to 580
	value = ((uint32_t)(input[70] & 0x07) << 29) |
			((uint32_t)input[71] << 21) |
			((uint32_t)(input[72] & 0xf8) << 13);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 581 to 596
	value = ((uint32_t)(input[72] & 0x07) << 29) |
			((uint32_t)input[73] << 21) |
			((uint32_t)(input[74] & 0xf8) << 13);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 597 to 612
	value = ((uint32_t)(input[74] & 0x07) << 29) |
			((uint32_t)input[75] << 21) |
			((uint32_t)(input[76] & 0xf8) << 13);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 613 to 628
	value = ((uint32_t)(input[76] & 0x07) << 29) |
			((uint32_t)input[77] << 21) |
			((uint32_t)(input[78] & 0xf8) << 13);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 629 to 644
	value = ((uint32_t)(input[78] & 0x07) << 29) |
			((uint32_t)input[79] << 21) |
			((uint32_t)(input[80] & 0xf8) << 13);
	output[39] = (double)(value >> 16);

	// read output[40]: from bit 645 to 660
	value = ((uint32_t)(input[80] & 0x07) << 29) |
			((uint32_t)input[81] << 21) |
			((uint32_t)(input[82] & 0xf8) << 13);
	output[40] = (double)(value >> 16);

	// read output[41]: from bit 661 to 676
	value = ((uint32_t)(input[82] & 0x07) << 29) |
			((uint32_t)input[83] << 21) |
			((uint32_t)(input[84] & 0xf8) << 13);
	output[41] = (double)(value >> 16);

	// read output[42]: from bit 677 to 692
	value = ((uint32_t)(input[84] & 0x07) << 29) |
			((uint32_t)input[85] << 21) |
			((uint32_t)(input[86] & 0xf8) << 13);
	output[42] = (double)(value >> 16);

	// read output[43]: from bit 693 to 708
	value = ((uint32_t)(input[86] & 0x07) << 29) |
			((uint32_t)input[87] << 21) |
			((uint32_t)(input[88] & 0xf8) << 13);
	output[43] = (double)(value >> 16);

	// read output[44]: from bit 709 to 724
	value = ((uint32_t)(input[88] & 0x07) << 29) |
			((uint32_t)input[89] << 21) |
			((uint32_t)(input[90] & 0xf8) << 13);
	output[44] = (double)(value >> 16);

	// read output[45]: from bit 725 to 740
	value = ((uint32_t)(input[90] & 0x07) << 29) |
			((uint32_t)input[91] << 21) |
			((uint32_t)(input[92] & 0xf8) << 13);
	output[45] = (double)(value >> 16);

	// read output[46]: from bit 741 to 756
	value = ((uint32_t)(input[92] & 0x07) << 29) |
			((uint32_t)input[93] << 21) |
			((uint32_t)(input[94] & 0xf8) << 13);
	output[46] = (double)(value >> 16);

	// read output[47]: from bit 757 to 772
	value = ((uint32_t)(input[94] & 0x07) << 29) |
			((uint32_t)input[95] << 21) |
			((uint32_t)(input[96] & 0xf8) << 13);
	output[47] = (double)(value >> 16);

	// read output[48]: from bit 773 to 788
	value = ((uint32_t)(input[96] & 0x07) << 29) |
			((uint32_t)input[97] << 21) |
			((uint32_t)(input[98] & 0xf8) << 13);
	output[48] = (double)(value >> 16);

	// read output[49]: from bit 789 to 804
	value = ((uint32_t)(input[98] & 0x07) << 29) |
			((uint32_t)input[99] << 21) |
			((uint32_t)(input[100] & 0xf8) << 13);
	output[49] = (double)(value >> 16);

	// read output[50]: from bit 805 to 820
	value = ((uint32_t)(input[100] & 0x07) << 29) |
			((uint32_t)input[101] << 21) |
			((uint32_t)(input[102] & 0xf8) << 13);
	output[50] = (double)(value >> 16);

	// read output[51]: from bit 821 to 836
	value = ((uint32_t)(input[102] & 0x07) << 29) |
			((uint32_t)input[103] << 21) |
			((uint32_t)(input[104] & 0xf8) << 13);
	output[51] = (double)(value >> 16);
}

static void unpack_52_16bit_signed_6off(const uint8_t * input, double * output, void *closure) {
	// Unpack 52 values into output
	// Values are 16-bit signed
	// Skip 6 bits, read 832 bits of data.
	// Input must be at least 105 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 6 to 21
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)(input[2] & 0xfc) << 14);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 22 to 37
	value = ((uint32_t)(input[2] & 0x03) << 30) |
			((uint32_t)input[3] << 22) |
			((uint32_t)(input[4] & 0xfc) << 14);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 38 to 53
	value = ((uint32_t)(input[4] & 0x03) << 30) |
			((uint32_t)input[5] << 22) |
			((uint32_t)(input[6] & 0xfc) << 14);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 54 to 69
	value = ((uint32_t)(input[6] & 0x03) << 30) |
			((uint32_t)input[7] << 22) |
			((uint32_t)(input[8] & 0xfc) << 14);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 70 to 85
	value = ((uint32_t)(input[8] & 0x03) << 30) |
			((uint32_t)input[9] << 22) |
			((uint32_t)(input[10] & 0xfc) << 14);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 86 to 101
	value = ((uint32_t)(input[10] & 0x03) << 30) |
			((uint32_t)input[11] << 22) |
			((uint32_t)(input[12] & 0xfc) << 14);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 102 to 117
	value = ((uint32_t)(input[12] & 0x03) << 30) |
			((uint32_t)input[13] << 22) |
			((uint32_t)(input[14] & 0xfc) << 14);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 118 to 133
	value = ((uint32_t)(input[14] & 0x03) << 30) |
			((uint32_t)input[15] << 22) |
			((uint32_t)(input[16] & 0xfc) << 14);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 134 to 149
	value = ((uint32_t)(input[16] & 0x03) << 30) |
			((uint32_t)input[17] << 22) |
			((uint32_t)(input[18] & 0xfc) << 14);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 150 to 165
	value = ((uint32_t)(input[18] & 0x03) << 30) |
			((uint32_t)input[19] << 22) |
			((uint32_t)(input[20] & 0xfc) << 14);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 166 to 181
	value = ((uint32_t)(input[20] & 0x03) << 30) |
			((uint32_t)input[21] << 22) |
			((uint32_t)(input[22] & 0xfc) << 14);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 182 to 197
	value = ((uint32_t)(input[22] & 0x03) << 30) |
			((uint32_t)input[23] << 22) |
			((uint32_t)(input[24] & 0xfc) << 14);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 198 to 213
	value = ((uint32_t)(input[24] & 0x03) << 30) |
			((uint32_t)input[25] << 22) |
			((uint32_t)(input[26] & 0xfc) << 14);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 214 to 229
	value = ((uint32_t)(input[26] & 0x03) << 30) |
			((uint32_t)input[27] << 22) |
			((uint32_t)(input[28] & 0xfc) << 14);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 230 to 245
	value = ((uint32_t)(input[28] & 0x03) << 30) |
			((uint32_t)input[29] << 22) |
			((uint32_t)(input[30] & 0xfc) << 14);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 246 to 261
	value = ((uint32_t)(input[30] & 0x03) << 30) |
			((uint32_t)input[31] << 22) |
			((uint32_t)(input[32] & 0xfc) << 14);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 262 to 277
	value = ((uint32_t)(input[32] & 0x03) << 30) |
			((uint32_t)input[33] << 22) |
			((uint32_t)(input[34] & 0xfc) << 14);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 278 to 293
	value = ((uint32_t)(input[34] & 0x03) << 30) |
			((uint32_t)input[35] << 22) |
			((uint32_t)(input[36] & 0xfc) << 14);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 294 to 309
	value = ((uint32_t)(input[36] & 0x03) << 30) |
			((uint32_t)input[37] << 22) |
			((uint32_t)(input[38] & 0xfc) << 14);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 310 to 325
	value = ((uint32_t)(input[38] & 0x03) << 30) |
			((uint32_t)input[39] << 22) |
			((uint32_t)(input[40] & 0xfc) << 14);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 326 to 341
	value = ((uint32_t)(input[40] & 0x03) << 30) |
			((uint32_t)input[41] << 22) |
			((uint32_t)(input[42] & 0xfc) << 14);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 342 to 357
	value = ((uint32_t)(input[42] & 0x03) << 30) |
			((uint32_t)input[43] << 22) |
			((uint32_t)(input[44] & 0xfc) << 14);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 358 to 373
	value = ((uint32_t)(input[44] & 0x03) << 30) |
			((uint32_t)input[45] << 22) |
			((uint32_t)(input[46] & 0xfc) << 14);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 374 to 389
	value = ((uint32_t)(input[46] & 0x03) << 30) |
			((uint32_t)input[47] << 22) |
			((uint32_t)(input[48] & 0xfc) << 14);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 390 to 405
	value = ((uint32_t)(input[48] & 0x03) << 30) |
			((uint32_t)input[49] << 22) |
			((uint32_t)(input[50] & 0xfc) << 14);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 406 to 421
	value = ((uint32_t)(input[50] & 0x03) << 30) |
			((uint32_t)input[51] << 22) |
			((uint32_t)(input[52] & 0xfc) << 14);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 422 to 437
	value = ((uint32_t)(input[52] & 0x03) << 30) |
			((uint32_t)input[53] << 22) |
			((uint32_t)(input[54] & 0xfc) << 14);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 438 to 453
	value = ((uint32_t)(input[54] & 0x03) << 30) |
			((uint32_t)input[55] << 22) |
			((uint32_t)(input[56] & 0xfc) << 14);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 454 to 469
	value = ((uint32_t)(input[56] & 0x03) << 30) |
			((uint32_t)input[57] << 22) |
			((uint32_t)(input[58] & 0xfc) << 14);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 470 to 485
	value = ((uint32_t)(input[58] & 0x03) << 30) |
			((uint32_t)input[59] << 22) |
			((uint32_t)(input[60] & 0xfc) << 14);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 486 to 501
	value = ((uint32_t)(input[60] & 0x03) << 30) |
			((uint32_t)input[61] << 22) |
			((uint32_t)(input[62] & 0xfc) << 14);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 502 to 517
	value = ((uint32_t)(input[62] & 0x03) << 30) |
			((uint32_t)input[63] << 22) |
			((uint32_t)(input[64] & 0xfc) << 14);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 518 to 533
	value = ((uint32_t)(input[64] & 0x03) << 30) |
			((uint32_t)input[65] << 22) |
			((uint32_t)(input[66] & 0xfc) << 14);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 534 to 549
	value = ((uint32_t)(input[66] & 0x03) << 30) |
			((uint32_t)input[67] << 22) |
			((uint32_t)(input[68] & 0xfc) << 14);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 550 to 565
	value = ((uint32_t)(input[68] & 0x03) << 30) |
			((uint32_t)input[69] << 22) |
			((uint32_t)(input[70] & 0xfc) << 14);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 566 to 581
	value = ((uint32_t)(input[70] & 0x03) << 30) |
			((uint32_t)input[71] << 22) |
			((uint32_t)(input[72] & 0xfc) << 14);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 582 to 597
	value = ((uint32_t)(input[72] & 0x03) << 30) |
			((uint32_t)input[73] << 22) |
			((uint32_t)(input[74] & 0xfc) << 14);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 598 to 613
	value = ((uint32_t)(input[74] & 0x03) << 30) |
			((uint32_t)input[75] << 22) |
			((uint32_t)(input[76] & 0xfc) << 14);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 614 to 629
	value = ((uint32_t)(input[76] & 0x03) << 30) |
			((uint32_t)input[77] << 22) |
			((uint32_t)(input[78] & 0xfc) << 14);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 630 to 645
	value = ((uint32_t)(input[78] & 0x03) << 30) |
			((uint32_t)input[79] << 22) |
			((uint32_t)(input[80] & 0xfc) << 14);
	output[39] = (double)(value >> 16);

	// read output[40]: from bit 646 to 661
	value = ((uint32_t)(input[80] & 0x03) << 30) |
			((uint32_t)input[81] << 22) |
			((uint32_t)(input[82] & 0xfc) << 14);
	output[40] = (double)(value >> 16);

	// read output[41]: from bit 662 to 677
	value = ((uint32_t)(input[82] & 0x03) << 30) |
			((uint32_t)input[83] << 22) |
			((uint32_t)(input[84] & 0xfc) << 14);
	output[41] = (double)(value >> 16);

	// read output[42]: from bit 678 to 693
	value = ((uint32_t)(input[84] & 0x03) << 30) |
			((uint32_t)input[85] << 22) |
			((uint32_t)(input[86] & 0xfc) << 14);
	output[42] = (double)(value >> 16);

	// read output[43]: from bit 694 to 709
	value = ((uint32_t)(input[86] & 0x03) << 30) |
			((uint32_t)input[87] << 22) |
			((uint32_t)(input[88] & 0xfc) << 14);
	output[43] = (double)(value >> 16);

	// read output[44]: from bit 710 to 725
	value = ((uint32_t)(input[88] & 0x03) << 30) |
			((uint32_t)input[89] << 22) |
			((uint32_t)(input[90] & 0xfc) << 14);
	output[44] = (double)(value >> 16);

	// read output[45]: from bit 726 to 741
	value = ((uint32_t)(input[90] & 0x03) << 30) |
			((uint32_t)input[91] << 22) |
			((uint32_t)(input[92] & 0xfc) << 14);
	output[45] = (double)(value >> 16);

	// read output[46]: from bit 742 to 757
	value = ((uint32_t)(input[92] & 0x03) << 30) |
			((uint32_t)input[93] << 22) |
			((uint32_t)(input[94] & 0xfc) << 14);
	output[46] = (double)(value >> 16);

	// read output[47]: from bit 758 to 773
	value = ((uint32_t)(input[94] & 0x03) << 30) |
			((uint32_t)input[95] << 22) |
			((uint32_t)(input[96] & 0xfc) << 14);
	output[47] = (double)(value >> 16);

	// read output[48]: from bit 774 to 789
	value = ((uint32_t)(input[96] & 0x03) << 30) |
			((uint32_t)input[97] << 22) |
			((uint32_t)(input[98] & 0xfc) << 14);
	output[48] = (double)(value >> 16);

	// read output[49]: from bit 790 to 805
	value = ((uint32_t)(input[98] & 0x03) << 30) |
			((uint32_t)input[99] << 22) |
			((uint32_t)(input[100] & 0xfc) << 14);
	output[49] = (double)(value >> 16);

	// read output[50]: from bit 806 to 821
	value = ((uint32_t)(input[100] & 0x03) << 30) |
			((uint32_t)input[101] << 22) |
			((uint32_t)(input[102] & 0xfc) << 14);
	output[50] = (double)(value >> 16);

	// read output[51]: from bit 822 to 837
	value = ((uint32_t)(input[102] & 0x03) << 30) |
			((uint32_t)input[103] << 22) |
			((uint32_t)(input[104] & 0xfc) << 14);
	output[51] = (double)(value >> 16);
}

static void unpack_52_16bit_unsigned_6off(const uint8_t * input, double * output, void *closure) {
	// Unpack 52 values into output
	// Values are 16-bit unsigned
	// Skip 6 bits, read 832 bits of data.
	// Input must be at least 105 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 6 to 21
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)(input[2] & 0xfc) << 14);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 22 to 37
	value = ((uint32_t)(input[2] & 0x03) << 30) |
			((uint32_t)input[3] << 22) |
			((uint32_t)(input[4] & 0xfc) << 14);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 38 to 53
	value = ((uint32_t)(input[4] & 0x03) << 30) |
			((uint32_t)input[5] << 22) |
			((uint32_t)(input[6] & 0xfc) << 14);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 54 to 69
	value = ((uint32_t)(input[6] & 0x03) << 30) |
			((uint32_t)input[7] << 22) |
			((uint32_t)(input[8] & 0xfc) << 14);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 70 to 85
	value = ((uint32_t)(input[8] & 0x03) << 30) |
			((uint32_t)input[9] << 22) |
			((uint32_t)(input[10] & 0xfc) << 14);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 86 to 101
	value = ((uint32_t)(input[10] & 0x03) << 30) |
			((uint32_t)input[11] << 22) |
			((uint32_t)(input[12] & 0xfc) << 14);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 102 to 117
	value = ((uint32_t)(input[12] & 0x03) << 30) |
			((uint32_t)input[13] << 22) |
			((uint32_t)(input[14] & 0xfc) << 14);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 118 to 133
	value = ((uint32_t)(input[14] & 0x03) << 30) |
			((uint32_t)input[15] << 22) |
			((uint32_t)(input[16] & 0xfc) << 14);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 134 to 149
	value = ((uint32_t)(input[16] & 0x03) << 30) |
			((uint32_t)input[17] << 22) |
			((uint32_t)(input[18] & 0xfc) << 14);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 150 to 165
	value = ((uint32_t)(input[18] & 0x03) << 30) |
			((uint32_t)input[19] << 22) |
			((uint32_t)(input[20] & 0xfc) << 14);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 166 to 181
	value = ((uint32_t)(input[20] & 0x03) << 30) |
			((uint32_t)input[21] << 22) |
			((uint32_t)(input[22] & 0xfc) << 14);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 182 to 197
	value = ((uint32_t)(input[22] & 0x03) << 30) |
			((uint32_t)input[23] << 22) |
			((uint32_t)(input[24] & 0xfc) << 14);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 198 to 213
	value = ((uint32_t)(input[24] & 0x03) << 30) |
			((uint32_t)input[25] << 22) |
			((uint32_t)(input[26] & 0xfc) << 14);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 214 to 229
	value = ((uint32_t)(input[26] & 0x03) << 30) |
			((uint32_t)input[27] << 22) |
			((uint32_t)(input[28] & 0xfc) << 14);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 230 to 245
	value = ((uint32_t)(input[28] & 0x03) << 30) |
			((uint32_t)input[29] << 22) |
			((uint32_t)(input[30] & 0xfc) << 14);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 246 to 261
	value = ((uint32_t)(input[30] & 0x03) << 30) |
			((uint32_t)input[31] << 22) |
			((uint32_t)(input[32] & 0xfc) << 14);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 262 to 277
	value = ((uint32_t)(input[32] & 0x03) << 30) |
			((uint32_t)input[33] << 22) |
			((uint32_t)(input[34] & 0xfc) << 14);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 278 to 293
	value = ((uint32_t)(input[34] & 0x03) << 30) |
			((uint32_t)input[35] << 22) |
			((uint32_t)(input[36] & 0xfc) << 14);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 294 to 309
	value = ((uint32_t)(input[36] & 0x03) << 30) |
			((uint32_t)input[37] << 22) |
			((uint32_t)(input[38] & 0xfc) << 14);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 310 to 325
	value = ((uint32_t)(input[38] & 0x03) << 30) |
			((uint32_t)input[39] << 22) |
			((uint32_t)(input[40] & 0xfc) << 14);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 326 to 341
	value = ((uint32_t)(input[40] & 0x03) << 30) |
			((uint32_t)input[41] << 22) |
			((uint32_t)(input[42] & 0xfc) << 14);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 342 to 357
	value = ((uint32_t)(input[42] & 0x03) << 30) |
			((uint32_t)input[43] << 22) |
			((uint32_t)(input[44] & 0xfc) << 14);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 358 to 373
	value = ((uint32_t)(input[44] & 0x03) << 30) |
			((uint32_t)input[45] << 22) |
			((uint32_t)(input[46] & 0xfc) << 14);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 374 to 389
	value = ((uint32_t)(input[46] & 0x03) << 30) |
			((uint32_t)input[47] << 22) |
			((uint32_t)(input[48] & 0xfc) << 14);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 390 to 405
	value = ((uint32_t)(input[48] & 0x03) << 30) |
			((uint32_t)input[49] << 22) |
			((uint32_t)(input[50] & 0xfc) << 14);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 406 to 421
	value = ((uint32_t)(input[50] & 0x03) << 30) |
			((uint32_t)input[51] << 22) |
			((uint32_t)(input[52] & 0xfc) << 14);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 422 to 437
	value = ((uint32_t)(input[52] & 0x03) << 30) |
			((uint32_t)input[53] << 22) |
			((uint32_t)(input[54] & 0xfc) << 14);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 438 to 453
	value = ((uint32_t)(input[54] & 0x03) << 30) |
			((uint32_t)input[55] << 22) |
			((uint32_t)(input[56] & 0xfc) << 14);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 454 to 469
	value = ((uint32_t)(input[56] & 0x03) << 30) |
			((uint32_t)input[57] << 22) |
			((uint32_t)(input[58] & 0xfc) << 14);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 470 to 485
	value = ((uint32_t)(input[58] & 0x03) << 30) |
			((uint32_t)input[59] << 22) |
			((uint32_t)(input[60] & 0xfc) << 14);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 486 to 501
	value = ((uint32_t)(input[60] & 0x03) << 30) |
			((uint32_t)input[61] << 22) |
			((uint32_t)(input[62] & 0xfc) << 14);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 502 to 517
	value = ((uint32_t)(input[62] & 0x03) << 30) |
			((uint32_t)input[63] << 22) |
			((uint32_t)(input[64] & 0xfc) << 14);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 518 to 533
	value = ((uint32_t)(input[64] & 0x03) << 30) |
			((uint32_t)input[65] << 22) |
			((uint32_t)(input[66] & 0xfc) << 14);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 534 to 549
	value = ((uint32_t)(input[66] & 0x03) << 30) |
			((uint32_t)input[67] << 22) |
			((uint32_t)(input[68] & 0xfc) << 14);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 550 to 565
	value = ((uint32_t)(input[68] & 0x03) << 30) |
			((uint32_t)input[69] << 22) |
			((uint32_t)(input[70] & 0xfc) << 14);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 566 to 581
	value = ((uint32_t)(input[70] & 0x03) << 30) |
			((uint32_t)input[71] << 22) |
			((uint32_t)(input[72] & 0xfc) << 14);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 582 to 597
	value = ((uint32_t)(input[72] & 0x03) << 30) |
			((uint32_t)input[73] << 22) |
			((uint32_t)(input[74] & 0xfc) << 14);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 598 to 613
	value = ((uint32_t)(input[74] & 0x03) << 30) |
			((uint32_t)input[75] << 22) |
			((uint32_t)(input[76] & 0xfc) << 14);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 614 to 629
	value = ((uint32_t)(input[76] & 0x03) << 30) |
			((uint32_t)input[77] << 22) |
			((uint32_t)(input[78] & 0xfc) << 14);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 630 to 645
	value = ((uint32_t)(input[78] & 0x03) << 30) |
			((uint32_t)input[79] << 22) |
			((uint32_t)(input[80] & 0xfc) << 14);
	output[39] = (double)(value >> 16);

	// read output[40]: from bit 646 to 661
	value = ((uint32_t)(input[80] & 0x03) << 30) |
			((uint32_t)input[81] << 22) |
			((uint32_t)(input[82] & 0xfc) << 14);
	output[40] = (double)(value >> 16);

	// read output[41]: from bit 662 to 677
	value = ((uint32_t)(input[82] & 0x03) << 30) |
			((uint32_t)input[83] << 22) |
			((uint32_t)(input[84] & 0xfc) << 14);
	output[41] = (double)(value >> 16);

	// read output[42]: from bit 678 to 693
	value = ((uint32_t)(input[84] & 0x03) << 30) |
			((uint32_t)input[85] << 22) |
			((uint32_t)(input[86] & 0xfc) << 14);
	output[42] = (double)(value >> 16);

	// read output[43]: from bit 694 to 709
	value = ((uint32_t)(input[86] & 0x03) << 30) |
			((uint32_t)input[87] << 22) |
			((uint32_t)(input[88] & 0xfc) << 14);
	output[43] = (double)(value >> 16);

	// read output[44]: from bit 710 to 725
	value = ((uint32_t)(input[88] & 0x03) << 30) |
			((uint32_t)input[89] << 22) |
			((uint32_t)(input[90] & 0xfc) << 14);
	output[44] = (double)(value >> 16);

	// read output[45]: from bit 726 to 741
	value = ((uint32_t)(input[90] & 0x03) << 30) |
			((uint32_t)input[91] << 22) |
			((uint32_t)(input[92] & 0xfc) << 14);
	output[45] = (double)(value >> 16);

	// read output[46]: from bit 742 to 757
	value = ((uint32_t)(input[92] & 0x03) << 30) |
			((uint32_t)input[93] << 22) |
			((uint32_t)(input[94] & 0xfc) << 14);
	output[46] = (double)(value >> 16);

	// read output[47]: from bit 758 to 773
	value = ((uint32_t)(input[94] & 0x03) << 30) |
			((uint32_t)input[95] << 22) |
			((uint32_t)(input[96] & 0xfc) << 14);
	output[47] = (double)(value >> 16);

	// read output[48]: from bit 774 to 789
	value = ((uint32_t)(input[96] & 0x03) << 30) |
			((uint32_t)input[97] << 22) |
			((uint32_t)(input[98] & 0xfc) << 14);
	output[48] = (double)(value >> 16);

	// read output[49]: from bit 790 to 805
	value = ((uint32_t)(input[98] & 0x03) << 30) |
			((uint32_t)input[99] << 22) |
			((uint32_t)(input[100] & 0xfc) << 14);
	output[49] = (double)(value >> 16);

	// read output[50]: from bit 806 to 821
	value = ((uint32_t)(input[100] & 0x03) << 30) |
			((uint32_t)input[101] << 22) |
			((uint32_t)(input[102] & 0xfc) << 14);
	output[50] = (double)(value >> 16);

	// read output[51]: from bit 822 to 837
	value = ((uint32_t)(input[102] & 0x03) << 30) |
			((uint32_t)input[103] << 22) |
			((uint32_t)(input[104] & 0xfc) << 14);
	output[51] = (double)(value >> 16);
}

static void unpack_52_16bit_signed_7off(const uint8_t * input, double * output, void *closure) {
	// Unpack 52 values into output
	// Values are 16-bit signed
	// Skip 7 bits, read 832 bits of data.
	// Input must be at least 105 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 7 to 22
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)(input[2] & 0xfe) << 15);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 23 to 38
	value = ((uint32_t)(input[2] & 0x01) << 31) |
			((uint32_t)input[3] << 23) |
			((uint32_t)(input[4] & 0xfe) << 15);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 39 to 54
	value = ((uint32_t)(input[4] & 0x01) << 31) |
			((uint32_t)input[5] << 23) |
			((uint32_t)(input[6] & 0xfe) << 15);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 55 to 70
	value = ((uint32_t)(input[6] & 0x01) << 31) |
			((uint32_t)input[7] << 23) |
			((uint32_t)(input[8] & 0xfe) << 15);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 71 to 86
	value = ((uint32_t)(input[8] & 0x01) << 31) |
			((uint32_t)input[9] << 23) |
			((uint32_t)(input[10] & 0xfe) << 15);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 87 to 102
	value = ((uint32_t)(input[10] & 0x01) << 31) |
			((uint32_t)input[11] << 23) |
			((uint32_t)(input[12] & 0xfe) << 15);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 103 to 118
	value = ((uint32_t)(input[12] & 0x01) << 31) |
			((uint32_t)input[13] << 23) |
			((uint32_t)(input[14] & 0xfe) << 15);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 119 to 134
	value = ((uint32_t)(input[14] & 0x01) << 31) |
			((uint32_t)input[15] << 23) |
			((uint32_t)(input[16] & 0xfe) << 15);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 135 to 150
	value = ((uint32_t)(input[16] & 0x01) << 31) |
			((uint32_t)input[17] << 23) |
			((uint32_t)(input[18] & 0xfe) << 15);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 151 to 166
	value = ((uint32_t)(input[18] & 0x01) << 31) |
			((uint32_t)input[19] << 23) |
			((uint32_t)(input[20] & 0xfe) << 15);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 167 to 182
	value = ((uint32_t)(input[20] & 0x01) << 31) |
			((uint32_t)input[21] << 23) |
			((uint32_t)(input[22] & 0xfe) << 15);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 183 to 198
	value = ((uint32_t)(input[22] & 0x01) << 31) |
			((uint32_t)input[23] << 23) |
			((uint32_t)(input[24] & 0xfe) << 15);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 199 to 214
	value = ((uint32_t)(input[24] & 0x01) << 31) |
			((uint32_t)input[25] << 23) |
			((uint32_t)(input[26] & 0xfe) << 15);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 215 to 230
	value = ((uint32_t)(input[26] & 0x01) << 31) |
			((uint32_t)input[27] << 23) |
			((uint32_t)(input[28] & 0xfe) << 15);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 231 to 246
	value = ((uint32_t)(input[28] & 0x01) << 31) |
			((uint32_t)input[29] << 23) |
			((uint32_t)(input[30] & 0xfe) << 15);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 247 to 262
	value = ((uint32_t)(input[30] & 0x01) << 31) |
			((uint32_t)input[31] << 23) |
			((uint32_t)(input[32] & 0xfe) << 15);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 263 to 278
	value = ((uint32_t)(input[32] & 0x01) << 31) |
			((uint32_t)input[33] << 23) |
			((uint32_t)(input[34] & 0xfe) << 15);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 279 to 294
	value = ((uint32_t)(input[34] & 0x01) << 31) |
			((uint32_t)input[35] << 23) |
			((uint32_t)(input[36] & 0xfe) << 15);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 295 to 310
	value = ((uint32_t)(input[36] & 0x01) << 31) |
			((uint32_t)input[37] << 23) |
			((uint32_t)(input[38] & 0xfe) << 15);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 311 to 326
	value = ((uint32_t)(input[38] & 0x01) << 31) |
			((uint32_t)input[39] << 23) |
			((uint32_t)(input[40] & 0xfe) << 15);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 327 to 342
	value = ((uint32_t)(input[40] & 0x01) << 31) |
			((uint32_t)input[41] << 23) |
			((uint32_t)(input[42] & 0xfe) << 15);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 343 to 358
	value = ((uint32_t)(input[42] & 0x01) << 31) |
			((uint32_t)input[43] << 23) |
			((uint32_t)(input[44] & 0xfe) << 15);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 359 to 374
	value = ((uint32_t)(input[44] & 0x01) << 31) |
			((uint32_t)input[45] << 23) |
			((uint32_t)(input[46] & 0xfe) << 15);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 375 to 390
	value = ((uint32_t)(input[46] & 0x01) << 31) |
			((uint32_t)input[47] << 23) |
			((uint32_t)(input[48] & 0xfe) << 15);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 391 to 406
	value = ((uint32_t)(input[48] & 0x01) << 31) |
			((uint32_t)input[49] << 23) |
			((uint32_t)(input[50] & 0xfe) << 15);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 407 to 422
	value = ((uint32_t)(input[50] & 0x01) << 31) |
			((uint32_t)input[51] << 23) |
			((uint32_t)(input[52] & 0xfe) << 15);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 423 to 438
	value = ((uint32_t)(input[52] & 0x01) << 31) |
			((uint32_t)input[53] << 23) |
			((uint32_t)(input[54] & 0xfe) << 15);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 439 to 454
	value = ((uint32_t)(input[54] & 0x01) << 31) |
			((uint32_t)input[55] << 23) |
			((uint32_t)(input[56] & 0xfe) << 15);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 455 to 470
	value = ((uint32_t)(input[56] & 0x01) << 31) |
			((uint32_t)input[57] << 23) |
			((uint32_t)(input[58] & 0xfe) << 15);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 471 to 486
	value = ((uint32_t)(input[58] & 0x01) << 31) |
			((uint32_t)input[59] << 23) |
			((uint32_t)(input[60] & 0xfe) << 15);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 487 to 502
	value = ((uint32_t)(input[60] & 0x01) << 31) |
			((uint32_t)input[61] << 23) |
			((uint32_t)(input[62] & 0xfe) << 15);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 503 to 518
	value = ((uint32_t)(input[62] & 0x01) << 31) |
			((uint32_t)input[63] << 23) |
			((uint32_t)(input[64] & 0xfe) << 15);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 519 to 534
	value = ((uint32_t)(input[64] & 0x01) << 31) |
			((uint32_t)input[65] << 23) |
			((uint32_t)(input[66] & 0xfe) << 15);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 535 to 550
	value = ((uint32_t)(input[66] & 0x01) << 31) |
			((uint32_t)input[67] << 23) |
			((uint32_t)(input[68] & 0xfe) << 15);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 551 to 566
	value = ((uint32_t)(input[68] & 0x01) << 31) |
			((uint32_t)input[69] << 23) |
			((uint32_t)(input[70] & 0xfe) << 15);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 567 to 582
	value = ((uint32_t)(input[70] & 0x01) << 31) |
			((uint32_t)input[71] << 23) |
			((uint32_t)(input[72] & 0xfe) << 15);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 583 to 598
	value = ((uint32_t)(input[72] & 0x01) << 31) |
			((uint32_t)input[73] << 23) |
			((uint32_t)(input[74] & 0xfe) << 15);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 599 to 614
	value = ((uint32_t)(input[74] & 0x01) << 31) |
			((uint32_t)input[75] << 23) |
			((uint32_t)(input[76] & 0xfe) << 15);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 615 to 630
	value = ((uint32_t)(input[76] & 0x01) << 31) |
			((uint32_t)input[77] << 23) |
			((uint32_t)(input[78] & 0xfe) << 15);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 631 to 646
	value = ((uint32_t)(input[78] & 0x01) << 31) |
			((uint32_t)input[79] << 23) |
			((uint32_t)(input[80] & 0xfe) << 15);
	output[39] = (double)(value >> 16);

	// read output[40]: from bit 647 to 662
	value = ((uint32_t)(input[80] & 0x01) << 31) |
			((uint32_t)input[81] << 23) |
			((uint32_t)(input[82] & 0xfe) << 15);
	output[40] = (double)(value >> 16);

	// read output[41]: from bit 663 to 678
	value = ((uint32_t)(input[82] & 0x01) << 31) |
			((uint32_t)input[83] << 23) |
			((uint32_t)(input[84] & 0xfe) << 15);
	output[41] = (double)(value >> 16);

	// read output[42]: from bit 679 to 694
	value = ((uint32_t)(input[84] & 0x01) << 31) |
			((uint32_t)input[85] << 23) |
			((uint32_t)(input[86] & 0xfe) << 15);
	output[42] = (double)(value >> 16);

	// read output[43]: from bit 695 to 710
	value = ((uint32_t)(input[86] & 0x01) << 31) |
			((uint32_t)input[87] << 23) |
			((uint32_t)(input[88] & 0xfe) << 15);
	output[43] = (double)(value >> 16);

	// read output[44]: from bit 711 to 726
	value = ((uint32_t)(input[88] & 0x01) << 31) |
			((uint32_t)input[89] << 23) |
			((uint32_t)(input[90] & 0xfe) << 15);
	output[44] = (double)(value >> 16);

	// read output[45]: from bit 727 to 742
	value = ((uint32_t)(input[90] & 0x01) << 31) |
			((uint32_t)input[91] << 23) |
			((uint32_t)(input[92] & 0xfe) << 15);
	output[45] = (double)(value >> 16);

	// read output[46]: from bit 743 to 758
	value = ((uint32_t)(input[92] & 0x01) << 31) |
			((uint32_t)input[93] << 23) |
			((uint32_t)(input[94] & 0xfe) << 15);
	output[46] = (double)(value >> 16);

	// read output[47]: from bit 759 to 774
	value = ((uint32_t)(input[94] & 0x01) << 31) |
			((uint32_t)input[95] << 23) |
			((uint32_t)(input[96] & 0xfe) << 15);
	output[47] = (double)(value >> 16);

	// read output[48]: from bit 775 to 790
	value = ((uint32_t)(input[96] & 0x01) << 31) |
			((uint32_t)input[97] << 23) |
			((uint32_t)(input[98] & 0xfe) << 15);
	output[48] = (double)(value >> 16);

	// read output[49]: from bit 791 to 806
	value = ((uint32_t)(input[98] & 0x01) << 31) |
			((uint32_t)input[99] << 23) |
			((uint32_t)(input[100] & 0xfe) << 15);
	output[49] = (double)(value >> 16);

	// read output[50]: from bit 807 to 822
	value = ((uint32_t)(input[100] & 0x01) << 31) |
			((uint32_t)input[101] << 23) |
			((uint32_t)(input[102] & 0xfe) << 15);
	output[50] = (double)(value >> 16);

	// read output[51]: from bit 823 to 838
	value = ((uint32_t)(input[102] & 0x01) << 31) |
			((uint32_t)input[103] << 23) |
			((uint32_t)(input[104] & 0xfe) << 15);
	output[51] = (double)(value >> 16);
}

static void unpack_52_16bit_unsigned_7off(const uint8_t * input, double * output, void *closure) {
	// Unpack 52 values into output
	// Values are 16-bit unsigned
	// Skip 7 bits, read 832 bits of data.
	// Input must be at least 105 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 7 to 22
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)(input[2] & 0xfe) << 15);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 23 to 38
	value = ((uint32_t)(input[2] & 0x01) << 31) |
			((uint32_t)input[3] << 23) |
			((uint32_t)(input[4] & 0xfe) << 15);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 39 to 54
	value = ((uint32_t)(input[4] & 0x01) << 31) |
			((uint32_t)input[5] << 23) |
			((uint32_t)(input[6] & 0xfe) << 15);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 55 to 70
	value = ((uint32_t)(input[6] & 0x01) << 31) |
			((uint32_t)input[7] << 23) |
			((uint32_t)(input[8] & 0xfe) << 15);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 71 to 86
	value = ((uint32_t)(input[8] & 0x01) << 31) |
			((uint32_t)input[9] << 23) |
			((uint32_t)(input[10] & 0xfe) << 15);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 87 to 102
	value = ((uint32_t)(input[10] & 0x01) << 31) |
			((uint32_t)input[11] << 23) |
			((uint32_t)(input[12] & 0xfe) << 15);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 103 to 118
	value = ((uint32_t)(input[12] & 0x01) << 31) |
			((uint32_t)input[13] << 23) |
			((uint32_t)(input[14] & 0xfe) << 15);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 119 to 134
	value = ((uint32_t)(input[14] & 0x01) << 31) |
			((uint32_t)input[15] << 23) |
			((uint32_t)(input[16] & 0xfe) << 15);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 135 to 150
	value = ((uint32_t)(input[16] & 0x01) << 31) |
			((uint32_t)input[17] << 23) |
			((uint32_t)(input[18] & 0xfe) << 15);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 151 to 166
	value = ((uint32_t)(input[18] & 0x01) << 31) |
			((uint32_t)input[19] << 23) |
			((uint32_t)(input[20] & 0xfe) << 15);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 167 to 182
	value = ((uint32_t)(input[20] & 0x01) << 31) |
			((uint32_t)input[21] << 23) |
			((uint32_t)(input[22] & 0xfe) << 15);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 183 to 198
	value = ((uint32_t)(input[22] & 0x01) << 31) |
			((uint32_t)input[23] << 23) |
			((uint32_t)(input[24] & 0xfe) << 15);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 199 to 214
	value = ((uint32_t)(input[24] & 0x01) << 31) |
			((uint32_t)input[25] << 23) |
			((uint32_t)(input[26] & 0xfe) << 15);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 215 to 230
	value = ((uint32_t)(input[26] & 0x01) << 31) |
			((uint32_t)input[27] << 23) |
			((uint32_t)(input[28] & 0xfe) << 15);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 231 to 246
	value = ((uint32_t)(input[28] & 0x01) << 31) |
			((uint32_t)input[29] << 23) |
			((uint32_t)(input[30] & 0xfe) << 15);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 247 to 262
	value = ((uint32_t)(input[30] & 0x01) << 31) |
			((uint32_t)input[31] << 23) |
			((uint32_t)(input[32] & 0xfe) << 15);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 263 to 278
	value = ((uint32_t)(input[32] & 0x01) << 31) |
			((uint32_t)input[33] << 23) |
			((uint32_t)(input[34] & 0xfe) << 15);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 279 to 294
	value = ((uint32_t)(input[34] & 0x01) << 31) |
			((uint32_t)input[35] << 23) |
			((uint32_t)(input[36] & 0xfe) << 15);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 295 to 310
	value = ((uint32_t)(input[36] & 0x01) << 31) |
			((uint32_t)input[37] << 23) |
			((uint32_t)(input[38] & 0xfe) << 15);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 311 to 326
	value = ((uint32_t)(input[38] & 0x01) << 31) |
			((uint32_t)input[39] << 23) |
			((uint32_t)(input[40] & 0xfe) << 15);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 327 to 342
	value = ((uint32_t)(input[40] & 0x01) << 31) |
			((uint32_t)input[41] << 23) |
			((uint32_t)(input[42] & 0xfe) << 15);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 343 to 358
	value = ((uint32_t)(input[42] & 0x01) << 31) |
			((uint32_t)input[43] << 23) |
			((uint32_t)(input[44] & 0xfe) << 15);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 359 to 374
	value = ((uint32_t)(input[44] & 0x01) << 31) |
			((uint32_t)input[45] << 23) |
			((uint32_t)(input[46] & 0xfe) << 15);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 375 to 390
	value = ((uint32_t)(input[46] & 0x01) << 31) |
			((uint32_t)input[47] << 23) |
			((uint32_t)(input[48] & 0xfe) << 15);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 391 to 406
	value = ((uint32_t)(input[48] & 0x01) << 31) |
			((uint32_t)input[49] << 23) |
			((uint32_t)(input[50] & 0xfe) << 15);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 407 to 422
	value = ((uint32_t)(input[50] & 0x01) << 31) |
			((uint32_t)input[51] << 23) |
			((uint32_t)(input[52] & 0xfe) << 15);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 423 to 438
	value = ((uint32_t)(input[52] & 0x01) << 31) |
			((uint32_t)input[53] << 23) |
			((uint32_t)(input[54] & 0xfe) << 15);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 439 to 454
	value = ((uint32_t)(input[54] & 0x01) << 31) |
			((uint32_t)input[55] << 23) |
			((uint32_t)(input[56] & 0xfe) << 15);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 455 to 470
	value = ((uint32_t)(input[56] & 0x01) << 31) |
			((uint32_t)input[57] << 23) |
			((uint32_t)(input[58] & 0xfe) << 15);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 471 to 486
	value = ((uint32_t)(input[58] & 0x01) << 31) |
			((uint32_t)input[59] << 23) |
			((uint32_t)(input[60] & 0xfe) << 15);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 487 to 502
	value = ((uint32_t)(input[60] & 0x01) << 31) |
			((uint32_t)input[61] << 23) |
			((uint32_t)(input[62] & 0xfe) << 15);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 503 to 518
	value = ((uint32_t)(input[62] & 0x01) << 31) |
			((uint32_t)input[63] << 23) |
			((uint32_t)(input[64] & 0xfe) << 15);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 519 to 534
	value = ((uint32_t)(input[64] & 0x01) << 31) |
			((uint32_t)input[65] << 23) |
			((uint32_t)(input[66] & 0xfe) << 15);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 535 to 550
	value = ((uint32_t)(input[66] & 0x01) << 31) |
			((uint32_t)input[67] << 23) |
			((uint32_t)(input[68] & 0xfe) << 15);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 551 to 566
	value = ((uint32_t)(input[68] & 0x01) << 31) |
			((uint32_t)input[69] << 23) |
			((uint32_t)(input[70] & 0xfe) << 15);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 567 to 582
	value = ((uint32_t)(input[70] & 0x01) << 31) |
			((uint32_t)input[71] << 23) |
			((uint32_t)(input[72] & 0xfe) << 15);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 583 to 598
	value = ((uint32_t)(input[72] & 0x01) << 31) |
			((uint32_t)input[73] << 23) |
			((uint32_t)(input[74] & 0xfe) << 15);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 599 to 614
	value = ((uint32_t)(input[74] & 0x01) << 31) |
			((uint32_t)input[75] << 23) |
			((uint32_t)(input[76] & 0xfe) << 15);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 615 to 630
	value = ((uint32_t)(input[76] & 0x01) << 31) |
			((uint32_t)input[77] << 23) |
			((uint32_t)(input[78] & 0xfe) << 15);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 631 to 646
	value = ((uint32_t)(input[78] & 0x01) << 31) |
			((uint32_t)input[79] << 23) |
			((uint32_t)(input[80] & 0xfe) << 15);
	output[39] = (double)(value >> 16);

	// read output[40]: from bit 647 to 662
	value = ((uint32_t)(input[80] & 0x01) << 31) |
			((uint32_t)input[81] << 23) |
			((uint32_t)(input[82] & 0xfe) << 15);
	output[40] = (double)(value >> 16);

	// read output[41]: from bit 663 to 678
	value = ((uint32_t)(input[82] & 0x01) << 31) |
			((uint32_t)input[83] << 23) |
			((uint32_t)(input[84] & 0xfe) << 15);
	output[41] = (double)(value >> 16);

	// read output[42]: from bit 679 to 694
	value = ((uint32_t)(input[84] & 0x01) << 31) |
			((uint32_t)input[85] << 23) |
			((uint32_t)(input[86] & 0xfe) << 15);
	output[42] = (double)(value >> 16);

	// read output[43]: from bit 695 to 710
	value = ((uint32_t)(input[86] & 0x01) << 31) |
			((uint32_t)input[87] << 23) |
			((uint32_t)(input[88] & 0xfe) << 15);
	output[43] = (double)(value >> 16);

	// read output[44]: from bit 711 to 726
	value = ((uint32_t)(input[88] & 0x01) << 31) |
			((uint32_t)input[89] << 23) |
			((uint32_t)(input[90] & 0xfe) << 15);
	output[44] = (double)(value >> 16);

	// read output[45]: from bit 727 to 742
	value = ((uint32_t)(input[90] & 0x01) << 31) |
			((uint32_t)input[91] << 23) |
			((uint32_t)(input[92] & 0xfe) << 15);
	output[45] = (double)(value >> 16);

	// read output[46]: from bit 743 to 758
	value = ((uint32_t)(input[92] & 0x01) << 31) |
			((uint32_t)input[93] << 23) |
			((uint32_t)(input[94] & 0xfe) << 15);
	output[46] = (double)(value >> 16);

	// read output[47]: from bit 759 to 774
	value = ((uint32_t)(input[94] & 0x01) << 31) |
			((uint32_t)input[95] << 23) |
			((uint32_t)(input[96] & 0xfe) << 15);
	output[47] = (double)(value >> 16);

	// read output[48]: from bit 775 to 790
	value = ((uint32_t)(input[96] & 0x01) << 31) |
			((uint32_t)input[97] << 23) |
			((uint32_t)(input[98] & 0xfe) << 15);
	output[48] = (double)(value >> 16);

	// read output[49]: from bit 791 to 806
	value = ((uint32_t)(input[98] & 0x01) << 31) |
			((uint32_t)input[99] << 23) |
			((uint32_t)(input[100] & 0xfe) << 15);
	output[49] = (double)(value >> 16);

	// read output[50]: from bit 807 to 822
	value = ((uint32_t)(input[100] & 0x01) << 31) |
			((uint32_t)input[101] << 23) |
			((uint32_t)(input[102] & 0xfe) << 15);
	output[50] = (double)(value >> 16);

	// read output[51]: from bit 823 to 838
	value = ((uint32_t)(input[102] & 0x01) << 31) |
			((uint32_t)input[103] << 23) |
			((uint32_t)(input[104] & 0xfe) << 15);
	output[51] = (double)(value >> 16);
}

static void unpack_53_16bit_signed_0off(const uint8_t * input, double * output, void *closure) {
	// Unpack 53 values into output
	// Values are 16-bit signed
	// Skip 0 bits, read 848 bits of data.
	// Input must be at least 106 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 0 to 15
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)input[1] << 16);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 16 to 31
	value = ((uint32_t)input[2] << 24) |
			((uint32_t)input[3] << 16);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 32 to 47
	value = ((uint32_t)input[4] << 24) |
			((uint32_t)input[5] << 16);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 48 to 63
	value = ((uint32_t)input[6] << 24) |
			((uint32_t)input[7] << 16);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 64 to 79
	value = ((uint32_t)input[8] << 24) |
			((uint32_t)input[9] << 16);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 80 to 95
	value = ((uint32_t)input[10] << 24) |
			((uint32_t)input[11] << 16);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 96 to 111
	value = ((uint32_t)input[12] << 24) |
			((uint32_t)input[13] << 16);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 112 to 127
	value = ((uint32_t)input[14] << 24) |
			((uint32_t)input[15] << 16);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 128 to 143
	value = ((uint32_t)input[16] << 24) |
			((uint32_t)input[17] << 16);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 144 to 159
	value = ((uint32_t)input[18] << 24) |
			((uint32_t)input[19] << 16);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 160 to 175
	value = ((uint32_t)input[20] << 24) |
			((uint32_t)input[21] << 16);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 176 to 191
	value = ((uint32_t)input[22] << 24) |
			((uint32_t)input[23] << 16);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 192 to 207
	value = ((uint32_t)input[24] << 24) |
			((uint32_t)input[25] << 16);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 208 to 223
	value = ((uint32_t)input[26] << 24) |
			((uint32_t)input[27] << 16);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 224 to 239
	value = ((uint32_t)input[28] << 24) |
			((uint32_t)input[29] << 16);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 240 to 255
	value = ((uint32_t)input[30] << 24) |
			((uint32_t)input[31] << 16);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 256 to 271
	value = ((uint32_t)input[32] << 24) |
			((uint32_t)input[33] << 16);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 272 to 287
	value = ((uint32_t)input[34] << 24) |
			((uint32_t)input[35] << 16);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 288 to 303
	value = ((uint32_t)input[36] << 24) |
			((uint32_t)input[37] << 16);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 304 to 319
	value = ((uint32_t)input[38] << 24) |
			((uint32_t)input[39] << 16);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 320 to 335
	value = ((uint32_t)input[40] << 24) |
			((uint32_t)input[41] << 16);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 336 to 351
	value = ((uint32_t)input[42] << 24) |
			((uint32_t)input[43] << 16);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 352 to 367
	value = ((uint32_t)input[44] << 24) |
			((uint32_t)input[45] << 16);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 368 to 383
	value = ((uint32_t)input[46] << 24) |
			((uint32_t)input[47] << 16);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 384 to 399
	value = ((uint32_t)input[48] << 24) |
			((uint32_t)input[49] << 16);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 400 to 415
	value = ((uint32_t)input[50] << 24) |
			((uint32_t)input[51] << 16);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 416 to 431
	value = ((uint32_t)input[52] << 24) |
			((uint32_t)input[53] << 16);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 432 to 447
	value = ((uint32_t)input[54] << 24) |
			((uint32_t)input[55] << 16);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 448 to 463
	value = ((uint32_t)input[56] << 24) |
			((uint32_t)input[57] << 16);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 464 to 479
	value = ((uint32_t)input[58] << 24) |
			((uint32_t)input[59] << 16);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 480 to 495
	value = ((uint32_t)input[60] << 24) |
			((uint32_t)input[61] << 16);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 496 to 511
	value = ((uint32_t)input[62] << 24) |
			((uint32_t)input[63] << 16);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 512 to 527
	value = ((uint32_t)input[64] << 24) |
			((uint32_t)input[65] << 16);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 528 to 543
	value = ((uint32_t)input[66] << 24) |
			((uint32_t)input[67] << 16);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 544 to 559
	value = ((uint32_t)input[68] << 24) |
			((uint32_t)input[69] << 16);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 560 to 575
	value = ((uint32_t)input[70] << 24) |
			((uint32_t)input[71] << 16);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 576 to 591
	value = ((uint32_t)input[72] << 24) |
			((uint32_t)input[73] << 16);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 592 to 607
	value = ((uint32_t)input[74] << 24) |
			((uint32_t)input[75] << 16);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 608 to 623
	value = ((uint32_t)input[76] << 24) |
			((uint32_t)input[77] << 16);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 624 to 639
	value = ((uint32_t)input[78] << 24) |
			((uint32_t)input[79] << 16);
	output[39] = (double)(value >> 16);

	// read output[40]: from bit 640 to 655
	value = ((uint32_t)input[80] << 24) |
			((uint32_t)input[81] << 16);
	output[40] = (double)(value >> 16);

	// read output[41]: from bit 656 to 671
	value = ((uint32_t)input[82] << 24) |
			((uint32_t)input[83] << 16);
	output[41] = (double)(value >> 16);

	// read output[42]: from bit 672 to 687
	value = ((uint32_t)input[84] << 24) |
			((uint32_t)input[85] << 16);
	output[42] = (double)(value >> 16);

	// read output[43]: from bit 688 to 703
	value = ((uint32_t)input[86] << 24) |
			((uint32_t)input[87] << 16);
	output[43] = (double)(value >> 16);

	// read output[44]: from bit 704 to 719
	value = ((uint32_t)input[88] << 24) |
			((uint32_t)input[89] << 16);
	output[44] = (double)(value >> 16);

	// read output[45]: from bit 720 to 735
	value = ((uint32_t)input[90] << 24) |
			((uint32_t)input[91] << 16);
	output[45] = (double)(value >> 16);

	// read output[46]: from bit 736 to 751
	value = ((uint32_t)input[92] << 24) |
			((uint32_t)input[93] << 16);
	output[46] = (double)(value >> 16);

	// read output[47]: from bit 752 to 767
	value = ((uint32_t)input[94] << 24) |
			((uint32_t)input[95] << 16);
	output[47] = (double)(value >> 16);

	// read output[48]: from bit 768 to 783
	value = ((uint32_t)input[96] << 24) |
			((uint32_t)input[97] << 16);
	output[48] = (double)(value >> 16);

	// read output[49]: from bit 784 to 799
	value = ((uint32_t)input[98] << 24) |
			((uint32_t)input[99] << 16);
	output[49] = (double)(value >> 16);

	// read output[50]: from bit 800 to 815
	value = ((uint32_t)input[100] << 24) |
			((uint32_t)input[101] << 16);
	output[50] = (double)(value >> 16);

	// read output[51]: from bit 816 to 831
	value = ((uint32_t)input[102] << 24) |
			((uint32_t)input[103] << 16);
	output[51] = (double)(value >> 16);

	// read output[52]: from bit 832 to 847
	value = ((uint32_t)input[104] << 24) |
			((uint32_t)input[105] << 16);
	output[52] = (double)(value >> 16);
}

static void unpack_53_16bit_unsigned_0off(const uint8_t * input, double * output, void *closure) {
	// Unpack 53 values into output
	// Values are 16-bit unsigned
	// Skip 0 bits, read 848 bits of data.
	// Input must be at least 106 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 0 to 15
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)input[1] << 16);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 16 to 31
	value = ((uint32_t)input[2] << 24) |
			((uint32_t)input[3] << 16);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 32 to 47
	value = ((uint32_t)input[4] << 24) |
			((uint32_t)input[5] << 16);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 48 to 63
	value = ((uint32_t)input[6] << 24) |
			((uint32_t)input[7] << 16);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 64 to 79
	value = ((uint32_t)input[8] << 24) |
			((uint32_t)input[9] << 16);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 80 to 95
	value = ((uint32_t)input[10] << 24) |
			((uint32_t)input[11] << 16);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 96 to 111
	value = ((uint32_t)input[12] << 24) |
			((uint32_t)input[13] << 16);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 112 to 127
	value = ((uint32_t)input[14] << 24) |
			((uint32_t)input[15] << 16);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 128 to 143
	value = ((uint32_t)input[16] << 24) |
			((uint32_t)input[17] << 16);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 144 to 159
	value = ((uint32_t)input[18] << 24) |
			((uint32_t)input[19] << 16);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 160 to 175
	value = ((uint32_t)input[20] << 24) |
			((uint32_t)input[21] << 16);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 176 to 191
	value = ((uint32_t)input[22] << 24) |
			((uint32_t)input[23] << 16);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 192 to 207
	value = ((uint32_t)input[24] << 24) |
			((uint32_t)input[25] << 16);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 208 to 223
	value = ((uint32_t)input[26] << 24) |
			((uint32_t)input[27] << 16);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 224 to 239
	value = ((uint32_t)input[28] << 24) |
			((uint32_t)input[29] << 16);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 240 to 255
	value = ((uint32_t)input[30] << 24) |
			((uint32_t)input[31] << 16);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 256 to 271
	value = ((uint32_t)input[32] << 24) |
			((uint32_t)input[33] << 16);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 272 to 287
	value = ((uint32_t)input[34] << 24) |
			((uint32_t)input[35] << 16);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 288 to 303
	value = ((uint32_t)input[36] << 24) |
			((uint32_t)input[37] << 16);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 304 to 319
	value = ((uint32_t)input[38] << 24) |
			((uint32_t)input[39] << 16);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 320 to 335
	value = ((uint32_t)input[40] << 24) |
			((uint32_t)input[41] << 16);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 336 to 351
	value = ((uint32_t)input[42] << 24) |
			((uint32_t)input[43] << 16);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 352 to 367
	value = ((uint32_t)input[44] << 24) |
			((uint32_t)input[45] << 16);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 368 to 383
	value = ((uint32_t)input[46] << 24) |
			((uint32_t)input[47] << 16);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 384 to 399
	value = ((uint32_t)input[48] << 24) |
			((uint32_t)input[49] << 16);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 400 to 415
	value = ((uint32_t)input[50] << 24) |
			((uint32_t)input[51] << 16);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 416 to 431
	value = ((uint32_t)input[52] << 24) |
			((uint32_t)input[53] << 16);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 432 to 447
	value = ((uint32_t)input[54] << 24) |
			((uint32_t)input[55] << 16);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 448 to 463
	value = ((uint32_t)input[56] << 24) |
			((uint32_t)input[57] << 16);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 464 to 479
	value = ((uint32_t)input[58] << 24) |
			((uint32_t)input[59] << 16);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 480 to 495
	value = ((uint32_t)input[60] << 24) |
			((uint32_t)input[61] << 16);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 496 to 511
	value = ((uint32_t)input[62] << 24) |
			((uint32_t)input[63] << 16);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 512 to 527
	value = ((uint32_t)input[64] << 24) |
			((uint32_t)input[65] << 16);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 528 to 543
	value = ((uint32_t)input[66] << 24) |
			((uint32_t)input[67] << 16);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 544 to 559
	value = ((uint32_t)input[68] << 24) |
			((uint32_t)input[69] << 16);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 560 to 575
	value = ((uint32_t)input[70] << 24) |
			((uint32_t)input[71] << 16);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 576 to 591
	value = ((uint32_t)input[72] << 24) |
			((uint32_t)input[73] << 16);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 592 to 607
	value = ((uint32_t)input[74] << 24) |
			((uint32_t)input[75] << 16);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 608 to 623
	value = ((uint32_t)input[76] << 24) |
			((uint32_t)input[77] << 16);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 624 to 639
	value = ((uint32_t)input[78] << 24) |
			((uint32_t)input[79] << 16);
	output[39] = (double)(value >> 16);

	// read output[40]: from bit 640 to 655
	value = ((uint32_t)input[80] << 24) |
			((uint32_t)input[81] << 16);
	output[40] = (double)(value >> 16);

	// read output[41]: from bit 656 to 671
	value = ((uint32_t)input[82] << 24) |
			((uint32_t)input[83] << 16);
	output[41] = (double)(value >> 16);

	// read output[42]: from bit 672 to 687
	value = ((uint32_t)input[84] << 24) |
			((uint32_t)input[85] << 16);
	output[42] = (double)(value >> 16);

	// read output[43]: from bit 688 to 703
	value = ((uint32_t)input[86] << 24) |
			((uint32_t)input[87] << 16);
	output[43] = (double)(value >> 16);

	// read output[44]: from bit 704 to 719
	value = ((uint32_t)input[88] << 24) |
			((uint32_t)input[89] << 16);
	output[44] = (double)(value >> 16);

	// read output[45]: from bit 720 to 735
	value = ((uint32_t)input[90] << 24) |
			((uint32_t)input[91] << 16);
	output[45] = (double)(value >> 16);

	// read output[46]: from bit 736 to 751
	value = ((uint32_t)input[92] << 24) |
			((uint32_t)input[93] << 16);
	output[46] = (double)(value >> 16);

	// read output[47]: from bit 752 to 767
	value = ((uint32_t)input[94] << 24) |
			((uint32_t)input[95] << 16);
	output[47] = (double)(value >> 16);

	// read output[48]: from bit 768 to 783
	value = ((uint32_t)input[96] << 24) |
			((uint32_t)input[97] << 16);
	output[48] = (double)(value >> 16);

	// read output[49]: from bit 784 to 799
	value = ((uint32_t)input[98] << 24) |
			((uint32_t)input[99] << 16);
	output[49] = (double)(value >> 16);

	// read output[50]: from bit 800 to 815
	value = ((uint32_t)input[100] << 24) |
			((uint32_t)input[101] << 16);
	output[50] = (double)(value >> 16);

	// read output[51]: from bit 816 to 831
	value = ((uint32_t)input[102] << 24) |
			((uint32_t)input[103] << 16);
	output[51] = (double)(value >> 16);

	// read output[52]: from bit 832 to 847
	value = ((uint32_t)input[104] << 24) |
			((uint32_t)input[105] << 16);
	output[52] = (double)(value >> 16);
}

static void unpack_53_16bit_signed_1off(const uint8_t * input, double * output, void *closure) {
	// Unpack 53 values into output
	// Values are 16-bit signed
	// Skip 1 bits, read 848 bits of data.
	// Input must be at least 107 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 1 to 16
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)input[1] << 17) |
			((uint32_t)(input[2] & 0x80) << 9);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 17 to 32
	value = ((uint32_t)(input[2] & 0x7f) << 25) |
			((uint32_t)input[3] << 17) |
			((uint32_t)(input[4] & 0x80) << 9);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 33 to 48
	value = ((uint32_t)(input[4] & 0x7f) << 25) |
			((uint32_t)input[5] << 17) |
			((uint32_t)(input[6] & 0x80) << 9);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 49 to 64
	value = ((uint32_t)(input[6] & 0x7f) << 25) |
			((uint32_t)input[7] << 17) |
			((uint32_t)(input[8] & 0x80) << 9);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 65 to 80
	value = ((uint32_t)(input[8] & 0x7f) << 25) |
			((uint32_t)input[9] << 17) |
			((uint32_t)(input[10] & 0x80) << 9);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 81 to 96
	value = ((uint32_t)(input[10] & 0x7f) << 25) |
			((uint32_t)input[11] << 17) |
			((uint32_t)(input[12] & 0x80) << 9);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 97 to 112
	value = ((uint32_t)(input[12] & 0x7f) << 25) |
			((uint32_t)input[13] << 17) |
			((uint32_t)(input[14] & 0x80) << 9);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 113 to 128
	value = ((uint32_t)(input[14] & 0x7f) << 25) |
			((uint32_t)input[15] << 17) |
			((uint32_t)(input[16] & 0x80) << 9);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 129 to 144
	value = ((uint32_t)(input[16] & 0x7f) << 25) |
			((uint32_t)input[17] << 17) |
			((uint32_t)(input[18] & 0x80) << 9);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 145 to 160
	value = ((uint32_t)(input[18] & 0x7f) << 25) |
			((uint32_t)input[19] << 17) |
			((uint32_t)(input[20] & 0x80) << 9);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 161 to 176
	value = ((uint32_t)(input[20] & 0x7f) << 25) |
			((uint32_t)input[21] << 17) |
			((uint32_t)(input[22] & 0x80) << 9);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 177 to 192
	value = ((uint32_t)(input[22] & 0x7f) << 25) |
			((uint32_t)input[23] << 17) |
			((uint32_t)(input[24] & 0x80) << 9);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 193 to 208
	value = ((uint32_t)(input[24] & 0x7f) << 25) |
			((uint32_t)input[25] << 17) |
			((uint32_t)(input[26] & 0x80) << 9);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 209 to 224
	value = ((uint32_t)(input[26] & 0x7f) << 25) |
			((uint32_t)input[27] << 17) |
			((uint32_t)(input[28] & 0x80) << 9);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 225 to 240
	value = ((uint32_t)(input[28] & 0x7f) << 25) |
			((uint32_t)input[29] << 17) |
			((uint32_t)(input[30] & 0x80) << 9);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 241 to 256
	value = ((uint32_t)(input[30] & 0x7f) << 25) |
			((uint32_t)input[31] << 17) |
			((uint32_t)(input[32] & 0x80) << 9);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 257 to 272
	value = ((uint32_t)(input[32] & 0x7f) << 25) |
			((uint32_t)input[33] << 17) |
			((uint32_t)(input[34] & 0x80) << 9);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 273 to 288
	value = ((uint32_t)(input[34] & 0x7f) << 25) |
			((uint32_t)input[35] << 17) |
			((uint32_t)(input[36] & 0x80) << 9);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 289 to 304
	value = ((uint32_t)(input[36] & 0x7f) << 25) |
			((uint32_t)input[37] << 17) |
			((uint32_t)(input[38] & 0x80) << 9);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 305 to 320
	value = ((uint32_t)(input[38] & 0x7f) << 25) |
			((uint32_t)input[39] << 17) |
			((uint32_t)(input[40] & 0x80) << 9);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 321 to 336
	value = ((uint32_t)(input[40] & 0x7f) << 25) |
			((uint32_t)input[41] << 17) |
			((uint32_t)(input[42] & 0x80) << 9);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 337 to 352
	value = ((uint32_t)(input[42] & 0x7f) << 25) |
			((uint32_t)input[43] << 17) |
			((uint32_t)(input[44] & 0x80) << 9);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 353 to 368
	value = ((uint32_t)(input[44] & 0x7f) << 25) |
			((uint32_t)input[45] << 17) |
			((uint32_t)(input[46] & 0x80) << 9);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 369 to 384
	value = ((uint32_t)(input[46] & 0x7f) << 25) |
			((uint32_t)input[47] << 17) |
			((uint32_t)(input[48] & 0x80) << 9);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 385 to 400
	value = ((uint32_t)(input[48] & 0x7f) << 25) |
			((uint32_t)input[49] << 17) |
			((uint32_t)(input[50] & 0x80) << 9);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 401 to 416
	value = ((uint32_t)(input[50] & 0x7f) << 25) |
			((uint32_t)input[51] << 17) |
			((uint32_t)(input[52] & 0x80) << 9);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 417 to 432
	value = ((uint32_t)(input[52] & 0x7f) << 25) |
			((uint32_t)input[53] << 17) |
			((uint32_t)(input[54] & 0x80) << 9);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 433 to 448
	value = ((uint32_t)(input[54] & 0x7f) << 25) |
			((uint32_t)input[55] << 17) |
			((uint32_t)(input[56] & 0x80) << 9);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 449 to 464
	value = ((uint32_t)(input[56] & 0x7f) << 25) |
			((uint32_t)input[57] << 17) |
			((uint32_t)(input[58] & 0x80) << 9);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 465 to 480
	value = ((uint32_t)(input[58] & 0x7f) << 25) |
			((uint32_t)input[59] << 17) |
			((uint32_t)(input[60] & 0x80) << 9);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 481 to 496
	value = ((uint32_t)(input[60] & 0x7f) << 25) |
			((uint32_t)input[61] << 17) |
			((uint32_t)(input[62] & 0x80) << 9);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 497 to 512
	value = ((uint32_t)(input[62] & 0x7f) << 25) |
			((uint32_t)input[63] << 17) |
			((uint32_t)(input[64] & 0x80) << 9);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 513 to 528
	value = ((uint32_t)(input[64] & 0x7f) << 25) |
			((uint32_t)input[65] << 17) |
			((uint32_t)(input[66] & 0x80) << 9);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 529 to 544
	value = ((uint32_t)(input[66] & 0x7f) << 25) |
			((uint32_t)input[67] << 17) |
			((uint32_t)(input[68] & 0x80) << 9);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 545 to 560
	value = ((uint32_t)(input[68] & 0x7f) << 25) |
			((uint32_t)input[69] << 17) |
			((uint32_t)(input[70] & 0x80) << 9);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 561 to 576
	value = ((uint32_t)(input[70] & 0x7f) << 25) |
			((uint32_t)input[71] << 17) |
			((uint32_t)(input[72] & 0x80) << 9);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 577 to 592
	value = ((uint32_t)(input[72] & 0x7f) << 25) |
			((uint32_t)input[73] << 17) |
			((uint32_t)(input[74] & 0x80) << 9);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 593 to 608
	value = ((uint32_t)(input[74] & 0x7f) << 25) |
			((uint32_t)input[75] << 17) |
			((uint32_t)(input[76] & 0x80) << 9);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 609 to 624
	value = ((uint32_t)(input[76] & 0x7f) << 25) |
			((uint32_t)input[77] << 17) |
			((uint32_t)(input[78] & 0x80) << 9);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 625 to 640
	value = ((uint32_t)(input[78] & 0x7f) << 25) |
			((uint32_t)input[79] << 17) |
			((uint32_t)(input[80] & 0x80) << 9);
	output[39] = (double)(value >> 16);

	// read output[40]: from bit 641 to 656
	value = ((uint32_t)(input[80] & 0x7f) << 25) |
			((uint32_t)input[81] << 17) |
			((uint32_t)(input[82] & 0x80) << 9);
	output[40] = (double)(value >> 16);

	// read output[41]: from bit 657 to 672
	value = ((uint32_t)(input[82] & 0x7f) << 25) |
			((uint32_t)input[83] << 17) |
			((uint32_t)(input[84] & 0x80) << 9);
	output[41] = (double)(value >> 16);

	// read output[42]: from bit 673 to 688
	value = ((uint32_t)(input[84] & 0x7f) << 25) |
			((uint32_t)input[85] << 17) |
			((uint32_t)(input[86] & 0x80) << 9);
	output[42] = (double)(value >> 16);

	// read output[43]: from bit 689 to 704
	value = ((uint32_t)(input[86] & 0x7f) << 25) |
			((uint32_t)input[87] << 17) |
			((uint32_t)(input[88] & 0x80) << 9);
	output[43] = (double)(value >> 16);

	// read output[44]: from bit 705 to 720
	value = ((uint32_t)(input[88] & 0x7f) << 25) |
			((uint32_t)input[89] << 17) |
			((uint32_t)(input[90] & 0x80) << 9);
	output[44] = (double)(value >> 16);

	// read output[45]: from bit 721 to 736
	value = ((uint32_t)(input[90] & 0x7f) << 25) |
			((uint32_t)input[91] << 17) |
			((uint32_t)(input[92] & 0x80) << 9);
	output[45] = (double)(value >> 16);

	// read output[46]: from bit 737 to 752
	value = ((uint32_t)(input[92] & 0x7f) << 25) |
			((uint32_t)input[93] << 17) |
			((uint32_t)(input[94] & 0x80) << 9);
	output[46] = (double)(value >> 16);

	// read output[47]: from bit 753 to 768
	value = ((uint32_t)(input[94] & 0x7f) << 25) |
			((uint32_t)input[95] << 17) |
			((uint32_t)(input[96] & 0x80) << 9);
	output[47] = (double)(value >> 16);

	// read output[48]: from bit 769 to 784
	value = ((uint32_t)(input[96] & 0x7f) << 25) |
			((uint32_t)input[97] << 17) |
			((uint32_t)(input[98] & 0x80) << 9);
	output[48] = (double)(value >> 16);

	// read output[49]: from bit 785 to 800
	value = ((uint32_t)(input[98] & 0x7f) << 25) |
			((uint32_t)input[99] << 17) |
			((uint32_t)(input[100] & 0x80) << 9);
	output[49] = (double)(value >> 16);

	// read output[50]: from bit 801 to 816
	value = ((uint32_t)(input[100] & 0x7f) << 25) |
			((uint32_t)input[101] << 17) |
			((uint32_t)(input[102] & 0x80) << 9);
	output[50] = (double)(value >> 16);

	// read output[51]: from bit 817 to 832
	value = ((uint32_t)(input[102] & 0x7f) << 25) |
			((uint32_t)input[103] << 17) |
			((uint32_t)(input[104] & 0x80) << 9);
	output[51] = (double)(value >> 16);

	// read output[52]: from bit 833 to 848
	value = ((uint32_t)(input[104] & 0x7f) << 25) |
			((uint32_t)input[105] << 17) |
			((uint32_t)(input[106] & 0x80) << 9);
	output[52] = (double)(value >> 16);
}

static void unpack_53_16bit_unsigned_1off(const uint8_t * input, double * output, void *closure) {
	// Unpack 53 values into output
	// Values are 16-bit unsigned
	// Skip 1 bits, read 848 bits of data.
	// Input must be at least 107 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 1 to 16
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)input[1] << 17) |
			((uint32_t)(input[2] & 0x80) << 9);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 17 to 32
	value = ((uint32_t)(input[2] & 0x7f) << 25) |
			((uint32_t)input[3] << 17) |
			((uint32_t)(input[4] & 0x80) << 9);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 33 to 48
	value = ((uint32_t)(input[4] & 0x7f) << 25) |
			((uint32_t)input[5] << 17) |
			((uint32_t)(input[6] & 0x80) << 9);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 49 to 64
	value = ((uint32_t)(input[6] & 0x7f) << 25) |
			((uint32_t)input[7] << 17) |
			((uint32_t)(input[8] & 0x80) << 9);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 65 to 80
	value = ((uint32_t)(input[8] & 0x7f) << 25) |
			((uint32_t)input[9] << 17) |
			((uint32_t)(input[10] & 0x80) << 9);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 81 to 96
	value = ((uint32_t)(input[10] & 0x7f) << 25) |
			((uint32_t)input[11] << 17) |
			((uint32_t)(input[12] & 0x80) << 9);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 97 to 112
	value = ((uint32_t)(input[12] & 0x7f) << 25) |
			((uint32_t)input[13] << 17) |
			((uint32_t)(input[14] & 0x80) << 9);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 113 to 128
	value = ((uint32_t)(input[14] & 0x7f) << 25) |
			((uint32_t)input[15] << 17) |
			((uint32_t)(input[16] & 0x80) << 9);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 129 to 144
	value = ((uint32_t)(input[16] & 0x7f) << 25) |
			((uint32_t)input[17] << 17) |
			((uint32_t)(input[18] & 0x80) << 9);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 145 to 160
	value = ((uint32_t)(input[18] & 0x7f) << 25) |
			((uint32_t)input[19] << 17) |
			((uint32_t)(input[20] & 0x80) << 9);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 161 to 176
	value = ((uint32_t)(input[20] & 0x7f) << 25) |
			((uint32_t)input[21] << 17) |
			((uint32_t)(input[22] & 0x80) << 9);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 177 to 192
	value = ((uint32_t)(input[22] & 0x7f) << 25) |
			((uint32_t)input[23] << 17) |
			((uint32_t)(input[24] & 0x80) << 9);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 193 to 208
	value = ((uint32_t)(input[24] & 0x7f) << 25) |
			((uint32_t)input[25] << 17) |
			((uint32_t)(input[26] & 0x80) << 9);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 209 to 224
	value = ((uint32_t)(input[26] & 0x7f) << 25) |
			((uint32_t)input[27] << 17) |
			((uint32_t)(input[28] & 0x80) << 9);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 225 to 240
	value = ((uint32_t)(input[28] & 0x7f) << 25) |
			((uint32_t)input[29] << 17) |
			((uint32_t)(input[30] & 0x80) << 9);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 241 to 256
	value = ((uint32_t)(input[30] & 0x7f) << 25) |
			((uint32_t)input[31] << 17) |
			((uint32_t)(input[32] & 0x80) << 9);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 257 to 272
	value = ((uint32_t)(input[32] & 0x7f) << 25) |
			((uint32_t)input[33] << 17) |
			((uint32_t)(input[34] & 0x80) << 9);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 273 to 288
	value = ((uint32_t)(input[34] & 0x7f) << 25) |
			((uint32_t)input[35] << 17) |
			((uint32_t)(input[36] & 0x80) << 9);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 289 to 304
	value = ((uint32_t)(input[36] & 0x7f) << 25) |
			((uint32_t)input[37] << 17) |
			((uint32_t)(input[38] & 0x80) << 9);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 305 to 320
	value = ((uint32_t)(input[38] & 0x7f) << 25) |
			((uint32_t)input[39] << 17) |
			((uint32_t)(input[40] & 0x80) << 9);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 321 to 336
	value = ((uint32_t)(input[40] & 0x7f) << 25) |
			((uint32_t)input[41] << 17) |
			((uint32_t)(input[42] & 0x80) << 9);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 337 to 352
	value = ((uint32_t)(input[42] & 0x7f) << 25) |
			((uint32_t)input[43] << 17) |
			((uint32_t)(input[44] & 0x80) << 9);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 353 to 368
	value = ((uint32_t)(input[44] & 0x7f) << 25) |
			((uint32_t)input[45] << 17) |
			((uint32_t)(input[46] & 0x80) << 9);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 369 to 384
	value = ((uint32_t)(input[46] & 0x7f) << 25) |
			((uint32_t)input[47] << 17) |
			((uint32_t)(input[48] & 0x80) << 9);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 385 to 400
	value = ((uint32_t)(input[48] & 0x7f) << 25) |
			((uint32_t)input[49] << 17) |
			((uint32_t)(input[50] & 0x80) << 9);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 401 to 416
	value = ((uint32_t)(input[50] & 0x7f) << 25) |
			((uint32_t)input[51] << 17) |
			((uint32_t)(input[52] & 0x80) << 9);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 417 to 432
	value = ((uint32_t)(input[52] & 0x7f) << 25) |
			((uint32_t)input[53] << 17) |
			((uint32_t)(input[54] & 0x80) << 9);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 433 to 448
	value = ((uint32_t)(input[54] & 0x7f) << 25) |
			((uint32_t)input[55] << 17) |
			((uint32_t)(input[56] & 0x80) << 9);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 449 to 464
	value = ((uint32_t)(input[56] & 0x7f) << 25) |
			((uint32_t)input[57] << 17) |
			((uint32_t)(input[58] & 0x80) << 9);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 465 to 480
	value = ((uint32_t)(input[58] & 0x7f) << 25) |
			((uint32_t)input[59] << 17) |
			((uint32_t)(input[60] & 0x80) << 9);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 481 to 496
	value = ((uint32_t)(input[60] & 0x7f) << 25) |
			((uint32_t)input[61] << 17) |
			((uint32_t)(input[62] & 0x80) << 9);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 497 to 512
	value = ((uint32_t)(input[62] & 0x7f) << 25) |
			((uint32_t)input[63] << 17) |
			((uint32_t)(input[64] & 0x80) << 9);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 513 to 528
	value = ((uint32_t)(input[64] & 0x7f) << 25) |
			((uint32_t)input[65] << 17) |
			((uint32_t)(input[66] & 0x80) << 9);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 529 to 544
	value = ((uint32_t)(input[66] & 0x7f) << 25) |
			((uint32_t)input[67] << 17) |
			((uint32_t)(input[68] & 0x80) << 9);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 545 to 560
	value = ((uint32_t)(input[68] & 0x7f) << 25) |
			((uint32_t)input[69] << 17) |
			((uint32_t)(input[70] & 0x80) << 9);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 561 to 576
	value = ((uint32_t)(input[70] & 0x7f) << 25) |
			((uint32_t)input[71] << 17) |
			((uint32_t)(input[72] & 0x80) << 9);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 577 to 592
	value = ((uint32_t)(input[72] & 0x7f) << 25) |
			((uint32_t)input[73] << 17) |
			((uint32_t)(input[74] & 0x80) << 9);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 593 to 608
	value = ((uint32_t)(input[74] & 0x7f) << 25) |
			((uint32_t)input[75] << 17) |
			((uint32_t)(input[76] & 0x80) << 9);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 609 to 624
	value = ((uint32_t)(input[76] & 0x7f) << 25) |
			((uint32_t)input[77] << 17) |
			((uint32_t)(input[78] & 0x80) << 9);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 625 to 640
	value = ((uint32_t)(input[78] & 0x7f) << 25) |
			((uint32_t)input[79] << 17) |
			((uint32_t)(input[80] & 0x80) << 9);
	output[39] = (double)(value >> 16);

	// read output[40]: from bit 641 to 656
	value = ((uint32_t)(input[80] & 0x7f) << 25) |
			((uint32_t)input[81] << 17) |
			((uint32_t)(input[82] & 0x80) << 9);
	output[40] = (double)(value >> 16);

	// read output[41]: from bit 657 to 672
	value = ((uint32_t)(input[82] & 0x7f) << 25) |
			((uint32_t)input[83] << 17) |
			((uint32_t)(input[84] & 0x80) << 9);
	output[41] = (double)(value >> 16);

	// read output[42]: from bit 673 to 688
	value = ((uint32_t)(input[84] & 0x7f) << 25) |
			((uint32_t)input[85] << 17) |
			((uint32_t)(input[86] & 0x80) << 9);
	output[42] = (double)(value >> 16);

	// read output[43]: from bit 689 to 704
	value = ((uint32_t)(input[86] & 0x7f) << 25) |
			((uint32_t)input[87] << 17) |
			((uint32_t)(input[88] & 0x80) << 9);
	output[43] = (double)(value >> 16);

	// read output[44]: from bit 705 to 720
	value = ((uint32_t)(input[88] & 0x7f) << 25) |
			((uint32_t)input[89] << 17) |
			((uint32_t)(input[90] & 0x80) << 9);
	output[44] = (double)(value >> 16);

	// read output[45]: from bit 721 to 736
	value = ((uint32_t)(input[90] & 0x7f) << 25) |
			((uint32_t)input[91] << 17) |
			((uint32_t)(input[92] & 0x80) << 9);
	output[45] = (double)(value >> 16);

	// read output[46]: from bit 737 to 752
	value = ((uint32_t)(input[92] & 0x7f) << 25) |
			((uint32_t)input[93] << 17) |
			((uint32_t)(input[94] & 0x80) << 9);
	output[46] = (double)(value >> 16);

	// read output[47]: from bit 753 to 768
	value = ((uint32_t)(input[94] & 0x7f) << 25) |
			((uint32_t)input[95] << 17) |
			((uint32_t)(input[96] & 0x80) << 9);
	output[47] = (double)(value >> 16);

	// read output[48]: from bit 769 to 784
	value = ((uint32_t)(input[96] & 0x7f) << 25) |
			((uint32_t)input[97] << 17) |
			((uint32_t)(input[98] & 0x80) << 9);
	output[48] = (double)(value >> 16);

	// read output[49]: from bit 785 to 800
	value = ((uint32_t)(input[98] & 0x7f) << 25) |
			((uint32_t)input[99] << 17) |
			((uint32_t)(input[100] & 0x80) << 9);
	output[49] = (double)(value >> 16);

	// read output[50]: from bit 801 to 816
	value = ((uint32_t)(input[100] & 0x7f) << 25) |
			((uint32_t)input[101] << 17) |
			((uint32_t)(input[102] & 0x80) << 9);
	output[50] = (double)(value >> 16);

	// read output[51]: from bit 817 to 832
	value = ((uint32_t)(input[102] & 0x7f) << 25) |
			((uint32_t)input[103] << 17) |
			((uint32_t)(input[104] & 0x80) << 9);
	output[51] = (double)(value >> 16);

	// read output[52]: from bit 833 to 848
	value = ((uint32_t)(input[104] & 0x7f) << 25) |
			((uint32_t)input[105] << 17) |
			((uint32_t)(input[106] & 0x80) << 9);
	output[52] = (double)(value >> 16);
}

static void unpack_53_16bit_signed_2off(const uint8_t * input, double * output, void *closure) {
	// Unpack 53 values into output
	// Values are 16-bit signed
	// Skip 2 bits, read 848 bits of data.
	// Input must be at least 107 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 2 to 17
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)input[1] << 18) |
			((uint32_t)(input[2] & 0xc0) << 10);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 18 to 33
	value = ((uint32_t)(input[2] & 0x3f) << 26) |
			((uint32_t)input[3] << 18) |
			((uint32_t)(input[4] & 0xc0) << 10);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 34 to 49
	value = ((uint32_t)(input[4] & 0x3f) << 26) |
			((uint32_t)input[5] << 18) |
			((uint32_t)(input[6] & 0xc0) << 10);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 50 to 65
	value = ((uint32_t)(input[6] & 0x3f) << 26) |
			((uint32_t)input[7] << 18) |
			((uint32_t)(input[8] & 0xc0) << 10);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 66 to 81
	value = ((uint32_t)(input[8] & 0x3f) << 26) |
			((uint32_t)input[9] << 18) |
			((uint32_t)(input[10] & 0xc0) << 10);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 82 to 97
	value = ((uint32_t)(input[10] & 0x3f) << 26) |
			((uint32_t)input[11] << 18) |
			((uint32_t)(input[12] & 0xc0) << 10);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 98 to 113
	value = ((uint32_t)(input[12] & 0x3f) << 26) |
			((uint32_t)input[13] << 18) |
			((uint32_t)(input[14] & 0xc0) << 10);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 114 to 129
	value = ((uint32_t)(input[14] & 0x3f) << 26) |
			((uint32_t)input[15] << 18) |
			((uint32_t)(input[16] & 0xc0) << 10);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 130 to 145
	value = ((uint32_t)(input[16] & 0x3f) << 26) |
			((uint32_t)input[17] << 18) |
			((uint32_t)(input[18] & 0xc0) << 10);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 146 to 161
	value = ((uint32_t)(input[18] & 0x3f) << 26) |
			((uint32_t)input[19] << 18) |
			((uint32_t)(input[20] & 0xc0) << 10);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 162 to 177
	value = ((uint32_t)(input[20] & 0x3f) << 26) |
			((uint32_t)input[21] << 18) |
			((uint32_t)(input[22] & 0xc0) << 10);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 178 to 193
	value = ((uint32_t)(input[22] & 0x3f) << 26) |
			((uint32_t)input[23] << 18) |
			((uint32_t)(input[24] & 0xc0) << 10);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 194 to 209
	value = ((uint32_t)(input[24] & 0x3f) << 26) |
			((uint32_t)input[25] << 18) |
			((uint32_t)(input[26] & 0xc0) << 10);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 210 to 225
	value = ((uint32_t)(input[26] & 0x3f) << 26) |
			((uint32_t)input[27] << 18) |
			((uint32_t)(input[28] & 0xc0) << 10);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 226 to 241
	value = ((uint32_t)(input[28] & 0x3f) << 26) |
			((uint32_t)input[29] << 18) |
			((uint32_t)(input[30] & 0xc0) << 10);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 242 to 257
	value = ((uint32_t)(input[30] & 0x3f) << 26) |
			((uint32_t)input[31] << 18) |
			((uint32_t)(input[32] & 0xc0) << 10);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 258 to 273
	value = ((uint32_t)(input[32] & 0x3f) << 26) |
			((uint32_t)input[33] << 18) |
			((uint32_t)(input[34] & 0xc0) << 10);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 274 to 289
	value = ((uint32_t)(input[34] & 0x3f) << 26) |
			((uint32_t)input[35] << 18) |
			((uint32_t)(input[36] & 0xc0) << 10);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 290 to 305
	value = ((uint32_t)(input[36] & 0x3f) << 26) |
			((uint32_t)input[37] << 18) |
			((uint32_t)(input[38] & 0xc0) << 10);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 306 to 321
	value = ((uint32_t)(input[38] & 0x3f) << 26) |
			((uint32_t)input[39] << 18) |
			((uint32_t)(input[40] & 0xc0) << 10);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 322 to 337
	value = ((uint32_t)(input[40] & 0x3f) << 26) |
			((uint32_t)input[41] << 18) |
			((uint32_t)(input[42] & 0xc0) << 10);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 338 to 353
	value = ((uint32_t)(input[42] & 0x3f) << 26) |
			((uint32_t)input[43] << 18) |
			((uint32_t)(input[44] & 0xc0) << 10);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 354 to 369
	value = ((uint32_t)(input[44] & 0x3f) << 26) |
			((uint32_t)input[45] << 18) |
			((uint32_t)(input[46] & 0xc0) << 10);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 370 to 385
	value = ((uint32_t)(input[46] & 0x3f) << 26) |
			((uint32_t)input[47] << 18) |
			((uint32_t)(input[48] & 0xc0) << 10);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 386 to 401
	value = ((uint32_t)(input[48] & 0x3f) << 26) |
			((uint32_t)input[49] << 18) |
			((uint32_t)(input[50] & 0xc0) << 10);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 402 to 417
	value = ((uint32_t)(input[50] & 0x3f) << 26) |
			((uint32_t)input[51] << 18) |
			((uint32_t)(input[52] & 0xc0) << 10);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 418 to 433
	value = ((uint32_t)(input[52] & 0x3f) << 26) |
			((uint32_t)input[53] << 18) |
			((uint32_t)(input[54] & 0xc0) << 10);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 434 to 449
	value = ((uint32_t)(input[54] & 0x3f) << 26) |
			((uint32_t)input[55] << 18) |
			((uint32_t)(input[56] & 0xc0) << 10);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 450 to 465
	value = ((uint32_t)(input[56] & 0x3f) << 26) |
			((uint32_t)input[57] << 18) |
			((uint32_t)(input[58] & 0xc0) << 10);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 466 to 481
	value = ((uint32_t)(input[58] & 0x3f) << 26) |
			((uint32_t)input[59] << 18) |
			((uint32_t)(input[60] & 0xc0) << 10);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 482 to 497
	value = ((uint32_t)(input[60] & 0x3f) << 26) |
			((uint32_t)input[61] << 18) |
			((uint32_t)(input[62] & 0xc0) << 10);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 498 to 513
	value = ((uint32_t)(input[62] & 0x3f) << 26) |
			((uint32_t)input[63] << 18) |
			((uint32_t)(input[64] & 0xc0) << 10);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 514 to 529
	value = ((uint32_t)(input[64] & 0x3f) << 26) |
			((uint32_t)input[65] << 18) |
			((uint32_t)(input[66] & 0xc0) << 10);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 530 to 545
	value = ((uint32_t)(input[66] & 0x3f) << 26) |
			((uint32_t)input[67] << 18) |
			((uint32_t)(input[68] & 0xc0) << 10);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 546 to 561
	value = ((uint32_t)(input[68] & 0x3f) << 26) |
			((uint32_t)input[69] << 18) |
			((uint32_t)(input[70] & 0xc0) << 10);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 562 to 577
	value = ((uint32_t)(input[70] & 0x3f) << 26) |
			((uint32_t)input[71] << 18) |
			((uint32_t)(input[72] & 0xc0) << 10);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 578 to 593
	value = ((uint32_t)(input[72] & 0x3f) << 26) |
			((uint32_t)input[73] << 18) |
			((uint32_t)(input[74] & 0xc0) << 10);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 594 to 609
	value = ((uint32_t)(input[74] & 0x3f) << 26) |
			((uint32_t)input[75] << 18) |
			((uint32_t)(input[76] & 0xc0) << 10);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 610 to 625
	value = ((uint32_t)(input[76] & 0x3f) << 26) |
			((uint32_t)input[77] << 18) |
			((uint32_t)(input[78] & 0xc0) << 10);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 626 to 641
	value = ((uint32_t)(input[78] & 0x3f) << 26) |
			((uint32_t)input[79] << 18) |
			((uint32_t)(input[80] & 0xc0) << 10);
	output[39] = (double)(value >> 16);

	// read output[40]: from bit 642 to 657
	value = ((uint32_t)(input[80] & 0x3f) << 26) |
			((uint32_t)input[81] << 18) |
			((uint32_t)(input[82] & 0xc0) << 10);
	output[40] = (double)(value >> 16);

	// read output[41]: from bit 658 to 673
	value = ((uint32_t)(input[82] & 0x3f) << 26) |
			((uint32_t)input[83] << 18) |
			((uint32_t)(input[84] & 0xc0) << 10);
	output[41] = (double)(value >> 16);

	// read output[42]: from bit 674 to 689
	value = ((uint32_t)(input[84] & 0x3f) << 26) |
			((uint32_t)input[85] << 18) |
			((uint32_t)(input[86] & 0xc0) << 10);
	output[42] = (double)(value >> 16);

	// read output[43]: from bit 690 to 705
	value = ((uint32_t)(input[86] & 0x3f) << 26) |
			((uint32_t)input[87] << 18) |
			((uint32_t)(input[88] & 0xc0) << 10);
	output[43] = (double)(value >> 16);

	// read output[44]: from bit 706 to 721
	value = ((uint32_t)(input[88] & 0x3f) << 26) |
			((uint32_t)input[89] << 18) |
			((uint32_t)(input[90] & 0xc0) << 10);
	output[44] = (double)(value >> 16);

	// read output[45]: from bit 722 to 737
	value = ((uint32_t)(input[90] & 0x3f) << 26) |
			((uint32_t)input[91] << 18) |
			((uint32_t)(input[92] & 0xc0) << 10);
	output[45] = (double)(value >> 16);

	// read output[46]: from bit 738 to 753
	value = ((uint32_t)(input[92] & 0x3f) << 26) |
			((uint32_t)input[93] << 18) |
			((uint32_t)(input[94] & 0xc0) << 10);
	output[46] = (double)(value >> 16);

	// read output[47]: from bit 754 to 769
	value = ((uint32_t)(input[94] & 0x3f) << 26) |
			((uint32_t)input[95] << 18) |
			((uint32_t)(input[96] & 0xc0) << 10);
	output[47] = (double)(value >> 16);

	// read output[48]: from bit 770 to 785
	value = ((uint32_t)(input[96] & 0x3f) << 26) |
			((uint32_t)input[97] << 18) |
			((uint32_t)(input[98] & 0xc0) << 10);
	output[48] = (double)(value >> 16);

	// read output[49]: from bit 786 to 801
	value = ((uint32_t)(input[98] & 0x3f) << 26) |
			((uint32_t)input[99] << 18) |
			((uint32_t)(input[100] & 0xc0) << 10);
	output[49] = (double)(value >> 16);

	// read output[50]: from bit 802 to 817
	value = ((uint32_t)(input[100] & 0x3f) << 26) |
			((uint32_t)input[101] << 18) |
			((uint32_t)(input[102] & 0xc0) << 10);
	output[50] = (double)(value >> 16);

	// read output[51]: from bit 818 to 833
	value = ((uint32_t)(input[102] & 0x3f) << 26) |
			((uint32_t)input[103] << 18) |
			((uint32_t)(input[104] & 0xc0) << 10);
	output[51] = (double)(value >> 16);

	// read output[52]: from bit 834 to 849
	value = ((uint32_t)(input[104] & 0x3f) << 26) |
			((uint32_t)input[105] << 18) |
			((uint32_t)(input[106] & 0xc0) << 10);
	output[52] = (double)(value >> 16);
}

static void unpack_53_16bit_unsigned_2off(const uint8_t * input, double * output, void *closure) {
	// Unpack 53 values into output
	// Values are 16-bit unsigned
	// Skip 2 bits, read 848 bits of data.
	// Input must be at least 107 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 2 to 17
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)input[1] << 18) |
			((uint32_t)(input[2] & 0xc0) << 10);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 18 to 33
	value = ((uint32_t)(input[2] & 0x3f) << 26) |
			((uint32_t)input[3] << 18) |
			((uint32_t)(input[4] & 0xc0) << 10);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 34 to 49
	value = ((uint32_t)(input[4] & 0x3f) << 26) |
			((uint32_t)input[5] << 18) |
			((uint32_t)(input[6] & 0xc0) << 10);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 50 to 65
	value = ((uint32_t)(input[6] & 0x3f) << 26) |
			((uint32_t)input[7] << 18) |
			((uint32_t)(input[8] & 0xc0) << 10);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 66 to 81
	value = ((uint32_t)(input[8] & 0x3f) << 26) |
			((uint32_t)input[9] << 18) |
			((uint32_t)(input[10] & 0xc0) << 10);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 82 to 97
	value = ((uint32_t)(input[10] & 0x3f) << 26) |
			((uint32_t)input[11] << 18) |
			((uint32_t)(input[12] & 0xc0) << 10);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 98 to 113
	value = ((uint32_t)(input[12] & 0x3f) << 26) |
			((uint32_t)input[13] << 18) |
			((uint32_t)(input[14] & 0xc0) << 10);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 114 to 129
	value = ((uint32_t)(input[14] & 0x3f) << 26) |
			((uint32_t)input[15] << 18) |
			((uint32_t)(input[16] & 0xc0) << 10);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 130 to 145
	value = ((uint32_t)(input[16] & 0x3f) << 26) |
			((uint32_t)input[17] << 18) |
			((uint32_t)(input[18] & 0xc0) << 10);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 146 to 161
	value = ((uint32_t)(input[18] & 0x3f) << 26) |
			((uint32_t)input[19] << 18) |
			((uint32_t)(input[20] & 0xc0) << 10);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 162 to 177
	value = ((uint32_t)(input[20] & 0x3f) << 26) |
			((uint32_t)input[21] << 18) |
			((uint32_t)(input[22] & 0xc0) << 10);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 178 to 193
	value = ((uint32_t)(input[22] & 0x3f) << 26) |
			((uint32_t)input[23] << 18) |
			((uint32_t)(input[24] & 0xc0) << 10);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 194 to 209
	value = ((uint32_t)(input[24] & 0x3f) << 26) |
			((uint32_t)input[25] << 18) |
			((uint32_t)(input[26] & 0xc0) << 10);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 210 to 225
	value = ((uint32_t)(input[26] & 0x3f) << 26) |
			((uint32_t)input[27] << 18) |
			((uint32_t)(input[28] & 0xc0) << 10);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 226 to 241
	value = ((uint32_t)(input[28] & 0x3f) << 26) |
			((uint32_t)input[29] << 18) |
			((uint32_t)(input[30] & 0xc0) << 10);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 242 to 257
	value = ((uint32_t)(input[30] & 0x3f) << 26) |
			((uint32_t)input[31] << 18) |
			((uint32_t)(input[32] & 0xc0) << 10);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 258 to 273
	value = ((uint32_t)(input[32] & 0x3f) << 26) |
			((uint32_t)input[33] << 18) |
			((uint32_t)(input[34] & 0xc0) << 10);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 274 to 289
	value = ((uint32_t)(input[34] & 0x3f) << 26) |
			((uint32_t)input[35] << 18) |
			((uint32_t)(input[36] & 0xc0) << 10);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 290 to 305
	value = ((uint32_t)(input[36] & 0x3f) << 26) |
			((uint32_t)input[37] << 18) |
			((uint32_t)(input[38] & 0xc0) << 10);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 306 to 321
	value = ((uint32_t)(input[38] & 0x3f) << 26) |
			((uint32_t)input[39] << 18) |
			((uint32_t)(input[40] & 0xc0) << 10);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 322 to 337
	value = ((uint32_t)(input[40] & 0x3f) << 26) |
			((uint32_t)input[41] << 18) |
			((uint32_t)(input[42] & 0xc0) << 10);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 338 to 353
	value = ((uint32_t)(input[42] & 0x3f) << 26) |
			((uint32_t)input[43] << 18) |
			((uint32_t)(input[44] & 0xc0) << 10);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 354 to 369
	value = ((uint32_t)(input[44] & 0x3f) << 26) |
			((uint32_t)input[45] << 18) |
			((uint32_t)(input[46] & 0xc0) << 10);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 370 to 385
	value = ((uint32_t)(input[46] & 0x3f) << 26) |
			((uint32_t)input[47] << 18) |
			((uint32_t)(input[48] & 0xc0) << 10);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 386 to 401
	value = ((uint32_t)(input[48] & 0x3f) << 26) |
			((uint32_t)input[49] << 18) |
			((uint32_t)(input[50] & 0xc0) << 10);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 402 to 417
	value = ((uint32_t)(input[50] & 0x3f) << 26) |
			((uint32_t)input[51] << 18) |
			((uint32_t)(input[52] & 0xc0) << 10);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 418 to 433
	value = ((uint32_t)(input[52] & 0x3f) << 26) |
			((uint32_t)input[53] << 18) |
			((uint32_t)(input[54] & 0xc0) << 10);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 434 to 449
	value = ((uint32_t)(input[54] & 0x3f) << 26) |
			((uint32_t)input[55] << 18) |
			((uint32_t)(input[56] & 0xc0) << 10);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 450 to 465
	value = ((uint32_t)(input[56] & 0x3f) << 26) |
			((uint32_t)input[57] << 18) |
			((uint32_t)(input[58] & 0xc0) << 10);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 466 to 481
	value = ((uint32_t)(input[58] & 0x3f) << 26) |
			((uint32_t)input[59] << 18) |
			((uint32_t)(input[60] & 0xc0) << 10);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 482 to 497
	value = ((uint32_t)(input[60] & 0x3f) << 26) |
			((uint32_t)input[61] << 18) |
			((uint32_t)(input[62] & 0xc0) << 10);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 498 to 513
	value = ((uint32_t)(input[62] & 0x3f) << 26) |
			((uint32_t)input[63] << 18) |
			((uint32_t)(input[64] & 0xc0) << 10);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 514 to 529
	value = ((uint32_t)(input[64] & 0x3f) << 26) |
			((uint32_t)input[65] << 18) |
			((uint32_t)(input[66] & 0xc0) << 10);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 530 to 545
	value = ((uint32_t)(input[66] & 0x3f) << 26) |
			((uint32_t)input[67] << 18) |
			((uint32_t)(input[68] & 0xc0) << 10);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 546 to 561
	value = ((uint32_t)(input[68] & 0x3f) << 26) |
			((uint32_t)input[69] << 18) |
			((uint32_t)(input[70] & 0xc0) << 10);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 562 to 577
	value = ((uint32_t)(input[70] & 0x3f) << 26) |
			((uint32_t)input[71] << 18) |
			((uint32_t)(input[72] & 0xc0) << 10);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 578 to 593
	value = ((uint32_t)(input[72] & 0x3f) << 26) |
			((uint32_t)input[73] << 18) |
			((uint32_t)(input[74] & 0xc0) << 10);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 594 to 609
	value = ((uint32_t)(input[74] & 0x3f) << 26) |
			((uint32_t)input[75] << 18) |
			((uint32_t)(input[76] & 0xc0) << 10);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 610 to 625
	value = ((uint32_t)(input[76] & 0x3f) << 26) |
			((uint32_t)input[77] << 18) |
			((uint32_t)(input[78] & 0xc0) << 10);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 626 to 641
	value = ((uint32_t)(input[78] & 0x3f) << 26) |
			((uint32_t)input[79] << 18) |
			((uint32_t)(input[80] & 0xc0) << 10);
	output[39] = (double)(value >> 16);

	// read output[40]: from bit 642 to 657
	value = ((uint32_t)(input[80] & 0x3f) << 26) |
			((uint32_t)input[81] << 18) |
			((uint32_t)(input[82] & 0xc0) << 10);
	output[40] = (double)(value >> 16);

	// read output[41]: from bit 658 to 673
	value = ((uint32_t)(input[82] & 0x3f) << 26) |
			((uint32_t)input[83] << 18) |
			((uint32_t)(input[84] & 0xc0) << 10);
	output[41] = (double)(value >> 16);

	// read output[42]: from bit 674 to 689
	value = ((uint32_t)(input[84] & 0x3f) << 26) |
			((uint32_t)input[85] << 18) |
			((uint32_t)(input[86] & 0xc0) << 10);
	output[42] = (double)(value >> 16);

	// read output[43]: from bit 690 to 705
	value = ((uint32_t)(input[86] & 0x3f) << 26) |
			((uint32_t)input[87] << 18) |
			((uint32_t)(input[88] & 0xc0) << 10);
	output[43] = (double)(value >> 16);

	// read output[44]: from bit 706 to 721
	value = ((uint32_t)(input[88] & 0x3f) << 26) |
			((uint32_t)input[89] << 18) |
			((uint32_t)(input[90] & 0xc0) << 10);
	output[44] = (double)(value >> 16);

	// read output[45]: from bit 722 to 737
	value = ((uint32_t)(input[90] & 0x3f) << 26) |
			((uint32_t)input[91] << 18) |
			((uint32_t)(input[92] & 0xc0) << 10);
	output[45] = (double)(value >> 16);

	// read output[46]: from bit 738 to 753
	value = ((uint32_t)(input[92] & 0x3f) << 26) |
			((uint32_t)input[93] << 18) |
			((uint32_t)(input[94] & 0xc0) << 10);
	output[46] = (double)(value >> 16);

	// read output[47]: from bit 754 to 769
	value = ((uint32_t)(input[94] & 0x3f) << 26) |
			((uint32_t)input[95] << 18) |
			((uint32_t)(input[96] & 0xc0) << 10);
	output[47] = (double)(value >> 16);

	// read output[48]: from bit 770 to 785
	value = ((uint32_t)(input[96] & 0x3f) << 26) |
			((uint32_t)input[97] << 18) |
			((uint32_t)(input[98] & 0xc0) << 10);
	output[48] = (double)(value >> 16);

	// read output[49]: from bit 786 to 801
	value = ((uint32_t)(input[98] & 0x3f) << 26) |
			((uint32_t)input[99] << 18) |
			((uint32_t)(input[100] & 0xc0) << 10);
	output[49] = (double)(value >> 16);

	// read output[50]: from bit 802 to 817
	value = ((uint32_t)(input[100] & 0x3f) << 26) |
			((uint32_t)input[101] << 18) |
			((uint32_t)(input[102] & 0xc0) << 10);
	output[50] = (double)(value >> 16);

	// read output[51]: from bit 818 to 833
	value = ((uint32_t)(input[102] & 0x3f) << 26) |
			((uint32_t)input[103] << 18) |
			((uint32_t)(input[104] & 0xc0) << 10);
	output[51] = (double)(value >> 16);

	// read output[52]: from bit 834 to 849
	value = ((uint32_t)(input[104] & 0x3f) << 26) |
			((uint32_t)input[105] << 18) |
			((uint32_t)(input[106] & 0xc0) << 10);
	output[52] = (double)(value >> 16);
}

static void unpack_53_16bit_signed_3off(const uint8_t * input, double * output, void *closure) {
	// Unpack 53 values into output
	// Values are 16-bit signed
	// Skip 3 bits, read 848 bits of data.
	// Input must be at least 107 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 3 to 18
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)input[1] << 19) |
			((uint32_t)(input[2] & 0xe0) << 11);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 19 to 34
	value = ((uint32_t)(input[2] & 0x1f) << 27) |
			((uint32_t)input[3] << 19) |
			((uint32_t)(input[4] & 0xe0) << 11);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 35 to 50
	value = ((uint32_t)(input[4] & 0x1f) << 27) |
			((uint32_t)input[5] << 19) |
			((uint32_t)(input[6] & 0xe0) << 11);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 51 to 66
	value = ((uint32_t)(input[6] & 0x1f) << 27) |
			((uint32_t)input[7] << 19) |
			((uint32_t)(input[8] & 0xe0) << 11);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 67 to 82
	value = ((uint32_t)(input[8] & 0x1f) << 27) |
			((uint32_t)input[9] << 19) |
			((uint32_t)(input[10] & 0xe0) << 11);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 83 to 98
	value = ((uint32_t)(input[10] & 0x1f) << 27) |
			((uint32_t)input[11] << 19) |
			((uint32_t)(input[12] & 0xe0) << 11);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 99 to 114
	value = ((uint32_t)(input[12] & 0x1f) << 27) |
			((uint32_t)input[13] << 19) |
			((uint32_t)(input[14] & 0xe0) << 11);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 115 to 130
	value = ((uint32_t)(input[14] & 0x1f) << 27) |
			((uint32_t)input[15] << 19) |
			((uint32_t)(input[16] & 0xe0) << 11);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 131 to 146
	value = ((uint32_t)(input[16] & 0x1f) << 27) |
			((uint32_t)input[17] << 19) |
			((uint32_t)(input[18] & 0xe0) << 11);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 147 to 162
	value = ((uint32_t)(input[18] & 0x1f) << 27) |
			((uint32_t)input[19] << 19) |
			((uint32_t)(input[20] & 0xe0) << 11);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 163 to 178
	value = ((uint32_t)(input[20] & 0x1f) << 27) |
			((uint32_t)input[21] << 19) |
			((uint32_t)(input[22] & 0xe0) << 11);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 179 to 194
	value = ((uint32_t)(input[22] & 0x1f) << 27) |
			((uint32_t)input[23] << 19) |
			((uint32_t)(input[24] & 0xe0) << 11);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 195 to 210
	value = ((uint32_t)(input[24] & 0x1f) << 27) |
			((uint32_t)input[25] << 19) |
			((uint32_t)(input[26] & 0xe0) << 11);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 211 to 226
	value = ((uint32_t)(input[26] & 0x1f) << 27) |
			((uint32_t)input[27] << 19) |
			((uint32_t)(input[28] & 0xe0) << 11);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 227 to 242
	value = ((uint32_t)(input[28] & 0x1f) << 27) |
			((uint32_t)input[29] << 19) |
			((uint32_t)(input[30] & 0xe0) << 11);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 243 to 258
	value = ((uint32_t)(input[30] & 0x1f) << 27) |
			((uint32_t)input[31] << 19) |
			((uint32_t)(input[32] & 0xe0) << 11);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 259 to 274
	value = ((uint32_t)(input[32] & 0x1f) << 27) |
			((uint32_t)input[33] << 19) |
			((uint32_t)(input[34] & 0xe0) << 11);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 275 to 290
	value = ((uint32_t)(input[34] & 0x1f) << 27) |
			((uint32_t)input[35] << 19) |
			((uint32_t)(input[36] & 0xe0) << 11);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 291 to 306
	value = ((uint32_t)(input[36] & 0x1f) << 27) |
			((uint32_t)input[37] << 19) |
			((uint32_t)(input[38] & 0xe0) << 11);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 307 to 322
	value = ((uint32_t)(input[38] & 0x1f) << 27) |
			((uint32_t)input[39] << 19) |
			((uint32_t)(input[40] & 0xe0) << 11);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 323 to 338
	value = ((uint32_t)(input[40] & 0x1f) << 27) |
			((uint32_t)input[41] << 19) |
			((uint32_t)(input[42] & 0xe0) << 11);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 339 to 354
	value = ((uint32_t)(input[42] & 0x1f) << 27) |
			((uint32_t)input[43] << 19) |
			((uint32_t)(input[44] & 0xe0) << 11);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 355 to 370
	value = ((uint32_t)(input[44] & 0x1f) << 27) |
			((uint32_t)input[45] << 19) |
			((uint32_t)(input[46] & 0xe0) << 11);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 371 to 386
	value = ((uint32_t)(input[46] & 0x1f) << 27) |
			((uint32_t)input[47] << 19) |
			((uint32_t)(input[48] & 0xe0) << 11);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 387 to 402
	value = ((uint32_t)(input[48] & 0x1f) << 27) |
			((uint32_t)input[49] << 19) |
			((uint32_t)(input[50] & 0xe0) << 11);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 403 to 418
	value = ((uint32_t)(input[50] & 0x1f) << 27) |
			((uint32_t)input[51] << 19) |
			((uint32_t)(input[52] & 0xe0) << 11);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 419 to 434
	value = ((uint32_t)(input[52] & 0x1f) << 27) |
			((uint32_t)input[53] << 19) |
			((uint32_t)(input[54] & 0xe0) << 11);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 435 to 450
	value = ((uint32_t)(input[54] & 0x1f) << 27) |
			((uint32_t)input[55] << 19) |
			((uint32_t)(input[56] & 0xe0) << 11);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 451 to 466
	value = ((uint32_t)(input[56] & 0x1f) << 27) |
			((uint32_t)input[57] << 19) |
			((uint32_t)(input[58] & 0xe0) << 11);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 467 to 482
	value = ((uint32_t)(input[58] & 0x1f) << 27) |
			((uint32_t)input[59] << 19) |
			((uint32_t)(input[60] & 0xe0) << 11);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 483 to 498
	value = ((uint32_t)(input[60] & 0x1f) << 27) |
			((uint32_t)input[61] << 19) |
			((uint32_t)(input[62] & 0xe0) << 11);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 499 to 514
	value = ((uint32_t)(input[62] & 0x1f) << 27) |
			((uint32_t)input[63] << 19) |
			((uint32_t)(input[64] & 0xe0) << 11);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 515 to 530
	value = ((uint32_t)(input[64] & 0x1f) << 27) |
			((uint32_t)input[65] << 19) |
			((uint32_t)(input[66] & 0xe0) << 11);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 531 to 546
	value = ((uint32_t)(input[66] & 0x1f) << 27) |
			((uint32_t)input[67] << 19) |
			((uint32_t)(input[68] & 0xe0) << 11);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 547 to 562
	value = ((uint32_t)(input[68] & 0x1f) << 27) |
			((uint32_t)input[69] << 19) |
			((uint32_t)(input[70] & 0xe0) << 11);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 563 to 578
	value = ((uint32_t)(input[70] & 0x1f) << 27) |
			((uint32_t)input[71] << 19) |
			((uint32_t)(input[72] & 0xe0) << 11);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 579 to 594
	value = ((uint32_t)(input[72] & 0x1f) << 27) |
			((uint32_t)input[73] << 19) |
			((uint32_t)(input[74] & 0xe0) << 11);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 595 to 610
	value = ((uint32_t)(input[74] & 0x1f) << 27) |
			((uint32_t)input[75] << 19) |
			((uint32_t)(input[76] & 0xe0) << 11);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 611 to 626
	value = ((uint32_t)(input[76] & 0x1f) << 27) |
			((uint32_t)input[77] << 19) |
			((uint32_t)(input[78] & 0xe0) << 11);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 627 to 642
	value = ((uint32_t)(input[78] & 0x1f) << 27) |
			((uint32_t)input[79] << 19) |
			((uint32_t)(input[80] & 0xe0) << 11);
	output[39] = (double)(value >> 16);

	// read output[40]: from bit 643 to 658
	value = ((uint32_t)(input[80] & 0x1f) << 27) |
			((uint32_t)input[81] << 19) |
			((uint32_t)(input[82] & 0xe0) << 11);
	output[40] = (double)(value >> 16);

	// read output[41]: from bit 659 to 674
	value = ((uint32_t)(input[82] & 0x1f) << 27) |
			((uint32_t)input[83] << 19) |
			((uint32_t)(input[84] & 0xe0) << 11);
	output[41] = (double)(value >> 16);

	// read output[42]: from bit 675 to 690
	value = ((uint32_t)(input[84] & 0x1f) << 27) |
			((uint32_t)input[85] << 19) |
			((uint32_t)(input[86] & 0xe0) << 11);
	output[42] = (double)(value >> 16);

	// read output[43]: from bit 691 to 706
	value = ((uint32_t)(input[86] & 0x1f) << 27) |
			((uint32_t)input[87] << 19) |
			((uint32_t)(input[88] & 0xe0) << 11);
	output[43] = (double)(value >> 16);

	// read output[44]: from bit 707 to 722
	value = ((uint32_t)(input[88] & 0x1f) << 27) |
			((uint32_t)input[89] << 19) |
			((uint32_t)(input[90] & 0xe0) << 11);
	output[44] = (double)(value >> 16);

	// read output[45]: from bit 723 to 738
	value = ((uint32_t)(input[90] & 0x1f) << 27) |
			((uint32_t)input[91] << 19) |
			((uint32_t)(input[92] & 0xe0) << 11);
	output[45] = (double)(value >> 16);

	// read output[46]: from bit 739 to 754
	value = ((uint32_t)(input[92] & 0x1f) << 27) |
			((uint32_t)input[93] << 19) |
			((uint32_t)(input[94] & 0xe0) << 11);
	output[46] = (double)(value >> 16);

	// read output[47]: from bit 755 to 770
	value = ((uint32_t)(input[94] & 0x1f) << 27) |
			((uint32_t)input[95] << 19) |
			((uint32_t)(input[96] & 0xe0) << 11);
	output[47] = (double)(value >> 16);

	// read output[48]: from bit 771 to 786
	value = ((uint32_t)(input[96] & 0x1f) << 27) |
			((uint32_t)input[97] << 19) |
			((uint32_t)(input[98] & 0xe0) << 11);
	output[48] = (double)(value >> 16);

	// read output[49]: from bit 787 to 802
	value = ((uint32_t)(input[98] & 0x1f) << 27) |
			((uint32_t)input[99] << 19) |
			((uint32_t)(input[100] & 0xe0) << 11);
	output[49] = (double)(value >> 16);

	// read output[50]: from bit 803 to 818
	value = ((uint32_t)(input[100] & 0x1f) << 27) |
			((uint32_t)input[101] << 19) |
			((uint32_t)(input[102] & 0xe0) << 11);
	output[50] = (double)(value >> 16);

	// read output[51]: from bit 819 to 834
	value = ((uint32_t)(input[102] & 0x1f) << 27) |
			((uint32_t)input[103] << 19) |
			((uint32_t)(input[104] & 0xe0) << 11);
	output[51] = (double)(value >> 16);

	// read output[52]: from bit 835 to 850
	value = ((uint32_t)(input[104] & 0x1f) << 27) |
			((uint32_t)input[105] << 19) |
			((uint32_t)(input[106] & 0xe0) << 11);
	output[52] = (double)(value >> 16);
}

static void unpack_53_16bit_unsigned_3off(const uint8_t * input, double * output, void *closure) {
	// Unpack 53 values into output
	// Values are 16-bit unsigned
	// Skip 3 bits, read 848 bits of data.
	// Input must be at least 107 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 3 to 18
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)input[1] << 19) |
			((uint32_t)(input[2] & 0xe0) << 11);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 19 to 34
	value = ((uint32_t)(input[2] & 0x1f) << 27) |
			((uint32_t)input[3] << 19) |
			((uint32_t)(input[4] & 0xe0) << 11);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 35 to 50
	value = ((uint32_t)(input[4] & 0x1f) << 27) |
			((uint32_t)input[5] << 19) |
			((uint32_t)(input[6] & 0xe0) << 11);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 51 to 66
	value = ((uint32_t)(input[6] & 0x1f) << 27) |
			((uint32_t)input[7] << 19) |
			((uint32_t)(input[8] & 0xe0) << 11);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 67 to 82
	value = ((uint32_t)(input[8] & 0x1f) << 27) |
			((uint32_t)input[9] << 19) |
			((uint32_t)(input[10] & 0xe0) << 11);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 83 to 98
	value = ((uint32_t)(input[10] & 0x1f) << 27) |
			((uint32_t)input[11] << 19) |
			((uint32_t)(input[12] & 0xe0) << 11);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 99 to 114
	value = ((uint32_t)(input[12] & 0x1f) << 27) |
			((uint32_t)input[13] << 19) |
			((uint32_t)(input[14] & 0xe0) << 11);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 115 to 130
	value = ((uint32_t)(input[14] & 0x1f) << 27) |
			((uint32_t)input[15] << 19) |
			((uint32_t)(input[16] & 0xe0) << 11);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 131 to 146
	value = ((uint32_t)(input[16] & 0x1f) << 27) |
			((uint32_t)input[17] << 19) |
			((uint32_t)(input[18] & 0xe0) << 11);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 147 to 162
	value = ((uint32_t)(input[18] & 0x1f) << 27) |
			((uint32_t)input[19] << 19) |
			((uint32_t)(input[20] & 0xe0) << 11);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 163 to 178
	value = ((uint32_t)(input[20] & 0x1f) << 27) |
			((uint32_t)input[21] << 19) |
			((uint32_t)(input[22] & 0xe0) << 11);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 179 to 194
	value = ((uint32_t)(input[22] & 0x1f) << 27) |
			((uint32_t)input[23] << 19) |
			((uint32_t)(input[24] & 0xe0) << 11);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 195 to 210
	value = ((uint32_t)(input[24] & 0x1f) << 27) |
			((uint32_t)input[25] << 19) |
			((uint32_t)(input[26] & 0xe0) << 11);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 211 to 226
	value = ((uint32_t)(input[26] & 0x1f) << 27) |
			((uint32_t)input[27] << 19) |
			((uint32_t)(input[28] & 0xe0) << 11);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 227 to 242
	value = ((uint32_t)(input[28] & 0x1f) << 27) |
			((uint32_t)input[29] << 19) |
			((uint32_t)(input[30] & 0xe0) << 11);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 243 to 258
	value = ((uint32_t)(input[30] & 0x1f) << 27) |
			((uint32_t)input[31] << 19) |
			((uint32_t)(input[32] & 0xe0) << 11);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 259 to 274
	value = ((uint32_t)(input[32] & 0x1f) << 27) |
			((uint32_t)input[33] << 19) |
			((uint32_t)(input[34] & 0xe0) << 11);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 275 to 290
	value = ((uint32_t)(input[34] & 0x1f) << 27) |
			((uint32_t)input[35] << 19) |
			((uint32_t)(input[36] & 0xe0) << 11);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 291 to 306
	value = ((uint32_t)(input[36] & 0x1f) << 27) |
			((uint32_t)input[37] << 19) |
			((uint32_t)(input[38] & 0xe0) << 11);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 307 to 322
	value = ((uint32_t)(input[38] & 0x1f) << 27) |
			((uint32_t)input[39] << 19) |
			((uint32_t)(input[40] & 0xe0) << 11);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 323 to 338
	value = ((uint32_t)(input[40] & 0x1f) << 27) |
			((uint32_t)input[41] << 19) |
			((uint32_t)(input[42] & 0xe0) << 11);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 339 to 354
	value = ((uint32_t)(input[42] & 0x1f) << 27) |
			((uint32_t)input[43] << 19) |
			((uint32_t)(input[44] & 0xe0) << 11);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 355 to 370
	value = ((uint32_t)(input[44] & 0x1f) << 27) |
			((uint32_t)input[45] << 19) |
			((uint32_t)(input[46] & 0xe0) << 11);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 371 to 386
	value = ((uint32_t)(input[46] & 0x1f) << 27) |
			((uint32_t)input[47] << 19) |
			((uint32_t)(input[48] & 0xe0) << 11);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 387 to 402
	value = ((uint32_t)(input[48] & 0x1f) << 27) |
			((uint32_t)input[49] << 19) |
			((uint32_t)(input[50] & 0xe0) << 11);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 403 to 418
	value = ((uint32_t)(input[50] & 0x1f) << 27) |
			((uint32_t)input[51] << 19) |
			((uint32_t)(input[52] & 0xe0) << 11);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 419 to 434
	value = ((uint32_t)(input[52] & 0x1f) << 27) |
			((uint32_t)input[53] << 19) |
			((uint32_t)(input[54] & 0xe0) << 11);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 435 to 450
	value = ((uint32_t)(input[54] & 0x1f) << 27) |
			((uint32_t)input[55] << 19) |
			((uint32_t)(input[56] & 0xe0) << 11);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 451 to 466
	value = ((uint32_t)(input[56] & 0x1f) << 27) |
			((uint32_t)input[57] << 19) |
			((uint32_t)(input[58] & 0xe0) << 11);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 467 to 482
	value = ((uint32_t)(input[58] & 0x1f) << 27) |
			((uint32_t)input[59] << 19) |
			((uint32_t)(input[60] & 0xe0) << 11);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 483 to 498
	value = ((uint32_t)(input[60] & 0x1f) << 27) |
			((uint32_t)input[61] << 19) |
			((uint32_t)(input[62] & 0xe0) << 11);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 499 to 514
	value = ((uint32_t)(input[62] & 0x1f) << 27) |
			((uint32_t)input[63] << 19) |
			((uint32_t)(input[64] & 0xe0) << 11);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 515 to 530
	value = ((uint32_t)(input[64] & 0x1f) << 27) |
			((uint32_t)input[65] << 19) |
			((uint32_t)(input[66] & 0xe0) << 11);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 531 to 546
	value = ((uint32_t)(input[66] & 0x1f) << 27) |
			((uint32_t)input[67] << 19) |
			((uint32_t)(input[68] & 0xe0) << 11);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 547 to 562
	value = ((uint32_t)(input[68] & 0x1f) << 27) |
			((uint32_t)input[69] << 19) |
			((uint32_t)(input[70] & 0xe0) << 11);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 563 to 578
	value = ((uint32_t)(input[70] & 0x1f) << 27) |
			((uint32_t)input[71] << 19) |
			((uint32_t)(input[72] & 0xe0) << 11);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 579 to 594
	value = ((uint32_t)(input[72] & 0x1f) << 27) |
			((uint32_t)input[73] << 19) |
			((uint32_t)(input[74] & 0xe0) << 11);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 595 to 610
	value = ((uint32_t)(input[74] & 0x1f) << 27) |
			((uint32_t)input[75] << 19) |
			((uint32_t)(input[76] & 0xe0) << 11);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 611 to 626
	value = ((uint32_t)(input[76] & 0x1f) << 27) |
			((uint32_t)input[77] << 19) |
			((uint32_t)(input[78] & 0xe0) << 11);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 627 to 642
	value = ((uint32_t)(input[78] & 0x1f) << 27) |
			((uint32_t)input[79] << 19) |
			((uint32_t)(input[80] & 0xe0) << 11);
	output[39] = (double)(value >> 16);

	// read output[40]: from bit 643 to 658
	value = ((uint32_t)(input[80] & 0x1f) << 27) |
			((uint32_t)input[81] << 19) |
			((uint32_t)(input[82] & 0xe0) << 11);
	output[40] = (double)(value >> 16);

	// read output[41]: from bit 659 to 674
	value = ((uint32_t)(input[82] & 0x1f) << 27) |
			((uint32_t)input[83] << 19) |
			((uint32_t)(input[84] & 0xe0) << 11);
	output[41] = (double)(value >> 16);

	// read output[42]: from bit 675 to 690
	value = ((uint32_t)(input[84] & 0x1f) << 27) |
			((uint32_t)input[85] << 19) |
			((uint32_t)(input[86] & 0xe0) << 11);
	output[42] = (double)(value >> 16);

	// read output[43]: from bit 691 to 706
	value = ((uint32_t)(input[86] & 0x1f) << 27) |
			((uint32_t)input[87] << 19) |
			((uint32_t)(input[88] & 0xe0) << 11);
	output[43] = (double)(value >> 16);

	// read output[44]: from bit 707 to 722
	value = ((uint32_t)(input[88] & 0x1f) << 27) |
			((uint32_t)input[89] << 19) |
			((uint32_t)(input[90] & 0xe0) << 11);
	output[44] = (double)(value >> 16);

	// read output[45]: from bit 723 to 738
	value = ((uint32_t)(input[90] & 0x1f) << 27) |
			((uint32_t)input[91] << 19) |
			((uint32_t)(input[92] & 0xe0) << 11);
	output[45] = (double)(value >> 16);

	// read output[46]: from bit 739 to 754
	value = ((uint32_t)(input[92] & 0x1f) << 27) |
			((uint32_t)input[93] << 19) |
			((uint32_t)(input[94] & 0xe0) << 11);
	output[46] = (double)(value >> 16);

	// read output[47]: from bit 755 to 770
	value = ((uint32_t)(input[94] & 0x1f) << 27) |
			((uint32_t)input[95] << 19) |
			((uint32_t)(input[96] & 0xe0) << 11);
	output[47] = (double)(value >> 16);

	// read output[48]: from bit 771 to 786
	value = ((uint32_t)(input[96] & 0x1f) << 27) |
			((uint32_t)input[97] << 19) |
			((uint32_t)(input[98] & 0xe0) << 11);
	output[48] = (double)(value >> 16);

	// read output[49]: from bit 787 to 802
	value = ((uint32_t)(input[98] & 0x1f) << 27) |
			((uint32_t)input[99] << 19) |
			((uint32_t)(input[100] & 0xe0) << 11);
	output[49] = (double)(value >> 16);

	// read output[50]: from bit 803 to 818
	value = ((uint32_t)(input[100] & 0x1f) << 27) |
			((uint32_t)input[101] << 19) |
			((uint32_t)(input[102] & 0xe0) << 11);
	output[50] = (double)(value >> 16);

	// read output[51]: from bit 819 to 834
	value = ((uint32_t)(input[102] & 0x1f) << 27) |
			((uint32_t)input[103] << 19) |
			((uint32_t)(input[104] & 0xe0) << 11);
	output[51] = (double)(value >> 16);

	// read output[52]: from bit 835 to 850
	value = ((uint32_t)(input[104] & 0x1f) << 27) |
			((uint32_t)input[105] << 19) |
			((uint32_t)(input[106] & 0xe0) << 11);
	output[52] = (double)(value >> 16);
}

static void unpack_53_16bit_signed_4off(const uint8_t * input, double * output, void *closure) {
	// Unpack 53 values into output
	// Values are 16-bit signed
	// Skip 4 bits, read 848 bits of data.
	// Input must be at least 107 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 4 to 19
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20) |
			((uint32_t)(input[2] & 0xf0) << 12);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 20 to 35
	value = ((uint32_t)(input[2] & 0x0f) << 28) |
			((uint32_t)input[3] << 20) |
			((uint32_t)(input[4] & 0xf0) << 12);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 36 to 51
	value = ((uint32_t)(input[4] & 0x0f) << 28) |
			((uint32_t)input[5] << 20) |
			((uint32_t)(input[6] & 0xf0) << 12);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 52 to 67
	value = ((uint32_t)(input[6] & 0x0f) << 28) |
			((uint32_t)input[7] << 20) |
			((uint32_t)(input[8] & 0xf0) << 12);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 68 to 83
	value = ((uint32_t)(input[8] & 0x0f) << 28) |
			((uint32_t)input[9] << 20) |
			((uint32_t)(input[10] & 0xf0) << 12);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 84 to 99
	value = ((uint32_t)(input[10] & 0x0f) << 28) |
			((uint32_t)input[11] << 20) |
			((uint32_t)(input[12] & 0xf0) << 12);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 100 to 115
	value = ((uint32_t)(input[12] & 0x0f) << 28) |
			((uint32_t)input[13] << 20) |
			((uint32_t)(input[14] & 0xf0) << 12);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 116 to 131
	value = ((uint32_t)(input[14] & 0x0f) << 28) |
			((uint32_t)input[15] << 20) |
			((uint32_t)(input[16] & 0xf0) << 12);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 132 to 147
	value = ((uint32_t)(input[16] & 0x0f) << 28) |
			((uint32_t)input[17] << 20) |
			((uint32_t)(input[18] & 0xf0) << 12);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 148 to 163
	value = ((uint32_t)(input[18] & 0x0f) << 28) |
			((uint32_t)input[19] << 20) |
			((uint32_t)(input[20] & 0xf0) << 12);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 164 to 179
	value = ((uint32_t)(input[20] & 0x0f) << 28) |
			((uint32_t)input[21] << 20) |
			((uint32_t)(input[22] & 0xf0) << 12);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 180 to 195
	value = ((uint32_t)(input[22] & 0x0f) << 28) |
			((uint32_t)input[23] << 20) |
			((uint32_t)(input[24] & 0xf0) << 12);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 196 to 211
	value = ((uint32_t)(input[24] & 0x0f) << 28) |
			((uint32_t)input[25] << 20) |
			((uint32_t)(input[26] & 0xf0) << 12);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 212 to 227
	value = ((uint32_t)(input[26] & 0x0f) << 28) |
			((uint32_t)input[27] << 20) |
			((uint32_t)(input[28] & 0xf0) << 12);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 228 to 243
	value = ((uint32_t)(input[28] & 0x0f) << 28) |
			((uint32_t)input[29] << 20) |
			((uint32_t)(input[30] & 0xf0) << 12);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 244 to 259
	value = ((uint32_t)(input[30] & 0x0f) << 28) |
			((uint32_t)input[31] << 20) |
			((uint32_t)(input[32] & 0xf0) << 12);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 260 to 275
	value = ((uint32_t)(input[32] & 0x0f) << 28) |
			((uint32_t)input[33] << 20) |
			((uint32_t)(input[34] & 0xf0) << 12);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 276 to 291
	value = ((uint32_t)(input[34] & 0x0f) << 28) |
			((uint32_t)input[35] << 20) |
			((uint32_t)(input[36] & 0xf0) << 12);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 292 to 307
	value = ((uint32_t)(input[36] & 0x0f) << 28) |
			((uint32_t)input[37] << 20) |
			((uint32_t)(input[38] & 0xf0) << 12);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 308 to 323
	value = ((uint32_t)(input[38] & 0x0f) << 28) |
			((uint32_t)input[39] << 20) |
			((uint32_t)(input[40] & 0xf0) << 12);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 324 to 339
	value = ((uint32_t)(input[40] & 0x0f) << 28) |
			((uint32_t)input[41] << 20) |
			((uint32_t)(input[42] & 0xf0) << 12);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 340 to 355
	value = ((uint32_t)(input[42] & 0x0f) << 28) |
			((uint32_t)input[43] << 20) |
			((uint32_t)(input[44] & 0xf0) << 12);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 356 to 371
	value = ((uint32_t)(input[44] & 0x0f) << 28) |
			((uint32_t)input[45] << 20) |
			((uint32_t)(input[46] & 0xf0) << 12);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 372 to 387
	value = ((uint32_t)(input[46] & 0x0f) << 28) |
			((uint32_t)input[47] << 20) |
			((uint32_t)(input[48] & 0xf0) << 12);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 388 to 403
	value = ((uint32_t)(input[48] & 0x0f) << 28) |
			((uint32_t)input[49] << 20) |
			((uint32_t)(input[50] & 0xf0) << 12);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 404 to 419
	value = ((uint32_t)(input[50] & 0x0f) << 28) |
			((uint32_t)input[51] << 20) |
			((uint32_t)(input[52] & 0xf0) << 12);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 420 to 435
	value = ((uint32_t)(input[52] & 0x0f) << 28) |
			((uint32_t)input[53] << 20) |
			((uint32_t)(input[54] & 0xf0) << 12);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 436 to 451
	value = ((uint32_t)(input[54] & 0x0f) << 28) |
			((uint32_t)input[55] << 20) |
			((uint32_t)(input[56] & 0xf0) << 12);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 452 to 467
	value = ((uint32_t)(input[56] & 0x0f) << 28) |
			((uint32_t)input[57] << 20) |
			((uint32_t)(input[58] & 0xf0) << 12);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 468 to 483
	value = ((uint32_t)(input[58] & 0x0f) << 28) |
			((uint32_t)input[59] << 20) |
			((uint32_t)(input[60] & 0xf0) << 12);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 484 to 499
	value = ((uint32_t)(input[60] & 0x0f) << 28) |
			((uint32_t)input[61] << 20) |
			((uint32_t)(input[62] & 0xf0) << 12);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 500 to 515
	value = ((uint32_t)(input[62] & 0x0f) << 28) |
			((uint32_t)input[63] << 20) |
			((uint32_t)(input[64] & 0xf0) << 12);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 516 to 531
	value = ((uint32_t)(input[64] & 0x0f) << 28) |
			((uint32_t)input[65] << 20) |
			((uint32_t)(input[66] & 0xf0) << 12);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 532 to 547
	value = ((uint32_t)(input[66] & 0x0f) << 28) |
			((uint32_t)input[67] << 20) |
			((uint32_t)(input[68] & 0xf0) << 12);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 548 to 563
	value = ((uint32_t)(input[68] & 0x0f) << 28) |
			((uint32_t)input[69] << 20) |
			((uint32_t)(input[70] & 0xf0) << 12);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 564 to 579
	value = ((uint32_t)(input[70] & 0x0f) << 28) |
			((uint32_t)input[71] << 20) |
			((uint32_t)(input[72] & 0xf0) << 12);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 580 to 595
	value = ((uint32_t)(input[72] & 0x0f) << 28) |
			((uint32_t)input[73] << 20) |
			((uint32_t)(input[74] & 0xf0) << 12);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 596 to 611
	value = ((uint32_t)(input[74] & 0x0f) << 28) |
			((uint32_t)input[75] << 20) |
			((uint32_t)(input[76] & 0xf0) << 12);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 612 to 627
	value = ((uint32_t)(input[76] & 0x0f) << 28) |
			((uint32_t)input[77] << 20) |
			((uint32_t)(input[78] & 0xf0) << 12);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 628 to 643
	value = ((uint32_t)(input[78] & 0x0f) << 28) |
			((uint32_t)input[79] << 20) |
			((uint32_t)(input[80] & 0xf0) << 12);
	output[39] = (double)(value >> 16);

	// read output[40]: from bit 644 to 659
	value = ((uint32_t)(input[80] & 0x0f) << 28) |
			((uint32_t)input[81] << 20) |
			((uint32_t)(input[82] & 0xf0) << 12);
	output[40] = (double)(value >> 16);

	// read output[41]: from bit 660 to 675
	value = ((uint32_t)(input[82] & 0x0f) << 28) |
			((uint32_t)input[83] << 20) |
			((uint32_t)(input[84] & 0xf0) << 12);
	output[41] = (double)(value >> 16);

	// read output[42]: from bit 676 to 691
	value = ((uint32_t)(input[84] & 0x0f) << 28) |
			((uint32_t)input[85] << 20) |
			((uint32_t)(input[86] & 0xf0) << 12);
	output[42] = (double)(value >> 16);

	// read output[43]: from bit 692 to 707
	value = ((uint32_t)(input[86] & 0x0f) << 28) |
			((uint32_t)input[87] << 20) |
			((uint32_t)(input[88] & 0xf0) << 12);
	output[43] = (double)(value >> 16);

	// read output[44]: from bit 708 to 723
	value = ((uint32_t)(input[88] & 0x0f) << 28) |
			((uint32_t)input[89] << 20) |
			((uint32_t)(input[90] & 0xf0) << 12);
	output[44] = (double)(value >> 16);

	// read output[45]: from bit 724 to 739
	value = ((uint32_t)(input[90] & 0x0f) << 28) |
			((uint32_t)input[91] << 20) |
			((uint32_t)(input[92] & 0xf0) << 12);
	output[45] = (double)(value >> 16);

	// read output[46]: from bit 740 to 755
	value = ((uint32_t)(input[92] & 0x0f) << 28) |
			((uint32_t)input[93] << 20) |
			((uint32_t)(input[94] & 0xf0) << 12);
	output[46] = (double)(value >> 16);

	// read output[47]: from bit 756 to 771
	value = ((uint32_t)(input[94] & 0x0f) << 28) |
			((uint32_t)input[95] << 20) |
			((uint32_t)(input[96] & 0xf0) << 12);
	output[47] = (double)(value >> 16);

	// read output[48]: from bit 772 to 787
	value = ((uint32_t)(input[96] & 0x0f) << 28) |
			((uint32_t)input[97] << 20) |
			((uint32_t)(input[98] & 0xf0) << 12);
	output[48] = (double)(value >> 16);

	// read output[49]: from bit 788 to 803
	value = ((uint32_t)(input[98] & 0x0f) << 28) |
			((uint32_t)input[99] << 20) |
			((uint32_t)(input[100] & 0xf0) << 12);
	output[49] = (double)(value >> 16);

	// read output[50]: from bit 804 to 819
	value = ((uint32_t)(input[100] & 0x0f) << 28) |
			((uint32_t)input[101] << 20) |
			((uint32_t)(input[102] & 0xf0) << 12);
	output[50] = (double)(value >> 16);

	// read output[51]: from bit 820 to 835
	value = ((uint32_t)(input[102] & 0x0f) << 28) |
			((uint32_t)input[103] << 20) |
			((uint32_t)(input[104] & 0xf0) << 12);
	output[51] = (double)(value >> 16);

	// read output[52]: from bit 836 to 851
	value = ((uint32_t)(input[104] & 0x0f) << 28) |
			((uint32_t)input[105] << 20) |
			((uint32_t)(input[106] & 0xf0) << 12);
	output[52] = (double)(value >> 16);
}

static void unpack_53_16bit_unsigned_4off(const uint8_t * input, double * output, void *closure) {
	// Unpack 53 values into output
	// Values are 16-bit unsigned
	// Skip 4 bits, read 848 bits of data.
	// Input must be at least 107 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 4 to 19
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20) |
			((uint32_t)(input[2] & 0xf0) << 12);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 20 to 35
	value = ((uint32_t)(input[2] & 0x0f) << 28) |
			((uint32_t)input[3] << 20) |
			((uint32_t)(input[4] & 0xf0) << 12);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 36 to 51
	value = ((uint32_t)(input[4] & 0x0f) << 28) |
			((uint32_t)input[5] << 20) |
			((uint32_t)(input[6] & 0xf0) << 12);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 52 to 67
	value = ((uint32_t)(input[6] & 0x0f) << 28) |
			((uint32_t)input[7] << 20) |
			((uint32_t)(input[8] & 0xf0) << 12);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 68 to 83
	value = ((uint32_t)(input[8] & 0x0f) << 28) |
			((uint32_t)input[9] << 20) |
			((uint32_t)(input[10] & 0xf0) << 12);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 84 to 99
	value = ((uint32_t)(input[10] & 0x0f) << 28) |
			((uint32_t)input[11] << 20) |
			((uint32_t)(input[12] & 0xf0) << 12);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 100 to 115
	value = ((uint32_t)(input[12] & 0x0f) << 28) |
			((uint32_t)input[13] << 20) |
			((uint32_t)(input[14] & 0xf0) << 12);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 116 to 131
	value = ((uint32_t)(input[14] & 0x0f) << 28) |
			((uint32_t)input[15] << 20) |
			((uint32_t)(input[16] & 0xf0) << 12);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 132 to 147
	value = ((uint32_t)(input[16] & 0x0f) << 28) |
			((uint32_t)input[17] << 20) |
			((uint32_t)(input[18] & 0xf0) << 12);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 148 to 163
	value = ((uint32_t)(input[18] & 0x0f) << 28) |
			((uint32_t)input[19] << 20) |
			((uint32_t)(input[20] & 0xf0) << 12);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 164 to 179
	value = ((uint32_t)(input[20] & 0x0f) << 28) |
			((uint32_t)input[21] << 20) |
			((uint32_t)(input[22] & 0xf0) << 12);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 180 to 195
	value = ((uint32_t)(input[22] & 0x0f) << 28) |
			((uint32_t)input[23] << 20) |
			((uint32_t)(input[24] & 0xf0) << 12);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 196 to 211
	value = ((uint32_t)(input[24] & 0x0f) << 28) |
			((uint32_t)input[25] << 20) |
			((uint32_t)(input[26] & 0xf0) << 12);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 212 to 227
	value = ((uint32_t)(input[26] & 0x0f) << 28) |
			((uint32_t)input[27] << 20) |
			((uint32_t)(input[28] & 0xf0) << 12);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 228 to 243
	value = ((uint32_t)(input[28] & 0x0f) << 28) |
			((uint32_t)input[29] << 20) |
			((uint32_t)(input[30] & 0xf0) << 12);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 244 to 259
	value = ((uint32_t)(input[30] & 0x0f) << 28) |
			((uint32_t)input[31] << 20) |
			((uint32_t)(input[32] & 0xf0) << 12);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 260 to 275
	value = ((uint32_t)(input[32] & 0x0f) << 28) |
			((uint32_t)input[33] << 20) |
			((uint32_t)(input[34] & 0xf0) << 12);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 276 to 291
	value = ((uint32_t)(input[34] & 0x0f) << 28) |
			((uint32_t)input[35] << 20) |
			((uint32_t)(input[36] & 0xf0) << 12);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 292 to 307
	value = ((uint32_t)(input[36] & 0x0f) << 28) |
			((uint32_t)input[37] << 20) |
			((uint32_t)(input[38] & 0xf0) << 12);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 308 to 323
	value = ((uint32_t)(input[38] & 0x0f) << 28) |
			((uint32_t)input[39] << 20) |
			((uint32_t)(input[40] & 0xf0) << 12);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 324 to 339
	value = ((uint32_t)(input[40] & 0x0f) << 28) |
			((uint32_t)input[41] << 20) |
			((uint32_t)(input[42] & 0xf0) << 12);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 340 to 355
	value = ((uint32_t)(input[42] & 0x0f) << 28) |
			((uint32_t)input[43] << 20) |
			((uint32_t)(input[44] & 0xf0) << 12);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 356 to 371
	value = ((uint32_t)(input[44] & 0x0f) << 28) |
			((uint32_t)input[45] << 20) |
			((uint32_t)(input[46] & 0xf0) << 12);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 372 to 387
	value = ((uint32_t)(input[46] & 0x0f) << 28) |
			((uint32_t)input[47] << 20) |
			((uint32_t)(input[48] & 0xf0) << 12);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 388 to 403
	value = ((uint32_t)(input[48] & 0x0f) << 28) |
			((uint32_t)input[49] << 20) |
			((uint32_t)(input[50] & 0xf0) << 12);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 404 to 419
	value = ((uint32_t)(input[50] & 0x0f) << 28) |
			((uint32_t)input[51] << 20) |
			((uint32_t)(input[52] & 0xf0) << 12);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 420 to 435
	value = ((uint32_t)(input[52] & 0x0f) << 28) |
			((uint32_t)input[53] << 20) |
			((uint32_t)(input[54] & 0xf0) << 12);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 436 to 451
	value = ((uint32_t)(input[54] & 0x0f) << 28) |
			((uint32_t)input[55] << 20) |
			((uint32_t)(input[56] & 0xf0) << 12);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 452 to 467
	value = ((uint32_t)(input[56] & 0x0f) << 28) |
			((uint32_t)input[57] << 20) |
			((uint32_t)(input[58] & 0xf0) << 12);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 468 to 483
	value = ((uint32_t)(input[58] & 0x0f) << 28) |
			((uint32_t)input[59] << 20) |
			((uint32_t)(input[60] & 0xf0) << 12);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 484 to 499
	value = ((uint32_t)(input[60] & 0x0f) << 28) |
			((uint32_t)input[61] << 20) |
			((uint32_t)(input[62] & 0xf0) << 12);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 500 to 515
	value = ((uint32_t)(input[62] & 0x0f) << 28) |
			((uint32_t)input[63] << 20) |
			((uint32_t)(input[64] & 0xf0) << 12);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 516 to 531
	value = ((uint32_t)(input[64] & 0x0f) << 28) |
			((uint32_t)input[65] << 20) |
			((uint32_t)(input[66] & 0xf0) << 12);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 532 to 547
	value = ((uint32_t)(input[66] & 0x0f) << 28) |
			((uint32_t)input[67] << 20) |
			((uint32_t)(input[68] & 0xf0) << 12);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 548 to 563
	value = ((uint32_t)(input[68] & 0x0f) << 28) |
			((uint32_t)input[69] << 20) |
			((uint32_t)(input[70] & 0xf0) << 12);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 564 to 579
	value = ((uint32_t)(input[70] & 0x0f) << 28) |
			((uint32_t)input[71] << 20) |
			((uint32_t)(input[72] & 0xf0) << 12);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 580 to 595
	value = ((uint32_t)(input[72] & 0x0f) << 28) |
			((uint32_t)input[73] << 20) |
			((uint32_t)(input[74] & 0xf0) << 12);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 596 to 611
	value = ((uint32_t)(input[74] & 0x0f) << 28) |
			((uint32_t)input[75] << 20) |
			((uint32_t)(input[76] & 0xf0) << 12);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 612 to 627
	value = ((uint32_t)(input[76] & 0x0f) << 28) |
			((uint32_t)input[77] << 20) |
			((uint32_t)(input[78] & 0xf0) << 12);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 628 to 643
	value = ((uint32_t)(input[78] & 0x0f) << 28) |
			((uint32_t)input[79] << 20) |
			((uint32_t)(input[80] & 0xf0) << 12);
	output[39] = (double)(value >> 16);

	// read output[40]: from bit 644 to 659
	value = ((uint32_t)(input[80] & 0x0f) << 28) |
			((uint32_t)input[81] << 20) |
			((uint32_t)(input[82] & 0xf0) << 12);
	output[40] = (double)(value >> 16);

	// read output[41]: from bit 660 to 675
	value = ((uint32_t)(input[82] & 0x0f) << 28) |
			((uint32_t)input[83] << 20) |
			((uint32_t)(input[84] & 0xf0) << 12);
	output[41] = (double)(value >> 16);

	// read output[42]: from bit 676 to 691
	value = ((uint32_t)(input[84] & 0x0f) << 28) |
			((uint32_t)input[85] << 20) |
			((uint32_t)(input[86] & 0xf0) << 12);
	output[42] = (double)(value >> 16);

	// read output[43]: from bit 692 to 707
	value = ((uint32_t)(input[86] & 0x0f) << 28) |
			((uint32_t)input[87] << 20) |
			((uint32_t)(input[88] & 0xf0) << 12);
	output[43] = (double)(value >> 16);

	// read output[44]: from bit 708 to 723
	value = ((uint32_t)(input[88] & 0x0f) << 28) |
			((uint32_t)input[89] << 20) |
			((uint32_t)(input[90] & 0xf0) << 12);
	output[44] = (double)(value >> 16);

	// read output[45]: from bit 724 to 739
	value = ((uint32_t)(input[90] & 0x0f) << 28) |
			((uint32_t)input[91] << 20) |
			((uint32_t)(input[92] & 0xf0) << 12);
	output[45] = (double)(value >> 16);

	// read output[46]: from bit 740 to 755
	value = ((uint32_t)(input[92] & 0x0f) << 28) |
			((uint32_t)input[93] << 20) |
			((uint32_t)(input[94] & 0xf0) << 12);
	output[46] = (double)(value >> 16);

	// read output[47]: from bit 756 to 771
	value = ((uint32_t)(input[94] & 0x0f) << 28) |
			((uint32_t)input[95] << 20) |
			((uint32_t)(input[96] & 0xf0) << 12);
	output[47] = (double)(value >> 16);

	// read output[48]: from bit 772 to 787
	value = ((uint32_t)(input[96] & 0x0f) << 28) |
			((uint32_t)input[97] << 20) |
			((uint32_t)(input[98] & 0xf0) << 12);
	output[48] = (double)(value >> 16);

	// read output[49]: from bit 788 to 803
	value = ((uint32_t)(input[98] & 0x0f) << 28) |
			((uint32_t)input[99] << 20) |
			((uint32_t)(input[100] & 0xf0) << 12);
	output[49] = (double)(value >> 16);

	// read output[50]: from bit 804 to 819
	value = ((uint32_t)(input[100] & 0x0f) << 28) |
			((uint32_t)input[101] << 20) |
			((uint32_t)(input[102] & 0xf0) << 12);
	output[50] = (double)(value >> 16);

	// read output[51]: from bit 820 to 835
	value = ((uint32_t)(input[102] & 0x0f) << 28) |
			((uint32_t)input[103] << 20) |
			((uint32_t)(input[104] & 0xf0) << 12);
	output[51] = (double)(value >> 16);

	// read output[52]: from bit 836 to 851
	value = ((uint32_t)(input[104] & 0x0f) << 28) |
			((uint32_t)input[105] << 20) |
			((uint32_t)(input[106] & 0xf0) << 12);
	output[52] = (double)(value >> 16);
}

static void unpack_53_16bit_signed_5off(const uint8_t * input, double * output, void *closure) {
	// Unpack 53 values into output
	// Values are 16-bit signed
	// Skip 5 bits, read 848 bits of data.
	// Input must be at least 107 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 5 to 20
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)(input[2] & 0xf8) << 13);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 21 to 36
	value = ((uint32_t)(input[2] & 0x07) << 29) |
			((uint32_t)input[3] << 21) |
			((uint32_t)(input[4] & 0xf8) << 13);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 37 to 52
	value = ((uint32_t)(input[4] & 0x07) << 29) |
			((uint32_t)input[5] << 21) |
			((uint32_t)(input[6] & 0xf8) << 13);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 53 to 68
	value = ((uint32_t)(input[6] & 0x07) << 29) |
			((uint32_t)input[7] << 21) |
			((uint32_t)(input[8] & 0xf8) << 13);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 69 to 84
	value = ((uint32_t)(input[8] & 0x07) << 29) |
			((uint32_t)input[9] << 21) |
			((uint32_t)(input[10] & 0xf8) << 13);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 85 to 100
	value = ((uint32_t)(input[10] & 0x07) << 29) |
			((uint32_t)input[11] << 21) |
			((uint32_t)(input[12] & 0xf8) << 13);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 101 to 116
	value = ((uint32_t)(input[12] & 0x07) << 29) |
			((uint32_t)input[13] << 21) |
			((uint32_t)(input[14] & 0xf8) << 13);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 117 to 132
	value = ((uint32_t)(input[14] & 0x07) << 29) |
			((uint32_t)input[15] << 21) |
			((uint32_t)(input[16] & 0xf8) << 13);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 133 to 148
	value = ((uint32_t)(input[16] & 0x07) << 29) |
			((uint32_t)input[17] << 21) |
			((uint32_t)(input[18] & 0xf8) << 13);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 149 to 164
	value = ((uint32_t)(input[18] & 0x07) << 29) |
			((uint32_t)input[19] << 21) |
			((uint32_t)(input[20] & 0xf8) << 13);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 165 to 180
	value = ((uint32_t)(input[20] & 0x07) << 29) |
			((uint32_t)input[21] << 21) |
			((uint32_t)(input[22] & 0xf8) << 13);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 181 to 196
	value = ((uint32_t)(input[22] & 0x07) << 29) |
			((uint32_t)input[23] << 21) |
			((uint32_t)(input[24] & 0xf8) << 13);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 197 to 212
	value = ((uint32_t)(input[24] & 0x07) << 29) |
			((uint32_t)input[25] << 21) |
			((uint32_t)(input[26] & 0xf8) << 13);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 213 to 228
	value = ((uint32_t)(input[26] & 0x07) << 29) |
			((uint32_t)input[27] << 21) |
			((uint32_t)(input[28] & 0xf8) << 13);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 229 to 244
	value = ((uint32_t)(input[28] & 0x07) << 29) |
			((uint32_t)input[29] << 21) |
			((uint32_t)(input[30] & 0xf8) << 13);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 245 to 260
	value = ((uint32_t)(input[30] & 0x07) << 29) |
			((uint32_t)input[31] << 21) |
			((uint32_t)(input[32] & 0xf8) << 13);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 261 to 276
	value = ((uint32_t)(input[32] & 0x07) << 29) |
			((uint32_t)input[33] << 21) |
			((uint32_t)(input[34] & 0xf8) << 13);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 277 to 292
	value = ((uint32_t)(input[34] & 0x07) << 29) |
			((uint32_t)input[35] << 21) |
			((uint32_t)(input[36] & 0xf8) << 13);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 293 to 308
	value = ((uint32_t)(input[36] & 0x07) << 29) |
			((uint32_t)input[37] << 21) |
			((uint32_t)(input[38] & 0xf8) << 13);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 309 to 324
	value = ((uint32_t)(input[38] & 0x07) << 29) |
			((uint32_t)input[39] << 21) |
			((uint32_t)(input[40] & 0xf8) << 13);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 325 to 340
	value = ((uint32_t)(input[40] & 0x07) << 29) |
			((uint32_t)input[41] << 21) |
			((uint32_t)(input[42] & 0xf8) << 13);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 341 to 356
	value = ((uint32_t)(input[42] & 0x07) << 29) |
			((uint32_t)input[43] << 21) |
			((uint32_t)(input[44] & 0xf8) << 13);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 357 to 372
	value = ((uint32_t)(input[44] & 0x07) << 29) |
			((uint32_t)input[45] << 21) |
			((uint32_t)(input[46] & 0xf8) << 13);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 373 to 388
	value = ((uint32_t)(input[46] & 0x07) << 29) |
			((uint32_t)input[47] << 21) |
			((uint32_t)(input[48] & 0xf8) << 13);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 389 to 404
	value = ((uint32_t)(input[48] & 0x07) << 29) |
			((uint32_t)input[49] << 21) |
			((uint32_t)(input[50] & 0xf8) << 13);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 405 to 420
	value = ((uint32_t)(input[50] & 0x07) << 29) |
			((uint32_t)input[51] << 21) |
			((uint32_t)(input[52] & 0xf8) << 13);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 421 to 436
	value = ((uint32_t)(input[52] & 0x07) << 29) |
			((uint32_t)input[53] << 21) |
			((uint32_t)(input[54] & 0xf8) << 13);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 437 to 452
	value = ((uint32_t)(input[54] & 0x07) << 29) |
			((uint32_t)input[55] << 21) |
			((uint32_t)(input[56] & 0xf8) << 13);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 453 to 468
	value = ((uint32_t)(input[56] & 0x07) << 29) |
			((uint32_t)input[57] << 21) |
			((uint32_t)(input[58] & 0xf8) << 13);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 469 to 484
	value = ((uint32_t)(input[58] & 0x07) << 29) |
			((uint32_t)input[59] << 21) |
			((uint32_t)(input[60] & 0xf8) << 13);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 485 to 500
	value = ((uint32_t)(input[60] & 0x07) << 29) |
			((uint32_t)input[61] << 21) |
			((uint32_t)(input[62] & 0xf8) << 13);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 501 to 516
	value = ((uint32_t)(input[62] & 0x07) << 29) |
			((uint32_t)input[63] << 21) |
			((uint32_t)(input[64] & 0xf8) << 13);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 517 to 532
	value = ((uint32_t)(input[64] & 0x07) << 29) |
			((uint32_t)input[65] << 21) |
			((uint32_t)(input[66] & 0xf8) << 13);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 533 to 548
	value = ((uint32_t)(input[66] & 0x07) << 29) |
			((uint32_t)input[67] << 21) |
			((uint32_t)(input[68] & 0xf8) << 13);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 549 to 564
	value = ((uint32_t)(input[68] & 0x07) << 29) |
			((uint32_t)input[69] << 21) |
			((uint32_t)(input[70] & 0xf8) << 13);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 565 to 580
	value = ((uint32_t)(input[70] & 0x07) << 29) |
			((uint32_t)input[71] << 21) |
			((uint32_t)(input[72] & 0xf8) << 13);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 581 to 596
	value = ((uint32_t)(input[72] & 0x07) << 29) |
			((uint32_t)input[73] << 21) |
			((uint32_t)(input[74] & 0xf8) << 13);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 597 to 612
	value = ((uint32_t)(input[74] & 0x07) << 29) |
			((uint32_t)input[75] << 21) |
			((uint32_t)(input[76] & 0xf8) << 13);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 613 to 628
	value = ((uint32_t)(input[76] & 0x07) << 29) |
			((uint32_t)input[77] << 21) |
			((uint32_t)(input[78] & 0xf8) << 13);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 629 to 644
	value = ((uint32_t)(input[78] & 0x07) << 29) |
			((uint32_t)input[79] << 21) |
			((uint32_t)(input[80] & 0xf8) << 13);
	output[39] = (double)(value >> 16);

	// read output[40]: from bit 645 to 660
	value = ((uint32_t)(input[80] & 0x07) << 29) |
			((uint32_t)input[81] << 21) |
			((uint32_t)(input[82] & 0xf8) << 13);
	output[40] = (double)(value >> 16);

	// read output[41]: from bit 661 to 676
	value = ((uint32_t)(input[82] & 0x07) << 29) |
			((uint32_t)input[83] << 21) |
			((uint32_t)(input[84] & 0xf8) << 13);
	output[41] = (double)(value >> 16);

	// read output[42]: from bit 677 to 692
	value = ((uint32_t)(input[84] & 0x07) << 29) |
			((uint32_t)input[85] << 21) |
			((uint32_t)(input[86] & 0xf8) << 13);
	output[42] = (double)(value >> 16);

	// read output[43]: from bit 693 to 708
	value = ((uint32_t)(input[86] & 0x07) << 29) |
			((uint32_t)input[87] << 21) |
			((uint32_t)(input[88] & 0xf8) << 13);
	output[43] = (double)(value >> 16);

	// read output[44]: from bit 709 to 724
	value = ((uint32_t)(input[88] & 0x07) << 29) |
			((uint32_t)input[89] << 21) |
			((uint32_t)(input[90] & 0xf8) << 13);
	output[44] = (double)(value >> 16);

	// read output[45]: from bit 725 to 740
	value = ((uint32_t)(input[90] & 0x07) << 29) |
			((uint32_t)input[91] << 21) |
			((uint32_t)(input[92] & 0xf8) << 13);
	output[45] = (double)(value >> 16);

	// read output[46]: from bit 741 to 756
	value = ((uint32_t)(input[92] & 0x07) << 29) |
			((uint32_t)input[93] << 21) |
			((uint32_t)(input[94] & 0xf8) << 13);
	output[46] = (double)(value >> 16);

	// read output[47]: from bit 757 to 772
	value = ((uint32_t)(input[94] & 0x07) << 29) |
			((uint32_t)input[95] << 21) |
			((uint32_t)(input[96] & 0xf8) << 13);
	output[47] = (double)(value >> 16);

	// read output[48]: from bit 773 to 788
	value = ((uint32_t)(input[96] & 0x07) << 29) |
			((uint32_t)input[97] << 21) |
			((uint32_t)(input[98] & 0xf8) << 13);
	output[48] = (double)(value >> 16);

	// read output[49]: from bit 789 to 804
	value = ((uint32_t)(input[98] & 0x07) << 29) |
			((uint32_t)input[99] << 21) |
			((uint32_t)(input[100] & 0xf8) << 13);
	output[49] = (double)(value >> 16);

	// read output[50]: from bit 805 to 820
	value = ((uint32_t)(input[100] & 0x07) << 29) |
			((uint32_t)input[101] << 21) |
			((uint32_t)(input[102] & 0xf8) << 13);
	output[50] = (double)(value >> 16);

	// read output[51]: from bit 821 to 836
	value = ((uint32_t)(input[102] & 0x07) << 29) |
			((uint32_t)input[103] << 21) |
			((uint32_t)(input[104] & 0xf8) << 13);
	output[51] = (double)(value >> 16);

	// read output[52]: from bit 837 to 852
	value = ((uint32_t)(input[104] & 0x07) << 29) |
			((uint32_t)input[105] << 21) |
			((uint32_t)(input[106] & 0xf8) << 13);
	output[52] = (double)(value >> 16);
}

static void unpack_53_16bit_unsigned_5off(const uint8_t * input, double * output, void *closure) {
	// Unpack 53 values into output
	// Values are 16-bit unsigned
	// Skip 5 bits, read 848 bits of data.
	// Input must be at least 107 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 5 to 20
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)(input[2] & 0xf8) << 13);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 21 to 36
	value = ((uint32_t)(input[2] & 0x07) << 29) |
			((uint32_t)input[3] << 21) |
			((uint32_t)(input[4] & 0xf8) << 13);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 37 to 52
	value = ((uint32_t)(input[4] & 0x07) << 29) |
			((uint32_t)input[5] << 21) |
			((uint32_t)(input[6] & 0xf8) << 13);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 53 to 68
	value = ((uint32_t)(input[6] & 0x07) << 29) |
			((uint32_t)input[7] << 21) |
			((uint32_t)(input[8] & 0xf8) << 13);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 69 to 84
	value = ((uint32_t)(input[8] & 0x07) << 29) |
			((uint32_t)input[9] << 21) |
			((uint32_t)(input[10] & 0xf8) << 13);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 85 to 100
	value = ((uint32_t)(input[10] & 0x07) << 29) |
			((uint32_t)input[11] << 21) |
			((uint32_t)(input[12] & 0xf8) << 13);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 101 to 116
	value = ((uint32_t)(input[12] & 0x07) << 29) |
			((uint32_t)input[13] << 21) |
			((uint32_t)(input[14] & 0xf8) << 13);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 117 to 132
	value = ((uint32_t)(input[14] & 0x07) << 29) |
			((uint32_t)input[15] << 21) |
			((uint32_t)(input[16] & 0xf8) << 13);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 133 to 148
	value = ((uint32_t)(input[16] & 0x07) << 29) |
			((uint32_t)input[17] << 21) |
			((uint32_t)(input[18] & 0xf8) << 13);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 149 to 164
	value = ((uint32_t)(input[18] & 0x07) << 29) |
			((uint32_t)input[19] << 21) |
			((uint32_t)(input[20] & 0xf8) << 13);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 165 to 180
	value = ((uint32_t)(input[20] & 0x07) << 29) |
			((uint32_t)input[21] << 21) |
			((uint32_t)(input[22] & 0xf8) << 13);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 181 to 196
	value = ((uint32_t)(input[22] & 0x07) << 29) |
			((uint32_t)input[23] << 21) |
			((uint32_t)(input[24] & 0xf8) << 13);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 197 to 212
	value = ((uint32_t)(input[24] & 0x07) << 29) |
			((uint32_t)input[25] << 21) |
			((uint32_t)(input[26] & 0xf8) << 13);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 213 to 228
	value = ((uint32_t)(input[26] & 0x07) << 29) |
			((uint32_t)input[27] << 21) |
			((uint32_t)(input[28] & 0xf8) << 13);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 229 to 244
	value = ((uint32_t)(input[28] & 0x07) << 29) |
			((uint32_t)input[29] << 21) |
			((uint32_t)(input[30] & 0xf8) << 13);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 245 to 260
	value = ((uint32_t)(input[30] & 0x07) << 29) |
			((uint32_t)input[31] << 21) |
			((uint32_t)(input[32] & 0xf8) << 13);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 261 to 276
	value = ((uint32_t)(input[32] & 0x07) << 29) |
			((uint32_t)input[33] << 21) |
			((uint32_t)(input[34] & 0xf8) << 13);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 277 to 292
	value = ((uint32_t)(input[34] & 0x07) << 29) |
			((uint32_t)input[35] << 21) |
			((uint32_t)(input[36] & 0xf8) << 13);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 293 to 308
	value = ((uint32_t)(input[36] & 0x07) << 29) |
			((uint32_t)input[37] << 21) |
			((uint32_t)(input[38] & 0xf8) << 13);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 309 to 324
	value = ((uint32_t)(input[38] & 0x07) << 29) |
			((uint32_t)input[39] << 21) |
			((uint32_t)(input[40] & 0xf8) << 13);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 325 to 340
	value = ((uint32_t)(input[40] & 0x07) << 29) |
			((uint32_t)input[41] << 21) |
			((uint32_t)(input[42] & 0xf8) << 13);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 341 to 356
	value = ((uint32_t)(input[42] & 0x07) << 29) |
			((uint32_t)input[43] << 21) |
			((uint32_t)(input[44] & 0xf8) << 13);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 357 to 372
	value = ((uint32_t)(input[44] & 0x07) << 29) |
			((uint32_t)input[45] << 21) |
			((uint32_t)(input[46] & 0xf8) << 13);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 373 to 388
	value = ((uint32_t)(input[46] & 0x07) << 29) |
			((uint32_t)input[47] << 21) |
			((uint32_t)(input[48] & 0xf8) << 13);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 389 to 404
	value = ((uint32_t)(input[48] & 0x07) << 29) |
			((uint32_t)input[49] << 21) |
			((uint32_t)(input[50] & 0xf8) << 13);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 405 to 420
	value = ((uint32_t)(input[50] & 0x07) << 29) |
			((uint32_t)input[51] << 21) |
			((uint32_t)(input[52] & 0xf8) << 13);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 421 to 436
	value = ((uint32_t)(input[52] & 0x07) << 29) |
			((uint32_t)input[53] << 21) |
			((uint32_t)(input[54] & 0xf8) << 13);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 437 to 452
	value = ((uint32_t)(input[54] & 0x07) << 29) |
			((uint32_t)input[55] << 21) |
			((uint32_t)(input[56] & 0xf8) << 13);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 453 to 468
	value = ((uint32_t)(input[56] & 0x07) << 29) |
			((uint32_t)input[57] << 21) |
			((uint32_t)(input[58] & 0xf8) << 13);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 469 to 484
	value = ((uint32_t)(input[58] & 0x07) << 29) |
			((uint32_t)input[59] << 21) |
			((uint32_t)(input[60] & 0xf8) << 13);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 485 to 500
	value = ((uint32_t)(input[60] & 0x07) << 29) |
			((uint32_t)input[61] << 21) |
			((uint32_t)(input[62] & 0xf8) << 13);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 501 to 516
	value = ((uint32_t)(input[62] & 0x07) << 29) |
			((uint32_t)input[63] << 21) |
			((uint32_t)(input[64] & 0xf8) << 13);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 517 to 532
	value = ((uint32_t)(input[64] & 0x07) << 29) |
			((uint32_t)input[65] << 21) |
			((uint32_t)(input[66] & 0xf8) << 13);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 533 to 548
	value = ((uint32_t)(input[66] & 0x07) << 29) |
			((uint32_t)input[67] << 21) |
			((uint32_t)(input[68] & 0xf8) << 13);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 549 to 564
	value = ((uint32_t)(input[68] & 0x07) << 29) |
			((uint32_t)input[69] << 21) |
			((uint32_t)(input[70] & 0xf8) << 13);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 565 to 580
	value = ((uint32_t)(input[70] & 0x07) << 29) |
			((uint32_t)input[71] << 21) |
			((uint32_t)(input[72] & 0xf8) << 13);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 581 to 596
	value = ((uint32_t)(input[72] & 0x07) << 29) |
			((uint32_t)input[73] << 21) |
			((uint32_t)(input[74] & 0xf8) << 13);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 597 to 612
	value = ((uint32_t)(input[74] & 0x07) << 29) |
			((uint32_t)input[75] << 21) |
			((uint32_t)(input[76] & 0xf8) << 13);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 613 to 628
	value = ((uint32_t)(input[76] & 0x07) << 29) |
			((uint32_t)input[77] << 21) |
			((uint32_t)(input[78] & 0xf8) << 13);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 629 to 644
	value = ((uint32_t)(input[78] & 0x07) << 29) |
			((uint32_t)input[79] << 21) |
			((uint32_t)(input[80] & 0xf8) << 13);
	output[39] = (double)(value >> 16);

	// read output[40]: from bit 645 to 660
	value = ((uint32_t)(input[80] & 0x07) << 29) |
			((uint32_t)input[81] << 21) |
			((uint32_t)(input[82] & 0xf8) << 13);
	output[40] = (double)(value >> 16);

	// read output[41]: from bit 661 to 676
	value = ((uint32_t)(input[82] & 0x07) << 29) |
			((uint32_t)input[83] << 21) |
			((uint32_t)(input[84] & 0xf8) << 13);
	output[41] = (double)(value >> 16);

	// read output[42]: from bit 677 to 692
	value = ((uint32_t)(input[84] & 0x07) << 29) |
			((uint32_t)input[85] << 21) |
			((uint32_t)(input[86] & 0xf8) << 13);
	output[42] = (double)(value >> 16);

	// read output[43]: from bit 693 to 708
	value = ((uint32_t)(input[86] & 0x07) << 29) |
			((uint32_t)input[87] << 21) |
			((uint32_t)(input[88] & 0xf8) << 13);
	output[43] = (double)(value >> 16);

	// read output[44]: from bit 709 to 724
	value = ((uint32_t)(input[88] & 0x07) << 29) |
			((uint32_t)input[89] << 21) |
			((uint32_t)(input[90] & 0xf8) << 13);
	output[44] = (double)(value >> 16);

	// read output[45]: from bit 725 to 740
	value = ((uint32_t)(input[90] & 0x07) << 29) |
			((uint32_t)input[91] << 21) |
			((uint32_t)(input[92] & 0xf8) << 13);
	output[45] = (double)(value >> 16);

	// read output[46]: from bit 741 to 756
	value = ((uint32_t)(input[92] & 0x07) << 29) |
			((uint32_t)input[93] << 21) |
			((uint32_t)(input[94] & 0xf8) << 13);
	output[46] = (double)(value >> 16);

	// read output[47]: from bit 757 to 772
	value = ((uint32_t)(input[94] & 0x07) << 29) |
			((uint32_t)input[95] << 21) |
			((uint32_t)(input[96] & 0xf8) << 13);
	output[47] = (double)(value >> 16);

	// read output[48]: from bit 773 to 788
	value = ((uint32_t)(input[96] & 0x07) << 29) |
			((uint32_t)input[97] << 21) |
			((uint32_t)(input[98] & 0xf8) << 13);
	output[48] = (double)(value >> 16);

	// read output[49]: from bit 789 to 804
	value = ((uint32_t)(input[98] & 0x07) << 29) |
			((uint32_t)input[99] << 21) |
			((uint32_t)(input[100] & 0xf8) << 13);
	output[49] = (double)(value >> 16);

	// read output[50]: from bit 805 to 820
	value = ((uint32_t)(input[100] & 0x07) << 29) |
			((uint32_t)input[101] << 21) |
			((uint32_t)(input[102] & 0xf8) << 13);
	output[50] = (double)(value >> 16);

	// read output[51]: from bit 821 to 836
	value = ((uint32_t)(input[102] & 0x07) << 29) |
			((uint32_t)input[103] << 21) |
			((uint32_t)(input[104] & 0xf8) << 13);
	output[51] = (double)(value >> 16);

	// read output[52]: from bit 837 to 852
	value = ((uint32_t)(input[104] & 0x07) << 29) |
			((uint32_t)input[105] << 21) |
			((uint32_t)(input[106] & 0xf8) << 13);
	output[52] = (double)(value >> 16);
}

static void unpack_53_16bit_signed_6off(const uint8_t * input, double * output, void *closure) {
	// Unpack 53 values into output
	// Values are 16-bit signed
	// Skip 6 bits, read 848 bits of data.
	// Input must be at least 107 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 6 to 21
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)(input[2] & 0xfc) << 14);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 22 to 37
	value = ((uint32_t)(input[2] & 0x03) << 30) |
			((uint32_t)input[3] << 22) |
			((uint32_t)(input[4] & 0xfc) << 14);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 38 to 53
	value = ((uint32_t)(input[4] & 0x03) << 30) |
			((uint32_t)input[5] << 22) |
			((uint32_t)(input[6] & 0xfc) << 14);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 54 to 69
	value = ((uint32_t)(input[6] & 0x03) << 30) |
			((uint32_t)input[7] << 22) |
			((uint32_t)(input[8] & 0xfc) << 14);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 70 to 85
	value = ((uint32_t)(input[8] & 0x03) << 30) |
			((uint32_t)input[9] << 22) |
			((uint32_t)(input[10] & 0xfc) << 14);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 86 to 101
	value = ((uint32_t)(input[10] & 0x03) << 30) |
			((uint32_t)input[11] << 22) |
			((uint32_t)(input[12] & 0xfc) << 14);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 102 to 117
	value = ((uint32_t)(input[12] & 0x03) << 30) |
			((uint32_t)input[13] << 22) |
			((uint32_t)(input[14] & 0xfc) << 14);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 118 to 133
	value = ((uint32_t)(input[14] & 0x03) << 30) |
			((uint32_t)input[15] << 22) |
			((uint32_t)(input[16] & 0xfc) << 14);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 134 to 149
	value = ((uint32_t)(input[16] & 0x03) << 30) |
			((uint32_t)input[17] << 22) |
			((uint32_t)(input[18] & 0xfc) << 14);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 150 to 165
	value = ((uint32_t)(input[18] & 0x03) << 30) |
			((uint32_t)input[19] << 22) |
			((uint32_t)(input[20] & 0xfc) << 14);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 166 to 181
	value = ((uint32_t)(input[20] & 0x03) << 30) |
			((uint32_t)input[21] << 22) |
			((uint32_t)(input[22] & 0xfc) << 14);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 182 to 197
	value = ((uint32_t)(input[22] & 0x03) << 30) |
			((uint32_t)input[23] << 22) |
			((uint32_t)(input[24] & 0xfc) << 14);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 198 to 213
	value = ((uint32_t)(input[24] & 0x03) << 30) |
			((uint32_t)input[25] << 22) |
			((uint32_t)(input[26] & 0xfc) << 14);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 214 to 229
	value = ((uint32_t)(input[26] & 0x03) << 30) |
			((uint32_t)input[27] << 22) |
			((uint32_t)(input[28] & 0xfc) << 14);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 230 to 245
	value = ((uint32_t)(input[28] & 0x03) << 30) |
			((uint32_t)input[29] << 22) |
			((uint32_t)(input[30] & 0xfc) << 14);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 246 to 261
	value = ((uint32_t)(input[30] & 0x03) << 30) |
			((uint32_t)input[31] << 22) |
			((uint32_t)(input[32] & 0xfc) << 14);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 262 to 277
	value = ((uint32_t)(input[32] & 0x03) << 30) |
			((uint32_t)input[33] << 22) |
			((uint32_t)(input[34] & 0xfc) << 14);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 278 to 293
	value = ((uint32_t)(input[34] & 0x03) << 30) |
			((uint32_t)input[35] << 22) |
			((uint32_t)(input[36] & 0xfc) << 14);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 294 to 309
	value = ((uint32_t)(input[36] & 0x03) << 30) |
			((uint32_t)input[37] << 22) |
			((uint32_t)(input[38] & 0xfc) << 14);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 310 to 325
	value = ((uint32_t)(input[38] & 0x03) << 30) |
			((uint32_t)input[39] << 22) |
			((uint32_t)(input[40] & 0xfc) << 14);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 326 to 341
	value = ((uint32_t)(input[40] & 0x03) << 30) |
			((uint32_t)input[41] << 22) |
			((uint32_t)(input[42] & 0xfc) << 14);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 342 to 357
	value = ((uint32_t)(input[42] & 0x03) << 30) |
			((uint32_t)input[43] << 22) |
			((uint32_t)(input[44] & 0xfc) << 14);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 358 to 373
	value = ((uint32_t)(input[44] & 0x03) << 30) |
			((uint32_t)input[45] << 22) |
			((uint32_t)(input[46] & 0xfc) << 14);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 374 to 389
	value = ((uint32_t)(input[46] & 0x03) << 30) |
			((uint32_t)input[47] << 22) |
			((uint32_t)(input[48] & 0xfc) << 14);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 390 to 405
	value = ((uint32_t)(input[48] & 0x03) << 30) |
			((uint32_t)input[49] << 22) |
			((uint32_t)(input[50] & 0xfc) << 14);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 406 to 421
	value = ((uint32_t)(input[50] & 0x03) << 30) |
			((uint32_t)input[51] << 22) |
			((uint32_t)(input[52] & 0xfc) << 14);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 422 to 437
	value = ((uint32_t)(input[52] & 0x03) << 30) |
			((uint32_t)input[53] << 22) |
			((uint32_t)(input[54] & 0xfc) << 14);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 438 to 453
	value = ((uint32_t)(input[54] & 0x03) << 30) |
			((uint32_t)input[55] << 22) |
			((uint32_t)(input[56] & 0xfc) << 14);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 454 to 469
	value = ((uint32_t)(input[56] & 0x03) << 30) |
			((uint32_t)input[57] << 22) |
			((uint32_t)(input[58] & 0xfc) << 14);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 470 to 485
	value = ((uint32_t)(input[58] & 0x03) << 30) |
			((uint32_t)input[59] << 22) |
			((uint32_t)(input[60] & 0xfc) << 14);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 486 to 501
	value = ((uint32_t)(input[60] & 0x03) << 30) |
			((uint32_t)input[61] << 22) |
			((uint32_t)(input[62] & 0xfc) << 14);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 502 to 517
	value = ((uint32_t)(input[62] & 0x03) << 30) |
			((uint32_t)input[63] << 22) |
			((uint32_t)(input[64] & 0xfc) << 14);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 518 to 533
	value = ((uint32_t)(input[64] & 0x03) << 30) |
			((uint32_t)input[65] << 22) |
			((uint32_t)(input[66] & 0xfc) << 14);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 534 to 549
	value = ((uint32_t)(input[66] & 0x03) << 30) |
			((uint32_t)input[67] << 22) |
			((uint32_t)(input[68] & 0xfc) << 14);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 550 to 565
	value = ((uint32_t)(input[68] & 0x03) << 30) |
			((uint32_t)input[69] << 22) |
			((uint32_t)(input[70] & 0xfc) << 14);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 566 to 581
	value = ((uint32_t)(input[70] & 0x03) << 30) |
			((uint32_t)input[71] << 22) |
			((uint32_t)(input[72] & 0xfc) << 14);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 582 to 597
	value = ((uint32_t)(input[72] & 0x03) << 30) |
			((uint32_t)input[73] << 22) |
			((uint32_t)(input[74] & 0xfc) << 14);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 598 to 613
	value = ((uint32_t)(input[74] & 0x03) << 30) |
			((uint32_t)input[75] << 22) |
			((uint32_t)(input[76] & 0xfc) << 14);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 614 to 629
	value = ((uint32_t)(input[76] & 0x03) << 30) |
			((uint32_t)input[77] << 22) |
			((uint32_t)(input[78] & 0xfc) << 14);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 630 to 645
	value = ((uint32_t)(input[78] & 0x03) << 30) |
			((uint32_t)input[79] << 22) |
			((uint32_t)(input[80] & 0xfc) << 14);
	output[39] = (double)(value >> 16);

	// read output[40]: from bit 646 to 661
	value = ((uint32_t)(input[80] & 0x03) << 30) |
			((uint32_t)input[81] << 22) |
			((uint32_t)(input[82] & 0xfc) << 14);
	output[40] = (double)(value >> 16);

	// read output[41]: from bit 662 to 677
	value = ((uint32_t)(input[82] & 0x03) << 30) |
			((uint32_t)input[83] << 22) |
			((uint32_t)(input[84] & 0xfc) << 14);
	output[41] = (double)(value >> 16);

	// read output[42]: from bit 678 to 693
	value = ((uint32_t)(input[84] & 0x03) << 30) |
			((uint32_t)input[85] << 22) |
			((uint32_t)(input[86] & 0xfc) << 14);
	output[42] = (double)(value >> 16);

	// read output[43]: from bit 694 to 709
	value = ((uint32_t)(input[86] & 0x03) << 30) |
			((uint32_t)input[87] << 22) |
			((uint32_t)(input[88] & 0xfc) << 14);
	output[43] = (double)(value >> 16);

	// read output[44]: from bit 710 to 725
	value = ((uint32_t)(input[88] & 0x03) << 30) |
			((uint32_t)input[89] << 22) |
			((uint32_t)(input[90] & 0xfc) << 14);
	output[44] = (double)(value >> 16);

	// read output[45]: from bit 726 to 741
	value = ((uint32_t)(input[90] & 0x03) << 30) |
			((uint32_t)input[91] << 22) |
			((uint32_t)(input[92] & 0xfc) << 14);
	output[45] = (double)(value >> 16);

	// read output[46]: from bit 742 to 757
	value = ((uint32_t)(input[92] & 0x03) << 30) |
			((uint32_t)input[93] << 22) |
			((uint32_t)(input[94] & 0xfc) << 14);
	output[46] = (double)(value >> 16);

	// read output[47]: from bit 758 to 773
	value = ((uint32_t)(input[94] & 0x03) << 30) |
			((uint32_t)input[95] << 22) |
			((uint32_t)(input[96] & 0xfc) << 14);
	output[47] = (double)(value >> 16);

	// read output[48]: from bit 774 to 789
	value = ((uint32_t)(input[96] & 0x03) << 30) |
			((uint32_t)input[97] << 22) |
			((uint32_t)(input[98] & 0xfc) << 14);
	output[48] = (double)(value >> 16);

	// read output[49]: from bit 790 to 805
	value = ((uint32_t)(input[98] & 0x03) << 30) |
			((uint32_t)input[99] << 22) |
			((uint32_t)(input[100] & 0xfc) << 14);
	output[49] = (double)(value >> 16);

	// read output[50]: from bit 806 to 821
	value = ((uint32_t)(input[100] & 0x03) << 30) |
			((uint32_t)input[101] << 22) |
			((uint32_t)(input[102] & 0xfc) << 14);
	output[50] = (double)(value >> 16);

	// read output[51]: from bit 822 to 837
	value = ((uint32_t)(input[102] & 0x03) << 30) |
			((uint32_t)input[103] << 22) |
			((uint32_t)(input[104] & 0xfc) << 14);
	output[51] = (double)(value >> 16);

	// read output[52]: from bit 838 to 853
	value = ((uint32_t)(input[104] & 0x03) << 30) |
			((uint32_t)input[105] << 22) |
			((uint32_t)(input[106] & 0xfc) << 14);
	output[52] = (double)(value >> 16);
}

static void unpack_53_16bit_unsigned_6off(const uint8_t * input, double * output, void *closure) {
	// Unpack 53 values into output
	// Values are 16-bit unsigned
	// Skip 6 bits, read 848 bits of data.
	// Input must be at least 107 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 6 to 21
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)(input[2] & 0xfc) << 14);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 22 to 37
	value = ((uint32_t)(input[2] & 0x03) << 30) |
			((uint32_t)input[3] << 22) |
			((uint32_t)(input[4] & 0xfc) << 14);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 38 to 53
	value = ((uint32_t)(input[4] & 0x03) << 30) |
			((uint32_t)input[5] << 22) |
			((uint32_t)(input[6] & 0xfc) << 14);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 54 to 69
	value = ((uint32_t)(input[6] & 0x03) << 30) |
			((uint32_t)input[7] << 22) |
			((uint32_t)(input[8] & 0xfc) << 14);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 70 to 85
	value = ((uint32_t)(input[8] & 0x03) << 30) |
			((uint32_t)input[9] << 22) |
			((uint32_t)(input[10] & 0xfc) << 14);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 86 to 101
	value = ((uint32_t)(input[10] & 0x03) << 30) |
			((uint32_t)input[11] << 22) |
			((uint32_t)(input[12] & 0xfc) << 14);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 102 to 117
	value = ((uint32_t)(input[12] & 0x03) << 30) |
			((uint32_t)input[13] << 22) |
			((uint32_t)(input[14] & 0xfc) << 14);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 118 to 133
	value = ((uint32_t)(input[14] & 0x03) << 30) |
			((uint32_t)input[15] << 22) |
			((uint32_t)(input[16] & 0xfc) << 14);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 134 to 149
	value = ((uint32_t)(input[16] & 0x03) << 30) |
			((uint32_t)input[17] << 22) |
			((uint32_t)(input[18] & 0xfc) << 14);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 150 to 165
	value = ((uint32_t)(input[18] & 0x03) << 30) |
			((uint32_t)input[19] << 22) |
			((uint32_t)(input[20] & 0xfc) << 14);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 166 to 181
	value = ((uint32_t)(input[20] & 0x03) << 30) |
			((uint32_t)input[21] << 22) |
			((uint32_t)(input[22] & 0xfc) << 14);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 182 to 197
	value = ((uint32_t)(input[22] & 0x03) << 30) |
			((uint32_t)input[23] << 22) |
			((uint32_t)(input[24] & 0xfc) << 14);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 198 to 213
	value = ((uint32_t)(input[24] & 0x03) << 30) |
			((uint32_t)input[25] << 22) |
			((uint32_t)(input[26] & 0xfc) << 14);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 214 to 229
	value = ((uint32_t)(input[26] & 0x03) << 30) |
			((uint32_t)input[27] << 22) |
			((uint32_t)(input[28] & 0xfc) << 14);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 230 to 245
	value = ((uint32_t)(input[28] & 0x03) << 30) |
			((uint32_t)input[29] << 22) |
			((uint32_t)(input[30] & 0xfc) << 14);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 246 to 261
	value = ((uint32_t)(input[30] & 0x03) << 30) |
			((uint32_t)input[31] << 22) |
			((uint32_t)(input[32] & 0xfc) << 14);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 262 to 277
	value = ((uint32_t)(input[32] & 0x03) << 30) |
			((uint32_t)input[33] << 22) |
			((uint32_t)(input[34] & 0xfc) << 14);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 278 to 293
	value = ((uint32_t)(input[34] & 0x03) << 30) |
			((uint32_t)input[35] << 22) |
			((uint32_t)(input[36] & 0xfc) << 14);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 294 to 309
	value = ((uint32_t)(input[36] & 0x03) << 30) |
			((uint32_t)input[37] << 22) |
			((uint32_t)(input[38] & 0xfc) << 14);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 310 to 325
	value = ((uint32_t)(input[38] & 0x03) << 30) |
			((uint32_t)input[39] << 22) |
			((uint32_t)(input[40] & 0xfc) << 14);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 326 to 341
	value = ((uint32_t)(input[40] & 0x03) << 30) |
			((uint32_t)input[41] << 22) |
			((uint32_t)(input[42] & 0xfc) << 14);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 342 to 357
	value = ((uint32_t)(input[42] & 0x03) << 30) |
			((uint32_t)input[43] << 22) |
			((uint32_t)(input[44] & 0xfc) << 14);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 358 to 373
	value = ((uint32_t)(input[44] & 0x03) << 30) |
			((uint32_t)input[45] << 22) |
			((uint32_t)(input[46] & 0xfc) << 14);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 374 to 389
	value = ((uint32_t)(input[46] & 0x03) << 30) |
			((uint32_t)input[47] << 22) |
			((uint32_t)(input[48] & 0xfc) << 14);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 390 to 405
	value = ((uint32_t)(input[48] & 0x03) << 30) |
			((uint32_t)input[49] << 22) |
			((uint32_t)(input[50] & 0xfc) << 14);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 406 to 421
	value = ((uint32_t)(input[50] & 0x03) << 30) |
			((uint32_t)input[51] << 22) |
			((uint32_t)(input[52] & 0xfc) << 14);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 422 to 437
	value = ((uint32_t)(input[52] & 0x03) << 30) |
			((uint32_t)input[53] << 22) |
			((uint32_t)(input[54] & 0xfc) << 14);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 438 to 453
	value = ((uint32_t)(input[54] & 0x03) << 30) |
			((uint32_t)input[55] << 22) |
			((uint32_t)(input[56] & 0xfc) << 14);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 454 to 469
	value = ((uint32_t)(input[56] & 0x03) << 30) |
			((uint32_t)input[57] << 22) |
			((uint32_t)(input[58] & 0xfc) << 14);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 470 to 485
	value = ((uint32_t)(input[58] & 0x03) << 30) |
			((uint32_t)input[59] << 22) |
			((uint32_t)(input[60] & 0xfc) << 14);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 486 to 501
	value = ((uint32_t)(input[60] & 0x03) << 30) |
			((uint32_t)input[61] << 22) |
			((uint32_t)(input[62] & 0xfc) << 14);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 502 to 517
	value = ((uint32_t)(input[62] & 0x03) << 30) |
			((uint32_t)input[63] << 22) |
			((uint32_t)(input[64] & 0xfc) << 14);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 518 to 533
	value = ((uint32_t)(input[64] & 0x03) << 30) |
			((uint32_t)input[65] << 22) |
			((uint32_t)(input[66] & 0xfc) << 14);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 534 to 549
	value = ((uint32_t)(input[66] & 0x03) << 30) |
			((uint32_t)input[67] << 22) |
			((uint32_t)(input[68] & 0xfc) << 14);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 550 to 565
	value = ((uint32_t)(input[68] & 0x03) << 30) |
			((uint32_t)input[69] << 22) |
			((uint32_t)(input[70] & 0xfc) << 14);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 566 to 581
	value = ((uint32_t)(input[70] & 0x03) << 30) |
			((uint32_t)input[71] << 22) |
			((uint32_t)(input[72] & 0xfc) << 14);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 582 to 597
	value = ((uint32_t)(input[72] & 0x03) << 30) |
			((uint32_t)input[73] << 22) |
			((uint32_t)(input[74] & 0xfc) << 14);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 598 to 613
	value = ((uint32_t)(input[74] & 0x03) << 30) |
			((uint32_t)input[75] << 22) |
			((uint32_t)(input[76] & 0xfc) << 14);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 614 to 629
	value = ((uint32_t)(input[76] & 0x03) << 30) |
			((uint32_t)input[77] << 22) |
			((uint32_t)(input[78] & 0xfc) << 14);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 630 to 645
	value = ((uint32_t)(input[78] & 0x03) << 30) |
			((uint32_t)input[79] << 22) |
			((uint32_t)(input[80] & 0xfc) << 14);
	output[39] = (double)(value >> 16);

	// read output[40]: from bit 646 to 661
	value = ((uint32_t)(input[80] & 0x03) << 30) |
			((uint32_t)input[81] << 22) |
			((uint32_t)(input[82] & 0xfc) << 14);
	output[40] = (double)(value >> 16);

	// read output[41]: from bit 662 to 677
	value = ((uint32_t)(input[82] & 0x03) << 30) |
			((uint32_t)input[83] << 22) |
			((uint32_t)(input[84] & 0xfc) << 14);
	output[41] = (double)(value >> 16);

	// read output[42]: from bit 678 to 693
	value = ((uint32_t)(input[84] & 0x03) << 30) |
			((uint32_t)input[85] << 22) |
			((uint32_t)(input[86] & 0xfc) << 14);
	output[42] = (double)(value >> 16);

	// read output[43]: from bit 694 to 709
	value = ((uint32_t)(input[86] & 0x03) << 30) |
			((uint32_t)input[87] << 22) |
			((uint32_t)(input[88] & 0xfc) << 14);
	output[43] = (double)(value >> 16);

	// read output[44]: from bit 710 to 725
	value = ((uint32_t)(input[88] & 0x03) << 30) |
			((uint32_t)input[89] << 22) |
			((uint32_t)(input[90] & 0xfc) << 14);
	output[44] = (double)(value >> 16);

	// read output[45]: from bit 726 to 741
	value = ((uint32_t)(input[90] & 0x03) << 30) |
			((uint32_t)input[91] << 22) |
			((uint32_t)(input[92] & 0xfc) << 14);
	output[45] = (double)(value >> 16);

	// read output[46]: from bit 742 to 757
	value = ((uint32_t)(input[92] & 0x03) << 30) |
			((uint32_t)input[93] << 22) |
			((uint32_t)(input[94] & 0xfc) << 14);
	output[46] = (double)(value >> 16);

	// read output[47]: from bit 758 to 773
	value = ((uint32_t)(input[94] & 0x03) << 30) |
			((uint32_t)input[95] << 22) |
			((uint32_t)(input[96] & 0xfc) << 14);
	output[47] = (double)(value >> 16);

	// read output[48]: from bit 774 to 789
	value = ((uint32_t)(input[96] & 0x03) << 30) |
			((uint32_t)input[97] << 22) |
			((uint32_t)(input[98] & 0xfc) << 14);
	output[48] = (double)(value >> 16);

	// read output[49]: from bit 790 to 805
	value = ((uint32_t)(input[98] & 0x03) << 30) |
			((uint32_t)input[99] << 22) |
			((uint32_t)(input[100] & 0xfc) << 14);
	output[49] = (double)(value >> 16);

	// read output[50]: from bit 806 to 821
	value = ((uint32_t)(input[100] & 0x03) << 30) |
			((uint32_t)input[101] << 22) |
			((uint32_t)(input[102] & 0xfc) << 14);
	output[50] = (double)(value >> 16);

	// read output[51]: from bit 822 to 837
	value = ((uint32_t)(input[102] & 0x03) << 30) |
			((uint32_t)input[103] << 22) |
			((uint32_t)(input[104] & 0xfc) << 14);
	output[51] = (double)(value >> 16);

	// read output[52]: from bit 838 to 853
	value = ((uint32_t)(input[104] & 0x03) << 30) |
			((uint32_t)input[105] << 22) |
			((uint32_t)(input[106] & 0xfc) << 14);
	output[52] = (double)(value >> 16);
}

static void unpack_53_16bit_signed_7off(const uint8_t * input, double * output, void *closure) {
	// Unpack 53 values into output
	// Values are 16-bit signed
	// Skip 7 bits, read 848 bits of data.
	// Input must be at least 107 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 7 to 22
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)(input[2] & 0xfe) << 15);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 23 to 38
	value = ((uint32_t)(input[2] & 0x01) << 31) |
			((uint32_t)input[3] << 23) |
			((uint32_t)(input[4] & 0xfe) << 15);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 39 to 54
	value = ((uint32_t)(input[4] & 0x01) << 31) |
			((uint32_t)input[5] << 23) |
			((uint32_t)(input[6] & 0xfe) << 15);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 55 to 70
	value = ((uint32_t)(input[6] & 0x01) << 31) |
			((uint32_t)input[7] << 23) |
			((uint32_t)(input[8] & 0xfe) << 15);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 71 to 86
	value = ((uint32_t)(input[8] & 0x01) << 31) |
			((uint32_t)input[9] << 23) |
			((uint32_t)(input[10] & 0xfe) << 15);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 87 to 102
	value = ((uint32_t)(input[10] & 0x01) << 31) |
			((uint32_t)input[11] << 23) |
			((uint32_t)(input[12] & 0xfe) << 15);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 103 to 118
	value = ((uint32_t)(input[12] & 0x01) << 31) |
			((uint32_t)input[13] << 23) |
			((uint32_t)(input[14] & 0xfe) << 15);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 119 to 134
	value = ((uint32_t)(input[14] & 0x01) << 31) |
			((uint32_t)input[15] << 23) |
			((uint32_t)(input[16] & 0xfe) << 15);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 135 to 150
	value = ((uint32_t)(input[16] & 0x01) << 31) |
			((uint32_t)input[17] << 23) |
			((uint32_t)(input[18] & 0xfe) << 15);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 151 to 166
	value = ((uint32_t)(input[18] & 0x01) << 31) |
			((uint32_t)input[19] << 23) |
			((uint32_t)(input[20] & 0xfe) << 15);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 167 to 182
	value = ((uint32_t)(input[20] & 0x01) << 31) |
			((uint32_t)input[21] << 23) |
			((uint32_t)(input[22] & 0xfe) << 15);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 183 to 198
	value = ((uint32_t)(input[22] & 0x01) << 31) |
			((uint32_t)input[23] << 23) |
			((uint32_t)(input[24] & 0xfe) << 15);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 199 to 214
	value = ((uint32_t)(input[24] & 0x01) << 31) |
			((uint32_t)input[25] << 23) |
			((uint32_t)(input[26] & 0xfe) << 15);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 215 to 230
	value = ((uint32_t)(input[26] & 0x01) << 31) |
			((uint32_t)input[27] << 23) |
			((uint32_t)(input[28] & 0xfe) << 15);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 231 to 246
	value = ((uint32_t)(input[28] & 0x01) << 31) |
			((uint32_t)input[29] << 23) |
			((uint32_t)(input[30] & 0xfe) << 15);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 247 to 262
	value = ((uint32_t)(input[30] & 0x01) << 31) |
			((uint32_t)input[31] << 23) |
			((uint32_t)(input[32] & 0xfe) << 15);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 263 to 278
	value = ((uint32_t)(input[32] & 0x01) << 31) |
			((uint32_t)input[33] << 23) |
			((uint32_t)(input[34] & 0xfe) << 15);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 279 to 294
	value = ((uint32_t)(input[34] & 0x01) << 31) |
			((uint32_t)input[35] << 23) |
			((uint32_t)(input[36] & 0xfe) << 15);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 295 to 310
	value = ((uint32_t)(input[36] & 0x01) << 31) |
			((uint32_t)input[37] << 23) |
			((uint32_t)(input[38] & 0xfe) << 15);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 311 to 326
	value = ((uint32_t)(input[38] & 0x01) << 31) |
			((uint32_t)input[39] << 23) |
			((uint32_t)(input[40] & 0xfe) << 15);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 327 to 342
	value = ((uint32_t)(input[40] & 0x01) << 31) |
			((uint32_t)input[41] << 23) |
			((uint32_t)(input[42] & 0xfe) << 15);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 343 to 358
	value = ((uint32_t)(input[42] & 0x01) << 31) |
			((uint32_t)input[43] << 23) |
			((uint32_t)(input[44] & 0xfe) << 15);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 359 to 374
	value = ((uint32_t)(input[44] & 0x01) << 31) |
			((uint32_t)input[45] << 23) |
			((uint32_t)(input[46] & 0xfe) << 15);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 375 to 390
	value = ((uint32_t)(input[46] & 0x01) << 31) |
			((uint32_t)input[47] << 23) |
			((uint32_t)(input[48] & 0xfe) << 15);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 391 to 406
	value = ((uint32_t)(input[48] & 0x01) << 31) |
			((uint32_t)input[49] << 23) |
			((uint32_t)(input[50] & 0xfe) << 15);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 407 to 422
	value = ((uint32_t)(input[50] & 0x01) << 31) |
			((uint32_t)input[51] << 23) |
			((uint32_t)(input[52] & 0xfe) << 15);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 423 to 438
	value = ((uint32_t)(input[52] & 0x01) << 31) |
			((uint32_t)input[53] << 23) |
			((uint32_t)(input[54] & 0xfe) << 15);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 439 to 454
	value = ((uint32_t)(input[54] & 0x01) << 31) |
			((uint32_t)input[55] << 23) |
			((uint32_t)(input[56] & 0xfe) << 15);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 455 to 470
	value = ((uint32_t)(input[56] & 0x01) << 31) |
			((uint32_t)input[57] << 23) |
			((uint32_t)(input[58] & 0xfe) << 15);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 471 to 486
	value = ((uint32_t)(input[58] & 0x01) << 31) |
			((uint32_t)input[59] << 23) |
			((uint32_t)(input[60] & 0xfe) << 15);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 487 to 502
	value = ((uint32_t)(input[60] & 0x01) << 31) |
			((uint32_t)input[61] << 23) |
			((uint32_t)(input[62] & 0xfe) << 15);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 503 to 518
	value = ((uint32_t)(input[62] & 0x01) << 31) |
			((uint32_t)input[63] << 23) |
			((uint32_t)(input[64] & 0xfe) << 15);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 519 to 534
	value = ((uint32_t)(input[64] & 0x01) << 31) |
			((uint32_t)input[65] << 23) |
			((uint32_t)(input[66] & 0xfe) << 15);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 535 to 550
	value = ((uint32_t)(input[66] & 0x01) << 31) |
			((uint32_t)input[67] << 23) |
			((uint32_t)(input[68] & 0xfe) << 15);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 551 to 566
	value = ((uint32_t)(input[68] & 0x01) << 31) |
			((uint32_t)input[69] << 23) |
			((uint32_t)(input[70] & 0xfe) << 15);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 567 to 582
	value = ((uint32_t)(input[70] & 0x01) << 31) |
			((uint32_t)input[71] << 23) |
			((uint32_t)(input[72] & 0xfe) << 15);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 583 to 598
	value = ((uint32_t)(input[72] & 0x01) << 31) |
			((uint32_t)input[73] << 23) |
			((uint32_t)(input[74] & 0xfe) << 15);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 599 to 614
	value = ((uint32_t)(input[74] & 0x01) << 31) |
			((uint32_t)input[75] << 23) |
			((uint32_t)(input[76] & 0xfe) << 15);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 615 to 630
	value = ((uint32_t)(input[76] & 0x01) << 31) |
			((uint32_t)input[77] << 23) |
			((uint32_t)(input[78] & 0xfe) << 15);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 631 to 646
	value = ((uint32_t)(input[78] & 0x01) << 31) |
			((uint32_t)input[79] << 23) |
			((uint32_t)(input[80] & 0xfe) << 15);
	output[39] = (double)(value >> 16);

	// read output[40]: from bit 647 to 662
	value = ((uint32_t)(input[80] & 0x01) << 31) |
			((uint32_t)input[81] << 23) |
			((uint32_t)(input[82] & 0xfe) << 15);
	output[40] = (double)(value >> 16);

	// read output[41]: from bit 663 to 678
	value = ((uint32_t)(input[82] & 0x01) << 31) |
			((uint32_t)input[83] << 23) |
			((uint32_t)(input[84] & 0xfe) << 15);
	output[41] = (double)(value >> 16);

	// read output[42]: from bit 679 to 694
	value = ((uint32_t)(input[84] & 0x01) << 31) |
			((uint32_t)input[85] << 23) |
			((uint32_t)(input[86] & 0xfe) << 15);
	output[42] = (double)(value >> 16);

	// read output[43]: from bit 695 to 710
	value = ((uint32_t)(input[86] & 0x01) << 31) |
			((uint32_t)input[87] << 23) |
			((uint32_t)(input[88] & 0xfe) << 15);
	output[43] = (double)(value >> 16);

	// read output[44]: from bit 711 to 726
	value = ((uint32_t)(input[88] & 0x01) << 31) |
			((uint32_t)input[89] << 23) |
			((uint32_t)(input[90] & 0xfe) << 15);
	output[44] = (double)(value >> 16);

	// read output[45]: from bit 727 to 742
	value = ((uint32_t)(input[90] & 0x01) << 31) |
			((uint32_t)input[91] << 23) |
			((uint32_t)(input[92] & 0xfe) << 15);
	output[45] = (double)(value >> 16);

	// read output[46]: from bit 743 to 758
	value = ((uint32_t)(input[92] & 0x01) << 31) |
			((uint32_t)input[93] << 23) |
			((uint32_t)(input[94] & 0xfe) << 15);
	output[46] = (double)(value >> 16);

	// read output[47]: from bit 759 to 774
	value = ((uint32_t)(input[94] & 0x01) << 31) |
			((uint32_t)input[95] << 23) |
			((uint32_t)(input[96] & 0xfe) << 15);
	output[47] = (double)(value >> 16);

	// read output[48]: from bit 775 to 790
	value = ((uint32_t)(input[96] & 0x01) << 31) |
			((uint32_t)input[97] << 23) |
			((uint32_t)(input[98] & 0xfe) << 15);
	output[48] = (double)(value >> 16);

	// read output[49]: from bit 791 to 806
	value = ((uint32_t)(input[98] & 0x01) << 31) |
			((uint32_t)input[99] << 23) |
			((uint32_t)(input[100] & 0xfe) << 15);
	output[49] = (double)(value >> 16);

	// read output[50]: from bit 807 to 822
	value = ((uint32_t)(input[100] & 0x01) << 31) |
			((uint32_t)input[101] << 23) |
			((uint32_t)(input[102] & 0xfe) << 15);
	output[50] = (double)(value >> 16);

	// read output[51]: from bit 823 to 838
	value = ((uint32_t)(input[102] & 0x01) << 31) |
			((uint32_t)input[103] << 23) |
			((uint32_t)(input[104] & 0xfe) << 15);
	output[51] = (double)(value >> 16);

	// read output[52]: from bit 839 to 854
	value = ((uint32_t)(input[104] & 0x01) << 31) |
			((uint32_t)input[105] << 23) |
			((uint32_t)(input[106] & 0xfe) << 15);
	output[52] = (double)(value >> 16);
}

static void unpack_53_16bit_unsigned_7off(const uint8_t * input, double * output, void *closure) {
	// Unpack 53 values into output
	// Values are 16-bit unsigned
	// Skip 7 bits, read 848 bits of data.
	// Input must be at least 107 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 7 to 22
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)(input[2] & 0xfe) << 15);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 23 to 38
	value = ((uint32_t)(input[2] & 0x01) << 31) |
			((uint32_t)input[3] << 23) |
			((uint32_t)(input[4] & 0xfe) << 15);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 39 to 54
	value = ((uint32_t)(input[4] & 0x01) << 31) |
			((uint32_t)input[5] << 23) |
			((uint32_t)(input[6] & 0xfe) << 15);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 55 to 70
	value = ((uint32_t)(input[6] & 0x01) << 31) |
			((uint32_t)input[7] << 23) |
			((uint32_t)(input[8] & 0xfe) << 15);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 71 to 86
	value = ((uint32_t)(input[8] & 0x01) << 31) |
			((uint32_t)input[9] << 23) |
			((uint32_t)(input[10] & 0xfe) << 15);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 87 to 102
	value = ((uint32_t)(input[10] & 0x01) << 31) |
			((uint32_t)input[11] << 23) |
			((uint32_t)(input[12] & 0xfe) << 15);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 103 to 118
	value = ((uint32_t)(input[12] & 0x01) << 31) |
			((uint32_t)input[13] << 23) |
			((uint32_t)(input[14] & 0xfe) << 15);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 119 to 134
	value = ((uint32_t)(input[14] & 0x01) << 31) |
			((uint32_t)input[15] << 23) |
			((uint32_t)(input[16] & 0xfe) << 15);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 135 to 150
	value = ((uint32_t)(input[16] & 0x01) << 31) |
			((uint32_t)input[17] << 23) |
			((uint32_t)(input[18] & 0xfe) << 15);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 151 to 166
	value = ((uint32_t)(input[18] & 0x01) << 31) |
			((uint32_t)input[19] << 23) |
			((uint32_t)(input[20] & 0xfe) << 15);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 167 to 182
	value = ((uint32_t)(input[20] & 0x01) << 31) |
			((uint32_t)input[21] << 23) |
			((uint32_t)(input[22] & 0xfe) << 15);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 183 to 198
	value = ((uint32_t)(input[22] & 0x01) << 31) |
			((uint32_t)input[23] << 23) |
			((uint32_t)(input[24] & 0xfe) << 15);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 199 to 214
	value = ((uint32_t)(input[24] & 0x01) << 31) |
			((uint32_t)input[25] << 23) |
			((uint32_t)(input[26] & 0xfe) << 15);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 215 to 230
	value = ((uint32_t)(input[26] & 0x01) << 31) |
			((uint32_t)input[27] << 23) |
			((uint32_t)(input[28] & 0xfe) << 15);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 231 to 246
	value = ((uint32_t)(input[28] & 0x01) << 31) |
			((uint32_t)input[29] << 23) |
			((uint32_t)(input[30] & 0xfe) << 15);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 247 to 262
	value = ((uint32_t)(input[30] & 0x01) << 31) |
			((uint32_t)input[31] << 23) |
			((uint32_t)(input[32] & 0xfe) << 15);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 263 to 278
	value = ((uint32_t)(input[32] & 0x01) << 31) |
			((uint32_t)input[33] << 23) |
			((uint32_t)(input[34] & 0xfe) << 15);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 279 to 294
	value = ((uint32_t)(input[34] & 0x01) << 31) |
			((uint32_t)input[35] << 23) |
			((uint32_t)(input[36] & 0xfe) << 15);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 295 to 310
	value = ((uint32_t)(input[36] & 0x01) << 31) |
			((uint32_t)input[37] << 23) |
			((uint32_t)(input[38] & 0xfe) << 15);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 311 to 326
	value = ((uint32_t)(input[38] & 0x01) << 31) |
			((uint32_t)input[39] << 23) |
			((uint32_t)(input[40] & 0xfe) << 15);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 327 to 342
	value = ((uint32_t)(input[40] & 0x01) << 31) |
			((uint32_t)input[41] << 23) |
			((uint32_t)(input[42] & 0xfe) << 15);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 343 to 358
	value = ((uint32_t)(input[42] & 0x01) << 31) |
			((uint32_t)input[43] << 23) |
			((uint32_t)(input[44] & 0xfe) << 15);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 359 to 374
	value = ((uint32_t)(input[44] & 0x01) << 31) |
			((uint32_t)input[45] << 23) |
			((uint32_t)(input[46] & 0xfe) << 15);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 375 to 390
	value = ((uint32_t)(input[46] & 0x01) << 31) |
			((uint32_t)input[47] << 23) |
			((uint32_t)(input[48] & 0xfe) << 15);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 391 to 406
	value = ((uint32_t)(input[48] & 0x01) << 31) |
			((uint32_t)input[49] << 23) |
			((uint32_t)(input[50] & 0xfe) << 15);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 407 to 422
	value = ((uint32_t)(input[50] & 0x01) << 31) |
			((uint32_t)input[51] << 23) |
			((uint32_t)(input[52] & 0xfe) << 15);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 423 to 438
	value = ((uint32_t)(input[52] & 0x01) << 31) |
			((uint32_t)input[53] << 23) |
			((uint32_t)(input[54] & 0xfe) << 15);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 439 to 454
	value = ((uint32_t)(input[54] & 0x01) << 31) |
			((uint32_t)input[55] << 23) |
			((uint32_t)(input[56] & 0xfe) << 15);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 455 to 470
	value = ((uint32_t)(input[56] & 0x01) << 31) |
			((uint32_t)input[57] << 23) |
			((uint32_t)(input[58] & 0xfe) << 15);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 471 to 486
	value = ((uint32_t)(input[58] & 0x01) << 31) |
			((uint32_t)input[59] << 23) |
			((uint32_t)(input[60] & 0xfe) << 15);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 487 to 502
	value = ((uint32_t)(input[60] & 0x01) << 31) |
			((uint32_t)input[61] << 23) |
			((uint32_t)(input[62] & 0xfe) << 15);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 503 to 518
	value = ((uint32_t)(input[62] & 0x01) << 31) |
			((uint32_t)input[63] << 23) |
			((uint32_t)(input[64] & 0xfe) << 15);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 519 to 534
	value = ((uint32_t)(input[64] & 0x01) << 31) |
			((uint32_t)input[65] << 23) |
			((uint32_t)(input[66] & 0xfe) << 15);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 535 to 550
	value = ((uint32_t)(input[66] & 0x01) << 31) |
			((uint32_t)input[67] << 23) |
			((uint32_t)(input[68] & 0xfe) << 15);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 551 to 566
	value = ((uint32_t)(input[68] & 0x01) << 31) |
			((uint32_t)input[69] << 23) |
			((uint32_t)(input[70] & 0xfe) << 15);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 567 to 582
	value = ((uint32_t)(input[70] & 0x01) << 31) |
			((uint32_t)input[71] << 23) |
			((uint32_t)(input[72] & 0xfe) << 15);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 583 to 598
	value = ((uint32_t)(input[72] & 0x01) << 31) |
			((uint32_t)input[73] << 23) |
			((uint32_t)(input[74] & 0xfe) << 15);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 599 to 614
	value = ((uint32_t)(input[74] & 0x01) << 31) |
			((uint32_t)input[75] << 23) |
			((uint32_t)(input[76] & 0xfe) << 15);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 615 to 630
	value = ((uint32_t)(input[76] & 0x01) << 31) |
			((uint32_t)input[77] << 23) |
			((uint32_t)(input[78] & 0xfe) << 15);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 631 to 646
	value = ((uint32_t)(input[78] & 0x01) << 31) |
			((uint32_t)input[79] << 23) |
			((uint32_t)(input[80] & 0xfe) << 15);
	output[39] = (double)(value >> 16);

	// read output[40]: from bit 647 to 662
	value = ((uint32_t)(input[80] & 0x01) << 31) |
			((uint32_t)input[81] << 23) |
			((uint32_t)(input[82] & 0xfe) << 15);
	output[40] = (double)(value >> 16);

	// read output[41]: from bit 663 to 678
	value = ((uint32_t)(input[82] & 0x01) << 31) |
			((uint32_t)input[83] << 23) |
			((uint32_t)(input[84] & 0xfe) << 15);
	output[41] = (double)(value >> 16);

	// read output[42]: from bit 679 to 694
	value = ((uint32_t)(input[84] & 0x01) << 31) |
			((uint32_t)input[85] << 23) |
			((uint32_t)(input[86] & 0xfe) << 15);
	output[42] = (double)(value >> 16);

	// read output[43]: from bit 695 to 710
	value = ((uint32_t)(input[86] & 0x01) << 31) |
			((uint32_t)input[87] << 23) |
			((uint32_t)(input[88] & 0xfe) << 15);
	output[43] = (double)(value >> 16);

	// read output[44]: from bit 711 to 726
	value = ((uint32_t)(input[88] & 0x01) << 31) |
			((uint32_t)input[89] << 23) |
			((uint32_t)(input[90] & 0xfe) << 15);
	output[44] = (double)(value >> 16);

	// read output[45]: from bit 727 to 742
	value = ((uint32_t)(input[90] & 0x01) << 31) |
			((uint32_t)input[91] << 23) |
			((uint32_t)(input[92] & 0xfe) << 15);
	output[45] = (double)(value >> 16);

	// read output[46]: from bit 743 to 758
	value = ((uint32_t)(input[92] & 0x01) << 31) |
			((uint32_t)input[93] << 23) |
			((uint32_t)(input[94] & 0xfe) << 15);
	output[46] = (double)(value >> 16);

	// read output[47]: from bit 759 to 774
	value = ((uint32_t)(input[94] & 0x01) << 31) |
			((uint32_t)input[95] << 23) |
			((uint32_t)(input[96] & 0xfe) << 15);
	output[47] = (double)(value >> 16);

	// read output[48]: from bit 775 to 790
	value = ((uint32_t)(input[96] & 0x01) << 31) |
			((uint32_t)input[97] << 23) |
			((uint32_t)(input[98] & 0xfe) << 15);
	output[48] = (double)(value >> 16);

	// read output[49]: from bit 791 to 806
	value = ((uint32_t)(input[98] & 0x01) << 31) |
			((uint32_t)input[99] << 23) |
			((uint32_t)(input[100] & 0xfe) << 15);
	output[49] = (double)(value >> 16);

	// read output[50]: from bit 807 to 822
	value = ((uint32_t)(input[100] & 0x01) << 31) |
			((uint32_t)input[101] << 23) |
			((uint32_t)(input[102] & 0xfe) << 15);
	output[50] = (double)(value >> 16);

	// read output[51]: from bit 823 to 838
	value = ((uint32_t)(input[102] & 0x01) << 31) |
			((uint32_t)input[103] << 23) |
			((uint32_t)(input[104] & 0xfe) << 15);
	output[51] = (double)(value >> 16);

	// read output[52]: from bit 839 to 854
	value = ((uint32_t)(input[104] & 0x01) << 31) |
			((uint32_t)input[105] << 23) |
			((uint32_t)(input[106] & 0xfe) << 15);
	output[52] = (double)(value >> 16);
}

static void unpack_54_16bit_signed_0off(const uint8_t * input, double * output, void *closure) {
	// Unpack 54 values into output
	// Values are 16-bit signed
	// Skip 0 bits, read 864 bits of data.
	// Input must be at least 108 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 0 to 15
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)input[1] << 16);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 16 to 31
	value = ((uint32_t)input[2] << 24) |
			((uint32_t)input[3] << 16);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 32 to 47
	value = ((uint32_t)input[4] << 24) |
			((uint32_t)input[5] << 16);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 48 to 63
	value = ((uint32_t)input[6] << 24) |
			((uint32_t)input[7] << 16);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 64 to 79
	value = ((uint32_t)input[8] << 24) |
			((uint32_t)input[9] << 16);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 80 to 95
	value = ((uint32_t)input[10] << 24) |
			((uint32_t)input[11] << 16);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 96 to 111
	value = ((uint32_t)input[12] << 24) |
			((uint32_t)input[13] << 16);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 112 to 127
	value = ((uint32_t)input[14] << 24) |
			((uint32_t)input[15] << 16);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 128 to 143
	value = ((uint32_t)input[16] << 24) |
			((uint32_t)input[17] << 16);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 144 to 159
	value = ((uint32_t)input[18] << 24) |
			((uint32_t)input[19] << 16);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 160 to 175
	value = ((uint32_t)input[20] << 24) |
			((uint32_t)input[21] << 16);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 176 to 191
	value = ((uint32_t)input[22] << 24) |
			((uint32_t)input[23] << 16);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 192 to 207
	value = ((uint32_t)input[24] << 24) |
			((uint32_t)input[25] << 16);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 208 to 223
	value = ((uint32_t)input[26] << 24) |
			((uint32_t)input[27] << 16);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 224 to 239
	value = ((uint32_t)input[28] << 24) |
			((uint32_t)input[29] << 16);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 240 to 255
	value = ((uint32_t)input[30] << 24) |
			((uint32_t)input[31] << 16);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 256 to 271
	value = ((uint32_t)input[32] << 24) |
			((uint32_t)input[33] << 16);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 272 to 287
	value = ((uint32_t)input[34] << 24) |
			((uint32_t)input[35] << 16);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 288 to 303
	value = ((uint32_t)input[36] << 24) |
			((uint32_t)input[37] << 16);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 304 to 319
	value = ((uint32_t)input[38] << 24) |
			((uint32_t)input[39] << 16);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 320 to 335
	value = ((uint32_t)input[40] << 24) |
			((uint32_t)input[41] << 16);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 336 to 351
	value = ((uint32_t)input[42] << 24) |
			((uint32_t)input[43] << 16);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 352 to 367
	value = ((uint32_t)input[44] << 24) |
			((uint32_t)input[45] << 16);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 368 to 383
	value = ((uint32_t)input[46] << 24) |
			((uint32_t)input[47] << 16);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 384 to 399
	value = ((uint32_t)input[48] << 24) |
			((uint32_t)input[49] << 16);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 400 to 415
	value = ((uint32_t)input[50] << 24) |
			((uint32_t)input[51] << 16);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 416 to 431
	value = ((uint32_t)input[52] << 24) |
			((uint32_t)input[53] << 16);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 432 to 447
	value = ((uint32_t)input[54] << 24) |
			((uint32_t)input[55] << 16);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 448 to 463
	value = ((uint32_t)input[56] << 24) |
			((uint32_t)input[57] << 16);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 464 to 479
	value = ((uint32_t)input[58] << 24) |
			((uint32_t)input[59] << 16);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 480 to 495
	value = ((uint32_t)input[60] << 24) |
			((uint32_t)input[61] << 16);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 496 to 511
	value = ((uint32_t)input[62] << 24) |
			((uint32_t)input[63] << 16);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 512 to 527
	value = ((uint32_t)input[64] << 24) |
			((uint32_t)input[65] << 16);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 528 to 543
	value = ((uint32_t)input[66] << 24) |
			((uint32_t)input[67] << 16);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 544 to 559
	value = ((uint32_t)input[68] << 24) |
			((uint32_t)input[69] << 16);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 560 to 575
	value = ((uint32_t)input[70] << 24) |
			((uint32_t)input[71] << 16);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 576 to 591
	value = ((uint32_t)input[72] << 24) |
			((uint32_t)input[73] << 16);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 592 to 607
	value = ((uint32_t)input[74] << 24) |
			((uint32_t)input[75] << 16);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 608 to 623
	value = ((uint32_t)input[76] << 24) |
			((uint32_t)input[77] << 16);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 624 to 639
	value = ((uint32_t)input[78] << 24) |
			((uint32_t)input[79] << 16);
	output[39] = (double)(value >> 16);

	// read output[40]: from bit 640 to 655
	value = ((uint32_t)input[80] << 24) |
			((uint32_t)input[81] << 16);
	output[40] = (double)(value >> 16);

	// read output[41]: from bit 656 to 671
	value = ((uint32_t)input[82] << 24) |
			((uint32_t)input[83] << 16);
	output[41] = (double)(value >> 16);

	// read output[42]: from bit 672 to 687
	value = ((uint32_t)input[84] << 24) |
			((uint32_t)input[85] << 16);
	output[42] = (double)(value >> 16);

	// read output[43]: from bit 688 to 703
	value = ((uint32_t)input[86] << 24) |
			((uint32_t)input[87] << 16);
	output[43] = (double)(value >> 16);

	// read output[44]: from bit 704 to 719
	value = ((uint32_t)input[88] << 24) |
			((uint32_t)input[89] << 16);
	output[44] = (double)(value >> 16);

	// read output[45]: from bit 720 to 735
	value = ((uint32_t)input[90] << 24) |
			((uint32_t)input[91] << 16);
	output[45] = (double)(value >> 16);

	// read output[46]: from bit 736 to 751
	value = ((uint32_t)input[92] << 24) |
			((uint32_t)input[93] << 16);
	output[46] = (double)(value >> 16);

	// read output[47]: from bit 752 to 767
	value = ((uint32_t)input[94] << 24) |
			((uint32_t)input[95] << 16);
	output[47] = (double)(value >> 16);

	// read output[48]: from bit 768 to 783
	value = ((uint32_t)input[96] << 24) |
			((uint32_t)input[97] << 16);
	output[48] = (double)(value >> 16);

	// read output[49]: from bit 784 to 799
	value = ((uint32_t)input[98] << 24) |
			((uint32_t)input[99] << 16);
	output[49] = (double)(value >> 16);

	// read output[50]: from bit 800 to 815
	value = ((uint32_t)input[100] << 24) |
			((uint32_t)input[101] << 16);
	output[50] = (double)(value >> 16);

	// read output[51]: from bit 816 to 831
	value = ((uint32_t)input[102] << 24) |
			((uint32_t)input[103] << 16);
	output[51] = (double)(value >> 16);

	// read output[52]: from bit 832 to 847
	value = ((uint32_t)input[104] << 24) |
			((uint32_t)input[105] << 16);
	output[52] = (double)(value >> 16);

	// read output[53]: from bit 848 to 863
	value = ((uint32_t)input[106] << 24) |
			((uint32_t)input[107] << 16);
	output[53] = (double)(value >> 16);
}

static void unpack_54_16bit_unsigned_0off(const uint8_t * input, double * output, void *closure) {
	// Unpack 54 values into output
	// Values are 16-bit unsigned
	// Skip 0 bits, read 864 bits of data.
	// Input must be at least 108 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 0 to 15
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)input[1] << 16);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 16 to 31
	value = ((uint32_t)input[2] << 24) |
			((uint32_t)input[3] << 16);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 32 to 47
	value = ((uint32_t)input[4] << 24) |
			((uint32_t)input[5] << 16);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 48 to 63
	value = ((uint32_t)input[6] << 24) |
			((uint32_t)input[7] << 16);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 64 to 79
	value = ((uint32_t)input[8] << 24) |
			((uint32_t)input[9] << 16);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 80 to 95
	value = ((uint32_t)input[10] << 24) |
			((uint32_t)input[11] << 16);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 96 to 111
	value = ((uint32_t)input[12] << 24) |
			((uint32_t)input[13] << 16);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 112 to 127
	value = ((uint32_t)input[14] << 24) |
			((uint32_t)input[15] << 16);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 128 to 143
	value = ((uint32_t)input[16] << 24) |
			((uint32_t)input[17] << 16);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 144 to 159
	value = ((uint32_t)input[18] << 24) |
			((uint32_t)input[19] << 16);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 160 to 175
	value = ((uint32_t)input[20] << 24) |
			((uint32_t)input[21] << 16);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 176 to 191
	value = ((uint32_t)input[22] << 24) |
			((uint32_t)input[23] << 16);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 192 to 207
	value = ((uint32_t)input[24] << 24) |
			((uint32_t)input[25] << 16);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 208 to 223
	value = ((uint32_t)input[26] << 24) |
			((uint32_t)input[27] << 16);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 224 to 239
	value = ((uint32_t)input[28] << 24) |
			((uint32_t)input[29] << 16);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 240 to 255
	value = ((uint32_t)input[30] << 24) |
			((uint32_t)input[31] << 16);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 256 to 271
	value = ((uint32_t)input[32] << 24) |
			((uint32_t)input[33] << 16);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 272 to 287
	value = ((uint32_t)input[34] << 24) |
			((uint32_t)input[35] << 16);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 288 to 303
	value = ((uint32_t)input[36] << 24) |
			((uint32_t)input[37] << 16);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 304 to 319
	value = ((uint32_t)input[38] << 24) |
			((uint32_t)input[39] << 16);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 320 to 335
	value = ((uint32_t)input[40] << 24) |
			((uint32_t)input[41] << 16);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 336 to 351
	value = ((uint32_t)input[42] << 24) |
			((uint32_t)input[43] << 16);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 352 to 367
	value = ((uint32_t)input[44] << 24) |
			((uint32_t)input[45] << 16);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 368 to 383
	value = ((uint32_t)input[46] << 24) |
			((uint32_t)input[47] << 16);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 384 to 399
	value = ((uint32_t)input[48] << 24) |
			((uint32_t)input[49] << 16);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 400 to 415
	value = ((uint32_t)input[50] << 24) |
			((uint32_t)input[51] << 16);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 416 to 431
	value = ((uint32_t)input[52] << 24) |
			((uint32_t)input[53] << 16);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 432 to 447
	value = ((uint32_t)input[54] << 24) |
			((uint32_t)input[55] << 16);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 448 to 463
	value = ((uint32_t)input[56] << 24) |
			((uint32_t)input[57] << 16);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 464 to 479
	value = ((uint32_t)input[58] << 24) |
			((uint32_t)input[59] << 16);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 480 to 495
	value = ((uint32_t)input[60] << 24) |
			((uint32_t)input[61] << 16);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 496 to 511
	value = ((uint32_t)input[62] << 24) |
			((uint32_t)input[63] << 16);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 512 to 527
	value = ((uint32_t)input[64] << 24) |
			((uint32_t)input[65] << 16);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 528 to 543
	value = ((uint32_t)input[66] << 24) |
			((uint32_t)input[67] << 16);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 544 to 559
	value = ((uint32_t)input[68] << 24) |
			((uint32_t)input[69] << 16);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 560 to 575
	value = ((uint32_t)input[70] << 24) |
			((uint32_t)input[71] << 16);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 576 to 591
	value = ((uint32_t)input[72] << 24) |
			((uint32_t)input[73] << 16);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 592 to 607
	value = ((uint32_t)input[74] << 24) |
			((uint32_t)input[75] << 16);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 608 to 623
	value = ((uint32_t)input[76] << 24) |
			((uint32_t)input[77] << 16);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 624 to 639
	value = ((uint32_t)input[78] << 24) |
			((uint32_t)input[79] << 16);
	output[39] = (double)(value >> 16);

	// read output[40]: from bit 640 to 655
	value = ((uint32_t)input[80] << 24) |
			((uint32_t)input[81] << 16);
	output[40] = (double)(value >> 16);

	// read output[41]: from bit 656 to 671
	value = ((uint32_t)input[82] << 24) |
			((uint32_t)input[83] << 16);
	output[41] = (double)(value >> 16);

	// read output[42]: from bit 672 to 687
	value = ((uint32_t)input[84] << 24) |
			((uint32_t)input[85] << 16);
	output[42] = (double)(value >> 16);

	// read output[43]: from bit 688 to 703
	value = ((uint32_t)input[86] << 24) |
			((uint32_t)input[87] << 16);
	output[43] = (double)(value >> 16);

	// read output[44]: from bit 704 to 719
	value = ((uint32_t)input[88] << 24) |
			((uint32_t)input[89] << 16);
	output[44] = (double)(value >> 16);

	// read output[45]: from bit 720 to 735
	value = ((uint32_t)input[90] << 24) |
			((uint32_t)input[91] << 16);
	output[45] = (double)(value >> 16);

	// read output[46]: from bit 736 to 751
	value = ((uint32_t)input[92] << 24) |
			((uint32_t)input[93] << 16);
	output[46] = (double)(value >> 16);

	// read output[47]: from bit 752 to 767
	value = ((uint32_t)input[94] << 24) |
			((uint32_t)input[95] << 16);
	output[47] = (double)(value >> 16);

	// read output[48]: from bit 768 to 783
	value = ((uint32_t)input[96] << 24) |
			((uint32_t)input[97] << 16);
	output[48] = (double)(value >> 16);

	// read output[49]: from bit 784 to 799
	value = ((uint32_t)input[98] << 24) |
			((uint32_t)input[99] << 16);
	output[49] = (double)(value >> 16);

	// read output[50]: from bit 800 to 815
	value = ((uint32_t)input[100] << 24) |
			((uint32_t)input[101] << 16);
	output[50] = (double)(value >> 16);

	// read output[51]: from bit 816 to 831
	value = ((uint32_t)input[102] << 24) |
			((uint32_t)input[103] << 16);
	output[51] = (double)(value >> 16);

	// read output[52]: from bit 832 to 847
	value = ((uint32_t)input[104] << 24) |
			((uint32_t)input[105] << 16);
	output[52] = (double)(value >> 16);

	// read output[53]: from bit 848 to 863
	value = ((uint32_t)input[106] << 24) |
			((uint32_t)input[107] << 16);
	output[53] = (double)(value >> 16);
}

static void unpack_54_16bit_signed_1off(const uint8_t * input, double * output, void *closure) {
	// Unpack 54 values into output
	// Values are 16-bit signed
	// Skip 1 bits, read 864 bits of data.
	// Input must be at least 109 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 1 to 16
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)input[1] << 17) |
			((uint32_t)(input[2] & 0x80) << 9);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 17 to 32
	value = ((uint32_t)(input[2] & 0x7f) << 25) |
			((uint32_t)input[3] << 17) |
			((uint32_t)(input[4] & 0x80) << 9);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 33 to 48
	value = ((uint32_t)(input[4] & 0x7f) << 25) |
			((uint32_t)input[5] << 17) |
			((uint32_t)(input[6] & 0x80) << 9);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 49 to 64
	value = ((uint32_t)(input[6] & 0x7f) << 25) |
			((uint32_t)input[7] << 17) |
			((uint32_t)(input[8] & 0x80) << 9);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 65 to 80
	value = ((uint32_t)(input[8] & 0x7f) << 25) |
			((uint32_t)input[9] << 17) |
			((uint32_t)(input[10] & 0x80) << 9);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 81 to 96
	value = ((uint32_t)(input[10] & 0x7f) << 25) |
			((uint32_t)input[11] << 17) |
			((uint32_t)(input[12] & 0x80) << 9);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 97 to 112
	value = ((uint32_t)(input[12] & 0x7f) << 25) |
			((uint32_t)input[13] << 17) |
			((uint32_t)(input[14] & 0x80) << 9);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 113 to 128
	value = ((uint32_t)(input[14] & 0x7f) << 25) |
			((uint32_t)input[15] << 17) |
			((uint32_t)(input[16] & 0x80) << 9);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 129 to 144
	value = ((uint32_t)(input[16] & 0x7f) << 25) |
			((uint32_t)input[17] << 17) |
			((uint32_t)(input[18] & 0x80) << 9);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 145 to 160
	value = ((uint32_t)(input[18] & 0x7f) << 25) |
			((uint32_t)input[19] << 17) |
			((uint32_t)(input[20] & 0x80) << 9);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 161 to 176
	value = ((uint32_t)(input[20] & 0x7f) << 25) |
			((uint32_t)input[21] << 17) |
			((uint32_t)(input[22] & 0x80) << 9);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 177 to 192
	value = ((uint32_t)(input[22] & 0x7f) << 25) |
			((uint32_t)input[23] << 17) |
			((uint32_t)(input[24] & 0x80) << 9);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 193 to 208
	value = ((uint32_t)(input[24] & 0x7f) << 25) |
			((uint32_t)input[25] << 17) |
			((uint32_t)(input[26] & 0x80) << 9);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 209 to 224
	value = ((uint32_t)(input[26] & 0x7f) << 25) |
			((uint32_t)input[27] << 17) |
			((uint32_t)(input[28] & 0x80) << 9);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 225 to 240
	value = ((uint32_t)(input[28] & 0x7f) << 25) |
			((uint32_t)input[29] << 17) |
			((uint32_t)(input[30] & 0x80) << 9);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 241 to 256
	value = ((uint32_t)(input[30] & 0x7f) << 25) |
			((uint32_t)input[31] << 17) |
			((uint32_t)(input[32] & 0x80) << 9);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 257 to 272
	value = ((uint32_t)(input[32] & 0x7f) << 25) |
			((uint32_t)input[33] << 17) |
			((uint32_t)(input[34] & 0x80) << 9);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 273 to 288
	value = ((uint32_t)(input[34] & 0x7f) << 25) |
			((uint32_t)input[35] << 17) |
			((uint32_t)(input[36] & 0x80) << 9);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 289 to 304
	value = ((uint32_t)(input[36] & 0x7f) << 25) |
			((uint32_t)input[37] << 17) |
			((uint32_t)(input[38] & 0x80) << 9);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 305 to 320
	value = ((uint32_t)(input[38] & 0x7f) << 25) |
			((uint32_t)input[39] << 17) |
			((uint32_t)(input[40] & 0x80) << 9);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 321 to 336
	value = ((uint32_t)(input[40] & 0x7f) << 25) |
			((uint32_t)input[41] << 17) |
			((uint32_t)(input[42] & 0x80) << 9);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 337 to 352
	value = ((uint32_t)(input[42] & 0x7f) << 25) |
			((uint32_t)input[43] << 17) |
			((uint32_t)(input[44] & 0x80) << 9);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 353 to 368
	value = ((uint32_t)(input[44] & 0x7f) << 25) |
			((uint32_t)input[45] << 17) |
			((uint32_t)(input[46] & 0x80) << 9);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 369 to 384
	value = ((uint32_t)(input[46] & 0x7f) << 25) |
			((uint32_t)input[47] << 17) |
			((uint32_t)(input[48] & 0x80) << 9);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 385 to 400
	value = ((uint32_t)(input[48] & 0x7f) << 25) |
			((uint32_t)input[49] << 17) |
			((uint32_t)(input[50] & 0x80) << 9);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 401 to 416
	value = ((uint32_t)(input[50] & 0x7f) << 25) |
			((uint32_t)input[51] << 17) |
			((uint32_t)(input[52] & 0x80) << 9);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 417 to 432
	value = ((uint32_t)(input[52] & 0x7f) << 25) |
			((uint32_t)input[53] << 17) |
			((uint32_t)(input[54] & 0x80) << 9);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 433 to 448
	value = ((uint32_t)(input[54] & 0x7f) << 25) |
			((uint32_t)input[55] << 17) |
			((uint32_t)(input[56] & 0x80) << 9);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 449 to 464
	value = ((uint32_t)(input[56] & 0x7f) << 25) |
			((uint32_t)input[57] << 17) |
			((uint32_t)(input[58] & 0x80) << 9);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 465 to 480
	value = ((uint32_t)(input[58] & 0x7f) << 25) |
			((uint32_t)input[59] << 17) |
			((uint32_t)(input[60] & 0x80) << 9);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 481 to 496
	value = ((uint32_t)(input[60] & 0x7f) << 25) |
			((uint32_t)input[61] << 17) |
			((uint32_t)(input[62] & 0x80) << 9);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 497 to 512
	value = ((uint32_t)(input[62] & 0x7f) << 25) |
			((uint32_t)input[63] << 17) |
			((uint32_t)(input[64] & 0x80) << 9);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 513 to 528
	value = ((uint32_t)(input[64] & 0x7f) << 25) |
			((uint32_t)input[65] << 17) |
			((uint32_t)(input[66] & 0x80) << 9);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 529 to 544
	value = ((uint32_t)(input[66] & 0x7f) << 25) |
			((uint32_t)input[67] << 17) |
			((uint32_t)(input[68] & 0x80) << 9);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 545 to 560
	value = ((uint32_t)(input[68] & 0x7f) << 25) |
			((uint32_t)input[69] << 17) |
			((uint32_t)(input[70] & 0x80) << 9);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 561 to 576
	value = ((uint32_t)(input[70] & 0x7f) << 25) |
			((uint32_t)input[71] << 17) |
			((uint32_t)(input[72] & 0x80) << 9);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 577 to 592
	value = ((uint32_t)(input[72] & 0x7f) << 25) |
			((uint32_t)input[73] << 17) |
			((uint32_t)(input[74] & 0x80) << 9);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 593 to 608
	value = ((uint32_t)(input[74] & 0x7f) << 25) |
			((uint32_t)input[75] << 17) |
			((uint32_t)(input[76] & 0x80) << 9);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 609 to 624
	value = ((uint32_t)(input[76] & 0x7f) << 25) |
			((uint32_t)input[77] << 17) |
			((uint32_t)(input[78] & 0x80) << 9);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 625 to 640
	value = ((uint32_t)(input[78] & 0x7f) << 25) |
			((uint32_t)input[79] << 17) |
			((uint32_t)(input[80] & 0x80) << 9);
	output[39] = (double)(value >> 16);

	// read output[40]: from bit 641 to 656
	value = ((uint32_t)(input[80] & 0x7f) << 25) |
			((uint32_t)input[81] << 17) |
			((uint32_t)(input[82] & 0x80) << 9);
	output[40] = (double)(value >> 16);

	// read output[41]: from bit 657 to 672
	value = ((uint32_t)(input[82] & 0x7f) << 25) |
			((uint32_t)input[83] << 17) |
			((uint32_t)(input[84] & 0x80) << 9);
	output[41] = (double)(value >> 16);

	// read output[42]: from bit 673 to 688
	value = ((uint32_t)(input[84] & 0x7f) << 25) |
			((uint32_t)input[85] << 17) |
			((uint32_t)(input[86] & 0x80) << 9);
	output[42] = (double)(value >> 16);

	// read output[43]: from bit 689 to 704
	value = ((uint32_t)(input[86] & 0x7f) << 25) |
			((uint32_t)input[87] << 17) |
			((uint32_t)(input[88] & 0x80) << 9);
	output[43] = (double)(value >> 16);

	// read output[44]: from bit 705 to 720
	value = ((uint32_t)(input[88] & 0x7f) << 25) |
			((uint32_t)input[89] << 17) |
			((uint32_t)(input[90] & 0x80) << 9);
	output[44] = (double)(value >> 16);

	// read output[45]: from bit 721 to 736
	value = ((uint32_t)(input[90] & 0x7f) << 25) |
			((uint32_t)input[91] << 17) |
			((uint32_t)(input[92] & 0x80) << 9);
	output[45] = (double)(value >> 16);

	// read output[46]: from bit 737 to 752
	value = ((uint32_t)(input[92] & 0x7f) << 25) |
			((uint32_t)input[93] << 17) |
			((uint32_t)(input[94] & 0x80) << 9);
	output[46] = (double)(value >> 16);

	// read output[47]: from bit 753 to 768
	value = ((uint32_t)(input[94] & 0x7f) << 25) |
			((uint32_t)input[95] << 17) |
			((uint32_t)(input[96] & 0x80) << 9);
	output[47] = (double)(value >> 16);

	// read output[48]: from bit 769 to 784
	value = ((uint32_t)(input[96] & 0x7f) << 25) |
			((uint32_t)input[97] << 17) |
			((uint32_t)(input[98] & 0x80) << 9);
	output[48] = (double)(value >> 16);

	// read output[49]: from bit 785 to 800
	value = ((uint32_t)(input[98] & 0x7f) << 25) |
			((uint32_t)input[99] << 17) |
			((uint32_t)(input[100] & 0x80) << 9);
	output[49] = (double)(value >> 16);

	// read output[50]: from bit 801 to 816
	value = ((uint32_t)(input[100] & 0x7f) << 25) |
			((uint32_t)input[101] << 17) |
			((uint32_t)(input[102] & 0x80) << 9);
	output[50] = (double)(value >> 16);

	// read output[51]: from bit 817 to 832
	value = ((uint32_t)(input[102] & 0x7f) << 25) |
			((uint32_t)input[103] << 17) |
			((uint32_t)(input[104] & 0x80) << 9);
	output[51] = (double)(value >> 16);

	// read output[52]: from bit 833 to 848
	value = ((uint32_t)(input[104] & 0x7f) << 25) |
			((uint32_t)input[105] << 17) |
			((uint32_t)(input[106] & 0x80) << 9);
	output[52] = (double)(value >> 16);

	// read output[53]: from bit 849 to 864
	value = ((uint32_t)(input[106] & 0x7f) << 25) |
			((uint32_t)input[107] << 17) |
			((uint32_t)(input[108] & 0x80) << 9);
	output[53] = (double)(value >> 16);
}

static void unpack_54_16bit_unsigned_1off(const uint8_t * input, double * output, void *closure) {
	// Unpack 54 values into output
	// Values are 16-bit unsigned
	// Skip 1 bits, read 864 bits of data.
	// Input must be at least 109 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 1 to 16
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)input[1] << 17) |
			((uint32_t)(input[2] & 0x80) << 9);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 17 to 32
	value = ((uint32_t)(input[2] & 0x7f) << 25) |
			((uint32_t)input[3] << 17) |
			((uint32_t)(input[4] & 0x80) << 9);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 33 to 48
	value = ((uint32_t)(input[4] & 0x7f) << 25) |
			((uint32_t)input[5] << 17) |
			((uint32_t)(input[6] & 0x80) << 9);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 49 to 64
	value = ((uint32_t)(input[6] & 0x7f) << 25) |
			((uint32_t)input[7] << 17) |
			((uint32_t)(input[8] & 0x80) << 9);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 65 to 80
	value = ((uint32_t)(input[8] & 0x7f) << 25) |
			((uint32_t)input[9] << 17) |
			((uint32_t)(input[10] & 0x80) << 9);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 81 to 96
	value = ((uint32_t)(input[10] & 0x7f) << 25) |
			((uint32_t)input[11] << 17) |
			((uint32_t)(input[12] & 0x80) << 9);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 97 to 112
	value = ((uint32_t)(input[12] & 0x7f) << 25) |
			((uint32_t)input[13] << 17) |
			((uint32_t)(input[14] & 0x80) << 9);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 113 to 128
	value = ((uint32_t)(input[14] & 0x7f) << 25) |
			((uint32_t)input[15] << 17) |
			((uint32_t)(input[16] & 0x80) << 9);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 129 to 144
	value = ((uint32_t)(input[16] & 0x7f) << 25) |
			((uint32_t)input[17] << 17) |
			((uint32_t)(input[18] & 0x80) << 9);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 145 to 160
	value = ((uint32_t)(input[18] & 0x7f) << 25) |
			((uint32_t)input[19] << 17) |
			((uint32_t)(input[20] & 0x80) << 9);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 161 to 176
	value = ((uint32_t)(input[20] & 0x7f) << 25) |
			((uint32_t)input[21] << 17) |
			((uint32_t)(input[22] & 0x80) << 9);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 177 to 192
	value = ((uint32_t)(input[22] & 0x7f) << 25) |
			((uint32_t)input[23] << 17) |
			((uint32_t)(input[24] & 0x80) << 9);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 193 to 208
	value = ((uint32_t)(input[24] & 0x7f) << 25) |
			((uint32_t)input[25] << 17) |
			((uint32_t)(input[26] & 0x80) << 9);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 209 to 224
	value = ((uint32_t)(input[26] & 0x7f) << 25) |
			((uint32_t)input[27] << 17) |
			((uint32_t)(input[28] & 0x80) << 9);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 225 to 240
	value = ((uint32_t)(input[28] & 0x7f) << 25) |
			((uint32_t)input[29] << 17) |
			((uint32_t)(input[30] & 0x80) << 9);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 241 to 256
	value = ((uint32_t)(input[30] & 0x7f) << 25) |
			((uint32_t)input[31] << 17) |
			((uint32_t)(input[32] & 0x80) << 9);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 257 to 272
	value = ((uint32_t)(input[32] & 0x7f) << 25) |
			((uint32_t)input[33] << 17) |
			((uint32_t)(input[34] & 0x80) << 9);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 273 to 288
	value = ((uint32_t)(input[34] & 0x7f) << 25) |
			((uint32_t)input[35] << 17) |
			((uint32_t)(input[36] & 0x80) << 9);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 289 to 304
	value = ((uint32_t)(input[36] & 0x7f) << 25) |
			((uint32_t)input[37] << 17) |
			((uint32_t)(input[38] & 0x80) << 9);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 305 to 320
	value = ((uint32_t)(input[38] & 0x7f) << 25) |
			((uint32_t)input[39] << 17) |
			((uint32_t)(input[40] & 0x80) << 9);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 321 to 336
	value = ((uint32_t)(input[40] & 0x7f) << 25) |
			((uint32_t)input[41] << 17) |
			((uint32_t)(input[42] & 0x80) << 9);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 337 to 352
	value = ((uint32_t)(input[42] & 0x7f) << 25) |
			((uint32_t)input[43] << 17) |
			((uint32_t)(input[44] & 0x80) << 9);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 353 to 368
	value = ((uint32_t)(input[44] & 0x7f) << 25) |
			((uint32_t)input[45] << 17) |
			((uint32_t)(input[46] & 0x80) << 9);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 369 to 384
	value = ((uint32_t)(input[46] & 0x7f) << 25) |
			((uint32_t)input[47] << 17) |
			((uint32_t)(input[48] & 0x80) << 9);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 385 to 400
	value = ((uint32_t)(input[48] & 0x7f) << 25) |
			((uint32_t)input[49] << 17) |
			((uint32_t)(input[50] & 0x80) << 9);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 401 to 416
	value = ((uint32_t)(input[50] & 0x7f) << 25) |
			((uint32_t)input[51] << 17) |
			((uint32_t)(input[52] & 0x80) << 9);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 417 to 432
	value = ((uint32_t)(input[52] & 0x7f) << 25) |
			((uint32_t)input[53] << 17) |
			((uint32_t)(input[54] & 0x80) << 9);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 433 to 448
	value = ((uint32_t)(input[54] & 0x7f) << 25) |
			((uint32_t)input[55] << 17) |
			((uint32_t)(input[56] & 0x80) << 9);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 449 to 464
	value = ((uint32_t)(input[56] & 0x7f) << 25) |
			((uint32_t)input[57] << 17) |
			((uint32_t)(input[58] & 0x80) << 9);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 465 to 480
	value = ((uint32_t)(input[58] & 0x7f) << 25) |
			((uint32_t)input[59] << 17) |
			((uint32_t)(input[60] & 0x80) << 9);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 481 to 496
	value = ((uint32_t)(input[60] & 0x7f) << 25) |
			((uint32_t)input[61] << 17) |
			((uint32_t)(input[62] & 0x80) << 9);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 497 to 512
	value = ((uint32_t)(input[62] & 0x7f) << 25) |
			((uint32_t)input[63] << 17) |
			((uint32_t)(input[64] & 0x80) << 9);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 513 to 528
	value = ((uint32_t)(input[64] & 0x7f) << 25) |
			((uint32_t)input[65] << 17) |
			((uint32_t)(input[66] & 0x80) << 9);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 529 to 544
	value = ((uint32_t)(input[66] & 0x7f) << 25) |
			((uint32_t)input[67] << 17) |
			((uint32_t)(input[68] & 0x80) << 9);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 545 to 560
	value = ((uint32_t)(input[68] & 0x7f) << 25) |
			((uint32_t)input[69] << 17) |
			((uint32_t)(input[70] & 0x80) << 9);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 561 to 576
	value = ((uint32_t)(input[70] & 0x7f) << 25) |
			((uint32_t)input[71] << 17) |
			((uint32_t)(input[72] & 0x80) << 9);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 577 to 592
	value = ((uint32_t)(input[72] & 0x7f) << 25) |
			((uint32_t)input[73] << 17) |
			((uint32_t)(input[74] & 0x80) << 9);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 593 to 608
	value = ((uint32_t)(input[74] & 0x7f) << 25) |
			((uint32_t)input[75] << 17) |
			((uint32_t)(input[76] & 0x80) << 9);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 609 to 624
	value = ((uint32_t)(input[76] & 0x7f) << 25) |
			((uint32_t)input[77] << 17) |
			((uint32_t)(input[78] & 0x80) << 9);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 625 to 640
	value = ((uint32_t)(input[78] & 0x7f) << 25) |
			((uint32_t)input[79] << 17) |
			((uint32_t)(input[80] & 0x80) << 9);
	output[39] = (double)(value >> 16);

	// read output[40]: from bit 641 to 656
	value = ((uint32_t)(input[80] & 0x7f) << 25) |
			((uint32_t)input[81] << 17) |
			((uint32_t)(input[82] & 0x80) << 9);
	output[40] = (double)(value >> 16);

	// read output[41]: from bit 657 to 672
	value = ((uint32_t)(input[82] & 0x7f) << 25) |
			((uint32_t)input[83] << 17) |
			((uint32_t)(input[84] & 0x80) << 9);
	output[41] = (double)(value >> 16);

	// read output[42]: from bit 673 to 688
	value = ((uint32_t)(input[84] & 0x7f) << 25) |
			((uint32_t)input[85] << 17) |
			((uint32_t)(input[86] & 0x80) << 9);
	output[42] = (double)(value >> 16);

	// read output[43]: from bit 689 to 704
	value = ((uint32_t)(input[86] & 0x7f) << 25) |
			((uint32_t)input[87] << 17) |
			((uint32_t)(input[88] & 0x80) << 9);
	output[43] = (double)(value >> 16);

	// read output[44]: from bit 705 to 720
	value = ((uint32_t)(input[88] & 0x7f) << 25) |
			((uint32_t)input[89] << 17) |
			((uint32_t)(input[90] & 0x80) << 9);
	output[44] = (double)(value >> 16);

	// read output[45]: from bit 721 to 736
	value = ((uint32_t)(input[90] & 0x7f) << 25) |
			((uint32_t)input[91] << 17) |
			((uint32_t)(input[92] & 0x80) << 9);
	output[45] = (double)(value >> 16);

	// read output[46]: from bit 737 to 752
	value = ((uint32_t)(input[92] & 0x7f) << 25) |
			((uint32_t)input[93] << 17) |
			((uint32_t)(input[94] & 0x80) << 9);
	output[46] = (double)(value >> 16);

	// read output[47]: from bit 753 to 768
	value = ((uint32_t)(input[94] & 0x7f) << 25) |
			((uint32_t)input[95] << 17) |
			((uint32_t)(input[96] & 0x80) << 9);
	output[47] = (double)(value >> 16);

	// read output[48]: from bit 769 to 784
	value = ((uint32_t)(input[96] & 0x7f) << 25) |
			((uint32_t)input[97] << 17) |
			((uint32_t)(input[98] & 0x80) << 9);
	output[48] = (double)(value >> 16);

	// read output[49]: from bit 785 to 800
	value = ((uint32_t)(input[98] & 0x7f) << 25) |
			((uint32_t)input[99] << 17) |
			((uint32_t)(input[100] & 0x80) << 9);
	output[49] = (double)(value >> 16);

	// read output[50]: from bit 801 to 816
	value = ((uint32_t)(input[100] & 0x7f) << 25) |
			((uint32_t)input[101] << 17) |
			((uint32_t)(input[102] & 0x80) << 9);
	output[50] = (double)(value >> 16);

	// read output[51]: from bit 817 to 832
	value = ((uint32_t)(input[102] & 0x7f) << 25) |
			((uint32_t)input[103] << 17) |
			((uint32_t)(input[104] & 0x80) << 9);
	output[51] = (double)(value >> 16);

	// read output[52]: from bit 833 to 848
	value = ((uint32_t)(input[104] & 0x7f) << 25) |
			((uint32_t)input[105] << 17) |
			((uint32_t)(input[106] & 0x80) << 9);
	output[52] = (double)(value >> 16);

	// read output[53]: from bit 849 to 864
	value = ((uint32_t)(input[106] & 0x7f) << 25) |
			((uint32_t)input[107] << 17) |
			((uint32_t)(input[108] & 0x80) << 9);
	output[53] = (double)(value >> 16);
}

static void unpack_54_16bit_signed_2off(const uint8_t * input, double * output, void *closure) {
	// Unpack 54 values into output
	// Values are 16-bit signed
	// Skip 2 bits, read 864 bits of data.
	// Input must be at least 109 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 2 to 17
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)input[1] << 18) |
			((uint32_t)(input[2] & 0xc0) << 10);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 18 to 33
	value = ((uint32_t)(input[2] & 0x3f) << 26) |
			((uint32_t)input[3] << 18) |
			((uint32_t)(input[4] & 0xc0) << 10);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 34 to 49
	value = ((uint32_t)(input[4] & 0x3f) << 26) |
			((uint32_t)input[5] << 18) |
			((uint32_t)(input[6] & 0xc0) << 10);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 50 to 65
	value = ((uint32_t)(input[6] & 0x3f) << 26) |
			((uint32_t)input[7] << 18) |
			((uint32_t)(input[8] & 0xc0) << 10);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 66 to 81
	value = ((uint32_t)(input[8] & 0x3f) << 26) |
			((uint32_t)input[9] << 18) |
			((uint32_t)(input[10] & 0xc0) << 10);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 82 to 97
	value = ((uint32_t)(input[10] & 0x3f) << 26) |
			((uint32_t)input[11] << 18) |
			((uint32_t)(input[12] & 0xc0) << 10);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 98 to 113
	value = ((uint32_t)(input[12] & 0x3f) << 26) |
			((uint32_t)input[13] << 18) |
			((uint32_t)(input[14] & 0xc0) << 10);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 114 to 129
	value = ((uint32_t)(input[14] & 0x3f) << 26) |
			((uint32_t)input[15] << 18) |
			((uint32_t)(input[16] & 0xc0) << 10);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 130 to 145
	value = ((uint32_t)(input[16] & 0x3f) << 26) |
			((uint32_t)input[17] << 18) |
			((uint32_t)(input[18] & 0xc0) << 10);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 146 to 161
	value = ((uint32_t)(input[18] & 0x3f) << 26) |
			((uint32_t)input[19] << 18) |
			((uint32_t)(input[20] & 0xc0) << 10);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 162 to 177
	value = ((uint32_t)(input[20] & 0x3f) << 26) |
			((uint32_t)input[21] << 18) |
			((uint32_t)(input[22] & 0xc0) << 10);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 178 to 193
	value = ((uint32_t)(input[22] & 0x3f) << 26) |
			((uint32_t)input[23] << 18) |
			((uint32_t)(input[24] & 0xc0) << 10);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 194 to 209
	value = ((uint32_t)(input[24] & 0x3f) << 26) |
			((uint32_t)input[25] << 18) |
			((uint32_t)(input[26] & 0xc0) << 10);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 210 to 225
	value = ((uint32_t)(input[26] & 0x3f) << 26) |
			((uint32_t)input[27] << 18) |
			((uint32_t)(input[28] & 0xc0) << 10);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 226 to 241
	value = ((uint32_t)(input[28] & 0x3f) << 26) |
			((uint32_t)input[29] << 18) |
			((uint32_t)(input[30] & 0xc0) << 10);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 242 to 257
	value = ((uint32_t)(input[30] & 0x3f) << 26) |
			((uint32_t)input[31] << 18) |
			((uint32_t)(input[32] & 0xc0) << 10);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 258 to 273
	value = ((uint32_t)(input[32] & 0x3f) << 26) |
			((uint32_t)input[33] << 18) |
			((uint32_t)(input[34] & 0xc0) << 10);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 274 to 289
	value = ((uint32_t)(input[34] & 0x3f) << 26) |
			((uint32_t)input[35] << 18) |
			((uint32_t)(input[36] & 0xc0) << 10);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 290 to 305
	value = ((uint32_t)(input[36] & 0x3f) << 26) |
			((uint32_t)input[37] << 18) |
			((uint32_t)(input[38] & 0xc0) << 10);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 306 to 321
	value = ((uint32_t)(input[38] & 0x3f) << 26) |
			((uint32_t)input[39] << 18) |
			((uint32_t)(input[40] & 0xc0) << 10);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 322 to 337
	value = ((uint32_t)(input[40] & 0x3f) << 26) |
			((uint32_t)input[41] << 18) |
			((uint32_t)(input[42] & 0xc0) << 10);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 338 to 353
	value = ((uint32_t)(input[42] & 0x3f) << 26) |
			((uint32_t)input[43] << 18) |
			((uint32_t)(input[44] & 0xc0) << 10);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 354 to 369
	value = ((uint32_t)(input[44] & 0x3f) << 26) |
			((uint32_t)input[45] << 18) |
			((uint32_t)(input[46] & 0xc0) << 10);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 370 to 385
	value = ((uint32_t)(input[46] & 0x3f) << 26) |
			((uint32_t)input[47] << 18) |
			((uint32_t)(input[48] & 0xc0) << 10);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 386 to 401
	value = ((uint32_t)(input[48] & 0x3f) << 26) |
			((uint32_t)input[49] << 18) |
			((uint32_t)(input[50] & 0xc0) << 10);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 402 to 417
	value = ((uint32_t)(input[50] & 0x3f) << 26) |
			((uint32_t)input[51] << 18) |
			((uint32_t)(input[52] & 0xc0) << 10);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 418 to 433
	value = ((uint32_t)(input[52] & 0x3f) << 26) |
			((uint32_t)input[53] << 18) |
			((uint32_t)(input[54] & 0xc0) << 10);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 434 to 449
	value = ((uint32_t)(input[54] & 0x3f) << 26) |
			((uint32_t)input[55] << 18) |
			((uint32_t)(input[56] & 0xc0) << 10);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 450 to 465
	value = ((uint32_t)(input[56] & 0x3f) << 26) |
			((uint32_t)input[57] << 18) |
			((uint32_t)(input[58] & 0xc0) << 10);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 466 to 481
	value = ((uint32_t)(input[58] & 0x3f) << 26) |
			((uint32_t)input[59] << 18) |
			((uint32_t)(input[60] & 0xc0) << 10);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 482 to 497
	value = ((uint32_t)(input[60] & 0x3f) << 26) |
			((uint32_t)input[61] << 18) |
			((uint32_t)(input[62] & 0xc0) << 10);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 498 to 513
	value = ((uint32_t)(input[62] & 0x3f) << 26) |
			((uint32_t)input[63] << 18) |
			((uint32_t)(input[64] & 0xc0) << 10);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 514 to 529
	value = ((uint32_t)(input[64] & 0x3f) << 26) |
			((uint32_t)input[65] << 18) |
			((uint32_t)(input[66] & 0xc0) << 10);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 530 to 545
	value = ((uint32_t)(input[66] & 0x3f) << 26) |
			((uint32_t)input[67] << 18) |
			((uint32_t)(input[68] & 0xc0) << 10);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 546 to 561
	value = ((uint32_t)(input[68] & 0x3f) << 26) |
			((uint32_t)input[69] << 18) |
			((uint32_t)(input[70] & 0xc0) << 10);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 562 to 577
	value = ((uint32_t)(input[70] & 0x3f) << 26) |
			((uint32_t)input[71] << 18) |
			((uint32_t)(input[72] & 0xc0) << 10);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 578 to 593
	value = ((uint32_t)(input[72] & 0x3f) << 26) |
			((uint32_t)input[73] << 18) |
			((uint32_t)(input[74] & 0xc0) << 10);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 594 to 609
	value = ((uint32_t)(input[74] & 0x3f) << 26) |
			((uint32_t)input[75] << 18) |
			((uint32_t)(input[76] & 0xc0) << 10);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 610 to 625
	value = ((uint32_t)(input[76] & 0x3f) << 26) |
			((uint32_t)input[77] << 18) |
			((uint32_t)(input[78] & 0xc0) << 10);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 626 to 641
	value = ((uint32_t)(input[78] & 0x3f) << 26) |
			((uint32_t)input[79] << 18) |
			((uint32_t)(input[80] & 0xc0) << 10);
	output[39] = (double)(value >> 16);

	// read output[40]: from bit 642 to 657
	value = ((uint32_t)(input[80] & 0x3f) << 26) |
			((uint32_t)input[81] << 18) |
			((uint32_t)(input[82] & 0xc0) << 10);
	output[40] = (double)(value >> 16);

	// read output[41]: from bit 658 to 673
	value = ((uint32_t)(input[82] & 0x3f) << 26) |
			((uint32_t)input[83] << 18) |
			((uint32_t)(input[84] & 0xc0) << 10);
	output[41] = (double)(value >> 16);

	// read output[42]: from bit 674 to 689
	value = ((uint32_t)(input[84] & 0x3f) << 26) |
			((uint32_t)input[85] << 18) |
			((uint32_t)(input[86] & 0xc0) << 10);
	output[42] = (double)(value >> 16);

	// read output[43]: from bit 690 to 705
	value = ((uint32_t)(input[86] & 0x3f) << 26) |
			((uint32_t)input[87] << 18) |
			((uint32_t)(input[88] & 0xc0) << 10);
	output[43] = (double)(value >> 16);

	// read output[44]: from bit 706 to 721
	value = ((uint32_t)(input[88] & 0x3f) << 26) |
			((uint32_t)input[89] << 18) |
			((uint32_t)(input[90] & 0xc0) << 10);
	output[44] = (double)(value >> 16);

	// read output[45]: from bit 722 to 737
	value = ((uint32_t)(input[90] & 0x3f) << 26) |
			((uint32_t)input[91] << 18) |
			((uint32_t)(input[92] & 0xc0) << 10);
	output[45] = (double)(value >> 16);

	// read output[46]: from bit 738 to 753
	value = ((uint32_t)(input[92] & 0x3f) << 26) |
			((uint32_t)input[93] << 18) |
			((uint32_t)(input[94] & 0xc0) << 10);
	output[46] = (double)(value >> 16);

	// read output[47]: from bit 754 to 769
	value = ((uint32_t)(input[94] & 0x3f) << 26) |
			((uint32_t)input[95] << 18) |
			((uint32_t)(input[96] & 0xc0) << 10);
	output[47] = (double)(value >> 16);

	// read output[48]: from bit 770 to 785
	value = ((uint32_t)(input[96] & 0x3f) << 26) |
			((uint32_t)input[97] << 18) |
			((uint32_t)(input[98] & 0xc0) << 10);
	output[48] = (double)(value >> 16);

	// read output[49]: from bit 786 to 801
	value = ((uint32_t)(input[98] & 0x3f) << 26) |
			((uint32_t)input[99] << 18) |
			((uint32_t)(input[100] & 0xc0) << 10);
	output[49] = (double)(value >> 16);

	// read output[50]: from bit 802 to 817
	value = ((uint32_t)(input[100] & 0x3f) << 26) |
			((uint32_t)input[101] << 18) |
			((uint32_t)(input[102] & 0xc0) << 10);
	output[50] = (double)(value >> 16);

	// read output[51]: from bit 818 to 833
	value = ((uint32_t)(input[102] & 0x3f) << 26) |
			((uint32_t)input[103] << 18) |
			((uint32_t)(input[104] & 0xc0) << 10);
	output[51] = (double)(value >> 16);

	// read output[52]: from bit 834 to 849
	value = ((uint32_t)(input[104] & 0x3f) << 26) |
			((uint32_t)input[105] << 18) |
			((uint32_t)(input[106] & 0xc0) << 10);
	output[52] = (double)(value >> 16);

	// read output[53]: from bit 850 to 865
	value = ((uint32_t)(input[106] & 0x3f) << 26) |
			((uint32_t)input[107] << 18) |
			((uint32_t)(input[108] & 0xc0) << 10);
	output[53] = (double)(value >> 16);
}

static void unpack_54_16bit_unsigned_2off(const uint8_t * input, double * output, void *closure) {
	// Unpack 54 values into output
	// Values are 16-bit unsigned
	// Skip 2 bits, read 864 bits of data.
	// Input must be at least 109 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 2 to 17
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)input[1] << 18) |
			((uint32_t)(input[2] & 0xc0) << 10);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 18 to 33
	value = ((uint32_t)(input[2] & 0x3f) << 26) |
			((uint32_t)input[3] << 18) |
			((uint32_t)(input[4] & 0xc0) << 10);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 34 to 49
	value = ((uint32_t)(input[4] & 0x3f) << 26) |
			((uint32_t)input[5] << 18) |
			((uint32_t)(input[6] & 0xc0) << 10);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 50 to 65
	value = ((uint32_t)(input[6] & 0x3f) << 26) |
			((uint32_t)input[7] << 18) |
			((uint32_t)(input[8] & 0xc0) << 10);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 66 to 81
	value = ((uint32_t)(input[8] & 0x3f) << 26) |
			((uint32_t)input[9] << 18) |
			((uint32_t)(input[10] & 0xc0) << 10);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 82 to 97
	value = ((uint32_t)(input[10] & 0x3f) << 26) |
			((uint32_t)input[11] << 18) |
			((uint32_t)(input[12] & 0xc0) << 10);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 98 to 113
	value = ((uint32_t)(input[12] & 0x3f) << 26) |
			((uint32_t)input[13] << 18) |
			((uint32_t)(input[14] & 0xc0) << 10);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 114 to 129
	value = ((uint32_t)(input[14] & 0x3f) << 26) |
			((uint32_t)input[15] << 18) |
			((uint32_t)(input[16] & 0xc0) << 10);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 130 to 145
	value = ((uint32_t)(input[16] & 0x3f) << 26) |
			((uint32_t)input[17] << 18) |
			((uint32_t)(input[18] & 0xc0) << 10);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 146 to 161
	value = ((uint32_t)(input[18] & 0x3f) << 26) |
			((uint32_t)input[19] << 18) |
			((uint32_t)(input[20] & 0xc0) << 10);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 162 to 177
	value = ((uint32_t)(input[20] & 0x3f) << 26) |
			((uint32_t)input[21] << 18) |
			((uint32_t)(input[22] & 0xc0) << 10);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 178 to 193
	value = ((uint32_t)(input[22] & 0x3f) << 26) |
			((uint32_t)input[23] << 18) |
			((uint32_t)(input[24] & 0xc0) << 10);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 194 to 209
	value = ((uint32_t)(input[24] & 0x3f) << 26) |
			((uint32_t)input[25] << 18) |
			((uint32_t)(input[26] & 0xc0) << 10);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 210 to 225
	value = ((uint32_t)(input[26] & 0x3f) << 26) |
			((uint32_t)input[27] << 18) |
			((uint32_t)(input[28] & 0xc0) << 10);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 226 to 241
	value = ((uint32_t)(input[28] & 0x3f) << 26) |
			((uint32_t)input[29] << 18) |
			((uint32_t)(input[30] & 0xc0) << 10);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 242 to 257
	value = ((uint32_t)(input[30] & 0x3f) << 26) |
			((uint32_t)input[31] << 18) |
			((uint32_t)(input[32] & 0xc0) << 10);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 258 to 273
	value = ((uint32_t)(input[32] & 0x3f) << 26) |
			((uint32_t)input[33] << 18) |
			((uint32_t)(input[34] & 0xc0) << 10);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 274 to 289
	value = ((uint32_t)(input[34] & 0x3f) << 26) |
			((uint32_t)input[35] << 18) |
			((uint32_t)(input[36] & 0xc0) << 10);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 290 to 305
	value = ((uint32_t)(input[36] & 0x3f) << 26) |
			((uint32_t)input[37] << 18) |
			((uint32_t)(input[38] & 0xc0) << 10);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 306 to 321
	value = ((uint32_t)(input[38] & 0x3f) << 26) |
			((uint32_t)input[39] << 18) |
			((uint32_t)(input[40] & 0xc0) << 10);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 322 to 337
	value = ((uint32_t)(input[40] & 0x3f) << 26) |
			((uint32_t)input[41] << 18) |
			((uint32_t)(input[42] & 0xc0) << 10);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 338 to 353
	value = ((uint32_t)(input[42] & 0x3f) << 26) |
			((uint32_t)input[43] << 18) |
			((uint32_t)(input[44] & 0xc0) << 10);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 354 to 369
	value = ((uint32_t)(input[44] & 0x3f) << 26) |
			((uint32_t)input[45] << 18) |
			((uint32_t)(input[46] & 0xc0) << 10);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 370 to 385
	value = ((uint32_t)(input[46] & 0x3f) << 26) |
			((uint32_t)input[47] << 18) |
			((uint32_t)(input[48] & 0xc0) << 10);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 386 to 401
	value = ((uint32_t)(input[48] & 0x3f) << 26) |
			((uint32_t)input[49] << 18) |
			((uint32_t)(input[50] & 0xc0) << 10);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 402 to 417
	value = ((uint32_t)(input[50] & 0x3f) << 26) |
			((uint32_t)input[51] << 18) |
			((uint32_t)(input[52] & 0xc0) << 10);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 418 to 433
	value = ((uint32_t)(input[52] & 0x3f) << 26) |
			((uint32_t)input[53] << 18) |
			((uint32_t)(input[54] & 0xc0) << 10);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 434 to 449
	value = ((uint32_t)(input[54] & 0x3f) << 26) |
			((uint32_t)input[55] << 18) |
			((uint32_t)(input[56] & 0xc0) << 10);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 450 to 465
	value = ((uint32_t)(input[56] & 0x3f) << 26) |
			((uint32_t)input[57] << 18) |
			((uint32_t)(input[58] & 0xc0) << 10);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 466 to 481
	value = ((uint32_t)(input[58] & 0x3f) << 26) |
			((uint32_t)input[59] << 18) |
			((uint32_t)(input[60] & 0xc0) << 10);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 482 to 497
	value = ((uint32_t)(input[60] & 0x3f) << 26) |
			((uint32_t)input[61] << 18) |
			((uint32_t)(input[62] & 0xc0) << 10);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 498 to 513
	value = ((uint32_t)(input[62] & 0x3f) << 26) |
			((uint32_t)input[63] << 18) |
			((uint32_t)(input[64] & 0xc0) << 10);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 514 to 529
	value = ((uint32_t)(input[64] & 0x3f) << 26) |
			((uint32_t)input[65] << 18) |
			((uint32_t)(input[66] & 0xc0) << 10);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 530 to 545
	value = ((uint32_t)(input[66] & 0x3f) << 26) |
			((uint32_t)input[67] << 18) |
			((uint32_t)(input[68] & 0xc0) << 10);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 546 to 561
	value = ((uint32_t)(input[68] & 0x3f) << 26) |
			((uint32_t)input[69] << 18) |
			((uint32_t)(input[70] & 0xc0) << 10);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 562 to 577
	value = ((uint32_t)(input[70] & 0x3f) << 26) |
			((uint32_t)input[71] << 18) |
			((uint32_t)(input[72] & 0xc0) << 10);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 578 to 593
	value = ((uint32_t)(input[72] & 0x3f) << 26) |
			((uint32_t)input[73] << 18) |
			((uint32_t)(input[74] & 0xc0) << 10);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 594 to 609
	value = ((uint32_t)(input[74] & 0x3f) << 26) |
			((uint32_t)input[75] << 18) |
			((uint32_t)(input[76] & 0xc0) << 10);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 610 to 625
	value = ((uint32_t)(input[76] & 0x3f) << 26) |
			((uint32_t)input[77] << 18) |
			((uint32_t)(input[78] & 0xc0) << 10);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 626 to 641
	value = ((uint32_t)(input[78] & 0x3f) << 26) |
			((uint32_t)input[79] << 18) |
			((uint32_t)(input[80] & 0xc0) << 10);
	output[39] = (double)(value >> 16);

	// read output[40]: from bit 642 to 657
	value = ((uint32_t)(input[80] & 0x3f) << 26) |
			((uint32_t)input[81] << 18) |
			((uint32_t)(input[82] & 0xc0) << 10);
	output[40] = (double)(value >> 16);

	// read output[41]: from bit 658 to 673
	value = ((uint32_t)(input[82] & 0x3f) << 26) |
			((uint32_t)input[83] << 18) |
			((uint32_t)(input[84] & 0xc0) << 10);
	output[41] = (double)(value >> 16);

	// read output[42]: from bit 674 to 689
	value = ((uint32_t)(input[84] & 0x3f) << 26) |
			((uint32_t)input[85] << 18) |
			((uint32_t)(input[86] & 0xc0) << 10);
	output[42] = (double)(value >> 16);

	// read output[43]: from bit 690 to 705
	value = ((uint32_t)(input[86] & 0x3f) << 26) |
			((uint32_t)input[87] << 18) |
			((uint32_t)(input[88] & 0xc0) << 10);
	output[43] = (double)(value >> 16);

	// read output[44]: from bit 706 to 721
	value = ((uint32_t)(input[88] & 0x3f) << 26) |
			((uint32_t)input[89] << 18) |
			((uint32_t)(input[90] & 0xc0) << 10);
	output[44] = (double)(value >> 16);

	// read output[45]: from bit 722 to 737
	value = ((uint32_t)(input[90] & 0x3f) << 26) |
			((uint32_t)input[91] << 18) |
			((uint32_t)(input[92] & 0xc0) << 10);
	output[45] = (double)(value >> 16);

	// read output[46]: from bit 738 to 753
	value = ((uint32_t)(input[92] & 0x3f) << 26) |
			((uint32_t)input[93] << 18) |
			((uint32_t)(input[94] & 0xc0) << 10);
	output[46] = (double)(value >> 16);

	// read output[47]: from bit 754 to 769
	value = ((uint32_t)(input[94] & 0x3f) << 26) |
			((uint32_t)input[95] << 18) |
			((uint32_t)(input[96] & 0xc0) << 10);
	output[47] = (double)(value >> 16);

	// read output[48]: from bit 770 to 785
	value = ((uint32_t)(input[96] & 0x3f) << 26) |
			((uint32_t)input[97] << 18) |
			((uint32_t)(input[98] & 0xc0) << 10);
	output[48] = (double)(value >> 16);

	// read output[49]: from bit 786 to 801
	value = ((uint32_t)(input[98] & 0x3f) << 26) |
			((uint32_t)input[99] << 18) |
			((uint32_t)(input[100] & 0xc0) << 10);
	output[49] = (double)(value >> 16);

	// read output[50]: from bit 802 to 817
	value = ((uint32_t)(input[100] & 0x3f) << 26) |
			((uint32_t)input[101] << 18) |
			((uint32_t)(input[102] & 0xc0) << 10);
	output[50] = (double)(value >> 16);

	// read output[51]: from bit 818 to 833
	value = ((uint32_t)(input[102] & 0x3f) << 26) |
			((uint32_t)input[103] << 18) |
			((uint32_t)(input[104] & 0xc0) << 10);
	output[51] = (double)(value >> 16);

	// read output[52]: from bit 834 to 849
	value = ((uint32_t)(input[104] & 0x3f) << 26) |
			((uint32_t)input[105] << 18) |
			((uint32_t)(input[106] & 0xc0) << 10);
	output[52] = (double)(value >> 16);

	// read output[53]: from bit 850 to 865
	value = ((uint32_t)(input[106] & 0x3f) << 26) |
			((uint32_t)input[107] << 18) |
			((uint32_t)(input[108] & 0xc0) << 10);
	output[53] = (double)(value >> 16);
}

static void unpack_54_16bit_signed_3off(const uint8_t * input, double * output, void *closure) {
	// Unpack 54 values into output
	// Values are 16-bit signed
	// Skip 3 bits, read 864 bits of data.
	// Input must be at least 109 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 3 to 18
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)input[1] << 19) |
			((uint32_t)(input[2] & 0xe0) << 11);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 19 to 34
	value = ((uint32_t)(input[2] & 0x1f) << 27) |
			((uint32_t)input[3] << 19) |
			((uint32_t)(input[4] & 0xe0) << 11);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 35 to 50
	value = ((uint32_t)(input[4] & 0x1f) << 27) |
			((uint32_t)input[5] << 19) |
			((uint32_t)(input[6] & 0xe0) << 11);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 51 to 66
	value = ((uint32_t)(input[6] & 0x1f) << 27) |
			((uint32_t)input[7] << 19) |
			((uint32_t)(input[8] & 0xe0) << 11);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 67 to 82
	value = ((uint32_t)(input[8] & 0x1f) << 27) |
			((uint32_t)input[9] << 19) |
			((uint32_t)(input[10] & 0xe0) << 11);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 83 to 98
	value = ((uint32_t)(input[10] & 0x1f) << 27) |
			((uint32_t)input[11] << 19) |
			((uint32_t)(input[12] & 0xe0) << 11);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 99 to 114
	value = ((uint32_t)(input[12] & 0x1f) << 27) |
			((uint32_t)input[13] << 19) |
			((uint32_t)(input[14] & 0xe0) << 11);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 115 to 130
	value = ((uint32_t)(input[14] & 0x1f) << 27) |
			((uint32_t)input[15] << 19) |
			((uint32_t)(input[16] & 0xe0) << 11);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 131 to 146
	value = ((uint32_t)(input[16] & 0x1f) << 27) |
			((uint32_t)input[17] << 19) |
			((uint32_t)(input[18] & 0xe0) << 11);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 147 to 162
	value = ((uint32_t)(input[18] & 0x1f) << 27) |
			((uint32_t)input[19] << 19) |
			((uint32_t)(input[20] & 0xe0) << 11);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 163 to 178
	value = ((uint32_t)(input[20] & 0x1f) << 27) |
			((uint32_t)input[21] << 19) |
			((uint32_t)(input[22] & 0xe0) << 11);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 179 to 194
	value = ((uint32_t)(input[22] & 0x1f) << 27) |
			((uint32_t)input[23] << 19) |
			((uint32_t)(input[24] & 0xe0) << 11);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 195 to 210
	value = ((uint32_t)(input[24] & 0x1f) << 27) |
			((uint32_t)input[25] << 19) |
			((uint32_t)(input[26] & 0xe0) << 11);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 211 to 226
	value = ((uint32_t)(input[26] & 0x1f) << 27) |
			((uint32_t)input[27] << 19) |
			((uint32_t)(input[28] & 0xe0) << 11);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 227 to 242
	value = ((uint32_t)(input[28] & 0x1f) << 27) |
			((uint32_t)input[29] << 19) |
			((uint32_t)(input[30] & 0xe0) << 11);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 243 to 258
	value = ((uint32_t)(input[30] & 0x1f) << 27) |
			((uint32_t)input[31] << 19) |
			((uint32_t)(input[32] & 0xe0) << 11);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 259 to 274
	value = ((uint32_t)(input[32] & 0x1f) << 27) |
			((uint32_t)input[33] << 19) |
			((uint32_t)(input[34] & 0xe0) << 11);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 275 to 290
	value = ((uint32_t)(input[34] & 0x1f) << 27) |
			((uint32_t)input[35] << 19) |
			((uint32_t)(input[36] & 0xe0) << 11);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 291 to 306
	value = ((uint32_t)(input[36] & 0x1f) << 27) |
			((uint32_t)input[37] << 19) |
			((uint32_t)(input[38] & 0xe0) << 11);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 307 to 322
	value = ((uint32_t)(input[38] & 0x1f) << 27) |
			((uint32_t)input[39] << 19) |
			((uint32_t)(input[40] & 0xe0) << 11);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 323 to 338
	value = ((uint32_t)(input[40] & 0x1f) << 27) |
			((uint32_t)input[41] << 19) |
			((uint32_t)(input[42] & 0xe0) << 11);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 339 to 354
	value = ((uint32_t)(input[42] & 0x1f) << 27) |
			((uint32_t)input[43] << 19) |
			((uint32_t)(input[44] & 0xe0) << 11);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 355 to 370
	value = ((uint32_t)(input[44] & 0x1f) << 27) |
			((uint32_t)input[45] << 19) |
			((uint32_t)(input[46] & 0xe0) << 11);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 371 to 386
	value = ((uint32_t)(input[46] & 0x1f) << 27) |
			((uint32_t)input[47] << 19) |
			((uint32_t)(input[48] & 0xe0) << 11);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 387 to 402
	value = ((uint32_t)(input[48] & 0x1f) << 27) |
			((uint32_t)input[49] << 19) |
			((uint32_t)(input[50] & 0xe0) << 11);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 403 to 418
	value = ((uint32_t)(input[50] & 0x1f) << 27) |
			((uint32_t)input[51] << 19) |
			((uint32_t)(input[52] & 0xe0) << 11);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 419 to 434
	value = ((uint32_t)(input[52] & 0x1f) << 27) |
			((uint32_t)input[53] << 19) |
			((uint32_t)(input[54] & 0xe0) << 11);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 435 to 450
	value = ((uint32_t)(input[54] & 0x1f) << 27) |
			((uint32_t)input[55] << 19) |
			((uint32_t)(input[56] & 0xe0) << 11);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 451 to 466
	value = ((uint32_t)(input[56] & 0x1f) << 27) |
			((uint32_t)input[57] << 19) |
			((uint32_t)(input[58] & 0xe0) << 11);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 467 to 482
	value = ((uint32_t)(input[58] & 0x1f) << 27) |
			((uint32_t)input[59] << 19) |
			((uint32_t)(input[60] & 0xe0) << 11);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 483 to 498
	value = ((uint32_t)(input[60] & 0x1f) << 27) |
			((uint32_t)input[61] << 19) |
			((uint32_t)(input[62] & 0xe0) << 11);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 499 to 514
	value = ((uint32_t)(input[62] & 0x1f) << 27) |
			((uint32_t)input[63] << 19) |
			((uint32_t)(input[64] & 0xe0) << 11);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 515 to 530
	value = ((uint32_t)(input[64] & 0x1f) << 27) |
			((uint32_t)input[65] << 19) |
			((uint32_t)(input[66] & 0xe0) << 11);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 531 to 546
	value = ((uint32_t)(input[66] & 0x1f) << 27) |
			((uint32_t)input[67] << 19) |
			((uint32_t)(input[68] & 0xe0) << 11);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 547 to 562
	value = ((uint32_t)(input[68] & 0x1f) << 27) |
			((uint32_t)input[69] << 19) |
			((uint32_t)(input[70] & 0xe0) << 11);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 563 to 578
	value = ((uint32_t)(input[70] & 0x1f) << 27) |
			((uint32_t)input[71] << 19) |
			((uint32_t)(input[72] & 0xe0) << 11);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 579 to 594
	value = ((uint32_t)(input[72] & 0x1f) << 27) |
			((uint32_t)input[73] << 19) |
			((uint32_t)(input[74] & 0xe0) << 11);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 595 to 610
	value = ((uint32_t)(input[74] & 0x1f) << 27) |
			((uint32_t)input[75] << 19) |
			((uint32_t)(input[76] & 0xe0) << 11);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 611 to 626
	value = ((uint32_t)(input[76] & 0x1f) << 27) |
			((uint32_t)input[77] << 19) |
			((uint32_t)(input[78] & 0xe0) << 11);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 627 to 642
	value = ((uint32_t)(input[78] & 0x1f) << 27) |
			((uint32_t)input[79] << 19) |
			((uint32_t)(input[80] & 0xe0) << 11);
	output[39] = (double)(value >> 16);

	// read output[40]: from bit 643 to 658
	value = ((uint32_t)(input[80] & 0x1f) << 27) |
			((uint32_t)input[81] << 19) |
			((uint32_t)(input[82] & 0xe0) << 11);
	output[40] = (double)(value >> 16);

	// read output[41]: from bit 659 to 674
	value = ((uint32_t)(input[82] & 0x1f) << 27) |
			((uint32_t)input[83] << 19) |
			((uint32_t)(input[84] & 0xe0) << 11);
	output[41] = (double)(value >> 16);

	// read output[42]: from bit 675 to 690
	value = ((uint32_t)(input[84] & 0x1f) << 27) |
			((uint32_t)input[85] << 19) |
			((uint32_t)(input[86] & 0xe0) << 11);
	output[42] = (double)(value >> 16);

	// read output[43]: from bit 691 to 706
	value = ((uint32_t)(input[86] & 0x1f) << 27) |
			((uint32_t)input[87] << 19) |
			((uint32_t)(input[88] & 0xe0) << 11);
	output[43] = (double)(value >> 16);

	// read output[44]: from bit 707 to 722
	value = ((uint32_t)(input[88] & 0x1f) << 27) |
			((uint32_t)input[89] << 19) |
			((uint32_t)(input[90] & 0xe0) << 11);
	output[44] = (double)(value >> 16);

	// read output[45]: from bit 723 to 738
	value = ((uint32_t)(input[90] & 0x1f) << 27) |
			((uint32_t)input[91] << 19) |
			((uint32_t)(input[92] & 0xe0) << 11);
	output[45] = (double)(value >> 16);

	// read output[46]: from bit 739 to 754
	value = ((uint32_t)(input[92] & 0x1f) << 27) |
			((uint32_t)input[93] << 19) |
			((uint32_t)(input[94] & 0xe0) << 11);
	output[46] = (double)(value >> 16);

	// read output[47]: from bit 755 to 770
	value = ((uint32_t)(input[94] & 0x1f) << 27) |
			((uint32_t)input[95] << 19) |
			((uint32_t)(input[96] & 0xe0) << 11);
	output[47] = (double)(value >> 16);

	// read output[48]: from bit 771 to 786
	value = ((uint32_t)(input[96] & 0x1f) << 27) |
			((uint32_t)input[97] << 19) |
			((uint32_t)(input[98] & 0xe0) << 11);
	output[48] = (double)(value >> 16);

	// read output[49]: from bit 787 to 802
	value = ((uint32_t)(input[98] & 0x1f) << 27) |
			((uint32_t)input[99] << 19) |
			((uint32_t)(input[100] & 0xe0) << 11);
	output[49] = (double)(value >> 16);

	// read output[50]: from bit 803 to 818
	value = ((uint32_t)(input[100] & 0x1f) << 27) |
			((uint32_t)input[101] << 19) |
			((uint32_t)(input[102] & 0xe0) << 11);
	output[50] = (double)(value >> 16);

	// read output[51]: from bit 819 to 834
	value = ((uint32_t)(input[102] & 0x1f) << 27) |
			((uint32_t)input[103] << 19) |
			((uint32_t)(input[104] & 0xe0) << 11);
	output[51] = (double)(value >> 16);

	// read output[52]: from bit 835 to 850
	value = ((uint32_t)(input[104] & 0x1f) << 27) |
			((uint32_t)input[105] << 19) |
			((uint32_t)(input[106] & 0xe0) << 11);
	output[52] = (double)(value >> 16);

	// read output[53]: from bit 851 to 866
	value = ((uint32_t)(input[106] & 0x1f) << 27) |
			((uint32_t)input[107] << 19) |
			((uint32_t)(input[108] & 0xe0) << 11);
	output[53] = (double)(value >> 16);
}

static void unpack_54_16bit_unsigned_3off(const uint8_t * input, double * output, void *closure) {
	// Unpack 54 values into output
	// Values are 16-bit unsigned
	// Skip 3 bits, read 864 bits of data.
	// Input must be at least 109 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 3 to 18
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)input[1] << 19) |
			((uint32_t)(input[2] & 0xe0) << 11);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 19 to 34
	value = ((uint32_t)(input[2] & 0x1f) << 27) |
			((uint32_t)input[3] << 19) |
			((uint32_t)(input[4] & 0xe0) << 11);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 35 to 50
	value = ((uint32_t)(input[4] & 0x1f) << 27) |
			((uint32_t)input[5] << 19) |
			((uint32_t)(input[6] & 0xe0) << 11);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 51 to 66
	value = ((uint32_t)(input[6] & 0x1f) << 27) |
			((uint32_t)input[7] << 19) |
			((uint32_t)(input[8] & 0xe0) << 11);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 67 to 82
	value = ((uint32_t)(input[8] & 0x1f) << 27) |
			((uint32_t)input[9] << 19) |
			((uint32_t)(input[10] & 0xe0) << 11);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 83 to 98
	value = ((uint32_t)(input[10] & 0x1f) << 27) |
			((uint32_t)input[11] << 19) |
			((uint32_t)(input[12] & 0xe0) << 11);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 99 to 114
	value = ((uint32_t)(input[12] & 0x1f) << 27) |
			((uint32_t)input[13] << 19) |
			((uint32_t)(input[14] & 0xe0) << 11);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 115 to 130
	value = ((uint32_t)(input[14] & 0x1f) << 27) |
			((uint32_t)input[15] << 19) |
			((uint32_t)(input[16] & 0xe0) << 11);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 131 to 146
	value = ((uint32_t)(input[16] & 0x1f) << 27) |
			((uint32_t)input[17] << 19) |
			((uint32_t)(input[18] & 0xe0) << 11);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 147 to 162
	value = ((uint32_t)(input[18] & 0x1f) << 27) |
			((uint32_t)input[19] << 19) |
			((uint32_t)(input[20] & 0xe0) << 11);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 163 to 178
	value = ((uint32_t)(input[20] & 0x1f) << 27) |
			((uint32_t)input[21] << 19) |
			((uint32_t)(input[22] & 0xe0) << 11);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 179 to 194
	value = ((uint32_t)(input[22] & 0x1f) << 27) |
			((uint32_t)input[23] << 19) |
			((uint32_t)(input[24] & 0xe0) << 11);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 195 to 210
	value = ((uint32_t)(input[24] & 0x1f) << 27) |
			((uint32_t)input[25] << 19) |
			((uint32_t)(input[26] & 0xe0) << 11);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 211 to 226
	value = ((uint32_t)(input[26] & 0x1f) << 27) |
			((uint32_t)input[27] << 19) |
			((uint32_t)(input[28] & 0xe0) << 11);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 227 to 242
	value = ((uint32_t)(input[28] & 0x1f) << 27) |
			((uint32_t)input[29] << 19) |
			((uint32_t)(input[30] & 0xe0) << 11);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 243 to 258
	value = ((uint32_t)(input[30] & 0x1f) << 27) |
			((uint32_t)input[31] << 19) |
			((uint32_t)(input[32] & 0xe0) << 11);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 259 to 274
	value = ((uint32_t)(input[32] & 0x1f) << 27) |
			((uint32_t)input[33] << 19) |
			((uint32_t)(input[34] & 0xe0) << 11);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 275 to 290
	value = ((uint32_t)(input[34] & 0x1f) << 27) |
			((uint32_t)input[35] << 19) |
			((uint32_t)(input[36] & 0xe0) << 11);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 291 to 306
	value = ((uint32_t)(input[36] & 0x1f) << 27) |
			((uint32_t)input[37] << 19) |
			((uint32_t)(input[38] & 0xe0) << 11);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 307 to 322
	value = ((uint32_t)(input[38] & 0x1f) << 27) |
			((uint32_t)input[39] << 19) |
			((uint32_t)(input[40] & 0xe0) << 11);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 323 to 338
	value = ((uint32_t)(input[40] & 0x1f) << 27) |
			((uint32_t)input[41] << 19) |
			((uint32_t)(input[42] & 0xe0) << 11);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 339 to 354
	value = ((uint32_t)(input[42] & 0x1f) << 27) |
			((uint32_t)input[43] << 19) |
			((uint32_t)(input[44] & 0xe0) << 11);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 355 to 370
	value = ((uint32_t)(input[44] & 0x1f) << 27) |
			((uint32_t)input[45] << 19) |
			((uint32_t)(input[46] & 0xe0) << 11);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 371 to 386
	value = ((uint32_t)(input[46] & 0x1f) << 27) |
			((uint32_t)input[47] << 19) |
			((uint32_t)(input[48] & 0xe0) << 11);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 387 to 402
	value = ((uint32_t)(input[48] & 0x1f) << 27) |
			((uint32_t)input[49] << 19) |
			((uint32_t)(input[50] & 0xe0) << 11);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 403 to 418
	value = ((uint32_t)(input[50] & 0x1f) << 27) |
			((uint32_t)input[51] << 19) |
			((uint32_t)(input[52] & 0xe0) << 11);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 419 to 434
	value = ((uint32_t)(input[52] & 0x1f) << 27) |
			((uint32_t)input[53] << 19) |
			((uint32_t)(input[54] & 0xe0) << 11);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 435 to 450
	value = ((uint32_t)(input[54] & 0x1f) << 27) |
			((uint32_t)input[55] << 19) |
			((uint32_t)(input[56] & 0xe0) << 11);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 451 to 466
	value = ((uint32_t)(input[56] & 0x1f) << 27) |
			((uint32_t)input[57] << 19) |
			((uint32_t)(input[58] & 0xe0) << 11);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 467 to 482
	value = ((uint32_t)(input[58] & 0x1f) << 27) |
			((uint32_t)input[59] << 19) |
			((uint32_t)(input[60] & 0xe0) << 11);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 483 to 498
	value = ((uint32_t)(input[60] & 0x1f) << 27) |
			((uint32_t)input[61] << 19) |
			((uint32_t)(input[62] & 0xe0) << 11);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 499 to 514
	value = ((uint32_t)(input[62] & 0x1f) << 27) |
			((uint32_t)input[63] << 19) |
			((uint32_t)(input[64] & 0xe0) << 11);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 515 to 530
	value = ((uint32_t)(input[64] & 0x1f) << 27) |
			((uint32_t)input[65] << 19) |
			((uint32_t)(input[66] & 0xe0) << 11);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 531 to 546
	value = ((uint32_t)(input[66] & 0x1f) << 27) |
			((uint32_t)input[67] << 19) |
			((uint32_t)(input[68] & 0xe0) << 11);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 547 to 562
	value = ((uint32_t)(input[68] & 0x1f) << 27) |
			((uint32_t)input[69] << 19) |
			((uint32_t)(input[70] & 0xe0) << 11);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 563 to 578
	value = ((uint32_t)(input[70] & 0x1f) << 27) |
			((uint32_t)input[71] << 19) |
			((uint32_t)(input[72] & 0xe0) << 11);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 579 to 594
	value = ((uint32_t)(input[72] & 0x1f) << 27) |
			((uint32_t)input[73] << 19) |
			((uint32_t)(input[74] & 0xe0) << 11);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 595 to 610
	value = ((uint32_t)(input[74] & 0x1f) << 27) |
			((uint32_t)input[75] << 19) |
			((uint32_t)(input[76] & 0xe0) << 11);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 611 to 626
	value = ((uint32_t)(input[76] & 0x1f) << 27) |
			((uint32_t)input[77] << 19) |
			((uint32_t)(input[78] & 0xe0) << 11);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 627 to 642
	value = ((uint32_t)(input[78] & 0x1f) << 27) |
			((uint32_t)input[79] << 19) |
			((uint32_t)(input[80] & 0xe0) << 11);
	output[39] = (double)(value >> 16);

	// read output[40]: from bit 643 to 658
	value = ((uint32_t)(input[80] & 0x1f) << 27) |
			((uint32_t)input[81] << 19) |
			((uint32_t)(input[82] & 0xe0) << 11);
	output[40] = (double)(value >> 16);

	// read output[41]: from bit 659 to 674
	value = ((uint32_t)(input[82] & 0x1f) << 27) |
			((uint32_t)input[83] << 19) |
			((uint32_t)(input[84] & 0xe0) << 11);
	output[41] = (double)(value >> 16);

	// read output[42]: from bit 675 to 690
	value = ((uint32_t)(input[84] & 0x1f) << 27) |
			((uint32_t)input[85] << 19) |
			((uint32_t)(input[86] & 0xe0) << 11);
	output[42] = (double)(value >> 16);

	// read output[43]: from bit 691 to 706
	value = ((uint32_t)(input[86] & 0x1f) << 27) |
			((uint32_t)input[87] << 19) |
			((uint32_t)(input[88] & 0xe0) << 11);
	output[43] = (double)(value >> 16);

	// read output[44]: from bit 707 to 722
	value = ((uint32_t)(input[88] & 0x1f) << 27) |
			((uint32_t)input[89] << 19) |
			((uint32_t)(input[90] & 0xe0) << 11);
	output[44] = (double)(value >> 16);

	// read output[45]: from bit 723 to 738
	value = ((uint32_t)(input[90] & 0x1f) << 27) |
			((uint32_t)input[91] << 19) |
			((uint32_t)(input[92] & 0xe0) << 11);
	output[45] = (double)(value >> 16);

	// read output[46]: from bit 739 to 754
	value = ((uint32_t)(input[92] & 0x1f) << 27) |
			((uint32_t)input[93] << 19) |
			((uint32_t)(input[94] & 0xe0) << 11);
	output[46] = (double)(value >> 16);

	// read output[47]: from bit 755 to 770
	value = ((uint32_t)(input[94] & 0x1f) << 27) |
			((uint32_t)input[95] << 19) |
			((uint32_t)(input[96] & 0xe0) << 11);
	output[47] = (double)(value >> 16);

	// read output[48]: from bit 771 to 786
	value = ((uint32_t)(input[96] & 0x1f) << 27) |
			((uint32_t)input[97] << 19) |
			((uint32_t)(input[98] & 0xe0) << 11);
	output[48] = (double)(value >> 16);

	// read output[49]: from bit 787 to 802
	value = ((uint32_t)(input[98] & 0x1f) << 27) |
			((uint32_t)input[99] << 19) |
			((uint32_t)(input[100] & 0xe0) << 11);
	output[49] = (double)(value >> 16);

	// read output[50]: from bit 803 to 818
	value = ((uint32_t)(input[100] & 0x1f) << 27) |
			((uint32_t)input[101] << 19) |
			((uint32_t)(input[102] & 0xe0) << 11);
	output[50] = (double)(value >> 16);

	// read output[51]: from bit 819 to 834
	value = ((uint32_t)(input[102] & 0x1f) << 27) |
			((uint32_t)input[103] << 19) |
			((uint32_t)(input[104] & 0xe0) << 11);
	output[51] = (double)(value >> 16);

	// read output[52]: from bit 835 to 850
	value = ((uint32_t)(input[104] & 0x1f) << 27) |
			((uint32_t)input[105] << 19) |
			((uint32_t)(input[106] & 0xe0) << 11);
	output[52] = (double)(value >> 16);

	// read output[53]: from bit 851 to 866
	value = ((uint32_t)(input[106] & 0x1f) << 27) |
			((uint32_t)input[107] << 19) |
			((uint32_t)(input[108] & 0xe0) << 11);
	output[53] = (double)(value >> 16);
}

static void unpack_54_16bit_signed_4off(const uint8_t * input, double * output, void *closure) {
	// Unpack 54 values into output
	// Values are 16-bit signed
	// Skip 4 bits, read 864 bits of data.
	// Input must be at least 109 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 4 to 19
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20) |
			((uint32_t)(input[2] & 0xf0) << 12);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 20 to 35
	value = ((uint32_t)(input[2] & 0x0f) << 28) |
			((uint32_t)input[3] << 20) |
			((uint32_t)(input[4] & 0xf0) << 12);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 36 to 51
	value = ((uint32_t)(input[4] & 0x0f) << 28) |
			((uint32_t)input[5] << 20) |
			((uint32_t)(input[6] & 0xf0) << 12);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 52 to 67
	value = ((uint32_t)(input[6] & 0x0f) << 28) |
			((uint32_t)input[7] << 20) |
			((uint32_t)(input[8] & 0xf0) << 12);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 68 to 83
	value = ((uint32_t)(input[8] & 0x0f) << 28) |
			((uint32_t)input[9] << 20) |
			((uint32_t)(input[10] & 0xf0) << 12);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 84 to 99
	value = ((uint32_t)(input[10] & 0x0f) << 28) |
			((uint32_t)input[11] << 20) |
			((uint32_t)(input[12] & 0xf0) << 12);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 100 to 115
	value = ((uint32_t)(input[12] & 0x0f) << 28) |
			((uint32_t)input[13] << 20) |
			((uint32_t)(input[14] & 0xf0) << 12);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 116 to 131
	value = ((uint32_t)(input[14] & 0x0f) << 28) |
			((uint32_t)input[15] << 20) |
			((uint32_t)(input[16] & 0xf0) << 12);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 132 to 147
	value = ((uint32_t)(input[16] & 0x0f) << 28) |
			((uint32_t)input[17] << 20) |
			((uint32_t)(input[18] & 0xf0) << 12);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 148 to 163
	value = ((uint32_t)(input[18] & 0x0f) << 28) |
			((uint32_t)input[19] << 20) |
			((uint32_t)(input[20] & 0xf0) << 12);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 164 to 179
	value = ((uint32_t)(input[20] & 0x0f) << 28) |
			((uint32_t)input[21] << 20) |
			((uint32_t)(input[22] & 0xf0) << 12);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 180 to 195
	value = ((uint32_t)(input[22] & 0x0f) << 28) |
			((uint32_t)input[23] << 20) |
			((uint32_t)(input[24] & 0xf0) << 12);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 196 to 211
	value = ((uint32_t)(input[24] & 0x0f) << 28) |
			((uint32_t)input[25] << 20) |
			((uint32_t)(input[26] & 0xf0) << 12);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 212 to 227
	value = ((uint32_t)(input[26] & 0x0f) << 28) |
			((uint32_t)input[27] << 20) |
			((uint32_t)(input[28] & 0xf0) << 12);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 228 to 243
	value = ((uint32_t)(input[28] & 0x0f) << 28) |
			((uint32_t)input[29] << 20) |
			((uint32_t)(input[30] & 0xf0) << 12);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 244 to 259
	value = ((uint32_t)(input[30] & 0x0f) << 28) |
			((uint32_t)input[31] << 20) |
			((uint32_t)(input[32] & 0xf0) << 12);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 260 to 275
	value = ((uint32_t)(input[32] & 0x0f) << 28) |
			((uint32_t)input[33] << 20) |
			((uint32_t)(input[34] & 0xf0) << 12);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 276 to 291
	value = ((uint32_t)(input[34] & 0x0f) << 28) |
			((uint32_t)input[35] << 20) |
			((uint32_t)(input[36] & 0xf0) << 12);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 292 to 307
	value = ((uint32_t)(input[36] & 0x0f) << 28) |
			((uint32_t)input[37] << 20) |
			((uint32_t)(input[38] & 0xf0) << 12);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 308 to 323
	value = ((uint32_t)(input[38] & 0x0f) << 28) |
			((uint32_t)input[39] << 20) |
			((uint32_t)(input[40] & 0xf0) << 12);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 324 to 339
	value = ((uint32_t)(input[40] & 0x0f) << 28) |
			((uint32_t)input[41] << 20) |
			((uint32_t)(input[42] & 0xf0) << 12);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 340 to 355
	value = ((uint32_t)(input[42] & 0x0f) << 28) |
			((uint32_t)input[43] << 20) |
			((uint32_t)(input[44] & 0xf0) << 12);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 356 to 371
	value = ((uint32_t)(input[44] & 0x0f) << 28) |
			((uint32_t)input[45] << 20) |
			((uint32_t)(input[46] & 0xf0) << 12);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 372 to 387
	value = ((uint32_t)(input[46] & 0x0f) << 28) |
			((uint32_t)input[47] << 20) |
			((uint32_t)(input[48] & 0xf0) << 12);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 388 to 403
	value = ((uint32_t)(input[48] & 0x0f) << 28) |
			((uint32_t)input[49] << 20) |
			((uint32_t)(input[50] & 0xf0) << 12);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 404 to 419
	value = ((uint32_t)(input[50] & 0x0f) << 28) |
			((uint32_t)input[51] << 20) |
			((uint32_t)(input[52] & 0xf0) << 12);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 420 to 435
	value = ((uint32_t)(input[52] & 0x0f) << 28) |
			((uint32_t)input[53] << 20) |
			((uint32_t)(input[54] & 0xf0) << 12);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 436 to 451
	value = ((uint32_t)(input[54] & 0x0f) << 28) |
			((uint32_t)input[55] << 20) |
			((uint32_t)(input[56] & 0xf0) << 12);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 452 to 467
	value = ((uint32_t)(input[56] & 0x0f) << 28) |
			((uint32_t)input[57] << 20) |
			((uint32_t)(input[58] & 0xf0) << 12);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 468 to 483
	value = ((uint32_t)(input[58] & 0x0f) << 28) |
			((uint32_t)input[59] << 20) |
			((uint32_t)(input[60] & 0xf0) << 12);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 484 to 499
	value = ((uint32_t)(input[60] & 0x0f) << 28) |
			((uint32_t)input[61] << 20) |
			((uint32_t)(input[62] & 0xf0) << 12);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 500 to 515
	value = ((uint32_t)(input[62] & 0x0f) << 28) |
			((uint32_t)input[63] << 20) |
			((uint32_t)(input[64] & 0xf0) << 12);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 516 to 531
	value = ((uint32_t)(input[64] & 0x0f) << 28) |
			((uint32_t)input[65] << 20) |
			((uint32_t)(input[66] & 0xf0) << 12);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 532 to 547
	value = ((uint32_t)(input[66] & 0x0f) << 28) |
			((uint32_t)input[67] << 20) |
			((uint32_t)(input[68] & 0xf0) << 12);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 548 to 563
	value = ((uint32_t)(input[68] & 0x0f) << 28) |
			((uint32_t)input[69] << 20) |
			((uint32_t)(input[70] & 0xf0) << 12);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 564 to 579
	value = ((uint32_t)(input[70] & 0x0f) << 28) |
			((uint32_t)input[71] << 20) |
			((uint32_t)(input[72] & 0xf0) << 12);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 580 to 595
	value = ((uint32_t)(input[72] & 0x0f) << 28) |
			((uint32_t)input[73] << 20) |
			((uint32_t)(input[74] & 0xf0) << 12);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 596 to 611
	value = ((uint32_t)(input[74] & 0x0f) << 28) |
			((uint32_t)input[75] << 20) |
			((uint32_t)(input[76] & 0xf0) << 12);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 612 to 627
	value = ((uint32_t)(input[76] & 0x0f) << 28) |
			((uint32_t)input[77] << 20) |
			((uint32_t)(input[78] & 0xf0) << 12);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 628 to 643
	value = ((uint32_t)(input[78] & 0x0f) << 28) |
			((uint32_t)input[79] << 20) |
			((uint32_t)(input[80] & 0xf0) << 12);
	output[39] = (double)(value >> 16);

	// read output[40]: from bit 644 to 659
	value = ((uint32_t)(input[80] & 0x0f) << 28) |
			((uint32_t)input[81] << 20) |
			((uint32_t)(input[82] & 0xf0) << 12);
	output[40] = (double)(value >> 16);

	// read output[41]: from bit 660 to 675
	value = ((uint32_t)(input[82] & 0x0f) << 28) |
			((uint32_t)input[83] << 20) |
			((uint32_t)(input[84] & 0xf0) << 12);
	output[41] = (double)(value >> 16);

	// read output[42]: from bit 676 to 691
	value = ((uint32_t)(input[84] & 0x0f) << 28) |
			((uint32_t)input[85] << 20) |
			((uint32_t)(input[86] & 0xf0) << 12);
	output[42] = (double)(value >> 16);

	// read output[43]: from bit 692 to 707
	value = ((uint32_t)(input[86] & 0x0f) << 28) |
			((uint32_t)input[87] << 20) |
			((uint32_t)(input[88] & 0xf0) << 12);
	output[43] = (double)(value >> 16);

	// read output[44]: from bit 708 to 723
	value = ((uint32_t)(input[88] & 0x0f) << 28) |
			((uint32_t)input[89] << 20) |
			((uint32_t)(input[90] & 0xf0) << 12);
	output[44] = (double)(value >> 16);

	// read output[45]: from bit 724 to 739
	value = ((uint32_t)(input[90] & 0x0f) << 28) |
			((uint32_t)input[91] << 20) |
			((uint32_t)(input[92] & 0xf0) << 12);
	output[45] = (double)(value >> 16);

	// read output[46]: from bit 740 to 755
	value = ((uint32_t)(input[92] & 0x0f) << 28) |
			((uint32_t)input[93] << 20) |
			((uint32_t)(input[94] & 0xf0) << 12);
	output[46] = (double)(value >> 16);

	// read output[47]: from bit 756 to 771
	value = ((uint32_t)(input[94] & 0x0f) << 28) |
			((uint32_t)input[95] << 20) |
			((uint32_t)(input[96] & 0xf0) << 12);
	output[47] = (double)(value >> 16);

	// read output[48]: from bit 772 to 787
	value = ((uint32_t)(input[96] & 0x0f) << 28) |
			((uint32_t)input[97] << 20) |
			((uint32_t)(input[98] & 0xf0) << 12);
	output[48] = (double)(value >> 16);

	// read output[49]: from bit 788 to 803
	value = ((uint32_t)(input[98] & 0x0f) << 28) |
			((uint32_t)input[99] << 20) |
			((uint32_t)(input[100] & 0xf0) << 12);
	output[49] = (double)(value >> 16);

	// read output[50]: from bit 804 to 819
	value = ((uint32_t)(input[100] & 0x0f) << 28) |
			((uint32_t)input[101] << 20) |
			((uint32_t)(input[102] & 0xf0) << 12);
	output[50] = (double)(value >> 16);

	// read output[51]: from bit 820 to 835
	value = ((uint32_t)(input[102] & 0x0f) << 28) |
			((uint32_t)input[103] << 20) |
			((uint32_t)(input[104] & 0xf0) << 12);
	output[51] = (double)(value >> 16);

	// read output[52]: from bit 836 to 851
	value = ((uint32_t)(input[104] & 0x0f) << 28) |
			((uint32_t)input[105] << 20) |
			((uint32_t)(input[106] & 0xf0) << 12);
	output[52] = (double)(value >> 16);

	// read output[53]: from bit 852 to 867
	value = ((uint32_t)(input[106] & 0x0f) << 28) |
			((uint32_t)input[107] << 20) |
			((uint32_t)(input[108] & 0xf0) << 12);
	output[53] = (double)(value >> 16);
}

static void unpack_54_16bit_unsigned_4off(const uint8_t * input, double * output, void *closure) {
	// Unpack 54 values into output
	// Values are 16-bit unsigned
	// Skip 4 bits, read 864 bits of data.
	// Input must be at least 109 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 4 to 19
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20) |
			((uint32_t)(input[2] & 0xf0) << 12);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 20 to 35
	value = ((uint32_t)(input[2] & 0x0f) << 28) |
			((uint32_t)input[3] << 20) |
			((uint32_t)(input[4] & 0xf0) << 12);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 36 to 51
	value = ((uint32_t)(input[4] & 0x0f) << 28) |
			((uint32_t)input[5] << 20) |
			((uint32_t)(input[6] & 0xf0) << 12);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 52 to 67
	value = ((uint32_t)(input[6] & 0x0f) << 28) |
			((uint32_t)input[7] << 20) |
			((uint32_t)(input[8] & 0xf0) << 12);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 68 to 83
	value = ((uint32_t)(input[8] & 0x0f) << 28) |
			((uint32_t)input[9] << 20) |
			((uint32_t)(input[10] & 0xf0) << 12);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 84 to 99
	value = ((uint32_t)(input[10] & 0x0f) << 28) |
			((uint32_t)input[11] << 20) |
			((uint32_t)(input[12] & 0xf0) << 12);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 100 to 115
	value = ((uint32_t)(input[12] & 0x0f) << 28) |
			((uint32_t)input[13] << 20) |
			((uint32_t)(input[14] & 0xf0) << 12);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 116 to 131
	value = ((uint32_t)(input[14] & 0x0f) << 28) |
			((uint32_t)input[15] << 20) |
			((uint32_t)(input[16] & 0xf0) << 12);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 132 to 147
	value = ((uint32_t)(input[16] & 0x0f) << 28) |
			((uint32_t)input[17] << 20) |
			((uint32_t)(input[18] & 0xf0) << 12);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 148 to 163
	value = ((uint32_t)(input[18] & 0x0f) << 28) |
			((uint32_t)input[19] << 20) |
			((uint32_t)(input[20] & 0xf0) << 12);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 164 to 179
	value = ((uint32_t)(input[20] & 0x0f) << 28) |
			((uint32_t)input[21] << 20) |
			((uint32_t)(input[22] & 0xf0) << 12);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 180 to 195
	value = ((uint32_t)(input[22] & 0x0f) << 28) |
			((uint32_t)input[23] << 20) |
			((uint32_t)(input[24] & 0xf0) << 12);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 196 to 211
	value = ((uint32_t)(input[24] & 0x0f) << 28) |
			((uint32_t)input[25] << 20) |
			((uint32_t)(input[26] & 0xf0) << 12);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 212 to 227
	value = ((uint32_t)(input[26] & 0x0f) << 28) |
			((uint32_t)input[27] << 20) |
			((uint32_t)(input[28] & 0xf0) << 12);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 228 to 243
	value = ((uint32_t)(input[28] & 0x0f) << 28) |
			((uint32_t)input[29] << 20) |
			((uint32_t)(input[30] & 0xf0) << 12);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 244 to 259
	value = ((uint32_t)(input[30] & 0x0f) << 28) |
			((uint32_t)input[31] << 20) |
			((uint32_t)(input[32] & 0xf0) << 12);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 260 to 275
	value = ((uint32_t)(input[32] & 0x0f) << 28) |
			((uint32_t)input[33] << 20) |
			((uint32_t)(input[34] & 0xf0) << 12);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 276 to 291
	value = ((uint32_t)(input[34] & 0x0f) << 28) |
			((uint32_t)input[35] << 20) |
			((uint32_t)(input[36] & 0xf0) << 12);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 292 to 307
	value = ((uint32_t)(input[36] & 0x0f) << 28) |
			((uint32_t)input[37] << 20) |
			((uint32_t)(input[38] & 0xf0) << 12);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 308 to 323
	value = ((uint32_t)(input[38] & 0x0f) << 28) |
			((uint32_t)input[39] << 20) |
			((uint32_t)(input[40] & 0xf0) << 12);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 324 to 339
	value = ((uint32_t)(input[40] & 0x0f) << 28) |
			((uint32_t)input[41] << 20) |
			((uint32_t)(input[42] & 0xf0) << 12);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 340 to 355
	value = ((uint32_t)(input[42] & 0x0f) << 28) |
			((uint32_t)input[43] << 20) |
			((uint32_t)(input[44] & 0xf0) << 12);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 356 to 371
	value = ((uint32_t)(input[44] & 0x0f) << 28) |
			((uint32_t)input[45] << 20) |
			((uint32_t)(input[46] & 0xf0) << 12);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 372 to 387
	value = ((uint32_t)(input[46] & 0x0f) << 28) |
			((uint32_t)input[47] << 20) |
			((uint32_t)(input[48] & 0xf0) << 12);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 388 to 403
	value = ((uint32_t)(input[48] & 0x0f) << 28) |
			((uint32_t)input[49] << 20) |
			((uint32_t)(input[50] & 0xf0) << 12);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 404 to 419
	value = ((uint32_t)(input[50] & 0x0f) << 28) |
			((uint32_t)input[51] << 20) |
			((uint32_t)(input[52] & 0xf0) << 12);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 420 to 435
	value = ((uint32_t)(input[52] & 0x0f) << 28) |
			((uint32_t)input[53] << 20) |
			((uint32_t)(input[54] & 0xf0) << 12);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 436 to 451
	value = ((uint32_t)(input[54] & 0x0f) << 28) |
			((uint32_t)input[55] << 20) |
			((uint32_t)(input[56] & 0xf0) << 12);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 452 to 467
	value = ((uint32_t)(input[56] & 0x0f) << 28) |
			((uint32_t)input[57] << 20) |
			((uint32_t)(input[58] & 0xf0) << 12);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 468 to 483
	value = ((uint32_t)(input[58] & 0x0f) << 28) |
			((uint32_t)input[59] << 20) |
			((uint32_t)(input[60] & 0xf0) << 12);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 484 to 499
	value = ((uint32_t)(input[60] & 0x0f) << 28) |
			((uint32_t)input[61] << 20) |
			((uint32_t)(input[62] & 0xf0) << 12);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 500 to 515
	value = ((uint32_t)(input[62] & 0x0f) << 28) |
			((uint32_t)input[63] << 20) |
			((uint32_t)(input[64] & 0xf0) << 12);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 516 to 531
	value = ((uint32_t)(input[64] & 0x0f) << 28) |
			((uint32_t)input[65] << 20) |
			((uint32_t)(input[66] & 0xf0) << 12);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 532 to 547
	value = ((uint32_t)(input[66] & 0x0f) << 28) |
			((uint32_t)input[67] << 20) |
			((uint32_t)(input[68] & 0xf0) << 12);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 548 to 563
	value = ((uint32_t)(input[68] & 0x0f) << 28) |
			((uint32_t)input[69] << 20) |
			((uint32_t)(input[70] & 0xf0) << 12);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 564 to 579
	value = ((uint32_t)(input[70] & 0x0f) << 28) |
			((uint32_t)input[71] << 20) |
			((uint32_t)(input[72] & 0xf0) << 12);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 580 to 595
	value = ((uint32_t)(input[72] & 0x0f) << 28) |
			((uint32_t)input[73] << 20) |
			((uint32_t)(input[74] & 0xf0) << 12);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 596 to 611
	value = ((uint32_t)(input[74] & 0x0f) << 28) |
			((uint32_t)input[75] << 20) |
			((uint32_t)(input[76] & 0xf0) << 12);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 612 to 627
	value = ((uint32_t)(input[76] & 0x0f) << 28) |
			((uint32_t)input[77] << 20) |
			((uint32_t)(input[78] & 0xf0) << 12);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 628 to 643
	value = ((uint32_t)(input[78] & 0x0f) << 28) |
			((uint32_t)input[79] << 20) |
			((uint32_t)(input[80] & 0xf0) << 12);
	output[39] = (double)(value >> 16);

	// read output[40]: from bit 644 to 659
	value = ((uint32_t)(input[80] & 0x0f) << 28) |
			((uint32_t)input[81] << 20) |
			((uint32_t)(input[82] & 0xf0) << 12);
	output[40] = (double)(value >> 16);

	// read output[41]: from bit 660 to 675
	value = ((uint32_t)(input[82] & 0x0f) << 28) |
			((uint32_t)input[83] << 20) |
			((uint32_t)(input[84] & 0xf0) << 12);
	output[41] = (double)(value >> 16);

	// read output[42]: from bit 676 to 691
	value = ((uint32_t)(input[84] & 0x0f) << 28) |
			((uint32_t)input[85] << 20) |
			((uint32_t)(input[86] & 0xf0) << 12);
	output[42] = (double)(value >> 16);

	// read output[43]: from bit 692 to 707
	value = ((uint32_t)(input[86] & 0x0f) << 28) |
			((uint32_t)input[87] << 20) |
			((uint32_t)(input[88] & 0xf0) << 12);
	output[43] = (double)(value >> 16);

	// read output[44]: from bit 708 to 723
	value = ((uint32_t)(input[88] & 0x0f) << 28) |
			((uint32_t)input[89] << 20) |
			((uint32_t)(input[90] & 0xf0) << 12);
	output[44] = (double)(value >> 16);

	// read output[45]: from bit 724 to 739
	value = ((uint32_t)(input[90] & 0x0f) << 28) |
			((uint32_t)input[91] << 20) |
			((uint32_t)(input[92] & 0xf0) << 12);
	output[45] = (double)(value >> 16);

	// read output[46]: from bit 740 to 755
	value = ((uint32_t)(input[92] & 0x0f) << 28) |
			((uint32_t)input[93] << 20) |
			((uint32_t)(input[94] & 0xf0) << 12);
	output[46] = (double)(value >> 16);

	// read output[47]: from bit 756 to 771
	value = ((uint32_t)(input[94] & 0x0f) << 28) |
			((uint32_t)input[95] << 20) |
			((uint32_t)(input[96] & 0xf0) << 12);
	output[47] = (double)(value >> 16);

	// read output[48]: from bit 772 to 787
	value = ((uint32_t)(input[96] & 0x0f) << 28) |
			((uint32_t)input[97] << 20) |
			((uint32_t)(input[98] & 0xf0) << 12);
	output[48] = (double)(value >> 16);

	// read output[49]: from bit 788 to 803
	value = ((uint32_t)(input[98] & 0x0f) << 28) |
			((uint32_t)input[99] << 20) |
			((uint32_t)(input[100] & 0xf0) << 12);
	output[49] = (double)(value >> 16);

	// read output[50]: from bit 804 to 819
	value = ((uint32_t)(input[100] & 0x0f) << 28) |
			((uint32_t)input[101] << 20) |
			((uint32_t)(input[102] & 0xf0) << 12);
	output[50] = (double)(value >> 16);

	// read output[51]: from bit 820 to 835
	value = ((uint32_t)(input[102] & 0x0f) << 28) |
			((uint32_t)input[103] << 20) |
			((uint32_t)(input[104] & 0xf0) << 12);
	output[51] = (double)(value >> 16);

	// read output[52]: from bit 836 to 851
	value = ((uint32_t)(input[104] & 0x0f) << 28) |
			((uint32_t)input[105] << 20) |
			((uint32_t)(input[106] & 0xf0) << 12);
	output[52] = (double)(value >> 16);

	// read output[53]: from bit 852 to 867
	value = ((uint32_t)(input[106] & 0x0f) << 28) |
			((uint32_t)input[107] << 20) |
			((uint32_t)(input[108] & 0xf0) << 12);
	output[53] = (double)(value >> 16);
}

static void unpack_54_16bit_signed_5off(const uint8_t * input, double * output, void *closure) {
	// Unpack 54 values into output
	// Values are 16-bit signed
	// Skip 5 bits, read 864 bits of data.
	// Input must be at least 109 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 5 to 20
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)(input[2] & 0xf8) << 13);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 21 to 36
	value = ((uint32_t)(input[2] & 0x07) << 29) |
			((uint32_t)input[3] << 21) |
			((uint32_t)(input[4] & 0xf8) << 13);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 37 to 52
	value = ((uint32_t)(input[4] & 0x07) << 29) |
			((uint32_t)input[5] << 21) |
			((uint32_t)(input[6] & 0xf8) << 13);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 53 to 68
	value = ((uint32_t)(input[6] & 0x07) << 29) |
			((uint32_t)input[7] << 21) |
			((uint32_t)(input[8] & 0xf8) << 13);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 69 to 84
	value = ((uint32_t)(input[8] & 0x07) << 29) |
			((uint32_t)input[9] << 21) |
			((uint32_t)(input[10] & 0xf8) << 13);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 85 to 100
	value = ((uint32_t)(input[10] & 0x07) << 29) |
			((uint32_t)input[11] << 21) |
			((uint32_t)(input[12] & 0xf8) << 13);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 101 to 116
	value = ((uint32_t)(input[12] & 0x07) << 29) |
			((uint32_t)input[13] << 21) |
			((uint32_t)(input[14] & 0xf8) << 13);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 117 to 132
	value = ((uint32_t)(input[14] & 0x07) << 29) |
			((uint32_t)input[15] << 21) |
			((uint32_t)(input[16] & 0xf8) << 13);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 133 to 148
	value = ((uint32_t)(input[16] & 0x07) << 29) |
			((uint32_t)input[17] << 21) |
			((uint32_t)(input[18] & 0xf8) << 13);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 149 to 164
	value = ((uint32_t)(input[18] & 0x07) << 29) |
			((uint32_t)input[19] << 21) |
			((uint32_t)(input[20] & 0xf8) << 13);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 165 to 180
	value = ((uint32_t)(input[20] & 0x07) << 29) |
			((uint32_t)input[21] << 21) |
			((uint32_t)(input[22] & 0xf8) << 13);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 181 to 196
	value = ((uint32_t)(input[22] & 0x07) << 29) |
			((uint32_t)input[23] << 21) |
			((uint32_t)(input[24] & 0xf8) << 13);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 197 to 212
	value = ((uint32_t)(input[24] & 0x07) << 29) |
			((uint32_t)input[25] << 21) |
			((uint32_t)(input[26] & 0xf8) << 13);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 213 to 228
	value = ((uint32_t)(input[26] & 0x07) << 29) |
			((uint32_t)input[27] << 21) |
			((uint32_t)(input[28] & 0xf8) << 13);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 229 to 244
	value = ((uint32_t)(input[28] & 0x07) << 29) |
			((uint32_t)input[29] << 21) |
			((uint32_t)(input[30] & 0xf8) << 13);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 245 to 260
	value = ((uint32_t)(input[30] & 0x07) << 29) |
			((uint32_t)input[31] << 21) |
			((uint32_t)(input[32] & 0xf8) << 13);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 261 to 276
	value = ((uint32_t)(input[32] & 0x07) << 29) |
			((uint32_t)input[33] << 21) |
			((uint32_t)(input[34] & 0xf8) << 13);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 277 to 292
	value = ((uint32_t)(input[34] & 0x07) << 29) |
			((uint32_t)input[35] << 21) |
			((uint32_t)(input[36] & 0xf8) << 13);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 293 to 308
	value = ((uint32_t)(input[36] & 0x07) << 29) |
			((uint32_t)input[37] << 21) |
			((uint32_t)(input[38] & 0xf8) << 13);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 309 to 324
	value = ((uint32_t)(input[38] & 0x07) << 29) |
			((uint32_t)input[39] << 21) |
			((uint32_t)(input[40] & 0xf8) << 13);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 325 to 340
	value = ((uint32_t)(input[40] & 0x07) << 29) |
			((uint32_t)input[41] << 21) |
			((uint32_t)(input[42] & 0xf8) << 13);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 341 to 356
	value = ((uint32_t)(input[42] & 0x07) << 29) |
			((uint32_t)input[43] << 21) |
			((uint32_t)(input[44] & 0xf8) << 13);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 357 to 372
	value = ((uint32_t)(input[44] & 0x07) << 29) |
			((uint32_t)input[45] << 21) |
			((uint32_t)(input[46] & 0xf8) << 13);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 373 to 388
	value = ((uint32_t)(input[46] & 0x07) << 29) |
			((uint32_t)input[47] << 21) |
			((uint32_t)(input[48] & 0xf8) << 13);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 389 to 404
	value = ((uint32_t)(input[48] & 0x07) << 29) |
			((uint32_t)input[49] << 21) |
			((uint32_t)(input[50] & 0xf8) << 13);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 405 to 420
	value = ((uint32_t)(input[50] & 0x07) << 29) |
			((uint32_t)input[51] << 21) |
			((uint32_t)(input[52] & 0xf8) << 13);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 421 to 436
	value = ((uint32_t)(input[52] & 0x07) << 29) |
			((uint32_t)input[53] << 21) |
			((uint32_t)(input[54] & 0xf8) << 13);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 437 to 452
	value = ((uint32_t)(input[54] & 0x07) << 29) |
			((uint32_t)input[55] << 21) |
			((uint32_t)(input[56] & 0xf8) << 13);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 453 to 468
	value = ((uint32_t)(input[56] & 0x07) << 29) |
			((uint32_t)input[57] << 21) |
			((uint32_t)(input[58] & 0xf8) << 13);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 469 to 484
	value = ((uint32_t)(input[58] & 0x07) << 29) |
			((uint32_t)input[59] << 21) |
			((uint32_t)(input[60] & 0xf8) << 13);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 485 to 500
	value = ((uint32_t)(input[60] & 0x07) << 29) |
			((uint32_t)input[61] << 21) |
			((uint32_t)(input[62] & 0xf8) << 13);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 501 to 516
	value = ((uint32_t)(input[62] & 0x07) << 29) |
			((uint32_t)input[63] << 21) |
			((uint32_t)(input[64] & 0xf8) << 13);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 517 to 532
	value = ((uint32_t)(input[64] & 0x07) << 29) |
			((uint32_t)input[65] << 21) |
			((uint32_t)(input[66] & 0xf8) << 13);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 533 to 548
	value = ((uint32_t)(input[66] & 0x07) << 29) |
			((uint32_t)input[67] << 21) |
			((uint32_t)(input[68] & 0xf8) << 13);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 549 to 564
	value = ((uint32_t)(input[68] & 0x07) << 29) |
			((uint32_t)input[69] << 21) |
			((uint32_t)(input[70] & 0xf8) << 13);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 565 to 580
	value = ((uint32_t)(input[70] & 0x07) << 29) |
			((uint32_t)input[71] << 21) |
			((uint32_t)(input[72] & 0xf8) << 13);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 581 to 596
	value = ((uint32_t)(input[72] & 0x07) << 29) |
			((uint32_t)input[73] << 21) |
			((uint32_t)(input[74] & 0xf8) << 13);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 597 to 612
	value = ((uint32_t)(input[74] & 0x07) << 29) |
			((uint32_t)input[75] << 21) |
			((uint32_t)(input[76] & 0xf8) << 13);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 613 to 628
	value = ((uint32_t)(input[76] & 0x07) << 29) |
			((uint32_t)input[77] << 21) |
			((uint32_t)(input[78] & 0xf8) << 13);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 629 to 644
	value = ((uint32_t)(input[78] & 0x07) << 29) |
			((uint32_t)input[79] << 21) |
			((uint32_t)(input[80] & 0xf8) << 13);
	output[39] = (double)(value >> 16);

	// read output[40]: from bit 645 to 660
	value = ((uint32_t)(input[80] & 0x07) << 29) |
			((uint32_t)input[81] << 21) |
			((uint32_t)(input[82] & 0xf8) << 13);
	output[40] = (double)(value >> 16);

	// read output[41]: from bit 661 to 676
	value = ((uint32_t)(input[82] & 0x07) << 29) |
			((uint32_t)input[83] << 21) |
			((uint32_t)(input[84] & 0xf8) << 13);
	output[41] = (double)(value >> 16);

	// read output[42]: from bit 677 to 692
	value = ((uint32_t)(input[84] & 0x07) << 29) |
			((uint32_t)input[85] << 21) |
			((uint32_t)(input[86] & 0xf8) << 13);
	output[42] = (double)(value >> 16);

	// read output[43]: from bit 693 to 708
	value = ((uint32_t)(input[86] & 0x07) << 29) |
			((uint32_t)input[87] << 21) |
			((uint32_t)(input[88] & 0xf8) << 13);
	output[43] = (double)(value >> 16);

	// read output[44]: from bit 709 to 724
	value = ((uint32_t)(input[88] & 0x07) << 29) |
			((uint32_t)input[89] << 21) |
			((uint32_t)(input[90] & 0xf8) << 13);
	output[44] = (double)(value >> 16);

	// read output[45]: from bit 725 to 740
	value = ((uint32_t)(input[90] & 0x07) << 29) |
			((uint32_t)input[91] << 21) |
			((uint32_t)(input[92] & 0xf8) << 13);
	output[45] = (double)(value >> 16);

	// read output[46]: from bit 741 to 756
	value = ((uint32_t)(input[92] & 0x07) << 29) |
			((uint32_t)input[93] << 21) |
			((uint32_t)(input[94] & 0xf8) << 13);
	output[46] = (double)(value >> 16);

	// read output[47]: from bit 757 to 772
	value = ((uint32_t)(input[94] & 0x07) << 29) |
			((uint32_t)input[95] << 21) |
			((uint32_t)(input[96] & 0xf8) << 13);
	output[47] = (double)(value >> 16);

	// read output[48]: from bit 773 to 788
	value = ((uint32_t)(input[96] & 0x07) << 29) |
			((uint32_t)input[97] << 21) |
			((uint32_t)(input[98] & 0xf8) << 13);
	output[48] = (double)(value >> 16);

	// read output[49]: from bit 789 to 804
	value = ((uint32_t)(input[98] & 0x07) << 29) |
			((uint32_t)input[99] << 21) |
			((uint32_t)(input[100] & 0xf8) << 13);
	output[49] = (double)(value >> 16);

	// read output[50]: from bit 805 to 820
	value = ((uint32_t)(input[100] & 0x07) << 29) |
			((uint32_t)input[101] << 21) |
			((uint32_t)(input[102] & 0xf8) << 13);
	output[50] = (double)(value >> 16);

	// read output[51]: from bit 821 to 836
	value = ((uint32_t)(input[102] & 0x07) << 29) |
			((uint32_t)input[103] << 21) |
			((uint32_t)(input[104] & 0xf8) << 13);
	output[51] = (double)(value >> 16);

	// read output[52]: from bit 837 to 852
	value = ((uint32_t)(input[104] & 0x07) << 29) |
			((uint32_t)input[105] << 21) |
			((uint32_t)(input[106] & 0xf8) << 13);
	output[52] = (double)(value >> 16);

	// read output[53]: from bit 853 to 868
	value = ((uint32_t)(input[106] & 0x07) << 29) |
			((uint32_t)input[107] << 21) |
			((uint32_t)(input[108] & 0xf8) << 13);
	output[53] = (double)(value >> 16);
}

static void unpack_54_16bit_unsigned_5off(const uint8_t * input, double * output, void *closure) {
	// Unpack 54 values into output
	// Values are 16-bit unsigned
	// Skip 5 bits, read 864 bits of data.
	// Input must be at least 109 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 5 to 20
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)(input[2] & 0xf8) << 13);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 21 to 36
	value = ((uint32_t)(input[2] & 0x07) << 29) |
			((uint32_t)input[3] << 21) |
			((uint32_t)(input[4] & 0xf8) << 13);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 37 to 52
	value = ((uint32_t)(input[4] & 0x07) << 29) |
			((uint32_t)input[5] << 21) |
			((uint32_t)(input[6] & 0xf8) << 13);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 53 to 68
	value = ((uint32_t)(input[6] & 0x07) << 29) |
			((uint32_t)input[7] << 21) |
			((uint32_t)(input[8] & 0xf8) << 13);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 69 to 84
	value = ((uint32_t)(input[8] & 0x07) << 29) |
			((uint32_t)input[9] << 21) |
			((uint32_t)(input[10] & 0xf8) << 13);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 85 to 100
	value = ((uint32_t)(input[10] & 0x07) << 29) |
			((uint32_t)input[11] << 21) |
			((uint32_t)(input[12] & 0xf8) << 13);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 101 to 116
	value = ((uint32_t)(input[12] & 0x07) << 29) |
			((uint32_t)input[13] << 21) |
			((uint32_t)(input[14] & 0xf8) << 13);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 117 to 132
	value = ((uint32_t)(input[14] & 0x07) << 29) |
			((uint32_t)input[15] << 21) |
			((uint32_t)(input[16] & 0xf8) << 13);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 133 to 148
	value = ((uint32_t)(input[16] & 0x07) << 29) |
			((uint32_t)input[17] << 21) |
			((uint32_t)(input[18] & 0xf8) << 13);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 149 to 164
	value = ((uint32_t)(input[18] & 0x07) << 29) |
			((uint32_t)input[19] << 21) |
			((uint32_t)(input[20] & 0xf8) << 13);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 165 to 180
	value = ((uint32_t)(input[20] & 0x07) << 29) |
			((uint32_t)input[21] << 21) |
			((uint32_t)(input[22] & 0xf8) << 13);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 181 to 196
	value = ((uint32_t)(input[22] & 0x07) << 29) |
			((uint32_t)input[23] << 21) |
			((uint32_t)(input[24] & 0xf8) << 13);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 197 to 212
	value = ((uint32_t)(input[24] & 0x07) << 29) |
			((uint32_t)input[25] << 21) |
			((uint32_t)(input[26] & 0xf8) << 13);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 213 to 228
	value = ((uint32_t)(input[26] & 0x07) << 29) |
			((uint32_t)input[27] << 21) |
			((uint32_t)(input[28] & 0xf8) << 13);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 229 to 244
	value = ((uint32_t)(input[28] & 0x07) << 29) |
			((uint32_t)input[29] << 21) |
			((uint32_t)(input[30] & 0xf8) << 13);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 245 to 260
	value = ((uint32_t)(input[30] & 0x07) << 29) |
			((uint32_t)input[31] << 21) |
			((uint32_t)(input[32] & 0xf8) << 13);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 261 to 276
	value = ((uint32_t)(input[32] & 0x07) << 29) |
			((uint32_t)input[33] << 21) |
			((uint32_t)(input[34] & 0xf8) << 13);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 277 to 292
	value = ((uint32_t)(input[34] & 0x07) << 29) |
			((uint32_t)input[35] << 21) |
			((uint32_t)(input[36] & 0xf8) << 13);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 293 to 308
	value = ((uint32_t)(input[36] & 0x07) << 29) |
			((uint32_t)input[37] << 21) |
			((uint32_t)(input[38] & 0xf8) << 13);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 309 to 324
	value = ((uint32_t)(input[38] & 0x07) << 29) |
			((uint32_t)input[39] << 21) |
			((uint32_t)(input[40] & 0xf8) << 13);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 325 to 340
	value = ((uint32_t)(input[40] & 0x07) << 29) |
			((uint32_t)input[41] << 21) |
			((uint32_t)(input[42] & 0xf8) << 13);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 341 to 356
	value = ((uint32_t)(input[42] & 0x07) << 29) |
			((uint32_t)input[43] << 21) |
			((uint32_t)(input[44] & 0xf8) << 13);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 357 to 372
	value = ((uint32_t)(input[44] & 0x07) << 29) |
			((uint32_t)input[45] << 21) |
			((uint32_t)(input[46] & 0xf8) << 13);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 373 to 388
	value = ((uint32_t)(input[46] & 0x07) << 29) |
			((uint32_t)input[47] << 21) |
			((uint32_t)(input[48] & 0xf8) << 13);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 389 to 404
	value = ((uint32_t)(input[48] & 0x07) << 29) |
			((uint32_t)input[49] << 21) |
			((uint32_t)(input[50] & 0xf8) << 13);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 405 to 420
	value = ((uint32_t)(input[50] & 0x07) << 29) |
			((uint32_t)input[51] << 21) |
			((uint32_t)(input[52] & 0xf8) << 13);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 421 to 436
	value = ((uint32_t)(input[52] & 0x07) << 29) |
			((uint32_t)input[53] << 21) |
			((uint32_t)(input[54] & 0xf8) << 13);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 437 to 452
	value = ((uint32_t)(input[54] & 0x07) << 29) |
			((uint32_t)input[55] << 21) |
			((uint32_t)(input[56] & 0xf8) << 13);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 453 to 468
	value = ((uint32_t)(input[56] & 0x07) << 29) |
			((uint32_t)input[57] << 21) |
			((uint32_t)(input[58] & 0xf8) << 13);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 469 to 484
	value = ((uint32_t)(input[58] & 0x07) << 29) |
			((uint32_t)input[59] << 21) |
			((uint32_t)(input[60] & 0xf8) << 13);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 485 to 500
	value = ((uint32_t)(input[60] & 0x07) << 29) |
			((uint32_t)input[61] << 21) |
			((uint32_t)(input[62] & 0xf8) << 13);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 501 to 516
	value = ((uint32_t)(input[62] & 0x07) << 29) |
			((uint32_t)input[63] << 21) |
			((uint32_t)(input[64] & 0xf8) << 13);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 517 to 532
	value = ((uint32_t)(input[64] & 0x07) << 29) |
			((uint32_t)input[65] << 21) |
			((uint32_t)(input[66] & 0xf8) << 13);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 533 to 548
	value = ((uint32_t)(input[66] & 0x07) << 29) |
			((uint32_t)input[67] << 21) |
			((uint32_t)(input[68] & 0xf8) << 13);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 549 to 564
	value = ((uint32_t)(input[68] & 0x07) << 29) |
			((uint32_t)input[69] << 21) |
			((uint32_t)(input[70] & 0xf8) << 13);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 565 to 580
	value = ((uint32_t)(input[70] & 0x07) << 29) |
			((uint32_t)input[71] << 21) |
			((uint32_t)(input[72] & 0xf8) << 13);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 581 to 596
	value = ((uint32_t)(input[72] & 0x07) << 29) |
			((uint32_t)input[73] << 21) |
			((uint32_t)(input[74] & 0xf8) << 13);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 597 to 612
	value = ((uint32_t)(input[74] & 0x07) << 29) |
			((uint32_t)input[75] << 21) |
			((uint32_t)(input[76] & 0xf8) << 13);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 613 to 628
	value = ((uint32_t)(input[76] & 0x07) << 29) |
			((uint32_t)input[77] << 21) |
			((uint32_t)(input[78] & 0xf8) << 13);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 629 to 644
	value = ((uint32_t)(input[78] & 0x07) << 29) |
			((uint32_t)input[79] << 21) |
			((uint32_t)(input[80] & 0xf8) << 13);
	output[39] = (double)(value >> 16);

	// read output[40]: from bit 645 to 660
	value = ((uint32_t)(input[80] & 0x07) << 29) |
			((uint32_t)input[81] << 21) |
			((uint32_t)(input[82] & 0xf8) << 13);
	output[40] = (double)(value >> 16);

	// read output[41]: from bit 661 to 676
	value = ((uint32_t)(input[82] & 0x07) << 29) |
			((uint32_t)input[83] << 21) |
			((uint32_t)(input[84] & 0xf8) << 13);
	output[41] = (double)(value >> 16);

	// read output[42]: from bit 677 to 692
	value = ((uint32_t)(input[84] & 0x07) << 29) |
			((uint32_t)input[85] << 21) |
			((uint32_t)(input[86] & 0xf8) << 13);
	output[42] = (double)(value >> 16);

	// read output[43]: from bit 693 to 708
	value = ((uint32_t)(input[86] & 0x07) << 29) |
			((uint32_t)input[87] << 21) |
			((uint32_t)(input[88] & 0xf8) << 13);
	output[43] = (double)(value >> 16);

	// read output[44]: from bit 709 to 724
	value = ((uint32_t)(input[88] & 0x07) << 29) |
			((uint32_t)input[89] << 21) |
			((uint32_t)(input[90] & 0xf8) << 13);
	output[44] = (double)(value >> 16);

	// read output[45]: from bit 725 to 740
	value = ((uint32_t)(input[90] & 0x07) << 29) |
			((uint32_t)input[91] << 21) |
			((uint32_t)(input[92] & 0xf8) << 13);
	output[45] = (double)(value >> 16);

	// read output[46]: from bit 741 to 756
	value = ((uint32_t)(input[92] & 0x07) << 29) |
			((uint32_t)input[93] << 21) |
			((uint32_t)(input[94] & 0xf8) << 13);
	output[46] = (double)(value >> 16);

	// read output[47]: from bit 757 to 772
	value = ((uint32_t)(input[94] & 0x07) << 29) |
			((uint32_t)input[95] << 21) |
			((uint32_t)(input[96] & 0xf8) << 13);
	output[47] = (double)(value >> 16);

	// read output[48]: from bit 773 to 788
	value = ((uint32_t)(input[96] & 0x07) << 29) |
			((uint32_t)input[97] << 21) |
			((uint32_t)(input[98] & 0xf8) << 13);
	output[48] = (double)(value >> 16);

	// read output[49]: from bit 789 to 804
	value = ((uint32_t)(input[98] & 0x07) << 29) |
			((uint32_t)input[99] << 21) |
			((uint32_t)(input[100] & 0xf8) << 13);
	output[49] = (double)(value >> 16);

	// read output[50]: from bit 805 to 820
	value = ((uint32_t)(input[100] & 0x07) << 29) |
			((uint32_t)input[101] << 21) |
			((uint32_t)(input[102] & 0xf8) << 13);
	output[50] = (double)(value >> 16);

	// read output[51]: from bit 821 to 836
	value = ((uint32_t)(input[102] & 0x07) << 29) |
			((uint32_t)input[103] << 21) |
			((uint32_t)(input[104] & 0xf8) << 13);
	output[51] = (double)(value >> 16);

	// read output[52]: from bit 837 to 852
	value = ((uint32_t)(input[104] & 0x07) << 29) |
			((uint32_t)input[105] << 21) |
			((uint32_t)(input[106] & 0xf8) << 13);
	output[52] = (double)(value >> 16);

	// read output[53]: from bit 853 to 868
	value = ((uint32_t)(input[106] & 0x07) << 29) |
			((uint32_t)input[107] << 21) |
			((uint32_t)(input[108] & 0xf8) << 13);
	output[53] = (double)(value >> 16);
}

static void unpack_54_16bit_signed_6off(const uint8_t * input, double * output, void *closure) {
	// Unpack 54 values into output
	// Values are 16-bit signed
	// Skip 6 bits, read 864 bits of data.
	// Input must be at least 109 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 6 to 21
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)(input[2] & 0xfc) << 14);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 22 to 37
	value = ((uint32_t)(input[2] & 0x03) << 30) |
			((uint32_t)input[3] << 22) |
			((uint32_t)(input[4] & 0xfc) << 14);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 38 to 53
	value = ((uint32_t)(input[4] & 0x03) << 30) |
			((uint32_t)input[5] << 22) |
			((uint32_t)(input[6] & 0xfc) << 14);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 54 to 69
	value = ((uint32_t)(input[6] & 0x03) << 30) |
			((uint32_t)input[7] << 22) |
			((uint32_t)(input[8] & 0xfc) << 14);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 70 to 85
	value = ((uint32_t)(input[8] & 0x03) << 30) |
			((uint32_t)input[9] << 22) |
			((uint32_t)(input[10] & 0xfc) << 14);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 86 to 101
	value = ((uint32_t)(input[10] & 0x03) << 30) |
			((uint32_t)input[11] << 22) |
			((uint32_t)(input[12] & 0xfc) << 14);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 102 to 117
	value = ((uint32_t)(input[12] & 0x03) << 30) |
			((uint32_t)input[13] << 22) |
			((uint32_t)(input[14] & 0xfc) << 14);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 118 to 133
	value = ((uint32_t)(input[14] & 0x03) << 30) |
			((uint32_t)input[15] << 22) |
			((uint32_t)(input[16] & 0xfc) << 14);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 134 to 149
	value = ((uint32_t)(input[16] & 0x03) << 30) |
			((uint32_t)input[17] << 22) |
			((uint32_t)(input[18] & 0xfc) << 14);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 150 to 165
	value = ((uint32_t)(input[18] & 0x03) << 30) |
			((uint32_t)input[19] << 22) |
			((uint32_t)(input[20] & 0xfc) << 14);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 166 to 181
	value = ((uint32_t)(input[20] & 0x03) << 30) |
			((uint32_t)input[21] << 22) |
			((uint32_t)(input[22] & 0xfc) << 14);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 182 to 197
	value = ((uint32_t)(input[22] & 0x03) << 30) |
			((uint32_t)input[23] << 22) |
			((uint32_t)(input[24] & 0xfc) << 14);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 198 to 213
	value = ((uint32_t)(input[24] & 0x03) << 30) |
			((uint32_t)input[25] << 22) |
			((uint32_t)(input[26] & 0xfc) << 14);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 214 to 229
	value = ((uint32_t)(input[26] & 0x03) << 30) |
			((uint32_t)input[27] << 22) |
			((uint32_t)(input[28] & 0xfc) << 14);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 230 to 245
	value = ((uint32_t)(input[28] & 0x03) << 30) |
			((uint32_t)input[29] << 22) |
			((uint32_t)(input[30] & 0xfc) << 14);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 246 to 261
	value = ((uint32_t)(input[30] & 0x03) << 30) |
			((uint32_t)input[31] << 22) |
			((uint32_t)(input[32] & 0xfc) << 14);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 262 to 277
	value = ((uint32_t)(input[32] & 0x03) << 30) |
			((uint32_t)input[33] << 22) |
			((uint32_t)(input[34] & 0xfc) << 14);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 278 to 293
	value = ((uint32_t)(input[34] & 0x03) << 30) |
			((uint32_t)input[35] << 22) |
			((uint32_t)(input[36] & 0xfc) << 14);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 294 to 309
	value = ((uint32_t)(input[36] & 0x03) << 30) |
			((uint32_t)input[37] << 22) |
			((uint32_t)(input[38] & 0xfc) << 14);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 310 to 325
	value = ((uint32_t)(input[38] & 0x03) << 30) |
			((uint32_t)input[39] << 22) |
			((uint32_t)(input[40] & 0xfc) << 14);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 326 to 341
	value = ((uint32_t)(input[40] & 0x03) << 30) |
			((uint32_t)input[41] << 22) |
			((uint32_t)(input[42] & 0xfc) << 14);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 342 to 357
	value = ((uint32_t)(input[42] & 0x03) << 30) |
			((uint32_t)input[43] << 22) |
			((uint32_t)(input[44] & 0xfc) << 14);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 358 to 373
	value = ((uint32_t)(input[44] & 0x03) << 30) |
			((uint32_t)input[45] << 22) |
			((uint32_t)(input[46] & 0xfc) << 14);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 374 to 389
	value = ((uint32_t)(input[46] & 0x03) << 30) |
			((uint32_t)input[47] << 22) |
			((uint32_t)(input[48] & 0xfc) << 14);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 390 to 405
	value = ((uint32_t)(input[48] & 0x03) << 30) |
			((uint32_t)input[49] << 22) |
			((uint32_t)(input[50] & 0xfc) << 14);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 406 to 421
	value = ((uint32_t)(input[50] & 0x03) << 30) |
			((uint32_t)input[51] << 22) |
			((uint32_t)(input[52] & 0xfc) << 14);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 422 to 437
	value = ((uint32_t)(input[52] & 0x03) << 30) |
			((uint32_t)input[53] << 22) |
			((uint32_t)(input[54] & 0xfc) << 14);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 438 to 453
	value = ((uint32_t)(input[54] & 0x03) << 30) |
			((uint32_t)input[55] << 22) |
			((uint32_t)(input[56] & 0xfc) << 14);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 454 to 469
	value = ((uint32_t)(input[56] & 0x03) << 30) |
			((uint32_t)input[57] << 22) |
			((uint32_t)(input[58] & 0xfc) << 14);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 470 to 485
	value = ((uint32_t)(input[58] & 0x03) << 30) |
			((uint32_t)input[59] << 22) |
			((uint32_t)(input[60] & 0xfc) << 14);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 486 to 501
	value = ((uint32_t)(input[60] & 0x03) << 30) |
			((uint32_t)input[61] << 22) |
			((uint32_t)(input[62] & 0xfc) << 14);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 502 to 517
	value = ((uint32_t)(input[62] & 0x03) << 30) |
			((uint32_t)input[63] << 22) |
			((uint32_t)(input[64] & 0xfc) << 14);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 518 to 533
	value = ((uint32_t)(input[64] & 0x03) << 30) |
			((uint32_t)input[65] << 22) |
			((uint32_t)(input[66] & 0xfc) << 14);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 534 to 549
	value = ((uint32_t)(input[66] & 0x03) << 30) |
			((uint32_t)input[67] << 22) |
			((uint32_t)(input[68] & 0xfc) << 14);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 550 to 565
	value = ((uint32_t)(input[68] & 0x03) << 30) |
			((uint32_t)input[69] << 22) |
			((uint32_t)(input[70] & 0xfc) << 14);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 566 to 581
	value = ((uint32_t)(input[70] & 0x03) << 30) |
			((uint32_t)input[71] << 22) |
			((uint32_t)(input[72] & 0xfc) << 14);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 582 to 597
	value = ((uint32_t)(input[72] & 0x03) << 30) |
			((uint32_t)input[73] << 22) |
			((uint32_t)(input[74] & 0xfc) << 14);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 598 to 613
	value = ((uint32_t)(input[74] & 0x03) << 30) |
			((uint32_t)input[75] << 22) |
			((uint32_t)(input[76] & 0xfc) << 14);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 614 to 629
	value = ((uint32_t)(input[76] & 0x03) << 30) |
			((uint32_t)input[77] << 22) |
			((uint32_t)(input[78] & 0xfc) << 14);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 630 to 645
	value = ((uint32_t)(input[78] & 0x03) << 30) |
			((uint32_t)input[79] << 22) |
			((uint32_t)(input[80] & 0xfc) << 14);
	output[39] = (double)(value >> 16);

	// read output[40]: from bit 646 to 661
	value = ((uint32_t)(input[80] & 0x03) << 30) |
			((uint32_t)input[81] << 22) |
			((uint32_t)(input[82] & 0xfc) << 14);
	output[40] = (double)(value >> 16);

	// read output[41]: from bit 662 to 677
	value = ((uint32_t)(input[82] & 0x03) << 30) |
			((uint32_t)input[83] << 22) |
			((uint32_t)(input[84] & 0xfc) << 14);
	output[41] = (double)(value >> 16);

	// read output[42]: from bit 678 to 693
	value = ((uint32_t)(input[84] & 0x03) << 30) |
			((uint32_t)input[85] << 22) |
			((uint32_t)(input[86] & 0xfc) << 14);
	output[42] = (double)(value >> 16);

	// read output[43]: from bit 694 to 709
	value = ((uint32_t)(input[86] & 0x03) << 30) |
			((uint32_t)input[87] << 22) |
			((uint32_t)(input[88] & 0xfc) << 14);
	output[43] = (double)(value >> 16);

	// read output[44]: from bit 710 to 725
	value = ((uint32_t)(input[88] & 0x03) << 30) |
			((uint32_t)input[89] << 22) |
			((uint32_t)(input[90] & 0xfc) << 14);
	output[44] = (double)(value >> 16);

	// read output[45]: from bit 726 to 741
	value = ((uint32_t)(input[90] & 0x03) << 30) |
			((uint32_t)input[91] << 22) |
			((uint32_t)(input[92] & 0xfc) << 14);
	output[45] = (double)(value >> 16);

	// read output[46]: from bit 742 to 757
	value = ((uint32_t)(input[92] & 0x03) << 30) |
			((uint32_t)input[93] << 22) |
			((uint32_t)(input[94] & 0xfc) << 14);
	output[46] = (double)(value >> 16);

	// read output[47]: from bit 758 to 773
	value = ((uint32_t)(input[94] & 0x03) << 30) |
			((uint32_t)input[95] << 22) |
			((uint32_t)(input[96] & 0xfc) << 14);
	output[47] = (double)(value >> 16);

	// read output[48]: from bit 774 to 789
	value = ((uint32_t)(input[96] & 0x03) << 30) |
			((uint32_t)input[97] << 22) |
			((uint32_t)(input[98] & 0xfc) << 14);
	output[48] = (double)(value >> 16);

	// read output[49]: from bit 790 to 805
	value = ((uint32_t)(input[98] & 0x03) << 30) |
			((uint32_t)input[99] << 22) |
			((uint32_t)(input[100] & 0xfc) << 14);
	output[49] = (double)(value >> 16);

	// read output[50]: from bit 806 to 821
	value = ((uint32_t)(input[100] & 0x03) << 30) |
			((uint32_t)input[101] << 22) |
			((uint32_t)(input[102] & 0xfc) << 14);
	output[50] = (double)(value >> 16);

	// read output[51]: from bit 822 to 837
	value = ((uint32_t)(input[102] & 0x03) << 30) |
			((uint32_t)input[103] << 22) |
			((uint32_t)(input[104] & 0xfc) << 14);
	output[51] = (double)(value >> 16);

	// read output[52]: from bit 838 to 853
	value = ((uint32_t)(input[104] & 0x03) << 30) |
			((uint32_t)input[105] << 22) |
			((uint32_t)(input[106] & 0xfc) << 14);
	output[52] = (double)(value >> 16);

	// read output[53]: from bit 854 to 869
	value = ((uint32_t)(input[106] & 0x03) << 30) |
			((uint32_t)input[107] << 22) |
			((uint32_t)(input[108] & 0xfc) << 14);
	output[53] = (double)(value >> 16);
}

static void unpack_54_16bit_unsigned_6off(const uint8_t * input, double * output, void *closure) {
	// Unpack 54 values into output
	// Values are 16-bit unsigned
	// Skip 6 bits, read 864 bits of data.
	// Input must be at least 109 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 6 to 21
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)(input[2] & 0xfc) << 14);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 22 to 37
	value = ((uint32_t)(input[2] & 0x03) << 30) |
			((uint32_t)input[3] << 22) |
			((uint32_t)(input[4] & 0xfc) << 14);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 38 to 53
	value = ((uint32_t)(input[4] & 0x03) << 30) |
			((uint32_t)input[5] << 22) |
			((uint32_t)(input[6] & 0xfc) << 14);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 54 to 69
	value = ((uint32_t)(input[6] & 0x03) << 30) |
			((uint32_t)input[7] << 22) |
			((uint32_t)(input[8] & 0xfc) << 14);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 70 to 85
	value = ((uint32_t)(input[8] & 0x03) << 30) |
			((uint32_t)input[9] << 22) |
			((uint32_t)(input[10] & 0xfc) << 14);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 86 to 101
	value = ((uint32_t)(input[10] & 0x03) << 30) |
			((uint32_t)input[11] << 22) |
			((uint32_t)(input[12] & 0xfc) << 14);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 102 to 117
	value = ((uint32_t)(input[12] & 0x03) << 30) |
			((uint32_t)input[13] << 22) |
			((uint32_t)(input[14] & 0xfc) << 14);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 118 to 133
	value = ((uint32_t)(input[14] & 0x03) << 30) |
			((uint32_t)input[15] << 22) |
			((uint32_t)(input[16] & 0xfc) << 14);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 134 to 149
	value = ((uint32_t)(input[16] & 0x03) << 30) |
			((uint32_t)input[17] << 22) |
			((uint32_t)(input[18] & 0xfc) << 14);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 150 to 165
	value = ((uint32_t)(input[18] & 0x03) << 30) |
			((uint32_t)input[19] << 22) |
			((uint32_t)(input[20] & 0xfc) << 14);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 166 to 181
	value = ((uint32_t)(input[20] & 0x03) << 30) |
			((uint32_t)input[21] << 22) |
			((uint32_t)(input[22] & 0xfc) << 14);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 182 to 197
	value = ((uint32_t)(input[22] & 0x03) << 30) |
			((uint32_t)input[23] << 22) |
			((uint32_t)(input[24] & 0xfc) << 14);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 198 to 213
	value = ((uint32_t)(input[24] & 0x03) << 30) |
			((uint32_t)input[25] << 22) |
			((uint32_t)(input[26] & 0xfc) << 14);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 214 to 229
	value = ((uint32_t)(input[26] & 0x03) << 30) |
			((uint32_t)input[27] << 22) |
			((uint32_t)(input[28] & 0xfc) << 14);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 230 to 245
	value = ((uint32_t)(input[28] & 0x03) << 30) |
			((uint32_t)input[29] << 22) |
			((uint32_t)(input[30] & 0xfc) << 14);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 246 to 261
	value = ((uint32_t)(input[30] & 0x03) << 30) |
			((uint32_t)input[31] << 22) |
			((uint32_t)(input[32] & 0xfc) << 14);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 262 to 277
	value = ((uint32_t)(input[32] & 0x03) << 30) |
			((uint32_t)input[33] << 22) |
			((uint32_t)(input[34] & 0xfc) << 14);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 278 to 293
	value = ((uint32_t)(input[34] & 0x03) << 30) |
			((uint32_t)input[35] << 22) |
			((uint32_t)(input[36] & 0xfc) << 14);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 294 to 309
	value = ((uint32_t)(input[36] & 0x03) << 30) |
			((uint32_t)input[37] << 22) |
			((uint32_t)(input[38] & 0xfc) << 14);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 310 to 325
	value = ((uint32_t)(input[38] & 0x03) << 30) |
			((uint32_t)input[39] << 22) |
			((uint32_t)(input[40] & 0xfc) << 14);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 326 to 341
	value = ((uint32_t)(input[40] & 0x03) << 30) |
			((uint32_t)input[41] << 22) |
			((uint32_t)(input[42] & 0xfc) << 14);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 342 to 357
	value = ((uint32_t)(input[42] & 0x03) << 30) |
			((uint32_t)input[43] << 22) |
			((uint32_t)(input[44] & 0xfc) << 14);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 358 to 373
	value = ((uint32_t)(input[44] & 0x03) << 30) |
			((uint32_t)input[45] << 22) |
			((uint32_t)(input[46] & 0xfc) << 14);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 374 to 389
	value = ((uint32_t)(input[46] & 0x03) << 30) |
			((uint32_t)input[47] << 22) |
			((uint32_t)(input[48] & 0xfc) << 14);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 390 to 405
	value = ((uint32_t)(input[48] & 0x03) << 30) |
			((uint32_t)input[49] << 22) |
			((uint32_t)(input[50] & 0xfc) << 14);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 406 to 421
	value = ((uint32_t)(input[50] & 0x03) << 30) |
			((uint32_t)input[51] << 22) |
			((uint32_t)(input[52] & 0xfc) << 14);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 422 to 437
	value = ((uint32_t)(input[52] & 0x03) << 30) |
			((uint32_t)input[53] << 22) |
			((uint32_t)(input[54] & 0xfc) << 14);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 438 to 453
	value = ((uint32_t)(input[54] & 0x03) << 30) |
			((uint32_t)input[55] << 22) |
			((uint32_t)(input[56] & 0xfc) << 14);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 454 to 469
	value = ((uint32_t)(input[56] & 0x03) << 30) |
			((uint32_t)input[57] << 22) |
			((uint32_t)(input[58] & 0xfc) << 14);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 470 to 485
	value = ((uint32_t)(input[58] & 0x03) << 30) |
			((uint32_t)input[59] << 22) |
			((uint32_t)(input[60] & 0xfc) << 14);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 486 to 501
	value = ((uint32_t)(input[60] & 0x03) << 30) |
			((uint32_t)input[61] << 22) |
			((uint32_t)(input[62] & 0xfc) << 14);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 502 to 517
	value = ((uint32_t)(input[62] & 0x03) << 30) |
			((uint32_t)input[63] << 22) |
			((uint32_t)(input[64] & 0xfc) << 14);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 518 to 533
	value = ((uint32_t)(input[64] & 0x03) << 30) |
			((uint32_t)input[65] << 22) |
			((uint32_t)(input[66] & 0xfc) << 14);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 534 to 549
	value = ((uint32_t)(input[66] & 0x03) << 30) |
			((uint32_t)input[67] << 22) |
			((uint32_t)(input[68] & 0xfc) << 14);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 550 to 565
	value = ((uint32_t)(input[68] & 0x03) << 30) |
			((uint32_t)input[69] << 22) |
			((uint32_t)(input[70] & 0xfc) << 14);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 566 to 581
	value = ((uint32_t)(input[70] & 0x03) << 30) |
			((uint32_t)input[71] << 22) |
			((uint32_t)(input[72] & 0xfc) << 14);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 582 to 597
	value = ((uint32_t)(input[72] & 0x03) << 30) |
			((uint32_t)input[73] << 22) |
			((uint32_t)(input[74] & 0xfc) << 14);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 598 to 613
	value = ((uint32_t)(input[74] & 0x03) << 30) |
			((uint32_t)input[75] << 22) |
			((uint32_t)(input[76] & 0xfc) << 14);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 614 to 629
	value = ((uint32_t)(input[76] & 0x03) << 30) |
			((uint32_t)input[77] << 22) |
			((uint32_t)(input[78] & 0xfc) << 14);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 630 to 645
	value = ((uint32_t)(input[78] & 0x03) << 30) |
			((uint32_t)input[79] << 22) |
			((uint32_t)(input[80] & 0xfc) << 14);
	output[39] = (double)(value >> 16);

	// read output[40]: from bit 646 to 661
	value = ((uint32_t)(input[80] & 0x03) << 30) |
			((uint32_t)input[81] << 22) |
			((uint32_t)(input[82] & 0xfc) << 14);
	output[40] = (double)(value >> 16);

	// read output[41]: from bit 662 to 677
	value = ((uint32_t)(input[82] & 0x03) << 30) |
			((uint32_t)input[83] << 22) |
			((uint32_t)(input[84] & 0xfc) << 14);
	output[41] = (double)(value >> 16);

	// read output[42]: from bit 678 to 693
	value = ((uint32_t)(input[84] & 0x03) << 30) |
			((uint32_t)input[85] << 22) |
			((uint32_t)(input[86] & 0xfc) << 14);
	output[42] = (double)(value >> 16);

	// read output[43]: from bit 694 to 709
	value = ((uint32_t)(input[86] & 0x03) << 30) |
			((uint32_t)input[87] << 22) |
			((uint32_t)(input[88] & 0xfc) << 14);
	output[43] = (double)(value >> 16);

	// read output[44]: from bit 710 to 725
	value = ((uint32_t)(input[88] & 0x03) << 30) |
			((uint32_t)input[89] << 22) |
			((uint32_t)(input[90] & 0xfc) << 14);
	output[44] = (double)(value >> 16);

	// read output[45]: from bit 726 to 741
	value = ((uint32_t)(input[90] & 0x03) << 30) |
			((uint32_t)input[91] << 22) |
			((uint32_t)(input[92] & 0xfc) << 14);
	output[45] = (double)(value >> 16);

	// read output[46]: from bit 742 to 757
	value = ((uint32_t)(input[92] & 0x03) << 30) |
			((uint32_t)input[93] << 22) |
			((uint32_t)(input[94] & 0xfc) << 14);
	output[46] = (double)(value >> 16);

	// read output[47]: from bit 758 to 773
	value = ((uint32_t)(input[94] & 0x03) << 30) |
			((uint32_t)input[95] << 22) |
			((uint32_t)(input[96] & 0xfc) << 14);
	output[47] = (double)(value >> 16);

	// read output[48]: from bit 774 to 789
	value = ((uint32_t)(input[96] & 0x03) << 30) |
			((uint32_t)input[97] << 22) |
			((uint32_t)(input[98] & 0xfc) << 14);
	output[48] = (double)(value >> 16);

	// read output[49]: from bit 790 to 805
	value = ((uint32_t)(input[98] & 0x03) << 30) |
			((uint32_t)input[99] << 22) |
			((uint32_t)(input[100] & 0xfc) << 14);
	output[49] = (double)(value >> 16);

	// read output[50]: from bit 806 to 821
	value = ((uint32_t)(input[100] & 0x03) << 30) |
			((uint32_t)input[101] << 22) |
			((uint32_t)(input[102] & 0xfc) << 14);
	output[50] = (double)(value >> 16);

	// read output[51]: from bit 822 to 837
	value = ((uint32_t)(input[102] & 0x03) << 30) |
			((uint32_t)input[103] << 22) |
			((uint32_t)(input[104] & 0xfc) << 14);
	output[51] = (double)(value >> 16);

	// read output[52]: from bit 838 to 853
	value = ((uint32_t)(input[104] & 0x03) << 30) |
			((uint32_t)input[105] << 22) |
			((uint32_t)(input[106] & 0xfc) << 14);
	output[52] = (double)(value >> 16);

	// read output[53]: from bit 854 to 869
	value = ((uint32_t)(input[106] & 0x03) << 30) |
			((uint32_t)input[107] << 22) |
			((uint32_t)(input[108] & 0xfc) << 14);
	output[53] = (double)(value >> 16);
}

static void unpack_54_16bit_signed_7off(const uint8_t * input, double * output, void *closure) {
	// Unpack 54 values into output
	// Values are 16-bit signed
	// Skip 7 bits, read 864 bits of data.
	// Input must be at least 109 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 7 to 22
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)(input[2] & 0xfe) << 15);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 23 to 38
	value = ((uint32_t)(input[2] & 0x01) << 31) |
			((uint32_t)input[3] << 23) |
			((uint32_t)(input[4] & 0xfe) << 15);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 39 to 54
	value = ((uint32_t)(input[4] & 0x01) << 31) |
			((uint32_t)input[5] << 23) |
			((uint32_t)(input[6] & 0xfe) << 15);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 55 to 70
	value = ((uint32_t)(input[6] & 0x01) << 31) |
			((uint32_t)input[7] << 23) |
			((uint32_t)(input[8] & 0xfe) << 15);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 71 to 86
	value = ((uint32_t)(input[8] & 0x01) << 31) |
			((uint32_t)input[9] << 23) |
			((uint32_t)(input[10] & 0xfe) << 15);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 87 to 102
	value = ((uint32_t)(input[10] & 0x01) << 31) |
			((uint32_t)input[11] << 23) |
			((uint32_t)(input[12] & 0xfe) << 15);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 103 to 118
	value = ((uint32_t)(input[12] & 0x01) << 31) |
			((uint32_t)input[13] << 23) |
			((uint32_t)(input[14] & 0xfe) << 15);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 119 to 134
	value = ((uint32_t)(input[14] & 0x01) << 31) |
			((uint32_t)input[15] << 23) |
			((uint32_t)(input[16] & 0xfe) << 15);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 135 to 150
	value = ((uint32_t)(input[16] & 0x01) << 31) |
			((uint32_t)input[17] << 23) |
			((uint32_t)(input[18] & 0xfe) << 15);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 151 to 166
	value = ((uint32_t)(input[18] & 0x01) << 31) |
			((uint32_t)input[19] << 23) |
			((uint32_t)(input[20] & 0xfe) << 15);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 167 to 182
	value = ((uint32_t)(input[20] & 0x01) << 31) |
			((uint32_t)input[21] << 23) |
			((uint32_t)(input[22] & 0xfe) << 15);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 183 to 198
	value = ((uint32_t)(input[22] & 0x01) << 31) |
			((uint32_t)input[23] << 23) |
			((uint32_t)(input[24] & 0xfe) << 15);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 199 to 214
	value = ((uint32_t)(input[24] & 0x01) << 31) |
			((uint32_t)input[25] << 23) |
			((uint32_t)(input[26] & 0xfe) << 15);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 215 to 230
	value = ((uint32_t)(input[26] & 0x01) << 31) |
			((uint32_t)input[27] << 23) |
			((uint32_t)(input[28] & 0xfe) << 15);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 231 to 246
	value = ((uint32_t)(input[28] & 0x01) << 31) |
			((uint32_t)input[29] << 23) |
			((uint32_t)(input[30] & 0xfe) << 15);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 247 to 262
	value = ((uint32_t)(input[30] & 0x01) << 31) |
			((uint32_t)input[31] << 23) |
			((uint32_t)(input[32] & 0xfe) << 15);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 263 to 278
	value = ((uint32_t)(input[32] & 0x01) << 31) |
			((uint32_t)input[33] << 23) |
			((uint32_t)(input[34] & 0xfe) << 15);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 279 to 294
	value = ((uint32_t)(input[34] & 0x01) << 31) |
			((uint32_t)input[35] << 23) |
			((uint32_t)(input[36] & 0xfe) << 15);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 295 to 310
	value = ((uint32_t)(input[36] & 0x01) << 31) |
			((uint32_t)input[37] << 23) |
			((uint32_t)(input[38] & 0xfe) << 15);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 311 to 326
	value = ((uint32_t)(input[38] & 0x01) << 31) |
			((uint32_t)input[39] << 23) |
			((uint32_t)(input[40] & 0xfe) << 15);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 327 to 342
	value = ((uint32_t)(input[40] & 0x01) << 31) |
			((uint32_t)input[41] << 23) |
			((uint32_t)(input[42] & 0xfe) << 15);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 343 to 358
	value = ((uint32_t)(input[42] & 0x01) << 31) |
			((uint32_t)input[43] << 23) |
			((uint32_t)(input[44] & 0xfe) << 15);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 359 to 374
	value = ((uint32_t)(input[44] & 0x01) << 31) |
			((uint32_t)input[45] << 23) |
			((uint32_t)(input[46] & 0xfe) << 15);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 375 to 390
	value = ((uint32_t)(input[46] & 0x01) << 31) |
			((uint32_t)input[47] << 23) |
			((uint32_t)(input[48] & 0xfe) << 15);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 391 to 406
	value = ((uint32_t)(input[48] & 0x01) << 31) |
			((uint32_t)input[49] << 23) |
			((uint32_t)(input[50] & 0xfe) << 15);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 407 to 422
	value = ((uint32_t)(input[50] & 0x01) << 31) |
			((uint32_t)input[51] << 23) |
			((uint32_t)(input[52] & 0xfe) << 15);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 423 to 438
	value = ((uint32_t)(input[52] & 0x01) << 31) |
			((uint32_t)input[53] << 23) |
			((uint32_t)(input[54] & 0xfe) << 15);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 439 to 454
	value = ((uint32_t)(input[54] & 0x01) << 31) |
			((uint32_t)input[55] << 23) |
			((uint32_t)(input[56] & 0xfe) << 15);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 455 to 470
	value = ((uint32_t)(input[56] & 0x01) << 31) |
			((uint32_t)input[57] << 23) |
			((uint32_t)(input[58] & 0xfe) << 15);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 471 to 486
	value = ((uint32_t)(input[58] & 0x01) << 31) |
			((uint32_t)input[59] << 23) |
			((uint32_t)(input[60] & 0xfe) << 15);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 487 to 502
	value = ((uint32_t)(input[60] & 0x01) << 31) |
			((uint32_t)input[61] << 23) |
			((uint32_t)(input[62] & 0xfe) << 15);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 503 to 518
	value = ((uint32_t)(input[62] & 0x01) << 31) |
			((uint32_t)input[63] << 23) |
			((uint32_t)(input[64] & 0xfe) << 15);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 519 to 534
	value = ((uint32_t)(input[64] & 0x01) << 31) |
			((uint32_t)input[65] << 23) |
			((uint32_t)(input[66] & 0xfe) << 15);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 535 to 550
	value = ((uint32_t)(input[66] & 0x01) << 31) |
			((uint32_t)input[67] << 23) |
			((uint32_t)(input[68] & 0xfe) << 15);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 551 to 566
	value = ((uint32_t)(input[68] & 0x01) << 31) |
			((uint32_t)input[69] << 23) |
			((uint32_t)(input[70] & 0xfe) << 15);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 567 to 582
	value = ((uint32_t)(input[70] & 0x01) << 31) |
			((uint32_t)input[71] << 23) |
			((uint32_t)(input[72] & 0xfe) << 15);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 583 to 598
	value = ((uint32_t)(input[72] & 0x01) << 31) |
			((uint32_t)input[73] << 23) |
			((uint32_t)(input[74] & 0xfe) << 15);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 599 to 614
	value = ((uint32_t)(input[74] & 0x01) << 31) |
			((uint32_t)input[75] << 23) |
			((uint32_t)(input[76] & 0xfe) << 15);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 615 to 630
	value = ((uint32_t)(input[76] & 0x01) << 31) |
			((uint32_t)input[77] << 23) |
			((uint32_t)(input[78] & 0xfe) << 15);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 631 to 646
	value = ((uint32_t)(input[78] & 0x01) << 31) |
			((uint32_t)input[79] << 23) |
			((uint32_t)(input[80] & 0xfe) << 15);
	output[39] = (double)(value >> 16);

	// read output[40]: from bit 647 to 662
	value = ((uint32_t)(input[80] & 0x01) << 31) |
			((uint32_t)input[81] << 23) |
			((uint32_t)(input[82] & 0xfe) << 15);
	output[40] = (double)(value >> 16);

	// read output[41]: from bit 663 to 678
	value = ((uint32_t)(input[82] & 0x01) << 31) |
			((uint32_t)input[83] << 23) |
			((uint32_t)(input[84] & 0xfe) << 15);
	output[41] = (double)(value >> 16);

	// read output[42]: from bit 679 to 694
	value = ((uint32_t)(input[84] & 0x01) << 31) |
			((uint32_t)input[85] << 23) |
			((uint32_t)(input[86] & 0xfe) << 15);
	output[42] = (double)(value >> 16);

	// read output[43]: from bit 695 to 710
	value = ((uint32_t)(input[86] & 0x01) << 31) |
			((uint32_t)input[87] << 23) |
			((uint32_t)(input[88] & 0xfe) << 15);
	output[43] = (double)(value >> 16);

	// read output[44]: from bit 711 to 726
	value = ((uint32_t)(input[88] & 0x01) << 31) |
			((uint32_t)input[89] << 23) |
			((uint32_t)(input[90] & 0xfe) << 15);
	output[44] = (double)(value >> 16);

	// read output[45]: from bit 727 to 742
	value = ((uint32_t)(input[90] & 0x01) << 31) |
			((uint32_t)input[91] << 23) |
			((uint32_t)(input[92] & 0xfe) << 15);
	output[45] = (double)(value >> 16);

	// read output[46]: from bit 743 to 758
	value = ((uint32_t)(input[92] & 0x01) << 31) |
			((uint32_t)input[93] << 23) |
			((uint32_t)(input[94] & 0xfe) << 15);
	output[46] = (double)(value >> 16);

	// read output[47]: from bit 759 to 774
	value = ((uint32_t)(input[94] & 0x01) << 31) |
			((uint32_t)input[95] << 23) |
			((uint32_t)(input[96] & 0xfe) << 15);
	output[47] = (double)(value >> 16);

	// read output[48]: from bit 775 to 790
	value = ((uint32_t)(input[96] & 0x01) << 31) |
			((uint32_t)input[97] << 23) |
			((uint32_t)(input[98] & 0xfe) << 15);
	output[48] = (double)(value >> 16);

	// read output[49]: from bit 791 to 806
	value = ((uint32_t)(input[98] & 0x01) << 31) |
			((uint32_t)input[99] << 23) |
			((uint32_t)(input[100] & 0xfe) << 15);
	output[49] = (double)(value >> 16);

	// read output[50]: from bit 807 to 822
	value = ((uint32_t)(input[100] & 0x01) << 31) |
			((uint32_t)input[101] << 23) |
			((uint32_t)(input[102] & 0xfe) << 15);
	output[50] = (double)(value >> 16);

	// read output[51]: from bit 823 to 838
	value = ((uint32_t)(input[102] & 0x01) << 31) |
			((uint32_t)input[103] << 23) |
			((uint32_t)(input[104] & 0xfe) << 15);
	output[51] = (double)(value >> 16);

	// read output[52]: from bit 839 to 854
	value = ((uint32_t)(input[104] & 0x01) << 31) |
			((uint32_t)input[105] << 23) |
			((uint32_t)(input[106] & 0xfe) << 15);
	output[52] = (double)(value >> 16);

	// read output[53]: from bit 855 to 870
	value = ((uint32_t)(input[106] & 0x01) << 31) |
			((uint32_t)input[107] << 23) |
			((uint32_t)(input[108] & 0xfe) << 15);
	output[53] = (double)(value >> 16);
}

static void unpack_54_16bit_unsigned_7off(const uint8_t * input, double * output, void *closure) {
	// Unpack 54 values into output
	// Values are 16-bit unsigned
	// Skip 7 bits, read 864 bits of data.
	// Input must be at least 109 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 7 to 22
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)(input[2] & 0xfe) << 15);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 23 to 38
	value = ((uint32_t)(input[2] & 0x01) << 31) |
			((uint32_t)input[3] << 23) |
			((uint32_t)(input[4] & 0xfe) << 15);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 39 to 54
	value = ((uint32_t)(input[4] & 0x01) << 31) |
			((uint32_t)input[5] << 23) |
			((uint32_t)(input[6] & 0xfe) << 15);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 55 to 70
	value = ((uint32_t)(input[6] & 0x01) << 31) |
			((uint32_t)input[7] << 23) |
			((uint32_t)(input[8] & 0xfe) << 15);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 71 to 86
	value = ((uint32_t)(input[8] & 0x01) << 31) |
			((uint32_t)input[9] << 23) |
			((uint32_t)(input[10] & 0xfe) << 15);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 87 to 102
	value = ((uint32_t)(input[10] & 0x01) << 31) |
			((uint32_t)input[11] << 23) |
			((uint32_t)(input[12] & 0xfe) << 15);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 103 to 118
	value = ((uint32_t)(input[12] & 0x01) << 31) |
			((uint32_t)input[13] << 23) |
			((uint32_t)(input[14] & 0xfe) << 15);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 119 to 134
	value = ((uint32_t)(input[14] & 0x01) << 31) |
			((uint32_t)input[15] << 23) |
			((uint32_t)(input[16] & 0xfe) << 15);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 135 to 150
	value = ((uint32_t)(input[16] & 0x01) << 31) |
			((uint32_t)input[17] << 23) |
			((uint32_t)(input[18] & 0xfe) << 15);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 151 to 166
	value = ((uint32_t)(input[18] & 0x01) << 31) |
			((uint32_t)input[19] << 23) |
			((uint32_t)(input[20] & 0xfe) << 15);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 167 to 182
	value = ((uint32_t)(input[20] & 0x01) << 31) |
			((uint32_t)input[21] << 23) |
			((uint32_t)(input[22] & 0xfe) << 15);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 183 to 198
	value = ((uint32_t)(input[22] & 0x01) << 31) |
			((uint32_t)input[23] << 23) |
			((uint32_t)(input[24] & 0xfe) << 15);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 199 to 214
	value = ((uint32_t)(input[24] & 0x01) << 31) |
			((uint32_t)input[25] << 23) |
			((uint32_t)(input[26] & 0xfe) << 15);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 215 to 230
	value = ((uint32_t)(input[26] & 0x01) << 31) |
			((uint32_t)input[27] << 23) |
			((uint32_t)(input[28] & 0xfe) << 15);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 231 to 246
	value = ((uint32_t)(input[28] & 0x01) << 31) |
			((uint32_t)input[29] << 23) |
			((uint32_t)(input[30] & 0xfe) << 15);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 247 to 262
	value = ((uint32_t)(input[30] & 0x01) << 31) |
			((uint32_t)input[31] << 23) |
			((uint32_t)(input[32] & 0xfe) << 15);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 263 to 278
	value = ((uint32_t)(input[32] & 0x01) << 31) |
			((uint32_t)input[33] << 23) |
			((uint32_t)(input[34] & 0xfe) << 15);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 279 to 294
	value = ((uint32_t)(input[34] & 0x01) << 31) |
			((uint32_t)input[35] << 23) |
			((uint32_t)(input[36] & 0xfe) << 15);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 295 to 310
	value = ((uint32_t)(input[36] & 0x01) << 31) |
			((uint32_t)input[37] << 23) |
			((uint32_t)(input[38] & 0xfe) << 15);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 311 to 326
	value = ((uint32_t)(input[38] & 0x01) << 31) |
			((uint32_t)input[39] << 23) |
			((uint32_t)(input[40] & 0xfe) << 15);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 327 to 342
	value = ((uint32_t)(input[40] & 0x01) << 31) |
			((uint32_t)input[41] << 23) |
			((uint32_t)(input[42] & 0xfe) << 15);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 343 to 358
	value = ((uint32_t)(input[42] & 0x01) << 31) |
			((uint32_t)input[43] << 23) |
			((uint32_t)(input[44] & 0xfe) << 15);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 359 to 374
	value = ((uint32_t)(input[44] & 0x01) << 31) |
			((uint32_t)input[45] << 23) |
			((uint32_t)(input[46] & 0xfe) << 15);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 375 to 390
	value = ((uint32_t)(input[46] & 0x01) << 31) |
			((uint32_t)input[47] << 23) |
			((uint32_t)(input[48] & 0xfe) << 15);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 391 to 406
	value = ((uint32_t)(input[48] & 0x01) << 31) |
			((uint32_t)input[49] << 23) |
			((uint32_t)(input[50] & 0xfe) << 15);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 407 to 422
	value = ((uint32_t)(input[50] & 0x01) << 31) |
			((uint32_t)input[51] << 23) |
			((uint32_t)(input[52] & 0xfe) << 15);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 423 to 438
	value = ((uint32_t)(input[52] & 0x01) << 31) |
			((uint32_t)input[53] << 23) |
			((uint32_t)(input[54] & 0xfe) << 15);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 439 to 454
	value = ((uint32_t)(input[54] & 0x01) << 31) |
			((uint32_t)input[55] << 23) |
			((uint32_t)(input[56] & 0xfe) << 15);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 455 to 470
	value = ((uint32_t)(input[56] & 0x01) << 31) |
			((uint32_t)input[57] << 23) |
			((uint32_t)(input[58] & 0xfe) << 15);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 471 to 486
	value = ((uint32_t)(input[58] & 0x01) << 31) |
			((uint32_t)input[59] << 23) |
			((uint32_t)(input[60] & 0xfe) << 15);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 487 to 502
	value = ((uint32_t)(input[60] & 0x01) << 31) |
			((uint32_t)input[61] << 23) |
			((uint32_t)(input[62] & 0xfe) << 15);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 503 to 518
	value = ((uint32_t)(input[62] & 0x01) << 31) |
			((uint32_t)input[63] << 23) |
			((uint32_t)(input[64] & 0xfe) << 15);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 519 to 534
	value = ((uint32_t)(input[64] & 0x01) << 31) |
			((uint32_t)input[65] << 23) |
			((uint32_t)(input[66] & 0xfe) << 15);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 535 to 550
	value = ((uint32_t)(input[66] & 0x01) << 31) |
			((uint32_t)input[67] << 23) |
			((uint32_t)(input[68] & 0xfe) << 15);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 551 to 566
	value = ((uint32_t)(input[68] & 0x01) << 31) |
			((uint32_t)input[69] << 23) |
			((uint32_t)(input[70] & 0xfe) << 15);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 567 to 582
	value = ((uint32_t)(input[70] & 0x01) << 31) |
			((uint32_t)input[71] << 23) |
			((uint32_t)(input[72] & 0xfe) << 15);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 583 to 598
	value = ((uint32_t)(input[72] & 0x01) << 31) |
			((uint32_t)input[73] << 23) |
			((uint32_t)(input[74] & 0xfe) << 15);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 599 to 614
	value = ((uint32_t)(input[74] & 0x01) << 31) |
			((uint32_t)input[75] << 23) |
			((uint32_t)(input[76] & 0xfe) << 15);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 615 to 630
	value = ((uint32_t)(input[76] & 0x01) << 31) |
			((uint32_t)input[77] << 23) |
			((uint32_t)(input[78] & 0xfe) << 15);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 631 to 646
	value = ((uint32_t)(input[78] & 0x01) << 31) |
			((uint32_t)input[79] << 23) |
			((uint32_t)(input[80] & 0xfe) << 15);
	output[39] = (double)(value >> 16);

	// read output[40]: from bit 647 to 662
	value = ((uint32_t)(input[80] & 0x01) << 31) |
			((uint32_t)input[81] << 23) |
			((uint32_t)(input[82] & 0xfe) << 15);
	output[40] = (double)(value >> 16);

	// read output[41]: from bit 663 to 678
	value = ((uint32_t)(input[82] & 0x01) << 31) |
			((uint32_t)input[83] << 23) |
			((uint32_t)(input[84] & 0xfe) << 15);
	output[41] = (double)(value >> 16);

	// read output[42]: from bit 679 to 694
	value = ((uint32_t)(input[84] & 0x01) << 31) |
			((uint32_t)input[85] << 23) |
			((uint32_t)(input[86] & 0xfe) << 15);
	output[42] = (double)(value >> 16);

	// read output[43]: from bit 695 to 710
	value = ((uint32_t)(input[86] & 0x01) << 31) |
			((uint32_t)input[87] << 23) |
			((uint32_t)(input[88] & 0xfe) << 15);
	output[43] = (double)(value >> 16);

	// read output[44]: from bit 711 to 726
	value = ((uint32_t)(input[88] & 0x01) << 31) |
			((uint32_t)input[89] << 23) |
			((uint32_t)(input[90] & 0xfe) << 15);
	output[44] = (double)(value >> 16);

	// read output[45]: from bit 727 to 742
	value = ((uint32_t)(input[90] & 0x01) << 31) |
			((uint32_t)input[91] << 23) |
			((uint32_t)(input[92] & 0xfe) << 15);
	output[45] = (double)(value >> 16);

	// read output[46]: from bit 743 to 758
	value = ((uint32_t)(input[92] & 0x01) << 31) |
			((uint32_t)input[93] << 23) |
			((uint32_t)(input[94] & 0xfe) << 15);
	output[46] = (double)(value >> 16);

	// read output[47]: from bit 759 to 774
	value = ((uint32_t)(input[94] & 0x01) << 31) |
			((uint32_t)input[95] << 23) |
			((uint32_t)(input[96] & 0xfe) << 15);
	output[47] = (double)(value >> 16);

	// read output[48]: from bit 775 to 790
	value = ((uint32_t)(input[96] & 0x01) << 31) |
			((uint32_t)input[97] << 23) |
			((uint32_t)(input[98] & 0xfe) << 15);
	output[48] = (double)(value >> 16);

	// read output[49]: from bit 791 to 806
	value = ((uint32_t)(input[98] & 0x01) << 31) |
			((uint32_t)input[99] << 23) |
			((uint32_t)(input[100] & 0xfe) << 15);
	output[49] = (double)(value >> 16);

	// read output[50]: from bit 807 to 822
	value = ((uint32_t)(input[100] & 0x01) << 31) |
			((uint32_t)input[101] << 23) |
			((uint32_t)(input[102] & 0xfe) << 15);
	output[50] = (double)(value >> 16);

	// read output[51]: from bit 823 to 838
	value = ((uint32_t)(input[102] & 0x01) << 31) |
			((uint32_t)input[103] << 23) |
			((uint32_t)(input[104] & 0xfe) << 15);
	output[51] = (double)(value >> 16);

	// read output[52]: from bit 839 to 854
	value = ((uint32_t)(input[104] & 0x01) << 31) |
			((uint32_t)input[105] << 23) |
			((uint32_t)(input[106] & 0xfe) << 15);
	output[52] = (double)(value >> 16);

	// read output[53]: from bit 855 to 870
	value = ((uint32_t)(input[106] & 0x01) << 31) |
			((uint32_t)input[107] << 23) |
			((uint32_t)(input[108] & 0xfe) << 15);
	output[53] = (double)(value >> 16);
}

static void unpack_55_16bit_signed_0off(const uint8_t * input, double * output, void *closure) {
	// Unpack 55 values into output
	// Values are 16-bit signed
	// Skip 0 bits, read 880 bits of data.
	// Input must be at least 110 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 0 to 15
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)input[1] << 16);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 16 to 31
	value = ((uint32_t)input[2] << 24) |
			((uint32_t)input[3] << 16);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 32 to 47
	value = ((uint32_t)input[4] << 24) |
			((uint32_t)input[5] << 16);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 48 to 63
	value = ((uint32_t)input[6] << 24) |
			((uint32_t)input[7] << 16);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 64 to 79
	value = ((uint32_t)input[8] << 24) |
			((uint32_t)input[9] << 16);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 80 to 95
	value = ((uint32_t)input[10] << 24) |
			((uint32_t)input[11] << 16);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 96 to 111
	value = ((uint32_t)input[12] << 24) |
			((uint32_t)input[13] << 16);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 112 to 127
	value = ((uint32_t)input[14] << 24) |
			((uint32_t)input[15] << 16);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 128 to 143
	value = ((uint32_t)input[16] << 24) |
			((uint32_t)input[17] << 16);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 144 to 159
	value = ((uint32_t)input[18] << 24) |
			((uint32_t)input[19] << 16);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 160 to 175
	value = ((uint32_t)input[20] << 24) |
			((uint32_t)input[21] << 16);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 176 to 191
	value = ((uint32_t)input[22] << 24) |
			((uint32_t)input[23] << 16);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 192 to 207
	value = ((uint32_t)input[24] << 24) |
			((uint32_t)input[25] << 16);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 208 to 223
	value = ((uint32_t)input[26] << 24) |
			((uint32_t)input[27] << 16);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 224 to 239
	value = ((uint32_t)input[28] << 24) |
			((uint32_t)input[29] << 16);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 240 to 255
	value = ((uint32_t)input[30] << 24) |
			((uint32_t)input[31] << 16);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 256 to 271
	value = ((uint32_t)input[32] << 24) |
			((uint32_t)input[33] << 16);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 272 to 287
	value = ((uint32_t)input[34] << 24) |
			((uint32_t)input[35] << 16);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 288 to 303
	value = ((uint32_t)input[36] << 24) |
			((uint32_t)input[37] << 16);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 304 to 319
	value = ((uint32_t)input[38] << 24) |
			((uint32_t)input[39] << 16);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 320 to 335
	value = ((uint32_t)input[40] << 24) |
			((uint32_t)input[41] << 16);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 336 to 351
	value = ((uint32_t)input[42] << 24) |
			((uint32_t)input[43] << 16);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 352 to 367
	value = ((uint32_t)input[44] << 24) |
			((uint32_t)input[45] << 16);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 368 to 383
	value = ((uint32_t)input[46] << 24) |
			((uint32_t)input[47] << 16);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 384 to 399
	value = ((uint32_t)input[48] << 24) |
			((uint32_t)input[49] << 16);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 400 to 415
	value = ((uint32_t)input[50] << 24) |
			((uint32_t)input[51] << 16);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 416 to 431
	value = ((uint32_t)input[52] << 24) |
			((uint32_t)input[53] << 16);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 432 to 447
	value = ((uint32_t)input[54] << 24) |
			((uint32_t)input[55] << 16);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 448 to 463
	value = ((uint32_t)input[56] << 24) |
			((uint32_t)input[57] << 16);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 464 to 479
	value = ((uint32_t)input[58] << 24) |
			((uint32_t)input[59] << 16);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 480 to 495
	value = ((uint32_t)input[60] << 24) |
			((uint32_t)input[61] << 16);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 496 to 511
	value = ((uint32_t)input[62] << 24) |
			((uint32_t)input[63] << 16);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 512 to 527
	value = ((uint32_t)input[64] << 24) |
			((uint32_t)input[65] << 16);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 528 to 543
	value = ((uint32_t)input[66] << 24) |
			((uint32_t)input[67] << 16);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 544 to 559
	value = ((uint32_t)input[68] << 24) |
			((uint32_t)input[69] << 16);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 560 to 575
	value = ((uint32_t)input[70] << 24) |
			((uint32_t)input[71] << 16);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 576 to 591
	value = ((uint32_t)input[72] << 24) |
			((uint32_t)input[73] << 16);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 592 to 607
	value = ((uint32_t)input[74] << 24) |
			((uint32_t)input[75] << 16);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 608 to 623
	value = ((uint32_t)input[76] << 24) |
			((uint32_t)input[77] << 16);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 624 to 639
	value = ((uint32_t)input[78] << 24) |
			((uint32_t)input[79] << 16);
	output[39] = (double)(value >> 16);

	// read output[40]: from bit 640 to 655
	value = ((uint32_t)input[80] << 24) |
			((uint32_t)input[81] << 16);
	output[40] = (double)(value >> 16);

	// read output[41]: from bit 656 to 671
	value = ((uint32_t)input[82] << 24) |
			((uint32_t)input[83] << 16);
	output[41] = (double)(value >> 16);

	// read output[42]: from bit 672 to 687
	value = ((uint32_t)input[84] << 24) |
			((uint32_t)input[85] << 16);
	output[42] = (double)(value >> 16);

	// read output[43]: from bit 688 to 703
	value = ((uint32_t)input[86] << 24) |
			((uint32_t)input[87] << 16);
	output[43] = (double)(value >> 16);

	// read output[44]: from bit 704 to 719
	value = ((uint32_t)input[88] << 24) |
			((uint32_t)input[89] << 16);
	output[44] = (double)(value >> 16);

	// read output[45]: from bit 720 to 735
	value = ((uint32_t)input[90] << 24) |
			((uint32_t)input[91] << 16);
	output[45] = (double)(value >> 16);

	// read output[46]: from bit 736 to 751
	value = ((uint32_t)input[92] << 24) |
			((uint32_t)input[93] << 16);
	output[46] = (double)(value >> 16);

	// read output[47]: from bit 752 to 767
	value = ((uint32_t)input[94] << 24) |
			((uint32_t)input[95] << 16);
	output[47] = (double)(value >> 16);

	// read output[48]: from bit 768 to 783
	value = ((uint32_t)input[96] << 24) |
			((uint32_t)input[97] << 16);
	output[48] = (double)(value >> 16);

	// read output[49]: from bit 784 to 799
	value = ((uint32_t)input[98] << 24) |
			((uint32_t)input[99] << 16);
	output[49] = (double)(value >> 16);

	// read output[50]: from bit 800 to 815
	value = ((uint32_t)input[100] << 24) |
			((uint32_t)input[101] << 16);
	output[50] = (double)(value >> 16);

	// read output[51]: from bit 816 to 831
	value = ((uint32_t)input[102] << 24) |
			((uint32_t)input[103] << 16);
	output[51] = (double)(value >> 16);

	// read output[52]: from bit 832 to 847
	value = ((uint32_t)input[104] << 24) |
			((uint32_t)input[105] << 16);
	output[52] = (double)(value >> 16);

	// read output[53]: from bit 848 to 863
	value = ((uint32_t)input[106] << 24) |
			((uint32_t)input[107] << 16);
	output[53] = (double)(value >> 16);

	// read output[54]: from bit 864 to 879
	value = ((uint32_t)input[108] << 24) |
			((uint32_t)input[109] << 16);
	output[54] = (double)(value >> 16);
}

static void unpack_55_16bit_unsigned_0off(const uint8_t * input, double * output, void *closure) {
	// Unpack 55 values into output
	// Values are 16-bit unsigned
	// Skip 0 bits, read 880 bits of data.
	// Input must be at least 110 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 0 to 15
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)input[1] << 16);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 16 to 31
	value = ((uint32_t)input[2] << 24) |
			((uint32_t)input[3] << 16);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 32 to 47
	value = ((uint32_t)input[4] << 24) |
			((uint32_t)input[5] << 16);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 48 to 63
	value = ((uint32_t)input[6] << 24) |
			((uint32_t)input[7] << 16);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 64 to 79
	value = ((uint32_t)input[8] << 24) |
			((uint32_t)input[9] << 16);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 80 to 95
	value = ((uint32_t)input[10] << 24) |
			((uint32_t)input[11] << 16);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 96 to 111
	value = ((uint32_t)input[12] << 24) |
			((uint32_t)input[13] << 16);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 112 to 127
	value = ((uint32_t)input[14] << 24) |
			((uint32_t)input[15] << 16);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 128 to 143
	value = ((uint32_t)input[16] << 24) |
			((uint32_t)input[17] << 16);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 144 to 159
	value = ((uint32_t)input[18] << 24) |
			((uint32_t)input[19] << 16);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 160 to 175
	value = ((uint32_t)input[20] << 24) |
			((uint32_t)input[21] << 16);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 176 to 191
	value = ((uint32_t)input[22] << 24) |
			((uint32_t)input[23] << 16);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 192 to 207
	value = ((uint32_t)input[24] << 24) |
			((uint32_t)input[25] << 16);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 208 to 223
	value = ((uint32_t)input[26] << 24) |
			((uint32_t)input[27] << 16);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 224 to 239
	value = ((uint32_t)input[28] << 24) |
			((uint32_t)input[29] << 16);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 240 to 255
	value = ((uint32_t)input[30] << 24) |
			((uint32_t)input[31] << 16);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 256 to 271
	value = ((uint32_t)input[32] << 24) |
			((uint32_t)input[33] << 16);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 272 to 287
	value = ((uint32_t)input[34] << 24) |
			((uint32_t)input[35] << 16);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 288 to 303
	value = ((uint32_t)input[36] << 24) |
			((uint32_t)input[37] << 16);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 304 to 319
	value = ((uint32_t)input[38] << 24) |
			((uint32_t)input[39] << 16);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 320 to 335
	value = ((uint32_t)input[40] << 24) |
			((uint32_t)input[41] << 16);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 336 to 351
	value = ((uint32_t)input[42] << 24) |
			((uint32_t)input[43] << 16);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 352 to 367
	value = ((uint32_t)input[44] << 24) |
			((uint32_t)input[45] << 16);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 368 to 383
	value = ((uint32_t)input[46] << 24) |
			((uint32_t)input[47] << 16);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 384 to 399
	value = ((uint32_t)input[48] << 24) |
			((uint32_t)input[49] << 16);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 400 to 415
	value = ((uint32_t)input[50] << 24) |
			((uint32_t)input[51] << 16);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 416 to 431
	value = ((uint32_t)input[52] << 24) |
			((uint32_t)input[53] << 16);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 432 to 447
	value = ((uint32_t)input[54] << 24) |
			((uint32_t)input[55] << 16);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 448 to 463
	value = ((uint32_t)input[56] << 24) |
			((uint32_t)input[57] << 16);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 464 to 479
	value = ((uint32_t)input[58] << 24) |
			((uint32_t)input[59] << 16);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 480 to 495
	value = ((uint32_t)input[60] << 24) |
			((uint32_t)input[61] << 16);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 496 to 511
	value = ((uint32_t)input[62] << 24) |
			((uint32_t)input[63] << 16);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 512 to 527
	value = ((uint32_t)input[64] << 24) |
			((uint32_t)input[65] << 16);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 528 to 543
	value = ((uint32_t)input[66] << 24) |
			((uint32_t)input[67] << 16);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 544 to 559
	value = ((uint32_t)input[68] << 24) |
			((uint32_t)input[69] << 16);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 560 to 575
	value = ((uint32_t)input[70] << 24) |
			((uint32_t)input[71] << 16);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 576 to 591
	value = ((uint32_t)input[72] << 24) |
			((uint32_t)input[73] << 16);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 592 to 607
	value = ((uint32_t)input[74] << 24) |
			((uint32_t)input[75] << 16);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 608 to 623
	value = ((uint32_t)input[76] << 24) |
			((uint32_t)input[77] << 16);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 624 to 639
	value = ((uint32_t)input[78] << 24) |
			((uint32_t)input[79] << 16);
	output[39] = (double)(value >> 16);

	// read output[40]: from bit 640 to 655
	value = ((uint32_t)input[80] << 24) |
			((uint32_t)input[81] << 16);
	output[40] = (double)(value >> 16);

	// read output[41]: from bit 656 to 671
	value = ((uint32_t)input[82] << 24) |
			((uint32_t)input[83] << 16);
	output[41] = (double)(value >> 16);

	// read output[42]: from bit 672 to 687
	value = ((uint32_t)input[84] << 24) |
			((uint32_t)input[85] << 16);
	output[42] = (double)(value >> 16);

	// read output[43]: from bit 688 to 703
	value = ((uint32_t)input[86] << 24) |
			((uint32_t)input[87] << 16);
	output[43] = (double)(value >> 16);

	// read output[44]: from bit 704 to 719
	value = ((uint32_t)input[88] << 24) |
			((uint32_t)input[89] << 16);
	output[44] = (double)(value >> 16);

	// read output[45]: from bit 720 to 735
	value = ((uint32_t)input[90] << 24) |
			((uint32_t)input[91] << 16);
	output[45] = (double)(value >> 16);

	// read output[46]: from bit 736 to 751
	value = ((uint32_t)input[92] << 24) |
			((uint32_t)input[93] << 16);
	output[46] = (double)(value >> 16);

	// read output[47]: from bit 752 to 767
	value = ((uint32_t)input[94] << 24) |
			((uint32_t)input[95] << 16);
	output[47] = (double)(value >> 16);

	// read output[48]: from bit 768 to 783
	value = ((uint32_t)input[96] << 24) |
			((uint32_t)input[97] << 16);
	output[48] = (double)(value >> 16);

	// read output[49]: from bit 784 to 799
	value = ((uint32_t)input[98] << 24) |
			((uint32_t)input[99] << 16);
	output[49] = (double)(value >> 16);

	// read output[50]: from bit 800 to 815
	value = ((uint32_t)input[100] << 24) |
			((uint32_t)input[101] << 16);
	output[50] = (double)(value >> 16);

	// read output[51]: from bit 816 to 831
	value = ((uint32_t)input[102] << 24) |
			((uint32_t)input[103] << 16);
	output[51] = (double)(value >> 16);

	// read output[52]: from bit 832 to 847
	value = ((uint32_t)input[104] << 24) |
			((uint32_t)input[105] << 16);
	output[52] = (double)(value >> 16);

	// read output[53]: from bit 848 to 863
	value = ((uint32_t)input[106] << 24) |
			((uint32_t)input[107] << 16);
	output[53] = (double)(value >> 16);

	// read output[54]: from bit 864 to 879
	value = ((uint32_t)input[108] << 24) |
			((uint32_t)input[109] << 16);
	output[54] = (double)(value >> 16);
}

static void unpack_55_16bit_signed_1off(const uint8_t * input, double * output, void *closure) {
	// Unpack 55 values into output
	// Values are 16-bit signed
	// Skip 1 bits, read 880 bits of data.
	// Input must be at least 111 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 1 to 16
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)input[1] << 17) |
			((uint32_t)(input[2] & 0x80) << 9);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 17 to 32
	value = ((uint32_t)(input[2] & 0x7f) << 25) |
			((uint32_t)input[3] << 17) |
			((uint32_t)(input[4] & 0x80) << 9);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 33 to 48
	value = ((uint32_t)(input[4] & 0x7f) << 25) |
			((uint32_t)input[5] << 17) |
			((uint32_t)(input[6] & 0x80) << 9);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 49 to 64
	value = ((uint32_t)(input[6] & 0x7f) << 25) |
			((uint32_t)input[7] << 17) |
			((uint32_t)(input[8] & 0x80) << 9);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 65 to 80
	value = ((uint32_t)(input[8] & 0x7f) << 25) |
			((uint32_t)input[9] << 17) |
			((uint32_t)(input[10] & 0x80) << 9);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 81 to 96
	value = ((uint32_t)(input[10] & 0x7f) << 25) |
			((uint32_t)input[11] << 17) |
			((uint32_t)(input[12] & 0x80) << 9);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 97 to 112
	value = ((uint32_t)(input[12] & 0x7f) << 25) |
			((uint32_t)input[13] << 17) |
			((uint32_t)(input[14] & 0x80) << 9);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 113 to 128
	value = ((uint32_t)(input[14] & 0x7f) << 25) |
			((uint32_t)input[15] << 17) |
			((uint32_t)(input[16] & 0x80) << 9);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 129 to 144
	value = ((uint32_t)(input[16] & 0x7f) << 25) |
			((uint32_t)input[17] << 17) |
			((uint32_t)(input[18] & 0x80) << 9);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 145 to 160
	value = ((uint32_t)(input[18] & 0x7f) << 25) |
			((uint32_t)input[19] << 17) |
			((uint32_t)(input[20] & 0x80) << 9);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 161 to 176
	value = ((uint32_t)(input[20] & 0x7f) << 25) |
			((uint32_t)input[21] << 17) |
			((uint32_t)(input[22] & 0x80) << 9);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 177 to 192
	value = ((uint32_t)(input[22] & 0x7f) << 25) |
			((uint32_t)input[23] << 17) |
			((uint32_t)(input[24] & 0x80) << 9);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 193 to 208
	value = ((uint32_t)(input[24] & 0x7f) << 25) |
			((uint32_t)input[25] << 17) |
			((uint32_t)(input[26] & 0x80) << 9);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 209 to 224
	value = ((uint32_t)(input[26] & 0x7f) << 25) |
			((uint32_t)input[27] << 17) |
			((uint32_t)(input[28] & 0x80) << 9);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 225 to 240
	value = ((uint32_t)(input[28] & 0x7f) << 25) |
			((uint32_t)input[29] << 17) |
			((uint32_t)(input[30] & 0x80) << 9);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 241 to 256
	value = ((uint32_t)(input[30] & 0x7f) << 25) |
			((uint32_t)input[31] << 17) |
			((uint32_t)(input[32] & 0x80) << 9);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 257 to 272
	value = ((uint32_t)(input[32] & 0x7f) << 25) |
			((uint32_t)input[33] << 17) |
			((uint32_t)(input[34] & 0x80) << 9);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 273 to 288
	value = ((uint32_t)(input[34] & 0x7f) << 25) |
			((uint32_t)input[35] << 17) |
			((uint32_t)(input[36] & 0x80) << 9);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 289 to 304
	value = ((uint32_t)(input[36] & 0x7f) << 25) |
			((uint32_t)input[37] << 17) |
			((uint32_t)(input[38] & 0x80) << 9);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 305 to 320
	value = ((uint32_t)(input[38] & 0x7f) << 25) |
			((uint32_t)input[39] << 17) |
			((uint32_t)(input[40] & 0x80) << 9);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 321 to 336
	value = ((uint32_t)(input[40] & 0x7f) << 25) |
			((uint32_t)input[41] << 17) |
			((uint32_t)(input[42] & 0x80) << 9);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 337 to 352
	value = ((uint32_t)(input[42] & 0x7f) << 25) |
			((uint32_t)input[43] << 17) |
			((uint32_t)(input[44] & 0x80) << 9);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 353 to 368
	value = ((uint32_t)(input[44] & 0x7f) << 25) |
			((uint32_t)input[45] << 17) |
			((uint32_t)(input[46] & 0x80) << 9);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 369 to 384
	value = ((uint32_t)(input[46] & 0x7f) << 25) |
			((uint32_t)input[47] << 17) |
			((uint32_t)(input[48] & 0x80) << 9);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 385 to 400
	value = ((uint32_t)(input[48] & 0x7f) << 25) |
			((uint32_t)input[49] << 17) |
			((uint32_t)(input[50] & 0x80) << 9);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 401 to 416
	value = ((uint32_t)(input[50] & 0x7f) << 25) |
			((uint32_t)input[51] << 17) |
			((uint32_t)(input[52] & 0x80) << 9);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 417 to 432
	value = ((uint32_t)(input[52] & 0x7f) << 25) |
			((uint32_t)input[53] << 17) |
			((uint32_t)(input[54] & 0x80) << 9);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 433 to 448
	value = ((uint32_t)(input[54] & 0x7f) << 25) |
			((uint32_t)input[55] << 17) |
			((uint32_t)(input[56] & 0x80) << 9);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 449 to 464
	value = ((uint32_t)(input[56] & 0x7f) << 25) |
			((uint32_t)input[57] << 17) |
			((uint32_t)(input[58] & 0x80) << 9);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 465 to 480
	value = ((uint32_t)(input[58] & 0x7f) << 25) |
			((uint32_t)input[59] << 17) |
			((uint32_t)(input[60] & 0x80) << 9);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 481 to 496
	value = ((uint32_t)(input[60] & 0x7f) << 25) |
			((uint32_t)input[61] << 17) |
			((uint32_t)(input[62] & 0x80) << 9);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 497 to 512
	value = ((uint32_t)(input[62] & 0x7f) << 25) |
			((uint32_t)input[63] << 17) |
			((uint32_t)(input[64] & 0x80) << 9);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 513 to 528
	value = ((uint32_t)(input[64] & 0x7f) << 25) |
			((uint32_t)input[65] << 17) |
			((uint32_t)(input[66] & 0x80) << 9);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 529 to 544
	value = ((uint32_t)(input[66] & 0x7f) << 25) |
			((uint32_t)input[67] << 17) |
			((uint32_t)(input[68] & 0x80) << 9);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 545 to 560
	value = ((uint32_t)(input[68] & 0x7f) << 25) |
			((uint32_t)input[69] << 17) |
			((uint32_t)(input[70] & 0x80) << 9);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 561 to 576
	value = ((uint32_t)(input[70] & 0x7f) << 25) |
			((uint32_t)input[71] << 17) |
			((uint32_t)(input[72] & 0x80) << 9);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 577 to 592
	value = ((uint32_t)(input[72] & 0x7f) << 25) |
			((uint32_t)input[73] << 17) |
			((uint32_t)(input[74] & 0x80) << 9);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 593 to 608
	value = ((uint32_t)(input[74] & 0x7f) << 25) |
			((uint32_t)input[75] << 17) |
			((uint32_t)(input[76] & 0x80) << 9);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 609 to 624
	value = ((uint32_t)(input[76] & 0x7f) << 25) |
			((uint32_t)input[77] << 17) |
			((uint32_t)(input[78] & 0x80) << 9);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 625 to 640
	value = ((uint32_t)(input[78] & 0x7f) << 25) |
			((uint32_t)input[79] << 17) |
			((uint32_t)(input[80] & 0x80) << 9);
	output[39] = (double)(value >> 16);

	// read output[40]: from bit 641 to 656
	value = ((uint32_t)(input[80] & 0x7f) << 25) |
			((uint32_t)input[81] << 17) |
			((uint32_t)(input[82] & 0x80) << 9);
	output[40] = (double)(value >> 16);

	// read output[41]: from bit 657 to 672
	value = ((uint32_t)(input[82] & 0x7f) << 25) |
			((uint32_t)input[83] << 17) |
			((uint32_t)(input[84] & 0x80) << 9);
	output[41] = (double)(value >> 16);

	// read output[42]: from bit 673 to 688
	value = ((uint32_t)(input[84] & 0x7f) << 25) |
			((uint32_t)input[85] << 17) |
			((uint32_t)(input[86] & 0x80) << 9);
	output[42] = (double)(value >> 16);

	// read output[43]: from bit 689 to 704
	value = ((uint32_t)(input[86] & 0x7f) << 25) |
			((uint32_t)input[87] << 17) |
			((uint32_t)(input[88] & 0x80) << 9);
	output[43] = (double)(value >> 16);

	// read output[44]: from bit 705 to 720
	value = ((uint32_t)(input[88] & 0x7f) << 25) |
			((uint32_t)input[89] << 17) |
			((uint32_t)(input[90] & 0x80) << 9);
	output[44] = (double)(value >> 16);

	// read output[45]: from bit 721 to 736
	value = ((uint32_t)(input[90] & 0x7f) << 25) |
			((uint32_t)input[91] << 17) |
			((uint32_t)(input[92] & 0x80) << 9);
	output[45] = (double)(value >> 16);

	// read output[46]: from bit 737 to 752
	value = ((uint32_t)(input[92] & 0x7f) << 25) |
			((uint32_t)input[93] << 17) |
			((uint32_t)(input[94] & 0x80) << 9);
	output[46] = (double)(value >> 16);

	// read output[47]: from bit 753 to 768
	value = ((uint32_t)(input[94] & 0x7f) << 25) |
			((uint32_t)input[95] << 17) |
			((uint32_t)(input[96] & 0x80) << 9);
	output[47] = (double)(value >> 16);

	// read output[48]: from bit 769 to 784
	value = ((uint32_t)(input[96] & 0x7f) << 25) |
			((uint32_t)input[97] << 17) |
			((uint32_t)(input[98] & 0x80) << 9);
	output[48] = (double)(value >> 16);

	// read output[49]: from bit 785 to 800
	value = ((uint32_t)(input[98] & 0x7f) << 25) |
			((uint32_t)input[99] << 17) |
			((uint32_t)(input[100] & 0x80) << 9);
	output[49] = (double)(value >> 16);

	// read output[50]: from bit 801 to 816
	value = ((uint32_t)(input[100] & 0x7f) << 25) |
			((uint32_t)input[101] << 17) |
			((uint32_t)(input[102] & 0x80) << 9);
	output[50] = (double)(value >> 16);

	// read output[51]: from bit 817 to 832
	value = ((uint32_t)(input[102] & 0x7f) << 25) |
			((uint32_t)input[103] << 17) |
			((uint32_t)(input[104] & 0x80) << 9);
	output[51] = (double)(value >> 16);

	// read output[52]: from bit 833 to 848
	value = ((uint32_t)(input[104] & 0x7f) << 25) |
			((uint32_t)input[105] << 17) |
			((uint32_t)(input[106] & 0x80) << 9);
	output[52] = (double)(value >> 16);

	// read output[53]: from bit 849 to 864
	value = ((uint32_t)(input[106] & 0x7f) << 25) |
			((uint32_t)input[107] << 17) |
			((uint32_t)(input[108] & 0x80) << 9);
	output[53] = (double)(value >> 16);

	// read output[54]: from bit 865 to 880
	value = ((uint32_t)(input[108] & 0x7f) << 25) |
			((uint32_t)input[109] << 17) |
			((uint32_t)(input[110] & 0x80) << 9);
	output[54] = (double)(value >> 16);
}

static void unpack_55_16bit_unsigned_1off(const uint8_t * input, double * output, void *closure) {
	// Unpack 55 values into output
	// Values are 16-bit unsigned
	// Skip 1 bits, read 880 bits of data.
	// Input must be at least 111 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 1 to 16
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)input[1] << 17) |
			((uint32_t)(input[2] & 0x80) << 9);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 17 to 32
	value = ((uint32_t)(input[2] & 0x7f) << 25) |
			((uint32_t)input[3] << 17) |
			((uint32_t)(input[4] & 0x80) << 9);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 33 to 48
	value = ((uint32_t)(input[4] & 0x7f) << 25) |
			((uint32_t)input[5] << 17) |
			((uint32_t)(input[6] & 0x80) << 9);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 49 to 64
	value = ((uint32_t)(input[6] & 0x7f) << 25) |
			((uint32_t)input[7] << 17) |
			((uint32_t)(input[8] & 0x80) << 9);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 65 to 80
	value = ((uint32_t)(input[8] & 0x7f) << 25) |
			((uint32_t)input[9] << 17) |
			((uint32_t)(input[10] & 0x80) << 9);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 81 to 96
	value = ((uint32_t)(input[10] & 0x7f) << 25) |
			((uint32_t)input[11] << 17) |
			((uint32_t)(input[12] & 0x80) << 9);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 97 to 112
	value = ((uint32_t)(input[12] & 0x7f) << 25) |
			((uint32_t)input[13] << 17) |
			((uint32_t)(input[14] & 0x80) << 9);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 113 to 128
	value = ((uint32_t)(input[14] & 0x7f) << 25) |
			((uint32_t)input[15] << 17) |
			((uint32_t)(input[16] & 0x80) << 9);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 129 to 144
	value = ((uint32_t)(input[16] & 0x7f) << 25) |
			((uint32_t)input[17] << 17) |
			((uint32_t)(input[18] & 0x80) << 9);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 145 to 160
	value = ((uint32_t)(input[18] & 0x7f) << 25) |
			((uint32_t)input[19] << 17) |
			((uint32_t)(input[20] & 0x80) << 9);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 161 to 176
	value = ((uint32_t)(input[20] & 0x7f) << 25) |
			((uint32_t)input[21] << 17) |
			((uint32_t)(input[22] & 0x80) << 9);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 177 to 192
	value = ((uint32_t)(input[22] & 0x7f) << 25) |
			((uint32_t)input[23] << 17) |
			((uint32_t)(input[24] & 0x80) << 9);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 193 to 208
	value = ((uint32_t)(input[24] & 0x7f) << 25) |
			((uint32_t)input[25] << 17) |
			((uint32_t)(input[26] & 0x80) << 9);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 209 to 224
	value = ((uint32_t)(input[26] & 0x7f) << 25) |
			((uint32_t)input[27] << 17) |
			((uint32_t)(input[28] & 0x80) << 9);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 225 to 240
	value = ((uint32_t)(input[28] & 0x7f) << 25) |
			((uint32_t)input[29] << 17) |
			((uint32_t)(input[30] & 0x80) << 9);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 241 to 256
	value = ((uint32_t)(input[30] & 0x7f) << 25) |
			((uint32_t)input[31] << 17) |
			((uint32_t)(input[32] & 0x80) << 9);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 257 to 272
	value = ((uint32_t)(input[32] & 0x7f) << 25) |
			((uint32_t)input[33] << 17) |
			((uint32_t)(input[34] & 0x80) << 9);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 273 to 288
	value = ((uint32_t)(input[34] & 0x7f) << 25) |
			((uint32_t)input[35] << 17) |
			((uint32_t)(input[36] & 0x80) << 9);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 289 to 304
	value = ((uint32_t)(input[36] & 0x7f) << 25) |
			((uint32_t)input[37] << 17) |
			((uint32_t)(input[38] & 0x80) << 9);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 305 to 320
	value = ((uint32_t)(input[38] & 0x7f) << 25) |
			((uint32_t)input[39] << 17) |
			((uint32_t)(input[40] & 0x80) << 9);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 321 to 336
	value = ((uint32_t)(input[40] & 0x7f) << 25) |
			((uint32_t)input[41] << 17) |
			((uint32_t)(input[42] & 0x80) << 9);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 337 to 352
	value = ((uint32_t)(input[42] & 0x7f) << 25) |
			((uint32_t)input[43] << 17) |
			((uint32_t)(input[44] & 0x80) << 9);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 353 to 368
	value = ((uint32_t)(input[44] & 0x7f) << 25) |
			((uint32_t)input[45] << 17) |
			((uint32_t)(input[46] & 0x80) << 9);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 369 to 384
	value = ((uint32_t)(input[46] & 0x7f) << 25) |
			((uint32_t)input[47] << 17) |
			((uint32_t)(input[48] & 0x80) << 9);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 385 to 400
	value = ((uint32_t)(input[48] & 0x7f) << 25) |
			((uint32_t)input[49] << 17) |
			((uint32_t)(input[50] & 0x80) << 9);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 401 to 416
	value = ((uint32_t)(input[50] & 0x7f) << 25) |
			((uint32_t)input[51] << 17) |
			((uint32_t)(input[52] & 0x80) << 9);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 417 to 432
	value = ((uint32_t)(input[52] & 0x7f) << 25) |
			((uint32_t)input[53] << 17) |
			((uint32_t)(input[54] & 0x80) << 9);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 433 to 448
	value = ((uint32_t)(input[54] & 0x7f) << 25) |
			((uint32_t)input[55] << 17) |
			((uint32_t)(input[56] & 0x80) << 9);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 449 to 464
	value = ((uint32_t)(input[56] & 0x7f) << 25) |
			((uint32_t)input[57] << 17) |
			((uint32_t)(input[58] & 0x80) << 9);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 465 to 480
	value = ((uint32_t)(input[58] & 0x7f) << 25) |
			((uint32_t)input[59] << 17) |
			((uint32_t)(input[60] & 0x80) << 9);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 481 to 496
	value = ((uint32_t)(input[60] & 0x7f) << 25) |
			((uint32_t)input[61] << 17) |
			((uint32_t)(input[62] & 0x80) << 9);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 497 to 512
	value = ((uint32_t)(input[62] & 0x7f) << 25) |
			((uint32_t)input[63] << 17) |
			((uint32_t)(input[64] & 0x80) << 9);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 513 to 528
	value = ((uint32_t)(input[64] & 0x7f) << 25) |
			((uint32_t)input[65] << 17) |
			((uint32_t)(input[66] & 0x80) << 9);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 529 to 544
	value = ((uint32_t)(input[66] & 0x7f) << 25) |
			((uint32_t)input[67] << 17) |
			((uint32_t)(input[68] & 0x80) << 9);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 545 to 560
	value = ((uint32_t)(input[68] & 0x7f) << 25) |
			((uint32_t)input[69] << 17) |
			((uint32_t)(input[70] & 0x80) << 9);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 561 to 576
	value = ((uint32_t)(input[70] & 0x7f) << 25) |
			((uint32_t)input[71] << 17) |
			((uint32_t)(input[72] & 0x80) << 9);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 577 to 592
	value = ((uint32_t)(input[72] & 0x7f) << 25) |
			((uint32_t)input[73] << 17) |
			((uint32_t)(input[74] & 0x80) << 9);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 593 to 608
	value = ((uint32_t)(input[74] & 0x7f) << 25) |
			((uint32_t)input[75] << 17) |
			((uint32_t)(input[76] & 0x80) << 9);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 609 to 624
	value = ((uint32_t)(input[76] & 0x7f) << 25) |
			((uint32_t)input[77] << 17) |
			((uint32_t)(input[78] & 0x80) << 9);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 625 to 640
	value = ((uint32_t)(input[78] & 0x7f) << 25) |
			((uint32_t)input[79] << 17) |
			((uint32_t)(input[80] & 0x80) << 9);
	output[39] = (double)(value >> 16);

	// read output[40]: from bit 641 to 656
	value = ((uint32_t)(input[80] & 0x7f) << 25) |
			((uint32_t)input[81] << 17) |
			((uint32_t)(input[82] & 0x80) << 9);
	output[40] = (double)(value >> 16);

	// read output[41]: from bit 657 to 672
	value = ((uint32_t)(input[82] & 0x7f) << 25) |
			((uint32_t)input[83] << 17) |
			((uint32_t)(input[84] & 0x80) << 9);
	output[41] = (double)(value >> 16);

	// read output[42]: from bit 673 to 688
	value = ((uint32_t)(input[84] & 0x7f) << 25) |
			((uint32_t)input[85] << 17) |
			((uint32_t)(input[86] & 0x80) << 9);
	output[42] = (double)(value >> 16);

	// read output[43]: from bit 689 to 704
	value = ((uint32_t)(input[86] & 0x7f) << 25) |
			((uint32_t)input[87] << 17) |
			((uint32_t)(input[88] & 0x80) << 9);
	output[43] = (double)(value >> 16);

	// read output[44]: from bit 705 to 720
	value = ((uint32_t)(input[88] & 0x7f) << 25) |
			((uint32_t)input[89] << 17) |
			((uint32_t)(input[90] & 0x80) << 9);
	output[44] = (double)(value >> 16);

	// read output[45]: from bit 721 to 736
	value = ((uint32_t)(input[90] & 0x7f) << 25) |
			((uint32_t)input[91] << 17) |
			((uint32_t)(input[92] & 0x80) << 9);
	output[45] = (double)(value >> 16);

	// read output[46]: from bit 737 to 752
	value = ((uint32_t)(input[92] & 0x7f) << 25) |
			((uint32_t)input[93] << 17) |
			((uint32_t)(input[94] & 0x80) << 9);
	output[46] = (double)(value >> 16);

	// read output[47]: from bit 753 to 768
	value = ((uint32_t)(input[94] & 0x7f) << 25) |
			((uint32_t)input[95] << 17) |
			((uint32_t)(input[96] & 0x80) << 9);
	output[47] = (double)(value >> 16);

	// read output[48]: from bit 769 to 784
	value = ((uint32_t)(input[96] & 0x7f) << 25) |
			((uint32_t)input[97] << 17) |
			((uint32_t)(input[98] & 0x80) << 9);
	output[48] = (double)(value >> 16);

	// read output[49]: from bit 785 to 800
	value = ((uint32_t)(input[98] & 0x7f) << 25) |
			((uint32_t)input[99] << 17) |
			((uint32_t)(input[100] & 0x80) << 9);
	output[49] = (double)(value >> 16);

	// read output[50]: from bit 801 to 816
	value = ((uint32_t)(input[100] & 0x7f) << 25) |
			((uint32_t)input[101] << 17) |
			((uint32_t)(input[102] & 0x80) << 9);
	output[50] = (double)(value >> 16);

	// read output[51]: from bit 817 to 832
	value = ((uint32_t)(input[102] & 0x7f) << 25) |
			((uint32_t)input[103] << 17) |
			((uint32_t)(input[104] & 0x80) << 9);
	output[51] = (double)(value >> 16);

	// read output[52]: from bit 833 to 848
	value = ((uint32_t)(input[104] & 0x7f) << 25) |
			((uint32_t)input[105] << 17) |
			((uint32_t)(input[106] & 0x80) << 9);
	output[52] = (double)(value >> 16);

	// read output[53]: from bit 849 to 864
	value = ((uint32_t)(input[106] & 0x7f) << 25) |
			((uint32_t)input[107] << 17) |
			((uint32_t)(input[108] & 0x80) << 9);
	output[53] = (double)(value >> 16);

	// read output[54]: from bit 865 to 880
	value = ((uint32_t)(input[108] & 0x7f) << 25) |
			((uint32_t)input[109] << 17) |
			((uint32_t)(input[110] & 0x80) << 9);
	output[54] = (double)(value >> 16);
}

static void unpack_55_16bit_signed_2off(const uint8_t * input, double * output, void *closure) {
	// Unpack 55 values into output
	// Values are 16-bit signed
	// Skip 2 bits, read 880 bits of data.
	// Input must be at least 111 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 2 to 17
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)input[1] << 18) |
			((uint32_t)(input[2] & 0xc0) << 10);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 18 to 33
	value = ((uint32_t)(input[2] & 0x3f) << 26) |
			((uint32_t)input[3] << 18) |
			((uint32_t)(input[4] & 0xc0) << 10);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 34 to 49
	value = ((uint32_t)(input[4] & 0x3f) << 26) |
			((uint32_t)input[5] << 18) |
			((uint32_t)(input[6] & 0xc0) << 10);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 50 to 65
	value = ((uint32_t)(input[6] & 0x3f) << 26) |
			((uint32_t)input[7] << 18) |
			((uint32_t)(input[8] & 0xc0) << 10);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 66 to 81
	value = ((uint32_t)(input[8] & 0x3f) << 26) |
			((uint32_t)input[9] << 18) |
			((uint32_t)(input[10] & 0xc0) << 10);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 82 to 97
	value = ((uint32_t)(input[10] & 0x3f) << 26) |
			((uint32_t)input[11] << 18) |
			((uint32_t)(input[12] & 0xc0) << 10);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 98 to 113
	value = ((uint32_t)(input[12] & 0x3f) << 26) |
			((uint32_t)input[13] << 18) |
			((uint32_t)(input[14] & 0xc0) << 10);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 114 to 129
	value = ((uint32_t)(input[14] & 0x3f) << 26) |
			((uint32_t)input[15] << 18) |
			((uint32_t)(input[16] & 0xc0) << 10);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 130 to 145
	value = ((uint32_t)(input[16] & 0x3f) << 26) |
			((uint32_t)input[17] << 18) |
			((uint32_t)(input[18] & 0xc0) << 10);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 146 to 161
	value = ((uint32_t)(input[18] & 0x3f) << 26) |
			((uint32_t)input[19] << 18) |
			((uint32_t)(input[20] & 0xc0) << 10);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 162 to 177
	value = ((uint32_t)(input[20] & 0x3f) << 26) |
			((uint32_t)input[21] << 18) |
			((uint32_t)(input[22] & 0xc0) << 10);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 178 to 193
	value = ((uint32_t)(input[22] & 0x3f) << 26) |
			((uint32_t)input[23] << 18) |
			((uint32_t)(input[24] & 0xc0) << 10);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 194 to 209
	value = ((uint32_t)(input[24] & 0x3f) << 26) |
			((uint32_t)input[25] << 18) |
			((uint32_t)(input[26] & 0xc0) << 10);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 210 to 225
	value = ((uint32_t)(input[26] & 0x3f) << 26) |
			((uint32_t)input[27] << 18) |
			((uint32_t)(input[28] & 0xc0) << 10);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 226 to 241
	value = ((uint32_t)(input[28] & 0x3f) << 26) |
			((uint32_t)input[29] << 18) |
			((uint32_t)(input[30] & 0xc0) << 10);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 242 to 257
	value = ((uint32_t)(input[30] & 0x3f) << 26) |
			((uint32_t)input[31] << 18) |
			((uint32_t)(input[32] & 0xc0) << 10);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 258 to 273
	value = ((uint32_t)(input[32] & 0x3f) << 26) |
			((uint32_t)input[33] << 18) |
			((uint32_t)(input[34] & 0xc0) << 10);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 274 to 289
	value = ((uint32_t)(input[34] & 0x3f) << 26) |
			((uint32_t)input[35] << 18) |
			((uint32_t)(input[36] & 0xc0) << 10);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 290 to 305
	value = ((uint32_t)(input[36] & 0x3f) << 26) |
			((uint32_t)input[37] << 18) |
			((uint32_t)(input[38] & 0xc0) << 10);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 306 to 321
	value = ((uint32_t)(input[38] & 0x3f) << 26) |
			((uint32_t)input[39] << 18) |
			((uint32_t)(input[40] & 0xc0) << 10);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 322 to 337
	value = ((uint32_t)(input[40] & 0x3f) << 26) |
			((uint32_t)input[41] << 18) |
			((uint32_t)(input[42] & 0xc0) << 10);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 338 to 353
	value = ((uint32_t)(input[42] & 0x3f) << 26) |
			((uint32_t)input[43] << 18) |
			((uint32_t)(input[44] & 0xc0) << 10);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 354 to 369
	value = ((uint32_t)(input[44] & 0x3f) << 26) |
			((uint32_t)input[45] << 18) |
			((uint32_t)(input[46] & 0xc0) << 10);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 370 to 385
	value = ((uint32_t)(input[46] & 0x3f) << 26) |
			((uint32_t)input[47] << 18) |
			((uint32_t)(input[48] & 0xc0) << 10);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 386 to 401
	value = ((uint32_t)(input[48] & 0x3f) << 26) |
			((uint32_t)input[49] << 18) |
			((uint32_t)(input[50] & 0xc0) << 10);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 402 to 417
	value = ((uint32_t)(input[50] & 0x3f) << 26) |
			((uint32_t)input[51] << 18) |
			((uint32_t)(input[52] & 0xc0) << 10);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 418 to 433
	value = ((uint32_t)(input[52] & 0x3f) << 26) |
			((uint32_t)input[53] << 18) |
			((uint32_t)(input[54] & 0xc0) << 10);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 434 to 449
	value = ((uint32_t)(input[54] & 0x3f) << 26) |
			((uint32_t)input[55] << 18) |
			((uint32_t)(input[56] & 0xc0) << 10);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 450 to 465
	value = ((uint32_t)(input[56] & 0x3f) << 26) |
			((uint32_t)input[57] << 18) |
			((uint32_t)(input[58] & 0xc0) << 10);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 466 to 481
	value = ((uint32_t)(input[58] & 0x3f) << 26) |
			((uint32_t)input[59] << 18) |
			((uint32_t)(input[60] & 0xc0) << 10);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 482 to 497
	value = ((uint32_t)(input[60] & 0x3f) << 26) |
			((uint32_t)input[61] << 18) |
			((uint32_t)(input[62] & 0xc0) << 10);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 498 to 513
	value = ((uint32_t)(input[62] & 0x3f) << 26) |
			((uint32_t)input[63] << 18) |
			((uint32_t)(input[64] & 0xc0) << 10);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 514 to 529
	value = ((uint32_t)(input[64] & 0x3f) << 26) |
			((uint32_t)input[65] << 18) |
			((uint32_t)(input[66] & 0xc0) << 10);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 530 to 545
	value = ((uint32_t)(input[66] & 0x3f) << 26) |
			((uint32_t)input[67] << 18) |
			((uint32_t)(input[68] & 0xc0) << 10);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 546 to 561
	value = ((uint32_t)(input[68] & 0x3f) << 26) |
			((uint32_t)input[69] << 18) |
			((uint32_t)(input[70] & 0xc0) << 10);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 562 to 577
	value = ((uint32_t)(input[70] & 0x3f) << 26) |
			((uint32_t)input[71] << 18) |
			((uint32_t)(input[72] & 0xc0) << 10);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 578 to 593
	value = ((uint32_t)(input[72] & 0x3f) << 26) |
			((uint32_t)input[73] << 18) |
			((uint32_t)(input[74] & 0xc0) << 10);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 594 to 609
	value = ((uint32_t)(input[74] & 0x3f) << 26) |
			((uint32_t)input[75] << 18) |
			((uint32_t)(input[76] & 0xc0) << 10);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 610 to 625
	value = ((uint32_t)(input[76] & 0x3f) << 26) |
			((uint32_t)input[77] << 18) |
			((uint32_t)(input[78] & 0xc0) << 10);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 626 to 641
	value = ((uint32_t)(input[78] & 0x3f) << 26) |
			((uint32_t)input[79] << 18) |
			((uint32_t)(input[80] & 0xc0) << 10);
	output[39] = (double)(value >> 16);

	// read output[40]: from bit 642 to 657
	value = ((uint32_t)(input[80] & 0x3f) << 26) |
			((uint32_t)input[81] << 18) |
			((uint32_t)(input[82] & 0xc0) << 10);
	output[40] = (double)(value >> 16);

	// read output[41]: from bit 658 to 673
	value = ((uint32_t)(input[82] & 0x3f) << 26) |
			((uint32_t)input[83] << 18) |
			((uint32_t)(input[84] & 0xc0) << 10);
	output[41] = (double)(value >> 16);

	// read output[42]: from bit 674 to 689
	value = ((uint32_t)(input[84] & 0x3f) << 26) |
			((uint32_t)input[85] << 18) |
			((uint32_t)(input[86] & 0xc0) << 10);
	output[42] = (double)(value >> 16);

	// read output[43]: from bit 690 to 705
	value = ((uint32_t)(input[86] & 0x3f) << 26) |
			((uint32_t)input[87] << 18) |
			((uint32_t)(input[88] & 0xc0) << 10);
	output[43] = (double)(value >> 16);

	// read output[44]: from bit 706 to 721
	value = ((uint32_t)(input[88] & 0x3f) << 26) |
			((uint32_t)input[89] << 18) |
			((uint32_t)(input[90] & 0xc0) << 10);
	output[44] = (double)(value >> 16);

	// read output[45]: from bit 722 to 737
	value = ((uint32_t)(input[90] & 0x3f) << 26) |
			((uint32_t)input[91] << 18) |
			((uint32_t)(input[92] & 0xc0) << 10);
	output[45] = (double)(value >> 16);

	// read output[46]: from bit 738 to 753
	value = ((uint32_t)(input[92] & 0x3f) << 26) |
			((uint32_t)input[93] << 18) |
			((uint32_t)(input[94] & 0xc0) << 10);
	output[46] = (double)(value >> 16);

	// read output[47]: from bit 754 to 769
	value = ((uint32_t)(input[94] & 0x3f) << 26) |
			((uint32_t)input[95] << 18) |
			((uint32_t)(input[96] & 0xc0) << 10);
	output[47] = (double)(value >> 16);

	// read output[48]: from bit 770 to 785
	value = ((uint32_t)(input[96] & 0x3f) << 26) |
			((uint32_t)input[97] << 18) |
			((uint32_t)(input[98] & 0xc0) << 10);
	output[48] = (double)(value >> 16);

	// read output[49]: from bit 786 to 801
	value = ((uint32_t)(input[98] & 0x3f) << 26) |
			((uint32_t)input[99] << 18) |
			((uint32_t)(input[100] & 0xc0) << 10);
	output[49] = (double)(value >> 16);

	// read output[50]: from bit 802 to 817
	value = ((uint32_t)(input[100] & 0x3f) << 26) |
			((uint32_t)input[101] << 18) |
			((uint32_t)(input[102] & 0xc0) << 10);
	output[50] = (double)(value >> 16);

	// read output[51]: from bit 818 to 833
	value = ((uint32_t)(input[102] & 0x3f) << 26) |
			((uint32_t)input[103] << 18) |
			((uint32_t)(input[104] & 0xc0) << 10);
	output[51] = (double)(value >> 16);

	// read output[52]: from bit 834 to 849
	value = ((uint32_t)(input[104] & 0x3f) << 26) |
			((uint32_t)input[105] << 18) |
			((uint32_t)(input[106] & 0xc0) << 10);
	output[52] = (double)(value >> 16);

	// read output[53]: from bit 850 to 865
	value = ((uint32_t)(input[106] & 0x3f) << 26) |
			((uint32_t)input[107] << 18) |
			((uint32_t)(input[108] & 0xc0) << 10);
	output[53] = (double)(value >> 16);

	// read output[54]: from bit 866 to 881
	value = ((uint32_t)(input[108] & 0x3f) << 26) |
			((uint32_t)input[109] << 18) |
			((uint32_t)(input[110] & 0xc0) << 10);
	output[54] = (double)(value >> 16);
}

static void unpack_55_16bit_unsigned_2off(const uint8_t * input, double * output, void *closure) {
	// Unpack 55 values into output
	// Values are 16-bit unsigned
	// Skip 2 bits, read 880 bits of data.
	// Input must be at least 111 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 2 to 17
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)input[1] << 18) |
			((uint32_t)(input[2] & 0xc0) << 10);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 18 to 33
	value = ((uint32_t)(input[2] & 0x3f) << 26) |
			((uint32_t)input[3] << 18) |
			((uint32_t)(input[4] & 0xc0) << 10);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 34 to 49
	value = ((uint32_t)(input[4] & 0x3f) << 26) |
			((uint32_t)input[5] << 18) |
			((uint32_t)(input[6] & 0xc0) << 10);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 50 to 65
	value = ((uint32_t)(input[6] & 0x3f) << 26) |
			((uint32_t)input[7] << 18) |
			((uint32_t)(input[8] & 0xc0) << 10);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 66 to 81
	value = ((uint32_t)(input[8] & 0x3f) << 26) |
			((uint32_t)input[9] << 18) |
			((uint32_t)(input[10] & 0xc0) << 10);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 82 to 97
	value = ((uint32_t)(input[10] & 0x3f) << 26) |
			((uint32_t)input[11] << 18) |
			((uint32_t)(input[12] & 0xc0) << 10);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 98 to 113
	value = ((uint32_t)(input[12] & 0x3f) << 26) |
			((uint32_t)input[13] << 18) |
			((uint32_t)(input[14] & 0xc0) << 10);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 114 to 129
	value = ((uint32_t)(input[14] & 0x3f) << 26) |
			((uint32_t)input[15] << 18) |
			((uint32_t)(input[16] & 0xc0) << 10);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 130 to 145
	value = ((uint32_t)(input[16] & 0x3f) << 26) |
			((uint32_t)input[17] << 18) |
			((uint32_t)(input[18] & 0xc0) << 10);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 146 to 161
	value = ((uint32_t)(input[18] & 0x3f) << 26) |
			((uint32_t)input[19] << 18) |
			((uint32_t)(input[20] & 0xc0) << 10);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 162 to 177
	value = ((uint32_t)(input[20] & 0x3f) << 26) |
			((uint32_t)input[21] << 18) |
			((uint32_t)(input[22] & 0xc0) << 10);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 178 to 193
	value = ((uint32_t)(input[22] & 0x3f) << 26) |
			((uint32_t)input[23] << 18) |
			((uint32_t)(input[24] & 0xc0) << 10);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 194 to 209
	value = ((uint32_t)(input[24] & 0x3f) << 26) |
			((uint32_t)input[25] << 18) |
			((uint32_t)(input[26] & 0xc0) << 10);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 210 to 225
	value = ((uint32_t)(input[26] & 0x3f) << 26) |
			((uint32_t)input[27] << 18) |
			((uint32_t)(input[28] & 0xc0) << 10);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 226 to 241
	value = ((uint32_t)(input[28] & 0x3f) << 26) |
			((uint32_t)input[29] << 18) |
			((uint32_t)(input[30] & 0xc0) << 10);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 242 to 257
	value = ((uint32_t)(input[30] & 0x3f) << 26) |
			((uint32_t)input[31] << 18) |
			((uint32_t)(input[32] & 0xc0) << 10);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 258 to 273
	value = ((uint32_t)(input[32] & 0x3f) << 26) |
			((uint32_t)input[33] << 18) |
			((uint32_t)(input[34] & 0xc0) << 10);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 274 to 289
	value = ((uint32_t)(input[34] & 0x3f) << 26) |
			((uint32_t)input[35] << 18) |
			((uint32_t)(input[36] & 0xc0) << 10);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 290 to 305
	value = ((uint32_t)(input[36] & 0x3f) << 26) |
			((uint32_t)input[37] << 18) |
			((uint32_t)(input[38] & 0xc0) << 10);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 306 to 321
	value = ((uint32_t)(input[38] & 0x3f) << 26) |
			((uint32_t)input[39] << 18) |
			((uint32_t)(input[40] & 0xc0) << 10);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 322 to 337
	value = ((uint32_t)(input[40] & 0x3f) << 26) |
			((uint32_t)input[41] << 18) |
			((uint32_t)(input[42] & 0xc0) << 10);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 338 to 353
	value = ((uint32_t)(input[42] & 0x3f) << 26) |
			((uint32_t)input[43] << 18) |
			((uint32_t)(input[44] & 0xc0) << 10);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 354 to 369
	value = ((uint32_t)(input[44] & 0x3f) << 26) |
			((uint32_t)input[45] << 18) |
			((uint32_t)(input[46] & 0xc0) << 10);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 370 to 385
	value = ((uint32_t)(input[46] & 0x3f) << 26) |
			((uint32_t)input[47] << 18) |
			((uint32_t)(input[48] & 0xc0) << 10);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 386 to 401
	value = ((uint32_t)(input[48] & 0x3f) << 26) |
			((uint32_t)input[49] << 18) |
			((uint32_t)(input[50] & 0xc0) << 10);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 402 to 417
	value = ((uint32_t)(input[50] & 0x3f) << 26) |
			((uint32_t)input[51] << 18) |
			((uint32_t)(input[52] & 0xc0) << 10);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 418 to 433
	value = ((uint32_t)(input[52] & 0x3f) << 26) |
			((uint32_t)input[53] << 18) |
			((uint32_t)(input[54] & 0xc0) << 10);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 434 to 449
	value = ((uint32_t)(input[54] & 0x3f) << 26) |
			((uint32_t)input[55] << 18) |
			((uint32_t)(input[56] & 0xc0) << 10);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 450 to 465
	value = ((uint32_t)(input[56] & 0x3f) << 26) |
			((uint32_t)input[57] << 18) |
			((uint32_t)(input[58] & 0xc0) << 10);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 466 to 481
	value = ((uint32_t)(input[58] & 0x3f) << 26) |
			((uint32_t)input[59] << 18) |
			((uint32_t)(input[60] & 0xc0) << 10);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 482 to 497
	value = ((uint32_t)(input[60] & 0x3f) << 26) |
			((uint32_t)input[61] << 18) |
			((uint32_t)(input[62] & 0xc0) << 10);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 498 to 513
	value = ((uint32_t)(input[62] & 0x3f) << 26) |
			((uint32_t)input[63] << 18) |
			((uint32_t)(input[64] & 0xc0) << 10);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 514 to 529
	value = ((uint32_t)(input[64] & 0x3f) << 26) |
			((uint32_t)input[65] << 18) |
			((uint32_t)(input[66] & 0xc0) << 10);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 530 to 545
	value = ((uint32_t)(input[66] & 0x3f) << 26) |
			((uint32_t)input[67] << 18) |
			((uint32_t)(input[68] & 0xc0) << 10);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 546 to 561
	value = ((uint32_t)(input[68] & 0x3f) << 26) |
			((uint32_t)input[69] << 18) |
			((uint32_t)(input[70] & 0xc0) << 10);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 562 to 577
	value = ((uint32_t)(input[70] & 0x3f) << 26) |
			((uint32_t)input[71] << 18) |
			((uint32_t)(input[72] & 0xc0) << 10);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 578 to 593
	value = ((uint32_t)(input[72] & 0x3f) << 26) |
			((uint32_t)input[73] << 18) |
			((uint32_t)(input[74] & 0xc0) << 10);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 594 to 609
	value = ((uint32_t)(input[74] & 0x3f) << 26) |
			((uint32_t)input[75] << 18) |
			((uint32_t)(input[76] & 0xc0) << 10);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 610 to 625
	value = ((uint32_t)(input[76] & 0x3f) << 26) |
			((uint32_t)input[77] << 18) |
			((uint32_t)(input[78] & 0xc0) << 10);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 626 to 641
	value = ((uint32_t)(input[78] & 0x3f) << 26) |
			((uint32_t)input[79] << 18) |
			((uint32_t)(input[80] & 0xc0) << 10);
	output[39] = (double)(value >> 16);

	// read output[40]: from bit 642 to 657
	value = ((uint32_t)(input[80] & 0x3f) << 26) |
			((uint32_t)input[81] << 18) |
			((uint32_t)(input[82] & 0xc0) << 10);
	output[40] = (double)(value >> 16);

	// read output[41]: from bit 658 to 673
	value = ((uint32_t)(input[82] & 0x3f) << 26) |
			((uint32_t)input[83] << 18) |
			((uint32_t)(input[84] & 0xc0) << 10);
	output[41] = (double)(value >> 16);

	// read output[42]: from bit 674 to 689
	value = ((uint32_t)(input[84] & 0x3f) << 26) |
			((uint32_t)input[85] << 18) |
			((uint32_t)(input[86] & 0xc0) << 10);
	output[42] = (double)(value >> 16);

	// read output[43]: from bit 690 to 705
	value = ((uint32_t)(input[86] & 0x3f) << 26) |
			((uint32_t)input[87] << 18) |
			((uint32_t)(input[88] & 0xc0) << 10);
	output[43] = (double)(value >> 16);

	// read output[44]: from bit 706 to 721
	value = ((uint32_t)(input[88] & 0x3f) << 26) |
			((uint32_t)input[89] << 18) |
			((uint32_t)(input[90] & 0xc0) << 10);
	output[44] = (double)(value >> 16);

	// read output[45]: from bit 722 to 737
	value = ((uint32_t)(input[90] & 0x3f) << 26) |
			((uint32_t)input[91] << 18) |
			((uint32_t)(input[92] & 0xc0) << 10);
	output[45] = (double)(value >> 16);

	// read output[46]: from bit 738 to 753
	value = ((uint32_t)(input[92] & 0x3f) << 26) |
			((uint32_t)input[93] << 18) |
			((uint32_t)(input[94] & 0xc0) << 10);
	output[46] = (double)(value >> 16);

	// read output[47]: from bit 754 to 769
	value = ((uint32_t)(input[94] & 0x3f) << 26) |
			((uint32_t)input[95] << 18) |
			((uint32_t)(input[96] & 0xc0) << 10);
	output[47] = (double)(value >> 16);

	// read output[48]: from bit 770 to 785
	value = ((uint32_t)(input[96] & 0x3f) << 26) |
			((uint32_t)input[97] << 18) |
			((uint32_t)(input[98] & 0xc0) << 10);
	output[48] = (double)(value >> 16);

	// read output[49]: from bit 786 to 801
	value = ((uint32_t)(input[98] & 0x3f) << 26) |
			((uint32_t)input[99] << 18) |
			((uint32_t)(input[100] & 0xc0) << 10);
	output[49] = (double)(value >> 16);

	// read output[50]: from bit 802 to 817
	value = ((uint32_t)(input[100] & 0x3f) << 26) |
			((uint32_t)input[101] << 18) |
			((uint32_t)(input[102] & 0xc0) << 10);
	output[50] = (double)(value >> 16);

	// read output[51]: from bit 818 to 833
	value = ((uint32_t)(input[102] & 0x3f) << 26) |
			((uint32_t)input[103] << 18) |
			((uint32_t)(input[104] & 0xc0) << 10);
	output[51] = (double)(value >> 16);

	// read output[52]: from bit 834 to 849
	value = ((uint32_t)(input[104] & 0x3f) << 26) |
			((uint32_t)input[105] << 18) |
			((uint32_t)(input[106] & 0xc0) << 10);
	output[52] = (double)(value >> 16);

	// read output[53]: from bit 850 to 865
	value = ((uint32_t)(input[106] & 0x3f) << 26) |
			((uint32_t)input[107] << 18) |
			((uint32_t)(input[108] & 0xc0) << 10);
	output[53] = (double)(value >> 16);

	// read output[54]: from bit 866 to 881
	value = ((uint32_t)(input[108] & 0x3f) << 26) |
			((uint32_t)input[109] << 18) |
			((uint32_t)(input[110] & 0xc0) << 10);
	output[54] = (double)(value >> 16);
}

static void unpack_55_16bit_signed_3off(const uint8_t * input, double * output, void *closure) {
	// Unpack 55 values into output
	// Values are 16-bit signed
	// Skip 3 bits, read 880 bits of data.
	// Input must be at least 111 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 3 to 18
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)input[1] << 19) |
			((uint32_t)(input[2] & 0xe0) << 11);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 19 to 34
	value = ((uint32_t)(input[2] & 0x1f) << 27) |
			((uint32_t)input[3] << 19) |
			((uint32_t)(input[4] & 0xe0) << 11);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 35 to 50
	value = ((uint32_t)(input[4] & 0x1f) << 27) |
			((uint32_t)input[5] << 19) |
			((uint32_t)(input[6] & 0xe0) << 11);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 51 to 66
	value = ((uint32_t)(input[6] & 0x1f) << 27) |
			((uint32_t)input[7] << 19) |
			((uint32_t)(input[8] & 0xe0) << 11);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 67 to 82
	value = ((uint32_t)(input[8] & 0x1f) << 27) |
			((uint32_t)input[9] << 19) |
			((uint32_t)(input[10] & 0xe0) << 11);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 83 to 98
	value = ((uint32_t)(input[10] & 0x1f) << 27) |
			((uint32_t)input[11] << 19) |
			((uint32_t)(input[12] & 0xe0) << 11);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 99 to 114
	value = ((uint32_t)(input[12] & 0x1f) << 27) |
			((uint32_t)input[13] << 19) |
			((uint32_t)(input[14] & 0xe0) << 11);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 115 to 130
	value = ((uint32_t)(input[14] & 0x1f) << 27) |
			((uint32_t)input[15] << 19) |
			((uint32_t)(input[16] & 0xe0) << 11);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 131 to 146
	value = ((uint32_t)(input[16] & 0x1f) << 27) |
			((uint32_t)input[17] << 19) |
			((uint32_t)(input[18] & 0xe0) << 11);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 147 to 162
	value = ((uint32_t)(input[18] & 0x1f) << 27) |
			((uint32_t)input[19] << 19) |
			((uint32_t)(input[20] & 0xe0) << 11);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 163 to 178
	value = ((uint32_t)(input[20] & 0x1f) << 27) |
			((uint32_t)input[21] << 19) |
			((uint32_t)(input[22] & 0xe0) << 11);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 179 to 194
	value = ((uint32_t)(input[22] & 0x1f) << 27) |
			((uint32_t)input[23] << 19) |
			((uint32_t)(input[24] & 0xe0) << 11);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 195 to 210
	value = ((uint32_t)(input[24] & 0x1f) << 27) |
			((uint32_t)input[25] << 19) |
			((uint32_t)(input[26] & 0xe0) << 11);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 211 to 226
	value = ((uint32_t)(input[26] & 0x1f) << 27) |
			((uint32_t)input[27] << 19) |
			((uint32_t)(input[28] & 0xe0) << 11);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 227 to 242
	value = ((uint32_t)(input[28] & 0x1f) << 27) |
			((uint32_t)input[29] << 19) |
			((uint32_t)(input[30] & 0xe0) << 11);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 243 to 258
	value = ((uint32_t)(input[30] & 0x1f) << 27) |
			((uint32_t)input[31] << 19) |
			((uint32_t)(input[32] & 0xe0) << 11);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 259 to 274
	value = ((uint32_t)(input[32] & 0x1f) << 27) |
			((uint32_t)input[33] << 19) |
			((uint32_t)(input[34] & 0xe0) << 11);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 275 to 290
	value = ((uint32_t)(input[34] & 0x1f) << 27) |
			((uint32_t)input[35] << 19) |
			((uint32_t)(input[36] & 0xe0) << 11);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 291 to 306
	value = ((uint32_t)(input[36] & 0x1f) << 27) |
			((uint32_t)input[37] << 19) |
			((uint32_t)(input[38] & 0xe0) << 11);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 307 to 322
	value = ((uint32_t)(input[38] & 0x1f) << 27) |
			((uint32_t)input[39] << 19) |
			((uint32_t)(input[40] & 0xe0) << 11);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 323 to 338
	value = ((uint32_t)(input[40] & 0x1f) << 27) |
			((uint32_t)input[41] << 19) |
			((uint32_t)(input[42] & 0xe0) << 11);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 339 to 354
	value = ((uint32_t)(input[42] & 0x1f) << 27) |
			((uint32_t)input[43] << 19) |
			((uint32_t)(input[44] & 0xe0) << 11);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 355 to 370
	value = ((uint32_t)(input[44] & 0x1f) << 27) |
			((uint32_t)input[45] << 19) |
			((uint32_t)(input[46] & 0xe0) << 11);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 371 to 386
	value = ((uint32_t)(input[46] & 0x1f) << 27) |
			((uint32_t)input[47] << 19) |
			((uint32_t)(input[48] & 0xe0) << 11);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 387 to 402
	value = ((uint32_t)(input[48] & 0x1f) << 27) |
			((uint32_t)input[49] << 19) |
			((uint32_t)(input[50] & 0xe0) << 11);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 403 to 418
	value = ((uint32_t)(input[50] & 0x1f) << 27) |
			((uint32_t)input[51] << 19) |
			((uint32_t)(input[52] & 0xe0) << 11);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 419 to 434
	value = ((uint32_t)(input[52] & 0x1f) << 27) |
			((uint32_t)input[53] << 19) |
			((uint32_t)(input[54] & 0xe0) << 11);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 435 to 450
	value = ((uint32_t)(input[54] & 0x1f) << 27) |
			((uint32_t)input[55] << 19) |
			((uint32_t)(input[56] & 0xe0) << 11);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 451 to 466
	value = ((uint32_t)(input[56] & 0x1f) << 27) |
			((uint32_t)input[57] << 19) |
			((uint32_t)(input[58] & 0xe0) << 11);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 467 to 482
	value = ((uint32_t)(input[58] & 0x1f) << 27) |
			((uint32_t)input[59] << 19) |
			((uint32_t)(input[60] & 0xe0) << 11);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 483 to 498
	value = ((uint32_t)(input[60] & 0x1f) << 27) |
			((uint32_t)input[61] << 19) |
			((uint32_t)(input[62] & 0xe0) << 11);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 499 to 514
	value = ((uint32_t)(input[62] & 0x1f) << 27) |
			((uint32_t)input[63] << 19) |
			((uint32_t)(input[64] & 0xe0) << 11);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 515 to 530
	value = ((uint32_t)(input[64] & 0x1f) << 27) |
			((uint32_t)input[65] << 19) |
			((uint32_t)(input[66] & 0xe0) << 11);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 531 to 546
	value = ((uint32_t)(input[66] & 0x1f) << 27) |
			((uint32_t)input[67] << 19) |
			((uint32_t)(input[68] & 0xe0) << 11);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 547 to 562
	value = ((uint32_t)(input[68] & 0x1f) << 27) |
			((uint32_t)input[69] << 19) |
			((uint32_t)(input[70] & 0xe0) << 11);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 563 to 578
	value = ((uint32_t)(input[70] & 0x1f) << 27) |
			((uint32_t)input[71] << 19) |
			((uint32_t)(input[72] & 0xe0) << 11);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 579 to 594
	value = ((uint32_t)(input[72] & 0x1f) << 27) |
			((uint32_t)input[73] << 19) |
			((uint32_t)(input[74] & 0xe0) << 11);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 595 to 610
	value = ((uint32_t)(input[74] & 0x1f) << 27) |
			((uint32_t)input[75] << 19) |
			((uint32_t)(input[76] & 0xe0) << 11);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 611 to 626
	value = ((uint32_t)(input[76] & 0x1f) << 27) |
			((uint32_t)input[77] << 19) |
			((uint32_t)(input[78] & 0xe0) << 11);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 627 to 642
	value = ((uint32_t)(input[78] & 0x1f) << 27) |
			((uint32_t)input[79] << 19) |
			((uint32_t)(input[80] & 0xe0) << 11);
	output[39] = (double)(value >> 16);

	// read output[40]: from bit 643 to 658
	value = ((uint32_t)(input[80] & 0x1f) << 27) |
			((uint32_t)input[81] << 19) |
			((uint32_t)(input[82] & 0xe0) << 11);
	output[40] = (double)(value >> 16);

	// read output[41]: from bit 659 to 674
	value = ((uint32_t)(input[82] & 0x1f) << 27) |
			((uint32_t)input[83] << 19) |
			((uint32_t)(input[84] & 0xe0) << 11);
	output[41] = (double)(value >> 16);

	// read output[42]: from bit 675 to 690
	value = ((uint32_t)(input[84] & 0x1f) << 27) |
			((uint32_t)input[85] << 19) |
			((uint32_t)(input[86] & 0xe0) << 11);
	output[42] = (double)(value >> 16);

	// read output[43]: from bit 691 to 706
	value = ((uint32_t)(input[86] & 0x1f) << 27) |
			((uint32_t)input[87] << 19) |
			((uint32_t)(input[88] & 0xe0) << 11);
	output[43] = (double)(value >> 16);

	// read output[44]: from bit 707 to 722
	value = ((uint32_t)(input[88] & 0x1f) << 27) |
			((uint32_t)input[89] << 19) |
			((uint32_t)(input[90] & 0xe0) << 11);
	output[44] = (double)(value >> 16);

	// read output[45]: from bit 723 to 738
	value = ((uint32_t)(input[90] & 0x1f) << 27) |
			((uint32_t)input[91] << 19) |
			((uint32_t)(input[92] & 0xe0) << 11);
	output[45] = (double)(value >> 16);

	// read output[46]: from bit 739 to 754
	value = ((uint32_t)(input[92] & 0x1f) << 27) |
			((uint32_t)input[93] << 19) |
			((uint32_t)(input[94] & 0xe0) << 11);
	output[46] = (double)(value >> 16);

	// read output[47]: from bit 755 to 770
	value = ((uint32_t)(input[94] & 0x1f) << 27) |
			((uint32_t)input[95] << 19) |
			((uint32_t)(input[96] & 0xe0) << 11);
	output[47] = (double)(value >> 16);

	// read output[48]: from bit 771 to 786
	value = ((uint32_t)(input[96] & 0x1f) << 27) |
			((uint32_t)input[97] << 19) |
			((uint32_t)(input[98] & 0xe0) << 11);
	output[48] = (double)(value >> 16);

	// read output[49]: from bit 787 to 802
	value = ((uint32_t)(input[98] & 0x1f) << 27) |
			((uint32_t)input[99] << 19) |
			((uint32_t)(input[100] & 0xe0) << 11);
	output[49] = (double)(value >> 16);

	// read output[50]: from bit 803 to 818
	value = ((uint32_t)(input[100] & 0x1f) << 27) |
			((uint32_t)input[101] << 19) |
			((uint32_t)(input[102] & 0xe0) << 11);
	output[50] = (double)(value >> 16);

	// read output[51]: from bit 819 to 834
	value = ((uint32_t)(input[102] & 0x1f) << 27) |
			((uint32_t)input[103] << 19) |
			((uint32_t)(input[104] & 0xe0) << 11);
	output[51] = (double)(value >> 16);

	// read output[52]: from bit 835 to 850
	value = ((uint32_t)(input[104] & 0x1f) << 27) |
			((uint32_t)input[105] << 19) |
			((uint32_t)(input[106] & 0xe0) << 11);
	output[52] = (double)(value >> 16);

	// read output[53]: from bit 851 to 866
	value = ((uint32_t)(input[106] & 0x1f) << 27) |
			((uint32_t)input[107] << 19) |
			((uint32_t)(input[108] & 0xe0) << 11);
	output[53] = (double)(value >> 16);

	// read output[54]: from bit 867 to 882
	value = ((uint32_t)(input[108] & 0x1f) << 27) |
			((uint32_t)input[109] << 19) |
			((uint32_t)(input[110] & 0xe0) << 11);
	output[54] = (double)(value >> 16);
}

static void unpack_55_16bit_unsigned_3off(const uint8_t * input, double * output, void *closure) {
	// Unpack 55 values into output
	// Values are 16-bit unsigned
	// Skip 3 bits, read 880 bits of data.
	// Input must be at least 111 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 3 to 18
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)input[1] << 19) |
			((uint32_t)(input[2] & 0xe0) << 11);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 19 to 34
	value = ((uint32_t)(input[2] & 0x1f) << 27) |
			((uint32_t)input[3] << 19) |
			((uint32_t)(input[4] & 0xe0) << 11);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 35 to 50
	value = ((uint32_t)(input[4] & 0x1f) << 27) |
			((uint32_t)input[5] << 19) |
			((uint32_t)(input[6] & 0xe0) << 11);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 51 to 66
	value = ((uint32_t)(input[6] & 0x1f) << 27) |
			((uint32_t)input[7] << 19) |
			((uint32_t)(input[8] & 0xe0) << 11);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 67 to 82
	value = ((uint32_t)(input[8] & 0x1f) << 27) |
			((uint32_t)input[9] << 19) |
			((uint32_t)(input[10] & 0xe0) << 11);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 83 to 98
	value = ((uint32_t)(input[10] & 0x1f) << 27) |
			((uint32_t)input[11] << 19) |
			((uint32_t)(input[12] & 0xe0) << 11);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 99 to 114
	value = ((uint32_t)(input[12] & 0x1f) << 27) |
			((uint32_t)input[13] << 19) |
			((uint32_t)(input[14] & 0xe0) << 11);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 115 to 130
	value = ((uint32_t)(input[14] & 0x1f) << 27) |
			((uint32_t)input[15] << 19) |
			((uint32_t)(input[16] & 0xe0) << 11);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 131 to 146
	value = ((uint32_t)(input[16] & 0x1f) << 27) |
			((uint32_t)input[17] << 19) |
			((uint32_t)(input[18] & 0xe0) << 11);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 147 to 162
	value = ((uint32_t)(input[18] & 0x1f) << 27) |
			((uint32_t)input[19] << 19) |
			((uint32_t)(input[20] & 0xe0) << 11);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 163 to 178
	value = ((uint32_t)(input[20] & 0x1f) << 27) |
			((uint32_t)input[21] << 19) |
			((uint32_t)(input[22] & 0xe0) << 11);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 179 to 194
	value = ((uint32_t)(input[22] & 0x1f) << 27) |
			((uint32_t)input[23] << 19) |
			((uint32_t)(input[24] & 0xe0) << 11);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 195 to 210
	value = ((uint32_t)(input[24] & 0x1f) << 27) |
			((uint32_t)input[25] << 19) |
			((uint32_t)(input[26] & 0xe0) << 11);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 211 to 226
	value = ((uint32_t)(input[26] & 0x1f) << 27) |
			((uint32_t)input[27] << 19) |
			((uint32_t)(input[28] & 0xe0) << 11);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 227 to 242
	value = ((uint32_t)(input[28] & 0x1f) << 27) |
			((uint32_t)input[29] << 19) |
			((uint32_t)(input[30] & 0xe0) << 11);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 243 to 258
	value = ((uint32_t)(input[30] & 0x1f) << 27) |
			((uint32_t)input[31] << 19) |
			((uint32_t)(input[32] & 0xe0) << 11);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 259 to 274
	value = ((uint32_t)(input[32] & 0x1f) << 27) |
			((uint32_t)input[33] << 19) |
			((uint32_t)(input[34] & 0xe0) << 11);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 275 to 290
	value = ((uint32_t)(input[34] & 0x1f) << 27) |
			((uint32_t)input[35] << 19) |
			((uint32_t)(input[36] & 0xe0) << 11);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 291 to 306
	value = ((uint32_t)(input[36] & 0x1f) << 27) |
			((uint32_t)input[37] << 19) |
			((uint32_t)(input[38] & 0xe0) << 11);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 307 to 322
	value = ((uint32_t)(input[38] & 0x1f) << 27) |
			((uint32_t)input[39] << 19) |
			((uint32_t)(input[40] & 0xe0) << 11);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 323 to 338
	value = ((uint32_t)(input[40] & 0x1f) << 27) |
			((uint32_t)input[41] << 19) |
			((uint32_t)(input[42] & 0xe0) << 11);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 339 to 354
	value = ((uint32_t)(input[42] & 0x1f) << 27) |
			((uint32_t)input[43] << 19) |
			((uint32_t)(input[44] & 0xe0) << 11);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 355 to 370
	value = ((uint32_t)(input[44] & 0x1f) << 27) |
			((uint32_t)input[45] << 19) |
			((uint32_t)(input[46] & 0xe0) << 11);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 371 to 386
	value = ((uint32_t)(input[46] & 0x1f) << 27) |
			((uint32_t)input[47] << 19) |
			((uint32_t)(input[48] & 0xe0) << 11);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 387 to 402
	value = ((uint32_t)(input[48] & 0x1f) << 27) |
			((uint32_t)input[49] << 19) |
			((uint32_t)(input[50] & 0xe0) << 11);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 403 to 418
	value = ((uint32_t)(input[50] & 0x1f) << 27) |
			((uint32_t)input[51] << 19) |
			((uint32_t)(input[52] & 0xe0) << 11);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 419 to 434
	value = ((uint32_t)(input[52] & 0x1f) << 27) |
			((uint32_t)input[53] << 19) |
			((uint32_t)(input[54] & 0xe0) << 11);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 435 to 450
	value = ((uint32_t)(input[54] & 0x1f) << 27) |
			((uint32_t)input[55] << 19) |
			((uint32_t)(input[56] & 0xe0) << 11);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 451 to 466
	value = ((uint32_t)(input[56] & 0x1f) << 27) |
			((uint32_t)input[57] << 19) |
			((uint32_t)(input[58] & 0xe0) << 11);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 467 to 482
	value = ((uint32_t)(input[58] & 0x1f) << 27) |
			((uint32_t)input[59] << 19) |
			((uint32_t)(input[60] & 0xe0) << 11);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 483 to 498
	value = ((uint32_t)(input[60] & 0x1f) << 27) |
			((uint32_t)input[61] << 19) |
			((uint32_t)(input[62] & 0xe0) << 11);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 499 to 514
	value = ((uint32_t)(input[62] & 0x1f) << 27) |
			((uint32_t)input[63] << 19) |
			((uint32_t)(input[64] & 0xe0) << 11);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 515 to 530
	value = ((uint32_t)(input[64] & 0x1f) << 27) |
			((uint32_t)input[65] << 19) |
			((uint32_t)(input[66] & 0xe0) << 11);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 531 to 546
	value = ((uint32_t)(input[66] & 0x1f) << 27) |
			((uint32_t)input[67] << 19) |
			((uint32_t)(input[68] & 0xe0) << 11);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 547 to 562
	value = ((uint32_t)(input[68] & 0x1f) << 27) |
			((uint32_t)input[69] << 19) |
			((uint32_t)(input[70] & 0xe0) << 11);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 563 to 578
	value = ((uint32_t)(input[70] & 0x1f) << 27) |
			((uint32_t)input[71] << 19) |
			((uint32_t)(input[72] & 0xe0) << 11);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 579 to 594
	value = ((uint32_t)(input[72] & 0x1f) << 27) |
			((uint32_t)input[73] << 19) |
			((uint32_t)(input[74] & 0xe0) << 11);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 595 to 610
	value = ((uint32_t)(input[74] & 0x1f) << 27) |
			((uint32_t)input[75] << 19) |
			((uint32_t)(input[76] & 0xe0) << 11);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 611 to 626
	value = ((uint32_t)(input[76] & 0x1f) << 27) |
			((uint32_t)input[77] << 19) |
			((uint32_t)(input[78] & 0xe0) << 11);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 627 to 642
	value = ((uint32_t)(input[78] & 0x1f) << 27) |
			((uint32_t)input[79] << 19) |
			((uint32_t)(input[80] & 0xe0) << 11);
	output[39] = (double)(value >> 16);

	// read output[40]: from bit 643 to 658
	value = ((uint32_t)(input[80] & 0x1f) << 27) |
			((uint32_t)input[81] << 19) |
			((uint32_t)(input[82] & 0xe0) << 11);
	output[40] = (double)(value >> 16);

	// read output[41]: from bit 659 to 674
	value = ((uint32_t)(input[82] & 0x1f) << 27) |
			((uint32_t)input[83] << 19) |
			((uint32_t)(input[84] & 0xe0) << 11);
	output[41] = (double)(value >> 16);

	// read output[42]: from bit 675 to 690
	value = ((uint32_t)(input[84] & 0x1f) << 27) |
			((uint32_t)input[85] << 19) |
			((uint32_t)(input[86] & 0xe0) << 11);
	output[42] = (double)(value >> 16);

	// read output[43]: from bit 691 to 706
	value = ((uint32_t)(input[86] & 0x1f) << 27) |
			((uint32_t)input[87] << 19) |
			((uint32_t)(input[88] & 0xe0) << 11);
	output[43] = (double)(value >> 16);

	// read output[44]: from bit 707 to 722
	value = ((uint32_t)(input[88] & 0x1f) << 27) |
			((uint32_t)input[89] << 19) |
			((uint32_t)(input[90] & 0xe0) << 11);
	output[44] = (double)(value >> 16);

	// read output[45]: from bit 723 to 738
	value = ((uint32_t)(input[90] & 0x1f) << 27) |
			((uint32_t)input[91] << 19) |
			((uint32_t)(input[92] & 0xe0) << 11);
	output[45] = (double)(value >> 16);

	// read output[46]: from bit 739 to 754
	value = ((uint32_t)(input[92] & 0x1f) << 27) |
			((uint32_t)input[93] << 19) |
			((uint32_t)(input[94] & 0xe0) << 11);
	output[46] = (double)(value >> 16);

	// read output[47]: from bit 755 to 770
	value = ((uint32_t)(input[94] & 0x1f) << 27) |
			((uint32_t)input[95] << 19) |
			((uint32_t)(input[96] & 0xe0) << 11);
	output[47] = (double)(value >> 16);

	// read output[48]: from bit 771 to 786
	value = ((uint32_t)(input[96] & 0x1f) << 27) |
			((uint32_t)input[97] << 19) |
			((uint32_t)(input[98] & 0xe0) << 11);
	output[48] = (double)(value >> 16);

	// read output[49]: from bit 787 to 802
	value = ((uint32_t)(input[98] & 0x1f) << 27) |
			((uint32_t)input[99] << 19) |
			((uint32_t)(input[100] & 0xe0) << 11);
	output[49] = (double)(value >> 16);

	// read output[50]: from bit 803 to 818
	value = ((uint32_t)(input[100] & 0x1f) << 27) |
			((uint32_t)input[101] << 19) |
			((uint32_t)(input[102] & 0xe0) << 11);
	output[50] = (double)(value >> 16);

	// read output[51]: from bit 819 to 834
	value = ((uint32_t)(input[102] & 0x1f) << 27) |
			((uint32_t)input[103] << 19) |
			((uint32_t)(input[104] & 0xe0) << 11);
	output[51] = (double)(value >> 16);

	// read output[52]: from bit 835 to 850
	value = ((uint32_t)(input[104] & 0x1f) << 27) |
			((uint32_t)input[105] << 19) |
			((uint32_t)(input[106] & 0xe0) << 11);
	output[52] = (double)(value >> 16);

	// read output[53]: from bit 851 to 866
	value = ((uint32_t)(input[106] & 0x1f) << 27) |
			((uint32_t)input[107] << 19) |
			((uint32_t)(input[108] & 0xe0) << 11);
	output[53] = (double)(value >> 16);

	// read output[54]: from bit 867 to 882
	value = ((uint32_t)(input[108] & 0x1f) << 27) |
			((uint32_t)input[109] << 19) |
			((uint32_t)(input[110] & 0xe0) << 11);
	output[54] = (double)(value >> 16);
}

static void unpack_55_16bit_signed_4off(const uint8_t * input, double * output, void *closure) {
	// Unpack 55 values into output
	// Values are 16-bit signed
	// Skip 4 bits, read 880 bits of data.
	// Input must be at least 111 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 4 to 19
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20) |
			((uint32_t)(input[2] & 0xf0) << 12);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 20 to 35
	value = ((uint32_t)(input[2] & 0x0f) << 28) |
			((uint32_t)input[3] << 20) |
			((uint32_t)(input[4] & 0xf0) << 12);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 36 to 51
	value = ((uint32_t)(input[4] & 0x0f) << 28) |
			((uint32_t)input[5] << 20) |
			((uint32_t)(input[6] & 0xf0) << 12);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 52 to 67
	value = ((uint32_t)(input[6] & 0x0f) << 28) |
			((uint32_t)input[7] << 20) |
			((uint32_t)(input[8] & 0xf0) << 12);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 68 to 83
	value = ((uint32_t)(input[8] & 0x0f) << 28) |
			((uint32_t)input[9] << 20) |
			((uint32_t)(input[10] & 0xf0) << 12);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 84 to 99
	value = ((uint32_t)(input[10] & 0x0f) << 28) |
			((uint32_t)input[11] << 20) |
			((uint32_t)(input[12] & 0xf0) << 12);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 100 to 115
	value = ((uint32_t)(input[12] & 0x0f) << 28) |
			((uint32_t)input[13] << 20) |
			((uint32_t)(input[14] & 0xf0) << 12);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 116 to 131
	value = ((uint32_t)(input[14] & 0x0f) << 28) |
			((uint32_t)input[15] << 20) |
			((uint32_t)(input[16] & 0xf0) << 12);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 132 to 147
	value = ((uint32_t)(input[16] & 0x0f) << 28) |
			((uint32_t)input[17] << 20) |
			((uint32_t)(input[18] & 0xf0) << 12);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 148 to 163
	value = ((uint32_t)(input[18] & 0x0f) << 28) |
			((uint32_t)input[19] << 20) |
			((uint32_t)(input[20] & 0xf0) << 12);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 164 to 179
	value = ((uint32_t)(input[20] & 0x0f) << 28) |
			((uint32_t)input[21] << 20) |
			((uint32_t)(input[22] & 0xf0) << 12);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 180 to 195
	value = ((uint32_t)(input[22] & 0x0f) << 28) |
			((uint32_t)input[23] << 20) |
			((uint32_t)(input[24] & 0xf0) << 12);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 196 to 211
	value = ((uint32_t)(input[24] & 0x0f) << 28) |
			((uint32_t)input[25] << 20) |
			((uint32_t)(input[26] & 0xf0) << 12);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 212 to 227
	value = ((uint32_t)(input[26] & 0x0f) << 28) |
			((uint32_t)input[27] << 20) |
			((uint32_t)(input[28] & 0xf0) << 12);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 228 to 243
	value = ((uint32_t)(input[28] & 0x0f) << 28) |
			((uint32_t)input[29] << 20) |
			((uint32_t)(input[30] & 0xf0) << 12);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 244 to 259
	value = ((uint32_t)(input[30] & 0x0f) << 28) |
			((uint32_t)input[31] << 20) |
			((uint32_t)(input[32] & 0xf0) << 12);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 260 to 275
	value = ((uint32_t)(input[32] & 0x0f) << 28) |
			((uint32_t)input[33] << 20) |
			((uint32_t)(input[34] & 0xf0) << 12);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 276 to 291
	value = ((uint32_t)(input[34] & 0x0f) << 28) |
			((uint32_t)input[35] << 20) |
			((uint32_t)(input[36] & 0xf0) << 12);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 292 to 307
	value = ((uint32_t)(input[36] & 0x0f) << 28) |
			((uint32_t)input[37] << 20) |
			((uint32_t)(input[38] & 0xf0) << 12);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 308 to 323
	value = ((uint32_t)(input[38] & 0x0f) << 28) |
			((uint32_t)input[39] << 20) |
			((uint32_t)(input[40] & 0xf0) << 12);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 324 to 339
	value = ((uint32_t)(input[40] & 0x0f) << 28) |
			((uint32_t)input[41] << 20) |
			((uint32_t)(input[42] & 0xf0) << 12);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 340 to 355
	value = ((uint32_t)(input[42] & 0x0f) << 28) |
			((uint32_t)input[43] << 20) |
			((uint32_t)(input[44] & 0xf0) << 12);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 356 to 371
	value = ((uint32_t)(input[44] & 0x0f) << 28) |
			((uint32_t)input[45] << 20) |
			((uint32_t)(input[46] & 0xf0) << 12);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 372 to 387
	value = ((uint32_t)(input[46] & 0x0f) << 28) |
			((uint32_t)input[47] << 20) |
			((uint32_t)(input[48] & 0xf0) << 12);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 388 to 403
	value = ((uint32_t)(input[48] & 0x0f) << 28) |
			((uint32_t)input[49] << 20) |
			((uint32_t)(input[50] & 0xf0) << 12);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 404 to 419
	value = ((uint32_t)(input[50] & 0x0f) << 28) |
			((uint32_t)input[51] << 20) |
			((uint32_t)(input[52] & 0xf0) << 12);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 420 to 435
	value = ((uint32_t)(input[52] & 0x0f) << 28) |
			((uint32_t)input[53] << 20) |
			((uint32_t)(input[54] & 0xf0) << 12);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 436 to 451
	value = ((uint32_t)(input[54] & 0x0f) << 28) |
			((uint32_t)input[55] << 20) |
			((uint32_t)(input[56] & 0xf0) << 12);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 452 to 467
	value = ((uint32_t)(input[56] & 0x0f) << 28) |
			((uint32_t)input[57] << 20) |
			((uint32_t)(input[58] & 0xf0) << 12);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 468 to 483
	value = ((uint32_t)(input[58] & 0x0f) << 28) |
			((uint32_t)input[59] << 20) |
			((uint32_t)(input[60] & 0xf0) << 12);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 484 to 499
	value = ((uint32_t)(input[60] & 0x0f) << 28) |
			((uint32_t)input[61] << 20) |
			((uint32_t)(input[62] & 0xf0) << 12);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 500 to 515
	value = ((uint32_t)(input[62] & 0x0f) << 28) |
			((uint32_t)input[63] << 20) |
			((uint32_t)(input[64] & 0xf0) << 12);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 516 to 531
	value = ((uint32_t)(input[64] & 0x0f) << 28) |
			((uint32_t)input[65] << 20) |
			((uint32_t)(input[66] & 0xf0) << 12);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 532 to 547
	value = ((uint32_t)(input[66] & 0x0f) << 28) |
			((uint32_t)input[67] << 20) |
			((uint32_t)(input[68] & 0xf0) << 12);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 548 to 563
	value = ((uint32_t)(input[68] & 0x0f) << 28) |
			((uint32_t)input[69] << 20) |
			((uint32_t)(input[70] & 0xf0) << 12);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 564 to 579
	value = ((uint32_t)(input[70] & 0x0f) << 28) |
			((uint32_t)input[71] << 20) |
			((uint32_t)(input[72] & 0xf0) << 12);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 580 to 595
	value = ((uint32_t)(input[72] & 0x0f) << 28) |
			((uint32_t)input[73] << 20) |
			((uint32_t)(input[74] & 0xf0) << 12);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 596 to 611
	value = ((uint32_t)(input[74] & 0x0f) << 28) |
			((uint32_t)input[75] << 20) |
			((uint32_t)(input[76] & 0xf0) << 12);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 612 to 627
	value = ((uint32_t)(input[76] & 0x0f) << 28) |
			((uint32_t)input[77] << 20) |
			((uint32_t)(input[78] & 0xf0) << 12);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 628 to 643
	value = ((uint32_t)(input[78] & 0x0f) << 28) |
			((uint32_t)input[79] << 20) |
			((uint32_t)(input[80] & 0xf0) << 12);
	output[39] = (double)(value >> 16);

	// read output[40]: from bit 644 to 659
	value = ((uint32_t)(input[80] & 0x0f) << 28) |
			((uint32_t)input[81] << 20) |
			((uint32_t)(input[82] & 0xf0) << 12);
	output[40] = (double)(value >> 16);

	// read output[41]: from bit 660 to 675
	value = ((uint32_t)(input[82] & 0x0f) << 28) |
			((uint32_t)input[83] << 20) |
			((uint32_t)(input[84] & 0xf0) << 12);
	output[41] = (double)(value >> 16);

	// read output[42]: from bit 676 to 691
	value = ((uint32_t)(input[84] & 0x0f) << 28) |
			((uint32_t)input[85] << 20) |
			((uint32_t)(input[86] & 0xf0) << 12);
	output[42] = (double)(value >> 16);

	// read output[43]: from bit 692 to 707
	value = ((uint32_t)(input[86] & 0x0f) << 28) |
			((uint32_t)input[87] << 20) |
			((uint32_t)(input[88] & 0xf0) << 12);
	output[43] = (double)(value >> 16);

	// read output[44]: from bit 708 to 723
	value = ((uint32_t)(input[88] & 0x0f) << 28) |
			((uint32_t)input[89] << 20) |
			((uint32_t)(input[90] & 0xf0) << 12);
	output[44] = (double)(value >> 16);

	// read output[45]: from bit 724 to 739
	value = ((uint32_t)(input[90] & 0x0f) << 28) |
			((uint32_t)input[91] << 20) |
			((uint32_t)(input[92] & 0xf0) << 12);
	output[45] = (double)(value >> 16);

	// read output[46]: from bit 740 to 755
	value = ((uint32_t)(input[92] & 0x0f) << 28) |
			((uint32_t)input[93] << 20) |
			((uint32_t)(input[94] & 0xf0) << 12);
	output[46] = (double)(value >> 16);

	// read output[47]: from bit 756 to 771
	value = ((uint32_t)(input[94] & 0x0f) << 28) |
			((uint32_t)input[95] << 20) |
			((uint32_t)(input[96] & 0xf0) << 12);
	output[47] = (double)(value >> 16);

	// read output[48]: from bit 772 to 787
	value = ((uint32_t)(input[96] & 0x0f) << 28) |
			((uint32_t)input[97] << 20) |
			((uint32_t)(input[98] & 0xf0) << 12);
	output[48] = (double)(value >> 16);

	// read output[49]: from bit 788 to 803
	value = ((uint32_t)(input[98] & 0x0f) << 28) |
			((uint32_t)input[99] << 20) |
			((uint32_t)(input[100] & 0xf0) << 12);
	output[49] = (double)(value >> 16);

	// read output[50]: from bit 804 to 819
	value = ((uint32_t)(input[100] & 0x0f) << 28) |
			((uint32_t)input[101] << 20) |
			((uint32_t)(input[102] & 0xf0) << 12);
	output[50] = (double)(value >> 16);

	// read output[51]: from bit 820 to 835
	value = ((uint32_t)(input[102] & 0x0f) << 28) |
			((uint32_t)input[103] << 20) |
			((uint32_t)(input[104] & 0xf0) << 12);
	output[51] = (double)(value >> 16);

	// read output[52]: from bit 836 to 851
	value = ((uint32_t)(input[104] & 0x0f) << 28) |
			((uint32_t)input[105] << 20) |
			((uint32_t)(input[106] & 0xf0) << 12);
	output[52] = (double)(value >> 16);

	// read output[53]: from bit 852 to 867
	value = ((uint32_t)(input[106] & 0x0f) << 28) |
			((uint32_t)input[107] << 20) |
			((uint32_t)(input[108] & 0xf0) << 12);
	output[53] = (double)(value >> 16);

	// read output[54]: from bit 868 to 883
	value = ((uint32_t)(input[108] & 0x0f) << 28) |
			((uint32_t)input[109] << 20) |
			((uint32_t)(input[110] & 0xf0) << 12);
	output[54] = (double)(value >> 16);
}

static void unpack_55_16bit_unsigned_4off(const uint8_t * input, double * output, void *closure) {
	// Unpack 55 values into output
	// Values are 16-bit unsigned
	// Skip 4 bits, read 880 bits of data.
	// Input must be at least 111 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 4 to 19
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20) |
			((uint32_t)(input[2] & 0xf0) << 12);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 20 to 35
	value = ((uint32_t)(input[2] & 0x0f) << 28) |
			((uint32_t)input[3] << 20) |
			((uint32_t)(input[4] & 0xf0) << 12);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 36 to 51
	value = ((uint32_t)(input[4] & 0x0f) << 28) |
			((uint32_t)input[5] << 20) |
			((uint32_t)(input[6] & 0xf0) << 12);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 52 to 67
	value = ((uint32_t)(input[6] & 0x0f) << 28) |
			((uint32_t)input[7] << 20) |
			((uint32_t)(input[8] & 0xf0) << 12);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 68 to 83
	value = ((uint32_t)(input[8] & 0x0f) << 28) |
			((uint32_t)input[9] << 20) |
			((uint32_t)(input[10] & 0xf0) << 12);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 84 to 99
	value = ((uint32_t)(input[10] & 0x0f) << 28) |
			((uint32_t)input[11] << 20) |
			((uint32_t)(input[12] & 0xf0) << 12);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 100 to 115
	value = ((uint32_t)(input[12] & 0x0f) << 28) |
			((uint32_t)input[13] << 20) |
			((uint32_t)(input[14] & 0xf0) << 12);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 116 to 131
	value = ((uint32_t)(input[14] & 0x0f) << 28) |
			((uint32_t)input[15] << 20) |
			((uint32_t)(input[16] & 0xf0) << 12);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 132 to 147
	value = ((uint32_t)(input[16] & 0x0f) << 28) |
			((uint32_t)input[17] << 20) |
			((uint32_t)(input[18] & 0xf0) << 12);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 148 to 163
	value = ((uint32_t)(input[18] & 0x0f) << 28) |
			((uint32_t)input[19] << 20) |
			((uint32_t)(input[20] & 0xf0) << 12);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 164 to 179
	value = ((uint32_t)(input[20] & 0x0f) << 28) |
			((uint32_t)input[21] << 20) |
			((uint32_t)(input[22] & 0xf0) << 12);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 180 to 195
	value = ((uint32_t)(input[22] & 0x0f) << 28) |
			((uint32_t)input[23] << 20) |
			((uint32_t)(input[24] & 0xf0) << 12);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 196 to 211
	value = ((uint32_t)(input[24] & 0x0f) << 28) |
			((uint32_t)input[25] << 20) |
			((uint32_t)(input[26] & 0xf0) << 12);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 212 to 227
	value = ((uint32_t)(input[26] & 0x0f) << 28) |
			((uint32_t)input[27] << 20) |
			((uint32_t)(input[28] & 0xf0) << 12);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 228 to 243
	value = ((uint32_t)(input[28] & 0x0f) << 28) |
			((uint32_t)input[29] << 20) |
			((uint32_t)(input[30] & 0xf0) << 12);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 244 to 259
	value = ((uint32_t)(input[30] & 0x0f) << 28) |
			((uint32_t)input[31] << 20) |
			((uint32_t)(input[32] & 0xf0) << 12);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 260 to 275
	value = ((uint32_t)(input[32] & 0x0f) << 28) |
			((uint32_t)input[33] << 20) |
			((uint32_t)(input[34] & 0xf0) << 12);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 276 to 291
	value = ((uint32_t)(input[34] & 0x0f) << 28) |
			((uint32_t)input[35] << 20) |
			((uint32_t)(input[36] & 0xf0) << 12);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 292 to 307
	value = ((uint32_t)(input[36] & 0x0f) << 28) |
			((uint32_t)input[37] << 20) |
			((uint32_t)(input[38] & 0xf0) << 12);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 308 to 323
	value = ((uint32_t)(input[38] & 0x0f) << 28) |
			((uint32_t)input[39] << 20) |
			((uint32_t)(input[40] & 0xf0) << 12);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 324 to 339
	value = ((uint32_t)(input[40] & 0x0f) << 28) |
			((uint32_t)input[41] << 20) |
			((uint32_t)(input[42] & 0xf0) << 12);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 340 to 355
	value = ((uint32_t)(input[42] & 0x0f) << 28) |
			((uint32_t)input[43] << 20) |
			((uint32_t)(input[44] & 0xf0) << 12);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 356 to 371
	value = ((uint32_t)(input[44] & 0x0f) << 28) |
			((uint32_t)input[45] << 20) |
			((uint32_t)(input[46] & 0xf0) << 12);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 372 to 387
	value = ((uint32_t)(input[46] & 0x0f) << 28) |
			((uint32_t)input[47] << 20) |
			((uint32_t)(input[48] & 0xf0) << 12);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 388 to 403
	value = ((uint32_t)(input[48] & 0x0f) << 28) |
			((uint32_t)input[49] << 20) |
			((uint32_t)(input[50] & 0xf0) << 12);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 404 to 419
	value = ((uint32_t)(input[50] & 0x0f) << 28) |
			((uint32_t)input[51] << 20) |
			((uint32_t)(input[52] & 0xf0) << 12);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 420 to 435
	value = ((uint32_t)(input[52] & 0x0f) << 28) |
			((uint32_t)input[53] << 20) |
			((uint32_t)(input[54] & 0xf0) << 12);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 436 to 451
	value = ((uint32_t)(input[54] & 0x0f) << 28) |
			((uint32_t)input[55] << 20) |
			((uint32_t)(input[56] & 0xf0) << 12);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 452 to 467
	value = ((uint32_t)(input[56] & 0x0f) << 28) |
			((uint32_t)input[57] << 20) |
			((uint32_t)(input[58] & 0xf0) << 12);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 468 to 483
	value = ((uint32_t)(input[58] & 0x0f) << 28) |
			((uint32_t)input[59] << 20) |
			((uint32_t)(input[60] & 0xf0) << 12);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 484 to 499
	value = ((uint32_t)(input[60] & 0x0f) << 28) |
			((uint32_t)input[61] << 20) |
			((uint32_t)(input[62] & 0xf0) << 12);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 500 to 515
	value = ((uint32_t)(input[62] & 0x0f) << 28) |
			((uint32_t)input[63] << 20) |
			((uint32_t)(input[64] & 0xf0) << 12);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 516 to 531
	value = ((uint32_t)(input[64] & 0x0f) << 28) |
			((uint32_t)input[65] << 20) |
			((uint32_t)(input[66] & 0xf0) << 12);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 532 to 547
	value = ((uint32_t)(input[66] & 0x0f) << 28) |
			((uint32_t)input[67] << 20) |
			((uint32_t)(input[68] & 0xf0) << 12);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 548 to 563
	value = ((uint32_t)(input[68] & 0x0f) << 28) |
			((uint32_t)input[69] << 20) |
			((uint32_t)(input[70] & 0xf0) << 12);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 564 to 579
	value = ((uint32_t)(input[70] & 0x0f) << 28) |
			((uint32_t)input[71] << 20) |
			((uint32_t)(input[72] & 0xf0) << 12);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 580 to 595
	value = ((uint32_t)(input[72] & 0x0f) << 28) |
			((uint32_t)input[73] << 20) |
			((uint32_t)(input[74] & 0xf0) << 12);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 596 to 611
	value = ((uint32_t)(input[74] & 0x0f) << 28) |
			((uint32_t)input[75] << 20) |
			((uint32_t)(input[76] & 0xf0) << 12);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 612 to 627
	value = ((uint32_t)(input[76] & 0x0f) << 28) |
			((uint32_t)input[77] << 20) |
			((uint32_t)(input[78] & 0xf0) << 12);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 628 to 643
	value = ((uint32_t)(input[78] & 0x0f) << 28) |
			((uint32_t)input[79] << 20) |
			((uint32_t)(input[80] & 0xf0) << 12);
	output[39] = (double)(value >> 16);

	// read output[40]: from bit 644 to 659
	value = ((uint32_t)(input[80] & 0x0f) << 28) |
			((uint32_t)input[81] << 20) |
			((uint32_t)(input[82] & 0xf0) << 12);
	output[40] = (double)(value >> 16);

	// read output[41]: from bit 660 to 675
	value = ((uint32_t)(input[82] & 0x0f) << 28) |
			((uint32_t)input[83] << 20) |
			((uint32_t)(input[84] & 0xf0) << 12);
	output[41] = (double)(value >> 16);

	// read output[42]: from bit 676 to 691
	value = ((uint32_t)(input[84] & 0x0f) << 28) |
			((uint32_t)input[85] << 20) |
			((uint32_t)(input[86] & 0xf0) << 12);
	output[42] = (double)(value >> 16);

	// read output[43]: from bit 692 to 707
	value = ((uint32_t)(input[86] & 0x0f) << 28) |
			((uint32_t)input[87] << 20) |
			((uint32_t)(input[88] & 0xf0) << 12);
	output[43] = (double)(value >> 16);

	// read output[44]: from bit 708 to 723
	value = ((uint32_t)(input[88] & 0x0f) << 28) |
			((uint32_t)input[89] << 20) |
			((uint32_t)(input[90] & 0xf0) << 12);
	output[44] = (double)(value >> 16);

	// read output[45]: from bit 724 to 739
	value = ((uint32_t)(input[90] & 0x0f) << 28) |
			((uint32_t)input[91] << 20) |
			((uint32_t)(input[92] & 0xf0) << 12);
	output[45] = (double)(value >> 16);

	// read output[46]: from bit 740 to 755
	value = ((uint32_t)(input[92] & 0x0f) << 28) |
			((uint32_t)input[93] << 20) |
			((uint32_t)(input[94] & 0xf0) << 12);
	output[46] = (double)(value >> 16);

	// read output[47]: from bit 756 to 771
	value = ((uint32_t)(input[94] & 0x0f) << 28) |
			((uint32_t)input[95] << 20) |
			((uint32_t)(input[96] & 0xf0) << 12);
	output[47] = (double)(value >> 16);

	// read output[48]: from bit 772 to 787
	value = ((uint32_t)(input[96] & 0x0f) << 28) |
			((uint32_t)input[97] << 20) |
			((uint32_t)(input[98] & 0xf0) << 12);
	output[48] = (double)(value >> 16);

	// read output[49]: from bit 788 to 803
	value = ((uint32_t)(input[98] & 0x0f) << 28) |
			((uint32_t)input[99] << 20) |
			((uint32_t)(input[100] & 0xf0) << 12);
	output[49] = (double)(value >> 16);

	// read output[50]: from bit 804 to 819
	value = ((uint32_t)(input[100] & 0x0f) << 28) |
			((uint32_t)input[101] << 20) |
			((uint32_t)(input[102] & 0xf0) << 12);
	output[50] = (double)(value >> 16);

	// read output[51]: from bit 820 to 835
	value = ((uint32_t)(input[102] & 0x0f) << 28) |
			((uint32_t)input[103] << 20) |
			((uint32_t)(input[104] & 0xf0) << 12);
	output[51] = (double)(value >> 16);

	// read output[52]: from bit 836 to 851
	value = ((uint32_t)(input[104] & 0x0f) << 28) |
			((uint32_t)input[105] << 20) |
			((uint32_t)(input[106] & 0xf0) << 12);
	output[52] = (double)(value >> 16);

	// read output[53]: from bit 852 to 867
	value = ((uint32_t)(input[106] & 0x0f) << 28) |
			((uint32_t)input[107] << 20) |
			((uint32_t)(input[108] & 0xf0) << 12);
	output[53] = (double)(value >> 16);

	// read output[54]: from bit 868 to 883
	value = ((uint32_t)(input[108] & 0x0f) << 28) |
			((uint32_t)input[109] << 20) |
			((uint32_t)(input[110] & 0xf0) << 12);
	output[54] = (double)(value >> 16);
}

static void unpack_55_16bit_signed_5off(const uint8_t * input, double * output, void *closure) {
	// Unpack 55 values into output
	// Values are 16-bit signed
	// Skip 5 bits, read 880 bits of data.
	// Input must be at least 111 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 5 to 20
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)(input[2] & 0xf8) << 13);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 21 to 36
	value = ((uint32_t)(input[2] & 0x07) << 29) |
			((uint32_t)input[3] << 21) |
			((uint32_t)(input[4] & 0xf8) << 13);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 37 to 52
	value = ((uint32_t)(input[4] & 0x07) << 29) |
			((uint32_t)input[5] << 21) |
			((uint32_t)(input[6] & 0xf8) << 13);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 53 to 68
	value = ((uint32_t)(input[6] & 0x07) << 29) |
			((uint32_t)input[7] << 21) |
			((uint32_t)(input[8] & 0xf8) << 13);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 69 to 84
	value = ((uint32_t)(input[8] & 0x07) << 29) |
			((uint32_t)input[9] << 21) |
			((uint32_t)(input[10] & 0xf8) << 13);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 85 to 100
	value = ((uint32_t)(input[10] & 0x07) << 29) |
			((uint32_t)input[11] << 21) |
			((uint32_t)(input[12] & 0xf8) << 13);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 101 to 116
	value = ((uint32_t)(input[12] & 0x07) << 29) |
			((uint32_t)input[13] << 21) |
			((uint32_t)(input[14] & 0xf8) << 13);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 117 to 132
	value = ((uint32_t)(input[14] & 0x07) << 29) |
			((uint32_t)input[15] << 21) |
			((uint32_t)(input[16] & 0xf8) << 13);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 133 to 148
	value = ((uint32_t)(input[16] & 0x07) << 29) |
			((uint32_t)input[17] << 21) |
			((uint32_t)(input[18] & 0xf8) << 13);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 149 to 164
	value = ((uint32_t)(input[18] & 0x07) << 29) |
			((uint32_t)input[19] << 21) |
			((uint32_t)(input[20] & 0xf8) << 13);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 165 to 180
	value = ((uint32_t)(input[20] & 0x07) << 29) |
			((uint32_t)input[21] << 21) |
			((uint32_t)(input[22] & 0xf8) << 13);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 181 to 196
	value = ((uint32_t)(input[22] & 0x07) << 29) |
			((uint32_t)input[23] << 21) |
			((uint32_t)(input[24] & 0xf8) << 13);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 197 to 212
	value = ((uint32_t)(input[24] & 0x07) << 29) |
			((uint32_t)input[25] << 21) |
			((uint32_t)(input[26] & 0xf8) << 13);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 213 to 228
	value = ((uint32_t)(input[26] & 0x07) << 29) |
			((uint32_t)input[27] << 21) |
			((uint32_t)(input[28] & 0xf8) << 13);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 229 to 244
	value = ((uint32_t)(input[28] & 0x07) << 29) |
			((uint32_t)input[29] << 21) |
			((uint32_t)(input[30] & 0xf8) << 13);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 245 to 260
	value = ((uint32_t)(input[30] & 0x07) << 29) |
			((uint32_t)input[31] << 21) |
			((uint32_t)(input[32] & 0xf8) << 13);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 261 to 276
	value = ((uint32_t)(input[32] & 0x07) << 29) |
			((uint32_t)input[33] << 21) |
			((uint32_t)(input[34] & 0xf8) << 13);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 277 to 292
	value = ((uint32_t)(input[34] & 0x07) << 29) |
			((uint32_t)input[35] << 21) |
			((uint32_t)(input[36] & 0xf8) << 13);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 293 to 308
	value = ((uint32_t)(input[36] & 0x07) << 29) |
			((uint32_t)input[37] << 21) |
			((uint32_t)(input[38] & 0xf8) << 13);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 309 to 324
	value = ((uint32_t)(input[38] & 0x07) << 29) |
			((uint32_t)input[39] << 21) |
			((uint32_t)(input[40] & 0xf8) << 13);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 325 to 340
	value = ((uint32_t)(input[40] & 0x07) << 29) |
			((uint32_t)input[41] << 21) |
			((uint32_t)(input[42] & 0xf8) << 13);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 341 to 356
	value = ((uint32_t)(input[42] & 0x07) << 29) |
			((uint32_t)input[43] << 21) |
			((uint32_t)(input[44] & 0xf8) << 13);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 357 to 372
	value = ((uint32_t)(input[44] & 0x07) << 29) |
			((uint32_t)input[45] << 21) |
			((uint32_t)(input[46] & 0xf8) << 13);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 373 to 388
	value = ((uint32_t)(input[46] & 0x07) << 29) |
			((uint32_t)input[47] << 21) |
			((uint32_t)(input[48] & 0xf8) << 13);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 389 to 404
	value = ((uint32_t)(input[48] & 0x07) << 29) |
			((uint32_t)input[49] << 21) |
			((uint32_t)(input[50] & 0xf8) << 13);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 405 to 420
	value = ((uint32_t)(input[50] & 0x07) << 29) |
			((uint32_t)input[51] << 21) |
			((uint32_t)(input[52] & 0xf8) << 13);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 421 to 436
	value = ((uint32_t)(input[52] & 0x07) << 29) |
			((uint32_t)input[53] << 21) |
			((uint32_t)(input[54] & 0xf8) << 13);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 437 to 452
	value = ((uint32_t)(input[54] & 0x07) << 29) |
			((uint32_t)input[55] << 21) |
			((uint32_t)(input[56] & 0xf8) << 13);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 453 to 468
	value = ((uint32_t)(input[56] & 0x07) << 29) |
			((uint32_t)input[57] << 21) |
			((uint32_t)(input[58] & 0xf8) << 13);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 469 to 484
	value = ((uint32_t)(input[58] & 0x07) << 29) |
			((uint32_t)input[59] << 21) |
			((uint32_t)(input[60] & 0xf8) << 13);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 485 to 500
	value = ((uint32_t)(input[60] & 0x07) << 29) |
			((uint32_t)input[61] << 21) |
			((uint32_t)(input[62] & 0xf8) << 13);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 501 to 516
	value = ((uint32_t)(input[62] & 0x07) << 29) |
			((uint32_t)input[63] << 21) |
			((uint32_t)(input[64] & 0xf8) << 13);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 517 to 532
	value = ((uint32_t)(input[64] & 0x07) << 29) |
			((uint32_t)input[65] << 21) |
			((uint32_t)(input[66] & 0xf8) << 13);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 533 to 548
	value = ((uint32_t)(input[66] & 0x07) << 29) |
			((uint32_t)input[67] << 21) |
			((uint32_t)(input[68] & 0xf8) << 13);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 549 to 564
	value = ((uint32_t)(input[68] & 0x07) << 29) |
			((uint32_t)input[69] << 21) |
			((uint32_t)(input[70] & 0xf8) << 13);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 565 to 580
	value = ((uint32_t)(input[70] & 0x07) << 29) |
			((uint32_t)input[71] << 21) |
			((uint32_t)(input[72] & 0xf8) << 13);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 581 to 596
	value = ((uint32_t)(input[72] & 0x07) << 29) |
			((uint32_t)input[73] << 21) |
			((uint32_t)(input[74] & 0xf8) << 13);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 597 to 612
	value = ((uint32_t)(input[74] & 0x07) << 29) |
			((uint32_t)input[75] << 21) |
			((uint32_t)(input[76] & 0xf8) << 13);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 613 to 628
	value = ((uint32_t)(input[76] & 0x07) << 29) |
			((uint32_t)input[77] << 21) |
			((uint32_t)(input[78] & 0xf8) << 13);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 629 to 644
	value = ((uint32_t)(input[78] & 0x07) << 29) |
			((uint32_t)input[79] << 21) |
			((uint32_t)(input[80] & 0xf8) << 13);
	output[39] = (double)(value >> 16);

	// read output[40]: from bit 645 to 660
	value = ((uint32_t)(input[80] & 0x07) << 29) |
			((uint32_t)input[81] << 21) |
			((uint32_t)(input[82] & 0xf8) << 13);
	output[40] = (double)(value >> 16);

	// read output[41]: from bit 661 to 676
	value = ((uint32_t)(input[82] & 0x07) << 29) |
			((uint32_t)input[83] << 21) |
			((uint32_t)(input[84] & 0xf8) << 13);
	output[41] = (double)(value >> 16);

	// read output[42]: from bit 677 to 692
	value = ((uint32_t)(input[84] & 0x07) << 29) |
			((uint32_t)input[85] << 21) |
			((uint32_t)(input[86] & 0xf8) << 13);
	output[42] = (double)(value >> 16);

	// read output[43]: from bit 693 to 708
	value = ((uint32_t)(input[86] & 0x07) << 29) |
			((uint32_t)input[87] << 21) |
			((uint32_t)(input[88] & 0xf8) << 13);
	output[43] = (double)(value >> 16);

	// read output[44]: from bit 709 to 724
	value = ((uint32_t)(input[88] & 0x07) << 29) |
			((uint32_t)input[89] << 21) |
			((uint32_t)(input[90] & 0xf8) << 13);
	output[44] = (double)(value >> 16);

	// read output[45]: from bit 725 to 740
	value = ((uint32_t)(input[90] & 0x07) << 29) |
			((uint32_t)input[91] << 21) |
			((uint32_t)(input[92] & 0xf8) << 13);
	output[45] = (double)(value >> 16);

	// read output[46]: from bit 741 to 756
	value = ((uint32_t)(input[92] & 0x07) << 29) |
			((uint32_t)input[93] << 21) |
			((uint32_t)(input[94] & 0xf8) << 13);
	output[46] = (double)(value >> 16);

	// read output[47]: from bit 757 to 772
	value = ((uint32_t)(input[94] & 0x07) << 29) |
			((uint32_t)input[95] << 21) |
			((uint32_t)(input[96] & 0xf8) << 13);
	output[47] = (double)(value >> 16);

	// read output[48]: from bit 773 to 788
	value = ((uint32_t)(input[96] & 0x07) << 29) |
			((uint32_t)input[97] << 21) |
			((uint32_t)(input[98] & 0xf8) << 13);
	output[48] = (double)(value >> 16);

	// read output[49]: from bit 789 to 804
	value = ((uint32_t)(input[98] & 0x07) << 29) |
			((uint32_t)input[99] << 21) |
			((uint32_t)(input[100] & 0xf8) << 13);
	output[49] = (double)(value >> 16);

	// read output[50]: from bit 805 to 820
	value = ((uint32_t)(input[100] & 0x07) << 29) |
			((uint32_t)input[101] << 21) |
			((uint32_t)(input[102] & 0xf8) << 13);
	output[50] = (double)(value >> 16);

	// read output[51]: from bit 821 to 836
	value = ((uint32_t)(input[102] & 0x07) << 29) |
			((uint32_t)input[103] << 21) |
			((uint32_t)(input[104] & 0xf8) << 13);
	output[51] = (double)(value >> 16);

	// read output[52]: from bit 837 to 852
	value = ((uint32_t)(input[104] & 0x07) << 29) |
			((uint32_t)input[105] << 21) |
			((uint32_t)(input[106] & 0xf8) << 13);
	output[52] = (double)(value >> 16);

	// read output[53]: from bit 853 to 868
	value = ((uint32_t)(input[106] & 0x07) << 29) |
			((uint32_t)input[107] << 21) |
			((uint32_t)(input[108] & 0xf8) << 13);
	output[53] = (double)(value >> 16);

	// read output[54]: from bit 869 to 884
	value = ((uint32_t)(input[108] & 0x07) << 29) |
			((uint32_t)input[109] << 21) |
			((uint32_t)(input[110] & 0xf8) << 13);
	output[54] = (double)(value >> 16);
}

static void unpack_55_16bit_unsigned_5off(const uint8_t * input, double * output, void *closure) {
	// Unpack 55 values into output
	// Values are 16-bit unsigned
	// Skip 5 bits, read 880 bits of data.
	// Input must be at least 111 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 5 to 20
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)(input[2] & 0xf8) << 13);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 21 to 36
	value = ((uint32_t)(input[2] & 0x07) << 29) |
			((uint32_t)input[3] << 21) |
			((uint32_t)(input[4] & 0xf8) << 13);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 37 to 52
	value = ((uint32_t)(input[4] & 0x07) << 29) |
			((uint32_t)input[5] << 21) |
			((uint32_t)(input[6] & 0xf8) << 13);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 53 to 68
	value = ((uint32_t)(input[6] & 0x07) << 29) |
			((uint32_t)input[7] << 21) |
			((uint32_t)(input[8] & 0xf8) << 13);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 69 to 84
	value = ((uint32_t)(input[8] & 0x07) << 29) |
			((uint32_t)input[9] << 21) |
			((uint32_t)(input[10] & 0xf8) << 13);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 85 to 100
	value = ((uint32_t)(input[10] & 0x07) << 29) |
			((uint32_t)input[11] << 21) |
			((uint32_t)(input[12] & 0xf8) << 13);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 101 to 116
	value = ((uint32_t)(input[12] & 0x07) << 29) |
			((uint32_t)input[13] << 21) |
			((uint32_t)(input[14] & 0xf8) << 13);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 117 to 132
	value = ((uint32_t)(input[14] & 0x07) << 29) |
			((uint32_t)input[15] << 21) |
			((uint32_t)(input[16] & 0xf8) << 13);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 133 to 148
	value = ((uint32_t)(input[16] & 0x07) << 29) |
			((uint32_t)input[17] << 21) |
			((uint32_t)(input[18] & 0xf8) << 13);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 149 to 164
	value = ((uint32_t)(input[18] & 0x07) << 29) |
			((uint32_t)input[19] << 21) |
			((uint32_t)(input[20] & 0xf8) << 13);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 165 to 180
	value = ((uint32_t)(input[20] & 0x07) << 29) |
			((uint32_t)input[21] << 21) |
			((uint32_t)(input[22] & 0xf8) << 13);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 181 to 196
	value = ((uint32_t)(input[22] & 0x07) << 29) |
			((uint32_t)input[23] << 21) |
			((uint32_t)(input[24] & 0xf8) << 13);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 197 to 212
	value = ((uint32_t)(input[24] & 0x07) << 29) |
			((uint32_t)input[25] << 21) |
			((uint32_t)(input[26] & 0xf8) << 13);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 213 to 228
	value = ((uint32_t)(input[26] & 0x07) << 29) |
			((uint32_t)input[27] << 21) |
			((uint32_t)(input[28] & 0xf8) << 13);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 229 to 244
	value = ((uint32_t)(input[28] & 0x07) << 29) |
			((uint32_t)input[29] << 21) |
			((uint32_t)(input[30] & 0xf8) << 13);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 245 to 260
	value = ((uint32_t)(input[30] & 0x07) << 29) |
			((uint32_t)input[31] << 21) |
			((uint32_t)(input[32] & 0xf8) << 13);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 261 to 276
	value = ((uint32_t)(input[32] & 0x07) << 29) |
			((uint32_t)input[33] << 21) |
			((uint32_t)(input[34] & 0xf8) << 13);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 277 to 292
	value = ((uint32_t)(input[34] & 0x07) << 29) |
			((uint32_t)input[35] << 21) |
			((uint32_t)(input[36] & 0xf8) << 13);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 293 to 308
	value = ((uint32_t)(input[36] & 0x07) << 29) |
			((uint32_t)input[37] << 21) |
			((uint32_t)(input[38] & 0xf8) << 13);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 309 to 324
	value = ((uint32_t)(input[38] & 0x07) << 29) |
			((uint32_t)input[39] << 21) |
			((uint32_t)(input[40] & 0xf8) << 13);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 325 to 340
	value = ((uint32_t)(input[40] & 0x07) << 29) |
			((uint32_t)input[41] << 21) |
			((uint32_t)(input[42] & 0xf8) << 13);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 341 to 356
	value = ((uint32_t)(input[42] & 0x07) << 29) |
			((uint32_t)input[43] << 21) |
			((uint32_t)(input[44] & 0xf8) << 13);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 357 to 372
	value = ((uint32_t)(input[44] & 0x07) << 29) |
			((uint32_t)input[45] << 21) |
			((uint32_t)(input[46] & 0xf8) << 13);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 373 to 388
	value = ((uint32_t)(input[46] & 0x07) << 29) |
			((uint32_t)input[47] << 21) |
			((uint32_t)(input[48] & 0xf8) << 13);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 389 to 404
	value = ((uint32_t)(input[48] & 0x07) << 29) |
			((uint32_t)input[49] << 21) |
			((uint32_t)(input[50] & 0xf8) << 13);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 405 to 420
	value = ((uint32_t)(input[50] & 0x07) << 29) |
			((uint32_t)input[51] << 21) |
			((uint32_t)(input[52] & 0xf8) << 13);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 421 to 436
	value = ((uint32_t)(input[52] & 0x07) << 29) |
			((uint32_t)input[53] << 21) |
			((uint32_t)(input[54] & 0xf8) << 13);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 437 to 452
	value = ((uint32_t)(input[54] & 0x07) << 29) |
			((uint32_t)input[55] << 21) |
			((uint32_t)(input[56] & 0xf8) << 13);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 453 to 468
	value = ((uint32_t)(input[56] & 0x07) << 29) |
			((uint32_t)input[57] << 21) |
			((uint32_t)(input[58] & 0xf8) << 13);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 469 to 484
	value = ((uint32_t)(input[58] & 0x07) << 29) |
			((uint32_t)input[59] << 21) |
			((uint32_t)(input[60] & 0xf8) << 13);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 485 to 500
	value = ((uint32_t)(input[60] & 0x07) << 29) |
			((uint32_t)input[61] << 21) |
			((uint32_t)(input[62] & 0xf8) << 13);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 501 to 516
	value = ((uint32_t)(input[62] & 0x07) << 29) |
			((uint32_t)input[63] << 21) |
			((uint32_t)(input[64] & 0xf8) << 13);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 517 to 532
	value = ((uint32_t)(input[64] & 0x07) << 29) |
			((uint32_t)input[65] << 21) |
			((uint32_t)(input[66] & 0xf8) << 13);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 533 to 548
	value = ((uint32_t)(input[66] & 0x07) << 29) |
			((uint32_t)input[67] << 21) |
			((uint32_t)(input[68] & 0xf8) << 13);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 549 to 564
	value = ((uint32_t)(input[68] & 0x07) << 29) |
			((uint32_t)input[69] << 21) |
			((uint32_t)(input[70] & 0xf8) << 13);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 565 to 580
	value = ((uint32_t)(input[70] & 0x07) << 29) |
			((uint32_t)input[71] << 21) |
			((uint32_t)(input[72] & 0xf8) << 13);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 581 to 596
	value = ((uint32_t)(input[72] & 0x07) << 29) |
			((uint32_t)input[73] << 21) |
			((uint32_t)(input[74] & 0xf8) << 13);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 597 to 612
	value = ((uint32_t)(input[74] & 0x07) << 29) |
			((uint32_t)input[75] << 21) |
			((uint32_t)(input[76] & 0xf8) << 13);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 613 to 628
	value = ((uint32_t)(input[76] & 0x07) << 29) |
			((uint32_t)input[77] << 21) |
			((uint32_t)(input[78] & 0xf8) << 13);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 629 to 644
	value = ((uint32_t)(input[78] & 0x07) << 29) |
			((uint32_t)input[79] << 21) |
			((uint32_t)(input[80] & 0xf8) << 13);
	output[39] = (double)(value >> 16);

	// read output[40]: from bit 645 to 660
	value = ((uint32_t)(input[80] & 0x07) << 29) |
			((uint32_t)input[81] << 21) |
			((uint32_t)(input[82] & 0xf8) << 13);
	output[40] = (double)(value >> 16);

	// read output[41]: from bit 661 to 676
	value = ((uint32_t)(input[82] & 0x07) << 29) |
			((uint32_t)input[83] << 21) |
			((uint32_t)(input[84] & 0xf8) << 13);
	output[41] = (double)(value >> 16);

	// read output[42]: from bit 677 to 692
	value = ((uint32_t)(input[84] & 0x07) << 29) |
			((uint32_t)input[85] << 21) |
			((uint32_t)(input[86] & 0xf8) << 13);
	output[42] = (double)(value >> 16);

	// read output[43]: from bit 693 to 708
	value = ((uint32_t)(input[86] & 0x07) << 29) |
			((uint32_t)input[87] << 21) |
			((uint32_t)(input[88] & 0xf8) << 13);
	output[43] = (double)(value >> 16);

	// read output[44]: from bit 709 to 724
	value = ((uint32_t)(input[88] & 0x07) << 29) |
			((uint32_t)input[89] << 21) |
			((uint32_t)(input[90] & 0xf8) << 13);
	output[44] = (double)(value >> 16);

	// read output[45]: from bit 725 to 740
	value = ((uint32_t)(input[90] & 0x07) << 29) |
			((uint32_t)input[91] << 21) |
			((uint32_t)(input[92] & 0xf8) << 13);
	output[45] = (double)(value >> 16);

	// read output[46]: from bit 741 to 756
	value = ((uint32_t)(input[92] & 0x07) << 29) |
			((uint32_t)input[93] << 21) |
			((uint32_t)(input[94] & 0xf8) << 13);
	output[46] = (double)(value >> 16);

	// read output[47]: from bit 757 to 772
	value = ((uint32_t)(input[94] & 0x07) << 29) |
			((uint32_t)input[95] << 21) |
			((uint32_t)(input[96] & 0xf8) << 13);
	output[47] = (double)(value >> 16);

	// read output[48]: from bit 773 to 788
	value = ((uint32_t)(input[96] & 0x07) << 29) |
			((uint32_t)input[97] << 21) |
			((uint32_t)(input[98] & 0xf8) << 13);
	output[48] = (double)(value >> 16);

	// read output[49]: from bit 789 to 804
	value = ((uint32_t)(input[98] & 0x07) << 29) |
			((uint32_t)input[99] << 21) |
			((uint32_t)(input[100] & 0xf8) << 13);
	output[49] = (double)(value >> 16);

	// read output[50]: from bit 805 to 820
	value = ((uint32_t)(input[100] & 0x07) << 29) |
			((uint32_t)input[101] << 21) |
			((uint32_t)(input[102] & 0xf8) << 13);
	output[50] = (double)(value >> 16);

	// read output[51]: from bit 821 to 836
	value = ((uint32_t)(input[102] & 0x07) << 29) |
			((uint32_t)input[103] << 21) |
			((uint32_t)(input[104] & 0xf8) << 13);
	output[51] = (double)(value >> 16);

	// read output[52]: from bit 837 to 852
	value = ((uint32_t)(input[104] & 0x07) << 29) |
			((uint32_t)input[105] << 21) |
			((uint32_t)(input[106] & 0xf8) << 13);
	output[52] = (double)(value >> 16);

	// read output[53]: from bit 853 to 868
	value = ((uint32_t)(input[106] & 0x07) << 29) |
			((uint32_t)input[107] << 21) |
			((uint32_t)(input[108] & 0xf8) << 13);
	output[53] = (double)(value >> 16);

	// read output[54]: from bit 869 to 884
	value = ((uint32_t)(input[108] & 0x07) << 29) |
			((uint32_t)input[109] << 21) |
			((uint32_t)(input[110] & 0xf8) << 13);
	output[54] = (double)(value >> 16);
}

static void unpack_55_16bit_signed_6off(const uint8_t * input, double * output, void *closure) {
	// Unpack 55 values into output
	// Values are 16-bit signed
	// Skip 6 bits, read 880 bits of data.
	// Input must be at least 111 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 6 to 21
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)(input[2] & 0xfc) << 14);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 22 to 37
	value = ((uint32_t)(input[2] & 0x03) << 30) |
			((uint32_t)input[3] << 22) |
			((uint32_t)(input[4] & 0xfc) << 14);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 38 to 53
	value = ((uint32_t)(input[4] & 0x03) << 30) |
			((uint32_t)input[5] << 22) |
			((uint32_t)(input[6] & 0xfc) << 14);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 54 to 69
	value = ((uint32_t)(input[6] & 0x03) << 30) |
			((uint32_t)input[7] << 22) |
			((uint32_t)(input[8] & 0xfc) << 14);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 70 to 85
	value = ((uint32_t)(input[8] & 0x03) << 30) |
			((uint32_t)input[9] << 22) |
			((uint32_t)(input[10] & 0xfc) << 14);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 86 to 101
	value = ((uint32_t)(input[10] & 0x03) << 30) |
			((uint32_t)input[11] << 22) |
			((uint32_t)(input[12] & 0xfc) << 14);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 102 to 117
	value = ((uint32_t)(input[12] & 0x03) << 30) |
			((uint32_t)input[13] << 22) |
			((uint32_t)(input[14] & 0xfc) << 14);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 118 to 133
	value = ((uint32_t)(input[14] & 0x03) << 30) |
			((uint32_t)input[15] << 22) |
			((uint32_t)(input[16] & 0xfc) << 14);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 134 to 149
	value = ((uint32_t)(input[16] & 0x03) << 30) |
			((uint32_t)input[17] << 22) |
			((uint32_t)(input[18] & 0xfc) << 14);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 150 to 165
	value = ((uint32_t)(input[18] & 0x03) << 30) |
			((uint32_t)input[19] << 22) |
			((uint32_t)(input[20] & 0xfc) << 14);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 166 to 181
	value = ((uint32_t)(input[20] & 0x03) << 30) |
			((uint32_t)input[21] << 22) |
			((uint32_t)(input[22] & 0xfc) << 14);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 182 to 197
	value = ((uint32_t)(input[22] & 0x03) << 30) |
			((uint32_t)input[23] << 22) |
			((uint32_t)(input[24] & 0xfc) << 14);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 198 to 213
	value = ((uint32_t)(input[24] & 0x03) << 30) |
			((uint32_t)input[25] << 22) |
			((uint32_t)(input[26] & 0xfc) << 14);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 214 to 229
	value = ((uint32_t)(input[26] & 0x03) << 30) |
			((uint32_t)input[27] << 22) |
			((uint32_t)(input[28] & 0xfc) << 14);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 230 to 245
	value = ((uint32_t)(input[28] & 0x03) << 30) |
			((uint32_t)input[29] << 22) |
			((uint32_t)(input[30] & 0xfc) << 14);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 246 to 261
	value = ((uint32_t)(input[30] & 0x03) << 30) |
			((uint32_t)input[31] << 22) |
			((uint32_t)(input[32] & 0xfc) << 14);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 262 to 277
	value = ((uint32_t)(input[32] & 0x03) << 30) |
			((uint32_t)input[33] << 22) |
			((uint32_t)(input[34] & 0xfc) << 14);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 278 to 293
	value = ((uint32_t)(input[34] & 0x03) << 30) |
			((uint32_t)input[35] << 22) |
			((uint32_t)(input[36] & 0xfc) << 14);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 294 to 309
	value = ((uint32_t)(input[36] & 0x03) << 30) |
			((uint32_t)input[37] << 22) |
			((uint32_t)(input[38] & 0xfc) << 14);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 310 to 325
	value = ((uint32_t)(input[38] & 0x03) << 30) |
			((uint32_t)input[39] << 22) |
			((uint32_t)(input[40] & 0xfc) << 14);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 326 to 341
	value = ((uint32_t)(input[40] & 0x03) << 30) |
			((uint32_t)input[41] << 22) |
			((uint32_t)(input[42] & 0xfc) << 14);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 342 to 357
	value = ((uint32_t)(input[42] & 0x03) << 30) |
			((uint32_t)input[43] << 22) |
			((uint32_t)(input[44] & 0xfc) << 14);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 358 to 373
	value = ((uint32_t)(input[44] & 0x03) << 30) |
			((uint32_t)input[45] << 22) |
			((uint32_t)(input[46] & 0xfc) << 14);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 374 to 389
	value = ((uint32_t)(input[46] & 0x03) << 30) |
			((uint32_t)input[47] << 22) |
			((uint32_t)(input[48] & 0xfc) << 14);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 390 to 405
	value = ((uint32_t)(input[48] & 0x03) << 30) |
			((uint32_t)input[49] << 22) |
			((uint32_t)(input[50] & 0xfc) << 14);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 406 to 421
	value = ((uint32_t)(input[50] & 0x03) << 30) |
			((uint32_t)input[51] << 22) |
			((uint32_t)(input[52] & 0xfc) << 14);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 422 to 437
	value = ((uint32_t)(input[52] & 0x03) << 30) |
			((uint32_t)input[53] << 22) |
			((uint32_t)(input[54] & 0xfc) << 14);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 438 to 453
	value = ((uint32_t)(input[54] & 0x03) << 30) |
			((uint32_t)input[55] << 22) |
			((uint32_t)(input[56] & 0xfc) << 14);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 454 to 469
	value = ((uint32_t)(input[56] & 0x03) << 30) |
			((uint32_t)input[57] << 22) |
			((uint32_t)(input[58] & 0xfc) << 14);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 470 to 485
	value = ((uint32_t)(input[58] & 0x03) << 30) |
			((uint32_t)input[59] << 22) |
			((uint32_t)(input[60] & 0xfc) << 14);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 486 to 501
	value = ((uint32_t)(input[60] & 0x03) << 30) |
			((uint32_t)input[61] << 22) |
			((uint32_t)(input[62] & 0xfc) << 14);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 502 to 517
	value = ((uint32_t)(input[62] & 0x03) << 30) |
			((uint32_t)input[63] << 22) |
			((uint32_t)(input[64] & 0xfc) << 14);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 518 to 533
	value = ((uint32_t)(input[64] & 0x03) << 30) |
			((uint32_t)input[65] << 22) |
			((uint32_t)(input[66] & 0xfc) << 14);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 534 to 549
	value = ((uint32_t)(input[66] & 0x03) << 30) |
			((uint32_t)input[67] << 22) |
			((uint32_t)(input[68] & 0xfc) << 14);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 550 to 565
	value = ((uint32_t)(input[68] & 0x03) << 30) |
			((uint32_t)input[69] << 22) |
			((uint32_t)(input[70] & 0xfc) << 14);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 566 to 581
	value = ((uint32_t)(input[70] & 0x03) << 30) |
			((uint32_t)input[71] << 22) |
			((uint32_t)(input[72] & 0xfc) << 14);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 582 to 597
	value = ((uint32_t)(input[72] & 0x03) << 30) |
			((uint32_t)input[73] << 22) |
			((uint32_t)(input[74] & 0xfc) << 14);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 598 to 613
	value = ((uint32_t)(input[74] & 0x03) << 30) |
			((uint32_t)input[75] << 22) |
			((uint32_t)(input[76] & 0xfc) << 14);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 614 to 629
	value = ((uint32_t)(input[76] & 0x03) << 30) |
			((uint32_t)input[77] << 22) |
			((uint32_t)(input[78] & 0xfc) << 14);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 630 to 645
	value = ((uint32_t)(input[78] & 0x03) << 30) |
			((uint32_t)input[79] << 22) |
			((uint32_t)(input[80] & 0xfc) << 14);
	output[39] = (double)(value >> 16);

	// read output[40]: from bit 646 to 661
	value = ((uint32_t)(input[80] & 0x03) << 30) |
			((uint32_t)input[81] << 22) |
			((uint32_t)(input[82] & 0xfc) << 14);
	output[40] = (double)(value >> 16);

	// read output[41]: from bit 662 to 677
	value = ((uint32_t)(input[82] & 0x03) << 30) |
			((uint32_t)input[83] << 22) |
			((uint32_t)(input[84] & 0xfc) << 14);
	output[41] = (double)(value >> 16);

	// read output[42]: from bit 678 to 693
	value = ((uint32_t)(input[84] & 0x03) << 30) |
			((uint32_t)input[85] << 22) |
			((uint32_t)(input[86] & 0xfc) << 14);
	output[42] = (double)(value >> 16);

	// read output[43]: from bit 694 to 709
	value = ((uint32_t)(input[86] & 0x03) << 30) |
			((uint32_t)input[87] << 22) |
			((uint32_t)(input[88] & 0xfc) << 14);
	output[43] = (double)(value >> 16);

	// read output[44]: from bit 710 to 725
	value = ((uint32_t)(input[88] & 0x03) << 30) |
			((uint32_t)input[89] << 22) |
			((uint32_t)(input[90] & 0xfc) << 14);
	output[44] = (double)(value >> 16);

	// read output[45]: from bit 726 to 741
	value = ((uint32_t)(input[90] & 0x03) << 30) |
			((uint32_t)input[91] << 22) |
			((uint32_t)(input[92] & 0xfc) << 14);
	output[45] = (double)(value >> 16);

	// read output[46]: from bit 742 to 757
	value = ((uint32_t)(input[92] & 0x03) << 30) |
			((uint32_t)input[93] << 22) |
			((uint32_t)(input[94] & 0xfc) << 14);
	output[46] = (double)(value >> 16);

	// read output[47]: from bit 758 to 773
	value = ((uint32_t)(input[94] & 0x03) << 30) |
			((uint32_t)input[95] << 22) |
			((uint32_t)(input[96] & 0xfc) << 14);
	output[47] = (double)(value >> 16);

	// read output[48]: from bit 774 to 789
	value = ((uint32_t)(input[96] & 0x03) << 30) |
			((uint32_t)input[97] << 22) |
			((uint32_t)(input[98] & 0xfc) << 14);
	output[48] = (double)(value >> 16);

	// read output[49]: from bit 790 to 805
	value = ((uint32_t)(input[98] & 0x03) << 30) |
			((uint32_t)input[99] << 22) |
			((uint32_t)(input[100] & 0xfc) << 14);
	output[49] = (double)(value >> 16);

	// read output[50]: from bit 806 to 821
	value = ((uint32_t)(input[100] & 0x03) << 30) |
			((uint32_t)input[101] << 22) |
			((uint32_t)(input[102] & 0xfc) << 14);
	output[50] = (double)(value >> 16);

	// read output[51]: from bit 822 to 837
	value = ((uint32_t)(input[102] & 0x03) << 30) |
			((uint32_t)input[103] << 22) |
			((uint32_t)(input[104] & 0xfc) << 14);
	output[51] = (double)(value >> 16);

	// read output[52]: from bit 838 to 853
	value = ((uint32_t)(input[104] & 0x03) << 30) |
			((uint32_t)input[105] << 22) |
			((uint32_t)(input[106] & 0xfc) << 14);
	output[52] = (double)(value >> 16);

	// read output[53]: from bit 854 to 869
	value = ((uint32_t)(input[106] & 0x03) << 30) |
			((uint32_t)input[107] << 22) |
			((uint32_t)(input[108] & 0xfc) << 14);
	output[53] = (double)(value >> 16);

	// read output[54]: from bit 870 to 885
	value = ((uint32_t)(input[108] & 0x03) << 30) |
			((uint32_t)input[109] << 22) |
			((uint32_t)(input[110] & 0xfc) << 14);
	output[54] = (double)(value >> 16);
}

static void unpack_55_16bit_unsigned_6off(const uint8_t * input, double * output, void *closure) {
	// Unpack 55 values into output
	// Values are 16-bit unsigned
	// Skip 6 bits, read 880 bits of data.
	// Input must be at least 111 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 6 to 21
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)(input[2] & 0xfc) << 14);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 22 to 37
	value = ((uint32_t)(input[2] & 0x03) << 30) |
			((uint32_t)input[3] << 22) |
			((uint32_t)(input[4] & 0xfc) << 14);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 38 to 53
	value = ((uint32_t)(input[4] & 0x03) << 30) |
			((uint32_t)input[5] << 22) |
			((uint32_t)(input[6] & 0xfc) << 14);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 54 to 69
	value = ((uint32_t)(input[6] & 0x03) << 30) |
			((uint32_t)input[7] << 22) |
			((uint32_t)(input[8] & 0xfc) << 14);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 70 to 85
	value = ((uint32_t)(input[8] & 0x03) << 30) |
			((uint32_t)input[9] << 22) |
			((uint32_t)(input[10] & 0xfc) << 14);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 86 to 101
	value = ((uint32_t)(input[10] & 0x03) << 30) |
			((uint32_t)input[11] << 22) |
			((uint32_t)(input[12] & 0xfc) << 14);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 102 to 117
	value = ((uint32_t)(input[12] & 0x03) << 30) |
			((uint32_t)input[13] << 22) |
			((uint32_t)(input[14] & 0xfc) << 14);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 118 to 133
	value = ((uint32_t)(input[14] & 0x03) << 30) |
			((uint32_t)input[15] << 22) |
			((uint32_t)(input[16] & 0xfc) << 14);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 134 to 149
	value = ((uint32_t)(input[16] & 0x03) << 30) |
			((uint32_t)input[17] << 22) |
			((uint32_t)(input[18] & 0xfc) << 14);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 150 to 165
	value = ((uint32_t)(input[18] & 0x03) << 30) |
			((uint32_t)input[19] << 22) |
			((uint32_t)(input[20] & 0xfc) << 14);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 166 to 181
	value = ((uint32_t)(input[20] & 0x03) << 30) |
			((uint32_t)input[21] << 22) |
			((uint32_t)(input[22] & 0xfc) << 14);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 182 to 197
	value = ((uint32_t)(input[22] & 0x03) << 30) |
			((uint32_t)input[23] << 22) |
			((uint32_t)(input[24] & 0xfc) << 14);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 198 to 213
	value = ((uint32_t)(input[24] & 0x03) << 30) |
			((uint32_t)input[25] << 22) |
			((uint32_t)(input[26] & 0xfc) << 14);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 214 to 229
	value = ((uint32_t)(input[26] & 0x03) << 30) |
			((uint32_t)input[27] << 22) |
			((uint32_t)(input[28] & 0xfc) << 14);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 230 to 245
	value = ((uint32_t)(input[28] & 0x03) << 30) |
			((uint32_t)input[29] << 22) |
			((uint32_t)(input[30] & 0xfc) << 14);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 246 to 261
	value = ((uint32_t)(input[30] & 0x03) << 30) |
			((uint32_t)input[31] << 22) |
			((uint32_t)(input[32] & 0xfc) << 14);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 262 to 277
	value = ((uint32_t)(input[32] & 0x03) << 30) |
			((uint32_t)input[33] << 22) |
			((uint32_t)(input[34] & 0xfc) << 14);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 278 to 293
	value = ((uint32_t)(input[34] & 0x03) << 30) |
			((uint32_t)input[35] << 22) |
			((uint32_t)(input[36] & 0xfc) << 14);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 294 to 309
	value = ((uint32_t)(input[36] & 0x03) << 30) |
			((uint32_t)input[37] << 22) |
			((uint32_t)(input[38] & 0xfc) << 14);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 310 to 325
	value = ((uint32_t)(input[38] & 0x03) << 30) |
			((uint32_t)input[39] << 22) |
			((uint32_t)(input[40] & 0xfc) << 14);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 326 to 341
	value = ((uint32_t)(input[40] & 0x03) << 30) |
			((uint32_t)input[41] << 22) |
			((uint32_t)(input[42] & 0xfc) << 14);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 342 to 357
	value = ((uint32_t)(input[42] & 0x03) << 30) |
			((uint32_t)input[43] << 22) |
			((uint32_t)(input[44] & 0xfc) << 14);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 358 to 373
	value = ((uint32_t)(input[44] & 0x03) << 30) |
			((uint32_t)input[45] << 22) |
			((uint32_t)(input[46] & 0xfc) << 14);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 374 to 389
	value = ((uint32_t)(input[46] & 0x03) << 30) |
			((uint32_t)input[47] << 22) |
			((uint32_t)(input[48] & 0xfc) << 14);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 390 to 405
	value = ((uint32_t)(input[48] & 0x03) << 30) |
			((uint32_t)input[49] << 22) |
			((uint32_t)(input[50] & 0xfc) << 14);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 406 to 421
	value = ((uint32_t)(input[50] & 0x03) << 30) |
			((uint32_t)input[51] << 22) |
			((uint32_t)(input[52] & 0xfc) << 14);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 422 to 437
	value = ((uint32_t)(input[52] & 0x03) << 30) |
			((uint32_t)input[53] << 22) |
			((uint32_t)(input[54] & 0xfc) << 14);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 438 to 453
	value = ((uint32_t)(input[54] & 0x03) << 30) |
			((uint32_t)input[55] << 22) |
			((uint32_t)(input[56] & 0xfc) << 14);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 454 to 469
	value = ((uint32_t)(input[56] & 0x03) << 30) |
			((uint32_t)input[57] << 22) |
			((uint32_t)(input[58] & 0xfc) << 14);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 470 to 485
	value = ((uint32_t)(input[58] & 0x03) << 30) |
			((uint32_t)input[59] << 22) |
			((uint32_t)(input[60] & 0xfc) << 14);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 486 to 501
	value = ((uint32_t)(input[60] & 0x03) << 30) |
			((uint32_t)input[61] << 22) |
			((uint32_t)(input[62] & 0xfc) << 14);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 502 to 517
	value = ((uint32_t)(input[62] & 0x03) << 30) |
			((uint32_t)input[63] << 22) |
			((uint32_t)(input[64] & 0xfc) << 14);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 518 to 533
	value = ((uint32_t)(input[64] & 0x03) << 30) |
			((uint32_t)input[65] << 22) |
			((uint32_t)(input[66] & 0xfc) << 14);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 534 to 549
	value = ((uint32_t)(input[66] & 0x03) << 30) |
			((uint32_t)input[67] << 22) |
			((uint32_t)(input[68] & 0xfc) << 14);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 550 to 565
	value = ((uint32_t)(input[68] & 0x03) << 30) |
			((uint32_t)input[69] << 22) |
			((uint32_t)(input[70] & 0xfc) << 14);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 566 to 581
	value = ((uint32_t)(input[70] & 0x03) << 30) |
			((uint32_t)input[71] << 22) |
			((uint32_t)(input[72] & 0xfc) << 14);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 582 to 597
	value = ((uint32_t)(input[72] & 0x03) << 30) |
			((uint32_t)input[73] << 22) |
			((uint32_t)(input[74] & 0xfc) << 14);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 598 to 613
	value = ((uint32_t)(input[74] & 0x03) << 30) |
			((uint32_t)input[75] << 22) |
			((uint32_t)(input[76] & 0xfc) << 14);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 614 to 629
	value = ((uint32_t)(input[76] & 0x03) << 30) |
			((uint32_t)input[77] << 22) |
			((uint32_t)(input[78] & 0xfc) << 14);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 630 to 645
	value = ((uint32_t)(input[78] & 0x03) << 30) |
			((uint32_t)input[79] << 22) |
			((uint32_t)(input[80] & 0xfc) << 14);
	output[39] = (double)(value >> 16);

	// read output[40]: from bit 646 to 661
	value = ((uint32_t)(input[80] & 0x03) << 30) |
			((uint32_t)input[81] << 22) |
			((uint32_t)(input[82] & 0xfc) << 14);
	output[40] = (double)(value >> 16);

	// read output[41]: from bit 662 to 677
	value = ((uint32_t)(input[82] & 0x03) << 30) |
			((uint32_t)input[83] << 22) |
			((uint32_t)(input[84] & 0xfc) << 14);
	output[41] = (double)(value >> 16);

	// read output[42]: from bit 678 to 693
	value = ((uint32_t)(input[84] & 0x03) << 30) |
			((uint32_t)input[85] << 22) |
			((uint32_t)(input[86] & 0xfc) << 14);
	output[42] = (double)(value >> 16);

	// read output[43]: from bit 694 to 709
	value = ((uint32_t)(input[86] & 0x03) << 30) |
			((uint32_t)input[87] << 22) |
			((uint32_t)(input[88] & 0xfc) << 14);
	output[43] = (double)(value >> 16);

	// read output[44]: from bit 710 to 725
	value = ((uint32_t)(input[88] & 0x03) << 30) |
			((uint32_t)input[89] << 22) |
			((uint32_t)(input[90] & 0xfc) << 14);
	output[44] = (double)(value >> 16);

	// read output[45]: from bit 726 to 741
	value = ((uint32_t)(input[90] & 0x03) << 30) |
			((uint32_t)input[91] << 22) |
			((uint32_t)(input[92] & 0xfc) << 14);
	output[45] = (double)(value >> 16);

	// read output[46]: from bit 742 to 757
	value = ((uint32_t)(input[92] & 0x03) << 30) |
			((uint32_t)input[93] << 22) |
			((uint32_t)(input[94] & 0xfc) << 14);
	output[46] = (double)(value >> 16);

	// read output[47]: from bit 758 to 773
	value = ((uint32_t)(input[94] & 0x03) << 30) |
			((uint32_t)input[95] << 22) |
			((uint32_t)(input[96] & 0xfc) << 14);
	output[47] = (double)(value >> 16);

	// read output[48]: from bit 774 to 789
	value = ((uint32_t)(input[96] & 0x03) << 30) |
			((uint32_t)input[97] << 22) |
			((uint32_t)(input[98] & 0xfc) << 14);
	output[48] = (double)(value >> 16);

	// read output[49]: from bit 790 to 805
	value = ((uint32_t)(input[98] & 0x03) << 30) |
			((uint32_t)input[99] << 22) |
			((uint32_t)(input[100] & 0xfc) << 14);
	output[49] = (double)(value >> 16);

	// read output[50]: from bit 806 to 821
	value = ((uint32_t)(input[100] & 0x03) << 30) |
			((uint32_t)input[101] << 22) |
			((uint32_t)(input[102] & 0xfc) << 14);
	output[50] = (double)(value >> 16);

	// read output[51]: from bit 822 to 837
	value = ((uint32_t)(input[102] & 0x03) << 30) |
			((uint32_t)input[103] << 22) |
			((uint32_t)(input[104] & 0xfc) << 14);
	output[51] = (double)(value >> 16);

	// read output[52]: from bit 838 to 853
	value = ((uint32_t)(input[104] & 0x03) << 30) |
			((uint32_t)input[105] << 22) |
			((uint32_t)(input[106] & 0xfc) << 14);
	output[52] = (double)(value >> 16);

	// read output[53]: from bit 854 to 869
	value = ((uint32_t)(input[106] & 0x03) << 30) |
			((uint32_t)input[107] << 22) |
			((uint32_t)(input[108] & 0xfc) << 14);
	output[53] = (double)(value >> 16);

	// read output[54]: from bit 870 to 885
	value = ((uint32_t)(input[108] & 0x03) << 30) |
			((uint32_t)input[109] << 22) |
			((uint32_t)(input[110] & 0xfc) << 14);
	output[54] = (double)(value >> 16);
}

static void unpack_55_16bit_signed_7off(const uint8_t * input, double * output, void *closure) {
	// Unpack 55 values into output
	// Values are 16-bit signed
	// Skip 7 bits, read 880 bits of data.
	// Input must be at least 111 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 7 to 22
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)(input[2] & 0xfe) << 15);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 23 to 38
	value = ((uint32_t)(input[2] & 0x01) << 31) |
			((uint32_t)input[3] << 23) |
			((uint32_t)(input[4] & 0xfe) << 15);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 39 to 54
	value = ((uint32_t)(input[4] & 0x01) << 31) |
			((uint32_t)input[5] << 23) |
			((uint32_t)(input[6] & 0xfe) << 15);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 55 to 70
	value = ((uint32_t)(input[6] & 0x01) << 31) |
			((uint32_t)input[7] << 23) |
			((uint32_t)(input[8] & 0xfe) << 15);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 71 to 86
	value = ((uint32_t)(input[8] & 0x01) << 31) |
			((uint32_t)input[9] << 23) |
			((uint32_t)(input[10] & 0xfe) << 15);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 87 to 102
	value = ((uint32_t)(input[10] & 0x01) << 31) |
			((uint32_t)input[11] << 23) |
			((uint32_t)(input[12] & 0xfe) << 15);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 103 to 118
	value = ((uint32_t)(input[12] & 0x01) << 31) |
			((uint32_t)input[13] << 23) |
			((uint32_t)(input[14] & 0xfe) << 15);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 119 to 134
	value = ((uint32_t)(input[14] & 0x01) << 31) |
			((uint32_t)input[15] << 23) |
			((uint32_t)(input[16] & 0xfe) << 15);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 135 to 150
	value = ((uint32_t)(input[16] & 0x01) << 31) |
			((uint32_t)input[17] << 23) |
			((uint32_t)(input[18] & 0xfe) << 15);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 151 to 166
	value = ((uint32_t)(input[18] & 0x01) << 31) |
			((uint32_t)input[19] << 23) |
			((uint32_t)(input[20] & 0xfe) << 15);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 167 to 182
	value = ((uint32_t)(input[20] & 0x01) << 31) |
			((uint32_t)input[21] << 23) |
			((uint32_t)(input[22] & 0xfe) << 15);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 183 to 198
	value = ((uint32_t)(input[22] & 0x01) << 31) |
			((uint32_t)input[23] << 23) |
			((uint32_t)(input[24] & 0xfe) << 15);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 199 to 214
	value = ((uint32_t)(input[24] & 0x01) << 31) |
			((uint32_t)input[25] << 23) |
			((uint32_t)(input[26] & 0xfe) << 15);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 215 to 230
	value = ((uint32_t)(input[26] & 0x01) << 31) |
			((uint32_t)input[27] << 23) |
			((uint32_t)(input[28] & 0xfe) << 15);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 231 to 246
	value = ((uint32_t)(input[28] & 0x01) << 31) |
			((uint32_t)input[29] << 23) |
			((uint32_t)(input[30] & 0xfe) << 15);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 247 to 262
	value = ((uint32_t)(input[30] & 0x01) << 31) |
			((uint32_t)input[31] << 23) |
			((uint32_t)(input[32] & 0xfe) << 15);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 263 to 278
	value = ((uint32_t)(input[32] & 0x01) << 31) |
			((uint32_t)input[33] << 23) |
			((uint32_t)(input[34] & 0xfe) << 15);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 279 to 294
	value = ((uint32_t)(input[34] & 0x01) << 31) |
			((uint32_t)input[35] << 23) |
			((uint32_t)(input[36] & 0xfe) << 15);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 295 to 310
	value = ((uint32_t)(input[36] & 0x01) << 31) |
			((uint32_t)input[37] << 23) |
			((uint32_t)(input[38] & 0xfe) << 15);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 311 to 326
	value = ((uint32_t)(input[38] & 0x01) << 31) |
			((uint32_t)input[39] << 23) |
			((uint32_t)(input[40] & 0xfe) << 15);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 327 to 342
	value = ((uint32_t)(input[40] & 0x01) << 31) |
			((uint32_t)input[41] << 23) |
			((uint32_t)(input[42] & 0xfe) << 15);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 343 to 358
	value = ((uint32_t)(input[42] & 0x01) << 31) |
			((uint32_t)input[43] << 23) |
			((uint32_t)(input[44] & 0xfe) << 15);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 359 to 374
	value = ((uint32_t)(input[44] & 0x01) << 31) |
			((uint32_t)input[45] << 23) |
			((uint32_t)(input[46] & 0xfe) << 15);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 375 to 390
	value = ((uint32_t)(input[46] & 0x01) << 31) |
			((uint32_t)input[47] << 23) |
			((uint32_t)(input[48] & 0xfe) << 15);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 391 to 406
	value = ((uint32_t)(input[48] & 0x01) << 31) |
			((uint32_t)input[49] << 23) |
			((uint32_t)(input[50] & 0xfe) << 15);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 407 to 422
	value = ((uint32_t)(input[50] & 0x01) << 31) |
			((uint32_t)input[51] << 23) |
			((uint32_t)(input[52] & 0xfe) << 15);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 423 to 438
	value = ((uint32_t)(input[52] & 0x01) << 31) |
			((uint32_t)input[53] << 23) |
			((uint32_t)(input[54] & 0xfe) << 15);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 439 to 454
	value = ((uint32_t)(input[54] & 0x01) << 31) |
			((uint32_t)input[55] << 23) |
			((uint32_t)(input[56] & 0xfe) << 15);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 455 to 470
	value = ((uint32_t)(input[56] & 0x01) << 31) |
			((uint32_t)input[57] << 23) |
			((uint32_t)(input[58] & 0xfe) << 15);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 471 to 486
	value = ((uint32_t)(input[58] & 0x01) << 31) |
			((uint32_t)input[59] << 23) |
			((uint32_t)(input[60] & 0xfe) << 15);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 487 to 502
	value = ((uint32_t)(input[60] & 0x01) << 31) |
			((uint32_t)input[61] << 23) |
			((uint32_t)(input[62] & 0xfe) << 15);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 503 to 518
	value = ((uint32_t)(input[62] & 0x01) << 31) |
			((uint32_t)input[63] << 23) |
			((uint32_t)(input[64] & 0xfe) << 15);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 519 to 534
	value = ((uint32_t)(input[64] & 0x01) << 31) |
			((uint32_t)input[65] << 23) |
			((uint32_t)(input[66] & 0xfe) << 15);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 535 to 550
	value = ((uint32_t)(input[66] & 0x01) << 31) |
			((uint32_t)input[67] << 23) |
			((uint32_t)(input[68] & 0xfe) << 15);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 551 to 566
	value = ((uint32_t)(input[68] & 0x01) << 31) |
			((uint32_t)input[69] << 23) |
			((uint32_t)(input[70] & 0xfe) << 15);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 567 to 582
	value = ((uint32_t)(input[70] & 0x01) << 31) |
			((uint32_t)input[71] << 23) |
			((uint32_t)(input[72] & 0xfe) << 15);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 583 to 598
	value = ((uint32_t)(input[72] & 0x01) << 31) |
			((uint32_t)input[73] << 23) |
			((uint32_t)(input[74] & 0xfe) << 15);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 599 to 614
	value = ((uint32_t)(input[74] & 0x01) << 31) |
			((uint32_t)input[75] << 23) |
			((uint32_t)(input[76] & 0xfe) << 15);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 615 to 630
	value = ((uint32_t)(input[76] & 0x01) << 31) |
			((uint32_t)input[77] << 23) |
			((uint32_t)(input[78] & 0xfe) << 15);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 631 to 646
	value = ((uint32_t)(input[78] & 0x01) << 31) |
			((uint32_t)input[79] << 23) |
			((uint32_t)(input[80] & 0xfe) << 15);
	output[39] = (double)(value >> 16);

	// read output[40]: from bit 647 to 662
	value = ((uint32_t)(input[80] & 0x01) << 31) |
			((uint32_t)input[81] << 23) |
			((uint32_t)(input[82] & 0xfe) << 15);
	output[40] = (double)(value >> 16);

	// read output[41]: from bit 663 to 678
	value = ((uint32_t)(input[82] & 0x01) << 31) |
			((uint32_t)input[83] << 23) |
			((uint32_t)(input[84] & 0xfe) << 15);
	output[41] = (double)(value >> 16);

	// read output[42]: from bit 679 to 694
	value = ((uint32_t)(input[84] & 0x01) << 31) |
			((uint32_t)input[85] << 23) |
			((uint32_t)(input[86] & 0xfe) << 15);
	output[42] = (double)(value >> 16);

	// read output[43]: from bit 695 to 710
	value = ((uint32_t)(input[86] & 0x01) << 31) |
			((uint32_t)input[87] << 23) |
			((uint32_t)(input[88] & 0xfe) << 15);
	output[43] = (double)(value >> 16);

	// read output[44]: from bit 711 to 726
	value = ((uint32_t)(input[88] & 0x01) << 31) |
			((uint32_t)input[89] << 23) |
			((uint32_t)(input[90] & 0xfe) << 15);
	output[44] = (double)(value >> 16);

	// read output[45]: from bit 727 to 742
	value = ((uint32_t)(input[90] & 0x01) << 31) |
			((uint32_t)input[91] << 23) |
			((uint32_t)(input[92] & 0xfe) << 15);
	output[45] = (double)(value >> 16);

	// read output[46]: from bit 743 to 758
	value = ((uint32_t)(input[92] & 0x01) << 31) |
			((uint32_t)input[93] << 23) |
			((uint32_t)(input[94] & 0xfe) << 15);
	output[46] = (double)(value >> 16);

	// read output[47]: from bit 759 to 774
	value = ((uint32_t)(input[94] & 0x01) << 31) |
			((uint32_t)input[95] << 23) |
			((uint32_t)(input[96] & 0xfe) << 15);
	output[47] = (double)(value >> 16);

	// read output[48]: from bit 775 to 790
	value = ((uint32_t)(input[96] & 0x01) << 31) |
			((uint32_t)input[97] << 23) |
			((uint32_t)(input[98] & 0xfe) << 15);
	output[48] = (double)(value >> 16);

	// read output[49]: from bit 791 to 806
	value = ((uint32_t)(input[98] & 0x01) << 31) |
			((uint32_t)input[99] << 23) |
			((uint32_t)(input[100] & 0xfe) << 15);
	output[49] = (double)(value >> 16);

	// read output[50]: from bit 807 to 822
	value = ((uint32_t)(input[100] & 0x01) << 31) |
			((uint32_t)input[101] << 23) |
			((uint32_t)(input[102] & 0xfe) << 15);
	output[50] = (double)(value >> 16);

	// read output[51]: from bit 823 to 838
	value = ((uint32_t)(input[102] & 0x01) << 31) |
			((uint32_t)input[103] << 23) |
			((uint32_t)(input[104] & 0xfe) << 15);
	output[51] = (double)(value >> 16);

	// read output[52]: from bit 839 to 854
	value = ((uint32_t)(input[104] & 0x01) << 31) |
			((uint32_t)input[105] << 23) |
			((uint32_t)(input[106] & 0xfe) << 15);
	output[52] = (double)(value >> 16);

	// read output[53]: from bit 855 to 870
	value = ((uint32_t)(input[106] & 0x01) << 31) |
			((uint32_t)input[107] << 23) |
			((uint32_t)(input[108] & 0xfe) << 15);
	output[53] = (double)(value >> 16);

	// read output[54]: from bit 871 to 886
	value = ((uint32_t)(input[108] & 0x01) << 31) |
			((uint32_t)input[109] << 23) |
			((uint32_t)(input[110] & 0xfe) << 15);
	output[54] = (double)(value >> 16);
}

static void unpack_55_16bit_unsigned_7off(const uint8_t * input, double * output, void *closure) {
	// Unpack 55 values into output
	// Values are 16-bit unsigned
	// Skip 7 bits, read 880 bits of data.
	// Input must be at least 111 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 7 to 22
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)(input[2] & 0xfe) << 15);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 23 to 38
	value = ((uint32_t)(input[2] & 0x01) << 31) |
			((uint32_t)input[3] << 23) |
			((uint32_t)(input[4] & 0xfe) << 15);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 39 to 54
	value = ((uint32_t)(input[4] & 0x01) << 31) |
			((uint32_t)input[5] << 23) |
			((uint32_t)(input[6] & 0xfe) << 15);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 55 to 70
	value = ((uint32_t)(input[6] & 0x01) << 31) |
			((uint32_t)input[7] << 23) |
			((uint32_t)(input[8] & 0xfe) << 15);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 71 to 86
	value = ((uint32_t)(input[8] & 0x01) << 31) |
			((uint32_t)input[9] << 23) |
			((uint32_t)(input[10] & 0xfe) << 15);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 87 to 102
	value = ((uint32_t)(input[10] & 0x01) << 31) |
			((uint32_t)input[11] << 23) |
			((uint32_t)(input[12] & 0xfe) << 15);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 103 to 118
	value = ((uint32_t)(input[12] & 0x01) << 31) |
			((uint32_t)input[13] << 23) |
			((uint32_t)(input[14] & 0xfe) << 15);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 119 to 134
	value = ((uint32_t)(input[14] & 0x01) << 31) |
			((uint32_t)input[15] << 23) |
			((uint32_t)(input[16] & 0xfe) << 15);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 135 to 150
	value = ((uint32_t)(input[16] & 0x01) << 31) |
			((uint32_t)input[17] << 23) |
			((uint32_t)(input[18] & 0xfe) << 15);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 151 to 166
	value = ((uint32_t)(input[18] & 0x01) << 31) |
			((uint32_t)input[19] << 23) |
			((uint32_t)(input[20] & 0xfe) << 15);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 167 to 182
	value = ((uint32_t)(input[20] & 0x01) << 31) |
			((uint32_t)input[21] << 23) |
			((uint32_t)(input[22] & 0xfe) << 15);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 183 to 198
	value = ((uint32_t)(input[22] & 0x01) << 31) |
			((uint32_t)input[23] << 23) |
			((uint32_t)(input[24] & 0xfe) << 15);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 199 to 214
	value = ((uint32_t)(input[24] & 0x01) << 31) |
			((uint32_t)input[25] << 23) |
			((uint32_t)(input[26] & 0xfe) << 15);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 215 to 230
	value = ((uint32_t)(input[26] & 0x01) << 31) |
			((uint32_t)input[27] << 23) |
			((uint32_t)(input[28] & 0xfe) << 15);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 231 to 246
	value = ((uint32_t)(input[28] & 0x01) << 31) |
			((uint32_t)input[29] << 23) |
			((uint32_t)(input[30] & 0xfe) << 15);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 247 to 262
	value = ((uint32_t)(input[30] & 0x01) << 31) |
			((uint32_t)input[31] << 23) |
			((uint32_t)(input[32] & 0xfe) << 15);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 263 to 278
	value = ((uint32_t)(input[32] & 0x01) << 31) |
			((uint32_t)input[33] << 23) |
			((uint32_t)(input[34] & 0xfe) << 15);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 279 to 294
	value = ((uint32_t)(input[34] & 0x01) << 31) |
			((uint32_t)input[35] << 23) |
			((uint32_t)(input[36] & 0xfe) << 15);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 295 to 310
	value = ((uint32_t)(input[36] & 0x01) << 31) |
			((uint32_t)input[37] << 23) |
			((uint32_t)(input[38] & 0xfe) << 15);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 311 to 326
	value = ((uint32_t)(input[38] & 0x01) << 31) |
			((uint32_t)input[39] << 23) |
			((uint32_t)(input[40] & 0xfe) << 15);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 327 to 342
	value = ((uint32_t)(input[40] & 0x01) << 31) |
			((uint32_t)input[41] << 23) |
			((uint32_t)(input[42] & 0xfe) << 15);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 343 to 358
	value = ((uint32_t)(input[42] & 0x01) << 31) |
			((uint32_t)input[43] << 23) |
			((uint32_t)(input[44] & 0xfe) << 15);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 359 to 374
	value = ((uint32_t)(input[44] & 0x01) << 31) |
			((uint32_t)input[45] << 23) |
			((uint32_t)(input[46] & 0xfe) << 15);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 375 to 390
	value = ((uint32_t)(input[46] & 0x01) << 31) |
			((uint32_t)input[47] << 23) |
			((uint32_t)(input[48] & 0xfe) << 15);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 391 to 406
	value = ((uint32_t)(input[48] & 0x01) << 31) |
			((uint32_t)input[49] << 23) |
			((uint32_t)(input[50] & 0xfe) << 15);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 407 to 422
	value = ((uint32_t)(input[50] & 0x01) << 31) |
			((uint32_t)input[51] << 23) |
			((uint32_t)(input[52] & 0xfe) << 15);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 423 to 438
	value = ((uint32_t)(input[52] & 0x01) << 31) |
			((uint32_t)input[53] << 23) |
			((uint32_t)(input[54] & 0xfe) << 15);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 439 to 454
	value = ((uint32_t)(input[54] & 0x01) << 31) |
			((uint32_t)input[55] << 23) |
			((uint32_t)(input[56] & 0xfe) << 15);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 455 to 470
	value = ((uint32_t)(input[56] & 0x01) << 31) |
			((uint32_t)input[57] << 23) |
			((uint32_t)(input[58] & 0xfe) << 15);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 471 to 486
	value = ((uint32_t)(input[58] & 0x01) << 31) |
			((uint32_t)input[59] << 23) |
			((uint32_t)(input[60] & 0xfe) << 15);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 487 to 502
	value = ((uint32_t)(input[60] & 0x01) << 31) |
			((uint32_t)input[61] << 23) |
			((uint32_t)(input[62] & 0xfe) << 15);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 503 to 518
	value = ((uint32_t)(input[62] & 0x01) << 31) |
			((uint32_t)input[63] << 23) |
			((uint32_t)(input[64] & 0xfe) << 15);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 519 to 534
	value = ((uint32_t)(input[64] & 0x01) << 31) |
			((uint32_t)input[65] << 23) |
			((uint32_t)(input[66] & 0xfe) << 15);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 535 to 550
	value = ((uint32_t)(input[66] & 0x01) << 31) |
			((uint32_t)input[67] << 23) |
			((uint32_t)(input[68] & 0xfe) << 15);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 551 to 566
	value = ((uint32_t)(input[68] & 0x01) << 31) |
			((uint32_t)input[69] << 23) |
			((uint32_t)(input[70] & 0xfe) << 15);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 567 to 582
	value = ((uint32_t)(input[70] & 0x01) << 31) |
			((uint32_t)input[71] << 23) |
			((uint32_t)(input[72] & 0xfe) << 15);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 583 to 598
	value = ((uint32_t)(input[72] & 0x01) << 31) |
			((uint32_t)input[73] << 23) |
			((uint32_t)(input[74] & 0xfe) << 15);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 599 to 614
	value = ((uint32_t)(input[74] & 0x01) << 31) |
			((uint32_t)input[75] << 23) |
			((uint32_t)(input[76] & 0xfe) << 15);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 615 to 630
	value = ((uint32_t)(input[76] & 0x01) << 31) |
			((uint32_t)input[77] << 23) |
			((uint32_t)(input[78] & 0xfe) << 15);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 631 to 646
	value = ((uint32_t)(input[78] & 0x01) << 31) |
			((uint32_t)input[79] << 23) |
			((uint32_t)(input[80] & 0xfe) << 15);
	output[39] = (double)(value >> 16);

	// read output[40]: from bit 647 to 662
	value = ((uint32_t)(input[80] & 0x01) << 31) |
			((uint32_t)input[81] << 23) |
			((uint32_t)(input[82] & 0xfe) << 15);
	output[40] = (double)(value >> 16);

	// read output[41]: from bit 663 to 678
	value = ((uint32_t)(input[82] & 0x01) << 31) |
			((uint32_t)input[83] << 23) |
			((uint32_t)(input[84] & 0xfe) << 15);
	output[41] = (double)(value >> 16);

	// read output[42]: from bit 679 to 694
	value = ((uint32_t)(input[84] & 0x01) << 31) |
			((uint32_t)input[85] << 23) |
			((uint32_t)(input[86] & 0xfe) << 15);
	output[42] = (double)(value >> 16);

	// read output[43]: from bit 695 to 710
	value = ((uint32_t)(input[86] & 0x01) << 31) |
			((uint32_t)input[87] << 23) |
			((uint32_t)(input[88] & 0xfe) << 15);
	output[43] = (double)(value >> 16);

	// read output[44]: from bit 711 to 726
	value = ((uint32_t)(input[88] & 0x01) << 31) |
			((uint32_t)input[89] << 23) |
			((uint32_t)(input[90] & 0xfe) << 15);
	output[44] = (double)(value >> 16);

	// read output[45]: from bit 727 to 742
	value = ((uint32_t)(input[90] & 0x01) << 31) |
			((uint32_t)input[91] << 23) |
			((uint32_t)(input[92] & 0xfe) << 15);
	output[45] = (double)(value >> 16);

	// read output[46]: from bit 743 to 758
	value = ((uint32_t)(input[92] & 0x01) << 31) |
			((uint32_t)input[93] << 23) |
			((uint32_t)(input[94] & 0xfe) << 15);
	output[46] = (double)(value >> 16);

	// read output[47]: from bit 759 to 774
	value = ((uint32_t)(input[94] & 0x01) << 31) |
			((uint32_t)input[95] << 23) |
			((uint32_t)(input[96] & 0xfe) << 15);
	output[47] = (double)(value >> 16);

	// read output[48]: from bit 775 to 790
	value = ((uint32_t)(input[96] & 0x01) << 31) |
			((uint32_t)input[97] << 23) |
			((uint32_t)(input[98] & 0xfe) << 15);
	output[48] = (double)(value >> 16);

	// read output[49]: from bit 791 to 806
	value = ((uint32_t)(input[98] & 0x01) << 31) |
			((uint32_t)input[99] << 23) |
			((uint32_t)(input[100] & 0xfe) << 15);
	output[49] = (double)(value >> 16);

	// read output[50]: from bit 807 to 822
	value = ((uint32_t)(input[100] & 0x01) << 31) |
			((uint32_t)input[101] << 23) |
			((uint32_t)(input[102] & 0xfe) << 15);
	output[50] = (double)(value >> 16);

	// read output[51]: from bit 823 to 838
	value = ((uint32_t)(input[102] & 0x01) << 31) |
			((uint32_t)input[103] << 23) |
			((uint32_t)(input[104] & 0xfe) << 15);
	output[51] = (double)(value >> 16);

	// read output[52]: from bit 839 to 854
	value = ((uint32_t)(input[104] & 0x01) << 31) |
			((uint32_t)input[105] << 23) |
			((uint32_t)(input[106] & 0xfe) << 15);
	output[52] = (double)(value >> 16);

	// read output[53]: from bit 855 to 870
	value = ((uint32_t)(input[106] & 0x01) << 31) |
			((uint32_t)input[107] << 23) |
			((uint32_t)(input[108] & 0xfe) << 15);
	output[53] = (double)(value >> 16);

	// read output[54]: from bit 871 to 886
	value = ((uint32_t)(input[108] & 0x01) << 31) |
			((uint32_t)input[109] << 23) |
			((uint32_t)(input[110] & 0xfe) << 15);
	output[54] = (double)(value >> 16);
}

static void unpack_56_16bit_signed_0off(const uint8_t * input, double * output, void *closure) {
	// Unpack 56 values into output
	// Values are 16-bit signed
	// Skip 0 bits, read 896 bits of data.
	// Input must be at least 112 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 0 to 15
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)input[1] << 16);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 16 to 31
	value = ((uint32_t)input[2] << 24) |
			((uint32_t)input[3] << 16);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 32 to 47
	value = ((uint32_t)input[4] << 24) |
			((uint32_t)input[5] << 16);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 48 to 63
	value = ((uint32_t)input[6] << 24) |
			((uint32_t)input[7] << 16);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 64 to 79
	value = ((uint32_t)input[8] << 24) |
			((uint32_t)input[9] << 16);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 80 to 95
	value = ((uint32_t)input[10] << 24) |
			((uint32_t)input[11] << 16);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 96 to 111
	value = ((uint32_t)input[12] << 24) |
			((uint32_t)input[13] << 16);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 112 to 127
	value = ((uint32_t)input[14] << 24) |
			((uint32_t)input[15] << 16);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 128 to 143
	value = ((uint32_t)input[16] << 24) |
			((uint32_t)input[17] << 16);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 144 to 159
	value = ((uint32_t)input[18] << 24) |
			((uint32_t)input[19] << 16);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 160 to 175
	value = ((uint32_t)input[20] << 24) |
			((uint32_t)input[21] << 16);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 176 to 191
	value = ((uint32_t)input[22] << 24) |
			((uint32_t)input[23] << 16);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 192 to 207
	value = ((uint32_t)input[24] << 24) |
			((uint32_t)input[25] << 16);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 208 to 223
	value = ((uint32_t)input[26] << 24) |
			((uint32_t)input[27] << 16);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 224 to 239
	value = ((uint32_t)input[28] << 24) |
			((uint32_t)input[29] << 16);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 240 to 255
	value = ((uint32_t)input[30] << 24) |
			((uint32_t)input[31] << 16);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 256 to 271
	value = ((uint32_t)input[32] << 24) |
			((uint32_t)input[33] << 16);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 272 to 287
	value = ((uint32_t)input[34] << 24) |
			((uint32_t)input[35] << 16);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 288 to 303
	value = ((uint32_t)input[36] << 24) |
			((uint32_t)input[37] << 16);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 304 to 319
	value = ((uint32_t)input[38] << 24) |
			((uint32_t)input[39] << 16);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 320 to 335
	value = ((uint32_t)input[40] << 24) |
			((uint32_t)input[41] << 16);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 336 to 351
	value = ((uint32_t)input[42] << 24) |
			((uint32_t)input[43] << 16);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 352 to 367
	value = ((uint32_t)input[44] << 24) |
			((uint32_t)input[45] << 16);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 368 to 383
	value = ((uint32_t)input[46] << 24) |
			((uint32_t)input[47] << 16);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 384 to 399
	value = ((uint32_t)input[48] << 24) |
			((uint32_t)input[49] << 16);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 400 to 415
	value = ((uint32_t)input[50] << 24) |
			((uint32_t)input[51] << 16);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 416 to 431
	value = ((uint32_t)input[52] << 24) |
			((uint32_t)input[53] << 16);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 432 to 447
	value = ((uint32_t)input[54] << 24) |
			((uint32_t)input[55] << 16);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 448 to 463
	value = ((uint32_t)input[56] << 24) |
			((uint32_t)input[57] << 16);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 464 to 479
	value = ((uint32_t)input[58] << 24) |
			((uint32_t)input[59] << 16);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 480 to 495
	value = ((uint32_t)input[60] << 24) |
			((uint32_t)input[61] << 16);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 496 to 511
	value = ((uint32_t)input[62] << 24) |
			((uint32_t)input[63] << 16);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 512 to 527
	value = ((uint32_t)input[64] << 24) |
			((uint32_t)input[65] << 16);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 528 to 543
	value = ((uint32_t)input[66] << 24) |
			((uint32_t)input[67] << 16);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 544 to 559
	value = ((uint32_t)input[68] << 24) |
			((uint32_t)input[69] << 16);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 560 to 575
	value = ((uint32_t)input[70] << 24) |
			((uint32_t)input[71] << 16);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 576 to 591
	value = ((uint32_t)input[72] << 24) |
			((uint32_t)input[73] << 16);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 592 to 607
	value = ((uint32_t)input[74] << 24) |
			((uint32_t)input[75] << 16);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 608 to 623
	value = ((uint32_t)input[76] << 24) |
			((uint32_t)input[77] << 16);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 624 to 639
	value = ((uint32_t)input[78] << 24) |
			((uint32_t)input[79] << 16);
	output[39] = (double)(value >> 16);

	// read output[40]: from bit 640 to 655
	value = ((uint32_t)input[80] << 24) |
			((uint32_t)input[81] << 16);
	output[40] = (double)(value >> 16);

	// read output[41]: from bit 656 to 671
	value = ((uint32_t)input[82] << 24) |
			((uint32_t)input[83] << 16);
	output[41] = (double)(value >> 16);

	// read output[42]: from bit 672 to 687
	value = ((uint32_t)input[84] << 24) |
			((uint32_t)input[85] << 16);
	output[42] = (double)(value >> 16);

	// read output[43]: from bit 688 to 703
	value = ((uint32_t)input[86] << 24) |
			((uint32_t)input[87] << 16);
	output[43] = (double)(value >> 16);

	// read output[44]: from bit 704 to 719
	value = ((uint32_t)input[88] << 24) |
			((uint32_t)input[89] << 16);
	output[44] = (double)(value >> 16);

	// read output[45]: from bit 720 to 735
	value = ((uint32_t)input[90] << 24) |
			((uint32_t)input[91] << 16);
	output[45] = (double)(value >> 16);

	// read output[46]: from bit 736 to 751
	value = ((uint32_t)input[92] << 24) |
			((uint32_t)input[93] << 16);
	output[46] = (double)(value >> 16);

	// read output[47]: from bit 752 to 767
	value = ((uint32_t)input[94] << 24) |
			((uint32_t)input[95] << 16);
	output[47] = (double)(value >> 16);

	// read output[48]: from bit 768 to 783
	value = ((uint32_t)input[96] << 24) |
			((uint32_t)input[97] << 16);
	output[48] = (double)(value >> 16);

	// read output[49]: from bit 784 to 799
	value = ((uint32_t)input[98] << 24) |
			((uint32_t)input[99] << 16);
	output[49] = (double)(value >> 16);

	// read output[50]: from bit 800 to 815
	value = ((uint32_t)input[100] << 24) |
			((uint32_t)input[101] << 16);
	output[50] = (double)(value >> 16);

	// read output[51]: from bit 816 to 831
	value = ((uint32_t)input[102] << 24) |
			((uint32_t)input[103] << 16);
	output[51] = (double)(value >> 16);

	// read output[52]: from bit 832 to 847
	value = ((uint32_t)input[104] << 24) |
			((uint32_t)input[105] << 16);
	output[52] = (double)(value >> 16);

	// read output[53]: from bit 848 to 863
	value = ((uint32_t)input[106] << 24) |
			((uint32_t)input[107] << 16);
	output[53] = (double)(value >> 16);

	// read output[54]: from bit 864 to 879
	value = ((uint32_t)input[108] << 24) |
			((uint32_t)input[109] << 16);
	output[54] = (double)(value >> 16);

	// read output[55]: from bit 880 to 895
	value = ((uint32_t)input[110] << 24) |
			((uint32_t)input[111] << 16);
	output[55] = (double)(value >> 16);
}

static void unpack_56_16bit_unsigned_0off(const uint8_t * input, double * output, void *closure) {
	// Unpack 56 values into output
	// Values are 16-bit unsigned
	// Skip 0 bits, read 896 bits of data.
	// Input must be at least 112 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 0 to 15
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)input[1] << 16);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 16 to 31
	value = ((uint32_t)input[2] << 24) |
			((uint32_t)input[3] << 16);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 32 to 47
	value = ((uint32_t)input[4] << 24) |
			((uint32_t)input[5] << 16);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 48 to 63
	value = ((uint32_t)input[6] << 24) |
			((uint32_t)input[7] << 16);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 64 to 79
	value = ((uint32_t)input[8] << 24) |
			((uint32_t)input[9] << 16);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 80 to 95
	value = ((uint32_t)input[10] << 24) |
			((uint32_t)input[11] << 16);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 96 to 111
	value = ((uint32_t)input[12] << 24) |
			((uint32_t)input[13] << 16);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 112 to 127
	value = ((uint32_t)input[14] << 24) |
			((uint32_t)input[15] << 16);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 128 to 143
	value = ((uint32_t)input[16] << 24) |
			((uint32_t)input[17] << 16);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 144 to 159
	value = ((uint32_t)input[18] << 24) |
			((uint32_t)input[19] << 16);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 160 to 175
	value = ((uint32_t)input[20] << 24) |
			((uint32_t)input[21] << 16);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 176 to 191
	value = ((uint32_t)input[22] << 24) |
			((uint32_t)input[23] << 16);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 192 to 207
	value = ((uint32_t)input[24] << 24) |
			((uint32_t)input[25] << 16);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 208 to 223
	value = ((uint32_t)input[26] << 24) |
			((uint32_t)input[27] << 16);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 224 to 239
	value = ((uint32_t)input[28] << 24) |
			((uint32_t)input[29] << 16);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 240 to 255
	value = ((uint32_t)input[30] << 24) |
			((uint32_t)input[31] << 16);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 256 to 271
	value = ((uint32_t)input[32] << 24) |
			((uint32_t)input[33] << 16);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 272 to 287
	value = ((uint32_t)input[34] << 24) |
			((uint32_t)input[35] << 16);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 288 to 303
	value = ((uint32_t)input[36] << 24) |
			((uint32_t)input[37] << 16);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 304 to 319
	value = ((uint32_t)input[38] << 24) |
			((uint32_t)input[39] << 16);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 320 to 335
	value = ((uint32_t)input[40] << 24) |
			((uint32_t)input[41] << 16);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 336 to 351
	value = ((uint32_t)input[42] << 24) |
			((uint32_t)input[43] << 16);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 352 to 367
	value = ((uint32_t)input[44] << 24) |
			((uint32_t)input[45] << 16);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 368 to 383
	value = ((uint32_t)input[46] << 24) |
			((uint32_t)input[47] << 16);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 384 to 399
	value = ((uint32_t)input[48] << 24) |
			((uint32_t)input[49] << 16);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 400 to 415
	value = ((uint32_t)input[50] << 24) |
			((uint32_t)input[51] << 16);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 416 to 431
	value = ((uint32_t)input[52] << 24) |
			((uint32_t)input[53] << 16);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 432 to 447
	value = ((uint32_t)input[54] << 24) |
			((uint32_t)input[55] << 16);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 448 to 463
	value = ((uint32_t)input[56] << 24) |
			((uint32_t)input[57] << 16);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 464 to 479
	value = ((uint32_t)input[58] << 24) |
			((uint32_t)input[59] << 16);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 480 to 495
	value = ((uint32_t)input[60] << 24) |
			((uint32_t)input[61] << 16);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 496 to 511
	value = ((uint32_t)input[62] << 24) |
			((uint32_t)input[63] << 16);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 512 to 527
	value = ((uint32_t)input[64] << 24) |
			((uint32_t)input[65] << 16);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 528 to 543
	value = ((uint32_t)input[66] << 24) |
			((uint32_t)input[67] << 16);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 544 to 559
	value = ((uint32_t)input[68] << 24) |
			((uint32_t)input[69] << 16);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 560 to 575
	value = ((uint32_t)input[70] << 24) |
			((uint32_t)input[71] << 16);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 576 to 591
	value = ((uint32_t)input[72] << 24) |
			((uint32_t)input[73] << 16);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 592 to 607
	value = ((uint32_t)input[74] << 24) |
			((uint32_t)input[75] << 16);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 608 to 623
	value = ((uint32_t)input[76] << 24) |
			((uint32_t)input[77] << 16);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 624 to 639
	value = ((uint32_t)input[78] << 24) |
			((uint32_t)input[79] << 16);
	output[39] = (double)(value >> 16);

	// read output[40]: from bit 640 to 655
	value = ((uint32_t)input[80] << 24) |
			((uint32_t)input[81] << 16);
	output[40] = (double)(value >> 16);

	// read output[41]: from bit 656 to 671
	value = ((uint32_t)input[82] << 24) |
			((uint32_t)input[83] << 16);
	output[41] = (double)(value >> 16);

	// read output[42]: from bit 672 to 687
	value = ((uint32_t)input[84] << 24) |
			((uint32_t)input[85] << 16);
	output[42] = (double)(value >> 16);

	// read output[43]: from bit 688 to 703
	value = ((uint32_t)input[86] << 24) |
			((uint32_t)input[87] << 16);
	output[43] = (double)(value >> 16);

	// read output[44]: from bit 704 to 719
	value = ((uint32_t)input[88] << 24) |
			((uint32_t)input[89] << 16);
	output[44] = (double)(value >> 16);

	// read output[45]: from bit 720 to 735
	value = ((uint32_t)input[90] << 24) |
			((uint32_t)input[91] << 16);
	output[45] = (double)(value >> 16);

	// read output[46]: from bit 736 to 751
	value = ((uint32_t)input[92] << 24) |
			((uint32_t)input[93] << 16);
	output[46] = (double)(value >> 16);

	// read output[47]: from bit 752 to 767
	value = ((uint32_t)input[94] << 24) |
			((uint32_t)input[95] << 16);
	output[47] = (double)(value >> 16);

	// read output[48]: from bit 768 to 783
	value = ((uint32_t)input[96] << 24) |
			((uint32_t)input[97] << 16);
	output[48] = (double)(value >> 16);

	// read output[49]: from bit 784 to 799
	value = ((uint32_t)input[98] << 24) |
			((uint32_t)input[99] << 16);
	output[49] = (double)(value >> 16);

	// read output[50]: from bit 800 to 815
	value = ((uint32_t)input[100] << 24) |
			((uint32_t)input[101] << 16);
	output[50] = (double)(value >> 16);

	// read output[51]: from bit 816 to 831
	value = ((uint32_t)input[102] << 24) |
			((uint32_t)input[103] << 16);
	output[51] = (double)(value >> 16);

	// read output[52]: from bit 832 to 847
	value = ((uint32_t)input[104] << 24) |
			((uint32_t)input[105] << 16);
	output[52] = (double)(value >> 16);

	// read output[53]: from bit 848 to 863
	value = ((uint32_t)input[106] << 24) |
			((uint32_t)input[107] << 16);
	output[53] = (double)(value >> 16);

	// read output[54]: from bit 864 to 879
	value = ((uint32_t)input[108] << 24) |
			((uint32_t)input[109] << 16);
	output[54] = (double)(value >> 16);

	// read output[55]: from bit 880 to 895
	value = ((uint32_t)input[110] << 24) |
			((uint32_t)input[111] << 16);
	output[55] = (double)(value >> 16);
}

static void unpack_56_16bit_signed_1off(const uint8_t * input, double * output, void *closure) {
	// Unpack 56 values into output
	// Values are 16-bit signed
	// Skip 1 bits, read 896 bits of data.
	// Input must be at least 113 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 1 to 16
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)input[1] << 17) |
			((uint32_t)(input[2] & 0x80) << 9);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 17 to 32
	value = ((uint32_t)(input[2] & 0x7f) << 25) |
			((uint32_t)input[3] << 17) |
			((uint32_t)(input[4] & 0x80) << 9);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 33 to 48
	value = ((uint32_t)(input[4] & 0x7f) << 25) |
			((uint32_t)input[5] << 17) |
			((uint32_t)(input[6] & 0x80) << 9);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 49 to 64
	value = ((uint32_t)(input[6] & 0x7f) << 25) |
			((uint32_t)input[7] << 17) |
			((uint32_t)(input[8] & 0x80) << 9);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 65 to 80
	value = ((uint32_t)(input[8] & 0x7f) << 25) |
			((uint32_t)input[9] << 17) |
			((uint32_t)(input[10] & 0x80) << 9);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 81 to 96
	value = ((uint32_t)(input[10] & 0x7f) << 25) |
			((uint32_t)input[11] << 17) |
			((uint32_t)(input[12] & 0x80) << 9);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 97 to 112
	value = ((uint32_t)(input[12] & 0x7f) << 25) |
			((uint32_t)input[13] << 17) |
			((uint32_t)(input[14] & 0x80) << 9);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 113 to 128
	value = ((uint32_t)(input[14] & 0x7f) << 25) |
			((uint32_t)input[15] << 17) |
			((uint32_t)(input[16] & 0x80) << 9);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 129 to 144
	value = ((uint32_t)(input[16] & 0x7f) << 25) |
			((uint32_t)input[17] << 17) |
			((uint32_t)(input[18] & 0x80) << 9);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 145 to 160
	value = ((uint32_t)(input[18] & 0x7f) << 25) |
			((uint32_t)input[19] << 17) |
			((uint32_t)(input[20] & 0x80) << 9);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 161 to 176
	value = ((uint32_t)(input[20] & 0x7f) << 25) |
			((uint32_t)input[21] << 17) |
			((uint32_t)(input[22] & 0x80) << 9);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 177 to 192
	value = ((uint32_t)(input[22] & 0x7f) << 25) |
			((uint32_t)input[23] << 17) |
			((uint32_t)(input[24] & 0x80) << 9);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 193 to 208
	value = ((uint32_t)(input[24] & 0x7f) << 25) |
			((uint32_t)input[25] << 17) |
			((uint32_t)(input[26] & 0x80) << 9);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 209 to 224
	value = ((uint32_t)(input[26] & 0x7f) << 25) |
			((uint32_t)input[27] << 17) |
			((uint32_t)(input[28] & 0x80) << 9);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 225 to 240
	value = ((uint32_t)(input[28] & 0x7f) << 25) |
			((uint32_t)input[29] << 17) |
			((uint32_t)(input[30] & 0x80) << 9);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 241 to 256
	value = ((uint32_t)(input[30] & 0x7f) << 25) |
			((uint32_t)input[31] << 17) |
			((uint32_t)(input[32] & 0x80) << 9);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 257 to 272
	value = ((uint32_t)(input[32] & 0x7f) << 25) |
			((uint32_t)input[33] << 17) |
			((uint32_t)(input[34] & 0x80) << 9);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 273 to 288
	value = ((uint32_t)(input[34] & 0x7f) << 25) |
			((uint32_t)input[35] << 17) |
			((uint32_t)(input[36] & 0x80) << 9);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 289 to 304
	value = ((uint32_t)(input[36] & 0x7f) << 25) |
			((uint32_t)input[37] << 17) |
			((uint32_t)(input[38] & 0x80) << 9);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 305 to 320
	value = ((uint32_t)(input[38] & 0x7f) << 25) |
			((uint32_t)input[39] << 17) |
			((uint32_t)(input[40] & 0x80) << 9);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 321 to 336
	value = ((uint32_t)(input[40] & 0x7f) << 25) |
			((uint32_t)input[41] << 17) |
			((uint32_t)(input[42] & 0x80) << 9);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 337 to 352
	value = ((uint32_t)(input[42] & 0x7f) << 25) |
			((uint32_t)input[43] << 17) |
			((uint32_t)(input[44] & 0x80) << 9);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 353 to 368
	value = ((uint32_t)(input[44] & 0x7f) << 25) |
			((uint32_t)input[45] << 17) |
			((uint32_t)(input[46] & 0x80) << 9);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 369 to 384
	value = ((uint32_t)(input[46] & 0x7f) << 25) |
			((uint32_t)input[47] << 17) |
			((uint32_t)(input[48] & 0x80) << 9);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 385 to 400
	value = ((uint32_t)(input[48] & 0x7f) << 25) |
			((uint32_t)input[49] << 17) |
			((uint32_t)(input[50] & 0x80) << 9);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 401 to 416
	value = ((uint32_t)(input[50] & 0x7f) << 25) |
			((uint32_t)input[51] << 17) |
			((uint32_t)(input[52] & 0x80) << 9);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 417 to 432
	value = ((uint32_t)(input[52] & 0x7f) << 25) |
			((uint32_t)input[53] << 17) |
			((uint32_t)(input[54] & 0x80) << 9);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 433 to 448
	value = ((uint32_t)(input[54] & 0x7f) << 25) |
			((uint32_t)input[55] << 17) |
			((uint32_t)(input[56] & 0x80) << 9);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 449 to 464
	value = ((uint32_t)(input[56] & 0x7f) << 25) |
			((uint32_t)input[57] << 17) |
			((uint32_t)(input[58] & 0x80) << 9);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 465 to 480
	value = ((uint32_t)(input[58] & 0x7f) << 25) |
			((uint32_t)input[59] << 17) |
			((uint32_t)(input[60] & 0x80) << 9);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 481 to 496
	value = ((uint32_t)(input[60] & 0x7f) << 25) |
			((uint32_t)input[61] << 17) |
			((uint32_t)(input[62] & 0x80) << 9);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 497 to 512
	value = ((uint32_t)(input[62] & 0x7f) << 25) |
			((uint32_t)input[63] << 17) |
			((uint32_t)(input[64] & 0x80) << 9);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 513 to 528
	value = ((uint32_t)(input[64] & 0x7f) << 25) |
			((uint32_t)input[65] << 17) |
			((uint32_t)(input[66] & 0x80) << 9);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 529 to 544
	value = ((uint32_t)(input[66] & 0x7f) << 25) |
			((uint32_t)input[67] << 17) |
			((uint32_t)(input[68] & 0x80) << 9);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 545 to 560
	value = ((uint32_t)(input[68] & 0x7f) << 25) |
			((uint32_t)input[69] << 17) |
			((uint32_t)(input[70] & 0x80) << 9);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 561 to 576
	value = ((uint32_t)(input[70] & 0x7f) << 25) |
			((uint32_t)input[71] << 17) |
			((uint32_t)(input[72] & 0x80) << 9);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 577 to 592
	value = ((uint32_t)(input[72] & 0x7f) << 25) |
			((uint32_t)input[73] << 17) |
			((uint32_t)(input[74] & 0x80) << 9);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 593 to 608
	value = ((uint32_t)(input[74] & 0x7f) << 25) |
			((uint32_t)input[75] << 17) |
			((uint32_t)(input[76] & 0x80) << 9);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 609 to 624
	value = ((uint32_t)(input[76] & 0x7f) << 25) |
			((uint32_t)input[77] << 17) |
			((uint32_t)(input[78] & 0x80) << 9);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 625 to 640
	value = ((uint32_t)(input[78] & 0x7f) << 25) |
			((uint32_t)input[79] << 17) |
			((uint32_t)(input[80] & 0x80) << 9);
	output[39] = (double)(value >> 16);

	// read output[40]: from bit 641 to 656
	value = ((uint32_t)(input[80] & 0x7f) << 25) |
			((uint32_t)input[81] << 17) |
			((uint32_t)(input[82] & 0x80) << 9);
	output[40] = (double)(value >> 16);

	// read output[41]: from bit 657 to 672
	value = ((uint32_t)(input[82] & 0x7f) << 25) |
			((uint32_t)input[83] << 17) |
			((uint32_t)(input[84] & 0x80) << 9);
	output[41] = (double)(value >> 16);

	// read output[42]: from bit 673 to 688
	value = ((uint32_t)(input[84] & 0x7f) << 25) |
			((uint32_t)input[85] << 17) |
			((uint32_t)(input[86] & 0x80) << 9);
	output[42] = (double)(value >> 16);

	// read output[43]: from bit 689 to 704
	value = ((uint32_t)(input[86] & 0x7f) << 25) |
			((uint32_t)input[87] << 17) |
			((uint32_t)(input[88] & 0x80) << 9);
	output[43] = (double)(value >> 16);

	// read output[44]: from bit 705 to 720
	value = ((uint32_t)(input[88] & 0x7f) << 25) |
			((uint32_t)input[89] << 17) |
			((uint32_t)(input[90] & 0x80) << 9);
	output[44] = (double)(value >> 16);

	// read output[45]: from bit 721 to 736
	value = ((uint32_t)(input[90] & 0x7f) << 25) |
			((uint32_t)input[91] << 17) |
			((uint32_t)(input[92] & 0x80) << 9);
	output[45] = (double)(value >> 16);

	// read output[46]: from bit 737 to 752
	value = ((uint32_t)(input[92] & 0x7f) << 25) |
			((uint32_t)input[93] << 17) |
			((uint32_t)(input[94] & 0x80) << 9);
	output[46] = (double)(value >> 16);

	// read output[47]: from bit 753 to 768
	value = ((uint32_t)(input[94] & 0x7f) << 25) |
			((uint32_t)input[95] << 17) |
			((uint32_t)(input[96] & 0x80) << 9);
	output[47] = (double)(value >> 16);

	// read output[48]: from bit 769 to 784
	value = ((uint32_t)(input[96] & 0x7f) << 25) |
			((uint32_t)input[97] << 17) |
			((uint32_t)(input[98] & 0x80) << 9);
	output[48] = (double)(value >> 16);

	// read output[49]: from bit 785 to 800
	value = ((uint32_t)(input[98] & 0x7f) << 25) |
			((uint32_t)input[99] << 17) |
			((uint32_t)(input[100] & 0x80) << 9);
	output[49] = (double)(value >> 16);

	// read output[50]: from bit 801 to 816
	value = ((uint32_t)(input[100] & 0x7f) << 25) |
			((uint32_t)input[101] << 17) |
			((uint32_t)(input[102] & 0x80) << 9);
	output[50] = (double)(value >> 16);

	// read output[51]: from bit 817 to 832
	value = ((uint32_t)(input[102] & 0x7f) << 25) |
			((uint32_t)input[103] << 17) |
			((uint32_t)(input[104] & 0x80) << 9);
	output[51] = (double)(value >> 16);

	// read output[52]: from bit 833 to 848
	value = ((uint32_t)(input[104] & 0x7f) << 25) |
			((uint32_t)input[105] << 17) |
			((uint32_t)(input[106] & 0x80) << 9);
	output[52] = (double)(value >> 16);

	// read output[53]: from bit 849 to 864
	value = ((uint32_t)(input[106] & 0x7f) << 25) |
			((uint32_t)input[107] << 17) |
			((uint32_t)(input[108] & 0x80) << 9);
	output[53] = (double)(value >> 16);

	// read output[54]: from bit 865 to 880
	value = ((uint32_t)(input[108] & 0x7f) << 25) |
			((uint32_t)input[109] << 17) |
			((uint32_t)(input[110] & 0x80) << 9);
	output[54] = (double)(value >> 16);

	// read output[55]: from bit 881 to 896
	value = ((uint32_t)(input[110] & 0x7f) << 25) |
			((uint32_t)input[111] << 17) |
			((uint32_t)(input[112] & 0x80) << 9);
	output[55] = (double)(value >> 16);
}

static void unpack_56_16bit_unsigned_1off(const uint8_t * input, double * output, void *closure) {
	// Unpack 56 values into output
	// Values are 16-bit unsigned
	// Skip 1 bits, read 896 bits of data.
	// Input must be at least 113 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 1 to 16
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)input[1] << 17) |
			((uint32_t)(input[2] & 0x80) << 9);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 17 to 32
	value = ((uint32_t)(input[2] & 0x7f) << 25) |
			((uint32_t)input[3] << 17) |
			((uint32_t)(input[4] & 0x80) << 9);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 33 to 48
	value = ((uint32_t)(input[4] & 0x7f) << 25) |
			((uint32_t)input[5] << 17) |
			((uint32_t)(input[6] & 0x80) << 9);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 49 to 64
	value = ((uint32_t)(input[6] & 0x7f) << 25) |
			((uint32_t)input[7] << 17) |
			((uint32_t)(input[8] & 0x80) << 9);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 65 to 80
	value = ((uint32_t)(input[8] & 0x7f) << 25) |
			((uint32_t)input[9] << 17) |
			((uint32_t)(input[10] & 0x80) << 9);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 81 to 96
	value = ((uint32_t)(input[10] & 0x7f) << 25) |
			((uint32_t)input[11] << 17) |
			((uint32_t)(input[12] & 0x80) << 9);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 97 to 112
	value = ((uint32_t)(input[12] & 0x7f) << 25) |
			((uint32_t)input[13] << 17) |
			((uint32_t)(input[14] & 0x80) << 9);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 113 to 128
	value = ((uint32_t)(input[14] & 0x7f) << 25) |
			((uint32_t)input[15] << 17) |
			((uint32_t)(input[16] & 0x80) << 9);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 129 to 144
	value = ((uint32_t)(input[16] & 0x7f) << 25) |
			((uint32_t)input[17] << 17) |
			((uint32_t)(input[18] & 0x80) << 9);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 145 to 160
	value = ((uint32_t)(input[18] & 0x7f) << 25) |
			((uint32_t)input[19] << 17) |
			((uint32_t)(input[20] & 0x80) << 9);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 161 to 176
	value = ((uint32_t)(input[20] & 0x7f) << 25) |
			((uint32_t)input[21] << 17) |
			((uint32_t)(input[22] & 0x80) << 9);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 177 to 192
	value = ((uint32_t)(input[22] & 0x7f) << 25) |
			((uint32_t)input[23] << 17) |
			((uint32_t)(input[24] & 0x80) << 9);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 193 to 208
	value = ((uint32_t)(input[24] & 0x7f) << 25) |
			((uint32_t)input[25] << 17) |
			((uint32_t)(input[26] & 0x80) << 9);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 209 to 224
	value = ((uint32_t)(input[26] & 0x7f) << 25) |
			((uint32_t)input[27] << 17) |
			((uint32_t)(input[28] & 0x80) << 9);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 225 to 240
	value = ((uint32_t)(input[28] & 0x7f) << 25) |
			((uint32_t)input[29] << 17) |
			((uint32_t)(input[30] & 0x80) << 9);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 241 to 256
	value = ((uint32_t)(input[30] & 0x7f) << 25) |
			((uint32_t)input[31] << 17) |
			((uint32_t)(input[32] & 0x80) << 9);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 257 to 272
	value = ((uint32_t)(input[32] & 0x7f) << 25) |
			((uint32_t)input[33] << 17) |
			((uint32_t)(input[34] & 0x80) << 9);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 273 to 288
	value = ((uint32_t)(input[34] & 0x7f) << 25) |
			((uint32_t)input[35] << 17) |
			((uint32_t)(input[36] & 0x80) << 9);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 289 to 304
	value = ((uint32_t)(input[36] & 0x7f) << 25) |
			((uint32_t)input[37] << 17) |
			((uint32_t)(input[38] & 0x80) << 9);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 305 to 320
	value = ((uint32_t)(input[38] & 0x7f) << 25) |
			((uint32_t)input[39] << 17) |
			((uint32_t)(input[40] & 0x80) << 9);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 321 to 336
	value = ((uint32_t)(input[40] & 0x7f) << 25) |
			((uint32_t)input[41] << 17) |
			((uint32_t)(input[42] & 0x80) << 9);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 337 to 352
	value = ((uint32_t)(input[42] & 0x7f) << 25) |
			((uint32_t)input[43] << 17) |
			((uint32_t)(input[44] & 0x80) << 9);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 353 to 368
	value = ((uint32_t)(input[44] & 0x7f) << 25) |
			((uint32_t)input[45] << 17) |
			((uint32_t)(input[46] & 0x80) << 9);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 369 to 384
	value = ((uint32_t)(input[46] & 0x7f) << 25) |
			((uint32_t)input[47] << 17) |
			((uint32_t)(input[48] & 0x80) << 9);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 385 to 400
	value = ((uint32_t)(input[48] & 0x7f) << 25) |
			((uint32_t)input[49] << 17) |
			((uint32_t)(input[50] & 0x80) << 9);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 401 to 416
	value = ((uint32_t)(input[50] & 0x7f) << 25) |
			((uint32_t)input[51] << 17) |
			((uint32_t)(input[52] & 0x80) << 9);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 417 to 432
	value = ((uint32_t)(input[52] & 0x7f) << 25) |
			((uint32_t)input[53] << 17) |
			((uint32_t)(input[54] & 0x80) << 9);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 433 to 448
	value = ((uint32_t)(input[54] & 0x7f) << 25) |
			((uint32_t)input[55] << 17) |
			((uint32_t)(input[56] & 0x80) << 9);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 449 to 464
	value = ((uint32_t)(input[56] & 0x7f) << 25) |
			((uint32_t)input[57] << 17) |
			((uint32_t)(input[58] & 0x80) << 9);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 465 to 480
	value = ((uint32_t)(input[58] & 0x7f) << 25) |
			((uint32_t)input[59] << 17) |
			((uint32_t)(input[60] & 0x80) << 9);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 481 to 496
	value = ((uint32_t)(input[60] & 0x7f) << 25) |
			((uint32_t)input[61] << 17) |
			((uint32_t)(input[62] & 0x80) << 9);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 497 to 512
	value = ((uint32_t)(input[62] & 0x7f) << 25) |
			((uint32_t)input[63] << 17) |
			((uint32_t)(input[64] & 0x80) << 9);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 513 to 528
	value = ((uint32_t)(input[64] & 0x7f) << 25) |
			((uint32_t)input[65] << 17) |
			((uint32_t)(input[66] & 0x80) << 9);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 529 to 544
	value = ((uint32_t)(input[66] & 0x7f) << 25) |
			((uint32_t)input[67] << 17) |
			((uint32_t)(input[68] & 0x80) << 9);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 545 to 560
	value = ((uint32_t)(input[68] & 0x7f) << 25) |
			((uint32_t)input[69] << 17) |
			((uint32_t)(input[70] & 0x80) << 9);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 561 to 576
	value = ((uint32_t)(input[70] & 0x7f) << 25) |
			((uint32_t)input[71] << 17) |
			((uint32_t)(input[72] & 0x80) << 9);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 577 to 592
	value = ((uint32_t)(input[72] & 0x7f) << 25) |
			((uint32_t)input[73] << 17) |
			((uint32_t)(input[74] & 0x80) << 9);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 593 to 608
	value = ((uint32_t)(input[74] & 0x7f) << 25) |
			((uint32_t)input[75] << 17) |
			((uint32_t)(input[76] & 0x80) << 9);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 609 to 624
	value = ((uint32_t)(input[76] & 0x7f) << 25) |
			((uint32_t)input[77] << 17) |
			((uint32_t)(input[78] & 0x80) << 9);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 625 to 640
	value = ((uint32_t)(input[78] & 0x7f) << 25) |
			((uint32_t)input[79] << 17) |
			((uint32_t)(input[80] & 0x80) << 9);
	output[39] = (double)(value >> 16);

	// read output[40]: from bit 641 to 656
	value = ((uint32_t)(input[80] & 0x7f) << 25) |
			((uint32_t)input[81] << 17) |
			((uint32_t)(input[82] & 0x80) << 9);
	output[40] = (double)(value >> 16);

	// read output[41]: from bit 657 to 672
	value = ((uint32_t)(input[82] & 0x7f) << 25) |
			((uint32_t)input[83] << 17) |
			((uint32_t)(input[84] & 0x80) << 9);
	output[41] = (double)(value >> 16);

	// read output[42]: from bit 673 to 688
	value = ((uint32_t)(input[84] & 0x7f) << 25) |
			((uint32_t)input[85] << 17) |
			((uint32_t)(input[86] & 0x80) << 9);
	output[42] = (double)(value >> 16);

	// read output[43]: from bit 689 to 704
	value = ((uint32_t)(input[86] & 0x7f) << 25) |
			((uint32_t)input[87] << 17) |
			((uint32_t)(input[88] & 0x80) << 9);
	output[43] = (double)(value >> 16);

	// read output[44]: from bit 705 to 720
	value = ((uint32_t)(input[88] & 0x7f) << 25) |
			((uint32_t)input[89] << 17) |
			((uint32_t)(input[90] & 0x80) << 9);
	output[44] = (double)(value >> 16);

	// read output[45]: from bit 721 to 736
	value = ((uint32_t)(input[90] & 0x7f) << 25) |
			((uint32_t)input[91] << 17) |
			((uint32_t)(input[92] & 0x80) << 9);
	output[45] = (double)(value >> 16);

	// read output[46]: from bit 737 to 752
	value = ((uint32_t)(input[92] & 0x7f) << 25) |
			((uint32_t)input[93] << 17) |
			((uint32_t)(input[94] & 0x80) << 9);
	output[46] = (double)(value >> 16);

	// read output[47]: from bit 753 to 768
	value = ((uint32_t)(input[94] & 0x7f) << 25) |
			((uint32_t)input[95] << 17) |
			((uint32_t)(input[96] & 0x80) << 9);
	output[47] = (double)(value >> 16);

	// read output[48]: from bit 769 to 784
	value = ((uint32_t)(input[96] & 0x7f) << 25) |
			((uint32_t)input[97] << 17) |
			((uint32_t)(input[98] & 0x80) << 9);
	output[48] = (double)(value >> 16);

	// read output[49]: from bit 785 to 800
	value = ((uint32_t)(input[98] & 0x7f) << 25) |
			((uint32_t)input[99] << 17) |
			((uint32_t)(input[100] & 0x80) << 9);
	output[49] = (double)(value >> 16);

	// read output[50]: from bit 801 to 816
	value = ((uint32_t)(input[100] & 0x7f) << 25) |
			((uint32_t)input[101] << 17) |
			((uint32_t)(input[102] & 0x80) << 9);
	output[50] = (double)(value >> 16);

	// read output[51]: from bit 817 to 832
	value = ((uint32_t)(input[102] & 0x7f) << 25) |
			((uint32_t)input[103] << 17) |
			((uint32_t)(input[104] & 0x80) << 9);
	output[51] = (double)(value >> 16);

	// read output[52]: from bit 833 to 848
	value = ((uint32_t)(input[104] & 0x7f) << 25) |
			((uint32_t)input[105] << 17) |
			((uint32_t)(input[106] & 0x80) << 9);
	output[52] = (double)(value >> 16);

	// read output[53]: from bit 849 to 864
	value = ((uint32_t)(input[106] & 0x7f) << 25) |
			((uint32_t)input[107] << 17) |
			((uint32_t)(input[108] & 0x80) << 9);
	output[53] = (double)(value >> 16);

	// read output[54]: from bit 865 to 880
	value = ((uint32_t)(input[108] & 0x7f) << 25) |
			((uint32_t)input[109] << 17) |
			((uint32_t)(input[110] & 0x80) << 9);
	output[54] = (double)(value >> 16);

	// read output[55]: from bit 881 to 896
	value = ((uint32_t)(input[110] & 0x7f) << 25) |
			((uint32_t)input[111] << 17) |
			((uint32_t)(input[112] & 0x80) << 9);
	output[55] = (double)(value >> 16);
}

static void unpack_56_16bit_signed_2off(const uint8_t * input, double * output, void *closure) {
	// Unpack 56 values into output
	// Values are 16-bit signed
	// Skip 2 bits, read 896 bits of data.
	// Input must be at least 113 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 2 to 17
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)input[1] << 18) |
			((uint32_t)(input[2] & 0xc0) << 10);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 18 to 33
	value = ((uint32_t)(input[2] & 0x3f) << 26) |
			((uint32_t)input[3] << 18) |
			((uint32_t)(input[4] & 0xc0) << 10);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 34 to 49
	value = ((uint32_t)(input[4] & 0x3f) << 26) |
			((uint32_t)input[5] << 18) |
			((uint32_t)(input[6] & 0xc0) << 10);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 50 to 65
	value = ((uint32_t)(input[6] & 0x3f) << 26) |
			((uint32_t)input[7] << 18) |
			((uint32_t)(input[8] & 0xc0) << 10);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 66 to 81
	value = ((uint32_t)(input[8] & 0x3f) << 26) |
			((uint32_t)input[9] << 18) |
			((uint32_t)(input[10] & 0xc0) << 10);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 82 to 97
	value = ((uint32_t)(input[10] & 0x3f) << 26) |
			((uint32_t)input[11] << 18) |
			((uint32_t)(input[12] & 0xc0) << 10);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 98 to 113
	value = ((uint32_t)(input[12] & 0x3f) << 26) |
			((uint32_t)input[13] << 18) |
			((uint32_t)(input[14] & 0xc0) << 10);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 114 to 129
	value = ((uint32_t)(input[14] & 0x3f) << 26) |
			((uint32_t)input[15] << 18) |
			((uint32_t)(input[16] & 0xc0) << 10);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 130 to 145
	value = ((uint32_t)(input[16] & 0x3f) << 26) |
			((uint32_t)input[17] << 18) |
			((uint32_t)(input[18] & 0xc0) << 10);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 146 to 161
	value = ((uint32_t)(input[18] & 0x3f) << 26) |
			((uint32_t)input[19] << 18) |
			((uint32_t)(input[20] & 0xc0) << 10);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 162 to 177
	value = ((uint32_t)(input[20] & 0x3f) << 26) |
			((uint32_t)input[21] << 18) |
			((uint32_t)(input[22] & 0xc0) << 10);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 178 to 193
	value = ((uint32_t)(input[22] & 0x3f) << 26) |
			((uint32_t)input[23] << 18) |
			((uint32_t)(input[24] & 0xc0) << 10);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 194 to 209
	value = ((uint32_t)(input[24] & 0x3f) << 26) |
			((uint32_t)input[25] << 18) |
			((uint32_t)(input[26] & 0xc0) << 10);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 210 to 225
	value = ((uint32_t)(input[26] & 0x3f) << 26) |
			((uint32_t)input[27] << 18) |
			((uint32_t)(input[28] & 0xc0) << 10);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 226 to 241
	value = ((uint32_t)(input[28] & 0x3f) << 26) |
			((uint32_t)input[29] << 18) |
			((uint32_t)(input[30] & 0xc0) << 10);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 242 to 257
	value = ((uint32_t)(input[30] & 0x3f) << 26) |
			((uint32_t)input[31] << 18) |
			((uint32_t)(input[32] & 0xc0) << 10);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 258 to 273
	value = ((uint32_t)(input[32] & 0x3f) << 26) |
			((uint32_t)input[33] << 18) |
			((uint32_t)(input[34] & 0xc0) << 10);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 274 to 289
	value = ((uint32_t)(input[34] & 0x3f) << 26) |
			((uint32_t)input[35] << 18) |
			((uint32_t)(input[36] & 0xc0) << 10);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 290 to 305
	value = ((uint32_t)(input[36] & 0x3f) << 26) |
			((uint32_t)input[37] << 18) |
			((uint32_t)(input[38] & 0xc0) << 10);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 306 to 321
	value = ((uint32_t)(input[38] & 0x3f) << 26) |
			((uint32_t)input[39] << 18) |
			((uint32_t)(input[40] & 0xc0) << 10);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 322 to 337
	value = ((uint32_t)(input[40] & 0x3f) << 26) |
			((uint32_t)input[41] << 18) |
			((uint32_t)(input[42] & 0xc0) << 10);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 338 to 353
	value = ((uint32_t)(input[42] & 0x3f) << 26) |
			((uint32_t)input[43] << 18) |
			((uint32_t)(input[44] & 0xc0) << 10);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 354 to 369
	value = ((uint32_t)(input[44] & 0x3f) << 26) |
			((uint32_t)input[45] << 18) |
			((uint32_t)(input[46] & 0xc0) << 10);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 370 to 385
	value = ((uint32_t)(input[46] & 0x3f) << 26) |
			((uint32_t)input[47] << 18) |
			((uint32_t)(input[48] & 0xc0) << 10);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 386 to 401
	value = ((uint32_t)(input[48] & 0x3f) << 26) |
			((uint32_t)input[49] << 18) |
			((uint32_t)(input[50] & 0xc0) << 10);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 402 to 417
	value = ((uint32_t)(input[50] & 0x3f) << 26) |
			((uint32_t)input[51] << 18) |
			((uint32_t)(input[52] & 0xc0) << 10);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 418 to 433
	value = ((uint32_t)(input[52] & 0x3f) << 26) |
			((uint32_t)input[53] << 18) |
			((uint32_t)(input[54] & 0xc0) << 10);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 434 to 449
	value = ((uint32_t)(input[54] & 0x3f) << 26) |
			((uint32_t)input[55] << 18) |
			((uint32_t)(input[56] & 0xc0) << 10);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 450 to 465
	value = ((uint32_t)(input[56] & 0x3f) << 26) |
			((uint32_t)input[57] << 18) |
			((uint32_t)(input[58] & 0xc0) << 10);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 466 to 481
	value = ((uint32_t)(input[58] & 0x3f) << 26) |
			((uint32_t)input[59] << 18) |
			((uint32_t)(input[60] & 0xc0) << 10);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 482 to 497
	value = ((uint32_t)(input[60] & 0x3f) << 26) |
			((uint32_t)input[61] << 18) |
			((uint32_t)(input[62] & 0xc0) << 10);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 498 to 513
	value = ((uint32_t)(input[62] & 0x3f) << 26) |
			((uint32_t)input[63] << 18) |
			((uint32_t)(input[64] & 0xc0) << 10);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 514 to 529
	value = ((uint32_t)(input[64] & 0x3f) << 26) |
			((uint32_t)input[65] << 18) |
			((uint32_t)(input[66] & 0xc0) << 10);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 530 to 545
	value = ((uint32_t)(input[66] & 0x3f) << 26) |
			((uint32_t)input[67] << 18) |
			((uint32_t)(input[68] & 0xc0) << 10);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 546 to 561
	value = ((uint32_t)(input[68] & 0x3f) << 26) |
			((uint32_t)input[69] << 18) |
			((uint32_t)(input[70] & 0xc0) << 10);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 562 to 577
	value = ((uint32_t)(input[70] & 0x3f) << 26) |
			((uint32_t)input[71] << 18) |
			((uint32_t)(input[72] & 0xc0) << 10);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 578 to 593
	value = ((uint32_t)(input[72] & 0x3f) << 26) |
			((uint32_t)input[73] << 18) |
			((uint32_t)(input[74] & 0xc0) << 10);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 594 to 609
	value = ((uint32_t)(input[74] & 0x3f) << 26) |
			((uint32_t)input[75] << 18) |
			((uint32_t)(input[76] & 0xc0) << 10);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 610 to 625
	value = ((uint32_t)(input[76] & 0x3f) << 26) |
			((uint32_t)input[77] << 18) |
			((uint32_t)(input[78] & 0xc0) << 10);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 626 to 641
	value = ((uint32_t)(input[78] & 0x3f) << 26) |
			((uint32_t)input[79] << 18) |
			((uint32_t)(input[80] & 0xc0) << 10);
	output[39] = (double)(value >> 16);

	// read output[40]: from bit 642 to 657
	value = ((uint32_t)(input[80] & 0x3f) << 26) |
			((uint32_t)input[81] << 18) |
			((uint32_t)(input[82] & 0xc0) << 10);
	output[40] = (double)(value >> 16);

	// read output[41]: from bit 658 to 673
	value = ((uint32_t)(input[82] & 0x3f) << 26) |
			((uint32_t)input[83] << 18) |
			((uint32_t)(input[84] & 0xc0) << 10);
	output[41] = (double)(value >> 16);

	// read output[42]: from bit 674 to 689
	value = ((uint32_t)(input[84] & 0x3f) << 26) |
			((uint32_t)input[85] << 18) |
			((uint32_t)(input[86] & 0xc0) << 10);
	output[42] = (double)(value >> 16);

	// read output[43]: from bit 690 to 705
	value = ((uint32_t)(input[86] & 0x3f) << 26) |
			((uint32_t)input[87] << 18) |
			((uint32_t)(input[88] & 0xc0) << 10);
	output[43] = (double)(value >> 16);

	// read output[44]: from bit 706 to 721
	value = ((uint32_t)(input[88] & 0x3f) << 26) |
			((uint32_t)input[89] << 18) |
			((uint32_t)(input[90] & 0xc0) << 10);
	output[44] = (double)(value >> 16);

	// read output[45]: from bit 722 to 737
	value = ((uint32_t)(input[90] & 0x3f) << 26) |
			((uint32_t)input[91] << 18) |
			((uint32_t)(input[92] & 0xc0) << 10);
	output[45] = (double)(value >> 16);

	// read output[46]: from bit 738 to 753
	value = ((uint32_t)(input[92] & 0x3f) << 26) |
			((uint32_t)input[93] << 18) |
			((uint32_t)(input[94] & 0xc0) << 10);
	output[46] = (double)(value >> 16);

	// read output[47]: from bit 754 to 769
	value = ((uint32_t)(input[94] & 0x3f) << 26) |
			((uint32_t)input[95] << 18) |
			((uint32_t)(input[96] & 0xc0) << 10);
	output[47] = (double)(value >> 16);

	// read output[48]: from bit 770 to 785
	value = ((uint32_t)(input[96] & 0x3f) << 26) |
			((uint32_t)input[97] << 18) |
			((uint32_t)(input[98] & 0xc0) << 10);
	output[48] = (double)(value >> 16);

	// read output[49]: from bit 786 to 801
	value = ((uint32_t)(input[98] & 0x3f) << 26) |
			((uint32_t)input[99] << 18) |
			((uint32_t)(input[100] & 0xc0) << 10);
	output[49] = (double)(value >> 16);

	// read output[50]: from bit 802 to 817
	value = ((uint32_t)(input[100] & 0x3f) << 26) |
			((uint32_t)input[101] << 18) |
			((uint32_t)(input[102] & 0xc0) << 10);
	output[50] = (double)(value >> 16);

	// read output[51]: from bit 818 to 833
	value = ((uint32_t)(input[102] & 0x3f) << 26) |
			((uint32_t)input[103] << 18) |
			((uint32_t)(input[104] & 0xc0) << 10);
	output[51] = (double)(value >> 16);

	// read output[52]: from bit 834 to 849
	value = ((uint32_t)(input[104] & 0x3f) << 26) |
			((uint32_t)input[105] << 18) |
			((uint32_t)(input[106] & 0xc0) << 10);
	output[52] = (double)(value >> 16);

	// read output[53]: from bit 850 to 865
	value = ((uint32_t)(input[106] & 0x3f) << 26) |
			((uint32_t)input[107] << 18) |
			((uint32_t)(input[108] & 0xc0) << 10);
	output[53] = (double)(value >> 16);

	// read output[54]: from bit 866 to 881
	value = ((uint32_t)(input[108] & 0x3f) << 26) |
			((uint32_t)input[109] << 18) |
			((uint32_t)(input[110] & 0xc0) << 10);
	output[54] = (double)(value >> 16);

	// read output[55]: from bit 882 to 897
	value = ((uint32_t)(input[110] & 0x3f) << 26) |
			((uint32_t)input[111] << 18) |
			((uint32_t)(input[112] & 0xc0) << 10);
	output[55] = (double)(value >> 16);
}

static void unpack_56_16bit_unsigned_2off(const uint8_t * input, double * output, void *closure) {
	// Unpack 56 values into output
	// Values are 16-bit unsigned
	// Skip 2 bits, read 896 bits of data.
	// Input must be at least 113 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 2 to 17
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)input[1] << 18) |
			((uint32_t)(input[2] & 0xc0) << 10);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 18 to 33
	value = ((uint32_t)(input[2] & 0x3f) << 26) |
			((uint32_t)input[3] << 18) |
			((uint32_t)(input[4] & 0xc0) << 10);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 34 to 49
	value = ((uint32_t)(input[4] & 0x3f) << 26) |
			((uint32_t)input[5] << 18) |
			((uint32_t)(input[6] & 0xc0) << 10);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 50 to 65
	value = ((uint32_t)(input[6] & 0x3f) << 26) |
			((uint32_t)input[7] << 18) |
			((uint32_t)(input[8] & 0xc0) << 10);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 66 to 81
	value = ((uint32_t)(input[8] & 0x3f) << 26) |
			((uint32_t)input[9] << 18) |
			((uint32_t)(input[10] & 0xc0) << 10);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 82 to 97
	value = ((uint32_t)(input[10] & 0x3f) << 26) |
			((uint32_t)input[11] << 18) |
			((uint32_t)(input[12] & 0xc0) << 10);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 98 to 113
	value = ((uint32_t)(input[12] & 0x3f) << 26) |
			((uint32_t)input[13] << 18) |
			((uint32_t)(input[14] & 0xc0) << 10);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 114 to 129
	value = ((uint32_t)(input[14] & 0x3f) << 26) |
			((uint32_t)input[15] << 18) |
			((uint32_t)(input[16] & 0xc0) << 10);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 130 to 145
	value = ((uint32_t)(input[16] & 0x3f) << 26) |
			((uint32_t)input[17] << 18) |
			((uint32_t)(input[18] & 0xc0) << 10);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 146 to 161
	value = ((uint32_t)(input[18] & 0x3f) << 26) |
			((uint32_t)input[19] << 18) |
			((uint32_t)(input[20] & 0xc0) << 10);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 162 to 177
	value = ((uint32_t)(input[20] & 0x3f) << 26) |
			((uint32_t)input[21] << 18) |
			((uint32_t)(input[22] & 0xc0) << 10);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 178 to 193
	value = ((uint32_t)(input[22] & 0x3f) << 26) |
			((uint32_t)input[23] << 18) |
			((uint32_t)(input[24] & 0xc0) << 10);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 194 to 209
	value = ((uint32_t)(input[24] & 0x3f) << 26) |
			((uint32_t)input[25] << 18) |
			((uint32_t)(input[26] & 0xc0) << 10);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 210 to 225
	value = ((uint32_t)(input[26] & 0x3f) << 26) |
			((uint32_t)input[27] << 18) |
			((uint32_t)(input[28] & 0xc0) << 10);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 226 to 241
	value = ((uint32_t)(input[28] & 0x3f) << 26) |
			((uint32_t)input[29] << 18) |
			((uint32_t)(input[30] & 0xc0) << 10);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 242 to 257
	value = ((uint32_t)(input[30] & 0x3f) << 26) |
			((uint32_t)input[31] << 18) |
			((uint32_t)(input[32] & 0xc0) << 10);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 258 to 273
	value = ((uint32_t)(input[32] & 0x3f) << 26) |
			((uint32_t)input[33] << 18) |
			((uint32_t)(input[34] & 0xc0) << 10);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 274 to 289
	value = ((uint32_t)(input[34] & 0x3f) << 26) |
			((uint32_t)input[35] << 18) |
			((uint32_t)(input[36] & 0xc0) << 10);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 290 to 305
	value = ((uint32_t)(input[36] & 0x3f) << 26) |
			((uint32_t)input[37] << 18) |
			((uint32_t)(input[38] & 0xc0) << 10);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 306 to 321
	value = ((uint32_t)(input[38] & 0x3f) << 26) |
			((uint32_t)input[39] << 18) |
			((uint32_t)(input[40] & 0xc0) << 10);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 322 to 337
	value = ((uint32_t)(input[40] & 0x3f) << 26) |
			((uint32_t)input[41] << 18) |
			((uint32_t)(input[42] & 0xc0) << 10);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 338 to 353
	value = ((uint32_t)(input[42] & 0x3f) << 26) |
			((uint32_t)input[43] << 18) |
			((uint32_t)(input[44] & 0xc0) << 10);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 354 to 369
	value = ((uint32_t)(input[44] & 0x3f) << 26) |
			((uint32_t)input[45] << 18) |
			((uint32_t)(input[46] & 0xc0) << 10);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 370 to 385
	value = ((uint32_t)(input[46] & 0x3f) << 26) |
			((uint32_t)input[47] << 18) |
			((uint32_t)(input[48] & 0xc0) << 10);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 386 to 401
	value = ((uint32_t)(input[48] & 0x3f) << 26) |
			((uint32_t)input[49] << 18) |
			((uint32_t)(input[50] & 0xc0) << 10);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 402 to 417
	value = ((uint32_t)(input[50] & 0x3f) << 26) |
			((uint32_t)input[51] << 18) |
			((uint32_t)(input[52] & 0xc0) << 10);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 418 to 433
	value = ((uint32_t)(input[52] & 0x3f) << 26) |
			((uint32_t)input[53] << 18) |
			((uint32_t)(input[54] & 0xc0) << 10);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 434 to 449
	value = ((uint32_t)(input[54] & 0x3f) << 26) |
			((uint32_t)input[55] << 18) |
			((uint32_t)(input[56] & 0xc0) << 10);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 450 to 465
	value = ((uint32_t)(input[56] & 0x3f) << 26) |
			((uint32_t)input[57] << 18) |
			((uint32_t)(input[58] & 0xc0) << 10);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 466 to 481
	value = ((uint32_t)(input[58] & 0x3f) << 26) |
			((uint32_t)input[59] << 18) |
			((uint32_t)(input[60] & 0xc0) << 10);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 482 to 497
	value = ((uint32_t)(input[60] & 0x3f) << 26) |
			((uint32_t)input[61] << 18) |
			((uint32_t)(input[62] & 0xc0) << 10);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 498 to 513
	value = ((uint32_t)(input[62] & 0x3f) << 26) |
			((uint32_t)input[63] << 18) |
			((uint32_t)(input[64] & 0xc0) << 10);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 514 to 529
	value = ((uint32_t)(input[64] & 0x3f) << 26) |
			((uint32_t)input[65] << 18) |
			((uint32_t)(input[66] & 0xc0) << 10);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 530 to 545
	value = ((uint32_t)(input[66] & 0x3f) << 26) |
			((uint32_t)input[67] << 18) |
			((uint32_t)(input[68] & 0xc0) << 10);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 546 to 561
	value = ((uint32_t)(input[68] & 0x3f) << 26) |
			((uint32_t)input[69] << 18) |
			((uint32_t)(input[70] & 0xc0) << 10);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 562 to 577
	value = ((uint32_t)(input[70] & 0x3f) << 26) |
			((uint32_t)input[71] << 18) |
			((uint32_t)(input[72] & 0xc0) << 10);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 578 to 593
	value = ((uint32_t)(input[72] & 0x3f) << 26) |
			((uint32_t)input[73] << 18) |
			((uint32_t)(input[74] & 0xc0) << 10);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 594 to 609
	value = ((uint32_t)(input[74] & 0x3f) << 26) |
			((uint32_t)input[75] << 18) |
			((uint32_t)(input[76] & 0xc0) << 10);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 610 to 625
	value = ((uint32_t)(input[76] & 0x3f) << 26) |
			((uint32_t)input[77] << 18) |
			((uint32_t)(input[78] & 0xc0) << 10);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 626 to 641
	value = ((uint32_t)(input[78] & 0x3f) << 26) |
			((uint32_t)input[79] << 18) |
			((uint32_t)(input[80] & 0xc0) << 10);
	output[39] = (double)(value >> 16);

	// read output[40]: from bit 642 to 657
	value = ((uint32_t)(input[80] & 0x3f) << 26) |
			((uint32_t)input[81] << 18) |
			((uint32_t)(input[82] & 0xc0) << 10);
	output[40] = (double)(value >> 16);

	// read output[41]: from bit 658 to 673
	value = ((uint32_t)(input[82] & 0x3f) << 26) |
			((uint32_t)input[83] << 18) |
			((uint32_t)(input[84] & 0xc0) << 10);
	output[41] = (double)(value >> 16);

	// read output[42]: from bit 674 to 689
	value = ((uint32_t)(input[84] & 0x3f) << 26) |
			((uint32_t)input[85] << 18) |
			((uint32_t)(input[86] & 0xc0) << 10);
	output[42] = (double)(value >> 16);

	// read output[43]: from bit 690 to 705
	value = ((uint32_t)(input[86] & 0x3f) << 26) |
			((uint32_t)input[87] << 18) |
			((uint32_t)(input[88] & 0xc0) << 10);
	output[43] = (double)(value >> 16);

	// read output[44]: from bit 706 to 721
	value = ((uint32_t)(input[88] & 0x3f) << 26) |
			((uint32_t)input[89] << 18) |
			((uint32_t)(input[90] & 0xc0) << 10);
	output[44] = (double)(value >> 16);

	// read output[45]: from bit 722 to 737
	value = ((uint32_t)(input[90] & 0x3f) << 26) |
			((uint32_t)input[91] << 18) |
			((uint32_t)(input[92] & 0xc0) << 10);
	output[45] = (double)(value >> 16);

	// read output[46]: from bit 738 to 753
	value = ((uint32_t)(input[92] & 0x3f) << 26) |
			((uint32_t)input[93] << 18) |
			((uint32_t)(input[94] & 0xc0) << 10);
	output[46] = (double)(value >> 16);

	// read output[47]: from bit 754 to 769
	value = ((uint32_t)(input[94] & 0x3f) << 26) |
			((uint32_t)input[95] << 18) |
			((uint32_t)(input[96] & 0xc0) << 10);
	output[47] = (double)(value >> 16);

	// read output[48]: from bit 770 to 785
	value = ((uint32_t)(input[96] & 0x3f) << 26) |
			((uint32_t)input[97] << 18) |
			((uint32_t)(input[98] & 0xc0) << 10);
	output[48] = (double)(value >> 16);

	// read output[49]: from bit 786 to 801
	value = ((uint32_t)(input[98] & 0x3f) << 26) |
			((uint32_t)input[99] << 18) |
			((uint32_t)(input[100] & 0xc0) << 10);
	output[49] = (double)(value >> 16);

	// read output[50]: from bit 802 to 817
	value = ((uint32_t)(input[100] & 0x3f) << 26) |
			((uint32_t)input[101] << 18) |
			((uint32_t)(input[102] & 0xc0) << 10);
	output[50] = (double)(value >> 16);

	// read output[51]: from bit 818 to 833
	value = ((uint32_t)(input[102] & 0x3f) << 26) |
			((uint32_t)input[103] << 18) |
			((uint32_t)(input[104] & 0xc0) << 10);
	output[51] = (double)(value >> 16);

	// read output[52]: from bit 834 to 849
	value = ((uint32_t)(input[104] & 0x3f) << 26) |
			((uint32_t)input[105] << 18) |
			((uint32_t)(input[106] & 0xc0) << 10);
	output[52] = (double)(value >> 16);

	// read output[53]: from bit 850 to 865
	value = ((uint32_t)(input[106] & 0x3f) << 26) |
			((uint32_t)input[107] << 18) |
			((uint32_t)(input[108] & 0xc0) << 10);
	output[53] = (double)(value >> 16);

	// read output[54]: from bit 866 to 881
	value = ((uint32_t)(input[108] & 0x3f) << 26) |
			((uint32_t)input[109] << 18) |
			((uint32_t)(input[110] & 0xc0) << 10);
	output[54] = (double)(value >> 16);

	// read output[55]: from bit 882 to 897
	value = ((uint32_t)(input[110] & 0x3f) << 26) |
			((uint32_t)input[111] << 18) |
			((uint32_t)(input[112] & 0xc0) << 10);
	output[55] = (double)(value >> 16);
}

static void unpack_56_16bit_signed_3off(const uint8_t * input, double * output, void *closure) {
	// Unpack 56 values into output
	// Values are 16-bit signed
	// Skip 3 bits, read 896 bits of data.
	// Input must be at least 113 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 3 to 18
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)input[1] << 19) |
			((uint32_t)(input[2] & 0xe0) << 11);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 19 to 34
	value = ((uint32_t)(input[2] & 0x1f) << 27) |
			((uint32_t)input[3] << 19) |
			((uint32_t)(input[4] & 0xe0) << 11);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 35 to 50
	value = ((uint32_t)(input[4] & 0x1f) << 27) |
			((uint32_t)input[5] << 19) |
			((uint32_t)(input[6] & 0xe0) << 11);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 51 to 66
	value = ((uint32_t)(input[6] & 0x1f) << 27) |
			((uint32_t)input[7] << 19) |
			((uint32_t)(input[8] & 0xe0) << 11);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 67 to 82
	value = ((uint32_t)(input[8] & 0x1f) << 27) |
			((uint32_t)input[9] << 19) |
			((uint32_t)(input[10] & 0xe0) << 11);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 83 to 98
	value = ((uint32_t)(input[10] & 0x1f) << 27) |
			((uint32_t)input[11] << 19) |
			((uint32_t)(input[12] & 0xe0) << 11);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 99 to 114
	value = ((uint32_t)(input[12] & 0x1f) << 27) |
			((uint32_t)input[13] << 19) |
			((uint32_t)(input[14] & 0xe0) << 11);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 115 to 130
	value = ((uint32_t)(input[14] & 0x1f) << 27) |
			((uint32_t)input[15] << 19) |
			((uint32_t)(input[16] & 0xe0) << 11);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 131 to 146
	value = ((uint32_t)(input[16] & 0x1f) << 27) |
			((uint32_t)input[17] << 19) |
			((uint32_t)(input[18] & 0xe0) << 11);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 147 to 162
	value = ((uint32_t)(input[18] & 0x1f) << 27) |
			((uint32_t)input[19] << 19) |
			((uint32_t)(input[20] & 0xe0) << 11);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 163 to 178
	value = ((uint32_t)(input[20] & 0x1f) << 27) |
			((uint32_t)input[21] << 19) |
			((uint32_t)(input[22] & 0xe0) << 11);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 179 to 194
	value = ((uint32_t)(input[22] & 0x1f) << 27) |
			((uint32_t)input[23] << 19) |
			((uint32_t)(input[24] & 0xe0) << 11);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 195 to 210
	value = ((uint32_t)(input[24] & 0x1f) << 27) |
			((uint32_t)input[25] << 19) |
			((uint32_t)(input[26] & 0xe0) << 11);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 211 to 226
	value = ((uint32_t)(input[26] & 0x1f) << 27) |
			((uint32_t)input[27] << 19) |
			((uint32_t)(input[28] & 0xe0) << 11);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 227 to 242
	value = ((uint32_t)(input[28] & 0x1f) << 27) |
			((uint32_t)input[29] << 19) |
			((uint32_t)(input[30] & 0xe0) << 11);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 243 to 258
	value = ((uint32_t)(input[30] & 0x1f) << 27) |
			((uint32_t)input[31] << 19) |
			((uint32_t)(input[32] & 0xe0) << 11);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 259 to 274
	value = ((uint32_t)(input[32] & 0x1f) << 27) |
			((uint32_t)input[33] << 19) |
			((uint32_t)(input[34] & 0xe0) << 11);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 275 to 290
	value = ((uint32_t)(input[34] & 0x1f) << 27) |
			((uint32_t)input[35] << 19) |
			((uint32_t)(input[36] & 0xe0) << 11);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 291 to 306
	value = ((uint32_t)(input[36] & 0x1f) << 27) |
			((uint32_t)input[37] << 19) |
			((uint32_t)(input[38] & 0xe0) << 11);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 307 to 322
	value = ((uint32_t)(input[38] & 0x1f) << 27) |
			((uint32_t)input[39] << 19) |
			((uint32_t)(input[40] & 0xe0) << 11);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 323 to 338
	value = ((uint32_t)(input[40] & 0x1f) << 27) |
			((uint32_t)input[41] << 19) |
			((uint32_t)(input[42] & 0xe0) << 11);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 339 to 354
	value = ((uint32_t)(input[42] & 0x1f) << 27) |
			((uint32_t)input[43] << 19) |
			((uint32_t)(input[44] & 0xe0) << 11);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 355 to 370
	value = ((uint32_t)(input[44] & 0x1f) << 27) |
			((uint32_t)input[45] << 19) |
			((uint32_t)(input[46] & 0xe0) << 11);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 371 to 386
	value = ((uint32_t)(input[46] & 0x1f) << 27) |
			((uint32_t)input[47] << 19) |
			((uint32_t)(input[48] & 0xe0) << 11);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 387 to 402
	value = ((uint32_t)(input[48] & 0x1f) << 27) |
			((uint32_t)input[49] << 19) |
			((uint32_t)(input[50] & 0xe0) << 11);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 403 to 418
	value = ((uint32_t)(input[50] & 0x1f) << 27) |
			((uint32_t)input[51] << 19) |
			((uint32_t)(input[52] & 0xe0) << 11);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 419 to 434
	value = ((uint32_t)(input[52] & 0x1f) << 27) |
			((uint32_t)input[53] << 19) |
			((uint32_t)(input[54] & 0xe0) << 11);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 435 to 450
	value = ((uint32_t)(input[54] & 0x1f) << 27) |
			((uint32_t)input[55] << 19) |
			((uint32_t)(input[56] & 0xe0) << 11);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 451 to 466
	value = ((uint32_t)(input[56] & 0x1f) << 27) |
			((uint32_t)input[57] << 19) |
			((uint32_t)(input[58] & 0xe0) << 11);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 467 to 482
	value = ((uint32_t)(input[58] & 0x1f) << 27) |
			((uint32_t)input[59] << 19) |
			((uint32_t)(input[60] & 0xe0) << 11);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 483 to 498
	value = ((uint32_t)(input[60] & 0x1f) << 27) |
			((uint32_t)input[61] << 19) |
			((uint32_t)(input[62] & 0xe0) << 11);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 499 to 514
	value = ((uint32_t)(input[62] & 0x1f) << 27) |
			((uint32_t)input[63] << 19) |
			((uint32_t)(input[64] & 0xe0) << 11);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 515 to 530
	value = ((uint32_t)(input[64] & 0x1f) << 27) |
			((uint32_t)input[65] << 19) |
			((uint32_t)(input[66] & 0xe0) << 11);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 531 to 546
	value = ((uint32_t)(input[66] & 0x1f) << 27) |
			((uint32_t)input[67] << 19) |
			((uint32_t)(input[68] & 0xe0) << 11);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 547 to 562
	value = ((uint32_t)(input[68] & 0x1f) << 27) |
			((uint32_t)input[69] << 19) |
			((uint32_t)(input[70] & 0xe0) << 11);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 563 to 578
	value = ((uint32_t)(input[70] & 0x1f) << 27) |
			((uint32_t)input[71] << 19) |
			((uint32_t)(input[72] & 0xe0) << 11);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 579 to 594
	value = ((uint32_t)(input[72] & 0x1f) << 27) |
			((uint32_t)input[73] << 19) |
			((uint32_t)(input[74] & 0xe0) << 11);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 595 to 610
	value = ((uint32_t)(input[74] & 0x1f) << 27) |
			((uint32_t)input[75] << 19) |
			((uint32_t)(input[76] & 0xe0) << 11);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 611 to 626
	value = ((uint32_t)(input[76] & 0x1f) << 27) |
			((uint32_t)input[77] << 19) |
			((uint32_t)(input[78] & 0xe0) << 11);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 627 to 642
	value = ((uint32_t)(input[78] & 0x1f) << 27) |
			((uint32_t)input[79] << 19) |
			((uint32_t)(input[80] & 0xe0) << 11);
	output[39] = (double)(value >> 16);

	// read output[40]: from bit 643 to 658
	value = ((uint32_t)(input[80] & 0x1f) << 27) |
			((uint32_t)input[81] << 19) |
			((uint32_t)(input[82] & 0xe0) << 11);
	output[40] = (double)(value >> 16);

	// read output[41]: from bit 659 to 674
	value = ((uint32_t)(input[82] & 0x1f) << 27) |
			((uint32_t)input[83] << 19) |
			((uint32_t)(input[84] & 0xe0) << 11);
	output[41] = (double)(value >> 16);

	// read output[42]: from bit 675 to 690
	value = ((uint32_t)(input[84] & 0x1f) << 27) |
			((uint32_t)input[85] << 19) |
			((uint32_t)(input[86] & 0xe0) << 11);
	output[42] = (double)(value >> 16);

	// read output[43]: from bit 691 to 706
	value = ((uint32_t)(input[86] & 0x1f) << 27) |
			((uint32_t)input[87] << 19) |
			((uint32_t)(input[88] & 0xe0) << 11);
	output[43] = (double)(value >> 16);

	// read output[44]: from bit 707 to 722
	value = ((uint32_t)(input[88] & 0x1f) << 27) |
			((uint32_t)input[89] << 19) |
			((uint32_t)(input[90] & 0xe0) << 11);
	output[44] = (double)(value >> 16);

	// read output[45]: from bit 723 to 738
	value = ((uint32_t)(input[90] & 0x1f) << 27) |
			((uint32_t)input[91] << 19) |
			((uint32_t)(input[92] & 0xe0) << 11);
	output[45] = (double)(value >> 16);

	// read output[46]: from bit 739 to 754
	value = ((uint32_t)(input[92] & 0x1f) << 27) |
			((uint32_t)input[93] << 19) |
			((uint32_t)(input[94] & 0xe0) << 11);
	output[46] = (double)(value >> 16);

	// read output[47]: from bit 755 to 770
	value = ((uint32_t)(input[94] & 0x1f) << 27) |
			((uint32_t)input[95] << 19) |
			((uint32_t)(input[96] & 0xe0) << 11);
	output[47] = (double)(value >> 16);

	// read output[48]: from bit 771 to 786
	value = ((uint32_t)(input[96] & 0x1f) << 27) |
			((uint32_t)input[97] << 19) |
			((uint32_t)(input[98] & 0xe0) << 11);
	output[48] = (double)(value >> 16);

	// read output[49]: from bit 787 to 802
	value = ((uint32_t)(input[98] & 0x1f) << 27) |
			((uint32_t)input[99] << 19) |
			((uint32_t)(input[100] & 0xe0) << 11);
	output[49] = (double)(value >> 16);

	// read output[50]: from bit 803 to 818
	value = ((uint32_t)(input[100] & 0x1f) << 27) |
			((uint32_t)input[101] << 19) |
			((uint32_t)(input[102] & 0xe0) << 11);
	output[50] = (double)(value >> 16);

	// read output[51]: from bit 819 to 834
	value = ((uint32_t)(input[102] & 0x1f) << 27) |
			((uint32_t)input[103] << 19) |
			((uint32_t)(input[104] & 0xe0) << 11);
	output[51] = (double)(value >> 16);

	// read output[52]: from bit 835 to 850
	value = ((uint32_t)(input[104] & 0x1f) << 27) |
			((uint32_t)input[105] << 19) |
			((uint32_t)(input[106] & 0xe0) << 11);
	output[52] = (double)(value >> 16);

	// read output[53]: from bit 851 to 866
	value = ((uint32_t)(input[106] & 0x1f) << 27) |
			((uint32_t)input[107] << 19) |
			((uint32_t)(input[108] & 0xe0) << 11);
	output[53] = (double)(value >> 16);

	// read output[54]: from bit 867 to 882
	value = ((uint32_t)(input[108] & 0x1f) << 27) |
			((uint32_t)input[109] << 19) |
			((uint32_t)(input[110] & 0xe0) << 11);
	output[54] = (double)(value >> 16);

	// read output[55]: from bit 883 to 898
	value = ((uint32_t)(input[110] & 0x1f) << 27) |
			((uint32_t)input[111] << 19) |
			((uint32_t)(input[112] & 0xe0) << 11);
	output[55] = (double)(value >> 16);
}

static void unpack_56_16bit_unsigned_3off(const uint8_t * input, double * output, void *closure) {
	// Unpack 56 values into output
	// Values are 16-bit unsigned
	// Skip 3 bits, read 896 bits of data.
	// Input must be at least 113 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 3 to 18
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)input[1] << 19) |
			((uint32_t)(input[2] & 0xe0) << 11);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 19 to 34
	value = ((uint32_t)(input[2] & 0x1f) << 27) |
			((uint32_t)input[3] << 19) |
			((uint32_t)(input[4] & 0xe0) << 11);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 35 to 50
	value = ((uint32_t)(input[4] & 0x1f) << 27) |
			((uint32_t)input[5] << 19) |
			((uint32_t)(input[6] & 0xe0) << 11);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 51 to 66
	value = ((uint32_t)(input[6] & 0x1f) << 27) |
			((uint32_t)input[7] << 19) |
			((uint32_t)(input[8] & 0xe0) << 11);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 67 to 82
	value = ((uint32_t)(input[8] & 0x1f) << 27) |
			((uint32_t)input[9] << 19) |
			((uint32_t)(input[10] & 0xe0) << 11);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 83 to 98
	value = ((uint32_t)(input[10] & 0x1f) << 27) |
			((uint32_t)input[11] << 19) |
			((uint32_t)(input[12] & 0xe0) << 11);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 99 to 114
	value = ((uint32_t)(input[12] & 0x1f) << 27) |
			((uint32_t)input[13] << 19) |
			((uint32_t)(input[14] & 0xe0) << 11);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 115 to 130
	value = ((uint32_t)(input[14] & 0x1f) << 27) |
			((uint32_t)input[15] << 19) |
			((uint32_t)(input[16] & 0xe0) << 11);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 131 to 146
	value = ((uint32_t)(input[16] & 0x1f) << 27) |
			((uint32_t)input[17] << 19) |
			((uint32_t)(input[18] & 0xe0) << 11);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 147 to 162
	value = ((uint32_t)(input[18] & 0x1f) << 27) |
			((uint32_t)input[19] << 19) |
			((uint32_t)(input[20] & 0xe0) << 11);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 163 to 178
	value = ((uint32_t)(input[20] & 0x1f) << 27) |
			((uint32_t)input[21] << 19) |
			((uint32_t)(input[22] & 0xe0) << 11);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 179 to 194
	value = ((uint32_t)(input[22] & 0x1f) << 27) |
			((uint32_t)input[23] << 19) |
			((uint32_t)(input[24] & 0xe0) << 11);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 195 to 210
	value = ((uint32_t)(input[24] & 0x1f) << 27) |
			((uint32_t)input[25] << 19) |
			((uint32_t)(input[26] & 0xe0) << 11);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 211 to 226
	value = ((uint32_t)(input[26] & 0x1f) << 27) |
			((uint32_t)input[27] << 19) |
			((uint32_t)(input[28] & 0xe0) << 11);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 227 to 242
	value = ((uint32_t)(input[28] & 0x1f) << 27) |
			((uint32_t)input[29] << 19) |
			((uint32_t)(input[30] & 0xe0) << 11);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 243 to 258
	value = ((uint32_t)(input[30] & 0x1f) << 27) |
			((uint32_t)input[31] << 19) |
			((uint32_t)(input[32] & 0xe0) << 11);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 259 to 274
	value = ((uint32_t)(input[32] & 0x1f) << 27) |
			((uint32_t)input[33] << 19) |
			((uint32_t)(input[34] & 0xe0) << 11);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 275 to 290
	value = ((uint32_t)(input[34] & 0x1f) << 27) |
			((uint32_t)input[35] << 19) |
			((uint32_t)(input[36] & 0xe0) << 11);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 291 to 306
	value = ((uint32_t)(input[36] & 0x1f) << 27) |
			((uint32_t)input[37] << 19) |
			((uint32_t)(input[38] & 0xe0) << 11);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 307 to 322
	value = ((uint32_t)(input[38] & 0x1f) << 27) |
			((uint32_t)input[39] << 19) |
			((uint32_t)(input[40] & 0xe0) << 11);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 323 to 338
	value = ((uint32_t)(input[40] & 0x1f) << 27) |
			((uint32_t)input[41] << 19) |
			((uint32_t)(input[42] & 0xe0) << 11);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 339 to 354
	value = ((uint32_t)(input[42] & 0x1f) << 27) |
			((uint32_t)input[43] << 19) |
			((uint32_t)(input[44] & 0xe0) << 11);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 355 to 370
	value = ((uint32_t)(input[44] & 0x1f) << 27) |
			((uint32_t)input[45] << 19) |
			((uint32_t)(input[46] & 0xe0) << 11);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 371 to 386
	value = ((uint32_t)(input[46] & 0x1f) << 27) |
			((uint32_t)input[47] << 19) |
			((uint32_t)(input[48] & 0xe0) << 11);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 387 to 402
	value = ((uint32_t)(input[48] & 0x1f) << 27) |
			((uint32_t)input[49] << 19) |
			((uint32_t)(input[50] & 0xe0) << 11);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 403 to 418
	value = ((uint32_t)(input[50] & 0x1f) << 27) |
			((uint32_t)input[51] << 19) |
			((uint32_t)(input[52] & 0xe0) << 11);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 419 to 434
	value = ((uint32_t)(input[52] & 0x1f) << 27) |
			((uint32_t)input[53] << 19) |
			((uint32_t)(input[54] & 0xe0) << 11);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 435 to 450
	value = ((uint32_t)(input[54] & 0x1f) << 27) |
			((uint32_t)input[55] << 19) |
			((uint32_t)(input[56] & 0xe0) << 11);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 451 to 466
	value = ((uint32_t)(input[56] & 0x1f) << 27) |
			((uint32_t)input[57] << 19) |
			((uint32_t)(input[58] & 0xe0) << 11);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 467 to 482
	value = ((uint32_t)(input[58] & 0x1f) << 27) |
			((uint32_t)input[59] << 19) |
			((uint32_t)(input[60] & 0xe0) << 11);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 483 to 498
	value = ((uint32_t)(input[60] & 0x1f) << 27) |
			((uint32_t)input[61] << 19) |
			((uint32_t)(input[62] & 0xe0) << 11);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 499 to 514
	value = ((uint32_t)(input[62] & 0x1f) << 27) |
			((uint32_t)input[63] << 19) |
			((uint32_t)(input[64] & 0xe0) << 11);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 515 to 530
	value = ((uint32_t)(input[64] & 0x1f) << 27) |
			((uint32_t)input[65] << 19) |
			((uint32_t)(input[66] & 0xe0) << 11);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 531 to 546
	value = ((uint32_t)(input[66] & 0x1f) << 27) |
			((uint32_t)input[67] << 19) |
			((uint32_t)(input[68] & 0xe0) << 11);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 547 to 562
	value = ((uint32_t)(input[68] & 0x1f) << 27) |
			((uint32_t)input[69] << 19) |
			((uint32_t)(input[70] & 0xe0) << 11);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 563 to 578
	value = ((uint32_t)(input[70] & 0x1f) << 27) |
			((uint32_t)input[71] << 19) |
			((uint32_t)(input[72] & 0xe0) << 11);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 579 to 594
	value = ((uint32_t)(input[72] & 0x1f) << 27) |
			((uint32_t)input[73] << 19) |
			((uint32_t)(input[74] & 0xe0) << 11);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 595 to 610
	value = ((uint32_t)(input[74] & 0x1f) << 27) |
			((uint32_t)input[75] << 19) |
			((uint32_t)(input[76] & 0xe0) << 11);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 611 to 626
	value = ((uint32_t)(input[76] & 0x1f) << 27) |
			((uint32_t)input[77] << 19) |
			((uint32_t)(input[78] & 0xe0) << 11);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 627 to 642
	value = ((uint32_t)(input[78] & 0x1f) << 27) |
			((uint32_t)input[79] << 19) |
			((uint32_t)(input[80] & 0xe0) << 11);
	output[39] = (double)(value >> 16);

	// read output[40]: from bit 643 to 658
	value = ((uint32_t)(input[80] & 0x1f) << 27) |
			((uint32_t)input[81] << 19) |
			((uint32_t)(input[82] & 0xe0) << 11);
	output[40] = (double)(value >> 16);

	// read output[41]: from bit 659 to 674
	value = ((uint32_t)(input[82] & 0x1f) << 27) |
			((uint32_t)input[83] << 19) |
			((uint32_t)(input[84] & 0xe0) << 11);
	output[41] = (double)(value >> 16);

	// read output[42]: from bit 675 to 690
	value = ((uint32_t)(input[84] & 0x1f) << 27) |
			((uint32_t)input[85] << 19) |
			((uint32_t)(input[86] & 0xe0) << 11);
	output[42] = (double)(value >> 16);

	// read output[43]: from bit 691 to 706
	value = ((uint32_t)(input[86] & 0x1f) << 27) |
			((uint32_t)input[87] << 19) |
			((uint32_t)(input[88] & 0xe0) << 11);
	output[43] = (double)(value >> 16);

	// read output[44]: from bit 707 to 722
	value = ((uint32_t)(input[88] & 0x1f) << 27) |
			((uint32_t)input[89] << 19) |
			((uint32_t)(input[90] & 0xe0) << 11);
	output[44] = (double)(value >> 16);

	// read output[45]: from bit 723 to 738
	value = ((uint32_t)(input[90] & 0x1f) << 27) |
			((uint32_t)input[91] << 19) |
			((uint32_t)(input[92] & 0xe0) << 11);
	output[45] = (double)(value >> 16);

	// read output[46]: from bit 739 to 754
	value = ((uint32_t)(input[92] & 0x1f) << 27) |
			((uint32_t)input[93] << 19) |
			((uint32_t)(input[94] & 0xe0) << 11);
	output[46] = (double)(value >> 16);

	// read output[47]: from bit 755 to 770
	value = ((uint32_t)(input[94] & 0x1f) << 27) |
			((uint32_t)input[95] << 19) |
			((uint32_t)(input[96] & 0xe0) << 11);
	output[47] = (double)(value >> 16);

	// read output[48]: from bit 771 to 786
	value = ((uint32_t)(input[96] & 0x1f) << 27) |
			((uint32_t)input[97] << 19) |
			((uint32_t)(input[98] & 0xe0) << 11);
	output[48] = (double)(value >> 16);

	// read output[49]: from bit 787 to 802
	value = ((uint32_t)(input[98] & 0x1f) << 27) |
			((uint32_t)input[99] << 19) |
			((uint32_t)(input[100] & 0xe0) << 11);
	output[49] = (double)(value >> 16);

	// read output[50]: from bit 803 to 818
	value = ((uint32_t)(input[100] & 0x1f) << 27) |
			((uint32_t)input[101] << 19) |
			((uint32_t)(input[102] & 0xe0) << 11);
	output[50] = (double)(value >> 16);

	// read output[51]: from bit 819 to 834
	value = ((uint32_t)(input[102] & 0x1f) << 27) |
			((uint32_t)input[103] << 19) |
			((uint32_t)(input[104] & 0xe0) << 11);
	output[51] = (double)(value >> 16);

	// read output[52]: from bit 835 to 850
	value = ((uint32_t)(input[104] & 0x1f) << 27) |
			((uint32_t)input[105] << 19) |
			((uint32_t)(input[106] & 0xe0) << 11);
	output[52] = (double)(value >> 16);

	// read output[53]: from bit 851 to 866
	value = ((uint32_t)(input[106] & 0x1f) << 27) |
			((uint32_t)input[107] << 19) |
			((uint32_t)(input[108] & 0xe0) << 11);
	output[53] = (double)(value >> 16);

	// read output[54]: from bit 867 to 882
	value = ((uint32_t)(input[108] & 0x1f) << 27) |
			((uint32_t)input[109] << 19) |
			((uint32_t)(input[110] & 0xe0) << 11);
	output[54] = (double)(value >> 16);

	// read output[55]: from bit 883 to 898
	value = ((uint32_t)(input[110] & 0x1f) << 27) |
			((uint32_t)input[111] << 19) |
			((uint32_t)(input[112] & 0xe0) << 11);
	output[55] = (double)(value >> 16);
}

static void unpack_56_16bit_signed_4off(const uint8_t * input, double * output, void *closure) {
	// Unpack 56 values into output
	// Values are 16-bit signed
	// Skip 4 bits, read 896 bits of data.
	// Input must be at least 113 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 4 to 19
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20) |
			((uint32_t)(input[2] & 0xf0) << 12);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 20 to 35
	value = ((uint32_t)(input[2] & 0x0f) << 28) |
			((uint32_t)input[3] << 20) |
			((uint32_t)(input[4] & 0xf0) << 12);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 36 to 51
	value = ((uint32_t)(input[4] & 0x0f) << 28) |
			((uint32_t)input[5] << 20) |
			((uint32_t)(input[6] & 0xf0) << 12);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 52 to 67
	value = ((uint32_t)(input[6] & 0x0f) << 28) |
			((uint32_t)input[7] << 20) |
			((uint32_t)(input[8] & 0xf0) << 12);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 68 to 83
	value = ((uint32_t)(input[8] & 0x0f) << 28) |
			((uint32_t)input[9] << 20) |
			((uint32_t)(input[10] & 0xf0) << 12);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 84 to 99
	value = ((uint32_t)(input[10] & 0x0f) << 28) |
			((uint32_t)input[11] << 20) |
			((uint32_t)(input[12] & 0xf0) << 12);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 100 to 115
	value = ((uint32_t)(input[12] & 0x0f) << 28) |
			((uint32_t)input[13] << 20) |
			((uint32_t)(input[14] & 0xf0) << 12);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 116 to 131
	value = ((uint32_t)(input[14] & 0x0f) << 28) |
			((uint32_t)input[15] << 20) |
			((uint32_t)(input[16] & 0xf0) << 12);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 132 to 147
	value = ((uint32_t)(input[16] & 0x0f) << 28) |
			((uint32_t)input[17] << 20) |
			((uint32_t)(input[18] & 0xf0) << 12);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 148 to 163
	value = ((uint32_t)(input[18] & 0x0f) << 28) |
			((uint32_t)input[19] << 20) |
			((uint32_t)(input[20] & 0xf0) << 12);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 164 to 179
	value = ((uint32_t)(input[20] & 0x0f) << 28) |
			((uint32_t)input[21] << 20) |
			((uint32_t)(input[22] & 0xf0) << 12);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 180 to 195
	value = ((uint32_t)(input[22] & 0x0f) << 28) |
			((uint32_t)input[23] << 20) |
			((uint32_t)(input[24] & 0xf0) << 12);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 196 to 211
	value = ((uint32_t)(input[24] & 0x0f) << 28) |
			((uint32_t)input[25] << 20) |
			((uint32_t)(input[26] & 0xf0) << 12);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 212 to 227
	value = ((uint32_t)(input[26] & 0x0f) << 28) |
			((uint32_t)input[27] << 20) |
			((uint32_t)(input[28] & 0xf0) << 12);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 228 to 243
	value = ((uint32_t)(input[28] & 0x0f) << 28) |
			((uint32_t)input[29] << 20) |
			((uint32_t)(input[30] & 0xf0) << 12);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 244 to 259
	value = ((uint32_t)(input[30] & 0x0f) << 28) |
			((uint32_t)input[31] << 20) |
			((uint32_t)(input[32] & 0xf0) << 12);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 260 to 275
	value = ((uint32_t)(input[32] & 0x0f) << 28) |
			((uint32_t)input[33] << 20) |
			((uint32_t)(input[34] & 0xf0) << 12);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 276 to 291
	value = ((uint32_t)(input[34] & 0x0f) << 28) |
			((uint32_t)input[35] << 20) |
			((uint32_t)(input[36] & 0xf0) << 12);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 292 to 307
	value = ((uint32_t)(input[36] & 0x0f) << 28) |
			((uint32_t)input[37] << 20) |
			((uint32_t)(input[38] & 0xf0) << 12);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 308 to 323
	value = ((uint32_t)(input[38] & 0x0f) << 28) |
			((uint32_t)input[39] << 20) |
			((uint32_t)(input[40] & 0xf0) << 12);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 324 to 339
	value = ((uint32_t)(input[40] & 0x0f) << 28) |
			((uint32_t)input[41] << 20) |
			((uint32_t)(input[42] & 0xf0) << 12);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 340 to 355
	value = ((uint32_t)(input[42] & 0x0f) << 28) |
			((uint32_t)input[43] << 20) |
			((uint32_t)(input[44] & 0xf0) << 12);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 356 to 371
	value = ((uint32_t)(input[44] & 0x0f) << 28) |
			((uint32_t)input[45] << 20) |
			((uint32_t)(input[46] & 0xf0) << 12);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 372 to 387
	value = ((uint32_t)(input[46] & 0x0f) << 28) |
			((uint32_t)input[47] << 20) |
			((uint32_t)(input[48] & 0xf0) << 12);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 388 to 403
	value = ((uint32_t)(input[48] & 0x0f) << 28) |
			((uint32_t)input[49] << 20) |
			((uint32_t)(input[50] & 0xf0) << 12);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 404 to 419
	value = ((uint32_t)(input[50] & 0x0f) << 28) |
			((uint32_t)input[51] << 20) |
			((uint32_t)(input[52] & 0xf0) << 12);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 420 to 435
	value = ((uint32_t)(input[52] & 0x0f) << 28) |
			((uint32_t)input[53] << 20) |
			((uint32_t)(input[54] & 0xf0) << 12);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 436 to 451
	value = ((uint32_t)(input[54] & 0x0f) << 28) |
			((uint32_t)input[55] << 20) |
			((uint32_t)(input[56] & 0xf0) << 12);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 452 to 467
	value = ((uint32_t)(input[56] & 0x0f) << 28) |
			((uint32_t)input[57] << 20) |
			((uint32_t)(input[58] & 0xf0) << 12);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 468 to 483
	value = ((uint32_t)(input[58] & 0x0f) << 28) |
			((uint32_t)input[59] << 20) |
			((uint32_t)(input[60] & 0xf0) << 12);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 484 to 499
	value = ((uint32_t)(input[60] & 0x0f) << 28) |
			((uint32_t)input[61] << 20) |
			((uint32_t)(input[62] & 0xf0) << 12);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 500 to 515
	value = ((uint32_t)(input[62] & 0x0f) << 28) |
			((uint32_t)input[63] << 20) |
			((uint32_t)(input[64] & 0xf0) << 12);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 516 to 531
	value = ((uint32_t)(input[64] & 0x0f) << 28) |
			((uint32_t)input[65] << 20) |
			((uint32_t)(input[66] & 0xf0) << 12);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 532 to 547
	value = ((uint32_t)(input[66] & 0x0f) << 28) |
			((uint32_t)input[67] << 20) |
			((uint32_t)(input[68] & 0xf0) << 12);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 548 to 563
	value = ((uint32_t)(input[68] & 0x0f) << 28) |
			((uint32_t)input[69] << 20) |
			((uint32_t)(input[70] & 0xf0) << 12);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 564 to 579
	value = ((uint32_t)(input[70] & 0x0f) << 28) |
			((uint32_t)input[71] << 20) |
			((uint32_t)(input[72] & 0xf0) << 12);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 580 to 595
	value = ((uint32_t)(input[72] & 0x0f) << 28) |
			((uint32_t)input[73] << 20) |
			((uint32_t)(input[74] & 0xf0) << 12);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 596 to 611
	value = ((uint32_t)(input[74] & 0x0f) << 28) |
			((uint32_t)input[75] << 20) |
			((uint32_t)(input[76] & 0xf0) << 12);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 612 to 627
	value = ((uint32_t)(input[76] & 0x0f) << 28) |
			((uint32_t)input[77] << 20) |
			((uint32_t)(input[78] & 0xf0) << 12);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 628 to 643
	value = ((uint32_t)(input[78] & 0x0f) << 28) |
			((uint32_t)input[79] << 20) |
			((uint32_t)(input[80] & 0xf0) << 12);
	output[39] = (double)(value >> 16);

	// read output[40]: from bit 644 to 659
	value = ((uint32_t)(input[80] & 0x0f) << 28) |
			((uint32_t)input[81] << 20) |
			((uint32_t)(input[82] & 0xf0) << 12);
	output[40] = (double)(value >> 16);

	// read output[41]: from bit 660 to 675
	value = ((uint32_t)(input[82] & 0x0f) << 28) |
			((uint32_t)input[83] << 20) |
			((uint32_t)(input[84] & 0xf0) << 12);
	output[41] = (double)(value >> 16);

	// read output[42]: from bit 676 to 691
	value = ((uint32_t)(input[84] & 0x0f) << 28) |
			((uint32_t)input[85] << 20) |
			((uint32_t)(input[86] & 0xf0) << 12);
	output[42] = (double)(value >> 16);

	// read output[43]: from bit 692 to 707
	value = ((uint32_t)(input[86] & 0x0f) << 28) |
			((uint32_t)input[87] << 20) |
			((uint32_t)(input[88] & 0xf0) << 12);
	output[43] = (double)(value >> 16);

	// read output[44]: from bit 708 to 723
	value = ((uint32_t)(input[88] & 0x0f) << 28) |
			((uint32_t)input[89] << 20) |
			((uint32_t)(input[90] & 0xf0) << 12);
	output[44] = (double)(value >> 16);

	// read output[45]: from bit 724 to 739
	value = ((uint32_t)(input[90] & 0x0f) << 28) |
			((uint32_t)input[91] << 20) |
			((uint32_t)(input[92] & 0xf0) << 12);
	output[45] = (double)(value >> 16);

	// read output[46]: from bit 740 to 755
	value = ((uint32_t)(input[92] & 0x0f) << 28) |
			((uint32_t)input[93] << 20) |
			((uint32_t)(input[94] & 0xf0) << 12);
	output[46] = (double)(value >> 16);

	// read output[47]: from bit 756 to 771
	value = ((uint32_t)(input[94] & 0x0f) << 28) |
			((uint32_t)input[95] << 20) |
			((uint32_t)(input[96] & 0xf0) << 12);
	output[47] = (double)(value >> 16);

	// read output[48]: from bit 772 to 787
	value = ((uint32_t)(input[96] & 0x0f) << 28) |
			((uint32_t)input[97] << 20) |
			((uint32_t)(input[98] & 0xf0) << 12);
	output[48] = (double)(value >> 16);

	// read output[49]: from bit 788 to 803
	value = ((uint32_t)(input[98] & 0x0f) << 28) |
			((uint32_t)input[99] << 20) |
			((uint32_t)(input[100] & 0xf0) << 12);
	output[49] = (double)(value >> 16);

	// read output[50]: from bit 804 to 819
	value = ((uint32_t)(input[100] & 0x0f) << 28) |
			((uint32_t)input[101] << 20) |
			((uint32_t)(input[102] & 0xf0) << 12);
	output[50] = (double)(value >> 16);

	// read output[51]: from bit 820 to 835
	value = ((uint32_t)(input[102] & 0x0f) << 28) |
			((uint32_t)input[103] << 20) |
			((uint32_t)(input[104] & 0xf0) << 12);
	output[51] = (double)(value >> 16);

	// read output[52]: from bit 836 to 851
	value = ((uint32_t)(input[104] & 0x0f) << 28) |
			((uint32_t)input[105] << 20) |
			((uint32_t)(input[106] & 0xf0) << 12);
	output[52] = (double)(value >> 16);

	// read output[53]: from bit 852 to 867
	value = ((uint32_t)(input[106] & 0x0f) << 28) |
			((uint32_t)input[107] << 20) |
			((uint32_t)(input[108] & 0xf0) << 12);
	output[53] = (double)(value >> 16);

	// read output[54]: from bit 868 to 883
	value = ((uint32_t)(input[108] & 0x0f) << 28) |
			((uint32_t)input[109] << 20) |
			((uint32_t)(input[110] & 0xf0) << 12);
	output[54] = (double)(value >> 16);

	// read output[55]: from bit 884 to 899
	value = ((uint32_t)(input[110] & 0x0f) << 28) |
			((uint32_t)input[111] << 20) |
			((uint32_t)(input[112] & 0xf0) << 12);
	output[55] = (double)(value >> 16);
}

static void unpack_56_16bit_unsigned_4off(const uint8_t * input, double * output, void *closure) {
	// Unpack 56 values into output
	// Values are 16-bit unsigned
	// Skip 4 bits, read 896 bits of data.
	// Input must be at least 113 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 4 to 19
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20) |
			((uint32_t)(input[2] & 0xf0) << 12);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 20 to 35
	value = ((uint32_t)(input[2] & 0x0f) << 28) |
			((uint32_t)input[3] << 20) |
			((uint32_t)(input[4] & 0xf0) << 12);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 36 to 51
	value = ((uint32_t)(input[4] & 0x0f) << 28) |
			((uint32_t)input[5] << 20) |
			((uint32_t)(input[6] & 0xf0) << 12);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 52 to 67
	value = ((uint32_t)(input[6] & 0x0f) << 28) |
			((uint32_t)input[7] << 20) |
			((uint32_t)(input[8] & 0xf0) << 12);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 68 to 83
	value = ((uint32_t)(input[8] & 0x0f) << 28) |
			((uint32_t)input[9] << 20) |
			((uint32_t)(input[10] & 0xf0) << 12);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 84 to 99
	value = ((uint32_t)(input[10] & 0x0f) << 28) |
			((uint32_t)input[11] << 20) |
			((uint32_t)(input[12] & 0xf0) << 12);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 100 to 115
	value = ((uint32_t)(input[12] & 0x0f) << 28) |
			((uint32_t)input[13] << 20) |
			((uint32_t)(input[14] & 0xf0) << 12);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 116 to 131
	value = ((uint32_t)(input[14] & 0x0f) << 28) |
			((uint32_t)input[15] << 20) |
			((uint32_t)(input[16] & 0xf0) << 12);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 132 to 147
	value = ((uint32_t)(input[16] & 0x0f) << 28) |
			((uint32_t)input[17] << 20) |
			((uint32_t)(input[18] & 0xf0) << 12);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 148 to 163
	value = ((uint32_t)(input[18] & 0x0f) << 28) |
			((uint32_t)input[19] << 20) |
			((uint32_t)(input[20] & 0xf0) << 12);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 164 to 179
	value = ((uint32_t)(input[20] & 0x0f) << 28) |
			((uint32_t)input[21] << 20) |
			((uint32_t)(input[22] & 0xf0) << 12);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 180 to 195
	value = ((uint32_t)(input[22] & 0x0f) << 28) |
			((uint32_t)input[23] << 20) |
			((uint32_t)(input[24] & 0xf0) << 12);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 196 to 211
	value = ((uint32_t)(input[24] & 0x0f) << 28) |
			((uint32_t)input[25] << 20) |
			((uint32_t)(input[26] & 0xf0) << 12);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 212 to 227
	value = ((uint32_t)(input[26] & 0x0f) << 28) |
			((uint32_t)input[27] << 20) |
			((uint32_t)(input[28] & 0xf0) << 12);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 228 to 243
	value = ((uint32_t)(input[28] & 0x0f) << 28) |
			((uint32_t)input[29] << 20) |
			((uint32_t)(input[30] & 0xf0) << 12);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 244 to 259
	value = ((uint32_t)(input[30] & 0x0f) << 28) |
			((uint32_t)input[31] << 20) |
			((uint32_t)(input[32] & 0xf0) << 12);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 260 to 275
	value = ((uint32_t)(input[32] & 0x0f) << 28) |
			((uint32_t)input[33] << 20) |
			((uint32_t)(input[34] & 0xf0) << 12);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 276 to 291
	value = ((uint32_t)(input[34] & 0x0f) << 28) |
			((uint32_t)input[35] << 20) |
			((uint32_t)(input[36] & 0xf0) << 12);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 292 to 307
	value = ((uint32_t)(input[36] & 0x0f) << 28) |
			((uint32_t)input[37] << 20) |
			((uint32_t)(input[38] & 0xf0) << 12);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 308 to 323
	value = ((uint32_t)(input[38] & 0x0f) << 28) |
			((uint32_t)input[39] << 20) |
			((uint32_t)(input[40] & 0xf0) << 12);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 324 to 339
	value = ((uint32_t)(input[40] & 0x0f) << 28) |
			((uint32_t)input[41] << 20) |
			((uint32_t)(input[42] & 0xf0) << 12);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 340 to 355
	value = ((uint32_t)(input[42] & 0x0f) << 28) |
			((uint32_t)input[43] << 20) |
			((uint32_t)(input[44] & 0xf0) << 12);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 356 to 371
	value = ((uint32_t)(input[44] & 0x0f) << 28) |
			((uint32_t)input[45] << 20) |
			((uint32_t)(input[46] & 0xf0) << 12);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 372 to 387
	value = ((uint32_t)(input[46] & 0x0f) << 28) |
			((uint32_t)input[47] << 20) |
			((uint32_t)(input[48] & 0xf0) << 12);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 388 to 403
	value = ((uint32_t)(input[48] & 0x0f) << 28) |
			((uint32_t)input[49] << 20) |
			((uint32_t)(input[50] & 0xf0) << 12);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 404 to 419
	value = ((uint32_t)(input[50] & 0x0f) << 28) |
			((uint32_t)input[51] << 20) |
			((uint32_t)(input[52] & 0xf0) << 12);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 420 to 435
	value = ((uint32_t)(input[52] & 0x0f) << 28) |
			((uint32_t)input[53] << 20) |
			((uint32_t)(input[54] & 0xf0) << 12);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 436 to 451
	value = ((uint32_t)(input[54] & 0x0f) << 28) |
			((uint32_t)input[55] << 20) |
			((uint32_t)(input[56] & 0xf0) << 12);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 452 to 467
	value = ((uint32_t)(input[56] & 0x0f) << 28) |
			((uint32_t)input[57] << 20) |
			((uint32_t)(input[58] & 0xf0) << 12);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 468 to 483
	value = ((uint32_t)(input[58] & 0x0f) << 28) |
			((uint32_t)input[59] << 20) |
			((uint32_t)(input[60] & 0xf0) << 12);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 484 to 499
	value = ((uint32_t)(input[60] & 0x0f) << 28) |
			((uint32_t)input[61] << 20) |
			((uint32_t)(input[62] & 0xf0) << 12);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 500 to 515
	value = ((uint32_t)(input[62] & 0x0f) << 28) |
			((uint32_t)input[63] << 20) |
			((uint32_t)(input[64] & 0xf0) << 12);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 516 to 531
	value = ((uint32_t)(input[64] & 0x0f) << 28) |
			((uint32_t)input[65] << 20) |
			((uint32_t)(input[66] & 0xf0) << 12);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 532 to 547
	value = ((uint32_t)(input[66] & 0x0f) << 28) |
			((uint32_t)input[67] << 20) |
			((uint32_t)(input[68] & 0xf0) << 12);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 548 to 563
	value = ((uint32_t)(input[68] & 0x0f) << 28) |
			((uint32_t)input[69] << 20) |
			((uint32_t)(input[70] & 0xf0) << 12);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 564 to 579
	value = ((uint32_t)(input[70] & 0x0f) << 28) |
			((uint32_t)input[71] << 20) |
			((uint32_t)(input[72] & 0xf0) << 12);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 580 to 595
	value = ((uint32_t)(input[72] & 0x0f) << 28) |
			((uint32_t)input[73] << 20) |
			((uint32_t)(input[74] & 0xf0) << 12);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 596 to 611
	value = ((uint32_t)(input[74] & 0x0f) << 28) |
			((uint32_t)input[75] << 20) |
			((uint32_t)(input[76] & 0xf0) << 12);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 612 to 627
	value = ((uint32_t)(input[76] & 0x0f) << 28) |
			((uint32_t)input[77] << 20) |
			((uint32_t)(input[78] & 0xf0) << 12);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 628 to 643
	value = ((uint32_t)(input[78] & 0x0f) << 28) |
			((uint32_t)input[79] << 20) |
			((uint32_t)(input[80] & 0xf0) << 12);
	output[39] = (double)(value >> 16);

	// read output[40]: from bit 644 to 659
	value = ((uint32_t)(input[80] & 0x0f) << 28) |
			((uint32_t)input[81] << 20) |
			((uint32_t)(input[82] & 0xf0) << 12);
	output[40] = (double)(value >> 16);

	// read output[41]: from bit 660 to 675
	value = ((uint32_t)(input[82] & 0x0f) << 28) |
			((uint32_t)input[83] << 20) |
			((uint32_t)(input[84] & 0xf0) << 12);
	output[41] = (double)(value >> 16);

	// read output[42]: from bit 676 to 691
	value = ((uint32_t)(input[84] & 0x0f) << 28) |
			((uint32_t)input[85] << 20) |
			((uint32_t)(input[86] & 0xf0) << 12);
	output[42] = (double)(value >> 16);

	// read output[43]: from bit 692 to 707
	value = ((uint32_t)(input[86] & 0x0f) << 28) |
			((uint32_t)input[87] << 20) |
			((uint32_t)(input[88] & 0xf0) << 12);
	output[43] = (double)(value >> 16);

	// read output[44]: from bit 708 to 723
	value = ((uint32_t)(input[88] & 0x0f) << 28) |
			((uint32_t)input[89] << 20) |
			((uint32_t)(input[90] & 0xf0) << 12);
	output[44] = (double)(value >> 16);

	// read output[45]: from bit 724 to 739
	value = ((uint32_t)(input[90] & 0x0f) << 28) |
			((uint32_t)input[91] << 20) |
			((uint32_t)(input[92] & 0xf0) << 12);
	output[45] = (double)(value >> 16);

	// read output[46]: from bit 740 to 755
	value = ((uint32_t)(input[92] & 0x0f) << 28) |
			((uint32_t)input[93] << 20) |
			((uint32_t)(input[94] & 0xf0) << 12);
	output[46] = (double)(value >> 16);

	// read output[47]: from bit 756 to 771
	value = ((uint32_t)(input[94] & 0x0f) << 28) |
			((uint32_t)input[95] << 20) |
			((uint32_t)(input[96] & 0xf0) << 12);
	output[47] = (double)(value >> 16);

	// read output[48]: from bit 772 to 787
	value = ((uint32_t)(input[96] & 0x0f) << 28) |
			((uint32_t)input[97] << 20) |
			((uint32_t)(input[98] & 0xf0) << 12);
	output[48] = (double)(value >> 16);

	// read output[49]: from bit 788 to 803
	value = ((uint32_t)(input[98] & 0x0f) << 28) |
			((uint32_t)input[99] << 20) |
			((uint32_t)(input[100] & 0xf0) << 12);
	output[49] = (double)(value >> 16);

	// read output[50]: from bit 804 to 819
	value = ((uint32_t)(input[100] & 0x0f) << 28) |
			((uint32_t)input[101] << 20) |
			((uint32_t)(input[102] & 0xf0) << 12);
	output[50] = (double)(value >> 16);

	// read output[51]: from bit 820 to 835
	value = ((uint32_t)(input[102] & 0x0f) << 28) |
			((uint32_t)input[103] << 20) |
			((uint32_t)(input[104] & 0xf0) << 12);
	output[51] = (double)(value >> 16);

	// read output[52]: from bit 836 to 851
	value = ((uint32_t)(input[104] & 0x0f) << 28) |
			((uint32_t)input[105] << 20) |
			((uint32_t)(input[106] & 0xf0) << 12);
	output[52] = (double)(value >> 16);

	// read output[53]: from bit 852 to 867
	value = ((uint32_t)(input[106] & 0x0f) << 28) |
			((uint32_t)input[107] << 20) |
			((uint32_t)(input[108] & 0xf0) << 12);
	output[53] = (double)(value >> 16);

	// read output[54]: from bit 868 to 883
	value = ((uint32_t)(input[108] & 0x0f) << 28) |
			((uint32_t)input[109] << 20) |
			((uint32_t)(input[110] & 0xf0) << 12);
	output[54] = (double)(value >> 16);

	// read output[55]: from bit 884 to 899
	value = ((uint32_t)(input[110] & 0x0f) << 28) |
			((uint32_t)input[111] << 20) |
			((uint32_t)(input[112] & 0xf0) << 12);
	output[55] = (double)(value >> 16);
}

static void unpack_56_16bit_signed_5off(const uint8_t * input, double * output, void *closure) {
	// Unpack 56 values into output
	// Values are 16-bit signed
	// Skip 5 bits, read 896 bits of data.
	// Input must be at least 113 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 5 to 20
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)(input[2] & 0xf8) << 13);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 21 to 36
	value = ((uint32_t)(input[2] & 0x07) << 29) |
			((uint32_t)input[3] << 21) |
			((uint32_t)(input[4] & 0xf8) << 13);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 37 to 52
	value = ((uint32_t)(input[4] & 0x07) << 29) |
			((uint32_t)input[5] << 21) |
			((uint32_t)(input[6] & 0xf8) << 13);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 53 to 68
	value = ((uint32_t)(input[6] & 0x07) << 29) |
			((uint32_t)input[7] << 21) |
			((uint32_t)(input[8] & 0xf8) << 13);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 69 to 84
	value = ((uint32_t)(input[8] & 0x07) << 29) |
			((uint32_t)input[9] << 21) |
			((uint32_t)(input[10] & 0xf8) << 13);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 85 to 100
	value = ((uint32_t)(input[10] & 0x07) << 29) |
			((uint32_t)input[11] << 21) |
			((uint32_t)(input[12] & 0xf8) << 13);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 101 to 116
	value = ((uint32_t)(input[12] & 0x07) << 29) |
			((uint32_t)input[13] << 21) |
			((uint32_t)(input[14] & 0xf8) << 13);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 117 to 132
	value = ((uint32_t)(input[14] & 0x07) << 29) |
			((uint32_t)input[15] << 21) |
			((uint32_t)(input[16] & 0xf8) << 13);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 133 to 148
	value = ((uint32_t)(input[16] & 0x07) << 29) |
			((uint32_t)input[17] << 21) |
			((uint32_t)(input[18] & 0xf8) << 13);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 149 to 164
	value = ((uint32_t)(input[18] & 0x07) << 29) |
			((uint32_t)input[19] << 21) |
			((uint32_t)(input[20] & 0xf8) << 13);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 165 to 180
	value = ((uint32_t)(input[20] & 0x07) << 29) |
			((uint32_t)input[21] << 21) |
			((uint32_t)(input[22] & 0xf8) << 13);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 181 to 196
	value = ((uint32_t)(input[22] & 0x07) << 29) |
			((uint32_t)input[23] << 21) |
			((uint32_t)(input[24] & 0xf8) << 13);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 197 to 212
	value = ((uint32_t)(input[24] & 0x07) << 29) |
			((uint32_t)input[25] << 21) |
			((uint32_t)(input[26] & 0xf8) << 13);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 213 to 228
	value = ((uint32_t)(input[26] & 0x07) << 29) |
			((uint32_t)input[27] << 21) |
			((uint32_t)(input[28] & 0xf8) << 13);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 229 to 244
	value = ((uint32_t)(input[28] & 0x07) << 29) |
			((uint32_t)input[29] << 21) |
			((uint32_t)(input[30] & 0xf8) << 13);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 245 to 260
	value = ((uint32_t)(input[30] & 0x07) << 29) |
			((uint32_t)input[31] << 21) |
			((uint32_t)(input[32] & 0xf8) << 13);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 261 to 276
	value = ((uint32_t)(input[32] & 0x07) << 29) |
			((uint32_t)input[33] << 21) |
			((uint32_t)(input[34] & 0xf8) << 13);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 277 to 292
	value = ((uint32_t)(input[34] & 0x07) << 29) |
			((uint32_t)input[35] << 21) |
			((uint32_t)(input[36] & 0xf8) << 13);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 293 to 308
	value = ((uint32_t)(input[36] & 0x07) << 29) |
			((uint32_t)input[37] << 21) |
			((uint32_t)(input[38] & 0xf8) << 13);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 309 to 324
	value = ((uint32_t)(input[38] & 0x07) << 29) |
			((uint32_t)input[39] << 21) |
			((uint32_t)(input[40] & 0xf8) << 13);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 325 to 340
	value = ((uint32_t)(input[40] & 0x07) << 29) |
			((uint32_t)input[41] << 21) |
			((uint32_t)(input[42] & 0xf8) << 13);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 341 to 356
	value = ((uint32_t)(input[42] & 0x07) << 29) |
			((uint32_t)input[43] << 21) |
			((uint32_t)(input[44] & 0xf8) << 13);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 357 to 372
	value = ((uint32_t)(input[44] & 0x07) << 29) |
			((uint32_t)input[45] << 21) |
			((uint32_t)(input[46] & 0xf8) << 13);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 373 to 388
	value = ((uint32_t)(input[46] & 0x07) << 29) |
			((uint32_t)input[47] << 21) |
			((uint32_t)(input[48] & 0xf8) << 13);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 389 to 404
	value = ((uint32_t)(input[48] & 0x07) << 29) |
			((uint32_t)input[49] << 21) |
			((uint32_t)(input[50] & 0xf8) << 13);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 405 to 420
	value = ((uint32_t)(input[50] & 0x07) << 29) |
			((uint32_t)input[51] << 21) |
			((uint32_t)(input[52] & 0xf8) << 13);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 421 to 436
	value = ((uint32_t)(input[52] & 0x07) << 29) |
			((uint32_t)input[53] << 21) |
			((uint32_t)(input[54] & 0xf8) << 13);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 437 to 452
	value = ((uint32_t)(input[54] & 0x07) << 29) |
			((uint32_t)input[55] << 21) |
			((uint32_t)(input[56] & 0xf8) << 13);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 453 to 468
	value = ((uint32_t)(input[56] & 0x07) << 29) |
			((uint32_t)input[57] << 21) |
			((uint32_t)(input[58] & 0xf8) << 13);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 469 to 484
	value = ((uint32_t)(input[58] & 0x07) << 29) |
			((uint32_t)input[59] << 21) |
			((uint32_t)(input[60] & 0xf8) << 13);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 485 to 500
	value = ((uint32_t)(input[60] & 0x07) << 29) |
			((uint32_t)input[61] << 21) |
			((uint32_t)(input[62] & 0xf8) << 13);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 501 to 516
	value = ((uint32_t)(input[62] & 0x07) << 29) |
			((uint32_t)input[63] << 21) |
			((uint32_t)(input[64] & 0xf8) << 13);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 517 to 532
	value = ((uint32_t)(input[64] & 0x07) << 29) |
			((uint32_t)input[65] << 21) |
			((uint32_t)(input[66] & 0xf8) << 13);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 533 to 548
	value = ((uint32_t)(input[66] & 0x07) << 29) |
			((uint32_t)input[67] << 21) |
			((uint32_t)(input[68] & 0xf8) << 13);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 549 to 564
	value = ((uint32_t)(input[68] & 0x07) << 29) |
			((uint32_t)input[69] << 21) |
			((uint32_t)(input[70] & 0xf8) << 13);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 565 to 580
	value = ((uint32_t)(input[70] & 0x07) << 29) |
			((uint32_t)input[71] << 21) |
			((uint32_t)(input[72] & 0xf8) << 13);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 581 to 596
	value = ((uint32_t)(input[72] & 0x07) << 29) |
			((uint32_t)input[73] << 21) |
			((uint32_t)(input[74] & 0xf8) << 13);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 597 to 612
	value = ((uint32_t)(input[74] & 0x07) << 29) |
			((uint32_t)input[75] << 21) |
			((uint32_t)(input[76] & 0xf8) << 13);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 613 to 628
	value = ((uint32_t)(input[76] & 0x07) << 29) |
			((uint32_t)input[77] << 21) |
			((uint32_t)(input[78] & 0xf8) << 13);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 629 to 644
	value = ((uint32_t)(input[78] & 0x07) << 29) |
			((uint32_t)input[79] << 21) |
			((uint32_t)(input[80] & 0xf8) << 13);
	output[39] = (double)(value >> 16);

	// read output[40]: from bit 645 to 660
	value = ((uint32_t)(input[80] & 0x07) << 29) |
			((uint32_t)input[81] << 21) |
			((uint32_t)(input[82] & 0xf8) << 13);
	output[40] = (double)(value >> 16);

	// read output[41]: from bit 661 to 676
	value = ((uint32_t)(input[82] & 0x07) << 29) |
			((uint32_t)input[83] << 21) |
			((uint32_t)(input[84] & 0xf8) << 13);
	output[41] = (double)(value >> 16);

	// read output[42]: from bit 677 to 692
	value = ((uint32_t)(input[84] & 0x07) << 29) |
			((uint32_t)input[85] << 21) |
			((uint32_t)(input[86] & 0xf8) << 13);
	output[42] = (double)(value >> 16);

	// read output[43]: from bit 693 to 708
	value = ((uint32_t)(input[86] & 0x07) << 29) |
			((uint32_t)input[87] << 21) |
			((uint32_t)(input[88] & 0xf8) << 13);
	output[43] = (double)(value >> 16);

	// read output[44]: from bit 709 to 724
	value = ((uint32_t)(input[88] & 0x07) << 29) |
			((uint32_t)input[89] << 21) |
			((uint32_t)(input[90] & 0xf8) << 13);
	output[44] = (double)(value >> 16);

	// read output[45]: from bit 725 to 740
	value = ((uint32_t)(input[90] & 0x07) << 29) |
			((uint32_t)input[91] << 21) |
			((uint32_t)(input[92] & 0xf8) << 13);
	output[45] = (double)(value >> 16);

	// read output[46]: from bit 741 to 756
	value = ((uint32_t)(input[92] & 0x07) << 29) |
			((uint32_t)input[93] << 21) |
			((uint32_t)(input[94] & 0xf8) << 13);
	output[46] = (double)(value >> 16);

	// read output[47]: from bit 757 to 772
	value = ((uint32_t)(input[94] & 0x07) << 29) |
			((uint32_t)input[95] << 21) |
			((uint32_t)(input[96] & 0xf8) << 13);
	output[47] = (double)(value >> 16);

	// read output[48]: from bit 773 to 788
	value = ((uint32_t)(input[96] & 0x07) << 29) |
			((uint32_t)input[97] << 21) |
			((uint32_t)(input[98] & 0xf8) << 13);
	output[48] = (double)(value >> 16);

	// read output[49]: from bit 789 to 804
	value = ((uint32_t)(input[98] & 0x07) << 29) |
			((uint32_t)input[99] << 21) |
			((uint32_t)(input[100] & 0xf8) << 13);
	output[49] = (double)(value >> 16);

	// read output[50]: from bit 805 to 820
	value = ((uint32_t)(input[100] & 0x07) << 29) |
			((uint32_t)input[101] << 21) |
			((uint32_t)(input[102] & 0xf8) << 13);
	output[50] = (double)(value >> 16);

	// read output[51]: from bit 821 to 836
	value = ((uint32_t)(input[102] & 0x07) << 29) |
			((uint32_t)input[103] << 21) |
			((uint32_t)(input[104] & 0xf8) << 13);
	output[51] = (double)(value >> 16);

	// read output[52]: from bit 837 to 852
	value = ((uint32_t)(input[104] & 0x07) << 29) |
			((uint32_t)input[105] << 21) |
			((uint32_t)(input[106] & 0xf8) << 13);
	output[52] = (double)(value >> 16);

	// read output[53]: from bit 853 to 868
	value = ((uint32_t)(input[106] & 0x07) << 29) |
			((uint32_t)input[107] << 21) |
			((uint32_t)(input[108] & 0xf8) << 13);
	output[53] = (double)(value >> 16);

	// read output[54]: from bit 869 to 884
	value = ((uint32_t)(input[108] & 0x07) << 29) |
			((uint32_t)input[109] << 21) |
			((uint32_t)(input[110] & 0xf8) << 13);
	output[54] = (double)(value >> 16);

	// read output[55]: from bit 885 to 900
	value = ((uint32_t)(input[110] & 0x07) << 29) |
			((uint32_t)input[111] << 21) |
			((uint32_t)(input[112] & 0xf8) << 13);
	output[55] = (double)(value >> 16);
}

static void unpack_56_16bit_unsigned_5off(const uint8_t * input, double * output, void *closure) {
	// Unpack 56 values into output
	// Values are 16-bit unsigned
	// Skip 5 bits, read 896 bits of data.
	// Input must be at least 113 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 5 to 20
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)(input[2] & 0xf8) << 13);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 21 to 36
	value = ((uint32_t)(input[2] & 0x07) << 29) |
			((uint32_t)input[3] << 21) |
			((uint32_t)(input[4] & 0xf8) << 13);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 37 to 52
	value = ((uint32_t)(input[4] & 0x07) << 29) |
			((uint32_t)input[5] << 21) |
			((uint32_t)(input[6] & 0xf8) << 13);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 53 to 68
	value = ((uint32_t)(input[6] & 0x07) << 29) |
			((uint32_t)input[7] << 21) |
			((uint32_t)(input[8] & 0xf8) << 13);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 69 to 84
	value = ((uint32_t)(input[8] & 0x07) << 29) |
			((uint32_t)input[9] << 21) |
			((uint32_t)(input[10] & 0xf8) << 13);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 85 to 100
	value = ((uint32_t)(input[10] & 0x07) << 29) |
			((uint32_t)input[11] << 21) |
			((uint32_t)(input[12] & 0xf8) << 13);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 101 to 116
	value = ((uint32_t)(input[12] & 0x07) << 29) |
			((uint32_t)input[13] << 21) |
			((uint32_t)(input[14] & 0xf8) << 13);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 117 to 132
	value = ((uint32_t)(input[14] & 0x07) << 29) |
			((uint32_t)input[15] << 21) |
			((uint32_t)(input[16] & 0xf8) << 13);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 133 to 148
	value = ((uint32_t)(input[16] & 0x07) << 29) |
			((uint32_t)input[17] << 21) |
			((uint32_t)(input[18] & 0xf8) << 13);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 149 to 164
	value = ((uint32_t)(input[18] & 0x07) << 29) |
			((uint32_t)input[19] << 21) |
			((uint32_t)(input[20] & 0xf8) << 13);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 165 to 180
	value = ((uint32_t)(input[20] & 0x07) << 29) |
			((uint32_t)input[21] << 21) |
			((uint32_t)(input[22] & 0xf8) << 13);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 181 to 196
	value = ((uint32_t)(input[22] & 0x07) << 29) |
			((uint32_t)input[23] << 21) |
			((uint32_t)(input[24] & 0xf8) << 13);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 197 to 212
	value = ((uint32_t)(input[24] & 0x07) << 29) |
			((uint32_t)input[25] << 21) |
			((uint32_t)(input[26] & 0xf8) << 13);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 213 to 228
	value = ((uint32_t)(input[26] & 0x07) << 29) |
			((uint32_t)input[27] << 21) |
			((uint32_t)(input[28] & 0xf8) << 13);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 229 to 244
	value = ((uint32_t)(input[28] & 0x07) << 29) |
			((uint32_t)input[29] << 21) |
			((uint32_t)(input[30] & 0xf8) << 13);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 245 to 260
	value = ((uint32_t)(input[30] & 0x07) << 29) |
			((uint32_t)input[31] << 21) |
			((uint32_t)(input[32] & 0xf8) << 13);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 261 to 276
	value = ((uint32_t)(input[32] & 0x07) << 29) |
			((uint32_t)input[33] << 21) |
			((uint32_t)(input[34] & 0xf8) << 13);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 277 to 292
	value = ((uint32_t)(input[34] & 0x07) << 29) |
			((uint32_t)input[35] << 21) |
			((uint32_t)(input[36] & 0xf8) << 13);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 293 to 308
	value = ((uint32_t)(input[36] & 0x07) << 29) |
			((uint32_t)input[37] << 21) |
			((uint32_t)(input[38] & 0xf8) << 13);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 309 to 324
	value = ((uint32_t)(input[38] & 0x07) << 29) |
			((uint32_t)input[39] << 21) |
			((uint32_t)(input[40] & 0xf8) << 13);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 325 to 340
	value = ((uint32_t)(input[40] & 0x07) << 29) |
			((uint32_t)input[41] << 21) |
			((uint32_t)(input[42] & 0xf8) << 13);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 341 to 356
	value = ((uint32_t)(input[42] & 0x07) << 29) |
			((uint32_t)input[43] << 21) |
			((uint32_t)(input[44] & 0xf8) << 13);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 357 to 372
	value = ((uint32_t)(input[44] & 0x07) << 29) |
			((uint32_t)input[45] << 21) |
			((uint32_t)(input[46] & 0xf8) << 13);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 373 to 388
	value = ((uint32_t)(input[46] & 0x07) << 29) |
			((uint32_t)input[47] << 21) |
			((uint32_t)(input[48] & 0xf8) << 13);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 389 to 404
	value = ((uint32_t)(input[48] & 0x07) << 29) |
			((uint32_t)input[49] << 21) |
			((uint32_t)(input[50] & 0xf8) << 13);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 405 to 420
	value = ((uint32_t)(input[50] & 0x07) << 29) |
			((uint32_t)input[51] << 21) |
			((uint32_t)(input[52] & 0xf8) << 13);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 421 to 436
	value = ((uint32_t)(input[52] & 0x07) << 29) |
			((uint32_t)input[53] << 21) |
			((uint32_t)(input[54] & 0xf8) << 13);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 437 to 452
	value = ((uint32_t)(input[54] & 0x07) << 29) |
			((uint32_t)input[55] << 21) |
			((uint32_t)(input[56] & 0xf8) << 13);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 453 to 468
	value = ((uint32_t)(input[56] & 0x07) << 29) |
			((uint32_t)input[57] << 21) |
			((uint32_t)(input[58] & 0xf8) << 13);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 469 to 484
	value = ((uint32_t)(input[58] & 0x07) << 29) |
			((uint32_t)input[59] << 21) |
			((uint32_t)(input[60] & 0xf8) << 13);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 485 to 500
	value = ((uint32_t)(input[60] & 0x07) << 29) |
			((uint32_t)input[61] << 21) |
			((uint32_t)(input[62] & 0xf8) << 13);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 501 to 516
	value = ((uint32_t)(input[62] & 0x07) << 29) |
			((uint32_t)input[63] << 21) |
			((uint32_t)(input[64] & 0xf8) << 13);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 517 to 532
	value = ((uint32_t)(input[64] & 0x07) << 29) |
			((uint32_t)input[65] << 21) |
			((uint32_t)(input[66] & 0xf8) << 13);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 533 to 548
	value = ((uint32_t)(input[66] & 0x07) << 29) |
			((uint32_t)input[67] << 21) |
			((uint32_t)(input[68] & 0xf8) << 13);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 549 to 564
	value = ((uint32_t)(input[68] & 0x07) << 29) |
			((uint32_t)input[69] << 21) |
			((uint32_t)(input[70] & 0xf8) << 13);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 565 to 580
	value = ((uint32_t)(input[70] & 0x07) << 29) |
			((uint32_t)input[71] << 21) |
			((uint32_t)(input[72] & 0xf8) << 13);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 581 to 596
	value = ((uint32_t)(input[72] & 0x07) << 29) |
			((uint32_t)input[73] << 21) |
			((uint32_t)(input[74] & 0xf8) << 13);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 597 to 612
	value = ((uint32_t)(input[74] & 0x07) << 29) |
			((uint32_t)input[75] << 21) |
			((uint32_t)(input[76] & 0xf8) << 13);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 613 to 628
	value = ((uint32_t)(input[76] & 0x07) << 29) |
			((uint32_t)input[77] << 21) |
			((uint32_t)(input[78] & 0xf8) << 13);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 629 to 644
	value = ((uint32_t)(input[78] & 0x07) << 29) |
			((uint32_t)input[79] << 21) |
			((uint32_t)(input[80] & 0xf8) << 13);
	output[39] = (double)(value >> 16);

	// read output[40]: from bit 645 to 660
	value = ((uint32_t)(input[80] & 0x07) << 29) |
			((uint32_t)input[81] << 21) |
			((uint32_t)(input[82] & 0xf8) << 13);
	output[40] = (double)(value >> 16);

	// read output[41]: from bit 661 to 676
	value = ((uint32_t)(input[82] & 0x07) << 29) |
			((uint32_t)input[83] << 21) |
			((uint32_t)(input[84] & 0xf8) << 13);
	output[41] = (double)(value >> 16);

	// read output[42]: from bit 677 to 692
	value = ((uint32_t)(input[84] & 0x07) << 29) |
			((uint32_t)input[85] << 21) |
			((uint32_t)(input[86] & 0xf8) << 13);
	output[42] = (double)(value >> 16);

	// read output[43]: from bit 693 to 708
	value = ((uint32_t)(input[86] & 0x07) << 29) |
			((uint32_t)input[87] << 21) |
			((uint32_t)(input[88] & 0xf8) << 13);
	output[43] = (double)(value >> 16);

	// read output[44]: from bit 709 to 724
	value = ((uint32_t)(input[88] & 0x07) << 29) |
			((uint32_t)input[89] << 21) |
			((uint32_t)(input[90] & 0xf8) << 13);
	output[44] = (double)(value >> 16);

	// read output[45]: from bit 725 to 740
	value = ((uint32_t)(input[90] & 0x07) << 29) |
			((uint32_t)input[91] << 21) |
			((uint32_t)(input[92] & 0xf8) << 13);
	output[45] = (double)(value >> 16);

	// read output[46]: from bit 741 to 756
	value = ((uint32_t)(input[92] & 0x07) << 29) |
			((uint32_t)input[93] << 21) |
			((uint32_t)(input[94] & 0xf8) << 13);
	output[46] = (double)(value >> 16);

	// read output[47]: from bit 757 to 772
	value = ((uint32_t)(input[94] & 0x07) << 29) |
			((uint32_t)input[95] << 21) |
			((uint32_t)(input[96] & 0xf8) << 13);
	output[47] = (double)(value >> 16);

	// read output[48]: from bit 773 to 788
	value = ((uint32_t)(input[96] & 0x07) << 29) |
			((uint32_t)input[97] << 21) |
			((uint32_t)(input[98] & 0xf8) << 13);
	output[48] = (double)(value >> 16);

	// read output[49]: from bit 789 to 804
	value = ((uint32_t)(input[98] & 0x07) << 29) |
			((uint32_t)input[99] << 21) |
			((uint32_t)(input[100] & 0xf8) << 13);
	output[49] = (double)(value >> 16);

	// read output[50]: from bit 805 to 820
	value = ((uint32_t)(input[100] & 0x07) << 29) |
			((uint32_t)input[101] << 21) |
			((uint32_t)(input[102] & 0xf8) << 13);
	output[50] = (double)(value >> 16);

	// read output[51]: from bit 821 to 836
	value = ((uint32_t)(input[102] & 0x07) << 29) |
			((uint32_t)input[103] << 21) |
			((uint32_t)(input[104] & 0xf8) << 13);
	output[51] = (double)(value >> 16);

	// read output[52]: from bit 837 to 852
	value = ((uint32_t)(input[104] & 0x07) << 29) |
			((uint32_t)input[105] << 21) |
			((uint32_t)(input[106] & 0xf8) << 13);
	output[52] = (double)(value >> 16);

	// read output[53]: from bit 853 to 868
	value = ((uint32_t)(input[106] & 0x07) << 29) |
			((uint32_t)input[107] << 21) |
			((uint32_t)(input[108] & 0xf8) << 13);
	output[53] = (double)(value >> 16);

	// read output[54]: from bit 869 to 884
	value = ((uint32_t)(input[108] & 0x07) << 29) |
			((uint32_t)input[109] << 21) |
			((uint32_t)(input[110] & 0xf8) << 13);
	output[54] = (double)(value >> 16);

	// read output[55]: from bit 885 to 900
	value = ((uint32_t)(input[110] & 0x07) << 29) |
			((uint32_t)input[111] << 21) |
			((uint32_t)(input[112] & 0xf8) << 13);
	output[55] = (double)(value >> 16);
}

static void unpack_56_16bit_signed_6off(const uint8_t * input, double * output, void *closure) {
	// Unpack 56 values into output
	// Values are 16-bit signed
	// Skip 6 bits, read 896 bits of data.
	// Input must be at least 113 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 6 to 21
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)(input[2] & 0xfc) << 14);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 22 to 37
	value = ((uint32_t)(input[2] & 0x03) << 30) |
			((uint32_t)input[3] << 22) |
			((uint32_t)(input[4] & 0xfc) << 14);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 38 to 53
	value = ((uint32_t)(input[4] & 0x03) << 30) |
			((uint32_t)input[5] << 22) |
			((uint32_t)(input[6] & 0xfc) << 14);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 54 to 69
	value = ((uint32_t)(input[6] & 0x03) << 30) |
			((uint32_t)input[7] << 22) |
			((uint32_t)(input[8] & 0xfc) << 14);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 70 to 85
	value = ((uint32_t)(input[8] & 0x03) << 30) |
			((uint32_t)input[9] << 22) |
			((uint32_t)(input[10] & 0xfc) << 14);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 86 to 101
	value = ((uint32_t)(input[10] & 0x03) << 30) |
			((uint32_t)input[11] << 22) |
			((uint32_t)(input[12] & 0xfc) << 14);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 102 to 117
	value = ((uint32_t)(input[12] & 0x03) << 30) |
			((uint32_t)input[13] << 22) |
			((uint32_t)(input[14] & 0xfc) << 14);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 118 to 133
	value = ((uint32_t)(input[14] & 0x03) << 30) |
			((uint32_t)input[15] << 22) |
			((uint32_t)(input[16] & 0xfc) << 14);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 134 to 149
	value = ((uint32_t)(input[16] & 0x03) << 30) |
			((uint32_t)input[17] << 22) |
			((uint32_t)(input[18] & 0xfc) << 14);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 150 to 165
	value = ((uint32_t)(input[18] & 0x03) << 30) |
			((uint32_t)input[19] << 22) |
			((uint32_t)(input[20] & 0xfc) << 14);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 166 to 181
	value = ((uint32_t)(input[20] & 0x03) << 30) |
			((uint32_t)input[21] << 22) |
			((uint32_t)(input[22] & 0xfc) << 14);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 182 to 197
	value = ((uint32_t)(input[22] & 0x03) << 30) |
			((uint32_t)input[23] << 22) |
			((uint32_t)(input[24] & 0xfc) << 14);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 198 to 213
	value = ((uint32_t)(input[24] & 0x03) << 30) |
			((uint32_t)input[25] << 22) |
			((uint32_t)(input[26] & 0xfc) << 14);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 214 to 229
	value = ((uint32_t)(input[26] & 0x03) << 30) |
			((uint32_t)input[27] << 22) |
			((uint32_t)(input[28] & 0xfc) << 14);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 230 to 245
	value = ((uint32_t)(input[28] & 0x03) << 30) |
			((uint32_t)input[29] << 22) |
			((uint32_t)(input[30] & 0xfc) << 14);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 246 to 261
	value = ((uint32_t)(input[30] & 0x03) << 30) |
			((uint32_t)input[31] << 22) |
			((uint32_t)(input[32] & 0xfc) << 14);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 262 to 277
	value = ((uint32_t)(input[32] & 0x03) << 30) |
			((uint32_t)input[33] << 22) |
			((uint32_t)(input[34] & 0xfc) << 14);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 278 to 293
	value = ((uint32_t)(input[34] & 0x03) << 30) |
			((uint32_t)input[35] << 22) |
			((uint32_t)(input[36] & 0xfc) << 14);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 294 to 309
	value = ((uint32_t)(input[36] & 0x03) << 30) |
			((uint32_t)input[37] << 22) |
			((uint32_t)(input[38] & 0xfc) << 14);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 310 to 325
	value = ((uint32_t)(input[38] & 0x03) << 30) |
			((uint32_t)input[39] << 22) |
			((uint32_t)(input[40] & 0xfc) << 14);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 326 to 341
	value = ((uint32_t)(input[40] & 0x03) << 30) |
			((uint32_t)input[41] << 22) |
			((uint32_t)(input[42] & 0xfc) << 14);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 342 to 357
	value = ((uint32_t)(input[42] & 0x03) << 30) |
			((uint32_t)input[43] << 22) |
			((uint32_t)(input[44] & 0xfc) << 14);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 358 to 373
	value = ((uint32_t)(input[44] & 0x03) << 30) |
			((uint32_t)input[45] << 22) |
			((uint32_t)(input[46] & 0xfc) << 14);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 374 to 389
	value = ((uint32_t)(input[46] & 0x03) << 30) |
			((uint32_t)input[47] << 22) |
			((uint32_t)(input[48] & 0xfc) << 14);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 390 to 405
	value = ((uint32_t)(input[48] & 0x03) << 30) |
			((uint32_t)input[49] << 22) |
			((uint32_t)(input[50] & 0xfc) << 14);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 406 to 421
	value = ((uint32_t)(input[50] & 0x03) << 30) |
			((uint32_t)input[51] << 22) |
			((uint32_t)(input[52] & 0xfc) << 14);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 422 to 437
	value = ((uint32_t)(input[52] & 0x03) << 30) |
			((uint32_t)input[53] << 22) |
			((uint32_t)(input[54] & 0xfc) << 14);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 438 to 453
	value = ((uint32_t)(input[54] & 0x03) << 30) |
			((uint32_t)input[55] << 22) |
			((uint32_t)(input[56] & 0xfc) << 14);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 454 to 469
	value = ((uint32_t)(input[56] & 0x03) << 30) |
			((uint32_t)input[57] << 22) |
			((uint32_t)(input[58] & 0xfc) << 14);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 470 to 485
	value = ((uint32_t)(input[58] & 0x03) << 30) |
			((uint32_t)input[59] << 22) |
			((uint32_t)(input[60] & 0xfc) << 14);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 486 to 501
	value = ((uint32_t)(input[60] & 0x03) << 30) |
			((uint32_t)input[61] << 22) |
			((uint32_t)(input[62] & 0xfc) << 14);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 502 to 517
	value = ((uint32_t)(input[62] & 0x03) << 30) |
			((uint32_t)input[63] << 22) |
			((uint32_t)(input[64] & 0xfc) << 14);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 518 to 533
	value = ((uint32_t)(input[64] & 0x03) << 30) |
			((uint32_t)input[65] << 22) |
			((uint32_t)(input[66] & 0xfc) << 14);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 534 to 549
	value = ((uint32_t)(input[66] & 0x03) << 30) |
			((uint32_t)input[67] << 22) |
			((uint32_t)(input[68] & 0xfc) << 14);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 550 to 565
	value = ((uint32_t)(input[68] & 0x03) << 30) |
			((uint32_t)input[69] << 22) |
			((uint32_t)(input[70] & 0xfc) << 14);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 566 to 581
	value = ((uint32_t)(input[70] & 0x03) << 30) |
			((uint32_t)input[71] << 22) |
			((uint32_t)(input[72] & 0xfc) << 14);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 582 to 597
	value = ((uint32_t)(input[72] & 0x03) << 30) |
			((uint32_t)input[73] << 22) |
			((uint32_t)(input[74] & 0xfc) << 14);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 598 to 613
	value = ((uint32_t)(input[74] & 0x03) << 30) |
			((uint32_t)input[75] << 22) |
			((uint32_t)(input[76] & 0xfc) << 14);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 614 to 629
	value = ((uint32_t)(input[76] & 0x03) << 30) |
			((uint32_t)input[77] << 22) |
			((uint32_t)(input[78] & 0xfc) << 14);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 630 to 645
	value = ((uint32_t)(input[78] & 0x03) << 30) |
			((uint32_t)input[79] << 22) |
			((uint32_t)(input[80] & 0xfc) << 14);
	output[39] = (double)(value >> 16);

	// read output[40]: from bit 646 to 661
	value = ((uint32_t)(input[80] & 0x03) << 30) |
			((uint32_t)input[81] << 22) |
			((uint32_t)(input[82] & 0xfc) << 14);
	output[40] = (double)(value >> 16);

	// read output[41]: from bit 662 to 677
	value = ((uint32_t)(input[82] & 0x03) << 30) |
			((uint32_t)input[83] << 22) |
			((uint32_t)(input[84] & 0xfc) << 14);
	output[41] = (double)(value >> 16);

	// read output[42]: from bit 678 to 693
	value = ((uint32_t)(input[84] & 0x03) << 30) |
			((uint32_t)input[85] << 22) |
			((uint32_t)(input[86] & 0xfc) << 14);
	output[42] = (double)(value >> 16);

	// read output[43]: from bit 694 to 709
	value = ((uint32_t)(input[86] & 0x03) << 30) |
			((uint32_t)input[87] << 22) |
			((uint32_t)(input[88] & 0xfc) << 14);
	output[43] = (double)(value >> 16);

	// read output[44]: from bit 710 to 725
	value = ((uint32_t)(input[88] & 0x03) << 30) |
			((uint32_t)input[89] << 22) |
			((uint32_t)(input[90] & 0xfc) << 14);
	output[44] = (double)(value >> 16);

	// read output[45]: from bit 726 to 741
	value = ((uint32_t)(input[90] & 0x03) << 30) |
			((uint32_t)input[91] << 22) |
			((uint32_t)(input[92] & 0xfc) << 14);
	output[45] = (double)(value >> 16);

	// read output[46]: from bit 742 to 757
	value = ((uint32_t)(input[92] & 0x03) << 30) |
			((uint32_t)input[93] << 22) |
			((uint32_t)(input[94] & 0xfc) << 14);
	output[46] = (double)(value >> 16);

	// read output[47]: from bit 758 to 773
	value = ((uint32_t)(input[94] & 0x03) << 30) |
			((uint32_t)input[95] << 22) |
			((uint32_t)(input[96] & 0xfc) << 14);
	output[47] = (double)(value >> 16);

	// read output[48]: from bit 774 to 789
	value = ((uint32_t)(input[96] & 0x03) << 30) |
			((uint32_t)input[97] << 22) |
			((uint32_t)(input[98] & 0xfc) << 14);
	output[48] = (double)(value >> 16);

	// read output[49]: from bit 790 to 805
	value = ((uint32_t)(input[98] & 0x03) << 30) |
			((uint32_t)input[99] << 22) |
			((uint32_t)(input[100] & 0xfc) << 14);
	output[49] = (double)(value >> 16);

	// read output[50]: from bit 806 to 821
	value = ((uint32_t)(input[100] & 0x03) << 30) |
			((uint32_t)input[101] << 22) |
			((uint32_t)(input[102] & 0xfc) << 14);
	output[50] = (double)(value >> 16);

	// read output[51]: from bit 822 to 837
	value = ((uint32_t)(input[102] & 0x03) << 30) |
			((uint32_t)input[103] << 22) |
			((uint32_t)(input[104] & 0xfc) << 14);
	output[51] = (double)(value >> 16);

	// read output[52]: from bit 838 to 853
	value = ((uint32_t)(input[104] & 0x03) << 30) |
			((uint32_t)input[105] << 22) |
			((uint32_t)(input[106] & 0xfc) << 14);
	output[52] = (double)(value >> 16);

	// read output[53]: from bit 854 to 869
	value = ((uint32_t)(input[106] & 0x03) << 30) |
			((uint32_t)input[107] << 22) |
			((uint32_t)(input[108] & 0xfc) << 14);
	output[53] = (double)(value >> 16);

	// read output[54]: from bit 870 to 885
	value = ((uint32_t)(input[108] & 0x03) << 30) |
			((uint32_t)input[109] << 22) |
			((uint32_t)(input[110] & 0xfc) << 14);
	output[54] = (double)(value >> 16);

	// read output[55]: from bit 886 to 901
	value = ((uint32_t)(input[110] & 0x03) << 30) |
			((uint32_t)input[111] << 22) |
			((uint32_t)(input[112] & 0xfc) << 14);
	output[55] = (double)(value >> 16);
}

static void unpack_56_16bit_unsigned_6off(const uint8_t * input, double * output, void *closure) {
	// Unpack 56 values into output
	// Values are 16-bit unsigned
	// Skip 6 bits, read 896 bits of data.
	// Input must be at least 113 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 6 to 21
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)(input[2] & 0xfc) << 14);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 22 to 37
	value = ((uint32_t)(input[2] & 0x03) << 30) |
			((uint32_t)input[3] << 22) |
			((uint32_t)(input[4] & 0xfc) << 14);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 38 to 53
	value = ((uint32_t)(input[4] & 0x03) << 30) |
			((uint32_t)input[5] << 22) |
			((uint32_t)(input[6] & 0xfc) << 14);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 54 to 69
	value = ((uint32_t)(input[6] & 0x03) << 30) |
			((uint32_t)input[7] << 22) |
			((uint32_t)(input[8] & 0xfc) << 14);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 70 to 85
	value = ((uint32_t)(input[8] & 0x03) << 30) |
			((uint32_t)input[9] << 22) |
			((uint32_t)(input[10] & 0xfc) << 14);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 86 to 101
	value = ((uint32_t)(input[10] & 0x03) << 30) |
			((uint32_t)input[11] << 22) |
			((uint32_t)(input[12] & 0xfc) << 14);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 102 to 117
	value = ((uint32_t)(input[12] & 0x03) << 30) |
			((uint32_t)input[13] << 22) |
			((uint32_t)(input[14] & 0xfc) << 14);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 118 to 133
	value = ((uint32_t)(input[14] & 0x03) << 30) |
			((uint32_t)input[15] << 22) |
			((uint32_t)(input[16] & 0xfc) << 14);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 134 to 149
	value = ((uint32_t)(input[16] & 0x03) << 30) |
			((uint32_t)input[17] << 22) |
			((uint32_t)(input[18] & 0xfc) << 14);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 150 to 165
	value = ((uint32_t)(input[18] & 0x03) << 30) |
			((uint32_t)input[19] << 22) |
			((uint32_t)(input[20] & 0xfc) << 14);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 166 to 181
	value = ((uint32_t)(input[20] & 0x03) << 30) |
			((uint32_t)input[21] << 22) |
			((uint32_t)(input[22] & 0xfc) << 14);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 182 to 197
	value = ((uint32_t)(input[22] & 0x03) << 30) |
			((uint32_t)input[23] << 22) |
			((uint32_t)(input[24] & 0xfc) << 14);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 198 to 213
	value = ((uint32_t)(input[24] & 0x03) << 30) |
			((uint32_t)input[25] << 22) |
			((uint32_t)(input[26] & 0xfc) << 14);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 214 to 229
	value = ((uint32_t)(input[26] & 0x03) << 30) |
			((uint32_t)input[27] << 22) |
			((uint32_t)(input[28] & 0xfc) << 14);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 230 to 245
	value = ((uint32_t)(input[28] & 0x03) << 30) |
			((uint32_t)input[29] << 22) |
			((uint32_t)(input[30] & 0xfc) << 14);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 246 to 261
	value = ((uint32_t)(input[30] & 0x03) << 30) |
			((uint32_t)input[31] << 22) |
			((uint32_t)(input[32] & 0xfc) << 14);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 262 to 277
	value = ((uint32_t)(input[32] & 0x03) << 30) |
			((uint32_t)input[33] << 22) |
			((uint32_t)(input[34] & 0xfc) << 14);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 278 to 293
	value = ((uint32_t)(input[34] & 0x03) << 30) |
			((uint32_t)input[35] << 22) |
			((uint32_t)(input[36] & 0xfc) << 14);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 294 to 309
	value = ((uint32_t)(input[36] & 0x03) << 30) |
			((uint32_t)input[37] << 22) |
			((uint32_t)(input[38] & 0xfc) << 14);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 310 to 325
	value = ((uint32_t)(input[38] & 0x03) << 30) |
			((uint32_t)input[39] << 22) |
			((uint32_t)(input[40] & 0xfc) << 14);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 326 to 341
	value = ((uint32_t)(input[40] & 0x03) << 30) |
			((uint32_t)input[41] << 22) |
			((uint32_t)(input[42] & 0xfc) << 14);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 342 to 357
	value = ((uint32_t)(input[42] & 0x03) << 30) |
			((uint32_t)input[43] << 22) |
			((uint32_t)(input[44] & 0xfc) << 14);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 358 to 373
	value = ((uint32_t)(input[44] & 0x03) << 30) |
			((uint32_t)input[45] << 22) |
			((uint32_t)(input[46] & 0xfc) << 14);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 374 to 389
	value = ((uint32_t)(input[46] & 0x03) << 30) |
			((uint32_t)input[47] << 22) |
			((uint32_t)(input[48] & 0xfc) << 14);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 390 to 405
	value = ((uint32_t)(input[48] & 0x03) << 30) |
			((uint32_t)input[49] << 22) |
			((uint32_t)(input[50] & 0xfc) << 14);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 406 to 421
	value = ((uint32_t)(input[50] & 0x03) << 30) |
			((uint32_t)input[51] << 22) |
			((uint32_t)(input[52] & 0xfc) << 14);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 422 to 437
	value = ((uint32_t)(input[52] & 0x03) << 30) |
			((uint32_t)input[53] << 22) |
			((uint32_t)(input[54] & 0xfc) << 14);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 438 to 453
	value = ((uint32_t)(input[54] & 0x03) << 30) |
			((uint32_t)input[55] << 22) |
			((uint32_t)(input[56] & 0xfc) << 14);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 454 to 469
	value = ((uint32_t)(input[56] & 0x03) << 30) |
			((uint32_t)input[57] << 22) |
			((uint32_t)(input[58] & 0xfc) << 14);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 470 to 485
	value = ((uint32_t)(input[58] & 0x03) << 30) |
			((uint32_t)input[59] << 22) |
			((uint32_t)(input[60] & 0xfc) << 14);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 486 to 501
	value = ((uint32_t)(input[60] & 0x03) << 30) |
			((uint32_t)input[61] << 22) |
			((uint32_t)(input[62] & 0xfc) << 14);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 502 to 517
	value = ((uint32_t)(input[62] & 0x03) << 30) |
			((uint32_t)input[63] << 22) |
			((uint32_t)(input[64] & 0xfc) << 14);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 518 to 533
	value = ((uint32_t)(input[64] & 0x03) << 30) |
			((uint32_t)input[65] << 22) |
			((uint32_t)(input[66] & 0xfc) << 14);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 534 to 549
	value = ((uint32_t)(input[66] & 0x03) << 30) |
			((uint32_t)input[67] << 22) |
			((uint32_t)(input[68] & 0xfc) << 14);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 550 to 565
	value = ((uint32_t)(input[68] & 0x03) << 30) |
			((uint32_t)input[69] << 22) |
			((uint32_t)(input[70] & 0xfc) << 14);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 566 to 581
	value = ((uint32_t)(input[70] & 0x03) << 30) |
			((uint32_t)input[71] << 22) |
			((uint32_t)(input[72] & 0xfc) << 14);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 582 to 597
	value = ((uint32_t)(input[72] & 0x03) << 30) |
			((uint32_t)input[73] << 22) |
			((uint32_t)(input[74] & 0xfc) << 14);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 598 to 613
	value = ((uint32_t)(input[74] & 0x03) << 30) |
			((uint32_t)input[75] << 22) |
			((uint32_t)(input[76] & 0xfc) << 14);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 614 to 629
	value = ((uint32_t)(input[76] & 0x03) << 30) |
			((uint32_t)input[77] << 22) |
			((uint32_t)(input[78] & 0xfc) << 14);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 630 to 645
	value = ((uint32_t)(input[78] & 0x03) << 30) |
			((uint32_t)input[79] << 22) |
			((uint32_t)(input[80] & 0xfc) << 14);
	output[39] = (double)(value >> 16);

	// read output[40]: from bit 646 to 661
	value = ((uint32_t)(input[80] & 0x03) << 30) |
			((uint32_t)input[81] << 22) |
			((uint32_t)(input[82] & 0xfc) << 14);
	output[40] = (double)(value >> 16);

	// read output[41]: from bit 662 to 677
	value = ((uint32_t)(input[82] & 0x03) << 30) |
			((uint32_t)input[83] << 22) |
			((uint32_t)(input[84] & 0xfc) << 14);
	output[41] = (double)(value >> 16);

	// read output[42]: from bit 678 to 693
	value = ((uint32_t)(input[84] & 0x03) << 30) |
			((uint32_t)input[85] << 22) |
			((uint32_t)(input[86] & 0xfc) << 14);
	output[42] = (double)(value >> 16);

	// read output[43]: from bit 694 to 709
	value = ((uint32_t)(input[86] & 0x03) << 30) |
			((uint32_t)input[87] << 22) |
			((uint32_t)(input[88] & 0xfc) << 14);
	output[43] = (double)(value >> 16);

	// read output[44]: from bit 710 to 725
	value = ((uint32_t)(input[88] & 0x03) << 30) |
			((uint32_t)input[89] << 22) |
			((uint32_t)(input[90] & 0xfc) << 14);
	output[44] = (double)(value >> 16);

	// read output[45]: from bit 726 to 741
	value = ((uint32_t)(input[90] & 0x03) << 30) |
			((uint32_t)input[91] << 22) |
			((uint32_t)(input[92] & 0xfc) << 14);
	output[45] = (double)(value >> 16);

	// read output[46]: from bit 742 to 757
	value = ((uint32_t)(input[92] & 0x03) << 30) |
			((uint32_t)input[93] << 22) |
			((uint32_t)(input[94] & 0xfc) << 14);
	output[46] = (double)(value >> 16);

	// read output[47]: from bit 758 to 773
	value = ((uint32_t)(input[94] & 0x03) << 30) |
			((uint32_t)input[95] << 22) |
			((uint32_t)(input[96] & 0xfc) << 14);
	output[47] = (double)(value >> 16);

	// read output[48]: from bit 774 to 789
	value = ((uint32_t)(input[96] & 0x03) << 30) |
			((uint32_t)input[97] << 22) |
			((uint32_t)(input[98] & 0xfc) << 14);
	output[48] = (double)(value >> 16);

	// read output[49]: from bit 790 to 805
	value = ((uint32_t)(input[98] & 0x03) << 30) |
			((uint32_t)input[99] << 22) |
			((uint32_t)(input[100] & 0xfc) << 14);
	output[49] = (double)(value >> 16);

	// read output[50]: from bit 806 to 821
	value = ((uint32_t)(input[100] & 0x03) << 30) |
			((uint32_t)input[101] << 22) |
			((uint32_t)(input[102] & 0xfc) << 14);
	output[50] = (double)(value >> 16);

	// read output[51]: from bit 822 to 837
	value = ((uint32_t)(input[102] & 0x03) << 30) |
			((uint32_t)input[103] << 22) |
			((uint32_t)(input[104] & 0xfc) << 14);
	output[51] = (double)(value >> 16);

	// read output[52]: from bit 838 to 853
	value = ((uint32_t)(input[104] & 0x03) << 30) |
			((uint32_t)input[105] << 22) |
			((uint32_t)(input[106] & 0xfc) << 14);
	output[52] = (double)(value >> 16);

	// read output[53]: from bit 854 to 869
	value = ((uint32_t)(input[106] & 0x03) << 30) |
			((uint32_t)input[107] << 22) |
			((uint32_t)(input[108] & 0xfc) << 14);
	output[53] = (double)(value >> 16);

	// read output[54]: from bit 870 to 885
	value = ((uint32_t)(input[108] & 0x03) << 30) |
			((uint32_t)input[109] << 22) |
			((uint32_t)(input[110] & 0xfc) << 14);
	output[54] = (double)(value >> 16);

	// read output[55]: from bit 886 to 901
	value = ((uint32_t)(input[110] & 0x03) << 30) |
			((uint32_t)input[111] << 22) |
			((uint32_t)(input[112] & 0xfc) << 14);
	output[55] = (double)(value >> 16);
}

static void unpack_56_16bit_signed_7off(const uint8_t * input, double * output, void *closure) {
	// Unpack 56 values into output
	// Values are 16-bit signed
	// Skip 7 bits, read 896 bits of data.
	// Input must be at least 113 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 7 to 22
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)(input[2] & 0xfe) << 15);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 23 to 38
	value = ((uint32_t)(input[2] & 0x01) << 31) |
			((uint32_t)input[3] << 23) |
			((uint32_t)(input[4] & 0xfe) << 15);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 39 to 54
	value = ((uint32_t)(input[4] & 0x01) << 31) |
			((uint32_t)input[5] << 23) |
			((uint32_t)(input[6] & 0xfe) << 15);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 55 to 70
	value = ((uint32_t)(input[6] & 0x01) << 31) |
			((uint32_t)input[7] << 23) |
			((uint32_t)(input[8] & 0xfe) << 15);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 71 to 86
	value = ((uint32_t)(input[8] & 0x01) << 31) |
			((uint32_t)input[9] << 23) |
			((uint32_t)(input[10] & 0xfe) << 15);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 87 to 102
	value = ((uint32_t)(input[10] & 0x01) << 31) |
			((uint32_t)input[11] << 23) |
			((uint32_t)(input[12] & 0xfe) << 15);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 103 to 118
	value = ((uint32_t)(input[12] & 0x01) << 31) |
			((uint32_t)input[13] << 23) |
			((uint32_t)(input[14] & 0xfe) << 15);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 119 to 134
	value = ((uint32_t)(input[14] & 0x01) << 31) |
			((uint32_t)input[15] << 23) |
			((uint32_t)(input[16] & 0xfe) << 15);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 135 to 150
	value = ((uint32_t)(input[16] & 0x01) << 31) |
			((uint32_t)input[17] << 23) |
			((uint32_t)(input[18] & 0xfe) << 15);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 151 to 166
	value = ((uint32_t)(input[18] & 0x01) << 31) |
			((uint32_t)input[19] << 23) |
			((uint32_t)(input[20] & 0xfe) << 15);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 167 to 182
	value = ((uint32_t)(input[20] & 0x01) << 31) |
			((uint32_t)input[21] << 23) |
			((uint32_t)(input[22] & 0xfe) << 15);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 183 to 198
	value = ((uint32_t)(input[22] & 0x01) << 31) |
			((uint32_t)input[23] << 23) |
			((uint32_t)(input[24] & 0xfe) << 15);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 199 to 214
	value = ((uint32_t)(input[24] & 0x01) << 31) |
			((uint32_t)input[25] << 23) |
			((uint32_t)(input[26] & 0xfe) << 15);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 215 to 230
	value = ((uint32_t)(input[26] & 0x01) << 31) |
			((uint32_t)input[27] << 23) |
			((uint32_t)(input[28] & 0xfe) << 15);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 231 to 246
	value = ((uint32_t)(input[28] & 0x01) << 31) |
			((uint32_t)input[29] << 23) |
			((uint32_t)(input[30] & 0xfe) << 15);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 247 to 262
	value = ((uint32_t)(input[30] & 0x01) << 31) |
			((uint32_t)input[31] << 23) |
			((uint32_t)(input[32] & 0xfe) << 15);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 263 to 278
	value = ((uint32_t)(input[32] & 0x01) << 31) |
			((uint32_t)input[33] << 23) |
			((uint32_t)(input[34] & 0xfe) << 15);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 279 to 294
	value = ((uint32_t)(input[34] & 0x01) << 31) |
			((uint32_t)input[35] << 23) |
			((uint32_t)(input[36] & 0xfe) << 15);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 295 to 310
	value = ((uint32_t)(input[36] & 0x01) << 31) |
			((uint32_t)input[37] << 23) |
			((uint32_t)(input[38] & 0xfe) << 15);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 311 to 326
	value = ((uint32_t)(input[38] & 0x01) << 31) |
			((uint32_t)input[39] << 23) |
			((uint32_t)(input[40] & 0xfe) << 15);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 327 to 342
	value = ((uint32_t)(input[40] & 0x01) << 31) |
			((uint32_t)input[41] << 23) |
			((uint32_t)(input[42] & 0xfe) << 15);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 343 to 358
	value = ((uint32_t)(input[42] & 0x01) << 31) |
			((uint32_t)input[43] << 23) |
			((uint32_t)(input[44] & 0xfe) << 15);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 359 to 374
	value = ((uint32_t)(input[44] & 0x01) << 31) |
			((uint32_t)input[45] << 23) |
			((uint32_t)(input[46] & 0xfe) << 15);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 375 to 390
	value = ((uint32_t)(input[46] & 0x01) << 31) |
			((uint32_t)input[47] << 23) |
			((uint32_t)(input[48] & 0xfe) << 15);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 391 to 406
	value = ((uint32_t)(input[48] & 0x01) << 31) |
			((uint32_t)input[49] << 23) |
			((uint32_t)(input[50] & 0xfe) << 15);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 407 to 422
	value = ((uint32_t)(input[50] & 0x01) << 31) |
			((uint32_t)input[51] << 23) |
			((uint32_t)(input[52] & 0xfe) << 15);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 423 to 438
	value = ((uint32_t)(input[52] & 0x01) << 31) |
			((uint32_t)input[53] << 23) |
			((uint32_t)(input[54] & 0xfe) << 15);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 439 to 454
	value = ((uint32_t)(input[54] & 0x01) << 31) |
			((uint32_t)input[55] << 23) |
			((uint32_t)(input[56] & 0xfe) << 15);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 455 to 470
	value = ((uint32_t)(input[56] & 0x01) << 31) |
			((uint32_t)input[57] << 23) |
			((uint32_t)(input[58] & 0xfe) << 15);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 471 to 486
	value = ((uint32_t)(input[58] & 0x01) << 31) |
			((uint32_t)input[59] << 23) |
			((uint32_t)(input[60] & 0xfe) << 15);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 487 to 502
	value = ((uint32_t)(input[60] & 0x01) << 31) |
			((uint32_t)input[61] << 23) |
			((uint32_t)(input[62] & 0xfe) << 15);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 503 to 518
	value = ((uint32_t)(input[62] & 0x01) << 31) |
			((uint32_t)input[63] << 23) |
			((uint32_t)(input[64] & 0xfe) << 15);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 519 to 534
	value = ((uint32_t)(input[64] & 0x01) << 31) |
			((uint32_t)input[65] << 23) |
			((uint32_t)(input[66] & 0xfe) << 15);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 535 to 550
	value = ((uint32_t)(input[66] & 0x01) << 31) |
			((uint32_t)input[67] << 23) |
			((uint32_t)(input[68] & 0xfe) << 15);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 551 to 566
	value = ((uint32_t)(input[68] & 0x01) << 31) |
			((uint32_t)input[69] << 23) |
			((uint32_t)(input[70] & 0xfe) << 15);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 567 to 582
	value = ((uint32_t)(input[70] & 0x01) << 31) |
			((uint32_t)input[71] << 23) |
			((uint32_t)(input[72] & 0xfe) << 15);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 583 to 598
	value = ((uint32_t)(input[72] & 0x01) << 31) |
			((uint32_t)input[73] << 23) |
			((uint32_t)(input[74] & 0xfe) << 15);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 599 to 614
	value = ((uint32_t)(input[74] & 0x01) << 31) |
			((uint32_t)input[75] << 23) |
			((uint32_t)(input[76] & 0xfe) << 15);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 615 to 630
	value = ((uint32_t)(input[76] & 0x01) << 31) |
			((uint32_t)input[77] << 23) |
			((uint32_t)(input[78] & 0xfe) << 15);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 631 to 646
	value = ((uint32_t)(input[78] & 0x01) << 31) |
			((uint32_t)input[79] << 23) |
			((uint32_t)(input[80] & 0xfe) << 15);
	output[39] = (double)(value >> 16);

	// read output[40]: from bit 647 to 662
	value = ((uint32_t)(input[80] & 0x01) << 31) |
			((uint32_t)input[81] << 23) |
			((uint32_t)(input[82] & 0xfe) << 15);
	output[40] = (double)(value >> 16);

	// read output[41]: from bit 663 to 678
	value = ((uint32_t)(input[82] & 0x01) << 31) |
			((uint32_t)input[83] << 23) |
			((uint32_t)(input[84] & 0xfe) << 15);
	output[41] = (double)(value >> 16);

	// read output[42]: from bit 679 to 694
	value = ((uint32_t)(input[84] & 0x01) << 31) |
			((uint32_t)input[85] << 23) |
			((uint32_t)(input[86] & 0xfe) << 15);
	output[42] = (double)(value >> 16);

	// read output[43]: from bit 695 to 710
	value = ((uint32_t)(input[86] & 0x01) << 31) |
			((uint32_t)input[87] << 23) |
			((uint32_t)(input[88] & 0xfe) << 15);
	output[43] = (double)(value >> 16);

	// read output[44]: from bit 711 to 726
	value = ((uint32_t)(input[88] & 0x01) << 31) |
			((uint32_t)input[89] << 23) |
			((uint32_t)(input[90] & 0xfe) << 15);
	output[44] = (double)(value >> 16);

	// read output[45]: from bit 727 to 742
	value = ((uint32_t)(input[90] & 0x01) << 31) |
			((uint32_t)input[91] << 23) |
			((uint32_t)(input[92] & 0xfe) << 15);
	output[45] = (double)(value >> 16);

	// read output[46]: from bit 743 to 758
	value = ((uint32_t)(input[92] & 0x01) << 31) |
			((uint32_t)input[93] << 23) |
			((uint32_t)(input[94] & 0xfe) << 15);
	output[46] = (double)(value >> 16);

	// read output[47]: from bit 759 to 774
	value = ((uint32_t)(input[94] & 0x01) << 31) |
			((uint32_t)input[95] << 23) |
			((uint32_t)(input[96] & 0xfe) << 15);
	output[47] = (double)(value >> 16);

	// read output[48]: from bit 775 to 790
	value = ((uint32_t)(input[96] & 0x01) << 31) |
			((uint32_t)input[97] << 23) |
			((uint32_t)(input[98] & 0xfe) << 15);
	output[48] = (double)(value >> 16);

	// read output[49]: from bit 791 to 806
	value = ((uint32_t)(input[98] & 0x01) << 31) |
			((uint32_t)input[99] << 23) |
			((uint32_t)(input[100] & 0xfe) << 15);
	output[49] = (double)(value >> 16);

	// read output[50]: from bit 807 to 822
	value = ((uint32_t)(input[100] & 0x01) << 31) |
			((uint32_t)input[101] << 23) |
			((uint32_t)(input[102] & 0xfe) << 15);
	output[50] = (double)(value >> 16);

	// read output[51]: from bit 823 to 838
	value = ((uint32_t)(input[102] & 0x01) << 31) |
			((uint32_t)input[103] << 23) |
			((uint32_t)(input[104] & 0xfe) << 15);
	output[51] = (double)(value >> 16);

	// read output[52]: from bit 839 to 854
	value = ((uint32_t)(input[104] & 0x01) << 31) |
			((uint32_t)input[105] << 23) |
			((uint32_t)(input[106] & 0xfe) << 15);
	output[52] = (double)(value >> 16);

	// read output[53]: from bit 855 to 870
	value = ((uint32_t)(input[106] & 0x01) << 31) |
			((uint32_t)input[107] << 23) |
			((uint32_t)(input[108] & 0xfe) << 15);
	output[53] = (double)(value >> 16);

	// read output[54]: from bit 871 to 886
	value = ((uint32_t)(input[108] & 0x01) << 31) |
			((uint32_t)input[109] << 23) |
			((uint32_t)(input[110] & 0xfe) << 15);
	output[54] = (double)(value >> 16);

	// read output[55]: from bit 887 to 902
	value = ((uint32_t)(input[110] & 0x01) << 31) |
			((uint32_t)input[111] << 23) |
			((uint32_t)(input[112] & 0xfe) << 15);
	output[55] = (double)(value >> 16);
}

static void unpack_56_16bit_unsigned_7off(const uint8_t * input, double * output, void *closure) {
	// Unpack 56 values into output
	// Values are 16-bit unsigned
	// Skip 7 bits, read 896 bits of data.
	// Input must be at least 113 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 7 to 22
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)(input[2] & 0xfe) << 15);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 23 to 38
	value = ((uint32_t)(input[2] & 0x01) << 31) |
			((uint32_t)input[3] << 23) |
			((uint32_t)(input[4] & 0xfe) << 15);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 39 to 54
	value = ((uint32_t)(input[4] & 0x01) << 31) |
			((uint32_t)input[5] << 23) |
			((uint32_t)(input[6] & 0xfe) << 15);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 55 to 70
	value = ((uint32_t)(input[6] & 0x01) << 31) |
			((uint32_t)input[7] << 23) |
			((uint32_t)(input[8] & 0xfe) << 15);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 71 to 86
	value = ((uint32_t)(input[8] & 0x01) << 31) |
			((uint32_t)input[9] << 23) |
			((uint32_t)(input[10] & 0xfe) << 15);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 87 to 102
	value = ((uint32_t)(input[10] & 0x01) << 31) |
			((uint32_t)input[11] << 23) |
			((uint32_t)(input[12] & 0xfe) << 15);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 103 to 118
	value = ((uint32_t)(input[12] & 0x01) << 31) |
			((uint32_t)input[13] << 23) |
			((uint32_t)(input[14] & 0xfe) << 15);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 119 to 134
	value = ((uint32_t)(input[14] & 0x01) << 31) |
			((uint32_t)input[15] << 23) |
			((uint32_t)(input[16] & 0xfe) << 15);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 135 to 150
	value = ((uint32_t)(input[16] & 0x01) << 31) |
			((uint32_t)input[17] << 23) |
			((uint32_t)(input[18] & 0xfe) << 15);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 151 to 166
	value = ((uint32_t)(input[18] & 0x01) << 31) |
			((uint32_t)input[19] << 23) |
			((uint32_t)(input[20] & 0xfe) << 15);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 167 to 182
	value = ((uint32_t)(input[20] & 0x01) << 31) |
			((uint32_t)input[21] << 23) |
			((uint32_t)(input[22] & 0xfe) << 15);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 183 to 198
	value = ((uint32_t)(input[22] & 0x01) << 31) |
			((uint32_t)input[23] << 23) |
			((uint32_t)(input[24] & 0xfe) << 15);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 199 to 214
	value = ((uint32_t)(input[24] & 0x01) << 31) |
			((uint32_t)input[25] << 23) |
			((uint32_t)(input[26] & 0xfe) << 15);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 215 to 230
	value = ((uint32_t)(input[26] & 0x01) << 31) |
			((uint32_t)input[27] << 23) |
			((uint32_t)(input[28] & 0xfe) << 15);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 231 to 246
	value = ((uint32_t)(input[28] & 0x01) << 31) |
			((uint32_t)input[29] << 23) |
			((uint32_t)(input[30] & 0xfe) << 15);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 247 to 262
	value = ((uint32_t)(input[30] & 0x01) << 31) |
			((uint32_t)input[31] << 23) |
			((uint32_t)(input[32] & 0xfe) << 15);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 263 to 278
	value = ((uint32_t)(input[32] & 0x01) << 31) |
			((uint32_t)input[33] << 23) |
			((uint32_t)(input[34] & 0xfe) << 15);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 279 to 294
	value = ((uint32_t)(input[34] & 0x01) << 31) |
			((uint32_t)input[35] << 23) |
			((uint32_t)(input[36] & 0xfe) << 15);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 295 to 310
	value = ((uint32_t)(input[36] & 0x01) << 31) |
			((uint32_t)input[37] << 23) |
			((uint32_t)(input[38] & 0xfe) << 15);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 311 to 326
	value = ((uint32_t)(input[38] & 0x01) << 31) |
			((uint32_t)input[39] << 23) |
			((uint32_t)(input[40] & 0xfe) << 15);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 327 to 342
	value = ((uint32_t)(input[40] & 0x01) << 31) |
			((uint32_t)input[41] << 23) |
			((uint32_t)(input[42] & 0xfe) << 15);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 343 to 358
	value = ((uint32_t)(input[42] & 0x01) << 31) |
			((uint32_t)input[43] << 23) |
			((uint32_t)(input[44] & 0xfe) << 15);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 359 to 374
	value = ((uint32_t)(input[44] & 0x01) << 31) |
			((uint32_t)input[45] << 23) |
			((uint32_t)(input[46] & 0xfe) << 15);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 375 to 390
	value = ((uint32_t)(input[46] & 0x01) << 31) |
			((uint32_t)input[47] << 23) |
			((uint32_t)(input[48] & 0xfe) << 15);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 391 to 406
	value = ((uint32_t)(input[48] & 0x01) << 31) |
			((uint32_t)input[49] << 23) |
			((uint32_t)(input[50] & 0xfe) << 15);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 407 to 422
	value = ((uint32_t)(input[50] & 0x01) << 31) |
			((uint32_t)input[51] << 23) |
			((uint32_t)(input[52] & 0xfe) << 15);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 423 to 438
	value = ((uint32_t)(input[52] & 0x01) << 31) |
			((uint32_t)input[53] << 23) |
			((uint32_t)(input[54] & 0xfe) << 15);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 439 to 454
	value = ((uint32_t)(input[54] & 0x01) << 31) |
			((uint32_t)input[55] << 23) |
			((uint32_t)(input[56] & 0xfe) << 15);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 455 to 470
	value = ((uint32_t)(input[56] & 0x01) << 31) |
			((uint32_t)input[57] << 23) |
			((uint32_t)(input[58] & 0xfe) << 15);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 471 to 486
	value = ((uint32_t)(input[58] & 0x01) << 31) |
			((uint32_t)input[59] << 23) |
			((uint32_t)(input[60] & 0xfe) << 15);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 487 to 502
	value = ((uint32_t)(input[60] & 0x01) << 31) |
			((uint32_t)input[61] << 23) |
			((uint32_t)(input[62] & 0xfe) << 15);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 503 to 518
	value = ((uint32_t)(input[62] & 0x01) << 31) |
			((uint32_t)input[63] << 23) |
			((uint32_t)(input[64] & 0xfe) << 15);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 519 to 534
	value = ((uint32_t)(input[64] & 0x01) << 31) |
			((uint32_t)input[65] << 23) |
			((uint32_t)(input[66] & 0xfe) << 15);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 535 to 550
	value = ((uint32_t)(input[66] & 0x01) << 31) |
			((uint32_t)input[67] << 23) |
			((uint32_t)(input[68] & 0xfe) << 15);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 551 to 566
	value = ((uint32_t)(input[68] & 0x01) << 31) |
			((uint32_t)input[69] << 23) |
			((uint32_t)(input[70] & 0xfe) << 15);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 567 to 582
	value = ((uint32_t)(input[70] & 0x01) << 31) |
			((uint32_t)input[71] << 23) |
			((uint32_t)(input[72] & 0xfe) << 15);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 583 to 598
	value = ((uint32_t)(input[72] & 0x01) << 31) |
			((uint32_t)input[73] << 23) |
			((uint32_t)(input[74] & 0xfe) << 15);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 599 to 614
	value = ((uint32_t)(input[74] & 0x01) << 31) |
			((uint32_t)input[75] << 23) |
			((uint32_t)(input[76] & 0xfe) << 15);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 615 to 630
	value = ((uint32_t)(input[76] & 0x01) << 31) |
			((uint32_t)input[77] << 23) |
			((uint32_t)(input[78] & 0xfe) << 15);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 631 to 646
	value = ((uint32_t)(input[78] & 0x01) << 31) |
			((uint32_t)input[79] << 23) |
			((uint32_t)(input[80] & 0xfe) << 15);
	output[39] = (double)(value >> 16);

	// read output[40]: from bit 647 to 662
	value = ((uint32_t)(input[80] & 0x01) << 31) |
			((uint32_t)input[81] << 23) |
			((uint32_t)(input[82] & 0xfe) << 15);
	output[40] = (double)(value >> 16);

	// read output[41]: from bit 663 to 678
	value = ((uint32_t)(input[82] & 0x01) << 31) |
			((uint32_t)input[83] << 23) |
			((uint32_t)(input[84] & 0xfe) << 15);
	output[41] = (double)(value >> 16);

	// read output[42]: from bit 679 to 694
	value = ((uint32_t)(input[84] & 0x01) << 31) |
			((uint32_t)input[85] << 23) |
			((uint32_t)(input[86] & 0xfe) << 15);
	output[42] = (double)(value >> 16);

	// read output[43]: from bit 695 to 710
	value = ((uint32_t)(input[86] & 0x01) << 31) |
			((uint32_t)input[87] << 23) |
			((uint32_t)(input[88] & 0xfe) << 15);
	output[43] = (double)(value >> 16);

	// read output[44]: from bit 711 to 726
	value = ((uint32_t)(input[88] & 0x01) << 31) |
			((uint32_t)input[89] << 23) |
			((uint32_t)(input[90] & 0xfe) << 15);
	output[44] = (double)(value >> 16);

	// read output[45]: from bit 727 to 742
	value = ((uint32_t)(input[90] & 0x01) << 31) |
			((uint32_t)input[91] << 23) |
			((uint32_t)(input[92] & 0xfe) << 15);
	output[45] = (double)(value >> 16);

	// read output[46]: from bit 743 to 758
	value = ((uint32_t)(input[92] & 0x01) << 31) |
			((uint32_t)input[93] << 23) |
			((uint32_t)(input[94] & 0xfe) << 15);
	output[46] = (double)(value >> 16);

	// read output[47]: from bit 759 to 774
	value = ((uint32_t)(input[94] & 0x01) << 31) |
			((uint32_t)input[95] << 23) |
			((uint32_t)(input[96] & 0xfe) << 15);
	output[47] = (double)(value >> 16);

	// read output[48]: from bit 775 to 790
	value = ((uint32_t)(input[96] & 0x01) << 31) |
			((uint32_t)input[97] << 23) |
			((uint32_t)(input[98] & 0xfe) << 15);
	output[48] = (double)(value >> 16);

	// read output[49]: from bit 791 to 806
	value = ((uint32_t)(input[98] & 0x01) << 31) |
			((uint32_t)input[99] << 23) |
			((uint32_t)(input[100] & 0xfe) << 15);
	output[49] = (double)(value >> 16);

	// read output[50]: from bit 807 to 822
	value = ((uint32_t)(input[100] & 0x01) << 31) |
			((uint32_t)input[101] << 23) |
			((uint32_t)(input[102] & 0xfe) << 15);
	output[50] = (double)(value >> 16);

	// read output[51]: from bit 823 to 838
	value = ((uint32_t)(input[102] & 0x01) << 31) |
			((uint32_t)input[103] << 23) |
			((uint32_t)(input[104] & 0xfe) << 15);
	output[51] = (double)(value >> 16);

	// read output[52]: from bit 839 to 854
	value = ((uint32_t)(input[104] & 0x01) << 31) |
			((uint32_t)input[105] << 23) |
			((uint32_t)(input[106] & 0xfe) << 15);
	output[52] = (double)(value >> 16);

	// read output[53]: from bit 855 to 870
	value = ((uint32_t)(input[106] & 0x01) << 31) |
			((uint32_t)input[107] << 23) |
			((uint32_t)(input[108] & 0xfe) << 15);
	output[53] = (double)(value >> 16);

	// read output[54]: from bit 871 to 886
	value = ((uint32_t)(input[108] & 0x01) << 31) |
			((uint32_t)input[109] << 23) |
			((uint32_t)(input[110] & 0xfe) << 15);
	output[54] = (double)(value >> 16);

	// read output[55]: from bit 887 to 902
	value = ((uint32_t)(input[110] & 0x01) << 31) |
			((uint32_t)input[111] << 23) |
			((uint32_t)(input[112] & 0xfe) << 15);
	output[55] = (double)(value >> 16);
}

static void unpack_57_16bit_signed_0off(const uint8_t * input, double * output, void *closure) {
	// Unpack 57 values into output
	// Values are 16-bit signed
	// Skip 0 bits, read 912 bits of data.
	// Input must be at least 114 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 0 to 15
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)input[1] << 16);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 16 to 31
	value = ((uint32_t)input[2] << 24) |
			((uint32_t)input[3] << 16);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 32 to 47
	value = ((uint32_t)input[4] << 24) |
			((uint32_t)input[5] << 16);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 48 to 63
	value = ((uint32_t)input[6] << 24) |
			((uint32_t)input[7] << 16);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 64 to 79
	value = ((uint32_t)input[8] << 24) |
			((uint32_t)input[9] << 16);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 80 to 95
	value = ((uint32_t)input[10] << 24) |
			((uint32_t)input[11] << 16);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 96 to 111
	value = ((uint32_t)input[12] << 24) |
			((uint32_t)input[13] << 16);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 112 to 127
	value = ((uint32_t)input[14] << 24) |
			((uint32_t)input[15] << 16);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 128 to 143
	value = ((uint32_t)input[16] << 24) |
			((uint32_t)input[17] << 16);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 144 to 159
	value = ((uint32_t)input[18] << 24) |
			((uint32_t)input[19] << 16);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 160 to 175
	value = ((uint32_t)input[20] << 24) |
			((uint32_t)input[21] << 16);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 176 to 191
	value = ((uint32_t)input[22] << 24) |
			((uint32_t)input[23] << 16);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 192 to 207
	value = ((uint32_t)input[24] << 24) |
			((uint32_t)input[25] << 16);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 208 to 223
	value = ((uint32_t)input[26] << 24) |
			((uint32_t)input[27] << 16);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 224 to 239
	value = ((uint32_t)input[28] << 24) |
			((uint32_t)input[29] << 16);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 240 to 255
	value = ((uint32_t)input[30] << 24) |
			((uint32_t)input[31] << 16);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 256 to 271
	value = ((uint32_t)input[32] << 24) |
			((uint32_t)input[33] << 16);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 272 to 287
	value = ((uint32_t)input[34] << 24) |
			((uint32_t)input[35] << 16);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 288 to 303
	value = ((uint32_t)input[36] << 24) |
			((uint32_t)input[37] << 16);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 304 to 319
	value = ((uint32_t)input[38] << 24) |
			((uint32_t)input[39] << 16);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 320 to 335
	value = ((uint32_t)input[40] << 24) |
			((uint32_t)input[41] << 16);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 336 to 351
	value = ((uint32_t)input[42] << 24) |
			((uint32_t)input[43] << 16);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 352 to 367
	value = ((uint32_t)input[44] << 24) |
			((uint32_t)input[45] << 16);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 368 to 383
	value = ((uint32_t)input[46] << 24) |
			((uint32_t)input[47] << 16);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 384 to 399
	value = ((uint32_t)input[48] << 24) |
			((uint32_t)input[49] << 16);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 400 to 415
	value = ((uint32_t)input[50] << 24) |
			((uint32_t)input[51] << 16);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 416 to 431
	value = ((uint32_t)input[52] << 24) |
			((uint32_t)input[53] << 16);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 432 to 447
	value = ((uint32_t)input[54] << 24) |
			((uint32_t)input[55] << 16);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 448 to 463
	value = ((uint32_t)input[56] << 24) |
			((uint32_t)input[57] << 16);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 464 to 479
	value = ((uint32_t)input[58] << 24) |
			((uint32_t)input[59] << 16);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 480 to 495
	value = ((uint32_t)input[60] << 24) |
			((uint32_t)input[61] << 16);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 496 to 511
	value = ((uint32_t)input[62] << 24) |
			((uint32_t)input[63] << 16);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 512 to 527
	value = ((uint32_t)input[64] << 24) |
			((uint32_t)input[65] << 16);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 528 to 543
	value = ((uint32_t)input[66] << 24) |
			((uint32_t)input[67] << 16);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 544 to 559
	value = ((uint32_t)input[68] << 24) |
			((uint32_t)input[69] << 16);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 560 to 575
	value = ((uint32_t)input[70] << 24) |
			((uint32_t)input[71] << 16);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 576 to 591
	value = ((uint32_t)input[72] << 24) |
			((uint32_t)input[73] << 16);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 592 to 607
	value = ((uint32_t)input[74] << 24) |
			((uint32_t)input[75] << 16);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 608 to 623
	value = ((uint32_t)input[76] << 24) |
			((uint32_t)input[77] << 16);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 624 to 639
	value = ((uint32_t)input[78] << 24) |
			((uint32_t)input[79] << 16);
	output[39] = (double)(value >> 16);

	// read output[40]: from bit 640 to 655
	value = ((uint32_t)input[80] << 24) |
			((uint32_t)input[81] << 16);
	output[40] = (double)(value >> 16);

	// read output[41]: from bit 656 to 671
	value = ((uint32_t)input[82] << 24) |
			((uint32_t)input[83] << 16);
	output[41] = (double)(value >> 16);

	// read output[42]: from bit 672 to 687
	value = ((uint32_t)input[84] << 24) |
			((uint32_t)input[85] << 16);
	output[42] = (double)(value >> 16);

	// read output[43]: from bit 688 to 703
	value = ((uint32_t)input[86] << 24) |
			((uint32_t)input[87] << 16);
	output[43] = (double)(value >> 16);

	// read output[44]: from bit 704 to 719
	value = ((uint32_t)input[88] << 24) |
			((uint32_t)input[89] << 16);
	output[44] = (double)(value >> 16);

	// read output[45]: from bit 720 to 735
	value = ((uint32_t)input[90] << 24) |
			((uint32_t)input[91] << 16);
	output[45] = (double)(value >> 16);

	// read output[46]: from bit 736 to 751
	value = ((uint32_t)input[92] << 24) |
			((uint32_t)input[93] << 16);
	output[46] = (double)(value >> 16);

	// read output[47]: from bit 752 to 767
	value = ((uint32_t)input[94] << 24) |
			((uint32_t)input[95] << 16);
	output[47] = (double)(value >> 16);

	// read output[48]: from bit 768 to 783
	value = ((uint32_t)input[96] << 24) |
			((uint32_t)input[97] << 16);
	output[48] = (double)(value >> 16);

	// read output[49]: from bit 784 to 799
	value = ((uint32_t)input[98] << 24) |
			((uint32_t)input[99] << 16);
	output[49] = (double)(value >> 16);

	// read output[50]: from bit 800 to 815
	value = ((uint32_t)input[100] << 24) |
			((uint32_t)input[101] << 16);
	output[50] = (double)(value >> 16);

	// read output[51]: from bit 816 to 831
	value = ((uint32_t)input[102] << 24) |
			((uint32_t)input[103] << 16);
	output[51] = (double)(value >> 16);

	// read output[52]: from bit 832 to 847
	value = ((uint32_t)input[104] << 24) |
			((uint32_t)input[105] << 16);
	output[52] = (double)(value >> 16);

	// read output[53]: from bit 848 to 863
	value = ((uint32_t)input[106] << 24) |
			((uint32_t)input[107] << 16);
	output[53] = (double)(value >> 16);

	// read output[54]: from bit 864 to 879
	value = ((uint32_t)input[108] << 24) |
			((uint32_t)input[109] << 16);
	output[54] = (double)(value >> 16);

	// read output[55]: from bit 880 to 895
	value = ((uint32_t)input[110] << 24) |
			((uint32_t)input[111] << 16);
	output[55] = (double)(value >> 16);

	// read output[56]: from bit 896 to 911
	value = ((uint32_t)input[112] << 24) |
			((uint32_t)input[113] << 16);
	output[56] = (double)(value >> 16);
}

static void unpack_57_16bit_unsigned_0off(const uint8_t * input, double * output, void *closure) {
	// Unpack 57 values into output
	// Values are 16-bit unsigned
	// Skip 0 bits, read 912 bits of data.
	// Input must be at least 114 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 0 to 15
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)input[1] << 16);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 16 to 31
	value = ((uint32_t)input[2] << 24) |
			((uint32_t)input[3] << 16);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 32 to 47
	value = ((uint32_t)input[4] << 24) |
			((uint32_t)input[5] << 16);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 48 to 63
	value = ((uint32_t)input[6] << 24) |
			((uint32_t)input[7] << 16);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 64 to 79
	value = ((uint32_t)input[8] << 24) |
			((uint32_t)input[9] << 16);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 80 to 95
	value = ((uint32_t)input[10] << 24) |
			((uint32_t)input[11] << 16);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 96 to 111
	value = ((uint32_t)input[12] << 24) |
			((uint32_t)input[13] << 16);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 112 to 127
	value = ((uint32_t)input[14] << 24) |
			((uint32_t)input[15] << 16);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 128 to 143
	value = ((uint32_t)input[16] << 24) |
			((uint32_t)input[17] << 16);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 144 to 159
	value = ((uint32_t)input[18] << 24) |
			((uint32_t)input[19] << 16);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 160 to 175
	value = ((uint32_t)input[20] << 24) |
			((uint32_t)input[21] << 16);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 176 to 191
	value = ((uint32_t)input[22] << 24) |
			((uint32_t)input[23] << 16);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 192 to 207
	value = ((uint32_t)input[24] << 24) |
			((uint32_t)input[25] << 16);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 208 to 223
	value = ((uint32_t)input[26] << 24) |
			((uint32_t)input[27] << 16);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 224 to 239
	value = ((uint32_t)input[28] << 24) |
			((uint32_t)input[29] << 16);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 240 to 255
	value = ((uint32_t)input[30] << 24) |
			((uint32_t)input[31] << 16);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 256 to 271
	value = ((uint32_t)input[32] << 24) |
			((uint32_t)input[33] << 16);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 272 to 287
	value = ((uint32_t)input[34] << 24) |
			((uint32_t)input[35] << 16);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 288 to 303
	value = ((uint32_t)input[36] << 24) |
			((uint32_t)input[37] << 16);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 304 to 319
	value = ((uint32_t)input[38] << 24) |
			((uint32_t)input[39] << 16);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 320 to 335
	value = ((uint32_t)input[40] << 24) |
			((uint32_t)input[41] << 16);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 336 to 351
	value = ((uint32_t)input[42] << 24) |
			((uint32_t)input[43] << 16);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 352 to 367
	value = ((uint32_t)input[44] << 24) |
			((uint32_t)input[45] << 16);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 368 to 383
	value = ((uint32_t)input[46] << 24) |
			((uint32_t)input[47] << 16);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 384 to 399
	value = ((uint32_t)input[48] << 24) |
			((uint32_t)input[49] << 16);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 400 to 415
	value = ((uint32_t)input[50] << 24) |
			((uint32_t)input[51] << 16);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 416 to 431
	value = ((uint32_t)input[52] << 24) |
			((uint32_t)input[53] << 16);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 432 to 447
	value = ((uint32_t)input[54] << 24) |
			((uint32_t)input[55] << 16);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 448 to 463
	value = ((uint32_t)input[56] << 24) |
			((uint32_t)input[57] << 16);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 464 to 479
	value = ((uint32_t)input[58] << 24) |
			((uint32_t)input[59] << 16);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 480 to 495
	value = ((uint32_t)input[60] << 24) |
			((uint32_t)input[61] << 16);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 496 to 511
	value = ((uint32_t)input[62] << 24) |
			((uint32_t)input[63] << 16);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 512 to 527
	value = ((uint32_t)input[64] << 24) |
			((uint32_t)input[65] << 16);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 528 to 543
	value = ((uint32_t)input[66] << 24) |
			((uint32_t)input[67] << 16);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 544 to 559
	value = ((uint32_t)input[68] << 24) |
			((uint32_t)input[69] << 16);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 560 to 575
	value = ((uint32_t)input[70] << 24) |
			((uint32_t)input[71] << 16);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 576 to 591
	value = ((uint32_t)input[72] << 24) |
			((uint32_t)input[73] << 16);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 592 to 607
	value = ((uint32_t)input[74] << 24) |
			((uint32_t)input[75] << 16);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 608 to 623
	value = ((uint32_t)input[76] << 24) |
			((uint32_t)input[77] << 16);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 624 to 639
	value = ((uint32_t)input[78] << 24) |
			((uint32_t)input[79] << 16);
	output[39] = (double)(value >> 16);

	// read output[40]: from bit 640 to 655
	value = ((uint32_t)input[80] << 24) |
			((uint32_t)input[81] << 16);
	output[40] = (double)(value >> 16);

	// read output[41]: from bit 656 to 671
	value = ((uint32_t)input[82] << 24) |
			((uint32_t)input[83] << 16);
	output[41] = (double)(value >> 16);

	// read output[42]: from bit 672 to 687
	value = ((uint32_t)input[84] << 24) |
			((uint32_t)input[85] << 16);
	output[42] = (double)(value >> 16);

	// read output[43]: from bit 688 to 703
	value = ((uint32_t)input[86] << 24) |
			((uint32_t)input[87] << 16);
	output[43] = (double)(value >> 16);

	// read output[44]: from bit 704 to 719
	value = ((uint32_t)input[88] << 24) |
			((uint32_t)input[89] << 16);
	output[44] = (double)(value >> 16);

	// read output[45]: from bit 720 to 735
	value = ((uint32_t)input[90] << 24) |
			((uint32_t)input[91] << 16);
	output[45] = (double)(value >> 16);

	// read output[46]: from bit 736 to 751
	value = ((uint32_t)input[92] << 24) |
			((uint32_t)input[93] << 16);
	output[46] = (double)(value >> 16);

	// read output[47]: from bit 752 to 767
	value = ((uint32_t)input[94] << 24) |
			((uint32_t)input[95] << 16);
	output[47] = (double)(value >> 16);

	// read output[48]: from bit 768 to 783
	value = ((uint32_t)input[96] << 24) |
			((uint32_t)input[97] << 16);
	output[48] = (double)(value >> 16);

	// read output[49]: from bit 784 to 799
	value = ((uint32_t)input[98] << 24) |
			((uint32_t)input[99] << 16);
	output[49] = (double)(value >> 16);

	// read output[50]: from bit 800 to 815
	value = ((uint32_t)input[100] << 24) |
			((uint32_t)input[101] << 16);
	output[50] = (double)(value >> 16);

	// read output[51]: from bit 816 to 831
	value = ((uint32_t)input[102] << 24) |
			((uint32_t)input[103] << 16);
	output[51] = (double)(value >> 16);

	// read output[52]: from bit 832 to 847
	value = ((uint32_t)input[104] << 24) |
			((uint32_t)input[105] << 16);
	output[52] = (double)(value >> 16);

	// read output[53]: from bit 848 to 863
	value = ((uint32_t)input[106] << 24) |
			((uint32_t)input[107] << 16);
	output[53] = (double)(value >> 16);

	// read output[54]: from bit 864 to 879
	value = ((uint32_t)input[108] << 24) |
			((uint32_t)input[109] << 16);
	output[54] = (double)(value >> 16);

	// read output[55]: from bit 880 to 895
	value = ((uint32_t)input[110] << 24) |
			((uint32_t)input[111] << 16);
	output[55] = (double)(value >> 16);

	// read output[56]: from bit 896 to 911
	value = ((uint32_t)input[112] << 24) |
			((uint32_t)input[113] << 16);
	output[56] = (double)(value >> 16);
}

static void unpack_57_16bit_signed_1off(const uint8_t * input, double * output, void *closure) {
	// Unpack 57 values into output
	// Values are 16-bit signed
	// Skip 1 bits, read 912 bits of data.
	// Input must be at least 115 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 1 to 16
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)input[1] << 17) |
			((uint32_t)(input[2] & 0x80) << 9);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 17 to 32
	value = ((uint32_t)(input[2] & 0x7f) << 25) |
			((uint32_t)input[3] << 17) |
			((uint32_t)(input[4] & 0x80) << 9);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 33 to 48
	value = ((uint32_t)(input[4] & 0x7f) << 25) |
			((uint32_t)input[5] << 17) |
			((uint32_t)(input[6] & 0x80) << 9);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 49 to 64
	value = ((uint32_t)(input[6] & 0x7f) << 25) |
			((uint32_t)input[7] << 17) |
			((uint32_t)(input[8] & 0x80) << 9);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 65 to 80
	value = ((uint32_t)(input[8] & 0x7f) << 25) |
			((uint32_t)input[9] << 17) |
			((uint32_t)(input[10] & 0x80) << 9);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 81 to 96
	value = ((uint32_t)(input[10] & 0x7f) << 25) |
			((uint32_t)input[11] << 17) |
			((uint32_t)(input[12] & 0x80) << 9);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 97 to 112
	value = ((uint32_t)(input[12] & 0x7f) << 25) |
			((uint32_t)input[13] << 17) |
			((uint32_t)(input[14] & 0x80) << 9);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 113 to 128
	value = ((uint32_t)(input[14] & 0x7f) << 25) |
			((uint32_t)input[15] << 17) |
			((uint32_t)(input[16] & 0x80) << 9);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 129 to 144
	value = ((uint32_t)(input[16] & 0x7f) << 25) |
			((uint32_t)input[17] << 17) |
			((uint32_t)(input[18] & 0x80) << 9);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 145 to 160
	value = ((uint32_t)(input[18] & 0x7f) << 25) |
			((uint32_t)input[19] << 17) |
			((uint32_t)(input[20] & 0x80) << 9);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 161 to 176
	value = ((uint32_t)(input[20] & 0x7f) << 25) |
			((uint32_t)input[21] << 17) |
			((uint32_t)(input[22] & 0x80) << 9);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 177 to 192
	value = ((uint32_t)(input[22] & 0x7f) << 25) |
			((uint32_t)input[23] << 17) |
			((uint32_t)(input[24] & 0x80) << 9);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 193 to 208
	value = ((uint32_t)(input[24] & 0x7f) << 25) |
			((uint32_t)input[25] << 17) |
			((uint32_t)(input[26] & 0x80) << 9);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 209 to 224
	value = ((uint32_t)(input[26] & 0x7f) << 25) |
			((uint32_t)input[27] << 17) |
			((uint32_t)(input[28] & 0x80) << 9);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 225 to 240
	value = ((uint32_t)(input[28] & 0x7f) << 25) |
			((uint32_t)input[29] << 17) |
			((uint32_t)(input[30] & 0x80) << 9);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 241 to 256
	value = ((uint32_t)(input[30] & 0x7f) << 25) |
			((uint32_t)input[31] << 17) |
			((uint32_t)(input[32] & 0x80) << 9);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 257 to 272
	value = ((uint32_t)(input[32] & 0x7f) << 25) |
			((uint32_t)input[33] << 17) |
			((uint32_t)(input[34] & 0x80) << 9);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 273 to 288
	value = ((uint32_t)(input[34] & 0x7f) << 25) |
			((uint32_t)input[35] << 17) |
			((uint32_t)(input[36] & 0x80) << 9);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 289 to 304
	value = ((uint32_t)(input[36] & 0x7f) << 25) |
			((uint32_t)input[37] << 17) |
			((uint32_t)(input[38] & 0x80) << 9);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 305 to 320
	value = ((uint32_t)(input[38] & 0x7f) << 25) |
			((uint32_t)input[39] << 17) |
			((uint32_t)(input[40] & 0x80) << 9);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 321 to 336
	value = ((uint32_t)(input[40] & 0x7f) << 25) |
			((uint32_t)input[41] << 17) |
			((uint32_t)(input[42] & 0x80) << 9);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 337 to 352
	value = ((uint32_t)(input[42] & 0x7f) << 25) |
			((uint32_t)input[43] << 17) |
			((uint32_t)(input[44] & 0x80) << 9);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 353 to 368
	value = ((uint32_t)(input[44] & 0x7f) << 25) |
			((uint32_t)input[45] << 17) |
			((uint32_t)(input[46] & 0x80) << 9);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 369 to 384
	value = ((uint32_t)(input[46] & 0x7f) << 25) |
			((uint32_t)input[47] << 17) |
			((uint32_t)(input[48] & 0x80) << 9);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 385 to 400
	value = ((uint32_t)(input[48] & 0x7f) << 25) |
			((uint32_t)input[49] << 17) |
			((uint32_t)(input[50] & 0x80) << 9);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 401 to 416
	value = ((uint32_t)(input[50] & 0x7f) << 25) |
			((uint32_t)input[51] << 17) |
			((uint32_t)(input[52] & 0x80) << 9);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 417 to 432
	value = ((uint32_t)(input[52] & 0x7f) << 25) |
			((uint32_t)input[53] << 17) |
			((uint32_t)(input[54] & 0x80) << 9);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 433 to 448
	value = ((uint32_t)(input[54] & 0x7f) << 25) |
			((uint32_t)input[55] << 17) |
			((uint32_t)(input[56] & 0x80) << 9);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 449 to 464
	value = ((uint32_t)(input[56] & 0x7f) << 25) |
			((uint32_t)input[57] << 17) |
			((uint32_t)(input[58] & 0x80) << 9);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 465 to 480
	value = ((uint32_t)(input[58] & 0x7f) << 25) |
			((uint32_t)input[59] << 17) |
			((uint32_t)(input[60] & 0x80) << 9);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 481 to 496
	value = ((uint32_t)(input[60] & 0x7f) << 25) |
			((uint32_t)input[61] << 17) |
			((uint32_t)(input[62] & 0x80) << 9);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 497 to 512
	value = ((uint32_t)(input[62] & 0x7f) << 25) |
			((uint32_t)input[63] << 17) |
			((uint32_t)(input[64] & 0x80) << 9);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 513 to 528
	value = ((uint32_t)(input[64] & 0x7f) << 25) |
			((uint32_t)input[65] << 17) |
			((uint32_t)(input[66] & 0x80) << 9);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 529 to 544
	value = ((uint32_t)(input[66] & 0x7f) << 25) |
			((uint32_t)input[67] << 17) |
			((uint32_t)(input[68] & 0x80) << 9);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 545 to 560
	value = ((uint32_t)(input[68] & 0x7f) << 25) |
			((uint32_t)input[69] << 17) |
			((uint32_t)(input[70] & 0x80) << 9);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 561 to 576
	value = ((uint32_t)(input[70] & 0x7f) << 25) |
			((uint32_t)input[71] << 17) |
			((uint32_t)(input[72] & 0x80) << 9);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 577 to 592
	value = ((uint32_t)(input[72] & 0x7f) << 25) |
			((uint32_t)input[73] << 17) |
			((uint32_t)(input[74] & 0x80) << 9);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 593 to 608
	value = ((uint32_t)(input[74] & 0x7f) << 25) |
			((uint32_t)input[75] << 17) |
			((uint32_t)(input[76] & 0x80) << 9);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 609 to 624
	value = ((uint32_t)(input[76] & 0x7f) << 25) |
			((uint32_t)input[77] << 17) |
			((uint32_t)(input[78] & 0x80) << 9);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 625 to 640
	value = ((uint32_t)(input[78] & 0x7f) << 25) |
			((uint32_t)input[79] << 17) |
			((uint32_t)(input[80] & 0x80) << 9);
	output[39] = (double)(value >> 16);

	// read output[40]: from bit 641 to 656
	value = ((uint32_t)(input[80] & 0x7f) << 25) |
			((uint32_t)input[81] << 17) |
			((uint32_t)(input[82] & 0x80) << 9);
	output[40] = (double)(value >> 16);

	// read output[41]: from bit 657 to 672
	value = ((uint32_t)(input[82] & 0x7f) << 25) |
			((uint32_t)input[83] << 17) |
			((uint32_t)(input[84] & 0x80) << 9);
	output[41] = (double)(value >> 16);

	// read output[42]: from bit 673 to 688
	value = ((uint32_t)(input[84] & 0x7f) << 25) |
			((uint32_t)input[85] << 17) |
			((uint32_t)(input[86] & 0x80) << 9);
	output[42] = (double)(value >> 16);

	// read output[43]: from bit 689 to 704
	value = ((uint32_t)(input[86] & 0x7f) << 25) |
			((uint32_t)input[87] << 17) |
			((uint32_t)(input[88] & 0x80) << 9);
	output[43] = (double)(value >> 16);

	// read output[44]: from bit 705 to 720
	value = ((uint32_t)(input[88] & 0x7f) << 25) |
			((uint32_t)input[89] << 17) |
			((uint32_t)(input[90] & 0x80) << 9);
	output[44] = (double)(value >> 16);

	// read output[45]: from bit 721 to 736
	value = ((uint32_t)(input[90] & 0x7f) << 25) |
			((uint32_t)input[91] << 17) |
			((uint32_t)(input[92] & 0x80) << 9);
	output[45] = (double)(value >> 16);

	// read output[46]: from bit 737 to 752
	value = ((uint32_t)(input[92] & 0x7f) << 25) |
			((uint32_t)input[93] << 17) |
			((uint32_t)(input[94] & 0x80) << 9);
	output[46] = (double)(value >> 16);

	// read output[47]: from bit 753 to 768
	value = ((uint32_t)(input[94] & 0x7f) << 25) |
			((uint32_t)input[95] << 17) |
			((uint32_t)(input[96] & 0x80) << 9);
	output[47] = (double)(value >> 16);

	// read output[48]: from bit 769 to 784
	value = ((uint32_t)(input[96] & 0x7f) << 25) |
			((uint32_t)input[97] << 17) |
			((uint32_t)(input[98] & 0x80) << 9);
	output[48] = (double)(value >> 16);

	// read output[49]: from bit 785 to 800
	value = ((uint32_t)(input[98] & 0x7f) << 25) |
			((uint32_t)input[99] << 17) |
			((uint32_t)(input[100] & 0x80) << 9);
	output[49] = (double)(value >> 16);

	// read output[50]: from bit 801 to 816
	value = ((uint32_t)(input[100] & 0x7f) << 25) |
			((uint32_t)input[101] << 17) |
			((uint32_t)(input[102] & 0x80) << 9);
	output[50] = (double)(value >> 16);

	// read output[51]: from bit 817 to 832
	value = ((uint32_t)(input[102] & 0x7f) << 25) |
			((uint32_t)input[103] << 17) |
			((uint32_t)(input[104] & 0x80) << 9);
	output[51] = (double)(value >> 16);

	// read output[52]: from bit 833 to 848
	value = ((uint32_t)(input[104] & 0x7f) << 25) |
			((uint32_t)input[105] << 17) |
			((uint32_t)(input[106] & 0x80) << 9);
	output[52] = (double)(value >> 16);

	// read output[53]: from bit 849 to 864
	value = ((uint32_t)(input[106] & 0x7f) << 25) |
			((uint32_t)input[107] << 17) |
			((uint32_t)(input[108] & 0x80) << 9);
	output[53] = (double)(value >> 16);

	// read output[54]: from bit 865 to 880
	value = ((uint32_t)(input[108] & 0x7f) << 25) |
			((uint32_t)input[109] << 17) |
			((uint32_t)(input[110] & 0x80) << 9);
	output[54] = (double)(value >> 16);

	// read output[55]: from bit 881 to 896
	value = ((uint32_t)(input[110] & 0x7f) << 25) |
			((uint32_t)input[111] << 17) |
			((uint32_t)(input[112] & 0x80) << 9);
	output[55] = (double)(value >> 16);

	// read output[56]: from bit 897 to 912
	value = ((uint32_t)(input[112] & 0x7f) << 25) |
			((uint32_t)input[113] << 17) |
			((uint32_t)(input[114] & 0x80) << 9);
	output[56] = (double)(value >> 16);
}

static void unpack_57_16bit_unsigned_1off(const uint8_t * input, double * output, void *closure) {
	// Unpack 57 values into output
	// Values are 16-bit unsigned
	// Skip 1 bits, read 912 bits of data.
	// Input must be at least 115 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 1 to 16
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)input[1] << 17) |
			((uint32_t)(input[2] & 0x80) << 9);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 17 to 32
	value = ((uint32_t)(input[2] & 0x7f) << 25) |
			((uint32_t)input[3] << 17) |
			((uint32_t)(input[4] & 0x80) << 9);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 33 to 48
	value = ((uint32_t)(input[4] & 0x7f) << 25) |
			((uint32_t)input[5] << 17) |
			((uint32_t)(input[6] & 0x80) << 9);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 49 to 64
	value = ((uint32_t)(input[6] & 0x7f) << 25) |
			((uint32_t)input[7] << 17) |
			((uint32_t)(input[8] & 0x80) << 9);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 65 to 80
	value = ((uint32_t)(input[8] & 0x7f) << 25) |
			((uint32_t)input[9] << 17) |
			((uint32_t)(input[10] & 0x80) << 9);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 81 to 96
	value = ((uint32_t)(input[10] & 0x7f) << 25) |
			((uint32_t)input[11] << 17) |
			((uint32_t)(input[12] & 0x80) << 9);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 97 to 112
	value = ((uint32_t)(input[12] & 0x7f) << 25) |
			((uint32_t)input[13] << 17) |
			((uint32_t)(input[14] & 0x80) << 9);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 113 to 128
	value = ((uint32_t)(input[14] & 0x7f) << 25) |
			((uint32_t)input[15] << 17) |
			((uint32_t)(input[16] & 0x80) << 9);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 129 to 144
	value = ((uint32_t)(input[16] & 0x7f) << 25) |
			((uint32_t)input[17] << 17) |
			((uint32_t)(input[18] & 0x80) << 9);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 145 to 160
	value = ((uint32_t)(input[18] & 0x7f) << 25) |
			((uint32_t)input[19] << 17) |
			((uint32_t)(input[20] & 0x80) << 9);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 161 to 176
	value = ((uint32_t)(input[20] & 0x7f) << 25) |
			((uint32_t)input[21] << 17) |
			((uint32_t)(input[22] & 0x80) << 9);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 177 to 192
	value = ((uint32_t)(input[22] & 0x7f) << 25) |
			((uint32_t)input[23] << 17) |
			((uint32_t)(input[24] & 0x80) << 9);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 193 to 208
	value = ((uint32_t)(input[24] & 0x7f) << 25) |
			((uint32_t)input[25] << 17) |
			((uint32_t)(input[26] & 0x80) << 9);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 209 to 224
	value = ((uint32_t)(input[26] & 0x7f) << 25) |
			((uint32_t)input[27] << 17) |
			((uint32_t)(input[28] & 0x80) << 9);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 225 to 240
	value = ((uint32_t)(input[28] & 0x7f) << 25) |
			((uint32_t)input[29] << 17) |
			((uint32_t)(input[30] & 0x80) << 9);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 241 to 256
	value = ((uint32_t)(input[30] & 0x7f) << 25) |
			((uint32_t)input[31] << 17) |
			((uint32_t)(input[32] & 0x80) << 9);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 257 to 272
	value = ((uint32_t)(input[32] & 0x7f) << 25) |
			((uint32_t)input[33] << 17) |
			((uint32_t)(input[34] & 0x80) << 9);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 273 to 288
	value = ((uint32_t)(input[34] & 0x7f) << 25) |
			((uint32_t)input[35] << 17) |
			((uint32_t)(input[36] & 0x80) << 9);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 289 to 304
	value = ((uint32_t)(input[36] & 0x7f) << 25) |
			((uint32_t)input[37] << 17) |
			((uint32_t)(input[38] & 0x80) << 9);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 305 to 320
	value = ((uint32_t)(input[38] & 0x7f) << 25) |
			((uint32_t)input[39] << 17) |
			((uint32_t)(input[40] & 0x80) << 9);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 321 to 336
	value = ((uint32_t)(input[40] & 0x7f) << 25) |
			((uint32_t)input[41] << 17) |
			((uint32_t)(input[42] & 0x80) << 9);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 337 to 352
	value = ((uint32_t)(input[42] & 0x7f) << 25) |
			((uint32_t)input[43] << 17) |
			((uint32_t)(input[44] & 0x80) << 9);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 353 to 368
	value = ((uint32_t)(input[44] & 0x7f) << 25) |
			((uint32_t)input[45] << 17) |
			((uint32_t)(input[46] & 0x80) << 9);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 369 to 384
	value = ((uint32_t)(input[46] & 0x7f) << 25) |
			((uint32_t)input[47] << 17) |
			((uint32_t)(input[48] & 0x80) << 9);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 385 to 400
	value = ((uint32_t)(input[48] & 0x7f) << 25) |
			((uint32_t)input[49] << 17) |
			((uint32_t)(input[50] & 0x80) << 9);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 401 to 416
	value = ((uint32_t)(input[50] & 0x7f) << 25) |
			((uint32_t)input[51] << 17) |
			((uint32_t)(input[52] & 0x80) << 9);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 417 to 432
	value = ((uint32_t)(input[52] & 0x7f) << 25) |
			((uint32_t)input[53] << 17) |
			((uint32_t)(input[54] & 0x80) << 9);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 433 to 448
	value = ((uint32_t)(input[54] & 0x7f) << 25) |
			((uint32_t)input[55] << 17) |
			((uint32_t)(input[56] & 0x80) << 9);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 449 to 464
	value = ((uint32_t)(input[56] & 0x7f) << 25) |
			((uint32_t)input[57] << 17) |
			((uint32_t)(input[58] & 0x80) << 9);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 465 to 480
	value = ((uint32_t)(input[58] & 0x7f) << 25) |
			((uint32_t)input[59] << 17) |
			((uint32_t)(input[60] & 0x80) << 9);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 481 to 496
	value = ((uint32_t)(input[60] & 0x7f) << 25) |
			((uint32_t)input[61] << 17) |
			((uint32_t)(input[62] & 0x80) << 9);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 497 to 512
	value = ((uint32_t)(input[62] & 0x7f) << 25) |
			((uint32_t)input[63] << 17) |
			((uint32_t)(input[64] & 0x80) << 9);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 513 to 528
	value = ((uint32_t)(input[64] & 0x7f) << 25) |
			((uint32_t)input[65] << 17) |
			((uint32_t)(input[66] & 0x80) << 9);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 529 to 544
	value = ((uint32_t)(input[66] & 0x7f) << 25) |
			((uint32_t)input[67] << 17) |
			((uint32_t)(input[68] & 0x80) << 9);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 545 to 560
	value = ((uint32_t)(input[68] & 0x7f) << 25) |
			((uint32_t)input[69] << 17) |
			((uint32_t)(input[70] & 0x80) << 9);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 561 to 576
	value = ((uint32_t)(input[70] & 0x7f) << 25) |
			((uint32_t)input[71] << 17) |
			((uint32_t)(input[72] & 0x80) << 9);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 577 to 592
	value = ((uint32_t)(input[72] & 0x7f) << 25) |
			((uint32_t)input[73] << 17) |
			((uint32_t)(input[74] & 0x80) << 9);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 593 to 608
	value = ((uint32_t)(input[74] & 0x7f) << 25) |
			((uint32_t)input[75] << 17) |
			((uint32_t)(input[76] & 0x80) << 9);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 609 to 624
	value = ((uint32_t)(input[76] & 0x7f) << 25) |
			((uint32_t)input[77] << 17) |
			((uint32_t)(input[78] & 0x80) << 9);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 625 to 640
	value = ((uint32_t)(input[78] & 0x7f) << 25) |
			((uint32_t)input[79] << 17) |
			((uint32_t)(input[80] & 0x80) << 9);
	output[39] = (double)(value >> 16);

	// read output[40]: from bit 641 to 656
	value = ((uint32_t)(input[80] & 0x7f) << 25) |
			((uint32_t)input[81] << 17) |
			((uint32_t)(input[82] & 0x80) << 9);
	output[40] = (double)(value >> 16);

	// read output[41]: from bit 657 to 672
	value = ((uint32_t)(input[82] & 0x7f) << 25) |
			((uint32_t)input[83] << 17) |
			((uint32_t)(input[84] & 0x80) << 9);
	output[41] = (double)(value >> 16);

	// read output[42]: from bit 673 to 688
	value = ((uint32_t)(input[84] & 0x7f) << 25) |
			((uint32_t)input[85] << 17) |
			((uint32_t)(input[86] & 0x80) << 9);
	output[42] = (double)(value >> 16);

	// read output[43]: from bit 689 to 704
	value = ((uint32_t)(input[86] & 0x7f) << 25) |
			((uint32_t)input[87] << 17) |
			((uint32_t)(input[88] & 0x80) << 9);
	output[43] = (double)(value >> 16);

	// read output[44]: from bit 705 to 720
	value = ((uint32_t)(input[88] & 0x7f) << 25) |
			((uint32_t)input[89] << 17) |
			((uint32_t)(input[90] & 0x80) << 9);
	output[44] = (double)(value >> 16);

	// read output[45]: from bit 721 to 736
	value = ((uint32_t)(input[90] & 0x7f) << 25) |
			((uint32_t)input[91] << 17) |
			((uint32_t)(input[92] & 0x80) << 9);
	output[45] = (double)(value >> 16);

	// read output[46]: from bit 737 to 752
	value = ((uint32_t)(input[92] & 0x7f) << 25) |
			((uint32_t)input[93] << 17) |
			((uint32_t)(input[94] & 0x80) << 9);
	output[46] = (double)(value >> 16);

	// read output[47]: from bit 753 to 768
	value = ((uint32_t)(input[94] & 0x7f) << 25) |
			((uint32_t)input[95] << 17) |
			((uint32_t)(input[96] & 0x80) << 9);
	output[47] = (double)(value >> 16);

	// read output[48]: from bit 769 to 784
	value = ((uint32_t)(input[96] & 0x7f) << 25) |
			((uint32_t)input[97] << 17) |
			((uint32_t)(input[98] & 0x80) << 9);
	output[48] = (double)(value >> 16);

	// read output[49]: from bit 785 to 800
	value = ((uint32_t)(input[98] & 0x7f) << 25) |
			((uint32_t)input[99] << 17) |
			((uint32_t)(input[100] & 0x80) << 9);
	output[49] = (double)(value >> 16);

	// read output[50]: from bit 801 to 816
	value = ((uint32_t)(input[100] & 0x7f) << 25) |
			((uint32_t)input[101] << 17) |
			((uint32_t)(input[102] & 0x80) << 9);
	output[50] = (double)(value >> 16);

	// read output[51]: from bit 817 to 832
	value = ((uint32_t)(input[102] & 0x7f) << 25) |
			((uint32_t)input[103] << 17) |
			((uint32_t)(input[104] & 0x80) << 9);
	output[51] = (double)(value >> 16);

	// read output[52]: from bit 833 to 848
	value = ((uint32_t)(input[104] & 0x7f) << 25) |
			((uint32_t)input[105] << 17) |
			((uint32_t)(input[106] & 0x80) << 9);
	output[52] = (double)(value >> 16);

	// read output[53]: from bit 849 to 864
	value = ((uint32_t)(input[106] & 0x7f) << 25) |
			((uint32_t)input[107] << 17) |
			((uint32_t)(input[108] & 0x80) << 9);
	output[53] = (double)(value >> 16);

	// read output[54]: from bit 865 to 880
	value = ((uint32_t)(input[108] & 0x7f) << 25) |
			((uint32_t)input[109] << 17) |
			((uint32_t)(input[110] & 0x80) << 9);
	output[54] = (double)(value >> 16);

	// read output[55]: from bit 881 to 896
	value = ((uint32_t)(input[110] & 0x7f) << 25) |
			((uint32_t)input[111] << 17) |
			((uint32_t)(input[112] & 0x80) << 9);
	output[55] = (double)(value >> 16);

	// read output[56]: from bit 897 to 912
	value = ((uint32_t)(input[112] & 0x7f) << 25) |
			((uint32_t)input[113] << 17) |
			((uint32_t)(input[114] & 0x80) << 9);
	output[56] = (double)(value >> 16);
}

static void unpack_57_16bit_signed_2off(const uint8_t * input, double * output, void *closure) {
	// Unpack 57 values into output
	// Values are 16-bit signed
	// Skip 2 bits, read 912 bits of data.
	// Input must be at least 115 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 2 to 17
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)input[1] << 18) |
			((uint32_t)(input[2] & 0xc0) << 10);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 18 to 33
	value = ((uint32_t)(input[2] & 0x3f) << 26) |
			((uint32_t)input[3] << 18) |
			((uint32_t)(input[4] & 0xc0) << 10);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 34 to 49
	value = ((uint32_t)(input[4] & 0x3f) << 26) |
			((uint32_t)input[5] << 18) |
			((uint32_t)(input[6] & 0xc0) << 10);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 50 to 65
	value = ((uint32_t)(input[6] & 0x3f) << 26) |
			((uint32_t)input[7] << 18) |
			((uint32_t)(input[8] & 0xc0) << 10);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 66 to 81
	value = ((uint32_t)(input[8] & 0x3f) << 26) |
			((uint32_t)input[9] << 18) |
			((uint32_t)(input[10] & 0xc0) << 10);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 82 to 97
	value = ((uint32_t)(input[10] & 0x3f) << 26) |
			((uint32_t)input[11] << 18) |
			((uint32_t)(input[12] & 0xc0) << 10);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 98 to 113
	value = ((uint32_t)(input[12] & 0x3f) << 26) |
			((uint32_t)input[13] << 18) |
			((uint32_t)(input[14] & 0xc0) << 10);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 114 to 129
	value = ((uint32_t)(input[14] & 0x3f) << 26) |
			((uint32_t)input[15] << 18) |
			((uint32_t)(input[16] & 0xc0) << 10);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 130 to 145
	value = ((uint32_t)(input[16] & 0x3f) << 26) |
			((uint32_t)input[17] << 18) |
			((uint32_t)(input[18] & 0xc0) << 10);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 146 to 161
	value = ((uint32_t)(input[18] & 0x3f) << 26) |
			((uint32_t)input[19] << 18) |
			((uint32_t)(input[20] & 0xc0) << 10);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 162 to 177
	value = ((uint32_t)(input[20] & 0x3f) << 26) |
			((uint32_t)input[21] << 18) |
			((uint32_t)(input[22] & 0xc0) << 10);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 178 to 193
	value = ((uint32_t)(input[22] & 0x3f) << 26) |
			((uint32_t)input[23] << 18) |
			((uint32_t)(input[24] & 0xc0) << 10);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 194 to 209
	value = ((uint32_t)(input[24] & 0x3f) << 26) |
			((uint32_t)input[25] << 18) |
			((uint32_t)(input[26] & 0xc0) << 10);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 210 to 225
	value = ((uint32_t)(input[26] & 0x3f) << 26) |
			((uint32_t)input[27] << 18) |
			((uint32_t)(input[28] & 0xc0) << 10);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 226 to 241
	value = ((uint32_t)(input[28] & 0x3f) << 26) |
			((uint32_t)input[29] << 18) |
			((uint32_t)(input[30] & 0xc0) << 10);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 242 to 257
	value = ((uint32_t)(input[30] & 0x3f) << 26) |
			((uint32_t)input[31] << 18) |
			((uint32_t)(input[32] & 0xc0) << 10);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 258 to 273
	value = ((uint32_t)(input[32] & 0x3f) << 26) |
			((uint32_t)input[33] << 18) |
			((uint32_t)(input[34] & 0xc0) << 10);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 274 to 289
	value = ((uint32_t)(input[34] & 0x3f) << 26) |
			((uint32_t)input[35] << 18) |
			((uint32_t)(input[36] & 0xc0) << 10);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 290 to 305
	value = ((uint32_t)(input[36] & 0x3f) << 26) |
			((uint32_t)input[37] << 18) |
			((uint32_t)(input[38] & 0xc0) << 10);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 306 to 321
	value = ((uint32_t)(input[38] & 0x3f) << 26) |
			((uint32_t)input[39] << 18) |
			((uint32_t)(input[40] & 0xc0) << 10);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 322 to 337
	value = ((uint32_t)(input[40] & 0x3f) << 26) |
			((uint32_t)input[41] << 18) |
			((uint32_t)(input[42] & 0xc0) << 10);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 338 to 353
	value = ((uint32_t)(input[42] & 0x3f) << 26) |
			((uint32_t)input[43] << 18) |
			((uint32_t)(input[44] & 0xc0) << 10);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 354 to 369
	value = ((uint32_t)(input[44] & 0x3f) << 26) |
			((uint32_t)input[45] << 18) |
			((uint32_t)(input[46] & 0xc0) << 10);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 370 to 385
	value = ((uint32_t)(input[46] & 0x3f) << 26) |
			((uint32_t)input[47] << 18) |
			((uint32_t)(input[48] & 0xc0) << 10);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 386 to 401
	value = ((uint32_t)(input[48] & 0x3f) << 26) |
			((uint32_t)input[49] << 18) |
			((uint32_t)(input[50] & 0xc0) << 10);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 402 to 417
	value = ((uint32_t)(input[50] & 0x3f) << 26) |
			((uint32_t)input[51] << 18) |
			((uint32_t)(input[52] & 0xc0) << 10);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 418 to 433
	value = ((uint32_t)(input[52] & 0x3f) << 26) |
			((uint32_t)input[53] << 18) |
			((uint32_t)(input[54] & 0xc0) << 10);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 434 to 449
	value = ((uint32_t)(input[54] & 0x3f) << 26) |
			((uint32_t)input[55] << 18) |
			((uint32_t)(input[56] & 0xc0) << 10);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 450 to 465
	value = ((uint32_t)(input[56] & 0x3f) << 26) |
			((uint32_t)input[57] << 18) |
			((uint32_t)(input[58] & 0xc0) << 10);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 466 to 481
	value = ((uint32_t)(input[58] & 0x3f) << 26) |
			((uint32_t)input[59] << 18) |
			((uint32_t)(input[60] & 0xc0) << 10);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 482 to 497
	value = ((uint32_t)(input[60] & 0x3f) << 26) |
			((uint32_t)input[61] << 18) |
			((uint32_t)(input[62] & 0xc0) << 10);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 498 to 513
	value = ((uint32_t)(input[62] & 0x3f) << 26) |
			((uint32_t)input[63] << 18) |
			((uint32_t)(input[64] & 0xc0) << 10);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 514 to 529
	value = ((uint32_t)(input[64] & 0x3f) << 26) |
			((uint32_t)input[65] << 18) |
			((uint32_t)(input[66] & 0xc0) << 10);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 530 to 545
	value = ((uint32_t)(input[66] & 0x3f) << 26) |
			((uint32_t)input[67] << 18) |
			((uint32_t)(input[68] & 0xc0) << 10);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 546 to 561
	value = ((uint32_t)(input[68] & 0x3f) << 26) |
			((uint32_t)input[69] << 18) |
			((uint32_t)(input[70] & 0xc0) << 10);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 562 to 577
	value = ((uint32_t)(input[70] & 0x3f) << 26) |
			((uint32_t)input[71] << 18) |
			((uint32_t)(input[72] & 0xc0) << 10);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 578 to 593
	value = ((uint32_t)(input[72] & 0x3f) << 26) |
			((uint32_t)input[73] << 18) |
			((uint32_t)(input[74] & 0xc0) << 10);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 594 to 609
	value = ((uint32_t)(input[74] & 0x3f) << 26) |
			((uint32_t)input[75] << 18) |
			((uint32_t)(input[76] & 0xc0) << 10);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 610 to 625
	value = ((uint32_t)(input[76] & 0x3f) << 26) |
			((uint32_t)input[77] << 18) |
			((uint32_t)(input[78] & 0xc0) << 10);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 626 to 641
	value = ((uint32_t)(input[78] & 0x3f) << 26) |
			((uint32_t)input[79] << 18) |
			((uint32_t)(input[80] & 0xc0) << 10);
	output[39] = (double)(value >> 16);

	// read output[40]: from bit 642 to 657
	value = ((uint32_t)(input[80] & 0x3f) << 26) |
			((uint32_t)input[81] << 18) |
			((uint32_t)(input[82] & 0xc0) << 10);
	output[40] = (double)(value >> 16);

	// read output[41]: from bit 658 to 673
	value = ((uint32_t)(input[82] & 0x3f) << 26) |
			((uint32_t)input[83] << 18) |
			((uint32_t)(input[84] & 0xc0) << 10);
	output[41] = (double)(value >> 16);

	// read output[42]: from bit 674 to 689
	value = ((uint32_t)(input[84] & 0x3f) << 26) |
			((uint32_t)input[85] << 18) |
			((uint32_t)(input[86] & 0xc0) << 10);
	output[42] = (double)(value >> 16);

	// read output[43]: from bit 690 to 705
	value = ((uint32_t)(input[86] & 0x3f) << 26) |
			((uint32_t)input[87] << 18) |
			((uint32_t)(input[88] & 0xc0) << 10);
	output[43] = (double)(value >> 16);

	// read output[44]: from bit 706 to 721
	value = ((uint32_t)(input[88] & 0x3f) << 26) |
			((uint32_t)input[89] << 18) |
			((uint32_t)(input[90] & 0xc0) << 10);
	output[44] = (double)(value >> 16);

	// read output[45]: from bit 722 to 737
	value = ((uint32_t)(input[90] & 0x3f) << 26) |
			((uint32_t)input[91] << 18) |
			((uint32_t)(input[92] & 0xc0) << 10);
	output[45] = (double)(value >> 16);

	// read output[46]: from bit 738 to 753
	value = ((uint32_t)(input[92] & 0x3f) << 26) |
			((uint32_t)input[93] << 18) |
			((uint32_t)(input[94] & 0xc0) << 10);
	output[46] = (double)(value >> 16);

	// read output[47]: from bit 754 to 769
	value = ((uint32_t)(input[94] & 0x3f) << 26) |
			((uint32_t)input[95] << 18) |
			((uint32_t)(input[96] & 0xc0) << 10);
	output[47] = (double)(value >> 16);

	// read output[48]: from bit 770 to 785
	value = ((uint32_t)(input[96] & 0x3f) << 26) |
			((uint32_t)input[97] << 18) |
			((uint32_t)(input[98] & 0xc0) << 10);
	output[48] = (double)(value >> 16);

	// read output[49]: from bit 786 to 801
	value = ((uint32_t)(input[98] & 0x3f) << 26) |
			((uint32_t)input[99] << 18) |
			((uint32_t)(input[100] & 0xc0) << 10);
	output[49] = (double)(value >> 16);

	// read output[50]: from bit 802 to 817
	value = ((uint32_t)(input[100] & 0x3f) << 26) |
			((uint32_t)input[101] << 18) |
			((uint32_t)(input[102] & 0xc0) << 10);
	output[50] = (double)(value >> 16);

	// read output[51]: from bit 818 to 833
	value = ((uint32_t)(input[102] & 0x3f) << 26) |
			((uint32_t)input[103] << 18) |
			((uint32_t)(input[104] & 0xc0) << 10);
	output[51] = (double)(value >> 16);

	// read output[52]: from bit 834 to 849
	value = ((uint32_t)(input[104] & 0x3f) << 26) |
			((uint32_t)input[105] << 18) |
			((uint32_t)(input[106] & 0xc0) << 10);
	output[52] = (double)(value >> 16);

	// read output[53]: from bit 850 to 865
	value = ((uint32_t)(input[106] & 0x3f) << 26) |
			((uint32_t)input[107] << 18) |
			((uint32_t)(input[108] & 0xc0) << 10);
	output[53] = (double)(value >> 16);

	// read output[54]: from bit 866 to 881
	value = ((uint32_t)(input[108] & 0x3f) << 26) |
			((uint32_t)input[109] << 18) |
			((uint32_t)(input[110] & 0xc0) << 10);
	output[54] = (double)(value >> 16);

	// read output[55]: from bit 882 to 897
	value = ((uint32_t)(input[110] & 0x3f) << 26) |
			((uint32_t)input[111] << 18) |
			((uint32_t)(input[112] & 0xc0) << 10);
	output[55] = (double)(value >> 16);

	// read output[56]: from bit 898 to 913
	value = ((uint32_t)(input[112] & 0x3f) << 26) |
			((uint32_t)input[113] << 18) |
			((uint32_t)(input[114] & 0xc0) << 10);
	output[56] = (double)(value >> 16);
}

static void unpack_57_16bit_unsigned_2off(const uint8_t * input, double * output, void *closure) {
	// Unpack 57 values into output
	// Values are 16-bit unsigned
	// Skip 2 bits, read 912 bits of data.
	// Input must be at least 115 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 2 to 17
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)input[1] << 18) |
			((uint32_t)(input[2] & 0xc0) << 10);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 18 to 33
	value = ((uint32_t)(input[2] & 0x3f) << 26) |
			((uint32_t)input[3] << 18) |
			((uint32_t)(input[4] & 0xc0) << 10);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 34 to 49
	value = ((uint32_t)(input[4] & 0x3f) << 26) |
			((uint32_t)input[5] << 18) |
			((uint32_t)(input[6] & 0xc0) << 10);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 50 to 65
	value = ((uint32_t)(input[6] & 0x3f) << 26) |
			((uint32_t)input[7] << 18) |
			((uint32_t)(input[8] & 0xc0) << 10);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 66 to 81
	value = ((uint32_t)(input[8] & 0x3f) << 26) |
			((uint32_t)input[9] << 18) |
			((uint32_t)(input[10] & 0xc0) << 10);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 82 to 97
	value = ((uint32_t)(input[10] & 0x3f) << 26) |
			((uint32_t)input[11] << 18) |
			((uint32_t)(input[12] & 0xc0) << 10);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 98 to 113
	value = ((uint32_t)(input[12] & 0x3f) << 26) |
			((uint32_t)input[13] << 18) |
			((uint32_t)(input[14] & 0xc0) << 10);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 114 to 129
	value = ((uint32_t)(input[14] & 0x3f) << 26) |
			((uint32_t)input[15] << 18) |
			((uint32_t)(input[16] & 0xc0) << 10);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 130 to 145
	value = ((uint32_t)(input[16] & 0x3f) << 26) |
			((uint32_t)input[17] << 18) |
			((uint32_t)(input[18] & 0xc0) << 10);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 146 to 161
	value = ((uint32_t)(input[18] & 0x3f) << 26) |
			((uint32_t)input[19] << 18) |
			((uint32_t)(input[20] & 0xc0) << 10);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 162 to 177
	value = ((uint32_t)(input[20] & 0x3f) << 26) |
			((uint32_t)input[21] << 18) |
			((uint32_t)(input[22] & 0xc0) << 10);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 178 to 193
	value = ((uint32_t)(input[22] & 0x3f) << 26) |
			((uint32_t)input[23] << 18) |
			((uint32_t)(input[24] & 0xc0) << 10);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 194 to 209
	value = ((uint32_t)(input[24] & 0x3f) << 26) |
			((uint32_t)input[25] << 18) |
			((uint32_t)(input[26] & 0xc0) << 10);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 210 to 225
	value = ((uint32_t)(input[26] & 0x3f) << 26) |
			((uint32_t)input[27] << 18) |
			((uint32_t)(input[28] & 0xc0) << 10);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 226 to 241
	value = ((uint32_t)(input[28] & 0x3f) << 26) |
			((uint32_t)input[29] << 18) |
			((uint32_t)(input[30] & 0xc0) << 10);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 242 to 257
	value = ((uint32_t)(input[30] & 0x3f) << 26) |
			((uint32_t)input[31] << 18) |
			((uint32_t)(input[32] & 0xc0) << 10);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 258 to 273
	value = ((uint32_t)(input[32] & 0x3f) << 26) |
			((uint32_t)input[33] << 18) |
			((uint32_t)(input[34] & 0xc0) << 10);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 274 to 289
	value = ((uint32_t)(input[34] & 0x3f) << 26) |
			((uint32_t)input[35] << 18) |
			((uint32_t)(input[36] & 0xc0) << 10);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 290 to 305
	value = ((uint32_t)(input[36] & 0x3f) << 26) |
			((uint32_t)input[37] << 18) |
			((uint32_t)(input[38] & 0xc0) << 10);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 306 to 321
	value = ((uint32_t)(input[38] & 0x3f) << 26) |
			((uint32_t)input[39] << 18) |
			((uint32_t)(input[40] & 0xc0) << 10);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 322 to 337
	value = ((uint32_t)(input[40] & 0x3f) << 26) |
			((uint32_t)input[41] << 18) |
			((uint32_t)(input[42] & 0xc0) << 10);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 338 to 353
	value = ((uint32_t)(input[42] & 0x3f) << 26) |
			((uint32_t)input[43] << 18) |
			((uint32_t)(input[44] & 0xc0) << 10);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 354 to 369
	value = ((uint32_t)(input[44] & 0x3f) << 26) |
			((uint32_t)input[45] << 18) |
			((uint32_t)(input[46] & 0xc0) << 10);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 370 to 385
	value = ((uint32_t)(input[46] & 0x3f) << 26) |
			((uint32_t)input[47] << 18) |
			((uint32_t)(input[48] & 0xc0) << 10);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 386 to 401
	value = ((uint32_t)(input[48] & 0x3f) << 26) |
			((uint32_t)input[49] << 18) |
			((uint32_t)(input[50] & 0xc0) << 10);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 402 to 417
	value = ((uint32_t)(input[50] & 0x3f) << 26) |
			((uint32_t)input[51] << 18) |
			((uint32_t)(input[52] & 0xc0) << 10);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 418 to 433
	value = ((uint32_t)(input[52] & 0x3f) << 26) |
			((uint32_t)input[53] << 18) |
			((uint32_t)(input[54] & 0xc0) << 10);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 434 to 449
	value = ((uint32_t)(input[54] & 0x3f) << 26) |
			((uint32_t)input[55] << 18) |
			((uint32_t)(input[56] & 0xc0) << 10);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 450 to 465
	value = ((uint32_t)(input[56] & 0x3f) << 26) |
			((uint32_t)input[57] << 18) |
			((uint32_t)(input[58] & 0xc0) << 10);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 466 to 481
	value = ((uint32_t)(input[58] & 0x3f) << 26) |
			((uint32_t)input[59] << 18) |
			((uint32_t)(input[60] & 0xc0) << 10);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 482 to 497
	value = ((uint32_t)(input[60] & 0x3f) << 26) |
			((uint32_t)input[61] << 18) |
			((uint32_t)(input[62] & 0xc0) << 10);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 498 to 513
	value = ((uint32_t)(input[62] & 0x3f) << 26) |
			((uint32_t)input[63] << 18) |
			((uint32_t)(input[64] & 0xc0) << 10);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 514 to 529
	value = ((uint32_t)(input[64] & 0x3f) << 26) |
			((uint32_t)input[65] << 18) |
			((uint32_t)(input[66] & 0xc0) << 10);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 530 to 545
	value = ((uint32_t)(input[66] & 0x3f) << 26) |
			((uint32_t)input[67] << 18) |
			((uint32_t)(input[68] & 0xc0) << 10);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 546 to 561
	value = ((uint32_t)(input[68] & 0x3f) << 26) |
			((uint32_t)input[69] << 18) |
			((uint32_t)(input[70] & 0xc0) << 10);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 562 to 577
	value = ((uint32_t)(input[70] & 0x3f) << 26) |
			((uint32_t)input[71] << 18) |
			((uint32_t)(input[72] & 0xc0) << 10);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 578 to 593
	value = ((uint32_t)(input[72] & 0x3f) << 26) |
			((uint32_t)input[73] << 18) |
			((uint32_t)(input[74] & 0xc0) << 10);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 594 to 609
	value = ((uint32_t)(input[74] & 0x3f) << 26) |
			((uint32_t)input[75] << 18) |
			((uint32_t)(input[76] & 0xc0) << 10);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 610 to 625
	value = ((uint32_t)(input[76] & 0x3f) << 26) |
			((uint32_t)input[77] << 18) |
			((uint32_t)(input[78] & 0xc0) << 10);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 626 to 641
	value = ((uint32_t)(input[78] & 0x3f) << 26) |
			((uint32_t)input[79] << 18) |
			((uint32_t)(input[80] & 0xc0) << 10);
	output[39] = (double)(value >> 16);

	// read output[40]: from bit 642 to 657
	value = ((uint32_t)(input[80] & 0x3f) << 26) |
			((uint32_t)input[81] << 18) |
			((uint32_t)(input[82] & 0xc0) << 10);
	output[40] = (double)(value >> 16);

	// read output[41]: from bit 658 to 673
	value = ((uint32_t)(input[82] & 0x3f) << 26) |
			((uint32_t)input[83] << 18) |
			((uint32_t)(input[84] & 0xc0) << 10);
	output[41] = (double)(value >> 16);

	// read output[42]: from bit 674 to 689
	value = ((uint32_t)(input[84] & 0x3f) << 26) |
			((uint32_t)input[85] << 18) |
			((uint32_t)(input[86] & 0xc0) << 10);
	output[42] = (double)(value >> 16);

	// read output[43]: from bit 690 to 705
	value = ((uint32_t)(input[86] & 0x3f) << 26) |
			((uint32_t)input[87] << 18) |
			((uint32_t)(input[88] & 0xc0) << 10);
	output[43] = (double)(value >> 16);

	// read output[44]: from bit 706 to 721
	value = ((uint32_t)(input[88] & 0x3f) << 26) |
			((uint32_t)input[89] << 18) |
			((uint32_t)(input[90] & 0xc0) << 10);
	output[44] = (double)(value >> 16);

	// read output[45]: from bit 722 to 737
	value = ((uint32_t)(input[90] & 0x3f) << 26) |
			((uint32_t)input[91] << 18) |
			((uint32_t)(input[92] & 0xc0) << 10);
	output[45] = (double)(value >> 16);

	// read output[46]: from bit 738 to 753
	value = ((uint32_t)(input[92] & 0x3f) << 26) |
			((uint32_t)input[93] << 18) |
			((uint32_t)(input[94] & 0xc0) << 10);
	output[46] = (double)(value >> 16);

	// read output[47]: from bit 754 to 769
	value = ((uint32_t)(input[94] & 0x3f) << 26) |
			((uint32_t)input[95] << 18) |
			((uint32_t)(input[96] & 0xc0) << 10);
	output[47] = (double)(value >> 16);

	// read output[48]: from bit 770 to 785
	value = ((uint32_t)(input[96] & 0x3f) << 26) |
			((uint32_t)input[97] << 18) |
			((uint32_t)(input[98] & 0xc0) << 10);
	output[48] = (double)(value >> 16);

	// read output[49]: from bit 786 to 801
	value = ((uint32_t)(input[98] & 0x3f) << 26) |
			((uint32_t)input[99] << 18) |
			((uint32_t)(input[100] & 0xc0) << 10);
	output[49] = (double)(value >> 16);

	// read output[50]: from bit 802 to 817
	value = ((uint32_t)(input[100] & 0x3f) << 26) |
			((uint32_t)input[101] << 18) |
			((uint32_t)(input[102] & 0xc0) << 10);
	output[50] = (double)(value >> 16);

	// read output[51]: from bit 818 to 833
	value = ((uint32_t)(input[102] & 0x3f) << 26) |
			((uint32_t)input[103] << 18) |
			((uint32_t)(input[104] & 0xc0) << 10);
	output[51] = (double)(value >> 16);

	// read output[52]: from bit 834 to 849
	value = ((uint32_t)(input[104] & 0x3f) << 26) |
			((uint32_t)input[105] << 18) |
			((uint32_t)(input[106] & 0xc0) << 10);
	output[52] = (double)(value >> 16);

	// read output[53]: from bit 850 to 865
	value = ((uint32_t)(input[106] & 0x3f) << 26) |
			((uint32_t)input[107] << 18) |
			((uint32_t)(input[108] & 0xc0) << 10);
	output[53] = (double)(value >> 16);

	// read output[54]: from bit 866 to 881
	value = ((uint32_t)(input[108] & 0x3f) << 26) |
			((uint32_t)input[109] << 18) |
			((uint32_t)(input[110] & 0xc0) << 10);
	output[54] = (double)(value >> 16);

	// read output[55]: from bit 882 to 897
	value = ((uint32_t)(input[110] & 0x3f) << 26) |
			((uint32_t)input[111] << 18) |
			((uint32_t)(input[112] & 0xc0) << 10);
	output[55] = (double)(value >> 16);

	// read output[56]: from bit 898 to 913
	value = ((uint32_t)(input[112] & 0x3f) << 26) |
			((uint32_t)input[113] << 18) |
			((uint32_t)(input[114] & 0xc0) << 10);
	output[56] = (double)(value >> 16);
}

static void unpack_57_16bit_signed_3off(const uint8_t * input, double * output, void *closure) {
	// Unpack 57 values into output
	// Values are 16-bit signed
	// Skip 3 bits, read 912 bits of data.
	// Input must be at least 115 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 3 to 18
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)input[1] << 19) |
			((uint32_t)(input[2] & 0xe0) << 11);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 19 to 34
	value = ((uint32_t)(input[2] & 0x1f) << 27) |
			((uint32_t)input[3] << 19) |
			((uint32_t)(input[4] & 0xe0) << 11);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 35 to 50
	value = ((uint32_t)(input[4] & 0x1f) << 27) |
			((uint32_t)input[5] << 19) |
			((uint32_t)(input[6] & 0xe0) << 11);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 51 to 66
	value = ((uint32_t)(input[6] & 0x1f) << 27) |
			((uint32_t)input[7] << 19) |
			((uint32_t)(input[8] & 0xe0) << 11);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 67 to 82
	value = ((uint32_t)(input[8] & 0x1f) << 27) |
			((uint32_t)input[9] << 19) |
			((uint32_t)(input[10] & 0xe0) << 11);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 83 to 98
	value = ((uint32_t)(input[10] & 0x1f) << 27) |
			((uint32_t)input[11] << 19) |
			((uint32_t)(input[12] & 0xe0) << 11);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 99 to 114
	value = ((uint32_t)(input[12] & 0x1f) << 27) |
			((uint32_t)input[13] << 19) |
			((uint32_t)(input[14] & 0xe0) << 11);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 115 to 130
	value = ((uint32_t)(input[14] & 0x1f) << 27) |
			((uint32_t)input[15] << 19) |
			((uint32_t)(input[16] & 0xe0) << 11);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 131 to 146
	value = ((uint32_t)(input[16] & 0x1f) << 27) |
			((uint32_t)input[17] << 19) |
			((uint32_t)(input[18] & 0xe0) << 11);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 147 to 162
	value = ((uint32_t)(input[18] & 0x1f) << 27) |
			((uint32_t)input[19] << 19) |
			((uint32_t)(input[20] & 0xe0) << 11);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 163 to 178
	value = ((uint32_t)(input[20] & 0x1f) << 27) |
			((uint32_t)input[21] << 19) |
			((uint32_t)(input[22] & 0xe0) << 11);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 179 to 194
	value = ((uint32_t)(input[22] & 0x1f) << 27) |
			((uint32_t)input[23] << 19) |
			((uint32_t)(input[24] & 0xe0) << 11);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 195 to 210
	value = ((uint32_t)(input[24] & 0x1f) << 27) |
			((uint32_t)input[25] << 19) |
			((uint32_t)(input[26] & 0xe0) << 11);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 211 to 226
	value = ((uint32_t)(input[26] & 0x1f) << 27) |
			((uint32_t)input[27] << 19) |
			((uint32_t)(input[28] & 0xe0) << 11);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 227 to 242
	value = ((uint32_t)(input[28] & 0x1f) << 27) |
			((uint32_t)input[29] << 19) |
			((uint32_t)(input[30] & 0xe0) << 11);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 243 to 258
	value = ((uint32_t)(input[30] & 0x1f) << 27) |
			((uint32_t)input[31] << 19) |
			((uint32_t)(input[32] & 0xe0) << 11);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 259 to 274
	value = ((uint32_t)(input[32] & 0x1f) << 27) |
			((uint32_t)input[33] << 19) |
			((uint32_t)(input[34] & 0xe0) << 11);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 275 to 290
	value = ((uint32_t)(input[34] & 0x1f) << 27) |
			((uint32_t)input[35] << 19) |
			((uint32_t)(input[36] & 0xe0) << 11);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 291 to 306
	value = ((uint32_t)(input[36] & 0x1f) << 27) |
			((uint32_t)input[37] << 19) |
			((uint32_t)(input[38] & 0xe0) << 11);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 307 to 322
	value = ((uint32_t)(input[38] & 0x1f) << 27) |
			((uint32_t)input[39] << 19) |
			((uint32_t)(input[40] & 0xe0) << 11);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 323 to 338
	value = ((uint32_t)(input[40] & 0x1f) << 27) |
			((uint32_t)input[41] << 19) |
			((uint32_t)(input[42] & 0xe0) << 11);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 339 to 354
	value = ((uint32_t)(input[42] & 0x1f) << 27) |
			((uint32_t)input[43] << 19) |
			((uint32_t)(input[44] & 0xe0) << 11);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 355 to 370
	value = ((uint32_t)(input[44] & 0x1f) << 27) |
			((uint32_t)input[45] << 19) |
			((uint32_t)(input[46] & 0xe0) << 11);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 371 to 386
	value = ((uint32_t)(input[46] & 0x1f) << 27) |
			((uint32_t)input[47] << 19) |
			((uint32_t)(input[48] & 0xe0) << 11);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 387 to 402
	value = ((uint32_t)(input[48] & 0x1f) << 27) |
			((uint32_t)input[49] << 19) |
			((uint32_t)(input[50] & 0xe0) << 11);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 403 to 418
	value = ((uint32_t)(input[50] & 0x1f) << 27) |
			((uint32_t)input[51] << 19) |
			((uint32_t)(input[52] & 0xe0) << 11);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 419 to 434
	value = ((uint32_t)(input[52] & 0x1f) << 27) |
			((uint32_t)input[53] << 19) |
			((uint32_t)(input[54] & 0xe0) << 11);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 435 to 450
	value = ((uint32_t)(input[54] & 0x1f) << 27) |
			((uint32_t)input[55] << 19) |
			((uint32_t)(input[56] & 0xe0) << 11);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 451 to 466
	value = ((uint32_t)(input[56] & 0x1f) << 27) |
			((uint32_t)input[57] << 19) |
			((uint32_t)(input[58] & 0xe0) << 11);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 467 to 482
	value = ((uint32_t)(input[58] & 0x1f) << 27) |
			((uint32_t)input[59] << 19) |
			((uint32_t)(input[60] & 0xe0) << 11);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 483 to 498
	value = ((uint32_t)(input[60] & 0x1f) << 27) |
			((uint32_t)input[61] << 19) |
			((uint32_t)(input[62] & 0xe0) << 11);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 499 to 514
	value = ((uint32_t)(input[62] & 0x1f) << 27) |
			((uint32_t)input[63] << 19) |
			((uint32_t)(input[64] & 0xe0) << 11);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 515 to 530
	value = ((uint32_t)(input[64] & 0x1f) << 27) |
			((uint32_t)input[65] << 19) |
			((uint32_t)(input[66] & 0xe0) << 11);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 531 to 546
	value = ((uint32_t)(input[66] & 0x1f) << 27) |
			((uint32_t)input[67] << 19) |
			((uint32_t)(input[68] & 0xe0) << 11);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 547 to 562
	value = ((uint32_t)(input[68] & 0x1f) << 27) |
			((uint32_t)input[69] << 19) |
			((uint32_t)(input[70] & 0xe0) << 11);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 563 to 578
	value = ((uint32_t)(input[70] & 0x1f) << 27) |
			((uint32_t)input[71] << 19) |
			((uint32_t)(input[72] & 0xe0) << 11);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 579 to 594
	value = ((uint32_t)(input[72] & 0x1f) << 27) |
			((uint32_t)input[73] << 19) |
			((uint32_t)(input[74] & 0xe0) << 11);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 595 to 610
	value = ((uint32_t)(input[74] & 0x1f) << 27) |
			((uint32_t)input[75] << 19) |
			((uint32_t)(input[76] & 0xe0) << 11);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 611 to 626
	value = ((uint32_t)(input[76] & 0x1f) << 27) |
			((uint32_t)input[77] << 19) |
			((uint32_t)(input[78] & 0xe0) << 11);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 627 to 642
	value = ((uint32_t)(input[78] & 0x1f) << 27) |
			((uint32_t)input[79] << 19) |
			((uint32_t)(input[80] & 0xe0) << 11);
	output[39] = (double)(value >> 16);

	// read output[40]: from bit 643 to 658
	value = ((uint32_t)(input[80] & 0x1f) << 27) |
			((uint32_t)input[81] << 19) |
			((uint32_t)(input[82] & 0xe0) << 11);
	output[40] = (double)(value >> 16);

	// read output[41]: from bit 659 to 674
	value = ((uint32_t)(input[82] & 0x1f) << 27) |
			((uint32_t)input[83] << 19) |
			((uint32_t)(input[84] & 0xe0) << 11);
	output[41] = (double)(value >> 16);

	// read output[42]: from bit 675 to 690
	value = ((uint32_t)(input[84] & 0x1f) << 27) |
			((uint32_t)input[85] << 19) |
			((uint32_t)(input[86] & 0xe0) << 11);
	output[42] = (double)(value >> 16);

	// read output[43]: from bit 691 to 706
	value = ((uint32_t)(input[86] & 0x1f) << 27) |
			((uint32_t)input[87] << 19) |
			((uint32_t)(input[88] & 0xe0) << 11);
	output[43] = (double)(value >> 16);

	// read output[44]: from bit 707 to 722
	value = ((uint32_t)(input[88] & 0x1f) << 27) |
			((uint32_t)input[89] << 19) |
			((uint32_t)(input[90] & 0xe0) << 11);
	output[44] = (double)(value >> 16);

	// read output[45]: from bit 723 to 738
	value = ((uint32_t)(input[90] & 0x1f) << 27) |
			((uint32_t)input[91] << 19) |
			((uint32_t)(input[92] & 0xe0) << 11);
	output[45] = (double)(value >> 16);

	// read output[46]: from bit 739 to 754
	value = ((uint32_t)(input[92] & 0x1f) << 27) |
			((uint32_t)input[93] << 19) |
			((uint32_t)(input[94] & 0xe0) << 11);
	output[46] = (double)(value >> 16);

	// read output[47]: from bit 755 to 770
	value = ((uint32_t)(input[94] & 0x1f) << 27) |
			((uint32_t)input[95] << 19) |
			((uint32_t)(input[96] & 0xe0) << 11);
	output[47] = (double)(value >> 16);

	// read output[48]: from bit 771 to 786
	value = ((uint32_t)(input[96] & 0x1f) << 27) |
			((uint32_t)input[97] << 19) |
			((uint32_t)(input[98] & 0xe0) << 11);
	output[48] = (double)(value >> 16);

	// read output[49]: from bit 787 to 802
	value = ((uint32_t)(input[98] & 0x1f) << 27) |
			((uint32_t)input[99] << 19) |
			((uint32_t)(input[100] & 0xe0) << 11);
	output[49] = (double)(value >> 16);

	// read output[50]: from bit 803 to 818
	value = ((uint32_t)(input[100] & 0x1f) << 27) |
			((uint32_t)input[101] << 19) |
			((uint32_t)(input[102] & 0xe0) << 11);
	output[50] = (double)(value >> 16);

	// read output[51]: from bit 819 to 834
	value = ((uint32_t)(input[102] & 0x1f) << 27) |
			((uint32_t)input[103] << 19) |
			((uint32_t)(input[104] & 0xe0) << 11);
	output[51] = (double)(value >> 16);

	// read output[52]: from bit 835 to 850
	value = ((uint32_t)(input[104] & 0x1f) << 27) |
			((uint32_t)input[105] << 19) |
			((uint32_t)(input[106] & 0xe0) << 11);
	output[52] = (double)(value >> 16);

	// read output[53]: from bit 851 to 866
	value = ((uint32_t)(input[106] & 0x1f) << 27) |
			((uint32_t)input[107] << 19) |
			((uint32_t)(input[108] & 0xe0) << 11);
	output[53] = (double)(value >> 16);

	// read output[54]: from bit 867 to 882
	value = ((uint32_t)(input[108] & 0x1f) << 27) |
			((uint32_t)input[109] << 19) |
			((uint32_t)(input[110] & 0xe0) << 11);
	output[54] = (double)(value >> 16);

	// read output[55]: from bit 883 to 898
	value = ((uint32_t)(input[110] & 0x1f) << 27) |
			((uint32_t)input[111] << 19) |
			((uint32_t)(input[112] & 0xe0) << 11);
	output[55] = (double)(value >> 16);

	// read output[56]: from bit 899 to 914
	value = ((uint32_t)(input[112] & 0x1f) << 27) |
			((uint32_t)input[113] << 19) |
			((uint32_t)(input[114] & 0xe0) << 11);
	output[56] = (double)(value >> 16);
}

static void unpack_57_16bit_unsigned_3off(const uint8_t * input, double * output, void *closure) {
	// Unpack 57 values into output
	// Values are 16-bit unsigned
	// Skip 3 bits, read 912 bits of data.
	// Input must be at least 115 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 3 to 18
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)input[1] << 19) |
			((uint32_t)(input[2] & 0xe0) << 11);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 19 to 34
	value = ((uint32_t)(input[2] & 0x1f) << 27) |
			((uint32_t)input[3] << 19) |
			((uint32_t)(input[4] & 0xe0) << 11);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 35 to 50
	value = ((uint32_t)(input[4] & 0x1f) << 27) |
			((uint32_t)input[5] << 19) |
			((uint32_t)(input[6] & 0xe0) << 11);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 51 to 66
	value = ((uint32_t)(input[6] & 0x1f) << 27) |
			((uint32_t)input[7] << 19) |
			((uint32_t)(input[8] & 0xe0) << 11);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 67 to 82
	value = ((uint32_t)(input[8] & 0x1f) << 27) |
			((uint32_t)input[9] << 19) |
			((uint32_t)(input[10] & 0xe0) << 11);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 83 to 98
	value = ((uint32_t)(input[10] & 0x1f) << 27) |
			((uint32_t)input[11] << 19) |
			((uint32_t)(input[12] & 0xe0) << 11);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 99 to 114
	value = ((uint32_t)(input[12] & 0x1f) << 27) |
			((uint32_t)input[13] << 19) |
			((uint32_t)(input[14] & 0xe0) << 11);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 115 to 130
	value = ((uint32_t)(input[14] & 0x1f) << 27) |
			((uint32_t)input[15] << 19) |
			((uint32_t)(input[16] & 0xe0) << 11);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 131 to 146
	value = ((uint32_t)(input[16] & 0x1f) << 27) |
			((uint32_t)input[17] << 19) |
			((uint32_t)(input[18] & 0xe0) << 11);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 147 to 162
	value = ((uint32_t)(input[18] & 0x1f) << 27) |
			((uint32_t)input[19] << 19) |
			((uint32_t)(input[20] & 0xe0) << 11);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 163 to 178
	value = ((uint32_t)(input[20] & 0x1f) << 27) |
			((uint32_t)input[21] << 19) |
			((uint32_t)(input[22] & 0xe0) << 11);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 179 to 194
	value = ((uint32_t)(input[22] & 0x1f) << 27) |
			((uint32_t)input[23] << 19) |
			((uint32_t)(input[24] & 0xe0) << 11);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 195 to 210
	value = ((uint32_t)(input[24] & 0x1f) << 27) |
			((uint32_t)input[25] << 19) |
			((uint32_t)(input[26] & 0xe0) << 11);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 211 to 226
	value = ((uint32_t)(input[26] & 0x1f) << 27) |
			((uint32_t)input[27] << 19) |
			((uint32_t)(input[28] & 0xe0) << 11);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 227 to 242
	value = ((uint32_t)(input[28] & 0x1f) << 27) |
			((uint32_t)input[29] << 19) |
			((uint32_t)(input[30] & 0xe0) << 11);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 243 to 258
	value = ((uint32_t)(input[30] & 0x1f) << 27) |
			((uint32_t)input[31] << 19) |
			((uint32_t)(input[32] & 0xe0) << 11);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 259 to 274
	value = ((uint32_t)(input[32] & 0x1f) << 27) |
			((uint32_t)input[33] << 19) |
			((uint32_t)(input[34] & 0xe0) << 11);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 275 to 290
	value = ((uint32_t)(input[34] & 0x1f) << 27) |
			((uint32_t)input[35] << 19) |
			((uint32_t)(input[36] & 0xe0) << 11);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 291 to 306
	value = ((uint32_t)(input[36] & 0x1f) << 27) |
			((uint32_t)input[37] << 19) |
			((uint32_t)(input[38] & 0xe0) << 11);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 307 to 322
	value = ((uint32_t)(input[38] & 0x1f) << 27) |
			((uint32_t)input[39] << 19) |
			((uint32_t)(input[40] & 0xe0) << 11);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 323 to 338
	value = ((uint32_t)(input[40] & 0x1f) << 27) |
			((uint32_t)input[41] << 19) |
			((uint32_t)(input[42] & 0xe0) << 11);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 339 to 354
	value = ((uint32_t)(input[42] & 0x1f) << 27) |
			((uint32_t)input[43] << 19) |
			((uint32_t)(input[44] & 0xe0) << 11);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 355 to 370
	value = ((uint32_t)(input[44] & 0x1f) << 27) |
			((uint32_t)input[45] << 19) |
			((uint32_t)(input[46] & 0xe0) << 11);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 371 to 386
	value = ((uint32_t)(input[46] & 0x1f) << 27) |
			((uint32_t)input[47] << 19) |
			((uint32_t)(input[48] & 0xe0) << 11);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 387 to 402
	value = ((uint32_t)(input[48] & 0x1f) << 27) |
			((uint32_t)input[49] << 19) |
			((uint32_t)(input[50] & 0xe0) << 11);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 403 to 418
	value = ((uint32_t)(input[50] & 0x1f) << 27) |
			((uint32_t)input[51] << 19) |
			((uint32_t)(input[52] & 0xe0) << 11);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 419 to 434
	value = ((uint32_t)(input[52] & 0x1f) << 27) |
			((uint32_t)input[53] << 19) |
			((uint32_t)(input[54] & 0xe0) << 11);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 435 to 450
	value = ((uint32_t)(input[54] & 0x1f) << 27) |
			((uint32_t)input[55] << 19) |
			((uint32_t)(input[56] & 0xe0) << 11);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 451 to 466
	value = ((uint32_t)(input[56] & 0x1f) << 27) |
			((uint32_t)input[57] << 19) |
			((uint32_t)(input[58] & 0xe0) << 11);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 467 to 482
	value = ((uint32_t)(input[58] & 0x1f) << 27) |
			((uint32_t)input[59] << 19) |
			((uint32_t)(input[60] & 0xe0) << 11);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 483 to 498
	value = ((uint32_t)(input[60] & 0x1f) << 27) |
			((uint32_t)input[61] << 19) |
			((uint32_t)(input[62] & 0xe0) << 11);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 499 to 514
	value = ((uint32_t)(input[62] & 0x1f) << 27) |
			((uint32_t)input[63] << 19) |
			((uint32_t)(input[64] & 0xe0) << 11);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 515 to 530
	value = ((uint32_t)(input[64] & 0x1f) << 27) |
			((uint32_t)input[65] << 19) |
			((uint32_t)(input[66] & 0xe0) << 11);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 531 to 546
	value = ((uint32_t)(input[66] & 0x1f) << 27) |
			((uint32_t)input[67] << 19) |
			((uint32_t)(input[68] & 0xe0) << 11);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 547 to 562
	value = ((uint32_t)(input[68] & 0x1f) << 27) |
			((uint32_t)input[69] << 19) |
			((uint32_t)(input[70] & 0xe0) << 11);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 563 to 578
	value = ((uint32_t)(input[70] & 0x1f) << 27) |
			((uint32_t)input[71] << 19) |
			((uint32_t)(input[72] & 0xe0) << 11);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 579 to 594
	value = ((uint32_t)(input[72] & 0x1f) << 27) |
			((uint32_t)input[73] << 19) |
			((uint32_t)(input[74] & 0xe0) << 11);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 595 to 610
	value = ((uint32_t)(input[74] & 0x1f) << 27) |
			((uint32_t)input[75] << 19) |
			((uint32_t)(input[76] & 0xe0) << 11);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 611 to 626
	value = ((uint32_t)(input[76] & 0x1f) << 27) |
			((uint32_t)input[77] << 19) |
			((uint32_t)(input[78] & 0xe0) << 11);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 627 to 642
	value = ((uint32_t)(input[78] & 0x1f) << 27) |
			((uint32_t)input[79] << 19) |
			((uint32_t)(input[80] & 0xe0) << 11);
	output[39] = (double)(value >> 16);

	// read output[40]: from bit 643 to 658
	value = ((uint32_t)(input[80] & 0x1f) << 27) |
			((uint32_t)input[81] << 19) |
			((uint32_t)(input[82] & 0xe0) << 11);
	output[40] = (double)(value >> 16);

	// read output[41]: from bit 659 to 674
	value = ((uint32_t)(input[82] & 0x1f) << 27) |
			((uint32_t)input[83] << 19) |
			((uint32_t)(input[84] & 0xe0) << 11);
	output[41] = (double)(value >> 16);

	// read output[42]: from bit 675 to 690
	value = ((uint32_t)(input[84] & 0x1f) << 27) |
			((uint32_t)input[85] << 19) |
			((uint32_t)(input[86] & 0xe0) << 11);
	output[42] = (double)(value >> 16);

	// read output[43]: from bit 691 to 706
	value = ((uint32_t)(input[86] & 0x1f) << 27) |
			((uint32_t)input[87] << 19) |
			((uint32_t)(input[88] & 0xe0) << 11);
	output[43] = (double)(value >> 16);

	// read output[44]: from bit 707 to 722
	value = ((uint32_t)(input[88] & 0x1f) << 27) |
			((uint32_t)input[89] << 19) |
			((uint32_t)(input[90] & 0xe0) << 11);
	output[44] = (double)(value >> 16);

	// read output[45]: from bit 723 to 738
	value = ((uint32_t)(input[90] & 0x1f) << 27) |
			((uint32_t)input[91] << 19) |
			((uint32_t)(input[92] & 0xe0) << 11);
	output[45] = (double)(value >> 16);

	// read output[46]: from bit 739 to 754
	value = ((uint32_t)(input[92] & 0x1f) << 27) |
			((uint32_t)input[93] << 19) |
			((uint32_t)(input[94] & 0xe0) << 11);
	output[46] = (double)(value >> 16);

	// read output[47]: from bit 755 to 770
	value = ((uint32_t)(input[94] & 0x1f) << 27) |
			((uint32_t)input[95] << 19) |
			((uint32_t)(input[96] & 0xe0) << 11);
	output[47] = (double)(value >> 16);

	// read output[48]: from bit 771 to 786
	value = ((uint32_t)(input[96] & 0x1f) << 27) |
			((uint32_t)input[97] << 19) |
			((uint32_t)(input[98] & 0xe0) << 11);
	output[48] = (double)(value >> 16);

	// read output[49]: from bit 787 to 802
	value = ((uint32_t)(input[98] & 0x1f) << 27) |
			((uint32_t)input[99] << 19) |
			((uint32_t)(input[100] & 0xe0) << 11);
	output[49] = (double)(value >> 16);

	// read output[50]: from bit 803 to 818
	value = ((uint32_t)(input[100] & 0x1f) << 27) |
			((uint32_t)input[101] << 19) |
			((uint32_t)(input[102] & 0xe0) << 11);
	output[50] = (double)(value >> 16);

	// read output[51]: from bit 819 to 834
	value = ((uint32_t)(input[102] & 0x1f) << 27) |
			((uint32_t)input[103] << 19) |
			((uint32_t)(input[104] & 0xe0) << 11);
	output[51] = (double)(value >> 16);

	// read output[52]: from bit 835 to 850
	value = ((uint32_t)(input[104] & 0x1f) << 27) |
			((uint32_t)input[105] << 19) |
			((uint32_t)(input[106] & 0xe0) << 11);
	output[52] = (double)(value >> 16);

	// read output[53]: from bit 851 to 866
	value = ((uint32_t)(input[106] & 0x1f) << 27) |
			((uint32_t)input[107] << 19) |
			((uint32_t)(input[108] & 0xe0) << 11);
	output[53] = (double)(value >> 16);

	// read output[54]: from bit 867 to 882
	value = ((uint32_t)(input[108] & 0x1f) << 27) |
			((uint32_t)input[109] << 19) |
			((uint32_t)(input[110] & 0xe0) << 11);
	output[54] = (double)(value >> 16);

	// read output[55]: from bit 883 to 898
	value = ((uint32_t)(input[110] & 0x1f) << 27) |
			((uint32_t)input[111] << 19) |
			((uint32_t)(input[112] & 0xe0) << 11);
	output[55] = (double)(value >> 16);

	// read output[56]: from bit 899 to 914
	value = ((uint32_t)(input[112] & 0x1f) << 27) |
			((uint32_t)input[113] << 19) |
			((uint32_t)(input[114] & 0xe0) << 11);
	output[56] = (double)(value >> 16);
}

static void unpack_57_16bit_signed_4off(const uint8_t * input, double * output, void *closure) {
	// Unpack 57 values into output
	// Values are 16-bit signed
	// Skip 4 bits, read 912 bits of data.
	// Input must be at least 115 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 4 to 19
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20) |
			((uint32_t)(input[2] & 0xf0) << 12);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 20 to 35
	value = ((uint32_t)(input[2] & 0x0f) << 28) |
			((uint32_t)input[3] << 20) |
			((uint32_t)(input[4] & 0xf0) << 12);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 36 to 51
	value = ((uint32_t)(input[4] & 0x0f) << 28) |
			((uint32_t)input[5] << 20) |
			((uint32_t)(input[6] & 0xf0) << 12);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 52 to 67
	value = ((uint32_t)(input[6] & 0x0f) << 28) |
			((uint32_t)input[7] << 20) |
			((uint32_t)(input[8] & 0xf0) << 12);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 68 to 83
	value = ((uint32_t)(input[8] & 0x0f) << 28) |
			((uint32_t)input[9] << 20) |
			((uint32_t)(input[10] & 0xf0) << 12);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 84 to 99
	value = ((uint32_t)(input[10] & 0x0f) << 28) |
			((uint32_t)input[11] << 20) |
			((uint32_t)(input[12] & 0xf0) << 12);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 100 to 115
	value = ((uint32_t)(input[12] & 0x0f) << 28) |
			((uint32_t)input[13] << 20) |
			((uint32_t)(input[14] & 0xf0) << 12);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 116 to 131
	value = ((uint32_t)(input[14] & 0x0f) << 28) |
			((uint32_t)input[15] << 20) |
			((uint32_t)(input[16] & 0xf0) << 12);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 132 to 147
	value = ((uint32_t)(input[16] & 0x0f) << 28) |
			((uint32_t)input[17] << 20) |
			((uint32_t)(input[18] & 0xf0) << 12);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 148 to 163
	value = ((uint32_t)(input[18] & 0x0f) << 28) |
			((uint32_t)input[19] << 20) |
			((uint32_t)(input[20] & 0xf0) << 12);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 164 to 179
	value = ((uint32_t)(input[20] & 0x0f) << 28) |
			((uint32_t)input[21] << 20) |
			((uint32_t)(input[22] & 0xf0) << 12);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 180 to 195
	value = ((uint32_t)(input[22] & 0x0f) << 28) |
			((uint32_t)input[23] << 20) |
			((uint32_t)(input[24] & 0xf0) << 12);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 196 to 211
	value = ((uint32_t)(input[24] & 0x0f) << 28) |
			((uint32_t)input[25] << 20) |
			((uint32_t)(input[26] & 0xf0) << 12);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 212 to 227
	value = ((uint32_t)(input[26] & 0x0f) << 28) |
			((uint32_t)input[27] << 20) |
			((uint32_t)(input[28] & 0xf0) << 12);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 228 to 243
	value = ((uint32_t)(input[28] & 0x0f) << 28) |
			((uint32_t)input[29] << 20) |
			((uint32_t)(input[30] & 0xf0) << 12);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 244 to 259
	value = ((uint32_t)(input[30] & 0x0f) << 28) |
			((uint32_t)input[31] << 20) |
			((uint32_t)(input[32] & 0xf0) << 12);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 260 to 275
	value = ((uint32_t)(input[32] & 0x0f) << 28) |
			((uint32_t)input[33] << 20) |
			((uint32_t)(input[34] & 0xf0) << 12);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 276 to 291
	value = ((uint32_t)(input[34] & 0x0f) << 28) |
			((uint32_t)input[35] << 20) |
			((uint32_t)(input[36] & 0xf0) << 12);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 292 to 307
	value = ((uint32_t)(input[36] & 0x0f) << 28) |
			((uint32_t)input[37] << 20) |
			((uint32_t)(input[38] & 0xf0) << 12);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 308 to 323
	value = ((uint32_t)(input[38] & 0x0f) << 28) |
			((uint32_t)input[39] << 20) |
			((uint32_t)(input[40] & 0xf0) << 12);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 324 to 339
	value = ((uint32_t)(input[40] & 0x0f) << 28) |
			((uint32_t)input[41] << 20) |
			((uint32_t)(input[42] & 0xf0) << 12);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 340 to 355
	value = ((uint32_t)(input[42] & 0x0f) << 28) |
			((uint32_t)input[43] << 20) |
			((uint32_t)(input[44] & 0xf0) << 12);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 356 to 371
	value = ((uint32_t)(input[44] & 0x0f) << 28) |
			((uint32_t)input[45] << 20) |
			((uint32_t)(input[46] & 0xf0) << 12);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 372 to 387
	value = ((uint32_t)(input[46] & 0x0f) << 28) |
			((uint32_t)input[47] << 20) |
			((uint32_t)(input[48] & 0xf0) << 12);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 388 to 403
	value = ((uint32_t)(input[48] & 0x0f) << 28) |
			((uint32_t)input[49] << 20) |
			((uint32_t)(input[50] & 0xf0) << 12);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 404 to 419
	value = ((uint32_t)(input[50] & 0x0f) << 28) |
			((uint32_t)input[51] << 20) |
			((uint32_t)(input[52] & 0xf0) << 12);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 420 to 435
	value = ((uint32_t)(input[52] & 0x0f) << 28) |
			((uint32_t)input[53] << 20) |
			((uint32_t)(input[54] & 0xf0) << 12);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 436 to 451
	value = ((uint32_t)(input[54] & 0x0f) << 28) |
			((uint32_t)input[55] << 20) |
			((uint32_t)(input[56] & 0xf0) << 12);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 452 to 467
	value = ((uint32_t)(input[56] & 0x0f) << 28) |
			((uint32_t)input[57] << 20) |
			((uint32_t)(input[58] & 0xf0) << 12);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 468 to 483
	value = ((uint32_t)(input[58] & 0x0f) << 28) |
			((uint32_t)input[59] << 20) |
			((uint32_t)(input[60] & 0xf0) << 12);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 484 to 499
	value = ((uint32_t)(input[60] & 0x0f) << 28) |
			((uint32_t)input[61] << 20) |
			((uint32_t)(input[62] & 0xf0) << 12);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 500 to 515
	value = ((uint32_t)(input[62] & 0x0f) << 28) |
			((uint32_t)input[63] << 20) |
			((uint32_t)(input[64] & 0xf0) << 12);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 516 to 531
	value = ((uint32_t)(input[64] & 0x0f) << 28) |
			((uint32_t)input[65] << 20) |
			((uint32_t)(input[66] & 0xf0) << 12);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 532 to 547
	value = ((uint32_t)(input[66] & 0x0f) << 28) |
			((uint32_t)input[67] << 20) |
			((uint32_t)(input[68] & 0xf0) << 12);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 548 to 563
	value = ((uint32_t)(input[68] & 0x0f) << 28) |
			((uint32_t)input[69] << 20) |
			((uint32_t)(input[70] & 0xf0) << 12);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 564 to 579
	value = ((uint32_t)(input[70] & 0x0f) << 28) |
			((uint32_t)input[71] << 20) |
			((uint32_t)(input[72] & 0xf0) << 12);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 580 to 595
	value = ((uint32_t)(input[72] & 0x0f) << 28) |
			((uint32_t)input[73] << 20) |
			((uint32_t)(input[74] & 0xf0) << 12);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 596 to 611
	value = ((uint32_t)(input[74] & 0x0f) << 28) |
			((uint32_t)input[75] << 20) |
			((uint32_t)(input[76] & 0xf0) << 12);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 612 to 627
	value = ((uint32_t)(input[76] & 0x0f) << 28) |
			((uint32_t)input[77] << 20) |
			((uint32_t)(input[78] & 0xf0) << 12);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 628 to 643
	value = ((uint32_t)(input[78] & 0x0f) << 28) |
			((uint32_t)input[79] << 20) |
			((uint32_t)(input[80] & 0xf0) << 12);
	output[39] = (double)(value >> 16);

	// read output[40]: from bit 644 to 659
	value = ((uint32_t)(input[80] & 0x0f) << 28) |
			((uint32_t)input[81] << 20) |
			((uint32_t)(input[82] & 0xf0) << 12);
	output[40] = (double)(value >> 16);

	// read output[41]: from bit 660 to 675
	value = ((uint32_t)(input[82] & 0x0f) << 28) |
			((uint32_t)input[83] << 20) |
			((uint32_t)(input[84] & 0xf0) << 12);
	output[41] = (double)(value >> 16);

	// read output[42]: from bit 676 to 691
	value = ((uint32_t)(input[84] & 0x0f) << 28) |
			((uint32_t)input[85] << 20) |
			((uint32_t)(input[86] & 0xf0) << 12);
	output[42] = (double)(value >> 16);

	// read output[43]: from bit 692 to 707
	value = ((uint32_t)(input[86] & 0x0f) << 28) |
			((uint32_t)input[87] << 20) |
			((uint32_t)(input[88] & 0xf0) << 12);
	output[43] = (double)(value >> 16);

	// read output[44]: from bit 708 to 723
	value = ((uint32_t)(input[88] & 0x0f) << 28) |
			((uint32_t)input[89] << 20) |
			((uint32_t)(input[90] & 0xf0) << 12);
	output[44] = (double)(value >> 16);

	// read output[45]: from bit 724 to 739
	value = ((uint32_t)(input[90] & 0x0f) << 28) |
			((uint32_t)input[91] << 20) |
			((uint32_t)(input[92] & 0xf0) << 12);
	output[45] = (double)(value >> 16);

	// read output[46]: from bit 740 to 755
	value = ((uint32_t)(input[92] & 0x0f) << 28) |
			((uint32_t)input[93] << 20) |
			((uint32_t)(input[94] & 0xf0) << 12);
	output[46] = (double)(value >> 16);

	// read output[47]: from bit 756 to 771
	value = ((uint32_t)(input[94] & 0x0f) << 28) |
			((uint32_t)input[95] << 20) |
			((uint32_t)(input[96] & 0xf0) << 12);
	output[47] = (double)(value >> 16);

	// read output[48]: from bit 772 to 787
	value = ((uint32_t)(input[96] & 0x0f) << 28) |
			((uint32_t)input[97] << 20) |
			((uint32_t)(input[98] & 0xf0) << 12);
	output[48] = (double)(value >> 16);

	// read output[49]: from bit 788 to 803
	value = ((uint32_t)(input[98] & 0x0f) << 28) |
			((uint32_t)input[99] << 20) |
			((uint32_t)(input[100] & 0xf0) << 12);
	output[49] = (double)(value >> 16);

	// read output[50]: from bit 804 to 819
	value = ((uint32_t)(input[100] & 0x0f) << 28) |
			((uint32_t)input[101] << 20) |
			((uint32_t)(input[102] & 0xf0) << 12);
	output[50] = (double)(value >> 16);

	// read output[51]: from bit 820 to 835
	value = ((uint32_t)(input[102] & 0x0f) << 28) |
			((uint32_t)input[103] << 20) |
			((uint32_t)(input[104] & 0xf0) << 12);
	output[51] = (double)(value >> 16);

	// read output[52]: from bit 836 to 851
	value = ((uint32_t)(input[104] & 0x0f) << 28) |
			((uint32_t)input[105] << 20) |
			((uint32_t)(input[106] & 0xf0) << 12);
	output[52] = (double)(value >> 16);

	// read output[53]: from bit 852 to 867
	value = ((uint32_t)(input[106] & 0x0f) << 28) |
			((uint32_t)input[107] << 20) |
			((uint32_t)(input[108] & 0xf0) << 12);
	output[53] = (double)(value >> 16);

	// read output[54]: from bit 868 to 883
	value = ((uint32_t)(input[108] & 0x0f) << 28) |
			((uint32_t)input[109] << 20) |
			((uint32_t)(input[110] & 0xf0) << 12);
	output[54] = (double)(value >> 16);

	// read output[55]: from bit 884 to 899
	value = ((uint32_t)(input[110] & 0x0f) << 28) |
			((uint32_t)input[111] << 20) |
			((uint32_t)(input[112] & 0xf0) << 12);
	output[55] = (double)(value >> 16);

	// read output[56]: from bit 900 to 915
	value = ((uint32_t)(input[112] & 0x0f) << 28) |
			((uint32_t)input[113] << 20) |
			((uint32_t)(input[114] & 0xf0) << 12);
	output[56] = (double)(value >> 16);
}

static void unpack_57_16bit_unsigned_4off(const uint8_t * input, double * output, void *closure) {
	// Unpack 57 values into output
	// Values are 16-bit unsigned
	// Skip 4 bits, read 912 bits of data.
	// Input must be at least 115 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 4 to 19
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20) |
			((uint32_t)(input[2] & 0xf0) << 12);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 20 to 35
	value = ((uint32_t)(input[2] & 0x0f) << 28) |
			((uint32_t)input[3] << 20) |
			((uint32_t)(input[4] & 0xf0) << 12);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 36 to 51
	value = ((uint32_t)(input[4] & 0x0f) << 28) |
			((uint32_t)input[5] << 20) |
			((uint32_t)(input[6] & 0xf0) << 12);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 52 to 67
	value = ((uint32_t)(input[6] & 0x0f) << 28) |
			((uint32_t)input[7] << 20) |
			((uint32_t)(input[8] & 0xf0) << 12);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 68 to 83
	value = ((uint32_t)(input[8] & 0x0f) << 28) |
			((uint32_t)input[9] << 20) |
			((uint32_t)(input[10] & 0xf0) << 12);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 84 to 99
	value = ((uint32_t)(input[10] & 0x0f) << 28) |
			((uint32_t)input[11] << 20) |
			((uint32_t)(input[12] & 0xf0) << 12);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 100 to 115
	value = ((uint32_t)(input[12] & 0x0f) << 28) |
			((uint32_t)input[13] << 20) |
			((uint32_t)(input[14] & 0xf0) << 12);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 116 to 131
	value = ((uint32_t)(input[14] & 0x0f) << 28) |
			((uint32_t)input[15] << 20) |
			((uint32_t)(input[16] & 0xf0) << 12);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 132 to 147
	value = ((uint32_t)(input[16] & 0x0f) << 28) |
			((uint32_t)input[17] << 20) |
			((uint32_t)(input[18] & 0xf0) << 12);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 148 to 163
	value = ((uint32_t)(input[18] & 0x0f) << 28) |
			((uint32_t)input[19] << 20) |
			((uint32_t)(input[20] & 0xf0) << 12);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 164 to 179
	value = ((uint32_t)(input[20] & 0x0f) << 28) |
			((uint32_t)input[21] << 20) |
			((uint32_t)(input[22] & 0xf0) << 12);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 180 to 195
	value = ((uint32_t)(input[22] & 0x0f) << 28) |
			((uint32_t)input[23] << 20) |
			((uint32_t)(input[24] & 0xf0) << 12);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 196 to 211
	value = ((uint32_t)(input[24] & 0x0f) << 28) |
			((uint32_t)input[25] << 20) |
			((uint32_t)(input[26] & 0xf0) << 12);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 212 to 227
	value = ((uint32_t)(input[26] & 0x0f) << 28) |
			((uint32_t)input[27] << 20) |
			((uint32_t)(input[28] & 0xf0) << 12);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 228 to 243
	value = ((uint32_t)(input[28] & 0x0f) << 28) |
			((uint32_t)input[29] << 20) |
			((uint32_t)(input[30] & 0xf0) << 12);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 244 to 259
	value = ((uint32_t)(input[30] & 0x0f) << 28) |
			((uint32_t)input[31] << 20) |
			((uint32_t)(input[32] & 0xf0) << 12);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 260 to 275
	value = ((uint32_t)(input[32] & 0x0f) << 28) |
			((uint32_t)input[33] << 20) |
			((uint32_t)(input[34] & 0xf0) << 12);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 276 to 291
	value = ((uint32_t)(input[34] & 0x0f) << 28) |
			((uint32_t)input[35] << 20) |
			((uint32_t)(input[36] & 0xf0) << 12);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 292 to 307
	value = ((uint32_t)(input[36] & 0x0f) << 28) |
			((uint32_t)input[37] << 20) |
			((uint32_t)(input[38] & 0xf0) << 12);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 308 to 323
	value = ((uint32_t)(input[38] & 0x0f) << 28) |
			((uint32_t)input[39] << 20) |
			((uint32_t)(input[40] & 0xf0) << 12);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 324 to 339
	value = ((uint32_t)(input[40] & 0x0f) << 28) |
			((uint32_t)input[41] << 20) |
			((uint32_t)(input[42] & 0xf0) << 12);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 340 to 355
	value = ((uint32_t)(input[42] & 0x0f) << 28) |
			((uint32_t)input[43] << 20) |
			((uint32_t)(input[44] & 0xf0) << 12);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 356 to 371
	value = ((uint32_t)(input[44] & 0x0f) << 28) |
			((uint32_t)input[45] << 20) |
			((uint32_t)(input[46] & 0xf0) << 12);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 372 to 387
	value = ((uint32_t)(input[46] & 0x0f) << 28) |
			((uint32_t)input[47] << 20) |
			((uint32_t)(input[48] & 0xf0) << 12);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 388 to 403
	value = ((uint32_t)(input[48] & 0x0f) << 28) |
			((uint32_t)input[49] << 20) |
			((uint32_t)(input[50] & 0xf0) << 12);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 404 to 419
	value = ((uint32_t)(input[50] & 0x0f) << 28) |
			((uint32_t)input[51] << 20) |
			((uint32_t)(input[52] & 0xf0) << 12);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 420 to 435
	value = ((uint32_t)(input[52] & 0x0f) << 28) |
			((uint32_t)input[53] << 20) |
			((uint32_t)(input[54] & 0xf0) << 12);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 436 to 451
	value = ((uint32_t)(input[54] & 0x0f) << 28) |
			((uint32_t)input[55] << 20) |
			((uint32_t)(input[56] & 0xf0) << 12);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 452 to 467
	value = ((uint32_t)(input[56] & 0x0f) << 28) |
			((uint32_t)input[57] << 20) |
			((uint32_t)(input[58] & 0xf0) << 12);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 468 to 483
	value = ((uint32_t)(input[58] & 0x0f) << 28) |
			((uint32_t)input[59] << 20) |
			((uint32_t)(input[60] & 0xf0) << 12);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 484 to 499
	value = ((uint32_t)(input[60] & 0x0f) << 28) |
			((uint32_t)input[61] << 20) |
			((uint32_t)(input[62] & 0xf0) << 12);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 500 to 515
	value = ((uint32_t)(input[62] & 0x0f) << 28) |
			((uint32_t)input[63] << 20) |
			((uint32_t)(input[64] & 0xf0) << 12);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 516 to 531
	value = ((uint32_t)(input[64] & 0x0f) << 28) |
			((uint32_t)input[65] << 20) |
			((uint32_t)(input[66] & 0xf0) << 12);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 532 to 547
	value = ((uint32_t)(input[66] & 0x0f) << 28) |
			((uint32_t)input[67] << 20) |
			((uint32_t)(input[68] & 0xf0) << 12);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 548 to 563
	value = ((uint32_t)(input[68] & 0x0f) << 28) |
			((uint32_t)input[69] << 20) |
			((uint32_t)(input[70] & 0xf0) << 12);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 564 to 579
	value = ((uint32_t)(input[70] & 0x0f) << 28) |
			((uint32_t)input[71] << 20) |
			((uint32_t)(input[72] & 0xf0) << 12);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 580 to 595
	value = ((uint32_t)(input[72] & 0x0f) << 28) |
			((uint32_t)input[73] << 20) |
			((uint32_t)(input[74] & 0xf0) << 12);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 596 to 611
	value = ((uint32_t)(input[74] & 0x0f) << 28) |
			((uint32_t)input[75] << 20) |
			((uint32_t)(input[76] & 0xf0) << 12);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 612 to 627
	value = ((uint32_t)(input[76] & 0x0f) << 28) |
			((uint32_t)input[77] << 20) |
			((uint32_t)(input[78] & 0xf0) << 12);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 628 to 643
	value = ((uint32_t)(input[78] & 0x0f) << 28) |
			((uint32_t)input[79] << 20) |
			((uint32_t)(input[80] & 0xf0) << 12);
	output[39] = (double)(value >> 16);

	// read output[40]: from bit 644 to 659
	value = ((uint32_t)(input[80] & 0x0f) << 28) |
			((uint32_t)input[81] << 20) |
			((uint32_t)(input[82] & 0xf0) << 12);
	output[40] = (double)(value >> 16);

	// read output[41]: from bit 660 to 675
	value = ((uint32_t)(input[82] & 0x0f) << 28) |
			((uint32_t)input[83] << 20) |
			((uint32_t)(input[84] & 0xf0) << 12);
	output[41] = (double)(value >> 16);

	// read output[42]: from bit 676 to 691
	value = ((uint32_t)(input[84] & 0x0f) << 28) |
			((uint32_t)input[85] << 20) |
			((uint32_t)(input[86] & 0xf0) << 12);
	output[42] = (double)(value >> 16);

	// read output[43]: from bit 692 to 707
	value = ((uint32_t)(input[86] & 0x0f) << 28) |
			((uint32_t)input[87] << 20) |
			((uint32_t)(input[88] & 0xf0) << 12);
	output[43] = (double)(value >> 16);

	// read output[44]: from bit 708 to 723
	value = ((uint32_t)(input[88] & 0x0f) << 28) |
			((uint32_t)input[89] << 20) |
			((uint32_t)(input[90] & 0xf0) << 12);
	output[44] = (double)(value >> 16);

	// read output[45]: from bit 724 to 739
	value = ((uint32_t)(input[90] & 0x0f) << 28) |
			((uint32_t)input[91] << 20) |
			((uint32_t)(input[92] & 0xf0) << 12);
	output[45] = (double)(value >> 16);

	// read output[46]: from bit 740 to 755
	value = ((uint32_t)(input[92] & 0x0f) << 28) |
			((uint32_t)input[93] << 20) |
			((uint32_t)(input[94] & 0xf0) << 12);
	output[46] = (double)(value >> 16);

	// read output[47]: from bit 756 to 771
	value = ((uint32_t)(input[94] & 0x0f) << 28) |
			((uint32_t)input[95] << 20) |
			((uint32_t)(input[96] & 0xf0) << 12);
	output[47] = (double)(value >> 16);

	// read output[48]: from bit 772 to 787
	value = ((uint32_t)(input[96] & 0x0f) << 28) |
			((uint32_t)input[97] << 20) |
			((uint32_t)(input[98] & 0xf0) << 12);
	output[48] = (double)(value >> 16);

	// read output[49]: from bit 788 to 803
	value = ((uint32_t)(input[98] & 0x0f) << 28) |
			((uint32_t)input[99] << 20) |
			((uint32_t)(input[100] & 0xf0) << 12);
	output[49] = (double)(value >> 16);

	// read output[50]: from bit 804 to 819
	value = ((uint32_t)(input[100] & 0x0f) << 28) |
			((uint32_t)input[101] << 20) |
			((uint32_t)(input[102] & 0xf0) << 12);
	output[50] = (double)(value >> 16);

	// read output[51]: from bit 820 to 835
	value = ((uint32_t)(input[102] & 0x0f) << 28) |
			((uint32_t)input[103] << 20) |
			((uint32_t)(input[104] & 0xf0) << 12);
	output[51] = (double)(value >> 16);

	// read output[52]: from bit 836 to 851
	value = ((uint32_t)(input[104] & 0x0f) << 28) |
			((uint32_t)input[105] << 20) |
			((uint32_t)(input[106] & 0xf0) << 12);
	output[52] = (double)(value >> 16);

	// read output[53]: from bit 852 to 867
	value = ((uint32_t)(input[106] & 0x0f) << 28) |
			((uint32_t)input[107] << 20) |
			((uint32_t)(input[108] & 0xf0) << 12);
	output[53] = (double)(value >> 16);

	// read output[54]: from bit 868 to 883
	value = ((uint32_t)(input[108] & 0x0f) << 28) |
			((uint32_t)input[109] << 20) |
			((uint32_t)(input[110] & 0xf0) << 12);
	output[54] = (double)(value >> 16);

	// read output[55]: from bit 884 to 899
	value = ((uint32_t)(input[110] & 0x0f) << 28) |
			((uint32_t)input[111] << 20) |
			((uint32_t)(input[112] & 0xf0) << 12);
	output[55] = (double)(value >> 16);

	// read output[56]: from bit 900 to 915
	value = ((uint32_t)(input[112] & 0x0f) << 28) |
			((uint32_t)input[113] << 20) |
			((uint32_t)(input[114] & 0xf0) << 12);
	output[56] = (double)(value >> 16);
}

static void unpack_57_16bit_signed_5off(const uint8_t * input, double * output, void *closure) {
	// Unpack 57 values into output
	// Values are 16-bit signed
	// Skip 5 bits, read 912 bits of data.
	// Input must be at least 115 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 5 to 20
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)(input[2] & 0xf8) << 13);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 21 to 36
	value = ((uint32_t)(input[2] & 0x07) << 29) |
			((uint32_t)input[3] << 21) |
			((uint32_t)(input[4] & 0xf8) << 13);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 37 to 52
	value = ((uint32_t)(input[4] & 0x07) << 29) |
			((uint32_t)input[5] << 21) |
			((uint32_t)(input[6] & 0xf8) << 13);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 53 to 68
	value = ((uint32_t)(input[6] & 0x07) << 29) |
			((uint32_t)input[7] << 21) |
			((uint32_t)(input[8] & 0xf8) << 13);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 69 to 84
	value = ((uint32_t)(input[8] & 0x07) << 29) |
			((uint32_t)input[9] << 21) |
			((uint32_t)(input[10] & 0xf8) << 13);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 85 to 100
	value = ((uint32_t)(input[10] & 0x07) << 29) |
			((uint32_t)input[11] << 21) |
			((uint32_t)(input[12] & 0xf8) << 13);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 101 to 116
	value = ((uint32_t)(input[12] & 0x07) << 29) |
			((uint32_t)input[13] << 21) |
			((uint32_t)(input[14] & 0xf8) << 13);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 117 to 132
	value = ((uint32_t)(input[14] & 0x07) << 29) |
			((uint32_t)input[15] << 21) |
			((uint32_t)(input[16] & 0xf8) << 13);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 133 to 148
	value = ((uint32_t)(input[16] & 0x07) << 29) |
			((uint32_t)input[17] << 21) |
			((uint32_t)(input[18] & 0xf8) << 13);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 149 to 164
	value = ((uint32_t)(input[18] & 0x07) << 29) |
			((uint32_t)input[19] << 21) |
			((uint32_t)(input[20] & 0xf8) << 13);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 165 to 180
	value = ((uint32_t)(input[20] & 0x07) << 29) |
			((uint32_t)input[21] << 21) |
			((uint32_t)(input[22] & 0xf8) << 13);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 181 to 196
	value = ((uint32_t)(input[22] & 0x07) << 29) |
			((uint32_t)input[23] << 21) |
			((uint32_t)(input[24] & 0xf8) << 13);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 197 to 212
	value = ((uint32_t)(input[24] & 0x07) << 29) |
			((uint32_t)input[25] << 21) |
			((uint32_t)(input[26] & 0xf8) << 13);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 213 to 228
	value = ((uint32_t)(input[26] & 0x07) << 29) |
			((uint32_t)input[27] << 21) |
			((uint32_t)(input[28] & 0xf8) << 13);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 229 to 244
	value = ((uint32_t)(input[28] & 0x07) << 29) |
			((uint32_t)input[29] << 21) |
			((uint32_t)(input[30] & 0xf8) << 13);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 245 to 260
	value = ((uint32_t)(input[30] & 0x07) << 29) |
			((uint32_t)input[31] << 21) |
			((uint32_t)(input[32] & 0xf8) << 13);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 261 to 276
	value = ((uint32_t)(input[32] & 0x07) << 29) |
			((uint32_t)input[33] << 21) |
			((uint32_t)(input[34] & 0xf8) << 13);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 277 to 292
	value = ((uint32_t)(input[34] & 0x07) << 29) |
			((uint32_t)input[35] << 21) |
			((uint32_t)(input[36] & 0xf8) << 13);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 293 to 308
	value = ((uint32_t)(input[36] & 0x07) << 29) |
			((uint32_t)input[37] << 21) |
			((uint32_t)(input[38] & 0xf8) << 13);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 309 to 324
	value = ((uint32_t)(input[38] & 0x07) << 29) |
			((uint32_t)input[39] << 21) |
			((uint32_t)(input[40] & 0xf8) << 13);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 325 to 340
	value = ((uint32_t)(input[40] & 0x07) << 29) |
			((uint32_t)input[41] << 21) |
			((uint32_t)(input[42] & 0xf8) << 13);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 341 to 356
	value = ((uint32_t)(input[42] & 0x07) << 29) |
			((uint32_t)input[43] << 21) |
			((uint32_t)(input[44] & 0xf8) << 13);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 357 to 372
	value = ((uint32_t)(input[44] & 0x07) << 29) |
			((uint32_t)input[45] << 21) |
			((uint32_t)(input[46] & 0xf8) << 13);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 373 to 388
	value = ((uint32_t)(input[46] & 0x07) << 29) |
			((uint32_t)input[47] << 21) |
			((uint32_t)(input[48] & 0xf8) << 13);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 389 to 404
	value = ((uint32_t)(input[48] & 0x07) << 29) |
			((uint32_t)input[49] << 21) |
			((uint32_t)(input[50] & 0xf8) << 13);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 405 to 420
	value = ((uint32_t)(input[50] & 0x07) << 29) |
			((uint32_t)input[51] << 21) |
			((uint32_t)(input[52] & 0xf8) << 13);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 421 to 436
	value = ((uint32_t)(input[52] & 0x07) << 29) |
			((uint32_t)input[53] << 21) |
			((uint32_t)(input[54] & 0xf8) << 13);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 437 to 452
	value = ((uint32_t)(input[54] & 0x07) << 29) |
			((uint32_t)input[55] << 21) |
			((uint32_t)(input[56] & 0xf8) << 13);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 453 to 468
	value = ((uint32_t)(input[56] & 0x07) << 29) |
			((uint32_t)input[57] << 21) |
			((uint32_t)(input[58] & 0xf8) << 13);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 469 to 484
	value = ((uint32_t)(input[58] & 0x07) << 29) |
			((uint32_t)input[59] << 21) |
			((uint32_t)(input[60] & 0xf8) << 13);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 485 to 500
	value = ((uint32_t)(input[60] & 0x07) << 29) |
			((uint32_t)input[61] << 21) |
			((uint32_t)(input[62] & 0xf8) << 13);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 501 to 516
	value = ((uint32_t)(input[62] & 0x07) << 29) |
			((uint32_t)input[63] << 21) |
			((uint32_t)(input[64] & 0xf8) << 13);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 517 to 532
	value = ((uint32_t)(input[64] & 0x07) << 29) |
			((uint32_t)input[65] << 21) |
			((uint32_t)(input[66] & 0xf8) << 13);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 533 to 548
	value = ((uint32_t)(input[66] & 0x07) << 29) |
			((uint32_t)input[67] << 21) |
			((uint32_t)(input[68] & 0xf8) << 13);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 549 to 564
	value = ((uint32_t)(input[68] & 0x07) << 29) |
			((uint32_t)input[69] << 21) |
			((uint32_t)(input[70] & 0xf8) << 13);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 565 to 580
	value = ((uint32_t)(input[70] & 0x07) << 29) |
			((uint32_t)input[71] << 21) |
			((uint32_t)(input[72] & 0xf8) << 13);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 581 to 596
	value = ((uint32_t)(input[72] & 0x07) << 29) |
			((uint32_t)input[73] << 21) |
			((uint32_t)(input[74] & 0xf8) << 13);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 597 to 612
	value = ((uint32_t)(input[74] & 0x07) << 29) |
			((uint32_t)input[75] << 21) |
			((uint32_t)(input[76] & 0xf8) << 13);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 613 to 628
	value = ((uint32_t)(input[76] & 0x07) << 29) |
			((uint32_t)input[77] << 21) |
			((uint32_t)(input[78] & 0xf8) << 13);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 629 to 644
	value = ((uint32_t)(input[78] & 0x07) << 29) |
			((uint32_t)input[79] << 21) |
			((uint32_t)(input[80] & 0xf8) << 13);
	output[39] = (double)(value >> 16);

	// read output[40]: from bit 645 to 660
	value = ((uint32_t)(input[80] & 0x07) << 29) |
			((uint32_t)input[81] << 21) |
			((uint32_t)(input[82] & 0xf8) << 13);
	output[40] = (double)(value >> 16);

	// read output[41]: from bit 661 to 676
	value = ((uint32_t)(input[82] & 0x07) << 29) |
			((uint32_t)input[83] << 21) |
			((uint32_t)(input[84] & 0xf8) << 13);
	output[41] = (double)(value >> 16);

	// read output[42]: from bit 677 to 692
	value = ((uint32_t)(input[84] & 0x07) << 29) |
			((uint32_t)input[85] << 21) |
			((uint32_t)(input[86] & 0xf8) << 13);
	output[42] = (double)(value >> 16);

	// read output[43]: from bit 693 to 708
	value = ((uint32_t)(input[86] & 0x07) << 29) |
			((uint32_t)input[87] << 21) |
			((uint32_t)(input[88] & 0xf8) << 13);
	output[43] = (double)(value >> 16);

	// read output[44]: from bit 709 to 724
	value = ((uint32_t)(input[88] & 0x07) << 29) |
			((uint32_t)input[89] << 21) |
			((uint32_t)(input[90] & 0xf8) << 13);
	output[44] = (double)(value >> 16);

	// read output[45]: from bit 725 to 740
	value = ((uint32_t)(input[90] & 0x07) << 29) |
			((uint32_t)input[91] << 21) |
			((uint32_t)(input[92] & 0xf8) << 13);
	output[45] = (double)(value >> 16);

	// read output[46]: from bit 741 to 756
	value = ((uint32_t)(input[92] & 0x07) << 29) |
			((uint32_t)input[93] << 21) |
			((uint32_t)(input[94] & 0xf8) << 13);
	output[46] = (double)(value >> 16);

	// read output[47]: from bit 757 to 772
	value = ((uint32_t)(input[94] & 0x07) << 29) |
			((uint32_t)input[95] << 21) |
			((uint32_t)(input[96] & 0xf8) << 13);
	output[47] = (double)(value >> 16);

	// read output[48]: from bit 773 to 788
	value = ((uint32_t)(input[96] & 0x07) << 29) |
			((uint32_t)input[97] << 21) |
			((uint32_t)(input[98] & 0xf8) << 13);
	output[48] = (double)(value >> 16);

	// read output[49]: from bit 789 to 804
	value = ((uint32_t)(input[98] & 0x07) << 29) |
			((uint32_t)input[99] << 21) |
			((uint32_t)(input[100] & 0xf8) << 13);
	output[49] = (double)(value >> 16);

	// read output[50]: from bit 805 to 820
	value = ((uint32_t)(input[100] & 0x07) << 29) |
			((uint32_t)input[101] << 21) |
			((uint32_t)(input[102] & 0xf8) << 13);
	output[50] = (double)(value >> 16);

	// read output[51]: from bit 821 to 836
	value = ((uint32_t)(input[102] & 0x07) << 29) |
			((uint32_t)input[103] << 21) |
			((uint32_t)(input[104] & 0xf8) << 13);
	output[51] = (double)(value >> 16);

	// read output[52]: from bit 837 to 852
	value = ((uint32_t)(input[104] & 0x07) << 29) |
			((uint32_t)input[105] << 21) |
			((uint32_t)(input[106] & 0xf8) << 13);
	output[52] = (double)(value >> 16);

	// read output[53]: from bit 853 to 868
	value = ((uint32_t)(input[106] & 0x07) << 29) |
			((uint32_t)input[107] << 21) |
			((uint32_t)(input[108] & 0xf8) << 13);
	output[53] = (double)(value >> 16);

	// read output[54]: from bit 869 to 884
	value = ((uint32_t)(input[108] & 0x07) << 29) |
			((uint32_t)input[109] << 21) |
			((uint32_t)(input[110] & 0xf8) << 13);
	output[54] = (double)(value >> 16);

	// read output[55]: from bit 885 to 900
	value = ((uint32_t)(input[110] & 0x07) << 29) |
			((uint32_t)input[111] << 21) |
			((uint32_t)(input[112] & 0xf8) << 13);
	output[55] = (double)(value >> 16);

	// read output[56]: from bit 901 to 916
	value = ((uint32_t)(input[112] & 0x07) << 29) |
			((uint32_t)input[113] << 21) |
			((uint32_t)(input[114] & 0xf8) << 13);
	output[56] = (double)(value >> 16);
}

static void unpack_57_16bit_unsigned_5off(const uint8_t * input, double * output, void *closure) {
	// Unpack 57 values into output
	// Values are 16-bit unsigned
	// Skip 5 bits, read 912 bits of data.
	// Input must be at least 115 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 5 to 20
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)(input[2] & 0xf8) << 13);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 21 to 36
	value = ((uint32_t)(input[2] & 0x07) << 29) |
			((uint32_t)input[3] << 21) |
			((uint32_t)(input[4] & 0xf8) << 13);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 37 to 52
	value = ((uint32_t)(input[4] & 0x07) << 29) |
			((uint32_t)input[5] << 21) |
			((uint32_t)(input[6] & 0xf8) << 13);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 53 to 68
	value = ((uint32_t)(input[6] & 0x07) << 29) |
			((uint32_t)input[7] << 21) |
			((uint32_t)(input[8] & 0xf8) << 13);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 69 to 84
	value = ((uint32_t)(input[8] & 0x07) << 29) |
			((uint32_t)input[9] << 21) |
			((uint32_t)(input[10] & 0xf8) << 13);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 85 to 100
	value = ((uint32_t)(input[10] & 0x07) << 29) |
			((uint32_t)input[11] << 21) |
			((uint32_t)(input[12] & 0xf8) << 13);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 101 to 116
	value = ((uint32_t)(input[12] & 0x07) << 29) |
			((uint32_t)input[13] << 21) |
			((uint32_t)(input[14] & 0xf8) << 13);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 117 to 132
	value = ((uint32_t)(input[14] & 0x07) << 29) |
			((uint32_t)input[15] << 21) |
			((uint32_t)(input[16] & 0xf8) << 13);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 133 to 148
	value = ((uint32_t)(input[16] & 0x07) << 29) |
			((uint32_t)input[17] << 21) |
			((uint32_t)(input[18] & 0xf8) << 13);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 149 to 164
	value = ((uint32_t)(input[18] & 0x07) << 29) |
			((uint32_t)input[19] << 21) |
			((uint32_t)(input[20] & 0xf8) << 13);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 165 to 180
	value = ((uint32_t)(input[20] & 0x07) << 29) |
			((uint32_t)input[21] << 21) |
			((uint32_t)(input[22] & 0xf8) << 13);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 181 to 196
	value = ((uint32_t)(input[22] & 0x07) << 29) |
			((uint32_t)input[23] << 21) |
			((uint32_t)(input[24] & 0xf8) << 13);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 197 to 212
	value = ((uint32_t)(input[24] & 0x07) << 29) |
			((uint32_t)input[25] << 21) |
			((uint32_t)(input[26] & 0xf8) << 13);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 213 to 228
	value = ((uint32_t)(input[26] & 0x07) << 29) |
			((uint32_t)input[27] << 21) |
			((uint32_t)(input[28] & 0xf8) << 13);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 229 to 244
	value = ((uint32_t)(input[28] & 0x07) << 29) |
			((uint32_t)input[29] << 21) |
			((uint32_t)(input[30] & 0xf8) << 13);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 245 to 260
	value = ((uint32_t)(input[30] & 0x07) << 29) |
			((uint32_t)input[31] << 21) |
			((uint32_t)(input[32] & 0xf8) << 13);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 261 to 276
	value = ((uint32_t)(input[32] & 0x07) << 29) |
			((uint32_t)input[33] << 21) |
			((uint32_t)(input[34] & 0xf8) << 13);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 277 to 292
	value = ((uint32_t)(input[34] & 0x07) << 29) |
			((uint32_t)input[35] << 21) |
			((uint32_t)(input[36] & 0xf8) << 13);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 293 to 308
	value = ((uint32_t)(input[36] & 0x07) << 29) |
			((uint32_t)input[37] << 21) |
			((uint32_t)(input[38] & 0xf8) << 13);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 309 to 324
	value = ((uint32_t)(input[38] & 0x07) << 29) |
			((uint32_t)input[39] << 21) |
			((uint32_t)(input[40] & 0xf8) << 13);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 325 to 340
	value = ((uint32_t)(input[40] & 0x07) << 29) |
			((uint32_t)input[41] << 21) |
			((uint32_t)(input[42] & 0xf8) << 13);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 341 to 356
	value = ((uint32_t)(input[42] & 0x07) << 29) |
			((uint32_t)input[43] << 21) |
			((uint32_t)(input[44] & 0xf8) << 13);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 357 to 372
	value = ((uint32_t)(input[44] & 0x07) << 29) |
			((uint32_t)input[45] << 21) |
			((uint32_t)(input[46] & 0xf8) << 13);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 373 to 388
	value = ((uint32_t)(input[46] & 0x07) << 29) |
			((uint32_t)input[47] << 21) |
			((uint32_t)(input[48] & 0xf8) << 13);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 389 to 404
	value = ((uint32_t)(input[48] & 0x07) << 29) |
			((uint32_t)input[49] << 21) |
			((uint32_t)(input[50] & 0xf8) << 13);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 405 to 420
	value = ((uint32_t)(input[50] & 0x07) << 29) |
			((uint32_t)input[51] << 21) |
			((uint32_t)(input[52] & 0xf8) << 13);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 421 to 436
	value = ((uint32_t)(input[52] & 0x07) << 29) |
			((uint32_t)input[53] << 21) |
			((uint32_t)(input[54] & 0xf8) << 13);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 437 to 452
	value = ((uint32_t)(input[54] & 0x07) << 29) |
			((uint32_t)input[55] << 21) |
			((uint32_t)(input[56] & 0xf8) << 13);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 453 to 468
	value = ((uint32_t)(input[56] & 0x07) << 29) |
			((uint32_t)input[57] << 21) |
			((uint32_t)(input[58] & 0xf8) << 13);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 469 to 484
	value = ((uint32_t)(input[58] & 0x07) << 29) |
			((uint32_t)input[59] << 21) |
			((uint32_t)(input[60] & 0xf8) << 13);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 485 to 500
	value = ((uint32_t)(input[60] & 0x07) << 29) |
			((uint32_t)input[61] << 21) |
			((uint32_t)(input[62] & 0xf8) << 13);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 501 to 516
	value = ((uint32_t)(input[62] & 0x07) << 29) |
			((uint32_t)input[63] << 21) |
			((uint32_t)(input[64] & 0xf8) << 13);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 517 to 532
	value = ((uint32_t)(input[64] & 0x07) << 29) |
			((uint32_t)input[65] << 21) |
			((uint32_t)(input[66] & 0xf8) << 13);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 533 to 548
	value = ((uint32_t)(input[66] & 0x07) << 29) |
			((uint32_t)input[67] << 21) |
			((uint32_t)(input[68] & 0xf8) << 13);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 549 to 564
	value = ((uint32_t)(input[68] & 0x07) << 29) |
			((uint32_t)input[69] << 21) |
			((uint32_t)(input[70] & 0xf8) << 13);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 565 to 580
	value = ((uint32_t)(input[70] & 0x07) << 29) |
			((uint32_t)input[71] << 21) |
			((uint32_t)(input[72] & 0xf8) << 13);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 581 to 596
	value = ((uint32_t)(input[72] & 0x07) << 29) |
			((uint32_t)input[73] << 21) |
			((uint32_t)(input[74] & 0xf8) << 13);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 597 to 612
	value = ((uint32_t)(input[74] & 0x07) << 29) |
			((uint32_t)input[75] << 21) |
			((uint32_t)(input[76] & 0xf8) << 13);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 613 to 628
	value = ((uint32_t)(input[76] & 0x07) << 29) |
			((uint32_t)input[77] << 21) |
			((uint32_t)(input[78] & 0xf8) << 13);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 629 to 644
	value = ((uint32_t)(input[78] & 0x07) << 29) |
			((uint32_t)input[79] << 21) |
			((uint32_t)(input[80] & 0xf8) << 13);
	output[39] = (double)(value >> 16);

	// read output[40]: from bit 645 to 660
	value = ((uint32_t)(input[80] & 0x07) << 29) |
			((uint32_t)input[81] << 21) |
			((uint32_t)(input[82] & 0xf8) << 13);
	output[40] = (double)(value >> 16);

	// read output[41]: from bit 661 to 676
	value = ((uint32_t)(input[82] & 0x07) << 29) |
			((uint32_t)input[83] << 21) |
			((uint32_t)(input[84] & 0xf8) << 13);
	output[41] = (double)(value >> 16);

	// read output[42]: from bit 677 to 692
	value = ((uint32_t)(input[84] & 0x07) << 29) |
			((uint32_t)input[85] << 21) |
			((uint32_t)(input[86] & 0xf8) << 13);
	output[42] = (double)(value >> 16);

	// read output[43]: from bit 693 to 708
	value = ((uint32_t)(input[86] & 0x07) << 29) |
			((uint32_t)input[87] << 21) |
			((uint32_t)(input[88] & 0xf8) << 13);
	output[43] = (double)(value >> 16);

	// read output[44]: from bit 709 to 724
	value = ((uint32_t)(input[88] & 0x07) << 29) |
			((uint32_t)input[89] << 21) |
			((uint32_t)(input[90] & 0xf8) << 13);
	output[44] = (double)(value >> 16);

	// read output[45]: from bit 725 to 740
	value = ((uint32_t)(input[90] & 0x07) << 29) |
			((uint32_t)input[91] << 21) |
			((uint32_t)(input[92] & 0xf8) << 13);
	output[45] = (double)(value >> 16);

	// read output[46]: from bit 741 to 756
	value = ((uint32_t)(input[92] & 0x07) << 29) |
			((uint32_t)input[93] << 21) |
			((uint32_t)(input[94] & 0xf8) << 13);
	output[46] = (double)(value >> 16);

	// read output[47]: from bit 757 to 772
	value = ((uint32_t)(input[94] & 0x07) << 29) |
			((uint32_t)input[95] << 21) |
			((uint32_t)(input[96] & 0xf8) << 13);
	output[47] = (double)(value >> 16);

	// read output[48]: from bit 773 to 788
	value = ((uint32_t)(input[96] & 0x07) << 29) |
			((uint32_t)input[97] << 21) |
			((uint32_t)(input[98] & 0xf8) << 13);
	output[48] = (double)(value >> 16);

	// read output[49]: from bit 789 to 804
	value = ((uint32_t)(input[98] & 0x07) << 29) |
			((uint32_t)input[99] << 21) |
			((uint32_t)(input[100] & 0xf8) << 13);
	output[49] = (double)(value >> 16);

	// read output[50]: from bit 805 to 820
	value = ((uint32_t)(input[100] & 0x07) << 29) |
			((uint32_t)input[101] << 21) |
			((uint32_t)(input[102] & 0xf8) << 13);
	output[50] = (double)(value >> 16);

	// read output[51]: from bit 821 to 836
	value = ((uint32_t)(input[102] & 0x07) << 29) |
			((uint32_t)input[103] << 21) |
			((uint32_t)(input[104] & 0xf8) << 13);
	output[51] = (double)(value >> 16);

	// read output[52]: from bit 837 to 852
	value = ((uint32_t)(input[104] & 0x07) << 29) |
			((uint32_t)input[105] << 21) |
			((uint32_t)(input[106] & 0xf8) << 13);
	output[52] = (double)(value >> 16);

	// read output[53]: from bit 853 to 868
	value = ((uint32_t)(input[106] & 0x07) << 29) |
			((uint32_t)input[107] << 21) |
			((uint32_t)(input[108] & 0xf8) << 13);
	output[53] = (double)(value >> 16);

	// read output[54]: from bit 869 to 884
	value = ((uint32_t)(input[108] & 0x07) << 29) |
			((uint32_t)input[109] << 21) |
			((uint32_t)(input[110] & 0xf8) << 13);
	output[54] = (double)(value >> 16);

	// read output[55]: from bit 885 to 900
	value = ((uint32_t)(input[110] & 0x07) << 29) |
			((uint32_t)input[111] << 21) |
			((uint32_t)(input[112] & 0xf8) << 13);
	output[55] = (double)(value >> 16);

	// read output[56]: from bit 901 to 916
	value = ((uint32_t)(input[112] & 0x07) << 29) |
			((uint32_t)input[113] << 21) |
			((uint32_t)(input[114] & 0xf8) << 13);
	output[56] = (double)(value >> 16);
}

static void unpack_57_16bit_signed_6off(const uint8_t * input, double * output, void *closure) {
	// Unpack 57 values into output
	// Values are 16-bit signed
	// Skip 6 bits, read 912 bits of data.
	// Input must be at least 115 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 6 to 21
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)(input[2] & 0xfc) << 14);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 22 to 37
	value = ((uint32_t)(input[2] & 0x03) << 30) |
			((uint32_t)input[3] << 22) |
			((uint32_t)(input[4] & 0xfc) << 14);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 38 to 53
	value = ((uint32_t)(input[4] & 0x03) << 30) |
			((uint32_t)input[5] << 22) |
			((uint32_t)(input[6] & 0xfc) << 14);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 54 to 69
	value = ((uint32_t)(input[6] & 0x03) << 30) |
			((uint32_t)input[7] << 22) |
			((uint32_t)(input[8] & 0xfc) << 14);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 70 to 85
	value = ((uint32_t)(input[8] & 0x03) << 30) |
			((uint32_t)input[9] << 22) |
			((uint32_t)(input[10] & 0xfc) << 14);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 86 to 101
	value = ((uint32_t)(input[10] & 0x03) << 30) |
			((uint32_t)input[11] << 22) |
			((uint32_t)(input[12] & 0xfc) << 14);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 102 to 117
	value = ((uint32_t)(input[12] & 0x03) << 30) |
			((uint32_t)input[13] << 22) |
			((uint32_t)(input[14] & 0xfc) << 14);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 118 to 133
	value = ((uint32_t)(input[14] & 0x03) << 30) |
			((uint32_t)input[15] << 22) |
			((uint32_t)(input[16] & 0xfc) << 14);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 134 to 149
	value = ((uint32_t)(input[16] & 0x03) << 30) |
			((uint32_t)input[17] << 22) |
			((uint32_t)(input[18] & 0xfc) << 14);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 150 to 165
	value = ((uint32_t)(input[18] & 0x03) << 30) |
			((uint32_t)input[19] << 22) |
			((uint32_t)(input[20] & 0xfc) << 14);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 166 to 181
	value = ((uint32_t)(input[20] & 0x03) << 30) |
			((uint32_t)input[21] << 22) |
			((uint32_t)(input[22] & 0xfc) << 14);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 182 to 197
	value = ((uint32_t)(input[22] & 0x03) << 30) |
			((uint32_t)input[23] << 22) |
			((uint32_t)(input[24] & 0xfc) << 14);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 198 to 213
	value = ((uint32_t)(input[24] & 0x03) << 30) |
			((uint32_t)input[25] << 22) |
			((uint32_t)(input[26] & 0xfc) << 14);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 214 to 229
	value = ((uint32_t)(input[26] & 0x03) << 30) |
			((uint32_t)input[27] << 22) |
			((uint32_t)(input[28] & 0xfc) << 14);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 230 to 245
	value = ((uint32_t)(input[28] & 0x03) << 30) |
			((uint32_t)input[29] << 22) |
			((uint32_t)(input[30] & 0xfc) << 14);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 246 to 261
	value = ((uint32_t)(input[30] & 0x03) << 30) |
			((uint32_t)input[31] << 22) |
			((uint32_t)(input[32] & 0xfc) << 14);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 262 to 277
	value = ((uint32_t)(input[32] & 0x03) << 30) |
			((uint32_t)input[33] << 22) |
			((uint32_t)(input[34] & 0xfc) << 14);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 278 to 293
	value = ((uint32_t)(input[34] & 0x03) << 30) |
			((uint32_t)input[35] << 22) |
			((uint32_t)(input[36] & 0xfc) << 14);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 294 to 309
	value = ((uint32_t)(input[36] & 0x03) << 30) |
			((uint32_t)input[37] << 22) |
			((uint32_t)(input[38] & 0xfc) << 14);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 310 to 325
	value = ((uint32_t)(input[38] & 0x03) << 30) |
			((uint32_t)input[39] << 22) |
			((uint32_t)(input[40] & 0xfc) << 14);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 326 to 341
	value = ((uint32_t)(input[40] & 0x03) << 30) |
			((uint32_t)input[41] << 22) |
			((uint32_t)(input[42] & 0xfc) << 14);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 342 to 357
	value = ((uint32_t)(input[42] & 0x03) << 30) |
			((uint32_t)input[43] << 22) |
			((uint32_t)(input[44] & 0xfc) << 14);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 358 to 373
	value = ((uint32_t)(input[44] & 0x03) << 30) |
			((uint32_t)input[45] << 22) |
			((uint32_t)(input[46] & 0xfc) << 14);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 374 to 389
	value = ((uint32_t)(input[46] & 0x03) << 30) |
			((uint32_t)input[47] << 22) |
			((uint32_t)(input[48] & 0xfc) << 14);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 390 to 405
	value = ((uint32_t)(input[48] & 0x03) << 30) |
			((uint32_t)input[49] << 22) |
			((uint32_t)(input[50] & 0xfc) << 14);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 406 to 421
	value = ((uint32_t)(input[50] & 0x03) << 30) |
			((uint32_t)input[51] << 22) |
			((uint32_t)(input[52] & 0xfc) << 14);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 422 to 437
	value = ((uint32_t)(input[52] & 0x03) << 30) |
			((uint32_t)input[53] << 22) |
			((uint32_t)(input[54] & 0xfc) << 14);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 438 to 453
	value = ((uint32_t)(input[54] & 0x03) << 30) |
			((uint32_t)input[55] << 22) |
			((uint32_t)(input[56] & 0xfc) << 14);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 454 to 469
	value = ((uint32_t)(input[56] & 0x03) << 30) |
			((uint32_t)input[57] << 22) |
			((uint32_t)(input[58] & 0xfc) << 14);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 470 to 485
	value = ((uint32_t)(input[58] & 0x03) << 30) |
			((uint32_t)input[59] << 22) |
			((uint32_t)(input[60] & 0xfc) << 14);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 486 to 501
	value = ((uint32_t)(input[60] & 0x03) << 30) |
			((uint32_t)input[61] << 22) |
			((uint32_t)(input[62] & 0xfc) << 14);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 502 to 517
	value = ((uint32_t)(input[62] & 0x03) << 30) |
			((uint32_t)input[63] << 22) |
			((uint32_t)(input[64] & 0xfc) << 14);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 518 to 533
	value = ((uint32_t)(input[64] & 0x03) << 30) |
			((uint32_t)input[65] << 22) |
			((uint32_t)(input[66] & 0xfc) << 14);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 534 to 549
	value = ((uint32_t)(input[66] & 0x03) << 30) |
			((uint32_t)input[67] << 22) |
			((uint32_t)(input[68] & 0xfc) << 14);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 550 to 565
	value = ((uint32_t)(input[68] & 0x03) << 30) |
			((uint32_t)input[69] << 22) |
			((uint32_t)(input[70] & 0xfc) << 14);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 566 to 581
	value = ((uint32_t)(input[70] & 0x03) << 30) |
			((uint32_t)input[71] << 22) |
			((uint32_t)(input[72] & 0xfc) << 14);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 582 to 597
	value = ((uint32_t)(input[72] & 0x03) << 30) |
			((uint32_t)input[73] << 22) |
			((uint32_t)(input[74] & 0xfc) << 14);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 598 to 613
	value = ((uint32_t)(input[74] & 0x03) << 30) |
			((uint32_t)input[75] << 22) |
			((uint32_t)(input[76] & 0xfc) << 14);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 614 to 629
	value = ((uint32_t)(input[76] & 0x03) << 30) |
			((uint32_t)input[77] << 22) |
			((uint32_t)(input[78] & 0xfc) << 14);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 630 to 645
	value = ((uint32_t)(input[78] & 0x03) << 30) |
			((uint32_t)input[79] << 22) |
			((uint32_t)(input[80] & 0xfc) << 14);
	output[39] = (double)(value >> 16);

	// read output[40]: from bit 646 to 661
	value = ((uint32_t)(input[80] & 0x03) << 30) |
			((uint32_t)input[81] << 22) |
			((uint32_t)(input[82] & 0xfc) << 14);
	output[40] = (double)(value >> 16);

	// read output[41]: from bit 662 to 677
	value = ((uint32_t)(input[82] & 0x03) << 30) |
			((uint32_t)input[83] << 22) |
			((uint32_t)(input[84] & 0xfc) << 14);
	output[41] = (double)(value >> 16);

	// read output[42]: from bit 678 to 693
	value = ((uint32_t)(input[84] & 0x03) << 30) |
			((uint32_t)input[85] << 22) |
			((uint32_t)(input[86] & 0xfc) << 14);
	output[42] = (double)(value >> 16);

	// read output[43]: from bit 694 to 709
	value = ((uint32_t)(input[86] & 0x03) << 30) |
			((uint32_t)input[87] << 22) |
			((uint32_t)(input[88] & 0xfc) << 14);
	output[43] = (double)(value >> 16);

	// read output[44]: from bit 710 to 725
	value = ((uint32_t)(input[88] & 0x03) << 30) |
			((uint32_t)input[89] << 22) |
			((uint32_t)(input[90] & 0xfc) << 14);
	output[44] = (double)(value >> 16);

	// read output[45]: from bit 726 to 741
	value = ((uint32_t)(input[90] & 0x03) << 30) |
			((uint32_t)input[91] << 22) |
			((uint32_t)(input[92] & 0xfc) << 14);
	output[45] = (double)(value >> 16);

	// read output[46]: from bit 742 to 757
	value = ((uint32_t)(input[92] & 0x03) << 30) |
			((uint32_t)input[93] << 22) |
			((uint32_t)(input[94] & 0xfc) << 14);
	output[46] = (double)(value >> 16);

	// read output[47]: from bit 758 to 773
	value = ((uint32_t)(input[94] & 0x03) << 30) |
			((uint32_t)input[95] << 22) |
			((uint32_t)(input[96] & 0xfc) << 14);
	output[47] = (double)(value >> 16);

	// read output[48]: from bit 774 to 789
	value = ((uint32_t)(input[96] & 0x03) << 30) |
			((uint32_t)input[97] << 22) |
			((uint32_t)(input[98] & 0xfc) << 14);
	output[48] = (double)(value >> 16);

	// read output[49]: from bit 790 to 805
	value = ((uint32_t)(input[98] & 0x03) << 30) |
			((uint32_t)input[99] << 22) |
			((uint32_t)(input[100] & 0xfc) << 14);
	output[49] = (double)(value >> 16);

	// read output[50]: from bit 806 to 821
	value = ((uint32_t)(input[100] & 0x03) << 30) |
			((uint32_t)input[101] << 22) |
			((uint32_t)(input[102] & 0xfc) << 14);
	output[50] = (double)(value >> 16);

	// read output[51]: from bit 822 to 837
	value = ((uint32_t)(input[102] & 0x03) << 30) |
			((uint32_t)input[103] << 22) |
			((uint32_t)(input[104] & 0xfc) << 14);
	output[51] = (double)(value >> 16);

	// read output[52]: from bit 838 to 853
	value = ((uint32_t)(input[104] & 0x03) << 30) |
			((uint32_t)input[105] << 22) |
			((uint32_t)(input[106] & 0xfc) << 14);
	output[52] = (double)(value >> 16);

	// read output[53]: from bit 854 to 869
	value = ((uint32_t)(input[106] & 0x03) << 30) |
			((uint32_t)input[107] << 22) |
			((uint32_t)(input[108] & 0xfc) << 14);
	output[53] = (double)(value >> 16);

	// read output[54]: from bit 870 to 885
	value = ((uint32_t)(input[108] & 0x03) << 30) |
			((uint32_t)input[109] << 22) |
			((uint32_t)(input[110] & 0xfc) << 14);
	output[54] = (double)(value >> 16);

	// read output[55]: from bit 886 to 901
	value = ((uint32_t)(input[110] & 0x03) << 30) |
			((uint32_t)input[111] << 22) |
			((uint32_t)(input[112] & 0xfc) << 14);
	output[55] = (double)(value >> 16);

	// read output[56]: from bit 902 to 917
	value = ((uint32_t)(input[112] & 0x03) << 30) |
			((uint32_t)input[113] << 22) |
			((uint32_t)(input[114] & 0xfc) << 14);
	output[56] = (double)(value >> 16);
}

static void unpack_57_16bit_unsigned_6off(const uint8_t * input, double * output, void *closure) {
	// Unpack 57 values into output
	// Values are 16-bit unsigned
	// Skip 6 bits, read 912 bits of data.
	// Input must be at least 115 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 6 to 21
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)(input[2] & 0xfc) << 14);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 22 to 37
	value = ((uint32_t)(input[2] & 0x03) << 30) |
			((uint32_t)input[3] << 22) |
			((uint32_t)(input[4] & 0xfc) << 14);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 38 to 53
	value = ((uint32_t)(input[4] & 0x03) << 30) |
			((uint32_t)input[5] << 22) |
			((uint32_t)(input[6] & 0xfc) << 14);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 54 to 69
	value = ((uint32_t)(input[6] & 0x03) << 30) |
			((uint32_t)input[7] << 22) |
			((uint32_t)(input[8] & 0xfc) << 14);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 70 to 85
	value = ((uint32_t)(input[8] & 0x03) << 30) |
			((uint32_t)input[9] << 22) |
			((uint32_t)(input[10] & 0xfc) << 14);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 86 to 101
	value = ((uint32_t)(input[10] & 0x03) << 30) |
			((uint32_t)input[11] << 22) |
			((uint32_t)(input[12] & 0xfc) << 14);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 102 to 117
	value = ((uint32_t)(input[12] & 0x03) << 30) |
			((uint32_t)input[13] << 22) |
			((uint32_t)(input[14] & 0xfc) << 14);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 118 to 133
	value = ((uint32_t)(input[14] & 0x03) << 30) |
			((uint32_t)input[15] << 22) |
			((uint32_t)(input[16] & 0xfc) << 14);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 134 to 149
	value = ((uint32_t)(input[16] & 0x03) << 30) |
			((uint32_t)input[17] << 22) |
			((uint32_t)(input[18] & 0xfc) << 14);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 150 to 165
	value = ((uint32_t)(input[18] & 0x03) << 30) |
			((uint32_t)input[19] << 22) |
			((uint32_t)(input[20] & 0xfc) << 14);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 166 to 181
	value = ((uint32_t)(input[20] & 0x03) << 30) |
			((uint32_t)input[21] << 22) |
			((uint32_t)(input[22] & 0xfc) << 14);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 182 to 197
	value = ((uint32_t)(input[22] & 0x03) << 30) |
			((uint32_t)input[23] << 22) |
			((uint32_t)(input[24] & 0xfc) << 14);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 198 to 213
	value = ((uint32_t)(input[24] & 0x03) << 30) |
			((uint32_t)input[25] << 22) |
			((uint32_t)(input[26] & 0xfc) << 14);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 214 to 229
	value = ((uint32_t)(input[26] & 0x03) << 30) |
			((uint32_t)input[27] << 22) |
			((uint32_t)(input[28] & 0xfc) << 14);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 230 to 245
	value = ((uint32_t)(input[28] & 0x03) << 30) |
			((uint32_t)input[29] << 22) |
			((uint32_t)(input[30] & 0xfc) << 14);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 246 to 261
	value = ((uint32_t)(input[30] & 0x03) << 30) |
			((uint32_t)input[31] << 22) |
			((uint32_t)(input[32] & 0xfc) << 14);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 262 to 277
	value = ((uint32_t)(input[32] & 0x03) << 30) |
			((uint32_t)input[33] << 22) |
			((uint32_t)(input[34] & 0xfc) << 14);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 278 to 293
	value = ((uint32_t)(input[34] & 0x03) << 30) |
			((uint32_t)input[35] << 22) |
			((uint32_t)(input[36] & 0xfc) << 14);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 294 to 309
	value = ((uint32_t)(input[36] & 0x03) << 30) |
			((uint32_t)input[37] << 22) |
			((uint32_t)(input[38] & 0xfc) << 14);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 310 to 325
	value = ((uint32_t)(input[38] & 0x03) << 30) |
			((uint32_t)input[39] << 22) |
			((uint32_t)(input[40] & 0xfc) << 14);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 326 to 341
	value = ((uint32_t)(input[40] & 0x03) << 30) |
			((uint32_t)input[41] << 22) |
			((uint32_t)(input[42] & 0xfc) << 14);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 342 to 357
	value = ((uint32_t)(input[42] & 0x03) << 30) |
			((uint32_t)input[43] << 22) |
			((uint32_t)(input[44] & 0xfc) << 14);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 358 to 373
	value = ((uint32_t)(input[44] & 0x03) << 30) |
			((uint32_t)input[45] << 22) |
			((uint32_t)(input[46] & 0xfc) << 14);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 374 to 389
	value = ((uint32_t)(input[46] & 0x03) << 30) |
			((uint32_t)input[47] << 22) |
			((uint32_t)(input[48] & 0xfc) << 14);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 390 to 405
	value = ((uint32_t)(input[48] & 0x03) << 30) |
			((uint32_t)input[49] << 22) |
			((uint32_t)(input[50] & 0xfc) << 14);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 406 to 421
	value = ((uint32_t)(input[50] & 0x03) << 30) |
			((uint32_t)input[51] << 22) |
			((uint32_t)(input[52] & 0xfc) << 14);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 422 to 437
	value = ((uint32_t)(input[52] & 0x03) << 30) |
			((uint32_t)input[53] << 22) |
			((uint32_t)(input[54] & 0xfc) << 14);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 438 to 453
	value = ((uint32_t)(input[54] & 0x03) << 30) |
			((uint32_t)input[55] << 22) |
			((uint32_t)(input[56] & 0xfc) << 14);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 454 to 469
	value = ((uint32_t)(input[56] & 0x03) << 30) |
			((uint32_t)input[57] << 22) |
			((uint32_t)(input[58] & 0xfc) << 14);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 470 to 485
	value = ((uint32_t)(input[58] & 0x03) << 30) |
			((uint32_t)input[59] << 22) |
			((uint32_t)(input[60] & 0xfc) << 14);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 486 to 501
	value = ((uint32_t)(input[60] & 0x03) << 30) |
			((uint32_t)input[61] << 22) |
			((uint32_t)(input[62] & 0xfc) << 14);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 502 to 517
	value = ((uint32_t)(input[62] & 0x03) << 30) |
			((uint32_t)input[63] << 22) |
			((uint32_t)(input[64] & 0xfc) << 14);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 518 to 533
	value = ((uint32_t)(input[64] & 0x03) << 30) |
			((uint32_t)input[65] << 22) |
			((uint32_t)(input[66] & 0xfc) << 14);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 534 to 549
	value = ((uint32_t)(input[66] & 0x03) << 30) |
			((uint32_t)input[67] << 22) |
			((uint32_t)(input[68] & 0xfc) << 14);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 550 to 565
	value = ((uint32_t)(input[68] & 0x03) << 30) |
			((uint32_t)input[69] << 22) |
			((uint32_t)(input[70] & 0xfc) << 14);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 566 to 581
	value = ((uint32_t)(input[70] & 0x03) << 30) |
			((uint32_t)input[71] << 22) |
			((uint32_t)(input[72] & 0xfc) << 14);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 582 to 597
	value = ((uint32_t)(input[72] & 0x03) << 30) |
			((uint32_t)input[73] << 22) |
			((uint32_t)(input[74] & 0xfc) << 14);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 598 to 613
	value = ((uint32_t)(input[74] & 0x03) << 30) |
			((uint32_t)input[75] << 22) |
			((uint32_t)(input[76] & 0xfc) << 14);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 614 to 629
	value = ((uint32_t)(input[76] & 0x03) << 30) |
			((uint32_t)input[77] << 22) |
			((uint32_t)(input[78] & 0xfc) << 14);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 630 to 645
	value = ((uint32_t)(input[78] & 0x03) << 30) |
			((uint32_t)input[79] << 22) |
			((uint32_t)(input[80] & 0xfc) << 14);
	output[39] = (double)(value >> 16);

	// read output[40]: from bit 646 to 661
	value = ((uint32_t)(input[80] & 0x03) << 30) |
			((uint32_t)input[81] << 22) |
			((uint32_t)(input[82] & 0xfc) << 14);
	output[40] = (double)(value >> 16);

	// read output[41]: from bit 662 to 677
	value = ((uint32_t)(input[82] & 0x03) << 30) |
			((uint32_t)input[83] << 22) |
			((uint32_t)(input[84] & 0xfc) << 14);
	output[41] = (double)(value >> 16);

	// read output[42]: from bit 678 to 693
	value = ((uint32_t)(input[84] & 0x03) << 30) |
			((uint32_t)input[85] << 22) |
			((uint32_t)(input[86] & 0xfc) << 14);
	output[42] = (double)(value >> 16);

	// read output[43]: from bit 694 to 709
	value = ((uint32_t)(input[86] & 0x03) << 30) |
			((uint32_t)input[87] << 22) |
			((uint32_t)(input[88] & 0xfc) << 14);
	output[43] = (double)(value >> 16);

	// read output[44]: from bit 710 to 725
	value = ((uint32_t)(input[88] & 0x03) << 30) |
			((uint32_t)input[89] << 22) |
			((uint32_t)(input[90] & 0xfc) << 14);
	output[44] = (double)(value >> 16);

	// read output[45]: from bit 726 to 741
	value = ((uint32_t)(input[90] & 0x03) << 30) |
			((uint32_t)input[91] << 22) |
			((uint32_t)(input[92] & 0xfc) << 14);
	output[45] = (double)(value >> 16);

	// read output[46]: from bit 742 to 757
	value = ((uint32_t)(input[92] & 0x03) << 30) |
			((uint32_t)input[93] << 22) |
			((uint32_t)(input[94] & 0xfc) << 14);
	output[46] = (double)(value >> 16);

	// read output[47]: from bit 758 to 773
	value = ((uint32_t)(input[94] & 0x03) << 30) |
			((uint32_t)input[95] << 22) |
			((uint32_t)(input[96] & 0xfc) << 14);
	output[47] = (double)(value >> 16);

	// read output[48]: from bit 774 to 789
	value = ((uint32_t)(input[96] & 0x03) << 30) |
			((uint32_t)input[97] << 22) |
			((uint32_t)(input[98] & 0xfc) << 14);
	output[48] = (double)(value >> 16);

	// read output[49]: from bit 790 to 805
	value = ((uint32_t)(input[98] & 0x03) << 30) |
			((uint32_t)input[99] << 22) |
			((uint32_t)(input[100] & 0xfc) << 14);
	output[49] = (double)(value >> 16);

	// read output[50]: from bit 806 to 821
	value = ((uint32_t)(input[100] & 0x03) << 30) |
			((uint32_t)input[101] << 22) |
			((uint32_t)(input[102] & 0xfc) << 14);
	output[50] = (double)(value >> 16);

	// read output[51]: from bit 822 to 837
	value = ((uint32_t)(input[102] & 0x03) << 30) |
			((uint32_t)input[103] << 22) |
			((uint32_t)(input[104] & 0xfc) << 14);
	output[51] = (double)(value >> 16);

	// read output[52]: from bit 838 to 853
	value = ((uint32_t)(input[104] & 0x03) << 30) |
			((uint32_t)input[105] << 22) |
			((uint32_t)(input[106] & 0xfc) << 14);
	output[52] = (double)(value >> 16);

	// read output[53]: from bit 854 to 869
	value = ((uint32_t)(input[106] & 0x03) << 30) |
			((uint32_t)input[107] << 22) |
			((uint32_t)(input[108] & 0xfc) << 14);
	output[53] = (double)(value >> 16);

	// read output[54]: from bit 870 to 885
	value = ((uint32_t)(input[108] & 0x03) << 30) |
			((uint32_t)input[109] << 22) |
			((uint32_t)(input[110] & 0xfc) << 14);
	output[54] = (double)(value >> 16);

	// read output[55]: from bit 886 to 901
	value = ((uint32_t)(input[110] & 0x03) << 30) |
			((uint32_t)input[111] << 22) |
			((uint32_t)(input[112] & 0xfc) << 14);
	output[55] = (double)(value >> 16);

	// read output[56]: from bit 902 to 917
	value = ((uint32_t)(input[112] & 0x03) << 30) |
			((uint32_t)input[113] << 22) |
			((uint32_t)(input[114] & 0xfc) << 14);
	output[56] = (double)(value >> 16);
}

static void unpack_57_16bit_signed_7off(const uint8_t * input, double * output, void *closure) {
	// Unpack 57 values into output
	// Values are 16-bit signed
	// Skip 7 bits, read 912 bits of data.
	// Input must be at least 115 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 7 to 22
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)(input[2] & 0xfe) << 15);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 23 to 38
	value = ((uint32_t)(input[2] & 0x01) << 31) |
			((uint32_t)input[3] << 23) |
			((uint32_t)(input[4] & 0xfe) << 15);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 39 to 54
	value = ((uint32_t)(input[4] & 0x01) << 31) |
			((uint32_t)input[5] << 23) |
			((uint32_t)(input[6] & 0xfe) << 15);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 55 to 70
	value = ((uint32_t)(input[6] & 0x01) << 31) |
			((uint32_t)input[7] << 23) |
			((uint32_t)(input[8] & 0xfe) << 15);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 71 to 86
	value = ((uint32_t)(input[8] & 0x01) << 31) |
			((uint32_t)input[9] << 23) |
			((uint32_t)(input[10] & 0xfe) << 15);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 87 to 102
	value = ((uint32_t)(input[10] & 0x01) << 31) |
			((uint32_t)input[11] << 23) |
			((uint32_t)(input[12] & 0xfe) << 15);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 103 to 118
	value = ((uint32_t)(input[12] & 0x01) << 31) |
			((uint32_t)input[13] << 23) |
			((uint32_t)(input[14] & 0xfe) << 15);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 119 to 134
	value = ((uint32_t)(input[14] & 0x01) << 31) |
			((uint32_t)input[15] << 23) |
			((uint32_t)(input[16] & 0xfe) << 15);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 135 to 150
	value = ((uint32_t)(input[16] & 0x01) << 31) |
			((uint32_t)input[17] << 23) |
			((uint32_t)(input[18] & 0xfe) << 15);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 151 to 166
	value = ((uint32_t)(input[18] & 0x01) << 31) |
			((uint32_t)input[19] << 23) |
			((uint32_t)(input[20] & 0xfe) << 15);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 167 to 182
	value = ((uint32_t)(input[20] & 0x01) << 31) |
			((uint32_t)input[21] << 23) |
			((uint32_t)(input[22] & 0xfe) << 15);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 183 to 198
	value = ((uint32_t)(input[22] & 0x01) << 31) |
			((uint32_t)input[23] << 23) |
			((uint32_t)(input[24] & 0xfe) << 15);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 199 to 214
	value = ((uint32_t)(input[24] & 0x01) << 31) |
			((uint32_t)input[25] << 23) |
			((uint32_t)(input[26] & 0xfe) << 15);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 215 to 230
	value = ((uint32_t)(input[26] & 0x01) << 31) |
			((uint32_t)input[27] << 23) |
			((uint32_t)(input[28] & 0xfe) << 15);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 231 to 246
	value = ((uint32_t)(input[28] & 0x01) << 31) |
			((uint32_t)input[29] << 23) |
			((uint32_t)(input[30] & 0xfe) << 15);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 247 to 262
	value = ((uint32_t)(input[30] & 0x01) << 31) |
			((uint32_t)input[31] << 23) |
			((uint32_t)(input[32] & 0xfe) << 15);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 263 to 278
	value = ((uint32_t)(input[32] & 0x01) << 31) |
			((uint32_t)input[33] << 23) |
			((uint32_t)(input[34] & 0xfe) << 15);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 279 to 294
	value = ((uint32_t)(input[34] & 0x01) << 31) |
			((uint32_t)input[35] << 23) |
			((uint32_t)(input[36] & 0xfe) << 15);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 295 to 310
	value = ((uint32_t)(input[36] & 0x01) << 31) |
			((uint32_t)input[37] << 23) |
			((uint32_t)(input[38] & 0xfe) << 15);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 311 to 326
	value = ((uint32_t)(input[38] & 0x01) << 31) |
			((uint32_t)input[39] << 23) |
			((uint32_t)(input[40] & 0xfe) << 15);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 327 to 342
	value = ((uint32_t)(input[40] & 0x01) << 31) |
			((uint32_t)input[41] << 23) |
			((uint32_t)(input[42] & 0xfe) << 15);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 343 to 358
	value = ((uint32_t)(input[42] & 0x01) << 31) |
			((uint32_t)input[43] << 23) |
			((uint32_t)(input[44] & 0xfe) << 15);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 359 to 374
	value = ((uint32_t)(input[44] & 0x01) << 31) |
			((uint32_t)input[45] << 23) |
			((uint32_t)(input[46] & 0xfe) << 15);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 375 to 390
	value = ((uint32_t)(input[46] & 0x01) << 31) |
			((uint32_t)input[47] << 23) |
			((uint32_t)(input[48] & 0xfe) << 15);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 391 to 406
	value = ((uint32_t)(input[48] & 0x01) << 31) |
			((uint32_t)input[49] << 23) |
			((uint32_t)(input[50] & 0xfe) << 15);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 407 to 422
	value = ((uint32_t)(input[50] & 0x01) << 31) |
			((uint32_t)input[51] << 23) |
			((uint32_t)(input[52] & 0xfe) << 15);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 423 to 438
	value = ((uint32_t)(input[52] & 0x01) << 31) |
			((uint32_t)input[53] << 23) |
			((uint32_t)(input[54] & 0xfe) << 15);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 439 to 454
	value = ((uint32_t)(input[54] & 0x01) << 31) |
			((uint32_t)input[55] << 23) |
			((uint32_t)(input[56] & 0xfe) << 15);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 455 to 470
	value = ((uint32_t)(input[56] & 0x01) << 31) |
			((uint32_t)input[57] << 23) |
			((uint32_t)(input[58] & 0xfe) << 15);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 471 to 486
	value = ((uint32_t)(input[58] & 0x01) << 31) |
			((uint32_t)input[59] << 23) |
			((uint32_t)(input[60] & 0xfe) << 15);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 487 to 502
	value = ((uint32_t)(input[60] & 0x01) << 31) |
			((uint32_t)input[61] << 23) |
			((uint32_t)(input[62] & 0xfe) << 15);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 503 to 518
	value = ((uint32_t)(input[62] & 0x01) << 31) |
			((uint32_t)input[63] << 23) |
			((uint32_t)(input[64] & 0xfe) << 15);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 519 to 534
	value = ((uint32_t)(input[64] & 0x01) << 31) |
			((uint32_t)input[65] << 23) |
			((uint32_t)(input[66] & 0xfe) << 15);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 535 to 550
	value = ((uint32_t)(input[66] & 0x01) << 31) |
			((uint32_t)input[67] << 23) |
			((uint32_t)(input[68] & 0xfe) << 15);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 551 to 566
	value = ((uint32_t)(input[68] & 0x01) << 31) |
			((uint32_t)input[69] << 23) |
			((uint32_t)(input[70] & 0xfe) << 15);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 567 to 582
	value = ((uint32_t)(input[70] & 0x01) << 31) |
			((uint32_t)input[71] << 23) |
			((uint32_t)(input[72] & 0xfe) << 15);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 583 to 598
	value = ((uint32_t)(input[72] & 0x01) << 31) |
			((uint32_t)input[73] << 23) |
			((uint32_t)(input[74] & 0xfe) << 15);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 599 to 614
	value = ((uint32_t)(input[74] & 0x01) << 31) |
			((uint32_t)input[75] << 23) |
			((uint32_t)(input[76] & 0xfe) << 15);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 615 to 630
	value = ((uint32_t)(input[76] & 0x01) << 31) |
			((uint32_t)input[77] << 23) |
			((uint32_t)(input[78] & 0xfe) << 15);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 631 to 646
	value = ((uint32_t)(input[78] & 0x01) << 31) |
			((uint32_t)input[79] << 23) |
			((uint32_t)(input[80] & 0xfe) << 15);
	output[39] = (double)(value >> 16);

	// read output[40]: from bit 647 to 662
	value = ((uint32_t)(input[80] & 0x01) << 31) |
			((uint32_t)input[81] << 23) |
			((uint32_t)(input[82] & 0xfe) << 15);
	output[40] = (double)(value >> 16);

	// read output[41]: from bit 663 to 678
	value = ((uint32_t)(input[82] & 0x01) << 31) |
			((uint32_t)input[83] << 23) |
			((uint32_t)(input[84] & 0xfe) << 15);
	output[41] = (double)(value >> 16);

	// read output[42]: from bit 679 to 694
	value = ((uint32_t)(input[84] & 0x01) << 31) |
			((uint32_t)input[85] << 23) |
			((uint32_t)(input[86] & 0xfe) << 15);
	output[42] = (double)(value >> 16);

	// read output[43]: from bit 695 to 710
	value = ((uint32_t)(input[86] & 0x01) << 31) |
			((uint32_t)input[87] << 23) |
			((uint32_t)(input[88] & 0xfe) << 15);
	output[43] = (double)(value >> 16);

	// read output[44]: from bit 711 to 726
	value = ((uint32_t)(input[88] & 0x01) << 31) |
			((uint32_t)input[89] << 23) |
			((uint32_t)(input[90] & 0xfe) << 15);
	output[44] = (double)(value >> 16);

	// read output[45]: from bit 727 to 742
	value = ((uint32_t)(input[90] & 0x01) << 31) |
			((uint32_t)input[91] << 23) |
			((uint32_t)(input[92] & 0xfe) << 15);
	output[45] = (double)(value >> 16);

	// read output[46]: from bit 743 to 758
	value = ((uint32_t)(input[92] & 0x01) << 31) |
			((uint32_t)input[93] << 23) |
			((uint32_t)(input[94] & 0xfe) << 15);
	output[46] = (double)(value >> 16);

	// read output[47]: from bit 759 to 774
	value = ((uint32_t)(input[94] & 0x01) << 31) |
			((uint32_t)input[95] << 23) |
			((uint32_t)(input[96] & 0xfe) << 15);
	output[47] = (double)(value >> 16);

	// read output[48]: from bit 775 to 790
	value = ((uint32_t)(input[96] & 0x01) << 31) |
			((uint32_t)input[97] << 23) |
			((uint32_t)(input[98] & 0xfe) << 15);
	output[48] = (double)(value >> 16);

	// read output[49]: from bit 791 to 806
	value = ((uint32_t)(input[98] & 0x01) << 31) |
			((uint32_t)input[99] << 23) |
			((uint32_t)(input[100] & 0xfe) << 15);
	output[49] = (double)(value >> 16);

	// read output[50]: from bit 807 to 822
	value = ((uint32_t)(input[100] & 0x01) << 31) |
			((uint32_t)input[101] << 23) |
			((uint32_t)(input[102] & 0xfe) << 15);
	output[50] = (double)(value >> 16);

	// read output[51]: from bit 823 to 838
	value = ((uint32_t)(input[102] & 0x01) << 31) |
			((uint32_t)input[103] << 23) |
			((uint32_t)(input[104] & 0xfe) << 15);
	output[51] = (double)(value >> 16);

	// read output[52]: from bit 839 to 854
	value = ((uint32_t)(input[104] & 0x01) << 31) |
			((uint32_t)input[105] << 23) |
			((uint32_t)(input[106] & 0xfe) << 15);
	output[52] = (double)(value >> 16);

	// read output[53]: from bit 855 to 870
	value = ((uint32_t)(input[106] & 0x01) << 31) |
			((uint32_t)input[107] << 23) |
			((uint32_t)(input[108] & 0xfe) << 15);
	output[53] = (double)(value >> 16);

	// read output[54]: from bit 871 to 886
	value = ((uint32_t)(input[108] & 0x01) << 31) |
			((uint32_t)input[109] << 23) |
			((uint32_t)(input[110] & 0xfe) << 15);
	output[54] = (double)(value >> 16);

	// read output[55]: from bit 887 to 902
	value = ((uint32_t)(input[110] & 0x01) << 31) |
			((uint32_t)input[111] << 23) |
			((uint32_t)(input[112] & 0xfe) << 15);
	output[55] = (double)(value >> 16);

	// read output[56]: from bit 903 to 918
	value = ((uint32_t)(input[112] & 0x01) << 31) |
			((uint32_t)input[113] << 23) |
			((uint32_t)(input[114] & 0xfe) << 15);
	output[56] = (double)(value >> 16);
}

static void unpack_57_16bit_unsigned_7off(const uint8_t * input, double * output, void *closure) {
	// Unpack 57 values into output
	// Values are 16-bit unsigned
	// Skip 7 bits, read 912 bits of data.
	// Input must be at least 115 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 7 to 22
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)(input[2] & 0xfe) << 15);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 23 to 38
	value = ((uint32_t)(input[2] & 0x01) << 31) |
			((uint32_t)input[3] << 23) |
			((uint32_t)(input[4] & 0xfe) << 15);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 39 to 54
	value = ((uint32_t)(input[4] & 0x01) << 31) |
			((uint32_t)input[5] << 23) |
			((uint32_t)(input[6] & 0xfe) << 15);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 55 to 70
	value = ((uint32_t)(input[6] & 0x01) << 31) |
			((uint32_t)input[7] << 23) |
			((uint32_t)(input[8] & 0xfe) << 15);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 71 to 86
	value = ((uint32_t)(input[8] & 0x01) << 31) |
			((uint32_t)input[9] << 23) |
			((uint32_t)(input[10] & 0xfe) << 15);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 87 to 102
	value = ((uint32_t)(input[10] & 0x01) << 31) |
			((uint32_t)input[11] << 23) |
			((uint32_t)(input[12] & 0xfe) << 15);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 103 to 118
	value = ((uint32_t)(input[12] & 0x01) << 31) |
			((uint32_t)input[13] << 23) |
			((uint32_t)(input[14] & 0xfe) << 15);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 119 to 134
	value = ((uint32_t)(input[14] & 0x01) << 31) |
			((uint32_t)input[15] << 23) |
			((uint32_t)(input[16] & 0xfe) << 15);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 135 to 150
	value = ((uint32_t)(input[16] & 0x01) << 31) |
			((uint32_t)input[17] << 23) |
			((uint32_t)(input[18] & 0xfe) << 15);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 151 to 166
	value = ((uint32_t)(input[18] & 0x01) << 31) |
			((uint32_t)input[19] << 23) |
			((uint32_t)(input[20] & 0xfe) << 15);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 167 to 182
	value = ((uint32_t)(input[20] & 0x01) << 31) |
			((uint32_t)input[21] << 23) |
			((uint32_t)(input[22] & 0xfe) << 15);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 183 to 198
	value = ((uint32_t)(input[22] & 0x01) << 31) |
			((uint32_t)input[23] << 23) |
			((uint32_t)(input[24] & 0xfe) << 15);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 199 to 214
	value = ((uint32_t)(input[24] & 0x01) << 31) |
			((uint32_t)input[25] << 23) |
			((uint32_t)(input[26] & 0xfe) << 15);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 215 to 230
	value = ((uint32_t)(input[26] & 0x01) << 31) |
			((uint32_t)input[27] << 23) |
			((uint32_t)(input[28] & 0xfe) << 15);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 231 to 246
	value = ((uint32_t)(input[28] & 0x01) << 31) |
			((uint32_t)input[29] << 23) |
			((uint32_t)(input[30] & 0xfe) << 15);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 247 to 262
	value = ((uint32_t)(input[30] & 0x01) << 31) |
			((uint32_t)input[31] << 23) |
			((uint32_t)(input[32] & 0xfe) << 15);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 263 to 278
	value = ((uint32_t)(input[32] & 0x01) << 31) |
			((uint32_t)input[33] << 23) |
			((uint32_t)(input[34] & 0xfe) << 15);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 279 to 294
	value = ((uint32_t)(input[34] & 0x01) << 31) |
			((uint32_t)input[35] << 23) |
			((uint32_t)(input[36] & 0xfe) << 15);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 295 to 310
	value = ((uint32_t)(input[36] & 0x01) << 31) |
			((uint32_t)input[37] << 23) |
			((uint32_t)(input[38] & 0xfe) << 15);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 311 to 326
	value = ((uint32_t)(input[38] & 0x01) << 31) |
			((uint32_t)input[39] << 23) |
			((uint32_t)(input[40] & 0xfe) << 15);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 327 to 342
	value = ((uint32_t)(input[40] & 0x01) << 31) |
			((uint32_t)input[41] << 23) |
			((uint32_t)(input[42] & 0xfe) << 15);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 343 to 358
	value = ((uint32_t)(input[42] & 0x01) << 31) |
			((uint32_t)input[43] << 23) |
			((uint32_t)(input[44] & 0xfe) << 15);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 359 to 374
	value = ((uint32_t)(input[44] & 0x01) << 31) |
			((uint32_t)input[45] << 23) |
			((uint32_t)(input[46] & 0xfe) << 15);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 375 to 390
	value = ((uint32_t)(input[46] & 0x01) << 31) |
			((uint32_t)input[47] << 23) |
			((uint32_t)(input[48] & 0xfe) << 15);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 391 to 406
	value = ((uint32_t)(input[48] & 0x01) << 31) |
			((uint32_t)input[49] << 23) |
			((uint32_t)(input[50] & 0xfe) << 15);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 407 to 422
	value = ((uint32_t)(input[50] & 0x01) << 31) |
			((uint32_t)input[51] << 23) |
			((uint32_t)(input[52] & 0xfe) << 15);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 423 to 438
	value = ((uint32_t)(input[52] & 0x01) << 31) |
			((uint32_t)input[53] << 23) |
			((uint32_t)(input[54] & 0xfe) << 15);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 439 to 454
	value = ((uint32_t)(input[54] & 0x01) << 31) |
			((uint32_t)input[55] << 23) |
			((uint32_t)(input[56] & 0xfe) << 15);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 455 to 470
	value = ((uint32_t)(input[56] & 0x01) << 31) |
			((uint32_t)input[57] << 23) |
			((uint32_t)(input[58] & 0xfe) << 15);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 471 to 486
	value = ((uint32_t)(input[58] & 0x01) << 31) |
			((uint32_t)input[59] << 23) |
			((uint32_t)(input[60] & 0xfe) << 15);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 487 to 502
	value = ((uint32_t)(input[60] & 0x01) << 31) |
			((uint32_t)input[61] << 23) |
			((uint32_t)(input[62] & 0xfe) << 15);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 503 to 518
	value = ((uint32_t)(input[62] & 0x01) << 31) |
			((uint32_t)input[63] << 23) |
			((uint32_t)(input[64] & 0xfe) << 15);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 519 to 534
	value = ((uint32_t)(input[64] & 0x01) << 31) |
			((uint32_t)input[65] << 23) |
			((uint32_t)(input[66] & 0xfe) << 15);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 535 to 550
	value = ((uint32_t)(input[66] & 0x01) << 31) |
			((uint32_t)input[67] << 23) |
			((uint32_t)(input[68] & 0xfe) << 15);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 551 to 566
	value = ((uint32_t)(input[68] & 0x01) << 31) |
			((uint32_t)input[69] << 23) |
			((uint32_t)(input[70] & 0xfe) << 15);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 567 to 582
	value = ((uint32_t)(input[70] & 0x01) << 31) |
			((uint32_t)input[71] << 23) |
			((uint32_t)(input[72] & 0xfe) << 15);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 583 to 598
	value = ((uint32_t)(input[72] & 0x01) << 31) |
			((uint32_t)input[73] << 23) |
			((uint32_t)(input[74] & 0xfe) << 15);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 599 to 614
	value = ((uint32_t)(input[74] & 0x01) << 31) |
			((uint32_t)input[75] << 23) |
			((uint32_t)(input[76] & 0xfe) << 15);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 615 to 630
	value = ((uint32_t)(input[76] & 0x01) << 31) |
			((uint32_t)input[77] << 23) |
			((uint32_t)(input[78] & 0xfe) << 15);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 631 to 646
	value = ((uint32_t)(input[78] & 0x01) << 31) |
			((uint32_t)input[79] << 23) |
			((uint32_t)(input[80] & 0xfe) << 15);
	output[39] = (double)(value >> 16);

	// read output[40]: from bit 647 to 662
	value = ((uint32_t)(input[80] & 0x01) << 31) |
			((uint32_t)input[81] << 23) |
			((uint32_t)(input[82] & 0xfe) << 15);
	output[40] = (double)(value >> 16);

	// read output[41]: from bit 663 to 678
	value = ((uint32_t)(input[82] & 0x01) << 31) |
			((uint32_t)input[83] << 23) |
			((uint32_t)(input[84] & 0xfe) << 15);
	output[41] = (double)(value >> 16);

	// read output[42]: from bit 679 to 694
	value = ((uint32_t)(input[84] & 0x01) << 31) |
			((uint32_t)input[85] << 23) |
			((uint32_t)(input[86] & 0xfe) << 15);
	output[42] = (double)(value >> 16);

	// read output[43]: from bit 695 to 710
	value = ((uint32_t)(input[86] & 0x01) << 31) |
			((uint32_t)input[87] << 23) |
			((uint32_t)(input[88] & 0xfe) << 15);
	output[43] = (double)(value >> 16);

	// read output[44]: from bit 711 to 726
	value = ((uint32_t)(input[88] & 0x01) << 31) |
			((uint32_t)input[89] << 23) |
			((uint32_t)(input[90] & 0xfe) << 15);
	output[44] = (double)(value >> 16);

	// read output[45]: from bit 727 to 742
	value = ((uint32_t)(input[90] & 0x01) << 31) |
			((uint32_t)input[91] << 23) |
			((uint32_t)(input[92] & 0xfe) << 15);
	output[45] = (double)(value >> 16);

	// read output[46]: from bit 743 to 758
	value = ((uint32_t)(input[92] & 0x01) << 31) |
			((uint32_t)input[93] << 23) |
			((uint32_t)(input[94] & 0xfe) << 15);
	output[46] = (double)(value >> 16);

	// read output[47]: from bit 759 to 774
	value = ((uint32_t)(input[94] & 0x01) << 31) |
			((uint32_t)input[95] << 23) |
			((uint32_t)(input[96] & 0xfe) << 15);
	output[47] = (double)(value >> 16);

	// read output[48]: from bit 775 to 790
	value = ((uint32_t)(input[96] & 0x01) << 31) |
			((uint32_t)input[97] << 23) |
			((uint32_t)(input[98] & 0xfe) << 15);
	output[48] = (double)(value >> 16);

	// read output[49]: from bit 791 to 806
	value = ((uint32_t)(input[98] & 0x01) << 31) |
			((uint32_t)input[99] << 23) |
			((uint32_t)(input[100] & 0xfe) << 15);
	output[49] = (double)(value >> 16);

	// read output[50]: from bit 807 to 822
	value = ((uint32_t)(input[100] & 0x01) << 31) |
			((uint32_t)input[101] << 23) |
			((uint32_t)(input[102] & 0xfe) << 15);
	output[50] = (double)(value >> 16);

	// read output[51]: from bit 823 to 838
	value = ((uint32_t)(input[102] & 0x01) << 31) |
			((uint32_t)input[103] << 23) |
			((uint32_t)(input[104] & 0xfe) << 15);
	output[51] = (double)(value >> 16);

	// read output[52]: from bit 839 to 854
	value = ((uint32_t)(input[104] & 0x01) << 31) |
			((uint32_t)input[105] << 23) |
			((uint32_t)(input[106] & 0xfe) << 15);
	output[52] = (double)(value >> 16);

	// read output[53]: from bit 855 to 870
	value = ((uint32_t)(input[106] & 0x01) << 31) |
			((uint32_t)input[107] << 23) |
			((uint32_t)(input[108] & 0xfe) << 15);
	output[53] = (double)(value >> 16);

	// read output[54]: from bit 871 to 886
	value = ((uint32_t)(input[108] & 0x01) << 31) |
			((uint32_t)input[109] << 23) |
			((uint32_t)(input[110] & 0xfe) << 15);
	output[54] = (double)(value >> 16);

	// read output[55]: from bit 887 to 902
	value = ((uint32_t)(input[110] & 0x01) << 31) |
			((uint32_t)input[111] << 23) |
			((uint32_t)(input[112] & 0xfe) << 15);
	output[55] = (double)(value >> 16);

	// read output[56]: from bit 903 to 918
	value = ((uint32_t)(input[112] & 0x01) << 31) |
			((uint32_t)input[113] << 23) |
			((uint32_t)(input[114] & 0xfe) << 15);
	output[56] = (double)(value >> 16);
}

static void unpack_58_16bit_signed_0off(const uint8_t * input, double * output, void *closure) {
	// Unpack 58 values into output
	// Values are 16-bit signed
	// Skip 0 bits, read 928 bits of data.
	// Input must be at least 116 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 0 to 15
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)input[1] << 16);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 16 to 31
	value = ((uint32_t)input[2] << 24) |
			((uint32_t)input[3] << 16);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 32 to 47
	value = ((uint32_t)input[4] << 24) |
			((uint32_t)input[5] << 16);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 48 to 63
	value = ((uint32_t)input[6] << 24) |
			((uint32_t)input[7] << 16);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 64 to 79
	value = ((uint32_t)input[8] << 24) |
			((uint32_t)input[9] << 16);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 80 to 95
	value = ((uint32_t)input[10] << 24) |
			((uint32_t)input[11] << 16);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 96 to 111
	value = ((uint32_t)input[12] << 24) |
			((uint32_t)input[13] << 16);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 112 to 127
	value = ((uint32_t)input[14] << 24) |
			((uint32_t)input[15] << 16);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 128 to 143
	value = ((uint32_t)input[16] << 24) |
			((uint32_t)input[17] << 16);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 144 to 159
	value = ((uint32_t)input[18] << 24) |
			((uint32_t)input[19] << 16);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 160 to 175
	value = ((uint32_t)input[20] << 24) |
			((uint32_t)input[21] << 16);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 176 to 191
	value = ((uint32_t)input[22] << 24) |
			((uint32_t)input[23] << 16);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 192 to 207
	value = ((uint32_t)input[24] << 24) |
			((uint32_t)input[25] << 16);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 208 to 223
	value = ((uint32_t)input[26] << 24) |
			((uint32_t)input[27] << 16);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 224 to 239
	value = ((uint32_t)input[28] << 24) |
			((uint32_t)input[29] << 16);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 240 to 255
	value = ((uint32_t)input[30] << 24) |
			((uint32_t)input[31] << 16);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 256 to 271
	value = ((uint32_t)input[32] << 24) |
			((uint32_t)input[33] << 16);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 272 to 287
	value = ((uint32_t)input[34] << 24) |
			((uint32_t)input[35] << 16);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 288 to 303
	value = ((uint32_t)input[36] << 24) |
			((uint32_t)input[37] << 16);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 304 to 319
	value = ((uint32_t)input[38] << 24) |
			((uint32_t)input[39] << 16);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 320 to 335
	value = ((uint32_t)input[40] << 24) |
			((uint32_t)input[41] << 16);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 336 to 351
	value = ((uint32_t)input[42] << 24) |
			((uint32_t)input[43] << 16);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 352 to 367
	value = ((uint32_t)input[44] << 24) |
			((uint32_t)input[45] << 16);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 368 to 383
	value = ((uint32_t)input[46] << 24) |
			((uint32_t)input[47] << 16);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 384 to 399
	value = ((uint32_t)input[48] << 24) |
			((uint32_t)input[49] << 16);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 400 to 415
	value = ((uint32_t)input[50] << 24) |
			((uint32_t)input[51] << 16);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 416 to 431
	value = ((uint32_t)input[52] << 24) |
			((uint32_t)input[53] << 16);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 432 to 447
	value = ((uint32_t)input[54] << 24) |
			((uint32_t)input[55] << 16);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 448 to 463
	value = ((uint32_t)input[56] << 24) |
			((uint32_t)input[57] << 16);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 464 to 479
	value = ((uint32_t)input[58] << 24) |
			((uint32_t)input[59] << 16);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 480 to 495
	value = ((uint32_t)input[60] << 24) |
			((uint32_t)input[61] << 16);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 496 to 511
	value = ((uint32_t)input[62] << 24) |
			((uint32_t)input[63] << 16);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 512 to 527
	value = ((uint32_t)input[64] << 24) |
			((uint32_t)input[65] << 16);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 528 to 543
	value = ((uint32_t)input[66] << 24) |
			((uint32_t)input[67] << 16);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 544 to 559
	value = ((uint32_t)input[68] << 24) |
			((uint32_t)input[69] << 16);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 560 to 575
	value = ((uint32_t)input[70] << 24) |
			((uint32_t)input[71] << 16);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 576 to 591
	value = ((uint32_t)input[72] << 24) |
			((uint32_t)input[73] << 16);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 592 to 607
	value = ((uint32_t)input[74] << 24) |
			((uint32_t)input[75] << 16);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 608 to 623
	value = ((uint32_t)input[76] << 24) |
			((uint32_t)input[77] << 16);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 624 to 639
	value = ((uint32_t)input[78] << 24) |
			((uint32_t)input[79] << 16);
	output[39] = (double)(value >> 16);

	// read output[40]: from bit 640 to 655
	value = ((uint32_t)input[80] << 24) |
			((uint32_t)input[81] << 16);
	output[40] = (double)(value >> 16);

	// read output[41]: from bit 656 to 671
	value = ((uint32_t)input[82] << 24) |
			((uint32_t)input[83] << 16);
	output[41] = (double)(value >> 16);

	// read output[42]: from bit 672 to 687
	value = ((uint32_t)input[84] << 24) |
			((uint32_t)input[85] << 16);
	output[42] = (double)(value >> 16);

	// read output[43]: from bit 688 to 703
	value = ((uint32_t)input[86] << 24) |
			((uint32_t)input[87] << 16);
	output[43] = (double)(value >> 16);

	// read output[44]: from bit 704 to 719
	value = ((uint32_t)input[88] << 24) |
			((uint32_t)input[89] << 16);
	output[44] = (double)(value >> 16);

	// read output[45]: from bit 720 to 735
	value = ((uint32_t)input[90] << 24) |
			((uint32_t)input[91] << 16);
	output[45] = (double)(value >> 16);

	// read output[46]: from bit 736 to 751
	value = ((uint32_t)input[92] << 24) |
			((uint32_t)input[93] << 16);
	output[46] = (double)(value >> 16);

	// read output[47]: from bit 752 to 767
	value = ((uint32_t)input[94] << 24) |
			((uint32_t)input[95] << 16);
	output[47] = (double)(value >> 16);

	// read output[48]: from bit 768 to 783
	value = ((uint32_t)input[96] << 24) |
			((uint32_t)input[97] << 16);
	output[48] = (double)(value >> 16);

	// read output[49]: from bit 784 to 799
	value = ((uint32_t)input[98] << 24) |
			((uint32_t)input[99] << 16);
	output[49] = (double)(value >> 16);

	// read output[50]: from bit 800 to 815
	value = ((uint32_t)input[100] << 24) |
			((uint32_t)input[101] << 16);
	output[50] = (double)(value >> 16);

	// read output[51]: from bit 816 to 831
	value = ((uint32_t)input[102] << 24) |
			((uint32_t)input[103] << 16);
	output[51] = (double)(value >> 16);

	// read output[52]: from bit 832 to 847
	value = ((uint32_t)input[104] << 24) |
			((uint32_t)input[105] << 16);
	output[52] = (double)(value >> 16);

	// read output[53]: from bit 848 to 863
	value = ((uint32_t)input[106] << 24) |
			((uint32_t)input[107] << 16);
	output[53] = (double)(value >> 16);

	// read output[54]: from bit 864 to 879
	value = ((uint32_t)input[108] << 24) |
			((uint32_t)input[109] << 16);
	output[54] = (double)(value >> 16);

	// read output[55]: from bit 880 to 895
	value = ((uint32_t)input[110] << 24) |
			((uint32_t)input[111] << 16);
	output[55] = (double)(value >> 16);

	// read output[56]: from bit 896 to 911
	value = ((uint32_t)input[112] << 24) |
			((uint32_t)input[113] << 16);
	output[56] = (double)(value >> 16);

	// read output[57]: from bit 912 to 927
	value = ((uint32_t)input[114] << 24) |
			((uint32_t)input[115] << 16);
	output[57] = (double)(value >> 16);
}

static void unpack_58_16bit_unsigned_0off(const uint8_t * input, double * output, void *closure) {
	// Unpack 58 values into output
	// Values are 16-bit unsigned
	// Skip 0 bits, read 928 bits of data.
	// Input must be at least 116 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 0 to 15
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)input[1] << 16);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 16 to 31
	value = ((uint32_t)input[2] << 24) |
			((uint32_t)input[3] << 16);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 32 to 47
	value = ((uint32_t)input[4] << 24) |
			((uint32_t)input[5] << 16);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 48 to 63
	value = ((uint32_t)input[6] << 24) |
			((uint32_t)input[7] << 16);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 64 to 79
	value = ((uint32_t)input[8] << 24) |
			((uint32_t)input[9] << 16);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 80 to 95
	value = ((uint32_t)input[10] << 24) |
			((uint32_t)input[11] << 16);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 96 to 111
	value = ((uint32_t)input[12] << 24) |
			((uint32_t)input[13] << 16);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 112 to 127
	value = ((uint32_t)input[14] << 24) |
			((uint32_t)input[15] << 16);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 128 to 143
	value = ((uint32_t)input[16] << 24) |
			((uint32_t)input[17] << 16);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 144 to 159
	value = ((uint32_t)input[18] << 24) |
			((uint32_t)input[19] << 16);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 160 to 175
	value = ((uint32_t)input[20] << 24) |
			((uint32_t)input[21] << 16);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 176 to 191
	value = ((uint32_t)input[22] << 24) |
			((uint32_t)input[23] << 16);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 192 to 207
	value = ((uint32_t)input[24] << 24) |
			((uint32_t)input[25] << 16);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 208 to 223
	value = ((uint32_t)input[26] << 24) |
			((uint32_t)input[27] << 16);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 224 to 239
	value = ((uint32_t)input[28] << 24) |
			((uint32_t)input[29] << 16);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 240 to 255
	value = ((uint32_t)input[30] << 24) |
			((uint32_t)input[31] << 16);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 256 to 271
	value = ((uint32_t)input[32] << 24) |
			((uint32_t)input[33] << 16);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 272 to 287
	value = ((uint32_t)input[34] << 24) |
			((uint32_t)input[35] << 16);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 288 to 303
	value = ((uint32_t)input[36] << 24) |
			((uint32_t)input[37] << 16);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 304 to 319
	value = ((uint32_t)input[38] << 24) |
			((uint32_t)input[39] << 16);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 320 to 335
	value = ((uint32_t)input[40] << 24) |
			((uint32_t)input[41] << 16);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 336 to 351
	value = ((uint32_t)input[42] << 24) |
			((uint32_t)input[43] << 16);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 352 to 367
	value = ((uint32_t)input[44] << 24) |
			((uint32_t)input[45] << 16);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 368 to 383
	value = ((uint32_t)input[46] << 24) |
			((uint32_t)input[47] << 16);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 384 to 399
	value = ((uint32_t)input[48] << 24) |
			((uint32_t)input[49] << 16);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 400 to 415
	value = ((uint32_t)input[50] << 24) |
			((uint32_t)input[51] << 16);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 416 to 431
	value = ((uint32_t)input[52] << 24) |
			((uint32_t)input[53] << 16);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 432 to 447
	value = ((uint32_t)input[54] << 24) |
			((uint32_t)input[55] << 16);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 448 to 463
	value = ((uint32_t)input[56] << 24) |
			((uint32_t)input[57] << 16);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 464 to 479
	value = ((uint32_t)input[58] << 24) |
			((uint32_t)input[59] << 16);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 480 to 495
	value = ((uint32_t)input[60] << 24) |
			((uint32_t)input[61] << 16);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 496 to 511
	value = ((uint32_t)input[62] << 24) |
			((uint32_t)input[63] << 16);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 512 to 527
	value = ((uint32_t)input[64] << 24) |
			((uint32_t)input[65] << 16);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 528 to 543
	value = ((uint32_t)input[66] << 24) |
			((uint32_t)input[67] << 16);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 544 to 559
	value = ((uint32_t)input[68] << 24) |
			((uint32_t)input[69] << 16);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 560 to 575
	value = ((uint32_t)input[70] << 24) |
			((uint32_t)input[71] << 16);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 576 to 591
	value = ((uint32_t)input[72] << 24) |
			((uint32_t)input[73] << 16);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 592 to 607
	value = ((uint32_t)input[74] << 24) |
			((uint32_t)input[75] << 16);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 608 to 623
	value = ((uint32_t)input[76] << 24) |
			((uint32_t)input[77] << 16);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 624 to 639
	value = ((uint32_t)input[78] << 24) |
			((uint32_t)input[79] << 16);
	output[39] = (double)(value >> 16);

	// read output[40]: from bit 640 to 655
	value = ((uint32_t)input[80] << 24) |
			((uint32_t)input[81] << 16);
	output[40] = (double)(value >> 16);

	// read output[41]: from bit 656 to 671
	value = ((uint32_t)input[82] << 24) |
			((uint32_t)input[83] << 16);
	output[41] = (double)(value >> 16);

	// read output[42]: from bit 672 to 687
	value = ((uint32_t)input[84] << 24) |
			((uint32_t)input[85] << 16);
	output[42] = (double)(value >> 16);

	// read output[43]: from bit 688 to 703
	value = ((uint32_t)input[86] << 24) |
			((uint32_t)input[87] << 16);
	output[43] = (double)(value >> 16);

	// read output[44]: from bit 704 to 719
	value = ((uint32_t)input[88] << 24) |
			((uint32_t)input[89] << 16);
	output[44] = (double)(value >> 16);

	// read output[45]: from bit 720 to 735
	value = ((uint32_t)input[90] << 24) |
			((uint32_t)input[91] << 16);
	output[45] = (double)(value >> 16);

	// read output[46]: from bit 736 to 751
	value = ((uint32_t)input[92] << 24) |
			((uint32_t)input[93] << 16);
	output[46] = (double)(value >> 16);

	// read output[47]: from bit 752 to 767
	value = ((uint32_t)input[94] << 24) |
			((uint32_t)input[95] << 16);
	output[47] = (double)(value >> 16);

	// read output[48]: from bit 768 to 783
	value = ((uint32_t)input[96] << 24) |
			((uint32_t)input[97] << 16);
	output[48] = (double)(value >> 16);

	// read output[49]: from bit 784 to 799
	value = ((uint32_t)input[98] << 24) |
			((uint32_t)input[99] << 16);
	output[49] = (double)(value >> 16);

	// read output[50]: from bit 800 to 815
	value = ((uint32_t)input[100] << 24) |
			((uint32_t)input[101] << 16);
	output[50] = (double)(value >> 16);

	// read output[51]: from bit 816 to 831
	value = ((uint32_t)input[102] << 24) |
			((uint32_t)input[103] << 16);
	output[51] = (double)(value >> 16);

	// read output[52]: from bit 832 to 847
	value = ((uint32_t)input[104] << 24) |
			((uint32_t)input[105] << 16);
	output[52] = (double)(value >> 16);

	// read output[53]: from bit 848 to 863
	value = ((uint32_t)input[106] << 24) |
			((uint32_t)input[107] << 16);
	output[53] = (double)(value >> 16);

	// read output[54]: from bit 864 to 879
	value = ((uint32_t)input[108] << 24) |
			((uint32_t)input[109] << 16);
	output[54] = (double)(value >> 16);

	// read output[55]: from bit 880 to 895
	value = ((uint32_t)input[110] << 24) |
			((uint32_t)input[111] << 16);
	output[55] = (double)(value >> 16);

	// read output[56]: from bit 896 to 911
	value = ((uint32_t)input[112] << 24) |
			((uint32_t)input[113] << 16);
	output[56] = (double)(value >> 16);

	// read output[57]: from bit 912 to 927
	value = ((uint32_t)input[114] << 24) |
			((uint32_t)input[115] << 16);
	output[57] = (double)(value >> 16);
}

static void unpack_58_16bit_signed_1off(const uint8_t * input, double * output, void *closure) {
	// Unpack 58 values into output
	// Values are 16-bit signed
	// Skip 1 bits, read 928 bits of data.
	// Input must be at least 117 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 1 to 16
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)input[1] << 17) |
			((uint32_t)(input[2] & 0x80) << 9);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 17 to 32
	value = ((uint32_t)(input[2] & 0x7f) << 25) |
			((uint32_t)input[3] << 17) |
			((uint32_t)(input[4] & 0x80) << 9);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 33 to 48
	value = ((uint32_t)(input[4] & 0x7f) << 25) |
			((uint32_t)input[5] << 17) |
			((uint32_t)(input[6] & 0x80) << 9);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 49 to 64
	value = ((uint32_t)(input[6] & 0x7f) << 25) |
			((uint32_t)input[7] << 17) |
			((uint32_t)(input[8] & 0x80) << 9);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 65 to 80
	value = ((uint32_t)(input[8] & 0x7f) << 25) |
			((uint32_t)input[9] << 17) |
			((uint32_t)(input[10] & 0x80) << 9);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 81 to 96
	value = ((uint32_t)(input[10] & 0x7f) << 25) |
			((uint32_t)input[11] << 17) |
			((uint32_t)(input[12] & 0x80) << 9);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 97 to 112
	value = ((uint32_t)(input[12] & 0x7f) << 25) |
			((uint32_t)input[13] << 17) |
			((uint32_t)(input[14] & 0x80) << 9);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 113 to 128
	value = ((uint32_t)(input[14] & 0x7f) << 25) |
			((uint32_t)input[15] << 17) |
			((uint32_t)(input[16] & 0x80) << 9);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 129 to 144
	value = ((uint32_t)(input[16] & 0x7f) << 25) |
			((uint32_t)input[17] << 17) |
			((uint32_t)(input[18] & 0x80) << 9);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 145 to 160
	value = ((uint32_t)(input[18] & 0x7f) << 25) |
			((uint32_t)input[19] << 17) |
			((uint32_t)(input[20] & 0x80) << 9);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 161 to 176
	value = ((uint32_t)(input[20] & 0x7f) << 25) |
			((uint32_t)input[21] << 17) |
			((uint32_t)(input[22] & 0x80) << 9);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 177 to 192
	value = ((uint32_t)(input[22] & 0x7f) << 25) |
			((uint32_t)input[23] << 17) |
			((uint32_t)(input[24] & 0x80) << 9);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 193 to 208
	value = ((uint32_t)(input[24] & 0x7f) << 25) |
			((uint32_t)input[25] << 17) |
			((uint32_t)(input[26] & 0x80) << 9);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 209 to 224
	value = ((uint32_t)(input[26] & 0x7f) << 25) |
			((uint32_t)input[27] << 17) |
			((uint32_t)(input[28] & 0x80) << 9);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 225 to 240
	value = ((uint32_t)(input[28] & 0x7f) << 25) |
			((uint32_t)input[29] << 17) |
			((uint32_t)(input[30] & 0x80) << 9);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 241 to 256
	value = ((uint32_t)(input[30] & 0x7f) << 25) |
			((uint32_t)input[31] << 17) |
			((uint32_t)(input[32] & 0x80) << 9);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 257 to 272
	value = ((uint32_t)(input[32] & 0x7f) << 25) |
			((uint32_t)input[33] << 17) |
			((uint32_t)(input[34] & 0x80) << 9);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 273 to 288
	value = ((uint32_t)(input[34] & 0x7f) << 25) |
			((uint32_t)input[35] << 17) |
			((uint32_t)(input[36] & 0x80) << 9);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 289 to 304
	value = ((uint32_t)(input[36] & 0x7f) << 25) |
			((uint32_t)input[37] << 17) |
			((uint32_t)(input[38] & 0x80) << 9);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 305 to 320
	value = ((uint32_t)(input[38] & 0x7f) << 25) |
			((uint32_t)input[39] << 17) |
			((uint32_t)(input[40] & 0x80) << 9);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 321 to 336
	value = ((uint32_t)(input[40] & 0x7f) << 25) |
			((uint32_t)input[41] << 17) |
			((uint32_t)(input[42] & 0x80) << 9);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 337 to 352
	value = ((uint32_t)(input[42] & 0x7f) << 25) |
			((uint32_t)input[43] << 17) |
			((uint32_t)(input[44] & 0x80) << 9);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 353 to 368
	value = ((uint32_t)(input[44] & 0x7f) << 25) |
			((uint32_t)input[45] << 17) |
			((uint32_t)(input[46] & 0x80) << 9);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 369 to 384
	value = ((uint32_t)(input[46] & 0x7f) << 25) |
			((uint32_t)input[47] << 17) |
			((uint32_t)(input[48] & 0x80) << 9);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 385 to 400
	value = ((uint32_t)(input[48] & 0x7f) << 25) |
			((uint32_t)input[49] << 17) |
			((uint32_t)(input[50] & 0x80) << 9);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 401 to 416
	value = ((uint32_t)(input[50] & 0x7f) << 25) |
			((uint32_t)input[51] << 17) |
			((uint32_t)(input[52] & 0x80) << 9);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 417 to 432
	value = ((uint32_t)(input[52] & 0x7f) << 25) |
			((uint32_t)input[53] << 17) |
			((uint32_t)(input[54] & 0x80) << 9);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 433 to 448
	value = ((uint32_t)(input[54] & 0x7f) << 25) |
			((uint32_t)input[55] << 17) |
			((uint32_t)(input[56] & 0x80) << 9);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 449 to 464
	value = ((uint32_t)(input[56] & 0x7f) << 25) |
			((uint32_t)input[57] << 17) |
			((uint32_t)(input[58] & 0x80) << 9);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 465 to 480
	value = ((uint32_t)(input[58] & 0x7f) << 25) |
			((uint32_t)input[59] << 17) |
			((uint32_t)(input[60] & 0x80) << 9);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 481 to 496
	value = ((uint32_t)(input[60] & 0x7f) << 25) |
			((uint32_t)input[61] << 17) |
			((uint32_t)(input[62] & 0x80) << 9);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 497 to 512
	value = ((uint32_t)(input[62] & 0x7f) << 25) |
			((uint32_t)input[63] << 17) |
			((uint32_t)(input[64] & 0x80) << 9);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 513 to 528
	value = ((uint32_t)(input[64] & 0x7f) << 25) |
			((uint32_t)input[65] << 17) |
			((uint32_t)(input[66] & 0x80) << 9);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 529 to 544
	value = ((uint32_t)(input[66] & 0x7f) << 25) |
			((uint32_t)input[67] << 17) |
			((uint32_t)(input[68] & 0x80) << 9);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 545 to 560
	value = ((uint32_t)(input[68] & 0x7f) << 25) |
			((uint32_t)input[69] << 17) |
			((uint32_t)(input[70] & 0x80) << 9);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 561 to 576
	value = ((uint32_t)(input[70] & 0x7f) << 25) |
			((uint32_t)input[71] << 17) |
			((uint32_t)(input[72] & 0x80) << 9);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 577 to 592
	value = ((uint32_t)(input[72] & 0x7f) << 25) |
			((uint32_t)input[73] << 17) |
			((uint32_t)(input[74] & 0x80) << 9);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 593 to 608
	value = ((uint32_t)(input[74] & 0x7f) << 25) |
			((uint32_t)input[75] << 17) |
			((uint32_t)(input[76] & 0x80) << 9);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 609 to 624
	value = ((uint32_t)(input[76] & 0x7f) << 25) |
			((uint32_t)input[77] << 17) |
			((uint32_t)(input[78] & 0x80) << 9);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 625 to 640
	value = ((uint32_t)(input[78] & 0x7f) << 25) |
			((uint32_t)input[79] << 17) |
			((uint32_t)(input[80] & 0x80) << 9);
	output[39] = (double)(value >> 16);

	// read output[40]: from bit 641 to 656
	value = ((uint32_t)(input[80] & 0x7f) << 25) |
			((uint32_t)input[81] << 17) |
			((uint32_t)(input[82] & 0x80) << 9);
	output[40] = (double)(value >> 16);

	// read output[41]: from bit 657 to 672
	value = ((uint32_t)(input[82] & 0x7f) << 25) |
			((uint32_t)input[83] << 17) |
			((uint32_t)(input[84] & 0x80) << 9);
	output[41] = (double)(value >> 16);

	// read output[42]: from bit 673 to 688
	value = ((uint32_t)(input[84] & 0x7f) << 25) |
			((uint32_t)input[85] << 17) |
			((uint32_t)(input[86] & 0x80) << 9);
	output[42] = (double)(value >> 16);

	// read output[43]: from bit 689 to 704
	value = ((uint32_t)(input[86] & 0x7f) << 25) |
			((uint32_t)input[87] << 17) |
			((uint32_t)(input[88] & 0x80) << 9);
	output[43] = (double)(value >> 16);

	// read output[44]: from bit 705 to 720
	value = ((uint32_t)(input[88] & 0x7f) << 25) |
			((uint32_t)input[89] << 17) |
			((uint32_t)(input[90] & 0x80) << 9);
	output[44] = (double)(value >> 16);

	// read output[45]: from bit 721 to 736
	value = ((uint32_t)(input[90] & 0x7f) << 25) |
			((uint32_t)input[91] << 17) |
			((uint32_t)(input[92] & 0x80) << 9);
	output[45] = (double)(value >> 16);

	// read output[46]: from bit 737 to 752
	value = ((uint32_t)(input[92] & 0x7f) << 25) |
			((uint32_t)input[93] << 17) |
			((uint32_t)(input[94] & 0x80) << 9);
	output[46] = (double)(value >> 16);

	// read output[47]: from bit 753 to 768
	value = ((uint32_t)(input[94] & 0x7f) << 25) |
			((uint32_t)input[95] << 17) |
			((uint32_t)(input[96] & 0x80) << 9);
	output[47] = (double)(value >> 16);

	// read output[48]: from bit 769 to 784
	value = ((uint32_t)(input[96] & 0x7f) << 25) |
			((uint32_t)input[97] << 17) |
			((uint32_t)(input[98] & 0x80) << 9);
	output[48] = (double)(value >> 16);

	// read output[49]: from bit 785 to 800
	value = ((uint32_t)(input[98] & 0x7f) << 25) |
			((uint32_t)input[99] << 17) |
			((uint32_t)(input[100] & 0x80) << 9);
	output[49] = (double)(value >> 16);

	// read output[50]: from bit 801 to 816
	value = ((uint32_t)(input[100] & 0x7f) << 25) |
			((uint32_t)input[101] << 17) |
			((uint32_t)(input[102] & 0x80) << 9);
	output[50] = (double)(value >> 16);

	// read output[51]: from bit 817 to 832
	value = ((uint32_t)(input[102] & 0x7f) << 25) |
			((uint32_t)input[103] << 17) |
			((uint32_t)(input[104] & 0x80) << 9);
	output[51] = (double)(value >> 16);

	// read output[52]: from bit 833 to 848
	value = ((uint32_t)(input[104] & 0x7f) << 25) |
			((uint32_t)input[105] << 17) |
			((uint32_t)(input[106] & 0x80) << 9);
	output[52] = (double)(value >> 16);

	// read output[53]: from bit 849 to 864
	value = ((uint32_t)(input[106] & 0x7f) << 25) |
			((uint32_t)input[107] << 17) |
			((uint32_t)(input[108] & 0x80) << 9);
	output[53] = (double)(value >> 16);

	// read output[54]: from bit 865 to 880
	value = ((uint32_t)(input[108] & 0x7f) << 25) |
			((uint32_t)input[109] << 17) |
			((uint32_t)(input[110] & 0x80) << 9);
	output[54] = (double)(value >> 16);

	// read output[55]: from bit 881 to 896
	value = ((uint32_t)(input[110] & 0x7f) << 25) |
			((uint32_t)input[111] << 17) |
			((uint32_t)(input[112] & 0x80) << 9);
	output[55] = (double)(value >> 16);

	// read output[56]: from bit 897 to 912
	value = ((uint32_t)(input[112] & 0x7f) << 25) |
			((uint32_t)input[113] << 17) |
			((uint32_t)(input[114] & 0x80) << 9);
	output[56] = (double)(value >> 16);

	// read output[57]: from bit 913 to 928
	value = ((uint32_t)(input[114] & 0x7f) << 25) |
			((uint32_t)input[115] << 17) |
			((uint32_t)(input[116] & 0x80) << 9);
	output[57] = (double)(value >> 16);
}

static void unpack_58_16bit_unsigned_1off(const uint8_t * input, double * output, void *closure) {
	// Unpack 58 values into output
	// Values are 16-bit unsigned
	// Skip 1 bits, read 928 bits of data.
	// Input must be at least 117 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 1 to 16
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)input[1] << 17) |
			((uint32_t)(input[2] & 0x80) << 9);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 17 to 32
	value = ((uint32_t)(input[2] & 0x7f) << 25) |
			((uint32_t)input[3] << 17) |
			((uint32_t)(input[4] & 0x80) << 9);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 33 to 48
	value = ((uint32_t)(input[4] & 0x7f) << 25) |
			((uint32_t)input[5] << 17) |
			((uint32_t)(input[6] & 0x80) << 9);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 49 to 64
	value = ((uint32_t)(input[6] & 0x7f) << 25) |
			((uint32_t)input[7] << 17) |
			((uint32_t)(input[8] & 0x80) << 9);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 65 to 80
	value = ((uint32_t)(input[8] & 0x7f) << 25) |
			((uint32_t)input[9] << 17) |
			((uint32_t)(input[10] & 0x80) << 9);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 81 to 96
	value = ((uint32_t)(input[10] & 0x7f) << 25) |
			((uint32_t)input[11] << 17) |
			((uint32_t)(input[12] & 0x80) << 9);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 97 to 112
	value = ((uint32_t)(input[12] & 0x7f) << 25) |
			((uint32_t)input[13] << 17) |
			((uint32_t)(input[14] & 0x80) << 9);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 113 to 128
	value = ((uint32_t)(input[14] & 0x7f) << 25) |
			((uint32_t)input[15] << 17) |
			((uint32_t)(input[16] & 0x80) << 9);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 129 to 144
	value = ((uint32_t)(input[16] & 0x7f) << 25) |
			((uint32_t)input[17] << 17) |
			((uint32_t)(input[18] & 0x80) << 9);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 145 to 160
	value = ((uint32_t)(input[18] & 0x7f) << 25) |
			((uint32_t)input[19] << 17) |
			((uint32_t)(input[20] & 0x80) << 9);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 161 to 176
	value = ((uint32_t)(input[20] & 0x7f) << 25) |
			((uint32_t)input[21] << 17) |
			((uint32_t)(input[22] & 0x80) << 9);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 177 to 192
	value = ((uint32_t)(input[22] & 0x7f) << 25) |
			((uint32_t)input[23] << 17) |
			((uint32_t)(input[24] & 0x80) << 9);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 193 to 208
	value = ((uint32_t)(input[24] & 0x7f) << 25) |
			((uint32_t)input[25] << 17) |
			((uint32_t)(input[26] & 0x80) << 9);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 209 to 224
	value = ((uint32_t)(input[26] & 0x7f) << 25) |
			((uint32_t)input[27] << 17) |
			((uint32_t)(input[28] & 0x80) << 9);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 225 to 240
	value = ((uint32_t)(input[28] & 0x7f) << 25) |
			((uint32_t)input[29] << 17) |
			((uint32_t)(input[30] & 0x80) << 9);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 241 to 256
	value = ((uint32_t)(input[30] & 0x7f) << 25) |
			((uint32_t)input[31] << 17) |
			((uint32_t)(input[32] & 0x80) << 9);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 257 to 272
	value = ((uint32_t)(input[32] & 0x7f) << 25) |
			((uint32_t)input[33] << 17) |
			((uint32_t)(input[34] & 0x80) << 9);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 273 to 288
	value = ((uint32_t)(input[34] & 0x7f) << 25) |
			((uint32_t)input[35] << 17) |
			((uint32_t)(input[36] & 0x80) << 9);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 289 to 304
	value = ((uint32_t)(input[36] & 0x7f) << 25) |
			((uint32_t)input[37] << 17) |
			((uint32_t)(input[38] & 0x80) << 9);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 305 to 320
	value = ((uint32_t)(input[38] & 0x7f) << 25) |
			((uint32_t)input[39] << 17) |
			((uint32_t)(input[40] & 0x80) << 9);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 321 to 336
	value = ((uint32_t)(input[40] & 0x7f) << 25) |
			((uint32_t)input[41] << 17) |
			((uint32_t)(input[42] & 0x80) << 9);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 337 to 352
	value = ((uint32_t)(input[42] & 0x7f) << 25) |
			((uint32_t)input[43] << 17) |
			((uint32_t)(input[44] & 0x80) << 9);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 353 to 368
	value = ((uint32_t)(input[44] & 0x7f) << 25) |
			((uint32_t)input[45] << 17) |
			((uint32_t)(input[46] & 0x80) << 9);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 369 to 384
	value = ((uint32_t)(input[46] & 0x7f) << 25) |
			((uint32_t)input[47] << 17) |
			((uint32_t)(input[48] & 0x80) << 9);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 385 to 400
	value = ((uint32_t)(input[48] & 0x7f) << 25) |
			((uint32_t)input[49] << 17) |
			((uint32_t)(input[50] & 0x80) << 9);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 401 to 416
	value = ((uint32_t)(input[50] & 0x7f) << 25) |
			((uint32_t)input[51] << 17) |
			((uint32_t)(input[52] & 0x80) << 9);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 417 to 432
	value = ((uint32_t)(input[52] & 0x7f) << 25) |
			((uint32_t)input[53] << 17) |
			((uint32_t)(input[54] & 0x80) << 9);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 433 to 448
	value = ((uint32_t)(input[54] & 0x7f) << 25) |
			((uint32_t)input[55] << 17) |
			((uint32_t)(input[56] & 0x80) << 9);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 449 to 464
	value = ((uint32_t)(input[56] & 0x7f) << 25) |
			((uint32_t)input[57] << 17) |
			((uint32_t)(input[58] & 0x80) << 9);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 465 to 480
	value = ((uint32_t)(input[58] & 0x7f) << 25) |
			((uint32_t)input[59] << 17) |
			((uint32_t)(input[60] & 0x80) << 9);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 481 to 496
	value = ((uint32_t)(input[60] & 0x7f) << 25) |
			((uint32_t)input[61] << 17) |
			((uint32_t)(input[62] & 0x80) << 9);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 497 to 512
	value = ((uint32_t)(input[62] & 0x7f) << 25) |
			((uint32_t)input[63] << 17) |
			((uint32_t)(input[64] & 0x80) << 9);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 513 to 528
	value = ((uint32_t)(input[64] & 0x7f) << 25) |
			((uint32_t)input[65] << 17) |
			((uint32_t)(input[66] & 0x80) << 9);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 529 to 544
	value = ((uint32_t)(input[66] & 0x7f) << 25) |
			((uint32_t)input[67] << 17) |
			((uint32_t)(input[68] & 0x80) << 9);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 545 to 560
	value = ((uint32_t)(input[68] & 0x7f) << 25) |
			((uint32_t)input[69] << 17) |
			((uint32_t)(input[70] & 0x80) << 9);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 561 to 576
	value = ((uint32_t)(input[70] & 0x7f) << 25) |
			((uint32_t)input[71] << 17) |
			((uint32_t)(input[72] & 0x80) << 9);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 577 to 592
	value = ((uint32_t)(input[72] & 0x7f) << 25) |
			((uint32_t)input[73] << 17) |
			((uint32_t)(input[74] & 0x80) << 9);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 593 to 608
	value = ((uint32_t)(input[74] & 0x7f) << 25) |
			((uint32_t)input[75] << 17) |
			((uint32_t)(input[76] & 0x80) << 9);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 609 to 624
	value = ((uint32_t)(input[76] & 0x7f) << 25) |
			((uint32_t)input[77] << 17) |
			((uint32_t)(input[78] & 0x80) << 9);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 625 to 640
	value = ((uint32_t)(input[78] & 0x7f) << 25) |
			((uint32_t)input[79] << 17) |
			((uint32_t)(input[80] & 0x80) << 9);
	output[39] = (double)(value >> 16);

	// read output[40]: from bit 641 to 656
	value = ((uint32_t)(input[80] & 0x7f) << 25) |
			((uint32_t)input[81] << 17) |
			((uint32_t)(input[82] & 0x80) << 9);
	output[40] = (double)(value >> 16);

	// read output[41]: from bit 657 to 672
	value = ((uint32_t)(input[82] & 0x7f) << 25) |
			((uint32_t)input[83] << 17) |
			((uint32_t)(input[84] & 0x80) << 9);
	output[41] = (double)(value >> 16);

	// read output[42]: from bit 673 to 688
	value = ((uint32_t)(input[84] & 0x7f) << 25) |
			((uint32_t)input[85] << 17) |
			((uint32_t)(input[86] & 0x80) << 9);
	output[42] = (double)(value >> 16);

	// read output[43]: from bit 689 to 704
	value = ((uint32_t)(input[86] & 0x7f) << 25) |
			((uint32_t)input[87] << 17) |
			((uint32_t)(input[88] & 0x80) << 9);
	output[43] = (double)(value >> 16);

	// read output[44]: from bit 705 to 720
	value = ((uint32_t)(input[88] & 0x7f) << 25) |
			((uint32_t)input[89] << 17) |
			((uint32_t)(input[90] & 0x80) << 9);
	output[44] = (double)(value >> 16);

	// read output[45]: from bit 721 to 736
	value = ((uint32_t)(input[90] & 0x7f) << 25) |
			((uint32_t)input[91] << 17) |
			((uint32_t)(input[92] & 0x80) << 9);
	output[45] = (double)(value >> 16);

	// read output[46]: from bit 737 to 752
	value = ((uint32_t)(input[92] & 0x7f) << 25) |
			((uint32_t)input[93] << 17) |
			((uint32_t)(input[94] & 0x80) << 9);
	output[46] = (double)(value >> 16);

	// read output[47]: from bit 753 to 768
	value = ((uint32_t)(input[94] & 0x7f) << 25) |
			((uint32_t)input[95] << 17) |
			((uint32_t)(input[96] & 0x80) << 9);
	output[47] = (double)(value >> 16);

	// read output[48]: from bit 769 to 784
	value = ((uint32_t)(input[96] & 0x7f) << 25) |
			((uint32_t)input[97] << 17) |
			((uint32_t)(input[98] & 0x80) << 9);
	output[48] = (double)(value >> 16);

	// read output[49]: from bit 785 to 800
	value = ((uint32_t)(input[98] & 0x7f) << 25) |
			((uint32_t)input[99] << 17) |
			((uint32_t)(input[100] & 0x80) << 9);
	output[49] = (double)(value >> 16);

	// read output[50]: from bit 801 to 816
	value = ((uint32_t)(input[100] & 0x7f) << 25) |
			((uint32_t)input[101] << 17) |
			((uint32_t)(input[102] & 0x80) << 9);
	output[50] = (double)(value >> 16);

	// read output[51]: from bit 817 to 832
	value = ((uint32_t)(input[102] & 0x7f) << 25) |
			((uint32_t)input[103] << 17) |
			((uint32_t)(input[104] & 0x80) << 9);
	output[51] = (double)(value >> 16);

	// read output[52]: from bit 833 to 848
	value = ((uint32_t)(input[104] & 0x7f) << 25) |
			((uint32_t)input[105] << 17) |
			((uint32_t)(input[106] & 0x80) << 9);
	output[52] = (double)(value >> 16);

	// read output[53]: from bit 849 to 864
	value = ((uint32_t)(input[106] & 0x7f) << 25) |
			((uint32_t)input[107] << 17) |
			((uint32_t)(input[108] & 0x80) << 9);
	output[53] = (double)(value >> 16);

	// read output[54]: from bit 865 to 880
	value = ((uint32_t)(input[108] & 0x7f) << 25) |
			((uint32_t)input[109] << 17) |
			((uint32_t)(input[110] & 0x80) << 9);
	output[54] = (double)(value >> 16);

	// read output[55]: from bit 881 to 896
	value = ((uint32_t)(input[110] & 0x7f) << 25) |
			((uint32_t)input[111] << 17) |
			((uint32_t)(input[112] & 0x80) << 9);
	output[55] = (double)(value >> 16);

	// read output[56]: from bit 897 to 912
	value = ((uint32_t)(input[112] & 0x7f) << 25) |
			((uint32_t)input[113] << 17) |
			((uint32_t)(input[114] & 0x80) << 9);
	output[56] = (double)(value >> 16);

	// read output[57]: from bit 913 to 928
	value = ((uint32_t)(input[114] & 0x7f) << 25) |
			((uint32_t)input[115] << 17) |
			((uint32_t)(input[116] & 0x80) << 9);
	output[57] = (double)(value >> 16);
}

static void unpack_58_16bit_signed_2off(const uint8_t * input, double * output, void *closure) {
	// Unpack 58 values into output
	// Values are 16-bit signed
	// Skip 2 bits, read 928 bits of data.
	// Input must be at least 117 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 2 to 17
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)input[1] << 18) |
			((uint32_t)(input[2] & 0xc0) << 10);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 18 to 33
	value = ((uint32_t)(input[2] & 0x3f) << 26) |
			((uint32_t)input[3] << 18) |
			((uint32_t)(input[4] & 0xc0) << 10);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 34 to 49
	value = ((uint32_t)(input[4] & 0x3f) << 26) |
			((uint32_t)input[5] << 18) |
			((uint32_t)(input[6] & 0xc0) << 10);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 50 to 65
	value = ((uint32_t)(input[6] & 0x3f) << 26) |
			((uint32_t)input[7] << 18) |
			((uint32_t)(input[8] & 0xc0) << 10);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 66 to 81
	value = ((uint32_t)(input[8] & 0x3f) << 26) |
			((uint32_t)input[9] << 18) |
			((uint32_t)(input[10] & 0xc0) << 10);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 82 to 97
	value = ((uint32_t)(input[10] & 0x3f) << 26) |
			((uint32_t)input[11] << 18) |
			((uint32_t)(input[12] & 0xc0) << 10);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 98 to 113
	value = ((uint32_t)(input[12] & 0x3f) << 26) |
			((uint32_t)input[13] << 18) |
			((uint32_t)(input[14] & 0xc0) << 10);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 114 to 129
	value = ((uint32_t)(input[14] & 0x3f) << 26) |
			((uint32_t)input[15] << 18) |
			((uint32_t)(input[16] & 0xc0) << 10);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 130 to 145
	value = ((uint32_t)(input[16] & 0x3f) << 26) |
			((uint32_t)input[17] << 18) |
			((uint32_t)(input[18] & 0xc0) << 10);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 146 to 161
	value = ((uint32_t)(input[18] & 0x3f) << 26) |
			((uint32_t)input[19] << 18) |
			((uint32_t)(input[20] & 0xc0) << 10);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 162 to 177
	value = ((uint32_t)(input[20] & 0x3f) << 26) |
			((uint32_t)input[21] << 18) |
			((uint32_t)(input[22] & 0xc0) << 10);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 178 to 193
	value = ((uint32_t)(input[22] & 0x3f) << 26) |
			((uint32_t)input[23] << 18) |
			((uint32_t)(input[24] & 0xc0) << 10);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 194 to 209
	value = ((uint32_t)(input[24] & 0x3f) << 26) |
			((uint32_t)input[25] << 18) |
			((uint32_t)(input[26] & 0xc0) << 10);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 210 to 225
	value = ((uint32_t)(input[26] & 0x3f) << 26) |
			((uint32_t)input[27] << 18) |
			((uint32_t)(input[28] & 0xc0) << 10);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 226 to 241
	value = ((uint32_t)(input[28] & 0x3f) << 26) |
			((uint32_t)input[29] << 18) |
			((uint32_t)(input[30] & 0xc0) << 10);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 242 to 257
	value = ((uint32_t)(input[30] & 0x3f) << 26) |
			((uint32_t)input[31] << 18) |
			((uint32_t)(input[32] & 0xc0) << 10);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 258 to 273
	value = ((uint32_t)(input[32] & 0x3f) << 26) |
			((uint32_t)input[33] << 18) |
			((uint32_t)(input[34] & 0xc0) << 10);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 274 to 289
	value = ((uint32_t)(input[34] & 0x3f) << 26) |
			((uint32_t)input[35] << 18) |
			((uint32_t)(input[36] & 0xc0) << 10);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 290 to 305
	value = ((uint32_t)(input[36] & 0x3f) << 26) |
			((uint32_t)input[37] << 18) |
			((uint32_t)(input[38] & 0xc0) << 10);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 306 to 321
	value = ((uint32_t)(input[38] & 0x3f) << 26) |
			((uint32_t)input[39] << 18) |
			((uint32_t)(input[40] & 0xc0) << 10);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 322 to 337
	value = ((uint32_t)(input[40] & 0x3f) << 26) |
			((uint32_t)input[41] << 18) |
			((uint32_t)(input[42] & 0xc0) << 10);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 338 to 353
	value = ((uint32_t)(input[42] & 0x3f) << 26) |
			((uint32_t)input[43] << 18) |
			((uint32_t)(input[44] & 0xc0) << 10);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 354 to 369
	value = ((uint32_t)(input[44] & 0x3f) << 26) |
			((uint32_t)input[45] << 18) |
			((uint32_t)(input[46] & 0xc0) << 10);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 370 to 385
	value = ((uint32_t)(input[46] & 0x3f) << 26) |
			((uint32_t)input[47] << 18) |
			((uint32_t)(input[48] & 0xc0) << 10);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 386 to 401
	value = ((uint32_t)(input[48] & 0x3f) << 26) |
			((uint32_t)input[49] << 18) |
			((uint32_t)(input[50] & 0xc0) << 10);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 402 to 417
	value = ((uint32_t)(input[50] & 0x3f) << 26) |
			((uint32_t)input[51] << 18) |
			((uint32_t)(input[52] & 0xc0) << 10);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 418 to 433
	value = ((uint32_t)(input[52] & 0x3f) << 26) |
			((uint32_t)input[53] << 18) |
			((uint32_t)(input[54] & 0xc0) << 10);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 434 to 449
	value = ((uint32_t)(input[54] & 0x3f) << 26) |
			((uint32_t)input[55] << 18) |
			((uint32_t)(input[56] & 0xc0) << 10);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 450 to 465
	value = ((uint32_t)(input[56] & 0x3f) << 26) |
			((uint32_t)input[57] << 18) |
			((uint32_t)(input[58] & 0xc0) << 10);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 466 to 481
	value = ((uint32_t)(input[58] & 0x3f) << 26) |
			((uint32_t)input[59] << 18) |
			((uint32_t)(input[60] & 0xc0) << 10);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 482 to 497
	value = ((uint32_t)(input[60] & 0x3f) << 26) |
			((uint32_t)input[61] << 18) |
			((uint32_t)(input[62] & 0xc0) << 10);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 498 to 513
	value = ((uint32_t)(input[62] & 0x3f) << 26) |
			((uint32_t)input[63] << 18) |
			((uint32_t)(input[64] & 0xc0) << 10);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 514 to 529
	value = ((uint32_t)(input[64] & 0x3f) << 26) |
			((uint32_t)input[65] << 18) |
			((uint32_t)(input[66] & 0xc0) << 10);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 530 to 545
	value = ((uint32_t)(input[66] & 0x3f) << 26) |
			((uint32_t)input[67] << 18) |
			((uint32_t)(input[68] & 0xc0) << 10);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 546 to 561
	value = ((uint32_t)(input[68] & 0x3f) << 26) |
			((uint32_t)input[69] << 18) |
			((uint32_t)(input[70] & 0xc0) << 10);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 562 to 577
	value = ((uint32_t)(input[70] & 0x3f) << 26) |
			((uint32_t)input[71] << 18) |
			((uint32_t)(input[72] & 0xc0) << 10);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 578 to 593
	value = ((uint32_t)(input[72] & 0x3f) << 26) |
			((uint32_t)input[73] << 18) |
			((uint32_t)(input[74] & 0xc0) << 10);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 594 to 609
	value = ((uint32_t)(input[74] & 0x3f) << 26) |
			((uint32_t)input[75] << 18) |
			((uint32_t)(input[76] & 0xc0) << 10);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 610 to 625
	value = ((uint32_t)(input[76] & 0x3f) << 26) |
			((uint32_t)input[77] << 18) |
			((uint32_t)(input[78] & 0xc0) << 10);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 626 to 641
	value = ((uint32_t)(input[78] & 0x3f) << 26) |
			((uint32_t)input[79] << 18) |
			((uint32_t)(input[80] & 0xc0) << 10);
	output[39] = (double)(value >> 16);

	// read output[40]: from bit 642 to 657
	value = ((uint32_t)(input[80] & 0x3f) << 26) |
			((uint32_t)input[81] << 18) |
			((uint32_t)(input[82] & 0xc0) << 10);
	output[40] = (double)(value >> 16);

	// read output[41]: from bit 658 to 673
	value = ((uint32_t)(input[82] & 0x3f) << 26) |
			((uint32_t)input[83] << 18) |
			((uint32_t)(input[84] & 0xc0) << 10);
	output[41] = (double)(value >> 16);

	// read output[42]: from bit 674 to 689
	value = ((uint32_t)(input[84] & 0x3f) << 26) |
			((uint32_t)input[85] << 18) |
			((uint32_t)(input[86] & 0xc0) << 10);
	output[42] = (double)(value >> 16);

	// read output[43]: from bit 690 to 705
	value = ((uint32_t)(input[86] & 0x3f) << 26) |
			((uint32_t)input[87] << 18) |
			((uint32_t)(input[88] & 0xc0) << 10);
	output[43] = (double)(value >> 16);

	// read output[44]: from bit 706 to 721
	value = ((uint32_t)(input[88] & 0x3f) << 26) |
			((uint32_t)input[89] << 18) |
			((uint32_t)(input[90] & 0xc0) << 10);
	output[44] = (double)(value >> 16);

	// read output[45]: from bit 722 to 737
	value = ((uint32_t)(input[90] & 0x3f) << 26) |
			((uint32_t)input[91] << 18) |
			((uint32_t)(input[92] & 0xc0) << 10);
	output[45] = (double)(value >> 16);

	// read output[46]: from bit 738 to 753
	value = ((uint32_t)(input[92] & 0x3f) << 26) |
			((uint32_t)input[93] << 18) |
			((uint32_t)(input[94] & 0xc0) << 10);
	output[46] = (double)(value >> 16);

	// read output[47]: from bit 754 to 769
	value = ((uint32_t)(input[94] & 0x3f) << 26) |
			((uint32_t)input[95] << 18) |
			((uint32_t)(input[96] & 0xc0) << 10);
	output[47] = (double)(value >> 16);

	// read output[48]: from bit 770 to 785
	value = ((uint32_t)(input[96] & 0x3f) << 26) |
			((uint32_t)input[97] << 18) |
			((uint32_t)(input[98] & 0xc0) << 10);
	output[48] = (double)(value >> 16);

	// read output[49]: from bit 786 to 801
	value = ((uint32_t)(input[98] & 0x3f) << 26) |
			((uint32_t)input[99] << 18) |
			((uint32_t)(input[100] & 0xc0) << 10);
	output[49] = (double)(value >> 16);

	// read output[50]: from bit 802 to 817
	value = ((uint32_t)(input[100] & 0x3f) << 26) |
			((uint32_t)input[101] << 18) |
			((uint32_t)(input[102] & 0xc0) << 10);
	output[50] = (double)(value >> 16);

	// read output[51]: from bit 818 to 833
	value = ((uint32_t)(input[102] & 0x3f) << 26) |
			((uint32_t)input[103] << 18) |
			((uint32_t)(input[104] & 0xc0) << 10);
	output[51] = (double)(value >> 16);

	// read output[52]: from bit 834 to 849
	value = ((uint32_t)(input[104] & 0x3f) << 26) |
			((uint32_t)input[105] << 18) |
			((uint32_t)(input[106] & 0xc0) << 10);
	output[52] = (double)(value >> 16);

	// read output[53]: from bit 850 to 865
	value = ((uint32_t)(input[106] & 0x3f) << 26) |
			((uint32_t)input[107] << 18) |
			((uint32_t)(input[108] & 0xc0) << 10);
	output[53] = (double)(value >> 16);

	// read output[54]: from bit 866 to 881
	value = ((uint32_t)(input[108] & 0x3f) << 26) |
			((uint32_t)input[109] << 18) |
			((uint32_t)(input[110] & 0xc0) << 10);
	output[54] = (double)(value >> 16);

	// read output[55]: from bit 882 to 897
	value = ((uint32_t)(input[110] & 0x3f) << 26) |
			((uint32_t)input[111] << 18) |
			((uint32_t)(input[112] & 0xc0) << 10);
	output[55] = (double)(value >> 16);

	// read output[56]: from bit 898 to 913
	value = ((uint32_t)(input[112] & 0x3f) << 26) |
			((uint32_t)input[113] << 18) |
			((uint32_t)(input[114] & 0xc0) << 10);
	output[56] = (double)(value >> 16);

	// read output[57]: from bit 914 to 929
	value = ((uint32_t)(input[114] & 0x3f) << 26) |
			((uint32_t)input[115] << 18) |
			((uint32_t)(input[116] & 0xc0) << 10);
	output[57] = (double)(value >> 16);
}

static void unpack_58_16bit_unsigned_2off(const uint8_t * input, double * output, void *closure) {
	// Unpack 58 values into output
	// Values are 16-bit unsigned
	// Skip 2 bits, read 928 bits of data.
	// Input must be at least 117 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 2 to 17
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)input[1] << 18) |
			((uint32_t)(input[2] & 0xc0) << 10);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 18 to 33
	value = ((uint32_t)(input[2] & 0x3f) << 26) |
			((uint32_t)input[3] << 18) |
			((uint32_t)(input[4] & 0xc0) << 10);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 34 to 49
	value = ((uint32_t)(input[4] & 0x3f) << 26) |
			((uint32_t)input[5] << 18) |
			((uint32_t)(input[6] & 0xc0) << 10);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 50 to 65
	value = ((uint32_t)(input[6] & 0x3f) << 26) |
			((uint32_t)input[7] << 18) |
			((uint32_t)(input[8] & 0xc0) << 10);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 66 to 81
	value = ((uint32_t)(input[8] & 0x3f) << 26) |
			((uint32_t)input[9] << 18) |
			((uint32_t)(input[10] & 0xc0) << 10);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 82 to 97
	value = ((uint32_t)(input[10] & 0x3f) << 26) |
			((uint32_t)input[11] << 18) |
			((uint32_t)(input[12] & 0xc0) << 10);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 98 to 113
	value = ((uint32_t)(input[12] & 0x3f) << 26) |
			((uint32_t)input[13] << 18) |
			((uint32_t)(input[14] & 0xc0) << 10);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 114 to 129
	value = ((uint32_t)(input[14] & 0x3f) << 26) |
			((uint32_t)input[15] << 18) |
			((uint32_t)(input[16] & 0xc0) << 10);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 130 to 145
	value = ((uint32_t)(input[16] & 0x3f) << 26) |
			((uint32_t)input[17] << 18) |
			((uint32_t)(input[18] & 0xc0) << 10);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 146 to 161
	value = ((uint32_t)(input[18] & 0x3f) << 26) |
			((uint32_t)input[19] << 18) |
			((uint32_t)(input[20] & 0xc0) << 10);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 162 to 177
	value = ((uint32_t)(input[20] & 0x3f) << 26) |
			((uint32_t)input[21] << 18) |
			((uint32_t)(input[22] & 0xc0) << 10);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 178 to 193
	value = ((uint32_t)(input[22] & 0x3f) << 26) |
			((uint32_t)input[23] << 18) |
			((uint32_t)(input[24] & 0xc0) << 10);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 194 to 209
	value = ((uint32_t)(input[24] & 0x3f) << 26) |
			((uint32_t)input[25] << 18) |
			((uint32_t)(input[26] & 0xc0) << 10);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 210 to 225
	value = ((uint32_t)(input[26] & 0x3f) << 26) |
			((uint32_t)input[27] << 18) |
			((uint32_t)(input[28] & 0xc0) << 10);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 226 to 241
	value = ((uint32_t)(input[28] & 0x3f) << 26) |
			((uint32_t)input[29] << 18) |
			((uint32_t)(input[30] & 0xc0) << 10);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 242 to 257
	value = ((uint32_t)(input[30] & 0x3f) << 26) |
			((uint32_t)input[31] << 18) |
			((uint32_t)(input[32] & 0xc0) << 10);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 258 to 273
	value = ((uint32_t)(input[32] & 0x3f) << 26) |
			((uint32_t)input[33] << 18) |
			((uint32_t)(input[34] & 0xc0) << 10);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 274 to 289
	value = ((uint32_t)(input[34] & 0x3f) << 26) |
			((uint32_t)input[35] << 18) |
			((uint32_t)(input[36] & 0xc0) << 10);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 290 to 305
	value = ((uint32_t)(input[36] & 0x3f) << 26) |
			((uint32_t)input[37] << 18) |
			((uint32_t)(input[38] & 0xc0) << 10);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 306 to 321
	value = ((uint32_t)(input[38] & 0x3f) << 26) |
			((uint32_t)input[39] << 18) |
			((uint32_t)(input[40] & 0xc0) << 10);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 322 to 337
	value = ((uint32_t)(input[40] & 0x3f) << 26) |
			((uint32_t)input[41] << 18) |
			((uint32_t)(input[42] & 0xc0) << 10);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 338 to 353
	value = ((uint32_t)(input[42] & 0x3f) << 26) |
			((uint32_t)input[43] << 18) |
			((uint32_t)(input[44] & 0xc0) << 10);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 354 to 369
	value = ((uint32_t)(input[44] & 0x3f) << 26) |
			((uint32_t)input[45] << 18) |
			((uint32_t)(input[46] & 0xc0) << 10);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 370 to 385
	value = ((uint32_t)(input[46] & 0x3f) << 26) |
			((uint32_t)input[47] << 18) |
			((uint32_t)(input[48] & 0xc0) << 10);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 386 to 401
	value = ((uint32_t)(input[48] & 0x3f) << 26) |
			((uint32_t)input[49] << 18) |
			((uint32_t)(input[50] & 0xc0) << 10);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 402 to 417
	value = ((uint32_t)(input[50] & 0x3f) << 26) |
			((uint32_t)input[51] << 18) |
			((uint32_t)(input[52] & 0xc0) << 10);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 418 to 433
	value = ((uint32_t)(input[52] & 0x3f) << 26) |
			((uint32_t)input[53] << 18) |
			((uint32_t)(input[54] & 0xc0) << 10);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 434 to 449
	value = ((uint32_t)(input[54] & 0x3f) << 26) |
			((uint32_t)input[55] << 18) |
			((uint32_t)(input[56] & 0xc0) << 10);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 450 to 465
	value = ((uint32_t)(input[56] & 0x3f) << 26) |
			((uint32_t)input[57] << 18) |
			((uint32_t)(input[58] & 0xc0) << 10);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 466 to 481
	value = ((uint32_t)(input[58] & 0x3f) << 26) |
			((uint32_t)input[59] << 18) |
			((uint32_t)(input[60] & 0xc0) << 10);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 482 to 497
	value = ((uint32_t)(input[60] & 0x3f) << 26) |
			((uint32_t)input[61] << 18) |
			((uint32_t)(input[62] & 0xc0) << 10);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 498 to 513
	value = ((uint32_t)(input[62] & 0x3f) << 26) |
			((uint32_t)input[63] << 18) |
			((uint32_t)(input[64] & 0xc0) << 10);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 514 to 529
	value = ((uint32_t)(input[64] & 0x3f) << 26) |
			((uint32_t)input[65] << 18) |
			((uint32_t)(input[66] & 0xc0) << 10);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 530 to 545
	value = ((uint32_t)(input[66] & 0x3f) << 26) |
			((uint32_t)input[67] << 18) |
			((uint32_t)(input[68] & 0xc0) << 10);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 546 to 561
	value = ((uint32_t)(input[68] & 0x3f) << 26) |
			((uint32_t)input[69] << 18) |
			((uint32_t)(input[70] & 0xc0) << 10);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 562 to 577
	value = ((uint32_t)(input[70] & 0x3f) << 26) |
			((uint32_t)input[71] << 18) |
			((uint32_t)(input[72] & 0xc0) << 10);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 578 to 593
	value = ((uint32_t)(input[72] & 0x3f) << 26) |
			((uint32_t)input[73] << 18) |
			((uint32_t)(input[74] & 0xc0) << 10);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 594 to 609
	value = ((uint32_t)(input[74] & 0x3f) << 26) |
			((uint32_t)input[75] << 18) |
			((uint32_t)(input[76] & 0xc0) << 10);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 610 to 625
	value = ((uint32_t)(input[76] & 0x3f) << 26) |
			((uint32_t)input[77] << 18) |
			((uint32_t)(input[78] & 0xc0) << 10);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 626 to 641
	value = ((uint32_t)(input[78] & 0x3f) << 26) |
			((uint32_t)input[79] << 18) |
			((uint32_t)(input[80] & 0xc0) << 10);
	output[39] = (double)(value >> 16);

	// read output[40]: from bit 642 to 657
	value = ((uint32_t)(input[80] & 0x3f) << 26) |
			((uint32_t)input[81] << 18) |
			((uint32_t)(input[82] & 0xc0) << 10);
	output[40] = (double)(value >> 16);

	// read output[41]: from bit 658 to 673
	value = ((uint32_t)(input[82] & 0x3f) << 26) |
			((uint32_t)input[83] << 18) |
			((uint32_t)(input[84] & 0xc0) << 10);
	output[41] = (double)(value >> 16);

	// read output[42]: from bit 674 to 689
	value = ((uint32_t)(input[84] & 0x3f) << 26) |
			((uint32_t)input[85] << 18) |
			((uint32_t)(input[86] & 0xc0) << 10);
	output[42] = (double)(value >> 16);

	// read output[43]: from bit 690 to 705
	value = ((uint32_t)(input[86] & 0x3f) << 26) |
			((uint32_t)input[87] << 18) |
			((uint32_t)(input[88] & 0xc0) << 10);
	output[43] = (double)(value >> 16);

	// read output[44]: from bit 706 to 721
	value = ((uint32_t)(input[88] & 0x3f) << 26) |
			((uint32_t)input[89] << 18) |
			((uint32_t)(input[90] & 0xc0) << 10);
	output[44] = (double)(value >> 16);

	// read output[45]: from bit 722 to 737
	value = ((uint32_t)(input[90] & 0x3f) << 26) |
			((uint32_t)input[91] << 18) |
			((uint32_t)(input[92] & 0xc0) << 10);
	output[45] = (double)(value >> 16);

	// read output[46]: from bit 738 to 753
	value = ((uint32_t)(input[92] & 0x3f) << 26) |
			((uint32_t)input[93] << 18) |
			((uint32_t)(input[94] & 0xc0) << 10);
	output[46] = (double)(value >> 16);

	// read output[47]: from bit 754 to 769
	value = ((uint32_t)(input[94] & 0x3f) << 26) |
			((uint32_t)input[95] << 18) |
			((uint32_t)(input[96] & 0xc0) << 10);
	output[47] = (double)(value >> 16);

	// read output[48]: from bit 770 to 785
	value = ((uint32_t)(input[96] & 0x3f) << 26) |
			((uint32_t)input[97] << 18) |
			((uint32_t)(input[98] & 0xc0) << 10);
	output[48] = (double)(value >> 16);

	// read output[49]: from bit 786 to 801
	value = ((uint32_t)(input[98] & 0x3f) << 26) |
			((uint32_t)input[99] << 18) |
			((uint32_t)(input[100] & 0xc0) << 10);
	output[49] = (double)(value >> 16);

	// read output[50]: from bit 802 to 817
	value = ((uint32_t)(input[100] & 0x3f) << 26) |
			((uint32_t)input[101] << 18) |
			((uint32_t)(input[102] & 0xc0) << 10);
	output[50] = (double)(value >> 16);

	// read output[51]: from bit 818 to 833
	value = ((uint32_t)(input[102] & 0x3f) << 26) |
			((uint32_t)input[103] << 18) |
			((uint32_t)(input[104] & 0xc0) << 10);
	output[51] = (double)(value >> 16);

	// read output[52]: from bit 834 to 849
	value = ((uint32_t)(input[104] & 0x3f) << 26) |
			((uint32_t)input[105] << 18) |
			((uint32_t)(input[106] & 0xc0) << 10);
	output[52] = (double)(value >> 16);

	// read output[53]: from bit 850 to 865
	value = ((uint32_t)(input[106] & 0x3f) << 26) |
			((uint32_t)input[107] << 18) |
			((uint32_t)(input[108] & 0xc0) << 10);
	output[53] = (double)(value >> 16);

	// read output[54]: from bit 866 to 881
	value = ((uint32_t)(input[108] & 0x3f) << 26) |
			((uint32_t)input[109] << 18) |
			((uint32_t)(input[110] & 0xc0) << 10);
	output[54] = (double)(value >> 16);

	// read output[55]: from bit 882 to 897
	value = ((uint32_t)(input[110] & 0x3f) << 26) |
			((uint32_t)input[111] << 18) |
			((uint32_t)(input[112] & 0xc0) << 10);
	output[55] = (double)(value >> 16);

	// read output[56]: from bit 898 to 913
	value = ((uint32_t)(input[112] & 0x3f) << 26) |
			((uint32_t)input[113] << 18) |
			((uint32_t)(input[114] & 0xc0) << 10);
	output[56] = (double)(value >> 16);

	// read output[57]: from bit 914 to 929
	value = ((uint32_t)(input[114] & 0x3f) << 26) |
			((uint32_t)input[115] << 18) |
			((uint32_t)(input[116] & 0xc0) << 10);
	output[57] = (double)(value >> 16);
}

static void unpack_58_16bit_signed_3off(const uint8_t * input, double * output, void *closure) {
	// Unpack 58 values into output
	// Values are 16-bit signed
	// Skip 3 bits, read 928 bits of data.
	// Input must be at least 117 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 3 to 18
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)input[1] << 19) |
			((uint32_t)(input[2] & 0xe0) << 11);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 19 to 34
	value = ((uint32_t)(input[2] & 0x1f) << 27) |
			((uint32_t)input[3] << 19) |
			((uint32_t)(input[4] & 0xe0) << 11);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 35 to 50
	value = ((uint32_t)(input[4] & 0x1f) << 27) |
			((uint32_t)input[5] << 19) |
			((uint32_t)(input[6] & 0xe0) << 11);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 51 to 66
	value = ((uint32_t)(input[6] & 0x1f) << 27) |
			((uint32_t)input[7] << 19) |
			((uint32_t)(input[8] & 0xe0) << 11);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 67 to 82
	value = ((uint32_t)(input[8] & 0x1f) << 27) |
			((uint32_t)input[9] << 19) |
			((uint32_t)(input[10] & 0xe0) << 11);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 83 to 98
	value = ((uint32_t)(input[10] & 0x1f) << 27) |
			((uint32_t)input[11] << 19) |
			((uint32_t)(input[12] & 0xe0) << 11);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 99 to 114
	value = ((uint32_t)(input[12] & 0x1f) << 27) |
			((uint32_t)input[13] << 19) |
			((uint32_t)(input[14] & 0xe0) << 11);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 115 to 130
	value = ((uint32_t)(input[14] & 0x1f) << 27) |
			((uint32_t)input[15] << 19) |
			((uint32_t)(input[16] & 0xe0) << 11);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 131 to 146
	value = ((uint32_t)(input[16] & 0x1f) << 27) |
			((uint32_t)input[17] << 19) |
			((uint32_t)(input[18] & 0xe0) << 11);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 147 to 162
	value = ((uint32_t)(input[18] & 0x1f) << 27) |
			((uint32_t)input[19] << 19) |
			((uint32_t)(input[20] & 0xe0) << 11);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 163 to 178
	value = ((uint32_t)(input[20] & 0x1f) << 27) |
			((uint32_t)input[21] << 19) |
			((uint32_t)(input[22] & 0xe0) << 11);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 179 to 194
	value = ((uint32_t)(input[22] & 0x1f) << 27) |
			((uint32_t)input[23] << 19) |
			((uint32_t)(input[24] & 0xe0) << 11);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 195 to 210
	value = ((uint32_t)(input[24] & 0x1f) << 27) |
			((uint32_t)input[25] << 19) |
			((uint32_t)(input[26] & 0xe0) << 11);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 211 to 226
	value = ((uint32_t)(input[26] & 0x1f) << 27) |
			((uint32_t)input[27] << 19) |
			((uint32_t)(input[28] & 0xe0) << 11);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 227 to 242
	value = ((uint32_t)(input[28] & 0x1f) << 27) |
			((uint32_t)input[29] << 19) |
			((uint32_t)(input[30] & 0xe0) << 11);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 243 to 258
	value = ((uint32_t)(input[30] & 0x1f) << 27) |
			((uint32_t)input[31] << 19) |
			((uint32_t)(input[32] & 0xe0) << 11);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 259 to 274
	value = ((uint32_t)(input[32] & 0x1f) << 27) |
			((uint32_t)input[33] << 19) |
			((uint32_t)(input[34] & 0xe0) << 11);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 275 to 290
	value = ((uint32_t)(input[34] & 0x1f) << 27) |
			((uint32_t)input[35] << 19) |
			((uint32_t)(input[36] & 0xe0) << 11);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 291 to 306
	value = ((uint32_t)(input[36] & 0x1f) << 27) |
			((uint32_t)input[37] << 19) |
			((uint32_t)(input[38] & 0xe0) << 11);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 307 to 322
	value = ((uint32_t)(input[38] & 0x1f) << 27) |
			((uint32_t)input[39] << 19) |
			((uint32_t)(input[40] & 0xe0) << 11);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 323 to 338
	value = ((uint32_t)(input[40] & 0x1f) << 27) |
			((uint32_t)input[41] << 19) |
			((uint32_t)(input[42] & 0xe0) << 11);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 339 to 354
	value = ((uint32_t)(input[42] & 0x1f) << 27) |
			((uint32_t)input[43] << 19) |
			((uint32_t)(input[44] & 0xe0) << 11);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 355 to 370
	value = ((uint32_t)(input[44] & 0x1f) << 27) |
			((uint32_t)input[45] << 19) |
			((uint32_t)(input[46] & 0xe0) << 11);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 371 to 386
	value = ((uint32_t)(input[46] & 0x1f) << 27) |
			((uint32_t)input[47] << 19) |
			((uint32_t)(input[48] & 0xe0) << 11);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 387 to 402
	value = ((uint32_t)(input[48] & 0x1f) << 27) |
			((uint32_t)input[49] << 19) |
			((uint32_t)(input[50] & 0xe0) << 11);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 403 to 418
	value = ((uint32_t)(input[50] & 0x1f) << 27) |
			((uint32_t)input[51] << 19) |
			((uint32_t)(input[52] & 0xe0) << 11);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 419 to 434
	value = ((uint32_t)(input[52] & 0x1f) << 27) |
			((uint32_t)input[53] << 19) |
			((uint32_t)(input[54] & 0xe0) << 11);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 435 to 450
	value = ((uint32_t)(input[54] & 0x1f) << 27) |
			((uint32_t)input[55] << 19) |
			((uint32_t)(input[56] & 0xe0) << 11);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 451 to 466
	value = ((uint32_t)(input[56] & 0x1f) << 27) |
			((uint32_t)input[57] << 19) |
			((uint32_t)(input[58] & 0xe0) << 11);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 467 to 482
	value = ((uint32_t)(input[58] & 0x1f) << 27) |
			((uint32_t)input[59] << 19) |
			((uint32_t)(input[60] & 0xe0) << 11);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 483 to 498
	value = ((uint32_t)(input[60] & 0x1f) << 27) |
			((uint32_t)input[61] << 19) |
			((uint32_t)(input[62] & 0xe0) << 11);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 499 to 514
	value = ((uint32_t)(input[62] & 0x1f) << 27) |
			((uint32_t)input[63] << 19) |
			((uint32_t)(input[64] & 0xe0) << 11);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 515 to 530
	value = ((uint32_t)(input[64] & 0x1f) << 27) |
			((uint32_t)input[65] << 19) |
			((uint32_t)(input[66] & 0xe0) << 11);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 531 to 546
	value = ((uint32_t)(input[66] & 0x1f) << 27) |
			((uint32_t)input[67] << 19) |
			((uint32_t)(input[68] & 0xe0) << 11);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 547 to 562
	value = ((uint32_t)(input[68] & 0x1f) << 27) |
			((uint32_t)input[69] << 19) |
			((uint32_t)(input[70] & 0xe0) << 11);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 563 to 578
	value = ((uint32_t)(input[70] & 0x1f) << 27) |
			((uint32_t)input[71] << 19) |
			((uint32_t)(input[72] & 0xe0) << 11);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 579 to 594
	value = ((uint32_t)(input[72] & 0x1f) << 27) |
			((uint32_t)input[73] << 19) |
			((uint32_t)(input[74] & 0xe0) << 11);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 595 to 610
	value = ((uint32_t)(input[74] & 0x1f) << 27) |
			((uint32_t)input[75] << 19) |
			((uint32_t)(input[76] & 0xe0) << 11);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 611 to 626
	value = ((uint32_t)(input[76] & 0x1f) << 27) |
			((uint32_t)input[77] << 19) |
			((uint32_t)(input[78] & 0xe0) << 11);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 627 to 642
	value = ((uint32_t)(input[78] & 0x1f) << 27) |
			((uint32_t)input[79] << 19) |
			((uint32_t)(input[80] & 0xe0) << 11);
	output[39] = (double)(value >> 16);

	// read output[40]: from bit 643 to 658
	value = ((uint32_t)(input[80] & 0x1f) << 27) |
			((uint32_t)input[81] << 19) |
			((uint32_t)(input[82] & 0xe0) << 11);
	output[40] = (double)(value >> 16);

	// read output[41]: from bit 659 to 674
	value = ((uint32_t)(input[82] & 0x1f) << 27) |
			((uint32_t)input[83] << 19) |
			((uint32_t)(input[84] & 0xe0) << 11);
	output[41] = (double)(value >> 16);

	// read output[42]: from bit 675 to 690
	value = ((uint32_t)(input[84] & 0x1f) << 27) |
			((uint32_t)input[85] << 19) |
			((uint32_t)(input[86] & 0xe0) << 11);
	output[42] = (double)(value >> 16);

	// read output[43]: from bit 691 to 706
	value = ((uint32_t)(input[86] & 0x1f) << 27) |
			((uint32_t)input[87] << 19) |
			((uint32_t)(input[88] & 0xe0) << 11);
	output[43] = (double)(value >> 16);

	// read output[44]: from bit 707 to 722
	value = ((uint32_t)(input[88] & 0x1f) << 27) |
			((uint32_t)input[89] << 19) |
			((uint32_t)(input[90] & 0xe0) << 11);
	output[44] = (double)(value >> 16);

	// read output[45]: from bit 723 to 738
	value = ((uint32_t)(input[90] & 0x1f) << 27) |
			((uint32_t)input[91] << 19) |
			((uint32_t)(input[92] & 0xe0) << 11);
	output[45] = (double)(value >> 16);

	// read output[46]: from bit 739 to 754
	value = ((uint32_t)(input[92] & 0x1f) << 27) |
			((uint32_t)input[93] << 19) |
			((uint32_t)(input[94] & 0xe0) << 11);
	output[46] = (double)(value >> 16);

	// read output[47]: from bit 755 to 770
	value = ((uint32_t)(input[94] & 0x1f) << 27) |
			((uint32_t)input[95] << 19) |
			((uint32_t)(input[96] & 0xe0) << 11);
	output[47] = (double)(value >> 16);

	// read output[48]: from bit 771 to 786
	value = ((uint32_t)(input[96] & 0x1f) << 27) |
			((uint32_t)input[97] << 19) |
			((uint32_t)(input[98] & 0xe0) << 11);
	output[48] = (double)(value >> 16);

	// read output[49]: from bit 787 to 802
	value = ((uint32_t)(input[98] & 0x1f) << 27) |
			((uint32_t)input[99] << 19) |
			((uint32_t)(input[100] & 0xe0) << 11);
	output[49] = (double)(value >> 16);

	// read output[50]: from bit 803 to 818
	value = ((uint32_t)(input[100] & 0x1f) << 27) |
			((uint32_t)input[101] << 19) |
			((uint32_t)(input[102] & 0xe0) << 11);
	output[50] = (double)(value >> 16);

	// read output[51]: from bit 819 to 834
	value = ((uint32_t)(input[102] & 0x1f) << 27) |
			((uint32_t)input[103] << 19) |
			((uint32_t)(input[104] & 0xe0) << 11);
	output[51] = (double)(value >> 16);

	// read output[52]: from bit 835 to 850
	value = ((uint32_t)(input[104] & 0x1f) << 27) |
			((uint32_t)input[105] << 19) |
			((uint32_t)(input[106] & 0xe0) << 11);
	output[52] = (double)(value >> 16);

	// read output[53]: from bit 851 to 866
	value = ((uint32_t)(input[106] & 0x1f) << 27) |
			((uint32_t)input[107] << 19) |
			((uint32_t)(input[108] & 0xe0) << 11);
	output[53] = (double)(value >> 16);

	// read output[54]: from bit 867 to 882
	value = ((uint32_t)(input[108] & 0x1f) << 27) |
			((uint32_t)input[109] << 19) |
			((uint32_t)(input[110] & 0xe0) << 11);
	output[54] = (double)(value >> 16);

	// read output[55]: from bit 883 to 898
	value = ((uint32_t)(input[110] & 0x1f) << 27) |
			((uint32_t)input[111] << 19) |
			((uint32_t)(input[112] & 0xe0) << 11);
	output[55] = (double)(value >> 16);

	// read output[56]: from bit 899 to 914
	value = ((uint32_t)(input[112] & 0x1f) << 27) |
			((uint32_t)input[113] << 19) |
			((uint32_t)(input[114] & 0xe0) << 11);
	output[56] = (double)(value >> 16);

	// read output[57]: from bit 915 to 930
	value = ((uint32_t)(input[114] & 0x1f) << 27) |
			((uint32_t)input[115] << 19) |
			((uint32_t)(input[116] & 0xe0) << 11);
	output[57] = (double)(value >> 16);
}

static void unpack_58_16bit_unsigned_3off(const uint8_t * input, double * output, void *closure) {
	// Unpack 58 values into output
	// Values are 16-bit unsigned
	// Skip 3 bits, read 928 bits of data.
	// Input must be at least 117 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 3 to 18
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)input[1] << 19) |
			((uint32_t)(input[2] & 0xe0) << 11);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 19 to 34
	value = ((uint32_t)(input[2] & 0x1f) << 27) |
			((uint32_t)input[3] << 19) |
			((uint32_t)(input[4] & 0xe0) << 11);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 35 to 50
	value = ((uint32_t)(input[4] & 0x1f) << 27) |
			((uint32_t)input[5] << 19) |
			((uint32_t)(input[6] & 0xe0) << 11);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 51 to 66
	value = ((uint32_t)(input[6] & 0x1f) << 27) |
			((uint32_t)input[7] << 19) |
			((uint32_t)(input[8] & 0xe0) << 11);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 67 to 82
	value = ((uint32_t)(input[8] & 0x1f) << 27) |
			((uint32_t)input[9] << 19) |
			((uint32_t)(input[10] & 0xe0) << 11);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 83 to 98
	value = ((uint32_t)(input[10] & 0x1f) << 27) |
			((uint32_t)input[11] << 19) |
			((uint32_t)(input[12] & 0xe0) << 11);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 99 to 114
	value = ((uint32_t)(input[12] & 0x1f) << 27) |
			((uint32_t)input[13] << 19) |
			((uint32_t)(input[14] & 0xe0) << 11);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 115 to 130
	value = ((uint32_t)(input[14] & 0x1f) << 27) |
			((uint32_t)input[15] << 19) |
			((uint32_t)(input[16] & 0xe0) << 11);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 131 to 146
	value = ((uint32_t)(input[16] & 0x1f) << 27) |
			((uint32_t)input[17] << 19) |
			((uint32_t)(input[18] & 0xe0) << 11);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 147 to 162
	value = ((uint32_t)(input[18] & 0x1f) << 27) |
			((uint32_t)input[19] << 19) |
			((uint32_t)(input[20] & 0xe0) << 11);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 163 to 178
	value = ((uint32_t)(input[20] & 0x1f) << 27) |
			((uint32_t)input[21] << 19) |
			((uint32_t)(input[22] & 0xe0) << 11);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 179 to 194
	value = ((uint32_t)(input[22] & 0x1f) << 27) |
			((uint32_t)input[23] << 19) |
			((uint32_t)(input[24] & 0xe0) << 11);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 195 to 210
	value = ((uint32_t)(input[24] & 0x1f) << 27) |
			((uint32_t)input[25] << 19) |
			((uint32_t)(input[26] & 0xe0) << 11);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 211 to 226
	value = ((uint32_t)(input[26] & 0x1f) << 27) |
			((uint32_t)input[27] << 19) |
			((uint32_t)(input[28] & 0xe0) << 11);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 227 to 242
	value = ((uint32_t)(input[28] & 0x1f) << 27) |
			((uint32_t)input[29] << 19) |
			((uint32_t)(input[30] & 0xe0) << 11);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 243 to 258
	value = ((uint32_t)(input[30] & 0x1f) << 27) |
			((uint32_t)input[31] << 19) |
			((uint32_t)(input[32] & 0xe0) << 11);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 259 to 274
	value = ((uint32_t)(input[32] & 0x1f) << 27) |
			((uint32_t)input[33] << 19) |
			((uint32_t)(input[34] & 0xe0) << 11);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 275 to 290
	value = ((uint32_t)(input[34] & 0x1f) << 27) |
			((uint32_t)input[35] << 19) |
			((uint32_t)(input[36] & 0xe0) << 11);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 291 to 306
	value = ((uint32_t)(input[36] & 0x1f) << 27) |
			((uint32_t)input[37] << 19) |
			((uint32_t)(input[38] & 0xe0) << 11);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 307 to 322
	value = ((uint32_t)(input[38] & 0x1f) << 27) |
			((uint32_t)input[39] << 19) |
			((uint32_t)(input[40] & 0xe0) << 11);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 323 to 338
	value = ((uint32_t)(input[40] & 0x1f) << 27) |
			((uint32_t)input[41] << 19) |
			((uint32_t)(input[42] & 0xe0) << 11);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 339 to 354
	value = ((uint32_t)(input[42] & 0x1f) << 27) |
			((uint32_t)input[43] << 19) |
			((uint32_t)(input[44] & 0xe0) << 11);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 355 to 370
	value = ((uint32_t)(input[44] & 0x1f) << 27) |
			((uint32_t)input[45] << 19) |
			((uint32_t)(input[46] & 0xe0) << 11);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 371 to 386
	value = ((uint32_t)(input[46] & 0x1f) << 27) |
			((uint32_t)input[47] << 19) |
			((uint32_t)(input[48] & 0xe0) << 11);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 387 to 402
	value = ((uint32_t)(input[48] & 0x1f) << 27) |
			((uint32_t)input[49] << 19) |
			((uint32_t)(input[50] & 0xe0) << 11);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 403 to 418
	value = ((uint32_t)(input[50] & 0x1f) << 27) |
			((uint32_t)input[51] << 19) |
			((uint32_t)(input[52] & 0xe0) << 11);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 419 to 434
	value = ((uint32_t)(input[52] & 0x1f) << 27) |
			((uint32_t)input[53] << 19) |
			((uint32_t)(input[54] & 0xe0) << 11);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 435 to 450
	value = ((uint32_t)(input[54] & 0x1f) << 27) |
			((uint32_t)input[55] << 19) |
			((uint32_t)(input[56] & 0xe0) << 11);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 451 to 466
	value = ((uint32_t)(input[56] & 0x1f) << 27) |
			((uint32_t)input[57] << 19) |
			((uint32_t)(input[58] & 0xe0) << 11);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 467 to 482
	value = ((uint32_t)(input[58] & 0x1f) << 27) |
			((uint32_t)input[59] << 19) |
			((uint32_t)(input[60] & 0xe0) << 11);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 483 to 498
	value = ((uint32_t)(input[60] & 0x1f) << 27) |
			((uint32_t)input[61] << 19) |
			((uint32_t)(input[62] & 0xe0) << 11);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 499 to 514
	value = ((uint32_t)(input[62] & 0x1f) << 27) |
			((uint32_t)input[63] << 19) |
			((uint32_t)(input[64] & 0xe0) << 11);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 515 to 530
	value = ((uint32_t)(input[64] & 0x1f) << 27) |
			((uint32_t)input[65] << 19) |
			((uint32_t)(input[66] & 0xe0) << 11);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 531 to 546
	value = ((uint32_t)(input[66] & 0x1f) << 27) |
			((uint32_t)input[67] << 19) |
			((uint32_t)(input[68] & 0xe0) << 11);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 547 to 562
	value = ((uint32_t)(input[68] & 0x1f) << 27) |
			((uint32_t)input[69] << 19) |
			((uint32_t)(input[70] & 0xe0) << 11);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 563 to 578
	value = ((uint32_t)(input[70] & 0x1f) << 27) |
			((uint32_t)input[71] << 19) |
			((uint32_t)(input[72] & 0xe0) << 11);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 579 to 594
	value = ((uint32_t)(input[72] & 0x1f) << 27) |
			((uint32_t)input[73] << 19) |
			((uint32_t)(input[74] & 0xe0) << 11);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 595 to 610
	value = ((uint32_t)(input[74] & 0x1f) << 27) |
			((uint32_t)input[75] << 19) |
			((uint32_t)(input[76] & 0xe0) << 11);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 611 to 626
	value = ((uint32_t)(input[76] & 0x1f) << 27) |
			((uint32_t)input[77] << 19) |
			((uint32_t)(input[78] & 0xe0) << 11);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 627 to 642
	value = ((uint32_t)(input[78] & 0x1f) << 27) |
			((uint32_t)input[79] << 19) |
			((uint32_t)(input[80] & 0xe0) << 11);
	output[39] = (double)(value >> 16);

	// read output[40]: from bit 643 to 658
	value = ((uint32_t)(input[80] & 0x1f) << 27) |
			((uint32_t)input[81] << 19) |
			((uint32_t)(input[82] & 0xe0) << 11);
	output[40] = (double)(value >> 16);

	// read output[41]: from bit 659 to 674
	value = ((uint32_t)(input[82] & 0x1f) << 27) |
			((uint32_t)input[83] << 19) |
			((uint32_t)(input[84] & 0xe0) << 11);
	output[41] = (double)(value >> 16);

	// read output[42]: from bit 675 to 690
	value = ((uint32_t)(input[84] & 0x1f) << 27) |
			((uint32_t)input[85] << 19) |
			((uint32_t)(input[86] & 0xe0) << 11);
	output[42] = (double)(value >> 16);

	// read output[43]: from bit 691 to 706
	value = ((uint32_t)(input[86] & 0x1f) << 27) |
			((uint32_t)input[87] << 19) |
			((uint32_t)(input[88] & 0xe0) << 11);
	output[43] = (double)(value >> 16);

	// read output[44]: from bit 707 to 722
	value = ((uint32_t)(input[88] & 0x1f) << 27) |
			((uint32_t)input[89] << 19) |
			((uint32_t)(input[90] & 0xe0) << 11);
	output[44] = (double)(value >> 16);

	// read output[45]: from bit 723 to 738
	value = ((uint32_t)(input[90] & 0x1f) << 27) |
			((uint32_t)input[91] << 19) |
			((uint32_t)(input[92] & 0xe0) << 11);
	output[45] = (double)(value >> 16);

	// read output[46]: from bit 739 to 754
	value = ((uint32_t)(input[92] & 0x1f) << 27) |
			((uint32_t)input[93] << 19) |
			((uint32_t)(input[94] & 0xe0) << 11);
	output[46] = (double)(value >> 16);

	// read output[47]: from bit 755 to 770
	value = ((uint32_t)(input[94] & 0x1f) << 27) |
			((uint32_t)input[95] << 19) |
			((uint32_t)(input[96] & 0xe0) << 11);
	output[47] = (double)(value >> 16);

	// read output[48]: from bit 771 to 786
	value = ((uint32_t)(input[96] & 0x1f) << 27) |
			((uint32_t)input[97] << 19) |
			((uint32_t)(input[98] & 0xe0) << 11);
	output[48] = (double)(value >> 16);

	// read output[49]: from bit 787 to 802
	value = ((uint32_t)(input[98] & 0x1f) << 27) |
			((uint32_t)input[99] << 19) |
			((uint32_t)(input[100] & 0xe0) << 11);
	output[49] = (double)(value >> 16);

	// read output[50]: from bit 803 to 818
	value = ((uint32_t)(input[100] & 0x1f) << 27) |
			((uint32_t)input[101] << 19) |
			((uint32_t)(input[102] & 0xe0) << 11);
	output[50] = (double)(value >> 16);

	// read output[51]: from bit 819 to 834
	value = ((uint32_t)(input[102] & 0x1f) << 27) |
			((uint32_t)input[103] << 19) |
			((uint32_t)(input[104] & 0xe0) << 11);
	output[51] = (double)(value >> 16);

	// read output[52]: from bit 835 to 850
	value = ((uint32_t)(input[104] & 0x1f) << 27) |
			((uint32_t)input[105] << 19) |
			((uint32_t)(input[106] & 0xe0) << 11);
	output[52] = (double)(value >> 16);

	// read output[53]: from bit 851 to 866
	value = ((uint32_t)(input[106] & 0x1f) << 27) |
			((uint32_t)input[107] << 19) |
			((uint32_t)(input[108] & 0xe0) << 11);
	output[53] = (double)(value >> 16);

	// read output[54]: from bit 867 to 882
	value = ((uint32_t)(input[108] & 0x1f) << 27) |
			((uint32_t)input[109] << 19) |
			((uint32_t)(input[110] & 0xe0) << 11);
	output[54] = (double)(value >> 16);

	// read output[55]: from bit 883 to 898
	value = ((uint32_t)(input[110] & 0x1f) << 27) |
			((uint32_t)input[111] << 19) |
			((uint32_t)(input[112] & 0xe0) << 11);
	output[55] = (double)(value >> 16);

	// read output[56]: from bit 899 to 914
	value = ((uint32_t)(input[112] & 0x1f) << 27) |
			((uint32_t)input[113] << 19) |
			((uint32_t)(input[114] & 0xe0) << 11);
	output[56] = (double)(value >> 16);

	// read output[57]: from bit 915 to 930
	value = ((uint32_t)(input[114] & 0x1f) << 27) |
			((uint32_t)input[115] << 19) |
			((uint32_t)(input[116] & 0xe0) << 11);
	output[57] = (double)(value >> 16);
}

static void unpack_58_16bit_signed_4off(const uint8_t * input, double * output, void *closure) {
	// Unpack 58 values into output
	// Values are 16-bit signed
	// Skip 4 bits, read 928 bits of data.
	// Input must be at least 117 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 4 to 19
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20) |
			((uint32_t)(input[2] & 0xf0) << 12);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 20 to 35
	value = ((uint32_t)(input[2] & 0x0f) << 28) |
			((uint32_t)input[3] << 20) |
			((uint32_t)(input[4] & 0xf0) << 12);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 36 to 51
	value = ((uint32_t)(input[4] & 0x0f) << 28) |
			((uint32_t)input[5] << 20) |
			((uint32_t)(input[6] & 0xf0) << 12);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 52 to 67
	value = ((uint32_t)(input[6] & 0x0f) << 28) |
			((uint32_t)input[7] << 20) |
			((uint32_t)(input[8] & 0xf0) << 12);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 68 to 83
	value = ((uint32_t)(input[8] & 0x0f) << 28) |
			((uint32_t)input[9] << 20) |
			((uint32_t)(input[10] & 0xf0) << 12);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 84 to 99
	value = ((uint32_t)(input[10] & 0x0f) << 28) |
			((uint32_t)input[11] << 20) |
			((uint32_t)(input[12] & 0xf0) << 12);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 100 to 115
	value = ((uint32_t)(input[12] & 0x0f) << 28) |
			((uint32_t)input[13] << 20) |
			((uint32_t)(input[14] & 0xf0) << 12);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 116 to 131
	value = ((uint32_t)(input[14] & 0x0f) << 28) |
			((uint32_t)input[15] << 20) |
			((uint32_t)(input[16] & 0xf0) << 12);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 132 to 147
	value = ((uint32_t)(input[16] & 0x0f) << 28) |
			((uint32_t)input[17] << 20) |
			((uint32_t)(input[18] & 0xf0) << 12);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 148 to 163
	value = ((uint32_t)(input[18] & 0x0f) << 28) |
			((uint32_t)input[19] << 20) |
			((uint32_t)(input[20] & 0xf0) << 12);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 164 to 179
	value = ((uint32_t)(input[20] & 0x0f) << 28) |
			((uint32_t)input[21] << 20) |
			((uint32_t)(input[22] & 0xf0) << 12);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 180 to 195
	value = ((uint32_t)(input[22] & 0x0f) << 28) |
			((uint32_t)input[23] << 20) |
			((uint32_t)(input[24] & 0xf0) << 12);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 196 to 211
	value = ((uint32_t)(input[24] & 0x0f) << 28) |
			((uint32_t)input[25] << 20) |
			((uint32_t)(input[26] & 0xf0) << 12);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 212 to 227
	value = ((uint32_t)(input[26] & 0x0f) << 28) |
			((uint32_t)input[27] << 20) |
			((uint32_t)(input[28] & 0xf0) << 12);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 228 to 243
	value = ((uint32_t)(input[28] & 0x0f) << 28) |
			((uint32_t)input[29] << 20) |
			((uint32_t)(input[30] & 0xf0) << 12);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 244 to 259
	value = ((uint32_t)(input[30] & 0x0f) << 28) |
			((uint32_t)input[31] << 20) |
			((uint32_t)(input[32] & 0xf0) << 12);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 260 to 275
	value = ((uint32_t)(input[32] & 0x0f) << 28) |
			((uint32_t)input[33] << 20) |
			((uint32_t)(input[34] & 0xf0) << 12);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 276 to 291
	value = ((uint32_t)(input[34] & 0x0f) << 28) |
			((uint32_t)input[35] << 20) |
			((uint32_t)(input[36] & 0xf0) << 12);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 292 to 307
	value = ((uint32_t)(input[36] & 0x0f) << 28) |
			((uint32_t)input[37] << 20) |
			((uint32_t)(input[38] & 0xf0) << 12);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 308 to 323
	value = ((uint32_t)(input[38] & 0x0f) << 28) |
			((uint32_t)input[39] << 20) |
			((uint32_t)(input[40] & 0xf0) << 12);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 324 to 339
	value = ((uint32_t)(input[40] & 0x0f) << 28) |
			((uint32_t)input[41] << 20) |
			((uint32_t)(input[42] & 0xf0) << 12);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 340 to 355
	value = ((uint32_t)(input[42] & 0x0f) << 28) |
			((uint32_t)input[43] << 20) |
			((uint32_t)(input[44] & 0xf0) << 12);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 356 to 371
	value = ((uint32_t)(input[44] & 0x0f) << 28) |
			((uint32_t)input[45] << 20) |
			((uint32_t)(input[46] & 0xf0) << 12);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 372 to 387
	value = ((uint32_t)(input[46] & 0x0f) << 28) |
			((uint32_t)input[47] << 20) |
			((uint32_t)(input[48] & 0xf0) << 12);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 388 to 403
	value = ((uint32_t)(input[48] & 0x0f) << 28) |
			((uint32_t)input[49] << 20) |
			((uint32_t)(input[50] & 0xf0) << 12);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 404 to 419
	value = ((uint32_t)(input[50] & 0x0f) << 28) |
			((uint32_t)input[51] << 20) |
			((uint32_t)(input[52] & 0xf0) << 12);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 420 to 435
	value = ((uint32_t)(input[52] & 0x0f) << 28) |
			((uint32_t)input[53] << 20) |
			((uint32_t)(input[54] & 0xf0) << 12);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 436 to 451
	value = ((uint32_t)(input[54] & 0x0f) << 28) |
			((uint32_t)input[55] << 20) |
			((uint32_t)(input[56] & 0xf0) << 12);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 452 to 467
	value = ((uint32_t)(input[56] & 0x0f) << 28) |
			((uint32_t)input[57] << 20) |
			((uint32_t)(input[58] & 0xf0) << 12);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 468 to 483
	value = ((uint32_t)(input[58] & 0x0f) << 28) |
			((uint32_t)input[59] << 20) |
			((uint32_t)(input[60] & 0xf0) << 12);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 484 to 499
	value = ((uint32_t)(input[60] & 0x0f) << 28) |
			((uint32_t)input[61] << 20) |
			((uint32_t)(input[62] & 0xf0) << 12);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 500 to 515
	value = ((uint32_t)(input[62] & 0x0f) << 28) |
			((uint32_t)input[63] << 20) |
			((uint32_t)(input[64] & 0xf0) << 12);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 516 to 531
	value = ((uint32_t)(input[64] & 0x0f) << 28) |
			((uint32_t)input[65] << 20) |
			((uint32_t)(input[66] & 0xf0) << 12);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 532 to 547
	value = ((uint32_t)(input[66] & 0x0f) << 28) |
			((uint32_t)input[67] << 20) |
			((uint32_t)(input[68] & 0xf0) << 12);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 548 to 563
	value = ((uint32_t)(input[68] & 0x0f) << 28) |
			((uint32_t)input[69] << 20) |
			((uint32_t)(input[70] & 0xf0) << 12);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 564 to 579
	value = ((uint32_t)(input[70] & 0x0f) << 28) |
			((uint32_t)input[71] << 20) |
			((uint32_t)(input[72] & 0xf0) << 12);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 580 to 595
	value = ((uint32_t)(input[72] & 0x0f) << 28) |
			((uint32_t)input[73] << 20) |
			((uint32_t)(input[74] & 0xf0) << 12);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 596 to 611
	value = ((uint32_t)(input[74] & 0x0f) << 28) |
			((uint32_t)input[75] << 20) |
			((uint32_t)(input[76] & 0xf0) << 12);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 612 to 627
	value = ((uint32_t)(input[76] & 0x0f) << 28) |
			((uint32_t)input[77] << 20) |
			((uint32_t)(input[78] & 0xf0) << 12);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 628 to 643
	value = ((uint32_t)(input[78] & 0x0f) << 28) |
			((uint32_t)input[79] << 20) |
			((uint32_t)(input[80] & 0xf0) << 12);
	output[39] = (double)(value >> 16);

	// read output[40]: from bit 644 to 659
	value = ((uint32_t)(input[80] & 0x0f) << 28) |
			((uint32_t)input[81] << 20) |
			((uint32_t)(input[82] & 0xf0) << 12);
	output[40] = (double)(value >> 16);

	// read output[41]: from bit 660 to 675
	value = ((uint32_t)(input[82] & 0x0f) << 28) |
			((uint32_t)input[83] << 20) |
			((uint32_t)(input[84] & 0xf0) << 12);
	output[41] = (double)(value >> 16);

	// read output[42]: from bit 676 to 691
	value = ((uint32_t)(input[84] & 0x0f) << 28) |
			((uint32_t)input[85] << 20) |
			((uint32_t)(input[86] & 0xf0) << 12);
	output[42] = (double)(value >> 16);

	// read output[43]: from bit 692 to 707
	value = ((uint32_t)(input[86] & 0x0f) << 28) |
			((uint32_t)input[87] << 20) |
			((uint32_t)(input[88] & 0xf0) << 12);
	output[43] = (double)(value >> 16);

	// read output[44]: from bit 708 to 723
	value = ((uint32_t)(input[88] & 0x0f) << 28) |
			((uint32_t)input[89] << 20) |
			((uint32_t)(input[90] & 0xf0) << 12);
	output[44] = (double)(value >> 16);

	// read output[45]: from bit 724 to 739
	value = ((uint32_t)(input[90] & 0x0f) << 28) |
			((uint32_t)input[91] << 20) |
			((uint32_t)(input[92] & 0xf0) << 12);
	output[45] = (double)(value >> 16);

	// read output[46]: from bit 740 to 755
	value = ((uint32_t)(input[92] & 0x0f) << 28) |
			((uint32_t)input[93] << 20) |
			((uint32_t)(input[94] & 0xf0) << 12);
	output[46] = (double)(value >> 16);

	// read output[47]: from bit 756 to 771
	value = ((uint32_t)(input[94] & 0x0f) << 28) |
			((uint32_t)input[95] << 20) |
			((uint32_t)(input[96] & 0xf0) << 12);
	output[47] = (double)(value >> 16);

	// read output[48]: from bit 772 to 787
	value = ((uint32_t)(input[96] & 0x0f) << 28) |
			((uint32_t)input[97] << 20) |
			((uint32_t)(input[98] & 0xf0) << 12);
	output[48] = (double)(value >> 16);

	// read output[49]: from bit 788 to 803
	value = ((uint32_t)(input[98] & 0x0f) << 28) |
			((uint32_t)input[99] << 20) |
			((uint32_t)(input[100] & 0xf0) << 12);
	output[49] = (double)(value >> 16);

	// read output[50]: from bit 804 to 819
	value = ((uint32_t)(input[100] & 0x0f) << 28) |
			((uint32_t)input[101] << 20) |
			((uint32_t)(input[102] & 0xf0) << 12);
	output[50] = (double)(value >> 16);

	// read output[51]: from bit 820 to 835
	value = ((uint32_t)(input[102] & 0x0f) << 28) |
			((uint32_t)input[103] << 20) |
			((uint32_t)(input[104] & 0xf0) << 12);
	output[51] = (double)(value >> 16);

	// read output[52]: from bit 836 to 851
	value = ((uint32_t)(input[104] & 0x0f) << 28) |
			((uint32_t)input[105] << 20) |
			((uint32_t)(input[106] & 0xf0) << 12);
	output[52] = (double)(value >> 16);

	// read output[53]: from bit 852 to 867
	value = ((uint32_t)(input[106] & 0x0f) << 28) |
			((uint32_t)input[107] << 20) |
			((uint32_t)(input[108] & 0xf0) << 12);
	output[53] = (double)(value >> 16);

	// read output[54]: from bit 868 to 883
	value = ((uint32_t)(input[108] & 0x0f) << 28) |
			((uint32_t)input[109] << 20) |
			((uint32_t)(input[110] & 0xf0) << 12);
	output[54] = (double)(value >> 16);

	// read output[55]: from bit 884 to 899
	value = ((uint32_t)(input[110] & 0x0f) << 28) |
			((uint32_t)input[111] << 20) |
			((uint32_t)(input[112] & 0xf0) << 12);
	output[55] = (double)(value >> 16);

	// read output[56]: from bit 900 to 915
	value = ((uint32_t)(input[112] & 0x0f) << 28) |
			((uint32_t)input[113] << 20) |
			((uint32_t)(input[114] & 0xf0) << 12);
	output[56] = (double)(value >> 16);

	// read output[57]: from bit 916 to 931
	value = ((uint32_t)(input[114] & 0x0f) << 28) |
			((uint32_t)input[115] << 20) |
			((uint32_t)(input[116] & 0xf0) << 12);
	output[57] = (double)(value >> 16);
}

static void unpack_58_16bit_unsigned_4off(const uint8_t * input, double * output, void *closure) {
	// Unpack 58 values into output
	// Values are 16-bit unsigned
	// Skip 4 bits, read 928 bits of data.
	// Input must be at least 117 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 4 to 19
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20) |
			((uint32_t)(input[2] & 0xf0) << 12);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 20 to 35
	value = ((uint32_t)(input[2] & 0x0f) << 28) |
			((uint32_t)input[3] << 20) |
			((uint32_t)(input[4] & 0xf0) << 12);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 36 to 51
	value = ((uint32_t)(input[4] & 0x0f) << 28) |
			((uint32_t)input[5] << 20) |
			((uint32_t)(input[6] & 0xf0) << 12);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 52 to 67
	value = ((uint32_t)(input[6] & 0x0f) << 28) |
			((uint32_t)input[7] << 20) |
			((uint32_t)(input[8] & 0xf0) << 12);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 68 to 83
	value = ((uint32_t)(input[8] & 0x0f) << 28) |
			((uint32_t)input[9] << 20) |
			((uint32_t)(input[10] & 0xf0) << 12);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 84 to 99
	value = ((uint32_t)(input[10] & 0x0f) << 28) |
			((uint32_t)input[11] << 20) |
			((uint32_t)(input[12] & 0xf0) << 12);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 100 to 115
	value = ((uint32_t)(input[12] & 0x0f) << 28) |
			((uint32_t)input[13] << 20) |
			((uint32_t)(input[14] & 0xf0) << 12);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 116 to 131
	value = ((uint32_t)(input[14] & 0x0f) << 28) |
			((uint32_t)input[15] << 20) |
			((uint32_t)(input[16] & 0xf0) << 12);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 132 to 147
	value = ((uint32_t)(input[16] & 0x0f) << 28) |
			((uint32_t)input[17] << 20) |
			((uint32_t)(input[18] & 0xf0) << 12);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 148 to 163
	value = ((uint32_t)(input[18] & 0x0f) << 28) |
			((uint32_t)input[19] << 20) |
			((uint32_t)(input[20] & 0xf0) << 12);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 164 to 179
	value = ((uint32_t)(input[20] & 0x0f) << 28) |
			((uint32_t)input[21] << 20) |
			((uint32_t)(input[22] & 0xf0) << 12);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 180 to 195
	value = ((uint32_t)(input[22] & 0x0f) << 28) |
			((uint32_t)input[23] << 20) |
			((uint32_t)(input[24] & 0xf0) << 12);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 196 to 211
	value = ((uint32_t)(input[24] & 0x0f) << 28) |
			((uint32_t)input[25] << 20) |
			((uint32_t)(input[26] & 0xf0) << 12);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 212 to 227
	value = ((uint32_t)(input[26] & 0x0f) << 28) |
			((uint32_t)input[27] << 20) |
			((uint32_t)(input[28] & 0xf0) << 12);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 228 to 243
	value = ((uint32_t)(input[28] & 0x0f) << 28) |
			((uint32_t)input[29] << 20) |
			((uint32_t)(input[30] & 0xf0) << 12);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 244 to 259
	value = ((uint32_t)(input[30] & 0x0f) << 28) |
			((uint32_t)input[31] << 20) |
			((uint32_t)(input[32] & 0xf0) << 12);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 260 to 275
	value = ((uint32_t)(input[32] & 0x0f) << 28) |
			((uint32_t)input[33] << 20) |
			((uint32_t)(input[34] & 0xf0) << 12);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 276 to 291
	value = ((uint32_t)(input[34] & 0x0f) << 28) |
			((uint32_t)input[35] << 20) |
			((uint32_t)(input[36] & 0xf0) << 12);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 292 to 307
	value = ((uint32_t)(input[36] & 0x0f) << 28) |
			((uint32_t)input[37] << 20) |
			((uint32_t)(input[38] & 0xf0) << 12);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 308 to 323
	value = ((uint32_t)(input[38] & 0x0f) << 28) |
			((uint32_t)input[39] << 20) |
			((uint32_t)(input[40] & 0xf0) << 12);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 324 to 339
	value = ((uint32_t)(input[40] & 0x0f) << 28) |
			((uint32_t)input[41] << 20) |
			((uint32_t)(input[42] & 0xf0) << 12);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 340 to 355
	value = ((uint32_t)(input[42] & 0x0f) << 28) |
			((uint32_t)input[43] << 20) |
			((uint32_t)(input[44] & 0xf0) << 12);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 356 to 371
	value = ((uint32_t)(input[44] & 0x0f) << 28) |
			((uint32_t)input[45] << 20) |
			((uint32_t)(input[46] & 0xf0) << 12);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 372 to 387
	value = ((uint32_t)(input[46] & 0x0f) << 28) |
			((uint32_t)input[47] << 20) |
			((uint32_t)(input[48] & 0xf0) << 12);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 388 to 403
	value = ((uint32_t)(input[48] & 0x0f) << 28) |
			((uint32_t)input[49] << 20) |
			((uint32_t)(input[50] & 0xf0) << 12);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 404 to 419
	value = ((uint32_t)(input[50] & 0x0f) << 28) |
			((uint32_t)input[51] << 20) |
			((uint32_t)(input[52] & 0xf0) << 12);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 420 to 435
	value = ((uint32_t)(input[52] & 0x0f) << 28) |
			((uint32_t)input[53] << 20) |
			((uint32_t)(input[54] & 0xf0) << 12);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 436 to 451
	value = ((uint32_t)(input[54] & 0x0f) << 28) |
			((uint32_t)input[55] << 20) |
			((uint32_t)(input[56] & 0xf0) << 12);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 452 to 467
	value = ((uint32_t)(input[56] & 0x0f) << 28) |
			((uint32_t)input[57] << 20) |
			((uint32_t)(input[58] & 0xf0) << 12);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 468 to 483
	value = ((uint32_t)(input[58] & 0x0f) << 28) |
			((uint32_t)input[59] << 20) |
			((uint32_t)(input[60] & 0xf0) << 12);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 484 to 499
	value = ((uint32_t)(input[60] & 0x0f) << 28) |
			((uint32_t)input[61] << 20) |
			((uint32_t)(input[62] & 0xf0) << 12);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 500 to 515
	value = ((uint32_t)(input[62] & 0x0f) << 28) |
			((uint32_t)input[63] << 20) |
			((uint32_t)(input[64] & 0xf0) << 12);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 516 to 531
	value = ((uint32_t)(input[64] & 0x0f) << 28) |
			((uint32_t)input[65] << 20) |
			((uint32_t)(input[66] & 0xf0) << 12);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 532 to 547
	value = ((uint32_t)(input[66] & 0x0f) << 28) |
			((uint32_t)input[67] << 20) |
			((uint32_t)(input[68] & 0xf0) << 12);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 548 to 563
	value = ((uint32_t)(input[68] & 0x0f) << 28) |
			((uint32_t)input[69] << 20) |
			((uint32_t)(input[70] & 0xf0) << 12);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 564 to 579
	value = ((uint32_t)(input[70] & 0x0f) << 28) |
			((uint32_t)input[71] << 20) |
			((uint32_t)(input[72] & 0xf0) << 12);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 580 to 595
	value = ((uint32_t)(input[72] & 0x0f) << 28) |
			((uint32_t)input[73] << 20) |
			((uint32_t)(input[74] & 0xf0) << 12);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 596 to 611
	value = ((uint32_t)(input[74] & 0x0f) << 28) |
			((uint32_t)input[75] << 20) |
			((uint32_t)(input[76] & 0xf0) << 12);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 612 to 627
	value = ((uint32_t)(input[76] & 0x0f) << 28) |
			((uint32_t)input[77] << 20) |
			((uint32_t)(input[78] & 0xf0) << 12);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 628 to 643
	value = ((uint32_t)(input[78] & 0x0f) << 28) |
			((uint32_t)input[79] << 20) |
			((uint32_t)(input[80] & 0xf0) << 12);
	output[39] = (double)(value >> 16);

	// read output[40]: from bit 644 to 659
	value = ((uint32_t)(input[80] & 0x0f) << 28) |
			((uint32_t)input[81] << 20) |
			((uint32_t)(input[82] & 0xf0) << 12);
	output[40] = (double)(value >> 16);

	// read output[41]: from bit 660 to 675
	value = ((uint32_t)(input[82] & 0x0f) << 28) |
			((uint32_t)input[83] << 20) |
			((uint32_t)(input[84] & 0xf0) << 12);
	output[41] = (double)(value >> 16);

	// read output[42]: from bit 676 to 691
	value = ((uint32_t)(input[84] & 0x0f) << 28) |
			((uint32_t)input[85] << 20) |
			((uint32_t)(input[86] & 0xf0) << 12);
	output[42] = (double)(value >> 16);

	// read output[43]: from bit 692 to 707
	value = ((uint32_t)(input[86] & 0x0f) << 28) |
			((uint32_t)input[87] << 20) |
			((uint32_t)(input[88] & 0xf0) << 12);
	output[43] = (double)(value >> 16);

	// read output[44]: from bit 708 to 723
	value = ((uint32_t)(input[88] & 0x0f) << 28) |
			((uint32_t)input[89] << 20) |
			((uint32_t)(input[90] & 0xf0) << 12);
	output[44] = (double)(value >> 16);

	// read output[45]: from bit 724 to 739
	value = ((uint32_t)(input[90] & 0x0f) << 28) |
			((uint32_t)input[91] << 20) |
			((uint32_t)(input[92] & 0xf0) << 12);
	output[45] = (double)(value >> 16);

	// read output[46]: from bit 740 to 755
	value = ((uint32_t)(input[92] & 0x0f) << 28) |
			((uint32_t)input[93] << 20) |
			((uint32_t)(input[94] & 0xf0) << 12);
	output[46] = (double)(value >> 16);

	// read output[47]: from bit 756 to 771
	value = ((uint32_t)(input[94] & 0x0f) << 28) |
			((uint32_t)input[95] << 20) |
			((uint32_t)(input[96] & 0xf0) << 12);
	output[47] = (double)(value >> 16);

	// read output[48]: from bit 772 to 787
	value = ((uint32_t)(input[96] & 0x0f) << 28) |
			((uint32_t)input[97] << 20) |
			((uint32_t)(input[98] & 0xf0) << 12);
	output[48] = (double)(value >> 16);

	// read output[49]: from bit 788 to 803
	value = ((uint32_t)(input[98] & 0x0f) << 28) |
			((uint32_t)input[99] << 20) |
			((uint32_t)(input[100] & 0xf0) << 12);
	output[49] = (double)(value >> 16);

	// read output[50]: from bit 804 to 819
	value = ((uint32_t)(input[100] & 0x0f) << 28) |
			((uint32_t)input[101] << 20) |
			((uint32_t)(input[102] & 0xf0) << 12);
	output[50] = (double)(value >> 16);

	// read output[51]: from bit 820 to 835
	value = ((uint32_t)(input[102] & 0x0f) << 28) |
			((uint32_t)input[103] << 20) |
			((uint32_t)(input[104] & 0xf0) << 12);
	output[51] = (double)(value >> 16);

	// read output[52]: from bit 836 to 851
	value = ((uint32_t)(input[104] & 0x0f) << 28) |
			((uint32_t)input[105] << 20) |
			((uint32_t)(input[106] & 0xf0) << 12);
	output[52] = (double)(value >> 16);

	// read output[53]: from bit 852 to 867
	value = ((uint32_t)(input[106] & 0x0f) << 28) |
			((uint32_t)input[107] << 20) |
			((uint32_t)(input[108] & 0xf0) << 12);
	output[53] = (double)(value >> 16);

	// read output[54]: from bit 868 to 883
	value = ((uint32_t)(input[108] & 0x0f) << 28) |
			((uint32_t)input[109] << 20) |
			((uint32_t)(input[110] & 0xf0) << 12);
	output[54] = (double)(value >> 16);

	// read output[55]: from bit 884 to 899
	value = ((uint32_t)(input[110] & 0x0f) << 28) |
			((uint32_t)input[111] << 20) |
			((uint32_t)(input[112] & 0xf0) << 12);
	output[55] = (double)(value >> 16);

	// read output[56]: from bit 900 to 915
	value = ((uint32_t)(input[112] & 0x0f) << 28) |
			((uint32_t)input[113] << 20) |
			((uint32_t)(input[114] & 0xf0) << 12);
	output[56] = (double)(value >> 16);

	// read output[57]: from bit 916 to 931
	value = ((uint32_t)(input[114] & 0x0f) << 28) |
			((uint32_t)input[115] << 20) |
			((uint32_t)(input[116] & 0xf0) << 12);
	output[57] = (double)(value >> 16);
}

static void unpack_58_16bit_signed_5off(const uint8_t * input, double * output, void *closure) {
	// Unpack 58 values into output
	// Values are 16-bit signed
	// Skip 5 bits, read 928 bits of data.
	// Input must be at least 117 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 5 to 20
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)(input[2] & 0xf8) << 13);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 21 to 36
	value = ((uint32_t)(input[2] & 0x07) << 29) |
			((uint32_t)input[3] << 21) |
			((uint32_t)(input[4] & 0xf8) << 13);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 37 to 52
	value = ((uint32_t)(input[4] & 0x07) << 29) |
			((uint32_t)input[5] << 21) |
			((uint32_t)(input[6] & 0xf8) << 13);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 53 to 68
	value = ((uint32_t)(input[6] & 0x07) << 29) |
			((uint32_t)input[7] << 21) |
			((uint32_t)(input[8] & 0xf8) << 13);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 69 to 84
	value = ((uint32_t)(input[8] & 0x07) << 29) |
			((uint32_t)input[9] << 21) |
			((uint32_t)(input[10] & 0xf8) << 13);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 85 to 100
	value = ((uint32_t)(input[10] & 0x07) << 29) |
			((uint32_t)input[11] << 21) |
			((uint32_t)(input[12] & 0xf8) << 13);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 101 to 116
	value = ((uint32_t)(input[12] & 0x07) << 29) |
			((uint32_t)input[13] << 21) |
			((uint32_t)(input[14] & 0xf8) << 13);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 117 to 132
	value = ((uint32_t)(input[14] & 0x07) << 29) |
			((uint32_t)input[15] << 21) |
			((uint32_t)(input[16] & 0xf8) << 13);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 133 to 148
	value = ((uint32_t)(input[16] & 0x07) << 29) |
			((uint32_t)input[17] << 21) |
			((uint32_t)(input[18] & 0xf8) << 13);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 149 to 164
	value = ((uint32_t)(input[18] & 0x07) << 29) |
			((uint32_t)input[19] << 21) |
			((uint32_t)(input[20] & 0xf8) << 13);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 165 to 180
	value = ((uint32_t)(input[20] & 0x07) << 29) |
			((uint32_t)input[21] << 21) |
			((uint32_t)(input[22] & 0xf8) << 13);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 181 to 196
	value = ((uint32_t)(input[22] & 0x07) << 29) |
			((uint32_t)input[23] << 21) |
			((uint32_t)(input[24] & 0xf8) << 13);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 197 to 212
	value = ((uint32_t)(input[24] & 0x07) << 29) |
			((uint32_t)input[25] << 21) |
			((uint32_t)(input[26] & 0xf8) << 13);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 213 to 228
	value = ((uint32_t)(input[26] & 0x07) << 29) |
			((uint32_t)input[27] << 21) |
			((uint32_t)(input[28] & 0xf8) << 13);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 229 to 244
	value = ((uint32_t)(input[28] & 0x07) << 29) |
			((uint32_t)input[29] << 21) |
			((uint32_t)(input[30] & 0xf8) << 13);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 245 to 260
	value = ((uint32_t)(input[30] & 0x07) << 29) |
			((uint32_t)input[31] << 21) |
			((uint32_t)(input[32] & 0xf8) << 13);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 261 to 276
	value = ((uint32_t)(input[32] & 0x07) << 29) |
			((uint32_t)input[33] << 21) |
			((uint32_t)(input[34] & 0xf8) << 13);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 277 to 292
	value = ((uint32_t)(input[34] & 0x07) << 29) |
			((uint32_t)input[35] << 21) |
			((uint32_t)(input[36] & 0xf8) << 13);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 293 to 308
	value = ((uint32_t)(input[36] & 0x07) << 29) |
			((uint32_t)input[37] << 21) |
			((uint32_t)(input[38] & 0xf8) << 13);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 309 to 324
	value = ((uint32_t)(input[38] & 0x07) << 29) |
			((uint32_t)input[39] << 21) |
			((uint32_t)(input[40] & 0xf8) << 13);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 325 to 340
	value = ((uint32_t)(input[40] & 0x07) << 29) |
			((uint32_t)input[41] << 21) |
			((uint32_t)(input[42] & 0xf8) << 13);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 341 to 356
	value = ((uint32_t)(input[42] & 0x07) << 29) |
			((uint32_t)input[43] << 21) |
			((uint32_t)(input[44] & 0xf8) << 13);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 357 to 372
	value = ((uint32_t)(input[44] & 0x07) << 29) |
			((uint32_t)input[45] << 21) |
			((uint32_t)(input[46] & 0xf8) << 13);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 373 to 388
	value = ((uint32_t)(input[46] & 0x07) << 29) |
			((uint32_t)input[47] << 21) |
			((uint32_t)(input[48] & 0xf8) << 13);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 389 to 404
	value = ((uint32_t)(input[48] & 0x07) << 29) |
			((uint32_t)input[49] << 21) |
			((uint32_t)(input[50] & 0xf8) << 13);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 405 to 420
	value = ((uint32_t)(input[50] & 0x07) << 29) |
			((uint32_t)input[51] << 21) |
			((uint32_t)(input[52] & 0xf8) << 13);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 421 to 436
	value = ((uint32_t)(input[52] & 0x07) << 29) |
			((uint32_t)input[53] << 21) |
			((uint32_t)(input[54] & 0xf8) << 13);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 437 to 452
	value = ((uint32_t)(input[54] & 0x07) << 29) |
			((uint32_t)input[55] << 21) |
			((uint32_t)(input[56] & 0xf8) << 13);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 453 to 468
	value = ((uint32_t)(input[56] & 0x07) << 29) |
			((uint32_t)input[57] << 21) |
			((uint32_t)(input[58] & 0xf8) << 13);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 469 to 484
	value = ((uint32_t)(input[58] & 0x07) << 29) |
			((uint32_t)input[59] << 21) |
			((uint32_t)(input[60] & 0xf8) << 13);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 485 to 500
	value = ((uint32_t)(input[60] & 0x07) << 29) |
			((uint32_t)input[61] << 21) |
			((uint32_t)(input[62] & 0xf8) << 13);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 501 to 516
	value = ((uint32_t)(input[62] & 0x07) << 29) |
			((uint32_t)input[63] << 21) |
			((uint32_t)(input[64] & 0xf8) << 13);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 517 to 532
	value = ((uint32_t)(input[64] & 0x07) << 29) |
			((uint32_t)input[65] << 21) |
			((uint32_t)(input[66] & 0xf8) << 13);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 533 to 548
	value = ((uint32_t)(input[66] & 0x07) << 29) |
			((uint32_t)input[67] << 21) |
			((uint32_t)(input[68] & 0xf8) << 13);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 549 to 564
	value = ((uint32_t)(input[68] & 0x07) << 29) |
			((uint32_t)input[69] << 21) |
			((uint32_t)(input[70] & 0xf8) << 13);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 565 to 580
	value = ((uint32_t)(input[70] & 0x07) << 29) |
			((uint32_t)input[71] << 21) |
			((uint32_t)(input[72] & 0xf8) << 13);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 581 to 596
	value = ((uint32_t)(input[72] & 0x07) << 29) |
			((uint32_t)input[73] << 21) |
			((uint32_t)(input[74] & 0xf8) << 13);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 597 to 612
	value = ((uint32_t)(input[74] & 0x07) << 29) |
			((uint32_t)input[75] << 21) |
			((uint32_t)(input[76] & 0xf8) << 13);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 613 to 628
	value = ((uint32_t)(input[76] & 0x07) << 29) |
			((uint32_t)input[77] << 21) |
			((uint32_t)(input[78] & 0xf8) << 13);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 629 to 644
	value = ((uint32_t)(input[78] & 0x07) << 29) |
			((uint32_t)input[79] << 21) |
			((uint32_t)(input[80] & 0xf8) << 13);
	output[39] = (double)(value >> 16);

	// read output[40]: from bit 645 to 660
	value = ((uint32_t)(input[80] & 0x07) << 29) |
			((uint32_t)input[81] << 21) |
			((uint32_t)(input[82] & 0xf8) << 13);
	output[40] = (double)(value >> 16);

	// read output[41]: from bit 661 to 676
	value = ((uint32_t)(input[82] & 0x07) << 29) |
			((uint32_t)input[83] << 21) |
			((uint32_t)(input[84] & 0xf8) << 13);
	output[41] = (double)(value >> 16);

	// read output[42]: from bit 677 to 692
	value = ((uint32_t)(input[84] & 0x07) << 29) |
			((uint32_t)input[85] << 21) |
			((uint32_t)(input[86] & 0xf8) << 13);
	output[42] = (double)(value >> 16);

	// read output[43]: from bit 693 to 708
	value = ((uint32_t)(input[86] & 0x07) << 29) |
			((uint32_t)input[87] << 21) |
			((uint32_t)(input[88] & 0xf8) << 13);
	output[43] = (double)(value >> 16);

	// read output[44]: from bit 709 to 724
	value = ((uint32_t)(input[88] & 0x07) << 29) |
			((uint32_t)input[89] << 21) |
			((uint32_t)(input[90] & 0xf8) << 13);
	output[44] = (double)(value >> 16);

	// read output[45]: from bit 725 to 740
	value = ((uint32_t)(input[90] & 0x07) << 29) |
			((uint32_t)input[91] << 21) |
			((uint32_t)(input[92] & 0xf8) << 13);
	output[45] = (double)(value >> 16);

	// read output[46]: from bit 741 to 756
	value = ((uint32_t)(input[92] & 0x07) << 29) |
			((uint32_t)input[93] << 21) |
			((uint32_t)(input[94] & 0xf8) << 13);
	output[46] = (double)(value >> 16);

	// read output[47]: from bit 757 to 772
	value = ((uint32_t)(input[94] & 0x07) << 29) |
			((uint32_t)input[95] << 21) |
			((uint32_t)(input[96] & 0xf8) << 13);
	output[47] = (double)(value >> 16);

	// read output[48]: from bit 773 to 788
	value = ((uint32_t)(input[96] & 0x07) << 29) |
			((uint32_t)input[97] << 21) |
			((uint32_t)(input[98] & 0xf8) << 13);
	output[48] = (double)(value >> 16);

	// read output[49]: from bit 789 to 804
	value = ((uint32_t)(input[98] & 0x07) << 29) |
			((uint32_t)input[99] << 21) |
			((uint32_t)(input[100] & 0xf8) << 13);
	output[49] = (double)(value >> 16);

	// read output[50]: from bit 805 to 820
	value = ((uint32_t)(input[100] & 0x07) << 29) |
			((uint32_t)input[101] << 21) |
			((uint32_t)(input[102] & 0xf8) << 13);
	output[50] = (double)(value >> 16);

	// read output[51]: from bit 821 to 836
	value = ((uint32_t)(input[102] & 0x07) << 29) |
			((uint32_t)input[103] << 21) |
			((uint32_t)(input[104] & 0xf8) << 13);
	output[51] = (double)(value >> 16);

	// read output[52]: from bit 837 to 852
	value = ((uint32_t)(input[104] & 0x07) << 29) |
			((uint32_t)input[105] << 21) |
			((uint32_t)(input[106] & 0xf8) << 13);
	output[52] = (double)(value >> 16);

	// read output[53]: from bit 853 to 868
	value = ((uint32_t)(input[106] & 0x07) << 29) |
			((uint32_t)input[107] << 21) |
			((uint32_t)(input[108] & 0xf8) << 13);
	output[53] = (double)(value >> 16);

	// read output[54]: from bit 869 to 884
	value = ((uint32_t)(input[108] & 0x07) << 29) |
			((uint32_t)input[109] << 21) |
			((uint32_t)(input[110] & 0xf8) << 13);
	output[54] = (double)(value >> 16);

	// read output[55]: from bit 885 to 900
	value = ((uint32_t)(input[110] & 0x07) << 29) |
			((uint32_t)input[111] << 21) |
			((uint32_t)(input[112] & 0xf8) << 13);
	output[55] = (double)(value >> 16);

	// read output[56]: from bit 901 to 916
	value = ((uint32_t)(input[112] & 0x07) << 29) |
			((uint32_t)input[113] << 21) |
			((uint32_t)(input[114] & 0xf8) << 13);
	output[56] = (double)(value >> 16);

	// read output[57]: from bit 917 to 932
	value = ((uint32_t)(input[114] & 0x07) << 29) |
			((uint32_t)input[115] << 21) |
			((uint32_t)(input[116] & 0xf8) << 13);
	output[57] = (double)(value >> 16);
}

static void unpack_58_16bit_unsigned_5off(const uint8_t * input, double * output, void *closure) {
	// Unpack 58 values into output
	// Values are 16-bit unsigned
	// Skip 5 bits, read 928 bits of data.
	// Input must be at least 117 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 5 to 20
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)(input[2] & 0xf8) << 13);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 21 to 36
	value = ((uint32_t)(input[2] & 0x07) << 29) |
			((uint32_t)input[3] << 21) |
			((uint32_t)(input[4] & 0xf8) << 13);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 37 to 52
	value = ((uint32_t)(input[4] & 0x07) << 29) |
			((uint32_t)input[5] << 21) |
			((uint32_t)(input[6] & 0xf8) << 13);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 53 to 68
	value = ((uint32_t)(input[6] & 0x07) << 29) |
			((uint32_t)input[7] << 21) |
			((uint32_t)(input[8] & 0xf8) << 13);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 69 to 84
	value = ((uint32_t)(input[8] & 0x07) << 29) |
			((uint32_t)input[9] << 21) |
			((uint32_t)(input[10] & 0xf8) << 13);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 85 to 100
	value = ((uint32_t)(input[10] & 0x07) << 29) |
			((uint32_t)input[11] << 21) |
			((uint32_t)(input[12] & 0xf8) << 13);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 101 to 116
	value = ((uint32_t)(input[12] & 0x07) << 29) |
			((uint32_t)input[13] << 21) |
			((uint32_t)(input[14] & 0xf8) << 13);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 117 to 132
	value = ((uint32_t)(input[14] & 0x07) << 29) |
			((uint32_t)input[15] << 21) |
			((uint32_t)(input[16] & 0xf8) << 13);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 133 to 148
	value = ((uint32_t)(input[16] & 0x07) << 29) |
			((uint32_t)input[17] << 21) |
			((uint32_t)(input[18] & 0xf8) << 13);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 149 to 164
	value = ((uint32_t)(input[18] & 0x07) << 29) |
			((uint32_t)input[19] << 21) |
			((uint32_t)(input[20] & 0xf8) << 13);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 165 to 180
	value = ((uint32_t)(input[20] & 0x07) << 29) |
			((uint32_t)input[21] << 21) |
			((uint32_t)(input[22] & 0xf8) << 13);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 181 to 196
	value = ((uint32_t)(input[22] & 0x07) << 29) |
			((uint32_t)input[23] << 21) |
			((uint32_t)(input[24] & 0xf8) << 13);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 197 to 212
	value = ((uint32_t)(input[24] & 0x07) << 29) |
			((uint32_t)input[25] << 21) |
			((uint32_t)(input[26] & 0xf8) << 13);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 213 to 228
	value = ((uint32_t)(input[26] & 0x07) << 29) |
			((uint32_t)input[27] << 21) |
			((uint32_t)(input[28] & 0xf8) << 13);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 229 to 244
	value = ((uint32_t)(input[28] & 0x07) << 29) |
			((uint32_t)input[29] << 21) |
			((uint32_t)(input[30] & 0xf8) << 13);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 245 to 260
	value = ((uint32_t)(input[30] & 0x07) << 29) |
			((uint32_t)input[31] << 21) |
			((uint32_t)(input[32] & 0xf8) << 13);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 261 to 276
	value = ((uint32_t)(input[32] & 0x07) << 29) |
			((uint32_t)input[33] << 21) |
			((uint32_t)(input[34] & 0xf8) << 13);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 277 to 292
	value = ((uint32_t)(input[34] & 0x07) << 29) |
			((uint32_t)input[35] << 21) |
			((uint32_t)(input[36] & 0xf8) << 13);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 293 to 308
	value = ((uint32_t)(input[36] & 0x07) << 29) |
			((uint32_t)input[37] << 21) |
			((uint32_t)(input[38] & 0xf8) << 13);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 309 to 324
	value = ((uint32_t)(input[38] & 0x07) << 29) |
			((uint32_t)input[39] << 21) |
			((uint32_t)(input[40] & 0xf8) << 13);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 325 to 340
	value = ((uint32_t)(input[40] & 0x07) << 29) |
			((uint32_t)input[41] << 21) |
			((uint32_t)(input[42] & 0xf8) << 13);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 341 to 356
	value = ((uint32_t)(input[42] & 0x07) << 29) |
			((uint32_t)input[43] << 21) |
			((uint32_t)(input[44] & 0xf8) << 13);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 357 to 372
	value = ((uint32_t)(input[44] & 0x07) << 29) |
			((uint32_t)input[45] << 21) |
			((uint32_t)(input[46] & 0xf8) << 13);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 373 to 388
	value = ((uint32_t)(input[46] & 0x07) << 29) |
			((uint32_t)input[47] << 21) |
			((uint32_t)(input[48] & 0xf8) << 13);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 389 to 404
	value = ((uint32_t)(input[48] & 0x07) << 29) |
			((uint32_t)input[49] << 21) |
			((uint32_t)(input[50] & 0xf8) << 13);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 405 to 420
	value = ((uint32_t)(input[50] & 0x07) << 29) |
			((uint32_t)input[51] << 21) |
			((uint32_t)(input[52] & 0xf8) << 13);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 421 to 436
	value = ((uint32_t)(input[52] & 0x07) << 29) |
			((uint32_t)input[53] << 21) |
			((uint32_t)(input[54] & 0xf8) << 13);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 437 to 452
	value = ((uint32_t)(input[54] & 0x07) << 29) |
			((uint32_t)input[55] << 21) |
			((uint32_t)(input[56] & 0xf8) << 13);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 453 to 468
	value = ((uint32_t)(input[56] & 0x07) << 29) |
			((uint32_t)input[57] << 21) |
			((uint32_t)(input[58] & 0xf8) << 13);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 469 to 484
	value = ((uint32_t)(input[58] & 0x07) << 29) |
			((uint32_t)input[59] << 21) |
			((uint32_t)(input[60] & 0xf8) << 13);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 485 to 500
	value = ((uint32_t)(input[60] & 0x07) << 29) |
			((uint32_t)input[61] << 21) |
			((uint32_t)(input[62] & 0xf8) << 13);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 501 to 516
	value = ((uint32_t)(input[62] & 0x07) << 29) |
			((uint32_t)input[63] << 21) |
			((uint32_t)(input[64] & 0xf8) << 13);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 517 to 532
	value = ((uint32_t)(input[64] & 0x07) << 29) |
			((uint32_t)input[65] << 21) |
			((uint32_t)(input[66] & 0xf8) << 13);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 533 to 548
	value = ((uint32_t)(input[66] & 0x07) << 29) |
			((uint32_t)input[67] << 21) |
			((uint32_t)(input[68] & 0xf8) << 13);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 549 to 564
	value = ((uint32_t)(input[68] & 0x07) << 29) |
			((uint32_t)input[69] << 21) |
			((uint32_t)(input[70] & 0xf8) << 13);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 565 to 580
	value = ((uint32_t)(input[70] & 0x07) << 29) |
			((uint32_t)input[71] << 21) |
			((uint32_t)(input[72] & 0xf8) << 13);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 581 to 596
	value = ((uint32_t)(input[72] & 0x07) << 29) |
			((uint32_t)input[73] << 21) |
			((uint32_t)(input[74] & 0xf8) << 13);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 597 to 612
	value = ((uint32_t)(input[74] & 0x07) << 29) |
			((uint32_t)input[75] << 21) |
			((uint32_t)(input[76] & 0xf8) << 13);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 613 to 628
	value = ((uint32_t)(input[76] & 0x07) << 29) |
			((uint32_t)input[77] << 21) |
			((uint32_t)(input[78] & 0xf8) << 13);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 629 to 644
	value = ((uint32_t)(input[78] & 0x07) << 29) |
			((uint32_t)input[79] << 21) |
			((uint32_t)(input[80] & 0xf8) << 13);
	output[39] = (double)(value >> 16);

	// read output[40]: from bit 645 to 660
	value = ((uint32_t)(input[80] & 0x07) << 29) |
			((uint32_t)input[81] << 21) |
			((uint32_t)(input[82] & 0xf8) << 13);
	output[40] = (double)(value >> 16);

	// read output[41]: from bit 661 to 676
	value = ((uint32_t)(input[82] & 0x07) << 29) |
			((uint32_t)input[83] << 21) |
			((uint32_t)(input[84] & 0xf8) << 13);
	output[41] = (double)(value >> 16);

	// read output[42]: from bit 677 to 692
	value = ((uint32_t)(input[84] & 0x07) << 29) |
			((uint32_t)input[85] << 21) |
			((uint32_t)(input[86] & 0xf8) << 13);
	output[42] = (double)(value >> 16);

	// read output[43]: from bit 693 to 708
	value = ((uint32_t)(input[86] & 0x07) << 29) |
			((uint32_t)input[87] << 21) |
			((uint32_t)(input[88] & 0xf8) << 13);
	output[43] = (double)(value >> 16);

	// read output[44]: from bit 709 to 724
	value = ((uint32_t)(input[88] & 0x07) << 29) |
			((uint32_t)input[89] << 21) |
			((uint32_t)(input[90] & 0xf8) << 13);
	output[44] = (double)(value >> 16);

	// read output[45]: from bit 725 to 740
	value = ((uint32_t)(input[90] & 0x07) << 29) |
			((uint32_t)input[91] << 21) |
			((uint32_t)(input[92] & 0xf8) << 13);
	output[45] = (double)(value >> 16);

	// read output[46]: from bit 741 to 756
	value = ((uint32_t)(input[92] & 0x07) << 29) |
			((uint32_t)input[93] << 21) |
			((uint32_t)(input[94] & 0xf8) << 13);
	output[46] = (double)(value >> 16);

	// read output[47]: from bit 757 to 772
	value = ((uint32_t)(input[94] & 0x07) << 29) |
			((uint32_t)input[95] << 21) |
			((uint32_t)(input[96] & 0xf8) << 13);
	output[47] = (double)(value >> 16);

	// read output[48]: from bit 773 to 788
	value = ((uint32_t)(input[96] & 0x07) << 29) |
			((uint32_t)input[97] << 21) |
			((uint32_t)(input[98] & 0xf8) << 13);
	output[48] = (double)(value >> 16);

	// read output[49]: from bit 789 to 804
	value = ((uint32_t)(input[98] & 0x07) << 29) |
			((uint32_t)input[99] << 21) |
			((uint32_t)(input[100] & 0xf8) << 13);
	output[49] = (double)(value >> 16);

	// read output[50]: from bit 805 to 820
	value = ((uint32_t)(input[100] & 0x07) << 29) |
			((uint32_t)input[101] << 21) |
			((uint32_t)(input[102] & 0xf8) << 13);
	output[50] = (double)(value >> 16);

	// read output[51]: from bit 821 to 836
	value = ((uint32_t)(input[102] & 0x07) << 29) |
			((uint32_t)input[103] << 21) |
			((uint32_t)(input[104] & 0xf8) << 13);
	output[51] = (double)(value >> 16);

	// read output[52]: from bit 837 to 852
	value = ((uint32_t)(input[104] & 0x07) << 29) |
			((uint32_t)input[105] << 21) |
			((uint32_t)(input[106] & 0xf8) << 13);
	output[52] = (double)(value >> 16);

	// read output[53]: from bit 853 to 868
	value = ((uint32_t)(input[106] & 0x07) << 29) |
			((uint32_t)input[107] << 21) |
			((uint32_t)(input[108] & 0xf8) << 13);
	output[53] = (double)(value >> 16);

	// read output[54]: from bit 869 to 884
	value = ((uint32_t)(input[108] & 0x07) << 29) |
			((uint32_t)input[109] << 21) |
			((uint32_t)(input[110] & 0xf8) << 13);
	output[54] = (double)(value >> 16);

	// read output[55]: from bit 885 to 900
	value = ((uint32_t)(input[110] & 0x07) << 29) |
			((uint32_t)input[111] << 21) |
			((uint32_t)(input[112] & 0xf8) << 13);
	output[55] = (double)(value >> 16);

	// read output[56]: from bit 901 to 916
	value = ((uint32_t)(input[112] & 0x07) << 29) |
			((uint32_t)input[113] << 21) |
			((uint32_t)(input[114] & 0xf8) << 13);
	output[56] = (double)(value >> 16);

	// read output[57]: from bit 917 to 932
	value = ((uint32_t)(input[114] & 0x07) << 29) |
			((uint32_t)input[115] << 21) |
			((uint32_t)(input[116] & 0xf8) << 13);
	output[57] = (double)(value >> 16);
}

static void unpack_58_16bit_signed_6off(const uint8_t * input, double * output, void *closure) {
	// Unpack 58 values into output
	// Values are 16-bit signed
	// Skip 6 bits, read 928 bits of data.
	// Input must be at least 117 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 6 to 21
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)(input[2] & 0xfc) << 14);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 22 to 37
	value = ((uint32_t)(input[2] & 0x03) << 30) |
			((uint32_t)input[3] << 22) |
			((uint32_t)(input[4] & 0xfc) << 14);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 38 to 53
	value = ((uint32_t)(input[4] & 0x03) << 30) |
			((uint32_t)input[5] << 22) |
			((uint32_t)(input[6] & 0xfc) << 14);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 54 to 69
	value = ((uint32_t)(input[6] & 0x03) << 30) |
			((uint32_t)input[7] << 22) |
			((uint32_t)(input[8] & 0xfc) << 14);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 70 to 85
	value = ((uint32_t)(input[8] & 0x03) << 30) |
			((uint32_t)input[9] << 22) |
			((uint32_t)(input[10] & 0xfc) << 14);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 86 to 101
	value = ((uint32_t)(input[10] & 0x03) << 30) |
			((uint32_t)input[11] << 22) |
			((uint32_t)(input[12] & 0xfc) << 14);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 102 to 117
	value = ((uint32_t)(input[12] & 0x03) << 30) |
			((uint32_t)input[13] << 22) |
			((uint32_t)(input[14] & 0xfc) << 14);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 118 to 133
	value = ((uint32_t)(input[14] & 0x03) << 30) |
			((uint32_t)input[15] << 22) |
			((uint32_t)(input[16] & 0xfc) << 14);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 134 to 149
	value = ((uint32_t)(input[16] & 0x03) << 30) |
			((uint32_t)input[17] << 22) |
			((uint32_t)(input[18] & 0xfc) << 14);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 150 to 165
	value = ((uint32_t)(input[18] & 0x03) << 30) |
			((uint32_t)input[19] << 22) |
			((uint32_t)(input[20] & 0xfc) << 14);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 166 to 181
	value = ((uint32_t)(input[20] & 0x03) << 30) |
			((uint32_t)input[21] << 22) |
			((uint32_t)(input[22] & 0xfc) << 14);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 182 to 197
	value = ((uint32_t)(input[22] & 0x03) << 30) |
			((uint32_t)input[23] << 22) |
			((uint32_t)(input[24] & 0xfc) << 14);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 198 to 213
	value = ((uint32_t)(input[24] & 0x03) << 30) |
			((uint32_t)input[25] << 22) |
			((uint32_t)(input[26] & 0xfc) << 14);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 214 to 229
	value = ((uint32_t)(input[26] & 0x03) << 30) |
			((uint32_t)input[27] << 22) |
			((uint32_t)(input[28] & 0xfc) << 14);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 230 to 245
	value = ((uint32_t)(input[28] & 0x03) << 30) |
			((uint32_t)input[29] << 22) |
			((uint32_t)(input[30] & 0xfc) << 14);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 246 to 261
	value = ((uint32_t)(input[30] & 0x03) << 30) |
			((uint32_t)input[31] << 22) |
			((uint32_t)(input[32] & 0xfc) << 14);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 262 to 277
	value = ((uint32_t)(input[32] & 0x03) << 30) |
			((uint32_t)input[33] << 22) |
			((uint32_t)(input[34] & 0xfc) << 14);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 278 to 293
	value = ((uint32_t)(input[34] & 0x03) << 30) |
			((uint32_t)input[35] << 22) |
			((uint32_t)(input[36] & 0xfc) << 14);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 294 to 309
	value = ((uint32_t)(input[36] & 0x03) << 30) |
			((uint32_t)input[37] << 22) |
			((uint32_t)(input[38] & 0xfc) << 14);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 310 to 325
	value = ((uint32_t)(input[38] & 0x03) << 30) |
			((uint32_t)input[39] << 22) |
			((uint32_t)(input[40] & 0xfc) << 14);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 326 to 341
	value = ((uint32_t)(input[40] & 0x03) << 30) |
			((uint32_t)input[41] << 22) |
			((uint32_t)(input[42] & 0xfc) << 14);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 342 to 357
	value = ((uint32_t)(input[42] & 0x03) << 30) |
			((uint32_t)input[43] << 22) |
			((uint32_t)(input[44] & 0xfc) << 14);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 358 to 373
	value = ((uint32_t)(input[44] & 0x03) << 30) |
			((uint32_t)input[45] << 22) |
			((uint32_t)(input[46] & 0xfc) << 14);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 374 to 389
	value = ((uint32_t)(input[46] & 0x03) << 30) |
			((uint32_t)input[47] << 22) |
			((uint32_t)(input[48] & 0xfc) << 14);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 390 to 405
	value = ((uint32_t)(input[48] & 0x03) << 30) |
			((uint32_t)input[49] << 22) |
			((uint32_t)(input[50] & 0xfc) << 14);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 406 to 421
	value = ((uint32_t)(input[50] & 0x03) << 30) |
			((uint32_t)input[51] << 22) |
			((uint32_t)(input[52] & 0xfc) << 14);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 422 to 437
	value = ((uint32_t)(input[52] & 0x03) << 30) |
			((uint32_t)input[53] << 22) |
			((uint32_t)(input[54] & 0xfc) << 14);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 438 to 453
	value = ((uint32_t)(input[54] & 0x03) << 30) |
			((uint32_t)input[55] << 22) |
			((uint32_t)(input[56] & 0xfc) << 14);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 454 to 469
	value = ((uint32_t)(input[56] & 0x03) << 30) |
			((uint32_t)input[57] << 22) |
			((uint32_t)(input[58] & 0xfc) << 14);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 470 to 485
	value = ((uint32_t)(input[58] & 0x03) << 30) |
			((uint32_t)input[59] << 22) |
			((uint32_t)(input[60] & 0xfc) << 14);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 486 to 501
	value = ((uint32_t)(input[60] & 0x03) << 30) |
			((uint32_t)input[61] << 22) |
			((uint32_t)(input[62] & 0xfc) << 14);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 502 to 517
	value = ((uint32_t)(input[62] & 0x03) << 30) |
			((uint32_t)input[63] << 22) |
			((uint32_t)(input[64] & 0xfc) << 14);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 518 to 533
	value = ((uint32_t)(input[64] & 0x03) << 30) |
			((uint32_t)input[65] << 22) |
			((uint32_t)(input[66] & 0xfc) << 14);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 534 to 549
	value = ((uint32_t)(input[66] & 0x03) << 30) |
			((uint32_t)input[67] << 22) |
			((uint32_t)(input[68] & 0xfc) << 14);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 550 to 565
	value = ((uint32_t)(input[68] & 0x03) << 30) |
			((uint32_t)input[69] << 22) |
			((uint32_t)(input[70] & 0xfc) << 14);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 566 to 581
	value = ((uint32_t)(input[70] & 0x03) << 30) |
			((uint32_t)input[71] << 22) |
			((uint32_t)(input[72] & 0xfc) << 14);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 582 to 597
	value = ((uint32_t)(input[72] & 0x03) << 30) |
			((uint32_t)input[73] << 22) |
			((uint32_t)(input[74] & 0xfc) << 14);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 598 to 613
	value = ((uint32_t)(input[74] & 0x03) << 30) |
			((uint32_t)input[75] << 22) |
			((uint32_t)(input[76] & 0xfc) << 14);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 614 to 629
	value = ((uint32_t)(input[76] & 0x03) << 30) |
			((uint32_t)input[77] << 22) |
			((uint32_t)(input[78] & 0xfc) << 14);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 630 to 645
	value = ((uint32_t)(input[78] & 0x03) << 30) |
			((uint32_t)input[79] << 22) |
			((uint32_t)(input[80] & 0xfc) << 14);
	output[39] = (double)(value >> 16);

	// read output[40]: from bit 646 to 661
	value = ((uint32_t)(input[80] & 0x03) << 30) |
			((uint32_t)input[81] << 22) |
			((uint32_t)(input[82] & 0xfc) << 14);
	output[40] = (double)(value >> 16);

	// read output[41]: from bit 662 to 677
	value = ((uint32_t)(input[82] & 0x03) << 30) |
			((uint32_t)input[83] << 22) |
			((uint32_t)(input[84] & 0xfc) << 14);
	output[41] = (double)(value >> 16);

	// read output[42]: from bit 678 to 693
	value = ((uint32_t)(input[84] & 0x03) << 30) |
			((uint32_t)input[85] << 22) |
			((uint32_t)(input[86] & 0xfc) << 14);
	output[42] = (double)(value >> 16);

	// read output[43]: from bit 694 to 709
	value = ((uint32_t)(input[86] & 0x03) << 30) |
			((uint32_t)input[87] << 22) |
			((uint32_t)(input[88] & 0xfc) << 14);
	output[43] = (double)(value >> 16);

	// read output[44]: from bit 710 to 725
	value = ((uint32_t)(input[88] & 0x03) << 30) |
			((uint32_t)input[89] << 22) |
			((uint32_t)(input[90] & 0xfc) << 14);
	output[44] = (double)(value >> 16);

	// read output[45]: from bit 726 to 741
	value = ((uint32_t)(input[90] & 0x03) << 30) |
			((uint32_t)input[91] << 22) |
			((uint32_t)(input[92] & 0xfc) << 14);
	output[45] = (double)(value >> 16);

	// read output[46]: from bit 742 to 757
	value = ((uint32_t)(input[92] & 0x03) << 30) |
			((uint32_t)input[93] << 22) |
			((uint32_t)(input[94] & 0xfc) << 14);
	output[46] = (double)(value >> 16);

	// read output[47]: from bit 758 to 773
	value = ((uint32_t)(input[94] & 0x03) << 30) |
			((uint32_t)input[95] << 22) |
			((uint32_t)(input[96] & 0xfc) << 14);
	output[47] = (double)(value >> 16);

	// read output[48]: from bit 774 to 789
	value = ((uint32_t)(input[96] & 0x03) << 30) |
			((uint32_t)input[97] << 22) |
			((uint32_t)(input[98] & 0xfc) << 14);
	output[48] = (double)(value >> 16);

	// read output[49]: from bit 790 to 805
	value = ((uint32_t)(input[98] & 0x03) << 30) |
			((uint32_t)input[99] << 22) |
			((uint32_t)(input[100] & 0xfc) << 14);
	output[49] = (double)(value >> 16);

	// read output[50]: from bit 806 to 821
	value = ((uint32_t)(input[100] & 0x03) << 30) |
			((uint32_t)input[101] << 22) |
			((uint32_t)(input[102] & 0xfc) << 14);
	output[50] = (double)(value >> 16);

	// read output[51]: from bit 822 to 837
	value = ((uint32_t)(input[102] & 0x03) << 30) |
			((uint32_t)input[103] << 22) |
			((uint32_t)(input[104] & 0xfc) << 14);
	output[51] = (double)(value >> 16);

	// read output[52]: from bit 838 to 853
	value = ((uint32_t)(input[104] & 0x03) << 30) |
			((uint32_t)input[105] << 22) |
			((uint32_t)(input[106] & 0xfc) << 14);
	output[52] = (double)(value >> 16);

	// read output[53]: from bit 854 to 869
	value = ((uint32_t)(input[106] & 0x03) << 30) |
			((uint32_t)input[107] << 22) |
			((uint32_t)(input[108] & 0xfc) << 14);
	output[53] = (double)(value >> 16);

	// read output[54]: from bit 870 to 885
	value = ((uint32_t)(input[108] & 0x03) << 30) |
			((uint32_t)input[109] << 22) |
			((uint32_t)(input[110] & 0xfc) << 14);
	output[54] = (double)(value >> 16);

	// read output[55]: from bit 886 to 901
	value = ((uint32_t)(input[110] & 0x03) << 30) |
			((uint32_t)input[111] << 22) |
			((uint32_t)(input[112] & 0xfc) << 14);
	output[55] = (double)(value >> 16);

	// read output[56]: from bit 902 to 917
	value = ((uint32_t)(input[112] & 0x03) << 30) |
			((uint32_t)input[113] << 22) |
			((uint32_t)(input[114] & 0xfc) << 14);
	output[56] = (double)(value >> 16);

	// read output[57]: from bit 918 to 933
	value = ((uint32_t)(input[114] & 0x03) << 30) |
			((uint32_t)input[115] << 22) |
			((uint32_t)(input[116] & 0xfc) << 14);
	output[57] = (double)(value >> 16);
}

static void unpack_58_16bit_unsigned_6off(const uint8_t * input, double * output, void *closure) {
	// Unpack 58 values into output
	// Values are 16-bit unsigned
	// Skip 6 bits, read 928 bits of data.
	// Input must be at least 117 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 6 to 21
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)(input[2] & 0xfc) << 14);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 22 to 37
	value = ((uint32_t)(input[2] & 0x03) << 30) |
			((uint32_t)input[3] << 22) |
			((uint32_t)(input[4] & 0xfc) << 14);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 38 to 53
	value = ((uint32_t)(input[4] & 0x03) << 30) |
			((uint32_t)input[5] << 22) |
			((uint32_t)(input[6] & 0xfc) << 14);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 54 to 69
	value = ((uint32_t)(input[6] & 0x03) << 30) |
			((uint32_t)input[7] << 22) |
			((uint32_t)(input[8] & 0xfc) << 14);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 70 to 85
	value = ((uint32_t)(input[8] & 0x03) << 30) |
			((uint32_t)input[9] << 22) |
			((uint32_t)(input[10] & 0xfc) << 14);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 86 to 101
	value = ((uint32_t)(input[10] & 0x03) << 30) |
			((uint32_t)input[11] << 22) |
			((uint32_t)(input[12] & 0xfc) << 14);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 102 to 117
	value = ((uint32_t)(input[12] & 0x03) << 30) |
			((uint32_t)input[13] << 22) |
			((uint32_t)(input[14] & 0xfc) << 14);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 118 to 133
	value = ((uint32_t)(input[14] & 0x03) << 30) |
			((uint32_t)input[15] << 22) |
			((uint32_t)(input[16] & 0xfc) << 14);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 134 to 149
	value = ((uint32_t)(input[16] & 0x03) << 30) |
			((uint32_t)input[17] << 22) |
			((uint32_t)(input[18] & 0xfc) << 14);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 150 to 165
	value = ((uint32_t)(input[18] & 0x03) << 30) |
			((uint32_t)input[19] << 22) |
			((uint32_t)(input[20] & 0xfc) << 14);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 166 to 181
	value = ((uint32_t)(input[20] & 0x03) << 30) |
			((uint32_t)input[21] << 22) |
			((uint32_t)(input[22] & 0xfc) << 14);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 182 to 197
	value = ((uint32_t)(input[22] & 0x03) << 30) |
			((uint32_t)input[23] << 22) |
			((uint32_t)(input[24] & 0xfc) << 14);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 198 to 213
	value = ((uint32_t)(input[24] & 0x03) << 30) |
			((uint32_t)input[25] << 22) |
			((uint32_t)(input[26] & 0xfc) << 14);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 214 to 229
	value = ((uint32_t)(input[26] & 0x03) << 30) |
			((uint32_t)input[27] << 22) |
			((uint32_t)(input[28] & 0xfc) << 14);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 230 to 245
	value = ((uint32_t)(input[28] & 0x03) << 30) |
			((uint32_t)input[29] << 22) |
			((uint32_t)(input[30] & 0xfc) << 14);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 246 to 261
	value = ((uint32_t)(input[30] & 0x03) << 30) |
			((uint32_t)input[31] << 22) |
			((uint32_t)(input[32] & 0xfc) << 14);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 262 to 277
	value = ((uint32_t)(input[32] & 0x03) << 30) |
			((uint32_t)input[33] << 22) |
			((uint32_t)(input[34] & 0xfc) << 14);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 278 to 293
	value = ((uint32_t)(input[34] & 0x03) << 30) |
			((uint32_t)input[35] << 22) |
			((uint32_t)(input[36] & 0xfc) << 14);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 294 to 309
	value = ((uint32_t)(input[36] & 0x03) << 30) |
			((uint32_t)input[37] << 22) |
			((uint32_t)(input[38] & 0xfc) << 14);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 310 to 325
	value = ((uint32_t)(input[38] & 0x03) << 30) |
			((uint32_t)input[39] << 22) |
			((uint32_t)(input[40] & 0xfc) << 14);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 326 to 341
	value = ((uint32_t)(input[40] & 0x03) << 30) |
			((uint32_t)input[41] << 22) |
			((uint32_t)(input[42] & 0xfc) << 14);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 342 to 357
	value = ((uint32_t)(input[42] & 0x03) << 30) |
			((uint32_t)input[43] << 22) |
			((uint32_t)(input[44] & 0xfc) << 14);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 358 to 373
	value = ((uint32_t)(input[44] & 0x03) << 30) |
			((uint32_t)input[45] << 22) |
			((uint32_t)(input[46] & 0xfc) << 14);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 374 to 389
	value = ((uint32_t)(input[46] & 0x03) << 30) |
			((uint32_t)input[47] << 22) |
			((uint32_t)(input[48] & 0xfc) << 14);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 390 to 405
	value = ((uint32_t)(input[48] & 0x03) << 30) |
			((uint32_t)input[49] << 22) |
			((uint32_t)(input[50] & 0xfc) << 14);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 406 to 421
	value = ((uint32_t)(input[50] & 0x03) << 30) |
			((uint32_t)input[51] << 22) |
			((uint32_t)(input[52] & 0xfc) << 14);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 422 to 437
	value = ((uint32_t)(input[52] & 0x03) << 30) |
			((uint32_t)input[53] << 22) |
			((uint32_t)(input[54] & 0xfc) << 14);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 438 to 453
	value = ((uint32_t)(input[54] & 0x03) << 30) |
			((uint32_t)input[55] << 22) |
			((uint32_t)(input[56] & 0xfc) << 14);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 454 to 469
	value = ((uint32_t)(input[56] & 0x03) << 30) |
			((uint32_t)input[57] << 22) |
			((uint32_t)(input[58] & 0xfc) << 14);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 470 to 485
	value = ((uint32_t)(input[58] & 0x03) << 30) |
			((uint32_t)input[59] << 22) |
			((uint32_t)(input[60] & 0xfc) << 14);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 486 to 501
	value = ((uint32_t)(input[60] & 0x03) << 30) |
			((uint32_t)input[61] << 22) |
			((uint32_t)(input[62] & 0xfc) << 14);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 502 to 517
	value = ((uint32_t)(input[62] & 0x03) << 30) |
			((uint32_t)input[63] << 22) |
			((uint32_t)(input[64] & 0xfc) << 14);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 518 to 533
	value = ((uint32_t)(input[64] & 0x03) << 30) |
			((uint32_t)input[65] << 22) |
			((uint32_t)(input[66] & 0xfc) << 14);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 534 to 549
	value = ((uint32_t)(input[66] & 0x03) << 30) |
			((uint32_t)input[67] << 22) |
			((uint32_t)(input[68] & 0xfc) << 14);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 550 to 565
	value = ((uint32_t)(input[68] & 0x03) << 30) |
			((uint32_t)input[69] << 22) |
			((uint32_t)(input[70] & 0xfc) << 14);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 566 to 581
	value = ((uint32_t)(input[70] & 0x03) << 30) |
			((uint32_t)input[71] << 22) |
			((uint32_t)(input[72] & 0xfc) << 14);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 582 to 597
	value = ((uint32_t)(input[72] & 0x03) << 30) |
			((uint32_t)input[73] << 22) |
			((uint32_t)(input[74] & 0xfc) << 14);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 598 to 613
	value = ((uint32_t)(input[74] & 0x03) << 30) |
			((uint32_t)input[75] << 22) |
			((uint32_t)(input[76] & 0xfc) << 14);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 614 to 629
	value = ((uint32_t)(input[76] & 0x03) << 30) |
			((uint32_t)input[77] << 22) |
			((uint32_t)(input[78] & 0xfc) << 14);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 630 to 645
	value = ((uint32_t)(input[78] & 0x03) << 30) |
			((uint32_t)input[79] << 22) |
			((uint32_t)(input[80] & 0xfc) << 14);
	output[39] = (double)(value >> 16);

	// read output[40]: from bit 646 to 661
	value = ((uint32_t)(input[80] & 0x03) << 30) |
			((uint32_t)input[81] << 22) |
			((uint32_t)(input[82] & 0xfc) << 14);
	output[40] = (double)(value >> 16);

	// read output[41]: from bit 662 to 677
	value = ((uint32_t)(input[82] & 0x03) << 30) |
			((uint32_t)input[83] << 22) |
			((uint32_t)(input[84] & 0xfc) << 14);
	output[41] = (double)(value >> 16);

	// read output[42]: from bit 678 to 693
	value = ((uint32_t)(input[84] & 0x03) << 30) |
			((uint32_t)input[85] << 22) |
			((uint32_t)(input[86] & 0xfc) << 14);
	output[42] = (double)(value >> 16);

	// read output[43]: from bit 694 to 709
	value = ((uint32_t)(input[86] & 0x03) << 30) |
			((uint32_t)input[87] << 22) |
			((uint32_t)(input[88] & 0xfc) << 14);
	output[43] = (double)(value >> 16);

	// read output[44]: from bit 710 to 725
	value = ((uint32_t)(input[88] & 0x03) << 30) |
			((uint32_t)input[89] << 22) |
			((uint32_t)(input[90] & 0xfc) << 14);
	output[44] = (double)(value >> 16);

	// read output[45]: from bit 726 to 741
	value = ((uint32_t)(input[90] & 0x03) << 30) |
			((uint32_t)input[91] << 22) |
			((uint32_t)(input[92] & 0xfc) << 14);
	output[45] = (double)(value >> 16);

	// read output[46]: from bit 742 to 757
	value = ((uint32_t)(input[92] & 0x03) << 30) |
			((uint32_t)input[93] << 22) |
			((uint32_t)(input[94] & 0xfc) << 14);
	output[46] = (double)(value >> 16);

	// read output[47]: from bit 758 to 773
	value = ((uint32_t)(input[94] & 0x03) << 30) |
			((uint32_t)input[95] << 22) |
			((uint32_t)(input[96] & 0xfc) << 14);
	output[47] = (double)(value >> 16);

	// read output[48]: from bit 774 to 789
	value = ((uint32_t)(input[96] & 0x03) << 30) |
			((uint32_t)input[97] << 22) |
			((uint32_t)(input[98] & 0xfc) << 14);
	output[48] = (double)(value >> 16);

	// read output[49]: from bit 790 to 805
	value = ((uint32_t)(input[98] & 0x03) << 30) |
			((uint32_t)input[99] << 22) |
			((uint32_t)(input[100] & 0xfc) << 14);
	output[49] = (double)(value >> 16);

	// read output[50]: from bit 806 to 821
	value = ((uint32_t)(input[100] & 0x03) << 30) |
			((uint32_t)input[101] << 22) |
			((uint32_t)(input[102] & 0xfc) << 14);
	output[50] = (double)(value >> 16);

	// read output[51]: from bit 822 to 837
	value = ((uint32_t)(input[102] & 0x03) << 30) |
			((uint32_t)input[103] << 22) |
			((uint32_t)(input[104] & 0xfc) << 14);
	output[51] = (double)(value >> 16);

	// read output[52]: from bit 838 to 853
	value = ((uint32_t)(input[104] & 0x03) << 30) |
			((uint32_t)input[105] << 22) |
			((uint32_t)(input[106] & 0xfc) << 14);
	output[52] = (double)(value >> 16);

	// read output[53]: from bit 854 to 869
	value = ((uint32_t)(input[106] & 0x03) << 30) |
			((uint32_t)input[107] << 22) |
			((uint32_t)(input[108] & 0xfc) << 14);
	output[53] = (double)(value >> 16);

	// read output[54]: from bit 870 to 885
	value = ((uint32_t)(input[108] & 0x03) << 30) |
			((uint32_t)input[109] << 22) |
			((uint32_t)(input[110] & 0xfc) << 14);
	output[54] = (double)(value >> 16);

	// read output[55]: from bit 886 to 901
	value = ((uint32_t)(input[110] & 0x03) << 30) |
			((uint32_t)input[111] << 22) |
			((uint32_t)(input[112] & 0xfc) << 14);
	output[55] = (double)(value >> 16);

	// read output[56]: from bit 902 to 917
	value = ((uint32_t)(input[112] & 0x03) << 30) |
			((uint32_t)input[113] << 22) |
			((uint32_t)(input[114] & 0xfc) << 14);
	output[56] = (double)(value >> 16);

	// read output[57]: from bit 918 to 933
	value = ((uint32_t)(input[114] & 0x03) << 30) |
			((uint32_t)input[115] << 22) |
			((uint32_t)(input[116] & 0xfc) << 14);
	output[57] = (double)(value >> 16);
}

static void unpack_58_16bit_signed_7off(const uint8_t * input, double * output, void *closure) {
	// Unpack 58 values into output
	// Values are 16-bit signed
	// Skip 7 bits, read 928 bits of data.
	// Input must be at least 117 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 7 to 22
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)(input[2] & 0xfe) << 15);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 23 to 38
	value = ((uint32_t)(input[2] & 0x01) << 31) |
			((uint32_t)input[3] << 23) |
			((uint32_t)(input[4] & 0xfe) << 15);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 39 to 54
	value = ((uint32_t)(input[4] & 0x01) << 31) |
			((uint32_t)input[5] << 23) |
			((uint32_t)(input[6] & 0xfe) << 15);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 55 to 70
	value = ((uint32_t)(input[6] & 0x01) << 31) |
			((uint32_t)input[7] << 23) |
			((uint32_t)(input[8] & 0xfe) << 15);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 71 to 86
	value = ((uint32_t)(input[8] & 0x01) << 31) |
			((uint32_t)input[9] << 23) |
			((uint32_t)(input[10] & 0xfe) << 15);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 87 to 102
	value = ((uint32_t)(input[10] & 0x01) << 31) |
			((uint32_t)input[11] << 23) |
			((uint32_t)(input[12] & 0xfe) << 15);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 103 to 118
	value = ((uint32_t)(input[12] & 0x01) << 31) |
			((uint32_t)input[13] << 23) |
			((uint32_t)(input[14] & 0xfe) << 15);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 119 to 134
	value = ((uint32_t)(input[14] & 0x01) << 31) |
			((uint32_t)input[15] << 23) |
			((uint32_t)(input[16] & 0xfe) << 15);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 135 to 150
	value = ((uint32_t)(input[16] & 0x01) << 31) |
			((uint32_t)input[17] << 23) |
			((uint32_t)(input[18] & 0xfe) << 15);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 151 to 166
	value = ((uint32_t)(input[18] & 0x01) << 31) |
			((uint32_t)input[19] << 23) |
			((uint32_t)(input[20] & 0xfe) << 15);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 167 to 182
	value = ((uint32_t)(input[20] & 0x01) << 31) |
			((uint32_t)input[21] << 23) |
			((uint32_t)(input[22] & 0xfe) << 15);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 183 to 198
	value = ((uint32_t)(input[22] & 0x01) << 31) |
			((uint32_t)input[23] << 23) |
			((uint32_t)(input[24] & 0xfe) << 15);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 199 to 214
	value = ((uint32_t)(input[24] & 0x01) << 31) |
			((uint32_t)input[25] << 23) |
			((uint32_t)(input[26] & 0xfe) << 15);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 215 to 230
	value = ((uint32_t)(input[26] & 0x01) << 31) |
			((uint32_t)input[27] << 23) |
			((uint32_t)(input[28] & 0xfe) << 15);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 231 to 246
	value = ((uint32_t)(input[28] & 0x01) << 31) |
			((uint32_t)input[29] << 23) |
			((uint32_t)(input[30] & 0xfe) << 15);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 247 to 262
	value = ((uint32_t)(input[30] & 0x01) << 31) |
			((uint32_t)input[31] << 23) |
			((uint32_t)(input[32] & 0xfe) << 15);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 263 to 278
	value = ((uint32_t)(input[32] & 0x01) << 31) |
			((uint32_t)input[33] << 23) |
			((uint32_t)(input[34] & 0xfe) << 15);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 279 to 294
	value = ((uint32_t)(input[34] & 0x01) << 31) |
			((uint32_t)input[35] << 23) |
			((uint32_t)(input[36] & 0xfe) << 15);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 295 to 310
	value = ((uint32_t)(input[36] & 0x01) << 31) |
			((uint32_t)input[37] << 23) |
			((uint32_t)(input[38] & 0xfe) << 15);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 311 to 326
	value = ((uint32_t)(input[38] & 0x01) << 31) |
			((uint32_t)input[39] << 23) |
			((uint32_t)(input[40] & 0xfe) << 15);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 327 to 342
	value = ((uint32_t)(input[40] & 0x01) << 31) |
			((uint32_t)input[41] << 23) |
			((uint32_t)(input[42] & 0xfe) << 15);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 343 to 358
	value = ((uint32_t)(input[42] & 0x01) << 31) |
			((uint32_t)input[43] << 23) |
			((uint32_t)(input[44] & 0xfe) << 15);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 359 to 374
	value = ((uint32_t)(input[44] & 0x01) << 31) |
			((uint32_t)input[45] << 23) |
			((uint32_t)(input[46] & 0xfe) << 15);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 375 to 390
	value = ((uint32_t)(input[46] & 0x01) << 31) |
			((uint32_t)input[47] << 23) |
			((uint32_t)(input[48] & 0xfe) << 15);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 391 to 406
	value = ((uint32_t)(input[48] & 0x01) << 31) |
			((uint32_t)input[49] << 23) |
			((uint32_t)(input[50] & 0xfe) << 15);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 407 to 422
	value = ((uint32_t)(input[50] & 0x01) << 31) |
			((uint32_t)input[51] << 23) |
			((uint32_t)(input[52] & 0xfe) << 15);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 423 to 438
	value = ((uint32_t)(input[52] & 0x01) << 31) |
			((uint32_t)input[53] << 23) |
			((uint32_t)(input[54] & 0xfe) << 15);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 439 to 454
	value = ((uint32_t)(input[54] & 0x01) << 31) |
			((uint32_t)input[55] << 23) |
			((uint32_t)(input[56] & 0xfe) << 15);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 455 to 470
	value = ((uint32_t)(input[56] & 0x01) << 31) |
			((uint32_t)input[57] << 23) |
			((uint32_t)(input[58] & 0xfe) << 15);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 471 to 486
	value = ((uint32_t)(input[58] & 0x01) << 31) |
			((uint32_t)input[59] << 23) |
			((uint32_t)(input[60] & 0xfe) << 15);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 487 to 502
	value = ((uint32_t)(input[60] & 0x01) << 31) |
			((uint32_t)input[61] << 23) |
			((uint32_t)(input[62] & 0xfe) << 15);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 503 to 518
	value = ((uint32_t)(input[62] & 0x01) << 31) |
			((uint32_t)input[63] << 23) |
			((uint32_t)(input[64] & 0xfe) << 15);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 519 to 534
	value = ((uint32_t)(input[64] & 0x01) << 31) |
			((uint32_t)input[65] << 23) |
			((uint32_t)(input[66] & 0xfe) << 15);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 535 to 550
	value = ((uint32_t)(input[66] & 0x01) << 31) |
			((uint32_t)input[67] << 23) |
			((uint32_t)(input[68] & 0xfe) << 15);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 551 to 566
	value = ((uint32_t)(input[68] & 0x01) << 31) |
			((uint32_t)input[69] << 23) |
			((uint32_t)(input[70] & 0xfe) << 15);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 567 to 582
	value = ((uint32_t)(input[70] & 0x01) << 31) |
			((uint32_t)input[71] << 23) |
			((uint32_t)(input[72] & 0xfe) << 15);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 583 to 598
	value = ((uint32_t)(input[72] & 0x01) << 31) |
			((uint32_t)input[73] << 23) |
			((uint32_t)(input[74] & 0xfe) << 15);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 599 to 614
	value = ((uint32_t)(input[74] & 0x01) << 31) |
			((uint32_t)input[75] << 23) |
			((uint32_t)(input[76] & 0xfe) << 15);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 615 to 630
	value = ((uint32_t)(input[76] & 0x01) << 31) |
			((uint32_t)input[77] << 23) |
			((uint32_t)(input[78] & 0xfe) << 15);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 631 to 646
	value = ((uint32_t)(input[78] & 0x01) << 31) |
			((uint32_t)input[79] << 23) |
			((uint32_t)(input[80] & 0xfe) << 15);
	output[39] = (double)(value >> 16);

	// read output[40]: from bit 647 to 662
	value = ((uint32_t)(input[80] & 0x01) << 31) |
			((uint32_t)input[81] << 23) |
			((uint32_t)(input[82] & 0xfe) << 15);
	output[40] = (double)(value >> 16);

	// read output[41]: from bit 663 to 678
	value = ((uint32_t)(input[82] & 0x01) << 31) |
			((uint32_t)input[83] << 23) |
			((uint32_t)(input[84] & 0xfe) << 15);
	output[41] = (double)(value >> 16);

	// read output[42]: from bit 679 to 694
	value = ((uint32_t)(input[84] & 0x01) << 31) |
			((uint32_t)input[85] << 23) |
			((uint32_t)(input[86] & 0xfe) << 15);
	output[42] = (double)(value >> 16);

	// read output[43]: from bit 695 to 710
	value = ((uint32_t)(input[86] & 0x01) << 31) |
			((uint32_t)input[87] << 23) |
			((uint32_t)(input[88] & 0xfe) << 15);
	output[43] = (double)(value >> 16);

	// read output[44]: from bit 711 to 726
	value = ((uint32_t)(input[88] & 0x01) << 31) |
			((uint32_t)input[89] << 23) |
			((uint32_t)(input[90] & 0xfe) << 15);
	output[44] = (double)(value >> 16);

	// read output[45]: from bit 727 to 742
	value = ((uint32_t)(input[90] & 0x01) << 31) |
			((uint32_t)input[91] << 23) |
			((uint32_t)(input[92] & 0xfe) << 15);
	output[45] = (double)(value >> 16);

	// read output[46]: from bit 743 to 758
	value = ((uint32_t)(input[92] & 0x01) << 31) |
			((uint32_t)input[93] << 23) |
			((uint32_t)(input[94] & 0xfe) << 15);
	output[46] = (double)(value >> 16);

	// read output[47]: from bit 759 to 774
	value = ((uint32_t)(input[94] & 0x01) << 31) |
			((uint32_t)input[95] << 23) |
			((uint32_t)(input[96] & 0xfe) << 15);
	output[47] = (double)(value >> 16);

	// read output[48]: from bit 775 to 790
	value = ((uint32_t)(input[96] & 0x01) << 31) |
			((uint32_t)input[97] << 23) |
			((uint32_t)(input[98] & 0xfe) << 15);
	output[48] = (double)(value >> 16);

	// read output[49]: from bit 791 to 806
	value = ((uint32_t)(input[98] & 0x01) << 31) |
			((uint32_t)input[99] << 23) |
			((uint32_t)(input[100] & 0xfe) << 15);
	output[49] = (double)(value >> 16);

	// read output[50]: from bit 807 to 822
	value = ((uint32_t)(input[100] & 0x01) << 31) |
			((uint32_t)input[101] << 23) |
			((uint32_t)(input[102] & 0xfe) << 15);
	output[50] = (double)(value >> 16);

	// read output[51]: from bit 823 to 838
	value = ((uint32_t)(input[102] & 0x01) << 31) |
			((uint32_t)input[103] << 23) |
			((uint32_t)(input[104] & 0xfe) << 15);
	output[51] = (double)(value >> 16);

	// read output[52]: from bit 839 to 854
	value = ((uint32_t)(input[104] & 0x01) << 31) |
			((uint32_t)input[105] << 23) |
			((uint32_t)(input[106] & 0xfe) << 15);
	output[52] = (double)(value >> 16);

	// read output[53]: from bit 855 to 870
	value = ((uint32_t)(input[106] & 0x01) << 31) |
			((uint32_t)input[107] << 23) |
			((uint32_t)(input[108] & 0xfe) << 15);
	output[53] = (double)(value >> 16);

	// read output[54]: from bit 871 to 886
	value = ((uint32_t)(input[108] & 0x01) << 31) |
			((uint32_t)input[109] << 23) |
			((uint32_t)(input[110] & 0xfe) << 15);
	output[54] = (double)(value >> 16);

	// read output[55]: from bit 887 to 902
	value = ((uint32_t)(input[110] & 0x01) << 31) |
			((uint32_t)input[111] << 23) |
			((uint32_t)(input[112] & 0xfe) << 15);
	output[55] = (double)(value >> 16);

	// read output[56]: from bit 903 to 918
	value = ((uint32_t)(input[112] & 0x01) << 31) |
			((uint32_t)input[113] << 23) |
			((uint32_t)(input[114] & 0xfe) << 15);
	output[56] = (double)(value >> 16);

	// read output[57]: from bit 919 to 934
	value = ((uint32_t)(input[114] & 0x01) << 31) |
			((uint32_t)input[115] << 23) |
			((uint32_t)(input[116] & 0xfe) << 15);
	output[57] = (double)(value >> 16);
}

static void unpack_58_16bit_unsigned_7off(const uint8_t * input, double * output, void *closure) {
	// Unpack 58 values into output
	// Values are 16-bit unsigned
	// Skip 7 bits, read 928 bits of data.
	// Input must be at least 117 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 7 to 22
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)(input[2] & 0xfe) << 15);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 23 to 38
	value = ((uint32_t)(input[2] & 0x01) << 31) |
			((uint32_t)input[3] << 23) |
			((uint32_t)(input[4] & 0xfe) << 15);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 39 to 54
	value = ((uint32_t)(input[4] & 0x01) << 31) |
			((uint32_t)input[5] << 23) |
			((uint32_t)(input[6] & 0xfe) << 15);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 55 to 70
	value = ((uint32_t)(input[6] & 0x01) << 31) |
			((uint32_t)input[7] << 23) |
			((uint32_t)(input[8] & 0xfe) << 15);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 71 to 86
	value = ((uint32_t)(input[8] & 0x01) << 31) |
			((uint32_t)input[9] << 23) |
			((uint32_t)(input[10] & 0xfe) << 15);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 87 to 102
	value = ((uint32_t)(input[10] & 0x01) << 31) |
			((uint32_t)input[11] << 23) |
			((uint32_t)(input[12] & 0xfe) << 15);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 103 to 118
	value = ((uint32_t)(input[12] & 0x01) << 31) |
			((uint32_t)input[13] << 23) |
			((uint32_t)(input[14] & 0xfe) << 15);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 119 to 134
	value = ((uint32_t)(input[14] & 0x01) << 31) |
			((uint32_t)input[15] << 23) |
			((uint32_t)(input[16] & 0xfe) << 15);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 135 to 150
	value = ((uint32_t)(input[16] & 0x01) << 31) |
			((uint32_t)input[17] << 23) |
			((uint32_t)(input[18] & 0xfe) << 15);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 151 to 166
	value = ((uint32_t)(input[18] & 0x01) << 31) |
			((uint32_t)input[19] << 23) |
			((uint32_t)(input[20] & 0xfe) << 15);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 167 to 182
	value = ((uint32_t)(input[20] & 0x01) << 31) |
			((uint32_t)input[21] << 23) |
			((uint32_t)(input[22] & 0xfe) << 15);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 183 to 198
	value = ((uint32_t)(input[22] & 0x01) << 31) |
			((uint32_t)input[23] << 23) |
			((uint32_t)(input[24] & 0xfe) << 15);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 199 to 214
	value = ((uint32_t)(input[24] & 0x01) << 31) |
			((uint32_t)input[25] << 23) |
			((uint32_t)(input[26] & 0xfe) << 15);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 215 to 230
	value = ((uint32_t)(input[26] & 0x01) << 31) |
			((uint32_t)input[27] << 23) |
			((uint32_t)(input[28] & 0xfe) << 15);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 231 to 246
	value = ((uint32_t)(input[28] & 0x01) << 31) |
			((uint32_t)input[29] << 23) |
			((uint32_t)(input[30] & 0xfe) << 15);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 247 to 262
	value = ((uint32_t)(input[30] & 0x01) << 31) |
			((uint32_t)input[31] << 23) |
			((uint32_t)(input[32] & 0xfe) << 15);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 263 to 278
	value = ((uint32_t)(input[32] & 0x01) << 31) |
			((uint32_t)input[33] << 23) |
			((uint32_t)(input[34] & 0xfe) << 15);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 279 to 294
	value = ((uint32_t)(input[34] & 0x01) << 31) |
			((uint32_t)input[35] << 23) |
			((uint32_t)(input[36] & 0xfe) << 15);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 295 to 310
	value = ((uint32_t)(input[36] & 0x01) << 31) |
			((uint32_t)input[37] << 23) |
			((uint32_t)(input[38] & 0xfe) << 15);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 311 to 326
	value = ((uint32_t)(input[38] & 0x01) << 31) |
			((uint32_t)input[39] << 23) |
			((uint32_t)(input[40] & 0xfe) << 15);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 327 to 342
	value = ((uint32_t)(input[40] & 0x01) << 31) |
			((uint32_t)input[41] << 23) |
			((uint32_t)(input[42] & 0xfe) << 15);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 343 to 358
	value = ((uint32_t)(input[42] & 0x01) << 31) |
			((uint32_t)input[43] << 23) |
			((uint32_t)(input[44] & 0xfe) << 15);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 359 to 374
	value = ((uint32_t)(input[44] & 0x01) << 31) |
			((uint32_t)input[45] << 23) |
			((uint32_t)(input[46] & 0xfe) << 15);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 375 to 390
	value = ((uint32_t)(input[46] & 0x01) << 31) |
			((uint32_t)input[47] << 23) |
			((uint32_t)(input[48] & 0xfe) << 15);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 391 to 406
	value = ((uint32_t)(input[48] & 0x01) << 31) |
			((uint32_t)input[49] << 23) |
			((uint32_t)(input[50] & 0xfe) << 15);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 407 to 422
	value = ((uint32_t)(input[50] & 0x01) << 31) |
			((uint32_t)input[51] << 23) |
			((uint32_t)(input[52] & 0xfe) << 15);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 423 to 438
	value = ((uint32_t)(input[52] & 0x01) << 31) |
			((uint32_t)input[53] << 23) |
			((uint32_t)(input[54] & 0xfe) << 15);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 439 to 454
	value = ((uint32_t)(input[54] & 0x01) << 31) |
			((uint32_t)input[55] << 23) |
			((uint32_t)(input[56] & 0xfe) << 15);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 455 to 470
	value = ((uint32_t)(input[56] & 0x01) << 31) |
			((uint32_t)input[57] << 23) |
			((uint32_t)(input[58] & 0xfe) << 15);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 471 to 486
	value = ((uint32_t)(input[58] & 0x01) << 31) |
			((uint32_t)input[59] << 23) |
			((uint32_t)(input[60] & 0xfe) << 15);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 487 to 502
	value = ((uint32_t)(input[60] & 0x01) << 31) |
			((uint32_t)input[61] << 23) |
			((uint32_t)(input[62] & 0xfe) << 15);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 503 to 518
	value = ((uint32_t)(input[62] & 0x01) << 31) |
			((uint32_t)input[63] << 23) |
			((uint32_t)(input[64] & 0xfe) << 15);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 519 to 534
	value = ((uint32_t)(input[64] & 0x01) << 31) |
			((uint32_t)input[65] << 23) |
			((uint32_t)(input[66] & 0xfe) << 15);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 535 to 550
	value = ((uint32_t)(input[66] & 0x01) << 31) |
			((uint32_t)input[67] << 23) |
			((uint32_t)(input[68] & 0xfe) << 15);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 551 to 566
	value = ((uint32_t)(input[68] & 0x01) << 31) |
			((uint32_t)input[69] << 23) |
			((uint32_t)(input[70] & 0xfe) << 15);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 567 to 582
	value = ((uint32_t)(input[70] & 0x01) << 31) |
			((uint32_t)input[71] << 23) |
			((uint32_t)(input[72] & 0xfe) << 15);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 583 to 598
	value = ((uint32_t)(input[72] & 0x01) << 31) |
			((uint32_t)input[73] << 23) |
			((uint32_t)(input[74] & 0xfe) << 15);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 599 to 614
	value = ((uint32_t)(input[74] & 0x01) << 31) |
			((uint32_t)input[75] << 23) |
			((uint32_t)(input[76] & 0xfe) << 15);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 615 to 630
	value = ((uint32_t)(input[76] & 0x01) << 31) |
			((uint32_t)input[77] << 23) |
			((uint32_t)(input[78] & 0xfe) << 15);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 631 to 646
	value = ((uint32_t)(input[78] & 0x01) << 31) |
			((uint32_t)input[79] << 23) |
			((uint32_t)(input[80] & 0xfe) << 15);
	output[39] = (double)(value >> 16);

	// read output[40]: from bit 647 to 662
	value = ((uint32_t)(input[80] & 0x01) << 31) |
			((uint32_t)input[81] << 23) |
			((uint32_t)(input[82] & 0xfe) << 15);
	output[40] = (double)(value >> 16);

	// read output[41]: from bit 663 to 678
	value = ((uint32_t)(input[82] & 0x01) << 31) |
			((uint32_t)input[83] << 23) |
			((uint32_t)(input[84] & 0xfe) << 15);
	output[41] = (double)(value >> 16);

	// read output[42]: from bit 679 to 694
	value = ((uint32_t)(input[84] & 0x01) << 31) |
			((uint32_t)input[85] << 23) |
			((uint32_t)(input[86] & 0xfe) << 15);
	output[42] = (double)(value >> 16);

	// read output[43]: from bit 695 to 710
	value = ((uint32_t)(input[86] & 0x01) << 31) |
			((uint32_t)input[87] << 23) |
			((uint32_t)(input[88] & 0xfe) << 15);
	output[43] = (double)(value >> 16);

	// read output[44]: from bit 711 to 726
	value = ((uint32_t)(input[88] & 0x01) << 31) |
			((uint32_t)input[89] << 23) |
			((uint32_t)(input[90] & 0xfe) << 15);
	output[44] = (double)(value >> 16);

	// read output[45]: from bit 727 to 742
	value = ((uint32_t)(input[90] & 0x01) << 31) |
			((uint32_t)input[91] << 23) |
			((uint32_t)(input[92] & 0xfe) << 15);
	output[45] = (double)(value >> 16);

	// read output[46]: from bit 743 to 758
	value = ((uint32_t)(input[92] & 0x01) << 31) |
			((uint32_t)input[93] << 23) |
			((uint32_t)(input[94] & 0xfe) << 15);
	output[46] = (double)(value >> 16);

	// read output[47]: from bit 759 to 774
	value = ((uint32_t)(input[94] & 0x01) << 31) |
			((uint32_t)input[95] << 23) |
			((uint32_t)(input[96] & 0xfe) << 15);
	output[47] = (double)(value >> 16);

	// read output[48]: from bit 775 to 790
	value = ((uint32_t)(input[96] & 0x01) << 31) |
			((uint32_t)input[97] << 23) |
			((uint32_t)(input[98] & 0xfe) << 15);
	output[48] = (double)(value >> 16);

	// read output[49]: from bit 791 to 806
	value = ((uint32_t)(input[98] & 0x01) << 31) |
			((uint32_t)input[99] << 23) |
			((uint32_t)(input[100] & 0xfe) << 15);
	output[49] = (double)(value >> 16);

	// read output[50]: from bit 807 to 822
	value = ((uint32_t)(input[100] & 0x01) << 31) |
			((uint32_t)input[101] << 23) |
			((uint32_t)(input[102] & 0xfe) << 15);
	output[50] = (double)(value >> 16);

	// read output[51]: from bit 823 to 838
	value = ((uint32_t)(input[102] & 0x01) << 31) |
			((uint32_t)input[103] << 23) |
			((uint32_t)(input[104] & 0xfe) << 15);
	output[51] = (double)(value >> 16);

	// read output[52]: from bit 839 to 854
	value = ((uint32_t)(input[104] & 0x01) << 31) |
			((uint32_t)input[105] << 23) |
			((uint32_t)(input[106] & 0xfe) << 15);
	output[52] = (double)(value >> 16);

	// read output[53]: from bit 855 to 870
	value = ((uint32_t)(input[106] & 0x01) << 31) |
			((uint32_t)input[107] << 23) |
			((uint32_t)(input[108] & 0xfe) << 15);
	output[53] = (double)(value >> 16);

	// read output[54]: from bit 871 to 886
	value = ((uint32_t)(input[108] & 0x01) << 31) |
			((uint32_t)input[109] << 23) |
			((uint32_t)(input[110] & 0xfe) << 15);
	output[54] = (double)(value >> 16);

	// read output[55]: from bit 887 to 902
	value = ((uint32_t)(input[110] & 0x01) << 31) |
			((uint32_t)input[111] << 23) |
			((uint32_t)(input[112] & 0xfe) << 15);
	output[55] = (double)(value >> 16);

	// read output[56]: from bit 903 to 918
	value = ((uint32_t)(input[112] & 0x01) << 31) |
			((uint32_t)input[113] << 23) |
			((uint32_t)(input[114] & 0xfe) << 15);
	output[56] = (double)(value >> 16);

	// read output[57]: from bit 919 to 934
	value = ((uint32_t)(input[114] & 0x01) << 31) |
			((uint32_t)input[115] << 23) |
			((uint32_t)(input[116] & 0xfe) << 15);
	output[57] = (double)(value >> 16);
}

static void unpack_59_16bit_signed_0off(const uint8_t * input, double * output, void *closure) {
	// Unpack 59 values into output
	// Values are 16-bit signed
	// Skip 0 bits, read 944 bits of data.
	// Input must be at least 118 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 0 to 15
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)input[1] << 16);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 16 to 31
	value = ((uint32_t)input[2] << 24) |
			((uint32_t)input[3] << 16);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 32 to 47
	value = ((uint32_t)input[4] << 24) |
			((uint32_t)input[5] << 16);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 48 to 63
	value = ((uint32_t)input[6] << 24) |
			((uint32_t)input[7] << 16);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 64 to 79
	value = ((uint32_t)input[8] << 24) |
			((uint32_t)input[9] << 16);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 80 to 95
	value = ((uint32_t)input[10] << 24) |
			((uint32_t)input[11] << 16);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 96 to 111
	value = ((uint32_t)input[12] << 24) |
			((uint32_t)input[13] << 16);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 112 to 127
	value = ((uint32_t)input[14] << 24) |
			((uint32_t)input[15] << 16);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 128 to 143
	value = ((uint32_t)input[16] << 24) |
			((uint32_t)input[17] << 16);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 144 to 159
	value = ((uint32_t)input[18] << 24) |
			((uint32_t)input[19] << 16);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 160 to 175
	value = ((uint32_t)input[20] << 24) |
			((uint32_t)input[21] << 16);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 176 to 191
	value = ((uint32_t)input[22] << 24) |
			((uint32_t)input[23] << 16);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 192 to 207
	value = ((uint32_t)input[24] << 24) |
			((uint32_t)input[25] << 16);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 208 to 223
	value = ((uint32_t)input[26] << 24) |
			((uint32_t)input[27] << 16);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 224 to 239
	value = ((uint32_t)input[28] << 24) |
			((uint32_t)input[29] << 16);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 240 to 255
	value = ((uint32_t)input[30] << 24) |
			((uint32_t)input[31] << 16);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 256 to 271
	value = ((uint32_t)input[32] << 24) |
			((uint32_t)input[33] << 16);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 272 to 287
	value = ((uint32_t)input[34] << 24) |
			((uint32_t)input[35] << 16);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 288 to 303
	value = ((uint32_t)input[36] << 24) |
			((uint32_t)input[37] << 16);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 304 to 319
	value = ((uint32_t)input[38] << 24) |
			((uint32_t)input[39] << 16);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 320 to 335
	value = ((uint32_t)input[40] << 24) |
			((uint32_t)input[41] << 16);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 336 to 351
	value = ((uint32_t)input[42] << 24) |
			((uint32_t)input[43] << 16);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 352 to 367
	value = ((uint32_t)input[44] << 24) |
			((uint32_t)input[45] << 16);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 368 to 383
	value = ((uint32_t)input[46] << 24) |
			((uint32_t)input[47] << 16);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 384 to 399
	value = ((uint32_t)input[48] << 24) |
			((uint32_t)input[49] << 16);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 400 to 415
	value = ((uint32_t)input[50] << 24) |
			((uint32_t)input[51] << 16);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 416 to 431
	value = ((uint32_t)input[52] << 24) |
			((uint32_t)input[53] << 16);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 432 to 447
	value = ((uint32_t)input[54] << 24) |
			((uint32_t)input[55] << 16);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 448 to 463
	value = ((uint32_t)input[56] << 24) |
			((uint32_t)input[57] << 16);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 464 to 479
	value = ((uint32_t)input[58] << 24) |
			((uint32_t)input[59] << 16);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 480 to 495
	value = ((uint32_t)input[60] << 24) |
			((uint32_t)input[61] << 16);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 496 to 511
	value = ((uint32_t)input[62] << 24) |
			((uint32_t)input[63] << 16);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 512 to 527
	value = ((uint32_t)input[64] << 24) |
			((uint32_t)input[65] << 16);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 528 to 543
	value = ((uint32_t)input[66] << 24) |
			((uint32_t)input[67] << 16);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 544 to 559
	value = ((uint32_t)input[68] << 24) |
			((uint32_t)input[69] << 16);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 560 to 575
	value = ((uint32_t)input[70] << 24) |
			((uint32_t)input[71] << 16);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 576 to 591
	value = ((uint32_t)input[72] << 24) |
			((uint32_t)input[73] << 16);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 592 to 607
	value = ((uint32_t)input[74] << 24) |
			((uint32_t)input[75] << 16);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 608 to 623
	value = ((uint32_t)input[76] << 24) |
			((uint32_t)input[77] << 16);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 624 to 639
	value = ((uint32_t)input[78] << 24) |
			((uint32_t)input[79] << 16);
	output[39] = (double)(value >> 16);

	// read output[40]: from bit 640 to 655
	value = ((uint32_t)input[80] << 24) |
			((uint32_t)input[81] << 16);
	output[40] = (double)(value >> 16);

	// read output[41]: from bit 656 to 671
	value = ((uint32_t)input[82] << 24) |
			((uint32_t)input[83] << 16);
	output[41] = (double)(value >> 16);

	// read output[42]: from bit 672 to 687
	value = ((uint32_t)input[84] << 24) |
			((uint32_t)input[85] << 16);
	output[42] = (double)(value >> 16);

	// read output[43]: from bit 688 to 703
	value = ((uint32_t)input[86] << 24) |
			((uint32_t)input[87] << 16);
	output[43] = (double)(value >> 16);

	// read output[44]: from bit 704 to 719
	value = ((uint32_t)input[88] << 24) |
			((uint32_t)input[89] << 16);
	output[44] = (double)(value >> 16);

	// read output[45]: from bit 720 to 735
	value = ((uint32_t)input[90] << 24) |
			((uint32_t)input[91] << 16);
	output[45] = (double)(value >> 16);

	// read output[46]: from bit 736 to 751
	value = ((uint32_t)input[92] << 24) |
			((uint32_t)input[93] << 16);
	output[46] = (double)(value >> 16);

	// read output[47]: from bit 752 to 767
	value = ((uint32_t)input[94] << 24) |
			((uint32_t)input[95] << 16);
	output[47] = (double)(value >> 16);

	// read output[48]: from bit 768 to 783
	value = ((uint32_t)input[96] << 24) |
			((uint32_t)input[97] << 16);
	output[48] = (double)(value >> 16);

	// read output[49]: from bit 784 to 799
	value = ((uint32_t)input[98] << 24) |
			((uint32_t)input[99] << 16);
	output[49] = (double)(value >> 16);

	// read output[50]: from bit 800 to 815
	value = ((uint32_t)input[100] << 24) |
			((uint32_t)input[101] << 16);
	output[50] = (double)(value >> 16);

	// read output[51]: from bit 816 to 831
	value = ((uint32_t)input[102] << 24) |
			((uint32_t)input[103] << 16);
	output[51] = (double)(value >> 16);

	// read output[52]: from bit 832 to 847
	value = ((uint32_t)input[104] << 24) |
			((uint32_t)input[105] << 16);
	output[52] = (double)(value >> 16);

	// read output[53]: from bit 848 to 863
	value = ((uint32_t)input[106] << 24) |
			((uint32_t)input[107] << 16);
	output[53] = (double)(value >> 16);

	// read output[54]: from bit 864 to 879
	value = ((uint32_t)input[108] << 24) |
			((uint32_t)input[109] << 16);
	output[54] = (double)(value >> 16);

	// read output[55]: from bit 880 to 895
	value = ((uint32_t)input[110] << 24) |
			((uint32_t)input[111] << 16);
	output[55] = (double)(value >> 16);

	// read output[56]: from bit 896 to 911
	value = ((uint32_t)input[112] << 24) |
			((uint32_t)input[113] << 16);
	output[56] = (double)(value >> 16);

	// read output[57]: from bit 912 to 927
	value = ((uint32_t)input[114] << 24) |
			((uint32_t)input[115] << 16);
	output[57] = (double)(value >> 16);

	// read output[58]: from bit 928 to 943
	value = ((uint32_t)input[116] << 24) |
			((uint32_t)input[117] << 16);
	output[58] = (double)(value >> 16);
}

static void unpack_59_16bit_unsigned_0off(const uint8_t * input, double * output, void *closure) {
	// Unpack 59 values into output
	// Values are 16-bit unsigned
	// Skip 0 bits, read 944 bits of data.
	// Input must be at least 118 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 0 to 15
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)input[1] << 16);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 16 to 31
	value = ((uint32_t)input[2] << 24) |
			((uint32_t)input[3] << 16);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 32 to 47
	value = ((uint32_t)input[4] << 24) |
			((uint32_t)input[5] << 16);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 48 to 63
	value = ((uint32_t)input[6] << 24) |
			((uint32_t)input[7] << 16);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 64 to 79
	value = ((uint32_t)input[8] << 24) |
			((uint32_t)input[9] << 16);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 80 to 95
	value = ((uint32_t)input[10] << 24) |
			((uint32_t)input[11] << 16);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 96 to 111
	value = ((uint32_t)input[12] << 24) |
			((uint32_t)input[13] << 16);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 112 to 127
	value = ((uint32_t)input[14] << 24) |
			((uint32_t)input[15] << 16);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 128 to 143
	value = ((uint32_t)input[16] << 24) |
			((uint32_t)input[17] << 16);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 144 to 159
	value = ((uint32_t)input[18] << 24) |
			((uint32_t)input[19] << 16);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 160 to 175
	value = ((uint32_t)input[20] << 24) |
			((uint32_t)input[21] << 16);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 176 to 191
	value = ((uint32_t)input[22] << 24) |
			((uint32_t)input[23] << 16);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 192 to 207
	value = ((uint32_t)input[24] << 24) |
			((uint32_t)input[25] << 16);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 208 to 223
	value = ((uint32_t)input[26] << 24) |
			((uint32_t)input[27] << 16);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 224 to 239
	value = ((uint32_t)input[28] << 24) |
			((uint32_t)input[29] << 16);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 240 to 255
	value = ((uint32_t)input[30] << 24) |
			((uint32_t)input[31] << 16);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 256 to 271
	value = ((uint32_t)input[32] << 24) |
			((uint32_t)input[33] << 16);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 272 to 287
	value = ((uint32_t)input[34] << 24) |
			((uint32_t)input[35] << 16);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 288 to 303
	value = ((uint32_t)input[36] << 24) |
			((uint32_t)input[37] << 16);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 304 to 319
	value = ((uint32_t)input[38] << 24) |
			((uint32_t)input[39] << 16);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 320 to 335
	value = ((uint32_t)input[40] << 24) |
			((uint32_t)input[41] << 16);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 336 to 351
	value = ((uint32_t)input[42] << 24) |
			((uint32_t)input[43] << 16);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 352 to 367
	value = ((uint32_t)input[44] << 24) |
			((uint32_t)input[45] << 16);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 368 to 383
	value = ((uint32_t)input[46] << 24) |
			((uint32_t)input[47] << 16);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 384 to 399
	value = ((uint32_t)input[48] << 24) |
			((uint32_t)input[49] << 16);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 400 to 415
	value = ((uint32_t)input[50] << 24) |
			((uint32_t)input[51] << 16);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 416 to 431
	value = ((uint32_t)input[52] << 24) |
			((uint32_t)input[53] << 16);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 432 to 447
	value = ((uint32_t)input[54] << 24) |
			((uint32_t)input[55] << 16);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 448 to 463
	value = ((uint32_t)input[56] << 24) |
			((uint32_t)input[57] << 16);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 464 to 479
	value = ((uint32_t)input[58] << 24) |
			((uint32_t)input[59] << 16);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 480 to 495
	value = ((uint32_t)input[60] << 24) |
			((uint32_t)input[61] << 16);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 496 to 511
	value = ((uint32_t)input[62] << 24) |
			((uint32_t)input[63] << 16);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 512 to 527
	value = ((uint32_t)input[64] << 24) |
			((uint32_t)input[65] << 16);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 528 to 543
	value = ((uint32_t)input[66] << 24) |
			((uint32_t)input[67] << 16);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 544 to 559
	value = ((uint32_t)input[68] << 24) |
			((uint32_t)input[69] << 16);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 560 to 575
	value = ((uint32_t)input[70] << 24) |
			((uint32_t)input[71] << 16);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 576 to 591
	value = ((uint32_t)input[72] << 24) |
			((uint32_t)input[73] << 16);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 592 to 607
	value = ((uint32_t)input[74] << 24) |
			((uint32_t)input[75] << 16);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 608 to 623
	value = ((uint32_t)input[76] << 24) |
			((uint32_t)input[77] << 16);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 624 to 639
	value = ((uint32_t)input[78] << 24) |
			((uint32_t)input[79] << 16);
	output[39] = (double)(value >> 16);

	// read output[40]: from bit 640 to 655
	value = ((uint32_t)input[80] << 24) |
			((uint32_t)input[81] << 16);
	output[40] = (double)(value >> 16);

	// read output[41]: from bit 656 to 671
	value = ((uint32_t)input[82] << 24) |
			((uint32_t)input[83] << 16);
	output[41] = (double)(value >> 16);

	// read output[42]: from bit 672 to 687
	value = ((uint32_t)input[84] << 24) |
			((uint32_t)input[85] << 16);
	output[42] = (double)(value >> 16);

	// read output[43]: from bit 688 to 703
	value = ((uint32_t)input[86] << 24) |
			((uint32_t)input[87] << 16);
	output[43] = (double)(value >> 16);

	// read output[44]: from bit 704 to 719
	value = ((uint32_t)input[88] << 24) |
			((uint32_t)input[89] << 16);
	output[44] = (double)(value >> 16);

	// read output[45]: from bit 720 to 735
	value = ((uint32_t)input[90] << 24) |
			((uint32_t)input[91] << 16);
	output[45] = (double)(value >> 16);

	// read output[46]: from bit 736 to 751
	value = ((uint32_t)input[92] << 24) |
			((uint32_t)input[93] << 16);
	output[46] = (double)(value >> 16);

	// read output[47]: from bit 752 to 767
	value = ((uint32_t)input[94] << 24) |
			((uint32_t)input[95] << 16);
	output[47] = (double)(value >> 16);

	// read output[48]: from bit 768 to 783
	value = ((uint32_t)input[96] << 24) |
			((uint32_t)input[97] << 16);
	output[48] = (double)(value >> 16);

	// read output[49]: from bit 784 to 799
	value = ((uint32_t)input[98] << 24) |
			((uint32_t)input[99] << 16);
	output[49] = (double)(value >> 16);

	// read output[50]: from bit 800 to 815
	value = ((uint32_t)input[100] << 24) |
			((uint32_t)input[101] << 16);
	output[50] = (double)(value >> 16);

	// read output[51]: from bit 816 to 831
	value = ((uint32_t)input[102] << 24) |
			((uint32_t)input[103] << 16);
	output[51] = (double)(value >> 16);

	// read output[52]: from bit 832 to 847
	value = ((uint32_t)input[104] << 24) |
			((uint32_t)input[105] << 16);
	output[52] = (double)(value >> 16);

	// read output[53]: from bit 848 to 863
	value = ((uint32_t)input[106] << 24) |
			((uint32_t)input[107] << 16);
	output[53] = (double)(value >> 16);

	// read output[54]: from bit 864 to 879
	value = ((uint32_t)input[108] << 24) |
			((uint32_t)input[109] << 16);
	output[54] = (double)(value >> 16);

	// read output[55]: from bit 880 to 895
	value = ((uint32_t)input[110] << 24) |
			((uint32_t)input[111] << 16);
	output[55] = (double)(value >> 16);

	// read output[56]: from bit 896 to 911
	value = ((uint32_t)input[112] << 24) |
			((uint32_t)input[113] << 16);
	output[56] = (double)(value >> 16);

	// read output[57]: from bit 912 to 927
	value = ((uint32_t)input[114] << 24) |
			((uint32_t)input[115] << 16);
	output[57] = (double)(value >> 16);

	// read output[58]: from bit 928 to 943
	value = ((uint32_t)input[116] << 24) |
			((uint32_t)input[117] << 16);
	output[58] = (double)(value >> 16);
}

static void unpack_59_16bit_signed_1off(const uint8_t * input, double * output, void *closure) {
	// Unpack 59 values into output
	// Values are 16-bit signed
	// Skip 1 bits, read 944 bits of data.
	// Input must be at least 119 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 1 to 16
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)input[1] << 17) |
			((uint32_t)(input[2] & 0x80) << 9);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 17 to 32
	value = ((uint32_t)(input[2] & 0x7f) << 25) |
			((uint32_t)input[3] << 17) |
			((uint32_t)(input[4] & 0x80) << 9);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 33 to 48
	value = ((uint32_t)(input[4] & 0x7f) << 25) |
			((uint32_t)input[5] << 17) |
			((uint32_t)(input[6] & 0x80) << 9);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 49 to 64
	value = ((uint32_t)(input[6] & 0x7f) << 25) |
			((uint32_t)input[7] << 17) |
			((uint32_t)(input[8] & 0x80) << 9);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 65 to 80
	value = ((uint32_t)(input[8] & 0x7f) << 25) |
			((uint32_t)input[9] << 17) |
			((uint32_t)(input[10] & 0x80) << 9);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 81 to 96
	value = ((uint32_t)(input[10] & 0x7f) << 25) |
			((uint32_t)input[11] << 17) |
			((uint32_t)(input[12] & 0x80) << 9);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 97 to 112
	value = ((uint32_t)(input[12] & 0x7f) << 25) |
			((uint32_t)input[13] << 17) |
			((uint32_t)(input[14] & 0x80) << 9);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 113 to 128
	value = ((uint32_t)(input[14] & 0x7f) << 25) |
			((uint32_t)input[15] << 17) |
			((uint32_t)(input[16] & 0x80) << 9);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 129 to 144
	value = ((uint32_t)(input[16] & 0x7f) << 25) |
			((uint32_t)input[17] << 17) |
			((uint32_t)(input[18] & 0x80) << 9);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 145 to 160
	value = ((uint32_t)(input[18] & 0x7f) << 25) |
			((uint32_t)input[19] << 17) |
			((uint32_t)(input[20] & 0x80) << 9);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 161 to 176
	value = ((uint32_t)(input[20] & 0x7f) << 25) |
			((uint32_t)input[21] << 17) |
			((uint32_t)(input[22] & 0x80) << 9);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 177 to 192
	value = ((uint32_t)(input[22] & 0x7f) << 25) |
			((uint32_t)input[23] << 17) |
			((uint32_t)(input[24] & 0x80) << 9);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 193 to 208
	value = ((uint32_t)(input[24] & 0x7f) << 25) |
			((uint32_t)input[25] << 17) |
			((uint32_t)(input[26] & 0x80) << 9);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 209 to 224
	value = ((uint32_t)(input[26] & 0x7f) << 25) |
			((uint32_t)input[27] << 17) |
			((uint32_t)(input[28] & 0x80) << 9);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 225 to 240
	value = ((uint32_t)(input[28] & 0x7f) << 25) |
			((uint32_t)input[29] << 17) |
			((uint32_t)(input[30] & 0x80) << 9);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 241 to 256
	value = ((uint32_t)(input[30] & 0x7f) << 25) |
			((uint32_t)input[31] << 17) |
			((uint32_t)(input[32] & 0x80) << 9);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 257 to 272
	value = ((uint32_t)(input[32] & 0x7f) << 25) |
			((uint32_t)input[33] << 17) |
			((uint32_t)(input[34] & 0x80) << 9);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 273 to 288
	value = ((uint32_t)(input[34] & 0x7f) << 25) |
			((uint32_t)input[35] << 17) |
			((uint32_t)(input[36] & 0x80) << 9);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 289 to 304
	value = ((uint32_t)(input[36] & 0x7f) << 25) |
			((uint32_t)input[37] << 17) |
			((uint32_t)(input[38] & 0x80) << 9);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 305 to 320
	value = ((uint32_t)(input[38] & 0x7f) << 25) |
			((uint32_t)input[39] << 17) |
			((uint32_t)(input[40] & 0x80) << 9);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 321 to 336
	value = ((uint32_t)(input[40] & 0x7f) << 25) |
			((uint32_t)input[41] << 17) |
			((uint32_t)(input[42] & 0x80) << 9);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 337 to 352
	value = ((uint32_t)(input[42] & 0x7f) << 25) |
			((uint32_t)input[43] << 17) |
			((uint32_t)(input[44] & 0x80) << 9);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 353 to 368
	value = ((uint32_t)(input[44] & 0x7f) << 25) |
			((uint32_t)input[45] << 17) |
			((uint32_t)(input[46] & 0x80) << 9);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 369 to 384
	value = ((uint32_t)(input[46] & 0x7f) << 25) |
			((uint32_t)input[47] << 17) |
			((uint32_t)(input[48] & 0x80) << 9);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 385 to 400
	value = ((uint32_t)(input[48] & 0x7f) << 25) |
			((uint32_t)input[49] << 17) |
			((uint32_t)(input[50] & 0x80) << 9);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 401 to 416
	value = ((uint32_t)(input[50] & 0x7f) << 25) |
			((uint32_t)input[51] << 17) |
			((uint32_t)(input[52] & 0x80) << 9);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 417 to 432
	value = ((uint32_t)(input[52] & 0x7f) << 25) |
			((uint32_t)input[53] << 17) |
			((uint32_t)(input[54] & 0x80) << 9);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 433 to 448
	value = ((uint32_t)(input[54] & 0x7f) << 25) |
			((uint32_t)input[55] << 17) |
			((uint32_t)(input[56] & 0x80) << 9);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 449 to 464
	value = ((uint32_t)(input[56] & 0x7f) << 25) |
			((uint32_t)input[57] << 17) |
			((uint32_t)(input[58] & 0x80) << 9);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 465 to 480
	value = ((uint32_t)(input[58] & 0x7f) << 25) |
			((uint32_t)input[59] << 17) |
			((uint32_t)(input[60] & 0x80) << 9);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 481 to 496
	value = ((uint32_t)(input[60] & 0x7f) << 25) |
			((uint32_t)input[61] << 17) |
			((uint32_t)(input[62] & 0x80) << 9);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 497 to 512
	value = ((uint32_t)(input[62] & 0x7f) << 25) |
			((uint32_t)input[63] << 17) |
			((uint32_t)(input[64] & 0x80) << 9);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 513 to 528
	value = ((uint32_t)(input[64] & 0x7f) << 25) |
			((uint32_t)input[65] << 17) |
			((uint32_t)(input[66] & 0x80) << 9);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 529 to 544
	value = ((uint32_t)(input[66] & 0x7f) << 25) |
			((uint32_t)input[67] << 17) |
			((uint32_t)(input[68] & 0x80) << 9);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 545 to 560
	value = ((uint32_t)(input[68] & 0x7f) << 25) |
			((uint32_t)input[69] << 17) |
			((uint32_t)(input[70] & 0x80) << 9);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 561 to 576
	value = ((uint32_t)(input[70] & 0x7f) << 25) |
			((uint32_t)input[71] << 17) |
			((uint32_t)(input[72] & 0x80) << 9);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 577 to 592
	value = ((uint32_t)(input[72] & 0x7f) << 25) |
			((uint32_t)input[73] << 17) |
			((uint32_t)(input[74] & 0x80) << 9);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 593 to 608
	value = ((uint32_t)(input[74] & 0x7f) << 25) |
			((uint32_t)input[75] << 17) |
			((uint32_t)(input[76] & 0x80) << 9);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 609 to 624
	value = ((uint32_t)(input[76] & 0x7f) << 25) |
			((uint32_t)input[77] << 17) |
			((uint32_t)(input[78] & 0x80) << 9);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 625 to 640
	value = ((uint32_t)(input[78] & 0x7f) << 25) |
			((uint32_t)input[79] << 17) |
			((uint32_t)(input[80] & 0x80) << 9);
	output[39] = (double)(value >> 16);

	// read output[40]: from bit 641 to 656
	value = ((uint32_t)(input[80] & 0x7f) << 25) |
			((uint32_t)input[81] << 17) |
			((uint32_t)(input[82] & 0x80) << 9);
	output[40] = (double)(value >> 16);

	// read output[41]: from bit 657 to 672
	value = ((uint32_t)(input[82] & 0x7f) << 25) |
			((uint32_t)input[83] << 17) |
			((uint32_t)(input[84] & 0x80) << 9);
	output[41] = (double)(value >> 16);

	// read output[42]: from bit 673 to 688
	value = ((uint32_t)(input[84] & 0x7f) << 25) |
			((uint32_t)input[85] << 17) |
			((uint32_t)(input[86] & 0x80) << 9);
	output[42] = (double)(value >> 16);

	// read output[43]: from bit 689 to 704
	value = ((uint32_t)(input[86] & 0x7f) << 25) |
			((uint32_t)input[87] << 17) |
			((uint32_t)(input[88] & 0x80) << 9);
	output[43] = (double)(value >> 16);

	// read output[44]: from bit 705 to 720
	value = ((uint32_t)(input[88] & 0x7f) << 25) |
			((uint32_t)input[89] << 17) |
			((uint32_t)(input[90] & 0x80) << 9);
	output[44] = (double)(value >> 16);

	// read output[45]: from bit 721 to 736
	value = ((uint32_t)(input[90] & 0x7f) << 25) |
			((uint32_t)input[91] << 17) |
			((uint32_t)(input[92] & 0x80) << 9);
	output[45] = (double)(value >> 16);

	// read output[46]: from bit 737 to 752
	value = ((uint32_t)(input[92] & 0x7f) << 25) |
			((uint32_t)input[93] << 17) |
			((uint32_t)(input[94] & 0x80) << 9);
	output[46] = (double)(value >> 16);

	// read output[47]: from bit 753 to 768
	value = ((uint32_t)(input[94] & 0x7f) << 25) |
			((uint32_t)input[95] << 17) |
			((uint32_t)(input[96] & 0x80) << 9);
	output[47] = (double)(value >> 16);

	// read output[48]: from bit 769 to 784
	value = ((uint32_t)(input[96] & 0x7f) << 25) |
			((uint32_t)input[97] << 17) |
			((uint32_t)(input[98] & 0x80) << 9);
	output[48] = (double)(value >> 16);

	// read output[49]: from bit 785 to 800
	value = ((uint32_t)(input[98] & 0x7f) << 25) |
			((uint32_t)input[99] << 17) |
			((uint32_t)(input[100] & 0x80) << 9);
	output[49] = (double)(value >> 16);

	// read output[50]: from bit 801 to 816
	value = ((uint32_t)(input[100] & 0x7f) << 25) |
			((uint32_t)input[101] << 17) |
			((uint32_t)(input[102] & 0x80) << 9);
	output[50] = (double)(value >> 16);

	// read output[51]: from bit 817 to 832
	value = ((uint32_t)(input[102] & 0x7f) << 25) |
			((uint32_t)input[103] << 17) |
			((uint32_t)(input[104] & 0x80) << 9);
	output[51] = (double)(value >> 16);

	// read output[52]: from bit 833 to 848
	value = ((uint32_t)(input[104] & 0x7f) << 25) |
			((uint32_t)input[105] << 17) |
			((uint32_t)(input[106] & 0x80) << 9);
	output[52] = (double)(value >> 16);

	// read output[53]: from bit 849 to 864
	value = ((uint32_t)(input[106] & 0x7f) << 25) |
			((uint32_t)input[107] << 17) |
			((uint32_t)(input[108] & 0x80) << 9);
	output[53] = (double)(value >> 16);

	// read output[54]: from bit 865 to 880
	value = ((uint32_t)(input[108] & 0x7f) << 25) |
			((uint32_t)input[109] << 17) |
			((uint32_t)(input[110] & 0x80) << 9);
	output[54] = (double)(value >> 16);

	// read output[55]: from bit 881 to 896
	value = ((uint32_t)(input[110] & 0x7f) << 25) |
			((uint32_t)input[111] << 17) |
			((uint32_t)(input[112] & 0x80) << 9);
	output[55] = (double)(value >> 16);

	// read output[56]: from bit 897 to 912
	value = ((uint32_t)(input[112] & 0x7f) << 25) |
			((uint32_t)input[113] << 17) |
			((uint32_t)(input[114] & 0x80) << 9);
	output[56] = (double)(value >> 16);

	// read output[57]: from bit 913 to 928
	value = ((uint32_t)(input[114] & 0x7f) << 25) |
			((uint32_t)input[115] << 17) |
			((uint32_t)(input[116] & 0x80) << 9);
	output[57] = (double)(value >> 16);

	// read output[58]: from bit 929 to 944
	value = ((uint32_t)(input[116] & 0x7f) << 25) |
			((uint32_t)input[117] << 17) |
			((uint32_t)(input[118] & 0x80) << 9);
	output[58] = (double)(value >> 16);
}

static void unpack_59_16bit_unsigned_1off(const uint8_t * input, double * output, void *closure) {
	// Unpack 59 values into output
	// Values are 16-bit unsigned
	// Skip 1 bits, read 944 bits of data.
	// Input must be at least 119 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 1 to 16
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)input[1] << 17) |
			((uint32_t)(input[2] & 0x80) << 9);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 17 to 32
	value = ((uint32_t)(input[2] & 0x7f) << 25) |
			((uint32_t)input[3] << 17) |
			((uint32_t)(input[4] & 0x80) << 9);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 33 to 48
	value = ((uint32_t)(input[4] & 0x7f) << 25) |
			((uint32_t)input[5] << 17) |
			((uint32_t)(input[6] & 0x80) << 9);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 49 to 64
	value = ((uint32_t)(input[6] & 0x7f) << 25) |
			((uint32_t)input[7] << 17) |
			((uint32_t)(input[8] & 0x80) << 9);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 65 to 80
	value = ((uint32_t)(input[8] & 0x7f) << 25) |
			((uint32_t)input[9] << 17) |
			((uint32_t)(input[10] & 0x80) << 9);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 81 to 96
	value = ((uint32_t)(input[10] & 0x7f) << 25) |
			((uint32_t)input[11] << 17) |
			((uint32_t)(input[12] & 0x80) << 9);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 97 to 112
	value = ((uint32_t)(input[12] & 0x7f) << 25) |
			((uint32_t)input[13] << 17) |
			((uint32_t)(input[14] & 0x80) << 9);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 113 to 128
	value = ((uint32_t)(input[14] & 0x7f) << 25) |
			((uint32_t)input[15] << 17) |
			((uint32_t)(input[16] & 0x80) << 9);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 129 to 144
	value = ((uint32_t)(input[16] & 0x7f) << 25) |
			((uint32_t)input[17] << 17) |
			((uint32_t)(input[18] & 0x80) << 9);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 145 to 160
	value = ((uint32_t)(input[18] & 0x7f) << 25) |
			((uint32_t)input[19] << 17) |
			((uint32_t)(input[20] & 0x80) << 9);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 161 to 176
	value = ((uint32_t)(input[20] & 0x7f) << 25) |
			((uint32_t)input[21] << 17) |
			((uint32_t)(input[22] & 0x80) << 9);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 177 to 192
	value = ((uint32_t)(input[22] & 0x7f) << 25) |
			((uint32_t)input[23] << 17) |
			((uint32_t)(input[24] & 0x80) << 9);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 193 to 208
	value = ((uint32_t)(input[24] & 0x7f) << 25) |
			((uint32_t)input[25] << 17) |
			((uint32_t)(input[26] & 0x80) << 9);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 209 to 224
	value = ((uint32_t)(input[26] & 0x7f) << 25) |
			((uint32_t)input[27] << 17) |
			((uint32_t)(input[28] & 0x80) << 9);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 225 to 240
	value = ((uint32_t)(input[28] & 0x7f) << 25) |
			((uint32_t)input[29] << 17) |
			((uint32_t)(input[30] & 0x80) << 9);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 241 to 256
	value = ((uint32_t)(input[30] & 0x7f) << 25) |
			((uint32_t)input[31] << 17) |
			((uint32_t)(input[32] & 0x80) << 9);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 257 to 272
	value = ((uint32_t)(input[32] & 0x7f) << 25) |
			((uint32_t)input[33] << 17) |
			((uint32_t)(input[34] & 0x80) << 9);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 273 to 288
	value = ((uint32_t)(input[34] & 0x7f) << 25) |
			((uint32_t)input[35] << 17) |
			((uint32_t)(input[36] & 0x80) << 9);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 289 to 304
	value = ((uint32_t)(input[36] & 0x7f) << 25) |
			((uint32_t)input[37] << 17) |
			((uint32_t)(input[38] & 0x80) << 9);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 305 to 320
	value = ((uint32_t)(input[38] & 0x7f) << 25) |
			((uint32_t)input[39] << 17) |
			((uint32_t)(input[40] & 0x80) << 9);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 321 to 336
	value = ((uint32_t)(input[40] & 0x7f) << 25) |
			((uint32_t)input[41] << 17) |
			((uint32_t)(input[42] & 0x80) << 9);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 337 to 352
	value = ((uint32_t)(input[42] & 0x7f) << 25) |
			((uint32_t)input[43] << 17) |
			((uint32_t)(input[44] & 0x80) << 9);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 353 to 368
	value = ((uint32_t)(input[44] & 0x7f) << 25) |
			((uint32_t)input[45] << 17) |
			((uint32_t)(input[46] & 0x80) << 9);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 369 to 384
	value = ((uint32_t)(input[46] & 0x7f) << 25) |
			((uint32_t)input[47] << 17) |
			((uint32_t)(input[48] & 0x80) << 9);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 385 to 400
	value = ((uint32_t)(input[48] & 0x7f) << 25) |
			((uint32_t)input[49] << 17) |
			((uint32_t)(input[50] & 0x80) << 9);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 401 to 416
	value = ((uint32_t)(input[50] & 0x7f) << 25) |
			((uint32_t)input[51] << 17) |
			((uint32_t)(input[52] & 0x80) << 9);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 417 to 432
	value = ((uint32_t)(input[52] & 0x7f) << 25) |
			((uint32_t)input[53] << 17) |
			((uint32_t)(input[54] & 0x80) << 9);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 433 to 448
	value = ((uint32_t)(input[54] & 0x7f) << 25) |
			((uint32_t)input[55] << 17) |
			((uint32_t)(input[56] & 0x80) << 9);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 449 to 464
	value = ((uint32_t)(input[56] & 0x7f) << 25) |
			((uint32_t)input[57] << 17) |
			((uint32_t)(input[58] & 0x80) << 9);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 465 to 480
	value = ((uint32_t)(input[58] & 0x7f) << 25) |
			((uint32_t)input[59] << 17) |
			((uint32_t)(input[60] & 0x80) << 9);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 481 to 496
	value = ((uint32_t)(input[60] & 0x7f) << 25) |
			((uint32_t)input[61] << 17) |
			((uint32_t)(input[62] & 0x80) << 9);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 497 to 512
	value = ((uint32_t)(input[62] & 0x7f) << 25) |
			((uint32_t)input[63] << 17) |
			((uint32_t)(input[64] & 0x80) << 9);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 513 to 528
	value = ((uint32_t)(input[64] & 0x7f) << 25) |
			((uint32_t)input[65] << 17) |
			((uint32_t)(input[66] & 0x80) << 9);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 529 to 544
	value = ((uint32_t)(input[66] & 0x7f) << 25) |
			((uint32_t)input[67] << 17) |
			((uint32_t)(input[68] & 0x80) << 9);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 545 to 560
	value = ((uint32_t)(input[68] & 0x7f) << 25) |
			((uint32_t)input[69] << 17) |
			((uint32_t)(input[70] & 0x80) << 9);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 561 to 576
	value = ((uint32_t)(input[70] & 0x7f) << 25) |
			((uint32_t)input[71] << 17) |
			((uint32_t)(input[72] & 0x80) << 9);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 577 to 592
	value = ((uint32_t)(input[72] & 0x7f) << 25) |
			((uint32_t)input[73] << 17) |
			((uint32_t)(input[74] & 0x80) << 9);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 593 to 608
	value = ((uint32_t)(input[74] & 0x7f) << 25) |
			((uint32_t)input[75] << 17) |
			((uint32_t)(input[76] & 0x80) << 9);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 609 to 624
	value = ((uint32_t)(input[76] & 0x7f) << 25) |
			((uint32_t)input[77] << 17) |
			((uint32_t)(input[78] & 0x80) << 9);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 625 to 640
	value = ((uint32_t)(input[78] & 0x7f) << 25) |
			((uint32_t)input[79] << 17) |
			((uint32_t)(input[80] & 0x80) << 9);
	output[39] = (double)(value >> 16);

	// read output[40]: from bit 641 to 656
	value = ((uint32_t)(input[80] & 0x7f) << 25) |
			((uint32_t)input[81] << 17) |
			((uint32_t)(input[82] & 0x80) << 9);
	output[40] = (double)(value >> 16);

	// read output[41]: from bit 657 to 672
	value = ((uint32_t)(input[82] & 0x7f) << 25) |
			((uint32_t)input[83] << 17) |
			((uint32_t)(input[84] & 0x80) << 9);
	output[41] = (double)(value >> 16);

	// read output[42]: from bit 673 to 688
	value = ((uint32_t)(input[84] & 0x7f) << 25) |
			((uint32_t)input[85] << 17) |
			((uint32_t)(input[86] & 0x80) << 9);
	output[42] = (double)(value >> 16);

	// read output[43]: from bit 689 to 704
	value = ((uint32_t)(input[86] & 0x7f) << 25) |
			((uint32_t)input[87] << 17) |
			((uint32_t)(input[88] & 0x80) << 9);
	output[43] = (double)(value >> 16);

	// read output[44]: from bit 705 to 720
	value = ((uint32_t)(input[88] & 0x7f) << 25) |
			((uint32_t)input[89] << 17) |
			((uint32_t)(input[90] & 0x80) << 9);
	output[44] = (double)(value >> 16);

	// read output[45]: from bit 721 to 736
	value = ((uint32_t)(input[90] & 0x7f) << 25) |
			((uint32_t)input[91] << 17) |
			((uint32_t)(input[92] & 0x80) << 9);
	output[45] = (double)(value >> 16);

	// read output[46]: from bit 737 to 752
	value = ((uint32_t)(input[92] & 0x7f) << 25) |
			((uint32_t)input[93] << 17) |
			((uint32_t)(input[94] & 0x80) << 9);
	output[46] = (double)(value >> 16);

	// read output[47]: from bit 753 to 768
	value = ((uint32_t)(input[94] & 0x7f) << 25) |
			((uint32_t)input[95] << 17) |
			((uint32_t)(input[96] & 0x80) << 9);
	output[47] = (double)(value >> 16);

	// read output[48]: from bit 769 to 784
	value = ((uint32_t)(input[96] & 0x7f) << 25) |
			((uint32_t)input[97] << 17) |
			((uint32_t)(input[98] & 0x80) << 9);
	output[48] = (double)(value >> 16);

	// read output[49]: from bit 785 to 800
	value = ((uint32_t)(input[98] & 0x7f) << 25) |
			((uint32_t)input[99] << 17) |
			((uint32_t)(input[100] & 0x80) << 9);
	output[49] = (double)(value >> 16);

	// read output[50]: from bit 801 to 816
	value = ((uint32_t)(input[100] & 0x7f) << 25) |
			((uint32_t)input[101] << 17) |
			((uint32_t)(input[102] & 0x80) << 9);
	output[50] = (double)(value >> 16);

	// read output[51]: from bit 817 to 832
	value = ((uint32_t)(input[102] & 0x7f) << 25) |
			((uint32_t)input[103] << 17) |
			((uint32_t)(input[104] & 0x80) << 9);
	output[51] = (double)(value >> 16);

	// read output[52]: from bit 833 to 848
	value = ((uint32_t)(input[104] & 0x7f) << 25) |
			((uint32_t)input[105] << 17) |
			((uint32_t)(input[106] & 0x80) << 9);
	output[52] = (double)(value >> 16);

	// read output[53]: from bit 849 to 864
	value = ((uint32_t)(input[106] & 0x7f) << 25) |
			((uint32_t)input[107] << 17) |
			((uint32_t)(input[108] & 0x80) << 9);
	output[53] = (double)(value >> 16);

	// read output[54]: from bit 865 to 880
	value = ((uint32_t)(input[108] & 0x7f) << 25) |
			((uint32_t)input[109] << 17) |
			((uint32_t)(input[110] & 0x80) << 9);
	output[54] = (double)(value >> 16);

	// read output[55]: from bit 881 to 896
	value = ((uint32_t)(input[110] & 0x7f) << 25) |
			((uint32_t)input[111] << 17) |
			((uint32_t)(input[112] & 0x80) << 9);
	output[55] = (double)(value >> 16);

	// read output[56]: from bit 897 to 912
	value = ((uint32_t)(input[112] & 0x7f) << 25) |
			((uint32_t)input[113] << 17) |
			((uint32_t)(input[114] & 0x80) << 9);
	output[56] = (double)(value >> 16);

	// read output[57]: from bit 913 to 928
	value = ((uint32_t)(input[114] & 0x7f) << 25) |
			((uint32_t)input[115] << 17) |
			((uint32_t)(input[116] & 0x80) << 9);
	output[57] = (double)(value >> 16);

	// read output[58]: from bit 929 to 944
	value = ((uint32_t)(input[116] & 0x7f) << 25) |
			((uint32_t)input[117] << 17) |
			((uint32_t)(input[118] & 0x80) << 9);
	output[58] = (double)(value >> 16);
}

static void unpack_59_16bit_signed_2off(const uint8_t * input, double * output, void *closure) {
	// Unpack 59 values into output
	// Values are 16-bit signed
	// Skip 2 bits, read 944 bits of data.
	// Input must be at least 119 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 2 to 17
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)input[1] << 18) |
			((uint32_t)(input[2] & 0xc0) << 10);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 18 to 33
	value = ((uint32_t)(input[2] & 0x3f) << 26) |
			((uint32_t)input[3] << 18) |
			((uint32_t)(input[4] & 0xc0) << 10);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 34 to 49
	value = ((uint32_t)(input[4] & 0x3f) << 26) |
			((uint32_t)input[5] << 18) |
			((uint32_t)(input[6] & 0xc0) << 10);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 50 to 65
	value = ((uint32_t)(input[6] & 0x3f) << 26) |
			((uint32_t)input[7] << 18) |
			((uint32_t)(input[8] & 0xc0) << 10);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 66 to 81
	value = ((uint32_t)(input[8] & 0x3f) << 26) |
			((uint32_t)input[9] << 18) |
			((uint32_t)(input[10] & 0xc0) << 10);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 82 to 97
	value = ((uint32_t)(input[10] & 0x3f) << 26) |
			((uint32_t)input[11] << 18) |
			((uint32_t)(input[12] & 0xc0) << 10);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 98 to 113
	value = ((uint32_t)(input[12] & 0x3f) << 26) |
			((uint32_t)input[13] << 18) |
			((uint32_t)(input[14] & 0xc0) << 10);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 114 to 129
	value = ((uint32_t)(input[14] & 0x3f) << 26) |
			((uint32_t)input[15] << 18) |
			((uint32_t)(input[16] & 0xc0) << 10);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 130 to 145
	value = ((uint32_t)(input[16] & 0x3f) << 26) |
			((uint32_t)input[17] << 18) |
			((uint32_t)(input[18] & 0xc0) << 10);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 146 to 161
	value = ((uint32_t)(input[18] & 0x3f) << 26) |
			((uint32_t)input[19] << 18) |
			((uint32_t)(input[20] & 0xc0) << 10);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 162 to 177
	value = ((uint32_t)(input[20] & 0x3f) << 26) |
			((uint32_t)input[21] << 18) |
			((uint32_t)(input[22] & 0xc0) << 10);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 178 to 193
	value = ((uint32_t)(input[22] & 0x3f) << 26) |
			((uint32_t)input[23] << 18) |
			((uint32_t)(input[24] & 0xc0) << 10);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 194 to 209
	value = ((uint32_t)(input[24] & 0x3f) << 26) |
			((uint32_t)input[25] << 18) |
			((uint32_t)(input[26] & 0xc0) << 10);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 210 to 225
	value = ((uint32_t)(input[26] & 0x3f) << 26) |
			((uint32_t)input[27] << 18) |
			((uint32_t)(input[28] & 0xc0) << 10);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 226 to 241
	value = ((uint32_t)(input[28] & 0x3f) << 26) |
			((uint32_t)input[29] << 18) |
			((uint32_t)(input[30] & 0xc0) << 10);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 242 to 257
	value = ((uint32_t)(input[30] & 0x3f) << 26) |
			((uint32_t)input[31] << 18) |
			((uint32_t)(input[32] & 0xc0) << 10);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 258 to 273
	value = ((uint32_t)(input[32] & 0x3f) << 26) |
			((uint32_t)input[33] << 18) |
			((uint32_t)(input[34] & 0xc0) << 10);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 274 to 289
	value = ((uint32_t)(input[34] & 0x3f) << 26) |
			((uint32_t)input[35] << 18) |
			((uint32_t)(input[36] & 0xc0) << 10);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 290 to 305
	value = ((uint32_t)(input[36] & 0x3f) << 26) |
			((uint32_t)input[37] << 18) |
			((uint32_t)(input[38] & 0xc0) << 10);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 306 to 321
	value = ((uint32_t)(input[38] & 0x3f) << 26) |
			((uint32_t)input[39] << 18) |
			((uint32_t)(input[40] & 0xc0) << 10);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 322 to 337
	value = ((uint32_t)(input[40] & 0x3f) << 26) |
			((uint32_t)input[41] << 18) |
			((uint32_t)(input[42] & 0xc0) << 10);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 338 to 353
	value = ((uint32_t)(input[42] & 0x3f) << 26) |
			((uint32_t)input[43] << 18) |
			((uint32_t)(input[44] & 0xc0) << 10);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 354 to 369
	value = ((uint32_t)(input[44] & 0x3f) << 26) |
			((uint32_t)input[45] << 18) |
			((uint32_t)(input[46] & 0xc0) << 10);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 370 to 385
	value = ((uint32_t)(input[46] & 0x3f) << 26) |
			((uint32_t)input[47] << 18) |
			((uint32_t)(input[48] & 0xc0) << 10);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 386 to 401
	value = ((uint32_t)(input[48] & 0x3f) << 26) |
			((uint32_t)input[49] << 18) |
			((uint32_t)(input[50] & 0xc0) << 10);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 402 to 417
	value = ((uint32_t)(input[50] & 0x3f) << 26) |
			((uint32_t)input[51] << 18) |
			((uint32_t)(input[52] & 0xc0) << 10);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 418 to 433
	value = ((uint32_t)(input[52] & 0x3f) << 26) |
			((uint32_t)input[53] << 18) |
			((uint32_t)(input[54] & 0xc0) << 10);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 434 to 449
	value = ((uint32_t)(input[54] & 0x3f) << 26) |
			((uint32_t)input[55] << 18) |
			((uint32_t)(input[56] & 0xc0) << 10);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 450 to 465
	value = ((uint32_t)(input[56] & 0x3f) << 26) |
			((uint32_t)input[57] << 18) |
			((uint32_t)(input[58] & 0xc0) << 10);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 466 to 481
	value = ((uint32_t)(input[58] & 0x3f) << 26) |
			((uint32_t)input[59] << 18) |
			((uint32_t)(input[60] & 0xc0) << 10);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 482 to 497
	value = ((uint32_t)(input[60] & 0x3f) << 26) |
			((uint32_t)input[61] << 18) |
			((uint32_t)(input[62] & 0xc0) << 10);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 498 to 513
	value = ((uint32_t)(input[62] & 0x3f) << 26) |
			((uint32_t)input[63] << 18) |
			((uint32_t)(input[64] & 0xc0) << 10);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 514 to 529
	value = ((uint32_t)(input[64] & 0x3f) << 26) |
			((uint32_t)input[65] << 18) |
			((uint32_t)(input[66] & 0xc0) << 10);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 530 to 545
	value = ((uint32_t)(input[66] & 0x3f) << 26) |
			((uint32_t)input[67] << 18) |
			((uint32_t)(input[68] & 0xc0) << 10);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 546 to 561
	value = ((uint32_t)(input[68] & 0x3f) << 26) |
			((uint32_t)input[69] << 18) |
			((uint32_t)(input[70] & 0xc0) << 10);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 562 to 577
	value = ((uint32_t)(input[70] & 0x3f) << 26) |
			((uint32_t)input[71] << 18) |
			((uint32_t)(input[72] & 0xc0) << 10);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 578 to 593
	value = ((uint32_t)(input[72] & 0x3f) << 26) |
			((uint32_t)input[73] << 18) |
			((uint32_t)(input[74] & 0xc0) << 10);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 594 to 609
	value = ((uint32_t)(input[74] & 0x3f) << 26) |
			((uint32_t)input[75] << 18) |
			((uint32_t)(input[76] & 0xc0) << 10);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 610 to 625
	value = ((uint32_t)(input[76] & 0x3f) << 26) |
			((uint32_t)input[77] << 18) |
			((uint32_t)(input[78] & 0xc0) << 10);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 626 to 641
	value = ((uint32_t)(input[78] & 0x3f) << 26) |
			((uint32_t)input[79] << 18) |
			((uint32_t)(input[80] & 0xc0) << 10);
	output[39] = (double)(value >> 16);

	// read output[40]: from bit 642 to 657
	value = ((uint32_t)(input[80] & 0x3f) << 26) |
			((uint32_t)input[81] << 18) |
			((uint32_t)(input[82] & 0xc0) << 10);
	output[40] = (double)(value >> 16);

	// read output[41]: from bit 658 to 673
	value = ((uint32_t)(input[82] & 0x3f) << 26) |
			((uint32_t)input[83] << 18) |
			((uint32_t)(input[84] & 0xc0) << 10);
	output[41] = (double)(value >> 16);

	// read output[42]: from bit 674 to 689
	value = ((uint32_t)(input[84] & 0x3f) << 26) |
			((uint32_t)input[85] << 18) |
			((uint32_t)(input[86] & 0xc0) << 10);
	output[42] = (double)(value >> 16);

	// read output[43]: from bit 690 to 705
	value = ((uint32_t)(input[86] & 0x3f) << 26) |
			((uint32_t)input[87] << 18) |
			((uint32_t)(input[88] & 0xc0) << 10);
	output[43] = (double)(value >> 16);

	// read output[44]: from bit 706 to 721
	value = ((uint32_t)(input[88] & 0x3f) << 26) |
			((uint32_t)input[89] << 18) |
			((uint32_t)(input[90] & 0xc0) << 10);
	output[44] = (double)(value >> 16);

	// read output[45]: from bit 722 to 737
	value = ((uint32_t)(input[90] & 0x3f) << 26) |
			((uint32_t)input[91] << 18) |
			((uint32_t)(input[92] & 0xc0) << 10);
	output[45] = (double)(value >> 16);

	// read output[46]: from bit 738 to 753
	value = ((uint32_t)(input[92] & 0x3f) << 26) |
			((uint32_t)input[93] << 18) |
			((uint32_t)(input[94] & 0xc0) << 10);
	output[46] = (double)(value >> 16);

	// read output[47]: from bit 754 to 769
	value = ((uint32_t)(input[94] & 0x3f) << 26) |
			((uint32_t)input[95] << 18) |
			((uint32_t)(input[96] & 0xc0) << 10);
	output[47] = (double)(value >> 16);

	// read output[48]: from bit 770 to 785
	value = ((uint32_t)(input[96] & 0x3f) << 26) |
			((uint32_t)input[97] << 18) |
			((uint32_t)(input[98] & 0xc0) << 10);
	output[48] = (double)(value >> 16);

	// read output[49]: from bit 786 to 801
	value = ((uint32_t)(input[98] & 0x3f) << 26) |
			((uint32_t)input[99] << 18) |
			((uint32_t)(input[100] & 0xc0) << 10);
	output[49] = (double)(value >> 16);

	// read output[50]: from bit 802 to 817
	value = ((uint32_t)(input[100] & 0x3f) << 26) |
			((uint32_t)input[101] << 18) |
			((uint32_t)(input[102] & 0xc0) << 10);
	output[50] = (double)(value >> 16);

	// read output[51]: from bit 818 to 833
	value = ((uint32_t)(input[102] & 0x3f) << 26) |
			((uint32_t)input[103] << 18) |
			((uint32_t)(input[104] & 0xc0) << 10);
	output[51] = (double)(value >> 16);

	// read output[52]: from bit 834 to 849
	value = ((uint32_t)(input[104] & 0x3f) << 26) |
			((uint32_t)input[105] << 18) |
			((uint32_t)(input[106] & 0xc0) << 10);
	output[52] = (double)(value >> 16);

	// read output[53]: from bit 850 to 865
	value = ((uint32_t)(input[106] & 0x3f) << 26) |
			((uint32_t)input[107] << 18) |
			((uint32_t)(input[108] & 0xc0) << 10);
	output[53] = (double)(value >> 16);

	// read output[54]: from bit 866 to 881
	value = ((uint32_t)(input[108] & 0x3f) << 26) |
			((uint32_t)input[109] << 18) |
			((uint32_t)(input[110] & 0xc0) << 10);
	output[54] = (double)(value >> 16);

	// read output[55]: from bit 882 to 897
	value = ((uint32_t)(input[110] & 0x3f) << 26) |
			((uint32_t)input[111] << 18) |
			((uint32_t)(input[112] & 0xc0) << 10);
	output[55] = (double)(value >> 16);

	// read output[56]: from bit 898 to 913
	value = ((uint32_t)(input[112] & 0x3f) << 26) |
			((uint32_t)input[113] << 18) |
			((uint32_t)(input[114] & 0xc0) << 10);
	output[56] = (double)(value >> 16);

	// read output[57]: from bit 914 to 929
	value = ((uint32_t)(input[114] & 0x3f) << 26) |
			((uint32_t)input[115] << 18) |
			((uint32_t)(input[116] & 0xc0) << 10);
	output[57] = (double)(value >> 16);

	// read output[58]: from bit 930 to 945
	value = ((uint32_t)(input[116] & 0x3f) << 26) |
			((uint32_t)input[117] << 18) |
			((uint32_t)(input[118] & 0xc0) << 10);
	output[58] = (double)(value >> 16);
}

static void unpack_59_16bit_unsigned_2off(const uint8_t * input, double * output, void *closure) {
	// Unpack 59 values into output
	// Values are 16-bit unsigned
	// Skip 2 bits, read 944 bits of data.
	// Input must be at least 119 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 2 to 17
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)input[1] << 18) |
			((uint32_t)(input[2] & 0xc0) << 10);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 18 to 33
	value = ((uint32_t)(input[2] & 0x3f) << 26) |
			((uint32_t)input[3] << 18) |
			((uint32_t)(input[4] & 0xc0) << 10);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 34 to 49
	value = ((uint32_t)(input[4] & 0x3f) << 26) |
			((uint32_t)input[5] << 18) |
			((uint32_t)(input[6] & 0xc0) << 10);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 50 to 65
	value = ((uint32_t)(input[6] & 0x3f) << 26) |
			((uint32_t)input[7] << 18) |
			((uint32_t)(input[8] & 0xc0) << 10);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 66 to 81
	value = ((uint32_t)(input[8] & 0x3f) << 26) |
			((uint32_t)input[9] << 18) |
			((uint32_t)(input[10] & 0xc0) << 10);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 82 to 97
	value = ((uint32_t)(input[10] & 0x3f) << 26) |
			((uint32_t)input[11] << 18) |
			((uint32_t)(input[12] & 0xc0) << 10);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 98 to 113
	value = ((uint32_t)(input[12] & 0x3f) << 26) |
			((uint32_t)input[13] << 18) |
			((uint32_t)(input[14] & 0xc0) << 10);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 114 to 129
	value = ((uint32_t)(input[14] & 0x3f) << 26) |
			((uint32_t)input[15] << 18) |
			((uint32_t)(input[16] & 0xc0) << 10);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 130 to 145
	value = ((uint32_t)(input[16] & 0x3f) << 26) |
			((uint32_t)input[17] << 18) |
			((uint32_t)(input[18] & 0xc0) << 10);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 146 to 161
	value = ((uint32_t)(input[18] & 0x3f) << 26) |
			((uint32_t)input[19] << 18) |
			((uint32_t)(input[20] & 0xc0) << 10);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 162 to 177
	value = ((uint32_t)(input[20] & 0x3f) << 26) |
			((uint32_t)input[21] << 18) |
			((uint32_t)(input[22] & 0xc0) << 10);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 178 to 193
	value = ((uint32_t)(input[22] & 0x3f) << 26) |
			((uint32_t)input[23] << 18) |
			((uint32_t)(input[24] & 0xc0) << 10);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 194 to 209
	value = ((uint32_t)(input[24] & 0x3f) << 26) |
			((uint32_t)input[25] << 18) |
			((uint32_t)(input[26] & 0xc0) << 10);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 210 to 225
	value = ((uint32_t)(input[26] & 0x3f) << 26) |
			((uint32_t)input[27] << 18) |
			((uint32_t)(input[28] & 0xc0) << 10);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 226 to 241
	value = ((uint32_t)(input[28] & 0x3f) << 26) |
			((uint32_t)input[29] << 18) |
			((uint32_t)(input[30] & 0xc0) << 10);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 242 to 257
	value = ((uint32_t)(input[30] & 0x3f) << 26) |
			((uint32_t)input[31] << 18) |
			((uint32_t)(input[32] & 0xc0) << 10);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 258 to 273
	value = ((uint32_t)(input[32] & 0x3f) << 26) |
			((uint32_t)input[33] << 18) |
			((uint32_t)(input[34] & 0xc0) << 10);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 274 to 289
	value = ((uint32_t)(input[34] & 0x3f) << 26) |
			((uint32_t)input[35] << 18) |
			((uint32_t)(input[36] & 0xc0) << 10);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 290 to 305
	value = ((uint32_t)(input[36] & 0x3f) << 26) |
			((uint32_t)input[37] << 18) |
			((uint32_t)(input[38] & 0xc0) << 10);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 306 to 321
	value = ((uint32_t)(input[38] & 0x3f) << 26) |
			((uint32_t)input[39] << 18) |
			((uint32_t)(input[40] & 0xc0) << 10);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 322 to 337
	value = ((uint32_t)(input[40] & 0x3f) << 26) |
			((uint32_t)input[41] << 18) |
			((uint32_t)(input[42] & 0xc0) << 10);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 338 to 353
	value = ((uint32_t)(input[42] & 0x3f) << 26) |
			((uint32_t)input[43] << 18) |
			((uint32_t)(input[44] & 0xc0) << 10);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 354 to 369
	value = ((uint32_t)(input[44] & 0x3f) << 26) |
			((uint32_t)input[45] << 18) |
			((uint32_t)(input[46] & 0xc0) << 10);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 370 to 385
	value = ((uint32_t)(input[46] & 0x3f) << 26) |
			((uint32_t)input[47] << 18) |
			((uint32_t)(input[48] & 0xc0) << 10);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 386 to 401
	value = ((uint32_t)(input[48] & 0x3f) << 26) |
			((uint32_t)input[49] << 18) |
			((uint32_t)(input[50] & 0xc0) << 10);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 402 to 417
	value = ((uint32_t)(input[50] & 0x3f) << 26) |
			((uint32_t)input[51] << 18) |
			((uint32_t)(input[52] & 0xc0) << 10);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 418 to 433
	value = ((uint32_t)(input[52] & 0x3f) << 26) |
			((uint32_t)input[53] << 18) |
			((uint32_t)(input[54] & 0xc0) << 10);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 434 to 449
	value = ((uint32_t)(input[54] & 0x3f) << 26) |
			((uint32_t)input[55] << 18) |
			((uint32_t)(input[56] & 0xc0) << 10);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 450 to 465
	value = ((uint32_t)(input[56] & 0x3f) << 26) |
			((uint32_t)input[57] << 18) |
			((uint32_t)(input[58] & 0xc0) << 10);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 466 to 481
	value = ((uint32_t)(input[58] & 0x3f) << 26) |
			((uint32_t)input[59] << 18) |
			((uint32_t)(input[60] & 0xc0) << 10);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 482 to 497
	value = ((uint32_t)(input[60] & 0x3f) << 26) |
			((uint32_t)input[61] << 18) |
			((uint32_t)(input[62] & 0xc0) << 10);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 498 to 513
	value = ((uint32_t)(input[62] & 0x3f) << 26) |
			((uint32_t)input[63] << 18) |
			((uint32_t)(input[64] & 0xc0) << 10);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 514 to 529
	value = ((uint32_t)(input[64] & 0x3f) << 26) |
			((uint32_t)input[65] << 18) |
			((uint32_t)(input[66] & 0xc0) << 10);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 530 to 545
	value = ((uint32_t)(input[66] & 0x3f) << 26) |
			((uint32_t)input[67] << 18) |
			((uint32_t)(input[68] & 0xc0) << 10);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 546 to 561
	value = ((uint32_t)(input[68] & 0x3f) << 26) |
			((uint32_t)input[69] << 18) |
			((uint32_t)(input[70] & 0xc0) << 10);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 562 to 577
	value = ((uint32_t)(input[70] & 0x3f) << 26) |
			((uint32_t)input[71] << 18) |
			((uint32_t)(input[72] & 0xc0) << 10);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 578 to 593
	value = ((uint32_t)(input[72] & 0x3f) << 26) |
			((uint32_t)input[73] << 18) |
			((uint32_t)(input[74] & 0xc0) << 10);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 594 to 609
	value = ((uint32_t)(input[74] & 0x3f) << 26) |
			((uint32_t)input[75] << 18) |
			((uint32_t)(input[76] & 0xc0) << 10);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 610 to 625
	value = ((uint32_t)(input[76] & 0x3f) << 26) |
			((uint32_t)input[77] << 18) |
			((uint32_t)(input[78] & 0xc0) << 10);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 626 to 641
	value = ((uint32_t)(input[78] & 0x3f) << 26) |
			((uint32_t)input[79] << 18) |
			((uint32_t)(input[80] & 0xc0) << 10);
	output[39] = (double)(value >> 16);

	// read output[40]: from bit 642 to 657
	value = ((uint32_t)(input[80] & 0x3f) << 26) |
			((uint32_t)input[81] << 18) |
			((uint32_t)(input[82] & 0xc0) << 10);
	output[40] = (double)(value >> 16);

	// read output[41]: from bit 658 to 673
	value = ((uint32_t)(input[82] & 0x3f) << 26) |
			((uint32_t)input[83] << 18) |
			((uint32_t)(input[84] & 0xc0) << 10);
	output[41] = (double)(value >> 16);

	// read output[42]: from bit 674 to 689
	value = ((uint32_t)(input[84] & 0x3f) << 26) |
			((uint32_t)input[85] << 18) |
			((uint32_t)(input[86] & 0xc0) << 10);
	output[42] = (double)(value >> 16);

	// read output[43]: from bit 690 to 705
	value = ((uint32_t)(input[86] & 0x3f) << 26) |
			((uint32_t)input[87] << 18) |
			((uint32_t)(input[88] & 0xc0) << 10);
	output[43] = (double)(value >> 16);

	// read output[44]: from bit 706 to 721
	value = ((uint32_t)(input[88] & 0x3f) << 26) |
			((uint32_t)input[89] << 18) |
			((uint32_t)(input[90] & 0xc0) << 10);
	output[44] = (double)(value >> 16);

	// read output[45]: from bit 722 to 737
	value = ((uint32_t)(input[90] & 0x3f) << 26) |
			((uint32_t)input[91] << 18) |
			((uint32_t)(input[92] & 0xc0) << 10);
	output[45] = (double)(value >> 16);

	// read output[46]: from bit 738 to 753
	value = ((uint32_t)(input[92] & 0x3f) << 26) |
			((uint32_t)input[93] << 18) |
			((uint32_t)(input[94] & 0xc0) << 10);
	output[46] = (double)(value >> 16);

	// read output[47]: from bit 754 to 769
	value = ((uint32_t)(input[94] & 0x3f) << 26) |
			((uint32_t)input[95] << 18) |
			((uint32_t)(input[96] & 0xc0) << 10);
	output[47] = (double)(value >> 16);

	// read output[48]: from bit 770 to 785
	value = ((uint32_t)(input[96] & 0x3f) << 26) |
			((uint32_t)input[97] << 18) |
			((uint32_t)(input[98] & 0xc0) << 10);
	output[48] = (double)(value >> 16);

	// read output[49]: from bit 786 to 801
	value = ((uint32_t)(input[98] & 0x3f) << 26) |
			((uint32_t)input[99] << 18) |
			((uint32_t)(input[100] & 0xc0) << 10);
	output[49] = (double)(value >> 16);

	// read output[50]: from bit 802 to 817
	value = ((uint32_t)(input[100] & 0x3f) << 26) |
			((uint32_t)input[101] << 18) |
			((uint32_t)(input[102] & 0xc0) << 10);
	output[50] = (double)(value >> 16);

	// read output[51]: from bit 818 to 833
	value = ((uint32_t)(input[102] & 0x3f) << 26) |
			((uint32_t)input[103] << 18) |
			((uint32_t)(input[104] & 0xc0) << 10);
	output[51] = (double)(value >> 16);

	// read output[52]: from bit 834 to 849
	value = ((uint32_t)(input[104] & 0x3f) << 26) |
			((uint32_t)input[105] << 18) |
			((uint32_t)(input[106] & 0xc0) << 10);
	output[52] = (double)(value >> 16);

	// read output[53]: from bit 850 to 865
	value = ((uint32_t)(input[106] & 0x3f) << 26) |
			((uint32_t)input[107] << 18) |
			((uint32_t)(input[108] & 0xc0) << 10);
	output[53] = (double)(value >> 16);

	// read output[54]: from bit 866 to 881
	value = ((uint32_t)(input[108] & 0x3f) << 26) |
			((uint32_t)input[109] << 18) |
			((uint32_t)(input[110] & 0xc0) << 10);
	output[54] = (double)(value >> 16);

	// read output[55]: from bit 882 to 897
	value = ((uint32_t)(input[110] & 0x3f) << 26) |
			((uint32_t)input[111] << 18) |
			((uint32_t)(input[112] & 0xc0) << 10);
	output[55] = (double)(value >> 16);

	// read output[56]: from bit 898 to 913
	value = ((uint32_t)(input[112] & 0x3f) << 26) |
			((uint32_t)input[113] << 18) |
			((uint32_t)(input[114] & 0xc0) << 10);
	output[56] = (double)(value >> 16);

	// read output[57]: from bit 914 to 929
	value = ((uint32_t)(input[114] & 0x3f) << 26) |
			((uint32_t)input[115] << 18) |
			((uint32_t)(input[116] & 0xc0) << 10);
	output[57] = (double)(value >> 16);

	// read output[58]: from bit 930 to 945
	value = ((uint32_t)(input[116] & 0x3f) << 26) |
			((uint32_t)input[117] << 18) |
			((uint32_t)(input[118] & 0xc0) << 10);
	output[58] = (double)(value >> 16);
}

static void unpack_59_16bit_signed_3off(const uint8_t * input, double * output, void *closure) {
	// Unpack 59 values into output
	// Values are 16-bit signed
	// Skip 3 bits, read 944 bits of data.
	// Input must be at least 119 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 3 to 18
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)input[1] << 19) |
			((uint32_t)(input[2] & 0xe0) << 11);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 19 to 34
	value = ((uint32_t)(input[2] & 0x1f) << 27) |
			((uint32_t)input[3] << 19) |
			((uint32_t)(input[4] & 0xe0) << 11);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 35 to 50
	value = ((uint32_t)(input[4] & 0x1f) << 27) |
			((uint32_t)input[5] << 19) |
			((uint32_t)(input[6] & 0xe0) << 11);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 51 to 66
	value = ((uint32_t)(input[6] & 0x1f) << 27) |
			((uint32_t)input[7] << 19) |
			((uint32_t)(input[8] & 0xe0) << 11);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 67 to 82
	value = ((uint32_t)(input[8] & 0x1f) << 27) |
			((uint32_t)input[9] << 19) |
			((uint32_t)(input[10] & 0xe0) << 11);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 83 to 98
	value = ((uint32_t)(input[10] & 0x1f) << 27) |
			((uint32_t)input[11] << 19) |
			((uint32_t)(input[12] & 0xe0) << 11);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 99 to 114
	value = ((uint32_t)(input[12] & 0x1f) << 27) |
			((uint32_t)input[13] << 19) |
			((uint32_t)(input[14] & 0xe0) << 11);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 115 to 130
	value = ((uint32_t)(input[14] & 0x1f) << 27) |
			((uint32_t)input[15] << 19) |
			((uint32_t)(input[16] & 0xe0) << 11);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 131 to 146
	value = ((uint32_t)(input[16] & 0x1f) << 27) |
			((uint32_t)input[17] << 19) |
			((uint32_t)(input[18] & 0xe0) << 11);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 147 to 162
	value = ((uint32_t)(input[18] & 0x1f) << 27) |
			((uint32_t)input[19] << 19) |
			((uint32_t)(input[20] & 0xe0) << 11);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 163 to 178
	value = ((uint32_t)(input[20] & 0x1f) << 27) |
			((uint32_t)input[21] << 19) |
			((uint32_t)(input[22] & 0xe0) << 11);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 179 to 194
	value = ((uint32_t)(input[22] & 0x1f) << 27) |
			((uint32_t)input[23] << 19) |
			((uint32_t)(input[24] & 0xe0) << 11);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 195 to 210
	value = ((uint32_t)(input[24] & 0x1f) << 27) |
			((uint32_t)input[25] << 19) |
			((uint32_t)(input[26] & 0xe0) << 11);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 211 to 226
	value = ((uint32_t)(input[26] & 0x1f) << 27) |
			((uint32_t)input[27] << 19) |
			((uint32_t)(input[28] & 0xe0) << 11);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 227 to 242
	value = ((uint32_t)(input[28] & 0x1f) << 27) |
			((uint32_t)input[29] << 19) |
			((uint32_t)(input[30] & 0xe0) << 11);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 243 to 258
	value = ((uint32_t)(input[30] & 0x1f) << 27) |
			((uint32_t)input[31] << 19) |
			((uint32_t)(input[32] & 0xe0) << 11);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 259 to 274
	value = ((uint32_t)(input[32] & 0x1f) << 27) |
			((uint32_t)input[33] << 19) |
			((uint32_t)(input[34] & 0xe0) << 11);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 275 to 290
	value = ((uint32_t)(input[34] & 0x1f) << 27) |
			((uint32_t)input[35] << 19) |
			((uint32_t)(input[36] & 0xe0) << 11);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 291 to 306
	value = ((uint32_t)(input[36] & 0x1f) << 27) |
			((uint32_t)input[37] << 19) |
			((uint32_t)(input[38] & 0xe0) << 11);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 307 to 322
	value = ((uint32_t)(input[38] & 0x1f) << 27) |
			((uint32_t)input[39] << 19) |
			((uint32_t)(input[40] & 0xe0) << 11);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 323 to 338
	value = ((uint32_t)(input[40] & 0x1f) << 27) |
			((uint32_t)input[41] << 19) |
			((uint32_t)(input[42] & 0xe0) << 11);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 339 to 354
	value = ((uint32_t)(input[42] & 0x1f) << 27) |
			((uint32_t)input[43] << 19) |
			((uint32_t)(input[44] & 0xe0) << 11);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 355 to 370
	value = ((uint32_t)(input[44] & 0x1f) << 27) |
			((uint32_t)input[45] << 19) |
			((uint32_t)(input[46] & 0xe0) << 11);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 371 to 386
	value = ((uint32_t)(input[46] & 0x1f) << 27) |
			((uint32_t)input[47] << 19) |
			((uint32_t)(input[48] & 0xe0) << 11);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 387 to 402
	value = ((uint32_t)(input[48] & 0x1f) << 27) |
			((uint32_t)input[49] << 19) |
			((uint32_t)(input[50] & 0xe0) << 11);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 403 to 418
	value = ((uint32_t)(input[50] & 0x1f) << 27) |
			((uint32_t)input[51] << 19) |
			((uint32_t)(input[52] & 0xe0) << 11);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 419 to 434
	value = ((uint32_t)(input[52] & 0x1f) << 27) |
			((uint32_t)input[53] << 19) |
			((uint32_t)(input[54] & 0xe0) << 11);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 435 to 450
	value = ((uint32_t)(input[54] & 0x1f) << 27) |
			((uint32_t)input[55] << 19) |
			((uint32_t)(input[56] & 0xe0) << 11);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 451 to 466
	value = ((uint32_t)(input[56] & 0x1f) << 27) |
			((uint32_t)input[57] << 19) |
			((uint32_t)(input[58] & 0xe0) << 11);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 467 to 482
	value = ((uint32_t)(input[58] & 0x1f) << 27) |
			((uint32_t)input[59] << 19) |
			((uint32_t)(input[60] & 0xe0) << 11);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 483 to 498
	value = ((uint32_t)(input[60] & 0x1f) << 27) |
			((uint32_t)input[61] << 19) |
			((uint32_t)(input[62] & 0xe0) << 11);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 499 to 514
	value = ((uint32_t)(input[62] & 0x1f) << 27) |
			((uint32_t)input[63] << 19) |
			((uint32_t)(input[64] & 0xe0) << 11);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 515 to 530
	value = ((uint32_t)(input[64] & 0x1f) << 27) |
			((uint32_t)input[65] << 19) |
			((uint32_t)(input[66] & 0xe0) << 11);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 531 to 546
	value = ((uint32_t)(input[66] & 0x1f) << 27) |
			((uint32_t)input[67] << 19) |
			((uint32_t)(input[68] & 0xe0) << 11);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 547 to 562
	value = ((uint32_t)(input[68] & 0x1f) << 27) |
			((uint32_t)input[69] << 19) |
			((uint32_t)(input[70] & 0xe0) << 11);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 563 to 578
	value = ((uint32_t)(input[70] & 0x1f) << 27) |
			((uint32_t)input[71] << 19) |
			((uint32_t)(input[72] & 0xe0) << 11);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 579 to 594
	value = ((uint32_t)(input[72] & 0x1f) << 27) |
			((uint32_t)input[73] << 19) |
			((uint32_t)(input[74] & 0xe0) << 11);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 595 to 610
	value = ((uint32_t)(input[74] & 0x1f) << 27) |
			((uint32_t)input[75] << 19) |
			((uint32_t)(input[76] & 0xe0) << 11);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 611 to 626
	value = ((uint32_t)(input[76] & 0x1f) << 27) |
			((uint32_t)input[77] << 19) |
			((uint32_t)(input[78] & 0xe0) << 11);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 627 to 642
	value = ((uint32_t)(input[78] & 0x1f) << 27) |
			((uint32_t)input[79] << 19) |
			((uint32_t)(input[80] & 0xe0) << 11);
	output[39] = (double)(value >> 16);

	// read output[40]: from bit 643 to 658
	value = ((uint32_t)(input[80] & 0x1f) << 27) |
			((uint32_t)input[81] << 19) |
			((uint32_t)(input[82] & 0xe0) << 11);
	output[40] = (double)(value >> 16);

	// read output[41]: from bit 659 to 674
	value = ((uint32_t)(input[82] & 0x1f) << 27) |
			((uint32_t)input[83] << 19) |
			((uint32_t)(input[84] & 0xe0) << 11);
	output[41] = (double)(value >> 16);

	// read output[42]: from bit 675 to 690
	value = ((uint32_t)(input[84] & 0x1f) << 27) |
			((uint32_t)input[85] << 19) |
			((uint32_t)(input[86] & 0xe0) << 11);
	output[42] = (double)(value >> 16);

	// read output[43]: from bit 691 to 706
	value = ((uint32_t)(input[86] & 0x1f) << 27) |
			((uint32_t)input[87] << 19) |
			((uint32_t)(input[88] & 0xe0) << 11);
	output[43] = (double)(value >> 16);

	// read output[44]: from bit 707 to 722
	value = ((uint32_t)(input[88] & 0x1f) << 27) |
			((uint32_t)input[89] << 19) |
			((uint32_t)(input[90] & 0xe0) << 11);
	output[44] = (double)(value >> 16);

	// read output[45]: from bit 723 to 738
	value = ((uint32_t)(input[90] & 0x1f) << 27) |
			((uint32_t)input[91] << 19) |
			((uint32_t)(input[92] & 0xe0) << 11);
	output[45] = (double)(value >> 16);

	// read output[46]: from bit 739 to 754
	value = ((uint32_t)(input[92] & 0x1f) << 27) |
			((uint32_t)input[93] << 19) |
			((uint32_t)(input[94] & 0xe0) << 11);
	output[46] = (double)(value >> 16);

	// read output[47]: from bit 755 to 770
	value = ((uint32_t)(input[94] & 0x1f) << 27) |
			((uint32_t)input[95] << 19) |
			((uint32_t)(input[96] & 0xe0) << 11);
	output[47] = (double)(value >> 16);

	// read output[48]: from bit 771 to 786
	value = ((uint32_t)(input[96] & 0x1f) << 27) |
			((uint32_t)input[97] << 19) |
			((uint32_t)(input[98] & 0xe0) << 11);
	output[48] = (double)(value >> 16);

	// read output[49]: from bit 787 to 802
	value = ((uint32_t)(input[98] & 0x1f) << 27) |
			((uint32_t)input[99] << 19) |
			((uint32_t)(input[100] & 0xe0) << 11);
	output[49] = (double)(value >> 16);

	// read output[50]: from bit 803 to 818
	value = ((uint32_t)(input[100] & 0x1f) << 27) |
			((uint32_t)input[101] << 19) |
			((uint32_t)(input[102] & 0xe0) << 11);
	output[50] = (double)(value >> 16);

	// read output[51]: from bit 819 to 834
	value = ((uint32_t)(input[102] & 0x1f) << 27) |
			((uint32_t)input[103] << 19) |
			((uint32_t)(input[104] & 0xe0) << 11);
	output[51] = (double)(value >> 16);

	// read output[52]: from bit 835 to 850
	value = ((uint32_t)(input[104] & 0x1f) << 27) |
			((uint32_t)input[105] << 19) |
			((uint32_t)(input[106] & 0xe0) << 11);
	output[52] = (double)(value >> 16);

	// read output[53]: from bit 851 to 866
	value = ((uint32_t)(input[106] & 0x1f) << 27) |
			((uint32_t)input[107] << 19) |
			((uint32_t)(input[108] & 0xe0) << 11);
	output[53] = (double)(value >> 16);

	// read output[54]: from bit 867 to 882
	value = ((uint32_t)(input[108] & 0x1f) << 27) |
			((uint32_t)input[109] << 19) |
			((uint32_t)(input[110] & 0xe0) << 11);
	output[54] = (double)(value >> 16);

	// read output[55]: from bit 883 to 898
	value = ((uint32_t)(input[110] & 0x1f) << 27) |
			((uint32_t)input[111] << 19) |
			((uint32_t)(input[112] & 0xe0) << 11);
	output[55] = (double)(value >> 16);

	// read output[56]: from bit 899 to 914
	value = ((uint32_t)(input[112] & 0x1f) << 27) |
			((uint32_t)input[113] << 19) |
			((uint32_t)(input[114] & 0xe0) << 11);
	output[56] = (double)(value >> 16);

	// read output[57]: from bit 915 to 930
	value = ((uint32_t)(input[114] & 0x1f) << 27) |
			((uint32_t)input[115] << 19) |
			((uint32_t)(input[116] & 0xe0) << 11);
	output[57] = (double)(value >> 16);

	// read output[58]: from bit 931 to 946
	value = ((uint32_t)(input[116] & 0x1f) << 27) |
			((uint32_t)input[117] << 19) |
			((uint32_t)(input[118] & 0xe0) << 11);
	output[58] = (double)(value >> 16);
}

static void unpack_59_16bit_unsigned_3off(const uint8_t * input, double * output, void *closure) {
	// Unpack 59 values into output
	// Values are 16-bit unsigned
	// Skip 3 bits, read 944 bits of data.
	// Input must be at least 119 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 3 to 18
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)input[1] << 19) |
			((uint32_t)(input[2] & 0xe0) << 11);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 19 to 34
	value = ((uint32_t)(input[2] & 0x1f) << 27) |
			((uint32_t)input[3] << 19) |
			((uint32_t)(input[4] & 0xe0) << 11);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 35 to 50
	value = ((uint32_t)(input[4] & 0x1f) << 27) |
			((uint32_t)input[5] << 19) |
			((uint32_t)(input[6] & 0xe0) << 11);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 51 to 66
	value = ((uint32_t)(input[6] & 0x1f) << 27) |
			((uint32_t)input[7] << 19) |
			((uint32_t)(input[8] & 0xe0) << 11);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 67 to 82
	value = ((uint32_t)(input[8] & 0x1f) << 27) |
			((uint32_t)input[9] << 19) |
			((uint32_t)(input[10] & 0xe0) << 11);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 83 to 98
	value = ((uint32_t)(input[10] & 0x1f) << 27) |
			((uint32_t)input[11] << 19) |
			((uint32_t)(input[12] & 0xe0) << 11);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 99 to 114
	value = ((uint32_t)(input[12] & 0x1f) << 27) |
			((uint32_t)input[13] << 19) |
			((uint32_t)(input[14] & 0xe0) << 11);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 115 to 130
	value = ((uint32_t)(input[14] & 0x1f) << 27) |
			((uint32_t)input[15] << 19) |
			((uint32_t)(input[16] & 0xe0) << 11);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 131 to 146
	value = ((uint32_t)(input[16] & 0x1f) << 27) |
			((uint32_t)input[17] << 19) |
			((uint32_t)(input[18] & 0xe0) << 11);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 147 to 162
	value = ((uint32_t)(input[18] & 0x1f) << 27) |
			((uint32_t)input[19] << 19) |
			((uint32_t)(input[20] & 0xe0) << 11);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 163 to 178
	value = ((uint32_t)(input[20] & 0x1f) << 27) |
			((uint32_t)input[21] << 19) |
			((uint32_t)(input[22] & 0xe0) << 11);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 179 to 194
	value = ((uint32_t)(input[22] & 0x1f) << 27) |
			((uint32_t)input[23] << 19) |
			((uint32_t)(input[24] & 0xe0) << 11);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 195 to 210
	value = ((uint32_t)(input[24] & 0x1f) << 27) |
			((uint32_t)input[25] << 19) |
			((uint32_t)(input[26] & 0xe0) << 11);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 211 to 226
	value = ((uint32_t)(input[26] & 0x1f) << 27) |
			((uint32_t)input[27] << 19) |
			((uint32_t)(input[28] & 0xe0) << 11);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 227 to 242
	value = ((uint32_t)(input[28] & 0x1f) << 27) |
			((uint32_t)input[29] << 19) |
			((uint32_t)(input[30] & 0xe0) << 11);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 243 to 258
	value = ((uint32_t)(input[30] & 0x1f) << 27) |
			((uint32_t)input[31] << 19) |
			((uint32_t)(input[32] & 0xe0) << 11);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 259 to 274
	value = ((uint32_t)(input[32] & 0x1f) << 27) |
			((uint32_t)input[33] << 19) |
			((uint32_t)(input[34] & 0xe0) << 11);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 275 to 290
	value = ((uint32_t)(input[34] & 0x1f) << 27) |
			((uint32_t)input[35] << 19) |
			((uint32_t)(input[36] & 0xe0) << 11);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 291 to 306
	value = ((uint32_t)(input[36] & 0x1f) << 27) |
			((uint32_t)input[37] << 19) |
			((uint32_t)(input[38] & 0xe0) << 11);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 307 to 322
	value = ((uint32_t)(input[38] & 0x1f) << 27) |
			((uint32_t)input[39] << 19) |
			((uint32_t)(input[40] & 0xe0) << 11);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 323 to 338
	value = ((uint32_t)(input[40] & 0x1f) << 27) |
			((uint32_t)input[41] << 19) |
			((uint32_t)(input[42] & 0xe0) << 11);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 339 to 354
	value = ((uint32_t)(input[42] & 0x1f) << 27) |
			((uint32_t)input[43] << 19) |
			((uint32_t)(input[44] & 0xe0) << 11);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 355 to 370
	value = ((uint32_t)(input[44] & 0x1f) << 27) |
			((uint32_t)input[45] << 19) |
			((uint32_t)(input[46] & 0xe0) << 11);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 371 to 386
	value = ((uint32_t)(input[46] & 0x1f) << 27) |
			((uint32_t)input[47] << 19) |
			((uint32_t)(input[48] & 0xe0) << 11);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 387 to 402
	value = ((uint32_t)(input[48] & 0x1f) << 27) |
			((uint32_t)input[49] << 19) |
			((uint32_t)(input[50] & 0xe0) << 11);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 403 to 418
	value = ((uint32_t)(input[50] & 0x1f) << 27) |
			((uint32_t)input[51] << 19) |
			((uint32_t)(input[52] & 0xe0) << 11);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 419 to 434
	value = ((uint32_t)(input[52] & 0x1f) << 27) |
			((uint32_t)input[53] << 19) |
			((uint32_t)(input[54] & 0xe0) << 11);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 435 to 450
	value = ((uint32_t)(input[54] & 0x1f) << 27) |
			((uint32_t)input[55] << 19) |
			((uint32_t)(input[56] & 0xe0) << 11);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 451 to 466
	value = ((uint32_t)(input[56] & 0x1f) << 27) |
			((uint32_t)input[57] << 19) |
			((uint32_t)(input[58] & 0xe0) << 11);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 467 to 482
	value = ((uint32_t)(input[58] & 0x1f) << 27) |
			((uint32_t)input[59] << 19) |
			((uint32_t)(input[60] & 0xe0) << 11);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 483 to 498
	value = ((uint32_t)(input[60] & 0x1f) << 27) |
			((uint32_t)input[61] << 19) |
			((uint32_t)(input[62] & 0xe0) << 11);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 499 to 514
	value = ((uint32_t)(input[62] & 0x1f) << 27) |
			((uint32_t)input[63] << 19) |
			((uint32_t)(input[64] & 0xe0) << 11);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 515 to 530
	value = ((uint32_t)(input[64] & 0x1f) << 27) |
			((uint32_t)input[65] << 19) |
			((uint32_t)(input[66] & 0xe0) << 11);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 531 to 546
	value = ((uint32_t)(input[66] & 0x1f) << 27) |
			((uint32_t)input[67] << 19) |
			((uint32_t)(input[68] & 0xe0) << 11);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 547 to 562
	value = ((uint32_t)(input[68] & 0x1f) << 27) |
			((uint32_t)input[69] << 19) |
			((uint32_t)(input[70] & 0xe0) << 11);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 563 to 578
	value = ((uint32_t)(input[70] & 0x1f) << 27) |
			((uint32_t)input[71] << 19) |
			((uint32_t)(input[72] & 0xe0) << 11);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 579 to 594
	value = ((uint32_t)(input[72] & 0x1f) << 27) |
			((uint32_t)input[73] << 19) |
			((uint32_t)(input[74] & 0xe0) << 11);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 595 to 610
	value = ((uint32_t)(input[74] & 0x1f) << 27) |
			((uint32_t)input[75] << 19) |
			((uint32_t)(input[76] & 0xe0) << 11);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 611 to 626
	value = ((uint32_t)(input[76] & 0x1f) << 27) |
			((uint32_t)input[77] << 19) |
			((uint32_t)(input[78] & 0xe0) << 11);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 627 to 642
	value = ((uint32_t)(input[78] & 0x1f) << 27) |
			((uint32_t)input[79] << 19) |
			((uint32_t)(input[80] & 0xe0) << 11);
	output[39] = (double)(value >> 16);

	// read output[40]: from bit 643 to 658
	value = ((uint32_t)(input[80] & 0x1f) << 27) |
			((uint32_t)input[81] << 19) |
			((uint32_t)(input[82] & 0xe0) << 11);
	output[40] = (double)(value >> 16);

	// read output[41]: from bit 659 to 674
	value = ((uint32_t)(input[82] & 0x1f) << 27) |
			((uint32_t)input[83] << 19) |
			((uint32_t)(input[84] & 0xe0) << 11);
	output[41] = (double)(value >> 16);

	// read output[42]: from bit 675 to 690
	value = ((uint32_t)(input[84] & 0x1f) << 27) |
			((uint32_t)input[85] << 19) |
			((uint32_t)(input[86] & 0xe0) << 11);
	output[42] = (double)(value >> 16);

	// read output[43]: from bit 691 to 706
	value = ((uint32_t)(input[86] & 0x1f) << 27) |
			((uint32_t)input[87] << 19) |
			((uint32_t)(input[88] & 0xe0) << 11);
	output[43] = (double)(value >> 16);

	// read output[44]: from bit 707 to 722
	value = ((uint32_t)(input[88] & 0x1f) << 27) |
			((uint32_t)input[89] << 19) |
			((uint32_t)(input[90] & 0xe0) << 11);
	output[44] = (double)(value >> 16);

	// read output[45]: from bit 723 to 738
	value = ((uint32_t)(input[90] & 0x1f) << 27) |
			((uint32_t)input[91] << 19) |
			((uint32_t)(input[92] & 0xe0) << 11);
	output[45] = (double)(value >> 16);

	// read output[46]: from bit 739 to 754
	value = ((uint32_t)(input[92] & 0x1f) << 27) |
			((uint32_t)input[93] << 19) |
			((uint32_t)(input[94] & 0xe0) << 11);
	output[46] = (double)(value >> 16);

	// read output[47]: from bit 755 to 770
	value = ((uint32_t)(input[94] & 0x1f) << 27) |
			((uint32_t)input[95] << 19) |
			((uint32_t)(input[96] & 0xe0) << 11);
	output[47] = (double)(value >> 16);

	// read output[48]: from bit 771 to 786
	value = ((uint32_t)(input[96] & 0x1f) << 27) |
			((uint32_t)input[97] << 19) |
			((uint32_t)(input[98] & 0xe0) << 11);
	output[48] = (double)(value >> 16);

	// read output[49]: from bit 787 to 802
	value = ((uint32_t)(input[98] & 0x1f) << 27) |
			((uint32_t)input[99] << 19) |
			((uint32_t)(input[100] & 0xe0) << 11);
	output[49] = (double)(value >> 16);

	// read output[50]: from bit 803 to 818
	value = ((uint32_t)(input[100] & 0x1f) << 27) |
			((uint32_t)input[101] << 19) |
			((uint32_t)(input[102] & 0xe0) << 11);
	output[50] = (double)(value >> 16);

	// read output[51]: from bit 819 to 834
	value = ((uint32_t)(input[102] & 0x1f) << 27) |
			((uint32_t)input[103] << 19) |
			((uint32_t)(input[104] & 0xe0) << 11);
	output[51] = (double)(value >> 16);

	// read output[52]: from bit 835 to 850
	value = ((uint32_t)(input[104] & 0x1f) << 27) |
			((uint32_t)input[105] << 19) |
			((uint32_t)(input[106] & 0xe0) << 11);
	output[52] = (double)(value >> 16);

	// read output[53]: from bit 851 to 866
	value = ((uint32_t)(input[106] & 0x1f) << 27) |
			((uint32_t)input[107] << 19) |
			((uint32_t)(input[108] & 0xe0) << 11);
	output[53] = (double)(value >> 16);

	// read output[54]: from bit 867 to 882
	value = ((uint32_t)(input[108] & 0x1f) << 27) |
			((uint32_t)input[109] << 19) |
			((uint32_t)(input[110] & 0xe0) << 11);
	output[54] = (double)(value >> 16);

	// read output[55]: from bit 883 to 898
	value = ((uint32_t)(input[110] & 0x1f) << 27) |
			((uint32_t)input[111] << 19) |
			((uint32_t)(input[112] & 0xe0) << 11);
	output[55] = (double)(value >> 16);

	// read output[56]: from bit 899 to 914
	value = ((uint32_t)(input[112] & 0x1f) << 27) |
			((uint32_t)input[113] << 19) |
			((uint32_t)(input[114] & 0xe0) << 11);
	output[56] = (double)(value >> 16);

	// read output[57]: from bit 915 to 930
	value = ((uint32_t)(input[114] & 0x1f) << 27) |
			((uint32_t)input[115] << 19) |
			((uint32_t)(input[116] & 0xe0) << 11);
	output[57] = (double)(value >> 16);

	// read output[58]: from bit 931 to 946
	value = ((uint32_t)(input[116] & 0x1f) << 27) |
			((uint32_t)input[117] << 19) |
			((uint32_t)(input[118] & 0xe0) << 11);
	output[58] = (double)(value >> 16);
}

static void unpack_59_16bit_signed_4off(const uint8_t * input, double * output, void *closure) {
	// Unpack 59 values into output
	// Values are 16-bit signed
	// Skip 4 bits, read 944 bits of data.
	// Input must be at least 119 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 4 to 19
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20) |
			((uint32_t)(input[2] & 0xf0) << 12);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 20 to 35
	value = ((uint32_t)(input[2] & 0x0f) << 28) |
			((uint32_t)input[3] << 20) |
			((uint32_t)(input[4] & 0xf0) << 12);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 36 to 51
	value = ((uint32_t)(input[4] & 0x0f) << 28) |
			((uint32_t)input[5] << 20) |
			((uint32_t)(input[6] & 0xf0) << 12);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 52 to 67
	value = ((uint32_t)(input[6] & 0x0f) << 28) |
			((uint32_t)input[7] << 20) |
			((uint32_t)(input[8] & 0xf0) << 12);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 68 to 83
	value = ((uint32_t)(input[8] & 0x0f) << 28) |
			((uint32_t)input[9] << 20) |
			((uint32_t)(input[10] & 0xf0) << 12);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 84 to 99
	value = ((uint32_t)(input[10] & 0x0f) << 28) |
			((uint32_t)input[11] << 20) |
			((uint32_t)(input[12] & 0xf0) << 12);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 100 to 115
	value = ((uint32_t)(input[12] & 0x0f) << 28) |
			((uint32_t)input[13] << 20) |
			((uint32_t)(input[14] & 0xf0) << 12);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 116 to 131
	value = ((uint32_t)(input[14] & 0x0f) << 28) |
			((uint32_t)input[15] << 20) |
			((uint32_t)(input[16] & 0xf0) << 12);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 132 to 147
	value = ((uint32_t)(input[16] & 0x0f) << 28) |
			((uint32_t)input[17] << 20) |
			((uint32_t)(input[18] & 0xf0) << 12);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 148 to 163
	value = ((uint32_t)(input[18] & 0x0f) << 28) |
			((uint32_t)input[19] << 20) |
			((uint32_t)(input[20] & 0xf0) << 12);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 164 to 179
	value = ((uint32_t)(input[20] & 0x0f) << 28) |
			((uint32_t)input[21] << 20) |
			((uint32_t)(input[22] & 0xf0) << 12);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 180 to 195
	value = ((uint32_t)(input[22] & 0x0f) << 28) |
			((uint32_t)input[23] << 20) |
			((uint32_t)(input[24] & 0xf0) << 12);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 196 to 211
	value = ((uint32_t)(input[24] & 0x0f) << 28) |
			((uint32_t)input[25] << 20) |
			((uint32_t)(input[26] & 0xf0) << 12);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 212 to 227
	value = ((uint32_t)(input[26] & 0x0f) << 28) |
			((uint32_t)input[27] << 20) |
			((uint32_t)(input[28] & 0xf0) << 12);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 228 to 243
	value = ((uint32_t)(input[28] & 0x0f) << 28) |
			((uint32_t)input[29] << 20) |
			((uint32_t)(input[30] & 0xf0) << 12);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 244 to 259
	value = ((uint32_t)(input[30] & 0x0f) << 28) |
			((uint32_t)input[31] << 20) |
			((uint32_t)(input[32] & 0xf0) << 12);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 260 to 275
	value = ((uint32_t)(input[32] & 0x0f) << 28) |
			((uint32_t)input[33] << 20) |
			((uint32_t)(input[34] & 0xf0) << 12);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 276 to 291
	value = ((uint32_t)(input[34] & 0x0f) << 28) |
			((uint32_t)input[35] << 20) |
			((uint32_t)(input[36] & 0xf0) << 12);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 292 to 307
	value = ((uint32_t)(input[36] & 0x0f) << 28) |
			((uint32_t)input[37] << 20) |
			((uint32_t)(input[38] & 0xf0) << 12);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 308 to 323
	value = ((uint32_t)(input[38] & 0x0f) << 28) |
			((uint32_t)input[39] << 20) |
			((uint32_t)(input[40] & 0xf0) << 12);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 324 to 339
	value = ((uint32_t)(input[40] & 0x0f) << 28) |
			((uint32_t)input[41] << 20) |
			((uint32_t)(input[42] & 0xf0) << 12);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 340 to 355
	value = ((uint32_t)(input[42] & 0x0f) << 28) |
			((uint32_t)input[43] << 20) |
			((uint32_t)(input[44] & 0xf0) << 12);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 356 to 371
	value = ((uint32_t)(input[44] & 0x0f) << 28) |
			((uint32_t)input[45] << 20) |
			((uint32_t)(input[46] & 0xf0) << 12);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 372 to 387
	value = ((uint32_t)(input[46] & 0x0f) << 28) |
			((uint32_t)input[47] << 20) |
			((uint32_t)(input[48] & 0xf0) << 12);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 388 to 403
	value = ((uint32_t)(input[48] & 0x0f) << 28) |
			((uint32_t)input[49] << 20) |
			((uint32_t)(input[50] & 0xf0) << 12);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 404 to 419
	value = ((uint32_t)(input[50] & 0x0f) << 28) |
			((uint32_t)input[51] << 20) |
			((uint32_t)(input[52] & 0xf0) << 12);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 420 to 435
	value = ((uint32_t)(input[52] & 0x0f) << 28) |
			((uint32_t)input[53] << 20) |
			((uint32_t)(input[54] & 0xf0) << 12);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 436 to 451
	value = ((uint32_t)(input[54] & 0x0f) << 28) |
			((uint32_t)input[55] << 20) |
			((uint32_t)(input[56] & 0xf0) << 12);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 452 to 467
	value = ((uint32_t)(input[56] & 0x0f) << 28) |
			((uint32_t)input[57] << 20) |
			((uint32_t)(input[58] & 0xf0) << 12);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 468 to 483
	value = ((uint32_t)(input[58] & 0x0f) << 28) |
			((uint32_t)input[59] << 20) |
			((uint32_t)(input[60] & 0xf0) << 12);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 484 to 499
	value = ((uint32_t)(input[60] & 0x0f) << 28) |
			((uint32_t)input[61] << 20) |
			((uint32_t)(input[62] & 0xf0) << 12);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 500 to 515
	value = ((uint32_t)(input[62] & 0x0f) << 28) |
			((uint32_t)input[63] << 20) |
			((uint32_t)(input[64] & 0xf0) << 12);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 516 to 531
	value = ((uint32_t)(input[64] & 0x0f) << 28) |
			((uint32_t)input[65] << 20) |
			((uint32_t)(input[66] & 0xf0) << 12);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 532 to 547
	value = ((uint32_t)(input[66] & 0x0f) << 28) |
			((uint32_t)input[67] << 20) |
			((uint32_t)(input[68] & 0xf0) << 12);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 548 to 563
	value = ((uint32_t)(input[68] & 0x0f) << 28) |
			((uint32_t)input[69] << 20) |
			((uint32_t)(input[70] & 0xf0) << 12);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 564 to 579
	value = ((uint32_t)(input[70] & 0x0f) << 28) |
			((uint32_t)input[71] << 20) |
			((uint32_t)(input[72] & 0xf0) << 12);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 580 to 595
	value = ((uint32_t)(input[72] & 0x0f) << 28) |
			((uint32_t)input[73] << 20) |
			((uint32_t)(input[74] & 0xf0) << 12);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 596 to 611
	value = ((uint32_t)(input[74] & 0x0f) << 28) |
			((uint32_t)input[75] << 20) |
			((uint32_t)(input[76] & 0xf0) << 12);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 612 to 627
	value = ((uint32_t)(input[76] & 0x0f) << 28) |
			((uint32_t)input[77] << 20) |
			((uint32_t)(input[78] & 0xf0) << 12);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 628 to 643
	value = ((uint32_t)(input[78] & 0x0f) << 28) |
			((uint32_t)input[79] << 20) |
			((uint32_t)(input[80] & 0xf0) << 12);
	output[39] = (double)(value >> 16);

	// read output[40]: from bit 644 to 659
	value = ((uint32_t)(input[80] & 0x0f) << 28) |
			((uint32_t)input[81] << 20) |
			((uint32_t)(input[82] & 0xf0) << 12);
	output[40] = (double)(value >> 16);

	// read output[41]: from bit 660 to 675
	value = ((uint32_t)(input[82] & 0x0f) << 28) |
			((uint32_t)input[83] << 20) |
			((uint32_t)(input[84] & 0xf0) << 12);
	output[41] = (double)(value >> 16);

	// read output[42]: from bit 676 to 691
	value = ((uint32_t)(input[84] & 0x0f) << 28) |
			((uint32_t)input[85] << 20) |
			((uint32_t)(input[86] & 0xf0) << 12);
	output[42] = (double)(value >> 16);

	// read output[43]: from bit 692 to 707
	value = ((uint32_t)(input[86] & 0x0f) << 28) |
			((uint32_t)input[87] << 20) |
			((uint32_t)(input[88] & 0xf0) << 12);
	output[43] = (double)(value >> 16);

	// read output[44]: from bit 708 to 723
	value = ((uint32_t)(input[88] & 0x0f) << 28) |
			((uint32_t)input[89] << 20) |
			((uint32_t)(input[90] & 0xf0) << 12);
	output[44] = (double)(value >> 16);

	// read output[45]: from bit 724 to 739
	value = ((uint32_t)(input[90] & 0x0f) << 28) |
			((uint32_t)input[91] << 20) |
			((uint32_t)(input[92] & 0xf0) << 12);
	output[45] = (double)(value >> 16);

	// read output[46]: from bit 740 to 755
	value = ((uint32_t)(input[92] & 0x0f) << 28) |
			((uint32_t)input[93] << 20) |
			((uint32_t)(input[94] & 0xf0) << 12);
	output[46] = (double)(value >> 16);

	// read output[47]: from bit 756 to 771
	value = ((uint32_t)(input[94] & 0x0f) << 28) |
			((uint32_t)input[95] << 20) |
			((uint32_t)(input[96] & 0xf0) << 12);
	output[47] = (double)(value >> 16);

	// read output[48]: from bit 772 to 787
	value = ((uint32_t)(input[96] & 0x0f) << 28) |
			((uint32_t)input[97] << 20) |
			((uint32_t)(input[98] & 0xf0) << 12);
	output[48] = (double)(value >> 16);

	// read output[49]: from bit 788 to 803
	value = ((uint32_t)(input[98] & 0x0f) << 28) |
			((uint32_t)input[99] << 20) |
			((uint32_t)(input[100] & 0xf0) << 12);
	output[49] = (double)(value >> 16);

	// read output[50]: from bit 804 to 819
	value = ((uint32_t)(input[100] & 0x0f) << 28) |
			((uint32_t)input[101] << 20) |
			((uint32_t)(input[102] & 0xf0) << 12);
	output[50] = (double)(value >> 16);

	// read output[51]: from bit 820 to 835
	value = ((uint32_t)(input[102] & 0x0f) << 28) |
			((uint32_t)input[103] << 20) |
			((uint32_t)(input[104] & 0xf0) << 12);
	output[51] = (double)(value >> 16);

	// read output[52]: from bit 836 to 851
	value = ((uint32_t)(input[104] & 0x0f) << 28) |
			((uint32_t)input[105] << 20) |
			((uint32_t)(input[106] & 0xf0) << 12);
	output[52] = (double)(value >> 16);

	// read output[53]: from bit 852 to 867
	value = ((uint32_t)(input[106] & 0x0f) << 28) |
			((uint32_t)input[107] << 20) |
			((uint32_t)(input[108] & 0xf0) << 12);
	output[53] = (double)(value >> 16);

	// read output[54]: from bit 868 to 883
	value = ((uint32_t)(input[108] & 0x0f) << 28) |
			((uint32_t)input[109] << 20) |
			((uint32_t)(input[110] & 0xf0) << 12);
	output[54] = (double)(value >> 16);

	// read output[55]: from bit 884 to 899
	value = ((uint32_t)(input[110] & 0x0f) << 28) |
			((uint32_t)input[111] << 20) |
			((uint32_t)(input[112] & 0xf0) << 12);
	output[55] = (double)(value >> 16);

	// read output[56]: from bit 900 to 915
	value = ((uint32_t)(input[112] & 0x0f) << 28) |
			((uint32_t)input[113] << 20) |
			((uint32_t)(input[114] & 0xf0) << 12);
	output[56] = (double)(value >> 16);

	// read output[57]: from bit 916 to 931
	value = ((uint32_t)(input[114] & 0x0f) << 28) |
			((uint32_t)input[115] << 20) |
			((uint32_t)(input[116] & 0xf0) << 12);
	output[57] = (double)(value >> 16);

	// read output[58]: from bit 932 to 947
	value = ((uint32_t)(input[116] & 0x0f) << 28) |
			((uint32_t)input[117] << 20) |
			((uint32_t)(input[118] & 0xf0) << 12);
	output[58] = (double)(value >> 16);
}

static void unpack_59_16bit_unsigned_4off(const uint8_t * input, double * output, void *closure) {
	// Unpack 59 values into output
	// Values are 16-bit unsigned
	// Skip 4 bits, read 944 bits of data.
	// Input must be at least 119 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 4 to 19
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20) |
			((uint32_t)(input[2] & 0xf0) << 12);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 20 to 35
	value = ((uint32_t)(input[2] & 0x0f) << 28) |
			((uint32_t)input[3] << 20) |
			((uint32_t)(input[4] & 0xf0) << 12);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 36 to 51
	value = ((uint32_t)(input[4] & 0x0f) << 28) |
			((uint32_t)input[5] << 20) |
			((uint32_t)(input[6] & 0xf0) << 12);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 52 to 67
	value = ((uint32_t)(input[6] & 0x0f) << 28) |
			((uint32_t)input[7] << 20) |
			((uint32_t)(input[8] & 0xf0) << 12);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 68 to 83
	value = ((uint32_t)(input[8] & 0x0f) << 28) |
			((uint32_t)input[9] << 20) |
			((uint32_t)(input[10] & 0xf0) << 12);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 84 to 99
	value = ((uint32_t)(input[10] & 0x0f) << 28) |
			((uint32_t)input[11] << 20) |
			((uint32_t)(input[12] & 0xf0) << 12);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 100 to 115
	value = ((uint32_t)(input[12] & 0x0f) << 28) |
			((uint32_t)input[13] << 20) |
			((uint32_t)(input[14] & 0xf0) << 12);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 116 to 131
	value = ((uint32_t)(input[14] & 0x0f) << 28) |
			((uint32_t)input[15] << 20) |
			((uint32_t)(input[16] & 0xf0) << 12);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 132 to 147
	value = ((uint32_t)(input[16] & 0x0f) << 28) |
			((uint32_t)input[17] << 20) |
			((uint32_t)(input[18] & 0xf0) << 12);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 148 to 163
	value = ((uint32_t)(input[18] & 0x0f) << 28) |
			((uint32_t)input[19] << 20) |
			((uint32_t)(input[20] & 0xf0) << 12);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 164 to 179
	value = ((uint32_t)(input[20] & 0x0f) << 28) |
			((uint32_t)input[21] << 20) |
			((uint32_t)(input[22] & 0xf0) << 12);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 180 to 195
	value = ((uint32_t)(input[22] & 0x0f) << 28) |
			((uint32_t)input[23] << 20) |
			((uint32_t)(input[24] & 0xf0) << 12);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 196 to 211
	value = ((uint32_t)(input[24] & 0x0f) << 28) |
			((uint32_t)input[25] << 20) |
			((uint32_t)(input[26] & 0xf0) << 12);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 212 to 227
	value = ((uint32_t)(input[26] & 0x0f) << 28) |
			((uint32_t)input[27] << 20) |
			((uint32_t)(input[28] & 0xf0) << 12);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 228 to 243
	value = ((uint32_t)(input[28] & 0x0f) << 28) |
			((uint32_t)input[29] << 20) |
			((uint32_t)(input[30] & 0xf0) << 12);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 244 to 259
	value = ((uint32_t)(input[30] & 0x0f) << 28) |
			((uint32_t)input[31] << 20) |
			((uint32_t)(input[32] & 0xf0) << 12);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 260 to 275
	value = ((uint32_t)(input[32] & 0x0f) << 28) |
			((uint32_t)input[33] << 20) |
			((uint32_t)(input[34] & 0xf0) << 12);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 276 to 291
	value = ((uint32_t)(input[34] & 0x0f) << 28) |
			((uint32_t)input[35] << 20) |
			((uint32_t)(input[36] & 0xf0) << 12);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 292 to 307
	value = ((uint32_t)(input[36] & 0x0f) << 28) |
			((uint32_t)input[37] << 20) |
			((uint32_t)(input[38] & 0xf0) << 12);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 308 to 323
	value = ((uint32_t)(input[38] & 0x0f) << 28) |
			((uint32_t)input[39] << 20) |
			((uint32_t)(input[40] & 0xf0) << 12);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 324 to 339
	value = ((uint32_t)(input[40] & 0x0f) << 28) |
			((uint32_t)input[41] << 20) |
			((uint32_t)(input[42] & 0xf0) << 12);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 340 to 355
	value = ((uint32_t)(input[42] & 0x0f) << 28) |
			((uint32_t)input[43] << 20) |
			((uint32_t)(input[44] & 0xf0) << 12);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 356 to 371
	value = ((uint32_t)(input[44] & 0x0f) << 28) |
			((uint32_t)input[45] << 20) |
			((uint32_t)(input[46] & 0xf0) << 12);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 372 to 387
	value = ((uint32_t)(input[46] & 0x0f) << 28) |
			((uint32_t)input[47] << 20) |
			((uint32_t)(input[48] & 0xf0) << 12);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 388 to 403
	value = ((uint32_t)(input[48] & 0x0f) << 28) |
			((uint32_t)input[49] << 20) |
			((uint32_t)(input[50] & 0xf0) << 12);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 404 to 419
	value = ((uint32_t)(input[50] & 0x0f) << 28) |
			((uint32_t)input[51] << 20) |
			((uint32_t)(input[52] & 0xf0) << 12);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 420 to 435
	value = ((uint32_t)(input[52] & 0x0f) << 28) |
			((uint32_t)input[53] << 20) |
			((uint32_t)(input[54] & 0xf0) << 12);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 436 to 451
	value = ((uint32_t)(input[54] & 0x0f) << 28) |
			((uint32_t)input[55] << 20) |
			((uint32_t)(input[56] & 0xf0) << 12);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 452 to 467
	value = ((uint32_t)(input[56] & 0x0f) << 28) |
			((uint32_t)input[57] << 20) |
			((uint32_t)(input[58] & 0xf0) << 12);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 468 to 483
	value = ((uint32_t)(input[58] & 0x0f) << 28) |
			((uint32_t)input[59] << 20) |
			((uint32_t)(input[60] & 0xf0) << 12);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 484 to 499
	value = ((uint32_t)(input[60] & 0x0f) << 28) |
			((uint32_t)input[61] << 20) |
			((uint32_t)(input[62] & 0xf0) << 12);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 500 to 515
	value = ((uint32_t)(input[62] & 0x0f) << 28) |
			((uint32_t)input[63] << 20) |
			((uint32_t)(input[64] & 0xf0) << 12);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 516 to 531
	value = ((uint32_t)(input[64] & 0x0f) << 28) |
			((uint32_t)input[65] << 20) |
			((uint32_t)(input[66] & 0xf0) << 12);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 532 to 547
	value = ((uint32_t)(input[66] & 0x0f) << 28) |
			((uint32_t)input[67] << 20) |
			((uint32_t)(input[68] & 0xf0) << 12);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 548 to 563
	value = ((uint32_t)(input[68] & 0x0f) << 28) |
			((uint32_t)input[69] << 20) |
			((uint32_t)(input[70] & 0xf0) << 12);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 564 to 579
	value = ((uint32_t)(input[70] & 0x0f) << 28) |
			((uint32_t)input[71] << 20) |
			((uint32_t)(input[72] & 0xf0) << 12);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 580 to 595
	value = ((uint32_t)(input[72] & 0x0f) << 28) |
			((uint32_t)input[73] << 20) |
			((uint32_t)(input[74] & 0xf0) << 12);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 596 to 611
	value = ((uint32_t)(input[74] & 0x0f) << 28) |
			((uint32_t)input[75] << 20) |
			((uint32_t)(input[76] & 0xf0) << 12);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 612 to 627
	value = ((uint32_t)(input[76] & 0x0f) << 28) |
			((uint32_t)input[77] << 20) |
			((uint32_t)(input[78] & 0xf0) << 12);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 628 to 643
	value = ((uint32_t)(input[78] & 0x0f) << 28) |
			((uint32_t)input[79] << 20) |
			((uint32_t)(input[80] & 0xf0) << 12);
	output[39] = (double)(value >> 16);

	// read output[40]: from bit 644 to 659
	value = ((uint32_t)(input[80] & 0x0f) << 28) |
			((uint32_t)input[81] << 20) |
			((uint32_t)(input[82] & 0xf0) << 12);
	output[40] = (double)(value >> 16);

	// read output[41]: from bit 660 to 675
	value = ((uint32_t)(input[82] & 0x0f) << 28) |
			((uint32_t)input[83] << 20) |
			((uint32_t)(input[84] & 0xf0) << 12);
	output[41] = (double)(value >> 16);

	// read output[42]: from bit 676 to 691
	value = ((uint32_t)(input[84] & 0x0f) << 28) |
			((uint32_t)input[85] << 20) |
			((uint32_t)(input[86] & 0xf0) << 12);
	output[42] = (double)(value >> 16);

	// read output[43]: from bit 692 to 707
	value = ((uint32_t)(input[86] & 0x0f) << 28) |
			((uint32_t)input[87] << 20) |
			((uint32_t)(input[88] & 0xf0) << 12);
	output[43] = (double)(value >> 16);

	// read output[44]: from bit 708 to 723
	value = ((uint32_t)(input[88] & 0x0f) << 28) |
			((uint32_t)input[89] << 20) |
			((uint32_t)(input[90] & 0xf0) << 12);
	output[44] = (double)(value >> 16);

	// read output[45]: from bit 724 to 739
	value = ((uint32_t)(input[90] & 0x0f) << 28) |
			((uint32_t)input[91] << 20) |
			((uint32_t)(input[92] & 0xf0) << 12);
	output[45] = (double)(value >> 16);

	// read output[46]: from bit 740 to 755
	value = ((uint32_t)(input[92] & 0x0f) << 28) |
			((uint32_t)input[93] << 20) |
			((uint32_t)(input[94] & 0xf0) << 12);
	output[46] = (double)(value >> 16);

	// read output[47]: from bit 756 to 771
	value = ((uint32_t)(input[94] & 0x0f) << 28) |
			((uint32_t)input[95] << 20) |
			((uint32_t)(input[96] & 0xf0) << 12);
	output[47] = (double)(value >> 16);

	// read output[48]: from bit 772 to 787
	value = ((uint32_t)(input[96] & 0x0f) << 28) |
			((uint32_t)input[97] << 20) |
			((uint32_t)(input[98] & 0xf0) << 12);
	output[48] = (double)(value >> 16);

	// read output[49]: from bit 788 to 803
	value = ((uint32_t)(input[98] & 0x0f) << 28) |
			((uint32_t)input[99] << 20) |
			((uint32_t)(input[100] & 0xf0) << 12);
	output[49] = (double)(value >> 16);

	// read output[50]: from bit 804 to 819
	value = ((uint32_t)(input[100] & 0x0f) << 28) |
			((uint32_t)input[101] << 20) |
			((uint32_t)(input[102] & 0xf0) << 12);
	output[50] = (double)(value >> 16);

	// read output[51]: from bit 820 to 835
	value = ((uint32_t)(input[102] & 0x0f) << 28) |
			((uint32_t)input[103] << 20) |
			((uint32_t)(input[104] & 0xf0) << 12);
	output[51] = (double)(value >> 16);

	// read output[52]: from bit 836 to 851
	value = ((uint32_t)(input[104] & 0x0f) << 28) |
			((uint32_t)input[105] << 20) |
			((uint32_t)(input[106] & 0xf0) << 12);
	output[52] = (double)(value >> 16);

	// read output[53]: from bit 852 to 867
	value = ((uint32_t)(input[106] & 0x0f) << 28) |
			((uint32_t)input[107] << 20) |
			((uint32_t)(input[108] & 0xf0) << 12);
	output[53] = (double)(value >> 16);

	// read output[54]: from bit 868 to 883
	value = ((uint32_t)(input[108] & 0x0f) << 28) |
			((uint32_t)input[109] << 20) |
			((uint32_t)(input[110] & 0xf0) << 12);
	output[54] = (double)(value >> 16);

	// read output[55]: from bit 884 to 899
	value = ((uint32_t)(input[110] & 0x0f) << 28) |
			((uint32_t)input[111] << 20) |
			((uint32_t)(input[112] & 0xf0) << 12);
	output[55] = (double)(value >> 16);

	// read output[56]: from bit 900 to 915
	value = ((uint32_t)(input[112] & 0x0f) << 28) |
			((uint32_t)input[113] << 20) |
			((uint32_t)(input[114] & 0xf0) << 12);
	output[56] = (double)(value >> 16);

	// read output[57]: from bit 916 to 931
	value = ((uint32_t)(input[114] & 0x0f) << 28) |
			((uint32_t)input[115] << 20) |
			((uint32_t)(input[116] & 0xf0) << 12);
	output[57] = (double)(value >> 16);

	// read output[58]: from bit 932 to 947
	value = ((uint32_t)(input[116] & 0x0f) << 28) |
			((uint32_t)input[117] << 20) |
			((uint32_t)(input[118] & 0xf0) << 12);
	output[58] = (double)(value >> 16);
}

static void unpack_59_16bit_signed_5off(const uint8_t * input, double * output, void *closure) {
	// Unpack 59 values into output
	// Values are 16-bit signed
	// Skip 5 bits, read 944 bits of data.
	// Input must be at least 119 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 5 to 20
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)(input[2] & 0xf8) << 13);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 21 to 36
	value = ((uint32_t)(input[2] & 0x07) << 29) |
			((uint32_t)input[3] << 21) |
			((uint32_t)(input[4] & 0xf8) << 13);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 37 to 52
	value = ((uint32_t)(input[4] & 0x07) << 29) |
			((uint32_t)input[5] << 21) |
			((uint32_t)(input[6] & 0xf8) << 13);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 53 to 68
	value = ((uint32_t)(input[6] & 0x07) << 29) |
			((uint32_t)input[7] << 21) |
			((uint32_t)(input[8] & 0xf8) << 13);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 69 to 84
	value = ((uint32_t)(input[8] & 0x07) << 29) |
			((uint32_t)input[9] << 21) |
			((uint32_t)(input[10] & 0xf8) << 13);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 85 to 100
	value = ((uint32_t)(input[10] & 0x07) << 29) |
			((uint32_t)input[11] << 21) |
			((uint32_t)(input[12] & 0xf8) << 13);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 101 to 116
	value = ((uint32_t)(input[12] & 0x07) << 29) |
			((uint32_t)input[13] << 21) |
			((uint32_t)(input[14] & 0xf8) << 13);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 117 to 132
	value = ((uint32_t)(input[14] & 0x07) << 29) |
			((uint32_t)input[15] << 21) |
			((uint32_t)(input[16] & 0xf8) << 13);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 133 to 148
	value = ((uint32_t)(input[16] & 0x07) << 29) |
			((uint32_t)input[17] << 21) |
			((uint32_t)(input[18] & 0xf8) << 13);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 149 to 164
	value = ((uint32_t)(input[18] & 0x07) << 29) |
			((uint32_t)input[19] << 21) |
			((uint32_t)(input[20] & 0xf8) << 13);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 165 to 180
	value = ((uint32_t)(input[20] & 0x07) << 29) |
			((uint32_t)input[21] << 21) |
			((uint32_t)(input[22] & 0xf8) << 13);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 181 to 196
	value = ((uint32_t)(input[22] & 0x07) << 29) |
			((uint32_t)input[23] << 21) |
			((uint32_t)(input[24] & 0xf8) << 13);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 197 to 212
	value = ((uint32_t)(input[24] & 0x07) << 29) |
			((uint32_t)input[25] << 21) |
			((uint32_t)(input[26] & 0xf8) << 13);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 213 to 228
	value = ((uint32_t)(input[26] & 0x07) << 29) |
			((uint32_t)input[27] << 21) |
			((uint32_t)(input[28] & 0xf8) << 13);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 229 to 244
	value = ((uint32_t)(input[28] & 0x07) << 29) |
			((uint32_t)input[29] << 21) |
			((uint32_t)(input[30] & 0xf8) << 13);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 245 to 260
	value = ((uint32_t)(input[30] & 0x07) << 29) |
			((uint32_t)input[31] << 21) |
			((uint32_t)(input[32] & 0xf8) << 13);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 261 to 276
	value = ((uint32_t)(input[32] & 0x07) << 29) |
			((uint32_t)input[33] << 21) |
			((uint32_t)(input[34] & 0xf8) << 13);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 277 to 292
	value = ((uint32_t)(input[34] & 0x07) << 29) |
			((uint32_t)input[35] << 21) |
			((uint32_t)(input[36] & 0xf8) << 13);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 293 to 308
	value = ((uint32_t)(input[36] & 0x07) << 29) |
			((uint32_t)input[37] << 21) |
			((uint32_t)(input[38] & 0xf8) << 13);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 309 to 324
	value = ((uint32_t)(input[38] & 0x07) << 29) |
			((uint32_t)input[39] << 21) |
			((uint32_t)(input[40] & 0xf8) << 13);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 325 to 340
	value = ((uint32_t)(input[40] & 0x07) << 29) |
			((uint32_t)input[41] << 21) |
			((uint32_t)(input[42] & 0xf8) << 13);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 341 to 356
	value = ((uint32_t)(input[42] & 0x07) << 29) |
			((uint32_t)input[43] << 21) |
			((uint32_t)(input[44] & 0xf8) << 13);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 357 to 372
	value = ((uint32_t)(input[44] & 0x07) << 29) |
			((uint32_t)input[45] << 21) |
			((uint32_t)(input[46] & 0xf8) << 13);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 373 to 388
	value = ((uint32_t)(input[46] & 0x07) << 29) |
			((uint32_t)input[47] << 21) |
			((uint32_t)(input[48] & 0xf8) << 13);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 389 to 404
	value = ((uint32_t)(input[48] & 0x07) << 29) |
			((uint32_t)input[49] << 21) |
			((uint32_t)(input[50] & 0xf8) << 13);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 405 to 420
	value = ((uint32_t)(input[50] & 0x07) << 29) |
			((uint32_t)input[51] << 21) |
			((uint32_t)(input[52] & 0xf8) << 13);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 421 to 436
	value = ((uint32_t)(input[52] & 0x07) << 29) |
			((uint32_t)input[53] << 21) |
			((uint32_t)(input[54] & 0xf8) << 13);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 437 to 452
	value = ((uint32_t)(input[54] & 0x07) << 29) |
			((uint32_t)input[55] << 21) |
			((uint32_t)(input[56] & 0xf8) << 13);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 453 to 468
	value = ((uint32_t)(input[56] & 0x07) << 29) |
			((uint32_t)input[57] << 21) |
			((uint32_t)(input[58] & 0xf8) << 13);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 469 to 484
	value = ((uint32_t)(input[58] & 0x07) << 29) |
			((uint32_t)input[59] << 21) |
			((uint32_t)(input[60] & 0xf8) << 13);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 485 to 500
	value = ((uint32_t)(input[60] & 0x07) << 29) |
			((uint32_t)input[61] << 21) |
			((uint32_t)(input[62] & 0xf8) << 13);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 501 to 516
	value = ((uint32_t)(input[62] & 0x07) << 29) |
			((uint32_t)input[63] << 21) |
			((uint32_t)(input[64] & 0xf8) << 13);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 517 to 532
	value = ((uint32_t)(input[64] & 0x07) << 29) |
			((uint32_t)input[65] << 21) |
			((uint32_t)(input[66] & 0xf8) << 13);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 533 to 548
	value = ((uint32_t)(input[66] & 0x07) << 29) |
			((uint32_t)input[67] << 21) |
			((uint32_t)(input[68] & 0xf8) << 13);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 549 to 564
	value = ((uint32_t)(input[68] & 0x07) << 29) |
			((uint32_t)input[69] << 21) |
			((uint32_t)(input[70] & 0xf8) << 13);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 565 to 580
	value = ((uint32_t)(input[70] & 0x07) << 29) |
			((uint32_t)input[71] << 21) |
			((uint32_t)(input[72] & 0xf8) << 13);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 581 to 596
	value = ((uint32_t)(input[72] & 0x07) << 29) |
			((uint32_t)input[73] << 21) |
			((uint32_t)(input[74] & 0xf8) << 13);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 597 to 612
	value = ((uint32_t)(input[74] & 0x07) << 29) |
			((uint32_t)input[75] << 21) |
			((uint32_t)(input[76] & 0xf8) << 13);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 613 to 628
	value = ((uint32_t)(input[76] & 0x07) << 29) |
			((uint32_t)input[77] << 21) |
			((uint32_t)(input[78] & 0xf8) << 13);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 629 to 644
	value = ((uint32_t)(input[78] & 0x07) << 29) |
			((uint32_t)input[79] << 21) |
			((uint32_t)(input[80] & 0xf8) << 13);
	output[39] = (double)(value >> 16);

	// read output[40]: from bit 645 to 660
	value = ((uint32_t)(input[80] & 0x07) << 29) |
			((uint32_t)input[81] << 21) |
			((uint32_t)(input[82] & 0xf8) << 13);
	output[40] = (double)(value >> 16);

	// read output[41]: from bit 661 to 676
	value = ((uint32_t)(input[82] & 0x07) << 29) |
			((uint32_t)input[83] << 21) |
			((uint32_t)(input[84] & 0xf8) << 13);
	output[41] = (double)(value >> 16);

	// read output[42]: from bit 677 to 692
	value = ((uint32_t)(input[84] & 0x07) << 29) |
			((uint32_t)input[85] << 21) |
			((uint32_t)(input[86] & 0xf8) << 13);
	output[42] = (double)(value >> 16);

	// read output[43]: from bit 693 to 708
	value = ((uint32_t)(input[86] & 0x07) << 29) |
			((uint32_t)input[87] << 21) |
			((uint32_t)(input[88] & 0xf8) << 13);
	output[43] = (double)(value >> 16);

	// read output[44]: from bit 709 to 724
	value = ((uint32_t)(input[88] & 0x07) << 29) |
			((uint32_t)input[89] << 21) |
			((uint32_t)(input[90] & 0xf8) << 13);
	output[44] = (double)(value >> 16);

	// read output[45]: from bit 725 to 740
	value = ((uint32_t)(input[90] & 0x07) << 29) |
			((uint32_t)input[91] << 21) |
			((uint32_t)(input[92] & 0xf8) << 13);
	output[45] = (double)(value >> 16);

	// read output[46]: from bit 741 to 756
	value = ((uint32_t)(input[92] & 0x07) << 29) |
			((uint32_t)input[93] << 21) |
			((uint32_t)(input[94] & 0xf8) << 13);
	output[46] = (double)(value >> 16);

	// read output[47]: from bit 757 to 772
	value = ((uint32_t)(input[94] & 0x07) << 29) |
			((uint32_t)input[95] << 21) |
			((uint32_t)(input[96] & 0xf8) << 13);
	output[47] = (double)(value >> 16);

	// read output[48]: from bit 773 to 788
	value = ((uint32_t)(input[96] & 0x07) << 29) |
			((uint32_t)input[97] << 21) |
			((uint32_t)(input[98] & 0xf8) << 13);
	output[48] = (double)(value >> 16);

	// read output[49]: from bit 789 to 804
	value = ((uint32_t)(input[98] & 0x07) << 29) |
			((uint32_t)input[99] << 21) |
			((uint32_t)(input[100] & 0xf8) << 13);
	output[49] = (double)(value >> 16);

	// read output[50]: from bit 805 to 820
	value = ((uint32_t)(input[100] & 0x07) << 29) |
			((uint32_t)input[101] << 21) |
			((uint32_t)(input[102] & 0xf8) << 13);
	output[50] = (double)(value >> 16);

	// read output[51]: from bit 821 to 836
	value = ((uint32_t)(input[102] & 0x07) << 29) |
			((uint32_t)input[103] << 21) |
			((uint32_t)(input[104] & 0xf8) << 13);
	output[51] = (double)(value >> 16);

	// read output[52]: from bit 837 to 852
	value = ((uint32_t)(input[104] & 0x07) << 29) |
			((uint32_t)input[105] << 21) |
			((uint32_t)(input[106] & 0xf8) << 13);
	output[52] = (double)(value >> 16);

	// read output[53]: from bit 853 to 868
	value = ((uint32_t)(input[106] & 0x07) << 29) |
			((uint32_t)input[107] << 21) |
			((uint32_t)(input[108] & 0xf8) << 13);
	output[53] = (double)(value >> 16);

	// read output[54]: from bit 869 to 884
	value = ((uint32_t)(input[108] & 0x07) << 29) |
			((uint32_t)input[109] << 21) |
			((uint32_t)(input[110] & 0xf8) << 13);
	output[54] = (double)(value >> 16);

	// read output[55]: from bit 885 to 900
	value = ((uint32_t)(input[110] & 0x07) << 29) |
			((uint32_t)input[111] << 21) |
			((uint32_t)(input[112] & 0xf8) << 13);
	output[55] = (double)(value >> 16);

	// read output[56]: from bit 901 to 916
	value = ((uint32_t)(input[112] & 0x07) << 29) |
			((uint32_t)input[113] << 21) |
			((uint32_t)(input[114] & 0xf8) << 13);
	output[56] = (double)(value >> 16);

	// read output[57]: from bit 917 to 932
	value = ((uint32_t)(input[114] & 0x07) << 29) |
			((uint32_t)input[115] << 21) |
			((uint32_t)(input[116] & 0xf8) << 13);
	output[57] = (double)(value >> 16);

	// read output[58]: from bit 933 to 948
	value = ((uint32_t)(input[116] & 0x07) << 29) |
			((uint32_t)input[117] << 21) |
			((uint32_t)(input[118] & 0xf8) << 13);
	output[58] = (double)(value >> 16);
}

static void unpack_59_16bit_unsigned_5off(const uint8_t * input, double * output, void *closure) {
	// Unpack 59 values into output
	// Values are 16-bit unsigned
	// Skip 5 bits, read 944 bits of data.
	// Input must be at least 119 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 5 to 20
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)(input[2] & 0xf8) << 13);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 21 to 36
	value = ((uint32_t)(input[2] & 0x07) << 29) |
			((uint32_t)input[3] << 21) |
			((uint32_t)(input[4] & 0xf8) << 13);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 37 to 52
	value = ((uint32_t)(input[4] & 0x07) << 29) |
			((uint32_t)input[5] << 21) |
			((uint32_t)(input[6] & 0xf8) << 13);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 53 to 68
	value = ((uint32_t)(input[6] & 0x07) << 29) |
			((uint32_t)input[7] << 21) |
			((uint32_t)(input[8] & 0xf8) << 13);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 69 to 84
	value = ((uint32_t)(input[8] & 0x07) << 29) |
			((uint32_t)input[9] << 21) |
			((uint32_t)(input[10] & 0xf8) << 13);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 85 to 100
	value = ((uint32_t)(input[10] & 0x07) << 29) |
			((uint32_t)input[11] << 21) |
			((uint32_t)(input[12] & 0xf8) << 13);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 101 to 116
	value = ((uint32_t)(input[12] & 0x07) << 29) |
			((uint32_t)input[13] << 21) |
			((uint32_t)(input[14] & 0xf8) << 13);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 117 to 132
	value = ((uint32_t)(input[14] & 0x07) << 29) |
			((uint32_t)input[15] << 21) |
			((uint32_t)(input[16] & 0xf8) << 13);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 133 to 148
	value = ((uint32_t)(input[16] & 0x07) << 29) |
			((uint32_t)input[17] << 21) |
			((uint32_t)(input[18] & 0xf8) << 13);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 149 to 164
	value = ((uint32_t)(input[18] & 0x07) << 29) |
			((uint32_t)input[19] << 21) |
			((uint32_t)(input[20] & 0xf8) << 13);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 165 to 180
	value = ((uint32_t)(input[20] & 0x07) << 29) |
			((uint32_t)input[21] << 21) |
			((uint32_t)(input[22] & 0xf8) << 13);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 181 to 196
	value = ((uint32_t)(input[22] & 0x07) << 29) |
			((uint32_t)input[23] << 21) |
			((uint32_t)(input[24] & 0xf8) << 13);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 197 to 212
	value = ((uint32_t)(input[24] & 0x07) << 29) |
			((uint32_t)input[25] << 21) |
			((uint32_t)(input[26] & 0xf8) << 13);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 213 to 228
	value = ((uint32_t)(input[26] & 0x07) << 29) |
			((uint32_t)input[27] << 21) |
			((uint32_t)(input[28] & 0xf8) << 13);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 229 to 244
	value = ((uint32_t)(input[28] & 0x07) << 29) |
			((uint32_t)input[29] << 21) |
			((uint32_t)(input[30] & 0xf8) << 13);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 245 to 260
	value = ((uint32_t)(input[30] & 0x07) << 29) |
			((uint32_t)input[31] << 21) |
			((uint32_t)(input[32] & 0xf8) << 13);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 261 to 276
	value = ((uint32_t)(input[32] & 0x07) << 29) |
			((uint32_t)input[33] << 21) |
			((uint32_t)(input[34] & 0xf8) << 13);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 277 to 292
	value = ((uint32_t)(input[34] & 0x07) << 29) |
			((uint32_t)input[35] << 21) |
			((uint32_t)(input[36] & 0xf8) << 13);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 293 to 308
	value = ((uint32_t)(input[36] & 0x07) << 29) |
			((uint32_t)input[37] << 21) |
			((uint32_t)(input[38] & 0xf8) << 13);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 309 to 324
	value = ((uint32_t)(input[38] & 0x07) << 29) |
			((uint32_t)input[39] << 21) |
			((uint32_t)(input[40] & 0xf8) << 13);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 325 to 340
	value = ((uint32_t)(input[40] & 0x07) << 29) |
			((uint32_t)input[41] << 21) |
			((uint32_t)(input[42] & 0xf8) << 13);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 341 to 356
	value = ((uint32_t)(input[42] & 0x07) << 29) |
			((uint32_t)input[43] << 21) |
			((uint32_t)(input[44] & 0xf8) << 13);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 357 to 372
	value = ((uint32_t)(input[44] & 0x07) << 29) |
			((uint32_t)input[45] << 21) |
			((uint32_t)(input[46] & 0xf8) << 13);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 373 to 388
	value = ((uint32_t)(input[46] & 0x07) << 29) |
			((uint32_t)input[47] << 21) |
			((uint32_t)(input[48] & 0xf8) << 13);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 389 to 404
	value = ((uint32_t)(input[48] & 0x07) << 29) |
			((uint32_t)input[49] << 21) |
			((uint32_t)(input[50] & 0xf8) << 13);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 405 to 420
	value = ((uint32_t)(input[50] & 0x07) << 29) |
			((uint32_t)input[51] << 21) |
			((uint32_t)(input[52] & 0xf8) << 13);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 421 to 436
	value = ((uint32_t)(input[52] & 0x07) << 29) |
			((uint32_t)input[53] << 21) |
			((uint32_t)(input[54] & 0xf8) << 13);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 437 to 452
	value = ((uint32_t)(input[54] & 0x07) << 29) |
			((uint32_t)input[55] << 21) |
			((uint32_t)(input[56] & 0xf8) << 13);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 453 to 468
	value = ((uint32_t)(input[56] & 0x07) << 29) |
			((uint32_t)input[57] << 21) |
			((uint32_t)(input[58] & 0xf8) << 13);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 469 to 484
	value = ((uint32_t)(input[58] & 0x07) << 29) |
			((uint32_t)input[59] << 21) |
			((uint32_t)(input[60] & 0xf8) << 13);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 485 to 500
	value = ((uint32_t)(input[60] & 0x07) << 29) |
			((uint32_t)input[61] << 21) |
			((uint32_t)(input[62] & 0xf8) << 13);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 501 to 516
	value = ((uint32_t)(input[62] & 0x07) << 29) |
			((uint32_t)input[63] << 21) |
			((uint32_t)(input[64] & 0xf8) << 13);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 517 to 532
	value = ((uint32_t)(input[64] & 0x07) << 29) |
			((uint32_t)input[65] << 21) |
			((uint32_t)(input[66] & 0xf8) << 13);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 533 to 548
	value = ((uint32_t)(input[66] & 0x07) << 29) |
			((uint32_t)input[67] << 21) |
			((uint32_t)(input[68] & 0xf8) << 13);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 549 to 564
	value = ((uint32_t)(input[68] & 0x07) << 29) |
			((uint32_t)input[69] << 21) |
			((uint32_t)(input[70] & 0xf8) << 13);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 565 to 580
	value = ((uint32_t)(input[70] & 0x07) << 29) |
			((uint32_t)input[71] << 21) |
			((uint32_t)(input[72] & 0xf8) << 13);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 581 to 596
	value = ((uint32_t)(input[72] & 0x07) << 29) |
			((uint32_t)input[73] << 21) |
			((uint32_t)(input[74] & 0xf8) << 13);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 597 to 612
	value = ((uint32_t)(input[74] & 0x07) << 29) |
			((uint32_t)input[75] << 21) |
			((uint32_t)(input[76] & 0xf8) << 13);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 613 to 628
	value = ((uint32_t)(input[76] & 0x07) << 29) |
			((uint32_t)input[77] << 21) |
			((uint32_t)(input[78] & 0xf8) << 13);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 629 to 644
	value = ((uint32_t)(input[78] & 0x07) << 29) |
			((uint32_t)input[79] << 21) |
			((uint32_t)(input[80] & 0xf8) << 13);
	output[39] = (double)(value >> 16);

	// read output[40]: from bit 645 to 660
	value = ((uint32_t)(input[80] & 0x07) << 29) |
			((uint32_t)input[81] << 21) |
			((uint32_t)(input[82] & 0xf8) << 13);
	output[40] = (double)(value >> 16);

	// read output[41]: from bit 661 to 676
	value = ((uint32_t)(input[82] & 0x07) << 29) |
			((uint32_t)input[83] << 21) |
			((uint32_t)(input[84] & 0xf8) << 13);
	output[41] = (double)(value >> 16);

	// read output[42]: from bit 677 to 692
	value = ((uint32_t)(input[84] & 0x07) << 29) |
			((uint32_t)input[85] << 21) |
			((uint32_t)(input[86] & 0xf8) << 13);
	output[42] = (double)(value >> 16);

	// read output[43]: from bit 693 to 708
	value = ((uint32_t)(input[86] & 0x07) << 29) |
			((uint32_t)input[87] << 21) |
			((uint32_t)(input[88] & 0xf8) << 13);
	output[43] = (double)(value >> 16);

	// read output[44]: from bit 709 to 724
	value = ((uint32_t)(input[88] & 0x07) << 29) |
			((uint32_t)input[89] << 21) |
			((uint32_t)(input[90] & 0xf8) << 13);
	output[44] = (double)(value >> 16);

	// read output[45]: from bit 725 to 740
	value = ((uint32_t)(input[90] & 0x07) << 29) |
			((uint32_t)input[91] << 21) |
			((uint32_t)(input[92] & 0xf8) << 13);
	output[45] = (double)(value >> 16);

	// read output[46]: from bit 741 to 756
	value = ((uint32_t)(input[92] & 0x07) << 29) |
			((uint32_t)input[93] << 21) |
			((uint32_t)(input[94] & 0xf8) << 13);
	output[46] = (double)(value >> 16);

	// read output[47]: from bit 757 to 772
	value = ((uint32_t)(input[94] & 0x07) << 29) |
			((uint32_t)input[95] << 21) |
			((uint32_t)(input[96] & 0xf8) << 13);
	output[47] = (double)(value >> 16);

	// read output[48]: from bit 773 to 788
	value = ((uint32_t)(input[96] & 0x07) << 29) |
			((uint32_t)input[97] << 21) |
			((uint32_t)(input[98] & 0xf8) << 13);
	output[48] = (double)(value >> 16);

	// read output[49]: from bit 789 to 804
	value = ((uint32_t)(input[98] & 0x07) << 29) |
			((uint32_t)input[99] << 21) |
			((uint32_t)(input[100] & 0xf8) << 13);
	output[49] = (double)(value >> 16);

	// read output[50]: from bit 805 to 820
	value = ((uint32_t)(input[100] & 0x07) << 29) |
			((uint32_t)input[101] << 21) |
			((uint32_t)(input[102] & 0xf8) << 13);
	output[50] = (double)(value >> 16);

	// read output[51]: from bit 821 to 836
	value = ((uint32_t)(input[102] & 0x07) << 29) |
			((uint32_t)input[103] << 21) |
			((uint32_t)(input[104] & 0xf8) << 13);
	output[51] = (double)(value >> 16);

	// read output[52]: from bit 837 to 852
	value = ((uint32_t)(input[104] & 0x07) << 29) |
			((uint32_t)input[105] << 21) |
			((uint32_t)(input[106] & 0xf8) << 13);
	output[52] = (double)(value >> 16);

	// read output[53]: from bit 853 to 868
	value = ((uint32_t)(input[106] & 0x07) << 29) |
			((uint32_t)input[107] << 21) |
			((uint32_t)(input[108] & 0xf8) << 13);
	output[53] = (double)(value >> 16);

	// read output[54]: from bit 869 to 884
	value = ((uint32_t)(input[108] & 0x07) << 29) |
			((uint32_t)input[109] << 21) |
			((uint32_t)(input[110] & 0xf8) << 13);
	output[54] = (double)(value >> 16);

	// read output[55]: from bit 885 to 900
	value = ((uint32_t)(input[110] & 0x07) << 29) |
			((uint32_t)input[111] << 21) |
			((uint32_t)(input[112] & 0xf8) << 13);
	output[55] = (double)(value >> 16);

	// read output[56]: from bit 901 to 916
	value = ((uint32_t)(input[112] & 0x07) << 29) |
			((uint32_t)input[113] << 21) |
			((uint32_t)(input[114] & 0xf8) << 13);
	output[56] = (double)(value >> 16);

	// read output[57]: from bit 917 to 932
	value = ((uint32_t)(input[114] & 0x07) << 29) |
			((uint32_t)input[115] << 21) |
			((uint32_t)(input[116] & 0xf8) << 13);
	output[57] = (double)(value >> 16);

	// read output[58]: from bit 933 to 948
	value = ((uint32_t)(input[116] & 0x07) << 29) |
			((uint32_t)input[117] << 21) |
			((uint32_t)(input[118] & 0xf8) << 13);
	output[58] = (double)(value >> 16);
}

static void unpack_59_16bit_signed_6off(const uint8_t * input, double * output, void *closure) {
	// Unpack 59 values into output
	// Values are 16-bit signed
	// Skip 6 bits, read 944 bits of data.
	// Input must be at least 119 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 6 to 21
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)(input[2] & 0xfc) << 14);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 22 to 37
	value = ((uint32_t)(input[2] & 0x03) << 30) |
			((uint32_t)input[3] << 22) |
			((uint32_t)(input[4] & 0xfc) << 14);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 38 to 53
	value = ((uint32_t)(input[4] & 0x03) << 30) |
			((uint32_t)input[5] << 22) |
			((uint32_t)(input[6] & 0xfc) << 14);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 54 to 69
	value = ((uint32_t)(input[6] & 0x03) << 30) |
			((uint32_t)input[7] << 22) |
			((uint32_t)(input[8] & 0xfc) << 14);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 70 to 85
	value = ((uint32_t)(input[8] & 0x03) << 30) |
			((uint32_t)input[9] << 22) |
			((uint32_t)(input[10] & 0xfc) << 14);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 86 to 101
	value = ((uint32_t)(input[10] & 0x03) << 30) |
			((uint32_t)input[11] << 22) |
			((uint32_t)(input[12] & 0xfc) << 14);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 102 to 117
	value = ((uint32_t)(input[12] & 0x03) << 30) |
			((uint32_t)input[13] << 22) |
			((uint32_t)(input[14] & 0xfc) << 14);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 118 to 133
	value = ((uint32_t)(input[14] & 0x03) << 30) |
			((uint32_t)input[15] << 22) |
			((uint32_t)(input[16] & 0xfc) << 14);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 134 to 149
	value = ((uint32_t)(input[16] & 0x03) << 30) |
			((uint32_t)input[17] << 22) |
			((uint32_t)(input[18] & 0xfc) << 14);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 150 to 165
	value = ((uint32_t)(input[18] & 0x03) << 30) |
			((uint32_t)input[19] << 22) |
			((uint32_t)(input[20] & 0xfc) << 14);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 166 to 181
	value = ((uint32_t)(input[20] & 0x03) << 30) |
			((uint32_t)input[21] << 22) |
			((uint32_t)(input[22] & 0xfc) << 14);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 182 to 197
	value = ((uint32_t)(input[22] & 0x03) << 30) |
			((uint32_t)input[23] << 22) |
			((uint32_t)(input[24] & 0xfc) << 14);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 198 to 213
	value = ((uint32_t)(input[24] & 0x03) << 30) |
			((uint32_t)input[25] << 22) |
			((uint32_t)(input[26] & 0xfc) << 14);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 214 to 229
	value = ((uint32_t)(input[26] & 0x03) << 30) |
			((uint32_t)input[27] << 22) |
			((uint32_t)(input[28] & 0xfc) << 14);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 230 to 245
	value = ((uint32_t)(input[28] & 0x03) << 30) |
			((uint32_t)input[29] << 22) |
			((uint32_t)(input[30] & 0xfc) << 14);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 246 to 261
	value = ((uint32_t)(input[30] & 0x03) << 30) |
			((uint32_t)input[31] << 22) |
			((uint32_t)(input[32] & 0xfc) << 14);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 262 to 277
	value = ((uint32_t)(input[32] & 0x03) << 30) |
			((uint32_t)input[33] << 22) |
			((uint32_t)(input[34] & 0xfc) << 14);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 278 to 293
	value = ((uint32_t)(input[34] & 0x03) << 30) |
			((uint32_t)input[35] << 22) |
			((uint32_t)(input[36] & 0xfc) << 14);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 294 to 309
	value = ((uint32_t)(input[36] & 0x03) << 30) |
			((uint32_t)input[37] << 22) |
			((uint32_t)(input[38] & 0xfc) << 14);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 310 to 325
	value = ((uint32_t)(input[38] & 0x03) << 30) |
			((uint32_t)input[39] << 22) |
			((uint32_t)(input[40] & 0xfc) << 14);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 326 to 341
	value = ((uint32_t)(input[40] & 0x03) << 30) |
			((uint32_t)input[41] << 22) |
			((uint32_t)(input[42] & 0xfc) << 14);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 342 to 357
	value = ((uint32_t)(input[42] & 0x03) << 30) |
			((uint32_t)input[43] << 22) |
			((uint32_t)(input[44] & 0xfc) << 14);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 358 to 373
	value = ((uint32_t)(input[44] & 0x03) << 30) |
			((uint32_t)input[45] << 22) |
			((uint32_t)(input[46] & 0xfc) << 14);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 374 to 389
	value = ((uint32_t)(input[46] & 0x03) << 30) |
			((uint32_t)input[47] << 22) |
			((uint32_t)(input[48] & 0xfc) << 14);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 390 to 405
	value = ((uint32_t)(input[48] & 0x03) << 30) |
			((uint32_t)input[49] << 22) |
			((uint32_t)(input[50] & 0xfc) << 14);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 406 to 421
	value = ((uint32_t)(input[50] & 0x03) << 30) |
			((uint32_t)input[51] << 22) |
			((uint32_t)(input[52] & 0xfc) << 14);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 422 to 437
	value = ((uint32_t)(input[52] & 0x03) << 30) |
			((uint32_t)input[53] << 22) |
			((uint32_t)(input[54] & 0xfc) << 14);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 438 to 453
	value = ((uint32_t)(input[54] & 0x03) << 30) |
			((uint32_t)input[55] << 22) |
			((uint32_t)(input[56] & 0xfc) << 14);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 454 to 469
	value = ((uint32_t)(input[56] & 0x03) << 30) |
			((uint32_t)input[57] << 22) |
			((uint32_t)(input[58] & 0xfc) << 14);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 470 to 485
	value = ((uint32_t)(input[58] & 0x03) << 30) |
			((uint32_t)input[59] << 22) |
			((uint32_t)(input[60] & 0xfc) << 14);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 486 to 501
	value = ((uint32_t)(input[60] & 0x03) << 30) |
			((uint32_t)input[61] << 22) |
			((uint32_t)(input[62] & 0xfc) << 14);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 502 to 517
	value = ((uint32_t)(input[62] & 0x03) << 30) |
			((uint32_t)input[63] << 22) |
			((uint32_t)(input[64] & 0xfc) << 14);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 518 to 533
	value = ((uint32_t)(input[64] & 0x03) << 30) |
			((uint32_t)input[65] << 22) |
			((uint32_t)(input[66] & 0xfc) << 14);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 534 to 549
	value = ((uint32_t)(input[66] & 0x03) << 30) |
			((uint32_t)input[67] << 22) |
			((uint32_t)(input[68] & 0xfc) << 14);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 550 to 565
	value = ((uint32_t)(input[68] & 0x03) << 30) |
			((uint32_t)input[69] << 22) |
			((uint32_t)(input[70] & 0xfc) << 14);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 566 to 581
	value = ((uint32_t)(input[70] & 0x03) << 30) |
			((uint32_t)input[71] << 22) |
			((uint32_t)(input[72] & 0xfc) << 14);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 582 to 597
	value = ((uint32_t)(input[72] & 0x03) << 30) |
			((uint32_t)input[73] << 22) |
			((uint32_t)(input[74] & 0xfc) << 14);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 598 to 613
	value = ((uint32_t)(input[74] & 0x03) << 30) |
			((uint32_t)input[75] << 22) |
			((uint32_t)(input[76] & 0xfc) << 14);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 614 to 629
	value = ((uint32_t)(input[76] & 0x03) << 30) |
			((uint32_t)input[77] << 22) |
			((uint32_t)(input[78] & 0xfc) << 14);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 630 to 645
	value = ((uint32_t)(input[78] & 0x03) << 30) |
			((uint32_t)input[79] << 22) |
			((uint32_t)(input[80] & 0xfc) << 14);
	output[39] = (double)(value >> 16);

	// read output[40]: from bit 646 to 661
	value = ((uint32_t)(input[80] & 0x03) << 30) |
			((uint32_t)input[81] << 22) |
			((uint32_t)(input[82] & 0xfc) << 14);
	output[40] = (double)(value >> 16);

	// read output[41]: from bit 662 to 677
	value = ((uint32_t)(input[82] & 0x03) << 30) |
			((uint32_t)input[83] << 22) |
			((uint32_t)(input[84] & 0xfc) << 14);
	output[41] = (double)(value >> 16);

	// read output[42]: from bit 678 to 693
	value = ((uint32_t)(input[84] & 0x03) << 30) |
			((uint32_t)input[85] << 22) |
			((uint32_t)(input[86] & 0xfc) << 14);
	output[42] = (double)(value >> 16);

	// read output[43]: from bit 694 to 709
	value = ((uint32_t)(input[86] & 0x03) << 30) |
			((uint32_t)input[87] << 22) |
			((uint32_t)(input[88] & 0xfc) << 14);
	output[43] = (double)(value >> 16);

	// read output[44]: from bit 710 to 725
	value = ((uint32_t)(input[88] & 0x03) << 30) |
			((uint32_t)input[89] << 22) |
			((uint32_t)(input[90] & 0xfc) << 14);
	output[44] = (double)(value >> 16);

	// read output[45]: from bit 726 to 741
	value = ((uint32_t)(input[90] & 0x03) << 30) |
			((uint32_t)input[91] << 22) |
			((uint32_t)(input[92] & 0xfc) << 14);
	output[45] = (double)(value >> 16);

	// read output[46]: from bit 742 to 757
	value = ((uint32_t)(input[92] & 0x03) << 30) |
			((uint32_t)input[93] << 22) |
			((uint32_t)(input[94] & 0xfc) << 14);
	output[46] = (double)(value >> 16);

	// read output[47]: from bit 758 to 773
	value = ((uint32_t)(input[94] & 0x03) << 30) |
			((uint32_t)input[95] << 22) |
			((uint32_t)(input[96] & 0xfc) << 14);
	output[47] = (double)(value >> 16);

	// read output[48]: from bit 774 to 789
	value = ((uint32_t)(input[96] & 0x03) << 30) |
			((uint32_t)input[97] << 22) |
			((uint32_t)(input[98] & 0xfc) << 14);
	output[48] = (double)(value >> 16);

	// read output[49]: from bit 790 to 805
	value = ((uint32_t)(input[98] & 0x03) << 30) |
			((uint32_t)input[99] << 22) |
			((uint32_t)(input[100] & 0xfc) << 14);
	output[49] = (double)(value >> 16);

	// read output[50]: from bit 806 to 821
	value = ((uint32_t)(input[100] & 0x03) << 30) |
			((uint32_t)input[101] << 22) |
			((uint32_t)(input[102] & 0xfc) << 14);
	output[50] = (double)(value >> 16);

	// read output[51]: from bit 822 to 837
	value = ((uint32_t)(input[102] & 0x03) << 30) |
			((uint32_t)input[103] << 22) |
			((uint32_t)(input[104] & 0xfc) << 14);
	output[51] = (double)(value >> 16);

	// read output[52]: from bit 838 to 853
	value = ((uint32_t)(input[104] & 0x03) << 30) |
			((uint32_t)input[105] << 22) |
			((uint32_t)(input[106] & 0xfc) << 14);
	output[52] = (double)(value >> 16);

	// read output[53]: from bit 854 to 869
	value = ((uint32_t)(input[106] & 0x03) << 30) |
			((uint32_t)input[107] << 22) |
			((uint32_t)(input[108] & 0xfc) << 14);
	output[53] = (double)(value >> 16);

	// read output[54]: from bit 870 to 885
	value = ((uint32_t)(input[108] & 0x03) << 30) |
			((uint32_t)input[109] << 22) |
			((uint32_t)(input[110] & 0xfc) << 14);
	output[54] = (double)(value >> 16);

	// read output[55]: from bit 886 to 901
	value = ((uint32_t)(input[110] & 0x03) << 30) |
			((uint32_t)input[111] << 22) |
			((uint32_t)(input[112] & 0xfc) << 14);
	output[55] = (double)(value >> 16);

	// read output[56]: from bit 902 to 917
	value = ((uint32_t)(input[112] & 0x03) << 30) |
			((uint32_t)input[113] << 22) |
			((uint32_t)(input[114] & 0xfc) << 14);
	output[56] = (double)(value >> 16);

	// read output[57]: from bit 918 to 933
	value = ((uint32_t)(input[114] & 0x03) << 30) |
			((uint32_t)input[115] << 22) |
			((uint32_t)(input[116] & 0xfc) << 14);
	output[57] = (double)(value >> 16);

	// read output[58]: from bit 934 to 949
	value = ((uint32_t)(input[116] & 0x03) << 30) |
			((uint32_t)input[117] << 22) |
			((uint32_t)(input[118] & 0xfc) << 14);
	output[58] = (double)(value >> 16);
}

static void unpack_59_16bit_unsigned_6off(const uint8_t * input, double * output, void *closure) {
	// Unpack 59 values into output
	// Values are 16-bit unsigned
	// Skip 6 bits, read 944 bits of data.
	// Input must be at least 119 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 6 to 21
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)(input[2] & 0xfc) << 14);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 22 to 37
	value = ((uint32_t)(input[2] & 0x03) << 30) |
			((uint32_t)input[3] << 22) |
			((uint32_t)(input[4] & 0xfc) << 14);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 38 to 53
	value = ((uint32_t)(input[4] & 0x03) << 30) |
			((uint32_t)input[5] << 22) |
			((uint32_t)(input[6] & 0xfc) << 14);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 54 to 69
	value = ((uint32_t)(input[6] & 0x03) << 30) |
			((uint32_t)input[7] << 22) |
			((uint32_t)(input[8] & 0xfc) << 14);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 70 to 85
	value = ((uint32_t)(input[8] & 0x03) << 30) |
			((uint32_t)input[9] << 22) |
			((uint32_t)(input[10] & 0xfc) << 14);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 86 to 101
	value = ((uint32_t)(input[10] & 0x03) << 30) |
			((uint32_t)input[11] << 22) |
			((uint32_t)(input[12] & 0xfc) << 14);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 102 to 117
	value = ((uint32_t)(input[12] & 0x03) << 30) |
			((uint32_t)input[13] << 22) |
			((uint32_t)(input[14] & 0xfc) << 14);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 118 to 133
	value = ((uint32_t)(input[14] & 0x03) << 30) |
			((uint32_t)input[15] << 22) |
			((uint32_t)(input[16] & 0xfc) << 14);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 134 to 149
	value = ((uint32_t)(input[16] & 0x03) << 30) |
			((uint32_t)input[17] << 22) |
			((uint32_t)(input[18] & 0xfc) << 14);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 150 to 165
	value = ((uint32_t)(input[18] & 0x03) << 30) |
			((uint32_t)input[19] << 22) |
			((uint32_t)(input[20] & 0xfc) << 14);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 166 to 181
	value = ((uint32_t)(input[20] & 0x03) << 30) |
			((uint32_t)input[21] << 22) |
			((uint32_t)(input[22] & 0xfc) << 14);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 182 to 197
	value = ((uint32_t)(input[22] & 0x03) << 30) |
			((uint32_t)input[23] << 22) |
			((uint32_t)(input[24] & 0xfc) << 14);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 198 to 213
	value = ((uint32_t)(input[24] & 0x03) << 30) |
			((uint32_t)input[25] << 22) |
			((uint32_t)(input[26] & 0xfc) << 14);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 214 to 229
	value = ((uint32_t)(input[26] & 0x03) << 30) |
			((uint32_t)input[27] << 22) |
			((uint32_t)(input[28] & 0xfc) << 14);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 230 to 245
	value = ((uint32_t)(input[28] & 0x03) << 30) |
			((uint32_t)input[29] << 22) |
			((uint32_t)(input[30] & 0xfc) << 14);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 246 to 261
	value = ((uint32_t)(input[30] & 0x03) << 30) |
			((uint32_t)input[31] << 22) |
			((uint32_t)(input[32] & 0xfc) << 14);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 262 to 277
	value = ((uint32_t)(input[32] & 0x03) << 30) |
			((uint32_t)input[33] << 22) |
			((uint32_t)(input[34] & 0xfc) << 14);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 278 to 293
	value = ((uint32_t)(input[34] & 0x03) << 30) |
			((uint32_t)input[35] << 22) |
			((uint32_t)(input[36] & 0xfc) << 14);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 294 to 309
	value = ((uint32_t)(input[36] & 0x03) << 30) |
			((uint32_t)input[37] << 22) |
			((uint32_t)(input[38] & 0xfc) << 14);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 310 to 325
	value = ((uint32_t)(input[38] & 0x03) << 30) |
			((uint32_t)input[39] << 22) |
			((uint32_t)(input[40] & 0xfc) << 14);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 326 to 341
	value = ((uint32_t)(input[40] & 0x03) << 30) |
			((uint32_t)input[41] << 22) |
			((uint32_t)(input[42] & 0xfc) << 14);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 342 to 357
	value = ((uint32_t)(input[42] & 0x03) << 30) |
			((uint32_t)input[43] << 22) |
			((uint32_t)(input[44] & 0xfc) << 14);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 358 to 373
	value = ((uint32_t)(input[44] & 0x03) << 30) |
			((uint32_t)input[45] << 22) |
			((uint32_t)(input[46] & 0xfc) << 14);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 374 to 389
	value = ((uint32_t)(input[46] & 0x03) << 30) |
			((uint32_t)input[47] << 22) |
			((uint32_t)(input[48] & 0xfc) << 14);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 390 to 405
	value = ((uint32_t)(input[48] & 0x03) << 30) |
			((uint32_t)input[49] << 22) |
			((uint32_t)(input[50] & 0xfc) << 14);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 406 to 421
	value = ((uint32_t)(input[50] & 0x03) << 30) |
			((uint32_t)input[51] << 22) |
			((uint32_t)(input[52] & 0xfc) << 14);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 422 to 437
	value = ((uint32_t)(input[52] & 0x03) << 30) |
			((uint32_t)input[53] << 22) |
			((uint32_t)(input[54] & 0xfc) << 14);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 438 to 453
	value = ((uint32_t)(input[54] & 0x03) << 30) |
			((uint32_t)input[55] << 22) |
			((uint32_t)(input[56] & 0xfc) << 14);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 454 to 469
	value = ((uint32_t)(input[56] & 0x03) << 30) |
			((uint32_t)input[57] << 22) |
			((uint32_t)(input[58] & 0xfc) << 14);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 470 to 485
	value = ((uint32_t)(input[58] & 0x03) << 30) |
			((uint32_t)input[59] << 22) |
			((uint32_t)(input[60] & 0xfc) << 14);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 486 to 501
	value = ((uint32_t)(input[60] & 0x03) << 30) |
			((uint32_t)input[61] << 22) |
			((uint32_t)(input[62] & 0xfc) << 14);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 502 to 517
	value = ((uint32_t)(input[62] & 0x03) << 30) |
			((uint32_t)input[63] << 22) |
			((uint32_t)(input[64] & 0xfc) << 14);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 518 to 533
	value = ((uint32_t)(input[64] & 0x03) << 30) |
			((uint32_t)input[65] << 22) |
			((uint32_t)(input[66] & 0xfc) << 14);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 534 to 549
	value = ((uint32_t)(input[66] & 0x03) << 30) |
			((uint32_t)input[67] << 22) |
			((uint32_t)(input[68] & 0xfc) << 14);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 550 to 565
	value = ((uint32_t)(input[68] & 0x03) << 30) |
			((uint32_t)input[69] << 22) |
			((uint32_t)(input[70] & 0xfc) << 14);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 566 to 581
	value = ((uint32_t)(input[70] & 0x03) << 30) |
			((uint32_t)input[71] << 22) |
			((uint32_t)(input[72] & 0xfc) << 14);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 582 to 597
	value = ((uint32_t)(input[72] & 0x03) << 30) |
			((uint32_t)input[73] << 22) |
			((uint32_t)(input[74] & 0xfc) << 14);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 598 to 613
	value = ((uint32_t)(input[74] & 0x03) << 30) |
			((uint32_t)input[75] << 22) |
			((uint32_t)(input[76] & 0xfc) << 14);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 614 to 629
	value = ((uint32_t)(input[76] & 0x03) << 30) |
			((uint32_t)input[77] << 22) |
			((uint32_t)(input[78] & 0xfc) << 14);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 630 to 645
	value = ((uint32_t)(input[78] & 0x03) << 30) |
			((uint32_t)input[79] << 22) |
			((uint32_t)(input[80] & 0xfc) << 14);
	output[39] = (double)(value >> 16);

	// read output[40]: from bit 646 to 661
	value = ((uint32_t)(input[80] & 0x03) << 30) |
			((uint32_t)input[81] << 22) |
			((uint32_t)(input[82] & 0xfc) << 14);
	output[40] = (double)(value >> 16);

	// read output[41]: from bit 662 to 677
	value = ((uint32_t)(input[82] & 0x03) << 30) |
			((uint32_t)input[83] << 22) |
			((uint32_t)(input[84] & 0xfc) << 14);
	output[41] = (double)(value >> 16);

	// read output[42]: from bit 678 to 693
	value = ((uint32_t)(input[84] & 0x03) << 30) |
			((uint32_t)input[85] << 22) |
			((uint32_t)(input[86] & 0xfc) << 14);
	output[42] = (double)(value >> 16);

	// read output[43]: from bit 694 to 709
	value = ((uint32_t)(input[86] & 0x03) << 30) |
			((uint32_t)input[87] << 22) |
			((uint32_t)(input[88] & 0xfc) << 14);
	output[43] = (double)(value >> 16);

	// read output[44]: from bit 710 to 725
	value = ((uint32_t)(input[88] & 0x03) << 30) |
			((uint32_t)input[89] << 22) |
			((uint32_t)(input[90] & 0xfc) << 14);
	output[44] = (double)(value >> 16);

	// read output[45]: from bit 726 to 741
	value = ((uint32_t)(input[90] & 0x03) << 30) |
			((uint32_t)input[91] << 22) |
			((uint32_t)(input[92] & 0xfc) << 14);
	output[45] = (double)(value >> 16);

	// read output[46]: from bit 742 to 757
	value = ((uint32_t)(input[92] & 0x03) << 30) |
			((uint32_t)input[93] << 22) |
			((uint32_t)(input[94] & 0xfc) << 14);
	output[46] = (double)(value >> 16);

	// read output[47]: from bit 758 to 773
	value = ((uint32_t)(input[94] & 0x03) << 30) |
			((uint32_t)input[95] << 22) |
			((uint32_t)(input[96] & 0xfc) << 14);
	output[47] = (double)(value >> 16);

	// read output[48]: from bit 774 to 789
	value = ((uint32_t)(input[96] & 0x03) << 30) |
			((uint32_t)input[97] << 22) |
			((uint32_t)(input[98] & 0xfc) << 14);
	output[48] = (double)(value >> 16);

	// read output[49]: from bit 790 to 805
	value = ((uint32_t)(input[98] & 0x03) << 30) |
			((uint32_t)input[99] << 22) |
			((uint32_t)(input[100] & 0xfc) << 14);
	output[49] = (double)(value >> 16);

	// read output[50]: from bit 806 to 821
	value = ((uint32_t)(input[100] & 0x03) << 30) |
			((uint32_t)input[101] << 22) |
			((uint32_t)(input[102] & 0xfc) << 14);
	output[50] = (double)(value >> 16);

	// read output[51]: from bit 822 to 837
	value = ((uint32_t)(input[102] & 0x03) << 30) |
			((uint32_t)input[103] << 22) |
			((uint32_t)(input[104] & 0xfc) << 14);
	output[51] = (double)(value >> 16);

	// read output[52]: from bit 838 to 853
	value = ((uint32_t)(input[104] & 0x03) << 30) |
			((uint32_t)input[105] << 22) |
			((uint32_t)(input[106] & 0xfc) << 14);
	output[52] = (double)(value >> 16);

	// read output[53]: from bit 854 to 869
	value = ((uint32_t)(input[106] & 0x03) << 30) |
			((uint32_t)input[107] << 22) |
			((uint32_t)(input[108] & 0xfc) << 14);
	output[53] = (double)(value >> 16);

	// read output[54]: from bit 870 to 885
	value = ((uint32_t)(input[108] & 0x03) << 30) |
			((uint32_t)input[109] << 22) |
			((uint32_t)(input[110] & 0xfc) << 14);
	output[54] = (double)(value >> 16);

	// read output[55]: from bit 886 to 901
	value = ((uint32_t)(input[110] & 0x03) << 30) |
			((uint32_t)input[111] << 22) |
			((uint32_t)(input[112] & 0xfc) << 14);
	output[55] = (double)(value >> 16);

	// read output[56]: from bit 902 to 917
	value = ((uint32_t)(input[112] & 0x03) << 30) |
			((uint32_t)input[113] << 22) |
			((uint32_t)(input[114] & 0xfc) << 14);
	output[56] = (double)(value >> 16);

	// read output[57]: from bit 918 to 933
	value = ((uint32_t)(input[114] & 0x03) << 30) |
			((uint32_t)input[115] << 22) |
			((uint32_t)(input[116] & 0xfc) << 14);
	output[57] = (double)(value >> 16);

	// read output[58]: from bit 934 to 949
	value = ((uint32_t)(input[116] & 0x03) << 30) |
			((uint32_t)input[117] << 22) |
			((uint32_t)(input[118] & 0xfc) << 14);
	output[58] = (double)(value >> 16);
}

static void unpack_59_16bit_signed_7off(const uint8_t * input, double * output, void *closure) {
	// Unpack 59 values into output
	// Values are 16-bit signed
	// Skip 7 bits, read 944 bits of data.
	// Input must be at least 119 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 7 to 22
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)(input[2] & 0xfe) << 15);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 23 to 38
	value = ((uint32_t)(input[2] & 0x01) << 31) |
			((uint32_t)input[3] << 23) |
			((uint32_t)(input[4] & 0xfe) << 15);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 39 to 54
	value = ((uint32_t)(input[4] & 0x01) << 31) |
			((uint32_t)input[5] << 23) |
			((uint32_t)(input[6] & 0xfe) << 15);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 55 to 70
	value = ((uint32_t)(input[6] & 0x01) << 31) |
			((uint32_t)input[7] << 23) |
			((uint32_t)(input[8] & 0xfe) << 15);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 71 to 86
	value = ((uint32_t)(input[8] & 0x01) << 31) |
			((uint32_t)input[9] << 23) |
			((uint32_t)(input[10] & 0xfe) << 15);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 87 to 102
	value = ((uint32_t)(input[10] & 0x01) << 31) |
			((uint32_t)input[11] << 23) |
			((uint32_t)(input[12] & 0xfe) << 15);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 103 to 118
	value = ((uint32_t)(input[12] & 0x01) << 31) |
			((uint32_t)input[13] << 23) |
			((uint32_t)(input[14] & 0xfe) << 15);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 119 to 134
	value = ((uint32_t)(input[14] & 0x01) << 31) |
			((uint32_t)input[15] << 23) |
			((uint32_t)(input[16] & 0xfe) << 15);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 135 to 150
	value = ((uint32_t)(input[16] & 0x01) << 31) |
			((uint32_t)input[17] << 23) |
			((uint32_t)(input[18] & 0xfe) << 15);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 151 to 166
	value = ((uint32_t)(input[18] & 0x01) << 31) |
			((uint32_t)input[19] << 23) |
			((uint32_t)(input[20] & 0xfe) << 15);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 167 to 182
	value = ((uint32_t)(input[20] & 0x01) << 31) |
			((uint32_t)input[21] << 23) |
			((uint32_t)(input[22] & 0xfe) << 15);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 183 to 198
	value = ((uint32_t)(input[22] & 0x01) << 31) |
			((uint32_t)input[23] << 23) |
			((uint32_t)(input[24] & 0xfe) << 15);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 199 to 214
	value = ((uint32_t)(input[24] & 0x01) << 31) |
			((uint32_t)input[25] << 23) |
			((uint32_t)(input[26] & 0xfe) << 15);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 215 to 230
	value = ((uint32_t)(input[26] & 0x01) << 31) |
			((uint32_t)input[27] << 23) |
			((uint32_t)(input[28] & 0xfe) << 15);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 231 to 246
	value = ((uint32_t)(input[28] & 0x01) << 31) |
			((uint32_t)input[29] << 23) |
			((uint32_t)(input[30] & 0xfe) << 15);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 247 to 262
	value = ((uint32_t)(input[30] & 0x01) << 31) |
			((uint32_t)input[31] << 23) |
			((uint32_t)(input[32] & 0xfe) << 15);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 263 to 278
	value = ((uint32_t)(input[32] & 0x01) << 31) |
			((uint32_t)input[33] << 23) |
			((uint32_t)(input[34] & 0xfe) << 15);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 279 to 294
	value = ((uint32_t)(input[34] & 0x01) << 31) |
			((uint32_t)input[35] << 23) |
			((uint32_t)(input[36] & 0xfe) << 15);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 295 to 310
	value = ((uint32_t)(input[36] & 0x01) << 31) |
			((uint32_t)input[37] << 23) |
			((uint32_t)(input[38] & 0xfe) << 15);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 311 to 326
	value = ((uint32_t)(input[38] & 0x01) << 31) |
			((uint32_t)input[39] << 23) |
			((uint32_t)(input[40] & 0xfe) << 15);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 327 to 342
	value = ((uint32_t)(input[40] & 0x01) << 31) |
			((uint32_t)input[41] << 23) |
			((uint32_t)(input[42] & 0xfe) << 15);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 343 to 358
	value = ((uint32_t)(input[42] & 0x01) << 31) |
			((uint32_t)input[43] << 23) |
			((uint32_t)(input[44] & 0xfe) << 15);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 359 to 374
	value = ((uint32_t)(input[44] & 0x01) << 31) |
			((uint32_t)input[45] << 23) |
			((uint32_t)(input[46] & 0xfe) << 15);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 375 to 390
	value = ((uint32_t)(input[46] & 0x01) << 31) |
			((uint32_t)input[47] << 23) |
			((uint32_t)(input[48] & 0xfe) << 15);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 391 to 406
	value = ((uint32_t)(input[48] & 0x01) << 31) |
			((uint32_t)input[49] << 23) |
			((uint32_t)(input[50] & 0xfe) << 15);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 407 to 422
	value = ((uint32_t)(input[50] & 0x01) << 31) |
			((uint32_t)input[51] << 23) |
			((uint32_t)(input[52] & 0xfe) << 15);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 423 to 438
	value = ((uint32_t)(input[52] & 0x01) << 31) |
			((uint32_t)input[53] << 23) |
			((uint32_t)(input[54] & 0xfe) << 15);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 439 to 454
	value = ((uint32_t)(input[54] & 0x01) << 31) |
			((uint32_t)input[55] << 23) |
			((uint32_t)(input[56] & 0xfe) << 15);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 455 to 470
	value = ((uint32_t)(input[56] & 0x01) << 31) |
			((uint32_t)input[57] << 23) |
			((uint32_t)(input[58] & 0xfe) << 15);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 471 to 486
	value = ((uint32_t)(input[58] & 0x01) << 31) |
			((uint32_t)input[59] << 23) |
			((uint32_t)(input[60] & 0xfe) << 15);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 487 to 502
	value = ((uint32_t)(input[60] & 0x01) << 31) |
			((uint32_t)input[61] << 23) |
			((uint32_t)(input[62] & 0xfe) << 15);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 503 to 518
	value = ((uint32_t)(input[62] & 0x01) << 31) |
			((uint32_t)input[63] << 23) |
			((uint32_t)(input[64] & 0xfe) << 15);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 519 to 534
	value = ((uint32_t)(input[64] & 0x01) << 31) |
			((uint32_t)input[65] << 23) |
			((uint32_t)(input[66] & 0xfe) << 15);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 535 to 550
	value = ((uint32_t)(input[66] & 0x01) << 31) |
			((uint32_t)input[67] << 23) |
			((uint32_t)(input[68] & 0xfe) << 15);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 551 to 566
	value = ((uint32_t)(input[68] & 0x01) << 31) |
			((uint32_t)input[69] << 23) |
			((uint32_t)(input[70] & 0xfe) << 15);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 567 to 582
	value = ((uint32_t)(input[70] & 0x01) << 31) |
			((uint32_t)input[71] << 23) |
			((uint32_t)(input[72] & 0xfe) << 15);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 583 to 598
	value = ((uint32_t)(input[72] & 0x01) << 31) |
			((uint32_t)input[73] << 23) |
			((uint32_t)(input[74] & 0xfe) << 15);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 599 to 614
	value = ((uint32_t)(input[74] & 0x01) << 31) |
			((uint32_t)input[75] << 23) |
			((uint32_t)(input[76] & 0xfe) << 15);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 615 to 630
	value = ((uint32_t)(input[76] & 0x01) << 31) |
			((uint32_t)input[77] << 23) |
			((uint32_t)(input[78] & 0xfe) << 15);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 631 to 646
	value = ((uint32_t)(input[78] & 0x01) << 31) |
			((uint32_t)input[79] << 23) |
			((uint32_t)(input[80] & 0xfe) << 15);
	output[39] = (double)(value >> 16);

	// read output[40]: from bit 647 to 662
	value = ((uint32_t)(input[80] & 0x01) << 31) |
			((uint32_t)input[81] << 23) |
			((uint32_t)(input[82] & 0xfe) << 15);
	output[40] = (double)(value >> 16);

	// read output[41]: from bit 663 to 678
	value = ((uint32_t)(input[82] & 0x01) << 31) |
			((uint32_t)input[83] << 23) |
			((uint32_t)(input[84] & 0xfe) << 15);
	output[41] = (double)(value >> 16);

	// read output[42]: from bit 679 to 694
	value = ((uint32_t)(input[84] & 0x01) << 31) |
			((uint32_t)input[85] << 23) |
			((uint32_t)(input[86] & 0xfe) << 15);
	output[42] = (double)(value >> 16);

	// read output[43]: from bit 695 to 710
	value = ((uint32_t)(input[86] & 0x01) << 31) |
			((uint32_t)input[87] << 23) |
			((uint32_t)(input[88] & 0xfe) << 15);
	output[43] = (double)(value >> 16);

	// read output[44]: from bit 711 to 726
	value = ((uint32_t)(input[88] & 0x01) << 31) |
			((uint32_t)input[89] << 23) |
			((uint32_t)(input[90] & 0xfe) << 15);
	output[44] = (double)(value >> 16);

	// read output[45]: from bit 727 to 742
	value = ((uint32_t)(input[90] & 0x01) << 31) |
			((uint32_t)input[91] << 23) |
			((uint32_t)(input[92] & 0xfe) << 15);
	output[45] = (double)(value >> 16);

	// read output[46]: from bit 743 to 758
	value = ((uint32_t)(input[92] & 0x01) << 31) |
			((uint32_t)input[93] << 23) |
			((uint32_t)(input[94] & 0xfe) << 15);
	output[46] = (double)(value >> 16);

	// read output[47]: from bit 759 to 774
	value = ((uint32_t)(input[94] & 0x01) << 31) |
			((uint32_t)input[95] << 23) |
			((uint32_t)(input[96] & 0xfe) << 15);
	output[47] = (double)(value >> 16);

	// read output[48]: from bit 775 to 790
	value = ((uint32_t)(input[96] & 0x01) << 31) |
			((uint32_t)input[97] << 23) |
			((uint32_t)(input[98] & 0xfe) << 15);
	output[48] = (double)(value >> 16);

	// read output[49]: from bit 791 to 806
	value = ((uint32_t)(input[98] & 0x01) << 31) |
			((uint32_t)input[99] << 23) |
			((uint32_t)(input[100] & 0xfe) << 15);
	output[49] = (double)(value >> 16);

	// read output[50]: from bit 807 to 822
	value = ((uint32_t)(input[100] & 0x01) << 31) |
			((uint32_t)input[101] << 23) |
			((uint32_t)(input[102] & 0xfe) << 15);
	output[50] = (double)(value >> 16);

	// read output[51]: from bit 823 to 838
	value = ((uint32_t)(input[102] & 0x01) << 31) |
			((uint32_t)input[103] << 23) |
			((uint32_t)(input[104] & 0xfe) << 15);
	output[51] = (double)(value >> 16);

	// read output[52]: from bit 839 to 854
	value = ((uint32_t)(input[104] & 0x01) << 31) |
			((uint32_t)input[105] << 23) |
			((uint32_t)(input[106] & 0xfe) << 15);
	output[52] = (double)(value >> 16);

	// read output[53]: from bit 855 to 870
	value = ((uint32_t)(input[106] & 0x01) << 31) |
			((uint32_t)input[107] << 23) |
			((uint32_t)(input[108] & 0xfe) << 15);
	output[53] = (double)(value >> 16);

	// read output[54]: from bit 871 to 886
	value = ((uint32_t)(input[108] & 0x01) << 31) |
			((uint32_t)input[109] << 23) |
			((uint32_t)(input[110] & 0xfe) << 15);
	output[54] = (double)(value >> 16);

	// read output[55]: from bit 887 to 902
	value = ((uint32_t)(input[110] & 0x01) << 31) |
			((uint32_t)input[111] << 23) |
			((uint32_t)(input[112] & 0xfe) << 15);
	output[55] = (double)(value >> 16);

	// read output[56]: from bit 903 to 918
	value = ((uint32_t)(input[112] & 0x01) << 31) |
			((uint32_t)input[113] << 23) |
			((uint32_t)(input[114] & 0xfe) << 15);
	output[56] = (double)(value >> 16);

	// read output[57]: from bit 919 to 934
	value = ((uint32_t)(input[114] & 0x01) << 31) |
			((uint32_t)input[115] << 23) |
			((uint32_t)(input[116] & 0xfe) << 15);
	output[57] = (double)(value >> 16);

	// read output[58]: from bit 935 to 950
	value = ((uint32_t)(input[116] & 0x01) << 31) |
			((uint32_t)input[117] << 23) |
			((uint32_t)(input[118] & 0xfe) << 15);
	output[58] = (double)(value >> 16);
}

static void unpack_59_16bit_unsigned_7off(const uint8_t * input, double * output, void *closure) {
	// Unpack 59 values into output
	// Values are 16-bit unsigned
	// Skip 7 bits, read 944 bits of data.
	// Input must be at least 119 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 7 to 22
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)(input[2] & 0xfe) << 15);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 23 to 38
	value = ((uint32_t)(input[2] & 0x01) << 31) |
			((uint32_t)input[3] << 23) |
			((uint32_t)(input[4] & 0xfe) << 15);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 39 to 54
	value = ((uint32_t)(input[4] & 0x01) << 31) |
			((uint32_t)input[5] << 23) |
			((uint32_t)(input[6] & 0xfe) << 15);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 55 to 70
	value = ((uint32_t)(input[6] & 0x01) << 31) |
			((uint32_t)input[7] << 23) |
			((uint32_t)(input[8] & 0xfe) << 15);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 71 to 86
	value = ((uint32_t)(input[8] & 0x01) << 31) |
			((uint32_t)input[9] << 23) |
			((uint32_t)(input[10] & 0xfe) << 15);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 87 to 102
	value = ((uint32_t)(input[10] & 0x01) << 31) |
			((uint32_t)input[11] << 23) |
			((uint32_t)(input[12] & 0xfe) << 15);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 103 to 118
	value = ((uint32_t)(input[12] & 0x01) << 31) |
			((uint32_t)input[13] << 23) |
			((uint32_t)(input[14] & 0xfe) << 15);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 119 to 134
	value = ((uint32_t)(input[14] & 0x01) << 31) |
			((uint32_t)input[15] << 23) |
			((uint32_t)(input[16] & 0xfe) << 15);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 135 to 150
	value = ((uint32_t)(input[16] & 0x01) << 31) |
			((uint32_t)input[17] << 23) |
			((uint32_t)(input[18] & 0xfe) << 15);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 151 to 166
	value = ((uint32_t)(input[18] & 0x01) << 31) |
			((uint32_t)input[19] << 23) |
			((uint32_t)(input[20] & 0xfe) << 15);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 167 to 182
	value = ((uint32_t)(input[20] & 0x01) << 31) |
			((uint32_t)input[21] << 23) |
			((uint32_t)(input[22] & 0xfe) << 15);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 183 to 198
	value = ((uint32_t)(input[22] & 0x01) << 31) |
			((uint32_t)input[23] << 23) |
			((uint32_t)(input[24] & 0xfe) << 15);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 199 to 214
	value = ((uint32_t)(input[24] & 0x01) << 31) |
			((uint32_t)input[25] << 23) |
			((uint32_t)(input[26] & 0xfe) << 15);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 215 to 230
	value = ((uint32_t)(input[26] & 0x01) << 31) |
			((uint32_t)input[27] << 23) |
			((uint32_t)(input[28] & 0xfe) << 15);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 231 to 246
	value = ((uint32_t)(input[28] & 0x01) << 31) |
			((uint32_t)input[29] << 23) |
			((uint32_t)(input[30] & 0xfe) << 15);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 247 to 262
	value = ((uint32_t)(input[30] & 0x01) << 31) |
			((uint32_t)input[31] << 23) |
			((uint32_t)(input[32] & 0xfe) << 15);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 263 to 278
	value = ((uint32_t)(input[32] & 0x01) << 31) |
			((uint32_t)input[33] << 23) |
			((uint32_t)(input[34] & 0xfe) << 15);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 279 to 294
	value = ((uint32_t)(input[34] & 0x01) << 31) |
			((uint32_t)input[35] << 23) |
			((uint32_t)(input[36] & 0xfe) << 15);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 295 to 310
	value = ((uint32_t)(input[36] & 0x01) << 31) |
			((uint32_t)input[37] << 23) |
			((uint32_t)(input[38] & 0xfe) << 15);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 311 to 326
	value = ((uint32_t)(input[38] & 0x01) << 31) |
			((uint32_t)input[39] << 23) |
			((uint32_t)(input[40] & 0xfe) << 15);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 327 to 342
	value = ((uint32_t)(input[40] & 0x01) << 31) |
			((uint32_t)input[41] << 23) |
			((uint32_t)(input[42] & 0xfe) << 15);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 343 to 358
	value = ((uint32_t)(input[42] & 0x01) << 31) |
			((uint32_t)input[43] << 23) |
			((uint32_t)(input[44] & 0xfe) << 15);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 359 to 374
	value = ((uint32_t)(input[44] & 0x01) << 31) |
			((uint32_t)input[45] << 23) |
			((uint32_t)(input[46] & 0xfe) << 15);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 375 to 390
	value = ((uint32_t)(input[46] & 0x01) << 31) |
			((uint32_t)input[47] << 23) |
			((uint32_t)(input[48] & 0xfe) << 15);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 391 to 406
	value = ((uint32_t)(input[48] & 0x01) << 31) |
			((uint32_t)input[49] << 23) |
			((uint32_t)(input[50] & 0xfe) << 15);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 407 to 422
	value = ((uint32_t)(input[50] & 0x01) << 31) |
			((uint32_t)input[51] << 23) |
			((uint32_t)(input[52] & 0xfe) << 15);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 423 to 438
	value = ((uint32_t)(input[52] & 0x01) << 31) |
			((uint32_t)input[53] << 23) |
			((uint32_t)(input[54] & 0xfe) << 15);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 439 to 454
	value = ((uint32_t)(input[54] & 0x01) << 31) |
			((uint32_t)input[55] << 23) |
			((uint32_t)(input[56] & 0xfe) << 15);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 455 to 470
	value = ((uint32_t)(input[56] & 0x01) << 31) |
			((uint32_t)input[57] << 23) |
			((uint32_t)(input[58] & 0xfe) << 15);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 471 to 486
	value = ((uint32_t)(input[58] & 0x01) << 31) |
			((uint32_t)input[59] << 23) |
			((uint32_t)(input[60] & 0xfe) << 15);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 487 to 502
	value = ((uint32_t)(input[60] & 0x01) << 31) |
			((uint32_t)input[61] << 23) |
			((uint32_t)(input[62] & 0xfe) << 15);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 503 to 518
	value = ((uint32_t)(input[62] & 0x01) << 31) |
			((uint32_t)input[63] << 23) |
			((uint32_t)(input[64] & 0xfe) << 15);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 519 to 534
	value = ((uint32_t)(input[64] & 0x01) << 31) |
			((uint32_t)input[65] << 23) |
			((uint32_t)(input[66] & 0xfe) << 15);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 535 to 550
	value = ((uint32_t)(input[66] & 0x01) << 31) |
			((uint32_t)input[67] << 23) |
			((uint32_t)(input[68] & 0xfe) << 15);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 551 to 566
	value = ((uint32_t)(input[68] & 0x01) << 31) |
			((uint32_t)input[69] << 23) |
			((uint32_t)(input[70] & 0xfe) << 15);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 567 to 582
	value = ((uint32_t)(input[70] & 0x01) << 31) |
			((uint32_t)input[71] << 23) |
			((uint32_t)(input[72] & 0xfe) << 15);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 583 to 598
	value = ((uint32_t)(input[72] & 0x01) << 31) |
			((uint32_t)input[73] << 23) |
			((uint32_t)(input[74] & 0xfe) << 15);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 599 to 614
	value = ((uint32_t)(input[74] & 0x01) << 31) |
			((uint32_t)input[75] << 23) |
			((uint32_t)(input[76] & 0xfe) << 15);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 615 to 630
	value = ((uint32_t)(input[76] & 0x01) << 31) |
			((uint32_t)input[77] << 23) |
			((uint32_t)(input[78] & 0xfe) << 15);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 631 to 646
	value = ((uint32_t)(input[78] & 0x01) << 31) |
			((uint32_t)input[79] << 23) |
			((uint32_t)(input[80] & 0xfe) << 15);
	output[39] = (double)(value >> 16);

	// read output[40]: from bit 647 to 662
	value = ((uint32_t)(input[80] & 0x01) << 31) |
			((uint32_t)input[81] << 23) |
			((uint32_t)(input[82] & 0xfe) << 15);
	output[40] = (double)(value >> 16);

	// read output[41]: from bit 663 to 678
	value = ((uint32_t)(input[82] & 0x01) << 31) |
			((uint32_t)input[83] << 23) |
			((uint32_t)(input[84] & 0xfe) << 15);
	output[41] = (double)(value >> 16);

	// read output[42]: from bit 679 to 694
	value = ((uint32_t)(input[84] & 0x01) << 31) |
			((uint32_t)input[85] << 23) |
			((uint32_t)(input[86] & 0xfe) << 15);
	output[42] = (double)(value >> 16);

	// read output[43]: from bit 695 to 710
	value = ((uint32_t)(input[86] & 0x01) << 31) |
			((uint32_t)input[87] << 23) |
			((uint32_t)(input[88] & 0xfe) << 15);
	output[43] = (double)(value >> 16);

	// read output[44]: from bit 711 to 726
	value = ((uint32_t)(input[88] & 0x01) << 31) |
			((uint32_t)input[89] << 23) |
			((uint32_t)(input[90] & 0xfe) << 15);
	output[44] = (double)(value >> 16);

	// read output[45]: from bit 727 to 742
	value = ((uint32_t)(input[90] & 0x01) << 31) |
			((uint32_t)input[91] << 23) |
			((uint32_t)(input[92] & 0xfe) << 15);
	output[45] = (double)(value >> 16);

	// read output[46]: from bit 743 to 758
	value = ((uint32_t)(input[92] & 0x01) << 31) |
			((uint32_t)input[93] << 23) |
			((uint32_t)(input[94] & 0xfe) << 15);
	output[46] = (double)(value >> 16);

	// read output[47]: from bit 759 to 774
	value = ((uint32_t)(input[94] & 0x01) << 31) |
			((uint32_t)input[95] << 23) |
			((uint32_t)(input[96] & 0xfe) << 15);
	output[47] = (double)(value >> 16);

	// read output[48]: from bit 775 to 790
	value = ((uint32_t)(input[96] & 0x01) << 31) |
			((uint32_t)input[97] << 23) |
			((uint32_t)(input[98] & 0xfe) << 15);
	output[48] = (double)(value >> 16);

	// read output[49]: from bit 791 to 806
	value = ((uint32_t)(input[98] & 0x01) << 31) |
			((uint32_t)input[99] << 23) |
			((uint32_t)(input[100] & 0xfe) << 15);
	output[49] = (double)(value >> 16);

	// read output[50]: from bit 807 to 822
	value = ((uint32_t)(input[100] & 0x01) << 31) |
			((uint32_t)input[101] << 23) |
			((uint32_t)(input[102] & 0xfe) << 15);
	output[50] = (double)(value >> 16);

	// read output[51]: from bit 823 to 838
	value = ((uint32_t)(input[102] & 0x01) << 31) |
			((uint32_t)input[103] << 23) |
			((uint32_t)(input[104] & 0xfe) << 15);
	output[51] = (double)(value >> 16);

	// read output[52]: from bit 839 to 854
	value = ((uint32_t)(input[104] & 0x01) << 31) |
			((uint32_t)input[105] << 23) |
			((uint32_t)(input[106] & 0xfe) << 15);
	output[52] = (double)(value >> 16);

	// read output[53]: from bit 855 to 870
	value = ((uint32_t)(input[106] & 0x01) << 31) |
			((uint32_t)input[107] << 23) |
			((uint32_t)(input[108] & 0xfe) << 15);
	output[53] = (double)(value >> 16);

	// read output[54]: from bit 871 to 886
	value = ((uint32_t)(input[108] & 0x01) << 31) |
			((uint32_t)input[109] << 23) |
			((uint32_t)(input[110] & 0xfe) << 15);
	output[54] = (double)(value >> 16);

	// read output[55]: from bit 887 to 902
	value = ((uint32_t)(input[110] & 0x01) << 31) |
			((uint32_t)input[111] << 23) |
			((uint32_t)(input[112] & 0xfe) << 15);
	output[55] = (double)(value >> 16);

	// read output[56]: from bit 903 to 918
	value = ((uint32_t)(input[112] & 0x01) << 31) |
			((uint32_t)input[113] << 23) |
			((uint32_t)(input[114] & 0xfe) << 15);
	output[56] = (double)(value >> 16);

	// read output[57]: from bit 919 to 934
	value = ((uint32_t)(input[114] & 0x01) << 31) |
			((uint32_t)input[115] << 23) |
			((uint32_t)(input[116] & 0xfe) << 15);
	output[57] = (double)(value >> 16);

	// read output[58]: from bit 935 to 950
	value = ((uint32_t)(input[116] & 0x01) << 31) |
			((uint32_t)input[117] << 23) |
			((uint32_t)(input[118] & 0xfe) << 15);
	output[58] = (double)(value >> 16);
}

static void unpack_60_16bit_signed_0off(const uint8_t * input, double * output, void *closure) {
	// Unpack 60 values into output
	// Values are 16-bit signed
	// Skip 0 bits, read 960 bits of data.
	// Input must be at least 120 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 0 to 15
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)input[1] << 16);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 16 to 31
	value = ((uint32_t)input[2] << 24) |
			((uint32_t)input[3] << 16);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 32 to 47
	value = ((uint32_t)input[4] << 24) |
			((uint32_t)input[5] << 16);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 48 to 63
	value = ((uint32_t)input[6] << 24) |
			((uint32_t)input[7] << 16);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 64 to 79
	value = ((uint32_t)input[8] << 24) |
			((uint32_t)input[9] << 16);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 80 to 95
	value = ((uint32_t)input[10] << 24) |
			((uint32_t)input[11] << 16);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 96 to 111
	value = ((uint32_t)input[12] << 24) |
			((uint32_t)input[13] << 16);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 112 to 127
	value = ((uint32_t)input[14] << 24) |
			((uint32_t)input[15] << 16);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 128 to 143
	value = ((uint32_t)input[16] << 24) |
			((uint32_t)input[17] << 16);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 144 to 159
	value = ((uint32_t)input[18] << 24) |
			((uint32_t)input[19] << 16);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 160 to 175
	value = ((uint32_t)input[20] << 24) |
			((uint32_t)input[21] << 16);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 176 to 191
	value = ((uint32_t)input[22] << 24) |
			((uint32_t)input[23] << 16);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 192 to 207
	value = ((uint32_t)input[24] << 24) |
			((uint32_t)input[25] << 16);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 208 to 223
	value = ((uint32_t)input[26] << 24) |
			((uint32_t)input[27] << 16);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 224 to 239
	value = ((uint32_t)input[28] << 24) |
			((uint32_t)input[29] << 16);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 240 to 255
	value = ((uint32_t)input[30] << 24) |
			((uint32_t)input[31] << 16);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 256 to 271
	value = ((uint32_t)input[32] << 24) |
			((uint32_t)input[33] << 16);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 272 to 287
	value = ((uint32_t)input[34] << 24) |
			((uint32_t)input[35] << 16);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 288 to 303
	value = ((uint32_t)input[36] << 24) |
			((uint32_t)input[37] << 16);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 304 to 319
	value = ((uint32_t)input[38] << 24) |
			((uint32_t)input[39] << 16);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 320 to 335
	value = ((uint32_t)input[40] << 24) |
			((uint32_t)input[41] << 16);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 336 to 351
	value = ((uint32_t)input[42] << 24) |
			((uint32_t)input[43] << 16);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 352 to 367
	value = ((uint32_t)input[44] << 24) |
			((uint32_t)input[45] << 16);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 368 to 383
	value = ((uint32_t)input[46] << 24) |
			((uint32_t)input[47] << 16);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 384 to 399
	value = ((uint32_t)input[48] << 24) |
			((uint32_t)input[49] << 16);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 400 to 415
	value = ((uint32_t)input[50] << 24) |
			((uint32_t)input[51] << 16);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 416 to 431
	value = ((uint32_t)input[52] << 24) |
			((uint32_t)input[53] << 16);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 432 to 447
	value = ((uint32_t)input[54] << 24) |
			((uint32_t)input[55] << 16);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 448 to 463
	value = ((uint32_t)input[56] << 24) |
			((uint32_t)input[57] << 16);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 464 to 479
	value = ((uint32_t)input[58] << 24) |
			((uint32_t)input[59] << 16);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 480 to 495
	value = ((uint32_t)input[60] << 24) |
			((uint32_t)input[61] << 16);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 496 to 511
	value = ((uint32_t)input[62] << 24) |
			((uint32_t)input[63] << 16);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 512 to 527
	value = ((uint32_t)input[64] << 24) |
			((uint32_t)input[65] << 16);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 528 to 543
	value = ((uint32_t)input[66] << 24) |
			((uint32_t)input[67] << 16);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 544 to 559
	value = ((uint32_t)input[68] << 24) |
			((uint32_t)input[69] << 16);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 560 to 575
	value = ((uint32_t)input[70] << 24) |
			((uint32_t)input[71] << 16);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 576 to 591
	value = ((uint32_t)input[72] << 24) |
			((uint32_t)input[73] << 16);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 592 to 607
	value = ((uint32_t)input[74] << 24) |
			((uint32_t)input[75] << 16);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 608 to 623
	value = ((uint32_t)input[76] << 24) |
			((uint32_t)input[77] << 16);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 624 to 639
	value = ((uint32_t)input[78] << 24) |
			((uint32_t)input[79] << 16);
	output[39] = (double)(value >> 16);

	// read output[40]: from bit 640 to 655
	value = ((uint32_t)input[80] << 24) |
			((uint32_t)input[81] << 16);
	output[40] = (double)(value >> 16);

	// read output[41]: from bit 656 to 671
	value = ((uint32_t)input[82] << 24) |
			((uint32_t)input[83] << 16);
	output[41] = (double)(value >> 16);

	// read output[42]: from bit 672 to 687
	value = ((uint32_t)input[84] << 24) |
			((uint32_t)input[85] << 16);
	output[42] = (double)(value >> 16);

	// read output[43]: from bit 688 to 703
	value = ((uint32_t)input[86] << 24) |
			((uint32_t)input[87] << 16);
	output[43] = (double)(value >> 16);

	// read output[44]: from bit 704 to 719
	value = ((uint32_t)input[88] << 24) |
			((uint32_t)input[89] << 16);
	output[44] = (double)(value >> 16);

	// read output[45]: from bit 720 to 735
	value = ((uint32_t)input[90] << 24) |
			((uint32_t)input[91] << 16);
	output[45] = (double)(value >> 16);

	// read output[46]: from bit 736 to 751
	value = ((uint32_t)input[92] << 24) |
			((uint32_t)input[93] << 16);
	output[46] = (double)(value >> 16);

	// read output[47]: from bit 752 to 767
	value = ((uint32_t)input[94] << 24) |
			((uint32_t)input[95] << 16);
	output[47] = (double)(value >> 16);

	// read output[48]: from bit 768 to 783
	value = ((uint32_t)input[96] << 24) |
			((uint32_t)input[97] << 16);
	output[48] = (double)(value >> 16);

	// read output[49]: from bit 784 to 799
	value = ((uint32_t)input[98] << 24) |
			((uint32_t)input[99] << 16);
	output[49] = (double)(value >> 16);

	// read output[50]: from bit 800 to 815
	value = ((uint32_t)input[100] << 24) |
			((uint32_t)input[101] << 16);
	output[50] = (double)(value >> 16);

	// read output[51]: from bit 816 to 831
	value = ((uint32_t)input[102] << 24) |
			((uint32_t)input[103] << 16);
	output[51] = (double)(value >> 16);

	// read output[52]: from bit 832 to 847
	value = ((uint32_t)input[104] << 24) |
			((uint32_t)input[105] << 16);
	output[52] = (double)(value >> 16);

	// read output[53]: from bit 848 to 863
	value = ((uint32_t)input[106] << 24) |
			((uint32_t)input[107] << 16);
	output[53] = (double)(value >> 16);

	// read output[54]: from bit 864 to 879
	value = ((uint32_t)input[108] << 24) |
			((uint32_t)input[109] << 16);
	output[54] = (double)(value >> 16);

	// read output[55]: from bit 880 to 895
	value = ((uint32_t)input[110] << 24) |
			((uint32_t)input[111] << 16);
	output[55] = (double)(value >> 16);

	// read output[56]: from bit 896 to 911
	value = ((uint32_t)input[112] << 24) |
			((uint32_t)input[113] << 16);
	output[56] = (double)(value >> 16);

	// read output[57]: from bit 912 to 927
	value = ((uint32_t)input[114] << 24) |
			((uint32_t)input[115] << 16);
	output[57] = (double)(value >> 16);

	// read output[58]: from bit 928 to 943
	value = ((uint32_t)input[116] << 24) |
			((uint32_t)input[117] << 16);
	output[58] = (double)(value >> 16);

	// read output[59]: from bit 944 to 959
	value = ((uint32_t)input[118] << 24) |
			((uint32_t)input[119] << 16);
	output[59] = (double)(value >> 16);
}

static void unpack_60_16bit_unsigned_0off(const uint8_t * input, double * output, void *closure) {
	// Unpack 60 values into output
	// Values are 16-bit unsigned
	// Skip 0 bits, read 960 bits of data.
	// Input must be at least 120 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 0 to 15
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)input[1] << 16);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 16 to 31
	value = ((uint32_t)input[2] << 24) |
			((uint32_t)input[3] << 16);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 32 to 47
	value = ((uint32_t)input[4] << 24) |
			((uint32_t)input[5] << 16);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 48 to 63
	value = ((uint32_t)input[6] << 24) |
			((uint32_t)input[7] << 16);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 64 to 79
	value = ((uint32_t)input[8] << 24) |
			((uint32_t)input[9] << 16);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 80 to 95
	value = ((uint32_t)input[10] << 24) |
			((uint32_t)input[11] << 16);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 96 to 111
	value = ((uint32_t)input[12] << 24) |
			((uint32_t)input[13] << 16);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 112 to 127
	value = ((uint32_t)input[14] << 24) |
			((uint32_t)input[15] << 16);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 128 to 143
	value = ((uint32_t)input[16] << 24) |
			((uint32_t)input[17] << 16);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 144 to 159
	value = ((uint32_t)input[18] << 24) |
			((uint32_t)input[19] << 16);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 160 to 175
	value = ((uint32_t)input[20] << 24) |
			((uint32_t)input[21] << 16);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 176 to 191
	value = ((uint32_t)input[22] << 24) |
			((uint32_t)input[23] << 16);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 192 to 207
	value = ((uint32_t)input[24] << 24) |
			((uint32_t)input[25] << 16);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 208 to 223
	value = ((uint32_t)input[26] << 24) |
			((uint32_t)input[27] << 16);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 224 to 239
	value = ((uint32_t)input[28] << 24) |
			((uint32_t)input[29] << 16);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 240 to 255
	value = ((uint32_t)input[30] << 24) |
			((uint32_t)input[31] << 16);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 256 to 271
	value = ((uint32_t)input[32] << 24) |
			((uint32_t)input[33] << 16);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 272 to 287
	value = ((uint32_t)input[34] << 24) |
			((uint32_t)input[35] << 16);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 288 to 303
	value = ((uint32_t)input[36] << 24) |
			((uint32_t)input[37] << 16);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 304 to 319
	value = ((uint32_t)input[38] << 24) |
			((uint32_t)input[39] << 16);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 320 to 335
	value = ((uint32_t)input[40] << 24) |
			((uint32_t)input[41] << 16);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 336 to 351
	value = ((uint32_t)input[42] << 24) |
			((uint32_t)input[43] << 16);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 352 to 367
	value = ((uint32_t)input[44] << 24) |
			((uint32_t)input[45] << 16);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 368 to 383
	value = ((uint32_t)input[46] << 24) |
			((uint32_t)input[47] << 16);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 384 to 399
	value = ((uint32_t)input[48] << 24) |
			((uint32_t)input[49] << 16);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 400 to 415
	value = ((uint32_t)input[50] << 24) |
			((uint32_t)input[51] << 16);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 416 to 431
	value = ((uint32_t)input[52] << 24) |
			((uint32_t)input[53] << 16);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 432 to 447
	value = ((uint32_t)input[54] << 24) |
			((uint32_t)input[55] << 16);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 448 to 463
	value = ((uint32_t)input[56] << 24) |
			((uint32_t)input[57] << 16);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 464 to 479
	value = ((uint32_t)input[58] << 24) |
			((uint32_t)input[59] << 16);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 480 to 495
	value = ((uint32_t)input[60] << 24) |
			((uint32_t)input[61] << 16);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 496 to 511
	value = ((uint32_t)input[62] << 24) |
			((uint32_t)input[63] << 16);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 512 to 527
	value = ((uint32_t)input[64] << 24) |
			((uint32_t)input[65] << 16);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 528 to 543
	value = ((uint32_t)input[66] << 24) |
			((uint32_t)input[67] << 16);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 544 to 559
	value = ((uint32_t)input[68] << 24) |
			((uint32_t)input[69] << 16);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 560 to 575
	value = ((uint32_t)input[70] << 24) |
			((uint32_t)input[71] << 16);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 576 to 591
	value = ((uint32_t)input[72] << 24) |
			((uint32_t)input[73] << 16);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 592 to 607
	value = ((uint32_t)input[74] << 24) |
			((uint32_t)input[75] << 16);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 608 to 623
	value = ((uint32_t)input[76] << 24) |
			((uint32_t)input[77] << 16);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 624 to 639
	value = ((uint32_t)input[78] << 24) |
			((uint32_t)input[79] << 16);
	output[39] = (double)(value >> 16);

	// read output[40]: from bit 640 to 655
	value = ((uint32_t)input[80] << 24) |
			((uint32_t)input[81] << 16);
	output[40] = (double)(value >> 16);

	// read output[41]: from bit 656 to 671
	value = ((uint32_t)input[82] << 24) |
			((uint32_t)input[83] << 16);
	output[41] = (double)(value >> 16);

	// read output[42]: from bit 672 to 687
	value = ((uint32_t)input[84] << 24) |
			((uint32_t)input[85] << 16);
	output[42] = (double)(value >> 16);

	// read output[43]: from bit 688 to 703
	value = ((uint32_t)input[86] << 24) |
			((uint32_t)input[87] << 16);
	output[43] = (double)(value >> 16);

	// read output[44]: from bit 704 to 719
	value = ((uint32_t)input[88] << 24) |
			((uint32_t)input[89] << 16);
	output[44] = (double)(value >> 16);

	// read output[45]: from bit 720 to 735
	value = ((uint32_t)input[90] << 24) |
			((uint32_t)input[91] << 16);
	output[45] = (double)(value >> 16);

	// read output[46]: from bit 736 to 751
	value = ((uint32_t)input[92] << 24) |
			((uint32_t)input[93] << 16);
	output[46] = (double)(value >> 16);

	// read output[47]: from bit 752 to 767
	value = ((uint32_t)input[94] << 24) |
			((uint32_t)input[95] << 16);
	output[47] = (double)(value >> 16);

	// read output[48]: from bit 768 to 783
	value = ((uint32_t)input[96] << 24) |
			((uint32_t)input[97] << 16);
	output[48] = (double)(value >> 16);

	// read output[49]: from bit 784 to 799
	value = ((uint32_t)input[98] << 24) |
			((uint32_t)input[99] << 16);
	output[49] = (double)(value >> 16);

	// read output[50]: from bit 800 to 815
	value = ((uint32_t)input[100] << 24) |
			((uint32_t)input[101] << 16);
	output[50] = (double)(value >> 16);

	// read output[51]: from bit 816 to 831
	value = ((uint32_t)input[102] << 24) |
			((uint32_t)input[103] << 16);
	output[51] = (double)(value >> 16);

	// read output[52]: from bit 832 to 847
	value = ((uint32_t)input[104] << 24) |
			((uint32_t)input[105] << 16);
	output[52] = (double)(value >> 16);

	// read output[53]: from bit 848 to 863
	value = ((uint32_t)input[106] << 24) |
			((uint32_t)input[107] << 16);
	output[53] = (double)(value >> 16);

	// read output[54]: from bit 864 to 879
	value = ((uint32_t)input[108] << 24) |
			((uint32_t)input[109] << 16);
	output[54] = (double)(value >> 16);

	// read output[55]: from bit 880 to 895
	value = ((uint32_t)input[110] << 24) |
			((uint32_t)input[111] << 16);
	output[55] = (double)(value >> 16);

	// read output[56]: from bit 896 to 911
	value = ((uint32_t)input[112] << 24) |
			((uint32_t)input[113] << 16);
	output[56] = (double)(value >> 16);

	// read output[57]: from bit 912 to 927
	value = ((uint32_t)input[114] << 24) |
			((uint32_t)input[115] << 16);
	output[57] = (double)(value >> 16);

	// read output[58]: from bit 928 to 943
	value = ((uint32_t)input[116] << 24) |
			((uint32_t)input[117] << 16);
	output[58] = (double)(value >> 16);

	// read output[59]: from bit 944 to 959
	value = ((uint32_t)input[118] << 24) |
			((uint32_t)input[119] << 16);
	output[59] = (double)(value >> 16);
}

static void unpack_60_16bit_signed_1off(const uint8_t * input, double * output, void *closure) {
	// Unpack 60 values into output
	// Values are 16-bit signed
	// Skip 1 bits, read 960 bits of data.
	// Input must be at least 121 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 1 to 16
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)input[1] << 17) |
			((uint32_t)(input[2] & 0x80) << 9);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 17 to 32
	value = ((uint32_t)(input[2] & 0x7f) << 25) |
			((uint32_t)input[3] << 17) |
			((uint32_t)(input[4] & 0x80) << 9);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 33 to 48
	value = ((uint32_t)(input[4] & 0x7f) << 25) |
			((uint32_t)input[5] << 17) |
			((uint32_t)(input[6] & 0x80) << 9);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 49 to 64
	value = ((uint32_t)(input[6] & 0x7f) << 25) |
			((uint32_t)input[7] << 17) |
			((uint32_t)(input[8] & 0x80) << 9);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 65 to 80
	value = ((uint32_t)(input[8] & 0x7f) << 25) |
			((uint32_t)input[9] << 17) |
			((uint32_t)(input[10] & 0x80) << 9);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 81 to 96
	value = ((uint32_t)(input[10] & 0x7f) << 25) |
			((uint32_t)input[11] << 17) |
			((uint32_t)(input[12] & 0x80) << 9);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 97 to 112
	value = ((uint32_t)(input[12] & 0x7f) << 25) |
			((uint32_t)input[13] << 17) |
			((uint32_t)(input[14] & 0x80) << 9);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 113 to 128
	value = ((uint32_t)(input[14] & 0x7f) << 25) |
			((uint32_t)input[15] << 17) |
			((uint32_t)(input[16] & 0x80) << 9);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 129 to 144
	value = ((uint32_t)(input[16] & 0x7f) << 25) |
			((uint32_t)input[17] << 17) |
			((uint32_t)(input[18] & 0x80) << 9);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 145 to 160
	value = ((uint32_t)(input[18] & 0x7f) << 25) |
			((uint32_t)input[19] << 17) |
			((uint32_t)(input[20] & 0x80) << 9);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 161 to 176
	value = ((uint32_t)(input[20] & 0x7f) << 25) |
			((uint32_t)input[21] << 17) |
			((uint32_t)(input[22] & 0x80) << 9);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 177 to 192
	value = ((uint32_t)(input[22] & 0x7f) << 25) |
			((uint32_t)input[23] << 17) |
			((uint32_t)(input[24] & 0x80) << 9);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 193 to 208
	value = ((uint32_t)(input[24] & 0x7f) << 25) |
			((uint32_t)input[25] << 17) |
			((uint32_t)(input[26] & 0x80) << 9);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 209 to 224
	value = ((uint32_t)(input[26] & 0x7f) << 25) |
			((uint32_t)input[27] << 17) |
			((uint32_t)(input[28] & 0x80) << 9);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 225 to 240
	value = ((uint32_t)(input[28] & 0x7f) << 25) |
			((uint32_t)input[29] << 17) |
			((uint32_t)(input[30] & 0x80) << 9);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 241 to 256
	value = ((uint32_t)(input[30] & 0x7f) << 25) |
			((uint32_t)input[31] << 17) |
			((uint32_t)(input[32] & 0x80) << 9);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 257 to 272
	value = ((uint32_t)(input[32] & 0x7f) << 25) |
			((uint32_t)input[33] << 17) |
			((uint32_t)(input[34] & 0x80) << 9);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 273 to 288
	value = ((uint32_t)(input[34] & 0x7f) << 25) |
			((uint32_t)input[35] << 17) |
			((uint32_t)(input[36] & 0x80) << 9);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 289 to 304
	value = ((uint32_t)(input[36] & 0x7f) << 25) |
			((uint32_t)input[37] << 17) |
			((uint32_t)(input[38] & 0x80) << 9);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 305 to 320
	value = ((uint32_t)(input[38] & 0x7f) << 25) |
			((uint32_t)input[39] << 17) |
			((uint32_t)(input[40] & 0x80) << 9);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 321 to 336
	value = ((uint32_t)(input[40] & 0x7f) << 25) |
			((uint32_t)input[41] << 17) |
			((uint32_t)(input[42] & 0x80) << 9);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 337 to 352
	value = ((uint32_t)(input[42] & 0x7f) << 25) |
			((uint32_t)input[43] << 17) |
			((uint32_t)(input[44] & 0x80) << 9);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 353 to 368
	value = ((uint32_t)(input[44] & 0x7f) << 25) |
			((uint32_t)input[45] << 17) |
			((uint32_t)(input[46] & 0x80) << 9);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 369 to 384
	value = ((uint32_t)(input[46] & 0x7f) << 25) |
			((uint32_t)input[47] << 17) |
			((uint32_t)(input[48] & 0x80) << 9);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 385 to 400
	value = ((uint32_t)(input[48] & 0x7f) << 25) |
			((uint32_t)input[49] << 17) |
			((uint32_t)(input[50] & 0x80) << 9);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 401 to 416
	value = ((uint32_t)(input[50] & 0x7f) << 25) |
			((uint32_t)input[51] << 17) |
			((uint32_t)(input[52] & 0x80) << 9);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 417 to 432
	value = ((uint32_t)(input[52] & 0x7f) << 25) |
			((uint32_t)input[53] << 17) |
			((uint32_t)(input[54] & 0x80) << 9);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 433 to 448
	value = ((uint32_t)(input[54] & 0x7f) << 25) |
			((uint32_t)input[55] << 17) |
			((uint32_t)(input[56] & 0x80) << 9);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 449 to 464
	value = ((uint32_t)(input[56] & 0x7f) << 25) |
			((uint32_t)input[57] << 17) |
			((uint32_t)(input[58] & 0x80) << 9);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 465 to 480
	value = ((uint32_t)(input[58] & 0x7f) << 25) |
			((uint32_t)input[59] << 17) |
			((uint32_t)(input[60] & 0x80) << 9);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 481 to 496
	value = ((uint32_t)(input[60] & 0x7f) << 25) |
			((uint32_t)input[61] << 17) |
			((uint32_t)(input[62] & 0x80) << 9);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 497 to 512
	value = ((uint32_t)(input[62] & 0x7f) << 25) |
			((uint32_t)input[63] << 17) |
			((uint32_t)(input[64] & 0x80) << 9);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 513 to 528
	value = ((uint32_t)(input[64] & 0x7f) << 25) |
			((uint32_t)input[65] << 17) |
			((uint32_t)(input[66] & 0x80) << 9);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 529 to 544
	value = ((uint32_t)(input[66] & 0x7f) << 25) |
			((uint32_t)input[67] << 17) |
			((uint32_t)(input[68] & 0x80) << 9);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 545 to 560
	value = ((uint32_t)(input[68] & 0x7f) << 25) |
			((uint32_t)input[69] << 17) |
			((uint32_t)(input[70] & 0x80) << 9);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 561 to 576
	value = ((uint32_t)(input[70] & 0x7f) << 25) |
			((uint32_t)input[71] << 17) |
			((uint32_t)(input[72] & 0x80) << 9);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 577 to 592
	value = ((uint32_t)(input[72] & 0x7f) << 25) |
			((uint32_t)input[73] << 17) |
			((uint32_t)(input[74] & 0x80) << 9);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 593 to 608
	value = ((uint32_t)(input[74] & 0x7f) << 25) |
			((uint32_t)input[75] << 17) |
			((uint32_t)(input[76] & 0x80) << 9);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 609 to 624
	value = ((uint32_t)(input[76] & 0x7f) << 25) |
			((uint32_t)input[77] << 17) |
			((uint32_t)(input[78] & 0x80) << 9);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 625 to 640
	value = ((uint32_t)(input[78] & 0x7f) << 25) |
			((uint32_t)input[79] << 17) |
			((uint32_t)(input[80] & 0x80) << 9);
	output[39] = (double)(value >> 16);

	// read output[40]: from bit 641 to 656
	value = ((uint32_t)(input[80] & 0x7f) << 25) |
			((uint32_t)input[81] << 17) |
			((uint32_t)(input[82] & 0x80) << 9);
	output[40] = (double)(value >> 16);

	// read output[41]: from bit 657 to 672
	value = ((uint32_t)(input[82] & 0x7f) << 25) |
			((uint32_t)input[83] << 17) |
			((uint32_t)(input[84] & 0x80) << 9);
	output[41] = (double)(value >> 16);

	// read output[42]: from bit 673 to 688
	value = ((uint32_t)(input[84] & 0x7f) << 25) |
			((uint32_t)input[85] << 17) |
			((uint32_t)(input[86] & 0x80) << 9);
	output[42] = (double)(value >> 16);

	// read output[43]: from bit 689 to 704
	value = ((uint32_t)(input[86] & 0x7f) << 25) |
			((uint32_t)input[87] << 17) |
			((uint32_t)(input[88] & 0x80) << 9);
	output[43] = (double)(value >> 16);

	// read output[44]: from bit 705 to 720
	value = ((uint32_t)(input[88] & 0x7f) << 25) |
			((uint32_t)input[89] << 17) |
			((uint32_t)(input[90] & 0x80) << 9);
	output[44] = (double)(value >> 16);

	// read output[45]: from bit 721 to 736
	value = ((uint32_t)(input[90] & 0x7f) << 25) |
			((uint32_t)input[91] << 17) |
			((uint32_t)(input[92] & 0x80) << 9);
	output[45] = (double)(value >> 16);

	// read output[46]: from bit 737 to 752
	value = ((uint32_t)(input[92] & 0x7f) << 25) |
			((uint32_t)input[93] << 17) |
			((uint32_t)(input[94] & 0x80) << 9);
	output[46] = (double)(value >> 16);

	// read output[47]: from bit 753 to 768
	value = ((uint32_t)(input[94] & 0x7f) << 25) |
			((uint32_t)input[95] << 17) |
			((uint32_t)(input[96] & 0x80) << 9);
	output[47] = (double)(value >> 16);

	// read output[48]: from bit 769 to 784
	value = ((uint32_t)(input[96] & 0x7f) << 25) |
			((uint32_t)input[97] << 17) |
			((uint32_t)(input[98] & 0x80) << 9);
	output[48] = (double)(value >> 16);

	// read output[49]: from bit 785 to 800
	value = ((uint32_t)(input[98] & 0x7f) << 25) |
			((uint32_t)input[99] << 17) |
			((uint32_t)(input[100] & 0x80) << 9);
	output[49] = (double)(value >> 16);

	// read output[50]: from bit 801 to 816
	value = ((uint32_t)(input[100] & 0x7f) << 25) |
			((uint32_t)input[101] << 17) |
			((uint32_t)(input[102] & 0x80) << 9);
	output[50] = (double)(value >> 16);

	// read output[51]: from bit 817 to 832
	value = ((uint32_t)(input[102] & 0x7f) << 25) |
			((uint32_t)input[103] << 17) |
			((uint32_t)(input[104] & 0x80) << 9);
	output[51] = (double)(value >> 16);

	// read output[52]: from bit 833 to 848
	value = ((uint32_t)(input[104] & 0x7f) << 25) |
			((uint32_t)input[105] << 17) |
			((uint32_t)(input[106] & 0x80) << 9);
	output[52] = (double)(value >> 16);

	// read output[53]: from bit 849 to 864
	value = ((uint32_t)(input[106] & 0x7f) << 25) |
			((uint32_t)input[107] << 17) |
			((uint32_t)(input[108] & 0x80) << 9);
	output[53] = (double)(value >> 16);

	// read output[54]: from bit 865 to 880
	value = ((uint32_t)(input[108] & 0x7f) << 25) |
			((uint32_t)input[109] << 17) |
			((uint32_t)(input[110] & 0x80) << 9);
	output[54] = (double)(value >> 16);

	// read output[55]: from bit 881 to 896
	value = ((uint32_t)(input[110] & 0x7f) << 25) |
			((uint32_t)input[111] << 17) |
			((uint32_t)(input[112] & 0x80) << 9);
	output[55] = (double)(value >> 16);

	// read output[56]: from bit 897 to 912
	value = ((uint32_t)(input[112] & 0x7f) << 25) |
			((uint32_t)input[113] << 17) |
			((uint32_t)(input[114] & 0x80) << 9);
	output[56] = (double)(value >> 16);

	// read output[57]: from bit 913 to 928
	value = ((uint32_t)(input[114] & 0x7f) << 25) |
			((uint32_t)input[115] << 17) |
			((uint32_t)(input[116] & 0x80) << 9);
	output[57] = (double)(value >> 16);

	// read output[58]: from bit 929 to 944
	value = ((uint32_t)(input[116] & 0x7f) << 25) |
			((uint32_t)input[117] << 17) |
			((uint32_t)(input[118] & 0x80) << 9);
	output[58] = (double)(value >> 16);

	// read output[59]: from bit 945 to 960
	value = ((uint32_t)(input[118] & 0x7f) << 25) |
			((uint32_t)input[119] << 17) |
			((uint32_t)(input[120] & 0x80) << 9);
	output[59] = (double)(value >> 16);
}

static void unpack_60_16bit_unsigned_1off(const uint8_t * input, double * output, void *closure) {
	// Unpack 60 values into output
	// Values are 16-bit unsigned
	// Skip 1 bits, read 960 bits of data.
	// Input must be at least 121 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 1 to 16
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)input[1] << 17) |
			((uint32_t)(input[2] & 0x80) << 9);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 17 to 32
	value = ((uint32_t)(input[2] & 0x7f) << 25) |
			((uint32_t)input[3] << 17) |
			((uint32_t)(input[4] & 0x80) << 9);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 33 to 48
	value = ((uint32_t)(input[4] & 0x7f) << 25) |
			((uint32_t)input[5] << 17) |
			((uint32_t)(input[6] & 0x80) << 9);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 49 to 64
	value = ((uint32_t)(input[6] & 0x7f) << 25) |
			((uint32_t)input[7] << 17) |
			((uint32_t)(input[8] & 0x80) << 9);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 65 to 80
	value = ((uint32_t)(input[8] & 0x7f) << 25) |
			((uint32_t)input[9] << 17) |
			((uint32_t)(input[10] & 0x80) << 9);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 81 to 96
	value = ((uint32_t)(input[10] & 0x7f) << 25) |
			((uint32_t)input[11] << 17) |
			((uint32_t)(input[12] & 0x80) << 9);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 97 to 112
	value = ((uint32_t)(input[12] & 0x7f) << 25) |
			((uint32_t)input[13] << 17) |
			((uint32_t)(input[14] & 0x80) << 9);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 113 to 128
	value = ((uint32_t)(input[14] & 0x7f) << 25) |
			((uint32_t)input[15] << 17) |
			((uint32_t)(input[16] & 0x80) << 9);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 129 to 144
	value = ((uint32_t)(input[16] & 0x7f) << 25) |
			((uint32_t)input[17] << 17) |
			((uint32_t)(input[18] & 0x80) << 9);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 145 to 160
	value = ((uint32_t)(input[18] & 0x7f) << 25) |
			((uint32_t)input[19] << 17) |
			((uint32_t)(input[20] & 0x80) << 9);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 161 to 176
	value = ((uint32_t)(input[20] & 0x7f) << 25) |
			((uint32_t)input[21] << 17) |
			((uint32_t)(input[22] & 0x80) << 9);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 177 to 192
	value = ((uint32_t)(input[22] & 0x7f) << 25) |
			((uint32_t)input[23] << 17) |
			((uint32_t)(input[24] & 0x80) << 9);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 193 to 208
	value = ((uint32_t)(input[24] & 0x7f) << 25) |
			((uint32_t)input[25] << 17) |
			((uint32_t)(input[26] & 0x80) << 9);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 209 to 224
	value = ((uint32_t)(input[26] & 0x7f) << 25) |
			((uint32_t)input[27] << 17) |
			((uint32_t)(input[28] & 0x80) << 9);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 225 to 240
	value = ((uint32_t)(input[28] & 0x7f) << 25) |
			((uint32_t)input[29] << 17) |
			((uint32_t)(input[30] & 0x80) << 9);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 241 to 256
	value = ((uint32_t)(input[30] & 0x7f) << 25) |
			((uint32_t)input[31] << 17) |
			((uint32_t)(input[32] & 0x80) << 9);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 257 to 272
	value = ((uint32_t)(input[32] & 0x7f) << 25) |
			((uint32_t)input[33] << 17) |
			((uint32_t)(input[34] & 0x80) << 9);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 273 to 288
	value = ((uint32_t)(input[34] & 0x7f) << 25) |
			((uint32_t)input[35] << 17) |
			((uint32_t)(input[36] & 0x80) << 9);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 289 to 304
	value = ((uint32_t)(input[36] & 0x7f) << 25) |
			((uint32_t)input[37] << 17) |
			((uint32_t)(input[38] & 0x80) << 9);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 305 to 320
	value = ((uint32_t)(input[38] & 0x7f) << 25) |
			((uint32_t)input[39] << 17) |
			((uint32_t)(input[40] & 0x80) << 9);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 321 to 336
	value = ((uint32_t)(input[40] & 0x7f) << 25) |
			((uint32_t)input[41] << 17) |
			((uint32_t)(input[42] & 0x80) << 9);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 337 to 352
	value = ((uint32_t)(input[42] & 0x7f) << 25) |
			((uint32_t)input[43] << 17) |
			((uint32_t)(input[44] & 0x80) << 9);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 353 to 368
	value = ((uint32_t)(input[44] & 0x7f) << 25) |
			((uint32_t)input[45] << 17) |
			((uint32_t)(input[46] & 0x80) << 9);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 369 to 384
	value = ((uint32_t)(input[46] & 0x7f) << 25) |
			((uint32_t)input[47] << 17) |
			((uint32_t)(input[48] & 0x80) << 9);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 385 to 400
	value = ((uint32_t)(input[48] & 0x7f) << 25) |
			((uint32_t)input[49] << 17) |
			((uint32_t)(input[50] & 0x80) << 9);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 401 to 416
	value = ((uint32_t)(input[50] & 0x7f) << 25) |
			((uint32_t)input[51] << 17) |
			((uint32_t)(input[52] & 0x80) << 9);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 417 to 432
	value = ((uint32_t)(input[52] & 0x7f) << 25) |
			((uint32_t)input[53] << 17) |
			((uint32_t)(input[54] & 0x80) << 9);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 433 to 448
	value = ((uint32_t)(input[54] & 0x7f) << 25) |
			((uint32_t)input[55] << 17) |
			((uint32_t)(input[56] & 0x80) << 9);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 449 to 464
	value = ((uint32_t)(input[56] & 0x7f) << 25) |
			((uint32_t)input[57] << 17) |
			((uint32_t)(input[58] & 0x80) << 9);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 465 to 480
	value = ((uint32_t)(input[58] & 0x7f) << 25) |
			((uint32_t)input[59] << 17) |
			((uint32_t)(input[60] & 0x80) << 9);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 481 to 496
	value = ((uint32_t)(input[60] & 0x7f) << 25) |
			((uint32_t)input[61] << 17) |
			((uint32_t)(input[62] & 0x80) << 9);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 497 to 512
	value = ((uint32_t)(input[62] & 0x7f) << 25) |
			((uint32_t)input[63] << 17) |
			((uint32_t)(input[64] & 0x80) << 9);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 513 to 528
	value = ((uint32_t)(input[64] & 0x7f) << 25) |
			((uint32_t)input[65] << 17) |
			((uint32_t)(input[66] & 0x80) << 9);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 529 to 544
	value = ((uint32_t)(input[66] & 0x7f) << 25) |
			((uint32_t)input[67] << 17) |
			((uint32_t)(input[68] & 0x80) << 9);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 545 to 560
	value = ((uint32_t)(input[68] & 0x7f) << 25) |
			((uint32_t)input[69] << 17) |
			((uint32_t)(input[70] & 0x80) << 9);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 561 to 576
	value = ((uint32_t)(input[70] & 0x7f) << 25) |
			((uint32_t)input[71] << 17) |
			((uint32_t)(input[72] & 0x80) << 9);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 577 to 592
	value = ((uint32_t)(input[72] & 0x7f) << 25) |
			((uint32_t)input[73] << 17) |
			((uint32_t)(input[74] & 0x80) << 9);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 593 to 608
	value = ((uint32_t)(input[74] & 0x7f) << 25) |
			((uint32_t)input[75] << 17) |
			((uint32_t)(input[76] & 0x80) << 9);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 609 to 624
	value = ((uint32_t)(input[76] & 0x7f) << 25) |
			((uint32_t)input[77] << 17) |
			((uint32_t)(input[78] & 0x80) << 9);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 625 to 640
	value = ((uint32_t)(input[78] & 0x7f) << 25) |
			((uint32_t)input[79] << 17) |
			((uint32_t)(input[80] & 0x80) << 9);
	output[39] = (double)(value >> 16);

	// read output[40]: from bit 641 to 656
	value = ((uint32_t)(input[80] & 0x7f) << 25) |
			((uint32_t)input[81] << 17) |
			((uint32_t)(input[82] & 0x80) << 9);
	output[40] = (double)(value >> 16);

	// read output[41]: from bit 657 to 672
	value = ((uint32_t)(input[82] & 0x7f) << 25) |
			((uint32_t)input[83] << 17) |
			((uint32_t)(input[84] & 0x80) << 9);
	output[41] = (double)(value >> 16);

	// read output[42]: from bit 673 to 688
	value = ((uint32_t)(input[84] & 0x7f) << 25) |
			((uint32_t)input[85] << 17) |
			((uint32_t)(input[86] & 0x80) << 9);
	output[42] = (double)(value >> 16);

	// read output[43]: from bit 689 to 704
	value = ((uint32_t)(input[86] & 0x7f) << 25) |
			((uint32_t)input[87] << 17) |
			((uint32_t)(input[88] & 0x80) << 9);
	output[43] = (double)(value >> 16);

	// read output[44]: from bit 705 to 720
	value = ((uint32_t)(input[88] & 0x7f) << 25) |
			((uint32_t)input[89] << 17) |
			((uint32_t)(input[90] & 0x80) << 9);
	output[44] = (double)(value >> 16);

	// read output[45]: from bit 721 to 736
	value = ((uint32_t)(input[90] & 0x7f) << 25) |
			((uint32_t)input[91] << 17) |
			((uint32_t)(input[92] & 0x80) << 9);
	output[45] = (double)(value >> 16);

	// read output[46]: from bit 737 to 752
	value = ((uint32_t)(input[92] & 0x7f) << 25) |
			((uint32_t)input[93] << 17) |
			((uint32_t)(input[94] & 0x80) << 9);
	output[46] = (double)(value >> 16);

	// read output[47]: from bit 753 to 768
	value = ((uint32_t)(input[94] & 0x7f) << 25) |
			((uint32_t)input[95] << 17) |
			((uint32_t)(input[96] & 0x80) << 9);
	output[47] = (double)(value >> 16);

	// read output[48]: from bit 769 to 784
	value = ((uint32_t)(input[96] & 0x7f) << 25) |
			((uint32_t)input[97] << 17) |
			((uint32_t)(input[98] & 0x80) << 9);
	output[48] = (double)(value >> 16);

	// read output[49]: from bit 785 to 800
	value = ((uint32_t)(input[98] & 0x7f) << 25) |
			((uint32_t)input[99] << 17) |
			((uint32_t)(input[100] & 0x80) << 9);
	output[49] = (double)(value >> 16);

	// read output[50]: from bit 801 to 816
	value = ((uint32_t)(input[100] & 0x7f) << 25) |
			((uint32_t)input[101] << 17) |
			((uint32_t)(input[102] & 0x80) << 9);
	output[50] = (double)(value >> 16);

	// read output[51]: from bit 817 to 832
	value = ((uint32_t)(input[102] & 0x7f) << 25) |
			((uint32_t)input[103] << 17) |
			((uint32_t)(input[104] & 0x80) << 9);
	output[51] = (double)(value >> 16);

	// read output[52]: from bit 833 to 848
	value = ((uint32_t)(input[104] & 0x7f) << 25) |
			((uint32_t)input[105] << 17) |
			((uint32_t)(input[106] & 0x80) << 9);
	output[52] = (double)(value >> 16);

	// read output[53]: from bit 849 to 864
	value = ((uint32_t)(input[106] & 0x7f) << 25) |
			((uint32_t)input[107] << 17) |
			((uint32_t)(input[108] & 0x80) << 9);
	output[53] = (double)(value >> 16);

	// read output[54]: from bit 865 to 880
	value = ((uint32_t)(input[108] & 0x7f) << 25) |
			((uint32_t)input[109] << 17) |
			((uint32_t)(input[110] & 0x80) << 9);
	output[54] = (double)(value >> 16);

	// read output[55]: from bit 881 to 896
	value = ((uint32_t)(input[110] & 0x7f) << 25) |
			((uint32_t)input[111] << 17) |
			((uint32_t)(input[112] & 0x80) << 9);
	output[55] = (double)(value >> 16);

	// read output[56]: from bit 897 to 912
	value = ((uint32_t)(input[112] & 0x7f) << 25) |
			((uint32_t)input[113] << 17) |
			((uint32_t)(input[114] & 0x80) << 9);
	output[56] = (double)(value >> 16);

	// read output[57]: from bit 913 to 928
	value = ((uint32_t)(input[114] & 0x7f) << 25) |
			((uint32_t)input[115] << 17) |
			((uint32_t)(input[116] & 0x80) << 9);
	output[57] = (double)(value >> 16);

	// read output[58]: from bit 929 to 944
	value = ((uint32_t)(input[116] & 0x7f) << 25) |
			((uint32_t)input[117] << 17) |
			((uint32_t)(input[118] & 0x80) << 9);
	output[58] = (double)(value >> 16);

	// read output[59]: from bit 945 to 960
	value = ((uint32_t)(input[118] & 0x7f) << 25) |
			((uint32_t)input[119] << 17) |
			((uint32_t)(input[120] & 0x80) << 9);
	output[59] = (double)(value >> 16);
}

static void unpack_60_16bit_signed_2off(const uint8_t * input, double * output, void *closure) {
	// Unpack 60 values into output
	// Values are 16-bit signed
	// Skip 2 bits, read 960 bits of data.
	// Input must be at least 121 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 2 to 17
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)input[1] << 18) |
			((uint32_t)(input[2] & 0xc0) << 10);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 18 to 33
	value = ((uint32_t)(input[2] & 0x3f) << 26) |
			((uint32_t)input[3] << 18) |
			((uint32_t)(input[4] & 0xc0) << 10);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 34 to 49
	value = ((uint32_t)(input[4] & 0x3f) << 26) |
			((uint32_t)input[5] << 18) |
			((uint32_t)(input[6] & 0xc0) << 10);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 50 to 65
	value = ((uint32_t)(input[6] & 0x3f) << 26) |
			((uint32_t)input[7] << 18) |
			((uint32_t)(input[8] & 0xc0) << 10);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 66 to 81
	value = ((uint32_t)(input[8] & 0x3f) << 26) |
			((uint32_t)input[9] << 18) |
			((uint32_t)(input[10] & 0xc0) << 10);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 82 to 97
	value = ((uint32_t)(input[10] & 0x3f) << 26) |
			((uint32_t)input[11] << 18) |
			((uint32_t)(input[12] & 0xc0) << 10);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 98 to 113
	value = ((uint32_t)(input[12] & 0x3f) << 26) |
			((uint32_t)input[13] << 18) |
			((uint32_t)(input[14] & 0xc0) << 10);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 114 to 129
	value = ((uint32_t)(input[14] & 0x3f) << 26) |
			((uint32_t)input[15] << 18) |
			((uint32_t)(input[16] & 0xc0) << 10);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 130 to 145
	value = ((uint32_t)(input[16] & 0x3f) << 26) |
			((uint32_t)input[17] << 18) |
			((uint32_t)(input[18] & 0xc0) << 10);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 146 to 161
	value = ((uint32_t)(input[18] & 0x3f) << 26) |
			((uint32_t)input[19] << 18) |
			((uint32_t)(input[20] & 0xc0) << 10);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 162 to 177
	value = ((uint32_t)(input[20] & 0x3f) << 26) |
			((uint32_t)input[21] << 18) |
			((uint32_t)(input[22] & 0xc0) << 10);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 178 to 193
	value = ((uint32_t)(input[22] & 0x3f) << 26) |
			((uint32_t)input[23] << 18) |
			((uint32_t)(input[24] & 0xc0) << 10);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 194 to 209
	value = ((uint32_t)(input[24] & 0x3f) << 26) |
			((uint32_t)input[25] << 18) |
			((uint32_t)(input[26] & 0xc0) << 10);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 210 to 225
	value = ((uint32_t)(input[26] & 0x3f) << 26) |
			((uint32_t)input[27] << 18) |
			((uint32_t)(input[28] & 0xc0) << 10);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 226 to 241
	value = ((uint32_t)(input[28] & 0x3f) << 26) |
			((uint32_t)input[29] << 18) |
			((uint32_t)(input[30] & 0xc0) << 10);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 242 to 257
	value = ((uint32_t)(input[30] & 0x3f) << 26) |
			((uint32_t)input[31] << 18) |
			((uint32_t)(input[32] & 0xc0) << 10);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 258 to 273
	value = ((uint32_t)(input[32] & 0x3f) << 26) |
			((uint32_t)input[33] << 18) |
			((uint32_t)(input[34] & 0xc0) << 10);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 274 to 289
	value = ((uint32_t)(input[34] & 0x3f) << 26) |
			((uint32_t)input[35] << 18) |
			((uint32_t)(input[36] & 0xc0) << 10);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 290 to 305
	value = ((uint32_t)(input[36] & 0x3f) << 26) |
			((uint32_t)input[37] << 18) |
			((uint32_t)(input[38] & 0xc0) << 10);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 306 to 321
	value = ((uint32_t)(input[38] & 0x3f) << 26) |
			((uint32_t)input[39] << 18) |
			((uint32_t)(input[40] & 0xc0) << 10);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 322 to 337
	value = ((uint32_t)(input[40] & 0x3f) << 26) |
			((uint32_t)input[41] << 18) |
			((uint32_t)(input[42] & 0xc0) << 10);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 338 to 353
	value = ((uint32_t)(input[42] & 0x3f) << 26) |
			((uint32_t)input[43] << 18) |
			((uint32_t)(input[44] & 0xc0) << 10);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 354 to 369
	value = ((uint32_t)(input[44] & 0x3f) << 26) |
			((uint32_t)input[45] << 18) |
			((uint32_t)(input[46] & 0xc0) << 10);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 370 to 385
	value = ((uint32_t)(input[46] & 0x3f) << 26) |
			((uint32_t)input[47] << 18) |
			((uint32_t)(input[48] & 0xc0) << 10);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 386 to 401
	value = ((uint32_t)(input[48] & 0x3f) << 26) |
			((uint32_t)input[49] << 18) |
			((uint32_t)(input[50] & 0xc0) << 10);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 402 to 417
	value = ((uint32_t)(input[50] & 0x3f) << 26) |
			((uint32_t)input[51] << 18) |
			((uint32_t)(input[52] & 0xc0) << 10);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 418 to 433
	value = ((uint32_t)(input[52] & 0x3f) << 26) |
			((uint32_t)input[53] << 18) |
			((uint32_t)(input[54] & 0xc0) << 10);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 434 to 449
	value = ((uint32_t)(input[54] & 0x3f) << 26) |
			((uint32_t)input[55] << 18) |
			((uint32_t)(input[56] & 0xc0) << 10);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 450 to 465
	value = ((uint32_t)(input[56] & 0x3f) << 26) |
			((uint32_t)input[57] << 18) |
			((uint32_t)(input[58] & 0xc0) << 10);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 466 to 481
	value = ((uint32_t)(input[58] & 0x3f) << 26) |
			((uint32_t)input[59] << 18) |
			((uint32_t)(input[60] & 0xc0) << 10);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 482 to 497
	value = ((uint32_t)(input[60] & 0x3f) << 26) |
			((uint32_t)input[61] << 18) |
			((uint32_t)(input[62] & 0xc0) << 10);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 498 to 513
	value = ((uint32_t)(input[62] & 0x3f) << 26) |
			((uint32_t)input[63] << 18) |
			((uint32_t)(input[64] & 0xc0) << 10);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 514 to 529
	value = ((uint32_t)(input[64] & 0x3f) << 26) |
			((uint32_t)input[65] << 18) |
			((uint32_t)(input[66] & 0xc0) << 10);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 530 to 545
	value = ((uint32_t)(input[66] & 0x3f) << 26) |
			((uint32_t)input[67] << 18) |
			((uint32_t)(input[68] & 0xc0) << 10);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 546 to 561
	value = ((uint32_t)(input[68] & 0x3f) << 26) |
			((uint32_t)input[69] << 18) |
			((uint32_t)(input[70] & 0xc0) << 10);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 562 to 577
	value = ((uint32_t)(input[70] & 0x3f) << 26) |
			((uint32_t)input[71] << 18) |
			((uint32_t)(input[72] & 0xc0) << 10);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 578 to 593
	value = ((uint32_t)(input[72] & 0x3f) << 26) |
			((uint32_t)input[73] << 18) |
			((uint32_t)(input[74] & 0xc0) << 10);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 594 to 609
	value = ((uint32_t)(input[74] & 0x3f) << 26) |
			((uint32_t)input[75] << 18) |
			((uint32_t)(input[76] & 0xc0) << 10);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 610 to 625
	value = ((uint32_t)(input[76] & 0x3f) << 26) |
			((uint32_t)input[77] << 18) |
			((uint32_t)(input[78] & 0xc0) << 10);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 626 to 641
	value = ((uint32_t)(input[78] & 0x3f) << 26) |
			((uint32_t)input[79] << 18) |
			((uint32_t)(input[80] & 0xc0) << 10);
	output[39] = (double)(value >> 16);

	// read output[40]: from bit 642 to 657
	value = ((uint32_t)(input[80] & 0x3f) << 26) |
			((uint32_t)input[81] << 18) |
			((uint32_t)(input[82] & 0xc0) << 10);
	output[40] = (double)(value >> 16);

	// read output[41]: from bit 658 to 673
	value = ((uint32_t)(input[82] & 0x3f) << 26) |
			((uint32_t)input[83] << 18) |
			((uint32_t)(input[84] & 0xc0) << 10);
	output[41] = (double)(value >> 16);

	// read output[42]: from bit 674 to 689
	value = ((uint32_t)(input[84] & 0x3f) << 26) |
			((uint32_t)input[85] << 18) |
			((uint32_t)(input[86] & 0xc0) << 10);
	output[42] = (double)(value >> 16);

	// read output[43]: from bit 690 to 705
	value = ((uint32_t)(input[86] & 0x3f) << 26) |
			((uint32_t)input[87] << 18) |
			((uint32_t)(input[88] & 0xc0) << 10);
	output[43] = (double)(value >> 16);

	// read output[44]: from bit 706 to 721
	value = ((uint32_t)(input[88] & 0x3f) << 26) |
			((uint32_t)input[89] << 18) |
			((uint32_t)(input[90] & 0xc0) << 10);
	output[44] = (double)(value >> 16);

	// read output[45]: from bit 722 to 737
	value = ((uint32_t)(input[90] & 0x3f) << 26) |
			((uint32_t)input[91] << 18) |
			((uint32_t)(input[92] & 0xc0) << 10);
	output[45] = (double)(value >> 16);

	// read output[46]: from bit 738 to 753
	value = ((uint32_t)(input[92] & 0x3f) << 26) |
			((uint32_t)input[93] << 18) |
			((uint32_t)(input[94] & 0xc0) << 10);
	output[46] = (double)(value >> 16);

	// read output[47]: from bit 754 to 769
	value = ((uint32_t)(input[94] & 0x3f) << 26) |
			((uint32_t)input[95] << 18) |
			((uint32_t)(input[96] & 0xc0) << 10);
	output[47] = (double)(value >> 16);

	// read output[48]: from bit 770 to 785
	value = ((uint32_t)(input[96] & 0x3f) << 26) |
			((uint32_t)input[97] << 18) |
			((uint32_t)(input[98] & 0xc0) << 10);
	output[48] = (double)(value >> 16);

	// read output[49]: from bit 786 to 801
	value = ((uint32_t)(input[98] & 0x3f) << 26) |
			((uint32_t)input[99] << 18) |
			((uint32_t)(input[100] & 0xc0) << 10);
	output[49] = (double)(value >> 16);

	// read output[50]: from bit 802 to 817
	value = ((uint32_t)(input[100] & 0x3f) << 26) |
			((uint32_t)input[101] << 18) |
			((uint32_t)(input[102] & 0xc0) << 10);
	output[50] = (double)(value >> 16);

	// read output[51]: from bit 818 to 833
	value = ((uint32_t)(input[102] & 0x3f) << 26) |
			((uint32_t)input[103] << 18) |
			((uint32_t)(input[104] & 0xc0) << 10);
	output[51] = (double)(value >> 16);

	// read output[52]: from bit 834 to 849
	value = ((uint32_t)(input[104] & 0x3f) << 26) |
			((uint32_t)input[105] << 18) |
			((uint32_t)(input[106] & 0xc0) << 10);
	output[52] = (double)(value >> 16);

	// read output[53]: from bit 850 to 865
	value = ((uint32_t)(input[106] & 0x3f) << 26) |
			((uint32_t)input[107] << 18) |
			((uint32_t)(input[108] & 0xc0) << 10);
	output[53] = (double)(value >> 16);

	// read output[54]: from bit 866 to 881
	value = ((uint32_t)(input[108] & 0x3f) << 26) |
			((uint32_t)input[109] << 18) |
			((uint32_t)(input[110] & 0xc0) << 10);
	output[54] = (double)(value >> 16);

	// read output[55]: from bit 882 to 897
	value = ((uint32_t)(input[110] & 0x3f) << 26) |
			((uint32_t)input[111] << 18) |
			((uint32_t)(input[112] & 0xc0) << 10);
	output[55] = (double)(value >> 16);

	// read output[56]: from bit 898 to 913
	value = ((uint32_t)(input[112] & 0x3f) << 26) |
			((uint32_t)input[113] << 18) |
			((uint32_t)(input[114] & 0xc0) << 10);
	output[56] = (double)(value >> 16);

	// read output[57]: from bit 914 to 929
	value = ((uint32_t)(input[114] & 0x3f) << 26) |
			((uint32_t)input[115] << 18) |
			((uint32_t)(input[116] & 0xc0) << 10);
	output[57] = (double)(value >> 16);

	// read output[58]: from bit 930 to 945
	value = ((uint32_t)(input[116] & 0x3f) << 26) |
			((uint32_t)input[117] << 18) |
			((uint32_t)(input[118] & 0xc0) << 10);
	output[58] = (double)(value >> 16);

	// read output[59]: from bit 946 to 961
	value = ((uint32_t)(input[118] & 0x3f) << 26) |
			((uint32_t)input[119] << 18) |
			((uint32_t)(input[120] & 0xc0) << 10);
	output[59] = (double)(value >> 16);
}

static void unpack_60_16bit_unsigned_2off(const uint8_t * input, double * output, void *closure) {
	// Unpack 60 values into output
	// Values are 16-bit unsigned
	// Skip 2 bits, read 960 bits of data.
	// Input must be at least 121 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 2 to 17
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)input[1] << 18) |
			((uint32_t)(input[2] & 0xc0) << 10);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 18 to 33
	value = ((uint32_t)(input[2] & 0x3f) << 26) |
			((uint32_t)input[3] << 18) |
			((uint32_t)(input[4] & 0xc0) << 10);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 34 to 49
	value = ((uint32_t)(input[4] & 0x3f) << 26) |
			((uint32_t)input[5] << 18) |
			((uint32_t)(input[6] & 0xc0) << 10);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 50 to 65
	value = ((uint32_t)(input[6] & 0x3f) << 26) |
			((uint32_t)input[7] << 18) |
			((uint32_t)(input[8] & 0xc0) << 10);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 66 to 81
	value = ((uint32_t)(input[8] & 0x3f) << 26) |
			((uint32_t)input[9] << 18) |
			((uint32_t)(input[10] & 0xc0) << 10);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 82 to 97
	value = ((uint32_t)(input[10] & 0x3f) << 26) |
			((uint32_t)input[11] << 18) |
			((uint32_t)(input[12] & 0xc0) << 10);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 98 to 113
	value = ((uint32_t)(input[12] & 0x3f) << 26) |
			((uint32_t)input[13] << 18) |
			((uint32_t)(input[14] & 0xc0) << 10);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 114 to 129
	value = ((uint32_t)(input[14] & 0x3f) << 26) |
			((uint32_t)input[15] << 18) |
			((uint32_t)(input[16] & 0xc0) << 10);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 130 to 145
	value = ((uint32_t)(input[16] & 0x3f) << 26) |
			((uint32_t)input[17] << 18) |
			((uint32_t)(input[18] & 0xc0) << 10);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 146 to 161
	value = ((uint32_t)(input[18] & 0x3f) << 26) |
			((uint32_t)input[19] << 18) |
			((uint32_t)(input[20] & 0xc0) << 10);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 162 to 177
	value = ((uint32_t)(input[20] & 0x3f) << 26) |
			((uint32_t)input[21] << 18) |
			((uint32_t)(input[22] & 0xc0) << 10);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 178 to 193
	value = ((uint32_t)(input[22] & 0x3f) << 26) |
			((uint32_t)input[23] << 18) |
			((uint32_t)(input[24] & 0xc0) << 10);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 194 to 209
	value = ((uint32_t)(input[24] & 0x3f) << 26) |
			((uint32_t)input[25] << 18) |
			((uint32_t)(input[26] & 0xc0) << 10);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 210 to 225
	value = ((uint32_t)(input[26] & 0x3f) << 26) |
			((uint32_t)input[27] << 18) |
			((uint32_t)(input[28] & 0xc0) << 10);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 226 to 241
	value = ((uint32_t)(input[28] & 0x3f) << 26) |
			((uint32_t)input[29] << 18) |
			((uint32_t)(input[30] & 0xc0) << 10);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 242 to 257
	value = ((uint32_t)(input[30] & 0x3f) << 26) |
			((uint32_t)input[31] << 18) |
			((uint32_t)(input[32] & 0xc0) << 10);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 258 to 273
	value = ((uint32_t)(input[32] & 0x3f) << 26) |
			((uint32_t)input[33] << 18) |
			((uint32_t)(input[34] & 0xc0) << 10);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 274 to 289
	value = ((uint32_t)(input[34] & 0x3f) << 26) |
			((uint32_t)input[35] << 18) |
			((uint32_t)(input[36] & 0xc0) << 10);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 290 to 305
	value = ((uint32_t)(input[36] & 0x3f) << 26) |
			((uint32_t)input[37] << 18) |
			((uint32_t)(input[38] & 0xc0) << 10);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 306 to 321
	value = ((uint32_t)(input[38] & 0x3f) << 26) |
			((uint32_t)input[39] << 18) |
			((uint32_t)(input[40] & 0xc0) << 10);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 322 to 337
	value = ((uint32_t)(input[40] & 0x3f) << 26) |
			((uint32_t)input[41] << 18) |
			((uint32_t)(input[42] & 0xc0) << 10);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 338 to 353
	value = ((uint32_t)(input[42] & 0x3f) << 26) |
			((uint32_t)input[43] << 18) |
			((uint32_t)(input[44] & 0xc0) << 10);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 354 to 369
	value = ((uint32_t)(input[44] & 0x3f) << 26) |
			((uint32_t)input[45] << 18) |
			((uint32_t)(input[46] & 0xc0) << 10);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 370 to 385
	value = ((uint32_t)(input[46] & 0x3f) << 26) |
			((uint32_t)input[47] << 18) |
			((uint32_t)(input[48] & 0xc0) << 10);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 386 to 401
	value = ((uint32_t)(input[48] & 0x3f) << 26) |
			((uint32_t)input[49] << 18) |
			((uint32_t)(input[50] & 0xc0) << 10);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 402 to 417
	value = ((uint32_t)(input[50] & 0x3f) << 26) |
			((uint32_t)input[51] << 18) |
			((uint32_t)(input[52] & 0xc0) << 10);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 418 to 433
	value = ((uint32_t)(input[52] & 0x3f) << 26) |
			((uint32_t)input[53] << 18) |
			((uint32_t)(input[54] & 0xc0) << 10);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 434 to 449
	value = ((uint32_t)(input[54] & 0x3f) << 26) |
			((uint32_t)input[55] << 18) |
			((uint32_t)(input[56] & 0xc0) << 10);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 450 to 465
	value = ((uint32_t)(input[56] & 0x3f) << 26) |
			((uint32_t)input[57] << 18) |
			((uint32_t)(input[58] & 0xc0) << 10);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 466 to 481
	value = ((uint32_t)(input[58] & 0x3f) << 26) |
			((uint32_t)input[59] << 18) |
			((uint32_t)(input[60] & 0xc0) << 10);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 482 to 497
	value = ((uint32_t)(input[60] & 0x3f) << 26) |
			((uint32_t)input[61] << 18) |
			((uint32_t)(input[62] & 0xc0) << 10);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 498 to 513
	value = ((uint32_t)(input[62] & 0x3f) << 26) |
			((uint32_t)input[63] << 18) |
			((uint32_t)(input[64] & 0xc0) << 10);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 514 to 529
	value = ((uint32_t)(input[64] & 0x3f) << 26) |
			((uint32_t)input[65] << 18) |
			((uint32_t)(input[66] & 0xc0) << 10);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 530 to 545
	value = ((uint32_t)(input[66] & 0x3f) << 26) |
			((uint32_t)input[67] << 18) |
			((uint32_t)(input[68] & 0xc0) << 10);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 546 to 561
	value = ((uint32_t)(input[68] & 0x3f) << 26) |
			((uint32_t)input[69] << 18) |
			((uint32_t)(input[70] & 0xc0) << 10);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 562 to 577
	value = ((uint32_t)(input[70] & 0x3f) << 26) |
			((uint32_t)input[71] << 18) |
			((uint32_t)(input[72] & 0xc0) << 10);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 578 to 593
	value = ((uint32_t)(input[72] & 0x3f) << 26) |
			((uint32_t)input[73] << 18) |
			((uint32_t)(input[74] & 0xc0) << 10);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 594 to 609
	value = ((uint32_t)(input[74] & 0x3f) << 26) |
			((uint32_t)input[75] << 18) |
			((uint32_t)(input[76] & 0xc0) << 10);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 610 to 625
	value = ((uint32_t)(input[76] & 0x3f) << 26) |
			((uint32_t)input[77] << 18) |
			((uint32_t)(input[78] & 0xc0) << 10);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 626 to 641
	value = ((uint32_t)(input[78] & 0x3f) << 26) |
			((uint32_t)input[79] << 18) |
			((uint32_t)(input[80] & 0xc0) << 10);
	output[39] = (double)(value >> 16);

	// read output[40]: from bit 642 to 657
	value = ((uint32_t)(input[80] & 0x3f) << 26) |
			((uint32_t)input[81] << 18) |
			((uint32_t)(input[82] & 0xc0) << 10);
	output[40] = (double)(value >> 16);

	// read output[41]: from bit 658 to 673
	value = ((uint32_t)(input[82] & 0x3f) << 26) |
			((uint32_t)input[83] << 18) |
			((uint32_t)(input[84] & 0xc0) << 10);
	output[41] = (double)(value >> 16);

	// read output[42]: from bit 674 to 689
	value = ((uint32_t)(input[84] & 0x3f) << 26) |
			((uint32_t)input[85] << 18) |
			((uint32_t)(input[86] & 0xc0) << 10);
	output[42] = (double)(value >> 16);

	// read output[43]: from bit 690 to 705
	value = ((uint32_t)(input[86] & 0x3f) << 26) |
			((uint32_t)input[87] << 18) |
			((uint32_t)(input[88] & 0xc0) << 10);
	output[43] = (double)(value >> 16);

	// read output[44]: from bit 706 to 721
	value = ((uint32_t)(input[88] & 0x3f) << 26) |
			((uint32_t)input[89] << 18) |
			((uint32_t)(input[90] & 0xc0) << 10);
	output[44] = (double)(value >> 16);

	// read output[45]: from bit 722 to 737
	value = ((uint32_t)(input[90] & 0x3f) << 26) |
			((uint32_t)input[91] << 18) |
			((uint32_t)(input[92] & 0xc0) << 10);
	output[45] = (double)(value >> 16);

	// read output[46]: from bit 738 to 753
	value = ((uint32_t)(input[92] & 0x3f) << 26) |
			((uint32_t)input[93] << 18) |
			((uint32_t)(input[94] & 0xc0) << 10);
	output[46] = (double)(value >> 16);

	// read output[47]: from bit 754 to 769
	value = ((uint32_t)(input[94] & 0x3f) << 26) |
			((uint32_t)input[95] << 18) |
			((uint32_t)(input[96] & 0xc0) << 10);
	output[47] = (double)(value >> 16);

	// read output[48]: from bit 770 to 785
	value = ((uint32_t)(input[96] & 0x3f) << 26) |
			((uint32_t)input[97] << 18) |
			((uint32_t)(input[98] & 0xc0) << 10);
	output[48] = (double)(value >> 16);

	// read output[49]: from bit 786 to 801
	value = ((uint32_t)(input[98] & 0x3f) << 26) |
			((uint32_t)input[99] << 18) |
			((uint32_t)(input[100] & 0xc0) << 10);
	output[49] = (double)(value >> 16);

	// read output[50]: from bit 802 to 817
	value = ((uint32_t)(input[100] & 0x3f) << 26) |
			((uint32_t)input[101] << 18) |
			((uint32_t)(input[102] & 0xc0) << 10);
	output[50] = (double)(value >> 16);

	// read output[51]: from bit 818 to 833
	value = ((uint32_t)(input[102] & 0x3f) << 26) |
			((uint32_t)input[103] << 18) |
			((uint32_t)(input[104] & 0xc0) << 10);
	output[51] = (double)(value >> 16);

	// read output[52]: from bit 834 to 849
	value = ((uint32_t)(input[104] & 0x3f) << 26) |
			((uint32_t)input[105] << 18) |
			((uint32_t)(input[106] & 0xc0) << 10);
	output[52] = (double)(value >> 16);

	// read output[53]: from bit 850 to 865
	value = ((uint32_t)(input[106] & 0x3f) << 26) |
			((uint32_t)input[107] << 18) |
			((uint32_t)(input[108] & 0xc0) << 10);
	output[53] = (double)(value >> 16);

	// read output[54]: from bit 866 to 881
	value = ((uint32_t)(input[108] & 0x3f) << 26) |
			((uint32_t)input[109] << 18) |
			((uint32_t)(input[110] & 0xc0) << 10);
	output[54] = (double)(value >> 16);

	// read output[55]: from bit 882 to 897
	value = ((uint32_t)(input[110] & 0x3f) << 26) |
			((uint32_t)input[111] << 18) |
			((uint32_t)(input[112] & 0xc0) << 10);
	output[55] = (double)(value >> 16);

	// read output[56]: from bit 898 to 913
	value = ((uint32_t)(input[112] & 0x3f) << 26) |
			((uint32_t)input[113] << 18) |
			((uint32_t)(input[114] & 0xc0) << 10);
	output[56] = (double)(value >> 16);

	// read output[57]: from bit 914 to 929
	value = ((uint32_t)(input[114] & 0x3f) << 26) |
			((uint32_t)input[115] << 18) |
			((uint32_t)(input[116] & 0xc0) << 10);
	output[57] = (double)(value >> 16);

	// read output[58]: from bit 930 to 945
	value = ((uint32_t)(input[116] & 0x3f) << 26) |
			((uint32_t)input[117] << 18) |
			((uint32_t)(input[118] & 0xc0) << 10);
	output[58] = (double)(value >> 16);

	// read output[59]: from bit 946 to 961
	value = ((uint32_t)(input[118] & 0x3f) << 26) |
			((uint32_t)input[119] << 18) |
			((uint32_t)(input[120] & 0xc0) << 10);
	output[59] = (double)(value >> 16);
}

static void unpack_60_16bit_signed_3off(const uint8_t * input, double * output, void *closure) {
	// Unpack 60 values into output
	// Values are 16-bit signed
	// Skip 3 bits, read 960 bits of data.
	// Input must be at least 121 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 3 to 18
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)input[1] << 19) |
			((uint32_t)(input[2] & 0xe0) << 11);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 19 to 34
	value = ((uint32_t)(input[2] & 0x1f) << 27) |
			((uint32_t)input[3] << 19) |
			((uint32_t)(input[4] & 0xe0) << 11);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 35 to 50
	value = ((uint32_t)(input[4] & 0x1f) << 27) |
			((uint32_t)input[5] << 19) |
			((uint32_t)(input[6] & 0xe0) << 11);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 51 to 66
	value = ((uint32_t)(input[6] & 0x1f) << 27) |
			((uint32_t)input[7] << 19) |
			((uint32_t)(input[8] & 0xe0) << 11);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 67 to 82
	value = ((uint32_t)(input[8] & 0x1f) << 27) |
			((uint32_t)input[9] << 19) |
			((uint32_t)(input[10] & 0xe0) << 11);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 83 to 98
	value = ((uint32_t)(input[10] & 0x1f) << 27) |
			((uint32_t)input[11] << 19) |
			((uint32_t)(input[12] & 0xe0) << 11);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 99 to 114
	value = ((uint32_t)(input[12] & 0x1f) << 27) |
			((uint32_t)input[13] << 19) |
			((uint32_t)(input[14] & 0xe0) << 11);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 115 to 130
	value = ((uint32_t)(input[14] & 0x1f) << 27) |
			((uint32_t)input[15] << 19) |
			((uint32_t)(input[16] & 0xe0) << 11);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 131 to 146
	value = ((uint32_t)(input[16] & 0x1f) << 27) |
			((uint32_t)input[17] << 19) |
			((uint32_t)(input[18] & 0xe0) << 11);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 147 to 162
	value = ((uint32_t)(input[18] & 0x1f) << 27) |
			((uint32_t)input[19] << 19) |
			((uint32_t)(input[20] & 0xe0) << 11);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 163 to 178
	value = ((uint32_t)(input[20] & 0x1f) << 27) |
			((uint32_t)input[21] << 19) |
			((uint32_t)(input[22] & 0xe0) << 11);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 179 to 194
	value = ((uint32_t)(input[22] & 0x1f) << 27) |
			((uint32_t)input[23] << 19) |
			((uint32_t)(input[24] & 0xe0) << 11);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 195 to 210
	value = ((uint32_t)(input[24] & 0x1f) << 27) |
			((uint32_t)input[25] << 19) |
			((uint32_t)(input[26] & 0xe0) << 11);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 211 to 226
	value = ((uint32_t)(input[26] & 0x1f) << 27) |
			((uint32_t)input[27] << 19) |
			((uint32_t)(input[28] & 0xe0) << 11);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 227 to 242
	value = ((uint32_t)(input[28] & 0x1f) << 27) |
			((uint32_t)input[29] << 19) |
			((uint32_t)(input[30] & 0xe0) << 11);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 243 to 258
	value = ((uint32_t)(input[30] & 0x1f) << 27) |
			((uint32_t)input[31] << 19) |
			((uint32_t)(input[32] & 0xe0) << 11);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 259 to 274
	value = ((uint32_t)(input[32] & 0x1f) << 27) |
			((uint32_t)input[33] << 19) |
			((uint32_t)(input[34] & 0xe0) << 11);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 275 to 290
	value = ((uint32_t)(input[34] & 0x1f) << 27) |
			((uint32_t)input[35] << 19) |
			((uint32_t)(input[36] & 0xe0) << 11);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 291 to 306
	value = ((uint32_t)(input[36] & 0x1f) << 27) |
			((uint32_t)input[37] << 19) |
			((uint32_t)(input[38] & 0xe0) << 11);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 307 to 322
	value = ((uint32_t)(input[38] & 0x1f) << 27) |
			((uint32_t)input[39] << 19) |
			((uint32_t)(input[40] & 0xe0) << 11);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 323 to 338
	value = ((uint32_t)(input[40] & 0x1f) << 27) |
			((uint32_t)input[41] << 19) |
			((uint32_t)(input[42] & 0xe0) << 11);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 339 to 354
	value = ((uint32_t)(input[42] & 0x1f) << 27) |
			((uint32_t)input[43] << 19) |
			((uint32_t)(input[44] & 0xe0) << 11);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 355 to 370
	value = ((uint32_t)(input[44] & 0x1f) << 27) |
			((uint32_t)input[45] << 19) |
			((uint32_t)(input[46] & 0xe0) << 11);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 371 to 386
	value = ((uint32_t)(input[46] & 0x1f) << 27) |
			((uint32_t)input[47] << 19) |
			((uint32_t)(input[48] & 0xe0) << 11);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 387 to 402
	value = ((uint32_t)(input[48] & 0x1f) << 27) |
			((uint32_t)input[49] << 19) |
			((uint32_t)(input[50] & 0xe0) << 11);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 403 to 418
	value = ((uint32_t)(input[50] & 0x1f) << 27) |
			((uint32_t)input[51] << 19) |
			((uint32_t)(input[52] & 0xe0) << 11);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 419 to 434
	value = ((uint32_t)(input[52] & 0x1f) << 27) |
			((uint32_t)input[53] << 19) |
			((uint32_t)(input[54] & 0xe0) << 11);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 435 to 450
	value = ((uint32_t)(input[54] & 0x1f) << 27) |
			((uint32_t)input[55] << 19) |
			((uint32_t)(input[56] & 0xe0) << 11);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 451 to 466
	value = ((uint32_t)(input[56] & 0x1f) << 27) |
			((uint32_t)input[57] << 19) |
			((uint32_t)(input[58] & 0xe0) << 11);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 467 to 482
	value = ((uint32_t)(input[58] & 0x1f) << 27) |
			((uint32_t)input[59] << 19) |
			((uint32_t)(input[60] & 0xe0) << 11);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 483 to 498
	value = ((uint32_t)(input[60] & 0x1f) << 27) |
			((uint32_t)input[61] << 19) |
			((uint32_t)(input[62] & 0xe0) << 11);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 499 to 514
	value = ((uint32_t)(input[62] & 0x1f) << 27) |
			((uint32_t)input[63] << 19) |
			((uint32_t)(input[64] & 0xe0) << 11);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 515 to 530
	value = ((uint32_t)(input[64] & 0x1f) << 27) |
			((uint32_t)input[65] << 19) |
			((uint32_t)(input[66] & 0xe0) << 11);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 531 to 546
	value = ((uint32_t)(input[66] & 0x1f) << 27) |
			((uint32_t)input[67] << 19) |
			((uint32_t)(input[68] & 0xe0) << 11);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 547 to 562
	value = ((uint32_t)(input[68] & 0x1f) << 27) |
			((uint32_t)input[69] << 19) |
			((uint32_t)(input[70] & 0xe0) << 11);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 563 to 578
	value = ((uint32_t)(input[70] & 0x1f) << 27) |
			((uint32_t)input[71] << 19) |
			((uint32_t)(input[72] & 0xe0) << 11);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 579 to 594
	value = ((uint32_t)(input[72] & 0x1f) << 27) |
			((uint32_t)input[73] << 19) |
			((uint32_t)(input[74] & 0xe0) << 11);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 595 to 610
	value = ((uint32_t)(input[74] & 0x1f) << 27) |
			((uint32_t)input[75] << 19) |
			((uint32_t)(input[76] & 0xe0) << 11);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 611 to 626
	value = ((uint32_t)(input[76] & 0x1f) << 27) |
			((uint32_t)input[77] << 19) |
			((uint32_t)(input[78] & 0xe0) << 11);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 627 to 642
	value = ((uint32_t)(input[78] & 0x1f) << 27) |
			((uint32_t)input[79] << 19) |
			((uint32_t)(input[80] & 0xe0) << 11);
	output[39] = (double)(value >> 16);

	// read output[40]: from bit 643 to 658
	value = ((uint32_t)(input[80] & 0x1f) << 27) |
			((uint32_t)input[81] << 19) |
			((uint32_t)(input[82] & 0xe0) << 11);
	output[40] = (double)(value >> 16);

	// read output[41]: from bit 659 to 674
	value = ((uint32_t)(input[82] & 0x1f) << 27) |
			((uint32_t)input[83] << 19) |
			((uint32_t)(input[84] & 0xe0) << 11);
	output[41] = (double)(value >> 16);

	// read output[42]: from bit 675 to 690
	value = ((uint32_t)(input[84] & 0x1f) << 27) |
			((uint32_t)input[85] << 19) |
			((uint32_t)(input[86] & 0xe0) << 11);
	output[42] = (double)(value >> 16);

	// read output[43]: from bit 691 to 706
	value = ((uint32_t)(input[86] & 0x1f) << 27) |
			((uint32_t)input[87] << 19) |
			((uint32_t)(input[88] & 0xe0) << 11);
	output[43] = (double)(value >> 16);

	// read output[44]: from bit 707 to 722
	value = ((uint32_t)(input[88] & 0x1f) << 27) |
			((uint32_t)input[89] << 19) |
			((uint32_t)(input[90] & 0xe0) << 11);
	output[44] = (double)(value >> 16);

	// read output[45]: from bit 723 to 738
	value = ((uint32_t)(input[90] & 0x1f) << 27) |
			((uint32_t)input[91] << 19) |
			((uint32_t)(input[92] & 0xe0) << 11);
	output[45] = (double)(value >> 16);

	// read output[46]: from bit 739 to 754
	value = ((uint32_t)(input[92] & 0x1f) << 27) |
			((uint32_t)input[93] << 19) |
			((uint32_t)(input[94] & 0xe0) << 11);
	output[46] = (double)(value >> 16);

	// read output[47]: from bit 755 to 770
	value = ((uint32_t)(input[94] & 0x1f) << 27) |
			((uint32_t)input[95] << 19) |
			((uint32_t)(input[96] & 0xe0) << 11);
	output[47] = (double)(value >> 16);

	// read output[48]: from bit 771 to 786
	value = ((uint32_t)(input[96] & 0x1f) << 27) |
			((uint32_t)input[97] << 19) |
			((uint32_t)(input[98] & 0xe0) << 11);
	output[48] = (double)(value >> 16);

	// read output[49]: from bit 787 to 802
	value = ((uint32_t)(input[98] & 0x1f) << 27) |
			((uint32_t)input[99] << 19) |
			((uint32_t)(input[100] & 0xe0) << 11);
	output[49] = (double)(value >> 16);

	// read output[50]: from bit 803 to 818
	value = ((uint32_t)(input[100] & 0x1f) << 27) |
			((uint32_t)input[101] << 19) |
			((uint32_t)(input[102] & 0xe0) << 11);
	output[50] = (double)(value >> 16);

	// read output[51]: from bit 819 to 834
	value = ((uint32_t)(input[102] & 0x1f) << 27) |
			((uint32_t)input[103] << 19) |
			((uint32_t)(input[104] & 0xe0) << 11);
	output[51] = (double)(value >> 16);

	// read output[52]: from bit 835 to 850
	value = ((uint32_t)(input[104] & 0x1f) << 27) |
			((uint32_t)input[105] << 19) |
			((uint32_t)(input[106] & 0xe0) << 11);
	output[52] = (double)(value >> 16);

	// read output[53]: from bit 851 to 866
	value = ((uint32_t)(input[106] & 0x1f) << 27) |
			((uint32_t)input[107] << 19) |
			((uint32_t)(input[108] & 0xe0) << 11);
	output[53] = (double)(value >> 16);

	// read output[54]: from bit 867 to 882
	value = ((uint32_t)(input[108] & 0x1f) << 27) |
			((uint32_t)input[109] << 19) |
			((uint32_t)(input[110] & 0xe0) << 11);
	output[54] = (double)(value >> 16);

	// read output[55]: from bit 883 to 898
	value = ((uint32_t)(input[110] & 0x1f) << 27) |
			((uint32_t)input[111] << 19) |
			((uint32_t)(input[112] & 0xe0) << 11);
	output[55] = (double)(value >> 16);

	// read output[56]: from bit 899 to 914
	value = ((uint32_t)(input[112] & 0x1f) << 27) |
			((uint32_t)input[113] << 19) |
			((uint32_t)(input[114] & 0xe0) << 11);
	output[56] = (double)(value >> 16);

	// read output[57]: from bit 915 to 930
	value = ((uint32_t)(input[114] & 0x1f) << 27) |
			((uint32_t)input[115] << 19) |
			((uint32_t)(input[116] & 0xe0) << 11);
	output[57] = (double)(value >> 16);

	// read output[58]: from bit 931 to 946
	value = ((uint32_t)(input[116] & 0x1f) << 27) |
			((uint32_t)input[117] << 19) |
			((uint32_t)(input[118] & 0xe0) << 11);
	output[58] = (double)(value >> 16);

	// read output[59]: from bit 947 to 962
	value = ((uint32_t)(input[118] & 0x1f) << 27) |
			((uint32_t)input[119] << 19) |
			((uint32_t)(input[120] & 0xe0) << 11);
	output[59] = (double)(value >> 16);
}

static void unpack_60_16bit_unsigned_3off(const uint8_t * input, double * output, void *closure) {
	// Unpack 60 values into output
	// Values are 16-bit unsigned
	// Skip 3 bits, read 960 bits of data.
	// Input must be at least 121 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 3 to 18
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)input[1] << 19) |
			((uint32_t)(input[2] & 0xe0) << 11);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 19 to 34
	value = ((uint32_t)(input[2] & 0x1f) << 27) |
			((uint32_t)input[3] << 19) |
			((uint32_t)(input[4] & 0xe0) << 11);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 35 to 50
	value = ((uint32_t)(input[4] & 0x1f) << 27) |
			((uint32_t)input[5] << 19) |
			((uint32_t)(input[6] & 0xe0) << 11);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 51 to 66
	value = ((uint32_t)(input[6] & 0x1f) << 27) |
			((uint32_t)input[7] << 19) |
			((uint32_t)(input[8] & 0xe0) << 11);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 67 to 82
	value = ((uint32_t)(input[8] & 0x1f) << 27) |
			((uint32_t)input[9] << 19) |
			((uint32_t)(input[10] & 0xe0) << 11);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 83 to 98
	value = ((uint32_t)(input[10] & 0x1f) << 27) |
			((uint32_t)input[11] << 19) |
			((uint32_t)(input[12] & 0xe0) << 11);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 99 to 114
	value = ((uint32_t)(input[12] & 0x1f) << 27) |
			((uint32_t)input[13] << 19) |
			((uint32_t)(input[14] & 0xe0) << 11);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 115 to 130
	value = ((uint32_t)(input[14] & 0x1f) << 27) |
			((uint32_t)input[15] << 19) |
			((uint32_t)(input[16] & 0xe0) << 11);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 131 to 146
	value = ((uint32_t)(input[16] & 0x1f) << 27) |
			((uint32_t)input[17] << 19) |
			((uint32_t)(input[18] & 0xe0) << 11);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 147 to 162
	value = ((uint32_t)(input[18] & 0x1f) << 27) |
			((uint32_t)input[19] << 19) |
			((uint32_t)(input[20] & 0xe0) << 11);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 163 to 178
	value = ((uint32_t)(input[20] & 0x1f) << 27) |
			((uint32_t)input[21] << 19) |
			((uint32_t)(input[22] & 0xe0) << 11);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 179 to 194
	value = ((uint32_t)(input[22] & 0x1f) << 27) |
			((uint32_t)input[23] << 19) |
			((uint32_t)(input[24] & 0xe0) << 11);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 195 to 210
	value = ((uint32_t)(input[24] & 0x1f) << 27) |
			((uint32_t)input[25] << 19) |
			((uint32_t)(input[26] & 0xe0) << 11);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 211 to 226
	value = ((uint32_t)(input[26] & 0x1f) << 27) |
			((uint32_t)input[27] << 19) |
			((uint32_t)(input[28] & 0xe0) << 11);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 227 to 242
	value = ((uint32_t)(input[28] & 0x1f) << 27) |
			((uint32_t)input[29] << 19) |
			((uint32_t)(input[30] & 0xe0) << 11);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 243 to 258
	value = ((uint32_t)(input[30] & 0x1f) << 27) |
			((uint32_t)input[31] << 19) |
			((uint32_t)(input[32] & 0xe0) << 11);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 259 to 274
	value = ((uint32_t)(input[32] & 0x1f) << 27) |
			((uint32_t)input[33] << 19) |
			((uint32_t)(input[34] & 0xe0) << 11);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 275 to 290
	value = ((uint32_t)(input[34] & 0x1f) << 27) |
			((uint32_t)input[35] << 19) |
			((uint32_t)(input[36] & 0xe0) << 11);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 291 to 306
	value = ((uint32_t)(input[36] & 0x1f) << 27) |
			((uint32_t)input[37] << 19) |
			((uint32_t)(input[38] & 0xe0) << 11);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 307 to 322
	value = ((uint32_t)(input[38] & 0x1f) << 27) |
			((uint32_t)input[39] << 19) |
			((uint32_t)(input[40] & 0xe0) << 11);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 323 to 338
	value = ((uint32_t)(input[40] & 0x1f) << 27) |
			((uint32_t)input[41] << 19) |
			((uint32_t)(input[42] & 0xe0) << 11);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 339 to 354
	value = ((uint32_t)(input[42] & 0x1f) << 27) |
			((uint32_t)input[43] << 19) |
			((uint32_t)(input[44] & 0xe0) << 11);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 355 to 370
	value = ((uint32_t)(input[44] & 0x1f) << 27) |
			((uint32_t)input[45] << 19) |
			((uint32_t)(input[46] & 0xe0) << 11);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 371 to 386
	value = ((uint32_t)(input[46] & 0x1f) << 27) |
			((uint32_t)input[47] << 19) |
			((uint32_t)(input[48] & 0xe0) << 11);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 387 to 402
	value = ((uint32_t)(input[48] & 0x1f) << 27) |
			((uint32_t)input[49] << 19) |
			((uint32_t)(input[50] & 0xe0) << 11);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 403 to 418
	value = ((uint32_t)(input[50] & 0x1f) << 27) |
			((uint32_t)input[51] << 19) |
			((uint32_t)(input[52] & 0xe0) << 11);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 419 to 434
	value = ((uint32_t)(input[52] & 0x1f) << 27) |
			((uint32_t)input[53] << 19) |
			((uint32_t)(input[54] & 0xe0) << 11);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 435 to 450
	value = ((uint32_t)(input[54] & 0x1f) << 27) |
			((uint32_t)input[55] << 19) |
			((uint32_t)(input[56] & 0xe0) << 11);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 451 to 466
	value = ((uint32_t)(input[56] & 0x1f) << 27) |
			((uint32_t)input[57] << 19) |
			((uint32_t)(input[58] & 0xe0) << 11);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 467 to 482
	value = ((uint32_t)(input[58] & 0x1f) << 27) |
			((uint32_t)input[59] << 19) |
			((uint32_t)(input[60] & 0xe0) << 11);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 483 to 498
	value = ((uint32_t)(input[60] & 0x1f) << 27) |
			((uint32_t)input[61] << 19) |
			((uint32_t)(input[62] & 0xe0) << 11);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 499 to 514
	value = ((uint32_t)(input[62] & 0x1f) << 27) |
			((uint32_t)input[63] << 19) |
			((uint32_t)(input[64] & 0xe0) << 11);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 515 to 530
	value = ((uint32_t)(input[64] & 0x1f) << 27) |
			((uint32_t)input[65] << 19) |
			((uint32_t)(input[66] & 0xe0) << 11);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 531 to 546
	value = ((uint32_t)(input[66] & 0x1f) << 27) |
			((uint32_t)input[67] << 19) |
			((uint32_t)(input[68] & 0xe0) << 11);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 547 to 562
	value = ((uint32_t)(input[68] & 0x1f) << 27) |
			((uint32_t)input[69] << 19) |
			((uint32_t)(input[70] & 0xe0) << 11);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 563 to 578
	value = ((uint32_t)(input[70] & 0x1f) << 27) |
			((uint32_t)input[71] << 19) |
			((uint32_t)(input[72] & 0xe0) << 11);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 579 to 594
	value = ((uint32_t)(input[72] & 0x1f) << 27) |
			((uint32_t)input[73] << 19) |
			((uint32_t)(input[74] & 0xe0) << 11);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 595 to 610
	value = ((uint32_t)(input[74] & 0x1f) << 27) |
			((uint32_t)input[75] << 19) |
			((uint32_t)(input[76] & 0xe0) << 11);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 611 to 626
	value = ((uint32_t)(input[76] & 0x1f) << 27) |
			((uint32_t)input[77] << 19) |
			((uint32_t)(input[78] & 0xe0) << 11);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 627 to 642
	value = ((uint32_t)(input[78] & 0x1f) << 27) |
			((uint32_t)input[79] << 19) |
			((uint32_t)(input[80] & 0xe0) << 11);
	output[39] = (double)(value >> 16);

	// read output[40]: from bit 643 to 658
	value = ((uint32_t)(input[80] & 0x1f) << 27) |
			((uint32_t)input[81] << 19) |
			((uint32_t)(input[82] & 0xe0) << 11);
	output[40] = (double)(value >> 16);

	// read output[41]: from bit 659 to 674
	value = ((uint32_t)(input[82] & 0x1f) << 27) |
			((uint32_t)input[83] << 19) |
			((uint32_t)(input[84] & 0xe0) << 11);
	output[41] = (double)(value >> 16);

	// read output[42]: from bit 675 to 690
	value = ((uint32_t)(input[84] & 0x1f) << 27) |
			((uint32_t)input[85] << 19) |
			((uint32_t)(input[86] & 0xe0) << 11);
	output[42] = (double)(value >> 16);

	// read output[43]: from bit 691 to 706
	value = ((uint32_t)(input[86] & 0x1f) << 27) |
			((uint32_t)input[87] << 19) |
			((uint32_t)(input[88] & 0xe0) << 11);
	output[43] = (double)(value >> 16);

	// read output[44]: from bit 707 to 722
	value = ((uint32_t)(input[88] & 0x1f) << 27) |
			((uint32_t)input[89] << 19) |
			((uint32_t)(input[90] & 0xe0) << 11);
	output[44] = (double)(value >> 16);

	// read output[45]: from bit 723 to 738
	value = ((uint32_t)(input[90] & 0x1f) << 27) |
			((uint32_t)input[91] << 19) |
			((uint32_t)(input[92] & 0xe0) << 11);
	output[45] = (double)(value >> 16);

	// read output[46]: from bit 739 to 754
	value = ((uint32_t)(input[92] & 0x1f) << 27) |
			((uint32_t)input[93] << 19) |
			((uint32_t)(input[94] & 0xe0) << 11);
	output[46] = (double)(value >> 16);

	// read output[47]: from bit 755 to 770
	value = ((uint32_t)(input[94] & 0x1f) << 27) |
			((uint32_t)input[95] << 19) |
			((uint32_t)(input[96] & 0xe0) << 11);
	output[47] = (double)(value >> 16);

	// read output[48]: from bit 771 to 786
	value = ((uint32_t)(input[96] & 0x1f) << 27) |
			((uint32_t)input[97] << 19) |
			((uint32_t)(input[98] & 0xe0) << 11);
	output[48] = (double)(value >> 16);

	// read output[49]: from bit 787 to 802
	value = ((uint32_t)(input[98] & 0x1f) << 27) |
			((uint32_t)input[99] << 19) |
			((uint32_t)(input[100] & 0xe0) << 11);
	output[49] = (double)(value >> 16);

	// read output[50]: from bit 803 to 818
	value = ((uint32_t)(input[100] & 0x1f) << 27) |
			((uint32_t)input[101] << 19) |
			((uint32_t)(input[102] & 0xe0) << 11);
	output[50] = (double)(value >> 16);

	// read output[51]: from bit 819 to 834
	value = ((uint32_t)(input[102] & 0x1f) << 27) |
			((uint32_t)input[103] << 19) |
			((uint32_t)(input[104] & 0xe0) << 11);
	output[51] = (double)(value >> 16);

	// read output[52]: from bit 835 to 850
	value = ((uint32_t)(input[104] & 0x1f) << 27) |
			((uint32_t)input[105] << 19) |
			((uint32_t)(input[106] & 0xe0) << 11);
	output[52] = (double)(value >> 16);

	// read output[53]: from bit 851 to 866
	value = ((uint32_t)(input[106] & 0x1f) << 27) |
			((uint32_t)input[107] << 19) |
			((uint32_t)(input[108] & 0xe0) << 11);
	output[53] = (double)(value >> 16);

	// read output[54]: from bit 867 to 882
	value = ((uint32_t)(input[108] & 0x1f) << 27) |
			((uint32_t)input[109] << 19) |
			((uint32_t)(input[110] & 0xe0) << 11);
	output[54] = (double)(value >> 16);

	// read output[55]: from bit 883 to 898
	value = ((uint32_t)(input[110] & 0x1f) << 27) |
			((uint32_t)input[111] << 19) |
			((uint32_t)(input[112] & 0xe0) << 11);
	output[55] = (double)(value >> 16);

	// read output[56]: from bit 899 to 914
	value = ((uint32_t)(input[112] & 0x1f) << 27) |
			((uint32_t)input[113] << 19) |
			((uint32_t)(input[114] & 0xe0) << 11);
	output[56] = (double)(value >> 16);

	// read output[57]: from bit 915 to 930
	value = ((uint32_t)(input[114] & 0x1f) << 27) |
			((uint32_t)input[115] << 19) |
			((uint32_t)(input[116] & 0xe0) << 11);
	output[57] = (double)(value >> 16);

	// read output[58]: from bit 931 to 946
	value = ((uint32_t)(input[116] & 0x1f) << 27) |
			((uint32_t)input[117] << 19) |
			((uint32_t)(input[118] & 0xe0) << 11);
	output[58] = (double)(value >> 16);

	// read output[59]: from bit 947 to 962
	value = ((uint32_t)(input[118] & 0x1f) << 27) |
			((uint32_t)input[119] << 19) |
			((uint32_t)(input[120] & 0xe0) << 11);
	output[59] = (double)(value >> 16);
}

static void unpack_60_16bit_signed_4off(const uint8_t * input, double * output, void *closure) {
	// Unpack 60 values into output
	// Values are 16-bit signed
	// Skip 4 bits, read 960 bits of data.
	// Input must be at least 121 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 4 to 19
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20) |
			((uint32_t)(input[2] & 0xf0) << 12);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 20 to 35
	value = ((uint32_t)(input[2] & 0x0f) << 28) |
			((uint32_t)input[3] << 20) |
			((uint32_t)(input[4] & 0xf0) << 12);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 36 to 51
	value = ((uint32_t)(input[4] & 0x0f) << 28) |
			((uint32_t)input[5] << 20) |
			((uint32_t)(input[6] & 0xf0) << 12);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 52 to 67
	value = ((uint32_t)(input[6] & 0x0f) << 28) |
			((uint32_t)input[7] << 20) |
			((uint32_t)(input[8] & 0xf0) << 12);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 68 to 83
	value = ((uint32_t)(input[8] & 0x0f) << 28) |
			((uint32_t)input[9] << 20) |
			((uint32_t)(input[10] & 0xf0) << 12);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 84 to 99
	value = ((uint32_t)(input[10] & 0x0f) << 28) |
			((uint32_t)input[11] << 20) |
			((uint32_t)(input[12] & 0xf0) << 12);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 100 to 115
	value = ((uint32_t)(input[12] & 0x0f) << 28) |
			((uint32_t)input[13] << 20) |
			((uint32_t)(input[14] & 0xf0) << 12);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 116 to 131
	value = ((uint32_t)(input[14] & 0x0f) << 28) |
			((uint32_t)input[15] << 20) |
			((uint32_t)(input[16] & 0xf0) << 12);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 132 to 147
	value = ((uint32_t)(input[16] & 0x0f) << 28) |
			((uint32_t)input[17] << 20) |
			((uint32_t)(input[18] & 0xf0) << 12);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 148 to 163
	value = ((uint32_t)(input[18] & 0x0f) << 28) |
			((uint32_t)input[19] << 20) |
			((uint32_t)(input[20] & 0xf0) << 12);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 164 to 179
	value = ((uint32_t)(input[20] & 0x0f) << 28) |
			((uint32_t)input[21] << 20) |
			((uint32_t)(input[22] & 0xf0) << 12);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 180 to 195
	value = ((uint32_t)(input[22] & 0x0f) << 28) |
			((uint32_t)input[23] << 20) |
			((uint32_t)(input[24] & 0xf0) << 12);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 196 to 211
	value = ((uint32_t)(input[24] & 0x0f) << 28) |
			((uint32_t)input[25] << 20) |
			((uint32_t)(input[26] & 0xf0) << 12);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 212 to 227
	value = ((uint32_t)(input[26] & 0x0f) << 28) |
			((uint32_t)input[27] << 20) |
			((uint32_t)(input[28] & 0xf0) << 12);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 228 to 243
	value = ((uint32_t)(input[28] & 0x0f) << 28) |
			((uint32_t)input[29] << 20) |
			((uint32_t)(input[30] & 0xf0) << 12);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 244 to 259
	value = ((uint32_t)(input[30] & 0x0f) << 28) |
			((uint32_t)input[31] << 20) |
			((uint32_t)(input[32] & 0xf0) << 12);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 260 to 275
	value = ((uint32_t)(input[32] & 0x0f) << 28) |
			((uint32_t)input[33] << 20) |
			((uint32_t)(input[34] & 0xf0) << 12);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 276 to 291
	value = ((uint32_t)(input[34] & 0x0f) << 28) |
			((uint32_t)input[35] << 20) |
			((uint32_t)(input[36] & 0xf0) << 12);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 292 to 307
	value = ((uint32_t)(input[36] & 0x0f) << 28) |
			((uint32_t)input[37] << 20) |
			((uint32_t)(input[38] & 0xf0) << 12);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 308 to 323
	value = ((uint32_t)(input[38] & 0x0f) << 28) |
			((uint32_t)input[39] << 20) |
			((uint32_t)(input[40] & 0xf0) << 12);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 324 to 339
	value = ((uint32_t)(input[40] & 0x0f) << 28) |
			((uint32_t)input[41] << 20) |
			((uint32_t)(input[42] & 0xf0) << 12);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 340 to 355
	value = ((uint32_t)(input[42] & 0x0f) << 28) |
			((uint32_t)input[43] << 20) |
			((uint32_t)(input[44] & 0xf0) << 12);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 356 to 371
	value = ((uint32_t)(input[44] & 0x0f) << 28) |
			((uint32_t)input[45] << 20) |
			((uint32_t)(input[46] & 0xf0) << 12);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 372 to 387
	value = ((uint32_t)(input[46] & 0x0f) << 28) |
			((uint32_t)input[47] << 20) |
			((uint32_t)(input[48] & 0xf0) << 12);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 388 to 403
	value = ((uint32_t)(input[48] & 0x0f) << 28) |
			((uint32_t)input[49] << 20) |
			((uint32_t)(input[50] & 0xf0) << 12);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 404 to 419
	value = ((uint32_t)(input[50] & 0x0f) << 28) |
			((uint32_t)input[51] << 20) |
			((uint32_t)(input[52] & 0xf0) << 12);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 420 to 435
	value = ((uint32_t)(input[52] & 0x0f) << 28) |
			((uint32_t)input[53] << 20) |
			((uint32_t)(input[54] & 0xf0) << 12);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 436 to 451
	value = ((uint32_t)(input[54] & 0x0f) << 28) |
			((uint32_t)input[55] << 20) |
			((uint32_t)(input[56] & 0xf0) << 12);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 452 to 467
	value = ((uint32_t)(input[56] & 0x0f) << 28) |
			((uint32_t)input[57] << 20) |
			((uint32_t)(input[58] & 0xf0) << 12);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 468 to 483
	value = ((uint32_t)(input[58] & 0x0f) << 28) |
			((uint32_t)input[59] << 20) |
			((uint32_t)(input[60] & 0xf0) << 12);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 484 to 499
	value = ((uint32_t)(input[60] & 0x0f) << 28) |
			((uint32_t)input[61] << 20) |
			((uint32_t)(input[62] & 0xf0) << 12);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 500 to 515
	value = ((uint32_t)(input[62] & 0x0f) << 28) |
			((uint32_t)input[63] << 20) |
			((uint32_t)(input[64] & 0xf0) << 12);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 516 to 531
	value = ((uint32_t)(input[64] & 0x0f) << 28) |
			((uint32_t)input[65] << 20) |
			((uint32_t)(input[66] & 0xf0) << 12);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 532 to 547
	value = ((uint32_t)(input[66] & 0x0f) << 28) |
			((uint32_t)input[67] << 20) |
			((uint32_t)(input[68] & 0xf0) << 12);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 548 to 563
	value = ((uint32_t)(input[68] & 0x0f) << 28) |
			((uint32_t)input[69] << 20) |
			((uint32_t)(input[70] & 0xf0) << 12);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 564 to 579
	value = ((uint32_t)(input[70] & 0x0f) << 28) |
			((uint32_t)input[71] << 20) |
			((uint32_t)(input[72] & 0xf0) << 12);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 580 to 595
	value = ((uint32_t)(input[72] & 0x0f) << 28) |
			((uint32_t)input[73] << 20) |
			((uint32_t)(input[74] & 0xf0) << 12);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 596 to 611
	value = ((uint32_t)(input[74] & 0x0f) << 28) |
			((uint32_t)input[75] << 20) |
			((uint32_t)(input[76] & 0xf0) << 12);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 612 to 627
	value = ((uint32_t)(input[76] & 0x0f) << 28) |
			((uint32_t)input[77] << 20) |
			((uint32_t)(input[78] & 0xf0) << 12);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 628 to 643
	value = ((uint32_t)(input[78] & 0x0f) << 28) |
			((uint32_t)input[79] << 20) |
			((uint32_t)(input[80] & 0xf0) << 12);
	output[39] = (double)(value >> 16);

	// read output[40]: from bit 644 to 659
	value = ((uint32_t)(input[80] & 0x0f) << 28) |
			((uint32_t)input[81] << 20) |
			((uint32_t)(input[82] & 0xf0) << 12);
	output[40] = (double)(value >> 16);

	// read output[41]: from bit 660 to 675
	value = ((uint32_t)(input[82] & 0x0f) << 28) |
			((uint32_t)input[83] << 20) |
			((uint32_t)(input[84] & 0xf0) << 12);
	output[41] = (double)(value >> 16);

	// read output[42]: from bit 676 to 691
	value = ((uint32_t)(input[84] & 0x0f) << 28) |
			((uint32_t)input[85] << 20) |
			((uint32_t)(input[86] & 0xf0) << 12);
	output[42] = (double)(value >> 16);

	// read output[43]: from bit 692 to 707
	value = ((uint32_t)(input[86] & 0x0f) << 28) |
			((uint32_t)input[87] << 20) |
			((uint32_t)(input[88] & 0xf0) << 12);
	output[43] = (double)(value >> 16);

	// read output[44]: from bit 708 to 723
	value = ((uint32_t)(input[88] & 0x0f) << 28) |
			((uint32_t)input[89] << 20) |
			((uint32_t)(input[90] & 0xf0) << 12);
	output[44] = (double)(value >> 16);

	// read output[45]: from bit 724 to 739
	value = ((uint32_t)(input[90] & 0x0f) << 28) |
			((uint32_t)input[91] << 20) |
			((uint32_t)(input[92] & 0xf0) << 12);
	output[45] = (double)(value >> 16);

	// read output[46]: from bit 740 to 755
	value = ((uint32_t)(input[92] & 0x0f) << 28) |
			((uint32_t)input[93] << 20) |
			((uint32_t)(input[94] & 0xf0) << 12);
	output[46] = (double)(value >> 16);

	// read output[47]: from bit 756 to 771
	value = ((uint32_t)(input[94] & 0x0f) << 28) |
			((uint32_t)input[95] << 20) |
			((uint32_t)(input[96] & 0xf0) << 12);
	output[47] = (double)(value >> 16);

	// read output[48]: from bit 772 to 787
	value = ((uint32_t)(input[96] & 0x0f) << 28) |
			((uint32_t)input[97] << 20) |
			((uint32_t)(input[98] & 0xf0) << 12);
	output[48] = (double)(value >> 16);

	// read output[49]: from bit 788 to 803
	value = ((uint32_t)(input[98] & 0x0f) << 28) |
			((uint32_t)input[99] << 20) |
			((uint32_t)(input[100] & 0xf0) << 12);
	output[49] = (double)(value >> 16);

	// read output[50]: from bit 804 to 819
	value = ((uint32_t)(input[100] & 0x0f) << 28) |
			((uint32_t)input[101] << 20) |
			((uint32_t)(input[102] & 0xf0) << 12);
	output[50] = (double)(value >> 16);

	// read output[51]: from bit 820 to 835
	value = ((uint32_t)(input[102] & 0x0f) << 28) |
			((uint32_t)input[103] << 20) |
			((uint32_t)(input[104] & 0xf0) << 12);
	output[51] = (double)(value >> 16);

	// read output[52]: from bit 836 to 851
	value = ((uint32_t)(input[104] & 0x0f) << 28) |
			((uint32_t)input[105] << 20) |
			((uint32_t)(input[106] & 0xf0) << 12);
	output[52] = (double)(value >> 16);

	// read output[53]: from bit 852 to 867
	value = ((uint32_t)(input[106] & 0x0f) << 28) |
			((uint32_t)input[107] << 20) |
			((uint32_t)(input[108] & 0xf0) << 12);
	output[53] = (double)(value >> 16);

	// read output[54]: from bit 868 to 883
	value = ((uint32_t)(input[108] & 0x0f) << 28) |
			((uint32_t)input[109] << 20) |
			((uint32_t)(input[110] & 0xf0) << 12);
	output[54] = (double)(value >> 16);

	// read output[55]: from bit 884 to 899
	value = ((uint32_t)(input[110] & 0x0f) << 28) |
			((uint32_t)input[111] << 20) |
			((uint32_t)(input[112] & 0xf0) << 12);
	output[55] = (double)(value >> 16);

	// read output[56]: from bit 900 to 915
	value = ((uint32_t)(input[112] & 0x0f) << 28) |
			((uint32_t)input[113] << 20) |
			((uint32_t)(input[114] & 0xf0) << 12);
	output[56] = (double)(value >> 16);

	// read output[57]: from bit 916 to 931
	value = ((uint32_t)(input[114] & 0x0f) << 28) |
			((uint32_t)input[115] << 20) |
			((uint32_t)(input[116] & 0xf0) << 12);
	output[57] = (double)(value >> 16);

	// read output[58]: from bit 932 to 947
	value = ((uint32_t)(input[116] & 0x0f) << 28) |
			((uint32_t)input[117] << 20) |
			((uint32_t)(input[118] & 0xf0) << 12);
	output[58] = (double)(value >> 16);

	// read output[59]: from bit 948 to 963
	value = ((uint32_t)(input[118] & 0x0f) << 28) |
			((uint32_t)input[119] << 20) |
			((uint32_t)(input[120] & 0xf0) << 12);
	output[59] = (double)(value >> 16);
}

static void unpack_60_16bit_unsigned_4off(const uint8_t * input, double * output, void *closure) {
	// Unpack 60 values into output
	// Values are 16-bit unsigned
	// Skip 4 bits, read 960 bits of data.
	// Input must be at least 121 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 4 to 19
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20) |
			((uint32_t)(input[2] & 0xf0) << 12);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 20 to 35
	value = ((uint32_t)(input[2] & 0x0f) << 28) |
			((uint32_t)input[3] << 20) |
			((uint32_t)(input[4] & 0xf0) << 12);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 36 to 51
	value = ((uint32_t)(input[4] & 0x0f) << 28) |
			((uint32_t)input[5] << 20) |
			((uint32_t)(input[6] & 0xf0) << 12);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 52 to 67
	value = ((uint32_t)(input[6] & 0x0f) << 28) |
			((uint32_t)input[7] << 20) |
			((uint32_t)(input[8] & 0xf0) << 12);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 68 to 83
	value = ((uint32_t)(input[8] & 0x0f) << 28) |
			((uint32_t)input[9] << 20) |
			((uint32_t)(input[10] & 0xf0) << 12);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 84 to 99
	value = ((uint32_t)(input[10] & 0x0f) << 28) |
			((uint32_t)input[11] << 20) |
			((uint32_t)(input[12] & 0xf0) << 12);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 100 to 115
	value = ((uint32_t)(input[12] & 0x0f) << 28) |
			((uint32_t)input[13] << 20) |
			((uint32_t)(input[14] & 0xf0) << 12);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 116 to 131
	value = ((uint32_t)(input[14] & 0x0f) << 28) |
			((uint32_t)input[15] << 20) |
			((uint32_t)(input[16] & 0xf0) << 12);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 132 to 147
	value = ((uint32_t)(input[16] & 0x0f) << 28) |
			((uint32_t)input[17] << 20) |
			((uint32_t)(input[18] & 0xf0) << 12);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 148 to 163
	value = ((uint32_t)(input[18] & 0x0f) << 28) |
			((uint32_t)input[19] << 20) |
			((uint32_t)(input[20] & 0xf0) << 12);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 164 to 179
	value = ((uint32_t)(input[20] & 0x0f) << 28) |
			((uint32_t)input[21] << 20) |
			((uint32_t)(input[22] & 0xf0) << 12);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 180 to 195
	value = ((uint32_t)(input[22] & 0x0f) << 28) |
			((uint32_t)input[23] << 20) |
			((uint32_t)(input[24] & 0xf0) << 12);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 196 to 211
	value = ((uint32_t)(input[24] & 0x0f) << 28) |
			((uint32_t)input[25] << 20) |
			((uint32_t)(input[26] & 0xf0) << 12);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 212 to 227
	value = ((uint32_t)(input[26] & 0x0f) << 28) |
			((uint32_t)input[27] << 20) |
			((uint32_t)(input[28] & 0xf0) << 12);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 228 to 243
	value = ((uint32_t)(input[28] & 0x0f) << 28) |
			((uint32_t)input[29] << 20) |
			((uint32_t)(input[30] & 0xf0) << 12);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 244 to 259
	value = ((uint32_t)(input[30] & 0x0f) << 28) |
			((uint32_t)input[31] << 20) |
			((uint32_t)(input[32] & 0xf0) << 12);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 260 to 275
	value = ((uint32_t)(input[32] & 0x0f) << 28) |
			((uint32_t)input[33] << 20) |
			((uint32_t)(input[34] & 0xf0) << 12);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 276 to 291
	value = ((uint32_t)(input[34] & 0x0f) << 28) |
			((uint32_t)input[35] << 20) |
			((uint32_t)(input[36] & 0xf0) << 12);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 292 to 307
	value = ((uint32_t)(input[36] & 0x0f) << 28) |
			((uint32_t)input[37] << 20) |
			((uint32_t)(input[38] & 0xf0) << 12);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 308 to 323
	value = ((uint32_t)(input[38] & 0x0f) << 28) |
			((uint32_t)input[39] << 20) |
			((uint32_t)(input[40] & 0xf0) << 12);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 324 to 339
	value = ((uint32_t)(input[40] & 0x0f) << 28) |
			((uint32_t)input[41] << 20) |
			((uint32_t)(input[42] & 0xf0) << 12);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 340 to 355
	value = ((uint32_t)(input[42] & 0x0f) << 28) |
			((uint32_t)input[43] << 20) |
			((uint32_t)(input[44] & 0xf0) << 12);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 356 to 371
	value = ((uint32_t)(input[44] & 0x0f) << 28) |
			((uint32_t)input[45] << 20) |
			((uint32_t)(input[46] & 0xf0) << 12);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 372 to 387
	value = ((uint32_t)(input[46] & 0x0f) << 28) |
			((uint32_t)input[47] << 20) |
			((uint32_t)(input[48] & 0xf0) << 12);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 388 to 403
	value = ((uint32_t)(input[48] & 0x0f) << 28) |
			((uint32_t)input[49] << 20) |
			((uint32_t)(input[50] & 0xf0) << 12);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 404 to 419
	value = ((uint32_t)(input[50] & 0x0f) << 28) |
			((uint32_t)input[51] << 20) |
			((uint32_t)(input[52] & 0xf0) << 12);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 420 to 435
	value = ((uint32_t)(input[52] & 0x0f) << 28) |
			((uint32_t)input[53] << 20) |
			((uint32_t)(input[54] & 0xf0) << 12);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 436 to 451
	value = ((uint32_t)(input[54] & 0x0f) << 28) |
			((uint32_t)input[55] << 20) |
			((uint32_t)(input[56] & 0xf0) << 12);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 452 to 467
	value = ((uint32_t)(input[56] & 0x0f) << 28) |
			((uint32_t)input[57] << 20) |
			((uint32_t)(input[58] & 0xf0) << 12);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 468 to 483
	value = ((uint32_t)(input[58] & 0x0f) << 28) |
			((uint32_t)input[59] << 20) |
			((uint32_t)(input[60] & 0xf0) << 12);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 484 to 499
	value = ((uint32_t)(input[60] & 0x0f) << 28) |
			((uint32_t)input[61] << 20) |
			((uint32_t)(input[62] & 0xf0) << 12);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 500 to 515
	value = ((uint32_t)(input[62] & 0x0f) << 28) |
			((uint32_t)input[63] << 20) |
			((uint32_t)(input[64] & 0xf0) << 12);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 516 to 531
	value = ((uint32_t)(input[64] & 0x0f) << 28) |
			((uint32_t)input[65] << 20) |
			((uint32_t)(input[66] & 0xf0) << 12);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 532 to 547
	value = ((uint32_t)(input[66] & 0x0f) << 28) |
			((uint32_t)input[67] << 20) |
			((uint32_t)(input[68] & 0xf0) << 12);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 548 to 563
	value = ((uint32_t)(input[68] & 0x0f) << 28) |
			((uint32_t)input[69] << 20) |
			((uint32_t)(input[70] & 0xf0) << 12);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 564 to 579
	value = ((uint32_t)(input[70] & 0x0f) << 28) |
			((uint32_t)input[71] << 20) |
			((uint32_t)(input[72] & 0xf0) << 12);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 580 to 595
	value = ((uint32_t)(input[72] & 0x0f) << 28) |
			((uint32_t)input[73] << 20) |
			((uint32_t)(input[74] & 0xf0) << 12);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 596 to 611
	value = ((uint32_t)(input[74] & 0x0f) << 28) |
			((uint32_t)input[75] << 20) |
			((uint32_t)(input[76] & 0xf0) << 12);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 612 to 627
	value = ((uint32_t)(input[76] & 0x0f) << 28) |
			((uint32_t)input[77] << 20) |
			((uint32_t)(input[78] & 0xf0) << 12);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 628 to 643
	value = ((uint32_t)(input[78] & 0x0f) << 28) |
			((uint32_t)input[79] << 20) |
			((uint32_t)(input[80] & 0xf0) << 12);
	output[39] = (double)(value >> 16);

	// read output[40]: from bit 644 to 659
	value = ((uint32_t)(input[80] & 0x0f) << 28) |
			((uint32_t)input[81] << 20) |
			((uint32_t)(input[82] & 0xf0) << 12);
	output[40] = (double)(value >> 16);

	// read output[41]: from bit 660 to 675
	value = ((uint32_t)(input[82] & 0x0f) << 28) |
			((uint32_t)input[83] << 20) |
			((uint32_t)(input[84] & 0xf0) << 12);
	output[41] = (double)(value >> 16);

	// read output[42]: from bit 676 to 691
	value = ((uint32_t)(input[84] & 0x0f) << 28) |
			((uint32_t)input[85] << 20) |
			((uint32_t)(input[86] & 0xf0) << 12);
	output[42] = (double)(value >> 16);

	// read output[43]: from bit 692 to 707
	value = ((uint32_t)(input[86] & 0x0f) << 28) |
			((uint32_t)input[87] << 20) |
			((uint32_t)(input[88] & 0xf0) << 12);
	output[43] = (double)(value >> 16);

	// read output[44]: from bit 708 to 723
	value = ((uint32_t)(input[88] & 0x0f) << 28) |
			((uint32_t)input[89] << 20) |
			((uint32_t)(input[90] & 0xf0) << 12);
	output[44] = (double)(value >> 16);

	// read output[45]: from bit 724 to 739
	value = ((uint32_t)(input[90] & 0x0f) << 28) |
			((uint32_t)input[91] << 20) |
			((uint32_t)(input[92] & 0xf0) << 12);
	output[45] = (double)(value >> 16);

	// read output[46]: from bit 740 to 755
	value = ((uint32_t)(input[92] & 0x0f) << 28) |
			((uint32_t)input[93] << 20) |
			((uint32_t)(input[94] & 0xf0) << 12);
	output[46] = (double)(value >> 16);

	// read output[47]: from bit 756 to 771
	value = ((uint32_t)(input[94] & 0x0f) << 28) |
			((uint32_t)input[95] << 20) |
			((uint32_t)(input[96] & 0xf0) << 12);
	output[47] = (double)(value >> 16);

	// read output[48]: from bit 772 to 787
	value = ((uint32_t)(input[96] & 0x0f) << 28) |
			((uint32_t)input[97] << 20) |
			((uint32_t)(input[98] & 0xf0) << 12);
	output[48] = (double)(value >> 16);

	// read output[49]: from bit 788 to 803
	value = ((uint32_t)(input[98] & 0x0f) << 28) |
			((uint32_t)input[99] << 20) |
			((uint32_t)(input[100] & 0xf0) << 12);
	output[49] = (double)(value >> 16);

	// read output[50]: from bit 804 to 819
	value = ((uint32_t)(input[100] & 0x0f) << 28) |
			((uint32_t)input[101] << 20) |
			((uint32_t)(input[102] & 0xf0) << 12);
	output[50] = (double)(value >> 16);

	// read output[51]: from bit 820 to 835
	value = ((uint32_t)(input[102] & 0x0f) << 28) |
			((uint32_t)input[103] << 20) |
			((uint32_t)(input[104] & 0xf0) << 12);
	output[51] = (double)(value >> 16);

	// read output[52]: from bit 836 to 851
	value = ((uint32_t)(input[104] & 0x0f) << 28) |
			((uint32_t)input[105] << 20) |
			((uint32_t)(input[106] & 0xf0) << 12);
	output[52] = (double)(value >> 16);

	// read output[53]: from bit 852 to 867
	value = ((uint32_t)(input[106] & 0x0f) << 28) |
			((uint32_t)input[107] << 20) |
			((uint32_t)(input[108] & 0xf0) << 12);
	output[53] = (double)(value >> 16);

	// read output[54]: from bit 868 to 883
	value = ((uint32_t)(input[108] & 0x0f) << 28) |
			((uint32_t)input[109] << 20) |
			((uint32_t)(input[110] & 0xf0) << 12);
	output[54] = (double)(value >> 16);

	// read output[55]: from bit 884 to 899
	value = ((uint32_t)(input[110] & 0x0f) << 28) |
			((uint32_t)input[111] << 20) |
			((uint32_t)(input[112] & 0xf0) << 12);
	output[55] = (double)(value >> 16);

	// read output[56]: from bit 900 to 915
	value = ((uint32_t)(input[112] & 0x0f) << 28) |
			((uint32_t)input[113] << 20) |
			((uint32_t)(input[114] & 0xf0) << 12);
	output[56] = (double)(value >> 16);

	// read output[57]: from bit 916 to 931
	value = ((uint32_t)(input[114] & 0x0f) << 28) |
			((uint32_t)input[115] << 20) |
			((uint32_t)(input[116] & 0xf0) << 12);
	output[57] = (double)(value >> 16);

	// read output[58]: from bit 932 to 947
	value = ((uint32_t)(input[116] & 0x0f) << 28) |
			((uint32_t)input[117] << 20) |
			((uint32_t)(input[118] & 0xf0) << 12);
	output[58] = (double)(value >> 16);

	// read output[59]: from bit 948 to 963
	value = ((uint32_t)(input[118] & 0x0f) << 28) |
			((uint32_t)input[119] << 20) |
			((uint32_t)(input[120] & 0xf0) << 12);
	output[59] = (double)(value >> 16);
}

static void unpack_60_16bit_signed_5off(const uint8_t * input, double * output, void *closure) {
	// Unpack 60 values into output
	// Values are 16-bit signed
	// Skip 5 bits, read 960 bits of data.
	// Input must be at least 121 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 5 to 20
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)(input[2] & 0xf8) << 13);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 21 to 36
	value = ((uint32_t)(input[2] & 0x07) << 29) |
			((uint32_t)input[3] << 21) |
			((uint32_t)(input[4] & 0xf8) << 13);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 37 to 52
	value = ((uint32_t)(input[4] & 0x07) << 29) |
			((uint32_t)input[5] << 21) |
			((uint32_t)(input[6] & 0xf8) << 13);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 53 to 68
	value = ((uint32_t)(input[6] & 0x07) << 29) |
			((uint32_t)input[7] << 21) |
			((uint32_t)(input[8] & 0xf8) << 13);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 69 to 84
	value = ((uint32_t)(input[8] & 0x07) << 29) |
			((uint32_t)input[9] << 21) |
			((uint32_t)(input[10] & 0xf8) << 13);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 85 to 100
	value = ((uint32_t)(input[10] & 0x07) << 29) |
			((uint32_t)input[11] << 21) |
			((uint32_t)(input[12] & 0xf8) << 13);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 101 to 116
	value = ((uint32_t)(input[12] & 0x07) << 29) |
			((uint32_t)input[13] << 21) |
			((uint32_t)(input[14] & 0xf8) << 13);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 117 to 132
	value = ((uint32_t)(input[14] & 0x07) << 29) |
			((uint32_t)input[15] << 21) |
			((uint32_t)(input[16] & 0xf8) << 13);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 133 to 148
	value = ((uint32_t)(input[16] & 0x07) << 29) |
			((uint32_t)input[17] << 21) |
			((uint32_t)(input[18] & 0xf8) << 13);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 149 to 164
	value = ((uint32_t)(input[18] & 0x07) << 29) |
			((uint32_t)input[19] << 21) |
			((uint32_t)(input[20] & 0xf8) << 13);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 165 to 180
	value = ((uint32_t)(input[20] & 0x07) << 29) |
			((uint32_t)input[21] << 21) |
			((uint32_t)(input[22] & 0xf8) << 13);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 181 to 196
	value = ((uint32_t)(input[22] & 0x07) << 29) |
			((uint32_t)input[23] << 21) |
			((uint32_t)(input[24] & 0xf8) << 13);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 197 to 212
	value = ((uint32_t)(input[24] & 0x07) << 29) |
			((uint32_t)input[25] << 21) |
			((uint32_t)(input[26] & 0xf8) << 13);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 213 to 228
	value = ((uint32_t)(input[26] & 0x07) << 29) |
			((uint32_t)input[27] << 21) |
			((uint32_t)(input[28] & 0xf8) << 13);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 229 to 244
	value = ((uint32_t)(input[28] & 0x07) << 29) |
			((uint32_t)input[29] << 21) |
			((uint32_t)(input[30] & 0xf8) << 13);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 245 to 260
	value = ((uint32_t)(input[30] & 0x07) << 29) |
			((uint32_t)input[31] << 21) |
			((uint32_t)(input[32] & 0xf8) << 13);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 261 to 276
	value = ((uint32_t)(input[32] & 0x07) << 29) |
			((uint32_t)input[33] << 21) |
			((uint32_t)(input[34] & 0xf8) << 13);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 277 to 292
	value = ((uint32_t)(input[34] & 0x07) << 29) |
			((uint32_t)input[35] << 21) |
			((uint32_t)(input[36] & 0xf8) << 13);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 293 to 308
	value = ((uint32_t)(input[36] & 0x07) << 29) |
			((uint32_t)input[37] << 21) |
			((uint32_t)(input[38] & 0xf8) << 13);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 309 to 324
	value = ((uint32_t)(input[38] & 0x07) << 29) |
			((uint32_t)input[39] << 21) |
			((uint32_t)(input[40] & 0xf8) << 13);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 325 to 340
	value = ((uint32_t)(input[40] & 0x07) << 29) |
			((uint32_t)input[41] << 21) |
			((uint32_t)(input[42] & 0xf8) << 13);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 341 to 356
	value = ((uint32_t)(input[42] & 0x07) << 29) |
			((uint32_t)input[43] << 21) |
			((uint32_t)(input[44] & 0xf8) << 13);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 357 to 372
	value = ((uint32_t)(input[44] & 0x07) << 29) |
			((uint32_t)input[45] << 21) |
			((uint32_t)(input[46] & 0xf8) << 13);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 373 to 388
	value = ((uint32_t)(input[46] & 0x07) << 29) |
			((uint32_t)input[47] << 21) |
			((uint32_t)(input[48] & 0xf8) << 13);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 389 to 404
	value = ((uint32_t)(input[48] & 0x07) << 29) |
			((uint32_t)input[49] << 21) |
			((uint32_t)(input[50] & 0xf8) << 13);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 405 to 420
	value = ((uint32_t)(input[50] & 0x07) << 29) |
			((uint32_t)input[51] << 21) |
			((uint32_t)(input[52] & 0xf8) << 13);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 421 to 436
	value = ((uint32_t)(input[52] & 0x07) << 29) |
			((uint32_t)input[53] << 21) |
			((uint32_t)(input[54] & 0xf8) << 13);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 437 to 452
	value = ((uint32_t)(input[54] & 0x07) << 29) |
			((uint32_t)input[55] << 21) |
			((uint32_t)(input[56] & 0xf8) << 13);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 453 to 468
	value = ((uint32_t)(input[56] & 0x07) << 29) |
			((uint32_t)input[57] << 21) |
			((uint32_t)(input[58] & 0xf8) << 13);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 469 to 484
	value = ((uint32_t)(input[58] & 0x07) << 29) |
			((uint32_t)input[59] << 21) |
			((uint32_t)(input[60] & 0xf8) << 13);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 485 to 500
	value = ((uint32_t)(input[60] & 0x07) << 29) |
			((uint32_t)input[61] << 21) |
			((uint32_t)(input[62] & 0xf8) << 13);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 501 to 516
	value = ((uint32_t)(input[62] & 0x07) << 29) |
			((uint32_t)input[63] << 21) |
			((uint32_t)(input[64] & 0xf8) << 13);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 517 to 532
	value = ((uint32_t)(input[64] & 0x07) << 29) |
			((uint32_t)input[65] << 21) |
			((uint32_t)(input[66] & 0xf8) << 13);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 533 to 548
	value = ((uint32_t)(input[66] & 0x07) << 29) |
			((uint32_t)input[67] << 21) |
			((uint32_t)(input[68] & 0xf8) << 13);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 549 to 564
	value = ((uint32_t)(input[68] & 0x07) << 29) |
			((uint32_t)input[69] << 21) |
			((uint32_t)(input[70] & 0xf8) << 13);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 565 to 580
	value = ((uint32_t)(input[70] & 0x07) << 29) |
			((uint32_t)input[71] << 21) |
			((uint32_t)(input[72] & 0xf8) << 13);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 581 to 596
	value = ((uint32_t)(input[72] & 0x07) << 29) |
			((uint32_t)input[73] << 21) |
			((uint32_t)(input[74] & 0xf8) << 13);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 597 to 612
	value = ((uint32_t)(input[74] & 0x07) << 29) |
			((uint32_t)input[75] << 21) |
			((uint32_t)(input[76] & 0xf8) << 13);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 613 to 628
	value = ((uint32_t)(input[76] & 0x07) << 29) |
			((uint32_t)input[77] << 21) |
			((uint32_t)(input[78] & 0xf8) << 13);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 629 to 644
	value = ((uint32_t)(input[78] & 0x07) << 29) |
			((uint32_t)input[79] << 21) |
			((uint32_t)(input[80] & 0xf8) << 13);
	output[39] = (double)(value >> 16);

	// read output[40]: from bit 645 to 660
	value = ((uint32_t)(input[80] & 0x07) << 29) |
			((uint32_t)input[81] << 21) |
			((uint32_t)(input[82] & 0xf8) << 13);
	output[40] = (double)(value >> 16);

	// read output[41]: from bit 661 to 676
	value = ((uint32_t)(input[82] & 0x07) << 29) |
			((uint32_t)input[83] << 21) |
			((uint32_t)(input[84] & 0xf8) << 13);
	output[41] = (double)(value >> 16);

	// read output[42]: from bit 677 to 692
	value = ((uint32_t)(input[84] & 0x07) << 29) |
			((uint32_t)input[85] << 21) |
			((uint32_t)(input[86] & 0xf8) << 13);
	output[42] = (double)(value >> 16);

	// read output[43]: from bit 693 to 708
	value = ((uint32_t)(input[86] & 0x07) << 29) |
			((uint32_t)input[87] << 21) |
			((uint32_t)(input[88] & 0xf8) << 13);
	output[43] = (double)(value >> 16);

	// read output[44]: from bit 709 to 724
	value = ((uint32_t)(input[88] & 0x07) << 29) |
			((uint32_t)input[89] << 21) |
			((uint32_t)(input[90] & 0xf8) << 13);
	output[44] = (double)(value >> 16);

	// read output[45]: from bit 725 to 740
	value = ((uint32_t)(input[90] & 0x07) << 29) |
			((uint32_t)input[91] << 21) |
			((uint32_t)(input[92] & 0xf8) << 13);
	output[45] = (double)(value >> 16);

	// read output[46]: from bit 741 to 756
	value = ((uint32_t)(input[92] & 0x07) << 29) |
			((uint32_t)input[93] << 21) |
			((uint32_t)(input[94] & 0xf8) << 13);
	output[46] = (double)(value >> 16);

	// read output[47]: from bit 757 to 772
	value = ((uint32_t)(input[94] & 0x07) << 29) |
			((uint32_t)input[95] << 21) |
			((uint32_t)(input[96] & 0xf8) << 13);
	output[47] = (double)(value >> 16);

	// read output[48]: from bit 773 to 788
	value = ((uint32_t)(input[96] & 0x07) << 29) |
			((uint32_t)input[97] << 21) |
			((uint32_t)(input[98] & 0xf8) << 13);
	output[48] = (double)(value >> 16);

	// read output[49]: from bit 789 to 804
	value = ((uint32_t)(input[98] & 0x07) << 29) |
			((uint32_t)input[99] << 21) |
			((uint32_t)(input[100] & 0xf8) << 13);
	output[49] = (double)(value >> 16);

	// read output[50]: from bit 805 to 820
	value = ((uint32_t)(input[100] & 0x07) << 29) |
			((uint32_t)input[101] << 21) |
			((uint32_t)(input[102] & 0xf8) << 13);
	output[50] = (double)(value >> 16);

	// read output[51]: from bit 821 to 836
	value = ((uint32_t)(input[102] & 0x07) << 29) |
			((uint32_t)input[103] << 21) |
			((uint32_t)(input[104] & 0xf8) << 13);
	output[51] = (double)(value >> 16);

	// read output[52]: from bit 837 to 852
	value = ((uint32_t)(input[104] & 0x07) << 29) |
			((uint32_t)input[105] << 21) |
			((uint32_t)(input[106] & 0xf8) << 13);
	output[52] = (double)(value >> 16);

	// read output[53]: from bit 853 to 868
	value = ((uint32_t)(input[106] & 0x07) << 29) |
			((uint32_t)input[107] << 21) |
			((uint32_t)(input[108] & 0xf8) << 13);
	output[53] = (double)(value >> 16);

	// read output[54]: from bit 869 to 884
	value = ((uint32_t)(input[108] & 0x07) << 29) |
			((uint32_t)input[109] << 21) |
			((uint32_t)(input[110] & 0xf8) << 13);
	output[54] = (double)(value >> 16);

	// read output[55]: from bit 885 to 900
	value = ((uint32_t)(input[110] & 0x07) << 29) |
			((uint32_t)input[111] << 21) |
			((uint32_t)(input[112] & 0xf8) << 13);
	output[55] = (double)(value >> 16);

	// read output[56]: from bit 901 to 916
	value = ((uint32_t)(input[112] & 0x07) << 29) |
			((uint32_t)input[113] << 21) |
			((uint32_t)(input[114] & 0xf8) << 13);
	output[56] = (double)(value >> 16);

	// read output[57]: from bit 917 to 932
	value = ((uint32_t)(input[114] & 0x07) << 29) |
			((uint32_t)input[115] << 21) |
			((uint32_t)(input[116] & 0xf8) << 13);
	output[57] = (double)(value >> 16);

	// read output[58]: from bit 933 to 948
	value = ((uint32_t)(input[116] & 0x07) << 29) |
			((uint32_t)input[117] << 21) |
			((uint32_t)(input[118] & 0xf8) << 13);
	output[58] = (double)(value >> 16);

	// read output[59]: from bit 949 to 964
	value = ((uint32_t)(input[118] & 0x07) << 29) |
			((uint32_t)input[119] << 21) |
			((uint32_t)(input[120] & 0xf8) << 13);
	output[59] = (double)(value >> 16);
}

static void unpack_60_16bit_unsigned_5off(const uint8_t * input, double * output, void *closure) {
	// Unpack 60 values into output
	// Values are 16-bit unsigned
	// Skip 5 bits, read 960 bits of data.
	// Input must be at least 121 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 5 to 20
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)(input[2] & 0xf8) << 13);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 21 to 36
	value = ((uint32_t)(input[2] & 0x07) << 29) |
			((uint32_t)input[3] << 21) |
			((uint32_t)(input[4] & 0xf8) << 13);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 37 to 52
	value = ((uint32_t)(input[4] & 0x07) << 29) |
			((uint32_t)input[5] << 21) |
			((uint32_t)(input[6] & 0xf8) << 13);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 53 to 68
	value = ((uint32_t)(input[6] & 0x07) << 29) |
			((uint32_t)input[7] << 21) |
			((uint32_t)(input[8] & 0xf8) << 13);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 69 to 84
	value = ((uint32_t)(input[8] & 0x07) << 29) |
			((uint32_t)input[9] << 21) |
			((uint32_t)(input[10] & 0xf8) << 13);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 85 to 100
	value = ((uint32_t)(input[10] & 0x07) << 29) |
			((uint32_t)input[11] << 21) |
			((uint32_t)(input[12] & 0xf8) << 13);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 101 to 116
	value = ((uint32_t)(input[12] & 0x07) << 29) |
			((uint32_t)input[13] << 21) |
			((uint32_t)(input[14] & 0xf8) << 13);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 117 to 132
	value = ((uint32_t)(input[14] & 0x07) << 29) |
			((uint32_t)input[15] << 21) |
			((uint32_t)(input[16] & 0xf8) << 13);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 133 to 148
	value = ((uint32_t)(input[16] & 0x07) << 29) |
			((uint32_t)input[17] << 21) |
			((uint32_t)(input[18] & 0xf8) << 13);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 149 to 164
	value = ((uint32_t)(input[18] & 0x07) << 29) |
			((uint32_t)input[19] << 21) |
			((uint32_t)(input[20] & 0xf8) << 13);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 165 to 180
	value = ((uint32_t)(input[20] & 0x07) << 29) |
			((uint32_t)input[21] << 21) |
			((uint32_t)(input[22] & 0xf8) << 13);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 181 to 196
	value = ((uint32_t)(input[22] & 0x07) << 29) |
			((uint32_t)input[23] << 21) |
			((uint32_t)(input[24] & 0xf8) << 13);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 197 to 212
	value = ((uint32_t)(input[24] & 0x07) << 29) |
			((uint32_t)input[25] << 21) |
			((uint32_t)(input[26] & 0xf8) << 13);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 213 to 228
	value = ((uint32_t)(input[26] & 0x07) << 29) |
			((uint32_t)input[27] << 21) |
			((uint32_t)(input[28] & 0xf8) << 13);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 229 to 244
	value = ((uint32_t)(input[28] & 0x07) << 29) |
			((uint32_t)input[29] << 21) |
			((uint32_t)(input[30] & 0xf8) << 13);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 245 to 260
	value = ((uint32_t)(input[30] & 0x07) << 29) |
			((uint32_t)input[31] << 21) |
			((uint32_t)(input[32] & 0xf8) << 13);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 261 to 276
	value = ((uint32_t)(input[32] & 0x07) << 29) |
			((uint32_t)input[33] << 21) |
			((uint32_t)(input[34] & 0xf8) << 13);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 277 to 292
	value = ((uint32_t)(input[34] & 0x07) << 29) |
			((uint32_t)input[35] << 21) |
			((uint32_t)(input[36] & 0xf8) << 13);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 293 to 308
	value = ((uint32_t)(input[36] & 0x07) << 29) |
			((uint32_t)input[37] << 21) |
			((uint32_t)(input[38] & 0xf8) << 13);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 309 to 324
	value = ((uint32_t)(input[38] & 0x07) << 29) |
			((uint32_t)input[39] << 21) |
			((uint32_t)(input[40] & 0xf8) << 13);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 325 to 340
	value = ((uint32_t)(input[40] & 0x07) << 29) |
			((uint32_t)input[41] << 21) |
			((uint32_t)(input[42] & 0xf8) << 13);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 341 to 356
	value = ((uint32_t)(input[42] & 0x07) << 29) |
			((uint32_t)input[43] << 21) |
			((uint32_t)(input[44] & 0xf8) << 13);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 357 to 372
	value = ((uint32_t)(input[44] & 0x07) << 29) |
			((uint32_t)input[45] << 21) |
			((uint32_t)(input[46] & 0xf8) << 13);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 373 to 388
	value = ((uint32_t)(input[46] & 0x07) << 29) |
			((uint32_t)input[47] << 21) |
			((uint32_t)(input[48] & 0xf8) << 13);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 389 to 404
	value = ((uint32_t)(input[48] & 0x07) << 29) |
			((uint32_t)input[49] << 21) |
			((uint32_t)(input[50] & 0xf8) << 13);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 405 to 420
	value = ((uint32_t)(input[50] & 0x07) << 29) |
			((uint32_t)input[51] << 21) |
			((uint32_t)(input[52] & 0xf8) << 13);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 421 to 436
	value = ((uint32_t)(input[52] & 0x07) << 29) |
			((uint32_t)input[53] << 21) |
			((uint32_t)(input[54] & 0xf8) << 13);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 437 to 452
	value = ((uint32_t)(input[54] & 0x07) << 29) |
			((uint32_t)input[55] << 21) |
			((uint32_t)(input[56] & 0xf8) << 13);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 453 to 468
	value = ((uint32_t)(input[56] & 0x07) << 29) |
			((uint32_t)input[57] << 21) |
			((uint32_t)(input[58] & 0xf8) << 13);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 469 to 484
	value = ((uint32_t)(input[58] & 0x07) << 29) |
			((uint32_t)input[59] << 21) |
			((uint32_t)(input[60] & 0xf8) << 13);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 485 to 500
	value = ((uint32_t)(input[60] & 0x07) << 29) |
			((uint32_t)input[61] << 21) |
			((uint32_t)(input[62] & 0xf8) << 13);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 501 to 516
	value = ((uint32_t)(input[62] & 0x07) << 29) |
			((uint32_t)input[63] << 21) |
			((uint32_t)(input[64] & 0xf8) << 13);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 517 to 532
	value = ((uint32_t)(input[64] & 0x07) << 29) |
			((uint32_t)input[65] << 21) |
			((uint32_t)(input[66] & 0xf8) << 13);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 533 to 548
	value = ((uint32_t)(input[66] & 0x07) << 29) |
			((uint32_t)input[67] << 21) |
			((uint32_t)(input[68] & 0xf8) << 13);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 549 to 564
	value = ((uint32_t)(input[68] & 0x07) << 29) |
			((uint32_t)input[69] << 21) |
			((uint32_t)(input[70] & 0xf8) << 13);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 565 to 580
	value = ((uint32_t)(input[70] & 0x07) << 29) |
			((uint32_t)input[71] << 21) |
			((uint32_t)(input[72] & 0xf8) << 13);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 581 to 596
	value = ((uint32_t)(input[72] & 0x07) << 29) |
			((uint32_t)input[73] << 21) |
			((uint32_t)(input[74] & 0xf8) << 13);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 597 to 612
	value = ((uint32_t)(input[74] & 0x07) << 29) |
			((uint32_t)input[75] << 21) |
			((uint32_t)(input[76] & 0xf8) << 13);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 613 to 628
	value = ((uint32_t)(input[76] & 0x07) << 29) |
			((uint32_t)input[77] << 21) |
			((uint32_t)(input[78] & 0xf8) << 13);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 629 to 644
	value = ((uint32_t)(input[78] & 0x07) << 29) |
			((uint32_t)input[79] << 21) |
			((uint32_t)(input[80] & 0xf8) << 13);
	output[39] = (double)(value >> 16);

	// read output[40]: from bit 645 to 660
	value = ((uint32_t)(input[80] & 0x07) << 29) |
			((uint32_t)input[81] << 21) |
			((uint32_t)(input[82] & 0xf8) << 13);
	output[40] = (double)(value >> 16);

	// read output[41]: from bit 661 to 676
	value = ((uint32_t)(input[82] & 0x07) << 29) |
			((uint32_t)input[83] << 21) |
			((uint32_t)(input[84] & 0xf8) << 13);
	output[41] = (double)(value >> 16);

	// read output[42]: from bit 677 to 692
	value = ((uint32_t)(input[84] & 0x07) << 29) |
			((uint32_t)input[85] << 21) |
			((uint32_t)(input[86] & 0xf8) << 13);
	output[42] = (double)(value >> 16);

	// read output[43]: from bit 693 to 708
	value = ((uint32_t)(input[86] & 0x07) << 29) |
			((uint32_t)input[87] << 21) |
			((uint32_t)(input[88] & 0xf8) << 13);
	output[43] = (double)(value >> 16);

	// read output[44]: from bit 709 to 724
	value = ((uint32_t)(input[88] & 0x07) << 29) |
			((uint32_t)input[89] << 21) |
			((uint32_t)(input[90] & 0xf8) << 13);
	output[44] = (double)(value >> 16);

	// read output[45]: from bit 725 to 740
	value = ((uint32_t)(input[90] & 0x07) << 29) |
			((uint32_t)input[91] << 21) |
			((uint32_t)(input[92] & 0xf8) << 13);
	output[45] = (double)(value >> 16);

	// read output[46]: from bit 741 to 756
	value = ((uint32_t)(input[92] & 0x07) << 29) |
			((uint32_t)input[93] << 21) |
			((uint32_t)(input[94] & 0xf8) << 13);
	output[46] = (double)(value >> 16);

	// read output[47]: from bit 757 to 772
	value = ((uint32_t)(input[94] & 0x07) << 29) |
			((uint32_t)input[95] << 21) |
			((uint32_t)(input[96] & 0xf8) << 13);
	output[47] = (double)(value >> 16);

	// read output[48]: from bit 773 to 788
	value = ((uint32_t)(input[96] & 0x07) << 29) |
			((uint32_t)input[97] << 21) |
			((uint32_t)(input[98] & 0xf8) << 13);
	output[48] = (double)(value >> 16);

	// read output[49]: from bit 789 to 804
	value = ((uint32_t)(input[98] & 0x07) << 29) |
			((uint32_t)input[99] << 21) |
			((uint32_t)(input[100] & 0xf8) << 13);
	output[49] = (double)(value >> 16);

	// read output[50]: from bit 805 to 820
	value = ((uint32_t)(input[100] & 0x07) << 29) |
			((uint32_t)input[101] << 21) |
			((uint32_t)(input[102] & 0xf8) << 13);
	output[50] = (double)(value >> 16);

	// read output[51]: from bit 821 to 836
	value = ((uint32_t)(input[102] & 0x07) << 29) |
			((uint32_t)input[103] << 21) |
			((uint32_t)(input[104] & 0xf8) << 13);
	output[51] = (double)(value >> 16);

	// read output[52]: from bit 837 to 852
	value = ((uint32_t)(input[104] & 0x07) << 29) |
			((uint32_t)input[105] << 21) |
			((uint32_t)(input[106] & 0xf8) << 13);
	output[52] = (double)(value >> 16);

	// read output[53]: from bit 853 to 868
	value = ((uint32_t)(input[106] & 0x07) << 29) |
			((uint32_t)input[107] << 21) |
			((uint32_t)(input[108] & 0xf8) << 13);
	output[53] = (double)(value >> 16);

	// read output[54]: from bit 869 to 884
	value = ((uint32_t)(input[108] & 0x07) << 29) |
			((uint32_t)input[109] << 21) |
			((uint32_t)(input[110] & 0xf8) << 13);
	output[54] = (double)(value >> 16);

	// read output[55]: from bit 885 to 900
	value = ((uint32_t)(input[110] & 0x07) << 29) |
			((uint32_t)input[111] << 21) |
			((uint32_t)(input[112] & 0xf8) << 13);
	output[55] = (double)(value >> 16);

	// read output[56]: from bit 901 to 916
	value = ((uint32_t)(input[112] & 0x07) << 29) |
			((uint32_t)input[113] << 21) |
			((uint32_t)(input[114] & 0xf8) << 13);
	output[56] = (double)(value >> 16);

	// read output[57]: from bit 917 to 932
	value = ((uint32_t)(input[114] & 0x07) << 29) |
			((uint32_t)input[115] << 21) |
			((uint32_t)(input[116] & 0xf8) << 13);
	output[57] = (double)(value >> 16);

	// read output[58]: from bit 933 to 948
	value = ((uint32_t)(input[116] & 0x07) << 29) |
			((uint32_t)input[117] << 21) |
			((uint32_t)(input[118] & 0xf8) << 13);
	output[58] = (double)(value >> 16);

	// read output[59]: from bit 949 to 964
	value = ((uint32_t)(input[118] & 0x07) << 29) |
			((uint32_t)input[119] << 21) |
			((uint32_t)(input[120] & 0xf8) << 13);
	output[59] = (double)(value >> 16);
}

static void unpack_60_16bit_signed_6off(const uint8_t * input, double * output, void *closure) {
	// Unpack 60 values into output
	// Values are 16-bit signed
	// Skip 6 bits, read 960 bits of data.
	// Input must be at least 121 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 6 to 21
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)(input[2] & 0xfc) << 14);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 22 to 37
	value = ((uint32_t)(input[2] & 0x03) << 30) |
			((uint32_t)input[3] << 22) |
			((uint32_t)(input[4] & 0xfc) << 14);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 38 to 53
	value = ((uint32_t)(input[4] & 0x03) << 30) |
			((uint32_t)input[5] << 22) |
			((uint32_t)(input[6] & 0xfc) << 14);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 54 to 69
	value = ((uint32_t)(input[6] & 0x03) << 30) |
			((uint32_t)input[7] << 22) |
			((uint32_t)(input[8] & 0xfc) << 14);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 70 to 85
	value = ((uint32_t)(input[8] & 0x03) << 30) |
			((uint32_t)input[9] << 22) |
			((uint32_t)(input[10] & 0xfc) << 14);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 86 to 101
	value = ((uint32_t)(input[10] & 0x03) << 30) |
			((uint32_t)input[11] << 22) |
			((uint32_t)(input[12] & 0xfc) << 14);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 102 to 117
	value = ((uint32_t)(input[12] & 0x03) << 30) |
			((uint32_t)input[13] << 22) |
			((uint32_t)(input[14] & 0xfc) << 14);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 118 to 133
	value = ((uint32_t)(input[14] & 0x03) << 30) |
			((uint32_t)input[15] << 22) |
			((uint32_t)(input[16] & 0xfc) << 14);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 134 to 149
	value = ((uint32_t)(input[16] & 0x03) << 30) |
			((uint32_t)input[17] << 22) |
			((uint32_t)(input[18] & 0xfc) << 14);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 150 to 165
	value = ((uint32_t)(input[18] & 0x03) << 30) |
			((uint32_t)input[19] << 22) |
			((uint32_t)(input[20] & 0xfc) << 14);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 166 to 181
	value = ((uint32_t)(input[20] & 0x03) << 30) |
			((uint32_t)input[21] << 22) |
			((uint32_t)(input[22] & 0xfc) << 14);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 182 to 197
	value = ((uint32_t)(input[22] & 0x03) << 30) |
			((uint32_t)input[23] << 22) |
			((uint32_t)(input[24] & 0xfc) << 14);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 198 to 213
	value = ((uint32_t)(input[24] & 0x03) << 30) |
			((uint32_t)input[25] << 22) |
			((uint32_t)(input[26] & 0xfc) << 14);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 214 to 229
	value = ((uint32_t)(input[26] & 0x03) << 30) |
			((uint32_t)input[27] << 22) |
			((uint32_t)(input[28] & 0xfc) << 14);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 230 to 245
	value = ((uint32_t)(input[28] & 0x03) << 30) |
			((uint32_t)input[29] << 22) |
			((uint32_t)(input[30] & 0xfc) << 14);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 246 to 261
	value = ((uint32_t)(input[30] & 0x03) << 30) |
			((uint32_t)input[31] << 22) |
			((uint32_t)(input[32] & 0xfc) << 14);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 262 to 277
	value = ((uint32_t)(input[32] & 0x03) << 30) |
			((uint32_t)input[33] << 22) |
			((uint32_t)(input[34] & 0xfc) << 14);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 278 to 293
	value = ((uint32_t)(input[34] & 0x03) << 30) |
			((uint32_t)input[35] << 22) |
			((uint32_t)(input[36] & 0xfc) << 14);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 294 to 309
	value = ((uint32_t)(input[36] & 0x03) << 30) |
			((uint32_t)input[37] << 22) |
			((uint32_t)(input[38] & 0xfc) << 14);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 310 to 325
	value = ((uint32_t)(input[38] & 0x03) << 30) |
			((uint32_t)input[39] << 22) |
			((uint32_t)(input[40] & 0xfc) << 14);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 326 to 341
	value = ((uint32_t)(input[40] & 0x03) << 30) |
			((uint32_t)input[41] << 22) |
			((uint32_t)(input[42] & 0xfc) << 14);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 342 to 357
	value = ((uint32_t)(input[42] & 0x03) << 30) |
			((uint32_t)input[43] << 22) |
			((uint32_t)(input[44] & 0xfc) << 14);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 358 to 373
	value = ((uint32_t)(input[44] & 0x03) << 30) |
			((uint32_t)input[45] << 22) |
			((uint32_t)(input[46] & 0xfc) << 14);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 374 to 389
	value = ((uint32_t)(input[46] & 0x03) << 30) |
			((uint32_t)input[47] << 22) |
			((uint32_t)(input[48] & 0xfc) << 14);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 390 to 405
	value = ((uint32_t)(input[48] & 0x03) << 30) |
			((uint32_t)input[49] << 22) |
			((uint32_t)(input[50] & 0xfc) << 14);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 406 to 421
	value = ((uint32_t)(input[50] & 0x03) << 30) |
			((uint32_t)input[51] << 22) |
			((uint32_t)(input[52] & 0xfc) << 14);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 422 to 437
	value = ((uint32_t)(input[52] & 0x03) << 30) |
			((uint32_t)input[53] << 22) |
			((uint32_t)(input[54] & 0xfc) << 14);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 438 to 453
	value = ((uint32_t)(input[54] & 0x03) << 30) |
			((uint32_t)input[55] << 22) |
			((uint32_t)(input[56] & 0xfc) << 14);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 454 to 469
	value = ((uint32_t)(input[56] & 0x03) << 30) |
			((uint32_t)input[57] << 22) |
			((uint32_t)(input[58] & 0xfc) << 14);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 470 to 485
	value = ((uint32_t)(input[58] & 0x03) << 30) |
			((uint32_t)input[59] << 22) |
			((uint32_t)(input[60] & 0xfc) << 14);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 486 to 501
	value = ((uint32_t)(input[60] & 0x03) << 30) |
			((uint32_t)input[61] << 22) |
			((uint32_t)(input[62] & 0xfc) << 14);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 502 to 517
	value = ((uint32_t)(input[62] & 0x03) << 30) |
			((uint32_t)input[63] << 22) |
			((uint32_t)(input[64] & 0xfc) << 14);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 518 to 533
	value = ((uint32_t)(input[64] & 0x03) << 30) |
			((uint32_t)input[65] << 22) |
			((uint32_t)(input[66] & 0xfc) << 14);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 534 to 549
	value = ((uint32_t)(input[66] & 0x03) << 30) |
			((uint32_t)input[67] << 22) |
			((uint32_t)(input[68] & 0xfc) << 14);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 550 to 565
	value = ((uint32_t)(input[68] & 0x03) << 30) |
			((uint32_t)input[69] << 22) |
			((uint32_t)(input[70] & 0xfc) << 14);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 566 to 581
	value = ((uint32_t)(input[70] & 0x03) << 30) |
			((uint32_t)input[71] << 22) |
			((uint32_t)(input[72] & 0xfc) << 14);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 582 to 597
	value = ((uint32_t)(input[72] & 0x03) << 30) |
			((uint32_t)input[73] << 22) |
			((uint32_t)(input[74] & 0xfc) << 14);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 598 to 613
	value = ((uint32_t)(input[74] & 0x03) << 30) |
			((uint32_t)input[75] << 22) |
			((uint32_t)(input[76] & 0xfc) << 14);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 614 to 629
	value = ((uint32_t)(input[76] & 0x03) << 30) |
			((uint32_t)input[77] << 22) |
			((uint32_t)(input[78] & 0xfc) << 14);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 630 to 645
	value = ((uint32_t)(input[78] & 0x03) << 30) |
			((uint32_t)input[79] << 22) |
			((uint32_t)(input[80] & 0xfc) << 14);
	output[39] = (double)(value >> 16);

	// read output[40]: from bit 646 to 661
	value = ((uint32_t)(input[80] & 0x03) << 30) |
			((uint32_t)input[81] << 22) |
			((uint32_t)(input[82] & 0xfc) << 14);
	output[40] = (double)(value >> 16);

	// read output[41]: from bit 662 to 677
	value = ((uint32_t)(input[82] & 0x03) << 30) |
			((uint32_t)input[83] << 22) |
			((uint32_t)(input[84] & 0xfc) << 14);
	output[41] = (double)(value >> 16);

	// read output[42]: from bit 678 to 693
	value = ((uint32_t)(input[84] & 0x03) << 30) |
			((uint32_t)input[85] << 22) |
			((uint32_t)(input[86] & 0xfc) << 14);
	output[42] = (double)(value >> 16);

	// read output[43]: from bit 694 to 709
	value = ((uint32_t)(input[86] & 0x03) << 30) |
			((uint32_t)input[87] << 22) |
			((uint32_t)(input[88] & 0xfc) << 14);
	output[43] = (double)(value >> 16);

	// read output[44]: from bit 710 to 725
	value = ((uint32_t)(input[88] & 0x03) << 30) |
			((uint32_t)input[89] << 22) |
			((uint32_t)(input[90] & 0xfc) << 14);
	output[44] = (double)(value >> 16);

	// read output[45]: from bit 726 to 741
	value = ((uint32_t)(input[90] & 0x03) << 30) |
			((uint32_t)input[91] << 22) |
			((uint32_t)(input[92] & 0xfc) << 14);
	output[45] = (double)(value >> 16);

	// read output[46]: from bit 742 to 757
	value = ((uint32_t)(input[92] & 0x03) << 30) |
			((uint32_t)input[93] << 22) |
			((uint32_t)(input[94] & 0xfc) << 14);
	output[46] = (double)(value >> 16);

	// read output[47]: from bit 758 to 773
	value = ((uint32_t)(input[94] & 0x03) << 30) |
			((uint32_t)input[95] << 22) |
			((uint32_t)(input[96] & 0xfc) << 14);
	output[47] = (double)(value >> 16);

	// read output[48]: from bit 774 to 789
	value = ((uint32_t)(input[96] & 0x03) << 30) |
			((uint32_t)input[97] << 22) |
			((uint32_t)(input[98] & 0xfc) << 14);
	output[48] = (double)(value >> 16);

	// read output[49]: from bit 790 to 805
	value = ((uint32_t)(input[98] & 0x03) << 30) |
			((uint32_t)input[99] << 22) |
			((uint32_t)(input[100] & 0xfc) << 14);
	output[49] = (double)(value >> 16);

	// read output[50]: from bit 806 to 821
	value = ((uint32_t)(input[100] & 0x03) << 30) |
			((uint32_t)input[101] << 22) |
			((uint32_t)(input[102] & 0xfc) << 14);
	output[50] = (double)(value >> 16);

	// read output[51]: from bit 822 to 837
	value = ((uint32_t)(input[102] & 0x03) << 30) |
			((uint32_t)input[103] << 22) |
			((uint32_t)(input[104] & 0xfc) << 14);
	output[51] = (double)(value >> 16);

	// read output[52]: from bit 838 to 853
	value = ((uint32_t)(input[104] & 0x03) << 30) |
			((uint32_t)input[105] << 22) |
			((uint32_t)(input[106] & 0xfc) << 14);
	output[52] = (double)(value >> 16);

	// read output[53]: from bit 854 to 869
	value = ((uint32_t)(input[106] & 0x03) << 30) |
			((uint32_t)input[107] << 22) |
			((uint32_t)(input[108] & 0xfc) << 14);
	output[53] = (double)(value >> 16);

	// read output[54]: from bit 870 to 885
	value = ((uint32_t)(input[108] & 0x03) << 30) |
			((uint32_t)input[109] << 22) |
			((uint32_t)(input[110] & 0xfc) << 14);
	output[54] = (double)(value >> 16);

	// read output[55]: from bit 886 to 901
	value = ((uint32_t)(input[110] & 0x03) << 30) |
			((uint32_t)input[111] << 22) |
			((uint32_t)(input[112] & 0xfc) << 14);
	output[55] = (double)(value >> 16);

	// read output[56]: from bit 902 to 917
	value = ((uint32_t)(input[112] & 0x03) << 30) |
			((uint32_t)input[113] << 22) |
			((uint32_t)(input[114] & 0xfc) << 14);
	output[56] = (double)(value >> 16);

	// read output[57]: from bit 918 to 933
	value = ((uint32_t)(input[114] & 0x03) << 30) |
			((uint32_t)input[115] << 22) |
			((uint32_t)(input[116] & 0xfc) << 14);
	output[57] = (double)(value >> 16);

	// read output[58]: from bit 934 to 949
	value = ((uint32_t)(input[116] & 0x03) << 30) |
			((uint32_t)input[117] << 22) |
			((uint32_t)(input[118] & 0xfc) << 14);
	output[58] = (double)(value >> 16);

	// read output[59]: from bit 950 to 965
	value = ((uint32_t)(input[118] & 0x03) << 30) |
			((uint32_t)input[119] << 22) |
			((uint32_t)(input[120] & 0xfc) << 14);
	output[59] = (double)(value >> 16);
}

static void unpack_60_16bit_unsigned_6off(const uint8_t * input, double * output, void *closure) {
	// Unpack 60 values into output
	// Values are 16-bit unsigned
	// Skip 6 bits, read 960 bits of data.
	// Input must be at least 121 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 6 to 21
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)(input[2] & 0xfc) << 14);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 22 to 37
	value = ((uint32_t)(input[2] & 0x03) << 30) |
			((uint32_t)input[3] << 22) |
			((uint32_t)(input[4] & 0xfc) << 14);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 38 to 53
	value = ((uint32_t)(input[4] & 0x03) << 30) |
			((uint32_t)input[5] << 22) |
			((uint32_t)(input[6] & 0xfc) << 14);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 54 to 69
	value = ((uint32_t)(input[6] & 0x03) << 30) |
			((uint32_t)input[7] << 22) |
			((uint32_t)(input[8] & 0xfc) << 14);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 70 to 85
	value = ((uint32_t)(input[8] & 0x03) << 30) |
			((uint32_t)input[9] << 22) |
			((uint32_t)(input[10] & 0xfc) << 14);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 86 to 101
	value = ((uint32_t)(input[10] & 0x03) << 30) |
			((uint32_t)input[11] << 22) |
			((uint32_t)(input[12] & 0xfc) << 14);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 102 to 117
	value = ((uint32_t)(input[12] & 0x03) << 30) |
			((uint32_t)input[13] << 22) |
			((uint32_t)(input[14] & 0xfc) << 14);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 118 to 133
	value = ((uint32_t)(input[14] & 0x03) << 30) |
			((uint32_t)input[15] << 22) |
			((uint32_t)(input[16] & 0xfc) << 14);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 134 to 149
	value = ((uint32_t)(input[16] & 0x03) << 30) |
			((uint32_t)input[17] << 22) |
			((uint32_t)(input[18] & 0xfc) << 14);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 150 to 165
	value = ((uint32_t)(input[18] & 0x03) << 30) |
			((uint32_t)input[19] << 22) |
			((uint32_t)(input[20] & 0xfc) << 14);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 166 to 181
	value = ((uint32_t)(input[20] & 0x03) << 30) |
			((uint32_t)input[21] << 22) |
			((uint32_t)(input[22] & 0xfc) << 14);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 182 to 197
	value = ((uint32_t)(input[22] & 0x03) << 30) |
			((uint32_t)input[23] << 22) |
			((uint32_t)(input[24] & 0xfc) << 14);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 198 to 213
	value = ((uint32_t)(input[24] & 0x03) << 30) |
			((uint32_t)input[25] << 22) |
			((uint32_t)(input[26] & 0xfc) << 14);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 214 to 229
	value = ((uint32_t)(input[26] & 0x03) << 30) |
			((uint32_t)input[27] << 22) |
			((uint32_t)(input[28] & 0xfc) << 14);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 230 to 245
	value = ((uint32_t)(input[28] & 0x03) << 30) |
			((uint32_t)input[29] << 22) |
			((uint32_t)(input[30] & 0xfc) << 14);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 246 to 261
	value = ((uint32_t)(input[30] & 0x03) << 30) |
			((uint32_t)input[31] << 22) |
			((uint32_t)(input[32] & 0xfc) << 14);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 262 to 277
	value = ((uint32_t)(input[32] & 0x03) << 30) |
			((uint32_t)input[33] << 22) |
			((uint32_t)(input[34] & 0xfc) << 14);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 278 to 293
	value = ((uint32_t)(input[34] & 0x03) << 30) |
			((uint32_t)input[35] << 22) |
			((uint32_t)(input[36] & 0xfc) << 14);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 294 to 309
	value = ((uint32_t)(input[36] & 0x03) << 30) |
			((uint32_t)input[37] << 22) |
			((uint32_t)(input[38] & 0xfc) << 14);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 310 to 325
	value = ((uint32_t)(input[38] & 0x03) << 30) |
			((uint32_t)input[39] << 22) |
			((uint32_t)(input[40] & 0xfc) << 14);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 326 to 341
	value = ((uint32_t)(input[40] & 0x03) << 30) |
			((uint32_t)input[41] << 22) |
			((uint32_t)(input[42] & 0xfc) << 14);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 342 to 357
	value = ((uint32_t)(input[42] & 0x03) << 30) |
			((uint32_t)input[43] << 22) |
			((uint32_t)(input[44] & 0xfc) << 14);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 358 to 373
	value = ((uint32_t)(input[44] & 0x03) << 30) |
			((uint32_t)input[45] << 22) |
			((uint32_t)(input[46] & 0xfc) << 14);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 374 to 389
	value = ((uint32_t)(input[46] & 0x03) << 30) |
			((uint32_t)input[47] << 22) |
			((uint32_t)(input[48] & 0xfc) << 14);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 390 to 405
	value = ((uint32_t)(input[48] & 0x03) << 30) |
			((uint32_t)input[49] << 22) |
			((uint32_t)(input[50] & 0xfc) << 14);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 406 to 421
	value = ((uint32_t)(input[50] & 0x03) << 30) |
			((uint32_t)input[51] << 22) |
			((uint32_t)(input[52] & 0xfc) << 14);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 422 to 437
	value = ((uint32_t)(input[52] & 0x03) << 30) |
			((uint32_t)input[53] << 22) |
			((uint32_t)(input[54] & 0xfc) << 14);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 438 to 453
	value = ((uint32_t)(input[54] & 0x03) << 30) |
			((uint32_t)input[55] << 22) |
			((uint32_t)(input[56] & 0xfc) << 14);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 454 to 469
	value = ((uint32_t)(input[56] & 0x03) << 30) |
			((uint32_t)input[57] << 22) |
			((uint32_t)(input[58] & 0xfc) << 14);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 470 to 485
	value = ((uint32_t)(input[58] & 0x03) << 30) |
			((uint32_t)input[59] << 22) |
			((uint32_t)(input[60] & 0xfc) << 14);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 486 to 501
	value = ((uint32_t)(input[60] & 0x03) << 30) |
			((uint32_t)input[61] << 22) |
			((uint32_t)(input[62] & 0xfc) << 14);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 502 to 517
	value = ((uint32_t)(input[62] & 0x03) << 30) |
			((uint32_t)input[63] << 22) |
			((uint32_t)(input[64] & 0xfc) << 14);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 518 to 533
	value = ((uint32_t)(input[64] & 0x03) << 30) |
			((uint32_t)input[65] << 22) |
			((uint32_t)(input[66] & 0xfc) << 14);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 534 to 549
	value = ((uint32_t)(input[66] & 0x03) << 30) |
			((uint32_t)input[67] << 22) |
			((uint32_t)(input[68] & 0xfc) << 14);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 550 to 565
	value = ((uint32_t)(input[68] & 0x03) << 30) |
			((uint32_t)input[69] << 22) |
			((uint32_t)(input[70] & 0xfc) << 14);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 566 to 581
	value = ((uint32_t)(input[70] & 0x03) << 30) |
			((uint32_t)input[71] << 22) |
			((uint32_t)(input[72] & 0xfc) << 14);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 582 to 597
	value = ((uint32_t)(input[72] & 0x03) << 30) |
			((uint32_t)input[73] << 22) |
			((uint32_t)(input[74] & 0xfc) << 14);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 598 to 613
	value = ((uint32_t)(input[74] & 0x03) << 30) |
			((uint32_t)input[75] << 22) |
			((uint32_t)(input[76] & 0xfc) << 14);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 614 to 629
	value = ((uint32_t)(input[76] & 0x03) << 30) |
			((uint32_t)input[77] << 22) |
			((uint32_t)(input[78] & 0xfc) << 14);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 630 to 645
	value = ((uint32_t)(input[78] & 0x03) << 30) |
			((uint32_t)input[79] << 22) |
			((uint32_t)(input[80] & 0xfc) << 14);
	output[39] = (double)(value >> 16);

	// read output[40]: from bit 646 to 661
	value = ((uint32_t)(input[80] & 0x03) << 30) |
			((uint32_t)input[81] << 22) |
			((uint32_t)(input[82] & 0xfc) << 14);
	output[40] = (double)(value >> 16);

	// read output[41]: from bit 662 to 677
	value = ((uint32_t)(input[82] & 0x03) << 30) |
			((uint32_t)input[83] << 22) |
			((uint32_t)(input[84] & 0xfc) << 14);
	output[41] = (double)(value >> 16);

	// read output[42]: from bit 678 to 693
	value = ((uint32_t)(input[84] & 0x03) << 30) |
			((uint32_t)input[85] << 22) |
			((uint32_t)(input[86] & 0xfc) << 14);
	output[42] = (double)(value >> 16);

	// read output[43]: from bit 694 to 709
	value = ((uint32_t)(input[86] & 0x03) << 30) |
			((uint32_t)input[87] << 22) |
			((uint32_t)(input[88] & 0xfc) << 14);
	output[43] = (double)(value >> 16);

	// read output[44]: from bit 710 to 725
	value = ((uint32_t)(input[88] & 0x03) << 30) |
			((uint32_t)input[89] << 22) |
			((uint32_t)(input[90] & 0xfc) << 14);
	output[44] = (double)(value >> 16);

	// read output[45]: from bit 726 to 741
	value = ((uint32_t)(input[90] & 0x03) << 30) |
			((uint32_t)input[91] << 22) |
			((uint32_t)(input[92] & 0xfc) << 14);
	output[45] = (double)(value >> 16);

	// read output[46]: from bit 742 to 757
	value = ((uint32_t)(input[92] & 0x03) << 30) |
			((uint32_t)input[93] << 22) |
			((uint32_t)(input[94] & 0xfc) << 14);
	output[46] = (double)(value >> 16);

	// read output[47]: from bit 758 to 773
	value = ((uint32_t)(input[94] & 0x03) << 30) |
			((uint32_t)input[95] << 22) |
			((uint32_t)(input[96] & 0xfc) << 14);
	output[47] = (double)(value >> 16);

	// read output[48]: from bit 774 to 789
	value = ((uint32_t)(input[96] & 0x03) << 30) |
			((uint32_t)input[97] << 22) |
			((uint32_t)(input[98] & 0xfc) << 14);
	output[48] = (double)(value >> 16);

	// read output[49]: from bit 790 to 805
	value = ((uint32_t)(input[98] & 0x03) << 30) |
			((uint32_t)input[99] << 22) |
			((uint32_t)(input[100] & 0xfc) << 14);
	output[49] = (double)(value >> 16);

	// read output[50]: from bit 806 to 821
	value = ((uint32_t)(input[100] & 0x03) << 30) |
			((uint32_t)input[101] << 22) |
			((uint32_t)(input[102] & 0xfc) << 14);
	output[50] = (double)(value >> 16);

	// read output[51]: from bit 822 to 837
	value = ((uint32_t)(input[102] & 0x03) << 30) |
			((uint32_t)input[103] << 22) |
			((uint32_t)(input[104] & 0xfc) << 14);
	output[51] = (double)(value >> 16);

	// read output[52]: from bit 838 to 853
	value = ((uint32_t)(input[104] & 0x03) << 30) |
			((uint32_t)input[105] << 22) |
			((uint32_t)(input[106] & 0xfc) << 14);
	output[52] = (double)(value >> 16);

	// read output[53]: from bit 854 to 869
	value = ((uint32_t)(input[106] & 0x03) << 30) |
			((uint32_t)input[107] << 22) |
			((uint32_t)(input[108] & 0xfc) << 14);
	output[53] = (double)(value >> 16);

	// read output[54]: from bit 870 to 885
	value = ((uint32_t)(input[108] & 0x03) << 30) |
			((uint32_t)input[109] << 22) |
			((uint32_t)(input[110] & 0xfc) << 14);
	output[54] = (double)(value >> 16);

	// read output[55]: from bit 886 to 901
	value = ((uint32_t)(input[110] & 0x03) << 30) |
			((uint32_t)input[111] << 22) |
			((uint32_t)(input[112] & 0xfc) << 14);
	output[55] = (double)(value >> 16);

	// read output[56]: from bit 902 to 917
	value = ((uint32_t)(input[112] & 0x03) << 30) |
			((uint32_t)input[113] << 22) |
			((uint32_t)(input[114] & 0xfc) << 14);
	output[56] = (double)(value >> 16);

	// read output[57]: from bit 918 to 933
	value = ((uint32_t)(input[114] & 0x03) << 30) |
			((uint32_t)input[115] << 22) |
			((uint32_t)(input[116] & 0xfc) << 14);
	output[57] = (double)(value >> 16);

	// read output[58]: from bit 934 to 949
	value = ((uint32_t)(input[116] & 0x03) << 30) |
			((uint32_t)input[117] << 22) |
			((uint32_t)(input[118] & 0xfc) << 14);
	output[58] = (double)(value >> 16);

	// read output[59]: from bit 950 to 965
	value = ((uint32_t)(input[118] & 0x03) << 30) |
			((uint32_t)input[119] << 22) |
			((uint32_t)(input[120] & 0xfc) << 14);
	output[59] = (double)(value >> 16);
}

static void unpack_60_16bit_signed_7off(const uint8_t * input, double * output, void *closure) {
	// Unpack 60 values into output
	// Values are 16-bit signed
	// Skip 7 bits, read 960 bits of data.
	// Input must be at least 121 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 7 to 22
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)(input[2] & 0xfe) << 15);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 23 to 38
	value = ((uint32_t)(input[2] & 0x01) << 31) |
			((uint32_t)input[3] << 23) |
			((uint32_t)(input[4] & 0xfe) << 15);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 39 to 54
	value = ((uint32_t)(input[4] & 0x01) << 31) |
			((uint32_t)input[5] << 23) |
			((uint32_t)(input[6] & 0xfe) << 15);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 55 to 70
	value = ((uint32_t)(input[6] & 0x01) << 31) |
			((uint32_t)input[7] << 23) |
			((uint32_t)(input[8] & 0xfe) << 15);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 71 to 86
	value = ((uint32_t)(input[8] & 0x01) << 31) |
			((uint32_t)input[9] << 23) |
			((uint32_t)(input[10] & 0xfe) << 15);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 87 to 102
	value = ((uint32_t)(input[10] & 0x01) << 31) |
			((uint32_t)input[11] << 23) |
			((uint32_t)(input[12] & 0xfe) << 15);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 103 to 118
	value = ((uint32_t)(input[12] & 0x01) << 31) |
			((uint32_t)input[13] << 23) |
			((uint32_t)(input[14] & 0xfe) << 15);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 119 to 134
	value = ((uint32_t)(input[14] & 0x01) << 31) |
			((uint32_t)input[15] << 23) |
			((uint32_t)(input[16] & 0xfe) << 15);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 135 to 150
	value = ((uint32_t)(input[16] & 0x01) << 31) |
			((uint32_t)input[17] << 23) |
			((uint32_t)(input[18] & 0xfe) << 15);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 151 to 166
	value = ((uint32_t)(input[18] & 0x01) << 31) |
			((uint32_t)input[19] << 23) |
			((uint32_t)(input[20] & 0xfe) << 15);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 167 to 182
	value = ((uint32_t)(input[20] & 0x01) << 31) |
			((uint32_t)input[21] << 23) |
			((uint32_t)(input[22] & 0xfe) << 15);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 183 to 198
	value = ((uint32_t)(input[22] & 0x01) << 31) |
			((uint32_t)input[23] << 23) |
			((uint32_t)(input[24] & 0xfe) << 15);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 199 to 214
	value = ((uint32_t)(input[24] & 0x01) << 31) |
			((uint32_t)input[25] << 23) |
			((uint32_t)(input[26] & 0xfe) << 15);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 215 to 230
	value = ((uint32_t)(input[26] & 0x01) << 31) |
			((uint32_t)input[27] << 23) |
			((uint32_t)(input[28] & 0xfe) << 15);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 231 to 246
	value = ((uint32_t)(input[28] & 0x01) << 31) |
			((uint32_t)input[29] << 23) |
			((uint32_t)(input[30] & 0xfe) << 15);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 247 to 262
	value = ((uint32_t)(input[30] & 0x01) << 31) |
			((uint32_t)input[31] << 23) |
			((uint32_t)(input[32] & 0xfe) << 15);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 263 to 278
	value = ((uint32_t)(input[32] & 0x01) << 31) |
			((uint32_t)input[33] << 23) |
			((uint32_t)(input[34] & 0xfe) << 15);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 279 to 294
	value = ((uint32_t)(input[34] & 0x01) << 31) |
			((uint32_t)input[35] << 23) |
			((uint32_t)(input[36] & 0xfe) << 15);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 295 to 310
	value = ((uint32_t)(input[36] & 0x01) << 31) |
			((uint32_t)input[37] << 23) |
			((uint32_t)(input[38] & 0xfe) << 15);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 311 to 326
	value = ((uint32_t)(input[38] & 0x01) << 31) |
			((uint32_t)input[39] << 23) |
			((uint32_t)(input[40] & 0xfe) << 15);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 327 to 342
	value = ((uint32_t)(input[40] & 0x01) << 31) |
			((uint32_t)input[41] << 23) |
			((uint32_t)(input[42] & 0xfe) << 15);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 343 to 358
	value = ((uint32_t)(input[42] & 0x01) << 31) |
			((uint32_t)input[43] << 23) |
			((uint32_t)(input[44] & 0xfe) << 15);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 359 to 374
	value = ((uint32_t)(input[44] & 0x01) << 31) |
			((uint32_t)input[45] << 23) |
			((uint32_t)(input[46] & 0xfe) << 15);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 375 to 390
	value = ((uint32_t)(input[46] & 0x01) << 31) |
			((uint32_t)input[47] << 23) |
			((uint32_t)(input[48] & 0xfe) << 15);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 391 to 406
	value = ((uint32_t)(input[48] & 0x01) << 31) |
			((uint32_t)input[49] << 23) |
			((uint32_t)(input[50] & 0xfe) << 15);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 407 to 422
	value = ((uint32_t)(input[50] & 0x01) << 31) |
			((uint32_t)input[51] << 23) |
			((uint32_t)(input[52] & 0xfe) << 15);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 423 to 438
	value = ((uint32_t)(input[52] & 0x01) << 31) |
			((uint32_t)input[53] << 23) |
			((uint32_t)(input[54] & 0xfe) << 15);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 439 to 454
	value = ((uint32_t)(input[54] & 0x01) << 31) |
			((uint32_t)input[55] << 23) |
			((uint32_t)(input[56] & 0xfe) << 15);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 455 to 470
	value = ((uint32_t)(input[56] & 0x01) << 31) |
			((uint32_t)input[57] << 23) |
			((uint32_t)(input[58] & 0xfe) << 15);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 471 to 486
	value = ((uint32_t)(input[58] & 0x01) << 31) |
			((uint32_t)input[59] << 23) |
			((uint32_t)(input[60] & 0xfe) << 15);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 487 to 502
	value = ((uint32_t)(input[60] & 0x01) << 31) |
			((uint32_t)input[61] << 23) |
			((uint32_t)(input[62] & 0xfe) << 15);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 503 to 518
	value = ((uint32_t)(input[62] & 0x01) << 31) |
			((uint32_t)input[63] << 23) |
			((uint32_t)(input[64] & 0xfe) << 15);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 519 to 534
	value = ((uint32_t)(input[64] & 0x01) << 31) |
			((uint32_t)input[65] << 23) |
			((uint32_t)(input[66] & 0xfe) << 15);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 535 to 550
	value = ((uint32_t)(input[66] & 0x01) << 31) |
			((uint32_t)input[67] << 23) |
			((uint32_t)(input[68] & 0xfe) << 15);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 551 to 566
	value = ((uint32_t)(input[68] & 0x01) << 31) |
			((uint32_t)input[69] << 23) |
			((uint32_t)(input[70] & 0xfe) << 15);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 567 to 582
	value = ((uint32_t)(input[70] & 0x01) << 31) |
			((uint32_t)input[71] << 23) |
			((uint32_t)(input[72] & 0xfe) << 15);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 583 to 598
	value = ((uint32_t)(input[72] & 0x01) << 31) |
			((uint32_t)input[73] << 23) |
			((uint32_t)(input[74] & 0xfe) << 15);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 599 to 614
	value = ((uint32_t)(input[74] & 0x01) << 31) |
			((uint32_t)input[75] << 23) |
			((uint32_t)(input[76] & 0xfe) << 15);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 615 to 630
	value = ((uint32_t)(input[76] & 0x01) << 31) |
			((uint32_t)input[77] << 23) |
			((uint32_t)(input[78] & 0xfe) << 15);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 631 to 646
	value = ((uint32_t)(input[78] & 0x01) << 31) |
			((uint32_t)input[79] << 23) |
			((uint32_t)(input[80] & 0xfe) << 15);
	output[39] = (double)(value >> 16);

	// read output[40]: from bit 647 to 662
	value = ((uint32_t)(input[80] & 0x01) << 31) |
			((uint32_t)input[81] << 23) |
			((uint32_t)(input[82] & 0xfe) << 15);
	output[40] = (double)(value >> 16);

	// read output[41]: from bit 663 to 678
	value = ((uint32_t)(input[82] & 0x01) << 31) |
			((uint32_t)input[83] << 23) |
			((uint32_t)(input[84] & 0xfe) << 15);
	output[41] = (double)(value >> 16);

	// read output[42]: from bit 679 to 694
	value = ((uint32_t)(input[84] & 0x01) << 31) |
			((uint32_t)input[85] << 23) |
			((uint32_t)(input[86] & 0xfe) << 15);
	output[42] = (double)(value >> 16);

	// read output[43]: from bit 695 to 710
	value = ((uint32_t)(input[86] & 0x01) << 31) |
			((uint32_t)input[87] << 23) |
			((uint32_t)(input[88] & 0xfe) << 15);
	output[43] = (double)(value >> 16);

	// read output[44]: from bit 711 to 726
	value = ((uint32_t)(input[88] & 0x01) << 31) |
			((uint32_t)input[89] << 23) |
			((uint32_t)(input[90] & 0xfe) << 15);
	output[44] = (double)(value >> 16);

	// read output[45]: from bit 727 to 742
	value = ((uint32_t)(input[90] & 0x01) << 31) |
			((uint32_t)input[91] << 23) |
			((uint32_t)(input[92] & 0xfe) << 15);
	output[45] = (double)(value >> 16);

	// read output[46]: from bit 743 to 758
	value = ((uint32_t)(input[92] & 0x01) << 31) |
			((uint32_t)input[93] << 23) |
			((uint32_t)(input[94] & 0xfe) << 15);
	output[46] = (double)(value >> 16);

	// read output[47]: from bit 759 to 774
	value = ((uint32_t)(input[94] & 0x01) << 31) |
			((uint32_t)input[95] << 23) |
			((uint32_t)(input[96] & 0xfe) << 15);
	output[47] = (double)(value >> 16);

	// read output[48]: from bit 775 to 790
	value = ((uint32_t)(input[96] & 0x01) << 31) |
			((uint32_t)input[97] << 23) |
			((uint32_t)(input[98] & 0xfe) << 15);
	output[48] = (double)(value >> 16);

	// read output[49]: from bit 791 to 806
	value = ((uint32_t)(input[98] & 0x01) << 31) |
			((uint32_t)input[99] << 23) |
			((uint32_t)(input[100] & 0xfe) << 15);
	output[49] = (double)(value >> 16);

	// read output[50]: from bit 807 to 822
	value = ((uint32_t)(input[100] & 0x01) << 31) |
			((uint32_t)input[101] << 23) |
			((uint32_t)(input[102] & 0xfe) << 15);
	output[50] = (double)(value >> 16);

	// read output[51]: from bit 823 to 838
	value = ((uint32_t)(input[102] & 0x01) << 31) |
			((uint32_t)input[103] << 23) |
			((uint32_t)(input[104] & 0xfe) << 15);
	output[51] = (double)(value >> 16);

	// read output[52]: from bit 839 to 854
	value = ((uint32_t)(input[104] & 0x01) << 31) |
			((uint32_t)input[105] << 23) |
			((uint32_t)(input[106] & 0xfe) << 15);
	output[52] = (double)(value >> 16);

	// read output[53]: from bit 855 to 870
	value = ((uint32_t)(input[106] & 0x01) << 31) |
			((uint32_t)input[107] << 23) |
			((uint32_t)(input[108] & 0xfe) << 15);
	output[53] = (double)(value >> 16);

	// read output[54]: from bit 871 to 886
	value = ((uint32_t)(input[108] & 0x01) << 31) |
			((uint32_t)input[109] << 23) |
			((uint32_t)(input[110] & 0xfe) << 15);
	output[54] = (double)(value >> 16);

	// read output[55]: from bit 887 to 902
	value = ((uint32_t)(input[110] & 0x01) << 31) |
			((uint32_t)input[111] << 23) |
			((uint32_t)(input[112] & 0xfe) << 15);
	output[55] = (double)(value >> 16);

	// read output[56]: from bit 903 to 918
	value = ((uint32_t)(input[112] & 0x01) << 31) |
			((uint32_t)input[113] << 23) |
			((uint32_t)(input[114] & 0xfe) << 15);
	output[56] = (double)(value >> 16);

	// read output[57]: from bit 919 to 934
	value = ((uint32_t)(input[114] & 0x01) << 31) |
			((uint32_t)input[115] << 23) |
			((uint32_t)(input[116] & 0xfe) << 15);
	output[57] = (double)(value >> 16);

	// read output[58]: from bit 935 to 950
	value = ((uint32_t)(input[116] & 0x01) << 31) |
			((uint32_t)input[117] << 23) |
			((uint32_t)(input[118] & 0xfe) << 15);
	output[58] = (double)(value >> 16);

	// read output[59]: from bit 951 to 966
	value = ((uint32_t)(input[118] & 0x01) << 31) |
			((uint32_t)input[119] << 23) |
			((uint32_t)(input[120] & 0xfe) << 15);
	output[59] = (double)(value >> 16);
}

static void unpack_60_16bit_unsigned_7off(const uint8_t * input, double * output, void *closure) {
	// Unpack 60 values into output
	// Values are 16-bit unsigned
	// Skip 7 bits, read 960 bits of data.
	// Input must be at least 121 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 7 to 22
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)(input[2] & 0xfe) << 15);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 23 to 38
	value = ((uint32_t)(input[2] & 0x01) << 31) |
			((uint32_t)input[3] << 23) |
			((uint32_t)(input[4] & 0xfe) << 15);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 39 to 54
	value = ((uint32_t)(input[4] & 0x01) << 31) |
			((uint32_t)input[5] << 23) |
			((uint32_t)(input[6] & 0xfe) << 15);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 55 to 70
	value = ((uint32_t)(input[6] & 0x01) << 31) |
			((uint32_t)input[7] << 23) |
			((uint32_t)(input[8] & 0xfe) << 15);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 71 to 86
	value = ((uint32_t)(input[8] & 0x01) << 31) |
			((uint32_t)input[9] << 23) |
			((uint32_t)(input[10] & 0xfe) << 15);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 87 to 102
	value = ((uint32_t)(input[10] & 0x01) << 31) |
			((uint32_t)input[11] << 23) |
			((uint32_t)(input[12] & 0xfe) << 15);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 103 to 118
	value = ((uint32_t)(input[12] & 0x01) << 31) |
			((uint32_t)input[13] << 23) |
			((uint32_t)(input[14] & 0xfe) << 15);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 119 to 134
	value = ((uint32_t)(input[14] & 0x01) << 31) |
			((uint32_t)input[15] << 23) |
			((uint32_t)(input[16] & 0xfe) << 15);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 135 to 150
	value = ((uint32_t)(input[16] & 0x01) << 31) |
			((uint32_t)input[17] << 23) |
			((uint32_t)(input[18] & 0xfe) << 15);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 151 to 166
	value = ((uint32_t)(input[18] & 0x01) << 31) |
			((uint32_t)input[19] << 23) |
			((uint32_t)(input[20] & 0xfe) << 15);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 167 to 182
	value = ((uint32_t)(input[20] & 0x01) << 31) |
			((uint32_t)input[21] << 23) |
			((uint32_t)(input[22] & 0xfe) << 15);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 183 to 198
	value = ((uint32_t)(input[22] & 0x01) << 31) |
			((uint32_t)input[23] << 23) |
			((uint32_t)(input[24] & 0xfe) << 15);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 199 to 214
	value = ((uint32_t)(input[24] & 0x01) << 31) |
			((uint32_t)input[25] << 23) |
			((uint32_t)(input[26] & 0xfe) << 15);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 215 to 230
	value = ((uint32_t)(input[26] & 0x01) << 31) |
			((uint32_t)input[27] << 23) |
			((uint32_t)(input[28] & 0xfe) << 15);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 231 to 246
	value = ((uint32_t)(input[28] & 0x01) << 31) |
			((uint32_t)input[29] << 23) |
			((uint32_t)(input[30] & 0xfe) << 15);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 247 to 262
	value = ((uint32_t)(input[30] & 0x01) << 31) |
			((uint32_t)input[31] << 23) |
			((uint32_t)(input[32] & 0xfe) << 15);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 263 to 278
	value = ((uint32_t)(input[32] & 0x01) << 31) |
			((uint32_t)input[33] << 23) |
			((uint32_t)(input[34] & 0xfe) << 15);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 279 to 294
	value = ((uint32_t)(input[34] & 0x01) << 31) |
			((uint32_t)input[35] << 23) |
			((uint32_t)(input[36] & 0xfe) << 15);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 295 to 310
	value = ((uint32_t)(input[36] & 0x01) << 31) |
			((uint32_t)input[37] << 23) |
			((uint32_t)(input[38] & 0xfe) << 15);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 311 to 326
	value = ((uint32_t)(input[38] & 0x01) << 31) |
			((uint32_t)input[39] << 23) |
			((uint32_t)(input[40] & 0xfe) << 15);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 327 to 342
	value = ((uint32_t)(input[40] & 0x01) << 31) |
			((uint32_t)input[41] << 23) |
			((uint32_t)(input[42] & 0xfe) << 15);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 343 to 358
	value = ((uint32_t)(input[42] & 0x01) << 31) |
			((uint32_t)input[43] << 23) |
			((uint32_t)(input[44] & 0xfe) << 15);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 359 to 374
	value = ((uint32_t)(input[44] & 0x01) << 31) |
			((uint32_t)input[45] << 23) |
			((uint32_t)(input[46] & 0xfe) << 15);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 375 to 390
	value = ((uint32_t)(input[46] & 0x01) << 31) |
			((uint32_t)input[47] << 23) |
			((uint32_t)(input[48] & 0xfe) << 15);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 391 to 406
	value = ((uint32_t)(input[48] & 0x01) << 31) |
			((uint32_t)input[49] << 23) |
			((uint32_t)(input[50] & 0xfe) << 15);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 407 to 422
	value = ((uint32_t)(input[50] & 0x01) << 31) |
			((uint32_t)input[51] << 23) |
			((uint32_t)(input[52] & 0xfe) << 15);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 423 to 438
	value = ((uint32_t)(input[52] & 0x01) << 31) |
			((uint32_t)input[53] << 23) |
			((uint32_t)(input[54] & 0xfe) << 15);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 439 to 454
	value = ((uint32_t)(input[54] & 0x01) << 31) |
			((uint32_t)input[55] << 23) |
			((uint32_t)(input[56] & 0xfe) << 15);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 455 to 470
	value = ((uint32_t)(input[56] & 0x01) << 31) |
			((uint32_t)input[57] << 23) |
			((uint32_t)(input[58] & 0xfe) << 15);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 471 to 486
	value = ((uint32_t)(input[58] & 0x01) << 31) |
			((uint32_t)input[59] << 23) |
			((uint32_t)(input[60] & 0xfe) << 15);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 487 to 502
	value = ((uint32_t)(input[60] & 0x01) << 31) |
			((uint32_t)input[61] << 23) |
			((uint32_t)(input[62] & 0xfe) << 15);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 503 to 518
	value = ((uint32_t)(input[62] & 0x01) << 31) |
			((uint32_t)input[63] << 23) |
			((uint32_t)(input[64] & 0xfe) << 15);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 519 to 534
	value = ((uint32_t)(input[64] & 0x01) << 31) |
			((uint32_t)input[65] << 23) |
			((uint32_t)(input[66] & 0xfe) << 15);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 535 to 550
	value = ((uint32_t)(input[66] & 0x01) << 31) |
			((uint32_t)input[67] << 23) |
			((uint32_t)(input[68] & 0xfe) << 15);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 551 to 566
	value = ((uint32_t)(input[68] & 0x01) << 31) |
			((uint32_t)input[69] << 23) |
			((uint32_t)(input[70] & 0xfe) << 15);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 567 to 582
	value = ((uint32_t)(input[70] & 0x01) << 31) |
			((uint32_t)input[71] << 23) |
			((uint32_t)(input[72] & 0xfe) << 15);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 583 to 598
	value = ((uint32_t)(input[72] & 0x01) << 31) |
			((uint32_t)input[73] << 23) |
			((uint32_t)(input[74] & 0xfe) << 15);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 599 to 614
	value = ((uint32_t)(input[74] & 0x01) << 31) |
			((uint32_t)input[75] << 23) |
			((uint32_t)(input[76] & 0xfe) << 15);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 615 to 630
	value = ((uint32_t)(input[76] & 0x01) << 31) |
			((uint32_t)input[77] << 23) |
			((uint32_t)(input[78] & 0xfe) << 15);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 631 to 646
	value = ((uint32_t)(input[78] & 0x01) << 31) |
			((uint32_t)input[79] << 23) |
			((uint32_t)(input[80] & 0xfe) << 15);
	output[39] = (double)(value >> 16);

	// read output[40]: from bit 647 to 662
	value = ((uint32_t)(input[80] & 0x01) << 31) |
			((uint32_t)input[81] << 23) |
			((uint32_t)(input[82] & 0xfe) << 15);
	output[40] = (double)(value >> 16);

	// read output[41]: from bit 663 to 678
	value = ((uint32_t)(input[82] & 0x01) << 31) |
			((uint32_t)input[83] << 23) |
			((uint32_t)(input[84] & 0xfe) << 15);
	output[41] = (double)(value >> 16);

	// read output[42]: from bit 679 to 694
	value = ((uint32_t)(input[84] & 0x01) << 31) |
			((uint32_t)input[85] << 23) |
			((uint32_t)(input[86] & 0xfe) << 15);
	output[42] = (double)(value >> 16);

	// read output[43]: from bit 695 to 710
	value = ((uint32_t)(input[86] & 0x01) << 31) |
			((uint32_t)input[87] << 23) |
			((uint32_t)(input[88] & 0xfe) << 15);
	output[43] = (double)(value >> 16);

	// read output[44]: from bit 711 to 726
	value = ((uint32_t)(input[88] & 0x01) << 31) |
			((uint32_t)input[89] << 23) |
			((uint32_t)(input[90] & 0xfe) << 15);
	output[44] = (double)(value >> 16);

	// read output[45]: from bit 727 to 742
	value = ((uint32_t)(input[90] & 0x01) << 31) |
			((uint32_t)input[91] << 23) |
			((uint32_t)(input[92] & 0xfe) << 15);
	output[45] = (double)(value >> 16);

	// read output[46]: from bit 743 to 758
	value = ((uint32_t)(input[92] & 0x01) << 31) |
			((uint32_t)input[93] << 23) |
			((uint32_t)(input[94] & 0xfe) << 15);
	output[46] = (double)(value >> 16);

	// read output[47]: from bit 759 to 774
	value = ((uint32_t)(input[94] & 0x01) << 31) |
			((uint32_t)input[95] << 23) |
			((uint32_t)(input[96] & 0xfe) << 15);
	output[47] = (double)(value >> 16);

	// read output[48]: from bit 775 to 790
	value = ((uint32_t)(input[96] & 0x01) << 31) |
			((uint32_t)input[97] << 23) |
			((uint32_t)(input[98] & 0xfe) << 15);
	output[48] = (double)(value >> 16);

	// read output[49]: from bit 791 to 806
	value = ((uint32_t)(input[98] & 0x01) << 31) |
			((uint32_t)input[99] << 23) |
			((uint32_t)(input[100] & 0xfe) << 15);
	output[49] = (double)(value >> 16);

	// read output[50]: from bit 807 to 822
	value = ((uint32_t)(input[100] & 0x01) << 31) |
			((uint32_t)input[101] << 23) |
			((uint32_t)(input[102] & 0xfe) << 15);
	output[50] = (double)(value >> 16);

	// read output[51]: from bit 823 to 838
	value = ((uint32_t)(input[102] & 0x01) << 31) |
			((uint32_t)input[103] << 23) |
			((uint32_t)(input[104] & 0xfe) << 15);
	output[51] = (double)(value >> 16);

	// read output[52]: from bit 839 to 854
	value = ((uint32_t)(input[104] & 0x01) << 31) |
			((uint32_t)input[105] << 23) |
			((uint32_t)(input[106] & 0xfe) << 15);
	output[52] = (double)(value >> 16);

	// read output[53]: from bit 855 to 870
	value = ((uint32_t)(input[106] & 0x01) << 31) |
			((uint32_t)input[107] << 23) |
			((uint32_t)(input[108] & 0xfe) << 15);
	output[53] = (double)(value >> 16);

	// read output[54]: from bit 871 to 886
	value = ((uint32_t)(input[108] & 0x01) << 31) |
			((uint32_t)input[109] << 23) |
			((uint32_t)(input[110] & 0xfe) << 15);
	output[54] = (double)(value >> 16);

	// read output[55]: from bit 887 to 902
	value = ((uint32_t)(input[110] & 0x01) << 31) |
			((uint32_t)input[111] << 23) |
			((uint32_t)(input[112] & 0xfe) << 15);
	output[55] = (double)(value >> 16);

	// read output[56]: from bit 903 to 918
	value = ((uint32_t)(input[112] & 0x01) << 31) |
			((uint32_t)input[113] << 23) |
			((uint32_t)(input[114] & 0xfe) << 15);
	output[56] = (double)(value >> 16);

	// read output[57]: from bit 919 to 934
	value = ((uint32_t)(input[114] & 0x01) << 31) |
			((uint32_t)input[115] << 23) |
			((uint32_t)(input[116] & 0xfe) << 15);
	output[57] = (double)(value >> 16);

	// read output[58]: from bit 935 to 950
	value = ((uint32_t)(input[116] & 0x01) << 31) |
			((uint32_t)input[117] << 23) |
			((uint32_t)(input[118] & 0xfe) << 15);
	output[58] = (double)(value >> 16);

	// read output[59]: from bit 951 to 966
	value = ((uint32_t)(input[118] & 0x01) << 31) |
			((uint32_t)input[119] << 23) |
			((uint32_t)(input[120] & 0xfe) << 15);
	output[59] = (double)(value >> 16);
}

static void unpack_61_16bit_signed_0off(const uint8_t * input, double * output, void *closure) {
	// Unpack 61 values into output
	// Values are 16-bit signed
	// Skip 0 bits, read 976 bits of data.
	// Input must be at least 122 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 0 to 15
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)input[1] << 16);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 16 to 31
	value = ((uint32_t)input[2] << 24) |
			((uint32_t)input[3] << 16);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 32 to 47
	value = ((uint32_t)input[4] << 24) |
			((uint32_t)input[5] << 16);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 48 to 63
	value = ((uint32_t)input[6] << 24) |
			((uint32_t)input[7] << 16);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 64 to 79
	value = ((uint32_t)input[8] << 24) |
			((uint32_t)input[9] << 16);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 80 to 95
	value = ((uint32_t)input[10] << 24) |
			((uint32_t)input[11] << 16);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 96 to 111
	value = ((uint32_t)input[12] << 24) |
			((uint32_t)input[13] << 16);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 112 to 127
	value = ((uint32_t)input[14] << 24) |
			((uint32_t)input[15] << 16);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 128 to 143
	value = ((uint32_t)input[16] << 24) |
			((uint32_t)input[17] << 16);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 144 to 159
	value = ((uint32_t)input[18] << 24) |
			((uint32_t)input[19] << 16);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 160 to 175
	value = ((uint32_t)input[20] << 24) |
			((uint32_t)input[21] << 16);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 176 to 191
	value = ((uint32_t)input[22] << 24) |
			((uint32_t)input[23] << 16);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 192 to 207
	value = ((uint32_t)input[24] << 24) |
			((uint32_t)input[25] << 16);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 208 to 223
	value = ((uint32_t)input[26] << 24) |
			((uint32_t)input[27] << 16);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 224 to 239
	value = ((uint32_t)input[28] << 24) |
			((uint32_t)input[29] << 16);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 240 to 255
	value = ((uint32_t)input[30] << 24) |
			((uint32_t)input[31] << 16);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 256 to 271
	value = ((uint32_t)input[32] << 24) |
			((uint32_t)input[33] << 16);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 272 to 287
	value = ((uint32_t)input[34] << 24) |
			((uint32_t)input[35] << 16);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 288 to 303
	value = ((uint32_t)input[36] << 24) |
			((uint32_t)input[37] << 16);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 304 to 319
	value = ((uint32_t)input[38] << 24) |
			((uint32_t)input[39] << 16);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 320 to 335
	value = ((uint32_t)input[40] << 24) |
			((uint32_t)input[41] << 16);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 336 to 351
	value = ((uint32_t)input[42] << 24) |
			((uint32_t)input[43] << 16);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 352 to 367
	value = ((uint32_t)input[44] << 24) |
			((uint32_t)input[45] << 16);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 368 to 383
	value = ((uint32_t)input[46] << 24) |
			((uint32_t)input[47] << 16);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 384 to 399
	value = ((uint32_t)input[48] << 24) |
			((uint32_t)input[49] << 16);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 400 to 415
	value = ((uint32_t)input[50] << 24) |
			((uint32_t)input[51] << 16);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 416 to 431
	value = ((uint32_t)input[52] << 24) |
			((uint32_t)input[53] << 16);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 432 to 447
	value = ((uint32_t)input[54] << 24) |
			((uint32_t)input[55] << 16);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 448 to 463
	value = ((uint32_t)input[56] << 24) |
			((uint32_t)input[57] << 16);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 464 to 479
	value = ((uint32_t)input[58] << 24) |
			((uint32_t)input[59] << 16);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 480 to 495
	value = ((uint32_t)input[60] << 24) |
			((uint32_t)input[61] << 16);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 496 to 511
	value = ((uint32_t)input[62] << 24) |
			((uint32_t)input[63] << 16);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 512 to 527
	value = ((uint32_t)input[64] << 24) |
			((uint32_t)input[65] << 16);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 528 to 543
	value = ((uint32_t)input[66] << 24) |
			((uint32_t)input[67] << 16);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 544 to 559
	value = ((uint32_t)input[68] << 24) |
			((uint32_t)input[69] << 16);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 560 to 575
	value = ((uint32_t)input[70] << 24) |
			((uint32_t)input[71] << 16);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 576 to 591
	value = ((uint32_t)input[72] << 24) |
			((uint32_t)input[73] << 16);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 592 to 607
	value = ((uint32_t)input[74] << 24) |
			((uint32_t)input[75] << 16);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 608 to 623
	value = ((uint32_t)input[76] << 24) |
			((uint32_t)input[77] << 16);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 624 to 639
	value = ((uint32_t)input[78] << 24) |
			((uint32_t)input[79] << 16);
	output[39] = (double)(value >> 16);

	// read output[40]: from bit 640 to 655
	value = ((uint32_t)input[80] << 24) |
			((uint32_t)input[81] << 16);
	output[40] = (double)(value >> 16);

	// read output[41]: from bit 656 to 671
	value = ((uint32_t)input[82] << 24) |
			((uint32_t)input[83] << 16);
	output[41] = (double)(value >> 16);

	// read output[42]: from bit 672 to 687
	value = ((uint32_t)input[84] << 24) |
			((uint32_t)input[85] << 16);
	output[42] = (double)(value >> 16);

	// read output[43]: from bit 688 to 703
	value = ((uint32_t)input[86] << 24) |
			((uint32_t)input[87] << 16);
	output[43] = (double)(value >> 16);

	// read output[44]: from bit 704 to 719
	value = ((uint32_t)input[88] << 24) |
			((uint32_t)input[89] << 16);
	output[44] = (double)(value >> 16);

	// read output[45]: from bit 720 to 735
	value = ((uint32_t)input[90] << 24) |
			((uint32_t)input[91] << 16);
	output[45] = (double)(value >> 16);

	// read output[46]: from bit 736 to 751
	value = ((uint32_t)input[92] << 24) |
			((uint32_t)input[93] << 16);
	output[46] = (double)(value >> 16);

	// read output[47]: from bit 752 to 767
	value = ((uint32_t)input[94] << 24) |
			((uint32_t)input[95] << 16);
	output[47] = (double)(value >> 16);

	// read output[48]: from bit 768 to 783
	value = ((uint32_t)input[96] << 24) |
			((uint32_t)input[97] << 16);
	output[48] = (double)(value >> 16);

	// read output[49]: from bit 784 to 799
	value = ((uint32_t)input[98] << 24) |
			((uint32_t)input[99] << 16);
	output[49] = (double)(value >> 16);

	// read output[50]: from bit 800 to 815
	value = ((uint32_t)input[100] << 24) |
			((uint32_t)input[101] << 16);
	output[50] = (double)(value >> 16);

	// read output[51]: from bit 816 to 831
	value = ((uint32_t)input[102] << 24) |
			((uint32_t)input[103] << 16);
	output[51] = (double)(value >> 16);

	// read output[52]: from bit 832 to 847
	value = ((uint32_t)input[104] << 24) |
			((uint32_t)input[105] << 16);
	output[52] = (double)(value >> 16);

	// read output[53]: from bit 848 to 863
	value = ((uint32_t)input[106] << 24) |
			((uint32_t)input[107] << 16);
	output[53] = (double)(value >> 16);

	// read output[54]: from bit 864 to 879
	value = ((uint32_t)input[108] << 24) |
			((uint32_t)input[109] << 16);
	output[54] = (double)(value >> 16);

	// read output[55]: from bit 880 to 895
	value = ((uint32_t)input[110] << 24) |
			((uint32_t)input[111] << 16);
	output[55] = (double)(value >> 16);

	// read output[56]: from bit 896 to 911
	value = ((uint32_t)input[112] << 24) |
			((uint32_t)input[113] << 16);
	output[56] = (double)(value >> 16);

	// read output[57]: from bit 912 to 927
	value = ((uint32_t)input[114] << 24) |
			((uint32_t)input[115] << 16);
	output[57] = (double)(value >> 16);

	// read output[58]: from bit 928 to 943
	value = ((uint32_t)input[116] << 24) |
			((uint32_t)input[117] << 16);
	output[58] = (double)(value >> 16);

	// read output[59]: from bit 944 to 959
	value = ((uint32_t)input[118] << 24) |
			((uint32_t)input[119] << 16);
	output[59] = (double)(value >> 16);

	// read output[60]: from bit 960 to 975
	value = ((uint32_t)input[120] << 24) |
			((uint32_t)input[121] << 16);
	output[60] = (double)(value >> 16);
}

static void unpack_61_16bit_unsigned_0off(const uint8_t * input, double * output, void *closure) {
	// Unpack 61 values into output
	// Values are 16-bit unsigned
	// Skip 0 bits, read 976 bits of data.
	// Input must be at least 122 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 0 to 15
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)input[1] << 16);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 16 to 31
	value = ((uint32_t)input[2] << 24) |
			((uint32_t)input[3] << 16);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 32 to 47
	value = ((uint32_t)input[4] << 24) |
			((uint32_t)input[5] << 16);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 48 to 63
	value = ((uint32_t)input[6] << 24) |
			((uint32_t)input[7] << 16);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 64 to 79
	value = ((uint32_t)input[8] << 24) |
			((uint32_t)input[9] << 16);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 80 to 95
	value = ((uint32_t)input[10] << 24) |
			((uint32_t)input[11] << 16);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 96 to 111
	value = ((uint32_t)input[12] << 24) |
			((uint32_t)input[13] << 16);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 112 to 127
	value = ((uint32_t)input[14] << 24) |
			((uint32_t)input[15] << 16);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 128 to 143
	value = ((uint32_t)input[16] << 24) |
			((uint32_t)input[17] << 16);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 144 to 159
	value = ((uint32_t)input[18] << 24) |
			((uint32_t)input[19] << 16);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 160 to 175
	value = ((uint32_t)input[20] << 24) |
			((uint32_t)input[21] << 16);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 176 to 191
	value = ((uint32_t)input[22] << 24) |
			((uint32_t)input[23] << 16);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 192 to 207
	value = ((uint32_t)input[24] << 24) |
			((uint32_t)input[25] << 16);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 208 to 223
	value = ((uint32_t)input[26] << 24) |
			((uint32_t)input[27] << 16);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 224 to 239
	value = ((uint32_t)input[28] << 24) |
			((uint32_t)input[29] << 16);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 240 to 255
	value = ((uint32_t)input[30] << 24) |
			((uint32_t)input[31] << 16);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 256 to 271
	value = ((uint32_t)input[32] << 24) |
			((uint32_t)input[33] << 16);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 272 to 287
	value = ((uint32_t)input[34] << 24) |
			((uint32_t)input[35] << 16);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 288 to 303
	value = ((uint32_t)input[36] << 24) |
			((uint32_t)input[37] << 16);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 304 to 319
	value = ((uint32_t)input[38] << 24) |
			((uint32_t)input[39] << 16);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 320 to 335
	value = ((uint32_t)input[40] << 24) |
			((uint32_t)input[41] << 16);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 336 to 351
	value = ((uint32_t)input[42] << 24) |
			((uint32_t)input[43] << 16);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 352 to 367
	value = ((uint32_t)input[44] << 24) |
			((uint32_t)input[45] << 16);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 368 to 383
	value = ((uint32_t)input[46] << 24) |
			((uint32_t)input[47] << 16);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 384 to 399
	value = ((uint32_t)input[48] << 24) |
			((uint32_t)input[49] << 16);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 400 to 415
	value = ((uint32_t)input[50] << 24) |
			((uint32_t)input[51] << 16);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 416 to 431
	value = ((uint32_t)input[52] << 24) |
			((uint32_t)input[53] << 16);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 432 to 447
	value = ((uint32_t)input[54] << 24) |
			((uint32_t)input[55] << 16);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 448 to 463
	value = ((uint32_t)input[56] << 24) |
			((uint32_t)input[57] << 16);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 464 to 479
	value = ((uint32_t)input[58] << 24) |
			((uint32_t)input[59] << 16);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 480 to 495
	value = ((uint32_t)input[60] << 24) |
			((uint32_t)input[61] << 16);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 496 to 511
	value = ((uint32_t)input[62] << 24) |
			((uint32_t)input[63] << 16);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 512 to 527
	value = ((uint32_t)input[64] << 24) |
			((uint32_t)input[65] << 16);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 528 to 543
	value = ((uint32_t)input[66] << 24) |
			((uint32_t)input[67] << 16);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 544 to 559
	value = ((uint32_t)input[68] << 24) |
			((uint32_t)input[69] << 16);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 560 to 575
	value = ((uint32_t)input[70] << 24) |
			((uint32_t)input[71] << 16);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 576 to 591
	value = ((uint32_t)input[72] << 24) |
			((uint32_t)input[73] << 16);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 592 to 607
	value = ((uint32_t)input[74] << 24) |
			((uint32_t)input[75] << 16);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 608 to 623
	value = ((uint32_t)input[76] << 24) |
			((uint32_t)input[77] << 16);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 624 to 639
	value = ((uint32_t)input[78] << 24) |
			((uint32_t)input[79] << 16);
	output[39] = (double)(value >> 16);

	// read output[40]: from bit 640 to 655
	value = ((uint32_t)input[80] << 24) |
			((uint32_t)input[81] << 16);
	output[40] = (double)(value >> 16);

	// read output[41]: from bit 656 to 671
	value = ((uint32_t)input[82] << 24) |
			((uint32_t)input[83] << 16);
	output[41] = (double)(value >> 16);

	// read output[42]: from bit 672 to 687
	value = ((uint32_t)input[84] << 24) |
			((uint32_t)input[85] << 16);
	output[42] = (double)(value >> 16);

	// read output[43]: from bit 688 to 703
	value = ((uint32_t)input[86] << 24) |
			((uint32_t)input[87] << 16);
	output[43] = (double)(value >> 16);

	// read output[44]: from bit 704 to 719
	value = ((uint32_t)input[88] << 24) |
			((uint32_t)input[89] << 16);
	output[44] = (double)(value >> 16);

	// read output[45]: from bit 720 to 735
	value = ((uint32_t)input[90] << 24) |
			((uint32_t)input[91] << 16);
	output[45] = (double)(value >> 16);

	// read output[46]: from bit 736 to 751
	value = ((uint32_t)input[92] << 24) |
			((uint32_t)input[93] << 16);
	output[46] = (double)(value >> 16);

	// read output[47]: from bit 752 to 767
	value = ((uint32_t)input[94] << 24) |
			((uint32_t)input[95] << 16);
	output[47] = (double)(value >> 16);

	// read output[48]: from bit 768 to 783
	value = ((uint32_t)input[96] << 24) |
			((uint32_t)input[97] << 16);
	output[48] = (double)(value >> 16);

	// read output[49]: from bit 784 to 799
	value = ((uint32_t)input[98] << 24) |
			((uint32_t)input[99] << 16);
	output[49] = (double)(value >> 16);

	// read output[50]: from bit 800 to 815
	value = ((uint32_t)input[100] << 24) |
			((uint32_t)input[101] << 16);
	output[50] = (double)(value >> 16);

	// read output[51]: from bit 816 to 831
	value = ((uint32_t)input[102] << 24) |
			((uint32_t)input[103] << 16);
	output[51] = (double)(value >> 16);

	// read output[52]: from bit 832 to 847
	value = ((uint32_t)input[104] << 24) |
			((uint32_t)input[105] << 16);
	output[52] = (double)(value >> 16);

	// read output[53]: from bit 848 to 863
	value = ((uint32_t)input[106] << 24) |
			((uint32_t)input[107] << 16);
	output[53] = (double)(value >> 16);

	// read output[54]: from bit 864 to 879
	value = ((uint32_t)input[108] << 24) |
			((uint32_t)input[109] << 16);
	output[54] = (double)(value >> 16);

	// read output[55]: from bit 880 to 895
	value = ((uint32_t)input[110] << 24) |
			((uint32_t)input[111] << 16);
	output[55] = (double)(value >> 16);

	// read output[56]: from bit 896 to 911
	value = ((uint32_t)input[112] << 24) |
			((uint32_t)input[113] << 16);
	output[56] = (double)(value >> 16);

	// read output[57]: from bit 912 to 927
	value = ((uint32_t)input[114] << 24) |
			((uint32_t)input[115] << 16);
	output[57] = (double)(value >> 16);

	// read output[58]: from bit 928 to 943
	value = ((uint32_t)input[116] << 24) |
			((uint32_t)input[117] << 16);
	output[58] = (double)(value >> 16);

	// read output[59]: from bit 944 to 959
	value = ((uint32_t)input[118] << 24) |
			((uint32_t)input[119] << 16);
	output[59] = (double)(value >> 16);

	// read output[60]: from bit 960 to 975
	value = ((uint32_t)input[120] << 24) |
			((uint32_t)input[121] << 16);
	output[60] = (double)(value >> 16);
}

static void unpack_61_16bit_signed_1off(const uint8_t * input, double * output, void *closure) {
	// Unpack 61 values into output
	// Values are 16-bit signed
	// Skip 1 bits, read 976 bits of data.
	// Input must be at least 123 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 1 to 16
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)input[1] << 17) |
			((uint32_t)(input[2] & 0x80) << 9);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 17 to 32
	value = ((uint32_t)(input[2] & 0x7f) << 25) |
			((uint32_t)input[3] << 17) |
			((uint32_t)(input[4] & 0x80) << 9);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 33 to 48
	value = ((uint32_t)(input[4] & 0x7f) << 25) |
			((uint32_t)input[5] << 17) |
			((uint32_t)(input[6] & 0x80) << 9);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 49 to 64
	value = ((uint32_t)(input[6] & 0x7f) << 25) |
			((uint32_t)input[7] << 17) |
			((uint32_t)(input[8] & 0x80) << 9);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 65 to 80
	value = ((uint32_t)(input[8] & 0x7f) << 25) |
			((uint32_t)input[9] << 17) |
			((uint32_t)(input[10] & 0x80) << 9);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 81 to 96
	value = ((uint32_t)(input[10] & 0x7f) << 25) |
			((uint32_t)input[11] << 17) |
			((uint32_t)(input[12] & 0x80) << 9);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 97 to 112
	value = ((uint32_t)(input[12] & 0x7f) << 25) |
			((uint32_t)input[13] << 17) |
			((uint32_t)(input[14] & 0x80) << 9);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 113 to 128
	value = ((uint32_t)(input[14] & 0x7f) << 25) |
			((uint32_t)input[15] << 17) |
			((uint32_t)(input[16] & 0x80) << 9);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 129 to 144
	value = ((uint32_t)(input[16] & 0x7f) << 25) |
			((uint32_t)input[17] << 17) |
			((uint32_t)(input[18] & 0x80) << 9);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 145 to 160
	value = ((uint32_t)(input[18] & 0x7f) << 25) |
			((uint32_t)input[19] << 17) |
			((uint32_t)(input[20] & 0x80) << 9);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 161 to 176
	value = ((uint32_t)(input[20] & 0x7f) << 25) |
			((uint32_t)input[21] << 17) |
			((uint32_t)(input[22] & 0x80) << 9);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 177 to 192
	value = ((uint32_t)(input[22] & 0x7f) << 25) |
			((uint32_t)input[23] << 17) |
			((uint32_t)(input[24] & 0x80) << 9);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 193 to 208
	value = ((uint32_t)(input[24] & 0x7f) << 25) |
			((uint32_t)input[25] << 17) |
			((uint32_t)(input[26] & 0x80) << 9);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 209 to 224
	value = ((uint32_t)(input[26] & 0x7f) << 25) |
			((uint32_t)input[27] << 17) |
			((uint32_t)(input[28] & 0x80) << 9);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 225 to 240
	value = ((uint32_t)(input[28] & 0x7f) << 25) |
			((uint32_t)input[29] << 17) |
			((uint32_t)(input[30] & 0x80) << 9);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 241 to 256
	value = ((uint32_t)(input[30] & 0x7f) << 25) |
			((uint32_t)input[31] << 17) |
			((uint32_t)(input[32] & 0x80) << 9);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 257 to 272
	value = ((uint32_t)(input[32] & 0x7f) << 25) |
			((uint32_t)input[33] << 17) |
			((uint32_t)(input[34] & 0x80) << 9);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 273 to 288
	value = ((uint32_t)(input[34] & 0x7f) << 25) |
			((uint32_t)input[35] << 17) |
			((uint32_t)(input[36] & 0x80) << 9);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 289 to 304
	value = ((uint32_t)(input[36] & 0x7f) << 25) |
			((uint32_t)input[37] << 17) |
			((uint32_t)(input[38] & 0x80) << 9);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 305 to 320
	value = ((uint32_t)(input[38] & 0x7f) << 25) |
			((uint32_t)input[39] << 17) |
			((uint32_t)(input[40] & 0x80) << 9);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 321 to 336
	value = ((uint32_t)(input[40] & 0x7f) << 25) |
			((uint32_t)input[41] << 17) |
			((uint32_t)(input[42] & 0x80) << 9);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 337 to 352
	value = ((uint32_t)(input[42] & 0x7f) << 25) |
			((uint32_t)input[43] << 17) |
			((uint32_t)(input[44] & 0x80) << 9);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 353 to 368
	value = ((uint32_t)(input[44] & 0x7f) << 25) |
			((uint32_t)input[45] << 17) |
			((uint32_t)(input[46] & 0x80) << 9);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 369 to 384
	value = ((uint32_t)(input[46] & 0x7f) << 25) |
			((uint32_t)input[47] << 17) |
			((uint32_t)(input[48] & 0x80) << 9);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 385 to 400
	value = ((uint32_t)(input[48] & 0x7f) << 25) |
			((uint32_t)input[49] << 17) |
			((uint32_t)(input[50] & 0x80) << 9);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 401 to 416
	value = ((uint32_t)(input[50] & 0x7f) << 25) |
			((uint32_t)input[51] << 17) |
			((uint32_t)(input[52] & 0x80) << 9);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 417 to 432
	value = ((uint32_t)(input[52] & 0x7f) << 25) |
			((uint32_t)input[53] << 17) |
			((uint32_t)(input[54] & 0x80) << 9);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 433 to 448
	value = ((uint32_t)(input[54] & 0x7f) << 25) |
			((uint32_t)input[55] << 17) |
			((uint32_t)(input[56] & 0x80) << 9);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 449 to 464
	value = ((uint32_t)(input[56] & 0x7f) << 25) |
			((uint32_t)input[57] << 17) |
			((uint32_t)(input[58] & 0x80) << 9);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 465 to 480
	value = ((uint32_t)(input[58] & 0x7f) << 25) |
			((uint32_t)input[59] << 17) |
			((uint32_t)(input[60] & 0x80) << 9);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 481 to 496
	value = ((uint32_t)(input[60] & 0x7f) << 25) |
			((uint32_t)input[61] << 17) |
			((uint32_t)(input[62] & 0x80) << 9);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 497 to 512
	value = ((uint32_t)(input[62] & 0x7f) << 25) |
			((uint32_t)input[63] << 17) |
			((uint32_t)(input[64] & 0x80) << 9);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 513 to 528
	value = ((uint32_t)(input[64] & 0x7f) << 25) |
			((uint32_t)input[65] << 17) |
			((uint32_t)(input[66] & 0x80) << 9);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 529 to 544
	value = ((uint32_t)(input[66] & 0x7f) << 25) |
			((uint32_t)input[67] << 17) |
			((uint32_t)(input[68] & 0x80) << 9);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 545 to 560
	value = ((uint32_t)(input[68] & 0x7f) << 25) |
			((uint32_t)input[69] << 17) |
			((uint32_t)(input[70] & 0x80) << 9);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 561 to 576
	value = ((uint32_t)(input[70] & 0x7f) << 25) |
			((uint32_t)input[71] << 17) |
			((uint32_t)(input[72] & 0x80) << 9);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 577 to 592
	value = ((uint32_t)(input[72] & 0x7f) << 25) |
			((uint32_t)input[73] << 17) |
			((uint32_t)(input[74] & 0x80) << 9);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 593 to 608
	value = ((uint32_t)(input[74] & 0x7f) << 25) |
			((uint32_t)input[75] << 17) |
			((uint32_t)(input[76] & 0x80) << 9);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 609 to 624
	value = ((uint32_t)(input[76] & 0x7f) << 25) |
			((uint32_t)input[77] << 17) |
			((uint32_t)(input[78] & 0x80) << 9);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 625 to 640
	value = ((uint32_t)(input[78] & 0x7f) << 25) |
			((uint32_t)input[79] << 17) |
			((uint32_t)(input[80] & 0x80) << 9);
	output[39] = (double)(value >> 16);

	// read output[40]: from bit 641 to 656
	value = ((uint32_t)(input[80] & 0x7f) << 25) |
			((uint32_t)input[81] << 17) |
			((uint32_t)(input[82] & 0x80) << 9);
	output[40] = (double)(value >> 16);

	// read output[41]: from bit 657 to 672
	value = ((uint32_t)(input[82] & 0x7f) << 25) |
			((uint32_t)input[83] << 17) |
			((uint32_t)(input[84] & 0x80) << 9);
	output[41] = (double)(value >> 16);

	// read output[42]: from bit 673 to 688
	value = ((uint32_t)(input[84] & 0x7f) << 25) |
			((uint32_t)input[85] << 17) |
			((uint32_t)(input[86] & 0x80) << 9);
	output[42] = (double)(value >> 16);

	// read output[43]: from bit 689 to 704
	value = ((uint32_t)(input[86] & 0x7f) << 25) |
			((uint32_t)input[87] << 17) |
			((uint32_t)(input[88] & 0x80) << 9);
	output[43] = (double)(value >> 16);

	// read output[44]: from bit 705 to 720
	value = ((uint32_t)(input[88] & 0x7f) << 25) |
			((uint32_t)input[89] << 17) |
			((uint32_t)(input[90] & 0x80) << 9);
	output[44] = (double)(value >> 16);

	// read output[45]: from bit 721 to 736
	value = ((uint32_t)(input[90] & 0x7f) << 25) |
			((uint32_t)input[91] << 17) |
			((uint32_t)(input[92] & 0x80) << 9);
	output[45] = (double)(value >> 16);

	// read output[46]: from bit 737 to 752
	value = ((uint32_t)(input[92] & 0x7f) << 25) |
			((uint32_t)input[93] << 17) |
			((uint32_t)(input[94] & 0x80) << 9);
	output[46] = (double)(value >> 16);

	// read output[47]: from bit 753 to 768
	value = ((uint32_t)(input[94] & 0x7f) << 25) |
			((uint32_t)input[95] << 17) |
			((uint32_t)(input[96] & 0x80) << 9);
	output[47] = (double)(value >> 16);

	// read output[48]: from bit 769 to 784
	value = ((uint32_t)(input[96] & 0x7f) << 25) |
			((uint32_t)input[97] << 17) |
			((uint32_t)(input[98] & 0x80) << 9);
	output[48] = (double)(value >> 16);

	// read output[49]: from bit 785 to 800
	value = ((uint32_t)(input[98] & 0x7f) << 25) |
			((uint32_t)input[99] << 17) |
			((uint32_t)(input[100] & 0x80) << 9);
	output[49] = (double)(value >> 16);

	// read output[50]: from bit 801 to 816
	value = ((uint32_t)(input[100] & 0x7f) << 25) |
			((uint32_t)input[101] << 17) |
			((uint32_t)(input[102] & 0x80) << 9);
	output[50] = (double)(value >> 16);

	// read output[51]: from bit 817 to 832
	value = ((uint32_t)(input[102] & 0x7f) << 25) |
			((uint32_t)input[103] << 17) |
			((uint32_t)(input[104] & 0x80) << 9);
	output[51] = (double)(value >> 16);

	// read output[52]: from bit 833 to 848
	value = ((uint32_t)(input[104] & 0x7f) << 25) |
			((uint32_t)input[105] << 17) |
			((uint32_t)(input[106] & 0x80) << 9);
	output[52] = (double)(value >> 16);

	// read output[53]: from bit 849 to 864
	value = ((uint32_t)(input[106] & 0x7f) << 25) |
			((uint32_t)input[107] << 17) |
			((uint32_t)(input[108] & 0x80) << 9);
	output[53] = (double)(value >> 16);

	// read output[54]: from bit 865 to 880
	value = ((uint32_t)(input[108] & 0x7f) << 25) |
			((uint32_t)input[109] << 17) |
			((uint32_t)(input[110] & 0x80) << 9);
	output[54] = (double)(value >> 16);

	// read output[55]: from bit 881 to 896
	value = ((uint32_t)(input[110] & 0x7f) << 25) |
			((uint32_t)input[111] << 17) |
			((uint32_t)(input[112] & 0x80) << 9);
	output[55] = (double)(value >> 16);

	// read output[56]: from bit 897 to 912
	value = ((uint32_t)(input[112] & 0x7f) << 25) |
			((uint32_t)input[113] << 17) |
			((uint32_t)(input[114] & 0x80) << 9);
	output[56] = (double)(value >> 16);

	// read output[57]: from bit 913 to 928
	value = ((uint32_t)(input[114] & 0x7f) << 25) |
			((uint32_t)input[115] << 17) |
			((uint32_t)(input[116] & 0x80) << 9);
	output[57] = (double)(value >> 16);

	// read output[58]: from bit 929 to 944
	value = ((uint32_t)(input[116] & 0x7f) << 25) |
			((uint32_t)input[117] << 17) |
			((uint32_t)(input[118] & 0x80) << 9);
	output[58] = (double)(value >> 16);

	// read output[59]: from bit 945 to 960
	value = ((uint32_t)(input[118] & 0x7f) << 25) |
			((uint32_t)input[119] << 17) |
			((uint32_t)(input[120] & 0x80) << 9);
	output[59] = (double)(value >> 16);

	// read output[60]: from bit 961 to 976
	value = ((uint32_t)(input[120] & 0x7f) << 25) |
			((uint32_t)input[121] << 17) |
			((uint32_t)(input[122] & 0x80) << 9);
	output[60] = (double)(value >> 16);
}

static void unpack_61_16bit_unsigned_1off(const uint8_t * input, double * output, void *closure) {
	// Unpack 61 values into output
	// Values are 16-bit unsigned
	// Skip 1 bits, read 976 bits of data.
	// Input must be at least 123 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 1 to 16
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)input[1] << 17) |
			((uint32_t)(input[2] & 0x80) << 9);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 17 to 32
	value = ((uint32_t)(input[2] & 0x7f) << 25) |
			((uint32_t)input[3] << 17) |
			((uint32_t)(input[4] & 0x80) << 9);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 33 to 48
	value = ((uint32_t)(input[4] & 0x7f) << 25) |
			((uint32_t)input[5] << 17) |
			((uint32_t)(input[6] & 0x80) << 9);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 49 to 64
	value = ((uint32_t)(input[6] & 0x7f) << 25) |
			((uint32_t)input[7] << 17) |
			((uint32_t)(input[8] & 0x80) << 9);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 65 to 80
	value = ((uint32_t)(input[8] & 0x7f) << 25) |
			((uint32_t)input[9] << 17) |
			((uint32_t)(input[10] & 0x80) << 9);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 81 to 96
	value = ((uint32_t)(input[10] & 0x7f) << 25) |
			((uint32_t)input[11] << 17) |
			((uint32_t)(input[12] & 0x80) << 9);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 97 to 112
	value = ((uint32_t)(input[12] & 0x7f) << 25) |
			((uint32_t)input[13] << 17) |
			((uint32_t)(input[14] & 0x80) << 9);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 113 to 128
	value = ((uint32_t)(input[14] & 0x7f) << 25) |
			((uint32_t)input[15] << 17) |
			((uint32_t)(input[16] & 0x80) << 9);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 129 to 144
	value = ((uint32_t)(input[16] & 0x7f) << 25) |
			((uint32_t)input[17] << 17) |
			((uint32_t)(input[18] & 0x80) << 9);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 145 to 160
	value = ((uint32_t)(input[18] & 0x7f) << 25) |
			((uint32_t)input[19] << 17) |
			((uint32_t)(input[20] & 0x80) << 9);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 161 to 176
	value = ((uint32_t)(input[20] & 0x7f) << 25) |
			((uint32_t)input[21] << 17) |
			((uint32_t)(input[22] & 0x80) << 9);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 177 to 192
	value = ((uint32_t)(input[22] & 0x7f) << 25) |
			((uint32_t)input[23] << 17) |
			((uint32_t)(input[24] & 0x80) << 9);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 193 to 208
	value = ((uint32_t)(input[24] & 0x7f) << 25) |
			((uint32_t)input[25] << 17) |
			((uint32_t)(input[26] & 0x80) << 9);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 209 to 224
	value = ((uint32_t)(input[26] & 0x7f) << 25) |
			((uint32_t)input[27] << 17) |
			((uint32_t)(input[28] & 0x80) << 9);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 225 to 240
	value = ((uint32_t)(input[28] & 0x7f) << 25) |
			((uint32_t)input[29] << 17) |
			((uint32_t)(input[30] & 0x80) << 9);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 241 to 256
	value = ((uint32_t)(input[30] & 0x7f) << 25) |
			((uint32_t)input[31] << 17) |
			((uint32_t)(input[32] & 0x80) << 9);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 257 to 272
	value = ((uint32_t)(input[32] & 0x7f) << 25) |
			((uint32_t)input[33] << 17) |
			((uint32_t)(input[34] & 0x80) << 9);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 273 to 288
	value = ((uint32_t)(input[34] & 0x7f) << 25) |
			((uint32_t)input[35] << 17) |
			((uint32_t)(input[36] & 0x80) << 9);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 289 to 304
	value = ((uint32_t)(input[36] & 0x7f) << 25) |
			((uint32_t)input[37] << 17) |
			((uint32_t)(input[38] & 0x80) << 9);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 305 to 320
	value = ((uint32_t)(input[38] & 0x7f) << 25) |
			((uint32_t)input[39] << 17) |
			((uint32_t)(input[40] & 0x80) << 9);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 321 to 336
	value = ((uint32_t)(input[40] & 0x7f) << 25) |
			((uint32_t)input[41] << 17) |
			((uint32_t)(input[42] & 0x80) << 9);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 337 to 352
	value = ((uint32_t)(input[42] & 0x7f) << 25) |
			((uint32_t)input[43] << 17) |
			((uint32_t)(input[44] & 0x80) << 9);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 353 to 368
	value = ((uint32_t)(input[44] & 0x7f) << 25) |
			((uint32_t)input[45] << 17) |
			((uint32_t)(input[46] & 0x80) << 9);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 369 to 384
	value = ((uint32_t)(input[46] & 0x7f) << 25) |
			((uint32_t)input[47] << 17) |
			((uint32_t)(input[48] & 0x80) << 9);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 385 to 400
	value = ((uint32_t)(input[48] & 0x7f) << 25) |
			((uint32_t)input[49] << 17) |
			((uint32_t)(input[50] & 0x80) << 9);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 401 to 416
	value = ((uint32_t)(input[50] & 0x7f) << 25) |
			((uint32_t)input[51] << 17) |
			((uint32_t)(input[52] & 0x80) << 9);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 417 to 432
	value = ((uint32_t)(input[52] & 0x7f) << 25) |
			((uint32_t)input[53] << 17) |
			((uint32_t)(input[54] & 0x80) << 9);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 433 to 448
	value = ((uint32_t)(input[54] & 0x7f) << 25) |
			((uint32_t)input[55] << 17) |
			((uint32_t)(input[56] & 0x80) << 9);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 449 to 464
	value = ((uint32_t)(input[56] & 0x7f) << 25) |
			((uint32_t)input[57] << 17) |
			((uint32_t)(input[58] & 0x80) << 9);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 465 to 480
	value = ((uint32_t)(input[58] & 0x7f) << 25) |
			((uint32_t)input[59] << 17) |
			((uint32_t)(input[60] & 0x80) << 9);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 481 to 496
	value = ((uint32_t)(input[60] & 0x7f) << 25) |
			((uint32_t)input[61] << 17) |
			((uint32_t)(input[62] & 0x80) << 9);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 497 to 512
	value = ((uint32_t)(input[62] & 0x7f) << 25) |
			((uint32_t)input[63] << 17) |
			((uint32_t)(input[64] & 0x80) << 9);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 513 to 528
	value = ((uint32_t)(input[64] & 0x7f) << 25) |
			((uint32_t)input[65] << 17) |
			((uint32_t)(input[66] & 0x80) << 9);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 529 to 544
	value = ((uint32_t)(input[66] & 0x7f) << 25) |
			((uint32_t)input[67] << 17) |
			((uint32_t)(input[68] & 0x80) << 9);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 545 to 560
	value = ((uint32_t)(input[68] & 0x7f) << 25) |
			((uint32_t)input[69] << 17) |
			((uint32_t)(input[70] & 0x80) << 9);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 561 to 576
	value = ((uint32_t)(input[70] & 0x7f) << 25) |
			((uint32_t)input[71] << 17) |
			((uint32_t)(input[72] & 0x80) << 9);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 577 to 592
	value = ((uint32_t)(input[72] & 0x7f) << 25) |
			((uint32_t)input[73] << 17) |
			((uint32_t)(input[74] & 0x80) << 9);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 593 to 608
	value = ((uint32_t)(input[74] & 0x7f) << 25) |
			((uint32_t)input[75] << 17) |
			((uint32_t)(input[76] & 0x80) << 9);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 609 to 624
	value = ((uint32_t)(input[76] & 0x7f) << 25) |
			((uint32_t)input[77] << 17) |
			((uint32_t)(input[78] & 0x80) << 9);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 625 to 640
	value = ((uint32_t)(input[78] & 0x7f) << 25) |
			((uint32_t)input[79] << 17) |
			((uint32_t)(input[80] & 0x80) << 9);
	output[39] = (double)(value >> 16);

	// read output[40]: from bit 641 to 656
	value = ((uint32_t)(input[80] & 0x7f) << 25) |
			((uint32_t)input[81] << 17) |
			((uint32_t)(input[82] & 0x80) << 9);
	output[40] = (double)(value >> 16);

	// read output[41]: from bit 657 to 672
	value = ((uint32_t)(input[82] & 0x7f) << 25) |
			((uint32_t)input[83] << 17) |
			((uint32_t)(input[84] & 0x80) << 9);
	output[41] = (double)(value >> 16);

	// read output[42]: from bit 673 to 688
	value = ((uint32_t)(input[84] & 0x7f) << 25) |
			((uint32_t)input[85] << 17) |
			((uint32_t)(input[86] & 0x80) << 9);
	output[42] = (double)(value >> 16);

	// read output[43]: from bit 689 to 704
	value = ((uint32_t)(input[86] & 0x7f) << 25) |
			((uint32_t)input[87] << 17) |
			((uint32_t)(input[88] & 0x80) << 9);
	output[43] = (double)(value >> 16);

	// read output[44]: from bit 705 to 720
	value = ((uint32_t)(input[88] & 0x7f) << 25) |
			((uint32_t)input[89] << 17) |
			((uint32_t)(input[90] & 0x80) << 9);
	output[44] = (double)(value >> 16);

	// read output[45]: from bit 721 to 736
	value = ((uint32_t)(input[90] & 0x7f) << 25) |
			((uint32_t)input[91] << 17) |
			((uint32_t)(input[92] & 0x80) << 9);
	output[45] = (double)(value >> 16);

	// read output[46]: from bit 737 to 752
	value = ((uint32_t)(input[92] & 0x7f) << 25) |
			((uint32_t)input[93] << 17) |
			((uint32_t)(input[94] & 0x80) << 9);
	output[46] = (double)(value >> 16);

	// read output[47]: from bit 753 to 768
	value = ((uint32_t)(input[94] & 0x7f) << 25) |
			((uint32_t)input[95] << 17) |
			((uint32_t)(input[96] & 0x80) << 9);
	output[47] = (double)(value >> 16);

	// read output[48]: from bit 769 to 784
	value = ((uint32_t)(input[96] & 0x7f) << 25) |
			((uint32_t)input[97] << 17) |
			((uint32_t)(input[98] & 0x80) << 9);
	output[48] = (double)(value >> 16);

	// read output[49]: from bit 785 to 800
	value = ((uint32_t)(input[98] & 0x7f) << 25) |
			((uint32_t)input[99] << 17) |
			((uint32_t)(input[100] & 0x80) << 9);
	output[49] = (double)(value >> 16);

	// read output[50]: from bit 801 to 816
	value = ((uint32_t)(input[100] & 0x7f) << 25) |
			((uint32_t)input[101] << 17) |
			((uint32_t)(input[102] & 0x80) << 9);
	output[50] = (double)(value >> 16);

	// read output[51]: from bit 817 to 832
	value = ((uint32_t)(input[102] & 0x7f) << 25) |
			((uint32_t)input[103] << 17) |
			((uint32_t)(input[104] & 0x80) << 9);
	output[51] = (double)(value >> 16);

	// read output[52]: from bit 833 to 848
	value = ((uint32_t)(input[104] & 0x7f) << 25) |
			((uint32_t)input[105] << 17) |
			((uint32_t)(input[106] & 0x80) << 9);
	output[52] = (double)(value >> 16);

	// read output[53]: from bit 849 to 864
	value = ((uint32_t)(input[106] & 0x7f) << 25) |
			((uint32_t)input[107] << 17) |
			((uint32_t)(input[108] & 0x80) << 9);
	output[53] = (double)(value >> 16);

	// read output[54]: from bit 865 to 880
	value = ((uint32_t)(input[108] & 0x7f) << 25) |
			((uint32_t)input[109] << 17) |
			((uint32_t)(input[110] & 0x80) << 9);
	output[54] = (double)(value >> 16);

	// read output[55]: from bit 881 to 896
	value = ((uint32_t)(input[110] & 0x7f) << 25) |
			((uint32_t)input[111] << 17) |
			((uint32_t)(input[112] & 0x80) << 9);
	output[55] = (double)(value >> 16);

	// read output[56]: from bit 897 to 912
	value = ((uint32_t)(input[112] & 0x7f) << 25) |
			((uint32_t)input[113] << 17) |
			((uint32_t)(input[114] & 0x80) << 9);
	output[56] = (double)(value >> 16);

	// read output[57]: from bit 913 to 928
	value = ((uint32_t)(input[114] & 0x7f) << 25) |
			((uint32_t)input[115] << 17) |
			((uint32_t)(input[116] & 0x80) << 9);
	output[57] = (double)(value >> 16);

	// read output[58]: from bit 929 to 944
	value = ((uint32_t)(input[116] & 0x7f) << 25) |
			((uint32_t)input[117] << 17) |
			((uint32_t)(input[118] & 0x80) << 9);
	output[58] = (double)(value >> 16);

	// read output[59]: from bit 945 to 960
	value = ((uint32_t)(input[118] & 0x7f) << 25) |
			((uint32_t)input[119] << 17) |
			((uint32_t)(input[120] & 0x80) << 9);
	output[59] = (double)(value >> 16);

	// read output[60]: from bit 961 to 976
	value = ((uint32_t)(input[120] & 0x7f) << 25) |
			((uint32_t)input[121] << 17) |
			((uint32_t)(input[122] & 0x80) << 9);
	output[60] = (double)(value >> 16);
}

static void unpack_61_16bit_signed_2off(const uint8_t * input, double * output, void *closure) {
	// Unpack 61 values into output
	// Values are 16-bit signed
	// Skip 2 bits, read 976 bits of data.
	// Input must be at least 123 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 2 to 17
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)input[1] << 18) |
			((uint32_t)(input[2] & 0xc0) << 10);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 18 to 33
	value = ((uint32_t)(input[2] & 0x3f) << 26) |
			((uint32_t)input[3] << 18) |
			((uint32_t)(input[4] & 0xc0) << 10);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 34 to 49
	value = ((uint32_t)(input[4] & 0x3f) << 26) |
			((uint32_t)input[5] << 18) |
			((uint32_t)(input[6] & 0xc0) << 10);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 50 to 65
	value = ((uint32_t)(input[6] & 0x3f) << 26) |
			((uint32_t)input[7] << 18) |
			((uint32_t)(input[8] & 0xc0) << 10);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 66 to 81
	value = ((uint32_t)(input[8] & 0x3f) << 26) |
			((uint32_t)input[9] << 18) |
			((uint32_t)(input[10] & 0xc0) << 10);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 82 to 97
	value = ((uint32_t)(input[10] & 0x3f) << 26) |
			((uint32_t)input[11] << 18) |
			((uint32_t)(input[12] & 0xc0) << 10);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 98 to 113
	value = ((uint32_t)(input[12] & 0x3f) << 26) |
			((uint32_t)input[13] << 18) |
			((uint32_t)(input[14] & 0xc0) << 10);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 114 to 129
	value = ((uint32_t)(input[14] & 0x3f) << 26) |
			((uint32_t)input[15] << 18) |
			((uint32_t)(input[16] & 0xc0) << 10);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 130 to 145
	value = ((uint32_t)(input[16] & 0x3f) << 26) |
			((uint32_t)input[17] << 18) |
			((uint32_t)(input[18] & 0xc0) << 10);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 146 to 161
	value = ((uint32_t)(input[18] & 0x3f) << 26) |
			((uint32_t)input[19] << 18) |
			((uint32_t)(input[20] & 0xc0) << 10);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 162 to 177
	value = ((uint32_t)(input[20] & 0x3f) << 26) |
			((uint32_t)input[21] << 18) |
			((uint32_t)(input[22] & 0xc0) << 10);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 178 to 193
	value = ((uint32_t)(input[22] & 0x3f) << 26) |
			((uint32_t)input[23] << 18) |
			((uint32_t)(input[24] & 0xc0) << 10);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 194 to 209
	value = ((uint32_t)(input[24] & 0x3f) << 26) |
			((uint32_t)input[25] << 18) |
			((uint32_t)(input[26] & 0xc0) << 10);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 210 to 225
	value = ((uint32_t)(input[26] & 0x3f) << 26) |
			((uint32_t)input[27] << 18) |
			((uint32_t)(input[28] & 0xc0) << 10);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 226 to 241
	value = ((uint32_t)(input[28] & 0x3f) << 26) |
			((uint32_t)input[29] << 18) |
			((uint32_t)(input[30] & 0xc0) << 10);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 242 to 257
	value = ((uint32_t)(input[30] & 0x3f) << 26) |
			((uint32_t)input[31] << 18) |
			((uint32_t)(input[32] & 0xc0) << 10);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 258 to 273
	value = ((uint32_t)(input[32] & 0x3f) << 26) |
			((uint32_t)input[33] << 18) |
			((uint32_t)(input[34] & 0xc0) << 10);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 274 to 289
	value = ((uint32_t)(input[34] & 0x3f) << 26) |
			((uint32_t)input[35] << 18) |
			((uint32_t)(input[36] & 0xc0) << 10);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 290 to 305
	value = ((uint32_t)(input[36] & 0x3f) << 26) |
			((uint32_t)input[37] << 18) |
			((uint32_t)(input[38] & 0xc0) << 10);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 306 to 321
	value = ((uint32_t)(input[38] & 0x3f) << 26) |
			((uint32_t)input[39] << 18) |
			((uint32_t)(input[40] & 0xc0) << 10);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 322 to 337
	value = ((uint32_t)(input[40] & 0x3f) << 26) |
			((uint32_t)input[41] << 18) |
			((uint32_t)(input[42] & 0xc0) << 10);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 338 to 353
	value = ((uint32_t)(input[42] & 0x3f) << 26) |
			((uint32_t)input[43] << 18) |
			((uint32_t)(input[44] & 0xc0) << 10);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 354 to 369
	value = ((uint32_t)(input[44] & 0x3f) << 26) |
			((uint32_t)input[45] << 18) |
			((uint32_t)(input[46] & 0xc0) << 10);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 370 to 385
	value = ((uint32_t)(input[46] & 0x3f) << 26) |
			((uint32_t)input[47] << 18) |
			((uint32_t)(input[48] & 0xc0) << 10);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 386 to 401
	value = ((uint32_t)(input[48] & 0x3f) << 26) |
			((uint32_t)input[49] << 18) |
			((uint32_t)(input[50] & 0xc0) << 10);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 402 to 417
	value = ((uint32_t)(input[50] & 0x3f) << 26) |
			((uint32_t)input[51] << 18) |
			((uint32_t)(input[52] & 0xc0) << 10);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 418 to 433
	value = ((uint32_t)(input[52] & 0x3f) << 26) |
			((uint32_t)input[53] << 18) |
			((uint32_t)(input[54] & 0xc0) << 10);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 434 to 449
	value = ((uint32_t)(input[54] & 0x3f) << 26) |
			((uint32_t)input[55] << 18) |
			((uint32_t)(input[56] & 0xc0) << 10);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 450 to 465
	value = ((uint32_t)(input[56] & 0x3f) << 26) |
			((uint32_t)input[57] << 18) |
			((uint32_t)(input[58] & 0xc0) << 10);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 466 to 481
	value = ((uint32_t)(input[58] & 0x3f) << 26) |
			((uint32_t)input[59] << 18) |
			((uint32_t)(input[60] & 0xc0) << 10);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 482 to 497
	value = ((uint32_t)(input[60] & 0x3f) << 26) |
			((uint32_t)input[61] << 18) |
			((uint32_t)(input[62] & 0xc0) << 10);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 498 to 513
	value = ((uint32_t)(input[62] & 0x3f) << 26) |
			((uint32_t)input[63] << 18) |
			((uint32_t)(input[64] & 0xc0) << 10);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 514 to 529
	value = ((uint32_t)(input[64] & 0x3f) << 26) |
			((uint32_t)input[65] << 18) |
			((uint32_t)(input[66] & 0xc0) << 10);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 530 to 545
	value = ((uint32_t)(input[66] & 0x3f) << 26) |
			((uint32_t)input[67] << 18) |
			((uint32_t)(input[68] & 0xc0) << 10);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 546 to 561
	value = ((uint32_t)(input[68] & 0x3f) << 26) |
			((uint32_t)input[69] << 18) |
			((uint32_t)(input[70] & 0xc0) << 10);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 562 to 577
	value = ((uint32_t)(input[70] & 0x3f) << 26) |
			((uint32_t)input[71] << 18) |
			((uint32_t)(input[72] & 0xc0) << 10);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 578 to 593
	value = ((uint32_t)(input[72] & 0x3f) << 26) |
			((uint32_t)input[73] << 18) |
			((uint32_t)(input[74] & 0xc0) << 10);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 594 to 609
	value = ((uint32_t)(input[74] & 0x3f) << 26) |
			((uint32_t)input[75] << 18) |
			((uint32_t)(input[76] & 0xc0) << 10);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 610 to 625
	value = ((uint32_t)(input[76] & 0x3f) << 26) |
			((uint32_t)input[77] << 18) |
			((uint32_t)(input[78] & 0xc0) << 10);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 626 to 641
	value = ((uint32_t)(input[78] & 0x3f) << 26) |
			((uint32_t)input[79] << 18) |
			((uint32_t)(input[80] & 0xc0) << 10);
	output[39] = (double)(value >> 16);

	// read output[40]: from bit 642 to 657
	value = ((uint32_t)(input[80] & 0x3f) << 26) |
			((uint32_t)input[81] << 18) |
			((uint32_t)(input[82] & 0xc0) << 10);
	output[40] = (double)(value >> 16);

	// read output[41]: from bit 658 to 673
	value = ((uint32_t)(input[82] & 0x3f) << 26) |
			((uint32_t)input[83] << 18) |
			((uint32_t)(input[84] & 0xc0) << 10);
	output[41] = (double)(value >> 16);

	// read output[42]: from bit 674 to 689
	value = ((uint32_t)(input[84] & 0x3f) << 26) |
			((uint32_t)input[85] << 18) |
			((uint32_t)(input[86] & 0xc0) << 10);
	output[42] = (double)(value >> 16);

	// read output[43]: from bit 690 to 705
	value = ((uint32_t)(input[86] & 0x3f) << 26) |
			((uint32_t)input[87] << 18) |
			((uint32_t)(input[88] & 0xc0) << 10);
	output[43] = (double)(value >> 16);

	// read output[44]: from bit 706 to 721
	value = ((uint32_t)(input[88] & 0x3f) << 26) |
			((uint32_t)input[89] << 18) |
			((uint32_t)(input[90] & 0xc0) << 10);
	output[44] = (double)(value >> 16);

	// read output[45]: from bit 722 to 737
	value = ((uint32_t)(input[90] & 0x3f) << 26) |
			((uint32_t)input[91] << 18) |
			((uint32_t)(input[92] & 0xc0) << 10);
	output[45] = (double)(value >> 16);

	// read output[46]: from bit 738 to 753
	value = ((uint32_t)(input[92] & 0x3f) << 26) |
			((uint32_t)input[93] << 18) |
			((uint32_t)(input[94] & 0xc0) << 10);
	output[46] = (double)(value >> 16);

	// read output[47]: from bit 754 to 769
	value = ((uint32_t)(input[94] & 0x3f) << 26) |
			((uint32_t)input[95] << 18) |
			((uint32_t)(input[96] & 0xc0) << 10);
	output[47] = (double)(value >> 16);

	// read output[48]: from bit 770 to 785
	value = ((uint32_t)(input[96] & 0x3f) << 26) |
			((uint32_t)input[97] << 18) |
			((uint32_t)(input[98] & 0xc0) << 10);
	output[48] = (double)(value >> 16);

	// read output[49]: from bit 786 to 801
	value = ((uint32_t)(input[98] & 0x3f) << 26) |
			((uint32_t)input[99] << 18) |
			((uint32_t)(input[100] & 0xc0) << 10);
	output[49] = (double)(value >> 16);

	// read output[50]: from bit 802 to 817
	value = ((uint32_t)(input[100] & 0x3f) << 26) |
			((uint32_t)input[101] << 18) |
			((uint32_t)(input[102] & 0xc0) << 10);
	output[50] = (double)(value >> 16);

	// read output[51]: from bit 818 to 833
	value = ((uint32_t)(input[102] & 0x3f) << 26) |
			((uint32_t)input[103] << 18) |
			((uint32_t)(input[104] & 0xc0) << 10);
	output[51] = (double)(value >> 16);

	// read output[52]: from bit 834 to 849
	value = ((uint32_t)(input[104] & 0x3f) << 26) |
			((uint32_t)input[105] << 18) |
			((uint32_t)(input[106] & 0xc0) << 10);
	output[52] = (double)(value >> 16);

	// read output[53]: from bit 850 to 865
	value = ((uint32_t)(input[106] & 0x3f) << 26) |
			((uint32_t)input[107] << 18) |
			((uint32_t)(input[108] & 0xc0) << 10);
	output[53] = (double)(value >> 16);

	// read output[54]: from bit 866 to 881
	value = ((uint32_t)(input[108] & 0x3f) << 26) |
			((uint32_t)input[109] << 18) |
			((uint32_t)(input[110] & 0xc0) << 10);
	output[54] = (double)(value >> 16);

	// read output[55]: from bit 882 to 897
	value = ((uint32_t)(input[110] & 0x3f) << 26) |
			((uint32_t)input[111] << 18) |
			((uint32_t)(input[112] & 0xc0) << 10);
	output[55] = (double)(value >> 16);

	// read output[56]: from bit 898 to 913
	value = ((uint32_t)(input[112] & 0x3f) << 26) |
			((uint32_t)input[113] << 18) |
			((uint32_t)(input[114] & 0xc0) << 10);
	output[56] = (double)(value >> 16);

	// read output[57]: from bit 914 to 929
	value = ((uint32_t)(input[114] & 0x3f) << 26) |
			((uint32_t)input[115] << 18) |
			((uint32_t)(input[116] & 0xc0) << 10);
	output[57] = (double)(value >> 16);

	// read output[58]: from bit 930 to 945
	value = ((uint32_t)(input[116] & 0x3f) << 26) |
			((uint32_t)input[117] << 18) |
			((uint32_t)(input[118] & 0xc0) << 10);
	output[58] = (double)(value >> 16);

	// read output[59]: from bit 946 to 961
	value = ((uint32_t)(input[118] & 0x3f) << 26) |
			((uint32_t)input[119] << 18) |
			((uint32_t)(input[120] & 0xc0) << 10);
	output[59] = (double)(value >> 16);

	// read output[60]: from bit 962 to 977
	value = ((uint32_t)(input[120] & 0x3f) << 26) |
			((uint32_t)input[121] << 18) |
			((uint32_t)(input[122] & 0xc0) << 10);
	output[60] = (double)(value >> 16);
}

static void unpack_61_16bit_unsigned_2off(const uint8_t * input, double * output, void *closure) {
	// Unpack 61 values into output
	// Values are 16-bit unsigned
	// Skip 2 bits, read 976 bits of data.
	// Input must be at least 123 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 2 to 17
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)input[1] << 18) |
			((uint32_t)(input[2] & 0xc0) << 10);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 18 to 33
	value = ((uint32_t)(input[2] & 0x3f) << 26) |
			((uint32_t)input[3] << 18) |
			((uint32_t)(input[4] & 0xc0) << 10);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 34 to 49
	value = ((uint32_t)(input[4] & 0x3f) << 26) |
			((uint32_t)input[5] << 18) |
			((uint32_t)(input[6] & 0xc0) << 10);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 50 to 65
	value = ((uint32_t)(input[6] & 0x3f) << 26) |
			((uint32_t)input[7] << 18) |
			((uint32_t)(input[8] & 0xc0) << 10);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 66 to 81
	value = ((uint32_t)(input[8] & 0x3f) << 26) |
			((uint32_t)input[9] << 18) |
			((uint32_t)(input[10] & 0xc0) << 10);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 82 to 97
	value = ((uint32_t)(input[10] & 0x3f) << 26) |
			((uint32_t)input[11] << 18) |
			((uint32_t)(input[12] & 0xc0) << 10);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 98 to 113
	value = ((uint32_t)(input[12] & 0x3f) << 26) |
			((uint32_t)input[13] << 18) |
			((uint32_t)(input[14] & 0xc0) << 10);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 114 to 129
	value = ((uint32_t)(input[14] & 0x3f) << 26) |
			((uint32_t)input[15] << 18) |
			((uint32_t)(input[16] & 0xc0) << 10);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 130 to 145
	value = ((uint32_t)(input[16] & 0x3f) << 26) |
			((uint32_t)input[17] << 18) |
			((uint32_t)(input[18] & 0xc0) << 10);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 146 to 161
	value = ((uint32_t)(input[18] & 0x3f) << 26) |
			((uint32_t)input[19] << 18) |
			((uint32_t)(input[20] & 0xc0) << 10);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 162 to 177
	value = ((uint32_t)(input[20] & 0x3f) << 26) |
			((uint32_t)input[21] << 18) |
			((uint32_t)(input[22] & 0xc0) << 10);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 178 to 193
	value = ((uint32_t)(input[22] & 0x3f) << 26) |
			((uint32_t)input[23] << 18) |
			((uint32_t)(input[24] & 0xc0) << 10);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 194 to 209
	value = ((uint32_t)(input[24] & 0x3f) << 26) |
			((uint32_t)input[25] << 18) |
			((uint32_t)(input[26] & 0xc0) << 10);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 210 to 225
	value = ((uint32_t)(input[26] & 0x3f) << 26) |
			((uint32_t)input[27] << 18) |
			((uint32_t)(input[28] & 0xc0) << 10);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 226 to 241
	value = ((uint32_t)(input[28] & 0x3f) << 26) |
			((uint32_t)input[29] << 18) |
			((uint32_t)(input[30] & 0xc0) << 10);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 242 to 257
	value = ((uint32_t)(input[30] & 0x3f) << 26) |
			((uint32_t)input[31] << 18) |
			((uint32_t)(input[32] & 0xc0) << 10);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 258 to 273
	value = ((uint32_t)(input[32] & 0x3f) << 26) |
			((uint32_t)input[33] << 18) |
			((uint32_t)(input[34] & 0xc0) << 10);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 274 to 289
	value = ((uint32_t)(input[34] & 0x3f) << 26) |
			((uint32_t)input[35] << 18) |
			((uint32_t)(input[36] & 0xc0) << 10);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 290 to 305
	value = ((uint32_t)(input[36] & 0x3f) << 26) |
			((uint32_t)input[37] << 18) |
			((uint32_t)(input[38] & 0xc0) << 10);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 306 to 321
	value = ((uint32_t)(input[38] & 0x3f) << 26) |
			((uint32_t)input[39] << 18) |
			((uint32_t)(input[40] & 0xc0) << 10);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 322 to 337
	value = ((uint32_t)(input[40] & 0x3f) << 26) |
			((uint32_t)input[41] << 18) |
			((uint32_t)(input[42] & 0xc0) << 10);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 338 to 353
	value = ((uint32_t)(input[42] & 0x3f) << 26) |
			((uint32_t)input[43] << 18) |
			((uint32_t)(input[44] & 0xc0) << 10);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 354 to 369
	value = ((uint32_t)(input[44] & 0x3f) << 26) |
			((uint32_t)input[45] << 18) |
			((uint32_t)(input[46] & 0xc0) << 10);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 370 to 385
	value = ((uint32_t)(input[46] & 0x3f) << 26) |
			((uint32_t)input[47] << 18) |
			((uint32_t)(input[48] & 0xc0) << 10);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 386 to 401
	value = ((uint32_t)(input[48] & 0x3f) << 26) |
			((uint32_t)input[49] << 18) |
			((uint32_t)(input[50] & 0xc0) << 10);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 402 to 417
	value = ((uint32_t)(input[50] & 0x3f) << 26) |
			((uint32_t)input[51] << 18) |
			((uint32_t)(input[52] & 0xc0) << 10);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 418 to 433
	value = ((uint32_t)(input[52] & 0x3f) << 26) |
			((uint32_t)input[53] << 18) |
			((uint32_t)(input[54] & 0xc0) << 10);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 434 to 449
	value = ((uint32_t)(input[54] & 0x3f) << 26) |
			((uint32_t)input[55] << 18) |
			((uint32_t)(input[56] & 0xc0) << 10);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 450 to 465
	value = ((uint32_t)(input[56] & 0x3f) << 26) |
			((uint32_t)input[57] << 18) |
			((uint32_t)(input[58] & 0xc0) << 10);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 466 to 481
	value = ((uint32_t)(input[58] & 0x3f) << 26) |
			((uint32_t)input[59] << 18) |
			((uint32_t)(input[60] & 0xc0) << 10);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 482 to 497
	value = ((uint32_t)(input[60] & 0x3f) << 26) |
			((uint32_t)input[61] << 18) |
			((uint32_t)(input[62] & 0xc0) << 10);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 498 to 513
	value = ((uint32_t)(input[62] & 0x3f) << 26) |
			((uint32_t)input[63] << 18) |
			((uint32_t)(input[64] & 0xc0) << 10);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 514 to 529
	value = ((uint32_t)(input[64] & 0x3f) << 26) |
			((uint32_t)input[65] << 18) |
			((uint32_t)(input[66] & 0xc0) << 10);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 530 to 545
	value = ((uint32_t)(input[66] & 0x3f) << 26) |
			((uint32_t)input[67] << 18) |
			((uint32_t)(input[68] & 0xc0) << 10);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 546 to 561
	value = ((uint32_t)(input[68] & 0x3f) << 26) |
			((uint32_t)input[69] << 18) |
			((uint32_t)(input[70] & 0xc0) << 10);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 562 to 577
	value = ((uint32_t)(input[70] & 0x3f) << 26) |
			((uint32_t)input[71] << 18) |
			((uint32_t)(input[72] & 0xc0) << 10);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 578 to 593
	value = ((uint32_t)(input[72] & 0x3f) << 26) |
			((uint32_t)input[73] << 18) |
			((uint32_t)(input[74] & 0xc0) << 10);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 594 to 609
	value = ((uint32_t)(input[74] & 0x3f) << 26) |
			((uint32_t)input[75] << 18) |
			((uint32_t)(input[76] & 0xc0) << 10);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 610 to 625
	value = ((uint32_t)(input[76] & 0x3f) << 26) |
			((uint32_t)input[77] << 18) |
			((uint32_t)(input[78] & 0xc0) << 10);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 626 to 641
	value = ((uint32_t)(input[78] & 0x3f) << 26) |
			((uint32_t)input[79] << 18) |
			((uint32_t)(input[80] & 0xc0) << 10);
	output[39] = (double)(value >> 16);

	// read output[40]: from bit 642 to 657
	value = ((uint32_t)(input[80] & 0x3f) << 26) |
			((uint32_t)input[81] << 18) |
			((uint32_t)(input[82] & 0xc0) << 10);
	output[40] = (double)(value >> 16);

	// read output[41]: from bit 658 to 673
	value = ((uint32_t)(input[82] & 0x3f) << 26) |
			((uint32_t)input[83] << 18) |
			((uint32_t)(input[84] & 0xc0) << 10);
	output[41] = (double)(value >> 16);

	// read output[42]: from bit 674 to 689
	value = ((uint32_t)(input[84] & 0x3f) << 26) |
			((uint32_t)input[85] << 18) |
			((uint32_t)(input[86] & 0xc0) << 10);
	output[42] = (double)(value >> 16);

	// read output[43]: from bit 690 to 705
	value = ((uint32_t)(input[86] & 0x3f) << 26) |
			((uint32_t)input[87] << 18) |
			((uint32_t)(input[88] & 0xc0) << 10);
	output[43] = (double)(value >> 16);

	// read output[44]: from bit 706 to 721
	value = ((uint32_t)(input[88] & 0x3f) << 26) |
			((uint32_t)input[89] << 18) |
			((uint32_t)(input[90] & 0xc0) << 10);
	output[44] = (double)(value >> 16);

	// read output[45]: from bit 722 to 737
	value = ((uint32_t)(input[90] & 0x3f) << 26) |
			((uint32_t)input[91] << 18) |
			((uint32_t)(input[92] & 0xc0) << 10);
	output[45] = (double)(value >> 16);

	// read output[46]: from bit 738 to 753
	value = ((uint32_t)(input[92] & 0x3f) << 26) |
			((uint32_t)input[93] << 18) |
			((uint32_t)(input[94] & 0xc0) << 10);
	output[46] = (double)(value >> 16);

	// read output[47]: from bit 754 to 769
	value = ((uint32_t)(input[94] & 0x3f) << 26) |
			((uint32_t)input[95] << 18) |
			((uint32_t)(input[96] & 0xc0) << 10);
	output[47] = (double)(value >> 16);

	// read output[48]: from bit 770 to 785
	value = ((uint32_t)(input[96] & 0x3f) << 26) |
			((uint32_t)input[97] << 18) |
			((uint32_t)(input[98] & 0xc0) << 10);
	output[48] = (double)(value >> 16);

	// read output[49]: from bit 786 to 801
	value = ((uint32_t)(input[98] & 0x3f) << 26) |
			((uint32_t)input[99] << 18) |
			((uint32_t)(input[100] & 0xc0) << 10);
	output[49] = (double)(value >> 16);

	// read output[50]: from bit 802 to 817
	value = ((uint32_t)(input[100] & 0x3f) << 26) |
			((uint32_t)input[101] << 18) |
			((uint32_t)(input[102] & 0xc0) << 10);
	output[50] = (double)(value >> 16);

	// read output[51]: from bit 818 to 833
	value = ((uint32_t)(input[102] & 0x3f) << 26) |
			((uint32_t)input[103] << 18) |
			((uint32_t)(input[104] & 0xc0) << 10);
	output[51] = (double)(value >> 16);

	// read output[52]: from bit 834 to 849
	value = ((uint32_t)(input[104] & 0x3f) << 26) |
			((uint32_t)input[105] << 18) |
			((uint32_t)(input[106] & 0xc0) << 10);
	output[52] = (double)(value >> 16);

	// read output[53]: from bit 850 to 865
	value = ((uint32_t)(input[106] & 0x3f) << 26) |
			((uint32_t)input[107] << 18) |
			((uint32_t)(input[108] & 0xc0) << 10);
	output[53] = (double)(value >> 16);

	// read output[54]: from bit 866 to 881
	value = ((uint32_t)(input[108] & 0x3f) << 26) |
			((uint32_t)input[109] << 18) |
			((uint32_t)(input[110] & 0xc0) << 10);
	output[54] = (double)(value >> 16);

	// read output[55]: from bit 882 to 897
	value = ((uint32_t)(input[110] & 0x3f) << 26) |
			((uint32_t)input[111] << 18) |
			((uint32_t)(input[112] & 0xc0) << 10);
	output[55] = (double)(value >> 16);

	// read output[56]: from bit 898 to 913
	value = ((uint32_t)(input[112] & 0x3f) << 26) |
			((uint32_t)input[113] << 18) |
			((uint32_t)(input[114] & 0xc0) << 10);
	output[56] = (double)(value >> 16);

	// read output[57]: from bit 914 to 929
	value = ((uint32_t)(input[114] & 0x3f) << 26) |
			((uint32_t)input[115] << 18) |
			((uint32_t)(input[116] & 0xc0) << 10);
	output[57] = (double)(value >> 16);

	// read output[58]: from bit 930 to 945
	value = ((uint32_t)(input[116] & 0x3f) << 26) |
			((uint32_t)input[117] << 18) |
			((uint32_t)(input[118] & 0xc0) << 10);
	output[58] = (double)(value >> 16);

	// read output[59]: from bit 946 to 961
	value = ((uint32_t)(input[118] & 0x3f) << 26) |
			((uint32_t)input[119] << 18) |
			((uint32_t)(input[120] & 0xc0) << 10);
	output[59] = (double)(value >> 16);

	// read output[60]: from bit 962 to 977
	value = ((uint32_t)(input[120] & 0x3f) << 26) |
			((uint32_t)input[121] << 18) |
			((uint32_t)(input[122] & 0xc0) << 10);
	output[60] = (double)(value >> 16);
}

static void unpack_61_16bit_signed_3off(const uint8_t * input, double * output, void *closure) {
	// Unpack 61 values into output
	// Values are 16-bit signed
	// Skip 3 bits, read 976 bits of data.
	// Input must be at least 123 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 3 to 18
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)input[1] << 19) |
			((uint32_t)(input[2] & 0xe0) << 11);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 19 to 34
	value = ((uint32_t)(input[2] & 0x1f) << 27) |
			((uint32_t)input[3] << 19) |
			((uint32_t)(input[4] & 0xe0) << 11);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 35 to 50
	value = ((uint32_t)(input[4] & 0x1f) << 27) |
			((uint32_t)input[5] << 19) |
			((uint32_t)(input[6] & 0xe0) << 11);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 51 to 66
	value = ((uint32_t)(input[6] & 0x1f) << 27) |
			((uint32_t)input[7] << 19) |
			((uint32_t)(input[8] & 0xe0) << 11);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 67 to 82
	value = ((uint32_t)(input[8] & 0x1f) << 27) |
			((uint32_t)input[9] << 19) |
			((uint32_t)(input[10] & 0xe0) << 11);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 83 to 98
	value = ((uint32_t)(input[10] & 0x1f) << 27) |
			((uint32_t)input[11] << 19) |
			((uint32_t)(input[12] & 0xe0) << 11);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 99 to 114
	value = ((uint32_t)(input[12] & 0x1f) << 27) |
			((uint32_t)input[13] << 19) |
			((uint32_t)(input[14] & 0xe0) << 11);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 115 to 130
	value = ((uint32_t)(input[14] & 0x1f) << 27) |
			((uint32_t)input[15] << 19) |
			((uint32_t)(input[16] & 0xe0) << 11);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 131 to 146
	value = ((uint32_t)(input[16] & 0x1f) << 27) |
			((uint32_t)input[17] << 19) |
			((uint32_t)(input[18] & 0xe0) << 11);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 147 to 162
	value = ((uint32_t)(input[18] & 0x1f) << 27) |
			((uint32_t)input[19] << 19) |
			((uint32_t)(input[20] & 0xe0) << 11);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 163 to 178
	value = ((uint32_t)(input[20] & 0x1f) << 27) |
			((uint32_t)input[21] << 19) |
			((uint32_t)(input[22] & 0xe0) << 11);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 179 to 194
	value = ((uint32_t)(input[22] & 0x1f) << 27) |
			((uint32_t)input[23] << 19) |
			((uint32_t)(input[24] & 0xe0) << 11);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 195 to 210
	value = ((uint32_t)(input[24] & 0x1f) << 27) |
			((uint32_t)input[25] << 19) |
			((uint32_t)(input[26] & 0xe0) << 11);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 211 to 226
	value = ((uint32_t)(input[26] & 0x1f) << 27) |
			((uint32_t)input[27] << 19) |
			((uint32_t)(input[28] & 0xe0) << 11);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 227 to 242
	value = ((uint32_t)(input[28] & 0x1f) << 27) |
			((uint32_t)input[29] << 19) |
			((uint32_t)(input[30] & 0xe0) << 11);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 243 to 258
	value = ((uint32_t)(input[30] & 0x1f) << 27) |
			((uint32_t)input[31] << 19) |
			((uint32_t)(input[32] & 0xe0) << 11);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 259 to 274
	value = ((uint32_t)(input[32] & 0x1f) << 27) |
			((uint32_t)input[33] << 19) |
			((uint32_t)(input[34] & 0xe0) << 11);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 275 to 290
	value = ((uint32_t)(input[34] & 0x1f) << 27) |
			((uint32_t)input[35] << 19) |
			((uint32_t)(input[36] & 0xe0) << 11);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 291 to 306
	value = ((uint32_t)(input[36] & 0x1f) << 27) |
			((uint32_t)input[37] << 19) |
			((uint32_t)(input[38] & 0xe0) << 11);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 307 to 322
	value = ((uint32_t)(input[38] & 0x1f) << 27) |
			((uint32_t)input[39] << 19) |
			((uint32_t)(input[40] & 0xe0) << 11);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 323 to 338
	value = ((uint32_t)(input[40] & 0x1f) << 27) |
			((uint32_t)input[41] << 19) |
			((uint32_t)(input[42] & 0xe0) << 11);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 339 to 354
	value = ((uint32_t)(input[42] & 0x1f) << 27) |
			((uint32_t)input[43] << 19) |
			((uint32_t)(input[44] & 0xe0) << 11);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 355 to 370
	value = ((uint32_t)(input[44] & 0x1f) << 27) |
			((uint32_t)input[45] << 19) |
			((uint32_t)(input[46] & 0xe0) << 11);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 371 to 386
	value = ((uint32_t)(input[46] & 0x1f) << 27) |
			((uint32_t)input[47] << 19) |
			((uint32_t)(input[48] & 0xe0) << 11);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 387 to 402
	value = ((uint32_t)(input[48] & 0x1f) << 27) |
			((uint32_t)input[49] << 19) |
			((uint32_t)(input[50] & 0xe0) << 11);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 403 to 418
	value = ((uint32_t)(input[50] & 0x1f) << 27) |
			((uint32_t)input[51] << 19) |
			((uint32_t)(input[52] & 0xe0) << 11);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 419 to 434
	value = ((uint32_t)(input[52] & 0x1f) << 27) |
			((uint32_t)input[53] << 19) |
			((uint32_t)(input[54] & 0xe0) << 11);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 435 to 450
	value = ((uint32_t)(input[54] & 0x1f) << 27) |
			((uint32_t)input[55] << 19) |
			((uint32_t)(input[56] & 0xe0) << 11);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 451 to 466
	value = ((uint32_t)(input[56] & 0x1f) << 27) |
			((uint32_t)input[57] << 19) |
			((uint32_t)(input[58] & 0xe0) << 11);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 467 to 482
	value = ((uint32_t)(input[58] & 0x1f) << 27) |
			((uint32_t)input[59] << 19) |
			((uint32_t)(input[60] & 0xe0) << 11);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 483 to 498
	value = ((uint32_t)(input[60] & 0x1f) << 27) |
			((uint32_t)input[61] << 19) |
			((uint32_t)(input[62] & 0xe0) << 11);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 499 to 514
	value = ((uint32_t)(input[62] & 0x1f) << 27) |
			((uint32_t)input[63] << 19) |
			((uint32_t)(input[64] & 0xe0) << 11);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 515 to 530
	value = ((uint32_t)(input[64] & 0x1f) << 27) |
			((uint32_t)input[65] << 19) |
			((uint32_t)(input[66] & 0xe0) << 11);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 531 to 546
	value = ((uint32_t)(input[66] & 0x1f) << 27) |
			((uint32_t)input[67] << 19) |
			((uint32_t)(input[68] & 0xe0) << 11);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 547 to 562
	value = ((uint32_t)(input[68] & 0x1f) << 27) |
			((uint32_t)input[69] << 19) |
			((uint32_t)(input[70] & 0xe0) << 11);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 563 to 578
	value = ((uint32_t)(input[70] & 0x1f) << 27) |
			((uint32_t)input[71] << 19) |
			((uint32_t)(input[72] & 0xe0) << 11);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 579 to 594
	value = ((uint32_t)(input[72] & 0x1f) << 27) |
			((uint32_t)input[73] << 19) |
			((uint32_t)(input[74] & 0xe0) << 11);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 595 to 610
	value = ((uint32_t)(input[74] & 0x1f) << 27) |
			((uint32_t)input[75] << 19) |
			((uint32_t)(input[76] & 0xe0) << 11);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 611 to 626
	value = ((uint32_t)(input[76] & 0x1f) << 27) |
			((uint32_t)input[77] << 19) |
			((uint32_t)(input[78] & 0xe0) << 11);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 627 to 642
	value = ((uint32_t)(input[78] & 0x1f) << 27) |
			((uint32_t)input[79] << 19) |
			((uint32_t)(input[80] & 0xe0) << 11);
	output[39] = (double)(value >> 16);

	// read output[40]: from bit 643 to 658
	value = ((uint32_t)(input[80] & 0x1f) << 27) |
			((uint32_t)input[81] << 19) |
			((uint32_t)(input[82] & 0xe0) << 11);
	output[40] = (double)(value >> 16);

	// read output[41]: from bit 659 to 674
	value = ((uint32_t)(input[82] & 0x1f) << 27) |
			((uint32_t)input[83] << 19) |
			((uint32_t)(input[84] & 0xe0) << 11);
	output[41] = (double)(value >> 16);

	// read output[42]: from bit 675 to 690
	value = ((uint32_t)(input[84] & 0x1f) << 27) |
			((uint32_t)input[85] << 19) |
			((uint32_t)(input[86] & 0xe0) << 11);
	output[42] = (double)(value >> 16);

	// read output[43]: from bit 691 to 706
	value = ((uint32_t)(input[86] & 0x1f) << 27) |
			((uint32_t)input[87] << 19) |
			((uint32_t)(input[88] & 0xe0) << 11);
	output[43] = (double)(value >> 16);

	// read output[44]: from bit 707 to 722
	value = ((uint32_t)(input[88] & 0x1f) << 27) |
			((uint32_t)input[89] << 19) |
			((uint32_t)(input[90] & 0xe0) << 11);
	output[44] = (double)(value >> 16);

	// read output[45]: from bit 723 to 738
	value = ((uint32_t)(input[90] & 0x1f) << 27) |
			((uint32_t)input[91] << 19) |
			((uint32_t)(input[92] & 0xe0) << 11);
	output[45] = (double)(value >> 16);

	// read output[46]: from bit 739 to 754
	value = ((uint32_t)(input[92] & 0x1f) << 27) |
			((uint32_t)input[93] << 19) |
			((uint32_t)(input[94] & 0xe0) << 11);
	output[46] = (double)(value >> 16);

	// read output[47]: from bit 755 to 770
	value = ((uint32_t)(input[94] & 0x1f) << 27) |
			((uint32_t)input[95] << 19) |
			((uint32_t)(input[96] & 0xe0) << 11);
	output[47] = (double)(value >> 16);

	// read output[48]: from bit 771 to 786
	value = ((uint32_t)(input[96] & 0x1f) << 27) |
			((uint32_t)input[97] << 19) |
			((uint32_t)(input[98] & 0xe0) << 11);
	output[48] = (double)(value >> 16);

	// read output[49]: from bit 787 to 802
	value = ((uint32_t)(input[98] & 0x1f) << 27) |
			((uint32_t)input[99] << 19) |
			((uint32_t)(input[100] & 0xe0) << 11);
	output[49] = (double)(value >> 16);

	// read output[50]: from bit 803 to 818
	value = ((uint32_t)(input[100] & 0x1f) << 27) |
			((uint32_t)input[101] << 19) |
			((uint32_t)(input[102] & 0xe0) << 11);
	output[50] = (double)(value >> 16);

	// read output[51]: from bit 819 to 834
	value = ((uint32_t)(input[102] & 0x1f) << 27) |
			((uint32_t)input[103] << 19) |
			((uint32_t)(input[104] & 0xe0) << 11);
	output[51] = (double)(value >> 16);

	// read output[52]: from bit 835 to 850
	value = ((uint32_t)(input[104] & 0x1f) << 27) |
			((uint32_t)input[105] << 19) |
			((uint32_t)(input[106] & 0xe0) << 11);
	output[52] = (double)(value >> 16);

	// read output[53]: from bit 851 to 866
	value = ((uint32_t)(input[106] & 0x1f) << 27) |
			((uint32_t)input[107] << 19) |
			((uint32_t)(input[108] & 0xe0) << 11);
	output[53] = (double)(value >> 16);

	// read output[54]: from bit 867 to 882
	value = ((uint32_t)(input[108] & 0x1f) << 27) |
			((uint32_t)input[109] << 19) |
			((uint32_t)(input[110] & 0xe0) << 11);
	output[54] = (double)(value >> 16);

	// read output[55]: from bit 883 to 898
	value = ((uint32_t)(input[110] & 0x1f) << 27) |
			((uint32_t)input[111] << 19) |
			((uint32_t)(input[112] & 0xe0) << 11);
	output[55] = (double)(value >> 16);

	// read output[56]: from bit 899 to 914
	value = ((uint32_t)(input[112] & 0x1f) << 27) |
			((uint32_t)input[113] << 19) |
			((uint32_t)(input[114] & 0xe0) << 11);
	output[56] = (double)(value >> 16);

	// read output[57]: from bit 915 to 930
	value = ((uint32_t)(input[114] & 0x1f) << 27) |
			((uint32_t)input[115] << 19) |
			((uint32_t)(input[116] & 0xe0) << 11);
	output[57] = (double)(value >> 16);

	// read output[58]: from bit 931 to 946
	value = ((uint32_t)(input[116] & 0x1f) << 27) |
			((uint32_t)input[117] << 19) |
			((uint32_t)(input[118] & 0xe0) << 11);
	output[58] = (double)(value >> 16);

	// read output[59]: from bit 947 to 962
	value = ((uint32_t)(input[118] & 0x1f) << 27) |
			((uint32_t)input[119] << 19) |
			((uint32_t)(input[120] & 0xe0) << 11);
	output[59] = (double)(value >> 16);

	// read output[60]: from bit 963 to 978
	value = ((uint32_t)(input[120] & 0x1f) << 27) |
			((uint32_t)input[121] << 19) |
			((uint32_t)(input[122] & 0xe0) << 11);
	output[60] = (double)(value >> 16);
}

static void unpack_61_16bit_unsigned_3off(const uint8_t * input, double * output, void *closure) {
	// Unpack 61 values into output
	// Values are 16-bit unsigned
	// Skip 3 bits, read 976 bits of data.
	// Input must be at least 123 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 3 to 18
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)input[1] << 19) |
			((uint32_t)(input[2] & 0xe0) << 11);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 19 to 34
	value = ((uint32_t)(input[2] & 0x1f) << 27) |
			((uint32_t)input[3] << 19) |
			((uint32_t)(input[4] & 0xe0) << 11);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 35 to 50
	value = ((uint32_t)(input[4] & 0x1f) << 27) |
			((uint32_t)input[5] << 19) |
			((uint32_t)(input[6] & 0xe0) << 11);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 51 to 66
	value = ((uint32_t)(input[6] & 0x1f) << 27) |
			((uint32_t)input[7] << 19) |
			((uint32_t)(input[8] & 0xe0) << 11);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 67 to 82
	value = ((uint32_t)(input[8] & 0x1f) << 27) |
			((uint32_t)input[9] << 19) |
			((uint32_t)(input[10] & 0xe0) << 11);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 83 to 98
	value = ((uint32_t)(input[10] & 0x1f) << 27) |
			((uint32_t)input[11] << 19) |
			((uint32_t)(input[12] & 0xe0) << 11);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 99 to 114
	value = ((uint32_t)(input[12] & 0x1f) << 27) |
			((uint32_t)input[13] << 19) |
			((uint32_t)(input[14] & 0xe0) << 11);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 115 to 130
	value = ((uint32_t)(input[14] & 0x1f) << 27) |
			((uint32_t)input[15] << 19) |
			((uint32_t)(input[16] & 0xe0) << 11);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 131 to 146
	value = ((uint32_t)(input[16] & 0x1f) << 27) |
			((uint32_t)input[17] << 19) |
			((uint32_t)(input[18] & 0xe0) << 11);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 147 to 162
	value = ((uint32_t)(input[18] & 0x1f) << 27) |
			((uint32_t)input[19] << 19) |
			((uint32_t)(input[20] & 0xe0) << 11);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 163 to 178
	value = ((uint32_t)(input[20] & 0x1f) << 27) |
			((uint32_t)input[21] << 19) |
			((uint32_t)(input[22] & 0xe0) << 11);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 179 to 194
	value = ((uint32_t)(input[22] & 0x1f) << 27) |
			((uint32_t)input[23] << 19) |
			((uint32_t)(input[24] & 0xe0) << 11);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 195 to 210
	value = ((uint32_t)(input[24] & 0x1f) << 27) |
			((uint32_t)input[25] << 19) |
			((uint32_t)(input[26] & 0xe0) << 11);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 211 to 226
	value = ((uint32_t)(input[26] & 0x1f) << 27) |
			((uint32_t)input[27] << 19) |
			((uint32_t)(input[28] & 0xe0) << 11);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 227 to 242
	value = ((uint32_t)(input[28] & 0x1f) << 27) |
			((uint32_t)input[29] << 19) |
			((uint32_t)(input[30] & 0xe0) << 11);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 243 to 258
	value = ((uint32_t)(input[30] & 0x1f) << 27) |
			((uint32_t)input[31] << 19) |
			((uint32_t)(input[32] & 0xe0) << 11);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 259 to 274
	value = ((uint32_t)(input[32] & 0x1f) << 27) |
			((uint32_t)input[33] << 19) |
			((uint32_t)(input[34] & 0xe0) << 11);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 275 to 290
	value = ((uint32_t)(input[34] & 0x1f) << 27) |
			((uint32_t)input[35] << 19) |
			((uint32_t)(input[36] & 0xe0) << 11);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 291 to 306
	value = ((uint32_t)(input[36] & 0x1f) << 27) |
			((uint32_t)input[37] << 19) |
			((uint32_t)(input[38] & 0xe0) << 11);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 307 to 322
	value = ((uint32_t)(input[38] & 0x1f) << 27) |
			((uint32_t)input[39] << 19) |
			((uint32_t)(input[40] & 0xe0) << 11);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 323 to 338
	value = ((uint32_t)(input[40] & 0x1f) << 27) |
			((uint32_t)input[41] << 19) |
			((uint32_t)(input[42] & 0xe0) << 11);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 339 to 354
	value = ((uint32_t)(input[42] & 0x1f) << 27) |
			((uint32_t)input[43] << 19) |
			((uint32_t)(input[44] & 0xe0) << 11);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 355 to 370
	value = ((uint32_t)(input[44] & 0x1f) << 27) |
			((uint32_t)input[45] << 19) |
			((uint32_t)(input[46] & 0xe0) << 11);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 371 to 386
	value = ((uint32_t)(input[46] & 0x1f) << 27) |
			((uint32_t)input[47] << 19) |
			((uint32_t)(input[48] & 0xe0) << 11);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 387 to 402
	value = ((uint32_t)(input[48] & 0x1f) << 27) |
			((uint32_t)input[49] << 19) |
			((uint32_t)(input[50] & 0xe0) << 11);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 403 to 418
	value = ((uint32_t)(input[50] & 0x1f) << 27) |
			((uint32_t)input[51] << 19) |
			((uint32_t)(input[52] & 0xe0) << 11);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 419 to 434
	value = ((uint32_t)(input[52] & 0x1f) << 27) |
			((uint32_t)input[53] << 19) |
			((uint32_t)(input[54] & 0xe0) << 11);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 435 to 450
	value = ((uint32_t)(input[54] & 0x1f) << 27) |
			((uint32_t)input[55] << 19) |
			((uint32_t)(input[56] & 0xe0) << 11);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 451 to 466
	value = ((uint32_t)(input[56] & 0x1f) << 27) |
			((uint32_t)input[57] << 19) |
			((uint32_t)(input[58] & 0xe0) << 11);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 467 to 482
	value = ((uint32_t)(input[58] & 0x1f) << 27) |
			((uint32_t)input[59] << 19) |
			((uint32_t)(input[60] & 0xe0) << 11);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 483 to 498
	value = ((uint32_t)(input[60] & 0x1f) << 27) |
			((uint32_t)input[61] << 19) |
			((uint32_t)(input[62] & 0xe0) << 11);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 499 to 514
	value = ((uint32_t)(input[62] & 0x1f) << 27) |
			((uint32_t)input[63] << 19) |
			((uint32_t)(input[64] & 0xe0) << 11);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 515 to 530
	value = ((uint32_t)(input[64] & 0x1f) << 27) |
			((uint32_t)input[65] << 19) |
			((uint32_t)(input[66] & 0xe0) << 11);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 531 to 546
	value = ((uint32_t)(input[66] & 0x1f) << 27) |
			((uint32_t)input[67] << 19) |
			((uint32_t)(input[68] & 0xe0) << 11);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 547 to 562
	value = ((uint32_t)(input[68] & 0x1f) << 27) |
			((uint32_t)input[69] << 19) |
			((uint32_t)(input[70] & 0xe0) << 11);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 563 to 578
	value = ((uint32_t)(input[70] & 0x1f) << 27) |
			((uint32_t)input[71] << 19) |
			((uint32_t)(input[72] & 0xe0) << 11);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 579 to 594
	value = ((uint32_t)(input[72] & 0x1f) << 27) |
			((uint32_t)input[73] << 19) |
			((uint32_t)(input[74] & 0xe0) << 11);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 595 to 610
	value = ((uint32_t)(input[74] & 0x1f) << 27) |
			((uint32_t)input[75] << 19) |
			((uint32_t)(input[76] & 0xe0) << 11);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 611 to 626
	value = ((uint32_t)(input[76] & 0x1f) << 27) |
			((uint32_t)input[77] << 19) |
			((uint32_t)(input[78] & 0xe0) << 11);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 627 to 642
	value = ((uint32_t)(input[78] & 0x1f) << 27) |
			((uint32_t)input[79] << 19) |
			((uint32_t)(input[80] & 0xe0) << 11);
	output[39] = (double)(value >> 16);

	// read output[40]: from bit 643 to 658
	value = ((uint32_t)(input[80] & 0x1f) << 27) |
			((uint32_t)input[81] << 19) |
			((uint32_t)(input[82] & 0xe0) << 11);
	output[40] = (double)(value >> 16);

	// read output[41]: from bit 659 to 674
	value = ((uint32_t)(input[82] & 0x1f) << 27) |
			((uint32_t)input[83] << 19) |
			((uint32_t)(input[84] & 0xe0) << 11);
	output[41] = (double)(value >> 16);

	// read output[42]: from bit 675 to 690
	value = ((uint32_t)(input[84] & 0x1f) << 27) |
			((uint32_t)input[85] << 19) |
			((uint32_t)(input[86] & 0xe0) << 11);
	output[42] = (double)(value >> 16);

	// read output[43]: from bit 691 to 706
	value = ((uint32_t)(input[86] & 0x1f) << 27) |
			((uint32_t)input[87] << 19) |
			((uint32_t)(input[88] & 0xe0) << 11);
	output[43] = (double)(value >> 16);

	// read output[44]: from bit 707 to 722
	value = ((uint32_t)(input[88] & 0x1f) << 27) |
			((uint32_t)input[89] << 19) |
			((uint32_t)(input[90] & 0xe0) << 11);
	output[44] = (double)(value >> 16);

	// read output[45]: from bit 723 to 738
	value = ((uint32_t)(input[90] & 0x1f) << 27) |
			((uint32_t)input[91] << 19) |
			((uint32_t)(input[92] & 0xe0) << 11);
	output[45] = (double)(value >> 16);

	// read output[46]: from bit 739 to 754
	value = ((uint32_t)(input[92] & 0x1f) << 27) |
			((uint32_t)input[93] << 19) |
			((uint32_t)(input[94] & 0xe0) << 11);
	output[46] = (double)(value >> 16);

	// read output[47]: from bit 755 to 770
	value = ((uint32_t)(input[94] & 0x1f) << 27) |
			((uint32_t)input[95] << 19) |
			((uint32_t)(input[96] & 0xe0) << 11);
	output[47] = (double)(value >> 16);

	// read output[48]: from bit 771 to 786
	value = ((uint32_t)(input[96] & 0x1f) << 27) |
			((uint32_t)input[97] << 19) |
			((uint32_t)(input[98] & 0xe0) << 11);
	output[48] = (double)(value >> 16);

	// read output[49]: from bit 787 to 802
	value = ((uint32_t)(input[98] & 0x1f) << 27) |
			((uint32_t)input[99] << 19) |
			((uint32_t)(input[100] & 0xe0) << 11);
	output[49] = (double)(value >> 16);

	// read output[50]: from bit 803 to 818
	value = ((uint32_t)(input[100] & 0x1f) << 27) |
			((uint32_t)input[101] << 19) |
			((uint32_t)(input[102] & 0xe0) << 11);
	output[50] = (double)(value >> 16);

	// read output[51]: from bit 819 to 834
	value = ((uint32_t)(input[102] & 0x1f) << 27) |
			((uint32_t)input[103] << 19) |
			((uint32_t)(input[104] & 0xe0) << 11);
	output[51] = (double)(value >> 16);

	// read output[52]: from bit 835 to 850
	value = ((uint32_t)(input[104] & 0x1f) << 27) |
			((uint32_t)input[105] << 19) |
			((uint32_t)(input[106] & 0xe0) << 11);
	output[52] = (double)(value >> 16);

	// read output[53]: from bit 851 to 866
	value = ((uint32_t)(input[106] & 0x1f) << 27) |
			((uint32_t)input[107] << 19) |
			((uint32_t)(input[108] & 0xe0) << 11);
	output[53] = (double)(value >> 16);

	// read output[54]: from bit 867 to 882
	value = ((uint32_t)(input[108] & 0x1f) << 27) |
			((uint32_t)input[109] << 19) |
			((uint32_t)(input[110] & 0xe0) << 11);
	output[54] = (double)(value >> 16);

	// read output[55]: from bit 883 to 898
	value = ((uint32_t)(input[110] & 0x1f) << 27) |
			((uint32_t)input[111] << 19) |
			((uint32_t)(input[112] & 0xe0) << 11);
	output[55] = (double)(value >> 16);

	// read output[56]: from bit 899 to 914
	value = ((uint32_t)(input[112] & 0x1f) << 27) |
			((uint32_t)input[113] << 19) |
			((uint32_t)(input[114] & 0xe0) << 11);
	output[56] = (double)(value >> 16);

	// read output[57]: from bit 915 to 930
	value = ((uint32_t)(input[114] & 0x1f) << 27) |
			((uint32_t)input[115] << 19) |
			((uint32_t)(input[116] & 0xe0) << 11);
	output[57] = (double)(value >> 16);

	// read output[58]: from bit 931 to 946
	value = ((uint32_t)(input[116] & 0x1f) << 27) |
			((uint32_t)input[117] << 19) |
			((uint32_t)(input[118] & 0xe0) << 11);
	output[58] = (double)(value >> 16);

	// read output[59]: from bit 947 to 962
	value = ((uint32_t)(input[118] & 0x1f) << 27) |
			((uint32_t)input[119] << 19) |
			((uint32_t)(input[120] & 0xe0) << 11);
	output[59] = (double)(value >> 16);

	// read output[60]: from bit 963 to 978
	value = ((uint32_t)(input[120] & 0x1f) << 27) |
			((uint32_t)input[121] << 19) |
			((uint32_t)(input[122] & 0xe0) << 11);
	output[60] = (double)(value >> 16);
}

static void unpack_61_16bit_signed_4off(const uint8_t * input, double * output, void *closure) {
	// Unpack 61 values into output
	// Values are 16-bit signed
	// Skip 4 bits, read 976 bits of data.
	// Input must be at least 123 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 4 to 19
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20) |
			((uint32_t)(input[2] & 0xf0) << 12);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 20 to 35
	value = ((uint32_t)(input[2] & 0x0f) << 28) |
			((uint32_t)input[3] << 20) |
			((uint32_t)(input[4] & 0xf0) << 12);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 36 to 51
	value = ((uint32_t)(input[4] & 0x0f) << 28) |
			((uint32_t)input[5] << 20) |
			((uint32_t)(input[6] & 0xf0) << 12);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 52 to 67
	value = ((uint32_t)(input[6] & 0x0f) << 28) |
			((uint32_t)input[7] << 20) |
			((uint32_t)(input[8] & 0xf0) << 12);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 68 to 83
	value = ((uint32_t)(input[8] & 0x0f) << 28) |
			((uint32_t)input[9] << 20) |
			((uint32_t)(input[10] & 0xf0) << 12);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 84 to 99
	value = ((uint32_t)(input[10] & 0x0f) << 28) |
			((uint32_t)input[11] << 20) |
			((uint32_t)(input[12] & 0xf0) << 12);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 100 to 115
	value = ((uint32_t)(input[12] & 0x0f) << 28) |
			((uint32_t)input[13] << 20) |
			((uint32_t)(input[14] & 0xf0) << 12);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 116 to 131
	value = ((uint32_t)(input[14] & 0x0f) << 28) |
			((uint32_t)input[15] << 20) |
			((uint32_t)(input[16] & 0xf0) << 12);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 132 to 147
	value = ((uint32_t)(input[16] & 0x0f) << 28) |
			((uint32_t)input[17] << 20) |
			((uint32_t)(input[18] & 0xf0) << 12);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 148 to 163
	value = ((uint32_t)(input[18] & 0x0f) << 28) |
			((uint32_t)input[19] << 20) |
			((uint32_t)(input[20] & 0xf0) << 12);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 164 to 179
	value = ((uint32_t)(input[20] & 0x0f) << 28) |
			((uint32_t)input[21] << 20) |
			((uint32_t)(input[22] & 0xf0) << 12);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 180 to 195
	value = ((uint32_t)(input[22] & 0x0f) << 28) |
			((uint32_t)input[23] << 20) |
			((uint32_t)(input[24] & 0xf0) << 12);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 196 to 211
	value = ((uint32_t)(input[24] & 0x0f) << 28) |
			((uint32_t)input[25] << 20) |
			((uint32_t)(input[26] & 0xf0) << 12);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 212 to 227
	value = ((uint32_t)(input[26] & 0x0f) << 28) |
			((uint32_t)input[27] << 20) |
			((uint32_t)(input[28] & 0xf0) << 12);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 228 to 243
	value = ((uint32_t)(input[28] & 0x0f) << 28) |
			((uint32_t)input[29] << 20) |
			((uint32_t)(input[30] & 0xf0) << 12);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 244 to 259
	value = ((uint32_t)(input[30] & 0x0f) << 28) |
			((uint32_t)input[31] << 20) |
			((uint32_t)(input[32] & 0xf0) << 12);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 260 to 275
	value = ((uint32_t)(input[32] & 0x0f) << 28) |
			((uint32_t)input[33] << 20) |
			((uint32_t)(input[34] & 0xf0) << 12);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 276 to 291
	value = ((uint32_t)(input[34] & 0x0f) << 28) |
			((uint32_t)input[35] << 20) |
			((uint32_t)(input[36] & 0xf0) << 12);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 292 to 307
	value = ((uint32_t)(input[36] & 0x0f) << 28) |
			((uint32_t)input[37] << 20) |
			((uint32_t)(input[38] & 0xf0) << 12);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 308 to 323
	value = ((uint32_t)(input[38] & 0x0f) << 28) |
			((uint32_t)input[39] << 20) |
			((uint32_t)(input[40] & 0xf0) << 12);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 324 to 339
	value = ((uint32_t)(input[40] & 0x0f) << 28) |
			((uint32_t)input[41] << 20) |
			((uint32_t)(input[42] & 0xf0) << 12);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 340 to 355
	value = ((uint32_t)(input[42] & 0x0f) << 28) |
			((uint32_t)input[43] << 20) |
			((uint32_t)(input[44] & 0xf0) << 12);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 356 to 371
	value = ((uint32_t)(input[44] & 0x0f) << 28) |
			((uint32_t)input[45] << 20) |
			((uint32_t)(input[46] & 0xf0) << 12);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 372 to 387
	value = ((uint32_t)(input[46] & 0x0f) << 28) |
			((uint32_t)input[47] << 20) |
			((uint32_t)(input[48] & 0xf0) << 12);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 388 to 403
	value = ((uint32_t)(input[48] & 0x0f) << 28) |
			((uint32_t)input[49] << 20) |
			((uint32_t)(input[50] & 0xf0) << 12);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 404 to 419
	value = ((uint32_t)(input[50] & 0x0f) << 28) |
			((uint32_t)input[51] << 20) |
			((uint32_t)(input[52] & 0xf0) << 12);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 420 to 435
	value = ((uint32_t)(input[52] & 0x0f) << 28) |
			((uint32_t)input[53] << 20) |
			((uint32_t)(input[54] & 0xf0) << 12);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 436 to 451
	value = ((uint32_t)(input[54] & 0x0f) << 28) |
			((uint32_t)input[55] << 20) |
			((uint32_t)(input[56] & 0xf0) << 12);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 452 to 467
	value = ((uint32_t)(input[56] & 0x0f) << 28) |
			((uint32_t)input[57] << 20) |
			((uint32_t)(input[58] & 0xf0) << 12);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 468 to 483
	value = ((uint32_t)(input[58] & 0x0f) << 28) |
			((uint32_t)input[59] << 20) |
			((uint32_t)(input[60] & 0xf0) << 12);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 484 to 499
	value = ((uint32_t)(input[60] & 0x0f) << 28) |
			((uint32_t)input[61] << 20) |
			((uint32_t)(input[62] & 0xf0) << 12);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 500 to 515
	value = ((uint32_t)(input[62] & 0x0f) << 28) |
			((uint32_t)input[63] << 20) |
			((uint32_t)(input[64] & 0xf0) << 12);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 516 to 531
	value = ((uint32_t)(input[64] & 0x0f) << 28) |
			((uint32_t)input[65] << 20) |
			((uint32_t)(input[66] & 0xf0) << 12);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 532 to 547
	value = ((uint32_t)(input[66] & 0x0f) << 28) |
			((uint32_t)input[67] << 20) |
			((uint32_t)(input[68] & 0xf0) << 12);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 548 to 563
	value = ((uint32_t)(input[68] & 0x0f) << 28) |
			((uint32_t)input[69] << 20) |
			((uint32_t)(input[70] & 0xf0) << 12);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 564 to 579
	value = ((uint32_t)(input[70] & 0x0f) << 28) |
			((uint32_t)input[71] << 20) |
			((uint32_t)(input[72] & 0xf0) << 12);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 580 to 595
	value = ((uint32_t)(input[72] & 0x0f) << 28) |
			((uint32_t)input[73] << 20) |
			((uint32_t)(input[74] & 0xf0) << 12);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 596 to 611
	value = ((uint32_t)(input[74] & 0x0f) << 28) |
			((uint32_t)input[75] << 20) |
			((uint32_t)(input[76] & 0xf0) << 12);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 612 to 627
	value = ((uint32_t)(input[76] & 0x0f) << 28) |
			((uint32_t)input[77] << 20) |
			((uint32_t)(input[78] & 0xf0) << 12);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 628 to 643
	value = ((uint32_t)(input[78] & 0x0f) << 28) |
			((uint32_t)input[79] << 20) |
			((uint32_t)(input[80] & 0xf0) << 12);
	output[39] = (double)(value >> 16);

	// read output[40]: from bit 644 to 659
	value = ((uint32_t)(input[80] & 0x0f) << 28) |
			((uint32_t)input[81] << 20) |
			((uint32_t)(input[82] & 0xf0) << 12);
	output[40] = (double)(value >> 16);

	// read output[41]: from bit 660 to 675
	value = ((uint32_t)(input[82] & 0x0f) << 28) |
			((uint32_t)input[83] << 20) |
			((uint32_t)(input[84] & 0xf0) << 12);
	output[41] = (double)(value >> 16);

	// read output[42]: from bit 676 to 691
	value = ((uint32_t)(input[84] & 0x0f) << 28) |
			((uint32_t)input[85] << 20) |
			((uint32_t)(input[86] & 0xf0) << 12);
	output[42] = (double)(value >> 16);

	// read output[43]: from bit 692 to 707
	value = ((uint32_t)(input[86] & 0x0f) << 28) |
			((uint32_t)input[87] << 20) |
			((uint32_t)(input[88] & 0xf0) << 12);
	output[43] = (double)(value >> 16);

	// read output[44]: from bit 708 to 723
	value = ((uint32_t)(input[88] & 0x0f) << 28) |
			((uint32_t)input[89] << 20) |
			((uint32_t)(input[90] & 0xf0) << 12);
	output[44] = (double)(value >> 16);

	// read output[45]: from bit 724 to 739
	value = ((uint32_t)(input[90] & 0x0f) << 28) |
			((uint32_t)input[91] << 20) |
			((uint32_t)(input[92] & 0xf0) << 12);
	output[45] = (double)(value >> 16);

	// read output[46]: from bit 740 to 755
	value = ((uint32_t)(input[92] & 0x0f) << 28) |
			((uint32_t)input[93] << 20) |
			((uint32_t)(input[94] & 0xf0) << 12);
	output[46] = (double)(value >> 16);

	// read output[47]: from bit 756 to 771
	value = ((uint32_t)(input[94] & 0x0f) << 28) |
			((uint32_t)input[95] << 20) |
			((uint32_t)(input[96] & 0xf0) << 12);
	output[47] = (double)(value >> 16);

	// read output[48]: from bit 772 to 787
	value = ((uint32_t)(input[96] & 0x0f) << 28) |
			((uint32_t)input[97] << 20) |
			((uint32_t)(input[98] & 0xf0) << 12);
	output[48] = (double)(value >> 16);

	// read output[49]: from bit 788 to 803
	value = ((uint32_t)(input[98] & 0x0f) << 28) |
			((uint32_t)input[99] << 20) |
			((uint32_t)(input[100] & 0xf0) << 12);
	output[49] = (double)(value >> 16);

	// read output[50]: from bit 804 to 819
	value = ((uint32_t)(input[100] & 0x0f) << 28) |
			((uint32_t)input[101] << 20) |
			((uint32_t)(input[102] & 0xf0) << 12);
	output[50] = (double)(value >> 16);

	// read output[51]: from bit 820 to 835
	value = ((uint32_t)(input[102] & 0x0f) << 28) |
			((uint32_t)input[103] << 20) |
			((uint32_t)(input[104] & 0xf0) << 12);
	output[51] = (double)(value >> 16);

	// read output[52]: from bit 836 to 851
	value = ((uint32_t)(input[104] & 0x0f) << 28) |
			((uint32_t)input[105] << 20) |
			((uint32_t)(input[106] & 0xf0) << 12);
	output[52] = (double)(value >> 16);

	// read output[53]: from bit 852 to 867
	value = ((uint32_t)(input[106] & 0x0f) << 28) |
			((uint32_t)input[107] << 20) |
			((uint32_t)(input[108] & 0xf0) << 12);
	output[53] = (double)(value >> 16);

	// read output[54]: from bit 868 to 883
	value = ((uint32_t)(input[108] & 0x0f) << 28) |
			((uint32_t)input[109] << 20) |
			((uint32_t)(input[110] & 0xf0) << 12);
	output[54] = (double)(value >> 16);

	// read output[55]: from bit 884 to 899
	value = ((uint32_t)(input[110] & 0x0f) << 28) |
			((uint32_t)input[111] << 20) |
			((uint32_t)(input[112] & 0xf0) << 12);
	output[55] = (double)(value >> 16);

	// read output[56]: from bit 900 to 915
	value = ((uint32_t)(input[112] & 0x0f) << 28) |
			((uint32_t)input[113] << 20) |
			((uint32_t)(input[114] & 0xf0) << 12);
	output[56] = (double)(value >> 16);

	// read output[57]: from bit 916 to 931
	value = ((uint32_t)(input[114] & 0x0f) << 28) |
			((uint32_t)input[115] << 20) |
			((uint32_t)(input[116] & 0xf0) << 12);
	output[57] = (double)(value >> 16);

	// read output[58]: from bit 932 to 947
	value = ((uint32_t)(input[116] & 0x0f) << 28) |
			((uint32_t)input[117] << 20) |
			((uint32_t)(input[118] & 0xf0) << 12);
	output[58] = (double)(value >> 16);

	// read output[59]: from bit 948 to 963
	value = ((uint32_t)(input[118] & 0x0f) << 28) |
			((uint32_t)input[119] << 20) |
			((uint32_t)(input[120] & 0xf0) << 12);
	output[59] = (double)(value >> 16);

	// read output[60]: from bit 964 to 979
	value = ((uint32_t)(input[120] & 0x0f) << 28) |
			((uint32_t)input[121] << 20) |
			((uint32_t)(input[122] & 0xf0) << 12);
	output[60] = (double)(value >> 16);
}

static void unpack_61_16bit_unsigned_4off(const uint8_t * input, double * output, void *closure) {
	// Unpack 61 values into output
	// Values are 16-bit unsigned
	// Skip 4 bits, read 976 bits of data.
	// Input must be at least 123 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 4 to 19
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20) |
			((uint32_t)(input[2] & 0xf0) << 12);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 20 to 35
	value = ((uint32_t)(input[2] & 0x0f) << 28) |
			((uint32_t)input[3] << 20) |
			((uint32_t)(input[4] & 0xf0) << 12);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 36 to 51
	value = ((uint32_t)(input[4] & 0x0f) << 28) |
			((uint32_t)input[5] << 20) |
			((uint32_t)(input[6] & 0xf0) << 12);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 52 to 67
	value = ((uint32_t)(input[6] & 0x0f) << 28) |
			((uint32_t)input[7] << 20) |
			((uint32_t)(input[8] & 0xf0) << 12);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 68 to 83
	value = ((uint32_t)(input[8] & 0x0f) << 28) |
			((uint32_t)input[9] << 20) |
			((uint32_t)(input[10] & 0xf0) << 12);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 84 to 99
	value = ((uint32_t)(input[10] & 0x0f) << 28) |
			((uint32_t)input[11] << 20) |
			((uint32_t)(input[12] & 0xf0) << 12);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 100 to 115
	value = ((uint32_t)(input[12] & 0x0f) << 28) |
			((uint32_t)input[13] << 20) |
			((uint32_t)(input[14] & 0xf0) << 12);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 116 to 131
	value = ((uint32_t)(input[14] & 0x0f) << 28) |
			((uint32_t)input[15] << 20) |
			((uint32_t)(input[16] & 0xf0) << 12);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 132 to 147
	value = ((uint32_t)(input[16] & 0x0f) << 28) |
			((uint32_t)input[17] << 20) |
			((uint32_t)(input[18] & 0xf0) << 12);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 148 to 163
	value = ((uint32_t)(input[18] & 0x0f) << 28) |
			((uint32_t)input[19] << 20) |
			((uint32_t)(input[20] & 0xf0) << 12);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 164 to 179
	value = ((uint32_t)(input[20] & 0x0f) << 28) |
			((uint32_t)input[21] << 20) |
			((uint32_t)(input[22] & 0xf0) << 12);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 180 to 195
	value = ((uint32_t)(input[22] & 0x0f) << 28) |
			((uint32_t)input[23] << 20) |
			((uint32_t)(input[24] & 0xf0) << 12);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 196 to 211
	value = ((uint32_t)(input[24] & 0x0f) << 28) |
			((uint32_t)input[25] << 20) |
			((uint32_t)(input[26] & 0xf0) << 12);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 212 to 227
	value = ((uint32_t)(input[26] & 0x0f) << 28) |
			((uint32_t)input[27] << 20) |
			((uint32_t)(input[28] & 0xf0) << 12);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 228 to 243
	value = ((uint32_t)(input[28] & 0x0f) << 28) |
			((uint32_t)input[29] << 20) |
			((uint32_t)(input[30] & 0xf0) << 12);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 244 to 259
	value = ((uint32_t)(input[30] & 0x0f) << 28) |
			((uint32_t)input[31] << 20) |
			((uint32_t)(input[32] & 0xf0) << 12);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 260 to 275
	value = ((uint32_t)(input[32] & 0x0f) << 28) |
			((uint32_t)input[33] << 20) |
			((uint32_t)(input[34] & 0xf0) << 12);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 276 to 291
	value = ((uint32_t)(input[34] & 0x0f) << 28) |
			((uint32_t)input[35] << 20) |
			((uint32_t)(input[36] & 0xf0) << 12);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 292 to 307
	value = ((uint32_t)(input[36] & 0x0f) << 28) |
			((uint32_t)input[37] << 20) |
			((uint32_t)(input[38] & 0xf0) << 12);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 308 to 323
	value = ((uint32_t)(input[38] & 0x0f) << 28) |
			((uint32_t)input[39] << 20) |
			((uint32_t)(input[40] & 0xf0) << 12);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 324 to 339
	value = ((uint32_t)(input[40] & 0x0f) << 28) |
			((uint32_t)input[41] << 20) |
			((uint32_t)(input[42] & 0xf0) << 12);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 340 to 355
	value = ((uint32_t)(input[42] & 0x0f) << 28) |
			((uint32_t)input[43] << 20) |
			((uint32_t)(input[44] & 0xf0) << 12);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 356 to 371
	value = ((uint32_t)(input[44] & 0x0f) << 28) |
			((uint32_t)input[45] << 20) |
			((uint32_t)(input[46] & 0xf0) << 12);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 372 to 387
	value = ((uint32_t)(input[46] & 0x0f) << 28) |
			((uint32_t)input[47] << 20) |
			((uint32_t)(input[48] & 0xf0) << 12);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 388 to 403
	value = ((uint32_t)(input[48] & 0x0f) << 28) |
			((uint32_t)input[49] << 20) |
			((uint32_t)(input[50] & 0xf0) << 12);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 404 to 419
	value = ((uint32_t)(input[50] & 0x0f) << 28) |
			((uint32_t)input[51] << 20) |
			((uint32_t)(input[52] & 0xf0) << 12);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 420 to 435
	value = ((uint32_t)(input[52] & 0x0f) << 28) |
			((uint32_t)input[53] << 20) |
			((uint32_t)(input[54] & 0xf0) << 12);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 436 to 451
	value = ((uint32_t)(input[54] & 0x0f) << 28) |
			((uint32_t)input[55] << 20) |
			((uint32_t)(input[56] & 0xf0) << 12);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 452 to 467
	value = ((uint32_t)(input[56] & 0x0f) << 28) |
			((uint32_t)input[57] << 20) |
			((uint32_t)(input[58] & 0xf0) << 12);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 468 to 483
	value = ((uint32_t)(input[58] & 0x0f) << 28) |
			((uint32_t)input[59] << 20) |
			((uint32_t)(input[60] & 0xf0) << 12);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 484 to 499
	value = ((uint32_t)(input[60] & 0x0f) << 28) |
			((uint32_t)input[61] << 20) |
			((uint32_t)(input[62] & 0xf0) << 12);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 500 to 515
	value = ((uint32_t)(input[62] & 0x0f) << 28) |
			((uint32_t)input[63] << 20) |
			((uint32_t)(input[64] & 0xf0) << 12);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 516 to 531
	value = ((uint32_t)(input[64] & 0x0f) << 28) |
			((uint32_t)input[65] << 20) |
			((uint32_t)(input[66] & 0xf0) << 12);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 532 to 547
	value = ((uint32_t)(input[66] & 0x0f) << 28) |
			((uint32_t)input[67] << 20) |
			((uint32_t)(input[68] & 0xf0) << 12);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 548 to 563
	value = ((uint32_t)(input[68] & 0x0f) << 28) |
			((uint32_t)input[69] << 20) |
			((uint32_t)(input[70] & 0xf0) << 12);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 564 to 579
	value = ((uint32_t)(input[70] & 0x0f) << 28) |
			((uint32_t)input[71] << 20) |
			((uint32_t)(input[72] & 0xf0) << 12);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 580 to 595
	value = ((uint32_t)(input[72] & 0x0f) << 28) |
			((uint32_t)input[73] << 20) |
			((uint32_t)(input[74] & 0xf0) << 12);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 596 to 611
	value = ((uint32_t)(input[74] & 0x0f) << 28) |
			((uint32_t)input[75] << 20) |
			((uint32_t)(input[76] & 0xf0) << 12);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 612 to 627
	value = ((uint32_t)(input[76] & 0x0f) << 28) |
			((uint32_t)input[77] << 20) |
			((uint32_t)(input[78] & 0xf0) << 12);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 628 to 643
	value = ((uint32_t)(input[78] & 0x0f) << 28) |
			((uint32_t)input[79] << 20) |
			((uint32_t)(input[80] & 0xf0) << 12);
	output[39] = (double)(value >> 16);

	// read output[40]: from bit 644 to 659
	value = ((uint32_t)(input[80] & 0x0f) << 28) |
			((uint32_t)input[81] << 20) |
			((uint32_t)(input[82] & 0xf0) << 12);
	output[40] = (double)(value >> 16);

	// read output[41]: from bit 660 to 675
	value = ((uint32_t)(input[82] & 0x0f) << 28) |
			((uint32_t)input[83] << 20) |
			((uint32_t)(input[84] & 0xf0) << 12);
	output[41] = (double)(value >> 16);

	// read output[42]: from bit 676 to 691
	value = ((uint32_t)(input[84] & 0x0f) << 28) |
			((uint32_t)input[85] << 20) |
			((uint32_t)(input[86] & 0xf0) << 12);
	output[42] = (double)(value >> 16);

	// read output[43]: from bit 692 to 707
	value = ((uint32_t)(input[86] & 0x0f) << 28) |
			((uint32_t)input[87] << 20) |
			((uint32_t)(input[88] & 0xf0) << 12);
	output[43] = (double)(value >> 16);

	// read output[44]: from bit 708 to 723
	value = ((uint32_t)(input[88] & 0x0f) << 28) |
			((uint32_t)input[89] << 20) |
			((uint32_t)(input[90] & 0xf0) << 12);
	output[44] = (double)(value >> 16);

	// read output[45]: from bit 724 to 739
	value = ((uint32_t)(input[90] & 0x0f) << 28) |
			((uint32_t)input[91] << 20) |
			((uint32_t)(input[92] & 0xf0) << 12);
	output[45] = (double)(value >> 16);

	// read output[46]: from bit 740 to 755
	value = ((uint32_t)(input[92] & 0x0f) << 28) |
			((uint32_t)input[93] << 20) |
			((uint32_t)(input[94] & 0xf0) << 12);
	output[46] = (double)(value >> 16);

	// read output[47]: from bit 756 to 771
	value = ((uint32_t)(input[94] & 0x0f) << 28) |
			((uint32_t)input[95] << 20) |
			((uint32_t)(input[96] & 0xf0) << 12);
	output[47] = (double)(value >> 16);

	// read output[48]: from bit 772 to 787
	value = ((uint32_t)(input[96] & 0x0f) << 28) |
			((uint32_t)input[97] << 20) |
			((uint32_t)(input[98] & 0xf0) << 12);
	output[48] = (double)(value >> 16);

	// read output[49]: from bit 788 to 803
	value = ((uint32_t)(input[98] & 0x0f) << 28) |
			((uint32_t)input[99] << 20) |
			((uint32_t)(input[100] & 0xf0) << 12);
	output[49] = (double)(value >> 16);

	// read output[50]: from bit 804 to 819
	value = ((uint32_t)(input[100] & 0x0f) << 28) |
			((uint32_t)input[101] << 20) |
			((uint32_t)(input[102] & 0xf0) << 12);
	output[50] = (double)(value >> 16);

	// read output[51]: from bit 820 to 835
	value = ((uint32_t)(input[102] & 0x0f) << 28) |
			((uint32_t)input[103] << 20) |
			((uint32_t)(input[104] & 0xf0) << 12);
	output[51] = (double)(value >> 16);

	// read output[52]: from bit 836 to 851
	value = ((uint32_t)(input[104] & 0x0f) << 28) |
			((uint32_t)input[105] << 20) |
			((uint32_t)(input[106] & 0xf0) << 12);
	output[52] = (double)(value >> 16);

	// read output[53]: from bit 852 to 867
	value = ((uint32_t)(input[106] & 0x0f) << 28) |
			((uint32_t)input[107] << 20) |
			((uint32_t)(input[108] & 0xf0) << 12);
	output[53] = (double)(value >> 16);

	// read output[54]: from bit 868 to 883
	value = ((uint32_t)(input[108] & 0x0f) << 28) |
			((uint32_t)input[109] << 20) |
			((uint32_t)(input[110] & 0xf0) << 12);
	output[54] = (double)(value >> 16);

	// read output[55]: from bit 884 to 899
	value = ((uint32_t)(input[110] & 0x0f) << 28) |
			((uint32_t)input[111] << 20) |
			((uint32_t)(input[112] & 0xf0) << 12);
	output[55] = (double)(value >> 16);

	// read output[56]: from bit 900 to 915
	value = ((uint32_t)(input[112] & 0x0f) << 28) |
			((uint32_t)input[113] << 20) |
			((uint32_t)(input[114] & 0xf0) << 12);
	output[56] = (double)(value >> 16);

	// read output[57]: from bit 916 to 931
	value = ((uint32_t)(input[114] & 0x0f) << 28) |
			((uint32_t)input[115] << 20) |
			((uint32_t)(input[116] & 0xf0) << 12);
	output[57] = (double)(value >> 16);

	// read output[58]: from bit 932 to 947
	value = ((uint32_t)(input[116] & 0x0f) << 28) |
			((uint32_t)input[117] << 20) |
			((uint32_t)(input[118] & 0xf0) << 12);
	output[58] = (double)(value >> 16);

	// read output[59]: from bit 948 to 963
	value = ((uint32_t)(input[118] & 0x0f) << 28) |
			((uint32_t)input[119] << 20) |
			((uint32_t)(input[120] & 0xf0) << 12);
	output[59] = (double)(value >> 16);

	// read output[60]: from bit 964 to 979
	value = ((uint32_t)(input[120] & 0x0f) << 28) |
			((uint32_t)input[121] << 20) |
			((uint32_t)(input[122] & 0xf0) << 12);
	output[60] = (double)(value >> 16);
}

static void unpack_61_16bit_signed_5off(const uint8_t * input, double * output, void *closure) {
	// Unpack 61 values into output
	// Values are 16-bit signed
	// Skip 5 bits, read 976 bits of data.
	// Input must be at least 123 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 5 to 20
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)(input[2] & 0xf8) << 13);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 21 to 36
	value = ((uint32_t)(input[2] & 0x07) << 29) |
			((uint32_t)input[3] << 21) |
			((uint32_t)(input[4] & 0xf8) << 13);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 37 to 52
	value = ((uint32_t)(input[4] & 0x07) << 29) |
			((uint32_t)input[5] << 21) |
			((uint32_t)(input[6] & 0xf8) << 13);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 53 to 68
	value = ((uint32_t)(input[6] & 0x07) << 29) |
			((uint32_t)input[7] << 21) |
			((uint32_t)(input[8] & 0xf8) << 13);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 69 to 84
	value = ((uint32_t)(input[8] & 0x07) << 29) |
			((uint32_t)input[9] << 21) |
			((uint32_t)(input[10] & 0xf8) << 13);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 85 to 100
	value = ((uint32_t)(input[10] & 0x07) << 29) |
			((uint32_t)input[11] << 21) |
			((uint32_t)(input[12] & 0xf8) << 13);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 101 to 116
	value = ((uint32_t)(input[12] & 0x07) << 29) |
			((uint32_t)input[13] << 21) |
			((uint32_t)(input[14] & 0xf8) << 13);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 117 to 132
	value = ((uint32_t)(input[14] & 0x07) << 29) |
			((uint32_t)input[15] << 21) |
			((uint32_t)(input[16] & 0xf8) << 13);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 133 to 148
	value = ((uint32_t)(input[16] & 0x07) << 29) |
			((uint32_t)input[17] << 21) |
			((uint32_t)(input[18] & 0xf8) << 13);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 149 to 164
	value = ((uint32_t)(input[18] & 0x07) << 29) |
			((uint32_t)input[19] << 21) |
			((uint32_t)(input[20] & 0xf8) << 13);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 165 to 180
	value = ((uint32_t)(input[20] & 0x07) << 29) |
			((uint32_t)input[21] << 21) |
			((uint32_t)(input[22] & 0xf8) << 13);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 181 to 196
	value = ((uint32_t)(input[22] & 0x07) << 29) |
			((uint32_t)input[23] << 21) |
			((uint32_t)(input[24] & 0xf8) << 13);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 197 to 212
	value = ((uint32_t)(input[24] & 0x07) << 29) |
			((uint32_t)input[25] << 21) |
			((uint32_t)(input[26] & 0xf8) << 13);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 213 to 228
	value = ((uint32_t)(input[26] & 0x07) << 29) |
			((uint32_t)input[27] << 21) |
			((uint32_t)(input[28] & 0xf8) << 13);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 229 to 244
	value = ((uint32_t)(input[28] & 0x07) << 29) |
			((uint32_t)input[29] << 21) |
			((uint32_t)(input[30] & 0xf8) << 13);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 245 to 260
	value = ((uint32_t)(input[30] & 0x07) << 29) |
			((uint32_t)input[31] << 21) |
			((uint32_t)(input[32] & 0xf8) << 13);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 261 to 276
	value = ((uint32_t)(input[32] & 0x07) << 29) |
			((uint32_t)input[33] << 21) |
			((uint32_t)(input[34] & 0xf8) << 13);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 277 to 292
	value = ((uint32_t)(input[34] & 0x07) << 29) |
			((uint32_t)input[35] << 21) |
			((uint32_t)(input[36] & 0xf8) << 13);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 293 to 308
	value = ((uint32_t)(input[36] & 0x07) << 29) |
			((uint32_t)input[37] << 21) |
			((uint32_t)(input[38] & 0xf8) << 13);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 309 to 324
	value = ((uint32_t)(input[38] & 0x07) << 29) |
			((uint32_t)input[39] << 21) |
			((uint32_t)(input[40] & 0xf8) << 13);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 325 to 340
	value = ((uint32_t)(input[40] & 0x07) << 29) |
			((uint32_t)input[41] << 21) |
			((uint32_t)(input[42] & 0xf8) << 13);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 341 to 356
	value = ((uint32_t)(input[42] & 0x07) << 29) |
			((uint32_t)input[43] << 21) |
			((uint32_t)(input[44] & 0xf8) << 13);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 357 to 372
	value = ((uint32_t)(input[44] & 0x07) << 29) |
			((uint32_t)input[45] << 21) |
			((uint32_t)(input[46] & 0xf8) << 13);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 373 to 388
	value = ((uint32_t)(input[46] & 0x07) << 29) |
			((uint32_t)input[47] << 21) |
			((uint32_t)(input[48] & 0xf8) << 13);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 389 to 404
	value = ((uint32_t)(input[48] & 0x07) << 29) |
			((uint32_t)input[49] << 21) |
			((uint32_t)(input[50] & 0xf8) << 13);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 405 to 420
	value = ((uint32_t)(input[50] & 0x07) << 29) |
			((uint32_t)input[51] << 21) |
			((uint32_t)(input[52] & 0xf8) << 13);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 421 to 436
	value = ((uint32_t)(input[52] & 0x07) << 29) |
			((uint32_t)input[53] << 21) |
			((uint32_t)(input[54] & 0xf8) << 13);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 437 to 452
	value = ((uint32_t)(input[54] & 0x07) << 29) |
			((uint32_t)input[55] << 21) |
			((uint32_t)(input[56] & 0xf8) << 13);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 453 to 468
	value = ((uint32_t)(input[56] & 0x07) << 29) |
			((uint32_t)input[57] << 21) |
			((uint32_t)(input[58] & 0xf8) << 13);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 469 to 484
	value = ((uint32_t)(input[58] & 0x07) << 29) |
			((uint32_t)input[59] << 21) |
			((uint32_t)(input[60] & 0xf8) << 13);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 485 to 500
	value = ((uint32_t)(input[60] & 0x07) << 29) |
			((uint32_t)input[61] << 21) |
			((uint32_t)(input[62] & 0xf8) << 13);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 501 to 516
	value = ((uint32_t)(input[62] & 0x07) << 29) |
			((uint32_t)input[63] << 21) |
			((uint32_t)(input[64] & 0xf8) << 13);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 517 to 532
	value = ((uint32_t)(input[64] & 0x07) << 29) |
			((uint32_t)input[65] << 21) |
			((uint32_t)(input[66] & 0xf8) << 13);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 533 to 548
	value = ((uint32_t)(input[66] & 0x07) << 29) |
			((uint32_t)input[67] << 21) |
			((uint32_t)(input[68] & 0xf8) << 13);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 549 to 564
	value = ((uint32_t)(input[68] & 0x07) << 29) |
			((uint32_t)input[69] << 21) |
			((uint32_t)(input[70] & 0xf8) << 13);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 565 to 580
	value = ((uint32_t)(input[70] & 0x07) << 29) |
			((uint32_t)input[71] << 21) |
			((uint32_t)(input[72] & 0xf8) << 13);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 581 to 596
	value = ((uint32_t)(input[72] & 0x07) << 29) |
			((uint32_t)input[73] << 21) |
			((uint32_t)(input[74] & 0xf8) << 13);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 597 to 612
	value = ((uint32_t)(input[74] & 0x07) << 29) |
			((uint32_t)input[75] << 21) |
			((uint32_t)(input[76] & 0xf8) << 13);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 613 to 628
	value = ((uint32_t)(input[76] & 0x07) << 29) |
			((uint32_t)input[77] << 21) |
			((uint32_t)(input[78] & 0xf8) << 13);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 629 to 644
	value = ((uint32_t)(input[78] & 0x07) << 29) |
			((uint32_t)input[79] << 21) |
			((uint32_t)(input[80] & 0xf8) << 13);
	output[39] = (double)(value >> 16);

	// read output[40]: from bit 645 to 660
	value = ((uint32_t)(input[80] & 0x07) << 29) |
			((uint32_t)input[81] << 21) |
			((uint32_t)(input[82] & 0xf8) << 13);
	output[40] = (double)(value >> 16);

	// read output[41]: from bit 661 to 676
	value = ((uint32_t)(input[82] & 0x07) << 29) |
			((uint32_t)input[83] << 21) |
			((uint32_t)(input[84] & 0xf8) << 13);
	output[41] = (double)(value >> 16);

	// read output[42]: from bit 677 to 692
	value = ((uint32_t)(input[84] & 0x07) << 29) |
			((uint32_t)input[85] << 21) |
			((uint32_t)(input[86] & 0xf8) << 13);
	output[42] = (double)(value >> 16);

	// read output[43]: from bit 693 to 708
	value = ((uint32_t)(input[86] & 0x07) << 29) |
			((uint32_t)input[87] << 21) |
			((uint32_t)(input[88] & 0xf8) << 13);
	output[43] = (double)(value >> 16);

	// read output[44]: from bit 709 to 724
	value = ((uint32_t)(input[88] & 0x07) << 29) |
			((uint32_t)input[89] << 21) |
			((uint32_t)(input[90] & 0xf8) << 13);
	output[44] = (double)(value >> 16);

	// read output[45]: from bit 725 to 740
	value = ((uint32_t)(input[90] & 0x07) << 29) |
			((uint32_t)input[91] << 21) |
			((uint32_t)(input[92] & 0xf8) << 13);
	output[45] = (double)(value >> 16);

	// read output[46]: from bit 741 to 756
	value = ((uint32_t)(input[92] & 0x07) << 29) |
			((uint32_t)input[93] << 21) |
			((uint32_t)(input[94] & 0xf8) << 13);
	output[46] = (double)(value >> 16);

	// read output[47]: from bit 757 to 772
	value = ((uint32_t)(input[94] & 0x07) << 29) |
			((uint32_t)input[95] << 21) |
			((uint32_t)(input[96] & 0xf8) << 13);
	output[47] = (double)(value >> 16);

	// read output[48]: from bit 773 to 788
	value = ((uint32_t)(input[96] & 0x07) << 29) |
			((uint32_t)input[97] << 21) |
			((uint32_t)(input[98] & 0xf8) << 13);
	output[48] = (double)(value >> 16);

	// read output[49]: from bit 789 to 804
	value = ((uint32_t)(input[98] & 0x07) << 29) |
			((uint32_t)input[99] << 21) |
			((uint32_t)(input[100] & 0xf8) << 13);
	output[49] = (double)(value >> 16);

	// read output[50]: from bit 805 to 820
	value = ((uint32_t)(input[100] & 0x07) << 29) |
			((uint32_t)input[101] << 21) |
			((uint32_t)(input[102] & 0xf8) << 13);
	output[50] = (double)(value >> 16);

	// read output[51]: from bit 821 to 836
	value = ((uint32_t)(input[102] & 0x07) << 29) |
			((uint32_t)input[103] << 21) |
			((uint32_t)(input[104] & 0xf8) << 13);
	output[51] = (double)(value >> 16);

	// read output[52]: from bit 837 to 852
	value = ((uint32_t)(input[104] & 0x07) << 29) |
			((uint32_t)input[105] << 21) |
			((uint32_t)(input[106] & 0xf8) << 13);
	output[52] = (double)(value >> 16);

	// read output[53]: from bit 853 to 868
	value = ((uint32_t)(input[106] & 0x07) << 29) |
			((uint32_t)input[107] << 21) |
			((uint32_t)(input[108] & 0xf8) << 13);
	output[53] = (double)(value >> 16);

	// read output[54]: from bit 869 to 884
	value = ((uint32_t)(input[108] & 0x07) << 29) |
			((uint32_t)input[109] << 21) |
			((uint32_t)(input[110] & 0xf8) << 13);
	output[54] = (double)(value >> 16);

	// read output[55]: from bit 885 to 900
	value = ((uint32_t)(input[110] & 0x07) << 29) |
			((uint32_t)input[111] << 21) |
			((uint32_t)(input[112] & 0xf8) << 13);
	output[55] = (double)(value >> 16);

	// read output[56]: from bit 901 to 916
	value = ((uint32_t)(input[112] & 0x07) << 29) |
			((uint32_t)input[113] << 21) |
			((uint32_t)(input[114] & 0xf8) << 13);
	output[56] = (double)(value >> 16);

	// read output[57]: from bit 917 to 932
	value = ((uint32_t)(input[114] & 0x07) << 29) |
			((uint32_t)input[115] << 21) |
			((uint32_t)(input[116] & 0xf8) << 13);
	output[57] = (double)(value >> 16);

	// read output[58]: from bit 933 to 948
	value = ((uint32_t)(input[116] & 0x07) << 29) |
			((uint32_t)input[117] << 21) |
			((uint32_t)(input[118] & 0xf8) << 13);
	output[58] = (double)(value >> 16);

	// read output[59]: from bit 949 to 964
	value = ((uint32_t)(input[118] & 0x07) << 29) |
			((uint32_t)input[119] << 21) |
			((uint32_t)(input[120] & 0xf8) << 13);
	output[59] = (double)(value >> 16);

	// read output[60]: from bit 965 to 980
	value = ((uint32_t)(input[120] & 0x07) << 29) |
			((uint32_t)input[121] << 21) |
			((uint32_t)(input[122] & 0xf8) << 13);
	output[60] = (double)(value >> 16);
}

static void unpack_61_16bit_unsigned_5off(const uint8_t * input, double * output, void *closure) {
	// Unpack 61 values into output
	// Values are 16-bit unsigned
	// Skip 5 bits, read 976 bits of data.
	// Input must be at least 123 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 5 to 20
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)(input[2] & 0xf8) << 13);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 21 to 36
	value = ((uint32_t)(input[2] & 0x07) << 29) |
			((uint32_t)input[3] << 21) |
			((uint32_t)(input[4] & 0xf8) << 13);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 37 to 52
	value = ((uint32_t)(input[4] & 0x07) << 29) |
			((uint32_t)input[5] << 21) |
			((uint32_t)(input[6] & 0xf8) << 13);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 53 to 68
	value = ((uint32_t)(input[6] & 0x07) << 29) |
			((uint32_t)input[7] << 21) |
			((uint32_t)(input[8] & 0xf8) << 13);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 69 to 84
	value = ((uint32_t)(input[8] & 0x07) << 29) |
			((uint32_t)input[9] << 21) |
			((uint32_t)(input[10] & 0xf8) << 13);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 85 to 100
	value = ((uint32_t)(input[10] & 0x07) << 29) |
			((uint32_t)input[11] << 21) |
			((uint32_t)(input[12] & 0xf8) << 13);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 101 to 116
	value = ((uint32_t)(input[12] & 0x07) << 29) |
			((uint32_t)input[13] << 21) |
			((uint32_t)(input[14] & 0xf8) << 13);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 117 to 132
	value = ((uint32_t)(input[14] & 0x07) << 29) |
			((uint32_t)input[15] << 21) |
			((uint32_t)(input[16] & 0xf8) << 13);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 133 to 148
	value = ((uint32_t)(input[16] & 0x07) << 29) |
			((uint32_t)input[17] << 21) |
			((uint32_t)(input[18] & 0xf8) << 13);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 149 to 164
	value = ((uint32_t)(input[18] & 0x07) << 29) |
			((uint32_t)input[19] << 21) |
			((uint32_t)(input[20] & 0xf8) << 13);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 165 to 180
	value = ((uint32_t)(input[20] & 0x07) << 29) |
			((uint32_t)input[21] << 21) |
			((uint32_t)(input[22] & 0xf8) << 13);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 181 to 196
	value = ((uint32_t)(input[22] & 0x07) << 29) |
			((uint32_t)input[23] << 21) |
			((uint32_t)(input[24] & 0xf8) << 13);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 197 to 212
	value = ((uint32_t)(input[24] & 0x07) << 29) |
			((uint32_t)input[25] << 21) |
			((uint32_t)(input[26] & 0xf8) << 13);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 213 to 228
	value = ((uint32_t)(input[26] & 0x07) << 29) |
			((uint32_t)input[27] << 21) |
			((uint32_t)(input[28] & 0xf8) << 13);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 229 to 244
	value = ((uint32_t)(input[28] & 0x07) << 29) |
			((uint32_t)input[29] << 21) |
			((uint32_t)(input[30] & 0xf8) << 13);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 245 to 260
	value = ((uint32_t)(input[30] & 0x07) << 29) |
			((uint32_t)input[31] << 21) |
			((uint32_t)(input[32] & 0xf8) << 13);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 261 to 276
	value = ((uint32_t)(input[32] & 0x07) << 29) |
			((uint32_t)input[33] << 21) |
			((uint32_t)(input[34] & 0xf8) << 13);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 277 to 292
	value = ((uint32_t)(input[34] & 0x07) << 29) |
			((uint32_t)input[35] << 21) |
			((uint32_t)(input[36] & 0xf8) << 13);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 293 to 308
	value = ((uint32_t)(input[36] & 0x07) << 29) |
			((uint32_t)input[37] << 21) |
			((uint32_t)(input[38] & 0xf8) << 13);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 309 to 324
	value = ((uint32_t)(input[38] & 0x07) << 29) |
			((uint32_t)input[39] << 21) |
			((uint32_t)(input[40] & 0xf8) << 13);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 325 to 340
	value = ((uint32_t)(input[40] & 0x07) << 29) |
			((uint32_t)input[41] << 21) |
			((uint32_t)(input[42] & 0xf8) << 13);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 341 to 356
	value = ((uint32_t)(input[42] & 0x07) << 29) |
			((uint32_t)input[43] << 21) |
			((uint32_t)(input[44] & 0xf8) << 13);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 357 to 372
	value = ((uint32_t)(input[44] & 0x07) << 29) |
			((uint32_t)input[45] << 21) |
			((uint32_t)(input[46] & 0xf8) << 13);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 373 to 388
	value = ((uint32_t)(input[46] & 0x07) << 29) |
			((uint32_t)input[47] << 21) |
			((uint32_t)(input[48] & 0xf8) << 13);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 389 to 404
	value = ((uint32_t)(input[48] & 0x07) << 29) |
			((uint32_t)input[49] << 21) |
			((uint32_t)(input[50] & 0xf8) << 13);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 405 to 420
	value = ((uint32_t)(input[50] & 0x07) << 29) |
			((uint32_t)input[51] << 21) |
			((uint32_t)(input[52] & 0xf8) << 13);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 421 to 436
	value = ((uint32_t)(input[52] & 0x07) << 29) |
			((uint32_t)input[53] << 21) |
			((uint32_t)(input[54] & 0xf8) << 13);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 437 to 452
	value = ((uint32_t)(input[54] & 0x07) << 29) |
			((uint32_t)input[55] << 21) |
			((uint32_t)(input[56] & 0xf8) << 13);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 453 to 468
	value = ((uint32_t)(input[56] & 0x07) << 29) |
			((uint32_t)input[57] << 21) |
			((uint32_t)(input[58] & 0xf8) << 13);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 469 to 484
	value = ((uint32_t)(input[58] & 0x07) << 29) |
			((uint32_t)input[59] << 21) |
			((uint32_t)(input[60] & 0xf8) << 13);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 485 to 500
	value = ((uint32_t)(input[60] & 0x07) << 29) |
			((uint32_t)input[61] << 21) |
			((uint32_t)(input[62] & 0xf8) << 13);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 501 to 516
	value = ((uint32_t)(input[62] & 0x07) << 29) |
			((uint32_t)input[63] << 21) |
			((uint32_t)(input[64] & 0xf8) << 13);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 517 to 532
	value = ((uint32_t)(input[64] & 0x07) << 29) |
			((uint32_t)input[65] << 21) |
			((uint32_t)(input[66] & 0xf8) << 13);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 533 to 548
	value = ((uint32_t)(input[66] & 0x07) << 29) |
			((uint32_t)input[67] << 21) |
			((uint32_t)(input[68] & 0xf8) << 13);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 549 to 564
	value = ((uint32_t)(input[68] & 0x07) << 29) |
			((uint32_t)input[69] << 21) |
			((uint32_t)(input[70] & 0xf8) << 13);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 565 to 580
	value = ((uint32_t)(input[70] & 0x07) << 29) |
			((uint32_t)input[71] << 21) |
			((uint32_t)(input[72] & 0xf8) << 13);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 581 to 596
	value = ((uint32_t)(input[72] & 0x07) << 29) |
			((uint32_t)input[73] << 21) |
			((uint32_t)(input[74] & 0xf8) << 13);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 597 to 612
	value = ((uint32_t)(input[74] & 0x07) << 29) |
			((uint32_t)input[75] << 21) |
			((uint32_t)(input[76] & 0xf8) << 13);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 613 to 628
	value = ((uint32_t)(input[76] & 0x07) << 29) |
			((uint32_t)input[77] << 21) |
			((uint32_t)(input[78] & 0xf8) << 13);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 629 to 644
	value = ((uint32_t)(input[78] & 0x07) << 29) |
			((uint32_t)input[79] << 21) |
			((uint32_t)(input[80] & 0xf8) << 13);
	output[39] = (double)(value >> 16);

	// read output[40]: from bit 645 to 660
	value = ((uint32_t)(input[80] & 0x07) << 29) |
			((uint32_t)input[81] << 21) |
			((uint32_t)(input[82] & 0xf8) << 13);
	output[40] = (double)(value >> 16);

	// read output[41]: from bit 661 to 676
	value = ((uint32_t)(input[82] & 0x07) << 29) |
			((uint32_t)input[83] << 21) |
			((uint32_t)(input[84] & 0xf8) << 13);
	output[41] = (double)(value >> 16);

	// read output[42]: from bit 677 to 692
	value = ((uint32_t)(input[84] & 0x07) << 29) |
			((uint32_t)input[85] << 21) |
			((uint32_t)(input[86] & 0xf8) << 13);
	output[42] = (double)(value >> 16);

	// read output[43]: from bit 693 to 708
	value = ((uint32_t)(input[86] & 0x07) << 29) |
			((uint32_t)input[87] << 21) |
			((uint32_t)(input[88] & 0xf8) << 13);
	output[43] = (double)(value >> 16);

	// read output[44]: from bit 709 to 724
	value = ((uint32_t)(input[88] & 0x07) << 29) |
			((uint32_t)input[89] << 21) |
			((uint32_t)(input[90] & 0xf8) << 13);
	output[44] = (double)(value >> 16);

	// read output[45]: from bit 725 to 740
	value = ((uint32_t)(input[90] & 0x07) << 29) |
			((uint32_t)input[91] << 21) |
			((uint32_t)(input[92] & 0xf8) << 13);
	output[45] = (double)(value >> 16);

	// read output[46]: from bit 741 to 756
	value = ((uint32_t)(input[92] & 0x07) << 29) |
			((uint32_t)input[93] << 21) |
			((uint32_t)(input[94] & 0xf8) << 13);
	output[46] = (double)(value >> 16);

	// read output[47]: from bit 757 to 772
	value = ((uint32_t)(input[94] & 0x07) << 29) |
			((uint32_t)input[95] << 21) |
			((uint32_t)(input[96] & 0xf8) << 13);
	output[47] = (double)(value >> 16);

	// read output[48]: from bit 773 to 788
	value = ((uint32_t)(input[96] & 0x07) << 29) |
			((uint32_t)input[97] << 21) |
			((uint32_t)(input[98] & 0xf8) << 13);
	output[48] = (double)(value >> 16);

	// read output[49]: from bit 789 to 804
	value = ((uint32_t)(input[98] & 0x07) << 29) |
			((uint32_t)input[99] << 21) |
			((uint32_t)(input[100] & 0xf8) << 13);
	output[49] = (double)(value >> 16);

	// read output[50]: from bit 805 to 820
	value = ((uint32_t)(input[100] & 0x07) << 29) |
			((uint32_t)input[101] << 21) |
			((uint32_t)(input[102] & 0xf8) << 13);
	output[50] = (double)(value >> 16);

	// read output[51]: from bit 821 to 836
	value = ((uint32_t)(input[102] & 0x07) << 29) |
			((uint32_t)input[103] << 21) |
			((uint32_t)(input[104] & 0xf8) << 13);
	output[51] = (double)(value >> 16);

	// read output[52]: from bit 837 to 852
	value = ((uint32_t)(input[104] & 0x07) << 29) |
			((uint32_t)input[105] << 21) |
			((uint32_t)(input[106] & 0xf8) << 13);
	output[52] = (double)(value >> 16);

	// read output[53]: from bit 853 to 868
	value = ((uint32_t)(input[106] & 0x07) << 29) |
			((uint32_t)input[107] << 21) |
			((uint32_t)(input[108] & 0xf8) << 13);
	output[53] = (double)(value >> 16);

	// read output[54]: from bit 869 to 884
	value = ((uint32_t)(input[108] & 0x07) << 29) |
			((uint32_t)input[109] << 21) |
			((uint32_t)(input[110] & 0xf8) << 13);
	output[54] = (double)(value >> 16);

	// read output[55]: from bit 885 to 900
	value = ((uint32_t)(input[110] & 0x07) << 29) |
			((uint32_t)input[111] << 21) |
			((uint32_t)(input[112] & 0xf8) << 13);
	output[55] = (double)(value >> 16);

	// read output[56]: from bit 901 to 916
	value = ((uint32_t)(input[112] & 0x07) << 29) |
			((uint32_t)input[113] << 21) |
			((uint32_t)(input[114] & 0xf8) << 13);
	output[56] = (double)(value >> 16);

	// read output[57]: from bit 917 to 932
	value = ((uint32_t)(input[114] & 0x07) << 29) |
			((uint32_t)input[115] << 21) |
			((uint32_t)(input[116] & 0xf8) << 13);
	output[57] = (double)(value >> 16);

	// read output[58]: from bit 933 to 948
	value = ((uint32_t)(input[116] & 0x07) << 29) |
			((uint32_t)input[117] << 21) |
			((uint32_t)(input[118] & 0xf8) << 13);
	output[58] = (double)(value >> 16);

	// read output[59]: from bit 949 to 964
	value = ((uint32_t)(input[118] & 0x07) << 29) |
			((uint32_t)input[119] << 21) |
			((uint32_t)(input[120] & 0xf8) << 13);
	output[59] = (double)(value >> 16);

	// read output[60]: from bit 965 to 980
	value = ((uint32_t)(input[120] & 0x07) << 29) |
			((uint32_t)input[121] << 21) |
			((uint32_t)(input[122] & 0xf8) << 13);
	output[60] = (double)(value >> 16);
}

static void unpack_61_16bit_signed_6off(const uint8_t * input, double * output, void *closure) {
	// Unpack 61 values into output
	// Values are 16-bit signed
	// Skip 6 bits, read 976 bits of data.
	// Input must be at least 123 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 6 to 21
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)(input[2] & 0xfc) << 14);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 22 to 37
	value = ((uint32_t)(input[2] & 0x03) << 30) |
			((uint32_t)input[3] << 22) |
			((uint32_t)(input[4] & 0xfc) << 14);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 38 to 53
	value = ((uint32_t)(input[4] & 0x03) << 30) |
			((uint32_t)input[5] << 22) |
			((uint32_t)(input[6] & 0xfc) << 14);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 54 to 69
	value = ((uint32_t)(input[6] & 0x03) << 30) |
			((uint32_t)input[7] << 22) |
			((uint32_t)(input[8] & 0xfc) << 14);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 70 to 85
	value = ((uint32_t)(input[8] & 0x03) << 30) |
			((uint32_t)input[9] << 22) |
			((uint32_t)(input[10] & 0xfc) << 14);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 86 to 101
	value = ((uint32_t)(input[10] & 0x03) << 30) |
			((uint32_t)input[11] << 22) |
			((uint32_t)(input[12] & 0xfc) << 14);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 102 to 117
	value = ((uint32_t)(input[12] & 0x03) << 30) |
			((uint32_t)input[13] << 22) |
			((uint32_t)(input[14] & 0xfc) << 14);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 118 to 133
	value = ((uint32_t)(input[14] & 0x03) << 30) |
			((uint32_t)input[15] << 22) |
			((uint32_t)(input[16] & 0xfc) << 14);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 134 to 149
	value = ((uint32_t)(input[16] & 0x03) << 30) |
			((uint32_t)input[17] << 22) |
			((uint32_t)(input[18] & 0xfc) << 14);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 150 to 165
	value = ((uint32_t)(input[18] & 0x03) << 30) |
			((uint32_t)input[19] << 22) |
			((uint32_t)(input[20] & 0xfc) << 14);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 166 to 181
	value = ((uint32_t)(input[20] & 0x03) << 30) |
			((uint32_t)input[21] << 22) |
			((uint32_t)(input[22] & 0xfc) << 14);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 182 to 197
	value = ((uint32_t)(input[22] & 0x03) << 30) |
			((uint32_t)input[23] << 22) |
			((uint32_t)(input[24] & 0xfc) << 14);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 198 to 213
	value = ((uint32_t)(input[24] & 0x03) << 30) |
			((uint32_t)input[25] << 22) |
			((uint32_t)(input[26] & 0xfc) << 14);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 214 to 229
	value = ((uint32_t)(input[26] & 0x03) << 30) |
			((uint32_t)input[27] << 22) |
			((uint32_t)(input[28] & 0xfc) << 14);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 230 to 245
	value = ((uint32_t)(input[28] & 0x03) << 30) |
			((uint32_t)input[29] << 22) |
			((uint32_t)(input[30] & 0xfc) << 14);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 246 to 261
	value = ((uint32_t)(input[30] & 0x03) << 30) |
			((uint32_t)input[31] << 22) |
			((uint32_t)(input[32] & 0xfc) << 14);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 262 to 277
	value = ((uint32_t)(input[32] & 0x03) << 30) |
			((uint32_t)input[33] << 22) |
			((uint32_t)(input[34] & 0xfc) << 14);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 278 to 293
	value = ((uint32_t)(input[34] & 0x03) << 30) |
			((uint32_t)input[35] << 22) |
			((uint32_t)(input[36] & 0xfc) << 14);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 294 to 309
	value = ((uint32_t)(input[36] & 0x03) << 30) |
			((uint32_t)input[37] << 22) |
			((uint32_t)(input[38] & 0xfc) << 14);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 310 to 325
	value = ((uint32_t)(input[38] & 0x03) << 30) |
			((uint32_t)input[39] << 22) |
			((uint32_t)(input[40] & 0xfc) << 14);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 326 to 341
	value = ((uint32_t)(input[40] & 0x03) << 30) |
			((uint32_t)input[41] << 22) |
			((uint32_t)(input[42] & 0xfc) << 14);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 342 to 357
	value = ((uint32_t)(input[42] & 0x03) << 30) |
			((uint32_t)input[43] << 22) |
			((uint32_t)(input[44] & 0xfc) << 14);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 358 to 373
	value = ((uint32_t)(input[44] & 0x03) << 30) |
			((uint32_t)input[45] << 22) |
			((uint32_t)(input[46] & 0xfc) << 14);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 374 to 389
	value = ((uint32_t)(input[46] & 0x03) << 30) |
			((uint32_t)input[47] << 22) |
			((uint32_t)(input[48] & 0xfc) << 14);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 390 to 405
	value = ((uint32_t)(input[48] & 0x03) << 30) |
			((uint32_t)input[49] << 22) |
			((uint32_t)(input[50] & 0xfc) << 14);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 406 to 421
	value = ((uint32_t)(input[50] & 0x03) << 30) |
			((uint32_t)input[51] << 22) |
			((uint32_t)(input[52] & 0xfc) << 14);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 422 to 437
	value = ((uint32_t)(input[52] & 0x03) << 30) |
			((uint32_t)input[53] << 22) |
			((uint32_t)(input[54] & 0xfc) << 14);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 438 to 453
	value = ((uint32_t)(input[54] & 0x03) << 30) |
			((uint32_t)input[55] << 22) |
			((uint32_t)(input[56] & 0xfc) << 14);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 454 to 469
	value = ((uint32_t)(input[56] & 0x03) << 30) |
			((uint32_t)input[57] << 22) |
			((uint32_t)(input[58] & 0xfc) << 14);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 470 to 485
	value = ((uint32_t)(input[58] & 0x03) << 30) |
			((uint32_t)input[59] << 22) |
			((uint32_t)(input[60] & 0xfc) << 14);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 486 to 501
	value = ((uint32_t)(input[60] & 0x03) << 30) |
			((uint32_t)input[61] << 22) |
			((uint32_t)(input[62] & 0xfc) << 14);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 502 to 517
	value = ((uint32_t)(input[62] & 0x03) << 30) |
			((uint32_t)input[63] << 22) |
			((uint32_t)(input[64] & 0xfc) << 14);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 518 to 533
	value = ((uint32_t)(input[64] & 0x03) << 30) |
			((uint32_t)input[65] << 22) |
			((uint32_t)(input[66] & 0xfc) << 14);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 534 to 549
	value = ((uint32_t)(input[66] & 0x03) << 30) |
			((uint32_t)input[67] << 22) |
			((uint32_t)(input[68] & 0xfc) << 14);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 550 to 565
	value = ((uint32_t)(input[68] & 0x03) << 30) |
			((uint32_t)input[69] << 22) |
			((uint32_t)(input[70] & 0xfc) << 14);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 566 to 581
	value = ((uint32_t)(input[70] & 0x03) << 30) |
			((uint32_t)input[71] << 22) |
			((uint32_t)(input[72] & 0xfc) << 14);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 582 to 597
	value = ((uint32_t)(input[72] & 0x03) << 30) |
			((uint32_t)input[73] << 22) |
			((uint32_t)(input[74] & 0xfc) << 14);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 598 to 613
	value = ((uint32_t)(input[74] & 0x03) << 30) |
			((uint32_t)input[75] << 22) |
			((uint32_t)(input[76] & 0xfc) << 14);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 614 to 629
	value = ((uint32_t)(input[76] & 0x03) << 30) |
			((uint32_t)input[77] << 22) |
			((uint32_t)(input[78] & 0xfc) << 14);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 630 to 645
	value = ((uint32_t)(input[78] & 0x03) << 30) |
			((uint32_t)input[79] << 22) |
			((uint32_t)(input[80] & 0xfc) << 14);
	output[39] = (double)(value >> 16);

	// read output[40]: from bit 646 to 661
	value = ((uint32_t)(input[80] & 0x03) << 30) |
			((uint32_t)input[81] << 22) |
			((uint32_t)(input[82] & 0xfc) << 14);
	output[40] = (double)(value >> 16);

	// read output[41]: from bit 662 to 677
	value = ((uint32_t)(input[82] & 0x03) << 30) |
			((uint32_t)input[83] << 22) |
			((uint32_t)(input[84] & 0xfc) << 14);
	output[41] = (double)(value >> 16);

	// read output[42]: from bit 678 to 693
	value = ((uint32_t)(input[84] & 0x03) << 30) |
			((uint32_t)input[85] << 22) |
			((uint32_t)(input[86] & 0xfc) << 14);
	output[42] = (double)(value >> 16);

	// read output[43]: from bit 694 to 709
	value = ((uint32_t)(input[86] & 0x03) << 30) |
			((uint32_t)input[87] << 22) |
			((uint32_t)(input[88] & 0xfc) << 14);
	output[43] = (double)(value >> 16);

	// read output[44]: from bit 710 to 725
	value = ((uint32_t)(input[88] & 0x03) << 30) |
			((uint32_t)input[89] << 22) |
			((uint32_t)(input[90] & 0xfc) << 14);
	output[44] = (double)(value >> 16);

	// read output[45]: from bit 726 to 741
	value = ((uint32_t)(input[90] & 0x03) << 30) |
			((uint32_t)input[91] << 22) |
			((uint32_t)(input[92] & 0xfc) << 14);
	output[45] = (double)(value >> 16);

	// read output[46]: from bit 742 to 757
	value = ((uint32_t)(input[92] & 0x03) << 30) |
			((uint32_t)input[93] << 22) |
			((uint32_t)(input[94] & 0xfc) << 14);
	output[46] = (double)(value >> 16);

	// read output[47]: from bit 758 to 773
	value = ((uint32_t)(input[94] & 0x03) << 30) |
			((uint32_t)input[95] << 22) |
			((uint32_t)(input[96] & 0xfc) << 14);
	output[47] = (double)(value >> 16);

	// read output[48]: from bit 774 to 789
	value = ((uint32_t)(input[96] & 0x03) << 30) |
			((uint32_t)input[97] << 22) |
			((uint32_t)(input[98] & 0xfc) << 14);
	output[48] = (double)(value >> 16);

	// read output[49]: from bit 790 to 805
	value = ((uint32_t)(input[98] & 0x03) << 30) |
			((uint32_t)input[99] << 22) |
			((uint32_t)(input[100] & 0xfc) << 14);
	output[49] = (double)(value >> 16);

	// read output[50]: from bit 806 to 821
	value = ((uint32_t)(input[100] & 0x03) << 30) |
			((uint32_t)input[101] << 22) |
			((uint32_t)(input[102] & 0xfc) << 14);
	output[50] = (double)(value >> 16);

	// read output[51]: from bit 822 to 837
	value = ((uint32_t)(input[102] & 0x03) << 30) |
			((uint32_t)input[103] << 22) |
			((uint32_t)(input[104] & 0xfc) << 14);
	output[51] = (double)(value >> 16);

	// read output[52]: from bit 838 to 853
	value = ((uint32_t)(input[104] & 0x03) << 30) |
			((uint32_t)input[105] << 22) |
			((uint32_t)(input[106] & 0xfc) << 14);
	output[52] = (double)(value >> 16);

	// read output[53]: from bit 854 to 869
	value = ((uint32_t)(input[106] & 0x03) << 30) |
			((uint32_t)input[107] << 22) |
			((uint32_t)(input[108] & 0xfc) << 14);
	output[53] = (double)(value >> 16);

	// read output[54]: from bit 870 to 885
	value = ((uint32_t)(input[108] & 0x03) << 30) |
			((uint32_t)input[109] << 22) |
			((uint32_t)(input[110] & 0xfc) << 14);
	output[54] = (double)(value >> 16);

	// read output[55]: from bit 886 to 901
	value = ((uint32_t)(input[110] & 0x03) << 30) |
			((uint32_t)input[111] << 22) |
			((uint32_t)(input[112] & 0xfc) << 14);
	output[55] = (double)(value >> 16);

	// read output[56]: from bit 902 to 917
	value = ((uint32_t)(input[112] & 0x03) << 30) |
			((uint32_t)input[113] << 22) |
			((uint32_t)(input[114] & 0xfc) << 14);
	output[56] = (double)(value >> 16);

	// read output[57]: from bit 918 to 933
	value = ((uint32_t)(input[114] & 0x03) << 30) |
			((uint32_t)input[115] << 22) |
			((uint32_t)(input[116] & 0xfc) << 14);
	output[57] = (double)(value >> 16);

	// read output[58]: from bit 934 to 949
	value = ((uint32_t)(input[116] & 0x03) << 30) |
			((uint32_t)input[117] << 22) |
			((uint32_t)(input[118] & 0xfc) << 14);
	output[58] = (double)(value >> 16);

	// read output[59]: from bit 950 to 965
	value = ((uint32_t)(input[118] & 0x03) << 30) |
			((uint32_t)input[119] << 22) |
			((uint32_t)(input[120] & 0xfc) << 14);
	output[59] = (double)(value >> 16);

	// read output[60]: from bit 966 to 981
	value = ((uint32_t)(input[120] & 0x03) << 30) |
			((uint32_t)input[121] << 22) |
			((uint32_t)(input[122] & 0xfc) << 14);
	output[60] = (double)(value >> 16);
}

static void unpack_61_16bit_unsigned_6off(const uint8_t * input, double * output, void *closure) {
	// Unpack 61 values into output
	// Values are 16-bit unsigned
	// Skip 6 bits, read 976 bits of data.
	// Input must be at least 123 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 6 to 21
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)(input[2] & 0xfc) << 14);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 22 to 37
	value = ((uint32_t)(input[2] & 0x03) << 30) |
			((uint32_t)input[3] << 22) |
			((uint32_t)(input[4] & 0xfc) << 14);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 38 to 53
	value = ((uint32_t)(input[4] & 0x03) << 30) |
			((uint32_t)input[5] << 22) |
			((uint32_t)(input[6] & 0xfc) << 14);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 54 to 69
	value = ((uint32_t)(input[6] & 0x03) << 30) |
			((uint32_t)input[7] << 22) |
			((uint32_t)(input[8] & 0xfc) << 14);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 70 to 85
	value = ((uint32_t)(input[8] & 0x03) << 30) |
			((uint32_t)input[9] << 22) |
			((uint32_t)(input[10] & 0xfc) << 14);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 86 to 101
	value = ((uint32_t)(input[10] & 0x03) << 30) |
			((uint32_t)input[11] << 22) |
			((uint32_t)(input[12] & 0xfc) << 14);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 102 to 117
	value = ((uint32_t)(input[12] & 0x03) << 30) |
			((uint32_t)input[13] << 22) |
			((uint32_t)(input[14] & 0xfc) << 14);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 118 to 133
	value = ((uint32_t)(input[14] & 0x03) << 30) |
			((uint32_t)input[15] << 22) |
			((uint32_t)(input[16] & 0xfc) << 14);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 134 to 149
	value = ((uint32_t)(input[16] & 0x03) << 30) |
			((uint32_t)input[17] << 22) |
			((uint32_t)(input[18] & 0xfc) << 14);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 150 to 165
	value = ((uint32_t)(input[18] & 0x03) << 30) |
			((uint32_t)input[19] << 22) |
			((uint32_t)(input[20] & 0xfc) << 14);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 166 to 181
	value = ((uint32_t)(input[20] & 0x03) << 30) |
			((uint32_t)input[21] << 22) |
			((uint32_t)(input[22] & 0xfc) << 14);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 182 to 197
	value = ((uint32_t)(input[22] & 0x03) << 30) |
			((uint32_t)input[23] << 22) |
			((uint32_t)(input[24] & 0xfc) << 14);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 198 to 213
	value = ((uint32_t)(input[24] & 0x03) << 30) |
			((uint32_t)input[25] << 22) |
			((uint32_t)(input[26] & 0xfc) << 14);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 214 to 229
	value = ((uint32_t)(input[26] & 0x03) << 30) |
			((uint32_t)input[27] << 22) |
			((uint32_t)(input[28] & 0xfc) << 14);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 230 to 245
	value = ((uint32_t)(input[28] & 0x03) << 30) |
			((uint32_t)input[29] << 22) |
			((uint32_t)(input[30] & 0xfc) << 14);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 246 to 261
	value = ((uint32_t)(input[30] & 0x03) << 30) |
			((uint32_t)input[31] << 22) |
			((uint32_t)(input[32] & 0xfc) << 14);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 262 to 277
	value = ((uint32_t)(input[32] & 0x03) << 30) |
			((uint32_t)input[33] << 22) |
			((uint32_t)(input[34] & 0xfc) << 14);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 278 to 293
	value = ((uint32_t)(input[34] & 0x03) << 30) |
			((uint32_t)input[35] << 22) |
			((uint32_t)(input[36] & 0xfc) << 14);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 294 to 309
	value = ((uint32_t)(input[36] & 0x03) << 30) |
			((uint32_t)input[37] << 22) |
			((uint32_t)(input[38] & 0xfc) << 14);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 310 to 325
	value = ((uint32_t)(input[38] & 0x03) << 30) |
			((uint32_t)input[39] << 22) |
			((uint32_t)(input[40] & 0xfc) << 14);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 326 to 341
	value = ((uint32_t)(input[40] & 0x03) << 30) |
			((uint32_t)input[41] << 22) |
			((uint32_t)(input[42] & 0xfc) << 14);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 342 to 357
	value = ((uint32_t)(input[42] & 0x03) << 30) |
			((uint32_t)input[43] << 22) |
			((uint32_t)(input[44] & 0xfc) << 14);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 358 to 373
	value = ((uint32_t)(input[44] & 0x03) << 30) |
			((uint32_t)input[45] << 22) |
			((uint32_t)(input[46] & 0xfc) << 14);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 374 to 389
	value = ((uint32_t)(input[46] & 0x03) << 30) |
			((uint32_t)input[47] << 22) |
			((uint32_t)(input[48] & 0xfc) << 14);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 390 to 405
	value = ((uint32_t)(input[48] & 0x03) << 30) |
			((uint32_t)input[49] << 22) |
			((uint32_t)(input[50] & 0xfc) << 14);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 406 to 421
	value = ((uint32_t)(input[50] & 0x03) << 30) |
			((uint32_t)input[51] << 22) |
			((uint32_t)(input[52] & 0xfc) << 14);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 422 to 437
	value = ((uint32_t)(input[52] & 0x03) << 30) |
			((uint32_t)input[53] << 22) |
			((uint32_t)(input[54] & 0xfc) << 14);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 438 to 453
	value = ((uint32_t)(input[54] & 0x03) << 30) |
			((uint32_t)input[55] << 22) |
			((uint32_t)(input[56] & 0xfc) << 14);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 454 to 469
	value = ((uint32_t)(input[56] & 0x03) << 30) |
			((uint32_t)input[57] << 22) |
			((uint32_t)(input[58] & 0xfc) << 14);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 470 to 485
	value = ((uint32_t)(input[58] & 0x03) << 30) |
			((uint32_t)input[59] << 22) |
			((uint32_t)(input[60] & 0xfc) << 14);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 486 to 501
	value = ((uint32_t)(input[60] & 0x03) << 30) |
			((uint32_t)input[61] << 22) |
			((uint32_t)(input[62] & 0xfc) << 14);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 502 to 517
	value = ((uint32_t)(input[62] & 0x03) << 30) |
			((uint32_t)input[63] << 22) |
			((uint32_t)(input[64] & 0xfc) << 14);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 518 to 533
	value = ((uint32_t)(input[64] & 0x03) << 30) |
			((uint32_t)input[65] << 22) |
			((uint32_t)(input[66] & 0xfc) << 14);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 534 to 549
	value = ((uint32_t)(input[66] & 0x03) << 30) |
			((uint32_t)input[67] << 22) |
			((uint32_t)(input[68] & 0xfc) << 14);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 550 to 565
	value = ((uint32_t)(input[68] & 0x03) << 30) |
			((uint32_t)input[69] << 22) |
			((uint32_t)(input[70] & 0xfc) << 14);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 566 to 581
	value = ((uint32_t)(input[70] & 0x03) << 30) |
			((uint32_t)input[71] << 22) |
			((uint32_t)(input[72] & 0xfc) << 14);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 582 to 597
	value = ((uint32_t)(input[72] & 0x03) << 30) |
			((uint32_t)input[73] << 22) |
			((uint32_t)(input[74] & 0xfc) << 14);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 598 to 613
	value = ((uint32_t)(input[74] & 0x03) << 30) |
			((uint32_t)input[75] << 22) |
			((uint32_t)(input[76] & 0xfc) << 14);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 614 to 629
	value = ((uint32_t)(input[76] & 0x03) << 30) |
			((uint32_t)input[77] << 22) |
			((uint32_t)(input[78] & 0xfc) << 14);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 630 to 645
	value = ((uint32_t)(input[78] & 0x03) << 30) |
			((uint32_t)input[79] << 22) |
			((uint32_t)(input[80] & 0xfc) << 14);
	output[39] = (double)(value >> 16);

	// read output[40]: from bit 646 to 661
	value = ((uint32_t)(input[80] & 0x03) << 30) |
			((uint32_t)input[81] << 22) |
			((uint32_t)(input[82] & 0xfc) << 14);
	output[40] = (double)(value >> 16);

	// read output[41]: from bit 662 to 677
	value = ((uint32_t)(input[82] & 0x03) << 30) |
			((uint32_t)input[83] << 22) |
			((uint32_t)(input[84] & 0xfc) << 14);
	output[41] = (double)(value >> 16);

	// read output[42]: from bit 678 to 693
	value = ((uint32_t)(input[84] & 0x03) << 30) |
			((uint32_t)input[85] << 22) |
			((uint32_t)(input[86] & 0xfc) << 14);
	output[42] = (double)(value >> 16);

	// read output[43]: from bit 694 to 709
	value = ((uint32_t)(input[86] & 0x03) << 30) |
			((uint32_t)input[87] << 22) |
			((uint32_t)(input[88] & 0xfc) << 14);
	output[43] = (double)(value >> 16);

	// read output[44]: from bit 710 to 725
	value = ((uint32_t)(input[88] & 0x03) << 30) |
			((uint32_t)input[89] << 22) |
			((uint32_t)(input[90] & 0xfc) << 14);
	output[44] = (double)(value >> 16);

	// read output[45]: from bit 726 to 741
	value = ((uint32_t)(input[90] & 0x03) << 30) |
			((uint32_t)input[91] << 22) |
			((uint32_t)(input[92] & 0xfc) << 14);
	output[45] = (double)(value >> 16);

	// read output[46]: from bit 742 to 757
	value = ((uint32_t)(input[92] & 0x03) << 30) |
			((uint32_t)input[93] << 22) |
			((uint32_t)(input[94] & 0xfc) << 14);
	output[46] = (double)(value >> 16);

	// read output[47]: from bit 758 to 773
	value = ((uint32_t)(input[94] & 0x03) << 30) |
			((uint32_t)input[95] << 22) |
			((uint32_t)(input[96] & 0xfc) << 14);
	output[47] = (double)(value >> 16);

	// read output[48]: from bit 774 to 789
	value = ((uint32_t)(input[96] & 0x03) << 30) |
			((uint32_t)input[97] << 22) |
			((uint32_t)(input[98] & 0xfc) << 14);
	output[48] = (double)(value >> 16);

	// read output[49]: from bit 790 to 805
	value = ((uint32_t)(input[98] & 0x03) << 30) |
			((uint32_t)input[99] << 22) |
			((uint32_t)(input[100] & 0xfc) << 14);
	output[49] = (double)(value >> 16);

	// read output[50]: from bit 806 to 821
	value = ((uint32_t)(input[100] & 0x03) << 30) |
			((uint32_t)input[101] << 22) |
			((uint32_t)(input[102] & 0xfc) << 14);
	output[50] = (double)(value >> 16);

	// read output[51]: from bit 822 to 837
	value = ((uint32_t)(input[102] & 0x03) << 30) |
			((uint32_t)input[103] << 22) |
			((uint32_t)(input[104] & 0xfc) << 14);
	output[51] = (double)(value >> 16);

	// read output[52]: from bit 838 to 853
	value = ((uint32_t)(input[104] & 0x03) << 30) |
			((uint32_t)input[105] << 22) |
			((uint32_t)(input[106] & 0xfc) << 14);
	output[52] = (double)(value >> 16);

	// read output[53]: from bit 854 to 869
	value = ((uint32_t)(input[106] & 0x03) << 30) |
			((uint32_t)input[107] << 22) |
			((uint32_t)(input[108] & 0xfc) << 14);
	output[53] = (double)(value >> 16);

	// read output[54]: from bit 870 to 885
	value = ((uint32_t)(input[108] & 0x03) << 30) |
			((uint32_t)input[109] << 22) |
			((uint32_t)(input[110] & 0xfc) << 14);
	output[54] = (double)(value >> 16);

	// read output[55]: from bit 886 to 901
	value = ((uint32_t)(input[110] & 0x03) << 30) |
			((uint32_t)input[111] << 22) |
			((uint32_t)(input[112] & 0xfc) << 14);
	output[55] = (double)(value >> 16);

	// read output[56]: from bit 902 to 917
	value = ((uint32_t)(input[112] & 0x03) << 30) |
			((uint32_t)input[113] << 22) |
			((uint32_t)(input[114] & 0xfc) << 14);
	output[56] = (double)(value >> 16);

	// read output[57]: from bit 918 to 933
	value = ((uint32_t)(input[114] & 0x03) << 30) |
			((uint32_t)input[115] << 22) |
			((uint32_t)(input[116] & 0xfc) << 14);
	output[57] = (double)(value >> 16);

	// read output[58]: from bit 934 to 949
	value = ((uint32_t)(input[116] & 0x03) << 30) |
			((uint32_t)input[117] << 22) |
			((uint32_t)(input[118] & 0xfc) << 14);
	output[58] = (double)(value >> 16);

	// read output[59]: from bit 950 to 965
	value = ((uint32_t)(input[118] & 0x03) << 30) |
			((uint32_t)input[119] << 22) |
			((uint32_t)(input[120] & 0xfc) << 14);
	output[59] = (double)(value >> 16);

	// read output[60]: from bit 966 to 981
	value = ((uint32_t)(input[120] & 0x03) << 30) |
			((uint32_t)input[121] << 22) |
			((uint32_t)(input[122] & 0xfc) << 14);
	output[60] = (double)(value >> 16);
}

static void unpack_61_16bit_signed_7off(const uint8_t * input, double * output, void *closure) {
	// Unpack 61 values into output
	// Values are 16-bit signed
	// Skip 7 bits, read 976 bits of data.
	// Input must be at least 123 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 7 to 22
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)(input[2] & 0xfe) << 15);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 23 to 38
	value = ((uint32_t)(input[2] & 0x01) << 31) |
			((uint32_t)input[3] << 23) |
			((uint32_t)(input[4] & 0xfe) << 15);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 39 to 54
	value = ((uint32_t)(input[4] & 0x01) << 31) |
			((uint32_t)input[5] << 23) |
			((uint32_t)(input[6] & 0xfe) << 15);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 55 to 70
	value = ((uint32_t)(input[6] & 0x01) << 31) |
			((uint32_t)input[7] << 23) |
			((uint32_t)(input[8] & 0xfe) << 15);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 71 to 86
	value = ((uint32_t)(input[8] & 0x01) << 31) |
			((uint32_t)input[9] << 23) |
			((uint32_t)(input[10] & 0xfe) << 15);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 87 to 102
	value = ((uint32_t)(input[10] & 0x01) << 31) |
			((uint32_t)input[11] << 23) |
			((uint32_t)(input[12] & 0xfe) << 15);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 103 to 118
	value = ((uint32_t)(input[12] & 0x01) << 31) |
			((uint32_t)input[13] << 23) |
			((uint32_t)(input[14] & 0xfe) << 15);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 119 to 134
	value = ((uint32_t)(input[14] & 0x01) << 31) |
			((uint32_t)input[15] << 23) |
			((uint32_t)(input[16] & 0xfe) << 15);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 135 to 150
	value = ((uint32_t)(input[16] & 0x01) << 31) |
			((uint32_t)input[17] << 23) |
			((uint32_t)(input[18] & 0xfe) << 15);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 151 to 166
	value = ((uint32_t)(input[18] & 0x01) << 31) |
			((uint32_t)input[19] << 23) |
			((uint32_t)(input[20] & 0xfe) << 15);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 167 to 182
	value = ((uint32_t)(input[20] & 0x01) << 31) |
			((uint32_t)input[21] << 23) |
			((uint32_t)(input[22] & 0xfe) << 15);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 183 to 198
	value = ((uint32_t)(input[22] & 0x01) << 31) |
			((uint32_t)input[23] << 23) |
			((uint32_t)(input[24] & 0xfe) << 15);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 199 to 214
	value = ((uint32_t)(input[24] & 0x01) << 31) |
			((uint32_t)input[25] << 23) |
			((uint32_t)(input[26] & 0xfe) << 15);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 215 to 230
	value = ((uint32_t)(input[26] & 0x01) << 31) |
			((uint32_t)input[27] << 23) |
			((uint32_t)(input[28] & 0xfe) << 15);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 231 to 246
	value = ((uint32_t)(input[28] & 0x01) << 31) |
			((uint32_t)input[29] << 23) |
			((uint32_t)(input[30] & 0xfe) << 15);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 247 to 262
	value = ((uint32_t)(input[30] & 0x01) << 31) |
			((uint32_t)input[31] << 23) |
			((uint32_t)(input[32] & 0xfe) << 15);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 263 to 278
	value = ((uint32_t)(input[32] & 0x01) << 31) |
			((uint32_t)input[33] << 23) |
			((uint32_t)(input[34] & 0xfe) << 15);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 279 to 294
	value = ((uint32_t)(input[34] & 0x01) << 31) |
			((uint32_t)input[35] << 23) |
			((uint32_t)(input[36] & 0xfe) << 15);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 295 to 310
	value = ((uint32_t)(input[36] & 0x01) << 31) |
			((uint32_t)input[37] << 23) |
			((uint32_t)(input[38] & 0xfe) << 15);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 311 to 326
	value = ((uint32_t)(input[38] & 0x01) << 31) |
			((uint32_t)input[39] << 23) |
			((uint32_t)(input[40] & 0xfe) << 15);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 327 to 342
	value = ((uint32_t)(input[40] & 0x01) << 31) |
			((uint32_t)input[41] << 23) |
			((uint32_t)(input[42] & 0xfe) << 15);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 343 to 358
	value = ((uint32_t)(input[42] & 0x01) << 31) |
			((uint32_t)input[43] << 23) |
			((uint32_t)(input[44] & 0xfe) << 15);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 359 to 374
	value = ((uint32_t)(input[44] & 0x01) << 31) |
			((uint32_t)input[45] << 23) |
			((uint32_t)(input[46] & 0xfe) << 15);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 375 to 390
	value = ((uint32_t)(input[46] & 0x01) << 31) |
			((uint32_t)input[47] << 23) |
			((uint32_t)(input[48] & 0xfe) << 15);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 391 to 406
	value = ((uint32_t)(input[48] & 0x01) << 31) |
			((uint32_t)input[49] << 23) |
			((uint32_t)(input[50] & 0xfe) << 15);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 407 to 422
	value = ((uint32_t)(input[50] & 0x01) << 31) |
			((uint32_t)input[51] << 23) |
			((uint32_t)(input[52] & 0xfe) << 15);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 423 to 438
	value = ((uint32_t)(input[52] & 0x01) << 31) |
			((uint32_t)input[53] << 23) |
			((uint32_t)(input[54] & 0xfe) << 15);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 439 to 454
	value = ((uint32_t)(input[54] & 0x01) << 31) |
			((uint32_t)input[55] << 23) |
			((uint32_t)(input[56] & 0xfe) << 15);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 455 to 470
	value = ((uint32_t)(input[56] & 0x01) << 31) |
			((uint32_t)input[57] << 23) |
			((uint32_t)(input[58] & 0xfe) << 15);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 471 to 486
	value = ((uint32_t)(input[58] & 0x01) << 31) |
			((uint32_t)input[59] << 23) |
			((uint32_t)(input[60] & 0xfe) << 15);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 487 to 502
	value = ((uint32_t)(input[60] & 0x01) << 31) |
			((uint32_t)input[61] << 23) |
			((uint32_t)(input[62] & 0xfe) << 15);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 503 to 518
	value = ((uint32_t)(input[62] & 0x01) << 31) |
			((uint32_t)input[63] << 23) |
			((uint32_t)(input[64] & 0xfe) << 15);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 519 to 534
	value = ((uint32_t)(input[64] & 0x01) << 31) |
			((uint32_t)input[65] << 23) |
			((uint32_t)(input[66] & 0xfe) << 15);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 535 to 550
	value = ((uint32_t)(input[66] & 0x01) << 31) |
			((uint32_t)input[67] << 23) |
			((uint32_t)(input[68] & 0xfe) << 15);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 551 to 566
	value = ((uint32_t)(input[68] & 0x01) << 31) |
			((uint32_t)input[69] << 23) |
			((uint32_t)(input[70] & 0xfe) << 15);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 567 to 582
	value = ((uint32_t)(input[70] & 0x01) << 31) |
			((uint32_t)input[71] << 23) |
			((uint32_t)(input[72] & 0xfe) << 15);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 583 to 598
	value = ((uint32_t)(input[72] & 0x01) << 31) |
			((uint32_t)input[73] << 23) |
			((uint32_t)(input[74] & 0xfe) << 15);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 599 to 614
	value = ((uint32_t)(input[74] & 0x01) << 31) |
			((uint32_t)input[75] << 23) |
			((uint32_t)(input[76] & 0xfe) << 15);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 615 to 630
	value = ((uint32_t)(input[76] & 0x01) << 31) |
			((uint32_t)input[77] << 23) |
			((uint32_t)(input[78] & 0xfe) << 15);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 631 to 646
	value = ((uint32_t)(input[78] & 0x01) << 31) |
			((uint32_t)input[79] << 23) |
			((uint32_t)(input[80] & 0xfe) << 15);
	output[39] = (double)(value >> 16);

	// read output[40]: from bit 647 to 662
	value = ((uint32_t)(input[80] & 0x01) << 31) |
			((uint32_t)input[81] << 23) |
			((uint32_t)(input[82] & 0xfe) << 15);
	output[40] = (double)(value >> 16);

	// read output[41]: from bit 663 to 678
	value = ((uint32_t)(input[82] & 0x01) << 31) |
			((uint32_t)input[83] << 23) |
			((uint32_t)(input[84] & 0xfe) << 15);
	output[41] = (double)(value >> 16);

	// read output[42]: from bit 679 to 694
	value = ((uint32_t)(input[84] & 0x01) << 31) |
			((uint32_t)input[85] << 23) |
			((uint32_t)(input[86] & 0xfe) << 15);
	output[42] = (double)(value >> 16);

	// read output[43]: from bit 695 to 710
	value = ((uint32_t)(input[86] & 0x01) << 31) |
			((uint32_t)input[87] << 23) |
			((uint32_t)(input[88] & 0xfe) << 15);
	output[43] = (double)(value >> 16);

	// read output[44]: from bit 711 to 726
	value = ((uint32_t)(input[88] & 0x01) << 31) |
			((uint32_t)input[89] << 23) |
			((uint32_t)(input[90] & 0xfe) << 15);
	output[44] = (double)(value >> 16);

	// read output[45]: from bit 727 to 742
	value = ((uint32_t)(input[90] & 0x01) << 31) |
			((uint32_t)input[91] << 23) |
			((uint32_t)(input[92] & 0xfe) << 15);
	output[45] = (double)(value >> 16);

	// read output[46]: from bit 743 to 758
	value = ((uint32_t)(input[92] & 0x01) << 31) |
			((uint32_t)input[93] << 23) |
			((uint32_t)(input[94] & 0xfe) << 15);
	output[46] = (double)(value >> 16);

	// read output[47]: from bit 759 to 774
	value = ((uint32_t)(input[94] & 0x01) << 31) |
			((uint32_t)input[95] << 23) |
			((uint32_t)(input[96] & 0xfe) << 15);
	output[47] = (double)(value >> 16);

	// read output[48]: from bit 775 to 790
	value = ((uint32_t)(input[96] & 0x01) << 31) |
			((uint32_t)input[97] << 23) |
			((uint32_t)(input[98] & 0xfe) << 15);
	output[48] = (double)(value >> 16);

	// read output[49]: from bit 791 to 806
	value = ((uint32_t)(input[98] & 0x01) << 31) |
			((uint32_t)input[99] << 23) |
			((uint32_t)(input[100] & 0xfe) << 15);
	output[49] = (double)(value >> 16);

	// read output[50]: from bit 807 to 822
	value = ((uint32_t)(input[100] & 0x01) << 31) |
			((uint32_t)input[101] << 23) |
			((uint32_t)(input[102] & 0xfe) << 15);
	output[50] = (double)(value >> 16);

	// read output[51]: from bit 823 to 838
	value = ((uint32_t)(input[102] & 0x01) << 31) |
			((uint32_t)input[103] << 23) |
			((uint32_t)(input[104] & 0xfe) << 15);
	output[51] = (double)(value >> 16);

	// read output[52]: from bit 839 to 854
	value = ((uint32_t)(input[104] & 0x01) << 31) |
			((uint32_t)input[105] << 23) |
			((uint32_t)(input[106] & 0xfe) << 15);
	output[52] = (double)(value >> 16);

	// read output[53]: from bit 855 to 870
	value = ((uint32_t)(input[106] & 0x01) << 31) |
			((uint32_t)input[107] << 23) |
			((uint32_t)(input[108] & 0xfe) << 15);
	output[53] = (double)(value >> 16);

	// read output[54]: from bit 871 to 886
	value = ((uint32_t)(input[108] & 0x01) << 31) |
			((uint32_t)input[109] << 23) |
			((uint32_t)(input[110] & 0xfe) << 15);
	output[54] = (double)(value >> 16);

	// read output[55]: from bit 887 to 902
	value = ((uint32_t)(input[110] & 0x01) << 31) |
			((uint32_t)input[111] << 23) |
			((uint32_t)(input[112] & 0xfe) << 15);
	output[55] = (double)(value >> 16);

	// read output[56]: from bit 903 to 918
	value = ((uint32_t)(input[112] & 0x01) << 31) |
			((uint32_t)input[113] << 23) |
			((uint32_t)(input[114] & 0xfe) << 15);
	output[56] = (double)(value >> 16);

	// read output[57]: from bit 919 to 934
	value = ((uint32_t)(input[114] & 0x01) << 31) |
			((uint32_t)input[115] << 23) |
			((uint32_t)(input[116] & 0xfe) << 15);
	output[57] = (double)(value >> 16);

	// read output[58]: from bit 935 to 950
	value = ((uint32_t)(input[116] & 0x01) << 31) |
			((uint32_t)input[117] << 23) |
			((uint32_t)(input[118] & 0xfe) << 15);
	output[58] = (double)(value >> 16);

	// read output[59]: from bit 951 to 966
	value = ((uint32_t)(input[118] & 0x01) << 31) |
			((uint32_t)input[119] << 23) |
			((uint32_t)(input[120] & 0xfe) << 15);
	output[59] = (double)(value >> 16);

	// read output[60]: from bit 967 to 982
	value = ((uint32_t)(input[120] & 0x01) << 31) |
			((uint32_t)input[121] << 23) |
			((uint32_t)(input[122] & 0xfe) << 15);
	output[60] = (double)(value >> 16);
}

static void unpack_61_16bit_unsigned_7off(const uint8_t * input, double * output, void *closure) {
	// Unpack 61 values into output
	// Values are 16-bit unsigned
	// Skip 7 bits, read 976 bits of data.
	// Input must be at least 123 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 7 to 22
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)(input[2] & 0xfe) << 15);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 23 to 38
	value = ((uint32_t)(input[2] & 0x01) << 31) |
			((uint32_t)input[3] << 23) |
			((uint32_t)(input[4] & 0xfe) << 15);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 39 to 54
	value = ((uint32_t)(input[4] & 0x01) << 31) |
			((uint32_t)input[5] << 23) |
			((uint32_t)(input[6] & 0xfe) << 15);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 55 to 70
	value = ((uint32_t)(input[6] & 0x01) << 31) |
			((uint32_t)input[7] << 23) |
			((uint32_t)(input[8] & 0xfe) << 15);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 71 to 86
	value = ((uint32_t)(input[8] & 0x01) << 31) |
			((uint32_t)input[9] << 23) |
			((uint32_t)(input[10] & 0xfe) << 15);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 87 to 102
	value = ((uint32_t)(input[10] & 0x01) << 31) |
			((uint32_t)input[11] << 23) |
			((uint32_t)(input[12] & 0xfe) << 15);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 103 to 118
	value = ((uint32_t)(input[12] & 0x01) << 31) |
			((uint32_t)input[13] << 23) |
			((uint32_t)(input[14] & 0xfe) << 15);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 119 to 134
	value = ((uint32_t)(input[14] & 0x01) << 31) |
			((uint32_t)input[15] << 23) |
			((uint32_t)(input[16] & 0xfe) << 15);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 135 to 150
	value = ((uint32_t)(input[16] & 0x01) << 31) |
			((uint32_t)input[17] << 23) |
			((uint32_t)(input[18] & 0xfe) << 15);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 151 to 166
	value = ((uint32_t)(input[18] & 0x01) << 31) |
			((uint32_t)input[19] << 23) |
			((uint32_t)(input[20] & 0xfe) << 15);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 167 to 182
	value = ((uint32_t)(input[20] & 0x01) << 31) |
			((uint32_t)input[21] << 23) |
			((uint32_t)(input[22] & 0xfe) << 15);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 183 to 198
	value = ((uint32_t)(input[22] & 0x01) << 31) |
			((uint32_t)input[23] << 23) |
			((uint32_t)(input[24] & 0xfe) << 15);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 199 to 214
	value = ((uint32_t)(input[24] & 0x01) << 31) |
			((uint32_t)input[25] << 23) |
			((uint32_t)(input[26] & 0xfe) << 15);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 215 to 230
	value = ((uint32_t)(input[26] & 0x01) << 31) |
			((uint32_t)input[27] << 23) |
			((uint32_t)(input[28] & 0xfe) << 15);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 231 to 246
	value = ((uint32_t)(input[28] & 0x01) << 31) |
			((uint32_t)input[29] << 23) |
			((uint32_t)(input[30] & 0xfe) << 15);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 247 to 262
	value = ((uint32_t)(input[30] & 0x01) << 31) |
			((uint32_t)input[31] << 23) |
			((uint32_t)(input[32] & 0xfe) << 15);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 263 to 278
	value = ((uint32_t)(input[32] & 0x01) << 31) |
			((uint32_t)input[33] << 23) |
			((uint32_t)(input[34] & 0xfe) << 15);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 279 to 294
	value = ((uint32_t)(input[34] & 0x01) << 31) |
			((uint32_t)input[35] << 23) |
			((uint32_t)(input[36] & 0xfe) << 15);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 295 to 310
	value = ((uint32_t)(input[36] & 0x01) << 31) |
			((uint32_t)input[37] << 23) |
			((uint32_t)(input[38] & 0xfe) << 15);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 311 to 326
	value = ((uint32_t)(input[38] & 0x01) << 31) |
			((uint32_t)input[39] << 23) |
			((uint32_t)(input[40] & 0xfe) << 15);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 327 to 342
	value = ((uint32_t)(input[40] & 0x01) << 31) |
			((uint32_t)input[41] << 23) |
			((uint32_t)(input[42] & 0xfe) << 15);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 343 to 358
	value = ((uint32_t)(input[42] & 0x01) << 31) |
			((uint32_t)input[43] << 23) |
			((uint32_t)(input[44] & 0xfe) << 15);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 359 to 374
	value = ((uint32_t)(input[44] & 0x01) << 31) |
			((uint32_t)input[45] << 23) |
			((uint32_t)(input[46] & 0xfe) << 15);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 375 to 390
	value = ((uint32_t)(input[46] & 0x01) << 31) |
			((uint32_t)input[47] << 23) |
			((uint32_t)(input[48] & 0xfe) << 15);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 391 to 406
	value = ((uint32_t)(input[48] & 0x01) << 31) |
			((uint32_t)input[49] << 23) |
			((uint32_t)(input[50] & 0xfe) << 15);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 407 to 422
	value = ((uint32_t)(input[50] & 0x01) << 31) |
			((uint32_t)input[51] << 23) |
			((uint32_t)(input[52] & 0xfe) << 15);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 423 to 438
	value = ((uint32_t)(input[52] & 0x01) << 31) |
			((uint32_t)input[53] << 23) |
			((uint32_t)(input[54] & 0xfe) << 15);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 439 to 454
	value = ((uint32_t)(input[54] & 0x01) << 31) |
			((uint32_t)input[55] << 23) |
			((uint32_t)(input[56] & 0xfe) << 15);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 455 to 470
	value = ((uint32_t)(input[56] & 0x01) << 31) |
			((uint32_t)input[57] << 23) |
			((uint32_t)(input[58] & 0xfe) << 15);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 471 to 486
	value = ((uint32_t)(input[58] & 0x01) << 31) |
			((uint32_t)input[59] << 23) |
			((uint32_t)(input[60] & 0xfe) << 15);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 487 to 502
	value = ((uint32_t)(input[60] & 0x01) << 31) |
			((uint32_t)input[61] << 23) |
			((uint32_t)(input[62] & 0xfe) << 15);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 503 to 518
	value = ((uint32_t)(input[62] & 0x01) << 31) |
			((uint32_t)input[63] << 23) |
			((uint32_t)(input[64] & 0xfe) << 15);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 519 to 534
	value = ((uint32_t)(input[64] & 0x01) << 31) |
			((uint32_t)input[65] << 23) |
			((uint32_t)(input[66] & 0xfe) << 15);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 535 to 550
	value = ((uint32_t)(input[66] & 0x01) << 31) |
			((uint32_t)input[67] << 23) |
			((uint32_t)(input[68] & 0xfe) << 15);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 551 to 566
	value = ((uint32_t)(input[68] & 0x01) << 31) |
			((uint32_t)input[69] << 23) |
			((uint32_t)(input[70] & 0xfe) << 15);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 567 to 582
	value = ((uint32_t)(input[70] & 0x01) << 31) |
			((uint32_t)input[71] << 23) |
			((uint32_t)(input[72] & 0xfe) << 15);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 583 to 598
	value = ((uint32_t)(input[72] & 0x01) << 31) |
			((uint32_t)input[73] << 23) |
			((uint32_t)(input[74] & 0xfe) << 15);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 599 to 614
	value = ((uint32_t)(input[74] & 0x01) << 31) |
			((uint32_t)input[75] << 23) |
			((uint32_t)(input[76] & 0xfe) << 15);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 615 to 630
	value = ((uint32_t)(input[76] & 0x01) << 31) |
			((uint32_t)input[77] << 23) |
			((uint32_t)(input[78] & 0xfe) << 15);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 631 to 646
	value = ((uint32_t)(input[78] & 0x01) << 31) |
			((uint32_t)input[79] << 23) |
			((uint32_t)(input[80] & 0xfe) << 15);
	output[39] = (double)(value >> 16);

	// read output[40]: from bit 647 to 662
	value = ((uint32_t)(input[80] & 0x01) << 31) |
			((uint32_t)input[81] << 23) |
			((uint32_t)(input[82] & 0xfe) << 15);
	output[40] = (double)(value >> 16);

	// read output[41]: from bit 663 to 678
	value = ((uint32_t)(input[82] & 0x01) << 31) |
			((uint32_t)input[83] << 23) |
			((uint32_t)(input[84] & 0xfe) << 15);
	output[41] = (double)(value >> 16);

	// read output[42]: from bit 679 to 694
	value = ((uint32_t)(input[84] & 0x01) << 31) |
			((uint32_t)input[85] << 23) |
			((uint32_t)(input[86] & 0xfe) << 15);
	output[42] = (double)(value >> 16);

	// read output[43]: from bit 695 to 710
	value = ((uint32_t)(input[86] & 0x01) << 31) |
			((uint32_t)input[87] << 23) |
			((uint32_t)(input[88] & 0xfe) << 15);
	output[43] = (double)(value >> 16);

	// read output[44]: from bit 711 to 726
	value = ((uint32_t)(input[88] & 0x01) << 31) |
			((uint32_t)input[89] << 23) |
			((uint32_t)(input[90] & 0xfe) << 15);
	output[44] = (double)(value >> 16);

	// read output[45]: from bit 727 to 742
	value = ((uint32_t)(input[90] & 0x01) << 31) |
			((uint32_t)input[91] << 23) |
			((uint32_t)(input[92] & 0xfe) << 15);
	output[45] = (double)(value >> 16);

	// read output[46]: from bit 743 to 758
	value = ((uint32_t)(input[92] & 0x01) << 31) |
			((uint32_t)input[93] << 23) |
			((uint32_t)(input[94] & 0xfe) << 15);
	output[46] = (double)(value >> 16);

	// read output[47]: from bit 759 to 774
	value = ((uint32_t)(input[94] & 0x01) << 31) |
			((uint32_t)input[95] << 23) |
			((uint32_t)(input[96] & 0xfe) << 15);
	output[47] = (double)(value >> 16);

	// read output[48]: from bit 775 to 790
	value = ((uint32_t)(input[96] & 0x01) << 31) |
			((uint32_t)input[97] << 23) |
			((uint32_t)(input[98] & 0xfe) << 15);
	output[48] = (double)(value >> 16);

	// read output[49]: from bit 791 to 806
	value = ((uint32_t)(input[98] & 0x01) << 31) |
			((uint32_t)input[99] << 23) |
			((uint32_t)(input[100] & 0xfe) << 15);
	output[49] = (double)(value >> 16);

	// read output[50]: from bit 807 to 822
	value = ((uint32_t)(input[100] & 0x01) << 31) |
			((uint32_t)input[101] << 23) |
			((uint32_t)(input[102] & 0xfe) << 15);
	output[50] = (double)(value >> 16);

	// read output[51]: from bit 823 to 838
	value = ((uint32_t)(input[102] & 0x01) << 31) |
			((uint32_t)input[103] << 23) |
			((uint32_t)(input[104] & 0xfe) << 15);
	output[51] = (double)(value >> 16);

	// read output[52]: from bit 839 to 854
	value = ((uint32_t)(input[104] & 0x01) << 31) |
			((uint32_t)input[105] << 23) |
			((uint32_t)(input[106] & 0xfe) << 15);
	output[52] = (double)(value >> 16);

	// read output[53]: from bit 855 to 870
	value = ((uint32_t)(input[106] & 0x01) << 31) |
			((uint32_t)input[107] << 23) |
			((uint32_t)(input[108] & 0xfe) << 15);
	output[53] = (double)(value >> 16);

	// read output[54]: from bit 871 to 886
	value = ((uint32_t)(input[108] & 0x01) << 31) |
			((uint32_t)input[109] << 23) |
			((uint32_t)(input[110] & 0xfe) << 15);
	output[54] = (double)(value >> 16);

	// read output[55]: from bit 887 to 902
	value = ((uint32_t)(input[110] & 0x01) << 31) |
			((uint32_t)input[111] << 23) |
			((uint32_t)(input[112] & 0xfe) << 15);
	output[55] = (double)(value >> 16);

	// read output[56]: from bit 903 to 918
	value = ((uint32_t)(input[112] & 0x01) << 31) |
			((uint32_t)input[113] << 23) |
			((uint32_t)(input[114] & 0xfe) << 15);
	output[56] = (double)(value >> 16);

	// read output[57]: from bit 919 to 934
	value = ((uint32_t)(input[114] & 0x01) << 31) |
			((uint32_t)input[115] << 23) |
			((uint32_t)(input[116] & 0xfe) << 15);
	output[57] = (double)(value >> 16);

	// read output[58]: from bit 935 to 950
	value = ((uint32_t)(input[116] & 0x01) << 31) |
			((uint32_t)input[117] << 23) |
			((uint32_t)(input[118] & 0xfe) << 15);
	output[58] = (double)(value >> 16);

	// read output[59]: from bit 951 to 966
	value = ((uint32_t)(input[118] & 0x01) << 31) |
			((uint32_t)input[119] << 23) |
			((uint32_t)(input[120] & 0xfe) << 15);
	output[59] = (double)(value >> 16);

	// read output[60]: from bit 967 to 982
	value = ((uint32_t)(input[120] & 0x01) << 31) |
			((uint32_t)input[121] << 23) |
			((uint32_t)(input[122] & 0xfe) << 15);
	output[60] = (double)(value >> 16);
}

static void unpack_62_16bit_signed_0off(const uint8_t * input, double * output, void *closure) {
	// Unpack 62 values into output
	// Values are 16-bit signed
	// Skip 0 bits, read 992 bits of data.
	// Input must be at least 124 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 0 to 15
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)input[1] << 16);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 16 to 31
	value = ((uint32_t)input[2] << 24) |
			((uint32_t)input[3] << 16);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 32 to 47
	value = ((uint32_t)input[4] << 24) |
			((uint32_t)input[5] << 16);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 48 to 63
	value = ((uint32_t)input[6] << 24) |
			((uint32_t)input[7] << 16);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 64 to 79
	value = ((uint32_t)input[8] << 24) |
			((uint32_t)input[9] << 16);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 80 to 95
	value = ((uint32_t)input[10] << 24) |
			((uint32_t)input[11] << 16);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 96 to 111
	value = ((uint32_t)input[12] << 24) |
			((uint32_t)input[13] << 16);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 112 to 127
	value = ((uint32_t)input[14] << 24) |
			((uint32_t)input[15] << 16);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 128 to 143
	value = ((uint32_t)input[16] << 24) |
			((uint32_t)input[17] << 16);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 144 to 159
	value = ((uint32_t)input[18] << 24) |
			((uint32_t)input[19] << 16);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 160 to 175
	value = ((uint32_t)input[20] << 24) |
			((uint32_t)input[21] << 16);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 176 to 191
	value = ((uint32_t)input[22] << 24) |
			((uint32_t)input[23] << 16);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 192 to 207
	value = ((uint32_t)input[24] << 24) |
			((uint32_t)input[25] << 16);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 208 to 223
	value = ((uint32_t)input[26] << 24) |
			((uint32_t)input[27] << 16);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 224 to 239
	value = ((uint32_t)input[28] << 24) |
			((uint32_t)input[29] << 16);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 240 to 255
	value = ((uint32_t)input[30] << 24) |
			((uint32_t)input[31] << 16);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 256 to 271
	value = ((uint32_t)input[32] << 24) |
			((uint32_t)input[33] << 16);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 272 to 287
	value = ((uint32_t)input[34] << 24) |
			((uint32_t)input[35] << 16);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 288 to 303
	value = ((uint32_t)input[36] << 24) |
			((uint32_t)input[37] << 16);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 304 to 319
	value = ((uint32_t)input[38] << 24) |
			((uint32_t)input[39] << 16);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 320 to 335
	value = ((uint32_t)input[40] << 24) |
			((uint32_t)input[41] << 16);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 336 to 351
	value = ((uint32_t)input[42] << 24) |
			((uint32_t)input[43] << 16);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 352 to 367
	value = ((uint32_t)input[44] << 24) |
			((uint32_t)input[45] << 16);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 368 to 383
	value = ((uint32_t)input[46] << 24) |
			((uint32_t)input[47] << 16);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 384 to 399
	value = ((uint32_t)input[48] << 24) |
			((uint32_t)input[49] << 16);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 400 to 415
	value = ((uint32_t)input[50] << 24) |
			((uint32_t)input[51] << 16);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 416 to 431
	value = ((uint32_t)input[52] << 24) |
			((uint32_t)input[53] << 16);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 432 to 447
	value = ((uint32_t)input[54] << 24) |
			((uint32_t)input[55] << 16);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 448 to 463
	value = ((uint32_t)input[56] << 24) |
			((uint32_t)input[57] << 16);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 464 to 479
	value = ((uint32_t)input[58] << 24) |
			((uint32_t)input[59] << 16);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 480 to 495
	value = ((uint32_t)input[60] << 24) |
			((uint32_t)input[61] << 16);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 496 to 511
	value = ((uint32_t)input[62] << 24) |
			((uint32_t)input[63] << 16);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 512 to 527
	value = ((uint32_t)input[64] << 24) |
			((uint32_t)input[65] << 16);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 528 to 543
	value = ((uint32_t)input[66] << 24) |
			((uint32_t)input[67] << 16);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 544 to 559
	value = ((uint32_t)input[68] << 24) |
			((uint32_t)input[69] << 16);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 560 to 575
	value = ((uint32_t)input[70] << 24) |
			((uint32_t)input[71] << 16);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 576 to 591
	value = ((uint32_t)input[72] << 24) |
			((uint32_t)input[73] << 16);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 592 to 607
	value = ((uint32_t)input[74] << 24) |
			((uint32_t)input[75] << 16);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 608 to 623
	value = ((uint32_t)input[76] << 24) |
			((uint32_t)input[77] << 16);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 624 to 639
	value = ((uint32_t)input[78] << 24) |
			((uint32_t)input[79] << 16);
	output[39] = (double)(value >> 16);

	// read output[40]: from bit 640 to 655
	value = ((uint32_t)input[80] << 24) |
			((uint32_t)input[81] << 16);
	output[40] = (double)(value >> 16);

	// read output[41]: from bit 656 to 671
	value = ((uint32_t)input[82] << 24) |
			((uint32_t)input[83] << 16);
	output[41] = (double)(value >> 16);

	// read output[42]: from bit 672 to 687
	value = ((uint32_t)input[84] << 24) |
			((uint32_t)input[85] << 16);
	output[42] = (double)(value >> 16);

	// read output[43]: from bit 688 to 703
	value = ((uint32_t)input[86] << 24) |
			((uint32_t)input[87] << 16);
	output[43] = (double)(value >> 16);

	// read output[44]: from bit 704 to 719
	value = ((uint32_t)input[88] << 24) |
			((uint32_t)input[89] << 16);
	output[44] = (double)(value >> 16);

	// read output[45]: from bit 720 to 735
	value = ((uint32_t)input[90] << 24) |
			((uint32_t)input[91] << 16);
	output[45] = (double)(value >> 16);

	// read output[46]: from bit 736 to 751
	value = ((uint32_t)input[92] << 24) |
			((uint32_t)input[93] << 16);
	output[46] = (double)(value >> 16);

	// read output[47]: from bit 752 to 767
	value = ((uint32_t)input[94] << 24) |
			((uint32_t)input[95] << 16);
	output[47] = (double)(value >> 16);

	// read output[48]: from bit 768 to 783
	value = ((uint32_t)input[96] << 24) |
			((uint32_t)input[97] << 16);
	output[48] = (double)(value >> 16);

	// read output[49]: from bit 784 to 799
	value = ((uint32_t)input[98] << 24) |
			((uint32_t)input[99] << 16);
	output[49] = (double)(value >> 16);

	// read output[50]: from bit 800 to 815
	value = ((uint32_t)input[100] << 24) |
			((uint32_t)input[101] << 16);
	output[50] = (double)(value >> 16);

	// read output[51]: from bit 816 to 831
	value = ((uint32_t)input[102] << 24) |
			((uint32_t)input[103] << 16);
	output[51] = (double)(value >> 16);

	// read output[52]: from bit 832 to 847
	value = ((uint32_t)input[104] << 24) |
			((uint32_t)input[105] << 16);
	output[52] = (double)(value >> 16);

	// read output[53]: from bit 848 to 863
	value = ((uint32_t)input[106] << 24) |
			((uint32_t)input[107] << 16);
	output[53] = (double)(value >> 16);

	// read output[54]: from bit 864 to 879
	value = ((uint32_t)input[108] << 24) |
			((uint32_t)input[109] << 16);
	output[54] = (double)(value >> 16);

	// read output[55]: from bit 880 to 895
	value = ((uint32_t)input[110] << 24) |
			((uint32_t)input[111] << 16);
	output[55] = (double)(value >> 16);

	// read output[56]: from bit 896 to 911
	value = ((uint32_t)input[112] << 24) |
			((uint32_t)input[113] << 16);
	output[56] = (double)(value >> 16);

	// read output[57]: from bit 912 to 927
	value = ((uint32_t)input[114] << 24) |
			((uint32_t)input[115] << 16);
	output[57] = (double)(value >> 16);

	// read output[58]: from bit 928 to 943
	value = ((uint32_t)input[116] << 24) |
			((uint32_t)input[117] << 16);
	output[58] = (double)(value >> 16);

	// read output[59]: from bit 944 to 959
	value = ((uint32_t)input[118] << 24) |
			((uint32_t)input[119] << 16);
	output[59] = (double)(value >> 16);

	// read output[60]: from bit 960 to 975
	value = ((uint32_t)input[120] << 24) |
			((uint32_t)input[121] << 16);
	output[60] = (double)(value >> 16);

	// read output[61]: from bit 976 to 991
	value = ((uint32_t)input[122] << 24) |
			((uint32_t)input[123] << 16);
	output[61] = (double)(value >> 16);
}

static void unpack_62_16bit_unsigned_0off(const uint8_t * input, double * output, void *closure) {
	// Unpack 62 values into output
	// Values are 16-bit unsigned
	// Skip 0 bits, read 992 bits of data.
	// Input must be at least 124 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 0 to 15
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)input[1] << 16);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 16 to 31
	value = ((uint32_t)input[2] << 24) |
			((uint32_t)input[3] << 16);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 32 to 47
	value = ((uint32_t)input[4] << 24) |
			((uint32_t)input[5] << 16);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 48 to 63
	value = ((uint32_t)input[6] << 24) |
			((uint32_t)input[7] << 16);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 64 to 79
	value = ((uint32_t)input[8] << 24) |
			((uint32_t)input[9] << 16);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 80 to 95
	value = ((uint32_t)input[10] << 24) |
			((uint32_t)input[11] << 16);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 96 to 111
	value = ((uint32_t)input[12] << 24) |
			((uint32_t)input[13] << 16);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 112 to 127
	value = ((uint32_t)input[14] << 24) |
			((uint32_t)input[15] << 16);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 128 to 143
	value = ((uint32_t)input[16] << 24) |
			((uint32_t)input[17] << 16);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 144 to 159
	value = ((uint32_t)input[18] << 24) |
			((uint32_t)input[19] << 16);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 160 to 175
	value = ((uint32_t)input[20] << 24) |
			((uint32_t)input[21] << 16);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 176 to 191
	value = ((uint32_t)input[22] << 24) |
			((uint32_t)input[23] << 16);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 192 to 207
	value = ((uint32_t)input[24] << 24) |
			((uint32_t)input[25] << 16);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 208 to 223
	value = ((uint32_t)input[26] << 24) |
			((uint32_t)input[27] << 16);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 224 to 239
	value = ((uint32_t)input[28] << 24) |
			((uint32_t)input[29] << 16);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 240 to 255
	value = ((uint32_t)input[30] << 24) |
			((uint32_t)input[31] << 16);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 256 to 271
	value = ((uint32_t)input[32] << 24) |
			((uint32_t)input[33] << 16);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 272 to 287
	value = ((uint32_t)input[34] << 24) |
			((uint32_t)input[35] << 16);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 288 to 303
	value = ((uint32_t)input[36] << 24) |
			((uint32_t)input[37] << 16);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 304 to 319
	value = ((uint32_t)input[38] << 24) |
			((uint32_t)input[39] << 16);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 320 to 335
	value = ((uint32_t)input[40] << 24) |
			((uint32_t)input[41] << 16);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 336 to 351
	value = ((uint32_t)input[42] << 24) |
			((uint32_t)input[43] << 16);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 352 to 367
	value = ((uint32_t)input[44] << 24) |
			((uint32_t)input[45] << 16);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 368 to 383
	value = ((uint32_t)input[46] << 24) |
			((uint32_t)input[47] << 16);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 384 to 399
	value = ((uint32_t)input[48] << 24) |
			((uint32_t)input[49] << 16);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 400 to 415
	value = ((uint32_t)input[50] << 24) |
			((uint32_t)input[51] << 16);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 416 to 431
	value = ((uint32_t)input[52] << 24) |
			((uint32_t)input[53] << 16);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 432 to 447
	value = ((uint32_t)input[54] << 24) |
			((uint32_t)input[55] << 16);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 448 to 463
	value = ((uint32_t)input[56] << 24) |
			((uint32_t)input[57] << 16);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 464 to 479
	value = ((uint32_t)input[58] << 24) |
			((uint32_t)input[59] << 16);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 480 to 495
	value = ((uint32_t)input[60] << 24) |
			((uint32_t)input[61] << 16);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 496 to 511
	value = ((uint32_t)input[62] << 24) |
			((uint32_t)input[63] << 16);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 512 to 527
	value = ((uint32_t)input[64] << 24) |
			((uint32_t)input[65] << 16);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 528 to 543
	value = ((uint32_t)input[66] << 24) |
			((uint32_t)input[67] << 16);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 544 to 559
	value = ((uint32_t)input[68] << 24) |
			((uint32_t)input[69] << 16);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 560 to 575
	value = ((uint32_t)input[70] << 24) |
			((uint32_t)input[71] << 16);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 576 to 591
	value = ((uint32_t)input[72] << 24) |
			((uint32_t)input[73] << 16);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 592 to 607
	value = ((uint32_t)input[74] << 24) |
			((uint32_t)input[75] << 16);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 608 to 623
	value = ((uint32_t)input[76] << 24) |
			((uint32_t)input[77] << 16);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 624 to 639
	value = ((uint32_t)input[78] << 24) |
			((uint32_t)input[79] << 16);
	output[39] = (double)(value >> 16);

	// read output[40]: from bit 640 to 655
	value = ((uint32_t)input[80] << 24) |
			((uint32_t)input[81] << 16);
	output[40] = (double)(value >> 16);

	// read output[41]: from bit 656 to 671
	value = ((uint32_t)input[82] << 24) |
			((uint32_t)input[83] << 16);
	output[41] = (double)(value >> 16);

	// read output[42]: from bit 672 to 687
	value = ((uint32_t)input[84] << 24) |
			((uint32_t)input[85] << 16);
	output[42] = (double)(value >> 16);

	// read output[43]: from bit 688 to 703
	value = ((uint32_t)input[86] << 24) |
			((uint32_t)input[87] << 16);
	output[43] = (double)(value >> 16);

	// read output[44]: from bit 704 to 719
	value = ((uint32_t)input[88] << 24) |
			((uint32_t)input[89] << 16);
	output[44] = (double)(value >> 16);

	// read output[45]: from bit 720 to 735
	value = ((uint32_t)input[90] << 24) |
			((uint32_t)input[91] << 16);
	output[45] = (double)(value >> 16);

	// read output[46]: from bit 736 to 751
	value = ((uint32_t)input[92] << 24) |
			((uint32_t)input[93] << 16);
	output[46] = (double)(value >> 16);

	// read output[47]: from bit 752 to 767
	value = ((uint32_t)input[94] << 24) |
			((uint32_t)input[95] << 16);
	output[47] = (double)(value >> 16);

	// read output[48]: from bit 768 to 783
	value = ((uint32_t)input[96] << 24) |
			((uint32_t)input[97] << 16);
	output[48] = (double)(value >> 16);

	// read output[49]: from bit 784 to 799
	value = ((uint32_t)input[98] << 24) |
			((uint32_t)input[99] << 16);
	output[49] = (double)(value >> 16);

	// read output[50]: from bit 800 to 815
	value = ((uint32_t)input[100] << 24) |
			((uint32_t)input[101] << 16);
	output[50] = (double)(value >> 16);

	// read output[51]: from bit 816 to 831
	value = ((uint32_t)input[102] << 24) |
			((uint32_t)input[103] << 16);
	output[51] = (double)(value >> 16);

	// read output[52]: from bit 832 to 847
	value = ((uint32_t)input[104] << 24) |
			((uint32_t)input[105] << 16);
	output[52] = (double)(value >> 16);

	// read output[53]: from bit 848 to 863
	value = ((uint32_t)input[106] << 24) |
			((uint32_t)input[107] << 16);
	output[53] = (double)(value >> 16);

	// read output[54]: from bit 864 to 879
	value = ((uint32_t)input[108] << 24) |
			((uint32_t)input[109] << 16);
	output[54] = (double)(value >> 16);

	// read output[55]: from bit 880 to 895
	value = ((uint32_t)input[110] << 24) |
			((uint32_t)input[111] << 16);
	output[55] = (double)(value >> 16);

	// read output[56]: from bit 896 to 911
	value = ((uint32_t)input[112] << 24) |
			((uint32_t)input[113] << 16);
	output[56] = (double)(value >> 16);

	// read output[57]: from bit 912 to 927
	value = ((uint32_t)input[114] << 24) |
			((uint32_t)input[115] << 16);
	output[57] = (double)(value >> 16);

	// read output[58]: from bit 928 to 943
	value = ((uint32_t)input[116] << 24) |
			((uint32_t)input[117] << 16);
	output[58] = (double)(value >> 16);

	// read output[59]: from bit 944 to 959
	value = ((uint32_t)input[118] << 24) |
			((uint32_t)input[119] << 16);
	output[59] = (double)(value >> 16);

	// read output[60]: from bit 960 to 975
	value = ((uint32_t)input[120] << 24) |
			((uint32_t)input[121] << 16);
	output[60] = (double)(value >> 16);

	// read output[61]: from bit 976 to 991
	value = ((uint32_t)input[122] << 24) |
			((uint32_t)input[123] << 16);
	output[61] = (double)(value >> 16);
}

static void unpack_62_16bit_signed_1off(const uint8_t * input, double * output, void *closure) {
	// Unpack 62 values into output
	// Values are 16-bit signed
	// Skip 1 bits, read 992 bits of data.
	// Input must be at least 125 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 1 to 16
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)input[1] << 17) |
			((uint32_t)(input[2] & 0x80) << 9);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 17 to 32
	value = ((uint32_t)(input[2] & 0x7f) << 25) |
			((uint32_t)input[3] << 17) |
			((uint32_t)(input[4] & 0x80) << 9);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 33 to 48
	value = ((uint32_t)(input[4] & 0x7f) << 25) |
			((uint32_t)input[5] << 17) |
			((uint32_t)(input[6] & 0x80) << 9);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 49 to 64
	value = ((uint32_t)(input[6] & 0x7f) << 25) |
			((uint32_t)input[7] << 17) |
			((uint32_t)(input[8] & 0x80) << 9);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 65 to 80
	value = ((uint32_t)(input[8] & 0x7f) << 25) |
			((uint32_t)input[9] << 17) |
			((uint32_t)(input[10] & 0x80) << 9);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 81 to 96
	value = ((uint32_t)(input[10] & 0x7f) << 25) |
			((uint32_t)input[11] << 17) |
			((uint32_t)(input[12] & 0x80) << 9);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 97 to 112
	value = ((uint32_t)(input[12] & 0x7f) << 25) |
			((uint32_t)input[13] << 17) |
			((uint32_t)(input[14] & 0x80) << 9);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 113 to 128
	value = ((uint32_t)(input[14] & 0x7f) << 25) |
			((uint32_t)input[15] << 17) |
			((uint32_t)(input[16] & 0x80) << 9);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 129 to 144
	value = ((uint32_t)(input[16] & 0x7f) << 25) |
			((uint32_t)input[17] << 17) |
			((uint32_t)(input[18] & 0x80) << 9);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 145 to 160
	value = ((uint32_t)(input[18] & 0x7f) << 25) |
			((uint32_t)input[19] << 17) |
			((uint32_t)(input[20] & 0x80) << 9);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 161 to 176
	value = ((uint32_t)(input[20] & 0x7f) << 25) |
			((uint32_t)input[21] << 17) |
			((uint32_t)(input[22] & 0x80) << 9);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 177 to 192
	value = ((uint32_t)(input[22] & 0x7f) << 25) |
			((uint32_t)input[23] << 17) |
			((uint32_t)(input[24] & 0x80) << 9);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 193 to 208
	value = ((uint32_t)(input[24] & 0x7f) << 25) |
			((uint32_t)input[25] << 17) |
			((uint32_t)(input[26] & 0x80) << 9);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 209 to 224
	value = ((uint32_t)(input[26] & 0x7f) << 25) |
			((uint32_t)input[27] << 17) |
			((uint32_t)(input[28] & 0x80) << 9);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 225 to 240
	value = ((uint32_t)(input[28] & 0x7f) << 25) |
			((uint32_t)input[29] << 17) |
			((uint32_t)(input[30] & 0x80) << 9);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 241 to 256
	value = ((uint32_t)(input[30] & 0x7f) << 25) |
			((uint32_t)input[31] << 17) |
			((uint32_t)(input[32] & 0x80) << 9);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 257 to 272
	value = ((uint32_t)(input[32] & 0x7f) << 25) |
			((uint32_t)input[33] << 17) |
			((uint32_t)(input[34] & 0x80) << 9);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 273 to 288
	value = ((uint32_t)(input[34] & 0x7f) << 25) |
			((uint32_t)input[35] << 17) |
			((uint32_t)(input[36] & 0x80) << 9);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 289 to 304
	value = ((uint32_t)(input[36] & 0x7f) << 25) |
			((uint32_t)input[37] << 17) |
			((uint32_t)(input[38] & 0x80) << 9);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 305 to 320
	value = ((uint32_t)(input[38] & 0x7f) << 25) |
			((uint32_t)input[39] << 17) |
			((uint32_t)(input[40] & 0x80) << 9);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 321 to 336
	value = ((uint32_t)(input[40] & 0x7f) << 25) |
			((uint32_t)input[41] << 17) |
			((uint32_t)(input[42] & 0x80) << 9);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 337 to 352
	value = ((uint32_t)(input[42] & 0x7f) << 25) |
			((uint32_t)input[43] << 17) |
			((uint32_t)(input[44] & 0x80) << 9);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 353 to 368
	value = ((uint32_t)(input[44] & 0x7f) << 25) |
			((uint32_t)input[45] << 17) |
			((uint32_t)(input[46] & 0x80) << 9);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 369 to 384
	value = ((uint32_t)(input[46] & 0x7f) << 25) |
			((uint32_t)input[47] << 17) |
			((uint32_t)(input[48] & 0x80) << 9);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 385 to 400
	value = ((uint32_t)(input[48] & 0x7f) << 25) |
			((uint32_t)input[49] << 17) |
			((uint32_t)(input[50] & 0x80) << 9);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 401 to 416
	value = ((uint32_t)(input[50] & 0x7f) << 25) |
			((uint32_t)input[51] << 17) |
			((uint32_t)(input[52] & 0x80) << 9);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 417 to 432
	value = ((uint32_t)(input[52] & 0x7f) << 25) |
			((uint32_t)input[53] << 17) |
			((uint32_t)(input[54] & 0x80) << 9);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 433 to 448
	value = ((uint32_t)(input[54] & 0x7f) << 25) |
			((uint32_t)input[55] << 17) |
			((uint32_t)(input[56] & 0x80) << 9);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 449 to 464
	value = ((uint32_t)(input[56] & 0x7f) << 25) |
			((uint32_t)input[57] << 17) |
			((uint32_t)(input[58] & 0x80) << 9);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 465 to 480
	value = ((uint32_t)(input[58] & 0x7f) << 25) |
			((uint32_t)input[59] << 17) |
			((uint32_t)(input[60] & 0x80) << 9);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 481 to 496
	value = ((uint32_t)(input[60] & 0x7f) << 25) |
			((uint32_t)input[61] << 17) |
			((uint32_t)(input[62] & 0x80) << 9);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 497 to 512
	value = ((uint32_t)(input[62] & 0x7f) << 25) |
			((uint32_t)input[63] << 17) |
			((uint32_t)(input[64] & 0x80) << 9);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 513 to 528
	value = ((uint32_t)(input[64] & 0x7f) << 25) |
			((uint32_t)input[65] << 17) |
			((uint32_t)(input[66] & 0x80) << 9);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 529 to 544
	value = ((uint32_t)(input[66] & 0x7f) << 25) |
			((uint32_t)input[67] << 17) |
			((uint32_t)(input[68] & 0x80) << 9);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 545 to 560
	value = ((uint32_t)(input[68] & 0x7f) << 25) |
			((uint32_t)input[69] << 17) |
			((uint32_t)(input[70] & 0x80) << 9);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 561 to 576
	value = ((uint32_t)(input[70] & 0x7f) << 25) |
			((uint32_t)input[71] << 17) |
			((uint32_t)(input[72] & 0x80) << 9);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 577 to 592
	value = ((uint32_t)(input[72] & 0x7f) << 25) |
			((uint32_t)input[73] << 17) |
			((uint32_t)(input[74] & 0x80) << 9);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 593 to 608
	value = ((uint32_t)(input[74] & 0x7f) << 25) |
			((uint32_t)input[75] << 17) |
			((uint32_t)(input[76] & 0x80) << 9);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 609 to 624
	value = ((uint32_t)(input[76] & 0x7f) << 25) |
			((uint32_t)input[77] << 17) |
			((uint32_t)(input[78] & 0x80) << 9);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 625 to 640
	value = ((uint32_t)(input[78] & 0x7f) << 25) |
			((uint32_t)input[79] << 17) |
			((uint32_t)(input[80] & 0x80) << 9);
	output[39] = (double)(value >> 16);

	// read output[40]: from bit 641 to 656
	value = ((uint32_t)(input[80] & 0x7f) << 25) |
			((uint32_t)input[81] << 17) |
			((uint32_t)(input[82] & 0x80) << 9);
	output[40] = (double)(value >> 16);

	// read output[41]: from bit 657 to 672
	value = ((uint32_t)(input[82] & 0x7f) << 25) |
			((uint32_t)input[83] << 17) |
			((uint32_t)(input[84] & 0x80) << 9);
	output[41] = (double)(value >> 16);

	// read output[42]: from bit 673 to 688
	value = ((uint32_t)(input[84] & 0x7f) << 25) |
			((uint32_t)input[85] << 17) |
			((uint32_t)(input[86] & 0x80) << 9);
	output[42] = (double)(value >> 16);

	// read output[43]: from bit 689 to 704
	value = ((uint32_t)(input[86] & 0x7f) << 25) |
			((uint32_t)input[87] << 17) |
			((uint32_t)(input[88] & 0x80) << 9);
	output[43] = (double)(value >> 16);

	// read output[44]: from bit 705 to 720
	value = ((uint32_t)(input[88] & 0x7f) << 25) |
			((uint32_t)input[89] << 17) |
			((uint32_t)(input[90] & 0x80) << 9);
	output[44] = (double)(value >> 16);

	// read output[45]: from bit 721 to 736
	value = ((uint32_t)(input[90] & 0x7f) << 25) |
			((uint32_t)input[91] << 17) |
			((uint32_t)(input[92] & 0x80) << 9);
	output[45] = (double)(value >> 16);

	// read output[46]: from bit 737 to 752
	value = ((uint32_t)(input[92] & 0x7f) << 25) |
			((uint32_t)input[93] << 17) |
			((uint32_t)(input[94] & 0x80) << 9);
	output[46] = (double)(value >> 16);

	// read output[47]: from bit 753 to 768
	value = ((uint32_t)(input[94] & 0x7f) << 25) |
			((uint32_t)input[95] << 17) |
			((uint32_t)(input[96] & 0x80) << 9);
	output[47] = (double)(value >> 16);

	// read output[48]: from bit 769 to 784
	value = ((uint32_t)(input[96] & 0x7f) << 25) |
			((uint32_t)input[97] << 17) |
			((uint32_t)(input[98] & 0x80) << 9);
	output[48] = (double)(value >> 16);

	// read output[49]: from bit 785 to 800
	value = ((uint32_t)(input[98] & 0x7f) << 25) |
			((uint32_t)input[99] << 17) |
			((uint32_t)(input[100] & 0x80) << 9);
	output[49] = (double)(value >> 16);

	// read output[50]: from bit 801 to 816
	value = ((uint32_t)(input[100] & 0x7f) << 25) |
			((uint32_t)input[101] << 17) |
			((uint32_t)(input[102] & 0x80) << 9);
	output[50] = (double)(value >> 16);

	// read output[51]: from bit 817 to 832
	value = ((uint32_t)(input[102] & 0x7f) << 25) |
			((uint32_t)input[103] << 17) |
			((uint32_t)(input[104] & 0x80) << 9);
	output[51] = (double)(value >> 16);

	// read output[52]: from bit 833 to 848
	value = ((uint32_t)(input[104] & 0x7f) << 25) |
			((uint32_t)input[105] << 17) |
			((uint32_t)(input[106] & 0x80) << 9);
	output[52] = (double)(value >> 16);

	// read output[53]: from bit 849 to 864
	value = ((uint32_t)(input[106] & 0x7f) << 25) |
			((uint32_t)input[107] << 17) |
			((uint32_t)(input[108] & 0x80) << 9);
	output[53] = (double)(value >> 16);

	// read output[54]: from bit 865 to 880
	value = ((uint32_t)(input[108] & 0x7f) << 25) |
			((uint32_t)input[109] << 17) |
			((uint32_t)(input[110] & 0x80) << 9);
	output[54] = (double)(value >> 16);

	// read output[55]: from bit 881 to 896
	value = ((uint32_t)(input[110] & 0x7f) << 25) |
			((uint32_t)input[111] << 17) |
			((uint32_t)(input[112] & 0x80) << 9);
	output[55] = (double)(value >> 16);

	// read output[56]: from bit 897 to 912
	value = ((uint32_t)(input[112] & 0x7f) << 25) |
			((uint32_t)input[113] << 17) |
			((uint32_t)(input[114] & 0x80) << 9);
	output[56] = (double)(value >> 16);

	// read output[57]: from bit 913 to 928
	value = ((uint32_t)(input[114] & 0x7f) << 25) |
			((uint32_t)input[115] << 17) |
			((uint32_t)(input[116] & 0x80) << 9);
	output[57] = (double)(value >> 16);

	// read output[58]: from bit 929 to 944
	value = ((uint32_t)(input[116] & 0x7f) << 25) |
			((uint32_t)input[117] << 17) |
			((uint32_t)(input[118] & 0x80) << 9);
	output[58] = (double)(value >> 16);

	// read output[59]: from bit 945 to 960
	value = ((uint32_t)(input[118] & 0x7f) << 25) |
			((uint32_t)input[119] << 17) |
			((uint32_t)(input[120] & 0x80) << 9);
	output[59] = (double)(value >> 16);

	// read output[60]: from bit 961 to 976
	value = ((uint32_t)(input[120] & 0x7f) << 25) |
			((uint32_t)input[121] << 17) |
			((uint32_t)(input[122] & 0x80) << 9);
	output[60] = (double)(value >> 16);

	// read output[61]: from bit 977 to 992
	value = ((uint32_t)(input[122] & 0x7f) << 25) |
			((uint32_t)input[123] << 17) |
			((uint32_t)(input[124] & 0x80) << 9);
	output[61] = (double)(value >> 16);
}

static void unpack_62_16bit_unsigned_1off(const uint8_t * input, double * output, void *closure) {
	// Unpack 62 values into output
	// Values are 16-bit unsigned
	// Skip 1 bits, read 992 bits of data.
	// Input must be at least 125 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 1 to 16
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)input[1] << 17) |
			((uint32_t)(input[2] & 0x80) << 9);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 17 to 32
	value = ((uint32_t)(input[2] & 0x7f) << 25) |
			((uint32_t)input[3] << 17) |
			((uint32_t)(input[4] & 0x80) << 9);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 33 to 48
	value = ((uint32_t)(input[4] & 0x7f) << 25) |
			((uint32_t)input[5] << 17) |
			((uint32_t)(input[6] & 0x80) << 9);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 49 to 64
	value = ((uint32_t)(input[6] & 0x7f) << 25) |
			((uint32_t)input[7] << 17) |
			((uint32_t)(input[8] & 0x80) << 9);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 65 to 80
	value = ((uint32_t)(input[8] & 0x7f) << 25) |
			((uint32_t)input[9] << 17) |
			((uint32_t)(input[10] & 0x80) << 9);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 81 to 96
	value = ((uint32_t)(input[10] & 0x7f) << 25) |
			((uint32_t)input[11] << 17) |
			((uint32_t)(input[12] & 0x80) << 9);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 97 to 112
	value = ((uint32_t)(input[12] & 0x7f) << 25) |
			((uint32_t)input[13] << 17) |
			((uint32_t)(input[14] & 0x80) << 9);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 113 to 128
	value = ((uint32_t)(input[14] & 0x7f) << 25) |
			((uint32_t)input[15] << 17) |
			((uint32_t)(input[16] & 0x80) << 9);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 129 to 144
	value = ((uint32_t)(input[16] & 0x7f) << 25) |
			((uint32_t)input[17] << 17) |
			((uint32_t)(input[18] & 0x80) << 9);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 145 to 160
	value = ((uint32_t)(input[18] & 0x7f) << 25) |
			((uint32_t)input[19] << 17) |
			((uint32_t)(input[20] & 0x80) << 9);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 161 to 176
	value = ((uint32_t)(input[20] & 0x7f) << 25) |
			((uint32_t)input[21] << 17) |
			((uint32_t)(input[22] & 0x80) << 9);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 177 to 192
	value = ((uint32_t)(input[22] & 0x7f) << 25) |
			((uint32_t)input[23] << 17) |
			((uint32_t)(input[24] & 0x80) << 9);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 193 to 208
	value = ((uint32_t)(input[24] & 0x7f) << 25) |
			((uint32_t)input[25] << 17) |
			((uint32_t)(input[26] & 0x80) << 9);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 209 to 224
	value = ((uint32_t)(input[26] & 0x7f) << 25) |
			((uint32_t)input[27] << 17) |
			((uint32_t)(input[28] & 0x80) << 9);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 225 to 240
	value = ((uint32_t)(input[28] & 0x7f) << 25) |
			((uint32_t)input[29] << 17) |
			((uint32_t)(input[30] & 0x80) << 9);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 241 to 256
	value = ((uint32_t)(input[30] & 0x7f) << 25) |
			((uint32_t)input[31] << 17) |
			((uint32_t)(input[32] & 0x80) << 9);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 257 to 272
	value = ((uint32_t)(input[32] & 0x7f) << 25) |
			((uint32_t)input[33] << 17) |
			((uint32_t)(input[34] & 0x80) << 9);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 273 to 288
	value = ((uint32_t)(input[34] & 0x7f) << 25) |
			((uint32_t)input[35] << 17) |
			((uint32_t)(input[36] & 0x80) << 9);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 289 to 304
	value = ((uint32_t)(input[36] & 0x7f) << 25) |
			((uint32_t)input[37] << 17) |
			((uint32_t)(input[38] & 0x80) << 9);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 305 to 320
	value = ((uint32_t)(input[38] & 0x7f) << 25) |
			((uint32_t)input[39] << 17) |
			((uint32_t)(input[40] & 0x80) << 9);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 321 to 336
	value = ((uint32_t)(input[40] & 0x7f) << 25) |
			((uint32_t)input[41] << 17) |
			((uint32_t)(input[42] & 0x80) << 9);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 337 to 352
	value = ((uint32_t)(input[42] & 0x7f) << 25) |
			((uint32_t)input[43] << 17) |
			((uint32_t)(input[44] & 0x80) << 9);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 353 to 368
	value = ((uint32_t)(input[44] & 0x7f) << 25) |
			((uint32_t)input[45] << 17) |
			((uint32_t)(input[46] & 0x80) << 9);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 369 to 384
	value = ((uint32_t)(input[46] & 0x7f) << 25) |
			((uint32_t)input[47] << 17) |
			((uint32_t)(input[48] & 0x80) << 9);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 385 to 400
	value = ((uint32_t)(input[48] & 0x7f) << 25) |
			((uint32_t)input[49] << 17) |
			((uint32_t)(input[50] & 0x80) << 9);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 401 to 416
	value = ((uint32_t)(input[50] & 0x7f) << 25) |
			((uint32_t)input[51] << 17) |
			((uint32_t)(input[52] & 0x80) << 9);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 417 to 432
	value = ((uint32_t)(input[52] & 0x7f) << 25) |
			((uint32_t)input[53] << 17) |
			((uint32_t)(input[54] & 0x80) << 9);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 433 to 448
	value = ((uint32_t)(input[54] & 0x7f) << 25) |
			((uint32_t)input[55] << 17) |
			((uint32_t)(input[56] & 0x80) << 9);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 449 to 464
	value = ((uint32_t)(input[56] & 0x7f) << 25) |
			((uint32_t)input[57] << 17) |
			((uint32_t)(input[58] & 0x80) << 9);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 465 to 480
	value = ((uint32_t)(input[58] & 0x7f) << 25) |
			((uint32_t)input[59] << 17) |
			((uint32_t)(input[60] & 0x80) << 9);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 481 to 496
	value = ((uint32_t)(input[60] & 0x7f) << 25) |
			((uint32_t)input[61] << 17) |
			((uint32_t)(input[62] & 0x80) << 9);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 497 to 512
	value = ((uint32_t)(input[62] & 0x7f) << 25) |
			((uint32_t)input[63] << 17) |
			((uint32_t)(input[64] & 0x80) << 9);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 513 to 528
	value = ((uint32_t)(input[64] & 0x7f) << 25) |
			((uint32_t)input[65] << 17) |
			((uint32_t)(input[66] & 0x80) << 9);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 529 to 544
	value = ((uint32_t)(input[66] & 0x7f) << 25) |
			((uint32_t)input[67] << 17) |
			((uint32_t)(input[68] & 0x80) << 9);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 545 to 560
	value = ((uint32_t)(input[68] & 0x7f) << 25) |
			((uint32_t)input[69] << 17) |
			((uint32_t)(input[70] & 0x80) << 9);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 561 to 576
	value = ((uint32_t)(input[70] & 0x7f) << 25) |
			((uint32_t)input[71] << 17) |
			((uint32_t)(input[72] & 0x80) << 9);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 577 to 592
	value = ((uint32_t)(input[72] & 0x7f) << 25) |
			((uint32_t)input[73] << 17) |
			((uint32_t)(input[74] & 0x80) << 9);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 593 to 608
	value = ((uint32_t)(input[74] & 0x7f) << 25) |
			((uint32_t)input[75] << 17) |
			((uint32_t)(input[76] & 0x80) << 9);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 609 to 624
	value = ((uint32_t)(input[76] & 0x7f) << 25) |
			((uint32_t)input[77] << 17) |
			((uint32_t)(input[78] & 0x80) << 9);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 625 to 640
	value = ((uint32_t)(input[78] & 0x7f) << 25) |
			((uint32_t)input[79] << 17) |
			((uint32_t)(input[80] & 0x80) << 9);
	output[39] = (double)(value >> 16);

	// read output[40]: from bit 641 to 656
	value = ((uint32_t)(input[80] & 0x7f) << 25) |
			((uint32_t)input[81] << 17) |
			((uint32_t)(input[82] & 0x80) << 9);
	output[40] = (double)(value >> 16);

	// read output[41]: from bit 657 to 672
	value = ((uint32_t)(input[82] & 0x7f) << 25) |
			((uint32_t)input[83] << 17) |
			((uint32_t)(input[84] & 0x80) << 9);
	output[41] = (double)(value >> 16);

	// read output[42]: from bit 673 to 688
	value = ((uint32_t)(input[84] & 0x7f) << 25) |
			((uint32_t)input[85] << 17) |
			((uint32_t)(input[86] & 0x80) << 9);
	output[42] = (double)(value >> 16);

	// read output[43]: from bit 689 to 704
	value = ((uint32_t)(input[86] & 0x7f) << 25) |
			((uint32_t)input[87] << 17) |
			((uint32_t)(input[88] & 0x80) << 9);
	output[43] = (double)(value >> 16);

	// read output[44]: from bit 705 to 720
	value = ((uint32_t)(input[88] & 0x7f) << 25) |
			((uint32_t)input[89] << 17) |
			((uint32_t)(input[90] & 0x80) << 9);
	output[44] = (double)(value >> 16);

	// read output[45]: from bit 721 to 736
	value = ((uint32_t)(input[90] & 0x7f) << 25) |
			((uint32_t)input[91] << 17) |
			((uint32_t)(input[92] & 0x80) << 9);
	output[45] = (double)(value >> 16);

	// read output[46]: from bit 737 to 752
	value = ((uint32_t)(input[92] & 0x7f) << 25) |
			((uint32_t)input[93] << 17) |
			((uint32_t)(input[94] & 0x80) << 9);
	output[46] = (double)(value >> 16);

	// read output[47]: from bit 753 to 768
	value = ((uint32_t)(input[94] & 0x7f) << 25) |
			((uint32_t)input[95] << 17) |
			((uint32_t)(input[96] & 0x80) << 9);
	output[47] = (double)(value >> 16);

	// read output[48]: from bit 769 to 784
	value = ((uint32_t)(input[96] & 0x7f) << 25) |
			((uint32_t)input[97] << 17) |
			((uint32_t)(input[98] & 0x80) << 9);
	output[48] = (double)(value >> 16);

	// read output[49]: from bit 785 to 800
	value = ((uint32_t)(input[98] & 0x7f) << 25) |
			((uint32_t)input[99] << 17) |
			((uint32_t)(input[100] & 0x80) << 9);
	output[49] = (double)(value >> 16);

	// read output[50]: from bit 801 to 816
	value = ((uint32_t)(input[100] & 0x7f) << 25) |
			((uint32_t)input[101] << 17) |
			((uint32_t)(input[102] & 0x80) << 9);
	output[50] = (double)(value >> 16);

	// read output[51]: from bit 817 to 832
	value = ((uint32_t)(input[102] & 0x7f) << 25) |
			((uint32_t)input[103] << 17) |
			((uint32_t)(input[104] & 0x80) << 9);
	output[51] = (double)(value >> 16);

	// read output[52]: from bit 833 to 848
	value = ((uint32_t)(input[104] & 0x7f) << 25) |
			((uint32_t)input[105] << 17) |
			((uint32_t)(input[106] & 0x80) << 9);
	output[52] = (double)(value >> 16);

	// read output[53]: from bit 849 to 864
	value = ((uint32_t)(input[106] & 0x7f) << 25) |
			((uint32_t)input[107] << 17) |
			((uint32_t)(input[108] & 0x80) << 9);
	output[53] = (double)(value >> 16);

	// read output[54]: from bit 865 to 880
	value = ((uint32_t)(input[108] & 0x7f) << 25) |
			((uint32_t)input[109] << 17) |
			((uint32_t)(input[110] & 0x80) << 9);
	output[54] = (double)(value >> 16);

	// read output[55]: from bit 881 to 896
	value = ((uint32_t)(input[110] & 0x7f) << 25) |
			((uint32_t)input[111] << 17) |
			((uint32_t)(input[112] & 0x80) << 9);
	output[55] = (double)(value >> 16);

	// read output[56]: from bit 897 to 912
	value = ((uint32_t)(input[112] & 0x7f) << 25) |
			((uint32_t)input[113] << 17) |
			((uint32_t)(input[114] & 0x80) << 9);
	output[56] = (double)(value >> 16);

	// read output[57]: from bit 913 to 928
	value = ((uint32_t)(input[114] & 0x7f) << 25) |
			((uint32_t)input[115] << 17) |
			((uint32_t)(input[116] & 0x80) << 9);
	output[57] = (double)(value >> 16);

	// read output[58]: from bit 929 to 944
	value = ((uint32_t)(input[116] & 0x7f) << 25) |
			((uint32_t)input[117] << 17) |
			((uint32_t)(input[118] & 0x80) << 9);
	output[58] = (double)(value >> 16);

	// read output[59]: from bit 945 to 960
	value = ((uint32_t)(input[118] & 0x7f) << 25) |
			((uint32_t)input[119] << 17) |
			((uint32_t)(input[120] & 0x80) << 9);
	output[59] = (double)(value >> 16);

	// read output[60]: from bit 961 to 976
	value = ((uint32_t)(input[120] & 0x7f) << 25) |
			((uint32_t)input[121] << 17) |
			((uint32_t)(input[122] & 0x80) << 9);
	output[60] = (double)(value >> 16);

	// read output[61]: from bit 977 to 992
	value = ((uint32_t)(input[122] & 0x7f) << 25) |
			((uint32_t)input[123] << 17) |
			((uint32_t)(input[124] & 0x80) << 9);
	output[61] = (double)(value >> 16);
}

static void unpack_62_16bit_signed_2off(const uint8_t * input, double * output, void *closure) {
	// Unpack 62 values into output
	// Values are 16-bit signed
	// Skip 2 bits, read 992 bits of data.
	// Input must be at least 125 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 2 to 17
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)input[1] << 18) |
			((uint32_t)(input[2] & 0xc0) << 10);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 18 to 33
	value = ((uint32_t)(input[2] & 0x3f) << 26) |
			((uint32_t)input[3] << 18) |
			((uint32_t)(input[4] & 0xc0) << 10);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 34 to 49
	value = ((uint32_t)(input[4] & 0x3f) << 26) |
			((uint32_t)input[5] << 18) |
			((uint32_t)(input[6] & 0xc0) << 10);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 50 to 65
	value = ((uint32_t)(input[6] & 0x3f) << 26) |
			((uint32_t)input[7] << 18) |
			((uint32_t)(input[8] & 0xc0) << 10);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 66 to 81
	value = ((uint32_t)(input[8] & 0x3f) << 26) |
			((uint32_t)input[9] << 18) |
			((uint32_t)(input[10] & 0xc0) << 10);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 82 to 97
	value = ((uint32_t)(input[10] & 0x3f) << 26) |
			((uint32_t)input[11] << 18) |
			((uint32_t)(input[12] & 0xc0) << 10);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 98 to 113
	value = ((uint32_t)(input[12] & 0x3f) << 26) |
			((uint32_t)input[13] << 18) |
			((uint32_t)(input[14] & 0xc0) << 10);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 114 to 129
	value = ((uint32_t)(input[14] & 0x3f) << 26) |
			((uint32_t)input[15] << 18) |
			((uint32_t)(input[16] & 0xc0) << 10);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 130 to 145
	value = ((uint32_t)(input[16] & 0x3f) << 26) |
			((uint32_t)input[17] << 18) |
			((uint32_t)(input[18] & 0xc0) << 10);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 146 to 161
	value = ((uint32_t)(input[18] & 0x3f) << 26) |
			((uint32_t)input[19] << 18) |
			((uint32_t)(input[20] & 0xc0) << 10);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 162 to 177
	value = ((uint32_t)(input[20] & 0x3f) << 26) |
			((uint32_t)input[21] << 18) |
			((uint32_t)(input[22] & 0xc0) << 10);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 178 to 193
	value = ((uint32_t)(input[22] & 0x3f) << 26) |
			((uint32_t)input[23] << 18) |
			((uint32_t)(input[24] & 0xc0) << 10);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 194 to 209
	value = ((uint32_t)(input[24] & 0x3f) << 26) |
			((uint32_t)input[25] << 18) |
			((uint32_t)(input[26] & 0xc0) << 10);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 210 to 225
	value = ((uint32_t)(input[26] & 0x3f) << 26) |
			((uint32_t)input[27] << 18) |
			((uint32_t)(input[28] & 0xc0) << 10);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 226 to 241
	value = ((uint32_t)(input[28] & 0x3f) << 26) |
			((uint32_t)input[29] << 18) |
			((uint32_t)(input[30] & 0xc0) << 10);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 242 to 257
	value = ((uint32_t)(input[30] & 0x3f) << 26) |
			((uint32_t)input[31] << 18) |
			((uint32_t)(input[32] & 0xc0) << 10);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 258 to 273
	value = ((uint32_t)(input[32] & 0x3f) << 26) |
			((uint32_t)input[33] << 18) |
			((uint32_t)(input[34] & 0xc0) << 10);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 274 to 289
	value = ((uint32_t)(input[34] & 0x3f) << 26) |
			((uint32_t)input[35] << 18) |
			((uint32_t)(input[36] & 0xc0) << 10);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 290 to 305
	value = ((uint32_t)(input[36] & 0x3f) << 26) |
			((uint32_t)input[37] << 18) |
			((uint32_t)(input[38] & 0xc0) << 10);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 306 to 321
	value = ((uint32_t)(input[38] & 0x3f) << 26) |
			((uint32_t)input[39] << 18) |
			((uint32_t)(input[40] & 0xc0) << 10);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 322 to 337
	value = ((uint32_t)(input[40] & 0x3f) << 26) |
			((uint32_t)input[41] << 18) |
			((uint32_t)(input[42] & 0xc0) << 10);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 338 to 353
	value = ((uint32_t)(input[42] & 0x3f) << 26) |
			((uint32_t)input[43] << 18) |
			((uint32_t)(input[44] & 0xc0) << 10);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 354 to 369
	value = ((uint32_t)(input[44] & 0x3f) << 26) |
			((uint32_t)input[45] << 18) |
			((uint32_t)(input[46] & 0xc0) << 10);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 370 to 385
	value = ((uint32_t)(input[46] & 0x3f) << 26) |
			((uint32_t)input[47] << 18) |
			((uint32_t)(input[48] & 0xc0) << 10);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 386 to 401
	value = ((uint32_t)(input[48] & 0x3f) << 26) |
			((uint32_t)input[49] << 18) |
			((uint32_t)(input[50] & 0xc0) << 10);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 402 to 417
	value = ((uint32_t)(input[50] & 0x3f) << 26) |
			((uint32_t)input[51] << 18) |
			((uint32_t)(input[52] & 0xc0) << 10);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 418 to 433
	value = ((uint32_t)(input[52] & 0x3f) << 26) |
			((uint32_t)input[53] << 18) |
			((uint32_t)(input[54] & 0xc0) << 10);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 434 to 449
	value = ((uint32_t)(input[54] & 0x3f) << 26) |
			((uint32_t)input[55] << 18) |
			((uint32_t)(input[56] & 0xc0) << 10);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 450 to 465
	value = ((uint32_t)(input[56] & 0x3f) << 26) |
			((uint32_t)input[57] << 18) |
			((uint32_t)(input[58] & 0xc0) << 10);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 466 to 481
	value = ((uint32_t)(input[58] & 0x3f) << 26) |
			((uint32_t)input[59] << 18) |
			((uint32_t)(input[60] & 0xc0) << 10);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 482 to 497
	value = ((uint32_t)(input[60] & 0x3f) << 26) |
			((uint32_t)input[61] << 18) |
			((uint32_t)(input[62] & 0xc0) << 10);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 498 to 513
	value = ((uint32_t)(input[62] & 0x3f) << 26) |
			((uint32_t)input[63] << 18) |
			((uint32_t)(input[64] & 0xc0) << 10);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 514 to 529
	value = ((uint32_t)(input[64] & 0x3f) << 26) |
			((uint32_t)input[65] << 18) |
			((uint32_t)(input[66] & 0xc0) << 10);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 530 to 545
	value = ((uint32_t)(input[66] & 0x3f) << 26) |
			((uint32_t)input[67] << 18) |
			((uint32_t)(input[68] & 0xc0) << 10);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 546 to 561
	value = ((uint32_t)(input[68] & 0x3f) << 26) |
			((uint32_t)input[69] << 18) |
			((uint32_t)(input[70] & 0xc0) << 10);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 562 to 577
	value = ((uint32_t)(input[70] & 0x3f) << 26) |
			((uint32_t)input[71] << 18) |
			((uint32_t)(input[72] & 0xc0) << 10);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 578 to 593
	value = ((uint32_t)(input[72] & 0x3f) << 26) |
			((uint32_t)input[73] << 18) |
			((uint32_t)(input[74] & 0xc0) << 10);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 594 to 609
	value = ((uint32_t)(input[74] & 0x3f) << 26) |
			((uint32_t)input[75] << 18) |
			((uint32_t)(input[76] & 0xc0) << 10);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 610 to 625
	value = ((uint32_t)(input[76] & 0x3f) << 26) |
			((uint32_t)input[77] << 18) |
			((uint32_t)(input[78] & 0xc0) << 10);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 626 to 641
	value = ((uint32_t)(input[78] & 0x3f) << 26) |
			((uint32_t)input[79] << 18) |
			((uint32_t)(input[80] & 0xc0) << 10);
	output[39] = (double)(value >> 16);

	// read output[40]: from bit 642 to 657
	value = ((uint32_t)(input[80] & 0x3f) << 26) |
			((uint32_t)input[81] << 18) |
			((uint32_t)(input[82] & 0xc0) << 10);
	output[40] = (double)(value >> 16);

	// read output[41]: from bit 658 to 673
	value = ((uint32_t)(input[82] & 0x3f) << 26) |
			((uint32_t)input[83] << 18) |
			((uint32_t)(input[84] & 0xc0) << 10);
	output[41] = (double)(value >> 16);

	// read output[42]: from bit 674 to 689
	value = ((uint32_t)(input[84] & 0x3f) << 26) |
			((uint32_t)input[85] << 18) |
			((uint32_t)(input[86] & 0xc0) << 10);
	output[42] = (double)(value >> 16);

	// read output[43]: from bit 690 to 705
	value = ((uint32_t)(input[86] & 0x3f) << 26) |
			((uint32_t)input[87] << 18) |
			((uint32_t)(input[88] & 0xc0) << 10);
	output[43] = (double)(value >> 16);

	// read output[44]: from bit 706 to 721
	value = ((uint32_t)(input[88] & 0x3f) << 26) |
			((uint32_t)input[89] << 18) |
			((uint32_t)(input[90] & 0xc0) << 10);
	output[44] = (double)(value >> 16);

	// read output[45]: from bit 722 to 737
	value = ((uint32_t)(input[90] & 0x3f) << 26) |
			((uint32_t)input[91] << 18) |
			((uint32_t)(input[92] & 0xc0) << 10);
	output[45] = (double)(value >> 16);

	// read output[46]: from bit 738 to 753
	value = ((uint32_t)(input[92] & 0x3f) << 26) |
			((uint32_t)input[93] << 18) |
			((uint32_t)(input[94] & 0xc0) << 10);
	output[46] = (double)(value >> 16);

	// read output[47]: from bit 754 to 769
	value = ((uint32_t)(input[94] & 0x3f) << 26) |
			((uint32_t)input[95] << 18) |
			((uint32_t)(input[96] & 0xc0) << 10);
	output[47] = (double)(value >> 16);

	// read output[48]: from bit 770 to 785
	value = ((uint32_t)(input[96] & 0x3f) << 26) |
			((uint32_t)input[97] << 18) |
			((uint32_t)(input[98] & 0xc0) << 10);
	output[48] = (double)(value >> 16);

	// read output[49]: from bit 786 to 801
	value = ((uint32_t)(input[98] & 0x3f) << 26) |
			((uint32_t)input[99] << 18) |
			((uint32_t)(input[100] & 0xc0) << 10);
	output[49] = (double)(value >> 16);

	// read output[50]: from bit 802 to 817
	value = ((uint32_t)(input[100] & 0x3f) << 26) |
			((uint32_t)input[101] << 18) |
			((uint32_t)(input[102] & 0xc0) << 10);
	output[50] = (double)(value >> 16);

	// read output[51]: from bit 818 to 833
	value = ((uint32_t)(input[102] & 0x3f) << 26) |
			((uint32_t)input[103] << 18) |
			((uint32_t)(input[104] & 0xc0) << 10);
	output[51] = (double)(value >> 16);

	// read output[52]: from bit 834 to 849
	value = ((uint32_t)(input[104] & 0x3f) << 26) |
			((uint32_t)input[105] << 18) |
			((uint32_t)(input[106] & 0xc0) << 10);
	output[52] = (double)(value >> 16);

	// read output[53]: from bit 850 to 865
	value = ((uint32_t)(input[106] & 0x3f) << 26) |
			((uint32_t)input[107] << 18) |
			((uint32_t)(input[108] & 0xc0) << 10);
	output[53] = (double)(value >> 16);

	// read output[54]: from bit 866 to 881
	value = ((uint32_t)(input[108] & 0x3f) << 26) |
			((uint32_t)input[109] << 18) |
			((uint32_t)(input[110] & 0xc0) << 10);
	output[54] = (double)(value >> 16);

	// read output[55]: from bit 882 to 897
	value = ((uint32_t)(input[110] & 0x3f) << 26) |
			((uint32_t)input[111] << 18) |
			((uint32_t)(input[112] & 0xc0) << 10);
	output[55] = (double)(value >> 16);

	// read output[56]: from bit 898 to 913
	value = ((uint32_t)(input[112] & 0x3f) << 26) |
			((uint32_t)input[113] << 18) |
			((uint32_t)(input[114] & 0xc0) << 10);
	output[56] = (double)(value >> 16);

	// read output[57]: from bit 914 to 929
	value = ((uint32_t)(input[114] & 0x3f) << 26) |
			((uint32_t)input[115] << 18) |
			((uint32_t)(input[116] & 0xc0) << 10);
	output[57] = (double)(value >> 16);

	// read output[58]: from bit 930 to 945
	value = ((uint32_t)(input[116] & 0x3f) << 26) |
			((uint32_t)input[117] << 18) |
			((uint32_t)(input[118] & 0xc0) << 10);
	output[58] = (double)(value >> 16);

	// read output[59]: from bit 946 to 961
	value = ((uint32_t)(input[118] & 0x3f) << 26) |
			((uint32_t)input[119] << 18) |
			((uint32_t)(input[120] & 0xc0) << 10);
	output[59] = (double)(value >> 16);

	// read output[60]: from bit 962 to 977
	value = ((uint32_t)(input[120] & 0x3f) << 26) |
			((uint32_t)input[121] << 18) |
			((uint32_t)(input[122] & 0xc0) << 10);
	output[60] = (double)(value >> 16);

	// read output[61]: from bit 978 to 993
	value = ((uint32_t)(input[122] & 0x3f) << 26) |
			((uint32_t)input[123] << 18) |
			((uint32_t)(input[124] & 0xc0) << 10);
	output[61] = (double)(value >> 16);
}

static void unpack_62_16bit_unsigned_2off(const uint8_t * input, double * output, void *closure) {
	// Unpack 62 values into output
	// Values are 16-bit unsigned
	// Skip 2 bits, read 992 bits of data.
	// Input must be at least 125 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 2 to 17
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)input[1] << 18) |
			((uint32_t)(input[2] & 0xc0) << 10);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 18 to 33
	value = ((uint32_t)(input[2] & 0x3f) << 26) |
			((uint32_t)input[3] << 18) |
			((uint32_t)(input[4] & 0xc0) << 10);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 34 to 49
	value = ((uint32_t)(input[4] & 0x3f) << 26) |
			((uint32_t)input[5] << 18) |
			((uint32_t)(input[6] & 0xc0) << 10);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 50 to 65
	value = ((uint32_t)(input[6] & 0x3f) << 26) |
			((uint32_t)input[7] << 18) |
			((uint32_t)(input[8] & 0xc0) << 10);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 66 to 81
	value = ((uint32_t)(input[8] & 0x3f) << 26) |
			((uint32_t)input[9] << 18) |
			((uint32_t)(input[10] & 0xc0) << 10);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 82 to 97
	value = ((uint32_t)(input[10] & 0x3f) << 26) |
			((uint32_t)input[11] << 18) |
			((uint32_t)(input[12] & 0xc0) << 10);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 98 to 113
	value = ((uint32_t)(input[12] & 0x3f) << 26) |
			((uint32_t)input[13] << 18) |
			((uint32_t)(input[14] & 0xc0) << 10);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 114 to 129
	value = ((uint32_t)(input[14] & 0x3f) << 26) |
			((uint32_t)input[15] << 18) |
			((uint32_t)(input[16] & 0xc0) << 10);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 130 to 145
	value = ((uint32_t)(input[16] & 0x3f) << 26) |
			((uint32_t)input[17] << 18) |
			((uint32_t)(input[18] & 0xc0) << 10);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 146 to 161
	value = ((uint32_t)(input[18] & 0x3f) << 26) |
			((uint32_t)input[19] << 18) |
			((uint32_t)(input[20] & 0xc0) << 10);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 162 to 177
	value = ((uint32_t)(input[20] & 0x3f) << 26) |
			((uint32_t)input[21] << 18) |
			((uint32_t)(input[22] & 0xc0) << 10);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 178 to 193
	value = ((uint32_t)(input[22] & 0x3f) << 26) |
			((uint32_t)input[23] << 18) |
			((uint32_t)(input[24] & 0xc0) << 10);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 194 to 209
	value = ((uint32_t)(input[24] & 0x3f) << 26) |
			((uint32_t)input[25] << 18) |
			((uint32_t)(input[26] & 0xc0) << 10);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 210 to 225
	value = ((uint32_t)(input[26] & 0x3f) << 26) |
			((uint32_t)input[27] << 18) |
			((uint32_t)(input[28] & 0xc0) << 10);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 226 to 241
	value = ((uint32_t)(input[28] & 0x3f) << 26) |
			((uint32_t)input[29] << 18) |
			((uint32_t)(input[30] & 0xc0) << 10);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 242 to 257
	value = ((uint32_t)(input[30] & 0x3f) << 26) |
			((uint32_t)input[31] << 18) |
			((uint32_t)(input[32] & 0xc0) << 10);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 258 to 273
	value = ((uint32_t)(input[32] & 0x3f) << 26) |
			((uint32_t)input[33] << 18) |
			((uint32_t)(input[34] & 0xc0) << 10);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 274 to 289
	value = ((uint32_t)(input[34] & 0x3f) << 26) |
			((uint32_t)input[35] << 18) |
			((uint32_t)(input[36] & 0xc0) << 10);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 290 to 305
	value = ((uint32_t)(input[36] & 0x3f) << 26) |
			((uint32_t)input[37] << 18) |
			((uint32_t)(input[38] & 0xc0) << 10);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 306 to 321
	value = ((uint32_t)(input[38] & 0x3f) << 26) |
			((uint32_t)input[39] << 18) |
			((uint32_t)(input[40] & 0xc0) << 10);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 322 to 337
	value = ((uint32_t)(input[40] & 0x3f) << 26) |
			((uint32_t)input[41] << 18) |
			((uint32_t)(input[42] & 0xc0) << 10);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 338 to 353
	value = ((uint32_t)(input[42] & 0x3f) << 26) |
			((uint32_t)input[43] << 18) |
			((uint32_t)(input[44] & 0xc0) << 10);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 354 to 369
	value = ((uint32_t)(input[44] & 0x3f) << 26) |
			((uint32_t)input[45] << 18) |
			((uint32_t)(input[46] & 0xc0) << 10);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 370 to 385
	value = ((uint32_t)(input[46] & 0x3f) << 26) |
			((uint32_t)input[47] << 18) |
			((uint32_t)(input[48] & 0xc0) << 10);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 386 to 401
	value = ((uint32_t)(input[48] & 0x3f) << 26) |
			((uint32_t)input[49] << 18) |
			((uint32_t)(input[50] & 0xc0) << 10);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 402 to 417
	value = ((uint32_t)(input[50] & 0x3f) << 26) |
			((uint32_t)input[51] << 18) |
			((uint32_t)(input[52] & 0xc0) << 10);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 418 to 433
	value = ((uint32_t)(input[52] & 0x3f) << 26) |
			((uint32_t)input[53] << 18) |
			((uint32_t)(input[54] & 0xc0) << 10);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 434 to 449
	value = ((uint32_t)(input[54] & 0x3f) << 26) |
			((uint32_t)input[55] << 18) |
			((uint32_t)(input[56] & 0xc0) << 10);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 450 to 465
	value = ((uint32_t)(input[56] & 0x3f) << 26) |
			((uint32_t)input[57] << 18) |
			((uint32_t)(input[58] & 0xc0) << 10);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 466 to 481
	value = ((uint32_t)(input[58] & 0x3f) << 26) |
			((uint32_t)input[59] << 18) |
			((uint32_t)(input[60] & 0xc0) << 10);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 482 to 497
	value = ((uint32_t)(input[60] & 0x3f) << 26) |
			((uint32_t)input[61] << 18) |
			((uint32_t)(input[62] & 0xc0) << 10);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 498 to 513
	value = ((uint32_t)(input[62] & 0x3f) << 26) |
			((uint32_t)input[63] << 18) |
			((uint32_t)(input[64] & 0xc0) << 10);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 514 to 529
	value = ((uint32_t)(input[64] & 0x3f) << 26) |
			((uint32_t)input[65] << 18) |
			((uint32_t)(input[66] & 0xc0) << 10);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 530 to 545
	value = ((uint32_t)(input[66] & 0x3f) << 26) |
			((uint32_t)input[67] << 18) |
			((uint32_t)(input[68] & 0xc0) << 10);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 546 to 561
	value = ((uint32_t)(input[68] & 0x3f) << 26) |
			((uint32_t)input[69] << 18) |
			((uint32_t)(input[70] & 0xc0) << 10);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 562 to 577
	value = ((uint32_t)(input[70] & 0x3f) << 26) |
			((uint32_t)input[71] << 18) |
			((uint32_t)(input[72] & 0xc0) << 10);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 578 to 593
	value = ((uint32_t)(input[72] & 0x3f) << 26) |
			((uint32_t)input[73] << 18) |
			((uint32_t)(input[74] & 0xc0) << 10);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 594 to 609
	value = ((uint32_t)(input[74] & 0x3f) << 26) |
			((uint32_t)input[75] << 18) |
			((uint32_t)(input[76] & 0xc0) << 10);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 610 to 625
	value = ((uint32_t)(input[76] & 0x3f) << 26) |
			((uint32_t)input[77] << 18) |
			((uint32_t)(input[78] & 0xc0) << 10);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 626 to 641
	value = ((uint32_t)(input[78] & 0x3f) << 26) |
			((uint32_t)input[79] << 18) |
			((uint32_t)(input[80] & 0xc0) << 10);
	output[39] = (double)(value >> 16);

	// read output[40]: from bit 642 to 657
	value = ((uint32_t)(input[80] & 0x3f) << 26) |
			((uint32_t)input[81] << 18) |
			((uint32_t)(input[82] & 0xc0) << 10);
	output[40] = (double)(value >> 16);

	// read output[41]: from bit 658 to 673
	value = ((uint32_t)(input[82] & 0x3f) << 26) |
			((uint32_t)input[83] << 18) |
			((uint32_t)(input[84] & 0xc0) << 10);
	output[41] = (double)(value >> 16);

	// read output[42]: from bit 674 to 689
	value = ((uint32_t)(input[84] & 0x3f) << 26) |
			((uint32_t)input[85] << 18) |
			((uint32_t)(input[86] & 0xc0) << 10);
	output[42] = (double)(value >> 16);

	// read output[43]: from bit 690 to 705
	value = ((uint32_t)(input[86] & 0x3f) << 26) |
			((uint32_t)input[87] << 18) |
			((uint32_t)(input[88] & 0xc0) << 10);
	output[43] = (double)(value >> 16);

	// read output[44]: from bit 706 to 721
	value = ((uint32_t)(input[88] & 0x3f) << 26) |
			((uint32_t)input[89] << 18) |
			((uint32_t)(input[90] & 0xc0) << 10);
	output[44] = (double)(value >> 16);

	// read output[45]: from bit 722 to 737
	value = ((uint32_t)(input[90] & 0x3f) << 26) |
			((uint32_t)input[91] << 18) |
			((uint32_t)(input[92] & 0xc0) << 10);
	output[45] = (double)(value >> 16);

	// read output[46]: from bit 738 to 753
	value = ((uint32_t)(input[92] & 0x3f) << 26) |
			((uint32_t)input[93] << 18) |
			((uint32_t)(input[94] & 0xc0) << 10);
	output[46] = (double)(value >> 16);

	// read output[47]: from bit 754 to 769
	value = ((uint32_t)(input[94] & 0x3f) << 26) |
			((uint32_t)input[95] << 18) |
			((uint32_t)(input[96] & 0xc0) << 10);
	output[47] = (double)(value >> 16);

	// read output[48]: from bit 770 to 785
	value = ((uint32_t)(input[96] & 0x3f) << 26) |
			((uint32_t)input[97] << 18) |
			((uint32_t)(input[98] & 0xc0) << 10);
	output[48] = (double)(value >> 16);

	// read output[49]: from bit 786 to 801
	value = ((uint32_t)(input[98] & 0x3f) << 26) |
			((uint32_t)input[99] << 18) |
			((uint32_t)(input[100] & 0xc0) << 10);
	output[49] = (double)(value >> 16);

	// read output[50]: from bit 802 to 817
	value = ((uint32_t)(input[100] & 0x3f) << 26) |
			((uint32_t)input[101] << 18) |
			((uint32_t)(input[102] & 0xc0) << 10);
	output[50] = (double)(value >> 16);

	// read output[51]: from bit 818 to 833
	value = ((uint32_t)(input[102] & 0x3f) << 26) |
			((uint32_t)input[103] << 18) |
			((uint32_t)(input[104] & 0xc0) << 10);
	output[51] = (double)(value >> 16);

	// read output[52]: from bit 834 to 849
	value = ((uint32_t)(input[104] & 0x3f) << 26) |
			((uint32_t)input[105] << 18) |
			((uint32_t)(input[106] & 0xc0) << 10);
	output[52] = (double)(value >> 16);

	// read output[53]: from bit 850 to 865
	value = ((uint32_t)(input[106] & 0x3f) << 26) |
			((uint32_t)input[107] << 18) |
			((uint32_t)(input[108] & 0xc0) << 10);
	output[53] = (double)(value >> 16);

	// read output[54]: from bit 866 to 881
	value = ((uint32_t)(input[108] & 0x3f) << 26) |
			((uint32_t)input[109] << 18) |
			((uint32_t)(input[110] & 0xc0) << 10);
	output[54] = (double)(value >> 16);

	// read output[55]: from bit 882 to 897
	value = ((uint32_t)(input[110] & 0x3f) << 26) |
			((uint32_t)input[111] << 18) |
			((uint32_t)(input[112] & 0xc0) << 10);
	output[55] = (double)(value >> 16);

	// read output[56]: from bit 898 to 913
	value = ((uint32_t)(input[112] & 0x3f) << 26) |
			((uint32_t)input[113] << 18) |
			((uint32_t)(input[114] & 0xc0) << 10);
	output[56] = (double)(value >> 16);

	// read output[57]: from bit 914 to 929
	value = ((uint32_t)(input[114] & 0x3f) << 26) |
			((uint32_t)input[115] << 18) |
			((uint32_t)(input[116] & 0xc0) << 10);
	output[57] = (double)(value >> 16);

	// read output[58]: from bit 930 to 945
	value = ((uint32_t)(input[116] & 0x3f) << 26) |
			((uint32_t)input[117] << 18) |
			((uint32_t)(input[118] & 0xc0) << 10);
	output[58] = (double)(value >> 16);

	// read output[59]: from bit 946 to 961
	value = ((uint32_t)(input[118] & 0x3f) << 26) |
			((uint32_t)input[119] << 18) |
			((uint32_t)(input[120] & 0xc0) << 10);
	output[59] = (double)(value >> 16);

	// read output[60]: from bit 962 to 977
	value = ((uint32_t)(input[120] & 0x3f) << 26) |
			((uint32_t)input[121] << 18) |
			((uint32_t)(input[122] & 0xc0) << 10);
	output[60] = (double)(value >> 16);

	// read output[61]: from bit 978 to 993
	value = ((uint32_t)(input[122] & 0x3f) << 26) |
			((uint32_t)input[123] << 18) |
			((uint32_t)(input[124] & 0xc0) << 10);
	output[61] = (double)(value >> 16);
}

static void unpack_62_16bit_signed_3off(const uint8_t * input, double * output, void *closure) {
	// Unpack 62 values into output
	// Values are 16-bit signed
	// Skip 3 bits, read 992 bits of data.
	// Input must be at least 125 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 3 to 18
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)input[1] << 19) |
			((uint32_t)(input[2] & 0xe0) << 11);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 19 to 34
	value = ((uint32_t)(input[2] & 0x1f) << 27) |
			((uint32_t)input[3] << 19) |
			((uint32_t)(input[4] & 0xe0) << 11);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 35 to 50
	value = ((uint32_t)(input[4] & 0x1f) << 27) |
			((uint32_t)input[5] << 19) |
			((uint32_t)(input[6] & 0xe0) << 11);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 51 to 66
	value = ((uint32_t)(input[6] & 0x1f) << 27) |
			((uint32_t)input[7] << 19) |
			((uint32_t)(input[8] & 0xe0) << 11);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 67 to 82
	value = ((uint32_t)(input[8] & 0x1f) << 27) |
			((uint32_t)input[9] << 19) |
			((uint32_t)(input[10] & 0xe0) << 11);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 83 to 98
	value = ((uint32_t)(input[10] & 0x1f) << 27) |
			((uint32_t)input[11] << 19) |
			((uint32_t)(input[12] & 0xe0) << 11);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 99 to 114
	value = ((uint32_t)(input[12] & 0x1f) << 27) |
			((uint32_t)input[13] << 19) |
			((uint32_t)(input[14] & 0xe0) << 11);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 115 to 130
	value = ((uint32_t)(input[14] & 0x1f) << 27) |
			((uint32_t)input[15] << 19) |
			((uint32_t)(input[16] & 0xe0) << 11);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 131 to 146
	value = ((uint32_t)(input[16] & 0x1f) << 27) |
			((uint32_t)input[17] << 19) |
			((uint32_t)(input[18] & 0xe0) << 11);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 147 to 162
	value = ((uint32_t)(input[18] & 0x1f) << 27) |
			((uint32_t)input[19] << 19) |
			((uint32_t)(input[20] & 0xe0) << 11);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 163 to 178
	value = ((uint32_t)(input[20] & 0x1f) << 27) |
			((uint32_t)input[21] << 19) |
			((uint32_t)(input[22] & 0xe0) << 11);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 179 to 194
	value = ((uint32_t)(input[22] & 0x1f) << 27) |
			((uint32_t)input[23] << 19) |
			((uint32_t)(input[24] & 0xe0) << 11);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 195 to 210
	value = ((uint32_t)(input[24] & 0x1f) << 27) |
			((uint32_t)input[25] << 19) |
			((uint32_t)(input[26] & 0xe0) << 11);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 211 to 226
	value = ((uint32_t)(input[26] & 0x1f) << 27) |
			((uint32_t)input[27] << 19) |
			((uint32_t)(input[28] & 0xe0) << 11);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 227 to 242
	value = ((uint32_t)(input[28] & 0x1f) << 27) |
			((uint32_t)input[29] << 19) |
			((uint32_t)(input[30] & 0xe0) << 11);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 243 to 258
	value = ((uint32_t)(input[30] & 0x1f) << 27) |
			((uint32_t)input[31] << 19) |
			((uint32_t)(input[32] & 0xe0) << 11);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 259 to 274
	value = ((uint32_t)(input[32] & 0x1f) << 27) |
			((uint32_t)input[33] << 19) |
			((uint32_t)(input[34] & 0xe0) << 11);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 275 to 290
	value = ((uint32_t)(input[34] & 0x1f) << 27) |
			((uint32_t)input[35] << 19) |
			((uint32_t)(input[36] & 0xe0) << 11);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 291 to 306
	value = ((uint32_t)(input[36] & 0x1f) << 27) |
			((uint32_t)input[37] << 19) |
			((uint32_t)(input[38] & 0xe0) << 11);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 307 to 322
	value = ((uint32_t)(input[38] & 0x1f) << 27) |
			((uint32_t)input[39] << 19) |
			((uint32_t)(input[40] & 0xe0) << 11);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 323 to 338
	value = ((uint32_t)(input[40] & 0x1f) << 27) |
			((uint32_t)input[41] << 19) |
			((uint32_t)(input[42] & 0xe0) << 11);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 339 to 354
	value = ((uint32_t)(input[42] & 0x1f) << 27) |
			((uint32_t)input[43] << 19) |
			((uint32_t)(input[44] & 0xe0) << 11);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 355 to 370
	value = ((uint32_t)(input[44] & 0x1f) << 27) |
			((uint32_t)input[45] << 19) |
			((uint32_t)(input[46] & 0xe0) << 11);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 371 to 386
	value = ((uint32_t)(input[46] & 0x1f) << 27) |
			((uint32_t)input[47] << 19) |
			((uint32_t)(input[48] & 0xe0) << 11);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 387 to 402
	value = ((uint32_t)(input[48] & 0x1f) << 27) |
			((uint32_t)input[49] << 19) |
			((uint32_t)(input[50] & 0xe0) << 11);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 403 to 418
	value = ((uint32_t)(input[50] & 0x1f) << 27) |
			((uint32_t)input[51] << 19) |
			((uint32_t)(input[52] & 0xe0) << 11);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 419 to 434
	value = ((uint32_t)(input[52] & 0x1f) << 27) |
			((uint32_t)input[53] << 19) |
			((uint32_t)(input[54] & 0xe0) << 11);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 435 to 450
	value = ((uint32_t)(input[54] & 0x1f) << 27) |
			((uint32_t)input[55] << 19) |
			((uint32_t)(input[56] & 0xe0) << 11);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 451 to 466
	value = ((uint32_t)(input[56] & 0x1f) << 27) |
			((uint32_t)input[57] << 19) |
			((uint32_t)(input[58] & 0xe0) << 11);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 467 to 482
	value = ((uint32_t)(input[58] & 0x1f) << 27) |
			((uint32_t)input[59] << 19) |
			((uint32_t)(input[60] & 0xe0) << 11);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 483 to 498
	value = ((uint32_t)(input[60] & 0x1f) << 27) |
			((uint32_t)input[61] << 19) |
			((uint32_t)(input[62] & 0xe0) << 11);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 499 to 514
	value = ((uint32_t)(input[62] & 0x1f) << 27) |
			((uint32_t)input[63] << 19) |
			((uint32_t)(input[64] & 0xe0) << 11);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 515 to 530
	value = ((uint32_t)(input[64] & 0x1f) << 27) |
			((uint32_t)input[65] << 19) |
			((uint32_t)(input[66] & 0xe0) << 11);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 531 to 546
	value = ((uint32_t)(input[66] & 0x1f) << 27) |
			((uint32_t)input[67] << 19) |
			((uint32_t)(input[68] & 0xe0) << 11);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 547 to 562
	value = ((uint32_t)(input[68] & 0x1f) << 27) |
			((uint32_t)input[69] << 19) |
			((uint32_t)(input[70] & 0xe0) << 11);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 563 to 578
	value = ((uint32_t)(input[70] & 0x1f) << 27) |
			((uint32_t)input[71] << 19) |
			((uint32_t)(input[72] & 0xe0) << 11);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 579 to 594
	value = ((uint32_t)(input[72] & 0x1f) << 27) |
			((uint32_t)input[73] << 19) |
			((uint32_t)(input[74] & 0xe0) << 11);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 595 to 610
	value = ((uint32_t)(input[74] & 0x1f) << 27) |
			((uint32_t)input[75] << 19) |
			((uint32_t)(input[76] & 0xe0) << 11);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 611 to 626
	value = ((uint32_t)(input[76] & 0x1f) << 27) |
			((uint32_t)input[77] << 19) |
			((uint32_t)(input[78] & 0xe0) << 11);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 627 to 642
	value = ((uint32_t)(input[78] & 0x1f) << 27) |
			((uint32_t)input[79] << 19) |
			((uint32_t)(input[80] & 0xe0) << 11);
	output[39] = (double)(value >> 16);

	// read output[40]: from bit 643 to 658
	value = ((uint32_t)(input[80] & 0x1f) << 27) |
			((uint32_t)input[81] << 19) |
			((uint32_t)(input[82] & 0xe0) << 11);
	output[40] = (double)(value >> 16);

	// read output[41]: from bit 659 to 674
	value = ((uint32_t)(input[82] & 0x1f) << 27) |
			((uint32_t)input[83] << 19) |
			((uint32_t)(input[84] & 0xe0) << 11);
	output[41] = (double)(value >> 16);

	// read output[42]: from bit 675 to 690
	value = ((uint32_t)(input[84] & 0x1f) << 27) |
			((uint32_t)input[85] << 19) |
			((uint32_t)(input[86] & 0xe0) << 11);
	output[42] = (double)(value >> 16);

	// read output[43]: from bit 691 to 706
	value = ((uint32_t)(input[86] & 0x1f) << 27) |
			((uint32_t)input[87] << 19) |
			((uint32_t)(input[88] & 0xe0) << 11);
	output[43] = (double)(value >> 16);

	// read output[44]: from bit 707 to 722
	value = ((uint32_t)(input[88] & 0x1f) << 27) |
			((uint32_t)input[89] << 19) |
			((uint32_t)(input[90] & 0xe0) << 11);
	output[44] = (double)(value >> 16);

	// read output[45]: from bit 723 to 738
	value = ((uint32_t)(input[90] & 0x1f) << 27) |
			((uint32_t)input[91] << 19) |
			((uint32_t)(input[92] & 0xe0) << 11);
	output[45] = (double)(value >> 16);

	// read output[46]: from bit 739 to 754
	value = ((uint32_t)(input[92] & 0x1f) << 27) |
			((uint32_t)input[93] << 19) |
			((uint32_t)(input[94] & 0xe0) << 11);
	output[46] = (double)(value >> 16);

	// read output[47]: from bit 755 to 770
	value = ((uint32_t)(input[94] & 0x1f) << 27) |
			((uint32_t)input[95] << 19) |
			((uint32_t)(input[96] & 0xe0) << 11);
	output[47] = (double)(value >> 16);

	// read output[48]: from bit 771 to 786
	value = ((uint32_t)(input[96] & 0x1f) << 27) |
			((uint32_t)input[97] << 19) |
			((uint32_t)(input[98] & 0xe0) << 11);
	output[48] = (double)(value >> 16);

	// read output[49]: from bit 787 to 802
	value = ((uint32_t)(input[98] & 0x1f) << 27) |
			((uint32_t)input[99] << 19) |
			((uint32_t)(input[100] & 0xe0) << 11);
	output[49] = (double)(value >> 16);

	// read output[50]: from bit 803 to 818
	value = ((uint32_t)(input[100] & 0x1f) << 27) |
			((uint32_t)input[101] << 19) |
			((uint32_t)(input[102] & 0xe0) << 11);
	output[50] = (double)(value >> 16);

	// read output[51]: from bit 819 to 834
	value = ((uint32_t)(input[102] & 0x1f) << 27) |
			((uint32_t)input[103] << 19) |
			((uint32_t)(input[104] & 0xe0) << 11);
	output[51] = (double)(value >> 16);

	// read output[52]: from bit 835 to 850
	value = ((uint32_t)(input[104] & 0x1f) << 27) |
			((uint32_t)input[105] << 19) |
			((uint32_t)(input[106] & 0xe0) << 11);
	output[52] = (double)(value >> 16);

	// read output[53]: from bit 851 to 866
	value = ((uint32_t)(input[106] & 0x1f) << 27) |
			((uint32_t)input[107] << 19) |
			((uint32_t)(input[108] & 0xe0) << 11);
	output[53] = (double)(value >> 16);

	// read output[54]: from bit 867 to 882
	value = ((uint32_t)(input[108] & 0x1f) << 27) |
			((uint32_t)input[109] << 19) |
			((uint32_t)(input[110] & 0xe0) << 11);
	output[54] = (double)(value >> 16);

	// read output[55]: from bit 883 to 898
	value = ((uint32_t)(input[110] & 0x1f) << 27) |
			((uint32_t)input[111] << 19) |
			((uint32_t)(input[112] & 0xe0) << 11);
	output[55] = (double)(value >> 16);

	// read output[56]: from bit 899 to 914
	value = ((uint32_t)(input[112] & 0x1f) << 27) |
			((uint32_t)input[113] << 19) |
			((uint32_t)(input[114] & 0xe0) << 11);
	output[56] = (double)(value >> 16);

	// read output[57]: from bit 915 to 930
	value = ((uint32_t)(input[114] & 0x1f) << 27) |
			((uint32_t)input[115] << 19) |
			((uint32_t)(input[116] & 0xe0) << 11);
	output[57] = (double)(value >> 16);

	// read output[58]: from bit 931 to 946
	value = ((uint32_t)(input[116] & 0x1f) << 27) |
			((uint32_t)input[117] << 19) |
			((uint32_t)(input[118] & 0xe0) << 11);
	output[58] = (double)(value >> 16);

	// read output[59]: from bit 947 to 962
	value = ((uint32_t)(input[118] & 0x1f) << 27) |
			((uint32_t)input[119] << 19) |
			((uint32_t)(input[120] & 0xe0) << 11);
	output[59] = (double)(value >> 16);

	// read output[60]: from bit 963 to 978
	value = ((uint32_t)(input[120] & 0x1f) << 27) |
			((uint32_t)input[121] << 19) |
			((uint32_t)(input[122] & 0xe0) << 11);
	output[60] = (double)(value >> 16);

	// read output[61]: from bit 979 to 994
	value = ((uint32_t)(input[122] & 0x1f) << 27) |
			((uint32_t)input[123] << 19) |
			((uint32_t)(input[124] & 0xe0) << 11);
	output[61] = (double)(value >> 16);
}

static void unpack_62_16bit_unsigned_3off(const uint8_t * input, double * output, void *closure) {
	// Unpack 62 values into output
	// Values are 16-bit unsigned
	// Skip 3 bits, read 992 bits of data.
	// Input must be at least 125 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 3 to 18
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)input[1] << 19) |
			((uint32_t)(input[2] & 0xe0) << 11);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 19 to 34
	value = ((uint32_t)(input[2] & 0x1f) << 27) |
			((uint32_t)input[3] << 19) |
			((uint32_t)(input[4] & 0xe0) << 11);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 35 to 50
	value = ((uint32_t)(input[4] & 0x1f) << 27) |
			((uint32_t)input[5] << 19) |
			((uint32_t)(input[6] & 0xe0) << 11);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 51 to 66
	value = ((uint32_t)(input[6] & 0x1f) << 27) |
			((uint32_t)input[7] << 19) |
			((uint32_t)(input[8] & 0xe0) << 11);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 67 to 82
	value = ((uint32_t)(input[8] & 0x1f) << 27) |
			((uint32_t)input[9] << 19) |
			((uint32_t)(input[10] & 0xe0) << 11);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 83 to 98
	value = ((uint32_t)(input[10] & 0x1f) << 27) |
			((uint32_t)input[11] << 19) |
			((uint32_t)(input[12] & 0xe0) << 11);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 99 to 114
	value = ((uint32_t)(input[12] & 0x1f) << 27) |
			((uint32_t)input[13] << 19) |
			((uint32_t)(input[14] & 0xe0) << 11);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 115 to 130
	value = ((uint32_t)(input[14] & 0x1f) << 27) |
			((uint32_t)input[15] << 19) |
			((uint32_t)(input[16] & 0xe0) << 11);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 131 to 146
	value = ((uint32_t)(input[16] & 0x1f) << 27) |
			((uint32_t)input[17] << 19) |
			((uint32_t)(input[18] & 0xe0) << 11);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 147 to 162
	value = ((uint32_t)(input[18] & 0x1f) << 27) |
			((uint32_t)input[19] << 19) |
			((uint32_t)(input[20] & 0xe0) << 11);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 163 to 178
	value = ((uint32_t)(input[20] & 0x1f) << 27) |
			((uint32_t)input[21] << 19) |
			((uint32_t)(input[22] & 0xe0) << 11);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 179 to 194
	value = ((uint32_t)(input[22] & 0x1f) << 27) |
			((uint32_t)input[23] << 19) |
			((uint32_t)(input[24] & 0xe0) << 11);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 195 to 210
	value = ((uint32_t)(input[24] & 0x1f) << 27) |
			((uint32_t)input[25] << 19) |
			((uint32_t)(input[26] & 0xe0) << 11);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 211 to 226
	value = ((uint32_t)(input[26] & 0x1f) << 27) |
			((uint32_t)input[27] << 19) |
			((uint32_t)(input[28] & 0xe0) << 11);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 227 to 242
	value = ((uint32_t)(input[28] & 0x1f) << 27) |
			((uint32_t)input[29] << 19) |
			((uint32_t)(input[30] & 0xe0) << 11);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 243 to 258
	value = ((uint32_t)(input[30] & 0x1f) << 27) |
			((uint32_t)input[31] << 19) |
			((uint32_t)(input[32] & 0xe0) << 11);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 259 to 274
	value = ((uint32_t)(input[32] & 0x1f) << 27) |
			((uint32_t)input[33] << 19) |
			((uint32_t)(input[34] & 0xe0) << 11);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 275 to 290
	value = ((uint32_t)(input[34] & 0x1f) << 27) |
			((uint32_t)input[35] << 19) |
			((uint32_t)(input[36] & 0xe0) << 11);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 291 to 306
	value = ((uint32_t)(input[36] & 0x1f) << 27) |
			((uint32_t)input[37] << 19) |
			((uint32_t)(input[38] & 0xe0) << 11);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 307 to 322
	value = ((uint32_t)(input[38] & 0x1f) << 27) |
			((uint32_t)input[39] << 19) |
			((uint32_t)(input[40] & 0xe0) << 11);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 323 to 338
	value = ((uint32_t)(input[40] & 0x1f) << 27) |
			((uint32_t)input[41] << 19) |
			((uint32_t)(input[42] & 0xe0) << 11);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 339 to 354
	value = ((uint32_t)(input[42] & 0x1f) << 27) |
			((uint32_t)input[43] << 19) |
			((uint32_t)(input[44] & 0xe0) << 11);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 355 to 370
	value = ((uint32_t)(input[44] & 0x1f) << 27) |
			((uint32_t)input[45] << 19) |
			((uint32_t)(input[46] & 0xe0) << 11);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 371 to 386
	value = ((uint32_t)(input[46] & 0x1f) << 27) |
			((uint32_t)input[47] << 19) |
			((uint32_t)(input[48] & 0xe0) << 11);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 387 to 402
	value = ((uint32_t)(input[48] & 0x1f) << 27) |
			((uint32_t)input[49] << 19) |
			((uint32_t)(input[50] & 0xe0) << 11);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 403 to 418
	value = ((uint32_t)(input[50] & 0x1f) << 27) |
			((uint32_t)input[51] << 19) |
			((uint32_t)(input[52] & 0xe0) << 11);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 419 to 434
	value = ((uint32_t)(input[52] & 0x1f) << 27) |
			((uint32_t)input[53] << 19) |
			((uint32_t)(input[54] & 0xe0) << 11);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 435 to 450
	value = ((uint32_t)(input[54] & 0x1f) << 27) |
			((uint32_t)input[55] << 19) |
			((uint32_t)(input[56] & 0xe0) << 11);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 451 to 466
	value = ((uint32_t)(input[56] & 0x1f) << 27) |
			((uint32_t)input[57] << 19) |
			((uint32_t)(input[58] & 0xe0) << 11);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 467 to 482
	value = ((uint32_t)(input[58] & 0x1f) << 27) |
			((uint32_t)input[59] << 19) |
			((uint32_t)(input[60] & 0xe0) << 11);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 483 to 498
	value = ((uint32_t)(input[60] & 0x1f) << 27) |
			((uint32_t)input[61] << 19) |
			((uint32_t)(input[62] & 0xe0) << 11);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 499 to 514
	value = ((uint32_t)(input[62] & 0x1f) << 27) |
			((uint32_t)input[63] << 19) |
			((uint32_t)(input[64] & 0xe0) << 11);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 515 to 530
	value = ((uint32_t)(input[64] & 0x1f) << 27) |
			((uint32_t)input[65] << 19) |
			((uint32_t)(input[66] & 0xe0) << 11);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 531 to 546
	value = ((uint32_t)(input[66] & 0x1f) << 27) |
			((uint32_t)input[67] << 19) |
			((uint32_t)(input[68] & 0xe0) << 11);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 547 to 562
	value = ((uint32_t)(input[68] & 0x1f) << 27) |
			((uint32_t)input[69] << 19) |
			((uint32_t)(input[70] & 0xe0) << 11);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 563 to 578
	value = ((uint32_t)(input[70] & 0x1f) << 27) |
			((uint32_t)input[71] << 19) |
			((uint32_t)(input[72] & 0xe0) << 11);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 579 to 594
	value = ((uint32_t)(input[72] & 0x1f) << 27) |
			((uint32_t)input[73] << 19) |
			((uint32_t)(input[74] & 0xe0) << 11);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 595 to 610
	value = ((uint32_t)(input[74] & 0x1f) << 27) |
			((uint32_t)input[75] << 19) |
			((uint32_t)(input[76] & 0xe0) << 11);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 611 to 626
	value = ((uint32_t)(input[76] & 0x1f) << 27) |
			((uint32_t)input[77] << 19) |
			((uint32_t)(input[78] & 0xe0) << 11);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 627 to 642
	value = ((uint32_t)(input[78] & 0x1f) << 27) |
			((uint32_t)input[79] << 19) |
			((uint32_t)(input[80] & 0xe0) << 11);
	output[39] = (double)(value >> 16);

	// read output[40]: from bit 643 to 658
	value = ((uint32_t)(input[80] & 0x1f) << 27) |
			((uint32_t)input[81] << 19) |
			((uint32_t)(input[82] & 0xe0) << 11);
	output[40] = (double)(value >> 16);

	// read output[41]: from bit 659 to 674
	value = ((uint32_t)(input[82] & 0x1f) << 27) |
			((uint32_t)input[83] << 19) |
			((uint32_t)(input[84] & 0xe0) << 11);
	output[41] = (double)(value >> 16);

	// read output[42]: from bit 675 to 690
	value = ((uint32_t)(input[84] & 0x1f) << 27) |
			((uint32_t)input[85] << 19) |
			((uint32_t)(input[86] & 0xe0) << 11);
	output[42] = (double)(value >> 16);

	// read output[43]: from bit 691 to 706
	value = ((uint32_t)(input[86] & 0x1f) << 27) |
			((uint32_t)input[87] << 19) |
			((uint32_t)(input[88] & 0xe0) << 11);
	output[43] = (double)(value >> 16);

	// read output[44]: from bit 707 to 722
	value = ((uint32_t)(input[88] & 0x1f) << 27) |
			((uint32_t)input[89] << 19) |
			((uint32_t)(input[90] & 0xe0) << 11);
	output[44] = (double)(value >> 16);

	// read output[45]: from bit 723 to 738
	value = ((uint32_t)(input[90] & 0x1f) << 27) |
			((uint32_t)input[91] << 19) |
			((uint32_t)(input[92] & 0xe0) << 11);
	output[45] = (double)(value >> 16);

	// read output[46]: from bit 739 to 754
	value = ((uint32_t)(input[92] & 0x1f) << 27) |
			((uint32_t)input[93] << 19) |
			((uint32_t)(input[94] & 0xe0) << 11);
	output[46] = (double)(value >> 16);

	// read output[47]: from bit 755 to 770
	value = ((uint32_t)(input[94] & 0x1f) << 27) |
			((uint32_t)input[95] << 19) |
			((uint32_t)(input[96] & 0xe0) << 11);
	output[47] = (double)(value >> 16);

	// read output[48]: from bit 771 to 786
	value = ((uint32_t)(input[96] & 0x1f) << 27) |
			((uint32_t)input[97] << 19) |
			((uint32_t)(input[98] & 0xe0) << 11);
	output[48] = (double)(value >> 16);

	// read output[49]: from bit 787 to 802
	value = ((uint32_t)(input[98] & 0x1f) << 27) |
			((uint32_t)input[99] << 19) |
			((uint32_t)(input[100] & 0xe0) << 11);
	output[49] = (double)(value >> 16);

	// read output[50]: from bit 803 to 818
	value = ((uint32_t)(input[100] & 0x1f) << 27) |
			((uint32_t)input[101] << 19) |
			((uint32_t)(input[102] & 0xe0) << 11);
	output[50] = (double)(value >> 16);

	// read output[51]: from bit 819 to 834
	value = ((uint32_t)(input[102] & 0x1f) << 27) |
			((uint32_t)input[103] << 19) |
			((uint32_t)(input[104] & 0xe0) << 11);
	output[51] = (double)(value >> 16);

	// read output[52]: from bit 835 to 850
	value = ((uint32_t)(input[104] & 0x1f) << 27) |
			((uint32_t)input[105] << 19) |
			((uint32_t)(input[106] & 0xe0) << 11);
	output[52] = (double)(value >> 16);

	// read output[53]: from bit 851 to 866
	value = ((uint32_t)(input[106] & 0x1f) << 27) |
			((uint32_t)input[107] << 19) |
			((uint32_t)(input[108] & 0xe0) << 11);
	output[53] = (double)(value >> 16);

	// read output[54]: from bit 867 to 882
	value = ((uint32_t)(input[108] & 0x1f) << 27) |
			((uint32_t)input[109] << 19) |
			((uint32_t)(input[110] & 0xe0) << 11);
	output[54] = (double)(value >> 16);

	// read output[55]: from bit 883 to 898
	value = ((uint32_t)(input[110] & 0x1f) << 27) |
			((uint32_t)input[111] << 19) |
			((uint32_t)(input[112] & 0xe0) << 11);
	output[55] = (double)(value >> 16);

	// read output[56]: from bit 899 to 914
	value = ((uint32_t)(input[112] & 0x1f) << 27) |
			((uint32_t)input[113] << 19) |
			((uint32_t)(input[114] & 0xe0) << 11);
	output[56] = (double)(value >> 16);

	// read output[57]: from bit 915 to 930
	value = ((uint32_t)(input[114] & 0x1f) << 27) |
			((uint32_t)input[115] << 19) |
			((uint32_t)(input[116] & 0xe0) << 11);
	output[57] = (double)(value >> 16);

	// read output[58]: from bit 931 to 946
	value = ((uint32_t)(input[116] & 0x1f) << 27) |
			((uint32_t)input[117] << 19) |
			((uint32_t)(input[118] & 0xe0) << 11);
	output[58] = (double)(value >> 16);

	// read output[59]: from bit 947 to 962
	value = ((uint32_t)(input[118] & 0x1f) << 27) |
			((uint32_t)input[119] << 19) |
			((uint32_t)(input[120] & 0xe0) << 11);
	output[59] = (double)(value >> 16);

	// read output[60]: from bit 963 to 978
	value = ((uint32_t)(input[120] & 0x1f) << 27) |
			((uint32_t)input[121] << 19) |
			((uint32_t)(input[122] & 0xe0) << 11);
	output[60] = (double)(value >> 16);

	// read output[61]: from bit 979 to 994
	value = ((uint32_t)(input[122] & 0x1f) << 27) |
			((uint32_t)input[123] << 19) |
			((uint32_t)(input[124] & 0xe0) << 11);
	output[61] = (double)(value >> 16);
}

static void unpack_62_16bit_signed_4off(const uint8_t * input, double * output, void *closure) {
	// Unpack 62 values into output
	// Values are 16-bit signed
	// Skip 4 bits, read 992 bits of data.
	// Input must be at least 125 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 4 to 19
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20) |
			((uint32_t)(input[2] & 0xf0) << 12);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 20 to 35
	value = ((uint32_t)(input[2] & 0x0f) << 28) |
			((uint32_t)input[3] << 20) |
			((uint32_t)(input[4] & 0xf0) << 12);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 36 to 51
	value = ((uint32_t)(input[4] & 0x0f) << 28) |
			((uint32_t)input[5] << 20) |
			((uint32_t)(input[6] & 0xf0) << 12);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 52 to 67
	value = ((uint32_t)(input[6] & 0x0f) << 28) |
			((uint32_t)input[7] << 20) |
			((uint32_t)(input[8] & 0xf0) << 12);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 68 to 83
	value = ((uint32_t)(input[8] & 0x0f) << 28) |
			((uint32_t)input[9] << 20) |
			((uint32_t)(input[10] & 0xf0) << 12);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 84 to 99
	value = ((uint32_t)(input[10] & 0x0f) << 28) |
			((uint32_t)input[11] << 20) |
			((uint32_t)(input[12] & 0xf0) << 12);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 100 to 115
	value = ((uint32_t)(input[12] & 0x0f) << 28) |
			((uint32_t)input[13] << 20) |
			((uint32_t)(input[14] & 0xf0) << 12);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 116 to 131
	value = ((uint32_t)(input[14] & 0x0f) << 28) |
			((uint32_t)input[15] << 20) |
			((uint32_t)(input[16] & 0xf0) << 12);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 132 to 147
	value = ((uint32_t)(input[16] & 0x0f) << 28) |
			((uint32_t)input[17] << 20) |
			((uint32_t)(input[18] & 0xf0) << 12);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 148 to 163
	value = ((uint32_t)(input[18] & 0x0f) << 28) |
			((uint32_t)input[19] << 20) |
			((uint32_t)(input[20] & 0xf0) << 12);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 164 to 179
	value = ((uint32_t)(input[20] & 0x0f) << 28) |
			((uint32_t)input[21] << 20) |
			((uint32_t)(input[22] & 0xf0) << 12);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 180 to 195
	value = ((uint32_t)(input[22] & 0x0f) << 28) |
			((uint32_t)input[23] << 20) |
			((uint32_t)(input[24] & 0xf0) << 12);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 196 to 211
	value = ((uint32_t)(input[24] & 0x0f) << 28) |
			((uint32_t)input[25] << 20) |
			((uint32_t)(input[26] & 0xf0) << 12);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 212 to 227
	value = ((uint32_t)(input[26] & 0x0f) << 28) |
			((uint32_t)input[27] << 20) |
			((uint32_t)(input[28] & 0xf0) << 12);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 228 to 243
	value = ((uint32_t)(input[28] & 0x0f) << 28) |
			((uint32_t)input[29] << 20) |
			((uint32_t)(input[30] & 0xf0) << 12);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 244 to 259
	value = ((uint32_t)(input[30] & 0x0f) << 28) |
			((uint32_t)input[31] << 20) |
			((uint32_t)(input[32] & 0xf0) << 12);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 260 to 275
	value = ((uint32_t)(input[32] & 0x0f) << 28) |
			((uint32_t)input[33] << 20) |
			((uint32_t)(input[34] & 0xf0) << 12);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 276 to 291
	value = ((uint32_t)(input[34] & 0x0f) << 28) |
			((uint32_t)input[35] << 20) |
			((uint32_t)(input[36] & 0xf0) << 12);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 292 to 307
	value = ((uint32_t)(input[36] & 0x0f) << 28) |
			((uint32_t)input[37] << 20) |
			((uint32_t)(input[38] & 0xf0) << 12);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 308 to 323
	value = ((uint32_t)(input[38] & 0x0f) << 28) |
			((uint32_t)input[39] << 20) |
			((uint32_t)(input[40] & 0xf0) << 12);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 324 to 339
	value = ((uint32_t)(input[40] & 0x0f) << 28) |
			((uint32_t)input[41] << 20) |
			((uint32_t)(input[42] & 0xf0) << 12);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 340 to 355
	value = ((uint32_t)(input[42] & 0x0f) << 28) |
			((uint32_t)input[43] << 20) |
			((uint32_t)(input[44] & 0xf0) << 12);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 356 to 371
	value = ((uint32_t)(input[44] & 0x0f) << 28) |
			((uint32_t)input[45] << 20) |
			((uint32_t)(input[46] & 0xf0) << 12);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 372 to 387
	value = ((uint32_t)(input[46] & 0x0f) << 28) |
			((uint32_t)input[47] << 20) |
			((uint32_t)(input[48] & 0xf0) << 12);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 388 to 403
	value = ((uint32_t)(input[48] & 0x0f) << 28) |
			((uint32_t)input[49] << 20) |
			((uint32_t)(input[50] & 0xf0) << 12);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 404 to 419
	value = ((uint32_t)(input[50] & 0x0f) << 28) |
			((uint32_t)input[51] << 20) |
			((uint32_t)(input[52] & 0xf0) << 12);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 420 to 435
	value = ((uint32_t)(input[52] & 0x0f) << 28) |
			((uint32_t)input[53] << 20) |
			((uint32_t)(input[54] & 0xf0) << 12);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 436 to 451
	value = ((uint32_t)(input[54] & 0x0f) << 28) |
			((uint32_t)input[55] << 20) |
			((uint32_t)(input[56] & 0xf0) << 12);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 452 to 467
	value = ((uint32_t)(input[56] & 0x0f) << 28) |
			((uint32_t)input[57] << 20) |
			((uint32_t)(input[58] & 0xf0) << 12);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 468 to 483
	value = ((uint32_t)(input[58] & 0x0f) << 28) |
			((uint32_t)input[59] << 20) |
			((uint32_t)(input[60] & 0xf0) << 12);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 484 to 499
	value = ((uint32_t)(input[60] & 0x0f) << 28) |
			((uint32_t)input[61] << 20) |
			((uint32_t)(input[62] & 0xf0) << 12);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 500 to 515
	value = ((uint32_t)(input[62] & 0x0f) << 28) |
			((uint32_t)input[63] << 20) |
			((uint32_t)(input[64] & 0xf0) << 12);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 516 to 531
	value = ((uint32_t)(input[64] & 0x0f) << 28) |
			((uint32_t)input[65] << 20) |
			((uint32_t)(input[66] & 0xf0) << 12);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 532 to 547
	value = ((uint32_t)(input[66] & 0x0f) << 28) |
			((uint32_t)input[67] << 20) |
			((uint32_t)(input[68] & 0xf0) << 12);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 548 to 563
	value = ((uint32_t)(input[68] & 0x0f) << 28) |
			((uint32_t)input[69] << 20) |
			((uint32_t)(input[70] & 0xf0) << 12);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 564 to 579
	value = ((uint32_t)(input[70] & 0x0f) << 28) |
			((uint32_t)input[71] << 20) |
			((uint32_t)(input[72] & 0xf0) << 12);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 580 to 595
	value = ((uint32_t)(input[72] & 0x0f) << 28) |
			((uint32_t)input[73] << 20) |
			((uint32_t)(input[74] & 0xf0) << 12);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 596 to 611
	value = ((uint32_t)(input[74] & 0x0f) << 28) |
			((uint32_t)input[75] << 20) |
			((uint32_t)(input[76] & 0xf0) << 12);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 612 to 627
	value = ((uint32_t)(input[76] & 0x0f) << 28) |
			((uint32_t)input[77] << 20) |
			((uint32_t)(input[78] & 0xf0) << 12);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 628 to 643
	value = ((uint32_t)(input[78] & 0x0f) << 28) |
			((uint32_t)input[79] << 20) |
			((uint32_t)(input[80] & 0xf0) << 12);
	output[39] = (double)(value >> 16);

	// read output[40]: from bit 644 to 659
	value = ((uint32_t)(input[80] & 0x0f) << 28) |
			((uint32_t)input[81] << 20) |
			((uint32_t)(input[82] & 0xf0) << 12);
	output[40] = (double)(value >> 16);

	// read output[41]: from bit 660 to 675
	value = ((uint32_t)(input[82] & 0x0f) << 28) |
			((uint32_t)input[83] << 20) |
			((uint32_t)(input[84] & 0xf0) << 12);
	output[41] = (double)(value >> 16);

	// read output[42]: from bit 676 to 691
	value = ((uint32_t)(input[84] & 0x0f) << 28) |
			((uint32_t)input[85] << 20) |
			((uint32_t)(input[86] & 0xf0) << 12);
	output[42] = (double)(value >> 16);

	// read output[43]: from bit 692 to 707
	value = ((uint32_t)(input[86] & 0x0f) << 28) |
			((uint32_t)input[87] << 20) |
			((uint32_t)(input[88] & 0xf0) << 12);
	output[43] = (double)(value >> 16);

	// read output[44]: from bit 708 to 723
	value = ((uint32_t)(input[88] & 0x0f) << 28) |
			((uint32_t)input[89] << 20) |
			((uint32_t)(input[90] & 0xf0) << 12);
	output[44] = (double)(value >> 16);

	// read output[45]: from bit 724 to 739
	value = ((uint32_t)(input[90] & 0x0f) << 28) |
			((uint32_t)input[91] << 20) |
			((uint32_t)(input[92] & 0xf0) << 12);
	output[45] = (double)(value >> 16);

	// read output[46]: from bit 740 to 755
	value = ((uint32_t)(input[92] & 0x0f) << 28) |
			((uint32_t)input[93] << 20) |
			((uint32_t)(input[94] & 0xf0) << 12);
	output[46] = (double)(value >> 16);

	// read output[47]: from bit 756 to 771
	value = ((uint32_t)(input[94] & 0x0f) << 28) |
			((uint32_t)input[95] << 20) |
			((uint32_t)(input[96] & 0xf0) << 12);
	output[47] = (double)(value >> 16);

	// read output[48]: from bit 772 to 787
	value = ((uint32_t)(input[96] & 0x0f) << 28) |
			((uint32_t)input[97] << 20) |
			((uint32_t)(input[98] & 0xf0) << 12);
	output[48] = (double)(value >> 16);

	// read output[49]: from bit 788 to 803
	value = ((uint32_t)(input[98] & 0x0f) << 28) |
			((uint32_t)input[99] << 20) |
			((uint32_t)(input[100] & 0xf0) << 12);
	output[49] = (double)(value >> 16);

	// read output[50]: from bit 804 to 819
	value = ((uint32_t)(input[100] & 0x0f) << 28) |
			((uint32_t)input[101] << 20) |
			((uint32_t)(input[102] & 0xf0) << 12);
	output[50] = (double)(value >> 16);

	// read output[51]: from bit 820 to 835
	value = ((uint32_t)(input[102] & 0x0f) << 28) |
			((uint32_t)input[103] << 20) |
			((uint32_t)(input[104] & 0xf0) << 12);
	output[51] = (double)(value >> 16);

	// read output[52]: from bit 836 to 851
	value = ((uint32_t)(input[104] & 0x0f) << 28) |
			((uint32_t)input[105] << 20) |
			((uint32_t)(input[106] & 0xf0) << 12);
	output[52] = (double)(value >> 16);

	// read output[53]: from bit 852 to 867
	value = ((uint32_t)(input[106] & 0x0f) << 28) |
			((uint32_t)input[107] << 20) |
			((uint32_t)(input[108] & 0xf0) << 12);
	output[53] = (double)(value >> 16);

	// read output[54]: from bit 868 to 883
	value = ((uint32_t)(input[108] & 0x0f) << 28) |
			((uint32_t)input[109] << 20) |
			((uint32_t)(input[110] & 0xf0) << 12);
	output[54] = (double)(value >> 16);

	// read output[55]: from bit 884 to 899
	value = ((uint32_t)(input[110] & 0x0f) << 28) |
			((uint32_t)input[111] << 20) |
			((uint32_t)(input[112] & 0xf0) << 12);
	output[55] = (double)(value >> 16);

	// read output[56]: from bit 900 to 915
	value = ((uint32_t)(input[112] & 0x0f) << 28) |
			((uint32_t)input[113] << 20) |
			((uint32_t)(input[114] & 0xf0) << 12);
	output[56] = (double)(value >> 16);

	// read output[57]: from bit 916 to 931
	value = ((uint32_t)(input[114] & 0x0f) << 28) |
			((uint32_t)input[115] << 20) |
			((uint32_t)(input[116] & 0xf0) << 12);
	output[57] = (double)(value >> 16);

	// read output[58]: from bit 932 to 947
	value = ((uint32_t)(input[116] & 0x0f) << 28) |
			((uint32_t)input[117] << 20) |
			((uint32_t)(input[118] & 0xf0) << 12);
	output[58] = (double)(value >> 16);

	// read output[59]: from bit 948 to 963
	value = ((uint32_t)(input[118] & 0x0f) << 28) |
			((uint32_t)input[119] << 20) |
			((uint32_t)(input[120] & 0xf0) << 12);
	output[59] = (double)(value >> 16);

	// read output[60]: from bit 964 to 979
	value = ((uint32_t)(input[120] & 0x0f) << 28) |
			((uint32_t)input[121] << 20) |
			((uint32_t)(input[122] & 0xf0) << 12);
	output[60] = (double)(value >> 16);

	// read output[61]: from bit 980 to 995
	value = ((uint32_t)(input[122] & 0x0f) << 28) |
			((uint32_t)input[123] << 20) |
			((uint32_t)(input[124] & 0xf0) << 12);
	output[61] = (double)(value >> 16);
}

static void unpack_62_16bit_unsigned_4off(const uint8_t * input, double * output, void *closure) {
	// Unpack 62 values into output
	// Values are 16-bit unsigned
	// Skip 4 bits, read 992 bits of data.
	// Input must be at least 125 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 4 to 19
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20) |
			((uint32_t)(input[2] & 0xf0) << 12);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 20 to 35
	value = ((uint32_t)(input[2] & 0x0f) << 28) |
			((uint32_t)input[3] << 20) |
			((uint32_t)(input[4] & 0xf0) << 12);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 36 to 51
	value = ((uint32_t)(input[4] & 0x0f) << 28) |
			((uint32_t)input[5] << 20) |
			((uint32_t)(input[6] & 0xf0) << 12);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 52 to 67
	value = ((uint32_t)(input[6] & 0x0f) << 28) |
			((uint32_t)input[7] << 20) |
			((uint32_t)(input[8] & 0xf0) << 12);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 68 to 83
	value = ((uint32_t)(input[8] & 0x0f) << 28) |
			((uint32_t)input[9] << 20) |
			((uint32_t)(input[10] & 0xf0) << 12);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 84 to 99
	value = ((uint32_t)(input[10] & 0x0f) << 28) |
			((uint32_t)input[11] << 20) |
			((uint32_t)(input[12] & 0xf0) << 12);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 100 to 115
	value = ((uint32_t)(input[12] & 0x0f) << 28) |
			((uint32_t)input[13] << 20) |
			((uint32_t)(input[14] & 0xf0) << 12);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 116 to 131
	value = ((uint32_t)(input[14] & 0x0f) << 28) |
			((uint32_t)input[15] << 20) |
			((uint32_t)(input[16] & 0xf0) << 12);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 132 to 147
	value = ((uint32_t)(input[16] & 0x0f) << 28) |
			((uint32_t)input[17] << 20) |
			((uint32_t)(input[18] & 0xf0) << 12);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 148 to 163
	value = ((uint32_t)(input[18] & 0x0f) << 28) |
			((uint32_t)input[19] << 20) |
			((uint32_t)(input[20] & 0xf0) << 12);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 164 to 179
	value = ((uint32_t)(input[20] & 0x0f) << 28) |
			((uint32_t)input[21] << 20) |
			((uint32_t)(input[22] & 0xf0) << 12);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 180 to 195
	value = ((uint32_t)(input[22] & 0x0f) << 28) |
			((uint32_t)input[23] << 20) |
			((uint32_t)(input[24] & 0xf0) << 12);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 196 to 211
	value = ((uint32_t)(input[24] & 0x0f) << 28) |
			((uint32_t)input[25] << 20) |
			((uint32_t)(input[26] & 0xf0) << 12);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 212 to 227
	value = ((uint32_t)(input[26] & 0x0f) << 28) |
			((uint32_t)input[27] << 20) |
			((uint32_t)(input[28] & 0xf0) << 12);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 228 to 243
	value = ((uint32_t)(input[28] & 0x0f) << 28) |
			((uint32_t)input[29] << 20) |
			((uint32_t)(input[30] & 0xf0) << 12);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 244 to 259
	value = ((uint32_t)(input[30] & 0x0f) << 28) |
			((uint32_t)input[31] << 20) |
			((uint32_t)(input[32] & 0xf0) << 12);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 260 to 275
	value = ((uint32_t)(input[32] & 0x0f) << 28) |
			((uint32_t)input[33] << 20) |
			((uint32_t)(input[34] & 0xf0) << 12);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 276 to 291
	value = ((uint32_t)(input[34] & 0x0f) << 28) |
			((uint32_t)input[35] << 20) |
			((uint32_t)(input[36] & 0xf0) << 12);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 292 to 307
	value = ((uint32_t)(input[36] & 0x0f) << 28) |
			((uint32_t)input[37] << 20) |
			((uint32_t)(input[38] & 0xf0) << 12);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 308 to 323
	value = ((uint32_t)(input[38] & 0x0f) << 28) |
			((uint32_t)input[39] << 20) |
			((uint32_t)(input[40] & 0xf0) << 12);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 324 to 339
	value = ((uint32_t)(input[40] & 0x0f) << 28) |
			((uint32_t)input[41] << 20) |
			((uint32_t)(input[42] & 0xf0) << 12);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 340 to 355
	value = ((uint32_t)(input[42] & 0x0f) << 28) |
			((uint32_t)input[43] << 20) |
			((uint32_t)(input[44] & 0xf0) << 12);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 356 to 371
	value = ((uint32_t)(input[44] & 0x0f) << 28) |
			((uint32_t)input[45] << 20) |
			((uint32_t)(input[46] & 0xf0) << 12);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 372 to 387
	value = ((uint32_t)(input[46] & 0x0f) << 28) |
			((uint32_t)input[47] << 20) |
			((uint32_t)(input[48] & 0xf0) << 12);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 388 to 403
	value = ((uint32_t)(input[48] & 0x0f) << 28) |
			((uint32_t)input[49] << 20) |
			((uint32_t)(input[50] & 0xf0) << 12);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 404 to 419
	value = ((uint32_t)(input[50] & 0x0f) << 28) |
			((uint32_t)input[51] << 20) |
			((uint32_t)(input[52] & 0xf0) << 12);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 420 to 435
	value = ((uint32_t)(input[52] & 0x0f) << 28) |
			((uint32_t)input[53] << 20) |
			((uint32_t)(input[54] & 0xf0) << 12);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 436 to 451
	value = ((uint32_t)(input[54] & 0x0f) << 28) |
			((uint32_t)input[55] << 20) |
			((uint32_t)(input[56] & 0xf0) << 12);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 452 to 467
	value = ((uint32_t)(input[56] & 0x0f) << 28) |
			((uint32_t)input[57] << 20) |
			((uint32_t)(input[58] & 0xf0) << 12);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 468 to 483
	value = ((uint32_t)(input[58] & 0x0f) << 28) |
			((uint32_t)input[59] << 20) |
			((uint32_t)(input[60] & 0xf0) << 12);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 484 to 499
	value = ((uint32_t)(input[60] & 0x0f) << 28) |
			((uint32_t)input[61] << 20) |
			((uint32_t)(input[62] & 0xf0) << 12);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 500 to 515
	value = ((uint32_t)(input[62] & 0x0f) << 28) |
			((uint32_t)input[63] << 20) |
			((uint32_t)(input[64] & 0xf0) << 12);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 516 to 531
	value = ((uint32_t)(input[64] & 0x0f) << 28) |
			((uint32_t)input[65] << 20) |
			((uint32_t)(input[66] & 0xf0) << 12);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 532 to 547
	value = ((uint32_t)(input[66] & 0x0f) << 28) |
			((uint32_t)input[67] << 20) |
			((uint32_t)(input[68] & 0xf0) << 12);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 548 to 563
	value = ((uint32_t)(input[68] & 0x0f) << 28) |
			((uint32_t)input[69] << 20) |
			((uint32_t)(input[70] & 0xf0) << 12);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 564 to 579
	value = ((uint32_t)(input[70] & 0x0f) << 28) |
			((uint32_t)input[71] << 20) |
			((uint32_t)(input[72] & 0xf0) << 12);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 580 to 595
	value = ((uint32_t)(input[72] & 0x0f) << 28) |
			((uint32_t)input[73] << 20) |
			((uint32_t)(input[74] & 0xf0) << 12);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 596 to 611
	value = ((uint32_t)(input[74] & 0x0f) << 28) |
			((uint32_t)input[75] << 20) |
			((uint32_t)(input[76] & 0xf0) << 12);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 612 to 627
	value = ((uint32_t)(input[76] & 0x0f) << 28) |
			((uint32_t)input[77] << 20) |
			((uint32_t)(input[78] & 0xf0) << 12);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 628 to 643
	value = ((uint32_t)(input[78] & 0x0f) << 28) |
			((uint32_t)input[79] << 20) |
			((uint32_t)(input[80] & 0xf0) << 12);
	output[39] = (double)(value >> 16);

	// read output[40]: from bit 644 to 659
	value = ((uint32_t)(input[80] & 0x0f) << 28) |
			((uint32_t)input[81] << 20) |
			((uint32_t)(input[82] & 0xf0) << 12);
	output[40] = (double)(value >> 16);

	// read output[41]: from bit 660 to 675
	value = ((uint32_t)(input[82] & 0x0f) << 28) |
			((uint32_t)input[83] << 20) |
			((uint32_t)(input[84] & 0xf0) << 12);
	output[41] = (double)(value >> 16);

	// read output[42]: from bit 676 to 691
	value = ((uint32_t)(input[84] & 0x0f) << 28) |
			((uint32_t)input[85] << 20) |
			((uint32_t)(input[86] & 0xf0) << 12);
	output[42] = (double)(value >> 16);

	// read output[43]: from bit 692 to 707
	value = ((uint32_t)(input[86] & 0x0f) << 28) |
			((uint32_t)input[87] << 20) |
			((uint32_t)(input[88] & 0xf0) << 12);
	output[43] = (double)(value >> 16);

	// read output[44]: from bit 708 to 723
	value = ((uint32_t)(input[88] & 0x0f) << 28) |
			((uint32_t)input[89] << 20) |
			((uint32_t)(input[90] & 0xf0) << 12);
	output[44] = (double)(value >> 16);

	// read output[45]: from bit 724 to 739
	value = ((uint32_t)(input[90] & 0x0f) << 28) |
			((uint32_t)input[91] << 20) |
			((uint32_t)(input[92] & 0xf0) << 12);
	output[45] = (double)(value >> 16);

	// read output[46]: from bit 740 to 755
	value = ((uint32_t)(input[92] & 0x0f) << 28) |
			((uint32_t)input[93] << 20) |
			((uint32_t)(input[94] & 0xf0) << 12);
	output[46] = (double)(value >> 16);

	// read output[47]: from bit 756 to 771
	value = ((uint32_t)(input[94] & 0x0f) << 28) |
			((uint32_t)input[95] << 20) |
			((uint32_t)(input[96] & 0xf0) << 12);
	output[47] = (double)(value >> 16);

	// read output[48]: from bit 772 to 787
	value = ((uint32_t)(input[96] & 0x0f) << 28) |
			((uint32_t)input[97] << 20) |
			((uint32_t)(input[98] & 0xf0) << 12);
	output[48] = (double)(value >> 16);

	// read output[49]: from bit 788 to 803
	value = ((uint32_t)(input[98] & 0x0f) << 28) |
			((uint32_t)input[99] << 20) |
			((uint32_t)(input[100] & 0xf0) << 12);
	output[49] = (double)(value >> 16);

	// read output[50]: from bit 804 to 819
	value = ((uint32_t)(input[100] & 0x0f) << 28) |
			((uint32_t)input[101] << 20) |
			((uint32_t)(input[102] & 0xf0) << 12);
	output[50] = (double)(value >> 16);

	// read output[51]: from bit 820 to 835
	value = ((uint32_t)(input[102] & 0x0f) << 28) |
			((uint32_t)input[103] << 20) |
			((uint32_t)(input[104] & 0xf0) << 12);
	output[51] = (double)(value >> 16);

	// read output[52]: from bit 836 to 851
	value = ((uint32_t)(input[104] & 0x0f) << 28) |
			((uint32_t)input[105] << 20) |
			((uint32_t)(input[106] & 0xf0) << 12);
	output[52] = (double)(value >> 16);

	// read output[53]: from bit 852 to 867
	value = ((uint32_t)(input[106] & 0x0f) << 28) |
			((uint32_t)input[107] << 20) |
			((uint32_t)(input[108] & 0xf0) << 12);
	output[53] = (double)(value >> 16);

	// read output[54]: from bit 868 to 883
	value = ((uint32_t)(input[108] & 0x0f) << 28) |
			((uint32_t)input[109] << 20) |
			((uint32_t)(input[110] & 0xf0) << 12);
	output[54] = (double)(value >> 16);

	// read output[55]: from bit 884 to 899
	value = ((uint32_t)(input[110] & 0x0f) << 28) |
			((uint32_t)input[111] << 20) |
			((uint32_t)(input[112] & 0xf0) << 12);
	output[55] = (double)(value >> 16);

	// read output[56]: from bit 900 to 915
	value = ((uint32_t)(input[112] & 0x0f) << 28) |
			((uint32_t)input[113] << 20) |
			((uint32_t)(input[114] & 0xf0) << 12);
	output[56] = (double)(value >> 16);

	// read output[57]: from bit 916 to 931
	value = ((uint32_t)(input[114] & 0x0f) << 28) |
			((uint32_t)input[115] << 20) |
			((uint32_t)(input[116] & 0xf0) << 12);
	output[57] = (double)(value >> 16);

	// read output[58]: from bit 932 to 947
	value = ((uint32_t)(input[116] & 0x0f) << 28) |
			((uint32_t)input[117] << 20) |
			((uint32_t)(input[118] & 0xf0) << 12);
	output[58] = (double)(value >> 16);

	// read output[59]: from bit 948 to 963
	value = ((uint32_t)(input[118] & 0x0f) << 28) |
			((uint32_t)input[119] << 20) |
			((uint32_t)(input[120] & 0xf0) << 12);
	output[59] = (double)(value >> 16);

	// read output[60]: from bit 964 to 979
	value = ((uint32_t)(input[120] & 0x0f) << 28) |
			((uint32_t)input[121] << 20) |
			((uint32_t)(input[122] & 0xf0) << 12);
	output[60] = (double)(value >> 16);

	// read output[61]: from bit 980 to 995
	value = ((uint32_t)(input[122] & 0x0f) << 28) |
			((uint32_t)input[123] << 20) |
			((uint32_t)(input[124] & 0xf0) << 12);
	output[61] = (double)(value >> 16);
}

static void unpack_62_16bit_signed_5off(const uint8_t * input, double * output, void *closure) {
	// Unpack 62 values into output
	// Values are 16-bit signed
	// Skip 5 bits, read 992 bits of data.
	// Input must be at least 125 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 5 to 20
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)(input[2] & 0xf8) << 13);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 21 to 36
	value = ((uint32_t)(input[2] & 0x07) << 29) |
			((uint32_t)input[3] << 21) |
			((uint32_t)(input[4] & 0xf8) << 13);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 37 to 52
	value = ((uint32_t)(input[4] & 0x07) << 29) |
			((uint32_t)input[5] << 21) |
			((uint32_t)(input[6] & 0xf8) << 13);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 53 to 68
	value = ((uint32_t)(input[6] & 0x07) << 29) |
			((uint32_t)input[7] << 21) |
			((uint32_t)(input[8] & 0xf8) << 13);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 69 to 84
	value = ((uint32_t)(input[8] & 0x07) << 29) |
			((uint32_t)input[9] << 21) |
			((uint32_t)(input[10] & 0xf8) << 13);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 85 to 100
	value = ((uint32_t)(input[10] & 0x07) << 29) |
			((uint32_t)input[11] << 21) |
			((uint32_t)(input[12] & 0xf8) << 13);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 101 to 116
	value = ((uint32_t)(input[12] & 0x07) << 29) |
			((uint32_t)input[13] << 21) |
			((uint32_t)(input[14] & 0xf8) << 13);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 117 to 132
	value = ((uint32_t)(input[14] & 0x07) << 29) |
			((uint32_t)input[15] << 21) |
			((uint32_t)(input[16] & 0xf8) << 13);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 133 to 148
	value = ((uint32_t)(input[16] & 0x07) << 29) |
			((uint32_t)input[17] << 21) |
			((uint32_t)(input[18] & 0xf8) << 13);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 149 to 164
	value = ((uint32_t)(input[18] & 0x07) << 29) |
			((uint32_t)input[19] << 21) |
			((uint32_t)(input[20] & 0xf8) << 13);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 165 to 180
	value = ((uint32_t)(input[20] & 0x07) << 29) |
			((uint32_t)input[21] << 21) |
			((uint32_t)(input[22] & 0xf8) << 13);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 181 to 196
	value = ((uint32_t)(input[22] & 0x07) << 29) |
			((uint32_t)input[23] << 21) |
			((uint32_t)(input[24] & 0xf8) << 13);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 197 to 212
	value = ((uint32_t)(input[24] & 0x07) << 29) |
			((uint32_t)input[25] << 21) |
			((uint32_t)(input[26] & 0xf8) << 13);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 213 to 228
	value = ((uint32_t)(input[26] & 0x07) << 29) |
			((uint32_t)input[27] << 21) |
			((uint32_t)(input[28] & 0xf8) << 13);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 229 to 244
	value = ((uint32_t)(input[28] & 0x07) << 29) |
			((uint32_t)input[29] << 21) |
			((uint32_t)(input[30] & 0xf8) << 13);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 245 to 260
	value = ((uint32_t)(input[30] & 0x07) << 29) |
			((uint32_t)input[31] << 21) |
			((uint32_t)(input[32] & 0xf8) << 13);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 261 to 276
	value = ((uint32_t)(input[32] & 0x07) << 29) |
			((uint32_t)input[33] << 21) |
			((uint32_t)(input[34] & 0xf8) << 13);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 277 to 292
	value = ((uint32_t)(input[34] & 0x07) << 29) |
			((uint32_t)input[35] << 21) |
			((uint32_t)(input[36] & 0xf8) << 13);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 293 to 308
	value = ((uint32_t)(input[36] & 0x07) << 29) |
			((uint32_t)input[37] << 21) |
			((uint32_t)(input[38] & 0xf8) << 13);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 309 to 324
	value = ((uint32_t)(input[38] & 0x07) << 29) |
			((uint32_t)input[39] << 21) |
			((uint32_t)(input[40] & 0xf8) << 13);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 325 to 340
	value = ((uint32_t)(input[40] & 0x07) << 29) |
			((uint32_t)input[41] << 21) |
			((uint32_t)(input[42] & 0xf8) << 13);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 341 to 356
	value = ((uint32_t)(input[42] & 0x07) << 29) |
			((uint32_t)input[43] << 21) |
			((uint32_t)(input[44] & 0xf8) << 13);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 357 to 372
	value = ((uint32_t)(input[44] & 0x07) << 29) |
			((uint32_t)input[45] << 21) |
			((uint32_t)(input[46] & 0xf8) << 13);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 373 to 388
	value = ((uint32_t)(input[46] & 0x07) << 29) |
			((uint32_t)input[47] << 21) |
			((uint32_t)(input[48] & 0xf8) << 13);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 389 to 404
	value = ((uint32_t)(input[48] & 0x07) << 29) |
			((uint32_t)input[49] << 21) |
			((uint32_t)(input[50] & 0xf8) << 13);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 405 to 420
	value = ((uint32_t)(input[50] & 0x07) << 29) |
			((uint32_t)input[51] << 21) |
			((uint32_t)(input[52] & 0xf8) << 13);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 421 to 436
	value = ((uint32_t)(input[52] & 0x07) << 29) |
			((uint32_t)input[53] << 21) |
			((uint32_t)(input[54] & 0xf8) << 13);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 437 to 452
	value = ((uint32_t)(input[54] & 0x07) << 29) |
			((uint32_t)input[55] << 21) |
			((uint32_t)(input[56] & 0xf8) << 13);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 453 to 468
	value = ((uint32_t)(input[56] & 0x07) << 29) |
			((uint32_t)input[57] << 21) |
			((uint32_t)(input[58] & 0xf8) << 13);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 469 to 484
	value = ((uint32_t)(input[58] & 0x07) << 29) |
			((uint32_t)input[59] << 21) |
			((uint32_t)(input[60] & 0xf8) << 13);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 485 to 500
	value = ((uint32_t)(input[60] & 0x07) << 29) |
			((uint32_t)input[61] << 21) |
			((uint32_t)(input[62] & 0xf8) << 13);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 501 to 516
	value = ((uint32_t)(input[62] & 0x07) << 29) |
			((uint32_t)input[63] << 21) |
			((uint32_t)(input[64] & 0xf8) << 13);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 517 to 532
	value = ((uint32_t)(input[64] & 0x07) << 29) |
			((uint32_t)input[65] << 21) |
			((uint32_t)(input[66] & 0xf8) << 13);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 533 to 548
	value = ((uint32_t)(input[66] & 0x07) << 29) |
			((uint32_t)input[67] << 21) |
			((uint32_t)(input[68] & 0xf8) << 13);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 549 to 564
	value = ((uint32_t)(input[68] & 0x07) << 29) |
			((uint32_t)input[69] << 21) |
			((uint32_t)(input[70] & 0xf8) << 13);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 565 to 580
	value = ((uint32_t)(input[70] & 0x07) << 29) |
			((uint32_t)input[71] << 21) |
			((uint32_t)(input[72] & 0xf8) << 13);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 581 to 596
	value = ((uint32_t)(input[72] & 0x07) << 29) |
			((uint32_t)input[73] << 21) |
			((uint32_t)(input[74] & 0xf8) << 13);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 597 to 612
	value = ((uint32_t)(input[74] & 0x07) << 29) |
			((uint32_t)input[75] << 21) |
			((uint32_t)(input[76] & 0xf8) << 13);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 613 to 628
	value = ((uint32_t)(input[76] & 0x07) << 29) |
			((uint32_t)input[77] << 21) |
			((uint32_t)(input[78] & 0xf8) << 13);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 629 to 644
	value = ((uint32_t)(input[78] & 0x07) << 29) |
			((uint32_t)input[79] << 21) |
			((uint32_t)(input[80] & 0xf8) << 13);
	output[39] = (double)(value >> 16);

	// read output[40]: from bit 645 to 660
	value = ((uint32_t)(input[80] & 0x07) << 29) |
			((uint32_t)input[81] << 21) |
			((uint32_t)(input[82] & 0xf8) << 13);
	output[40] = (double)(value >> 16);

	// read output[41]: from bit 661 to 676
	value = ((uint32_t)(input[82] & 0x07) << 29) |
			((uint32_t)input[83] << 21) |
			((uint32_t)(input[84] & 0xf8) << 13);
	output[41] = (double)(value >> 16);

	// read output[42]: from bit 677 to 692
	value = ((uint32_t)(input[84] & 0x07) << 29) |
			((uint32_t)input[85] << 21) |
			((uint32_t)(input[86] & 0xf8) << 13);
	output[42] = (double)(value >> 16);

	// read output[43]: from bit 693 to 708
	value = ((uint32_t)(input[86] & 0x07) << 29) |
			((uint32_t)input[87] << 21) |
			((uint32_t)(input[88] & 0xf8) << 13);
	output[43] = (double)(value >> 16);

	// read output[44]: from bit 709 to 724
	value = ((uint32_t)(input[88] & 0x07) << 29) |
			((uint32_t)input[89] << 21) |
			((uint32_t)(input[90] & 0xf8) << 13);
	output[44] = (double)(value >> 16);

	// read output[45]: from bit 725 to 740
	value = ((uint32_t)(input[90] & 0x07) << 29) |
			((uint32_t)input[91] << 21) |
			((uint32_t)(input[92] & 0xf8) << 13);
	output[45] = (double)(value >> 16);

	// read output[46]: from bit 741 to 756
	value = ((uint32_t)(input[92] & 0x07) << 29) |
			((uint32_t)input[93] << 21) |
			((uint32_t)(input[94] & 0xf8) << 13);
	output[46] = (double)(value >> 16);

	// read output[47]: from bit 757 to 772
	value = ((uint32_t)(input[94] & 0x07) << 29) |
			((uint32_t)input[95] << 21) |
			((uint32_t)(input[96] & 0xf8) << 13);
	output[47] = (double)(value >> 16);

	// read output[48]: from bit 773 to 788
	value = ((uint32_t)(input[96] & 0x07) << 29) |
			((uint32_t)input[97] << 21) |
			((uint32_t)(input[98] & 0xf8) << 13);
	output[48] = (double)(value >> 16);

	// read output[49]: from bit 789 to 804
	value = ((uint32_t)(input[98] & 0x07) << 29) |
			((uint32_t)input[99] << 21) |
			((uint32_t)(input[100] & 0xf8) << 13);
	output[49] = (double)(value >> 16);

	// read output[50]: from bit 805 to 820
	value = ((uint32_t)(input[100] & 0x07) << 29) |
			((uint32_t)input[101] << 21) |
			((uint32_t)(input[102] & 0xf8) << 13);
	output[50] = (double)(value >> 16);

	// read output[51]: from bit 821 to 836
	value = ((uint32_t)(input[102] & 0x07) << 29) |
			((uint32_t)input[103] << 21) |
			((uint32_t)(input[104] & 0xf8) << 13);
	output[51] = (double)(value >> 16);

	// read output[52]: from bit 837 to 852
	value = ((uint32_t)(input[104] & 0x07) << 29) |
			((uint32_t)input[105] << 21) |
			((uint32_t)(input[106] & 0xf8) << 13);
	output[52] = (double)(value >> 16);

	// read output[53]: from bit 853 to 868
	value = ((uint32_t)(input[106] & 0x07) << 29) |
			((uint32_t)input[107] << 21) |
			((uint32_t)(input[108] & 0xf8) << 13);
	output[53] = (double)(value >> 16);

	// read output[54]: from bit 869 to 884
	value = ((uint32_t)(input[108] & 0x07) << 29) |
			((uint32_t)input[109] << 21) |
			((uint32_t)(input[110] & 0xf8) << 13);
	output[54] = (double)(value >> 16);

	// read output[55]: from bit 885 to 900
	value = ((uint32_t)(input[110] & 0x07) << 29) |
			((uint32_t)input[111] << 21) |
			((uint32_t)(input[112] & 0xf8) << 13);
	output[55] = (double)(value >> 16);

	// read output[56]: from bit 901 to 916
	value = ((uint32_t)(input[112] & 0x07) << 29) |
			((uint32_t)input[113] << 21) |
			((uint32_t)(input[114] & 0xf8) << 13);
	output[56] = (double)(value >> 16);

	// read output[57]: from bit 917 to 932
	value = ((uint32_t)(input[114] & 0x07) << 29) |
			((uint32_t)input[115] << 21) |
			((uint32_t)(input[116] & 0xf8) << 13);
	output[57] = (double)(value >> 16);

	// read output[58]: from bit 933 to 948
	value = ((uint32_t)(input[116] & 0x07) << 29) |
			((uint32_t)input[117] << 21) |
			((uint32_t)(input[118] & 0xf8) << 13);
	output[58] = (double)(value >> 16);

	// read output[59]: from bit 949 to 964
	value = ((uint32_t)(input[118] & 0x07) << 29) |
			((uint32_t)input[119] << 21) |
			((uint32_t)(input[120] & 0xf8) << 13);
	output[59] = (double)(value >> 16);

	// read output[60]: from bit 965 to 980
	value = ((uint32_t)(input[120] & 0x07) << 29) |
			((uint32_t)input[121] << 21) |
			((uint32_t)(input[122] & 0xf8) << 13);
	output[60] = (double)(value >> 16);

	// read output[61]: from bit 981 to 996
	value = ((uint32_t)(input[122] & 0x07) << 29) |
			((uint32_t)input[123] << 21) |
			((uint32_t)(input[124] & 0xf8) << 13);
	output[61] = (double)(value >> 16);
}

static void unpack_62_16bit_unsigned_5off(const uint8_t * input, double * output, void *closure) {
	// Unpack 62 values into output
	// Values are 16-bit unsigned
	// Skip 5 bits, read 992 bits of data.
	// Input must be at least 125 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 5 to 20
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)(input[2] & 0xf8) << 13);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 21 to 36
	value = ((uint32_t)(input[2] & 0x07) << 29) |
			((uint32_t)input[3] << 21) |
			((uint32_t)(input[4] & 0xf8) << 13);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 37 to 52
	value = ((uint32_t)(input[4] & 0x07) << 29) |
			((uint32_t)input[5] << 21) |
			((uint32_t)(input[6] & 0xf8) << 13);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 53 to 68
	value = ((uint32_t)(input[6] & 0x07) << 29) |
			((uint32_t)input[7] << 21) |
			((uint32_t)(input[8] & 0xf8) << 13);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 69 to 84
	value = ((uint32_t)(input[8] & 0x07) << 29) |
			((uint32_t)input[9] << 21) |
			((uint32_t)(input[10] & 0xf8) << 13);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 85 to 100
	value = ((uint32_t)(input[10] & 0x07) << 29) |
			((uint32_t)input[11] << 21) |
			((uint32_t)(input[12] & 0xf8) << 13);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 101 to 116
	value = ((uint32_t)(input[12] & 0x07) << 29) |
			((uint32_t)input[13] << 21) |
			((uint32_t)(input[14] & 0xf8) << 13);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 117 to 132
	value = ((uint32_t)(input[14] & 0x07) << 29) |
			((uint32_t)input[15] << 21) |
			((uint32_t)(input[16] & 0xf8) << 13);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 133 to 148
	value = ((uint32_t)(input[16] & 0x07) << 29) |
			((uint32_t)input[17] << 21) |
			((uint32_t)(input[18] & 0xf8) << 13);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 149 to 164
	value = ((uint32_t)(input[18] & 0x07) << 29) |
			((uint32_t)input[19] << 21) |
			((uint32_t)(input[20] & 0xf8) << 13);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 165 to 180
	value = ((uint32_t)(input[20] & 0x07) << 29) |
			((uint32_t)input[21] << 21) |
			((uint32_t)(input[22] & 0xf8) << 13);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 181 to 196
	value = ((uint32_t)(input[22] & 0x07) << 29) |
			((uint32_t)input[23] << 21) |
			((uint32_t)(input[24] & 0xf8) << 13);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 197 to 212
	value = ((uint32_t)(input[24] & 0x07) << 29) |
			((uint32_t)input[25] << 21) |
			((uint32_t)(input[26] & 0xf8) << 13);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 213 to 228
	value = ((uint32_t)(input[26] & 0x07) << 29) |
			((uint32_t)input[27] << 21) |
			((uint32_t)(input[28] & 0xf8) << 13);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 229 to 244
	value = ((uint32_t)(input[28] & 0x07) << 29) |
			((uint32_t)input[29] << 21) |
			((uint32_t)(input[30] & 0xf8) << 13);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 245 to 260
	value = ((uint32_t)(input[30] & 0x07) << 29) |
			((uint32_t)input[31] << 21) |
			((uint32_t)(input[32] & 0xf8) << 13);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 261 to 276
	value = ((uint32_t)(input[32] & 0x07) << 29) |
			((uint32_t)input[33] << 21) |
			((uint32_t)(input[34] & 0xf8) << 13);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 277 to 292
	value = ((uint32_t)(input[34] & 0x07) << 29) |
			((uint32_t)input[35] << 21) |
			((uint32_t)(input[36] & 0xf8) << 13);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 293 to 308
	value = ((uint32_t)(input[36] & 0x07) << 29) |
			((uint32_t)input[37] << 21) |
			((uint32_t)(input[38] & 0xf8) << 13);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 309 to 324
	value = ((uint32_t)(input[38] & 0x07) << 29) |
			((uint32_t)input[39] << 21) |
			((uint32_t)(input[40] & 0xf8) << 13);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 325 to 340
	value = ((uint32_t)(input[40] & 0x07) << 29) |
			((uint32_t)input[41] << 21) |
			((uint32_t)(input[42] & 0xf8) << 13);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 341 to 356
	value = ((uint32_t)(input[42] & 0x07) << 29) |
			((uint32_t)input[43] << 21) |
			((uint32_t)(input[44] & 0xf8) << 13);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 357 to 372
	value = ((uint32_t)(input[44] & 0x07) << 29) |
			((uint32_t)input[45] << 21) |
			((uint32_t)(input[46] & 0xf8) << 13);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 373 to 388
	value = ((uint32_t)(input[46] & 0x07) << 29) |
			((uint32_t)input[47] << 21) |
			((uint32_t)(input[48] & 0xf8) << 13);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 389 to 404
	value = ((uint32_t)(input[48] & 0x07) << 29) |
			((uint32_t)input[49] << 21) |
			((uint32_t)(input[50] & 0xf8) << 13);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 405 to 420
	value = ((uint32_t)(input[50] & 0x07) << 29) |
			((uint32_t)input[51] << 21) |
			((uint32_t)(input[52] & 0xf8) << 13);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 421 to 436
	value = ((uint32_t)(input[52] & 0x07) << 29) |
			((uint32_t)input[53] << 21) |
			((uint32_t)(input[54] & 0xf8) << 13);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 437 to 452
	value = ((uint32_t)(input[54] & 0x07) << 29) |
			((uint32_t)input[55] << 21) |
			((uint32_t)(input[56] & 0xf8) << 13);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 453 to 468
	value = ((uint32_t)(input[56] & 0x07) << 29) |
			((uint32_t)input[57] << 21) |
			((uint32_t)(input[58] & 0xf8) << 13);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 469 to 484
	value = ((uint32_t)(input[58] & 0x07) << 29) |
			((uint32_t)input[59] << 21) |
			((uint32_t)(input[60] & 0xf8) << 13);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 485 to 500
	value = ((uint32_t)(input[60] & 0x07) << 29) |
			((uint32_t)input[61] << 21) |
			((uint32_t)(input[62] & 0xf8) << 13);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 501 to 516
	value = ((uint32_t)(input[62] & 0x07) << 29) |
			((uint32_t)input[63] << 21) |
			((uint32_t)(input[64] & 0xf8) << 13);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 517 to 532
	value = ((uint32_t)(input[64] & 0x07) << 29) |
			((uint32_t)input[65] << 21) |
			((uint32_t)(input[66] & 0xf8) << 13);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 533 to 548
	value = ((uint32_t)(input[66] & 0x07) << 29) |
			((uint32_t)input[67] << 21) |
			((uint32_t)(input[68] & 0xf8) << 13);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 549 to 564
	value = ((uint32_t)(input[68] & 0x07) << 29) |
			((uint32_t)input[69] << 21) |
			((uint32_t)(input[70] & 0xf8) << 13);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 565 to 580
	value = ((uint32_t)(input[70] & 0x07) << 29) |
			((uint32_t)input[71] << 21) |
			((uint32_t)(input[72] & 0xf8) << 13);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 581 to 596
	value = ((uint32_t)(input[72] & 0x07) << 29) |
			((uint32_t)input[73] << 21) |
			((uint32_t)(input[74] & 0xf8) << 13);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 597 to 612
	value = ((uint32_t)(input[74] & 0x07) << 29) |
			((uint32_t)input[75] << 21) |
			((uint32_t)(input[76] & 0xf8) << 13);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 613 to 628
	value = ((uint32_t)(input[76] & 0x07) << 29) |
			((uint32_t)input[77] << 21) |
			((uint32_t)(input[78] & 0xf8) << 13);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 629 to 644
	value = ((uint32_t)(input[78] & 0x07) << 29) |
			((uint32_t)input[79] << 21) |
			((uint32_t)(input[80] & 0xf8) << 13);
	output[39] = (double)(value >> 16);

	// read output[40]: from bit 645 to 660
	value = ((uint32_t)(input[80] & 0x07) << 29) |
			((uint32_t)input[81] << 21) |
			((uint32_t)(input[82] & 0xf8) << 13);
	output[40] = (double)(value >> 16);

	// read output[41]: from bit 661 to 676
	value = ((uint32_t)(input[82] & 0x07) << 29) |
			((uint32_t)input[83] << 21) |
			((uint32_t)(input[84] & 0xf8) << 13);
	output[41] = (double)(value >> 16);

	// read output[42]: from bit 677 to 692
	value = ((uint32_t)(input[84] & 0x07) << 29) |
			((uint32_t)input[85] << 21) |
			((uint32_t)(input[86] & 0xf8) << 13);
	output[42] = (double)(value >> 16);

	// read output[43]: from bit 693 to 708
	value = ((uint32_t)(input[86] & 0x07) << 29) |
			((uint32_t)input[87] << 21) |
			((uint32_t)(input[88] & 0xf8) << 13);
	output[43] = (double)(value >> 16);

	// read output[44]: from bit 709 to 724
	value = ((uint32_t)(input[88] & 0x07) << 29) |
			((uint32_t)input[89] << 21) |
			((uint32_t)(input[90] & 0xf8) << 13);
	output[44] = (double)(value >> 16);

	// read output[45]: from bit 725 to 740
	value = ((uint32_t)(input[90] & 0x07) << 29) |
			((uint32_t)input[91] << 21) |
			((uint32_t)(input[92] & 0xf8) << 13);
	output[45] = (double)(value >> 16);

	// read output[46]: from bit 741 to 756
	value = ((uint32_t)(input[92] & 0x07) << 29) |
			((uint32_t)input[93] << 21) |
			((uint32_t)(input[94] & 0xf8) << 13);
	output[46] = (double)(value >> 16);

	// read output[47]: from bit 757 to 772
	value = ((uint32_t)(input[94] & 0x07) << 29) |
			((uint32_t)input[95] << 21) |
			((uint32_t)(input[96] & 0xf8) << 13);
	output[47] = (double)(value >> 16);

	// read output[48]: from bit 773 to 788
	value = ((uint32_t)(input[96] & 0x07) << 29) |
			((uint32_t)input[97] << 21) |
			((uint32_t)(input[98] & 0xf8) << 13);
	output[48] = (double)(value >> 16);

	// read output[49]: from bit 789 to 804
	value = ((uint32_t)(input[98] & 0x07) << 29) |
			((uint32_t)input[99] << 21) |
			((uint32_t)(input[100] & 0xf8) << 13);
	output[49] = (double)(value >> 16);

	// read output[50]: from bit 805 to 820
	value = ((uint32_t)(input[100] & 0x07) << 29) |
			((uint32_t)input[101] << 21) |
			((uint32_t)(input[102] & 0xf8) << 13);
	output[50] = (double)(value >> 16);

	// read output[51]: from bit 821 to 836
	value = ((uint32_t)(input[102] & 0x07) << 29) |
			((uint32_t)input[103] << 21) |
			((uint32_t)(input[104] & 0xf8) << 13);
	output[51] = (double)(value >> 16);

	// read output[52]: from bit 837 to 852
	value = ((uint32_t)(input[104] & 0x07) << 29) |
			((uint32_t)input[105] << 21) |
			((uint32_t)(input[106] & 0xf8) << 13);
	output[52] = (double)(value >> 16);

	// read output[53]: from bit 853 to 868
	value = ((uint32_t)(input[106] & 0x07) << 29) |
			((uint32_t)input[107] << 21) |
			((uint32_t)(input[108] & 0xf8) << 13);
	output[53] = (double)(value >> 16);

	// read output[54]: from bit 869 to 884
	value = ((uint32_t)(input[108] & 0x07) << 29) |
			((uint32_t)input[109] << 21) |
			((uint32_t)(input[110] & 0xf8) << 13);
	output[54] = (double)(value >> 16);

	// read output[55]: from bit 885 to 900
	value = ((uint32_t)(input[110] & 0x07) << 29) |
			((uint32_t)input[111] << 21) |
			((uint32_t)(input[112] & 0xf8) << 13);
	output[55] = (double)(value >> 16);

	// read output[56]: from bit 901 to 916
	value = ((uint32_t)(input[112] & 0x07) << 29) |
			((uint32_t)input[113] << 21) |
			((uint32_t)(input[114] & 0xf8) << 13);
	output[56] = (double)(value >> 16);

	// read output[57]: from bit 917 to 932
	value = ((uint32_t)(input[114] & 0x07) << 29) |
			((uint32_t)input[115] << 21) |
			((uint32_t)(input[116] & 0xf8) << 13);
	output[57] = (double)(value >> 16);

	// read output[58]: from bit 933 to 948
	value = ((uint32_t)(input[116] & 0x07) << 29) |
			((uint32_t)input[117] << 21) |
			((uint32_t)(input[118] & 0xf8) << 13);
	output[58] = (double)(value >> 16);

	// read output[59]: from bit 949 to 964
	value = ((uint32_t)(input[118] & 0x07) << 29) |
			((uint32_t)input[119] << 21) |
			((uint32_t)(input[120] & 0xf8) << 13);
	output[59] = (double)(value >> 16);

	// read output[60]: from bit 965 to 980
	value = ((uint32_t)(input[120] & 0x07) << 29) |
			((uint32_t)input[121] << 21) |
			((uint32_t)(input[122] & 0xf8) << 13);
	output[60] = (double)(value >> 16);

	// read output[61]: from bit 981 to 996
	value = ((uint32_t)(input[122] & 0x07) << 29) |
			((uint32_t)input[123] << 21) |
			((uint32_t)(input[124] & 0xf8) << 13);
	output[61] = (double)(value >> 16);
}

static void unpack_62_16bit_signed_6off(const uint8_t * input, double * output, void *closure) {
	// Unpack 62 values into output
	// Values are 16-bit signed
	// Skip 6 bits, read 992 bits of data.
	// Input must be at least 125 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 6 to 21
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)(input[2] & 0xfc) << 14);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 22 to 37
	value = ((uint32_t)(input[2] & 0x03) << 30) |
			((uint32_t)input[3] << 22) |
			((uint32_t)(input[4] & 0xfc) << 14);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 38 to 53
	value = ((uint32_t)(input[4] & 0x03) << 30) |
			((uint32_t)input[5] << 22) |
			((uint32_t)(input[6] & 0xfc) << 14);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 54 to 69
	value = ((uint32_t)(input[6] & 0x03) << 30) |
			((uint32_t)input[7] << 22) |
			((uint32_t)(input[8] & 0xfc) << 14);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 70 to 85
	value = ((uint32_t)(input[8] & 0x03) << 30) |
			((uint32_t)input[9] << 22) |
			((uint32_t)(input[10] & 0xfc) << 14);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 86 to 101
	value = ((uint32_t)(input[10] & 0x03) << 30) |
			((uint32_t)input[11] << 22) |
			((uint32_t)(input[12] & 0xfc) << 14);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 102 to 117
	value = ((uint32_t)(input[12] & 0x03) << 30) |
			((uint32_t)input[13] << 22) |
			((uint32_t)(input[14] & 0xfc) << 14);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 118 to 133
	value = ((uint32_t)(input[14] & 0x03) << 30) |
			((uint32_t)input[15] << 22) |
			((uint32_t)(input[16] & 0xfc) << 14);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 134 to 149
	value = ((uint32_t)(input[16] & 0x03) << 30) |
			((uint32_t)input[17] << 22) |
			((uint32_t)(input[18] & 0xfc) << 14);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 150 to 165
	value = ((uint32_t)(input[18] & 0x03) << 30) |
			((uint32_t)input[19] << 22) |
			((uint32_t)(input[20] & 0xfc) << 14);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 166 to 181
	value = ((uint32_t)(input[20] & 0x03) << 30) |
			((uint32_t)input[21] << 22) |
			((uint32_t)(input[22] & 0xfc) << 14);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 182 to 197
	value = ((uint32_t)(input[22] & 0x03) << 30) |
			((uint32_t)input[23] << 22) |
			((uint32_t)(input[24] & 0xfc) << 14);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 198 to 213
	value = ((uint32_t)(input[24] & 0x03) << 30) |
			((uint32_t)input[25] << 22) |
			((uint32_t)(input[26] & 0xfc) << 14);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 214 to 229
	value = ((uint32_t)(input[26] & 0x03) << 30) |
			((uint32_t)input[27] << 22) |
			((uint32_t)(input[28] & 0xfc) << 14);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 230 to 245
	value = ((uint32_t)(input[28] & 0x03) << 30) |
			((uint32_t)input[29] << 22) |
			((uint32_t)(input[30] & 0xfc) << 14);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 246 to 261
	value = ((uint32_t)(input[30] & 0x03) << 30) |
			((uint32_t)input[31] << 22) |
			((uint32_t)(input[32] & 0xfc) << 14);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 262 to 277
	value = ((uint32_t)(input[32] & 0x03) << 30) |
			((uint32_t)input[33] << 22) |
			((uint32_t)(input[34] & 0xfc) << 14);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 278 to 293
	value = ((uint32_t)(input[34] & 0x03) << 30) |
			((uint32_t)input[35] << 22) |
			((uint32_t)(input[36] & 0xfc) << 14);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 294 to 309
	value = ((uint32_t)(input[36] & 0x03) << 30) |
			((uint32_t)input[37] << 22) |
			((uint32_t)(input[38] & 0xfc) << 14);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 310 to 325
	value = ((uint32_t)(input[38] & 0x03) << 30) |
			((uint32_t)input[39] << 22) |
			((uint32_t)(input[40] & 0xfc) << 14);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 326 to 341
	value = ((uint32_t)(input[40] & 0x03) << 30) |
			((uint32_t)input[41] << 22) |
			((uint32_t)(input[42] & 0xfc) << 14);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 342 to 357
	value = ((uint32_t)(input[42] & 0x03) << 30) |
			((uint32_t)input[43] << 22) |
			((uint32_t)(input[44] & 0xfc) << 14);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 358 to 373
	value = ((uint32_t)(input[44] & 0x03) << 30) |
			((uint32_t)input[45] << 22) |
			((uint32_t)(input[46] & 0xfc) << 14);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 374 to 389
	value = ((uint32_t)(input[46] & 0x03) << 30) |
			((uint32_t)input[47] << 22) |
			((uint32_t)(input[48] & 0xfc) << 14);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 390 to 405
	value = ((uint32_t)(input[48] & 0x03) << 30) |
			((uint32_t)input[49] << 22) |
			((uint32_t)(input[50] & 0xfc) << 14);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 406 to 421
	value = ((uint32_t)(input[50] & 0x03) << 30) |
			((uint32_t)input[51] << 22) |
			((uint32_t)(input[52] & 0xfc) << 14);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 422 to 437
	value = ((uint32_t)(input[52] & 0x03) << 30) |
			((uint32_t)input[53] << 22) |
			((uint32_t)(input[54] & 0xfc) << 14);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 438 to 453
	value = ((uint32_t)(input[54] & 0x03) << 30) |
			((uint32_t)input[55] << 22) |
			((uint32_t)(input[56] & 0xfc) << 14);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 454 to 469
	value = ((uint32_t)(input[56] & 0x03) << 30) |
			((uint32_t)input[57] << 22) |
			((uint32_t)(input[58] & 0xfc) << 14);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 470 to 485
	value = ((uint32_t)(input[58] & 0x03) << 30) |
			((uint32_t)input[59] << 22) |
			((uint32_t)(input[60] & 0xfc) << 14);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 486 to 501
	value = ((uint32_t)(input[60] & 0x03) << 30) |
			((uint32_t)input[61] << 22) |
			((uint32_t)(input[62] & 0xfc) << 14);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 502 to 517
	value = ((uint32_t)(input[62] & 0x03) << 30) |
			((uint32_t)input[63] << 22) |
			((uint32_t)(input[64] & 0xfc) << 14);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 518 to 533
	value = ((uint32_t)(input[64] & 0x03) << 30) |
			((uint32_t)input[65] << 22) |
			((uint32_t)(input[66] & 0xfc) << 14);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 534 to 549
	value = ((uint32_t)(input[66] & 0x03) << 30) |
			((uint32_t)input[67] << 22) |
			((uint32_t)(input[68] & 0xfc) << 14);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 550 to 565
	value = ((uint32_t)(input[68] & 0x03) << 30) |
			((uint32_t)input[69] << 22) |
			((uint32_t)(input[70] & 0xfc) << 14);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 566 to 581
	value = ((uint32_t)(input[70] & 0x03) << 30) |
			((uint32_t)input[71] << 22) |
			((uint32_t)(input[72] & 0xfc) << 14);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 582 to 597
	value = ((uint32_t)(input[72] & 0x03) << 30) |
			((uint32_t)input[73] << 22) |
			((uint32_t)(input[74] & 0xfc) << 14);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 598 to 613
	value = ((uint32_t)(input[74] & 0x03) << 30) |
			((uint32_t)input[75] << 22) |
			((uint32_t)(input[76] & 0xfc) << 14);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 614 to 629
	value = ((uint32_t)(input[76] & 0x03) << 30) |
			((uint32_t)input[77] << 22) |
			((uint32_t)(input[78] & 0xfc) << 14);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 630 to 645
	value = ((uint32_t)(input[78] & 0x03) << 30) |
			((uint32_t)input[79] << 22) |
			((uint32_t)(input[80] & 0xfc) << 14);
	output[39] = (double)(value >> 16);

	// read output[40]: from bit 646 to 661
	value = ((uint32_t)(input[80] & 0x03) << 30) |
			((uint32_t)input[81] << 22) |
			((uint32_t)(input[82] & 0xfc) << 14);
	output[40] = (double)(value >> 16);

	// read output[41]: from bit 662 to 677
	value = ((uint32_t)(input[82] & 0x03) << 30) |
			((uint32_t)input[83] << 22) |
			((uint32_t)(input[84] & 0xfc) << 14);
	output[41] = (double)(value >> 16);

	// read output[42]: from bit 678 to 693
	value = ((uint32_t)(input[84] & 0x03) << 30) |
			((uint32_t)input[85] << 22) |
			((uint32_t)(input[86] & 0xfc) << 14);
	output[42] = (double)(value >> 16);

	// read output[43]: from bit 694 to 709
	value = ((uint32_t)(input[86] & 0x03) << 30) |
			((uint32_t)input[87] << 22) |
			((uint32_t)(input[88] & 0xfc) << 14);
	output[43] = (double)(value >> 16);

	// read output[44]: from bit 710 to 725
	value = ((uint32_t)(input[88] & 0x03) << 30) |
			((uint32_t)input[89] << 22) |
			((uint32_t)(input[90] & 0xfc) << 14);
	output[44] = (double)(value >> 16);

	// read output[45]: from bit 726 to 741
	value = ((uint32_t)(input[90] & 0x03) << 30) |
			((uint32_t)input[91] << 22) |
			((uint32_t)(input[92] & 0xfc) << 14);
	output[45] = (double)(value >> 16);

	// read output[46]: from bit 742 to 757
	value = ((uint32_t)(input[92] & 0x03) << 30) |
			((uint32_t)input[93] << 22) |
			((uint32_t)(input[94] & 0xfc) << 14);
	output[46] = (double)(value >> 16);

	// read output[47]: from bit 758 to 773
	value = ((uint32_t)(input[94] & 0x03) << 30) |
			((uint32_t)input[95] << 22) |
			((uint32_t)(input[96] & 0xfc) << 14);
	output[47] = (double)(value >> 16);

	// read output[48]: from bit 774 to 789
	value = ((uint32_t)(input[96] & 0x03) << 30) |
			((uint32_t)input[97] << 22) |
			((uint32_t)(input[98] & 0xfc) << 14);
	output[48] = (double)(value >> 16);

	// read output[49]: from bit 790 to 805
	value = ((uint32_t)(input[98] & 0x03) << 30) |
			((uint32_t)input[99] << 22) |
			((uint32_t)(input[100] & 0xfc) << 14);
	output[49] = (double)(value >> 16);

	// read output[50]: from bit 806 to 821
	value = ((uint32_t)(input[100] & 0x03) << 30) |
			((uint32_t)input[101] << 22) |
			((uint32_t)(input[102] & 0xfc) << 14);
	output[50] = (double)(value >> 16);

	// read output[51]: from bit 822 to 837
	value = ((uint32_t)(input[102] & 0x03) << 30) |
			((uint32_t)input[103] << 22) |
			((uint32_t)(input[104] & 0xfc) << 14);
	output[51] = (double)(value >> 16);

	// read output[52]: from bit 838 to 853
	value = ((uint32_t)(input[104] & 0x03) << 30) |
			((uint32_t)input[105] << 22) |
			((uint32_t)(input[106] & 0xfc) << 14);
	output[52] = (double)(value >> 16);

	// read output[53]: from bit 854 to 869
	value = ((uint32_t)(input[106] & 0x03) << 30) |
			((uint32_t)input[107] << 22) |
			((uint32_t)(input[108] & 0xfc) << 14);
	output[53] = (double)(value >> 16);

	// read output[54]: from bit 870 to 885
	value = ((uint32_t)(input[108] & 0x03) << 30) |
			((uint32_t)input[109] << 22) |
			((uint32_t)(input[110] & 0xfc) << 14);
	output[54] = (double)(value >> 16);

	// read output[55]: from bit 886 to 901
	value = ((uint32_t)(input[110] & 0x03) << 30) |
			((uint32_t)input[111] << 22) |
			((uint32_t)(input[112] & 0xfc) << 14);
	output[55] = (double)(value >> 16);

	// read output[56]: from bit 902 to 917
	value = ((uint32_t)(input[112] & 0x03) << 30) |
			((uint32_t)input[113] << 22) |
			((uint32_t)(input[114] & 0xfc) << 14);
	output[56] = (double)(value >> 16);

	// read output[57]: from bit 918 to 933
	value = ((uint32_t)(input[114] & 0x03) << 30) |
			((uint32_t)input[115] << 22) |
			((uint32_t)(input[116] & 0xfc) << 14);
	output[57] = (double)(value >> 16);

	// read output[58]: from bit 934 to 949
	value = ((uint32_t)(input[116] & 0x03) << 30) |
			((uint32_t)input[117] << 22) |
			((uint32_t)(input[118] & 0xfc) << 14);
	output[58] = (double)(value >> 16);

	// read output[59]: from bit 950 to 965
	value = ((uint32_t)(input[118] & 0x03) << 30) |
			((uint32_t)input[119] << 22) |
			((uint32_t)(input[120] & 0xfc) << 14);
	output[59] = (double)(value >> 16);

	// read output[60]: from bit 966 to 981
	value = ((uint32_t)(input[120] & 0x03) << 30) |
			((uint32_t)input[121] << 22) |
			((uint32_t)(input[122] & 0xfc) << 14);
	output[60] = (double)(value >> 16);

	// read output[61]: from bit 982 to 997
	value = ((uint32_t)(input[122] & 0x03) << 30) |
			((uint32_t)input[123] << 22) |
			((uint32_t)(input[124] & 0xfc) << 14);
	output[61] = (double)(value >> 16);
}

static void unpack_62_16bit_unsigned_6off(const uint8_t * input, double * output, void *closure) {
	// Unpack 62 values into output
	// Values are 16-bit unsigned
	// Skip 6 bits, read 992 bits of data.
	// Input must be at least 125 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 6 to 21
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)(input[2] & 0xfc) << 14);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 22 to 37
	value = ((uint32_t)(input[2] & 0x03) << 30) |
			((uint32_t)input[3] << 22) |
			((uint32_t)(input[4] & 0xfc) << 14);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 38 to 53
	value = ((uint32_t)(input[4] & 0x03) << 30) |
			((uint32_t)input[5] << 22) |
			((uint32_t)(input[6] & 0xfc) << 14);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 54 to 69
	value = ((uint32_t)(input[6] & 0x03) << 30) |
			((uint32_t)input[7] << 22) |
			((uint32_t)(input[8] & 0xfc) << 14);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 70 to 85
	value = ((uint32_t)(input[8] & 0x03) << 30) |
			((uint32_t)input[9] << 22) |
			((uint32_t)(input[10] & 0xfc) << 14);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 86 to 101
	value = ((uint32_t)(input[10] & 0x03) << 30) |
			((uint32_t)input[11] << 22) |
			((uint32_t)(input[12] & 0xfc) << 14);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 102 to 117
	value = ((uint32_t)(input[12] & 0x03) << 30) |
			((uint32_t)input[13] << 22) |
			((uint32_t)(input[14] & 0xfc) << 14);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 118 to 133
	value = ((uint32_t)(input[14] & 0x03) << 30) |
			((uint32_t)input[15] << 22) |
			((uint32_t)(input[16] & 0xfc) << 14);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 134 to 149
	value = ((uint32_t)(input[16] & 0x03) << 30) |
			((uint32_t)input[17] << 22) |
			((uint32_t)(input[18] & 0xfc) << 14);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 150 to 165
	value = ((uint32_t)(input[18] & 0x03) << 30) |
			((uint32_t)input[19] << 22) |
			((uint32_t)(input[20] & 0xfc) << 14);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 166 to 181
	value = ((uint32_t)(input[20] & 0x03) << 30) |
			((uint32_t)input[21] << 22) |
			((uint32_t)(input[22] & 0xfc) << 14);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 182 to 197
	value = ((uint32_t)(input[22] & 0x03) << 30) |
			((uint32_t)input[23] << 22) |
			((uint32_t)(input[24] & 0xfc) << 14);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 198 to 213
	value = ((uint32_t)(input[24] & 0x03) << 30) |
			((uint32_t)input[25] << 22) |
			((uint32_t)(input[26] & 0xfc) << 14);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 214 to 229
	value = ((uint32_t)(input[26] & 0x03) << 30) |
			((uint32_t)input[27] << 22) |
			((uint32_t)(input[28] & 0xfc) << 14);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 230 to 245
	value = ((uint32_t)(input[28] & 0x03) << 30) |
			((uint32_t)input[29] << 22) |
			((uint32_t)(input[30] & 0xfc) << 14);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 246 to 261
	value = ((uint32_t)(input[30] & 0x03) << 30) |
			((uint32_t)input[31] << 22) |
			((uint32_t)(input[32] & 0xfc) << 14);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 262 to 277
	value = ((uint32_t)(input[32] & 0x03) << 30) |
			((uint32_t)input[33] << 22) |
			((uint32_t)(input[34] & 0xfc) << 14);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 278 to 293
	value = ((uint32_t)(input[34] & 0x03) << 30) |
			((uint32_t)input[35] << 22) |
			((uint32_t)(input[36] & 0xfc) << 14);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 294 to 309
	value = ((uint32_t)(input[36] & 0x03) << 30) |
			((uint32_t)input[37] << 22) |
			((uint32_t)(input[38] & 0xfc) << 14);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 310 to 325
	value = ((uint32_t)(input[38] & 0x03) << 30) |
			((uint32_t)input[39] << 22) |
			((uint32_t)(input[40] & 0xfc) << 14);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 326 to 341
	value = ((uint32_t)(input[40] & 0x03) << 30) |
			((uint32_t)input[41] << 22) |
			((uint32_t)(input[42] & 0xfc) << 14);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 342 to 357
	value = ((uint32_t)(input[42] & 0x03) << 30) |
			((uint32_t)input[43] << 22) |
			((uint32_t)(input[44] & 0xfc) << 14);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 358 to 373
	value = ((uint32_t)(input[44] & 0x03) << 30) |
			((uint32_t)input[45] << 22) |
			((uint32_t)(input[46] & 0xfc) << 14);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 374 to 389
	value = ((uint32_t)(input[46] & 0x03) << 30) |
			((uint32_t)input[47] << 22) |
			((uint32_t)(input[48] & 0xfc) << 14);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 390 to 405
	value = ((uint32_t)(input[48] & 0x03) << 30) |
			((uint32_t)input[49] << 22) |
			((uint32_t)(input[50] & 0xfc) << 14);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 406 to 421
	value = ((uint32_t)(input[50] & 0x03) << 30) |
			((uint32_t)input[51] << 22) |
			((uint32_t)(input[52] & 0xfc) << 14);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 422 to 437
	value = ((uint32_t)(input[52] & 0x03) << 30) |
			((uint32_t)input[53] << 22) |
			((uint32_t)(input[54] & 0xfc) << 14);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 438 to 453
	value = ((uint32_t)(input[54] & 0x03) << 30) |
			((uint32_t)input[55] << 22) |
			((uint32_t)(input[56] & 0xfc) << 14);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 454 to 469
	value = ((uint32_t)(input[56] & 0x03) << 30) |
			((uint32_t)input[57] << 22) |
			((uint32_t)(input[58] & 0xfc) << 14);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 470 to 485
	value = ((uint32_t)(input[58] & 0x03) << 30) |
			((uint32_t)input[59] << 22) |
			((uint32_t)(input[60] & 0xfc) << 14);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 486 to 501
	value = ((uint32_t)(input[60] & 0x03) << 30) |
			((uint32_t)input[61] << 22) |
			((uint32_t)(input[62] & 0xfc) << 14);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 502 to 517
	value = ((uint32_t)(input[62] & 0x03) << 30) |
			((uint32_t)input[63] << 22) |
			((uint32_t)(input[64] & 0xfc) << 14);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 518 to 533
	value = ((uint32_t)(input[64] & 0x03) << 30) |
			((uint32_t)input[65] << 22) |
			((uint32_t)(input[66] & 0xfc) << 14);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 534 to 549
	value = ((uint32_t)(input[66] & 0x03) << 30) |
			((uint32_t)input[67] << 22) |
			((uint32_t)(input[68] & 0xfc) << 14);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 550 to 565
	value = ((uint32_t)(input[68] & 0x03) << 30) |
			((uint32_t)input[69] << 22) |
			((uint32_t)(input[70] & 0xfc) << 14);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 566 to 581
	value = ((uint32_t)(input[70] & 0x03) << 30) |
			((uint32_t)input[71] << 22) |
			((uint32_t)(input[72] & 0xfc) << 14);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 582 to 597
	value = ((uint32_t)(input[72] & 0x03) << 30) |
			((uint32_t)input[73] << 22) |
			((uint32_t)(input[74] & 0xfc) << 14);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 598 to 613
	value = ((uint32_t)(input[74] & 0x03) << 30) |
			((uint32_t)input[75] << 22) |
			((uint32_t)(input[76] & 0xfc) << 14);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 614 to 629
	value = ((uint32_t)(input[76] & 0x03) << 30) |
			((uint32_t)input[77] << 22) |
			((uint32_t)(input[78] & 0xfc) << 14);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 630 to 645
	value = ((uint32_t)(input[78] & 0x03) << 30) |
			((uint32_t)input[79] << 22) |
			((uint32_t)(input[80] & 0xfc) << 14);
	output[39] = (double)(value >> 16);

	// read output[40]: from bit 646 to 661
	value = ((uint32_t)(input[80] & 0x03) << 30) |
			((uint32_t)input[81] << 22) |
			((uint32_t)(input[82] & 0xfc) << 14);
	output[40] = (double)(value >> 16);

	// read output[41]: from bit 662 to 677
	value = ((uint32_t)(input[82] & 0x03) << 30) |
			((uint32_t)input[83] << 22) |
			((uint32_t)(input[84] & 0xfc) << 14);
	output[41] = (double)(value >> 16);

	// read output[42]: from bit 678 to 693
	value = ((uint32_t)(input[84] & 0x03) << 30) |
			((uint32_t)input[85] << 22) |
			((uint32_t)(input[86] & 0xfc) << 14);
	output[42] = (double)(value >> 16);

	// read output[43]: from bit 694 to 709
	value = ((uint32_t)(input[86] & 0x03) << 30) |
			((uint32_t)input[87] << 22) |
			((uint32_t)(input[88] & 0xfc) << 14);
	output[43] = (double)(value >> 16);

	// read output[44]: from bit 710 to 725
	value = ((uint32_t)(input[88] & 0x03) << 30) |
			((uint32_t)input[89] << 22) |
			((uint32_t)(input[90] & 0xfc) << 14);
	output[44] = (double)(value >> 16);

	// read output[45]: from bit 726 to 741
	value = ((uint32_t)(input[90] & 0x03) << 30) |
			((uint32_t)input[91] << 22) |
			((uint32_t)(input[92] & 0xfc) << 14);
	output[45] = (double)(value >> 16);

	// read output[46]: from bit 742 to 757
	value = ((uint32_t)(input[92] & 0x03) << 30) |
			((uint32_t)input[93] << 22) |
			((uint32_t)(input[94] & 0xfc) << 14);
	output[46] = (double)(value >> 16);

	// read output[47]: from bit 758 to 773
	value = ((uint32_t)(input[94] & 0x03) << 30) |
			((uint32_t)input[95] << 22) |
			((uint32_t)(input[96] & 0xfc) << 14);
	output[47] = (double)(value >> 16);

	// read output[48]: from bit 774 to 789
	value = ((uint32_t)(input[96] & 0x03) << 30) |
			((uint32_t)input[97] << 22) |
			((uint32_t)(input[98] & 0xfc) << 14);
	output[48] = (double)(value >> 16);

	// read output[49]: from bit 790 to 805
	value = ((uint32_t)(input[98] & 0x03) << 30) |
			((uint32_t)input[99] << 22) |
			((uint32_t)(input[100] & 0xfc) << 14);
	output[49] = (double)(value >> 16);

	// read output[50]: from bit 806 to 821
	value = ((uint32_t)(input[100] & 0x03) << 30) |
			((uint32_t)input[101] << 22) |
			((uint32_t)(input[102] & 0xfc) << 14);
	output[50] = (double)(value >> 16);

	// read output[51]: from bit 822 to 837
	value = ((uint32_t)(input[102] & 0x03) << 30) |
			((uint32_t)input[103] << 22) |
			((uint32_t)(input[104] & 0xfc) << 14);
	output[51] = (double)(value >> 16);

	// read output[52]: from bit 838 to 853
	value = ((uint32_t)(input[104] & 0x03) << 30) |
			((uint32_t)input[105] << 22) |
			((uint32_t)(input[106] & 0xfc) << 14);
	output[52] = (double)(value >> 16);

	// read output[53]: from bit 854 to 869
	value = ((uint32_t)(input[106] & 0x03) << 30) |
			((uint32_t)input[107] << 22) |
			((uint32_t)(input[108] & 0xfc) << 14);
	output[53] = (double)(value >> 16);

	// read output[54]: from bit 870 to 885
	value = ((uint32_t)(input[108] & 0x03) << 30) |
			((uint32_t)input[109] << 22) |
			((uint32_t)(input[110] & 0xfc) << 14);
	output[54] = (double)(value >> 16);

	// read output[55]: from bit 886 to 901
	value = ((uint32_t)(input[110] & 0x03) << 30) |
			((uint32_t)input[111] << 22) |
			((uint32_t)(input[112] & 0xfc) << 14);
	output[55] = (double)(value >> 16);

	// read output[56]: from bit 902 to 917
	value = ((uint32_t)(input[112] & 0x03) << 30) |
			((uint32_t)input[113] << 22) |
			((uint32_t)(input[114] & 0xfc) << 14);
	output[56] = (double)(value >> 16);

	// read output[57]: from bit 918 to 933
	value = ((uint32_t)(input[114] & 0x03) << 30) |
			((uint32_t)input[115] << 22) |
			((uint32_t)(input[116] & 0xfc) << 14);
	output[57] = (double)(value >> 16);

	// read output[58]: from bit 934 to 949
	value = ((uint32_t)(input[116] & 0x03) << 30) |
			((uint32_t)input[117] << 22) |
			((uint32_t)(input[118] & 0xfc) << 14);
	output[58] = (double)(value >> 16);

	// read output[59]: from bit 950 to 965
	value = ((uint32_t)(input[118] & 0x03) << 30) |
			((uint32_t)input[119] << 22) |
			((uint32_t)(input[120] & 0xfc) << 14);
	output[59] = (double)(value >> 16);

	// read output[60]: from bit 966 to 981
	value = ((uint32_t)(input[120] & 0x03) << 30) |
			((uint32_t)input[121] << 22) |
			((uint32_t)(input[122] & 0xfc) << 14);
	output[60] = (double)(value >> 16);

	// read output[61]: from bit 982 to 997
	value = ((uint32_t)(input[122] & 0x03) << 30) |
			((uint32_t)input[123] << 22) |
			((uint32_t)(input[124] & 0xfc) << 14);
	output[61] = (double)(value >> 16);
}

static void unpack_62_16bit_signed_7off(const uint8_t * input, double * output, void *closure) {
	// Unpack 62 values into output
	// Values are 16-bit signed
	// Skip 7 bits, read 992 bits of data.
	// Input must be at least 125 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 7 to 22
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)(input[2] & 0xfe) << 15);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 23 to 38
	value = ((uint32_t)(input[2] & 0x01) << 31) |
			((uint32_t)input[3] << 23) |
			((uint32_t)(input[4] & 0xfe) << 15);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 39 to 54
	value = ((uint32_t)(input[4] & 0x01) << 31) |
			((uint32_t)input[5] << 23) |
			((uint32_t)(input[6] & 0xfe) << 15);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 55 to 70
	value = ((uint32_t)(input[6] & 0x01) << 31) |
			((uint32_t)input[7] << 23) |
			((uint32_t)(input[8] & 0xfe) << 15);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 71 to 86
	value = ((uint32_t)(input[8] & 0x01) << 31) |
			((uint32_t)input[9] << 23) |
			((uint32_t)(input[10] & 0xfe) << 15);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 87 to 102
	value = ((uint32_t)(input[10] & 0x01) << 31) |
			((uint32_t)input[11] << 23) |
			((uint32_t)(input[12] & 0xfe) << 15);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 103 to 118
	value = ((uint32_t)(input[12] & 0x01) << 31) |
			((uint32_t)input[13] << 23) |
			((uint32_t)(input[14] & 0xfe) << 15);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 119 to 134
	value = ((uint32_t)(input[14] & 0x01) << 31) |
			((uint32_t)input[15] << 23) |
			((uint32_t)(input[16] & 0xfe) << 15);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 135 to 150
	value = ((uint32_t)(input[16] & 0x01) << 31) |
			((uint32_t)input[17] << 23) |
			((uint32_t)(input[18] & 0xfe) << 15);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 151 to 166
	value = ((uint32_t)(input[18] & 0x01) << 31) |
			((uint32_t)input[19] << 23) |
			((uint32_t)(input[20] & 0xfe) << 15);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 167 to 182
	value = ((uint32_t)(input[20] & 0x01) << 31) |
			((uint32_t)input[21] << 23) |
			((uint32_t)(input[22] & 0xfe) << 15);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 183 to 198
	value = ((uint32_t)(input[22] & 0x01) << 31) |
			((uint32_t)input[23] << 23) |
			((uint32_t)(input[24] & 0xfe) << 15);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 199 to 214
	value = ((uint32_t)(input[24] & 0x01) << 31) |
			((uint32_t)input[25] << 23) |
			((uint32_t)(input[26] & 0xfe) << 15);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 215 to 230
	value = ((uint32_t)(input[26] & 0x01) << 31) |
			((uint32_t)input[27] << 23) |
			((uint32_t)(input[28] & 0xfe) << 15);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 231 to 246
	value = ((uint32_t)(input[28] & 0x01) << 31) |
			((uint32_t)input[29] << 23) |
			((uint32_t)(input[30] & 0xfe) << 15);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 247 to 262
	value = ((uint32_t)(input[30] & 0x01) << 31) |
			((uint32_t)input[31] << 23) |
			((uint32_t)(input[32] & 0xfe) << 15);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 263 to 278
	value = ((uint32_t)(input[32] & 0x01) << 31) |
			((uint32_t)input[33] << 23) |
			((uint32_t)(input[34] & 0xfe) << 15);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 279 to 294
	value = ((uint32_t)(input[34] & 0x01) << 31) |
			((uint32_t)input[35] << 23) |
			((uint32_t)(input[36] & 0xfe) << 15);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 295 to 310
	value = ((uint32_t)(input[36] & 0x01) << 31) |
			((uint32_t)input[37] << 23) |
			((uint32_t)(input[38] & 0xfe) << 15);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 311 to 326
	value = ((uint32_t)(input[38] & 0x01) << 31) |
			((uint32_t)input[39] << 23) |
			((uint32_t)(input[40] & 0xfe) << 15);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 327 to 342
	value = ((uint32_t)(input[40] & 0x01) << 31) |
			((uint32_t)input[41] << 23) |
			((uint32_t)(input[42] & 0xfe) << 15);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 343 to 358
	value = ((uint32_t)(input[42] & 0x01) << 31) |
			((uint32_t)input[43] << 23) |
			((uint32_t)(input[44] & 0xfe) << 15);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 359 to 374
	value = ((uint32_t)(input[44] & 0x01) << 31) |
			((uint32_t)input[45] << 23) |
			((uint32_t)(input[46] & 0xfe) << 15);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 375 to 390
	value = ((uint32_t)(input[46] & 0x01) << 31) |
			((uint32_t)input[47] << 23) |
			((uint32_t)(input[48] & 0xfe) << 15);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 391 to 406
	value = ((uint32_t)(input[48] & 0x01) << 31) |
			((uint32_t)input[49] << 23) |
			((uint32_t)(input[50] & 0xfe) << 15);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 407 to 422
	value = ((uint32_t)(input[50] & 0x01) << 31) |
			((uint32_t)input[51] << 23) |
			((uint32_t)(input[52] & 0xfe) << 15);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 423 to 438
	value = ((uint32_t)(input[52] & 0x01) << 31) |
			((uint32_t)input[53] << 23) |
			((uint32_t)(input[54] & 0xfe) << 15);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 439 to 454
	value = ((uint32_t)(input[54] & 0x01) << 31) |
			((uint32_t)input[55] << 23) |
			((uint32_t)(input[56] & 0xfe) << 15);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 455 to 470
	value = ((uint32_t)(input[56] & 0x01) << 31) |
			((uint32_t)input[57] << 23) |
			((uint32_t)(input[58] & 0xfe) << 15);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 471 to 486
	value = ((uint32_t)(input[58] & 0x01) << 31) |
			((uint32_t)input[59] << 23) |
			((uint32_t)(input[60] & 0xfe) << 15);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 487 to 502
	value = ((uint32_t)(input[60] & 0x01) << 31) |
			((uint32_t)input[61] << 23) |
			((uint32_t)(input[62] & 0xfe) << 15);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 503 to 518
	value = ((uint32_t)(input[62] & 0x01) << 31) |
			((uint32_t)input[63] << 23) |
			((uint32_t)(input[64] & 0xfe) << 15);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 519 to 534
	value = ((uint32_t)(input[64] & 0x01) << 31) |
			((uint32_t)input[65] << 23) |
			((uint32_t)(input[66] & 0xfe) << 15);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 535 to 550
	value = ((uint32_t)(input[66] & 0x01) << 31) |
			((uint32_t)input[67] << 23) |
			((uint32_t)(input[68] & 0xfe) << 15);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 551 to 566
	value = ((uint32_t)(input[68] & 0x01) << 31) |
			((uint32_t)input[69] << 23) |
			((uint32_t)(input[70] & 0xfe) << 15);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 567 to 582
	value = ((uint32_t)(input[70] & 0x01) << 31) |
			((uint32_t)input[71] << 23) |
			((uint32_t)(input[72] & 0xfe) << 15);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 583 to 598
	value = ((uint32_t)(input[72] & 0x01) << 31) |
			((uint32_t)input[73] << 23) |
			((uint32_t)(input[74] & 0xfe) << 15);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 599 to 614
	value = ((uint32_t)(input[74] & 0x01) << 31) |
			((uint32_t)input[75] << 23) |
			((uint32_t)(input[76] & 0xfe) << 15);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 615 to 630
	value = ((uint32_t)(input[76] & 0x01) << 31) |
			((uint32_t)input[77] << 23) |
			((uint32_t)(input[78] & 0xfe) << 15);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 631 to 646
	value = ((uint32_t)(input[78] & 0x01) << 31) |
			((uint32_t)input[79] << 23) |
			((uint32_t)(input[80] & 0xfe) << 15);
	output[39] = (double)(value >> 16);

	// read output[40]: from bit 647 to 662
	value = ((uint32_t)(input[80] & 0x01) << 31) |
			((uint32_t)input[81] << 23) |
			((uint32_t)(input[82] & 0xfe) << 15);
	output[40] = (double)(value >> 16);

	// read output[41]: from bit 663 to 678
	value = ((uint32_t)(input[82] & 0x01) << 31) |
			((uint32_t)input[83] << 23) |
			((uint32_t)(input[84] & 0xfe) << 15);
	output[41] = (double)(value >> 16);

	// read output[42]: from bit 679 to 694
	value = ((uint32_t)(input[84] & 0x01) << 31) |
			((uint32_t)input[85] << 23) |
			((uint32_t)(input[86] & 0xfe) << 15);
	output[42] = (double)(value >> 16);

	// read output[43]: from bit 695 to 710
	value = ((uint32_t)(input[86] & 0x01) << 31) |
			((uint32_t)input[87] << 23) |
			((uint32_t)(input[88] & 0xfe) << 15);
	output[43] = (double)(value >> 16);

	// read output[44]: from bit 711 to 726
	value = ((uint32_t)(input[88] & 0x01) << 31) |
			((uint32_t)input[89] << 23) |
			((uint32_t)(input[90] & 0xfe) << 15);
	output[44] = (double)(value >> 16);

	// read output[45]: from bit 727 to 742
	value = ((uint32_t)(input[90] & 0x01) << 31) |
			((uint32_t)input[91] << 23) |
			((uint32_t)(input[92] & 0xfe) << 15);
	output[45] = (double)(value >> 16);

	// read output[46]: from bit 743 to 758
	value = ((uint32_t)(input[92] & 0x01) << 31) |
			((uint32_t)input[93] << 23) |
			((uint32_t)(input[94] & 0xfe) << 15);
	output[46] = (double)(value >> 16);

	// read output[47]: from bit 759 to 774
	value = ((uint32_t)(input[94] & 0x01) << 31) |
			((uint32_t)input[95] << 23) |
			((uint32_t)(input[96] & 0xfe) << 15);
	output[47] = (double)(value >> 16);

	// read output[48]: from bit 775 to 790
	value = ((uint32_t)(input[96] & 0x01) << 31) |
			((uint32_t)input[97] << 23) |
			((uint32_t)(input[98] & 0xfe) << 15);
	output[48] = (double)(value >> 16);

	// read output[49]: from bit 791 to 806
	value = ((uint32_t)(input[98] & 0x01) << 31) |
			((uint32_t)input[99] << 23) |
			((uint32_t)(input[100] & 0xfe) << 15);
	output[49] = (double)(value >> 16);

	// read output[50]: from bit 807 to 822
	value = ((uint32_t)(input[100] & 0x01) << 31) |
			((uint32_t)input[101] << 23) |
			((uint32_t)(input[102] & 0xfe) << 15);
	output[50] = (double)(value >> 16);

	// read output[51]: from bit 823 to 838
	value = ((uint32_t)(input[102] & 0x01) << 31) |
			((uint32_t)input[103] << 23) |
			((uint32_t)(input[104] & 0xfe) << 15);
	output[51] = (double)(value >> 16);

	// read output[52]: from bit 839 to 854
	value = ((uint32_t)(input[104] & 0x01) << 31) |
			((uint32_t)input[105] << 23) |
			((uint32_t)(input[106] & 0xfe) << 15);
	output[52] = (double)(value >> 16);

	// read output[53]: from bit 855 to 870
	value = ((uint32_t)(input[106] & 0x01) << 31) |
			((uint32_t)input[107] << 23) |
			((uint32_t)(input[108] & 0xfe) << 15);
	output[53] = (double)(value >> 16);

	// read output[54]: from bit 871 to 886
	value = ((uint32_t)(input[108] & 0x01) << 31) |
			((uint32_t)input[109] << 23) |
			((uint32_t)(input[110] & 0xfe) << 15);
	output[54] = (double)(value >> 16);

	// read output[55]: from bit 887 to 902
	value = ((uint32_t)(input[110] & 0x01) << 31) |
			((uint32_t)input[111] << 23) |
			((uint32_t)(input[112] & 0xfe) << 15);
	output[55] = (double)(value >> 16);

	// read output[56]: from bit 903 to 918
	value = ((uint32_t)(input[112] & 0x01) << 31) |
			((uint32_t)input[113] << 23) |
			((uint32_t)(input[114] & 0xfe) << 15);
	output[56] = (double)(value >> 16);

	// read output[57]: from bit 919 to 934
	value = ((uint32_t)(input[114] & 0x01) << 31) |
			((uint32_t)input[115] << 23) |
			((uint32_t)(input[116] & 0xfe) << 15);
	output[57] = (double)(value >> 16);

	// read output[58]: from bit 935 to 950
	value = ((uint32_t)(input[116] & 0x01) << 31) |
			((uint32_t)input[117] << 23) |
			((uint32_t)(input[118] & 0xfe) << 15);
	output[58] = (double)(value >> 16);

	// read output[59]: from bit 951 to 966
	value = ((uint32_t)(input[118] & 0x01) << 31) |
			((uint32_t)input[119] << 23) |
			((uint32_t)(input[120] & 0xfe) << 15);
	output[59] = (double)(value >> 16);

	// read output[60]: from bit 967 to 982
	value = ((uint32_t)(input[120] & 0x01) << 31) |
			((uint32_t)input[121] << 23) |
			((uint32_t)(input[122] & 0xfe) << 15);
	output[60] = (double)(value >> 16);

	// read output[61]: from bit 983 to 998
	value = ((uint32_t)(input[122] & 0x01) << 31) |
			((uint32_t)input[123] << 23) |
			((uint32_t)(input[124] & 0xfe) << 15);
	output[61] = (double)(value >> 16);
}

static void unpack_62_16bit_unsigned_7off(const uint8_t * input, double * output, void *closure) {
	// Unpack 62 values into output
	// Values are 16-bit unsigned
	// Skip 7 bits, read 992 bits of data.
	// Input must be at least 125 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 7 to 22
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)(input[2] & 0xfe) << 15);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 23 to 38
	value = ((uint32_t)(input[2] & 0x01) << 31) |
			((uint32_t)input[3] << 23) |
			((uint32_t)(input[4] & 0xfe) << 15);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 39 to 54
	value = ((uint32_t)(input[4] & 0x01) << 31) |
			((uint32_t)input[5] << 23) |
			((uint32_t)(input[6] & 0xfe) << 15);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 55 to 70
	value = ((uint32_t)(input[6] & 0x01) << 31) |
			((uint32_t)input[7] << 23) |
			((uint32_t)(input[8] & 0xfe) << 15);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 71 to 86
	value = ((uint32_t)(input[8] & 0x01) << 31) |
			((uint32_t)input[9] << 23) |
			((uint32_t)(input[10] & 0xfe) << 15);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 87 to 102
	value = ((uint32_t)(input[10] & 0x01) << 31) |
			((uint32_t)input[11] << 23) |
			((uint32_t)(input[12] & 0xfe) << 15);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 103 to 118
	value = ((uint32_t)(input[12] & 0x01) << 31) |
			((uint32_t)input[13] << 23) |
			((uint32_t)(input[14] & 0xfe) << 15);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 119 to 134
	value = ((uint32_t)(input[14] & 0x01) << 31) |
			((uint32_t)input[15] << 23) |
			((uint32_t)(input[16] & 0xfe) << 15);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 135 to 150
	value = ((uint32_t)(input[16] & 0x01) << 31) |
			((uint32_t)input[17] << 23) |
			((uint32_t)(input[18] & 0xfe) << 15);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 151 to 166
	value = ((uint32_t)(input[18] & 0x01) << 31) |
			((uint32_t)input[19] << 23) |
			((uint32_t)(input[20] & 0xfe) << 15);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 167 to 182
	value = ((uint32_t)(input[20] & 0x01) << 31) |
			((uint32_t)input[21] << 23) |
			((uint32_t)(input[22] & 0xfe) << 15);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 183 to 198
	value = ((uint32_t)(input[22] & 0x01) << 31) |
			((uint32_t)input[23] << 23) |
			((uint32_t)(input[24] & 0xfe) << 15);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 199 to 214
	value = ((uint32_t)(input[24] & 0x01) << 31) |
			((uint32_t)input[25] << 23) |
			((uint32_t)(input[26] & 0xfe) << 15);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 215 to 230
	value = ((uint32_t)(input[26] & 0x01) << 31) |
			((uint32_t)input[27] << 23) |
			((uint32_t)(input[28] & 0xfe) << 15);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 231 to 246
	value = ((uint32_t)(input[28] & 0x01) << 31) |
			((uint32_t)input[29] << 23) |
			((uint32_t)(input[30] & 0xfe) << 15);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 247 to 262
	value = ((uint32_t)(input[30] & 0x01) << 31) |
			((uint32_t)input[31] << 23) |
			((uint32_t)(input[32] & 0xfe) << 15);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 263 to 278
	value = ((uint32_t)(input[32] & 0x01) << 31) |
			((uint32_t)input[33] << 23) |
			((uint32_t)(input[34] & 0xfe) << 15);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 279 to 294
	value = ((uint32_t)(input[34] & 0x01) << 31) |
			((uint32_t)input[35] << 23) |
			((uint32_t)(input[36] & 0xfe) << 15);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 295 to 310
	value = ((uint32_t)(input[36] & 0x01) << 31) |
			((uint32_t)input[37] << 23) |
			((uint32_t)(input[38] & 0xfe) << 15);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 311 to 326
	value = ((uint32_t)(input[38] & 0x01) << 31) |
			((uint32_t)input[39] << 23) |
			((uint32_t)(input[40] & 0xfe) << 15);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 327 to 342
	value = ((uint32_t)(input[40] & 0x01) << 31) |
			((uint32_t)input[41] << 23) |
			((uint32_t)(input[42] & 0xfe) << 15);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 343 to 358
	value = ((uint32_t)(input[42] & 0x01) << 31) |
			((uint32_t)input[43] << 23) |
			((uint32_t)(input[44] & 0xfe) << 15);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 359 to 374
	value = ((uint32_t)(input[44] & 0x01) << 31) |
			((uint32_t)input[45] << 23) |
			((uint32_t)(input[46] & 0xfe) << 15);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 375 to 390
	value = ((uint32_t)(input[46] & 0x01) << 31) |
			((uint32_t)input[47] << 23) |
			((uint32_t)(input[48] & 0xfe) << 15);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 391 to 406
	value = ((uint32_t)(input[48] & 0x01) << 31) |
			((uint32_t)input[49] << 23) |
			((uint32_t)(input[50] & 0xfe) << 15);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 407 to 422
	value = ((uint32_t)(input[50] & 0x01) << 31) |
			((uint32_t)input[51] << 23) |
			((uint32_t)(input[52] & 0xfe) << 15);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 423 to 438
	value = ((uint32_t)(input[52] & 0x01) << 31) |
			((uint32_t)input[53] << 23) |
			((uint32_t)(input[54] & 0xfe) << 15);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 439 to 454
	value = ((uint32_t)(input[54] & 0x01) << 31) |
			((uint32_t)input[55] << 23) |
			((uint32_t)(input[56] & 0xfe) << 15);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 455 to 470
	value = ((uint32_t)(input[56] & 0x01) << 31) |
			((uint32_t)input[57] << 23) |
			((uint32_t)(input[58] & 0xfe) << 15);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 471 to 486
	value = ((uint32_t)(input[58] & 0x01) << 31) |
			((uint32_t)input[59] << 23) |
			((uint32_t)(input[60] & 0xfe) << 15);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 487 to 502
	value = ((uint32_t)(input[60] & 0x01) << 31) |
			((uint32_t)input[61] << 23) |
			((uint32_t)(input[62] & 0xfe) << 15);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 503 to 518
	value = ((uint32_t)(input[62] & 0x01) << 31) |
			((uint32_t)input[63] << 23) |
			((uint32_t)(input[64] & 0xfe) << 15);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 519 to 534
	value = ((uint32_t)(input[64] & 0x01) << 31) |
			((uint32_t)input[65] << 23) |
			((uint32_t)(input[66] & 0xfe) << 15);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 535 to 550
	value = ((uint32_t)(input[66] & 0x01) << 31) |
			((uint32_t)input[67] << 23) |
			((uint32_t)(input[68] & 0xfe) << 15);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 551 to 566
	value = ((uint32_t)(input[68] & 0x01) << 31) |
			((uint32_t)input[69] << 23) |
			((uint32_t)(input[70] & 0xfe) << 15);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 567 to 582
	value = ((uint32_t)(input[70] & 0x01) << 31) |
			((uint32_t)input[71] << 23) |
			((uint32_t)(input[72] & 0xfe) << 15);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 583 to 598
	value = ((uint32_t)(input[72] & 0x01) << 31) |
			((uint32_t)input[73] << 23) |
			((uint32_t)(input[74] & 0xfe) << 15);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 599 to 614
	value = ((uint32_t)(input[74] & 0x01) << 31) |
			((uint32_t)input[75] << 23) |
			((uint32_t)(input[76] & 0xfe) << 15);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 615 to 630
	value = ((uint32_t)(input[76] & 0x01) << 31) |
			((uint32_t)input[77] << 23) |
			((uint32_t)(input[78] & 0xfe) << 15);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 631 to 646
	value = ((uint32_t)(input[78] & 0x01) << 31) |
			((uint32_t)input[79] << 23) |
			((uint32_t)(input[80] & 0xfe) << 15);
	output[39] = (double)(value >> 16);

	// read output[40]: from bit 647 to 662
	value = ((uint32_t)(input[80] & 0x01) << 31) |
			((uint32_t)input[81] << 23) |
			((uint32_t)(input[82] & 0xfe) << 15);
	output[40] = (double)(value >> 16);

	// read output[41]: from bit 663 to 678
	value = ((uint32_t)(input[82] & 0x01) << 31) |
			((uint32_t)input[83] << 23) |
			((uint32_t)(input[84] & 0xfe) << 15);
	output[41] = (double)(value >> 16);

	// read output[42]: from bit 679 to 694
	value = ((uint32_t)(input[84] & 0x01) << 31) |
			((uint32_t)input[85] << 23) |
			((uint32_t)(input[86] & 0xfe) << 15);
	output[42] = (double)(value >> 16);

	// read output[43]: from bit 695 to 710
	value = ((uint32_t)(input[86] & 0x01) << 31) |
			((uint32_t)input[87] << 23) |
			((uint32_t)(input[88] & 0xfe) << 15);
	output[43] = (double)(value >> 16);

	// read output[44]: from bit 711 to 726
	value = ((uint32_t)(input[88] & 0x01) << 31) |
			((uint32_t)input[89] << 23) |
			((uint32_t)(input[90] & 0xfe) << 15);
	output[44] = (double)(value >> 16);

	// read output[45]: from bit 727 to 742
	value = ((uint32_t)(input[90] & 0x01) << 31) |
			((uint32_t)input[91] << 23) |
			((uint32_t)(input[92] & 0xfe) << 15);
	output[45] = (double)(value >> 16);

	// read output[46]: from bit 743 to 758
	value = ((uint32_t)(input[92] & 0x01) << 31) |
			((uint32_t)input[93] << 23) |
			((uint32_t)(input[94] & 0xfe) << 15);
	output[46] = (double)(value >> 16);

	// read output[47]: from bit 759 to 774
	value = ((uint32_t)(input[94] & 0x01) << 31) |
			((uint32_t)input[95] << 23) |
			((uint32_t)(input[96] & 0xfe) << 15);
	output[47] = (double)(value >> 16);

	// read output[48]: from bit 775 to 790
	value = ((uint32_t)(input[96] & 0x01) << 31) |
			((uint32_t)input[97] << 23) |
			((uint32_t)(input[98] & 0xfe) << 15);
	output[48] = (double)(value >> 16);

	// read output[49]: from bit 791 to 806
	value = ((uint32_t)(input[98] & 0x01) << 31) |
			((uint32_t)input[99] << 23) |
			((uint32_t)(input[100] & 0xfe) << 15);
	output[49] = (double)(value >> 16);

	// read output[50]: from bit 807 to 822
	value = ((uint32_t)(input[100] & 0x01) << 31) |
			((uint32_t)input[101] << 23) |
			((uint32_t)(input[102] & 0xfe) << 15);
	output[50] = (double)(value >> 16);

	// read output[51]: from bit 823 to 838
	value = ((uint32_t)(input[102] & 0x01) << 31) |
			((uint32_t)input[103] << 23) |
			((uint32_t)(input[104] & 0xfe) << 15);
	output[51] = (double)(value >> 16);

	// read output[52]: from bit 839 to 854
	value = ((uint32_t)(input[104] & 0x01) << 31) |
			((uint32_t)input[105] << 23) |
			((uint32_t)(input[106] & 0xfe) << 15);
	output[52] = (double)(value >> 16);

	// read output[53]: from bit 855 to 870
	value = ((uint32_t)(input[106] & 0x01) << 31) |
			((uint32_t)input[107] << 23) |
			((uint32_t)(input[108] & 0xfe) << 15);
	output[53] = (double)(value >> 16);

	// read output[54]: from bit 871 to 886
	value = ((uint32_t)(input[108] & 0x01) << 31) |
			((uint32_t)input[109] << 23) |
			((uint32_t)(input[110] & 0xfe) << 15);
	output[54] = (double)(value >> 16);

	// read output[55]: from bit 887 to 902
	value = ((uint32_t)(input[110] & 0x01) << 31) |
			((uint32_t)input[111] << 23) |
			((uint32_t)(input[112] & 0xfe) << 15);
	output[55] = (double)(value >> 16);

	// read output[56]: from bit 903 to 918
	value = ((uint32_t)(input[112] & 0x01) << 31) |
			((uint32_t)input[113] << 23) |
			((uint32_t)(input[114] & 0xfe) << 15);
	output[56] = (double)(value >> 16);

	// read output[57]: from bit 919 to 934
	value = ((uint32_t)(input[114] & 0x01) << 31) |
			((uint32_t)input[115] << 23) |
			((uint32_t)(input[116] & 0xfe) << 15);
	output[57] = (double)(value >> 16);

	// read output[58]: from bit 935 to 950
	value = ((uint32_t)(input[116] & 0x01) << 31) |
			((uint32_t)input[117] << 23) |
			((uint32_t)(input[118] & 0xfe) << 15);
	output[58] = (double)(value >> 16);

	// read output[59]: from bit 951 to 966
	value = ((uint32_t)(input[118] & 0x01) << 31) |
			((uint32_t)input[119] << 23) |
			((uint32_t)(input[120] & 0xfe) << 15);
	output[59] = (double)(value >> 16);

	// read output[60]: from bit 967 to 982
	value = ((uint32_t)(input[120] & 0x01) << 31) |
			((uint32_t)input[121] << 23) |
			((uint32_t)(input[122] & 0xfe) << 15);
	output[60] = (double)(value >> 16);

	// read output[61]: from bit 983 to 998
	value = ((uint32_t)(input[122] & 0x01) << 31) |
			((uint32_t)input[123] << 23) |
			((uint32_t)(input[124] & 0xfe) << 15);
	output[61] = (double)(value >> 16);
}

static void unpack_63_16bit_signed_0off(const uint8_t * input, double * output, void *closure) {
	// Unpack 63 values into output
	// Values are 16-bit signed
	// Skip 0 bits, read 1008 bits of data.
	// Input must be at least 126 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 0 to 15
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)input[1] << 16);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 16 to 31
	value = ((uint32_t)input[2] << 24) |
			((uint32_t)input[3] << 16);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 32 to 47
	value = ((uint32_t)input[4] << 24) |
			((uint32_t)input[5] << 16);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 48 to 63
	value = ((uint32_t)input[6] << 24) |
			((uint32_t)input[7] << 16);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 64 to 79
	value = ((uint32_t)input[8] << 24) |
			((uint32_t)input[9] << 16);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 80 to 95
	value = ((uint32_t)input[10] << 24) |
			((uint32_t)input[11] << 16);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 96 to 111
	value = ((uint32_t)input[12] << 24) |
			((uint32_t)input[13] << 16);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 112 to 127
	value = ((uint32_t)input[14] << 24) |
			((uint32_t)input[15] << 16);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 128 to 143
	value = ((uint32_t)input[16] << 24) |
			((uint32_t)input[17] << 16);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 144 to 159
	value = ((uint32_t)input[18] << 24) |
			((uint32_t)input[19] << 16);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 160 to 175
	value = ((uint32_t)input[20] << 24) |
			((uint32_t)input[21] << 16);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 176 to 191
	value = ((uint32_t)input[22] << 24) |
			((uint32_t)input[23] << 16);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 192 to 207
	value = ((uint32_t)input[24] << 24) |
			((uint32_t)input[25] << 16);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 208 to 223
	value = ((uint32_t)input[26] << 24) |
			((uint32_t)input[27] << 16);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 224 to 239
	value = ((uint32_t)input[28] << 24) |
			((uint32_t)input[29] << 16);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 240 to 255
	value = ((uint32_t)input[30] << 24) |
			((uint32_t)input[31] << 16);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 256 to 271
	value = ((uint32_t)input[32] << 24) |
			((uint32_t)input[33] << 16);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 272 to 287
	value = ((uint32_t)input[34] << 24) |
			((uint32_t)input[35] << 16);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 288 to 303
	value = ((uint32_t)input[36] << 24) |
			((uint32_t)input[37] << 16);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 304 to 319
	value = ((uint32_t)input[38] << 24) |
			((uint32_t)input[39] << 16);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 320 to 335
	value = ((uint32_t)input[40] << 24) |
			((uint32_t)input[41] << 16);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 336 to 351
	value = ((uint32_t)input[42] << 24) |
			((uint32_t)input[43] << 16);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 352 to 367
	value = ((uint32_t)input[44] << 24) |
			((uint32_t)input[45] << 16);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 368 to 383
	value = ((uint32_t)input[46] << 24) |
			((uint32_t)input[47] << 16);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 384 to 399
	value = ((uint32_t)input[48] << 24) |
			((uint32_t)input[49] << 16);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 400 to 415
	value = ((uint32_t)input[50] << 24) |
			((uint32_t)input[51] << 16);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 416 to 431
	value = ((uint32_t)input[52] << 24) |
			((uint32_t)input[53] << 16);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 432 to 447
	value = ((uint32_t)input[54] << 24) |
			((uint32_t)input[55] << 16);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 448 to 463
	value = ((uint32_t)input[56] << 24) |
			((uint32_t)input[57] << 16);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 464 to 479
	value = ((uint32_t)input[58] << 24) |
			((uint32_t)input[59] << 16);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 480 to 495
	value = ((uint32_t)input[60] << 24) |
			((uint32_t)input[61] << 16);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 496 to 511
	value = ((uint32_t)input[62] << 24) |
			((uint32_t)input[63] << 16);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 512 to 527
	value = ((uint32_t)input[64] << 24) |
			((uint32_t)input[65] << 16);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 528 to 543
	value = ((uint32_t)input[66] << 24) |
			((uint32_t)input[67] << 16);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 544 to 559
	value = ((uint32_t)input[68] << 24) |
			((uint32_t)input[69] << 16);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 560 to 575
	value = ((uint32_t)input[70] << 24) |
			((uint32_t)input[71] << 16);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 576 to 591
	value = ((uint32_t)input[72] << 24) |
			((uint32_t)input[73] << 16);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 592 to 607
	value = ((uint32_t)input[74] << 24) |
			((uint32_t)input[75] << 16);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 608 to 623
	value = ((uint32_t)input[76] << 24) |
			((uint32_t)input[77] << 16);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 624 to 639
	value = ((uint32_t)input[78] << 24) |
			((uint32_t)input[79] << 16);
	output[39] = (double)(value >> 16);

	// read output[40]: from bit 640 to 655
	value = ((uint32_t)input[80] << 24) |
			((uint32_t)input[81] << 16);
	output[40] = (double)(value >> 16);

	// read output[41]: from bit 656 to 671
	value = ((uint32_t)input[82] << 24) |
			((uint32_t)input[83] << 16);
	output[41] = (double)(value >> 16);

	// read output[42]: from bit 672 to 687
	value = ((uint32_t)input[84] << 24) |
			((uint32_t)input[85] << 16);
	output[42] = (double)(value >> 16);

	// read output[43]: from bit 688 to 703
	value = ((uint32_t)input[86] << 24) |
			((uint32_t)input[87] << 16);
	output[43] = (double)(value >> 16);

	// read output[44]: from bit 704 to 719
	value = ((uint32_t)input[88] << 24) |
			((uint32_t)input[89] << 16);
	output[44] = (double)(value >> 16);

	// read output[45]: from bit 720 to 735
	value = ((uint32_t)input[90] << 24) |
			((uint32_t)input[91] << 16);
	output[45] = (double)(value >> 16);

	// read output[46]: from bit 736 to 751
	value = ((uint32_t)input[92] << 24) |
			((uint32_t)input[93] << 16);
	output[46] = (double)(value >> 16);

	// read output[47]: from bit 752 to 767
	value = ((uint32_t)input[94] << 24) |
			((uint32_t)input[95] << 16);
	output[47] = (double)(value >> 16);

	// read output[48]: from bit 768 to 783
	value = ((uint32_t)input[96] << 24) |
			((uint32_t)input[97] << 16);
	output[48] = (double)(value >> 16);

	// read output[49]: from bit 784 to 799
	value = ((uint32_t)input[98] << 24) |
			((uint32_t)input[99] << 16);
	output[49] = (double)(value >> 16);

	// read output[50]: from bit 800 to 815
	value = ((uint32_t)input[100] << 24) |
			((uint32_t)input[101] << 16);
	output[50] = (double)(value >> 16);

	// read output[51]: from bit 816 to 831
	value = ((uint32_t)input[102] << 24) |
			((uint32_t)input[103] << 16);
	output[51] = (double)(value >> 16);

	// read output[52]: from bit 832 to 847
	value = ((uint32_t)input[104] << 24) |
			((uint32_t)input[105] << 16);
	output[52] = (double)(value >> 16);

	// read output[53]: from bit 848 to 863
	value = ((uint32_t)input[106] << 24) |
			((uint32_t)input[107] << 16);
	output[53] = (double)(value >> 16);

	// read output[54]: from bit 864 to 879
	value = ((uint32_t)input[108] << 24) |
			((uint32_t)input[109] << 16);
	output[54] = (double)(value >> 16);

	// read output[55]: from bit 880 to 895
	value = ((uint32_t)input[110] << 24) |
			((uint32_t)input[111] << 16);
	output[55] = (double)(value >> 16);

	// read output[56]: from bit 896 to 911
	value = ((uint32_t)input[112] << 24) |
			((uint32_t)input[113] << 16);
	output[56] = (double)(value >> 16);

	// read output[57]: from bit 912 to 927
	value = ((uint32_t)input[114] << 24) |
			((uint32_t)input[115] << 16);
	output[57] = (double)(value >> 16);

	// read output[58]: from bit 928 to 943
	value = ((uint32_t)input[116] << 24) |
			((uint32_t)input[117] << 16);
	output[58] = (double)(value >> 16);

	// read output[59]: from bit 944 to 959
	value = ((uint32_t)input[118] << 24) |
			((uint32_t)input[119] << 16);
	output[59] = (double)(value >> 16);

	// read output[60]: from bit 960 to 975
	value = ((uint32_t)input[120] << 24) |
			((uint32_t)input[121] << 16);
	output[60] = (double)(value >> 16);

	// read output[61]: from bit 976 to 991
	value = ((uint32_t)input[122] << 24) |
			((uint32_t)input[123] << 16);
	output[61] = (double)(value >> 16);

	// read output[62]: from bit 992 to 1007
	value = ((uint32_t)input[124] << 24) |
			((uint32_t)input[125] << 16);
	output[62] = (double)(value >> 16);
}

static void unpack_63_16bit_unsigned_0off(const uint8_t * input, double * output, void *closure) {
	// Unpack 63 values into output
	// Values are 16-bit unsigned
	// Skip 0 bits, read 1008 bits of data.
	// Input must be at least 126 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 0 to 15
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)input[1] << 16);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 16 to 31
	value = ((uint32_t)input[2] << 24) |
			((uint32_t)input[3] << 16);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 32 to 47
	value = ((uint32_t)input[4] << 24) |
			((uint32_t)input[5] << 16);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 48 to 63
	value = ((uint32_t)input[6] << 24) |
			((uint32_t)input[7] << 16);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 64 to 79
	value = ((uint32_t)input[8] << 24) |
			((uint32_t)input[9] << 16);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 80 to 95
	value = ((uint32_t)input[10] << 24) |
			((uint32_t)input[11] << 16);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 96 to 111
	value = ((uint32_t)input[12] << 24) |
			((uint32_t)input[13] << 16);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 112 to 127
	value = ((uint32_t)input[14] << 24) |
			((uint32_t)input[15] << 16);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 128 to 143
	value = ((uint32_t)input[16] << 24) |
			((uint32_t)input[17] << 16);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 144 to 159
	value = ((uint32_t)input[18] << 24) |
			((uint32_t)input[19] << 16);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 160 to 175
	value = ((uint32_t)input[20] << 24) |
			((uint32_t)input[21] << 16);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 176 to 191
	value = ((uint32_t)input[22] << 24) |
			((uint32_t)input[23] << 16);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 192 to 207
	value = ((uint32_t)input[24] << 24) |
			((uint32_t)input[25] << 16);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 208 to 223
	value = ((uint32_t)input[26] << 24) |
			((uint32_t)input[27] << 16);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 224 to 239
	value = ((uint32_t)input[28] << 24) |
			((uint32_t)input[29] << 16);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 240 to 255
	value = ((uint32_t)input[30] << 24) |
			((uint32_t)input[31] << 16);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 256 to 271
	value = ((uint32_t)input[32] << 24) |
			((uint32_t)input[33] << 16);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 272 to 287
	value = ((uint32_t)input[34] << 24) |
			((uint32_t)input[35] << 16);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 288 to 303
	value = ((uint32_t)input[36] << 24) |
			((uint32_t)input[37] << 16);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 304 to 319
	value = ((uint32_t)input[38] << 24) |
			((uint32_t)input[39] << 16);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 320 to 335
	value = ((uint32_t)input[40] << 24) |
			((uint32_t)input[41] << 16);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 336 to 351
	value = ((uint32_t)input[42] << 24) |
			((uint32_t)input[43] << 16);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 352 to 367
	value = ((uint32_t)input[44] << 24) |
			((uint32_t)input[45] << 16);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 368 to 383
	value = ((uint32_t)input[46] << 24) |
			((uint32_t)input[47] << 16);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 384 to 399
	value = ((uint32_t)input[48] << 24) |
			((uint32_t)input[49] << 16);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 400 to 415
	value = ((uint32_t)input[50] << 24) |
			((uint32_t)input[51] << 16);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 416 to 431
	value = ((uint32_t)input[52] << 24) |
			((uint32_t)input[53] << 16);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 432 to 447
	value = ((uint32_t)input[54] << 24) |
			((uint32_t)input[55] << 16);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 448 to 463
	value = ((uint32_t)input[56] << 24) |
			((uint32_t)input[57] << 16);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 464 to 479
	value = ((uint32_t)input[58] << 24) |
			((uint32_t)input[59] << 16);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 480 to 495
	value = ((uint32_t)input[60] << 24) |
			((uint32_t)input[61] << 16);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 496 to 511
	value = ((uint32_t)input[62] << 24) |
			((uint32_t)input[63] << 16);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 512 to 527
	value = ((uint32_t)input[64] << 24) |
			((uint32_t)input[65] << 16);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 528 to 543
	value = ((uint32_t)input[66] << 24) |
			((uint32_t)input[67] << 16);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 544 to 559
	value = ((uint32_t)input[68] << 24) |
			((uint32_t)input[69] << 16);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 560 to 575
	value = ((uint32_t)input[70] << 24) |
			((uint32_t)input[71] << 16);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 576 to 591
	value = ((uint32_t)input[72] << 24) |
			((uint32_t)input[73] << 16);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 592 to 607
	value = ((uint32_t)input[74] << 24) |
			((uint32_t)input[75] << 16);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 608 to 623
	value = ((uint32_t)input[76] << 24) |
			((uint32_t)input[77] << 16);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 624 to 639
	value = ((uint32_t)input[78] << 24) |
			((uint32_t)input[79] << 16);
	output[39] = (double)(value >> 16);

	// read output[40]: from bit 640 to 655
	value = ((uint32_t)input[80] << 24) |
			((uint32_t)input[81] << 16);
	output[40] = (double)(value >> 16);

	// read output[41]: from bit 656 to 671
	value = ((uint32_t)input[82] << 24) |
			((uint32_t)input[83] << 16);
	output[41] = (double)(value >> 16);

	// read output[42]: from bit 672 to 687
	value = ((uint32_t)input[84] << 24) |
			((uint32_t)input[85] << 16);
	output[42] = (double)(value >> 16);

	// read output[43]: from bit 688 to 703
	value = ((uint32_t)input[86] << 24) |
			((uint32_t)input[87] << 16);
	output[43] = (double)(value >> 16);

	// read output[44]: from bit 704 to 719
	value = ((uint32_t)input[88] << 24) |
			((uint32_t)input[89] << 16);
	output[44] = (double)(value >> 16);

	// read output[45]: from bit 720 to 735
	value = ((uint32_t)input[90] << 24) |
			((uint32_t)input[91] << 16);
	output[45] = (double)(value >> 16);

	// read output[46]: from bit 736 to 751
	value = ((uint32_t)input[92] << 24) |
			((uint32_t)input[93] << 16);
	output[46] = (double)(value >> 16);

	// read output[47]: from bit 752 to 767
	value = ((uint32_t)input[94] << 24) |
			((uint32_t)input[95] << 16);
	output[47] = (double)(value >> 16);

	// read output[48]: from bit 768 to 783
	value = ((uint32_t)input[96] << 24) |
			((uint32_t)input[97] << 16);
	output[48] = (double)(value >> 16);

	// read output[49]: from bit 784 to 799
	value = ((uint32_t)input[98] << 24) |
			((uint32_t)input[99] << 16);
	output[49] = (double)(value >> 16);

	// read output[50]: from bit 800 to 815
	value = ((uint32_t)input[100] << 24) |
			((uint32_t)input[101] << 16);
	output[50] = (double)(value >> 16);

	// read output[51]: from bit 816 to 831
	value = ((uint32_t)input[102] << 24) |
			((uint32_t)input[103] << 16);
	output[51] = (double)(value >> 16);

	// read output[52]: from bit 832 to 847
	value = ((uint32_t)input[104] << 24) |
			((uint32_t)input[105] << 16);
	output[52] = (double)(value >> 16);

	// read output[53]: from bit 848 to 863
	value = ((uint32_t)input[106] << 24) |
			((uint32_t)input[107] << 16);
	output[53] = (double)(value >> 16);

	// read output[54]: from bit 864 to 879
	value = ((uint32_t)input[108] << 24) |
			((uint32_t)input[109] << 16);
	output[54] = (double)(value >> 16);

	// read output[55]: from bit 880 to 895
	value = ((uint32_t)input[110] << 24) |
			((uint32_t)input[111] << 16);
	output[55] = (double)(value >> 16);

	// read output[56]: from bit 896 to 911
	value = ((uint32_t)input[112] << 24) |
			((uint32_t)input[113] << 16);
	output[56] = (double)(value >> 16);

	// read output[57]: from bit 912 to 927
	value = ((uint32_t)input[114] << 24) |
			((uint32_t)input[115] << 16);
	output[57] = (double)(value >> 16);

	// read output[58]: from bit 928 to 943
	value = ((uint32_t)input[116] << 24) |
			((uint32_t)input[117] << 16);
	output[58] = (double)(value >> 16);

	// read output[59]: from bit 944 to 959
	value = ((uint32_t)input[118] << 24) |
			((uint32_t)input[119] << 16);
	output[59] = (double)(value >> 16);

	// read output[60]: from bit 960 to 975
	value = ((uint32_t)input[120] << 24) |
			((uint32_t)input[121] << 16);
	output[60] = (double)(value >> 16);

	// read output[61]: from bit 976 to 991
	value = ((uint32_t)input[122] << 24) |
			((uint32_t)input[123] << 16);
	output[61] = (double)(value >> 16);

	// read output[62]: from bit 992 to 1007
	value = ((uint32_t)input[124] << 24) |
			((uint32_t)input[125] << 16);
	output[62] = (double)(value >> 16);
}

static void unpack_63_16bit_signed_1off(const uint8_t * input, double * output, void *closure) {
	// Unpack 63 values into output
	// Values are 16-bit signed
	// Skip 1 bits, read 1008 bits of data.
	// Input must be at least 127 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 1 to 16
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)input[1] << 17) |
			((uint32_t)(input[2] & 0x80) << 9);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 17 to 32
	value = ((uint32_t)(input[2] & 0x7f) << 25) |
			((uint32_t)input[3] << 17) |
			((uint32_t)(input[4] & 0x80) << 9);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 33 to 48
	value = ((uint32_t)(input[4] & 0x7f) << 25) |
			((uint32_t)input[5] << 17) |
			((uint32_t)(input[6] & 0x80) << 9);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 49 to 64
	value = ((uint32_t)(input[6] & 0x7f) << 25) |
			((uint32_t)input[7] << 17) |
			((uint32_t)(input[8] & 0x80) << 9);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 65 to 80
	value = ((uint32_t)(input[8] & 0x7f) << 25) |
			((uint32_t)input[9] << 17) |
			((uint32_t)(input[10] & 0x80) << 9);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 81 to 96
	value = ((uint32_t)(input[10] & 0x7f) << 25) |
			((uint32_t)input[11] << 17) |
			((uint32_t)(input[12] & 0x80) << 9);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 97 to 112
	value = ((uint32_t)(input[12] & 0x7f) << 25) |
			((uint32_t)input[13] << 17) |
			((uint32_t)(input[14] & 0x80) << 9);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 113 to 128
	value = ((uint32_t)(input[14] & 0x7f) << 25) |
			((uint32_t)input[15] << 17) |
			((uint32_t)(input[16] & 0x80) << 9);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 129 to 144
	value = ((uint32_t)(input[16] & 0x7f) << 25) |
			((uint32_t)input[17] << 17) |
			((uint32_t)(input[18] & 0x80) << 9);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 145 to 160
	value = ((uint32_t)(input[18] & 0x7f) << 25) |
			((uint32_t)input[19] << 17) |
			((uint32_t)(input[20] & 0x80) << 9);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 161 to 176
	value = ((uint32_t)(input[20] & 0x7f) << 25) |
			((uint32_t)input[21] << 17) |
			((uint32_t)(input[22] & 0x80) << 9);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 177 to 192
	value = ((uint32_t)(input[22] & 0x7f) << 25) |
			((uint32_t)input[23] << 17) |
			((uint32_t)(input[24] & 0x80) << 9);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 193 to 208
	value = ((uint32_t)(input[24] & 0x7f) << 25) |
			((uint32_t)input[25] << 17) |
			((uint32_t)(input[26] & 0x80) << 9);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 209 to 224
	value = ((uint32_t)(input[26] & 0x7f) << 25) |
			((uint32_t)input[27] << 17) |
			((uint32_t)(input[28] & 0x80) << 9);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 225 to 240
	value = ((uint32_t)(input[28] & 0x7f) << 25) |
			((uint32_t)input[29] << 17) |
			((uint32_t)(input[30] & 0x80) << 9);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 241 to 256
	value = ((uint32_t)(input[30] & 0x7f) << 25) |
			((uint32_t)input[31] << 17) |
			((uint32_t)(input[32] & 0x80) << 9);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 257 to 272
	value = ((uint32_t)(input[32] & 0x7f) << 25) |
			((uint32_t)input[33] << 17) |
			((uint32_t)(input[34] & 0x80) << 9);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 273 to 288
	value = ((uint32_t)(input[34] & 0x7f) << 25) |
			((uint32_t)input[35] << 17) |
			((uint32_t)(input[36] & 0x80) << 9);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 289 to 304
	value = ((uint32_t)(input[36] & 0x7f) << 25) |
			((uint32_t)input[37] << 17) |
			((uint32_t)(input[38] & 0x80) << 9);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 305 to 320
	value = ((uint32_t)(input[38] & 0x7f) << 25) |
			((uint32_t)input[39] << 17) |
			((uint32_t)(input[40] & 0x80) << 9);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 321 to 336
	value = ((uint32_t)(input[40] & 0x7f) << 25) |
			((uint32_t)input[41] << 17) |
			((uint32_t)(input[42] & 0x80) << 9);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 337 to 352
	value = ((uint32_t)(input[42] & 0x7f) << 25) |
			((uint32_t)input[43] << 17) |
			((uint32_t)(input[44] & 0x80) << 9);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 353 to 368
	value = ((uint32_t)(input[44] & 0x7f) << 25) |
			((uint32_t)input[45] << 17) |
			((uint32_t)(input[46] & 0x80) << 9);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 369 to 384
	value = ((uint32_t)(input[46] & 0x7f) << 25) |
			((uint32_t)input[47] << 17) |
			((uint32_t)(input[48] & 0x80) << 9);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 385 to 400
	value = ((uint32_t)(input[48] & 0x7f) << 25) |
			((uint32_t)input[49] << 17) |
			((uint32_t)(input[50] & 0x80) << 9);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 401 to 416
	value = ((uint32_t)(input[50] & 0x7f) << 25) |
			((uint32_t)input[51] << 17) |
			((uint32_t)(input[52] & 0x80) << 9);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 417 to 432
	value = ((uint32_t)(input[52] & 0x7f) << 25) |
			((uint32_t)input[53] << 17) |
			((uint32_t)(input[54] & 0x80) << 9);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 433 to 448
	value = ((uint32_t)(input[54] & 0x7f) << 25) |
			((uint32_t)input[55] << 17) |
			((uint32_t)(input[56] & 0x80) << 9);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 449 to 464
	value = ((uint32_t)(input[56] & 0x7f) << 25) |
			((uint32_t)input[57] << 17) |
			((uint32_t)(input[58] & 0x80) << 9);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 465 to 480
	value = ((uint32_t)(input[58] & 0x7f) << 25) |
			((uint32_t)input[59] << 17) |
			((uint32_t)(input[60] & 0x80) << 9);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 481 to 496
	value = ((uint32_t)(input[60] & 0x7f) << 25) |
			((uint32_t)input[61] << 17) |
			((uint32_t)(input[62] & 0x80) << 9);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 497 to 512
	value = ((uint32_t)(input[62] & 0x7f) << 25) |
			((uint32_t)input[63] << 17) |
			((uint32_t)(input[64] & 0x80) << 9);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 513 to 528
	value = ((uint32_t)(input[64] & 0x7f) << 25) |
			((uint32_t)input[65] << 17) |
			((uint32_t)(input[66] & 0x80) << 9);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 529 to 544
	value = ((uint32_t)(input[66] & 0x7f) << 25) |
			((uint32_t)input[67] << 17) |
			((uint32_t)(input[68] & 0x80) << 9);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 545 to 560
	value = ((uint32_t)(input[68] & 0x7f) << 25) |
			((uint32_t)input[69] << 17) |
			((uint32_t)(input[70] & 0x80) << 9);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 561 to 576
	value = ((uint32_t)(input[70] & 0x7f) << 25) |
			((uint32_t)input[71] << 17) |
			((uint32_t)(input[72] & 0x80) << 9);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 577 to 592
	value = ((uint32_t)(input[72] & 0x7f) << 25) |
			((uint32_t)input[73] << 17) |
			((uint32_t)(input[74] & 0x80) << 9);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 593 to 608
	value = ((uint32_t)(input[74] & 0x7f) << 25) |
			((uint32_t)input[75] << 17) |
			((uint32_t)(input[76] & 0x80) << 9);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 609 to 624
	value = ((uint32_t)(input[76] & 0x7f) << 25) |
			((uint32_t)input[77] << 17) |
			((uint32_t)(input[78] & 0x80) << 9);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 625 to 640
	value = ((uint32_t)(input[78] & 0x7f) << 25) |
			((uint32_t)input[79] << 17) |
			((uint32_t)(input[80] & 0x80) << 9);
	output[39] = (double)(value >> 16);

	// read output[40]: from bit 641 to 656
	value = ((uint32_t)(input[80] & 0x7f) << 25) |
			((uint32_t)input[81] << 17) |
			((uint32_t)(input[82] & 0x80) << 9);
	output[40] = (double)(value >> 16);

	// read output[41]: from bit 657 to 672
	value = ((uint32_t)(input[82] & 0x7f) << 25) |
			((uint32_t)input[83] << 17) |
			((uint32_t)(input[84] & 0x80) << 9);
	output[41] = (double)(value >> 16);

	// read output[42]: from bit 673 to 688
	value = ((uint32_t)(input[84] & 0x7f) << 25) |
			((uint32_t)input[85] << 17) |
			((uint32_t)(input[86] & 0x80) << 9);
	output[42] = (double)(value >> 16);

	// read output[43]: from bit 689 to 704
	value = ((uint32_t)(input[86] & 0x7f) << 25) |
			((uint32_t)input[87] << 17) |
			((uint32_t)(input[88] & 0x80) << 9);
	output[43] = (double)(value >> 16);

	// read output[44]: from bit 705 to 720
	value = ((uint32_t)(input[88] & 0x7f) << 25) |
			((uint32_t)input[89] << 17) |
			((uint32_t)(input[90] & 0x80) << 9);
	output[44] = (double)(value >> 16);

	// read output[45]: from bit 721 to 736
	value = ((uint32_t)(input[90] & 0x7f) << 25) |
			((uint32_t)input[91] << 17) |
			((uint32_t)(input[92] & 0x80) << 9);
	output[45] = (double)(value >> 16);

	// read output[46]: from bit 737 to 752
	value = ((uint32_t)(input[92] & 0x7f) << 25) |
			((uint32_t)input[93] << 17) |
			((uint32_t)(input[94] & 0x80) << 9);
	output[46] = (double)(value >> 16);

	// read output[47]: from bit 753 to 768
	value = ((uint32_t)(input[94] & 0x7f) << 25) |
			((uint32_t)input[95] << 17) |
			((uint32_t)(input[96] & 0x80) << 9);
	output[47] = (double)(value >> 16);

	// read output[48]: from bit 769 to 784
	value = ((uint32_t)(input[96] & 0x7f) << 25) |
			((uint32_t)input[97] << 17) |
			((uint32_t)(input[98] & 0x80) << 9);
	output[48] = (double)(value >> 16);

	// read output[49]: from bit 785 to 800
	value = ((uint32_t)(input[98] & 0x7f) << 25) |
			((uint32_t)input[99] << 17) |
			((uint32_t)(input[100] & 0x80) << 9);
	output[49] = (double)(value >> 16);

	// read output[50]: from bit 801 to 816
	value = ((uint32_t)(input[100] & 0x7f) << 25) |
			((uint32_t)input[101] << 17) |
			((uint32_t)(input[102] & 0x80) << 9);
	output[50] = (double)(value >> 16);

	// read output[51]: from bit 817 to 832
	value = ((uint32_t)(input[102] & 0x7f) << 25) |
			((uint32_t)input[103] << 17) |
			((uint32_t)(input[104] & 0x80) << 9);
	output[51] = (double)(value >> 16);

	// read output[52]: from bit 833 to 848
	value = ((uint32_t)(input[104] & 0x7f) << 25) |
			((uint32_t)input[105] << 17) |
			((uint32_t)(input[106] & 0x80) << 9);
	output[52] = (double)(value >> 16);

	// read output[53]: from bit 849 to 864
	value = ((uint32_t)(input[106] & 0x7f) << 25) |
			((uint32_t)input[107] << 17) |
			((uint32_t)(input[108] & 0x80) << 9);
	output[53] = (double)(value >> 16);

	// read output[54]: from bit 865 to 880
	value = ((uint32_t)(input[108] & 0x7f) << 25) |
			((uint32_t)input[109] << 17) |
			((uint32_t)(input[110] & 0x80) << 9);
	output[54] = (double)(value >> 16);

	// read output[55]: from bit 881 to 896
	value = ((uint32_t)(input[110] & 0x7f) << 25) |
			((uint32_t)input[111] << 17) |
			((uint32_t)(input[112] & 0x80) << 9);
	output[55] = (double)(value >> 16);

	// read output[56]: from bit 897 to 912
	value = ((uint32_t)(input[112] & 0x7f) << 25) |
			((uint32_t)input[113] << 17) |
			((uint32_t)(input[114] & 0x80) << 9);
	output[56] = (double)(value >> 16);

	// read output[57]: from bit 913 to 928
	value = ((uint32_t)(input[114] & 0x7f) << 25) |
			((uint32_t)input[115] << 17) |
			((uint32_t)(input[116] & 0x80) << 9);
	output[57] = (double)(value >> 16);

	// read output[58]: from bit 929 to 944
	value = ((uint32_t)(input[116] & 0x7f) << 25) |
			((uint32_t)input[117] << 17) |
			((uint32_t)(input[118] & 0x80) << 9);
	output[58] = (double)(value >> 16);

	// read output[59]: from bit 945 to 960
	value = ((uint32_t)(input[118] & 0x7f) << 25) |
			((uint32_t)input[119] << 17) |
			((uint32_t)(input[120] & 0x80) << 9);
	output[59] = (double)(value >> 16);

	// read output[60]: from bit 961 to 976
	value = ((uint32_t)(input[120] & 0x7f) << 25) |
			((uint32_t)input[121] << 17) |
			((uint32_t)(input[122] & 0x80) << 9);
	output[60] = (double)(value >> 16);

	// read output[61]: from bit 977 to 992
	value = ((uint32_t)(input[122] & 0x7f) << 25) |
			((uint32_t)input[123] << 17) |
			((uint32_t)(input[124] & 0x80) << 9);
	output[61] = (double)(value >> 16);

	// read output[62]: from bit 993 to 1008
	value = ((uint32_t)(input[124] & 0x7f) << 25) |
			((uint32_t)input[125] << 17) |
			((uint32_t)(input[126] & 0x80) << 9);
	output[62] = (double)(value >> 16);
}

static void unpack_63_16bit_unsigned_1off(const uint8_t * input, double * output, void *closure) {
	// Unpack 63 values into output
	// Values are 16-bit unsigned
	// Skip 1 bits, read 1008 bits of data.
	// Input must be at least 127 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 1 to 16
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)input[1] << 17) |
			((uint32_t)(input[2] & 0x80) << 9);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 17 to 32
	value = ((uint32_t)(input[2] & 0x7f) << 25) |
			((uint32_t)input[3] << 17) |
			((uint32_t)(input[4] & 0x80) << 9);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 33 to 48
	value = ((uint32_t)(input[4] & 0x7f) << 25) |
			((uint32_t)input[5] << 17) |
			((uint32_t)(input[6] & 0x80) << 9);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 49 to 64
	value = ((uint32_t)(input[6] & 0x7f) << 25) |
			((uint32_t)input[7] << 17) |
			((uint32_t)(input[8] & 0x80) << 9);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 65 to 80
	value = ((uint32_t)(input[8] & 0x7f) << 25) |
			((uint32_t)input[9] << 17) |
			((uint32_t)(input[10] & 0x80) << 9);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 81 to 96
	value = ((uint32_t)(input[10] & 0x7f) << 25) |
			((uint32_t)input[11] << 17) |
			((uint32_t)(input[12] & 0x80) << 9);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 97 to 112
	value = ((uint32_t)(input[12] & 0x7f) << 25) |
			((uint32_t)input[13] << 17) |
			((uint32_t)(input[14] & 0x80) << 9);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 113 to 128
	value = ((uint32_t)(input[14] & 0x7f) << 25) |
			((uint32_t)input[15] << 17) |
			((uint32_t)(input[16] & 0x80) << 9);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 129 to 144
	value = ((uint32_t)(input[16] & 0x7f) << 25) |
			((uint32_t)input[17] << 17) |
			((uint32_t)(input[18] & 0x80) << 9);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 145 to 160
	value = ((uint32_t)(input[18] & 0x7f) << 25) |
			((uint32_t)input[19] << 17) |
			((uint32_t)(input[20] & 0x80) << 9);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 161 to 176
	value = ((uint32_t)(input[20] & 0x7f) << 25) |
			((uint32_t)input[21] << 17) |
			((uint32_t)(input[22] & 0x80) << 9);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 177 to 192
	value = ((uint32_t)(input[22] & 0x7f) << 25) |
			((uint32_t)input[23] << 17) |
			((uint32_t)(input[24] & 0x80) << 9);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 193 to 208
	value = ((uint32_t)(input[24] & 0x7f) << 25) |
			((uint32_t)input[25] << 17) |
			((uint32_t)(input[26] & 0x80) << 9);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 209 to 224
	value = ((uint32_t)(input[26] & 0x7f) << 25) |
			((uint32_t)input[27] << 17) |
			((uint32_t)(input[28] & 0x80) << 9);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 225 to 240
	value = ((uint32_t)(input[28] & 0x7f) << 25) |
			((uint32_t)input[29] << 17) |
			((uint32_t)(input[30] & 0x80) << 9);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 241 to 256
	value = ((uint32_t)(input[30] & 0x7f) << 25) |
			((uint32_t)input[31] << 17) |
			((uint32_t)(input[32] & 0x80) << 9);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 257 to 272
	value = ((uint32_t)(input[32] & 0x7f) << 25) |
			((uint32_t)input[33] << 17) |
			((uint32_t)(input[34] & 0x80) << 9);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 273 to 288
	value = ((uint32_t)(input[34] & 0x7f) << 25) |
			((uint32_t)input[35] << 17) |
			((uint32_t)(input[36] & 0x80) << 9);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 289 to 304
	value = ((uint32_t)(input[36] & 0x7f) << 25) |
			((uint32_t)input[37] << 17) |
			((uint32_t)(input[38] & 0x80) << 9);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 305 to 320
	value = ((uint32_t)(input[38] & 0x7f) << 25) |
			((uint32_t)input[39] << 17) |
			((uint32_t)(input[40] & 0x80) << 9);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 321 to 336
	value = ((uint32_t)(input[40] & 0x7f) << 25) |
			((uint32_t)input[41] << 17) |
			((uint32_t)(input[42] & 0x80) << 9);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 337 to 352
	value = ((uint32_t)(input[42] & 0x7f) << 25) |
			((uint32_t)input[43] << 17) |
			((uint32_t)(input[44] & 0x80) << 9);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 353 to 368
	value = ((uint32_t)(input[44] & 0x7f) << 25) |
			((uint32_t)input[45] << 17) |
			((uint32_t)(input[46] & 0x80) << 9);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 369 to 384
	value = ((uint32_t)(input[46] & 0x7f) << 25) |
			((uint32_t)input[47] << 17) |
			((uint32_t)(input[48] & 0x80) << 9);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 385 to 400
	value = ((uint32_t)(input[48] & 0x7f) << 25) |
			((uint32_t)input[49] << 17) |
			((uint32_t)(input[50] & 0x80) << 9);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 401 to 416
	value = ((uint32_t)(input[50] & 0x7f) << 25) |
			((uint32_t)input[51] << 17) |
			((uint32_t)(input[52] & 0x80) << 9);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 417 to 432
	value = ((uint32_t)(input[52] & 0x7f) << 25) |
			((uint32_t)input[53] << 17) |
			((uint32_t)(input[54] & 0x80) << 9);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 433 to 448
	value = ((uint32_t)(input[54] & 0x7f) << 25) |
			((uint32_t)input[55] << 17) |
			((uint32_t)(input[56] & 0x80) << 9);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 449 to 464
	value = ((uint32_t)(input[56] & 0x7f) << 25) |
			((uint32_t)input[57] << 17) |
			((uint32_t)(input[58] & 0x80) << 9);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 465 to 480
	value = ((uint32_t)(input[58] & 0x7f) << 25) |
			((uint32_t)input[59] << 17) |
			((uint32_t)(input[60] & 0x80) << 9);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 481 to 496
	value = ((uint32_t)(input[60] & 0x7f) << 25) |
			((uint32_t)input[61] << 17) |
			((uint32_t)(input[62] & 0x80) << 9);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 497 to 512
	value = ((uint32_t)(input[62] & 0x7f) << 25) |
			((uint32_t)input[63] << 17) |
			((uint32_t)(input[64] & 0x80) << 9);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 513 to 528
	value = ((uint32_t)(input[64] & 0x7f) << 25) |
			((uint32_t)input[65] << 17) |
			((uint32_t)(input[66] & 0x80) << 9);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 529 to 544
	value = ((uint32_t)(input[66] & 0x7f) << 25) |
			((uint32_t)input[67] << 17) |
			((uint32_t)(input[68] & 0x80) << 9);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 545 to 560
	value = ((uint32_t)(input[68] & 0x7f) << 25) |
			((uint32_t)input[69] << 17) |
			((uint32_t)(input[70] & 0x80) << 9);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 561 to 576
	value = ((uint32_t)(input[70] & 0x7f) << 25) |
			((uint32_t)input[71] << 17) |
			((uint32_t)(input[72] & 0x80) << 9);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 577 to 592
	value = ((uint32_t)(input[72] & 0x7f) << 25) |
			((uint32_t)input[73] << 17) |
			((uint32_t)(input[74] & 0x80) << 9);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 593 to 608
	value = ((uint32_t)(input[74] & 0x7f) << 25) |
			((uint32_t)input[75] << 17) |
			((uint32_t)(input[76] & 0x80) << 9);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 609 to 624
	value = ((uint32_t)(input[76] & 0x7f) << 25) |
			((uint32_t)input[77] << 17) |
			((uint32_t)(input[78] & 0x80) << 9);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 625 to 640
	value = ((uint32_t)(input[78] & 0x7f) << 25) |
			((uint32_t)input[79] << 17) |
			((uint32_t)(input[80] & 0x80) << 9);
	output[39] = (double)(value >> 16);

	// read output[40]: from bit 641 to 656
	value = ((uint32_t)(input[80] & 0x7f) << 25) |
			((uint32_t)input[81] << 17) |
			((uint32_t)(input[82] & 0x80) << 9);
	output[40] = (double)(value >> 16);

	// read output[41]: from bit 657 to 672
	value = ((uint32_t)(input[82] & 0x7f) << 25) |
			((uint32_t)input[83] << 17) |
			((uint32_t)(input[84] & 0x80) << 9);
	output[41] = (double)(value >> 16);

	// read output[42]: from bit 673 to 688
	value = ((uint32_t)(input[84] & 0x7f) << 25) |
			((uint32_t)input[85] << 17) |
			((uint32_t)(input[86] & 0x80) << 9);
	output[42] = (double)(value >> 16);

	// read output[43]: from bit 689 to 704
	value = ((uint32_t)(input[86] & 0x7f) << 25) |
			((uint32_t)input[87] << 17) |
			((uint32_t)(input[88] & 0x80) << 9);
	output[43] = (double)(value >> 16);

	// read output[44]: from bit 705 to 720
	value = ((uint32_t)(input[88] & 0x7f) << 25) |
			((uint32_t)input[89] << 17) |
			((uint32_t)(input[90] & 0x80) << 9);
	output[44] = (double)(value >> 16);

	// read output[45]: from bit 721 to 736
	value = ((uint32_t)(input[90] & 0x7f) << 25) |
			((uint32_t)input[91] << 17) |
			((uint32_t)(input[92] & 0x80) << 9);
	output[45] = (double)(value >> 16);

	// read output[46]: from bit 737 to 752
	value = ((uint32_t)(input[92] & 0x7f) << 25) |
			((uint32_t)input[93] << 17) |
			((uint32_t)(input[94] & 0x80) << 9);
	output[46] = (double)(value >> 16);

	// read output[47]: from bit 753 to 768
	value = ((uint32_t)(input[94] & 0x7f) << 25) |
			((uint32_t)input[95] << 17) |
			((uint32_t)(input[96] & 0x80) << 9);
	output[47] = (double)(value >> 16);

	// read output[48]: from bit 769 to 784
	value = ((uint32_t)(input[96] & 0x7f) << 25) |
			((uint32_t)input[97] << 17) |
			((uint32_t)(input[98] & 0x80) << 9);
	output[48] = (double)(value >> 16);

	// read output[49]: from bit 785 to 800
	value = ((uint32_t)(input[98] & 0x7f) << 25) |
			((uint32_t)input[99] << 17) |
			((uint32_t)(input[100] & 0x80) << 9);
	output[49] = (double)(value >> 16);

	// read output[50]: from bit 801 to 816
	value = ((uint32_t)(input[100] & 0x7f) << 25) |
			((uint32_t)input[101] << 17) |
			((uint32_t)(input[102] & 0x80) << 9);
	output[50] = (double)(value >> 16);

	// read output[51]: from bit 817 to 832
	value = ((uint32_t)(input[102] & 0x7f) << 25) |
			((uint32_t)input[103] << 17) |
			((uint32_t)(input[104] & 0x80) << 9);
	output[51] = (double)(value >> 16);

	// read output[52]: from bit 833 to 848
	value = ((uint32_t)(input[104] & 0x7f) << 25) |
			((uint32_t)input[105] << 17) |
			((uint32_t)(input[106] & 0x80) << 9);
	output[52] = (double)(value >> 16);

	// read output[53]: from bit 849 to 864
	value = ((uint32_t)(input[106] & 0x7f) << 25) |
			((uint32_t)input[107] << 17) |
			((uint32_t)(input[108] & 0x80) << 9);
	output[53] = (double)(value >> 16);

	// read output[54]: from bit 865 to 880
	value = ((uint32_t)(input[108] & 0x7f) << 25) |
			((uint32_t)input[109] << 17) |
			((uint32_t)(input[110] & 0x80) << 9);
	output[54] = (double)(value >> 16);

	// read output[55]: from bit 881 to 896
	value = ((uint32_t)(input[110] & 0x7f) << 25) |
			((uint32_t)input[111] << 17) |
			((uint32_t)(input[112] & 0x80) << 9);
	output[55] = (double)(value >> 16);

	// read output[56]: from bit 897 to 912
	value = ((uint32_t)(input[112] & 0x7f) << 25) |
			((uint32_t)input[113] << 17) |
			((uint32_t)(input[114] & 0x80) << 9);
	output[56] = (double)(value >> 16);

	// read output[57]: from bit 913 to 928
	value = ((uint32_t)(input[114] & 0x7f) << 25) |
			((uint32_t)input[115] << 17) |
			((uint32_t)(input[116] & 0x80) << 9);
	output[57] = (double)(value >> 16);

	// read output[58]: from bit 929 to 944
	value = ((uint32_t)(input[116] & 0x7f) << 25) |
			((uint32_t)input[117] << 17) |
			((uint32_t)(input[118] & 0x80) << 9);
	output[58] = (double)(value >> 16);

	// read output[59]: from bit 945 to 960
	value = ((uint32_t)(input[118] & 0x7f) << 25) |
			((uint32_t)input[119] << 17) |
			((uint32_t)(input[120] & 0x80) << 9);
	output[59] = (double)(value >> 16);

	// read output[60]: from bit 961 to 976
	value = ((uint32_t)(input[120] & 0x7f) << 25) |
			((uint32_t)input[121] << 17) |
			((uint32_t)(input[122] & 0x80) << 9);
	output[60] = (double)(value >> 16);

	// read output[61]: from bit 977 to 992
	value = ((uint32_t)(input[122] & 0x7f) << 25) |
			((uint32_t)input[123] << 17) |
			((uint32_t)(input[124] & 0x80) << 9);
	output[61] = (double)(value >> 16);

	// read output[62]: from bit 993 to 1008
	value = ((uint32_t)(input[124] & 0x7f) << 25) |
			((uint32_t)input[125] << 17) |
			((uint32_t)(input[126] & 0x80) << 9);
	output[62] = (double)(value >> 16);
}

static void unpack_63_16bit_signed_2off(const uint8_t * input, double * output, void *closure) {
	// Unpack 63 values into output
	// Values are 16-bit signed
	// Skip 2 bits, read 1008 bits of data.
	// Input must be at least 127 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 2 to 17
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)input[1] << 18) |
			((uint32_t)(input[2] & 0xc0) << 10);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 18 to 33
	value = ((uint32_t)(input[2] & 0x3f) << 26) |
			((uint32_t)input[3] << 18) |
			((uint32_t)(input[4] & 0xc0) << 10);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 34 to 49
	value = ((uint32_t)(input[4] & 0x3f) << 26) |
			((uint32_t)input[5] << 18) |
			((uint32_t)(input[6] & 0xc0) << 10);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 50 to 65
	value = ((uint32_t)(input[6] & 0x3f) << 26) |
			((uint32_t)input[7] << 18) |
			((uint32_t)(input[8] & 0xc0) << 10);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 66 to 81
	value = ((uint32_t)(input[8] & 0x3f) << 26) |
			((uint32_t)input[9] << 18) |
			((uint32_t)(input[10] & 0xc0) << 10);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 82 to 97
	value = ((uint32_t)(input[10] & 0x3f) << 26) |
			((uint32_t)input[11] << 18) |
			((uint32_t)(input[12] & 0xc0) << 10);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 98 to 113
	value = ((uint32_t)(input[12] & 0x3f) << 26) |
			((uint32_t)input[13] << 18) |
			((uint32_t)(input[14] & 0xc0) << 10);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 114 to 129
	value = ((uint32_t)(input[14] & 0x3f) << 26) |
			((uint32_t)input[15] << 18) |
			((uint32_t)(input[16] & 0xc0) << 10);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 130 to 145
	value = ((uint32_t)(input[16] & 0x3f) << 26) |
			((uint32_t)input[17] << 18) |
			((uint32_t)(input[18] & 0xc0) << 10);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 146 to 161
	value = ((uint32_t)(input[18] & 0x3f) << 26) |
			((uint32_t)input[19] << 18) |
			((uint32_t)(input[20] & 0xc0) << 10);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 162 to 177
	value = ((uint32_t)(input[20] & 0x3f) << 26) |
			((uint32_t)input[21] << 18) |
			((uint32_t)(input[22] & 0xc0) << 10);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 178 to 193
	value = ((uint32_t)(input[22] & 0x3f) << 26) |
			((uint32_t)input[23] << 18) |
			((uint32_t)(input[24] & 0xc0) << 10);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 194 to 209
	value = ((uint32_t)(input[24] & 0x3f) << 26) |
			((uint32_t)input[25] << 18) |
			((uint32_t)(input[26] & 0xc0) << 10);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 210 to 225
	value = ((uint32_t)(input[26] & 0x3f) << 26) |
			((uint32_t)input[27] << 18) |
			((uint32_t)(input[28] & 0xc0) << 10);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 226 to 241
	value = ((uint32_t)(input[28] & 0x3f) << 26) |
			((uint32_t)input[29] << 18) |
			((uint32_t)(input[30] & 0xc0) << 10);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 242 to 257
	value = ((uint32_t)(input[30] & 0x3f) << 26) |
			((uint32_t)input[31] << 18) |
			((uint32_t)(input[32] & 0xc0) << 10);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 258 to 273
	value = ((uint32_t)(input[32] & 0x3f) << 26) |
			((uint32_t)input[33] << 18) |
			((uint32_t)(input[34] & 0xc0) << 10);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 274 to 289
	value = ((uint32_t)(input[34] & 0x3f) << 26) |
			((uint32_t)input[35] << 18) |
			((uint32_t)(input[36] & 0xc0) << 10);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 290 to 305
	value = ((uint32_t)(input[36] & 0x3f) << 26) |
			((uint32_t)input[37] << 18) |
			((uint32_t)(input[38] & 0xc0) << 10);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 306 to 321
	value = ((uint32_t)(input[38] & 0x3f) << 26) |
			((uint32_t)input[39] << 18) |
			((uint32_t)(input[40] & 0xc0) << 10);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 322 to 337
	value = ((uint32_t)(input[40] & 0x3f) << 26) |
			((uint32_t)input[41] << 18) |
			((uint32_t)(input[42] & 0xc0) << 10);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 338 to 353
	value = ((uint32_t)(input[42] & 0x3f) << 26) |
			((uint32_t)input[43] << 18) |
			((uint32_t)(input[44] & 0xc0) << 10);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 354 to 369
	value = ((uint32_t)(input[44] & 0x3f) << 26) |
			((uint32_t)input[45] << 18) |
			((uint32_t)(input[46] & 0xc0) << 10);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 370 to 385
	value = ((uint32_t)(input[46] & 0x3f) << 26) |
			((uint32_t)input[47] << 18) |
			((uint32_t)(input[48] & 0xc0) << 10);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 386 to 401
	value = ((uint32_t)(input[48] & 0x3f) << 26) |
			((uint32_t)input[49] << 18) |
			((uint32_t)(input[50] & 0xc0) << 10);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 402 to 417
	value = ((uint32_t)(input[50] & 0x3f) << 26) |
			((uint32_t)input[51] << 18) |
			((uint32_t)(input[52] & 0xc0) << 10);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 418 to 433
	value = ((uint32_t)(input[52] & 0x3f) << 26) |
			((uint32_t)input[53] << 18) |
			((uint32_t)(input[54] & 0xc0) << 10);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 434 to 449
	value = ((uint32_t)(input[54] & 0x3f) << 26) |
			((uint32_t)input[55] << 18) |
			((uint32_t)(input[56] & 0xc0) << 10);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 450 to 465
	value = ((uint32_t)(input[56] & 0x3f) << 26) |
			((uint32_t)input[57] << 18) |
			((uint32_t)(input[58] & 0xc0) << 10);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 466 to 481
	value = ((uint32_t)(input[58] & 0x3f) << 26) |
			((uint32_t)input[59] << 18) |
			((uint32_t)(input[60] & 0xc0) << 10);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 482 to 497
	value = ((uint32_t)(input[60] & 0x3f) << 26) |
			((uint32_t)input[61] << 18) |
			((uint32_t)(input[62] & 0xc0) << 10);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 498 to 513
	value = ((uint32_t)(input[62] & 0x3f) << 26) |
			((uint32_t)input[63] << 18) |
			((uint32_t)(input[64] & 0xc0) << 10);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 514 to 529
	value = ((uint32_t)(input[64] & 0x3f) << 26) |
			((uint32_t)input[65] << 18) |
			((uint32_t)(input[66] & 0xc0) << 10);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 530 to 545
	value = ((uint32_t)(input[66] & 0x3f) << 26) |
			((uint32_t)input[67] << 18) |
			((uint32_t)(input[68] & 0xc0) << 10);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 546 to 561
	value = ((uint32_t)(input[68] & 0x3f) << 26) |
			((uint32_t)input[69] << 18) |
			((uint32_t)(input[70] & 0xc0) << 10);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 562 to 577
	value = ((uint32_t)(input[70] & 0x3f) << 26) |
			((uint32_t)input[71] << 18) |
			((uint32_t)(input[72] & 0xc0) << 10);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 578 to 593
	value = ((uint32_t)(input[72] & 0x3f) << 26) |
			((uint32_t)input[73] << 18) |
			((uint32_t)(input[74] & 0xc0) << 10);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 594 to 609
	value = ((uint32_t)(input[74] & 0x3f) << 26) |
			((uint32_t)input[75] << 18) |
			((uint32_t)(input[76] & 0xc0) << 10);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 610 to 625
	value = ((uint32_t)(input[76] & 0x3f) << 26) |
			((uint32_t)input[77] << 18) |
			((uint32_t)(input[78] & 0xc0) << 10);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 626 to 641
	value = ((uint32_t)(input[78] & 0x3f) << 26) |
			((uint32_t)input[79] << 18) |
			((uint32_t)(input[80] & 0xc0) << 10);
	output[39] = (double)(value >> 16);

	// read output[40]: from bit 642 to 657
	value = ((uint32_t)(input[80] & 0x3f) << 26) |
			((uint32_t)input[81] << 18) |
			((uint32_t)(input[82] & 0xc0) << 10);
	output[40] = (double)(value >> 16);

	// read output[41]: from bit 658 to 673
	value = ((uint32_t)(input[82] & 0x3f) << 26) |
			((uint32_t)input[83] << 18) |
			((uint32_t)(input[84] & 0xc0) << 10);
	output[41] = (double)(value >> 16);

	// read output[42]: from bit 674 to 689
	value = ((uint32_t)(input[84] & 0x3f) << 26) |
			((uint32_t)input[85] << 18) |
			((uint32_t)(input[86] & 0xc0) << 10);
	output[42] = (double)(value >> 16);

	// read output[43]: from bit 690 to 705
	value = ((uint32_t)(input[86] & 0x3f) << 26) |
			((uint32_t)input[87] << 18) |
			((uint32_t)(input[88] & 0xc0) << 10);
	output[43] = (double)(value >> 16);

	// read output[44]: from bit 706 to 721
	value = ((uint32_t)(input[88] & 0x3f) << 26) |
			((uint32_t)input[89] << 18) |
			((uint32_t)(input[90] & 0xc0) << 10);
	output[44] = (double)(value >> 16);

	// read output[45]: from bit 722 to 737
	value = ((uint32_t)(input[90] & 0x3f) << 26) |
			((uint32_t)input[91] << 18) |
			((uint32_t)(input[92] & 0xc0) << 10);
	output[45] = (double)(value >> 16);

	// read output[46]: from bit 738 to 753
	value = ((uint32_t)(input[92] & 0x3f) << 26) |
			((uint32_t)input[93] << 18) |
			((uint32_t)(input[94] & 0xc0) << 10);
	output[46] = (double)(value >> 16);

	// read output[47]: from bit 754 to 769
	value = ((uint32_t)(input[94] & 0x3f) << 26) |
			((uint32_t)input[95] << 18) |
			((uint32_t)(input[96] & 0xc0) << 10);
	output[47] = (double)(value >> 16);

	// read output[48]: from bit 770 to 785
	value = ((uint32_t)(input[96] & 0x3f) << 26) |
			((uint32_t)input[97] << 18) |
			((uint32_t)(input[98] & 0xc0) << 10);
	output[48] = (double)(value >> 16);

	// read output[49]: from bit 786 to 801
	value = ((uint32_t)(input[98] & 0x3f) << 26) |
			((uint32_t)input[99] << 18) |
			((uint32_t)(input[100] & 0xc0) << 10);
	output[49] = (double)(value >> 16);

	// read output[50]: from bit 802 to 817
	value = ((uint32_t)(input[100] & 0x3f) << 26) |
			((uint32_t)input[101] << 18) |
			((uint32_t)(input[102] & 0xc0) << 10);
	output[50] = (double)(value >> 16);

	// read output[51]: from bit 818 to 833
	value = ((uint32_t)(input[102] & 0x3f) << 26) |
			((uint32_t)input[103] << 18) |
			((uint32_t)(input[104] & 0xc0) << 10);
	output[51] = (double)(value >> 16);

	// read output[52]: from bit 834 to 849
	value = ((uint32_t)(input[104] & 0x3f) << 26) |
			((uint32_t)input[105] << 18) |
			((uint32_t)(input[106] & 0xc0) << 10);
	output[52] = (double)(value >> 16);

	// read output[53]: from bit 850 to 865
	value = ((uint32_t)(input[106] & 0x3f) << 26) |
			((uint32_t)input[107] << 18) |
			((uint32_t)(input[108] & 0xc0) << 10);
	output[53] = (double)(value >> 16);

	// read output[54]: from bit 866 to 881
	value = ((uint32_t)(input[108] & 0x3f) << 26) |
			((uint32_t)input[109] << 18) |
			((uint32_t)(input[110] & 0xc0) << 10);
	output[54] = (double)(value >> 16);

	// read output[55]: from bit 882 to 897
	value = ((uint32_t)(input[110] & 0x3f) << 26) |
			((uint32_t)input[111] << 18) |
			((uint32_t)(input[112] & 0xc0) << 10);
	output[55] = (double)(value >> 16);

	// read output[56]: from bit 898 to 913
	value = ((uint32_t)(input[112] & 0x3f) << 26) |
			((uint32_t)input[113] << 18) |
			((uint32_t)(input[114] & 0xc0) << 10);
	output[56] = (double)(value >> 16);

	// read output[57]: from bit 914 to 929
	value = ((uint32_t)(input[114] & 0x3f) << 26) |
			((uint32_t)input[115] << 18) |
			((uint32_t)(input[116] & 0xc0) << 10);
	output[57] = (double)(value >> 16);

	// read output[58]: from bit 930 to 945
	value = ((uint32_t)(input[116] & 0x3f) << 26) |
			((uint32_t)input[117] << 18) |
			((uint32_t)(input[118] & 0xc0) << 10);
	output[58] = (double)(value >> 16);

	// read output[59]: from bit 946 to 961
	value = ((uint32_t)(input[118] & 0x3f) << 26) |
			((uint32_t)input[119] << 18) |
			((uint32_t)(input[120] & 0xc0) << 10);
	output[59] = (double)(value >> 16);

	// read output[60]: from bit 962 to 977
	value = ((uint32_t)(input[120] & 0x3f) << 26) |
			((uint32_t)input[121] << 18) |
			((uint32_t)(input[122] & 0xc0) << 10);
	output[60] = (double)(value >> 16);

	// read output[61]: from bit 978 to 993
	value = ((uint32_t)(input[122] & 0x3f) << 26) |
			((uint32_t)input[123] << 18) |
			((uint32_t)(input[124] & 0xc0) << 10);
	output[61] = (double)(value >> 16);

	// read output[62]: from bit 994 to 1009
	value = ((uint32_t)(input[124] & 0x3f) << 26) |
			((uint32_t)input[125] << 18) |
			((uint32_t)(input[126] & 0xc0) << 10);
	output[62] = (double)(value >> 16);
}

static void unpack_63_16bit_unsigned_2off(const uint8_t * input, double * output, void *closure) {
	// Unpack 63 values into output
	// Values are 16-bit unsigned
	// Skip 2 bits, read 1008 bits of data.
	// Input must be at least 127 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 2 to 17
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)input[1] << 18) |
			((uint32_t)(input[2] & 0xc0) << 10);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 18 to 33
	value = ((uint32_t)(input[2] & 0x3f) << 26) |
			((uint32_t)input[3] << 18) |
			((uint32_t)(input[4] & 0xc0) << 10);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 34 to 49
	value = ((uint32_t)(input[4] & 0x3f) << 26) |
			((uint32_t)input[5] << 18) |
			((uint32_t)(input[6] & 0xc0) << 10);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 50 to 65
	value = ((uint32_t)(input[6] & 0x3f) << 26) |
			((uint32_t)input[7] << 18) |
			((uint32_t)(input[8] & 0xc0) << 10);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 66 to 81
	value = ((uint32_t)(input[8] & 0x3f) << 26) |
			((uint32_t)input[9] << 18) |
			((uint32_t)(input[10] & 0xc0) << 10);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 82 to 97
	value = ((uint32_t)(input[10] & 0x3f) << 26) |
			((uint32_t)input[11] << 18) |
			((uint32_t)(input[12] & 0xc0) << 10);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 98 to 113
	value = ((uint32_t)(input[12] & 0x3f) << 26) |
			((uint32_t)input[13] << 18) |
			((uint32_t)(input[14] & 0xc0) << 10);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 114 to 129
	value = ((uint32_t)(input[14] & 0x3f) << 26) |
			((uint32_t)input[15] << 18) |
			((uint32_t)(input[16] & 0xc0) << 10);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 130 to 145
	value = ((uint32_t)(input[16] & 0x3f) << 26) |
			((uint32_t)input[17] << 18) |
			((uint32_t)(input[18] & 0xc0) << 10);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 146 to 161
	value = ((uint32_t)(input[18] & 0x3f) << 26) |
			((uint32_t)input[19] << 18) |
			((uint32_t)(input[20] & 0xc0) << 10);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 162 to 177
	value = ((uint32_t)(input[20] & 0x3f) << 26) |
			((uint32_t)input[21] << 18) |
			((uint32_t)(input[22] & 0xc0) << 10);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 178 to 193
	value = ((uint32_t)(input[22] & 0x3f) << 26) |
			((uint32_t)input[23] << 18) |
			((uint32_t)(input[24] & 0xc0) << 10);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 194 to 209
	value = ((uint32_t)(input[24] & 0x3f) << 26) |
			((uint32_t)input[25] << 18) |
			((uint32_t)(input[26] & 0xc0) << 10);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 210 to 225
	value = ((uint32_t)(input[26] & 0x3f) << 26) |
			((uint32_t)input[27] << 18) |
			((uint32_t)(input[28] & 0xc0) << 10);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 226 to 241
	value = ((uint32_t)(input[28] & 0x3f) << 26) |
			((uint32_t)input[29] << 18) |
			((uint32_t)(input[30] & 0xc0) << 10);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 242 to 257
	value = ((uint32_t)(input[30] & 0x3f) << 26) |
			((uint32_t)input[31] << 18) |
			((uint32_t)(input[32] & 0xc0) << 10);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 258 to 273
	value = ((uint32_t)(input[32] & 0x3f) << 26) |
			((uint32_t)input[33] << 18) |
			((uint32_t)(input[34] & 0xc0) << 10);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 274 to 289
	value = ((uint32_t)(input[34] & 0x3f) << 26) |
			((uint32_t)input[35] << 18) |
			((uint32_t)(input[36] & 0xc0) << 10);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 290 to 305
	value = ((uint32_t)(input[36] & 0x3f) << 26) |
			((uint32_t)input[37] << 18) |
			((uint32_t)(input[38] & 0xc0) << 10);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 306 to 321
	value = ((uint32_t)(input[38] & 0x3f) << 26) |
			((uint32_t)input[39] << 18) |
			((uint32_t)(input[40] & 0xc0) << 10);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 322 to 337
	value = ((uint32_t)(input[40] & 0x3f) << 26) |
			((uint32_t)input[41] << 18) |
			((uint32_t)(input[42] & 0xc0) << 10);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 338 to 353
	value = ((uint32_t)(input[42] & 0x3f) << 26) |
			((uint32_t)input[43] << 18) |
			((uint32_t)(input[44] & 0xc0) << 10);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 354 to 369
	value = ((uint32_t)(input[44] & 0x3f) << 26) |
			((uint32_t)input[45] << 18) |
			((uint32_t)(input[46] & 0xc0) << 10);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 370 to 385
	value = ((uint32_t)(input[46] & 0x3f) << 26) |
			((uint32_t)input[47] << 18) |
			((uint32_t)(input[48] & 0xc0) << 10);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 386 to 401
	value = ((uint32_t)(input[48] & 0x3f) << 26) |
			((uint32_t)input[49] << 18) |
			((uint32_t)(input[50] & 0xc0) << 10);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 402 to 417
	value = ((uint32_t)(input[50] & 0x3f) << 26) |
			((uint32_t)input[51] << 18) |
			((uint32_t)(input[52] & 0xc0) << 10);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 418 to 433
	value = ((uint32_t)(input[52] & 0x3f) << 26) |
			((uint32_t)input[53] << 18) |
			((uint32_t)(input[54] & 0xc0) << 10);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 434 to 449
	value = ((uint32_t)(input[54] & 0x3f) << 26) |
			((uint32_t)input[55] << 18) |
			((uint32_t)(input[56] & 0xc0) << 10);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 450 to 465
	value = ((uint32_t)(input[56] & 0x3f) << 26) |
			((uint32_t)input[57] << 18) |
			((uint32_t)(input[58] & 0xc0) << 10);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 466 to 481
	value = ((uint32_t)(input[58] & 0x3f) << 26) |
			((uint32_t)input[59] << 18) |
			((uint32_t)(input[60] & 0xc0) << 10);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 482 to 497
	value = ((uint32_t)(input[60] & 0x3f) << 26) |
			((uint32_t)input[61] << 18) |
			((uint32_t)(input[62] & 0xc0) << 10);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 498 to 513
	value = ((uint32_t)(input[62] & 0x3f) << 26) |
			((uint32_t)input[63] << 18) |
			((uint32_t)(input[64] & 0xc0) << 10);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 514 to 529
	value = ((uint32_t)(input[64] & 0x3f) << 26) |
			((uint32_t)input[65] << 18) |
			((uint32_t)(input[66] & 0xc0) << 10);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 530 to 545
	value = ((uint32_t)(input[66] & 0x3f) << 26) |
			((uint32_t)input[67] << 18) |
			((uint32_t)(input[68] & 0xc0) << 10);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 546 to 561
	value = ((uint32_t)(input[68] & 0x3f) << 26) |
			((uint32_t)input[69] << 18) |
			((uint32_t)(input[70] & 0xc0) << 10);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 562 to 577
	value = ((uint32_t)(input[70] & 0x3f) << 26) |
			((uint32_t)input[71] << 18) |
			((uint32_t)(input[72] & 0xc0) << 10);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 578 to 593
	value = ((uint32_t)(input[72] & 0x3f) << 26) |
			((uint32_t)input[73] << 18) |
			((uint32_t)(input[74] & 0xc0) << 10);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 594 to 609
	value = ((uint32_t)(input[74] & 0x3f) << 26) |
			((uint32_t)input[75] << 18) |
			((uint32_t)(input[76] & 0xc0) << 10);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 610 to 625
	value = ((uint32_t)(input[76] & 0x3f) << 26) |
			((uint32_t)input[77] << 18) |
			((uint32_t)(input[78] & 0xc0) << 10);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 626 to 641
	value = ((uint32_t)(input[78] & 0x3f) << 26) |
			((uint32_t)input[79] << 18) |
			((uint32_t)(input[80] & 0xc0) << 10);
	output[39] = (double)(value >> 16);

	// read output[40]: from bit 642 to 657
	value = ((uint32_t)(input[80] & 0x3f) << 26) |
			((uint32_t)input[81] << 18) |
			((uint32_t)(input[82] & 0xc0) << 10);
	output[40] = (double)(value >> 16);

	// read output[41]: from bit 658 to 673
	value = ((uint32_t)(input[82] & 0x3f) << 26) |
			((uint32_t)input[83] << 18) |
			((uint32_t)(input[84] & 0xc0) << 10);
	output[41] = (double)(value >> 16);

	// read output[42]: from bit 674 to 689
	value = ((uint32_t)(input[84] & 0x3f) << 26) |
			((uint32_t)input[85] << 18) |
			((uint32_t)(input[86] & 0xc0) << 10);
	output[42] = (double)(value >> 16);

	// read output[43]: from bit 690 to 705
	value = ((uint32_t)(input[86] & 0x3f) << 26) |
			((uint32_t)input[87] << 18) |
			((uint32_t)(input[88] & 0xc0) << 10);
	output[43] = (double)(value >> 16);

	// read output[44]: from bit 706 to 721
	value = ((uint32_t)(input[88] & 0x3f) << 26) |
			((uint32_t)input[89] << 18) |
			((uint32_t)(input[90] & 0xc0) << 10);
	output[44] = (double)(value >> 16);

	// read output[45]: from bit 722 to 737
	value = ((uint32_t)(input[90] & 0x3f) << 26) |
			((uint32_t)input[91] << 18) |
			((uint32_t)(input[92] & 0xc0) << 10);
	output[45] = (double)(value >> 16);

	// read output[46]: from bit 738 to 753
	value = ((uint32_t)(input[92] & 0x3f) << 26) |
			((uint32_t)input[93] << 18) |
			((uint32_t)(input[94] & 0xc0) << 10);
	output[46] = (double)(value >> 16);

	// read output[47]: from bit 754 to 769
	value = ((uint32_t)(input[94] & 0x3f) << 26) |
			((uint32_t)input[95] << 18) |
			((uint32_t)(input[96] & 0xc0) << 10);
	output[47] = (double)(value >> 16);

	// read output[48]: from bit 770 to 785
	value = ((uint32_t)(input[96] & 0x3f) << 26) |
			((uint32_t)input[97] << 18) |
			((uint32_t)(input[98] & 0xc0) << 10);
	output[48] = (double)(value >> 16);

	// read output[49]: from bit 786 to 801
	value = ((uint32_t)(input[98] & 0x3f) << 26) |
			((uint32_t)input[99] << 18) |
			((uint32_t)(input[100] & 0xc0) << 10);
	output[49] = (double)(value >> 16);

	// read output[50]: from bit 802 to 817
	value = ((uint32_t)(input[100] & 0x3f) << 26) |
			((uint32_t)input[101] << 18) |
			((uint32_t)(input[102] & 0xc0) << 10);
	output[50] = (double)(value >> 16);

	// read output[51]: from bit 818 to 833
	value = ((uint32_t)(input[102] & 0x3f) << 26) |
			((uint32_t)input[103] << 18) |
			((uint32_t)(input[104] & 0xc0) << 10);
	output[51] = (double)(value >> 16);

	// read output[52]: from bit 834 to 849
	value = ((uint32_t)(input[104] & 0x3f) << 26) |
			((uint32_t)input[105] << 18) |
			((uint32_t)(input[106] & 0xc0) << 10);
	output[52] = (double)(value >> 16);

	// read output[53]: from bit 850 to 865
	value = ((uint32_t)(input[106] & 0x3f) << 26) |
			((uint32_t)input[107] << 18) |
			((uint32_t)(input[108] & 0xc0) << 10);
	output[53] = (double)(value >> 16);

	// read output[54]: from bit 866 to 881
	value = ((uint32_t)(input[108] & 0x3f) << 26) |
			((uint32_t)input[109] << 18) |
			((uint32_t)(input[110] & 0xc0) << 10);
	output[54] = (double)(value >> 16);

	// read output[55]: from bit 882 to 897
	value = ((uint32_t)(input[110] & 0x3f) << 26) |
			((uint32_t)input[111] << 18) |
			((uint32_t)(input[112] & 0xc0) << 10);
	output[55] = (double)(value >> 16);

	// read output[56]: from bit 898 to 913
	value = ((uint32_t)(input[112] & 0x3f) << 26) |
			((uint32_t)input[113] << 18) |
			((uint32_t)(input[114] & 0xc0) << 10);
	output[56] = (double)(value >> 16);

	// read output[57]: from bit 914 to 929
	value = ((uint32_t)(input[114] & 0x3f) << 26) |
			((uint32_t)input[115] << 18) |
			((uint32_t)(input[116] & 0xc0) << 10);
	output[57] = (double)(value >> 16);

	// read output[58]: from bit 930 to 945
	value = ((uint32_t)(input[116] & 0x3f) << 26) |
			((uint32_t)input[117] << 18) |
			((uint32_t)(input[118] & 0xc0) << 10);
	output[58] = (double)(value >> 16);

	// read output[59]: from bit 946 to 961
	value = ((uint32_t)(input[118] & 0x3f) << 26) |
			((uint32_t)input[119] << 18) |
			((uint32_t)(input[120] & 0xc0) << 10);
	output[59] = (double)(value >> 16);

	// read output[60]: from bit 962 to 977
	value = ((uint32_t)(input[120] & 0x3f) << 26) |
			((uint32_t)input[121] << 18) |
			((uint32_t)(input[122] & 0xc0) << 10);
	output[60] = (double)(value >> 16);

	// read output[61]: from bit 978 to 993
	value = ((uint32_t)(input[122] & 0x3f) << 26) |
			((uint32_t)input[123] << 18) |
			((uint32_t)(input[124] & 0xc0) << 10);
	output[61] = (double)(value >> 16);

	// read output[62]: from bit 994 to 1009
	value = ((uint32_t)(input[124] & 0x3f) << 26) |
			((uint32_t)input[125] << 18) |
			((uint32_t)(input[126] & 0xc0) << 10);
	output[62] = (double)(value >> 16);
}

static void unpack_63_16bit_signed_3off(const uint8_t * input, double * output, void *closure) {
	// Unpack 63 values into output
	// Values are 16-bit signed
	// Skip 3 bits, read 1008 bits of data.
	// Input must be at least 127 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 3 to 18
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)input[1] << 19) |
			((uint32_t)(input[2] & 0xe0) << 11);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 19 to 34
	value = ((uint32_t)(input[2] & 0x1f) << 27) |
			((uint32_t)input[3] << 19) |
			((uint32_t)(input[4] & 0xe0) << 11);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 35 to 50
	value = ((uint32_t)(input[4] & 0x1f) << 27) |
			((uint32_t)input[5] << 19) |
			((uint32_t)(input[6] & 0xe0) << 11);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 51 to 66
	value = ((uint32_t)(input[6] & 0x1f) << 27) |
			((uint32_t)input[7] << 19) |
			((uint32_t)(input[8] & 0xe0) << 11);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 67 to 82
	value = ((uint32_t)(input[8] & 0x1f) << 27) |
			((uint32_t)input[9] << 19) |
			((uint32_t)(input[10] & 0xe0) << 11);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 83 to 98
	value = ((uint32_t)(input[10] & 0x1f) << 27) |
			((uint32_t)input[11] << 19) |
			((uint32_t)(input[12] & 0xe0) << 11);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 99 to 114
	value = ((uint32_t)(input[12] & 0x1f) << 27) |
			((uint32_t)input[13] << 19) |
			((uint32_t)(input[14] & 0xe0) << 11);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 115 to 130
	value = ((uint32_t)(input[14] & 0x1f) << 27) |
			((uint32_t)input[15] << 19) |
			((uint32_t)(input[16] & 0xe0) << 11);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 131 to 146
	value = ((uint32_t)(input[16] & 0x1f) << 27) |
			((uint32_t)input[17] << 19) |
			((uint32_t)(input[18] & 0xe0) << 11);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 147 to 162
	value = ((uint32_t)(input[18] & 0x1f) << 27) |
			((uint32_t)input[19] << 19) |
			((uint32_t)(input[20] & 0xe0) << 11);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 163 to 178
	value = ((uint32_t)(input[20] & 0x1f) << 27) |
			((uint32_t)input[21] << 19) |
			((uint32_t)(input[22] & 0xe0) << 11);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 179 to 194
	value = ((uint32_t)(input[22] & 0x1f) << 27) |
			((uint32_t)input[23] << 19) |
			((uint32_t)(input[24] & 0xe0) << 11);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 195 to 210
	value = ((uint32_t)(input[24] & 0x1f) << 27) |
			((uint32_t)input[25] << 19) |
			((uint32_t)(input[26] & 0xe0) << 11);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 211 to 226
	value = ((uint32_t)(input[26] & 0x1f) << 27) |
			((uint32_t)input[27] << 19) |
			((uint32_t)(input[28] & 0xe0) << 11);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 227 to 242
	value = ((uint32_t)(input[28] & 0x1f) << 27) |
			((uint32_t)input[29] << 19) |
			((uint32_t)(input[30] & 0xe0) << 11);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 243 to 258
	value = ((uint32_t)(input[30] & 0x1f) << 27) |
			((uint32_t)input[31] << 19) |
			((uint32_t)(input[32] & 0xe0) << 11);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 259 to 274
	value = ((uint32_t)(input[32] & 0x1f) << 27) |
			((uint32_t)input[33] << 19) |
			((uint32_t)(input[34] & 0xe0) << 11);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 275 to 290
	value = ((uint32_t)(input[34] & 0x1f) << 27) |
			((uint32_t)input[35] << 19) |
			((uint32_t)(input[36] & 0xe0) << 11);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 291 to 306
	value = ((uint32_t)(input[36] & 0x1f) << 27) |
			((uint32_t)input[37] << 19) |
			((uint32_t)(input[38] & 0xe0) << 11);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 307 to 322
	value = ((uint32_t)(input[38] & 0x1f) << 27) |
			((uint32_t)input[39] << 19) |
			((uint32_t)(input[40] & 0xe0) << 11);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 323 to 338
	value = ((uint32_t)(input[40] & 0x1f) << 27) |
			((uint32_t)input[41] << 19) |
			((uint32_t)(input[42] & 0xe0) << 11);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 339 to 354
	value = ((uint32_t)(input[42] & 0x1f) << 27) |
			((uint32_t)input[43] << 19) |
			((uint32_t)(input[44] & 0xe0) << 11);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 355 to 370
	value = ((uint32_t)(input[44] & 0x1f) << 27) |
			((uint32_t)input[45] << 19) |
			((uint32_t)(input[46] & 0xe0) << 11);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 371 to 386
	value = ((uint32_t)(input[46] & 0x1f) << 27) |
			((uint32_t)input[47] << 19) |
			((uint32_t)(input[48] & 0xe0) << 11);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 387 to 402
	value = ((uint32_t)(input[48] & 0x1f) << 27) |
			((uint32_t)input[49] << 19) |
			((uint32_t)(input[50] & 0xe0) << 11);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 403 to 418
	value = ((uint32_t)(input[50] & 0x1f) << 27) |
			((uint32_t)input[51] << 19) |
			((uint32_t)(input[52] & 0xe0) << 11);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 419 to 434
	value = ((uint32_t)(input[52] & 0x1f) << 27) |
			((uint32_t)input[53] << 19) |
			((uint32_t)(input[54] & 0xe0) << 11);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 435 to 450
	value = ((uint32_t)(input[54] & 0x1f) << 27) |
			((uint32_t)input[55] << 19) |
			((uint32_t)(input[56] & 0xe0) << 11);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 451 to 466
	value = ((uint32_t)(input[56] & 0x1f) << 27) |
			((uint32_t)input[57] << 19) |
			((uint32_t)(input[58] & 0xe0) << 11);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 467 to 482
	value = ((uint32_t)(input[58] & 0x1f) << 27) |
			((uint32_t)input[59] << 19) |
			((uint32_t)(input[60] & 0xe0) << 11);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 483 to 498
	value = ((uint32_t)(input[60] & 0x1f) << 27) |
			((uint32_t)input[61] << 19) |
			((uint32_t)(input[62] & 0xe0) << 11);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 499 to 514
	value = ((uint32_t)(input[62] & 0x1f) << 27) |
			((uint32_t)input[63] << 19) |
			((uint32_t)(input[64] & 0xe0) << 11);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 515 to 530
	value = ((uint32_t)(input[64] & 0x1f) << 27) |
			((uint32_t)input[65] << 19) |
			((uint32_t)(input[66] & 0xe0) << 11);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 531 to 546
	value = ((uint32_t)(input[66] & 0x1f) << 27) |
			((uint32_t)input[67] << 19) |
			((uint32_t)(input[68] & 0xe0) << 11);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 547 to 562
	value = ((uint32_t)(input[68] & 0x1f) << 27) |
			((uint32_t)input[69] << 19) |
			((uint32_t)(input[70] & 0xe0) << 11);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 563 to 578
	value = ((uint32_t)(input[70] & 0x1f) << 27) |
			((uint32_t)input[71] << 19) |
			((uint32_t)(input[72] & 0xe0) << 11);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 579 to 594
	value = ((uint32_t)(input[72] & 0x1f) << 27) |
			((uint32_t)input[73] << 19) |
			((uint32_t)(input[74] & 0xe0) << 11);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 595 to 610
	value = ((uint32_t)(input[74] & 0x1f) << 27) |
			((uint32_t)input[75] << 19) |
			((uint32_t)(input[76] & 0xe0) << 11);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 611 to 626
	value = ((uint32_t)(input[76] & 0x1f) << 27) |
			((uint32_t)input[77] << 19) |
			((uint32_t)(input[78] & 0xe0) << 11);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 627 to 642
	value = ((uint32_t)(input[78] & 0x1f) << 27) |
			((uint32_t)input[79] << 19) |
			((uint32_t)(input[80] & 0xe0) << 11);
	output[39] = (double)(value >> 16);

	// read output[40]: from bit 643 to 658
	value = ((uint32_t)(input[80] & 0x1f) << 27) |
			((uint32_t)input[81] << 19) |
			((uint32_t)(input[82] & 0xe0) << 11);
	output[40] = (double)(value >> 16);

	// read output[41]: from bit 659 to 674
	value = ((uint32_t)(input[82] & 0x1f) << 27) |
			((uint32_t)input[83] << 19) |
			((uint32_t)(input[84] & 0xe0) << 11);
	output[41] = (double)(value >> 16);

	// read output[42]: from bit 675 to 690
	value = ((uint32_t)(input[84] & 0x1f) << 27) |
			((uint32_t)input[85] << 19) |
			((uint32_t)(input[86] & 0xe0) << 11);
	output[42] = (double)(value >> 16);

	// read output[43]: from bit 691 to 706
	value = ((uint32_t)(input[86] & 0x1f) << 27) |
			((uint32_t)input[87] << 19) |
			((uint32_t)(input[88] & 0xe0) << 11);
	output[43] = (double)(value >> 16);

	// read output[44]: from bit 707 to 722
	value = ((uint32_t)(input[88] & 0x1f) << 27) |
			((uint32_t)input[89] << 19) |
			((uint32_t)(input[90] & 0xe0) << 11);
	output[44] = (double)(value >> 16);

	// read output[45]: from bit 723 to 738
	value = ((uint32_t)(input[90] & 0x1f) << 27) |
			((uint32_t)input[91] << 19) |
			((uint32_t)(input[92] & 0xe0) << 11);
	output[45] = (double)(value >> 16);

	// read output[46]: from bit 739 to 754
	value = ((uint32_t)(input[92] & 0x1f) << 27) |
			((uint32_t)input[93] << 19) |
			((uint32_t)(input[94] & 0xe0) << 11);
	output[46] = (double)(value >> 16);

	// read output[47]: from bit 755 to 770
	value = ((uint32_t)(input[94] & 0x1f) << 27) |
			((uint32_t)input[95] << 19) |
			((uint32_t)(input[96] & 0xe0) << 11);
	output[47] = (double)(value >> 16);

	// read output[48]: from bit 771 to 786
	value = ((uint32_t)(input[96] & 0x1f) << 27) |
			((uint32_t)input[97] << 19) |
			((uint32_t)(input[98] & 0xe0) << 11);
	output[48] = (double)(value >> 16);

	// read output[49]: from bit 787 to 802
	value = ((uint32_t)(input[98] & 0x1f) << 27) |
			((uint32_t)input[99] << 19) |
			((uint32_t)(input[100] & 0xe0) << 11);
	output[49] = (double)(value >> 16);

	// read output[50]: from bit 803 to 818
	value = ((uint32_t)(input[100] & 0x1f) << 27) |
			((uint32_t)input[101] << 19) |
			((uint32_t)(input[102] & 0xe0) << 11);
	output[50] = (double)(value >> 16);

	// read output[51]: from bit 819 to 834
	value = ((uint32_t)(input[102] & 0x1f) << 27) |
			((uint32_t)input[103] << 19) |
			((uint32_t)(input[104] & 0xe0) << 11);
	output[51] = (double)(value >> 16);

	// read output[52]: from bit 835 to 850
	value = ((uint32_t)(input[104] & 0x1f) << 27) |
			((uint32_t)input[105] << 19) |
			((uint32_t)(input[106] & 0xe0) << 11);
	output[52] = (double)(value >> 16);

	// read output[53]: from bit 851 to 866
	value = ((uint32_t)(input[106] & 0x1f) << 27) |
			((uint32_t)input[107] << 19) |
			((uint32_t)(input[108] & 0xe0) << 11);
	output[53] = (double)(value >> 16);

	// read output[54]: from bit 867 to 882
	value = ((uint32_t)(input[108] & 0x1f) << 27) |
			((uint32_t)input[109] << 19) |
			((uint32_t)(input[110] & 0xe0) << 11);
	output[54] = (double)(value >> 16);

	// read output[55]: from bit 883 to 898
	value = ((uint32_t)(input[110] & 0x1f) << 27) |
			((uint32_t)input[111] << 19) |
			((uint32_t)(input[112] & 0xe0) << 11);
	output[55] = (double)(value >> 16);

	// read output[56]: from bit 899 to 914
	value = ((uint32_t)(input[112] & 0x1f) << 27) |
			((uint32_t)input[113] << 19) |
			((uint32_t)(input[114] & 0xe0) << 11);
	output[56] = (double)(value >> 16);

	// read output[57]: from bit 915 to 930
	value = ((uint32_t)(input[114] & 0x1f) << 27) |
			((uint32_t)input[115] << 19) |
			((uint32_t)(input[116] & 0xe0) << 11);
	output[57] = (double)(value >> 16);

	// read output[58]: from bit 931 to 946
	value = ((uint32_t)(input[116] & 0x1f) << 27) |
			((uint32_t)input[117] << 19) |
			((uint32_t)(input[118] & 0xe0) << 11);
	output[58] = (double)(value >> 16);

	// read output[59]: from bit 947 to 962
	value = ((uint32_t)(input[118] & 0x1f) << 27) |
			((uint32_t)input[119] << 19) |
			((uint32_t)(input[120] & 0xe0) << 11);
	output[59] = (double)(value >> 16);

	// read output[60]: from bit 963 to 978
	value = ((uint32_t)(input[120] & 0x1f) << 27) |
			((uint32_t)input[121] << 19) |
			((uint32_t)(input[122] & 0xe0) << 11);
	output[60] = (double)(value >> 16);

	// read output[61]: from bit 979 to 994
	value = ((uint32_t)(input[122] & 0x1f) << 27) |
			((uint32_t)input[123] << 19) |
			((uint32_t)(input[124] & 0xe0) << 11);
	output[61] = (double)(value >> 16);

	// read output[62]: from bit 995 to 1010
	value = ((uint32_t)(input[124] & 0x1f) << 27) |
			((uint32_t)input[125] << 19) |
			((uint32_t)(input[126] & 0xe0) << 11);
	output[62] = (double)(value >> 16);
}

static void unpack_63_16bit_unsigned_3off(const uint8_t * input, double * output, void *closure) {
	// Unpack 63 values into output
	// Values are 16-bit unsigned
	// Skip 3 bits, read 1008 bits of data.
	// Input must be at least 127 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 3 to 18
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)input[1] << 19) |
			((uint32_t)(input[2] & 0xe0) << 11);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 19 to 34
	value = ((uint32_t)(input[2] & 0x1f) << 27) |
			((uint32_t)input[3] << 19) |
			((uint32_t)(input[4] & 0xe0) << 11);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 35 to 50
	value = ((uint32_t)(input[4] & 0x1f) << 27) |
			((uint32_t)input[5] << 19) |
			((uint32_t)(input[6] & 0xe0) << 11);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 51 to 66
	value = ((uint32_t)(input[6] & 0x1f) << 27) |
			((uint32_t)input[7] << 19) |
			((uint32_t)(input[8] & 0xe0) << 11);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 67 to 82
	value = ((uint32_t)(input[8] & 0x1f) << 27) |
			((uint32_t)input[9] << 19) |
			((uint32_t)(input[10] & 0xe0) << 11);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 83 to 98
	value = ((uint32_t)(input[10] & 0x1f) << 27) |
			((uint32_t)input[11] << 19) |
			((uint32_t)(input[12] & 0xe0) << 11);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 99 to 114
	value = ((uint32_t)(input[12] & 0x1f) << 27) |
			((uint32_t)input[13] << 19) |
			((uint32_t)(input[14] & 0xe0) << 11);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 115 to 130
	value = ((uint32_t)(input[14] & 0x1f) << 27) |
			((uint32_t)input[15] << 19) |
			((uint32_t)(input[16] & 0xe0) << 11);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 131 to 146
	value = ((uint32_t)(input[16] & 0x1f) << 27) |
			((uint32_t)input[17] << 19) |
			((uint32_t)(input[18] & 0xe0) << 11);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 147 to 162
	value = ((uint32_t)(input[18] & 0x1f) << 27) |
			((uint32_t)input[19] << 19) |
			((uint32_t)(input[20] & 0xe0) << 11);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 163 to 178
	value = ((uint32_t)(input[20] & 0x1f) << 27) |
			((uint32_t)input[21] << 19) |
			((uint32_t)(input[22] & 0xe0) << 11);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 179 to 194
	value = ((uint32_t)(input[22] & 0x1f) << 27) |
			((uint32_t)input[23] << 19) |
			((uint32_t)(input[24] & 0xe0) << 11);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 195 to 210
	value = ((uint32_t)(input[24] & 0x1f) << 27) |
			((uint32_t)input[25] << 19) |
			((uint32_t)(input[26] & 0xe0) << 11);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 211 to 226
	value = ((uint32_t)(input[26] & 0x1f) << 27) |
			((uint32_t)input[27] << 19) |
			((uint32_t)(input[28] & 0xe0) << 11);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 227 to 242
	value = ((uint32_t)(input[28] & 0x1f) << 27) |
			((uint32_t)input[29] << 19) |
			((uint32_t)(input[30] & 0xe0) << 11);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 243 to 258
	value = ((uint32_t)(input[30] & 0x1f) << 27) |
			((uint32_t)input[31] << 19) |
			((uint32_t)(input[32] & 0xe0) << 11);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 259 to 274
	value = ((uint32_t)(input[32] & 0x1f) << 27) |
			((uint32_t)input[33] << 19) |
			((uint32_t)(input[34] & 0xe0) << 11);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 275 to 290
	value = ((uint32_t)(input[34] & 0x1f) << 27) |
			((uint32_t)input[35] << 19) |
			((uint32_t)(input[36] & 0xe0) << 11);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 291 to 306
	value = ((uint32_t)(input[36] & 0x1f) << 27) |
			((uint32_t)input[37] << 19) |
			((uint32_t)(input[38] & 0xe0) << 11);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 307 to 322
	value = ((uint32_t)(input[38] & 0x1f) << 27) |
			((uint32_t)input[39] << 19) |
			((uint32_t)(input[40] & 0xe0) << 11);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 323 to 338
	value = ((uint32_t)(input[40] & 0x1f) << 27) |
			((uint32_t)input[41] << 19) |
			((uint32_t)(input[42] & 0xe0) << 11);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 339 to 354
	value = ((uint32_t)(input[42] & 0x1f) << 27) |
			((uint32_t)input[43] << 19) |
			((uint32_t)(input[44] & 0xe0) << 11);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 355 to 370
	value = ((uint32_t)(input[44] & 0x1f) << 27) |
			((uint32_t)input[45] << 19) |
			((uint32_t)(input[46] & 0xe0) << 11);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 371 to 386
	value = ((uint32_t)(input[46] & 0x1f) << 27) |
			((uint32_t)input[47] << 19) |
			((uint32_t)(input[48] & 0xe0) << 11);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 387 to 402
	value = ((uint32_t)(input[48] & 0x1f) << 27) |
			((uint32_t)input[49] << 19) |
			((uint32_t)(input[50] & 0xe0) << 11);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 403 to 418
	value = ((uint32_t)(input[50] & 0x1f) << 27) |
			((uint32_t)input[51] << 19) |
			((uint32_t)(input[52] & 0xe0) << 11);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 419 to 434
	value = ((uint32_t)(input[52] & 0x1f) << 27) |
			((uint32_t)input[53] << 19) |
			((uint32_t)(input[54] & 0xe0) << 11);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 435 to 450
	value = ((uint32_t)(input[54] & 0x1f) << 27) |
			((uint32_t)input[55] << 19) |
			((uint32_t)(input[56] & 0xe0) << 11);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 451 to 466
	value = ((uint32_t)(input[56] & 0x1f) << 27) |
			((uint32_t)input[57] << 19) |
			((uint32_t)(input[58] & 0xe0) << 11);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 467 to 482
	value = ((uint32_t)(input[58] & 0x1f) << 27) |
			((uint32_t)input[59] << 19) |
			((uint32_t)(input[60] & 0xe0) << 11);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 483 to 498
	value = ((uint32_t)(input[60] & 0x1f) << 27) |
			((uint32_t)input[61] << 19) |
			((uint32_t)(input[62] & 0xe0) << 11);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 499 to 514
	value = ((uint32_t)(input[62] & 0x1f) << 27) |
			((uint32_t)input[63] << 19) |
			((uint32_t)(input[64] & 0xe0) << 11);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 515 to 530
	value = ((uint32_t)(input[64] & 0x1f) << 27) |
			((uint32_t)input[65] << 19) |
			((uint32_t)(input[66] & 0xe0) << 11);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 531 to 546
	value = ((uint32_t)(input[66] & 0x1f) << 27) |
			((uint32_t)input[67] << 19) |
			((uint32_t)(input[68] & 0xe0) << 11);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 547 to 562
	value = ((uint32_t)(input[68] & 0x1f) << 27) |
			((uint32_t)input[69] << 19) |
			((uint32_t)(input[70] & 0xe0) << 11);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 563 to 578
	value = ((uint32_t)(input[70] & 0x1f) << 27) |
			((uint32_t)input[71] << 19) |
			((uint32_t)(input[72] & 0xe0) << 11);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 579 to 594
	value = ((uint32_t)(input[72] & 0x1f) << 27) |
			((uint32_t)input[73] << 19) |
			((uint32_t)(input[74] & 0xe0) << 11);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 595 to 610
	value = ((uint32_t)(input[74] & 0x1f) << 27) |
			((uint32_t)input[75] << 19) |
			((uint32_t)(input[76] & 0xe0) << 11);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 611 to 626
	value = ((uint32_t)(input[76] & 0x1f) << 27) |
			((uint32_t)input[77] << 19) |
			((uint32_t)(input[78] & 0xe0) << 11);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 627 to 642
	value = ((uint32_t)(input[78] & 0x1f) << 27) |
			((uint32_t)input[79] << 19) |
			((uint32_t)(input[80] & 0xe0) << 11);
	output[39] = (double)(value >> 16);

	// read output[40]: from bit 643 to 658
	value = ((uint32_t)(input[80] & 0x1f) << 27) |
			((uint32_t)input[81] << 19) |
			((uint32_t)(input[82] & 0xe0) << 11);
	output[40] = (double)(value >> 16);

	// read output[41]: from bit 659 to 674
	value = ((uint32_t)(input[82] & 0x1f) << 27) |
			((uint32_t)input[83] << 19) |
			((uint32_t)(input[84] & 0xe0) << 11);
	output[41] = (double)(value >> 16);

	// read output[42]: from bit 675 to 690
	value = ((uint32_t)(input[84] & 0x1f) << 27) |
			((uint32_t)input[85] << 19) |
			((uint32_t)(input[86] & 0xe0) << 11);
	output[42] = (double)(value >> 16);

	// read output[43]: from bit 691 to 706
	value = ((uint32_t)(input[86] & 0x1f) << 27) |
			((uint32_t)input[87] << 19) |
			((uint32_t)(input[88] & 0xe0) << 11);
	output[43] = (double)(value >> 16);

	// read output[44]: from bit 707 to 722
	value = ((uint32_t)(input[88] & 0x1f) << 27) |
			((uint32_t)input[89] << 19) |
			((uint32_t)(input[90] & 0xe0) << 11);
	output[44] = (double)(value >> 16);

	// read output[45]: from bit 723 to 738
	value = ((uint32_t)(input[90] & 0x1f) << 27) |
			((uint32_t)input[91] << 19) |
			((uint32_t)(input[92] & 0xe0) << 11);
	output[45] = (double)(value >> 16);

	// read output[46]: from bit 739 to 754
	value = ((uint32_t)(input[92] & 0x1f) << 27) |
			((uint32_t)input[93] << 19) |
			((uint32_t)(input[94] & 0xe0) << 11);
	output[46] = (double)(value >> 16);

	// read output[47]: from bit 755 to 770
	value = ((uint32_t)(input[94] & 0x1f) << 27) |
			((uint32_t)input[95] << 19) |
			((uint32_t)(input[96] & 0xe0) << 11);
	output[47] = (double)(value >> 16);

	// read output[48]: from bit 771 to 786
	value = ((uint32_t)(input[96] & 0x1f) << 27) |
			((uint32_t)input[97] << 19) |
			((uint32_t)(input[98] & 0xe0) << 11);
	output[48] = (double)(value >> 16);

	// read output[49]: from bit 787 to 802
	value = ((uint32_t)(input[98] & 0x1f) << 27) |
			((uint32_t)input[99] << 19) |
			((uint32_t)(input[100] & 0xe0) << 11);
	output[49] = (double)(value >> 16);

	// read output[50]: from bit 803 to 818
	value = ((uint32_t)(input[100] & 0x1f) << 27) |
			((uint32_t)input[101] << 19) |
			((uint32_t)(input[102] & 0xe0) << 11);
	output[50] = (double)(value >> 16);

	// read output[51]: from bit 819 to 834
	value = ((uint32_t)(input[102] & 0x1f) << 27) |
			((uint32_t)input[103] << 19) |
			((uint32_t)(input[104] & 0xe0) << 11);
	output[51] = (double)(value >> 16);

	// read output[52]: from bit 835 to 850
	value = ((uint32_t)(input[104] & 0x1f) << 27) |
			((uint32_t)input[105] << 19) |
			((uint32_t)(input[106] & 0xe0) << 11);
	output[52] = (double)(value >> 16);

	// read output[53]: from bit 851 to 866
	value = ((uint32_t)(input[106] & 0x1f) << 27) |
			((uint32_t)input[107] << 19) |
			((uint32_t)(input[108] & 0xe0) << 11);
	output[53] = (double)(value >> 16);

	// read output[54]: from bit 867 to 882
	value = ((uint32_t)(input[108] & 0x1f) << 27) |
			((uint32_t)input[109] << 19) |
			((uint32_t)(input[110] & 0xe0) << 11);
	output[54] = (double)(value >> 16);

	// read output[55]: from bit 883 to 898
	value = ((uint32_t)(input[110] & 0x1f) << 27) |
			((uint32_t)input[111] << 19) |
			((uint32_t)(input[112] & 0xe0) << 11);
	output[55] = (double)(value >> 16);

	// read output[56]: from bit 899 to 914
	value = ((uint32_t)(input[112] & 0x1f) << 27) |
			((uint32_t)input[113] << 19) |
			((uint32_t)(input[114] & 0xe0) << 11);
	output[56] = (double)(value >> 16);

	// read output[57]: from bit 915 to 930
	value = ((uint32_t)(input[114] & 0x1f) << 27) |
			((uint32_t)input[115] << 19) |
			((uint32_t)(input[116] & 0xe0) << 11);
	output[57] = (double)(value >> 16);

	// read output[58]: from bit 931 to 946
	value = ((uint32_t)(input[116] & 0x1f) << 27) |
			((uint32_t)input[117] << 19) |
			((uint32_t)(input[118] & 0xe0) << 11);
	output[58] = (double)(value >> 16);

	// read output[59]: from bit 947 to 962
	value = ((uint32_t)(input[118] & 0x1f) << 27) |
			((uint32_t)input[119] << 19) |
			((uint32_t)(input[120] & 0xe0) << 11);
	output[59] = (double)(value >> 16);

	// read output[60]: from bit 963 to 978
	value = ((uint32_t)(input[120] & 0x1f) << 27) |
			((uint32_t)input[121] << 19) |
			((uint32_t)(input[122] & 0xe0) << 11);
	output[60] = (double)(value >> 16);

	// read output[61]: from bit 979 to 994
	value = ((uint32_t)(input[122] & 0x1f) << 27) |
			((uint32_t)input[123] << 19) |
			((uint32_t)(input[124] & 0xe0) << 11);
	output[61] = (double)(value >> 16);

	// read output[62]: from bit 995 to 1010
	value = ((uint32_t)(input[124] & 0x1f) << 27) |
			((uint32_t)input[125] << 19) |
			((uint32_t)(input[126] & 0xe0) << 11);
	output[62] = (double)(value >> 16);
}

static void unpack_63_16bit_signed_4off(const uint8_t * input, double * output, void *closure) {
	// Unpack 63 values into output
	// Values are 16-bit signed
	// Skip 4 bits, read 1008 bits of data.
	// Input must be at least 127 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 4 to 19
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20) |
			((uint32_t)(input[2] & 0xf0) << 12);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 20 to 35
	value = ((uint32_t)(input[2] & 0x0f) << 28) |
			((uint32_t)input[3] << 20) |
			((uint32_t)(input[4] & 0xf0) << 12);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 36 to 51
	value = ((uint32_t)(input[4] & 0x0f) << 28) |
			((uint32_t)input[5] << 20) |
			((uint32_t)(input[6] & 0xf0) << 12);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 52 to 67
	value = ((uint32_t)(input[6] & 0x0f) << 28) |
			((uint32_t)input[7] << 20) |
			((uint32_t)(input[8] & 0xf0) << 12);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 68 to 83
	value = ((uint32_t)(input[8] & 0x0f) << 28) |
			((uint32_t)input[9] << 20) |
			((uint32_t)(input[10] & 0xf0) << 12);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 84 to 99
	value = ((uint32_t)(input[10] & 0x0f) << 28) |
			((uint32_t)input[11] << 20) |
			((uint32_t)(input[12] & 0xf0) << 12);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 100 to 115
	value = ((uint32_t)(input[12] & 0x0f) << 28) |
			((uint32_t)input[13] << 20) |
			((uint32_t)(input[14] & 0xf0) << 12);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 116 to 131
	value = ((uint32_t)(input[14] & 0x0f) << 28) |
			((uint32_t)input[15] << 20) |
			((uint32_t)(input[16] & 0xf0) << 12);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 132 to 147
	value = ((uint32_t)(input[16] & 0x0f) << 28) |
			((uint32_t)input[17] << 20) |
			((uint32_t)(input[18] & 0xf0) << 12);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 148 to 163
	value = ((uint32_t)(input[18] & 0x0f) << 28) |
			((uint32_t)input[19] << 20) |
			((uint32_t)(input[20] & 0xf0) << 12);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 164 to 179
	value = ((uint32_t)(input[20] & 0x0f) << 28) |
			((uint32_t)input[21] << 20) |
			((uint32_t)(input[22] & 0xf0) << 12);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 180 to 195
	value = ((uint32_t)(input[22] & 0x0f) << 28) |
			((uint32_t)input[23] << 20) |
			((uint32_t)(input[24] & 0xf0) << 12);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 196 to 211
	value = ((uint32_t)(input[24] & 0x0f) << 28) |
			((uint32_t)input[25] << 20) |
			((uint32_t)(input[26] & 0xf0) << 12);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 212 to 227
	value = ((uint32_t)(input[26] & 0x0f) << 28) |
			((uint32_t)input[27] << 20) |
			((uint32_t)(input[28] & 0xf0) << 12);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 228 to 243
	value = ((uint32_t)(input[28] & 0x0f) << 28) |
			((uint32_t)input[29] << 20) |
			((uint32_t)(input[30] & 0xf0) << 12);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 244 to 259
	value = ((uint32_t)(input[30] & 0x0f) << 28) |
			((uint32_t)input[31] << 20) |
			((uint32_t)(input[32] & 0xf0) << 12);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 260 to 275
	value = ((uint32_t)(input[32] & 0x0f) << 28) |
			((uint32_t)input[33] << 20) |
			((uint32_t)(input[34] & 0xf0) << 12);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 276 to 291
	value = ((uint32_t)(input[34] & 0x0f) << 28) |
			((uint32_t)input[35] << 20) |
			((uint32_t)(input[36] & 0xf0) << 12);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 292 to 307
	value = ((uint32_t)(input[36] & 0x0f) << 28) |
			((uint32_t)input[37] << 20) |
			((uint32_t)(input[38] & 0xf0) << 12);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 308 to 323
	value = ((uint32_t)(input[38] & 0x0f) << 28) |
			((uint32_t)input[39] << 20) |
			((uint32_t)(input[40] & 0xf0) << 12);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 324 to 339
	value = ((uint32_t)(input[40] & 0x0f) << 28) |
			((uint32_t)input[41] << 20) |
			((uint32_t)(input[42] & 0xf0) << 12);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 340 to 355
	value = ((uint32_t)(input[42] & 0x0f) << 28) |
			((uint32_t)input[43] << 20) |
			((uint32_t)(input[44] & 0xf0) << 12);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 356 to 371
	value = ((uint32_t)(input[44] & 0x0f) << 28) |
			((uint32_t)input[45] << 20) |
			((uint32_t)(input[46] & 0xf0) << 12);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 372 to 387
	value = ((uint32_t)(input[46] & 0x0f) << 28) |
			((uint32_t)input[47] << 20) |
			((uint32_t)(input[48] & 0xf0) << 12);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 388 to 403
	value = ((uint32_t)(input[48] & 0x0f) << 28) |
			((uint32_t)input[49] << 20) |
			((uint32_t)(input[50] & 0xf0) << 12);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 404 to 419
	value = ((uint32_t)(input[50] & 0x0f) << 28) |
			((uint32_t)input[51] << 20) |
			((uint32_t)(input[52] & 0xf0) << 12);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 420 to 435
	value = ((uint32_t)(input[52] & 0x0f) << 28) |
			((uint32_t)input[53] << 20) |
			((uint32_t)(input[54] & 0xf0) << 12);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 436 to 451
	value = ((uint32_t)(input[54] & 0x0f) << 28) |
			((uint32_t)input[55] << 20) |
			((uint32_t)(input[56] & 0xf0) << 12);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 452 to 467
	value = ((uint32_t)(input[56] & 0x0f) << 28) |
			((uint32_t)input[57] << 20) |
			((uint32_t)(input[58] & 0xf0) << 12);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 468 to 483
	value = ((uint32_t)(input[58] & 0x0f) << 28) |
			((uint32_t)input[59] << 20) |
			((uint32_t)(input[60] & 0xf0) << 12);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 484 to 499
	value = ((uint32_t)(input[60] & 0x0f) << 28) |
			((uint32_t)input[61] << 20) |
			((uint32_t)(input[62] & 0xf0) << 12);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 500 to 515
	value = ((uint32_t)(input[62] & 0x0f) << 28) |
			((uint32_t)input[63] << 20) |
			((uint32_t)(input[64] & 0xf0) << 12);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 516 to 531
	value = ((uint32_t)(input[64] & 0x0f) << 28) |
			((uint32_t)input[65] << 20) |
			((uint32_t)(input[66] & 0xf0) << 12);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 532 to 547
	value = ((uint32_t)(input[66] & 0x0f) << 28) |
			((uint32_t)input[67] << 20) |
			((uint32_t)(input[68] & 0xf0) << 12);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 548 to 563
	value = ((uint32_t)(input[68] & 0x0f) << 28) |
			((uint32_t)input[69] << 20) |
			((uint32_t)(input[70] & 0xf0) << 12);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 564 to 579
	value = ((uint32_t)(input[70] & 0x0f) << 28) |
			((uint32_t)input[71] << 20) |
			((uint32_t)(input[72] & 0xf0) << 12);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 580 to 595
	value = ((uint32_t)(input[72] & 0x0f) << 28) |
			((uint32_t)input[73] << 20) |
			((uint32_t)(input[74] & 0xf0) << 12);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 596 to 611
	value = ((uint32_t)(input[74] & 0x0f) << 28) |
			((uint32_t)input[75] << 20) |
			((uint32_t)(input[76] & 0xf0) << 12);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 612 to 627
	value = ((uint32_t)(input[76] & 0x0f) << 28) |
			((uint32_t)input[77] << 20) |
			((uint32_t)(input[78] & 0xf0) << 12);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 628 to 643
	value = ((uint32_t)(input[78] & 0x0f) << 28) |
			((uint32_t)input[79] << 20) |
			((uint32_t)(input[80] & 0xf0) << 12);
	output[39] = (double)(value >> 16);

	// read output[40]: from bit 644 to 659
	value = ((uint32_t)(input[80] & 0x0f) << 28) |
			((uint32_t)input[81] << 20) |
			((uint32_t)(input[82] & 0xf0) << 12);
	output[40] = (double)(value >> 16);

	// read output[41]: from bit 660 to 675
	value = ((uint32_t)(input[82] & 0x0f) << 28) |
			((uint32_t)input[83] << 20) |
			((uint32_t)(input[84] & 0xf0) << 12);
	output[41] = (double)(value >> 16);

	// read output[42]: from bit 676 to 691
	value = ((uint32_t)(input[84] & 0x0f) << 28) |
			((uint32_t)input[85] << 20) |
			((uint32_t)(input[86] & 0xf0) << 12);
	output[42] = (double)(value >> 16);

	// read output[43]: from bit 692 to 707
	value = ((uint32_t)(input[86] & 0x0f) << 28) |
			((uint32_t)input[87] << 20) |
			((uint32_t)(input[88] & 0xf0) << 12);
	output[43] = (double)(value >> 16);

	// read output[44]: from bit 708 to 723
	value = ((uint32_t)(input[88] & 0x0f) << 28) |
			((uint32_t)input[89] << 20) |
			((uint32_t)(input[90] & 0xf0) << 12);
	output[44] = (double)(value >> 16);

	// read output[45]: from bit 724 to 739
	value = ((uint32_t)(input[90] & 0x0f) << 28) |
			((uint32_t)input[91] << 20) |
			((uint32_t)(input[92] & 0xf0) << 12);
	output[45] = (double)(value >> 16);

	// read output[46]: from bit 740 to 755
	value = ((uint32_t)(input[92] & 0x0f) << 28) |
			((uint32_t)input[93] << 20) |
			((uint32_t)(input[94] & 0xf0) << 12);
	output[46] = (double)(value >> 16);

	// read output[47]: from bit 756 to 771
	value = ((uint32_t)(input[94] & 0x0f) << 28) |
			((uint32_t)input[95] << 20) |
			((uint32_t)(input[96] & 0xf0) << 12);
	output[47] = (double)(value >> 16);

	// read output[48]: from bit 772 to 787
	value = ((uint32_t)(input[96] & 0x0f) << 28) |
			((uint32_t)input[97] << 20) |
			((uint32_t)(input[98] & 0xf0) << 12);
	output[48] = (double)(value >> 16);

	// read output[49]: from bit 788 to 803
	value = ((uint32_t)(input[98] & 0x0f) << 28) |
			((uint32_t)input[99] << 20) |
			((uint32_t)(input[100] & 0xf0) << 12);
	output[49] = (double)(value >> 16);

	// read output[50]: from bit 804 to 819
	value = ((uint32_t)(input[100] & 0x0f) << 28) |
			((uint32_t)input[101] << 20) |
			((uint32_t)(input[102] & 0xf0) << 12);
	output[50] = (double)(value >> 16);

	// read output[51]: from bit 820 to 835
	value = ((uint32_t)(input[102] & 0x0f) << 28) |
			((uint32_t)input[103] << 20) |
			((uint32_t)(input[104] & 0xf0) << 12);
	output[51] = (double)(value >> 16);

	// read output[52]: from bit 836 to 851
	value = ((uint32_t)(input[104] & 0x0f) << 28) |
			((uint32_t)input[105] << 20) |
			((uint32_t)(input[106] & 0xf0) << 12);
	output[52] = (double)(value >> 16);

	// read output[53]: from bit 852 to 867
	value = ((uint32_t)(input[106] & 0x0f) << 28) |
			((uint32_t)input[107] << 20) |
			((uint32_t)(input[108] & 0xf0) << 12);
	output[53] = (double)(value >> 16);

	// read output[54]: from bit 868 to 883
	value = ((uint32_t)(input[108] & 0x0f) << 28) |
			((uint32_t)input[109] << 20) |
			((uint32_t)(input[110] & 0xf0) << 12);
	output[54] = (double)(value >> 16);

	// read output[55]: from bit 884 to 899
	value = ((uint32_t)(input[110] & 0x0f) << 28) |
			((uint32_t)input[111] << 20) |
			((uint32_t)(input[112] & 0xf0) << 12);
	output[55] = (double)(value >> 16);

	// read output[56]: from bit 900 to 915
	value = ((uint32_t)(input[112] & 0x0f) << 28) |
			((uint32_t)input[113] << 20) |
			((uint32_t)(input[114] & 0xf0) << 12);
	output[56] = (double)(value >> 16);

	// read output[57]: from bit 916 to 931
	value = ((uint32_t)(input[114] & 0x0f) << 28) |
			((uint32_t)input[115] << 20) |
			((uint32_t)(input[116] & 0xf0) << 12);
	output[57] = (double)(value >> 16);

	// read output[58]: from bit 932 to 947
	value = ((uint32_t)(input[116] & 0x0f) << 28) |
			((uint32_t)input[117] << 20) |
			((uint32_t)(input[118] & 0xf0) << 12);
	output[58] = (double)(value >> 16);

	// read output[59]: from bit 948 to 963
	value = ((uint32_t)(input[118] & 0x0f) << 28) |
			((uint32_t)input[119] << 20) |
			((uint32_t)(input[120] & 0xf0) << 12);
	output[59] = (double)(value >> 16);

	// read output[60]: from bit 964 to 979
	value = ((uint32_t)(input[120] & 0x0f) << 28) |
			((uint32_t)input[121] << 20) |
			((uint32_t)(input[122] & 0xf0) << 12);
	output[60] = (double)(value >> 16);

	// read output[61]: from bit 980 to 995
	value = ((uint32_t)(input[122] & 0x0f) << 28) |
			((uint32_t)input[123] << 20) |
			((uint32_t)(input[124] & 0xf0) << 12);
	output[61] = (double)(value >> 16);

	// read output[62]: from bit 996 to 1011
	value = ((uint32_t)(input[124] & 0x0f) << 28) |
			((uint32_t)input[125] << 20) |
			((uint32_t)(input[126] & 0xf0) << 12);
	output[62] = (double)(value >> 16);
}

static void unpack_63_16bit_unsigned_4off(const uint8_t * input, double * output, void *closure) {
	// Unpack 63 values into output
	// Values are 16-bit unsigned
	// Skip 4 bits, read 1008 bits of data.
	// Input must be at least 127 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 4 to 19
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20) |
			((uint32_t)(input[2] & 0xf0) << 12);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 20 to 35
	value = ((uint32_t)(input[2] & 0x0f) << 28) |
			((uint32_t)input[3] << 20) |
			((uint32_t)(input[4] & 0xf0) << 12);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 36 to 51
	value = ((uint32_t)(input[4] & 0x0f) << 28) |
			((uint32_t)input[5] << 20) |
			((uint32_t)(input[6] & 0xf0) << 12);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 52 to 67
	value = ((uint32_t)(input[6] & 0x0f) << 28) |
			((uint32_t)input[7] << 20) |
			((uint32_t)(input[8] & 0xf0) << 12);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 68 to 83
	value = ((uint32_t)(input[8] & 0x0f) << 28) |
			((uint32_t)input[9] << 20) |
			((uint32_t)(input[10] & 0xf0) << 12);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 84 to 99
	value = ((uint32_t)(input[10] & 0x0f) << 28) |
			((uint32_t)input[11] << 20) |
			((uint32_t)(input[12] & 0xf0) << 12);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 100 to 115
	value = ((uint32_t)(input[12] & 0x0f) << 28) |
			((uint32_t)input[13] << 20) |
			((uint32_t)(input[14] & 0xf0) << 12);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 116 to 131
	value = ((uint32_t)(input[14] & 0x0f) << 28) |
			((uint32_t)input[15] << 20) |
			((uint32_t)(input[16] & 0xf0) << 12);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 132 to 147
	value = ((uint32_t)(input[16] & 0x0f) << 28) |
			((uint32_t)input[17] << 20) |
			((uint32_t)(input[18] & 0xf0) << 12);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 148 to 163
	value = ((uint32_t)(input[18] & 0x0f) << 28) |
			((uint32_t)input[19] << 20) |
			((uint32_t)(input[20] & 0xf0) << 12);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 164 to 179
	value = ((uint32_t)(input[20] & 0x0f) << 28) |
			((uint32_t)input[21] << 20) |
			((uint32_t)(input[22] & 0xf0) << 12);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 180 to 195
	value = ((uint32_t)(input[22] & 0x0f) << 28) |
			((uint32_t)input[23] << 20) |
			((uint32_t)(input[24] & 0xf0) << 12);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 196 to 211
	value = ((uint32_t)(input[24] & 0x0f) << 28) |
			((uint32_t)input[25] << 20) |
			((uint32_t)(input[26] & 0xf0) << 12);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 212 to 227
	value = ((uint32_t)(input[26] & 0x0f) << 28) |
			((uint32_t)input[27] << 20) |
			((uint32_t)(input[28] & 0xf0) << 12);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 228 to 243
	value = ((uint32_t)(input[28] & 0x0f) << 28) |
			((uint32_t)input[29] << 20) |
			((uint32_t)(input[30] & 0xf0) << 12);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 244 to 259
	value = ((uint32_t)(input[30] & 0x0f) << 28) |
			((uint32_t)input[31] << 20) |
			((uint32_t)(input[32] & 0xf0) << 12);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 260 to 275
	value = ((uint32_t)(input[32] & 0x0f) << 28) |
			((uint32_t)input[33] << 20) |
			((uint32_t)(input[34] & 0xf0) << 12);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 276 to 291
	value = ((uint32_t)(input[34] & 0x0f) << 28) |
			((uint32_t)input[35] << 20) |
			((uint32_t)(input[36] & 0xf0) << 12);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 292 to 307
	value = ((uint32_t)(input[36] & 0x0f) << 28) |
			((uint32_t)input[37] << 20) |
			((uint32_t)(input[38] & 0xf0) << 12);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 308 to 323
	value = ((uint32_t)(input[38] & 0x0f) << 28) |
			((uint32_t)input[39] << 20) |
			((uint32_t)(input[40] & 0xf0) << 12);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 324 to 339
	value = ((uint32_t)(input[40] & 0x0f) << 28) |
			((uint32_t)input[41] << 20) |
			((uint32_t)(input[42] & 0xf0) << 12);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 340 to 355
	value = ((uint32_t)(input[42] & 0x0f) << 28) |
			((uint32_t)input[43] << 20) |
			((uint32_t)(input[44] & 0xf0) << 12);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 356 to 371
	value = ((uint32_t)(input[44] & 0x0f) << 28) |
			((uint32_t)input[45] << 20) |
			((uint32_t)(input[46] & 0xf0) << 12);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 372 to 387
	value = ((uint32_t)(input[46] & 0x0f) << 28) |
			((uint32_t)input[47] << 20) |
			((uint32_t)(input[48] & 0xf0) << 12);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 388 to 403
	value = ((uint32_t)(input[48] & 0x0f) << 28) |
			((uint32_t)input[49] << 20) |
			((uint32_t)(input[50] & 0xf0) << 12);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 404 to 419
	value = ((uint32_t)(input[50] & 0x0f) << 28) |
			((uint32_t)input[51] << 20) |
			((uint32_t)(input[52] & 0xf0) << 12);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 420 to 435
	value = ((uint32_t)(input[52] & 0x0f) << 28) |
			((uint32_t)input[53] << 20) |
			((uint32_t)(input[54] & 0xf0) << 12);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 436 to 451
	value = ((uint32_t)(input[54] & 0x0f) << 28) |
			((uint32_t)input[55] << 20) |
			((uint32_t)(input[56] & 0xf0) << 12);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 452 to 467
	value = ((uint32_t)(input[56] & 0x0f) << 28) |
			((uint32_t)input[57] << 20) |
			((uint32_t)(input[58] & 0xf0) << 12);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 468 to 483
	value = ((uint32_t)(input[58] & 0x0f) << 28) |
			((uint32_t)input[59] << 20) |
			((uint32_t)(input[60] & 0xf0) << 12);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 484 to 499
	value = ((uint32_t)(input[60] & 0x0f) << 28) |
			((uint32_t)input[61] << 20) |
			((uint32_t)(input[62] & 0xf0) << 12);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 500 to 515
	value = ((uint32_t)(input[62] & 0x0f) << 28) |
			((uint32_t)input[63] << 20) |
			((uint32_t)(input[64] & 0xf0) << 12);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 516 to 531
	value = ((uint32_t)(input[64] & 0x0f) << 28) |
			((uint32_t)input[65] << 20) |
			((uint32_t)(input[66] & 0xf0) << 12);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 532 to 547
	value = ((uint32_t)(input[66] & 0x0f) << 28) |
			((uint32_t)input[67] << 20) |
			((uint32_t)(input[68] & 0xf0) << 12);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 548 to 563
	value = ((uint32_t)(input[68] & 0x0f) << 28) |
			((uint32_t)input[69] << 20) |
			((uint32_t)(input[70] & 0xf0) << 12);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 564 to 579
	value = ((uint32_t)(input[70] & 0x0f) << 28) |
			((uint32_t)input[71] << 20) |
			((uint32_t)(input[72] & 0xf0) << 12);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 580 to 595
	value = ((uint32_t)(input[72] & 0x0f) << 28) |
			((uint32_t)input[73] << 20) |
			((uint32_t)(input[74] & 0xf0) << 12);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 596 to 611
	value = ((uint32_t)(input[74] & 0x0f) << 28) |
			((uint32_t)input[75] << 20) |
			((uint32_t)(input[76] & 0xf0) << 12);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 612 to 627
	value = ((uint32_t)(input[76] & 0x0f) << 28) |
			((uint32_t)input[77] << 20) |
			((uint32_t)(input[78] & 0xf0) << 12);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 628 to 643
	value = ((uint32_t)(input[78] & 0x0f) << 28) |
			((uint32_t)input[79] << 20) |
			((uint32_t)(input[80] & 0xf0) << 12);
	output[39] = (double)(value >> 16);

	// read output[40]: from bit 644 to 659
	value = ((uint32_t)(input[80] & 0x0f) << 28) |
			((uint32_t)input[81] << 20) |
			((uint32_t)(input[82] & 0xf0) << 12);
	output[40] = (double)(value >> 16);

	// read output[41]: from bit 660 to 675
	value = ((uint32_t)(input[82] & 0x0f) << 28) |
			((uint32_t)input[83] << 20) |
			((uint32_t)(input[84] & 0xf0) << 12);
	output[41] = (double)(value >> 16);

	// read output[42]: from bit 676 to 691
	value = ((uint32_t)(input[84] & 0x0f) << 28) |
			((uint32_t)input[85] << 20) |
			((uint32_t)(input[86] & 0xf0) << 12);
	output[42] = (double)(value >> 16);

	// read output[43]: from bit 692 to 707
	value = ((uint32_t)(input[86] & 0x0f) << 28) |
			((uint32_t)input[87] << 20) |
			((uint32_t)(input[88] & 0xf0) << 12);
	output[43] = (double)(value >> 16);

	// read output[44]: from bit 708 to 723
	value = ((uint32_t)(input[88] & 0x0f) << 28) |
			((uint32_t)input[89] << 20) |
			((uint32_t)(input[90] & 0xf0) << 12);
	output[44] = (double)(value >> 16);

	// read output[45]: from bit 724 to 739
	value = ((uint32_t)(input[90] & 0x0f) << 28) |
			((uint32_t)input[91] << 20) |
			((uint32_t)(input[92] & 0xf0) << 12);
	output[45] = (double)(value >> 16);

	// read output[46]: from bit 740 to 755
	value = ((uint32_t)(input[92] & 0x0f) << 28) |
			((uint32_t)input[93] << 20) |
			((uint32_t)(input[94] & 0xf0) << 12);
	output[46] = (double)(value >> 16);

	// read output[47]: from bit 756 to 771
	value = ((uint32_t)(input[94] & 0x0f) << 28) |
			((uint32_t)input[95] << 20) |
			((uint32_t)(input[96] & 0xf0) << 12);
	output[47] = (double)(value >> 16);

	// read output[48]: from bit 772 to 787
	value = ((uint32_t)(input[96] & 0x0f) << 28) |
			((uint32_t)input[97] << 20) |
			((uint32_t)(input[98] & 0xf0) << 12);
	output[48] = (double)(value >> 16);

	// read output[49]: from bit 788 to 803
	value = ((uint32_t)(input[98] & 0x0f) << 28) |
			((uint32_t)input[99] << 20) |
			((uint32_t)(input[100] & 0xf0) << 12);
	output[49] = (double)(value >> 16);

	// read output[50]: from bit 804 to 819
	value = ((uint32_t)(input[100] & 0x0f) << 28) |
			((uint32_t)input[101] << 20) |
			((uint32_t)(input[102] & 0xf0) << 12);
	output[50] = (double)(value >> 16);

	// read output[51]: from bit 820 to 835
	value = ((uint32_t)(input[102] & 0x0f) << 28) |
			((uint32_t)input[103] << 20) |
			((uint32_t)(input[104] & 0xf0) << 12);
	output[51] = (double)(value >> 16);

	// read output[52]: from bit 836 to 851
	value = ((uint32_t)(input[104] & 0x0f) << 28) |
			((uint32_t)input[105] << 20) |
			((uint32_t)(input[106] & 0xf0) << 12);
	output[52] = (double)(value >> 16);

	// read output[53]: from bit 852 to 867
	value = ((uint32_t)(input[106] & 0x0f) << 28) |
			((uint32_t)input[107] << 20) |
			((uint32_t)(input[108] & 0xf0) << 12);
	output[53] = (double)(value >> 16);

	// read output[54]: from bit 868 to 883
	value = ((uint32_t)(input[108] & 0x0f) << 28) |
			((uint32_t)input[109] << 20) |
			((uint32_t)(input[110] & 0xf0) << 12);
	output[54] = (double)(value >> 16);

	// read output[55]: from bit 884 to 899
	value = ((uint32_t)(input[110] & 0x0f) << 28) |
			((uint32_t)input[111] << 20) |
			((uint32_t)(input[112] & 0xf0) << 12);
	output[55] = (double)(value >> 16);

	// read output[56]: from bit 900 to 915
	value = ((uint32_t)(input[112] & 0x0f) << 28) |
			((uint32_t)input[113] << 20) |
			((uint32_t)(input[114] & 0xf0) << 12);
	output[56] = (double)(value >> 16);

	// read output[57]: from bit 916 to 931
	value = ((uint32_t)(input[114] & 0x0f) << 28) |
			((uint32_t)input[115] << 20) |
			((uint32_t)(input[116] & 0xf0) << 12);
	output[57] = (double)(value >> 16);

	// read output[58]: from bit 932 to 947
	value = ((uint32_t)(input[116] & 0x0f) << 28) |
			((uint32_t)input[117] << 20) |
			((uint32_t)(input[118] & 0xf0) << 12);
	output[58] = (double)(value >> 16);

	// read output[59]: from bit 948 to 963
	value = ((uint32_t)(input[118] & 0x0f) << 28) |
			((uint32_t)input[119] << 20) |
			((uint32_t)(input[120] & 0xf0) << 12);
	output[59] = (double)(value >> 16);

	// read output[60]: from bit 964 to 979
	value = ((uint32_t)(input[120] & 0x0f) << 28) |
			((uint32_t)input[121] << 20) |
			((uint32_t)(input[122] & 0xf0) << 12);
	output[60] = (double)(value >> 16);

	// read output[61]: from bit 980 to 995
	value = ((uint32_t)(input[122] & 0x0f) << 28) |
			((uint32_t)input[123] << 20) |
			((uint32_t)(input[124] & 0xf0) << 12);
	output[61] = (double)(value >> 16);

	// read output[62]: from bit 996 to 1011
	value = ((uint32_t)(input[124] & 0x0f) << 28) |
			((uint32_t)input[125] << 20) |
			((uint32_t)(input[126] & 0xf0) << 12);
	output[62] = (double)(value >> 16);
}

static void unpack_63_16bit_signed_5off(const uint8_t * input, double * output, void *closure) {
	// Unpack 63 values into output
	// Values are 16-bit signed
	// Skip 5 bits, read 1008 bits of data.
	// Input must be at least 127 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 5 to 20
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)(input[2] & 0xf8) << 13);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 21 to 36
	value = ((uint32_t)(input[2] & 0x07) << 29) |
			((uint32_t)input[3] << 21) |
			((uint32_t)(input[4] & 0xf8) << 13);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 37 to 52
	value = ((uint32_t)(input[4] & 0x07) << 29) |
			((uint32_t)input[5] << 21) |
			((uint32_t)(input[6] & 0xf8) << 13);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 53 to 68
	value = ((uint32_t)(input[6] & 0x07) << 29) |
			((uint32_t)input[7] << 21) |
			((uint32_t)(input[8] & 0xf8) << 13);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 69 to 84
	value = ((uint32_t)(input[8] & 0x07) << 29) |
			((uint32_t)input[9] << 21) |
			((uint32_t)(input[10] & 0xf8) << 13);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 85 to 100
	value = ((uint32_t)(input[10] & 0x07) << 29) |
			((uint32_t)input[11] << 21) |
			((uint32_t)(input[12] & 0xf8) << 13);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 101 to 116
	value = ((uint32_t)(input[12] & 0x07) << 29) |
			((uint32_t)input[13] << 21) |
			((uint32_t)(input[14] & 0xf8) << 13);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 117 to 132
	value = ((uint32_t)(input[14] & 0x07) << 29) |
			((uint32_t)input[15] << 21) |
			((uint32_t)(input[16] & 0xf8) << 13);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 133 to 148
	value = ((uint32_t)(input[16] & 0x07) << 29) |
			((uint32_t)input[17] << 21) |
			((uint32_t)(input[18] & 0xf8) << 13);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 149 to 164
	value = ((uint32_t)(input[18] & 0x07) << 29) |
			((uint32_t)input[19] << 21) |
			((uint32_t)(input[20] & 0xf8) << 13);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 165 to 180
	value = ((uint32_t)(input[20] & 0x07) << 29) |
			((uint32_t)input[21] << 21) |
			((uint32_t)(input[22] & 0xf8) << 13);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 181 to 196
	value = ((uint32_t)(input[22] & 0x07) << 29) |
			((uint32_t)input[23] << 21) |
			((uint32_t)(input[24] & 0xf8) << 13);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 197 to 212
	value = ((uint32_t)(input[24] & 0x07) << 29) |
			((uint32_t)input[25] << 21) |
			((uint32_t)(input[26] & 0xf8) << 13);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 213 to 228
	value = ((uint32_t)(input[26] & 0x07) << 29) |
			((uint32_t)input[27] << 21) |
			((uint32_t)(input[28] & 0xf8) << 13);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 229 to 244
	value = ((uint32_t)(input[28] & 0x07) << 29) |
			((uint32_t)input[29] << 21) |
			((uint32_t)(input[30] & 0xf8) << 13);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 245 to 260
	value = ((uint32_t)(input[30] & 0x07) << 29) |
			((uint32_t)input[31] << 21) |
			((uint32_t)(input[32] & 0xf8) << 13);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 261 to 276
	value = ((uint32_t)(input[32] & 0x07) << 29) |
			((uint32_t)input[33] << 21) |
			((uint32_t)(input[34] & 0xf8) << 13);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 277 to 292
	value = ((uint32_t)(input[34] & 0x07) << 29) |
			((uint32_t)input[35] << 21) |
			((uint32_t)(input[36] & 0xf8) << 13);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 293 to 308
	value = ((uint32_t)(input[36] & 0x07) << 29) |
			((uint32_t)input[37] << 21) |
			((uint32_t)(input[38] & 0xf8) << 13);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 309 to 324
	value = ((uint32_t)(input[38] & 0x07) << 29) |
			((uint32_t)input[39] << 21) |
			((uint32_t)(input[40] & 0xf8) << 13);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 325 to 340
	value = ((uint32_t)(input[40] & 0x07) << 29) |
			((uint32_t)input[41] << 21) |
			((uint32_t)(input[42] & 0xf8) << 13);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 341 to 356
	value = ((uint32_t)(input[42] & 0x07) << 29) |
			((uint32_t)input[43] << 21) |
			((uint32_t)(input[44] & 0xf8) << 13);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 357 to 372
	value = ((uint32_t)(input[44] & 0x07) << 29) |
			((uint32_t)input[45] << 21) |
			((uint32_t)(input[46] & 0xf8) << 13);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 373 to 388
	value = ((uint32_t)(input[46] & 0x07) << 29) |
			((uint32_t)input[47] << 21) |
			((uint32_t)(input[48] & 0xf8) << 13);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 389 to 404
	value = ((uint32_t)(input[48] & 0x07) << 29) |
			((uint32_t)input[49] << 21) |
			((uint32_t)(input[50] & 0xf8) << 13);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 405 to 420
	value = ((uint32_t)(input[50] & 0x07) << 29) |
			((uint32_t)input[51] << 21) |
			((uint32_t)(input[52] & 0xf8) << 13);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 421 to 436
	value = ((uint32_t)(input[52] & 0x07) << 29) |
			((uint32_t)input[53] << 21) |
			((uint32_t)(input[54] & 0xf8) << 13);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 437 to 452
	value = ((uint32_t)(input[54] & 0x07) << 29) |
			((uint32_t)input[55] << 21) |
			((uint32_t)(input[56] & 0xf8) << 13);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 453 to 468
	value = ((uint32_t)(input[56] & 0x07) << 29) |
			((uint32_t)input[57] << 21) |
			((uint32_t)(input[58] & 0xf8) << 13);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 469 to 484
	value = ((uint32_t)(input[58] & 0x07) << 29) |
			((uint32_t)input[59] << 21) |
			((uint32_t)(input[60] & 0xf8) << 13);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 485 to 500
	value = ((uint32_t)(input[60] & 0x07) << 29) |
			((uint32_t)input[61] << 21) |
			((uint32_t)(input[62] & 0xf8) << 13);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 501 to 516
	value = ((uint32_t)(input[62] & 0x07) << 29) |
			((uint32_t)input[63] << 21) |
			((uint32_t)(input[64] & 0xf8) << 13);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 517 to 532
	value = ((uint32_t)(input[64] & 0x07) << 29) |
			((uint32_t)input[65] << 21) |
			((uint32_t)(input[66] & 0xf8) << 13);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 533 to 548
	value = ((uint32_t)(input[66] & 0x07) << 29) |
			((uint32_t)input[67] << 21) |
			((uint32_t)(input[68] & 0xf8) << 13);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 549 to 564
	value = ((uint32_t)(input[68] & 0x07) << 29) |
			((uint32_t)input[69] << 21) |
			((uint32_t)(input[70] & 0xf8) << 13);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 565 to 580
	value = ((uint32_t)(input[70] & 0x07) << 29) |
			((uint32_t)input[71] << 21) |
			((uint32_t)(input[72] & 0xf8) << 13);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 581 to 596
	value = ((uint32_t)(input[72] & 0x07) << 29) |
			((uint32_t)input[73] << 21) |
			((uint32_t)(input[74] & 0xf8) << 13);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 597 to 612
	value = ((uint32_t)(input[74] & 0x07) << 29) |
			((uint32_t)input[75] << 21) |
			((uint32_t)(input[76] & 0xf8) << 13);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 613 to 628
	value = ((uint32_t)(input[76] & 0x07) << 29) |
			((uint32_t)input[77] << 21) |
			((uint32_t)(input[78] & 0xf8) << 13);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 629 to 644
	value = ((uint32_t)(input[78] & 0x07) << 29) |
			((uint32_t)input[79] << 21) |
			((uint32_t)(input[80] & 0xf8) << 13);
	output[39] = (double)(value >> 16);

	// read output[40]: from bit 645 to 660
	value = ((uint32_t)(input[80] & 0x07) << 29) |
			((uint32_t)input[81] << 21) |
			((uint32_t)(input[82] & 0xf8) << 13);
	output[40] = (double)(value >> 16);

	// read output[41]: from bit 661 to 676
	value = ((uint32_t)(input[82] & 0x07) << 29) |
			((uint32_t)input[83] << 21) |
			((uint32_t)(input[84] & 0xf8) << 13);
	output[41] = (double)(value >> 16);

	// read output[42]: from bit 677 to 692
	value = ((uint32_t)(input[84] & 0x07) << 29) |
			((uint32_t)input[85] << 21) |
			((uint32_t)(input[86] & 0xf8) << 13);
	output[42] = (double)(value >> 16);

	// read output[43]: from bit 693 to 708
	value = ((uint32_t)(input[86] & 0x07) << 29) |
			((uint32_t)input[87] << 21) |
			((uint32_t)(input[88] & 0xf8) << 13);
	output[43] = (double)(value >> 16);

	// read output[44]: from bit 709 to 724
	value = ((uint32_t)(input[88] & 0x07) << 29) |
			((uint32_t)input[89] << 21) |
			((uint32_t)(input[90] & 0xf8) << 13);
	output[44] = (double)(value >> 16);

	// read output[45]: from bit 725 to 740
	value = ((uint32_t)(input[90] & 0x07) << 29) |
			((uint32_t)input[91] << 21) |
			((uint32_t)(input[92] & 0xf8) << 13);
	output[45] = (double)(value >> 16);

	// read output[46]: from bit 741 to 756
	value = ((uint32_t)(input[92] & 0x07) << 29) |
			((uint32_t)input[93] << 21) |
			((uint32_t)(input[94] & 0xf8) << 13);
	output[46] = (double)(value >> 16);

	// read output[47]: from bit 757 to 772
	value = ((uint32_t)(input[94] & 0x07) << 29) |
			((uint32_t)input[95] << 21) |
			((uint32_t)(input[96] & 0xf8) << 13);
	output[47] = (double)(value >> 16);

	// read output[48]: from bit 773 to 788
	value = ((uint32_t)(input[96] & 0x07) << 29) |
			((uint32_t)input[97] << 21) |
			((uint32_t)(input[98] & 0xf8) << 13);
	output[48] = (double)(value >> 16);

	// read output[49]: from bit 789 to 804
	value = ((uint32_t)(input[98] & 0x07) << 29) |
			((uint32_t)input[99] << 21) |
			((uint32_t)(input[100] & 0xf8) << 13);
	output[49] = (double)(value >> 16);

	// read output[50]: from bit 805 to 820
	value = ((uint32_t)(input[100] & 0x07) << 29) |
			((uint32_t)input[101] << 21) |
			((uint32_t)(input[102] & 0xf8) << 13);
	output[50] = (double)(value >> 16);

	// read output[51]: from bit 821 to 836
	value = ((uint32_t)(input[102] & 0x07) << 29) |
			((uint32_t)input[103] << 21) |
			((uint32_t)(input[104] & 0xf8) << 13);
	output[51] = (double)(value >> 16);

	// read output[52]: from bit 837 to 852
	value = ((uint32_t)(input[104] & 0x07) << 29) |
			((uint32_t)input[105] << 21) |
			((uint32_t)(input[106] & 0xf8) << 13);
	output[52] = (double)(value >> 16);

	// read output[53]: from bit 853 to 868
	value = ((uint32_t)(input[106] & 0x07) << 29) |
			((uint32_t)input[107] << 21) |
			((uint32_t)(input[108] & 0xf8) << 13);
	output[53] = (double)(value >> 16);

	// read output[54]: from bit 869 to 884
	value = ((uint32_t)(input[108] & 0x07) << 29) |
			((uint32_t)input[109] << 21) |
			((uint32_t)(input[110] & 0xf8) << 13);
	output[54] = (double)(value >> 16);

	// read output[55]: from bit 885 to 900
	value = ((uint32_t)(input[110] & 0x07) << 29) |
			((uint32_t)input[111] << 21) |
			((uint32_t)(input[112] & 0xf8) << 13);
	output[55] = (double)(value >> 16);

	// read output[56]: from bit 901 to 916
	value = ((uint32_t)(input[112] & 0x07) << 29) |
			((uint32_t)input[113] << 21) |
			((uint32_t)(input[114] & 0xf8) << 13);
	output[56] = (double)(value >> 16);

	// read output[57]: from bit 917 to 932
	value = ((uint32_t)(input[114] & 0x07) << 29) |
			((uint32_t)input[115] << 21) |
			((uint32_t)(input[116] & 0xf8) << 13);
	output[57] = (double)(value >> 16);

	// read output[58]: from bit 933 to 948
	value = ((uint32_t)(input[116] & 0x07) << 29) |
			((uint32_t)input[117] << 21) |
			((uint32_t)(input[118] & 0xf8) << 13);
	output[58] = (double)(value >> 16);

	// read output[59]: from bit 949 to 964
	value = ((uint32_t)(input[118] & 0x07) << 29) |
			((uint32_t)input[119] << 21) |
			((uint32_t)(input[120] & 0xf8) << 13);
	output[59] = (double)(value >> 16);

	// read output[60]: from bit 965 to 980
	value = ((uint32_t)(input[120] & 0x07) << 29) |
			((uint32_t)input[121] << 21) |
			((uint32_t)(input[122] & 0xf8) << 13);
	output[60] = (double)(value >> 16);

	// read output[61]: from bit 981 to 996
	value = ((uint32_t)(input[122] & 0x07) << 29) |
			((uint32_t)input[123] << 21) |
			((uint32_t)(input[124] & 0xf8) << 13);
	output[61] = (double)(value >> 16);

	// read output[62]: from bit 997 to 1012
	value = ((uint32_t)(input[124] & 0x07) << 29) |
			((uint32_t)input[125] << 21) |
			((uint32_t)(input[126] & 0xf8) << 13);
	output[62] = (double)(value >> 16);
}

static void unpack_63_16bit_unsigned_5off(const uint8_t * input, double * output, void *closure) {
	// Unpack 63 values into output
	// Values are 16-bit unsigned
	// Skip 5 bits, read 1008 bits of data.
	// Input must be at least 127 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 5 to 20
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)(input[2] & 0xf8) << 13);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 21 to 36
	value = ((uint32_t)(input[2] & 0x07) << 29) |
			((uint32_t)input[3] << 21) |
			((uint32_t)(input[4] & 0xf8) << 13);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 37 to 52
	value = ((uint32_t)(input[4] & 0x07) << 29) |
			((uint32_t)input[5] << 21) |
			((uint32_t)(input[6] & 0xf8) << 13);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 53 to 68
	value = ((uint32_t)(input[6] & 0x07) << 29) |
			((uint32_t)input[7] << 21) |
			((uint32_t)(input[8] & 0xf8) << 13);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 69 to 84
	value = ((uint32_t)(input[8] & 0x07) << 29) |
			((uint32_t)input[9] << 21) |
			((uint32_t)(input[10] & 0xf8) << 13);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 85 to 100
	value = ((uint32_t)(input[10] & 0x07) << 29) |
			((uint32_t)input[11] << 21) |
			((uint32_t)(input[12] & 0xf8) << 13);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 101 to 116
	value = ((uint32_t)(input[12] & 0x07) << 29) |
			((uint32_t)input[13] << 21) |
			((uint32_t)(input[14] & 0xf8) << 13);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 117 to 132
	value = ((uint32_t)(input[14] & 0x07) << 29) |
			((uint32_t)input[15] << 21) |
			((uint32_t)(input[16] & 0xf8) << 13);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 133 to 148
	value = ((uint32_t)(input[16] & 0x07) << 29) |
			((uint32_t)input[17] << 21) |
			((uint32_t)(input[18] & 0xf8) << 13);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 149 to 164
	value = ((uint32_t)(input[18] & 0x07) << 29) |
			((uint32_t)input[19] << 21) |
			((uint32_t)(input[20] & 0xf8) << 13);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 165 to 180
	value = ((uint32_t)(input[20] & 0x07) << 29) |
			((uint32_t)input[21] << 21) |
			((uint32_t)(input[22] & 0xf8) << 13);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 181 to 196
	value = ((uint32_t)(input[22] & 0x07) << 29) |
			((uint32_t)input[23] << 21) |
			((uint32_t)(input[24] & 0xf8) << 13);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 197 to 212
	value = ((uint32_t)(input[24] & 0x07) << 29) |
			((uint32_t)input[25] << 21) |
			((uint32_t)(input[26] & 0xf8) << 13);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 213 to 228
	value = ((uint32_t)(input[26] & 0x07) << 29) |
			((uint32_t)input[27] << 21) |
			((uint32_t)(input[28] & 0xf8) << 13);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 229 to 244
	value = ((uint32_t)(input[28] & 0x07) << 29) |
			((uint32_t)input[29] << 21) |
			((uint32_t)(input[30] & 0xf8) << 13);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 245 to 260
	value = ((uint32_t)(input[30] & 0x07) << 29) |
			((uint32_t)input[31] << 21) |
			((uint32_t)(input[32] & 0xf8) << 13);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 261 to 276
	value = ((uint32_t)(input[32] & 0x07) << 29) |
			((uint32_t)input[33] << 21) |
			((uint32_t)(input[34] & 0xf8) << 13);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 277 to 292
	value = ((uint32_t)(input[34] & 0x07) << 29) |
			((uint32_t)input[35] << 21) |
			((uint32_t)(input[36] & 0xf8) << 13);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 293 to 308
	value = ((uint32_t)(input[36] & 0x07) << 29) |
			((uint32_t)input[37] << 21) |
			((uint32_t)(input[38] & 0xf8) << 13);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 309 to 324
	value = ((uint32_t)(input[38] & 0x07) << 29) |
			((uint32_t)input[39] << 21) |
			((uint32_t)(input[40] & 0xf8) << 13);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 325 to 340
	value = ((uint32_t)(input[40] & 0x07) << 29) |
			((uint32_t)input[41] << 21) |
			((uint32_t)(input[42] & 0xf8) << 13);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 341 to 356
	value = ((uint32_t)(input[42] & 0x07) << 29) |
			((uint32_t)input[43] << 21) |
			((uint32_t)(input[44] & 0xf8) << 13);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 357 to 372
	value = ((uint32_t)(input[44] & 0x07) << 29) |
			((uint32_t)input[45] << 21) |
			((uint32_t)(input[46] & 0xf8) << 13);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 373 to 388
	value = ((uint32_t)(input[46] & 0x07) << 29) |
			((uint32_t)input[47] << 21) |
			((uint32_t)(input[48] & 0xf8) << 13);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 389 to 404
	value = ((uint32_t)(input[48] & 0x07) << 29) |
			((uint32_t)input[49] << 21) |
			((uint32_t)(input[50] & 0xf8) << 13);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 405 to 420
	value = ((uint32_t)(input[50] & 0x07) << 29) |
			((uint32_t)input[51] << 21) |
			((uint32_t)(input[52] & 0xf8) << 13);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 421 to 436
	value = ((uint32_t)(input[52] & 0x07) << 29) |
			((uint32_t)input[53] << 21) |
			((uint32_t)(input[54] & 0xf8) << 13);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 437 to 452
	value = ((uint32_t)(input[54] & 0x07) << 29) |
			((uint32_t)input[55] << 21) |
			((uint32_t)(input[56] & 0xf8) << 13);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 453 to 468
	value = ((uint32_t)(input[56] & 0x07) << 29) |
			((uint32_t)input[57] << 21) |
			((uint32_t)(input[58] & 0xf8) << 13);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 469 to 484
	value = ((uint32_t)(input[58] & 0x07) << 29) |
			((uint32_t)input[59] << 21) |
			((uint32_t)(input[60] & 0xf8) << 13);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 485 to 500
	value = ((uint32_t)(input[60] & 0x07) << 29) |
			((uint32_t)input[61] << 21) |
			((uint32_t)(input[62] & 0xf8) << 13);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 501 to 516
	value = ((uint32_t)(input[62] & 0x07) << 29) |
			((uint32_t)input[63] << 21) |
			((uint32_t)(input[64] & 0xf8) << 13);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 517 to 532
	value = ((uint32_t)(input[64] & 0x07) << 29) |
			((uint32_t)input[65] << 21) |
			((uint32_t)(input[66] & 0xf8) << 13);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 533 to 548
	value = ((uint32_t)(input[66] & 0x07) << 29) |
			((uint32_t)input[67] << 21) |
			((uint32_t)(input[68] & 0xf8) << 13);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 549 to 564
	value = ((uint32_t)(input[68] & 0x07) << 29) |
			((uint32_t)input[69] << 21) |
			((uint32_t)(input[70] & 0xf8) << 13);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 565 to 580
	value = ((uint32_t)(input[70] & 0x07) << 29) |
			((uint32_t)input[71] << 21) |
			((uint32_t)(input[72] & 0xf8) << 13);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 581 to 596
	value = ((uint32_t)(input[72] & 0x07) << 29) |
			((uint32_t)input[73] << 21) |
			((uint32_t)(input[74] & 0xf8) << 13);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 597 to 612
	value = ((uint32_t)(input[74] & 0x07) << 29) |
			((uint32_t)input[75] << 21) |
			((uint32_t)(input[76] & 0xf8) << 13);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 613 to 628
	value = ((uint32_t)(input[76] & 0x07) << 29) |
			((uint32_t)input[77] << 21) |
			((uint32_t)(input[78] & 0xf8) << 13);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 629 to 644
	value = ((uint32_t)(input[78] & 0x07) << 29) |
			((uint32_t)input[79] << 21) |
			((uint32_t)(input[80] & 0xf8) << 13);
	output[39] = (double)(value >> 16);

	// read output[40]: from bit 645 to 660
	value = ((uint32_t)(input[80] & 0x07) << 29) |
			((uint32_t)input[81] << 21) |
			((uint32_t)(input[82] & 0xf8) << 13);
	output[40] = (double)(value >> 16);

	// read output[41]: from bit 661 to 676
	value = ((uint32_t)(input[82] & 0x07) << 29) |
			((uint32_t)input[83] << 21) |
			((uint32_t)(input[84] & 0xf8) << 13);
	output[41] = (double)(value >> 16);

	// read output[42]: from bit 677 to 692
	value = ((uint32_t)(input[84] & 0x07) << 29) |
			((uint32_t)input[85] << 21) |
			((uint32_t)(input[86] & 0xf8) << 13);
	output[42] = (double)(value >> 16);

	// read output[43]: from bit 693 to 708
	value = ((uint32_t)(input[86] & 0x07) << 29) |
			((uint32_t)input[87] << 21) |
			((uint32_t)(input[88] & 0xf8) << 13);
	output[43] = (double)(value >> 16);

	// read output[44]: from bit 709 to 724
	value = ((uint32_t)(input[88] & 0x07) << 29) |
			((uint32_t)input[89] << 21) |
			((uint32_t)(input[90] & 0xf8) << 13);
	output[44] = (double)(value >> 16);

	// read output[45]: from bit 725 to 740
	value = ((uint32_t)(input[90] & 0x07) << 29) |
			((uint32_t)input[91] << 21) |
			((uint32_t)(input[92] & 0xf8) << 13);
	output[45] = (double)(value >> 16);

	// read output[46]: from bit 741 to 756
	value = ((uint32_t)(input[92] & 0x07) << 29) |
			((uint32_t)input[93] << 21) |
			((uint32_t)(input[94] & 0xf8) << 13);
	output[46] = (double)(value >> 16);

	// read output[47]: from bit 757 to 772
	value = ((uint32_t)(input[94] & 0x07) << 29) |
			((uint32_t)input[95] << 21) |
			((uint32_t)(input[96] & 0xf8) << 13);
	output[47] = (double)(value >> 16);

	// read output[48]: from bit 773 to 788
	value = ((uint32_t)(input[96] & 0x07) << 29) |
			((uint32_t)input[97] << 21) |
			((uint32_t)(input[98] & 0xf8) << 13);
	output[48] = (double)(value >> 16);

	// read output[49]: from bit 789 to 804
	value = ((uint32_t)(input[98] & 0x07) << 29) |
			((uint32_t)input[99] << 21) |
			((uint32_t)(input[100] & 0xf8) << 13);
	output[49] = (double)(value >> 16);

	// read output[50]: from bit 805 to 820
	value = ((uint32_t)(input[100] & 0x07) << 29) |
			((uint32_t)input[101] << 21) |
			((uint32_t)(input[102] & 0xf8) << 13);
	output[50] = (double)(value >> 16);

	// read output[51]: from bit 821 to 836
	value = ((uint32_t)(input[102] & 0x07) << 29) |
			((uint32_t)input[103] << 21) |
			((uint32_t)(input[104] & 0xf8) << 13);
	output[51] = (double)(value >> 16);

	// read output[52]: from bit 837 to 852
	value = ((uint32_t)(input[104] & 0x07) << 29) |
			((uint32_t)input[105] << 21) |
			((uint32_t)(input[106] & 0xf8) << 13);
	output[52] = (double)(value >> 16);

	// read output[53]: from bit 853 to 868
	value = ((uint32_t)(input[106] & 0x07) << 29) |
			((uint32_t)input[107] << 21) |
			((uint32_t)(input[108] & 0xf8) << 13);
	output[53] = (double)(value >> 16);

	// read output[54]: from bit 869 to 884
	value = ((uint32_t)(input[108] & 0x07) << 29) |
			((uint32_t)input[109] << 21) |
			((uint32_t)(input[110] & 0xf8) << 13);
	output[54] = (double)(value >> 16);

	// read output[55]: from bit 885 to 900
	value = ((uint32_t)(input[110] & 0x07) << 29) |
			((uint32_t)input[111] << 21) |
			((uint32_t)(input[112] & 0xf8) << 13);
	output[55] = (double)(value >> 16);

	// read output[56]: from bit 901 to 916
	value = ((uint32_t)(input[112] & 0x07) << 29) |
			((uint32_t)input[113] << 21) |
			((uint32_t)(input[114] & 0xf8) << 13);
	output[56] = (double)(value >> 16);

	// read output[57]: from bit 917 to 932
	value = ((uint32_t)(input[114] & 0x07) << 29) |
			((uint32_t)input[115] << 21) |
			((uint32_t)(input[116] & 0xf8) << 13);
	output[57] = (double)(value >> 16);

	// read output[58]: from bit 933 to 948
	value = ((uint32_t)(input[116] & 0x07) << 29) |
			((uint32_t)input[117] << 21) |
			((uint32_t)(input[118] & 0xf8) << 13);
	output[58] = (double)(value >> 16);

	// read output[59]: from bit 949 to 964
	value = ((uint32_t)(input[118] & 0x07) << 29) |
			((uint32_t)input[119] << 21) |
			((uint32_t)(input[120] & 0xf8) << 13);
	output[59] = (double)(value >> 16);

	// read output[60]: from bit 965 to 980
	value = ((uint32_t)(input[120] & 0x07) << 29) |
			((uint32_t)input[121] << 21) |
			((uint32_t)(input[122] & 0xf8) << 13);
	output[60] = (double)(value >> 16);

	// read output[61]: from bit 981 to 996
	value = ((uint32_t)(input[122] & 0x07) << 29) |
			((uint32_t)input[123] << 21) |
			((uint32_t)(input[124] & 0xf8) << 13);
	output[61] = (double)(value >> 16);

	// read output[62]: from bit 997 to 1012
	value = ((uint32_t)(input[124] & 0x07) << 29) |
			((uint32_t)input[125] << 21) |
			((uint32_t)(input[126] & 0xf8) << 13);
	output[62] = (double)(value >> 16);
}

static void unpack_63_16bit_signed_6off(const uint8_t * input, double * output, void *closure) {
	// Unpack 63 values into output
	// Values are 16-bit signed
	// Skip 6 bits, read 1008 bits of data.
	// Input must be at least 127 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 6 to 21
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)(input[2] & 0xfc) << 14);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 22 to 37
	value = ((uint32_t)(input[2] & 0x03) << 30) |
			((uint32_t)input[3] << 22) |
			((uint32_t)(input[4] & 0xfc) << 14);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 38 to 53
	value = ((uint32_t)(input[4] & 0x03) << 30) |
			((uint32_t)input[5] << 22) |
			((uint32_t)(input[6] & 0xfc) << 14);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 54 to 69
	value = ((uint32_t)(input[6] & 0x03) << 30) |
			((uint32_t)input[7] << 22) |
			((uint32_t)(input[8] & 0xfc) << 14);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 70 to 85
	value = ((uint32_t)(input[8] & 0x03) << 30) |
			((uint32_t)input[9] << 22) |
			((uint32_t)(input[10] & 0xfc) << 14);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 86 to 101
	value = ((uint32_t)(input[10] & 0x03) << 30) |
			((uint32_t)input[11] << 22) |
			((uint32_t)(input[12] & 0xfc) << 14);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 102 to 117
	value = ((uint32_t)(input[12] & 0x03) << 30) |
			((uint32_t)input[13] << 22) |
			((uint32_t)(input[14] & 0xfc) << 14);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 118 to 133
	value = ((uint32_t)(input[14] & 0x03) << 30) |
			((uint32_t)input[15] << 22) |
			((uint32_t)(input[16] & 0xfc) << 14);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 134 to 149
	value = ((uint32_t)(input[16] & 0x03) << 30) |
			((uint32_t)input[17] << 22) |
			((uint32_t)(input[18] & 0xfc) << 14);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 150 to 165
	value = ((uint32_t)(input[18] & 0x03) << 30) |
			((uint32_t)input[19] << 22) |
			((uint32_t)(input[20] & 0xfc) << 14);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 166 to 181
	value = ((uint32_t)(input[20] & 0x03) << 30) |
			((uint32_t)input[21] << 22) |
			((uint32_t)(input[22] & 0xfc) << 14);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 182 to 197
	value = ((uint32_t)(input[22] & 0x03) << 30) |
			((uint32_t)input[23] << 22) |
			((uint32_t)(input[24] & 0xfc) << 14);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 198 to 213
	value = ((uint32_t)(input[24] & 0x03) << 30) |
			((uint32_t)input[25] << 22) |
			((uint32_t)(input[26] & 0xfc) << 14);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 214 to 229
	value = ((uint32_t)(input[26] & 0x03) << 30) |
			((uint32_t)input[27] << 22) |
			((uint32_t)(input[28] & 0xfc) << 14);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 230 to 245
	value = ((uint32_t)(input[28] & 0x03) << 30) |
			((uint32_t)input[29] << 22) |
			((uint32_t)(input[30] & 0xfc) << 14);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 246 to 261
	value = ((uint32_t)(input[30] & 0x03) << 30) |
			((uint32_t)input[31] << 22) |
			((uint32_t)(input[32] & 0xfc) << 14);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 262 to 277
	value = ((uint32_t)(input[32] & 0x03) << 30) |
			((uint32_t)input[33] << 22) |
			((uint32_t)(input[34] & 0xfc) << 14);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 278 to 293
	value = ((uint32_t)(input[34] & 0x03) << 30) |
			((uint32_t)input[35] << 22) |
			((uint32_t)(input[36] & 0xfc) << 14);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 294 to 309
	value = ((uint32_t)(input[36] & 0x03) << 30) |
			((uint32_t)input[37] << 22) |
			((uint32_t)(input[38] & 0xfc) << 14);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 310 to 325
	value = ((uint32_t)(input[38] & 0x03) << 30) |
			((uint32_t)input[39] << 22) |
			((uint32_t)(input[40] & 0xfc) << 14);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 326 to 341
	value = ((uint32_t)(input[40] & 0x03) << 30) |
			((uint32_t)input[41] << 22) |
			((uint32_t)(input[42] & 0xfc) << 14);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 342 to 357
	value = ((uint32_t)(input[42] & 0x03) << 30) |
			((uint32_t)input[43] << 22) |
			((uint32_t)(input[44] & 0xfc) << 14);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 358 to 373
	value = ((uint32_t)(input[44] & 0x03) << 30) |
			((uint32_t)input[45] << 22) |
			((uint32_t)(input[46] & 0xfc) << 14);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 374 to 389
	value = ((uint32_t)(input[46] & 0x03) << 30) |
			((uint32_t)input[47] << 22) |
			((uint32_t)(input[48] & 0xfc) << 14);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 390 to 405
	value = ((uint32_t)(input[48] & 0x03) << 30) |
			((uint32_t)input[49] << 22) |
			((uint32_t)(input[50] & 0xfc) << 14);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 406 to 421
	value = ((uint32_t)(input[50] & 0x03) << 30) |
			((uint32_t)input[51] << 22) |
			((uint32_t)(input[52] & 0xfc) << 14);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 422 to 437
	value = ((uint32_t)(input[52] & 0x03) << 30) |
			((uint32_t)input[53] << 22) |
			((uint32_t)(input[54] & 0xfc) << 14);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 438 to 453
	value = ((uint32_t)(input[54] & 0x03) << 30) |
			((uint32_t)input[55] << 22) |
			((uint32_t)(input[56] & 0xfc) << 14);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 454 to 469
	value = ((uint32_t)(input[56] & 0x03) << 30) |
			((uint32_t)input[57] << 22) |
			((uint32_t)(input[58] & 0xfc) << 14);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 470 to 485
	value = ((uint32_t)(input[58] & 0x03) << 30) |
			((uint32_t)input[59] << 22) |
			((uint32_t)(input[60] & 0xfc) << 14);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 486 to 501
	value = ((uint32_t)(input[60] & 0x03) << 30) |
			((uint32_t)input[61] << 22) |
			((uint32_t)(input[62] & 0xfc) << 14);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 502 to 517
	value = ((uint32_t)(input[62] & 0x03) << 30) |
			((uint32_t)input[63] << 22) |
			((uint32_t)(input[64] & 0xfc) << 14);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 518 to 533
	value = ((uint32_t)(input[64] & 0x03) << 30) |
			((uint32_t)input[65] << 22) |
			((uint32_t)(input[66] & 0xfc) << 14);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 534 to 549
	value = ((uint32_t)(input[66] & 0x03) << 30) |
			((uint32_t)input[67] << 22) |
			((uint32_t)(input[68] & 0xfc) << 14);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 550 to 565
	value = ((uint32_t)(input[68] & 0x03) << 30) |
			((uint32_t)input[69] << 22) |
			((uint32_t)(input[70] & 0xfc) << 14);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 566 to 581
	value = ((uint32_t)(input[70] & 0x03) << 30) |
			((uint32_t)input[71] << 22) |
			((uint32_t)(input[72] & 0xfc) << 14);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 582 to 597
	value = ((uint32_t)(input[72] & 0x03) << 30) |
			((uint32_t)input[73] << 22) |
			((uint32_t)(input[74] & 0xfc) << 14);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 598 to 613
	value = ((uint32_t)(input[74] & 0x03) << 30) |
			((uint32_t)input[75] << 22) |
			((uint32_t)(input[76] & 0xfc) << 14);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 614 to 629
	value = ((uint32_t)(input[76] & 0x03) << 30) |
			((uint32_t)input[77] << 22) |
			((uint32_t)(input[78] & 0xfc) << 14);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 630 to 645
	value = ((uint32_t)(input[78] & 0x03) << 30) |
			((uint32_t)input[79] << 22) |
			((uint32_t)(input[80] & 0xfc) << 14);
	output[39] = (double)(value >> 16);

	// read output[40]: from bit 646 to 661
	value = ((uint32_t)(input[80] & 0x03) << 30) |
			((uint32_t)input[81] << 22) |
			((uint32_t)(input[82] & 0xfc) << 14);
	output[40] = (double)(value >> 16);

	// read output[41]: from bit 662 to 677
	value = ((uint32_t)(input[82] & 0x03) << 30) |
			((uint32_t)input[83] << 22) |
			((uint32_t)(input[84] & 0xfc) << 14);
	output[41] = (double)(value >> 16);

	// read output[42]: from bit 678 to 693
	value = ((uint32_t)(input[84] & 0x03) << 30) |
			((uint32_t)input[85] << 22) |
			((uint32_t)(input[86] & 0xfc) << 14);
	output[42] = (double)(value >> 16);

	// read output[43]: from bit 694 to 709
	value = ((uint32_t)(input[86] & 0x03) << 30) |
			((uint32_t)input[87] << 22) |
			((uint32_t)(input[88] & 0xfc) << 14);
	output[43] = (double)(value >> 16);

	// read output[44]: from bit 710 to 725
	value = ((uint32_t)(input[88] & 0x03) << 30) |
			((uint32_t)input[89] << 22) |
			((uint32_t)(input[90] & 0xfc) << 14);
	output[44] = (double)(value >> 16);

	// read output[45]: from bit 726 to 741
	value = ((uint32_t)(input[90] & 0x03) << 30) |
			((uint32_t)input[91] << 22) |
			((uint32_t)(input[92] & 0xfc) << 14);
	output[45] = (double)(value >> 16);

	// read output[46]: from bit 742 to 757
	value = ((uint32_t)(input[92] & 0x03) << 30) |
			((uint32_t)input[93] << 22) |
			((uint32_t)(input[94] & 0xfc) << 14);
	output[46] = (double)(value >> 16);

	// read output[47]: from bit 758 to 773
	value = ((uint32_t)(input[94] & 0x03) << 30) |
			((uint32_t)input[95] << 22) |
			((uint32_t)(input[96] & 0xfc) << 14);
	output[47] = (double)(value >> 16);

	// read output[48]: from bit 774 to 789
	value = ((uint32_t)(input[96] & 0x03) << 30) |
			((uint32_t)input[97] << 22) |
			((uint32_t)(input[98] & 0xfc) << 14);
	output[48] = (double)(value >> 16);

	// read output[49]: from bit 790 to 805
	value = ((uint32_t)(input[98] & 0x03) << 30) |
			((uint32_t)input[99] << 22) |
			((uint32_t)(input[100] & 0xfc) << 14);
	output[49] = (double)(value >> 16);

	// read output[50]: from bit 806 to 821
	value = ((uint32_t)(input[100] & 0x03) << 30) |
			((uint32_t)input[101] << 22) |
			((uint32_t)(input[102] & 0xfc) << 14);
	output[50] = (double)(value >> 16);

	// read output[51]: from bit 822 to 837
	value = ((uint32_t)(input[102] & 0x03) << 30) |
			((uint32_t)input[103] << 22) |
			((uint32_t)(input[104] & 0xfc) << 14);
	output[51] = (double)(value >> 16);

	// read output[52]: from bit 838 to 853
	value = ((uint32_t)(input[104] & 0x03) << 30) |
			((uint32_t)input[105] << 22) |
			((uint32_t)(input[106] & 0xfc) << 14);
	output[52] = (double)(value >> 16);

	// read output[53]: from bit 854 to 869
	value = ((uint32_t)(input[106] & 0x03) << 30) |
			((uint32_t)input[107] << 22) |
			((uint32_t)(input[108] & 0xfc) << 14);
	output[53] = (double)(value >> 16);

	// read output[54]: from bit 870 to 885
	value = ((uint32_t)(input[108] & 0x03) << 30) |
			((uint32_t)input[109] << 22) |
			((uint32_t)(input[110] & 0xfc) << 14);
	output[54] = (double)(value >> 16);

	// read output[55]: from bit 886 to 901
	value = ((uint32_t)(input[110] & 0x03) << 30) |
			((uint32_t)input[111] << 22) |
			((uint32_t)(input[112] & 0xfc) << 14);
	output[55] = (double)(value >> 16);

	// read output[56]: from bit 902 to 917
	value = ((uint32_t)(input[112] & 0x03) << 30) |
			((uint32_t)input[113] << 22) |
			((uint32_t)(input[114] & 0xfc) << 14);
	output[56] = (double)(value >> 16);

	// read output[57]: from bit 918 to 933
	value = ((uint32_t)(input[114] & 0x03) << 30) |
			((uint32_t)input[115] << 22) |
			((uint32_t)(input[116] & 0xfc) << 14);
	output[57] = (double)(value >> 16);

	// read output[58]: from bit 934 to 949
	value = ((uint32_t)(input[116] & 0x03) << 30) |
			((uint32_t)input[117] << 22) |
			((uint32_t)(input[118] & 0xfc) << 14);
	output[58] = (double)(value >> 16);

	// read output[59]: from bit 950 to 965
	value = ((uint32_t)(input[118] & 0x03) << 30) |
			((uint32_t)input[119] << 22) |
			((uint32_t)(input[120] & 0xfc) << 14);
	output[59] = (double)(value >> 16);

	// read output[60]: from bit 966 to 981
	value = ((uint32_t)(input[120] & 0x03) << 30) |
			((uint32_t)input[121] << 22) |
			((uint32_t)(input[122] & 0xfc) << 14);
	output[60] = (double)(value >> 16);

	// read output[61]: from bit 982 to 997
	value = ((uint32_t)(input[122] & 0x03) << 30) |
			((uint32_t)input[123] << 22) |
			((uint32_t)(input[124] & 0xfc) << 14);
	output[61] = (double)(value >> 16);

	// read output[62]: from bit 998 to 1013
	value = ((uint32_t)(input[124] & 0x03) << 30) |
			((uint32_t)input[125] << 22) |
			((uint32_t)(input[126] & 0xfc) << 14);
	output[62] = (double)(value >> 16);
}

static void unpack_63_16bit_unsigned_6off(const uint8_t * input, double * output, void *closure) {
	// Unpack 63 values into output
	// Values are 16-bit unsigned
	// Skip 6 bits, read 1008 bits of data.
	// Input must be at least 127 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 6 to 21
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)(input[2] & 0xfc) << 14);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 22 to 37
	value = ((uint32_t)(input[2] & 0x03) << 30) |
			((uint32_t)input[3] << 22) |
			((uint32_t)(input[4] & 0xfc) << 14);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 38 to 53
	value = ((uint32_t)(input[4] & 0x03) << 30) |
			((uint32_t)input[5] << 22) |
			((uint32_t)(input[6] & 0xfc) << 14);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 54 to 69
	value = ((uint32_t)(input[6] & 0x03) << 30) |
			((uint32_t)input[7] << 22) |
			((uint32_t)(input[8] & 0xfc) << 14);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 70 to 85
	value = ((uint32_t)(input[8] & 0x03) << 30) |
			((uint32_t)input[9] << 22) |
			((uint32_t)(input[10] & 0xfc) << 14);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 86 to 101
	value = ((uint32_t)(input[10] & 0x03) << 30) |
			((uint32_t)input[11] << 22) |
			((uint32_t)(input[12] & 0xfc) << 14);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 102 to 117
	value = ((uint32_t)(input[12] & 0x03) << 30) |
			((uint32_t)input[13] << 22) |
			((uint32_t)(input[14] & 0xfc) << 14);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 118 to 133
	value = ((uint32_t)(input[14] & 0x03) << 30) |
			((uint32_t)input[15] << 22) |
			((uint32_t)(input[16] & 0xfc) << 14);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 134 to 149
	value = ((uint32_t)(input[16] & 0x03) << 30) |
			((uint32_t)input[17] << 22) |
			((uint32_t)(input[18] & 0xfc) << 14);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 150 to 165
	value = ((uint32_t)(input[18] & 0x03) << 30) |
			((uint32_t)input[19] << 22) |
			((uint32_t)(input[20] & 0xfc) << 14);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 166 to 181
	value = ((uint32_t)(input[20] & 0x03) << 30) |
			((uint32_t)input[21] << 22) |
			((uint32_t)(input[22] & 0xfc) << 14);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 182 to 197
	value = ((uint32_t)(input[22] & 0x03) << 30) |
			((uint32_t)input[23] << 22) |
			((uint32_t)(input[24] & 0xfc) << 14);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 198 to 213
	value = ((uint32_t)(input[24] & 0x03) << 30) |
			((uint32_t)input[25] << 22) |
			((uint32_t)(input[26] & 0xfc) << 14);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 214 to 229
	value = ((uint32_t)(input[26] & 0x03) << 30) |
			((uint32_t)input[27] << 22) |
			((uint32_t)(input[28] & 0xfc) << 14);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 230 to 245
	value = ((uint32_t)(input[28] & 0x03) << 30) |
			((uint32_t)input[29] << 22) |
			((uint32_t)(input[30] & 0xfc) << 14);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 246 to 261
	value = ((uint32_t)(input[30] & 0x03) << 30) |
			((uint32_t)input[31] << 22) |
			((uint32_t)(input[32] & 0xfc) << 14);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 262 to 277
	value = ((uint32_t)(input[32] & 0x03) << 30) |
			((uint32_t)input[33] << 22) |
			((uint32_t)(input[34] & 0xfc) << 14);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 278 to 293
	value = ((uint32_t)(input[34] & 0x03) << 30) |
			((uint32_t)input[35] << 22) |
			((uint32_t)(input[36] & 0xfc) << 14);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 294 to 309
	value = ((uint32_t)(input[36] & 0x03) << 30) |
			((uint32_t)input[37] << 22) |
			((uint32_t)(input[38] & 0xfc) << 14);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 310 to 325
	value = ((uint32_t)(input[38] & 0x03) << 30) |
			((uint32_t)input[39] << 22) |
			((uint32_t)(input[40] & 0xfc) << 14);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 326 to 341
	value = ((uint32_t)(input[40] & 0x03) << 30) |
			((uint32_t)input[41] << 22) |
			((uint32_t)(input[42] & 0xfc) << 14);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 342 to 357
	value = ((uint32_t)(input[42] & 0x03) << 30) |
			((uint32_t)input[43] << 22) |
			((uint32_t)(input[44] & 0xfc) << 14);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 358 to 373
	value = ((uint32_t)(input[44] & 0x03) << 30) |
			((uint32_t)input[45] << 22) |
			((uint32_t)(input[46] & 0xfc) << 14);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 374 to 389
	value = ((uint32_t)(input[46] & 0x03) << 30) |
			((uint32_t)input[47] << 22) |
			((uint32_t)(input[48] & 0xfc) << 14);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 390 to 405
	value = ((uint32_t)(input[48] & 0x03) << 30) |
			((uint32_t)input[49] << 22) |
			((uint32_t)(input[50] & 0xfc) << 14);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 406 to 421
	value = ((uint32_t)(input[50] & 0x03) << 30) |
			((uint32_t)input[51] << 22) |
			((uint32_t)(input[52] & 0xfc) << 14);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 422 to 437
	value = ((uint32_t)(input[52] & 0x03) << 30) |
			((uint32_t)input[53] << 22) |
			((uint32_t)(input[54] & 0xfc) << 14);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 438 to 453
	value = ((uint32_t)(input[54] & 0x03) << 30) |
			((uint32_t)input[55] << 22) |
			((uint32_t)(input[56] & 0xfc) << 14);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 454 to 469
	value = ((uint32_t)(input[56] & 0x03) << 30) |
			((uint32_t)input[57] << 22) |
			((uint32_t)(input[58] & 0xfc) << 14);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 470 to 485
	value = ((uint32_t)(input[58] & 0x03) << 30) |
			((uint32_t)input[59] << 22) |
			((uint32_t)(input[60] & 0xfc) << 14);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 486 to 501
	value = ((uint32_t)(input[60] & 0x03) << 30) |
			((uint32_t)input[61] << 22) |
			((uint32_t)(input[62] & 0xfc) << 14);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 502 to 517
	value = ((uint32_t)(input[62] & 0x03) << 30) |
			((uint32_t)input[63] << 22) |
			((uint32_t)(input[64] & 0xfc) << 14);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 518 to 533
	value = ((uint32_t)(input[64] & 0x03) << 30) |
			((uint32_t)input[65] << 22) |
			((uint32_t)(input[66] & 0xfc) << 14);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 534 to 549
	value = ((uint32_t)(input[66] & 0x03) << 30) |
			((uint32_t)input[67] << 22) |
			((uint32_t)(input[68] & 0xfc) << 14);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 550 to 565
	value = ((uint32_t)(input[68] & 0x03) << 30) |
			((uint32_t)input[69] << 22) |
			((uint32_t)(input[70] & 0xfc) << 14);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 566 to 581
	value = ((uint32_t)(input[70] & 0x03) << 30) |
			((uint32_t)input[71] << 22) |
			((uint32_t)(input[72] & 0xfc) << 14);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 582 to 597
	value = ((uint32_t)(input[72] & 0x03) << 30) |
			((uint32_t)input[73] << 22) |
			((uint32_t)(input[74] & 0xfc) << 14);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 598 to 613
	value = ((uint32_t)(input[74] & 0x03) << 30) |
			((uint32_t)input[75] << 22) |
			((uint32_t)(input[76] & 0xfc) << 14);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 614 to 629
	value = ((uint32_t)(input[76] & 0x03) << 30) |
			((uint32_t)input[77] << 22) |
			((uint32_t)(input[78] & 0xfc) << 14);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 630 to 645
	value = ((uint32_t)(input[78] & 0x03) << 30) |
			((uint32_t)input[79] << 22) |
			((uint32_t)(input[80] & 0xfc) << 14);
	output[39] = (double)(value >> 16);

	// read output[40]: from bit 646 to 661
	value = ((uint32_t)(input[80] & 0x03) << 30) |
			((uint32_t)input[81] << 22) |
			((uint32_t)(input[82] & 0xfc) << 14);
	output[40] = (double)(value >> 16);

	// read output[41]: from bit 662 to 677
	value = ((uint32_t)(input[82] & 0x03) << 30) |
			((uint32_t)input[83] << 22) |
			((uint32_t)(input[84] & 0xfc) << 14);
	output[41] = (double)(value >> 16);

	// read output[42]: from bit 678 to 693
	value = ((uint32_t)(input[84] & 0x03) << 30) |
			((uint32_t)input[85] << 22) |
			((uint32_t)(input[86] & 0xfc) << 14);
	output[42] = (double)(value >> 16);

	// read output[43]: from bit 694 to 709
	value = ((uint32_t)(input[86] & 0x03) << 30) |
			((uint32_t)input[87] << 22) |
			((uint32_t)(input[88] & 0xfc) << 14);
	output[43] = (double)(value >> 16);

	// read output[44]: from bit 710 to 725
	value = ((uint32_t)(input[88] & 0x03) << 30) |
			((uint32_t)input[89] << 22) |
			((uint32_t)(input[90] & 0xfc) << 14);
	output[44] = (double)(value >> 16);

	// read output[45]: from bit 726 to 741
	value = ((uint32_t)(input[90] & 0x03) << 30) |
			((uint32_t)input[91] << 22) |
			((uint32_t)(input[92] & 0xfc) << 14);
	output[45] = (double)(value >> 16);

	// read output[46]: from bit 742 to 757
	value = ((uint32_t)(input[92] & 0x03) << 30) |
			((uint32_t)input[93] << 22) |
			((uint32_t)(input[94] & 0xfc) << 14);
	output[46] = (double)(value >> 16);

	// read output[47]: from bit 758 to 773
	value = ((uint32_t)(input[94] & 0x03) << 30) |
			((uint32_t)input[95] << 22) |
			((uint32_t)(input[96] & 0xfc) << 14);
	output[47] = (double)(value >> 16);

	// read output[48]: from bit 774 to 789
	value = ((uint32_t)(input[96] & 0x03) << 30) |
			((uint32_t)input[97] << 22) |
			((uint32_t)(input[98] & 0xfc) << 14);
	output[48] = (double)(value >> 16);

	// read output[49]: from bit 790 to 805
	value = ((uint32_t)(input[98] & 0x03) << 30) |
			((uint32_t)input[99] << 22) |
			((uint32_t)(input[100] & 0xfc) << 14);
	output[49] = (double)(value >> 16);

	// read output[50]: from bit 806 to 821
	value = ((uint32_t)(input[100] & 0x03) << 30) |
			((uint32_t)input[101] << 22) |
			((uint32_t)(input[102] & 0xfc) << 14);
	output[50] = (double)(value >> 16);

	// read output[51]: from bit 822 to 837
	value = ((uint32_t)(input[102] & 0x03) << 30) |
			((uint32_t)input[103] << 22) |
			((uint32_t)(input[104] & 0xfc) << 14);
	output[51] = (double)(value >> 16);

	// read output[52]: from bit 838 to 853
	value = ((uint32_t)(input[104] & 0x03) << 30) |
			((uint32_t)input[105] << 22) |
			((uint32_t)(input[106] & 0xfc) << 14);
	output[52] = (double)(value >> 16);

	// read output[53]: from bit 854 to 869
	value = ((uint32_t)(input[106] & 0x03) << 30) |
			((uint32_t)input[107] << 22) |
			((uint32_t)(input[108] & 0xfc) << 14);
	output[53] = (double)(value >> 16);

	// read output[54]: from bit 870 to 885
	value = ((uint32_t)(input[108] & 0x03) << 30) |
			((uint32_t)input[109] << 22) |
			((uint32_t)(input[110] & 0xfc) << 14);
	output[54] = (double)(value >> 16);

	// read output[55]: from bit 886 to 901
	value = ((uint32_t)(input[110] & 0x03) << 30) |
			((uint32_t)input[111] << 22) |
			((uint32_t)(input[112] & 0xfc) << 14);
	output[55] = (double)(value >> 16);

	// read output[56]: from bit 902 to 917
	value = ((uint32_t)(input[112] & 0x03) << 30) |
			((uint32_t)input[113] << 22) |
			((uint32_t)(input[114] & 0xfc) << 14);
	output[56] = (double)(value >> 16);

	// read output[57]: from bit 918 to 933
	value = ((uint32_t)(input[114] & 0x03) << 30) |
			((uint32_t)input[115] << 22) |
			((uint32_t)(input[116] & 0xfc) << 14);
	output[57] = (double)(value >> 16);

	// read output[58]: from bit 934 to 949
	value = ((uint32_t)(input[116] & 0x03) << 30) |
			((uint32_t)input[117] << 22) |
			((uint32_t)(input[118] & 0xfc) << 14);
	output[58] = (double)(value >> 16);

	// read output[59]: from bit 950 to 965
	value = ((uint32_t)(input[118] & 0x03) << 30) |
			((uint32_t)input[119] << 22) |
			((uint32_t)(input[120] & 0xfc) << 14);
	output[59] = (double)(value >> 16);

	// read output[60]: from bit 966 to 981
	value = ((uint32_t)(input[120] & 0x03) << 30) |
			((uint32_t)input[121] << 22) |
			((uint32_t)(input[122] & 0xfc) << 14);
	output[60] = (double)(value >> 16);

	// read output[61]: from bit 982 to 997
	value = ((uint32_t)(input[122] & 0x03) << 30) |
			((uint32_t)input[123] << 22) |
			((uint32_t)(input[124] & 0xfc) << 14);
	output[61] = (double)(value >> 16);

	// read output[62]: from bit 998 to 1013
	value = ((uint32_t)(input[124] & 0x03) << 30) |
			((uint32_t)input[125] << 22) |
			((uint32_t)(input[126] & 0xfc) << 14);
	output[62] = (double)(value >> 16);
}

static void unpack_63_16bit_signed_7off(const uint8_t * input, double * output, void *closure) {
	// Unpack 63 values into output
	// Values are 16-bit signed
	// Skip 7 bits, read 1008 bits of data.
	// Input must be at least 127 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 7 to 22
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)(input[2] & 0xfe) << 15);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 23 to 38
	value = ((uint32_t)(input[2] & 0x01) << 31) |
			((uint32_t)input[3] << 23) |
			((uint32_t)(input[4] & 0xfe) << 15);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 39 to 54
	value = ((uint32_t)(input[4] & 0x01) << 31) |
			((uint32_t)input[5] << 23) |
			((uint32_t)(input[6] & 0xfe) << 15);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 55 to 70
	value = ((uint32_t)(input[6] & 0x01) << 31) |
			((uint32_t)input[7] << 23) |
			((uint32_t)(input[8] & 0xfe) << 15);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 71 to 86
	value = ((uint32_t)(input[8] & 0x01) << 31) |
			((uint32_t)input[9] << 23) |
			((uint32_t)(input[10] & 0xfe) << 15);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 87 to 102
	value = ((uint32_t)(input[10] & 0x01) << 31) |
			((uint32_t)input[11] << 23) |
			((uint32_t)(input[12] & 0xfe) << 15);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 103 to 118
	value = ((uint32_t)(input[12] & 0x01) << 31) |
			((uint32_t)input[13] << 23) |
			((uint32_t)(input[14] & 0xfe) << 15);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 119 to 134
	value = ((uint32_t)(input[14] & 0x01) << 31) |
			((uint32_t)input[15] << 23) |
			((uint32_t)(input[16] & 0xfe) << 15);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 135 to 150
	value = ((uint32_t)(input[16] & 0x01) << 31) |
			((uint32_t)input[17] << 23) |
			((uint32_t)(input[18] & 0xfe) << 15);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 151 to 166
	value = ((uint32_t)(input[18] & 0x01) << 31) |
			((uint32_t)input[19] << 23) |
			((uint32_t)(input[20] & 0xfe) << 15);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 167 to 182
	value = ((uint32_t)(input[20] & 0x01) << 31) |
			((uint32_t)input[21] << 23) |
			((uint32_t)(input[22] & 0xfe) << 15);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 183 to 198
	value = ((uint32_t)(input[22] & 0x01) << 31) |
			((uint32_t)input[23] << 23) |
			((uint32_t)(input[24] & 0xfe) << 15);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 199 to 214
	value = ((uint32_t)(input[24] & 0x01) << 31) |
			((uint32_t)input[25] << 23) |
			((uint32_t)(input[26] & 0xfe) << 15);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 215 to 230
	value = ((uint32_t)(input[26] & 0x01) << 31) |
			((uint32_t)input[27] << 23) |
			((uint32_t)(input[28] & 0xfe) << 15);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 231 to 246
	value = ((uint32_t)(input[28] & 0x01) << 31) |
			((uint32_t)input[29] << 23) |
			((uint32_t)(input[30] & 0xfe) << 15);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 247 to 262
	value = ((uint32_t)(input[30] & 0x01) << 31) |
			((uint32_t)input[31] << 23) |
			((uint32_t)(input[32] & 0xfe) << 15);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 263 to 278
	value = ((uint32_t)(input[32] & 0x01) << 31) |
			((uint32_t)input[33] << 23) |
			((uint32_t)(input[34] & 0xfe) << 15);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 279 to 294
	value = ((uint32_t)(input[34] & 0x01) << 31) |
			((uint32_t)input[35] << 23) |
			((uint32_t)(input[36] & 0xfe) << 15);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 295 to 310
	value = ((uint32_t)(input[36] & 0x01) << 31) |
			((uint32_t)input[37] << 23) |
			((uint32_t)(input[38] & 0xfe) << 15);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 311 to 326
	value = ((uint32_t)(input[38] & 0x01) << 31) |
			((uint32_t)input[39] << 23) |
			((uint32_t)(input[40] & 0xfe) << 15);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 327 to 342
	value = ((uint32_t)(input[40] & 0x01) << 31) |
			((uint32_t)input[41] << 23) |
			((uint32_t)(input[42] & 0xfe) << 15);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 343 to 358
	value = ((uint32_t)(input[42] & 0x01) << 31) |
			((uint32_t)input[43] << 23) |
			((uint32_t)(input[44] & 0xfe) << 15);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 359 to 374
	value = ((uint32_t)(input[44] & 0x01) << 31) |
			((uint32_t)input[45] << 23) |
			((uint32_t)(input[46] & 0xfe) << 15);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 375 to 390
	value = ((uint32_t)(input[46] & 0x01) << 31) |
			((uint32_t)input[47] << 23) |
			((uint32_t)(input[48] & 0xfe) << 15);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 391 to 406
	value = ((uint32_t)(input[48] & 0x01) << 31) |
			((uint32_t)input[49] << 23) |
			((uint32_t)(input[50] & 0xfe) << 15);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 407 to 422
	value = ((uint32_t)(input[50] & 0x01) << 31) |
			((uint32_t)input[51] << 23) |
			((uint32_t)(input[52] & 0xfe) << 15);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 423 to 438
	value = ((uint32_t)(input[52] & 0x01) << 31) |
			((uint32_t)input[53] << 23) |
			((uint32_t)(input[54] & 0xfe) << 15);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 439 to 454
	value = ((uint32_t)(input[54] & 0x01) << 31) |
			((uint32_t)input[55] << 23) |
			((uint32_t)(input[56] & 0xfe) << 15);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 455 to 470
	value = ((uint32_t)(input[56] & 0x01) << 31) |
			((uint32_t)input[57] << 23) |
			((uint32_t)(input[58] & 0xfe) << 15);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 471 to 486
	value = ((uint32_t)(input[58] & 0x01) << 31) |
			((uint32_t)input[59] << 23) |
			((uint32_t)(input[60] & 0xfe) << 15);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 487 to 502
	value = ((uint32_t)(input[60] & 0x01) << 31) |
			((uint32_t)input[61] << 23) |
			((uint32_t)(input[62] & 0xfe) << 15);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 503 to 518
	value = ((uint32_t)(input[62] & 0x01) << 31) |
			((uint32_t)input[63] << 23) |
			((uint32_t)(input[64] & 0xfe) << 15);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 519 to 534
	value = ((uint32_t)(input[64] & 0x01) << 31) |
			((uint32_t)input[65] << 23) |
			((uint32_t)(input[66] & 0xfe) << 15);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 535 to 550
	value = ((uint32_t)(input[66] & 0x01) << 31) |
			((uint32_t)input[67] << 23) |
			((uint32_t)(input[68] & 0xfe) << 15);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 551 to 566
	value = ((uint32_t)(input[68] & 0x01) << 31) |
			((uint32_t)input[69] << 23) |
			((uint32_t)(input[70] & 0xfe) << 15);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 567 to 582
	value = ((uint32_t)(input[70] & 0x01) << 31) |
			((uint32_t)input[71] << 23) |
			((uint32_t)(input[72] & 0xfe) << 15);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 583 to 598
	value = ((uint32_t)(input[72] & 0x01) << 31) |
			((uint32_t)input[73] << 23) |
			((uint32_t)(input[74] & 0xfe) << 15);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 599 to 614
	value = ((uint32_t)(input[74] & 0x01) << 31) |
			((uint32_t)input[75] << 23) |
			((uint32_t)(input[76] & 0xfe) << 15);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 615 to 630
	value = ((uint32_t)(input[76] & 0x01) << 31) |
			((uint32_t)input[77] << 23) |
			((uint32_t)(input[78] & 0xfe) << 15);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 631 to 646
	value = ((uint32_t)(input[78] & 0x01) << 31) |
			((uint32_t)input[79] << 23) |
			((uint32_t)(input[80] & 0xfe) << 15);
	output[39] = (double)(value >> 16);

	// read output[40]: from bit 647 to 662
	value = ((uint32_t)(input[80] & 0x01) << 31) |
			((uint32_t)input[81] << 23) |
			((uint32_t)(input[82] & 0xfe) << 15);
	output[40] = (double)(value >> 16);

	// read output[41]: from bit 663 to 678
	value = ((uint32_t)(input[82] & 0x01) << 31) |
			((uint32_t)input[83] << 23) |
			((uint32_t)(input[84] & 0xfe) << 15);
	output[41] = (double)(value >> 16);

	// read output[42]: from bit 679 to 694
	value = ((uint32_t)(input[84] & 0x01) << 31) |
			((uint32_t)input[85] << 23) |
			((uint32_t)(input[86] & 0xfe) << 15);
	output[42] = (double)(value >> 16);

	// read output[43]: from bit 695 to 710
	value = ((uint32_t)(input[86] & 0x01) << 31) |
			((uint32_t)input[87] << 23) |
			((uint32_t)(input[88] & 0xfe) << 15);
	output[43] = (double)(value >> 16);

	// read output[44]: from bit 711 to 726
	value = ((uint32_t)(input[88] & 0x01) << 31) |
			((uint32_t)input[89] << 23) |
			((uint32_t)(input[90] & 0xfe) << 15);
	output[44] = (double)(value >> 16);

	// read output[45]: from bit 727 to 742
	value = ((uint32_t)(input[90] & 0x01) << 31) |
			((uint32_t)input[91] << 23) |
			((uint32_t)(input[92] & 0xfe) << 15);
	output[45] = (double)(value >> 16);

	// read output[46]: from bit 743 to 758
	value = ((uint32_t)(input[92] & 0x01) << 31) |
			((uint32_t)input[93] << 23) |
			((uint32_t)(input[94] & 0xfe) << 15);
	output[46] = (double)(value >> 16);

	// read output[47]: from bit 759 to 774
	value = ((uint32_t)(input[94] & 0x01) << 31) |
			((uint32_t)input[95] << 23) |
			((uint32_t)(input[96] & 0xfe) << 15);
	output[47] = (double)(value >> 16);

	// read output[48]: from bit 775 to 790
	value = ((uint32_t)(input[96] & 0x01) << 31) |
			((uint32_t)input[97] << 23) |
			((uint32_t)(input[98] & 0xfe) << 15);
	output[48] = (double)(value >> 16);

	// read output[49]: from bit 791 to 806
	value = ((uint32_t)(input[98] & 0x01) << 31) |
			((uint32_t)input[99] << 23) |
			((uint32_t)(input[100] & 0xfe) << 15);
	output[49] = (double)(value >> 16);

	// read output[50]: from bit 807 to 822
	value = ((uint32_t)(input[100] & 0x01) << 31) |
			((uint32_t)input[101] << 23) |
			((uint32_t)(input[102] & 0xfe) << 15);
	output[50] = (double)(value >> 16);

	// read output[51]: from bit 823 to 838
	value = ((uint32_t)(input[102] & 0x01) << 31) |
			((uint32_t)input[103] << 23) |
			((uint32_t)(input[104] & 0xfe) << 15);
	output[51] = (double)(value >> 16);

	// read output[52]: from bit 839 to 854
	value = ((uint32_t)(input[104] & 0x01) << 31) |
			((uint32_t)input[105] << 23) |
			((uint32_t)(input[106] & 0xfe) << 15);
	output[52] = (double)(value >> 16);

	// read output[53]: from bit 855 to 870
	value = ((uint32_t)(input[106] & 0x01) << 31) |
			((uint32_t)input[107] << 23) |
			((uint32_t)(input[108] & 0xfe) << 15);
	output[53] = (double)(value >> 16);

	// read output[54]: from bit 871 to 886
	value = ((uint32_t)(input[108] & 0x01) << 31) |
			((uint32_t)input[109] << 23) |
			((uint32_t)(input[110] & 0xfe) << 15);
	output[54] = (double)(value >> 16);

	// read output[55]: from bit 887 to 902
	value = ((uint32_t)(input[110] & 0x01) << 31) |
			((uint32_t)input[111] << 23) |
			((uint32_t)(input[112] & 0xfe) << 15);
	output[55] = (double)(value >> 16);

	// read output[56]: from bit 903 to 918
	value = ((uint32_t)(input[112] & 0x01) << 31) |
			((uint32_t)input[113] << 23) |
			((uint32_t)(input[114] & 0xfe) << 15);
	output[56] = (double)(value >> 16);

	// read output[57]: from bit 919 to 934
	value = ((uint32_t)(input[114] & 0x01) << 31) |
			((uint32_t)input[115] << 23) |
			((uint32_t)(input[116] & 0xfe) << 15);
	output[57] = (double)(value >> 16);

	// read output[58]: from bit 935 to 950
	value = ((uint32_t)(input[116] & 0x01) << 31) |
			((uint32_t)input[117] << 23) |
			((uint32_t)(input[118] & 0xfe) << 15);
	output[58] = (double)(value >> 16);

	// read output[59]: from bit 951 to 966
	value = ((uint32_t)(input[118] & 0x01) << 31) |
			((uint32_t)input[119] << 23) |
			((uint32_t)(input[120] & 0xfe) << 15);
	output[59] = (double)(value >> 16);

	// read output[60]: from bit 967 to 982
	value = ((uint32_t)(input[120] & 0x01) << 31) |
			((uint32_t)input[121] << 23) |
			((uint32_t)(input[122] & 0xfe) << 15);
	output[60] = (double)(value >> 16);

	// read output[61]: from bit 983 to 998
	value = ((uint32_t)(input[122] & 0x01) << 31) |
			((uint32_t)input[123] << 23) |
			((uint32_t)(input[124] & 0xfe) << 15);
	output[61] = (double)(value >> 16);

	// read output[62]: from bit 999 to 1014
	value = ((uint32_t)(input[124] & 0x01) << 31) |
			((uint32_t)input[125] << 23) |
			((uint32_t)(input[126] & 0xfe) << 15);
	output[62] = (double)(value >> 16);
}

static void unpack_63_16bit_unsigned_7off(const uint8_t * input, double * output, void *closure) {
	// Unpack 63 values into output
	// Values are 16-bit unsigned
	// Skip 7 bits, read 1008 bits of data.
	// Input must be at least 127 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 7 to 22
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)(input[2] & 0xfe) << 15);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 23 to 38
	value = ((uint32_t)(input[2] & 0x01) << 31) |
			((uint32_t)input[3] << 23) |
			((uint32_t)(input[4] & 0xfe) << 15);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 39 to 54
	value = ((uint32_t)(input[4] & 0x01) << 31) |
			((uint32_t)input[5] << 23) |
			((uint32_t)(input[6] & 0xfe) << 15);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 55 to 70
	value = ((uint32_t)(input[6] & 0x01) << 31) |
			((uint32_t)input[7] << 23) |
			((uint32_t)(input[8] & 0xfe) << 15);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 71 to 86
	value = ((uint32_t)(input[8] & 0x01) << 31) |
			((uint32_t)input[9] << 23) |
			((uint32_t)(input[10] & 0xfe) << 15);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 87 to 102
	value = ((uint32_t)(input[10] & 0x01) << 31) |
			((uint32_t)input[11] << 23) |
			((uint32_t)(input[12] & 0xfe) << 15);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 103 to 118
	value = ((uint32_t)(input[12] & 0x01) << 31) |
			((uint32_t)input[13] << 23) |
			((uint32_t)(input[14] & 0xfe) << 15);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 119 to 134
	value = ((uint32_t)(input[14] & 0x01) << 31) |
			((uint32_t)input[15] << 23) |
			((uint32_t)(input[16] & 0xfe) << 15);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 135 to 150
	value = ((uint32_t)(input[16] & 0x01) << 31) |
			((uint32_t)input[17] << 23) |
			((uint32_t)(input[18] & 0xfe) << 15);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 151 to 166
	value = ((uint32_t)(input[18] & 0x01) << 31) |
			((uint32_t)input[19] << 23) |
			((uint32_t)(input[20] & 0xfe) << 15);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 167 to 182
	value = ((uint32_t)(input[20] & 0x01) << 31) |
			((uint32_t)input[21] << 23) |
			((uint32_t)(input[22] & 0xfe) << 15);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 183 to 198
	value = ((uint32_t)(input[22] & 0x01) << 31) |
			((uint32_t)input[23] << 23) |
			((uint32_t)(input[24] & 0xfe) << 15);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 199 to 214
	value = ((uint32_t)(input[24] & 0x01) << 31) |
			((uint32_t)input[25] << 23) |
			((uint32_t)(input[26] & 0xfe) << 15);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 215 to 230
	value = ((uint32_t)(input[26] & 0x01) << 31) |
			((uint32_t)input[27] << 23) |
			((uint32_t)(input[28] & 0xfe) << 15);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 231 to 246
	value = ((uint32_t)(input[28] & 0x01) << 31) |
			((uint32_t)input[29] << 23) |
			((uint32_t)(input[30] & 0xfe) << 15);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 247 to 262
	value = ((uint32_t)(input[30] & 0x01) << 31) |
			((uint32_t)input[31] << 23) |
			((uint32_t)(input[32] & 0xfe) << 15);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 263 to 278
	value = ((uint32_t)(input[32] & 0x01) << 31) |
			((uint32_t)input[33] << 23) |
			((uint32_t)(input[34] & 0xfe) << 15);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 279 to 294
	value = ((uint32_t)(input[34] & 0x01) << 31) |
			((uint32_t)input[35] << 23) |
			((uint32_t)(input[36] & 0xfe) << 15);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 295 to 310
	value = ((uint32_t)(input[36] & 0x01) << 31) |
			((uint32_t)input[37] << 23) |
			((uint32_t)(input[38] & 0xfe) << 15);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 311 to 326
	value = ((uint32_t)(input[38] & 0x01) << 31) |
			((uint32_t)input[39] << 23) |
			((uint32_t)(input[40] & 0xfe) << 15);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 327 to 342
	value = ((uint32_t)(input[40] & 0x01) << 31) |
			((uint32_t)input[41] << 23) |
			((uint32_t)(input[42] & 0xfe) << 15);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 343 to 358
	value = ((uint32_t)(input[42] & 0x01) << 31) |
			((uint32_t)input[43] << 23) |
			((uint32_t)(input[44] & 0xfe) << 15);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 359 to 374
	value = ((uint32_t)(input[44] & 0x01) << 31) |
			((uint32_t)input[45] << 23) |
			((uint32_t)(input[46] & 0xfe) << 15);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 375 to 390
	value = ((uint32_t)(input[46] & 0x01) << 31) |
			((uint32_t)input[47] << 23) |
			((uint32_t)(input[48] & 0xfe) << 15);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 391 to 406
	value = ((uint32_t)(input[48] & 0x01) << 31) |
			((uint32_t)input[49] << 23) |
			((uint32_t)(input[50] & 0xfe) << 15);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 407 to 422
	value = ((uint32_t)(input[50] & 0x01) << 31) |
			((uint32_t)input[51] << 23) |
			((uint32_t)(input[52] & 0xfe) << 15);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 423 to 438
	value = ((uint32_t)(input[52] & 0x01) << 31) |
			((uint32_t)input[53] << 23) |
			((uint32_t)(input[54] & 0xfe) << 15);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 439 to 454
	value = ((uint32_t)(input[54] & 0x01) << 31) |
			((uint32_t)input[55] << 23) |
			((uint32_t)(input[56] & 0xfe) << 15);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 455 to 470
	value = ((uint32_t)(input[56] & 0x01) << 31) |
			((uint32_t)input[57] << 23) |
			((uint32_t)(input[58] & 0xfe) << 15);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 471 to 486
	value = ((uint32_t)(input[58] & 0x01) << 31) |
			((uint32_t)input[59] << 23) |
			((uint32_t)(input[60] & 0xfe) << 15);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 487 to 502
	value = ((uint32_t)(input[60] & 0x01) << 31) |
			((uint32_t)input[61] << 23) |
			((uint32_t)(input[62] & 0xfe) << 15);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 503 to 518
	value = ((uint32_t)(input[62] & 0x01) << 31) |
			((uint32_t)input[63] << 23) |
			((uint32_t)(input[64] & 0xfe) << 15);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 519 to 534
	value = ((uint32_t)(input[64] & 0x01) << 31) |
			((uint32_t)input[65] << 23) |
			((uint32_t)(input[66] & 0xfe) << 15);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 535 to 550
	value = ((uint32_t)(input[66] & 0x01) << 31) |
			((uint32_t)input[67] << 23) |
			((uint32_t)(input[68] & 0xfe) << 15);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 551 to 566
	value = ((uint32_t)(input[68] & 0x01) << 31) |
			((uint32_t)input[69] << 23) |
			((uint32_t)(input[70] & 0xfe) << 15);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 567 to 582
	value = ((uint32_t)(input[70] & 0x01) << 31) |
			((uint32_t)input[71] << 23) |
			((uint32_t)(input[72] & 0xfe) << 15);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 583 to 598
	value = ((uint32_t)(input[72] & 0x01) << 31) |
			((uint32_t)input[73] << 23) |
			((uint32_t)(input[74] & 0xfe) << 15);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 599 to 614
	value = ((uint32_t)(input[74] & 0x01) << 31) |
			((uint32_t)input[75] << 23) |
			((uint32_t)(input[76] & 0xfe) << 15);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 615 to 630
	value = ((uint32_t)(input[76] & 0x01) << 31) |
			((uint32_t)input[77] << 23) |
			((uint32_t)(input[78] & 0xfe) << 15);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 631 to 646
	value = ((uint32_t)(input[78] & 0x01) << 31) |
			((uint32_t)input[79] << 23) |
			((uint32_t)(input[80] & 0xfe) << 15);
	output[39] = (double)(value >> 16);

	// read output[40]: from bit 647 to 662
	value = ((uint32_t)(input[80] & 0x01) << 31) |
			((uint32_t)input[81] << 23) |
			((uint32_t)(input[82] & 0xfe) << 15);
	output[40] = (double)(value >> 16);

	// read output[41]: from bit 663 to 678
	value = ((uint32_t)(input[82] & 0x01) << 31) |
			((uint32_t)input[83] << 23) |
			((uint32_t)(input[84] & 0xfe) << 15);
	output[41] = (double)(value >> 16);

	// read output[42]: from bit 679 to 694
	value = ((uint32_t)(input[84] & 0x01) << 31) |
			((uint32_t)input[85] << 23) |
			((uint32_t)(input[86] & 0xfe) << 15);
	output[42] = (double)(value >> 16);

	// read output[43]: from bit 695 to 710
	value = ((uint32_t)(input[86] & 0x01) << 31) |
			((uint32_t)input[87] << 23) |
			((uint32_t)(input[88] & 0xfe) << 15);
	output[43] = (double)(value >> 16);

	// read output[44]: from bit 711 to 726
	value = ((uint32_t)(input[88] & 0x01) << 31) |
			((uint32_t)input[89] << 23) |
			((uint32_t)(input[90] & 0xfe) << 15);
	output[44] = (double)(value >> 16);

	// read output[45]: from bit 727 to 742
	value = ((uint32_t)(input[90] & 0x01) << 31) |
			((uint32_t)input[91] << 23) |
			((uint32_t)(input[92] & 0xfe) << 15);
	output[45] = (double)(value >> 16);

	// read output[46]: from bit 743 to 758
	value = ((uint32_t)(input[92] & 0x01) << 31) |
			((uint32_t)input[93] << 23) |
			((uint32_t)(input[94] & 0xfe) << 15);
	output[46] = (double)(value >> 16);

	// read output[47]: from bit 759 to 774
	value = ((uint32_t)(input[94] & 0x01) << 31) |
			((uint32_t)input[95] << 23) |
			((uint32_t)(input[96] & 0xfe) << 15);
	output[47] = (double)(value >> 16);

	// read output[48]: from bit 775 to 790
	value = ((uint32_t)(input[96] & 0x01) << 31) |
			((uint32_t)input[97] << 23) |
			((uint32_t)(input[98] & 0xfe) << 15);
	output[48] = (double)(value >> 16);

	// read output[49]: from bit 791 to 806
	value = ((uint32_t)(input[98] & 0x01) << 31) |
			((uint32_t)input[99] << 23) |
			((uint32_t)(input[100] & 0xfe) << 15);
	output[49] = (double)(value >> 16);

	// read output[50]: from bit 807 to 822
	value = ((uint32_t)(input[100] & 0x01) << 31) |
			((uint32_t)input[101] << 23) |
			((uint32_t)(input[102] & 0xfe) << 15);
	output[50] = (double)(value >> 16);

	// read output[51]: from bit 823 to 838
	value = ((uint32_t)(input[102] & 0x01) << 31) |
			((uint32_t)input[103] << 23) |
			((uint32_t)(input[104] & 0xfe) << 15);
	output[51] = (double)(value >> 16);

	// read output[52]: from bit 839 to 854
	value = ((uint32_t)(input[104] & 0x01) << 31) |
			((uint32_t)input[105] << 23) |
			((uint32_t)(input[106] & 0xfe) << 15);
	output[52] = (double)(value >> 16);

	// read output[53]: from bit 855 to 870
	value = ((uint32_t)(input[106] & 0x01) << 31) |
			((uint32_t)input[107] << 23) |
			((uint32_t)(input[108] & 0xfe) << 15);
	output[53] = (double)(value >> 16);

	// read output[54]: from bit 871 to 886
	value = ((uint32_t)(input[108] & 0x01) << 31) |
			((uint32_t)input[109] << 23) |
			((uint32_t)(input[110] & 0xfe) << 15);
	output[54] = (double)(value >> 16);

	// read output[55]: from bit 887 to 902
	value = ((uint32_t)(input[110] & 0x01) << 31) |
			((uint32_t)input[111] << 23) |
			((uint32_t)(input[112] & 0xfe) << 15);
	output[55] = (double)(value >> 16);

	// read output[56]: from bit 903 to 918
	value = ((uint32_t)(input[112] & 0x01) << 31) |
			((uint32_t)input[113] << 23) |
			((uint32_t)(input[114] & 0xfe) << 15);
	output[56] = (double)(value >> 16);

	// read output[57]: from bit 919 to 934
	value = ((uint32_t)(input[114] & 0x01) << 31) |
			((uint32_t)input[115] << 23) |
			((uint32_t)(input[116] & 0xfe) << 15);
	output[57] = (double)(value >> 16);

	// read output[58]: from bit 935 to 950
	value = ((uint32_t)(input[116] & 0x01) << 31) |
			((uint32_t)input[117] << 23) |
			((uint32_t)(input[118] & 0xfe) << 15);
	output[58] = (double)(value >> 16);

	// read output[59]: from bit 951 to 966
	value = ((uint32_t)(input[118] & 0x01) << 31) |
			((uint32_t)input[119] << 23) |
			((uint32_t)(input[120] & 0xfe) << 15);
	output[59] = (double)(value >> 16);

	// read output[60]: from bit 967 to 982
	value = ((uint32_t)(input[120] & 0x01) << 31) |
			((uint32_t)input[121] << 23) |
			((uint32_t)(input[122] & 0xfe) << 15);
	output[60] = (double)(value >> 16);

	// read output[61]: from bit 983 to 998
	value = ((uint32_t)(input[122] & 0x01) << 31) |
			((uint32_t)input[123] << 23) |
			((uint32_t)(input[124] & 0xfe) << 15);
	output[61] = (double)(value >> 16);

	// read output[62]: from bit 999 to 1014
	value = ((uint32_t)(input[124] & 0x01) << 31) |
			((uint32_t)input[125] << 23) |
			((uint32_t)(input[126] & 0xfe) << 15);
	output[62] = (double)(value >> 16);
}

static void unpack_64_16bit_signed_0off(const uint8_t * input, double * output, void *closure) {
	// Unpack 64 values into output
	// Values are 16-bit signed
	// Skip 0 bits, read 1024 bits of data.
	// Input must be at least 128 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 0 to 15
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)input[1] << 16);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 16 to 31
	value = ((uint32_t)input[2] << 24) |
			((uint32_t)input[3] << 16);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 32 to 47
	value = ((uint32_t)input[4] << 24) |
			((uint32_t)input[5] << 16);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 48 to 63
	value = ((uint32_t)input[6] << 24) |
			((uint32_t)input[7] << 16);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 64 to 79
	value = ((uint32_t)input[8] << 24) |
			((uint32_t)input[9] << 16);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 80 to 95
	value = ((uint32_t)input[10] << 24) |
			((uint32_t)input[11] << 16);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 96 to 111
	value = ((uint32_t)input[12] << 24) |
			((uint32_t)input[13] << 16);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 112 to 127
	value = ((uint32_t)input[14] << 24) |
			((uint32_t)input[15] << 16);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 128 to 143
	value = ((uint32_t)input[16] << 24) |
			((uint32_t)input[17] << 16);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 144 to 159
	value = ((uint32_t)input[18] << 24) |
			((uint32_t)input[19] << 16);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 160 to 175
	value = ((uint32_t)input[20] << 24) |
			((uint32_t)input[21] << 16);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 176 to 191
	value = ((uint32_t)input[22] << 24) |
			((uint32_t)input[23] << 16);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 192 to 207
	value = ((uint32_t)input[24] << 24) |
			((uint32_t)input[25] << 16);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 208 to 223
	value = ((uint32_t)input[26] << 24) |
			((uint32_t)input[27] << 16);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 224 to 239
	value = ((uint32_t)input[28] << 24) |
			((uint32_t)input[29] << 16);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 240 to 255
	value = ((uint32_t)input[30] << 24) |
			((uint32_t)input[31] << 16);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 256 to 271
	value = ((uint32_t)input[32] << 24) |
			((uint32_t)input[33] << 16);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 272 to 287
	value = ((uint32_t)input[34] << 24) |
			((uint32_t)input[35] << 16);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 288 to 303
	value = ((uint32_t)input[36] << 24) |
			((uint32_t)input[37] << 16);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 304 to 319
	value = ((uint32_t)input[38] << 24) |
			((uint32_t)input[39] << 16);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 320 to 335
	value = ((uint32_t)input[40] << 24) |
			((uint32_t)input[41] << 16);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 336 to 351
	value = ((uint32_t)input[42] << 24) |
			((uint32_t)input[43] << 16);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 352 to 367
	value = ((uint32_t)input[44] << 24) |
			((uint32_t)input[45] << 16);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 368 to 383
	value = ((uint32_t)input[46] << 24) |
			((uint32_t)input[47] << 16);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 384 to 399
	value = ((uint32_t)input[48] << 24) |
			((uint32_t)input[49] << 16);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 400 to 415
	value = ((uint32_t)input[50] << 24) |
			((uint32_t)input[51] << 16);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 416 to 431
	value = ((uint32_t)input[52] << 24) |
			((uint32_t)input[53] << 16);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 432 to 447
	value = ((uint32_t)input[54] << 24) |
			((uint32_t)input[55] << 16);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 448 to 463
	value = ((uint32_t)input[56] << 24) |
			((uint32_t)input[57] << 16);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 464 to 479
	value = ((uint32_t)input[58] << 24) |
			((uint32_t)input[59] << 16);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 480 to 495
	value = ((uint32_t)input[60] << 24) |
			((uint32_t)input[61] << 16);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 496 to 511
	value = ((uint32_t)input[62] << 24) |
			((uint32_t)input[63] << 16);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 512 to 527
	value = ((uint32_t)input[64] << 24) |
			((uint32_t)input[65] << 16);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 528 to 543
	value = ((uint32_t)input[66] << 24) |
			((uint32_t)input[67] << 16);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 544 to 559
	value = ((uint32_t)input[68] << 24) |
			((uint32_t)input[69] << 16);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 560 to 575
	value = ((uint32_t)input[70] << 24) |
			((uint32_t)input[71] << 16);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 576 to 591
	value = ((uint32_t)input[72] << 24) |
			((uint32_t)input[73] << 16);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 592 to 607
	value = ((uint32_t)input[74] << 24) |
			((uint32_t)input[75] << 16);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 608 to 623
	value = ((uint32_t)input[76] << 24) |
			((uint32_t)input[77] << 16);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 624 to 639
	value = ((uint32_t)input[78] << 24) |
			((uint32_t)input[79] << 16);
	output[39] = (double)(value >> 16);

	// read output[40]: from bit 640 to 655
	value = ((uint32_t)input[80] << 24) |
			((uint32_t)input[81] << 16);
	output[40] = (double)(value >> 16);

	// read output[41]: from bit 656 to 671
	value = ((uint32_t)input[82] << 24) |
			((uint32_t)input[83] << 16);
	output[41] = (double)(value >> 16);

	// read output[42]: from bit 672 to 687
	value = ((uint32_t)input[84] << 24) |
			((uint32_t)input[85] << 16);
	output[42] = (double)(value >> 16);

	// read output[43]: from bit 688 to 703
	value = ((uint32_t)input[86] << 24) |
			((uint32_t)input[87] << 16);
	output[43] = (double)(value >> 16);

	// read output[44]: from bit 704 to 719
	value = ((uint32_t)input[88] << 24) |
			((uint32_t)input[89] << 16);
	output[44] = (double)(value >> 16);

	// read output[45]: from bit 720 to 735
	value = ((uint32_t)input[90] << 24) |
			((uint32_t)input[91] << 16);
	output[45] = (double)(value >> 16);

	// read output[46]: from bit 736 to 751
	value = ((uint32_t)input[92] << 24) |
			((uint32_t)input[93] << 16);
	output[46] = (double)(value >> 16);

	// read output[47]: from bit 752 to 767
	value = ((uint32_t)input[94] << 24) |
			((uint32_t)input[95] << 16);
	output[47] = (double)(value >> 16);

	// read output[48]: from bit 768 to 783
	value = ((uint32_t)input[96] << 24) |
			((uint32_t)input[97] << 16);
	output[48] = (double)(value >> 16);

	// read output[49]: from bit 784 to 799
	value = ((uint32_t)input[98] << 24) |
			((uint32_t)input[99] << 16);
	output[49] = (double)(value >> 16);

	// read output[50]: from bit 800 to 815
	value = ((uint32_t)input[100] << 24) |
			((uint32_t)input[101] << 16);
	output[50] = (double)(value >> 16);

	// read output[51]: from bit 816 to 831
	value = ((uint32_t)input[102] << 24) |
			((uint32_t)input[103] << 16);
	output[51] = (double)(value >> 16);

	// read output[52]: from bit 832 to 847
	value = ((uint32_t)input[104] << 24) |
			((uint32_t)input[105] << 16);
	output[52] = (double)(value >> 16);

	// read output[53]: from bit 848 to 863
	value = ((uint32_t)input[106] << 24) |
			((uint32_t)input[107] << 16);
	output[53] = (double)(value >> 16);

	// read output[54]: from bit 864 to 879
	value = ((uint32_t)input[108] << 24) |
			((uint32_t)input[109] << 16);
	output[54] = (double)(value >> 16);

	// read output[55]: from bit 880 to 895
	value = ((uint32_t)input[110] << 24) |
			((uint32_t)input[111] << 16);
	output[55] = (double)(value >> 16);

	// read output[56]: from bit 896 to 911
	value = ((uint32_t)input[112] << 24) |
			((uint32_t)input[113] << 16);
	output[56] = (double)(value >> 16);

	// read output[57]: from bit 912 to 927
	value = ((uint32_t)input[114] << 24) |
			((uint32_t)input[115] << 16);
	output[57] = (double)(value >> 16);

	// read output[58]: from bit 928 to 943
	value = ((uint32_t)input[116] << 24) |
			((uint32_t)input[117] << 16);
	output[58] = (double)(value >> 16);

	// read output[59]: from bit 944 to 959
	value = ((uint32_t)input[118] << 24) |
			((uint32_t)input[119] << 16);
	output[59] = (double)(value >> 16);

	// read output[60]: from bit 960 to 975
	value = ((uint32_t)input[120] << 24) |
			((uint32_t)input[121] << 16);
	output[60] = (double)(value >> 16);

	// read output[61]: from bit 976 to 991
	value = ((uint32_t)input[122] << 24) |
			((uint32_t)input[123] << 16);
	output[61] = (double)(value >> 16);

	// read output[62]: from bit 992 to 1007
	value = ((uint32_t)input[124] << 24) |
			((uint32_t)input[125] << 16);
	output[62] = (double)(value >> 16);

	// read output[63]: from bit 1008 to 1023
	value = ((uint32_t)input[126] << 24) |
			((uint32_t)input[127] << 16);
	output[63] = (double)(value >> 16);
}

static void unpack_64_16bit_unsigned_0off(const uint8_t * input, double * output, void *closure) {
	// Unpack 64 values into output
	// Values are 16-bit unsigned
	// Skip 0 bits, read 1024 bits of data.
	// Input must be at least 128 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 0 to 15
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)input[1] << 16);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 16 to 31
	value = ((uint32_t)input[2] << 24) |
			((uint32_t)input[3] << 16);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 32 to 47
	value = ((uint32_t)input[4] << 24) |
			((uint32_t)input[5] << 16);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 48 to 63
	value = ((uint32_t)input[6] << 24) |
			((uint32_t)input[7] << 16);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 64 to 79
	value = ((uint32_t)input[8] << 24) |
			((uint32_t)input[9] << 16);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 80 to 95
	value = ((uint32_t)input[10] << 24) |
			((uint32_t)input[11] << 16);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 96 to 111
	value = ((uint32_t)input[12] << 24) |
			((uint32_t)input[13] << 16);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 112 to 127
	value = ((uint32_t)input[14] << 24) |
			((uint32_t)input[15] << 16);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 128 to 143
	value = ((uint32_t)input[16] << 24) |
			((uint32_t)input[17] << 16);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 144 to 159
	value = ((uint32_t)input[18] << 24) |
			((uint32_t)input[19] << 16);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 160 to 175
	value = ((uint32_t)input[20] << 24) |
			((uint32_t)input[21] << 16);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 176 to 191
	value = ((uint32_t)input[22] << 24) |
			((uint32_t)input[23] << 16);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 192 to 207
	value = ((uint32_t)input[24] << 24) |
			((uint32_t)input[25] << 16);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 208 to 223
	value = ((uint32_t)input[26] << 24) |
			((uint32_t)input[27] << 16);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 224 to 239
	value = ((uint32_t)input[28] << 24) |
			((uint32_t)input[29] << 16);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 240 to 255
	value = ((uint32_t)input[30] << 24) |
			((uint32_t)input[31] << 16);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 256 to 271
	value = ((uint32_t)input[32] << 24) |
			((uint32_t)input[33] << 16);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 272 to 287
	value = ((uint32_t)input[34] << 24) |
			((uint32_t)input[35] << 16);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 288 to 303
	value = ((uint32_t)input[36] << 24) |
			((uint32_t)input[37] << 16);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 304 to 319
	value = ((uint32_t)input[38] << 24) |
			((uint32_t)input[39] << 16);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 320 to 335
	value = ((uint32_t)input[40] << 24) |
			((uint32_t)input[41] << 16);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 336 to 351
	value = ((uint32_t)input[42] << 24) |
			((uint32_t)input[43] << 16);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 352 to 367
	value = ((uint32_t)input[44] << 24) |
			((uint32_t)input[45] << 16);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 368 to 383
	value = ((uint32_t)input[46] << 24) |
			((uint32_t)input[47] << 16);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 384 to 399
	value = ((uint32_t)input[48] << 24) |
			((uint32_t)input[49] << 16);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 400 to 415
	value = ((uint32_t)input[50] << 24) |
			((uint32_t)input[51] << 16);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 416 to 431
	value = ((uint32_t)input[52] << 24) |
			((uint32_t)input[53] << 16);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 432 to 447
	value = ((uint32_t)input[54] << 24) |
			((uint32_t)input[55] << 16);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 448 to 463
	value = ((uint32_t)input[56] << 24) |
			((uint32_t)input[57] << 16);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 464 to 479
	value = ((uint32_t)input[58] << 24) |
			((uint32_t)input[59] << 16);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 480 to 495
	value = ((uint32_t)input[60] << 24) |
			((uint32_t)input[61] << 16);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 496 to 511
	value = ((uint32_t)input[62] << 24) |
			((uint32_t)input[63] << 16);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 512 to 527
	value = ((uint32_t)input[64] << 24) |
			((uint32_t)input[65] << 16);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 528 to 543
	value = ((uint32_t)input[66] << 24) |
			((uint32_t)input[67] << 16);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 544 to 559
	value = ((uint32_t)input[68] << 24) |
			((uint32_t)input[69] << 16);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 560 to 575
	value = ((uint32_t)input[70] << 24) |
			((uint32_t)input[71] << 16);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 576 to 591
	value = ((uint32_t)input[72] << 24) |
			((uint32_t)input[73] << 16);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 592 to 607
	value = ((uint32_t)input[74] << 24) |
			((uint32_t)input[75] << 16);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 608 to 623
	value = ((uint32_t)input[76] << 24) |
			((uint32_t)input[77] << 16);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 624 to 639
	value = ((uint32_t)input[78] << 24) |
			((uint32_t)input[79] << 16);
	output[39] = (double)(value >> 16);

	// read output[40]: from bit 640 to 655
	value = ((uint32_t)input[80] << 24) |
			((uint32_t)input[81] << 16);
	output[40] = (double)(value >> 16);

	// read output[41]: from bit 656 to 671
	value = ((uint32_t)input[82] << 24) |
			((uint32_t)input[83] << 16);
	output[41] = (double)(value >> 16);

	// read output[42]: from bit 672 to 687
	value = ((uint32_t)input[84] << 24) |
			((uint32_t)input[85] << 16);
	output[42] = (double)(value >> 16);

	// read output[43]: from bit 688 to 703
	value = ((uint32_t)input[86] << 24) |
			((uint32_t)input[87] << 16);
	output[43] = (double)(value >> 16);

	// read output[44]: from bit 704 to 719
	value = ((uint32_t)input[88] << 24) |
			((uint32_t)input[89] << 16);
	output[44] = (double)(value >> 16);

	// read output[45]: from bit 720 to 735
	value = ((uint32_t)input[90] << 24) |
			((uint32_t)input[91] << 16);
	output[45] = (double)(value >> 16);

	// read output[46]: from bit 736 to 751
	value = ((uint32_t)input[92] << 24) |
			((uint32_t)input[93] << 16);
	output[46] = (double)(value >> 16);

	// read output[47]: from bit 752 to 767
	value = ((uint32_t)input[94] << 24) |
			((uint32_t)input[95] << 16);
	output[47] = (double)(value >> 16);

	// read output[48]: from bit 768 to 783
	value = ((uint32_t)input[96] << 24) |
			((uint32_t)input[97] << 16);
	output[48] = (double)(value >> 16);

	// read output[49]: from bit 784 to 799
	value = ((uint32_t)input[98] << 24) |
			((uint32_t)input[99] << 16);
	output[49] = (double)(value >> 16);

	// read output[50]: from bit 800 to 815
	value = ((uint32_t)input[100] << 24) |
			((uint32_t)input[101] << 16);
	output[50] = (double)(value >> 16);

	// read output[51]: from bit 816 to 831
	value = ((uint32_t)input[102] << 24) |
			((uint32_t)input[103] << 16);
	output[51] = (double)(value >> 16);

	// read output[52]: from bit 832 to 847
	value = ((uint32_t)input[104] << 24) |
			((uint32_t)input[105] << 16);
	output[52] = (double)(value >> 16);

	// read output[53]: from bit 848 to 863
	value = ((uint32_t)input[106] << 24) |
			((uint32_t)input[107] << 16);
	output[53] = (double)(value >> 16);

	// read output[54]: from bit 864 to 879
	value = ((uint32_t)input[108] << 24) |
			((uint32_t)input[109] << 16);
	output[54] = (double)(value >> 16);

	// read output[55]: from bit 880 to 895
	value = ((uint32_t)input[110] << 24) |
			((uint32_t)input[111] << 16);
	output[55] = (double)(value >> 16);

	// read output[56]: from bit 896 to 911
	value = ((uint32_t)input[112] << 24) |
			((uint32_t)input[113] << 16);
	output[56] = (double)(value >> 16);

	// read output[57]: from bit 912 to 927
	value = ((uint32_t)input[114] << 24) |
			((uint32_t)input[115] << 16);
	output[57] = (double)(value >> 16);

	// read output[58]: from bit 928 to 943
	value = ((uint32_t)input[116] << 24) |
			((uint32_t)input[117] << 16);
	output[58] = (double)(value >> 16);

	// read output[59]: from bit 944 to 959
	value = ((uint32_t)input[118] << 24) |
			((uint32_t)input[119] << 16);
	output[59] = (double)(value >> 16);

	// read output[60]: from bit 960 to 975
	value = ((uint32_t)input[120] << 24) |
			((uint32_t)input[121] << 16);
	output[60] = (double)(value >> 16);

	// read output[61]: from bit 976 to 991
	value = ((uint32_t)input[122] << 24) |
			((uint32_t)input[123] << 16);
	output[61] = (double)(value >> 16);

	// read output[62]: from bit 992 to 1007
	value = ((uint32_t)input[124] << 24) |
			((uint32_t)input[125] << 16);
	output[62] = (double)(value >> 16);

	// read output[63]: from bit 1008 to 1023
	value = ((uint32_t)input[126] << 24) |
			((uint32_t)input[127] << 16);
	output[63] = (double)(value >> 16);
}

static void unpack_64_16bit_signed_1off(const uint8_t * input, double * output, void *closure) {
	// Unpack 64 values into output
	// Values are 16-bit signed
	// Skip 1 bits, read 1024 bits of data.
	// Input must be at least 129 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 1 to 16
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)input[1] << 17) |
			((uint32_t)(input[2] & 0x80) << 9);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 17 to 32
	value = ((uint32_t)(input[2] & 0x7f) << 25) |
			((uint32_t)input[3] << 17) |
			((uint32_t)(input[4] & 0x80) << 9);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 33 to 48
	value = ((uint32_t)(input[4] & 0x7f) << 25) |
			((uint32_t)input[5] << 17) |
			((uint32_t)(input[6] & 0x80) << 9);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 49 to 64
	value = ((uint32_t)(input[6] & 0x7f) << 25) |
			((uint32_t)input[7] << 17) |
			((uint32_t)(input[8] & 0x80) << 9);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 65 to 80
	value = ((uint32_t)(input[8] & 0x7f) << 25) |
			((uint32_t)input[9] << 17) |
			((uint32_t)(input[10] & 0x80) << 9);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 81 to 96
	value = ((uint32_t)(input[10] & 0x7f) << 25) |
			((uint32_t)input[11] << 17) |
			((uint32_t)(input[12] & 0x80) << 9);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 97 to 112
	value = ((uint32_t)(input[12] & 0x7f) << 25) |
			((uint32_t)input[13] << 17) |
			((uint32_t)(input[14] & 0x80) << 9);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 113 to 128
	value = ((uint32_t)(input[14] & 0x7f) << 25) |
			((uint32_t)input[15] << 17) |
			((uint32_t)(input[16] & 0x80) << 9);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 129 to 144
	value = ((uint32_t)(input[16] & 0x7f) << 25) |
			((uint32_t)input[17] << 17) |
			((uint32_t)(input[18] & 0x80) << 9);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 145 to 160
	value = ((uint32_t)(input[18] & 0x7f) << 25) |
			((uint32_t)input[19] << 17) |
			((uint32_t)(input[20] & 0x80) << 9);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 161 to 176
	value = ((uint32_t)(input[20] & 0x7f) << 25) |
			((uint32_t)input[21] << 17) |
			((uint32_t)(input[22] & 0x80) << 9);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 177 to 192
	value = ((uint32_t)(input[22] & 0x7f) << 25) |
			((uint32_t)input[23] << 17) |
			((uint32_t)(input[24] & 0x80) << 9);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 193 to 208
	value = ((uint32_t)(input[24] & 0x7f) << 25) |
			((uint32_t)input[25] << 17) |
			((uint32_t)(input[26] & 0x80) << 9);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 209 to 224
	value = ((uint32_t)(input[26] & 0x7f) << 25) |
			((uint32_t)input[27] << 17) |
			((uint32_t)(input[28] & 0x80) << 9);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 225 to 240
	value = ((uint32_t)(input[28] & 0x7f) << 25) |
			((uint32_t)input[29] << 17) |
			((uint32_t)(input[30] & 0x80) << 9);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 241 to 256
	value = ((uint32_t)(input[30] & 0x7f) << 25) |
			((uint32_t)input[31] << 17) |
			((uint32_t)(input[32] & 0x80) << 9);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 257 to 272
	value = ((uint32_t)(input[32] & 0x7f) << 25) |
			((uint32_t)input[33] << 17) |
			((uint32_t)(input[34] & 0x80) << 9);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 273 to 288
	value = ((uint32_t)(input[34] & 0x7f) << 25) |
			((uint32_t)input[35] << 17) |
			((uint32_t)(input[36] & 0x80) << 9);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 289 to 304
	value = ((uint32_t)(input[36] & 0x7f) << 25) |
			((uint32_t)input[37] << 17) |
			((uint32_t)(input[38] & 0x80) << 9);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 305 to 320
	value = ((uint32_t)(input[38] & 0x7f) << 25) |
			((uint32_t)input[39] << 17) |
			((uint32_t)(input[40] & 0x80) << 9);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 321 to 336
	value = ((uint32_t)(input[40] & 0x7f) << 25) |
			((uint32_t)input[41] << 17) |
			((uint32_t)(input[42] & 0x80) << 9);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 337 to 352
	value = ((uint32_t)(input[42] & 0x7f) << 25) |
			((uint32_t)input[43] << 17) |
			((uint32_t)(input[44] & 0x80) << 9);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 353 to 368
	value = ((uint32_t)(input[44] & 0x7f) << 25) |
			((uint32_t)input[45] << 17) |
			((uint32_t)(input[46] & 0x80) << 9);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 369 to 384
	value = ((uint32_t)(input[46] & 0x7f) << 25) |
			((uint32_t)input[47] << 17) |
			((uint32_t)(input[48] & 0x80) << 9);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 385 to 400
	value = ((uint32_t)(input[48] & 0x7f) << 25) |
			((uint32_t)input[49] << 17) |
			((uint32_t)(input[50] & 0x80) << 9);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 401 to 416
	value = ((uint32_t)(input[50] & 0x7f) << 25) |
			((uint32_t)input[51] << 17) |
			((uint32_t)(input[52] & 0x80) << 9);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 417 to 432
	value = ((uint32_t)(input[52] & 0x7f) << 25) |
			((uint32_t)input[53] << 17) |
			((uint32_t)(input[54] & 0x80) << 9);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 433 to 448
	value = ((uint32_t)(input[54] & 0x7f) << 25) |
			((uint32_t)input[55] << 17) |
			((uint32_t)(input[56] & 0x80) << 9);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 449 to 464
	value = ((uint32_t)(input[56] & 0x7f) << 25) |
			((uint32_t)input[57] << 17) |
			((uint32_t)(input[58] & 0x80) << 9);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 465 to 480
	value = ((uint32_t)(input[58] & 0x7f) << 25) |
			((uint32_t)input[59] << 17) |
			((uint32_t)(input[60] & 0x80) << 9);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 481 to 496
	value = ((uint32_t)(input[60] & 0x7f) << 25) |
			((uint32_t)input[61] << 17) |
			((uint32_t)(input[62] & 0x80) << 9);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 497 to 512
	value = ((uint32_t)(input[62] & 0x7f) << 25) |
			((uint32_t)input[63] << 17) |
			((uint32_t)(input[64] & 0x80) << 9);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 513 to 528
	value = ((uint32_t)(input[64] & 0x7f) << 25) |
			((uint32_t)input[65] << 17) |
			((uint32_t)(input[66] & 0x80) << 9);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 529 to 544
	value = ((uint32_t)(input[66] & 0x7f) << 25) |
			((uint32_t)input[67] << 17) |
			((uint32_t)(input[68] & 0x80) << 9);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 545 to 560
	value = ((uint32_t)(input[68] & 0x7f) << 25) |
			((uint32_t)input[69] << 17) |
			((uint32_t)(input[70] & 0x80) << 9);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 561 to 576
	value = ((uint32_t)(input[70] & 0x7f) << 25) |
			((uint32_t)input[71] << 17) |
			((uint32_t)(input[72] & 0x80) << 9);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 577 to 592
	value = ((uint32_t)(input[72] & 0x7f) << 25) |
			((uint32_t)input[73] << 17) |
			((uint32_t)(input[74] & 0x80) << 9);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 593 to 608
	value = ((uint32_t)(input[74] & 0x7f) << 25) |
			((uint32_t)input[75] << 17) |
			((uint32_t)(input[76] & 0x80) << 9);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 609 to 624
	value = ((uint32_t)(input[76] & 0x7f) << 25) |
			((uint32_t)input[77] << 17) |
			((uint32_t)(input[78] & 0x80) << 9);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 625 to 640
	value = ((uint32_t)(input[78] & 0x7f) << 25) |
			((uint32_t)input[79] << 17) |
			((uint32_t)(input[80] & 0x80) << 9);
	output[39] = (double)(value >> 16);

	// read output[40]: from bit 641 to 656
	value = ((uint32_t)(input[80] & 0x7f) << 25) |
			((uint32_t)input[81] << 17) |
			((uint32_t)(input[82] & 0x80) << 9);
	output[40] = (double)(value >> 16);

	// read output[41]: from bit 657 to 672
	value = ((uint32_t)(input[82] & 0x7f) << 25) |
			((uint32_t)input[83] << 17) |
			((uint32_t)(input[84] & 0x80) << 9);
	output[41] = (double)(value >> 16);

	// read output[42]: from bit 673 to 688
	value = ((uint32_t)(input[84] & 0x7f) << 25) |
			((uint32_t)input[85] << 17) |
			((uint32_t)(input[86] & 0x80) << 9);
	output[42] = (double)(value >> 16);

	// read output[43]: from bit 689 to 704
	value = ((uint32_t)(input[86] & 0x7f) << 25) |
			((uint32_t)input[87] << 17) |
			((uint32_t)(input[88] & 0x80) << 9);
	output[43] = (double)(value >> 16);

	// read output[44]: from bit 705 to 720
	value = ((uint32_t)(input[88] & 0x7f) << 25) |
			((uint32_t)input[89] << 17) |
			((uint32_t)(input[90] & 0x80) << 9);
	output[44] = (double)(value >> 16);

	// read output[45]: from bit 721 to 736
	value = ((uint32_t)(input[90] & 0x7f) << 25) |
			((uint32_t)input[91] << 17) |
			((uint32_t)(input[92] & 0x80) << 9);
	output[45] = (double)(value >> 16);

	// read output[46]: from bit 737 to 752
	value = ((uint32_t)(input[92] & 0x7f) << 25) |
			((uint32_t)input[93] << 17) |
			((uint32_t)(input[94] & 0x80) << 9);
	output[46] = (double)(value >> 16);

	// read output[47]: from bit 753 to 768
	value = ((uint32_t)(input[94] & 0x7f) << 25) |
			((uint32_t)input[95] << 17) |
			((uint32_t)(input[96] & 0x80) << 9);
	output[47] = (double)(value >> 16);

	// read output[48]: from bit 769 to 784
	value = ((uint32_t)(input[96] & 0x7f) << 25) |
			((uint32_t)input[97] << 17) |
			((uint32_t)(input[98] & 0x80) << 9);
	output[48] = (double)(value >> 16);

	// read output[49]: from bit 785 to 800
	value = ((uint32_t)(input[98] & 0x7f) << 25) |
			((uint32_t)input[99] << 17) |
			((uint32_t)(input[100] & 0x80) << 9);
	output[49] = (double)(value >> 16);

	// read output[50]: from bit 801 to 816
	value = ((uint32_t)(input[100] & 0x7f) << 25) |
			((uint32_t)input[101] << 17) |
			((uint32_t)(input[102] & 0x80) << 9);
	output[50] = (double)(value >> 16);

	// read output[51]: from bit 817 to 832
	value = ((uint32_t)(input[102] & 0x7f) << 25) |
			((uint32_t)input[103] << 17) |
			((uint32_t)(input[104] & 0x80) << 9);
	output[51] = (double)(value >> 16);

	// read output[52]: from bit 833 to 848
	value = ((uint32_t)(input[104] & 0x7f) << 25) |
			((uint32_t)input[105] << 17) |
			((uint32_t)(input[106] & 0x80) << 9);
	output[52] = (double)(value >> 16);

	// read output[53]: from bit 849 to 864
	value = ((uint32_t)(input[106] & 0x7f) << 25) |
			((uint32_t)input[107] << 17) |
			((uint32_t)(input[108] & 0x80) << 9);
	output[53] = (double)(value >> 16);

	// read output[54]: from bit 865 to 880
	value = ((uint32_t)(input[108] & 0x7f) << 25) |
			((uint32_t)input[109] << 17) |
			((uint32_t)(input[110] & 0x80) << 9);
	output[54] = (double)(value >> 16);

	// read output[55]: from bit 881 to 896
	value = ((uint32_t)(input[110] & 0x7f) << 25) |
			((uint32_t)input[111] << 17) |
			((uint32_t)(input[112] & 0x80) << 9);
	output[55] = (double)(value >> 16);

	// read output[56]: from bit 897 to 912
	value = ((uint32_t)(input[112] & 0x7f) << 25) |
			((uint32_t)input[113] << 17) |
			((uint32_t)(input[114] & 0x80) << 9);
	output[56] = (double)(value >> 16);

	// read output[57]: from bit 913 to 928
	value = ((uint32_t)(input[114] & 0x7f) << 25) |
			((uint32_t)input[115] << 17) |
			((uint32_t)(input[116] & 0x80) << 9);
	output[57] = (double)(value >> 16);

	// read output[58]: from bit 929 to 944
	value = ((uint32_t)(input[116] & 0x7f) << 25) |
			((uint32_t)input[117] << 17) |
			((uint32_t)(input[118] & 0x80) << 9);
	output[58] = (double)(value >> 16);

	// read output[59]: from bit 945 to 960
	value = ((uint32_t)(input[118] & 0x7f) << 25) |
			((uint32_t)input[119] << 17) |
			((uint32_t)(input[120] & 0x80) << 9);
	output[59] = (double)(value >> 16);

	// read output[60]: from bit 961 to 976
	value = ((uint32_t)(input[120] & 0x7f) << 25) |
			((uint32_t)input[121] << 17) |
			((uint32_t)(input[122] & 0x80) << 9);
	output[60] = (double)(value >> 16);

	// read output[61]: from bit 977 to 992
	value = ((uint32_t)(input[122] & 0x7f) << 25) |
			((uint32_t)input[123] << 17) |
			((uint32_t)(input[124] & 0x80) << 9);
	output[61] = (double)(value >> 16);

	// read output[62]: from bit 993 to 1008
	value = ((uint32_t)(input[124] & 0x7f) << 25) |
			((uint32_t)input[125] << 17) |
			((uint32_t)(input[126] & 0x80) << 9);
	output[62] = (double)(value >> 16);

	// read output[63]: from bit 1009 to 1024
	value = ((uint32_t)(input[126] & 0x7f) << 25) |
			((uint32_t)input[127] << 17) |
			((uint32_t)(input[128] & 0x80) << 9);
	output[63] = (double)(value >> 16);
}

static void unpack_64_16bit_unsigned_1off(const uint8_t * input, double * output, void *closure) {
	// Unpack 64 values into output
	// Values are 16-bit unsigned
	// Skip 1 bits, read 1024 bits of data.
	// Input must be at least 129 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 1 to 16
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)input[1] << 17) |
			((uint32_t)(input[2] & 0x80) << 9);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 17 to 32
	value = ((uint32_t)(input[2] & 0x7f) << 25) |
			((uint32_t)input[3] << 17) |
			((uint32_t)(input[4] & 0x80) << 9);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 33 to 48
	value = ((uint32_t)(input[4] & 0x7f) << 25) |
			((uint32_t)input[5] << 17) |
			((uint32_t)(input[6] & 0x80) << 9);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 49 to 64
	value = ((uint32_t)(input[6] & 0x7f) << 25) |
			((uint32_t)input[7] << 17) |
			((uint32_t)(input[8] & 0x80) << 9);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 65 to 80
	value = ((uint32_t)(input[8] & 0x7f) << 25) |
			((uint32_t)input[9] << 17) |
			((uint32_t)(input[10] & 0x80) << 9);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 81 to 96
	value = ((uint32_t)(input[10] & 0x7f) << 25) |
			((uint32_t)input[11] << 17) |
			((uint32_t)(input[12] & 0x80) << 9);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 97 to 112
	value = ((uint32_t)(input[12] & 0x7f) << 25) |
			((uint32_t)input[13] << 17) |
			((uint32_t)(input[14] & 0x80) << 9);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 113 to 128
	value = ((uint32_t)(input[14] & 0x7f) << 25) |
			((uint32_t)input[15] << 17) |
			((uint32_t)(input[16] & 0x80) << 9);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 129 to 144
	value = ((uint32_t)(input[16] & 0x7f) << 25) |
			((uint32_t)input[17] << 17) |
			((uint32_t)(input[18] & 0x80) << 9);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 145 to 160
	value = ((uint32_t)(input[18] & 0x7f) << 25) |
			((uint32_t)input[19] << 17) |
			((uint32_t)(input[20] & 0x80) << 9);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 161 to 176
	value = ((uint32_t)(input[20] & 0x7f) << 25) |
			((uint32_t)input[21] << 17) |
			((uint32_t)(input[22] & 0x80) << 9);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 177 to 192
	value = ((uint32_t)(input[22] & 0x7f) << 25) |
			((uint32_t)input[23] << 17) |
			((uint32_t)(input[24] & 0x80) << 9);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 193 to 208
	value = ((uint32_t)(input[24] & 0x7f) << 25) |
			((uint32_t)input[25] << 17) |
			((uint32_t)(input[26] & 0x80) << 9);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 209 to 224
	value = ((uint32_t)(input[26] & 0x7f) << 25) |
			((uint32_t)input[27] << 17) |
			((uint32_t)(input[28] & 0x80) << 9);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 225 to 240
	value = ((uint32_t)(input[28] & 0x7f) << 25) |
			((uint32_t)input[29] << 17) |
			((uint32_t)(input[30] & 0x80) << 9);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 241 to 256
	value = ((uint32_t)(input[30] & 0x7f) << 25) |
			((uint32_t)input[31] << 17) |
			((uint32_t)(input[32] & 0x80) << 9);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 257 to 272
	value = ((uint32_t)(input[32] & 0x7f) << 25) |
			((uint32_t)input[33] << 17) |
			((uint32_t)(input[34] & 0x80) << 9);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 273 to 288
	value = ((uint32_t)(input[34] & 0x7f) << 25) |
			((uint32_t)input[35] << 17) |
			((uint32_t)(input[36] & 0x80) << 9);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 289 to 304
	value = ((uint32_t)(input[36] & 0x7f) << 25) |
			((uint32_t)input[37] << 17) |
			((uint32_t)(input[38] & 0x80) << 9);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 305 to 320
	value = ((uint32_t)(input[38] & 0x7f) << 25) |
			((uint32_t)input[39] << 17) |
			((uint32_t)(input[40] & 0x80) << 9);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 321 to 336
	value = ((uint32_t)(input[40] & 0x7f) << 25) |
			((uint32_t)input[41] << 17) |
			((uint32_t)(input[42] & 0x80) << 9);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 337 to 352
	value = ((uint32_t)(input[42] & 0x7f) << 25) |
			((uint32_t)input[43] << 17) |
			((uint32_t)(input[44] & 0x80) << 9);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 353 to 368
	value = ((uint32_t)(input[44] & 0x7f) << 25) |
			((uint32_t)input[45] << 17) |
			((uint32_t)(input[46] & 0x80) << 9);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 369 to 384
	value = ((uint32_t)(input[46] & 0x7f) << 25) |
			((uint32_t)input[47] << 17) |
			((uint32_t)(input[48] & 0x80) << 9);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 385 to 400
	value = ((uint32_t)(input[48] & 0x7f) << 25) |
			((uint32_t)input[49] << 17) |
			((uint32_t)(input[50] & 0x80) << 9);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 401 to 416
	value = ((uint32_t)(input[50] & 0x7f) << 25) |
			((uint32_t)input[51] << 17) |
			((uint32_t)(input[52] & 0x80) << 9);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 417 to 432
	value = ((uint32_t)(input[52] & 0x7f) << 25) |
			((uint32_t)input[53] << 17) |
			((uint32_t)(input[54] & 0x80) << 9);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 433 to 448
	value = ((uint32_t)(input[54] & 0x7f) << 25) |
			((uint32_t)input[55] << 17) |
			((uint32_t)(input[56] & 0x80) << 9);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 449 to 464
	value = ((uint32_t)(input[56] & 0x7f) << 25) |
			((uint32_t)input[57] << 17) |
			((uint32_t)(input[58] & 0x80) << 9);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 465 to 480
	value = ((uint32_t)(input[58] & 0x7f) << 25) |
			((uint32_t)input[59] << 17) |
			((uint32_t)(input[60] & 0x80) << 9);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 481 to 496
	value = ((uint32_t)(input[60] & 0x7f) << 25) |
			((uint32_t)input[61] << 17) |
			((uint32_t)(input[62] & 0x80) << 9);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 497 to 512
	value = ((uint32_t)(input[62] & 0x7f) << 25) |
			((uint32_t)input[63] << 17) |
			((uint32_t)(input[64] & 0x80) << 9);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 513 to 528
	value = ((uint32_t)(input[64] & 0x7f) << 25) |
			((uint32_t)input[65] << 17) |
			((uint32_t)(input[66] & 0x80) << 9);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 529 to 544
	value = ((uint32_t)(input[66] & 0x7f) << 25) |
			((uint32_t)input[67] << 17) |
			((uint32_t)(input[68] & 0x80) << 9);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 545 to 560
	value = ((uint32_t)(input[68] & 0x7f) << 25) |
			((uint32_t)input[69] << 17) |
			((uint32_t)(input[70] & 0x80) << 9);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 561 to 576
	value = ((uint32_t)(input[70] & 0x7f) << 25) |
			((uint32_t)input[71] << 17) |
			((uint32_t)(input[72] & 0x80) << 9);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 577 to 592
	value = ((uint32_t)(input[72] & 0x7f) << 25) |
			((uint32_t)input[73] << 17) |
			((uint32_t)(input[74] & 0x80) << 9);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 593 to 608
	value = ((uint32_t)(input[74] & 0x7f) << 25) |
			((uint32_t)input[75] << 17) |
			((uint32_t)(input[76] & 0x80) << 9);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 609 to 624
	value = ((uint32_t)(input[76] & 0x7f) << 25) |
			((uint32_t)input[77] << 17) |
			((uint32_t)(input[78] & 0x80) << 9);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 625 to 640
	value = ((uint32_t)(input[78] & 0x7f) << 25) |
			((uint32_t)input[79] << 17) |
			((uint32_t)(input[80] & 0x80) << 9);
	output[39] = (double)(value >> 16);

	// read output[40]: from bit 641 to 656
	value = ((uint32_t)(input[80] & 0x7f) << 25) |
			((uint32_t)input[81] << 17) |
			((uint32_t)(input[82] & 0x80) << 9);
	output[40] = (double)(value >> 16);

	// read output[41]: from bit 657 to 672
	value = ((uint32_t)(input[82] & 0x7f) << 25) |
			((uint32_t)input[83] << 17) |
			((uint32_t)(input[84] & 0x80) << 9);
	output[41] = (double)(value >> 16);

	// read output[42]: from bit 673 to 688
	value = ((uint32_t)(input[84] & 0x7f) << 25) |
			((uint32_t)input[85] << 17) |
			((uint32_t)(input[86] & 0x80) << 9);
	output[42] = (double)(value >> 16);

	// read output[43]: from bit 689 to 704
	value = ((uint32_t)(input[86] & 0x7f) << 25) |
			((uint32_t)input[87] << 17) |
			((uint32_t)(input[88] & 0x80) << 9);
	output[43] = (double)(value >> 16);

	// read output[44]: from bit 705 to 720
	value = ((uint32_t)(input[88] & 0x7f) << 25) |
			((uint32_t)input[89] << 17) |
			((uint32_t)(input[90] & 0x80) << 9);
	output[44] = (double)(value >> 16);

	// read output[45]: from bit 721 to 736
	value = ((uint32_t)(input[90] & 0x7f) << 25) |
			((uint32_t)input[91] << 17) |
			((uint32_t)(input[92] & 0x80) << 9);
	output[45] = (double)(value >> 16);

	// read output[46]: from bit 737 to 752
	value = ((uint32_t)(input[92] & 0x7f) << 25) |
			((uint32_t)input[93] << 17) |
			((uint32_t)(input[94] & 0x80) << 9);
	output[46] = (double)(value >> 16);

	// read output[47]: from bit 753 to 768
	value = ((uint32_t)(input[94] & 0x7f) << 25) |
			((uint32_t)input[95] << 17) |
			((uint32_t)(input[96] & 0x80) << 9);
	output[47] = (double)(value >> 16);

	// read output[48]: from bit 769 to 784
	value = ((uint32_t)(input[96] & 0x7f) << 25) |
			((uint32_t)input[97] << 17) |
			((uint32_t)(input[98] & 0x80) << 9);
	output[48] = (double)(value >> 16);

	// read output[49]: from bit 785 to 800
	value = ((uint32_t)(input[98] & 0x7f) << 25) |
			((uint32_t)input[99] << 17) |
			((uint32_t)(input[100] & 0x80) << 9);
	output[49] = (double)(value >> 16);

	// read output[50]: from bit 801 to 816
	value = ((uint32_t)(input[100] & 0x7f) << 25) |
			((uint32_t)input[101] << 17) |
			((uint32_t)(input[102] & 0x80) << 9);
	output[50] = (double)(value >> 16);

	// read output[51]: from bit 817 to 832
	value = ((uint32_t)(input[102] & 0x7f) << 25) |
			((uint32_t)input[103] << 17) |
			((uint32_t)(input[104] & 0x80) << 9);
	output[51] = (double)(value >> 16);

	// read output[52]: from bit 833 to 848
	value = ((uint32_t)(input[104] & 0x7f) << 25) |
			((uint32_t)input[105] << 17) |
			((uint32_t)(input[106] & 0x80) << 9);
	output[52] = (double)(value >> 16);

	// read output[53]: from bit 849 to 864
	value = ((uint32_t)(input[106] & 0x7f) << 25) |
			((uint32_t)input[107] << 17) |
			((uint32_t)(input[108] & 0x80) << 9);
	output[53] = (double)(value >> 16);

	// read output[54]: from bit 865 to 880
	value = ((uint32_t)(input[108] & 0x7f) << 25) |
			((uint32_t)input[109] << 17) |
			((uint32_t)(input[110] & 0x80) << 9);
	output[54] = (double)(value >> 16);

	// read output[55]: from bit 881 to 896
	value = ((uint32_t)(input[110] & 0x7f) << 25) |
			((uint32_t)input[111] << 17) |
			((uint32_t)(input[112] & 0x80) << 9);
	output[55] = (double)(value >> 16);

	// read output[56]: from bit 897 to 912
	value = ((uint32_t)(input[112] & 0x7f) << 25) |
			((uint32_t)input[113] << 17) |
			((uint32_t)(input[114] & 0x80) << 9);
	output[56] = (double)(value >> 16);

	// read output[57]: from bit 913 to 928
	value = ((uint32_t)(input[114] & 0x7f) << 25) |
			((uint32_t)input[115] << 17) |
			((uint32_t)(input[116] & 0x80) << 9);
	output[57] = (double)(value >> 16);

	// read output[58]: from bit 929 to 944
	value = ((uint32_t)(input[116] & 0x7f) << 25) |
			((uint32_t)input[117] << 17) |
			((uint32_t)(input[118] & 0x80) << 9);
	output[58] = (double)(value >> 16);

	// read output[59]: from bit 945 to 960
	value = ((uint32_t)(input[118] & 0x7f) << 25) |
			((uint32_t)input[119] << 17) |
			((uint32_t)(input[120] & 0x80) << 9);
	output[59] = (double)(value >> 16);

	// read output[60]: from bit 961 to 976
	value = ((uint32_t)(input[120] & 0x7f) << 25) |
			((uint32_t)input[121] << 17) |
			((uint32_t)(input[122] & 0x80) << 9);
	output[60] = (double)(value >> 16);

	// read output[61]: from bit 977 to 992
	value = ((uint32_t)(input[122] & 0x7f) << 25) |
			((uint32_t)input[123] << 17) |
			((uint32_t)(input[124] & 0x80) << 9);
	output[61] = (double)(value >> 16);

	// read output[62]: from bit 993 to 1008
	value = ((uint32_t)(input[124] & 0x7f) << 25) |
			((uint32_t)input[125] << 17) |
			((uint32_t)(input[126] & 0x80) << 9);
	output[62] = (double)(value >> 16);

	// read output[63]: from bit 1009 to 1024
	value = ((uint32_t)(input[126] & 0x7f) << 25) |
			((uint32_t)input[127] << 17) |
			((uint32_t)(input[128] & 0x80) << 9);
	output[63] = (double)(value >> 16);
}

static void unpack_64_16bit_signed_2off(const uint8_t * input, double * output, void *closure) {
	// Unpack 64 values into output
	// Values are 16-bit signed
	// Skip 2 bits, read 1024 bits of data.
	// Input must be at least 129 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 2 to 17
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)input[1] << 18) |
			((uint32_t)(input[2] & 0xc0) << 10);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 18 to 33
	value = ((uint32_t)(input[2] & 0x3f) << 26) |
			((uint32_t)input[3] << 18) |
			((uint32_t)(input[4] & 0xc0) << 10);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 34 to 49
	value = ((uint32_t)(input[4] & 0x3f) << 26) |
			((uint32_t)input[5] << 18) |
			((uint32_t)(input[6] & 0xc0) << 10);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 50 to 65
	value = ((uint32_t)(input[6] & 0x3f) << 26) |
			((uint32_t)input[7] << 18) |
			((uint32_t)(input[8] & 0xc0) << 10);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 66 to 81
	value = ((uint32_t)(input[8] & 0x3f) << 26) |
			((uint32_t)input[9] << 18) |
			((uint32_t)(input[10] & 0xc0) << 10);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 82 to 97
	value = ((uint32_t)(input[10] & 0x3f) << 26) |
			((uint32_t)input[11] << 18) |
			((uint32_t)(input[12] & 0xc0) << 10);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 98 to 113
	value = ((uint32_t)(input[12] & 0x3f) << 26) |
			((uint32_t)input[13] << 18) |
			((uint32_t)(input[14] & 0xc0) << 10);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 114 to 129
	value = ((uint32_t)(input[14] & 0x3f) << 26) |
			((uint32_t)input[15] << 18) |
			((uint32_t)(input[16] & 0xc0) << 10);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 130 to 145
	value = ((uint32_t)(input[16] & 0x3f) << 26) |
			((uint32_t)input[17] << 18) |
			((uint32_t)(input[18] & 0xc0) << 10);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 146 to 161
	value = ((uint32_t)(input[18] & 0x3f) << 26) |
			((uint32_t)input[19] << 18) |
			((uint32_t)(input[20] & 0xc0) << 10);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 162 to 177
	value = ((uint32_t)(input[20] & 0x3f) << 26) |
			((uint32_t)input[21] << 18) |
			((uint32_t)(input[22] & 0xc0) << 10);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 178 to 193
	value = ((uint32_t)(input[22] & 0x3f) << 26) |
			((uint32_t)input[23] << 18) |
			((uint32_t)(input[24] & 0xc0) << 10);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 194 to 209
	value = ((uint32_t)(input[24] & 0x3f) << 26) |
			((uint32_t)input[25] << 18) |
			((uint32_t)(input[26] & 0xc0) << 10);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 210 to 225
	value = ((uint32_t)(input[26] & 0x3f) << 26) |
			((uint32_t)input[27] << 18) |
			((uint32_t)(input[28] & 0xc0) << 10);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 226 to 241
	value = ((uint32_t)(input[28] & 0x3f) << 26) |
			((uint32_t)input[29] << 18) |
			((uint32_t)(input[30] & 0xc0) << 10);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 242 to 257
	value = ((uint32_t)(input[30] & 0x3f) << 26) |
			((uint32_t)input[31] << 18) |
			((uint32_t)(input[32] & 0xc0) << 10);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 258 to 273
	value = ((uint32_t)(input[32] & 0x3f) << 26) |
			((uint32_t)input[33] << 18) |
			((uint32_t)(input[34] & 0xc0) << 10);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 274 to 289
	value = ((uint32_t)(input[34] & 0x3f) << 26) |
			((uint32_t)input[35] << 18) |
			((uint32_t)(input[36] & 0xc0) << 10);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 290 to 305
	value = ((uint32_t)(input[36] & 0x3f) << 26) |
			((uint32_t)input[37] << 18) |
			((uint32_t)(input[38] & 0xc0) << 10);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 306 to 321
	value = ((uint32_t)(input[38] & 0x3f) << 26) |
			((uint32_t)input[39] << 18) |
			((uint32_t)(input[40] & 0xc0) << 10);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 322 to 337
	value = ((uint32_t)(input[40] & 0x3f) << 26) |
			((uint32_t)input[41] << 18) |
			((uint32_t)(input[42] & 0xc0) << 10);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 338 to 353
	value = ((uint32_t)(input[42] & 0x3f) << 26) |
			((uint32_t)input[43] << 18) |
			((uint32_t)(input[44] & 0xc0) << 10);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 354 to 369
	value = ((uint32_t)(input[44] & 0x3f) << 26) |
			((uint32_t)input[45] << 18) |
			((uint32_t)(input[46] & 0xc0) << 10);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 370 to 385
	value = ((uint32_t)(input[46] & 0x3f) << 26) |
			((uint32_t)input[47] << 18) |
			((uint32_t)(input[48] & 0xc0) << 10);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 386 to 401
	value = ((uint32_t)(input[48] & 0x3f) << 26) |
			((uint32_t)input[49] << 18) |
			((uint32_t)(input[50] & 0xc0) << 10);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 402 to 417
	value = ((uint32_t)(input[50] & 0x3f) << 26) |
			((uint32_t)input[51] << 18) |
			((uint32_t)(input[52] & 0xc0) << 10);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 418 to 433
	value = ((uint32_t)(input[52] & 0x3f) << 26) |
			((uint32_t)input[53] << 18) |
			((uint32_t)(input[54] & 0xc0) << 10);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 434 to 449
	value = ((uint32_t)(input[54] & 0x3f) << 26) |
			((uint32_t)input[55] << 18) |
			((uint32_t)(input[56] & 0xc0) << 10);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 450 to 465
	value = ((uint32_t)(input[56] & 0x3f) << 26) |
			((uint32_t)input[57] << 18) |
			((uint32_t)(input[58] & 0xc0) << 10);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 466 to 481
	value = ((uint32_t)(input[58] & 0x3f) << 26) |
			((uint32_t)input[59] << 18) |
			((uint32_t)(input[60] & 0xc0) << 10);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 482 to 497
	value = ((uint32_t)(input[60] & 0x3f) << 26) |
			((uint32_t)input[61] << 18) |
			((uint32_t)(input[62] & 0xc0) << 10);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 498 to 513
	value = ((uint32_t)(input[62] & 0x3f) << 26) |
			((uint32_t)input[63] << 18) |
			((uint32_t)(input[64] & 0xc0) << 10);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 514 to 529
	value = ((uint32_t)(input[64] & 0x3f) << 26) |
			((uint32_t)input[65] << 18) |
			((uint32_t)(input[66] & 0xc0) << 10);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 530 to 545
	value = ((uint32_t)(input[66] & 0x3f) << 26) |
			((uint32_t)input[67] << 18) |
			((uint32_t)(input[68] & 0xc0) << 10);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 546 to 561
	value = ((uint32_t)(input[68] & 0x3f) << 26) |
			((uint32_t)input[69] << 18) |
			((uint32_t)(input[70] & 0xc0) << 10);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 562 to 577
	value = ((uint32_t)(input[70] & 0x3f) << 26) |
			((uint32_t)input[71] << 18) |
			((uint32_t)(input[72] & 0xc0) << 10);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 578 to 593
	value = ((uint32_t)(input[72] & 0x3f) << 26) |
			((uint32_t)input[73] << 18) |
			((uint32_t)(input[74] & 0xc0) << 10);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 594 to 609
	value = ((uint32_t)(input[74] & 0x3f) << 26) |
			((uint32_t)input[75] << 18) |
			((uint32_t)(input[76] & 0xc0) << 10);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 610 to 625
	value = ((uint32_t)(input[76] & 0x3f) << 26) |
			((uint32_t)input[77] << 18) |
			((uint32_t)(input[78] & 0xc0) << 10);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 626 to 641
	value = ((uint32_t)(input[78] & 0x3f) << 26) |
			((uint32_t)input[79] << 18) |
			((uint32_t)(input[80] & 0xc0) << 10);
	output[39] = (double)(value >> 16);

	// read output[40]: from bit 642 to 657
	value = ((uint32_t)(input[80] & 0x3f) << 26) |
			((uint32_t)input[81] << 18) |
			((uint32_t)(input[82] & 0xc0) << 10);
	output[40] = (double)(value >> 16);

	// read output[41]: from bit 658 to 673
	value = ((uint32_t)(input[82] & 0x3f) << 26) |
			((uint32_t)input[83] << 18) |
			((uint32_t)(input[84] & 0xc0) << 10);
	output[41] = (double)(value >> 16);

	// read output[42]: from bit 674 to 689
	value = ((uint32_t)(input[84] & 0x3f) << 26) |
			((uint32_t)input[85] << 18) |
			((uint32_t)(input[86] & 0xc0) << 10);
	output[42] = (double)(value >> 16);

	// read output[43]: from bit 690 to 705
	value = ((uint32_t)(input[86] & 0x3f) << 26) |
			((uint32_t)input[87] << 18) |
			((uint32_t)(input[88] & 0xc0) << 10);
	output[43] = (double)(value >> 16);

	// read output[44]: from bit 706 to 721
	value = ((uint32_t)(input[88] & 0x3f) << 26) |
			((uint32_t)input[89] << 18) |
			((uint32_t)(input[90] & 0xc0) << 10);
	output[44] = (double)(value >> 16);

	// read output[45]: from bit 722 to 737
	value = ((uint32_t)(input[90] & 0x3f) << 26) |
			((uint32_t)input[91] << 18) |
			((uint32_t)(input[92] & 0xc0) << 10);
	output[45] = (double)(value >> 16);

	// read output[46]: from bit 738 to 753
	value = ((uint32_t)(input[92] & 0x3f) << 26) |
			((uint32_t)input[93] << 18) |
			((uint32_t)(input[94] & 0xc0) << 10);
	output[46] = (double)(value >> 16);

	// read output[47]: from bit 754 to 769
	value = ((uint32_t)(input[94] & 0x3f) << 26) |
			((uint32_t)input[95] << 18) |
			((uint32_t)(input[96] & 0xc0) << 10);
	output[47] = (double)(value >> 16);

	// read output[48]: from bit 770 to 785
	value = ((uint32_t)(input[96] & 0x3f) << 26) |
			((uint32_t)input[97] << 18) |
			((uint32_t)(input[98] & 0xc0) << 10);
	output[48] = (double)(value >> 16);

	// read output[49]: from bit 786 to 801
	value = ((uint32_t)(input[98] & 0x3f) << 26) |
			((uint32_t)input[99] << 18) |
			((uint32_t)(input[100] & 0xc0) << 10);
	output[49] = (double)(value >> 16);

	// read output[50]: from bit 802 to 817
	value = ((uint32_t)(input[100] & 0x3f) << 26) |
			((uint32_t)input[101] << 18) |
			((uint32_t)(input[102] & 0xc0) << 10);
	output[50] = (double)(value >> 16);

	// read output[51]: from bit 818 to 833
	value = ((uint32_t)(input[102] & 0x3f) << 26) |
			((uint32_t)input[103] << 18) |
			((uint32_t)(input[104] & 0xc0) << 10);
	output[51] = (double)(value >> 16);

	// read output[52]: from bit 834 to 849
	value = ((uint32_t)(input[104] & 0x3f) << 26) |
			((uint32_t)input[105] << 18) |
			((uint32_t)(input[106] & 0xc0) << 10);
	output[52] = (double)(value >> 16);

	// read output[53]: from bit 850 to 865
	value = ((uint32_t)(input[106] & 0x3f) << 26) |
			((uint32_t)input[107] << 18) |
			((uint32_t)(input[108] & 0xc0) << 10);
	output[53] = (double)(value >> 16);

	// read output[54]: from bit 866 to 881
	value = ((uint32_t)(input[108] & 0x3f) << 26) |
			((uint32_t)input[109] << 18) |
			((uint32_t)(input[110] & 0xc0) << 10);
	output[54] = (double)(value >> 16);

	// read output[55]: from bit 882 to 897
	value = ((uint32_t)(input[110] & 0x3f) << 26) |
			((uint32_t)input[111] << 18) |
			((uint32_t)(input[112] & 0xc0) << 10);
	output[55] = (double)(value >> 16);

	// read output[56]: from bit 898 to 913
	value = ((uint32_t)(input[112] & 0x3f) << 26) |
			((uint32_t)input[113] << 18) |
			((uint32_t)(input[114] & 0xc0) << 10);
	output[56] = (double)(value >> 16);

	// read output[57]: from bit 914 to 929
	value = ((uint32_t)(input[114] & 0x3f) << 26) |
			((uint32_t)input[115] << 18) |
			((uint32_t)(input[116] & 0xc0) << 10);
	output[57] = (double)(value >> 16);

	// read output[58]: from bit 930 to 945
	value = ((uint32_t)(input[116] & 0x3f) << 26) |
			((uint32_t)input[117] << 18) |
			((uint32_t)(input[118] & 0xc0) << 10);
	output[58] = (double)(value >> 16);

	// read output[59]: from bit 946 to 961
	value = ((uint32_t)(input[118] & 0x3f) << 26) |
			((uint32_t)input[119] << 18) |
			((uint32_t)(input[120] & 0xc0) << 10);
	output[59] = (double)(value >> 16);

	// read output[60]: from bit 962 to 977
	value = ((uint32_t)(input[120] & 0x3f) << 26) |
			((uint32_t)input[121] << 18) |
			((uint32_t)(input[122] & 0xc0) << 10);
	output[60] = (double)(value >> 16);

	// read output[61]: from bit 978 to 993
	value = ((uint32_t)(input[122] & 0x3f) << 26) |
			((uint32_t)input[123] << 18) |
			((uint32_t)(input[124] & 0xc0) << 10);
	output[61] = (double)(value >> 16);

	// read output[62]: from bit 994 to 1009
	value = ((uint32_t)(input[124] & 0x3f) << 26) |
			((uint32_t)input[125] << 18) |
			((uint32_t)(input[126] & 0xc0) << 10);
	output[62] = (double)(value >> 16);

	// read output[63]: from bit 1010 to 1025
	value = ((uint32_t)(input[126] & 0x3f) << 26) |
			((uint32_t)input[127] << 18) |
			((uint32_t)(input[128] & 0xc0) << 10);
	output[63] = (double)(value >> 16);
}

static void unpack_64_16bit_unsigned_2off(const uint8_t * input, double * output, void *closure) {
	// Unpack 64 values into output
	// Values are 16-bit unsigned
	// Skip 2 bits, read 1024 bits of data.
	// Input must be at least 129 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 2 to 17
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)input[1] << 18) |
			((uint32_t)(input[2] & 0xc0) << 10);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 18 to 33
	value = ((uint32_t)(input[2] & 0x3f) << 26) |
			((uint32_t)input[3] << 18) |
			((uint32_t)(input[4] & 0xc0) << 10);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 34 to 49
	value = ((uint32_t)(input[4] & 0x3f) << 26) |
			((uint32_t)input[5] << 18) |
			((uint32_t)(input[6] & 0xc0) << 10);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 50 to 65
	value = ((uint32_t)(input[6] & 0x3f) << 26) |
			((uint32_t)input[7] << 18) |
			((uint32_t)(input[8] & 0xc0) << 10);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 66 to 81
	value = ((uint32_t)(input[8] & 0x3f) << 26) |
			((uint32_t)input[9] << 18) |
			((uint32_t)(input[10] & 0xc0) << 10);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 82 to 97
	value = ((uint32_t)(input[10] & 0x3f) << 26) |
			((uint32_t)input[11] << 18) |
			((uint32_t)(input[12] & 0xc0) << 10);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 98 to 113
	value = ((uint32_t)(input[12] & 0x3f) << 26) |
			((uint32_t)input[13] << 18) |
			((uint32_t)(input[14] & 0xc0) << 10);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 114 to 129
	value = ((uint32_t)(input[14] & 0x3f) << 26) |
			((uint32_t)input[15] << 18) |
			((uint32_t)(input[16] & 0xc0) << 10);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 130 to 145
	value = ((uint32_t)(input[16] & 0x3f) << 26) |
			((uint32_t)input[17] << 18) |
			((uint32_t)(input[18] & 0xc0) << 10);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 146 to 161
	value = ((uint32_t)(input[18] & 0x3f) << 26) |
			((uint32_t)input[19] << 18) |
			((uint32_t)(input[20] & 0xc0) << 10);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 162 to 177
	value = ((uint32_t)(input[20] & 0x3f) << 26) |
			((uint32_t)input[21] << 18) |
			((uint32_t)(input[22] & 0xc0) << 10);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 178 to 193
	value = ((uint32_t)(input[22] & 0x3f) << 26) |
			((uint32_t)input[23] << 18) |
			((uint32_t)(input[24] & 0xc0) << 10);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 194 to 209
	value = ((uint32_t)(input[24] & 0x3f) << 26) |
			((uint32_t)input[25] << 18) |
			((uint32_t)(input[26] & 0xc0) << 10);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 210 to 225
	value = ((uint32_t)(input[26] & 0x3f) << 26) |
			((uint32_t)input[27] << 18) |
			((uint32_t)(input[28] & 0xc0) << 10);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 226 to 241
	value = ((uint32_t)(input[28] & 0x3f) << 26) |
			((uint32_t)input[29] << 18) |
			((uint32_t)(input[30] & 0xc0) << 10);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 242 to 257
	value = ((uint32_t)(input[30] & 0x3f) << 26) |
			((uint32_t)input[31] << 18) |
			((uint32_t)(input[32] & 0xc0) << 10);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 258 to 273
	value = ((uint32_t)(input[32] & 0x3f) << 26) |
			((uint32_t)input[33] << 18) |
			((uint32_t)(input[34] & 0xc0) << 10);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 274 to 289
	value = ((uint32_t)(input[34] & 0x3f) << 26) |
			((uint32_t)input[35] << 18) |
			((uint32_t)(input[36] & 0xc0) << 10);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 290 to 305
	value = ((uint32_t)(input[36] & 0x3f) << 26) |
			((uint32_t)input[37] << 18) |
			((uint32_t)(input[38] & 0xc0) << 10);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 306 to 321
	value = ((uint32_t)(input[38] & 0x3f) << 26) |
			((uint32_t)input[39] << 18) |
			((uint32_t)(input[40] & 0xc0) << 10);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 322 to 337
	value = ((uint32_t)(input[40] & 0x3f) << 26) |
			((uint32_t)input[41] << 18) |
			((uint32_t)(input[42] & 0xc0) << 10);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 338 to 353
	value = ((uint32_t)(input[42] & 0x3f) << 26) |
			((uint32_t)input[43] << 18) |
			((uint32_t)(input[44] & 0xc0) << 10);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 354 to 369
	value = ((uint32_t)(input[44] & 0x3f) << 26) |
			((uint32_t)input[45] << 18) |
			((uint32_t)(input[46] & 0xc0) << 10);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 370 to 385
	value = ((uint32_t)(input[46] & 0x3f) << 26) |
			((uint32_t)input[47] << 18) |
			((uint32_t)(input[48] & 0xc0) << 10);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 386 to 401
	value = ((uint32_t)(input[48] & 0x3f) << 26) |
			((uint32_t)input[49] << 18) |
			((uint32_t)(input[50] & 0xc0) << 10);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 402 to 417
	value = ((uint32_t)(input[50] & 0x3f) << 26) |
			((uint32_t)input[51] << 18) |
			((uint32_t)(input[52] & 0xc0) << 10);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 418 to 433
	value = ((uint32_t)(input[52] & 0x3f) << 26) |
			((uint32_t)input[53] << 18) |
			((uint32_t)(input[54] & 0xc0) << 10);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 434 to 449
	value = ((uint32_t)(input[54] & 0x3f) << 26) |
			((uint32_t)input[55] << 18) |
			((uint32_t)(input[56] & 0xc0) << 10);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 450 to 465
	value = ((uint32_t)(input[56] & 0x3f) << 26) |
			((uint32_t)input[57] << 18) |
			((uint32_t)(input[58] & 0xc0) << 10);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 466 to 481
	value = ((uint32_t)(input[58] & 0x3f) << 26) |
			((uint32_t)input[59] << 18) |
			((uint32_t)(input[60] & 0xc0) << 10);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 482 to 497
	value = ((uint32_t)(input[60] & 0x3f) << 26) |
			((uint32_t)input[61] << 18) |
			((uint32_t)(input[62] & 0xc0) << 10);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 498 to 513
	value = ((uint32_t)(input[62] & 0x3f) << 26) |
			((uint32_t)input[63] << 18) |
			((uint32_t)(input[64] & 0xc0) << 10);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 514 to 529
	value = ((uint32_t)(input[64] & 0x3f) << 26) |
			((uint32_t)input[65] << 18) |
			((uint32_t)(input[66] & 0xc0) << 10);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 530 to 545
	value = ((uint32_t)(input[66] & 0x3f) << 26) |
			((uint32_t)input[67] << 18) |
			((uint32_t)(input[68] & 0xc0) << 10);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 546 to 561
	value = ((uint32_t)(input[68] & 0x3f) << 26) |
			((uint32_t)input[69] << 18) |
			((uint32_t)(input[70] & 0xc0) << 10);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 562 to 577
	value = ((uint32_t)(input[70] & 0x3f) << 26) |
			((uint32_t)input[71] << 18) |
			((uint32_t)(input[72] & 0xc0) << 10);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 578 to 593
	value = ((uint32_t)(input[72] & 0x3f) << 26) |
			((uint32_t)input[73] << 18) |
			((uint32_t)(input[74] & 0xc0) << 10);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 594 to 609
	value = ((uint32_t)(input[74] & 0x3f) << 26) |
			((uint32_t)input[75] << 18) |
			((uint32_t)(input[76] & 0xc0) << 10);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 610 to 625
	value = ((uint32_t)(input[76] & 0x3f) << 26) |
			((uint32_t)input[77] << 18) |
			((uint32_t)(input[78] & 0xc0) << 10);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 626 to 641
	value = ((uint32_t)(input[78] & 0x3f) << 26) |
			((uint32_t)input[79] << 18) |
			((uint32_t)(input[80] & 0xc0) << 10);
	output[39] = (double)(value >> 16);

	// read output[40]: from bit 642 to 657
	value = ((uint32_t)(input[80] & 0x3f) << 26) |
			((uint32_t)input[81] << 18) |
			((uint32_t)(input[82] & 0xc0) << 10);
	output[40] = (double)(value >> 16);

	// read output[41]: from bit 658 to 673
	value = ((uint32_t)(input[82] & 0x3f) << 26) |
			((uint32_t)input[83] << 18) |
			((uint32_t)(input[84] & 0xc0) << 10);
	output[41] = (double)(value >> 16);

	// read output[42]: from bit 674 to 689
	value = ((uint32_t)(input[84] & 0x3f) << 26) |
			((uint32_t)input[85] << 18) |
			((uint32_t)(input[86] & 0xc0) << 10);
	output[42] = (double)(value >> 16);

	// read output[43]: from bit 690 to 705
	value = ((uint32_t)(input[86] & 0x3f) << 26) |
			((uint32_t)input[87] << 18) |
			((uint32_t)(input[88] & 0xc0) << 10);
	output[43] = (double)(value >> 16);

	// read output[44]: from bit 706 to 721
	value = ((uint32_t)(input[88] & 0x3f) << 26) |
			((uint32_t)input[89] << 18) |
			((uint32_t)(input[90] & 0xc0) << 10);
	output[44] = (double)(value >> 16);

	// read output[45]: from bit 722 to 737
	value = ((uint32_t)(input[90] & 0x3f) << 26) |
			((uint32_t)input[91] << 18) |
			((uint32_t)(input[92] & 0xc0) << 10);
	output[45] = (double)(value >> 16);

	// read output[46]: from bit 738 to 753
	value = ((uint32_t)(input[92] & 0x3f) << 26) |
			((uint32_t)input[93] << 18) |
			((uint32_t)(input[94] & 0xc0) << 10);
	output[46] = (double)(value >> 16);

	// read output[47]: from bit 754 to 769
	value = ((uint32_t)(input[94] & 0x3f) << 26) |
			((uint32_t)input[95] << 18) |
			((uint32_t)(input[96] & 0xc0) << 10);
	output[47] = (double)(value >> 16);

	// read output[48]: from bit 770 to 785
	value = ((uint32_t)(input[96] & 0x3f) << 26) |
			((uint32_t)input[97] << 18) |
			((uint32_t)(input[98] & 0xc0) << 10);
	output[48] = (double)(value >> 16);

	// read output[49]: from bit 786 to 801
	value = ((uint32_t)(input[98] & 0x3f) << 26) |
			((uint32_t)input[99] << 18) |
			((uint32_t)(input[100] & 0xc0) << 10);
	output[49] = (double)(value >> 16);

	// read output[50]: from bit 802 to 817
	value = ((uint32_t)(input[100] & 0x3f) << 26) |
			((uint32_t)input[101] << 18) |
			((uint32_t)(input[102] & 0xc0) << 10);
	output[50] = (double)(value >> 16);

	// read output[51]: from bit 818 to 833
	value = ((uint32_t)(input[102] & 0x3f) << 26) |
			((uint32_t)input[103] << 18) |
			((uint32_t)(input[104] & 0xc0) << 10);
	output[51] = (double)(value >> 16);

	// read output[52]: from bit 834 to 849
	value = ((uint32_t)(input[104] & 0x3f) << 26) |
			((uint32_t)input[105] << 18) |
			((uint32_t)(input[106] & 0xc0) << 10);
	output[52] = (double)(value >> 16);

	// read output[53]: from bit 850 to 865
	value = ((uint32_t)(input[106] & 0x3f) << 26) |
			((uint32_t)input[107] << 18) |
			((uint32_t)(input[108] & 0xc0) << 10);
	output[53] = (double)(value >> 16);

	// read output[54]: from bit 866 to 881
	value = ((uint32_t)(input[108] & 0x3f) << 26) |
			((uint32_t)input[109] << 18) |
			((uint32_t)(input[110] & 0xc0) << 10);
	output[54] = (double)(value >> 16);

	// read output[55]: from bit 882 to 897
	value = ((uint32_t)(input[110] & 0x3f) << 26) |
			((uint32_t)input[111] << 18) |
			((uint32_t)(input[112] & 0xc0) << 10);
	output[55] = (double)(value >> 16);

	// read output[56]: from bit 898 to 913
	value = ((uint32_t)(input[112] & 0x3f) << 26) |
			((uint32_t)input[113] << 18) |
			((uint32_t)(input[114] & 0xc0) << 10);
	output[56] = (double)(value >> 16);

	// read output[57]: from bit 914 to 929
	value = ((uint32_t)(input[114] & 0x3f) << 26) |
			((uint32_t)input[115] << 18) |
			((uint32_t)(input[116] & 0xc0) << 10);
	output[57] = (double)(value >> 16);

	// read output[58]: from bit 930 to 945
	value = ((uint32_t)(input[116] & 0x3f) << 26) |
			((uint32_t)input[117] << 18) |
			((uint32_t)(input[118] & 0xc0) << 10);
	output[58] = (double)(value >> 16);

	// read output[59]: from bit 946 to 961
	value = ((uint32_t)(input[118] & 0x3f) << 26) |
			((uint32_t)input[119] << 18) |
			((uint32_t)(input[120] & 0xc0) << 10);
	output[59] = (double)(value >> 16);

	// read output[60]: from bit 962 to 977
	value = ((uint32_t)(input[120] & 0x3f) << 26) |
			((uint32_t)input[121] << 18) |
			((uint32_t)(input[122] & 0xc0) << 10);
	output[60] = (double)(value >> 16);

	// read output[61]: from bit 978 to 993
	value = ((uint32_t)(input[122] & 0x3f) << 26) |
			((uint32_t)input[123] << 18) |
			((uint32_t)(input[124] & 0xc0) << 10);
	output[61] = (double)(value >> 16);

	// read output[62]: from bit 994 to 1009
	value = ((uint32_t)(input[124] & 0x3f) << 26) |
			((uint32_t)input[125] << 18) |
			((uint32_t)(input[126] & 0xc0) << 10);
	output[62] = (double)(value >> 16);

	// read output[63]: from bit 1010 to 1025
	value = ((uint32_t)(input[126] & 0x3f) << 26) |
			((uint32_t)input[127] << 18) |
			((uint32_t)(input[128] & 0xc0) << 10);
	output[63] = (double)(value >> 16);
}

static void unpack_64_16bit_signed_3off(const uint8_t * input, double * output, void *closure) {
	// Unpack 64 values into output
	// Values are 16-bit signed
	// Skip 3 bits, read 1024 bits of data.
	// Input must be at least 129 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 3 to 18
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)input[1] << 19) |
			((uint32_t)(input[2] & 0xe0) << 11);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 19 to 34
	value = ((uint32_t)(input[2] & 0x1f) << 27) |
			((uint32_t)input[3] << 19) |
			((uint32_t)(input[4] & 0xe0) << 11);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 35 to 50
	value = ((uint32_t)(input[4] & 0x1f) << 27) |
			((uint32_t)input[5] << 19) |
			((uint32_t)(input[6] & 0xe0) << 11);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 51 to 66
	value = ((uint32_t)(input[6] & 0x1f) << 27) |
			((uint32_t)input[7] << 19) |
			((uint32_t)(input[8] & 0xe0) << 11);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 67 to 82
	value = ((uint32_t)(input[8] & 0x1f) << 27) |
			((uint32_t)input[9] << 19) |
			((uint32_t)(input[10] & 0xe0) << 11);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 83 to 98
	value = ((uint32_t)(input[10] & 0x1f) << 27) |
			((uint32_t)input[11] << 19) |
			((uint32_t)(input[12] & 0xe0) << 11);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 99 to 114
	value = ((uint32_t)(input[12] & 0x1f) << 27) |
			((uint32_t)input[13] << 19) |
			((uint32_t)(input[14] & 0xe0) << 11);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 115 to 130
	value = ((uint32_t)(input[14] & 0x1f) << 27) |
			((uint32_t)input[15] << 19) |
			((uint32_t)(input[16] & 0xe0) << 11);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 131 to 146
	value = ((uint32_t)(input[16] & 0x1f) << 27) |
			((uint32_t)input[17] << 19) |
			((uint32_t)(input[18] & 0xe0) << 11);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 147 to 162
	value = ((uint32_t)(input[18] & 0x1f) << 27) |
			((uint32_t)input[19] << 19) |
			((uint32_t)(input[20] & 0xe0) << 11);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 163 to 178
	value = ((uint32_t)(input[20] & 0x1f) << 27) |
			((uint32_t)input[21] << 19) |
			((uint32_t)(input[22] & 0xe0) << 11);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 179 to 194
	value = ((uint32_t)(input[22] & 0x1f) << 27) |
			((uint32_t)input[23] << 19) |
			((uint32_t)(input[24] & 0xe0) << 11);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 195 to 210
	value = ((uint32_t)(input[24] & 0x1f) << 27) |
			((uint32_t)input[25] << 19) |
			((uint32_t)(input[26] & 0xe0) << 11);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 211 to 226
	value = ((uint32_t)(input[26] & 0x1f) << 27) |
			((uint32_t)input[27] << 19) |
			((uint32_t)(input[28] & 0xe0) << 11);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 227 to 242
	value = ((uint32_t)(input[28] & 0x1f) << 27) |
			((uint32_t)input[29] << 19) |
			((uint32_t)(input[30] & 0xe0) << 11);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 243 to 258
	value = ((uint32_t)(input[30] & 0x1f) << 27) |
			((uint32_t)input[31] << 19) |
			((uint32_t)(input[32] & 0xe0) << 11);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 259 to 274
	value = ((uint32_t)(input[32] & 0x1f) << 27) |
			((uint32_t)input[33] << 19) |
			((uint32_t)(input[34] & 0xe0) << 11);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 275 to 290
	value = ((uint32_t)(input[34] & 0x1f) << 27) |
			((uint32_t)input[35] << 19) |
			((uint32_t)(input[36] & 0xe0) << 11);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 291 to 306
	value = ((uint32_t)(input[36] & 0x1f) << 27) |
			((uint32_t)input[37] << 19) |
			((uint32_t)(input[38] & 0xe0) << 11);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 307 to 322
	value = ((uint32_t)(input[38] & 0x1f) << 27) |
			((uint32_t)input[39] << 19) |
			((uint32_t)(input[40] & 0xe0) << 11);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 323 to 338
	value = ((uint32_t)(input[40] & 0x1f) << 27) |
			((uint32_t)input[41] << 19) |
			((uint32_t)(input[42] & 0xe0) << 11);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 339 to 354
	value = ((uint32_t)(input[42] & 0x1f) << 27) |
			((uint32_t)input[43] << 19) |
			((uint32_t)(input[44] & 0xe0) << 11);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 355 to 370
	value = ((uint32_t)(input[44] & 0x1f) << 27) |
			((uint32_t)input[45] << 19) |
			((uint32_t)(input[46] & 0xe0) << 11);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 371 to 386
	value = ((uint32_t)(input[46] & 0x1f) << 27) |
			((uint32_t)input[47] << 19) |
			((uint32_t)(input[48] & 0xe0) << 11);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 387 to 402
	value = ((uint32_t)(input[48] & 0x1f) << 27) |
			((uint32_t)input[49] << 19) |
			((uint32_t)(input[50] & 0xe0) << 11);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 403 to 418
	value = ((uint32_t)(input[50] & 0x1f) << 27) |
			((uint32_t)input[51] << 19) |
			((uint32_t)(input[52] & 0xe0) << 11);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 419 to 434
	value = ((uint32_t)(input[52] & 0x1f) << 27) |
			((uint32_t)input[53] << 19) |
			((uint32_t)(input[54] & 0xe0) << 11);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 435 to 450
	value = ((uint32_t)(input[54] & 0x1f) << 27) |
			((uint32_t)input[55] << 19) |
			((uint32_t)(input[56] & 0xe0) << 11);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 451 to 466
	value = ((uint32_t)(input[56] & 0x1f) << 27) |
			((uint32_t)input[57] << 19) |
			((uint32_t)(input[58] & 0xe0) << 11);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 467 to 482
	value = ((uint32_t)(input[58] & 0x1f) << 27) |
			((uint32_t)input[59] << 19) |
			((uint32_t)(input[60] & 0xe0) << 11);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 483 to 498
	value = ((uint32_t)(input[60] & 0x1f) << 27) |
			((uint32_t)input[61] << 19) |
			((uint32_t)(input[62] & 0xe0) << 11);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 499 to 514
	value = ((uint32_t)(input[62] & 0x1f) << 27) |
			((uint32_t)input[63] << 19) |
			((uint32_t)(input[64] & 0xe0) << 11);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 515 to 530
	value = ((uint32_t)(input[64] & 0x1f) << 27) |
			((uint32_t)input[65] << 19) |
			((uint32_t)(input[66] & 0xe0) << 11);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 531 to 546
	value = ((uint32_t)(input[66] & 0x1f) << 27) |
			((uint32_t)input[67] << 19) |
			((uint32_t)(input[68] & 0xe0) << 11);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 547 to 562
	value = ((uint32_t)(input[68] & 0x1f) << 27) |
			((uint32_t)input[69] << 19) |
			((uint32_t)(input[70] & 0xe0) << 11);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 563 to 578
	value = ((uint32_t)(input[70] & 0x1f) << 27) |
			((uint32_t)input[71] << 19) |
			((uint32_t)(input[72] & 0xe0) << 11);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 579 to 594
	value = ((uint32_t)(input[72] & 0x1f) << 27) |
			((uint32_t)input[73] << 19) |
			((uint32_t)(input[74] & 0xe0) << 11);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 595 to 610
	value = ((uint32_t)(input[74] & 0x1f) << 27) |
			((uint32_t)input[75] << 19) |
			((uint32_t)(input[76] & 0xe0) << 11);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 611 to 626
	value = ((uint32_t)(input[76] & 0x1f) << 27) |
			((uint32_t)input[77] << 19) |
			((uint32_t)(input[78] & 0xe0) << 11);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 627 to 642
	value = ((uint32_t)(input[78] & 0x1f) << 27) |
			((uint32_t)input[79] << 19) |
			((uint32_t)(input[80] & 0xe0) << 11);
	output[39] = (double)(value >> 16);

	// read output[40]: from bit 643 to 658
	value = ((uint32_t)(input[80] & 0x1f) << 27) |
			((uint32_t)input[81] << 19) |
			((uint32_t)(input[82] & 0xe0) << 11);
	output[40] = (double)(value >> 16);

	// read output[41]: from bit 659 to 674
	value = ((uint32_t)(input[82] & 0x1f) << 27) |
			((uint32_t)input[83] << 19) |
			((uint32_t)(input[84] & 0xe0) << 11);
	output[41] = (double)(value >> 16);

	// read output[42]: from bit 675 to 690
	value = ((uint32_t)(input[84] & 0x1f) << 27) |
			((uint32_t)input[85] << 19) |
			((uint32_t)(input[86] & 0xe0) << 11);
	output[42] = (double)(value >> 16);

	// read output[43]: from bit 691 to 706
	value = ((uint32_t)(input[86] & 0x1f) << 27) |
			((uint32_t)input[87] << 19) |
			((uint32_t)(input[88] & 0xe0) << 11);
	output[43] = (double)(value >> 16);

	// read output[44]: from bit 707 to 722
	value = ((uint32_t)(input[88] & 0x1f) << 27) |
			((uint32_t)input[89] << 19) |
			((uint32_t)(input[90] & 0xe0) << 11);
	output[44] = (double)(value >> 16);

	// read output[45]: from bit 723 to 738
	value = ((uint32_t)(input[90] & 0x1f) << 27) |
			((uint32_t)input[91] << 19) |
			((uint32_t)(input[92] & 0xe0) << 11);
	output[45] = (double)(value >> 16);

	// read output[46]: from bit 739 to 754
	value = ((uint32_t)(input[92] & 0x1f) << 27) |
			((uint32_t)input[93] << 19) |
			((uint32_t)(input[94] & 0xe0) << 11);
	output[46] = (double)(value >> 16);

	// read output[47]: from bit 755 to 770
	value = ((uint32_t)(input[94] & 0x1f) << 27) |
			((uint32_t)input[95] << 19) |
			((uint32_t)(input[96] & 0xe0) << 11);
	output[47] = (double)(value >> 16);

	// read output[48]: from bit 771 to 786
	value = ((uint32_t)(input[96] & 0x1f) << 27) |
			((uint32_t)input[97] << 19) |
			((uint32_t)(input[98] & 0xe0) << 11);
	output[48] = (double)(value >> 16);

	// read output[49]: from bit 787 to 802
	value = ((uint32_t)(input[98] & 0x1f) << 27) |
			((uint32_t)input[99] << 19) |
			((uint32_t)(input[100] & 0xe0) << 11);
	output[49] = (double)(value >> 16);

	// read output[50]: from bit 803 to 818
	value = ((uint32_t)(input[100] & 0x1f) << 27) |
			((uint32_t)input[101] << 19) |
			((uint32_t)(input[102] & 0xe0) << 11);
	output[50] = (double)(value >> 16);

	// read output[51]: from bit 819 to 834
	value = ((uint32_t)(input[102] & 0x1f) << 27) |
			((uint32_t)input[103] << 19) |
			((uint32_t)(input[104] & 0xe0) << 11);
	output[51] = (double)(value >> 16);

	// read output[52]: from bit 835 to 850
	value = ((uint32_t)(input[104] & 0x1f) << 27) |
			((uint32_t)input[105] << 19) |
			((uint32_t)(input[106] & 0xe0) << 11);
	output[52] = (double)(value >> 16);

	// read output[53]: from bit 851 to 866
	value = ((uint32_t)(input[106] & 0x1f) << 27) |
			((uint32_t)input[107] << 19) |
			((uint32_t)(input[108] & 0xe0) << 11);
	output[53] = (double)(value >> 16);

	// read output[54]: from bit 867 to 882
	value = ((uint32_t)(input[108] & 0x1f) << 27) |
			((uint32_t)input[109] << 19) |
			((uint32_t)(input[110] & 0xe0) << 11);
	output[54] = (double)(value >> 16);

	// read output[55]: from bit 883 to 898
	value = ((uint32_t)(input[110] & 0x1f) << 27) |
			((uint32_t)input[111] << 19) |
			((uint32_t)(input[112] & 0xe0) << 11);
	output[55] = (double)(value >> 16);

	// read output[56]: from bit 899 to 914
	value = ((uint32_t)(input[112] & 0x1f) << 27) |
			((uint32_t)input[113] << 19) |
			((uint32_t)(input[114] & 0xe0) << 11);
	output[56] = (double)(value >> 16);

	// read output[57]: from bit 915 to 930
	value = ((uint32_t)(input[114] & 0x1f) << 27) |
			((uint32_t)input[115] << 19) |
			((uint32_t)(input[116] & 0xe0) << 11);
	output[57] = (double)(value >> 16);

	// read output[58]: from bit 931 to 946
	value = ((uint32_t)(input[116] & 0x1f) << 27) |
			((uint32_t)input[117] << 19) |
			((uint32_t)(input[118] & 0xe0) << 11);
	output[58] = (double)(value >> 16);

	// read output[59]: from bit 947 to 962
	value = ((uint32_t)(input[118] & 0x1f) << 27) |
			((uint32_t)input[119] << 19) |
			((uint32_t)(input[120] & 0xe0) << 11);
	output[59] = (double)(value >> 16);

	// read output[60]: from bit 963 to 978
	value = ((uint32_t)(input[120] & 0x1f) << 27) |
			((uint32_t)input[121] << 19) |
			((uint32_t)(input[122] & 0xe0) << 11);
	output[60] = (double)(value >> 16);

	// read output[61]: from bit 979 to 994
	value = ((uint32_t)(input[122] & 0x1f) << 27) |
			((uint32_t)input[123] << 19) |
			((uint32_t)(input[124] & 0xe0) << 11);
	output[61] = (double)(value >> 16);

	// read output[62]: from bit 995 to 1010
	value = ((uint32_t)(input[124] & 0x1f) << 27) |
			((uint32_t)input[125] << 19) |
			((uint32_t)(input[126] & 0xe0) << 11);
	output[62] = (double)(value >> 16);

	// read output[63]: from bit 1011 to 1026
	value = ((uint32_t)(input[126] & 0x1f) << 27) |
			((uint32_t)input[127] << 19) |
			((uint32_t)(input[128] & 0xe0) << 11);
	output[63] = (double)(value >> 16);
}

static void unpack_64_16bit_unsigned_3off(const uint8_t * input, double * output, void *closure) {
	// Unpack 64 values into output
	// Values are 16-bit unsigned
	// Skip 3 bits, read 1024 bits of data.
	// Input must be at least 129 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 3 to 18
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)input[1] << 19) |
			((uint32_t)(input[2] & 0xe0) << 11);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 19 to 34
	value = ((uint32_t)(input[2] & 0x1f) << 27) |
			((uint32_t)input[3] << 19) |
			((uint32_t)(input[4] & 0xe0) << 11);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 35 to 50
	value = ((uint32_t)(input[4] & 0x1f) << 27) |
			((uint32_t)input[5] << 19) |
			((uint32_t)(input[6] & 0xe0) << 11);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 51 to 66
	value = ((uint32_t)(input[6] & 0x1f) << 27) |
			((uint32_t)input[7] << 19) |
			((uint32_t)(input[8] & 0xe0) << 11);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 67 to 82
	value = ((uint32_t)(input[8] & 0x1f) << 27) |
			((uint32_t)input[9] << 19) |
			((uint32_t)(input[10] & 0xe0) << 11);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 83 to 98
	value = ((uint32_t)(input[10] & 0x1f) << 27) |
			((uint32_t)input[11] << 19) |
			((uint32_t)(input[12] & 0xe0) << 11);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 99 to 114
	value = ((uint32_t)(input[12] & 0x1f) << 27) |
			((uint32_t)input[13] << 19) |
			((uint32_t)(input[14] & 0xe0) << 11);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 115 to 130
	value = ((uint32_t)(input[14] & 0x1f) << 27) |
			((uint32_t)input[15] << 19) |
			((uint32_t)(input[16] & 0xe0) << 11);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 131 to 146
	value = ((uint32_t)(input[16] & 0x1f) << 27) |
			((uint32_t)input[17] << 19) |
			((uint32_t)(input[18] & 0xe0) << 11);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 147 to 162
	value = ((uint32_t)(input[18] & 0x1f) << 27) |
			((uint32_t)input[19] << 19) |
			((uint32_t)(input[20] & 0xe0) << 11);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 163 to 178
	value = ((uint32_t)(input[20] & 0x1f) << 27) |
			((uint32_t)input[21] << 19) |
			((uint32_t)(input[22] & 0xe0) << 11);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 179 to 194
	value = ((uint32_t)(input[22] & 0x1f) << 27) |
			((uint32_t)input[23] << 19) |
			((uint32_t)(input[24] & 0xe0) << 11);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 195 to 210
	value = ((uint32_t)(input[24] & 0x1f) << 27) |
			((uint32_t)input[25] << 19) |
			((uint32_t)(input[26] & 0xe0) << 11);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 211 to 226
	value = ((uint32_t)(input[26] & 0x1f) << 27) |
			((uint32_t)input[27] << 19) |
			((uint32_t)(input[28] & 0xe0) << 11);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 227 to 242
	value = ((uint32_t)(input[28] & 0x1f) << 27) |
			((uint32_t)input[29] << 19) |
			((uint32_t)(input[30] & 0xe0) << 11);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 243 to 258
	value = ((uint32_t)(input[30] & 0x1f) << 27) |
			((uint32_t)input[31] << 19) |
			((uint32_t)(input[32] & 0xe0) << 11);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 259 to 274
	value = ((uint32_t)(input[32] & 0x1f) << 27) |
			((uint32_t)input[33] << 19) |
			((uint32_t)(input[34] & 0xe0) << 11);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 275 to 290
	value = ((uint32_t)(input[34] & 0x1f) << 27) |
			((uint32_t)input[35] << 19) |
			((uint32_t)(input[36] & 0xe0) << 11);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 291 to 306
	value = ((uint32_t)(input[36] & 0x1f) << 27) |
			((uint32_t)input[37] << 19) |
			((uint32_t)(input[38] & 0xe0) << 11);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 307 to 322
	value = ((uint32_t)(input[38] & 0x1f) << 27) |
			((uint32_t)input[39] << 19) |
			((uint32_t)(input[40] & 0xe0) << 11);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 323 to 338
	value = ((uint32_t)(input[40] & 0x1f) << 27) |
			((uint32_t)input[41] << 19) |
			((uint32_t)(input[42] & 0xe0) << 11);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 339 to 354
	value = ((uint32_t)(input[42] & 0x1f) << 27) |
			((uint32_t)input[43] << 19) |
			((uint32_t)(input[44] & 0xe0) << 11);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 355 to 370
	value = ((uint32_t)(input[44] & 0x1f) << 27) |
			((uint32_t)input[45] << 19) |
			((uint32_t)(input[46] & 0xe0) << 11);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 371 to 386
	value = ((uint32_t)(input[46] & 0x1f) << 27) |
			((uint32_t)input[47] << 19) |
			((uint32_t)(input[48] & 0xe0) << 11);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 387 to 402
	value = ((uint32_t)(input[48] & 0x1f) << 27) |
			((uint32_t)input[49] << 19) |
			((uint32_t)(input[50] & 0xe0) << 11);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 403 to 418
	value = ((uint32_t)(input[50] & 0x1f) << 27) |
			((uint32_t)input[51] << 19) |
			((uint32_t)(input[52] & 0xe0) << 11);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 419 to 434
	value = ((uint32_t)(input[52] & 0x1f) << 27) |
			((uint32_t)input[53] << 19) |
			((uint32_t)(input[54] & 0xe0) << 11);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 435 to 450
	value = ((uint32_t)(input[54] & 0x1f) << 27) |
			((uint32_t)input[55] << 19) |
			((uint32_t)(input[56] & 0xe0) << 11);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 451 to 466
	value = ((uint32_t)(input[56] & 0x1f) << 27) |
			((uint32_t)input[57] << 19) |
			((uint32_t)(input[58] & 0xe0) << 11);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 467 to 482
	value = ((uint32_t)(input[58] & 0x1f) << 27) |
			((uint32_t)input[59] << 19) |
			((uint32_t)(input[60] & 0xe0) << 11);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 483 to 498
	value = ((uint32_t)(input[60] & 0x1f) << 27) |
			((uint32_t)input[61] << 19) |
			((uint32_t)(input[62] & 0xe0) << 11);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 499 to 514
	value = ((uint32_t)(input[62] & 0x1f) << 27) |
			((uint32_t)input[63] << 19) |
			((uint32_t)(input[64] & 0xe0) << 11);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 515 to 530
	value = ((uint32_t)(input[64] & 0x1f) << 27) |
			((uint32_t)input[65] << 19) |
			((uint32_t)(input[66] & 0xe0) << 11);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 531 to 546
	value = ((uint32_t)(input[66] & 0x1f) << 27) |
			((uint32_t)input[67] << 19) |
			((uint32_t)(input[68] & 0xe0) << 11);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 547 to 562
	value = ((uint32_t)(input[68] & 0x1f) << 27) |
			((uint32_t)input[69] << 19) |
			((uint32_t)(input[70] & 0xe0) << 11);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 563 to 578
	value = ((uint32_t)(input[70] & 0x1f) << 27) |
			((uint32_t)input[71] << 19) |
			((uint32_t)(input[72] & 0xe0) << 11);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 579 to 594
	value = ((uint32_t)(input[72] & 0x1f) << 27) |
			((uint32_t)input[73] << 19) |
			((uint32_t)(input[74] & 0xe0) << 11);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 595 to 610
	value = ((uint32_t)(input[74] & 0x1f) << 27) |
			((uint32_t)input[75] << 19) |
			((uint32_t)(input[76] & 0xe0) << 11);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 611 to 626
	value = ((uint32_t)(input[76] & 0x1f) << 27) |
			((uint32_t)input[77] << 19) |
			((uint32_t)(input[78] & 0xe0) << 11);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 627 to 642
	value = ((uint32_t)(input[78] & 0x1f) << 27) |
			((uint32_t)input[79] << 19) |
			((uint32_t)(input[80] & 0xe0) << 11);
	output[39] = (double)(value >> 16);

	// read output[40]: from bit 643 to 658
	value = ((uint32_t)(input[80] & 0x1f) << 27) |
			((uint32_t)input[81] << 19) |
			((uint32_t)(input[82] & 0xe0) << 11);
	output[40] = (double)(value >> 16);

	// read output[41]: from bit 659 to 674
	value = ((uint32_t)(input[82] & 0x1f) << 27) |
			((uint32_t)input[83] << 19) |
			((uint32_t)(input[84] & 0xe0) << 11);
	output[41] = (double)(value >> 16);

	// read output[42]: from bit 675 to 690
	value = ((uint32_t)(input[84] & 0x1f) << 27) |
			((uint32_t)input[85] << 19) |
			((uint32_t)(input[86] & 0xe0) << 11);
	output[42] = (double)(value >> 16);

	// read output[43]: from bit 691 to 706
	value = ((uint32_t)(input[86] & 0x1f) << 27) |
			((uint32_t)input[87] << 19) |
			((uint32_t)(input[88] & 0xe0) << 11);
	output[43] = (double)(value >> 16);

	// read output[44]: from bit 707 to 722
	value = ((uint32_t)(input[88] & 0x1f) << 27) |
			((uint32_t)input[89] << 19) |
			((uint32_t)(input[90] & 0xe0) << 11);
	output[44] = (double)(value >> 16);

	// read output[45]: from bit 723 to 738
	value = ((uint32_t)(input[90] & 0x1f) << 27) |
			((uint32_t)input[91] << 19) |
			((uint32_t)(input[92] & 0xe0) << 11);
	output[45] = (double)(value >> 16);

	// read output[46]: from bit 739 to 754
	value = ((uint32_t)(input[92] & 0x1f) << 27) |
			((uint32_t)input[93] << 19) |
			((uint32_t)(input[94] & 0xe0) << 11);
	output[46] = (double)(value >> 16);

	// read output[47]: from bit 755 to 770
	value = ((uint32_t)(input[94] & 0x1f) << 27) |
			((uint32_t)input[95] << 19) |
			((uint32_t)(input[96] & 0xe0) << 11);
	output[47] = (double)(value >> 16);

	// read output[48]: from bit 771 to 786
	value = ((uint32_t)(input[96] & 0x1f) << 27) |
			((uint32_t)input[97] << 19) |
			((uint32_t)(input[98] & 0xe0) << 11);
	output[48] = (double)(value >> 16);

	// read output[49]: from bit 787 to 802
	value = ((uint32_t)(input[98] & 0x1f) << 27) |
			((uint32_t)input[99] << 19) |
			((uint32_t)(input[100] & 0xe0) << 11);
	output[49] = (double)(value >> 16);

	// read output[50]: from bit 803 to 818
	value = ((uint32_t)(input[100] & 0x1f) << 27) |
			((uint32_t)input[101] << 19) |
			((uint32_t)(input[102] & 0xe0) << 11);
	output[50] = (double)(value >> 16);

	// read output[51]: from bit 819 to 834
	value = ((uint32_t)(input[102] & 0x1f) << 27) |
			((uint32_t)input[103] << 19) |
			((uint32_t)(input[104] & 0xe0) << 11);
	output[51] = (double)(value >> 16);

	// read output[52]: from bit 835 to 850
	value = ((uint32_t)(input[104] & 0x1f) << 27) |
			((uint32_t)input[105] << 19) |
			((uint32_t)(input[106] & 0xe0) << 11);
	output[52] = (double)(value >> 16);

	// read output[53]: from bit 851 to 866
	value = ((uint32_t)(input[106] & 0x1f) << 27) |
			((uint32_t)input[107] << 19) |
			((uint32_t)(input[108] & 0xe0) << 11);
	output[53] = (double)(value >> 16);

	// read output[54]: from bit 867 to 882
	value = ((uint32_t)(input[108] & 0x1f) << 27) |
			((uint32_t)input[109] << 19) |
			((uint32_t)(input[110] & 0xe0) << 11);
	output[54] = (double)(value >> 16);

	// read output[55]: from bit 883 to 898
	value = ((uint32_t)(input[110] & 0x1f) << 27) |
			((uint32_t)input[111] << 19) |
			((uint32_t)(input[112] & 0xe0) << 11);
	output[55] = (double)(value >> 16);

	// read output[56]: from bit 899 to 914
	value = ((uint32_t)(input[112] & 0x1f) << 27) |
			((uint32_t)input[113] << 19) |
			((uint32_t)(input[114] & 0xe0) << 11);
	output[56] = (double)(value >> 16);

	// read output[57]: from bit 915 to 930
	value = ((uint32_t)(input[114] & 0x1f) << 27) |
			((uint32_t)input[115] << 19) |
			((uint32_t)(input[116] & 0xe0) << 11);
	output[57] = (double)(value >> 16);

	// read output[58]: from bit 931 to 946
	value = ((uint32_t)(input[116] & 0x1f) << 27) |
			((uint32_t)input[117] << 19) |
			((uint32_t)(input[118] & 0xe0) << 11);
	output[58] = (double)(value >> 16);

	// read output[59]: from bit 947 to 962
	value = ((uint32_t)(input[118] & 0x1f) << 27) |
			((uint32_t)input[119] << 19) |
			((uint32_t)(input[120] & 0xe0) << 11);
	output[59] = (double)(value >> 16);

	// read output[60]: from bit 963 to 978
	value = ((uint32_t)(input[120] & 0x1f) << 27) |
			((uint32_t)input[121] << 19) |
			((uint32_t)(input[122] & 0xe0) << 11);
	output[60] = (double)(value >> 16);

	// read output[61]: from bit 979 to 994
	value = ((uint32_t)(input[122] & 0x1f) << 27) |
			((uint32_t)input[123] << 19) |
			((uint32_t)(input[124] & 0xe0) << 11);
	output[61] = (double)(value >> 16);

	// read output[62]: from bit 995 to 1010
	value = ((uint32_t)(input[124] & 0x1f) << 27) |
			((uint32_t)input[125] << 19) |
			((uint32_t)(input[126] & 0xe0) << 11);
	output[62] = (double)(value >> 16);

	// read output[63]: from bit 1011 to 1026
	value = ((uint32_t)(input[126] & 0x1f) << 27) |
			((uint32_t)input[127] << 19) |
			((uint32_t)(input[128] & 0xe0) << 11);
	output[63] = (double)(value >> 16);
}

static void unpack_64_16bit_signed_4off(const uint8_t * input, double * output, void *closure) {
	// Unpack 64 values into output
	// Values are 16-bit signed
	// Skip 4 bits, read 1024 bits of data.
	// Input must be at least 129 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 4 to 19
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20) |
			((uint32_t)(input[2] & 0xf0) << 12);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 20 to 35
	value = ((uint32_t)(input[2] & 0x0f) << 28) |
			((uint32_t)input[3] << 20) |
			((uint32_t)(input[4] & 0xf0) << 12);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 36 to 51
	value = ((uint32_t)(input[4] & 0x0f) << 28) |
			((uint32_t)input[5] << 20) |
			((uint32_t)(input[6] & 0xf0) << 12);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 52 to 67
	value = ((uint32_t)(input[6] & 0x0f) << 28) |
			((uint32_t)input[7] << 20) |
			((uint32_t)(input[8] & 0xf0) << 12);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 68 to 83
	value = ((uint32_t)(input[8] & 0x0f) << 28) |
			((uint32_t)input[9] << 20) |
			((uint32_t)(input[10] & 0xf0) << 12);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 84 to 99
	value = ((uint32_t)(input[10] & 0x0f) << 28) |
			((uint32_t)input[11] << 20) |
			((uint32_t)(input[12] & 0xf0) << 12);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 100 to 115
	value = ((uint32_t)(input[12] & 0x0f) << 28) |
			((uint32_t)input[13] << 20) |
			((uint32_t)(input[14] & 0xf0) << 12);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 116 to 131
	value = ((uint32_t)(input[14] & 0x0f) << 28) |
			((uint32_t)input[15] << 20) |
			((uint32_t)(input[16] & 0xf0) << 12);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 132 to 147
	value = ((uint32_t)(input[16] & 0x0f) << 28) |
			((uint32_t)input[17] << 20) |
			((uint32_t)(input[18] & 0xf0) << 12);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 148 to 163
	value = ((uint32_t)(input[18] & 0x0f) << 28) |
			((uint32_t)input[19] << 20) |
			((uint32_t)(input[20] & 0xf0) << 12);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 164 to 179
	value = ((uint32_t)(input[20] & 0x0f) << 28) |
			((uint32_t)input[21] << 20) |
			((uint32_t)(input[22] & 0xf0) << 12);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 180 to 195
	value = ((uint32_t)(input[22] & 0x0f) << 28) |
			((uint32_t)input[23] << 20) |
			((uint32_t)(input[24] & 0xf0) << 12);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 196 to 211
	value = ((uint32_t)(input[24] & 0x0f) << 28) |
			((uint32_t)input[25] << 20) |
			((uint32_t)(input[26] & 0xf0) << 12);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 212 to 227
	value = ((uint32_t)(input[26] & 0x0f) << 28) |
			((uint32_t)input[27] << 20) |
			((uint32_t)(input[28] & 0xf0) << 12);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 228 to 243
	value = ((uint32_t)(input[28] & 0x0f) << 28) |
			((uint32_t)input[29] << 20) |
			((uint32_t)(input[30] & 0xf0) << 12);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 244 to 259
	value = ((uint32_t)(input[30] & 0x0f) << 28) |
			((uint32_t)input[31] << 20) |
			((uint32_t)(input[32] & 0xf0) << 12);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 260 to 275
	value = ((uint32_t)(input[32] & 0x0f) << 28) |
			((uint32_t)input[33] << 20) |
			((uint32_t)(input[34] & 0xf0) << 12);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 276 to 291
	value = ((uint32_t)(input[34] & 0x0f) << 28) |
			((uint32_t)input[35] << 20) |
			((uint32_t)(input[36] & 0xf0) << 12);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 292 to 307
	value = ((uint32_t)(input[36] & 0x0f) << 28) |
			((uint32_t)input[37] << 20) |
			((uint32_t)(input[38] & 0xf0) << 12);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 308 to 323
	value = ((uint32_t)(input[38] & 0x0f) << 28) |
			((uint32_t)input[39] << 20) |
			((uint32_t)(input[40] & 0xf0) << 12);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 324 to 339
	value = ((uint32_t)(input[40] & 0x0f) << 28) |
			((uint32_t)input[41] << 20) |
			((uint32_t)(input[42] & 0xf0) << 12);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 340 to 355
	value = ((uint32_t)(input[42] & 0x0f) << 28) |
			((uint32_t)input[43] << 20) |
			((uint32_t)(input[44] & 0xf0) << 12);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 356 to 371
	value = ((uint32_t)(input[44] & 0x0f) << 28) |
			((uint32_t)input[45] << 20) |
			((uint32_t)(input[46] & 0xf0) << 12);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 372 to 387
	value = ((uint32_t)(input[46] & 0x0f) << 28) |
			((uint32_t)input[47] << 20) |
			((uint32_t)(input[48] & 0xf0) << 12);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 388 to 403
	value = ((uint32_t)(input[48] & 0x0f) << 28) |
			((uint32_t)input[49] << 20) |
			((uint32_t)(input[50] & 0xf0) << 12);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 404 to 419
	value = ((uint32_t)(input[50] & 0x0f) << 28) |
			((uint32_t)input[51] << 20) |
			((uint32_t)(input[52] & 0xf0) << 12);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 420 to 435
	value = ((uint32_t)(input[52] & 0x0f) << 28) |
			((uint32_t)input[53] << 20) |
			((uint32_t)(input[54] & 0xf0) << 12);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 436 to 451
	value = ((uint32_t)(input[54] & 0x0f) << 28) |
			((uint32_t)input[55] << 20) |
			((uint32_t)(input[56] & 0xf0) << 12);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 452 to 467
	value = ((uint32_t)(input[56] & 0x0f) << 28) |
			((uint32_t)input[57] << 20) |
			((uint32_t)(input[58] & 0xf0) << 12);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 468 to 483
	value = ((uint32_t)(input[58] & 0x0f) << 28) |
			((uint32_t)input[59] << 20) |
			((uint32_t)(input[60] & 0xf0) << 12);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 484 to 499
	value = ((uint32_t)(input[60] & 0x0f) << 28) |
			((uint32_t)input[61] << 20) |
			((uint32_t)(input[62] & 0xf0) << 12);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 500 to 515
	value = ((uint32_t)(input[62] & 0x0f) << 28) |
			((uint32_t)input[63] << 20) |
			((uint32_t)(input[64] & 0xf0) << 12);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 516 to 531
	value = ((uint32_t)(input[64] & 0x0f) << 28) |
			((uint32_t)input[65] << 20) |
			((uint32_t)(input[66] & 0xf0) << 12);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 532 to 547
	value = ((uint32_t)(input[66] & 0x0f) << 28) |
			((uint32_t)input[67] << 20) |
			((uint32_t)(input[68] & 0xf0) << 12);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 548 to 563
	value = ((uint32_t)(input[68] & 0x0f) << 28) |
			((uint32_t)input[69] << 20) |
			((uint32_t)(input[70] & 0xf0) << 12);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 564 to 579
	value = ((uint32_t)(input[70] & 0x0f) << 28) |
			((uint32_t)input[71] << 20) |
			((uint32_t)(input[72] & 0xf0) << 12);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 580 to 595
	value = ((uint32_t)(input[72] & 0x0f) << 28) |
			((uint32_t)input[73] << 20) |
			((uint32_t)(input[74] & 0xf0) << 12);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 596 to 611
	value = ((uint32_t)(input[74] & 0x0f) << 28) |
			((uint32_t)input[75] << 20) |
			((uint32_t)(input[76] & 0xf0) << 12);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 612 to 627
	value = ((uint32_t)(input[76] & 0x0f) << 28) |
			((uint32_t)input[77] << 20) |
			((uint32_t)(input[78] & 0xf0) << 12);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 628 to 643
	value = ((uint32_t)(input[78] & 0x0f) << 28) |
			((uint32_t)input[79] << 20) |
			((uint32_t)(input[80] & 0xf0) << 12);
	output[39] = (double)(value >> 16);

	// read output[40]: from bit 644 to 659
	value = ((uint32_t)(input[80] & 0x0f) << 28) |
			((uint32_t)input[81] << 20) |
			((uint32_t)(input[82] & 0xf0) << 12);
	output[40] = (double)(value >> 16);

	// read output[41]: from bit 660 to 675
	value = ((uint32_t)(input[82] & 0x0f) << 28) |
			((uint32_t)input[83] << 20) |
			((uint32_t)(input[84] & 0xf0) << 12);
	output[41] = (double)(value >> 16);

	// read output[42]: from bit 676 to 691
	value = ((uint32_t)(input[84] & 0x0f) << 28) |
			((uint32_t)input[85] << 20) |
			((uint32_t)(input[86] & 0xf0) << 12);
	output[42] = (double)(value >> 16);

	// read output[43]: from bit 692 to 707
	value = ((uint32_t)(input[86] & 0x0f) << 28) |
			((uint32_t)input[87] << 20) |
			((uint32_t)(input[88] & 0xf0) << 12);
	output[43] = (double)(value >> 16);

	// read output[44]: from bit 708 to 723
	value = ((uint32_t)(input[88] & 0x0f) << 28) |
			((uint32_t)input[89] << 20) |
			((uint32_t)(input[90] & 0xf0) << 12);
	output[44] = (double)(value >> 16);

	// read output[45]: from bit 724 to 739
	value = ((uint32_t)(input[90] & 0x0f) << 28) |
			((uint32_t)input[91] << 20) |
			((uint32_t)(input[92] & 0xf0) << 12);
	output[45] = (double)(value >> 16);

	// read output[46]: from bit 740 to 755
	value = ((uint32_t)(input[92] & 0x0f) << 28) |
			((uint32_t)input[93] << 20) |
			((uint32_t)(input[94] & 0xf0) << 12);
	output[46] = (double)(value >> 16);

	// read output[47]: from bit 756 to 771
	value = ((uint32_t)(input[94] & 0x0f) << 28) |
			((uint32_t)input[95] << 20) |
			((uint32_t)(input[96] & 0xf0) << 12);
	output[47] = (double)(value >> 16);

	// read output[48]: from bit 772 to 787
	value = ((uint32_t)(input[96] & 0x0f) << 28) |
			((uint32_t)input[97] << 20) |
			((uint32_t)(input[98] & 0xf0) << 12);
	output[48] = (double)(value >> 16);

	// read output[49]: from bit 788 to 803
	value = ((uint32_t)(input[98] & 0x0f) << 28) |
			((uint32_t)input[99] << 20) |
			((uint32_t)(input[100] & 0xf0) << 12);
	output[49] = (double)(value >> 16);

	// read output[50]: from bit 804 to 819
	value = ((uint32_t)(input[100] & 0x0f) << 28) |
			((uint32_t)input[101] << 20) |
			((uint32_t)(input[102] & 0xf0) << 12);
	output[50] = (double)(value >> 16);

	// read output[51]: from bit 820 to 835
	value = ((uint32_t)(input[102] & 0x0f) << 28) |
			((uint32_t)input[103] << 20) |
			((uint32_t)(input[104] & 0xf0) << 12);
	output[51] = (double)(value >> 16);

	// read output[52]: from bit 836 to 851
	value = ((uint32_t)(input[104] & 0x0f) << 28) |
			((uint32_t)input[105] << 20) |
			((uint32_t)(input[106] & 0xf0) << 12);
	output[52] = (double)(value >> 16);

	// read output[53]: from bit 852 to 867
	value = ((uint32_t)(input[106] & 0x0f) << 28) |
			((uint32_t)input[107] << 20) |
			((uint32_t)(input[108] & 0xf0) << 12);
	output[53] = (double)(value >> 16);

	// read output[54]: from bit 868 to 883
	value = ((uint32_t)(input[108] & 0x0f) << 28) |
			((uint32_t)input[109] << 20) |
			((uint32_t)(input[110] & 0xf0) << 12);
	output[54] = (double)(value >> 16);

	// read output[55]: from bit 884 to 899
	value = ((uint32_t)(input[110] & 0x0f) << 28) |
			((uint32_t)input[111] << 20) |
			((uint32_t)(input[112] & 0xf0) << 12);
	output[55] = (double)(value >> 16);

	// read output[56]: from bit 900 to 915
	value = ((uint32_t)(input[112] & 0x0f) << 28) |
			((uint32_t)input[113] << 20) |
			((uint32_t)(input[114] & 0xf0) << 12);
	output[56] = (double)(value >> 16);

	// read output[57]: from bit 916 to 931
	value = ((uint32_t)(input[114] & 0x0f) << 28) |
			((uint32_t)input[115] << 20) |
			((uint32_t)(input[116] & 0xf0) << 12);
	output[57] = (double)(value >> 16);

	// read output[58]: from bit 932 to 947
	value = ((uint32_t)(input[116] & 0x0f) << 28) |
			((uint32_t)input[117] << 20) |
			((uint32_t)(input[118] & 0xf0) << 12);
	output[58] = (double)(value >> 16);

	// read output[59]: from bit 948 to 963
	value = ((uint32_t)(input[118] & 0x0f) << 28) |
			((uint32_t)input[119] << 20) |
			((uint32_t)(input[120] & 0xf0) << 12);
	output[59] = (double)(value >> 16);

	// read output[60]: from bit 964 to 979
	value = ((uint32_t)(input[120] & 0x0f) << 28) |
			((uint32_t)input[121] << 20) |
			((uint32_t)(input[122] & 0xf0) << 12);
	output[60] = (double)(value >> 16);

	// read output[61]: from bit 980 to 995
	value = ((uint32_t)(input[122] & 0x0f) << 28) |
			((uint32_t)input[123] << 20) |
			((uint32_t)(input[124] & 0xf0) << 12);
	output[61] = (double)(value >> 16);

	// read output[62]: from bit 996 to 1011
	value = ((uint32_t)(input[124] & 0x0f) << 28) |
			((uint32_t)input[125] << 20) |
			((uint32_t)(input[126] & 0xf0) << 12);
	output[62] = (double)(value >> 16);

	// read output[63]: from bit 1012 to 1027
	value = ((uint32_t)(input[126] & 0x0f) << 28) |
			((uint32_t)input[127] << 20) |
			((uint32_t)(input[128] & 0xf0) << 12);
	output[63] = (double)(value >> 16);
}

static void unpack_64_16bit_unsigned_4off(const uint8_t * input, double * output, void *closure) {
	// Unpack 64 values into output
	// Values are 16-bit unsigned
	// Skip 4 bits, read 1024 bits of data.
	// Input must be at least 129 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 4 to 19
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20) |
			((uint32_t)(input[2] & 0xf0) << 12);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 20 to 35
	value = ((uint32_t)(input[2] & 0x0f) << 28) |
			((uint32_t)input[3] << 20) |
			((uint32_t)(input[4] & 0xf0) << 12);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 36 to 51
	value = ((uint32_t)(input[4] & 0x0f) << 28) |
			((uint32_t)input[5] << 20) |
			((uint32_t)(input[6] & 0xf0) << 12);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 52 to 67
	value = ((uint32_t)(input[6] & 0x0f) << 28) |
			((uint32_t)input[7] << 20) |
			((uint32_t)(input[8] & 0xf0) << 12);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 68 to 83
	value = ((uint32_t)(input[8] & 0x0f) << 28) |
			((uint32_t)input[9] << 20) |
			((uint32_t)(input[10] & 0xf0) << 12);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 84 to 99
	value = ((uint32_t)(input[10] & 0x0f) << 28) |
			((uint32_t)input[11] << 20) |
			((uint32_t)(input[12] & 0xf0) << 12);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 100 to 115
	value = ((uint32_t)(input[12] & 0x0f) << 28) |
			((uint32_t)input[13] << 20) |
			((uint32_t)(input[14] & 0xf0) << 12);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 116 to 131
	value = ((uint32_t)(input[14] & 0x0f) << 28) |
			((uint32_t)input[15] << 20) |
			((uint32_t)(input[16] & 0xf0) << 12);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 132 to 147
	value = ((uint32_t)(input[16] & 0x0f) << 28) |
			((uint32_t)input[17] << 20) |
			((uint32_t)(input[18] & 0xf0) << 12);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 148 to 163
	value = ((uint32_t)(input[18] & 0x0f) << 28) |
			((uint32_t)input[19] << 20) |
			((uint32_t)(input[20] & 0xf0) << 12);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 164 to 179
	value = ((uint32_t)(input[20] & 0x0f) << 28) |
			((uint32_t)input[21] << 20) |
			((uint32_t)(input[22] & 0xf0) << 12);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 180 to 195
	value = ((uint32_t)(input[22] & 0x0f) << 28) |
			((uint32_t)input[23] << 20) |
			((uint32_t)(input[24] & 0xf0) << 12);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 196 to 211
	value = ((uint32_t)(input[24] & 0x0f) << 28) |
			((uint32_t)input[25] << 20) |
			((uint32_t)(input[26] & 0xf0) << 12);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 212 to 227
	value = ((uint32_t)(input[26] & 0x0f) << 28) |
			((uint32_t)input[27] << 20) |
			((uint32_t)(input[28] & 0xf0) << 12);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 228 to 243
	value = ((uint32_t)(input[28] & 0x0f) << 28) |
			((uint32_t)input[29] << 20) |
			((uint32_t)(input[30] & 0xf0) << 12);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 244 to 259
	value = ((uint32_t)(input[30] & 0x0f) << 28) |
			((uint32_t)input[31] << 20) |
			((uint32_t)(input[32] & 0xf0) << 12);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 260 to 275
	value = ((uint32_t)(input[32] & 0x0f) << 28) |
			((uint32_t)input[33] << 20) |
			((uint32_t)(input[34] & 0xf0) << 12);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 276 to 291
	value = ((uint32_t)(input[34] & 0x0f) << 28) |
			((uint32_t)input[35] << 20) |
			((uint32_t)(input[36] & 0xf0) << 12);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 292 to 307
	value = ((uint32_t)(input[36] & 0x0f) << 28) |
			((uint32_t)input[37] << 20) |
			((uint32_t)(input[38] & 0xf0) << 12);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 308 to 323
	value = ((uint32_t)(input[38] & 0x0f) << 28) |
			((uint32_t)input[39] << 20) |
			((uint32_t)(input[40] & 0xf0) << 12);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 324 to 339
	value = ((uint32_t)(input[40] & 0x0f) << 28) |
			((uint32_t)input[41] << 20) |
			((uint32_t)(input[42] & 0xf0) << 12);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 340 to 355
	value = ((uint32_t)(input[42] & 0x0f) << 28) |
			((uint32_t)input[43] << 20) |
			((uint32_t)(input[44] & 0xf0) << 12);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 356 to 371
	value = ((uint32_t)(input[44] & 0x0f) << 28) |
			((uint32_t)input[45] << 20) |
			((uint32_t)(input[46] & 0xf0) << 12);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 372 to 387
	value = ((uint32_t)(input[46] & 0x0f) << 28) |
			((uint32_t)input[47] << 20) |
			((uint32_t)(input[48] & 0xf0) << 12);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 388 to 403
	value = ((uint32_t)(input[48] & 0x0f) << 28) |
			((uint32_t)input[49] << 20) |
			((uint32_t)(input[50] & 0xf0) << 12);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 404 to 419
	value = ((uint32_t)(input[50] & 0x0f) << 28) |
			((uint32_t)input[51] << 20) |
			((uint32_t)(input[52] & 0xf0) << 12);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 420 to 435
	value = ((uint32_t)(input[52] & 0x0f) << 28) |
			((uint32_t)input[53] << 20) |
			((uint32_t)(input[54] & 0xf0) << 12);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 436 to 451
	value = ((uint32_t)(input[54] & 0x0f) << 28) |
			((uint32_t)input[55] << 20) |
			((uint32_t)(input[56] & 0xf0) << 12);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 452 to 467
	value = ((uint32_t)(input[56] & 0x0f) << 28) |
			((uint32_t)input[57] << 20) |
			((uint32_t)(input[58] & 0xf0) << 12);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 468 to 483
	value = ((uint32_t)(input[58] & 0x0f) << 28) |
			((uint32_t)input[59] << 20) |
			((uint32_t)(input[60] & 0xf0) << 12);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 484 to 499
	value = ((uint32_t)(input[60] & 0x0f) << 28) |
			((uint32_t)input[61] << 20) |
			((uint32_t)(input[62] & 0xf0) << 12);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 500 to 515
	value = ((uint32_t)(input[62] & 0x0f) << 28) |
			((uint32_t)input[63] << 20) |
			((uint32_t)(input[64] & 0xf0) << 12);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 516 to 531
	value = ((uint32_t)(input[64] & 0x0f) << 28) |
			((uint32_t)input[65] << 20) |
			((uint32_t)(input[66] & 0xf0) << 12);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 532 to 547
	value = ((uint32_t)(input[66] & 0x0f) << 28) |
			((uint32_t)input[67] << 20) |
			((uint32_t)(input[68] & 0xf0) << 12);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 548 to 563
	value = ((uint32_t)(input[68] & 0x0f) << 28) |
			((uint32_t)input[69] << 20) |
			((uint32_t)(input[70] & 0xf0) << 12);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 564 to 579
	value = ((uint32_t)(input[70] & 0x0f) << 28) |
			((uint32_t)input[71] << 20) |
			((uint32_t)(input[72] & 0xf0) << 12);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 580 to 595
	value = ((uint32_t)(input[72] & 0x0f) << 28) |
			((uint32_t)input[73] << 20) |
			((uint32_t)(input[74] & 0xf0) << 12);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 596 to 611
	value = ((uint32_t)(input[74] & 0x0f) << 28) |
			((uint32_t)input[75] << 20) |
			((uint32_t)(input[76] & 0xf0) << 12);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 612 to 627
	value = ((uint32_t)(input[76] & 0x0f) << 28) |
			((uint32_t)input[77] << 20) |
			((uint32_t)(input[78] & 0xf0) << 12);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 628 to 643
	value = ((uint32_t)(input[78] & 0x0f) << 28) |
			((uint32_t)input[79] << 20) |
			((uint32_t)(input[80] & 0xf0) << 12);
	output[39] = (double)(value >> 16);

	// read output[40]: from bit 644 to 659
	value = ((uint32_t)(input[80] & 0x0f) << 28) |
			((uint32_t)input[81] << 20) |
			((uint32_t)(input[82] & 0xf0) << 12);
	output[40] = (double)(value >> 16);

	// read output[41]: from bit 660 to 675
	value = ((uint32_t)(input[82] & 0x0f) << 28) |
			((uint32_t)input[83] << 20) |
			((uint32_t)(input[84] & 0xf0) << 12);
	output[41] = (double)(value >> 16);

	// read output[42]: from bit 676 to 691
	value = ((uint32_t)(input[84] & 0x0f) << 28) |
			((uint32_t)input[85] << 20) |
			((uint32_t)(input[86] & 0xf0) << 12);
	output[42] = (double)(value >> 16);

	// read output[43]: from bit 692 to 707
	value = ((uint32_t)(input[86] & 0x0f) << 28) |
			((uint32_t)input[87] << 20) |
			((uint32_t)(input[88] & 0xf0) << 12);
	output[43] = (double)(value >> 16);

	// read output[44]: from bit 708 to 723
	value = ((uint32_t)(input[88] & 0x0f) << 28) |
			((uint32_t)input[89] << 20) |
			((uint32_t)(input[90] & 0xf0) << 12);
	output[44] = (double)(value >> 16);

	// read output[45]: from bit 724 to 739
	value = ((uint32_t)(input[90] & 0x0f) << 28) |
			((uint32_t)input[91] << 20) |
			((uint32_t)(input[92] & 0xf0) << 12);
	output[45] = (double)(value >> 16);

	// read output[46]: from bit 740 to 755
	value = ((uint32_t)(input[92] & 0x0f) << 28) |
			((uint32_t)input[93] << 20) |
			((uint32_t)(input[94] & 0xf0) << 12);
	output[46] = (double)(value >> 16);

	// read output[47]: from bit 756 to 771
	value = ((uint32_t)(input[94] & 0x0f) << 28) |
			((uint32_t)input[95] << 20) |
			((uint32_t)(input[96] & 0xf0) << 12);
	output[47] = (double)(value >> 16);

	// read output[48]: from bit 772 to 787
	value = ((uint32_t)(input[96] & 0x0f) << 28) |
			((uint32_t)input[97] << 20) |
			((uint32_t)(input[98] & 0xf0) << 12);
	output[48] = (double)(value >> 16);

	// read output[49]: from bit 788 to 803
	value = ((uint32_t)(input[98] & 0x0f) << 28) |
			((uint32_t)input[99] << 20) |
			((uint32_t)(input[100] & 0xf0) << 12);
	output[49] = (double)(value >> 16);

	// read output[50]: from bit 804 to 819
	value = ((uint32_t)(input[100] & 0x0f) << 28) |
			((uint32_t)input[101] << 20) |
			((uint32_t)(input[102] & 0xf0) << 12);
	output[50] = (double)(value >> 16);

	// read output[51]: from bit 820 to 835
	value = ((uint32_t)(input[102] & 0x0f) << 28) |
			((uint32_t)input[103] << 20) |
			((uint32_t)(input[104] & 0xf0) << 12);
	output[51] = (double)(value >> 16);

	// read output[52]: from bit 836 to 851
	value = ((uint32_t)(input[104] & 0x0f) << 28) |
			((uint32_t)input[105] << 20) |
			((uint32_t)(input[106] & 0xf0) << 12);
	output[52] = (double)(value >> 16);

	// read output[53]: from bit 852 to 867
	value = ((uint32_t)(input[106] & 0x0f) << 28) |
			((uint32_t)input[107] << 20) |
			((uint32_t)(input[108] & 0xf0) << 12);
	output[53] = (double)(value >> 16);

	// read output[54]: from bit 868 to 883
	value = ((uint32_t)(input[108] & 0x0f) << 28) |
			((uint32_t)input[109] << 20) |
			((uint32_t)(input[110] & 0xf0) << 12);
	output[54] = (double)(value >> 16);

	// read output[55]: from bit 884 to 899
	value = ((uint32_t)(input[110] & 0x0f) << 28) |
			((uint32_t)input[111] << 20) |
			((uint32_t)(input[112] & 0xf0) << 12);
	output[55] = (double)(value >> 16);

	// read output[56]: from bit 900 to 915
	value = ((uint32_t)(input[112] & 0x0f) << 28) |
			((uint32_t)input[113] << 20) |
			((uint32_t)(input[114] & 0xf0) << 12);
	output[56] = (double)(value >> 16);

	// read output[57]: from bit 916 to 931
	value = ((uint32_t)(input[114] & 0x0f) << 28) |
			((uint32_t)input[115] << 20) |
			((uint32_t)(input[116] & 0xf0) << 12);
	output[57] = (double)(value >> 16);

	// read output[58]: from bit 932 to 947
	value = ((uint32_t)(input[116] & 0x0f) << 28) |
			((uint32_t)input[117] << 20) |
			((uint32_t)(input[118] & 0xf0) << 12);
	output[58] = (double)(value >> 16);

	// read output[59]: from bit 948 to 963
	value = ((uint32_t)(input[118] & 0x0f) << 28) |
			((uint32_t)input[119] << 20) |
			((uint32_t)(input[120] & 0xf0) << 12);
	output[59] = (double)(value >> 16);

	// read output[60]: from bit 964 to 979
	value = ((uint32_t)(input[120] & 0x0f) << 28) |
			((uint32_t)input[121] << 20) |
			((uint32_t)(input[122] & 0xf0) << 12);
	output[60] = (double)(value >> 16);

	// read output[61]: from bit 980 to 995
	value = ((uint32_t)(input[122] & 0x0f) << 28) |
			((uint32_t)input[123] << 20) |
			((uint32_t)(input[124] & 0xf0) << 12);
	output[61] = (double)(value >> 16);

	// read output[62]: from bit 996 to 1011
	value = ((uint32_t)(input[124] & 0x0f) << 28) |
			((uint32_t)input[125] << 20) |
			((uint32_t)(input[126] & 0xf0) << 12);
	output[62] = (double)(value >> 16);

	// read output[63]: from bit 1012 to 1027
	value = ((uint32_t)(input[126] & 0x0f) << 28) |
			((uint32_t)input[127] << 20) |
			((uint32_t)(input[128] & 0xf0) << 12);
	output[63] = (double)(value >> 16);
}

static void unpack_64_16bit_signed_5off(const uint8_t * input, double * output, void *closure) {
	// Unpack 64 values into output
	// Values are 16-bit signed
	// Skip 5 bits, read 1024 bits of data.
	// Input must be at least 129 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 5 to 20
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)(input[2] & 0xf8) << 13);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 21 to 36
	value = ((uint32_t)(input[2] & 0x07) << 29) |
			((uint32_t)input[3] << 21) |
			((uint32_t)(input[4] & 0xf8) << 13);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 37 to 52
	value = ((uint32_t)(input[4] & 0x07) << 29) |
			((uint32_t)input[5] << 21) |
			((uint32_t)(input[6] & 0xf8) << 13);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 53 to 68
	value = ((uint32_t)(input[6] & 0x07) << 29) |
			((uint32_t)input[7] << 21) |
			((uint32_t)(input[8] & 0xf8) << 13);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 69 to 84
	value = ((uint32_t)(input[8] & 0x07) << 29) |
			((uint32_t)input[9] << 21) |
			((uint32_t)(input[10] & 0xf8) << 13);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 85 to 100
	value = ((uint32_t)(input[10] & 0x07) << 29) |
			((uint32_t)input[11] << 21) |
			((uint32_t)(input[12] & 0xf8) << 13);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 101 to 116
	value = ((uint32_t)(input[12] & 0x07) << 29) |
			((uint32_t)input[13] << 21) |
			((uint32_t)(input[14] & 0xf8) << 13);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 117 to 132
	value = ((uint32_t)(input[14] & 0x07) << 29) |
			((uint32_t)input[15] << 21) |
			((uint32_t)(input[16] & 0xf8) << 13);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 133 to 148
	value = ((uint32_t)(input[16] & 0x07) << 29) |
			((uint32_t)input[17] << 21) |
			((uint32_t)(input[18] & 0xf8) << 13);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 149 to 164
	value = ((uint32_t)(input[18] & 0x07) << 29) |
			((uint32_t)input[19] << 21) |
			((uint32_t)(input[20] & 0xf8) << 13);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 165 to 180
	value = ((uint32_t)(input[20] & 0x07) << 29) |
			((uint32_t)input[21] << 21) |
			((uint32_t)(input[22] & 0xf8) << 13);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 181 to 196
	value = ((uint32_t)(input[22] & 0x07) << 29) |
			((uint32_t)input[23] << 21) |
			((uint32_t)(input[24] & 0xf8) << 13);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 197 to 212
	value = ((uint32_t)(input[24] & 0x07) << 29) |
			((uint32_t)input[25] << 21) |
			((uint32_t)(input[26] & 0xf8) << 13);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 213 to 228
	value = ((uint32_t)(input[26] & 0x07) << 29) |
			((uint32_t)input[27] << 21) |
			((uint32_t)(input[28] & 0xf8) << 13);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 229 to 244
	value = ((uint32_t)(input[28] & 0x07) << 29) |
			((uint32_t)input[29] << 21) |
			((uint32_t)(input[30] & 0xf8) << 13);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 245 to 260
	value = ((uint32_t)(input[30] & 0x07) << 29) |
			((uint32_t)input[31] << 21) |
			((uint32_t)(input[32] & 0xf8) << 13);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 261 to 276
	value = ((uint32_t)(input[32] & 0x07) << 29) |
			((uint32_t)input[33] << 21) |
			((uint32_t)(input[34] & 0xf8) << 13);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 277 to 292
	value = ((uint32_t)(input[34] & 0x07) << 29) |
			((uint32_t)input[35] << 21) |
			((uint32_t)(input[36] & 0xf8) << 13);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 293 to 308
	value = ((uint32_t)(input[36] & 0x07) << 29) |
			((uint32_t)input[37] << 21) |
			((uint32_t)(input[38] & 0xf8) << 13);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 309 to 324
	value = ((uint32_t)(input[38] & 0x07) << 29) |
			((uint32_t)input[39] << 21) |
			((uint32_t)(input[40] & 0xf8) << 13);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 325 to 340
	value = ((uint32_t)(input[40] & 0x07) << 29) |
			((uint32_t)input[41] << 21) |
			((uint32_t)(input[42] & 0xf8) << 13);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 341 to 356
	value = ((uint32_t)(input[42] & 0x07) << 29) |
			((uint32_t)input[43] << 21) |
			((uint32_t)(input[44] & 0xf8) << 13);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 357 to 372
	value = ((uint32_t)(input[44] & 0x07) << 29) |
			((uint32_t)input[45] << 21) |
			((uint32_t)(input[46] & 0xf8) << 13);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 373 to 388
	value = ((uint32_t)(input[46] & 0x07) << 29) |
			((uint32_t)input[47] << 21) |
			((uint32_t)(input[48] & 0xf8) << 13);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 389 to 404
	value = ((uint32_t)(input[48] & 0x07) << 29) |
			((uint32_t)input[49] << 21) |
			((uint32_t)(input[50] & 0xf8) << 13);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 405 to 420
	value = ((uint32_t)(input[50] & 0x07) << 29) |
			((uint32_t)input[51] << 21) |
			((uint32_t)(input[52] & 0xf8) << 13);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 421 to 436
	value = ((uint32_t)(input[52] & 0x07) << 29) |
			((uint32_t)input[53] << 21) |
			((uint32_t)(input[54] & 0xf8) << 13);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 437 to 452
	value = ((uint32_t)(input[54] & 0x07) << 29) |
			((uint32_t)input[55] << 21) |
			((uint32_t)(input[56] & 0xf8) << 13);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 453 to 468
	value = ((uint32_t)(input[56] & 0x07) << 29) |
			((uint32_t)input[57] << 21) |
			((uint32_t)(input[58] & 0xf8) << 13);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 469 to 484
	value = ((uint32_t)(input[58] & 0x07) << 29) |
			((uint32_t)input[59] << 21) |
			((uint32_t)(input[60] & 0xf8) << 13);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 485 to 500
	value = ((uint32_t)(input[60] & 0x07) << 29) |
			((uint32_t)input[61] << 21) |
			((uint32_t)(input[62] & 0xf8) << 13);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 501 to 516
	value = ((uint32_t)(input[62] & 0x07) << 29) |
			((uint32_t)input[63] << 21) |
			((uint32_t)(input[64] & 0xf8) << 13);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 517 to 532
	value = ((uint32_t)(input[64] & 0x07) << 29) |
			((uint32_t)input[65] << 21) |
			((uint32_t)(input[66] & 0xf8) << 13);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 533 to 548
	value = ((uint32_t)(input[66] & 0x07) << 29) |
			((uint32_t)input[67] << 21) |
			((uint32_t)(input[68] & 0xf8) << 13);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 549 to 564
	value = ((uint32_t)(input[68] & 0x07) << 29) |
			((uint32_t)input[69] << 21) |
			((uint32_t)(input[70] & 0xf8) << 13);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 565 to 580
	value = ((uint32_t)(input[70] & 0x07) << 29) |
			((uint32_t)input[71] << 21) |
			((uint32_t)(input[72] & 0xf8) << 13);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 581 to 596
	value = ((uint32_t)(input[72] & 0x07) << 29) |
			((uint32_t)input[73] << 21) |
			((uint32_t)(input[74] & 0xf8) << 13);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 597 to 612
	value = ((uint32_t)(input[74] & 0x07) << 29) |
			((uint32_t)input[75] << 21) |
			((uint32_t)(input[76] & 0xf8) << 13);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 613 to 628
	value = ((uint32_t)(input[76] & 0x07) << 29) |
			((uint32_t)input[77] << 21) |
			((uint32_t)(input[78] & 0xf8) << 13);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 629 to 644
	value = ((uint32_t)(input[78] & 0x07) << 29) |
			((uint32_t)input[79] << 21) |
			((uint32_t)(input[80] & 0xf8) << 13);
	output[39] = (double)(value >> 16);

	// read output[40]: from bit 645 to 660
	value = ((uint32_t)(input[80] & 0x07) << 29) |
			((uint32_t)input[81] << 21) |
			((uint32_t)(input[82] & 0xf8) << 13);
	output[40] = (double)(value >> 16);

	// read output[41]: from bit 661 to 676
	value = ((uint32_t)(input[82] & 0x07) << 29) |
			((uint32_t)input[83] << 21) |
			((uint32_t)(input[84] & 0xf8) << 13);
	output[41] = (double)(value >> 16);

	// read output[42]: from bit 677 to 692
	value = ((uint32_t)(input[84] & 0x07) << 29) |
			((uint32_t)input[85] << 21) |
			((uint32_t)(input[86] & 0xf8) << 13);
	output[42] = (double)(value >> 16);

	// read output[43]: from bit 693 to 708
	value = ((uint32_t)(input[86] & 0x07) << 29) |
			((uint32_t)input[87] << 21) |
			((uint32_t)(input[88] & 0xf8) << 13);
	output[43] = (double)(value >> 16);

	// read output[44]: from bit 709 to 724
	value = ((uint32_t)(input[88] & 0x07) << 29) |
			((uint32_t)input[89] << 21) |
			((uint32_t)(input[90] & 0xf8) << 13);
	output[44] = (double)(value >> 16);

	// read output[45]: from bit 725 to 740
	value = ((uint32_t)(input[90] & 0x07) << 29) |
			((uint32_t)input[91] << 21) |
			((uint32_t)(input[92] & 0xf8) << 13);
	output[45] = (double)(value >> 16);

	// read output[46]: from bit 741 to 756
	value = ((uint32_t)(input[92] & 0x07) << 29) |
			((uint32_t)input[93] << 21) |
			((uint32_t)(input[94] & 0xf8) << 13);
	output[46] = (double)(value >> 16);

	// read output[47]: from bit 757 to 772
	value = ((uint32_t)(input[94] & 0x07) << 29) |
			((uint32_t)input[95] << 21) |
			((uint32_t)(input[96] & 0xf8) << 13);
	output[47] = (double)(value >> 16);

	// read output[48]: from bit 773 to 788
	value = ((uint32_t)(input[96] & 0x07) << 29) |
			((uint32_t)input[97] << 21) |
			((uint32_t)(input[98] & 0xf8) << 13);
	output[48] = (double)(value >> 16);

	// read output[49]: from bit 789 to 804
	value = ((uint32_t)(input[98] & 0x07) << 29) |
			((uint32_t)input[99] << 21) |
			((uint32_t)(input[100] & 0xf8) << 13);
	output[49] = (double)(value >> 16);

	// read output[50]: from bit 805 to 820
	value = ((uint32_t)(input[100] & 0x07) << 29) |
			((uint32_t)input[101] << 21) |
			((uint32_t)(input[102] & 0xf8) << 13);
	output[50] = (double)(value >> 16);

	// read output[51]: from bit 821 to 836
	value = ((uint32_t)(input[102] & 0x07) << 29) |
			((uint32_t)input[103] << 21) |
			((uint32_t)(input[104] & 0xf8) << 13);
	output[51] = (double)(value >> 16);

	// read output[52]: from bit 837 to 852
	value = ((uint32_t)(input[104] & 0x07) << 29) |
			((uint32_t)input[105] << 21) |
			((uint32_t)(input[106] & 0xf8) << 13);
	output[52] = (double)(value >> 16);

	// read output[53]: from bit 853 to 868
	value = ((uint32_t)(input[106] & 0x07) << 29) |
			((uint32_t)input[107] << 21) |
			((uint32_t)(input[108] & 0xf8) << 13);
	output[53] = (double)(value >> 16);

	// read output[54]: from bit 869 to 884
	value = ((uint32_t)(input[108] & 0x07) << 29) |
			((uint32_t)input[109] << 21) |
			((uint32_t)(input[110] & 0xf8) << 13);
	output[54] = (double)(value >> 16);

	// read output[55]: from bit 885 to 900
	value = ((uint32_t)(input[110] & 0x07) << 29) |
			((uint32_t)input[111] << 21) |
			((uint32_t)(input[112] & 0xf8) << 13);
	output[55] = (double)(value >> 16);

	// read output[56]: from bit 901 to 916
	value = ((uint32_t)(input[112] & 0x07) << 29) |
			((uint32_t)input[113] << 21) |
			((uint32_t)(input[114] & 0xf8) << 13);
	output[56] = (double)(value >> 16);

	// read output[57]: from bit 917 to 932
	value = ((uint32_t)(input[114] & 0x07) << 29) |
			((uint32_t)input[115] << 21) |
			((uint32_t)(input[116] & 0xf8) << 13);
	output[57] = (double)(value >> 16);

	// read output[58]: from bit 933 to 948
	value = ((uint32_t)(input[116] & 0x07) << 29) |
			((uint32_t)input[117] << 21) |
			((uint32_t)(input[118] & 0xf8) << 13);
	output[58] = (double)(value >> 16);

	// read output[59]: from bit 949 to 964
	value = ((uint32_t)(input[118] & 0x07) << 29) |
			((uint32_t)input[119] << 21) |
			((uint32_t)(input[120] & 0xf8) << 13);
	output[59] = (double)(value >> 16);

	// read output[60]: from bit 965 to 980
	value = ((uint32_t)(input[120] & 0x07) << 29) |
			((uint32_t)input[121] << 21) |
			((uint32_t)(input[122] & 0xf8) << 13);
	output[60] = (double)(value >> 16);

	// read output[61]: from bit 981 to 996
	value = ((uint32_t)(input[122] & 0x07) << 29) |
			((uint32_t)input[123] << 21) |
			((uint32_t)(input[124] & 0xf8) << 13);
	output[61] = (double)(value >> 16);

	// read output[62]: from bit 997 to 1012
	value = ((uint32_t)(input[124] & 0x07) << 29) |
			((uint32_t)input[125] << 21) |
			((uint32_t)(input[126] & 0xf8) << 13);
	output[62] = (double)(value >> 16);

	// read output[63]: from bit 1013 to 1028
	value = ((uint32_t)(input[126] & 0x07) << 29) |
			((uint32_t)input[127] << 21) |
			((uint32_t)(input[128] & 0xf8) << 13);
	output[63] = (double)(value >> 16);
}

static void unpack_64_16bit_unsigned_5off(const uint8_t * input, double * output, void *closure) {
	// Unpack 64 values into output
	// Values are 16-bit unsigned
	// Skip 5 bits, read 1024 bits of data.
	// Input must be at least 129 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 5 to 20
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)(input[2] & 0xf8) << 13);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 21 to 36
	value = ((uint32_t)(input[2] & 0x07) << 29) |
			((uint32_t)input[3] << 21) |
			((uint32_t)(input[4] & 0xf8) << 13);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 37 to 52
	value = ((uint32_t)(input[4] & 0x07) << 29) |
			((uint32_t)input[5] << 21) |
			((uint32_t)(input[6] & 0xf8) << 13);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 53 to 68
	value = ((uint32_t)(input[6] & 0x07) << 29) |
			((uint32_t)input[7] << 21) |
			((uint32_t)(input[8] & 0xf8) << 13);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 69 to 84
	value = ((uint32_t)(input[8] & 0x07) << 29) |
			((uint32_t)input[9] << 21) |
			((uint32_t)(input[10] & 0xf8) << 13);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 85 to 100
	value = ((uint32_t)(input[10] & 0x07) << 29) |
			((uint32_t)input[11] << 21) |
			((uint32_t)(input[12] & 0xf8) << 13);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 101 to 116
	value = ((uint32_t)(input[12] & 0x07) << 29) |
			((uint32_t)input[13] << 21) |
			((uint32_t)(input[14] & 0xf8) << 13);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 117 to 132
	value = ((uint32_t)(input[14] & 0x07) << 29) |
			((uint32_t)input[15] << 21) |
			((uint32_t)(input[16] & 0xf8) << 13);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 133 to 148
	value = ((uint32_t)(input[16] & 0x07) << 29) |
			((uint32_t)input[17] << 21) |
			((uint32_t)(input[18] & 0xf8) << 13);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 149 to 164
	value = ((uint32_t)(input[18] & 0x07) << 29) |
			((uint32_t)input[19] << 21) |
			((uint32_t)(input[20] & 0xf8) << 13);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 165 to 180
	value = ((uint32_t)(input[20] & 0x07) << 29) |
			((uint32_t)input[21] << 21) |
			((uint32_t)(input[22] & 0xf8) << 13);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 181 to 196
	value = ((uint32_t)(input[22] & 0x07) << 29) |
			((uint32_t)input[23] << 21) |
			((uint32_t)(input[24] & 0xf8) << 13);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 197 to 212
	value = ((uint32_t)(input[24] & 0x07) << 29) |
			((uint32_t)input[25] << 21) |
			((uint32_t)(input[26] & 0xf8) << 13);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 213 to 228
	value = ((uint32_t)(input[26] & 0x07) << 29) |
			((uint32_t)input[27] << 21) |
			((uint32_t)(input[28] & 0xf8) << 13);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 229 to 244
	value = ((uint32_t)(input[28] & 0x07) << 29) |
			((uint32_t)input[29] << 21) |
			((uint32_t)(input[30] & 0xf8) << 13);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 245 to 260
	value = ((uint32_t)(input[30] & 0x07) << 29) |
			((uint32_t)input[31] << 21) |
			((uint32_t)(input[32] & 0xf8) << 13);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 261 to 276
	value = ((uint32_t)(input[32] & 0x07) << 29) |
			((uint32_t)input[33] << 21) |
			((uint32_t)(input[34] & 0xf8) << 13);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 277 to 292
	value = ((uint32_t)(input[34] & 0x07) << 29) |
			((uint32_t)input[35] << 21) |
			((uint32_t)(input[36] & 0xf8) << 13);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 293 to 308
	value = ((uint32_t)(input[36] & 0x07) << 29) |
			((uint32_t)input[37] << 21) |
			((uint32_t)(input[38] & 0xf8) << 13);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 309 to 324
	value = ((uint32_t)(input[38] & 0x07) << 29) |
			((uint32_t)input[39] << 21) |
			((uint32_t)(input[40] & 0xf8) << 13);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 325 to 340
	value = ((uint32_t)(input[40] & 0x07) << 29) |
			((uint32_t)input[41] << 21) |
			((uint32_t)(input[42] & 0xf8) << 13);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 341 to 356
	value = ((uint32_t)(input[42] & 0x07) << 29) |
			((uint32_t)input[43] << 21) |
			((uint32_t)(input[44] & 0xf8) << 13);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 357 to 372
	value = ((uint32_t)(input[44] & 0x07) << 29) |
			((uint32_t)input[45] << 21) |
			((uint32_t)(input[46] & 0xf8) << 13);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 373 to 388
	value = ((uint32_t)(input[46] & 0x07) << 29) |
			((uint32_t)input[47] << 21) |
			((uint32_t)(input[48] & 0xf8) << 13);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 389 to 404
	value = ((uint32_t)(input[48] & 0x07) << 29) |
			((uint32_t)input[49] << 21) |
			((uint32_t)(input[50] & 0xf8) << 13);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 405 to 420
	value = ((uint32_t)(input[50] & 0x07) << 29) |
			((uint32_t)input[51] << 21) |
			((uint32_t)(input[52] & 0xf8) << 13);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 421 to 436
	value = ((uint32_t)(input[52] & 0x07) << 29) |
			((uint32_t)input[53] << 21) |
			((uint32_t)(input[54] & 0xf8) << 13);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 437 to 452
	value = ((uint32_t)(input[54] & 0x07) << 29) |
			((uint32_t)input[55] << 21) |
			((uint32_t)(input[56] & 0xf8) << 13);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 453 to 468
	value = ((uint32_t)(input[56] & 0x07) << 29) |
			((uint32_t)input[57] << 21) |
			((uint32_t)(input[58] & 0xf8) << 13);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 469 to 484
	value = ((uint32_t)(input[58] & 0x07) << 29) |
			((uint32_t)input[59] << 21) |
			((uint32_t)(input[60] & 0xf8) << 13);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 485 to 500
	value = ((uint32_t)(input[60] & 0x07) << 29) |
			((uint32_t)input[61] << 21) |
			((uint32_t)(input[62] & 0xf8) << 13);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 501 to 516
	value = ((uint32_t)(input[62] & 0x07) << 29) |
			((uint32_t)input[63] << 21) |
			((uint32_t)(input[64] & 0xf8) << 13);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 517 to 532
	value = ((uint32_t)(input[64] & 0x07) << 29) |
			((uint32_t)input[65] << 21) |
			((uint32_t)(input[66] & 0xf8) << 13);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 533 to 548
	value = ((uint32_t)(input[66] & 0x07) << 29) |
			((uint32_t)input[67] << 21) |
			((uint32_t)(input[68] & 0xf8) << 13);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 549 to 564
	value = ((uint32_t)(input[68] & 0x07) << 29) |
			((uint32_t)input[69] << 21) |
			((uint32_t)(input[70] & 0xf8) << 13);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 565 to 580
	value = ((uint32_t)(input[70] & 0x07) << 29) |
			((uint32_t)input[71] << 21) |
			((uint32_t)(input[72] & 0xf8) << 13);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 581 to 596
	value = ((uint32_t)(input[72] & 0x07) << 29) |
			((uint32_t)input[73] << 21) |
			((uint32_t)(input[74] & 0xf8) << 13);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 597 to 612
	value = ((uint32_t)(input[74] & 0x07) << 29) |
			((uint32_t)input[75] << 21) |
			((uint32_t)(input[76] & 0xf8) << 13);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 613 to 628
	value = ((uint32_t)(input[76] & 0x07) << 29) |
			((uint32_t)input[77] << 21) |
			((uint32_t)(input[78] & 0xf8) << 13);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 629 to 644
	value = ((uint32_t)(input[78] & 0x07) << 29) |
			((uint32_t)input[79] << 21) |
			((uint32_t)(input[80] & 0xf8) << 13);
	output[39] = (double)(value >> 16);

	// read output[40]: from bit 645 to 660
	value = ((uint32_t)(input[80] & 0x07) << 29) |
			((uint32_t)input[81] << 21) |
			((uint32_t)(input[82] & 0xf8) << 13);
	output[40] = (double)(value >> 16);

	// read output[41]: from bit 661 to 676
	value = ((uint32_t)(input[82] & 0x07) << 29) |
			((uint32_t)input[83] << 21) |
			((uint32_t)(input[84] & 0xf8) << 13);
	output[41] = (double)(value >> 16);

	// read output[42]: from bit 677 to 692
	value = ((uint32_t)(input[84] & 0x07) << 29) |
			((uint32_t)input[85] << 21) |
			((uint32_t)(input[86] & 0xf8) << 13);
	output[42] = (double)(value >> 16);

	// read output[43]: from bit 693 to 708
	value = ((uint32_t)(input[86] & 0x07) << 29) |
			((uint32_t)input[87] << 21) |
			((uint32_t)(input[88] & 0xf8) << 13);
	output[43] = (double)(value >> 16);

	// read output[44]: from bit 709 to 724
	value = ((uint32_t)(input[88] & 0x07) << 29) |
			((uint32_t)input[89] << 21) |
			((uint32_t)(input[90] & 0xf8) << 13);
	output[44] = (double)(value >> 16);

	// read output[45]: from bit 725 to 740
	value = ((uint32_t)(input[90] & 0x07) << 29) |
			((uint32_t)input[91] << 21) |
			((uint32_t)(input[92] & 0xf8) << 13);
	output[45] = (double)(value >> 16);

	// read output[46]: from bit 741 to 756
	value = ((uint32_t)(input[92] & 0x07) << 29) |
			((uint32_t)input[93] << 21) |
			((uint32_t)(input[94] & 0xf8) << 13);
	output[46] = (double)(value >> 16);

	// read output[47]: from bit 757 to 772
	value = ((uint32_t)(input[94] & 0x07) << 29) |
			((uint32_t)input[95] << 21) |
			((uint32_t)(input[96] & 0xf8) << 13);
	output[47] = (double)(value >> 16);

	// read output[48]: from bit 773 to 788
	value = ((uint32_t)(input[96] & 0x07) << 29) |
			((uint32_t)input[97] << 21) |
			((uint32_t)(input[98] & 0xf8) << 13);
	output[48] = (double)(value >> 16);

	// read output[49]: from bit 789 to 804
	value = ((uint32_t)(input[98] & 0x07) << 29) |
			((uint32_t)input[99] << 21) |
			((uint32_t)(input[100] & 0xf8) << 13);
	output[49] = (double)(value >> 16);

	// read output[50]: from bit 805 to 820
	value = ((uint32_t)(input[100] & 0x07) << 29) |
			((uint32_t)input[101] << 21) |
			((uint32_t)(input[102] & 0xf8) << 13);
	output[50] = (double)(value >> 16);

	// read output[51]: from bit 821 to 836
	value = ((uint32_t)(input[102] & 0x07) << 29) |
			((uint32_t)input[103] << 21) |
			((uint32_t)(input[104] & 0xf8) << 13);
	output[51] = (double)(value >> 16);

	// read output[52]: from bit 837 to 852
	value = ((uint32_t)(input[104] & 0x07) << 29) |
			((uint32_t)input[105] << 21) |
			((uint32_t)(input[106] & 0xf8) << 13);
	output[52] = (double)(value >> 16);

	// read output[53]: from bit 853 to 868
	value = ((uint32_t)(input[106] & 0x07) << 29) |
			((uint32_t)input[107] << 21) |
			((uint32_t)(input[108] & 0xf8) << 13);
	output[53] = (double)(value >> 16);

	// read output[54]: from bit 869 to 884
	value = ((uint32_t)(input[108] & 0x07) << 29) |
			((uint32_t)input[109] << 21) |
			((uint32_t)(input[110] & 0xf8) << 13);
	output[54] = (double)(value >> 16);

	// read output[55]: from bit 885 to 900
	value = ((uint32_t)(input[110] & 0x07) << 29) |
			((uint32_t)input[111] << 21) |
			((uint32_t)(input[112] & 0xf8) << 13);
	output[55] = (double)(value >> 16);

	// read output[56]: from bit 901 to 916
	value = ((uint32_t)(input[112] & 0x07) << 29) |
			((uint32_t)input[113] << 21) |
			((uint32_t)(input[114] & 0xf8) << 13);
	output[56] = (double)(value >> 16);

	// read output[57]: from bit 917 to 932
	value = ((uint32_t)(input[114] & 0x07) << 29) |
			((uint32_t)input[115] << 21) |
			((uint32_t)(input[116] & 0xf8) << 13);
	output[57] = (double)(value >> 16);

	// read output[58]: from bit 933 to 948
	value = ((uint32_t)(input[116] & 0x07) << 29) |
			((uint32_t)input[117] << 21) |
			((uint32_t)(input[118] & 0xf8) << 13);
	output[58] = (double)(value >> 16);

	// read output[59]: from bit 949 to 964
	value = ((uint32_t)(input[118] & 0x07) << 29) |
			((uint32_t)input[119] << 21) |
			((uint32_t)(input[120] & 0xf8) << 13);
	output[59] = (double)(value >> 16);

	// read output[60]: from bit 965 to 980
	value = ((uint32_t)(input[120] & 0x07) << 29) |
			((uint32_t)input[121] << 21) |
			((uint32_t)(input[122] & 0xf8) << 13);
	output[60] = (double)(value >> 16);

	// read output[61]: from bit 981 to 996
	value = ((uint32_t)(input[122] & 0x07) << 29) |
			((uint32_t)input[123] << 21) |
			((uint32_t)(input[124] & 0xf8) << 13);
	output[61] = (double)(value >> 16);

	// read output[62]: from bit 997 to 1012
	value = ((uint32_t)(input[124] & 0x07) << 29) |
			((uint32_t)input[125] << 21) |
			((uint32_t)(input[126] & 0xf8) << 13);
	output[62] = (double)(value >> 16);

	// read output[63]: from bit 1013 to 1028
	value = ((uint32_t)(input[126] & 0x07) << 29) |
			((uint32_t)input[127] << 21) |
			((uint32_t)(input[128] & 0xf8) << 13);
	output[63] = (double)(value >> 16);
}

static void unpack_64_16bit_signed_6off(const uint8_t * input, double * output, void *closure) {
	// Unpack 64 values into output
	// Values are 16-bit signed
	// Skip 6 bits, read 1024 bits of data.
	// Input must be at least 129 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 6 to 21
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)(input[2] & 0xfc) << 14);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 22 to 37
	value = ((uint32_t)(input[2] & 0x03) << 30) |
			((uint32_t)input[3] << 22) |
			((uint32_t)(input[4] & 0xfc) << 14);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 38 to 53
	value = ((uint32_t)(input[4] & 0x03) << 30) |
			((uint32_t)input[5] << 22) |
			((uint32_t)(input[6] & 0xfc) << 14);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 54 to 69
	value = ((uint32_t)(input[6] & 0x03) << 30) |
			((uint32_t)input[7] << 22) |
			((uint32_t)(input[8] & 0xfc) << 14);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 70 to 85
	value = ((uint32_t)(input[8] & 0x03) << 30) |
			((uint32_t)input[9] << 22) |
			((uint32_t)(input[10] & 0xfc) << 14);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 86 to 101
	value = ((uint32_t)(input[10] & 0x03) << 30) |
			((uint32_t)input[11] << 22) |
			((uint32_t)(input[12] & 0xfc) << 14);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 102 to 117
	value = ((uint32_t)(input[12] & 0x03) << 30) |
			((uint32_t)input[13] << 22) |
			((uint32_t)(input[14] & 0xfc) << 14);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 118 to 133
	value = ((uint32_t)(input[14] & 0x03) << 30) |
			((uint32_t)input[15] << 22) |
			((uint32_t)(input[16] & 0xfc) << 14);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 134 to 149
	value = ((uint32_t)(input[16] & 0x03) << 30) |
			((uint32_t)input[17] << 22) |
			((uint32_t)(input[18] & 0xfc) << 14);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 150 to 165
	value = ((uint32_t)(input[18] & 0x03) << 30) |
			((uint32_t)input[19] << 22) |
			((uint32_t)(input[20] & 0xfc) << 14);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 166 to 181
	value = ((uint32_t)(input[20] & 0x03) << 30) |
			((uint32_t)input[21] << 22) |
			((uint32_t)(input[22] & 0xfc) << 14);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 182 to 197
	value = ((uint32_t)(input[22] & 0x03) << 30) |
			((uint32_t)input[23] << 22) |
			((uint32_t)(input[24] & 0xfc) << 14);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 198 to 213
	value = ((uint32_t)(input[24] & 0x03) << 30) |
			((uint32_t)input[25] << 22) |
			((uint32_t)(input[26] & 0xfc) << 14);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 214 to 229
	value = ((uint32_t)(input[26] & 0x03) << 30) |
			((uint32_t)input[27] << 22) |
			((uint32_t)(input[28] & 0xfc) << 14);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 230 to 245
	value = ((uint32_t)(input[28] & 0x03) << 30) |
			((uint32_t)input[29] << 22) |
			((uint32_t)(input[30] & 0xfc) << 14);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 246 to 261
	value = ((uint32_t)(input[30] & 0x03) << 30) |
			((uint32_t)input[31] << 22) |
			((uint32_t)(input[32] & 0xfc) << 14);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 262 to 277
	value = ((uint32_t)(input[32] & 0x03) << 30) |
			((uint32_t)input[33] << 22) |
			((uint32_t)(input[34] & 0xfc) << 14);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 278 to 293
	value = ((uint32_t)(input[34] & 0x03) << 30) |
			((uint32_t)input[35] << 22) |
			((uint32_t)(input[36] & 0xfc) << 14);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 294 to 309
	value = ((uint32_t)(input[36] & 0x03) << 30) |
			((uint32_t)input[37] << 22) |
			((uint32_t)(input[38] & 0xfc) << 14);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 310 to 325
	value = ((uint32_t)(input[38] & 0x03) << 30) |
			((uint32_t)input[39] << 22) |
			((uint32_t)(input[40] & 0xfc) << 14);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 326 to 341
	value = ((uint32_t)(input[40] & 0x03) << 30) |
			((uint32_t)input[41] << 22) |
			((uint32_t)(input[42] & 0xfc) << 14);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 342 to 357
	value = ((uint32_t)(input[42] & 0x03) << 30) |
			((uint32_t)input[43] << 22) |
			((uint32_t)(input[44] & 0xfc) << 14);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 358 to 373
	value = ((uint32_t)(input[44] & 0x03) << 30) |
			((uint32_t)input[45] << 22) |
			((uint32_t)(input[46] & 0xfc) << 14);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 374 to 389
	value = ((uint32_t)(input[46] & 0x03) << 30) |
			((uint32_t)input[47] << 22) |
			((uint32_t)(input[48] & 0xfc) << 14);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 390 to 405
	value = ((uint32_t)(input[48] & 0x03) << 30) |
			((uint32_t)input[49] << 22) |
			((uint32_t)(input[50] & 0xfc) << 14);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 406 to 421
	value = ((uint32_t)(input[50] & 0x03) << 30) |
			((uint32_t)input[51] << 22) |
			((uint32_t)(input[52] & 0xfc) << 14);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 422 to 437
	value = ((uint32_t)(input[52] & 0x03) << 30) |
			((uint32_t)input[53] << 22) |
			((uint32_t)(input[54] & 0xfc) << 14);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 438 to 453
	value = ((uint32_t)(input[54] & 0x03) << 30) |
			((uint32_t)input[55] << 22) |
			((uint32_t)(input[56] & 0xfc) << 14);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 454 to 469
	value = ((uint32_t)(input[56] & 0x03) << 30) |
			((uint32_t)input[57] << 22) |
			((uint32_t)(input[58] & 0xfc) << 14);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 470 to 485
	value = ((uint32_t)(input[58] & 0x03) << 30) |
			((uint32_t)input[59] << 22) |
			((uint32_t)(input[60] & 0xfc) << 14);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 486 to 501
	value = ((uint32_t)(input[60] & 0x03) << 30) |
			((uint32_t)input[61] << 22) |
			((uint32_t)(input[62] & 0xfc) << 14);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 502 to 517
	value = ((uint32_t)(input[62] & 0x03) << 30) |
			((uint32_t)input[63] << 22) |
			((uint32_t)(input[64] & 0xfc) << 14);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 518 to 533
	value = ((uint32_t)(input[64] & 0x03) << 30) |
			((uint32_t)input[65] << 22) |
			((uint32_t)(input[66] & 0xfc) << 14);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 534 to 549
	value = ((uint32_t)(input[66] & 0x03) << 30) |
			((uint32_t)input[67] << 22) |
			((uint32_t)(input[68] & 0xfc) << 14);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 550 to 565
	value = ((uint32_t)(input[68] & 0x03) << 30) |
			((uint32_t)input[69] << 22) |
			((uint32_t)(input[70] & 0xfc) << 14);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 566 to 581
	value = ((uint32_t)(input[70] & 0x03) << 30) |
			((uint32_t)input[71] << 22) |
			((uint32_t)(input[72] & 0xfc) << 14);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 582 to 597
	value = ((uint32_t)(input[72] & 0x03) << 30) |
			((uint32_t)input[73] << 22) |
			((uint32_t)(input[74] & 0xfc) << 14);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 598 to 613
	value = ((uint32_t)(input[74] & 0x03) << 30) |
			((uint32_t)input[75] << 22) |
			((uint32_t)(input[76] & 0xfc) << 14);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 614 to 629
	value = ((uint32_t)(input[76] & 0x03) << 30) |
			((uint32_t)input[77] << 22) |
			((uint32_t)(input[78] & 0xfc) << 14);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 630 to 645
	value = ((uint32_t)(input[78] & 0x03) << 30) |
			((uint32_t)input[79] << 22) |
			((uint32_t)(input[80] & 0xfc) << 14);
	output[39] = (double)(value >> 16);

	// read output[40]: from bit 646 to 661
	value = ((uint32_t)(input[80] & 0x03) << 30) |
			((uint32_t)input[81] << 22) |
			((uint32_t)(input[82] & 0xfc) << 14);
	output[40] = (double)(value >> 16);

	// read output[41]: from bit 662 to 677
	value = ((uint32_t)(input[82] & 0x03) << 30) |
			((uint32_t)input[83] << 22) |
			((uint32_t)(input[84] & 0xfc) << 14);
	output[41] = (double)(value >> 16);

	// read output[42]: from bit 678 to 693
	value = ((uint32_t)(input[84] & 0x03) << 30) |
			((uint32_t)input[85] << 22) |
			((uint32_t)(input[86] & 0xfc) << 14);
	output[42] = (double)(value >> 16);

	// read output[43]: from bit 694 to 709
	value = ((uint32_t)(input[86] & 0x03) << 30) |
			((uint32_t)input[87] << 22) |
			((uint32_t)(input[88] & 0xfc) << 14);
	output[43] = (double)(value >> 16);

	// read output[44]: from bit 710 to 725
	value = ((uint32_t)(input[88] & 0x03) << 30) |
			((uint32_t)input[89] << 22) |
			((uint32_t)(input[90] & 0xfc) << 14);
	output[44] = (double)(value >> 16);

	// read output[45]: from bit 726 to 741
	value = ((uint32_t)(input[90] & 0x03) << 30) |
			((uint32_t)input[91] << 22) |
			((uint32_t)(input[92] & 0xfc) << 14);
	output[45] = (double)(value >> 16);

	// read output[46]: from bit 742 to 757
	value = ((uint32_t)(input[92] & 0x03) << 30) |
			((uint32_t)input[93] << 22) |
			((uint32_t)(input[94] & 0xfc) << 14);
	output[46] = (double)(value >> 16);

	// read output[47]: from bit 758 to 773
	value = ((uint32_t)(input[94] & 0x03) << 30) |
			((uint32_t)input[95] << 22) |
			((uint32_t)(input[96] & 0xfc) << 14);
	output[47] = (double)(value >> 16);

	// read output[48]: from bit 774 to 789
	value = ((uint32_t)(input[96] & 0x03) << 30) |
			((uint32_t)input[97] << 22) |
			((uint32_t)(input[98] & 0xfc) << 14);
	output[48] = (double)(value >> 16);

	// read output[49]: from bit 790 to 805
	value = ((uint32_t)(input[98] & 0x03) << 30) |
			((uint32_t)input[99] << 22) |
			((uint32_t)(input[100] & 0xfc) << 14);
	output[49] = (double)(value >> 16);

	// read output[50]: from bit 806 to 821
	value = ((uint32_t)(input[100] & 0x03) << 30) |
			((uint32_t)input[101] << 22) |
			((uint32_t)(input[102] & 0xfc) << 14);
	output[50] = (double)(value >> 16);

	// read output[51]: from bit 822 to 837
	value = ((uint32_t)(input[102] & 0x03) << 30) |
			((uint32_t)input[103] << 22) |
			((uint32_t)(input[104] & 0xfc) << 14);
	output[51] = (double)(value >> 16);

	// read output[52]: from bit 838 to 853
	value = ((uint32_t)(input[104] & 0x03) << 30) |
			((uint32_t)input[105] << 22) |
			((uint32_t)(input[106] & 0xfc) << 14);
	output[52] = (double)(value >> 16);

	// read output[53]: from bit 854 to 869
	value = ((uint32_t)(input[106] & 0x03) << 30) |
			((uint32_t)input[107] << 22) |
			((uint32_t)(input[108] & 0xfc) << 14);
	output[53] = (double)(value >> 16);

	// read output[54]: from bit 870 to 885
	value = ((uint32_t)(input[108] & 0x03) << 30) |
			((uint32_t)input[109] << 22) |
			((uint32_t)(input[110] & 0xfc) << 14);
	output[54] = (double)(value >> 16);

	// read output[55]: from bit 886 to 901
	value = ((uint32_t)(input[110] & 0x03) << 30) |
			((uint32_t)input[111] << 22) |
			((uint32_t)(input[112] & 0xfc) << 14);
	output[55] = (double)(value >> 16);

	// read output[56]: from bit 902 to 917
	value = ((uint32_t)(input[112] & 0x03) << 30) |
			((uint32_t)input[113] << 22) |
			((uint32_t)(input[114] & 0xfc) << 14);
	output[56] = (double)(value >> 16);

	// read output[57]: from bit 918 to 933
	value = ((uint32_t)(input[114] & 0x03) << 30) |
			((uint32_t)input[115] << 22) |
			((uint32_t)(input[116] & 0xfc) << 14);
	output[57] = (double)(value >> 16);

	// read output[58]: from bit 934 to 949
	value = ((uint32_t)(input[116] & 0x03) << 30) |
			((uint32_t)input[117] << 22) |
			((uint32_t)(input[118] & 0xfc) << 14);
	output[58] = (double)(value >> 16);

	// read output[59]: from bit 950 to 965
	value = ((uint32_t)(input[118] & 0x03) << 30) |
			((uint32_t)input[119] << 22) |
			((uint32_t)(input[120] & 0xfc) << 14);
	output[59] = (double)(value >> 16);

	// read output[60]: from bit 966 to 981
	value = ((uint32_t)(input[120] & 0x03) << 30) |
			((uint32_t)input[121] << 22) |
			((uint32_t)(input[122] & 0xfc) << 14);
	output[60] = (double)(value >> 16);

	// read output[61]: from bit 982 to 997
	value = ((uint32_t)(input[122] & 0x03) << 30) |
			((uint32_t)input[123] << 22) |
			((uint32_t)(input[124] & 0xfc) << 14);
	output[61] = (double)(value >> 16);

	// read output[62]: from bit 998 to 1013
	value = ((uint32_t)(input[124] & 0x03) << 30) |
			((uint32_t)input[125] << 22) |
			((uint32_t)(input[126] & 0xfc) << 14);
	output[62] = (double)(value >> 16);

	// read output[63]: from bit 1014 to 1029
	value = ((uint32_t)(input[126] & 0x03) << 30) |
			((uint32_t)input[127] << 22) |
			((uint32_t)(input[128] & 0xfc) << 14);
	output[63] = (double)(value >> 16);
}

static void unpack_64_16bit_unsigned_6off(const uint8_t * input, double * output, void *closure) {
	// Unpack 64 values into output
	// Values are 16-bit unsigned
	// Skip 6 bits, read 1024 bits of data.
	// Input must be at least 129 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 6 to 21
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)(input[2] & 0xfc) << 14);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 22 to 37
	value = ((uint32_t)(input[2] & 0x03) << 30) |
			((uint32_t)input[3] << 22) |
			((uint32_t)(input[4] & 0xfc) << 14);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 38 to 53
	value = ((uint32_t)(input[4] & 0x03) << 30) |
			((uint32_t)input[5] << 22) |
			((uint32_t)(input[6] & 0xfc) << 14);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 54 to 69
	value = ((uint32_t)(input[6] & 0x03) << 30) |
			((uint32_t)input[7] << 22) |
			((uint32_t)(input[8] & 0xfc) << 14);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 70 to 85
	value = ((uint32_t)(input[8] & 0x03) << 30) |
			((uint32_t)input[9] << 22) |
			((uint32_t)(input[10] & 0xfc) << 14);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 86 to 101
	value = ((uint32_t)(input[10] & 0x03) << 30) |
			((uint32_t)input[11] << 22) |
			((uint32_t)(input[12] & 0xfc) << 14);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 102 to 117
	value = ((uint32_t)(input[12] & 0x03) << 30) |
			((uint32_t)input[13] << 22) |
			((uint32_t)(input[14] & 0xfc) << 14);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 118 to 133
	value = ((uint32_t)(input[14] & 0x03) << 30) |
			((uint32_t)input[15] << 22) |
			((uint32_t)(input[16] & 0xfc) << 14);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 134 to 149
	value = ((uint32_t)(input[16] & 0x03) << 30) |
			((uint32_t)input[17] << 22) |
			((uint32_t)(input[18] & 0xfc) << 14);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 150 to 165
	value = ((uint32_t)(input[18] & 0x03) << 30) |
			((uint32_t)input[19] << 22) |
			((uint32_t)(input[20] & 0xfc) << 14);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 166 to 181
	value = ((uint32_t)(input[20] & 0x03) << 30) |
			((uint32_t)input[21] << 22) |
			((uint32_t)(input[22] & 0xfc) << 14);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 182 to 197
	value = ((uint32_t)(input[22] & 0x03) << 30) |
			((uint32_t)input[23] << 22) |
			((uint32_t)(input[24] & 0xfc) << 14);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 198 to 213
	value = ((uint32_t)(input[24] & 0x03) << 30) |
			((uint32_t)input[25] << 22) |
			((uint32_t)(input[26] & 0xfc) << 14);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 214 to 229
	value = ((uint32_t)(input[26] & 0x03) << 30) |
			((uint32_t)input[27] << 22) |
			((uint32_t)(input[28] & 0xfc) << 14);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 230 to 245
	value = ((uint32_t)(input[28] & 0x03) << 30) |
			((uint32_t)input[29] << 22) |
			((uint32_t)(input[30] & 0xfc) << 14);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 246 to 261
	value = ((uint32_t)(input[30] & 0x03) << 30) |
			((uint32_t)input[31] << 22) |
			((uint32_t)(input[32] & 0xfc) << 14);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 262 to 277
	value = ((uint32_t)(input[32] & 0x03) << 30) |
			((uint32_t)input[33] << 22) |
			((uint32_t)(input[34] & 0xfc) << 14);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 278 to 293
	value = ((uint32_t)(input[34] & 0x03) << 30) |
			((uint32_t)input[35] << 22) |
			((uint32_t)(input[36] & 0xfc) << 14);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 294 to 309
	value = ((uint32_t)(input[36] & 0x03) << 30) |
			((uint32_t)input[37] << 22) |
			((uint32_t)(input[38] & 0xfc) << 14);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 310 to 325
	value = ((uint32_t)(input[38] & 0x03) << 30) |
			((uint32_t)input[39] << 22) |
			((uint32_t)(input[40] & 0xfc) << 14);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 326 to 341
	value = ((uint32_t)(input[40] & 0x03) << 30) |
			((uint32_t)input[41] << 22) |
			((uint32_t)(input[42] & 0xfc) << 14);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 342 to 357
	value = ((uint32_t)(input[42] & 0x03) << 30) |
			((uint32_t)input[43] << 22) |
			((uint32_t)(input[44] & 0xfc) << 14);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 358 to 373
	value = ((uint32_t)(input[44] & 0x03) << 30) |
			((uint32_t)input[45] << 22) |
			((uint32_t)(input[46] & 0xfc) << 14);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 374 to 389
	value = ((uint32_t)(input[46] & 0x03) << 30) |
			((uint32_t)input[47] << 22) |
			((uint32_t)(input[48] & 0xfc) << 14);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 390 to 405
	value = ((uint32_t)(input[48] & 0x03) << 30) |
			((uint32_t)input[49] << 22) |
			((uint32_t)(input[50] & 0xfc) << 14);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 406 to 421
	value = ((uint32_t)(input[50] & 0x03) << 30) |
			((uint32_t)input[51] << 22) |
			((uint32_t)(input[52] & 0xfc) << 14);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 422 to 437
	value = ((uint32_t)(input[52] & 0x03) << 30) |
			((uint32_t)input[53] << 22) |
			((uint32_t)(input[54] & 0xfc) << 14);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 438 to 453
	value = ((uint32_t)(input[54] & 0x03) << 30) |
			((uint32_t)input[55] << 22) |
			((uint32_t)(input[56] & 0xfc) << 14);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 454 to 469
	value = ((uint32_t)(input[56] & 0x03) << 30) |
			((uint32_t)input[57] << 22) |
			((uint32_t)(input[58] & 0xfc) << 14);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 470 to 485
	value = ((uint32_t)(input[58] & 0x03) << 30) |
			((uint32_t)input[59] << 22) |
			((uint32_t)(input[60] & 0xfc) << 14);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 486 to 501
	value = ((uint32_t)(input[60] & 0x03) << 30) |
			((uint32_t)input[61] << 22) |
			((uint32_t)(input[62] & 0xfc) << 14);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 502 to 517
	value = ((uint32_t)(input[62] & 0x03) << 30) |
			((uint32_t)input[63] << 22) |
			((uint32_t)(input[64] & 0xfc) << 14);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 518 to 533
	value = ((uint32_t)(input[64] & 0x03) << 30) |
			((uint32_t)input[65] << 22) |
			((uint32_t)(input[66] & 0xfc) << 14);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 534 to 549
	value = ((uint32_t)(input[66] & 0x03) << 30) |
			((uint32_t)input[67] << 22) |
			((uint32_t)(input[68] & 0xfc) << 14);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 550 to 565
	value = ((uint32_t)(input[68] & 0x03) << 30) |
			((uint32_t)input[69] << 22) |
			((uint32_t)(input[70] & 0xfc) << 14);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 566 to 581
	value = ((uint32_t)(input[70] & 0x03) << 30) |
			((uint32_t)input[71] << 22) |
			((uint32_t)(input[72] & 0xfc) << 14);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 582 to 597
	value = ((uint32_t)(input[72] & 0x03) << 30) |
			((uint32_t)input[73] << 22) |
			((uint32_t)(input[74] & 0xfc) << 14);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 598 to 613
	value = ((uint32_t)(input[74] & 0x03) << 30) |
			((uint32_t)input[75] << 22) |
			((uint32_t)(input[76] & 0xfc) << 14);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 614 to 629
	value = ((uint32_t)(input[76] & 0x03) << 30) |
			((uint32_t)input[77] << 22) |
			((uint32_t)(input[78] & 0xfc) << 14);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 630 to 645
	value = ((uint32_t)(input[78] & 0x03) << 30) |
			((uint32_t)input[79] << 22) |
			((uint32_t)(input[80] & 0xfc) << 14);
	output[39] = (double)(value >> 16);

	// read output[40]: from bit 646 to 661
	value = ((uint32_t)(input[80] & 0x03) << 30) |
			((uint32_t)input[81] << 22) |
			((uint32_t)(input[82] & 0xfc) << 14);
	output[40] = (double)(value >> 16);

	// read output[41]: from bit 662 to 677
	value = ((uint32_t)(input[82] & 0x03) << 30) |
			((uint32_t)input[83] << 22) |
			((uint32_t)(input[84] & 0xfc) << 14);
	output[41] = (double)(value >> 16);

	// read output[42]: from bit 678 to 693
	value = ((uint32_t)(input[84] & 0x03) << 30) |
			((uint32_t)input[85] << 22) |
			((uint32_t)(input[86] & 0xfc) << 14);
	output[42] = (double)(value >> 16);

	// read output[43]: from bit 694 to 709
	value = ((uint32_t)(input[86] & 0x03) << 30) |
			((uint32_t)input[87] << 22) |
			((uint32_t)(input[88] & 0xfc) << 14);
	output[43] = (double)(value >> 16);

	// read output[44]: from bit 710 to 725
	value = ((uint32_t)(input[88] & 0x03) << 30) |
			((uint32_t)input[89] << 22) |
			((uint32_t)(input[90] & 0xfc) << 14);
	output[44] = (double)(value >> 16);

	// read output[45]: from bit 726 to 741
	value = ((uint32_t)(input[90] & 0x03) << 30) |
			((uint32_t)input[91] << 22) |
			((uint32_t)(input[92] & 0xfc) << 14);
	output[45] = (double)(value >> 16);

	// read output[46]: from bit 742 to 757
	value = ((uint32_t)(input[92] & 0x03) << 30) |
			((uint32_t)input[93] << 22) |
			((uint32_t)(input[94] & 0xfc) << 14);
	output[46] = (double)(value >> 16);

	// read output[47]: from bit 758 to 773
	value = ((uint32_t)(input[94] & 0x03) << 30) |
			((uint32_t)input[95] << 22) |
			((uint32_t)(input[96] & 0xfc) << 14);
	output[47] = (double)(value >> 16);

	// read output[48]: from bit 774 to 789
	value = ((uint32_t)(input[96] & 0x03) << 30) |
			((uint32_t)input[97] << 22) |
			((uint32_t)(input[98] & 0xfc) << 14);
	output[48] = (double)(value >> 16);

	// read output[49]: from bit 790 to 805
	value = ((uint32_t)(input[98] & 0x03) << 30) |
			((uint32_t)input[99] << 22) |
			((uint32_t)(input[100] & 0xfc) << 14);
	output[49] = (double)(value >> 16);

	// read output[50]: from bit 806 to 821
	value = ((uint32_t)(input[100] & 0x03) << 30) |
			((uint32_t)input[101] << 22) |
			((uint32_t)(input[102] & 0xfc) << 14);
	output[50] = (double)(value >> 16);

	// read output[51]: from bit 822 to 837
	value = ((uint32_t)(input[102] & 0x03) << 30) |
			((uint32_t)input[103] << 22) |
			((uint32_t)(input[104] & 0xfc) << 14);
	output[51] = (double)(value >> 16);

	// read output[52]: from bit 838 to 853
	value = ((uint32_t)(input[104] & 0x03) << 30) |
			((uint32_t)input[105] << 22) |
			((uint32_t)(input[106] & 0xfc) << 14);
	output[52] = (double)(value >> 16);

	// read output[53]: from bit 854 to 869
	value = ((uint32_t)(input[106] & 0x03) << 30) |
			((uint32_t)input[107] << 22) |
			((uint32_t)(input[108] & 0xfc) << 14);
	output[53] = (double)(value >> 16);

	// read output[54]: from bit 870 to 885
	value = ((uint32_t)(input[108] & 0x03) << 30) |
			((uint32_t)input[109] << 22) |
			((uint32_t)(input[110] & 0xfc) << 14);
	output[54] = (double)(value >> 16);

	// read output[55]: from bit 886 to 901
	value = ((uint32_t)(input[110] & 0x03) << 30) |
			((uint32_t)input[111] << 22) |
			((uint32_t)(input[112] & 0xfc) << 14);
	output[55] = (double)(value >> 16);

	// read output[56]: from bit 902 to 917
	value = ((uint32_t)(input[112] & 0x03) << 30) |
			((uint32_t)input[113] << 22) |
			((uint32_t)(input[114] & 0xfc) << 14);
	output[56] = (double)(value >> 16);

	// read output[57]: from bit 918 to 933
	value = ((uint32_t)(input[114] & 0x03) << 30) |
			((uint32_t)input[115] << 22) |
			((uint32_t)(input[116] & 0xfc) << 14);
	output[57] = (double)(value >> 16);

	// read output[58]: from bit 934 to 949
	value = ((uint32_t)(input[116] & 0x03) << 30) |
			((uint32_t)input[117] << 22) |
			((uint32_t)(input[118] & 0xfc) << 14);
	output[58] = (double)(value >> 16);

	// read output[59]: from bit 950 to 965
	value = ((uint32_t)(input[118] & 0x03) << 30) |
			((uint32_t)input[119] << 22) |
			((uint32_t)(input[120] & 0xfc) << 14);
	output[59] = (double)(value >> 16);

	// read output[60]: from bit 966 to 981
	value = ((uint32_t)(input[120] & 0x03) << 30) |
			((uint32_t)input[121] << 22) |
			((uint32_t)(input[122] & 0xfc) << 14);
	output[60] = (double)(value >> 16);

	// read output[61]: from bit 982 to 997
	value = ((uint32_t)(input[122] & 0x03) << 30) |
			((uint32_t)input[123] << 22) |
			((uint32_t)(input[124] & 0xfc) << 14);
	output[61] = (double)(value >> 16);

	// read output[62]: from bit 998 to 1013
	value = ((uint32_t)(input[124] & 0x03) << 30) |
			((uint32_t)input[125] << 22) |
			((uint32_t)(input[126] & 0xfc) << 14);
	output[62] = (double)(value >> 16);

	// read output[63]: from bit 1014 to 1029
	value = ((uint32_t)(input[126] & 0x03) << 30) |
			((uint32_t)input[127] << 22) |
			((uint32_t)(input[128] & 0xfc) << 14);
	output[63] = (double)(value >> 16);
}

static void unpack_64_16bit_signed_7off(const uint8_t * input, double * output, void *closure) {
	// Unpack 64 values into output
	// Values are 16-bit signed
	// Skip 7 bits, read 1024 bits of data.
	// Input must be at least 129 bytes long

	(void)closure; // suppress unused parameter warning

	int32_t value;

	// read output[0]: from bit 7 to 22
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)(input[2] & 0xfe) << 15);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 23 to 38
	value = ((uint32_t)(input[2] & 0x01) << 31) |
			((uint32_t)input[3] << 23) |
			((uint32_t)(input[4] & 0xfe) << 15);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 39 to 54
	value = ((uint32_t)(input[4] & 0x01) << 31) |
			((uint32_t)input[5] << 23) |
			((uint32_t)(input[6] & 0xfe) << 15);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 55 to 70
	value = ((uint32_t)(input[6] & 0x01) << 31) |
			((uint32_t)input[7] << 23) |
			((uint32_t)(input[8] & 0xfe) << 15);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 71 to 86
	value = ((uint32_t)(input[8] & 0x01) << 31) |
			((uint32_t)input[9] << 23) |
			((uint32_t)(input[10] & 0xfe) << 15);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 87 to 102
	value = ((uint32_t)(input[10] & 0x01) << 31) |
			((uint32_t)input[11] << 23) |
			((uint32_t)(input[12] & 0xfe) << 15);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 103 to 118
	value = ((uint32_t)(input[12] & 0x01) << 31) |
			((uint32_t)input[13] << 23) |
			((uint32_t)(input[14] & 0xfe) << 15);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 119 to 134
	value = ((uint32_t)(input[14] & 0x01) << 31) |
			((uint32_t)input[15] << 23) |
			((uint32_t)(input[16] & 0xfe) << 15);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 135 to 150
	value = ((uint32_t)(input[16] & 0x01) << 31) |
			((uint32_t)input[17] << 23) |
			((uint32_t)(input[18] & 0xfe) << 15);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 151 to 166
	value = ((uint32_t)(input[18] & 0x01) << 31) |
			((uint32_t)input[19] << 23) |
			((uint32_t)(input[20] & 0xfe) << 15);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 167 to 182
	value = ((uint32_t)(input[20] & 0x01) << 31) |
			((uint32_t)input[21] << 23) |
			((uint32_t)(input[22] & 0xfe) << 15);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 183 to 198
	value = ((uint32_t)(input[22] & 0x01) << 31) |
			((uint32_t)input[23] << 23) |
			((uint32_t)(input[24] & 0xfe) << 15);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 199 to 214
	value = ((uint32_t)(input[24] & 0x01) << 31) |
			((uint32_t)input[25] << 23) |
			((uint32_t)(input[26] & 0xfe) << 15);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 215 to 230
	value = ((uint32_t)(input[26] & 0x01) << 31) |
			((uint32_t)input[27] << 23) |
			((uint32_t)(input[28] & 0xfe) << 15);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 231 to 246
	value = ((uint32_t)(input[28] & 0x01) << 31) |
			((uint32_t)input[29] << 23) |
			((uint32_t)(input[30] & 0xfe) << 15);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 247 to 262
	value = ((uint32_t)(input[30] & 0x01) << 31) |
			((uint32_t)input[31] << 23) |
			((uint32_t)(input[32] & 0xfe) << 15);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 263 to 278
	value = ((uint32_t)(input[32] & 0x01) << 31) |
			((uint32_t)input[33] << 23) |
			((uint32_t)(input[34] & 0xfe) << 15);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 279 to 294
	value = ((uint32_t)(input[34] & 0x01) << 31) |
			((uint32_t)input[35] << 23) |
			((uint32_t)(input[36] & 0xfe) << 15);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 295 to 310
	value = ((uint32_t)(input[36] & 0x01) << 31) |
			((uint32_t)input[37] << 23) |
			((uint32_t)(input[38] & 0xfe) << 15);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 311 to 326
	value = ((uint32_t)(input[38] & 0x01) << 31) |
			((uint32_t)input[39] << 23) |
			((uint32_t)(input[40] & 0xfe) << 15);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 327 to 342
	value = ((uint32_t)(input[40] & 0x01) << 31) |
			((uint32_t)input[41] << 23) |
			((uint32_t)(input[42] & 0xfe) << 15);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 343 to 358
	value = ((uint32_t)(input[42] & 0x01) << 31) |
			((uint32_t)input[43] << 23) |
			((uint32_t)(input[44] & 0xfe) << 15);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 359 to 374
	value = ((uint32_t)(input[44] & 0x01) << 31) |
			((uint32_t)input[45] << 23) |
			((uint32_t)(input[46] & 0xfe) << 15);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 375 to 390
	value = ((uint32_t)(input[46] & 0x01) << 31) |
			((uint32_t)input[47] << 23) |
			((uint32_t)(input[48] & 0xfe) << 15);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 391 to 406
	value = ((uint32_t)(input[48] & 0x01) << 31) |
			((uint32_t)input[49] << 23) |
			((uint32_t)(input[50] & 0xfe) << 15);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 407 to 422
	value = ((uint32_t)(input[50] & 0x01) << 31) |
			((uint32_t)input[51] << 23) |
			((uint32_t)(input[52] & 0xfe) << 15);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 423 to 438
	value = ((uint32_t)(input[52] & 0x01) << 31) |
			((uint32_t)input[53] << 23) |
			((uint32_t)(input[54] & 0xfe) << 15);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 439 to 454
	value = ((uint32_t)(input[54] & 0x01) << 31) |
			((uint32_t)input[55] << 23) |
			((uint32_t)(input[56] & 0xfe) << 15);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 455 to 470
	value = ((uint32_t)(input[56] & 0x01) << 31) |
			((uint32_t)input[57] << 23) |
			((uint32_t)(input[58] & 0xfe) << 15);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 471 to 486
	value = ((uint32_t)(input[58] & 0x01) << 31) |
			((uint32_t)input[59] << 23) |
			((uint32_t)(input[60] & 0xfe) << 15);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 487 to 502
	value = ((uint32_t)(input[60] & 0x01) << 31) |
			((uint32_t)input[61] << 23) |
			((uint32_t)(input[62] & 0xfe) << 15);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 503 to 518
	value = ((uint32_t)(input[62] & 0x01) << 31) |
			((uint32_t)input[63] << 23) |
			((uint32_t)(input[64] & 0xfe) << 15);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 519 to 534
	value = ((uint32_t)(input[64] & 0x01) << 31) |
			((uint32_t)input[65] << 23) |
			((uint32_t)(input[66] & 0xfe) << 15);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 535 to 550
	value = ((uint32_t)(input[66] & 0x01) << 31) |
			((uint32_t)input[67] << 23) |
			((uint32_t)(input[68] & 0xfe) << 15);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 551 to 566
	value = ((uint32_t)(input[68] & 0x01) << 31) |
			((uint32_t)input[69] << 23) |
			((uint32_t)(input[70] & 0xfe) << 15);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 567 to 582
	value = ((uint32_t)(input[70] & 0x01) << 31) |
			((uint32_t)input[71] << 23) |
			((uint32_t)(input[72] & 0xfe) << 15);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 583 to 598
	value = ((uint32_t)(input[72] & 0x01) << 31) |
			((uint32_t)input[73] << 23) |
			((uint32_t)(input[74] & 0xfe) << 15);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 599 to 614
	value = ((uint32_t)(input[74] & 0x01) << 31) |
			((uint32_t)input[75] << 23) |
			((uint32_t)(input[76] & 0xfe) << 15);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 615 to 630
	value = ((uint32_t)(input[76] & 0x01) << 31) |
			((uint32_t)input[77] << 23) |
			((uint32_t)(input[78] & 0xfe) << 15);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 631 to 646
	value = ((uint32_t)(input[78] & 0x01) << 31) |
			((uint32_t)input[79] << 23) |
			((uint32_t)(input[80] & 0xfe) << 15);
	output[39] = (double)(value >> 16);

	// read output[40]: from bit 647 to 662
	value = ((uint32_t)(input[80] & 0x01) << 31) |
			((uint32_t)input[81] << 23) |
			((uint32_t)(input[82] & 0xfe) << 15);
	output[40] = (double)(value >> 16);

	// read output[41]: from bit 663 to 678
	value = ((uint32_t)(input[82] & 0x01) << 31) |
			((uint32_t)input[83] << 23) |
			((uint32_t)(input[84] & 0xfe) << 15);
	output[41] = (double)(value >> 16);

	// read output[42]: from bit 679 to 694
	value = ((uint32_t)(input[84] & 0x01) << 31) |
			((uint32_t)input[85] << 23) |
			((uint32_t)(input[86] & 0xfe) << 15);
	output[42] = (double)(value >> 16);

	// read output[43]: from bit 695 to 710
	value = ((uint32_t)(input[86] & 0x01) << 31) |
			((uint32_t)input[87] << 23) |
			((uint32_t)(input[88] & 0xfe) << 15);
	output[43] = (double)(value >> 16);

	// read output[44]: from bit 711 to 726
	value = ((uint32_t)(input[88] & 0x01) << 31) |
			((uint32_t)input[89] << 23) |
			((uint32_t)(input[90] & 0xfe) << 15);
	output[44] = (double)(value >> 16);

	// read output[45]: from bit 727 to 742
	value = ((uint32_t)(input[90] & 0x01) << 31) |
			((uint32_t)input[91] << 23) |
			((uint32_t)(input[92] & 0xfe) << 15);
	output[45] = (double)(value >> 16);

	// read output[46]: from bit 743 to 758
	value = ((uint32_t)(input[92] & 0x01) << 31) |
			((uint32_t)input[93] << 23) |
			((uint32_t)(input[94] & 0xfe) << 15);
	output[46] = (double)(value >> 16);

	// read output[47]: from bit 759 to 774
	value = ((uint32_t)(input[94] & 0x01) << 31) |
			((uint32_t)input[95] << 23) |
			((uint32_t)(input[96] & 0xfe) << 15);
	output[47] = (double)(value >> 16);

	// read output[48]: from bit 775 to 790
	value = ((uint32_t)(input[96] & 0x01) << 31) |
			((uint32_t)input[97] << 23) |
			((uint32_t)(input[98] & 0xfe) << 15);
	output[48] = (double)(value >> 16);

	// read output[49]: from bit 791 to 806
	value = ((uint32_t)(input[98] & 0x01) << 31) |
			((uint32_t)input[99] << 23) |
			((uint32_t)(input[100] & 0xfe) << 15);
	output[49] = (double)(value >> 16);

	// read output[50]: from bit 807 to 822
	value = ((uint32_t)(input[100] & 0x01) << 31) |
			((uint32_t)input[101] << 23) |
			((uint32_t)(input[102] & 0xfe) << 15);
	output[50] = (double)(value >> 16);

	// read output[51]: from bit 823 to 838
	value = ((uint32_t)(input[102] & 0x01) << 31) |
			((uint32_t)input[103] << 23) |
			((uint32_t)(input[104] & 0xfe) << 15);
	output[51] = (double)(value >> 16);

	// read output[52]: from bit 839 to 854
	value = ((uint32_t)(input[104] & 0x01) << 31) |
			((uint32_t)input[105] << 23) |
			((uint32_t)(input[106] & 0xfe) << 15);
	output[52] = (double)(value >> 16);

	// read output[53]: from bit 855 to 870
	value = ((uint32_t)(input[106] & 0x01) << 31) |
			((uint32_t)input[107] << 23) |
			((uint32_t)(input[108] & 0xfe) << 15);
	output[53] = (double)(value >> 16);

	// read output[54]: from bit 871 to 886
	value = ((uint32_t)(input[108] & 0x01) << 31) |
			((uint32_t)input[109] << 23) |
			((uint32_t)(input[110] & 0xfe) << 15);
	output[54] = (double)(value >> 16);

	// read output[55]: from bit 887 to 902
	value = ((uint32_t)(input[110] & 0x01) << 31) |
			((uint32_t)input[111] << 23) |
			((uint32_t)(input[112] & 0xfe) << 15);
	output[55] = (double)(value >> 16);

	// read output[56]: from bit 903 to 918
	value = ((uint32_t)(input[112] & 0x01) << 31) |
			((uint32_t)input[113] << 23) |
			((uint32_t)(input[114] & 0xfe) << 15);
	output[56] = (double)(value >> 16);

	// read output[57]: from bit 919 to 934
	value = ((uint32_t)(input[114] & 0x01) << 31) |
			((uint32_t)input[115] << 23) |
			((uint32_t)(input[116] & 0xfe) << 15);
	output[57] = (double)(value >> 16);

	// read output[58]: from bit 935 to 950
	value = ((uint32_t)(input[116] & 0x01) << 31) |
			((uint32_t)input[117] << 23) |
			((uint32_t)(input[118] & 0xfe) << 15);
	output[58] = (double)(value >> 16);

	// read output[59]: from bit 951 to 966
	value = ((uint32_t)(input[118] & 0x01) << 31) |
			((uint32_t)input[119] << 23) |
			((uint32_t)(input[120] & 0xfe) << 15);
	output[59] = (double)(value >> 16);

	// read output[60]: from bit 967 to 982
	value = ((uint32_t)(input[120] & 0x01) << 31) |
			((uint32_t)input[121] << 23) |
			((uint32_t)(input[122] & 0xfe) << 15);
	output[60] = (double)(value >> 16);

	// read output[61]: from bit 983 to 998
	value = ((uint32_t)(input[122] & 0x01) << 31) |
			((uint32_t)input[123] << 23) |
			((uint32_t)(input[124] & 0xfe) << 15);
	output[61] = (double)(value >> 16);

	// read output[62]: from bit 999 to 1014
	value = ((uint32_t)(input[124] & 0x01) << 31) |
			((uint32_t)input[125] << 23) |
			((uint32_t)(input[126] & 0xfe) << 15);
	output[62] = (double)(value >> 16);

	// read output[63]: from bit 1015 to 1030
	value = ((uint32_t)(input[126] & 0x01) << 31) |
			((uint32_t)input[127] << 23) |
			((uint32_t)(input[128] & 0xfe) << 15);
	output[63] = (double)(value >> 16);
}

static void unpack_64_16bit_unsigned_7off(const uint8_t * input, double * output, void *closure) {
	// Unpack 64 values into output
	// Values are 16-bit unsigned
	// Skip 7 bits, read 1024 bits of data.
	// Input must be at least 129 bytes long

	(void)closure; // suppress unused parameter warning

	uint32_t value;

	// read output[0]: from bit 7 to 22
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)(input[2] & 0xfe) << 15);
	output[0] = (double)(value >> 16);

	// read output[1]: from bit 23 to 38
	value = ((uint32_t)(input[2] & 0x01) << 31) |
			((uint32_t)input[3] << 23) |
			((uint32_t)(input[4] & 0xfe) << 15);
	output[1] = (double)(value >> 16);

	// read output[2]: from bit 39 to 54
	value = ((uint32_t)(input[4] & 0x01) << 31) |
			((uint32_t)input[5] << 23) |
			((uint32_t)(input[6] & 0xfe) << 15);
	output[2] = (double)(value >> 16);

	// read output[3]: from bit 55 to 70
	value = ((uint32_t)(input[6] & 0x01) << 31) |
			((uint32_t)input[7] << 23) |
			((uint32_t)(input[8] & 0xfe) << 15);
	output[3] = (double)(value >> 16);

	// read output[4]: from bit 71 to 86
	value = ((uint32_t)(input[8] & 0x01) << 31) |
			((uint32_t)input[9] << 23) |
			((uint32_t)(input[10] & 0xfe) << 15);
	output[4] = (double)(value >> 16);

	// read output[5]: from bit 87 to 102
	value = ((uint32_t)(input[10] & 0x01) << 31) |
			((uint32_t)input[11] << 23) |
			((uint32_t)(input[12] & 0xfe) << 15);
	output[5] = (double)(value >> 16);

	// read output[6]: from bit 103 to 118
	value = ((uint32_t)(input[12] & 0x01) << 31) |
			((uint32_t)input[13] << 23) |
			((uint32_t)(input[14] & 0xfe) << 15);
	output[6] = (double)(value >> 16);

	// read output[7]: from bit 119 to 134
	value = ((uint32_t)(input[14] & 0x01) << 31) |
			((uint32_t)input[15] << 23) |
			((uint32_t)(input[16] & 0xfe) << 15);
	output[7] = (double)(value >> 16);

	// read output[8]: from bit 135 to 150
	value = ((uint32_t)(input[16] & 0x01) << 31) |
			((uint32_t)input[17] << 23) |
			((uint32_t)(input[18] & 0xfe) << 15);
	output[8] = (double)(value >> 16);

	// read output[9]: from bit 151 to 166
	value = ((uint32_t)(input[18] & 0x01) << 31) |
			((uint32_t)input[19] << 23) |
			((uint32_t)(input[20] & 0xfe) << 15);
	output[9] = (double)(value >> 16);

	// read output[10]: from bit 167 to 182
	value = ((uint32_t)(input[20] & 0x01) << 31) |
			((uint32_t)input[21] << 23) |
			((uint32_t)(input[22] & 0xfe) << 15);
	output[10] = (double)(value >> 16);

	// read output[11]: from bit 183 to 198
	value = ((uint32_t)(input[22] & 0x01) << 31) |
			((uint32_t)input[23] << 23) |
			((uint32_t)(input[24] & 0xfe) << 15);
	output[11] = (double)(value >> 16);

	// read output[12]: from bit 199 to 214
	value = ((uint32_t)(input[24] & 0x01) << 31) |
			((uint32_t)input[25] << 23) |
			((uint32_t)(input[26] & 0xfe) << 15);
	output[12] = (double)(value >> 16);

	// read output[13]: from bit 215 to 230
	value = ((uint32_t)(input[26] & 0x01) << 31) |
			((uint32_t)input[27] << 23) |
			((uint32_t)(input[28] & 0xfe) << 15);
	output[13] = (double)(value >> 16);

	// read output[14]: from bit 231 to 246
	value = ((uint32_t)(input[28] & 0x01) << 31) |
			((uint32_t)input[29] << 23) |
			((uint32_t)(input[30] & 0xfe) << 15);
	output[14] = (double)(value >> 16);

	// read output[15]: from bit 247 to 262
	value = ((uint32_t)(input[30] & 0x01) << 31) |
			((uint32_t)input[31] << 23) |
			((uint32_t)(input[32] & 0xfe) << 15);
	output[15] = (double)(value >> 16);

	// read output[16]: from bit 263 to 278
	value = ((uint32_t)(input[32] & 0x01) << 31) |
			((uint32_t)input[33] << 23) |
			((uint32_t)(input[34] & 0xfe) << 15);
	output[16] = (double)(value >> 16);

	// read output[17]: from bit 279 to 294
	value = ((uint32_t)(input[34] & 0x01) << 31) |
			((uint32_t)input[35] << 23) |
			((uint32_t)(input[36] & 0xfe) << 15);
	output[17] = (double)(value >> 16);

	// read output[18]: from bit 295 to 310
	value = ((uint32_t)(input[36] & 0x01) << 31) |
			((uint32_t)input[37] << 23) |
			((uint32_t)(input[38] & 0xfe) << 15);
	output[18] = (double)(value >> 16);

	// read output[19]: from bit 311 to 326
	value = ((uint32_t)(input[38] & 0x01) << 31) |
			((uint32_t)input[39] << 23) |
			((uint32_t)(input[40] & 0xfe) << 15);
	output[19] = (double)(value >> 16);

	// read output[20]: from bit 327 to 342
	value = ((uint32_t)(input[40] & 0x01) << 31) |
			((uint32_t)input[41] << 23) |
			((uint32_t)(input[42] & 0xfe) << 15);
	output[20] = (double)(value >> 16);

	// read output[21]: from bit 343 to 358
	value = ((uint32_t)(input[42] & 0x01) << 31) |
			((uint32_t)input[43] << 23) |
			((uint32_t)(input[44] & 0xfe) << 15);
	output[21] = (double)(value >> 16);

	// read output[22]: from bit 359 to 374
	value = ((uint32_t)(input[44] & 0x01) << 31) |
			((uint32_t)input[45] << 23) |
			((uint32_t)(input[46] & 0xfe) << 15);
	output[22] = (double)(value >> 16);

	// read output[23]: from bit 375 to 390
	value = ((uint32_t)(input[46] & 0x01) << 31) |
			((uint32_t)input[47] << 23) |
			((uint32_t)(input[48] & 0xfe) << 15);
	output[23] = (double)(value >> 16);

	// read output[24]: from bit 391 to 406
	value = ((uint32_t)(input[48] & 0x01) << 31) |
			((uint32_t)input[49] << 23) |
			((uint32_t)(input[50] & 0xfe) << 15);
	output[24] = (double)(value >> 16);

	// read output[25]: from bit 407 to 422
	value = ((uint32_t)(input[50] & 0x01) << 31) |
			((uint32_t)input[51] << 23) |
			((uint32_t)(input[52] & 0xfe) << 15);
	output[25] = (double)(value >> 16);

	// read output[26]: from bit 423 to 438
	value = ((uint32_t)(input[52] & 0x01) << 31) |
			((uint32_t)input[53] << 23) |
			((uint32_t)(input[54] & 0xfe) << 15);
	output[26] = (double)(value >> 16);

	// read output[27]: from bit 439 to 454
	value = ((uint32_t)(input[54] & 0x01) << 31) |
			((uint32_t)input[55] << 23) |
			((uint32_t)(input[56] & 0xfe) << 15);
	output[27] = (double)(value >> 16);

	// read output[28]: from bit 455 to 470
	value = ((uint32_t)(input[56] & 0x01) << 31) |
			((uint32_t)input[57] << 23) |
			((uint32_t)(input[58] & 0xfe) << 15);
	output[28] = (double)(value >> 16);

	// read output[29]: from bit 471 to 486
	value = ((uint32_t)(input[58] & 0x01) << 31) |
			((uint32_t)input[59] << 23) |
			((uint32_t)(input[60] & 0xfe) << 15);
	output[29] = (double)(value >> 16);

	// read output[30]: from bit 487 to 502
	value = ((uint32_t)(input[60] & 0x01) << 31) |
			((uint32_t)input[61] << 23) |
			((uint32_t)(input[62] & 0xfe) << 15);
	output[30] = (double)(value >> 16);

	// read output[31]: from bit 503 to 518
	value = ((uint32_t)(input[62] & 0x01) << 31) |
			((uint32_t)input[63] << 23) |
			((uint32_t)(input[64] & 0xfe) << 15);
	output[31] = (double)(value >> 16);

	// read output[32]: from bit 519 to 534
	value = ((uint32_t)(input[64] & 0x01) << 31) |
			((uint32_t)input[65] << 23) |
			((uint32_t)(input[66] & 0xfe) << 15);
	output[32] = (double)(value >> 16);

	// read output[33]: from bit 535 to 550
	value = ((uint32_t)(input[66] & 0x01) << 31) |
			((uint32_t)input[67] << 23) |
			((uint32_t)(input[68] & 0xfe) << 15);
	output[33] = (double)(value >> 16);

	// read output[34]: from bit 551 to 566
	value = ((uint32_t)(input[68] & 0x01) << 31) |
			((uint32_t)input[69] << 23) |
			((uint32_t)(input[70] & 0xfe) << 15);
	output[34] = (double)(value >> 16);

	// read output[35]: from bit 567 to 582
	value = ((uint32_t)(input[70] & 0x01) << 31) |
			((uint32_t)input[71] << 23) |
			((uint32_t)(input[72] & 0xfe) << 15);
	output[35] = (double)(value >> 16);

	// read output[36]: from bit 583 to 598
	value = ((uint32_t)(input[72] & 0x01) << 31) |
			((uint32_t)input[73] << 23) |
			((uint32_t)(input[74] & 0xfe) << 15);
	output[36] = (double)(value >> 16);

	// read output[37]: from bit 599 to 614
	value = ((uint32_t)(input[74] & 0x01) << 31) |
			((uint32_t)input[75] << 23) |
			((uint32_t)(input[76] & 0xfe) << 15);
	output[37] = (double)(value >> 16);

	// read output[38]: from bit 615 to 630
	value = ((uint32_t)(input[76] & 0x01) << 31) |
			((uint32_t)input[77] << 23) |
			((uint32_t)(input[78] & 0xfe) << 15);
	output[38] = (double)(value >> 16);

	// read output[39]: from bit 631 to 646
	value = ((uint32_t)(input[78] & 0x01) << 31) |
			((uint32_t)input[79] << 23) |
			((uint32_t)(input[80] & 0xfe) << 15);
	output[39] = (double)(value >> 16);

	// read output[40]: from bit 647 to 662
	value = ((uint32_t)(input[80] & 0x01) << 31) |
			((uint32_t)input[81] << 23) |
			((uint32_t)(input[82] & 0xfe) << 15);
	output[40] = (double)(value >> 16);

	// read output[41]: from bit 663 to 678
	value = ((uint32_t)(input[82] & 0x01) << 31) |
			((uint32_t)input[83] << 23) |
			((uint32_t)(input[84] & 0xfe) << 15);
	output[41] = (double)(value >> 16);

	// read output[42]: from bit 679 to 694
	value = ((uint32_t)(input[84] & 0x01) << 31) |
			((uint32_t)input[85] << 23) |
			((uint32_t)(input[86] & 0xfe) << 15);
	output[42] = (double)(value >> 16);

	// read output[43]: from bit 695 to 710
	value = ((uint32_t)(input[86] & 0x01) << 31) |
			((uint32_t)input[87] << 23) |
			((uint32_t)(input[88] & 0xfe) << 15);
	output[43] = (double)(value >> 16);

	// read output[44]: from bit 711 to 726
	value = ((uint32_t)(input[88] & 0x01) << 31) |
			((uint32_t)input[89] << 23) |
			((uint32_t)(input[90] & 0xfe) << 15);
	output[44] = (double)(value >> 16);

	// read output[45]: from bit 727 to 742
	value = ((uint32_t)(input[90] & 0x01) << 31) |
			((uint32_t)input[91] << 23) |
			((uint32_t)(input[92] & 0xfe) << 15);
	output[45] = (double)(value >> 16);

	// read output[46]: from bit 743 to 758
	value = ((uint32_t)(input[92] & 0x01) << 31) |
			((uint32_t)input[93] << 23) |
			((uint32_t)(input[94] & 0xfe) << 15);
	output[46] = (double)(value >> 16);

	// read output[47]: from bit 759 to 774
	value = ((uint32_t)(input[94] & 0x01) << 31) |
			((uint32_t)input[95] << 23) |
			((uint32_t)(input[96] & 0xfe) << 15);
	output[47] = (double)(value >> 16);

	// read output[48]: from bit 775 to 790
	value = ((uint32_t)(input[96] & 0x01) << 31) |
			((uint32_t)input[97] << 23) |
			((uint32_t)(input[98] & 0xfe) << 15);
	output[48] = (double)(value >> 16);

	// read output[49]: from bit 791 to 806
	value = ((uint32_t)(input[98] & 0x01) << 31) |
			((uint32_t)input[99] << 23) |
			((uint32_t)(input[100] & 0xfe) << 15);
	output[49] = (double)(value >> 16);

	// read output[50]: from bit 807 to 822
	value = ((uint32_t)(input[100] & 0x01) << 31) |
			((uint32_t)input[101] << 23) |
			((uint32_t)(input[102] & 0xfe) << 15);
	output[50] = (double)(value >> 16);

	// read output[51]: from bit 823 to 838
	value = ((uint32_t)(input[102] & 0x01) << 31) |
			((uint32_t)input[103] << 23) |
			((uint32_t)(input[104] & 0xfe) << 15);
	output[51] = (double)(value >> 16);

	// read output[52]: from bit 839 to 854
	value = ((uint32_t)(input[104] & 0x01) << 31) |
			((uint32_t)input[105] << 23) |
			((uint32_t)(input[106] & 0xfe) << 15);
	output[52] = (double)(value >> 16);

	// read output[53]: from bit 855 to 870
	value = ((uint32_t)(input[106] & 0x01) << 31) |
			((uint32_t)input[107] << 23) |
			((uint32_t)(input[108] & 0xfe) << 15);
	output[53] = (double)(value >> 16);

	// read output[54]: from bit 871 to 886
	value = ((uint32_t)(input[108] & 0x01) << 31) |
			((uint32_t)input[109] << 23) |
			((uint32_t)(input[110] & 0xfe) << 15);
	output[54] = (double)(value >> 16);

	// read output[55]: from bit 887 to 902
	value = ((uint32_t)(input[110] & 0x01) << 31) |
			((uint32_t)input[111] << 23) |
			((uint32_t)(input[112] & 0xfe) << 15);
	output[55] = (double)(value >> 16);

	// read output[56]: from bit 903 to 918
	value = ((uint32_t)(input[112] & 0x01) << 31) |
			((uint32_t)input[113] << 23) |
			((uint32_t)(input[114] & 0xfe) << 15);
	output[56] = (double)(value >> 16);

	// read output[57]: from bit 919 to 934
	value = ((uint32_t)(input[114] & 0x01) << 31) |
			((uint32_t)input[115] << 23) |
			((uint32_t)(input[116] & 0xfe) << 15);
	output[57] = (double)(value >> 16);

	// read output[58]: from bit 935 to 950
	value = ((uint32_t)(input[116] & 0x01) << 31) |
			((uint32_t)input[117] << 23) |
			((uint32_t)(input[118] & 0xfe) << 15);
	output[58] = (double)(value >> 16);

	// read output[59]: from bit 951 to 966
	value = ((uint32_t)(input[118] & 0x01) << 31) |
			((uint32_t)input[119] << 23) |
			((uint32_t)(input[120] & 0xfe) << 15);
	output[59] = (double)(value >> 16);

	// read output[60]: from bit 967 to 982
	value = ((uint32_t)(input[120] & 0x01) << 31) |
			((uint32_t)input[121] << 23) |
			((uint32_t)(input[122] & 0xfe) << 15);
	output[60] = (double)(value >> 16);

	// read output[61]: from bit 983 to 998
	value = ((uint32_t)(input[122] & 0x01) << 31) |
			((uint32_t)input[123] << 23) |
			((uint32_t)(input[124] & 0xfe) << 15);
	output[61] = (double)(value >> 16);

	// read output[62]: from bit 999 to 1014
	value = ((uint32_t)(input[124] & 0x01) << 31) |
			((uint32_t)input[125] << 23) |
			((uint32_t)(input[126] & 0xfe) << 15);
	output[62] = (double)(value >> 16);

	// read output[63]: from bit 1015 to 1030
	value = ((uint32_t)(input[126] & 0x01) << 31) |
			((uint32_t)input[127] << 23) |
			((uint32_t)(input[128] & 0xfe) << 15);
	output[63] = (double)(value >> 16);
}


unpack_func_t unpack_16bit[UNPACK_16BIT_MAX_COUNT][8][2] = {
	{
		{
			unpack_1_16bit_unsigned_0off,
			unpack_1_16bit_signed_0off,
		},
		{
			unpack_1_16bit_unsigned_1off,
			unpack_1_16bit_signed_1off,
		},
		{
			unpack_1_16bit_unsigned_2off,
			unpack_1_16bit_signed_2off,
		},
		{
			unpack_1_16bit_unsigned_3off,
			unpack_1_16bit_signed_3off,
		},
		{
			unpack_1_16bit_unsigned_4off,
			unpack_1_16bit_signed_4off,
		},
		{
			unpack_1_16bit_unsigned_5off,
			unpack_1_16bit_signed_5off,
		},
		{
			unpack_1_16bit_unsigned_6off,
			unpack_1_16bit_signed_6off,
		},
		{
			unpack_1_16bit_unsigned_7off,
			unpack_1_16bit_signed_7off,
		},
	},
	{
		{
			unpack_2_16bit_unsigned_0off,
			unpack_2_16bit_signed_0off,
		},
		{
			unpack_2_16bit_unsigned_1off,
			unpack_2_16bit_signed_1off,
		},
		{
			unpack_2_16bit_unsigned_2off,
			unpack_2_16bit_signed_2off,
		},
		{
			unpack_2_16bit_unsigned_3off,
			unpack_2_16bit_signed_3off,
		},
		{
			unpack_2_16bit_unsigned_4off,
			unpack_2_16bit_signed_4off,
		},
		{
			unpack_2_16bit_unsigned_5off,
			unpack_2_16bit_signed_5off,
		},
		{
			unpack_2_16bit_unsigned_6off,
			unpack_2_16bit_signed_6off,
		},
		{
			unpack_2_16bit_unsigned_7off,
			unpack_2_16bit_signed_7off,
		},
	},
	{
		{
			unpack_3_16bit_unsigned_0off,
			unpack_3_16bit_signed_0off,
		},
		{
			unpack_3_16bit_unsigned_1off,
			unpack_3_16bit_signed_1off,
		},
		{
			unpack_3_16bit_unsigned_2off,
			unpack_3_16bit_signed_2off,
		},
		{
			unpack_3_16bit_unsigned_3off,
			unpack_3_16bit_signed_3off,
		},
		{
			unpack_3_16bit_unsigned_4off,
			unpack_3_16bit_signed_4off,
		},
		{
			unpack_3_16bit_unsigned_5off,
			unpack_3_16bit_signed_5off,
		},
		{
			unpack_3_16bit_unsigned_6off,
			unpack_3_16bit_signed_6off,
		},
		{
			unpack_3_16bit_unsigned_7off,
			unpack_3_16bit_signed_7off,
		},
	},
	{
		{
			unpack_4_16bit_unsigned_0off,
			unpack_4_16bit_signed_0off,
		},
		{
			unpack_4_16bit_unsigned_1off,
			unpack_4_16bit_signed_1off,
		},
		{
			unpack_4_16bit_unsigned_2off,
			unpack_4_16bit_signed_2off,
		},
		{
			unpack_4_16bit_unsigned_3off,
			unpack_4_16bit_signed_3off,
		},
		{
			unpack_4_16bit_unsigned_4off,
			unpack_4_16bit_signed_4off,
		},
		{
			unpack_4_16bit_unsigned_5off,
			unpack_4_16bit_signed_5off,
		},
		{
			unpack_4_16bit_unsigned_6off,
			unpack_4_16bit_signed_6off,
		},
		{
			unpack_4_16bit_unsigned_7off,
			unpack_4_16bit_signed_7off,
		},
	},
	{
		{
			unpack_5_16bit_unsigned_0off,
			unpack_5_16bit_signed_0off,
		},
		{
			unpack_5_16bit_unsigned_1off,
			unpack_5_16bit_signed_1off,
		},
		{
			unpack_5_16bit_unsigned_2off,
			unpack_5_16bit_signed_2off,
		},
		{
			unpack_5_16bit_unsigned_3off,
			unpack_5_16bit_signed_3off,
		},
		{
			unpack_5_16bit_unsigned_4off,
			unpack_5_16bit_signed_4off,
		},
		{
			unpack_5_16bit_unsigned_5off,
			unpack_5_16bit_signed_5off,
		},
		{
			unpack_5_16bit_unsigned_6off,
			unpack_5_16bit_signed_6off,
		},
		{
			unpack_5_16bit_unsigned_7off,
			unpack_5_16bit_signed_7off,
		},
	},
	{
		{
			unpack_6_16bit_unsigned_0off,
			unpack_6_16bit_signed_0off,
		},
		{
			unpack_6_16bit_unsigned_1off,
			unpack_6_16bit_signed_1off,
		},
		{
			unpack_6_16bit_unsigned_2off,
			unpack_6_16bit_signed_2off,
		},
		{
			unpack_6_16bit_unsigned_3off,
			unpack_6_16bit_signed_3off,
		},
		{
			unpack_6_16bit_unsigned_4off,
			unpack_6_16bit_signed_4off,
		},
		{
			unpack_6_16bit_unsigned_5off,
			unpack_6_16bit_signed_5off,
		},
		{
			unpack_6_16bit_unsigned_6off,
			unpack_6_16bit_signed_6off,
		},
		{
			unpack_6_16bit_unsigned_7off,
			unpack_6_16bit_signed_7off,
		},
	},
	{
		{
			unpack_7_16bit_unsigned_0off,
			unpack_7_16bit_signed_0off,
		},
		{
			unpack_7_16bit_unsigned_1off,
			unpack_7_16bit_signed_1off,
		},
		{
			unpack_7_16bit_unsigned_2off,
			unpack_7_16bit_signed_2off,
		},
		{
			unpack_7_16bit_unsigned_3off,
			unpack_7_16bit_signed_3off,
		},
		{
			unpack_7_16bit_unsigned_4off,
			unpack_7_16bit_signed_4off,
		},
		{
			unpack_7_16bit_unsigned_5off,
			unpack_7_16bit_signed_5off,
		},
		{
			unpack_7_16bit_unsigned_6off,
			unpack_7_16bit_signed_6off,
		},
		{
			unpack_7_16bit_unsigned_7off,
			unpack_7_16bit_signed_7off,
		},
	},
	{
		{
			unpack_8_16bit_unsigned_0off,
			unpack_8_16bit_signed_0off,
		},
		{
			unpack_8_16bit_unsigned_1off,
			unpack_8_16bit_signed_1off,
		},
		{
			unpack_8_16bit_unsigned_2off,
			unpack_8_16bit_signed_2off,
		},
		{
			unpack_8_16bit_unsigned_3off,
			unpack_8_16bit_signed_3off,
		},
		{
			unpack_8_16bit_unsigned_4off,
			unpack_8_16bit_signed_4off,
		},
		{
			unpack_8_16bit_unsigned_5off,
			unpack_8_16bit_signed_5off,
		},
		{
			unpack_8_16bit_unsigned_6off,
			unpack_8_16bit_signed_6off,
		},
		{
			unpack_8_16bit_unsigned_7off,
			unpack_8_16bit_signed_7off,
		},
	},
	{
		{
			unpack_9_16bit_unsigned_0off,
			unpack_9_16bit_signed_0off,
		},
		{
			unpack_9_16bit_unsigned_1off,
			unpack_9_16bit_signed_1off,
		},
		{
			unpack_9_16bit_unsigned_2off,
			unpack_9_16bit_signed_2off,
		},
		{
			unpack_9_16bit_unsigned_3off,
			unpack_9_16bit_signed_3off,
		},
		{
			unpack_9_16bit_unsigned_4off,
			unpack_9_16bit_signed_4off,
		},
		{
			unpack_9_16bit_unsigned_5off,
			unpack_9_16bit_signed_5off,
		},
		{
			unpack_9_16bit_unsigned_6off,
			unpack_9_16bit_signed_6off,
		},
		{
			unpack_9_16bit_unsigned_7off,
			unpack_9_16bit_signed_7off,
		},
	},
	{
		{
			unpack_10_16bit_unsigned_0off,
			unpack_10_16bit_signed_0off,
		},
		{
			unpack_10_16bit_unsigned_1off,
			unpack_10_16bit_signed_1off,
		},
		{
			unpack_10_16bit_unsigned_2off,
			unpack_10_16bit_signed_2off,
		},
		{
			unpack_10_16bit_unsigned_3off,
			unpack_10_16bit_signed_3off,
		},
		{
			unpack_10_16bit_unsigned_4off,
			unpack_10_16bit_signed_4off,
		},
		{
			unpack_10_16bit_unsigned_5off,
			unpack_10_16bit_signed_5off,
		},
		{
			unpack_10_16bit_unsigned_6off,
			unpack_10_16bit_signed_6off,
		},
		{
			unpack_10_16bit_unsigned_7off,
			unpack_10_16bit_signed_7off,
		},
	},
	{
		{
			unpack_11_16bit_unsigned_0off,
			unpack_11_16bit_signed_0off,
		},
		{
			unpack_11_16bit_unsigned_1off,
			unpack_11_16bit_signed_1off,
		},
		{
			unpack_11_16bit_unsigned_2off,
			unpack_11_16bit_signed_2off,
		},
		{
			unpack_11_16bit_unsigned_3off,
			unpack_11_16bit_signed_3off,
		},
		{
			unpack_11_16bit_unsigned_4off,
			unpack_11_16bit_signed_4off,
		},
		{
			unpack_11_16bit_unsigned_5off,
			unpack_11_16bit_signed_5off,
		},
		{
			unpack_11_16bit_unsigned_6off,
			unpack_11_16bit_signed_6off,
		},
		{
			unpack_11_16bit_unsigned_7off,
			unpack_11_16bit_signed_7off,
		},
	},
	{
		{
			unpack_12_16bit_unsigned_0off,
			unpack_12_16bit_signed_0off,
		},
		{
			unpack_12_16bit_unsigned_1off,
			unpack_12_16bit_signed_1off,
		},
		{
			unpack_12_16bit_unsigned_2off,
			unpack_12_16bit_signed_2off,
		},
		{
			unpack_12_16bit_unsigned_3off,
			unpack_12_16bit_signed_3off,
		},
		{
			unpack_12_16bit_unsigned_4off,
			unpack_12_16bit_signed_4off,
		},
		{
			unpack_12_16bit_unsigned_5off,
			unpack_12_16bit_signed_5off,
		},
		{
			unpack_12_16bit_unsigned_6off,
			unpack_12_16bit_signed_6off,
		},
		{
			unpack_12_16bit_unsigned_7off,
			unpack_12_16bit_signed_7off,
		},
	},
	{
		{
			unpack_13_16bit_unsigned_0off,
			unpack_13_16bit_signed_0off,
		},
		{
			unpack_13_16bit_unsigned_1off,
			unpack_13_16bit_signed_1off,
		},
		{
			unpack_13_16bit_unsigned_2off,
			unpack_13_16bit_signed_2off,
		},
		{
			unpack_13_16bit_unsigned_3off,
			unpack_13_16bit_signed_3off,
		},
		{
			unpack_13_16bit_unsigned_4off,
			unpack_13_16bit_signed_4off,
		},
		{
			unpack_13_16bit_unsigned_5off,
			unpack_13_16bit_signed_5off,
		},
		{
			unpack_13_16bit_unsigned_6off,
			unpack_13_16bit_signed_6off,
		},
		{
			unpack_13_16bit_unsigned_7off,
			unpack_13_16bit_signed_7off,
		},
	},
	{
		{
			unpack_14_16bit_unsigned_0off,
			unpack_14_16bit_signed_0off,
		},
		{
			unpack_14_16bit_unsigned_1off,
			unpack_14_16bit_signed_1off,
		},
		{
			unpack_14_16bit_unsigned_2off,
			unpack_14_16bit_signed_2off,
		},
		{
			unpack_14_16bit_unsigned_3off,
			unpack_14_16bit_signed_3off,
		},
		{
			unpack_14_16bit_unsigned_4off,
			unpack_14_16bit_signed_4off,
		},
		{
			unpack_14_16bit_unsigned_5off,
			unpack_14_16bit_signed_5off,
		},
		{
			unpack_14_16bit_unsigned_6off,
			unpack_14_16bit_signed_6off,
		},
		{
			unpack_14_16bit_unsigned_7off,
			unpack_14_16bit_signed_7off,
		},
	},
	{
		{
			unpack_15_16bit_unsigned_0off,
			unpack_15_16bit_signed_0off,
		},
		{
			unpack_15_16bit_unsigned_1off,
			unpack_15_16bit_signed_1off,
		},
		{
			unpack_15_16bit_unsigned_2off,
			unpack_15_16bit_signed_2off,
		},
		{
			unpack_15_16bit_unsigned_3off,
			unpack_15_16bit_signed_3off,
		},
		{
			unpack_15_16bit_unsigned_4off,
			unpack_15_16bit_signed_4off,
		},
		{
			unpack_15_16bit_unsigned_5off,
			unpack_15_16bit_signed_5off,
		},
		{
			unpack_15_16bit_unsigned_6off,
			unpack_15_16bit_signed_6off,
		},
		{
			unpack_15_16bit_unsigned_7off,
			unpack_15_16bit_signed_7off,
		},
	},
	{
		{
			unpack_16_16bit_unsigned_0off,
			unpack_16_16bit_signed_0off,
		},
		{
			unpack_16_16bit_unsigned_1off,
			unpack_16_16bit_signed_1off,
		},
		{
			unpack_16_16bit_unsigned_2off,
			unpack_16_16bit_signed_2off,
		},
		{
			unpack_16_16bit_unsigned_3off,
			unpack_16_16bit_signed_3off,
		},
		{
			unpack_16_16bit_unsigned_4off,
			unpack_16_16bit_signed_4off,
		},
		{
			unpack_16_16bit_unsigned_5off,
			unpack_16_16bit_signed_5off,
		},
		{
			unpack_16_16bit_unsigned_6off,
			unpack_16_16bit_signed_6off,
		},
		{
			unpack_16_16bit_unsigned_7off,
			unpack_16_16bit_signed_7off,
		},
	},
	{
		{
			unpack_17_16bit_unsigned_0off,
			unpack_17_16bit_signed_0off,
		},
		{
			unpack_17_16bit_unsigned_1off,
			unpack_17_16bit_signed_1off,
		},
		{
			unpack_17_16bit_unsigned_2off,
			unpack_17_16bit_signed_2off,
		},
		{
			unpack_17_16bit_unsigned_3off,
			unpack_17_16bit_signed_3off,
		},
		{
			unpack_17_16bit_unsigned_4off,
			unpack_17_16bit_signed_4off,
		},
		{
			unpack_17_16bit_unsigned_5off,
			unpack_17_16bit_signed_5off,
		},
		{
			unpack_17_16bit_unsigned_6off,
			unpack_17_16bit_signed_6off,
		},
		{
			unpack_17_16bit_unsigned_7off,
			unpack_17_16bit_signed_7off,
		},
	},
	{
		{
			unpack_18_16bit_unsigned_0off,
			unpack_18_16bit_signed_0off,
		},
		{
			unpack_18_16bit_unsigned_1off,
			unpack_18_16bit_signed_1off,
		},
		{
			unpack_18_16bit_unsigned_2off,
			unpack_18_16bit_signed_2off,
		},
		{
			unpack_18_16bit_unsigned_3off,
			unpack_18_16bit_signed_3off,
		},
		{
			unpack_18_16bit_unsigned_4off,
			unpack_18_16bit_signed_4off,
		},
		{
			unpack_18_16bit_unsigned_5off,
			unpack_18_16bit_signed_5off,
		},
		{
			unpack_18_16bit_unsigned_6off,
			unpack_18_16bit_signed_6off,
		},
		{
			unpack_18_16bit_unsigned_7off,
			unpack_18_16bit_signed_7off,
		},
	},
	{
		{
			unpack_19_16bit_unsigned_0off,
			unpack_19_16bit_signed_0off,
		},
		{
			unpack_19_16bit_unsigned_1off,
			unpack_19_16bit_signed_1off,
		},
		{
			unpack_19_16bit_unsigned_2off,
			unpack_19_16bit_signed_2off,
		},
		{
			unpack_19_16bit_unsigned_3off,
			unpack_19_16bit_signed_3off,
		},
		{
			unpack_19_16bit_unsigned_4off,
			unpack_19_16bit_signed_4off,
		},
		{
			unpack_19_16bit_unsigned_5off,
			unpack_19_16bit_signed_5off,
		},
		{
			unpack_19_16bit_unsigned_6off,
			unpack_19_16bit_signed_6off,
		},
		{
			unpack_19_16bit_unsigned_7off,
			unpack_19_16bit_signed_7off,
		},
	},
	{
		{
			unpack_20_16bit_unsigned_0off,
			unpack_20_16bit_signed_0off,
		},
		{
			unpack_20_16bit_unsigned_1off,
			unpack_20_16bit_signed_1off,
		},
		{
			unpack_20_16bit_unsigned_2off,
			unpack_20_16bit_signed_2off,
		},
		{
			unpack_20_16bit_unsigned_3off,
			unpack_20_16bit_signed_3off,
		},
		{
			unpack_20_16bit_unsigned_4off,
			unpack_20_16bit_signed_4off,
		},
		{
			unpack_20_16bit_unsigned_5off,
			unpack_20_16bit_signed_5off,
		},
		{
			unpack_20_16bit_unsigned_6off,
			unpack_20_16bit_signed_6off,
		},
		{
			unpack_20_16bit_unsigned_7off,
			unpack_20_16bit_signed_7off,
		},
	},
	{
		{
			unpack_21_16bit_unsigned_0off,
			unpack_21_16bit_signed_0off,
		},
		{
			unpack_21_16bit_unsigned_1off,
			unpack_21_16bit_signed_1off,
		},
		{
			unpack_21_16bit_unsigned_2off,
			unpack_21_16bit_signed_2off,
		},
		{
			unpack_21_16bit_unsigned_3off,
			unpack_21_16bit_signed_3off,
		},
		{
			unpack_21_16bit_unsigned_4off,
			unpack_21_16bit_signed_4off,
		},
		{
			unpack_21_16bit_unsigned_5off,
			unpack_21_16bit_signed_5off,
		},
		{
			unpack_21_16bit_unsigned_6off,
			unpack_21_16bit_signed_6off,
		},
		{
			unpack_21_16bit_unsigned_7off,
			unpack_21_16bit_signed_7off,
		},
	},
	{
		{
			unpack_22_16bit_unsigned_0off,
			unpack_22_16bit_signed_0off,
		},
		{
			unpack_22_16bit_unsigned_1off,
			unpack_22_16bit_signed_1off,
		},
		{
			unpack_22_16bit_unsigned_2off,
			unpack_22_16bit_signed_2off,
		},
		{
			unpack_22_16bit_unsigned_3off,
			unpack_22_16bit_signed_3off,
		},
		{
			unpack_22_16bit_unsigned_4off,
			unpack_22_16bit_signed_4off,
		},
		{
			unpack_22_16bit_unsigned_5off,
			unpack_22_16bit_signed_5off,
		},
		{
			unpack_22_16bit_unsigned_6off,
			unpack_22_16bit_signed_6off,
		},
		{
			unpack_22_16bit_unsigned_7off,
			unpack_22_16bit_signed_7off,
		},
	},
	{
		{
			unpack_23_16bit_unsigned_0off,
			unpack_23_16bit_signed_0off,
		},
		{
			unpack_23_16bit_unsigned_1off,
			unpack_23_16bit_signed_1off,
		},
		{
			unpack_23_16bit_unsigned_2off,
			unpack_23_16bit_signed_2off,
		},
		{
			unpack_23_16bit_unsigned_3off,
			unpack_23_16bit_signed_3off,
		},
		{
			unpack_23_16bit_unsigned_4off,
			unpack_23_16bit_signed_4off,
		},
		{
			unpack_23_16bit_unsigned_5off,
			unpack_23_16bit_signed_5off,
		},
		{
			unpack_23_16bit_unsigned_6off,
			unpack_23_16bit_signed_6off,
		},
		{
			unpack_23_16bit_unsigned_7off,
			unpack_23_16bit_signed_7off,
		},
	},
	{
		{
			unpack_24_16bit_unsigned_0off,
			unpack_24_16bit_signed_0off,
		},
		{
			unpack_24_16bit_unsigned_1off,
			unpack_24_16bit_signed_1off,
		},
		{
			unpack_24_16bit_unsigned_2off,
			unpack_24_16bit_signed_2off,
		},
		{
			unpack_24_16bit_unsigned_3off,
			unpack_24_16bit_signed_3off,
		},
		{
			unpack_24_16bit_unsigned_4off,
			unpack_24_16bit_signed_4off,
		},
		{
			unpack_24_16bit_unsigned_5off,
			unpack_24_16bit_signed_5off,
		},
		{
			unpack_24_16bit_unsigned_6off,
			unpack_24_16bit_signed_6off,
		},
		{
			unpack_24_16bit_unsigned_7off,
			unpack_24_16bit_signed_7off,
		},
	},
	{
		{
			unpack_25_16bit_unsigned_0off,
			unpack_25_16bit_signed_0off,
		},
		{
			unpack_25_16bit_unsigned_1off,
			unpack_25_16bit_signed_1off,
		},
		{
			unpack_25_16bit_unsigned_2off,
			unpack_25_16bit_signed_2off,
		},
		{
			unpack_25_16bit_unsigned_3off,
			unpack_25_16bit_signed_3off,
		},
		{
			unpack_25_16bit_unsigned_4off,
			unpack_25_16bit_signed_4off,
		},
		{
			unpack_25_16bit_unsigned_5off,
			unpack_25_16bit_signed_5off,
		},
		{
			unpack_25_16bit_unsigned_6off,
			unpack_25_16bit_signed_6off,
		},
		{
			unpack_25_16bit_unsigned_7off,
			unpack_25_16bit_signed_7off,
		},
	},
	{
		{
			unpack_26_16bit_unsigned_0off,
			unpack_26_16bit_signed_0off,
		},
		{
			unpack_26_16bit_unsigned_1off,
			unpack_26_16bit_signed_1off,
		},
		{
			unpack_26_16bit_unsigned_2off,
			unpack_26_16bit_signed_2off,
		},
		{
			unpack_26_16bit_unsigned_3off,
			unpack_26_16bit_signed_3off,
		},
		{
			unpack_26_16bit_unsigned_4off,
			unpack_26_16bit_signed_4off,
		},
		{
			unpack_26_16bit_unsigned_5off,
			unpack_26_16bit_signed_5off,
		},
		{
			unpack_26_16bit_unsigned_6off,
			unpack_26_16bit_signed_6off,
		},
		{
			unpack_26_16bit_unsigned_7off,
			unpack_26_16bit_signed_7off,
		},
	},
	{
		{
			unpack_27_16bit_unsigned_0off,
			unpack_27_16bit_signed_0off,
		},
		{
			unpack_27_16bit_unsigned_1off,
			unpack_27_16bit_signed_1off,
		},
		{
			unpack_27_16bit_unsigned_2off,
			unpack_27_16bit_signed_2off,
		},
		{
			unpack_27_16bit_unsigned_3off,
			unpack_27_16bit_signed_3off,
		},
		{
			unpack_27_16bit_unsigned_4off,
			unpack_27_16bit_signed_4off,
		},
		{
			unpack_27_16bit_unsigned_5off,
			unpack_27_16bit_signed_5off,
		},
		{
			unpack_27_16bit_unsigned_6off,
			unpack_27_16bit_signed_6off,
		},
		{
			unpack_27_16bit_unsigned_7off,
			unpack_27_16bit_signed_7off,
		},
	},
	{
		{
			unpack_28_16bit_unsigned_0off,
			unpack_28_16bit_signed_0off,
		},
		{
			unpack_28_16bit_unsigned_1off,
			unpack_28_16bit_signed_1off,
		},
		{
			unpack_28_16bit_unsigned_2off,
			unpack_28_16bit_signed_2off,
		},
		{
			unpack_28_16bit_unsigned_3off,
			unpack_28_16bit_signed_3off,
		},
		{
			unpack_28_16bit_unsigned_4off,
			unpack_28_16bit_signed_4off,
		},
		{
			unpack_28_16bit_unsigned_5off,
			unpack_28_16bit_signed_5off,
		},
		{
			unpack_28_16bit_unsigned_6off,
			unpack_28_16bit_signed_6off,
		},
		{
			unpack_28_16bit_unsigned_7off,
			unpack_28_16bit_signed_7off,
		},
	},
	{
		{
			unpack_29_16bit_unsigned_0off,
			unpack_29_16bit_signed_0off,
		},
		{
			unpack_29_16bit_unsigned_1off,
			unpack_29_16bit_signed_1off,
		},
		{
			unpack_29_16bit_unsigned_2off,
			unpack_29_16bit_signed_2off,
		},
		{
			unpack_29_16bit_unsigned_3off,
			unpack_29_16bit_signed_3off,
		},
		{
			unpack_29_16bit_unsigned_4off,
			unpack_29_16bit_signed_4off,
		},
		{
			unpack_29_16bit_unsigned_5off,
			unpack_29_16bit_signed_5off,
		},
		{
			unpack_29_16bit_unsigned_6off,
			unpack_29_16bit_signed_6off,
		},
		{
			unpack_29_16bit_unsigned_7off,
			unpack_29_16bit_signed_7off,
		},
	},
	{
		{
			unpack_30_16bit_unsigned_0off,
			unpack_30_16bit_signed_0off,
		},
		{
			unpack_30_16bit_unsigned_1off,
			unpack_30_16bit_signed_1off,
		},
		{
			unpack_30_16bit_unsigned_2off,
			unpack_30_16bit_signed_2off,
		},
		{
			unpack_30_16bit_unsigned_3off,
			unpack_30_16bit_signed_3off,
		},
		{
			unpack_30_16bit_unsigned_4off,
			unpack_30_16bit_signed_4off,
		},
		{
			unpack_30_16bit_unsigned_5off,
			unpack_30_16bit_signed_5off,
		},
		{
			unpack_30_16bit_unsigned_6off,
			unpack_30_16bit_signed_6off,
		},
		{
			unpack_30_16bit_unsigned_7off,
			unpack_30_16bit_signed_7off,
		},
	},
	{
		{
			unpack_31_16bit_unsigned_0off,
			unpack_31_16bit_signed_0off,
		},
		{
			unpack_31_16bit_unsigned_1off,
			unpack_31_16bit_signed_1off,
		},
		{
			unpack_31_16bit_unsigned_2off,
			unpack_31_16bit_signed_2off,
		},
		{
			unpack_31_16bit_unsigned_3off,
			unpack_31_16bit_signed_3off,
		},
		{
			unpack_31_16bit_unsigned_4off,
			unpack_31_16bit_signed_4off,
		},
		{
			unpack_31_16bit_unsigned_5off,
			unpack_31_16bit_signed_5off,
		},
		{
			unpack_31_16bit_unsigned_6off,
			unpack_31_16bit_signed_6off,
		},
		{
			unpack_31_16bit_unsigned_7off,
			unpack_31_16bit_signed_7off,
		},
	},
	{
		{
			unpack_32_16bit_unsigned_0off,
			unpack_32_16bit_signed_0off,
		},
		{
			unpack_32_16bit_unsigned_1off,
			unpack_32_16bit_signed_1off,
		},
		{
			unpack_32_16bit_unsigned_2off,
			unpack_32_16bit_signed_2off,
		},
		{
			unpack_32_16bit_unsigned_3off,
			unpack_32_16bit_signed_3off,
		},
		{
			unpack_32_16bit_unsigned_4off,
			unpack_32_16bit_signed_4off,
		},
		{
			unpack_32_16bit_unsigned_5off,
			unpack_32_16bit_signed_5off,
		},
		{
			unpack_32_16bit_unsigned_6off,
			unpack_32_16bit_signed_6off,
		},
		{
			unpack_32_16bit_unsigned_7off,
			unpack_32_16bit_signed_7off,
		},
	},
	{
		{
			unpack_33_16bit_unsigned_0off,
			unpack_33_16bit_signed_0off,
		},
		{
			unpack_33_16bit_unsigned_1off,
			unpack_33_16bit_signed_1off,
		},
		{
			unpack_33_16bit_unsigned_2off,
			unpack_33_16bit_signed_2off,
		},
		{
			unpack_33_16bit_unsigned_3off,
			unpack_33_16bit_signed_3off,
		},
		{
			unpack_33_16bit_unsigned_4off,
			unpack_33_16bit_signed_4off,
		},
		{
			unpack_33_16bit_unsigned_5off,
			unpack_33_16bit_signed_5off,
		},
		{
			unpack_33_16bit_unsigned_6off,
			unpack_33_16bit_signed_6off,
		},
		{
			unpack_33_16bit_unsigned_7off,
			unpack_33_16bit_signed_7off,
		},
	},
	{
		{
			unpack_34_16bit_unsigned_0off,
			unpack_34_16bit_signed_0off,
		},
		{
			unpack_34_16bit_unsigned_1off,
			unpack_34_16bit_signed_1off,
		},
		{
			unpack_34_16bit_unsigned_2off,
			unpack_34_16bit_signed_2off,
		},
		{
			unpack_34_16bit_unsigned_3off,
			unpack_34_16bit_signed_3off,
		},
		{
			unpack_34_16bit_unsigned_4off,
			unpack_34_16bit_signed_4off,
		},
		{
			unpack_34_16bit_unsigned_5off,
			unpack_34_16bit_signed_5off,
		},
		{
			unpack_34_16bit_unsigned_6off,
			unpack_34_16bit_signed_6off,
		},
		{
			unpack_34_16bit_unsigned_7off,
			unpack_34_16bit_signed_7off,
		},
	},
	{
		{
			unpack_35_16bit_unsigned_0off,
			unpack_35_16bit_signed_0off,
		},
		{
			unpack_35_16bit_unsigned_1off,
			unpack_35_16bit_signed_1off,
		},
		{
			unpack_35_16bit_unsigned_2off,
			unpack_35_16bit_signed_2off,
		},
		{
			unpack_35_16bit_unsigned_3off,
			unpack_35_16bit_signed_3off,
		},
		{
			unpack_35_16bit_unsigned_4off,
			unpack_35_16bit_signed_4off,
		},
		{
			unpack_35_16bit_unsigned_5off,
			unpack_35_16bit_signed_5off,
		},
		{
			unpack_35_16bit_unsigned_6off,
			unpack_35_16bit_signed_6off,
		},
		{
			unpack_35_16bit_unsigned_7off,
			unpack_35_16bit_signed_7off,
		},
	},
	{
		{
			unpack_36_16bit_unsigned_0off,
			unpack_36_16bit_signed_0off,
		},
		{
			unpack_36_16bit_unsigned_1off,
			unpack_36_16bit_signed_1off,
		},
		{
			unpack_36_16bit_unsigned_2off,
			unpack_36_16bit_signed_2off,
		},
		{
			unpack_36_16bit_unsigned_3off,
			unpack_36_16bit_signed_3off,
		},
		{
			unpack_36_16bit_unsigned_4off,
			unpack_36_16bit_signed_4off,
		},
		{
			unpack_36_16bit_unsigned_5off,
			unpack_36_16bit_signed_5off,
		},
		{
			unpack_36_16bit_unsigned_6off,
			unpack_36_16bit_signed_6off,
		},
		{
			unpack_36_16bit_unsigned_7off,
			unpack_36_16bit_signed_7off,
		},
	},
	{
		{
			unpack_37_16bit_unsigned_0off,
			unpack_37_16bit_signed_0off,
		},
		{
			unpack_37_16bit_unsigned_1off,
			unpack_37_16bit_signed_1off,
		},
		{
			unpack_37_16bit_unsigned_2off,
			unpack_37_16bit_signed_2off,
		},
		{
			unpack_37_16bit_unsigned_3off,
			unpack_37_16bit_signed_3off,
		},
		{
			unpack_37_16bit_unsigned_4off,
			unpack_37_16bit_signed_4off,
		},
		{
			unpack_37_16bit_unsigned_5off,
			unpack_37_16bit_signed_5off,
		},
		{
			unpack_37_16bit_unsigned_6off,
			unpack_37_16bit_signed_6off,
		},
		{
			unpack_37_16bit_unsigned_7off,
			unpack_37_16bit_signed_7off,
		},
	},
	{
		{
			unpack_38_16bit_unsigned_0off,
			unpack_38_16bit_signed_0off,
		},
		{
			unpack_38_16bit_unsigned_1off,
			unpack_38_16bit_signed_1off,
		},
		{
			unpack_38_16bit_unsigned_2off,
			unpack_38_16bit_signed_2off,
		},
		{
			unpack_38_16bit_unsigned_3off,
			unpack_38_16bit_signed_3off,
		},
		{
			unpack_38_16bit_unsigned_4off,
			unpack_38_16bit_signed_4off,
		},
		{
			unpack_38_16bit_unsigned_5off,
			unpack_38_16bit_signed_5off,
		},
		{
			unpack_38_16bit_unsigned_6off,
			unpack_38_16bit_signed_6off,
		},
		{
			unpack_38_16bit_unsigned_7off,
			unpack_38_16bit_signed_7off,
		},
	},
	{
		{
			unpack_39_16bit_unsigned_0off,
			unpack_39_16bit_signed_0off,
		},
		{
			unpack_39_16bit_unsigned_1off,
			unpack_39_16bit_signed_1off,
		},
		{
			unpack_39_16bit_unsigned_2off,
			unpack_39_16bit_signed_2off,
		},
		{
			unpack_39_16bit_unsigned_3off,
			unpack_39_16bit_signed_3off,
		},
		{
			unpack_39_16bit_unsigned_4off,
			unpack_39_16bit_signed_4off,
		},
		{
			unpack_39_16bit_unsigned_5off,
			unpack_39_16bit_signed_5off,
		},
		{
			unpack_39_16bit_unsigned_6off,
			unpack_39_16bit_signed_6off,
		},
		{
			unpack_39_16bit_unsigned_7off,
			unpack_39_16bit_signed_7off,
		},
	},
	{
		{
			unpack_40_16bit_unsigned_0off,
			unpack_40_16bit_signed_0off,
		},
		{
			unpack_40_16bit_unsigned_1off,
			unpack_40_16bit_signed_1off,
		},
		{
			unpack_40_16bit_unsigned_2off,
			unpack_40_16bit_signed_2off,
		},
		{
			unpack_40_16bit_unsigned_3off,
			unpack_40_16bit_signed_3off,
		},
		{
			unpack_40_16bit_unsigned_4off,
			unpack_40_16bit_signed_4off,
		},
		{
			unpack_40_16bit_unsigned_5off,
			unpack_40_16bit_signed_5off,
		},
		{
			unpack_40_16bit_unsigned_6off,
			unpack_40_16bit_signed_6off,
		},
		{
			unpack_40_16bit_unsigned_7off,
			unpack_40_16bit_signed_7off,
		},
	},
	{
		{
			unpack_41_16bit_unsigned_0off,
			unpack_41_16bit_signed_0off,
		},
		{
			unpack_41_16bit_unsigned_1off,
			unpack_41_16bit_signed_1off,
		},
		{
			unpack_41_16bit_unsigned_2off,
			unpack_41_16bit_signed_2off,
		},
		{
			unpack_41_16bit_unsigned_3off,
			unpack_41_16bit_signed_3off,
		},
		{
			unpack_41_16bit_unsigned_4off,
			unpack_41_16bit_signed_4off,
		},
		{
			unpack_41_16bit_unsigned_5off,
			unpack_41_16bit_signed_5off,
		},
		{
			unpack_41_16bit_unsigned_6off,
			unpack_41_16bit_signed_6off,
		},
		{
			unpack_41_16bit_unsigned_7off,
			unpack_41_16bit_signed_7off,
		},
	},
	{
		{
			unpack_42_16bit_unsigned_0off,
			unpack_42_16bit_signed_0off,
		},
		{
			unpack_42_16bit_unsigned_1off,
			unpack_42_16bit_signed_1off,
		},
		{
			unpack_42_16bit_unsigned_2off,
			unpack_42_16bit_signed_2off,
		},
		{
			unpack_42_16bit_unsigned_3off,
			unpack_42_16bit_signed_3off,
		},
		{
			unpack_42_16bit_unsigned_4off,
			unpack_42_16bit_signed_4off,
		},
		{
			unpack_42_16bit_unsigned_5off,
			unpack_42_16bit_signed_5off,
		},
		{
			unpack_42_16bit_unsigned_6off,
			unpack_42_16bit_signed_6off,
		},
		{
			unpack_42_16bit_unsigned_7off,
			unpack_42_16bit_signed_7off,
		},
	},
	{
		{
			unpack_43_16bit_unsigned_0off,
			unpack_43_16bit_signed_0off,
		},
		{
			unpack_43_16bit_unsigned_1off,
			unpack_43_16bit_signed_1off,
		},
		{
			unpack_43_16bit_unsigned_2off,
			unpack_43_16bit_signed_2off,
		},
		{
			unpack_43_16bit_unsigned_3off,
			unpack_43_16bit_signed_3off,
		},
		{
			unpack_43_16bit_unsigned_4off,
			unpack_43_16bit_signed_4off,
		},
		{
			unpack_43_16bit_unsigned_5off,
			unpack_43_16bit_signed_5off,
		},
		{
			unpack_43_16bit_unsigned_6off,
			unpack_43_16bit_signed_6off,
		},
		{
			unpack_43_16bit_unsigned_7off,
			unpack_43_16bit_signed_7off,
		},
	},
	{
		{
			unpack_44_16bit_unsigned_0off,
			unpack_44_16bit_signed_0off,
		},
		{
			unpack_44_16bit_unsigned_1off,
			unpack_44_16bit_signed_1off,
		},
		{
			unpack_44_16bit_unsigned_2off,
			unpack_44_16bit_signed_2off,
		},
		{
			unpack_44_16bit_unsigned_3off,
			unpack_44_16bit_signed_3off,
		},
		{
			unpack_44_16bit_unsigned_4off,
			unpack_44_16bit_signed_4off,
		},
		{
			unpack_44_16bit_unsigned_5off,
			unpack_44_16bit_signed_5off,
		},
		{
			unpack_44_16bit_unsigned_6off,
			unpack_44_16bit_signed_6off,
		},
		{
			unpack_44_16bit_unsigned_7off,
			unpack_44_16bit_signed_7off,
		},
	},
	{
		{
			unpack_45_16bit_unsigned_0off,
			unpack_45_16bit_signed_0off,
		},
		{
			unpack_45_16bit_unsigned_1off,
			unpack_45_16bit_signed_1off,
		},
		{
			unpack_45_16bit_unsigned_2off,
			unpack_45_16bit_signed_2off,
		},
		{
			unpack_45_16bit_unsigned_3off,
			unpack_45_16bit_signed_3off,
		},
		{
			unpack_45_16bit_unsigned_4off,
			unpack_45_16bit_signed_4off,
		},
		{
			unpack_45_16bit_unsigned_5off,
			unpack_45_16bit_signed_5off,
		},
		{
			unpack_45_16bit_unsigned_6off,
			unpack_45_16bit_signed_6off,
		},
		{
			unpack_45_16bit_unsigned_7off,
			unpack_45_16bit_signed_7off,
		},
	},
	{
		{
			unpack_46_16bit_unsigned_0off,
			unpack_46_16bit_signed_0off,
		},
		{
			unpack_46_16bit_unsigned_1off,
			unpack_46_16bit_signed_1off,
		},
		{
			unpack_46_16bit_unsigned_2off,
			unpack_46_16bit_signed_2off,
		},
		{
			unpack_46_16bit_unsigned_3off,
			unpack_46_16bit_signed_3off,
		},
		{
			unpack_46_16bit_unsigned_4off,
			unpack_46_16bit_signed_4off,
		},
		{
			unpack_46_16bit_unsigned_5off,
			unpack_46_16bit_signed_5off,
		},
		{
			unpack_46_16bit_unsigned_6off,
			unpack_46_16bit_signed_6off,
		},
		{
			unpack_46_16bit_unsigned_7off,
			unpack_46_16bit_signed_7off,
		},
	},
	{
		{
			unpack_47_16bit_unsigned_0off,
			unpack_47_16bit_signed_0off,
		},
		{
			unpack_47_16bit_unsigned_1off,
			unpack_47_16bit_signed_1off,
		},
		{
			unpack_47_16bit_unsigned_2off,
			unpack_47_16bit_signed_2off,
		},
		{
			unpack_47_16bit_unsigned_3off,
			unpack_47_16bit_signed_3off,
		},
		{
			unpack_47_16bit_unsigned_4off,
			unpack_47_16bit_signed_4off,
		},
		{
			unpack_47_16bit_unsigned_5off,
			unpack_47_16bit_signed_5off,
		},
		{
			unpack_47_16bit_unsigned_6off,
			unpack_47_16bit_signed_6off,
		},
		{
			unpack_47_16bit_unsigned_7off,
			unpack_47_16bit_signed_7off,
		},
	},
	{
		{
			unpack_48_16bit_unsigned_0off,
			unpack_48_16bit_signed_0off,
		},
		{
			unpack_48_16bit_unsigned_1off,
			unpack_48_16bit_signed_1off,
		},
		{
			unpack_48_16bit_unsigned_2off,
			unpack_48_16bit_signed_2off,
		},
		{
			unpack_48_16bit_unsigned_3off,
			unpack_48_16bit_signed_3off,
		},
		{
			unpack_48_16bit_unsigned_4off,
			unpack_48_16bit_signed_4off,
		},
		{
			unpack_48_16bit_unsigned_5off,
			unpack_48_16bit_signed_5off,
		},
		{
			unpack_48_16bit_unsigned_6off,
			unpack_48_16bit_signed_6off,
		},
		{
			unpack_48_16bit_unsigned_7off,
			unpack_48_16bit_signed_7off,
		},
	},
	{
		{
			unpack_49_16bit_unsigned_0off,
			unpack_49_16bit_signed_0off,
		},
		{
			unpack_49_16bit_unsigned_1off,
			unpack_49_16bit_signed_1off,
		},
		{
			unpack_49_16bit_unsigned_2off,
			unpack_49_16bit_signed_2off,
		},
		{
			unpack_49_16bit_unsigned_3off,
			unpack_49_16bit_signed_3off,
		},
		{
			unpack_49_16bit_unsigned_4off,
			unpack_49_16bit_signed_4off,
		},
		{
			unpack_49_16bit_unsigned_5off,
			unpack_49_16bit_signed_5off,
		},
		{
			unpack_49_16bit_unsigned_6off,
			unpack_49_16bit_signed_6off,
		},
		{
			unpack_49_16bit_unsigned_7off,
			unpack_49_16bit_signed_7off,
		},
	},
	{
		{
			unpack_50_16bit_unsigned_0off,
			unpack_50_16bit_signed_0off,
		},
		{
			unpack_50_16bit_unsigned_1off,
			unpack_50_16bit_signed_1off,
		},
		{
			unpack_50_16bit_unsigned_2off,
			unpack_50_16bit_signed_2off,
		},
		{
			unpack_50_16bit_unsigned_3off,
			unpack_50_16bit_signed_3off,
		},
		{
			unpack_50_16bit_unsigned_4off,
			unpack_50_16bit_signed_4off,
		},
		{
			unpack_50_16bit_unsigned_5off,
			unpack_50_16bit_signed_5off,
		},
		{
			unpack_50_16bit_unsigned_6off,
			unpack_50_16bit_signed_6off,
		},
		{
			unpack_50_16bit_unsigned_7off,
			unpack_50_16bit_signed_7off,
		},
	},
	{
		{
			unpack_51_16bit_unsigned_0off,
			unpack_51_16bit_signed_0off,
		},
		{
			unpack_51_16bit_unsigned_1off,
			unpack_51_16bit_signed_1off,
		},
		{
			unpack_51_16bit_unsigned_2off,
			unpack_51_16bit_signed_2off,
		},
		{
			unpack_51_16bit_unsigned_3off,
			unpack_51_16bit_signed_3off,
		},
		{
			unpack_51_16bit_unsigned_4off,
			unpack_51_16bit_signed_4off,
		},
		{
			unpack_51_16bit_unsigned_5off,
			unpack_51_16bit_signed_5off,
		},
		{
			unpack_51_16bit_unsigned_6off,
			unpack_51_16bit_signed_6off,
		},
		{
			unpack_51_16bit_unsigned_7off,
			unpack_51_16bit_signed_7off,
		},
	},
	{
		{
			unpack_52_16bit_unsigned_0off,
			unpack_52_16bit_signed_0off,
		},
		{
			unpack_52_16bit_unsigned_1off,
			unpack_52_16bit_signed_1off,
		},
		{
			unpack_52_16bit_unsigned_2off,
			unpack_52_16bit_signed_2off,
		},
		{
			unpack_52_16bit_unsigned_3off,
			unpack_52_16bit_signed_3off,
		},
		{
			unpack_52_16bit_unsigned_4off,
			unpack_52_16bit_signed_4off,
		},
		{
			unpack_52_16bit_unsigned_5off,
			unpack_52_16bit_signed_5off,
		},
		{
			unpack_52_16bit_unsigned_6off,
			unpack_52_16bit_signed_6off,
		},
		{
			unpack_52_16bit_unsigned_7off,
			unpack_52_16bit_signed_7off,
		},
	},
	{
		{
			unpack_53_16bit_unsigned_0off,
			unpack_53_16bit_signed_0off,
		},
		{
			unpack_53_16bit_unsigned_1off,
			unpack_53_16bit_signed_1off,
		},
		{
			unpack_53_16bit_unsigned_2off,
			unpack_53_16bit_signed_2off,
		},
		{
			unpack_53_16bit_unsigned_3off,
			unpack_53_16bit_signed_3off,
		},
		{
			unpack_53_16bit_unsigned_4off,
			unpack_53_16bit_signed_4off,
		},
		{
			unpack_53_16bit_unsigned_5off,
			unpack_53_16bit_signed_5off,
		},
		{
			unpack_53_16bit_unsigned_6off,
			unpack_53_16bit_signed_6off,
		},
		{
			unpack_53_16bit_unsigned_7off,
			unpack_53_16bit_signed_7off,
		},
	},
	{
		{
			unpack_54_16bit_unsigned_0off,
			unpack_54_16bit_signed_0off,
		},
		{
			unpack_54_16bit_unsigned_1off,
			unpack_54_16bit_signed_1off,
		},
		{
			unpack_54_16bit_unsigned_2off,
			unpack_54_16bit_signed_2off,
		},
		{
			unpack_54_16bit_unsigned_3off,
			unpack_54_16bit_signed_3off,
		},
		{
			unpack_54_16bit_unsigned_4off,
			unpack_54_16bit_signed_4off,
		},
		{
			unpack_54_16bit_unsigned_5off,
			unpack_54_16bit_signed_5off,
		},
		{
			unpack_54_16bit_unsigned_6off,
			unpack_54_16bit_signed_6off,
		},
		{
			unpack_54_16bit_unsigned_7off,
			unpack_54_16bit_signed_7off,
		},
	},
	{
		{
			unpack_55_16bit_unsigned_0off,
			unpack_55_16bit_signed_0off,
		},
		{
			unpack_55_16bit_unsigned_1off,
			unpack_55_16bit_signed_1off,
		},
		{
			unpack_55_16bit_unsigned_2off,
			unpack_55_16bit_signed_2off,
		},
		{
			unpack_55_16bit_unsigned_3off,
			unpack_55_16bit_signed_3off,
		},
		{
			unpack_55_16bit_unsigned_4off,
			unpack_55_16bit_signed_4off,
		},
		{
			unpack_55_16bit_unsigned_5off,
			unpack_55_16bit_signed_5off,
		},
		{
			unpack_55_16bit_unsigned_6off,
			unpack_55_16bit_signed_6off,
		},
		{
			unpack_55_16bit_unsigned_7off,
			unpack_55_16bit_signed_7off,
		},
	},
	{
		{
			unpack_56_16bit_unsigned_0off,
			unpack_56_16bit_signed_0off,
		},
		{
			unpack_56_16bit_unsigned_1off,
			unpack_56_16bit_signed_1off,
		},
		{
			unpack_56_16bit_unsigned_2off,
			unpack_56_16bit_signed_2off,
		},
		{
			unpack_56_16bit_unsigned_3off,
			unpack_56_16bit_signed_3off,
		},
		{
			unpack_56_16bit_unsigned_4off,
			unpack_56_16bit_signed_4off,
		},
		{
			unpack_56_16bit_unsigned_5off,
			unpack_56_16bit_signed_5off,
		},
		{
			unpack_56_16bit_unsigned_6off,
			unpack_56_16bit_signed_6off,
		},
		{
			unpack_56_16bit_unsigned_7off,
			unpack_56_16bit_signed_7off,
		},
	},
	{
		{
			unpack_57_16bit_unsigned_0off,
			unpack_57_16bit_signed_0off,
		},
		{
			unpack_57_16bit_unsigned_1off,
			unpack_57_16bit_signed_1off,
		},
		{
			unpack_57_16bit_unsigned_2off,
			unpack_57_16bit_signed_2off,
		},
		{
			unpack_57_16bit_unsigned_3off,
			unpack_57_16bit_signed_3off,
		},
		{
			unpack_57_16bit_unsigned_4off,
			unpack_57_16bit_signed_4off,
		},
		{
			unpack_57_16bit_unsigned_5off,
			unpack_57_16bit_signed_5off,
		},
		{
			unpack_57_16bit_unsigned_6off,
			unpack_57_16bit_signed_6off,
		},
		{
			unpack_57_16bit_unsigned_7off,
			unpack_57_16bit_signed_7off,
		},
	},
	{
		{
			unpack_58_16bit_unsigned_0off,
			unpack_58_16bit_signed_0off,
		},
		{
			unpack_58_16bit_unsigned_1off,
			unpack_58_16bit_signed_1off,
		},
		{
			unpack_58_16bit_unsigned_2off,
			unpack_58_16bit_signed_2off,
		},
		{
			unpack_58_16bit_unsigned_3off,
			unpack_58_16bit_signed_3off,
		},
		{
			unpack_58_16bit_unsigned_4off,
			unpack_58_16bit_signed_4off,
		},
		{
			unpack_58_16bit_unsigned_5off,
			unpack_58_16bit_signed_5off,
		},
		{
			unpack_58_16bit_unsigned_6off,
			unpack_58_16bit_signed_6off,
		},
		{
			unpack_58_16bit_unsigned_7off,
			unpack_58_16bit_signed_7off,
		},
	},
	{
		{
			unpack_59_16bit_unsigned_0off,
			unpack_59_16bit_signed_0off,
		},
		{
			unpack_59_16bit_unsigned_1off,
			unpack_59_16bit_signed_1off,
		},
		{
			unpack_59_16bit_unsigned_2off,
			unpack_59_16bit_signed_2off,
		},
		{
			unpack_59_16bit_unsigned_3off,
			unpack_59_16bit_signed_3off,
		},
		{
			unpack_59_16bit_unsigned_4off,
			unpack_59_16bit_signed_4off,
		},
		{
			unpack_59_16bit_unsigned_5off,
			unpack_59_16bit_signed_5off,
		},
		{
			unpack_59_16bit_unsigned_6off,
			unpack_59_16bit_signed_6off,
		},
		{
			unpack_59_16bit_unsigned_7off,
			unpack_59_16bit_signed_7off,
		},
	},
	{
		{
			unpack_60_16bit_unsigned_0off,
			unpack_60_16bit_signed_0off,
		},
		{
			unpack_60_16bit_unsigned_1off,
			unpack_60_16bit_signed_1off,
		},
		{
			unpack_60_16bit_unsigned_2off,
			unpack_60_16bit_signed_2off,
		},
		{
			unpack_60_16bit_unsigned_3off,
			unpack_60_16bit_signed_3off,
		},
		{
			unpack_60_16bit_unsigned_4off,
			unpack_60_16bit_signed_4off,
		},
		{
			unpack_60_16bit_unsigned_5off,
			unpack_60_16bit_signed_5off,
		},
		{
			unpack_60_16bit_unsigned_6off,
			unpack_60_16bit_signed_6off,
		},
		{
			unpack_60_16bit_unsigned_7off,
			unpack_60_16bit_signed_7off,
		},
	},
	{
		{
			unpack_61_16bit_unsigned_0off,
			unpack_61_16bit_signed_0off,
		},
		{
			unpack_61_16bit_unsigned_1off,
			unpack_61_16bit_signed_1off,
		},
		{
			unpack_61_16bit_unsigned_2off,
			unpack_61_16bit_signed_2off,
		},
		{
			unpack_61_16bit_unsigned_3off,
			unpack_61_16bit_signed_3off,
		},
		{
			unpack_61_16bit_unsigned_4off,
			unpack_61_16bit_signed_4off,
		},
		{
			unpack_61_16bit_unsigned_5off,
			unpack_61_16bit_signed_5off,
		},
		{
			unpack_61_16bit_unsigned_6off,
			unpack_61_16bit_signed_6off,
		},
		{
			unpack_61_16bit_unsigned_7off,
			unpack_61_16bit_signed_7off,
		},
	},
	{
		{
			unpack_62_16bit_unsigned_0off,
			unpack_62_16bit_signed_0off,
		},
		{
			unpack_62_16bit_unsigned_1off,
			unpack_62_16bit_signed_1off,
		},
		{
			unpack_62_16bit_unsigned_2off,
			unpack_62_16bit_signed_2off,
		},
		{
			unpack_62_16bit_unsigned_3off,
			unpack_62_16bit_signed_3off,
		},
		{
			unpack_62_16bit_unsigned_4off,
			unpack_62_16bit_signed_4off,
		},
		{
			unpack_62_16bit_unsigned_5off,
			unpack_62_16bit_signed_5off,
		},
		{
			unpack_62_16bit_unsigned_6off,
			unpack_62_16bit_signed_6off,
		},
		{
			unpack_62_16bit_unsigned_7off,
			unpack_62_16bit_signed_7off,
		},
	},
	{
		{
			unpack_63_16bit_unsigned_0off,
			unpack_63_16bit_signed_0off,
		},
		{
			unpack_63_16bit_unsigned_1off,
			unpack_63_16bit_signed_1off,
		},
		{
			unpack_63_16bit_unsigned_2off,
			unpack_63_16bit_signed_2off,
		},
		{
			unpack_63_16bit_unsigned_3off,
			unpack_63_16bit_signed_3off,
		},
		{
			unpack_63_16bit_unsigned_4off,
			unpack_63_16bit_signed_4off,
		},
		{
			unpack_63_16bit_unsigned_5off,
			unpack_63_16bit_signed_5off,
		},
		{
			unpack_63_16bit_unsigned_6off,
			unpack_63_16bit_signed_6off,
		},
		{
			unpack_63_16bit_unsigned_7off,
			unpack_63_16bit_signed_7off,
		},
	},
	{
		{
			unpack_64_16bit_unsigned_0off,
			unpack_64_16bit_signed_0off,
		},
		{
			unpack_64_16bit_unsigned_1off,
			unpack_64_16bit_signed_1off,
		},
		{
			unpack_64_16bit_unsigned_2off,
			unpack_64_16bit_signed_2off,
		},
		{
			unpack_64_16bit_unsigned_3off,
			unpack_64_16bit_signed_3off,
		},
		{
			unpack_64_16bit_unsigned_4off,
			unpack_64_16bit_signed_4off,
		},
		{
			unpack_64_16bit_unsigned_5off,
			unpack_64_16bit_signed_5off,
		},
		{
			unpack_64_16bit_unsigned_6off,
			unpack_64_16bit_signed_6off,
		},
		{
			unpack_64_16bit_unsigned_7off,
			unpack_64_16bit_signed_7off,
		},
	},
};
